%------------------------------------------------------------------------------
% File     : VBT00028^2 : TPTP v7.6.0. Released v7.6.0.
% Domain   : Interactive Theorem Proving
% Problem  : Sledgehammer problem VEBT_InsertCorrectness 00053_003130
% Version  : [Des22] axioms.
% English  :

% Refs     : [BH+15] Blanchette et al. (2015), Mining the Archive of Formal
%          : [Des22] Desharnais (2022), Email to Geoff Sutcliffe
% Source   : [Des22]
% Names    : 0067_VEBT_InsertCorrectness_00053_003130 [Des22]

% Status   : Theorem
% Rating   : ? v7.6.0
% Syntax   : Number of formulae    : 9529 (3036 unt; 575 typ;   0 def)
%            Number of atoms       : 28113 (9586 equ;   5 cnn)
%            Maximal formula atoms :   71 (   3 avg)
%            Number of connectives : 172657 (2236   ~; 339   |;2215   &;154946   @)
%                                         (   0 <=>;12921  =>;   0  <=;   0 <~>)
%            Maximal formula depth :   40 (   7 avg)
%            Number of types       :   12 (  11 usr)
%            Number of type conns  : 3770 (3770   >;   0   *;   0   +;   0  <<)
%            Number of symbols     :  568 ( 564 usr;  13 con; 0-9 aty)
%            Number of variables   : 29249 (2505   ^25361   !; 864   ?;29249   :)
%                                         ( 519  !>;   0  ?*;   0  @-;   0  @+)
% SPC      : TH1_THM_EQU_NAR

% Comments : This file was generated by Isabelle (most likely Sledgehammer)
%            2022-02-17 20:26:17.859
%------------------------------------------------------------------------------
% Could-be-implicit typings (18)
thf(ty_t_VEBT__Definitions_OVEBT,type,
    vEBT_VEBT: $tType ).

thf(ty_t_Code__Numeral_Ointeger,type,
    code_integer: $tType ).

thf(ty_t_Product__Type_Ounit,type,
    product_unit: $tType ).

thf(ty_t_Product__Type_Oprod,type,
    product_prod: $tType > $tType > $tType ).

thf(ty_t_Extended__Nat_Oenat,type,
    extended_enat: $tType ).

thf(ty_t_Complex_Ocomplex,type,
    complex: $tType ).

thf(ty_t_Sum__Type_Osum,type,
    sum_sum: $tType > $tType > $tType ).

thf(ty_t_Option_Ooption,type,
    option: $tType > $tType ).

thf(ty_t_Filter_Ofilter,type,
    filter: $tType > $tType ).

thf(ty_t_String_Ochar,type,
    char: $tType ).

thf(ty_t_Real_Oreal,type,
    real: $tType ).

thf(ty_t_List_Olist,type,
    list: $tType > $tType ).

thf(ty_t_Set_Oset,type,
    set: $tType > $tType ).

thf(ty_t_Rat_Orat,type,
    rat: $tType ).

thf(ty_t_Num_Onum,type,
    num: $tType ).

thf(ty_t_Nat_Onat,type,
    nat: $tType ).

thf(ty_t_Int_Oint,type,
    int: $tType ).

thf(ty_t_itself,type,
    itself: $tType > $tType ).

% Explicit typings (557)
thf(sy_cl_Lattices_Obounded__lattice,type,
    bounded_lattice: 
      !>[A: $tType] : $o ).

thf(sy_cl_HOL_Otype,type,
    type: 
      !>[A: $tType] : $o ).

thf(sy_cl_Nat_Osize,type,
    size: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Odvd,type,
    dvd: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Oone,type,
    one: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Oidom,type,
    idom: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Oring,type,
    ring: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Oplus,type,
    plus: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Ozero,type,
    zero: 
      !>[A: $tType] : $o ).

thf(sy_cl_Num_Onumeral,type,
    numeral: 
      !>[A: $tType] : $o ).

thf(sy_cl_Power_Opower,type,
    power: 
      !>[A: $tType] : $o ).

thf(sy_cl_Fields_Ofield,type,
    field: 
      !>[A: $tType] : $o ).

thf(sy_cl_GCD_Oring__gcd,type,
    ring_gcd: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Oabs__if,type,
    abs_if: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Oring__1,type,
    ring_1: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Ouminus,type,
    uminus: 
      !>[A: $tType] : $o ).

thf(sy_cl_Orderings_Oord,type,
    ord: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Osemidom,type,
    semidom: 
      !>[A: $tType] : $o ).

thf(sy_cl_Fields_Oinverse,type,
    inverse: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Osemiring,type,
    semiring: 
      !>[A: $tType] : $o ).

thf(sy_cl_Nat_Oring__char__0,type,
    ring_char_0: 
      !>[A: $tType] : $o ).

thf(sy_cl_Num_Oneg__numeral,type,
    neg_numeral: 
      !>[A: $tType] : $o ).

thf(sy_cl_Orderings_Oorder,type,
    order: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Ocomm__ring,type,
    comm_ring: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Omult__zero,type,
    mult_zero: 
      !>[A: $tType] : $o ).

thf(sy_cl_GCD_Osemiring__Gcd,type,
    semiring_Gcd: 
      !>[A: $tType] : $o ).

thf(sy_cl_GCD_Osemiring__gcd,type,
    semiring_gcd: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Ogroup__add,type,
    group_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Lattices_Olattice,type,
    lattice: 
      !>[A: $tType] : $o ).

thf(sy_cl_Orderings_Ono__bot,type,
    no_bot: 
      !>[A: $tType] : $o ).

thf(sy_cl_Orderings_Ono__top,type,
    no_top: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Osemiring__0,type,
    semiring_0: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Osemiring__1,type,
    semiring_1: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Omonoid__add,type,
    monoid_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Ocomm__ring__1,type,
    comm_ring_1: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Oidom__divide,type,
    idom_divide: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Oidom__modulo,type,
    idom_modulo: 
      !>[A: $tType] : $o ).

thf(sy_cl_Transcendental_Oln,type,
    ln: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Omonoid__mult,type,
    monoid_mult: 
      !>[A: $tType] : $o ).

thf(sy_cl_Orderings_Olinorder,type,
    linorder: 
      !>[A: $tType] : $o ).

thf(sy_cl_Orderings_Opreorder,type,
    preorder: 
      !>[A: $tType] : $o ).

thf(sy_cl_Parity_Oring__parity,type,
    ring_parity: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Oidom__abs__sgn,type,
    idom_abs_sgn: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Oordered__ring,type,
    ordered_ring: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Ozero__neq__one,type,
    zero_neq_one: 
      !>[A: $tType] : $o ).

thf(sy_cl_Fields_Ofield__char__0,type,
    field_char_0: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Oab__group__add,type,
    ab_group_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Nat_Osemiring__char__0,type,
    semiring_char_0: 
      !>[A: $tType] : $o ).

thf(sy_cl_Orderings_Oorder__bot,type,
    order_bot: 
      !>[A: $tType] : $o ).

thf(sy_cl_Orderings_Oorder__top,type,
    order_top: 
      !>[A: $tType] : $o ).

thf(sy_cl_Orderings_Owellorder,type,
    wellorder: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Ocomm__semiring,type,
    comm_semiring: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Ozero__less__one,type,
    zero_less_one: 
      !>[A: $tType] : $o ).

thf(sy_cl_Fields_Odivision__ring,type,
    division_ring: 
      !>[A: $tType] : $o ).

thf(sy_cl_Fields_Ofield__abs__sgn,type,
    field_abs_sgn: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Osemigroup__add,type,
    semigroup_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Num_Osemiring__numeral,type,
    semiring_numeral: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Osemidom__divide,type,
    semidom_divide: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Osemidom__modulo,type,
    semidom_modulo: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Osemigroup__mult,type,
    semigroup_mult: 
      !>[A: $tType] : $o ).

thf(sy_cl_Orderings_Odense__order,type,
    dense_order: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Ocomm__semiring__0,type,
    comm_semiring_0: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Ocomm__semiring__1,type,
    comm_semiring_1: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Olinordered__idom,type,
    linordered_idom: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Olinordered__ring,type,
    linordered_ring: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Osemiring__modulo,type,
    semiring_modulo: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Ocomm__monoid__add,type,
    comm_monoid_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Parity_Osemiring__parity,type,
    semiring_parity: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Oordered__ring__abs,type,
    ordered_ring_abs: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Oordered__semiring,type,
    ordered_semiring: 
      !>[A: $tType] : $o ).

thf(sy_cl_Fields_Olinordered__field,type,
    linordered_field: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Oab__semigroup__add,type,
    ab_semigroup_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Ocomm__monoid__diff,type,
    comm_monoid_diff: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Ocomm__monoid__mult,type,
    comm_monoid_mult: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Oalgebraic__semidom,type,
    algebraic_semidom: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Osemiring__1__cancel,type,
    semiring_1_cancel: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Oab__semigroup__mult,type,
    ab_semigroup_mult: 
      !>[A: $tType] : $o ).

thf(sy_cl_Lattices_Osemilattice__inf,type,
    semilattice_inf: 
      !>[A: $tType] : $o ).

thf(sy_cl_Lattices_Osemilattice__sup,type,
    semilattice_sup: 
      !>[A: $tType] : $o ).

thf(sy_cl_Orderings_Odense__linorder,type,
    dense_linorder: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Olinordered__semidom,type,
    linordered_semidom: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Oordered__semiring__0,type,
    ordered_semiring_0: 
      !>[A: $tType] : $o ).

thf(sy_cl_Real__Vector__Spaces_Obanach,type,
    real_Vector_banach: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Olinordered__semiring,type,
    linordered_semiring: 
      !>[A: $tType] : $o ).

thf(sy_cl_Enum_Ofinite__distrib__lattice,type,
    finite8700451911770168679attice: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Ocancel__semigroup__add,type,
    cancel_semigroup_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Oordered__ab__group__add,type,
    ordered_ab_group_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Olinordered__semiring__1,type,
    linord6961819062388156250ring_1: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Oordered__comm__semiring,type,
    ordere2520102378445227354miring: 
      !>[A: $tType] : $o ).

thf(sy_cl_Topological__Spaces_Ot2__space,type,
    topological_t2_space: 
      !>[A: $tType] : $o ).

thf(sy_cl_Topological__Spaces_Ot3__space,type,
    topological_t3_space: 
      !>[A: $tType] : $o ).

thf(sy_cl_Topological__Spaces_Ot4__space,type,
    topological_t4_space: 
      !>[A: $tType] : $o ).

thf(sy_cl_Bit__Operations_Osemiring__bits,type,
    bit_semiring_bits: 
      !>[A: $tType] : $o ).

thf(sy_cl_Limits_Otopological__group__add,type,
    topolo1633459387980952147up_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Ocomm__semiring__1__cancel,type,
    comm_s4317794764714335236cancel: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Olinordered__ring__strict,type,
    linord4710134922213307826strict: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Ocancel__comm__monoid__add,type,
    cancel1802427076303600483id_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Limits_Otopological__monoid__add,type,
    topolo6943815403480290642id_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Real__Vector__Spaces_Oreal__field,type,
    real_V7773925162809079976_field: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Oring__1__no__zero__divisors,type,
    ring_15535105094025558882visors: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Ocancel__ab__semigroup__add,type,
    cancel2418104881723323429up_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Olinordered__ab__group__add,type,
    linord5086331880401160121up_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Oordered__comm__monoid__add,type,
    ordere6911136660526730532id_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Limits_Otopological__monoid__mult,type,
    topolo1898628316856586783d_mult: 
      !>[A: $tType] : $o ).

thf(sy_cl_Real__Vector__Spaces_Oreal__vector,type,
    real_V4867850818363320053vector: 
      !>[A: $tType] : $o ).

thf(sy_cl_Archimedean__Field_Ofloor__ceiling,type,
    archim2362893244070406136eiling: 
      !>[A: $tType] : $o ).

thf(sy_cl_GCD_Osemiring__gcd__mult__normalize,type,
    semiri6843258321239162965malize: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Oordered__ab__group__add__abs,type,
    ordere166539214618696060dd_abs: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Oordered__ab__semigroup__add,type,
    ordere6658533253407199908up_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Limits_Otopological__ab__group__add,type,
    topolo1287966508704411220up_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Real__Vector__Spaces_Ometric__space,type,
    real_V7819770556892013058_space: 
      !>[A: $tType] : $o ).

thf(sy_cl_Real__Vector__Spaces_Oreal__algebra,type,
    real_V6157519004096292374lgebra: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Osemiring__no__zero__divisors,type,
    semiri3467727345109120633visors: 
      !>[A: $tType] : $o ).

thf(sy_cl_Boolean__Algebras_Oboolean__algebra,type,
    boolea8198339166811842893lgebra: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Olinordered__semiring__strict,type,
    linord8928482502909563296strict: 
      !>[A: $tType] : $o ).

thf(sy_cl_Topological__Spaces_Operfect__space,type,
    topolo8386298272705272623_space: 
      !>[A: $tType] : $o ).

thf(sy_cl_Topological__Spaces_Ouniform__space,type,
    topolo7287701948861334536_space: 
      !>[A: $tType] : $o ).

thf(sy_cl_Euclidean__Division_Oeuclidean__ring,type,
    euclid5891614535332579305n_ring: 
      !>[A: $tType] : $o ).

thf(sy_cl_Limits_Otopological__semigroup__mult,type,
    topolo4211221413907600880p_mult: 
      !>[A: $tType] : $o ).

thf(sy_cl_Real__Vector__Spaces_Ocomplete__space,type,
    real_V8037385150606011577_space: 
      !>[A: $tType] : $o ).

thf(sy_cl_Real__Vector__Spaces_Oreal__algebra__1,type,
    real_V2191834092415804123ebra_1: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Olinordered__nonzero__semiring,type,
    linord181362715937106298miring: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Osemiring__1__no__zero__divisors,type,
    semiri2026040879449505780visors: 
      !>[A: $tType] : $o ).

thf(sy_cl_Topological__Spaces_Oorder__topology,type,
    topolo2564578578187576103pology: 
      !>[A: $tType] : $o ).

thf(sy_cl_Bit__Operations_Oring__bit__operations,type,
    bit_ri3973907225187159222ations: 
      !>[A: $tType] : $o ).

thf(sy_cl_Complete__Lattices_Ocomplete__lattice,type,
    comple6319245703460814977attice: 
      !>[A: $tType] : $o ).

thf(sy_cl_Limits_Otopological__comm__monoid__add,type,
    topolo5987344860129210374id_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Orderings_Ounbounded__dense__linorder,type,
    unboun7993243217541854897norder: 
      !>[A: $tType] : $o ).

thf(sy_cl_Real__Vector__Spaces_Ouniformity__dist,type,
    real_V768167426530841204y_dist: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Olinordered__semiring__1__strict,type,
    linord715952674999750819strict: 
      !>[A: $tType] : $o ).

thf(sy_cl_Archimedean__Field_Oarchimedean__field,type,
    archim462609752435547400_field: 
      !>[A: $tType] : $o ).

thf(sy_cl_Complete__Lattices_Ocomplete__linorder,type,
    comple5582772986160207858norder: 
      !>[A: $tType] : $o ).

thf(sy_cl_Limits_Otopological__comm__monoid__mult,type,
    topolo4987421752381908075d_mult: 
      !>[A: $tType] : $o ).

thf(sy_cl_Real__Vector__Spaces_Oreal__div__algebra,type,
    real_V5047593784448816457lgebra: 
      !>[A: $tType] : $o ).

thf(sy_cl_Lattices_Obounded__semilattice__inf__top,type,
    bounde4346867609351753570nf_top: 
      !>[A: $tType] : $o ).

thf(sy_cl_Lattices_Obounded__semilattice__sup__bot,type,
    bounde4967611905675639751up_bot: 
      !>[A: $tType] : $o ).

thf(sy_cl_Real__Vector__Spaces_Oreal__normed__field,type,
    real_V3459762299906320749_field: 
      !>[A: $tType] : $o ).

thf(sy_cl_Topological__Spaces_Olinorder__topology,type,
    topolo1944317154257567458pology: 
      !>[A: $tType] : $o ).

thf(sy_cl_Topological__Spaces_Otopological__space,type,
    topolo4958980785337419405_space: 
      !>[A: $tType] : $o ).

thf(sy_cl_Euclidean__Division_Oeuclidean__semiring,type,
    euclid3725896446679973847miring: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Ocanonically__ordered__monoid__add,type,
    canoni5634975068530333245id_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Oordered__cancel__comm__monoid__add,type,
    ordere8940638589300402666id_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Ostrict__ordered__comm__monoid__add,type,
    strict7427464778891057005id_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Real__Vector__Spaces_Oreal__normed__vector,type,
    real_V822414075346904944vector: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Olinordered__comm__semiring__strict,type,
    linord2810124833399127020strict: 
      !>[A: $tType] : $o ).

thf(sy_cl_Bit__Operations_Osemiring__bit__operations,type,
    bit_se359711467146920520ations: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Oordered__ab__semigroup__add__imp__le,type,
    ordere2412721322843649153imp_le: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Oordered__cancel__ab__semigroup__add,type,
    ordere580206878836729694up_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Oordered__cancel__comm__monoid__diff,type,
    ordere1170586879665033532d_diff: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Ostrict__ordered__ab__semigroup__add,type,
    strict9044650504122735259up_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Real__Vector__Spaces_Oordered__real__vector,type,
    real_V5355595471888546746vector: 
      !>[A: $tType] : $o ).

thf(sy_cl_Real__Vector__Spaces_Oreal__normed__algebra,type,
    real_V4412858255891104859lgebra: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Osemiring__no__zero__divisors__cancel,type,
    semiri6575147826004484403cancel: 
      !>[A: $tType] : $o ).

thf(sy_cl_Euclidean__Division_Oeuclidean__ring__cancel,type,
    euclid8851590272496341667cancel: 
      !>[A: $tType] : $o ).

thf(sy_cl_Real__Vector__Spaces_Oreal__normed__algebra__1,type,
    real_V2822296259951069270ebra_1: 
      !>[A: $tType] : $o ).

thf(sy_cl_Divides_Ounique__euclidean__semiring__numeral,type,
    unique1627219031080169319umeral: 
      !>[A: $tType] : $o ).

thf(sy_cl_Complete__Lattices_Ocomplete__distrib__lattice,type,
    comple592849572758109894attice: 
      !>[A: $tType] : $o ).

thf(sy_cl_Real__Vector__Spaces_Oreal__normed__div__algebra,type,
    real_V8999393235501362500lgebra: 
      !>[A: $tType] : $o ).

thf(sy_cl_Topological__Spaces_Ofirst__countable__topology,type,
    topolo3112930676232923870pology: 
      !>[A: $tType] : $o ).

thf(sy_cl_Euclidean__Division_Oeuclidean__semiring__cancel,type,
    euclid4440199948858584721cancel: 
      !>[A: $tType] : $o ).

thf(sy_cl_Euclidean__Division_Ounique__euclidean__semiring,type,
    euclid3128863361964157862miring: 
      !>[A: $tType] : $o ).

thf(sy_cl_Topological__Spaces_Olinear__continuum__topology,type,
    topolo8458572112393995274pology: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Oordered__ab__semigroup__monoid__add__imp__le,type,
    ordere1937475149494474687imp_le: 
      !>[A: $tType] : $o ).

thf(sy_cl_Conditionally__Complete__Lattices_Olinear__continuum,type,
    condit5016429287641298734tinuum: 
      !>[A: $tType] : $o ).

thf(sy_cl_Euclidean__Division_Ounique__euclidean__ring__with__nat,type,
    euclid8789492081693882211th_nat: 
      !>[A: $tType] : $o ).

thf(sy_cl_Euclidean__Division_Ounique__euclidean__semiring__with__nat,type,
    euclid5411537665997757685th_nat: 
      !>[A: $tType] : $o ).

thf(sy_cl_Countable__Complete__Lattices_Ocountable__complete__lattice,type,
    counta3822494911875563373attice: 
      !>[A: $tType] : $o ).

thf(sy_cl_Semiring__Normalization_Ocomm__semiring__1__cancel__crossproduct,type,
    semiri1453513574482234551roduct: 
      !>[A: $tType] : $o ).

thf(sy_cl_Bit__Operations_Ounique__euclidean__semiring__with__bit__operations,type,
    bit_un5681908812861735899ations: 
      !>[A: $tType] : $o ).

thf(sy_cl_Conditionally__Complete__Lattices_Oconditionally__complete__lattice,type,
    condit1219197933456340205attice: 
      !>[A: $tType] : $o ).

thf(sy_cl_Conditionally__Complete__Lattices_Oconditionally__complete__linorder,type,
    condit6923001295902523014norder: 
      !>[A: $tType] : $o ).

thf(sy_c_Archimedean__Field_Oceiling,type,
    archimedean_ceiling: 
      !>[A: $tType] : ( A > int ) ).

thf(sy_c_Archimedean__Field_Ofloor__ceiling__class_Ofloor,type,
    archim6421214686448440834_floor: 
      !>[A: $tType] : ( A > int ) ).

thf(sy_c_Archimedean__Field_Ofrac,type,
    archimedean_frac: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Archimedean__Field_Oround,type,
    archimedean_round: 
      !>[A: $tType] : ( A > int ) ).

thf(sy_c_BNF__Greatest__Fixpoint_Oimage2,type,
    bNF_Greatest_image2: 
      !>[C: $tType,A: $tType,B: $tType] : ( ( set @ C ) > ( C > A ) > ( C > B ) > ( set @ ( product_prod @ A @ B ) ) ) ).

thf(sy_c_BNF__Wellorder__Constructions_OFunc,type,
    bNF_Wellorder_Func: 
      !>[A: $tType,B: $tType] : ( ( set @ A ) > ( set @ B ) > ( set @ ( A > B ) ) ) ).

thf(sy_c_BNF__Wellorder__Constructions_OFunc__map,type,
    bNF_We4925052301507509544nc_map: 
      !>[B: $tType,C: $tType,A: $tType,D: $tType] : ( ( set @ B ) > ( C > A ) > ( B > D ) > ( D > C ) > B > A ) ).

thf(sy_c_Basic__BNF__LFPs_Oprod_Osize__prod,type,
    basic_BNF_size_prod: 
      !>[A: $tType,B: $tType] : ( ( A > nat ) > ( B > nat ) > ( product_prod @ A @ B ) > nat ) ).

thf(sy_c_Binomial_Obinomial,type,
    binomial: nat > nat > nat ).

thf(sy_c_Binomial_Ogbinomial,type,
    gbinomial: 
      !>[A: $tType] : ( A > nat > A ) ).

thf(sy_c_Bit__Operations_Oand__int__rel,type,
    bit_and_int_rel: ( product_prod @ int @ int ) > ( product_prod @ int @ int ) > $o ).

thf(sy_c_Bit__Operations_Oand__not__num,type,
    bit_and_not_num: num > num > ( option @ num ) ).

thf(sy_c_Bit__Operations_Oand__not__num__rel,type,
    bit_and_not_num_rel: ( product_prod @ num @ num ) > ( product_prod @ num @ num ) > $o ).

thf(sy_c_Bit__Operations_Oconcat__bit,type,
    bit_concat_bit: nat > int > int > int ).

thf(sy_c_Bit__Operations_Oor__not__num__neg,type,
    bit_or_not_num_neg: num > num > num ).

thf(sy_c_Bit__Operations_Oor__not__num__neg__rel,type,
    bit_or3848514188828904588eg_rel: ( product_prod @ num @ num ) > ( product_prod @ num @ num ) > $o ).

thf(sy_c_Bit__Operations_Oring__bit__operations__class_Onot,type,
    bit_ri4277139882892585799ns_not: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Bit__Operations_Oring__bit__operations__class_Osigned__take__bit,type,
    bit_ri4674362597316999326ke_bit: 
      !>[A: $tType] : ( nat > A > A ) ).

thf(sy_c_Bit__Operations_Osemiring__bit__operations__class_Oand,type,
    bit_se5824344872417868541ns_and: 
      !>[A: $tType] : ( A > A > A ) ).

thf(sy_c_Bit__Operations_Osemiring__bit__operations__class_Odrop__bit,type,
    bit_se4197421643247451524op_bit: 
      !>[A: $tType] : ( nat > A > A ) ).

thf(sy_c_Bit__Operations_Osemiring__bit__operations__class_Oflip__bit,type,
    bit_se8732182000553998342ip_bit: 
      !>[A: $tType] : ( nat > A > A ) ).

thf(sy_c_Bit__Operations_Osemiring__bit__operations__class_Omask,type,
    bit_se2239418461657761734s_mask: 
      !>[A: $tType] : ( nat > A ) ).

thf(sy_c_Bit__Operations_Osemiring__bit__operations__class_Oor,type,
    bit_se1065995026697491101ons_or: 
      !>[A: $tType] : ( A > A > A ) ).

thf(sy_c_Bit__Operations_Osemiring__bit__operations__class_Opush__bit,type,
    bit_se4730199178511100633sh_bit: 
      !>[A: $tType] : ( nat > A > A ) ).

thf(sy_c_Bit__Operations_Osemiring__bit__operations__class_Oset__bit,type,
    bit_se5668285175392031749et_bit: 
      !>[A: $tType] : ( nat > A > A ) ).

thf(sy_c_Bit__Operations_Osemiring__bit__operations__class_Otake__bit,type,
    bit_se2584673776208193580ke_bit: 
      !>[A: $tType] : ( nat > A > A ) ).

thf(sy_c_Bit__Operations_Osemiring__bit__operations__class_Ounset__bit,type,
    bit_se2638667681897837118et_bit: 
      !>[A: $tType] : ( nat > A > A ) ).

thf(sy_c_Bit__Operations_Osemiring__bit__operations__class_Oxor,type,
    bit_se5824344971392196577ns_xor: 
      !>[A: $tType] : ( A > A > A ) ).

thf(sy_c_Bit__Operations_Osemiring__bits__class_Obit,type,
    bit_se5641148757651400278ts_bit: 
      !>[A: $tType] : ( A > nat > $o ) ).

thf(sy_c_Bit__Operations_Otake__bit__num,type,
    bit_take_bit_num: nat > num > ( option @ num ) ).

thf(sy_c_Bit__Operations_Ounique__euclidean__semiring__with__bit__operations_Oand__num,type,
    bit_un1837492267222099188nd_num: num > num > ( option @ num ) ).

thf(sy_c_Bit__Operations_Ounique__euclidean__semiring__with__bit__operations_Oand__num__rel,type,
    bit_un5425074673868309765um_rel: ( product_prod @ num @ num ) > ( product_prod @ num @ num ) > $o ).

thf(sy_c_Bit__Operations_Ounique__euclidean__semiring__with__bit__operations_Oxor__num,type,
    bit_un6178654185764691216or_num: num > num > ( option @ num ) ).

thf(sy_c_Bit__Operations_Ounique__euclidean__semiring__with__bit__operations_Oxor__num__rel,type,
    bit_un3595099601533988841um_rel: ( product_prod @ num @ num ) > ( product_prod @ num @ num ) > $o ).

thf(sy_c_Bit__Operations_Ounique__euclidean__semiring__with__bit__operations__class_Oand__num,type,
    bit_un7362597486090784418nd_num: num > num > ( option @ num ) ).

thf(sy_c_Bit__Operations_Ounique__euclidean__semiring__with__bit__operations__class_Oand__num__rel,type,
    bit_un4731106466462545111um_rel: ( product_prod @ num @ num ) > ( product_prod @ num @ num ) > $o ).

thf(sy_c_Bit__Operations_Ounique__euclidean__semiring__with__bit__operations__class_Oxor__num,type,
    bit_un2480387367778600638or_num: num > num > ( option @ num ) ).

thf(sy_c_Bit__Operations_Ounique__euclidean__semiring__with__bit__operations__class_Oxor__num__rel,type,
    bit_un2901131394128224187um_rel: ( product_prod @ num @ num ) > ( product_prod @ num @ num ) > $o ).

thf(sy_c_Boolean__Algebras_Oabstract__boolean__algebra,type,
    boolea2506097494486148201lgebra: 
      !>[A: $tType] : ( ( A > A > A ) > ( A > A > A ) > ( A > A ) > A > A > $o ) ).

thf(sy_c_Boolean__Algebras_Oabstract__boolean__algebra__sym__diff,type,
    boolea3799213064322606851m_diff: 
      !>[A: $tType] : ( ( A > A > A ) > ( A > A > A ) > ( A > A ) > A > A > ( A > A > A ) > $o ) ).

thf(sy_c_Code__Numeral_Obit__cut__integer,type,
    code_bit_cut_integer: code_integer > ( product_prod @ code_integer @ $o ) ).

thf(sy_c_Code__Numeral_Odivmod__abs,type,
    code_divmod_abs: code_integer > code_integer > ( product_prod @ code_integer @ code_integer ) ).

thf(sy_c_Code__Numeral_Odivmod__integer,type,
    code_divmod_integer: code_integer > code_integer > ( product_prod @ code_integer @ code_integer ) ).

thf(sy_c_Code__Numeral_Ointeger_Oint__of__integer,type,
    code_int_of_integer: code_integer > int ).

thf(sy_c_Code__Numeral_Ointeger_Ointeger__of__int,type,
    code_integer_of_int: int > code_integer ).

thf(sy_c_Code__Numeral_Ointeger__of__num,type,
    code_integer_of_num: num > code_integer ).

thf(sy_c_Code__Numeral_Onat__of__integer,type,
    code_nat_of_integer: code_integer > nat ).

thf(sy_c_Code__Numeral_Onegative,type,
    code_negative: num > code_integer ).

thf(sy_c_Code__Numeral_Onum__of__integer,type,
    code_num_of_integer: code_integer > num ).

thf(sy_c_Code__Numeral_Opositive,type,
    code_positive: num > code_integer ).

thf(sy_c_Code__Target__Int_Onegative,type,
    code_Target_negative: num > int ).

thf(sy_c_Code__Target__Int_Opositive,type,
    code_Target_positive: num > int ).

thf(sy_c_Complete__Lattices_OInf__class_OInf,type,
    complete_Inf_Inf: 
      !>[A: $tType] : ( ( set @ A ) > A ) ).

thf(sy_c_Complete__Lattices_OSup__class_OSup,type,
    complete_Sup_Sup: 
      !>[A: $tType] : ( ( set @ A ) > A ) ).

thf(sy_c_Complex_OArg,type,
    arg: complex > real ).

thf(sy_c_Complex_Ocis,type,
    cis: real > complex ).

thf(sy_c_Complex_Ocnj,type,
    cnj: complex > complex ).

thf(sy_c_Complex_Ocomplex_OComplex,type,
    complex2: real > real > complex ).

thf(sy_c_Complex_Ocomplex_OIm,type,
    im: complex > real ).

thf(sy_c_Complex_Ocomplex_ORe,type,
    re: complex > real ).

thf(sy_c_Complex_Ocsqrt,type,
    csqrt: complex > complex ).

thf(sy_c_Complex_Oimaginary__unit,type,
    imaginary_unit: complex ).

thf(sy_c_Deriv_Odifferentiable,type,
    differentiable: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > ( filter @ A ) > $o ) ).

thf(sy_c_Deriv_Ohas__derivative,type,
    has_derivative: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > ( A > B ) > ( filter @ A ) > $o ) ).

thf(sy_c_Deriv_Ohas__field__derivative,type,
    has_field_derivative: 
      !>[A: $tType] : ( ( A > A ) > A > ( filter @ A ) > $o ) ).

thf(sy_c_Divides_Oadjust__div,type,
    adjust_div: ( product_prod @ int @ int ) > int ).

thf(sy_c_Divides_Oadjust__mod,type,
    adjust_mod: int > int > int ).

thf(sy_c_Divides_Odivmod__nat,type,
    divmod_nat: nat > nat > ( product_prod @ nat @ nat ) ).

thf(sy_c_Divides_Oeucl__rel__int,type,
    eucl_rel_int: int > int > ( product_prod @ int @ int ) > $o ).

thf(sy_c_Divides_Ounique__euclidean__semiring__numeral__class_Odivides__aux,type,
    unique5940410009612947441es_aux: 
      !>[A: $tType] : ( ( product_prod @ A @ A ) > $o ) ).

thf(sy_c_Divides_Ounique__euclidean__semiring__numeral__class_Odivmod,type,
    unique8689654367752047608divmod: 
      !>[A: $tType] : ( num > num > ( product_prod @ A @ A ) ) ).

thf(sy_c_Divides_Ounique__euclidean__semiring__numeral__class_Odivmod__step,type,
    unique1321980374590559556d_step: 
      !>[A: $tType] : ( num > ( product_prod @ A @ A ) > ( product_prod @ A @ A ) ) ).

thf(sy_c_Factorial_Ocomm__semiring__1__class_Opochhammer,type,
    comm_s3205402744901411588hammer: 
      !>[A: $tType] : ( A > nat > A ) ).

thf(sy_c_Factorial_Osemiring__char__0__class_Ofact,type,
    semiring_char_0_fact: 
      !>[A: $tType] : ( nat > A ) ).

thf(sy_c_Fields_Oinverse__class_Oinverse,type,
    inverse_inverse: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Filter_Oat__bot,type,
    at_bot: 
      !>[A: $tType] : ( filter @ A ) ).

thf(sy_c_Filter_Oat__top,type,
    at_top: 
      !>[A: $tType] : ( filter @ A ) ).

thf(sy_c_Filter_Oeventually,type,
    eventually: 
      !>[A: $tType] : ( ( A > $o ) > ( filter @ A ) > $o ) ).

thf(sy_c_Filter_Ofilterlim,type,
    filterlim: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > ( filter @ B ) > ( filter @ A ) > $o ) ).

thf(sy_c_Filter_Omap__filter__on,type,
    map_filter_on: 
      !>[A: $tType,B: $tType] : ( ( set @ A ) > ( A > B ) > ( filter @ A ) > ( filter @ B ) ) ).

thf(sy_c_Filter_Oprincipal,type,
    principal: 
      !>[A: $tType] : ( ( set @ A ) > ( filter @ A ) ) ).

thf(sy_c_Finite__Set_OFpow,type,
    finite_Fpow: 
      !>[A: $tType] : ( ( set @ A ) > ( set @ ( set @ A ) ) ) ).

thf(sy_c_Finite__Set_Ocard,type,
    finite_card: 
      !>[B: $tType] : ( ( set @ B ) > nat ) ).

thf(sy_c_Finite__Set_Ocomp__fun__commute,type,
    finite6289374366891150609ommute: 
      !>[A: $tType,B: $tType] : ( ( A > B > B ) > $o ) ).

thf(sy_c_Finite__Set_Ocomp__fun__commute__on,type,
    finite4664212375090638736ute_on: 
      !>[A: $tType,B: $tType] : ( ( set @ A ) > ( A > B > B ) > $o ) ).

thf(sy_c_Finite__Set_Ofinite,type,
    finite_finite: 
      !>[A: $tType] : ( ( set @ A ) > $o ) ).

thf(sy_c_Finite__Set_Ofold,type,
    finite_fold: 
      !>[A: $tType,B: $tType] : ( ( A > B > B ) > B > ( set @ A ) > B ) ).

thf(sy_c_Finite__Set_Ofolding__idem__on,type,
    finite1890593828518410140dem_on: 
      !>[A: $tType,B: $tType] : ( ( set @ A ) > ( A > B > B ) > $o ) ).

thf(sy_c_Finite__Set_Ofolding__on,type,
    finite_folding_on: 
      !>[A: $tType,B: $tType] : ( ( set @ A ) > ( A > B > B ) > $o ) ).

thf(sy_c_Finite__Set_Ofolding__on_OF,type,
    finite_folding_F: 
      !>[A: $tType,B: $tType] : ( ( A > B > B ) > B > ( set @ A ) > B ) ).

thf(sy_c_Fun_Obij__betw,type,
    bij_betw: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > ( set @ A ) > ( set @ B ) > $o ) ).

thf(sy_c_Fun_Ocomp,type,
    comp: 
      !>[B: $tType,C: $tType,A: $tType] : ( ( B > C ) > ( A > B ) > A > C ) ).

thf(sy_c_Fun_Ofun__upd,type,
    fun_upd: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > A > B > A > B ) ).

thf(sy_c_Fun_Oinj__on,type,
    inj_on: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > ( set @ A ) > $o ) ).

thf(sy_c_Fun_Omap__fun,type,
    map_fun: 
      !>[C: $tType,A: $tType,B: $tType,D: $tType] : ( ( C > A ) > ( B > D ) > ( A > B ) > C > D ) ).

thf(sy_c_Fun_Ostrict__mono__on,type,
    strict_mono_on: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > ( set @ A ) > $o ) ).

thf(sy_c_Fun_Othe__inv__into,type,
    the_inv_into: 
      !>[A: $tType,B: $tType] : ( ( set @ A ) > ( A > B ) > B > A ) ).

thf(sy_c_GCD_OGcd__class_OGcd,type,
    gcd_Gcd: 
      !>[A: $tType] : ( ( set @ A ) > A ) ).

thf(sy_c_GCD_Obezw,type,
    bezw: nat > nat > ( product_prod @ int @ int ) ).

thf(sy_c_GCD_Obezw__rel,type,
    bezw_rel: ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) > $o ).

thf(sy_c_GCD_Ogcd__class_Ogcd,type,
    gcd_gcd: 
      !>[A: $tType] : ( A > A > A ) ).

thf(sy_c_GCD_Ogcd__nat__rel,type,
    gcd_nat_rel: ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) > $o ).

thf(sy_c_GCD_Osemiring__1__class_Osemiring__char,type,
    semiri4206861660011772517g_char: 
      !>[A: $tType] : ( ( itself @ A ) > nat ) ).

thf(sy_c_Groups_Oabs__class_Oabs,type,
    abs_abs: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Groups_Ominus__class_Ominus,type,
    minus_minus: 
      !>[A: $tType] : ( A > A > A ) ).

thf(sy_c_Groups_Oone__class_Oone,type,
    one_one: 
      !>[A: $tType] : A ).

thf(sy_c_Groups_Oplus__class_Oplus,type,
    plus_plus: 
      !>[A: $tType] : ( A > A > A ) ).

thf(sy_c_Groups_Osgn__class_Osgn,type,
    sgn_sgn: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Groups_Otimes__class_Otimes,type,
    times_times: 
      !>[A: $tType] : ( A > A > A ) ).

thf(sy_c_Groups_Ouminus__class_Ouminus,type,
    uminus_uminus: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Groups_Ozero__class_Ozero,type,
    zero_zero: 
      !>[A: $tType] : A ).

thf(sy_c_Groups__Big_Ocomm__monoid__add__class_Osum,type,
    groups7311177749621191930dd_sum: 
      !>[B: $tType,A: $tType] : ( ( B > A ) > ( set @ B ) > A ) ).

thf(sy_c_Groups__Big_Ocomm__monoid__add__class_Osum_H,type,
    groups1027152243600224163dd_sum: 
      !>[C: $tType,A: $tType] : ( ( C > A ) > ( set @ C ) > A ) ).

thf(sy_c_Groups__Big_Ocomm__monoid__mult__class_Oprod,type,
    groups7121269368397514597t_prod: 
      !>[B: $tType,A: $tType] : ( ( B > A ) > ( set @ B ) > A ) ).

thf(sy_c_Groups__Big_Ocomm__monoid__mult__class_Oprod_H,type,
    groups1962203154675924110t_prod: 
      !>[C: $tType,A: $tType] : ( ( C > A ) > ( set @ C ) > A ) ).

thf(sy_c_Groups__List_Ocomm__semiring__0__class_Ohorner__sum,type,
    groups4207007520872428315er_sum: 
      !>[B: $tType,A: $tType] : ( ( B > A ) > A > ( list @ B ) > A ) ).

thf(sy_c_Groups__List_Omonoid__add__class_Osum__list,type,
    groups8242544230860333062m_list: 
      !>[A: $tType] : ( ( list @ A ) > A ) ).

thf(sy_c_HOL_ONO__MATCH,type,
    nO_MATCH: 
      !>[A: $tType,B: $tType] : ( A > B > $o ) ).

thf(sy_c_HOL_OThe,type,
    the: 
      !>[A: $tType] : ( ( A > $o ) > A ) ).

thf(sy_c_If,type,
    if: 
      !>[A: $tType] : ( $o > A > A > A ) ).

thf(sy_c_Int_OAbs__Integ,type,
    abs_Integ: ( product_prod @ nat @ nat ) > int ).

thf(sy_c_Int_ORep__Integ,type,
    rep_Integ: int > ( product_prod @ nat @ nat ) ).

thf(sy_c_Int_Oint__ge__less__than,type,
    int_ge_less_than: int > ( set @ ( product_prod @ int @ int ) ) ).

thf(sy_c_Int_Oint__ge__less__than2,type,
    int_ge_less_than2: int > ( set @ ( product_prod @ int @ int ) ) ).

thf(sy_c_Int_Onat,type,
    nat2: int > nat ).

thf(sy_c_Int_Opower__int,type,
    power_int: 
      !>[A: $tType] : ( A > int > A ) ).

thf(sy_c_Int_Oring__1__class_OInts,type,
    ring_1_Ints: 
      !>[A: $tType] : ( set @ A ) ).

thf(sy_c_Int_Oring__1__class_Oof__int,type,
    ring_1_of_int: 
      !>[A: $tType] : ( int > A ) ).

thf(sy_c_Lattices_Oinf__class_Oinf,type,
    inf_inf: 
      !>[A: $tType] : ( A > A > A ) ).

thf(sy_c_Lattices_Osemilattice__neutr__order,type,
    semila1105856199041335345_order: 
      !>[A: $tType] : ( ( A > A > A ) > A > ( A > A > $o ) > ( A > A > $o ) > $o ) ).

thf(sy_c_Lattices_Osup__class_Osup,type,
    sup_sup: 
      !>[A: $tType] : ( A > A > A ) ).

thf(sy_c_Lattices__Big_Oord__class_Oarg__min__on,type,
    lattic7623131987881927897min_on: 
      !>[B: $tType,A: $tType] : ( ( B > A ) > ( set @ B ) > B ) ).

thf(sy_c_Limits_OBfun,type,
    bfun: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > ( filter @ A ) > $o ) ).

thf(sy_c_Limits_Oat__infinity,type,
    at_infinity: 
      !>[A: $tType] : ( filter @ A ) ).

thf(sy_c_List_Oappend,type,
    append: 
      !>[A: $tType] : ( ( list @ A ) > ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_Obind,type,
    bind: 
      !>[A: $tType,B: $tType] : ( ( list @ A ) > ( A > ( list @ B ) ) > ( list @ B ) ) ).

thf(sy_c_List_Oconcat,type,
    concat: 
      !>[A: $tType] : ( ( list @ ( list @ A ) ) > ( list @ A ) ) ).

thf(sy_c_List_Ocount__list,type,
    count_list: 
      !>[A: $tType] : ( ( list @ A ) > A > nat ) ).

thf(sy_c_List_Odistinct,type,
    distinct: 
      !>[A: $tType] : ( ( list @ A ) > $o ) ).

thf(sy_c_List_OdropWhile,type,
    dropWhile: 
      !>[A: $tType] : ( ( A > $o ) > ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_Oenumerate,type,
    enumerate: 
      !>[A: $tType] : ( nat > ( list @ A ) > ( list @ ( product_prod @ nat @ A ) ) ) ).

thf(sy_c_List_Oextract,type,
    extract: 
      !>[A: $tType] : ( ( A > $o ) > ( list @ A ) > ( option @ ( product_prod @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) ) ) ) ).

thf(sy_c_List_Ofilter,type,
    filter2: 
      !>[A: $tType] : ( ( A > $o ) > ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_Ofind,type,
    find: 
      !>[A: $tType] : ( ( A > $o ) > ( list @ A ) > ( option @ A ) ) ).

thf(sy_c_List_Ofolding__insort__key,type,
    folding_insort_key: 
      !>[A: $tType,B: $tType] : ( ( A > A > $o ) > ( A > A > $o ) > ( set @ B ) > ( B > A ) > $o ) ).

thf(sy_c_List_Ofoldr,type,
    foldr: 
      !>[A: $tType,B: $tType] : ( ( A > B > B ) > ( list @ A ) > B > B ) ).

thf(sy_c_List_Olenlex,type,
    lenlex: 
      !>[A: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > ( set @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) ) ) ).

thf(sy_c_List_Olex,type,
    lex: 
      !>[A: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > ( set @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) ) ) ).

thf(sy_c_List_Olexn,type,
    lexn: 
      !>[A: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > nat > ( set @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) ) ) ).

thf(sy_c_List_Olexord,type,
    lexord: 
      !>[A: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > ( set @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) ) ) ).

thf(sy_c_List_Olexordp,type,
    lexordp: 
      !>[A: $tType] : ( ( A > A > $o ) > ( list @ A ) > ( list @ A ) > $o ) ).

thf(sy_c_List_Olinorder_Oinsort__key,type,
    insort_key: 
      !>[A: $tType,B: $tType] : ( ( A > A > $o ) > ( B > A ) > B > ( list @ B ) > ( list @ B ) ) ).

thf(sy_c_List_Olinorder_Osorted__key__list__of__set,type,
    sorted8670434370408473282of_set: 
      !>[A: $tType,B: $tType] : ( ( A > A > $o ) > ( B > A ) > ( set @ B ) > ( list @ B ) ) ).

thf(sy_c_List_Olinorder__class_Oinsort__key,type,
    linorder_insort_key: 
      !>[B: $tType,A: $tType] : ( ( B > A ) > B > ( list @ B ) > ( list @ B ) ) ).

thf(sy_c_List_Olinorder__class_Osorted__key__list__of__set,type,
    linord144544945434240204of_set: 
      !>[B: $tType,A: $tType] : ( ( B > A ) > ( set @ B ) > ( list @ B ) ) ).

thf(sy_c_List_Olinorder__class_Osorted__list__of__set,type,
    linord4507533701916653071of_set: 
      !>[A: $tType] : ( ( set @ A ) > ( list @ A ) ) ).

thf(sy_c_List_Olist_OCons,type,
    cons: 
      !>[A: $tType] : ( A > ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_Olist_ONil,type,
    nil: 
      !>[A: $tType] : ( list @ A ) ).

thf(sy_c_List_Olist_Ocase__list,type,
    case_list: 
      !>[B: $tType,A: $tType] : ( B > ( A > ( list @ A ) > B ) > ( list @ A ) > B ) ).

thf(sy_c_List_Olist_Ohd,type,
    hd: 
      !>[A: $tType] : ( ( list @ A ) > A ) ).

thf(sy_c_List_Olist_Omap,type,
    map: 
      !>[A: $tType,Aa: $tType] : ( ( A > Aa ) > ( list @ A ) > ( list @ Aa ) ) ).

thf(sy_c_List_Olist_Oset,type,
    set2: 
      !>[A: $tType] : ( ( list @ A ) > ( set @ A ) ) ).

thf(sy_c_List_Olist_Osize__list,type,
    size_list: 
      !>[A: $tType] : ( ( A > nat ) > ( list @ A ) > nat ) ).

thf(sy_c_List_Olist_Otl,type,
    tl: 
      !>[A: $tType] : ( ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_Olist__update,type,
    list_update: 
      !>[A: $tType] : ( ( list @ A ) > nat > A > ( list @ A ) ) ).

thf(sy_c_List_Olistrel1,type,
    listrel1: 
      !>[A: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > ( set @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) ) ) ).

thf(sy_c_List_Olistrel1p,type,
    listrel1p: 
      !>[A: $tType] : ( ( A > A > $o ) > ( list @ A ) > ( list @ A ) > $o ) ).

thf(sy_c_List_Olistset,type,
    listset: 
      !>[A: $tType] : ( ( list @ ( set @ A ) ) > ( set @ ( list @ A ) ) ) ).

thf(sy_c_List_Omap__filter,type,
    map_filter: 
      !>[A: $tType,B: $tType] : ( ( A > ( option @ B ) ) > ( list @ A ) > ( list @ B ) ) ).

thf(sy_c_List_On__lists,type,
    n_lists: 
      !>[A: $tType] : ( nat > ( list @ A ) > ( list @ ( list @ A ) ) ) ).

thf(sy_c_List_Onth,type,
    nth: 
      !>[A: $tType] : ( ( list @ A ) > nat > A ) ).

thf(sy_c_List_Opartition,type,
    partition: 
      !>[A: $tType] : ( ( A > $o ) > ( list @ A ) > ( product_prod @ ( list @ A ) @ ( list @ A ) ) ) ).

thf(sy_c_List_Oproduct,type,
    product: 
      !>[A: $tType,B: $tType] : ( ( list @ A ) > ( list @ B ) > ( list @ ( product_prod @ A @ B ) ) ) ).

thf(sy_c_List_Oproduct__lists,type,
    product_lists: 
      !>[A: $tType] : ( ( list @ ( list @ A ) ) > ( list @ ( list @ A ) ) ) ).

thf(sy_c_List_Oremdups,type,
    remdups: 
      !>[A: $tType] : ( ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_Oremdups__adj,type,
    remdups_adj: 
      !>[A: $tType] : ( ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_Oremdups__adj__rel,type,
    remdups_adj_rel: 
      !>[A: $tType] : ( ( list @ A ) > ( list @ A ) > $o ) ).

thf(sy_c_List_Oremove1,type,
    remove1: 
      !>[A: $tType] : ( A > ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_OremoveAll,type,
    removeAll: 
      !>[A: $tType] : ( A > ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_Oreplicate,type,
    replicate: 
      !>[A: $tType] : ( nat > A > ( list @ A ) ) ).

thf(sy_c_List_Orev,type,
    rev: 
      !>[A: $tType] : ( ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_Orotate1,type,
    rotate1: 
      !>[A: $tType] : ( ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_Oset__Cons,type,
    set_Cons: 
      !>[A: $tType] : ( ( set @ A ) > ( set @ ( list @ A ) ) > ( set @ ( list @ A ) ) ) ).

thf(sy_c_List_Oshuffles,type,
    shuffles: 
      !>[A: $tType] : ( ( list @ A ) > ( list @ A ) > ( set @ ( list @ A ) ) ) ).

thf(sy_c_List_Oshuffles__rel,type,
    shuffles_rel: 
      !>[A: $tType] : ( ( product_prod @ ( list @ A ) @ ( list @ A ) ) > ( product_prod @ ( list @ A ) @ ( list @ A ) ) > $o ) ).

thf(sy_c_List_Osorted__wrt,type,
    sorted_wrt: 
      !>[A: $tType] : ( ( A > A > $o ) > ( list @ A ) > $o ) ).

thf(sy_c_List_Osorted__wrt__rel,type,
    sorted_wrt_rel: 
      !>[A: $tType] : ( ( product_prod @ ( A > A > $o ) @ ( list @ A ) ) > ( product_prod @ ( A > A > $o ) @ ( list @ A ) ) > $o ) ).

thf(sy_c_List_Osplice,type,
    splice: 
      !>[A: $tType] : ( ( list @ A ) > ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_Osplice__rel,type,
    splice_rel: 
      !>[A: $tType] : ( ( product_prod @ ( list @ A ) @ ( list @ A ) ) > ( product_prod @ ( list @ A ) @ ( list @ A ) ) > $o ) ).

thf(sy_c_List_Osubseqs,type,
    subseqs: 
      !>[A: $tType] : ( ( list @ A ) > ( list @ ( list @ A ) ) ) ).

thf(sy_c_List_OtakeWhile,type,
    takeWhile: 
      !>[A: $tType] : ( ( A > $o ) > ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_Otranspose,type,
    transpose: 
      !>[A: $tType] : ( ( list @ ( list @ A ) ) > ( list @ ( list @ A ) ) ) ).

thf(sy_c_List_Otranspose__rel,type,
    transpose_rel: 
      !>[A: $tType] : ( ( list @ ( list @ A ) ) > ( list @ ( list @ A ) ) > $o ) ).

thf(sy_c_List_Ounion,type,
    union: 
      !>[A: $tType] : ( ( list @ A ) > ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_Oupt,type,
    upt: nat > nat > ( list @ nat ) ).

thf(sy_c_List_Oupto,type,
    upto: int > int > ( list @ int ) ).

thf(sy_c_List_Oupto__aux,type,
    upto_aux: int > int > ( list @ int ) > ( list @ int ) ).

thf(sy_c_List_Oupto__rel,type,
    upto_rel: ( product_prod @ int @ int ) > ( product_prod @ int @ int ) > $o ).

thf(sy_c_Map_Odom,type,
    dom: 
      !>[A: $tType,B: $tType] : ( ( A > ( option @ B ) ) > ( set @ A ) ) ).

thf(sy_c_Map_Ograph,type,
    graph: 
      !>[A: $tType,B: $tType] : ( ( A > ( option @ B ) ) > ( set @ ( product_prod @ A @ B ) ) ) ).

thf(sy_c_Map_Omap__of,type,
    map_of: 
      !>[A: $tType,B: $tType] : ( ( list @ ( product_prod @ A @ B ) ) > A > ( option @ B ) ) ).

thf(sy_c_Map_Omap__upds,type,
    map_upds: 
      !>[A: $tType,B: $tType] : ( ( A > ( option @ B ) ) > ( list @ A ) > ( list @ B ) > A > ( option @ B ) ) ).

thf(sy_c_Map_Oran,type,
    ran: 
      !>[A: $tType,B: $tType] : ( ( A > ( option @ B ) ) > ( set @ B ) ) ).

thf(sy_c_Map_Orestrict__map,type,
    restrict_map: 
      !>[A: $tType,B: $tType] : ( ( A > ( option @ B ) ) > ( set @ A ) > A > ( option @ B ) ) ).

thf(sy_c_Nat_OSuc,type,
    suc: nat > nat ).

thf(sy_c_Nat_Ocompow,type,
    compow: 
      !>[A: $tType] : ( nat > A > A ) ).

thf(sy_c_Nat_Ofunpow,type,
    funpow: 
      !>[A: $tType] : ( nat > ( A > A ) > A > A ) ).

thf(sy_c_Nat_Onat_Ocase__nat,type,
    case_nat: 
      !>[A: $tType] : ( A > ( nat > A ) > nat > A ) ).

thf(sy_c_Nat_Onat_Opred,type,
    pred: nat > nat ).

thf(sy_c_Nat_Oold_Onat_Orec__nat,type,
    rec_nat: 
      !>[T: $tType] : ( T > ( nat > T > T ) > nat > T ) ).

thf(sy_c_Nat_Oold_Onat_Orec__set__nat,type,
    rec_set_nat: 
      !>[T: $tType] : ( T > ( nat > T > T ) > nat > T > $o ) ).

thf(sy_c_Nat_Osemiring__1__class_Oof__nat,type,
    semiring_1_of_nat: 
      !>[A: $tType] : ( nat > A ) ).

thf(sy_c_Nat_Osemiring__1__class_Oof__nat__aux,type,
    semiri8178284476397505188at_aux: 
      !>[A: $tType] : ( ( A > A ) > nat > A > A ) ).

thf(sy_c_Nat_Osize__class_Osize,type,
    size_size: 
      !>[A: $tType] : ( A > nat ) ).

thf(sy_c_Nat__Bijection_Oprod__decode__aux,type,
    nat_prod_decode_aux: nat > nat > ( product_prod @ nat @ nat ) ).

thf(sy_c_Nat__Bijection_Oprod__decode__aux__rel,type,
    nat_pr5047031295181774490ux_rel: ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) > $o ).

thf(sy_c_Nat__Bijection_Oset__decode,type,
    nat_set_decode: nat > ( set @ nat ) ).

thf(sy_c_Nat__Bijection_Oset__encode,type,
    nat_set_encode: ( set @ nat ) > nat ).

thf(sy_c_Nat__Bijection_Otriangle,type,
    nat_triangle: nat > nat ).

thf(sy_c_NthRoot_Oroot,type,
    root: nat > real > real ).

thf(sy_c_NthRoot_Osqrt,type,
    sqrt: real > real ).

thf(sy_c_Num_OBitM,type,
    bitM: num > num ).

thf(sy_c_Num_Oinc,type,
    inc: num > num ).

thf(sy_c_Num_Oneg__numeral__class_Odbl,type,
    neg_numeral_dbl: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Num_Oneg__numeral__class_Odbl__dec,type,
    neg_numeral_dbl_dec: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Num_Oneg__numeral__class_Odbl__inc,type,
    neg_numeral_dbl_inc: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Num_Oneg__numeral__class_Osub,type,
    neg_numeral_sub: 
      !>[A: $tType] : ( num > num > A ) ).

thf(sy_c_Num_Onum_OBit0,type,
    bit0: num > num ).

thf(sy_c_Num_Onum_OBit1,type,
    bit1: num > num ).

thf(sy_c_Num_Onum_OOne,type,
    one2: num ).

thf(sy_c_Num_Onum_Ocase__num,type,
    case_num: 
      !>[A: $tType] : ( A > ( num > A ) > ( num > A ) > num > A ) ).

thf(sy_c_Num_Onum_Osize__num,type,
    size_num: num > nat ).

thf(sy_c_Num_Onum__of__nat,type,
    num_of_nat: nat > num ).

thf(sy_c_Num_Onumeral__class_Onumeral,type,
    numeral_numeral: 
      !>[A: $tType] : ( num > A ) ).

thf(sy_c_Num_Opow,type,
    pow: num > num > num ).

thf(sy_c_Num_Opred__numeral,type,
    pred_numeral: num > nat ).

thf(sy_c_Num_Oring__1__class_Oiszero,type,
    ring_1_iszero: 
      !>[A: $tType] : ( A > $o ) ).

thf(sy_c_Num_Osqr,type,
    sqr: num > num ).

thf(sy_c_Option_Ooption_ONone,type,
    none: 
      !>[A: $tType] : ( option @ A ) ).

thf(sy_c_Option_Ooption_OSome,type,
    some: 
      !>[A: $tType] : ( A > ( option @ A ) ) ).

thf(sy_c_Option_Ooption_Ocase__option,type,
    case_option: 
      !>[B: $tType,A: $tType] : ( B > ( A > B ) > ( option @ A ) > B ) ).

thf(sy_c_Option_Ooption_Omap__option,type,
    map_option: 
      !>[A: $tType,Aa: $tType] : ( ( A > Aa ) > ( option @ A ) > ( option @ Aa ) ) ).

thf(sy_c_Option_Ooption_Osize__option,type,
    size_option: 
      !>[A: $tType] : ( ( A > nat ) > ( option @ A ) > nat ) ).

thf(sy_c_Option_Ooption_Othe,type,
    the2: 
      !>[A: $tType] : ( ( option @ A ) > A ) ).

thf(sy_c_Option_Othese,type,
    these: 
      !>[A: $tType] : ( ( set @ ( option @ A ) ) > ( set @ A ) ) ).

thf(sy_c_Orderings_Obot__class_Obot,type,
    bot_bot: 
      !>[A: $tType] : A ).

thf(sy_c_Orderings_Oord__class_Oless,type,
    ord_less: 
      !>[A: $tType] : ( A > A > $o ) ).

thf(sy_c_Orderings_Oord__class_Oless__eq,type,
    ord_less_eq: 
      !>[A: $tType] : ( A > A > $o ) ).

thf(sy_c_Orderings_Oord__class_Omax,type,
    ord_max: 
      !>[A: $tType] : ( A > A > A ) ).

thf(sy_c_Orderings_Oorder__class_OGreatest,type,
    order_Greatest: 
      !>[A: $tType] : ( ( A > $o ) > A ) ).

thf(sy_c_Orderings_Oorder__class_Oantimono,type,
    order_antimono: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > $o ) ).

thf(sy_c_Orderings_Oorder__class_Omono,type,
    order_mono: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > $o ) ).

thf(sy_c_Orderings_Oorder__class_Ostrict__mono,type,
    order_strict_mono: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > $o ) ).

thf(sy_c_Orderings_Otop__class_Otop,type,
    top_top: 
      !>[A: $tType] : A ).

thf(sy_c_Power_Opower__class_Opower,type,
    power_power: 
      !>[A: $tType] : ( A > nat > A ) ).

thf(sy_c_Product__Type_OPair,type,
    product_Pair: 
      !>[A: $tType,B: $tType] : ( A > B > ( product_prod @ A @ B ) ) ).

thf(sy_c_Product__Type_OSigma,type,
    product_Sigma: 
      !>[A: $tType,B: $tType] : ( ( set @ A ) > ( A > ( set @ B ) ) > ( set @ ( product_prod @ A @ B ) ) ) ).

thf(sy_c_Product__Type_Oapfst,type,
    product_apfst: 
      !>[A: $tType,C: $tType,B: $tType] : ( ( A > C ) > ( product_prod @ A @ B ) > ( product_prod @ C @ B ) ) ).

thf(sy_c_Product__Type_Oapsnd,type,
    product_apsnd: 
      !>[B: $tType,C: $tType,A: $tType] : ( ( B > C ) > ( product_prod @ A @ B ) > ( product_prod @ A @ C ) ) ).

thf(sy_c_Product__Type_Oold_Oprod_Orec__prod,type,
    product_rec_prod: 
      !>[A: $tType,B: $tType,T: $tType] : ( ( A > B > T ) > ( product_prod @ A @ B ) > T ) ).

thf(sy_c_Product__Type_Oprod_Ocase__prod,type,
    product_case_prod: 
      !>[A: $tType,B: $tType,C: $tType] : ( ( A > B > C ) > ( product_prod @ A @ B ) > C ) ).

thf(sy_c_Product__Type_Oprod_Ofst,type,
    product_fst: 
      !>[A: $tType,B: $tType] : ( ( product_prod @ A @ B ) > A ) ).

thf(sy_c_Product__Type_Oprod_Osnd,type,
    product_snd: 
      !>[A: $tType,B: $tType] : ( ( product_prod @ A @ B ) > B ) ).

thf(sy_c_Product__Type_Oproduct,type,
    product_product: 
      !>[A: $tType,B: $tType] : ( ( set @ A ) > ( set @ B ) > ( set @ ( product_prod @ A @ B ) ) ) ).

thf(sy_c_Rat_OFract,type,
    fract: int > int > rat ).

thf(sy_c_Rat_OFrct,type,
    frct: ( product_prod @ int @ int ) > rat ).

thf(sy_c_Rat_Onormalize,type,
    normalize: ( product_prod @ int @ int ) > ( product_prod @ int @ int ) ).

thf(sy_c_Rat_Oquotient__of,type,
    quotient_of: rat > ( product_prod @ int @ int ) ).

thf(sy_c_Real__Vector__Spaces_OReals,type,
    real_Vector_Reals: 
      !>[A: $tType] : ( set @ A ) ).

thf(sy_c_Real__Vector__Spaces_Obounded__linear,type,
    real_V3181309239436604168linear: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > $o ) ).

thf(sy_c_Real__Vector__Spaces_Obounded__linear__axioms,type,
    real_V4916620083959148203axioms: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > $o ) ).

thf(sy_c_Real__Vector__Spaces_Odist__class_Odist,type,
    real_V557655796197034286t_dist: 
      !>[A: $tType] : ( A > A > real ) ).

thf(sy_c_Real__Vector__Spaces_Onorm__class_Onorm,type,
    real_V7770717601297561774m_norm: 
      !>[A: $tType] : ( A > real ) ).

thf(sy_c_Real__Vector__Spaces_Oof__real,type,
    real_Vector_of_real: 
      !>[A: $tType] : ( real > A ) ).

thf(sy_c_Real__Vector__Spaces_OscaleR__class_OscaleR,type,
    real_V8093663219630862766scaleR: 
      !>[A: $tType] : ( real > A > A ) ).

thf(sy_c_Relation_OId__on,type,
    id_on: 
      !>[A: $tType] : ( ( set @ A ) > ( set @ ( product_prod @ A @ A ) ) ) ).

thf(sy_c_Relation_Oirrefl,type,
    irrefl: 
      !>[A: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > $o ) ).

thf(sy_c_Relation_Orelcomp,type,
    relcomp: 
      !>[A: $tType,B: $tType,C: $tType] : ( ( set @ ( product_prod @ A @ B ) ) > ( set @ ( product_prod @ B @ C ) ) > ( set @ ( product_prod @ A @ C ) ) ) ).

thf(sy_c_Rings_Odivide__class_Odivide,type,
    divide_divide: 
      !>[A: $tType] : ( A > A > A ) ).

thf(sy_c_Rings_Odvd__class_Odvd,type,
    dvd_dvd: 
      !>[A: $tType] : ( A > A > $o ) ).

thf(sy_c_Rings_Omodulo__class_Omodulo,type,
    modulo_modulo: 
      !>[A: $tType] : ( A > A > A ) ).

thf(sy_c_Rings_Ozero__neq__one__class_Oof__bool,type,
    zero_neq_one_of_bool: 
      !>[A: $tType] : ( $o > A ) ).

thf(sy_c_Series_Osuminf,type,
    suminf: 
      !>[A: $tType] : ( ( nat > A ) > A ) ).

thf(sy_c_Series_Osummable,type,
    summable: 
      !>[A: $tType] : ( ( nat > A ) > $o ) ).

thf(sy_c_Series_Osums,type,
    sums: 
      !>[A: $tType] : ( ( nat > A ) > A > $o ) ).

thf(sy_c_Set_OBall,type,
    ball: 
      !>[A: $tType] : ( ( set @ A ) > ( A > $o ) > $o ) ).

thf(sy_c_Set_OCollect,type,
    collect: 
      !>[A: $tType] : ( ( A > $o ) > ( set @ A ) ) ).

thf(sy_c_Set_OPow,type,
    pow2: 
      !>[A: $tType] : ( ( set @ A ) > ( set @ ( set @ A ) ) ) ).

thf(sy_c_Set_Oimage,type,
    image: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > ( set @ A ) > ( set @ B ) ) ).

thf(sy_c_Set_Oinsert,type,
    insert: 
      !>[A: $tType] : ( A > ( set @ A ) > ( set @ A ) ) ).

thf(sy_c_Set_Othe__elem,type,
    the_elem: 
      !>[A: $tType] : ( ( set @ A ) > A ) ).

thf(sy_c_Set__Interval_Ofold__atLeastAtMost__nat,type,
    set_fo6178422350223883121st_nat: 
      !>[A: $tType] : ( ( nat > A > A ) > nat > nat > A > A ) ).

thf(sy_c_Set__Interval_Ofold__atLeastAtMost__nat__rel,type,
    set_fo1817059534552279752at_rel: 
      !>[A: $tType] : ( ( product_prod @ ( nat > A > A ) @ ( product_prod @ nat @ ( product_prod @ nat @ A ) ) ) > ( product_prod @ ( nat > A > A ) @ ( product_prod @ nat @ ( product_prod @ nat @ A ) ) ) > $o ) ).

thf(sy_c_Set__Interval_Oord__class_OatLeast,type,
    set_ord_atLeast: 
      !>[A: $tType] : ( A > ( set @ A ) ) ).

thf(sy_c_Set__Interval_Oord__class_OatLeastAtMost,type,
    set_or1337092689740270186AtMost: 
      !>[A: $tType] : ( A > A > ( set @ A ) ) ).

thf(sy_c_Set__Interval_Oord__class_OatLeastLessThan,type,
    set_or7035219750837199246ssThan: 
      !>[A: $tType] : ( A > A > ( set @ A ) ) ).

thf(sy_c_Set__Interval_Oord__class_OatMost,type,
    set_ord_atMost: 
      !>[A: $tType] : ( A > ( set @ A ) ) ).

thf(sy_c_Set__Interval_Oord__class_OgreaterThan,type,
    set_ord_greaterThan: 
      !>[A: $tType] : ( A > ( set @ A ) ) ).

thf(sy_c_Set__Interval_Oord__class_OgreaterThanAtMost,type,
    set_or3652927894154168847AtMost: 
      !>[A: $tType] : ( A > A > ( set @ A ) ) ).

thf(sy_c_Set__Interval_Oord__class_OgreaterThanLessThan,type,
    set_or5935395276787703475ssThan: 
      !>[A: $tType] : ( A > A > ( set @ A ) ) ).

thf(sy_c_Set__Interval_Oord__class_OlessThan,type,
    set_ord_lessThan: 
      !>[A: $tType] : ( A > ( set @ A ) ) ).

thf(sy_c_String_Oascii__of,type,
    ascii_of: char > char ).

thf(sy_c_String_Ochar_OChar,type,
    char2: $o > $o > $o > $o > $o > $o > $o > $o > char ).

thf(sy_c_String_Ochar_Osize__char,type,
    size_char: char > nat ).

thf(sy_c_String_Ocomm__semiring__1__class_Oof__char,type,
    comm_s6883823935334413003f_char: 
      !>[A: $tType] : ( char > A ) ).

thf(sy_c_String_Ointeger__of__char,type,
    integer_of_char: char > code_integer ).

thf(sy_c_String_Ounique__euclidean__semiring__with__bit__operations__class_Ochar__of,type,
    unique5772411509450598832har_of: 
      !>[A: $tType] : ( A > char ) ).

thf(sy_c_Topological__Spaces_Ocontinuous,type,
    topolo3448309680560233919inuous: 
      !>[A: $tType,B: $tType] : ( ( filter @ A ) > ( A > B ) > $o ) ).

thf(sy_c_Topological__Spaces_Ocontinuous__on,type,
    topolo81223032696312382ous_on: 
      !>[A: $tType,B: $tType] : ( ( set @ A ) > ( A > B ) > $o ) ).

thf(sy_c_Topological__Spaces_Omonoseq,type,
    topological_monoseq: 
      !>[A: $tType] : ( ( nat > A ) > $o ) ).

thf(sy_c_Topological__Spaces_Oopen__class_Oopen,type,
    topolo1002775350975398744n_open: 
      !>[A: $tType] : ( ( set @ A ) > $o ) ).

thf(sy_c_Topological__Spaces_Ot2__space__class_OLim,type,
    topolo3827282254853284352ce_Lim: 
      !>[F: $tType,A: $tType] : ( ( filter @ F ) > ( F > A ) > A ) ).

thf(sy_c_Topological__Spaces_Otopological__space__class_Oat__within,type,
    topolo174197925503356063within: 
      !>[A: $tType] : ( A > ( set @ A ) > ( filter @ A ) ) ).

thf(sy_c_Topological__Spaces_Otopological__space__class_Oclosed,type,
    topolo7761053866217962861closed: 
      !>[A: $tType] : ( ( set @ A ) > $o ) ).

thf(sy_c_Topological__Spaces_Otopological__space__class_Ocompact,type,
    topolo2193935891317330818ompact: 
      !>[A: $tType] : ( ( set @ A ) > $o ) ).

thf(sy_c_Topological__Spaces_Otopological__space__class_Onhds,type,
    topolo7230453075368039082e_nhds: 
      !>[A: $tType] : ( A > ( filter @ A ) ) ).

thf(sy_c_Topological__Spaces_Ouniform__space__class_OCauchy,type,
    topolo3814608138187158403Cauchy: 
      !>[A: $tType] : ( ( nat > A ) > $o ) ).

thf(sy_c_Topological__Spaces_Ouniform__space__class_Ocauchy__filter,type,
    topolo6773858410816713723filter: 
      !>[A: $tType] : ( ( filter @ A ) > $o ) ).

thf(sy_c_Topological__Spaces_Ouniform__space__class_Ototally__bounded,type,
    topolo6688025880775521714ounded: 
      !>[A: $tType] : ( ( set @ A ) > $o ) ).

thf(sy_c_Transcendental_Oarccos,type,
    arccos: real > real ).

thf(sy_c_Transcendental_Oarcosh,type,
    arcosh: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Transcendental_Oarcsin,type,
    arcsin: real > real ).

thf(sy_c_Transcendental_Oarctan,type,
    arctan: real > real ).

thf(sy_c_Transcendental_Oarsinh,type,
    arsinh: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Transcendental_Oartanh,type,
    artanh: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Transcendental_Ocos,type,
    cos: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Transcendental_Ocos__coeff,type,
    cos_coeff: nat > real ).

thf(sy_c_Transcendental_Ocosh,type,
    cosh: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Transcendental_Ocot,type,
    cot: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Transcendental_Odiffs,type,
    diffs: 
      !>[A: $tType] : ( ( nat > A ) > nat > A ) ).

thf(sy_c_Transcendental_Oexp,type,
    exp: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Transcendental_Oln__class_Oln,type,
    ln_ln: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Transcendental_Olog,type,
    log: real > real > real ).

thf(sy_c_Transcendental_Opi,type,
    pi: real ).

thf(sy_c_Transcendental_Opowr,type,
    powr: 
      !>[A: $tType] : ( A > A > A ) ).

thf(sy_c_Transcendental_Osin,type,
    sin: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Transcendental_Osin__coeff,type,
    sin_coeff: nat > real ).

thf(sy_c_Transcendental_Osinh,type,
    sinh: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Transcendental_Otan,type,
    tan: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Transcendental_Otanh,type,
    tanh: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Transitive__Closure_Ontrancl,type,
    transitive_ntrancl: 
      !>[A: $tType] : ( nat > ( set @ ( product_prod @ A @ A ) ) > ( set @ ( product_prod @ A @ A ) ) ) ).

thf(sy_c_Transitive__Closure_Ortrancl,type,
    transitive_rtrancl: 
      !>[A: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > ( set @ ( product_prod @ A @ A ) ) ) ).

thf(sy_c_Transitive__Closure_Otrancl,type,
    transitive_trancl: 
      !>[A: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > ( set @ ( product_prod @ A @ A ) ) ) ).

thf(sy_c_VEBT__Definitions_OVEBT_OLeaf,type,
    vEBT_Leaf: $o > $o > vEBT_VEBT ).

thf(sy_c_VEBT__Definitions_OVEBT_ONode,type,
    vEBT_Node: ( option @ ( product_prod @ nat @ nat ) ) > nat > ( list @ vEBT_VEBT ) > vEBT_VEBT > vEBT_VEBT ).

thf(sy_c_VEBT__Definitions_OVEBT_Osize__VEBT,type,
    vEBT_size_VEBT: vEBT_VEBT > nat ).

thf(sy_c_VEBT__Definitions_OVEBT__internal_Oboth__member__options,type,
    vEBT_V8194947554948674370ptions: vEBT_VEBT > nat > $o ).

thf(sy_c_VEBT__Definitions_OVEBT__internal_Ohigh,type,
    vEBT_VEBT_high: nat > nat > nat ).

thf(sy_c_VEBT__Definitions_OVEBT__internal_Oin__children,type,
    vEBT_V5917875025757280293ildren: nat > ( list @ vEBT_VEBT ) > nat > $o ).

thf(sy_c_VEBT__Definitions_OVEBT__internal_Olow,type,
    vEBT_VEBT_low: nat > nat > nat ).

thf(sy_c_VEBT__Definitions_OVEBT__internal_Omembermima,type,
    vEBT_VEBT_membermima: vEBT_VEBT > nat > $o ).

thf(sy_c_VEBT__Definitions_OVEBT__internal_Omembermima__rel,type,
    vEBT_V4351362008482014158ma_rel: ( product_prod @ vEBT_VEBT @ nat ) > ( product_prod @ vEBT_VEBT @ nat ) > $o ).

thf(sy_c_VEBT__Definitions_OVEBT__internal_Onaive__member,type,
    vEBT_V5719532721284313246member: vEBT_VEBT > nat > $o ).

thf(sy_c_VEBT__Definitions_OVEBT__internal_Onaive__member__rel,type,
    vEBT_V5765760719290551771er_rel: ( product_prod @ vEBT_VEBT @ nat ) > ( product_prod @ vEBT_VEBT @ nat ) > $o ).

thf(sy_c_VEBT__Definitions_OVEBT__internal_Ovalid_H,type,
    vEBT_VEBT_valid: vEBT_VEBT > nat > $o ).

thf(sy_c_VEBT__Definitions_OVEBT__internal_Ovalid_H__rel,type,
    vEBT_VEBT_valid_rel: ( product_prod @ vEBT_VEBT @ nat ) > ( product_prod @ vEBT_VEBT @ nat ) > $o ).

thf(sy_c_VEBT__Definitions_Oinvar__vebt,type,
    vEBT_invar_vebt: vEBT_VEBT > nat > $o ).

thf(sy_c_VEBT__Definitions_Oset__vebt,type,
    vEBT_set_vebt: vEBT_VEBT > ( set @ nat ) ).

thf(sy_c_VEBT__Definitions_Ovebt__buildup,type,
    vEBT_vebt_buildup: nat > vEBT_VEBT ).

thf(sy_c_VEBT__Definitions_Ovebt__buildup__rel,type,
    vEBT_v4011308405150292612up_rel: nat > nat > $o ).

thf(sy_c_VEBT__Insert_Ovebt__insert,type,
    vEBT_vebt_insert: vEBT_VEBT > nat > vEBT_VEBT ).

thf(sy_c_VEBT__Insert_Ovebt__insert__rel,type,
    vEBT_vebt_insert_rel: ( product_prod @ vEBT_VEBT @ nat ) > ( product_prod @ vEBT_VEBT @ nat ) > $o ).

thf(sy_c_VEBT__Member_OVEBT__internal_Obit__concat,type,
    vEBT_VEBT_bit_concat: nat > nat > nat > nat ).

thf(sy_c_VEBT__Member_OVEBT__internal_OminNull,type,
    vEBT_VEBT_minNull: vEBT_VEBT > $o ).

thf(sy_c_VEBT__Member_OVEBT__internal_OminNull__rel,type,
    vEBT_V6963167321098673237ll_rel: vEBT_VEBT > vEBT_VEBT > $o ).

thf(sy_c_VEBT__Member_OVEBT__internal_Oset__vebt_H,type,
    vEBT_VEBT_set_vebt: vEBT_VEBT > ( set @ nat ) ).

thf(sy_c_VEBT__Member_Ovebt__member,type,
    vEBT_vebt_member: vEBT_VEBT > nat > $o ).

thf(sy_c_VEBT__Member_Ovebt__member__rel,type,
    vEBT_vebt_member_rel: ( product_prod @ vEBT_VEBT @ nat ) > ( product_prod @ vEBT_VEBT @ nat ) > $o ).

thf(sy_c_Wellfounded_Oaccp,type,
    accp: 
      !>[A: $tType] : ( ( A > A > $o ) > A > $o ) ).

thf(sy_c_Wellfounded_Ofinite__psubset,type,
    finite_psubset: 
      !>[A: $tType] : ( set @ ( product_prod @ ( set @ A ) @ ( set @ A ) ) ) ).

thf(sy_c_Wellfounded_Olex__prod,type,
    lex_prod: 
      !>[A: $tType,B: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > ( set @ ( product_prod @ B @ B ) ) > ( set @ ( product_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) ) ) ) ).

thf(sy_c_Wellfounded_Omax__ext,type,
    max_ext: 
      !>[A: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > ( set @ ( product_prod @ ( set @ A ) @ ( set @ A ) ) ) ) ).

thf(sy_c_Wellfounded_Omax__extp,type,
    max_extp: 
      !>[A: $tType] : ( ( A > A > $o ) > ( set @ A ) > ( set @ A ) > $o ) ).

thf(sy_c_Wellfounded_Omeasure,type,
    measure: 
      !>[A: $tType] : ( ( A > nat ) > ( set @ ( product_prod @ A @ A ) ) ) ).

thf(sy_c_Wellfounded_Omin__ext,type,
    min_ext: 
      !>[A: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > ( set @ ( product_prod @ ( set @ A ) @ ( set @ A ) ) ) ) ).

thf(sy_c_Wellfounded_Omlex__prod,type,
    mlex_prod: 
      !>[A: $tType] : ( ( A > nat ) > ( set @ ( product_prod @ A @ A ) ) > ( set @ ( product_prod @ A @ A ) ) ) ).

thf(sy_c_Wellfounded_Opred__nat,type,
    pred_nat: set @ ( product_prod @ nat @ nat ) ).

thf(sy_c_Wfrec_Osame__fst,type,
    same_fst: 
      !>[A: $tType,B: $tType] : ( ( A > $o ) > ( A > ( set @ ( product_prod @ B @ B ) ) ) > ( set @ ( product_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) ) ) ) ).

thf(sy_c_fChoice,type,
    fChoice: 
      !>[A: $tType] : ( ( A > $o ) > A ) ).

thf(sy_c_member,type,
    member: 
      !>[A: $tType] : ( A > ( set @ A ) > $o ) ).

thf(sy_v_deg____,type,
    deg: nat ).

thf(sy_v_m____,type,
    m: nat ).

thf(sy_v_na____,type,
    na: nat ).

thf(sy_v_summary____,type,
    summary: vEBT_VEBT ).

thf(sy_v_treeList____,type,
    treeList: list @ vEBT_VEBT ).

thf(sy_v_xa____,type,
    xa: nat ).

% Relevant facts (8182)
thf(fact_0__C8_C,axiom,
    ord_less_eq @ nat @ xa @ xa ).

% "8"
thf(fact_1__C4_C,axiom,
    ~ ? [X_1: nat] : ( vEBT_V8194947554948674370ptions @ summary @ X_1 ) ).

% "4"
thf(fact_2__C5_C,axiom,
    ! [X: vEBT_VEBT] :
      ( ( member @ vEBT_VEBT @ X @ ( set2 @ vEBT_VEBT @ treeList ) )
     => ~ ? [X_1: nat] : ( vEBT_V8194947554948674370ptions @ X @ X_1 ) ) ).

% "5"
thf(fact_3__C3_C,axiom,
    ( deg
    = ( plus_plus @ nat @ na @ m ) ) ).

% "3"
thf(fact_4__C1_C,axiom,
    vEBT_invar_vebt @ summary @ m ).

% "1"
thf(fact_5__C0_C,axiom,
    ! [X: vEBT_VEBT] :
      ( ( member @ vEBT_VEBT @ X @ ( set2 @ vEBT_VEBT @ treeList ) )
     => ( vEBT_invar_vebt @ X @ na ) ) ).

% "0"
thf(fact_6_even__odd__cases,axiom,
    ! [X2: nat] :
      ( ! [N: nat] :
          ( X2
         != ( plus_plus @ nat @ N @ N ) )
     => ~ ! [N: nat] :
            ( X2
           != ( plus_plus @ nat @ N @ ( suc @ N ) ) ) ) ).

% even_odd_cases
thf(fact_7__C7_C,axiom,
    ! [X: vEBT_VEBT] :
      ( ( member @ vEBT_VEBT @ X @ ( set2 @ vEBT_VEBT @ treeList ) )
     => ~ ? [X_1: nat] : ( vEBT_V8194947554948674370ptions @ X @ X_1 ) ) ).

% "7"
thf(fact_8_deg__deg__n,axiom,
    ! [Info: option @ ( product_prod @ nat @ nat ),Deg: nat,TreeList: list @ vEBT_VEBT,Summary: vEBT_VEBT,N2: nat] :
      ( ( vEBT_invar_vebt @ ( vEBT_Node @ Info @ Deg @ TreeList @ Summary ) @ N2 )
     => ( Deg = N2 ) ) ).

% deg_deg_n
thf(fact_9_deg__SUcn__Node,axiom,
    ! [Tree: vEBT_VEBT,N2: nat] :
      ( ( vEBT_invar_vebt @ Tree @ ( suc @ ( suc @ N2 ) ) )
     => ? [Info2: option @ ( product_prod @ nat @ nat ),TreeList2: list @ vEBT_VEBT,S: vEBT_VEBT] :
          ( Tree
          = ( vEBT_Node @ Info2 @ ( suc @ ( suc @ N2 ) ) @ TreeList2 @ S ) ) ) ).

% deg_SUcn_Node
thf(fact_10__C9_C,axiom,
    ord_less @ nat @ xa @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ deg ) ).

% "9"
thf(fact_11__C6_C,axiom,
    ( ( vEBT_vebt_insert @ ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ deg @ treeList @ summary ) @ xa )
    = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ xa @ xa ) ) @ deg @ treeList @ summary ) ) ).

% "6"
thf(fact_12__C2_C,axiom,
    ( ( size_size @ ( list @ vEBT_VEBT ) @ treeList )
    = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ m ) ) ).

% "2"
thf(fact_13_set__vebt__set__vebt_H__valid,axiom,
    ! [T2: vEBT_VEBT,N2: nat] :
      ( ( vEBT_invar_vebt @ T2 @ N2 )
     => ( ( vEBT_set_vebt @ T2 )
        = ( vEBT_VEBT_set_vebt @ T2 ) ) ) ).

% set_vebt_set_vebt'_valid
thf(fact_14_VEBT_Oinject_I1_J,axiom,
    ! [X11: option @ ( product_prod @ nat @ nat ),X12: nat,X13: list @ vEBT_VEBT,X14: vEBT_VEBT,Y11: option @ ( product_prod @ nat @ nat ),Y12: nat,Y13: list @ vEBT_VEBT,Y14: vEBT_VEBT] :
      ( ( ( vEBT_Node @ X11 @ X12 @ X13 @ X14 )
        = ( vEBT_Node @ Y11 @ Y12 @ Y13 @ Y14 ) )
      = ( ( X11 = Y11 )
        & ( X12 = Y12 )
        & ( X13 = Y13 )
        & ( X14 = Y14 ) ) ) ).

% VEBT.inject(1)
thf(fact_15__C3_OIH_C_I1_J,axiom,
    ! [X: vEBT_VEBT] :
      ( ( member @ vEBT_VEBT @ X @ ( set2 @ vEBT_VEBT @ treeList ) )
     => ( ( vEBT_invar_vebt @ X @ na )
        & ! [Xa: nat] :
            ( ( ord_less @ nat @ Xa @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ na ) )
           => ( vEBT_invar_vebt @ ( vEBT_vebt_insert @ X @ Xa ) @ na ) ) ) ) ).

% "3.IH"(1)
thf(fact_16_valid__eq,axiom,
    vEBT_VEBT_valid = vEBT_invar_vebt ).

% valid_eq
thf(fact_17_valid__eq1,axiom,
    ! [T2: vEBT_VEBT,D2: nat] :
      ( ( vEBT_invar_vebt @ T2 @ D2 )
     => ( vEBT_VEBT_valid @ T2 @ D2 ) ) ).

% valid_eq1
thf(fact_18_valid__eq2,axiom,
    ! [T2: vEBT_VEBT,D2: nat] :
      ( ( vEBT_VEBT_valid @ T2 @ D2 )
     => ( vEBT_invar_vebt @ T2 @ D2 ) ) ).

% valid_eq2
thf(fact_19__C3_OIH_C_I2_J,axiom,
    ! [X2: nat] :
      ( ( ord_less @ nat @ X2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ m ) )
     => ( vEBT_invar_vebt @ ( vEBT_vebt_insert @ summary @ X2 ) @ m ) ) ).

% "3.IH"(2)
thf(fact_20_mi__eq__ma__no__ch,axiom,
    ! [Mi: nat,Ma: nat,Deg: nat,TreeList: list @ vEBT_VEBT,Summary: vEBT_VEBT] :
      ( ( vEBT_invar_vebt @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi @ Ma ) ) @ Deg @ TreeList @ Summary ) @ Deg )
     => ( ( Mi = Ma )
       => ( ! [X: vEBT_VEBT] :
              ( ( member @ vEBT_VEBT @ X @ ( set2 @ vEBT_VEBT @ TreeList ) )
             => ~ ? [X_1: nat] : ( vEBT_V8194947554948674370ptions @ X @ X_1 ) )
          & ~ ? [X_1: nat] : ( vEBT_V8194947554948674370ptions @ Summary @ X_1 ) ) ) ) ).

% mi_eq_ma_no_ch
thf(fact_21__C10_C,axiom,
    ( ( xa != xa )
   => ! [I: nat] :
        ( ( ord_less @ nat @ I @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ na ) ) )
       => ( ( ( ( vEBT_VEBT_high @ xa @ deg )
              = I )
           => ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ treeList @ I ) @ ( vEBT_VEBT_low @ xa @ deg ) ) )
          & ! [Y: nat] :
              ( ( ( ( vEBT_VEBT_high @ Y @ deg )
                  = I )
                & ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ treeList @ I ) @ ( vEBT_VEBT_low @ Y @ deg ) ) )
             => ( ( ord_less @ nat @ xa @ Y )
                & ( ord_less_eq @ nat @ Y @ xa ) ) ) ) ) ) ).

% "10"
thf(fact_22_valid__0__not,axiom,
    ! [T2: vEBT_VEBT] :
      ~ ( vEBT_invar_vebt @ T2 @ ( zero_zero @ nat ) ) ).

% valid_0_not
thf(fact_23_valid__tree__deg__neq__0,axiom,
    ! [T2: vEBT_VEBT] :
      ~ ( vEBT_invar_vebt @ T2 @ ( zero_zero @ nat ) ) ).

% valid_tree_deg_neq_0
thf(fact_24__092_060open_062_092_060lbrakk_062_092_060forall_062t_092_060in_062set_AtreeList_O_Ainvar__vebt_At_An_059_Ainvar__vebt_Asummary_Am_059_Alength_AtreeList_A_061_A2_A_094_Am_059_Am_A_061_ASuc_An_059_Adeg_A_061_An_A_L_Am_059_A_092_060forall_062i_0602_A_094_Am_O_A_I_092_060exists_062x_O_Aboth__member__options_A_ItreeList_A_B_Ai_J_Ax_J_A_061_Aboth__member__options_Asummary_Ai_059_Ax_A_061_Ax_A_092_060longrightarrow_062_A_I_092_060forall_062t_092_060in_062set_AtreeList_O_A_092_060nexists_062x_O_Aboth__member__options_At_Ax_J_059_Ax_A_092_060le_062_Ax_059_Ax_A_060_A2_A_094_Adeg_059_Ax_A_092_060noteq_062_Ax_A_092_060longrightarrow_062_A_I_092_060forall_062i_0602_A_094_Am_O_A_Ihigh_Ax_An_A_061_Ai_A_092_060longrightarrow_062_Aboth__member__options_A_ItreeList_A_B_Ai_J_A_Ilow_Ax_An_J_J_A_092_060and_062_A_I_092_060forall_062x_O_Ahigh_Ax_An_A_061_Ai_A_092_060and_062_Aboth__member__options_A_ItreeList_A_B_Ai_J_A_Ilow_Ax_An_J_A_092_060longrightarrow_062_Ax_A_060_Ax_A_092_060and_062_Ax_A_092_060le_062_Ax_J_J_092_060rbrakk_062_A_092_060Longrightarrow_062_Ainvar__vebt_A_INode_A_ISome_A_Ix_M_Ax_J_J_Adeg_AtreeList_Asummary_J_Adeg_092_060close_062,axiom,
    ( ! [X3: vEBT_VEBT] :
        ( ( member @ vEBT_VEBT @ X3 @ ( set2 @ vEBT_VEBT @ treeList ) )
       => ( vEBT_invar_vebt @ X3 @ na ) )
   => ( ( vEBT_invar_vebt @ summary @ m )
     => ( ( ( size_size @ ( list @ vEBT_VEBT ) @ treeList )
          = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ m ) )
       => ( ( m
            = ( suc @ na ) )
         => ( ( deg
              = ( plus_plus @ nat @ na @ m ) )
           => ( ! [I2: nat] :
                  ( ( ord_less @ nat @ I2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ m ) )
                 => ( ( ? [X4: nat] : ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ treeList @ I2 ) @ X4 ) )
                    = ( vEBT_V8194947554948674370ptions @ summary @ I2 ) ) )
             => ( ! [X3: vEBT_VEBT] :
                    ( ( member @ vEBT_VEBT @ X3 @ ( set2 @ vEBT_VEBT @ treeList ) )
                   => ~ ? [X_12: nat] : ( vEBT_V8194947554948674370ptions @ X3 @ X_12 ) )
               => ( ( ord_less_eq @ nat @ xa @ xa )
                 => ( ( ord_less @ nat @ xa @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ deg ) )
                   => ( vEBT_invar_vebt @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ xa @ xa ) ) @ deg @ treeList @ summary ) @ deg ) ) ) ) ) ) ) ) ) ) ).

% \<open>\<lbrakk>\<forall>t\<in>set treeList. invar_vebt t n; invar_vebt summary m; length treeList = 2 ^ m; m = Suc n; deg = n + m; \<forall>i<2 ^ m. (\<exists>x. both_member_options (treeList ! i) x) = both_member_options summary i; x = x \<longrightarrow> (\<forall>t\<in>set treeList. \<nexists>x. both_member_options t x); x \<le> x; x < 2 ^ deg; x \<noteq> x \<longrightarrow> (\<forall>i<2 ^ m. (high x n = i \<longrightarrow> both_member_options (treeList ! i) (low x n)) \<and> (\<forall>x. high x n = i \<and> both_member_options (treeList ! i) (low x n) \<longrightarrow> x < x \<and> x \<le> x))\<rbrakk> \<Longrightarrow> invar_vebt (Node (Some (x, x)) deg treeList summary) deg\<close>
thf(fact_25_nth__mem,axiom,
    ! [A: $tType,N2: nat,Xs: list @ A] :
      ( ( ord_less @ nat @ N2 @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( member @ A @ ( nth @ A @ Xs @ N2 ) @ ( set2 @ A @ Xs ) ) ) ).

% nth_mem
thf(fact_26__C3_Ohyps_C_I3_J,axiom,
    ( m
    = ( suc @ na ) ) ).

% "3.hyps"(3)
thf(fact_27_deg__not__0,axiom,
    ! [T2: vEBT_VEBT,N2: nat] :
      ( ( vEBT_invar_vebt @ T2 @ N2 )
     => ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 ) ) ).

% deg_not_0
thf(fact_28_inthall,axiom,
    ! [A: $tType,Xs: list @ A,P: A > $o,N2: nat] :
      ( ! [X3: A] :
          ( ( member @ A @ X3 @ ( set2 @ A @ Xs ) )
         => ( P @ X3 ) )
     => ( ( ord_less @ nat @ N2 @ ( size_size @ ( list @ A ) @ Xs ) )
       => ( P @ ( nth @ A @ Xs @ N2 ) ) ) ) ).

% inthall
thf(fact_29_bit__split__inv,axiom,
    ! [X2: nat,D2: nat] :
      ( ( vEBT_VEBT_bit_concat @ ( vEBT_VEBT_high @ X2 @ D2 ) @ ( vEBT_VEBT_low @ X2 @ D2 ) @ D2 )
      = X2 ) ).

% bit_split_inv
thf(fact_30_high__bound__aux,axiom,
    ! [Ma: nat,N2: nat,M: nat] :
      ( ( ord_less @ nat @ Ma @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( plus_plus @ nat @ N2 @ M ) ) )
     => ( ord_less @ nat @ ( vEBT_VEBT_high @ Ma @ N2 ) @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M ) ) ) ).

% high_bound_aux
thf(fact_31_insert__simp__mima,axiom,
    ! [X2: nat,Mi: nat,Ma: nat,Deg: nat,TreeList: list @ vEBT_VEBT,Summary: vEBT_VEBT] :
      ( ( ( X2 = Mi )
        | ( X2 = Ma ) )
     => ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg )
       => ( ( vEBT_vebt_insert @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi @ Ma ) ) @ Deg @ TreeList @ Summary ) @ X2 )
          = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi @ Ma ) ) @ Deg @ TreeList @ Summary ) ) ) ) ).

% insert_simp_mima
thf(fact_32_valid__insert__both__member__options__pres,axiom,
    ! [T2: vEBT_VEBT,N2: nat,X2: nat,Y2: nat] :
      ( ( vEBT_invar_vebt @ T2 @ N2 )
     => ( ( ord_less @ nat @ X2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) )
       => ( ( ord_less @ nat @ Y2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) )
         => ( ( vEBT_V8194947554948674370ptions @ T2 @ X2 )
           => ( vEBT_V8194947554948674370ptions @ ( vEBT_vebt_insert @ T2 @ Y2 ) @ X2 ) ) ) ) ) ).

% valid_insert_both_member_options_pres
thf(fact_33_valid__insert__both__member__options__add,axiom,
    ! [T2: vEBT_VEBT,N2: nat,X2: nat] :
      ( ( vEBT_invar_vebt @ T2 @ N2 )
     => ( ( ord_less @ nat @ X2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) )
       => ( vEBT_V8194947554948674370ptions @ ( vEBT_vebt_insert @ T2 @ X2 ) @ X2 ) ) ) ).

% valid_insert_both_member_options_add
thf(fact_34_mi__ma__2__deg,axiom,
    ! [Mi: nat,Ma: nat,Deg: nat,TreeList: list @ vEBT_VEBT,Summary: vEBT_VEBT,N2: nat] :
      ( ( vEBT_invar_vebt @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi @ Ma ) ) @ Deg @ TreeList @ Summary ) @ N2 )
     => ( ( ord_less_eq @ nat @ Mi @ Ma )
        & ( ord_less @ nat @ Ma @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg ) ) ) ) ).

% mi_ma_2_deg
thf(fact_35_invar__vebt_Ointros_I5_J,axiom,
    ! [TreeList: list @ vEBT_VEBT,N2: nat,Summary: vEBT_VEBT,M: nat,Deg: nat,Mi: nat,Ma: nat] :
      ( ! [X3: vEBT_VEBT] :
          ( ( member @ vEBT_VEBT @ X3 @ ( set2 @ vEBT_VEBT @ TreeList ) )
         => ( vEBT_invar_vebt @ X3 @ N2 ) )
     => ( ( vEBT_invar_vebt @ Summary @ M )
       => ( ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList )
            = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M ) )
         => ( ( M
              = ( suc @ N2 ) )
           => ( ( Deg
                = ( plus_plus @ nat @ N2 @ M ) )
             => ( ! [I2: nat] :
                    ( ( ord_less @ nat @ I2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M ) )
                   => ( ( ? [X4: nat] : ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList @ I2 ) @ X4 ) )
                      = ( vEBT_V8194947554948674370ptions @ Summary @ I2 ) ) )
               => ( ( ( Mi = Ma )
                   => ! [X3: vEBT_VEBT] :
                        ( ( member @ vEBT_VEBT @ X3 @ ( set2 @ vEBT_VEBT @ TreeList ) )
                       => ~ ? [X_12: nat] : ( vEBT_V8194947554948674370ptions @ X3 @ X_12 ) ) )
                 => ( ( ord_less_eq @ nat @ Mi @ Ma )
                   => ( ( ord_less @ nat @ Ma @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg ) )
                     => ( ( ( Mi != Ma )
                         => ! [I2: nat] :
                              ( ( ord_less @ nat @ I2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M ) )
                             => ( ( ( ( vEBT_VEBT_high @ Ma @ N2 )
                                    = I2 )
                                 => ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList @ I2 ) @ ( vEBT_VEBT_low @ Ma @ N2 ) ) )
                                & ! [X3: nat] :
                                    ( ( ( ( vEBT_VEBT_high @ X3 @ N2 )
                                        = I2 )
                                      & ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList @ I2 ) @ ( vEBT_VEBT_low @ X3 @ N2 ) ) )
                                   => ( ( ord_less @ nat @ Mi @ X3 )
                                      & ( ord_less_eq @ nat @ X3 @ Ma ) ) ) ) ) )
                       => ( vEBT_invar_vebt @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi @ Ma ) ) @ Deg @ TreeList @ Summary ) @ Deg ) ) ) ) ) ) ) ) ) ) ) ).

% invar_vebt.intros(5)
thf(fact_36_invar__vebt_Ointros_I4_J,axiom,
    ! [TreeList: list @ vEBT_VEBT,N2: nat,Summary: vEBT_VEBT,M: nat,Deg: nat,Mi: nat,Ma: nat] :
      ( ! [X3: vEBT_VEBT] :
          ( ( member @ vEBT_VEBT @ X3 @ ( set2 @ vEBT_VEBT @ TreeList ) )
         => ( vEBT_invar_vebt @ X3 @ N2 ) )
     => ( ( vEBT_invar_vebt @ Summary @ M )
       => ( ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList )
            = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M ) )
         => ( ( M = N2 )
           => ( ( Deg
                = ( plus_plus @ nat @ N2 @ M ) )
             => ( ! [I2: nat] :
                    ( ( ord_less @ nat @ I2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M ) )
                   => ( ( ? [X4: nat] : ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList @ I2 ) @ X4 ) )
                      = ( vEBT_V8194947554948674370ptions @ Summary @ I2 ) ) )
               => ( ( ( Mi = Ma )
                   => ! [X3: vEBT_VEBT] :
                        ( ( member @ vEBT_VEBT @ X3 @ ( set2 @ vEBT_VEBT @ TreeList ) )
                       => ~ ? [X_12: nat] : ( vEBT_V8194947554948674370ptions @ X3 @ X_12 ) ) )
                 => ( ( ord_less_eq @ nat @ Mi @ Ma )
                   => ( ( ord_less @ nat @ Ma @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg ) )
                     => ( ( ( Mi != Ma )
                         => ! [I2: nat] :
                              ( ( ord_less @ nat @ I2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M ) )
                             => ( ( ( ( vEBT_VEBT_high @ Ma @ N2 )
                                    = I2 )
                                 => ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList @ I2 ) @ ( vEBT_VEBT_low @ Ma @ N2 ) ) )
                                & ! [X3: nat] :
                                    ( ( ( ( vEBT_VEBT_high @ X3 @ N2 )
                                        = I2 )
                                      & ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList @ I2 ) @ ( vEBT_VEBT_low @ X3 @ N2 ) ) )
                                   => ( ( ord_less @ nat @ Mi @ X3 )
                                      & ( ord_less_eq @ nat @ X3 @ Ma ) ) ) ) ) )
                       => ( vEBT_invar_vebt @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi @ Ma ) ) @ Deg @ TreeList @ Summary ) @ Deg ) ) ) ) ) ) ) ) ) ) ) ).

% invar_vebt.intros(4)
thf(fact_37_VEBT__internal_Oexp__split__high__low_I2_J,axiom,
    ! [X2: nat,N2: nat,M: nat] :
      ( ( ord_less @ nat @ X2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( plus_plus @ nat @ N2 @ M ) ) )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
       => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M )
         => ( ord_less @ nat @ ( vEBT_VEBT_low @ X2 @ N2 ) @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) ) ) ) ).

% VEBT_internal.exp_split_high_low(2)
thf(fact_38_VEBT__internal_Oexp__split__high__low_I1_J,axiom,
    ! [X2: nat,N2: nat,M: nat] :
      ( ( ord_less @ nat @ X2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( plus_plus @ nat @ N2 @ M ) ) )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
       => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M )
         => ( ord_less @ nat @ ( vEBT_VEBT_high @ X2 @ N2 ) @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M ) ) ) ) ) ).

% VEBT_internal.exp_split_high_low(1)
thf(fact_39_vebt__buildup_Ocases,axiom,
    ! [X2: nat] :
      ( ( X2
       != ( zero_zero @ nat ) )
     => ( ( X2
         != ( suc @ ( zero_zero @ nat ) ) )
       => ~ ! [Va: nat] :
              ( X2
             != ( suc @ ( suc @ Va ) ) ) ) ) ).

% vebt_buildup.cases
thf(fact_40_invar__vebt_Ointros_I3_J,axiom,
    ! [TreeList: list @ vEBT_VEBT,N2: nat,Summary: vEBT_VEBT,M: nat,Deg: nat] :
      ( ! [X3: vEBT_VEBT] :
          ( ( member @ vEBT_VEBT @ X3 @ ( set2 @ vEBT_VEBT @ TreeList ) )
         => ( vEBT_invar_vebt @ X3 @ N2 ) )
     => ( ( vEBT_invar_vebt @ Summary @ M )
       => ( ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList )
            = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M ) )
         => ( ( M
              = ( suc @ N2 ) )
           => ( ( Deg
                = ( plus_plus @ nat @ N2 @ M ) )
             => ( ~ ? [X_12: nat] : ( vEBT_V8194947554948674370ptions @ Summary @ X_12 )
               => ( ! [X3: vEBT_VEBT] :
                      ( ( member @ vEBT_VEBT @ X3 @ ( set2 @ vEBT_VEBT @ TreeList ) )
                     => ~ ? [X_12: nat] : ( vEBT_V8194947554948674370ptions @ X3 @ X_12 ) )
                 => ( vEBT_invar_vebt @ ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ Deg @ TreeList @ Summary ) @ Deg ) ) ) ) ) ) ) ) ).

% invar_vebt.intros(3)
thf(fact_41_invar__vebt_Ointros_I2_J,axiom,
    ! [TreeList: list @ vEBT_VEBT,N2: nat,Summary: vEBT_VEBT,M: nat,Deg: nat] :
      ( ! [X3: vEBT_VEBT] :
          ( ( member @ vEBT_VEBT @ X3 @ ( set2 @ vEBT_VEBT @ TreeList ) )
         => ( vEBT_invar_vebt @ X3 @ N2 ) )
     => ( ( vEBT_invar_vebt @ Summary @ M )
       => ( ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList )
            = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M ) )
         => ( ( M = N2 )
           => ( ( Deg
                = ( plus_plus @ nat @ N2 @ M ) )
             => ( ~ ? [X_12: nat] : ( vEBT_V8194947554948674370ptions @ Summary @ X_12 )
               => ( ! [X3: vEBT_VEBT] :
                      ( ( member @ vEBT_VEBT @ X3 @ ( set2 @ vEBT_VEBT @ TreeList ) )
                     => ~ ? [X_12: nat] : ( vEBT_V8194947554948674370ptions @ X3 @ X_12 ) )
                 => ( vEBT_invar_vebt @ ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ Deg @ TreeList @ Summary ) @ Deg ) ) ) ) ) ) ) ) ).

% invar_vebt.intros(2)
thf(fact_42_in__children__def,axiom,
    ( vEBT_V5917875025757280293ildren
    = ( ^ [N3: nat,TreeList3: list @ vEBT_VEBT,X5: nat] : ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ X5 @ N3 ) ) @ ( vEBT_VEBT_low @ X5 @ N3 ) ) ) ) ).

% in_children_def
thf(fact_43_sum__power2__eq__zero__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X2: A,Y2: A] :
          ( ( ( plus_plus @ A @ ( power_power @ A @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ A @ Y2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
            = ( zero_zero @ A ) )
          = ( ( X2
              = ( zero_zero @ A ) )
            & ( Y2
              = ( zero_zero @ A ) ) ) ) ) ).

% sum_power2_eq_zero_iff
thf(fact_44_zero__less__power2,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
          = ( ( A2
             != ( zero_zero @ A ) ) ) ) ) ).

% zero_less_power2
thf(fact_45_mem__Collect__eq,axiom,
    ! [A: $tType,A2: A,P: A > $o] :
      ( ( member @ A @ A2 @ ( collect @ A @ P ) )
      = ( P @ A2 ) ) ).

% mem_Collect_eq
thf(fact_46_Collect__mem__eq,axiom,
    ! [A: $tType,A3: set @ A] :
      ( ( collect @ A
        @ ^ [X5: A] : ( member @ A @ X5 @ A3 ) )
      = A3 ) ).

% Collect_mem_eq
thf(fact_47_Collect__cong,axiom,
    ! [A: $tType,P: A > $o,Q: A > $o] :
      ( ! [X3: A] :
          ( ( P @ X3 )
          = ( Q @ X3 ) )
     => ( ( collect @ A @ P )
        = ( collect @ A @ Q ) ) ) ).

% Collect_cong
thf(fact_48_ext,axiom,
    ! [B: $tType,A: $tType,F2: A > B,G: A > B] :
      ( ! [X3: A] :
          ( ( F2 @ X3 )
          = ( G @ X3 ) )
     => ( F2 = G ) ) ).

% ext
thf(fact_49_power2__less__eq__zero__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( zero_zero @ A ) )
          = ( A2
            = ( zero_zero @ A ) ) ) ) ).

% power2_less_eq_zero_iff
thf(fact_50_power2__eq__iff__nonneg,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [X2: A,Y2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ Y2 )
           => ( ( ( power_power @ A @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
                = ( power_power @ A @ Y2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
              = ( X2 = Y2 ) ) ) ) ) ).

% power2_eq_iff_nonneg
thf(fact_51_add__2__eq__Suc,axiom,
    ! [N2: nat] :
      ( ( plus_plus @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 )
      = ( suc @ ( suc @ N2 ) ) ) ).

% add_2_eq_Suc
thf(fact_52_add__2__eq__Suc_H,axiom,
    ! [N2: nat] :
      ( ( plus_plus @ nat @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
      = ( suc @ ( suc @ N2 ) ) ) ).

% add_2_eq_Suc'
thf(fact_53_zero__eq__power2,axiom,
    ! [A: $tType] :
      ( ( semiri2026040879449505780visors @ A )
     => ! [A2: A] :
          ( ( ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
            = ( zero_zero @ A ) )
          = ( A2
            = ( zero_zero @ A ) ) ) ) ).

% zero_eq_power2
thf(fact_54_power__mono__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,B2: A,N2: nat] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 )
           => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
             => ( ( ord_less_eq @ A @ ( power_power @ A @ A2 @ N2 ) @ ( power_power @ A @ B2 @ N2 ) )
                = ( ord_less_eq @ A @ A2 @ B2 ) ) ) ) ) ) ).

% power_mono_iff
thf(fact_55_post__member__pre__member,axiom,
    ! [T2: vEBT_VEBT,N2: nat,X2: nat,Y2: nat] :
      ( ( vEBT_invar_vebt @ T2 @ N2 )
     => ( ( ord_less @ nat @ X2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) )
       => ( ( ord_less @ nat @ Y2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) )
         => ( ( vEBT_vebt_member @ ( vEBT_vebt_insert @ T2 @ X2 ) @ Y2 )
           => ( ( vEBT_vebt_member @ T2 @ Y2 )
              | ( X2 = Y2 ) ) ) ) ) ) ).

% post_member_pre_member
thf(fact_56_power__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( semiri2026040879449505780visors @ A )
     => ! [A2: A,N2: nat] :
          ( ( ( power_power @ A @ A2 @ N2 )
            = ( zero_zero @ A ) )
          = ( ( A2
              = ( zero_zero @ A ) )
            & ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 ) ) ) ) ).

% power_eq_0_iff
thf(fact_57_member__bound,axiom,
    ! [Tree: vEBT_VEBT,X2: nat,N2: nat] :
      ( ( vEBT_vebt_member @ Tree @ X2 )
     => ( ( vEBT_invar_vebt @ Tree @ N2 )
       => ( ord_less @ nat @ X2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) ) ) ).

% member_bound
thf(fact_58_both__member__options__equiv__member,axiom,
    ! [T2: vEBT_VEBT,N2: nat,X2: nat] :
      ( ( vEBT_invar_vebt @ T2 @ N2 )
     => ( ( vEBT_V8194947554948674370ptions @ T2 @ X2 )
        = ( vEBT_vebt_member @ T2 @ X2 ) ) ) ).

% both_member_options_equiv_member
thf(fact_59_valid__member__both__member__options,axiom,
    ! [T2: vEBT_VEBT,N2: nat,X2: nat] :
      ( ( vEBT_invar_vebt @ T2 @ N2 )
     => ( ( vEBT_V8194947554948674370ptions @ T2 @ X2 )
       => ( vEBT_vebt_member @ T2 @ X2 ) ) ) ).

% valid_member_both_member_options
thf(fact_60_member__correct,axiom,
    ! [T2: vEBT_VEBT,N2: nat,X2: nat] :
      ( ( vEBT_invar_vebt @ T2 @ N2 )
     => ( ( vEBT_vebt_member @ T2 @ X2 )
        = ( member @ nat @ X2 @ ( vEBT_set_vebt @ T2 ) ) ) ) ).

% member_correct
thf(fact_61_numeral__eq__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [M: num,N2: num] :
          ( ( ( numeral_numeral @ A @ M )
            = ( numeral_numeral @ A @ N2 ) )
          = ( M = N2 ) ) ) ).

% numeral_eq_iff
thf(fact_62_numeral__le__iff,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [M: num,N2: num] :
          ( ( ord_less_eq @ A @ ( numeral_numeral @ A @ M ) @ ( numeral_numeral @ A @ N2 ) )
          = ( ord_less_eq @ num @ M @ N2 ) ) ) ).

% numeral_le_iff
thf(fact_63_numeral__less__iff,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [M: num,N2: num] :
          ( ( ord_less @ A @ ( numeral_numeral @ A @ M ) @ ( numeral_numeral @ A @ N2 ) )
          = ( ord_less @ num @ M @ N2 ) ) ) ).

% numeral_less_iff
thf(fact_64_add__numeral__left,axiom,
    ! [A: $tType] :
      ( ( numeral @ A )
     => ! [V: num,W: num,Z: A] :
          ( ( plus_plus @ A @ ( numeral_numeral @ A @ V ) @ ( plus_plus @ A @ ( numeral_numeral @ A @ W ) @ Z ) )
          = ( plus_plus @ A @ ( numeral_numeral @ A @ ( plus_plus @ num @ V @ W ) ) @ Z ) ) ) ).

% add_numeral_left
thf(fact_65_numeral__plus__numeral,axiom,
    ! [A: $tType] :
      ( ( numeral @ A )
     => ! [M: num,N2: num] :
          ( ( plus_plus @ A @ ( numeral_numeral @ A @ M ) @ ( numeral_numeral @ A @ N2 ) )
          = ( numeral_numeral @ A @ ( plus_plus @ num @ M @ N2 ) ) ) ) ).

% numeral_plus_numeral
thf(fact_66_power__0__Suc,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [N2: nat] :
          ( ( power_power @ A @ ( zero_zero @ A ) @ ( suc @ N2 ) )
          = ( zero_zero @ A ) ) ) ).

% power_0_Suc
thf(fact_67_power__zero__numeral,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [K: num] :
          ( ( power_power @ A @ ( zero_zero @ A ) @ ( numeral_numeral @ nat @ K ) )
          = ( zero_zero @ A ) ) ) ).

% power_zero_numeral
thf(fact_68_Suc__numeral,axiom,
    ! [N2: num] :
      ( ( suc @ ( numeral_numeral @ nat @ N2 ) )
      = ( numeral_numeral @ nat @ ( plus_plus @ num @ N2 @ one2 ) ) ) ).

% Suc_numeral
thf(fact_69_power__Suc0__right,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [A2: A] :
          ( ( power_power @ A @ A2 @ ( suc @ ( zero_zero @ nat ) ) )
          = A2 ) ) ).

% power_Suc0_right
thf(fact_70_nat__power__eq__Suc__0__iff,axiom,
    ! [X2: nat,M: nat] :
      ( ( ( power_power @ nat @ X2 @ M )
        = ( suc @ ( zero_zero @ nat ) ) )
      = ( ( M
          = ( zero_zero @ nat ) )
        | ( X2
          = ( suc @ ( zero_zero @ nat ) ) ) ) ) ).

% nat_power_eq_Suc_0_iff
thf(fact_71_power__Suc__0,axiom,
    ! [N2: nat] :
      ( ( power_power @ nat @ ( suc @ ( zero_zero @ nat ) ) @ N2 )
      = ( suc @ ( zero_zero @ nat ) ) ) ).

% power_Suc_0
thf(fact_72_nat__zero__less__power__iff,axiom,
    ! [X2: nat,N2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( power_power @ nat @ X2 @ N2 ) )
      = ( ( ord_less @ nat @ ( zero_zero @ nat ) @ X2 )
        | ( N2
          = ( zero_zero @ nat ) ) ) ) ).

% nat_zero_less_power_iff
thf(fact_73_add__One__commute,axiom,
    ! [N2: num] :
      ( ( plus_plus @ num @ one2 @ N2 )
      = ( plus_plus @ num @ N2 @ one2 ) ) ).

% add_One_commute
thf(fact_74_le__num__One__iff,axiom,
    ! [X2: num] :
      ( ( ord_less_eq @ num @ X2 @ one2 )
      = ( X2 = one2 ) ) ).

% le_num_One_iff
thf(fact_75_subset__code_I1_J,axiom,
    ! [A: $tType,Xs: list @ A,B3: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ Xs ) @ B3 )
      = ( ! [X5: A] :
            ( ( member @ A @ X5 @ ( set2 @ A @ Xs ) )
           => ( member @ A @ X5 @ B3 ) ) ) ) ).

% subset_code(1)
thf(fact_76_Suc__nat__number__of__add,axiom,
    ! [V: num,N2: nat] :
      ( ( suc @ ( plus_plus @ nat @ ( numeral_numeral @ nat @ V ) @ N2 ) )
      = ( plus_plus @ nat @ ( numeral_numeral @ nat @ ( plus_plus @ num @ V @ one2 ) ) @ N2 ) ) ).

% Suc_nat_number_of_add
thf(fact_77_is__num__normalize_I1_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( plus_plus @ A @ ( plus_plus @ A @ A2 @ B2 ) @ C2 )
          = ( plus_plus @ A @ A2 @ ( plus_plus @ A @ B2 @ C2 ) ) ) ) ).

% is_num_normalize(1)
thf(fact_78_neq__if__length__neq,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A] :
      ( ( ( size_size @ ( list @ A ) @ Xs )
       != ( size_size @ ( list @ A ) @ Ys ) )
     => ( Xs != Ys ) ) ).

% neq_if_length_neq
thf(fact_79_Ex__list__of__length,axiom,
    ! [A: $tType,N2: nat] :
    ? [Xs2: list @ A] :
      ( ( size_size @ ( list @ A ) @ Xs2 )
      = N2 ) ).

% Ex_list_of_length
thf(fact_80_le__numeral__extra_I3_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( zero_zero @ A ) ) ) ).

% le_numeral_extra(3)
thf(fact_81_less__numeral__extra_I3_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ~ ( ord_less @ A @ ( zero_zero @ A ) @ ( zero_zero @ A ) ) ) ).

% less_numeral_extra(3)
thf(fact_82_zero__neq__numeral,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [N2: num] :
          ( ( zero_zero @ A )
         != ( numeral_numeral @ A @ N2 ) ) ) ).

% zero_neq_numeral
thf(fact_83_power__not__zero,axiom,
    ! [A: $tType] :
      ( ( semiri2026040879449505780visors @ A )
     => ! [A2: A,N2: nat] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( power_power @ A @ A2 @ N2 )
           != ( zero_zero @ A ) ) ) ) ).

% power_not_zero
thf(fact_84_length__induct,axiom,
    ! [A: $tType,P: ( list @ A ) > $o,Xs: list @ A] :
      ( ! [Xs2: list @ A] :
          ( ! [Ys2: list @ A] :
              ( ( ord_less @ nat @ ( size_size @ ( list @ A ) @ Ys2 ) @ ( size_size @ ( list @ A ) @ Xs2 ) )
             => ( P @ Ys2 ) )
         => ( P @ Xs2 ) )
     => ( P @ Xs ) ) ).

% length_induct
thf(fact_85_not__numeral__le__zero,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [N2: num] :
          ~ ( ord_less_eq @ A @ ( numeral_numeral @ A @ N2 ) @ ( zero_zero @ A ) ) ) ).

% not_numeral_le_zero
thf(fact_86_zero__le__numeral,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [N2: num] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( numeral_numeral @ A @ N2 ) ) ) ).

% zero_le_numeral
thf(fact_87_not__numeral__less__zero,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [N2: num] :
          ~ ( ord_less @ A @ ( numeral_numeral @ A @ N2 ) @ ( zero_zero @ A ) ) ) ).

% not_numeral_less_zero
thf(fact_88_zero__less__numeral,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [N2: num] : ( ord_less @ A @ ( zero_zero @ A ) @ ( numeral_numeral @ A @ N2 ) ) ) ).

% zero_less_numeral
thf(fact_89_zero__le__power,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,N2: nat] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( power_power @ A @ A2 @ N2 ) ) ) ) ).

% zero_le_power
thf(fact_90_power__mono,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,B2: A,N2: nat] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
           => ( ord_less_eq @ A @ ( power_power @ A @ A2 @ N2 ) @ ( power_power @ A @ B2 @ N2 ) ) ) ) ) ).

% power_mono
thf(fact_91_zero__less__power,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,N2: nat] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ord_less @ A @ ( zero_zero @ A ) @ ( power_power @ A @ A2 @ N2 ) ) ) ) ).

% zero_less_power
thf(fact_92_numeral__Bit0,axiom,
    ! [A: $tType] :
      ( ( numeral @ A )
     => ! [N2: num] :
          ( ( numeral_numeral @ A @ ( bit0 @ N2 ) )
          = ( plus_plus @ A @ ( numeral_numeral @ A @ N2 ) @ ( numeral_numeral @ A @ N2 ) ) ) ) ).

% numeral_Bit0
thf(fact_93_nat__power__less__imp__less,axiom,
    ! [I3: nat,M: nat,N2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ I3 )
     => ( ( ord_less @ nat @ ( power_power @ nat @ I3 @ M ) @ ( power_power @ nat @ I3 @ N2 ) )
       => ( ord_less @ nat @ M @ N2 ) ) ) ).

% nat_power_less_imp_less
thf(fact_94_list__eq__iff__nth__eq,axiom,
    ! [A: $tType] :
      ( ( ^ [Y3: list @ A,Z2: list @ A] : ( Y3 = Z2 ) )
      = ( ^ [Xs3: list @ A,Ys3: list @ A] :
            ( ( ( size_size @ ( list @ A ) @ Xs3 )
              = ( size_size @ ( list @ A ) @ Ys3 ) )
            & ! [I4: nat] :
                ( ( ord_less @ nat @ I4 @ ( size_size @ ( list @ A ) @ Xs3 ) )
               => ( ( nth @ A @ Xs3 @ I4 )
                  = ( nth @ A @ Ys3 @ I4 ) ) ) ) ) ) ).

% list_eq_iff_nth_eq
thf(fact_95_Skolem__list__nth,axiom,
    ! [A: $tType,K: nat,P: nat > A > $o] :
      ( ( ! [I4: nat] :
            ( ( ord_less @ nat @ I4 @ K )
           => ? [X4: A] : ( P @ I4 @ X4 ) ) )
      = ( ? [Xs3: list @ A] :
            ( ( ( size_size @ ( list @ A ) @ Xs3 )
              = K )
            & ! [I4: nat] :
                ( ( ord_less @ nat @ I4 @ K )
               => ( P @ I4 @ ( nth @ A @ Xs3 @ I4 ) ) ) ) ) ) ).

% Skolem_list_nth
thf(fact_96_nth__equalityI,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A] :
      ( ( ( size_size @ ( list @ A ) @ Xs )
        = ( size_size @ ( list @ A ) @ Ys ) )
     => ( ! [I2: nat] :
            ( ( ord_less @ nat @ I2 @ ( size_size @ ( list @ A ) @ Xs ) )
           => ( ( nth @ A @ Xs @ I2 )
              = ( nth @ A @ Ys @ I2 ) ) )
       => ( Xs = Ys ) ) ) ).

% nth_equalityI
thf(fact_97_power__less__imp__less__base,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,N2: nat,B2: A] :
          ( ( ord_less @ A @ ( power_power @ A @ A2 @ N2 ) @ ( power_power @ A @ B2 @ N2 ) )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 )
           => ( ord_less @ A @ A2 @ B2 ) ) ) ) ).

% power_less_imp_less_base
thf(fact_98_power__le__imp__le__base,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,N2: nat,B2: A] :
          ( ( ord_less_eq @ A @ ( power_power @ A @ A2 @ ( suc @ N2 ) ) @ ( power_power @ A @ B2 @ ( suc @ N2 ) ) )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 )
           => ( ord_less_eq @ A @ A2 @ B2 ) ) ) ) ).

% power_le_imp_le_base
thf(fact_99_power__inject__base,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,N2: nat,B2: A] :
          ( ( ( power_power @ A @ A2 @ ( suc @ N2 ) )
            = ( power_power @ A @ B2 @ ( suc @ N2 ) ) )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
           => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 )
             => ( A2 = B2 ) ) ) ) ) ).

% power_inject_base
thf(fact_100_zero__power,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [N2: nat] :
          ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
         => ( ( power_power @ A @ ( zero_zero @ A ) @ N2 )
            = ( zero_zero @ A ) ) ) ) ).

% zero_power
thf(fact_101_numeral__1__eq__Suc__0,axiom,
    ( ( numeral_numeral @ nat @ one2 )
    = ( suc @ ( zero_zero @ nat ) ) ) ).

% numeral_1_eq_Suc_0
thf(fact_102_length__pos__if__in__set,axiom,
    ! [A: $tType,X2: A,Xs: list @ A] :
      ( ( member @ A @ X2 @ ( set2 @ A @ Xs ) )
     => ( ord_less @ nat @ ( zero_zero @ nat ) @ ( size_size @ ( list @ A ) @ Xs ) ) ) ).

% length_pos_if_in_set
thf(fact_103_power__gt__expt,axiom,
    ! [N2: nat,K: nat] :
      ( ( ord_less @ nat @ ( suc @ ( zero_zero @ nat ) ) @ N2 )
     => ( ord_less @ nat @ K @ ( power_power @ nat @ N2 @ K ) ) ) ).

% power_gt_expt
thf(fact_104_nat__one__le__power,axiom,
    ! [I3: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ ( suc @ ( zero_zero @ nat ) ) @ I3 )
     => ( ord_less_eq @ nat @ ( suc @ ( zero_zero @ nat ) ) @ ( power_power @ nat @ I3 @ N2 ) ) ) ).

% nat_one_le_power
thf(fact_105_all__set__conv__all__nth,axiom,
    ! [A: $tType,Xs: list @ A,P: A > $o] :
      ( ( ! [X5: A] :
            ( ( member @ A @ X5 @ ( set2 @ A @ Xs ) )
           => ( P @ X5 ) ) )
      = ( ! [I4: nat] :
            ( ( ord_less @ nat @ I4 @ ( size_size @ ( list @ A ) @ Xs ) )
           => ( P @ ( nth @ A @ Xs @ I4 ) ) ) ) ) ).

% all_set_conv_all_nth
thf(fact_106_all__nth__imp__all__set,axiom,
    ! [A: $tType,Xs: list @ A,P: A > $o,X2: A] :
      ( ! [I2: nat] :
          ( ( ord_less @ nat @ I2 @ ( size_size @ ( list @ A ) @ Xs ) )
         => ( P @ ( nth @ A @ Xs @ I2 ) ) )
     => ( ( member @ A @ X2 @ ( set2 @ A @ Xs ) )
       => ( P @ X2 ) ) ) ).

% all_nth_imp_all_set
thf(fact_107_in__set__conv__nth,axiom,
    ! [A: $tType,X2: A,Xs: list @ A] :
      ( ( member @ A @ X2 @ ( set2 @ A @ Xs ) )
      = ( ? [I4: nat] :
            ( ( ord_less @ nat @ I4 @ ( size_size @ ( list @ A ) @ Xs ) )
            & ( ( nth @ A @ Xs @ I4 )
              = X2 ) ) ) ) ).

% in_set_conv_nth
thf(fact_108_list__ball__nth,axiom,
    ! [A: $tType,N2: nat,Xs: list @ A,P: A > $o] :
      ( ( ord_less @ nat @ N2 @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( ! [X3: A] :
            ( ( member @ A @ X3 @ ( set2 @ A @ Xs ) )
           => ( P @ X3 ) )
       => ( P @ ( nth @ A @ Xs @ N2 ) ) ) ) ).

% list_ball_nth
thf(fact_109_power__eq__imp__eq__base,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,N2: nat,B2: A] :
          ( ( ( power_power @ A @ A2 @ N2 )
            = ( power_power @ A @ B2 @ N2 ) )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
           => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 )
             => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
               => ( A2 = B2 ) ) ) ) ) ) ).

% power_eq_imp_eq_base
thf(fact_110_power__eq__iff__eq__base,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [N2: nat,A2: A,B2: A] :
          ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
           => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 )
             => ( ( ( power_power @ A @ A2 @ N2 )
                  = ( power_power @ A @ B2 @ N2 ) )
                = ( A2 = B2 ) ) ) ) ) ) ).

% power_eq_iff_eq_base
thf(fact_111_zero__power2,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ( ( power_power @ A @ ( zero_zero @ A ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
        = ( zero_zero @ A ) ) ) ).

% zero_power2
thf(fact_112_numeral__2__eq__2,axiom,
    ( ( numeral_numeral @ nat @ ( bit0 @ one2 ) )
    = ( suc @ ( suc @ ( zero_zero @ nat ) ) ) ) ).

% numeral_2_eq_2
thf(fact_113_less__exp,axiom,
    ! [N2: nat] : ( ord_less @ nat @ N2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) ).

% less_exp
thf(fact_114_power2__nat__le__imp__le,axiom,
    ! [M: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ ( power_power @ nat @ M @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ N2 )
     => ( ord_less_eq @ nat @ M @ N2 ) ) ).

% power2_nat_le_imp_le
thf(fact_115_power2__nat__le__eq__le,axiom,
    ! [M: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ ( power_power @ nat @ M @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ nat @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
      = ( ord_less_eq @ nat @ M @ N2 ) ) ).

% power2_nat_le_eq_le
thf(fact_116_self__le__ge2__pow,axiom,
    ! [K: nat,M: nat] :
      ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ K )
     => ( ord_less_eq @ nat @ M @ ( power_power @ nat @ K @ M ) ) ) ).

% self_le_ge2_pow
thf(fact_117_power2__le__imp__le,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [X2: A,Y2: A] :
          ( ( ord_less_eq @ A @ ( power_power @ A @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ A @ Y2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ Y2 )
           => ( ord_less_eq @ A @ X2 @ Y2 ) ) ) ) ).

% power2_le_imp_le
thf(fact_118_power2__eq__imp__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [X2: A,Y2: A] :
          ( ( ( power_power @ A @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
            = ( power_power @ A @ Y2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X2 )
           => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ Y2 )
             => ( X2 = Y2 ) ) ) ) ) ).

% power2_eq_imp_eq
thf(fact_119_zero__le__power2,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ).

% zero_le_power2
thf(fact_120_power__strict__mono,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,B2: A,N2: nat] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
           => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
             => ( ord_less @ A @ ( power_power @ A @ A2 @ N2 ) @ ( power_power @ A @ B2 @ N2 ) ) ) ) ) ) ).

% power_strict_mono
thf(fact_121_power2__less__0,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A] :
          ~ ( ord_less @ A @ ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( zero_zero @ A ) ) ) ).

% power2_less_0
thf(fact_122_less__2__cases__iff,axiom,
    ! [N2: nat] :
      ( ( ord_less @ nat @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
      = ( ( N2
          = ( zero_zero @ nat ) )
        | ( N2
          = ( suc @ ( zero_zero @ nat ) ) ) ) ) ).

% less_2_cases_iff
thf(fact_123_less__2__cases,axiom,
    ! [N2: nat] :
      ( ( ord_less @ nat @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
     => ( ( N2
          = ( zero_zero @ nat ) )
        | ( N2
          = ( suc @ ( zero_zero @ nat ) ) ) ) ) ).

% less_2_cases
thf(fact_124_power2__less__imp__less,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [X2: A,Y2: A] :
          ( ( ord_less @ A @ ( power_power @ A @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ A @ Y2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ Y2 )
           => ( ord_less @ A @ X2 @ Y2 ) ) ) ) ).

% power2_less_imp_less
thf(fact_125_sum__power2__le__zero__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X2: A,Y2: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ ( power_power @ A @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ A @ Y2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( zero_zero @ A ) )
          = ( ( X2
              = ( zero_zero @ A ) )
            & ( Y2
              = ( zero_zero @ A ) ) ) ) ) ).

% sum_power2_le_zero_iff
thf(fact_126_sum__power2__ge__zero,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X2: A,Y2: A] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( plus_plus @ A @ ( power_power @ A @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ A @ Y2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% sum_power2_ge_zero
thf(fact_127_sum__power2__gt__zero__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X2: A,Y2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( plus_plus @ A @ ( power_power @ A @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ A @ Y2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
          = ( ( X2
             != ( zero_zero @ A ) )
            | ( Y2
             != ( zero_zero @ A ) ) ) ) ) ).

% sum_power2_gt_zero_iff
thf(fact_128_not__sum__power2__lt__zero,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X2: A,Y2: A] :
          ~ ( ord_less @ A @ ( plus_plus @ A @ ( power_power @ A @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ A @ Y2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( zero_zero @ A ) ) ) ).

% not_sum_power2_lt_zero
thf(fact_129_member__inv,axiom,
    ! [Mi: nat,Ma: nat,Deg: nat,TreeList: list @ vEBT_VEBT,Summary: vEBT_VEBT,X2: nat] :
      ( ( vEBT_vebt_member @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi @ Ma ) ) @ Deg @ TreeList @ Summary ) @ X2 )
     => ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg )
        & ( ( X2 = Mi )
          | ( X2 = Ma )
          | ( ( ord_less @ nat @ X2 @ Ma )
            & ( ord_less @ nat @ Mi @ X2 )
            & ( ord_less @ nat @ ( vEBT_VEBT_high @ X2 @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList ) )
            & ( vEBT_vebt_member @ ( nth @ vEBT_VEBT @ TreeList @ ( vEBT_VEBT_high @ X2 @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ X2 @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ).

% member_inv
thf(fact_130_both__member__options__ding,axiom,
    ! [Info: option @ ( product_prod @ nat @ nat ),Deg: nat,TreeList: list @ vEBT_VEBT,Summary: vEBT_VEBT,N2: nat,X2: nat] :
      ( ( vEBT_invar_vebt @ ( vEBT_Node @ Info @ Deg @ TreeList @ Summary ) @ N2 )
     => ( ( ord_less @ nat @ X2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg ) )
       => ( ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList @ ( vEBT_VEBT_high @ X2 @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ X2 @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
         => ( vEBT_V8194947554948674370ptions @ ( vEBT_Node @ Info @ Deg @ TreeList @ Summary ) @ X2 ) ) ) ) ).

% both_member_options_ding
thf(fact_131_add__gr__0,axiom,
    ! [M: nat,N2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( plus_plus @ nat @ M @ N2 ) )
      = ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M )
        | ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 ) ) ) ).

% add_gr_0
thf(fact_132_zero__less__Suc,axiom,
    ! [N2: nat] : ( ord_less @ nat @ ( zero_zero @ nat ) @ ( suc @ N2 ) ) ).

% zero_less_Suc
thf(fact_133_less__Suc0,axiom,
    ! [N2: nat] :
      ( ( ord_less @ nat @ N2 @ ( suc @ ( zero_zero @ nat ) ) )
      = ( N2
        = ( zero_zero @ nat ) ) ) ).

% less_Suc0
thf(fact_134_set__n__deg__not__0,axiom,
    ! [TreeList: list @ vEBT_VEBT,N2: nat,M: nat] :
      ( ! [X3: vEBT_VEBT] :
          ( ( member @ vEBT_VEBT @ X3 @ ( set2 @ vEBT_VEBT @ TreeList ) )
         => ( vEBT_invar_vebt @ X3 @ N2 ) )
     => ( ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList )
          = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M ) )
       => ( ord_less_eq @ nat @ ( one_one @ nat ) @ N2 ) ) ) ).

% set_n_deg_not_0
thf(fact_135_buildup__gives__valid,axiom,
    ! [N2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( vEBT_invar_vebt @ ( vEBT_vebt_buildup @ N2 ) @ N2 ) ) ).

% buildup_gives_valid
thf(fact_136_zero__less__double__add__iff__zero__less__single__add,axiom,
    ! [A: $tType] :
      ( ( linord5086331880401160121up_add @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( plus_plus @ A @ A2 @ A2 ) )
          = ( ord_less @ A @ ( zero_zero @ A ) @ A2 ) ) ) ).

% zero_less_double_add_iff_zero_less_single_add
thf(fact_137_double__add__less__zero__iff__single__add__less__zero,axiom,
    ! [A: $tType] :
      ( ( linord5086331880401160121up_add @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( plus_plus @ A @ A2 @ A2 ) @ ( zero_zero @ A ) )
          = ( ord_less @ A @ A2 @ ( zero_zero @ A ) ) ) ) ).

% double_add_less_zero_iff_single_add_less_zero
thf(fact_138_less__add__same__cancel2,axiom,
    ! [A: $tType] :
      ( ( ordere1937475149494474687imp_le @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ ( plus_plus @ A @ B2 @ A2 ) )
          = ( ord_less @ A @ ( zero_zero @ A ) @ B2 ) ) ) ).

% less_add_same_cancel2
thf(fact_139_less__add__same__cancel1,axiom,
    ! [A: $tType] :
      ( ( ordere1937475149494474687imp_le @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ ( plus_plus @ A @ A2 @ B2 ) )
          = ( ord_less @ A @ ( zero_zero @ A ) @ B2 ) ) ) ).

% less_add_same_cancel1
thf(fact_140_add__less__same__cancel2,axiom,
    ! [A: $tType] :
      ( ( ordere1937475149494474687imp_le @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( plus_plus @ A @ A2 @ B2 ) @ B2 )
          = ( ord_less @ A @ A2 @ ( zero_zero @ A ) ) ) ) ).

% add_less_same_cancel2
thf(fact_141_add__left__cancel,axiom,
    ! [A: $tType] :
      ( ( cancel_semigroup_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ( plus_plus @ A @ A2 @ B2 )
            = ( plus_plus @ A @ A2 @ C2 ) )
          = ( B2 = C2 ) ) ) ).

% add_left_cancel
thf(fact_142_add__right__cancel,axiom,
    ! [A: $tType] :
      ( ( cancel_semigroup_add @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( ( plus_plus @ A @ B2 @ A2 )
            = ( plus_plus @ A @ C2 @ A2 ) )
          = ( B2 = C2 ) ) ) ).

% add_right_cancel
thf(fact_143_nat_Oinject,axiom,
    ! [X22: nat,Y22: nat] :
      ( ( ( suc @ X22 )
        = ( suc @ Y22 ) )
      = ( X22 = Y22 ) ) ).

% nat.inject
thf(fact_144_old_Onat_Oinject,axiom,
    ! [Nat: nat,Nat2: nat] :
      ( ( ( suc @ Nat )
        = ( suc @ Nat2 ) )
      = ( Nat = Nat2 ) ) ).

% old.nat.inject
thf(fact_145_pow__sum,axiom,
    ! [A2: nat,B2: nat] :
      ( ( divide_divide @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( plus_plus @ nat @ A2 @ B2 ) ) @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ A2 ) )
      = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ B2 ) ) ).

% pow_sum
thf(fact_146_high__def,axiom,
    ( vEBT_VEBT_high
    = ( ^ [X5: nat,N3: nat] : ( divide_divide @ nat @ X5 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N3 ) ) ) ) ).

% high_def
thf(fact_147_le__zero__eq,axiom,
    ! [A: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ! [N2: A] :
          ( ( ord_less_eq @ A @ N2 @ ( zero_zero @ A ) )
          = ( N2
            = ( zero_zero @ A ) ) ) ) ).

% le_zero_eq
thf(fact_148_not__gr__zero,axiom,
    ! [A: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ! [N2: A] :
          ( ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ N2 ) )
          = ( N2
            = ( zero_zero @ A ) ) ) ) ).

% not_gr_zero
thf(fact_149_add__le__cancel__left,axiom,
    ! [A: $tType] :
      ( ( ordere2412721322843649153imp_le @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ C2 @ A2 ) @ ( plus_plus @ A @ C2 @ B2 ) )
          = ( ord_less_eq @ A @ A2 @ B2 ) ) ) ).

% add_le_cancel_left
thf(fact_150_add__le__cancel__right,axiom,
    ! [A: $tType] :
      ( ( ordere2412721322843649153imp_le @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ A2 @ C2 ) @ ( plus_plus @ A @ B2 @ C2 ) )
          = ( ord_less_eq @ A @ A2 @ B2 ) ) ) ).

% add_le_cancel_right
thf(fact_151_add_Oright__neutral,axiom,
    ! [A: $tType] :
      ( ( monoid_add @ A )
     => ! [A2: A] :
          ( ( plus_plus @ A @ A2 @ ( zero_zero @ A ) )
          = A2 ) ) ).

% add.right_neutral
thf(fact_152_double__zero__sym,axiom,
    ! [A: $tType] :
      ( ( linord5086331880401160121up_add @ A )
     => ! [A2: A] :
          ( ( ( zero_zero @ A )
            = ( plus_plus @ A @ A2 @ A2 ) )
          = ( A2
            = ( zero_zero @ A ) ) ) ) ).

% double_zero_sym
thf(fact_153_add__cancel__left__left,axiom,
    ! [A: $tType] :
      ( ( cancel1802427076303600483id_add @ A )
     => ! [B2: A,A2: A] :
          ( ( ( plus_plus @ A @ B2 @ A2 )
            = A2 )
          = ( B2
            = ( zero_zero @ A ) ) ) ) ).

% add_cancel_left_left
thf(fact_154_add__cancel__left__right,axiom,
    ! [A: $tType] :
      ( ( cancel1802427076303600483id_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ( plus_plus @ A @ A2 @ B2 )
            = A2 )
          = ( B2
            = ( zero_zero @ A ) ) ) ) ).

% add_cancel_left_right
thf(fact_155_add__cancel__right__left,axiom,
    ! [A: $tType] :
      ( ( cancel1802427076303600483id_add @ A )
     => ! [A2: A,B2: A] :
          ( ( A2
            = ( plus_plus @ A @ B2 @ A2 ) )
          = ( B2
            = ( zero_zero @ A ) ) ) ) ).

% add_cancel_right_left
thf(fact_156_add__cancel__right__right,axiom,
    ! [A: $tType] :
      ( ( cancel1802427076303600483id_add @ A )
     => ! [A2: A,B2: A] :
          ( ( A2
            = ( plus_plus @ A @ A2 @ B2 ) )
          = ( B2
            = ( zero_zero @ A ) ) ) ) ).

% add_cancel_right_right
thf(fact_157_add__eq__0__iff__both__eq__0,axiom,
    ! [A: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ! [X2: A,Y2: A] :
          ( ( ( plus_plus @ A @ X2 @ Y2 )
            = ( zero_zero @ A ) )
          = ( ( X2
              = ( zero_zero @ A ) )
            & ( Y2
              = ( zero_zero @ A ) ) ) ) ) ).

% add_eq_0_iff_both_eq_0
thf(fact_158_zero__eq__add__iff__both__eq__0,axiom,
    ! [A: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ! [X2: A,Y2: A] :
          ( ( ( zero_zero @ A )
            = ( plus_plus @ A @ X2 @ Y2 ) )
          = ( ( X2
              = ( zero_zero @ A ) )
            & ( Y2
              = ( zero_zero @ A ) ) ) ) ) ).

% zero_eq_add_iff_both_eq_0
thf(fact_159_add__0,axiom,
    ! [A: $tType] :
      ( ( monoid_add @ A )
     => ! [A2: A] :
          ( ( plus_plus @ A @ ( zero_zero @ A ) @ A2 )
          = A2 ) ) ).

% add_0
thf(fact_160_add__less__cancel__left,axiom,
    ! [A: $tType] :
      ( ( ordere2412721322843649153imp_le @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less @ A @ ( plus_plus @ A @ C2 @ A2 ) @ ( plus_plus @ A @ C2 @ B2 ) )
          = ( ord_less @ A @ A2 @ B2 ) ) ) ).

% add_less_cancel_left
thf(fact_161_add__less__cancel__right,axiom,
    ! [A: $tType] :
      ( ( ordere2412721322843649153imp_le @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ord_less @ A @ ( plus_plus @ A @ A2 @ C2 ) @ ( plus_plus @ A @ B2 @ C2 ) )
          = ( ord_less @ A @ A2 @ B2 ) ) ) ).

% add_less_cancel_right
thf(fact_162_power__one,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [N2: nat] :
          ( ( power_power @ A @ ( one_one @ A ) @ N2 )
          = ( one_one @ A ) ) ) ).

% power_one
thf(fact_163_lessI,axiom,
    ! [N2: nat] : ( ord_less @ nat @ N2 @ ( suc @ N2 ) ) ).

% lessI
thf(fact_164_Suc__mono,axiom,
    ! [M: nat,N2: nat] :
      ( ( ord_less @ nat @ M @ N2 )
     => ( ord_less @ nat @ ( suc @ M ) @ ( suc @ N2 ) ) ) ).

% Suc_mono
thf(fact_165_Suc__less__eq,axiom,
    ! [M: nat,N2: nat] :
      ( ( ord_less @ nat @ ( suc @ M ) @ ( suc @ N2 ) )
      = ( ord_less @ nat @ M @ N2 ) ) ).

% Suc_less_eq
thf(fact_166_bot__nat__0_Onot__eq__extremum,axiom,
    ! [A2: nat] :
      ( ( ( A2
         != ( zero_zero @ nat ) ) )
      = ( ord_less @ nat @ ( zero_zero @ nat ) @ A2 ) ) ).

% bot_nat_0.not_eq_extremum
thf(fact_167_neq0__conv,axiom,
    ! [N2: nat] :
      ( ( ( N2
         != ( zero_zero @ nat ) ) )
      = ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 ) ) ).

% neq0_conv
thf(fact_168_less__nat__zero__code,axiom,
    ! [N2: nat] :
      ~ ( ord_less @ nat @ N2 @ ( zero_zero @ nat ) ) ).

% less_nat_zero_code
thf(fact_169_Suc__le__mono,axiom,
    ! [N2: nat,M: nat] :
      ( ( ord_less_eq @ nat @ ( suc @ N2 ) @ ( suc @ M ) )
      = ( ord_less_eq @ nat @ N2 @ M ) ) ).

% Suc_le_mono
thf(fact_170_bot__nat__0_Oextremum,axiom,
    ! [A2: nat] : ( ord_less_eq @ nat @ ( zero_zero @ nat ) @ A2 ) ).

% bot_nat_0.extremum
thf(fact_171_le0,axiom,
    ! [N2: nat] : ( ord_less_eq @ nat @ ( zero_zero @ nat ) @ N2 ) ).

% le0
thf(fact_172_add__Suc__right,axiom,
    ! [M: nat,N2: nat] :
      ( ( plus_plus @ nat @ M @ ( suc @ N2 ) )
      = ( suc @ ( plus_plus @ nat @ M @ N2 ) ) ) ).

% add_Suc_right
thf(fact_173_add__is__0,axiom,
    ! [M: nat,N2: nat] :
      ( ( ( plus_plus @ nat @ M @ N2 )
        = ( zero_zero @ nat ) )
      = ( ( M
          = ( zero_zero @ nat ) )
        & ( N2
          = ( zero_zero @ nat ) ) ) ) ).

% add_is_0
thf(fact_174_Nat_Oadd__0__right,axiom,
    ! [M: nat] :
      ( ( plus_plus @ nat @ M @ ( zero_zero @ nat ) )
      = M ) ).

% Nat.add_0_right
thf(fact_175_nat__add__left__cancel__less,axiom,
    ! [K: nat,M: nat,N2: nat] :
      ( ( ord_less @ nat @ ( plus_plus @ nat @ K @ M ) @ ( plus_plus @ nat @ K @ N2 ) )
      = ( ord_less @ nat @ M @ N2 ) ) ).

% nat_add_left_cancel_less
thf(fact_176_nat__add__left__cancel__le,axiom,
    ! [K: nat,M: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ ( plus_plus @ nat @ K @ M ) @ ( plus_plus @ nat @ K @ N2 ) )
      = ( ord_less_eq @ nat @ M @ N2 ) ) ).

% nat_add_left_cancel_le
thf(fact_177_power__one__right,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [A2: A] :
          ( ( power_power @ A @ A2 @ ( one_one @ nat ) )
          = A2 ) ) ).

% power_one_right
thf(fact_178_add__le__same__cancel1,axiom,
    ! [A: $tType] :
      ( ( ordere1937475149494474687imp_le @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ B2 @ A2 ) @ B2 )
          = ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) ) ) ) ).

% add_le_same_cancel1
thf(fact_179_add__le__same__cancel2,axiom,
    ! [A: $tType] :
      ( ( ordere1937475149494474687imp_le @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ A2 @ B2 ) @ B2 )
          = ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) ) ) ) ).

% add_le_same_cancel2
thf(fact_180_le__add__same__cancel1,axiom,
    ! [A: $tType] :
      ( ( ordere1937475149494474687imp_le @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ ( plus_plus @ A @ A2 @ B2 ) )
          = ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 ) ) ) ).

% le_add_same_cancel1
thf(fact_181_le__add__same__cancel2,axiom,
    ! [A: $tType] :
      ( ( ordere1937475149494474687imp_le @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ ( plus_plus @ A @ B2 @ A2 ) )
          = ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 ) ) ) ).

% le_add_same_cancel2
thf(fact_182_double__add__le__zero__iff__single__add__le__zero,axiom,
    ! [A: $tType] :
      ( ( linord5086331880401160121up_add @ A )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ A2 @ A2 ) @ ( zero_zero @ A ) )
          = ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) ) ) ) ).

% double_add_le_zero_iff_single_add_le_zero
thf(fact_183_zero__le__double__add__iff__zero__le__single__add,axiom,
    ! [A: $tType] :
      ( ( linord5086331880401160121up_add @ A )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( plus_plus @ A @ A2 @ A2 ) )
          = ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 ) ) ) ).

% zero_le_double_add_iff_zero_le_single_add
thf(fact_184_add__less__same__cancel1,axiom,
    ! [A: $tType] :
      ( ( ordere1937475149494474687imp_le @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less @ A @ ( plus_plus @ A @ B2 @ A2 ) @ B2 )
          = ( ord_less @ A @ A2 @ ( zero_zero @ A ) ) ) ) ).

% add_less_same_cancel1
thf(fact_185_numeral__eq__one__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [N2: num] :
          ( ( ( numeral_numeral @ A @ N2 )
            = ( one_one @ A ) )
          = ( N2 = one2 ) ) ) ).

% numeral_eq_one_iff
thf(fact_186_one__eq__numeral__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [N2: num] :
          ( ( ( one_one @ A )
            = ( numeral_numeral @ A @ N2 ) )
          = ( one2 = N2 ) ) ) ).

% one_eq_numeral_iff
thf(fact_187_power__inject__exp,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,M: nat,N2: nat] :
          ( ( ord_less @ A @ ( one_one @ A ) @ A2 )
         => ( ( ( power_power @ A @ A2 @ M )
              = ( power_power @ A @ A2 @ N2 ) )
            = ( M = N2 ) ) ) ) ).

% power_inject_exp
thf(fact_188_less__one,axiom,
    ! [N2: nat] :
      ( ( ord_less @ nat @ N2 @ ( one_one @ nat ) )
      = ( N2
        = ( zero_zero @ nat ) ) ) ).

% less_one
thf(fact_189_both__member__options__from__complete__tree__to__child,axiom,
    ! [Deg: nat,Mi: nat,Ma: nat,TreeList: list @ vEBT_VEBT,Summary: vEBT_VEBT,X2: nat] :
      ( ( ord_less_eq @ nat @ ( one_one @ nat ) @ Deg )
     => ( ( vEBT_V8194947554948674370ptions @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi @ Ma ) ) @ Deg @ TreeList @ Summary ) @ X2 )
       => ( ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList @ ( vEBT_VEBT_high @ X2 @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ X2 @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
          | ( X2 = Mi )
          | ( X2 = Ma ) ) ) ) ).

% both_member_options_from_complete_tree_to_child
thf(fact_190_power__strict__increasing__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [B2: A,X2: nat,Y2: nat] :
          ( ( ord_less @ A @ ( one_one @ A ) @ B2 )
         => ( ( ord_less @ A @ ( power_power @ A @ B2 @ X2 ) @ ( power_power @ A @ B2 @ Y2 ) )
            = ( ord_less @ nat @ X2 @ Y2 ) ) ) ) ).

% power_strict_increasing_iff
thf(fact_191_both__member__options__from__chilf__to__complete__tree,axiom,
    ! [X2: nat,Deg: nat,TreeList: list @ vEBT_VEBT,Mi: nat,Ma: nat,Summary: vEBT_VEBT] :
      ( ( ord_less @ nat @ ( vEBT_VEBT_high @ X2 @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList ) )
     => ( ( ord_less_eq @ nat @ ( one_one @ nat ) @ Deg )
       => ( ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList @ ( vEBT_VEBT_high @ X2 @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ X2 @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
         => ( vEBT_V8194947554948674370ptions @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi @ Ma ) ) @ Deg @ TreeList @ Summary ) @ X2 ) ) ) ) ).

% both_member_options_from_chilf_to_complete_tree
thf(fact_192_one__add__one,axiom,
    ! [A: $tType] :
      ( ( numeral @ A )
     => ( ( plus_plus @ A @ ( one_one @ A ) @ ( one_one @ A ) )
        = ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ).

% one_add_one
thf(fact_193_power__strict__decreasing__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [B2: A,M: nat,N2: nat] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ B2 )
         => ( ( ord_less @ A @ B2 @ ( one_one @ A ) )
           => ( ( ord_less @ A @ ( power_power @ A @ B2 @ M ) @ ( power_power @ A @ B2 @ N2 ) )
              = ( ord_less @ nat @ N2 @ M ) ) ) ) ) ).

% power_strict_decreasing_iff
thf(fact_194_power__increasing__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [B2: A,X2: nat,Y2: nat] :
          ( ( ord_less @ A @ ( one_one @ A ) @ B2 )
         => ( ( ord_less_eq @ A @ ( power_power @ A @ B2 @ X2 ) @ ( power_power @ A @ B2 @ Y2 ) )
            = ( ord_less_eq @ nat @ X2 @ Y2 ) ) ) ) ).

% power_increasing_iff
thf(fact_195_Suc__1,axiom,
    ( ( suc @ ( one_one @ nat ) )
    = ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ).

% Suc_1
thf(fact_196_numeral__plus__one,axiom,
    ! [A: $tType] :
      ( ( numeral @ A )
     => ! [N2: num] :
          ( ( plus_plus @ A @ ( numeral_numeral @ A @ N2 ) @ ( one_one @ A ) )
          = ( numeral_numeral @ A @ ( plus_plus @ num @ N2 @ one2 ) ) ) ) ).

% numeral_plus_one
thf(fact_197_one__plus__numeral,axiom,
    ! [A: $tType] :
      ( ( numeral @ A )
     => ! [N2: num] :
          ( ( plus_plus @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ N2 ) )
          = ( numeral_numeral @ A @ ( plus_plus @ num @ one2 @ N2 ) ) ) ) ).

% one_plus_numeral
thf(fact_198_numeral__le__one__iff,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [N2: num] :
          ( ( ord_less_eq @ A @ ( numeral_numeral @ A @ N2 ) @ ( one_one @ A ) )
          = ( ord_less_eq @ num @ N2 @ one2 ) ) ) ).

% numeral_le_one_iff
thf(fact_199_one__less__numeral__iff,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [N2: num] :
          ( ( ord_less @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ N2 ) )
          = ( ord_less @ num @ one2 @ N2 ) ) ) ).

% one_less_numeral_iff
thf(fact_200_power__decreasing__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [B2: A,M: nat,N2: nat] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ B2 )
         => ( ( ord_less @ A @ B2 @ ( one_one @ A ) )
           => ( ( ord_less_eq @ A @ ( power_power @ A @ B2 @ M ) @ ( power_power @ A @ B2 @ N2 ) )
              = ( ord_less_eq @ nat @ N2 @ M ) ) ) ) ) ).

% power_decreasing_iff
thf(fact_201_one__reorient,axiom,
    ! [A: $tType] :
      ( ( one @ A )
     => ! [X2: A] :
          ( ( ( one_one @ A )
            = X2 )
          = ( X2
            = ( one_one @ A ) ) ) ) ).

% one_reorient
thf(fact_202_power__one__over,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A,N2: nat] :
          ( ( power_power @ A @ ( divide_divide @ A @ ( one_one @ A ) @ A2 ) @ N2 )
          = ( divide_divide @ A @ ( one_one @ A ) @ ( power_power @ A @ A2 @ N2 ) ) ) ) ).

% power_one_over
thf(fact_203_power__divide,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A2: A,B2: A,N2: nat] :
          ( ( power_power @ A @ ( divide_divide @ A @ A2 @ B2 ) @ N2 )
          = ( divide_divide @ A @ ( power_power @ A @ A2 @ N2 ) @ ( power_power @ A @ B2 @ N2 ) ) ) ) ).

% power_divide
thf(fact_204_le__numeral__extra_I4_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ( ord_less_eq @ A @ ( one_one @ A ) @ ( one_one @ A ) ) ) ).

% le_numeral_extra(4)
thf(fact_205_less__numeral__extra_I4_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ~ ( ord_less @ A @ ( one_one @ A ) @ ( one_one @ A ) ) ) ).

% less_numeral_extra(4)
thf(fact_206_One__nat__def,axiom,
    ( ( one_one @ nat )
    = ( suc @ ( zero_zero @ nat ) ) ) ).

% One_nat_def
thf(fact_207_Suc__eq__plus1,axiom,
    ( suc
    = ( ^ [N3: nat] : ( plus_plus @ nat @ N3 @ ( one_one @ nat ) ) ) ) ).

% Suc_eq_plus1
thf(fact_208_plus__1__eq__Suc,axiom,
    ( ( plus_plus @ nat @ ( one_one @ nat ) )
    = suc ) ).

% plus_1_eq_Suc
thf(fact_209_Suc__eq__plus1__left,axiom,
    ( suc
    = ( plus_plus @ nat @ ( one_one @ nat ) ) ) ).

% Suc_eq_plus1_left
thf(fact_210_divide__numeral__1,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A2: A] :
          ( ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ one2 ) )
          = A2 ) ) ).

% divide_numeral_1
thf(fact_211_less__numeral__extra_I1_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ( ord_less @ A @ ( zero_zero @ A ) @ ( one_one @ A ) ) ) ).

% less_numeral_extra(1)
thf(fact_212_one__le__numeral,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [N2: num] : ( ord_less_eq @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ N2 ) ) ) ).

% one_le_numeral
thf(fact_213_not__numeral__less__one,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [N2: num] :
          ~ ( ord_less @ A @ ( numeral_numeral @ A @ N2 ) @ ( one_one @ A ) ) ) ).

% not_numeral_less_one
thf(fact_214_nat__induct__non__zero,axiom,
    ! [N2: nat,P: nat > $o] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( P @ ( one_one @ nat ) )
       => ( ! [N: nat] :
              ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
             => ( ( P @ N )
               => ( P @ ( suc @ N ) ) ) )
         => ( P @ N2 ) ) ) ) ).

% nat_induct_non_zero
thf(fact_215_one__plus__numeral__commute,axiom,
    ! [A: $tType] :
      ( ( numeral @ A )
     => ! [X2: num] :
          ( ( plus_plus @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ X2 ) )
          = ( plus_plus @ A @ ( numeral_numeral @ A @ X2 ) @ ( one_one @ A ) ) ) ) ).

% one_plus_numeral_commute
thf(fact_216_numeral__One,axiom,
    ! [A: $tType] :
      ( ( numeral @ A )
     => ( ( numeral_numeral @ A @ one2 )
        = ( one_one @ A ) ) ) ).

% numeral_One
thf(fact_217_one__le__power,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,N2: nat] :
          ( ( ord_less_eq @ A @ ( one_one @ A ) @ A2 )
         => ( ord_less_eq @ A @ ( one_one @ A ) @ ( power_power @ A @ A2 @ N2 ) ) ) ) ).

% one_le_power
thf(fact_218_power__0,axiom,
    ! [A: $tType] :
      ( ( power @ A )
     => ! [A2: A] :
          ( ( power_power @ A @ A2 @ ( zero_zero @ nat ) )
          = ( one_one @ A ) ) ) ).

% power_0
thf(fact_219_numerals_I1_J,axiom,
    ( ( numeral_numeral @ nat @ one2 )
    = ( one_one @ nat ) ) ).

% numerals(1)
thf(fact_220_zero__reorient,axiom,
    ! [A: $tType] :
      ( ( zero @ A )
     => ! [X2: A] :
          ( ( ( zero_zero @ A )
            = X2 )
          = ( X2
            = ( zero_zero @ A ) ) ) ) ).

% zero_reorient
thf(fact_221_power__le__one,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,N2: nat] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less_eq @ A @ A2 @ ( one_one @ A ) )
           => ( ord_less_eq @ A @ ( power_power @ A @ A2 @ N2 ) @ ( one_one @ A ) ) ) ) ) ).

% power_le_one
thf(fact_222_measure__induct,axiom,
    ! [B: $tType,A: $tType] :
      ( ( wellorder @ B )
     => ! [F2: A > B,P: A > $o,A2: A] :
          ( ! [X3: A] :
              ( ! [Y: A] :
                  ( ( ord_less @ B @ ( F2 @ Y ) @ ( F2 @ X3 ) )
                 => ( P @ Y ) )
             => ( P @ X3 ) )
         => ( P @ A2 ) ) ) ).

% measure_induct
thf(fact_223_measure__induct__rule,axiom,
    ! [B: $tType,A: $tType] :
      ( ( wellorder @ B )
     => ! [F2: A > B,P: A > $o,A2: A] :
          ( ! [X3: A] :
              ( ! [Y: A] :
                  ( ( ord_less @ B @ ( F2 @ Y ) @ ( F2 @ X3 ) )
                 => ( P @ Y ) )
             => ( P @ X3 ) )
         => ( P @ A2 ) ) ) ).

% measure_induct_rule
thf(fact_224_power__0__left,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [N2: nat] :
          ( ( ( N2
              = ( zero_zero @ nat ) )
           => ( ( power_power @ A @ ( zero_zero @ A ) @ N2 )
              = ( one_one @ A ) ) )
          & ( ( N2
             != ( zero_zero @ nat ) )
           => ( ( power_power @ A @ ( zero_zero @ A ) @ N2 )
              = ( zero_zero @ A ) ) ) ) ) ).

% power_0_left
thf(fact_225_power__gt1,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,N2: nat] :
          ( ( ord_less @ A @ ( one_one @ A ) @ A2 )
         => ( ord_less @ A @ ( one_one @ A ) @ ( power_power @ A @ A2 @ ( suc @ N2 ) ) ) ) ) ).

% power_gt1
thf(fact_226_ab__semigroup__add__class_Oadd__ac_I1_J,axiom,
    ! [A: $tType] :
      ( ( ab_semigroup_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( plus_plus @ A @ ( plus_plus @ A @ A2 @ B2 ) @ C2 )
          = ( plus_plus @ A @ A2 @ ( plus_plus @ A @ B2 @ C2 ) ) ) ) ).

% ab_semigroup_add_class.add_ac(1)
thf(fact_227_add__mono__thms__linordered__semiring_I4_J,axiom,
    ! [A: $tType] :
      ( ( ordere6658533253407199908up_add @ A )
     => ! [I3: A,J: A,K: A,L: A] :
          ( ( ( I3 = J )
            & ( K = L ) )
         => ( ( plus_plus @ A @ I3 @ K )
            = ( plus_plus @ A @ J @ L ) ) ) ) ).

% add_mono_thms_linordered_semiring(4)
thf(fact_228_group__cancel_Oadd1,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A3: A,K: A,A2: A,B2: A] :
          ( ( A3
            = ( plus_plus @ A @ K @ A2 ) )
         => ( ( plus_plus @ A @ A3 @ B2 )
            = ( plus_plus @ A @ K @ ( plus_plus @ A @ A2 @ B2 ) ) ) ) ) ).

% group_cancel.add1
thf(fact_229_group__cancel_Oadd2,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [B3: A,K: A,B2: A,A2: A] :
          ( ( B3
            = ( plus_plus @ A @ K @ B2 ) )
         => ( ( plus_plus @ A @ A2 @ B3 )
            = ( plus_plus @ A @ K @ ( plus_plus @ A @ A2 @ B2 ) ) ) ) ) ).

% group_cancel.add2
thf(fact_230_add_Oassoc,axiom,
    ! [A: $tType] :
      ( ( semigroup_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( plus_plus @ A @ ( plus_plus @ A @ A2 @ B2 ) @ C2 )
          = ( plus_plus @ A @ A2 @ ( plus_plus @ A @ B2 @ C2 ) ) ) ) ).

% add.assoc
thf(fact_231_add_Oleft__cancel,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ( plus_plus @ A @ A2 @ B2 )
            = ( plus_plus @ A @ A2 @ C2 ) )
          = ( B2 = C2 ) ) ) ).

% add.left_cancel
thf(fact_232_add_Oright__cancel,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( ( plus_plus @ A @ B2 @ A2 )
            = ( plus_plus @ A @ C2 @ A2 ) )
          = ( B2 = C2 ) ) ) ).

% add.right_cancel
thf(fact_233_add_Ocommute,axiom,
    ! [A: $tType] :
      ( ( ab_semigroup_add @ A )
     => ( ( plus_plus @ A )
        = ( ^ [A4: A,B4: A] : ( plus_plus @ A @ B4 @ A4 ) ) ) ) ).

% add.commute
thf(fact_234_add_Oleft__commute,axiom,
    ! [A: $tType] :
      ( ( ab_semigroup_add @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( plus_plus @ A @ B2 @ ( plus_plus @ A @ A2 @ C2 ) )
          = ( plus_plus @ A @ A2 @ ( plus_plus @ A @ B2 @ C2 ) ) ) ) ).

% add.left_commute
thf(fact_235_add__left__imp__eq,axiom,
    ! [A: $tType] :
      ( ( cancel_semigroup_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ( plus_plus @ A @ A2 @ B2 )
            = ( plus_plus @ A @ A2 @ C2 ) )
         => ( B2 = C2 ) ) ) ).

% add_left_imp_eq
thf(fact_236_add__right__imp__eq,axiom,
    ! [A: $tType] :
      ( ( cancel_semigroup_add @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( ( plus_plus @ A @ B2 @ A2 )
            = ( plus_plus @ A @ C2 @ A2 ) )
         => ( B2 = C2 ) ) ) ).

% add_right_imp_eq
thf(fact_237_power__less__imp__less__exp,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,M: nat,N2: nat] :
          ( ( ord_less @ A @ ( one_one @ A ) @ A2 )
         => ( ( ord_less @ A @ ( power_power @ A @ A2 @ M ) @ ( power_power @ A @ A2 @ N2 ) )
           => ( ord_less @ nat @ M @ N2 ) ) ) ) ).

% power_less_imp_less_exp
thf(fact_238_power__strict__increasing,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [N2: nat,N4: nat,A2: A] :
          ( ( ord_less @ nat @ N2 @ N4 )
         => ( ( ord_less @ A @ ( one_one @ A ) @ A2 )
           => ( ord_less @ A @ ( power_power @ A @ A2 @ N2 ) @ ( power_power @ A @ A2 @ N4 ) ) ) ) ) ).

% power_strict_increasing
thf(fact_239_power__increasing,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [N2: nat,N4: nat,A2: A] :
          ( ( ord_less_eq @ nat @ N2 @ N4 )
         => ( ( ord_less_eq @ A @ ( one_one @ A ) @ A2 )
           => ( ord_less_eq @ A @ ( power_power @ A @ A2 @ N2 ) @ ( power_power @ A @ A2 @ N4 ) ) ) ) ) ).

% power_increasing
thf(fact_240_Suc__inject,axiom,
    ! [X2: nat,Y2: nat] :
      ( ( ( suc @ X2 )
        = ( suc @ Y2 ) )
     => ( X2 = Y2 ) ) ).

% Suc_inject
thf(fact_241_n__not__Suc__n,axiom,
    ! [N2: nat] :
      ( N2
     != ( suc @ N2 ) ) ).

% n_not_Suc_n
thf(fact_242_nat__neq__iff,axiom,
    ! [M: nat,N2: nat] :
      ( ( ( M != N2 ) )
      = ( ( ord_less @ nat @ M @ N2 )
        | ( ord_less @ nat @ N2 @ M ) ) ) ).

% nat_neq_iff
thf(fact_243_less__not__refl,axiom,
    ! [N2: nat] :
      ~ ( ord_less @ nat @ N2 @ N2 ) ).

% less_not_refl
thf(fact_244_less__not__refl2,axiom,
    ! [N2: nat,M: nat] :
      ( ( ord_less @ nat @ N2 @ M )
     => ( M != N2 ) ) ).

% less_not_refl2
thf(fact_245_less__not__refl3,axiom,
    ! [S2: nat,T2: nat] :
      ( ( ord_less @ nat @ S2 @ T2 )
     => ( S2 != T2 ) ) ).

% less_not_refl3
thf(fact_246_less__irrefl__nat,axiom,
    ! [N2: nat] :
      ~ ( ord_less @ nat @ N2 @ N2 ) ).

% less_irrefl_nat
thf(fact_247_nat__less__induct,axiom,
    ! [P: nat > $o,N2: nat] :
      ( ! [N: nat] :
          ( ! [M2: nat] :
              ( ( ord_less @ nat @ M2 @ N )
             => ( P @ M2 ) )
         => ( P @ N ) )
     => ( P @ N2 ) ) ).

% nat_less_induct
thf(fact_248_infinite__descent,axiom,
    ! [P: nat > $o,N2: nat] :
      ( ! [N: nat] :
          ( ~ ( P @ N )
         => ? [M2: nat] :
              ( ( ord_less @ nat @ M2 @ N )
              & ~ ( P @ M2 ) ) )
     => ( P @ N2 ) ) ).

% infinite_descent
thf(fact_249_linorder__neqE__nat,axiom,
    ! [X2: nat,Y2: nat] :
      ( ( X2 != Y2 )
     => ( ~ ( ord_less @ nat @ X2 @ Y2 )
       => ( ord_less @ nat @ Y2 @ X2 ) ) ) ).

% linorder_neqE_nat
thf(fact_250_infinite__descent__measure,axiom,
    ! [A: $tType,P: A > $o,V2: A > nat,X2: A] :
      ( ! [X3: A] :
          ( ~ ( P @ X3 )
         => ? [Y: A] :
              ( ( ord_less @ nat @ ( V2 @ Y ) @ ( V2 @ X3 ) )
              & ~ ( P @ Y ) ) )
     => ( P @ X2 ) ) ).

% infinite_descent_measure
thf(fact_251_le__refl,axiom,
    ! [N2: nat] : ( ord_less_eq @ nat @ N2 @ N2 ) ).

% le_refl
thf(fact_252_le__trans,axiom,
    ! [I3: nat,J: nat,K: nat] :
      ( ( ord_less_eq @ nat @ I3 @ J )
     => ( ( ord_less_eq @ nat @ J @ K )
       => ( ord_less_eq @ nat @ I3 @ K ) ) ) ).

% le_trans
thf(fact_253_eq__imp__le,axiom,
    ! [M: nat,N2: nat] :
      ( ( M = N2 )
     => ( ord_less_eq @ nat @ M @ N2 ) ) ).

% eq_imp_le
thf(fact_254_le__antisym,axiom,
    ! [M: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ M @ N2 )
     => ( ( ord_less_eq @ nat @ N2 @ M )
       => ( M = N2 ) ) ) ).

% le_antisym
thf(fact_255_nat__le__linear,axiom,
    ! [M: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ M @ N2 )
      | ( ord_less_eq @ nat @ N2 @ M ) ) ).

% nat_le_linear
thf(fact_256_Nat_Oex__has__greatest__nat,axiom,
    ! [P: nat > $o,K: nat,B2: nat] :
      ( ( P @ K )
     => ( ! [Y4: nat] :
            ( ( P @ Y4 )
           => ( ord_less_eq @ nat @ Y4 @ B2 ) )
       => ? [X3: nat] :
            ( ( P @ X3 )
            & ! [Y: nat] :
                ( ( P @ Y )
               => ( ord_less_eq @ nat @ Y @ X3 ) ) ) ) ) ).

% Nat.ex_has_greatest_nat
thf(fact_257_size__neq__size__imp__neq,axiom,
    ! [A: $tType] :
      ( ( size @ A )
     => ! [X2: A,Y2: A] :
          ( ( ( size_size @ A @ X2 )
           != ( size_size @ A @ Y2 ) )
         => ( X2 != Y2 ) ) ) ).

% size_neq_size_imp_neq
thf(fact_258_power__Suc__le__self,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,N2: nat] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less_eq @ A @ A2 @ ( one_one @ A ) )
           => ( ord_less_eq @ A @ ( power_power @ A @ A2 @ ( suc @ N2 ) ) @ A2 ) ) ) ) ).

% power_Suc_le_self
thf(fact_259_power__Suc__less__one,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,N2: nat] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less @ A @ A2 @ ( one_one @ A ) )
           => ( ord_less @ A @ ( power_power @ A @ A2 @ ( suc @ N2 ) ) @ ( one_one @ A ) ) ) ) ) ).

% power_Suc_less_one
thf(fact_260_power__strict__decreasing,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [N2: nat,N4: nat,A2: A] :
          ( ( ord_less @ nat @ N2 @ N4 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
           => ( ( ord_less @ A @ A2 @ ( one_one @ A ) )
             => ( ord_less @ A @ ( power_power @ A @ A2 @ N4 ) @ ( power_power @ A @ A2 @ N2 ) ) ) ) ) ) ).

% power_strict_decreasing
thf(fact_261_power__decreasing,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [N2: nat,N4: nat,A2: A] :
          ( ( ord_less_eq @ nat @ N2 @ N4 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
           => ( ( ord_less_eq @ A @ A2 @ ( one_one @ A ) )
             => ( ord_less_eq @ A @ ( power_power @ A @ A2 @ N4 ) @ ( power_power @ A @ A2 @ N2 ) ) ) ) ) ) ).

% power_decreasing
thf(fact_262_power__le__imp__le__exp,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,M: nat,N2: nat] :
          ( ( ord_less @ A @ ( one_one @ A ) @ A2 )
         => ( ( ord_less_eq @ A @ ( power_power @ A @ A2 @ M ) @ ( power_power @ A @ A2 @ N2 ) )
           => ( ord_less_eq @ nat @ M @ N2 ) ) ) ) ).

% power_le_imp_le_exp
thf(fact_263_self__le__power,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,N2: nat] :
          ( ( ord_less_eq @ A @ ( one_one @ A ) @ A2 )
         => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
           => ( ord_less_eq @ A @ A2 @ ( power_power @ A @ A2 @ N2 ) ) ) ) ) ).

% self_le_power
thf(fact_264_one__power2,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ( ( power_power @ A @ ( one_one @ A ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
        = ( one_one @ A ) ) ) ).

% one_power2
thf(fact_265_one__less__power,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,N2: nat] :
          ( ( ord_less @ A @ ( one_one @ A ) @ A2 )
         => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
           => ( ord_less @ A @ ( one_one @ A ) @ ( power_power @ A @ A2 @ N2 ) ) ) ) ) ).

% one_less_power
thf(fact_266_nat__1__add__1,axiom,
    ( ( plus_plus @ nat @ ( one_one @ nat ) @ ( one_one @ nat ) )
    = ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ).

% nat_1_add_1
thf(fact_267_half__gt__zero,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ord_less @ A @ ( zero_zero @ A ) @ ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ).

% half_gt_zero
thf(fact_268_half__gt__zero__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) )
          = ( ord_less @ A @ ( zero_zero @ A ) @ A2 ) ) ) ).

% half_gt_zero_iff
thf(fact_269_zero__le,axiom,
    ! [A: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ! [X2: A] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ X2 ) ) ).

% zero_le
thf(fact_270_gr__zeroI,axiom,
    ! [A: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ! [N2: A] :
          ( ( N2
           != ( zero_zero @ A ) )
         => ( ord_less @ A @ ( zero_zero @ A ) @ N2 ) ) ) ).

% gr_zeroI
thf(fact_271_not__less__zero,axiom,
    ! [A: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ! [N2: A] :
          ~ ( ord_less @ A @ N2 @ ( zero_zero @ A ) ) ) ).

% not_less_zero
thf(fact_272_gr__implies__not__zero,axiom,
    ! [A: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ! [M: A,N2: A] :
          ( ( ord_less @ A @ M @ N2 )
         => ( N2
           != ( zero_zero @ A ) ) ) ) ).

% gr_implies_not_zero
thf(fact_273_zero__less__iff__neq__zero,axiom,
    ! [A: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ! [N2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ N2 )
          = ( ( N2
             != ( zero_zero @ A ) ) ) ) ) ).

% zero_less_iff_neq_zero
thf(fact_274_add__mono__thms__linordered__semiring_I3_J,axiom,
    ! [A: $tType] :
      ( ( ordere6658533253407199908up_add @ A )
     => ! [I3: A,J: A,K: A,L: A] :
          ( ( ( ord_less_eq @ A @ I3 @ J )
            & ( K = L ) )
         => ( ord_less_eq @ A @ ( plus_plus @ A @ I3 @ K ) @ ( plus_plus @ A @ J @ L ) ) ) ) ).

% add_mono_thms_linordered_semiring(3)
thf(fact_275_add__mono__thms__linordered__semiring_I2_J,axiom,
    ! [A: $tType] :
      ( ( ordere6658533253407199908up_add @ A )
     => ! [I3: A,J: A,K: A,L: A] :
          ( ( ( I3 = J )
            & ( ord_less_eq @ A @ K @ L ) )
         => ( ord_less_eq @ A @ ( plus_plus @ A @ I3 @ K ) @ ( plus_plus @ A @ J @ L ) ) ) ) ).

% add_mono_thms_linordered_semiring(2)
thf(fact_276_add__mono__thms__linordered__semiring_I1_J,axiom,
    ! [A: $tType] :
      ( ( ordere6658533253407199908up_add @ A )
     => ! [I3: A,J: A,K: A,L: A] :
          ( ( ( ord_less_eq @ A @ I3 @ J )
            & ( ord_less_eq @ A @ K @ L ) )
         => ( ord_less_eq @ A @ ( plus_plus @ A @ I3 @ K ) @ ( plus_plus @ A @ J @ L ) ) ) ) ).

% add_mono_thms_linordered_semiring(1)
thf(fact_277_add__mono,axiom,
    ! [A: $tType] :
      ( ( ordere6658533253407199908up_add @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ C2 @ D2 )
           => ( ord_less_eq @ A @ ( plus_plus @ A @ A2 @ C2 ) @ ( plus_plus @ A @ B2 @ D2 ) ) ) ) ) ).

% add_mono
thf(fact_278_add__left__mono,axiom,
    ! [A: $tType] :
      ( ( ordere6658533253407199908up_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ord_less_eq @ A @ ( plus_plus @ A @ C2 @ A2 ) @ ( plus_plus @ A @ C2 @ B2 ) ) ) ) ).

% add_left_mono
thf(fact_279_less__eqE,axiom,
    ! [A: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ~ ! [C3: A] :
                ( B2
               != ( plus_plus @ A @ A2 @ C3 ) ) ) ) ).

% less_eqE
thf(fact_280_add__right__mono,axiom,
    ! [A: $tType] :
      ( ( ordere6658533253407199908up_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ord_less_eq @ A @ ( plus_plus @ A @ A2 @ C2 ) @ ( plus_plus @ A @ B2 @ C2 ) ) ) ) ).

% add_right_mono
thf(fact_281_le__iff__add,axiom,
    ! [A: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [A4: A,B4: A] :
            ? [C4: A] :
              ( B4
              = ( plus_plus @ A @ A4 @ C4 ) ) ) ) ) ).

% le_iff_add
thf(fact_282_add__le__imp__le__left,axiom,
    ! [A: $tType] :
      ( ( ordere2412721322843649153imp_le @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ C2 @ A2 ) @ ( plus_plus @ A @ C2 @ B2 ) )
         => ( ord_less_eq @ A @ A2 @ B2 ) ) ) ).

% add_le_imp_le_left
thf(fact_283_add__le__imp__le__right,axiom,
    ! [A: $tType] :
      ( ( ordere2412721322843649153imp_le @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ A2 @ C2 ) @ ( plus_plus @ A @ B2 @ C2 ) )
         => ( ord_less_eq @ A @ A2 @ B2 ) ) ) ).

% add_le_imp_le_right
thf(fact_284_comm__monoid__add__class_Oadd__0,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A2: A] :
          ( ( plus_plus @ A @ ( zero_zero @ A ) @ A2 )
          = A2 ) ) ).

% comm_monoid_add_class.add_0
thf(fact_285_add_Ocomm__neutral,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A2: A] :
          ( ( plus_plus @ A @ A2 @ ( zero_zero @ A ) )
          = A2 ) ) ).

% add.comm_neutral
thf(fact_286_add_Ogroup__left__neutral,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A] :
          ( ( plus_plus @ A @ ( zero_zero @ A ) @ A2 )
          = A2 ) ) ).

% add.group_left_neutral
thf(fact_287_add__mono__thms__linordered__field_I5_J,axiom,
    ! [A: $tType] :
      ( ( ordere580206878836729694up_add @ A )
     => ! [I3: A,J: A,K: A,L: A] :
          ( ( ( ord_less @ A @ I3 @ J )
            & ( ord_less @ A @ K @ L ) )
         => ( ord_less @ A @ ( plus_plus @ A @ I3 @ K ) @ ( plus_plus @ A @ J @ L ) ) ) ) ).

% add_mono_thms_linordered_field(5)
thf(fact_288_add__mono__thms__linordered__field_I2_J,axiom,
    ! [A: $tType] :
      ( ( ordere580206878836729694up_add @ A )
     => ! [I3: A,J: A,K: A,L: A] :
          ( ( ( I3 = J )
            & ( ord_less @ A @ K @ L ) )
         => ( ord_less @ A @ ( plus_plus @ A @ I3 @ K ) @ ( plus_plus @ A @ J @ L ) ) ) ) ).

% add_mono_thms_linordered_field(2)
thf(fact_289_add__mono__thms__linordered__field_I1_J,axiom,
    ! [A: $tType] :
      ( ( ordere580206878836729694up_add @ A )
     => ! [I3: A,J: A,K: A,L: A] :
          ( ( ( ord_less @ A @ I3 @ J )
            & ( K = L ) )
         => ( ord_less @ A @ ( plus_plus @ A @ I3 @ K ) @ ( plus_plus @ A @ J @ L ) ) ) ) ).

% add_mono_thms_linordered_field(1)
thf(fact_290_add__strict__mono,axiom,
    ! [A: $tType] :
      ( ( strict9044650504122735259up_add @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_less @ A @ C2 @ D2 )
           => ( ord_less @ A @ ( plus_plus @ A @ A2 @ C2 ) @ ( plus_plus @ A @ B2 @ D2 ) ) ) ) ) ).

% add_strict_mono
thf(fact_291_add__strict__left__mono,axiom,
    ! [A: $tType] :
      ( ( ordere580206878836729694up_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ord_less @ A @ ( plus_plus @ A @ C2 @ A2 ) @ ( plus_plus @ A @ C2 @ B2 ) ) ) ) ).

% add_strict_left_mono
thf(fact_292_add__strict__right__mono,axiom,
    ! [A: $tType] :
      ( ( ordere580206878836729694up_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ord_less @ A @ ( plus_plus @ A @ A2 @ C2 ) @ ( plus_plus @ A @ B2 @ C2 ) ) ) ) ).

% add_strict_right_mono
thf(fact_293_add__less__imp__less__left,axiom,
    ! [A: $tType] :
      ( ( ordere2412721322843649153imp_le @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less @ A @ ( plus_plus @ A @ C2 @ A2 ) @ ( plus_plus @ A @ C2 @ B2 ) )
         => ( ord_less @ A @ A2 @ B2 ) ) ) ).

% add_less_imp_less_left
thf(fact_294_add__less__imp__less__right,axiom,
    ! [A: $tType] :
      ( ( ordere2412721322843649153imp_le @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ord_less @ A @ ( plus_plus @ A @ A2 @ C2 ) @ ( plus_plus @ A @ B2 @ C2 ) )
         => ( ord_less @ A @ A2 @ B2 ) ) ) ).

% add_less_imp_less_right
thf(fact_295_nat_Odistinct_I1_J,axiom,
    ! [X22: nat] :
      ( ( zero_zero @ nat )
     != ( suc @ X22 ) ) ).

% nat.distinct(1)
thf(fact_296_old_Onat_Odistinct_I2_J,axiom,
    ! [Nat3: nat] :
      ( ( suc @ Nat3 )
     != ( zero_zero @ nat ) ) ).

% old.nat.distinct(2)
thf(fact_297_old_Onat_Odistinct_I1_J,axiom,
    ! [Nat2: nat] :
      ( ( zero_zero @ nat )
     != ( suc @ Nat2 ) ) ).

% old.nat.distinct(1)
thf(fact_298_nat_OdiscI,axiom,
    ! [Nat: nat,X22: nat] :
      ( ( Nat
        = ( suc @ X22 ) )
     => ( Nat
       != ( zero_zero @ nat ) ) ) ).

% nat.discI
thf(fact_299_old_Onat_Oexhaust,axiom,
    ! [Y2: nat] :
      ( ( Y2
       != ( zero_zero @ nat ) )
     => ~ ! [Nat4: nat] :
            ( Y2
           != ( suc @ Nat4 ) ) ) ).

% old.nat.exhaust
thf(fact_300_nat__induct,axiom,
    ! [P: nat > $o,N2: nat] :
      ( ( P @ ( zero_zero @ nat ) )
     => ( ! [N: nat] :
            ( ( P @ N )
           => ( P @ ( suc @ N ) ) )
       => ( P @ N2 ) ) ) ).

% nat_induct
thf(fact_301_diff__induct,axiom,
    ! [P: nat > nat > $o,M: nat,N2: nat] :
      ( ! [X3: nat] : ( P @ X3 @ ( zero_zero @ nat ) )
     => ( ! [Y4: nat] : ( P @ ( zero_zero @ nat ) @ ( suc @ Y4 ) )
       => ( ! [X3: nat,Y4: nat] :
              ( ( P @ X3 @ Y4 )
             => ( P @ ( suc @ X3 ) @ ( suc @ Y4 ) ) )
         => ( P @ M @ N2 ) ) ) ) ).

% diff_induct
thf(fact_302_zero__induct,axiom,
    ! [P: nat > $o,K: nat] :
      ( ( P @ K )
     => ( ! [N: nat] :
            ( ( P @ ( suc @ N ) )
           => ( P @ N ) )
       => ( P @ ( zero_zero @ nat ) ) ) ) ).

% zero_induct
thf(fact_303_Suc__neq__Zero,axiom,
    ! [M: nat] :
      ( ( suc @ M )
     != ( zero_zero @ nat ) ) ).

% Suc_neq_Zero
thf(fact_304_Zero__neq__Suc,axiom,
    ! [M: nat] :
      ( ( zero_zero @ nat )
     != ( suc @ M ) ) ).

% Zero_neq_Suc
thf(fact_305_Zero__not__Suc,axiom,
    ! [M: nat] :
      ( ( zero_zero @ nat )
     != ( suc @ M ) ) ).

% Zero_not_Suc
thf(fact_306_not0__implies__Suc,axiom,
    ! [N2: nat] :
      ( ( N2
       != ( zero_zero @ nat ) )
     => ? [M3: nat] :
          ( N2
          = ( suc @ M3 ) ) ) ).

% not0_implies_Suc
thf(fact_307_Nat_OlessE,axiom,
    ! [I3: nat,K: nat] :
      ( ( ord_less @ nat @ I3 @ K )
     => ( ( K
         != ( suc @ I3 ) )
       => ~ ! [J2: nat] :
              ( ( ord_less @ nat @ I3 @ J2 )
             => ( K
               != ( suc @ J2 ) ) ) ) ) ).

% Nat.lessE
thf(fact_308_Suc__lessD,axiom,
    ! [M: nat,N2: nat] :
      ( ( ord_less @ nat @ ( suc @ M ) @ N2 )
     => ( ord_less @ nat @ M @ N2 ) ) ).

% Suc_lessD
thf(fact_309_Suc__lessE,axiom,
    ! [I3: nat,K: nat] :
      ( ( ord_less @ nat @ ( suc @ I3 ) @ K )
     => ~ ! [J2: nat] :
            ( ( ord_less @ nat @ I3 @ J2 )
           => ( K
             != ( suc @ J2 ) ) ) ) ).

% Suc_lessE
thf(fact_310_Suc__lessI,axiom,
    ! [M: nat,N2: nat] :
      ( ( ord_less @ nat @ M @ N2 )
     => ( ( ( suc @ M )
         != N2 )
       => ( ord_less @ nat @ ( suc @ M ) @ N2 ) ) ) ).

% Suc_lessI
thf(fact_311_less__SucE,axiom,
    ! [M: nat,N2: nat] :
      ( ( ord_less @ nat @ M @ ( suc @ N2 ) )
     => ( ~ ( ord_less @ nat @ M @ N2 )
       => ( M = N2 ) ) ) ).

% less_SucE
thf(fact_312_less__SucI,axiom,
    ! [M: nat,N2: nat] :
      ( ( ord_less @ nat @ M @ N2 )
     => ( ord_less @ nat @ M @ ( suc @ N2 ) ) ) ).

% less_SucI
thf(fact_313_Ex__less__Suc,axiom,
    ! [N2: nat,P: nat > $o] :
      ( ( ? [I4: nat] :
            ( ( ord_less @ nat @ I4 @ ( suc @ N2 ) )
            & ( P @ I4 ) ) )
      = ( ( P @ N2 )
        | ? [I4: nat] :
            ( ( ord_less @ nat @ I4 @ N2 )
            & ( P @ I4 ) ) ) ) ).

% Ex_less_Suc
thf(fact_314_less__Suc__eq,axiom,
    ! [M: nat,N2: nat] :
      ( ( ord_less @ nat @ M @ ( suc @ N2 ) )
      = ( ( ord_less @ nat @ M @ N2 )
        | ( M = N2 ) ) ) ).

% less_Suc_eq
thf(fact_315_not__less__eq,axiom,
    ! [M: nat,N2: nat] :
      ( ( ~ ( ord_less @ nat @ M @ N2 ) )
      = ( ord_less @ nat @ N2 @ ( suc @ M ) ) ) ).

% not_less_eq
thf(fact_316_All__less__Suc,axiom,
    ! [N2: nat,P: nat > $o] :
      ( ( ! [I4: nat] :
            ( ( ord_less @ nat @ I4 @ ( suc @ N2 ) )
           => ( P @ I4 ) ) )
      = ( ( P @ N2 )
        & ! [I4: nat] :
            ( ( ord_less @ nat @ I4 @ N2 )
           => ( P @ I4 ) ) ) ) ).

% All_less_Suc
thf(fact_317_Suc__less__eq2,axiom,
    ! [N2: nat,M: nat] :
      ( ( ord_less @ nat @ ( suc @ N2 ) @ M )
      = ( ? [M4: nat] :
            ( ( M
              = ( suc @ M4 ) )
            & ( ord_less @ nat @ N2 @ M4 ) ) ) ) ).

% Suc_less_eq2
thf(fact_318_less__antisym,axiom,
    ! [N2: nat,M: nat] :
      ( ~ ( ord_less @ nat @ N2 @ M )
     => ( ( ord_less @ nat @ N2 @ ( suc @ M ) )
       => ( M = N2 ) ) ) ).

% less_antisym
thf(fact_319_Suc__less__SucD,axiom,
    ! [M: nat,N2: nat] :
      ( ( ord_less @ nat @ ( suc @ M ) @ ( suc @ N2 ) )
     => ( ord_less @ nat @ M @ N2 ) ) ).

% Suc_less_SucD
thf(fact_320_less__trans__Suc,axiom,
    ! [I3: nat,J: nat,K: nat] :
      ( ( ord_less @ nat @ I3 @ J )
     => ( ( ord_less @ nat @ J @ K )
       => ( ord_less @ nat @ ( suc @ I3 ) @ K ) ) ) ).

% less_trans_Suc
thf(fact_321_less__Suc__induct,axiom,
    ! [I3: nat,J: nat,P: nat > nat > $o] :
      ( ( ord_less @ nat @ I3 @ J )
     => ( ! [I2: nat] : ( P @ I2 @ ( suc @ I2 ) )
       => ( ! [I2: nat,J2: nat,K2: nat] :
              ( ( ord_less @ nat @ I2 @ J2 )
             => ( ( ord_less @ nat @ J2 @ K2 )
               => ( ( P @ I2 @ J2 )
                 => ( ( P @ J2 @ K2 )
                   => ( P @ I2 @ K2 ) ) ) ) )
         => ( P @ I3 @ J ) ) ) ) ).

% less_Suc_induct
thf(fact_322_strict__inc__induct,axiom,
    ! [I3: nat,J: nat,P: nat > $o] :
      ( ( ord_less @ nat @ I3 @ J )
     => ( ! [I2: nat] :
            ( ( J
              = ( suc @ I2 ) )
           => ( P @ I2 ) )
       => ( ! [I2: nat] :
              ( ( ord_less @ nat @ I2 @ J )
             => ( ( P @ ( suc @ I2 ) )
               => ( P @ I2 ) ) )
         => ( P @ I3 ) ) ) ) ).

% strict_inc_induct
thf(fact_323_not__less__less__Suc__eq,axiom,
    ! [N2: nat,M: nat] :
      ( ~ ( ord_less @ nat @ N2 @ M )
     => ( ( ord_less @ nat @ N2 @ ( suc @ M ) )
        = ( N2 = M ) ) ) ).

% not_less_less_Suc_eq
thf(fact_324_bot__nat__0_Oextremum__strict,axiom,
    ! [A2: nat] :
      ~ ( ord_less @ nat @ A2 @ ( zero_zero @ nat ) ) ).

% bot_nat_0.extremum_strict
thf(fact_325_gr0I,axiom,
    ! [N2: nat] :
      ( ( N2
       != ( zero_zero @ nat ) )
     => ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 ) ) ).

% gr0I
thf(fact_326_not__gr0,axiom,
    ! [N2: nat] :
      ( ( ~ ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 ) )
      = ( N2
        = ( zero_zero @ nat ) ) ) ).

% not_gr0
thf(fact_327_not__less0,axiom,
    ! [N2: nat] :
      ~ ( ord_less @ nat @ N2 @ ( zero_zero @ nat ) ) ).

% not_less0
thf(fact_328_less__zeroE,axiom,
    ! [N2: nat] :
      ~ ( ord_less @ nat @ N2 @ ( zero_zero @ nat ) ) ).

% less_zeroE
thf(fact_329_gr__implies__not0,axiom,
    ! [M: nat,N2: nat] :
      ( ( ord_less @ nat @ M @ N2 )
     => ( N2
       != ( zero_zero @ nat ) ) ) ).

% gr_implies_not0
thf(fact_330_infinite__descent0,axiom,
    ! [P: nat > $o,N2: nat] :
      ( ( P @ ( zero_zero @ nat ) )
     => ( ! [N: nat] :
            ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
           => ( ~ ( P @ N )
             => ? [M2: nat] :
                  ( ( ord_less @ nat @ M2 @ N )
                  & ~ ( P @ M2 ) ) ) )
       => ( P @ N2 ) ) ) ).

% infinite_descent0
thf(fact_331_infinite__descent0__measure,axiom,
    ! [A: $tType,V2: A > nat,P: A > $o,X2: A] :
      ( ! [X3: A] :
          ( ( ( V2 @ X3 )
            = ( zero_zero @ nat ) )
         => ( P @ X3 ) )
     => ( ! [X3: A] :
            ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( V2 @ X3 ) )
           => ( ~ ( P @ X3 )
             => ? [Y: A] :
                  ( ( ord_less @ nat @ ( V2 @ Y ) @ ( V2 @ X3 ) )
                  & ~ ( P @ Y ) ) ) )
       => ( P @ X2 ) ) ) ).

% infinite_descent0_measure
thf(fact_332_Suc__leD,axiom,
    ! [M: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ ( suc @ M ) @ N2 )
     => ( ord_less_eq @ nat @ M @ N2 ) ) ).

% Suc_leD
thf(fact_333_le__SucE,axiom,
    ! [M: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ M @ ( suc @ N2 ) )
     => ( ~ ( ord_less_eq @ nat @ M @ N2 )
       => ( M
          = ( suc @ N2 ) ) ) ) ).

% le_SucE
thf(fact_334_le__SucI,axiom,
    ! [M: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ M @ N2 )
     => ( ord_less_eq @ nat @ M @ ( suc @ N2 ) ) ) ).

% le_SucI
thf(fact_335_Suc__le__D,axiom,
    ! [N2: nat,M5: nat] :
      ( ( ord_less_eq @ nat @ ( suc @ N2 ) @ M5 )
     => ? [M3: nat] :
          ( M5
          = ( suc @ M3 ) ) ) ).

% Suc_le_D
thf(fact_336_le__Suc__eq,axiom,
    ! [M: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ M @ ( suc @ N2 ) )
      = ( ( ord_less_eq @ nat @ M @ N2 )
        | ( M
          = ( suc @ N2 ) ) ) ) ).

% le_Suc_eq
thf(fact_337_Suc__n__not__le__n,axiom,
    ! [N2: nat] :
      ~ ( ord_less_eq @ nat @ ( suc @ N2 ) @ N2 ) ).

% Suc_n_not_le_n
thf(fact_338_not__less__eq__eq,axiom,
    ! [M: nat,N2: nat] :
      ( ( ~ ( ord_less_eq @ nat @ M @ N2 ) )
      = ( ord_less_eq @ nat @ ( suc @ N2 ) @ M ) ) ).

% not_less_eq_eq
thf(fact_339_full__nat__induct,axiom,
    ! [P: nat > $o,N2: nat] :
      ( ! [N: nat] :
          ( ! [M2: nat] :
              ( ( ord_less_eq @ nat @ ( suc @ M2 ) @ N )
             => ( P @ M2 ) )
         => ( P @ N ) )
     => ( P @ N2 ) ) ).

% full_nat_induct
thf(fact_340_nat__induct__at__least,axiom,
    ! [M: nat,N2: nat,P: nat > $o] :
      ( ( ord_less_eq @ nat @ M @ N2 )
     => ( ( P @ M )
       => ( ! [N: nat] :
              ( ( ord_less_eq @ nat @ M @ N )
             => ( ( P @ N )
               => ( P @ ( suc @ N ) ) ) )
         => ( P @ N2 ) ) ) ) ).

% nat_induct_at_least
thf(fact_341_transitive__stepwise__le,axiom,
    ! [M: nat,N2: nat,R: nat > nat > $o] :
      ( ( ord_less_eq @ nat @ M @ N2 )
     => ( ! [X3: nat] : ( R @ X3 @ X3 )
       => ( ! [X3: nat,Y4: nat,Z3: nat] :
              ( ( R @ X3 @ Y4 )
             => ( ( R @ Y4 @ Z3 )
               => ( R @ X3 @ Z3 ) ) )
         => ( ! [N: nat] : ( R @ N @ ( suc @ N ) )
           => ( R @ M @ N2 ) ) ) ) ) ).

% transitive_stepwise_le
thf(fact_342_less__eq__nat_Osimps_I1_J,axiom,
    ! [N2: nat] : ( ord_less_eq @ nat @ ( zero_zero @ nat ) @ N2 ) ).

% less_eq_nat.simps(1)
thf(fact_343_bot__nat__0_Oextremum__unique,axiom,
    ! [A2: nat] :
      ( ( ord_less_eq @ nat @ A2 @ ( zero_zero @ nat ) )
      = ( A2
        = ( zero_zero @ nat ) ) ) ).

% bot_nat_0.extremum_unique
thf(fact_344_bot__nat__0_Oextremum__uniqueI,axiom,
    ! [A2: nat] :
      ( ( ord_less_eq @ nat @ A2 @ ( zero_zero @ nat ) )
     => ( A2
        = ( zero_zero @ nat ) ) ) ).

% bot_nat_0.extremum_uniqueI
thf(fact_345_le__0__eq,axiom,
    ! [N2: nat] :
      ( ( ord_less_eq @ nat @ N2 @ ( zero_zero @ nat ) )
      = ( N2
        = ( zero_zero @ nat ) ) ) ).

% le_0_eq
thf(fact_346_nat__arith_Osuc1,axiom,
    ! [A3: nat,K: nat,A2: nat] :
      ( ( A3
        = ( plus_plus @ nat @ K @ A2 ) )
     => ( ( suc @ A3 )
        = ( plus_plus @ nat @ K @ ( suc @ A2 ) ) ) ) ).

% nat_arith.suc1
thf(fact_347_add__Suc,axiom,
    ! [M: nat,N2: nat] :
      ( ( plus_plus @ nat @ ( suc @ M ) @ N2 )
      = ( suc @ ( plus_plus @ nat @ M @ N2 ) ) ) ).

% add_Suc
thf(fact_348_add__Suc__shift,axiom,
    ! [M: nat,N2: nat] :
      ( ( plus_plus @ nat @ ( suc @ M ) @ N2 )
      = ( plus_plus @ nat @ M @ ( suc @ N2 ) ) ) ).

% add_Suc_shift
thf(fact_349_nat__less__le,axiom,
    ( ( ord_less @ nat )
    = ( ^ [M6: nat,N3: nat] :
          ( ( ord_less_eq @ nat @ M6 @ N3 )
          & ( M6 != N3 ) ) ) ) ).

% nat_less_le
thf(fact_350_less__imp__le__nat,axiom,
    ! [M: nat,N2: nat] :
      ( ( ord_less @ nat @ M @ N2 )
     => ( ord_less_eq @ nat @ M @ N2 ) ) ).

% less_imp_le_nat
thf(fact_351_le__eq__less__or__eq,axiom,
    ( ( ord_less_eq @ nat )
    = ( ^ [M6: nat,N3: nat] :
          ( ( ord_less @ nat @ M6 @ N3 )
          | ( M6 = N3 ) ) ) ) ).

% le_eq_less_or_eq
thf(fact_352_less__or__eq__imp__le,axiom,
    ! [M: nat,N2: nat] :
      ( ( ( ord_less @ nat @ M @ N2 )
        | ( M = N2 ) )
     => ( ord_less_eq @ nat @ M @ N2 ) ) ).

% less_or_eq_imp_le
thf(fact_353_le__neq__implies__less,axiom,
    ! [M: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ M @ N2 )
     => ( ( M != N2 )
       => ( ord_less @ nat @ M @ N2 ) ) ) ).

% le_neq_implies_less
thf(fact_354_less__mono__imp__le__mono,axiom,
    ! [F2: nat > nat,I3: nat,J: nat] :
      ( ! [I2: nat,J2: nat] :
          ( ( ord_less @ nat @ I2 @ J2 )
         => ( ord_less @ nat @ ( F2 @ I2 ) @ ( F2 @ J2 ) ) )
     => ( ( ord_less_eq @ nat @ I3 @ J )
       => ( ord_less_eq @ nat @ ( F2 @ I3 ) @ ( F2 @ J ) ) ) ) ).

% less_mono_imp_le_mono
thf(fact_355_plus__nat_Oadd__0,axiom,
    ! [N2: nat] :
      ( ( plus_plus @ nat @ ( zero_zero @ nat ) @ N2 )
      = N2 ) ).

% plus_nat.add_0
thf(fact_356_add__eq__self__zero,axiom,
    ! [M: nat,N2: nat] :
      ( ( ( plus_plus @ nat @ M @ N2 )
        = M )
     => ( N2
        = ( zero_zero @ nat ) ) ) ).

% add_eq_self_zero
thf(fact_357_add__lessD1,axiom,
    ! [I3: nat,J: nat,K: nat] :
      ( ( ord_less @ nat @ ( plus_plus @ nat @ I3 @ J ) @ K )
     => ( ord_less @ nat @ I3 @ K ) ) ).

% add_lessD1
thf(fact_358_add__less__mono,axiom,
    ! [I3: nat,J: nat,K: nat,L: nat] :
      ( ( ord_less @ nat @ I3 @ J )
     => ( ( ord_less @ nat @ K @ L )
       => ( ord_less @ nat @ ( plus_plus @ nat @ I3 @ K ) @ ( plus_plus @ nat @ J @ L ) ) ) ) ).

% add_less_mono
thf(fact_359_not__add__less1,axiom,
    ! [I3: nat,J: nat] :
      ~ ( ord_less @ nat @ ( plus_plus @ nat @ I3 @ J ) @ I3 ) ).

% not_add_less1
thf(fact_360_not__add__less2,axiom,
    ! [J: nat,I3: nat] :
      ~ ( ord_less @ nat @ ( plus_plus @ nat @ J @ I3 ) @ I3 ) ).

% not_add_less2
thf(fact_361_add__less__mono1,axiom,
    ! [I3: nat,J: nat,K: nat] :
      ( ( ord_less @ nat @ I3 @ J )
     => ( ord_less @ nat @ ( plus_plus @ nat @ I3 @ K ) @ ( plus_plus @ nat @ J @ K ) ) ) ).

% add_less_mono1
thf(fact_362_trans__less__add1,axiom,
    ! [I3: nat,J: nat,M: nat] :
      ( ( ord_less @ nat @ I3 @ J )
     => ( ord_less @ nat @ I3 @ ( plus_plus @ nat @ J @ M ) ) ) ).

% trans_less_add1
thf(fact_363_trans__less__add2,axiom,
    ! [I3: nat,J: nat,M: nat] :
      ( ( ord_less @ nat @ I3 @ J )
     => ( ord_less @ nat @ I3 @ ( plus_plus @ nat @ M @ J ) ) ) ).

% trans_less_add2
thf(fact_364_less__add__eq__less,axiom,
    ! [K: nat,L: nat,M: nat,N2: nat] :
      ( ( ord_less @ nat @ K @ L )
     => ( ( ( plus_plus @ nat @ M @ L )
          = ( plus_plus @ nat @ K @ N2 ) )
       => ( ord_less @ nat @ M @ N2 ) ) ) ).

% less_add_eq_less
thf(fact_365_add__leE,axiom,
    ! [M: nat,K: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ ( plus_plus @ nat @ M @ K ) @ N2 )
     => ~ ( ( ord_less_eq @ nat @ M @ N2 )
         => ~ ( ord_less_eq @ nat @ K @ N2 ) ) ) ).

% add_leE
thf(fact_366_le__add1,axiom,
    ! [N2: nat,M: nat] : ( ord_less_eq @ nat @ N2 @ ( plus_plus @ nat @ N2 @ M ) ) ).

% le_add1
thf(fact_367_le__add2,axiom,
    ! [N2: nat,M: nat] : ( ord_less_eq @ nat @ N2 @ ( plus_plus @ nat @ M @ N2 ) ) ).

% le_add2
thf(fact_368_add__leD1,axiom,
    ! [M: nat,K: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ ( plus_plus @ nat @ M @ K ) @ N2 )
     => ( ord_less_eq @ nat @ M @ N2 ) ) ).

% add_leD1
thf(fact_369_add__leD2,axiom,
    ! [M: nat,K: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ ( plus_plus @ nat @ M @ K ) @ N2 )
     => ( ord_less_eq @ nat @ K @ N2 ) ) ).

% add_leD2
thf(fact_370_le__Suc__ex,axiom,
    ! [K: nat,L: nat] :
      ( ( ord_less_eq @ nat @ K @ L )
     => ? [N: nat] :
          ( L
          = ( plus_plus @ nat @ K @ N ) ) ) ).

% le_Suc_ex
thf(fact_371_add__le__mono,axiom,
    ! [I3: nat,J: nat,K: nat,L: nat] :
      ( ( ord_less_eq @ nat @ I3 @ J )
     => ( ( ord_less_eq @ nat @ K @ L )
       => ( ord_less_eq @ nat @ ( plus_plus @ nat @ I3 @ K ) @ ( plus_plus @ nat @ J @ L ) ) ) ) ).

% add_le_mono
thf(fact_372_add__le__mono1,axiom,
    ! [I3: nat,J: nat,K: nat] :
      ( ( ord_less_eq @ nat @ I3 @ J )
     => ( ord_less_eq @ nat @ ( plus_plus @ nat @ I3 @ K ) @ ( plus_plus @ nat @ J @ K ) ) ) ).

% add_le_mono1
thf(fact_373_trans__le__add1,axiom,
    ! [I3: nat,J: nat,M: nat] :
      ( ( ord_less_eq @ nat @ I3 @ J )
     => ( ord_less_eq @ nat @ I3 @ ( plus_plus @ nat @ J @ M ) ) ) ).

% trans_le_add1
thf(fact_374_trans__le__add2,axiom,
    ! [I3: nat,J: nat,M: nat] :
      ( ( ord_less_eq @ nat @ I3 @ J )
     => ( ord_less_eq @ nat @ I3 @ ( plus_plus @ nat @ M @ J ) ) ) ).

% trans_le_add2
thf(fact_375_nat__le__iff__add,axiom,
    ( ( ord_less_eq @ nat )
    = ( ^ [M6: nat,N3: nat] :
        ? [K3: nat] :
          ( N3
          = ( plus_plus @ nat @ M6 @ K3 ) ) ) ) ).

% nat_le_iff_add
thf(fact_376_ex__power__ivl1,axiom,
    ! [B2: nat,K: nat] :
      ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ B2 )
     => ( ( ord_less_eq @ nat @ ( one_one @ nat ) @ K )
       => ? [N: nat] :
            ( ( ord_less_eq @ nat @ ( power_power @ nat @ B2 @ N ) @ K )
            & ( ord_less @ nat @ K @ ( power_power @ nat @ B2 @ ( plus_plus @ nat @ N @ ( one_one @ nat ) ) ) ) ) ) ) ).

% ex_power_ivl1
thf(fact_377_ex__power__ivl2,axiom,
    ! [B2: nat,K: nat] :
      ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ B2 )
     => ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ K )
       => ? [N: nat] :
            ( ( ord_less @ nat @ ( power_power @ nat @ B2 @ N ) @ K )
            & ( ord_less_eq @ nat @ K @ ( power_power @ nat @ B2 @ ( plus_plus @ nat @ N @ ( one_one @ nat ) ) ) ) ) ) ) ).

% ex_power_ivl2
thf(fact_378_add__decreasing,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ C2 @ B2 )
           => ( ord_less_eq @ A @ ( plus_plus @ A @ A2 @ C2 ) @ B2 ) ) ) ) ).

% add_decreasing
thf(fact_379_add__increasing,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less_eq @ A @ B2 @ C2 )
           => ( ord_less_eq @ A @ B2 @ ( plus_plus @ A @ A2 @ C2 ) ) ) ) ) ).

% add_increasing
thf(fact_380_add__decreasing2,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less_eq @ A @ C2 @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ A2 @ B2 )
           => ( ord_less_eq @ A @ ( plus_plus @ A @ A2 @ C2 ) @ B2 ) ) ) ) ).

% add_decreasing2
thf(fact_381_add__increasing2,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
         => ( ( ord_less_eq @ A @ B2 @ A2 )
           => ( ord_less_eq @ A @ B2 @ ( plus_plus @ A @ A2 @ C2 ) ) ) ) ) ).

% add_increasing2
thf(fact_382_add__nonneg__nonneg,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 )
           => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( plus_plus @ A @ A2 @ B2 ) ) ) ) ) ).

% add_nonneg_nonneg
thf(fact_383_add__nonpos__nonpos,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ B2 @ ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ ( plus_plus @ A @ A2 @ B2 ) @ ( zero_zero @ A ) ) ) ) ) ).

% add_nonpos_nonpos
thf(fact_384_add__nonneg__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [X2: A,Y2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ Y2 )
           => ( ( ( plus_plus @ A @ X2 @ Y2 )
                = ( zero_zero @ A ) )
              = ( ( X2
                  = ( zero_zero @ A ) )
                & ( Y2
                  = ( zero_zero @ A ) ) ) ) ) ) ) ).

% add_nonneg_eq_0_iff
thf(fact_385_add__nonpos__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [X2: A,Y2: A] :
          ( ( ord_less_eq @ A @ X2 @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ Y2 @ ( zero_zero @ A ) )
           => ( ( ( plus_plus @ A @ X2 @ Y2 )
                = ( zero_zero @ A ) )
              = ( ( X2
                  = ( zero_zero @ A ) )
                & ( Y2
                  = ( zero_zero @ A ) ) ) ) ) ) ) ).

% add_nonpos_eq_0_iff
thf(fact_386_add__mono__thms__linordered__field_I4_J,axiom,
    ! [A: $tType] :
      ( ( ordere580206878836729694up_add @ A )
     => ! [I3: A,J: A,K: A,L: A] :
          ( ( ( ord_less_eq @ A @ I3 @ J )
            & ( ord_less @ A @ K @ L ) )
         => ( ord_less @ A @ ( plus_plus @ A @ I3 @ K ) @ ( plus_plus @ A @ J @ L ) ) ) ) ).

% add_mono_thms_linordered_field(4)
thf(fact_387_add__mono__thms__linordered__field_I3_J,axiom,
    ! [A: $tType] :
      ( ( ordere580206878836729694up_add @ A )
     => ! [I3: A,J: A,K: A,L: A] :
          ( ( ( ord_less @ A @ I3 @ J )
            & ( ord_less_eq @ A @ K @ L ) )
         => ( ord_less @ A @ ( plus_plus @ A @ I3 @ K ) @ ( plus_plus @ A @ J @ L ) ) ) ) ).

% add_mono_thms_linordered_field(3)
thf(fact_388_add__le__less__mono,axiom,
    ! [A: $tType] :
      ( ( ordere580206878836729694up_add @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less @ A @ C2 @ D2 )
           => ( ord_less @ A @ ( plus_plus @ A @ A2 @ C2 ) @ ( plus_plus @ A @ B2 @ D2 ) ) ) ) ) ).

% add_le_less_mono
thf(fact_389_add__less__le__mono,axiom,
    ! [A: $tType] :
      ( ( ordere580206878836729694up_add @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ C2 @ D2 )
           => ( ord_less @ A @ ( plus_plus @ A @ A2 @ C2 ) @ ( plus_plus @ A @ B2 @ D2 ) ) ) ) ) ).

% add_less_le_mono
thf(fact_390_add__neg__neg,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ B2 @ ( zero_zero @ A ) )
           => ( ord_less @ A @ ( plus_plus @ A @ A2 @ B2 ) @ ( zero_zero @ A ) ) ) ) ) ).

% add_neg_neg
thf(fact_391_add__pos__pos,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ B2 )
           => ( ord_less @ A @ ( zero_zero @ A ) @ ( plus_plus @ A @ A2 @ B2 ) ) ) ) ) ).

% add_pos_pos
thf(fact_392_canonically__ordered__monoid__add__class_OlessE,axiom,
    ! [A: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ~ ! [C3: A] :
                ( ( B2
                  = ( plus_plus @ A @ A2 @ C3 ) )
               => ( C3
                  = ( zero_zero @ A ) ) ) ) ) ).

% canonically_ordered_monoid_add_class.lessE
thf(fact_393_pos__add__strict,axiom,
    ! [A: $tType] :
      ( ( strict7427464778891057005id_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less @ A @ B2 @ C2 )
           => ( ord_less @ A @ B2 @ ( plus_plus @ A @ A2 @ C2 ) ) ) ) ) ).

% pos_add_strict
thf(fact_394_lift__Suc__mono__less,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [F2: nat > A,N2: nat,N5: nat] :
          ( ! [N: nat] : ( ord_less @ A @ ( F2 @ N ) @ ( F2 @ ( suc @ N ) ) )
         => ( ( ord_less @ nat @ N2 @ N5 )
           => ( ord_less @ A @ ( F2 @ N2 ) @ ( F2 @ N5 ) ) ) ) ) ).

% lift_Suc_mono_less
thf(fact_395_lift__Suc__mono__less__iff,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [F2: nat > A,N2: nat,M: nat] :
          ( ! [N: nat] : ( ord_less @ A @ ( F2 @ N ) @ ( F2 @ ( suc @ N ) ) )
         => ( ( ord_less @ A @ ( F2 @ N2 ) @ ( F2 @ M ) )
            = ( ord_less @ nat @ N2 @ M ) ) ) ) ).

% lift_Suc_mono_less_iff
thf(fact_396_lift__Suc__mono__le,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [F2: nat > A,N2: nat,N5: nat] :
          ( ! [N: nat] : ( ord_less_eq @ A @ ( F2 @ N ) @ ( F2 @ ( suc @ N ) ) )
         => ( ( ord_less_eq @ nat @ N2 @ N5 )
           => ( ord_less_eq @ A @ ( F2 @ N2 ) @ ( F2 @ N5 ) ) ) ) ) ).

% lift_Suc_mono_le
thf(fact_397_lift__Suc__antimono__le,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [F2: nat > A,N2: nat,N5: nat] :
          ( ! [N: nat] : ( ord_less_eq @ A @ ( F2 @ ( suc @ N ) ) @ ( F2 @ N ) )
         => ( ( ord_less_eq @ nat @ N2 @ N5 )
           => ( ord_less_eq @ A @ ( F2 @ N5 ) @ ( F2 @ N2 ) ) ) ) ) ).

% lift_Suc_antimono_le
thf(fact_398_Ex__less__Suc2,axiom,
    ! [N2: nat,P: nat > $o] :
      ( ( ? [I4: nat] :
            ( ( ord_less @ nat @ I4 @ ( suc @ N2 ) )
            & ( P @ I4 ) ) )
      = ( ( P @ ( zero_zero @ nat ) )
        | ? [I4: nat] :
            ( ( ord_less @ nat @ I4 @ N2 )
            & ( P @ ( suc @ I4 ) ) ) ) ) ).

% Ex_less_Suc2
thf(fact_399_gr0__conv__Suc,axiom,
    ! [N2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
      = ( ? [M6: nat] :
            ( N2
            = ( suc @ M6 ) ) ) ) ).

% gr0_conv_Suc
thf(fact_400_All__less__Suc2,axiom,
    ! [N2: nat,P: nat > $o] :
      ( ( ! [I4: nat] :
            ( ( ord_less @ nat @ I4 @ ( suc @ N2 ) )
           => ( P @ I4 ) ) )
      = ( ( P @ ( zero_zero @ nat ) )
        & ! [I4: nat] :
            ( ( ord_less @ nat @ I4 @ N2 )
           => ( P @ ( suc @ I4 ) ) ) ) ) ).

% All_less_Suc2
thf(fact_401_gr0__implies__Suc,axiom,
    ! [N2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ? [M3: nat] :
          ( N2
          = ( suc @ M3 ) ) ) ).

% gr0_implies_Suc
thf(fact_402_less__Suc__eq__0__disj,axiom,
    ! [M: nat,N2: nat] :
      ( ( ord_less @ nat @ M @ ( suc @ N2 ) )
      = ( ( M
          = ( zero_zero @ nat ) )
        | ? [J3: nat] :
            ( ( M
              = ( suc @ J3 ) )
            & ( ord_less @ nat @ J3 @ N2 ) ) ) ) ).

% less_Suc_eq_0_disj
thf(fact_403_Suc__leI,axiom,
    ! [M: nat,N2: nat] :
      ( ( ord_less @ nat @ M @ N2 )
     => ( ord_less_eq @ nat @ ( suc @ M ) @ N2 ) ) ).

% Suc_leI
thf(fact_404_Suc__le__eq,axiom,
    ! [M: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ ( suc @ M ) @ N2 )
      = ( ord_less @ nat @ M @ N2 ) ) ).

% Suc_le_eq
thf(fact_405_dec__induct,axiom,
    ! [I3: nat,J: nat,P: nat > $o] :
      ( ( ord_less_eq @ nat @ I3 @ J )
     => ( ( P @ I3 )
       => ( ! [N: nat] :
              ( ( ord_less_eq @ nat @ I3 @ N )
             => ( ( ord_less @ nat @ N @ J )
               => ( ( P @ N )
                 => ( P @ ( suc @ N ) ) ) ) )
         => ( P @ J ) ) ) ) ).

% dec_induct
thf(fact_406_inc__induct,axiom,
    ! [I3: nat,J: nat,P: nat > $o] :
      ( ( ord_less_eq @ nat @ I3 @ J )
     => ( ( P @ J )
       => ( ! [N: nat] :
              ( ( ord_less_eq @ nat @ I3 @ N )
             => ( ( ord_less @ nat @ N @ J )
               => ( ( P @ ( suc @ N ) )
                 => ( P @ N ) ) ) )
         => ( P @ I3 ) ) ) ) ).

% inc_induct
thf(fact_407_Suc__le__lessD,axiom,
    ! [M: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ ( suc @ M ) @ N2 )
     => ( ord_less @ nat @ M @ N2 ) ) ).

% Suc_le_lessD
thf(fact_408_le__less__Suc__eq,axiom,
    ! [M: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ M @ N2 )
     => ( ( ord_less @ nat @ N2 @ ( suc @ M ) )
        = ( N2 = M ) ) ) ).

% le_less_Suc_eq
thf(fact_409_less__Suc__eq__le,axiom,
    ! [M: nat,N2: nat] :
      ( ( ord_less @ nat @ M @ ( suc @ N2 ) )
      = ( ord_less_eq @ nat @ M @ N2 ) ) ).

% less_Suc_eq_le
thf(fact_410_less__eq__Suc__le,axiom,
    ( ( ord_less @ nat )
    = ( ^ [N3: nat] : ( ord_less_eq @ nat @ ( suc @ N3 ) ) ) ) ).

% less_eq_Suc_le
thf(fact_411_le__imp__less__Suc,axiom,
    ! [M: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ M @ N2 )
     => ( ord_less @ nat @ M @ ( suc @ N2 ) ) ) ).

% le_imp_less_Suc
thf(fact_412_add__is__1,axiom,
    ! [M: nat,N2: nat] :
      ( ( ( plus_plus @ nat @ M @ N2 )
        = ( suc @ ( zero_zero @ nat ) ) )
      = ( ( ( M
            = ( suc @ ( zero_zero @ nat ) ) )
          & ( N2
            = ( zero_zero @ nat ) ) )
        | ( ( M
            = ( zero_zero @ nat ) )
          & ( N2
            = ( suc @ ( zero_zero @ nat ) ) ) ) ) ) ).

% add_is_1
thf(fact_413_one__is__add,axiom,
    ! [M: nat,N2: nat] :
      ( ( ( suc @ ( zero_zero @ nat ) )
        = ( plus_plus @ nat @ M @ N2 ) )
      = ( ( ( M
            = ( suc @ ( zero_zero @ nat ) ) )
          & ( N2
            = ( zero_zero @ nat ) ) )
        | ( ( M
            = ( zero_zero @ nat ) )
          & ( N2
            = ( suc @ ( zero_zero @ nat ) ) ) ) ) ) ).

% one_is_add
thf(fact_414_ex__least__nat__le,axiom,
    ! [P: nat > $o,N2: nat] :
      ( ( P @ N2 )
     => ( ~ ( P @ ( zero_zero @ nat ) )
       => ? [K2: nat] :
            ( ( ord_less_eq @ nat @ K2 @ N2 )
            & ! [I: nat] :
                ( ( ord_less @ nat @ I @ K2 )
               => ~ ( P @ I ) )
            & ( P @ K2 ) ) ) ) ).

% ex_least_nat_le
thf(fact_415_less__natE,axiom,
    ! [M: nat,N2: nat] :
      ( ( ord_less @ nat @ M @ N2 )
     => ~ ! [Q2: nat] :
            ( N2
           != ( suc @ ( plus_plus @ nat @ M @ Q2 ) ) ) ) ).

% less_natE
thf(fact_416_less__add__Suc1,axiom,
    ! [I3: nat,M: nat] : ( ord_less @ nat @ I3 @ ( suc @ ( plus_plus @ nat @ I3 @ M ) ) ) ).

% less_add_Suc1
thf(fact_417_less__add__Suc2,axiom,
    ! [I3: nat,M: nat] : ( ord_less @ nat @ I3 @ ( suc @ ( plus_plus @ nat @ M @ I3 ) ) ) ).

% less_add_Suc2
thf(fact_418_less__iff__Suc__add,axiom,
    ( ( ord_less @ nat )
    = ( ^ [M6: nat,N3: nat] :
        ? [K3: nat] :
          ( N3
          = ( suc @ ( plus_plus @ nat @ M6 @ K3 ) ) ) ) ) ).

% less_iff_Suc_add
thf(fact_419_less__imp__Suc__add,axiom,
    ! [M: nat,N2: nat] :
      ( ( ord_less @ nat @ M @ N2 )
     => ? [K2: nat] :
          ( N2
          = ( suc @ ( plus_plus @ nat @ M @ K2 ) ) ) ) ).

% less_imp_Suc_add
thf(fact_420_less__imp__add__positive,axiom,
    ! [I3: nat,J: nat] :
      ( ( ord_less @ nat @ I3 @ J )
     => ? [K2: nat] :
          ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K2 )
          & ( ( plus_plus @ nat @ I3 @ K2 )
            = J ) ) ) ).

% less_imp_add_positive
thf(fact_421_mono__nat__linear__lb,axiom,
    ! [F2: nat > nat,M: nat,K: nat] :
      ( ! [M3: nat,N: nat] :
          ( ( ord_less @ nat @ M3 @ N )
         => ( ord_less @ nat @ ( F2 @ M3 ) @ ( F2 @ N ) ) )
     => ( ord_less_eq @ nat @ ( plus_plus @ nat @ ( F2 @ M ) @ K ) @ ( F2 @ ( plus_plus @ nat @ M @ K ) ) ) ) ).

% mono_nat_linear_lb
thf(fact_422_add__neg__nonpos,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ B2 @ ( zero_zero @ A ) )
           => ( ord_less @ A @ ( plus_plus @ A @ A2 @ B2 ) @ ( zero_zero @ A ) ) ) ) ) ).

% add_neg_nonpos
thf(fact_423_add__nonneg__pos,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ B2 )
           => ( ord_less @ A @ ( zero_zero @ A ) @ ( plus_plus @ A @ A2 @ B2 ) ) ) ) ) ).

% add_nonneg_pos
thf(fact_424_add__nonpos__neg,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ B2 @ ( zero_zero @ A ) )
           => ( ord_less @ A @ ( plus_plus @ A @ A2 @ B2 ) @ ( zero_zero @ A ) ) ) ) ) ).

% add_nonpos_neg
thf(fact_425_add__pos__nonneg,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 )
           => ( ord_less @ A @ ( zero_zero @ A ) @ ( plus_plus @ A @ A2 @ B2 ) ) ) ) ) ).

% add_pos_nonneg
thf(fact_426_add__strict__increasing,axiom,
    ! [A: $tType] :
      ( ( ordere8940638589300402666id_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less_eq @ A @ B2 @ C2 )
           => ( ord_less @ A @ B2 @ ( plus_plus @ A @ A2 @ C2 ) ) ) ) ) ).

% add_strict_increasing
thf(fact_427_add__strict__increasing2,axiom,
    ! [A: $tType] :
      ( ( ordere8940638589300402666id_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less @ A @ B2 @ C2 )
           => ( ord_less @ A @ B2 @ ( plus_plus @ A @ A2 @ C2 ) ) ) ) ) ).

% add_strict_increasing2
thf(fact_428_ex__least__nat__less,axiom,
    ! [P: nat > $o,N2: nat] :
      ( ( P @ N2 )
     => ( ~ ( P @ ( zero_zero @ nat ) )
       => ? [K2: nat] :
            ( ( ord_less @ nat @ K2 @ N2 )
            & ! [I: nat] :
                ( ( ord_less_eq @ nat @ I @ K2 )
               => ~ ( P @ I ) )
            & ( P @ ( suc @ K2 ) ) ) ) ) ).

% ex_least_nat_less
thf(fact_429_bits__1__div__2,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ( ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
        = ( zero_zero @ A ) ) ) ).

% bits_1_div_2
thf(fact_430_one__div__two__eq__zero,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ( ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
        = ( zero_zero @ A ) ) ) ).

% one_div_two_eq_zero
thf(fact_431_add__self__div__2,axiom,
    ! [M: nat] :
      ( ( divide_divide @ nat @ ( plus_plus @ nat @ M @ M ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
      = M ) ).

% add_self_div_2
thf(fact_432_div2__Suc__Suc,axiom,
    ! [M: nat] :
      ( ( divide_divide @ nat @ ( suc @ ( suc @ M ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
      = ( suc @ ( divide_divide @ nat @ M @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ).

% div2_Suc_Suc
thf(fact_433_divide__le__eq__1__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ ( divide_divide @ A @ B2 @ A2 ) @ ( one_one @ A ) )
            = ( ord_less_eq @ A @ A2 @ B2 ) ) ) ) ).

% divide_le_eq_1_neg
thf(fact_434_divide__le__eq__1__pos,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less_eq @ A @ ( divide_divide @ A @ B2 @ A2 ) @ ( one_one @ A ) )
            = ( ord_less_eq @ A @ B2 @ A2 ) ) ) ) ).

% divide_le_eq_1_pos
thf(fact_435_le__divide__eq__1__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ ( one_one @ A ) @ ( divide_divide @ A @ B2 @ A2 ) )
            = ( ord_less_eq @ A @ B2 @ A2 ) ) ) ) ).

% le_divide_eq_1_neg
thf(fact_436_le__divide__eq__1__pos,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less_eq @ A @ ( one_one @ A ) @ ( divide_divide @ A @ B2 @ A2 ) )
            = ( ord_less_eq @ A @ A2 @ B2 ) ) ) ) ).

% le_divide_eq_1_pos
thf(fact_437_divide__less__0__1__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( divide_divide @ A @ ( one_one @ A ) @ A2 ) @ ( zero_zero @ A ) )
          = ( ord_less @ A @ A2 @ ( zero_zero @ A ) ) ) ) ).

% divide_less_0_1_iff
thf(fact_438_divide__less__eq__1__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ ( divide_divide @ A @ B2 @ A2 ) @ ( one_one @ A ) )
            = ( ord_less @ A @ A2 @ B2 ) ) ) ) ).

% divide_less_eq_1_neg
thf(fact_439_divide__less__eq__1__pos,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less @ A @ ( divide_divide @ A @ B2 @ A2 ) @ ( one_one @ A ) )
            = ( ord_less @ A @ B2 @ A2 ) ) ) ) ).

% divide_less_eq_1_pos
thf(fact_440_less__divide__eq__1__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ ( one_one @ A ) @ ( divide_divide @ A @ B2 @ A2 ) )
            = ( ord_less @ A @ B2 @ A2 ) ) ) ) ).

% less_divide_eq_1_neg
thf(fact_441_division__ring__divide__zero,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A] :
          ( ( divide_divide @ A @ A2 @ ( zero_zero @ A ) )
          = ( zero_zero @ A ) ) ) ).

% division_ring_divide_zero
thf(fact_442_bits__div__by__0,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A] :
          ( ( divide_divide @ A @ A2 @ ( zero_zero @ A ) )
          = ( zero_zero @ A ) ) ) ).

% bits_div_by_0
thf(fact_443_bits__div__0,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A] :
          ( ( divide_divide @ A @ ( zero_zero @ A ) @ A2 )
          = ( zero_zero @ A ) ) ) ).

% bits_div_0
thf(fact_444_divide__cancel__right,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ( divide_divide @ A @ A2 @ C2 )
            = ( divide_divide @ A @ B2 @ C2 ) )
          = ( ( C2
              = ( zero_zero @ A ) )
            | ( A2 = B2 ) ) ) ) ).

% divide_cancel_right
thf(fact_445_divide__cancel__left,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ( divide_divide @ A @ C2 @ A2 )
            = ( divide_divide @ A @ C2 @ B2 ) )
          = ( ( C2
              = ( zero_zero @ A ) )
            | ( A2 = B2 ) ) ) ) ).

% divide_cancel_left
thf(fact_446_divide__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A2: A,B2: A] :
          ( ( ( divide_divide @ A @ A2 @ B2 )
            = ( zero_zero @ A ) )
          = ( ( A2
              = ( zero_zero @ A ) )
            | ( B2
              = ( zero_zero @ A ) ) ) ) ) ).

% divide_eq_0_iff
thf(fact_447_half__negative__int__iff,axiom,
    ! [K: int] :
      ( ( ord_less @ int @ ( divide_divide @ int @ K @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( zero_zero @ int ) )
      = ( ord_less @ int @ K @ ( zero_zero @ int ) ) ) ).

% half_negative_int_iff
thf(fact_448_half__nonnegative__int__iff,axiom,
    ! [K: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( divide_divide @ int @ K @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) )
      = ( ord_less_eq @ int @ ( zero_zero @ int ) @ K ) ) ).

% half_nonnegative_int_iff
thf(fact_449_bits__div__by__1,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A] :
          ( ( divide_divide @ A @ A2 @ ( one_one @ A ) )
          = A2 ) ) ).

% bits_div_by_1
thf(fact_450_zero__eq__1__divide__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A] :
          ( ( ( zero_zero @ A )
            = ( divide_divide @ A @ ( one_one @ A ) @ A2 ) )
          = ( A2
            = ( zero_zero @ A ) ) ) ) ).

% zero_eq_1_divide_iff
thf(fact_451_one__divide__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A] :
          ( ( ( divide_divide @ A @ ( one_one @ A ) @ A2 )
            = ( zero_zero @ A ) )
          = ( A2
            = ( zero_zero @ A ) ) ) ) ).

% one_divide_eq_0_iff
thf(fact_452_eq__divide__eq__1,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,A2: A] :
          ( ( ( one_one @ A )
            = ( divide_divide @ A @ B2 @ A2 ) )
          = ( ( A2
             != ( zero_zero @ A ) )
            & ( A2 = B2 ) ) ) ) ).

% eq_divide_eq_1
thf(fact_453_divide__eq__eq__1,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,A2: A] :
          ( ( ( divide_divide @ A @ B2 @ A2 )
            = ( one_one @ A ) )
          = ( ( A2
             != ( zero_zero @ A ) )
            & ( A2 = B2 ) ) ) ) ).

% divide_eq_eq_1
thf(fact_454_divide__self__if,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A] :
          ( ( ( A2
              = ( zero_zero @ A ) )
           => ( ( divide_divide @ A @ A2 @ A2 )
              = ( zero_zero @ A ) ) )
          & ( ( A2
             != ( zero_zero @ A ) )
           => ( ( divide_divide @ A @ A2 @ A2 )
              = ( one_one @ A ) ) ) ) ) ).

% divide_self_if
thf(fact_455_divide__self,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ A2 @ A2 )
            = ( one_one @ A ) ) ) ) ).

% divide_self
thf(fact_456_one__eq__divide__iff,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A2: A,B2: A] :
          ( ( ( one_one @ A )
            = ( divide_divide @ A @ A2 @ B2 ) )
          = ( ( B2
             != ( zero_zero @ A ) )
            & ( A2 = B2 ) ) ) ) ).

% one_eq_divide_iff
thf(fact_457_divide__eq__1__iff,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A2: A,B2: A] :
          ( ( ( divide_divide @ A @ A2 @ B2 )
            = ( one_one @ A ) )
          = ( ( B2
             != ( zero_zero @ A ) )
            & ( A2 = B2 ) ) ) ) ).

% divide_eq_1_iff
thf(fact_458_div__by__Suc__0,axiom,
    ! [M: nat] :
      ( ( divide_divide @ nat @ M @ ( suc @ ( zero_zero @ nat ) ) )
      = M ) ).

% div_by_Suc_0
thf(fact_459_div__less,axiom,
    ! [M: nat,N2: nat] :
      ( ( ord_less @ nat @ M @ N2 )
     => ( ( divide_divide @ nat @ M @ N2 )
        = ( zero_zero @ nat ) ) ) ).

% div_less
thf(fact_460_zero__le__divide__1__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( divide_divide @ A @ ( one_one @ A ) @ A2 ) )
          = ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 ) ) ) ).

% zero_le_divide_1_iff
thf(fact_461_divide__le__0__1__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ ( divide_divide @ A @ ( one_one @ A ) @ A2 ) @ ( zero_zero @ A ) )
          = ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) ) ) ) ).

% divide_le_0_1_iff
thf(fact_462_zero__less__divide__1__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( divide_divide @ A @ ( one_one @ A ) @ A2 ) )
          = ( ord_less @ A @ ( zero_zero @ A ) @ A2 ) ) ) ).

% zero_less_divide_1_iff
thf(fact_463_less__divide__eq__1__pos,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less @ A @ ( one_one @ A ) @ ( divide_divide @ A @ B2 @ A2 ) )
            = ( ord_less @ A @ A2 @ B2 ) ) ) ) ).

% less_divide_eq_1_pos
thf(fact_464_linordered__field__no__ub,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A] :
        ? [X_12: A] : ( ord_less @ A @ X @ X_12 ) ) ).

% linordered_field_no_ub
thf(fact_465_linordered__field__no__lb,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A] :
        ? [Y4: A] : ( ord_less @ A @ Y4 @ X ) ) ).

% linordered_field_no_lb
thf(fact_466_num_Osize_I4_J,axiom,
    ( ( size_size @ num @ one2 )
    = ( zero_zero @ nat ) ) ).

% num.size(4)
thf(fact_467_not__exp__less__eq__0__int,axiom,
    ! [N2: nat] :
      ~ ( ord_less_eq @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N2 ) @ ( zero_zero @ int ) ) ).

% not_exp_less_eq_0_int
thf(fact_468_add__divide__distrib,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( divide_divide @ A @ ( plus_plus @ A @ A2 @ B2 ) @ C2 )
          = ( plus_plus @ A @ ( divide_divide @ A @ A2 @ C2 ) @ ( divide_divide @ A @ B2 @ C2 ) ) ) ) ).

% add_divide_distrib
thf(fact_469_div__le__dividend,axiom,
    ! [M: nat,N2: nat] : ( ord_less_eq @ nat @ ( divide_divide @ nat @ M @ N2 ) @ M ) ).

% div_le_dividend
thf(fact_470_div__le__mono,axiom,
    ! [M: nat,N2: nat,K: nat] :
      ( ( ord_less_eq @ nat @ M @ N2 )
     => ( ord_less_eq @ nat @ ( divide_divide @ nat @ M @ K ) @ ( divide_divide @ nat @ N2 @ K ) ) ) ).

% div_le_mono
thf(fact_471_num_Osize_I5_J,axiom,
    ! [X22: num] :
      ( ( size_size @ num @ ( bit0 @ X22 ) )
      = ( plus_plus @ nat @ ( size_size @ num @ X22 ) @ ( suc @ ( zero_zero @ nat ) ) ) ) ).

% num.size(5)
thf(fact_472_divide__right__mono__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ C2 @ ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ ( divide_divide @ A @ B2 @ C2 ) @ ( divide_divide @ A @ A2 @ C2 ) ) ) ) ) ).

% divide_right_mono_neg
thf(fact_473_divide__nonpos__nonpos,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X2: A,Y2: A] :
          ( ( ord_less_eq @ A @ X2 @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ Y2 @ ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( divide_divide @ A @ X2 @ Y2 ) ) ) ) ) ).

% divide_nonpos_nonpos
thf(fact_474_divide__nonpos__nonneg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X2: A,Y2: A] :
          ( ( ord_less_eq @ A @ X2 @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ Y2 )
           => ( ord_less_eq @ A @ ( divide_divide @ A @ X2 @ Y2 ) @ ( zero_zero @ A ) ) ) ) ) ).

% divide_nonpos_nonneg
thf(fact_475_divide__nonneg__nonpos,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X2: A,Y2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X2 )
         => ( ( ord_less_eq @ A @ Y2 @ ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ ( divide_divide @ A @ X2 @ Y2 ) @ ( zero_zero @ A ) ) ) ) ) ).

% divide_nonneg_nonpos
thf(fact_476_divide__nonneg__nonneg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X2: A,Y2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ Y2 )
           => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( divide_divide @ A @ X2 @ Y2 ) ) ) ) ) ).

% divide_nonneg_nonneg
thf(fact_477_zero__le__divide__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( divide_divide @ A @ A2 @ B2 ) )
          = ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
              & ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 ) )
            | ( ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) )
              & ( ord_less_eq @ A @ B2 @ ( zero_zero @ A ) ) ) ) ) ) ).

% zero_le_divide_iff
thf(fact_478_divide__right__mono,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
           => ( ord_less_eq @ A @ ( divide_divide @ A @ A2 @ C2 ) @ ( divide_divide @ A @ B2 @ C2 ) ) ) ) ) ).

% divide_right_mono
thf(fact_479_divide__le__0__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( divide_divide @ A @ A2 @ B2 ) @ ( zero_zero @ A ) )
          = ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
              & ( ord_less_eq @ A @ B2 @ ( zero_zero @ A ) ) )
            | ( ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) )
              & ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 ) ) ) ) ) ).

% divide_le_0_iff
thf(fact_480_divide__strict__right__mono__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( ord_less @ A @ B2 @ A2 )
         => ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
           => ( ord_less @ A @ ( divide_divide @ A @ A2 @ C2 ) @ ( divide_divide @ A @ B2 @ C2 ) ) ) ) ) ).

% divide_strict_right_mono_neg
thf(fact_481_divide__strict__right__mono,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
           => ( ord_less @ A @ ( divide_divide @ A @ A2 @ C2 ) @ ( divide_divide @ A @ B2 @ C2 ) ) ) ) ) ).

% divide_strict_right_mono
thf(fact_482_zero__less__divide__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( divide_divide @ A @ A2 @ B2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
              & ( ord_less @ A @ ( zero_zero @ A ) @ B2 ) )
            | ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
              & ( ord_less @ A @ B2 @ ( zero_zero @ A ) ) ) ) ) ) ).

% zero_less_divide_iff
thf(fact_483_divide__less__cancel,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ord_less @ A @ ( divide_divide @ A @ A2 @ C2 ) @ ( divide_divide @ A @ B2 @ C2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less @ A @ A2 @ B2 ) )
            & ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
             => ( ord_less @ A @ B2 @ A2 ) )
            & ( C2
             != ( zero_zero @ A ) ) ) ) ) ).

% divide_less_cancel
thf(fact_484_divide__less__0__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( divide_divide @ A @ A2 @ B2 ) @ ( zero_zero @ A ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
              & ( ord_less @ A @ B2 @ ( zero_zero @ A ) ) )
            | ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
              & ( ord_less @ A @ ( zero_zero @ A ) @ B2 ) ) ) ) ) ).

% divide_less_0_iff
thf(fact_485_divide__pos__pos,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X2: A,Y2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ X2 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ Y2 )
           => ( ord_less @ A @ ( zero_zero @ A ) @ ( divide_divide @ A @ X2 @ Y2 ) ) ) ) ) ).

% divide_pos_pos
thf(fact_486_divide__pos__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X2: A,Y2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ X2 )
         => ( ( ord_less @ A @ Y2 @ ( zero_zero @ A ) )
           => ( ord_less @ A @ ( divide_divide @ A @ X2 @ Y2 ) @ ( zero_zero @ A ) ) ) ) ) ).

% divide_pos_neg
thf(fact_487_divide__neg__pos,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X2: A,Y2: A] :
          ( ( ord_less @ A @ X2 @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ Y2 )
           => ( ord_less @ A @ ( divide_divide @ A @ X2 @ Y2 ) @ ( zero_zero @ A ) ) ) ) ) ).

% divide_neg_pos
thf(fact_488_divide__neg__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X2: A,Y2: A] :
          ( ( ord_less @ A @ X2 @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ Y2 @ ( zero_zero @ A ) )
           => ( ord_less @ A @ ( zero_zero @ A ) @ ( divide_divide @ A @ X2 @ Y2 ) ) ) ) ) ).

% divide_neg_neg
thf(fact_489_right__inverse__eq,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [B2: A,A2: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( ( divide_divide @ A @ A2 @ B2 )
              = ( one_one @ A ) )
            = ( A2 = B2 ) ) ) ) ).

% right_inverse_eq
thf(fact_490_Euclidean__Division_Odiv__eq__0__iff,axiom,
    ! [M: nat,N2: nat] :
      ( ( ( divide_divide @ nat @ M @ N2 )
        = ( zero_zero @ nat ) )
      = ( ( ord_less @ nat @ M @ N2 )
        | ( N2
          = ( zero_zero @ nat ) ) ) ) ).

% Euclidean_Division.div_eq_0_iff
thf(fact_491_Suc__div__le__mono,axiom,
    ! [M: nat,N2: nat] : ( ord_less_eq @ nat @ ( divide_divide @ nat @ M @ N2 ) @ ( divide_divide @ nat @ ( suc @ M ) @ N2 ) ) ).

% Suc_div_le_mono
thf(fact_492_field__le__epsilon,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X2: A,Y2: A] :
          ( ! [E: A] :
              ( ( ord_less @ A @ ( zero_zero @ A ) @ E )
             => ( ord_less_eq @ A @ X2 @ ( plus_plus @ A @ Y2 @ E ) ) )
         => ( ord_less_eq @ A @ X2 @ Y2 ) ) ) ).

% field_le_epsilon
thf(fact_493_divide__nonpos__pos,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X2: A,Y2: A] :
          ( ( ord_less_eq @ A @ X2 @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ Y2 )
           => ( ord_less_eq @ A @ ( divide_divide @ A @ X2 @ Y2 ) @ ( zero_zero @ A ) ) ) ) ) ).

% divide_nonpos_pos
thf(fact_494_divide__nonpos__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X2: A,Y2: A] :
          ( ( ord_less_eq @ A @ X2 @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ Y2 @ ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( divide_divide @ A @ X2 @ Y2 ) ) ) ) ) ).

% divide_nonpos_neg
thf(fact_495_divide__nonneg__pos,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X2: A,Y2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X2 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ Y2 )
           => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( divide_divide @ A @ X2 @ Y2 ) ) ) ) ) ).

% divide_nonneg_pos
thf(fact_496_divide__nonneg__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X2: A,Y2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X2 )
         => ( ( ord_less @ A @ Y2 @ ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ ( divide_divide @ A @ X2 @ Y2 ) @ ( zero_zero @ A ) ) ) ) ) ).

% divide_nonneg_neg
thf(fact_497_divide__le__cancel,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( divide_divide @ A @ A2 @ C2 ) @ ( divide_divide @ A @ B2 @ C2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less_eq @ A @ A2 @ B2 ) )
            & ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
             => ( ord_less_eq @ A @ B2 @ A2 ) ) ) ) ) ).

% divide_le_cancel
thf(fact_498_frac__less2,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X2: A,Y2: A,W: A,Z: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ X2 )
         => ( ( ord_less_eq @ A @ X2 @ Y2 )
           => ( ( ord_less @ A @ ( zero_zero @ A ) @ W )
             => ( ( ord_less @ A @ W @ Z )
               => ( ord_less @ A @ ( divide_divide @ A @ X2 @ Z ) @ ( divide_divide @ A @ Y2 @ W ) ) ) ) ) ) ) ).

% frac_less2
thf(fact_499_frac__less,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X2: A,Y2: A,W: A,Z: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X2 )
         => ( ( ord_less @ A @ X2 @ Y2 )
           => ( ( ord_less @ A @ ( zero_zero @ A ) @ W )
             => ( ( ord_less_eq @ A @ W @ Z )
               => ( ord_less @ A @ ( divide_divide @ A @ X2 @ Z ) @ ( divide_divide @ A @ Y2 @ W ) ) ) ) ) ) ) ).

% frac_less
thf(fact_500_frac__le,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [Y2: A,X2: A,W: A,Z: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ Y2 )
         => ( ( ord_less_eq @ A @ X2 @ Y2 )
           => ( ( ord_less @ A @ ( zero_zero @ A ) @ W )
             => ( ( ord_less_eq @ A @ W @ Z )
               => ( ord_less_eq @ A @ ( divide_divide @ A @ X2 @ Z ) @ ( divide_divide @ A @ Y2 @ W ) ) ) ) ) ) ) ).

% frac_le
thf(fact_501_less__divide__eq__1,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less @ A @ ( one_one @ A ) @ ( divide_divide @ A @ B2 @ A2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
              & ( ord_less @ A @ A2 @ B2 ) )
            | ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
              & ( ord_less @ A @ B2 @ A2 ) ) ) ) ) ).

% less_divide_eq_1
thf(fact_502_divide__less__eq__1,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less @ A @ ( divide_divide @ A @ B2 @ A2 ) @ ( one_one @ A ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
              & ( ord_less @ A @ B2 @ A2 ) )
            | ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
              & ( ord_less @ A @ A2 @ B2 ) )
            | ( A2
              = ( zero_zero @ A ) ) ) ) ) ).

% divide_less_eq_1
thf(fact_503_div__add__self2,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [B2: A,A2: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ ( plus_plus @ A @ A2 @ B2 ) @ B2 )
            = ( plus_plus @ A @ ( divide_divide @ A @ A2 @ B2 ) @ ( one_one @ A ) ) ) ) ) ).

% div_add_self2
thf(fact_504_div__add__self1,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [B2: A,A2: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ ( plus_plus @ A @ B2 @ A2 ) @ B2 )
            = ( plus_plus @ A @ ( divide_divide @ A @ A2 @ B2 ) @ ( one_one @ A ) ) ) ) ) ).

% div_add_self1
thf(fact_505_less__half__sum,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ord_less @ A @ A2 @ ( divide_divide @ A @ ( plus_plus @ A @ A2 @ B2 ) @ ( plus_plus @ A @ ( one_one @ A ) @ ( one_one @ A ) ) ) ) ) ) ).

% less_half_sum
thf(fact_506_gt__half__sum,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ord_less @ A @ ( divide_divide @ A @ ( plus_plus @ A @ A2 @ B2 ) @ ( plus_plus @ A @ ( one_one @ A ) @ ( one_one @ A ) ) ) @ B2 ) ) ) ).

% gt_half_sum
thf(fact_507_numeral__Bit0__div__2,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [N2: num] :
          ( ( divide_divide @ A @ ( numeral_numeral @ A @ ( bit0 @ N2 ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
          = ( numeral_numeral @ A @ N2 ) ) ) ).

% numeral_Bit0_div_2
thf(fact_508_div__greater__zero__iff,axiom,
    ! [M: nat,N2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( divide_divide @ nat @ M @ N2 ) )
      = ( ( ord_less_eq @ nat @ N2 @ M )
        & ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 ) ) ) ).

% div_greater_zero_iff
thf(fact_509_div__le__mono2,axiom,
    ! [M: nat,N2: nat,K: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M )
     => ( ( ord_less_eq @ nat @ M @ N2 )
       => ( ord_less_eq @ nat @ ( divide_divide @ nat @ K @ N2 ) @ ( divide_divide @ nat @ K @ M ) ) ) ) ).

% div_le_mono2
thf(fact_510_div__eq__dividend__iff,axiom,
    ! [M: nat,N2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M )
     => ( ( ( divide_divide @ nat @ M @ N2 )
          = M )
        = ( N2
          = ( one_one @ nat ) ) ) ) ).

% div_eq_dividend_iff
thf(fact_511_div__less__dividend,axiom,
    ! [N2: nat,M: nat] :
      ( ( ord_less @ nat @ ( one_one @ nat ) @ N2 )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M )
       => ( ord_less @ nat @ ( divide_divide @ nat @ M @ N2 ) @ M ) ) ) ).

% div_less_dividend
thf(fact_512_le__divide__eq__1,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less_eq @ A @ ( one_one @ A ) @ ( divide_divide @ A @ B2 @ A2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
              & ( ord_less_eq @ A @ A2 @ B2 ) )
            | ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
              & ( ord_less_eq @ A @ B2 @ A2 ) ) ) ) ) ).

% le_divide_eq_1
thf(fact_513_divide__le__eq__1,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less_eq @ A @ ( divide_divide @ A @ B2 @ A2 ) @ ( one_one @ A ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
              & ( ord_less_eq @ A @ B2 @ A2 ) )
            | ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
              & ( ord_less_eq @ A @ A2 @ B2 ) )
            | ( A2
              = ( zero_zero @ A ) ) ) ) ) ).

% divide_le_eq_1
thf(fact_514_exp__add__not__zero__imp__right,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [M: nat,N2: nat] :
          ( ( ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( plus_plus @ nat @ M @ N2 ) )
           != ( zero_zero @ A ) )
         => ( ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N2 )
           != ( zero_zero @ A ) ) ) ) ).

% exp_add_not_zero_imp_right
thf(fact_515_exp__add__not__zero__imp__left,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [M: nat,N2: nat] :
          ( ( ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( plus_plus @ nat @ M @ N2 ) )
           != ( zero_zero @ A ) )
         => ( ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M )
           != ( zero_zero @ A ) ) ) ) ).

% exp_add_not_zero_imp_left
thf(fact_516_div__exp__eq,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A,M: nat,N2: nat] :
          ( ( divide_divide @ A @ ( divide_divide @ A @ A2 @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M ) ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N2 ) )
          = ( divide_divide @ A @ A2 @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( plus_plus @ nat @ M @ N2 ) ) ) ) ) ).

% div_exp_eq
thf(fact_517_Suc__n__div__2__gt__zero,axiom,
    ! [N2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ord_less @ nat @ ( zero_zero @ nat ) @ ( divide_divide @ nat @ ( suc @ N2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ).

% Suc_n_div_2_gt_zero
thf(fact_518_div__2__gt__zero,axiom,
    ! [N2: nat] :
      ( ( ord_less @ nat @ ( suc @ ( zero_zero @ nat ) ) @ N2 )
     => ( ord_less @ nat @ ( zero_zero @ nat ) @ ( divide_divide @ nat @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ).

% div_2_gt_zero
thf(fact_519_semiring__norm_I76_J,axiom,
    ! [N2: num] : ( ord_less @ num @ one2 @ ( bit0 @ N2 ) ) ).

% semiring_norm(76)
thf(fact_520_semiring__norm_I69_J,axiom,
    ! [M: num] :
      ~ ( ord_less_eq @ num @ ( bit0 @ M ) @ one2 ) ).

% semiring_norm(69)
thf(fact_521_semiring__norm_I2_J,axiom,
    ( ( plus_plus @ num @ one2 @ one2 )
    = ( bit0 @ one2 ) ) ).

% semiring_norm(2)
thf(fact_522_div__self,axiom,
    ! [A: $tType] :
      ( ( semidom_divide @ A )
     => ! [A2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ A2 @ A2 )
            = ( one_one @ A ) ) ) ) ).

% div_self
thf(fact_523_vebt__insert_Osimps_I4_J,axiom,
    ! [V: nat,TreeList: list @ vEBT_VEBT,Summary: vEBT_VEBT,X2: nat] :
      ( ( vEBT_vebt_insert @ ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ ( suc @ V ) ) @ TreeList @ Summary ) @ X2 )
      = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ X2 @ X2 ) ) @ ( suc @ ( suc @ V ) ) @ TreeList @ Summary ) ) ).

% vebt_insert.simps(4)
thf(fact_524_nat__induct2,axiom,
    ! [P: nat > $o,N2: nat] :
      ( ( P @ ( zero_zero @ nat ) )
     => ( ( P @ ( one_one @ nat ) )
       => ( ! [N: nat] :
              ( ( P @ N )
             => ( P @ ( plus_plus @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
         => ( P @ N2 ) ) ) ) ).

% nat_induct2
thf(fact_525_field__less__half__sum,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X2: A,Y2: A] :
          ( ( ord_less @ A @ X2 @ Y2 )
         => ( ord_less @ A @ X2 @ ( divide_divide @ A @ ( plus_plus @ A @ X2 @ Y2 ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ).

% field_less_half_sum
thf(fact_526_bit__concat__def,axiom,
    ( vEBT_VEBT_bit_concat
    = ( ^ [H: nat,L2: nat,D3: nat] : ( plus_plus @ nat @ ( times_times @ nat @ H @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ D3 ) ) @ L2 ) ) ) ).

% bit_concat_def
thf(fact_527_low__inv,axiom,
    ! [X2: nat,N2: nat,Y2: nat] :
      ( ( ord_less @ nat @ X2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) )
     => ( ( vEBT_VEBT_low @ ( plus_plus @ nat @ ( times_times @ nat @ Y2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) @ X2 ) @ N2 )
        = X2 ) ) ).

% low_inv
thf(fact_528_high__inv,axiom,
    ! [X2: nat,N2: nat,Y2: nat] :
      ( ( ord_less @ nat @ X2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) )
     => ( ( vEBT_VEBT_high @ ( plus_plus @ nat @ ( times_times @ nat @ Y2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) @ X2 ) @ N2 )
        = Y2 ) ) ).

% high_inv
thf(fact_529_semiring__norm_I75_J,axiom,
    ! [M: num] :
      ~ ( ord_less @ num @ M @ one2 ) ).

% semiring_norm(75)
thf(fact_530_semiring__norm_I87_J,axiom,
    ! [M: num,N2: num] :
      ( ( ( bit0 @ M )
        = ( bit0 @ N2 ) )
      = ( M = N2 ) ) ).

% semiring_norm(87)
thf(fact_531_mult__zero__left,axiom,
    ! [A: $tType] :
      ( ( mult_zero @ A )
     => ! [A2: A] :
          ( ( times_times @ A @ ( zero_zero @ A ) @ A2 )
          = ( zero_zero @ A ) ) ) ).

% mult_zero_left
thf(fact_532_mult__zero__right,axiom,
    ! [A: $tType] :
      ( ( mult_zero @ A )
     => ! [A2: A] :
          ( ( times_times @ A @ A2 @ ( zero_zero @ A ) )
          = ( zero_zero @ A ) ) ) ).

% mult_zero_right
thf(fact_533_mult__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( semiri3467727345109120633visors @ A )
     => ! [A2: A,B2: A] :
          ( ( ( times_times @ A @ A2 @ B2 )
            = ( zero_zero @ A ) )
          = ( ( A2
              = ( zero_zero @ A ) )
            | ( B2
              = ( zero_zero @ A ) ) ) ) ) ).

% mult_eq_0_iff
thf(fact_534_mult__cancel__left,axiom,
    ! [A: $tType] :
      ( ( semiri6575147826004484403cancel @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ( times_times @ A @ C2 @ A2 )
            = ( times_times @ A @ C2 @ B2 ) )
          = ( ( C2
              = ( zero_zero @ A ) )
            | ( A2 = B2 ) ) ) ) ).

% mult_cancel_left
thf(fact_535_mult__cancel__right,axiom,
    ! [A: $tType] :
      ( ( semiri6575147826004484403cancel @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ( times_times @ A @ A2 @ C2 )
            = ( times_times @ A @ B2 @ C2 ) )
          = ( ( C2
              = ( zero_zero @ A ) )
            | ( A2 = B2 ) ) ) ) ).

% mult_cancel_right
thf(fact_536_mult__numeral__left__semiring__numeral,axiom,
    ! [A: $tType] :
      ( ( semiring_numeral @ A )
     => ! [V: num,W: num,Z: A] :
          ( ( times_times @ A @ ( numeral_numeral @ A @ V ) @ ( times_times @ A @ ( numeral_numeral @ A @ W ) @ Z ) )
          = ( times_times @ A @ ( numeral_numeral @ A @ ( times_times @ num @ V @ W ) ) @ Z ) ) ) ).

% mult_numeral_left_semiring_numeral
thf(fact_537_numeral__times__numeral,axiom,
    ! [A: $tType] :
      ( ( semiring_numeral @ A )
     => ! [M: num,N2: num] :
          ( ( times_times @ A @ ( numeral_numeral @ A @ M ) @ ( numeral_numeral @ A @ N2 ) )
          = ( numeral_numeral @ A @ ( times_times @ num @ M @ N2 ) ) ) ) ).

% numeral_times_numeral
thf(fact_538_div__0,axiom,
    ! [A: $tType] :
      ( ( semidom_divide @ A )
     => ! [A2: A] :
          ( ( divide_divide @ A @ ( zero_zero @ A ) @ A2 )
          = ( zero_zero @ A ) ) ) ).

% div_0
thf(fact_539_div__by__0,axiom,
    ! [A: $tType] :
      ( ( semidom_divide @ A )
     => ! [A2: A] :
          ( ( divide_divide @ A @ A2 @ ( zero_zero @ A ) )
          = ( zero_zero @ A ) ) ) ).

% div_by_0
thf(fact_540_mult_Oright__neutral,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [A2: A] :
          ( ( times_times @ A @ A2 @ ( one_one @ A ) )
          = A2 ) ) ).

% mult.right_neutral
thf(fact_541_mult__1,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [A2: A] :
          ( ( times_times @ A @ ( one_one @ A ) @ A2 )
          = A2 ) ) ).

% mult_1
thf(fact_542_semiring__norm_I85_J,axiom,
    ! [M: num] :
      ( ( bit0 @ M )
     != one2 ) ).

% semiring_norm(85)
thf(fact_543_semiring__norm_I83_J,axiom,
    ! [N2: num] :
      ( one2
     != ( bit0 @ N2 ) ) ).

% semiring_norm(83)
thf(fact_544_times__divide__eq__left,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( times_times @ A @ ( divide_divide @ A @ B2 @ C2 ) @ A2 )
          = ( divide_divide @ A @ ( times_times @ A @ B2 @ A2 ) @ C2 ) ) ) ).

% times_divide_eq_left
thf(fact_545_divide__divide__eq__left,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( divide_divide @ A @ ( divide_divide @ A @ A2 @ B2 ) @ C2 )
          = ( divide_divide @ A @ A2 @ ( times_times @ A @ B2 @ C2 ) ) ) ) ).

% divide_divide_eq_left
thf(fact_546_divide__divide__eq__right,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( divide_divide @ A @ A2 @ ( divide_divide @ A @ B2 @ C2 ) )
          = ( divide_divide @ A @ ( times_times @ A @ A2 @ C2 ) @ B2 ) ) ) ).

% divide_divide_eq_right
thf(fact_547_times__divide__eq__right,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( times_times @ A @ A2 @ ( divide_divide @ A @ B2 @ C2 ) )
          = ( divide_divide @ A @ ( times_times @ A @ A2 @ B2 ) @ C2 ) ) ) ).

% times_divide_eq_right
thf(fact_548_div__by__1,axiom,
    ! [A: $tType] :
      ( ( semidom_divide @ A )
     => ! [A2: A] :
          ( ( divide_divide @ A @ A2 @ ( one_one @ A ) )
          = A2 ) ) ).

% div_by_1
thf(fact_549_mult__is__0,axiom,
    ! [M: nat,N2: nat] :
      ( ( ( times_times @ nat @ M @ N2 )
        = ( zero_zero @ nat ) )
      = ( ( M
          = ( zero_zero @ nat ) )
        | ( N2
          = ( zero_zero @ nat ) ) ) ) ).

% mult_is_0
thf(fact_550_mult__0__right,axiom,
    ! [M: nat] :
      ( ( times_times @ nat @ M @ ( zero_zero @ nat ) )
      = ( zero_zero @ nat ) ) ).

% mult_0_right
thf(fact_551_mult__cancel1,axiom,
    ! [K: nat,M: nat,N2: nat] :
      ( ( ( times_times @ nat @ K @ M )
        = ( times_times @ nat @ K @ N2 ) )
      = ( ( M = N2 )
        | ( K
          = ( zero_zero @ nat ) ) ) ) ).

% mult_cancel1
thf(fact_552_mult__cancel2,axiom,
    ! [M: nat,K: nat,N2: nat] :
      ( ( ( times_times @ nat @ M @ K )
        = ( times_times @ nat @ N2 @ K ) )
      = ( ( M = N2 )
        | ( K
          = ( zero_zero @ nat ) ) ) ) ).

% mult_cancel2
thf(fact_553_nat__1__eq__mult__iff,axiom,
    ! [M: nat,N2: nat] :
      ( ( ( one_one @ nat )
        = ( times_times @ nat @ M @ N2 ) )
      = ( ( M
          = ( one_one @ nat ) )
        & ( N2
          = ( one_one @ nat ) ) ) ) ).

% nat_1_eq_mult_iff
thf(fact_554_nat__mult__eq__1__iff,axiom,
    ! [M: nat,N2: nat] :
      ( ( ( times_times @ nat @ M @ N2 )
        = ( one_one @ nat ) )
      = ( ( M
          = ( one_one @ nat ) )
        & ( N2
          = ( one_one @ nat ) ) ) ) ).

% nat_mult_eq_1_iff
thf(fact_555_semiring__norm_I6_J,axiom,
    ! [M: num,N2: num] :
      ( ( plus_plus @ num @ ( bit0 @ M ) @ ( bit0 @ N2 ) )
      = ( bit0 @ ( plus_plus @ num @ M @ N2 ) ) ) ).

% semiring_norm(6)
thf(fact_556_semiring__norm_I71_J,axiom,
    ! [M: num,N2: num] :
      ( ( ord_less_eq @ num @ ( bit0 @ M ) @ ( bit0 @ N2 ) )
      = ( ord_less_eq @ num @ M @ N2 ) ) ).

% semiring_norm(71)
thf(fact_557_semiring__norm_I78_J,axiom,
    ! [M: num,N2: num] :
      ( ( ord_less @ num @ ( bit0 @ M ) @ ( bit0 @ N2 ) )
      = ( ord_less @ num @ M @ N2 ) ) ).

% semiring_norm(78)
thf(fact_558_semiring__norm_I68_J,axiom,
    ! [N2: num] : ( ord_less_eq @ num @ one2 @ N2 ) ).

% semiring_norm(68)
thf(fact_559_mult__cancel__left1,axiom,
    ! [A: $tType] :
      ( ( ring_15535105094025558882visors @ A )
     => ! [C2: A,B2: A] :
          ( ( C2
            = ( times_times @ A @ C2 @ B2 ) )
          = ( ( C2
              = ( zero_zero @ A ) )
            | ( B2
              = ( one_one @ A ) ) ) ) ) ).

% mult_cancel_left1
thf(fact_560_mult__cancel__left2,axiom,
    ! [A: $tType] :
      ( ( ring_15535105094025558882visors @ A )
     => ! [C2: A,A2: A] :
          ( ( ( times_times @ A @ C2 @ A2 )
            = C2 )
          = ( ( C2
              = ( zero_zero @ A ) )
            | ( A2
              = ( one_one @ A ) ) ) ) ) ).

% mult_cancel_left2
thf(fact_561_mult__cancel__right1,axiom,
    ! [A: $tType] :
      ( ( ring_15535105094025558882visors @ A )
     => ! [C2: A,B2: A] :
          ( ( C2
            = ( times_times @ A @ B2 @ C2 ) )
          = ( ( C2
              = ( zero_zero @ A ) )
            | ( B2
              = ( one_one @ A ) ) ) ) ) ).

% mult_cancel_right1
thf(fact_562_mult__cancel__right2,axiom,
    ! [A: $tType] :
      ( ( ring_15535105094025558882visors @ A )
     => ! [A2: A,C2: A] :
          ( ( ( times_times @ A @ A2 @ C2 )
            = C2 )
          = ( ( C2
              = ( zero_zero @ A ) )
            | ( A2
              = ( one_one @ A ) ) ) ) ) ).

% mult_cancel_right2
thf(fact_563_sum__squares__eq__zero__iff,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [X2: A,Y2: A] :
          ( ( ( plus_plus @ A @ ( times_times @ A @ X2 @ X2 ) @ ( times_times @ A @ Y2 @ Y2 ) )
            = ( zero_zero @ A ) )
          = ( ( X2
              = ( zero_zero @ A ) )
            & ( Y2
              = ( zero_zero @ A ) ) ) ) ) ).

% sum_squares_eq_zero_iff
thf(fact_564_nonzero__mult__div__cancel__left,axiom,
    ! [A: $tType] :
      ( ( semidom_divide @ A )
     => ! [A2: A,B2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ ( times_times @ A @ A2 @ B2 ) @ A2 )
            = B2 ) ) ) ).

% nonzero_mult_div_cancel_left
thf(fact_565_nonzero__mult__div__cancel__right,axiom,
    ! [A: $tType] :
      ( ( semidom_divide @ A )
     => ! [B2: A,A2: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ ( times_times @ A @ A2 @ B2 ) @ B2 )
            = A2 ) ) ) ).

% nonzero_mult_div_cancel_right
thf(fact_566_mult__divide__mult__cancel__left__if,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ( C2
              = ( zero_zero @ A ) )
           => ( ( divide_divide @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) )
              = ( zero_zero @ A ) ) )
          & ( ( C2
             != ( zero_zero @ A ) )
           => ( ( divide_divide @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) )
              = ( divide_divide @ A @ A2 @ B2 ) ) ) ) ) ).

% mult_divide_mult_cancel_left_if
thf(fact_567_nonzero__mult__divide__mult__cancel__left,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) )
            = ( divide_divide @ A @ A2 @ B2 ) ) ) ) ).

% nonzero_mult_divide_mult_cancel_left
thf(fact_568_nonzero__mult__divide__mult__cancel__left2,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ B2 @ C2 ) )
            = ( divide_divide @ A @ A2 @ B2 ) ) ) ) ).

% nonzero_mult_divide_mult_cancel_left2
thf(fact_569_nonzero__mult__divide__mult__cancel__right,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) )
            = ( divide_divide @ A @ A2 @ B2 ) ) ) ) ).

% nonzero_mult_divide_mult_cancel_right
thf(fact_570_nonzero__mult__divide__mult__cancel__right2,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ C2 @ B2 ) )
            = ( divide_divide @ A @ A2 @ B2 ) ) ) ) ).

% nonzero_mult_divide_mult_cancel_right2
thf(fact_571_div__mult__mult1,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) )
            = ( divide_divide @ A @ A2 @ B2 ) ) ) ) ).

% div_mult_mult1
thf(fact_572_div__mult__mult2,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) )
            = ( divide_divide @ A @ A2 @ B2 ) ) ) ) ).

% div_mult_mult2
thf(fact_573_div__mult__mult1__if,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ( C2
              = ( zero_zero @ A ) )
           => ( ( divide_divide @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) )
              = ( zero_zero @ A ) ) )
          & ( ( C2
             != ( zero_zero @ A ) )
           => ( ( divide_divide @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) )
              = ( divide_divide @ A @ A2 @ B2 ) ) ) ) ) ).

% div_mult_mult1_if
thf(fact_574_distrib__left__numeral,axiom,
    ! [A: $tType] :
      ( ( ( numeral @ A )
        & ( semiring @ A ) )
     => ! [V: num,B2: A,C2: A] :
          ( ( times_times @ A @ ( numeral_numeral @ A @ V ) @ ( plus_plus @ A @ B2 @ C2 ) )
          = ( plus_plus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ V ) @ B2 ) @ ( times_times @ A @ ( numeral_numeral @ A @ V ) @ C2 ) ) ) ) ).

% distrib_left_numeral
thf(fact_575_distrib__right__numeral,axiom,
    ! [A: $tType] :
      ( ( ( numeral @ A )
        & ( semiring @ A ) )
     => ! [A2: A,B2: A,V: num] :
          ( ( times_times @ A @ ( plus_plus @ A @ A2 @ B2 ) @ ( numeral_numeral @ A @ V ) )
          = ( plus_plus @ A @ ( times_times @ A @ A2 @ ( numeral_numeral @ A @ V ) ) @ ( times_times @ A @ B2 @ ( numeral_numeral @ A @ V ) ) ) ) ) ).

% distrib_right_numeral
thf(fact_576_mult__eq__1__iff,axiom,
    ! [M: nat,N2: nat] :
      ( ( ( times_times @ nat @ M @ N2 )
        = ( suc @ ( zero_zero @ nat ) ) )
      = ( ( M
          = ( suc @ ( zero_zero @ nat ) ) )
        & ( N2
          = ( suc @ ( zero_zero @ nat ) ) ) ) ) ).

% mult_eq_1_iff
thf(fact_577_one__eq__mult__iff,axiom,
    ! [M: nat,N2: nat] :
      ( ( ( suc @ ( zero_zero @ nat ) )
        = ( times_times @ nat @ M @ N2 ) )
      = ( ( M
          = ( suc @ ( zero_zero @ nat ) ) )
        & ( N2
          = ( suc @ ( zero_zero @ nat ) ) ) ) ) ).

% one_eq_mult_iff
thf(fact_578_nat__mult__less__cancel__disj,axiom,
    ! [K: nat,M: nat,N2: nat] :
      ( ( ord_less @ nat @ ( times_times @ nat @ K @ M ) @ ( times_times @ nat @ K @ N2 ) )
      = ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
        & ( ord_less @ nat @ M @ N2 ) ) ) ).

% nat_mult_less_cancel_disj
thf(fact_579_mult__less__cancel2,axiom,
    ! [M: nat,K: nat,N2: nat] :
      ( ( ord_less @ nat @ ( times_times @ nat @ M @ K ) @ ( times_times @ nat @ N2 @ K ) )
      = ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
        & ( ord_less @ nat @ M @ N2 ) ) ) ).

% mult_less_cancel2
thf(fact_580_nat__0__less__mult__iff,axiom,
    ! [M: nat,N2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( times_times @ nat @ M @ N2 ) )
      = ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M )
        & ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 ) ) ) ).

% nat_0_less_mult_iff
thf(fact_581_mult__Suc__right,axiom,
    ! [M: nat,N2: nat] :
      ( ( times_times @ nat @ M @ ( suc @ N2 ) )
      = ( plus_plus @ nat @ M @ ( times_times @ nat @ M @ N2 ) ) ) ).

% mult_Suc_right
thf(fact_582_nat__mult__div__cancel__disj,axiom,
    ! [K: nat,M: nat,N2: nat] :
      ( ( ( K
          = ( zero_zero @ nat ) )
       => ( ( divide_divide @ nat @ ( times_times @ nat @ K @ M ) @ ( times_times @ nat @ K @ N2 ) )
          = ( zero_zero @ nat ) ) )
      & ( ( K
         != ( zero_zero @ nat ) )
       => ( ( divide_divide @ nat @ ( times_times @ nat @ K @ M ) @ ( times_times @ nat @ K @ N2 ) )
          = ( divide_divide @ nat @ M @ N2 ) ) ) ) ).

% nat_mult_div_cancel_disj
thf(fact_583_divide__le__eq__numeral1_I1_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,W: num,A2: A] :
          ( ( ord_less_eq @ A @ ( divide_divide @ A @ B2 @ ( numeral_numeral @ A @ W ) ) @ A2 )
          = ( ord_less_eq @ A @ B2 @ ( times_times @ A @ A2 @ ( numeral_numeral @ A @ W ) ) ) ) ) ).

% divide_le_eq_numeral1(1)
thf(fact_584_le__divide__eq__numeral1_I1_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A,W: num] :
          ( ( ord_less_eq @ A @ A2 @ ( divide_divide @ A @ B2 @ ( numeral_numeral @ A @ W ) ) )
          = ( ord_less_eq @ A @ ( times_times @ A @ A2 @ ( numeral_numeral @ A @ W ) ) @ B2 ) ) ) ).

% le_divide_eq_numeral1(1)
thf(fact_585_divide__eq__eq__numeral1_I1_J,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [B2: A,W: num,A2: A] :
          ( ( ( divide_divide @ A @ B2 @ ( numeral_numeral @ A @ W ) )
            = A2 )
          = ( ( ( ( numeral_numeral @ A @ W )
               != ( zero_zero @ A ) )
             => ( B2
                = ( times_times @ A @ A2 @ ( numeral_numeral @ A @ W ) ) ) )
            & ( ( ( numeral_numeral @ A @ W )
                = ( zero_zero @ A ) )
             => ( A2
                = ( zero_zero @ A ) ) ) ) ) ) ).

% divide_eq_eq_numeral1(1)
thf(fact_586_eq__divide__eq__numeral1_I1_J,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A,B2: A,W: num] :
          ( ( A2
            = ( divide_divide @ A @ B2 @ ( numeral_numeral @ A @ W ) ) )
          = ( ( ( ( numeral_numeral @ A @ W )
               != ( zero_zero @ A ) )
             => ( ( times_times @ A @ A2 @ ( numeral_numeral @ A @ W ) )
                = B2 ) )
            & ( ( ( numeral_numeral @ A @ W )
                = ( zero_zero @ A ) )
             => ( A2
                = ( zero_zero @ A ) ) ) ) ) ) ).

% eq_divide_eq_numeral1(1)
thf(fact_587_divide__less__eq__numeral1_I1_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,W: num,A2: A] :
          ( ( ord_less @ A @ ( divide_divide @ A @ B2 @ ( numeral_numeral @ A @ W ) ) @ A2 )
          = ( ord_less @ A @ B2 @ ( times_times @ A @ A2 @ ( numeral_numeral @ A @ W ) ) ) ) ) ).

% divide_less_eq_numeral1(1)
thf(fact_588_less__divide__eq__numeral1_I1_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A,W: num] :
          ( ( ord_less @ A @ A2 @ ( divide_divide @ A @ B2 @ ( numeral_numeral @ A @ W ) ) )
          = ( ord_less @ A @ ( times_times @ A @ A2 @ ( numeral_numeral @ A @ W ) ) @ B2 ) ) ) ).

% less_divide_eq_numeral1(1)
thf(fact_589_nonzero__divide__mult__cancel__left,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A2: A,B2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ A2 @ ( times_times @ A @ A2 @ B2 ) )
            = ( divide_divide @ A @ ( one_one @ A ) @ B2 ) ) ) ) ).

% nonzero_divide_mult_cancel_left
thf(fact_590_nonzero__divide__mult__cancel__right,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [B2: A,A2: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ B2 @ ( times_times @ A @ A2 @ B2 ) )
            = ( divide_divide @ A @ ( one_one @ A ) @ A2 ) ) ) ) ).

% nonzero_divide_mult_cancel_right
thf(fact_591_div__mult__self1,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ ( plus_plus @ A @ A2 @ ( times_times @ A @ C2 @ B2 ) ) @ B2 )
            = ( plus_plus @ A @ C2 @ ( divide_divide @ A @ A2 @ B2 ) ) ) ) ) ).

% div_mult_self1
thf(fact_592_div__mult__self2,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ ( plus_plus @ A @ A2 @ ( times_times @ A @ B2 @ C2 ) ) @ B2 )
            = ( plus_plus @ A @ C2 @ ( divide_divide @ A @ A2 @ B2 ) ) ) ) ) ).

% div_mult_self2
thf(fact_593_div__mult__self3,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ ( plus_plus @ A @ ( times_times @ A @ C2 @ B2 ) @ A2 ) @ B2 )
            = ( plus_plus @ A @ C2 @ ( divide_divide @ A @ A2 @ B2 ) ) ) ) ) ).

% div_mult_self3
thf(fact_594_div__mult__self4,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ ( plus_plus @ A @ ( times_times @ A @ B2 @ C2 ) @ A2 ) @ B2 )
            = ( plus_plus @ A @ C2 @ ( divide_divide @ A @ A2 @ B2 ) ) ) ) ) ).

% div_mult_self4
thf(fact_595_one__le__mult__iff,axiom,
    ! [M: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ ( suc @ ( zero_zero @ nat ) ) @ ( times_times @ nat @ M @ N2 ) )
      = ( ( ord_less_eq @ nat @ ( suc @ ( zero_zero @ nat ) ) @ M )
        & ( ord_less_eq @ nat @ ( suc @ ( zero_zero @ nat ) ) @ N2 ) ) ) ).

% one_le_mult_iff
thf(fact_596_nat__mult__le__cancel__disj,axiom,
    ! [K: nat,M: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ ( times_times @ nat @ K @ M ) @ ( times_times @ nat @ K @ N2 ) )
      = ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
       => ( ord_less_eq @ nat @ M @ N2 ) ) ) ).

% nat_mult_le_cancel_disj
thf(fact_597_mult__le__cancel2,axiom,
    ! [M: nat,K: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ ( times_times @ nat @ M @ K ) @ ( times_times @ nat @ N2 @ K ) )
      = ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
       => ( ord_less_eq @ nat @ M @ N2 ) ) ) ).

% mult_le_cancel2
thf(fact_598_div__mult__self__is__m,axiom,
    ! [N2: nat,M: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( divide_divide @ nat @ ( times_times @ nat @ M @ N2 ) @ N2 )
        = M ) ) ).

% div_mult_self_is_m
thf(fact_599_div__mult__self1__is__m,axiom,
    ! [N2: nat,M: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( divide_divide @ nat @ ( times_times @ nat @ N2 @ M ) @ N2 )
        = M ) ) ).

% div_mult_self1_is_m
thf(fact_600_power__add__numeral,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [A2: A,M: num,N2: num] :
          ( ( times_times @ A @ ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ M ) ) @ ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ N2 ) ) )
          = ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ ( plus_plus @ num @ M @ N2 ) ) ) ) ) ).

% power_add_numeral
thf(fact_601_power__add__numeral2,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [A2: A,M: num,N2: num,B2: A] :
          ( ( times_times @ A @ ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ M ) ) @ ( times_times @ A @ ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ N2 ) ) @ B2 ) )
          = ( times_times @ A @ ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ ( plus_plus @ num @ M @ N2 ) ) ) @ B2 ) ) ) ).

% power_add_numeral2
thf(fact_602_div__neg__neg__trivial,axiom,
    ! [K: int,L: int] :
      ( ( ord_less_eq @ int @ K @ ( zero_zero @ int ) )
     => ( ( ord_less @ int @ L @ K )
       => ( ( divide_divide @ int @ K @ L )
          = ( zero_zero @ int ) ) ) ) ).

% div_neg_neg_trivial
thf(fact_603_div__pos__pos__trivial,axiom,
    ! [K: int,L: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ K )
     => ( ( ord_less @ int @ K @ L )
       => ( ( divide_divide @ int @ K @ L )
          = ( zero_zero @ int ) ) ) ) ).

% div_pos_pos_trivial
thf(fact_604_mult_Oleft__commute,axiom,
    ! [A: $tType] :
      ( ( ab_semigroup_mult @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( times_times @ A @ B2 @ ( times_times @ A @ A2 @ C2 ) )
          = ( times_times @ A @ A2 @ ( times_times @ A @ B2 @ C2 ) ) ) ) ).

% mult.left_commute
thf(fact_605_mult_Ocommute,axiom,
    ! [A: $tType] :
      ( ( ab_semigroup_mult @ A )
     => ( ( times_times @ A )
        = ( ^ [A4: A,B4: A] : ( times_times @ A @ B4 @ A4 ) ) ) ) ).

% mult.commute
thf(fact_606_mult_Oassoc,axiom,
    ! [A: $tType] :
      ( ( semigroup_mult @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( times_times @ A @ ( times_times @ A @ A2 @ B2 ) @ C2 )
          = ( times_times @ A @ A2 @ ( times_times @ A @ B2 @ C2 ) ) ) ) ).

% mult.assoc
thf(fact_607_ab__semigroup__mult__class_Omult__ac_I1_J,axiom,
    ! [A: $tType] :
      ( ( ab_semigroup_mult @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( times_times @ A @ ( times_times @ A @ A2 @ B2 ) @ C2 )
          = ( times_times @ A @ A2 @ ( times_times @ A @ B2 @ C2 ) ) ) ) ).

% ab_semigroup_mult_class.mult_ac(1)
thf(fact_608_mult__not__zero,axiom,
    ! [A: $tType] :
      ( ( mult_zero @ A )
     => ! [A2: A,B2: A] :
          ( ( ( times_times @ A @ A2 @ B2 )
           != ( zero_zero @ A ) )
         => ( ( A2
             != ( zero_zero @ A ) )
            & ( B2
             != ( zero_zero @ A ) ) ) ) ) ).

% mult_not_zero
thf(fact_609_divisors__zero,axiom,
    ! [A: $tType] :
      ( ( semiri3467727345109120633visors @ A )
     => ! [A2: A,B2: A] :
          ( ( ( times_times @ A @ A2 @ B2 )
            = ( zero_zero @ A ) )
         => ( ( A2
              = ( zero_zero @ A ) )
            | ( B2
              = ( zero_zero @ A ) ) ) ) ) ).

% divisors_zero
thf(fact_610_no__zero__divisors,axiom,
    ! [A: $tType] :
      ( ( semiri3467727345109120633visors @ A )
     => ! [A2: A,B2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( B2
             != ( zero_zero @ A ) )
           => ( ( times_times @ A @ A2 @ B2 )
             != ( zero_zero @ A ) ) ) ) ) ).

% no_zero_divisors
thf(fact_611_mult__left__cancel,axiom,
    ! [A: $tType] :
      ( ( semiri6575147826004484403cancel @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( ( times_times @ A @ C2 @ A2 )
              = ( times_times @ A @ C2 @ B2 ) )
            = ( A2 = B2 ) ) ) ) ).

% mult_left_cancel
thf(fact_612_mult__right__cancel,axiom,
    ! [A: $tType] :
      ( ( semiri6575147826004484403cancel @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( ( times_times @ A @ A2 @ C2 )
              = ( times_times @ A @ B2 @ C2 ) )
            = ( A2 = B2 ) ) ) ) ).

% mult_right_cancel
thf(fact_613_ring__class_Oring__distribs_I2_J,axiom,
    ! [A: $tType] :
      ( ( ring @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( times_times @ A @ ( plus_plus @ A @ A2 @ B2 ) @ C2 )
          = ( plus_plus @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) ) ) ) ).

% ring_class.ring_distribs(2)
thf(fact_614_ring__class_Oring__distribs_I1_J,axiom,
    ! [A: $tType] :
      ( ( ring @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( times_times @ A @ A2 @ ( plus_plus @ A @ B2 @ C2 ) )
          = ( plus_plus @ A @ ( times_times @ A @ A2 @ B2 ) @ ( times_times @ A @ A2 @ C2 ) ) ) ) ).

% ring_class.ring_distribs(1)
thf(fact_615_comm__semiring__class_Odistrib,axiom,
    ! [A: $tType] :
      ( ( comm_semiring @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( times_times @ A @ ( plus_plus @ A @ A2 @ B2 ) @ C2 )
          = ( plus_plus @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) ) ) ) ).

% comm_semiring_class.distrib
thf(fact_616_distrib__left,axiom,
    ! [A: $tType] :
      ( ( semiring @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( times_times @ A @ A2 @ ( plus_plus @ A @ B2 @ C2 ) )
          = ( plus_plus @ A @ ( times_times @ A @ A2 @ B2 ) @ ( times_times @ A @ A2 @ C2 ) ) ) ) ).

% distrib_left
thf(fact_617_distrib__right,axiom,
    ! [A: $tType] :
      ( ( semiring @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( times_times @ A @ ( plus_plus @ A @ A2 @ B2 ) @ C2 )
          = ( plus_plus @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) ) ) ) ).

% distrib_right
thf(fact_618_combine__common__factor,axiom,
    ! [A: $tType] :
      ( ( semiring @ A )
     => ! [A2: A,E2: A,B2: A,C2: A] :
          ( ( plus_plus @ A @ ( times_times @ A @ A2 @ E2 ) @ ( plus_plus @ A @ ( times_times @ A @ B2 @ E2 ) @ C2 ) )
          = ( plus_plus @ A @ ( times_times @ A @ ( plus_plus @ A @ A2 @ B2 ) @ E2 ) @ C2 ) ) ) ).

% combine_common_factor
thf(fact_619_nat__mult__eq__cancel__disj,axiom,
    ! [K: nat,M: nat,N2: nat] :
      ( ( ( times_times @ nat @ K @ M )
        = ( times_times @ nat @ K @ N2 ) )
      = ( ( K
          = ( zero_zero @ nat ) )
        | ( M = N2 ) ) ) ).

% nat_mult_eq_cancel_disj
thf(fact_620_left__add__mult__distrib,axiom,
    ! [I3: nat,U: nat,J: nat,K: nat] :
      ( ( plus_plus @ nat @ ( times_times @ nat @ I3 @ U ) @ ( plus_plus @ nat @ ( times_times @ nat @ J @ U ) @ K ) )
      = ( plus_plus @ nat @ ( times_times @ nat @ ( plus_plus @ nat @ I3 @ J ) @ U ) @ K ) ) ).

% left_add_mult_distrib
thf(fact_621_comm__monoid__mult__class_Omult__1,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A2: A] :
          ( ( times_times @ A @ ( one_one @ A ) @ A2 )
          = A2 ) ) ).

% comm_monoid_mult_class.mult_1
thf(fact_622_mult_Ocomm__neutral,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A2: A] :
          ( ( times_times @ A @ A2 @ ( one_one @ A ) )
          = A2 ) ) ).

% mult.comm_neutral
thf(fact_623_times__divide__times__eq,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [X2: A,Y2: A,Z: A,W: A] :
          ( ( times_times @ A @ ( divide_divide @ A @ X2 @ Y2 ) @ ( divide_divide @ A @ Z @ W ) )
          = ( divide_divide @ A @ ( times_times @ A @ X2 @ Z ) @ ( times_times @ A @ Y2 @ W ) ) ) ) ).

% times_divide_times_eq
thf(fact_624_divide__divide__times__eq,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [X2: A,Y2: A,Z: A,W: A] :
          ( ( divide_divide @ A @ ( divide_divide @ A @ X2 @ Y2 ) @ ( divide_divide @ A @ Z @ W ) )
          = ( divide_divide @ A @ ( times_times @ A @ X2 @ W ) @ ( times_times @ A @ Y2 @ Z ) ) ) ) ).

% divide_divide_times_eq
thf(fact_625_divide__divide__eq__left_H,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( divide_divide @ A @ ( divide_divide @ A @ A2 @ B2 ) @ C2 )
          = ( divide_divide @ A @ A2 @ ( times_times @ A @ C2 @ B2 ) ) ) ) ).

% divide_divide_eq_left'
thf(fact_626_power__commutes,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [A2: A,N2: nat] :
          ( ( times_times @ A @ ( power_power @ A @ A2 @ N2 ) @ A2 )
          = ( times_times @ A @ A2 @ ( power_power @ A @ A2 @ N2 ) ) ) ) ).

% power_commutes
thf(fact_627_power__mult__distrib,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A2: A,B2: A,N2: nat] :
          ( ( power_power @ A @ ( times_times @ A @ A2 @ B2 ) @ N2 )
          = ( times_times @ A @ ( power_power @ A @ A2 @ N2 ) @ ( power_power @ A @ B2 @ N2 ) ) ) ) ).

% power_mult_distrib
thf(fact_628_power__commuting__commutes,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [X2: A,Y2: A,N2: nat] :
          ( ( ( times_times @ A @ X2 @ Y2 )
            = ( times_times @ A @ Y2 @ X2 ) )
         => ( ( times_times @ A @ ( power_power @ A @ X2 @ N2 ) @ Y2 )
            = ( times_times @ A @ Y2 @ ( power_power @ A @ X2 @ N2 ) ) ) ) ) ).

% power_commuting_commutes
thf(fact_629_Suc__mult__cancel1,axiom,
    ! [K: nat,M: nat,N2: nat] :
      ( ( ( times_times @ nat @ ( suc @ K ) @ M )
        = ( times_times @ nat @ ( suc @ K ) @ N2 ) )
      = ( M = N2 ) ) ).

% Suc_mult_cancel1
thf(fact_630_power__mult,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [A2: A,M: nat,N2: nat] :
          ( ( power_power @ A @ A2 @ ( times_times @ nat @ M @ N2 ) )
          = ( power_power @ A @ ( power_power @ A @ A2 @ M ) @ N2 ) ) ) ).

% power_mult
thf(fact_631_mult__0,axiom,
    ! [N2: nat] :
      ( ( times_times @ nat @ ( zero_zero @ nat ) @ N2 )
      = ( zero_zero @ nat ) ) ).

% mult_0
thf(fact_632_le__cube,axiom,
    ! [M: nat] : ( ord_less_eq @ nat @ M @ ( times_times @ nat @ M @ ( times_times @ nat @ M @ M ) ) ) ).

% le_cube
thf(fact_633_le__square,axiom,
    ! [M: nat] : ( ord_less_eq @ nat @ M @ ( times_times @ nat @ M @ M ) ) ).

% le_square
thf(fact_634_mult__le__mono,axiom,
    ! [I3: nat,J: nat,K: nat,L: nat] :
      ( ( ord_less_eq @ nat @ I3 @ J )
     => ( ( ord_less_eq @ nat @ K @ L )
       => ( ord_less_eq @ nat @ ( times_times @ nat @ I3 @ K ) @ ( times_times @ nat @ J @ L ) ) ) ) ).

% mult_le_mono
thf(fact_635_mult__le__mono1,axiom,
    ! [I3: nat,J: nat,K: nat] :
      ( ( ord_less_eq @ nat @ I3 @ J )
     => ( ord_less_eq @ nat @ ( times_times @ nat @ I3 @ K ) @ ( times_times @ nat @ J @ K ) ) ) ).

% mult_le_mono1
thf(fact_636_mult__le__mono2,axiom,
    ! [I3: nat,J: nat,K: nat] :
      ( ( ord_less_eq @ nat @ I3 @ J )
     => ( ord_less_eq @ nat @ ( times_times @ nat @ K @ I3 ) @ ( times_times @ nat @ K @ J ) ) ) ).

% mult_le_mono2
thf(fact_637_add__mult__distrib,axiom,
    ! [M: nat,N2: nat,K: nat] :
      ( ( times_times @ nat @ ( plus_plus @ nat @ M @ N2 ) @ K )
      = ( plus_plus @ nat @ ( times_times @ nat @ M @ K ) @ ( times_times @ nat @ N2 @ K ) ) ) ).

% add_mult_distrib
thf(fact_638_add__mult__distrib2,axiom,
    ! [K: nat,M: nat,N2: nat] :
      ( ( times_times @ nat @ K @ ( plus_plus @ nat @ M @ N2 ) )
      = ( plus_plus @ nat @ ( times_times @ nat @ K @ M ) @ ( times_times @ nat @ K @ N2 ) ) ) ).

% add_mult_distrib2
thf(fact_639_nat__mult__1,axiom,
    ! [N2: nat] :
      ( ( times_times @ nat @ ( one_one @ nat ) @ N2 )
      = N2 ) ).

% nat_mult_1
thf(fact_640_nat__mult__1__right,axiom,
    ! [N2: nat] :
      ( ( times_times @ nat @ N2 @ ( one_one @ nat ) )
      = N2 ) ).

% nat_mult_1_right
thf(fact_641_div__mult2__eq,axiom,
    ! [M: nat,N2: nat,Q3: nat] :
      ( ( divide_divide @ nat @ M @ ( times_times @ nat @ N2 @ Q3 ) )
      = ( divide_divide @ nat @ ( divide_divide @ nat @ M @ N2 ) @ Q3 ) ) ).

% div_mult2_eq
thf(fact_642_mult__mono,axiom,
    ! [A: $tType] :
      ( ( ordered_semiring @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ C2 @ D2 )
           => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 )
             => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
               => ( ord_less_eq @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ D2 ) ) ) ) ) ) ) ).

% mult_mono
thf(fact_643_mult__mono_H,axiom,
    ! [A: $tType] :
      ( ( ordered_semiring @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ C2 @ D2 )
           => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
             => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
               => ( ord_less_eq @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ D2 ) ) ) ) ) ) ) ).

% mult_mono'
thf(fact_644_zero__le__square,axiom,
    ! [A: $tType] :
      ( ( linordered_ring @ A )
     => ! [A2: A] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A2 @ A2 ) ) ) ).

% zero_le_square
thf(fact_645_split__mult__pos__le,axiom,
    ! [A: $tType] :
      ( ( ordered_ring @ A )
     => ! [A2: A,B2: A] :
          ( ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
              & ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 ) )
            | ( ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) )
              & ( ord_less_eq @ A @ B2 @ ( zero_zero @ A ) ) ) )
         => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A2 @ B2 ) ) ) ) ).

% split_mult_pos_le
thf(fact_646_mult__left__mono__neg,axiom,
    ! [A: $tType] :
      ( ( ordered_ring @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( ord_less_eq @ A @ B2 @ A2 )
         => ( ( ord_less_eq @ A @ C2 @ ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) ) ) ) ) ).

% mult_left_mono_neg
thf(fact_647_mult__nonpos__nonpos,axiom,
    ! [A: $tType] :
      ( ( ordered_ring @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ B2 @ ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A2 @ B2 ) ) ) ) ) ).

% mult_nonpos_nonpos
thf(fact_648_mult__left__mono,axiom,
    ! [A: $tType] :
      ( ( ordered_semiring @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
           => ( ord_less_eq @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) ) ) ) ) ).

% mult_left_mono
thf(fact_649_mult__right__mono__neg,axiom,
    ! [A: $tType] :
      ( ( ordered_ring @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( ord_less_eq @ A @ B2 @ A2 )
         => ( ( ord_less_eq @ A @ C2 @ ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) ) ) ) ) ).

% mult_right_mono_neg
thf(fact_650_mult__right__mono,axiom,
    ! [A: $tType] :
      ( ( ordered_semiring @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
           => ( ord_less_eq @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) ) ) ) ) ).

% mult_right_mono
thf(fact_651_mult__le__0__iff,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( times_times @ A @ A2 @ B2 ) @ ( zero_zero @ A ) )
          = ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
              & ( ord_less_eq @ A @ B2 @ ( zero_zero @ A ) ) )
            | ( ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) )
              & ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 ) ) ) ) ) ).

% mult_le_0_iff
thf(fact_652_split__mult__neg__le,axiom,
    ! [A: $tType] :
      ( ( ordered_semiring_0 @ A )
     => ! [A2: A,B2: A] :
          ( ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
              & ( ord_less_eq @ A @ B2 @ ( zero_zero @ A ) ) )
            | ( ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) )
              & ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 ) ) )
         => ( ord_less_eq @ A @ ( times_times @ A @ A2 @ B2 ) @ ( zero_zero @ A ) ) ) ) ).

% split_mult_neg_le
thf(fact_653_mult__nonneg__nonneg,axiom,
    ! [A: $tType] :
      ( ( ordered_semiring_0 @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 )
           => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A2 @ B2 ) ) ) ) ) ).

% mult_nonneg_nonneg
thf(fact_654_mult__nonneg__nonpos,axiom,
    ! [A: $tType] :
      ( ( ordered_semiring_0 @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less_eq @ A @ B2 @ ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ ( times_times @ A @ A2 @ B2 ) @ ( zero_zero @ A ) ) ) ) ) ).

% mult_nonneg_nonpos
thf(fact_655_mult__nonpos__nonneg,axiom,
    ! [A: $tType] :
      ( ( ordered_semiring_0 @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 )
           => ( ord_less_eq @ A @ ( times_times @ A @ A2 @ B2 ) @ ( zero_zero @ A ) ) ) ) ) ).

% mult_nonpos_nonneg
thf(fact_656_mult__nonneg__nonpos2,axiom,
    ! [A: $tType] :
      ( ( ordered_semiring_0 @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less_eq @ A @ B2 @ ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ ( times_times @ A @ B2 @ A2 ) @ ( zero_zero @ A ) ) ) ) ) ).

% mult_nonneg_nonpos2
thf(fact_657_zero__le__mult__iff,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A2 @ B2 ) )
          = ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
              & ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 ) )
            | ( ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) )
              & ( ord_less_eq @ A @ B2 @ ( zero_zero @ A ) ) ) ) ) ) ).

% zero_le_mult_iff
thf(fact_658_ordered__comm__semiring__class_Ocomm__mult__left__mono,axiom,
    ! [A: $tType] :
      ( ( ordere2520102378445227354miring @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
           => ( ord_less_eq @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) ) ) ) ) ).

% ordered_comm_semiring_class.comm_mult_left_mono
thf(fact_659_mult__neg__neg,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ B2 @ ( zero_zero @ A ) )
           => ( ord_less @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A2 @ B2 ) ) ) ) ) ).

% mult_neg_neg
thf(fact_660_not__square__less__zero,axiom,
    ! [A: $tType] :
      ( ( linordered_ring @ A )
     => ! [A2: A] :
          ~ ( ord_less @ A @ ( times_times @ A @ A2 @ A2 ) @ ( zero_zero @ A ) ) ) ).

% not_square_less_zero
thf(fact_661_mult__less__0__iff,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( times_times @ A @ A2 @ B2 ) @ ( zero_zero @ A ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
              & ( ord_less @ A @ B2 @ ( zero_zero @ A ) ) )
            | ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
              & ( ord_less @ A @ ( zero_zero @ A ) @ B2 ) ) ) ) ) ).

% mult_less_0_iff
thf(fact_662_mult__neg__pos,axiom,
    ! [A: $tType] :
      ( ( linord8928482502909563296strict @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ B2 )
           => ( ord_less @ A @ ( times_times @ A @ A2 @ B2 ) @ ( zero_zero @ A ) ) ) ) ) ).

% mult_neg_pos
thf(fact_663_mult__pos__neg,axiom,
    ! [A: $tType] :
      ( ( linord8928482502909563296strict @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less @ A @ B2 @ ( zero_zero @ A ) )
           => ( ord_less @ A @ ( times_times @ A @ A2 @ B2 ) @ ( zero_zero @ A ) ) ) ) ) ).

% mult_pos_neg
thf(fact_664_mult__pos__pos,axiom,
    ! [A: $tType] :
      ( ( linord8928482502909563296strict @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ B2 )
           => ( ord_less @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A2 @ B2 ) ) ) ) ) ).

% mult_pos_pos
thf(fact_665_mult__pos__neg2,axiom,
    ! [A: $tType] :
      ( ( linord8928482502909563296strict @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less @ A @ B2 @ ( zero_zero @ A ) )
           => ( ord_less @ A @ ( times_times @ A @ B2 @ A2 ) @ ( zero_zero @ A ) ) ) ) ) ).

% mult_pos_neg2
thf(fact_666_zero__less__mult__iff,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A2 @ B2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
              & ( ord_less @ A @ ( zero_zero @ A ) @ B2 ) )
            | ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
              & ( ord_less @ A @ B2 @ ( zero_zero @ A ) ) ) ) ) ) ).

% zero_less_mult_iff
thf(fact_667_zero__less__mult__pos,axiom,
    ! [A: $tType] :
      ( ( linord8928482502909563296strict @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A2 @ B2 ) )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
           => ( ord_less @ A @ ( zero_zero @ A ) @ B2 ) ) ) ) ).

% zero_less_mult_pos
thf(fact_668_zero__less__mult__pos2,axiom,
    ! [A: $tType] :
      ( ( linord8928482502909563296strict @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( times_times @ A @ B2 @ A2 ) )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
           => ( ord_less @ A @ ( zero_zero @ A ) @ B2 ) ) ) ) ).

% zero_less_mult_pos2
thf(fact_669_mult__less__cancel__left__neg,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) )
            = ( ord_less @ A @ B2 @ A2 ) ) ) ) ).

% mult_less_cancel_left_neg
thf(fact_670_mult__less__cancel__left__pos,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
         => ( ( ord_less @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) )
            = ( ord_less @ A @ A2 @ B2 ) ) ) ) ).

% mult_less_cancel_left_pos
thf(fact_671_mult__strict__left__mono__neg,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( ord_less @ A @ B2 @ A2 )
         => ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
           => ( ord_less @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) ) ) ) ) ).

% mult_strict_left_mono_neg
thf(fact_672_mult__strict__left__mono,axiom,
    ! [A: $tType] :
      ( ( linord8928482502909563296strict @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
           => ( ord_less @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) ) ) ) ) ).

% mult_strict_left_mono
thf(fact_673_mult__less__cancel__left__disj,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
              & ( ord_less @ A @ A2 @ B2 ) )
            | ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
              & ( ord_less @ A @ B2 @ A2 ) ) ) ) ) ).

% mult_less_cancel_left_disj
thf(fact_674_mult__strict__right__mono__neg,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( ord_less @ A @ B2 @ A2 )
         => ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
           => ( ord_less @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) ) ) ) ) ).

% mult_strict_right_mono_neg
thf(fact_675_mult__strict__right__mono,axiom,
    ! [A: $tType] :
      ( ( linord8928482502909563296strict @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
           => ( ord_less @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) ) ) ) ) ).

% mult_strict_right_mono
thf(fact_676_mult__less__cancel__right__disj,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ord_less @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
              & ( ord_less @ A @ A2 @ B2 ) )
            | ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
              & ( ord_less @ A @ B2 @ A2 ) ) ) ) ) ).

% mult_less_cancel_right_disj
thf(fact_677_linordered__comm__semiring__strict__class_Ocomm__mult__strict__left__mono,axiom,
    ! [A: $tType] :
      ( ( linord2810124833399127020strict @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
           => ( ord_less @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) ) ) ) ) ).

% linordered_comm_semiring_strict_class.comm_mult_strict_left_mono
thf(fact_678_less__1__mult,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [M: A,N2: A] :
          ( ( ord_less @ A @ ( one_one @ A ) @ M )
         => ( ( ord_less @ A @ ( one_one @ A ) @ N2 )
           => ( ord_less @ A @ ( one_one @ A ) @ ( times_times @ A @ M @ N2 ) ) ) ) ) ).

% less_1_mult
thf(fact_679_nat__mult__eq__cancel1,axiom,
    ! [K: nat,M: nat,N2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
     => ( ( ( times_times @ nat @ K @ M )
          = ( times_times @ nat @ K @ N2 ) )
        = ( M = N2 ) ) ) ).

% nat_mult_eq_cancel1
thf(fact_680_nat__mult__less__cancel1,axiom,
    ! [K: nat,M: nat,N2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
     => ( ( ord_less @ nat @ ( times_times @ nat @ K @ M ) @ ( times_times @ nat @ K @ N2 ) )
        = ( ord_less @ nat @ M @ N2 ) ) ) ).

% nat_mult_less_cancel1
thf(fact_681_mult__le__cancel__left,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less_eq @ A @ A2 @ B2 ) )
            & ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
             => ( ord_less_eq @ A @ B2 @ A2 ) ) ) ) ) ).

% mult_le_cancel_left
thf(fact_682_mult__le__cancel__right,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less_eq @ A @ A2 @ B2 ) )
            & ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
             => ( ord_less_eq @ A @ B2 @ A2 ) ) ) ) ) ).

% mult_le_cancel_right
thf(fact_683_mult__left__less__imp__less,axiom,
    ! [A: $tType] :
      ( ( linordered_semiring @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
           => ( ord_less @ A @ A2 @ B2 ) ) ) ) ).

% mult_left_less_imp_less
thf(fact_684_mult__strict__mono,axiom,
    ! [A: $tType] :
      ( ( linord8928482502909563296strict @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_less @ A @ C2 @ D2 )
           => ( ( ord_less @ A @ ( zero_zero @ A ) @ B2 )
             => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
               => ( ord_less @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ D2 ) ) ) ) ) ) ) ).

% mult_strict_mono
thf(fact_685_mult__less__cancel__left,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) )
          = ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less @ A @ A2 @ B2 ) )
            & ( ( ord_less_eq @ A @ C2 @ ( zero_zero @ A ) )
             => ( ord_less @ A @ B2 @ A2 ) ) ) ) ) ).

% mult_less_cancel_left
thf(fact_686_mult__right__less__imp__less,axiom,
    ! [A: $tType] :
      ( ( linordered_semiring @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ord_less @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
           => ( ord_less @ A @ A2 @ B2 ) ) ) ) ).

% mult_right_less_imp_less
thf(fact_687_mult__strict__mono_H,axiom,
    ! [A: $tType] :
      ( ( linord8928482502909563296strict @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_less @ A @ C2 @ D2 )
           => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
             => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
               => ( ord_less @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ D2 ) ) ) ) ) ) ) ).

% mult_strict_mono'
thf(fact_688_mult__less__cancel__right,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ord_less @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) )
          = ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less @ A @ A2 @ B2 ) )
            & ( ( ord_less_eq @ A @ C2 @ ( zero_zero @ A ) )
             => ( ord_less @ A @ B2 @ A2 ) ) ) ) ) ).

% mult_less_cancel_right
thf(fact_689_mult__le__cancel__left__neg,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) )
            = ( ord_less_eq @ A @ B2 @ A2 ) ) ) ) ).

% mult_le_cancel_left_neg
thf(fact_690_mult__le__cancel__left__pos,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
         => ( ( ord_less_eq @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) )
            = ( ord_less_eq @ A @ A2 @ B2 ) ) ) ) ).

% mult_le_cancel_left_pos
thf(fact_691_mult__left__le__imp__le,axiom,
    ! [A: $tType] :
      ( ( linord8928482502909563296strict @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
           => ( ord_less_eq @ A @ A2 @ B2 ) ) ) ) ).

% mult_left_le_imp_le
thf(fact_692_mult__right__le__imp__le,axiom,
    ! [A: $tType] :
      ( ( linord8928482502909563296strict @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
           => ( ord_less_eq @ A @ A2 @ B2 ) ) ) ) ).

% mult_right_le_imp_le
thf(fact_693_mult__le__less__imp__less,axiom,
    ! [A: $tType] :
      ( ( linord8928482502909563296strict @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less @ A @ C2 @ D2 )
           => ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
             => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
               => ( ord_less @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ D2 ) ) ) ) ) ) ) ).

% mult_le_less_imp_less
thf(fact_694_mult__less__le__imp__less,axiom,
    ! [A: $tType] :
      ( ( linord8928482502909563296strict @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ C2 @ D2 )
           => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
             => ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
               => ( ord_less @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ D2 ) ) ) ) ) ) ) ).

% mult_less_le_imp_less
thf(fact_695_mult__left__le__one__le,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X2: A,Y2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ Y2 )
           => ( ( ord_less_eq @ A @ Y2 @ ( one_one @ A ) )
             => ( ord_less_eq @ A @ ( times_times @ A @ Y2 @ X2 ) @ X2 ) ) ) ) ) ).

% mult_left_le_one_le
thf(fact_696_mult__right__le__one__le,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X2: A,Y2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ Y2 )
           => ( ( ord_less_eq @ A @ Y2 @ ( one_one @ A ) )
             => ( ord_less_eq @ A @ ( times_times @ A @ X2 @ Y2 ) @ X2 ) ) ) ) ) ).

% mult_right_le_one_le
thf(fact_697_mult__le__one,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ ( one_one @ A ) )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 )
           => ( ( ord_less_eq @ A @ B2 @ ( one_one @ A ) )
             => ( ord_less_eq @ A @ ( times_times @ A @ A2 @ B2 ) @ ( one_one @ A ) ) ) ) ) ) ).

% mult_le_one
thf(fact_698_mult__left__le,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [C2: A,A2: A] :
          ( ( ord_less_eq @ A @ C2 @ ( one_one @ A ) )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
           => ( ord_less_eq @ A @ ( times_times @ A @ A2 @ C2 ) @ A2 ) ) ) ) ).

% mult_left_le
thf(fact_699_sum__squares__ge__zero,axiom,
    ! [A: $tType] :
      ( ( linordered_ring @ A )
     => ! [X2: A,Y2: A] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( plus_plus @ A @ ( times_times @ A @ X2 @ X2 ) @ ( times_times @ A @ Y2 @ Y2 ) ) ) ) ).

% sum_squares_ge_zero
thf(fact_700_not__sum__squares__lt__zero,axiom,
    ! [A: $tType] :
      ( ( linordered_ring @ A )
     => ! [X2: A,Y2: A] :
          ~ ( ord_less @ A @ ( plus_plus @ A @ ( times_times @ A @ X2 @ X2 ) @ ( times_times @ A @ Y2 @ Y2 ) ) @ ( zero_zero @ A ) ) ) ).

% not_sum_squares_lt_zero
thf(fact_701_frac__eq__eq,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [Y2: A,Z: A,X2: A,W: A] :
          ( ( Y2
           != ( zero_zero @ A ) )
         => ( ( Z
             != ( zero_zero @ A ) )
           => ( ( ( divide_divide @ A @ X2 @ Y2 )
                = ( divide_divide @ A @ W @ Z ) )
              = ( ( times_times @ A @ X2 @ Z )
                = ( times_times @ A @ W @ Y2 ) ) ) ) ) ) ).

% frac_eq_eq
thf(fact_702_divide__eq__eq,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( ( divide_divide @ A @ B2 @ C2 )
            = A2 )
          = ( ( ( C2
               != ( zero_zero @ A ) )
             => ( B2
                = ( times_times @ A @ A2 @ C2 ) ) )
            & ( ( C2
                = ( zero_zero @ A ) )
             => ( A2
                = ( zero_zero @ A ) ) ) ) ) ) ).

% divide_eq_eq
thf(fact_703_eq__divide__eq,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( A2
            = ( divide_divide @ A @ B2 @ C2 ) )
          = ( ( ( C2
               != ( zero_zero @ A ) )
             => ( ( times_times @ A @ A2 @ C2 )
                = B2 ) )
            & ( ( C2
                = ( zero_zero @ A ) )
             => ( A2
                = ( zero_zero @ A ) ) ) ) ) ) ).

% eq_divide_eq
thf(fact_704_divide__eq__imp,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( B2
              = ( times_times @ A @ A2 @ C2 ) )
           => ( ( divide_divide @ A @ B2 @ C2 )
              = A2 ) ) ) ) ).

% divide_eq_imp
thf(fact_705_eq__divide__imp,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( ( times_times @ A @ A2 @ C2 )
              = B2 )
           => ( A2
              = ( divide_divide @ A @ B2 @ C2 ) ) ) ) ) ).

% eq_divide_imp
thf(fact_706_nonzero__divide__eq__eq,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( ( divide_divide @ A @ B2 @ C2 )
              = A2 )
            = ( B2
              = ( times_times @ A @ A2 @ C2 ) ) ) ) ) ).

% nonzero_divide_eq_eq
thf(fact_707_nonzero__eq__divide__eq,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( A2
              = ( divide_divide @ A @ B2 @ C2 ) )
            = ( ( times_times @ A @ A2 @ C2 )
              = B2 ) ) ) ) ).

% nonzero_eq_divide_eq
thf(fact_708_mult__numeral__1,axiom,
    ! [A: $tType] :
      ( ( semiring_numeral @ A )
     => ! [A2: A] :
          ( ( times_times @ A @ ( numeral_numeral @ A @ one2 ) @ A2 )
          = A2 ) ) ).

% mult_numeral_1
thf(fact_709_mult__numeral__1__right,axiom,
    ! [A: $tType] :
      ( ( semiring_numeral @ A )
     => ! [A2: A] :
          ( ( times_times @ A @ A2 @ ( numeral_numeral @ A @ one2 ) )
          = A2 ) ) ).

% mult_numeral_1_right
thf(fact_710_left__right__inverse__power,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [X2: A,Y2: A,N2: nat] :
          ( ( ( times_times @ A @ X2 @ Y2 )
            = ( one_one @ A ) )
         => ( ( times_times @ A @ ( power_power @ A @ X2 @ N2 ) @ ( power_power @ A @ Y2 @ N2 ) )
            = ( one_one @ A ) ) ) ) ).

% left_right_inverse_power
thf(fact_711_nat__mult__le__cancel1,axiom,
    ! [K: nat,M: nat,N2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
     => ( ( ord_less_eq @ nat @ ( times_times @ nat @ K @ M ) @ ( times_times @ nat @ K @ N2 ) )
        = ( ord_less_eq @ nat @ M @ N2 ) ) ) ).

% nat_mult_le_cancel1
thf(fact_712_power__Suc,axiom,
    ! [A: $tType] :
      ( ( power @ A )
     => ! [A2: A,N2: nat] :
          ( ( power_power @ A @ A2 @ ( suc @ N2 ) )
          = ( times_times @ A @ A2 @ ( power_power @ A @ A2 @ N2 ) ) ) ) ).

% power_Suc
thf(fact_713_power__Suc2,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [A2: A,N2: nat] :
          ( ( power_power @ A @ A2 @ ( suc @ N2 ) )
          = ( times_times @ A @ ( power_power @ A @ A2 @ N2 ) @ A2 ) ) ) ).

% power_Suc2
thf(fact_714_nat__mult__div__cancel1,axiom,
    ! [K: nat,M: nat,N2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
     => ( ( divide_divide @ nat @ ( times_times @ nat @ K @ M ) @ ( times_times @ nat @ K @ N2 ) )
        = ( divide_divide @ nat @ M @ N2 ) ) ) ).

% nat_mult_div_cancel1
thf(fact_715_Suc__mult__less__cancel1,axiom,
    ! [K: nat,M: nat,N2: nat] :
      ( ( ord_less @ nat @ ( times_times @ nat @ ( suc @ K ) @ M ) @ ( times_times @ nat @ ( suc @ K ) @ N2 ) )
      = ( ord_less @ nat @ M @ N2 ) ) ).

% Suc_mult_less_cancel1
thf(fact_716_power__add,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [A2: A,M: nat,N2: nat] :
          ( ( power_power @ A @ A2 @ ( plus_plus @ nat @ M @ N2 ) )
          = ( times_times @ A @ ( power_power @ A @ A2 @ M ) @ ( power_power @ A @ A2 @ N2 ) ) ) ) ).

% power_add
thf(fact_717_mult__less__mono1,axiom,
    ! [I3: nat,J: nat,K: nat] :
      ( ( ord_less @ nat @ I3 @ J )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
       => ( ord_less @ nat @ ( times_times @ nat @ I3 @ K ) @ ( times_times @ nat @ J @ K ) ) ) ) ).

% mult_less_mono1
thf(fact_718_mult__less__mono2,axiom,
    ! [I3: nat,J: nat,K: nat] :
      ( ( ord_less @ nat @ I3 @ J )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
       => ( ord_less @ nat @ ( times_times @ nat @ K @ I3 ) @ ( times_times @ nat @ K @ J ) ) ) ) ).

% mult_less_mono2
thf(fact_719_Suc__mult__le__cancel1,axiom,
    ! [K: nat,M: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ ( times_times @ nat @ ( suc @ K ) @ M ) @ ( times_times @ nat @ ( suc @ K ) @ N2 ) )
      = ( ord_less_eq @ nat @ M @ N2 ) ) ).

% Suc_mult_le_cancel1
thf(fact_720_mult__Suc,axiom,
    ! [M: nat,N2: nat] :
      ( ( times_times @ nat @ ( suc @ M ) @ N2 )
      = ( plus_plus @ nat @ N2 @ ( times_times @ nat @ M @ N2 ) ) ) ).

% mult_Suc
thf(fact_721_mult__eq__self__implies__10,axiom,
    ! [M: nat,N2: nat] :
      ( ( M
        = ( times_times @ nat @ M @ N2 ) )
     => ( ( N2
          = ( one_one @ nat ) )
        | ( M
          = ( zero_zero @ nat ) ) ) ) ).

% mult_eq_self_implies_10
thf(fact_722_less__mult__imp__div__less,axiom,
    ! [M: nat,I3: nat,N2: nat] :
      ( ( ord_less @ nat @ M @ ( times_times @ nat @ I3 @ N2 ) )
     => ( ord_less @ nat @ ( divide_divide @ nat @ M @ N2 ) @ I3 ) ) ).

% less_mult_imp_div_less
thf(fact_723_div__times__less__eq__dividend,axiom,
    ! [M: nat,N2: nat] : ( ord_less_eq @ nat @ ( times_times @ nat @ ( divide_divide @ nat @ M @ N2 ) @ N2 ) @ M ) ).

% div_times_less_eq_dividend
thf(fact_724_times__div__less__eq__dividend,axiom,
    ! [N2: nat,M: nat] : ( ord_less_eq @ nat @ ( times_times @ nat @ N2 @ ( divide_divide @ nat @ M @ N2 ) ) @ M ) ).

% times_div_less_eq_dividend
thf(fact_725_power__odd__eq,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [A2: A,N2: nat] :
          ( ( power_power @ A @ A2 @ ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) )
          = ( times_times @ A @ A2 @ ( power_power @ A @ ( power_power @ A @ A2 @ N2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% power_odd_eq
thf(fact_726_mult__le__cancel__left1,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [C2: A,B2: A] :
          ( ( ord_less_eq @ A @ C2 @ ( times_times @ A @ C2 @ B2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less_eq @ A @ ( one_one @ A ) @ B2 ) )
            & ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
             => ( ord_less_eq @ A @ B2 @ ( one_one @ A ) ) ) ) ) ) ).

% mult_le_cancel_left1
thf(fact_727_mult__le__cancel__left2,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [C2: A,A2: A] :
          ( ( ord_less_eq @ A @ ( times_times @ A @ C2 @ A2 ) @ C2 )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less_eq @ A @ A2 @ ( one_one @ A ) ) )
            & ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
             => ( ord_less_eq @ A @ ( one_one @ A ) @ A2 ) ) ) ) ) ).

% mult_le_cancel_left2
thf(fact_728_mult__le__cancel__right1,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [C2: A,B2: A] :
          ( ( ord_less_eq @ A @ C2 @ ( times_times @ A @ B2 @ C2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less_eq @ A @ ( one_one @ A ) @ B2 ) )
            & ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
             => ( ord_less_eq @ A @ B2 @ ( one_one @ A ) ) ) ) ) ) ).

% mult_le_cancel_right1
thf(fact_729_mult__le__cancel__right2,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A,C2: A] :
          ( ( ord_less_eq @ A @ ( times_times @ A @ A2 @ C2 ) @ C2 )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less_eq @ A @ A2 @ ( one_one @ A ) ) )
            & ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
             => ( ord_less_eq @ A @ ( one_one @ A ) @ A2 ) ) ) ) ) ).

% mult_le_cancel_right2
thf(fact_730_mult__less__cancel__left1,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [C2: A,B2: A] :
          ( ( ord_less @ A @ C2 @ ( times_times @ A @ C2 @ B2 ) )
          = ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less @ A @ ( one_one @ A ) @ B2 ) )
            & ( ( ord_less_eq @ A @ C2 @ ( zero_zero @ A ) )
             => ( ord_less @ A @ B2 @ ( one_one @ A ) ) ) ) ) ) ).

% mult_less_cancel_left1
thf(fact_731_mult__less__cancel__left2,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [C2: A,A2: A] :
          ( ( ord_less @ A @ ( times_times @ A @ C2 @ A2 ) @ C2 )
          = ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less @ A @ A2 @ ( one_one @ A ) ) )
            & ( ( ord_less_eq @ A @ C2 @ ( zero_zero @ A ) )
             => ( ord_less @ A @ ( one_one @ A ) @ A2 ) ) ) ) ) ).

% mult_less_cancel_left2
thf(fact_732_mult__less__cancel__right1,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [C2: A,B2: A] :
          ( ( ord_less @ A @ C2 @ ( times_times @ A @ B2 @ C2 ) )
          = ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less @ A @ ( one_one @ A ) @ B2 ) )
            & ( ( ord_less_eq @ A @ C2 @ ( zero_zero @ A ) )
             => ( ord_less @ A @ B2 @ ( one_one @ A ) ) ) ) ) ) ).

% mult_less_cancel_right1
thf(fact_733_mult__less__cancel__right2,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A,C2: A] :
          ( ( ord_less @ A @ ( times_times @ A @ A2 @ C2 ) @ C2 )
          = ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less @ A @ A2 @ ( one_one @ A ) ) )
            & ( ( ord_less_eq @ A @ C2 @ ( zero_zero @ A ) )
             => ( ord_less @ A @ ( one_one @ A ) @ A2 ) ) ) ) ) ).

% mult_less_cancel_right2
thf(fact_734_convex__bound__le,axiom,
    ! [A: $tType] :
      ( ( linord6961819062388156250ring_1 @ A )
     => ! [X2: A,A2: A,Y2: A,U: A,V: A] :
          ( ( ord_less_eq @ A @ X2 @ A2 )
         => ( ( ord_less_eq @ A @ Y2 @ A2 )
           => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ U )
             => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ V )
               => ( ( ( plus_plus @ A @ U @ V )
                    = ( one_one @ A ) )
                 => ( ord_less_eq @ A @ ( plus_plus @ A @ ( times_times @ A @ U @ X2 ) @ ( times_times @ A @ V @ Y2 ) ) @ A2 ) ) ) ) ) ) ) ).

% convex_bound_le
thf(fact_735_Suc__double__not__eq__double,axiom,
    ! [M: nat,N2: nat] :
      ( ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M ) )
     != ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) ).

% Suc_double_not_eq_double
thf(fact_736_double__not__eq__Suc__double,axiom,
    ! [M: nat,N2: nat] :
      ( ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M )
     != ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) ) ).

% double_not_eq_Suc_double
thf(fact_737_sum__squares__le__zero__iff,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [X2: A,Y2: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ ( times_times @ A @ X2 @ X2 ) @ ( times_times @ A @ Y2 @ Y2 ) ) @ ( zero_zero @ A ) )
          = ( ( X2
              = ( zero_zero @ A ) )
            & ( Y2
              = ( zero_zero @ A ) ) ) ) ) ).

% sum_squares_le_zero_iff
thf(fact_738_sum__squares__gt__zero__iff,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [X2: A,Y2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( plus_plus @ A @ ( times_times @ A @ X2 @ X2 ) @ ( times_times @ A @ Y2 @ Y2 ) ) )
          = ( ( X2
             != ( zero_zero @ A ) )
            | ( Y2
             != ( zero_zero @ A ) ) ) ) ) ).

% sum_squares_gt_zero_iff
thf(fact_739_divide__less__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( ord_less @ A @ ( divide_divide @ A @ B2 @ C2 ) @ A2 )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less @ A @ B2 @ ( times_times @ A @ A2 @ C2 ) ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ ( times_times @ A @ A2 @ C2 ) @ B2 ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ ( zero_zero @ A ) @ A2 ) ) ) ) ) ) ) ).

% divide_less_eq
thf(fact_740_less__divide__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less @ A @ A2 @ ( divide_divide @ A @ B2 @ C2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less @ A @ ( times_times @ A @ A2 @ C2 ) @ B2 ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ B2 @ ( times_times @ A @ A2 @ C2 ) ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ A2 @ ( zero_zero @ A ) ) ) ) ) ) ) ) ).

% less_divide_eq
thf(fact_741_neg__divide__less__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ ( divide_divide @ A @ B2 @ C2 ) @ A2 )
            = ( ord_less @ A @ ( times_times @ A @ A2 @ C2 ) @ B2 ) ) ) ) ).

% neg_divide_less_eq
thf(fact_742_neg__less__divide__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ A2 @ ( divide_divide @ A @ B2 @ C2 ) )
            = ( ord_less @ A @ B2 @ ( times_times @ A @ A2 @ C2 ) ) ) ) ) ).

% neg_less_divide_eq
thf(fact_743_pos__divide__less__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
         => ( ( ord_less @ A @ ( divide_divide @ A @ B2 @ C2 ) @ A2 )
            = ( ord_less @ A @ B2 @ ( times_times @ A @ A2 @ C2 ) ) ) ) ) ).

% pos_divide_less_eq
thf(fact_744_pos__less__divide__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
         => ( ( ord_less @ A @ A2 @ ( divide_divide @ A @ B2 @ C2 ) )
            = ( ord_less @ A @ ( times_times @ A @ A2 @ C2 ) @ B2 ) ) ) ) ).

% pos_less_divide_eq
thf(fact_745_mult__imp__div__pos__less,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [Y2: A,X2: A,Z: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ Y2 )
         => ( ( ord_less @ A @ X2 @ ( times_times @ A @ Z @ Y2 ) )
           => ( ord_less @ A @ ( divide_divide @ A @ X2 @ Y2 ) @ Z ) ) ) ) ).

% mult_imp_div_pos_less
thf(fact_746_mult__imp__less__div__pos,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [Y2: A,Z: A,X2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ Y2 )
         => ( ( ord_less @ A @ ( times_times @ A @ Z @ Y2 ) @ X2 )
           => ( ord_less @ A @ Z @ ( divide_divide @ A @ X2 @ Y2 ) ) ) ) ) ).

% mult_imp_less_div_pos
thf(fact_747_divide__strict__left__mono,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( ord_less @ A @ B2 @ A2 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
           => ( ( ord_less @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A2 @ B2 ) )
             => ( ord_less @ A @ ( divide_divide @ A @ C2 @ A2 ) @ ( divide_divide @ A @ C2 @ B2 ) ) ) ) ) ) ).

% divide_strict_left_mono
thf(fact_748_divide__strict__left__mono__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
           => ( ( ord_less @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A2 @ B2 ) )
             => ( ord_less @ A @ ( divide_divide @ A @ C2 @ A2 ) @ ( divide_divide @ A @ C2 @ B2 ) ) ) ) ) ) ).

% divide_strict_left_mono_neg
thf(fact_749_divide__eq__eq__numeral_I1_J,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [B2: A,C2: A,W: num] :
          ( ( ( divide_divide @ A @ B2 @ C2 )
            = ( numeral_numeral @ A @ W ) )
          = ( ( ( C2
               != ( zero_zero @ A ) )
             => ( B2
                = ( times_times @ A @ ( numeral_numeral @ A @ W ) @ C2 ) ) )
            & ( ( C2
                = ( zero_zero @ A ) )
             => ( ( numeral_numeral @ A @ W )
                = ( zero_zero @ A ) ) ) ) ) ) ).

% divide_eq_eq_numeral(1)
thf(fact_750_eq__divide__eq__numeral_I1_J,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [W: num,B2: A,C2: A] :
          ( ( ( numeral_numeral @ A @ W )
            = ( divide_divide @ A @ B2 @ C2 ) )
          = ( ( ( C2
               != ( zero_zero @ A ) )
             => ( ( times_times @ A @ ( numeral_numeral @ A @ W ) @ C2 )
                = B2 ) )
            & ( ( C2
                = ( zero_zero @ A ) )
             => ( ( numeral_numeral @ A @ W )
                = ( zero_zero @ A ) ) ) ) ) ) ).

% eq_divide_eq_numeral(1)
thf(fact_751_add__divide__eq__if__simps_I2_J,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [Z: A,A2: A,B2: A] :
          ( ( ( Z
              = ( zero_zero @ A ) )
           => ( ( plus_plus @ A @ ( divide_divide @ A @ A2 @ Z ) @ B2 )
              = B2 ) )
          & ( ( Z
             != ( zero_zero @ A ) )
           => ( ( plus_plus @ A @ ( divide_divide @ A @ A2 @ Z ) @ B2 )
              = ( divide_divide @ A @ ( plus_plus @ A @ A2 @ ( times_times @ A @ B2 @ Z ) ) @ Z ) ) ) ) ) ).

% add_divide_eq_if_simps(2)
thf(fact_752_add__divide__eq__if__simps_I1_J,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [Z: A,A2: A,B2: A] :
          ( ( ( Z
              = ( zero_zero @ A ) )
           => ( ( plus_plus @ A @ A2 @ ( divide_divide @ A @ B2 @ Z ) )
              = A2 ) )
          & ( ( Z
             != ( zero_zero @ A ) )
           => ( ( plus_plus @ A @ A2 @ ( divide_divide @ A @ B2 @ Z ) )
              = ( divide_divide @ A @ ( plus_plus @ A @ ( times_times @ A @ A2 @ Z ) @ B2 ) @ Z ) ) ) ) ) ).

% add_divide_eq_if_simps(1)
thf(fact_753_add__frac__eq,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [Y2: A,Z: A,X2: A,W: A] :
          ( ( Y2
           != ( zero_zero @ A ) )
         => ( ( Z
             != ( zero_zero @ A ) )
           => ( ( plus_plus @ A @ ( divide_divide @ A @ X2 @ Y2 ) @ ( divide_divide @ A @ W @ Z ) )
              = ( divide_divide @ A @ ( plus_plus @ A @ ( times_times @ A @ X2 @ Z ) @ ( times_times @ A @ W @ Y2 ) ) @ ( times_times @ A @ Y2 @ Z ) ) ) ) ) ) ).

% add_frac_eq
thf(fact_754_add__frac__num,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [Y2: A,X2: A,Z: A] :
          ( ( Y2
           != ( zero_zero @ A ) )
         => ( ( plus_plus @ A @ ( divide_divide @ A @ X2 @ Y2 ) @ Z )
            = ( divide_divide @ A @ ( plus_plus @ A @ X2 @ ( times_times @ A @ Z @ Y2 ) ) @ Y2 ) ) ) ) ).

% add_frac_num
thf(fact_755_add__num__frac,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [Y2: A,Z: A,X2: A] :
          ( ( Y2
           != ( zero_zero @ A ) )
         => ( ( plus_plus @ A @ Z @ ( divide_divide @ A @ X2 @ Y2 ) )
            = ( divide_divide @ A @ ( plus_plus @ A @ X2 @ ( times_times @ A @ Z @ Y2 ) ) @ Y2 ) ) ) ) ).

% add_num_frac
thf(fact_756_add__divide__eq__iff,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [Z: A,X2: A,Y2: A] :
          ( ( Z
           != ( zero_zero @ A ) )
         => ( ( plus_plus @ A @ X2 @ ( divide_divide @ A @ Y2 @ Z ) )
            = ( divide_divide @ A @ ( plus_plus @ A @ ( times_times @ A @ X2 @ Z ) @ Y2 ) @ Z ) ) ) ) ).

% add_divide_eq_iff
thf(fact_757_divide__add__eq__iff,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [Z: A,X2: A,Y2: A] :
          ( ( Z
           != ( zero_zero @ A ) )
         => ( ( plus_plus @ A @ ( divide_divide @ A @ X2 @ Z ) @ Y2 )
            = ( divide_divide @ A @ ( plus_plus @ A @ X2 @ ( times_times @ A @ Y2 @ Z ) ) @ Z ) ) ) ) ).

% divide_add_eq_iff
thf(fact_758_power__gt1__lemma,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,N2: nat] :
          ( ( ord_less @ A @ ( one_one @ A ) @ A2 )
         => ( ord_less @ A @ ( one_one @ A ) @ ( times_times @ A @ A2 @ ( power_power @ A @ A2 @ N2 ) ) ) ) ) ).

% power_gt1_lemma
thf(fact_759_power__less__power__Suc,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,N2: nat] :
          ( ( ord_less @ A @ ( one_one @ A ) @ A2 )
         => ( ord_less @ A @ ( power_power @ A @ A2 @ N2 ) @ ( times_times @ A @ A2 @ ( power_power @ A @ A2 @ N2 ) ) ) ) ) ).

% power_less_power_Suc
thf(fact_760_one__less__mult,axiom,
    ! [N2: nat,M: nat] :
      ( ( ord_less @ nat @ ( suc @ ( zero_zero @ nat ) ) @ N2 )
     => ( ( ord_less @ nat @ ( suc @ ( zero_zero @ nat ) ) @ M )
       => ( ord_less @ nat @ ( suc @ ( zero_zero @ nat ) ) @ ( times_times @ nat @ M @ N2 ) ) ) ) ).

% one_less_mult
thf(fact_761_n__less__m__mult__n,axiom,
    ! [N2: nat,M: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( ord_less @ nat @ ( suc @ ( zero_zero @ nat ) ) @ M )
       => ( ord_less @ nat @ N2 @ ( times_times @ nat @ M @ N2 ) ) ) ) ).

% n_less_m_mult_n
thf(fact_762_n__less__n__mult__m,axiom,
    ! [N2: nat,M: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( ord_less @ nat @ ( suc @ ( zero_zero @ nat ) ) @ M )
       => ( ord_less @ nat @ N2 @ ( times_times @ nat @ N2 @ M ) ) ) ) ).

% n_less_n_mult_m
thf(fact_763_linorder__neqE__linordered__idom,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X2: A,Y2: A] :
          ( ( X2 != Y2 )
         => ( ~ ( ord_less @ A @ X2 @ Y2 )
           => ( ord_less @ A @ Y2 @ X2 ) ) ) ) ).

% linorder_neqE_linordered_idom
thf(fact_764_div__less__iff__less__mult,axiom,
    ! [Q3: nat,M: nat,N2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ Q3 )
     => ( ( ord_less @ nat @ ( divide_divide @ nat @ M @ Q3 ) @ N2 )
        = ( ord_less @ nat @ M @ ( times_times @ nat @ N2 @ Q3 ) ) ) ) ).

% div_less_iff_less_mult
thf(fact_765_convex__bound__lt,axiom,
    ! [A: $tType] :
      ( ( linord715952674999750819strict @ A )
     => ! [X2: A,A2: A,Y2: A,U: A,V: A] :
          ( ( ord_less @ A @ X2 @ A2 )
         => ( ( ord_less @ A @ Y2 @ A2 )
           => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ U )
             => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ V )
               => ( ( ( plus_plus @ A @ U @ V )
                    = ( one_one @ A ) )
                 => ( ord_less @ A @ ( plus_plus @ A @ ( times_times @ A @ U @ X2 ) @ ( times_times @ A @ V @ Y2 ) ) @ A2 ) ) ) ) ) ) ) ).

% convex_bound_lt
thf(fact_766_field__le__mult__one__interval,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X2: A,Y2: A] :
          ( ! [Z3: A] :
              ( ( ord_less @ A @ ( zero_zero @ A ) @ Z3 )
             => ( ( ord_less @ A @ Z3 @ ( one_one @ A ) )
               => ( ord_less_eq @ A @ ( times_times @ A @ Z3 @ X2 ) @ Y2 ) ) )
         => ( ord_less_eq @ A @ X2 @ Y2 ) ) ) ).

% field_le_mult_one_interval
thf(fact_767_divide__le__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( ord_less_eq @ A @ ( divide_divide @ A @ B2 @ C2 ) @ A2 )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less_eq @ A @ B2 @ ( times_times @ A @ A2 @ C2 ) ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ ( times_times @ A @ A2 @ C2 ) @ B2 ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 ) ) ) ) ) ) ) ).

% divide_le_eq
thf(fact_768_le__divide__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ ( divide_divide @ A @ B2 @ C2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less_eq @ A @ ( times_times @ A @ A2 @ C2 ) @ B2 ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ B2 @ ( times_times @ A @ A2 @ C2 ) ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) ) ) ) ) ) ) ) ).

% le_divide_eq
thf(fact_769_divide__left__mono,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( ord_less_eq @ A @ B2 @ A2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
           => ( ( ord_less @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A2 @ B2 ) )
             => ( ord_less_eq @ A @ ( divide_divide @ A @ C2 @ A2 ) @ ( divide_divide @ A @ C2 @ B2 ) ) ) ) ) ) ).

% divide_left_mono
thf(fact_770_neg__divide__le__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ ( divide_divide @ A @ B2 @ C2 ) @ A2 )
            = ( ord_less_eq @ A @ ( times_times @ A @ A2 @ C2 ) @ B2 ) ) ) ) ).

% neg_divide_le_eq
thf(fact_771_neg__le__divide__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ A2 @ ( divide_divide @ A @ B2 @ C2 ) )
            = ( ord_less_eq @ A @ B2 @ ( times_times @ A @ A2 @ C2 ) ) ) ) ) ).

% neg_le_divide_eq
thf(fact_772_pos__divide__le__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
         => ( ( ord_less_eq @ A @ ( divide_divide @ A @ B2 @ C2 ) @ A2 )
            = ( ord_less_eq @ A @ B2 @ ( times_times @ A @ A2 @ C2 ) ) ) ) ) ).

% pos_divide_le_eq
thf(fact_773_pos__le__divide__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
         => ( ( ord_less_eq @ A @ A2 @ ( divide_divide @ A @ B2 @ C2 ) )
            = ( ord_less_eq @ A @ ( times_times @ A @ A2 @ C2 ) @ B2 ) ) ) ) ).

% pos_le_divide_eq
thf(fact_774_mult__imp__div__pos__le,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [Y2: A,X2: A,Z: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ Y2 )
         => ( ( ord_less_eq @ A @ X2 @ ( times_times @ A @ Z @ Y2 ) )
           => ( ord_less_eq @ A @ ( divide_divide @ A @ X2 @ Y2 ) @ Z ) ) ) ) ).

% mult_imp_div_pos_le
thf(fact_775_mult__imp__le__div__pos,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [Y2: A,Z: A,X2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ Y2 )
         => ( ( ord_less_eq @ A @ ( times_times @ A @ Z @ Y2 ) @ X2 )
           => ( ord_less_eq @ A @ Z @ ( divide_divide @ A @ X2 @ Y2 ) ) ) ) ) ).

% mult_imp_le_div_pos
thf(fact_776_divide__left__mono__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ C2 @ ( zero_zero @ A ) )
           => ( ( ord_less @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A2 @ B2 ) )
             => ( ord_less_eq @ A @ ( divide_divide @ A @ C2 @ A2 ) @ ( divide_divide @ A @ C2 @ B2 ) ) ) ) ) ) ).

% divide_left_mono_neg
thf(fact_777_divide__less__eq__numeral_I1_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,C2: A,W: num] :
          ( ( ord_less @ A @ ( divide_divide @ A @ B2 @ C2 ) @ ( numeral_numeral @ A @ W ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less @ A @ B2 @ ( times_times @ A @ ( numeral_numeral @ A @ W ) @ C2 ) ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ ( times_times @ A @ ( numeral_numeral @ A @ W ) @ C2 ) @ B2 ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ ( zero_zero @ A ) @ ( numeral_numeral @ A @ W ) ) ) ) ) ) ) ) ).

% divide_less_eq_numeral(1)
thf(fact_778_less__divide__eq__numeral_I1_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [W: num,B2: A,C2: A] :
          ( ( ord_less @ A @ ( numeral_numeral @ A @ W ) @ ( divide_divide @ A @ B2 @ C2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less @ A @ ( times_times @ A @ ( numeral_numeral @ A @ W ) @ C2 ) @ B2 ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ B2 @ ( times_times @ A @ ( numeral_numeral @ A @ W ) @ C2 ) ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ ( numeral_numeral @ A @ W ) @ ( zero_zero @ A ) ) ) ) ) ) ) ) ).

% less_divide_eq_numeral(1)
thf(fact_779_power__Suc__less,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,N2: nat] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less @ A @ A2 @ ( one_one @ A ) )
           => ( ord_less @ A @ ( times_times @ A @ A2 @ ( power_power @ A @ A2 @ N2 ) ) @ ( power_power @ A @ A2 @ N2 ) ) ) ) ) ).

% power_Suc_less
thf(fact_780_mult__2,axiom,
    ! [A: $tType] :
      ( ( semiring_numeral @ A )
     => ! [Z: A] :
          ( ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ Z )
          = ( plus_plus @ A @ Z @ Z ) ) ) ).

% mult_2
thf(fact_781_mult__2__right,axiom,
    ! [A: $tType] :
      ( ( semiring_numeral @ A )
     => ! [Z: A] :
          ( ( times_times @ A @ Z @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
          = ( plus_plus @ A @ Z @ Z ) ) ) ).

% mult_2_right
thf(fact_782_left__add__twice,axiom,
    ! [A: $tType] :
      ( ( semiring_numeral @ A )
     => ! [A2: A,B2: A] :
          ( ( plus_plus @ A @ A2 @ ( plus_plus @ A @ A2 @ B2 ) )
          = ( plus_plus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) @ B2 ) ) ) ).

% left_add_twice
thf(fact_783_power4__eq__xxxx,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [X2: A] :
          ( ( power_power @ A @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ ( bit0 @ one2 ) ) ) )
          = ( times_times @ A @ ( times_times @ A @ ( times_times @ A @ X2 @ X2 ) @ X2 ) @ X2 ) ) ) ).

% power4_eq_xxxx
thf(fact_784_power2__eq__square,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [A2: A] :
          ( ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
          = ( times_times @ A @ A2 @ A2 ) ) ) ).

% power2_eq_square
thf(fact_785_power__even__eq,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [A2: A,N2: nat] :
          ( ( power_power @ A @ A2 @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) )
          = ( power_power @ A @ ( power_power @ A @ A2 @ N2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ).

% power_even_eq
thf(fact_786_div__nat__eqI,axiom,
    ! [N2: nat,Q3: nat,M: nat] :
      ( ( ord_less_eq @ nat @ ( times_times @ nat @ N2 @ Q3 ) @ M )
     => ( ( ord_less @ nat @ M @ ( times_times @ nat @ N2 @ ( suc @ Q3 ) ) )
       => ( ( divide_divide @ nat @ M @ N2 )
          = Q3 ) ) ) ).

% div_nat_eqI
thf(fact_787_less__eq__div__iff__mult__less__eq,axiom,
    ! [Q3: nat,M: nat,N2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ Q3 )
     => ( ( ord_less_eq @ nat @ M @ ( divide_divide @ nat @ N2 @ Q3 ) )
        = ( ord_less_eq @ nat @ ( times_times @ nat @ M @ Q3 ) @ N2 ) ) ) ).

% less_eq_div_iff_mult_less_eq
thf(fact_788_split__div,axiom,
    ! [P: nat > $o,M: nat,N2: nat] :
      ( ( P @ ( divide_divide @ nat @ M @ N2 ) )
      = ( ( ( N2
            = ( zero_zero @ nat ) )
         => ( P @ ( zero_zero @ nat ) ) )
        & ( ( N2
           != ( zero_zero @ nat ) )
         => ! [I4: nat,J3: nat] :
              ( ( ord_less @ nat @ J3 @ N2 )
             => ( ( M
                  = ( plus_plus @ nat @ ( times_times @ nat @ N2 @ I4 ) @ J3 ) )
               => ( P @ I4 ) ) ) ) ) ) ).

% split_div
thf(fact_789_dividend__less__div__times,axiom,
    ! [N2: nat,M: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ord_less @ nat @ M @ ( plus_plus @ nat @ N2 @ ( times_times @ nat @ ( divide_divide @ nat @ M @ N2 ) @ N2 ) ) ) ) ).

% dividend_less_div_times
thf(fact_790_dividend__less__times__div,axiom,
    ! [N2: nat,M: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ord_less @ nat @ M @ ( plus_plus @ nat @ N2 @ ( times_times @ nat @ N2 @ ( divide_divide @ nat @ M @ N2 ) ) ) ) ) ).

% dividend_less_times_div
thf(fact_791_divide__le__eq__numeral_I1_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,C2: A,W: num] :
          ( ( ord_less_eq @ A @ ( divide_divide @ A @ B2 @ C2 ) @ ( numeral_numeral @ A @ W ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less_eq @ A @ B2 @ ( times_times @ A @ ( numeral_numeral @ A @ W ) @ C2 ) ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ ( times_times @ A @ ( numeral_numeral @ A @ W ) @ C2 ) @ B2 ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( numeral_numeral @ A @ W ) ) ) ) ) ) ) ) ).

% divide_le_eq_numeral(1)
thf(fact_792_le__divide__eq__numeral_I1_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [W: num,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ ( numeral_numeral @ A @ W ) @ ( divide_divide @ A @ B2 @ C2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less_eq @ A @ ( times_times @ A @ ( numeral_numeral @ A @ W ) @ C2 ) @ B2 ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ B2 @ ( times_times @ A @ ( numeral_numeral @ A @ W ) @ C2 ) ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ ( numeral_numeral @ A @ W ) @ ( zero_zero @ A ) ) ) ) ) ) ) ) ).

% le_divide_eq_numeral(1)
thf(fact_793_split__div_H,axiom,
    ! [P: nat > $o,M: nat,N2: nat] :
      ( ( P @ ( divide_divide @ nat @ M @ N2 ) )
      = ( ( ( N2
            = ( zero_zero @ nat ) )
          & ( P @ ( zero_zero @ nat ) ) )
        | ? [Q4: nat] :
            ( ( ord_less_eq @ nat @ ( times_times @ nat @ N2 @ Q4 ) @ M )
            & ( ord_less @ nat @ M @ ( times_times @ nat @ N2 @ ( suc @ Q4 ) ) )
            & ( P @ Q4 ) ) ) ) ).

% split_div'
thf(fact_794_power2__sum,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [X2: A,Y2: A] :
          ( ( power_power @ A @ ( plus_plus @ A @ X2 @ Y2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
          = ( plus_plus @ A @ ( plus_plus @ A @ ( power_power @ A @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ A @ Y2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( times_times @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ X2 ) @ Y2 ) ) ) ) ).

% power2_sum
thf(fact_795_zero__le__even__power_H,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A,N2: nat] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( power_power @ A @ A2 @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) ) ) ).

% zero_le_even_power'
thf(fact_796_nat__bit__induct,axiom,
    ! [P: nat > $o,N2: nat] :
      ( ( P @ ( zero_zero @ nat ) )
     => ( ! [N: nat] :
            ( ( P @ N )
           => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
             => ( P @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ) )
       => ( ! [N: nat] :
              ( ( P @ N )
             => ( P @ ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ) )
         => ( P @ N2 ) ) ) ) ).

% nat_bit_induct
thf(fact_797_field__lbound__gt__zero,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [D1: A,D22: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ D1 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ D22 )
           => ? [E: A] :
                ( ( ord_less @ A @ ( zero_zero @ A ) @ E )
                & ( ord_less @ A @ E @ D1 )
                & ( ord_less @ A @ E @ D22 ) ) ) ) ) ).

% field_lbound_gt_zero
thf(fact_798_zero__neq__one,axiom,
    ! [A: $tType] :
      ( ( zero_neq_one @ A )
     => ( ( zero_zero @ A )
       != ( one_one @ A ) ) ) ).

% zero_neq_one
thf(fact_799_two__realpow__ge__one,axiom,
    ! [N2: nat] : ( ord_less_eq @ real @ ( one_one @ real ) @ ( power_power @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ N2 ) ) ).

% two_realpow_ge_one
thf(fact_800_odd__0__le__power__imp__0__le,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A,N2: nat] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( power_power @ A @ A2 @ ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) ) )
         => ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 ) ) ) ).

% odd_0_le_power_imp_0_le
thf(fact_801_odd__power__less__zero,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A,N2: nat] :
          ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
         => ( ord_less @ A @ ( power_power @ A @ A2 @ ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) ) @ ( zero_zero @ A ) ) ) ) ).

% odd_power_less_zero
thf(fact_802_zero__less__one__class_Ozero__le__one,axiom,
    ! [A: $tType] :
      ( ( zero_less_one @ A )
     => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( one_one @ A ) ) ) ).

% zero_less_one_class.zero_le_one
thf(fact_803_linordered__nonzero__semiring__class_Ozero__le__one,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( one_one @ A ) ) ) ).

% linordered_nonzero_semiring_class.zero_le_one
thf(fact_804_not__one__le__zero,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ~ ( ord_less_eq @ A @ ( one_one @ A ) @ ( zero_zero @ A ) ) ) ).

% not_one_le_zero
thf(fact_805_zero__less__one,axiom,
    ! [A: $tType] :
      ( ( zero_less_one @ A )
     => ( ord_less @ A @ ( zero_zero @ A ) @ ( one_one @ A ) ) ) ).

% zero_less_one
thf(fact_806_not__one__less__zero,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ~ ( ord_less @ A @ ( one_one @ A ) @ ( zero_zero @ A ) ) ) ).

% not_one_less_zero
thf(fact_807_add__less__zeroD,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X2: A,Y2: A] :
          ( ( ord_less @ A @ ( plus_plus @ A @ X2 @ Y2 ) @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ X2 @ ( zero_zero @ A ) )
            | ( ord_less @ A @ Y2 @ ( zero_zero @ A ) ) ) ) ) ).

% add_less_zeroD
thf(fact_808_less__add__one,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A] : ( ord_less @ A @ A2 @ ( plus_plus @ A @ A2 @ ( one_one @ A ) ) ) ) ).

% less_add_one
thf(fact_809_add__mono1,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ord_less @ A @ ( plus_plus @ A @ A2 @ ( one_one @ A ) ) @ ( plus_plus @ A @ B2 @ ( one_one @ A ) ) ) ) ) ).

% add_mono1
thf(fact_810_vebt__insert_Osimps_I2_J,axiom,
    ! [Info: option @ ( product_prod @ nat @ nat ),Ts: list @ vEBT_VEBT,S2: vEBT_VEBT,X2: nat] :
      ( ( vEBT_vebt_insert @ ( vEBT_Node @ Info @ ( zero_zero @ nat ) @ Ts @ S2 ) @ X2 )
      = ( vEBT_Node @ Info @ ( zero_zero @ nat ) @ Ts @ S2 ) ) ).

% vebt_insert.simps(2)
thf(fact_811_zero__less__two,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ( ord_less @ A @ ( zero_zero @ A ) @ ( plus_plus @ A @ ( one_one @ A ) @ ( one_one @ A ) ) ) ) ).

% zero_less_two
thf(fact_812_vebt__insert_Osimps_I3_J,axiom,
    ! [Info: option @ ( product_prod @ nat @ nat ),Ts: list @ vEBT_VEBT,S2: vEBT_VEBT,X2: nat] :
      ( ( vEBT_vebt_insert @ ( vEBT_Node @ Info @ ( suc @ ( zero_zero @ nat ) ) @ Ts @ S2 ) @ X2 )
      = ( vEBT_Node @ Info @ ( suc @ ( zero_zero @ nat ) ) @ Ts @ S2 ) ) ).

% vebt_insert.simps(3)
thf(fact_813_field__sum__of__halves,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X2: A] :
          ( ( plus_plus @ A @ ( divide_divide @ A @ X2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ A @ X2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) )
          = X2 ) ) ).

% field_sum_of_halves
thf(fact_814_arith__geo__mean,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [U: A,X2: A,Y2: A] :
          ( ( ( power_power @ A @ U @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
            = ( times_times @ A @ X2 @ Y2 ) )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X2 )
           => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ Y2 )
             => ( ord_less_eq @ A @ U @ ( divide_divide @ A @ ( plus_plus @ A @ X2 @ Y2 ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% arith_geo_mean
thf(fact_815_sum__squares__bound,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X2: A,Y2: A] : ( ord_less_eq @ A @ ( times_times @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ X2 ) @ Y2 ) @ ( plus_plus @ A @ ( power_power @ A @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ A @ Y2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% sum_squares_bound
thf(fact_816_zdiv__numeral__Bit0,axiom,
    ! [V: num,W: num] :
      ( ( divide_divide @ int @ ( numeral_numeral @ int @ ( bit0 @ V ) ) @ ( numeral_numeral @ int @ ( bit0 @ W ) ) )
      = ( divide_divide @ int @ ( numeral_numeral @ int @ V ) @ ( numeral_numeral @ int @ W ) ) ) ).

% zdiv_numeral_Bit0
thf(fact_817_set__bit__0,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A] :
          ( ( bit_se5668285175392031749et_bit @ A @ ( zero_zero @ nat ) @ A2 )
          = ( plus_plus @ A @ ( one_one @ A ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% set_bit_0
thf(fact_818_invar__vebt_Ocases,axiom,
    ! [A1: vEBT_VEBT,A22: nat] :
      ( ( vEBT_invar_vebt @ A1 @ A22 )
     => ( ( ? [A5: $o,B5: $o] :
              ( A1
              = ( vEBT_Leaf @ A5 @ B5 ) )
         => ( A22
           != ( suc @ ( zero_zero @ nat ) ) ) )
       => ( ! [TreeList2: list @ vEBT_VEBT,N: nat,Summary2: vEBT_VEBT,M3: nat,Deg2: nat] :
              ( ( A1
                = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ Deg2 @ TreeList2 @ Summary2 ) )
             => ( ( A22 = Deg2 )
               => ( ! [X: vEBT_VEBT] :
                      ( ( member @ vEBT_VEBT @ X @ ( set2 @ vEBT_VEBT @ TreeList2 ) )
                     => ( vEBT_invar_vebt @ X @ N ) )
                 => ( ( vEBT_invar_vebt @ Summary2 @ M3 )
                   => ( ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 )
                        = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M3 ) )
                     => ( ( M3 = N )
                       => ( ( Deg2
                            = ( plus_plus @ nat @ N @ M3 ) )
                         => ( ~ ? [X_1: nat] : ( vEBT_V8194947554948674370ptions @ Summary2 @ X_1 )
                           => ~ ! [X: vEBT_VEBT] :
                                  ( ( member @ vEBT_VEBT @ X @ ( set2 @ vEBT_VEBT @ TreeList2 ) )
                                 => ~ ? [X_1: nat] : ( vEBT_V8194947554948674370ptions @ X @ X_1 ) ) ) ) ) ) ) ) ) )
         => ( ! [TreeList2: list @ vEBT_VEBT,N: nat,Summary2: vEBT_VEBT,M3: nat,Deg2: nat] :
                ( ( A1
                  = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ Deg2 @ TreeList2 @ Summary2 ) )
               => ( ( A22 = Deg2 )
                 => ( ! [X: vEBT_VEBT] :
                        ( ( member @ vEBT_VEBT @ X @ ( set2 @ vEBT_VEBT @ TreeList2 ) )
                       => ( vEBT_invar_vebt @ X @ N ) )
                   => ( ( vEBT_invar_vebt @ Summary2 @ M3 )
                     => ( ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 )
                          = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M3 ) )
                       => ( ( M3
                            = ( suc @ N ) )
                         => ( ( Deg2
                              = ( plus_plus @ nat @ N @ M3 ) )
                           => ( ~ ? [X_1: nat] : ( vEBT_V8194947554948674370ptions @ Summary2 @ X_1 )
                             => ~ ! [X: vEBT_VEBT] :
                                    ( ( member @ vEBT_VEBT @ X @ ( set2 @ vEBT_VEBT @ TreeList2 ) )
                                   => ~ ? [X_1: nat] : ( vEBT_V8194947554948674370ptions @ X @ X_1 ) ) ) ) ) ) ) ) ) )
           => ( ! [TreeList2: list @ vEBT_VEBT,N: nat,Summary2: vEBT_VEBT,M3: nat,Deg2: nat,Mi2: nat,Ma2: nat] :
                  ( ( A1
                    = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ Ma2 ) ) @ Deg2 @ TreeList2 @ Summary2 ) )
                 => ( ( A22 = Deg2 )
                   => ( ! [X: vEBT_VEBT] :
                          ( ( member @ vEBT_VEBT @ X @ ( set2 @ vEBT_VEBT @ TreeList2 ) )
                         => ( vEBT_invar_vebt @ X @ N ) )
                     => ( ( vEBT_invar_vebt @ Summary2 @ M3 )
                       => ( ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 )
                            = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M3 ) )
                         => ( ( M3 = N )
                           => ( ( Deg2
                                = ( plus_plus @ nat @ N @ M3 ) )
                             => ( ! [I: nat] :
                                    ( ( ord_less @ nat @ I @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M3 ) )
                                   => ( ( ? [X4: nat] : ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList2 @ I ) @ X4 ) )
                                      = ( vEBT_V8194947554948674370ptions @ Summary2 @ I ) ) )
                               => ( ( ( Mi2 = Ma2 )
                                   => ! [X: vEBT_VEBT] :
                                        ( ( member @ vEBT_VEBT @ X @ ( set2 @ vEBT_VEBT @ TreeList2 ) )
                                       => ~ ? [X_1: nat] : ( vEBT_V8194947554948674370ptions @ X @ X_1 ) ) )
                                 => ( ( ord_less_eq @ nat @ Mi2 @ Ma2 )
                                   => ( ( ord_less @ nat @ Ma2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg2 ) )
                                     => ~ ( ( Mi2 != Ma2 )
                                         => ! [I: nat] :
                                              ( ( ord_less @ nat @ I @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M3 ) )
                                             => ( ( ( ( vEBT_VEBT_high @ Ma2 @ N )
                                                    = I )
                                                 => ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList2 @ I ) @ ( vEBT_VEBT_low @ Ma2 @ N ) ) )
                                                & ! [X: nat] :
                                                    ( ( ( ( vEBT_VEBT_high @ X @ N )
                                                        = I )
                                                      & ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList2 @ I ) @ ( vEBT_VEBT_low @ X @ N ) ) )
                                                   => ( ( ord_less @ nat @ Mi2 @ X )
                                                      & ( ord_less_eq @ nat @ X @ Ma2 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) )
             => ~ ! [TreeList2: list @ vEBT_VEBT,N: nat,Summary2: vEBT_VEBT,M3: nat,Deg2: nat,Mi2: nat,Ma2: nat] :
                    ( ( A1
                      = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ Ma2 ) ) @ Deg2 @ TreeList2 @ Summary2 ) )
                   => ( ( A22 = Deg2 )
                     => ( ! [X: vEBT_VEBT] :
                            ( ( member @ vEBT_VEBT @ X @ ( set2 @ vEBT_VEBT @ TreeList2 ) )
                           => ( vEBT_invar_vebt @ X @ N ) )
                       => ( ( vEBT_invar_vebt @ Summary2 @ M3 )
                         => ( ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 )
                              = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M3 ) )
                           => ( ( M3
                                = ( suc @ N ) )
                             => ( ( Deg2
                                  = ( plus_plus @ nat @ N @ M3 ) )
                               => ( ! [I: nat] :
                                      ( ( ord_less @ nat @ I @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M3 ) )
                                     => ( ( ? [X4: nat] : ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList2 @ I ) @ X4 ) )
                                        = ( vEBT_V8194947554948674370ptions @ Summary2 @ I ) ) )
                                 => ( ( ( Mi2 = Ma2 )
                                     => ! [X: vEBT_VEBT] :
                                          ( ( member @ vEBT_VEBT @ X @ ( set2 @ vEBT_VEBT @ TreeList2 ) )
                                         => ~ ? [X_1: nat] : ( vEBT_V8194947554948674370ptions @ X @ X_1 ) ) )
                                   => ( ( ord_less_eq @ nat @ Mi2 @ Ma2 )
                                     => ( ( ord_less @ nat @ Ma2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg2 ) )
                                       => ~ ( ( Mi2 != Ma2 )
                                           => ! [I: nat] :
                                                ( ( ord_less @ nat @ I @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M3 ) )
                                               => ( ( ( ( vEBT_VEBT_high @ Ma2 @ N )
                                                      = I )
                                                   => ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList2 @ I ) @ ( vEBT_VEBT_low @ Ma2 @ N ) ) )
                                                  & ! [X: nat] :
                                                      ( ( ( ( vEBT_VEBT_high @ X @ N )
                                                          = I )
                                                        & ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList2 @ I ) @ ( vEBT_VEBT_low @ X @ N ) ) )
                                                     => ( ( ord_less @ nat @ Mi2 @ X )
                                                        & ( ord_less_eq @ nat @ X @ Ma2 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ).

% invar_vebt.cases
thf(fact_819_invar__vebt_Osimps,axiom,
    ( vEBT_invar_vebt
    = ( ^ [A12: vEBT_VEBT,A23: nat] :
          ( ( ? [A4: $o,B4: $o] :
                ( A12
                = ( vEBT_Leaf @ A4 @ B4 ) )
            & ( A23
              = ( suc @ ( zero_zero @ nat ) ) ) )
          | ? [TreeList3: list @ vEBT_VEBT,N3: nat,Summary3: vEBT_VEBT] :
              ( ( A12
                = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ A23 @ TreeList3 @ Summary3 ) )
              & ! [X5: vEBT_VEBT] :
                  ( ( member @ vEBT_VEBT @ X5 @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                 => ( vEBT_invar_vebt @ X5 @ N3 ) )
              & ( vEBT_invar_vebt @ Summary3 @ N3 )
              & ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 )
                = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N3 ) )
              & ( A23
                = ( plus_plus @ nat @ N3 @ N3 ) )
              & ~ ? [X4: nat] : ( vEBT_V8194947554948674370ptions @ Summary3 @ X4 )
              & ! [X5: vEBT_VEBT] :
                  ( ( member @ vEBT_VEBT @ X5 @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                 => ~ ? [X4: nat] : ( vEBT_V8194947554948674370ptions @ X5 @ X4 ) ) )
          | ? [TreeList3: list @ vEBT_VEBT,N3: nat,Summary3: vEBT_VEBT] :
              ( ( A12
                = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ A23 @ TreeList3 @ Summary3 ) )
              & ! [X5: vEBT_VEBT] :
                  ( ( member @ vEBT_VEBT @ X5 @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                 => ( vEBT_invar_vebt @ X5 @ N3 ) )
              & ( vEBT_invar_vebt @ Summary3 @ ( suc @ N3 ) )
              & ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 )
                = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( suc @ N3 ) ) )
              & ( A23
                = ( plus_plus @ nat @ N3 @ ( suc @ N3 ) ) )
              & ~ ? [X4: nat] : ( vEBT_V8194947554948674370ptions @ Summary3 @ X4 )
              & ! [X5: vEBT_VEBT] :
                  ( ( member @ vEBT_VEBT @ X5 @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                 => ~ ? [X4: nat] : ( vEBT_V8194947554948674370ptions @ X5 @ X4 ) ) )
          | ? [TreeList3: list @ vEBT_VEBT,N3: nat,Summary3: vEBT_VEBT,Mi3: nat,Ma3: nat] :
              ( ( A12
                = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi3 @ Ma3 ) ) @ A23 @ TreeList3 @ Summary3 ) )
              & ! [X5: vEBT_VEBT] :
                  ( ( member @ vEBT_VEBT @ X5 @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                 => ( vEBT_invar_vebt @ X5 @ N3 ) )
              & ( vEBT_invar_vebt @ Summary3 @ N3 )
              & ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 )
                = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N3 ) )
              & ( A23
                = ( plus_plus @ nat @ N3 @ N3 ) )
              & ! [I4: nat] :
                  ( ( ord_less @ nat @ I4 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N3 ) )
                 => ( ( ? [X4: nat] : ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList3 @ I4 ) @ X4 ) )
                    = ( vEBT_V8194947554948674370ptions @ Summary3 @ I4 ) ) )
              & ( ( Mi3 = Ma3 )
               => ! [X5: vEBT_VEBT] :
                    ( ( member @ vEBT_VEBT @ X5 @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                   => ~ ? [X4: nat] : ( vEBT_V8194947554948674370ptions @ X5 @ X4 ) ) )
              & ( ord_less_eq @ nat @ Mi3 @ Ma3 )
              & ( ord_less @ nat @ Ma3 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ A23 ) )
              & ( ( Mi3 != Ma3 )
               => ! [I4: nat] :
                    ( ( ord_less @ nat @ I4 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N3 ) )
                   => ( ( ( ( vEBT_VEBT_high @ Ma3 @ N3 )
                          = I4 )
                       => ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList3 @ I4 ) @ ( vEBT_VEBT_low @ Ma3 @ N3 ) ) )
                      & ! [X5: nat] :
                          ( ( ( ( vEBT_VEBT_high @ X5 @ N3 )
                              = I4 )
                            & ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList3 @ I4 ) @ ( vEBT_VEBT_low @ X5 @ N3 ) ) )
                         => ( ( ord_less @ nat @ Mi3 @ X5 )
                            & ( ord_less_eq @ nat @ X5 @ Ma3 ) ) ) ) ) ) )
          | ? [TreeList3: list @ vEBT_VEBT,N3: nat,Summary3: vEBT_VEBT,Mi3: nat,Ma3: nat] :
              ( ( A12
                = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi3 @ Ma3 ) ) @ A23 @ TreeList3 @ Summary3 ) )
              & ! [X5: vEBT_VEBT] :
                  ( ( member @ vEBT_VEBT @ X5 @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                 => ( vEBT_invar_vebt @ X5 @ N3 ) )
              & ( vEBT_invar_vebt @ Summary3 @ ( suc @ N3 ) )
              & ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 )
                = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( suc @ N3 ) ) )
              & ( A23
                = ( plus_plus @ nat @ N3 @ ( suc @ N3 ) ) )
              & ! [I4: nat] :
                  ( ( ord_less @ nat @ I4 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( suc @ N3 ) ) )
                 => ( ( ? [X4: nat] : ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList3 @ I4 ) @ X4 ) )
                    = ( vEBT_V8194947554948674370ptions @ Summary3 @ I4 ) ) )
              & ( ( Mi3 = Ma3 )
               => ! [X5: vEBT_VEBT] :
                    ( ( member @ vEBT_VEBT @ X5 @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                   => ~ ? [X4: nat] : ( vEBT_V8194947554948674370ptions @ X5 @ X4 ) ) )
              & ( ord_less_eq @ nat @ Mi3 @ Ma3 )
              & ( ord_less @ nat @ Ma3 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ A23 ) )
              & ( ( Mi3 != Ma3 )
               => ! [I4: nat] :
                    ( ( ord_less @ nat @ I4 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( suc @ N3 ) ) )
                   => ( ( ( ( vEBT_VEBT_high @ Ma3 @ N3 )
                          = I4 )
                       => ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList3 @ I4 ) @ ( vEBT_VEBT_low @ Ma3 @ N3 ) ) )
                      & ! [X5: nat] :
                          ( ( ( ( vEBT_VEBT_high @ X5 @ N3 )
                              = I4 )
                            & ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList3 @ I4 ) @ ( vEBT_VEBT_low @ X5 @ N3 ) ) )
                         => ( ( ord_less @ nat @ Mi3 @ X5 )
                            & ( ord_less_eq @ nat @ X5 @ Ma3 ) ) ) ) ) ) ) ) ) ) ).

% invar_vebt.simps
thf(fact_820_vebt__member_Osimps_I4_J,axiom,
    ! [V: product_prod @ nat @ nat,Vb: list @ vEBT_VEBT,Vc: vEBT_VEBT,X2: nat] :
      ~ ( vEBT_vebt_member @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ V ) @ ( suc @ ( zero_zero @ nat ) ) @ Vb @ Vc ) @ X2 ) ).

% vebt_member.simps(4)
thf(fact_821_not__Some__eq,axiom,
    ! [A: $tType,X2: option @ A] :
      ( ( ! [Y5: A] :
            ( X2
           != ( some @ A @ Y5 ) ) )
      = ( X2
        = ( none @ A ) ) ) ).

% not_Some_eq
thf(fact_822_not__None__eq,axiom,
    ! [A: $tType,X2: option @ A] :
      ( ( ( X2
         != ( none @ A ) ) )
      = ( ? [Y5: A] :
            ( X2
            = ( some @ A @ Y5 ) ) ) ) ).

% not_None_eq
thf(fact_823_Leaf__0__not,axiom,
    ! [A2: $o,B2: $o] :
      ~ ( vEBT_invar_vebt @ ( vEBT_Leaf @ A2 @ B2 ) @ ( zero_zero @ nat ) ) ).

% Leaf_0_not
thf(fact_824_deg1Leaf,axiom,
    ! [T2: vEBT_VEBT] :
      ( ( vEBT_invar_vebt @ T2 @ ( one_one @ nat ) )
      = ( ? [A4: $o,B4: $o] :
            ( T2
            = ( vEBT_Leaf @ A4 @ B4 ) ) ) ) ).

% deg1Leaf
thf(fact_825_deg__1__Leaf,axiom,
    ! [T2: vEBT_VEBT] :
      ( ( vEBT_invar_vebt @ T2 @ ( one_one @ nat ) )
     => ? [A5: $o,B5: $o] :
          ( T2
          = ( vEBT_Leaf @ A5 @ B5 ) ) ) ).

% deg_1_Leaf
thf(fact_826_deg__1__Leafy,axiom,
    ! [T2: vEBT_VEBT,N2: nat] :
      ( ( vEBT_invar_vebt @ T2 @ N2 )
     => ( ( N2
          = ( one_one @ nat ) )
       => ? [A5: $o,B5: $o] :
            ( T2
            = ( vEBT_Leaf @ A5 @ B5 ) ) ) ) ).

% deg_1_Leafy
thf(fact_827_option_Oinject,axiom,
    ! [A: $tType,X22: A,Y22: A] :
      ( ( ( some @ A @ X22 )
        = ( some @ A @ Y22 ) )
      = ( X22 = Y22 ) ) ).

% option.inject
thf(fact_828_VEBT_Oinject_I2_J,axiom,
    ! [X21: $o,X222: $o,Y21: $o,Y222: $o] :
      ( ( ( vEBT_Leaf @ X21 @ X222 )
        = ( vEBT_Leaf @ Y21 @ Y222 ) )
      = ( ( X21 = Y21 )
        & ( X222 = Y222 ) ) ) ).

% VEBT.inject(2)
thf(fact_829_set__bit__nonnegative__int__iff,axiom,
    ! [N2: nat,K: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( bit_se5668285175392031749et_bit @ int @ N2 @ K ) )
      = ( ord_less_eq @ int @ ( zero_zero @ int ) @ K ) ) ).

% set_bit_nonnegative_int_iff
thf(fact_830_set__bit__negative__int__iff,axiom,
    ! [N2: nat,K: int] :
      ( ( ord_less @ int @ ( bit_se5668285175392031749et_bit @ int @ N2 @ K ) @ ( zero_zero @ int ) )
      = ( ord_less @ int @ K @ ( zero_zero @ int ) ) ) ).

% set_bit_negative_int_iff
thf(fact_831_semiring__norm_I13_J,axiom,
    ! [M: num,N2: num] :
      ( ( times_times @ num @ ( bit0 @ M ) @ ( bit0 @ N2 ) )
      = ( bit0 @ ( bit0 @ ( times_times @ num @ M @ N2 ) ) ) ) ).

% semiring_norm(13)
thf(fact_832_semiring__norm_I11_J,axiom,
    ! [M: num] :
      ( ( times_times @ num @ M @ one2 )
      = M ) ).

% semiring_norm(11)
thf(fact_833_semiring__norm_I12_J,axiom,
    ! [N2: num] :
      ( ( times_times @ num @ one2 @ N2 )
      = N2 ) ).

% semiring_norm(12)
thf(fact_834_num__double,axiom,
    ! [N2: num] :
      ( ( times_times @ num @ ( bit0 @ one2 ) @ N2 )
      = ( bit0 @ N2 ) ) ).

% num_double
thf(fact_835_power__mult__numeral,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [A2: A,M: num,N2: num] :
          ( ( power_power @ A @ ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ M ) ) @ ( numeral_numeral @ nat @ N2 ) )
          = ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ ( times_times @ num @ M @ N2 ) ) ) ) ) ).

% power_mult_numeral
thf(fact_836_real__arch__pow,axiom,
    ! [X2: real,Y2: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ X2 )
     => ? [N: nat] : ( ord_less @ real @ Y2 @ ( power_power @ real @ X2 @ N ) ) ) ).

% real_arch_pow
thf(fact_837_real__arch__pow__inv,axiom,
    ! [Y2: real,X2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ Y2 )
     => ( ( ord_less @ real @ X2 @ ( one_one @ real ) )
       => ? [N: nat] : ( ord_less @ real @ ( power_power @ real @ X2 @ N ) @ Y2 ) ) ) ).

% real_arch_pow_inv
thf(fact_838_less__eq__real__def,axiom,
    ( ( ord_less_eq @ real )
    = ( ^ [X5: real,Y5: real] :
          ( ( ord_less @ real @ X5 @ Y5 )
          | ( X5 = Y5 ) ) ) ) ).

% less_eq_real_def
thf(fact_839_complete__real,axiom,
    ! [S3: set @ real] :
      ( ? [X: real] : ( member @ real @ X @ S3 )
     => ( ? [Z4: real] :
          ! [X3: real] :
            ( ( member @ real @ X3 @ S3 )
           => ( ord_less_eq @ real @ X3 @ Z4 ) )
       => ? [Y4: real] :
            ( ! [X: real] :
                ( ( member @ real @ X @ S3 )
               => ( ord_less_eq @ real @ X @ Y4 ) )
            & ! [Z4: real] :
                ( ! [X3: real] :
                    ( ( member @ real @ X3 @ S3 )
                   => ( ord_less_eq @ real @ X3 @ Z4 ) )
               => ( ord_less_eq @ real @ Y4 @ Z4 ) ) ) ) ) ).

% complete_real
thf(fact_840_VEBT_Osize_I4_J,axiom,
    ! [X21: $o,X222: $o] :
      ( ( size_size @ vEBT_VEBT @ ( vEBT_Leaf @ X21 @ X222 ) )
      = ( zero_zero @ nat ) ) ).

% VEBT.size(4)
thf(fact_841_VEBT_Odistinct_I1_J,axiom,
    ! [X11: option @ ( product_prod @ nat @ nat ),X12: nat,X13: list @ vEBT_VEBT,X14: vEBT_VEBT,X21: $o,X222: $o] :
      ( ( vEBT_Node @ X11 @ X12 @ X13 @ X14 )
     != ( vEBT_Leaf @ X21 @ X222 ) ) ).

% VEBT.distinct(1)
thf(fact_842_VEBT_Oexhaust,axiom,
    ! [Y2: vEBT_VEBT] :
      ( ! [X112: option @ ( product_prod @ nat @ nat ),X122: nat,X132: list @ vEBT_VEBT,X142: vEBT_VEBT] :
          ( Y2
         != ( vEBT_Node @ X112 @ X122 @ X132 @ X142 ) )
     => ~ ! [X212: $o,X223: $o] :
            ( Y2
           != ( vEBT_Leaf @ X212 @ X223 ) ) ) ).

% VEBT.exhaust
thf(fact_843_set__bit__greater__eq,axiom,
    ! [K: int,N2: nat] : ( ord_less_eq @ int @ K @ ( bit_se5668285175392031749et_bit @ int @ N2 @ K ) ) ).

% set_bit_greater_eq
thf(fact_844_L2__set__mult__ineq__lemma,axiom,
    ! [A2: real,C2: real,B2: real,D2: real] : ( ord_less_eq @ real @ ( times_times @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( times_times @ real @ A2 @ C2 ) ) @ ( times_times @ real @ B2 @ D2 ) ) @ ( plus_plus @ real @ ( times_times @ real @ ( power_power @ real @ A2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ D2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( times_times @ real @ ( power_power @ real @ B2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ C2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% L2_set_mult_ineq_lemma
thf(fact_845_four__x__squared,axiom,
    ! [X2: real] :
      ( ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
      = ( power_power @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ X2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ).

% four_x_squared
thf(fact_846_div__mult2__numeral__eq,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [A2: A,K: num,L: num] :
          ( ( divide_divide @ A @ ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ K ) ) @ ( numeral_numeral @ A @ L ) )
          = ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( times_times @ num @ K @ L ) ) ) ) ) ).

% div_mult2_numeral_eq
thf(fact_847_vebt__member_Osimps_I1_J,axiom,
    ! [A2: $o,B2: $o,X2: nat] :
      ( ( vEBT_vebt_member @ ( vEBT_Leaf @ A2 @ B2 ) @ X2 )
      = ( ( ( X2
            = ( zero_zero @ nat ) )
         => A2 )
        & ( ( X2
           != ( zero_zero @ nat ) )
         => ( ( ( X2
                = ( one_one @ nat ) )
             => B2 )
            & ( X2
              = ( one_one @ nat ) ) ) ) ) ) ).

% vebt_member.simps(1)
thf(fact_848_VEBT__internal_OminNull_Ocases,axiom,
    ! [X2: vEBT_VEBT] :
      ( ( X2
       != ( vEBT_Leaf @ $false @ $false ) )
     => ( ! [Uv: $o] :
            ( X2
           != ( vEBT_Leaf @ $true @ Uv ) )
       => ( ! [Uu: $o] :
              ( X2
             != ( vEBT_Leaf @ Uu @ $true ) )
         => ( ! [Uw: nat,Ux: list @ vEBT_VEBT,Uy: vEBT_VEBT] :
                ( X2
               != ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ Uw @ Ux @ Uy ) )
           => ~ ! [Uz: product_prod @ nat @ nat,Va2: nat,Vb2: list @ vEBT_VEBT,Vc2: vEBT_VEBT] :
                  ( X2
                 != ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ Uz ) @ Va2 @ Vb2 @ Vc2 ) ) ) ) ) ) ).

% VEBT_internal.minNull.cases
thf(fact_849_vebt__buildup_Osimps_I1_J,axiom,
    ( ( vEBT_vebt_buildup @ ( zero_zero @ nat ) )
    = ( vEBT_Leaf @ $false @ $false ) ) ).

% vebt_buildup.simps(1)
thf(fact_850_q__pos__lemma,axiom,
    ! [B6: int,Q5: int,R2: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( plus_plus @ int @ ( times_times @ int @ B6 @ Q5 ) @ R2 ) )
     => ( ( ord_less @ int @ R2 @ B6 )
       => ( ( ord_less @ int @ ( zero_zero @ int ) @ B6 )
         => ( ord_less_eq @ int @ ( zero_zero @ int ) @ Q5 ) ) ) ) ).

% q_pos_lemma
thf(fact_851_zdiv__mono2__lemma,axiom,
    ! [B2: int,Q3: int,R3: int,B6: int,Q5: int,R2: int] :
      ( ( ( plus_plus @ int @ ( times_times @ int @ B2 @ Q3 ) @ R3 )
        = ( plus_plus @ int @ ( times_times @ int @ B6 @ Q5 ) @ R2 ) )
     => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( plus_plus @ int @ ( times_times @ int @ B6 @ Q5 ) @ R2 ) )
       => ( ( ord_less @ int @ R2 @ B6 )
         => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ R3 )
           => ( ( ord_less @ int @ ( zero_zero @ int ) @ B6 )
             => ( ( ord_less_eq @ int @ B6 @ B2 )
               => ( ord_less_eq @ int @ Q3 @ Q5 ) ) ) ) ) ) ) ).

% zdiv_mono2_lemma
thf(fact_852_zdiv__mono2__neg__lemma,axiom,
    ! [B2: int,Q3: int,R3: int,B6: int,Q5: int,R2: int] :
      ( ( ( plus_plus @ int @ ( times_times @ int @ B2 @ Q3 ) @ R3 )
        = ( plus_plus @ int @ ( times_times @ int @ B6 @ Q5 ) @ R2 ) )
     => ( ( ord_less @ int @ ( plus_plus @ int @ ( times_times @ int @ B6 @ Q5 ) @ R2 ) @ ( zero_zero @ int ) )
       => ( ( ord_less @ int @ R3 @ B2 )
         => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ R2 )
           => ( ( ord_less @ int @ ( zero_zero @ int ) @ B6 )
             => ( ( ord_less_eq @ int @ B6 @ B2 )
               => ( ord_less_eq @ int @ Q5 @ Q3 ) ) ) ) ) ) ) ).

% zdiv_mono2_neg_lemma
thf(fact_853_unique__quotient__lemma,axiom,
    ! [B2: int,Q5: int,R2: int,Q3: int,R3: int] :
      ( ( ord_less_eq @ int @ ( plus_plus @ int @ ( times_times @ int @ B2 @ Q5 ) @ R2 ) @ ( plus_plus @ int @ ( times_times @ int @ B2 @ Q3 ) @ R3 ) )
     => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ R2 )
       => ( ( ord_less @ int @ R2 @ B2 )
         => ( ( ord_less @ int @ R3 @ B2 )
           => ( ord_less_eq @ int @ Q5 @ Q3 ) ) ) ) ) ).

% unique_quotient_lemma
thf(fact_854_unique__quotient__lemma__neg,axiom,
    ! [B2: int,Q5: int,R2: int,Q3: int,R3: int] :
      ( ( ord_less_eq @ int @ ( plus_plus @ int @ ( times_times @ int @ B2 @ Q5 ) @ R2 ) @ ( plus_plus @ int @ ( times_times @ int @ B2 @ Q3 ) @ R3 ) )
     => ( ( ord_less_eq @ int @ R3 @ ( zero_zero @ int ) )
       => ( ( ord_less @ int @ B2 @ R3 )
         => ( ( ord_less @ int @ B2 @ R2 )
           => ( ord_less_eq @ int @ Q3 @ Q5 ) ) ) ) ) ).

% unique_quotient_lemma_neg
thf(fact_855_VEBT__internal_Ovalid_H_Osimps_I1_J,axiom,
    ! [Uu2: $o,Uv2: $o,D2: nat] :
      ( ( vEBT_VEBT_valid @ ( vEBT_Leaf @ Uu2 @ Uv2 ) @ D2 )
      = ( D2
        = ( one_one @ nat ) ) ) ).

% VEBT_internal.valid'.simps(1)
thf(fact_856_invar__vebt_Ointros_I1_J,axiom,
    ! [A2: $o,B2: $o] : ( vEBT_invar_vebt @ ( vEBT_Leaf @ A2 @ B2 ) @ ( suc @ ( zero_zero @ nat ) ) ) ).

% invar_vebt.intros(1)
thf(fact_857_int__div__pos__eq,axiom,
    ! [A2: int,B2: int,Q3: int,R3: int] :
      ( ( A2
        = ( plus_plus @ int @ ( times_times @ int @ B2 @ Q3 ) @ R3 ) )
     => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ R3 )
       => ( ( ord_less @ int @ R3 @ B2 )
         => ( ( divide_divide @ int @ A2 @ B2 )
            = Q3 ) ) ) ) ).

% int_div_pos_eq
thf(fact_858_int__div__neg__eq,axiom,
    ! [A2: int,B2: int,Q3: int,R3: int] :
      ( ( A2
        = ( plus_plus @ int @ ( times_times @ int @ B2 @ Q3 ) @ R3 ) )
     => ( ( ord_less_eq @ int @ R3 @ ( zero_zero @ int ) )
       => ( ( ord_less @ int @ B2 @ R3 )
         => ( ( divide_divide @ int @ A2 @ B2 )
            = Q3 ) ) ) ) ).

% int_div_neg_eq
thf(fact_859_split__zdiv,axiom,
    ! [P: int > $o,N2: int,K: int] :
      ( ( P @ ( divide_divide @ int @ N2 @ K ) )
      = ( ( ( K
            = ( zero_zero @ int ) )
         => ( P @ ( zero_zero @ int ) ) )
        & ( ( ord_less @ int @ ( zero_zero @ int ) @ K )
         => ! [I4: int,J3: int] :
              ( ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ J3 )
                & ( ord_less @ int @ J3 @ K )
                & ( N2
                  = ( plus_plus @ int @ ( times_times @ int @ K @ I4 ) @ J3 ) ) )
             => ( P @ I4 ) ) )
        & ( ( ord_less @ int @ K @ ( zero_zero @ int ) )
         => ! [I4: int,J3: int] :
              ( ( ( ord_less @ int @ K @ J3 )
                & ( ord_less_eq @ int @ J3 @ ( zero_zero @ int ) )
                & ( N2
                  = ( plus_plus @ int @ ( times_times @ int @ K @ I4 ) @ J3 ) ) )
             => ( P @ I4 ) ) ) ) ) ).

% split_zdiv
thf(fact_860_vebt__buildup_Osimps_I2_J,axiom,
    ( ( vEBT_vebt_buildup @ ( suc @ ( zero_zero @ nat ) ) )
    = ( vEBT_Leaf @ $false @ $false ) ) ).

% vebt_buildup.simps(2)
thf(fact_861_vebt__insert_Osimps_I1_J,axiom,
    ! [X2: nat,A2: $o,B2: $o] :
      ( ( ( X2
          = ( zero_zero @ nat ) )
       => ( ( vEBT_vebt_insert @ ( vEBT_Leaf @ A2 @ B2 ) @ X2 )
          = ( vEBT_Leaf @ $true @ B2 ) ) )
      & ( ( X2
         != ( zero_zero @ nat ) )
       => ( ( ( X2
              = ( one_one @ nat ) )
           => ( ( vEBT_vebt_insert @ ( vEBT_Leaf @ A2 @ B2 ) @ X2 )
              = ( vEBT_Leaf @ A2 @ $true ) ) )
          & ( ( X2
             != ( one_one @ nat ) )
           => ( ( vEBT_vebt_insert @ ( vEBT_Leaf @ A2 @ B2 ) @ X2 )
              = ( vEBT_Leaf @ A2 @ B2 ) ) ) ) ) ) ).

% vebt_insert.simps(1)
thf(fact_862_realpow__pos__nth2,axiom,
    ! [A2: real,N2: nat] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
     => ? [R4: real] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ R4 )
          & ( ( power_power @ real @ R4 @ ( suc @ N2 ) )
            = A2 ) ) ) ).

% realpow_pos_nth2
thf(fact_863_option_Osize__neq,axiom,
    ! [A: $tType,X2: option @ A] :
      ( ( size_size @ ( option @ A ) @ X2 )
     != ( zero_zero @ nat ) ) ).

% option.size_neq
thf(fact_864_zdiv__zmult2__eq,axiom,
    ! [C2: int,A2: int,B2: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ C2 )
     => ( ( divide_divide @ int @ A2 @ ( times_times @ int @ B2 @ C2 ) )
        = ( divide_divide @ int @ ( divide_divide @ int @ A2 @ B2 ) @ C2 ) ) ) ).

% zdiv_zmult2_eq
thf(fact_865_pos__zdiv__mult__2,axiom,
    ! [A2: int,B2: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ A2 )
     => ( ( divide_divide @ int @ ( plus_plus @ int @ ( one_one @ int ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ B2 ) ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ A2 ) )
        = ( divide_divide @ int @ B2 @ A2 ) ) ) ).

% pos_zdiv_mult_2
thf(fact_866_neg__zdiv__mult__2,axiom,
    ! [A2: int,B2: int] :
      ( ( ord_less_eq @ int @ A2 @ ( zero_zero @ int ) )
     => ( ( divide_divide @ int @ ( plus_plus @ int @ ( one_one @ int ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ B2 ) ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ A2 ) )
        = ( divide_divide @ int @ ( plus_plus @ int @ B2 @ ( one_one @ int ) ) @ A2 ) ) ) ).

% neg_zdiv_mult_2
thf(fact_867_realpow__pos__nth__unique,axiom,
    ! [N2: nat,A2: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
       => ? [X3: real] :
            ( ( ord_less @ real @ ( zero_zero @ real ) @ X3 )
            & ( ( power_power @ real @ X3 @ N2 )
              = A2 )
            & ! [Y: real] :
                ( ( ( ord_less @ real @ ( zero_zero @ real ) @ Y )
                  & ( ( power_power @ real @ Y @ N2 )
                    = A2 ) )
               => ( Y = X3 ) ) ) ) ) ).

% realpow_pos_nth_unique
thf(fact_868_realpow__pos__nth,axiom,
    ! [N2: nat,A2: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
       => ? [R4: real] :
            ( ( ord_less @ real @ ( zero_zero @ real ) @ R4 )
            & ( ( power_power @ real @ R4 @ N2 )
              = A2 ) ) ) ) ).

% realpow_pos_nth
thf(fact_869_option_Odistinct_I1_J,axiom,
    ! [A: $tType,X22: A] :
      ( ( none @ A )
     != ( some @ A @ X22 ) ) ).

% option.distinct(1)
thf(fact_870_option_OdiscI,axiom,
    ! [A: $tType,Option: option @ A,X22: A] :
      ( ( Option
        = ( some @ A @ X22 ) )
     => ( Option
       != ( none @ A ) ) ) ).

% option.discI
thf(fact_871_option_Oexhaust,axiom,
    ! [A: $tType,Y2: option @ A] :
      ( ( Y2
       != ( none @ A ) )
     => ~ ! [X23: A] :
            ( Y2
           != ( some @ A @ X23 ) ) ) ).

% option.exhaust
thf(fact_872_split__option__ex,axiom,
    ! [A: $tType] :
      ( ( ^ [P2: ( option @ A ) > $o] :
          ? [X6: option @ A] : ( P2 @ X6 ) )
      = ( ^ [P3: ( option @ A ) > $o] :
            ( ( P3 @ ( none @ A ) )
            | ? [X5: A] : ( P3 @ ( some @ A @ X5 ) ) ) ) ) ).

% split_option_ex
thf(fact_873_split__option__all,axiom,
    ! [A: $tType] :
      ( ( ^ [P2: ( option @ A ) > $o] :
          ! [X6: option @ A] : ( P2 @ X6 ) )
      = ( ^ [P3: ( option @ A ) > $o] :
            ( ( P3 @ ( none @ A ) )
            & ! [X5: A] : ( P3 @ ( some @ A @ X5 ) ) ) ) ) ).

% split_option_all
thf(fact_874_combine__options__cases,axiom,
    ! [A: $tType,B: $tType,X2: option @ A,P: ( option @ A ) > ( option @ B ) > $o,Y2: option @ B] :
      ( ( ( X2
          = ( none @ A ) )
       => ( P @ X2 @ Y2 ) )
     => ( ( ( Y2
            = ( none @ B ) )
         => ( P @ X2 @ Y2 ) )
       => ( ! [A5: A,B5: B] :
              ( ( X2
                = ( some @ A @ A5 ) )
             => ( ( Y2
                  = ( some @ B @ B5 ) )
               => ( P @ X2 @ Y2 ) ) )
         => ( P @ X2 @ Y2 ) ) ) ) ).

% combine_options_cases
thf(fact_875_option_Osize_I4_J,axiom,
    ! [A: $tType,X22: A] :
      ( ( size_size @ ( option @ A ) @ ( some @ A @ X22 ) )
      = ( suc @ ( zero_zero @ nat ) ) ) ).

% option.size(4)
thf(fact_876_option_Osize_I3_J,axiom,
    ! [A: $tType] :
      ( ( size_size @ ( option @ A ) @ ( none @ A ) )
      = ( suc @ ( zero_zero @ nat ) ) ) ).

% option.size(3)
thf(fact_877_pos__imp__zdiv__neg__iff,axiom,
    ! [B2: int,A2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ B2 )
     => ( ( ord_less @ int @ ( divide_divide @ int @ A2 @ B2 ) @ ( zero_zero @ int ) )
        = ( ord_less @ int @ A2 @ ( zero_zero @ int ) ) ) ) ).

% pos_imp_zdiv_neg_iff
thf(fact_878_neg__imp__zdiv__neg__iff,axiom,
    ! [B2: int,A2: int] :
      ( ( ord_less @ int @ B2 @ ( zero_zero @ int ) )
     => ( ( ord_less @ int @ ( divide_divide @ int @ A2 @ B2 ) @ ( zero_zero @ int ) )
        = ( ord_less @ int @ ( zero_zero @ int ) @ A2 ) ) ) ).

% neg_imp_zdiv_neg_iff
thf(fact_879_int__div__less__self,axiom,
    ! [X2: int,K: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ X2 )
     => ( ( ord_less @ int @ ( one_one @ int ) @ K )
       => ( ord_less @ int @ ( divide_divide @ int @ X2 @ K ) @ X2 ) ) ) ).

% int_div_less_self
thf(fact_880_div__neg__pos__less0,axiom,
    ! [A2: int,B2: int] :
      ( ( ord_less @ int @ A2 @ ( zero_zero @ int ) )
     => ( ( ord_less @ int @ ( zero_zero @ int ) @ B2 )
       => ( ord_less @ int @ ( divide_divide @ int @ A2 @ B2 ) @ ( zero_zero @ int ) ) ) ) ).

% div_neg_pos_less0
thf(fact_881_vebt__member_Osimps_I2_J,axiom,
    ! [Uu2: nat,Uv2: list @ vEBT_VEBT,Uw2: vEBT_VEBT,X2: nat] :
      ~ ( vEBT_vebt_member @ ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ Uu2 @ Uv2 @ Uw2 ) @ X2 ) ).

% vebt_member.simps(2)
thf(fact_882_div__positive,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ B2 )
         => ( ( ord_less_eq @ A @ B2 @ A2 )
           => ( ord_less @ A @ ( zero_zero @ A ) @ ( divide_divide @ A @ A2 @ B2 ) ) ) ) ) ).

% div_positive
thf(fact_883_unique__euclidean__semiring__numeral__class_Odiv__less,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less @ A @ A2 @ B2 )
           => ( ( divide_divide @ A @ A2 @ B2 )
              = ( zero_zero @ A ) ) ) ) ) ).

% unique_euclidean_semiring_numeral_class.div_less
thf(fact_884_discrete,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ( ( ord_less @ A )
        = ( ^ [A4: A] : ( ord_less_eq @ A @ ( plus_plus @ A @ A4 @ ( one_one @ A ) ) ) ) ) ) ).

% discrete
thf(fact_885_unique__euclidean__semiring__numeral__class_Odiv__mult2__eq,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
         => ( ( divide_divide @ A @ A2 @ ( times_times @ A @ B2 @ C2 ) )
            = ( divide_divide @ A @ ( divide_divide @ A @ A2 @ B2 ) @ C2 ) ) ) ) ).

% unique_euclidean_semiring_numeral_class.div_mult2_eq
thf(fact_886_nonneg1__imp__zdiv__pos__iff,axiom,
    ! [A2: int,B2: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ A2 )
     => ( ( ord_less @ int @ ( zero_zero @ int ) @ ( divide_divide @ int @ A2 @ B2 ) )
        = ( ( ord_less_eq @ int @ B2 @ A2 )
          & ( ord_less @ int @ ( zero_zero @ int ) @ B2 ) ) ) ) ).

% nonneg1_imp_zdiv_pos_iff
thf(fact_887_pos__imp__zdiv__nonneg__iff,axiom,
    ! [B2: int,A2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ B2 )
     => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( divide_divide @ int @ A2 @ B2 ) )
        = ( ord_less_eq @ int @ ( zero_zero @ int ) @ A2 ) ) ) ).

% pos_imp_zdiv_nonneg_iff
thf(fact_888_neg__imp__zdiv__nonneg__iff,axiom,
    ! [B2: int,A2: int] :
      ( ( ord_less @ int @ B2 @ ( zero_zero @ int ) )
     => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( divide_divide @ int @ A2 @ B2 ) )
        = ( ord_less_eq @ int @ A2 @ ( zero_zero @ int ) ) ) ) ).

% neg_imp_zdiv_nonneg_iff
thf(fact_889_pos__imp__zdiv__pos__iff,axiom,
    ! [K: int,I3: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ K )
     => ( ( ord_less @ int @ ( zero_zero @ int ) @ ( divide_divide @ int @ I3 @ K ) )
        = ( ord_less_eq @ int @ K @ I3 ) ) ) ).

% pos_imp_zdiv_pos_iff
thf(fact_890_div__nonpos__pos__le0,axiom,
    ! [A2: int,B2: int] :
      ( ( ord_less_eq @ int @ A2 @ ( zero_zero @ int ) )
     => ( ( ord_less @ int @ ( zero_zero @ int ) @ B2 )
       => ( ord_less_eq @ int @ ( divide_divide @ int @ A2 @ B2 ) @ ( zero_zero @ int ) ) ) ) ).

% div_nonpos_pos_le0
thf(fact_891_div__nonneg__neg__le0,axiom,
    ! [A2: int,B2: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ A2 )
     => ( ( ord_less @ int @ B2 @ ( zero_zero @ int ) )
       => ( ord_less_eq @ int @ ( divide_divide @ int @ A2 @ B2 ) @ ( zero_zero @ int ) ) ) ) ).

% div_nonneg_neg_le0
thf(fact_892_div__positive__int,axiom,
    ! [L: int,K: int] :
      ( ( ord_less_eq @ int @ L @ K )
     => ( ( ord_less @ int @ ( zero_zero @ int ) @ L )
       => ( ord_less @ int @ ( zero_zero @ int ) @ ( divide_divide @ int @ K @ L ) ) ) ) ).

% div_positive_int
thf(fact_893_div__int__pos__iff,axiom,
    ! [K: int,L: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( divide_divide @ int @ K @ L ) )
      = ( ( K
          = ( zero_zero @ int ) )
        | ( L
          = ( zero_zero @ int ) )
        | ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ K )
          & ( ord_less_eq @ int @ ( zero_zero @ int ) @ L ) )
        | ( ( ord_less @ int @ K @ ( zero_zero @ int ) )
          & ( ord_less @ int @ L @ ( zero_zero @ int ) ) ) ) ) ).

% div_int_pos_iff
thf(fact_894_zdiv__mono2__neg,axiom,
    ! [A2: int,B6: int,B2: int] :
      ( ( ord_less @ int @ A2 @ ( zero_zero @ int ) )
     => ( ( ord_less @ int @ ( zero_zero @ int ) @ B6 )
       => ( ( ord_less_eq @ int @ B6 @ B2 )
         => ( ord_less_eq @ int @ ( divide_divide @ int @ A2 @ B6 ) @ ( divide_divide @ int @ A2 @ B2 ) ) ) ) ) ).

% zdiv_mono2_neg
thf(fact_895_zdiv__mono1__neg,axiom,
    ! [A2: int,A6: int,B2: int] :
      ( ( ord_less_eq @ int @ A2 @ A6 )
     => ( ( ord_less @ int @ B2 @ ( zero_zero @ int ) )
       => ( ord_less_eq @ int @ ( divide_divide @ int @ A6 @ B2 ) @ ( divide_divide @ int @ A2 @ B2 ) ) ) ) ).

% zdiv_mono1_neg
thf(fact_896_zdiv__eq__0__iff,axiom,
    ! [I3: int,K: int] :
      ( ( ( divide_divide @ int @ I3 @ K )
        = ( zero_zero @ int ) )
      = ( ( K
          = ( zero_zero @ int ) )
        | ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ I3 )
          & ( ord_less @ int @ I3 @ K ) )
        | ( ( ord_less_eq @ int @ I3 @ ( zero_zero @ int ) )
          & ( ord_less @ int @ K @ I3 ) ) ) ) ).

% zdiv_eq_0_iff
thf(fact_897_zdiv__mono2,axiom,
    ! [A2: int,B6: int,B2: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ A2 )
     => ( ( ord_less @ int @ ( zero_zero @ int ) @ B6 )
       => ( ( ord_less_eq @ int @ B6 @ B2 )
         => ( ord_less_eq @ int @ ( divide_divide @ int @ A2 @ B2 ) @ ( divide_divide @ int @ A2 @ B6 ) ) ) ) ) ).

% zdiv_mono2
thf(fact_898_zdiv__mono1,axiom,
    ! [A2: int,A6: int,B2: int] :
      ( ( ord_less_eq @ int @ A2 @ A6 )
     => ( ( ord_less @ int @ ( zero_zero @ int ) @ B2 )
       => ( ord_less_eq @ int @ ( divide_divide @ int @ A2 @ B2 ) @ ( divide_divide @ int @ A6 @ B2 ) ) ) ) ).

% zdiv_mono1
thf(fact_899_vebt__member_Osimps_I3_J,axiom,
    ! [V: product_prod @ nat @ nat,Uy2: list @ vEBT_VEBT,Uz2: vEBT_VEBT,X2: nat] :
      ~ ( vEBT_vebt_member @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ V ) @ ( zero_zero @ nat ) @ Uy2 @ Uz2 ) @ X2 ) ).

% vebt_member.simps(3)
thf(fact_900_pos2,axiom,
    ord_less @ nat @ ( zero_zero @ nat ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ).

% pos2
thf(fact_901_zle__add1__eq__le,axiom,
    ! [W: int,Z: int] :
      ( ( ord_less @ int @ W @ ( plus_plus @ int @ Z @ ( one_one @ int ) ) )
      = ( ord_less_eq @ int @ W @ Z ) ) ).

% zle_add1_eq_le
thf(fact_902_le__imp__0__less,axiom,
    ! [Z: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Z )
     => ( ord_less @ int @ ( zero_zero @ int ) @ ( plus_plus @ int @ ( one_one @ int ) @ Z ) ) ) ).

% le_imp_0_less
thf(fact_903_enat__ord__number_I1_J,axiom,
    ! [M: num,N2: num] :
      ( ( ord_less_eq @ extended_enat @ ( numeral_numeral @ extended_enat @ M ) @ ( numeral_numeral @ extended_enat @ N2 ) )
      = ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ M ) @ ( numeral_numeral @ nat @ N2 ) ) ) ).

% enat_ord_number(1)
thf(fact_904_enat__ord__number_I2_J,axiom,
    ! [M: num,N2: num] :
      ( ( ord_less @ extended_enat @ ( numeral_numeral @ extended_enat @ M ) @ ( numeral_numeral @ extended_enat @ N2 ) )
      = ( ord_less @ nat @ ( numeral_numeral @ nat @ M ) @ ( numeral_numeral @ nat @ N2 ) ) ) ).

% enat_ord_number(2)
thf(fact_905_double__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( linord5086331880401160121up_add @ A )
     => ! [A2: A] :
          ( ( ( plus_plus @ A @ A2 @ A2 )
            = ( zero_zero @ A ) )
          = ( A2
            = ( zero_zero @ A ) ) ) ) ).

% double_eq_0_iff
thf(fact_906_unset__bit__0,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A] :
          ( ( bit_se2638667681897837118et_bit @ A @ ( zero_zero @ nat ) @ A2 )
          = ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ).

% unset_bit_0
thf(fact_907_zless__imp__add1__zle,axiom,
    ! [W: int,Z: int] :
      ( ( ord_less @ int @ W @ Z )
     => ( ord_less_eq @ int @ ( plus_plus @ int @ W @ ( one_one @ int ) ) @ Z ) ) ).

% zless_imp_add1_zle
thf(fact_908_add1__zle__eq,axiom,
    ! [W: int,Z: int] :
      ( ( ord_less_eq @ int @ ( plus_plus @ int @ W @ ( one_one @ int ) ) @ Z )
      = ( ord_less @ int @ W @ Z ) ) ).

% add1_zle_eq
thf(fact_909_odd__less__0__iff,axiom,
    ! [Z: int] :
      ( ( ord_less @ int @ ( plus_plus @ int @ ( plus_plus @ int @ ( one_one @ int ) @ Z ) @ Z ) @ ( zero_zero @ int ) )
      = ( ord_less @ int @ Z @ ( zero_zero @ int ) ) ) ).

% odd_less_0_iff
thf(fact_910_not__min__Null__member,axiom,
    ! [T2: vEBT_VEBT] :
      ( ~ ( vEBT_VEBT_minNull @ T2 )
     => ? [X_12: nat] : ( vEBT_V8194947554948674370ptions @ T2 @ X_12 ) ) ).

% not_min_Null_member
thf(fact_911_min__Null__member,axiom,
    ! [T2: vEBT_VEBT,X2: nat] :
      ( ( vEBT_VEBT_minNull @ T2 )
     => ~ ( vEBT_vebt_member @ T2 @ X2 ) ) ).

% min_Null_member
thf(fact_912_real__divide__square__eq,axiom,
    ! [R3: real,A2: real] :
      ( ( divide_divide @ real @ ( times_times @ real @ R3 @ A2 ) @ ( times_times @ real @ R3 @ R3 ) )
      = ( divide_divide @ real @ A2 @ R3 ) ) ).

% real_divide_square_eq
thf(fact_913_i0__less,axiom,
    ! [N2: extended_enat] :
      ( ( ord_less @ extended_enat @ ( zero_zero @ extended_enat ) @ N2 )
      = ( ( N2
         != ( zero_zero @ extended_enat ) ) ) ) ).

% i0_less
thf(fact_914_unset__bit__nonnegative__int__iff,axiom,
    ! [N2: nat,K: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( bit_se2638667681897837118et_bit @ int @ N2 @ K ) )
      = ( ord_less_eq @ int @ ( zero_zero @ int ) @ K ) ) ).

% unset_bit_nonnegative_int_iff
thf(fact_915_unset__bit__negative__int__iff,axiom,
    ! [N2: nat,K: int] :
      ( ( ord_less @ int @ ( bit_se2638667681897837118et_bit @ int @ N2 @ K ) @ ( zero_zero @ int ) )
      = ( ord_less @ int @ K @ ( zero_zero @ int ) ) ) ).

% unset_bit_negative_int_iff
thf(fact_916_not__real__square__gt__zero,axiom,
    ! [X2: real] :
      ( ( ~ ( ord_less @ real @ ( zero_zero @ real ) @ ( times_times @ real @ X2 @ X2 ) ) )
      = ( X2
        = ( zero_zero @ real ) ) ) ).

% not_real_square_gt_zero
thf(fact_917_enat__0__less__mult__iff,axiom,
    ! [M: extended_enat,N2: extended_enat] :
      ( ( ord_less @ extended_enat @ ( zero_zero @ extended_enat ) @ ( times_times @ extended_enat @ M @ N2 ) )
      = ( ( ord_less @ extended_enat @ ( zero_zero @ extended_enat ) @ M )
        & ( ord_less @ extended_enat @ ( zero_zero @ extended_enat ) @ N2 ) ) ) ).

% enat_0_less_mult_iff
thf(fact_918_ile0__eq,axiom,
    ! [N2: extended_enat] :
      ( ( ord_less_eq @ extended_enat @ N2 @ ( zero_zero @ extended_enat ) )
      = ( N2
        = ( zero_zero @ extended_enat ) ) ) ).

% ile0_eq
thf(fact_919_i0__lb,axiom,
    ! [N2: extended_enat] : ( ord_less_eq @ extended_enat @ ( zero_zero @ extended_enat ) @ N2 ) ).

% i0_lb
thf(fact_920_not__iless0,axiom,
    ! [N2: extended_enat] :
      ~ ( ord_less @ extended_enat @ N2 @ ( zero_zero @ extended_enat ) ) ).

% not_iless0
thf(fact_921_enat__less__induct,axiom,
    ! [P: extended_enat > $o,N2: extended_enat] :
      ( ! [N: extended_enat] :
          ( ! [M2: extended_enat] :
              ( ( ord_less @ extended_enat @ M2 @ N )
             => ( P @ M2 ) )
         => ( P @ N ) )
     => ( P @ N2 ) ) ).

% enat_less_induct
thf(fact_922_unset__bit__less__eq,axiom,
    ! [N2: nat,K: int] : ( ord_less_eq @ int @ ( bit_se2638667681897837118et_bit @ int @ N2 @ K ) @ K ) ).

% unset_bit_less_eq
thf(fact_923_VEBT__internal_OminNull_Osimps_I5_J,axiom,
    ! [Uz2: product_prod @ nat @ nat,Va3: nat,Vb: list @ vEBT_VEBT,Vc: vEBT_VEBT] :
      ~ ( vEBT_VEBT_minNull @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ Uz2 ) @ Va3 @ Vb @ Vc ) ) ).

% VEBT_internal.minNull.simps(5)
thf(fact_924_VEBT__internal_OminNull_Osimps_I4_J,axiom,
    ! [Uw2: nat,Ux2: list @ vEBT_VEBT,Uy2: vEBT_VEBT] : ( vEBT_VEBT_minNull @ ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ Uw2 @ Ux2 @ Uy2 ) ) ).

% VEBT_internal.minNull.simps(4)
thf(fact_925_times__int__code_I2_J,axiom,
    ! [L: int] :
      ( ( times_times @ int @ ( zero_zero @ int ) @ L )
      = ( zero_zero @ int ) ) ).

% times_int_code(2)
thf(fact_926_times__int__code_I1_J,axiom,
    ! [K: int] :
      ( ( times_times @ int @ K @ ( zero_zero @ int ) )
      = ( zero_zero @ int ) ) ).

% times_int_code(1)
thf(fact_927_int__distrib_I2_J,axiom,
    ! [W: int,Z1: int,Z22: int] :
      ( ( times_times @ int @ W @ ( plus_plus @ int @ Z1 @ Z22 ) )
      = ( plus_plus @ int @ ( times_times @ int @ W @ Z1 ) @ ( times_times @ int @ W @ Z22 ) ) ) ).

% int_distrib(2)
thf(fact_928_int__distrib_I1_J,axiom,
    ! [Z1: int,Z22: int,W: int] :
      ( ( times_times @ int @ ( plus_plus @ int @ Z1 @ Z22 ) @ W )
      = ( plus_plus @ int @ ( times_times @ int @ Z1 @ W ) @ ( times_times @ int @ Z22 @ W ) ) ) ).

% int_distrib(1)
thf(fact_929_VEBT__internal_OminNull_Oelims_I3_J,axiom,
    ! [X2: vEBT_VEBT] :
      ( ~ ( vEBT_VEBT_minNull @ X2 )
     => ( ! [Uv: $o] :
            ( X2
           != ( vEBT_Leaf @ $true @ Uv ) )
       => ( ! [Uu: $o] :
              ( X2
             != ( vEBT_Leaf @ Uu @ $true ) )
         => ~ ! [Uz: product_prod @ nat @ nat,Va2: nat,Vb2: list @ vEBT_VEBT,Vc2: vEBT_VEBT] :
                ( X2
               != ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ Uz ) @ Va2 @ Vb2 @ Vc2 ) ) ) ) ) ).

% VEBT_internal.minNull.elims(3)
thf(fact_930_VEBT__internal_OminNull_Oelims_I2_J,axiom,
    ! [X2: vEBT_VEBT] :
      ( ( vEBT_VEBT_minNull @ X2 )
     => ( ( X2
         != ( vEBT_Leaf @ $false @ $false ) )
       => ~ ! [Uw: nat,Ux: list @ vEBT_VEBT,Uy: vEBT_VEBT] :
              ( X2
             != ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ Uw @ Ux @ Uy ) ) ) ) ).

% VEBT_internal.minNull.elims(2)
thf(fact_931_VEBT__internal_OminNull_Oelims_I1_J,axiom,
    ! [X2: vEBT_VEBT,Y2: $o] :
      ( ( ( vEBT_VEBT_minNull @ X2 )
        = Y2 )
     => ( ( ( X2
            = ( vEBT_Leaf @ $false @ $false ) )
         => ~ Y2 )
       => ( ( ? [Uv: $o] :
                ( X2
                = ( vEBT_Leaf @ $true @ Uv ) )
           => Y2 )
         => ( ( ? [Uu: $o] :
                  ( X2
                  = ( vEBT_Leaf @ Uu @ $true ) )
             => Y2 )
           => ( ( ? [Uw: nat,Ux: list @ vEBT_VEBT,Uy: vEBT_VEBT] :
                    ( X2
                    = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ Uw @ Ux @ Uy ) )
               => ~ Y2 )
             => ~ ( ? [Uz: product_prod @ nat @ nat,Va2: nat,Vb2: list @ vEBT_VEBT,Vc2: vEBT_VEBT] :
                      ( X2
                      = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ Uz ) @ Va2 @ Vb2 @ Vc2 ) )
                 => Y2 ) ) ) ) ) ) ).

% VEBT_internal.minNull.elims(1)
thf(fact_932_less__eq__int__code_I1_J,axiom,
    ord_less_eq @ int @ ( zero_zero @ int ) @ ( zero_zero @ int ) ).

% less_eq_int_code(1)
thf(fact_933_less__int__code_I1_J,axiom,
    ~ ( ord_less @ int @ ( zero_zero @ int ) @ ( zero_zero @ int ) ) ).

% less_int_code(1)
thf(fact_934_zmult__zless__mono2,axiom,
    ! [I3: int,J: int,K: int] :
      ( ( ord_less @ int @ I3 @ J )
     => ( ( ord_less @ int @ ( zero_zero @ int ) @ K )
       => ( ord_less @ int @ ( times_times @ int @ K @ I3 ) @ ( times_times @ int @ K @ J ) ) ) ) ).

% zmult_zless_mono2
thf(fact_935_plus__int__code_I1_J,axiom,
    ! [K: int] :
      ( ( plus_plus @ int @ K @ ( zero_zero @ int ) )
      = K ) ).

% plus_int_code(1)
thf(fact_936_plus__int__code_I2_J,axiom,
    ! [L: int] :
      ( ( plus_plus @ int @ ( zero_zero @ int ) @ L )
      = L ) ).

% plus_int_code(2)
thf(fact_937_pos__zmult__eq__1__iff,axiom,
    ! [M: int,N2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ M )
     => ( ( ( times_times @ int @ M @ N2 )
          = ( one_one @ int ) )
        = ( ( M
            = ( one_one @ int ) )
          & ( N2
            = ( one_one @ int ) ) ) ) ) ).

% pos_zmult_eq_1_iff
thf(fact_938_odd__nonzero,axiom,
    ! [Z: int] :
      ( ( plus_plus @ int @ ( plus_plus @ int @ ( one_one @ int ) @ Z ) @ Z )
     != ( zero_zero @ int ) ) ).

% odd_nonzero
thf(fact_939_int__ge__induct,axiom,
    ! [K: int,I3: int,P: int > $o] :
      ( ( ord_less_eq @ int @ K @ I3 )
     => ( ( P @ K )
       => ( ! [I2: int] :
              ( ( ord_less_eq @ int @ K @ I2 )
             => ( ( P @ I2 )
               => ( P @ ( plus_plus @ int @ I2 @ ( one_one @ int ) ) ) ) )
         => ( P @ I3 ) ) ) ) ).

% int_ge_induct
thf(fact_940_int__gr__induct,axiom,
    ! [K: int,I3: int,P: int > $o] :
      ( ( ord_less @ int @ K @ I3 )
     => ( ( P @ ( plus_plus @ int @ K @ ( one_one @ int ) ) )
       => ( ! [I2: int] :
              ( ( ord_less @ int @ K @ I2 )
             => ( ( P @ I2 )
               => ( P @ ( plus_plus @ int @ I2 @ ( one_one @ int ) ) ) ) )
         => ( P @ I3 ) ) ) ) ).

% int_gr_induct
thf(fact_941_zless__add1__eq,axiom,
    ! [W: int,Z: int] :
      ( ( ord_less @ int @ W @ ( plus_plus @ int @ Z @ ( one_one @ int ) ) )
      = ( ( ord_less @ int @ W @ Z )
        | ( W = Z ) ) ) ).

% zless_add1_eq
thf(fact_942_int__one__le__iff__zero__less,axiom,
    ! [Z: int] :
      ( ( ord_less_eq @ int @ ( one_one @ int ) @ Z )
      = ( ord_less @ int @ ( zero_zero @ int ) @ Z ) ) ).

% int_one_le_iff_zero_less
thf(fact_943_incr__mult__lemma,axiom,
    ! [D2: int,P: int > $o,K: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D2 )
     => ( ! [X3: int] :
            ( ( P @ X3 )
           => ( P @ ( plus_plus @ int @ X3 @ D2 ) ) )
       => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ K )
         => ! [X: int] :
              ( ( P @ X )
             => ( P @ ( plus_plus @ int @ X @ ( times_times @ int @ K @ D2 ) ) ) ) ) ) ) ).

% incr_mult_lemma
thf(fact_944_buildup__nothing__in__leaf,axiom,
    ! [N2: nat,X2: nat] :
      ~ ( vEBT_V5719532721284313246member @ ( vEBT_vebt_buildup @ N2 ) @ X2 ) ).

% buildup_nothing_in_leaf
thf(fact_945_mult__le__cancel__iff1,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [Z: A,X2: A,Y2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ Z )
         => ( ( ord_less_eq @ A @ ( times_times @ A @ X2 @ Z ) @ ( times_times @ A @ Y2 @ Z ) )
            = ( ord_less_eq @ A @ X2 @ Y2 ) ) ) ) ).

% mult_le_cancel_iff1
thf(fact_946_mult__le__cancel__iff2,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [Z: A,X2: A,Y2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ Z )
         => ( ( ord_less_eq @ A @ ( times_times @ A @ Z @ X2 ) @ ( times_times @ A @ Z @ Y2 ) )
            = ( ord_less_eq @ A @ X2 @ Y2 ) ) ) ) ).

% mult_le_cancel_iff2
thf(fact_947_divides__aux__eq,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [Q3: A,R3: A] :
          ( ( unique5940410009612947441es_aux @ A @ ( product_Pair @ A @ A @ Q3 @ R3 ) )
          = ( R3
            = ( zero_zero @ A ) ) ) ) ).

% divides_aux_eq
thf(fact_948_low__def,axiom,
    ( vEBT_VEBT_low
    = ( ^ [X5: nat,N3: nat] : ( modulo_modulo @ nat @ X5 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N3 ) ) ) ) ).

% low_def
thf(fact_949_insert__simp__excp,axiom,
    ! [Mi: nat,Deg: nat,TreeList: list @ vEBT_VEBT,X2: nat,Ma: nat,Summary: vEBT_VEBT] :
      ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Mi @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList ) )
     => ( ( ord_less @ nat @ X2 @ Mi )
       => ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg )
         => ( ( X2 != Ma )
           => ( ( vEBT_vebt_insert @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi @ Ma ) ) @ Deg @ TreeList @ Summary ) @ X2 )
              = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ X2 @ ( ord_max @ nat @ Mi @ Ma ) ) ) @ Deg @ ( list_update @ vEBT_VEBT @ TreeList @ ( vEBT_VEBT_high @ Mi @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( vEBT_vebt_insert @ ( nth @ vEBT_VEBT @ TreeList @ ( vEBT_VEBT_high @ Mi @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Mi @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) @ ( if @ vEBT_VEBT @ ( vEBT_VEBT_minNull @ ( nth @ vEBT_VEBT @ TreeList @ ( vEBT_VEBT_high @ Mi @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) @ ( vEBT_vebt_insert @ Summary @ ( vEBT_VEBT_high @ Mi @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ Summary ) ) ) ) ) ) ) ).

% insert_simp_excp
thf(fact_950_insert__simp__norm,axiom,
    ! [X2: nat,Deg: nat,TreeList: list @ vEBT_VEBT,Mi: nat,Ma: nat,Summary: vEBT_VEBT] :
      ( ( ord_less @ nat @ ( vEBT_VEBT_high @ X2 @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList ) )
     => ( ( ord_less @ nat @ Mi @ X2 )
       => ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg )
         => ( ( X2 != Ma )
           => ( ( vEBT_vebt_insert @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi @ Ma ) ) @ Deg @ TreeList @ Summary ) @ X2 )
              = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi @ ( ord_max @ nat @ X2 @ Ma ) ) ) @ Deg @ ( list_update @ vEBT_VEBT @ TreeList @ ( vEBT_VEBT_high @ X2 @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( vEBT_vebt_insert @ ( nth @ vEBT_VEBT @ TreeList @ ( vEBT_VEBT_high @ X2 @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ X2 @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) @ ( if @ vEBT_VEBT @ ( vEBT_VEBT_minNull @ ( nth @ vEBT_VEBT @ TreeList @ ( vEBT_VEBT_high @ X2 @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) @ ( vEBT_vebt_insert @ Summary @ ( vEBT_VEBT_high @ X2 @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ Summary ) ) ) ) ) ) ) ).

% insert_simp_norm
thf(fact_951_mod__mod__trivial,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [A2: A,B2: A] :
          ( ( modulo_modulo @ A @ ( modulo_modulo @ A @ A2 @ B2 ) @ B2 )
          = ( modulo_modulo @ A @ A2 @ B2 ) ) ) ).

% mod_mod_trivial
thf(fact_952_list__update__overwrite,axiom,
    ! [A: $tType,Xs: list @ A,I3: nat,X2: A,Y2: A] :
      ( ( list_update @ A @ ( list_update @ A @ Xs @ I3 @ X2 ) @ I3 @ Y2 )
      = ( list_update @ A @ Xs @ I3 @ Y2 ) ) ).

% list_update_overwrite
thf(fact_953_bits__mod__0,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A] :
          ( ( modulo_modulo @ A @ ( zero_zero @ A ) @ A2 )
          = ( zero_zero @ A ) ) ) ).

% bits_mod_0
thf(fact_954_mod__self,axiom,
    ! [A: $tType] :
      ( ( semidom_modulo @ A )
     => ! [A2: A] :
          ( ( modulo_modulo @ A @ A2 @ A2 )
          = ( zero_zero @ A ) ) ) ).

% mod_self
thf(fact_955_mod__by__0,axiom,
    ! [A: $tType] :
      ( ( semidom_modulo @ A )
     => ! [A2: A] :
          ( ( modulo_modulo @ A @ A2 @ ( zero_zero @ A ) )
          = A2 ) ) ).

% mod_by_0
thf(fact_956_mod__0,axiom,
    ! [A: $tType] :
      ( ( semidom_modulo @ A )
     => ! [A2: A] :
          ( ( modulo_modulo @ A @ ( zero_zero @ A ) @ A2 )
          = ( zero_zero @ A ) ) ) ).

% mod_0
thf(fact_957_mod__add__self2,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [A2: A,B2: A] :
          ( ( modulo_modulo @ A @ ( plus_plus @ A @ A2 @ B2 ) @ B2 )
          = ( modulo_modulo @ A @ A2 @ B2 ) ) ) ).

% mod_add_self2
thf(fact_958_mod__add__self1,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [B2: A,A2: A] :
          ( ( modulo_modulo @ A @ ( plus_plus @ A @ B2 @ A2 ) @ B2 )
          = ( modulo_modulo @ A @ A2 @ B2 ) ) ) ).

% mod_add_self1
thf(fact_959_mod__less,axiom,
    ! [M: nat,N2: nat] :
      ( ( ord_less @ nat @ M @ N2 )
     => ( ( modulo_modulo @ nat @ M @ N2 )
        = M ) ) ).

% mod_less
thf(fact_960_length__list__update,axiom,
    ! [A: $tType,Xs: list @ A,I3: nat,X2: A] :
      ( ( size_size @ ( list @ A ) @ ( list_update @ A @ Xs @ I3 @ X2 ) )
      = ( size_size @ ( list @ A ) @ Xs ) ) ).

% length_list_update
thf(fact_961_max__Suc__Suc,axiom,
    ! [M: nat,N2: nat] :
      ( ( ord_max @ nat @ ( suc @ M ) @ ( suc @ N2 ) )
      = ( suc @ ( ord_max @ nat @ M @ N2 ) ) ) ).

% max_Suc_Suc
thf(fact_962_max__0R,axiom,
    ! [N2: nat] :
      ( ( ord_max @ nat @ N2 @ ( zero_zero @ nat ) )
      = N2 ) ).

% max_0R
thf(fact_963_max__0L,axiom,
    ! [N2: nat] :
      ( ( ord_max @ nat @ ( zero_zero @ nat ) @ N2 )
      = N2 ) ).

% max_0L
thf(fact_964_max__nat_Oright__neutral,axiom,
    ! [A2: nat] :
      ( ( ord_max @ nat @ A2 @ ( zero_zero @ nat ) )
      = A2 ) ).

% max_nat.right_neutral
thf(fact_965_max__nat_Oneutr__eq__iff,axiom,
    ! [A2: nat,B2: nat] :
      ( ( ( zero_zero @ nat )
        = ( ord_max @ nat @ A2 @ B2 ) )
      = ( ( A2
          = ( zero_zero @ nat ) )
        & ( B2
          = ( zero_zero @ nat ) ) ) ) ).

% max_nat.neutr_eq_iff
thf(fact_966_max__nat_Oleft__neutral,axiom,
    ! [A2: nat] :
      ( ( ord_max @ nat @ ( zero_zero @ nat ) @ A2 )
      = A2 ) ).

% max_nat.left_neutral
thf(fact_967_max__nat_Oeq__neutr__iff,axiom,
    ! [A2: nat,B2: nat] :
      ( ( ( ord_max @ nat @ A2 @ B2 )
        = ( zero_zero @ nat ) )
      = ( ( A2
          = ( zero_zero @ nat ) )
        & ( B2
          = ( zero_zero @ nat ) ) ) ) ).

% max_nat.eq_neutr_iff
thf(fact_968_nth__list__update__neq,axiom,
    ! [A: $tType,I3: nat,J: nat,Xs: list @ A,X2: A] :
      ( ( I3 != J )
     => ( ( nth @ A @ ( list_update @ A @ Xs @ I3 @ X2 ) @ J )
        = ( nth @ A @ Xs @ J ) ) ) ).

% nth_list_update_neq
thf(fact_969_list__update__id,axiom,
    ! [A: $tType,Xs: list @ A,I3: nat] :
      ( ( list_update @ A @ Xs @ I3 @ ( nth @ A @ Xs @ I3 ) )
      = Xs ) ).

% list_update_id
thf(fact_970_mod__mult__self2__is__0,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [A2: A,B2: A] :
          ( ( modulo_modulo @ A @ ( times_times @ A @ A2 @ B2 ) @ B2 )
          = ( zero_zero @ A ) ) ) ).

% mod_mult_self2_is_0
thf(fact_971_mod__mult__self1__is__0,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [B2: A,A2: A] :
          ( ( modulo_modulo @ A @ ( times_times @ A @ B2 @ A2 ) @ B2 )
          = ( zero_zero @ A ) ) ) ).

% mod_mult_self1_is_0
thf(fact_972_bits__mod__by__1,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A] :
          ( ( modulo_modulo @ A @ A2 @ ( one_one @ A ) )
          = ( zero_zero @ A ) ) ) ).

% bits_mod_by_1
thf(fact_973_mod__by__1,axiom,
    ! [A: $tType] :
      ( ( semidom_modulo @ A )
     => ! [A2: A] :
          ( ( modulo_modulo @ A @ A2 @ ( one_one @ A ) )
          = ( zero_zero @ A ) ) ) ).

% mod_by_1
thf(fact_974_mod__div__trivial,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [A2: A,B2: A] :
          ( ( divide_divide @ A @ ( modulo_modulo @ A @ A2 @ B2 ) @ B2 )
          = ( zero_zero @ A ) ) ) ).

% mod_div_trivial
thf(fact_975_bits__mod__div__trivial,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A,B2: A] :
          ( ( divide_divide @ A @ ( modulo_modulo @ A @ A2 @ B2 ) @ B2 )
          = ( zero_zero @ A ) ) ) ).

% bits_mod_div_trivial
thf(fact_976_mod__mult__self1,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( modulo_modulo @ A @ ( plus_plus @ A @ A2 @ ( times_times @ A @ C2 @ B2 ) ) @ B2 )
          = ( modulo_modulo @ A @ A2 @ B2 ) ) ) ).

% mod_mult_self1
thf(fact_977_mod__mult__self2,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( modulo_modulo @ A @ ( plus_plus @ A @ A2 @ ( times_times @ A @ B2 @ C2 ) ) @ B2 )
          = ( modulo_modulo @ A @ A2 @ B2 ) ) ) ).

% mod_mult_self2
thf(fact_978_mod__mult__self3,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( modulo_modulo @ A @ ( plus_plus @ A @ ( times_times @ A @ C2 @ B2 ) @ A2 ) @ B2 )
          = ( modulo_modulo @ A @ A2 @ B2 ) ) ) ).

% mod_mult_self3
thf(fact_979_mod__mult__self4,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( modulo_modulo @ A @ ( plus_plus @ A @ ( times_times @ A @ B2 @ C2 ) @ A2 ) @ B2 )
          = ( modulo_modulo @ A @ A2 @ B2 ) ) ) ).

% mod_mult_self4
thf(fact_980_max__number__of_I1_J,axiom,
    ! [A: $tType] :
      ( ( ( numeral @ A )
        & ( ord @ A ) )
     => ! [U: num,V: num] :
          ( ( ( ord_less_eq @ A @ ( numeral_numeral @ A @ U ) @ ( numeral_numeral @ A @ V ) )
           => ( ( ord_max @ A @ ( numeral_numeral @ A @ U ) @ ( numeral_numeral @ A @ V ) )
              = ( numeral_numeral @ A @ V ) ) )
          & ( ~ ( ord_less_eq @ A @ ( numeral_numeral @ A @ U ) @ ( numeral_numeral @ A @ V ) )
           => ( ( ord_max @ A @ ( numeral_numeral @ A @ U ) @ ( numeral_numeral @ A @ V ) )
              = ( numeral_numeral @ A @ U ) ) ) ) ) ).

% max_number_of(1)
thf(fact_981_max__0__1_I3_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [X2: num] :
          ( ( ord_max @ A @ ( zero_zero @ A ) @ ( numeral_numeral @ A @ X2 ) )
          = ( numeral_numeral @ A @ X2 ) ) ) ).

% max_0_1(3)
thf(fact_982_max__0__1_I4_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [X2: num] :
          ( ( ord_max @ A @ ( numeral_numeral @ A @ X2 ) @ ( zero_zero @ A ) )
          = ( numeral_numeral @ A @ X2 ) ) ) ).

% max_0_1(4)
thf(fact_983_max__0__1_I2_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ( ( ord_max @ A @ ( one_one @ A ) @ ( zero_zero @ A ) )
        = ( one_one @ A ) ) ) ).

% max_0_1(2)
thf(fact_984_max__0__1_I1_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ( ( ord_max @ A @ ( zero_zero @ A ) @ ( one_one @ A ) )
        = ( one_one @ A ) ) ) ).

% max_0_1(1)
thf(fact_985_max__0__1_I6_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [X2: num] :
          ( ( ord_max @ A @ ( numeral_numeral @ A @ X2 ) @ ( one_one @ A ) )
          = ( numeral_numeral @ A @ X2 ) ) ) ).

% max_0_1(6)
thf(fact_986_max__0__1_I5_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [X2: num] :
          ( ( ord_max @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ X2 ) )
          = ( numeral_numeral @ A @ X2 ) ) ) ).

% max_0_1(5)
thf(fact_987_mod__by__Suc__0,axiom,
    ! [M: nat] :
      ( ( modulo_modulo @ nat @ M @ ( suc @ ( zero_zero @ nat ) ) )
      = ( zero_zero @ nat ) ) ).

% mod_by_Suc_0
thf(fact_988_list__update__beyond,axiom,
    ! [A: $tType,Xs: list @ A,I3: nat,X2: A] :
      ( ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ I3 )
     => ( ( list_update @ A @ Xs @ I3 @ X2 )
        = Xs ) ) ).

% list_update_beyond
thf(fact_989_Suc__mod__mult__self4,axiom,
    ! [N2: nat,K: nat,M: nat] :
      ( ( modulo_modulo @ nat @ ( suc @ ( plus_plus @ nat @ ( times_times @ nat @ N2 @ K ) @ M ) ) @ N2 )
      = ( modulo_modulo @ nat @ ( suc @ M ) @ N2 ) ) ).

% Suc_mod_mult_self4
thf(fact_990_Suc__mod__mult__self3,axiom,
    ! [K: nat,N2: nat,M: nat] :
      ( ( modulo_modulo @ nat @ ( suc @ ( plus_plus @ nat @ ( times_times @ nat @ K @ N2 ) @ M ) ) @ N2 )
      = ( modulo_modulo @ nat @ ( suc @ M ) @ N2 ) ) ).

% Suc_mod_mult_self3
thf(fact_991_Suc__mod__mult__self2,axiom,
    ! [M: nat,N2: nat,K: nat] :
      ( ( modulo_modulo @ nat @ ( suc @ ( plus_plus @ nat @ M @ ( times_times @ nat @ N2 @ K ) ) ) @ N2 )
      = ( modulo_modulo @ nat @ ( suc @ M ) @ N2 ) ) ).

% Suc_mod_mult_self2
thf(fact_992_Suc__mod__mult__self1,axiom,
    ! [M: nat,K: nat,N2: nat] :
      ( ( modulo_modulo @ nat @ ( suc @ ( plus_plus @ nat @ M @ ( times_times @ nat @ K @ N2 ) ) ) @ N2 )
      = ( modulo_modulo @ nat @ ( suc @ M ) @ N2 ) ) ).

% Suc_mod_mult_self1
thf(fact_993_nth__list__update__eq,axiom,
    ! [A: $tType,I3: nat,Xs: list @ A,X2: A] :
      ( ( ord_less @ nat @ I3 @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( ( nth @ A @ ( list_update @ A @ Xs @ I3 @ X2 ) @ I3 )
        = X2 ) ) ).

% nth_list_update_eq
thf(fact_994_one__mod__two__eq__one,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ( ( modulo_modulo @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
        = ( one_one @ A ) ) ) ).

% one_mod_two_eq_one
thf(fact_995_bits__one__mod__two__eq__one,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ( ( modulo_modulo @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
        = ( one_one @ A ) ) ) ).

% bits_one_mod_two_eq_one
thf(fact_996_mod2__Suc__Suc,axiom,
    ! [M: nat] :
      ( ( modulo_modulo @ nat @ ( suc @ ( suc @ M ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
      = ( modulo_modulo @ nat @ M @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ).

% mod2_Suc_Suc
thf(fact_997_Suc__times__numeral__mod__eq,axiom,
    ! [K: num,N2: nat] :
      ( ( ( numeral_numeral @ nat @ K )
       != ( one_one @ nat ) )
     => ( ( modulo_modulo @ nat @ ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ K ) @ N2 ) ) @ ( numeral_numeral @ nat @ K ) )
        = ( one_one @ nat ) ) ) ).

% Suc_times_numeral_mod_eq
thf(fact_998_set__swap,axiom,
    ! [A: $tType,I3: nat,Xs: list @ A,J: nat] :
      ( ( ord_less @ nat @ I3 @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( ( ord_less @ nat @ J @ ( size_size @ ( list @ A ) @ Xs ) )
       => ( ( set2 @ A @ ( list_update @ A @ ( list_update @ A @ Xs @ I3 @ ( nth @ A @ Xs @ J ) ) @ J @ ( nth @ A @ Xs @ I3 ) ) )
          = ( set2 @ A @ Xs ) ) ) ) ).

% set_swap
thf(fact_999_not__mod__2__eq__1__eq__0,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [A2: A] :
          ( ( ( ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
             != ( one_one @ A ) ) )
          = ( ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
            = ( zero_zero @ A ) ) ) ) ).

% not_mod_2_eq_1_eq_0
thf(fact_1000_not__mod__2__eq__0__eq__1,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [A2: A] :
          ( ( ( ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
             != ( zero_zero @ A ) ) )
          = ( ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
            = ( one_one @ A ) ) ) ) ).

% not_mod_2_eq_0_eq_1
thf(fact_1001_not__mod2__eq__Suc__0__eq__0,axiom,
    ! [N2: nat] :
      ( ( ( ( modulo_modulo @ nat @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
         != ( suc @ ( zero_zero @ nat ) ) ) )
      = ( ( modulo_modulo @ nat @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
        = ( zero_zero @ nat ) ) ) ).

% not_mod2_eq_Suc_0_eq_0
thf(fact_1002_add__self__mod__2,axiom,
    ! [M: nat] :
      ( ( modulo_modulo @ nat @ ( plus_plus @ nat @ M @ M ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
      = ( zero_zero @ nat ) ) ).

% add_self_mod_2
thf(fact_1003_mod2__gr__0,axiom,
    ! [M: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( modulo_modulo @ nat @ M @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
      = ( ( modulo_modulo @ nat @ M @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
        = ( one_one @ nat ) ) ) ).

% mod2_gr_0
thf(fact_1004_zero__one__enat__neq_I1_J,axiom,
    ( zero_zero @ extended_enat )
 != ( one_one @ extended_enat ) ).

% zero_one_enat_neq(1)
thf(fact_1005_imult__is__0,axiom,
    ! [M: extended_enat,N2: extended_enat] :
      ( ( ( times_times @ extended_enat @ M @ N2 )
        = ( zero_zero @ extended_enat ) )
      = ( ( M
          = ( zero_zero @ extended_enat ) )
        | ( N2
          = ( zero_zero @ extended_enat ) ) ) ) ).

% imult_is_0
thf(fact_1006_iadd__is__0,axiom,
    ! [M: extended_enat,N2: extended_enat] :
      ( ( ( plus_plus @ extended_enat @ M @ N2 )
        = ( zero_zero @ extended_enat ) )
      = ( ( M
          = ( zero_zero @ extended_enat ) )
        & ( N2
          = ( zero_zero @ extended_enat ) ) ) ) ).

% iadd_is_0
thf(fact_1007_list__update__swap,axiom,
    ! [A: $tType,I3: nat,I5: nat,Xs: list @ A,X2: A,X7: A] :
      ( ( I3 != I5 )
     => ( ( list_update @ A @ ( list_update @ A @ Xs @ I3 @ X2 ) @ I5 @ X7 )
        = ( list_update @ A @ ( list_update @ A @ Xs @ I5 @ X7 ) @ I3 @ X2 ) ) ) ).

% list_update_swap
thf(fact_1008_max__add__distrib__right,axiom,
    ! [A: $tType] :
      ( ( ordere2412721322843649153imp_le @ A )
     => ! [X2: A,Y2: A,Z: A] :
          ( ( plus_plus @ A @ X2 @ ( ord_max @ A @ Y2 @ Z ) )
          = ( ord_max @ A @ ( plus_plus @ A @ X2 @ Y2 ) @ ( plus_plus @ A @ X2 @ Z ) ) ) ) ).

% max_add_distrib_right
thf(fact_1009_max__add__distrib__left,axiom,
    ! [A: $tType] :
      ( ( ordere2412721322843649153imp_le @ A )
     => ! [X2: A,Y2: A,Z: A] :
          ( ( plus_plus @ A @ ( ord_max @ A @ X2 @ Y2 ) @ Z )
          = ( ord_max @ A @ ( plus_plus @ A @ X2 @ Z ) @ ( plus_plus @ A @ Y2 @ Z ) ) ) ) ).

% max_add_distrib_left
thf(fact_1010_mod__mult__eq,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( modulo_modulo @ A @ ( times_times @ A @ ( modulo_modulo @ A @ A2 @ C2 ) @ ( modulo_modulo @ A @ B2 @ C2 ) ) @ C2 )
          = ( modulo_modulo @ A @ ( times_times @ A @ A2 @ B2 ) @ C2 ) ) ) ).

% mod_mult_eq
thf(fact_1011_mod__mult__cong,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [A2: A,C2: A,A6: A,B2: A,B6: A] :
          ( ( ( modulo_modulo @ A @ A2 @ C2 )
            = ( modulo_modulo @ A @ A6 @ C2 ) )
         => ( ( ( modulo_modulo @ A @ B2 @ C2 )
              = ( modulo_modulo @ A @ B6 @ C2 ) )
           => ( ( modulo_modulo @ A @ ( times_times @ A @ A2 @ B2 ) @ C2 )
              = ( modulo_modulo @ A @ ( times_times @ A @ A6 @ B6 ) @ C2 ) ) ) ) ) ).

% mod_mult_cong
thf(fact_1012_mod__mult__mult2,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( modulo_modulo @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) )
          = ( times_times @ A @ ( modulo_modulo @ A @ A2 @ B2 ) @ C2 ) ) ) ).

% mod_mult_mult2
thf(fact_1013_mult__mod__right,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( times_times @ A @ C2 @ ( modulo_modulo @ A @ A2 @ B2 ) )
          = ( modulo_modulo @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) ) ) ) ).

% mult_mod_right
thf(fact_1014_mod__mult__left__eq,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( modulo_modulo @ A @ ( times_times @ A @ ( modulo_modulo @ A @ A2 @ C2 ) @ B2 ) @ C2 )
          = ( modulo_modulo @ A @ ( times_times @ A @ A2 @ B2 ) @ C2 ) ) ) ).

% mod_mult_left_eq
thf(fact_1015_mod__mult__right__eq,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( modulo_modulo @ A @ ( times_times @ A @ A2 @ ( modulo_modulo @ A @ B2 @ C2 ) ) @ C2 )
          = ( modulo_modulo @ A @ ( times_times @ A @ A2 @ B2 ) @ C2 ) ) ) ).

% mod_mult_right_eq
thf(fact_1016_mod__add__right__eq,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( modulo_modulo @ A @ ( plus_plus @ A @ A2 @ ( modulo_modulo @ A @ B2 @ C2 ) ) @ C2 )
          = ( modulo_modulo @ A @ ( plus_plus @ A @ A2 @ B2 ) @ C2 ) ) ) ).

% mod_add_right_eq
thf(fact_1017_mod__add__left__eq,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( modulo_modulo @ A @ ( plus_plus @ A @ ( modulo_modulo @ A @ A2 @ C2 ) @ B2 ) @ C2 )
          = ( modulo_modulo @ A @ ( plus_plus @ A @ A2 @ B2 ) @ C2 ) ) ) ).

% mod_add_left_eq
thf(fact_1018_mod__add__cong,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [A2: A,C2: A,A6: A,B2: A,B6: A] :
          ( ( ( modulo_modulo @ A @ A2 @ C2 )
            = ( modulo_modulo @ A @ A6 @ C2 ) )
         => ( ( ( modulo_modulo @ A @ B2 @ C2 )
              = ( modulo_modulo @ A @ B6 @ C2 ) )
           => ( ( modulo_modulo @ A @ ( plus_plus @ A @ A2 @ B2 ) @ C2 )
              = ( modulo_modulo @ A @ ( plus_plus @ A @ A6 @ B6 ) @ C2 ) ) ) ) ) ).

% mod_add_cong
thf(fact_1019_mod__add__eq,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( modulo_modulo @ A @ ( plus_plus @ A @ ( modulo_modulo @ A @ A2 @ C2 ) @ ( modulo_modulo @ A @ B2 @ C2 ) ) @ C2 )
          = ( modulo_modulo @ A @ ( plus_plus @ A @ A2 @ B2 ) @ C2 ) ) ) ).

% mod_add_eq
thf(fact_1020_power__mod,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [A2: A,B2: A,N2: nat] :
          ( ( modulo_modulo @ A @ ( power_power @ A @ ( modulo_modulo @ A @ A2 @ B2 ) @ N2 ) @ B2 )
          = ( modulo_modulo @ A @ ( power_power @ A @ A2 @ N2 ) @ B2 ) ) ) ).

% power_mod
thf(fact_1021_nat__add__max__right,axiom,
    ! [M: nat,N2: nat,Q3: nat] :
      ( ( plus_plus @ nat @ M @ ( ord_max @ nat @ N2 @ Q3 ) )
      = ( ord_max @ nat @ ( plus_plus @ nat @ M @ N2 ) @ ( plus_plus @ nat @ M @ Q3 ) ) ) ).

% nat_add_max_right
thf(fact_1022_nat__add__max__left,axiom,
    ! [M: nat,N2: nat,Q3: nat] :
      ( ( plus_plus @ nat @ ( ord_max @ nat @ M @ N2 ) @ Q3 )
      = ( ord_max @ nat @ ( plus_plus @ nat @ M @ Q3 ) @ ( plus_plus @ nat @ N2 @ Q3 ) ) ) ).

% nat_add_max_left
thf(fact_1023_nat__mult__max__left,axiom,
    ! [M: nat,N2: nat,Q3: nat] :
      ( ( times_times @ nat @ ( ord_max @ nat @ M @ N2 ) @ Q3 )
      = ( ord_max @ nat @ ( times_times @ nat @ M @ Q3 ) @ ( times_times @ nat @ N2 @ Q3 ) ) ) ).

% nat_mult_max_left
thf(fact_1024_nat__mult__max__right,axiom,
    ! [M: nat,N2: nat,Q3: nat] :
      ( ( times_times @ nat @ M @ ( ord_max @ nat @ N2 @ Q3 ) )
      = ( ord_max @ nat @ ( times_times @ nat @ M @ N2 ) @ ( times_times @ nat @ M @ Q3 ) ) ) ).

% nat_mult_max_right
thf(fact_1025_mod__Suc__Suc__eq,axiom,
    ! [M: nat,N2: nat] :
      ( ( modulo_modulo @ nat @ ( suc @ ( suc @ ( modulo_modulo @ nat @ M @ N2 ) ) ) @ N2 )
      = ( modulo_modulo @ nat @ ( suc @ ( suc @ M ) ) @ N2 ) ) ).

% mod_Suc_Suc_eq
thf(fact_1026_mod__Suc__eq,axiom,
    ! [M: nat,N2: nat] :
      ( ( modulo_modulo @ nat @ ( suc @ ( modulo_modulo @ nat @ M @ N2 ) ) @ N2 )
      = ( modulo_modulo @ nat @ ( suc @ M ) @ N2 ) ) ).

% mod_Suc_eq
thf(fact_1027_mod__less__eq__dividend,axiom,
    ! [M: nat,N2: nat] : ( ord_less_eq @ nat @ ( modulo_modulo @ nat @ M @ N2 ) @ M ) ).

% mod_less_eq_dividend
thf(fact_1028_unique__euclidean__semiring__numeral__class_Omod__less__eq__dividend,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( ord_less_eq @ A @ ( modulo_modulo @ A @ A2 @ B2 ) @ A2 ) ) ) ).

% unique_euclidean_semiring_numeral_class.mod_less_eq_dividend
thf(fact_1029_unique__euclidean__semiring__numeral__class_Opos__mod__bound,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ B2 )
         => ( ord_less @ A @ ( modulo_modulo @ A @ A2 @ B2 ) @ B2 ) ) ) ).

% unique_euclidean_semiring_numeral_class.pos_mod_bound
thf(fact_1030_mod__eq__self__iff__div__eq__0,axiom,
    ! [A: $tType] :
      ( ( euclid3725896446679973847miring @ A )
     => ! [A2: A,B2: A] :
          ( ( ( modulo_modulo @ A @ A2 @ B2 )
            = A2 )
          = ( ( divide_divide @ A @ A2 @ B2 )
            = ( zero_zero @ A ) ) ) ) ).

% mod_eq_self_iff_div_eq_0
thf(fact_1031_cong__exp__iff__simps_I9_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [M: num,Q3: num,N2: num] :
          ( ( ( modulo_modulo @ A @ ( numeral_numeral @ A @ ( bit0 @ M ) ) @ ( numeral_numeral @ A @ ( bit0 @ Q3 ) ) )
            = ( modulo_modulo @ A @ ( numeral_numeral @ A @ ( bit0 @ N2 ) ) @ ( numeral_numeral @ A @ ( bit0 @ Q3 ) ) ) )
          = ( ( modulo_modulo @ A @ ( numeral_numeral @ A @ M ) @ ( numeral_numeral @ A @ Q3 ) )
            = ( modulo_modulo @ A @ ( numeral_numeral @ A @ N2 ) @ ( numeral_numeral @ A @ Q3 ) ) ) ) ) ).

% cong_exp_iff_simps(9)
thf(fact_1032_cong__exp__iff__simps_I4_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [M: num,N2: num] :
          ( ( modulo_modulo @ A @ ( numeral_numeral @ A @ M ) @ ( numeral_numeral @ A @ one2 ) )
          = ( modulo_modulo @ A @ ( numeral_numeral @ A @ N2 ) @ ( numeral_numeral @ A @ one2 ) ) ) ) ).

% cong_exp_iff_simps(4)
thf(fact_1033_mod__eqE,axiom,
    ! [A: $tType] :
      ( ( euclid8851590272496341667cancel @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ( modulo_modulo @ A @ A2 @ C2 )
            = ( modulo_modulo @ A @ B2 @ C2 ) )
         => ~ ! [D4: A] :
                ( B2
               != ( plus_plus @ A @ A2 @ ( times_times @ A @ C2 @ D4 ) ) ) ) ) ).

% mod_eqE
thf(fact_1034_div__add1__eq,axiom,
    ! [A: $tType] :
      ( ( euclid3128863361964157862miring @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( divide_divide @ A @ ( plus_plus @ A @ A2 @ B2 ) @ C2 )
          = ( plus_plus @ A @ ( plus_plus @ A @ ( divide_divide @ A @ A2 @ C2 ) @ ( divide_divide @ A @ B2 @ C2 ) ) @ ( divide_divide @ A @ ( plus_plus @ A @ ( modulo_modulo @ A @ A2 @ C2 ) @ ( modulo_modulo @ A @ B2 @ C2 ) ) @ C2 ) ) ) ) ).

% div_add1_eq
thf(fact_1035_mod__Suc,axiom,
    ! [M: nat,N2: nat] :
      ( ( ( ( suc @ ( modulo_modulo @ nat @ M @ N2 ) )
          = N2 )
       => ( ( modulo_modulo @ nat @ ( suc @ M ) @ N2 )
          = ( zero_zero @ nat ) ) )
      & ( ( ( suc @ ( modulo_modulo @ nat @ M @ N2 ) )
         != N2 )
       => ( ( modulo_modulo @ nat @ ( suc @ M ) @ N2 )
          = ( suc @ ( modulo_modulo @ nat @ M @ N2 ) ) ) ) ) ).

% mod_Suc
thf(fact_1036_mod__induct,axiom,
    ! [P: nat > $o,N2: nat,P4: nat,M: nat] :
      ( ( P @ N2 )
     => ( ( ord_less @ nat @ N2 @ P4 )
       => ( ( ord_less @ nat @ M @ P4 )
         => ( ! [N: nat] :
                ( ( ord_less @ nat @ N @ P4 )
               => ( ( P @ N )
                 => ( P @ ( modulo_modulo @ nat @ ( suc @ N ) @ P4 ) ) ) )
           => ( P @ M ) ) ) ) ) ).

% mod_induct
thf(fact_1037_mod__less__divisor,axiom,
    ! [N2: nat,M: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ord_less @ nat @ ( modulo_modulo @ nat @ M @ N2 ) @ N2 ) ) ).

% mod_less_divisor
thf(fact_1038_mod__Suc__le__divisor,axiom,
    ! [M: nat,N2: nat] : ( ord_less_eq @ nat @ ( modulo_modulo @ nat @ M @ ( suc @ N2 ) ) @ N2 ) ).

% mod_Suc_le_divisor
thf(fact_1039_mod__eq__0D,axiom,
    ! [M: nat,D2: nat] :
      ( ( ( modulo_modulo @ nat @ M @ D2 )
        = ( zero_zero @ nat ) )
     => ? [Q2: nat] :
          ( M
          = ( times_times @ nat @ D2 @ Q2 ) ) ) ).

% mod_eq_0D
thf(fact_1040_nat__mod__eq__iff,axiom,
    ! [X2: nat,N2: nat,Y2: nat] :
      ( ( ( modulo_modulo @ nat @ X2 @ N2 )
        = ( modulo_modulo @ nat @ Y2 @ N2 ) )
      = ( ? [Q1: nat,Q22: nat] :
            ( ( plus_plus @ nat @ X2 @ ( times_times @ nat @ N2 @ Q1 ) )
            = ( plus_plus @ nat @ Y2 @ ( times_times @ nat @ N2 @ Q22 ) ) ) ) ) ).

% nat_mod_eq_iff
thf(fact_1041_set__update__subsetI,axiom,
    ! [A: $tType,Xs: list @ A,A3: set @ A,X2: A,I3: nat] :
      ( ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ Xs ) @ A3 )
     => ( ( member @ A @ X2 @ A3 )
       => ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ ( list_update @ A @ Xs @ I3 @ X2 ) ) @ A3 ) ) ) ).

% set_update_subsetI
thf(fact_1042_VEBT__internal_Ovalid_H_Ocases,axiom,
    ! [X2: product_prod @ vEBT_VEBT @ nat] :
      ( ! [Uu: $o,Uv: $o,D4: nat] :
          ( X2
         != ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Leaf @ Uu @ Uv ) @ D4 ) )
     => ~ ! [Mima: option @ ( product_prod @ nat @ nat ),Deg2: nat,TreeList2: list @ vEBT_VEBT,Summary2: vEBT_VEBT,Deg3: nat] :
            ( X2
           != ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ Mima @ Deg2 @ TreeList2 @ Summary2 ) @ Deg3 ) ) ) ).

% VEBT_internal.valid'.cases
thf(fact_1043_unique__euclidean__semiring__numeral__class_Opos__mod__sign,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ B2 )
         => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( modulo_modulo @ A @ A2 @ B2 ) ) ) ) ).

% unique_euclidean_semiring_numeral_class.pos_mod_sign
thf(fact_1044_unique__euclidean__semiring__numeral__class_Omod__less,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less @ A @ A2 @ B2 )
           => ( ( modulo_modulo @ A @ A2 @ B2 )
              = A2 ) ) ) ) ).

% unique_euclidean_semiring_numeral_class.mod_less
thf(fact_1045_cong__exp__iff__simps_I2_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [N2: num,Q3: num] :
          ( ( ( modulo_modulo @ A @ ( numeral_numeral @ A @ ( bit0 @ N2 ) ) @ ( numeral_numeral @ A @ ( bit0 @ Q3 ) ) )
            = ( zero_zero @ A ) )
          = ( ( modulo_modulo @ A @ ( numeral_numeral @ A @ N2 ) @ ( numeral_numeral @ A @ Q3 ) )
            = ( zero_zero @ A ) ) ) ) ).

% cong_exp_iff_simps(2)
thf(fact_1046_cong__exp__iff__simps_I1_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [N2: num] :
          ( ( modulo_modulo @ A @ ( numeral_numeral @ A @ N2 ) @ ( numeral_numeral @ A @ one2 ) )
          = ( zero_zero @ A ) ) ) ).

% cong_exp_iff_simps(1)
thf(fact_1047_cong__exp__iff__simps_I6_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [Q3: num,N2: num] :
          ( ( modulo_modulo @ A @ ( numeral_numeral @ A @ one2 ) @ ( numeral_numeral @ A @ ( bit0 @ Q3 ) ) )
         != ( modulo_modulo @ A @ ( numeral_numeral @ A @ ( bit0 @ N2 ) ) @ ( numeral_numeral @ A @ ( bit0 @ Q3 ) ) ) ) ) ).

% cong_exp_iff_simps(6)
thf(fact_1048_cong__exp__iff__simps_I8_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [M: num,Q3: num] :
          ( ( modulo_modulo @ A @ ( numeral_numeral @ A @ ( bit0 @ M ) ) @ ( numeral_numeral @ A @ ( bit0 @ Q3 ) ) )
         != ( modulo_modulo @ A @ ( numeral_numeral @ A @ one2 ) @ ( numeral_numeral @ A @ ( bit0 @ Q3 ) ) ) ) ) ).

% cong_exp_iff_simps(8)
thf(fact_1049_div__mult1__eq,axiom,
    ! [A: $tType] :
      ( ( euclid3128863361964157862miring @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( divide_divide @ A @ ( times_times @ A @ A2 @ B2 ) @ C2 )
          = ( plus_plus @ A @ ( times_times @ A @ A2 @ ( divide_divide @ A @ B2 @ C2 ) ) @ ( divide_divide @ A @ ( times_times @ A @ A2 @ ( modulo_modulo @ A @ B2 @ C2 ) ) @ C2 ) ) ) ) ).

% div_mult1_eq
thf(fact_1050_mult__div__mod__eq,axiom,
    ! [A: $tType] :
      ( ( semiring_modulo @ A )
     => ! [B2: A,A2: A] :
          ( ( plus_plus @ A @ ( times_times @ A @ B2 @ ( divide_divide @ A @ A2 @ B2 ) ) @ ( modulo_modulo @ A @ A2 @ B2 ) )
          = A2 ) ) ).

% mult_div_mod_eq
thf(fact_1051_mod__mult__div__eq,axiom,
    ! [A: $tType] :
      ( ( semiring_modulo @ A )
     => ! [A2: A,B2: A] :
          ( ( plus_plus @ A @ ( modulo_modulo @ A @ A2 @ B2 ) @ ( times_times @ A @ B2 @ ( divide_divide @ A @ A2 @ B2 ) ) )
          = A2 ) ) ).

% mod_mult_div_eq
thf(fact_1052_mod__div__mult__eq,axiom,
    ! [A: $tType] :
      ( ( semiring_modulo @ A )
     => ! [A2: A,B2: A] :
          ( ( plus_plus @ A @ ( modulo_modulo @ A @ A2 @ B2 ) @ ( times_times @ A @ ( divide_divide @ A @ A2 @ B2 ) @ B2 ) )
          = A2 ) ) ).

% mod_div_mult_eq
thf(fact_1053_div__mult__mod__eq,axiom,
    ! [A: $tType] :
      ( ( semiring_modulo @ A )
     => ! [A2: A,B2: A] :
          ( ( plus_plus @ A @ ( times_times @ A @ ( divide_divide @ A @ A2 @ B2 ) @ B2 ) @ ( modulo_modulo @ A @ A2 @ B2 ) )
          = A2 ) ) ).

% div_mult_mod_eq
thf(fact_1054_mod__div__decomp,axiom,
    ! [A: $tType] :
      ( ( semiring_modulo @ A )
     => ! [A2: A,B2: A] :
          ( A2
          = ( plus_plus @ A @ ( times_times @ A @ ( divide_divide @ A @ A2 @ B2 ) @ B2 ) @ ( modulo_modulo @ A @ A2 @ B2 ) ) ) ) ).

% mod_div_decomp
thf(fact_1055_cancel__div__mod__rules_I1_J,axiom,
    ! [A: $tType] :
      ( ( semidom_modulo @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( plus_plus @ A @ ( plus_plus @ A @ ( times_times @ A @ ( divide_divide @ A @ A2 @ B2 ) @ B2 ) @ ( modulo_modulo @ A @ A2 @ B2 ) ) @ C2 )
          = ( plus_plus @ A @ A2 @ C2 ) ) ) ).

% cancel_div_mod_rules(1)
thf(fact_1056_cancel__div__mod__rules_I2_J,axiom,
    ! [A: $tType] :
      ( ( semidom_modulo @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( plus_plus @ A @ ( plus_plus @ A @ ( times_times @ A @ B2 @ ( divide_divide @ A @ A2 @ B2 ) ) @ ( modulo_modulo @ A @ A2 @ B2 ) ) @ C2 )
          = ( plus_plus @ A @ A2 @ C2 ) ) ) ).

% cancel_div_mod_rules(2)
thf(fact_1057_mod__le__divisor,axiom,
    ! [N2: nat,M: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ord_less_eq @ nat @ ( modulo_modulo @ nat @ M @ N2 ) @ N2 ) ) ).

% mod_le_divisor
thf(fact_1058_nat__mod__eq__lemma,axiom,
    ! [X2: nat,N2: nat,Y2: nat] :
      ( ( ( modulo_modulo @ nat @ X2 @ N2 )
        = ( modulo_modulo @ nat @ Y2 @ N2 ) )
     => ( ( ord_less_eq @ nat @ Y2 @ X2 )
       => ? [Q2: nat] :
            ( X2
            = ( plus_plus @ nat @ Y2 @ ( times_times @ nat @ N2 @ Q2 ) ) ) ) ) ).

% nat_mod_eq_lemma
thf(fact_1059_mod__eq__nat2E,axiom,
    ! [M: nat,Q3: nat,N2: nat] :
      ( ( ( modulo_modulo @ nat @ M @ Q3 )
        = ( modulo_modulo @ nat @ N2 @ Q3 ) )
     => ( ( ord_less_eq @ nat @ M @ N2 )
       => ~ ! [S: nat] :
              ( N2
             != ( plus_plus @ nat @ M @ ( times_times @ nat @ Q3 @ S ) ) ) ) ) ).

% mod_eq_nat2E
thf(fact_1060_mod__eq__nat1E,axiom,
    ! [M: nat,Q3: nat,N2: nat] :
      ( ( ( modulo_modulo @ nat @ M @ Q3 )
        = ( modulo_modulo @ nat @ N2 @ Q3 ) )
     => ( ( ord_less_eq @ nat @ N2 @ M )
       => ~ ! [S: nat] :
              ( M
             != ( plus_plus @ nat @ N2 @ ( times_times @ nat @ Q3 @ S ) ) ) ) ) ).

% mod_eq_nat1E
thf(fact_1061_VEBT__internal_Onaive__member_Osimps_I2_J,axiom,
    ! [Uu2: option @ ( product_prod @ nat @ nat ),Uv2: list @ vEBT_VEBT,Uw2: vEBT_VEBT,Ux2: nat] :
      ~ ( vEBT_V5719532721284313246member @ ( vEBT_Node @ Uu2 @ ( zero_zero @ nat ) @ Uv2 @ Uw2 ) @ Ux2 ) ).

% VEBT_internal.naive_member.simps(2)
thf(fact_1062_mod__mult2__eq,axiom,
    ! [M: nat,N2: nat,Q3: nat] :
      ( ( modulo_modulo @ nat @ M @ ( times_times @ nat @ N2 @ Q3 ) )
      = ( plus_plus @ nat @ ( times_times @ nat @ N2 @ ( modulo_modulo @ nat @ ( divide_divide @ nat @ M @ N2 ) @ Q3 ) ) @ ( modulo_modulo @ nat @ M @ N2 ) ) ) ).

% mod_mult2_eq
thf(fact_1063_set__update__memI,axiom,
    ! [A: $tType,N2: nat,Xs: list @ A,X2: A] :
      ( ( ord_less @ nat @ N2 @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( member @ A @ X2 @ ( set2 @ A @ ( list_update @ A @ Xs @ N2 @ X2 ) ) ) ) ).

% set_update_memI
thf(fact_1064_list__update__same__conv,axiom,
    ! [A: $tType,I3: nat,Xs: list @ A,X2: A] :
      ( ( ord_less @ nat @ I3 @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( ( ( list_update @ A @ Xs @ I3 @ X2 )
          = Xs )
        = ( ( nth @ A @ Xs @ I3 )
          = X2 ) ) ) ).

% list_update_same_conv
thf(fact_1065_nth__list__update,axiom,
    ! [A: $tType,I3: nat,Xs: list @ A,J: nat,X2: A] :
      ( ( ord_less @ nat @ I3 @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( ( ( I3 = J )
         => ( ( nth @ A @ ( list_update @ A @ Xs @ I3 @ X2 ) @ J )
            = X2 ) )
        & ( ( I3 != J )
         => ( ( nth @ A @ ( list_update @ A @ Xs @ I3 @ X2 ) @ J )
            = ( nth @ A @ Xs @ J ) ) ) ) ) ).

% nth_list_update
thf(fact_1066_pinf_I1_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [P: A > $o,P5: A > $o,Q: A > $o,Q6: A > $o] :
          ( ? [Z4: A] :
            ! [X3: A] :
              ( ( ord_less @ A @ Z4 @ X3 )
             => ( ( P @ X3 )
                = ( P5 @ X3 ) ) )
         => ( ? [Z4: A] :
              ! [X3: A] :
                ( ( ord_less @ A @ Z4 @ X3 )
               => ( ( Q @ X3 )
                  = ( Q6 @ X3 ) ) )
           => ? [Z3: A] :
              ! [X: A] :
                ( ( ord_less @ A @ Z3 @ X )
               => ( ( ( P @ X )
                    & ( Q @ X ) )
                  = ( ( P5 @ X )
                    & ( Q6 @ X ) ) ) ) ) ) ) ).

% pinf(1)
thf(fact_1067_pinf_I2_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [P: A > $o,P5: A > $o,Q: A > $o,Q6: A > $o] :
          ( ? [Z4: A] :
            ! [X3: A] :
              ( ( ord_less @ A @ Z4 @ X3 )
             => ( ( P @ X3 )
                = ( P5 @ X3 ) ) )
         => ( ? [Z4: A] :
              ! [X3: A] :
                ( ( ord_less @ A @ Z4 @ X3 )
               => ( ( Q @ X3 )
                  = ( Q6 @ X3 ) ) )
           => ? [Z3: A] :
              ! [X: A] :
                ( ( ord_less @ A @ Z3 @ X )
               => ( ( ( P @ X )
                    | ( Q @ X ) )
                  = ( ( P5 @ X )
                    | ( Q6 @ X ) ) ) ) ) ) ) ).

% pinf(2)
thf(fact_1068_pinf_I3_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [T2: A] :
        ? [Z3: A] :
        ! [X: A] :
          ( ( ord_less @ A @ Z3 @ X )
         => ( X != T2 ) ) ) ).

% pinf(3)
thf(fact_1069_pinf_I4_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [T2: A] :
        ? [Z3: A] :
        ! [X: A] :
          ( ( ord_less @ A @ Z3 @ X )
         => ( X != T2 ) ) ) ).

% pinf(4)
thf(fact_1070_pinf_I5_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [T2: A] :
        ? [Z3: A] :
        ! [X: A] :
          ( ( ord_less @ A @ Z3 @ X )
         => ~ ( ord_less @ A @ X @ T2 ) ) ) ).

% pinf(5)
thf(fact_1071_pinf_I7_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [T2: A] :
        ? [Z3: A] :
        ! [X: A] :
          ( ( ord_less @ A @ Z3 @ X )
         => ( ord_less @ A @ T2 @ X ) ) ) ).

% pinf(7)
thf(fact_1072_pinf_I11_J,axiom,
    ! [C: $tType,D: $tType] :
      ( ( ord @ C )
     => ! [F3: D] :
        ? [Z3: C] :
        ! [X: C] :
          ( ( ord_less @ C @ Z3 @ X )
         => ( F3 = F3 ) ) ) ).

% pinf(11)
thf(fact_1073_minf_I1_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [P: A > $o,P5: A > $o,Q: A > $o,Q6: A > $o] :
          ( ? [Z4: A] :
            ! [X3: A] :
              ( ( ord_less @ A @ X3 @ Z4 )
             => ( ( P @ X3 )
                = ( P5 @ X3 ) ) )
         => ( ? [Z4: A] :
              ! [X3: A] :
                ( ( ord_less @ A @ X3 @ Z4 )
               => ( ( Q @ X3 )
                  = ( Q6 @ X3 ) ) )
           => ? [Z3: A] :
              ! [X: A] :
                ( ( ord_less @ A @ X @ Z3 )
               => ( ( ( P @ X )
                    & ( Q @ X ) )
                  = ( ( P5 @ X )
                    & ( Q6 @ X ) ) ) ) ) ) ) ).

% minf(1)
thf(fact_1074_minf_I2_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [P: A > $o,P5: A > $o,Q: A > $o,Q6: A > $o] :
          ( ? [Z4: A] :
            ! [X3: A] :
              ( ( ord_less @ A @ X3 @ Z4 )
             => ( ( P @ X3 )
                = ( P5 @ X3 ) ) )
         => ( ? [Z4: A] :
              ! [X3: A] :
                ( ( ord_less @ A @ X3 @ Z4 )
               => ( ( Q @ X3 )
                  = ( Q6 @ X3 ) ) )
           => ? [Z3: A] :
              ! [X: A] :
                ( ( ord_less @ A @ X @ Z3 )
               => ( ( ( P @ X )
                    | ( Q @ X ) )
                  = ( ( P5 @ X )
                    | ( Q6 @ X ) ) ) ) ) ) ) ).

% minf(2)
thf(fact_1075_minf_I3_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [T2: A] :
        ? [Z3: A] :
        ! [X: A] :
          ( ( ord_less @ A @ X @ Z3 )
         => ( X != T2 ) ) ) ).

% minf(3)
thf(fact_1076_minf_I4_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [T2: A] :
        ? [Z3: A] :
        ! [X: A] :
          ( ( ord_less @ A @ X @ Z3 )
         => ( X != T2 ) ) ) ).

% minf(4)
thf(fact_1077_minf_I5_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [T2: A] :
        ? [Z3: A] :
        ! [X: A] :
          ( ( ord_less @ A @ X @ Z3 )
         => ( ord_less @ A @ X @ T2 ) ) ) ).

% minf(5)
thf(fact_1078_minf_I7_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [T2: A] :
        ? [Z3: A] :
        ! [X: A] :
          ( ( ord_less @ A @ X @ Z3 )
         => ~ ( ord_less @ A @ T2 @ X ) ) ) ).

% minf(7)
thf(fact_1079_minf_I11_J,axiom,
    ! [C: $tType,D: $tType] :
      ( ( ord @ C )
     => ! [F3: D] :
        ? [Z3: C] :
        ! [X: C] :
          ( ( ord_less @ C @ X @ Z3 )
         => ( F3 = F3 ) ) ) ).

% minf(11)
thf(fact_1080_split__mod,axiom,
    ! [P: nat > $o,M: nat,N2: nat] :
      ( ( P @ ( modulo_modulo @ nat @ M @ N2 ) )
      = ( ( ( N2
            = ( zero_zero @ nat ) )
         => ( P @ M ) )
        & ( ( N2
           != ( zero_zero @ nat ) )
         => ! [I4: nat,J3: nat] :
              ( ( ord_less @ nat @ J3 @ N2 )
             => ( ( M
                  = ( plus_plus @ nat @ ( times_times @ nat @ N2 @ I4 ) @ J3 ) )
               => ( P @ J3 ) ) ) ) ) ) ).

% split_mod
thf(fact_1081_VEBT__internal_Onaive__member_Ocases,axiom,
    ! [X2: product_prod @ vEBT_VEBT @ nat] :
      ( ! [A5: $o,B5: $o,X3: nat] :
          ( X2
         != ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Leaf @ A5 @ B5 ) @ X3 ) )
     => ( ! [Uu: option @ ( product_prod @ nat @ nat ),Uv: list @ vEBT_VEBT,Uw: vEBT_VEBT,Ux: nat] :
            ( X2
           != ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ Uu @ ( zero_zero @ nat ) @ Uv @ Uw ) @ Ux ) )
       => ~ ! [Uy: option @ ( product_prod @ nat @ nat ),V3: nat,TreeList2: list @ vEBT_VEBT,S: vEBT_VEBT,X3: nat] :
              ( X2
             != ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ Uy @ ( suc @ V3 ) @ TreeList2 @ S ) @ X3 ) ) ) ) ).

% VEBT_internal.naive_member.cases
thf(fact_1082_VEBT__internal_Onaive__member_Osimps_I1_J,axiom,
    ! [A2: $o,B2: $o,X2: nat] :
      ( ( vEBT_V5719532721284313246member @ ( vEBT_Leaf @ A2 @ B2 ) @ X2 )
      = ( ( ( X2
            = ( zero_zero @ nat ) )
         => A2 )
        & ( ( X2
           != ( zero_zero @ nat ) )
         => ( ( ( X2
                = ( one_one @ nat ) )
             => B2 )
            & ( X2
              = ( one_one @ nat ) ) ) ) ) ) ).

% VEBT_internal.naive_member.simps(1)
thf(fact_1083_unique__euclidean__semiring__numeral__class_Omod__mult2__eq,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
         => ( ( modulo_modulo @ A @ A2 @ ( times_times @ A @ B2 @ C2 ) )
            = ( plus_plus @ A @ ( times_times @ A @ B2 @ ( modulo_modulo @ A @ ( divide_divide @ A @ A2 @ B2 ) @ C2 ) ) @ ( modulo_modulo @ A @ A2 @ B2 ) ) ) ) ) ).

% unique_euclidean_semiring_numeral_class.mod_mult2_eq
thf(fact_1084_Suc__times__mod__eq,axiom,
    ! [M: nat,N2: nat] :
      ( ( ord_less @ nat @ ( suc @ ( zero_zero @ nat ) ) @ M )
     => ( ( modulo_modulo @ nat @ ( suc @ ( times_times @ nat @ M @ N2 ) ) @ M )
        = ( one_one @ nat ) ) ) ).

% Suc_times_mod_eq
thf(fact_1085_divmod__digit__0_I2_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ B2 )
         => ( ( ord_less @ A @ ( modulo_modulo @ A @ A2 @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B2 ) ) @ B2 )
           => ( ( modulo_modulo @ A @ A2 @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B2 ) )
              = ( modulo_modulo @ A @ A2 @ B2 ) ) ) ) ) ).

% divmod_digit_0(2)
thf(fact_1086_bits__stable__imp__add__self,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A] :
          ( ( ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
            = A2 )
         => ( ( plus_plus @ A @ A2 @ ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) )
            = ( zero_zero @ A ) ) ) ) ).

% bits_stable_imp_add_self
thf(fact_1087_div__exp__mod__exp__eq,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A,N2: nat,M: nat] :
          ( ( modulo_modulo @ A @ ( divide_divide @ A @ A2 @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N2 ) ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M ) )
          = ( divide_divide @ A @ ( modulo_modulo @ A @ A2 @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( plus_plus @ nat @ N2 @ M ) ) ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N2 ) ) ) ) ).

% div_exp_mod_exp_eq
thf(fact_1088_divmod__digit__0_I1_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ B2 )
         => ( ( ord_less @ A @ ( modulo_modulo @ A @ A2 @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B2 ) ) @ B2 )
           => ( ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( divide_divide @ A @ A2 @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B2 ) ) )
              = ( divide_divide @ A @ A2 @ B2 ) ) ) ) ) ).

% divmod_digit_0(1)
thf(fact_1089_pinf_I6_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [T2: A] :
        ? [Z3: A] :
        ! [X: A] :
          ( ( ord_less @ A @ Z3 @ X )
         => ~ ( ord_less_eq @ A @ X @ T2 ) ) ) ).

% pinf(6)
thf(fact_1090_pinf_I8_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [T2: A] :
        ? [Z3: A] :
        ! [X: A] :
          ( ( ord_less @ A @ Z3 @ X )
         => ( ord_less_eq @ A @ T2 @ X ) ) ) ).

% pinf(8)
thf(fact_1091_minf_I6_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [T2: A] :
        ? [Z3: A] :
        ! [X: A] :
          ( ( ord_less @ A @ X @ Z3 )
         => ( ord_less_eq @ A @ X @ T2 ) ) ) ).

% minf(6)
thf(fact_1092_minf_I8_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [T2: A] :
        ? [Z3: A] :
        ! [X: A] :
          ( ( ord_less @ A @ X @ Z3 )
         => ~ ( ord_less_eq @ A @ T2 @ X ) ) ) ).

% minf(8)
thf(fact_1093_imp__le__cong,axiom,
    ! [X2: int,X7: int,P: $o,P5: $o] :
      ( ( X2 = X7 )
     => ( ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ X7 )
         => ( P = P5 ) )
       => ( ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ X2 )
           => P )
          = ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ X7 )
           => P5 ) ) ) ) ).

% imp_le_cong
thf(fact_1094_conj__le__cong,axiom,
    ! [X2: int,X7: int,P: $o,P5: $o] :
      ( ( X2 = X7 )
     => ( ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ X7 )
         => ( P = P5 ) )
       => ( ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ X2 )
            & P )
          = ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ X7 )
            & P5 ) ) ) ) ).

% conj_le_cong
thf(fact_1095_mod__double__modulus,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [M: A,X2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ M )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X2 )
           => ( ( ( modulo_modulo @ A @ X2 @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M ) )
                = ( modulo_modulo @ A @ X2 @ M ) )
              | ( ( modulo_modulo @ A @ X2 @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M ) )
                = ( plus_plus @ A @ ( modulo_modulo @ A @ X2 @ M ) @ M ) ) ) ) ) ) ).

% mod_double_modulus
thf(fact_1096_vebt__member_Ocases,axiom,
    ! [X2: product_prod @ vEBT_VEBT @ nat] :
      ( ! [A5: $o,B5: $o,X3: nat] :
          ( X2
         != ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Leaf @ A5 @ B5 ) @ X3 ) )
     => ( ! [Uu: nat,Uv: list @ vEBT_VEBT,Uw: vEBT_VEBT,X3: nat] :
            ( X2
           != ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ Uu @ Uv @ Uw ) @ X3 ) )
       => ( ! [V3: product_prod @ nat @ nat,Uy: list @ vEBT_VEBT,Uz: vEBT_VEBT,X3: nat] :
              ( X2
             != ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ V3 ) @ ( zero_zero @ nat ) @ Uy @ Uz ) @ X3 ) )
         => ( ! [V3: product_prod @ nat @ nat,Vb2: list @ vEBT_VEBT,Vc2: vEBT_VEBT,X3: nat] :
                ( X2
               != ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ V3 ) @ ( suc @ ( zero_zero @ nat ) ) @ Vb2 @ Vc2 ) @ X3 ) )
           => ~ ! [Mi2: nat,Ma2: nat,Va: nat,TreeList2: list @ vEBT_VEBT,Summary2: vEBT_VEBT,X3: nat] :
                  ( X2
                 != ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ Ma2 ) ) @ ( suc @ ( suc @ Va ) ) @ TreeList2 @ Summary2 ) @ X3 ) ) ) ) ) ) ).

% vebt_member.cases
thf(fact_1097_VEBT__internal_Omembermima_Ocases,axiom,
    ! [X2: product_prod @ vEBT_VEBT @ nat] :
      ( ! [Uu: $o,Uv: $o,Uw: nat] :
          ( X2
         != ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Leaf @ Uu @ Uv ) @ Uw ) )
     => ( ! [Ux: list @ vEBT_VEBT,Uy: vEBT_VEBT,Uz: nat] :
            ( X2
           != ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( zero_zero @ nat ) @ Ux @ Uy ) @ Uz ) )
       => ( ! [Mi2: nat,Ma2: nat,Va2: list @ vEBT_VEBT,Vb2: vEBT_VEBT,X3: nat] :
              ( X2
             != ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ Ma2 ) ) @ ( zero_zero @ nat ) @ Va2 @ Vb2 ) @ X3 ) )
         => ( ! [Mi2: nat,Ma2: nat,V3: nat,TreeList2: list @ vEBT_VEBT,Vc2: vEBT_VEBT,X3: nat] :
                ( X2
               != ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ Ma2 ) ) @ ( suc @ V3 ) @ TreeList2 @ Vc2 ) @ X3 ) )
           => ~ ! [V3: nat,TreeList2: list @ vEBT_VEBT,Vd: vEBT_VEBT,X3: nat] :
                  ( X2
                 != ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ V3 ) @ TreeList2 @ Vd ) @ X3 ) ) ) ) ) ) ).

% VEBT_internal.membermima.cases
thf(fact_1098_vebt__insert_Ocases,axiom,
    ! [X2: product_prod @ vEBT_VEBT @ nat] :
      ( ! [A5: $o,B5: $o,X3: nat] :
          ( X2
         != ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Leaf @ A5 @ B5 ) @ X3 ) )
     => ( ! [Info2: option @ ( product_prod @ nat @ nat ),Ts2: list @ vEBT_VEBT,S: vEBT_VEBT,X3: nat] :
            ( X2
           != ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ Info2 @ ( zero_zero @ nat ) @ Ts2 @ S ) @ X3 ) )
       => ( ! [Info2: option @ ( product_prod @ nat @ nat ),Ts2: list @ vEBT_VEBT,S: vEBT_VEBT,X3: nat] :
              ( X2
             != ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ Info2 @ ( suc @ ( zero_zero @ nat ) ) @ Ts2 @ S ) @ X3 ) )
         => ( ! [V3: nat,TreeList2: list @ vEBT_VEBT,Summary2: vEBT_VEBT,X3: nat] :
                ( X2
               != ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ ( suc @ V3 ) ) @ TreeList2 @ Summary2 ) @ X3 ) )
           => ~ ! [Mi2: nat,Ma2: nat,Va: nat,TreeList2: list @ vEBT_VEBT,Summary2: vEBT_VEBT,X3: nat] :
                  ( X2
                 != ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ Ma2 ) ) @ ( suc @ ( suc @ Va ) ) @ TreeList2 @ Summary2 ) @ X3 ) ) ) ) ) ) ).

% vebt_insert.cases
thf(fact_1099_unset__bit__Suc,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N2: nat,A2: A] :
          ( ( bit_se2638667681897837118et_bit @ A @ ( suc @ N2 ) @ A2 )
          = ( plus_plus @ A @ ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se2638667681897837118et_bit @ A @ N2 @ ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% unset_bit_Suc
thf(fact_1100_set__bit__Suc,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N2: nat,A2: A] :
          ( ( bit_se5668285175392031749et_bit @ A @ ( suc @ N2 ) @ A2 )
          = ( plus_plus @ A @ ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se5668285175392031749et_bit @ A @ N2 @ ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% set_bit_Suc
thf(fact_1101_divmod__digit__1_I1_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ B2 )
           => ( ( ord_less_eq @ A @ B2 @ ( modulo_modulo @ A @ A2 @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B2 ) ) )
             => ( ( plus_plus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( divide_divide @ A @ A2 @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B2 ) ) ) @ ( one_one @ A ) )
                = ( divide_divide @ A @ A2 @ B2 ) ) ) ) ) ) ).

% divmod_digit_1(1)
thf(fact_1102_mult__less__iff1,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [Z: A,X2: A,Y2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ Z )
         => ( ( ord_less @ A @ ( times_times @ A @ X2 @ Z ) @ ( times_times @ A @ Y2 @ Z ) )
            = ( ord_less @ A @ X2 @ Y2 ) ) ) ) ).

% mult_less_iff1
thf(fact_1103_verit__le__mono__div,axiom,
    ! [A3: nat,B3: nat,N2: nat] :
      ( ( ord_less @ nat @ A3 @ B3 )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
       => ( ord_less_eq @ nat
          @ ( plus_plus @ nat @ ( divide_divide @ nat @ A3 @ N2 )
            @ ( if @ nat
              @ ( ( modulo_modulo @ nat @ B3 @ N2 )
                = ( zero_zero @ nat ) )
              @ ( one_one @ nat )
              @ ( zero_zero @ nat ) ) )
          @ ( divide_divide @ nat @ B3 @ N2 ) ) ) ) ).

% verit_le_mono_div
thf(fact_1104_member__valid__both__member__options,axiom,
    ! [Tree: vEBT_VEBT,N2: nat,X2: nat] :
      ( ( vEBT_invar_vebt @ Tree @ N2 )
     => ( ( vEBT_vebt_member @ Tree @ X2 )
       => ( ( vEBT_V5719532721284313246member @ Tree @ X2 )
          | ( vEBT_VEBT_membermima @ Tree @ X2 ) ) ) ) ).

% member_valid_both_member_options
thf(fact_1105_max__less__iff__conj,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X2: A,Y2: A,Z: A] :
          ( ( ord_less @ A @ ( ord_max @ A @ X2 @ Y2 ) @ Z )
          = ( ( ord_less @ A @ X2 @ Z )
            & ( ord_less @ A @ Y2 @ Z ) ) ) ) ).

% max_less_iff_conj
thf(fact_1106_max_Oabsorb4,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_max @ A @ A2 @ B2 )
            = B2 ) ) ) ).

% max.absorb4
thf(fact_1107_max_Oabsorb3,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less @ A @ B2 @ A2 )
         => ( ( ord_max @ A @ A2 @ B2 )
            = A2 ) ) ) ).

% max.absorb3
thf(fact_1108_max_Obounded__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( ord_less_eq @ A @ ( ord_max @ A @ B2 @ C2 ) @ A2 )
          = ( ( ord_less_eq @ A @ B2 @ A2 )
            & ( ord_less_eq @ A @ C2 @ A2 ) ) ) ) ).

% max.bounded_iff
thf(fact_1109_max_Oabsorb2,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_max @ A @ A2 @ B2 )
            = B2 ) ) ) ).

% max.absorb2
thf(fact_1110_max_Oabsorb1,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less_eq @ A @ B2 @ A2 )
         => ( ( ord_max @ A @ A2 @ B2 )
            = A2 ) ) ) ).

% max.absorb1
thf(fact_1111_div__mod__decomp,axiom,
    ! [A3: nat,N2: nat] :
      ( A3
      = ( plus_plus @ nat @ ( times_times @ nat @ ( divide_divide @ nat @ A3 @ N2 ) @ N2 ) @ ( modulo_modulo @ nat @ A3 @ N2 ) ) ) ).

% div_mod_decomp
thf(fact_1112_buildup__nothing__in__min__max,axiom,
    ! [N2: nat,X2: nat] :
      ~ ( vEBT_VEBT_membermima @ ( vEBT_vebt_buildup @ N2 ) @ X2 ) ).

% buildup_nothing_in_min_max
thf(fact_1113_both__member__options__def,axiom,
    ( vEBT_V8194947554948674370ptions
    = ( ^ [T3: vEBT_VEBT,X5: nat] :
          ( ( vEBT_V5719532721284313246member @ T3 @ X5 )
          | ( vEBT_VEBT_membermima @ T3 @ X5 ) ) ) ) ).

% both_member_options_def
thf(fact_1114_verit__eq__simplify_I8_J,axiom,
    ! [X22: num,Y22: num] :
      ( ( ( bit0 @ X22 )
        = ( bit0 @ Y22 ) )
      = ( X22 = Y22 ) ) ).

% verit_eq_simplify(8)
thf(fact_1115_max__enat__simps_I3_J,axiom,
    ! [Q3: extended_enat] :
      ( ( ord_max @ extended_enat @ ( zero_zero @ extended_enat ) @ Q3 )
      = Q3 ) ).

% max_enat_simps(3)
thf(fact_1116_max__enat__simps_I2_J,axiom,
    ! [Q3: extended_enat] :
      ( ( ord_max @ extended_enat @ Q3 @ ( zero_zero @ extended_enat ) )
      = Q3 ) ).

% max_enat_simps(2)
thf(fact_1117_mod__neg__neg__trivial,axiom,
    ! [K: int,L: int] :
      ( ( ord_less_eq @ int @ K @ ( zero_zero @ int ) )
     => ( ( ord_less @ int @ L @ K )
       => ( ( modulo_modulo @ int @ K @ L )
          = K ) ) ) ).

% mod_neg_neg_trivial
thf(fact_1118_mod__pos__pos__trivial,axiom,
    ! [K: int,L: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ K )
     => ( ( ord_less @ int @ K @ L )
       => ( ( modulo_modulo @ int @ K @ L )
          = K ) ) ) ).

% mod_pos_pos_trivial
thf(fact_1119_zmod__numeral__Bit0,axiom,
    ! [V: num,W: num] :
      ( ( modulo_modulo @ int @ ( numeral_numeral @ int @ ( bit0 @ V ) ) @ ( numeral_numeral @ int @ ( bit0 @ W ) ) )
      = ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( modulo_modulo @ int @ ( numeral_numeral @ int @ V ) @ ( numeral_numeral @ int @ W ) ) ) ) ).

% zmod_numeral_Bit0
thf(fact_1120_VEBT__internal_Omembermima_Osimps_I1_J,axiom,
    ! [Uu2: $o,Uv2: $o,Uw2: nat] :
      ~ ( vEBT_VEBT_membermima @ ( vEBT_Leaf @ Uu2 @ Uv2 ) @ Uw2 ) ).

% VEBT_internal.membermima.simps(1)
thf(fact_1121_zmod__le__nonneg__dividend,axiom,
    ! [M: int,K: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ M )
     => ( ord_less_eq @ int @ ( modulo_modulo @ int @ M @ K ) @ M ) ) ).

% zmod_le_nonneg_dividend
thf(fact_1122_neg__mod__bound,axiom,
    ! [L: int,K: int] :
      ( ( ord_less @ int @ L @ ( zero_zero @ int ) )
     => ( ord_less @ int @ L @ ( modulo_modulo @ int @ K @ L ) ) ) ).

% neg_mod_bound
thf(fact_1123_Euclidean__Division_Opos__mod__bound,axiom,
    ! [L: int,K: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ L )
     => ( ord_less @ int @ ( modulo_modulo @ int @ K @ L ) @ L ) ) ).

% Euclidean_Division.pos_mod_bound
thf(fact_1124_zmod__eq__0__iff,axiom,
    ! [M: int,D2: int] :
      ( ( ( modulo_modulo @ int @ M @ D2 )
        = ( zero_zero @ int ) )
      = ( ? [Q4: int] :
            ( M
            = ( times_times @ int @ D2 @ Q4 ) ) ) ) ).

% zmod_eq_0_iff
thf(fact_1125_zmod__eq__0D,axiom,
    ! [M: int,D2: int] :
      ( ( ( modulo_modulo @ int @ M @ D2 )
        = ( zero_zero @ int ) )
     => ? [Q2: int] :
          ( M
          = ( times_times @ int @ D2 @ Q2 ) ) ) ).

% zmod_eq_0D
thf(fact_1126_zdiv__mono__strict,axiom,
    ! [A3: int,B3: int,N2: int] :
      ( ( ord_less @ int @ A3 @ B3 )
     => ( ( ord_less @ int @ ( zero_zero @ int ) @ N2 )
       => ( ( ( modulo_modulo @ int @ A3 @ N2 )
            = ( zero_zero @ int ) )
         => ( ( ( modulo_modulo @ int @ B3 @ N2 )
              = ( zero_zero @ int ) )
           => ( ord_less @ int @ ( divide_divide @ int @ A3 @ N2 ) @ ( divide_divide @ int @ B3 @ N2 ) ) ) ) ) ) ).

% zdiv_mono_strict
thf(fact_1127_div__mod__decomp__int,axiom,
    ! [A3: int,N2: int] :
      ( A3
      = ( plus_plus @ int @ ( times_times @ int @ ( divide_divide @ int @ A3 @ N2 ) @ N2 ) @ ( modulo_modulo @ int @ A3 @ N2 ) ) ) ).

% div_mod_decomp_int
thf(fact_1128_neg__mod__sign,axiom,
    ! [L: int,K: int] :
      ( ( ord_less @ int @ L @ ( zero_zero @ int ) )
     => ( ord_less_eq @ int @ ( modulo_modulo @ int @ K @ L ) @ ( zero_zero @ int ) ) ) ).

% neg_mod_sign
thf(fact_1129_Euclidean__Division_Opos__mod__sign,axiom,
    ! [L: int,K: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ L )
     => ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( modulo_modulo @ int @ K @ L ) ) ) ).

% Euclidean_Division.pos_mod_sign
thf(fact_1130_zmod__trivial__iff,axiom,
    ! [I3: int,K: int] :
      ( ( ( modulo_modulo @ int @ I3 @ K )
        = I3 )
      = ( ( K
          = ( zero_zero @ int ) )
        | ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ I3 )
          & ( ord_less @ int @ I3 @ K ) )
        | ( ( ord_less_eq @ int @ I3 @ ( zero_zero @ int ) )
          & ( ord_less @ int @ K @ I3 ) ) ) ) ).

% zmod_trivial_iff
thf(fact_1131_pos__mod__conj,axiom,
    ! [B2: int,A2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ B2 )
     => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( modulo_modulo @ int @ A2 @ B2 ) )
        & ( ord_less @ int @ ( modulo_modulo @ int @ A2 @ B2 ) @ B2 ) ) ) ).

% pos_mod_conj
thf(fact_1132_neg__mod__conj,axiom,
    ! [B2: int,A2: int] :
      ( ( ord_less @ int @ B2 @ ( zero_zero @ int ) )
     => ( ( ord_less_eq @ int @ ( modulo_modulo @ int @ A2 @ B2 ) @ ( zero_zero @ int ) )
        & ( ord_less @ int @ B2 @ ( modulo_modulo @ int @ A2 @ B2 ) ) ) ) ).

% neg_mod_conj
thf(fact_1133_verit__comp__simplify1_I2_J,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [A2: A] : ( ord_less_eq @ A @ A2 @ A2 ) ) ).

% verit_comp_simplify1(2)
thf(fact_1134_verit__la__disequality,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A] :
          ( ( A2 = B2 )
          | ~ ( ord_less_eq @ A @ A2 @ B2 )
          | ~ ( ord_less_eq @ A @ B2 @ A2 ) ) ) ).

% verit_la_disequality
thf(fact_1135_verit__comp__simplify1_I1_J,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [A2: A] :
          ~ ( ord_less @ A @ A2 @ A2 ) ) ).

% verit_comp_simplify1(1)
thf(fact_1136_verit__la__generic,axiom,
    ! [A2: int,X2: int] :
      ( ( ord_less_eq @ int @ A2 @ X2 )
      | ( A2 = X2 )
      | ( ord_less_eq @ int @ X2 @ A2 ) ) ).

% verit_la_generic
thf(fact_1137_mod__pos__neg__trivial,axiom,
    ! [K: int,L: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ K )
     => ( ( ord_less_eq @ int @ ( plus_plus @ int @ K @ L ) @ ( zero_zero @ int ) )
       => ( ( modulo_modulo @ int @ K @ L )
          = ( plus_plus @ int @ K @ L ) ) ) ) ).

% mod_pos_neg_trivial
thf(fact_1138_VEBT__internal_Omembermima_Osimps_I2_J,axiom,
    ! [Ux2: list @ vEBT_VEBT,Uy2: vEBT_VEBT,Uz2: nat] :
      ~ ( vEBT_VEBT_membermima @ ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( zero_zero @ nat ) @ Ux2 @ Uy2 ) @ Uz2 ) ).

% VEBT_internal.membermima.simps(2)
thf(fact_1139_verit__le__mono__div__int,axiom,
    ! [A3: int,B3: int,N2: int] :
      ( ( ord_less @ int @ A3 @ B3 )
     => ( ( ord_less @ int @ ( zero_zero @ int ) @ N2 )
       => ( ord_less_eq @ int
          @ ( plus_plus @ int @ ( divide_divide @ int @ A3 @ N2 )
            @ ( if @ int
              @ ( ( modulo_modulo @ int @ B3 @ N2 )
                = ( zero_zero @ int ) )
              @ ( one_one @ int )
              @ ( zero_zero @ int ) ) )
          @ ( divide_divide @ int @ B3 @ N2 ) ) ) ) ).

% verit_le_mono_div_int
thf(fact_1140_int__mod__pos__eq,axiom,
    ! [A2: int,B2: int,Q3: int,R3: int] :
      ( ( A2
        = ( plus_plus @ int @ ( times_times @ int @ B2 @ Q3 ) @ R3 ) )
     => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ R3 )
       => ( ( ord_less @ int @ R3 @ B2 )
         => ( ( modulo_modulo @ int @ A2 @ B2 )
            = R3 ) ) ) ) ).

% int_mod_pos_eq
thf(fact_1141_int__mod__neg__eq,axiom,
    ! [A2: int,B2: int,Q3: int,R3: int] :
      ( ( A2
        = ( plus_plus @ int @ ( times_times @ int @ B2 @ Q3 ) @ R3 ) )
     => ( ( ord_less_eq @ int @ R3 @ ( zero_zero @ int ) )
       => ( ( ord_less @ int @ B2 @ R3 )
         => ( ( modulo_modulo @ int @ A2 @ B2 )
            = R3 ) ) ) ) ).

% int_mod_neg_eq
thf(fact_1142_split__zmod,axiom,
    ! [P: int > $o,N2: int,K: int] :
      ( ( P @ ( modulo_modulo @ int @ N2 @ K ) )
      = ( ( ( K
            = ( zero_zero @ int ) )
         => ( P @ N2 ) )
        & ( ( ord_less @ int @ ( zero_zero @ int ) @ K )
         => ! [I4: int,J3: int] :
              ( ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ J3 )
                & ( ord_less @ int @ J3 @ K )
                & ( N2
                  = ( plus_plus @ int @ ( times_times @ int @ K @ I4 ) @ J3 ) ) )
             => ( P @ J3 ) ) )
        & ( ( ord_less @ int @ K @ ( zero_zero @ int ) )
         => ! [I4: int,J3: int] :
              ( ( ( ord_less @ int @ K @ J3 )
                & ( ord_less_eq @ int @ J3 @ ( zero_zero @ int ) )
                & ( N2
                  = ( plus_plus @ int @ ( times_times @ int @ K @ I4 ) @ J3 ) ) )
             => ( P @ J3 ) ) ) ) ) ).

% split_zmod
thf(fact_1143_zmod__zmult2__eq,axiom,
    ! [C2: int,A2: int,B2: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ C2 )
     => ( ( modulo_modulo @ int @ A2 @ ( times_times @ int @ B2 @ C2 ) )
        = ( plus_plus @ int @ ( times_times @ int @ B2 @ ( modulo_modulo @ int @ ( divide_divide @ int @ A2 @ B2 ) @ C2 ) ) @ ( modulo_modulo @ int @ A2 @ B2 ) ) ) ) ).

% zmod_zmult2_eq
thf(fact_1144_VEBT__internal_Omembermima_Osimps_I3_J,axiom,
    ! [Mi: nat,Ma: nat,Va3: list @ vEBT_VEBT,Vb: vEBT_VEBT,X2: nat] :
      ( ( vEBT_VEBT_membermima @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi @ Ma ) ) @ ( zero_zero @ nat ) @ Va3 @ Vb ) @ X2 )
      = ( ( X2 = Mi )
        | ( X2 = Ma ) ) ) ).

% VEBT_internal.membermima.simps(3)
thf(fact_1145_split__neg__lemma,axiom,
    ! [K: int,P: int > int > $o,N2: int] :
      ( ( ord_less @ int @ K @ ( zero_zero @ int ) )
     => ( ( P @ ( divide_divide @ int @ N2 @ K ) @ ( modulo_modulo @ int @ N2 @ K ) )
        = ( ! [I4: int,J3: int] :
              ( ( ( ord_less @ int @ K @ J3 )
                & ( ord_less_eq @ int @ J3 @ ( zero_zero @ int ) )
                & ( N2
                  = ( plus_plus @ int @ ( times_times @ int @ K @ I4 ) @ J3 ) ) )
             => ( P @ I4 @ J3 ) ) ) ) ) ).

% split_neg_lemma
thf(fact_1146_split__pos__lemma,axiom,
    ! [K: int,P: int > int > $o,N2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ K )
     => ( ( P @ ( divide_divide @ int @ N2 @ K ) @ ( modulo_modulo @ int @ N2 @ K ) )
        = ( ! [I4: int,J3: int] :
              ( ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ J3 )
                & ( ord_less @ int @ J3 @ K )
                & ( N2
                  = ( plus_plus @ int @ ( times_times @ int @ K @ I4 ) @ J3 ) ) )
             => ( P @ I4 @ J3 ) ) ) ) ) ).

% split_pos_lemma
thf(fact_1147_verit__comp__simplify1_I3_J,axiom,
    ! [B: $tType] :
      ( ( linorder @ B )
     => ! [B6: B,A6: B] :
          ( ( ~ ( ord_less_eq @ B @ B6 @ A6 ) )
          = ( ord_less @ B @ A6 @ B6 ) ) ) ).

% verit_comp_simplify1(3)
thf(fact_1148_verit__sum__simplify,axiom,
    ! [A: $tType] :
      ( ( cancel1802427076303600483id_add @ A )
     => ! [A2: A] :
          ( ( plus_plus @ A @ A2 @ ( zero_zero @ A ) )
          = A2 ) ) ).

% verit_sum_simplify
thf(fact_1149_verit__eq__simplify_I10_J,axiom,
    ! [X22: num] :
      ( one2
     != ( bit0 @ X22 ) ) ).

% verit_eq_simplify(10)
thf(fact_1150_max_Omono,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [C2: A,A2: A,D2: A,B2: A] :
          ( ( ord_less_eq @ A @ C2 @ A2 )
         => ( ( ord_less_eq @ A @ D2 @ B2 )
           => ( ord_less_eq @ A @ ( ord_max @ A @ C2 @ D2 ) @ ( ord_max @ A @ A2 @ B2 ) ) ) ) ) ).

% max.mono
thf(fact_1151_max_OorderE,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less_eq @ A @ B2 @ A2 )
         => ( A2
            = ( ord_max @ A @ A2 @ B2 ) ) ) ) ).

% max.orderE
thf(fact_1152_max_OorderI,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A] :
          ( ( A2
            = ( ord_max @ A @ A2 @ B2 ) )
         => ( ord_less_eq @ A @ B2 @ A2 ) ) ) ).

% max.orderI
thf(fact_1153_max_OboundedE,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( ord_less_eq @ A @ ( ord_max @ A @ B2 @ C2 ) @ A2 )
         => ~ ( ( ord_less_eq @ A @ B2 @ A2 )
             => ~ ( ord_less_eq @ A @ C2 @ A2 ) ) ) ) ).

% max.boundedE
thf(fact_1154_max_OboundedI,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( ord_less_eq @ A @ B2 @ A2 )
         => ( ( ord_less_eq @ A @ C2 @ A2 )
           => ( ord_less_eq @ A @ ( ord_max @ A @ B2 @ C2 ) @ A2 ) ) ) ) ).

% max.boundedI
thf(fact_1155_max_Oorder__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [B4: A,A4: A] :
              ( A4
              = ( ord_max @ A @ A4 @ B4 ) ) ) ) ) ).

% max.order_iff
thf(fact_1156_max_Ocobounded1,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A] : ( ord_less_eq @ A @ A2 @ ( ord_max @ A @ A2 @ B2 ) ) ) ).

% max.cobounded1
thf(fact_1157_max_Ocobounded2,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [B2: A,A2: A] : ( ord_less_eq @ A @ B2 @ ( ord_max @ A @ A2 @ B2 ) ) ) ).

% max.cobounded2
thf(fact_1158_le__max__iff__disj,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Z: A,X2: A,Y2: A] :
          ( ( ord_less_eq @ A @ Z @ ( ord_max @ A @ X2 @ Y2 ) )
          = ( ( ord_less_eq @ A @ Z @ X2 )
            | ( ord_less_eq @ A @ Z @ Y2 ) ) ) ) ).

% le_max_iff_disj
thf(fact_1159_max_Oabsorb__iff1,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [B4: A,A4: A] :
              ( ( ord_max @ A @ A4 @ B4 )
              = A4 ) ) ) ) ).

% max.absorb_iff1
thf(fact_1160_max_Oabsorb__iff2,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [A4: A,B4: A] :
              ( ( ord_max @ A @ A4 @ B4 )
              = B4 ) ) ) ) ).

% max.absorb_iff2
thf(fact_1161_max_OcoboundedI1,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less_eq @ A @ C2 @ A2 )
         => ( ord_less_eq @ A @ C2 @ ( ord_max @ A @ A2 @ B2 ) ) ) ) ).

% max.coboundedI1
thf(fact_1162_max_OcoboundedI2,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( ord_less_eq @ A @ C2 @ B2 )
         => ( ord_less_eq @ A @ C2 @ ( ord_max @ A @ A2 @ B2 ) ) ) ) ).

% max.coboundedI2
thf(fact_1163_less__max__iff__disj,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Z: A,X2: A,Y2: A] :
          ( ( ord_less @ A @ Z @ ( ord_max @ A @ X2 @ Y2 ) )
          = ( ( ord_less @ A @ Z @ X2 )
            | ( ord_less @ A @ Z @ Y2 ) ) ) ) ).

% less_max_iff_disj
thf(fact_1164_max_Ostrict__boundedE,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( ord_less @ A @ ( ord_max @ A @ B2 @ C2 ) @ A2 )
         => ~ ( ( ord_less @ A @ B2 @ A2 )
             => ~ ( ord_less @ A @ C2 @ A2 ) ) ) ) ).

% max.strict_boundedE
thf(fact_1165_max_Ostrict__order__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( ( ord_less @ A )
        = ( ^ [B4: A,A4: A] :
              ( ( A4
                = ( ord_max @ A @ A4 @ B4 ) )
              & ( A4 != B4 ) ) ) ) ) ).

% max.strict_order_iff
thf(fact_1166_max_Ostrict__coboundedI1,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less @ A @ C2 @ A2 )
         => ( ord_less @ A @ C2 @ ( ord_max @ A @ A2 @ B2 ) ) ) ) ).

% max.strict_coboundedI1
thf(fact_1167_max_Ostrict__coboundedI2,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( ord_less @ A @ C2 @ B2 )
         => ( ord_less @ A @ C2 @ ( ord_max @ A @ A2 @ B2 ) ) ) ) ).

% max.strict_coboundedI2
thf(fact_1168_pos__zmod__mult__2,axiom,
    ! [A2: int,B2: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ A2 )
     => ( ( modulo_modulo @ int @ ( plus_plus @ int @ ( one_one @ int ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ B2 ) ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ A2 ) )
        = ( plus_plus @ int @ ( one_one @ int ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( modulo_modulo @ int @ B2 @ A2 ) ) ) ) ) ).

% pos_zmod_mult_2
thf(fact_1169_div__less__mono,axiom,
    ! [A3: nat,B3: nat,N2: nat] :
      ( ( ord_less @ nat @ A3 @ B3 )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
       => ( ( ( modulo_modulo @ nat @ A3 @ N2 )
            = ( zero_zero @ nat ) )
         => ( ( ( modulo_modulo @ nat @ B3 @ N2 )
              = ( zero_zero @ nat ) )
           => ( ord_less @ nat @ ( divide_divide @ nat @ A3 @ N2 ) @ ( divide_divide @ nat @ B3 @ N2 ) ) ) ) ) ) ).

% div_less_mono
thf(fact_1170_flip__bit__Suc,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N2: nat,A2: A] :
          ( ( bit_se8732182000553998342ip_bit @ A @ ( suc @ N2 ) @ A2 )
          = ( plus_plus @ A @ ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se8732182000553998342ip_bit @ A @ N2 @ ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% flip_bit_Suc
thf(fact_1171_product__nth,axiom,
    ! [A: $tType,B: $tType,N2: nat,Xs: list @ A,Ys: list @ B] :
      ( ( ord_less @ nat @ N2 @ ( times_times @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ ( size_size @ ( list @ B ) @ Ys ) ) )
     => ( ( nth @ ( product_prod @ A @ B ) @ ( product @ A @ B @ Xs @ Ys ) @ N2 )
        = ( product_Pair @ A @ B @ ( nth @ A @ Xs @ ( divide_divide @ nat @ N2 @ ( size_size @ ( list @ B ) @ Ys ) ) ) @ ( nth @ B @ Ys @ ( modulo_modulo @ nat @ N2 @ ( size_size @ ( list @ B ) @ Ys ) ) ) ) ) ) ).

% product_nth
thf(fact_1172_pos__eucl__rel__int__mult__2,axiom,
    ! [B2: int,A2: int,Q3: int,R3: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ B2 )
     => ( ( eucl_rel_int @ A2 @ B2 @ ( product_Pair @ int @ int @ Q3 @ R3 ) )
       => ( eucl_rel_int @ ( plus_plus @ int @ ( one_one @ int ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ A2 ) ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ B2 ) @ ( product_Pair @ int @ int @ Q3 @ ( plus_plus @ int @ ( one_one @ int ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ R3 ) ) ) ) ) ) ).

% pos_eucl_rel_int_mult_2
thf(fact_1173_gcd__nat__induct,axiom,
    ! [P: nat > nat > $o,M: nat,N2: nat] :
      ( ! [M3: nat] : ( P @ M3 @ ( zero_zero @ nat ) )
     => ( ! [M3: nat,N: nat] :
            ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
           => ( ( P @ N @ ( modulo_modulo @ nat @ M3 @ N ) )
             => ( P @ M3 @ N ) ) )
       => ( P @ M @ N2 ) ) ) ).

% gcd_nat_induct
thf(fact_1174_dbl__simps_I3_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( neg_numeral_dbl @ A @ ( one_one @ A ) )
        = ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ).

% dbl_simps(3)
thf(fact_1175_ex__has__greatest__nat__lemma,axiom,
    ! [A: $tType,P: A > $o,K: A,F2: A > nat,N2: nat] :
      ( ( P @ K )
     => ( ! [X3: A] :
            ( ( P @ X3 )
           => ? [Y: A] :
                ( ( P @ Y )
                & ~ ( ord_less_eq @ nat @ ( F2 @ Y ) @ ( F2 @ X3 ) ) ) )
       => ? [Y4: A] :
            ( ( P @ Y4 )
            & ~ ( ord_less @ nat @ ( F2 @ Y4 ) @ ( plus_plus @ nat @ ( F2 @ K ) @ N2 ) ) ) ) ) ).

% ex_has_greatest_nat_lemma
thf(fact_1176_option_Osize__gen_I2_J,axiom,
    ! [A: $tType,X2: A > nat,X22: A] :
      ( ( size_option @ A @ X2 @ ( some @ A @ X22 ) )
      = ( plus_plus @ nat @ ( X2 @ X22 ) @ ( suc @ ( zero_zero @ nat ) ) ) ) ).

% option.size_gen(2)
thf(fact_1177_flip__bit__nonnegative__int__iff,axiom,
    ! [N2: nat,K: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( bit_se8732182000553998342ip_bit @ int @ N2 @ K ) )
      = ( ord_less_eq @ int @ ( zero_zero @ int ) @ K ) ) ).

% flip_bit_nonnegative_int_iff
thf(fact_1178_flip__bit__negative__int__iff,axiom,
    ! [N2: nat,K: int] :
      ( ( ord_less @ int @ ( bit_se8732182000553998342ip_bit @ int @ N2 @ K ) @ ( zero_zero @ int ) )
      = ( ord_less @ int @ K @ ( zero_zero @ int ) ) ) ).

% flip_bit_negative_int_iff
thf(fact_1179_dbl__simps_I2_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( neg_numeral_dbl @ A @ ( zero_zero @ A ) )
        = ( zero_zero @ A ) ) ) ).

% dbl_simps(2)
thf(fact_1180_dbl__simps_I5_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [K: num] :
          ( ( neg_numeral_dbl @ A @ ( numeral_numeral @ A @ K ) )
          = ( numeral_numeral @ A @ ( bit0 @ K ) ) ) ) ).

% dbl_simps(5)
thf(fact_1181_length__product,axiom,
    ! [A: $tType,B: $tType,Xs: list @ A,Ys: list @ B] :
      ( ( size_size @ ( list @ ( product_prod @ A @ B ) ) @ ( product @ A @ B @ Xs @ Ys ) )
      = ( times_times @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ ( size_size @ ( list @ B ) @ Ys ) ) ) ).

% length_product
thf(fact_1182_eucl__rel__int__by0,axiom,
    ! [K: int] : ( eucl_rel_int @ K @ ( zero_zero @ int ) @ ( product_Pair @ int @ int @ ( zero_zero @ int ) @ K ) ) ).

% eucl_rel_int_by0
thf(fact_1183_div__int__unique,axiom,
    ! [K: int,L: int,Q3: int,R3: int] :
      ( ( eucl_rel_int @ K @ L @ ( product_Pair @ int @ int @ Q3 @ R3 ) )
     => ( ( divide_divide @ int @ K @ L )
        = Q3 ) ) ).

% div_int_unique
thf(fact_1184_eucl__rel__int,axiom,
    ! [K: int,L: int] : ( eucl_rel_int @ K @ L @ ( product_Pair @ int @ int @ ( divide_divide @ int @ K @ L ) @ ( modulo_modulo @ int @ K @ L ) ) ) ).

% eucl_rel_int
thf(fact_1185_dbl__def,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( neg_numeral_dbl @ A )
        = ( ^ [X5: A] : ( plus_plus @ A @ X5 @ X5 ) ) ) ) ).

% dbl_def
thf(fact_1186_eucl__rel__int__dividesI,axiom,
    ! [L: int,K: int,Q3: int] :
      ( ( L
       != ( zero_zero @ int ) )
     => ( ( K
          = ( times_times @ int @ Q3 @ L ) )
       => ( eucl_rel_int @ K @ L @ ( product_Pair @ int @ int @ Q3 @ ( zero_zero @ int ) ) ) ) ) ).

% eucl_rel_int_dividesI
thf(fact_1187_ex__has__least__nat,axiom,
    ! [A: $tType,P: A > $o,K: A,M: A > nat] :
      ( ( P @ K )
     => ? [X3: A] :
          ( ( P @ X3 )
          & ! [Y: A] :
              ( ( P @ Y )
             => ( ord_less_eq @ nat @ ( M @ X3 ) @ ( M @ Y ) ) ) ) ) ).

% ex_has_least_nat
thf(fact_1188_bounded__Max__nat,axiom,
    ! [P: nat > $o,X2: nat,M7: nat] :
      ( ( P @ X2 )
     => ( ! [X3: nat] :
            ( ( P @ X3 )
           => ( ord_less_eq @ nat @ X3 @ M7 ) )
       => ~ ! [M3: nat] :
              ( ( P @ M3 )
             => ~ ! [X: nat] :
                    ( ( P @ X )
                   => ( ord_less_eq @ nat @ X @ M3 ) ) ) ) ) ).

% bounded_Max_nat
thf(fact_1189_fold__atLeastAtMost__nat_Ocases,axiom,
    ! [A: $tType,X2: product_prod @ ( nat > A > A ) @ ( product_prod @ nat @ ( product_prod @ nat @ A ) )] :
      ~ ! [F4: nat > A > A,A5: nat,B5: nat,Acc: A] :
          ( X2
         != ( product_Pair @ ( nat > A > A ) @ ( product_prod @ nat @ ( product_prod @ nat @ A ) ) @ F4 @ ( product_Pair @ nat @ ( product_prod @ nat @ A ) @ A5 @ ( product_Pair @ nat @ A @ B5 @ Acc ) ) ) ) ).

% fold_atLeastAtMost_nat.cases
thf(fact_1190_Lattices__Big_Oex__has__greatest__nat,axiom,
    ! [A: $tType,P: A > $o,K: A,F2: A > nat,B2: nat] :
      ( ( P @ K )
     => ( ! [Y4: A] :
            ( ( P @ Y4 )
           => ( ord_less @ nat @ ( F2 @ Y4 ) @ B2 ) )
       => ? [X3: A] :
            ( ( P @ X3 )
            & ! [Y: A] :
                ( ( P @ Y )
               => ( ord_less_eq @ nat @ ( F2 @ Y ) @ ( F2 @ X3 ) ) ) ) ) ) ).

% Lattices_Big.ex_has_greatest_nat
thf(fact_1191_Euclid__induct,axiom,
    ! [P: nat > nat > $o,A2: nat,B2: nat] :
      ( ! [A5: nat,B5: nat] :
          ( ( P @ A5 @ B5 )
          = ( P @ B5 @ A5 ) )
     => ( ! [A5: nat] : ( P @ A5 @ ( zero_zero @ nat ) )
       => ( ! [A5: nat,B5: nat] :
              ( ( P @ A5 @ B5 )
             => ( P @ A5 @ ( plus_plus @ nat @ A5 @ B5 ) ) )
         => ( P @ A2 @ B2 ) ) ) ) ).

% Euclid_induct
thf(fact_1192_eucl__rel__int__iff,axiom,
    ! [K: int,L: int,Q3: int,R3: int] :
      ( ( eucl_rel_int @ K @ L @ ( product_Pair @ int @ int @ Q3 @ R3 ) )
      = ( ( K
          = ( plus_plus @ int @ ( times_times @ int @ L @ Q3 ) @ R3 ) )
        & ( ( ord_less @ int @ ( zero_zero @ int ) @ L )
         => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ R3 )
            & ( ord_less @ int @ R3 @ L ) ) )
        & ( ~ ( ord_less @ int @ ( zero_zero @ int ) @ L )
         => ( ( ( ord_less @ int @ L @ ( zero_zero @ int ) )
             => ( ( ord_less @ int @ L @ R3 )
                & ( ord_less_eq @ int @ R3 @ ( zero_zero @ int ) ) ) )
            & ( ~ ( ord_less @ int @ L @ ( zero_zero @ int ) )
             => ( Q3
                = ( zero_zero @ int ) ) ) ) ) ) ) ).

% eucl_rel_int_iff
thf(fact_1193_option_Osize__gen_I1_J,axiom,
    ! [A: $tType,X2: A > nat] :
      ( ( size_option @ A @ X2 @ ( none @ A ) )
      = ( suc @ ( zero_zero @ nat ) ) ) ).

% option.size_gen(1)
thf(fact_1194_concat__bit__Suc,axiom,
    ! [N2: nat,K: int,L: int] :
      ( ( bit_concat_bit @ ( suc @ N2 ) @ K @ L )
      = ( plus_plus @ int @ ( modulo_modulo @ int @ K @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_concat_bit @ N2 @ ( divide_divide @ int @ K @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ L ) ) ) ) ).

% concat_bit_Suc
thf(fact_1195_neg__eucl__rel__int__mult__2,axiom,
    ! [B2: int,A2: int,Q3: int,R3: int] :
      ( ( ord_less_eq @ int @ B2 @ ( zero_zero @ int ) )
     => ( ( eucl_rel_int @ ( plus_plus @ int @ A2 @ ( one_one @ int ) ) @ B2 @ ( product_Pair @ int @ int @ Q3 @ R3 ) )
       => ( eucl_rel_int @ ( plus_plus @ int @ ( one_one @ int ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ A2 ) ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ B2 ) @ ( product_Pair @ int @ int @ Q3 @ ( minus_minus @ int @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ R3 ) @ ( one_one @ int ) ) ) ) ) ) ).

% neg_eucl_rel_int_mult_2
thf(fact_1196_even__succ__mod__exp,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A,N2: nat] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
         => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
           => ( ( modulo_modulo @ A @ ( plus_plus @ A @ ( one_one @ A ) @ A2 ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N2 ) )
              = ( plus_plus @ A @ ( one_one @ A ) @ ( modulo_modulo @ A @ A2 @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N2 ) ) ) ) ) ) ) ).

% even_succ_mod_exp
thf(fact_1197_even__succ__div__exp,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A,N2: nat] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
         => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
           => ( ( divide_divide @ A @ ( plus_plus @ A @ ( one_one @ A ) @ A2 ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N2 ) )
              = ( divide_divide @ A @ A2 @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N2 ) ) ) ) ) ) ).

% even_succ_div_exp
thf(fact_1198_signed__take__bit__Suc,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N2: nat,A2: A] :
          ( ( bit_ri4674362597316999326ke_bit @ A @ ( suc @ N2 ) @ A2 )
          = ( plus_plus @ A @ ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_ri4674362597316999326ke_bit @ A @ N2 @ ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% signed_take_bit_Suc
thf(fact_1199_vebt__insert_Oelims,axiom,
    ! [X2: vEBT_VEBT,Xa2: nat,Y2: vEBT_VEBT] :
      ( ( ( vEBT_vebt_insert @ X2 @ Xa2 )
        = Y2 )
     => ( ! [A5: $o,B5: $o] :
            ( ( X2
              = ( vEBT_Leaf @ A5 @ B5 ) )
           => ~ ( ( ( Xa2
                    = ( zero_zero @ nat ) )
                 => ( Y2
                    = ( vEBT_Leaf @ $true @ B5 ) ) )
                & ( ( Xa2
                   != ( zero_zero @ nat ) )
                 => ( ( ( Xa2
                        = ( one_one @ nat ) )
                     => ( Y2
                        = ( vEBT_Leaf @ A5 @ $true ) ) )
                    & ( ( Xa2
                       != ( one_one @ nat ) )
                     => ( Y2
                        = ( vEBT_Leaf @ A5 @ B5 ) ) ) ) ) ) )
       => ( ! [Info2: option @ ( product_prod @ nat @ nat ),Ts2: list @ vEBT_VEBT,S: vEBT_VEBT] :
              ( ( X2
                = ( vEBT_Node @ Info2 @ ( zero_zero @ nat ) @ Ts2 @ S ) )
             => ( Y2
               != ( vEBT_Node @ Info2 @ ( zero_zero @ nat ) @ Ts2 @ S ) ) )
         => ( ! [Info2: option @ ( product_prod @ nat @ nat ),Ts2: list @ vEBT_VEBT,S: vEBT_VEBT] :
                ( ( X2
                  = ( vEBT_Node @ Info2 @ ( suc @ ( zero_zero @ nat ) ) @ Ts2 @ S ) )
               => ( Y2
                 != ( vEBT_Node @ Info2 @ ( suc @ ( zero_zero @ nat ) ) @ Ts2 @ S ) ) )
           => ( ! [V3: nat,TreeList2: list @ vEBT_VEBT,Summary2: vEBT_VEBT] :
                  ( ( X2
                    = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ ( suc @ V3 ) ) @ TreeList2 @ Summary2 ) )
                 => ( Y2
                   != ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Xa2 @ Xa2 ) ) @ ( suc @ ( suc @ V3 ) ) @ TreeList2 @ Summary2 ) ) )
             => ~ ! [Mi2: nat,Ma2: nat,Va: nat,TreeList2: list @ vEBT_VEBT,Summary2: vEBT_VEBT] :
                    ( ( X2
                      = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ Ma2 ) ) @ ( suc @ ( suc @ Va ) ) @ TreeList2 @ Summary2 ) )
                   => ( Y2
                     != ( if @ vEBT_VEBT
                        @ ( ( ord_less @ nat @ ( vEBT_VEBT_high @ ( if @ nat @ ( ord_less @ nat @ Xa2 @ Mi2 ) @ Mi2 @ Xa2 ) @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 ) )
                          & ~ ( ( Xa2 = Mi2 )
                              | ( Xa2 = Ma2 ) ) )
                        @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ ( if @ nat @ ( ord_less @ nat @ Xa2 @ Mi2 ) @ Xa2 @ Mi2 ) @ ( ord_max @ nat @ ( if @ nat @ ( ord_less @ nat @ Xa2 @ Mi2 ) @ Mi2 @ Xa2 ) @ Ma2 ) ) ) @ ( suc @ ( suc @ Va ) ) @ ( list_update @ vEBT_VEBT @ TreeList2 @ ( vEBT_VEBT_high @ ( if @ nat @ ( ord_less @ nat @ Xa2 @ Mi2 ) @ Mi2 @ Xa2 ) @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( vEBT_vebt_insert @ ( nth @ vEBT_VEBT @ TreeList2 @ ( vEBT_VEBT_high @ ( if @ nat @ ( ord_less @ nat @ Xa2 @ Mi2 ) @ Mi2 @ Xa2 ) @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ ( if @ nat @ ( ord_less @ nat @ Xa2 @ Mi2 ) @ Mi2 @ Xa2 ) @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) @ ( if @ vEBT_VEBT @ ( vEBT_VEBT_minNull @ ( nth @ vEBT_VEBT @ TreeList2 @ ( vEBT_VEBT_high @ ( if @ nat @ ( ord_less @ nat @ Xa2 @ Mi2 ) @ Mi2 @ Xa2 ) @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) @ ( vEBT_vebt_insert @ Summary2 @ ( vEBT_VEBT_high @ ( if @ nat @ ( ord_less @ nat @ Xa2 @ Mi2 ) @ Mi2 @ Xa2 ) @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ Summary2 ) )
                        @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ Ma2 ) ) @ ( suc @ ( suc @ Va ) ) @ TreeList2 @ Summary2 ) ) ) ) ) ) ) ) ) ).

% vebt_insert.elims
thf(fact_1200_add__scale__eq__noteq,axiom,
    ! [A: $tType] :
      ( ( semiri1453513574482234551roduct @ A )
     => ! [R3: A,A2: A,B2: A,C2: A,D2: A] :
          ( ( R3
           != ( zero_zero @ A ) )
         => ( ( ( A2 = B2 )
              & ( C2 != D2 ) )
           => ( ( plus_plus @ A @ A2 @ ( times_times @ A @ R3 @ C2 ) )
             != ( plus_plus @ A @ B2 @ ( times_times @ A @ R3 @ D2 ) ) ) ) ) ) ).

% add_scale_eq_noteq
thf(fact_1201_num_Osize__gen_I2_J,axiom,
    ! [X22: num] :
      ( ( size_num @ ( bit0 @ X22 ) )
      = ( plus_plus @ nat @ ( size_num @ X22 ) @ ( suc @ ( zero_zero @ nat ) ) ) ) ).

% num.size_gen(2)
thf(fact_1202_power__numeral,axiom,
    ! [A: $tType] :
      ( ( semiring_numeral @ A )
     => ! [K: num,L: num] :
          ( ( power_power @ A @ ( numeral_numeral @ A @ K ) @ ( numeral_numeral @ nat @ L ) )
          = ( numeral_numeral @ A @ ( pow @ K @ L ) ) ) ) ).

% power_numeral
thf(fact_1203_set__vebt_H__def,axiom,
    ( vEBT_VEBT_set_vebt
    = ( ^ [T3: vEBT_VEBT] : ( collect @ nat @ ( vEBT_vebt_member @ T3 ) ) ) ) ).

% set_vebt'_def
thf(fact_1204_nat__dvd__1__iff__1,axiom,
    ! [M: nat] :
      ( ( dvd_dvd @ nat @ M @ ( one_one @ nat ) )
      = ( M
        = ( one_one @ nat ) ) ) ).

% nat_dvd_1_iff_1
thf(fact_1205_diff__self,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A] :
          ( ( minus_minus @ A @ A2 @ A2 )
          = ( zero_zero @ A ) ) ) ).

% diff_self
thf(fact_1206_diff__0__right,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A] :
          ( ( minus_minus @ A @ A2 @ ( zero_zero @ A ) )
          = A2 ) ) ).

% diff_0_right
thf(fact_1207_zero__diff,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_diff @ A )
     => ! [A2: A] :
          ( ( minus_minus @ A @ ( zero_zero @ A ) @ A2 )
          = ( zero_zero @ A ) ) ) ).

% zero_diff
thf(fact_1208_diff__zero,axiom,
    ! [A: $tType] :
      ( ( cancel1802427076303600483id_add @ A )
     => ! [A2: A] :
          ( ( minus_minus @ A @ A2 @ ( zero_zero @ A ) )
          = A2 ) ) ).

% diff_zero
thf(fact_1209_cancel__comm__monoid__add__class_Odiff__cancel,axiom,
    ! [A: $tType] :
      ( ( cancel1802427076303600483id_add @ A )
     => ! [A2: A] :
          ( ( minus_minus @ A @ A2 @ A2 )
          = ( zero_zero @ A ) ) ) ).

% cancel_comm_monoid_add_class.diff_cancel
thf(fact_1210_add__diff__cancel,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( minus_minus @ A @ ( plus_plus @ A @ A2 @ B2 ) @ B2 )
          = A2 ) ) ).

% add_diff_cancel
thf(fact_1211_diff__add__cancel,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( plus_plus @ A @ ( minus_minus @ A @ A2 @ B2 ) @ B2 )
          = A2 ) ) ).

% diff_add_cancel
thf(fact_1212_add__diff__cancel__left,axiom,
    ! [A: $tType] :
      ( ( cancel2418104881723323429up_add @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( minus_minus @ A @ ( plus_plus @ A @ C2 @ A2 ) @ ( plus_plus @ A @ C2 @ B2 ) )
          = ( minus_minus @ A @ A2 @ B2 ) ) ) ).

% add_diff_cancel_left
thf(fact_1213_add__diff__cancel__left_H,axiom,
    ! [A: $tType] :
      ( ( cancel2418104881723323429up_add @ A )
     => ! [A2: A,B2: A] :
          ( ( minus_minus @ A @ ( plus_plus @ A @ A2 @ B2 ) @ A2 )
          = B2 ) ) ).

% add_diff_cancel_left'
thf(fact_1214_add__diff__cancel__right,axiom,
    ! [A: $tType] :
      ( ( cancel2418104881723323429up_add @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( minus_minus @ A @ ( plus_plus @ A @ A2 @ C2 ) @ ( plus_plus @ A @ B2 @ C2 ) )
          = ( minus_minus @ A @ A2 @ B2 ) ) ) ).

% add_diff_cancel_right
thf(fact_1215_add__diff__cancel__right_H,axiom,
    ! [A: $tType] :
      ( ( cancel2418104881723323429up_add @ A )
     => ! [A2: A,B2: A] :
          ( ( minus_minus @ A @ ( plus_plus @ A @ A2 @ B2 ) @ B2 )
          = A2 ) ) ).

% add_diff_cancel_right'
thf(fact_1216_dvd__0__right,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [A2: A] : ( dvd_dvd @ A @ A2 @ ( zero_zero @ A ) ) ) ).

% dvd_0_right
thf(fact_1217_dvd__0__left__iff,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [A2: A] :
          ( ( dvd_dvd @ A @ ( zero_zero @ A ) @ A2 )
          = ( A2
            = ( zero_zero @ A ) ) ) ) ).

% dvd_0_left_iff
thf(fact_1218_dvd__add__triv__left__iff,axiom,
    ! [A: $tType] :
      ( ( comm_s4317794764714335236cancel @ A )
     => ! [A2: A,B2: A] :
          ( ( dvd_dvd @ A @ A2 @ ( plus_plus @ A @ A2 @ B2 ) )
          = ( dvd_dvd @ A @ A2 @ B2 ) ) ) ).

% dvd_add_triv_left_iff
thf(fact_1219_dvd__add__triv__right__iff,axiom,
    ! [A: $tType] :
      ( ( comm_s4317794764714335236cancel @ A )
     => ! [A2: A,B2: A] :
          ( ( dvd_dvd @ A @ A2 @ ( plus_plus @ A @ B2 @ A2 ) )
          = ( dvd_dvd @ A @ A2 @ B2 ) ) ) ).

% dvd_add_triv_right_iff
thf(fact_1220_dvd__1__left,axiom,
    ! [K: nat] : ( dvd_dvd @ nat @ ( suc @ ( zero_zero @ nat ) ) @ K ) ).

% dvd_1_left
thf(fact_1221_dvd__1__iff__1,axiom,
    ! [M: nat] :
      ( ( dvd_dvd @ nat @ M @ ( suc @ ( zero_zero @ nat ) ) )
      = ( M
        = ( suc @ ( zero_zero @ nat ) ) ) ) ).

% dvd_1_iff_1
thf(fact_1222_div__dvd__div,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( dvd_dvd @ A @ A2 @ B2 )
         => ( ( dvd_dvd @ A @ A2 @ C2 )
           => ( ( dvd_dvd @ A @ ( divide_divide @ A @ B2 @ A2 ) @ ( divide_divide @ A @ C2 @ A2 ) )
              = ( dvd_dvd @ A @ B2 @ C2 ) ) ) ) ) ).

% div_dvd_div
thf(fact_1223_minus__mod__self2,axiom,
    ! [A: $tType] :
      ( ( euclid8851590272496341667cancel @ A )
     => ! [A2: A,B2: A] :
          ( ( modulo_modulo @ A @ ( minus_minus @ A @ A2 @ B2 ) @ B2 )
          = ( modulo_modulo @ A @ A2 @ B2 ) ) ) ).

% minus_mod_self2
thf(fact_1224_nat__mult__dvd__cancel__disj,axiom,
    ! [K: nat,M: nat,N2: nat] :
      ( ( dvd_dvd @ nat @ ( times_times @ nat @ K @ M ) @ ( times_times @ nat @ K @ N2 ) )
      = ( ( K
          = ( zero_zero @ nat ) )
        | ( dvd_dvd @ nat @ M @ N2 ) ) ) ).

% nat_mult_dvd_cancel_disj
thf(fact_1225_signed__take__bit__of__0,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N2: nat] :
          ( ( bit_ri4674362597316999326ke_bit @ A @ N2 @ ( zero_zero @ A ) )
          = ( zero_zero @ A ) ) ) ).

% signed_take_bit_of_0
thf(fact_1226_concat__bit__0,axiom,
    ! [K: int,L: int] :
      ( ( bit_concat_bit @ ( zero_zero @ nat ) @ K @ L )
      = L ) ).

% concat_bit_0
thf(fact_1227_diff__ge__0__iff__ge,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( minus_minus @ A @ A2 @ B2 ) )
          = ( ord_less_eq @ A @ B2 @ A2 ) ) ) ).

% diff_ge_0_iff_ge
thf(fact_1228_diff__gt__0__iff__gt,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( minus_minus @ A @ A2 @ B2 ) )
          = ( ord_less @ A @ B2 @ A2 ) ) ) ).

% diff_gt_0_iff_gt
thf(fact_1229_le__add__diff__inverse,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less_eq @ A @ B2 @ A2 )
         => ( ( plus_plus @ A @ B2 @ ( minus_minus @ A @ A2 @ B2 ) )
            = A2 ) ) ) ).

% le_add_diff_inverse
thf(fact_1230_le__add__diff__inverse2,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less_eq @ A @ B2 @ A2 )
         => ( ( plus_plus @ A @ ( minus_minus @ A @ A2 @ B2 ) @ B2 )
            = A2 ) ) ) ).

% le_add_diff_inverse2
thf(fact_1231_diff__numeral__special_I9_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( minus_minus @ A @ ( one_one @ A ) @ ( one_one @ A ) )
        = ( zero_zero @ A ) ) ) ).

% diff_numeral_special(9)
thf(fact_1232_diff__add__zero,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_diff @ A )
     => ! [A2: A,B2: A] :
          ( ( minus_minus @ A @ A2 @ ( plus_plus @ A @ A2 @ B2 ) )
          = ( zero_zero @ A ) ) ) ).

% diff_add_zero
thf(fact_1233_right__diff__distrib__numeral,axiom,
    ! [A: $tType] :
      ( ( ( numeral @ A )
        & ( ring @ A ) )
     => ! [V: num,B2: A,C2: A] :
          ( ( times_times @ A @ ( numeral_numeral @ A @ V ) @ ( minus_minus @ A @ B2 @ C2 ) )
          = ( minus_minus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ V ) @ B2 ) @ ( times_times @ A @ ( numeral_numeral @ A @ V ) @ C2 ) ) ) ) ).

% right_diff_distrib_numeral
thf(fact_1234_left__diff__distrib__numeral,axiom,
    ! [A: $tType] :
      ( ( ( numeral @ A )
        & ( ring @ A ) )
     => ! [A2: A,B2: A,V: num] :
          ( ( times_times @ A @ ( minus_minus @ A @ A2 @ B2 ) @ ( numeral_numeral @ A @ V ) )
          = ( minus_minus @ A @ ( times_times @ A @ A2 @ ( numeral_numeral @ A @ V ) ) @ ( times_times @ A @ B2 @ ( numeral_numeral @ A @ V ) ) ) ) ) ).

% left_diff_distrib_numeral
thf(fact_1235_dvd__mult__cancel__left,axiom,
    ! [A: $tType] :
      ( ( idom @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( dvd_dvd @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) )
          = ( ( C2
              = ( zero_zero @ A ) )
            | ( dvd_dvd @ A @ A2 @ B2 ) ) ) ) ).

% dvd_mult_cancel_left
thf(fact_1236_dvd__mult__cancel__right,axiom,
    ! [A: $tType] :
      ( ( idom @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( dvd_dvd @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) )
          = ( ( C2
              = ( zero_zero @ A ) )
            | ( dvd_dvd @ A @ A2 @ B2 ) ) ) ) ).

% dvd_mult_cancel_right
thf(fact_1237_dvd__times__left__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( dvd_dvd @ A @ ( times_times @ A @ A2 @ B2 ) @ ( times_times @ A @ A2 @ C2 ) )
            = ( dvd_dvd @ A @ B2 @ C2 ) ) ) ) ).

% dvd_times_left_cancel_iff
thf(fact_1238_dvd__times__right__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( dvd_dvd @ A @ ( times_times @ A @ B2 @ A2 ) @ ( times_times @ A @ C2 @ A2 ) )
            = ( dvd_dvd @ A @ B2 @ C2 ) ) ) ) ).

% dvd_times_right_cancel_iff
thf(fact_1239_unit__prod,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,B2: A] :
          ( ( dvd_dvd @ A @ A2 @ ( one_one @ A ) )
         => ( ( dvd_dvd @ A @ B2 @ ( one_one @ A ) )
           => ( dvd_dvd @ A @ ( times_times @ A @ A2 @ B2 ) @ ( one_one @ A ) ) ) ) ) ).

% unit_prod
thf(fact_1240_dvd__add__times__triv__right__iff,axiom,
    ! [A: $tType] :
      ( ( comm_s4317794764714335236cancel @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( dvd_dvd @ A @ A2 @ ( plus_plus @ A @ B2 @ ( times_times @ A @ C2 @ A2 ) ) )
          = ( dvd_dvd @ A @ A2 @ B2 ) ) ) ).

% dvd_add_times_triv_right_iff
thf(fact_1241_dvd__add__times__triv__left__iff,axiom,
    ! [A: $tType] :
      ( ( comm_s4317794764714335236cancel @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( dvd_dvd @ A @ A2 @ ( plus_plus @ A @ ( times_times @ A @ C2 @ A2 ) @ B2 ) )
          = ( dvd_dvd @ A @ A2 @ B2 ) ) ) ).

% dvd_add_times_triv_left_iff
thf(fact_1242_dvd__div__mult__self,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,B2: A] :
          ( ( dvd_dvd @ A @ A2 @ B2 )
         => ( ( times_times @ A @ ( divide_divide @ A @ B2 @ A2 ) @ A2 )
            = B2 ) ) ) ).

% dvd_div_mult_self
thf(fact_1243_dvd__mult__div__cancel,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,B2: A] :
          ( ( dvd_dvd @ A @ A2 @ B2 )
         => ( ( times_times @ A @ A2 @ ( divide_divide @ A @ B2 @ A2 ) )
            = B2 ) ) ) ).

% dvd_mult_div_cancel
thf(fact_1244_unit__div,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,B2: A] :
          ( ( dvd_dvd @ A @ A2 @ ( one_one @ A ) )
         => ( ( dvd_dvd @ A @ B2 @ ( one_one @ A ) )
           => ( dvd_dvd @ A @ ( divide_divide @ A @ A2 @ B2 ) @ ( one_one @ A ) ) ) ) ) ).

% unit_div
thf(fact_1245_unit__div__1__unit,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A] :
          ( ( dvd_dvd @ A @ A2 @ ( one_one @ A ) )
         => ( dvd_dvd @ A @ ( divide_divide @ A @ ( one_one @ A ) @ A2 ) @ ( one_one @ A ) ) ) ) ).

% unit_div_1_unit
thf(fact_1246_unit__div__1__div__1,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A] :
          ( ( dvd_dvd @ A @ A2 @ ( one_one @ A ) )
         => ( ( divide_divide @ A @ ( one_one @ A ) @ ( divide_divide @ A @ ( one_one @ A ) @ A2 ) )
            = A2 ) ) ) ).

% unit_div_1_div_1
thf(fact_1247_div__add,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( dvd_dvd @ A @ C2 @ A2 )
         => ( ( dvd_dvd @ A @ C2 @ B2 )
           => ( ( divide_divide @ A @ ( plus_plus @ A @ A2 @ B2 ) @ C2 )
              = ( plus_plus @ A @ ( divide_divide @ A @ A2 @ C2 ) @ ( divide_divide @ A @ B2 @ C2 ) ) ) ) ) ) ).

% div_add
thf(fact_1248_div__diff,axiom,
    ! [A: $tType] :
      ( ( idom_modulo @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( dvd_dvd @ A @ C2 @ A2 )
         => ( ( dvd_dvd @ A @ C2 @ B2 )
           => ( ( divide_divide @ A @ ( minus_minus @ A @ A2 @ B2 ) @ C2 )
              = ( minus_minus @ A @ ( divide_divide @ A @ A2 @ C2 ) @ ( divide_divide @ A @ B2 @ C2 ) ) ) ) ) ) ).

% div_diff
thf(fact_1249_dvd__imp__mod__0,axiom,
    ! [A: $tType] :
      ( ( semidom_modulo @ A )
     => ! [A2: A,B2: A] :
          ( ( dvd_dvd @ A @ A2 @ B2 )
         => ( ( modulo_modulo @ A @ B2 @ A2 )
            = ( zero_zero @ A ) ) ) ) ).

% dvd_imp_mod_0
thf(fact_1250_signed__take__bit__Suc__1,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N2: nat] :
          ( ( bit_ri4674362597316999326ke_bit @ A @ ( suc @ N2 ) @ ( one_one @ A ) )
          = ( one_one @ A ) ) ) ).

% signed_take_bit_Suc_1
thf(fact_1251_signed__take__bit__numeral__of__1,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [K: num] :
          ( ( bit_ri4674362597316999326ke_bit @ A @ ( numeral_numeral @ nat @ K ) @ ( one_one @ A ) )
          = ( one_one @ A ) ) ) ).

% signed_take_bit_numeral_of_1
thf(fact_1252_concat__bit__nonnegative__iff,axiom,
    ! [N2: nat,K: int,L: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( bit_concat_bit @ N2 @ K @ L ) )
      = ( ord_less_eq @ int @ ( zero_zero @ int ) @ L ) ) ).

% concat_bit_nonnegative_iff
thf(fact_1253_concat__bit__negative__iff,axiom,
    ! [N2: nat,K: int,L: int] :
      ( ( ord_less @ int @ ( bit_concat_bit @ N2 @ K @ L ) @ ( zero_zero @ int ) )
      = ( ord_less @ int @ L @ ( zero_zero @ int ) ) ) ).

% concat_bit_negative_iff
thf(fact_1254_unit__mult__div__div,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,B2: A] :
          ( ( dvd_dvd @ A @ A2 @ ( one_one @ A ) )
         => ( ( times_times @ A @ B2 @ ( divide_divide @ A @ ( one_one @ A ) @ A2 ) )
            = ( divide_divide @ A @ B2 @ A2 ) ) ) ) ).

% unit_mult_div_div
thf(fact_1255_unit__div__mult__self,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,B2: A] :
          ( ( dvd_dvd @ A @ A2 @ ( one_one @ A ) )
         => ( ( times_times @ A @ ( divide_divide @ A @ B2 @ A2 ) @ A2 )
            = B2 ) ) ) ).

% unit_div_mult_self
thf(fact_1256_even__Suc,axiom,
    ! [N2: nat] :
      ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( suc @ N2 ) )
      = ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) ) ).

% even_Suc
thf(fact_1257_even__Suc__Suc__iff,axiom,
    ! [N2: nat] :
      ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( suc @ ( suc @ N2 ) ) )
      = ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) ).

% even_Suc_Suc_iff
thf(fact_1258_pow__divides__pow__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [N2: nat,A2: A,B2: A] :
          ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
         => ( ( dvd_dvd @ A @ ( power_power @ A @ A2 @ N2 ) @ ( power_power @ A @ B2 @ N2 ) )
            = ( dvd_dvd @ A @ A2 @ B2 ) ) ) ) ).

% pow_divides_pow_iff
thf(fact_1259_zle__diff1__eq,axiom,
    ! [W: int,Z: int] :
      ( ( ord_less_eq @ int @ W @ ( minus_minus @ int @ Z @ ( one_one @ int ) ) )
      = ( ord_less @ int @ W @ Z ) ) ).

% zle_diff1_eq
thf(fact_1260_even__mult__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [A2: A,B2: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( times_times @ A @ A2 @ B2 ) )
          = ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
            | ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B2 ) ) ) ) ).

% even_mult_iff
thf(fact_1261_odd__add,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [A2: A,B2: A] :
          ( ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( plus_plus @ A @ A2 @ B2 ) ) )
          = ( ( ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) )
             != ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B2 ) ) ) ) ) ) ).

% odd_add
thf(fact_1262_even__add,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [A2: A,B2: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( plus_plus @ A @ A2 @ B2 ) )
          = ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
            = ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B2 ) ) ) ) ).

% even_add
thf(fact_1263_even__mod__2__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [A2: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) )
          = ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) ) ) ).

% even_mod_2_iff
thf(fact_1264_odd__Suc__div__two,axiom,
    ! [N2: nat] :
      ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 )
     => ( ( divide_divide @ nat @ ( suc @ N2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
        = ( suc @ ( divide_divide @ nat @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% odd_Suc_div_two
thf(fact_1265_even__Suc__div__two,axiom,
    ! [N2: nat] :
      ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 )
     => ( ( divide_divide @ nat @ ( suc @ N2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
        = ( divide_divide @ nat @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ).

% even_Suc_div_two
thf(fact_1266_signed__take__bit__Suc__bit0,axiom,
    ! [N2: nat,K: num] :
      ( ( bit_ri4674362597316999326ke_bit @ int @ ( suc @ N2 ) @ ( numeral_numeral @ int @ ( bit0 @ K ) ) )
      = ( times_times @ int @ ( bit_ri4674362597316999326ke_bit @ int @ N2 @ ( numeral_numeral @ int @ K ) ) @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ).

% signed_take_bit_Suc_bit0
thf(fact_1267_zero__le__power__eq__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A,W: num] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ W ) ) )
          = ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( numeral_numeral @ nat @ W ) )
            | ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( numeral_numeral @ nat @ W ) )
              & ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 ) ) ) ) ) ).

% zero_le_power_eq_numeral
thf(fact_1268_power__less__zero__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A,N2: nat] :
          ( ( ord_less @ A @ ( power_power @ A @ A2 @ N2 ) @ ( zero_zero @ A ) )
          = ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 )
            & ( ord_less @ A @ A2 @ ( zero_zero @ A ) ) ) ) ) ).

% power_less_zero_eq
thf(fact_1269_power__less__zero__eq__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A,W: num] :
          ( ( ord_less @ A @ ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ W ) ) @ ( zero_zero @ A ) )
          = ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( numeral_numeral @ nat @ W ) )
            & ( ord_less @ A @ A2 @ ( zero_zero @ A ) ) ) ) ) ).

% power_less_zero_eq_numeral
thf(fact_1270_even__plus__one__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [A2: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( plus_plus @ A @ A2 @ ( one_one @ A ) ) )
          = ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) ) ) ) ).

% even_plus_one_iff
thf(fact_1271_even__diff,axiom,
    ! [A: $tType] :
      ( ( ring_parity @ A )
     => ! [A2: A,B2: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( minus_minus @ A @ A2 @ B2 ) )
          = ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( plus_plus @ A @ A2 @ B2 ) ) ) ) ).

% even_diff
thf(fact_1272_zero__less__power__eq__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A,W: num] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ W ) ) )
          = ( ( ( numeral_numeral @ nat @ W )
              = ( zero_zero @ nat ) )
            | ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( numeral_numeral @ nat @ W ) )
              & ( A2
               != ( zero_zero @ A ) ) )
            | ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( numeral_numeral @ nat @ W ) )
              & ( ord_less @ A @ ( zero_zero @ A ) @ A2 ) ) ) ) ) ).

% zero_less_power_eq_numeral
thf(fact_1273_odd__succ__div__two,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [A2: A] :
          ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
         => ( ( divide_divide @ A @ ( plus_plus @ A @ A2 @ ( one_one @ A ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
            = ( plus_plus @ A @ ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( one_one @ A ) ) ) ) ) ).

% odd_succ_div_two
thf(fact_1274_even__succ__div__two,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [A2: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
         => ( ( divide_divide @ A @ ( plus_plus @ A @ A2 @ ( one_one @ A ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
            = ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ).

% even_succ_div_two
thf(fact_1275_even__succ__div__2,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
         => ( ( divide_divide @ A @ ( plus_plus @ A @ ( one_one @ A ) @ A2 ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
            = ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ).

% even_succ_div_2
thf(fact_1276_even__power,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [A2: A,N2: nat] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( power_power @ A @ A2 @ N2 ) )
          = ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
            & ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 ) ) ) ) ).

% even_power
thf(fact_1277_odd__two__times__div__two__succ,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [A2: A] :
          ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
         => ( ( plus_plus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) @ ( one_one @ A ) )
            = A2 ) ) ) ).

% odd_two_times_div_two_succ
thf(fact_1278_power__le__zero__eq__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A,W: num] :
          ( ( ord_less_eq @ A @ ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ W ) ) @ ( zero_zero @ A ) )
          = ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( numeral_numeral @ nat @ W ) )
            & ( ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( numeral_numeral @ nat @ W ) )
                & ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) ) )
              | ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( numeral_numeral @ nat @ W ) )
                & ( A2
                  = ( zero_zero @ A ) ) ) ) ) ) ) ).

% power_le_zero_eq_numeral
thf(fact_1279_semiring__parity__class_Oeven__mask__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [N2: nat] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( minus_minus @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N2 ) @ ( one_one @ A ) ) )
          = ( N2
            = ( zero_zero @ nat ) ) ) ) ).

% semiring_parity_class.even_mask_iff
thf(fact_1280_dvd__minus__mod,axiom,
    ! [A: $tType] :
      ( ( semidom_modulo @ A )
     => ! [B2: A,A2: A] : ( dvd_dvd @ A @ B2 @ ( minus_minus @ A @ A2 @ ( modulo_modulo @ A @ A2 @ B2 ) ) ) ) ).

% dvd_minus_mod
thf(fact_1281_mod__eq__dvd__iff,axiom,
    ! [A: $tType] :
      ( ( euclid8851590272496341667cancel @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ( modulo_modulo @ A @ A2 @ C2 )
            = ( modulo_modulo @ A @ B2 @ C2 ) )
          = ( dvd_dvd @ A @ C2 @ ( minus_minus @ A @ A2 @ B2 ) ) ) ) ).

% mod_eq_dvd_iff
thf(fact_1282_signed__take__bit__diff,axiom,
    ! [N2: nat,K: int,L: int] :
      ( ( bit_ri4674362597316999326ke_bit @ int @ N2 @ ( minus_minus @ int @ ( bit_ri4674362597316999326ke_bit @ int @ N2 @ K ) @ ( bit_ri4674362597316999326ke_bit @ int @ N2 @ L ) ) )
      = ( bit_ri4674362597316999326ke_bit @ int @ N2 @ ( minus_minus @ int @ K @ L ) ) ) ).

% signed_take_bit_diff
thf(fact_1283_dvd__diff__commute,axiom,
    ! [A: $tType] :
      ( ( euclid5891614535332579305n_ring @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( dvd_dvd @ A @ A2 @ ( minus_minus @ A @ C2 @ B2 ) )
          = ( dvd_dvd @ A @ A2 @ ( minus_minus @ A @ B2 @ C2 ) ) ) ) ).

% dvd_diff_commute
thf(fact_1284_diff__right__commute,axiom,
    ! [A: $tType] :
      ( ( cancel2418104881723323429up_add @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( minus_minus @ A @ ( minus_minus @ A @ A2 @ C2 ) @ B2 )
          = ( minus_minus @ A @ ( minus_minus @ A @ A2 @ B2 ) @ C2 ) ) ) ).

% diff_right_commute
thf(fact_1285_diff__eq__diff__eq,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ( minus_minus @ A @ A2 @ B2 )
            = ( minus_minus @ A @ C2 @ D2 ) )
         => ( ( A2 = B2 )
            = ( C2 = D2 ) ) ) ) ).

% diff_eq_diff_eq
thf(fact_1286_dvd__trans,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( dvd_dvd @ A @ A2 @ B2 )
         => ( ( dvd_dvd @ A @ B2 @ C2 )
           => ( dvd_dvd @ A @ A2 @ C2 ) ) ) ) ).

% dvd_trans
thf(fact_1287_dvd__refl,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A2: A] : ( dvd_dvd @ A @ A2 @ A2 ) ) ).

% dvd_refl
thf(fact_1288_dvd__diff,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [X2: A,Y2: A,Z: A] :
          ( ( dvd_dvd @ A @ X2 @ Y2 )
         => ( ( dvd_dvd @ A @ X2 @ Z )
           => ( dvd_dvd @ A @ X2 @ ( minus_minus @ A @ Y2 @ Z ) ) ) ) ) ).

% dvd_diff
thf(fact_1289_strict__subset__divisors__dvd,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ ( set @ A )
            @ ( collect @ A
              @ ^ [C4: A] : ( dvd_dvd @ A @ C4 @ A2 ) )
            @ ( collect @ A
              @ ^ [C4: A] : ( dvd_dvd @ A @ C4 @ B2 ) ) )
          = ( ( dvd_dvd @ A @ A2 @ B2 )
            & ~ ( dvd_dvd @ A @ B2 @ A2 ) ) ) ) ).

% strict_subset_divisors_dvd
thf(fact_1290_subset__divisors__dvd,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ ( set @ A )
            @ ( collect @ A
              @ ^ [C4: A] : ( dvd_dvd @ A @ C4 @ A2 ) )
            @ ( collect @ A
              @ ^ [C4: A] : ( dvd_dvd @ A @ C4 @ B2 ) ) )
          = ( dvd_dvd @ A @ A2 @ B2 ) ) ) ).

% subset_divisors_dvd
thf(fact_1291_lambda__zero,axiom,
    ! [A: $tType] :
      ( ( mult_zero @ A )
     => ( ( ^ [H: A] : ( zero_zero @ A ) )
        = ( times_times @ A @ ( zero_zero @ A ) ) ) ) ).

% lambda_zero
thf(fact_1292_lambda__one,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ( ( ^ [X5: A] : X5 )
        = ( times_times @ A @ ( one_one @ A ) ) ) ) ).

% lambda_one
thf(fact_1293_max__def__raw,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ( ( ord_max @ A )
        = ( ^ [A4: A,B4: A] : ( if @ A @ ( ord_less_eq @ A @ A4 @ B4 ) @ B4 @ A4 ) ) ) ) ).

% max_def_raw
thf(fact_1294_inf__period_I3_J,axiom,
    ! [A: $tType] :
      ( ( ( comm_ring @ A )
        & ( dvd @ A ) )
     => ! [D2: A,D5: A,T2: A] :
          ( ( dvd_dvd @ A @ D2 @ D5 )
         => ! [X: A,K4: A] :
              ( ( dvd_dvd @ A @ D2 @ ( plus_plus @ A @ X @ T2 ) )
              = ( dvd_dvd @ A @ D2 @ ( plus_plus @ A @ ( minus_minus @ A @ X @ ( times_times @ A @ K4 @ D5 ) ) @ T2 ) ) ) ) ) ).

% inf_period(3)
thf(fact_1295_inf__period_I4_J,axiom,
    ! [A: $tType] :
      ( ( ( comm_ring @ A )
        & ( dvd @ A ) )
     => ! [D2: A,D5: A,T2: A] :
          ( ( dvd_dvd @ A @ D2 @ D5 )
         => ! [X: A,K4: A] :
              ( ( ~ ( dvd_dvd @ A @ D2 @ ( plus_plus @ A @ X @ T2 ) ) )
              = ( ~ ( dvd_dvd @ A @ D2 @ ( plus_plus @ A @ ( minus_minus @ A @ X @ ( times_times @ A @ K4 @ D5 ) ) @ T2 ) ) ) ) ) ) ).

% inf_period(4)
thf(fact_1296_dvd__0__left,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [A2: A] :
          ( ( dvd_dvd @ A @ ( zero_zero @ A ) @ A2 )
         => ( A2
            = ( zero_zero @ A ) ) ) ) ).

% dvd_0_left
thf(fact_1297_dvd__field__iff,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ( ( dvd_dvd @ A )
        = ( ^ [A4: A,B4: A] :
              ( ( A4
                = ( zero_zero @ A ) )
             => ( B4
                = ( zero_zero @ A ) ) ) ) ) ) ).

% dvd_field_iff
thf(fact_1298_diff__mono,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A,B2: A,D2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ D2 @ C2 )
           => ( ord_less_eq @ A @ ( minus_minus @ A @ A2 @ C2 ) @ ( minus_minus @ A @ B2 @ D2 ) ) ) ) ) ).

% diff_mono
thf(fact_1299_diff__left__mono,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( ord_less_eq @ A @ B2 @ A2 )
         => ( ord_less_eq @ A @ ( minus_minus @ A @ C2 @ A2 ) @ ( minus_minus @ A @ C2 @ B2 ) ) ) ) ).

% diff_left_mono
thf(fact_1300_diff__right__mono,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ord_less_eq @ A @ ( minus_minus @ A @ A2 @ C2 ) @ ( minus_minus @ A @ B2 @ C2 ) ) ) ) ).

% diff_right_mono
thf(fact_1301_diff__eq__diff__less__eq,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ( minus_minus @ A @ A2 @ B2 )
            = ( minus_minus @ A @ C2 @ D2 ) )
         => ( ( ord_less_eq @ A @ A2 @ B2 )
            = ( ord_less_eq @ A @ C2 @ D2 ) ) ) ) ).

% diff_eq_diff_less_eq
thf(fact_1302_eq__iff__diff__eq__0,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ( ( ^ [Y3: A,Z2: A] : ( Y3 = Z2 ) )
        = ( ^ [A4: A,B4: A] :
              ( ( minus_minus @ A @ A4 @ B4 )
              = ( zero_zero @ A ) ) ) ) ) ).

% eq_iff_diff_eq_0
thf(fact_1303_dvdE,axiom,
    ! [A: $tType] :
      ( ( dvd @ A )
     => ! [B2: A,A2: A] :
          ( ( dvd_dvd @ A @ B2 @ A2 )
         => ~ ! [K2: A] :
                ( A2
               != ( times_times @ A @ B2 @ K2 ) ) ) ) ).

% dvdE
thf(fact_1304_dvdI,axiom,
    ! [A: $tType] :
      ( ( dvd @ A )
     => ! [A2: A,B2: A,K: A] :
          ( ( A2
            = ( times_times @ A @ B2 @ K ) )
         => ( dvd_dvd @ A @ B2 @ A2 ) ) ) ).

% dvdI
thf(fact_1305_dvd__def,axiom,
    ! [A: $tType] :
      ( ( dvd @ A )
     => ( ( dvd_dvd @ A )
        = ( ^ [B4: A,A4: A] :
            ? [K3: A] :
              ( A4
              = ( times_times @ A @ B4 @ K3 ) ) ) ) ) ).

% dvd_def
thf(fact_1306_dvd__mult,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( dvd_dvd @ A @ A2 @ C2 )
         => ( dvd_dvd @ A @ A2 @ ( times_times @ A @ B2 @ C2 ) ) ) ) ).

% dvd_mult
thf(fact_1307_dvd__mult2,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( dvd_dvd @ A @ A2 @ B2 )
         => ( dvd_dvd @ A @ A2 @ ( times_times @ A @ B2 @ C2 ) ) ) ) ).

% dvd_mult2
thf(fact_1308_dvd__mult__left,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( dvd_dvd @ A @ ( times_times @ A @ A2 @ B2 ) @ C2 )
         => ( dvd_dvd @ A @ A2 @ C2 ) ) ) ).

% dvd_mult_left
thf(fact_1309_dvd__triv__left,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A2: A,B2: A] : ( dvd_dvd @ A @ A2 @ ( times_times @ A @ A2 @ B2 ) ) ) ).

% dvd_triv_left
thf(fact_1310_mult__dvd__mono,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( dvd_dvd @ A @ A2 @ B2 )
         => ( ( dvd_dvd @ A @ C2 @ D2 )
           => ( dvd_dvd @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ D2 ) ) ) ) ) ).

% mult_dvd_mono
thf(fact_1311_dvd__mult__right,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( dvd_dvd @ A @ ( times_times @ A @ A2 @ B2 ) @ C2 )
         => ( dvd_dvd @ A @ B2 @ C2 ) ) ) ).

% dvd_mult_right
thf(fact_1312_dvd__triv__right,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A2: A,B2: A] : ( dvd_dvd @ A @ A2 @ ( times_times @ A @ B2 @ A2 ) ) ) ).

% dvd_triv_right
thf(fact_1313_dvd__productE,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [P4: A,A2: A,B2: A] :
          ( ( dvd_dvd @ A @ P4 @ ( times_times @ A @ A2 @ B2 ) )
         => ~ ! [X3: A,Y4: A] :
                ( ( P4
                  = ( times_times @ A @ X3 @ Y4 ) )
               => ( ( dvd_dvd @ A @ X3 @ A2 )
                 => ~ ( dvd_dvd @ A @ Y4 @ B2 ) ) ) ) ) ).

% dvd_productE
thf(fact_1314_division__decomp,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( dvd_dvd @ A @ A2 @ ( times_times @ A @ B2 @ C2 ) )
         => ? [B7: A,C5: A] :
              ( ( A2
                = ( times_times @ A @ B7 @ C5 ) )
              & ( dvd_dvd @ A @ B7 @ B2 )
              & ( dvd_dvd @ A @ C5 @ C2 ) ) ) ) ).

% division_decomp
thf(fact_1315_diff__strict__mono,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A,B2: A,D2: A,C2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_less @ A @ D2 @ C2 )
           => ( ord_less @ A @ ( minus_minus @ A @ A2 @ C2 ) @ ( minus_minus @ A @ B2 @ D2 ) ) ) ) ) ).

% diff_strict_mono
thf(fact_1316_diff__eq__diff__less,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ( minus_minus @ A @ A2 @ B2 )
            = ( minus_minus @ A @ C2 @ D2 ) )
         => ( ( ord_less @ A @ A2 @ B2 )
            = ( ord_less @ A @ C2 @ D2 ) ) ) ) ).

% diff_eq_diff_less
thf(fact_1317_diff__strict__left__mono,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( ord_less @ A @ B2 @ A2 )
         => ( ord_less @ A @ ( minus_minus @ A @ C2 @ A2 ) @ ( minus_minus @ A @ C2 @ B2 ) ) ) ) ).

% diff_strict_left_mono
thf(fact_1318_diff__strict__right__mono,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ord_less @ A @ ( minus_minus @ A @ A2 @ C2 ) @ ( minus_minus @ A @ B2 @ C2 ) ) ) ) ).

% diff_strict_right_mono
thf(fact_1319_one__dvd,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A2: A] : ( dvd_dvd @ A @ ( one_one @ A ) @ A2 ) ) ).

% one_dvd
thf(fact_1320_unit__imp__dvd,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [B2: A,A2: A] :
          ( ( dvd_dvd @ A @ B2 @ ( one_one @ A ) )
         => ( dvd_dvd @ A @ B2 @ A2 ) ) ) ).

% unit_imp_dvd
thf(fact_1321_dvd__unit__imp__unit,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,B2: A] :
          ( ( dvd_dvd @ A @ A2 @ B2 )
         => ( ( dvd_dvd @ A @ B2 @ ( one_one @ A ) )
           => ( dvd_dvd @ A @ A2 @ ( one_one @ A ) ) ) ) ) ).

% dvd_unit_imp_unit
thf(fact_1322_dvd__add,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( dvd_dvd @ A @ A2 @ B2 )
         => ( ( dvd_dvd @ A @ A2 @ C2 )
           => ( dvd_dvd @ A @ A2 @ ( plus_plus @ A @ B2 @ C2 ) ) ) ) ) ).

% dvd_add
thf(fact_1323_dvd__add__left__iff,axiom,
    ! [A: $tType] :
      ( ( comm_s4317794764714335236cancel @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( dvd_dvd @ A @ A2 @ C2 )
         => ( ( dvd_dvd @ A @ A2 @ ( plus_plus @ A @ B2 @ C2 ) )
            = ( dvd_dvd @ A @ A2 @ B2 ) ) ) ) ).

% dvd_add_left_iff
thf(fact_1324_dvd__add__right__iff,axiom,
    ! [A: $tType] :
      ( ( comm_s4317794764714335236cancel @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( dvd_dvd @ A @ A2 @ B2 )
         => ( ( dvd_dvd @ A @ A2 @ ( plus_plus @ A @ B2 @ C2 ) )
            = ( dvd_dvd @ A @ A2 @ C2 ) ) ) ) ).

% dvd_add_right_iff
thf(fact_1325_left__diff__distrib,axiom,
    ! [A: $tType] :
      ( ( ring @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( times_times @ A @ ( minus_minus @ A @ A2 @ B2 ) @ C2 )
          = ( minus_minus @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) ) ) ) ).

% left_diff_distrib
thf(fact_1326_right__diff__distrib,axiom,
    ! [A: $tType] :
      ( ( ring @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( times_times @ A @ A2 @ ( minus_minus @ A @ B2 @ C2 ) )
          = ( minus_minus @ A @ ( times_times @ A @ A2 @ B2 ) @ ( times_times @ A @ A2 @ C2 ) ) ) ) ).

% right_diff_distrib
thf(fact_1327_left__diff__distrib_H,axiom,
    ! [A: $tType] :
      ( ( comm_s4317794764714335236cancel @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( times_times @ A @ ( minus_minus @ A @ B2 @ C2 ) @ A2 )
          = ( minus_minus @ A @ ( times_times @ A @ B2 @ A2 ) @ ( times_times @ A @ C2 @ A2 ) ) ) ) ).

% left_diff_distrib'
thf(fact_1328_right__diff__distrib_H,axiom,
    ! [A: $tType] :
      ( ( comm_s4317794764714335236cancel @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( times_times @ A @ A2 @ ( minus_minus @ A @ B2 @ C2 ) )
          = ( minus_minus @ A @ ( times_times @ A @ A2 @ B2 ) @ ( times_times @ A @ A2 @ C2 ) ) ) ) ).

% right_diff_distrib'
thf(fact_1329_inf__period_I1_J,axiom,
    ! [A: $tType] :
      ( ( ( comm_ring @ A )
        & ( dvd @ A ) )
     => ! [P: A > $o,D5: A,Q: A > $o] :
          ( ! [X3: A,K2: A] :
              ( ( P @ X3 )
              = ( P @ ( minus_minus @ A @ X3 @ ( times_times @ A @ K2 @ D5 ) ) ) )
         => ( ! [X3: A,K2: A] :
                ( ( Q @ X3 )
                = ( Q @ ( minus_minus @ A @ X3 @ ( times_times @ A @ K2 @ D5 ) ) ) )
           => ! [X: A,K4: A] :
                ( ( ( P @ X )
                  & ( Q @ X ) )
                = ( ( P @ ( minus_minus @ A @ X @ ( times_times @ A @ K4 @ D5 ) ) )
                  & ( Q @ ( minus_minus @ A @ X @ ( times_times @ A @ K4 @ D5 ) ) ) ) ) ) ) ) ).

% inf_period(1)
thf(fact_1330_inf__period_I2_J,axiom,
    ! [A: $tType] :
      ( ( ( comm_ring @ A )
        & ( dvd @ A ) )
     => ! [P: A > $o,D5: A,Q: A > $o] :
          ( ! [X3: A,K2: A] :
              ( ( P @ X3 )
              = ( P @ ( minus_minus @ A @ X3 @ ( times_times @ A @ K2 @ D5 ) ) ) )
         => ( ! [X3: A,K2: A] :
                ( ( Q @ X3 )
                = ( Q @ ( minus_minus @ A @ X3 @ ( times_times @ A @ K2 @ D5 ) ) ) )
           => ! [X: A,K4: A] :
                ( ( ( P @ X )
                  | ( Q @ X ) )
                = ( ( P @ ( minus_minus @ A @ X @ ( times_times @ A @ K4 @ D5 ) ) )
                  | ( Q @ ( minus_minus @ A @ X @ ( times_times @ A @ K4 @ D5 ) ) ) ) ) ) ) ) ).

% inf_period(2)
thf(fact_1331_dvd__div__eq__iff,axiom,
    ! [A: $tType] :
      ( ( semidom_divide @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( dvd_dvd @ A @ C2 @ A2 )
         => ( ( dvd_dvd @ A @ C2 @ B2 )
           => ( ( ( divide_divide @ A @ A2 @ C2 )
                = ( divide_divide @ A @ B2 @ C2 ) )
              = ( A2 = B2 ) ) ) ) ) ).

% dvd_div_eq_iff
thf(fact_1332_dvd__div__eq__cancel,axiom,
    ! [A: $tType] :
      ( ( semidom_divide @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ( divide_divide @ A @ A2 @ C2 )
            = ( divide_divide @ A @ B2 @ C2 ) )
         => ( ( dvd_dvd @ A @ C2 @ A2 )
           => ( ( dvd_dvd @ A @ C2 @ B2 )
             => ( A2 = B2 ) ) ) ) ) ).

% dvd_div_eq_cancel
thf(fact_1333_div__div__div__same,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [D2: A,B2: A,A2: A] :
          ( ( dvd_dvd @ A @ D2 @ B2 )
         => ( ( dvd_dvd @ A @ B2 @ A2 )
           => ( ( divide_divide @ A @ ( divide_divide @ A @ A2 @ D2 ) @ ( divide_divide @ A @ B2 @ D2 ) )
              = ( divide_divide @ A @ A2 @ B2 ) ) ) ) ) ).

% div_div_div_same
thf(fact_1334_add__diff__add,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [A2: A,C2: A,B2: A,D2: A] :
          ( ( minus_minus @ A @ ( plus_plus @ A @ A2 @ C2 ) @ ( plus_plus @ A @ B2 @ D2 ) )
          = ( plus_plus @ A @ ( minus_minus @ A @ A2 @ B2 ) @ ( minus_minus @ A @ C2 @ D2 ) ) ) ) ).

% add_diff_add
thf(fact_1335_group__cancel_Osub1,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [A3: A,K: A,A2: A,B2: A] :
          ( ( A3
            = ( plus_plus @ A @ K @ A2 ) )
         => ( ( minus_minus @ A @ A3 @ B2 )
            = ( plus_plus @ A @ K @ ( minus_minus @ A @ A2 @ B2 ) ) ) ) ) ).

% group_cancel.sub1
thf(fact_1336_diff__eq__eq,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ( minus_minus @ A @ A2 @ B2 )
            = C2 )
          = ( A2
            = ( plus_plus @ A @ C2 @ B2 ) ) ) ) ).

% diff_eq_eq
thf(fact_1337_eq__diff__eq,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( A2
            = ( minus_minus @ A @ C2 @ B2 ) )
          = ( ( plus_plus @ A @ A2 @ B2 )
            = C2 ) ) ) ).

% eq_diff_eq
thf(fact_1338_add__diff__eq,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( plus_plus @ A @ A2 @ ( minus_minus @ A @ B2 @ C2 ) )
          = ( minus_minus @ A @ ( plus_plus @ A @ A2 @ B2 ) @ C2 ) ) ) ).

% add_diff_eq
thf(fact_1339_diff__diff__eq2,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( minus_minus @ A @ A2 @ ( minus_minus @ A @ B2 @ C2 ) )
          = ( minus_minus @ A @ ( plus_plus @ A @ A2 @ C2 ) @ B2 ) ) ) ).

% diff_diff_eq2
thf(fact_1340_diff__add__eq,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( plus_plus @ A @ ( minus_minus @ A @ A2 @ B2 ) @ C2 )
          = ( minus_minus @ A @ ( plus_plus @ A @ A2 @ C2 ) @ B2 ) ) ) ).

% diff_add_eq
thf(fact_1341_diff__add__eq__diff__diff__swap,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( minus_minus @ A @ A2 @ ( plus_plus @ A @ B2 @ C2 ) )
          = ( minus_minus @ A @ ( minus_minus @ A @ A2 @ C2 ) @ B2 ) ) ) ).

% diff_add_eq_diff_diff_swap
thf(fact_1342_add__implies__diff,axiom,
    ! [A: $tType] :
      ( ( cancel1802427076303600483id_add @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( ( plus_plus @ A @ C2 @ B2 )
            = A2 )
         => ( C2
            = ( minus_minus @ A @ A2 @ B2 ) ) ) ) ).

% add_implies_diff
thf(fact_1343_diff__diff__eq,axiom,
    ! [A: $tType] :
      ( ( cancel2418104881723323429up_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( minus_minus @ A @ ( minus_minus @ A @ A2 @ B2 ) @ C2 )
          = ( minus_minus @ A @ A2 @ ( plus_plus @ A @ B2 @ C2 ) ) ) ) ).

% diff_diff_eq
thf(fact_1344_dvd__power__same,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [X2: A,Y2: A,N2: nat] :
          ( ( dvd_dvd @ A @ X2 @ Y2 )
         => ( dvd_dvd @ A @ ( power_power @ A @ X2 @ N2 ) @ ( power_power @ A @ Y2 @ N2 ) ) ) ) ).

% dvd_power_same
thf(fact_1345_diff__divide__distrib,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( divide_divide @ A @ ( minus_minus @ A @ A2 @ B2 ) @ C2 )
          = ( minus_minus @ A @ ( divide_divide @ A @ A2 @ C2 ) @ ( divide_divide @ A @ B2 @ C2 ) ) ) ) ).

% diff_divide_distrib
thf(fact_1346_gcd__nat_Oextremum__uniqueI,axiom,
    ! [A2: nat] :
      ( ( dvd_dvd @ nat @ ( zero_zero @ nat ) @ A2 )
     => ( A2
        = ( zero_zero @ nat ) ) ) ).

% gcd_nat.extremum_uniqueI
thf(fact_1347_gcd__nat_Onot__eq__extremum,axiom,
    ! [A2: nat] :
      ( ( ( A2
         != ( zero_zero @ nat ) ) )
      = ( ( dvd_dvd @ nat @ A2 @ ( zero_zero @ nat ) )
        & ( A2
         != ( zero_zero @ nat ) ) ) ) ).

% gcd_nat.not_eq_extremum
thf(fact_1348_gcd__nat_Oextremum__unique,axiom,
    ! [A2: nat] :
      ( ( dvd_dvd @ nat @ ( zero_zero @ nat ) @ A2 )
      = ( A2
        = ( zero_zero @ nat ) ) ) ).

% gcd_nat.extremum_unique
thf(fact_1349_gcd__nat_Oextremum__strict,axiom,
    ! [A2: nat] :
      ~ ( ( dvd_dvd @ nat @ ( zero_zero @ nat ) @ A2 )
        & ( ( zero_zero @ nat )
         != A2 ) ) ).

% gcd_nat.extremum_strict
thf(fact_1350_gcd__nat_Oextremum,axiom,
    ! [A2: nat] : ( dvd_dvd @ nat @ A2 @ ( zero_zero @ nat ) ) ).

% gcd_nat.extremum
thf(fact_1351_mod__mod__cancel,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( dvd_dvd @ A @ C2 @ B2 )
         => ( ( modulo_modulo @ A @ ( modulo_modulo @ A @ A2 @ B2 ) @ C2 )
            = ( modulo_modulo @ A @ A2 @ C2 ) ) ) ) ).

% mod_mod_cancel
thf(fact_1352_dvd__mod,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [K: A,M: A,N2: A] :
          ( ( dvd_dvd @ A @ K @ M )
         => ( ( dvd_dvd @ A @ K @ N2 )
           => ( dvd_dvd @ A @ K @ ( modulo_modulo @ A @ M @ N2 ) ) ) ) ) ).

% dvd_mod
thf(fact_1353_dvd__mod__imp__dvd,axiom,
    ! [A: $tType] :
      ( ( semidom_modulo @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( dvd_dvd @ A @ C2 @ ( modulo_modulo @ A @ A2 @ B2 ) )
         => ( ( dvd_dvd @ A @ C2 @ B2 )
           => ( dvd_dvd @ A @ C2 @ A2 ) ) ) ) ).

% dvd_mod_imp_dvd
thf(fact_1354_dvd__mod__iff,axiom,
    ! [A: $tType] :
      ( ( semidom_modulo @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( dvd_dvd @ A @ C2 @ B2 )
         => ( ( dvd_dvd @ A @ C2 @ ( modulo_modulo @ A @ A2 @ B2 ) )
            = ( dvd_dvd @ A @ C2 @ A2 ) ) ) ) ).

% dvd_mod_iff
thf(fact_1355_mod__diff__right__eq,axiom,
    ! [A: $tType] :
      ( ( euclid8851590272496341667cancel @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( modulo_modulo @ A @ ( minus_minus @ A @ A2 @ ( modulo_modulo @ A @ B2 @ C2 ) ) @ C2 )
          = ( modulo_modulo @ A @ ( minus_minus @ A @ A2 @ B2 ) @ C2 ) ) ) ).

% mod_diff_right_eq
thf(fact_1356_mod__diff__left__eq,axiom,
    ! [A: $tType] :
      ( ( euclid8851590272496341667cancel @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( modulo_modulo @ A @ ( minus_minus @ A @ ( modulo_modulo @ A @ A2 @ C2 ) @ B2 ) @ C2 )
          = ( modulo_modulo @ A @ ( minus_minus @ A @ A2 @ B2 ) @ C2 ) ) ) ).

% mod_diff_left_eq
thf(fact_1357_mod__diff__cong,axiom,
    ! [A: $tType] :
      ( ( euclid8851590272496341667cancel @ A )
     => ! [A2: A,C2: A,A6: A,B2: A,B6: A] :
          ( ( ( modulo_modulo @ A @ A2 @ C2 )
            = ( modulo_modulo @ A @ A6 @ C2 ) )
         => ( ( ( modulo_modulo @ A @ B2 @ C2 )
              = ( modulo_modulo @ A @ B6 @ C2 ) )
           => ( ( modulo_modulo @ A @ ( minus_minus @ A @ A2 @ B2 ) @ C2 )
              = ( modulo_modulo @ A @ ( minus_minus @ A @ A6 @ B6 ) @ C2 ) ) ) ) ) ).

% mod_diff_cong
thf(fact_1358_mod__diff__eq,axiom,
    ! [A: $tType] :
      ( ( euclid8851590272496341667cancel @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( modulo_modulo @ A @ ( minus_minus @ A @ ( modulo_modulo @ A @ A2 @ C2 ) @ ( modulo_modulo @ A @ B2 @ C2 ) ) @ C2 )
          = ( modulo_modulo @ A @ ( minus_minus @ A @ A2 @ B2 ) @ C2 ) ) ) ).

% mod_diff_eq
thf(fact_1359_minus__int__code_I1_J,axiom,
    ! [K: int] :
      ( ( minus_minus @ int @ K @ ( zero_zero @ int ) )
      = K ) ).

% minus_int_code(1)
thf(fact_1360_signed__take__bit__mult,axiom,
    ! [N2: nat,K: int,L: int] :
      ( ( bit_ri4674362597316999326ke_bit @ int @ N2 @ ( times_times @ int @ ( bit_ri4674362597316999326ke_bit @ int @ N2 @ K ) @ ( bit_ri4674362597316999326ke_bit @ int @ N2 @ L ) ) )
      = ( bit_ri4674362597316999326ke_bit @ int @ N2 @ ( times_times @ int @ K @ L ) ) ) ).

% signed_take_bit_mult
thf(fact_1361_signed__take__bit__add,axiom,
    ! [N2: nat,K: int,L: int] :
      ( ( bit_ri4674362597316999326ke_bit @ int @ N2 @ ( plus_plus @ int @ ( bit_ri4674362597316999326ke_bit @ int @ N2 @ K ) @ ( bit_ri4674362597316999326ke_bit @ int @ N2 @ L ) ) )
      = ( bit_ri4674362597316999326ke_bit @ int @ N2 @ ( plus_plus @ int @ K @ L ) ) ) ).

% signed_take_bit_add
thf(fact_1362_int__distrib_I4_J,axiom,
    ! [W: int,Z1: int,Z22: int] :
      ( ( times_times @ int @ W @ ( minus_minus @ int @ Z1 @ Z22 ) )
      = ( minus_minus @ int @ ( times_times @ int @ W @ Z1 ) @ ( times_times @ int @ W @ Z22 ) ) ) ).

% int_distrib(4)
thf(fact_1363_int__distrib_I3_J,axiom,
    ! [Z1: int,Z22: int,W: int] :
      ( ( times_times @ int @ ( minus_minus @ int @ Z1 @ Z22 ) @ W )
      = ( minus_minus @ int @ ( times_times @ int @ Z1 @ W ) @ ( times_times @ int @ Z22 @ W ) ) ) ).

% int_distrib(3)
thf(fact_1364_max__diff__distrib__left,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [X2: A,Y2: A,Z: A] :
          ( ( minus_minus @ A @ ( ord_max @ A @ X2 @ Y2 ) @ Z )
          = ( ord_max @ A @ ( minus_minus @ A @ X2 @ Z ) @ ( minus_minus @ A @ Y2 @ Z ) ) ) ) ).

% max_diff_distrib_left
thf(fact_1365_numeral__code_I2_J,axiom,
    ! [A: $tType] :
      ( ( numeral @ A )
     => ! [N2: num] :
          ( ( numeral_numeral @ A @ ( bit0 @ N2 ) )
          = ( plus_plus @ A @ ( numeral_numeral @ A @ N2 ) @ ( numeral_numeral @ A @ N2 ) ) ) ) ).

% numeral_code(2)
thf(fact_1366_set__vebt__def,axiom,
    ( vEBT_set_vebt
    = ( ^ [T3: vEBT_VEBT] : ( collect @ nat @ ( vEBT_V8194947554948674370ptions @ T3 ) ) ) ) ).

% set_vebt_def
thf(fact_1367_concat__bit__assoc,axiom,
    ! [N2: nat,K: int,M: nat,L: int,R3: int] :
      ( ( bit_concat_bit @ N2 @ K @ ( bit_concat_bit @ M @ L @ R3 ) )
      = ( bit_concat_bit @ ( plus_plus @ nat @ M @ N2 ) @ ( bit_concat_bit @ N2 @ K @ L ) @ R3 ) ) ).

% concat_bit_assoc
thf(fact_1368_even__signed__take__bit__iff,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [M: nat,A2: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_ri4674362597316999326ke_bit @ A @ M @ A2 ) )
          = ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) ) ) ).

% even_signed_take_bit_iff
thf(fact_1369_power__numeral__even,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [Z: A,W: num] :
          ( ( power_power @ A @ Z @ ( numeral_numeral @ nat @ ( bit0 @ W ) ) )
          = ( times_times @ A @ ( power_power @ A @ Z @ ( numeral_numeral @ nat @ W ) ) @ ( power_power @ A @ Z @ ( numeral_numeral @ nat @ W ) ) ) ) ) ).

% power_numeral_even
thf(fact_1370_even__diff__iff,axiom,
    ! [K: int,L: int] :
      ( ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( minus_minus @ int @ K @ L ) )
      = ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( plus_plus @ int @ K @ L ) ) ) ).

% even_diff_iff
thf(fact_1371_le__iff__diff__le__0,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [A4: A,B4: A] : ( ord_less_eq @ A @ ( minus_minus @ A @ A4 @ B4 ) @ ( zero_zero @ A ) ) ) ) ) ).

% le_iff_diff_le_0
thf(fact_1372_not__is__unit__0,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ~ ( dvd_dvd @ A @ ( zero_zero @ A ) @ ( one_one @ A ) ) ) ).

% not_is_unit_0
thf(fact_1373_less__iff__diff__less__0,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ( ( ord_less @ A )
        = ( ^ [A4: A,B4: A] : ( ord_less @ A @ ( minus_minus @ A @ A4 @ B4 ) @ ( zero_zero @ A ) ) ) ) ) ).

% less_iff_diff_less_0
thf(fact_1374_minf_I10_J,axiom,
    ! [B: $tType] :
      ( ( ( plus @ B )
        & ( linorder @ B )
        & ( dvd @ B ) )
     => ! [D2: B,S2: B] :
        ? [Z3: B] :
        ! [X: B] :
          ( ( ord_less @ B @ X @ Z3 )
         => ( ( ~ ( dvd_dvd @ B @ D2 @ ( plus_plus @ B @ X @ S2 ) ) )
            = ( ~ ( dvd_dvd @ B @ D2 @ ( plus_plus @ B @ X @ S2 ) ) ) ) ) ) ).

% minf(10)
thf(fact_1375_minf_I9_J,axiom,
    ! [B: $tType] :
      ( ( ( plus @ B )
        & ( linorder @ B )
        & ( dvd @ B ) )
     => ! [D2: B,S2: B] :
        ? [Z3: B] :
        ! [X: B] :
          ( ( ord_less @ B @ X @ Z3 )
         => ( ( dvd_dvd @ B @ D2 @ ( plus_plus @ B @ X @ S2 ) )
            = ( dvd_dvd @ B @ D2 @ ( plus_plus @ B @ X @ S2 ) ) ) ) ) ).

% minf(9)
thf(fact_1376_pinf_I10_J,axiom,
    ! [B: $tType] :
      ( ( ( plus @ B )
        & ( linorder @ B )
        & ( dvd @ B ) )
     => ! [D2: B,S2: B] :
        ? [Z3: B] :
        ! [X: B] :
          ( ( ord_less @ B @ Z3 @ X )
         => ( ( ~ ( dvd_dvd @ B @ D2 @ ( plus_plus @ B @ X @ S2 ) ) )
            = ( ~ ( dvd_dvd @ B @ D2 @ ( plus_plus @ B @ X @ S2 ) ) ) ) ) ) ).

% pinf(10)
thf(fact_1377_pinf_I9_J,axiom,
    ! [B: $tType] :
      ( ( ( plus @ B )
        & ( linorder @ B )
        & ( dvd @ B ) )
     => ! [D2: B,S2: B] :
        ? [Z3: B] :
        ! [X: B] :
          ( ( ord_less @ B @ Z3 @ X )
         => ( ( dvd_dvd @ B @ D2 @ ( plus_plus @ B @ X @ S2 ) )
            = ( dvd_dvd @ B @ D2 @ ( plus_plus @ B @ X @ S2 ) ) ) ) ) ).

% pinf(9)
thf(fact_1378_dvd__div__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( semidom_divide @ A )
     => ! [B2: A,A2: A] :
          ( ( dvd_dvd @ A @ B2 @ A2 )
         => ( ( ( divide_divide @ A @ A2 @ B2 )
              = ( zero_zero @ A ) )
            = ( A2
              = ( zero_zero @ A ) ) ) ) ) ).

% dvd_div_eq_0_iff
thf(fact_1379_is__unit__mult__iff,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,B2: A] :
          ( ( dvd_dvd @ A @ ( times_times @ A @ A2 @ B2 ) @ ( one_one @ A ) )
          = ( ( dvd_dvd @ A @ A2 @ ( one_one @ A ) )
            & ( dvd_dvd @ A @ B2 @ ( one_one @ A ) ) ) ) ) ).

% is_unit_mult_iff
thf(fact_1380_dvd__mult__unit__iff,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( dvd_dvd @ A @ B2 @ ( one_one @ A ) )
         => ( ( dvd_dvd @ A @ A2 @ ( times_times @ A @ C2 @ B2 ) )
            = ( dvd_dvd @ A @ A2 @ C2 ) ) ) ) ).

% dvd_mult_unit_iff
thf(fact_1381_mult__unit__dvd__iff,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( dvd_dvd @ A @ B2 @ ( one_one @ A ) )
         => ( ( dvd_dvd @ A @ ( times_times @ A @ A2 @ B2 ) @ C2 )
            = ( dvd_dvd @ A @ A2 @ C2 ) ) ) ) ).

% mult_unit_dvd_iff
thf(fact_1382_dvd__mult__unit__iff_H,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( dvd_dvd @ A @ B2 @ ( one_one @ A ) )
         => ( ( dvd_dvd @ A @ A2 @ ( times_times @ A @ B2 @ C2 ) )
            = ( dvd_dvd @ A @ A2 @ C2 ) ) ) ) ).

% dvd_mult_unit_iff'
thf(fact_1383_mult__unit__dvd__iff_H,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( dvd_dvd @ A @ A2 @ ( one_one @ A ) )
         => ( ( dvd_dvd @ A @ ( times_times @ A @ A2 @ B2 ) @ C2 )
            = ( dvd_dvd @ A @ B2 @ C2 ) ) ) ) ).

% mult_unit_dvd_iff'
thf(fact_1384_unit__mult__left__cancel,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( dvd_dvd @ A @ A2 @ ( one_one @ A ) )
         => ( ( ( times_times @ A @ A2 @ B2 )
              = ( times_times @ A @ A2 @ C2 ) )
            = ( B2 = C2 ) ) ) ) ).

% unit_mult_left_cancel
thf(fact_1385_unit__mult__right__cancel,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( dvd_dvd @ A @ A2 @ ( one_one @ A ) )
         => ( ( ( times_times @ A @ B2 @ A2 )
              = ( times_times @ A @ C2 @ A2 ) )
            = ( B2 = C2 ) ) ) ) ).

% unit_mult_right_cancel
thf(fact_1386_add__le__imp__le__diff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [I3: A,K: A,N2: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ I3 @ K ) @ N2 )
         => ( ord_less_eq @ A @ I3 @ ( minus_minus @ A @ N2 @ K ) ) ) ) ).

% add_le_imp_le_diff
thf(fact_1387_add__le__add__imp__diff__le,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [I3: A,K: A,N2: A,J: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ I3 @ K ) @ N2 )
         => ( ( ord_less_eq @ A @ N2 @ ( plus_plus @ A @ J @ K ) )
           => ( ( ord_less_eq @ A @ ( plus_plus @ A @ I3 @ K ) @ N2 )
             => ( ( ord_less_eq @ A @ N2 @ ( plus_plus @ A @ J @ K ) )
               => ( ord_less_eq @ A @ ( minus_minus @ A @ N2 @ K ) @ J ) ) ) ) ) ) ).

% add_le_add_imp_diff_le
thf(fact_1388_diff__le__eq,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ ( minus_minus @ A @ A2 @ B2 ) @ C2 )
          = ( ord_less_eq @ A @ A2 @ ( plus_plus @ A @ C2 @ B2 ) ) ) ) ).

% diff_le_eq
thf(fact_1389_le__diff__eq,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ ( minus_minus @ A @ C2 @ B2 ) )
          = ( ord_less_eq @ A @ ( plus_plus @ A @ A2 @ B2 ) @ C2 ) ) ) ).

% le_diff_eq
thf(fact_1390_diff__add,axiom,
    ! [A: $tType] :
      ( ( ordere1170586879665033532d_diff @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( plus_plus @ A @ ( minus_minus @ A @ B2 @ A2 ) @ A2 )
            = B2 ) ) ) ).

% diff_add
thf(fact_1391_le__add__diff,axiom,
    ! [A: $tType] :
      ( ( ordere1170586879665033532d_diff @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ord_less_eq @ A @ C2 @ ( minus_minus @ A @ ( plus_plus @ A @ B2 @ C2 ) @ A2 ) ) ) ) ).

% le_add_diff
thf(fact_1392_ordered__cancel__comm__monoid__diff__class_Ole__diff__conv2,axiom,
    ! [A: $tType] :
      ( ( ordere1170586879665033532d_diff @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ C2 @ ( minus_minus @ A @ B2 @ A2 ) )
            = ( ord_less_eq @ A @ ( plus_plus @ A @ C2 @ A2 ) @ B2 ) ) ) ) ).

% ordered_cancel_comm_monoid_diff_class.le_diff_conv2
thf(fact_1393_ordered__cancel__comm__monoid__diff__class_Oadd__diff__assoc,axiom,
    ! [A: $tType] :
      ( ( ordere1170586879665033532d_diff @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( plus_plus @ A @ C2 @ ( minus_minus @ A @ B2 @ A2 ) )
            = ( minus_minus @ A @ ( plus_plus @ A @ C2 @ B2 ) @ A2 ) ) ) ) ).

% ordered_cancel_comm_monoid_diff_class.add_diff_assoc
thf(fact_1394_ordered__cancel__comm__monoid__diff__class_Odiff__add__assoc,axiom,
    ! [A: $tType] :
      ( ( ordere1170586879665033532d_diff @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( minus_minus @ A @ ( plus_plus @ A @ C2 @ B2 ) @ A2 )
            = ( plus_plus @ A @ C2 @ ( minus_minus @ A @ B2 @ A2 ) ) ) ) ) ).

% ordered_cancel_comm_monoid_diff_class.diff_add_assoc
thf(fact_1395_ordered__cancel__comm__monoid__diff__class_Oadd__diff__assoc2,axiom,
    ! [A: $tType] :
      ( ( ordere1170586879665033532d_diff @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( plus_plus @ A @ ( minus_minus @ A @ B2 @ A2 ) @ C2 )
            = ( minus_minus @ A @ ( plus_plus @ A @ B2 @ C2 ) @ A2 ) ) ) ) ).

% ordered_cancel_comm_monoid_diff_class.add_diff_assoc2
thf(fact_1396_ordered__cancel__comm__monoid__diff__class_Odiff__add__assoc2,axiom,
    ! [A: $tType] :
      ( ( ordere1170586879665033532d_diff @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( minus_minus @ A @ ( plus_plus @ A @ B2 @ C2 ) @ A2 )
            = ( plus_plus @ A @ ( minus_minus @ A @ B2 @ A2 ) @ C2 ) ) ) ) ).

% ordered_cancel_comm_monoid_diff_class.diff_add_assoc2
thf(fact_1397_ordered__cancel__comm__monoid__diff__class_Odiff__diff__right,axiom,
    ! [A: $tType] :
      ( ( ordere1170586879665033532d_diff @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( minus_minus @ A @ C2 @ ( minus_minus @ A @ B2 @ A2 ) )
            = ( minus_minus @ A @ ( plus_plus @ A @ C2 @ A2 ) @ B2 ) ) ) ) ).

% ordered_cancel_comm_monoid_diff_class.diff_diff_right
thf(fact_1398_ordered__cancel__comm__monoid__diff__class_Oadd__diff__inverse,axiom,
    ! [A: $tType] :
      ( ( ordere1170586879665033532d_diff @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( plus_plus @ A @ A2 @ ( minus_minus @ A @ B2 @ A2 ) )
            = B2 ) ) ) ).

% ordered_cancel_comm_monoid_diff_class.add_diff_inverse
thf(fact_1399_ordered__cancel__comm__monoid__diff__class_Ole__imp__diff__is__add,axiom,
    ! [A: $tType] :
      ( ( ordere1170586879665033532d_diff @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ A2 @ B2 )
           => ( ( ( minus_minus @ A @ B2 @ A2 )
                = C2 )
              = ( B2
                = ( plus_plus @ A @ C2 @ A2 ) ) ) ) ) ) ).

% ordered_cancel_comm_monoid_diff_class.le_imp_diff_is_add
thf(fact_1400_linordered__semidom__class_Oadd__diff__inverse,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,B2: A] :
          ( ~ ( ord_less @ A @ A2 @ B2 )
         => ( ( plus_plus @ A @ B2 @ ( minus_minus @ A @ A2 @ B2 ) )
            = A2 ) ) ) ).

% linordered_semidom_class.add_diff_inverse
thf(fact_1401_diff__less__eq,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less @ A @ ( minus_minus @ A @ A2 @ B2 ) @ C2 )
          = ( ord_less @ A @ A2 @ ( plus_plus @ A @ C2 @ B2 ) ) ) ) ).

% diff_less_eq
thf(fact_1402_less__diff__eq,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ ( minus_minus @ A @ C2 @ B2 ) )
          = ( ord_less @ A @ ( plus_plus @ A @ A2 @ B2 ) @ C2 ) ) ) ).

% less_diff_eq
thf(fact_1403_dvd__div__mult,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( dvd_dvd @ A @ C2 @ B2 )
         => ( ( times_times @ A @ ( divide_divide @ A @ B2 @ C2 ) @ A2 )
            = ( divide_divide @ A @ ( times_times @ A @ B2 @ A2 ) @ C2 ) ) ) ) ).

% dvd_div_mult
thf(fact_1404_div__mult__swap,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( dvd_dvd @ A @ C2 @ B2 )
         => ( ( times_times @ A @ A2 @ ( divide_divide @ A @ B2 @ C2 ) )
            = ( divide_divide @ A @ ( times_times @ A @ A2 @ B2 ) @ C2 ) ) ) ) ).

% div_mult_swap
thf(fact_1405_div__div__eq__right,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( dvd_dvd @ A @ C2 @ B2 )
         => ( ( dvd_dvd @ A @ B2 @ A2 )
           => ( ( divide_divide @ A @ A2 @ ( divide_divide @ A @ B2 @ C2 ) )
              = ( times_times @ A @ ( divide_divide @ A @ A2 @ B2 ) @ C2 ) ) ) ) ) ).

% div_div_eq_right
thf(fact_1406_dvd__div__mult2__eq,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( dvd_dvd @ A @ ( times_times @ A @ B2 @ C2 ) @ A2 )
         => ( ( divide_divide @ A @ A2 @ ( times_times @ A @ B2 @ C2 ) )
            = ( divide_divide @ A @ ( divide_divide @ A @ A2 @ B2 ) @ C2 ) ) ) ) ).

% dvd_div_mult2_eq
thf(fact_1407_dvd__mult__imp__div,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( dvd_dvd @ A @ ( times_times @ A @ A2 @ C2 ) @ B2 )
         => ( dvd_dvd @ A @ A2 @ ( divide_divide @ A @ B2 @ C2 ) ) ) ) ).

% dvd_mult_imp_div
thf(fact_1408_div__mult__div__if__dvd,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [B2: A,A2: A,D2: A,C2: A] :
          ( ( dvd_dvd @ A @ B2 @ A2 )
         => ( ( dvd_dvd @ A @ D2 @ C2 )
           => ( ( times_times @ A @ ( divide_divide @ A @ A2 @ B2 ) @ ( divide_divide @ A @ C2 @ D2 ) )
              = ( divide_divide @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ D2 ) ) ) ) ) ) ).

% div_mult_div_if_dvd
thf(fact_1409_unit__div__cancel,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( dvd_dvd @ A @ A2 @ ( one_one @ A ) )
         => ( ( ( divide_divide @ A @ B2 @ A2 )
              = ( divide_divide @ A @ C2 @ A2 ) )
            = ( B2 = C2 ) ) ) ) ).

% unit_div_cancel
thf(fact_1410_div__unit__dvd__iff,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( dvd_dvd @ A @ B2 @ ( one_one @ A ) )
         => ( ( dvd_dvd @ A @ ( divide_divide @ A @ A2 @ B2 ) @ C2 )
            = ( dvd_dvd @ A @ A2 @ C2 ) ) ) ) ).

% div_unit_dvd_iff
thf(fact_1411_dvd__div__unit__iff,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( dvd_dvd @ A @ B2 @ ( one_one @ A ) )
         => ( ( dvd_dvd @ A @ A2 @ ( divide_divide @ A @ C2 @ B2 ) )
            = ( dvd_dvd @ A @ A2 @ C2 ) ) ) ) ).

% dvd_div_unit_iff
thf(fact_1412_div__plus__div__distrib__dvd__left,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( dvd_dvd @ A @ C2 @ A2 )
         => ( ( divide_divide @ A @ ( plus_plus @ A @ A2 @ B2 ) @ C2 )
            = ( plus_plus @ A @ ( divide_divide @ A @ A2 @ C2 ) @ ( divide_divide @ A @ B2 @ C2 ) ) ) ) ) ).

% div_plus_div_distrib_dvd_left
thf(fact_1413_div__plus__div__distrib__dvd__right,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( dvd_dvd @ A @ C2 @ B2 )
         => ( ( divide_divide @ A @ ( plus_plus @ A @ A2 @ B2 ) @ C2 )
            = ( plus_plus @ A @ ( divide_divide @ A @ A2 @ C2 ) @ ( divide_divide @ A @ B2 @ C2 ) ) ) ) ) ).

% div_plus_div_distrib_dvd_right
thf(fact_1414_mult__diff__mult,axiom,
    ! [A: $tType] :
      ( ( ring @ A )
     => ! [X2: A,Y2: A,A2: A,B2: A] :
          ( ( minus_minus @ A @ ( times_times @ A @ X2 @ Y2 ) @ ( times_times @ A @ A2 @ B2 ) )
          = ( plus_plus @ A @ ( times_times @ A @ X2 @ ( minus_minus @ A @ Y2 @ B2 ) ) @ ( times_times @ A @ ( minus_minus @ A @ X2 @ A2 ) @ B2 ) ) ) ) ).

% mult_diff_mult
thf(fact_1415_square__diff__square__factored,axiom,
    ! [A: $tType] :
      ( ( comm_ring @ A )
     => ! [X2: A,Y2: A] :
          ( ( minus_minus @ A @ ( times_times @ A @ X2 @ X2 ) @ ( times_times @ A @ Y2 @ Y2 ) )
          = ( times_times @ A @ ( plus_plus @ A @ X2 @ Y2 ) @ ( minus_minus @ A @ X2 @ Y2 ) ) ) ) ).

% square_diff_square_factored
thf(fact_1416_eq__add__iff2,axiom,
    ! [A: $tType] :
      ( ( ring @ A )
     => ! [A2: A,E2: A,C2: A,B2: A,D2: A] :
          ( ( ( plus_plus @ A @ ( times_times @ A @ A2 @ E2 ) @ C2 )
            = ( plus_plus @ A @ ( times_times @ A @ B2 @ E2 ) @ D2 ) )
          = ( C2
            = ( plus_plus @ A @ ( times_times @ A @ ( minus_minus @ A @ B2 @ A2 ) @ E2 ) @ D2 ) ) ) ) ).

% eq_add_iff2
thf(fact_1417_eq__add__iff1,axiom,
    ! [A: $tType] :
      ( ( ring @ A )
     => ! [A2: A,E2: A,C2: A,B2: A,D2: A] :
          ( ( ( plus_plus @ A @ ( times_times @ A @ A2 @ E2 ) @ C2 )
            = ( plus_plus @ A @ ( times_times @ A @ B2 @ E2 ) @ D2 ) )
          = ( ( plus_plus @ A @ ( times_times @ A @ ( minus_minus @ A @ A2 @ B2 ) @ E2 ) @ C2 )
            = D2 ) ) ) ).

% eq_add_iff1
thf(fact_1418_div__power,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [B2: A,A2: A,N2: nat] :
          ( ( dvd_dvd @ A @ B2 @ A2 )
         => ( ( power_power @ A @ ( divide_divide @ A @ A2 @ B2 ) @ N2 )
            = ( divide_divide @ A @ ( power_power @ A @ A2 @ N2 ) @ ( power_power @ A @ B2 @ N2 ) ) ) ) ) ).

% div_power
thf(fact_1419_mod__0__imp__dvd,axiom,
    ! [A: $tType] :
      ( ( semiring_modulo @ A )
     => ! [A2: A,B2: A] :
          ( ( ( modulo_modulo @ A @ A2 @ B2 )
            = ( zero_zero @ A ) )
         => ( dvd_dvd @ A @ B2 @ A2 ) ) ) ).

% mod_0_imp_dvd
thf(fact_1420_dvd__eq__mod__eq__0,axiom,
    ! [A: $tType] :
      ( ( semidom_modulo @ A )
     => ( ( dvd_dvd @ A )
        = ( ^ [A4: A,B4: A] :
              ( ( modulo_modulo @ A @ B4 @ A4 )
              = ( zero_zero @ A ) ) ) ) ) ).

% dvd_eq_mod_eq_0
thf(fact_1421_mod__eq__0__iff__dvd,axiom,
    ! [A: $tType] :
      ( ( semidom_modulo @ A )
     => ! [A2: A,B2: A] :
          ( ( ( modulo_modulo @ A @ A2 @ B2 )
            = ( zero_zero @ A ) )
          = ( dvd_dvd @ A @ B2 @ A2 ) ) ) ).

% mod_eq_0_iff_dvd
thf(fact_1422_dvd__power__le,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [X2: A,Y2: A,N2: nat,M: nat] :
          ( ( dvd_dvd @ A @ X2 @ Y2 )
         => ( ( ord_less_eq @ nat @ N2 @ M )
           => ( dvd_dvd @ A @ ( power_power @ A @ X2 @ N2 ) @ ( power_power @ A @ Y2 @ M ) ) ) ) ) ).

% dvd_power_le
thf(fact_1423_power__le__dvd,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [A2: A,N2: nat,B2: A,M: nat] :
          ( ( dvd_dvd @ A @ ( power_power @ A @ A2 @ N2 ) @ B2 )
         => ( ( ord_less_eq @ nat @ M @ N2 )
           => ( dvd_dvd @ A @ ( power_power @ A @ A2 @ M ) @ B2 ) ) ) ) ).

% power_le_dvd
thf(fact_1424_le__imp__power__dvd,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [M: nat,N2: nat,A2: A] :
          ( ( ord_less_eq @ nat @ M @ N2 )
         => ( dvd_dvd @ A @ ( power_power @ A @ A2 @ M ) @ ( power_power @ A @ A2 @ N2 ) ) ) ) ).

% le_imp_power_dvd
thf(fact_1425_nat__dvd__not__less,axiom,
    ! [M: nat,N2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M )
     => ( ( ord_less @ nat @ M @ N2 )
       => ~ ( dvd_dvd @ nat @ N2 @ M ) ) ) ).

% nat_dvd_not_less
thf(fact_1426_dvd__pos__nat,axiom,
    ! [N2: nat,M: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( dvd_dvd @ nat @ M @ N2 )
       => ( ord_less @ nat @ ( zero_zero @ nat ) @ M ) ) ) ).

% dvd_pos_nat
thf(fact_1427_zdvd__antisym__nonneg,axiom,
    ! [M: int,N2: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ M )
     => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ N2 )
       => ( ( dvd_dvd @ int @ M @ N2 )
         => ( ( dvd_dvd @ int @ N2 @ M )
           => ( M = N2 ) ) ) ) ) ).

% zdvd_antisym_nonneg
thf(fact_1428_zdvd__not__zless,axiom,
    ! [M: int,N2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ M )
     => ( ( ord_less @ int @ M @ N2 )
       => ~ ( dvd_dvd @ int @ N2 @ M ) ) ) ).

% zdvd_not_zless
thf(fact_1429_zdvd__mult__cancel,axiom,
    ! [K: int,M: int,N2: int] :
      ( ( dvd_dvd @ int @ ( times_times @ int @ K @ M ) @ ( times_times @ int @ K @ N2 ) )
     => ( ( K
         != ( zero_zero @ int ) )
       => ( dvd_dvd @ int @ M @ N2 ) ) ) ).

% zdvd_mult_cancel
thf(fact_1430_zdvd__mono,axiom,
    ! [K: int,M: int,T2: int] :
      ( ( K
       != ( zero_zero @ int ) )
     => ( ( dvd_dvd @ int @ M @ T2 )
        = ( dvd_dvd @ int @ ( times_times @ int @ K @ M ) @ ( times_times @ int @ K @ T2 ) ) ) ) ).

% zdvd_mono
thf(fact_1431_bezout__lemma__nat,axiom,
    ! [D2: nat,A2: nat,B2: nat,X2: nat,Y2: nat] :
      ( ( dvd_dvd @ nat @ D2 @ A2 )
     => ( ( dvd_dvd @ nat @ D2 @ B2 )
       => ( ( ( ( times_times @ nat @ A2 @ X2 )
              = ( plus_plus @ nat @ ( times_times @ nat @ B2 @ Y2 ) @ D2 ) )
            | ( ( times_times @ nat @ B2 @ X2 )
              = ( plus_plus @ nat @ ( times_times @ nat @ A2 @ Y2 ) @ D2 ) ) )
         => ? [X3: nat,Y4: nat] :
              ( ( dvd_dvd @ nat @ D2 @ A2 )
              & ( dvd_dvd @ nat @ D2 @ ( plus_plus @ nat @ A2 @ B2 ) )
              & ( ( ( times_times @ nat @ A2 @ X3 )
                  = ( plus_plus @ nat @ ( times_times @ nat @ ( plus_plus @ nat @ A2 @ B2 ) @ Y4 ) @ D2 ) )
                | ( ( times_times @ nat @ ( plus_plus @ nat @ A2 @ B2 ) @ X3 )
                  = ( plus_plus @ nat @ ( times_times @ nat @ A2 @ Y4 ) @ D2 ) ) ) ) ) ) ) ).

% bezout_lemma_nat
thf(fact_1432_bezout__add__nat,axiom,
    ! [A2: nat,B2: nat] :
    ? [D4: nat,X3: nat,Y4: nat] :
      ( ( dvd_dvd @ nat @ D4 @ A2 )
      & ( dvd_dvd @ nat @ D4 @ B2 )
      & ( ( ( times_times @ nat @ A2 @ X3 )
          = ( plus_plus @ nat @ ( times_times @ nat @ B2 @ Y4 ) @ D4 ) )
        | ( ( times_times @ nat @ B2 @ X3 )
          = ( plus_plus @ nat @ ( times_times @ nat @ A2 @ Y4 ) @ D4 ) ) ) ) ).

% bezout_add_nat
thf(fact_1433_int__le__induct,axiom,
    ! [I3: int,K: int,P: int > $o] :
      ( ( ord_less_eq @ int @ I3 @ K )
     => ( ( P @ K )
       => ( ! [I2: int] :
              ( ( ord_less_eq @ int @ I2 @ K )
             => ( ( P @ I2 )
               => ( P @ ( minus_minus @ int @ I2 @ ( one_one @ int ) ) ) ) )
         => ( P @ I3 ) ) ) ) ).

% int_le_induct
thf(fact_1434_int__less__induct,axiom,
    ! [I3: int,K: int,P: int > $o] :
      ( ( ord_less @ int @ I3 @ K )
     => ( ( P @ ( minus_minus @ int @ K @ ( one_one @ int ) ) )
       => ( ! [I2: int] :
              ( ( ord_less @ int @ I2 @ K )
             => ( ( P @ I2 )
               => ( P @ ( minus_minus @ int @ I2 @ ( one_one @ int ) ) ) ) )
         => ( P @ I3 ) ) ) ) ).

% int_less_induct
thf(fact_1435_zdvd__period,axiom,
    ! [A2: int,D2: int,X2: int,T2: int,C2: int] :
      ( ( dvd_dvd @ int @ A2 @ D2 )
     => ( ( dvd_dvd @ int @ A2 @ ( plus_plus @ int @ X2 @ T2 ) )
        = ( dvd_dvd @ int @ A2 @ ( plus_plus @ int @ ( plus_plus @ int @ X2 @ ( times_times @ int @ C2 @ D2 ) ) @ T2 ) ) ) ) ).

% zdvd_period
thf(fact_1436_zdvd__reduce,axiom,
    ! [K: int,N2: int,M: int] :
      ( ( dvd_dvd @ int @ K @ ( plus_plus @ int @ N2 @ ( times_times @ int @ K @ M ) ) )
      = ( dvd_dvd @ int @ K @ N2 ) ) ).

% zdvd_reduce
thf(fact_1437_pow_Osimps_I1_J,axiom,
    ! [X2: num] :
      ( ( pow @ X2 @ one2 )
      = X2 ) ).

% pow.simps(1)
thf(fact_1438_signed__take__bit__int__less__eq,axiom,
    ! [N2: nat,K: int] :
      ( ( ord_less_eq @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N2 ) @ K )
     => ( ord_less_eq @ int @ ( bit_ri4674362597316999326ke_bit @ int @ N2 @ K ) @ ( minus_minus @ int @ K @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( suc @ N2 ) ) ) ) ) ).

% signed_take_bit_int_less_eq
thf(fact_1439_unit__dvdE,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,B2: A] :
          ( ( dvd_dvd @ A @ A2 @ ( one_one @ A ) )
         => ~ ( ( A2
               != ( zero_zero @ A ) )
             => ! [C3: A] :
                  ( B2
                 != ( times_times @ A @ A2 @ C3 ) ) ) ) ) ).

% unit_dvdE
thf(fact_1440_unity__coeff__ex,axiom,
    ! [A: $tType] :
      ( ( ( dvd @ A )
        & ( semiring_0 @ A ) )
     => ! [P: A > $o,L: A] :
          ( ( ? [X5: A] : ( P @ ( times_times @ A @ L @ X5 ) ) )
          = ( ? [X5: A] :
                ( ( dvd_dvd @ A @ L @ ( plus_plus @ A @ X5 @ ( zero_zero @ A ) ) )
                & ( P @ X5 ) ) ) ) ) ).

% unity_coeff_ex
thf(fact_1441_dvd__div__eq__mult,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( dvd_dvd @ A @ A2 @ B2 )
           => ( ( ( divide_divide @ A @ B2 @ A2 )
                = C2 )
              = ( B2
                = ( times_times @ A @ C2 @ A2 ) ) ) ) ) ) ).

% dvd_div_eq_mult
thf(fact_1442_div__dvd__iff__mult,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( dvd_dvd @ A @ B2 @ A2 )
           => ( ( dvd_dvd @ A @ ( divide_divide @ A @ A2 @ B2 ) @ C2 )
              = ( dvd_dvd @ A @ A2 @ ( times_times @ A @ C2 @ B2 ) ) ) ) ) ) ).

% div_dvd_iff_mult
thf(fact_1443_dvd__div__iff__mult,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( dvd_dvd @ A @ C2 @ B2 )
           => ( ( dvd_dvd @ A @ A2 @ ( divide_divide @ A @ B2 @ C2 ) )
              = ( dvd_dvd @ A @ ( times_times @ A @ A2 @ C2 ) @ B2 ) ) ) ) ) ).

% dvd_div_iff_mult
thf(fact_1444_dvd__div__div__eq__mult,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,C2: A,B2: A,D2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( C2
             != ( zero_zero @ A ) )
           => ( ( dvd_dvd @ A @ A2 @ B2 )
             => ( ( dvd_dvd @ A @ C2 @ D2 )
               => ( ( ( divide_divide @ A @ B2 @ A2 )
                    = ( divide_divide @ A @ D2 @ C2 ) )
                  = ( ( times_times @ A @ B2 @ C2 )
                    = ( times_times @ A @ A2 @ D2 ) ) ) ) ) ) ) ) ).

% dvd_div_div_eq_mult
thf(fact_1445_unit__div__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [B2: A,A2: A] :
          ( ( dvd_dvd @ A @ B2 @ ( one_one @ A ) )
         => ( ( ( divide_divide @ A @ A2 @ B2 )
              = ( zero_zero @ A ) )
            = ( A2
              = ( zero_zero @ A ) ) ) ) ) ).

% unit_div_eq_0_iff
thf(fact_1446_even__numeral,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [N2: num] : ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( numeral_numeral @ A @ ( bit0 @ N2 ) ) ) ) ).

% even_numeral
thf(fact_1447_ordered__ring__class_Ole__add__iff1,axiom,
    ! [A: $tType] :
      ( ( ordered_ring @ A )
     => ! [A2: A,E2: A,C2: A,B2: A,D2: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ ( times_times @ A @ A2 @ E2 ) @ C2 ) @ ( plus_plus @ A @ ( times_times @ A @ B2 @ E2 ) @ D2 ) )
          = ( ord_less_eq @ A @ ( plus_plus @ A @ ( times_times @ A @ ( minus_minus @ A @ A2 @ B2 ) @ E2 ) @ C2 ) @ D2 ) ) ) ).

% ordered_ring_class.le_add_iff1
thf(fact_1448_ordered__ring__class_Ole__add__iff2,axiom,
    ! [A: $tType] :
      ( ( ordered_ring @ A )
     => ! [A2: A,E2: A,C2: A,B2: A,D2: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ ( times_times @ A @ A2 @ E2 ) @ C2 ) @ ( plus_plus @ A @ ( times_times @ A @ B2 @ E2 ) @ D2 ) )
          = ( ord_less_eq @ A @ C2 @ ( plus_plus @ A @ ( times_times @ A @ ( minus_minus @ A @ B2 @ A2 ) @ E2 ) @ D2 ) ) ) ) ).

% ordered_ring_class.le_add_iff2
thf(fact_1449_unit__eq__div1,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( dvd_dvd @ A @ B2 @ ( one_one @ A ) )
         => ( ( ( divide_divide @ A @ A2 @ B2 )
              = C2 )
            = ( A2
              = ( times_times @ A @ C2 @ B2 ) ) ) ) ) ).

% unit_eq_div1
thf(fact_1450_unit__eq__div2,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( dvd_dvd @ A @ B2 @ ( one_one @ A ) )
         => ( ( A2
              = ( divide_divide @ A @ C2 @ B2 ) )
            = ( ( times_times @ A @ A2 @ B2 )
              = C2 ) ) ) ) ).

% unit_eq_div2
thf(fact_1451_div__mult__unit2,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( dvd_dvd @ A @ C2 @ ( one_one @ A ) )
         => ( ( dvd_dvd @ A @ B2 @ A2 )
           => ( ( divide_divide @ A @ A2 @ ( times_times @ A @ B2 @ C2 ) )
              = ( divide_divide @ A @ ( divide_divide @ A @ A2 @ B2 ) @ C2 ) ) ) ) ) ).

% div_mult_unit2
thf(fact_1452_unit__div__commute,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( dvd_dvd @ A @ B2 @ ( one_one @ A ) )
         => ( ( times_times @ A @ ( divide_divide @ A @ A2 @ B2 ) @ C2 )
            = ( divide_divide @ A @ ( times_times @ A @ A2 @ C2 ) @ B2 ) ) ) ) ).

% unit_div_commute
thf(fact_1453_unit__div__mult__swap,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( dvd_dvd @ A @ C2 @ ( one_one @ A ) )
         => ( ( times_times @ A @ A2 @ ( divide_divide @ A @ B2 @ C2 ) )
            = ( divide_divide @ A @ ( times_times @ A @ A2 @ B2 ) @ C2 ) ) ) ) ).

% unit_div_mult_swap
thf(fact_1454_is__unit__div__mult2__eq,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( dvd_dvd @ A @ B2 @ ( one_one @ A ) )
         => ( ( dvd_dvd @ A @ C2 @ ( one_one @ A ) )
           => ( ( divide_divide @ A @ A2 @ ( times_times @ A @ B2 @ C2 ) )
              = ( divide_divide @ A @ ( divide_divide @ A @ A2 @ B2 ) @ C2 ) ) ) ) ) ).

% is_unit_div_mult2_eq
thf(fact_1455_less__add__iff1,axiom,
    ! [A: $tType] :
      ( ( ordered_ring @ A )
     => ! [A2: A,E2: A,C2: A,B2: A,D2: A] :
          ( ( ord_less @ A @ ( plus_plus @ A @ ( times_times @ A @ A2 @ E2 ) @ C2 ) @ ( plus_plus @ A @ ( times_times @ A @ B2 @ E2 ) @ D2 ) )
          = ( ord_less @ A @ ( plus_plus @ A @ ( times_times @ A @ ( minus_minus @ A @ A2 @ B2 ) @ E2 ) @ C2 ) @ D2 ) ) ) ).

% less_add_iff1
thf(fact_1456_less__add__iff2,axiom,
    ! [A: $tType] :
      ( ( ordered_ring @ A )
     => ! [A2: A,E2: A,C2: A,B2: A,D2: A] :
          ( ( ord_less @ A @ ( plus_plus @ A @ ( times_times @ A @ A2 @ E2 ) @ C2 ) @ ( plus_plus @ A @ ( times_times @ A @ B2 @ E2 ) @ D2 ) )
          = ( ord_less @ A @ C2 @ ( plus_plus @ A @ ( times_times @ A @ ( minus_minus @ A @ B2 @ A2 ) @ E2 ) @ D2 ) ) ) ) ).

% less_add_iff2
thf(fact_1457_add__divide__eq__if__simps_I4_J,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [Z: A,A2: A,B2: A] :
          ( ( ( Z
              = ( zero_zero @ A ) )
           => ( ( minus_minus @ A @ A2 @ ( divide_divide @ A @ B2 @ Z ) )
              = A2 ) )
          & ( ( Z
             != ( zero_zero @ A ) )
           => ( ( minus_minus @ A @ A2 @ ( divide_divide @ A @ B2 @ Z ) )
              = ( divide_divide @ A @ ( minus_minus @ A @ ( times_times @ A @ A2 @ Z ) @ B2 ) @ Z ) ) ) ) ) ).

% add_divide_eq_if_simps(4)
thf(fact_1458_diff__frac__eq,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [Y2: A,Z: A,X2: A,W: A] :
          ( ( Y2
           != ( zero_zero @ A ) )
         => ( ( Z
             != ( zero_zero @ A ) )
           => ( ( minus_minus @ A @ ( divide_divide @ A @ X2 @ Y2 ) @ ( divide_divide @ A @ W @ Z ) )
              = ( divide_divide @ A @ ( minus_minus @ A @ ( times_times @ A @ X2 @ Z ) @ ( times_times @ A @ W @ Y2 ) ) @ ( times_times @ A @ Y2 @ Z ) ) ) ) ) ) ).

% diff_frac_eq
thf(fact_1459_diff__divide__eq__iff,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [Z: A,X2: A,Y2: A] :
          ( ( Z
           != ( zero_zero @ A ) )
         => ( ( minus_minus @ A @ X2 @ ( divide_divide @ A @ Y2 @ Z ) )
            = ( divide_divide @ A @ ( minus_minus @ A @ ( times_times @ A @ X2 @ Z ) @ Y2 ) @ Z ) ) ) ) ).

% diff_divide_eq_iff
thf(fact_1460_divide__diff__eq__iff,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [Z: A,X2: A,Y2: A] :
          ( ( Z
           != ( zero_zero @ A ) )
         => ( ( minus_minus @ A @ ( divide_divide @ A @ X2 @ Z ) @ Y2 )
            = ( divide_divide @ A @ ( minus_minus @ A @ X2 @ ( times_times @ A @ Y2 @ Z ) ) @ Z ) ) ) ) ).

% divide_diff_eq_iff
thf(fact_1461_square__diff__one__factored,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [X2: A] :
          ( ( minus_minus @ A @ ( times_times @ A @ X2 @ X2 ) @ ( one_one @ A ) )
          = ( times_times @ A @ ( plus_plus @ A @ X2 @ ( one_one @ A ) ) @ ( minus_minus @ A @ X2 @ ( one_one @ A ) ) ) ) ) ).

% square_diff_one_factored
thf(fact_1462_unit__imp__mod__eq__0,axiom,
    ! [A: $tType] :
      ( ( euclid3725896446679973847miring @ A )
     => ! [B2: A,A2: A] :
          ( ( dvd_dvd @ A @ B2 @ ( one_one @ A ) )
         => ( ( modulo_modulo @ A @ A2 @ B2 )
            = ( zero_zero @ A ) ) ) ) ).

% unit_imp_mod_eq_0
thf(fact_1463_is__unit__power__iff,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,N2: nat] :
          ( ( dvd_dvd @ A @ ( power_power @ A @ A2 @ N2 ) @ ( one_one @ A ) )
          = ( ( dvd_dvd @ A @ A2 @ ( one_one @ A ) )
            | ( N2
              = ( zero_zero @ nat ) ) ) ) ) ).

% is_unit_power_iff
thf(fact_1464_minus__div__mult__eq__mod,axiom,
    ! [A: $tType] :
      ( ( semiring_modulo @ A )
     => ! [A2: A,B2: A] :
          ( ( minus_minus @ A @ A2 @ ( times_times @ A @ ( divide_divide @ A @ A2 @ B2 ) @ B2 ) )
          = ( modulo_modulo @ A @ A2 @ B2 ) ) ) ).

% minus_div_mult_eq_mod
thf(fact_1465_minus__mod__eq__div__mult,axiom,
    ! [A: $tType] :
      ( ( semiring_modulo @ A )
     => ! [A2: A,B2: A] :
          ( ( minus_minus @ A @ A2 @ ( modulo_modulo @ A @ A2 @ B2 ) )
          = ( times_times @ A @ ( divide_divide @ A @ A2 @ B2 ) @ B2 ) ) ) ).

% minus_mod_eq_div_mult
thf(fact_1466_minus__mod__eq__mult__div,axiom,
    ! [A: $tType] :
      ( ( semiring_modulo @ A )
     => ! [A2: A,B2: A] :
          ( ( minus_minus @ A @ A2 @ ( modulo_modulo @ A @ A2 @ B2 ) )
          = ( times_times @ A @ B2 @ ( divide_divide @ A @ A2 @ B2 ) ) ) ) ).

% minus_mod_eq_mult_div
thf(fact_1467_minus__mult__div__eq__mod,axiom,
    ! [A: $tType] :
      ( ( semiring_modulo @ A )
     => ! [A2: A,B2: A] :
          ( ( minus_minus @ A @ A2 @ ( times_times @ A @ B2 @ ( divide_divide @ A @ A2 @ B2 ) ) )
          = ( modulo_modulo @ A @ A2 @ B2 ) ) ) ).

% minus_mult_div_eq_mod
thf(fact_1468_dvd__imp__le,axiom,
    ! [K: nat,N2: nat] :
      ( ( dvd_dvd @ nat @ K @ N2 )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
       => ( ord_less_eq @ nat @ K @ N2 ) ) ) ).

% dvd_imp_le
thf(fact_1469_nat__mult__dvd__cancel1,axiom,
    ! [K: nat,M: nat,N2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
     => ( ( dvd_dvd @ nat @ ( times_times @ nat @ K @ M ) @ ( times_times @ nat @ K @ N2 ) )
        = ( dvd_dvd @ nat @ M @ N2 ) ) ) ).

% nat_mult_dvd_cancel1
thf(fact_1470_dvd__mult__cancel,axiom,
    ! [K: nat,M: nat,N2: nat] :
      ( ( dvd_dvd @ nat @ ( times_times @ nat @ K @ M ) @ ( times_times @ nat @ K @ N2 ) )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
       => ( dvd_dvd @ nat @ M @ N2 ) ) ) ).

% dvd_mult_cancel
thf(fact_1471_bezout__add__strong__nat,axiom,
    ! [A2: nat,B2: nat] :
      ( ( A2
       != ( zero_zero @ nat ) )
     => ? [D4: nat,X3: nat,Y4: nat] :
          ( ( dvd_dvd @ nat @ D4 @ A2 )
          & ( dvd_dvd @ nat @ D4 @ B2 )
          & ( ( times_times @ nat @ A2 @ X3 )
            = ( plus_plus @ nat @ ( times_times @ nat @ B2 @ Y4 ) @ D4 ) ) ) ) ).

% bezout_add_strong_nat
thf(fact_1472_zdvd__imp__le,axiom,
    ! [Z: int,N2: int] :
      ( ( dvd_dvd @ int @ Z @ N2 )
     => ( ( ord_less @ int @ ( zero_zero @ int ) @ N2 )
       => ( ord_less_eq @ int @ Z @ N2 ) ) ) ).

% zdvd_imp_le
thf(fact_1473_mod__greater__zero__iff__not__dvd,axiom,
    ! [M: nat,N2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( modulo_modulo @ nat @ M @ N2 ) )
      = ( ~ ( dvd_dvd @ nat @ N2 @ M ) ) ) ).

% mod_greater_zero_iff_not_dvd
thf(fact_1474_minusinfinity,axiom,
    ! [D2: int,P1: int > $o,P: int > $o] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D2 )
     => ( ! [X3: int,K2: int] :
            ( ( P1 @ X3 )
            = ( P1 @ ( minus_minus @ int @ X3 @ ( times_times @ int @ K2 @ D2 ) ) ) )
       => ( ? [Z4: int] :
            ! [X3: int] :
              ( ( ord_less @ int @ X3 @ Z4 )
             => ( ( P @ X3 )
                = ( P1 @ X3 ) ) )
         => ( ? [X_1: int] : ( P1 @ X_1 )
           => ? [X_12: int] : ( P @ X_12 ) ) ) ) ) ).

% minusinfinity
thf(fact_1475_plusinfinity,axiom,
    ! [D2: int,P5: int > $o,P: int > $o] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D2 )
     => ( ! [X3: int,K2: int] :
            ( ( P5 @ X3 )
            = ( P5 @ ( minus_minus @ int @ X3 @ ( times_times @ int @ K2 @ D2 ) ) ) )
       => ( ? [Z4: int] :
            ! [X3: int] :
              ( ( ord_less @ int @ Z4 @ X3 )
             => ( ( P @ X3 )
                = ( P5 @ X3 ) ) )
         => ( ? [X_1: int] : ( P5 @ X_1 )
           => ? [X_12: int] : ( P @ X_12 ) ) ) ) ) ).

% plusinfinity
thf(fact_1476_int__induct,axiom,
    ! [P: int > $o,K: int,I3: int] :
      ( ( P @ K )
     => ( ! [I2: int] :
            ( ( ord_less_eq @ int @ K @ I2 )
           => ( ( P @ I2 )
             => ( P @ ( plus_plus @ int @ I2 @ ( one_one @ int ) ) ) ) )
       => ( ! [I2: int] :
              ( ( ord_less_eq @ int @ I2 @ K )
             => ( ( P @ I2 )
               => ( P @ ( minus_minus @ int @ I2 @ ( one_one @ int ) ) ) ) )
         => ( P @ I3 ) ) ) ) ).

% int_induct
thf(fact_1477_even__mask__div__iff_H,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [M: nat,N2: nat] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( divide_divide @ A @ ( minus_minus @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M ) @ ( one_one @ A ) ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N2 ) ) )
          = ( ord_less_eq @ nat @ M @ N2 ) ) ) ).

% even_mask_div_iff'
thf(fact_1478_even__mask__div__iff,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [M: nat,N2: nat] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( divide_divide @ A @ ( minus_minus @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M ) @ ( one_one @ A ) ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N2 ) ) )
          = ( ( ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N2 )
              = ( zero_zero @ A ) )
            | ( ord_less_eq @ nat @ M @ N2 ) ) ) ) ).

% even_mask_div_iff
thf(fact_1479_even__zero,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( zero_zero @ A ) ) ) ).

% even_zero
thf(fact_1480_is__unitE,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,C2: A] :
          ( ( dvd_dvd @ A @ A2 @ ( one_one @ A ) )
         => ~ ( ( A2
               != ( zero_zero @ A ) )
             => ! [B5: A] :
                  ( ( B5
                   != ( zero_zero @ A ) )
                 => ( ( dvd_dvd @ A @ B5 @ ( one_one @ A ) )
                   => ( ( ( divide_divide @ A @ ( one_one @ A ) @ A2 )
                        = B5 )
                     => ( ( ( divide_divide @ A @ ( one_one @ A ) @ B5 )
                          = A2 )
                       => ( ( ( times_times @ A @ A2 @ B5 )
                            = ( one_one @ A ) )
                         => ( ( divide_divide @ A @ C2 @ A2 )
                           != ( times_times @ A @ C2 @ B5 ) ) ) ) ) ) ) ) ) ) ).

% is_unitE
thf(fact_1481_is__unit__div__mult__cancel__left,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,B2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( dvd_dvd @ A @ B2 @ ( one_one @ A ) )
           => ( ( divide_divide @ A @ A2 @ ( times_times @ A @ A2 @ B2 ) )
              = ( divide_divide @ A @ ( one_one @ A ) @ B2 ) ) ) ) ) ).

% is_unit_div_mult_cancel_left
thf(fact_1482_is__unit__div__mult__cancel__right,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,B2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( dvd_dvd @ A @ B2 @ ( one_one @ A ) )
           => ( ( divide_divide @ A @ A2 @ ( times_times @ A @ B2 @ A2 ) )
              = ( divide_divide @ A @ ( one_one @ A ) @ B2 ) ) ) ) ) ).

% is_unit_div_mult_cancel_right
thf(fact_1483_evenE,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [A2: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
         => ~ ! [B5: A] :
                ( A2
               != ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B5 ) ) ) ) ).

% evenE
thf(fact_1484_odd__one,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( one_one @ A ) ) ) ).

% odd_one
thf(fact_1485_odd__even__add,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [A2: A,B2: A] :
          ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
         => ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B2 )
           => ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( plus_plus @ A @ A2 @ B2 ) ) ) ) ) ).

% odd_even_add
thf(fact_1486_frac__le__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [Y2: A,Z: A,X2: A,W: A] :
          ( ( Y2
           != ( zero_zero @ A ) )
         => ( ( Z
             != ( zero_zero @ A ) )
           => ( ( ord_less_eq @ A @ ( divide_divide @ A @ X2 @ Y2 ) @ ( divide_divide @ A @ W @ Z ) )
              = ( ord_less_eq @ A @ ( divide_divide @ A @ ( minus_minus @ A @ ( times_times @ A @ X2 @ Z ) @ ( times_times @ A @ W @ Y2 ) ) @ ( times_times @ A @ Y2 @ Z ) ) @ ( zero_zero @ A ) ) ) ) ) ) ).

% frac_le_eq
thf(fact_1487_bit__eq__rec,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ( ( ^ [Y3: A,Z2: A] : ( Y3 = Z2 ) )
        = ( ^ [A4: A,B4: A] :
              ( ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A4 )
                = ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B4 ) )
              & ( ( divide_divide @ A @ A4 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
                = ( divide_divide @ A @ B4 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% bit_eq_rec
thf(fact_1488_frac__less__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [Y2: A,Z: A,X2: A,W: A] :
          ( ( Y2
           != ( zero_zero @ A ) )
         => ( ( Z
             != ( zero_zero @ A ) )
           => ( ( ord_less @ A @ ( divide_divide @ A @ X2 @ Y2 ) @ ( divide_divide @ A @ W @ Z ) )
              = ( ord_less @ A @ ( divide_divide @ A @ ( minus_minus @ A @ ( times_times @ A @ X2 @ Z ) @ ( times_times @ A @ W @ Y2 ) ) @ ( times_times @ A @ Y2 @ Z ) ) @ ( zero_zero @ A ) ) ) ) ) ) ).

% frac_less_eq
thf(fact_1489_dvd__power__iff,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [X2: A,M: nat,N2: nat] :
          ( ( X2
           != ( zero_zero @ A ) )
         => ( ( dvd_dvd @ A @ ( power_power @ A @ X2 @ M ) @ ( power_power @ A @ X2 @ N2 ) )
            = ( ( dvd_dvd @ A @ X2 @ ( one_one @ A ) )
              | ( ord_less_eq @ nat @ M @ N2 ) ) ) ) ) ).

% dvd_power_iff
thf(fact_1490_dvd__power,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [N2: nat,X2: A] :
          ( ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
            | ( X2
              = ( one_one @ A ) ) )
         => ( dvd_dvd @ A @ X2 @ ( power_power @ A @ X2 @ N2 ) ) ) ) ).

% dvd_power
thf(fact_1491_power2__commute,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [X2: A,Y2: A] :
          ( ( power_power @ A @ ( minus_minus @ A @ X2 @ Y2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
          = ( power_power @ A @ ( minus_minus @ A @ Y2 @ X2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ).

% power2_commute
thf(fact_1492_even__even__mod__4__iff,axiom,
    ! [N2: nat] :
      ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 )
      = ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( modulo_modulo @ nat @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ ( bit0 @ one2 ) ) ) ) ) ) ).

% even_even_mod_4_iff
thf(fact_1493_dvd__mult__cancel1,axiom,
    ! [M: nat,N2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M )
     => ( ( dvd_dvd @ nat @ ( times_times @ nat @ M @ N2 ) @ M )
        = ( N2
          = ( one_one @ nat ) ) ) ) ).

% dvd_mult_cancel1
thf(fact_1494_dvd__mult__cancel2,axiom,
    ! [M: nat,N2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M )
     => ( ( dvd_dvd @ nat @ ( times_times @ nat @ N2 @ M ) @ M )
        = ( N2
          = ( one_one @ nat ) ) ) ) ).

% dvd_mult_cancel2
thf(fact_1495_power__dvd__imp__le,axiom,
    ! [I3: nat,M: nat,N2: nat] :
      ( ( dvd_dvd @ nat @ ( power_power @ nat @ I3 @ M ) @ ( power_power @ nat @ I3 @ N2 ) )
     => ( ( ord_less @ nat @ ( one_one @ nat ) @ I3 )
       => ( ord_less_eq @ nat @ M @ N2 ) ) ) ).

% power_dvd_imp_le
thf(fact_1496_decr__mult__lemma,axiom,
    ! [D2: int,P: int > $o,K: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D2 )
     => ( ! [X3: int] :
            ( ( P @ X3 )
           => ( P @ ( minus_minus @ int @ X3 @ D2 ) ) )
       => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ K )
         => ! [X: int] :
              ( ( P @ X )
             => ( P @ ( minus_minus @ int @ X @ ( times_times @ int @ K @ D2 ) ) ) ) ) ) ) ).

% decr_mult_lemma
thf(fact_1497_mod__int__pos__iff,axiom,
    ! [K: int,L: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( modulo_modulo @ int @ K @ L ) )
      = ( ( dvd_dvd @ int @ L @ K )
        | ( ( L
            = ( zero_zero @ int ) )
          & ( ord_less_eq @ int @ ( zero_zero @ int ) @ K ) )
        | ( ord_less @ int @ ( zero_zero @ int ) @ L ) ) ) ).

% mod_int_pos_iff
thf(fact_1498_mod__pos__geq,axiom,
    ! [L: int,K: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ L )
     => ( ( ord_less_eq @ int @ L @ K )
       => ( ( modulo_modulo @ int @ K @ L )
          = ( modulo_modulo @ int @ ( minus_minus @ int @ K @ L ) @ L ) ) ) ) ).

% mod_pos_geq
thf(fact_1499_even__two__times__div__two,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [A2: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
         => ( ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) )
            = A2 ) ) ) ).

% even_two_times_div_two
thf(fact_1500_scaling__mono,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [U: A,V: A,R3: A,S2: A] :
          ( ( ord_less_eq @ A @ U @ V )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ R3 )
           => ( ( ord_less_eq @ A @ R3 @ S2 )
             => ( ord_less_eq @ A @ ( plus_plus @ A @ U @ ( divide_divide @ A @ ( times_times @ A @ R3 @ ( minus_minus @ A @ V @ U ) ) @ S2 ) ) @ V ) ) ) ) ) ).

% scaling_mono
thf(fact_1501_even__iff__mod__2__eq__zero,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [A2: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
          = ( ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
            = ( zero_zero @ A ) ) ) ) ).

% even_iff_mod_2_eq_zero
thf(fact_1502_odd__iff__mod__2__eq__one,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [A2: A] :
          ( ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) )
          = ( ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
            = ( one_one @ A ) ) ) ) ).

% odd_iff_mod_2_eq_one
thf(fact_1503_power__mono__odd,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N2: nat,A2: A,B2: A] :
          ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 )
         => ( ( ord_less_eq @ A @ A2 @ B2 )
           => ( ord_less_eq @ A @ ( power_power @ A @ A2 @ N2 ) @ ( power_power @ A @ B2 @ N2 ) ) ) ) ) ).

% power_mono_odd
thf(fact_1504_odd__pos,axiom,
    ! [N2: nat] :
      ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 )
     => ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 ) ) ).

% odd_pos
thf(fact_1505_dvd__power__iff__le,axiom,
    ! [K: nat,M: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ K )
     => ( ( dvd_dvd @ nat @ ( power_power @ nat @ K @ M ) @ ( power_power @ nat @ K @ N2 ) )
        = ( ord_less_eq @ nat @ M @ N2 ) ) ) ).

% dvd_power_iff_le
thf(fact_1506_signed__take__bit__int__less__exp,axiom,
    ! [N2: nat,K: int] : ( ord_less @ int @ ( bit_ri4674362597316999326ke_bit @ int @ N2 @ K ) @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N2 ) ) ).

% signed_take_bit_int_less_exp
thf(fact_1507_even__unset__bit__iff,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M: nat,A2: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se2638667681897837118et_bit @ A @ M @ A2 ) )
          = ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
            | ( M
              = ( zero_zero @ nat ) ) ) ) ) ).

% even_unset_bit_iff
thf(fact_1508_even__set__bit__iff,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M: nat,A2: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se5668285175392031749et_bit @ A @ M @ A2 ) )
          = ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
            & ( M
             != ( zero_zero @ nat ) ) ) ) ) ).

% even_set_bit_iff
thf(fact_1509_even__flip__bit__iff,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M: nat,A2: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se8732182000553998342ip_bit @ A @ M @ A2 ) )
          = ( ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
             != ( M
                = ( zero_zero @ nat ) ) ) ) ) ) ).

% even_flip_bit_iff
thf(fact_1510_num_Osize__gen_I1_J,axiom,
    ( ( size_num @ one2 )
    = ( zero_zero @ nat ) ) ).

% num.size_gen(1)
thf(fact_1511_VEBT__internal_Onaive__member_Osimps_I3_J,axiom,
    ! [Uy2: option @ ( product_prod @ nat @ nat ),V: nat,TreeList: list @ vEBT_VEBT,S2: vEBT_VEBT,X2: nat] :
      ( ( vEBT_V5719532721284313246member @ ( vEBT_Node @ Uy2 @ ( suc @ V ) @ TreeList @ S2 ) @ X2 )
      = ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ X2 @ ( divide_divide @ nat @ ( suc @ V ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList ) )
         => ( vEBT_V5719532721284313246member @ ( nth @ vEBT_VEBT @ TreeList @ ( vEBT_VEBT_high @ X2 @ ( divide_divide @ nat @ ( suc @ V ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ X2 @ ( divide_divide @ nat @ ( suc @ V ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
        & ( ord_less @ nat @ ( vEBT_VEBT_high @ X2 @ ( divide_divide @ nat @ ( suc @ V ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList ) ) ) ) ).

% VEBT_internal.naive_member.simps(3)
thf(fact_1512_oddE,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [A2: A] :
          ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
         => ~ ! [B5: A] :
                ( A2
               != ( plus_plus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B5 ) @ ( one_one @ A ) ) ) ) ) ).

% oddE
thf(fact_1513_mod2__eq__if,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [A2: A] :
          ( ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
           => ( ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
              = ( zero_zero @ A ) ) )
          & ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
           => ( ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
              = ( one_one @ A ) ) ) ) ) ).

% mod2_eq_if
thf(fact_1514_parity__cases,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [A2: A] :
          ( ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
           => ( ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
             != ( zero_zero @ A ) ) )
         => ~ ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
             => ( ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
               != ( one_one @ A ) ) ) ) ) ).

% parity_cases
thf(fact_1515_zero__le__power__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A,N2: nat] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( power_power @ A @ A2 @ N2 ) )
          = ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 )
            | ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 )
              & ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 ) ) ) ) ) ).

% zero_le_power_eq
thf(fact_1516_zero__le__odd__power,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N2: nat,A2: A] :
          ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( power_power @ A @ A2 @ N2 ) )
            = ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 ) ) ) ) ).

% zero_le_odd_power
thf(fact_1517_zero__le__even__power,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N2: nat,A2: A] :
          ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 )
         => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( power_power @ A @ A2 @ N2 ) ) ) ) ).

% zero_le_even_power
thf(fact_1518_signed__take__bit__int__greater__eq__self__iff,axiom,
    ! [K: int,N2: nat] :
      ( ( ord_less_eq @ int @ K @ ( bit_ri4674362597316999326ke_bit @ int @ N2 @ K ) )
      = ( ord_less @ int @ K @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N2 ) ) ) ).

% signed_take_bit_int_greater_eq_self_iff
thf(fact_1519_signed__take__bit__int__less__self__iff,axiom,
    ! [N2: nat,K: int] :
      ( ( ord_less @ int @ ( bit_ri4674362597316999326ke_bit @ int @ N2 @ K ) @ K )
      = ( ord_less_eq @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N2 ) @ K ) ) ).

% signed_take_bit_int_less_self_iff
thf(fact_1520_VEBT__internal_Omembermima_Osimps_I5_J,axiom,
    ! [V: nat,TreeList: list @ vEBT_VEBT,Vd2: vEBT_VEBT,X2: nat] :
      ( ( vEBT_VEBT_membermima @ ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ V ) @ TreeList @ Vd2 ) @ X2 )
      = ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ X2 @ ( divide_divide @ nat @ ( suc @ V ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList ) )
         => ( vEBT_VEBT_membermima @ ( nth @ vEBT_VEBT @ TreeList @ ( vEBT_VEBT_high @ X2 @ ( divide_divide @ nat @ ( suc @ V ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ X2 @ ( divide_divide @ nat @ ( suc @ V ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
        & ( ord_less @ nat @ ( vEBT_VEBT_high @ X2 @ ( divide_divide @ nat @ ( suc @ V ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList ) ) ) ) ).

% VEBT_internal.membermima.simps(5)
thf(fact_1521_div__pos__geq,axiom,
    ! [L: int,K: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ L )
     => ( ( ord_less_eq @ int @ L @ K )
       => ( ( divide_divide @ int @ K @ L )
          = ( plus_plus @ int @ ( divide_divide @ int @ ( minus_minus @ int @ K @ L ) @ L ) @ ( one_one @ int ) ) ) ) ) ).

% div_pos_geq
thf(fact_1522_vebt__member_Osimps_I5_J,axiom,
    ! [Mi: nat,Ma: nat,Va3: nat,TreeList: list @ vEBT_VEBT,Summary: vEBT_VEBT,X2: nat] :
      ( ( vEBT_vebt_member @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi @ Ma ) ) @ ( suc @ ( suc @ Va3 ) ) @ TreeList @ Summary ) @ X2 )
      = ( ( X2 != Mi )
       => ( ( X2 != Ma )
         => ( ~ ( ord_less @ nat @ X2 @ Mi )
            & ( ~ ( ord_less @ nat @ X2 @ Mi )
             => ( ~ ( ord_less @ nat @ Ma @ X2 )
                & ( ~ ( ord_less @ nat @ Ma @ X2 )
                 => ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ X2 @ ( divide_divide @ nat @ ( suc @ ( suc @ Va3 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList ) )
                     => ( vEBT_vebt_member @ ( nth @ vEBT_VEBT @ TreeList @ ( vEBT_VEBT_high @ X2 @ ( divide_divide @ nat @ ( suc @ ( suc @ Va3 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ X2 @ ( divide_divide @ nat @ ( suc @ ( suc @ Va3 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                    & ( ord_less @ nat @ ( vEBT_VEBT_high @ X2 @ ( divide_divide @ nat @ ( suc @ ( suc @ Va3 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList ) ) ) ) ) ) ) ) ) ) ).

% vebt_member.simps(5)
thf(fact_1523_VEBT__internal_Omembermima_Osimps_I4_J,axiom,
    ! [Mi: nat,Ma: nat,V: nat,TreeList: list @ vEBT_VEBT,Vc: vEBT_VEBT,X2: nat] :
      ( ( vEBT_VEBT_membermima @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi @ Ma ) ) @ ( suc @ V ) @ TreeList @ Vc ) @ X2 )
      = ( ( X2 = Mi )
        | ( X2 = Ma )
        | ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ X2 @ ( divide_divide @ nat @ ( suc @ V ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList ) )
           => ( vEBT_VEBT_membermima @ ( nth @ vEBT_VEBT @ TreeList @ ( vEBT_VEBT_high @ X2 @ ( divide_divide @ nat @ ( suc @ V ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ X2 @ ( divide_divide @ nat @ ( suc @ V ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
          & ( ord_less @ nat @ ( vEBT_VEBT_high @ X2 @ ( divide_divide @ nat @ ( suc @ V ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList ) ) ) ) ) ).

% VEBT_internal.membermima.simps(4)
thf(fact_1524_add__0__iff,axiom,
    ! [A: $tType] :
      ( ( semiri1453513574482234551roduct @ A )
     => ! [B2: A,A2: A] :
          ( ( B2
            = ( plus_plus @ A @ B2 @ A2 ) )
          = ( A2
            = ( zero_zero @ A ) ) ) ) ).

% add_0_iff
thf(fact_1525_crossproduct__eq,axiom,
    ! [A: $tType] :
      ( ( semiri1453513574482234551roduct @ A )
     => ! [W: A,Y2: A,X2: A,Z: A] :
          ( ( ( plus_plus @ A @ ( times_times @ A @ W @ Y2 ) @ ( times_times @ A @ X2 @ Z ) )
            = ( plus_plus @ A @ ( times_times @ A @ W @ Z ) @ ( times_times @ A @ X2 @ Y2 ) ) )
          = ( ( W = X2 )
            | ( Y2 = Z ) ) ) ) ).

% crossproduct_eq
thf(fact_1526_crossproduct__noteq,axiom,
    ! [A: $tType] :
      ( ( semiri1453513574482234551roduct @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ( A2 != B2 )
            & ( C2 != D2 ) )
          = ( ( ( plus_plus @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ D2 ) )
             != ( plus_plus @ A @ ( times_times @ A @ A2 @ D2 ) @ ( times_times @ A @ B2 @ C2 ) ) ) ) ) ) ).

% crossproduct_noteq
thf(fact_1527_power2__diff,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [X2: A,Y2: A] :
          ( ( power_power @ A @ ( minus_minus @ A @ X2 @ Y2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
          = ( minus_minus @ A @ ( plus_plus @ A @ ( power_power @ A @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ A @ Y2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( times_times @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ X2 ) @ Y2 ) ) ) ) ).

% power2_diff
thf(fact_1528_zero__less__power__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A,N2: nat] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( power_power @ A @ A2 @ N2 ) )
          = ( ( N2
              = ( zero_zero @ nat ) )
            | ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 )
              & ( A2
               != ( zero_zero @ A ) ) )
            | ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 )
              & ( ord_less @ A @ ( zero_zero @ A ) @ A2 ) ) ) ) ) ).

% zero_less_power_eq
thf(fact_1529_VEBT__internal_Onaive__member_Oelims_I3_J,axiom,
    ! [X2: vEBT_VEBT,Xa2: nat] :
      ( ~ ( vEBT_V5719532721284313246member @ X2 @ Xa2 )
     => ( ! [A5: $o,B5: $o] :
            ( ( X2
              = ( vEBT_Leaf @ A5 @ B5 ) )
           => ( ( ( Xa2
                  = ( zero_zero @ nat ) )
               => A5 )
              & ( ( Xa2
                 != ( zero_zero @ nat ) )
               => ( ( ( Xa2
                      = ( one_one @ nat ) )
                   => B5 )
                  & ( Xa2
                    = ( one_one @ nat ) ) ) ) ) )
       => ( ! [Uu: option @ ( product_prod @ nat @ nat ),Uv: list @ vEBT_VEBT,Uw: vEBT_VEBT] :
              ( X2
             != ( vEBT_Node @ Uu @ ( zero_zero @ nat ) @ Uv @ Uw ) )
         => ~ ! [Uy: option @ ( product_prod @ nat @ nat ),V3: nat,TreeList2: list @ vEBT_VEBT] :
                ( ? [S: vEBT_VEBT] :
                    ( X2
                    = ( vEBT_Node @ Uy @ ( suc @ V3 ) @ TreeList2 @ S ) )
               => ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 ) )
                   => ( vEBT_V5719532721284313246member @ ( nth @ vEBT_VEBT @ TreeList2 @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                  & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 ) ) ) ) ) ) ) ).

% VEBT_internal.naive_member.elims(3)
thf(fact_1530_VEBT__internal_Onaive__member_Oelims_I2_J,axiom,
    ! [X2: vEBT_VEBT,Xa2: nat] :
      ( ( vEBT_V5719532721284313246member @ X2 @ Xa2 )
     => ( ! [A5: $o,B5: $o] :
            ( ( X2
              = ( vEBT_Leaf @ A5 @ B5 ) )
           => ~ ( ( ( Xa2
                    = ( zero_zero @ nat ) )
                 => A5 )
                & ( ( Xa2
                   != ( zero_zero @ nat ) )
                 => ( ( ( Xa2
                        = ( one_one @ nat ) )
                     => B5 )
                    & ( Xa2
                      = ( one_one @ nat ) ) ) ) ) )
       => ~ ! [Uy: option @ ( product_prod @ nat @ nat ),V3: nat,TreeList2: list @ vEBT_VEBT] :
              ( ? [S: vEBT_VEBT] :
                  ( X2
                  = ( vEBT_Node @ Uy @ ( suc @ V3 ) @ TreeList2 @ S ) )
             => ~ ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 ) )
                   => ( vEBT_V5719532721284313246member @ ( nth @ vEBT_VEBT @ TreeList2 @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                  & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 ) ) ) ) ) ) ).

% VEBT_internal.naive_member.elims(2)
thf(fact_1531_VEBT__internal_Onaive__member_Oelims_I1_J,axiom,
    ! [X2: vEBT_VEBT,Xa2: nat,Y2: $o] :
      ( ( ( vEBT_V5719532721284313246member @ X2 @ Xa2 )
        = Y2 )
     => ( ! [A5: $o,B5: $o] :
            ( ( X2
              = ( vEBT_Leaf @ A5 @ B5 ) )
           => ( Y2
              = ( ~ ( ( ( Xa2
                        = ( zero_zero @ nat ) )
                     => A5 )
                    & ( ( Xa2
                       != ( zero_zero @ nat ) )
                     => ( ( ( Xa2
                            = ( one_one @ nat ) )
                         => B5 )
                        & ( Xa2
                          = ( one_one @ nat ) ) ) ) ) ) ) )
       => ( ( ? [Uu: option @ ( product_prod @ nat @ nat ),Uv: list @ vEBT_VEBT,Uw: vEBT_VEBT] :
                ( X2
                = ( vEBT_Node @ Uu @ ( zero_zero @ nat ) @ Uv @ Uw ) )
           => Y2 )
         => ~ ! [Uy: option @ ( product_prod @ nat @ nat ),V3: nat,TreeList2: list @ vEBT_VEBT] :
                ( ? [S: vEBT_VEBT] :
                    ( X2
                    = ( vEBT_Node @ Uy @ ( suc @ V3 ) @ TreeList2 @ S ) )
               => ( Y2
                  = ( ~ ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 ) )
                         => ( vEBT_V5719532721284313246member @ ( nth @ vEBT_VEBT @ TreeList2 @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                        & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 ) ) ) ) ) ) ) ) ) ).

% VEBT_internal.naive_member.elims(1)
thf(fact_1532_VEBT__internal_Omembermima_Oelims_I2_J,axiom,
    ! [X2: vEBT_VEBT,Xa2: nat] :
      ( ( vEBT_VEBT_membermima @ X2 @ Xa2 )
     => ( ! [Mi2: nat,Ma2: nat] :
            ( ? [Va2: list @ vEBT_VEBT,Vb2: vEBT_VEBT] :
                ( X2
                = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ Ma2 ) ) @ ( zero_zero @ nat ) @ Va2 @ Vb2 ) )
           => ~ ( ( Xa2 = Mi2 )
                | ( Xa2 = Ma2 ) ) )
       => ( ! [Mi2: nat,Ma2: nat,V3: nat,TreeList2: list @ vEBT_VEBT] :
              ( ? [Vc2: vEBT_VEBT] :
                  ( X2
                  = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ Ma2 ) ) @ ( suc @ V3 ) @ TreeList2 @ Vc2 ) )
             => ~ ( ( Xa2 = Mi2 )
                  | ( Xa2 = Ma2 )
                  | ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 ) )
                     => ( vEBT_VEBT_membermima @ ( nth @ vEBT_VEBT @ TreeList2 @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                    & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 ) ) ) ) )
         => ~ ! [V3: nat,TreeList2: list @ vEBT_VEBT] :
                ( ? [Vd: vEBT_VEBT] :
                    ( X2
                    = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ V3 ) @ TreeList2 @ Vd ) )
               => ~ ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 ) )
                     => ( vEBT_VEBT_membermima @ ( nth @ vEBT_VEBT @ TreeList2 @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                    & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 ) ) ) ) ) ) ) ).

% VEBT_internal.membermima.elims(2)
thf(fact_1533_divmod__digit__1_I2_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ B2 )
           => ( ( ord_less_eq @ A @ B2 @ ( modulo_modulo @ A @ A2 @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B2 ) ) )
             => ( ( minus_minus @ A @ ( modulo_modulo @ A @ A2 @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B2 ) ) @ B2 )
                = ( modulo_modulo @ A @ A2 @ B2 ) ) ) ) ) ) ).

% divmod_digit_1(2)
thf(fact_1534_power__le__zero__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A,N2: nat] :
          ( ( ord_less_eq @ A @ ( power_power @ A @ A2 @ N2 ) @ ( zero_zero @ A ) )
          = ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
            & ( ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 )
                & ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) ) )
              | ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 )
                & ( A2
                  = ( zero_zero @ A ) ) ) ) ) ) ) ).

% power_le_zero_eq
thf(fact_1535_vebt__member_Oelims_I2_J,axiom,
    ! [X2: vEBT_VEBT,Xa2: nat] :
      ( ( vEBT_vebt_member @ X2 @ Xa2 )
     => ( ! [A5: $o,B5: $o] :
            ( ( X2
              = ( vEBT_Leaf @ A5 @ B5 ) )
           => ~ ( ( ( Xa2
                    = ( zero_zero @ nat ) )
                 => A5 )
                & ( ( Xa2
                   != ( zero_zero @ nat ) )
                 => ( ( ( Xa2
                        = ( one_one @ nat ) )
                     => B5 )
                    & ( Xa2
                      = ( one_one @ nat ) ) ) ) ) )
       => ~ ! [Mi2: nat,Ma2: nat,Va: nat,TreeList2: list @ vEBT_VEBT] :
              ( ? [Summary2: vEBT_VEBT] :
                  ( X2
                  = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ Ma2 ) ) @ ( suc @ ( suc @ Va ) ) @ TreeList2 @ Summary2 ) )
             => ~ ( ( Xa2 != Mi2 )
                 => ( ( Xa2 != Ma2 )
                   => ( ~ ( ord_less @ nat @ Xa2 @ Mi2 )
                      & ( ~ ( ord_less @ nat @ Xa2 @ Mi2 )
                       => ( ~ ( ord_less @ nat @ Ma2 @ Xa2 )
                          & ( ~ ( ord_less @ nat @ Ma2 @ Xa2 )
                           => ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 ) )
                               => ( vEBT_vebt_member @ ( nth @ vEBT_VEBT @ TreeList2 @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa2 @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                              & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 ) ) ) ) ) ) ) ) ) ) ) ) ).

% vebt_member.elims(2)
thf(fact_1536_VEBT__internal_Omembermima_Oelims_I3_J,axiom,
    ! [X2: vEBT_VEBT,Xa2: nat] :
      ( ~ ( vEBT_VEBT_membermima @ X2 @ Xa2 )
     => ( ! [Uu: $o,Uv: $o] :
            ( X2
           != ( vEBT_Leaf @ Uu @ Uv ) )
       => ( ! [Ux: list @ vEBT_VEBT,Uy: vEBT_VEBT] :
              ( X2
             != ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( zero_zero @ nat ) @ Ux @ Uy ) )
         => ( ! [Mi2: nat,Ma2: nat] :
                ( ? [Va2: list @ vEBT_VEBT,Vb2: vEBT_VEBT] :
                    ( X2
                    = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ Ma2 ) ) @ ( zero_zero @ nat ) @ Va2 @ Vb2 ) )
               => ( ( Xa2 = Mi2 )
                  | ( Xa2 = Ma2 ) ) )
           => ( ! [Mi2: nat,Ma2: nat,V3: nat,TreeList2: list @ vEBT_VEBT] :
                  ( ? [Vc2: vEBT_VEBT] :
                      ( X2
                      = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ Ma2 ) ) @ ( suc @ V3 ) @ TreeList2 @ Vc2 ) )
                 => ( ( Xa2 = Mi2 )
                    | ( Xa2 = Ma2 )
                    | ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 ) )
                       => ( vEBT_VEBT_membermima @ ( nth @ vEBT_VEBT @ TreeList2 @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                      & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 ) ) ) ) )
             => ~ ! [V3: nat,TreeList2: list @ vEBT_VEBT] :
                    ( ? [Vd: vEBT_VEBT] :
                        ( X2
                        = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ V3 ) @ TreeList2 @ Vd ) )
                   => ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 ) )
                       => ( vEBT_VEBT_membermima @ ( nth @ vEBT_VEBT @ TreeList2 @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                      & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 ) ) ) ) ) ) ) ) ) ).

% VEBT_internal.membermima.elims(3)
thf(fact_1537_VEBT__internal_Omembermima_Oelims_I1_J,axiom,
    ! [X2: vEBT_VEBT,Xa2: nat,Y2: $o] :
      ( ( ( vEBT_VEBT_membermima @ X2 @ Xa2 )
        = Y2 )
     => ( ( ? [Uu: $o,Uv: $o] :
              ( X2
              = ( vEBT_Leaf @ Uu @ Uv ) )
         => Y2 )
       => ( ( ? [Ux: list @ vEBT_VEBT,Uy: vEBT_VEBT] :
                ( X2
                = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( zero_zero @ nat ) @ Ux @ Uy ) )
           => Y2 )
         => ( ! [Mi2: nat,Ma2: nat] :
                ( ? [Va2: list @ vEBT_VEBT,Vb2: vEBT_VEBT] :
                    ( X2
                    = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ Ma2 ) ) @ ( zero_zero @ nat ) @ Va2 @ Vb2 ) )
               => ( Y2
                  = ( ~ ( ( Xa2 = Mi2 )
                        | ( Xa2 = Ma2 ) ) ) ) )
           => ( ! [Mi2: nat,Ma2: nat,V3: nat,TreeList2: list @ vEBT_VEBT] :
                  ( ? [Vc2: vEBT_VEBT] :
                      ( X2
                      = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ Ma2 ) ) @ ( suc @ V3 ) @ TreeList2 @ Vc2 ) )
                 => ( Y2
                    = ( ~ ( ( Xa2 = Mi2 )
                          | ( Xa2 = Ma2 )
                          | ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 ) )
                             => ( vEBT_VEBT_membermima @ ( nth @ vEBT_VEBT @ TreeList2 @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                            & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 ) ) ) ) ) ) )
             => ~ ! [V3: nat,TreeList2: list @ vEBT_VEBT] :
                    ( ? [Vd: vEBT_VEBT] :
                        ( X2
                        = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ V3 ) @ TreeList2 @ Vd ) )
                   => ( Y2
                      = ( ~ ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 ) )
                             => ( vEBT_VEBT_membermima @ ( nth @ vEBT_VEBT @ TreeList2 @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                            & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 ) ) ) ) ) ) ) ) ) ) ) ).

% VEBT_internal.membermima.elims(1)
thf(fact_1538_vebt__insert_Osimps_I5_J,axiom,
    ! [Mi: nat,Ma: nat,Va3: nat,TreeList: list @ vEBT_VEBT,Summary: vEBT_VEBT,X2: nat] :
      ( ( vEBT_vebt_insert @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi @ Ma ) ) @ ( suc @ ( suc @ Va3 ) ) @ TreeList @ Summary ) @ X2 )
      = ( if @ vEBT_VEBT
        @ ( ( ord_less @ nat @ ( vEBT_VEBT_high @ ( if @ nat @ ( ord_less @ nat @ X2 @ Mi ) @ Mi @ X2 ) @ ( divide_divide @ nat @ ( suc @ ( suc @ Va3 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList ) )
          & ~ ( ( X2 = Mi )
              | ( X2 = Ma ) ) )
        @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ ( if @ nat @ ( ord_less @ nat @ X2 @ Mi ) @ X2 @ Mi ) @ ( ord_max @ nat @ ( if @ nat @ ( ord_less @ nat @ X2 @ Mi ) @ Mi @ X2 ) @ Ma ) ) ) @ ( suc @ ( suc @ Va3 ) ) @ ( list_update @ vEBT_VEBT @ TreeList @ ( vEBT_VEBT_high @ ( if @ nat @ ( ord_less @ nat @ X2 @ Mi ) @ Mi @ X2 ) @ ( divide_divide @ nat @ ( suc @ ( suc @ Va3 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( vEBT_vebt_insert @ ( nth @ vEBT_VEBT @ TreeList @ ( vEBT_VEBT_high @ ( if @ nat @ ( ord_less @ nat @ X2 @ Mi ) @ Mi @ X2 ) @ ( divide_divide @ nat @ ( suc @ ( suc @ Va3 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ ( if @ nat @ ( ord_less @ nat @ X2 @ Mi ) @ Mi @ X2 ) @ ( divide_divide @ nat @ ( suc @ ( suc @ Va3 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) @ ( if @ vEBT_VEBT @ ( vEBT_VEBT_minNull @ ( nth @ vEBT_VEBT @ TreeList @ ( vEBT_VEBT_high @ ( if @ nat @ ( ord_less @ nat @ X2 @ Mi ) @ Mi @ X2 ) @ ( divide_divide @ nat @ ( suc @ ( suc @ Va3 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) @ ( vEBT_vebt_insert @ Summary @ ( vEBT_VEBT_high @ ( if @ nat @ ( ord_less @ nat @ X2 @ Mi ) @ Mi @ X2 ) @ ( divide_divide @ nat @ ( suc @ ( suc @ Va3 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ Summary ) )
        @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi @ Ma ) ) @ ( suc @ ( suc @ Va3 ) ) @ TreeList @ Summary ) ) ) ).

% vebt_insert.simps(5)
thf(fact_1539_vebt__member_Oelims_I3_J,axiom,
    ! [X2: vEBT_VEBT,Xa2: nat] :
      ( ~ ( vEBT_vebt_member @ X2 @ Xa2 )
     => ( ! [A5: $o,B5: $o] :
            ( ( X2
              = ( vEBT_Leaf @ A5 @ B5 ) )
           => ( ( ( Xa2
                  = ( zero_zero @ nat ) )
               => A5 )
              & ( ( Xa2
                 != ( zero_zero @ nat ) )
               => ( ( ( Xa2
                      = ( one_one @ nat ) )
                   => B5 )
                  & ( Xa2
                    = ( one_one @ nat ) ) ) ) ) )
       => ( ! [Uu: nat,Uv: list @ vEBT_VEBT,Uw: vEBT_VEBT] :
              ( X2
             != ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ Uu @ Uv @ Uw ) )
         => ( ! [V3: product_prod @ nat @ nat,Uy: list @ vEBT_VEBT,Uz: vEBT_VEBT] :
                ( X2
               != ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ V3 ) @ ( zero_zero @ nat ) @ Uy @ Uz ) )
           => ( ! [V3: product_prod @ nat @ nat,Vb2: list @ vEBT_VEBT,Vc2: vEBT_VEBT] :
                  ( X2
                 != ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ V3 ) @ ( suc @ ( zero_zero @ nat ) ) @ Vb2 @ Vc2 ) )
             => ~ ! [Mi2: nat,Ma2: nat,Va: nat,TreeList2: list @ vEBT_VEBT] :
                    ( ? [Summary2: vEBT_VEBT] :
                        ( X2
                        = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ Ma2 ) ) @ ( suc @ ( suc @ Va ) ) @ TreeList2 @ Summary2 ) )
                   => ( ( Xa2 != Mi2 )
                     => ( ( Xa2 != Ma2 )
                       => ( ~ ( ord_less @ nat @ Xa2 @ Mi2 )
                          & ( ~ ( ord_less @ nat @ Xa2 @ Mi2 )
                           => ( ~ ( ord_less @ nat @ Ma2 @ Xa2 )
                              & ( ~ ( ord_less @ nat @ Ma2 @ Xa2 )
                               => ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 ) )
                                   => ( vEBT_vebt_member @ ( nth @ vEBT_VEBT @ TreeList2 @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa2 @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                                  & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ).

% vebt_member.elims(3)
thf(fact_1540_vebt__member_Oelims_I1_J,axiom,
    ! [X2: vEBT_VEBT,Xa2: nat,Y2: $o] :
      ( ( ( vEBT_vebt_member @ X2 @ Xa2 )
        = Y2 )
     => ( ! [A5: $o,B5: $o] :
            ( ( X2
              = ( vEBT_Leaf @ A5 @ B5 ) )
           => ( Y2
              = ( ~ ( ( ( Xa2
                        = ( zero_zero @ nat ) )
                     => A5 )
                    & ( ( Xa2
                       != ( zero_zero @ nat ) )
                     => ( ( ( Xa2
                            = ( one_one @ nat ) )
                         => B5 )
                        & ( Xa2
                          = ( one_one @ nat ) ) ) ) ) ) ) )
       => ( ( ? [Uu: nat,Uv: list @ vEBT_VEBT,Uw: vEBT_VEBT] :
                ( X2
                = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ Uu @ Uv @ Uw ) )
           => Y2 )
         => ( ( ? [V3: product_prod @ nat @ nat,Uy: list @ vEBT_VEBT,Uz: vEBT_VEBT] :
                  ( X2
                  = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ V3 ) @ ( zero_zero @ nat ) @ Uy @ Uz ) )
             => Y2 )
           => ( ( ? [V3: product_prod @ nat @ nat,Vb2: list @ vEBT_VEBT,Vc2: vEBT_VEBT] :
                    ( X2
                    = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ V3 ) @ ( suc @ ( zero_zero @ nat ) ) @ Vb2 @ Vc2 ) )
               => Y2 )
             => ~ ! [Mi2: nat,Ma2: nat,Va: nat,TreeList2: list @ vEBT_VEBT] :
                    ( ? [Summary2: vEBT_VEBT] :
                        ( X2
                        = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ Ma2 ) ) @ ( suc @ ( suc @ Va ) ) @ TreeList2 @ Summary2 ) )
                   => ( Y2
                      = ( ~ ( ( Xa2 != Mi2 )
                           => ( ( Xa2 != Ma2 )
                             => ( ~ ( ord_less @ nat @ Xa2 @ Mi2 )
                                & ( ~ ( ord_less @ nat @ Xa2 @ Mi2 )
                                 => ( ~ ( ord_less @ nat @ Ma2 @ Xa2 )
                                    & ( ~ ( ord_less @ nat @ Ma2 @ Xa2 )
                                     => ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 ) )
                                         => ( vEBT_vebt_member @ ( nth @ vEBT_VEBT @ TreeList2 @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa2 @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                                        & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ).

% vebt_member.elims(1)
thf(fact_1541_neg__zmod__mult__2,axiom,
    ! [A2: int,B2: int] :
      ( ( ord_less_eq @ int @ A2 @ ( zero_zero @ int ) )
     => ( ( modulo_modulo @ int @ ( plus_plus @ int @ ( one_one @ int ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ B2 ) ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ A2 ) )
        = ( minus_minus @ int @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( modulo_modulo @ int @ ( plus_plus @ int @ B2 @ ( one_one @ int ) ) @ A2 ) ) @ ( one_one @ int ) ) ) ) ).

% neg_zmod_mult_2
thf(fact_1542_divmod__step__eq,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [L: num,R3: A,Q3: A] :
          ( ( ( ord_less_eq @ A @ ( numeral_numeral @ A @ L ) @ R3 )
           => ( ( unique1321980374590559556d_step @ A @ L @ ( product_Pair @ A @ A @ Q3 @ R3 ) )
              = ( product_Pair @ A @ A @ ( plus_plus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ Q3 ) @ ( one_one @ A ) ) @ ( minus_minus @ A @ R3 @ ( numeral_numeral @ A @ L ) ) ) ) )
          & ( ~ ( ord_less_eq @ A @ ( numeral_numeral @ A @ L ) @ R3 )
           => ( ( unique1321980374590559556d_step @ A @ L @ ( product_Pair @ A @ A @ Q3 @ R3 ) )
              = ( product_Pair @ A @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ Q3 ) @ R3 ) ) ) ) ) ).

% divmod_step_eq
thf(fact_1543_vebt__insert_Opelims,axiom,
    ! [X2: vEBT_VEBT,Xa2: nat,Y2: vEBT_VEBT] :
      ( ( ( vEBT_vebt_insert @ X2 @ Xa2 )
        = Y2 )
     => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_vebt_insert_rel @ ( product_Pair @ vEBT_VEBT @ nat @ X2 @ Xa2 ) )
       => ( ! [A5: $o,B5: $o] :
              ( ( X2
                = ( vEBT_Leaf @ A5 @ B5 ) )
             => ( ( ( ( Xa2
                      = ( zero_zero @ nat ) )
                   => ( Y2
                      = ( vEBT_Leaf @ $true @ B5 ) ) )
                  & ( ( Xa2
                     != ( zero_zero @ nat ) )
                   => ( ( ( Xa2
                          = ( one_one @ nat ) )
                       => ( Y2
                          = ( vEBT_Leaf @ A5 @ $true ) ) )
                      & ( ( Xa2
                         != ( one_one @ nat ) )
                       => ( Y2
                          = ( vEBT_Leaf @ A5 @ B5 ) ) ) ) ) )
               => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_vebt_insert_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Leaf @ A5 @ B5 ) @ Xa2 ) ) ) )
         => ( ! [Info2: option @ ( product_prod @ nat @ nat ),Ts2: list @ vEBT_VEBT,S: vEBT_VEBT] :
                ( ( X2
                  = ( vEBT_Node @ Info2 @ ( zero_zero @ nat ) @ Ts2 @ S ) )
               => ( ( Y2
                    = ( vEBT_Node @ Info2 @ ( zero_zero @ nat ) @ Ts2 @ S ) )
                 => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_vebt_insert_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ Info2 @ ( zero_zero @ nat ) @ Ts2 @ S ) @ Xa2 ) ) ) )
           => ( ! [Info2: option @ ( product_prod @ nat @ nat ),Ts2: list @ vEBT_VEBT,S: vEBT_VEBT] :
                  ( ( X2
                    = ( vEBT_Node @ Info2 @ ( suc @ ( zero_zero @ nat ) ) @ Ts2 @ S ) )
                 => ( ( Y2
                      = ( vEBT_Node @ Info2 @ ( suc @ ( zero_zero @ nat ) ) @ Ts2 @ S ) )
                   => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_vebt_insert_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ Info2 @ ( suc @ ( zero_zero @ nat ) ) @ Ts2 @ S ) @ Xa2 ) ) ) )
             => ( ! [V3: nat,TreeList2: list @ vEBT_VEBT,Summary2: vEBT_VEBT] :
                    ( ( X2
                      = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ ( suc @ V3 ) ) @ TreeList2 @ Summary2 ) )
                   => ( ( Y2
                        = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Xa2 @ Xa2 ) ) @ ( suc @ ( suc @ V3 ) ) @ TreeList2 @ Summary2 ) )
                     => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_vebt_insert_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ ( suc @ V3 ) ) @ TreeList2 @ Summary2 ) @ Xa2 ) ) ) )
               => ~ ! [Mi2: nat,Ma2: nat,Va: nat,TreeList2: list @ vEBT_VEBT,Summary2: vEBT_VEBT] :
                      ( ( X2
                        = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ Ma2 ) ) @ ( suc @ ( suc @ Va ) ) @ TreeList2 @ Summary2 ) )
                     => ( ( Y2
                          = ( if @ vEBT_VEBT
                            @ ( ( ord_less @ nat @ ( vEBT_VEBT_high @ ( if @ nat @ ( ord_less @ nat @ Xa2 @ Mi2 ) @ Mi2 @ Xa2 ) @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 ) )
                              & ~ ( ( Xa2 = Mi2 )
                                  | ( Xa2 = Ma2 ) ) )
                            @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ ( if @ nat @ ( ord_less @ nat @ Xa2 @ Mi2 ) @ Xa2 @ Mi2 ) @ ( ord_max @ nat @ ( if @ nat @ ( ord_less @ nat @ Xa2 @ Mi2 ) @ Mi2 @ Xa2 ) @ Ma2 ) ) ) @ ( suc @ ( suc @ Va ) ) @ ( list_update @ vEBT_VEBT @ TreeList2 @ ( vEBT_VEBT_high @ ( if @ nat @ ( ord_less @ nat @ Xa2 @ Mi2 ) @ Mi2 @ Xa2 ) @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( vEBT_vebt_insert @ ( nth @ vEBT_VEBT @ TreeList2 @ ( vEBT_VEBT_high @ ( if @ nat @ ( ord_less @ nat @ Xa2 @ Mi2 ) @ Mi2 @ Xa2 ) @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ ( if @ nat @ ( ord_less @ nat @ Xa2 @ Mi2 ) @ Mi2 @ Xa2 ) @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) @ ( if @ vEBT_VEBT @ ( vEBT_VEBT_minNull @ ( nth @ vEBT_VEBT @ TreeList2 @ ( vEBT_VEBT_high @ ( if @ nat @ ( ord_less @ nat @ Xa2 @ Mi2 ) @ Mi2 @ Xa2 ) @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) @ ( vEBT_vebt_insert @ Summary2 @ ( vEBT_VEBT_high @ ( if @ nat @ ( ord_less @ nat @ Xa2 @ Mi2 ) @ Mi2 @ Xa2 ) @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ Summary2 ) )
                            @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ Ma2 ) ) @ ( suc @ ( suc @ Va ) ) @ TreeList2 @ Summary2 ) ) )
                       => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_vebt_insert_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ Ma2 ) ) @ ( suc @ ( suc @ Va ) ) @ TreeList2 @ Summary2 ) @ Xa2 ) ) ) ) ) ) ) ) ) ) ).

% vebt_insert.pelims
thf(fact_1544_div2__even__ext__nat,axiom,
    ! [X2: nat,Y2: nat] :
      ( ( ( divide_divide @ nat @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
        = ( divide_divide @ nat @ Y2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
     => ( ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ X2 )
          = ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Y2 ) )
       => ( X2 = Y2 ) ) ) ).

% div2_even_ext_nat
thf(fact_1545_prod__cases4,axiom,
    ! [A: $tType,B: $tType,C: $tType,D: $tType,Y2: product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ D ) )] :
      ~ ! [A5: A,B5: B,C3: C,D4: D] :
          ( Y2
         != ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C @ D ) ) @ A5 @ ( product_Pair @ B @ ( product_prod @ C @ D ) @ B5 @ ( product_Pair @ C @ D @ C3 @ D4 ) ) ) ) ).

% prod_cases4
thf(fact_1546_prod__cases5,axiom,
    ! [A: $tType,B: $tType,C: $tType,D: $tType,E3: $tType,Y2: product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ E3 ) ) )] :
      ~ ! [A5: A,B5: B,C3: C,D4: D,E: E3] :
          ( Y2
         != ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ E3 ) ) ) @ A5 @ ( product_Pair @ B @ ( product_prod @ C @ ( product_prod @ D @ E3 ) ) @ B5 @ ( product_Pair @ C @ ( product_prod @ D @ E3 ) @ C3 @ ( product_Pair @ D @ E3 @ D4 @ E ) ) ) ) ) ).

% prod_cases5
thf(fact_1547_prod__cases6,axiom,
    ! [A: $tType,B: $tType,C: $tType,D: $tType,E3: $tType,F: $tType,Y2: product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E3 @ F ) ) ) )] :
      ~ ! [A5: A,B5: B,C3: C,D4: D,E: E3,F4: F] :
          ( Y2
         != ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E3 @ F ) ) ) ) @ A5 @ ( product_Pair @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E3 @ F ) ) ) @ B5 @ ( product_Pair @ C @ ( product_prod @ D @ ( product_prod @ E3 @ F ) ) @ C3 @ ( product_Pair @ D @ ( product_prod @ E3 @ F ) @ D4 @ ( product_Pair @ E3 @ F @ E @ F4 ) ) ) ) ) ) ).

% prod_cases6
thf(fact_1548_prod__cases7,axiom,
    ! [A: $tType,B: $tType,C: $tType,D: $tType,E3: $tType,F: $tType,G2: $tType,Y2: product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E3 @ ( product_prod @ F @ G2 ) ) ) ) )] :
      ~ ! [A5: A,B5: B,C3: C,D4: D,E: E3,F4: F,G3: G2] :
          ( Y2
         != ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E3 @ ( product_prod @ F @ G2 ) ) ) ) ) @ A5 @ ( product_Pair @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E3 @ ( product_prod @ F @ G2 ) ) ) ) @ B5 @ ( product_Pair @ C @ ( product_prod @ D @ ( product_prod @ E3 @ ( product_prod @ F @ G2 ) ) ) @ C3 @ ( product_Pair @ D @ ( product_prod @ E3 @ ( product_prod @ F @ G2 ) ) @ D4 @ ( product_Pair @ E3 @ ( product_prod @ F @ G2 ) @ E @ ( product_Pair @ F @ G2 @ F4 @ G3 ) ) ) ) ) ) ) ).

% prod_cases7
thf(fact_1549_prod__induct4,axiom,
    ! [D: $tType,C: $tType,B: $tType,A: $tType,P: ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ D ) ) ) > $o,X2: product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ D ) )] :
      ( ! [A5: A,B5: B,C3: C,D4: D] : ( P @ ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C @ D ) ) @ A5 @ ( product_Pair @ B @ ( product_prod @ C @ D ) @ B5 @ ( product_Pair @ C @ D @ C3 @ D4 ) ) ) )
     => ( P @ X2 ) ) ).

% prod_induct4
thf(fact_1550_old_Oprod_Oinject,axiom,
    ! [A: $tType,B: $tType,A2: A,B2: B,A6: A,B6: B] :
      ( ( ( product_Pair @ A @ B @ A2 @ B2 )
        = ( product_Pair @ A @ B @ A6 @ B6 ) )
      = ( ( A2 = A6 )
        & ( B2 = B6 ) ) ) ).

% old.prod.inject
thf(fact_1551_prod_Oinject,axiom,
    ! [A: $tType,B: $tType,X1: A,X22: B,Y1: A,Y22: B] :
      ( ( ( product_Pair @ A @ B @ X1 @ X22 )
        = ( product_Pair @ A @ B @ Y1 @ Y22 ) )
      = ( ( X1 = Y1 )
        & ( X22 = Y22 ) ) ) ).

% prod.inject
thf(fact_1552_Suc__diff__diff,axiom,
    ! [M: nat,N2: nat,K: nat] :
      ( ( minus_minus @ nat @ ( minus_minus @ nat @ ( suc @ M ) @ N2 ) @ ( suc @ K ) )
      = ( minus_minus @ nat @ ( minus_minus @ nat @ M @ N2 ) @ K ) ) ).

% Suc_diff_diff
thf(fact_1553_diff__Suc__Suc,axiom,
    ! [M: nat,N2: nat] :
      ( ( minus_minus @ nat @ ( suc @ M ) @ ( suc @ N2 ) )
      = ( minus_minus @ nat @ M @ N2 ) ) ).

% diff_Suc_Suc
thf(fact_1554_diff__self__eq__0,axiom,
    ! [M: nat] :
      ( ( minus_minus @ nat @ M @ M )
      = ( zero_zero @ nat ) ) ).

% diff_self_eq_0
thf(fact_1555_diff__0__eq__0,axiom,
    ! [N2: nat] :
      ( ( minus_minus @ nat @ ( zero_zero @ nat ) @ N2 )
      = ( zero_zero @ nat ) ) ).

% diff_0_eq_0
thf(fact_1556_diff__diff__cancel,axiom,
    ! [I3: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ I3 @ N2 )
     => ( ( minus_minus @ nat @ N2 @ ( minus_minus @ nat @ N2 @ I3 ) )
        = I3 ) ) ).

% diff_diff_cancel
thf(fact_1557_diff__diff__left,axiom,
    ! [I3: nat,J: nat,K: nat] :
      ( ( minus_minus @ nat @ ( minus_minus @ nat @ I3 @ J ) @ K )
      = ( minus_minus @ nat @ I3 @ ( plus_plus @ nat @ J @ K ) ) ) ).

% diff_diff_left
thf(fact_1558_idiff__0__right,axiom,
    ! [N2: extended_enat] :
      ( ( minus_minus @ extended_enat @ N2 @ ( zero_zero @ extended_enat ) )
      = N2 ) ).

% idiff_0_right
thf(fact_1559_idiff__0,axiom,
    ! [N2: extended_enat] :
      ( ( minus_minus @ extended_enat @ ( zero_zero @ extended_enat ) @ N2 )
      = ( zero_zero @ extended_enat ) ) ).

% idiff_0
thf(fact_1560_zero__less__diff,axiom,
    ! [N2: nat,M: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( minus_minus @ nat @ N2 @ M ) )
      = ( ord_less @ nat @ M @ N2 ) ) ).

% zero_less_diff
thf(fact_1561_diff__is__0__eq_H,axiom,
    ! [M: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ M @ N2 )
     => ( ( minus_minus @ nat @ M @ N2 )
        = ( zero_zero @ nat ) ) ) ).

% diff_is_0_eq'
thf(fact_1562_diff__is__0__eq,axiom,
    ! [M: nat,N2: nat] :
      ( ( ( minus_minus @ nat @ M @ N2 )
        = ( zero_zero @ nat ) )
      = ( ord_less_eq @ nat @ M @ N2 ) ) ).

% diff_is_0_eq
thf(fact_1563_Nat_Odiff__diff__right,axiom,
    ! [K: nat,J: nat,I3: nat] :
      ( ( ord_less_eq @ nat @ K @ J )
     => ( ( minus_minus @ nat @ I3 @ ( minus_minus @ nat @ J @ K ) )
        = ( minus_minus @ nat @ ( plus_plus @ nat @ I3 @ K ) @ J ) ) ) ).

% Nat.diff_diff_right
thf(fact_1564_Nat_Oadd__diff__assoc2,axiom,
    ! [K: nat,J: nat,I3: nat] :
      ( ( ord_less_eq @ nat @ K @ J )
     => ( ( plus_plus @ nat @ ( minus_minus @ nat @ J @ K ) @ I3 )
        = ( minus_minus @ nat @ ( plus_plus @ nat @ J @ I3 ) @ K ) ) ) ).

% Nat.add_diff_assoc2
thf(fact_1565_Nat_Oadd__diff__assoc,axiom,
    ! [K: nat,J: nat,I3: nat] :
      ( ( ord_less_eq @ nat @ K @ J )
     => ( ( plus_plus @ nat @ I3 @ ( minus_minus @ nat @ J @ K ) )
        = ( minus_minus @ nat @ ( plus_plus @ nat @ I3 @ J ) @ K ) ) ) ).

% Nat.add_diff_assoc
thf(fact_1566_diff__Suc__1,axiom,
    ! [N2: nat] :
      ( ( minus_minus @ nat @ ( suc @ N2 ) @ ( one_one @ nat ) )
      = N2 ) ).

% diff_Suc_1
thf(fact_1567_Suc__pred,axiom,
    ! [N2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( suc @ ( minus_minus @ nat @ N2 @ ( suc @ ( zero_zero @ nat ) ) ) )
        = N2 ) ) ).

% Suc_pred
thf(fact_1568_diff__Suc__diff__eq2,axiom,
    ! [K: nat,J: nat,I3: nat] :
      ( ( ord_less_eq @ nat @ K @ J )
     => ( ( minus_minus @ nat @ ( suc @ ( minus_minus @ nat @ J @ K ) ) @ I3 )
        = ( minus_minus @ nat @ ( suc @ J ) @ ( plus_plus @ nat @ K @ I3 ) ) ) ) ).

% diff_Suc_diff_eq2
thf(fact_1569_diff__Suc__diff__eq1,axiom,
    ! [K: nat,J: nat,I3: nat] :
      ( ( ord_less_eq @ nat @ K @ J )
     => ( ( minus_minus @ nat @ I3 @ ( suc @ ( minus_minus @ nat @ J @ K ) ) )
        = ( minus_minus @ nat @ ( plus_plus @ nat @ I3 @ K ) @ ( suc @ J ) ) ) ) ).

% diff_Suc_diff_eq1
thf(fact_1570_Suc__diff__1,axiom,
    ! [N2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( suc @ ( minus_minus @ nat @ N2 @ ( one_one @ nat ) ) )
        = N2 ) ) ).

% Suc_diff_1
thf(fact_1571_odd__Suc__minus__one,axiom,
    ! [N2: nat] :
      ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 )
     => ( ( suc @ ( minus_minus @ nat @ N2 @ ( suc @ ( zero_zero @ nat ) ) ) )
        = N2 ) ) ).

% odd_Suc_minus_one
thf(fact_1572_even__diff__nat,axiom,
    ! [M: nat,N2: nat] :
      ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ M @ N2 ) )
      = ( ( ord_less @ nat @ M @ N2 )
        | ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( plus_plus @ nat @ M @ N2 ) ) ) ) ).

% even_diff_nat
thf(fact_1573_odd__two__times__div__two__nat,axiom,
    ! [N2: nat] :
      ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 )
     => ( ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( divide_divide @ nat @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
        = ( minus_minus @ nat @ N2 @ ( one_one @ nat ) ) ) ) ).

% odd_two_times_div_two_nat
thf(fact_1574_dvd__diff__nat,axiom,
    ! [K: nat,M: nat,N2: nat] :
      ( ( dvd_dvd @ nat @ K @ M )
     => ( ( dvd_dvd @ nat @ K @ N2 )
       => ( dvd_dvd @ nat @ K @ ( minus_minus @ nat @ M @ N2 ) ) ) ) ).

% dvd_diff_nat
thf(fact_1575_dvd__antisym,axiom,
    ! [M: nat,N2: nat] :
      ( ( dvd_dvd @ nat @ M @ N2 )
     => ( ( dvd_dvd @ nat @ N2 @ M )
       => ( M = N2 ) ) ) ).

% dvd_antisym
thf(fact_1576_zero__induct__lemma,axiom,
    ! [P: nat > $o,K: nat,I3: nat] :
      ( ( P @ K )
     => ( ! [N: nat] :
            ( ( P @ ( suc @ N ) )
           => ( P @ N ) )
       => ( P @ ( minus_minus @ nat @ K @ I3 ) ) ) ) ).

% zero_induct_lemma
thf(fact_1577_diffs0__imp__equal,axiom,
    ! [M: nat,N2: nat] :
      ( ( ( minus_minus @ nat @ M @ N2 )
        = ( zero_zero @ nat ) )
     => ( ( ( minus_minus @ nat @ N2 @ M )
          = ( zero_zero @ nat ) )
       => ( M = N2 ) ) ) ).

% diffs0_imp_equal
thf(fact_1578_minus__nat_Odiff__0,axiom,
    ! [M: nat] :
      ( ( minus_minus @ nat @ M @ ( zero_zero @ nat ) )
      = M ) ).

% minus_nat.diff_0
thf(fact_1579_less__imp__diff__less,axiom,
    ! [J: nat,K: nat,N2: nat] :
      ( ( ord_less @ nat @ J @ K )
     => ( ord_less @ nat @ ( minus_minus @ nat @ J @ N2 ) @ K ) ) ).

% less_imp_diff_less
thf(fact_1580_diff__less__mono2,axiom,
    ! [M: nat,N2: nat,L: nat] :
      ( ( ord_less @ nat @ M @ N2 )
     => ( ( ord_less @ nat @ M @ L )
       => ( ord_less @ nat @ ( minus_minus @ nat @ L @ N2 ) @ ( minus_minus @ nat @ L @ M ) ) ) ) ).

% diff_less_mono2
thf(fact_1581_dvd__minus__self,axiom,
    ! [M: nat,N2: nat] :
      ( ( dvd_dvd @ nat @ M @ ( minus_minus @ nat @ N2 @ M ) )
      = ( ( ord_less @ nat @ N2 @ M )
        | ( dvd_dvd @ nat @ M @ N2 ) ) ) ).

% dvd_minus_self
thf(fact_1582_diff__le__mono2,axiom,
    ! [M: nat,N2: nat,L: nat] :
      ( ( ord_less_eq @ nat @ M @ N2 )
     => ( ord_less_eq @ nat @ ( minus_minus @ nat @ L @ N2 ) @ ( minus_minus @ nat @ L @ M ) ) ) ).

% diff_le_mono2
thf(fact_1583_le__diff__iff_H,axiom,
    ! [A2: nat,C2: nat,B2: nat] :
      ( ( ord_less_eq @ nat @ A2 @ C2 )
     => ( ( ord_less_eq @ nat @ B2 @ C2 )
       => ( ( ord_less_eq @ nat @ ( minus_minus @ nat @ C2 @ A2 ) @ ( minus_minus @ nat @ C2 @ B2 ) )
          = ( ord_less_eq @ nat @ B2 @ A2 ) ) ) ) ).

% le_diff_iff'
thf(fact_1584_diff__le__self,axiom,
    ! [M: nat,N2: nat] : ( ord_less_eq @ nat @ ( minus_minus @ nat @ M @ N2 ) @ M ) ).

% diff_le_self
thf(fact_1585_diff__le__mono,axiom,
    ! [M: nat,N2: nat,L: nat] :
      ( ( ord_less_eq @ nat @ M @ N2 )
     => ( ord_less_eq @ nat @ ( minus_minus @ nat @ M @ L ) @ ( minus_minus @ nat @ N2 @ L ) ) ) ).

% diff_le_mono
thf(fact_1586_Nat_Odiff__diff__eq,axiom,
    ! [K: nat,M: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ K @ M )
     => ( ( ord_less_eq @ nat @ K @ N2 )
       => ( ( minus_minus @ nat @ ( minus_minus @ nat @ M @ K ) @ ( minus_minus @ nat @ N2 @ K ) )
          = ( minus_minus @ nat @ M @ N2 ) ) ) ) ).

% Nat.diff_diff_eq
thf(fact_1587_le__diff__iff,axiom,
    ! [K: nat,M: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ K @ M )
     => ( ( ord_less_eq @ nat @ K @ N2 )
       => ( ( ord_less_eq @ nat @ ( minus_minus @ nat @ M @ K ) @ ( minus_minus @ nat @ N2 @ K ) )
          = ( ord_less_eq @ nat @ M @ N2 ) ) ) ) ).

% le_diff_iff
thf(fact_1588_eq__diff__iff,axiom,
    ! [K: nat,M: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ K @ M )
     => ( ( ord_less_eq @ nat @ K @ N2 )
       => ( ( ( minus_minus @ nat @ M @ K )
            = ( minus_minus @ nat @ N2 @ K ) )
          = ( M = N2 ) ) ) ) ).

% eq_diff_iff
thf(fact_1589_less__eq__dvd__minus,axiom,
    ! [M: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ M @ N2 )
     => ( ( dvd_dvd @ nat @ M @ N2 )
        = ( dvd_dvd @ nat @ M @ ( minus_minus @ nat @ N2 @ M ) ) ) ) ).

% less_eq_dvd_minus
thf(fact_1590_dvd__diffD1,axiom,
    ! [K: nat,M: nat,N2: nat] :
      ( ( dvd_dvd @ nat @ K @ ( minus_minus @ nat @ M @ N2 ) )
     => ( ( dvd_dvd @ nat @ K @ M )
       => ( ( ord_less_eq @ nat @ N2 @ M )
         => ( dvd_dvd @ nat @ K @ N2 ) ) ) ) ).

% dvd_diffD1
thf(fact_1591_dvd__diffD,axiom,
    ! [K: nat,M: nat,N2: nat] :
      ( ( dvd_dvd @ nat @ K @ ( minus_minus @ nat @ M @ N2 ) )
     => ( ( dvd_dvd @ nat @ K @ N2 )
       => ( ( ord_less_eq @ nat @ N2 @ M )
         => ( dvd_dvd @ nat @ K @ M ) ) ) ) ).

% dvd_diffD
thf(fact_1592_diff__add__inverse2,axiom,
    ! [M: nat,N2: nat] :
      ( ( minus_minus @ nat @ ( plus_plus @ nat @ M @ N2 ) @ N2 )
      = M ) ).

% diff_add_inverse2
thf(fact_1593_diff__add__inverse,axiom,
    ! [N2: nat,M: nat] :
      ( ( minus_minus @ nat @ ( plus_plus @ nat @ N2 @ M ) @ N2 )
      = M ) ).

% diff_add_inverse
thf(fact_1594_diff__cancel2,axiom,
    ! [M: nat,K: nat,N2: nat] :
      ( ( minus_minus @ nat @ ( plus_plus @ nat @ M @ K ) @ ( plus_plus @ nat @ N2 @ K ) )
      = ( minus_minus @ nat @ M @ N2 ) ) ).

% diff_cancel2
thf(fact_1595_Nat_Odiff__cancel,axiom,
    ! [K: nat,M: nat,N2: nat] :
      ( ( minus_minus @ nat @ ( plus_plus @ nat @ K @ M ) @ ( plus_plus @ nat @ K @ N2 ) )
      = ( minus_minus @ nat @ M @ N2 ) ) ).

% Nat.diff_cancel
thf(fact_1596_diff__mult__distrib,axiom,
    ! [M: nat,N2: nat,K: nat] :
      ( ( times_times @ nat @ ( minus_minus @ nat @ M @ N2 ) @ K )
      = ( minus_minus @ nat @ ( times_times @ nat @ M @ K ) @ ( times_times @ nat @ N2 @ K ) ) ) ).

% diff_mult_distrib
thf(fact_1597_diff__mult__distrib2,axiom,
    ! [K: nat,M: nat,N2: nat] :
      ( ( times_times @ nat @ K @ ( minus_minus @ nat @ M @ N2 ) )
      = ( minus_minus @ nat @ ( times_times @ nat @ K @ M ) @ ( times_times @ nat @ K @ N2 ) ) ) ).

% diff_mult_distrib2
thf(fact_1598_bezout1__nat,axiom,
    ! [A2: nat,B2: nat] :
    ? [D4: nat,X3: nat,Y4: nat] :
      ( ( dvd_dvd @ nat @ D4 @ A2 )
      & ( dvd_dvd @ nat @ D4 @ B2 )
      & ( ( ( minus_minus @ nat @ ( times_times @ nat @ A2 @ X3 ) @ ( times_times @ nat @ B2 @ Y4 ) )
          = D4 )
        | ( ( minus_minus @ nat @ ( times_times @ nat @ B2 @ X3 ) @ ( times_times @ nat @ A2 @ Y4 ) )
          = D4 ) ) ) ).

% bezout1_nat
thf(fact_1599_diff__less__Suc,axiom,
    ! [M: nat,N2: nat] : ( ord_less @ nat @ ( minus_minus @ nat @ M @ N2 ) @ ( suc @ M ) ) ).

% diff_less_Suc
thf(fact_1600_Suc__diff__Suc,axiom,
    ! [N2: nat,M: nat] :
      ( ( ord_less @ nat @ N2 @ M )
     => ( ( suc @ ( minus_minus @ nat @ M @ ( suc @ N2 ) ) )
        = ( minus_minus @ nat @ M @ N2 ) ) ) ).

% Suc_diff_Suc
thf(fact_1601_diff__less,axiom,
    ! [N2: nat,M: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M )
       => ( ord_less @ nat @ ( minus_minus @ nat @ M @ N2 ) @ M ) ) ) ).

% diff_less
thf(fact_1602_Suc__diff__le,axiom,
    ! [N2: nat,M: nat] :
      ( ( ord_less_eq @ nat @ N2 @ M )
     => ( ( minus_minus @ nat @ ( suc @ M ) @ N2 )
        = ( suc @ ( minus_minus @ nat @ M @ N2 ) ) ) ) ).

% Suc_diff_le
thf(fact_1603_diff__less__mono,axiom,
    ! [A2: nat,B2: nat,C2: nat] :
      ( ( ord_less @ nat @ A2 @ B2 )
     => ( ( ord_less_eq @ nat @ C2 @ A2 )
       => ( ord_less @ nat @ ( minus_minus @ nat @ A2 @ C2 ) @ ( minus_minus @ nat @ B2 @ C2 ) ) ) ) ).

% diff_less_mono
thf(fact_1604_less__diff__iff,axiom,
    ! [K: nat,M: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ K @ M )
     => ( ( ord_less_eq @ nat @ K @ N2 )
       => ( ( ord_less @ nat @ ( minus_minus @ nat @ M @ K ) @ ( minus_minus @ nat @ N2 @ K ) )
          = ( ord_less @ nat @ M @ N2 ) ) ) ) ).

% less_diff_iff
thf(fact_1605_diff__add__0,axiom,
    ! [N2: nat,M: nat] :
      ( ( minus_minus @ nat @ N2 @ ( plus_plus @ nat @ N2 @ M ) )
      = ( zero_zero @ nat ) ) ).

% diff_add_0
thf(fact_1606_add__diff__inverse__nat,axiom,
    ! [M: nat,N2: nat] :
      ( ~ ( ord_less @ nat @ M @ N2 )
     => ( ( plus_plus @ nat @ N2 @ ( minus_minus @ nat @ M @ N2 ) )
        = M ) ) ).

% add_diff_inverse_nat
thf(fact_1607_less__diff__conv,axiom,
    ! [I3: nat,J: nat,K: nat] :
      ( ( ord_less @ nat @ I3 @ ( minus_minus @ nat @ J @ K ) )
      = ( ord_less @ nat @ ( plus_plus @ nat @ I3 @ K ) @ J ) ) ).

% less_diff_conv
thf(fact_1608_Nat_Ole__imp__diff__is__add,axiom,
    ! [I3: nat,J: nat,K: nat] :
      ( ( ord_less_eq @ nat @ I3 @ J )
     => ( ( ( minus_minus @ nat @ J @ I3 )
          = K )
        = ( J
          = ( plus_plus @ nat @ K @ I3 ) ) ) ) ).

% Nat.le_imp_diff_is_add
thf(fact_1609_Nat_Odiff__add__assoc2,axiom,
    ! [K: nat,J: nat,I3: nat] :
      ( ( ord_less_eq @ nat @ K @ J )
     => ( ( minus_minus @ nat @ ( plus_plus @ nat @ J @ I3 ) @ K )
        = ( plus_plus @ nat @ ( minus_minus @ nat @ J @ K ) @ I3 ) ) ) ).

% Nat.diff_add_assoc2
thf(fact_1610_Nat_Odiff__add__assoc,axiom,
    ! [K: nat,J: nat,I3: nat] :
      ( ( ord_less_eq @ nat @ K @ J )
     => ( ( minus_minus @ nat @ ( plus_plus @ nat @ I3 @ J ) @ K )
        = ( plus_plus @ nat @ I3 @ ( minus_minus @ nat @ J @ K ) ) ) ) ).

% Nat.diff_add_assoc
thf(fact_1611_Nat_Ole__diff__conv2,axiom,
    ! [K: nat,J: nat,I3: nat] :
      ( ( ord_less_eq @ nat @ K @ J )
     => ( ( ord_less_eq @ nat @ I3 @ ( minus_minus @ nat @ J @ K ) )
        = ( ord_less_eq @ nat @ ( plus_plus @ nat @ I3 @ K ) @ J ) ) ) ).

% Nat.le_diff_conv2
thf(fact_1612_le__diff__conv,axiom,
    ! [J: nat,K: nat,I3: nat] :
      ( ( ord_less_eq @ nat @ ( minus_minus @ nat @ J @ K ) @ I3 )
      = ( ord_less_eq @ nat @ J @ ( plus_plus @ nat @ I3 @ K ) ) ) ).

% le_diff_conv
thf(fact_1613_diff__Suc__eq__diff__pred,axiom,
    ! [M: nat,N2: nat] :
      ( ( minus_minus @ nat @ M @ ( suc @ N2 ) )
      = ( minus_minus @ nat @ ( minus_minus @ nat @ M @ ( one_one @ nat ) ) @ N2 ) ) ).

% diff_Suc_eq_diff_pred
thf(fact_1614_mod__geq,axiom,
    ! [M: nat,N2: nat] :
      ( ~ ( ord_less @ nat @ M @ N2 )
     => ( ( modulo_modulo @ nat @ M @ N2 )
        = ( modulo_modulo @ nat @ ( minus_minus @ nat @ M @ N2 ) @ N2 ) ) ) ).

% mod_geq
thf(fact_1615_mod__if,axiom,
    ( ( modulo_modulo @ nat )
    = ( ^ [M6: nat,N3: nat] : ( if @ nat @ ( ord_less @ nat @ M6 @ N3 ) @ M6 @ ( modulo_modulo @ nat @ ( minus_minus @ nat @ M6 @ N3 ) @ N3 ) ) ) ) ).

% mod_if
thf(fact_1616_le__mod__geq,axiom,
    ! [N2: nat,M: nat] :
      ( ( ord_less_eq @ nat @ N2 @ M )
     => ( ( modulo_modulo @ nat @ M @ N2 )
        = ( modulo_modulo @ nat @ ( minus_minus @ nat @ M @ N2 ) @ N2 ) ) ) ).

% le_mod_geq
thf(fact_1617_mod__eq__dvd__iff__nat,axiom,
    ! [N2: nat,M: nat,Q3: nat] :
      ( ( ord_less_eq @ nat @ N2 @ M )
     => ( ( ( modulo_modulo @ nat @ M @ Q3 )
          = ( modulo_modulo @ nat @ N2 @ Q3 ) )
        = ( dvd_dvd @ nat @ Q3 @ ( minus_minus @ nat @ M @ N2 ) ) ) ) ).

% mod_eq_dvd_iff_nat
thf(fact_1618_nat__minus__add__max,axiom,
    ! [N2: nat,M: nat] :
      ( ( plus_plus @ nat @ ( minus_minus @ nat @ N2 @ M ) @ M )
      = ( ord_max @ nat @ N2 @ M ) ) ).

% nat_minus_add_max
thf(fact_1619_add__diff__assoc__enat,axiom,
    ! [Z: extended_enat,Y2: extended_enat,X2: extended_enat] :
      ( ( ord_less_eq @ extended_enat @ Z @ Y2 )
     => ( ( plus_plus @ extended_enat @ X2 @ ( minus_minus @ extended_enat @ Y2 @ Z ) )
        = ( minus_minus @ extended_enat @ ( plus_plus @ extended_enat @ X2 @ Y2 ) @ Z ) ) ) ).

% add_diff_assoc_enat
thf(fact_1620_diff__Suc__less,axiom,
    ! [N2: nat,I3: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ord_less @ nat @ ( minus_minus @ nat @ N2 @ ( suc @ I3 ) ) @ N2 ) ) ).

% diff_Suc_less
thf(fact_1621_nat__diff__split__asm,axiom,
    ! [P: nat > $o,A2: nat,B2: nat] :
      ( ( P @ ( minus_minus @ nat @ A2 @ B2 ) )
      = ( ~ ( ( ( ord_less @ nat @ A2 @ B2 )
              & ~ ( P @ ( zero_zero @ nat ) ) )
            | ? [D3: nat] :
                ( ( A2
                  = ( plus_plus @ nat @ B2 @ D3 ) )
                & ~ ( P @ D3 ) ) ) ) ) ).

% nat_diff_split_asm
thf(fact_1622_nat__diff__split,axiom,
    ! [P: nat > $o,A2: nat,B2: nat] :
      ( ( P @ ( minus_minus @ nat @ A2 @ B2 ) )
      = ( ( ( ord_less @ nat @ A2 @ B2 )
         => ( P @ ( zero_zero @ nat ) ) )
        & ! [D3: nat] :
            ( ( A2
              = ( plus_plus @ nat @ B2 @ D3 ) )
           => ( P @ D3 ) ) ) ) ).

% nat_diff_split
thf(fact_1623_less__diff__conv2,axiom,
    ! [K: nat,J: nat,I3: nat] :
      ( ( ord_less_eq @ nat @ K @ J )
     => ( ( ord_less @ nat @ ( minus_minus @ nat @ J @ K ) @ I3 )
        = ( ord_less @ nat @ J @ ( plus_plus @ nat @ I3 @ K ) ) ) ) ).

% less_diff_conv2
thf(fact_1624_nat__diff__add__eq2,axiom,
    ! [I3: nat,J: nat,U: nat,M: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ I3 @ J )
     => ( ( minus_minus @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ I3 @ U ) @ M ) @ ( plus_plus @ nat @ ( times_times @ nat @ J @ U ) @ N2 ) )
        = ( minus_minus @ nat @ M @ ( plus_plus @ nat @ ( times_times @ nat @ ( minus_minus @ nat @ J @ I3 ) @ U ) @ N2 ) ) ) ) ).

% nat_diff_add_eq2
thf(fact_1625_nat__diff__add__eq1,axiom,
    ! [J: nat,I3: nat,U: nat,M: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ J @ I3 )
     => ( ( minus_minus @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ I3 @ U ) @ M ) @ ( plus_plus @ nat @ ( times_times @ nat @ J @ U ) @ N2 ) )
        = ( minus_minus @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ ( minus_minus @ nat @ I3 @ J ) @ U ) @ M ) @ N2 ) ) ) ).

% nat_diff_add_eq1
thf(fact_1626_nat__le__add__iff2,axiom,
    ! [I3: nat,J: nat,U: nat,M: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ I3 @ J )
     => ( ( ord_less_eq @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ I3 @ U ) @ M ) @ ( plus_plus @ nat @ ( times_times @ nat @ J @ U ) @ N2 ) )
        = ( ord_less_eq @ nat @ M @ ( plus_plus @ nat @ ( times_times @ nat @ ( minus_minus @ nat @ J @ I3 ) @ U ) @ N2 ) ) ) ) ).

% nat_le_add_iff2
thf(fact_1627_nat__le__add__iff1,axiom,
    ! [J: nat,I3: nat,U: nat,M: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ J @ I3 )
     => ( ( ord_less_eq @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ I3 @ U ) @ M ) @ ( plus_plus @ nat @ ( times_times @ nat @ J @ U ) @ N2 ) )
        = ( ord_less_eq @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ ( minus_minus @ nat @ I3 @ J ) @ U ) @ M ) @ N2 ) ) ) ).

% nat_le_add_iff1
thf(fact_1628_nat__eq__add__iff2,axiom,
    ! [I3: nat,J: nat,U: nat,M: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ I3 @ J )
     => ( ( ( plus_plus @ nat @ ( times_times @ nat @ I3 @ U ) @ M )
          = ( plus_plus @ nat @ ( times_times @ nat @ J @ U ) @ N2 ) )
        = ( M
          = ( plus_plus @ nat @ ( times_times @ nat @ ( minus_minus @ nat @ J @ I3 ) @ U ) @ N2 ) ) ) ) ).

% nat_eq_add_iff2
thf(fact_1629_nat__eq__add__iff1,axiom,
    ! [J: nat,I3: nat,U: nat,M: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ J @ I3 )
     => ( ( ( plus_plus @ nat @ ( times_times @ nat @ I3 @ U ) @ M )
          = ( plus_plus @ nat @ ( times_times @ nat @ J @ U ) @ N2 ) )
        = ( ( plus_plus @ nat @ ( times_times @ nat @ ( minus_minus @ nat @ I3 @ J ) @ U ) @ M )
          = N2 ) ) ) ).

% nat_eq_add_iff1
thf(fact_1630_dvd__minus__add,axiom,
    ! [Q3: nat,N2: nat,R3: nat,M: nat] :
      ( ( ord_less_eq @ nat @ Q3 @ N2 )
     => ( ( ord_less_eq @ nat @ Q3 @ ( times_times @ nat @ R3 @ M ) )
       => ( ( dvd_dvd @ nat @ M @ ( minus_minus @ nat @ N2 @ Q3 ) )
          = ( dvd_dvd @ nat @ M @ ( plus_plus @ nat @ N2 @ ( minus_minus @ nat @ ( times_times @ nat @ R3 @ M ) @ Q3 ) ) ) ) ) ) ).

% dvd_minus_add
thf(fact_1631_mod__nat__eqI,axiom,
    ! [R3: nat,N2: nat,M: nat] :
      ( ( ord_less @ nat @ R3 @ N2 )
     => ( ( ord_less_eq @ nat @ R3 @ M )
       => ( ( dvd_dvd @ nat @ N2 @ ( minus_minus @ nat @ M @ R3 ) )
         => ( ( modulo_modulo @ nat @ M @ N2 )
            = R3 ) ) ) ) ).

% mod_nat_eqI
thf(fact_1632_Pair__inject,axiom,
    ! [A: $tType,B: $tType,A2: A,B2: B,A6: A,B6: B] :
      ( ( ( product_Pair @ A @ B @ A2 @ B2 )
        = ( product_Pair @ A @ B @ A6 @ B6 ) )
     => ~ ( ( A2 = A6 )
         => ( B2 != B6 ) ) ) ).

% Pair_inject
thf(fact_1633_prod__cases,axiom,
    ! [B: $tType,A: $tType,P: ( product_prod @ A @ B ) > $o,P4: product_prod @ A @ B] :
      ( ! [A5: A,B5: B] : ( P @ ( product_Pair @ A @ B @ A5 @ B5 ) )
     => ( P @ P4 ) ) ).

% prod_cases
thf(fact_1634_surj__pair,axiom,
    ! [A: $tType,B: $tType,P4: product_prod @ A @ B] :
    ? [X3: A,Y4: B] :
      ( P4
      = ( product_Pair @ A @ B @ X3 @ Y4 ) ) ).

% surj_pair
thf(fact_1635_old_Oprod_Oexhaust,axiom,
    ! [A: $tType,B: $tType,Y2: product_prod @ A @ B] :
      ~ ! [A5: A,B5: B] :
          ( Y2
         != ( product_Pair @ A @ B @ A5 @ B5 ) ) ).

% old.prod.exhaust
thf(fact_1636_modulo__nat__def,axiom,
    ( ( modulo_modulo @ nat )
    = ( ^ [M6: nat,N3: nat] : ( minus_minus @ nat @ M6 @ ( times_times @ nat @ ( divide_divide @ nat @ M6 @ N3 ) @ N3 ) ) ) ) ).

% modulo_nat_def
thf(fact_1637_prod__decode__aux_Ocases,axiom,
    ! [X2: product_prod @ nat @ nat] :
      ~ ! [K2: nat,M3: nat] :
          ( X2
         != ( product_Pair @ nat @ nat @ K2 @ M3 ) ) ).

% prod_decode_aux.cases
thf(fact_1638_power__diff,axiom,
    ! [A: $tType] :
      ( ( semidom_divide @ A )
     => ! [A2: A,N2: nat,M: nat] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( ord_less_eq @ nat @ N2 @ M )
           => ( ( power_power @ A @ A2 @ ( minus_minus @ nat @ M @ N2 ) )
              = ( divide_divide @ A @ ( power_power @ A @ A2 @ M ) @ ( power_power @ A @ A2 @ N2 ) ) ) ) ) ) ).

% power_diff
thf(fact_1639_Suc__diff__eq__diff__pred,axiom,
    ! [N2: nat,M: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( minus_minus @ nat @ ( suc @ M ) @ N2 )
        = ( minus_minus @ nat @ M @ ( minus_minus @ nat @ N2 @ ( one_one @ nat ) ) ) ) ) ).

% Suc_diff_eq_diff_pred
thf(fact_1640_Suc__pred_H,axiom,
    ! [N2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( N2
        = ( suc @ ( minus_minus @ nat @ N2 @ ( one_one @ nat ) ) ) ) ) ).

% Suc_pred'
thf(fact_1641_div__geq,axiom,
    ! [N2: nat,M: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ~ ( ord_less @ nat @ M @ N2 )
       => ( ( divide_divide @ nat @ M @ N2 )
          = ( suc @ ( divide_divide @ nat @ ( minus_minus @ nat @ M @ N2 ) @ N2 ) ) ) ) ) ).

% div_geq
thf(fact_1642_div__if,axiom,
    ( ( divide_divide @ nat )
    = ( ^ [M6: nat,N3: nat] :
          ( if @ nat
          @ ( ( ord_less @ nat @ M6 @ N3 )
            | ( N3
              = ( zero_zero @ nat ) ) )
          @ ( zero_zero @ nat )
          @ ( suc @ ( divide_divide @ nat @ ( minus_minus @ nat @ M6 @ N3 ) @ N3 ) ) ) ) ) ).

% div_if
thf(fact_1643_add__eq__if,axiom,
    ( ( plus_plus @ nat )
    = ( ^ [M6: nat,N3: nat] :
          ( if @ nat
          @ ( M6
            = ( zero_zero @ nat ) )
          @ N3
          @ ( suc @ ( plus_plus @ nat @ ( minus_minus @ nat @ M6 @ ( one_one @ nat ) ) @ N3 ) ) ) ) ) ).

% add_eq_if
thf(fact_1644_nat__less__add__iff2,axiom,
    ! [I3: nat,J: nat,U: nat,M: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ I3 @ J )
     => ( ( ord_less @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ I3 @ U ) @ M ) @ ( plus_plus @ nat @ ( times_times @ nat @ J @ U ) @ N2 ) )
        = ( ord_less @ nat @ M @ ( plus_plus @ nat @ ( times_times @ nat @ ( minus_minus @ nat @ J @ I3 ) @ U ) @ N2 ) ) ) ) ).

% nat_less_add_iff2
thf(fact_1645_nat__less__add__iff1,axiom,
    ! [J: nat,I3: nat,U: nat,M: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ J @ I3 )
     => ( ( ord_less @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ I3 @ U ) @ M ) @ ( plus_plus @ nat @ ( times_times @ nat @ J @ U ) @ N2 ) )
        = ( ord_less @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ ( minus_minus @ nat @ I3 @ J ) @ U ) @ M ) @ N2 ) ) ) ).

% nat_less_add_iff1
thf(fact_1646_mult__eq__if,axiom,
    ( ( times_times @ nat )
    = ( ^ [M6: nat,N3: nat] :
          ( if @ nat
          @ ( M6
            = ( zero_zero @ nat ) )
          @ ( zero_zero @ nat )
          @ ( plus_plus @ nat @ N3 @ ( times_times @ nat @ ( minus_minus @ nat @ M6 @ ( one_one @ nat ) ) @ N3 ) ) ) ) ) ).

% mult_eq_if
thf(fact_1647_exp__not__zero__imp__exp__diff__not__zero,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [N2: nat,M: nat] :
          ( ( ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N2 )
           != ( zero_zero @ A ) )
         => ( ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ N2 @ M ) )
           != ( zero_zero @ A ) ) ) ) ).

% exp_not_zero_imp_exp_diff_not_zero
thf(fact_1648_power__diff__power__eq,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [A2: A,N2: nat,M: nat] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( ( ord_less_eq @ nat @ N2 @ M )
             => ( ( divide_divide @ A @ ( power_power @ A @ A2 @ M ) @ ( power_power @ A @ A2 @ N2 ) )
                = ( power_power @ A @ A2 @ ( minus_minus @ nat @ M @ N2 ) ) ) )
            & ( ~ ( ord_less_eq @ nat @ N2 @ M )
             => ( ( divide_divide @ A @ ( power_power @ A @ A2 @ M ) @ ( power_power @ A @ A2 @ N2 ) )
                = ( divide_divide @ A @ ( one_one @ A ) @ ( power_power @ A @ A2 @ ( minus_minus @ nat @ N2 @ M ) ) ) ) ) ) ) ) ).

% power_diff_power_eq
thf(fact_1649_power__eq__if,axiom,
    ! [A: $tType] :
      ( ( power @ A )
     => ( ( power_power @ A )
        = ( ^ [P6: A,M6: nat] :
              ( if @ A
              @ ( M6
                = ( zero_zero @ nat ) )
              @ ( one_one @ A )
              @ ( times_times @ A @ P6 @ ( power_power @ A @ P6 @ ( minus_minus @ nat @ M6 @ ( one_one @ nat ) ) ) ) ) ) ) ) ).

% power_eq_if
thf(fact_1650_power__minus__mult,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [N2: nat,A2: A] :
          ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
         => ( ( times_times @ A @ ( power_power @ A @ A2 @ ( minus_minus @ nat @ N2 @ ( one_one @ nat ) ) ) @ A2 )
            = ( power_power @ A @ A2 @ N2 ) ) ) ) ).

% power_minus_mult
thf(fact_1651_diff__le__diff__pow,axiom,
    ! [K: nat,M: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ K )
     => ( ord_less_eq @ nat @ ( minus_minus @ nat @ M @ N2 ) @ ( minus_minus @ nat @ ( power_power @ nat @ K @ M ) @ ( power_power @ nat @ K @ N2 ) ) ) ) ).

% diff_le_diff_pow
thf(fact_1652_le__div__geq,axiom,
    ! [N2: nat,M: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( ord_less_eq @ nat @ N2 @ M )
       => ( ( divide_divide @ nat @ M @ N2 )
          = ( suc @ ( divide_divide @ nat @ ( minus_minus @ nat @ M @ N2 ) @ N2 ) ) ) ) ) ).

% le_div_geq
thf(fact_1653_list__decode_Ocases,axiom,
    ! [X2: nat] :
      ( ( X2
       != ( zero_zero @ nat ) )
     => ~ ! [N: nat] :
            ( X2
           != ( suc @ N ) ) ) ).

% list_decode.cases
thf(fact_1654_mult__exp__mod__exp__eq,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [M: nat,N2: nat,A2: A] :
          ( ( ord_less_eq @ nat @ M @ N2 )
         => ( ( modulo_modulo @ A @ ( times_times @ A @ A2 @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M ) ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N2 ) )
            = ( times_times @ A @ ( modulo_modulo @ A @ A2 @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ N2 @ M ) ) ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M ) ) ) ) ) ).

% mult_exp_mod_exp_eq
thf(fact_1655_prod__induct3,axiom,
    ! [C: $tType,B: $tType,A: $tType,P: ( product_prod @ A @ ( product_prod @ B @ C ) ) > $o,X2: product_prod @ A @ ( product_prod @ B @ C )] :
      ( ! [A5: A,B5: B,C3: C] : ( P @ ( product_Pair @ A @ ( product_prod @ B @ C ) @ A5 @ ( product_Pair @ B @ C @ B5 @ C3 ) ) )
     => ( P @ X2 ) ) ).

% prod_induct3
thf(fact_1656_prod__cases3,axiom,
    ! [A: $tType,B: $tType,C: $tType,Y2: product_prod @ A @ ( product_prod @ B @ C )] :
      ~ ! [A5: A,B5: B,C3: C] :
          ( Y2
         != ( product_Pair @ A @ ( product_prod @ B @ C ) @ A5 @ ( product_Pair @ B @ C @ B5 @ C3 ) ) ) ).

% prod_cases3
thf(fact_1657_even__mod__4__div__2,axiom,
    ! [N2: nat] :
      ( ( ( modulo_modulo @ nat @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ ( bit0 @ one2 ) ) ) )
        = ( suc @ ( zero_zero @ nat ) ) )
     => ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( divide_divide @ nat @ ( minus_minus @ nat @ N2 @ ( suc @ ( zero_zero @ nat ) ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ).

% even_mod_4_div_2
thf(fact_1658_int__power__div__base,axiom,
    ! [M: nat,K: int] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M )
     => ( ( ord_less @ int @ ( zero_zero @ int ) @ K )
       => ( ( divide_divide @ int @ ( power_power @ int @ K @ M ) @ K )
          = ( power_power @ int @ K @ ( minus_minus @ nat @ M @ ( suc @ ( zero_zero @ nat ) ) ) ) ) ) ) ).

% int_power_div_base
thf(fact_1659_even__mult__exp__div__exp__iff,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A,M: nat,N2: nat] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( divide_divide @ A @ ( times_times @ A @ A2 @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M ) ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N2 ) ) )
          = ( ( ord_less @ nat @ N2 @ M )
            | ( ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N2 )
              = ( zero_zero @ A ) )
            | ( ( ord_less_eq @ nat @ M @ N2 )
              & ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( divide_divide @ A @ A2 @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ N2 @ M ) ) ) ) ) ) ) ) ).

% even_mult_exp_div_exp_iff
thf(fact_1660_prod__induct7,axiom,
    ! [G2: $tType,F: $tType,E3: $tType,D: $tType,C: $tType,B: $tType,A: $tType,P: ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E3 @ ( product_prod @ F @ G2 ) ) ) ) ) ) > $o,X2: product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E3 @ ( product_prod @ F @ G2 ) ) ) ) )] :
      ( ! [A5: A,B5: B,C3: C,D4: D,E: E3,F4: F,G3: G2] : ( P @ ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E3 @ ( product_prod @ F @ G2 ) ) ) ) ) @ A5 @ ( product_Pair @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E3 @ ( product_prod @ F @ G2 ) ) ) ) @ B5 @ ( product_Pair @ C @ ( product_prod @ D @ ( product_prod @ E3 @ ( product_prod @ F @ G2 ) ) ) @ C3 @ ( product_Pair @ D @ ( product_prod @ E3 @ ( product_prod @ F @ G2 ) ) @ D4 @ ( product_Pair @ E3 @ ( product_prod @ F @ G2 ) @ E @ ( product_Pair @ F @ G2 @ F4 @ G3 ) ) ) ) ) ) )
     => ( P @ X2 ) ) ).

% prod_induct7
thf(fact_1661_prod__induct6,axiom,
    ! [F: $tType,E3: $tType,D: $tType,C: $tType,B: $tType,A: $tType,P: ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E3 @ F ) ) ) ) ) > $o,X2: product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E3 @ F ) ) ) )] :
      ( ! [A5: A,B5: B,C3: C,D4: D,E: E3,F4: F] : ( P @ ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E3 @ F ) ) ) ) @ A5 @ ( product_Pair @ B @ ( product_prod @ C @ ( product_prod @ D @ ( product_prod @ E3 @ F ) ) ) @ B5 @ ( product_Pair @ C @ ( product_prod @ D @ ( product_prod @ E3 @ F ) ) @ C3 @ ( product_Pair @ D @ ( product_prod @ E3 @ F ) @ D4 @ ( product_Pair @ E3 @ F @ E @ F4 ) ) ) ) ) )
     => ( P @ X2 ) ) ).

% prod_induct6
thf(fact_1662_prod__induct5,axiom,
    ! [E3: $tType,D: $tType,C: $tType,B: $tType,A: $tType,P: ( product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ E3 ) ) ) ) > $o,X2: product_prod @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ E3 ) ) )] :
      ( ! [A5: A,B5: B,C3: C,D4: D,E: E3] : ( P @ ( product_Pair @ A @ ( product_prod @ B @ ( product_prod @ C @ ( product_prod @ D @ E3 ) ) ) @ A5 @ ( product_Pair @ B @ ( product_prod @ C @ ( product_prod @ D @ E3 ) ) @ B5 @ ( product_Pair @ C @ ( product_prod @ D @ E3 ) @ C3 @ ( product_Pair @ D @ E3 @ D4 @ E ) ) ) ) )
     => ( P @ X2 ) ) ).

% prod_induct5
thf(fact_1663_real__average__minus__first,axiom,
    ! [A2: real,B2: real] :
      ( ( minus_minus @ real @ ( divide_divide @ real @ ( plus_plus @ real @ A2 @ B2 ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ A2 )
      = ( divide_divide @ real @ ( minus_minus @ real @ B2 @ A2 ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ).

% real_average_minus_first
thf(fact_1664_real__average__minus__second,axiom,
    ! [B2: real,A2: real] :
      ( ( minus_minus @ real @ ( divide_divide @ real @ ( plus_plus @ real @ B2 @ A2 ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ A2 )
      = ( divide_divide @ real @ ( minus_minus @ real @ B2 @ A2 ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ).

% real_average_minus_second
thf(fact_1665_vebt__member_Opelims_I1_J,axiom,
    ! [X2: vEBT_VEBT,Xa2: nat,Y2: $o] :
      ( ( ( vEBT_vebt_member @ X2 @ Xa2 )
        = Y2 )
     => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_vebt_member_rel @ ( product_Pair @ vEBT_VEBT @ nat @ X2 @ Xa2 ) )
       => ( ! [A5: $o,B5: $o] :
              ( ( X2
                = ( vEBT_Leaf @ A5 @ B5 ) )
             => ( ( Y2
                  = ( ( ( Xa2
                        = ( zero_zero @ nat ) )
                     => A5 )
                    & ( ( Xa2
                       != ( zero_zero @ nat ) )
                     => ( ( ( Xa2
                            = ( one_one @ nat ) )
                         => B5 )
                        & ( Xa2
                          = ( one_one @ nat ) ) ) ) ) )
               => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_vebt_member_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Leaf @ A5 @ B5 ) @ Xa2 ) ) ) )
         => ( ! [Uu: nat,Uv: list @ vEBT_VEBT,Uw: vEBT_VEBT] :
                ( ( X2
                  = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ Uu @ Uv @ Uw ) )
               => ( ~ Y2
                 => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_vebt_member_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ Uu @ Uv @ Uw ) @ Xa2 ) ) ) )
           => ( ! [V3: product_prod @ nat @ nat,Uy: list @ vEBT_VEBT,Uz: vEBT_VEBT] :
                  ( ( X2
                    = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ V3 ) @ ( zero_zero @ nat ) @ Uy @ Uz ) )
                 => ( ~ Y2
                   => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_vebt_member_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ V3 ) @ ( zero_zero @ nat ) @ Uy @ Uz ) @ Xa2 ) ) ) )
             => ( ! [V3: product_prod @ nat @ nat,Vb2: list @ vEBT_VEBT,Vc2: vEBT_VEBT] :
                    ( ( X2
                      = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ V3 ) @ ( suc @ ( zero_zero @ nat ) ) @ Vb2 @ Vc2 ) )
                   => ( ~ Y2
                     => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_vebt_member_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ V3 ) @ ( suc @ ( zero_zero @ nat ) ) @ Vb2 @ Vc2 ) @ Xa2 ) ) ) )
               => ~ ! [Mi2: nat,Ma2: nat,Va: nat,TreeList2: list @ vEBT_VEBT,Summary2: vEBT_VEBT] :
                      ( ( X2
                        = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ Ma2 ) ) @ ( suc @ ( suc @ Va ) ) @ TreeList2 @ Summary2 ) )
                     => ( ( Y2
                          = ( ( Xa2 != Mi2 )
                           => ( ( Xa2 != Ma2 )
                             => ( ~ ( ord_less @ nat @ Xa2 @ Mi2 )
                                & ( ~ ( ord_less @ nat @ Xa2 @ Mi2 )
                                 => ( ~ ( ord_less @ nat @ Ma2 @ Xa2 )
                                    & ( ~ ( ord_less @ nat @ Ma2 @ Xa2 )
                                     => ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 ) )
                                         => ( vEBT_vebt_member @ ( nth @ vEBT_VEBT @ TreeList2 @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa2 @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                                        & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 ) ) ) ) ) ) ) ) ) )
                       => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_vebt_member_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ Ma2 ) ) @ ( suc @ ( suc @ Va ) ) @ TreeList2 @ Summary2 ) @ Xa2 ) ) ) ) ) ) ) ) ) ) ).

% vebt_member.pelims(1)
thf(fact_1666_vebt__member_Opelims_I3_J,axiom,
    ! [X2: vEBT_VEBT,Xa2: nat] :
      ( ~ ( vEBT_vebt_member @ X2 @ Xa2 )
     => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_vebt_member_rel @ ( product_Pair @ vEBT_VEBT @ nat @ X2 @ Xa2 ) )
       => ( ! [A5: $o,B5: $o] :
              ( ( X2
                = ( vEBT_Leaf @ A5 @ B5 ) )
             => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_vebt_member_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Leaf @ A5 @ B5 ) @ Xa2 ) )
               => ( ( ( Xa2
                      = ( zero_zero @ nat ) )
                   => A5 )
                  & ( ( Xa2
                     != ( zero_zero @ nat ) )
                   => ( ( ( Xa2
                          = ( one_one @ nat ) )
                       => B5 )
                      & ( Xa2
                        = ( one_one @ nat ) ) ) ) ) ) )
         => ( ! [Uu: nat,Uv: list @ vEBT_VEBT,Uw: vEBT_VEBT] :
                ( ( X2
                  = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ Uu @ Uv @ Uw ) )
               => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_vebt_member_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ Uu @ Uv @ Uw ) @ Xa2 ) ) )
           => ( ! [V3: product_prod @ nat @ nat,Uy: list @ vEBT_VEBT,Uz: vEBT_VEBT] :
                  ( ( X2
                    = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ V3 ) @ ( zero_zero @ nat ) @ Uy @ Uz ) )
                 => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_vebt_member_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ V3 ) @ ( zero_zero @ nat ) @ Uy @ Uz ) @ Xa2 ) ) )
             => ( ! [V3: product_prod @ nat @ nat,Vb2: list @ vEBT_VEBT,Vc2: vEBT_VEBT] :
                    ( ( X2
                      = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ V3 ) @ ( suc @ ( zero_zero @ nat ) ) @ Vb2 @ Vc2 ) )
                   => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_vebt_member_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ V3 ) @ ( suc @ ( zero_zero @ nat ) ) @ Vb2 @ Vc2 ) @ Xa2 ) ) )
               => ~ ! [Mi2: nat,Ma2: nat,Va: nat,TreeList2: list @ vEBT_VEBT,Summary2: vEBT_VEBT] :
                      ( ( X2
                        = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ Ma2 ) ) @ ( suc @ ( suc @ Va ) ) @ TreeList2 @ Summary2 ) )
                     => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_vebt_member_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ Ma2 ) ) @ ( suc @ ( suc @ Va ) ) @ TreeList2 @ Summary2 ) @ Xa2 ) )
                       => ( ( Xa2 != Mi2 )
                         => ( ( Xa2 != Ma2 )
                           => ( ~ ( ord_less @ nat @ Xa2 @ Mi2 )
                              & ( ~ ( ord_less @ nat @ Xa2 @ Mi2 )
                               => ( ~ ( ord_less @ nat @ Ma2 @ Xa2 )
                                  & ( ~ ( ord_less @ nat @ Ma2 @ Xa2 )
                                   => ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 ) )
                                       => ( vEBT_vebt_member @ ( nth @ vEBT_VEBT @ TreeList2 @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa2 @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                                      & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ).

% vebt_member.pelims(3)
thf(fact_1667_VEBT__internal_Onaive__member_Opelims_I1_J,axiom,
    ! [X2: vEBT_VEBT,Xa2: nat,Y2: $o] :
      ( ( ( vEBT_V5719532721284313246member @ X2 @ Xa2 )
        = Y2 )
     => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V5765760719290551771er_rel @ ( product_Pair @ vEBT_VEBT @ nat @ X2 @ Xa2 ) )
       => ( ! [A5: $o,B5: $o] :
              ( ( X2
                = ( vEBT_Leaf @ A5 @ B5 ) )
             => ( ( Y2
                  = ( ( ( Xa2
                        = ( zero_zero @ nat ) )
                     => A5 )
                    & ( ( Xa2
                       != ( zero_zero @ nat ) )
                     => ( ( ( Xa2
                            = ( one_one @ nat ) )
                         => B5 )
                        & ( Xa2
                          = ( one_one @ nat ) ) ) ) ) )
               => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V5765760719290551771er_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Leaf @ A5 @ B5 ) @ Xa2 ) ) ) )
         => ( ! [Uu: option @ ( product_prod @ nat @ nat ),Uv: list @ vEBT_VEBT,Uw: vEBT_VEBT] :
                ( ( X2
                  = ( vEBT_Node @ Uu @ ( zero_zero @ nat ) @ Uv @ Uw ) )
               => ( ~ Y2
                 => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V5765760719290551771er_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ Uu @ ( zero_zero @ nat ) @ Uv @ Uw ) @ Xa2 ) ) ) )
           => ~ ! [Uy: option @ ( product_prod @ nat @ nat ),V3: nat,TreeList2: list @ vEBT_VEBT,S: vEBT_VEBT] :
                  ( ( X2
                    = ( vEBT_Node @ Uy @ ( suc @ V3 ) @ TreeList2 @ S ) )
                 => ( ( Y2
                      = ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 ) )
                         => ( vEBT_V5719532721284313246member @ ( nth @ vEBT_VEBT @ TreeList2 @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                        & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 ) ) ) )
                   => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V5765760719290551771er_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ Uy @ ( suc @ V3 ) @ TreeList2 @ S ) @ Xa2 ) ) ) ) ) ) ) ) ).

% VEBT_internal.naive_member.pelims(1)
thf(fact_1668_VEBT__internal_Onaive__member_Opelims_I2_J,axiom,
    ! [X2: vEBT_VEBT,Xa2: nat] :
      ( ( vEBT_V5719532721284313246member @ X2 @ Xa2 )
     => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V5765760719290551771er_rel @ ( product_Pair @ vEBT_VEBT @ nat @ X2 @ Xa2 ) )
       => ( ! [A5: $o,B5: $o] :
              ( ( X2
                = ( vEBT_Leaf @ A5 @ B5 ) )
             => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V5765760719290551771er_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Leaf @ A5 @ B5 ) @ Xa2 ) )
               => ~ ( ( ( Xa2
                        = ( zero_zero @ nat ) )
                     => A5 )
                    & ( ( Xa2
                       != ( zero_zero @ nat ) )
                     => ( ( ( Xa2
                            = ( one_one @ nat ) )
                         => B5 )
                        & ( Xa2
                          = ( one_one @ nat ) ) ) ) ) ) )
         => ~ ! [Uy: option @ ( product_prod @ nat @ nat ),V3: nat,TreeList2: list @ vEBT_VEBT,S: vEBT_VEBT] :
                ( ( X2
                  = ( vEBT_Node @ Uy @ ( suc @ V3 ) @ TreeList2 @ S ) )
               => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V5765760719290551771er_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ Uy @ ( suc @ V3 ) @ TreeList2 @ S ) @ Xa2 ) )
                 => ~ ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 ) )
                       => ( vEBT_V5719532721284313246member @ ( nth @ vEBT_VEBT @ TreeList2 @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                      & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 ) ) ) ) ) ) ) ) ).

% VEBT_internal.naive_member.pelims(2)
thf(fact_1669_VEBT__internal_Onaive__member_Opelims_I3_J,axiom,
    ! [X2: vEBT_VEBT,Xa2: nat] :
      ( ~ ( vEBT_V5719532721284313246member @ X2 @ Xa2 )
     => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V5765760719290551771er_rel @ ( product_Pair @ vEBT_VEBT @ nat @ X2 @ Xa2 ) )
       => ( ! [A5: $o,B5: $o] :
              ( ( X2
                = ( vEBT_Leaf @ A5 @ B5 ) )
             => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V5765760719290551771er_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Leaf @ A5 @ B5 ) @ Xa2 ) )
               => ( ( ( Xa2
                      = ( zero_zero @ nat ) )
                   => A5 )
                  & ( ( Xa2
                     != ( zero_zero @ nat ) )
                   => ( ( ( Xa2
                          = ( one_one @ nat ) )
                       => B5 )
                      & ( Xa2
                        = ( one_one @ nat ) ) ) ) ) ) )
         => ( ! [Uu: option @ ( product_prod @ nat @ nat ),Uv: list @ vEBT_VEBT,Uw: vEBT_VEBT] :
                ( ( X2
                  = ( vEBT_Node @ Uu @ ( zero_zero @ nat ) @ Uv @ Uw ) )
               => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V5765760719290551771er_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ Uu @ ( zero_zero @ nat ) @ Uv @ Uw ) @ Xa2 ) ) )
           => ~ ! [Uy: option @ ( product_prod @ nat @ nat ),V3: nat,TreeList2: list @ vEBT_VEBT,S: vEBT_VEBT] :
                  ( ( X2
                    = ( vEBT_Node @ Uy @ ( suc @ V3 ) @ TreeList2 @ S ) )
                 => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V5765760719290551771er_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ Uy @ ( suc @ V3 ) @ TreeList2 @ S ) @ Xa2 ) )
                   => ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 ) )
                       => ( vEBT_V5719532721284313246member @ ( nth @ vEBT_VEBT @ TreeList2 @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                      & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 ) ) ) ) ) ) ) ) ) ).

% VEBT_internal.naive_member.pelims(3)
thf(fact_1670_vebt__member_Opelims_I2_J,axiom,
    ! [X2: vEBT_VEBT,Xa2: nat] :
      ( ( vEBT_vebt_member @ X2 @ Xa2 )
     => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_vebt_member_rel @ ( product_Pair @ vEBT_VEBT @ nat @ X2 @ Xa2 ) )
       => ( ! [A5: $o,B5: $o] :
              ( ( X2
                = ( vEBT_Leaf @ A5 @ B5 ) )
             => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_vebt_member_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Leaf @ A5 @ B5 ) @ Xa2 ) )
               => ~ ( ( ( Xa2
                        = ( zero_zero @ nat ) )
                     => A5 )
                    & ( ( Xa2
                       != ( zero_zero @ nat ) )
                     => ( ( ( Xa2
                            = ( one_one @ nat ) )
                         => B5 )
                        & ( Xa2
                          = ( one_one @ nat ) ) ) ) ) ) )
         => ~ ! [Mi2: nat,Ma2: nat,Va: nat,TreeList2: list @ vEBT_VEBT,Summary2: vEBT_VEBT] :
                ( ( X2
                  = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ Ma2 ) ) @ ( suc @ ( suc @ Va ) ) @ TreeList2 @ Summary2 ) )
               => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_vebt_member_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ Ma2 ) ) @ ( suc @ ( suc @ Va ) ) @ TreeList2 @ Summary2 ) @ Xa2 ) )
                 => ~ ( ( Xa2 != Mi2 )
                     => ( ( Xa2 != Ma2 )
                       => ( ~ ( ord_less @ nat @ Xa2 @ Mi2 )
                          & ( ~ ( ord_less @ nat @ Xa2 @ Mi2 )
                           => ( ~ ( ord_less @ nat @ Ma2 @ Xa2 )
                              & ( ~ ( ord_less @ nat @ Ma2 @ Xa2 )
                               => ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 ) )
                                   => ( vEBT_vebt_member @ ( nth @ vEBT_VEBT @ TreeList2 @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa2 @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                                  & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ).

% vebt_member.pelims(2)
thf(fact_1671_diff__commute,axiom,
    ! [I3: nat,J: nat,K: nat] :
      ( ( minus_minus @ nat @ ( minus_minus @ nat @ I3 @ J ) @ K )
      = ( minus_minus @ nat @ ( minus_minus @ nat @ I3 @ K ) @ J ) ) ).

% diff_commute
thf(fact_1672_mult__commute__abs,axiom,
    ! [A: $tType] :
      ( ( ab_semigroup_mult @ A )
     => ! [C2: A] :
          ( ( ^ [X5: A] : ( times_times @ A @ X5 @ C2 ) )
          = ( times_times @ A @ C2 ) ) ) ).

% mult_commute_abs
thf(fact_1673_VEBT__internal_Omembermima_Opelims_I3_J,axiom,
    ! [X2: vEBT_VEBT,Xa2: nat] :
      ( ~ ( vEBT_VEBT_membermima @ X2 @ Xa2 )
     => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V4351362008482014158ma_rel @ ( product_Pair @ vEBT_VEBT @ nat @ X2 @ Xa2 ) )
       => ( ! [Uu: $o,Uv: $o] :
              ( ( X2
                = ( vEBT_Leaf @ Uu @ Uv ) )
             => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V4351362008482014158ma_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Leaf @ Uu @ Uv ) @ Xa2 ) ) )
         => ( ! [Ux: list @ vEBT_VEBT,Uy: vEBT_VEBT] :
                ( ( X2
                  = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( zero_zero @ nat ) @ Ux @ Uy ) )
               => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V4351362008482014158ma_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( zero_zero @ nat ) @ Ux @ Uy ) @ Xa2 ) ) )
           => ( ! [Mi2: nat,Ma2: nat,Va2: list @ vEBT_VEBT,Vb2: vEBT_VEBT] :
                  ( ( X2
                    = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ Ma2 ) ) @ ( zero_zero @ nat ) @ Va2 @ Vb2 ) )
                 => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V4351362008482014158ma_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ Ma2 ) ) @ ( zero_zero @ nat ) @ Va2 @ Vb2 ) @ Xa2 ) )
                   => ( ( Xa2 = Mi2 )
                      | ( Xa2 = Ma2 ) ) ) )
             => ( ! [Mi2: nat,Ma2: nat,V3: nat,TreeList2: list @ vEBT_VEBT,Vc2: vEBT_VEBT] :
                    ( ( X2
                      = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ Ma2 ) ) @ ( suc @ V3 ) @ TreeList2 @ Vc2 ) )
                   => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V4351362008482014158ma_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ Ma2 ) ) @ ( suc @ V3 ) @ TreeList2 @ Vc2 ) @ Xa2 ) )
                     => ( ( Xa2 = Mi2 )
                        | ( Xa2 = Ma2 )
                        | ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 ) )
                           => ( vEBT_VEBT_membermima @ ( nth @ vEBT_VEBT @ TreeList2 @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                          & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 ) ) ) ) ) )
               => ~ ! [V3: nat,TreeList2: list @ vEBT_VEBT,Vd: vEBT_VEBT] :
                      ( ( X2
                        = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ V3 ) @ TreeList2 @ Vd ) )
                     => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V4351362008482014158ma_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ V3 ) @ TreeList2 @ Vd ) @ Xa2 ) )
                       => ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 ) )
                           => ( vEBT_VEBT_membermima @ ( nth @ vEBT_VEBT @ TreeList2 @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                          & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 ) ) ) ) ) ) ) ) ) ) ) ).

% VEBT_internal.membermima.pelims(3)
thf(fact_1674_VEBT__internal_Omembermima_Opelims_I1_J,axiom,
    ! [X2: vEBT_VEBT,Xa2: nat,Y2: $o] :
      ( ( ( vEBT_VEBT_membermima @ X2 @ Xa2 )
        = Y2 )
     => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V4351362008482014158ma_rel @ ( product_Pair @ vEBT_VEBT @ nat @ X2 @ Xa2 ) )
       => ( ! [Uu: $o,Uv: $o] :
              ( ( X2
                = ( vEBT_Leaf @ Uu @ Uv ) )
             => ( ~ Y2
               => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V4351362008482014158ma_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Leaf @ Uu @ Uv ) @ Xa2 ) ) ) )
         => ( ! [Ux: list @ vEBT_VEBT,Uy: vEBT_VEBT] :
                ( ( X2
                  = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( zero_zero @ nat ) @ Ux @ Uy ) )
               => ( ~ Y2
                 => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V4351362008482014158ma_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( zero_zero @ nat ) @ Ux @ Uy ) @ Xa2 ) ) ) )
           => ( ! [Mi2: nat,Ma2: nat,Va2: list @ vEBT_VEBT,Vb2: vEBT_VEBT] :
                  ( ( X2
                    = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ Ma2 ) ) @ ( zero_zero @ nat ) @ Va2 @ Vb2 ) )
                 => ( ( Y2
                      = ( ( Xa2 = Mi2 )
                        | ( Xa2 = Ma2 ) ) )
                   => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V4351362008482014158ma_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ Ma2 ) ) @ ( zero_zero @ nat ) @ Va2 @ Vb2 ) @ Xa2 ) ) ) )
             => ( ! [Mi2: nat,Ma2: nat,V3: nat,TreeList2: list @ vEBT_VEBT,Vc2: vEBT_VEBT] :
                    ( ( X2
                      = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ Ma2 ) ) @ ( suc @ V3 ) @ TreeList2 @ Vc2 ) )
                   => ( ( Y2
                        = ( ( Xa2 = Mi2 )
                          | ( Xa2 = Ma2 )
                          | ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 ) )
                             => ( vEBT_VEBT_membermima @ ( nth @ vEBT_VEBT @ TreeList2 @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                            & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 ) ) ) ) )
                     => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V4351362008482014158ma_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ Ma2 ) ) @ ( suc @ V3 ) @ TreeList2 @ Vc2 ) @ Xa2 ) ) ) )
               => ~ ! [V3: nat,TreeList2: list @ vEBT_VEBT,Vd: vEBT_VEBT] :
                      ( ( X2
                        = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ V3 ) @ TreeList2 @ Vd ) )
                     => ( ( Y2
                          = ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 ) )
                             => ( vEBT_VEBT_membermima @ ( nth @ vEBT_VEBT @ TreeList2 @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                            & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 ) ) ) )
                       => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V4351362008482014158ma_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ V3 ) @ TreeList2 @ Vd ) @ Xa2 ) ) ) ) ) ) ) ) ) ) ).

% VEBT_internal.membermima.pelims(1)
thf(fact_1675_VEBT__internal_Omembermima_Opelims_I2_J,axiom,
    ! [X2: vEBT_VEBT,Xa2: nat] :
      ( ( vEBT_VEBT_membermima @ X2 @ Xa2 )
     => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V4351362008482014158ma_rel @ ( product_Pair @ vEBT_VEBT @ nat @ X2 @ Xa2 ) )
       => ( ! [Mi2: nat,Ma2: nat,Va2: list @ vEBT_VEBT,Vb2: vEBT_VEBT] :
              ( ( X2
                = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ Ma2 ) ) @ ( zero_zero @ nat ) @ Va2 @ Vb2 ) )
             => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V4351362008482014158ma_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ Ma2 ) ) @ ( zero_zero @ nat ) @ Va2 @ Vb2 ) @ Xa2 ) )
               => ~ ( ( Xa2 = Mi2 )
                    | ( Xa2 = Ma2 ) ) ) )
         => ( ! [Mi2: nat,Ma2: nat,V3: nat,TreeList2: list @ vEBT_VEBT,Vc2: vEBT_VEBT] :
                ( ( X2
                  = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ Ma2 ) ) @ ( suc @ V3 ) @ TreeList2 @ Vc2 ) )
               => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V4351362008482014158ma_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ Ma2 ) ) @ ( suc @ V3 ) @ TreeList2 @ Vc2 ) @ Xa2 ) )
                 => ~ ( ( Xa2 = Mi2 )
                      | ( Xa2 = Ma2 )
                      | ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 ) )
                         => ( vEBT_VEBT_membermima @ ( nth @ vEBT_VEBT @ TreeList2 @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                        & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 ) ) ) ) ) )
           => ~ ! [V3: nat,TreeList2: list @ vEBT_VEBT,Vd: vEBT_VEBT] :
                  ( ( X2
                    = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ V3 ) @ TreeList2 @ Vd ) )
                 => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V4351362008482014158ma_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ V3 ) @ TreeList2 @ Vd ) @ Xa2 ) )
                   => ~ ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 ) )
                         => ( vEBT_VEBT_membermima @ ( nth @ vEBT_VEBT @ TreeList2 @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                        & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa2 @ ( divide_divide @ nat @ ( suc @ V3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 ) ) ) ) ) ) ) ) ) ).

% VEBT_internal.membermima.pelims(2)
thf(fact_1676_inrange,axiom,
    ! [T2: vEBT_VEBT,N2: nat] :
      ( ( vEBT_invar_vebt @ T2 @ N2 )
     => ( ord_less_eq @ ( set @ nat ) @ ( vEBT_VEBT_set_vebt @ T2 ) @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ ( minus_minus @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) @ ( one_one @ nat ) ) ) ) ) ).

% inrange
thf(fact_1677_psubsetI,axiom,
    ! [A: $tType,A3: set @ A,B3: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ B3 )
     => ( ( A3 != B3 )
       => ( ord_less @ ( set @ A ) @ A3 @ B3 ) ) ) ).

% psubsetI
thf(fact_1678_Bolzano,axiom,
    ! [A2: real,B2: real,P: real > real > $o] :
      ( ( ord_less_eq @ real @ A2 @ B2 )
     => ( ! [A5: real,B5: real,C3: real] :
            ( ( P @ A5 @ B5 )
           => ( ( P @ B5 @ C3 )
             => ( ( ord_less_eq @ real @ A5 @ B5 )
               => ( ( ord_less_eq @ real @ B5 @ C3 )
                 => ( P @ A5 @ C3 ) ) ) ) )
       => ( ! [X3: real] :
              ( ( ord_less_eq @ real @ A2 @ X3 )
             => ( ( ord_less_eq @ real @ X3 @ B2 )
               => ? [D6: real] :
                    ( ( ord_less @ real @ ( zero_zero @ real ) @ D6 )
                    & ! [A5: real,B5: real] :
                        ( ( ( ord_less_eq @ real @ A5 @ X3 )
                          & ( ord_less_eq @ real @ X3 @ B5 )
                          & ( ord_less @ real @ ( minus_minus @ real @ B5 @ A5 ) @ D6 ) )
                       => ( P @ A5 @ B5 ) ) ) ) )
         => ( P @ A2 @ B2 ) ) ) ) ).

% Bolzano
thf(fact_1679_Suc__if__eq,axiom,
    ! [A: $tType,F2: nat > A,H2: nat > A,G: A,N2: nat] :
      ( ! [N: nat] :
          ( ( F2 @ ( suc @ N ) )
          = ( H2 @ N ) )
     => ( ( ( F2 @ ( zero_zero @ nat ) )
          = G )
       => ( ( ( N2
              = ( zero_zero @ nat ) )
           => ( ( F2 @ N2 )
              = G ) )
          & ( ( N2
             != ( zero_zero @ nat ) )
           => ( ( F2 @ N2 )
              = ( H2 @ ( minus_minus @ nat @ N2 @ ( one_one @ nat ) ) ) ) ) ) ) ) ).

% Suc_if_eq
thf(fact_1680_vebt__buildup_Oelims,axiom,
    ! [X2: nat,Y2: vEBT_VEBT] :
      ( ( ( vEBT_vebt_buildup @ X2 )
        = Y2 )
     => ( ( ( X2
            = ( zero_zero @ nat ) )
         => ( Y2
           != ( vEBT_Leaf @ $false @ $false ) ) )
       => ( ( ( X2
              = ( suc @ ( zero_zero @ nat ) ) )
           => ( Y2
             != ( vEBT_Leaf @ $false @ $false ) ) )
         => ~ ! [Va: nat] :
                ( ( X2
                  = ( suc @ ( suc @ Va ) ) )
               => ~ ( ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( suc @ ( suc @ Va ) ) )
                     => ( Y2
                        = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ ( suc @ Va ) ) @ ( replicate @ vEBT_VEBT @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( vEBT_vebt_buildup @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_vebt_buildup @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) )
                    & ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( suc @ ( suc @ Va ) ) )
                     => ( Y2
                        = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ ( suc @ Va ) ) @ ( replicate @ vEBT_VEBT @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( suc @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_vebt_buildup @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_vebt_buildup @ ( suc @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ) ) ) ).

% vebt_buildup.elims
thf(fact_1681_intind,axiom,
    ! [A: $tType,I3: nat,N2: nat,P: A > $o,X2: A] :
      ( ( ord_less @ nat @ I3 @ N2 )
     => ( ( P @ X2 )
       => ( P @ ( nth @ A @ ( replicate @ A @ N2 @ X2 ) @ I3 ) ) ) ) ).

% intind
thf(fact_1682_subset__antisym,axiom,
    ! [A: $tType,A3: set @ A,B3: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ B3 )
     => ( ( ord_less_eq @ ( set @ A ) @ B3 @ A3 )
       => ( A3 = B3 ) ) ) ).

% subset_antisym
thf(fact_1683_subsetI,axiom,
    ! [A: $tType,A3: set @ A,B3: set @ A] :
      ( ! [X3: A] :
          ( ( member @ A @ X3 @ A3 )
         => ( member @ A @ X3 @ B3 ) )
     => ( ord_less_eq @ ( set @ A ) @ A3 @ B3 ) ) ).

% subsetI
thf(fact_1684_Icc__eq__Icc,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [L: A,H2: A,L3: A,H3: A] :
          ( ( ( set_or1337092689740270186AtMost @ A @ L @ H2 )
            = ( set_or1337092689740270186AtMost @ A @ L3 @ H3 ) )
          = ( ( ( L = L3 )
              & ( H2 = H3 ) )
            | ( ~ ( ord_less_eq @ A @ L @ H2 )
              & ~ ( ord_less_eq @ A @ L3 @ H3 ) ) ) ) ) ).

% Icc_eq_Icc
thf(fact_1685_atLeastAtMost__iff,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [I3: A,L: A,U: A] :
          ( ( member @ A @ I3 @ ( set_or1337092689740270186AtMost @ A @ L @ U ) )
          = ( ( ord_less_eq @ A @ L @ I3 )
            & ( ord_less_eq @ A @ I3 @ U ) ) ) ) ).

% atLeastAtMost_iff
thf(fact_1686_replicate__eq__replicate,axiom,
    ! [A: $tType,M: nat,X2: A,N2: nat,Y2: A] :
      ( ( ( replicate @ A @ M @ X2 )
        = ( replicate @ A @ N2 @ Y2 ) )
      = ( ( M = N2 )
        & ( ( M
           != ( zero_zero @ nat ) )
         => ( X2 = Y2 ) ) ) ) ).

% replicate_eq_replicate
thf(fact_1687_length__replicate,axiom,
    ! [A: $tType,N2: nat,X2: A] :
      ( ( size_size @ ( list @ A ) @ ( replicate @ A @ N2 @ X2 ) )
      = N2 ) ).

% length_replicate
thf(fact_1688_atLeastatMost__subset__iff,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ord_less_eq @ ( set @ A ) @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) @ ( set_or1337092689740270186AtMost @ A @ C2 @ D2 ) )
          = ( ~ ( ord_less_eq @ A @ A2 @ B2 )
            | ( ( ord_less_eq @ A @ C2 @ A2 )
              & ( ord_less_eq @ A @ B2 @ D2 ) ) ) ) ) ).

% atLeastatMost_subset_iff
thf(fact_1689_Ball__set__replicate,axiom,
    ! [A: $tType,N2: nat,A2: A,P: A > $o] :
      ( ( ! [X5: A] :
            ( ( member @ A @ X5 @ ( set2 @ A @ ( replicate @ A @ N2 @ A2 ) ) )
           => ( P @ X5 ) ) )
      = ( ( P @ A2 )
        | ( N2
          = ( zero_zero @ nat ) ) ) ) ).

% Ball_set_replicate
thf(fact_1690_Bex__set__replicate,axiom,
    ! [A: $tType,N2: nat,A2: A,P: A > $o] :
      ( ( ? [X5: A] :
            ( ( member @ A @ X5 @ ( set2 @ A @ ( replicate @ A @ N2 @ A2 ) ) )
            & ( P @ X5 ) ) )
      = ( ( P @ A2 )
        & ( N2
         != ( zero_zero @ nat ) ) ) ) ).

% Bex_set_replicate
thf(fact_1691_in__set__replicate,axiom,
    ! [A: $tType,X2: A,N2: nat,Y2: A] :
      ( ( member @ A @ X2 @ ( set2 @ A @ ( replicate @ A @ N2 @ Y2 ) ) )
      = ( ( X2 = Y2 )
        & ( N2
         != ( zero_zero @ nat ) ) ) ) ).

% in_set_replicate
thf(fact_1692_nth__replicate,axiom,
    ! [A: $tType,I3: nat,N2: nat,X2: A] :
      ( ( ord_less @ nat @ I3 @ N2 )
     => ( ( nth @ A @ ( replicate @ A @ N2 @ X2 ) @ I3 )
        = X2 ) ) ).

% nth_replicate
thf(fact_1693_all__nat__less,axiom,
    ! [N2: nat,P: nat > $o] :
      ( ( ! [M6: nat] :
            ( ( ord_less_eq @ nat @ M6 @ N2 )
           => ( P @ M6 ) ) )
      = ( ! [X5: nat] :
            ( ( member @ nat @ X5 @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N2 ) )
           => ( P @ X5 ) ) ) ) ).

% all_nat_less
thf(fact_1694_ex__nat__less,axiom,
    ! [N2: nat,P: nat > $o] :
      ( ( ? [M6: nat] :
            ( ( ord_less_eq @ nat @ M6 @ N2 )
            & ( P @ M6 ) ) )
      = ( ? [X5: nat] :
            ( ( member @ nat @ X5 @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N2 ) )
            & ( P @ X5 ) ) ) ) ).

% ex_nat_less
thf(fact_1695_replicate__length__same,axiom,
    ! [A: $tType,Xs: list @ A,X2: A] :
      ( ! [X3: A] :
          ( ( member @ A @ X3 @ ( set2 @ A @ Xs ) )
         => ( X3 = X2 ) )
     => ( ( replicate @ A @ ( size_size @ ( list @ A ) @ Xs ) @ X2 )
        = Xs ) ) ).

% replicate_length_same
thf(fact_1696_replicate__eqI,axiom,
    ! [A: $tType,Xs: list @ A,N2: nat,X2: A] :
      ( ( ( size_size @ ( list @ A ) @ Xs )
        = N2 )
     => ( ! [Y4: A] :
            ( ( member @ A @ Y4 @ ( set2 @ A @ Xs ) )
           => ( Y4 = X2 ) )
       => ( Xs
          = ( replicate @ A @ N2 @ X2 ) ) ) ) ).

% replicate_eqI
thf(fact_1697_atLeastatMost__psubset__iff,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ord_less @ ( set @ A ) @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) @ ( set_or1337092689740270186AtMost @ A @ C2 @ D2 ) )
          = ( ( ~ ( ord_less_eq @ A @ A2 @ B2 )
              | ( ( ord_less_eq @ A @ C2 @ A2 )
                & ( ord_less_eq @ A @ B2 @ D2 )
                & ( ( ord_less @ A @ C2 @ A2 )
                  | ( ord_less @ A @ B2 @ D2 ) ) ) )
            & ( ord_less_eq @ A @ C2 @ D2 ) ) ) ) ).

% atLeastatMost_psubset_iff
thf(fact_1698_double__diff,axiom,
    ! [A: $tType,A3: set @ A,B3: set @ A,C6: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ B3 )
     => ( ( ord_less_eq @ ( set @ A ) @ B3 @ C6 )
       => ( ( minus_minus @ ( set @ A ) @ B3 @ ( minus_minus @ ( set @ A ) @ C6 @ A3 ) )
          = A3 ) ) ) ).

% double_diff
thf(fact_1699_Diff__subset,axiom,
    ! [A: $tType,A3: set @ A,B3: set @ A] : ( ord_less_eq @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ A3 @ B3 ) @ A3 ) ).

% Diff_subset
thf(fact_1700_Diff__mono,axiom,
    ! [A: $tType,A3: set @ A,C6: set @ A,D5: set @ A,B3: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ C6 )
     => ( ( ord_less_eq @ ( set @ A ) @ D5 @ B3 )
       => ( ord_less_eq @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ A3 @ B3 ) @ ( minus_minus @ ( set @ A ) @ C6 @ D5 ) ) ) ) ).

% Diff_mono
thf(fact_1701_Collect__mono__iff,axiom,
    ! [A: $tType,P: A > $o,Q: A > $o] :
      ( ( ord_less_eq @ ( set @ A ) @ ( collect @ A @ P ) @ ( collect @ A @ Q ) )
      = ( ! [X5: A] :
            ( ( P @ X5 )
           => ( Q @ X5 ) ) ) ) ).

% Collect_mono_iff
thf(fact_1702_set__eq__subset,axiom,
    ! [A: $tType] :
      ( ( ^ [Y3: set @ A,Z2: set @ A] : ( Y3 = Z2 ) )
      = ( ^ [A7: set @ A,B8: set @ A] :
            ( ( ord_less_eq @ ( set @ A ) @ A7 @ B8 )
            & ( ord_less_eq @ ( set @ A ) @ B8 @ A7 ) ) ) ) ).

% set_eq_subset
thf(fact_1703_subset__trans,axiom,
    ! [A: $tType,A3: set @ A,B3: set @ A,C6: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ B3 )
     => ( ( ord_less_eq @ ( set @ A ) @ B3 @ C6 )
       => ( ord_less_eq @ ( set @ A ) @ A3 @ C6 ) ) ) ).

% subset_trans
thf(fact_1704_Collect__mono,axiom,
    ! [A: $tType,P: A > $o,Q: A > $o] :
      ( ! [X3: A] :
          ( ( P @ X3 )
         => ( Q @ X3 ) )
     => ( ord_less_eq @ ( set @ A ) @ ( collect @ A @ P ) @ ( collect @ A @ Q ) ) ) ).

% Collect_mono
thf(fact_1705_subset__refl,axiom,
    ! [A: $tType,A3: set @ A] : ( ord_less_eq @ ( set @ A ) @ A3 @ A3 ) ).

% subset_refl
thf(fact_1706_subset__iff,axiom,
    ! [A: $tType] :
      ( ( ord_less_eq @ ( set @ A ) )
      = ( ^ [A7: set @ A,B8: set @ A] :
          ! [T3: A] :
            ( ( member @ A @ T3 @ A7 )
           => ( member @ A @ T3 @ B8 ) ) ) ) ).

% subset_iff
thf(fact_1707_equalityD2,axiom,
    ! [A: $tType,A3: set @ A,B3: set @ A] :
      ( ( A3 = B3 )
     => ( ord_less_eq @ ( set @ A ) @ B3 @ A3 ) ) ).

% equalityD2
thf(fact_1708_equalityD1,axiom,
    ! [A: $tType,A3: set @ A,B3: set @ A] :
      ( ( A3 = B3 )
     => ( ord_less_eq @ ( set @ A ) @ A3 @ B3 ) ) ).

% equalityD1
thf(fact_1709_subset__eq,axiom,
    ! [A: $tType] :
      ( ( ord_less_eq @ ( set @ A ) )
      = ( ^ [A7: set @ A,B8: set @ A] :
          ! [X5: A] :
            ( ( member @ A @ X5 @ A7 )
           => ( member @ A @ X5 @ B8 ) ) ) ) ).

% subset_eq
thf(fact_1710_equalityE,axiom,
    ! [A: $tType,A3: set @ A,B3: set @ A] :
      ( ( A3 = B3 )
     => ~ ( ( ord_less_eq @ ( set @ A ) @ A3 @ B3 )
         => ~ ( ord_less_eq @ ( set @ A ) @ B3 @ A3 ) ) ) ).

% equalityE
thf(fact_1711_subsetD,axiom,
    ! [A: $tType,A3: set @ A,B3: set @ A,C2: A] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ B3 )
     => ( ( member @ A @ C2 @ A3 )
       => ( member @ A @ C2 @ B3 ) ) ) ).

% subsetD
thf(fact_1712_in__mono,axiom,
    ! [A: $tType,A3: set @ A,B3: set @ A,X2: A] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ B3 )
     => ( ( member @ A @ X2 @ A3 )
       => ( member @ A @ X2 @ B3 ) ) ) ).

% in_mono
thf(fact_1713_psubset__imp__ex__mem,axiom,
    ! [A: $tType,A3: set @ A,B3: set @ A] :
      ( ( ord_less @ ( set @ A ) @ A3 @ B3 )
     => ? [B5: A] : ( member @ A @ B5 @ ( minus_minus @ ( set @ A ) @ B3 @ A3 ) ) ) ).

% psubset_imp_ex_mem
thf(fact_1714_psubsetD,axiom,
    ! [A: $tType,A3: set @ A,B3: set @ A,C2: A] :
      ( ( ord_less @ ( set @ A ) @ A3 @ B3 )
     => ( ( member @ A @ C2 @ A3 )
       => ( member @ A @ C2 @ B3 ) ) ) ).

% psubsetD
thf(fact_1715_psubset__trans,axiom,
    ! [A: $tType,A3: set @ A,B3: set @ A,C6: set @ A] :
      ( ( ord_less @ ( set @ A ) @ A3 @ B3 )
     => ( ( ord_less @ ( set @ A ) @ B3 @ C6 )
       => ( ord_less @ ( set @ A ) @ A3 @ C6 ) ) ) ).

% psubset_trans
thf(fact_1716_less__eq__set__def,axiom,
    ! [A: $tType] :
      ( ( ord_less_eq @ ( set @ A ) )
      = ( ^ [A7: set @ A,B8: set @ A] :
            ( ord_less_eq @ ( A > $o )
            @ ^ [X5: A] : ( member @ A @ X5 @ A7 )
            @ ^ [X5: A] : ( member @ A @ X5 @ B8 ) ) ) ) ).

% less_eq_set_def
thf(fact_1717_Collect__subset,axiom,
    ! [A: $tType,A3: set @ A,P: A > $o] :
      ( ord_less_eq @ ( set @ A )
      @ ( collect @ A
        @ ^ [X5: A] :
            ( ( member @ A @ X5 @ A3 )
            & ( P @ X5 ) ) )
      @ A3 ) ).

% Collect_subset
thf(fact_1718_less__set__def,axiom,
    ! [A: $tType] :
      ( ( ord_less @ ( set @ A ) )
      = ( ^ [A7: set @ A,B8: set @ A] :
            ( ord_less @ ( A > $o )
            @ ^ [X5: A] : ( member @ A @ X5 @ A7 )
            @ ^ [X5: A] : ( member @ A @ X5 @ B8 ) ) ) ) ).

% less_set_def
thf(fact_1719_subset__iff__psubset__eq,axiom,
    ! [A: $tType] :
      ( ( ord_less_eq @ ( set @ A ) )
      = ( ^ [A7: set @ A,B8: set @ A] :
            ( ( ord_less @ ( set @ A ) @ A7 @ B8 )
            | ( A7 = B8 ) ) ) ) ).

% subset_iff_psubset_eq
thf(fact_1720_subset__psubset__trans,axiom,
    ! [A: $tType,A3: set @ A,B3: set @ A,C6: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ B3 )
     => ( ( ord_less @ ( set @ A ) @ B3 @ C6 )
       => ( ord_less @ ( set @ A ) @ A3 @ C6 ) ) ) ).

% subset_psubset_trans
thf(fact_1721_subset__not__subset__eq,axiom,
    ! [A: $tType] :
      ( ( ord_less @ ( set @ A ) )
      = ( ^ [A7: set @ A,B8: set @ A] :
            ( ( ord_less_eq @ ( set @ A ) @ A7 @ B8 )
            & ~ ( ord_less_eq @ ( set @ A ) @ B8 @ A7 ) ) ) ) ).

% subset_not_subset_eq
thf(fact_1722_psubset__subset__trans,axiom,
    ! [A: $tType,A3: set @ A,B3: set @ A,C6: set @ A] :
      ( ( ord_less @ ( set @ A ) @ A3 @ B3 )
     => ( ( ord_less_eq @ ( set @ A ) @ B3 @ C6 )
       => ( ord_less @ ( set @ A ) @ A3 @ C6 ) ) ) ).

% psubset_subset_trans
thf(fact_1723_psubset__imp__subset,axiom,
    ! [A: $tType,A3: set @ A,B3: set @ A] :
      ( ( ord_less @ ( set @ A ) @ A3 @ B3 )
     => ( ord_less_eq @ ( set @ A ) @ A3 @ B3 ) ) ).

% psubset_imp_subset
thf(fact_1724_psubset__eq,axiom,
    ! [A: $tType] :
      ( ( ord_less @ ( set @ A ) )
      = ( ^ [A7: set @ A,B8: set @ A] :
            ( ( ord_less_eq @ ( set @ A ) @ A7 @ B8 )
            & ( A7 != B8 ) ) ) ) ).

% psubset_eq
thf(fact_1725_psubsetE,axiom,
    ! [A: $tType,A3: set @ A,B3: set @ A] :
      ( ( ord_less @ ( set @ A ) @ A3 @ B3 )
     => ~ ( ( ord_less_eq @ ( set @ A ) @ A3 @ B3 )
         => ( ord_less_eq @ ( set @ A ) @ B3 @ A3 ) ) ) ).

% psubsetE
thf(fact_1726_vebt__buildup_Osimps_I3_J,axiom,
    ! [Va3: nat] :
      ( ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( suc @ ( suc @ Va3 ) ) )
       => ( ( vEBT_vebt_buildup @ ( suc @ ( suc @ Va3 ) ) )
          = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ ( suc @ Va3 ) ) @ ( replicate @ vEBT_VEBT @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( divide_divide @ nat @ ( suc @ ( suc @ Va3 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( vEBT_vebt_buildup @ ( divide_divide @ nat @ ( suc @ ( suc @ Va3 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_vebt_buildup @ ( divide_divide @ nat @ ( suc @ ( suc @ Va3 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) )
      & ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( suc @ ( suc @ Va3 ) ) )
       => ( ( vEBT_vebt_buildup @ ( suc @ ( suc @ Va3 ) ) )
          = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ ( suc @ Va3 ) ) @ ( replicate @ vEBT_VEBT @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( suc @ ( divide_divide @ nat @ ( suc @ ( suc @ Va3 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_vebt_buildup @ ( divide_divide @ nat @ ( suc @ ( suc @ Va3 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_vebt_buildup @ ( suc @ ( divide_divide @ nat @ ( suc @ ( suc @ Va3 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ).

% vebt_buildup.simps(3)
thf(fact_1727_triangle__def,axiom,
    ( nat_triangle
    = ( ^ [N3: nat] : ( divide_divide @ nat @ ( times_times @ nat @ N3 @ ( suc @ N3 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ).

% triangle_def
thf(fact_1728_old_Oprod_Orec,axiom,
    ! [A: $tType,T: $tType,B: $tType,F1: A > B > T,A2: A,B2: B] :
      ( ( product_rec_prod @ A @ B @ T @ F1 @ ( product_Pair @ A @ B @ A2 @ B2 ) )
      = ( F1 @ A2 @ B2 ) ) ).

% old.prod.rec
thf(fact_1729_signed__take__bit__rec,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( ( bit_ri4674362597316999326ke_bit @ A )
        = ( ^ [N3: nat,A4: A] :
              ( if @ A
              @ ( N3
                = ( zero_zero @ nat ) )
              @ ( uminus_uminus @ A @ ( modulo_modulo @ A @ A4 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) )
              @ ( plus_plus @ A @ ( modulo_modulo @ A @ A4 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_ri4674362597316999326ke_bit @ A @ ( minus_minus @ nat @ N3 @ ( one_one @ nat ) ) @ ( divide_divide @ A @ A4 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ).

% signed_take_bit_rec
thf(fact_1730_vebt__buildup_Opelims,axiom,
    ! [X2: nat,Y2: vEBT_VEBT] :
      ( ( ( vEBT_vebt_buildup @ X2 )
        = Y2 )
     => ( ( accp @ nat @ vEBT_v4011308405150292612up_rel @ X2 )
       => ( ( ( X2
              = ( zero_zero @ nat ) )
           => ( ( Y2
                = ( vEBT_Leaf @ $false @ $false ) )
             => ~ ( accp @ nat @ vEBT_v4011308405150292612up_rel @ ( zero_zero @ nat ) ) ) )
         => ( ( ( X2
                = ( suc @ ( zero_zero @ nat ) ) )
             => ( ( Y2
                  = ( vEBT_Leaf @ $false @ $false ) )
               => ~ ( accp @ nat @ vEBT_v4011308405150292612up_rel @ ( suc @ ( zero_zero @ nat ) ) ) ) )
           => ~ ! [Va: nat] :
                  ( ( X2
                    = ( suc @ ( suc @ Va ) ) )
                 => ( ( ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( suc @ ( suc @ Va ) ) )
                       => ( Y2
                          = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ ( suc @ Va ) ) @ ( replicate @ vEBT_VEBT @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( vEBT_vebt_buildup @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_vebt_buildup @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) )
                      & ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( suc @ ( suc @ Va ) ) )
                       => ( Y2
                          = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ ( suc @ Va ) ) @ ( replicate @ vEBT_VEBT @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( suc @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_vebt_buildup @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_vebt_buildup @ ( suc @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) )
                   => ~ ( accp @ nat @ vEBT_v4011308405150292612up_rel @ ( suc @ ( suc @ Va ) ) ) ) ) ) ) ) ) ).

% vebt_buildup.pelims
thf(fact_1731_flip__bit__0,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A] :
          ( ( bit_se8732182000553998342ip_bit @ A @ ( zero_zero @ nat ) @ A2 )
          = ( plus_plus @ A @ ( zero_neq_one_of_bool @ A @ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% flip_bit_0
thf(fact_1732_set__decode__0,axiom,
    ! [X2: nat] :
      ( ( member @ nat @ ( zero_zero @ nat ) @ ( nat_set_decode @ X2 ) )
      = ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ X2 ) ) ) ).

% set_decode_0
thf(fact_1733_set__decode__Suc,axiom,
    ! [N2: nat,X2: nat] :
      ( ( member @ nat @ ( suc @ N2 ) @ ( nat_set_decode @ X2 ) )
      = ( member @ nat @ N2 @ ( nat_set_decode @ ( divide_divide @ nat @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% set_decode_Suc
thf(fact_1734_neg__equal__iff__equal,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ( uminus_uminus @ A @ A2 )
            = ( uminus_uminus @ A @ B2 ) )
          = ( A2 = B2 ) ) ) ).

% neg_equal_iff_equal
thf(fact_1735_add_Oinverse__inverse,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A] :
          ( ( uminus_uminus @ A @ ( uminus_uminus @ A @ A2 ) )
          = A2 ) ) ).

% add.inverse_inverse
thf(fact_1736_Compl__subset__Compl__iff,axiom,
    ! [A: $tType,A3: set @ A,B3: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ ( uminus_uminus @ ( set @ A ) @ A3 ) @ ( uminus_uminus @ ( set @ A ) @ B3 ) )
      = ( ord_less_eq @ ( set @ A ) @ B3 @ A3 ) ) ).

% Compl_subset_Compl_iff
thf(fact_1737_Compl__anti__mono,axiom,
    ! [A: $tType,A3: set @ A,B3: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ B3 )
     => ( ord_less_eq @ ( set @ A ) @ ( uminus_uminus @ ( set @ A ) @ B3 ) @ ( uminus_uminus @ ( set @ A ) @ A3 ) ) ) ).

% Compl_anti_mono
thf(fact_1738_neg__le__iff__le,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ B2 ) @ ( uminus_uminus @ A @ A2 ) )
          = ( ord_less_eq @ A @ A2 @ B2 ) ) ) ).

% neg_le_iff_le
thf(fact_1739_add_Oinverse__neutral,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ( ( uminus_uminus @ A @ ( zero_zero @ A ) )
        = ( zero_zero @ A ) ) ) ).

% add.inverse_neutral
thf(fact_1740_neg__0__equal__iff__equal,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A] :
          ( ( ( zero_zero @ A )
            = ( uminus_uminus @ A @ A2 ) )
          = ( ( zero_zero @ A )
            = A2 ) ) ) ).

% neg_0_equal_iff_equal
thf(fact_1741_neg__equal__0__iff__equal,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A] :
          ( ( ( uminus_uminus @ A @ A2 )
            = ( zero_zero @ A ) )
          = ( A2
            = ( zero_zero @ A ) ) ) ) ).

% neg_equal_0_iff_equal
thf(fact_1742_equal__neg__zero,axiom,
    ! [A: $tType] :
      ( ( linord5086331880401160121up_add @ A )
     => ! [A2: A] :
          ( ( A2
            = ( uminus_uminus @ A @ A2 ) )
          = ( A2
            = ( zero_zero @ A ) ) ) ) ).

% equal_neg_zero
thf(fact_1743_neg__equal__zero,axiom,
    ! [A: $tType] :
      ( ( linord5086331880401160121up_add @ A )
     => ! [A2: A] :
          ( ( ( uminus_uminus @ A @ A2 )
            = A2 )
          = ( A2
            = ( zero_zero @ A ) ) ) ) ).

% neg_equal_zero
thf(fact_1744_neg__less__iff__less,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less @ A @ ( uminus_uminus @ A @ B2 ) @ ( uminus_uminus @ A @ A2 ) )
          = ( ord_less @ A @ A2 @ B2 ) ) ) ).

% neg_less_iff_less
thf(fact_1745_neg__numeral__eq__iff,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [M: num,N2: num] :
          ( ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) )
            = ( uminus_uminus @ A @ ( numeral_numeral @ A @ N2 ) ) )
          = ( M = N2 ) ) ) ).

% neg_numeral_eq_iff
thf(fact_1746_mult__minus__left,axiom,
    ! [A: $tType] :
      ( ( ring @ A )
     => ! [A2: A,B2: A] :
          ( ( times_times @ A @ ( uminus_uminus @ A @ A2 ) @ B2 )
          = ( uminus_uminus @ A @ ( times_times @ A @ A2 @ B2 ) ) ) ) ).

% mult_minus_left
thf(fact_1747_minus__mult__minus,axiom,
    ! [A: $tType] :
      ( ( ring @ A )
     => ! [A2: A,B2: A] :
          ( ( times_times @ A @ ( uminus_uminus @ A @ A2 ) @ ( uminus_uminus @ A @ B2 ) )
          = ( times_times @ A @ A2 @ B2 ) ) ) ).

% minus_mult_minus
thf(fact_1748_mult__minus__right,axiom,
    ! [A: $tType] :
      ( ( ring @ A )
     => ! [A2: A,B2: A] :
          ( ( times_times @ A @ A2 @ ( uminus_uminus @ A @ B2 ) )
          = ( uminus_uminus @ A @ ( times_times @ A @ A2 @ B2 ) ) ) ) ).

% mult_minus_right
thf(fact_1749_add__minus__cancel,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( plus_plus @ A @ A2 @ ( plus_plus @ A @ ( uminus_uminus @ A @ A2 ) @ B2 ) )
          = B2 ) ) ).

% add_minus_cancel
thf(fact_1750_minus__add__cancel,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( plus_plus @ A @ ( uminus_uminus @ A @ A2 ) @ ( plus_plus @ A @ A2 @ B2 ) )
          = B2 ) ) ).

% minus_add_cancel
thf(fact_1751_minus__add__distrib,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( uminus_uminus @ A @ ( plus_plus @ A @ A2 @ B2 ) )
          = ( plus_plus @ A @ ( uminus_uminus @ A @ A2 ) @ ( uminus_uminus @ A @ B2 ) ) ) ) ).

% minus_add_distrib
thf(fact_1752_minus__diff__eq,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( uminus_uminus @ A @ ( minus_minus @ A @ A2 @ B2 ) )
          = ( minus_minus @ A @ B2 @ A2 ) ) ) ).

% minus_diff_eq
thf(fact_1753_div__minus__minus,axiom,
    ! [A: $tType] :
      ( ( euclid8851590272496341667cancel @ A )
     => ! [A2: A,B2: A] :
          ( ( divide_divide @ A @ ( uminus_uminus @ A @ A2 ) @ ( uminus_uminus @ A @ B2 ) )
          = ( divide_divide @ A @ A2 @ B2 ) ) ) ).

% div_minus_minus
thf(fact_1754_minus__dvd__iff,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [X2: A,Y2: A] :
          ( ( dvd_dvd @ A @ ( uminus_uminus @ A @ X2 ) @ Y2 )
          = ( dvd_dvd @ A @ X2 @ Y2 ) ) ) ).

% minus_dvd_iff
thf(fact_1755_dvd__minus__iff,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [X2: A,Y2: A] :
          ( ( dvd_dvd @ A @ X2 @ ( uminus_uminus @ A @ Y2 ) )
          = ( dvd_dvd @ A @ X2 @ Y2 ) ) ) ).

% dvd_minus_iff
thf(fact_1756_mod__minus__minus,axiom,
    ! [A: $tType] :
      ( ( euclid8851590272496341667cancel @ A )
     => ! [A2: A,B2: A] :
          ( ( modulo_modulo @ A @ ( uminus_uminus @ A @ A2 ) @ ( uminus_uminus @ A @ B2 ) )
          = ( uminus_uminus @ A @ ( modulo_modulo @ A @ A2 @ B2 ) ) ) ) ).

% mod_minus_minus
thf(fact_1757_of__bool__less__eq__iff,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [P: $o,Q: $o] :
          ( ( ord_less_eq @ A @ ( zero_neq_one_of_bool @ A @ P ) @ ( zero_neq_one_of_bool @ A @ Q ) )
          = ( P
           => Q ) ) ) ).

% of_bool_less_eq_iff
thf(fact_1758_of__bool__eq_I1_J,axiom,
    ! [A: $tType] :
      ( ( zero_neq_one @ A )
     => ( ( zero_neq_one_of_bool @ A @ $false )
        = ( zero_zero @ A ) ) ) ).

% of_bool_eq(1)
thf(fact_1759_of__bool__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( zero_neq_one @ A )
     => ! [P: $o] :
          ( ( ( zero_neq_one_of_bool @ A @ P )
            = ( zero_zero @ A ) )
          = ( ~ P ) ) ) ).

% of_bool_eq_0_iff
thf(fact_1760_real__add__minus__iff,axiom,
    ! [X2: real,A2: real] :
      ( ( ( plus_plus @ real @ X2 @ ( uminus_uminus @ real @ A2 ) )
        = ( zero_zero @ real ) )
      = ( X2 = A2 ) ) ).

% real_add_minus_iff
thf(fact_1761_of__bool__less__iff,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [P: $o,Q: $o] :
          ( ( ord_less @ A @ ( zero_neq_one_of_bool @ A @ P ) @ ( zero_neq_one_of_bool @ A @ Q ) )
          = ( ~ P
            & Q ) ) ) ).

% of_bool_less_iff
thf(fact_1762_of__bool__eq_I2_J,axiom,
    ! [A: $tType] :
      ( ( zero_neq_one @ A )
     => ( ( zero_neq_one_of_bool @ A @ $true )
        = ( one_one @ A ) ) ) ).

% of_bool_eq(2)
thf(fact_1763_of__bool__eq__1__iff,axiom,
    ! [A: $tType] :
      ( ( zero_neq_one @ A )
     => ! [P: $o] :
          ( ( ( zero_neq_one_of_bool @ A @ P )
            = ( one_one @ A ) )
          = P ) ) ).

% of_bool_eq_1_iff
thf(fact_1764_of__bool__or__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [P: $o,Q: $o] :
          ( ( zero_neq_one_of_bool @ A
            @ ( P
              | Q ) )
          = ( ord_max @ A @ ( zero_neq_one_of_bool @ A @ P ) @ ( zero_neq_one_of_bool @ A @ Q ) ) ) ) ).

% of_bool_or_iff
thf(fact_1765_triangle__0,axiom,
    ( ( nat_triangle @ ( zero_zero @ nat ) )
    = ( zero_zero @ nat ) ) ).

% triangle_0
thf(fact_1766_neg__0__le__iff__le,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( uminus_uminus @ A @ A2 ) )
          = ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) ) ) ) ).

% neg_0_le_iff_le
thf(fact_1767_neg__le__0__iff__le,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ A2 ) @ ( zero_zero @ A ) )
          = ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 ) ) ) ).

% neg_le_0_iff_le
thf(fact_1768_less__eq__neg__nonpos,axiom,
    ! [A: $tType] :
      ( ( linord5086331880401160121up_add @ A )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ A2 @ ( uminus_uminus @ A @ A2 ) )
          = ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) ) ) ) ).

% less_eq_neg_nonpos
thf(fact_1769_neg__less__eq__nonneg,axiom,
    ! [A: $tType] :
      ( ( linord5086331880401160121up_add @ A )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ A2 ) @ A2 )
          = ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 ) ) ) ).

% neg_less_eq_nonneg
thf(fact_1770_less__neg__neg,axiom,
    ! [A: $tType] :
      ( ( linord5086331880401160121up_add @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ A2 @ ( uminus_uminus @ A @ A2 ) )
          = ( ord_less @ A @ A2 @ ( zero_zero @ A ) ) ) ) ).

% less_neg_neg
thf(fact_1771_neg__less__pos,axiom,
    ! [A: $tType] :
      ( ( linord5086331880401160121up_add @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( uminus_uminus @ A @ A2 ) @ A2 )
          = ( ord_less @ A @ ( zero_zero @ A ) @ A2 ) ) ) ).

% neg_less_pos
thf(fact_1772_neg__0__less__iff__less,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( uminus_uminus @ A @ A2 ) )
          = ( ord_less @ A @ A2 @ ( zero_zero @ A ) ) ) ) ).

% neg_0_less_iff_less
thf(fact_1773_neg__less__0__iff__less,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( uminus_uminus @ A @ A2 ) @ ( zero_zero @ A ) )
          = ( ord_less @ A @ ( zero_zero @ A ) @ A2 ) ) ) ).

% neg_less_0_iff_less
thf(fact_1774_add_Oright__inverse,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A] :
          ( ( plus_plus @ A @ A2 @ ( uminus_uminus @ A @ A2 ) )
          = ( zero_zero @ A ) ) ) ).

% add.right_inverse
thf(fact_1775_ab__left__minus,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A] :
          ( ( plus_plus @ A @ ( uminus_uminus @ A @ A2 ) @ A2 )
          = ( zero_zero @ A ) ) ) ).

% ab_left_minus
thf(fact_1776_diff__0,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A] :
          ( ( minus_minus @ A @ ( zero_zero @ A ) @ A2 )
          = ( uminus_uminus @ A @ A2 ) ) ) ).

% diff_0
thf(fact_1777_verit__minus__simplify_I3_J,axiom,
    ! [B: $tType] :
      ( ( group_add @ B )
     => ! [B2: B] :
          ( ( minus_minus @ B @ ( zero_zero @ B ) @ B2 )
          = ( uminus_uminus @ B @ B2 ) ) ) ).

% verit_minus_simplify(3)
thf(fact_1778_add__neg__numeral__simps_I3_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [M: num,N2: num] :
          ( ( plus_plus @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N2 ) ) )
          = ( uminus_uminus @ A @ ( plus_plus @ A @ ( numeral_numeral @ A @ M ) @ ( numeral_numeral @ A @ N2 ) ) ) ) ) ).

% add_neg_numeral_simps(3)
thf(fact_1779_mult__minus1__right,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [Z: A] :
          ( ( times_times @ A @ Z @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( uminus_uminus @ A @ Z ) ) ) ).

% mult_minus1_right
thf(fact_1780_mult__minus1,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [Z: A] :
          ( ( times_times @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ Z )
          = ( uminus_uminus @ A @ Z ) ) ) ).

% mult_minus1
thf(fact_1781_uminus__add__conv__diff,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( plus_plus @ A @ ( uminus_uminus @ A @ A2 ) @ B2 )
          = ( minus_minus @ A @ B2 @ A2 ) ) ) ).

% uminus_add_conv_diff
thf(fact_1782_diff__minus__eq__add,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( minus_minus @ A @ A2 @ ( uminus_uminus @ A @ B2 ) )
          = ( plus_plus @ A @ A2 @ B2 ) ) ) ).

% diff_minus_eq_add
thf(fact_1783_divide__minus1,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [X2: A] :
          ( ( divide_divide @ A @ X2 @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( uminus_uminus @ A @ X2 ) ) ) ).

% divide_minus1
thf(fact_1784_div__minus1__right,axiom,
    ! [A: $tType] :
      ( ( euclid8851590272496341667cancel @ A )
     => ! [A2: A] :
          ( ( divide_divide @ A @ A2 @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( uminus_uminus @ A @ A2 ) ) ) ).

% div_minus1_right
thf(fact_1785_minus__mod__self1,axiom,
    ! [A: $tType] :
      ( ( euclid8851590272496341667cancel @ A )
     => ! [B2: A,A2: A] :
          ( ( modulo_modulo @ A @ ( minus_minus @ A @ B2 @ A2 ) @ B2 )
          = ( modulo_modulo @ A @ ( uminus_uminus @ A @ A2 ) @ B2 ) ) ) ).

% minus_mod_self1
thf(fact_1786_zero__less__of__bool__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [P: $o] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( zero_neq_one_of_bool @ A @ P ) )
          = P ) ) ).

% zero_less_of_bool_iff
thf(fact_1787_of__bool__less__one__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [P: $o] :
          ( ( ord_less @ A @ ( zero_neq_one_of_bool @ A @ P ) @ ( one_one @ A ) )
          = ( ~ P ) ) ) ).

% of_bool_less_one_iff
thf(fact_1788_of__bool__not__iff,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [P: $o] :
          ( ( zero_neq_one_of_bool @ A @ ~ P )
          = ( minus_minus @ A @ ( one_one @ A ) @ ( zero_neq_one_of_bool @ A @ P ) ) ) ) ).

% of_bool_not_iff
thf(fact_1789_Suc__0__mod__eq,axiom,
    ! [N2: nat] :
      ( ( modulo_modulo @ nat @ ( suc @ ( zero_zero @ nat ) ) @ N2 )
      = ( zero_neq_one_of_bool @ nat
        @ ( N2
         != ( suc @ ( zero_zero @ nat ) ) ) ) ) ).

% Suc_0_mod_eq
thf(fact_1790_signed__take__bit__of__minus__1,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N2: nat] :
          ( ( bit_ri4674362597316999326ke_bit @ A @ N2 @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% signed_take_bit_of_minus_1
thf(fact_1791_dbl__simps_I1_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [K: num] :
          ( ( neg_numeral_dbl @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ K ) ) )
          = ( uminus_uminus @ A @ ( neg_numeral_dbl @ A @ ( numeral_numeral @ A @ K ) ) ) ) ) ).

% dbl_simps(1)
thf(fact_1792_triangle__Suc,axiom,
    ! [N2: nat] :
      ( ( nat_triangle @ ( suc @ N2 ) )
      = ( plus_plus @ nat @ ( nat_triangle @ N2 ) @ ( suc @ N2 ) ) ) ).

% triangle_Suc
thf(fact_1793_add__neg__numeral__special_I8_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( plus_plus @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( one_one @ A ) )
        = ( zero_zero @ A ) ) ) ).

% add_neg_numeral_special(8)
thf(fact_1794_add__neg__numeral__special_I7_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( plus_plus @ A @ ( one_one @ A ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
        = ( zero_zero @ A ) ) ) ).

% add_neg_numeral_special(7)
thf(fact_1795_diff__numeral__special_I12_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( minus_minus @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
        = ( zero_zero @ A ) ) ) ).

% diff_numeral_special(12)
thf(fact_1796_neg__one__eq__numeral__iff,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [N2: num] :
          ( ( ( uminus_uminus @ A @ ( one_one @ A ) )
            = ( uminus_uminus @ A @ ( numeral_numeral @ A @ N2 ) ) )
          = ( N2 = one2 ) ) ) ).

% neg_one_eq_numeral_iff
thf(fact_1797_numeral__eq__neg__one__iff,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [N2: num] :
          ( ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ N2 ) )
            = ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( N2 = one2 ) ) ) ).

% numeral_eq_neg_one_iff
thf(fact_1798_minus__one__mult__self,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [N2: nat] :
          ( ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ N2 ) @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ N2 ) )
          = ( one_one @ A ) ) ) ).

% minus_one_mult_self
thf(fact_1799_left__minus__one__mult__self,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [N2: nat,A2: A] :
          ( ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ N2 ) @ ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ N2 ) @ A2 ) )
          = A2 ) ) ).

% left_minus_one_mult_self
thf(fact_1800_mod__minus1__right,axiom,
    ! [A: $tType] :
      ( ( euclid8851590272496341667cancel @ A )
     => ! [A2: A] :
          ( ( modulo_modulo @ A @ A2 @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( zero_zero @ A ) ) ) ).

% mod_minus1_right
thf(fact_1801_max__number__of_I4_J,axiom,
    ! [A: $tType] :
      ( ( ( uminus @ A )
        & ( numeral @ A )
        & ( ord @ A ) )
     => ! [U: num,V: num] :
          ( ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ U ) ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) )
           => ( ( ord_max @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ U ) ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) )
              = ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) ) )
          & ( ~ ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ U ) ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) )
           => ( ( ord_max @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ U ) ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) )
              = ( uminus_uminus @ A @ ( numeral_numeral @ A @ U ) ) ) ) ) ) ).

% max_number_of(4)
thf(fact_1802_max__number__of_I3_J,axiom,
    ! [A: $tType] :
      ( ( ( uminus @ A )
        & ( numeral @ A )
        & ( ord @ A ) )
     => ! [U: num,V: num] :
          ( ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ U ) ) @ ( numeral_numeral @ A @ V ) )
           => ( ( ord_max @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ U ) ) @ ( numeral_numeral @ A @ V ) )
              = ( numeral_numeral @ A @ V ) ) )
          & ( ~ ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ U ) ) @ ( numeral_numeral @ A @ V ) )
           => ( ( ord_max @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ U ) ) @ ( numeral_numeral @ A @ V ) )
              = ( uminus_uminus @ A @ ( numeral_numeral @ A @ U ) ) ) ) ) ) ).

% max_number_of(3)
thf(fact_1803_max__number__of_I2_J,axiom,
    ! [A: $tType] :
      ( ( ( uminus @ A )
        & ( numeral @ A )
        & ( ord @ A ) )
     => ! [U: num,V: num] :
          ( ( ( ord_less_eq @ A @ ( numeral_numeral @ A @ U ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) )
           => ( ( ord_max @ A @ ( numeral_numeral @ A @ U ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) )
              = ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) ) )
          & ( ~ ( ord_less_eq @ A @ ( numeral_numeral @ A @ U ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) )
           => ( ( ord_max @ A @ ( numeral_numeral @ A @ U ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) )
              = ( numeral_numeral @ A @ U ) ) ) ) ) ).

% max_number_of(2)
thf(fact_1804_semiring__norm_I168_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [V: num,W: num,Y2: A] :
          ( ( plus_plus @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) @ ( plus_plus @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) @ Y2 ) )
          = ( plus_plus @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( plus_plus @ num @ V @ W ) ) ) @ Y2 ) ) ) ).

% semiring_norm(168)
thf(fact_1805_diff__numeral__simps_I2_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [M: num,N2: num] :
          ( ( minus_minus @ A @ ( numeral_numeral @ A @ M ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N2 ) ) )
          = ( numeral_numeral @ A @ ( plus_plus @ num @ M @ N2 ) ) ) ) ).

% diff_numeral_simps(2)
thf(fact_1806_diff__numeral__simps_I3_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [M: num,N2: num] :
          ( ( minus_minus @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) @ ( numeral_numeral @ A @ N2 ) )
          = ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( plus_plus @ num @ M @ N2 ) ) ) ) ) ).

% diff_numeral_simps(3)
thf(fact_1807_semiring__norm_I172_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [V: num,W: num,Y2: A] :
          ( ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) @ ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) @ Y2 ) )
          = ( times_times @ A @ ( numeral_numeral @ A @ ( times_times @ num @ V @ W ) ) @ Y2 ) ) ) ).

% semiring_norm(172)
thf(fact_1808_semiring__norm_I171_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [V: num,W: num,Y2: A] :
          ( ( times_times @ A @ ( numeral_numeral @ A @ V ) @ ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) @ Y2 ) )
          = ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( times_times @ num @ V @ W ) ) ) @ Y2 ) ) ) ).

% semiring_norm(171)
thf(fact_1809_semiring__norm_I170_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [V: num,W: num,Y2: A] :
          ( ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) @ ( times_times @ A @ ( numeral_numeral @ A @ W ) @ Y2 ) )
          = ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( times_times @ num @ V @ W ) ) ) @ Y2 ) ) ) ).

% semiring_norm(170)
thf(fact_1810_mult__neg__numeral__simps_I1_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [M: num,N2: num] :
          ( ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N2 ) ) )
          = ( numeral_numeral @ A @ ( times_times @ num @ M @ N2 ) ) ) ) ).

% mult_neg_numeral_simps(1)
thf(fact_1811_mult__neg__numeral__simps_I2_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [M: num,N2: num] :
          ( ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) @ ( numeral_numeral @ A @ N2 ) )
          = ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( times_times @ num @ M @ N2 ) ) ) ) ) ).

% mult_neg_numeral_simps(2)
thf(fact_1812_mult__neg__numeral__simps_I3_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [M: num,N2: num] :
          ( ( times_times @ A @ ( numeral_numeral @ A @ M ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N2 ) ) )
          = ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( times_times @ num @ M @ N2 ) ) ) ) ) ).

% mult_neg_numeral_simps(3)
thf(fact_1813_neg__numeral__le__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M: num,N2: num] :
          ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N2 ) ) )
          = ( ord_less_eq @ num @ N2 @ M ) ) ) ).

% neg_numeral_le_iff
thf(fact_1814_neg__numeral__less__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M: num,N2: num] :
          ( ( ord_less @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N2 ) ) )
          = ( ord_less @ num @ N2 @ M ) ) ) ).

% neg_numeral_less_iff
thf(fact_1815_not__neg__one__le__neg__numeral__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M: num] :
          ( ( ~ ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) ) )
          = ( ( M != one2 ) ) ) ) ).

% not_neg_one_le_neg_numeral_iff
thf(fact_1816_divide__le__eq__numeral1_I2_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,W: num,A2: A] :
          ( ( ord_less_eq @ A @ ( divide_divide @ A @ B2 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) ) @ A2 )
          = ( ord_less_eq @ A @ ( times_times @ A @ A2 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) ) @ B2 ) ) ) ).

% divide_le_eq_numeral1(2)
thf(fact_1817_le__divide__eq__numeral1_I2_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A,W: num] :
          ( ( ord_less_eq @ A @ A2 @ ( divide_divide @ A @ B2 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) ) )
          = ( ord_less_eq @ A @ B2 @ ( times_times @ A @ A2 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) ) ) ) ) ).

% le_divide_eq_numeral1(2)
thf(fact_1818_divide__eq__eq__numeral1_I2_J,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [B2: A,W: num,A2: A] :
          ( ( ( divide_divide @ A @ B2 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) )
            = A2 )
          = ( ( ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) )
               != ( zero_zero @ A ) )
             => ( B2
                = ( times_times @ A @ A2 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) ) ) )
            & ( ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) )
                = ( zero_zero @ A ) )
             => ( A2
                = ( zero_zero @ A ) ) ) ) ) ) ).

% divide_eq_eq_numeral1(2)
thf(fact_1819_eq__divide__eq__numeral1_I2_J,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A,B2: A,W: num] :
          ( ( A2
            = ( divide_divide @ A @ B2 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) ) )
          = ( ( ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) )
               != ( zero_zero @ A ) )
             => ( ( times_times @ A @ A2 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) )
                = B2 ) )
            & ( ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) )
                = ( zero_zero @ A ) )
             => ( A2
                = ( zero_zero @ A ) ) ) ) ) ) ).

% eq_divide_eq_numeral1(2)
thf(fact_1820_neg__numeral__less__neg__one__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M: num] :
          ( ( ord_less @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( ( M != one2 ) ) ) ) ).

% neg_numeral_less_neg_one_iff
thf(fact_1821_divide__less__eq__numeral1_I2_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,W: num,A2: A] :
          ( ( ord_less @ A @ ( divide_divide @ A @ B2 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) ) @ A2 )
          = ( ord_less @ A @ ( times_times @ A @ A2 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) ) @ B2 ) ) ) ).

% divide_less_eq_numeral1(2)
thf(fact_1822_less__divide__eq__numeral1_I2_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A,W: num] :
          ( ( ord_less @ A @ A2 @ ( divide_divide @ A @ B2 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) ) )
          = ( ord_less @ A @ B2 @ ( times_times @ A @ A2 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) ) ) ) ) ).

% less_divide_eq_numeral1(2)
thf(fact_1823_power2__minus,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [A2: A] :
          ( ( power_power @ A @ ( uminus_uminus @ A @ A2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
          = ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ).

% power2_minus
thf(fact_1824_odd__of__bool__self,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [P4: $o] :
          ( ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( zero_neq_one_of_bool @ A @ P4 ) ) )
          = P4 ) ) ).

% odd_of_bool_self
thf(fact_1825_add__neg__numeral__special_I9_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( plus_plus @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
        = ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% add_neg_numeral_special(9)
thf(fact_1826_diff__numeral__special_I11_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( minus_minus @ A @ ( one_one @ A ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
        = ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ).

% diff_numeral_special(11)
thf(fact_1827_diff__numeral__special_I10_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( minus_minus @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( one_one @ A ) )
        = ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% diff_numeral_special(10)
thf(fact_1828_minus__1__div__2__eq,axiom,
    ! [A: $tType] :
      ( ( euclid8789492081693882211th_nat @ A )
     => ( ( divide_divide @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
        = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% minus_1_div_2_eq
thf(fact_1829_minus__1__mod__2__eq,axiom,
    ! [A: $tType] :
      ( ( euclid8789492081693882211th_nat @ A )
     => ( ( modulo_modulo @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
        = ( one_one @ A ) ) ) ).

% minus_1_mod_2_eq
thf(fact_1830_bits__minus__1__mod__2__eq,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( ( modulo_modulo @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
        = ( one_one @ A ) ) ) ).

% bits_minus_1_mod_2_eq
thf(fact_1831_Power_Oring__1__class_Opower__minus__even,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [A2: A,N2: nat] :
          ( ( power_power @ A @ ( uminus_uminus @ A @ A2 ) @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) )
          = ( power_power @ A @ A2 @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) ) ) ).

% Power.ring_1_class.power_minus_even
thf(fact_1832_of__bool__half__eq__0,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [B2: $o] :
          ( ( divide_divide @ A @ ( zero_neq_one_of_bool @ A @ B2 ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
          = ( zero_zero @ A ) ) ) ).

% of_bool_half_eq_0
thf(fact_1833_power__minus__odd,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [N2: nat,A2: A] :
          ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 )
         => ( ( power_power @ A @ ( uminus_uminus @ A @ A2 ) @ N2 )
            = ( uminus_uminus @ A @ ( power_power @ A @ A2 @ N2 ) ) ) ) ) ).

% power_minus_odd
thf(fact_1834_Parity_Oring__1__class_Opower__minus__even,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [N2: nat,A2: A] :
          ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 )
         => ( ( power_power @ A @ ( uminus_uminus @ A @ A2 ) @ N2 )
            = ( power_power @ A @ A2 @ N2 ) ) ) ) ).

% Parity.ring_1_class.power_minus_even
thf(fact_1835_diff__numeral__special_I3_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [N2: num] :
          ( ( minus_minus @ A @ ( one_one @ A ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N2 ) ) )
          = ( numeral_numeral @ A @ ( plus_plus @ num @ one2 @ N2 ) ) ) ) ).

% diff_numeral_special(3)
thf(fact_1836_diff__numeral__special_I4_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [M: num] :
          ( ( minus_minus @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) @ ( one_one @ A ) )
          = ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( plus_plus @ num @ M @ one2 ) ) ) ) ) ).

% diff_numeral_special(4)
thf(fact_1837_signed__take__bit__Suc__minus__bit0,axiom,
    ! [N2: nat,K: num] :
      ( ( bit_ri4674362597316999326ke_bit @ int @ ( suc @ N2 ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit0 @ K ) ) ) )
      = ( times_times @ int @ ( bit_ri4674362597316999326ke_bit @ int @ N2 @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ K ) ) ) @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ).

% signed_take_bit_Suc_minus_bit0
thf(fact_1838_dbl__simps_I4_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( neg_numeral_dbl @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
        = ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% dbl_simps(4)
thf(fact_1839_power__minus1__even,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [N2: nat] :
          ( ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) )
          = ( one_one @ A ) ) ) ).

% power_minus1_even
thf(fact_1840_neg__one__odd__power,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [N2: nat] :
          ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 )
         => ( ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ N2 )
            = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ) ).

% neg_one_odd_power
thf(fact_1841_neg__one__even__power,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [N2: nat] :
          ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 )
         => ( ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ N2 )
            = ( one_one @ A ) ) ) ) ).

% neg_one_even_power
thf(fact_1842_signed__take__bit__0,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [A2: A] :
          ( ( bit_ri4674362597316999326ke_bit @ A @ ( zero_zero @ nat ) @ A2 )
          = ( uminus_uminus @ A @ ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ).

% signed_take_bit_0
thf(fact_1843_bits__1__div__exp,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [N2: nat] :
          ( ( divide_divide @ A @ ( one_one @ A ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N2 ) )
          = ( zero_neq_one_of_bool @ A
            @ ( N2
              = ( zero_zero @ nat ) ) ) ) ) ).

% bits_1_div_exp
thf(fact_1844_one__div__2__pow__eq,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [N2: nat] :
          ( ( divide_divide @ A @ ( one_one @ A ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N2 ) )
          = ( zero_neq_one_of_bool @ A
            @ ( N2
              = ( zero_zero @ nat ) ) ) ) ) ).

% one_div_2_pow_eq
thf(fact_1845_one__mod__2__pow__eq,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [N2: nat] :
          ( ( modulo_modulo @ A @ ( one_one @ A ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N2 ) )
          = ( zero_neq_one_of_bool @ A @ ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 ) ) ) ) ).

% one_mod_2_pow_eq
thf(fact_1846_minus__equation__iff,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ( uminus_uminus @ A @ A2 )
            = B2 )
          = ( ( uminus_uminus @ A @ B2 )
            = A2 ) ) ) ).

% minus_equation_iff
thf(fact_1847_equation__minus__iff,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( A2
            = ( uminus_uminus @ A @ B2 ) )
          = ( B2
            = ( uminus_uminus @ A @ A2 ) ) ) ) ).

% equation_minus_iff
thf(fact_1848_of__bool__eq__iff,axiom,
    ! [A: $tType] :
      ( ( zero_neq_one @ A )
     => ! [P4: $o,Q3: $o] :
          ( ( ( zero_neq_one_of_bool @ A @ P4 )
            = ( zero_neq_one_of_bool @ A @ Q3 ) )
          = ( P4 = Q3 ) ) ) ).

% of_bool_eq_iff
thf(fact_1849_of__bool__conj,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [P: $o,Q: $o] :
          ( ( zero_neq_one_of_bool @ A
            @ ( P
              & Q ) )
          = ( times_times @ A @ ( zero_neq_one_of_bool @ A @ P ) @ ( zero_neq_one_of_bool @ A @ Q ) ) ) ) ).

% of_bool_conj
thf(fact_1850_le__minus__iff,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ ( uminus_uminus @ A @ B2 ) )
          = ( ord_less_eq @ A @ B2 @ ( uminus_uminus @ A @ A2 ) ) ) ) ).

% le_minus_iff
thf(fact_1851_minus__le__iff,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ A2 ) @ B2 )
          = ( ord_less_eq @ A @ ( uminus_uminus @ A @ B2 ) @ A2 ) ) ) ).

% minus_le_iff
thf(fact_1852_le__imp__neg__le,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ord_less_eq @ A @ ( uminus_uminus @ A @ B2 ) @ ( uminus_uminus @ A @ A2 ) ) ) ) ).

% le_imp_neg_le
thf(fact_1853_verit__negate__coefficient_I2_J,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ord_less @ A @ ( uminus_uminus @ A @ B2 ) @ ( uminus_uminus @ A @ A2 ) ) ) ) ).

% verit_negate_coefficient(2)
thf(fact_1854_less__minus__iff,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ ( uminus_uminus @ A @ B2 ) )
          = ( ord_less @ A @ B2 @ ( uminus_uminus @ A @ A2 ) ) ) ) ).

% less_minus_iff
thf(fact_1855_minus__less__iff,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( uminus_uminus @ A @ A2 ) @ B2 )
          = ( ord_less @ A @ ( uminus_uminus @ A @ B2 ) @ A2 ) ) ) ).

% minus_less_iff
thf(fact_1856_neg__numeral__neq__numeral,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [M: num,N2: num] :
          ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) )
         != ( numeral_numeral @ A @ N2 ) ) ) ).

% neg_numeral_neq_numeral
thf(fact_1857_numeral__neq__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [M: num,N2: num] :
          ( ( numeral_numeral @ A @ M )
         != ( uminus_uminus @ A @ ( numeral_numeral @ A @ N2 ) ) ) ) ).

% numeral_neq_neg_numeral
thf(fact_1858_square__eq__iff,axiom,
    ! [A: $tType] :
      ( ( idom @ A )
     => ! [A2: A,B2: A] :
          ( ( ( times_times @ A @ A2 @ A2 )
            = ( times_times @ A @ B2 @ B2 ) )
          = ( ( A2 = B2 )
            | ( A2
              = ( uminus_uminus @ A @ B2 ) ) ) ) ) ).

% square_eq_iff
thf(fact_1859_minus__mult__commute,axiom,
    ! [A: $tType] :
      ( ( ring @ A )
     => ! [A2: A,B2: A] :
          ( ( times_times @ A @ ( uminus_uminus @ A @ A2 ) @ B2 )
          = ( times_times @ A @ A2 @ ( uminus_uminus @ A @ B2 ) ) ) ) ).

% minus_mult_commute
thf(fact_1860_one__neq__neg__one,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ( ( one_one @ A )
       != ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% one_neq_neg_one
thf(fact_1861_group__cancel_Oneg1,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [A3: A,K: A,A2: A] :
          ( ( A3
            = ( plus_plus @ A @ K @ A2 ) )
         => ( ( uminus_uminus @ A @ A3 )
            = ( plus_plus @ A @ ( uminus_uminus @ A @ K ) @ ( uminus_uminus @ A @ A2 ) ) ) ) ) ).

% group_cancel.neg1
thf(fact_1862_add_Oinverse__distrib__swap,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( uminus_uminus @ A @ ( plus_plus @ A @ A2 @ B2 ) )
          = ( plus_plus @ A @ ( uminus_uminus @ A @ B2 ) @ ( uminus_uminus @ A @ A2 ) ) ) ) ).

% add.inverse_distrib_swap
thf(fact_1863_is__num__normalize_I8_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [A2: A,B2: A] :
          ( ( uminus_uminus @ A @ ( plus_plus @ A @ A2 @ B2 ) )
          = ( plus_plus @ A @ ( uminus_uminus @ A @ B2 ) @ ( uminus_uminus @ A @ A2 ) ) ) ) ).

% is_num_normalize(8)
thf(fact_1864_minus__diff__commute,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [B2: A,A2: A] :
          ( ( minus_minus @ A @ ( uminus_uminus @ A @ B2 ) @ A2 )
          = ( minus_minus @ A @ ( uminus_uminus @ A @ A2 ) @ B2 ) ) ) ).

% minus_diff_commute
thf(fact_1865_minus__diff__minus,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( minus_minus @ A @ ( uminus_uminus @ A @ A2 ) @ ( uminus_uminus @ A @ B2 ) )
          = ( uminus_uminus @ A @ ( minus_minus @ A @ A2 @ B2 ) ) ) ) ).

% minus_diff_minus
thf(fact_1866_minus__divide__right,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A2: A,B2: A] :
          ( ( uminus_uminus @ A @ ( divide_divide @ A @ A2 @ B2 ) )
          = ( divide_divide @ A @ A2 @ ( uminus_uminus @ A @ B2 ) ) ) ) ).

% minus_divide_right
thf(fact_1867_minus__divide__divide,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A2: A,B2: A] :
          ( ( divide_divide @ A @ ( uminus_uminus @ A @ A2 ) @ ( uminus_uminus @ A @ B2 ) )
          = ( divide_divide @ A @ A2 @ B2 ) ) ) ).

% minus_divide_divide
thf(fact_1868_minus__divide__left,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A,B2: A] :
          ( ( uminus_uminus @ A @ ( divide_divide @ A @ A2 @ B2 ) )
          = ( divide_divide @ A @ ( uminus_uminus @ A @ A2 ) @ B2 ) ) ) ).

% minus_divide_left
thf(fact_1869_div__minus__right,axiom,
    ! [A: $tType] :
      ( ( euclid8851590272496341667cancel @ A )
     => ! [A2: A,B2: A] :
          ( ( divide_divide @ A @ A2 @ ( uminus_uminus @ A @ B2 ) )
          = ( divide_divide @ A @ ( uminus_uminus @ A @ A2 ) @ B2 ) ) ) ).

% div_minus_right
thf(fact_1870_mod__minus__right,axiom,
    ! [A: $tType] :
      ( ( euclid8851590272496341667cancel @ A )
     => ! [A2: A,B2: A] :
          ( ( modulo_modulo @ A @ A2 @ ( uminus_uminus @ A @ B2 ) )
          = ( uminus_uminus @ A @ ( modulo_modulo @ A @ ( uminus_uminus @ A @ A2 ) @ B2 ) ) ) ) ).

% mod_minus_right
thf(fact_1871_mod__minus__cong,axiom,
    ! [A: $tType] :
      ( ( euclid8851590272496341667cancel @ A )
     => ! [A2: A,B2: A,A6: A] :
          ( ( ( modulo_modulo @ A @ A2 @ B2 )
            = ( modulo_modulo @ A @ A6 @ B2 ) )
         => ( ( modulo_modulo @ A @ ( uminus_uminus @ A @ A2 ) @ B2 )
            = ( modulo_modulo @ A @ ( uminus_uminus @ A @ A6 ) @ B2 ) ) ) ) ).

% mod_minus_cong
thf(fact_1872_mod__minus__eq,axiom,
    ! [A: $tType] :
      ( ( euclid8851590272496341667cancel @ A )
     => ! [A2: A,B2: A] :
          ( ( modulo_modulo @ A @ ( uminus_uminus @ A @ ( modulo_modulo @ A @ A2 @ B2 ) ) @ B2 )
          = ( modulo_modulo @ A @ ( uminus_uminus @ A @ A2 ) @ B2 ) ) ) ).

% mod_minus_eq
thf(fact_1873_uminus__int__code_I1_J,axiom,
    ( ( uminus_uminus @ int @ ( zero_zero @ int ) )
    = ( zero_zero @ int ) ) ).

% uminus_int_code(1)
thf(fact_1874_signed__take__bit__minus,axiom,
    ! [N2: nat,K: int] :
      ( ( bit_ri4674362597316999326ke_bit @ int @ N2 @ ( uminus_uminus @ int @ ( bit_ri4674362597316999326ke_bit @ int @ N2 @ K ) ) )
      = ( bit_ri4674362597316999326ke_bit @ int @ N2 @ ( uminus_uminus @ int @ K ) ) ) ).

% signed_take_bit_minus
thf(fact_1875_zero__less__eq__of__bool,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [P: $o] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( zero_neq_one_of_bool @ A @ P ) ) ) ).

% zero_less_eq_of_bool
thf(fact_1876_of__bool__less__eq__one,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [P: $o] : ( ord_less_eq @ A @ ( zero_neq_one_of_bool @ A @ P ) @ ( one_one @ A ) ) ) ).

% of_bool_less_eq_one
thf(fact_1877_of__bool__def,axiom,
    ! [A: $tType] :
      ( ( zero_neq_one @ A )
     => ( ( zero_neq_one_of_bool @ A )
        = ( ^ [P6: $o] : ( if @ A @ P6 @ ( one_one @ A ) @ ( zero_zero @ A ) ) ) ) ) ).

% of_bool_def
thf(fact_1878_split__of__bool,axiom,
    ! [A: $tType] :
      ( ( zero_neq_one @ A )
     => ! [P: A > $o,P4: $o] :
          ( ( P @ ( zero_neq_one_of_bool @ A @ P4 ) )
          = ( ( P4
             => ( P @ ( one_one @ A ) ) )
            & ( ~ P4
             => ( P @ ( zero_zero @ A ) ) ) ) ) ) ).

% split_of_bool
thf(fact_1879_split__of__bool__asm,axiom,
    ! [A: $tType] :
      ( ( zero_neq_one @ A )
     => ! [P: A > $o,P4: $o] :
          ( ( P @ ( zero_neq_one_of_bool @ A @ P4 ) )
          = ( ~ ( ( P4
                  & ~ ( P @ ( one_one @ A ) ) )
                | ( ~ P4
                  & ~ ( P @ ( zero_zero @ A ) ) ) ) ) ) ) ).

% split_of_bool_asm
thf(fact_1880_neg__numeral__le__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M: num,N2: num] : ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) @ ( numeral_numeral @ A @ N2 ) ) ) ).

% neg_numeral_le_numeral
thf(fact_1881_not__numeral__le__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M: num,N2: num] :
          ~ ( ord_less_eq @ A @ ( numeral_numeral @ A @ M ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N2 ) ) ) ) ).

% not_numeral_le_neg_numeral
thf(fact_1882_zero__neq__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [N2: num] :
          ( ( zero_zero @ A )
         != ( uminus_uminus @ A @ ( numeral_numeral @ A @ N2 ) ) ) ) ).

% zero_neq_neg_numeral
thf(fact_1883_neg__numeral__less__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M: num,N2: num] : ( ord_less @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) @ ( numeral_numeral @ A @ N2 ) ) ) ).

% neg_numeral_less_numeral
thf(fact_1884_not__numeral__less__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M: num,N2: num] :
          ~ ( ord_less @ A @ ( numeral_numeral @ A @ M ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N2 ) ) ) ) ).

% not_numeral_less_neg_numeral
thf(fact_1885_le__minus__one__simps_I2_J,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( one_one @ A ) ) ) ).

% le_minus_one_simps(2)
thf(fact_1886_le__minus__one__simps_I4_J,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ~ ( ord_less_eq @ A @ ( one_one @ A ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% le_minus_one_simps(4)
thf(fact_1887_zero__neq__neg__one,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ( ( zero_zero @ A )
       != ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% zero_neq_neg_one
thf(fact_1888_add__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ( plus_plus @ A @ A2 @ B2 )
            = ( zero_zero @ A ) )
          = ( B2
            = ( uminus_uminus @ A @ A2 ) ) ) ) ).

% add_eq_0_iff
thf(fact_1889_ab__group__add__class_Oab__left__minus,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [A2: A] :
          ( ( plus_plus @ A @ ( uminus_uminus @ A @ A2 ) @ A2 )
          = ( zero_zero @ A ) ) ) ).

% ab_group_add_class.ab_left_minus
thf(fact_1890_add_Oinverse__unique,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ( plus_plus @ A @ A2 @ B2 )
            = ( zero_zero @ A ) )
         => ( ( uminus_uminus @ A @ A2 )
            = B2 ) ) ) ).

% add.inverse_unique
thf(fact_1891_eq__neg__iff__add__eq__0,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( A2
            = ( uminus_uminus @ A @ B2 ) )
          = ( ( plus_plus @ A @ A2 @ B2 )
            = ( zero_zero @ A ) ) ) ) ).

% eq_neg_iff_add_eq_0
thf(fact_1892_neg__eq__iff__add__eq__0,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ( uminus_uminus @ A @ A2 )
            = B2 )
          = ( ( plus_plus @ A @ A2 @ B2 )
            = ( zero_zero @ A ) ) ) ) ).

% neg_eq_iff_add_eq_0
thf(fact_1893_less__minus__one__simps_I2_J,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ( ord_less @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( one_one @ A ) ) ) ).

% less_minus_one_simps(2)
thf(fact_1894_less__minus__one__simps_I4_J,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ~ ( ord_less @ A @ ( one_one @ A ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% less_minus_one_simps(4)
thf(fact_1895_numeral__times__minus__swap,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [W: num,X2: A] :
          ( ( times_times @ A @ ( numeral_numeral @ A @ W ) @ ( uminus_uminus @ A @ X2 ) )
          = ( times_times @ A @ X2 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) ) ) ) ).

% numeral_times_minus_swap
thf(fact_1896_nonzero__minus__divide__right,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [B2: A,A2: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( uminus_uminus @ A @ ( divide_divide @ A @ A2 @ B2 ) )
            = ( divide_divide @ A @ A2 @ ( uminus_uminus @ A @ B2 ) ) ) ) ) ).

% nonzero_minus_divide_right
thf(fact_1897_nonzero__minus__divide__divide,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [B2: A,A2: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ ( uminus_uminus @ A @ A2 ) @ ( uminus_uminus @ A @ B2 ) )
            = ( divide_divide @ A @ A2 @ B2 ) ) ) ) ).

% nonzero_minus_divide_divide
thf(fact_1898_one__neq__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [N2: num] :
          ( ( one_one @ A )
         != ( uminus_uminus @ A @ ( numeral_numeral @ A @ N2 ) ) ) ) ).

% one_neq_neg_numeral
thf(fact_1899_numeral__neq__neg__one,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [N2: num] :
          ( ( numeral_numeral @ A @ N2 )
         != ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% numeral_neq_neg_one
thf(fact_1900_square__eq__1__iff,axiom,
    ! [A: $tType] :
      ( ( ring_15535105094025558882visors @ A )
     => ! [X2: A] :
          ( ( ( times_times @ A @ X2 @ X2 )
            = ( one_one @ A ) )
          = ( ( X2
              = ( one_one @ A ) )
            | ( X2
              = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ) ) ).

% square_eq_1_iff
thf(fact_1901_group__cancel_Osub2,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [B3: A,K: A,B2: A,A2: A] :
          ( ( B3
            = ( plus_plus @ A @ K @ B2 ) )
         => ( ( minus_minus @ A @ A2 @ B3 )
            = ( plus_plus @ A @ ( uminus_uminus @ A @ K ) @ ( minus_minus @ A @ A2 @ B2 ) ) ) ) ) ).

% group_cancel.sub2
thf(fact_1902_diff__conv__add__uminus,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ( ( minus_minus @ A )
        = ( ^ [A4: A,B4: A] : ( plus_plus @ A @ A4 @ ( uminus_uminus @ A @ B4 ) ) ) ) ) ).

% diff_conv_add_uminus
thf(fact_1903_ab__group__add__class_Oab__diff__conv__add__uminus,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ( ( minus_minus @ A )
        = ( ^ [A4: A,B4: A] : ( plus_plus @ A @ A4 @ ( uminus_uminus @ A @ B4 ) ) ) ) ) ).

% ab_group_add_class.ab_diff_conv_add_uminus
thf(fact_1904_dvd__div__neg,axiom,
    ! [A: $tType] :
      ( ( idom_divide @ A )
     => ! [B2: A,A2: A] :
          ( ( dvd_dvd @ A @ B2 @ A2 )
         => ( ( divide_divide @ A @ A2 @ ( uminus_uminus @ A @ B2 ) )
            = ( uminus_uminus @ A @ ( divide_divide @ A @ A2 @ B2 ) ) ) ) ) ).

% dvd_div_neg
thf(fact_1905_dvd__neg__div,axiom,
    ! [A: $tType] :
      ( ( idom_divide @ A )
     => ! [B2: A,A2: A] :
          ( ( dvd_dvd @ A @ B2 @ A2 )
         => ( ( divide_divide @ A @ ( uminus_uminus @ A @ A2 ) @ B2 )
            = ( uminus_uminus @ A @ ( divide_divide @ A @ A2 @ B2 ) ) ) ) ) ).

% dvd_neg_div
thf(fact_1906_real__minus__mult__self__le,axiom,
    ! [U: real,X2: real] : ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( times_times @ real @ U @ U ) ) @ ( times_times @ real @ X2 @ X2 ) ) ).

% real_minus_mult_self_le
thf(fact_1907_pos__zmult__eq__1__iff__lemma,axiom,
    ! [M: int,N2: int] :
      ( ( ( times_times @ int @ M @ N2 )
        = ( one_one @ int ) )
     => ( ( M
          = ( one_one @ int ) )
        | ( M
          = ( uminus_uminus @ int @ ( one_one @ int ) ) ) ) ) ).

% pos_zmult_eq_1_iff_lemma
thf(fact_1908_zmult__eq__1__iff,axiom,
    ! [M: int,N2: int] :
      ( ( ( times_times @ int @ M @ N2 )
        = ( one_one @ int ) )
      = ( ( ( M
            = ( one_one @ int ) )
          & ( N2
            = ( one_one @ int ) ) )
        | ( ( M
            = ( uminus_uminus @ int @ ( one_one @ int ) ) )
          & ( N2
            = ( uminus_uminus @ int @ ( one_one @ int ) ) ) ) ) ) ).

% zmult_eq_1_iff
thf(fact_1909_minus__int__code_I2_J,axiom,
    ! [L: int] :
      ( ( minus_minus @ int @ ( zero_zero @ int ) @ L )
      = ( uminus_uminus @ int @ L ) ) ).

% minus_int_code(2)
thf(fact_1910_zmod__zminus1__not__zero,axiom,
    ! [K: int,L: int] :
      ( ( ( modulo_modulo @ int @ ( uminus_uminus @ int @ K ) @ L )
       != ( zero_zero @ int ) )
     => ( ( modulo_modulo @ int @ K @ L )
       != ( zero_zero @ int ) ) ) ).

% zmod_zminus1_not_zero
thf(fact_1911_zmod__zminus2__not__zero,axiom,
    ! [K: int,L: int] :
      ( ( ( modulo_modulo @ int @ K @ ( uminus_uminus @ int @ L ) )
       != ( zero_zero @ int ) )
     => ( ( modulo_modulo @ int @ K @ L )
       != ( zero_zero @ int ) ) ) ).

% zmod_zminus2_not_zero
thf(fact_1912_minus__real__def,axiom,
    ( ( minus_minus @ real )
    = ( ^ [X5: real,Y5: real] : ( plus_plus @ real @ X5 @ ( uminus_uminus @ real @ Y5 ) ) ) ) ).

% minus_real_def
thf(fact_1913_neg__numeral__le__zero,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N2: num] : ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N2 ) ) @ ( zero_zero @ A ) ) ) ).

% neg_numeral_le_zero
thf(fact_1914_not__zero__le__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N2: num] :
          ~ ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N2 ) ) ) ) ).

% not_zero_le_neg_numeral
thf(fact_1915_neg__numeral__less__zero,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N2: num] : ( ord_less @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N2 ) ) @ ( zero_zero @ A ) ) ) ).

% neg_numeral_less_zero
thf(fact_1916_not__zero__less__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N2: num] :
          ~ ( ord_less @ A @ ( zero_zero @ A ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N2 ) ) ) ) ).

% not_zero_less_neg_numeral
thf(fact_1917_le__minus__one__simps_I3_J,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ~ ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% le_minus_one_simps(3)
thf(fact_1918_le__minus__one__simps_I1_J,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( zero_zero @ A ) ) ) ).

% le_minus_one_simps(1)
thf(fact_1919_less__minus__one__simps_I3_J,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ~ ( ord_less @ A @ ( zero_zero @ A ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% less_minus_one_simps(3)
thf(fact_1920_less__minus__one__simps_I1_J,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ( ord_less @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( zero_zero @ A ) ) ) ).

% less_minus_one_simps(1)
thf(fact_1921_neg__numeral__le__one,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M: num] : ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) @ ( one_one @ A ) ) ) ).

% neg_numeral_le_one
thf(fact_1922_neg__one__le__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M: num] : ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( numeral_numeral @ A @ M ) ) ) ).

% neg_one_le_numeral
thf(fact_1923_neg__numeral__le__neg__one,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M: num] : ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% neg_numeral_le_neg_one
thf(fact_1924_not__numeral__le__neg__one,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M: num] :
          ~ ( ord_less_eq @ A @ ( numeral_numeral @ A @ M ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% not_numeral_le_neg_one
thf(fact_1925_not__one__le__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M: num] :
          ~ ( ord_less_eq @ A @ ( one_one @ A ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) ) ) ).

% not_one_le_neg_numeral
thf(fact_1926_neg__numeral__less__one,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M: num] : ( ord_less @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) @ ( one_one @ A ) ) ) ).

% neg_numeral_less_one
thf(fact_1927_neg__one__less__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M: num] : ( ord_less @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( numeral_numeral @ A @ M ) ) ) ).

% neg_one_less_numeral
thf(fact_1928_not__numeral__less__neg__one,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M: num] :
          ~ ( ord_less @ A @ ( numeral_numeral @ A @ M ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% not_numeral_less_neg_one
thf(fact_1929_not__one__less__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M: num] :
          ~ ( ord_less @ A @ ( one_one @ A ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) ) ) ).

% not_one_less_neg_numeral
thf(fact_1930_not__neg__one__less__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M: num] :
          ~ ( ord_less @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) ) ) ).

% not_neg_one_less_neg_numeral
thf(fact_1931_eq__minus__divide__eq,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( A2
            = ( uminus_uminus @ A @ ( divide_divide @ A @ B2 @ C2 ) ) )
          = ( ( ( C2
               != ( zero_zero @ A ) )
             => ( ( times_times @ A @ A2 @ C2 )
                = ( uminus_uminus @ A @ B2 ) ) )
            & ( ( C2
                = ( zero_zero @ A ) )
             => ( A2
                = ( zero_zero @ A ) ) ) ) ) ) ).

% eq_minus_divide_eq
thf(fact_1932_minus__divide__eq__eq,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( ( uminus_uminus @ A @ ( divide_divide @ A @ B2 @ C2 ) )
            = A2 )
          = ( ( ( C2
               != ( zero_zero @ A ) )
             => ( ( uminus_uminus @ A @ B2 )
                = ( times_times @ A @ A2 @ C2 ) ) )
            & ( ( C2
                = ( zero_zero @ A ) )
             => ( A2
                = ( zero_zero @ A ) ) ) ) ) ) ).

% minus_divide_eq_eq
thf(fact_1933_nonzero__neg__divide__eq__eq,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( ( uminus_uminus @ A @ ( divide_divide @ A @ A2 @ B2 ) )
              = C2 )
            = ( ( uminus_uminus @ A @ A2 )
              = ( times_times @ A @ C2 @ B2 ) ) ) ) ) ).

% nonzero_neg_divide_eq_eq
thf(fact_1934_nonzero__neg__divide__eq__eq2,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( C2
              = ( uminus_uminus @ A @ ( divide_divide @ A @ A2 @ B2 ) ) )
            = ( ( times_times @ A @ C2 @ B2 )
              = ( uminus_uminus @ A @ A2 ) ) ) ) ) ).

% nonzero_neg_divide_eq_eq2
thf(fact_1935_divide__eq__minus__1__iff,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A2: A,B2: A] :
          ( ( ( divide_divide @ A @ A2 @ B2 )
            = ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( ( B2
             != ( zero_zero @ A ) )
            & ( A2
              = ( uminus_uminus @ A @ B2 ) ) ) ) ) ).

% divide_eq_minus_1_iff
thf(fact_1936_mult__1s__ring__1_I2_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [B2: A] :
          ( ( times_times @ A @ B2 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ one2 ) ) )
          = ( uminus_uminus @ A @ B2 ) ) ) ).

% mult_1s_ring_1(2)
thf(fact_1937_mult__1s__ring__1_I1_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [B2: A] :
          ( ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ one2 ) ) @ B2 )
          = ( uminus_uminus @ A @ B2 ) ) ) ).

% mult_1s_ring_1(1)
thf(fact_1938_uminus__numeral__One,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ one2 ) )
        = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% uminus_numeral_One
thf(fact_1939_power__minus,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [A2: A,N2: nat] :
          ( ( power_power @ A @ ( uminus_uminus @ A @ A2 ) @ N2 )
          = ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ N2 ) @ ( power_power @ A @ A2 @ N2 ) ) ) ) ).

% power_minus
thf(fact_1940_power__minus__Bit0,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [X2: A,K: num] :
          ( ( power_power @ A @ ( uminus_uminus @ A @ X2 ) @ ( numeral_numeral @ nat @ ( bit0 @ K ) ) )
          = ( power_power @ A @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ K ) ) ) ) ) ).

% power_minus_Bit0
thf(fact_1941_real__add__less__0__iff,axiom,
    ! [X2: real,Y2: real] :
      ( ( ord_less @ real @ ( plus_plus @ real @ X2 @ Y2 ) @ ( zero_zero @ real ) )
      = ( ord_less @ real @ Y2 @ ( uminus_uminus @ real @ X2 ) ) ) ).

% real_add_less_0_iff
thf(fact_1942_real__0__less__add__iff,axiom,
    ! [X2: real,Y2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ ( plus_plus @ real @ X2 @ Y2 ) )
      = ( ord_less @ real @ ( uminus_uminus @ real @ X2 ) @ Y2 ) ) ).

% real_0_less_add_iff
thf(fact_1943_real__0__le__add__iff,axiom,
    ! [X2: real,Y2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( plus_plus @ real @ X2 @ Y2 ) )
      = ( ord_less_eq @ real @ ( uminus_uminus @ real @ X2 ) @ Y2 ) ) ).

% real_0_le_add_iff
thf(fact_1944_real__add__le__0__iff,axiom,
    ! [X2: real,Y2: real] :
      ( ( ord_less_eq @ real @ ( plus_plus @ real @ X2 @ Y2 ) @ ( zero_zero @ real ) )
      = ( ord_less_eq @ real @ Y2 @ ( uminus_uminus @ real @ X2 ) ) ) ).

% real_add_le_0_iff
thf(fact_1945_zmod__zminus2__eq__if,axiom,
    ! [A2: int,B2: int] :
      ( ( ( ( modulo_modulo @ int @ A2 @ B2 )
          = ( zero_zero @ int ) )
       => ( ( modulo_modulo @ int @ A2 @ ( uminus_uminus @ int @ B2 ) )
          = ( zero_zero @ int ) ) )
      & ( ( ( modulo_modulo @ int @ A2 @ B2 )
         != ( zero_zero @ int ) )
       => ( ( modulo_modulo @ int @ A2 @ ( uminus_uminus @ int @ B2 ) )
          = ( minus_minus @ int @ ( modulo_modulo @ int @ A2 @ B2 ) @ B2 ) ) ) ) ).

% zmod_zminus2_eq_if
thf(fact_1946_zmod__zminus1__eq__if,axiom,
    ! [A2: int,B2: int] :
      ( ( ( ( modulo_modulo @ int @ A2 @ B2 )
          = ( zero_zero @ int ) )
       => ( ( modulo_modulo @ int @ ( uminus_uminus @ int @ A2 ) @ B2 )
          = ( zero_zero @ int ) ) )
      & ( ( ( modulo_modulo @ int @ A2 @ B2 )
         != ( zero_zero @ int ) )
       => ( ( modulo_modulo @ int @ ( uminus_uminus @ int @ A2 ) @ B2 )
          = ( minus_minus @ int @ B2 @ ( modulo_modulo @ int @ A2 @ B2 ) ) ) ) ) ).

% zmod_zminus1_eq_if
thf(fact_1947_less__minus__divide__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less @ A @ A2 @ ( uminus_uminus @ A @ ( divide_divide @ A @ B2 @ C2 ) ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less @ A @ ( times_times @ A @ A2 @ C2 ) @ ( uminus_uminus @ A @ B2 ) ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ ( uminus_uminus @ A @ B2 ) @ ( times_times @ A @ A2 @ C2 ) ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ A2 @ ( zero_zero @ A ) ) ) ) ) ) ) ) ).

% less_minus_divide_eq
thf(fact_1948_minus__divide__less__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( ord_less @ A @ ( uminus_uminus @ A @ ( divide_divide @ A @ B2 @ C2 ) ) @ A2 )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less @ A @ ( uminus_uminus @ A @ B2 ) @ ( times_times @ A @ A2 @ C2 ) ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ ( times_times @ A @ A2 @ C2 ) @ ( uminus_uminus @ A @ B2 ) ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ ( zero_zero @ A ) @ A2 ) ) ) ) ) ) ) ).

% minus_divide_less_eq
thf(fact_1949_neg__less__minus__divide__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ A2 @ ( uminus_uminus @ A @ ( divide_divide @ A @ B2 @ C2 ) ) )
            = ( ord_less @ A @ ( uminus_uminus @ A @ B2 ) @ ( times_times @ A @ A2 @ C2 ) ) ) ) ) ).

% neg_less_minus_divide_eq
thf(fact_1950_neg__minus__divide__less__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ ( uminus_uminus @ A @ ( divide_divide @ A @ B2 @ C2 ) ) @ A2 )
            = ( ord_less @ A @ ( times_times @ A @ A2 @ C2 ) @ ( uminus_uminus @ A @ B2 ) ) ) ) ) ).

% neg_minus_divide_less_eq
thf(fact_1951_pos__less__minus__divide__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
         => ( ( ord_less @ A @ A2 @ ( uminus_uminus @ A @ ( divide_divide @ A @ B2 @ C2 ) ) )
            = ( ord_less @ A @ ( times_times @ A @ A2 @ C2 ) @ ( uminus_uminus @ A @ B2 ) ) ) ) ) ).

% pos_less_minus_divide_eq
thf(fact_1952_pos__minus__divide__less__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
         => ( ( ord_less @ A @ ( uminus_uminus @ A @ ( divide_divide @ A @ B2 @ C2 ) ) @ A2 )
            = ( ord_less @ A @ ( uminus_uminus @ A @ B2 ) @ ( times_times @ A @ A2 @ C2 ) ) ) ) ) ).

% pos_minus_divide_less_eq
thf(fact_1953_divide__eq__eq__numeral_I2_J,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [B2: A,C2: A,W: num] :
          ( ( ( divide_divide @ A @ B2 @ C2 )
            = ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) )
          = ( ( ( C2
               != ( zero_zero @ A ) )
             => ( B2
                = ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) @ C2 ) ) )
            & ( ( C2
                = ( zero_zero @ A ) )
             => ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) )
                = ( zero_zero @ A ) ) ) ) ) ) ).

% divide_eq_eq_numeral(2)
thf(fact_1954_eq__divide__eq__numeral_I2_J,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [W: num,B2: A,C2: A] :
          ( ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) )
            = ( divide_divide @ A @ B2 @ C2 ) )
          = ( ( ( C2
               != ( zero_zero @ A ) )
             => ( ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) @ C2 )
                = B2 ) )
            & ( ( C2
                = ( zero_zero @ A ) )
             => ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) )
                = ( zero_zero @ A ) ) ) ) ) ) ).

% eq_divide_eq_numeral(2)
thf(fact_1955_subset__decode__imp__le,axiom,
    ! [M: nat,N2: nat] :
      ( ( ord_less_eq @ ( set @ nat ) @ ( nat_set_decode @ M ) @ ( nat_set_decode @ N2 ) )
     => ( ord_less_eq @ nat @ M @ N2 ) ) ).

% subset_decode_imp_le
thf(fact_1956_add__divide__eq__if__simps_I3_J,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [Z: A,A2: A,B2: A] :
          ( ( ( Z
              = ( zero_zero @ A ) )
           => ( ( plus_plus @ A @ ( uminus_uminus @ A @ ( divide_divide @ A @ A2 @ Z ) ) @ B2 )
              = B2 ) )
          & ( ( Z
             != ( zero_zero @ A ) )
           => ( ( plus_plus @ A @ ( uminus_uminus @ A @ ( divide_divide @ A @ A2 @ Z ) ) @ B2 )
              = ( divide_divide @ A @ ( plus_plus @ A @ ( uminus_uminus @ A @ A2 ) @ ( times_times @ A @ B2 @ Z ) ) @ Z ) ) ) ) ) ).

% add_divide_eq_if_simps(3)
thf(fact_1957_minus__divide__add__eq__iff,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [Z: A,X2: A,Y2: A] :
          ( ( Z
           != ( zero_zero @ A ) )
         => ( ( plus_plus @ A @ ( uminus_uminus @ A @ ( divide_divide @ A @ X2 @ Z ) ) @ Y2 )
            = ( divide_divide @ A @ ( plus_plus @ A @ ( uminus_uminus @ A @ X2 ) @ ( times_times @ A @ Y2 @ Z ) ) @ Z ) ) ) ) ).

% minus_divide_add_eq_iff
thf(fact_1958_minus__divide__diff__eq__iff,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [Z: A,X2: A,Y2: A] :
          ( ( Z
           != ( zero_zero @ A ) )
         => ( ( minus_minus @ A @ ( uminus_uminus @ A @ ( divide_divide @ A @ X2 @ Z ) ) @ Y2 )
            = ( divide_divide @ A @ ( minus_minus @ A @ ( uminus_uminus @ A @ X2 ) @ ( times_times @ A @ Y2 @ Z ) ) @ Z ) ) ) ) ).

% minus_divide_diff_eq_iff
thf(fact_1959_add__divide__eq__if__simps_I5_J,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [Z: A,A2: A,B2: A] :
          ( ( ( Z
              = ( zero_zero @ A ) )
           => ( ( minus_minus @ A @ ( divide_divide @ A @ A2 @ Z ) @ B2 )
              = ( uminus_uminus @ A @ B2 ) ) )
          & ( ( Z
             != ( zero_zero @ A ) )
           => ( ( minus_minus @ A @ ( divide_divide @ A @ A2 @ Z ) @ B2 )
              = ( divide_divide @ A @ ( minus_minus @ A @ A2 @ ( times_times @ A @ B2 @ Z ) ) @ Z ) ) ) ) ) ).

% add_divide_eq_if_simps(5)
thf(fact_1960_add__divide__eq__if__simps_I6_J,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [Z: A,A2: A,B2: A] :
          ( ( ( Z
              = ( zero_zero @ A ) )
           => ( ( minus_minus @ A @ ( uminus_uminus @ A @ ( divide_divide @ A @ A2 @ Z ) ) @ B2 )
              = ( uminus_uminus @ A @ B2 ) ) )
          & ( ( Z
             != ( zero_zero @ A ) )
           => ( ( minus_minus @ A @ ( uminus_uminus @ A @ ( divide_divide @ A @ A2 @ Z ) ) @ B2 )
              = ( divide_divide @ A @ ( minus_minus @ A @ ( uminus_uminus @ A @ A2 ) @ ( times_times @ A @ B2 @ Z ) ) @ Z ) ) ) ) ) ).

% add_divide_eq_if_simps(6)
thf(fact_1961_even__minus,axiom,
    ! [A: $tType] :
      ( ( ring_parity @ A )
     => ! [A2: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( uminus_uminus @ A @ A2 ) )
          = ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) ) ) ).

% even_minus
thf(fact_1962_power2__eq__iff,axiom,
    ! [A: $tType] :
      ( ( idom @ A )
     => ! [X2: A,Y2: A] :
          ( ( ( power_power @ A @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
            = ( power_power @ A @ Y2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
          = ( ( X2 = Y2 )
            | ( X2
              = ( uminus_uminus @ A @ Y2 ) ) ) ) ) ).

% power2_eq_iff
thf(fact_1963_verit__less__mono__div__int2,axiom,
    ! [A3: int,B3: int,N2: int] :
      ( ( ord_less_eq @ int @ A3 @ B3 )
     => ( ( ord_less @ int @ ( zero_zero @ int ) @ ( uminus_uminus @ int @ N2 ) )
       => ( ord_less_eq @ int @ ( divide_divide @ int @ B3 @ N2 ) @ ( divide_divide @ int @ A3 @ N2 ) ) ) ) ).

% verit_less_mono_div_int2
thf(fact_1964_div__eq__minus1,axiom,
    ! [B2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ B2 )
     => ( ( divide_divide @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ B2 )
        = ( uminus_uminus @ int @ ( one_one @ int ) ) ) ) ).

% div_eq_minus1
thf(fact_1965_of__bool__odd__eq__mod__2,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [A2: A] :
          ( ( zero_neq_one_of_bool @ A
            @ ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) )
          = ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% of_bool_odd_eq_mod_2
thf(fact_1966_le__minus__divide__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ ( uminus_uminus @ A @ ( divide_divide @ A @ B2 @ C2 ) ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less_eq @ A @ ( times_times @ A @ A2 @ C2 ) @ ( uminus_uminus @ A @ B2 ) ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ ( uminus_uminus @ A @ B2 ) @ ( times_times @ A @ A2 @ C2 ) ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) ) ) ) ) ) ) ) ).

% le_minus_divide_eq
thf(fact_1967_minus__divide__le__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( divide_divide @ A @ B2 @ C2 ) ) @ A2 )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less_eq @ A @ ( uminus_uminus @ A @ B2 ) @ ( times_times @ A @ A2 @ C2 ) ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ ( times_times @ A @ A2 @ C2 ) @ ( uminus_uminus @ A @ B2 ) ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 ) ) ) ) ) ) ) ).

% minus_divide_le_eq
thf(fact_1968_neg__le__minus__divide__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ A2 @ ( uminus_uminus @ A @ ( divide_divide @ A @ B2 @ C2 ) ) )
            = ( ord_less_eq @ A @ ( uminus_uminus @ A @ B2 ) @ ( times_times @ A @ A2 @ C2 ) ) ) ) ) ).

% neg_le_minus_divide_eq
thf(fact_1969_neg__minus__divide__le__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( divide_divide @ A @ B2 @ C2 ) ) @ A2 )
            = ( ord_less_eq @ A @ ( times_times @ A @ A2 @ C2 ) @ ( uminus_uminus @ A @ B2 ) ) ) ) ) ).

% neg_minus_divide_le_eq
thf(fact_1970_pos__le__minus__divide__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
         => ( ( ord_less_eq @ A @ A2 @ ( uminus_uminus @ A @ ( divide_divide @ A @ B2 @ C2 ) ) )
            = ( ord_less_eq @ A @ ( times_times @ A @ A2 @ C2 ) @ ( uminus_uminus @ A @ B2 ) ) ) ) ) ).

% pos_le_minus_divide_eq
thf(fact_1971_pos__minus__divide__le__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
         => ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( divide_divide @ A @ B2 @ C2 ) ) @ A2 )
            = ( ord_less_eq @ A @ ( uminus_uminus @ A @ B2 ) @ ( times_times @ A @ A2 @ C2 ) ) ) ) ) ).

% pos_minus_divide_le_eq
thf(fact_1972_divide__less__eq__numeral_I2_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,C2: A,W: num] :
          ( ( ord_less @ A @ ( divide_divide @ A @ B2 @ C2 ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less @ A @ B2 @ ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) @ C2 ) ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) @ C2 ) @ B2 ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ ( zero_zero @ A ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) ) ) ) ) ) ) ) ).

% divide_less_eq_numeral(2)
thf(fact_1973_less__divide__eq__numeral_I2_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [W: num,B2: A,C2: A] :
          ( ( ord_less @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) @ ( divide_divide @ A @ B2 @ C2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less @ A @ ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) @ C2 ) @ B2 ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ B2 @ ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) @ C2 ) ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) @ ( zero_zero @ A ) ) ) ) ) ) ) ) ).

% less_divide_eq_numeral(2)
thf(fact_1974_periodic__finite__ex,axiom,
    ! [D2: int,P: int > $o] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D2 )
     => ( ! [X3: int,K2: int] :
            ( ( P @ X3 )
            = ( P @ ( minus_minus @ int @ X3 @ ( times_times @ int @ K2 @ D2 ) ) ) )
       => ( ( ? [X4: int] : ( P @ X4 ) )
          = ( ? [X5: int] :
                ( ( member @ int @ X5 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D2 ) )
                & ( P @ X5 ) ) ) ) ) ) ).

% periodic_finite_ex
thf(fact_1975_aset_I7_J,axiom,
    ! [D5: int,A3: set @ int,T2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D5 )
     => ! [X: int] :
          ( ! [Xa3: int] :
              ( ( member @ int @ Xa3 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
             => ! [Xb: int] :
                  ( ( member @ int @ Xb @ A3 )
                 => ( X
                   != ( minus_minus @ int @ Xb @ Xa3 ) ) ) )
         => ( ( ord_less @ int @ T2 @ X )
           => ( ord_less @ int @ T2 @ ( plus_plus @ int @ X @ D5 ) ) ) ) ) ).

% aset(7)
thf(fact_1976_aset_I5_J,axiom,
    ! [D5: int,T2: int,A3: set @ int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D5 )
     => ( ( member @ int @ T2 @ A3 )
       => ! [X: int] :
            ( ! [Xa3: int] :
                ( ( member @ int @ Xa3 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
               => ! [Xb: int] :
                    ( ( member @ int @ Xb @ A3 )
                   => ( X
                     != ( minus_minus @ int @ Xb @ Xa3 ) ) ) )
           => ( ( ord_less @ int @ X @ T2 )
             => ( ord_less @ int @ ( plus_plus @ int @ X @ D5 ) @ T2 ) ) ) ) ) ).

% aset(5)
thf(fact_1977_aset_I4_J,axiom,
    ! [D5: int,T2: int,A3: set @ int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D5 )
     => ( ( member @ int @ T2 @ A3 )
       => ! [X: int] :
            ( ! [Xa3: int] :
                ( ( member @ int @ Xa3 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
               => ! [Xb: int] :
                    ( ( member @ int @ Xb @ A3 )
                   => ( X
                     != ( minus_minus @ int @ Xb @ Xa3 ) ) ) )
           => ( ( X != T2 )
             => ( ( plus_plus @ int @ X @ D5 )
               != T2 ) ) ) ) ) ).

% aset(4)
thf(fact_1978_aset_I3_J,axiom,
    ! [D5: int,T2: int,A3: set @ int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D5 )
     => ( ( member @ int @ ( plus_plus @ int @ T2 @ ( one_one @ int ) ) @ A3 )
       => ! [X: int] :
            ( ! [Xa3: int] :
                ( ( member @ int @ Xa3 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
               => ! [Xb: int] :
                    ( ( member @ int @ Xb @ A3 )
                   => ( X
                     != ( minus_minus @ int @ Xb @ Xa3 ) ) ) )
           => ( ( X = T2 )
             => ( ( plus_plus @ int @ X @ D5 )
                = T2 ) ) ) ) ) ).

% aset(3)
thf(fact_1979_bset_I7_J,axiom,
    ! [D5: int,T2: int,B3: set @ int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D5 )
     => ( ( member @ int @ T2 @ B3 )
       => ! [X: int] :
            ( ! [Xa3: int] :
                ( ( member @ int @ Xa3 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
               => ! [Xb: int] :
                    ( ( member @ int @ Xb @ B3 )
                   => ( X
                     != ( plus_plus @ int @ Xb @ Xa3 ) ) ) )
           => ( ( ord_less @ int @ T2 @ X )
             => ( ord_less @ int @ T2 @ ( minus_minus @ int @ X @ D5 ) ) ) ) ) ) ).

% bset(7)
thf(fact_1980_bset_I5_J,axiom,
    ! [D5: int,B3: set @ int,T2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D5 )
     => ! [X: int] :
          ( ! [Xa3: int] :
              ( ( member @ int @ Xa3 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
             => ! [Xb: int] :
                  ( ( member @ int @ Xb @ B3 )
                 => ( X
                   != ( plus_plus @ int @ Xb @ Xa3 ) ) ) )
         => ( ( ord_less @ int @ X @ T2 )
           => ( ord_less @ int @ ( minus_minus @ int @ X @ D5 ) @ T2 ) ) ) ) ).

% bset(5)
thf(fact_1981_bset_I4_J,axiom,
    ! [D5: int,T2: int,B3: set @ int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D5 )
     => ( ( member @ int @ T2 @ B3 )
       => ! [X: int] :
            ( ! [Xa3: int] :
                ( ( member @ int @ Xa3 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
               => ! [Xb: int] :
                    ( ( member @ int @ Xb @ B3 )
                   => ( X
                     != ( plus_plus @ int @ Xb @ Xa3 ) ) ) )
           => ( ( X != T2 )
             => ( ( minus_minus @ int @ X @ D5 )
               != T2 ) ) ) ) ) ).

% bset(4)
thf(fact_1982_bset_I3_J,axiom,
    ! [D5: int,T2: int,B3: set @ int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D5 )
     => ( ( member @ int @ ( minus_minus @ int @ T2 @ ( one_one @ int ) ) @ B3 )
       => ! [X: int] :
            ( ! [Xa3: int] :
                ( ( member @ int @ Xa3 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
               => ! [Xb: int] :
                    ( ( member @ int @ Xb @ B3 )
                   => ( X
                     != ( plus_plus @ int @ Xb @ Xa3 ) ) ) )
           => ( ( X = T2 )
             => ( ( minus_minus @ int @ X @ D5 )
                = T2 ) ) ) ) ) ).

% bset(3)
thf(fact_1983_power2__eq__1__iff,axiom,
    ! [A: $tType] :
      ( ( ring_15535105094025558882visors @ A )
     => ! [A2: A] :
          ( ( ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
            = ( one_one @ A ) )
          = ( ( A2
              = ( one_one @ A ) )
            | ( A2
              = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ) ) ).

% power2_eq_1_iff
thf(fact_1984_uminus__power__if,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [N2: nat,A2: A] :
          ( ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 )
           => ( ( power_power @ A @ ( uminus_uminus @ A @ A2 ) @ N2 )
              = ( power_power @ A @ A2 @ N2 ) ) )
          & ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 )
           => ( ( power_power @ A @ ( uminus_uminus @ A @ A2 ) @ N2 )
              = ( uminus_uminus @ A @ ( power_power @ A @ A2 @ N2 ) ) ) ) ) ) ).

% uminus_power_if
thf(fact_1985_neg__one__power__add__eq__neg__one__power__diff,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [K: nat,N2: nat] :
          ( ( ord_less_eq @ nat @ K @ N2 )
         => ( ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( plus_plus @ nat @ N2 @ K ) )
            = ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( minus_minus @ nat @ N2 @ K ) ) ) ) ) ).

% neg_one_power_add_eq_neg_one_power_diff
thf(fact_1986_realpow__square__minus__le,axiom,
    ! [U: real,X2: real] : ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( power_power @ real @ U @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( power_power @ real @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ).

% realpow_square_minus_le
thf(fact_1987_minus__mod__int__eq,axiom,
    ! [L: int,K: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ L )
     => ( ( modulo_modulo @ int @ ( uminus_uminus @ int @ K ) @ L )
        = ( minus_minus @ int @ ( minus_minus @ int @ L @ ( one_one @ int ) ) @ ( modulo_modulo @ int @ ( minus_minus @ int @ K @ ( one_one @ int ) ) @ L ) ) ) ) ).

% minus_mod_int_eq
thf(fact_1988_zmod__minus1,axiom,
    ! [B2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ B2 )
     => ( ( modulo_modulo @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ B2 )
        = ( minus_minus @ int @ B2 @ ( one_one @ int ) ) ) ) ).

% zmod_minus1
thf(fact_1989_zdiv__zminus2__eq__if,axiom,
    ! [B2: int,A2: int] :
      ( ( B2
       != ( zero_zero @ int ) )
     => ( ( ( ( modulo_modulo @ int @ A2 @ B2 )
            = ( zero_zero @ int ) )
         => ( ( divide_divide @ int @ A2 @ ( uminus_uminus @ int @ B2 ) )
            = ( uminus_uminus @ int @ ( divide_divide @ int @ A2 @ B2 ) ) ) )
        & ( ( ( modulo_modulo @ int @ A2 @ B2 )
           != ( zero_zero @ int ) )
         => ( ( divide_divide @ int @ A2 @ ( uminus_uminus @ int @ B2 ) )
            = ( minus_minus @ int @ ( uminus_uminus @ int @ ( divide_divide @ int @ A2 @ B2 ) ) @ ( one_one @ int ) ) ) ) ) ) ).

% zdiv_zminus2_eq_if
thf(fact_1990_zdiv__zminus1__eq__if,axiom,
    ! [B2: int,A2: int] :
      ( ( B2
       != ( zero_zero @ int ) )
     => ( ( ( ( modulo_modulo @ int @ A2 @ B2 )
            = ( zero_zero @ int ) )
         => ( ( divide_divide @ int @ ( uminus_uminus @ int @ A2 ) @ B2 )
            = ( uminus_uminus @ int @ ( divide_divide @ int @ A2 @ B2 ) ) ) )
        & ( ( ( modulo_modulo @ int @ A2 @ B2 )
           != ( zero_zero @ int ) )
         => ( ( divide_divide @ int @ ( uminus_uminus @ int @ A2 ) @ B2 )
            = ( minus_minus @ int @ ( uminus_uminus @ int @ ( divide_divide @ int @ A2 @ B2 ) ) @ ( one_one @ int ) ) ) ) ) ) ).

% zdiv_zminus1_eq_if
thf(fact_1991_zminus1__lemma,axiom,
    ! [A2: int,B2: int,Q3: int,R3: int] :
      ( ( eucl_rel_int @ A2 @ B2 @ ( product_Pair @ int @ int @ Q3 @ R3 ) )
     => ( ( B2
         != ( zero_zero @ int ) )
       => ( eucl_rel_int @ ( uminus_uminus @ int @ A2 ) @ B2
          @ ( product_Pair @ int @ int
            @ ( if @ int
              @ ( R3
                = ( zero_zero @ int ) )
              @ ( uminus_uminus @ int @ Q3 )
              @ ( minus_minus @ int @ ( uminus_uminus @ int @ Q3 ) @ ( one_one @ int ) ) )
            @ ( if @ int
              @ ( R3
                = ( zero_zero @ int ) )
              @ ( zero_zero @ int )
              @ ( minus_minus @ int @ B2 @ R3 ) ) ) ) ) ) ).

% zminus1_lemma
thf(fact_1992_bits__induct,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [P: A > $o,A2: A] :
          ( ! [A5: A] :
              ( ( ( divide_divide @ A @ A5 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
                = A5 )
             => ( P @ A5 ) )
         => ( ! [A5: A,B5: $o] :
                ( ( P @ A5 )
               => ( ( ( divide_divide @ A @ ( plus_plus @ A @ ( zero_neq_one_of_bool @ A @ B5 ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A5 ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
                    = A5 )
                 => ( P @ ( plus_plus @ A @ ( zero_neq_one_of_bool @ A @ B5 ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A5 ) ) ) ) )
           => ( P @ A2 ) ) ) ) ).

% bits_induct
thf(fact_1993_divide__le__eq__numeral_I2_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,C2: A,W: num] :
          ( ( ord_less_eq @ A @ ( divide_divide @ A @ B2 @ C2 ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less_eq @ A @ B2 @ ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) @ C2 ) ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) @ C2 ) @ B2 ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) ) ) ) ) ) ) ) ).

% divide_le_eq_numeral(2)
thf(fact_1994_le__divide__eq__numeral_I2_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [W: num,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) @ ( divide_divide @ A @ B2 @ C2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less_eq @ A @ ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) @ C2 ) @ B2 ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ B2 @ ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) @ C2 ) ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) @ ( zero_zero @ A ) ) ) ) ) ) ) ) ).

% le_divide_eq_numeral(2)
thf(fact_1995_aset_I8_J,axiom,
    ! [D5: int,A3: set @ int,T2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D5 )
     => ! [X: int] :
          ( ! [Xa3: int] :
              ( ( member @ int @ Xa3 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
             => ! [Xb: int] :
                  ( ( member @ int @ Xb @ A3 )
                 => ( X
                   != ( minus_minus @ int @ Xb @ Xa3 ) ) ) )
         => ( ( ord_less_eq @ int @ T2 @ X )
           => ( ord_less_eq @ int @ T2 @ ( plus_plus @ int @ X @ D5 ) ) ) ) ) ).

% aset(8)
thf(fact_1996_aset_I6_J,axiom,
    ! [D5: int,T2: int,A3: set @ int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D5 )
     => ( ( member @ int @ ( plus_plus @ int @ T2 @ ( one_one @ int ) ) @ A3 )
       => ! [X: int] :
            ( ! [Xa3: int] :
                ( ( member @ int @ Xa3 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
               => ! [Xb: int] :
                    ( ( member @ int @ Xb @ A3 )
                   => ( X
                     != ( minus_minus @ int @ Xb @ Xa3 ) ) ) )
           => ( ( ord_less_eq @ int @ X @ T2 )
             => ( ord_less_eq @ int @ ( plus_plus @ int @ X @ D5 ) @ T2 ) ) ) ) ) ).

% aset(6)
thf(fact_1997_bset_I8_J,axiom,
    ! [D5: int,T2: int,B3: set @ int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D5 )
     => ( ( member @ int @ ( minus_minus @ int @ T2 @ ( one_one @ int ) ) @ B3 )
       => ! [X: int] :
            ( ! [Xa3: int] :
                ( ( member @ int @ Xa3 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
               => ! [Xb: int] :
                    ( ( member @ int @ Xb @ B3 )
                   => ( X
                     != ( plus_plus @ int @ Xb @ Xa3 ) ) ) )
           => ( ( ord_less_eq @ int @ T2 @ X )
             => ( ord_less_eq @ int @ T2 @ ( minus_minus @ int @ X @ D5 ) ) ) ) ) ) ).

% bset(8)
thf(fact_1998_bset_I6_J,axiom,
    ! [D5: int,B3: set @ int,T2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D5 )
     => ! [X: int] :
          ( ! [Xa3: int] :
              ( ( member @ int @ Xa3 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
             => ! [Xb: int] :
                  ( ( member @ int @ Xb @ B3 )
                 => ( X
                   != ( plus_plus @ int @ Xb @ Xa3 ) ) ) )
         => ( ( ord_less_eq @ int @ X @ T2 )
           => ( ord_less_eq @ int @ ( minus_minus @ int @ X @ D5 ) @ T2 ) ) ) ) ).

% bset(6)
thf(fact_1999_cppi,axiom,
    ! [D5: int,P: int > $o,P5: int > $o,A3: set @ int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D5 )
     => ( ? [Z4: int] :
          ! [X3: int] :
            ( ( ord_less @ int @ Z4 @ X3 )
           => ( ( P @ X3 )
              = ( P5 @ X3 ) ) )
       => ( ! [X3: int] :
              ( ! [Xa: int] :
                  ( ( member @ int @ Xa @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
                 => ! [Xb2: int] :
                      ( ( member @ int @ Xb2 @ A3 )
                     => ( X3
                       != ( minus_minus @ int @ Xb2 @ Xa ) ) ) )
             => ( ( P @ X3 )
               => ( P @ ( plus_plus @ int @ X3 @ D5 ) ) ) )
         => ( ! [X3: int,K2: int] :
                ( ( P5 @ X3 )
                = ( P5 @ ( minus_minus @ int @ X3 @ ( times_times @ int @ K2 @ D5 ) ) ) )
           => ( ( ? [X4: int] : ( P @ X4 ) )
              = ( ? [X5: int] :
                    ( ( member @ int @ X5 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
                    & ( P5 @ X5 ) )
                | ? [X5: int] :
                    ( ( member @ int @ X5 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
                    & ? [Y5: int] :
                        ( ( member @ int @ Y5 @ A3 )
                        & ( P @ ( minus_minus @ int @ Y5 @ X5 ) ) ) ) ) ) ) ) ) ) ).

% cppi
thf(fact_2000_cpmi,axiom,
    ! [D5: int,P: int > $o,P5: int > $o,B3: set @ int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D5 )
     => ( ? [Z4: int] :
          ! [X3: int] :
            ( ( ord_less @ int @ X3 @ Z4 )
           => ( ( P @ X3 )
              = ( P5 @ X3 ) ) )
       => ( ! [X3: int] :
              ( ! [Xa: int] :
                  ( ( member @ int @ Xa @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
                 => ! [Xb2: int] :
                      ( ( member @ int @ Xb2 @ B3 )
                     => ( X3
                       != ( plus_plus @ int @ Xb2 @ Xa ) ) ) )
             => ( ( P @ X3 )
               => ( P @ ( minus_minus @ int @ X3 @ D5 ) ) ) )
         => ( ! [X3: int,K2: int] :
                ( ( P5 @ X3 )
                = ( P5 @ ( minus_minus @ int @ X3 @ ( times_times @ int @ K2 @ D5 ) ) ) )
           => ( ( ? [X4: int] : ( P @ X4 ) )
              = ( ? [X5: int] :
                    ( ( member @ int @ X5 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
                    & ( P5 @ X5 ) )
                | ? [X5: int] :
                    ( ( member @ int @ X5 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
                    & ? [Y5: int] :
                        ( ( member @ int @ Y5 @ B3 )
                        & ( P @ ( plus_plus @ int @ Y5 @ X5 ) ) ) ) ) ) ) ) ) ) ).

% cpmi
thf(fact_2001_square__le__1,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X2: A] :
          ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ X2 )
         => ( ( ord_less_eq @ A @ X2 @ ( one_one @ A ) )
           => ( ord_less_eq @ A @ ( power_power @ A @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ A ) ) ) ) ) ).

% square_le_1
thf(fact_2002_minus__power__mult__self,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [A2: A,N2: nat] :
          ( ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ A2 ) @ N2 ) @ ( power_power @ A @ ( uminus_uminus @ A @ A2 ) @ N2 ) )
          = ( power_power @ A @ A2 @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) ) ) ).

% minus_power_mult_self
thf(fact_2003_minus__one__power__iff,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [N2: nat] :
          ( ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 )
           => ( ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ N2 )
              = ( one_one @ A ) ) )
          & ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 )
           => ( ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ N2 )
              = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ) ) ).

% minus_one_power_iff
thf(fact_2004_minus__1__div__exp__eq__int,axiom,
    ! [N2: nat] :
      ( ( divide_divide @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N2 ) )
      = ( uminus_uminus @ int @ ( one_one @ int ) ) ) ).

% minus_1_div_exp_eq_int
thf(fact_2005_div__pos__neg__trivial,axiom,
    ! [K: int,L: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ K )
     => ( ( ord_less_eq @ int @ ( plus_plus @ int @ K @ L ) @ ( zero_zero @ int ) )
       => ( ( divide_divide @ int @ K @ L )
          = ( uminus_uminus @ int @ ( one_one @ int ) ) ) ) ) ).

% div_pos_neg_trivial
thf(fact_2006_signed__take__bit__int__greater__eq__minus__exp,axiom,
    ! [N2: nat,K: int] : ( ord_less_eq @ int @ ( uminus_uminus @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N2 ) ) @ ( bit_ri4674362597316999326ke_bit @ int @ N2 @ K ) ) ).

% signed_take_bit_int_greater_eq_minus_exp
thf(fact_2007_signed__take__bit__int__less__eq__self__iff,axiom,
    ! [N2: nat,K: int] :
      ( ( ord_less_eq @ int @ ( bit_ri4674362597316999326ke_bit @ int @ N2 @ K ) @ K )
      = ( ord_less_eq @ int @ ( uminus_uminus @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N2 ) ) @ K ) ) ).

% signed_take_bit_int_less_eq_self_iff
thf(fact_2008_signed__take__bit__int__greater__self__iff,axiom,
    ! [K: int,N2: nat] :
      ( ( ord_less @ int @ K @ ( bit_ri4674362597316999326ke_bit @ int @ N2 @ K ) )
      = ( ord_less @ int @ K @ ( uminus_uminus @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N2 ) ) ) ) ).

% signed_take_bit_int_greater_self_iff
thf(fact_2009_exp__mod__exp,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [M: nat,N2: nat] :
          ( ( modulo_modulo @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N2 ) )
          = ( times_times @ A @ ( zero_neq_one_of_bool @ A @ ( ord_less @ nat @ M @ N2 ) ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M ) ) ) ) ).

% exp_mod_exp
thf(fact_2010_power__minus1__odd,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [N2: nat] :
          ( ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) )
          = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% power_minus1_odd
thf(fact_2011_int__bit__induct,axiom,
    ! [P: int > $o,K: int] :
      ( ( P @ ( zero_zero @ int ) )
     => ( ( P @ ( uminus_uminus @ int @ ( one_one @ int ) ) )
       => ( ! [K2: int] :
              ( ( P @ K2 )
             => ( ( K2
                 != ( zero_zero @ int ) )
               => ( P @ ( times_times @ int @ K2 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) )
         => ( ! [K2: int] :
                ( ( P @ K2 )
               => ( ( K2
                   != ( uminus_uminus @ int @ ( one_one @ int ) ) )
                 => ( P @ ( plus_plus @ int @ ( one_one @ int ) @ ( times_times @ int @ K2 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) ) )
           => ( P @ K ) ) ) ) ) ).

% int_bit_induct
thf(fact_2012_signed__take__bit__int__eq__self__iff,axiom,
    ! [N2: nat,K: int] :
      ( ( ( bit_ri4674362597316999326ke_bit @ int @ N2 @ K )
        = K )
      = ( ( ord_less_eq @ int @ ( uminus_uminus @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N2 ) ) @ K )
        & ( ord_less @ int @ K @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N2 ) ) ) ) ).

% signed_take_bit_int_eq_self_iff
thf(fact_2013_signed__take__bit__int__eq__self,axiom,
    ! [N2: nat,K: int] :
      ( ( ord_less_eq @ int @ ( uminus_uminus @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N2 ) ) @ K )
     => ( ( ord_less @ int @ K @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N2 ) )
       => ( ( bit_ri4674362597316999326ke_bit @ int @ N2 @ K )
          = K ) ) ) ).

% signed_take_bit_int_eq_self
thf(fact_2014_exp__div__exp__eq,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [M: nat,N2: nat] :
          ( ( divide_divide @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N2 ) )
          = ( times_times @ A
            @ ( zero_neq_one_of_bool @ A
              @ ( ( ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M )
                 != ( zero_zero @ A ) )
                & ( ord_less_eq @ nat @ N2 @ M ) ) )
            @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ M @ N2 ) ) ) ) ) ).

% exp_div_exp_eq
thf(fact_2015_signed__take__bit__int__greater__eq,axiom,
    ! [K: int,N2: nat] :
      ( ( ord_less @ int @ K @ ( uminus_uminus @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N2 ) ) )
     => ( ord_less_eq @ int @ ( plus_plus @ int @ K @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( suc @ N2 ) ) ) @ ( bit_ri4674362597316999326ke_bit @ int @ N2 @ K ) ) ) ).

% signed_take_bit_int_greater_eq
thf(fact_2016_set__decode__def,axiom,
    ( nat_set_decode
    = ( ^ [X5: nat] :
          ( collect @ nat
          @ ^ [N3: nat] :
              ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( divide_divide @ nat @ X5 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N3 ) ) ) ) ) ) ).

% set_decode_def
thf(fact_2017_compl__less__compl__iff,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [X2: A,Y2: A] :
          ( ( ord_less @ A @ ( uminus_uminus @ A @ X2 ) @ ( uminus_uminus @ A @ Y2 ) )
          = ( ord_less @ A @ Y2 @ X2 ) ) ) ).

% compl_less_compl_iff
thf(fact_2018_compl__le__compl__iff,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [X2: A,Y2: A] :
          ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ X2 ) @ ( uminus_uminus @ A @ Y2 ) )
          = ( ord_less_eq @ A @ Y2 @ X2 ) ) ) ).

% compl_le_compl_iff
thf(fact_2019_Divides_Oadjust__div__eq,axiom,
    ! [Q3: int,R3: int] :
      ( ( adjust_div @ ( product_Pair @ int @ int @ Q3 @ R3 ) )
      = ( plus_plus @ int @ Q3
        @ ( zero_neq_one_of_bool @ int
          @ ( R3
           != ( zero_zero @ int ) ) ) ) ) ).

% Divides.adjust_div_eq
thf(fact_2020_signed__take__bit__Suc__minus__bit1,axiom,
    ! [N2: nat,K: num] :
      ( ( bit_ri4674362597316999326ke_bit @ int @ ( suc @ N2 ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit1 @ K ) ) ) )
      = ( plus_plus @ int @ ( times_times @ int @ ( bit_ri4674362597316999326ke_bit @ int @ N2 @ ( minus_minus @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ K ) ) @ ( one_one @ int ) ) ) @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( one_one @ int ) ) ) ).

% signed_take_bit_Suc_minus_bit1
thf(fact_2021_predicate1I,axiom,
    ! [A: $tType,P: A > $o,Q: A > $o] :
      ( ! [X3: A] :
          ( ( P @ X3 )
         => ( Q @ X3 ) )
     => ( ord_less_eq @ ( A > $o ) @ P @ Q ) ) ).

% predicate1I
thf(fact_2022_less__fun__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ord @ B )
     => ( ( ord_less @ ( A > B ) )
        = ( ^ [F5: A > B,G4: A > B] :
              ( ( ord_less_eq @ ( A > B ) @ F5 @ G4 )
              & ~ ( ord_less_eq @ ( A > B ) @ G4 @ F5 ) ) ) ) ) ).

% less_fun_def
thf(fact_2023_divmod__step__def,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ( ( unique1321980374590559556d_step @ A )
        = ( ^ [L2: num] :
              ( product_case_prod @ A @ A @ ( product_prod @ A @ A )
              @ ^ [Q4: A,R5: A] : ( if @ ( product_prod @ A @ A ) @ ( ord_less_eq @ A @ ( numeral_numeral @ A @ L2 ) @ R5 ) @ ( product_Pair @ A @ A @ ( plus_plus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ Q4 ) @ ( one_one @ A ) ) @ ( minus_minus @ A @ R5 @ ( numeral_numeral @ A @ L2 ) ) ) @ ( product_Pair @ A @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ Q4 ) @ R5 ) ) ) ) ) ) ).

% divmod_step_def
thf(fact_2024_dual__order_Orefl,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A2: A] : ( ord_less_eq @ A @ A2 @ A2 ) ) ).

% dual_order.refl
thf(fact_2025_order__refl,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [X2: A] : ( ord_less_eq @ A @ X2 @ X2 ) ) ).

% order_refl
thf(fact_2026_semiring__norm_I90_J,axiom,
    ! [M: num,N2: num] :
      ( ( ( bit1 @ M )
        = ( bit1 @ N2 ) )
      = ( M = N2 ) ) ).

% semiring_norm(90)
thf(fact_2027_semiring__norm_I88_J,axiom,
    ! [M: num,N2: num] :
      ( ( bit0 @ M )
     != ( bit1 @ N2 ) ) ).

% semiring_norm(88)
thf(fact_2028_semiring__norm_I89_J,axiom,
    ! [M: num,N2: num] :
      ( ( bit1 @ M )
     != ( bit0 @ N2 ) ) ).

% semiring_norm(89)
thf(fact_2029_semiring__norm_I84_J,axiom,
    ! [N2: num] :
      ( one2
     != ( bit1 @ N2 ) ) ).

% semiring_norm(84)
thf(fact_2030_semiring__norm_I86_J,axiom,
    ! [M: num] :
      ( ( bit1 @ M )
     != one2 ) ).

% semiring_norm(86)
thf(fact_2031_semiring__norm_I73_J,axiom,
    ! [M: num,N2: num] :
      ( ( ord_less_eq @ num @ ( bit1 @ M ) @ ( bit1 @ N2 ) )
      = ( ord_less_eq @ num @ M @ N2 ) ) ).

% semiring_norm(73)
thf(fact_2032_semiring__norm_I80_J,axiom,
    ! [M: num,N2: num] :
      ( ( ord_less @ num @ ( bit1 @ M ) @ ( bit1 @ N2 ) )
      = ( ord_less @ num @ M @ N2 ) ) ).

% semiring_norm(80)
thf(fact_2033_case__prod__conv,axiom,
    ! [B: $tType,A: $tType,C: $tType,F2: B > C > A,A2: B,B2: C] :
      ( ( product_case_prod @ B @ C @ A @ F2 @ ( product_Pair @ B @ C @ A2 @ B2 ) )
      = ( F2 @ A2 @ B2 ) ) ).

% case_prod_conv
thf(fact_2034_semiring__norm_I9_J,axiom,
    ! [M: num,N2: num] :
      ( ( plus_plus @ num @ ( bit1 @ M ) @ ( bit0 @ N2 ) )
      = ( bit1 @ ( plus_plus @ num @ M @ N2 ) ) ) ).

% semiring_norm(9)
thf(fact_2035_semiring__norm_I7_J,axiom,
    ! [M: num,N2: num] :
      ( ( plus_plus @ num @ ( bit0 @ M ) @ ( bit1 @ N2 ) )
      = ( bit1 @ ( plus_plus @ num @ M @ N2 ) ) ) ).

% semiring_norm(7)
thf(fact_2036_semiring__norm_I15_J,axiom,
    ! [M: num,N2: num] :
      ( ( times_times @ num @ ( bit1 @ M ) @ ( bit0 @ N2 ) )
      = ( bit0 @ ( times_times @ num @ ( bit1 @ M ) @ N2 ) ) ) ).

% semiring_norm(15)
thf(fact_2037_semiring__norm_I14_J,axiom,
    ! [M: num,N2: num] :
      ( ( times_times @ num @ ( bit0 @ M ) @ ( bit1 @ N2 ) )
      = ( bit0 @ ( times_times @ num @ M @ ( bit1 @ N2 ) ) ) ) ).

% semiring_norm(14)
thf(fact_2038_semiring__norm_I81_J,axiom,
    ! [M: num,N2: num] :
      ( ( ord_less @ num @ ( bit1 @ M ) @ ( bit0 @ N2 ) )
      = ( ord_less @ num @ M @ N2 ) ) ).

% semiring_norm(81)
thf(fact_2039_semiring__norm_I72_J,axiom,
    ! [M: num,N2: num] :
      ( ( ord_less_eq @ num @ ( bit0 @ M ) @ ( bit1 @ N2 ) )
      = ( ord_less_eq @ num @ M @ N2 ) ) ).

% semiring_norm(72)
thf(fact_2040_semiring__norm_I77_J,axiom,
    ! [N2: num] : ( ord_less @ num @ one2 @ ( bit1 @ N2 ) ) ).

% semiring_norm(77)
thf(fact_2041_semiring__norm_I70_J,axiom,
    ! [M: num] :
      ~ ( ord_less_eq @ num @ ( bit1 @ M ) @ one2 ) ).

% semiring_norm(70)
thf(fact_2042_zdiv__numeral__Bit1,axiom,
    ! [V: num,W: num] :
      ( ( divide_divide @ int @ ( numeral_numeral @ int @ ( bit1 @ V ) ) @ ( numeral_numeral @ int @ ( bit0 @ W ) ) )
      = ( divide_divide @ int @ ( numeral_numeral @ int @ V ) @ ( numeral_numeral @ int @ W ) ) ) ).

% zdiv_numeral_Bit1
thf(fact_2043_semiring__norm_I3_J,axiom,
    ! [N2: num] :
      ( ( plus_plus @ num @ one2 @ ( bit0 @ N2 ) )
      = ( bit1 @ N2 ) ) ).

% semiring_norm(3)
thf(fact_2044_semiring__norm_I4_J,axiom,
    ! [N2: num] :
      ( ( plus_plus @ num @ one2 @ ( bit1 @ N2 ) )
      = ( bit0 @ ( plus_plus @ num @ N2 @ one2 ) ) ) ).

% semiring_norm(4)
thf(fact_2045_semiring__norm_I5_J,axiom,
    ! [M: num] :
      ( ( plus_plus @ num @ ( bit0 @ M ) @ one2 )
      = ( bit1 @ M ) ) ).

% semiring_norm(5)
thf(fact_2046_semiring__norm_I8_J,axiom,
    ! [M: num] :
      ( ( plus_plus @ num @ ( bit1 @ M ) @ one2 )
      = ( bit0 @ ( plus_plus @ num @ M @ one2 ) ) ) ).

% semiring_norm(8)
thf(fact_2047_semiring__norm_I10_J,axiom,
    ! [M: num,N2: num] :
      ( ( plus_plus @ num @ ( bit1 @ M ) @ ( bit1 @ N2 ) )
      = ( bit0 @ ( plus_plus @ num @ ( plus_plus @ num @ M @ N2 ) @ one2 ) ) ) ).

% semiring_norm(10)
thf(fact_2048_semiring__norm_I16_J,axiom,
    ! [M: num,N2: num] :
      ( ( times_times @ num @ ( bit1 @ M ) @ ( bit1 @ N2 ) )
      = ( bit1 @ ( plus_plus @ num @ ( plus_plus @ num @ M @ N2 ) @ ( bit0 @ ( times_times @ num @ M @ N2 ) ) ) ) ) ).

% semiring_norm(16)
thf(fact_2049_semiring__norm_I79_J,axiom,
    ! [M: num,N2: num] :
      ( ( ord_less @ num @ ( bit0 @ M ) @ ( bit1 @ N2 ) )
      = ( ord_less_eq @ num @ M @ N2 ) ) ).

% semiring_norm(79)
thf(fact_2050_semiring__norm_I74_J,axiom,
    ! [M: num,N2: num] :
      ( ( ord_less_eq @ num @ ( bit1 @ M ) @ ( bit0 @ N2 ) )
      = ( ord_less @ num @ M @ N2 ) ) ).

% semiring_norm(74)
thf(fact_2051_Suc__div__eq__add3__div__numeral,axiom,
    ! [M: nat,V: num] :
      ( ( divide_divide @ nat @ ( suc @ ( suc @ ( suc @ M ) ) ) @ ( numeral_numeral @ nat @ V ) )
      = ( divide_divide @ nat @ ( plus_plus @ nat @ ( numeral_numeral @ nat @ ( bit1 @ one2 ) ) @ M ) @ ( numeral_numeral @ nat @ V ) ) ) ).

% Suc_div_eq_add3_div_numeral
thf(fact_2052_div__Suc__eq__div__add3,axiom,
    ! [M: nat,N2: nat] :
      ( ( divide_divide @ nat @ M @ ( suc @ ( suc @ ( suc @ N2 ) ) ) )
      = ( divide_divide @ nat @ M @ ( plus_plus @ nat @ ( numeral_numeral @ nat @ ( bit1 @ one2 ) ) @ N2 ) ) ) ).

% div_Suc_eq_div_add3
thf(fact_2053_Suc__mod__eq__add3__mod__numeral,axiom,
    ! [M: nat,V: num] :
      ( ( modulo_modulo @ nat @ ( suc @ ( suc @ ( suc @ M ) ) ) @ ( numeral_numeral @ nat @ V ) )
      = ( modulo_modulo @ nat @ ( plus_plus @ nat @ ( numeral_numeral @ nat @ ( bit1 @ one2 ) ) @ M ) @ ( numeral_numeral @ nat @ V ) ) ) ).

% Suc_mod_eq_add3_mod_numeral
thf(fact_2054_mod__Suc__eq__mod__add3,axiom,
    ! [M: nat,N2: nat] :
      ( ( modulo_modulo @ nat @ M @ ( suc @ ( suc @ ( suc @ N2 ) ) ) )
      = ( modulo_modulo @ nat @ M @ ( plus_plus @ nat @ ( numeral_numeral @ nat @ ( bit1 @ one2 ) ) @ N2 ) ) ) ).

% mod_Suc_eq_mod_add3
thf(fact_2055_zmod__numeral__Bit1,axiom,
    ! [V: num,W: num] :
      ( ( modulo_modulo @ int @ ( numeral_numeral @ int @ ( bit1 @ V ) ) @ ( numeral_numeral @ int @ ( bit0 @ W ) ) )
      = ( plus_plus @ int @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( modulo_modulo @ int @ ( numeral_numeral @ int @ V ) @ ( numeral_numeral @ int @ W ) ) ) @ ( one_one @ int ) ) ) ).

% zmod_numeral_Bit1
thf(fact_2056_signed__take__bit__Suc__bit1,axiom,
    ! [N2: nat,K: num] :
      ( ( bit_ri4674362597316999326ke_bit @ int @ ( suc @ N2 ) @ ( numeral_numeral @ int @ ( bit1 @ K ) ) )
      = ( plus_plus @ int @ ( times_times @ int @ ( bit_ri4674362597316999326ke_bit @ int @ N2 @ ( numeral_numeral @ int @ K ) ) @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( one_one @ int ) ) ) ).

% signed_take_bit_Suc_bit1
thf(fact_2057_verit__eq__simplify_I14_J,axiom,
    ! [X22: num,X32: num] :
      ( ( bit0 @ X22 )
     != ( bit1 @ X32 ) ) ).

% verit_eq_simplify(14)
thf(fact_2058_verit__eq__simplify_I12_J,axiom,
    ! [X32: num] :
      ( one2
     != ( bit1 @ X32 ) ) ).

% verit_eq_simplify(12)
thf(fact_2059_old_Oprod_Ocase,axiom,
    ! [A: $tType,C: $tType,B: $tType,F2: A > B > C,X1: A,X22: B] :
      ( ( product_case_prod @ A @ B @ C @ F2 @ ( product_Pair @ A @ B @ X1 @ X22 ) )
      = ( F2 @ X1 @ X22 ) ) ).

% old.prod.case
thf(fact_2060_cond__case__prod__eta,axiom,
    ! [C: $tType,B: $tType,A: $tType,F2: A > B > C,G: ( product_prod @ A @ B ) > C] :
      ( ! [X3: A,Y4: B] :
          ( ( F2 @ X3 @ Y4 )
          = ( G @ ( product_Pair @ A @ B @ X3 @ Y4 ) ) )
     => ( ( product_case_prod @ A @ B @ C @ F2 )
        = G ) ) ).

% cond_case_prod_eta
thf(fact_2061_case__prod__eta,axiom,
    ! [C: $tType,B: $tType,A: $tType,F2: ( product_prod @ A @ B ) > C] :
      ( ( product_case_prod @ A @ B @ C
        @ ^ [X5: A,Y5: B] : ( F2 @ ( product_Pair @ A @ B @ X5 @ Y5 ) ) )
      = F2 ) ).

% case_prod_eta
thf(fact_2062_case__prodE2,axiom,
    ! [B: $tType,A: $tType,C: $tType,Q: A > $o,P: B > C > A,Z: product_prod @ B @ C] :
      ( ( Q @ ( product_case_prod @ B @ C @ A @ P @ Z ) )
     => ~ ! [X3: B,Y4: C] :
            ( ( Z
              = ( product_Pair @ B @ C @ X3 @ Y4 ) )
           => ~ ( Q @ ( P @ X3 @ Y4 ) ) ) ) ).

% case_prodE2
thf(fact_2063_xor__num_Ocases,axiom,
    ! [X2: product_prod @ num @ num] :
      ( ( X2
       != ( product_Pair @ num @ num @ one2 @ one2 ) )
     => ( ! [N: num] :
            ( X2
           != ( product_Pair @ num @ num @ one2 @ ( bit0 @ N ) ) )
       => ( ! [N: num] :
              ( X2
             != ( product_Pair @ num @ num @ one2 @ ( bit1 @ N ) ) )
         => ( ! [M3: num] :
                ( X2
               != ( product_Pair @ num @ num @ ( bit0 @ M3 ) @ one2 ) )
           => ( ! [M3: num,N: num] :
                  ( X2
                 != ( product_Pair @ num @ num @ ( bit0 @ M3 ) @ ( bit0 @ N ) ) )
             => ( ! [M3: num,N: num] :
                    ( X2
                   != ( product_Pair @ num @ num @ ( bit0 @ M3 ) @ ( bit1 @ N ) ) )
               => ( ! [M3: num] :
                      ( X2
                     != ( product_Pair @ num @ num @ ( bit1 @ M3 ) @ one2 ) )
                 => ( ! [M3: num,N: num] :
                        ( X2
                       != ( product_Pair @ num @ num @ ( bit1 @ M3 ) @ ( bit0 @ N ) ) )
                   => ~ ! [M3: num,N: num] :
                          ( X2
                         != ( product_Pair @ num @ num @ ( bit1 @ M3 ) @ ( bit1 @ N ) ) ) ) ) ) ) ) ) ) ) ).

% xor_num.cases
thf(fact_2064_num_Oexhaust,axiom,
    ! [Y2: num] :
      ( ( Y2 != one2 )
     => ( ! [X23: num] :
            ( Y2
           != ( bit0 @ X23 ) )
       => ~ ! [X33: num] :
              ( Y2
             != ( bit1 @ X33 ) ) ) ) ).

% num.exhaust
thf(fact_2065_numeral__Bit1,axiom,
    ! [A: $tType] :
      ( ( numeral @ A )
     => ! [N2: num] :
          ( ( numeral_numeral @ A @ ( bit1 @ N2 ) )
          = ( plus_plus @ A @ ( plus_plus @ A @ ( numeral_numeral @ A @ N2 ) @ ( numeral_numeral @ A @ N2 ) ) @ ( one_one @ A ) ) ) ) ).

% numeral_Bit1
thf(fact_2066_eval__nat__numeral_I3_J,axiom,
    ! [N2: num] :
      ( ( numeral_numeral @ nat @ ( bit1 @ N2 ) )
      = ( suc @ ( numeral_numeral @ nat @ ( bit0 @ N2 ) ) ) ) ).

% eval_nat_numeral(3)
thf(fact_2067_cong__exp__iff__simps_I10_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [M: num,Q3: num,N2: num] :
          ( ( modulo_modulo @ A @ ( numeral_numeral @ A @ ( bit0 @ M ) ) @ ( numeral_numeral @ A @ ( bit0 @ Q3 ) ) )
         != ( modulo_modulo @ A @ ( numeral_numeral @ A @ ( bit1 @ N2 ) ) @ ( numeral_numeral @ A @ ( bit0 @ Q3 ) ) ) ) ) ).

% cong_exp_iff_simps(10)
thf(fact_2068_cong__exp__iff__simps_I12_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [M: num,Q3: num,N2: num] :
          ( ( modulo_modulo @ A @ ( numeral_numeral @ A @ ( bit1 @ M ) ) @ ( numeral_numeral @ A @ ( bit0 @ Q3 ) ) )
         != ( modulo_modulo @ A @ ( numeral_numeral @ A @ ( bit0 @ N2 ) ) @ ( numeral_numeral @ A @ ( bit0 @ Q3 ) ) ) ) ) ).

% cong_exp_iff_simps(12)
thf(fact_2069_cong__exp__iff__simps_I13_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [M: num,Q3: num,N2: num] :
          ( ( ( modulo_modulo @ A @ ( numeral_numeral @ A @ ( bit1 @ M ) ) @ ( numeral_numeral @ A @ ( bit0 @ Q3 ) ) )
            = ( modulo_modulo @ A @ ( numeral_numeral @ A @ ( bit1 @ N2 ) ) @ ( numeral_numeral @ A @ ( bit0 @ Q3 ) ) ) )
          = ( ( modulo_modulo @ A @ ( numeral_numeral @ A @ M ) @ ( numeral_numeral @ A @ Q3 ) )
            = ( modulo_modulo @ A @ ( numeral_numeral @ A @ N2 ) @ ( numeral_numeral @ A @ Q3 ) ) ) ) ) ).

% cong_exp_iff_simps(13)
thf(fact_2070_power__minus__Bit1,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [X2: A,K: num] :
          ( ( power_power @ A @ ( uminus_uminus @ A @ X2 ) @ ( numeral_numeral @ nat @ ( bit1 @ K ) ) )
          = ( uminus_uminus @ A @ ( power_power @ A @ X2 @ ( numeral_numeral @ nat @ ( bit1 @ K ) ) ) ) ) ) ).

% power_minus_Bit1
thf(fact_2071_order__antisym__conv,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [Y2: A,X2: A] :
          ( ( ord_less_eq @ A @ Y2 @ X2 )
         => ( ( ord_less_eq @ A @ X2 @ Y2 )
            = ( X2 = Y2 ) ) ) ) ).

% order_antisym_conv
thf(fact_2072_linorder__le__cases,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X2: A,Y2: A] :
          ( ~ ( ord_less_eq @ A @ X2 @ Y2 )
         => ( ord_less_eq @ A @ Y2 @ X2 ) ) ) ).

% linorder_le_cases
thf(fact_2073_ord__le__eq__subst,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( ord @ B )
        & ( ord @ A ) )
     => ! [A2: A,B2: A,F2: A > B,C2: B] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ( F2 @ B2 )
              = C2 )
           => ( ! [X3: A,Y4: A] :
                  ( ( ord_less_eq @ A @ X3 @ Y4 )
                 => ( ord_less_eq @ B @ ( F2 @ X3 ) @ ( F2 @ Y4 ) ) )
             => ( ord_less_eq @ B @ ( F2 @ A2 ) @ C2 ) ) ) ) ) ).

% ord_le_eq_subst
thf(fact_2074_ord__eq__le__subst,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( ord @ B )
        & ( ord @ A ) )
     => ! [A2: A,F2: B > A,B2: B,C2: B] :
          ( ( A2
            = ( F2 @ B2 ) )
         => ( ( ord_less_eq @ B @ B2 @ C2 )
           => ( ! [X3: B,Y4: B] :
                  ( ( ord_less_eq @ B @ X3 @ Y4 )
                 => ( ord_less_eq @ A @ ( F2 @ X3 ) @ ( F2 @ Y4 ) ) )
             => ( ord_less_eq @ A @ A2 @ ( F2 @ C2 ) ) ) ) ) ) ).

% ord_eq_le_subst
thf(fact_2075_linorder__linear,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X2: A,Y2: A] :
          ( ( ord_less_eq @ A @ X2 @ Y2 )
          | ( ord_less_eq @ A @ Y2 @ X2 ) ) ) ).

% linorder_linear
thf(fact_2076_order__eq__refl,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [X2: A,Y2: A] :
          ( ( X2 = Y2 )
         => ( ord_less_eq @ A @ X2 @ Y2 ) ) ) ).

% order_eq_refl
thf(fact_2077_order__subst2,axiom,
    ! [A: $tType,C: $tType] :
      ( ( ( order @ C )
        & ( order @ A ) )
     => ! [A2: A,B2: A,F2: A > C,C2: C] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ C @ ( F2 @ B2 ) @ C2 )
           => ( ! [X3: A,Y4: A] :
                  ( ( ord_less_eq @ A @ X3 @ Y4 )
                 => ( ord_less_eq @ C @ ( F2 @ X3 ) @ ( F2 @ Y4 ) ) )
             => ( ord_less_eq @ C @ ( F2 @ A2 ) @ C2 ) ) ) ) ) ).

% order_subst2
thf(fact_2078_order__subst1,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( order @ B )
        & ( order @ A ) )
     => ! [A2: A,F2: B > A,B2: B,C2: B] :
          ( ( ord_less_eq @ A @ A2 @ ( F2 @ B2 ) )
         => ( ( ord_less_eq @ B @ B2 @ C2 )
           => ( ! [X3: B,Y4: B] :
                  ( ( ord_less_eq @ B @ X3 @ Y4 )
                 => ( ord_less_eq @ A @ ( F2 @ X3 ) @ ( F2 @ Y4 ) ) )
             => ( ord_less_eq @ A @ A2 @ ( F2 @ C2 ) ) ) ) ) ) ).

% order_subst1
thf(fact_2079_Orderings_Oorder__eq__iff,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( ^ [Y3: A,Z2: A] : ( Y3 = Z2 ) )
        = ( ^ [A4: A,B4: A] :
              ( ( ord_less_eq @ A @ A4 @ B4 )
              & ( ord_less_eq @ A @ B4 @ A4 ) ) ) ) ) ).

% Orderings.order_eq_iff
thf(fact_2080_antisym,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ B2 @ A2 )
           => ( A2 = B2 ) ) ) ) ).

% antisym
thf(fact_2081_dual__order_Otrans,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( ord_less_eq @ A @ B2 @ A2 )
         => ( ( ord_less_eq @ A @ C2 @ B2 )
           => ( ord_less_eq @ A @ C2 @ A2 ) ) ) ) ).

% dual_order.trans
thf(fact_2082_dual__order_Oantisym,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less_eq @ A @ B2 @ A2 )
         => ( ( ord_less_eq @ A @ A2 @ B2 )
           => ( A2 = B2 ) ) ) ) ).

% dual_order.antisym
thf(fact_2083_dual__order_Oeq__iff,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( ^ [Y3: A,Z2: A] : ( Y3 = Z2 ) )
        = ( ^ [A4: A,B4: A] :
              ( ( ord_less_eq @ A @ B4 @ A4 )
              & ( ord_less_eq @ A @ A4 @ B4 ) ) ) ) ) ).

% dual_order.eq_iff
thf(fact_2084_linorder__wlog,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [P: A > A > $o,A2: A,B2: A] :
          ( ! [A5: A,B5: A] :
              ( ( ord_less_eq @ A @ A5 @ B5 )
             => ( P @ A5 @ B5 ) )
         => ( ! [A5: A,B5: A] :
                ( ( P @ B5 @ A5 )
               => ( P @ A5 @ B5 ) )
           => ( P @ A2 @ B2 ) ) ) ) ).

% linorder_wlog
thf(fact_2085_order__trans,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [X2: A,Y2: A,Z: A] :
          ( ( ord_less_eq @ A @ X2 @ Y2 )
         => ( ( ord_less_eq @ A @ Y2 @ Z )
           => ( ord_less_eq @ A @ X2 @ Z ) ) ) ) ).

% order_trans
thf(fact_2086_order_Otrans,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ B2 @ C2 )
           => ( ord_less_eq @ A @ A2 @ C2 ) ) ) ) ).

% order.trans
thf(fact_2087_order__antisym,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [X2: A,Y2: A] :
          ( ( ord_less_eq @ A @ X2 @ Y2 )
         => ( ( ord_less_eq @ A @ Y2 @ X2 )
           => ( X2 = Y2 ) ) ) ) ).

% order_antisym
thf(fact_2088_ord__le__eq__trans,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( B2 = C2 )
           => ( ord_less_eq @ A @ A2 @ C2 ) ) ) ) ).

% ord_le_eq_trans
thf(fact_2089_ord__eq__le__trans,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( A2 = B2 )
         => ( ( ord_less_eq @ A @ B2 @ C2 )
           => ( ord_less_eq @ A @ A2 @ C2 ) ) ) ) ).

% ord_eq_le_trans
thf(fact_2090_order__class_Oorder__eq__iff,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( ^ [Y3: A,Z2: A] : ( Y3 = Z2 ) )
        = ( ^ [X5: A,Y5: A] :
              ( ( ord_less_eq @ A @ X5 @ Y5 )
              & ( ord_less_eq @ A @ Y5 @ X5 ) ) ) ) ) ).

% order_class.order_eq_iff
thf(fact_2091_le__cases3,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X2: A,Y2: A,Z: A] :
          ( ( ( ord_less_eq @ A @ X2 @ Y2 )
           => ~ ( ord_less_eq @ A @ Y2 @ Z ) )
         => ( ( ( ord_less_eq @ A @ Y2 @ X2 )
             => ~ ( ord_less_eq @ A @ X2 @ Z ) )
           => ( ( ( ord_less_eq @ A @ X2 @ Z )
               => ~ ( ord_less_eq @ A @ Z @ Y2 ) )
             => ( ( ( ord_less_eq @ A @ Z @ Y2 )
                 => ~ ( ord_less_eq @ A @ Y2 @ X2 ) )
               => ( ( ( ord_less_eq @ A @ Y2 @ Z )
                   => ~ ( ord_less_eq @ A @ Z @ X2 ) )
                 => ~ ( ( ord_less_eq @ A @ Z @ X2 )
                     => ~ ( ord_less_eq @ A @ X2 @ Y2 ) ) ) ) ) ) ) ) ).

% le_cases3
thf(fact_2092_nle__le,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ~ ( ord_less_eq @ A @ A2 @ B2 ) )
          = ( ( ord_less_eq @ A @ B2 @ A2 )
            & ( B2 != A2 ) ) ) ) ).

% nle_le
thf(fact_2093_order__less__imp__not__less,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [X2: A,Y2: A] :
          ( ( ord_less @ A @ X2 @ Y2 )
         => ~ ( ord_less @ A @ Y2 @ X2 ) ) ) ).

% order_less_imp_not_less
thf(fact_2094_order__less__imp__not__eq2,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [X2: A,Y2: A] :
          ( ( ord_less @ A @ X2 @ Y2 )
         => ( Y2 != X2 ) ) ) ).

% order_less_imp_not_eq2
thf(fact_2095_order__less__imp__not__eq,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [X2: A,Y2: A] :
          ( ( ord_less @ A @ X2 @ Y2 )
         => ( X2 != Y2 ) ) ) ).

% order_less_imp_not_eq
thf(fact_2096_linorder__less__linear,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X2: A,Y2: A] :
          ( ( ord_less @ A @ X2 @ Y2 )
          | ( X2 = Y2 )
          | ( ord_less @ A @ Y2 @ X2 ) ) ) ).

% linorder_less_linear
thf(fact_2097_order__less__imp__triv,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [X2: A,Y2: A,P: $o] :
          ( ( ord_less @ A @ X2 @ Y2 )
         => ( ( ord_less @ A @ Y2 @ X2 )
           => P ) ) ) ).

% order_less_imp_triv
thf(fact_2098_order__less__not__sym,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [X2: A,Y2: A] :
          ( ( ord_less @ A @ X2 @ Y2 )
         => ~ ( ord_less @ A @ Y2 @ X2 ) ) ) ).

% order_less_not_sym
thf(fact_2099_order__less__subst2,axiom,
    ! [A: $tType,C: $tType] :
      ( ( ( order @ C )
        & ( order @ A ) )
     => ! [A2: A,B2: A,F2: A > C,C2: C] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_less @ C @ ( F2 @ B2 ) @ C2 )
           => ( ! [X3: A,Y4: A] :
                  ( ( ord_less @ A @ X3 @ Y4 )
                 => ( ord_less @ C @ ( F2 @ X3 ) @ ( F2 @ Y4 ) ) )
             => ( ord_less @ C @ ( F2 @ A2 ) @ C2 ) ) ) ) ) ).

% order_less_subst2
thf(fact_2100_order__less__subst1,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( order @ B )
        & ( order @ A ) )
     => ! [A2: A,F2: B > A,B2: B,C2: B] :
          ( ( ord_less @ A @ A2 @ ( F2 @ B2 ) )
         => ( ( ord_less @ B @ B2 @ C2 )
           => ( ! [X3: B,Y4: B] :
                  ( ( ord_less @ B @ X3 @ Y4 )
                 => ( ord_less @ A @ ( F2 @ X3 ) @ ( F2 @ Y4 ) ) )
             => ( ord_less @ A @ A2 @ ( F2 @ C2 ) ) ) ) ) ) ).

% order_less_subst1
thf(fact_2101_order__less__irrefl,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [X2: A] :
          ~ ( ord_less @ A @ X2 @ X2 ) ) ).

% order_less_irrefl
thf(fact_2102_ord__less__eq__subst,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( ord @ B )
        & ( ord @ A ) )
     => ! [A2: A,B2: A,F2: A > B,C2: B] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ( F2 @ B2 )
              = C2 )
           => ( ! [X3: A,Y4: A] :
                  ( ( ord_less @ A @ X3 @ Y4 )
                 => ( ord_less @ B @ ( F2 @ X3 ) @ ( F2 @ Y4 ) ) )
             => ( ord_less @ B @ ( F2 @ A2 ) @ C2 ) ) ) ) ) ).

% ord_less_eq_subst
thf(fact_2103_ord__eq__less__subst,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( ord @ B )
        & ( ord @ A ) )
     => ! [A2: A,F2: B > A,B2: B,C2: B] :
          ( ( A2
            = ( F2 @ B2 ) )
         => ( ( ord_less @ B @ B2 @ C2 )
           => ( ! [X3: B,Y4: B] :
                  ( ( ord_less @ B @ X3 @ Y4 )
                 => ( ord_less @ A @ ( F2 @ X3 ) @ ( F2 @ Y4 ) ) )
             => ( ord_less @ A @ A2 @ ( F2 @ C2 ) ) ) ) ) ) ).

% ord_eq_less_subst
thf(fact_2104_order__less__trans,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [X2: A,Y2: A,Z: A] :
          ( ( ord_less @ A @ X2 @ Y2 )
         => ( ( ord_less @ A @ Y2 @ Z )
           => ( ord_less @ A @ X2 @ Z ) ) ) ) ).

% order_less_trans
thf(fact_2105_order__less__asym_H,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ~ ( ord_less @ A @ B2 @ A2 ) ) ) ).

% order_less_asym'
thf(fact_2106_linorder__neq__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X2: A,Y2: A] :
          ( ( ( X2 != Y2 ) )
          = ( ( ord_less @ A @ X2 @ Y2 )
            | ( ord_less @ A @ Y2 @ X2 ) ) ) ) ).

% linorder_neq_iff
thf(fact_2107_order__less__asym,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [X2: A,Y2: A] :
          ( ( ord_less @ A @ X2 @ Y2 )
         => ~ ( ord_less @ A @ Y2 @ X2 ) ) ) ).

% order_less_asym
thf(fact_2108_linorder__neqE,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X2: A,Y2: A] :
          ( ( X2 != Y2 )
         => ( ~ ( ord_less @ A @ X2 @ Y2 )
           => ( ord_less @ A @ Y2 @ X2 ) ) ) ) ).

% linorder_neqE
thf(fact_2109_dual__order_Ostrict__implies__not__eq,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less @ A @ B2 @ A2 )
         => ( A2 != B2 ) ) ) ).

% dual_order.strict_implies_not_eq
thf(fact_2110_order_Ostrict__implies__not__eq,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( A2 != B2 ) ) ) ).

% order.strict_implies_not_eq
thf(fact_2111_dual__order_Ostrict__trans,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( ord_less @ A @ B2 @ A2 )
         => ( ( ord_less @ A @ C2 @ B2 )
           => ( ord_less @ A @ C2 @ A2 ) ) ) ) ).

% dual_order.strict_trans
thf(fact_2112_not__less__iff__gr__or__eq,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X2: A,Y2: A] :
          ( ( ~ ( ord_less @ A @ X2 @ Y2 ) )
          = ( ( ord_less @ A @ Y2 @ X2 )
            | ( X2 = Y2 ) ) ) ) ).

% not_less_iff_gr_or_eq
thf(fact_2113_order_Ostrict__trans,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_less @ A @ B2 @ C2 )
           => ( ord_less @ A @ A2 @ C2 ) ) ) ) ).

% order.strict_trans
thf(fact_2114_linorder__less__wlog,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [P: A > A > $o,A2: A,B2: A] :
          ( ! [A5: A,B5: A] :
              ( ( ord_less @ A @ A5 @ B5 )
             => ( P @ A5 @ B5 ) )
         => ( ! [A5: A] : ( P @ A5 @ A5 )
           => ( ! [A5: A,B5: A] :
                  ( ( P @ B5 @ A5 )
                 => ( P @ A5 @ B5 ) )
             => ( P @ A2 @ B2 ) ) ) ) ) ).

% linorder_less_wlog
thf(fact_2115_exists__least__iff,axiom,
    ! [A: $tType] :
      ( ( wellorder @ A )
     => ( ( ^ [P2: A > $o] :
            ? [X6: A] : ( P2 @ X6 ) )
        = ( ^ [P3: A > $o] :
            ? [N3: A] :
              ( ( P3 @ N3 )
              & ! [M6: A] :
                  ( ( ord_less @ A @ M6 @ N3 )
                 => ~ ( P3 @ M6 ) ) ) ) ) ) ).

% exists_least_iff
thf(fact_2116_dual__order_Oirrefl,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A2: A] :
          ~ ( ord_less @ A @ A2 @ A2 ) ) ).

% dual_order.irrefl
thf(fact_2117_dual__order_Oasym,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less @ A @ B2 @ A2 )
         => ~ ( ord_less @ A @ A2 @ B2 ) ) ) ).

% dual_order.asym
thf(fact_2118_linorder__cases,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X2: A,Y2: A] :
          ( ~ ( ord_less @ A @ X2 @ Y2 )
         => ( ( X2 != Y2 )
           => ( ord_less @ A @ Y2 @ X2 ) ) ) ) ).

% linorder_cases
thf(fact_2119_antisym__conv3,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Y2: A,X2: A] :
          ( ~ ( ord_less @ A @ Y2 @ X2 )
         => ( ( ~ ( ord_less @ A @ X2 @ Y2 ) )
            = ( X2 = Y2 ) ) ) ) ).

% antisym_conv3
thf(fact_2120_less__induct,axiom,
    ! [A: $tType] :
      ( ( wellorder @ A )
     => ! [P: A > $o,A2: A] :
          ( ! [X3: A] :
              ( ! [Y: A] :
                  ( ( ord_less @ A @ Y @ X3 )
                 => ( P @ Y ) )
             => ( P @ X3 ) )
         => ( P @ A2 ) ) ) ).

% less_induct
thf(fact_2121_ord__less__eq__trans,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( B2 = C2 )
           => ( ord_less @ A @ A2 @ C2 ) ) ) ) ).

% ord_less_eq_trans
thf(fact_2122_ord__eq__less__trans,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( A2 = B2 )
         => ( ( ord_less @ A @ B2 @ C2 )
           => ( ord_less @ A @ A2 @ C2 ) ) ) ) ).

% ord_eq_less_trans
thf(fact_2123_order_Oasym,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ~ ( ord_less @ A @ B2 @ A2 ) ) ) ).

% order.asym
thf(fact_2124_less__imp__neq,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [X2: A,Y2: A] :
          ( ( ord_less @ A @ X2 @ Y2 )
         => ( X2 != Y2 ) ) ) ).

% less_imp_neq
thf(fact_2125_dense,axiom,
    ! [A: $tType] :
      ( ( dense_order @ A )
     => ! [X2: A,Y2: A] :
          ( ( ord_less @ A @ X2 @ Y2 )
         => ? [Z3: A] :
              ( ( ord_less @ A @ X2 @ Z3 )
              & ( ord_less @ A @ Z3 @ Y2 ) ) ) ) ).

% dense
thf(fact_2126_gt__ex,axiom,
    ! [A: $tType] :
      ( ( no_top @ A )
     => ! [X2: A] :
        ? [X_12: A] : ( ord_less @ A @ X2 @ X_12 ) ) ).

% gt_ex
thf(fact_2127_lt__ex,axiom,
    ! [A: $tType] :
      ( ( no_bot @ A )
     => ! [X2: A] :
        ? [Y4: A] : ( ord_less @ A @ Y4 @ X2 ) ) ).

% lt_ex
thf(fact_2128_numeral__code_I3_J,axiom,
    ! [A: $tType] :
      ( ( numeral @ A )
     => ! [N2: num] :
          ( ( numeral_numeral @ A @ ( bit1 @ N2 ) )
          = ( plus_plus @ A @ ( plus_plus @ A @ ( numeral_numeral @ A @ N2 ) @ ( numeral_numeral @ A @ N2 ) ) @ ( one_one @ A ) ) ) ) ).

% numeral_code(3)
thf(fact_2129_power__numeral__odd,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [Z: A,W: num] :
          ( ( power_power @ A @ Z @ ( numeral_numeral @ nat @ ( bit1 @ W ) ) )
          = ( times_times @ A @ ( times_times @ A @ Z @ ( power_power @ A @ Z @ ( numeral_numeral @ nat @ W ) ) ) @ ( power_power @ A @ Z @ ( numeral_numeral @ nat @ W ) ) ) ) ) ).

% power_numeral_odd
thf(fact_2130_numeral__Bit1__div__2,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [N2: num] :
          ( ( divide_divide @ A @ ( numeral_numeral @ A @ ( bit1 @ N2 ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
          = ( numeral_numeral @ A @ N2 ) ) ) ).

% numeral_Bit1_div_2
thf(fact_2131_odd__numeral,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [N2: num] :
          ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( numeral_numeral @ A @ ( bit1 @ N2 ) ) ) ) ).

% odd_numeral
thf(fact_2132_cong__exp__iff__simps_I3_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [N2: num,Q3: num] :
          ( ( modulo_modulo @ A @ ( numeral_numeral @ A @ ( bit1 @ N2 ) ) @ ( numeral_numeral @ A @ ( bit0 @ Q3 ) ) )
         != ( zero_zero @ A ) ) ) ).

% cong_exp_iff_simps(3)
thf(fact_2133_power3__eq__cube,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [A2: A] :
          ( ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ ( bit1 @ one2 ) ) )
          = ( times_times @ A @ ( times_times @ A @ A2 @ A2 ) @ A2 ) ) ) ).

% power3_eq_cube
thf(fact_2134_numeral__3__eq__3,axiom,
    ( ( numeral_numeral @ nat @ ( bit1 @ one2 ) )
    = ( suc @ ( suc @ ( suc @ ( zero_zero @ nat ) ) ) ) ) ).

% numeral_3_eq_3
thf(fact_2135_Suc3__eq__add__3,axiom,
    ! [N2: nat] :
      ( ( suc @ ( suc @ ( suc @ N2 ) ) )
      = ( plus_plus @ nat @ ( numeral_numeral @ nat @ ( bit1 @ one2 ) ) @ N2 ) ) ).

% Suc3_eq_add_3
thf(fact_2136_predicate1D,axiom,
    ! [A: $tType,P: A > $o,Q: A > $o,X2: A] :
      ( ( ord_less_eq @ ( A > $o ) @ P @ Q )
     => ( ( P @ X2 )
       => ( Q @ X2 ) ) ) ).

% predicate1D
thf(fact_2137_rev__predicate1D,axiom,
    ! [A: $tType,P: A > $o,X2: A,Q: A > $o] :
      ( ( P @ X2 )
     => ( ( ord_less_eq @ ( A > $o ) @ P @ Q )
       => ( Q @ X2 ) ) ) ).

% rev_predicate1D
thf(fact_2138_num_Osize_I6_J,axiom,
    ! [X32: num] :
      ( ( size_size @ num @ ( bit1 @ X32 ) )
      = ( plus_plus @ nat @ ( size_size @ num @ X32 ) @ ( suc @ ( zero_zero @ nat ) ) ) ) ).

% num.size(6)
thf(fact_2139_num_Osize__gen_I3_J,axiom,
    ! [X32: num] :
      ( ( size_num @ ( bit1 @ X32 ) )
      = ( plus_plus @ nat @ ( size_num @ X32 ) @ ( suc @ ( zero_zero @ nat ) ) ) ) ).

% num.size_gen(3)
thf(fact_2140_cong__exp__iff__simps_I7_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [Q3: num,N2: num] :
          ( ( ( modulo_modulo @ A @ ( numeral_numeral @ A @ one2 ) @ ( numeral_numeral @ A @ ( bit0 @ Q3 ) ) )
            = ( modulo_modulo @ A @ ( numeral_numeral @ A @ ( bit1 @ N2 ) ) @ ( numeral_numeral @ A @ ( bit0 @ Q3 ) ) ) )
          = ( ( modulo_modulo @ A @ ( numeral_numeral @ A @ N2 ) @ ( numeral_numeral @ A @ Q3 ) )
            = ( zero_zero @ A ) ) ) ) ).

% cong_exp_iff_simps(7)
thf(fact_2141_cong__exp__iff__simps_I11_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [M: num,Q3: num] :
          ( ( ( modulo_modulo @ A @ ( numeral_numeral @ A @ ( bit1 @ M ) ) @ ( numeral_numeral @ A @ ( bit0 @ Q3 ) ) )
            = ( modulo_modulo @ A @ ( numeral_numeral @ A @ one2 ) @ ( numeral_numeral @ A @ ( bit0 @ Q3 ) ) ) )
          = ( ( modulo_modulo @ A @ ( numeral_numeral @ A @ M ) @ ( numeral_numeral @ A @ Q3 ) )
            = ( zero_zero @ A ) ) ) ) ).

% cong_exp_iff_simps(11)
thf(fact_2142_Suc__div__eq__add3__div,axiom,
    ! [M: nat,N2: nat] :
      ( ( divide_divide @ nat @ ( suc @ ( suc @ ( suc @ M ) ) ) @ N2 )
      = ( divide_divide @ nat @ ( plus_plus @ nat @ ( numeral_numeral @ nat @ ( bit1 @ one2 ) ) @ M ) @ N2 ) ) ).

% Suc_div_eq_add3_div
thf(fact_2143_Suc__mod__eq__add3__mod,axiom,
    ! [M: nat,N2: nat] :
      ( ( modulo_modulo @ nat @ ( suc @ ( suc @ ( suc @ M ) ) ) @ N2 )
      = ( modulo_modulo @ nat @ ( plus_plus @ nat @ ( numeral_numeral @ nat @ ( bit1 @ one2 ) ) @ M ) @ N2 ) ) ).

% Suc_mod_eq_add3_mod
thf(fact_2144_order__le__imp__less__or__eq,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [X2: A,Y2: A] :
          ( ( ord_less_eq @ A @ X2 @ Y2 )
         => ( ( ord_less @ A @ X2 @ Y2 )
            | ( X2 = Y2 ) ) ) ) ).

% order_le_imp_less_or_eq
thf(fact_2145_linorder__le__less__linear,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X2: A,Y2: A] :
          ( ( ord_less_eq @ A @ X2 @ Y2 )
          | ( ord_less @ A @ Y2 @ X2 ) ) ) ).

% linorder_le_less_linear
thf(fact_2146_order__less__le__subst2,axiom,
    ! [A: $tType,C: $tType] :
      ( ( ( order @ C )
        & ( order @ A ) )
     => ! [A2: A,B2: A,F2: A > C,C2: C] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ C @ ( F2 @ B2 ) @ C2 )
           => ( ! [X3: A,Y4: A] :
                  ( ( ord_less @ A @ X3 @ Y4 )
                 => ( ord_less @ C @ ( F2 @ X3 ) @ ( F2 @ Y4 ) ) )
             => ( ord_less @ C @ ( F2 @ A2 ) @ C2 ) ) ) ) ) ).

% order_less_le_subst2
thf(fact_2147_order__less__le__subst1,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( order @ B )
        & ( order @ A ) )
     => ! [A2: A,F2: B > A,B2: B,C2: B] :
          ( ( ord_less @ A @ A2 @ ( F2 @ B2 ) )
         => ( ( ord_less_eq @ B @ B2 @ C2 )
           => ( ! [X3: B,Y4: B] :
                  ( ( ord_less_eq @ B @ X3 @ Y4 )
                 => ( ord_less_eq @ A @ ( F2 @ X3 ) @ ( F2 @ Y4 ) ) )
             => ( ord_less @ A @ A2 @ ( F2 @ C2 ) ) ) ) ) ) ).

% order_less_le_subst1
thf(fact_2148_order__le__less__subst2,axiom,
    ! [A: $tType,C: $tType] :
      ( ( ( order @ C )
        & ( order @ A ) )
     => ! [A2: A,B2: A,F2: A > C,C2: C] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less @ C @ ( F2 @ B2 ) @ C2 )
           => ( ! [X3: A,Y4: A] :
                  ( ( ord_less_eq @ A @ X3 @ Y4 )
                 => ( ord_less_eq @ C @ ( F2 @ X3 ) @ ( F2 @ Y4 ) ) )
             => ( ord_less @ C @ ( F2 @ A2 ) @ C2 ) ) ) ) ) ).

% order_le_less_subst2
thf(fact_2149_order__le__less__subst1,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( order @ B )
        & ( order @ A ) )
     => ! [A2: A,F2: B > A,B2: B,C2: B] :
          ( ( ord_less_eq @ A @ A2 @ ( F2 @ B2 ) )
         => ( ( ord_less @ B @ B2 @ C2 )
           => ( ! [X3: B,Y4: B] :
                  ( ( ord_less @ B @ X3 @ Y4 )
                 => ( ord_less @ A @ ( F2 @ X3 ) @ ( F2 @ Y4 ) ) )
             => ( ord_less @ A @ A2 @ ( F2 @ C2 ) ) ) ) ) ) ).

% order_le_less_subst1
thf(fact_2150_order__less__le__trans,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [X2: A,Y2: A,Z: A] :
          ( ( ord_less @ A @ X2 @ Y2 )
         => ( ( ord_less_eq @ A @ Y2 @ Z )
           => ( ord_less @ A @ X2 @ Z ) ) ) ) ).

% order_less_le_trans
thf(fact_2151_order__le__less__trans,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [X2: A,Y2: A,Z: A] :
          ( ( ord_less_eq @ A @ X2 @ Y2 )
         => ( ( ord_less @ A @ Y2 @ Z )
           => ( ord_less @ A @ X2 @ Z ) ) ) ) ).

% order_le_less_trans
thf(fact_2152_order__neq__le__trans,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [A2: A,B2: A] :
          ( ( A2 != B2 )
         => ( ( ord_less_eq @ A @ A2 @ B2 )
           => ( ord_less @ A @ A2 @ B2 ) ) ) ) ).

% order_neq_le_trans
thf(fact_2153_order__le__neq__trans,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( A2 != B2 )
           => ( ord_less @ A @ A2 @ B2 ) ) ) ) ).

% order_le_neq_trans
thf(fact_2154_order__less__imp__le,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [X2: A,Y2: A] :
          ( ( ord_less @ A @ X2 @ Y2 )
         => ( ord_less_eq @ A @ X2 @ Y2 ) ) ) ).

% order_less_imp_le
thf(fact_2155_linorder__not__less,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X2: A,Y2: A] :
          ( ( ~ ( ord_less @ A @ X2 @ Y2 ) )
          = ( ord_less_eq @ A @ Y2 @ X2 ) ) ) ).

% linorder_not_less
thf(fact_2156_linorder__not__le,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X2: A,Y2: A] :
          ( ( ~ ( ord_less_eq @ A @ X2 @ Y2 ) )
          = ( ord_less @ A @ Y2 @ X2 ) ) ) ).

% linorder_not_le
thf(fact_2157_order__less__le,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( ord_less @ A )
        = ( ^ [X5: A,Y5: A] :
              ( ( ord_less_eq @ A @ X5 @ Y5 )
              & ( X5 != Y5 ) ) ) ) ) ).

% order_less_le
thf(fact_2158_order__le__less,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [X5: A,Y5: A] :
              ( ( ord_less @ A @ X5 @ Y5 )
              | ( X5 = Y5 ) ) ) ) ) ).

% order_le_less
thf(fact_2159_dual__order_Ostrict__implies__order,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less @ A @ B2 @ A2 )
         => ( ord_less_eq @ A @ B2 @ A2 ) ) ) ).

% dual_order.strict_implies_order
thf(fact_2160_order_Ostrict__implies__order,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ord_less_eq @ A @ A2 @ B2 ) ) ) ).

% order.strict_implies_order
thf(fact_2161_dual__order_Ostrict__iff__not,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ( ( ord_less @ A )
        = ( ^ [B4: A,A4: A] :
              ( ( ord_less_eq @ A @ B4 @ A4 )
              & ~ ( ord_less_eq @ A @ A4 @ B4 ) ) ) ) ) ).

% dual_order.strict_iff_not
thf(fact_2162_dual__order_Ostrict__trans2,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( ord_less @ A @ B2 @ A2 )
         => ( ( ord_less_eq @ A @ C2 @ B2 )
           => ( ord_less @ A @ C2 @ A2 ) ) ) ) ).

% dual_order.strict_trans2
thf(fact_2163_dual__order_Ostrict__trans1,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( ord_less_eq @ A @ B2 @ A2 )
         => ( ( ord_less @ A @ C2 @ B2 )
           => ( ord_less @ A @ C2 @ A2 ) ) ) ) ).

% dual_order.strict_trans1
thf(fact_2164_dual__order_Ostrict__iff__order,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( ord_less @ A )
        = ( ^ [B4: A,A4: A] :
              ( ( ord_less_eq @ A @ B4 @ A4 )
              & ( A4 != B4 ) ) ) ) ) ).

% dual_order.strict_iff_order
thf(fact_2165_dual__order_Oorder__iff__strict,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [B4: A,A4: A] :
              ( ( ord_less @ A @ B4 @ A4 )
              | ( A4 = B4 ) ) ) ) ) ).

% dual_order.order_iff_strict
thf(fact_2166_dense__le__bounded,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [X2: A,Y2: A,Z: A] :
          ( ( ord_less @ A @ X2 @ Y2 )
         => ( ! [W2: A] :
                ( ( ord_less @ A @ X2 @ W2 )
               => ( ( ord_less @ A @ W2 @ Y2 )
                 => ( ord_less_eq @ A @ W2 @ Z ) ) )
           => ( ord_less_eq @ A @ Y2 @ Z ) ) ) ) ).

% dense_le_bounded
thf(fact_2167_dense__ge__bounded,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [Z: A,X2: A,Y2: A] :
          ( ( ord_less @ A @ Z @ X2 )
         => ( ! [W2: A] :
                ( ( ord_less @ A @ Z @ W2 )
               => ( ( ord_less @ A @ W2 @ X2 )
                 => ( ord_less_eq @ A @ Y2 @ W2 ) ) )
           => ( ord_less_eq @ A @ Y2 @ Z ) ) ) ) ).

% dense_ge_bounded
thf(fact_2168_order_Ostrict__iff__not,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ( ( ord_less @ A )
        = ( ^ [A4: A,B4: A] :
              ( ( ord_less_eq @ A @ A4 @ B4 )
              & ~ ( ord_less_eq @ A @ B4 @ A4 ) ) ) ) ) ).

% order.strict_iff_not
thf(fact_2169_order_Ostrict__trans2,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ B2 @ C2 )
           => ( ord_less @ A @ A2 @ C2 ) ) ) ) ).

% order.strict_trans2
thf(fact_2170_order_Ostrict__trans1,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less @ A @ B2 @ C2 )
           => ( ord_less @ A @ A2 @ C2 ) ) ) ) ).

% order.strict_trans1
thf(fact_2171_order_Ostrict__iff__order,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( ord_less @ A )
        = ( ^ [A4: A,B4: A] :
              ( ( ord_less_eq @ A @ A4 @ B4 )
              & ( A4 != B4 ) ) ) ) ) ).

% order.strict_iff_order
thf(fact_2172_order_Oorder__iff__strict,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [A4: A,B4: A] :
              ( ( ord_less @ A @ A4 @ B4 )
              | ( A4 = B4 ) ) ) ) ) ).

% order.order_iff_strict
thf(fact_2173_not__le__imp__less,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Y2: A,X2: A] :
          ( ~ ( ord_less_eq @ A @ Y2 @ X2 )
         => ( ord_less @ A @ X2 @ Y2 ) ) ) ).

% not_le_imp_less
thf(fact_2174_less__le__not__le,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ( ( ord_less @ A )
        = ( ^ [X5: A,Y5: A] :
              ( ( ord_less_eq @ A @ X5 @ Y5 )
              & ~ ( ord_less_eq @ A @ Y5 @ X5 ) ) ) ) ) ).

% less_le_not_le
thf(fact_2175_dense__le,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [Y2: A,Z: A] :
          ( ! [X3: A] :
              ( ( ord_less @ A @ X3 @ Y2 )
             => ( ord_less_eq @ A @ X3 @ Z ) )
         => ( ord_less_eq @ A @ Y2 @ Z ) ) ) ).

% dense_le
thf(fact_2176_dense__ge,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [Z: A,Y2: A] :
          ( ! [X3: A] :
              ( ( ord_less @ A @ Z @ X3 )
             => ( ord_less_eq @ A @ Y2 @ X3 ) )
         => ( ord_less_eq @ A @ Y2 @ Z ) ) ) ).

% dense_ge
thf(fact_2177_antisym__conv2,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [X2: A,Y2: A] :
          ( ( ord_less_eq @ A @ X2 @ Y2 )
         => ( ( ~ ( ord_less @ A @ X2 @ Y2 ) )
            = ( X2 = Y2 ) ) ) ) ).

% antisym_conv2
thf(fact_2178_antisym__conv1,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [X2: A,Y2: A] :
          ( ~ ( ord_less @ A @ X2 @ Y2 )
         => ( ( ord_less_eq @ A @ X2 @ Y2 )
            = ( X2 = Y2 ) ) ) ) ).

% antisym_conv1
thf(fact_2179_nless__le,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [A2: A,B2: A] :
          ( ( ~ ( ord_less @ A @ A2 @ B2 ) )
          = ( ~ ( ord_less_eq @ A @ A2 @ B2 )
            | ( A2 = B2 ) ) ) ) ).

% nless_le
thf(fact_2180_leI,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X2: A,Y2: A] :
          ( ~ ( ord_less @ A @ X2 @ Y2 )
         => ( ord_less_eq @ A @ Y2 @ X2 ) ) ) ).

% leI
thf(fact_2181_leD,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [Y2: A,X2: A] :
          ( ( ord_less_eq @ A @ Y2 @ X2 )
         => ~ ( ord_less @ A @ X2 @ Y2 ) ) ) ).

% leD
thf(fact_2182_compl__mono,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [X2: A,Y2: A] :
          ( ( ord_less_eq @ A @ X2 @ Y2 )
         => ( ord_less_eq @ A @ ( uminus_uminus @ A @ Y2 ) @ ( uminus_uminus @ A @ X2 ) ) ) ) ).

% compl_mono
thf(fact_2183_compl__le__swap1,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [Y2: A,X2: A] :
          ( ( ord_less_eq @ A @ Y2 @ ( uminus_uminus @ A @ X2 ) )
         => ( ord_less_eq @ A @ X2 @ ( uminus_uminus @ A @ Y2 ) ) ) ) ).

% compl_le_swap1
thf(fact_2184_compl__le__swap2,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [Y2: A,X2: A] :
          ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ Y2 ) @ X2 )
         => ( ord_less_eq @ A @ ( uminus_uminus @ A @ X2 ) @ Y2 ) ) ) ).

% compl_le_swap2
thf(fact_2185_compl__less__swap2,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [Y2: A,X2: A] :
          ( ( ord_less @ A @ ( uminus_uminus @ A @ Y2 ) @ X2 )
         => ( ord_less @ A @ ( uminus_uminus @ A @ X2 ) @ Y2 ) ) ) ).

% compl_less_swap2
thf(fact_2186_compl__less__swap1,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [Y2: A,X2: A] :
          ( ( ord_less @ A @ Y2 @ ( uminus_uminus @ A @ X2 ) )
         => ( ord_less @ A @ X2 @ ( uminus_uminus @ A @ Y2 ) ) ) ) ).

% compl_less_swap1
thf(fact_2187_max__absorb2,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [X2: A,Y2: A] :
          ( ( ord_less_eq @ A @ X2 @ Y2 )
         => ( ( ord_max @ A @ X2 @ Y2 )
            = Y2 ) ) ) ).

% max_absorb2
thf(fact_2188_max__absorb1,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [Y2: A,X2: A] :
          ( ( ord_less_eq @ A @ Y2 @ X2 )
         => ( ( ord_max @ A @ X2 @ Y2 )
            = X2 ) ) ) ).

% max_absorb1
thf(fact_2189_max__def,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ( ( ord_max @ A )
        = ( ^ [A4: A,B4: A] : ( if @ A @ ( ord_less_eq @ A @ A4 @ B4 ) @ B4 @ A4 ) ) ) ) ).

% max_def
thf(fact_2190_le__fun__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ord @ B )
     => ( ( ord_less_eq @ ( A > B ) )
        = ( ^ [F5: A > B,G4: A > B] :
            ! [X5: A] : ( ord_less_eq @ B @ ( F5 @ X5 ) @ ( G4 @ X5 ) ) ) ) ) ).

% le_fun_def
thf(fact_2191_le__funI,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ord @ B )
     => ! [F2: A > B,G: A > B] :
          ( ! [X3: A] : ( ord_less_eq @ B @ ( F2 @ X3 ) @ ( G @ X3 ) )
         => ( ord_less_eq @ ( A > B ) @ F2 @ G ) ) ) ).

% le_funI
thf(fact_2192_le__funE,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ord @ B )
     => ! [F2: A > B,G: A > B,X2: A] :
          ( ( ord_less_eq @ ( A > B ) @ F2 @ G )
         => ( ord_less_eq @ B @ ( F2 @ X2 ) @ ( G @ X2 ) ) ) ) ).

% le_funE
thf(fact_2193_le__funD,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ord @ B )
     => ! [F2: A > B,G: A > B,X2: A] :
          ( ( ord_less_eq @ ( A > B ) @ F2 @ G )
         => ( ord_less_eq @ B @ ( F2 @ X2 ) @ ( G @ X2 ) ) ) ) ).

% le_funD
thf(fact_2194_divmod__step__nat__def,axiom,
    ( ( unique1321980374590559556d_step @ nat )
    = ( ^ [L2: num] :
          ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
          @ ^ [Q4: nat,R5: nat] : ( if @ ( product_prod @ nat @ nat ) @ ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ L2 ) @ R5 ) @ ( product_Pair @ nat @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Q4 ) @ ( one_one @ nat ) ) @ ( minus_minus @ nat @ R5 @ ( numeral_numeral @ nat @ L2 ) ) ) @ ( product_Pair @ nat @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Q4 ) @ R5 ) ) ) ) ) ).

% divmod_step_nat_def
thf(fact_2195_divmod__step__int__def,axiom,
    ( ( unique1321980374590559556d_step @ int )
    = ( ^ [L2: num] :
          ( product_case_prod @ int @ int @ ( product_prod @ int @ int )
          @ ^ [Q4: int,R5: int] : ( if @ ( product_prod @ int @ int ) @ ( ord_less_eq @ int @ ( numeral_numeral @ int @ L2 ) @ R5 ) @ ( product_Pair @ int @ int @ ( plus_plus @ int @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ Q4 ) @ ( one_one @ int ) ) @ ( minus_minus @ int @ R5 @ ( numeral_numeral @ int @ L2 ) ) ) @ ( product_Pair @ int @ int @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ Q4 ) @ R5 ) ) ) ) ) ).

% divmod_step_int_def
thf(fact_2196_odd__mod__4__div__2,axiom,
    ! [N2: nat] :
      ( ( ( modulo_modulo @ nat @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ ( bit0 @ one2 ) ) ) )
        = ( numeral_numeral @ nat @ ( bit1 @ one2 ) ) )
     => ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( divide_divide @ nat @ ( minus_minus @ nat @ N2 @ ( suc @ ( zero_zero @ nat ) ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ).

% odd_mod_4_div_2
thf(fact_2197_mod__exhaust__less__4,axiom,
    ! [M: nat] :
      ( ( ( modulo_modulo @ nat @ M @ ( numeral_numeral @ nat @ ( bit0 @ ( bit0 @ one2 ) ) ) )
        = ( zero_zero @ nat ) )
      | ( ( modulo_modulo @ nat @ M @ ( numeral_numeral @ nat @ ( bit0 @ ( bit0 @ one2 ) ) ) )
        = ( one_one @ nat ) )
      | ( ( modulo_modulo @ nat @ M @ ( numeral_numeral @ nat @ ( bit0 @ ( bit0 @ one2 ) ) ) )
        = ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
      | ( ( modulo_modulo @ nat @ M @ ( numeral_numeral @ nat @ ( bit0 @ ( bit0 @ one2 ) ) ) )
        = ( numeral_numeral @ nat @ ( bit1 @ one2 ) ) ) ) ).

% mod_exhaust_less_4
thf(fact_2198_divmod__algorithm__code_I6_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [M: num,N2: num] :
          ( ( unique8689654367752047608divmod @ A @ ( bit1 @ M ) @ ( bit0 @ N2 ) )
          = ( product_case_prod @ A @ A @ ( product_prod @ A @ A )
            @ ^ [Q4: A,R5: A] : ( product_Pair @ A @ A @ Q4 @ ( plus_plus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ R5 ) @ ( one_one @ A ) ) )
            @ ( unique8689654367752047608divmod @ A @ M @ N2 ) ) ) ) ).

% divmod_algorithm_code(6)
thf(fact_2199_signed__take__bit__numeral__minus__bit1,axiom,
    ! [L: num,K: num] :
      ( ( bit_ri4674362597316999326ke_bit @ int @ ( numeral_numeral @ nat @ L ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit1 @ K ) ) ) )
      = ( plus_plus @ int @ ( times_times @ int @ ( bit_ri4674362597316999326ke_bit @ int @ ( pred_numeral @ L ) @ ( minus_minus @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ K ) ) @ ( one_one @ int ) ) ) @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( one_one @ int ) ) ) ).

% signed_take_bit_numeral_minus_bit1
thf(fact_2200_dbl__dec__simps_I4_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( neg_numeral_dbl_dec @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
        = ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( bit1 @ one2 ) ) ) ) ) ).

% dbl_dec_simps(4)
thf(fact_2201_divmod__algorithm__code_I8_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [M: num,N2: num] :
          ( ( ( ord_less @ num @ M @ N2 )
           => ( ( unique8689654367752047608divmod @ A @ ( bit1 @ M ) @ ( bit1 @ N2 ) )
              = ( product_Pair @ A @ A @ ( zero_zero @ A ) @ ( numeral_numeral @ A @ ( bit1 @ M ) ) ) ) )
          & ( ~ ( ord_less @ num @ M @ N2 )
           => ( ( unique8689654367752047608divmod @ A @ ( bit1 @ M ) @ ( bit1 @ N2 ) )
              = ( unique1321980374590559556d_step @ A @ ( bit1 @ N2 ) @ ( unique8689654367752047608divmod @ A @ ( bit1 @ M ) @ ( bit0 @ ( bit1 @ N2 ) ) ) ) ) ) ) ) ).

% divmod_algorithm_code(8)
thf(fact_2202_divmod__algorithm__code_I7_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [M: num,N2: num] :
          ( ( ( ord_less_eq @ num @ M @ N2 )
           => ( ( unique8689654367752047608divmod @ A @ ( bit0 @ M ) @ ( bit1 @ N2 ) )
              = ( product_Pair @ A @ A @ ( zero_zero @ A ) @ ( numeral_numeral @ A @ ( bit0 @ M ) ) ) ) )
          & ( ~ ( ord_less_eq @ num @ M @ N2 )
           => ( ( unique8689654367752047608divmod @ A @ ( bit0 @ M ) @ ( bit1 @ N2 ) )
              = ( unique1321980374590559556d_step @ A @ ( bit1 @ N2 ) @ ( unique8689654367752047608divmod @ A @ ( bit0 @ M ) @ ( bit0 @ ( bit1 @ N2 ) ) ) ) ) ) ) ) ).

% divmod_algorithm_code(7)
thf(fact_2203_signed__take__bit__numeral__bit1,axiom,
    ! [L: num,K: num] :
      ( ( bit_ri4674362597316999326ke_bit @ int @ ( numeral_numeral @ nat @ L ) @ ( numeral_numeral @ int @ ( bit1 @ K ) ) )
      = ( plus_plus @ int @ ( times_times @ int @ ( bit_ri4674362597316999326ke_bit @ int @ ( pred_numeral @ L ) @ ( numeral_numeral @ int @ K ) ) @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( one_one @ int ) ) ) ).

% signed_take_bit_numeral_bit1
thf(fact_2204_case__prodI,axiom,
    ! [A: $tType,B: $tType,F2: A > B > $o,A2: A,B2: B] :
      ( ( F2 @ A2 @ B2 )
     => ( product_case_prod @ A @ B @ $o @ F2 @ ( product_Pair @ A @ B @ A2 @ B2 ) ) ) ).

% case_prodI
thf(fact_2205_case__prodI2,axiom,
    ! [B: $tType,A: $tType,P4: product_prod @ A @ B,C2: A > B > $o] :
      ( ! [A5: A,B5: B] :
          ( ( P4
            = ( product_Pair @ A @ B @ A5 @ B5 ) )
         => ( C2 @ A5 @ B5 ) )
     => ( product_case_prod @ A @ B @ $o @ C2 @ P4 ) ) ).

% case_prodI2
thf(fact_2206_mem__case__prodI,axiom,
    ! [A: $tType,B: $tType,C: $tType,Z: A,C2: B > C > ( set @ A ),A2: B,B2: C] :
      ( ( member @ A @ Z @ ( C2 @ A2 @ B2 ) )
     => ( member @ A @ Z @ ( product_case_prod @ B @ C @ ( set @ A ) @ C2 @ ( product_Pair @ B @ C @ A2 @ B2 ) ) ) ) ).

% mem_case_prodI
thf(fact_2207_mem__case__prodI2,axiom,
    ! [C: $tType,B: $tType,A: $tType,P4: product_prod @ A @ B,Z: C,C2: A > B > ( set @ C )] :
      ( ! [A5: A,B5: B] :
          ( ( P4
            = ( product_Pair @ A @ B @ A5 @ B5 ) )
         => ( member @ C @ Z @ ( C2 @ A5 @ B5 ) ) )
     => ( member @ C @ Z @ ( product_case_prod @ A @ B @ ( set @ C ) @ C2 @ P4 ) ) ) ).

% mem_case_prodI2
thf(fact_2208_case__prodI2_H,axiom,
    ! [A: $tType,B: $tType,C: $tType,P4: product_prod @ A @ B,C2: A > B > C > $o,X2: C] :
      ( ! [A5: A,B5: B] :
          ( ( ( product_Pair @ A @ B @ A5 @ B5 )
            = P4 )
         => ( C2 @ A5 @ B5 @ X2 ) )
     => ( product_case_prod @ A @ B @ ( C > $o ) @ C2 @ P4 @ X2 ) ) ).

% case_prodI2'
thf(fact_2209_dbl__dec__simps_I3_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( neg_numeral_dbl_dec @ A @ ( one_one @ A ) )
        = ( one_one @ A ) ) ) ).

% dbl_dec_simps(3)
thf(fact_2210_pred__numeral__simps_I1_J,axiom,
    ( ( pred_numeral @ one2 )
    = ( zero_zero @ nat ) ) ).

% pred_numeral_simps(1)
thf(fact_2211_Suc__eq__numeral,axiom,
    ! [N2: nat,K: num] :
      ( ( ( suc @ N2 )
        = ( numeral_numeral @ nat @ K ) )
      = ( N2
        = ( pred_numeral @ K ) ) ) ).

% Suc_eq_numeral
thf(fact_2212_eq__numeral__Suc,axiom,
    ! [K: num,N2: nat] :
      ( ( ( numeral_numeral @ nat @ K )
        = ( suc @ N2 ) )
      = ( ( pred_numeral @ K )
        = N2 ) ) ).

% eq_numeral_Suc
thf(fact_2213_less__Suc__numeral,axiom,
    ! [N2: nat,K: num] :
      ( ( ord_less @ nat @ ( suc @ N2 ) @ ( numeral_numeral @ nat @ K ) )
      = ( ord_less @ nat @ N2 @ ( pred_numeral @ K ) ) ) ).

% less_Suc_numeral
thf(fact_2214_less__numeral__Suc,axiom,
    ! [K: num,N2: nat] :
      ( ( ord_less @ nat @ ( numeral_numeral @ nat @ K ) @ ( suc @ N2 ) )
      = ( ord_less @ nat @ ( pred_numeral @ K ) @ N2 ) ) ).

% less_numeral_Suc
thf(fact_2215_pred__numeral__simps_I3_J,axiom,
    ! [K: num] :
      ( ( pred_numeral @ ( bit1 @ K ) )
      = ( numeral_numeral @ nat @ ( bit0 @ K ) ) ) ).

% pred_numeral_simps(3)
thf(fact_2216_le__Suc__numeral,axiom,
    ! [N2: nat,K: num] :
      ( ( ord_less_eq @ nat @ ( suc @ N2 ) @ ( numeral_numeral @ nat @ K ) )
      = ( ord_less_eq @ nat @ N2 @ ( pred_numeral @ K ) ) ) ).

% le_Suc_numeral
thf(fact_2217_le__numeral__Suc,axiom,
    ! [K: num,N2: nat] :
      ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ K ) @ ( suc @ N2 ) )
      = ( ord_less_eq @ nat @ ( pred_numeral @ K ) @ N2 ) ) ).

% le_numeral_Suc
thf(fact_2218_diff__Suc__numeral,axiom,
    ! [N2: nat,K: num] :
      ( ( minus_minus @ nat @ ( suc @ N2 ) @ ( numeral_numeral @ nat @ K ) )
      = ( minus_minus @ nat @ N2 @ ( pred_numeral @ K ) ) ) ).

% diff_Suc_numeral
thf(fact_2219_diff__numeral__Suc,axiom,
    ! [K: num,N2: nat] :
      ( ( minus_minus @ nat @ ( numeral_numeral @ nat @ K ) @ ( suc @ N2 ) )
      = ( minus_minus @ nat @ ( pred_numeral @ K ) @ N2 ) ) ).

% diff_numeral_Suc
thf(fact_2220_max__Suc__numeral,axiom,
    ! [N2: nat,K: num] :
      ( ( ord_max @ nat @ ( suc @ N2 ) @ ( numeral_numeral @ nat @ K ) )
      = ( suc @ ( ord_max @ nat @ N2 @ ( pred_numeral @ K ) ) ) ) ).

% max_Suc_numeral
thf(fact_2221_max__numeral__Suc,axiom,
    ! [K: num,N2: nat] :
      ( ( ord_max @ nat @ ( numeral_numeral @ nat @ K ) @ ( suc @ N2 ) )
      = ( suc @ ( ord_max @ nat @ ( pred_numeral @ K ) @ N2 ) ) ) ).

% max_numeral_Suc
thf(fact_2222_dbl__dec__simps_I2_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( neg_numeral_dbl_dec @ A @ ( zero_zero @ A ) )
        = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% dbl_dec_simps(2)
thf(fact_2223_numeral__div__minus__numeral,axiom,
    ! [M: num,N2: num] :
      ( ( divide_divide @ int @ ( numeral_numeral @ int @ M ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N2 ) ) )
      = ( uminus_uminus @ int @ ( adjust_div @ ( unique8689654367752047608divmod @ int @ M @ N2 ) ) ) ) ).

% numeral_div_minus_numeral
thf(fact_2224_minus__numeral__div__numeral,axiom,
    ! [M: num,N2: num] :
      ( ( divide_divide @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ M ) ) @ ( numeral_numeral @ int @ N2 ) )
      = ( uminus_uminus @ int @ ( adjust_div @ ( unique8689654367752047608divmod @ int @ M @ N2 ) ) ) ) ).

% minus_numeral_div_numeral
thf(fact_2225_dvd__numeral__simp,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [M: num,N2: num] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ M ) @ ( numeral_numeral @ A @ N2 ) )
          = ( unique5940410009612947441es_aux @ A @ ( unique8689654367752047608divmod @ A @ N2 @ M ) ) ) ) ).

% dvd_numeral_simp
thf(fact_2226_divmod__algorithm__code_I2_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [M: num] :
          ( ( unique8689654367752047608divmod @ A @ M @ one2 )
          = ( product_Pair @ A @ A @ ( numeral_numeral @ A @ M ) @ ( zero_zero @ A ) ) ) ) ).

% divmod_algorithm_code(2)
thf(fact_2227_divmod__algorithm__code_I3_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [N2: num] :
          ( ( unique8689654367752047608divmod @ A @ one2 @ ( bit0 @ N2 ) )
          = ( product_Pair @ A @ A @ ( zero_zero @ A ) @ ( numeral_numeral @ A @ one2 ) ) ) ) ).

% divmod_algorithm_code(3)
thf(fact_2228_divmod__algorithm__code_I4_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [N2: num] :
          ( ( unique8689654367752047608divmod @ A @ one2 @ ( bit1 @ N2 ) )
          = ( product_Pair @ A @ A @ ( zero_zero @ A ) @ ( numeral_numeral @ A @ one2 ) ) ) ) ).

% divmod_algorithm_code(4)
thf(fact_2229_one__div__minus__numeral,axiom,
    ! [N2: num] :
      ( ( divide_divide @ int @ ( one_one @ int ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N2 ) ) )
      = ( uminus_uminus @ int @ ( adjust_div @ ( unique8689654367752047608divmod @ int @ one2 @ N2 ) ) ) ) ).

% one_div_minus_numeral
thf(fact_2230_minus__one__div__numeral,axiom,
    ! [N2: num] :
      ( ( divide_divide @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( numeral_numeral @ int @ N2 ) )
      = ( uminus_uminus @ int @ ( adjust_div @ ( unique8689654367752047608divmod @ int @ one2 @ N2 ) ) ) ) ).

% minus_one_div_numeral
thf(fact_2231_signed__take__bit__numeral__bit0,axiom,
    ! [L: num,K: num] :
      ( ( bit_ri4674362597316999326ke_bit @ int @ ( numeral_numeral @ nat @ L ) @ ( numeral_numeral @ int @ ( bit0 @ K ) ) )
      = ( times_times @ int @ ( bit_ri4674362597316999326ke_bit @ int @ ( pred_numeral @ L ) @ ( numeral_numeral @ int @ K ) ) @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ).

% signed_take_bit_numeral_bit0
thf(fact_2232_divmod__algorithm__code_I5_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [M: num,N2: num] :
          ( ( unique8689654367752047608divmod @ A @ ( bit0 @ M ) @ ( bit0 @ N2 ) )
          = ( product_case_prod @ A @ A @ ( product_prod @ A @ A )
            @ ^ [Q4: A,R5: A] : ( product_Pair @ A @ A @ Q4 @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ R5 ) )
            @ ( unique8689654367752047608divmod @ A @ M @ N2 ) ) ) ) ).

% divmod_algorithm_code(5)
thf(fact_2233_signed__take__bit__numeral__minus__bit0,axiom,
    ! [L: num,K: num] :
      ( ( bit_ri4674362597316999326ke_bit @ int @ ( numeral_numeral @ nat @ L ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit0 @ K ) ) ) )
      = ( times_times @ int @ ( bit_ri4674362597316999326ke_bit @ int @ ( pred_numeral @ L ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ K ) ) ) @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ).

% signed_take_bit_numeral_minus_bit0
thf(fact_2234_mem__case__prodE,axiom,
    ! [B: $tType,A: $tType,C: $tType,Z: A,C2: B > C > ( set @ A ),P4: product_prod @ B @ C] :
      ( ( member @ A @ Z @ ( product_case_prod @ B @ C @ ( set @ A ) @ C2 @ P4 ) )
     => ~ ! [X3: B,Y4: C] :
            ( ( P4
              = ( product_Pair @ B @ C @ X3 @ Y4 ) )
           => ~ ( member @ A @ Z @ ( C2 @ X3 @ Y4 ) ) ) ) ).

% mem_case_prodE
thf(fact_2235_case__prodD,axiom,
    ! [A: $tType,B: $tType,F2: A > B > $o,A2: A,B2: B] :
      ( ( product_case_prod @ A @ B @ $o @ F2 @ ( product_Pair @ A @ B @ A2 @ B2 ) )
     => ( F2 @ A2 @ B2 ) ) ).

% case_prodD
thf(fact_2236_case__prodE,axiom,
    ! [A: $tType,B: $tType,C2: A > B > $o,P4: product_prod @ A @ B] :
      ( ( product_case_prod @ A @ B @ $o @ C2 @ P4 )
     => ~ ! [X3: A,Y4: B] :
            ( ( P4
              = ( product_Pair @ A @ B @ X3 @ Y4 ) )
           => ~ ( C2 @ X3 @ Y4 ) ) ) ).

% case_prodE
thf(fact_2237_case__prodD_H,axiom,
    ! [B: $tType,A: $tType,C: $tType,R: A > B > C > $o,A2: A,B2: B,C2: C] :
      ( ( product_case_prod @ A @ B @ ( C > $o ) @ R @ ( product_Pair @ A @ B @ A2 @ B2 ) @ C2 )
     => ( R @ A2 @ B2 @ C2 ) ) ).

% case_prodD'
thf(fact_2238_case__prodE_H,axiom,
    ! [B: $tType,A: $tType,C: $tType,C2: A > B > C > $o,P4: product_prod @ A @ B,Z: C] :
      ( ( product_case_prod @ A @ B @ ( C > $o ) @ C2 @ P4 @ Z )
     => ~ ! [X3: A,Y4: B] :
            ( ( P4
              = ( product_Pair @ A @ B @ X3 @ Y4 ) )
           => ~ ( C2 @ X3 @ Y4 @ Z ) ) ) ).

% case_prodE'
thf(fact_2239_numeral__eq__Suc,axiom,
    ( ( numeral_numeral @ nat )
    = ( ^ [K3: num] : ( suc @ ( pred_numeral @ K3 ) ) ) ) ).

% numeral_eq_Suc
thf(fact_2240_pred__numeral__def,axiom,
    ( pred_numeral
    = ( ^ [K3: num] : ( minus_minus @ nat @ ( numeral_numeral @ nat @ K3 ) @ ( one_one @ nat ) ) ) ) ).

% pred_numeral_def
thf(fact_2241_divmod__int__def,axiom,
    ( ( unique8689654367752047608divmod @ int )
    = ( ^ [M6: num,N3: num] : ( product_Pair @ int @ int @ ( divide_divide @ int @ ( numeral_numeral @ int @ M6 ) @ ( numeral_numeral @ int @ N3 ) ) @ ( modulo_modulo @ int @ ( numeral_numeral @ int @ M6 ) @ ( numeral_numeral @ int @ N3 ) ) ) ) ) ).

% divmod_int_def
thf(fact_2242_Divides_Oadjust__div__def,axiom,
    ( adjust_div
    = ( product_case_prod @ int @ int @ int
      @ ^ [Q4: int,R5: int] :
          ( plus_plus @ int @ Q4
          @ ( zero_neq_one_of_bool @ int
            @ ( R5
             != ( zero_zero @ int ) ) ) ) ) ) ).

% Divides.adjust_div_def
thf(fact_2243_divmod__def,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ( ( unique8689654367752047608divmod @ A )
        = ( ^ [M6: num,N3: num] : ( product_Pair @ A @ A @ ( divide_divide @ A @ ( numeral_numeral @ A @ M6 ) @ ( numeral_numeral @ A @ N3 ) ) @ ( modulo_modulo @ A @ ( numeral_numeral @ A @ M6 ) @ ( numeral_numeral @ A @ N3 ) ) ) ) ) ) ).

% divmod_def
thf(fact_2244_divmod_H__nat__def,axiom,
    ( ( unique8689654367752047608divmod @ nat )
    = ( ^ [M6: num,N3: num] : ( product_Pair @ nat @ nat @ ( divide_divide @ nat @ ( numeral_numeral @ nat @ M6 ) @ ( numeral_numeral @ nat @ N3 ) ) @ ( modulo_modulo @ nat @ ( numeral_numeral @ nat @ M6 ) @ ( numeral_numeral @ nat @ N3 ) ) ) ) ) ).

% divmod'_nat_def
thf(fact_2245_dbl__dec__def,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( neg_numeral_dbl_dec @ A )
        = ( ^ [X5: A] : ( minus_minus @ A @ ( plus_plus @ A @ X5 @ X5 ) @ ( one_one @ A ) ) ) ) ) ).

% dbl_dec_def
thf(fact_2246_divmod__divmod__step,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ( ( unique8689654367752047608divmod @ A )
        = ( ^ [M6: num,N3: num] : ( if @ ( product_prod @ A @ A ) @ ( ord_less @ num @ M6 @ N3 ) @ ( product_Pair @ A @ A @ ( zero_zero @ A ) @ ( numeral_numeral @ A @ M6 ) ) @ ( unique1321980374590559556d_step @ A @ N3 @ ( unique8689654367752047608divmod @ A @ M6 @ ( bit0 @ N3 ) ) ) ) ) ) ) ).

% divmod_divmod_step
thf(fact_2247_divmod__nat__if,axiom,
    ( divmod_nat
    = ( ^ [M6: nat,N3: nat] :
          ( if @ ( product_prod @ nat @ nat )
          @ ( ( N3
              = ( zero_zero @ nat ) )
            | ( ord_less @ nat @ M6 @ N3 ) )
          @ ( product_Pair @ nat @ nat @ ( zero_zero @ nat ) @ M6 )
          @ ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
            @ ^ [Q4: nat] : ( product_Pair @ nat @ nat @ ( suc @ Q4 ) )
            @ ( divmod_nat @ ( minus_minus @ nat @ M6 @ N3 ) @ N3 ) ) ) ) ) ).

% divmod_nat_if
thf(fact_2248_dbl__inc__simps_I3_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( neg_numeral_dbl_inc @ A @ ( one_one @ A ) )
        = ( numeral_numeral @ A @ ( bit1 @ one2 ) ) ) ) ).

% dbl_inc_simps(3)
thf(fact_2249_of__int__code__if,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ( ( ring_1_of_int @ A )
        = ( ^ [K3: int] :
              ( if @ A
              @ ( K3
                = ( zero_zero @ int ) )
              @ ( zero_zero @ A )
              @ ( if @ A @ ( ord_less @ int @ K3 @ ( zero_zero @ int ) ) @ ( uminus_uminus @ A @ ( ring_1_of_int @ A @ ( uminus_uminus @ int @ K3 ) ) )
                @ ( if @ A
                  @ ( ( modulo_modulo @ int @ K3 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) )
                    = ( zero_zero @ int ) )
                  @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( ring_1_of_int @ A @ ( divide_divide @ int @ K3 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) )
                  @ ( plus_plus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( ring_1_of_int @ A @ ( divide_divide @ int @ K3 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) @ ( one_one @ A ) ) ) ) ) ) ) ) ).

% of_int_code_if
thf(fact_2250_int__ge__less__than__def,axiom,
    ( int_ge_less_than
    = ( ^ [D3: int] :
          ( collect @ ( product_prod @ int @ int )
          @ ( product_case_prod @ int @ int @ $o
            @ ^ [Z5: int,Z6: int] :
                ( ( ord_less_eq @ int @ D3 @ Z5 )
                & ( ord_less @ int @ Z5 @ Z6 ) ) ) ) ) ) ).

% int_ge_less_than_def
thf(fact_2251_int__ge__less__than2__def,axiom,
    ( int_ge_less_than2
    = ( ^ [D3: int] :
          ( collect @ ( product_prod @ int @ int )
          @ ( product_case_prod @ int @ int @ $o
            @ ^ [Z5: int,Z6: int] :
                ( ( ord_less_eq @ int @ D3 @ Z6 )
                & ( ord_less @ int @ Z5 @ Z6 ) ) ) ) ) ) ).

% int_ge_less_than2_def
thf(fact_2252_of__int__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [Z: int] :
          ( ( ( ring_1_of_int @ A @ Z )
            = ( zero_zero @ A ) )
          = ( Z
            = ( zero_zero @ int ) ) ) ) ).

% of_int_eq_0_iff
thf(fact_2253_of__int__0__eq__iff,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [Z: int] :
          ( ( ( zero_zero @ A )
            = ( ring_1_of_int @ A @ Z ) )
          = ( Z
            = ( zero_zero @ int ) ) ) ) ).

% of_int_0_eq_iff
thf(fact_2254_of__int__0,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ( ( ring_1_of_int @ A @ ( zero_zero @ int ) )
        = ( zero_zero @ A ) ) ) ).

% of_int_0
thf(fact_2255_of__int__le__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [W: int,Z: int] :
          ( ( ord_less_eq @ A @ ( ring_1_of_int @ A @ W ) @ ( ring_1_of_int @ A @ Z ) )
          = ( ord_less_eq @ int @ W @ Z ) ) ) ).

% of_int_le_iff
thf(fact_2256_of__int__eq__numeral__iff,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [Z: int,N2: num] :
          ( ( ( ring_1_of_int @ A @ Z )
            = ( numeral_numeral @ A @ N2 ) )
          = ( Z
            = ( numeral_numeral @ int @ N2 ) ) ) ) ).

% of_int_eq_numeral_iff
thf(fact_2257_of__int__numeral,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [K: num] :
          ( ( ring_1_of_int @ A @ ( numeral_numeral @ int @ K ) )
          = ( numeral_numeral @ A @ K ) ) ) ).

% of_int_numeral
thf(fact_2258_of__int__less__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [W: int,Z: int] :
          ( ( ord_less @ A @ ( ring_1_of_int @ A @ W ) @ ( ring_1_of_int @ A @ Z ) )
          = ( ord_less @ int @ W @ Z ) ) ) ).

% of_int_less_iff
thf(fact_2259_of__int__eq__1__iff,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [Z: int] :
          ( ( ( ring_1_of_int @ A @ Z )
            = ( one_one @ A ) )
          = ( Z
            = ( one_one @ int ) ) ) ) ).

% of_int_eq_1_iff
thf(fact_2260_of__int__1,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ( ( ring_1_of_int @ A @ ( one_one @ int ) )
        = ( one_one @ A ) ) ) ).

% of_int_1
thf(fact_2261_of__int__mult,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [W: int,Z: int] :
          ( ( ring_1_of_int @ A @ ( times_times @ int @ W @ Z ) )
          = ( times_times @ A @ ( ring_1_of_int @ A @ W ) @ ( ring_1_of_int @ A @ Z ) ) ) ) ).

% of_int_mult
thf(fact_2262_of__int__add,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [W: int,Z: int] :
          ( ( ring_1_of_int @ A @ ( plus_plus @ int @ W @ Z ) )
          = ( plus_plus @ A @ ( ring_1_of_int @ A @ W ) @ ( ring_1_of_int @ A @ Z ) ) ) ) ).

% of_int_add
thf(fact_2263_of__int__power__eq__of__int__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [X2: int,B2: int,W: nat] :
          ( ( ( ring_1_of_int @ A @ X2 )
            = ( power_power @ A @ ( ring_1_of_int @ A @ B2 ) @ W ) )
          = ( X2
            = ( power_power @ int @ B2 @ W ) ) ) ) ).

% of_int_power_eq_of_int_cancel_iff
thf(fact_2264_of__int__eq__of__int__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [B2: int,W: nat,X2: int] :
          ( ( ( power_power @ A @ ( ring_1_of_int @ A @ B2 ) @ W )
            = ( ring_1_of_int @ A @ X2 ) )
          = ( ( power_power @ int @ B2 @ W )
            = X2 ) ) ) ).

% of_int_eq_of_int_power_cancel_iff
thf(fact_2265_of__int__power,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [Z: int,N2: nat] :
          ( ( ring_1_of_int @ A @ ( power_power @ int @ Z @ N2 ) )
          = ( power_power @ A @ ( ring_1_of_int @ A @ Z ) @ N2 ) ) ) ).

% of_int_power
thf(fact_2266_dbl__inc__simps_I2_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( neg_numeral_dbl_inc @ A @ ( zero_zero @ A ) )
        = ( one_one @ A ) ) ) ).

% dbl_inc_simps(2)
thf(fact_2267_dbl__inc__simps_I4_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( neg_numeral_dbl_inc @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
        = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% dbl_inc_simps(4)
thf(fact_2268_dbl__inc__simps_I5_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [K: num] :
          ( ( neg_numeral_dbl_inc @ A @ ( numeral_numeral @ A @ K ) )
          = ( numeral_numeral @ A @ ( bit1 @ K ) ) ) ) ).

% dbl_inc_simps(5)
thf(fact_2269_dbl__dec__simps_I1_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [K: num] :
          ( ( neg_numeral_dbl_dec @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ K ) ) )
          = ( uminus_uminus @ A @ ( neg_numeral_dbl_inc @ A @ ( numeral_numeral @ A @ K ) ) ) ) ) ).

% dbl_dec_simps(1)
thf(fact_2270_dbl__inc__simps_I1_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [K: num] :
          ( ( neg_numeral_dbl_inc @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ K ) ) )
          = ( uminus_uminus @ A @ ( neg_numeral_dbl_dec @ A @ ( numeral_numeral @ A @ K ) ) ) ) ) ).

% dbl_inc_simps(1)
thf(fact_2271_of__int__le__0__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [Z: int] :
          ( ( ord_less_eq @ A @ ( ring_1_of_int @ A @ Z ) @ ( zero_zero @ A ) )
          = ( ord_less_eq @ int @ Z @ ( zero_zero @ int ) ) ) ) ).

% of_int_le_0_iff
thf(fact_2272_of__int__0__le__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [Z: int] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( ring_1_of_int @ A @ Z ) )
          = ( ord_less_eq @ int @ ( zero_zero @ int ) @ Z ) ) ) ).

% of_int_0_le_iff
thf(fact_2273_of__int__less__0__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [Z: int] :
          ( ( ord_less @ A @ ( ring_1_of_int @ A @ Z ) @ ( zero_zero @ A ) )
          = ( ord_less @ int @ Z @ ( zero_zero @ int ) ) ) ) ).

% of_int_less_0_iff
thf(fact_2274_of__int__0__less__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [Z: int] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( ring_1_of_int @ A @ Z ) )
          = ( ord_less @ int @ ( zero_zero @ int ) @ Z ) ) ) ).

% of_int_0_less_iff
thf(fact_2275_of__int__numeral__le__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N2: num,Z: int] :
          ( ( ord_less_eq @ A @ ( numeral_numeral @ A @ N2 ) @ ( ring_1_of_int @ A @ Z ) )
          = ( ord_less_eq @ int @ ( numeral_numeral @ int @ N2 ) @ Z ) ) ) ).

% of_int_numeral_le_iff
thf(fact_2276_of__int__le__numeral__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [Z: int,N2: num] :
          ( ( ord_less_eq @ A @ ( ring_1_of_int @ A @ Z ) @ ( numeral_numeral @ A @ N2 ) )
          = ( ord_less_eq @ int @ Z @ ( numeral_numeral @ int @ N2 ) ) ) ) ).

% of_int_le_numeral_iff
thf(fact_2277_of__int__numeral__less__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N2: num,Z: int] :
          ( ( ord_less @ A @ ( numeral_numeral @ A @ N2 ) @ ( ring_1_of_int @ A @ Z ) )
          = ( ord_less @ int @ ( numeral_numeral @ int @ N2 ) @ Z ) ) ) ).

% of_int_numeral_less_iff
thf(fact_2278_of__int__less__numeral__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [Z: int,N2: num] :
          ( ( ord_less @ A @ ( ring_1_of_int @ A @ Z ) @ ( numeral_numeral @ A @ N2 ) )
          = ( ord_less @ int @ Z @ ( numeral_numeral @ int @ N2 ) ) ) ) ).

% of_int_less_numeral_iff
thf(fact_2279_of__int__le__1__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [Z: int] :
          ( ( ord_less_eq @ A @ ( ring_1_of_int @ A @ Z ) @ ( one_one @ A ) )
          = ( ord_less_eq @ int @ Z @ ( one_one @ int ) ) ) ) ).

% of_int_le_1_iff
thf(fact_2280_of__int__1__le__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [Z: int] :
          ( ( ord_less_eq @ A @ ( one_one @ A ) @ ( ring_1_of_int @ A @ Z ) )
          = ( ord_less_eq @ int @ ( one_one @ int ) @ Z ) ) ) ).

% of_int_1_le_iff
thf(fact_2281_of__int__less__1__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [Z: int] :
          ( ( ord_less @ A @ ( ring_1_of_int @ A @ Z ) @ ( one_one @ A ) )
          = ( ord_less @ int @ Z @ ( one_one @ int ) ) ) ) ).

% of_int_less_1_iff
thf(fact_2282_of__int__1__less__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [Z: int] :
          ( ( ord_less @ A @ ( one_one @ A ) @ ( ring_1_of_int @ A @ Z ) )
          = ( ord_less @ int @ ( one_one @ int ) @ Z ) ) ) ).

% of_int_1_less_iff
thf(fact_2283_of__int__power__le__of__int__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X2: int,B2: int,W: nat] :
          ( ( ord_less_eq @ A @ ( ring_1_of_int @ A @ X2 ) @ ( power_power @ A @ ( ring_1_of_int @ A @ B2 ) @ W ) )
          = ( ord_less_eq @ int @ X2 @ ( power_power @ int @ B2 @ W ) ) ) ) ).

% of_int_power_le_of_int_cancel_iff
thf(fact_2284_of__int__le__of__int__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [B2: int,W: nat,X2: int] :
          ( ( ord_less_eq @ A @ ( power_power @ A @ ( ring_1_of_int @ A @ B2 ) @ W ) @ ( ring_1_of_int @ A @ X2 ) )
          = ( ord_less_eq @ int @ ( power_power @ int @ B2 @ W ) @ X2 ) ) ) ).

% of_int_le_of_int_power_cancel_iff
thf(fact_2285_of__int__eq__numeral__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [Y2: int,X2: num,N2: nat] :
          ( ( ( ring_1_of_int @ A @ Y2 )
            = ( power_power @ A @ ( numeral_numeral @ A @ X2 ) @ N2 ) )
          = ( Y2
            = ( power_power @ int @ ( numeral_numeral @ int @ X2 ) @ N2 ) ) ) ) ).

% of_int_eq_numeral_power_cancel_iff
thf(fact_2286_numeral__power__eq__of__int__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [X2: num,N2: nat,Y2: int] :
          ( ( ( power_power @ A @ ( numeral_numeral @ A @ X2 ) @ N2 )
            = ( ring_1_of_int @ A @ Y2 ) )
          = ( ( power_power @ int @ ( numeral_numeral @ int @ X2 ) @ N2 )
            = Y2 ) ) ) ).

% numeral_power_eq_of_int_cancel_iff
thf(fact_2287_of__int__power__less__of__int__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X2: int,B2: int,W: nat] :
          ( ( ord_less @ A @ ( ring_1_of_int @ A @ X2 ) @ ( power_power @ A @ ( ring_1_of_int @ A @ B2 ) @ W ) )
          = ( ord_less @ int @ X2 @ ( power_power @ int @ B2 @ W ) ) ) ) ).

% of_int_power_less_of_int_cancel_iff
thf(fact_2288_of__int__less__of__int__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [B2: int,W: nat,X2: int] :
          ( ( ord_less @ A @ ( power_power @ A @ ( ring_1_of_int @ A @ B2 ) @ W ) @ ( ring_1_of_int @ A @ X2 ) )
          = ( ord_less @ int @ ( power_power @ int @ B2 @ W ) @ X2 ) ) ) ).

% of_int_less_of_int_power_cancel_iff
thf(fact_2289_of__int__le__numeral__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: int,X2: num,N2: nat] :
          ( ( ord_less_eq @ A @ ( ring_1_of_int @ A @ A2 ) @ ( power_power @ A @ ( numeral_numeral @ A @ X2 ) @ N2 ) )
          = ( ord_less_eq @ int @ A2 @ ( power_power @ int @ ( numeral_numeral @ int @ X2 ) @ N2 ) ) ) ) ).

% of_int_le_numeral_power_cancel_iff
thf(fact_2290_numeral__power__le__of__int__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X2: num,N2: nat,A2: int] :
          ( ( ord_less_eq @ A @ ( power_power @ A @ ( numeral_numeral @ A @ X2 ) @ N2 ) @ ( ring_1_of_int @ A @ A2 ) )
          = ( ord_less_eq @ int @ ( power_power @ int @ ( numeral_numeral @ int @ X2 ) @ N2 ) @ A2 ) ) ) ).

% numeral_power_le_of_int_cancel_iff
thf(fact_2291_of__int__less__numeral__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: int,X2: num,N2: nat] :
          ( ( ord_less @ A @ ( ring_1_of_int @ A @ A2 ) @ ( power_power @ A @ ( numeral_numeral @ A @ X2 ) @ N2 ) )
          = ( ord_less @ int @ A2 @ ( power_power @ int @ ( numeral_numeral @ int @ X2 ) @ N2 ) ) ) ) ).

% of_int_less_numeral_power_cancel_iff
thf(fact_2292_numeral__power__less__of__int__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X2: num,N2: nat,A2: int] :
          ( ( ord_less @ A @ ( power_power @ A @ ( numeral_numeral @ A @ X2 ) @ N2 ) @ ( ring_1_of_int @ A @ A2 ) )
          = ( ord_less @ int @ ( power_power @ int @ ( numeral_numeral @ int @ X2 ) @ N2 ) @ A2 ) ) ) ).

% numeral_power_less_of_int_cancel_iff
thf(fact_2293_neg__numeral__power__eq__of__int__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [X2: num,N2: nat,Y2: int] :
          ( ( ( power_power @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ X2 ) ) @ N2 )
            = ( ring_1_of_int @ A @ Y2 ) )
          = ( ( power_power @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ X2 ) ) @ N2 )
            = Y2 ) ) ) ).

% neg_numeral_power_eq_of_int_cancel_iff
thf(fact_2294_of__int__eq__neg__numeral__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [Y2: int,X2: num,N2: nat] :
          ( ( ( ring_1_of_int @ A @ Y2 )
            = ( power_power @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ X2 ) ) @ N2 ) )
          = ( Y2
            = ( power_power @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ X2 ) ) @ N2 ) ) ) ) ).

% of_int_eq_neg_numeral_power_cancel_iff
thf(fact_2295_of__int__le__neg__numeral__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: int,X2: num,N2: nat] :
          ( ( ord_less_eq @ A @ ( ring_1_of_int @ A @ A2 ) @ ( power_power @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ X2 ) ) @ N2 ) )
          = ( ord_less_eq @ int @ A2 @ ( power_power @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ X2 ) ) @ N2 ) ) ) ) ).

% of_int_le_neg_numeral_power_cancel_iff
thf(fact_2296_neg__numeral__power__le__of__int__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X2: num,N2: nat,A2: int] :
          ( ( ord_less_eq @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ X2 ) ) @ N2 ) @ ( ring_1_of_int @ A @ A2 ) )
          = ( ord_less_eq @ int @ ( power_power @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ X2 ) ) @ N2 ) @ A2 ) ) ) ).

% neg_numeral_power_le_of_int_cancel_iff
thf(fact_2297_of__int__less__neg__numeral__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: int,X2: num,N2: nat] :
          ( ( ord_less @ A @ ( ring_1_of_int @ A @ A2 ) @ ( power_power @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ X2 ) ) @ N2 ) )
          = ( ord_less @ int @ A2 @ ( power_power @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ X2 ) ) @ N2 ) ) ) ) ).

% of_int_less_neg_numeral_power_cancel_iff
thf(fact_2298_neg__numeral__power__less__of__int__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X2: num,N2: nat,A2: int] :
          ( ( ord_less @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ X2 ) ) @ N2 ) @ ( ring_1_of_int @ A @ A2 ) )
          = ( ord_less @ int @ ( power_power @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ X2 ) ) @ N2 ) @ A2 ) ) ) ).

% neg_numeral_power_less_of_int_cancel_iff
thf(fact_2299_Collect__case__prod__mono,axiom,
    ! [B: $tType,A: $tType,A3: A > B > $o,B3: A > B > $o] :
      ( ( ord_less_eq @ ( A > B > $o ) @ A3 @ B3 )
     => ( ord_less_eq @ ( set @ ( product_prod @ A @ B ) ) @ ( collect @ ( product_prod @ A @ B ) @ ( product_case_prod @ A @ B @ $o @ A3 ) ) @ ( collect @ ( product_prod @ A @ B ) @ ( product_case_prod @ A @ B @ $o @ B3 ) ) ) ) ).

% Collect_case_prod_mono
thf(fact_2300_mult__of__int__commute,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [X2: int,Y2: A] :
          ( ( times_times @ A @ ( ring_1_of_int @ A @ X2 ) @ Y2 )
          = ( times_times @ A @ Y2 @ ( ring_1_of_int @ A @ X2 ) ) ) ) ).

% mult_of_int_commute
thf(fact_2301_real__of__int__div4,axiom,
    ! [N2: int,X2: int] : ( ord_less_eq @ real @ ( ring_1_of_int @ real @ ( divide_divide @ int @ N2 @ X2 ) ) @ ( divide_divide @ real @ ( ring_1_of_int @ real @ N2 ) @ ( ring_1_of_int @ real @ X2 ) ) ) ).

% real_of_int_div4
thf(fact_2302_real__of__int__div,axiom,
    ! [D2: int,N2: int] :
      ( ( dvd_dvd @ int @ D2 @ N2 )
     => ( ( ring_1_of_int @ real @ ( divide_divide @ int @ N2 @ D2 ) )
        = ( divide_divide @ real @ ( ring_1_of_int @ real @ N2 ) @ ( ring_1_of_int @ real @ D2 ) ) ) ) ).

% real_of_int_div
thf(fact_2303_of__int__nonneg,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [Z: int] :
          ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Z )
         => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( ring_1_of_int @ A @ Z ) ) ) ) ).

% of_int_nonneg
thf(fact_2304_of__int__pos,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [Z: int] :
          ( ( ord_less @ int @ ( zero_zero @ int ) @ Z )
         => ( ord_less @ A @ ( zero_zero @ A ) @ ( ring_1_of_int @ A @ Z ) ) ) ) ).

% of_int_pos
thf(fact_2305_of__int__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [K: num] :
          ( ( ring_1_of_int @ A @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ K ) ) )
          = ( uminus_uminus @ A @ ( numeral_numeral @ A @ K ) ) ) ) ).

% of_int_neg_numeral
thf(fact_2306_int__le__real__less,axiom,
    ( ( ord_less_eq @ int )
    = ( ^ [N3: int,M6: int] : ( ord_less @ real @ ( ring_1_of_int @ real @ N3 ) @ ( plus_plus @ real @ ( ring_1_of_int @ real @ M6 ) @ ( one_one @ real ) ) ) ) ) ).

% int_le_real_less
thf(fact_2307_int__less__real__le,axiom,
    ( ( ord_less @ int )
    = ( ^ [N3: int,M6: int] : ( ord_less_eq @ real @ ( plus_plus @ real @ ( ring_1_of_int @ real @ N3 ) @ ( one_one @ real ) ) @ ( ring_1_of_int @ real @ M6 ) ) ) ) ).

% int_less_real_le
thf(fact_2308_dbl__inc__def,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( neg_numeral_dbl_inc @ A )
        = ( ^ [X5: A] : ( plus_plus @ A @ ( plus_plus @ A @ X5 @ X5 ) @ ( one_one @ A ) ) ) ) ) ).

% dbl_inc_def
thf(fact_2309_real__of__int__div__aux,axiom,
    ! [X2: int,D2: int] :
      ( ( divide_divide @ real @ ( ring_1_of_int @ real @ X2 ) @ ( ring_1_of_int @ real @ D2 ) )
      = ( plus_plus @ real @ ( ring_1_of_int @ real @ ( divide_divide @ int @ X2 @ D2 ) ) @ ( divide_divide @ real @ ( ring_1_of_int @ real @ ( modulo_modulo @ int @ X2 @ D2 ) ) @ ( ring_1_of_int @ real @ D2 ) ) ) ) ).

% real_of_int_div_aux
thf(fact_2310_real__of__int__div2,axiom,
    ! [N2: int,X2: int] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( minus_minus @ real @ ( divide_divide @ real @ ( ring_1_of_int @ real @ N2 ) @ ( ring_1_of_int @ real @ X2 ) ) @ ( ring_1_of_int @ real @ ( divide_divide @ int @ N2 @ X2 ) ) ) ) ).

% real_of_int_div2
thf(fact_2311_real__of__int__div3,axiom,
    ! [N2: int,X2: int] : ( ord_less_eq @ real @ ( minus_minus @ real @ ( divide_divide @ real @ ( ring_1_of_int @ real @ N2 ) @ ( ring_1_of_int @ real @ X2 ) ) @ ( ring_1_of_int @ real @ ( divide_divide @ int @ N2 @ X2 ) ) ) @ ( one_one @ real ) ) ).

% real_of_int_div3
thf(fact_2312_even__of__int__iff,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [K: int] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( ring_1_of_int @ A @ K ) )
          = ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ K ) ) ) ).

% even_of_int_iff
thf(fact_2313_divmod__nat__def,axiom,
    ( divmod_nat
    = ( ^ [M6: nat,N3: nat] : ( product_Pair @ nat @ nat @ ( divide_divide @ nat @ M6 @ N3 ) @ ( modulo_modulo @ nat @ M6 @ N3 ) ) ) ) ).

% divmod_nat_def
thf(fact_2314_floor__exists1,axiom,
    ! [A: $tType] :
      ( ( archim462609752435547400_field @ A )
     => ! [X2: A] :
        ? [X3: int] :
          ( ( ord_less_eq @ A @ ( ring_1_of_int @ A @ X3 ) @ X2 )
          & ( ord_less @ A @ X2 @ ( ring_1_of_int @ A @ ( plus_plus @ int @ X3 @ ( one_one @ int ) ) ) )
          & ! [Y: int] :
              ( ( ( ord_less_eq @ A @ ( ring_1_of_int @ A @ Y ) @ X2 )
                & ( ord_less @ A @ X2 @ ( ring_1_of_int @ A @ ( plus_plus @ int @ Y @ ( one_one @ int ) ) ) ) )
             => ( Y = X3 ) ) ) ) ).

% floor_exists1
thf(fact_2315_floor__exists,axiom,
    ! [A: $tType] :
      ( ( archim462609752435547400_field @ A )
     => ! [X2: A] :
        ? [Z3: int] :
          ( ( ord_less_eq @ A @ ( ring_1_of_int @ A @ Z3 ) @ X2 )
          & ( ord_less @ A @ X2 @ ( ring_1_of_int @ A @ ( plus_plus @ int @ Z3 @ ( one_one @ int ) ) ) ) ) ) ).

% floor_exists
thf(fact_2316_divmod__BitM__2__eq,axiom,
    ! [M: num] :
      ( ( unique8689654367752047608divmod @ int @ ( bitM @ M ) @ ( bit0 @ one2 ) )
      = ( product_Pair @ int @ int @ ( minus_minus @ int @ ( numeral_numeral @ int @ M ) @ ( one_one @ int ) ) @ ( one_one @ int ) ) ) ).

% divmod_BitM_2_eq
thf(fact_2317_Sum__Icc__int,axiom,
    ! [M: int,N2: int] :
      ( ( ord_less_eq @ int @ M @ N2 )
     => ( ( groups7311177749621191930dd_sum @ int @ int
          @ ^ [X5: int] : X5
          @ ( set_or1337092689740270186AtMost @ int @ M @ N2 ) )
        = ( divide_divide @ int @ ( minus_minus @ int @ ( times_times @ int @ N2 @ ( plus_plus @ int @ N2 @ ( one_one @ int ) ) ) @ ( times_times @ int @ M @ ( minus_minus @ int @ M @ ( one_one @ int ) ) ) ) @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) ).

% Sum_Icc_int
thf(fact_2318_mask__numeral,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N2: num] :
          ( ( bit_se2239418461657761734s_mask @ A @ ( numeral_numeral @ nat @ N2 ) )
          = ( plus_plus @ A @ ( one_one @ A ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se2239418461657761734s_mask @ A @ ( pred_numeral @ N2 ) ) ) ) ) ) ).

% mask_numeral
thf(fact_2319_take__bit__rec,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se2584673776208193580ke_bit @ A )
        = ( ^ [N3: nat,A4: A] :
              ( if @ A
              @ ( N3
                = ( zero_zero @ nat ) )
              @ ( zero_zero @ A )
              @ ( plus_plus @ A @ ( times_times @ A @ ( bit_se2584673776208193580ke_bit @ A @ ( minus_minus @ nat @ N3 @ ( one_one @ nat ) ) @ ( divide_divide @ A @ A4 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( modulo_modulo @ A @ A4 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% take_bit_rec
thf(fact_2320_predicate2I,axiom,
    ! [B: $tType,A: $tType,P: A > B > $o,Q: A > B > $o] :
      ( ! [X3: A,Y4: B] :
          ( ( P @ X3 @ Y4 )
         => ( Q @ X3 @ Y4 ) )
     => ( ord_less_eq @ ( A > B > $o ) @ P @ Q ) ) ).

% predicate2I
thf(fact_2321_mask__nat__positive__iff,axiom,
    ! [N2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( bit_se2239418461657761734s_mask @ nat @ N2 ) )
      = ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 ) ) ).

% mask_nat_positive_iff
thf(fact_2322_take__bit__of__0,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N2: nat] :
          ( ( bit_se2584673776208193580ke_bit @ A @ N2 @ ( zero_zero @ A ) )
          = ( zero_zero @ A ) ) ) ).

% take_bit_of_0
thf(fact_2323_concat__bit__of__zero__2,axiom,
    ! [N2: nat,K: int] :
      ( ( bit_concat_bit @ N2 @ K @ ( zero_zero @ int ) )
      = ( bit_se2584673776208193580ke_bit @ int @ N2 @ K ) ) ).

% concat_bit_of_zero_2
thf(fact_2324_take__bit__0,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A] :
          ( ( bit_se2584673776208193580ke_bit @ A @ ( zero_zero @ nat ) @ A2 )
          = ( zero_zero @ A ) ) ) ).

% take_bit_0
thf(fact_2325_take__bit__Suc__1,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [N2: nat] :
          ( ( bit_se2584673776208193580ke_bit @ A @ ( suc @ N2 ) @ ( one_one @ A ) )
          = ( one_one @ A ) ) ) ).

% take_bit_Suc_1
thf(fact_2326_take__bit__numeral__1,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [L: num] :
          ( ( bit_se2584673776208193580ke_bit @ A @ ( numeral_numeral @ nat @ L ) @ ( one_one @ A ) )
          = ( one_one @ A ) ) ) ).

% take_bit_numeral_1
thf(fact_2327_mask__0,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se2239418461657761734s_mask @ A @ ( zero_zero @ nat ) )
        = ( zero_zero @ A ) ) ) ).

% mask_0
thf(fact_2328_mask__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N2: nat] :
          ( ( ( bit_se2239418461657761734s_mask @ A @ N2 )
            = ( zero_zero @ A ) )
          = ( N2
            = ( zero_zero @ nat ) ) ) ) ).

% mask_eq_0_iff
thf(fact_2329_dbl__dec__simps_I5_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [K: num] :
          ( ( neg_numeral_dbl_dec @ A @ ( numeral_numeral @ A @ K ) )
          = ( numeral_numeral @ A @ ( bitM @ K ) ) ) ) ).

% dbl_dec_simps(5)
thf(fact_2330_take__bit__of__1__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [N2: nat] :
          ( ( ( bit_se2584673776208193580ke_bit @ A @ N2 @ ( one_one @ A ) )
            = ( zero_zero @ A ) )
          = ( N2
            = ( zero_zero @ nat ) ) ) ) ).

% take_bit_of_1_eq_0_iff
thf(fact_2331_mask__Suc__0,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se2239418461657761734s_mask @ A @ ( suc @ ( zero_zero @ nat ) ) )
        = ( one_one @ A ) ) ) ).

% mask_Suc_0
thf(fact_2332_take__bit__minus__one__eq__mask,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N2: nat] :
          ( ( bit_se2584673776208193580ke_bit @ A @ N2 @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( bit_se2239418461657761734s_mask @ A @ N2 ) ) ) ).

% take_bit_minus_one_eq_mask
thf(fact_2333_take__bit__of__Suc__0,axiom,
    ! [N2: nat] :
      ( ( bit_se2584673776208193580ke_bit @ nat @ N2 @ ( suc @ ( zero_zero @ nat ) ) )
      = ( zero_neq_one_of_bool @ nat @ ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 ) ) ) ).

% take_bit_of_Suc_0
thf(fact_2334_pred__numeral__simps_I2_J,axiom,
    ! [K: num] :
      ( ( pred_numeral @ ( bit0 @ K ) )
      = ( numeral_numeral @ nat @ ( bitM @ K ) ) ) ).

% pred_numeral_simps(2)
thf(fact_2335_take__bit__of__1,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N2: nat] :
          ( ( bit_se2584673776208193580ke_bit @ A @ N2 @ ( one_one @ A ) )
          = ( zero_neq_one_of_bool @ A @ ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 ) ) ) ) ).

% take_bit_of_1
thf(fact_2336_even__take__bit__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N2: nat,A2: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se2584673776208193580ke_bit @ A @ N2 @ A2 ) )
          = ( ( N2
              = ( zero_zero @ nat ) )
            | ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) ) ) ) ).

% even_take_bit_eq
thf(fact_2337_take__bit__Suc__0,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A] :
          ( ( bit_se2584673776208193580ke_bit @ A @ ( suc @ ( zero_zero @ nat ) ) @ A2 )
          = ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% take_bit_Suc_0
thf(fact_2338_take__bit__of__exp,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [M: nat,N2: nat] :
          ( ( bit_se2584673776208193580ke_bit @ A @ M @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N2 ) )
          = ( times_times @ A @ ( zero_neq_one_of_bool @ A @ ( ord_less @ nat @ N2 @ M ) ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N2 ) ) ) ) ).

% take_bit_of_exp
thf(fact_2339_take__bit__of__2,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [N2: nat] :
          ( ( bit_se2584673776208193580ke_bit @ A @ N2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
          = ( times_times @ A @ ( zero_neq_one_of_bool @ A @ ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% take_bit_of_2
thf(fact_2340_of__int__mask__eq,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N2: nat] :
          ( ( ring_1_of_int @ A @ ( bit_se2239418461657761734s_mask @ int @ N2 ) )
          = ( bit_se2239418461657761734s_mask @ A @ N2 ) ) ) ).

% of_int_mask_eq
thf(fact_2341_take__bit__of__int,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N2: nat,K: int] :
          ( ( bit_se2584673776208193580ke_bit @ A @ N2 @ ( ring_1_of_int @ A @ K ) )
          = ( ring_1_of_int @ A @ ( bit_se2584673776208193580ke_bit @ int @ N2 @ K ) ) ) ) ).

% take_bit_of_int
thf(fact_2342_rev__predicate2D,axiom,
    ! [A: $tType,B: $tType,P: A > B > $o,X2: A,Y2: B,Q: A > B > $o] :
      ( ( P @ X2 @ Y2 )
     => ( ( ord_less_eq @ ( A > B > $o ) @ P @ Q )
       => ( Q @ X2 @ Y2 ) ) ) ).

% rev_predicate2D
thf(fact_2343_predicate2D,axiom,
    ! [A: $tType,B: $tType,P: A > B > $o,Q: A > B > $o,X2: A,Y2: B] :
      ( ( ord_less_eq @ ( A > B > $o ) @ P @ Q )
     => ( ( P @ X2 @ Y2 )
       => ( Q @ X2 @ Y2 ) ) ) ).

% predicate2D
thf(fact_2344_take__bit__add,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [N2: nat,A2: A,B2: A] :
          ( ( bit_se2584673776208193580ke_bit @ A @ N2 @ ( plus_plus @ A @ ( bit_se2584673776208193580ke_bit @ A @ N2 @ A2 ) @ ( bit_se2584673776208193580ke_bit @ A @ N2 @ B2 ) ) )
          = ( bit_se2584673776208193580ke_bit @ A @ N2 @ ( plus_plus @ A @ A2 @ B2 ) ) ) ) ).

% take_bit_add
thf(fact_2345_take__bit__tightened,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N2: nat,A2: A,B2: A,M: nat] :
          ( ( ( bit_se2584673776208193580ke_bit @ A @ N2 @ A2 )
            = ( bit_se2584673776208193580ke_bit @ A @ N2 @ B2 ) )
         => ( ( ord_less_eq @ nat @ M @ N2 )
           => ( ( bit_se2584673776208193580ke_bit @ A @ M @ A2 )
              = ( bit_se2584673776208193580ke_bit @ A @ M @ B2 ) ) ) ) ) ).

% take_bit_tightened
thf(fact_2346_take__bit__nat__less__eq__self,axiom,
    ! [N2: nat,M: nat] : ( ord_less_eq @ nat @ ( bit_se2584673776208193580ke_bit @ nat @ N2 @ M ) @ M ) ).

% take_bit_nat_less_eq_self
thf(fact_2347_take__bit__tightened__less__eq__nat,axiom,
    ! [M: nat,N2: nat,Q3: nat] :
      ( ( ord_less_eq @ nat @ M @ N2 )
     => ( ord_less_eq @ nat @ ( bit_se2584673776208193580ke_bit @ nat @ M @ Q3 ) @ ( bit_se2584673776208193580ke_bit @ nat @ N2 @ Q3 ) ) ) ).

% take_bit_tightened_less_eq_nat
thf(fact_2348_take__bit__minus,axiom,
    ! [N2: nat,K: int] :
      ( ( bit_se2584673776208193580ke_bit @ int @ N2 @ ( uminus_uminus @ int @ ( bit_se2584673776208193580ke_bit @ int @ N2 @ K ) ) )
      = ( bit_se2584673776208193580ke_bit @ int @ N2 @ ( uminus_uminus @ int @ K ) ) ) ).

% take_bit_minus
thf(fact_2349_take__bit__mult,axiom,
    ! [N2: nat,K: int,L: int] :
      ( ( bit_se2584673776208193580ke_bit @ int @ N2 @ ( times_times @ int @ ( bit_se2584673776208193580ke_bit @ int @ N2 @ K ) @ ( bit_se2584673776208193580ke_bit @ int @ N2 @ L ) ) )
      = ( bit_se2584673776208193580ke_bit @ int @ N2 @ ( times_times @ int @ K @ L ) ) ) ).

% take_bit_mult
thf(fact_2350_take__bit__diff,axiom,
    ! [N2: nat,K: int,L: int] :
      ( ( bit_se2584673776208193580ke_bit @ int @ N2 @ ( minus_minus @ int @ ( bit_se2584673776208193580ke_bit @ int @ N2 @ K ) @ ( bit_se2584673776208193580ke_bit @ int @ N2 @ L ) ) )
      = ( bit_se2584673776208193580ke_bit @ int @ N2 @ ( minus_minus @ int @ K @ L ) ) ) ).

% take_bit_diff
thf(fact_2351_concat__bit__take__bit__eq,axiom,
    ! [N2: nat,B2: int] :
      ( ( bit_concat_bit @ N2 @ ( bit_se2584673776208193580ke_bit @ int @ N2 @ B2 ) )
      = ( bit_concat_bit @ N2 @ B2 ) ) ).

% concat_bit_take_bit_eq
thf(fact_2352_concat__bit__eq__iff,axiom,
    ! [N2: nat,K: int,L: int,R3: int,S2: int] :
      ( ( ( bit_concat_bit @ N2 @ K @ L )
        = ( bit_concat_bit @ N2 @ R3 @ S2 ) )
      = ( ( ( bit_se2584673776208193580ke_bit @ int @ N2 @ K )
          = ( bit_se2584673776208193580ke_bit @ int @ N2 @ R3 ) )
        & ( L = S2 ) ) ) ).

% concat_bit_eq_iff
thf(fact_2353_less__eq__mask,axiom,
    ! [N2: nat] : ( ord_less_eq @ nat @ N2 @ ( bit_se2239418461657761734s_mask @ nat @ N2 ) ) ).

% less_eq_mask
thf(fact_2354_semiring__norm_I26_J,axiom,
    ( ( bitM @ one2 )
    = one2 ) ).

% semiring_norm(26)
thf(fact_2355_mod__sum__eq,axiom,
    ! [B: $tType,A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [F2: B > A,A2: A,A3: set @ B] :
          ( ( modulo_modulo @ A
            @ ( groups7311177749621191930dd_sum @ B @ A
              @ ^ [I4: B] : ( modulo_modulo @ A @ ( F2 @ I4 ) @ A2 )
              @ A3 )
            @ A2 )
          = ( modulo_modulo @ A @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ A3 ) @ A2 ) ) ) ).

% mod_sum_eq
thf(fact_2356_take__bit__eq__mask__iff,axiom,
    ! [N2: nat,K: int] :
      ( ( ( bit_se2584673776208193580ke_bit @ int @ N2 @ K )
        = ( bit_se2239418461657761734s_mask @ int @ N2 ) )
      = ( ( bit_se2584673776208193580ke_bit @ int @ N2 @ ( plus_plus @ int @ K @ ( one_one @ int ) ) )
        = ( zero_zero @ int ) ) ) ).

% take_bit_eq_mask_iff
thf(fact_2357_take__bit__tightened__less__eq__int,axiom,
    ! [M: nat,N2: nat,K: int] :
      ( ( ord_less_eq @ nat @ M @ N2 )
     => ( ord_less_eq @ int @ ( bit_se2584673776208193580ke_bit @ int @ M @ K ) @ ( bit_se2584673776208193580ke_bit @ int @ N2 @ K ) ) ) ).

% take_bit_tightened_less_eq_int
thf(fact_2358_take__bit__nonnegative,axiom,
    ! [N2: nat,K: int] : ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( bit_se2584673776208193580ke_bit @ int @ N2 @ K ) ) ).

% take_bit_nonnegative
thf(fact_2359_take__bit__int__less__eq__self__iff,axiom,
    ! [N2: nat,K: int] :
      ( ( ord_less_eq @ int @ ( bit_se2584673776208193580ke_bit @ int @ N2 @ K ) @ K )
      = ( ord_less_eq @ int @ ( zero_zero @ int ) @ K ) ) ).

% take_bit_int_less_eq_self_iff
thf(fact_2360_signed__take__bit__eq__iff__take__bit__eq,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N2: nat,A2: A,B2: A] :
          ( ( ( bit_ri4674362597316999326ke_bit @ A @ N2 @ A2 )
            = ( bit_ri4674362597316999326ke_bit @ A @ N2 @ B2 ) )
          = ( ( bit_se2584673776208193580ke_bit @ A @ ( suc @ N2 ) @ A2 )
            = ( bit_se2584673776208193580ke_bit @ A @ ( suc @ N2 ) @ B2 ) ) ) ) ).

% signed_take_bit_eq_iff_take_bit_eq
thf(fact_2361_not__take__bit__negative,axiom,
    ! [N2: nat,K: int] :
      ~ ( ord_less @ int @ ( bit_se2584673776208193580ke_bit @ int @ N2 @ K ) @ ( zero_zero @ int ) ) ).

% not_take_bit_negative
thf(fact_2362_take__bit__int__greater__self__iff,axiom,
    ! [K: int,N2: nat] :
      ( ( ord_less @ int @ K @ ( bit_se2584673776208193580ke_bit @ int @ N2 @ K ) )
      = ( ord_less @ int @ K @ ( zero_zero @ int ) ) ) ).

% take_bit_int_greater_self_iff
thf(fact_2363_signed__take__bit__take__bit,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [M: nat,N2: nat,A2: A] :
          ( ( bit_ri4674362597316999326ke_bit @ A @ M @ ( bit_se2584673776208193580ke_bit @ A @ N2 @ A2 ) )
          = ( if @ ( A > A ) @ ( ord_less_eq @ nat @ N2 @ M ) @ ( bit_se2584673776208193580ke_bit @ A @ N2 ) @ ( bit_ri4674362597316999326ke_bit @ A @ M ) @ A2 ) ) ) ).

% signed_take_bit_take_bit
thf(fact_2364_take__bit__unset__bit__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N2: nat,M: nat,A2: A] :
          ( ( ( ord_less_eq @ nat @ N2 @ M )
           => ( ( bit_se2584673776208193580ke_bit @ A @ N2 @ ( bit_se2638667681897837118et_bit @ A @ M @ A2 ) )
              = ( bit_se2584673776208193580ke_bit @ A @ N2 @ A2 ) ) )
          & ( ~ ( ord_less_eq @ nat @ N2 @ M )
           => ( ( bit_se2584673776208193580ke_bit @ A @ N2 @ ( bit_se2638667681897837118et_bit @ A @ M @ A2 ) )
              = ( bit_se2638667681897837118et_bit @ A @ M @ ( bit_se2584673776208193580ke_bit @ A @ N2 @ A2 ) ) ) ) ) ) ).

% take_bit_unset_bit_eq
thf(fact_2365_take__bit__set__bit__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N2: nat,M: nat,A2: A] :
          ( ( ( ord_less_eq @ nat @ N2 @ M )
           => ( ( bit_se2584673776208193580ke_bit @ A @ N2 @ ( bit_se5668285175392031749et_bit @ A @ M @ A2 ) )
              = ( bit_se2584673776208193580ke_bit @ A @ N2 @ A2 ) ) )
          & ( ~ ( ord_less_eq @ nat @ N2 @ M )
           => ( ( bit_se2584673776208193580ke_bit @ A @ N2 @ ( bit_se5668285175392031749et_bit @ A @ M @ A2 ) )
              = ( bit_se5668285175392031749et_bit @ A @ M @ ( bit_se2584673776208193580ke_bit @ A @ N2 @ A2 ) ) ) ) ) ) ).

% take_bit_set_bit_eq
thf(fact_2366_take__bit__flip__bit__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N2: nat,M: nat,A2: A] :
          ( ( ( ord_less_eq @ nat @ N2 @ M )
           => ( ( bit_se2584673776208193580ke_bit @ A @ N2 @ ( bit_se8732182000553998342ip_bit @ A @ M @ A2 ) )
              = ( bit_se2584673776208193580ke_bit @ A @ N2 @ A2 ) ) )
          & ( ~ ( ord_less_eq @ nat @ N2 @ M )
           => ( ( bit_se2584673776208193580ke_bit @ A @ N2 @ ( bit_se8732182000553998342ip_bit @ A @ M @ A2 ) )
              = ( bit_se8732182000553998342ip_bit @ A @ M @ ( bit_se2584673776208193580ke_bit @ A @ N2 @ A2 ) ) ) ) ) ) ).

% take_bit_flip_bit_eq
thf(fact_2367_mask__nonnegative__int,axiom,
    ! [N2: nat] : ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( bit_se2239418461657761734s_mask @ int @ N2 ) ) ).

% mask_nonnegative_int
thf(fact_2368_not__mask__negative__int,axiom,
    ! [N2: nat] :
      ~ ( ord_less @ int @ ( bit_se2239418461657761734s_mask @ int @ N2 ) @ ( zero_zero @ int ) ) ).

% not_mask_negative_int
thf(fact_2369_semiring__norm_I28_J,axiom,
    ! [N2: num] :
      ( ( bitM @ ( bit1 @ N2 ) )
      = ( bit1 @ ( bit0 @ N2 ) ) ) ).

% semiring_norm(28)
thf(fact_2370_semiring__norm_I27_J,axiom,
    ! [N2: num] :
      ( ( bitM @ ( bit0 @ N2 ) )
      = ( bit1 @ ( bitM @ N2 ) ) ) ).

% semiring_norm(27)
thf(fact_2371_take__bit__signed__take__bit,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [M: nat,N2: nat,A2: A] :
          ( ( ord_less_eq @ nat @ M @ ( suc @ N2 ) )
         => ( ( bit_se2584673776208193580ke_bit @ A @ M @ ( bit_ri4674362597316999326ke_bit @ A @ N2 @ A2 ) )
            = ( bit_se2584673776208193580ke_bit @ A @ M @ A2 ) ) ) ) ).

% take_bit_signed_take_bit
thf(fact_2372_take__bit__decr__eq,axiom,
    ! [N2: nat,K: int] :
      ( ( ( bit_se2584673776208193580ke_bit @ int @ N2 @ K )
       != ( zero_zero @ int ) )
     => ( ( bit_se2584673776208193580ke_bit @ int @ N2 @ ( minus_minus @ int @ K @ ( one_one @ int ) ) )
        = ( minus_minus @ int @ ( bit_se2584673776208193580ke_bit @ int @ N2 @ K ) @ ( one_one @ int ) ) ) ) ).

% take_bit_decr_eq
thf(fact_2373_less__mask,axiom,
    ! [N2: nat] :
      ( ( ord_less @ nat @ ( suc @ ( zero_zero @ nat ) ) @ N2 )
     => ( ord_less @ nat @ N2 @ ( bit_se2239418461657761734s_mask @ nat @ N2 ) ) ) ).

% less_mask
thf(fact_2374_eval__nat__numeral_I2_J,axiom,
    ! [N2: num] :
      ( ( numeral_numeral @ nat @ ( bit0 @ N2 ) )
      = ( suc @ ( numeral_numeral @ nat @ ( bitM @ N2 ) ) ) ) ).

% eval_nat_numeral(2)
thf(fact_2375_take__bit__eq__mask__iff__exp__dvd,axiom,
    ! [N2: nat,K: int] :
      ( ( ( bit_se2584673776208193580ke_bit @ int @ N2 @ K )
        = ( bit_se2239418461657761734s_mask @ int @ N2 ) )
      = ( dvd_dvd @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N2 ) @ ( plus_plus @ int @ K @ ( one_one @ int ) ) ) ) ).

% take_bit_eq_mask_iff_exp_dvd
thf(fact_2376_BitM__plus__one,axiom,
    ! [N2: num] :
      ( ( plus_plus @ num @ ( bitM @ N2 ) @ one2 )
      = ( bit0 @ N2 ) ) ).

% BitM_plus_one
thf(fact_2377_one__plus__BitM,axiom,
    ! [N2: num] :
      ( ( plus_plus @ num @ one2 @ ( bitM @ N2 ) )
      = ( bit0 @ N2 ) ) ).

% one_plus_BitM
thf(fact_2378_take__bit__Suc__bit0,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [N2: nat,K: num] :
          ( ( bit_se2584673776208193580ke_bit @ A @ ( suc @ N2 ) @ ( numeral_numeral @ A @ ( bit0 @ K ) ) )
          = ( times_times @ A @ ( bit_se2584673776208193580ke_bit @ A @ N2 @ ( numeral_numeral @ A @ K ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% take_bit_Suc_bit0
thf(fact_2379_take__bit__eq__mod,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se2584673776208193580ke_bit @ A )
        = ( ^ [N3: nat,A4: A] : ( modulo_modulo @ A @ A4 @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N3 ) ) ) ) ) ).

% take_bit_eq_mod
thf(fact_2380_numeral__BitM,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [N2: num] :
          ( ( numeral_numeral @ A @ ( bitM @ N2 ) )
          = ( minus_minus @ A @ ( numeral_numeral @ A @ ( bit0 @ N2 ) ) @ ( one_one @ A ) ) ) ) ).

% numeral_BitM
thf(fact_2381_odd__numeral__BitM,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [W: num] :
          ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( numeral_numeral @ A @ ( bitM @ W ) ) ) ) ).

% odd_numeral_BitM
thf(fact_2382_take__bit__nat__eq__self,axiom,
    ! [M: nat,N2: nat] :
      ( ( ord_less @ nat @ M @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) )
     => ( ( bit_se2584673776208193580ke_bit @ nat @ N2 @ M )
        = M ) ) ).

% take_bit_nat_eq_self
thf(fact_2383_take__bit__nat__less__exp,axiom,
    ! [N2: nat,M: nat] : ( ord_less @ nat @ ( bit_se2584673776208193580ke_bit @ nat @ N2 @ M ) @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) ).

% take_bit_nat_less_exp
thf(fact_2384_take__bit__nat__eq__self__iff,axiom,
    ! [N2: nat,M: nat] :
      ( ( ( bit_se2584673776208193580ke_bit @ nat @ N2 @ M )
        = M )
      = ( ord_less @ nat @ M @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) ) ).

% take_bit_nat_eq_self_iff
thf(fact_2385_take__bit__nat__def,axiom,
    ( ( bit_se2584673776208193580ke_bit @ nat )
    = ( ^ [N3: nat,M6: nat] : ( modulo_modulo @ nat @ M6 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N3 ) ) ) ) ).

% take_bit_nat_def
thf(fact_2386_take__bit__int__less__exp,axiom,
    ! [N2: nat,K: int] : ( ord_less @ int @ ( bit_se2584673776208193580ke_bit @ int @ N2 @ K ) @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N2 ) ) ).

% take_bit_int_less_exp
thf(fact_2387_take__bit__int__def,axiom,
    ( ( bit_se2584673776208193580ke_bit @ int )
    = ( ^ [N3: nat,K3: int] : ( modulo_modulo @ int @ K3 @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N3 ) ) ) ) ).

% take_bit_int_def
thf(fact_2388_take__bit__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N2: nat,A2: A] :
          ( ( ( bit_se2584673776208193580ke_bit @ A @ N2 @ A2 )
            = ( zero_zero @ A ) )
          = ( dvd_dvd @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N2 ) @ A2 ) ) ) ).

% take_bit_eq_0_iff
thf(fact_2389_take__bit__numeral__bit0,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [L: num,K: num] :
          ( ( bit_se2584673776208193580ke_bit @ A @ ( numeral_numeral @ nat @ L ) @ ( numeral_numeral @ A @ ( bit0 @ K ) ) )
          = ( times_times @ A @ ( bit_se2584673776208193580ke_bit @ A @ ( pred_numeral @ L ) @ ( numeral_numeral @ A @ K ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% take_bit_numeral_bit0
thf(fact_2390_take__bit__nat__less__self__iff,axiom,
    ! [N2: nat,M: nat] :
      ( ( ord_less @ nat @ ( bit_se2584673776208193580ke_bit @ nat @ N2 @ M ) @ M )
      = ( ord_less_eq @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) @ M ) ) ).

% take_bit_nat_less_self_iff
thf(fact_2391_Suc__mask__eq__exp,axiom,
    ! [N2: nat] :
      ( ( suc @ ( bit_se2239418461657761734s_mask @ nat @ N2 ) )
      = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) ).

% Suc_mask_eq_exp
thf(fact_2392_mask__nat__less__exp,axiom,
    ! [N2: nat] : ( ord_less @ nat @ ( bit_se2239418461657761734s_mask @ nat @ N2 ) @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) ).

% mask_nat_less_exp
thf(fact_2393_take__bit__Suc__minus__bit0,axiom,
    ! [N2: nat,K: num] :
      ( ( bit_se2584673776208193580ke_bit @ int @ ( suc @ N2 ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit0 @ K ) ) ) )
      = ( times_times @ int @ ( bit_se2584673776208193580ke_bit @ int @ N2 @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ K ) ) ) @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ).

% take_bit_Suc_minus_bit0
thf(fact_2394_take__bit__int__greater__eq__self__iff,axiom,
    ! [K: int,N2: nat] :
      ( ( ord_less_eq @ int @ K @ ( bit_se2584673776208193580ke_bit @ int @ N2 @ K ) )
      = ( ord_less @ int @ K @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N2 ) ) ) ).

% take_bit_int_greater_eq_self_iff
thf(fact_2395_take__bit__int__less__self__iff,axiom,
    ! [N2: nat,K: int] :
      ( ( ord_less @ int @ ( bit_se2584673776208193580ke_bit @ int @ N2 @ K ) @ K )
      = ( ord_less_eq @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N2 ) @ K ) ) ).

% take_bit_int_less_self_iff
thf(fact_2396_semiring__bit__operations__class_Oeven__mask__iff,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N2: nat] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se2239418461657761734s_mask @ A @ N2 ) )
          = ( N2
            = ( zero_zero @ nat ) ) ) ) ).

% semiring_bit_operations_class.even_mask_iff
thf(fact_2397_take__bit__int__eq__self__iff,axiom,
    ! [N2: nat,K: int] :
      ( ( ( bit_se2584673776208193580ke_bit @ int @ N2 @ K )
        = K )
      = ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ K )
        & ( ord_less @ int @ K @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N2 ) ) ) ) ).

% take_bit_int_eq_self_iff
thf(fact_2398_take__bit__int__eq__self,axiom,
    ! [K: int,N2: nat] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ K )
     => ( ( ord_less @ int @ K @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N2 ) )
       => ( ( bit_se2584673776208193580ke_bit @ int @ N2 @ K )
          = K ) ) ) ).

% take_bit_int_eq_self
thf(fact_2399_take__bit__numeral__minus__bit0,axiom,
    ! [L: num,K: num] :
      ( ( bit_se2584673776208193580ke_bit @ int @ ( numeral_numeral @ nat @ L ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit0 @ K ) ) ) )
      = ( times_times @ int @ ( bit_se2584673776208193580ke_bit @ int @ ( pred_numeral @ L ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ K ) ) ) @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ).

% take_bit_numeral_minus_bit0
thf(fact_2400_mask__nat__def,axiom,
    ( ( bit_se2239418461657761734s_mask @ nat )
    = ( ^ [N3: nat] : ( minus_minus @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N3 ) @ ( one_one @ nat ) ) ) ) ).

% mask_nat_def
thf(fact_2401_mask__half__int,axiom,
    ! [N2: nat] :
      ( ( divide_divide @ int @ ( bit_se2239418461657761734s_mask @ int @ N2 ) @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) )
      = ( bit_se2239418461657761734s_mask @ int @ ( minus_minus @ nat @ N2 @ ( one_one @ nat ) ) ) ) ).

% mask_half_int
thf(fact_2402_take__bit__incr__eq,axiom,
    ! [N2: nat,K: int] :
      ( ( ( bit_se2584673776208193580ke_bit @ int @ N2 @ K )
       != ( minus_minus @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N2 ) @ ( one_one @ int ) ) )
     => ( ( bit_se2584673776208193580ke_bit @ int @ N2 @ ( plus_plus @ int @ K @ ( one_one @ int ) ) )
        = ( plus_plus @ int @ ( one_one @ int ) @ ( bit_se2584673776208193580ke_bit @ int @ N2 @ K ) ) ) ) ).

% take_bit_incr_eq
thf(fact_2403_exists__least__lemma,axiom,
    ! [P: nat > $o] :
      ( ~ ( P @ ( zero_zero @ nat ) )
     => ( ? [X_1: nat] : ( P @ X_1 )
       => ? [N: nat] :
            ( ~ ( P @ N )
            & ( P @ ( suc @ N ) ) ) ) ) ).

% exists_least_lemma
thf(fact_2404_mask__int__def,axiom,
    ( ( bit_se2239418461657761734s_mask @ int )
    = ( ^ [N3: nat] : ( minus_minus @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N3 ) @ ( one_one @ int ) ) ) ) ).

% mask_int_def
thf(fact_2405_ex__le__of__int,axiom,
    ! [A: $tType] :
      ( ( archim462609752435547400_field @ A )
     => ! [X2: A] :
        ? [Z3: int] : ( ord_less_eq @ A @ X2 @ ( ring_1_of_int @ A @ Z3 ) ) ) ).

% ex_le_of_int
thf(fact_2406_ex__of__int__less,axiom,
    ! [A: $tType] :
      ( ( archim462609752435547400_field @ A )
     => ! [X2: A] :
        ? [Z3: int] : ( ord_less @ A @ ( ring_1_of_int @ A @ Z3 ) @ X2 ) ) ).

% ex_of_int_less
thf(fact_2407_ex__less__of__int,axiom,
    ! [A: $tType] :
      ( ( archim462609752435547400_field @ A )
     => ! [X2: A] :
        ? [Z3: int] : ( ord_less @ A @ X2 @ ( ring_1_of_int @ A @ Z3 ) ) ) ).

% ex_less_of_int
thf(fact_2408_take__bit__Suc__minus__1__eq,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N2: nat] :
          ( ( bit_se2584673776208193580ke_bit @ A @ ( suc @ N2 ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( minus_minus @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( suc @ N2 ) ) @ ( one_one @ A ) ) ) ) ).

% take_bit_Suc_minus_1_eq
thf(fact_2409_take__bit__Suc__bit1,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [N2: nat,K: num] :
          ( ( bit_se2584673776208193580ke_bit @ A @ ( suc @ N2 ) @ ( numeral_numeral @ A @ ( bit1 @ K ) ) )
          = ( plus_plus @ A @ ( times_times @ A @ ( bit_se2584673776208193580ke_bit @ A @ N2 @ ( numeral_numeral @ A @ K ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( one_one @ A ) ) ) ) ).

% take_bit_Suc_bit1
thf(fact_2410_take__bit__numeral__minus__1__eq,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [K: num] :
          ( ( bit_se2584673776208193580ke_bit @ A @ ( numeral_numeral @ nat @ K ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( minus_minus @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( numeral_numeral @ nat @ K ) ) @ ( one_one @ A ) ) ) ) ).

% take_bit_numeral_minus_1_eq
thf(fact_2411_take__bit__Suc,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N2: nat,A2: A] :
          ( ( bit_se2584673776208193580ke_bit @ A @ ( suc @ N2 ) @ A2 )
          = ( plus_plus @ A @ ( times_times @ A @ ( bit_se2584673776208193580ke_bit @ A @ N2 @ ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ).

% take_bit_Suc
thf(fact_2412_mask__eq__exp__minus__1,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se2239418461657761734s_mask @ A )
        = ( ^ [N3: nat] : ( minus_minus @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N3 ) @ ( one_one @ A ) ) ) ) ) ).

% mask_eq_exp_minus_1
thf(fact_2413_take__bit__int__less__eq,axiom,
    ! [N2: nat,K: int] :
      ( ( ord_less_eq @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N2 ) @ K )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
       => ( ord_less_eq @ int @ ( bit_se2584673776208193580ke_bit @ int @ N2 @ K ) @ ( minus_minus @ int @ K @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N2 ) ) ) ) ) ).

% take_bit_int_less_eq
thf(fact_2414_take__bit__int__greater__eq,axiom,
    ! [K: int,N2: nat] :
      ( ( ord_less @ int @ K @ ( zero_zero @ int ) )
     => ( ord_less_eq @ int @ ( plus_plus @ int @ K @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N2 ) ) @ ( bit_se2584673776208193580ke_bit @ int @ N2 @ K ) ) ) ).

% take_bit_int_greater_eq
thf(fact_2415_signed__take__bit__eq__take__bit__shift,axiom,
    ( ( bit_ri4674362597316999326ke_bit @ int )
    = ( ^ [N3: nat,K3: int] : ( minus_minus @ int @ ( bit_se2584673776208193580ke_bit @ int @ ( suc @ N3 ) @ ( plus_plus @ int @ K3 @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N3 ) ) ) @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N3 ) ) ) ) ).

% signed_take_bit_eq_take_bit_shift
thf(fact_2416_stable__imp__take__bit__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A,N2: nat] :
          ( ( ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
            = A2 )
         => ( ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
             => ( ( bit_se2584673776208193580ke_bit @ A @ N2 @ A2 )
                = ( zero_zero @ A ) ) )
            & ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
             => ( ( bit_se2584673776208193580ke_bit @ A @ N2 @ A2 )
                = ( minus_minus @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N2 ) @ ( one_one @ A ) ) ) ) ) ) ) ).

% stable_imp_take_bit_eq
thf(fact_2417_take__bit__numeral__bit1,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [L: num,K: num] :
          ( ( bit_se2584673776208193580ke_bit @ A @ ( numeral_numeral @ nat @ L ) @ ( numeral_numeral @ A @ ( bit1 @ K ) ) )
          = ( plus_plus @ A @ ( times_times @ A @ ( bit_se2584673776208193580ke_bit @ A @ ( pred_numeral @ L ) @ ( numeral_numeral @ A @ K ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( one_one @ A ) ) ) ) ).

% take_bit_numeral_bit1
thf(fact_2418_take__bit__minus__small__eq,axiom,
    ! [K: int,N2: nat] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ K )
     => ( ( ord_less_eq @ int @ K @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N2 ) )
       => ( ( bit_se2584673776208193580ke_bit @ int @ N2 @ ( uminus_uminus @ int @ K ) )
          = ( minus_minus @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N2 ) @ K ) ) ) ) ).

% take_bit_minus_small_eq
thf(fact_2419_sum_Oneutral__const,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A3: set @ B] :
          ( ( groups7311177749621191930dd_sum @ B @ A
            @ ^ [Uu3: B] : ( zero_zero @ A )
            @ A3 )
          = ( zero_zero @ A ) ) ) ).

% sum.neutral_const
thf(fact_2420_round__unique,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A,Y2: int] :
          ( ( ord_less @ A @ ( minus_minus @ A @ X2 @ ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) @ ( ring_1_of_int @ A @ Y2 ) )
         => ( ( ord_less_eq @ A @ ( ring_1_of_int @ A @ Y2 ) @ ( plus_plus @ A @ X2 @ ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) )
           => ( ( archimedean_round @ A @ X2 )
              = Y2 ) ) ) ) ).

% round_unique
thf(fact_2421_take__bit__numeral__minus__bit1,axiom,
    ! [L: num,K: num] :
      ( ( bit_se2584673776208193580ke_bit @ int @ ( numeral_numeral @ nat @ L ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit1 @ K ) ) ) )
      = ( plus_plus @ int @ ( times_times @ int @ ( bit_se2584673776208193580ke_bit @ int @ ( pred_numeral @ L ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( inc @ K ) ) ) ) @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( one_one @ int ) ) ) ).

% take_bit_numeral_minus_bit1
thf(fact_2422_pred__subset__eq2,axiom,
    ! [B: $tType,A: $tType,R: set @ ( product_prod @ A @ B ),S3: set @ ( product_prod @ A @ B )] :
      ( ( ord_less_eq @ ( A > B > $o )
        @ ^ [X5: A,Y5: B] : ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X5 @ Y5 ) @ R )
        @ ^ [X5: A,Y5: B] : ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X5 @ Y5 ) @ S3 ) )
      = ( ord_less_eq @ ( set @ ( product_prod @ A @ B ) ) @ R @ S3 ) ) ).

% pred_subset_eq2
thf(fact_2423_accp__subset,axiom,
    ! [A: $tType,R1: A > A > $o,R22: A > A > $o] :
      ( ( ord_less_eq @ ( A > A > $o ) @ R1 @ R22 )
     => ( ord_less_eq @ ( A > $o ) @ ( accp @ A @ R22 ) @ ( accp @ A @ R1 ) ) ) ).

% accp_subset
thf(fact_2424_take__bit__Suc__minus__bit1,axiom,
    ! [N2: nat,K: num] :
      ( ( bit_se2584673776208193580ke_bit @ int @ ( suc @ N2 ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit1 @ K ) ) ) )
      = ( plus_plus @ int @ ( times_times @ int @ ( bit_se2584673776208193580ke_bit @ int @ N2 @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( inc @ K ) ) ) ) @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( one_one @ int ) ) ) ).

% take_bit_Suc_minus_bit1
thf(fact_2425_round__0,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ( ( archimedean_round @ A @ ( zero_zero @ A ) )
        = ( zero_zero @ int ) ) ) ).

% round_0
thf(fact_2426_round__numeral,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [N2: num] :
          ( ( archimedean_round @ A @ ( numeral_numeral @ A @ N2 ) )
          = ( numeral_numeral @ int @ N2 ) ) ) ).

% round_numeral
thf(fact_2427_round__1,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ( ( archimedean_round @ A @ ( one_one @ A ) )
        = ( one_one @ int ) ) ) ).

% round_1
thf(fact_2428_pred__numeral__inc,axiom,
    ! [K: num] :
      ( ( pred_numeral @ ( inc @ K ) )
      = ( numeral_numeral @ nat @ K ) ) ).

% pred_numeral_inc
thf(fact_2429_sum_Ocl__ivl__Suc,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [N2: nat,M: nat,G: nat > A] :
          ( ( ( ord_less @ nat @ ( suc @ N2 ) @ M )
           => ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ ( suc @ N2 ) ) )
              = ( zero_zero @ A ) ) )
          & ( ~ ( ord_less @ nat @ ( suc @ N2 ) @ M )
           => ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ ( suc @ N2 ) ) )
              = ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ N2 ) ) @ ( G @ ( suc @ N2 ) ) ) ) ) ) ) ).

% sum.cl_ivl_Suc
thf(fact_2430_add__neg__numeral__special_I5_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [N2: num] :
          ( ( plus_plus @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N2 ) ) )
          = ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( inc @ N2 ) ) ) ) ) ).

% add_neg_numeral_special(5)
thf(fact_2431_add__neg__numeral__special_I6_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [M: num] :
          ( ( plus_plus @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( inc @ M ) ) ) ) ) ).

% add_neg_numeral_special(6)
thf(fact_2432_diff__numeral__special_I5_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [N2: num] :
          ( ( minus_minus @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( numeral_numeral @ A @ N2 ) )
          = ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( inc @ N2 ) ) ) ) ) ).

% diff_numeral_special(5)
thf(fact_2433_diff__numeral__special_I6_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [M: num] :
          ( ( minus_minus @ A @ ( numeral_numeral @ A @ M ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( numeral_numeral @ A @ ( inc @ M ) ) ) ) ).

% diff_numeral_special(6)
thf(fact_2434_round__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [N2: num] :
          ( ( archimedean_round @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N2 ) ) )
          = ( uminus_uminus @ int @ ( numeral_numeral @ int @ N2 ) ) ) ) ).

% round_neg_numeral
thf(fact_2435_sum__cong__Suc,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A3: set @ nat,F2: nat > A,G: nat > A] :
          ( ~ ( member @ nat @ ( zero_zero @ nat ) @ A3 )
         => ( ! [X3: nat] :
                ( ( member @ nat @ ( suc @ X3 ) @ A3 )
               => ( ( F2 @ ( suc @ X3 ) )
                  = ( G @ ( suc @ X3 ) ) ) )
           => ( ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ A3 )
              = ( groups7311177749621191930dd_sum @ nat @ A @ G @ A3 ) ) ) ) ) ).

% sum_cong_Suc
thf(fact_2436_num__induct,axiom,
    ! [P: num > $o,X2: num] :
      ( ( P @ one2 )
     => ( ! [X3: num] :
            ( ( P @ X3 )
           => ( P @ ( inc @ X3 ) ) )
       => ( P @ X2 ) ) ) ).

% num_induct
thf(fact_2437_sum__subtractf__nat,axiom,
    ! [A: $tType,A3: set @ A,G: A > nat,F2: A > nat] :
      ( ! [X3: A] :
          ( ( member @ A @ X3 @ A3 )
         => ( ord_less_eq @ nat @ ( G @ X3 ) @ ( F2 @ X3 ) ) )
     => ( ( groups7311177749621191930dd_sum @ A @ nat
          @ ^ [X5: A] : ( minus_minus @ nat @ ( F2 @ X5 ) @ ( G @ X5 ) )
          @ A3 )
        = ( minus_minus @ nat @ ( groups7311177749621191930dd_sum @ A @ nat @ F2 @ A3 ) @ ( groups7311177749621191930dd_sum @ A @ nat @ G @ A3 ) ) ) ) ).

% sum_subtractf_nat
thf(fact_2438_add__inc,axiom,
    ! [X2: num,Y2: num] :
      ( ( plus_plus @ num @ X2 @ ( inc @ Y2 ) )
      = ( inc @ ( plus_plus @ num @ X2 @ Y2 ) ) ) ).

% add_inc
thf(fact_2439_sum__SucD,axiom,
    ! [A: $tType,F2: A > nat,A3: set @ A,N2: nat] :
      ( ( ( groups7311177749621191930dd_sum @ A @ nat @ F2 @ A3 )
        = ( suc @ N2 ) )
     => ? [X3: A] :
          ( ( member @ A @ X3 @ A3 )
          & ( ord_less @ nat @ ( zero_zero @ nat ) @ ( F2 @ X3 ) ) ) ) ).

% sum_SucD
thf(fact_2440_sum_Oshift__bounds__cl__Suc__ivl,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,M: nat,N2: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ M ) @ ( suc @ N2 ) ) )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [I4: nat] : ( G @ ( suc @ I4 ) )
            @ ( set_or1337092689740270186AtMost @ nat @ M @ N2 ) ) ) ) ).

% sum.shift_bounds_cl_Suc_ivl
thf(fact_2441_sum_Oshift__bounds__cl__nat__ivl,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,M: nat,K: nat,N2: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( plus_plus @ nat @ M @ K ) @ ( plus_plus @ nat @ N2 @ K ) ) )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [I4: nat] : ( G @ ( plus_plus @ nat @ I4 @ K ) )
            @ ( set_or1337092689740270186AtMost @ nat @ M @ N2 ) ) ) ) ).

% sum.shift_bounds_cl_nat_ivl
thf(fact_2442_inc_Osimps_I1_J,axiom,
    ( ( inc @ one2 )
    = ( bit0 @ one2 ) ) ).

% inc.simps(1)
thf(fact_2443_inc_Osimps_I2_J,axiom,
    ! [X2: num] :
      ( ( inc @ ( bit0 @ X2 ) )
      = ( bit1 @ X2 ) ) ).

% inc.simps(2)
thf(fact_2444_inc_Osimps_I3_J,axiom,
    ! [X2: num] :
      ( ( inc @ ( bit1 @ X2 ) )
      = ( bit0 @ ( inc @ X2 ) ) ) ).

% inc.simps(3)
thf(fact_2445_add__One,axiom,
    ! [X2: num] :
      ( ( plus_plus @ num @ X2 @ one2 )
      = ( inc @ X2 ) ) ).

% add_One
thf(fact_2446_inc__BitM__eq,axiom,
    ! [N2: num] :
      ( ( inc @ ( bitM @ N2 ) )
      = ( bit0 @ N2 ) ) ).

% inc_BitM_eq
thf(fact_2447_BitM__inc__eq,axiom,
    ! [N2: num] :
      ( ( bitM @ ( inc @ N2 ) )
      = ( bit1 @ N2 ) ) ).

% BitM_inc_eq
thf(fact_2448_round__mono,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A,Y2: A] :
          ( ( ord_less_eq @ A @ X2 @ Y2 )
         => ( ord_less_eq @ int @ ( archimedean_round @ A @ X2 ) @ ( archimedean_round @ A @ Y2 ) ) ) ) ).

% round_mono
thf(fact_2449_mult__inc,axiom,
    ! [X2: num,Y2: num] :
      ( ( times_times @ num @ X2 @ ( inc @ Y2 ) )
      = ( plus_plus @ num @ ( times_times @ num @ X2 @ Y2 ) @ X2 ) ) ).

% mult_inc
thf(fact_2450_sum__power__add,axiom,
    ! [A: $tType] :
      ( ( ( monoid_mult @ A )
        & ( comm_ring @ A ) )
     => ! [X2: A,M: nat,I6: set @ nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [I4: nat] : ( power_power @ A @ X2 @ ( plus_plus @ nat @ M @ I4 ) )
            @ I6 )
          = ( times_times @ A @ ( power_power @ A @ X2 @ M ) @ ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X2 ) @ I6 ) ) ) ) ).

% sum_power_add
thf(fact_2451_sum_OatLeastAtMost__rev,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,N2: nat,M: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ N2 @ M ) )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [I4: nat] : ( G @ ( minus_minus @ nat @ ( plus_plus @ nat @ M @ N2 ) @ I4 ) )
            @ ( set_or1337092689740270186AtMost @ nat @ N2 @ M ) ) ) ) ).

% sum.atLeastAtMost_rev
thf(fact_2452_sum__shift__lb__Suc0__0,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [F2: nat > A,K: nat] :
          ( ( ( F2 @ ( zero_zero @ nat ) )
            = ( zero_zero @ A ) )
         => ( ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ ( zero_zero @ nat ) ) @ K ) )
            = ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ K ) ) ) ) ) ).

% sum_shift_lb_Suc0_0
thf(fact_2453_sum_OatLeast0__atMost__Suc,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,N2: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ ( suc @ N2 ) ) )
          = ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N2 ) ) @ ( G @ ( suc @ N2 ) ) ) ) ) ).

% sum.atLeast0_atMost_Suc
thf(fact_2454_sum_OatLeast__Suc__atMost,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [M: nat,N2: nat,G: nat > A] :
          ( ( ord_less_eq @ nat @ M @ N2 )
         => ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ N2 ) )
            = ( plus_plus @ A @ ( G @ M ) @ ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ M ) @ N2 ) ) ) ) ) ) ).

% sum.atLeast_Suc_atMost
thf(fact_2455_sum_Onat__ivl__Suc_H,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [M: nat,N2: nat,G: nat > A] :
          ( ( ord_less_eq @ nat @ M @ ( suc @ N2 ) )
         => ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ ( suc @ N2 ) ) )
            = ( plus_plus @ A @ ( G @ ( suc @ N2 ) ) @ ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ N2 ) ) ) ) ) ) ).

% sum.nat_ivl_Suc'
thf(fact_2456_numeral__inc,axiom,
    ! [A: $tType] :
      ( ( numeral @ A )
     => ! [X2: num] :
          ( ( numeral_numeral @ A @ ( inc @ X2 ) )
          = ( plus_plus @ A @ ( numeral_numeral @ A @ X2 ) @ ( one_one @ A ) ) ) ) ).

% numeral_inc
thf(fact_2457_sum_OSuc__reindex__ivl,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [M: nat,N2: nat,G: nat > A] :
          ( ( ord_less_eq @ nat @ M @ N2 )
         => ( ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ N2 ) ) @ ( G @ ( suc @ N2 ) ) )
            = ( plus_plus @ A @ ( G @ M )
              @ ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I4: nat] : ( G @ ( suc @ I4 ) )
                @ ( set_or1337092689740270186AtMost @ nat @ M @ N2 ) ) ) ) ) ) ).

% sum.Suc_reindex_ivl
thf(fact_2458_sum__Suc__diff,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [M: nat,N2: nat,F2: nat > A] :
          ( ( ord_less_eq @ nat @ M @ ( suc @ N2 ) )
         => ( ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [I4: nat] : ( minus_minus @ A @ ( F2 @ ( suc @ I4 ) ) @ ( F2 @ I4 ) )
              @ ( set_or1337092689740270186AtMost @ nat @ M @ N2 ) )
            = ( minus_minus @ A @ ( F2 @ ( suc @ N2 ) ) @ ( F2 @ M ) ) ) ) ) ).

% sum_Suc_diff
thf(fact_2459_pred__equals__eq2,axiom,
    ! [B: $tType,A: $tType,R: set @ ( product_prod @ A @ B ),S3: set @ ( product_prod @ A @ B )] :
      ( ( ( ^ [X5: A,Y5: B] : ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X5 @ Y5 ) @ R ) )
        = ( ^ [X5: A,Y5: B] : ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X5 @ Y5 ) @ S3 ) ) )
      = ( R = S3 ) ) ).

% pred_equals_eq2
thf(fact_2460_sum_Oub__add__nat,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [M: nat,N2: nat,G: nat > A,P4: nat] :
          ( ( ord_less_eq @ nat @ M @ ( plus_plus @ nat @ N2 @ ( one_one @ nat ) ) )
         => ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ ( plus_plus @ nat @ N2 @ P4 ) ) )
            = ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ N2 ) ) @ ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( plus_plus @ nat @ N2 @ ( one_one @ nat ) ) @ ( plus_plus @ nat @ N2 @ P4 ) ) ) ) ) ) ) ).

% sum.ub_add_nat
thf(fact_2461_sum__natinterval__diff,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [M: nat,N2: nat,F2: nat > A] :
          ( ( ( ord_less_eq @ nat @ M @ N2 )
           => ( ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [K3: nat] : ( minus_minus @ A @ ( F2 @ K3 ) @ ( F2 @ ( plus_plus @ nat @ K3 @ ( one_one @ nat ) ) ) )
                @ ( set_or1337092689740270186AtMost @ nat @ M @ N2 ) )
              = ( minus_minus @ A @ ( F2 @ M ) @ ( F2 @ ( plus_plus @ nat @ N2 @ ( one_one @ nat ) ) ) ) ) )
          & ( ~ ( ord_less_eq @ nat @ M @ N2 )
           => ( ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [K3: nat] : ( minus_minus @ A @ ( F2 @ K3 ) @ ( F2 @ ( plus_plus @ nat @ K3 @ ( one_one @ nat ) ) ) )
                @ ( set_or1337092689740270186AtMost @ nat @ M @ N2 ) )
              = ( zero_zero @ A ) ) ) ) ) ).

% sum_natinterval_diff
thf(fact_2462_sum__telescope_H_H,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [M: nat,N2: nat,F2: nat > A] :
          ( ( ord_less_eq @ nat @ M @ N2 )
         => ( ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [K3: nat] : ( minus_minus @ A @ ( F2 @ K3 ) @ ( F2 @ ( minus_minus @ nat @ K3 @ ( one_one @ nat ) ) ) )
              @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ M ) @ N2 ) )
            = ( minus_minus @ A @ ( F2 @ N2 ) @ ( F2 @ M ) ) ) ) ) ).

% sum_telescope''
thf(fact_2463_sum_Oneutral,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A3: set @ B,G: B > A] :
          ( ! [X3: B] :
              ( ( member @ B @ X3 @ A3 )
             => ( ( G @ X3 )
                = ( zero_zero @ A ) ) )
         => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ A3 )
            = ( zero_zero @ A ) ) ) ) ).

% sum.neutral
thf(fact_2464_sum_Onot__neutral__contains__not__neutral,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: B > A,A3: set @ B] :
          ( ( ( groups7311177749621191930dd_sum @ B @ A @ G @ A3 )
           != ( zero_zero @ A ) )
         => ~ ! [A5: B] :
                ( ( member @ B @ A5 @ A3 )
               => ( ( G @ A5 )
                  = ( zero_zero @ A ) ) ) ) ) ).

% sum.not_neutral_contains_not_neutral
thf(fact_2465_mask__eq__sum__exp,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [N2: nat] :
          ( ( minus_minus @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N2 ) @ ( one_one @ A ) )
          = ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
            @ ( collect @ nat
              @ ^ [Q4: nat] : ( ord_less @ nat @ Q4 @ N2 ) ) ) ) ) ).

% mask_eq_sum_exp
thf(fact_2466_sum__gp__multiplied,axiom,
    ! [A: $tType] :
      ( ( ( monoid_mult @ A )
        & ( comm_ring @ A ) )
     => ! [M: nat,N2: nat,X2: A] :
          ( ( ord_less_eq @ nat @ M @ N2 )
         => ( ( times_times @ A @ ( minus_minus @ A @ ( one_one @ A ) @ X2 ) @ ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X2 ) @ ( set_or1337092689740270186AtMost @ nat @ M @ N2 ) ) )
            = ( minus_minus @ A @ ( power_power @ A @ X2 @ M ) @ ( power_power @ A @ X2 @ ( suc @ N2 ) ) ) ) ) ) ).

% sum_gp_multiplied
thf(fact_2467_sum_Oin__pairs,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,M: nat,N2: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M ) @ ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) ) )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [I4: nat] : ( plus_plus @ A @ ( G @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ I4 ) ) @ ( G @ ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ I4 ) ) ) )
            @ ( set_or1337092689740270186AtMost @ nat @ M @ N2 ) ) ) ) ).

% sum.in_pairs
thf(fact_2468_subrelI,axiom,
    ! [B: $tType,A: $tType,R3: set @ ( product_prod @ A @ B ),S2: set @ ( product_prod @ A @ B )] :
      ( ! [X3: A,Y4: B] :
          ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X3 @ Y4 ) @ R3 )
         => ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X3 @ Y4 ) @ S2 ) )
     => ( ord_less_eq @ ( set @ ( product_prod @ A @ B ) ) @ R3 @ S2 ) ) ).

% subrelI
thf(fact_2469_accp__subset__induct,axiom,
    ! [A: $tType,D5: A > $o,R: A > A > $o,X2: A,P: A > $o] :
      ( ( ord_less_eq @ ( A > $o ) @ D5 @ ( accp @ A @ R ) )
     => ( ! [X3: A,Z3: A] :
            ( ( D5 @ X3 )
           => ( ( R @ Z3 @ X3 )
             => ( D5 @ Z3 ) ) )
       => ( ( D5 @ X2 )
         => ( ! [X3: A] :
                ( ( D5 @ X3 )
               => ( ! [Z4: A] :
                      ( ( R @ Z4 @ X3 )
                     => ( P @ Z4 ) )
                 => ( P @ X3 ) ) )
           => ( P @ X2 ) ) ) ) ) ).

% accp_subset_induct
thf(fact_2470_mask__eq__sum__exp__nat,axiom,
    ! [N2: nat] :
      ( ( minus_minus @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) @ ( suc @ ( zero_zero @ nat ) ) )
      = ( groups7311177749621191930dd_sum @ nat @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
        @ ( collect @ nat
          @ ^ [Q4: nat] : ( ord_less @ nat @ Q4 @ N2 ) ) ) ) ).

% mask_eq_sum_exp_nat
thf(fact_2471_gauss__sum__nat,axiom,
    ! [N2: nat] :
      ( ( groups7311177749621191930dd_sum @ nat @ nat
        @ ^ [X5: nat] : X5
        @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N2 ) )
      = ( divide_divide @ nat @ ( times_times @ nat @ N2 @ ( suc @ N2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ).

% gauss_sum_nat
thf(fact_2472_sum__mono,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [K5: set @ B,F2: B > A,G: B > A] :
          ( ! [I2: B] :
              ( ( member @ B @ I2 @ K5 )
             => ( ord_less_eq @ A @ ( F2 @ I2 ) @ ( G @ I2 ) ) )
         => ( ord_less_eq @ A @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ K5 ) @ ( groups7311177749621191930dd_sum @ B @ A @ G @ K5 ) ) ) ) ).

% sum_mono
thf(fact_2473_sum__distrib__left,axiom,
    ! [A: $tType,B: $tType] :
      ( ( semiring_0 @ A )
     => ! [R3: A,F2: B > A,A3: set @ B] :
          ( ( times_times @ A @ R3 @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ A3 ) )
          = ( groups7311177749621191930dd_sum @ B @ A
            @ ^ [N3: B] : ( times_times @ A @ R3 @ ( F2 @ N3 ) )
            @ A3 ) ) ) ).

% sum_distrib_left
thf(fact_2474_sum__distrib__right,axiom,
    ! [A: $tType,B: $tType] :
      ( ( semiring_0 @ A )
     => ! [F2: B > A,A3: set @ B,R3: A] :
          ( ( times_times @ A @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ A3 ) @ R3 )
          = ( groups7311177749621191930dd_sum @ B @ A
            @ ^ [N3: B] : ( times_times @ A @ ( F2 @ N3 ) @ R3 )
            @ A3 ) ) ) ).

% sum_distrib_right
thf(fact_2475_sum__product,axiom,
    ! [B: $tType,C: $tType,A: $tType] :
      ( ( semiring_0 @ B )
     => ! [F2: A > B,A3: set @ A,G: C > B,B3: set @ C] :
          ( ( times_times @ B @ ( groups7311177749621191930dd_sum @ A @ B @ F2 @ A3 ) @ ( groups7311177749621191930dd_sum @ C @ B @ G @ B3 ) )
          = ( groups7311177749621191930dd_sum @ A @ B
            @ ^ [I4: A] :
                ( groups7311177749621191930dd_sum @ C @ B
                @ ^ [J3: C] : ( times_times @ B @ ( F2 @ I4 ) @ ( G @ J3 ) )
                @ B3 )
            @ A3 ) ) ) ).

% sum_product
thf(fact_2476_sum_Odistrib,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: B > A,H2: B > A,A3: set @ B] :
          ( ( groups7311177749621191930dd_sum @ B @ A
            @ ^ [X5: B] : ( plus_plus @ A @ ( G @ X5 ) @ ( H2 @ X5 ) )
            @ A3 )
          = ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ B @ A @ G @ A3 ) @ ( groups7311177749621191930dd_sum @ B @ A @ H2 @ A3 ) ) ) ) ).

% sum.distrib
thf(fact_2477_sum__divide__distrib,axiom,
    ! [A: $tType,B: $tType] :
      ( ( field @ A )
     => ! [F2: B > A,A3: set @ B,R3: A] :
          ( ( divide_divide @ A @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ A3 ) @ R3 )
          = ( groups7311177749621191930dd_sum @ B @ A
            @ ^ [N3: B] : ( divide_divide @ A @ ( F2 @ N3 ) @ R3 )
            @ A3 ) ) ) ).

% sum_divide_distrib
thf(fact_2478_arith__series__nat,axiom,
    ! [A2: nat,D2: nat,N2: nat] :
      ( ( groups7311177749621191930dd_sum @ nat @ nat
        @ ^ [I4: nat] : ( plus_plus @ nat @ A2 @ ( times_times @ nat @ I4 @ D2 ) )
        @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N2 ) )
      = ( divide_divide @ nat @ ( times_times @ nat @ ( suc @ N2 ) @ ( plus_plus @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ A2 ) @ ( times_times @ nat @ N2 @ D2 ) ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ).

% arith_series_nat
thf(fact_2479_Sum__Icc__nat,axiom,
    ! [M: nat,N2: nat] :
      ( ( groups7311177749621191930dd_sum @ nat @ nat
        @ ^ [X5: nat] : X5
        @ ( set_or1337092689740270186AtMost @ nat @ M @ N2 ) )
      = ( divide_divide @ nat @ ( minus_minus @ nat @ ( times_times @ nat @ N2 @ ( plus_plus @ nat @ N2 @ ( one_one @ nat ) ) ) @ ( times_times @ nat @ M @ ( minus_minus @ nat @ M @ ( one_one @ nat ) ) ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ).

% Sum_Icc_nat
thf(fact_2480_pred__subset__eq,axiom,
    ! [A: $tType,R: set @ A,S3: set @ A] :
      ( ( ord_less_eq @ ( A > $o )
        @ ^ [X5: A] : ( member @ A @ X5 @ R )
        @ ^ [X5: A] : ( member @ A @ X5 @ S3 ) )
      = ( ord_less_eq @ ( set @ A ) @ R @ S3 ) ) ).

% pred_subset_eq
thf(fact_2481_sum__nonpos,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [A3: set @ B,F2: B > A] :
          ( ! [X3: B] :
              ( ( member @ B @ X3 @ A3 )
             => ( ord_less_eq @ A @ ( F2 @ X3 ) @ ( zero_zero @ A ) ) )
         => ( ord_less_eq @ A @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ A3 ) @ ( zero_zero @ A ) ) ) ) ).

% sum_nonpos
thf(fact_2482_sum__nonneg,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [A3: set @ B,F2: B > A] :
          ( ! [X3: B] :
              ( ( member @ B @ X3 @ A3 )
             => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( F2 @ X3 ) ) )
         => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ A3 ) ) ) ) ).

% sum_nonneg
thf(fact_2483_of__int__round__le,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A] : ( ord_less_eq @ A @ ( ring_1_of_int @ A @ ( archimedean_round @ A @ X2 ) ) @ ( plus_plus @ A @ X2 @ ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ).

% of_int_round_le
thf(fact_2484_of__int__round__ge,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A] : ( ord_less_eq @ A @ ( minus_minus @ A @ X2 @ ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) @ ( ring_1_of_int @ A @ ( archimedean_round @ A @ X2 ) ) ) ) ).

% of_int_round_ge
thf(fact_2485_of__int__round__gt,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A] : ( ord_less @ A @ ( minus_minus @ A @ X2 @ ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) @ ( ring_1_of_int @ A @ ( archimedean_round @ A @ X2 ) ) ) ) ).

% of_int_round_gt
thf(fact_2486_fold__atLeastAtMost__nat_Opinduct,axiom,
    ! [A: $tType,A0: nat > A > A,A1: nat,A22: nat,A32: A,P: ( nat > A > A ) > nat > nat > A > $o] :
      ( ( accp @ ( product_prod @ ( nat > A > A ) @ ( product_prod @ nat @ ( product_prod @ nat @ A ) ) ) @ ( set_fo1817059534552279752at_rel @ A ) @ ( product_Pair @ ( nat > A > A ) @ ( product_prod @ nat @ ( product_prod @ nat @ A ) ) @ A0 @ ( product_Pair @ nat @ ( product_prod @ nat @ A ) @ A1 @ ( product_Pair @ nat @ A @ A22 @ A32 ) ) ) )
     => ( ! [F4: nat > A > A,A5: nat,B5: nat,Acc: A] :
            ( ( accp @ ( product_prod @ ( nat > A > A ) @ ( product_prod @ nat @ ( product_prod @ nat @ A ) ) ) @ ( set_fo1817059534552279752at_rel @ A ) @ ( product_Pair @ ( nat > A > A ) @ ( product_prod @ nat @ ( product_prod @ nat @ A ) ) @ F4 @ ( product_Pair @ nat @ ( product_prod @ nat @ A ) @ A5 @ ( product_Pair @ nat @ A @ B5 @ Acc ) ) ) )
           => ( ( ~ ( ord_less @ nat @ B5 @ A5 )
               => ( P @ F4 @ ( plus_plus @ nat @ A5 @ ( one_one @ nat ) ) @ B5 @ ( F4 @ A5 @ Acc ) ) )
             => ( P @ F4 @ A5 @ B5 @ Acc ) ) )
       => ( P @ A0 @ A1 @ A22 @ A32 ) ) ) ).

% fold_atLeastAtMost_nat.pinduct
thf(fact_2487_in__measure,axiom,
    ! [A: $tType,X2: A,Y2: A,F2: A > nat] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ Y2 ) @ ( measure @ A @ F2 ) )
      = ( ord_less @ nat @ ( F2 @ X2 ) @ ( F2 @ Y2 ) ) ) ).

% in_measure
thf(fact_2488_sum__gp,axiom,
    ! [A: $tType] :
      ( ( ( division_ring @ A )
        & ( comm_ring @ A ) )
     => ! [N2: nat,M: nat,X2: A] :
          ( ( ( ord_less @ nat @ N2 @ M )
           => ( ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X2 ) @ ( set_or1337092689740270186AtMost @ nat @ M @ N2 ) )
              = ( zero_zero @ A ) ) )
          & ( ~ ( ord_less @ nat @ N2 @ M )
           => ( ( ( X2
                  = ( one_one @ A ) )
               => ( ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X2 ) @ ( set_or1337092689740270186AtMost @ nat @ M @ N2 ) )
                  = ( semiring_1_of_nat @ A @ ( minus_minus @ nat @ ( plus_plus @ nat @ N2 @ ( one_one @ nat ) ) @ M ) ) ) )
              & ( ( X2
                 != ( one_one @ A ) )
               => ( ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X2 ) @ ( set_or1337092689740270186AtMost @ nat @ M @ N2 ) )
                  = ( divide_divide @ A @ ( minus_minus @ A @ ( power_power @ A @ X2 @ M ) @ ( power_power @ A @ X2 @ ( suc @ N2 ) ) ) @ ( minus_minus @ A @ ( one_one @ A ) @ X2 ) ) ) ) ) ) ) ) ).

% sum_gp
thf(fact_2489_upto_Opinduct,axiom,
    ! [A0: int,A1: int,P: int > int > $o] :
      ( ( accp @ ( product_prod @ int @ int ) @ upto_rel @ ( product_Pair @ int @ int @ A0 @ A1 ) )
     => ( ! [I2: int,J2: int] :
            ( ( accp @ ( product_prod @ int @ int ) @ upto_rel @ ( product_Pair @ int @ int @ I2 @ J2 ) )
           => ( ( ( ord_less_eq @ int @ I2 @ J2 )
               => ( P @ ( plus_plus @ int @ I2 @ ( one_one @ int ) ) @ J2 ) )
             => ( P @ I2 @ J2 ) ) )
       => ( P @ A0 @ A1 ) ) ) ).

% upto.pinduct
thf(fact_2490_signed__take__bit__eq__take__bit__minus,axiom,
    ( ( bit_ri4674362597316999326ke_bit @ int )
    = ( ^ [N3: nat,K3: int] : ( minus_minus @ int @ ( bit_se2584673776208193580ke_bit @ int @ ( suc @ N3 ) @ K3 ) @ ( times_times @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( suc @ N3 ) ) @ ( zero_neq_one_of_bool @ int @ ( bit_se5641148757651400278ts_bit @ int @ K3 @ N3 ) ) ) ) ) ) ).

% signed_take_bit_eq_take_bit_minus
thf(fact_2491_gauss__sum__from__Suc__0,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [N2: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ ( semiring_1_of_nat @ A ) @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ ( zero_zero @ nat ) ) @ N2 ) )
          = ( divide_divide @ A @ ( times_times @ A @ ( semiring_1_of_nat @ A @ N2 ) @ ( plus_plus @ A @ ( semiring_1_of_nat @ A @ N2 ) @ ( one_one @ A ) ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% gauss_sum_from_Suc_0
thf(fact_2492_of__nat__eq__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [M: nat,N2: nat] :
          ( ( ( semiring_1_of_nat @ A @ M )
            = ( semiring_1_of_nat @ A @ N2 ) )
          = ( M = N2 ) ) ) ).

% of_nat_eq_iff
thf(fact_2493_int__eq__iff__numeral,axiom,
    ! [M: nat,V: num] :
      ( ( ( semiring_1_of_nat @ int @ M )
        = ( numeral_numeral @ int @ V ) )
      = ( M
        = ( numeral_numeral @ nat @ V ) ) ) ).

% int_eq_iff_numeral
thf(fact_2494_negative__eq__positive,axiom,
    ! [N2: nat,M: nat] :
      ( ( ( uminus_uminus @ int @ ( semiring_1_of_nat @ int @ N2 ) )
        = ( semiring_1_of_nat @ int @ M ) )
      = ( ( N2
          = ( zero_zero @ nat ) )
        & ( M
          = ( zero_zero @ nat ) ) ) ) ).

% negative_eq_positive
thf(fact_2495_negative__zle,axiom,
    ! [N2: nat,M: nat] : ( ord_less_eq @ int @ ( uminus_uminus @ int @ ( semiring_1_of_nat @ int @ N2 ) ) @ ( semiring_1_of_nat @ int @ M ) ) ).

% negative_zle
thf(fact_2496_of__nat__0,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ( ( semiring_1_of_nat @ A @ ( zero_zero @ nat ) )
        = ( zero_zero @ A ) ) ) ).

% of_nat_0
thf(fact_2497_of__nat__0__eq__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [N2: nat] :
          ( ( ( zero_zero @ A )
            = ( semiring_1_of_nat @ A @ N2 ) )
          = ( ( zero_zero @ nat )
            = N2 ) ) ) ).

% of_nat_0_eq_iff
thf(fact_2498_of__nat__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [M: nat] :
          ( ( ( semiring_1_of_nat @ A @ M )
            = ( zero_zero @ A ) )
          = ( M
            = ( zero_zero @ nat ) ) ) ) ).

% of_nat_eq_0_iff
thf(fact_2499_of__nat__less__iff,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [M: nat,N2: nat] :
          ( ( ord_less @ A @ ( semiring_1_of_nat @ A @ M ) @ ( semiring_1_of_nat @ A @ N2 ) )
          = ( ord_less @ nat @ M @ N2 ) ) ) ).

% of_nat_less_iff
thf(fact_2500_of__nat__le__iff,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [M: nat,N2: nat] :
          ( ( ord_less_eq @ A @ ( semiring_1_of_nat @ A @ M ) @ ( semiring_1_of_nat @ A @ N2 ) )
          = ( ord_less_eq @ nat @ M @ N2 ) ) ) ).

% of_nat_le_iff
thf(fact_2501_of__nat__numeral,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [N2: num] :
          ( ( semiring_1_of_nat @ A @ ( numeral_numeral @ nat @ N2 ) )
          = ( numeral_numeral @ A @ N2 ) ) ) ).

% of_nat_numeral
thf(fact_2502_of__nat__add,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [M: nat,N2: nat] :
          ( ( semiring_1_of_nat @ A @ ( plus_plus @ nat @ M @ N2 ) )
          = ( plus_plus @ A @ ( semiring_1_of_nat @ A @ M ) @ ( semiring_1_of_nat @ A @ N2 ) ) ) ) ).

% of_nat_add
thf(fact_2503_of__nat__mult,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [M: nat,N2: nat] :
          ( ( semiring_1_of_nat @ A @ ( times_times @ nat @ M @ N2 ) )
          = ( times_times @ A @ ( semiring_1_of_nat @ A @ M ) @ ( semiring_1_of_nat @ A @ N2 ) ) ) ) ).

% of_nat_mult
thf(fact_2504_of__nat__1,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ( ( semiring_1_of_nat @ A @ ( one_one @ nat ) )
        = ( one_one @ A ) ) ) ).

% of_nat_1
thf(fact_2505_of__nat__1__eq__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [N2: nat] :
          ( ( ( one_one @ A )
            = ( semiring_1_of_nat @ A @ N2 ) )
          = ( N2
            = ( one_one @ nat ) ) ) ) ).

% of_nat_1_eq_iff
thf(fact_2506_of__nat__eq__1__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [N2: nat] :
          ( ( ( semiring_1_of_nat @ A @ N2 )
            = ( one_one @ A ) )
          = ( N2
            = ( one_one @ nat ) ) ) ) ).

% of_nat_eq_1_iff
thf(fact_2507_of__nat__power,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [M: nat,N2: nat] :
          ( ( semiring_1_of_nat @ A @ ( power_power @ nat @ M @ N2 ) )
          = ( power_power @ A @ ( semiring_1_of_nat @ A @ M ) @ N2 ) ) ) ).

% of_nat_power
thf(fact_2508_of__nat__eq__of__nat__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [B2: nat,W: nat,X2: nat] :
          ( ( ( power_power @ A @ ( semiring_1_of_nat @ A @ B2 ) @ W )
            = ( semiring_1_of_nat @ A @ X2 ) )
          = ( ( power_power @ nat @ B2 @ W )
            = X2 ) ) ) ).

% of_nat_eq_of_nat_power_cancel_iff
thf(fact_2509_of__nat__power__eq__of__nat__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [X2: nat,B2: nat,W: nat] :
          ( ( ( semiring_1_of_nat @ A @ X2 )
            = ( power_power @ A @ ( semiring_1_of_nat @ A @ B2 ) @ W ) )
          = ( X2
            = ( power_power @ nat @ B2 @ W ) ) ) ) ).

% of_nat_power_eq_of_nat_cancel_iff
thf(fact_2510_negative__zless,axiom,
    ! [N2: nat,M: nat] : ( ord_less @ int @ ( uminus_uminus @ int @ ( semiring_1_of_nat @ int @ ( suc @ N2 ) ) ) @ ( semiring_1_of_nat @ int @ M ) ) ).

% negative_zless
thf(fact_2511_of__nat__of__bool,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [P: $o] :
          ( ( semiring_1_of_nat @ A @ ( zero_neq_one_of_bool @ nat @ P ) )
          = ( zero_neq_one_of_bool @ A @ P ) ) ) ).

% of_nat_of_bool
thf(fact_2512_of__nat__le__0__iff,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [M: nat] :
          ( ( ord_less_eq @ A @ ( semiring_1_of_nat @ A @ M ) @ ( zero_zero @ A ) )
          = ( M
            = ( zero_zero @ nat ) ) ) ) ).

% of_nat_le_0_iff
thf(fact_2513_of__nat__Suc,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [M: nat] :
          ( ( semiring_1_of_nat @ A @ ( suc @ M ) )
          = ( plus_plus @ A @ ( one_one @ A ) @ ( semiring_1_of_nat @ A @ M ) ) ) ) ).

% of_nat_Suc
thf(fact_2514_bit__numeral__Bit0__Suc__iff,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [M: num,N2: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( numeral_numeral @ A @ ( bit0 @ M ) ) @ ( suc @ N2 ) )
          = ( bit_se5641148757651400278ts_bit @ A @ ( numeral_numeral @ A @ M ) @ N2 ) ) ) ).

% bit_numeral_Bit0_Suc_iff
thf(fact_2515_numeral__less__real__of__nat__iff,axiom,
    ! [W: num,N2: nat] :
      ( ( ord_less @ real @ ( numeral_numeral @ real @ W ) @ ( semiring_1_of_nat @ real @ N2 ) )
      = ( ord_less @ nat @ ( numeral_numeral @ nat @ W ) @ N2 ) ) ).

% numeral_less_real_of_nat_iff
thf(fact_2516_real__of__nat__less__numeral__iff,axiom,
    ! [N2: nat,W: num] :
      ( ( ord_less @ real @ ( semiring_1_of_nat @ real @ N2 ) @ ( numeral_numeral @ real @ W ) )
      = ( ord_less @ nat @ N2 @ ( numeral_numeral @ nat @ W ) ) ) ).

% real_of_nat_less_numeral_iff
thf(fact_2517_bit__numeral__Bit1__Suc__iff,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [M: num,N2: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( numeral_numeral @ A @ ( bit1 @ M ) ) @ ( suc @ N2 ) )
          = ( bit_se5641148757651400278ts_bit @ A @ ( numeral_numeral @ A @ M ) @ N2 ) ) ) ).

% bit_numeral_Bit1_Suc_iff
thf(fact_2518_numeral__le__real__of__nat__iff,axiom,
    ! [N2: num,M: nat] :
      ( ( ord_less_eq @ real @ ( numeral_numeral @ real @ N2 ) @ ( semiring_1_of_nat @ real @ M ) )
      = ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ N2 ) @ M ) ) ).

% numeral_le_real_of_nat_iff
thf(fact_2519_signed__take__bit__nonnegative__iff,axiom,
    ! [N2: nat,K: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( bit_ri4674362597316999326ke_bit @ int @ N2 @ K ) )
      = ( ~ ( bit_se5641148757651400278ts_bit @ int @ K @ N2 ) ) ) ).

% signed_take_bit_nonnegative_iff
thf(fact_2520_signed__take__bit__negative__iff,axiom,
    ! [N2: nat,K: int] :
      ( ( ord_less @ int @ ( bit_ri4674362597316999326ke_bit @ int @ N2 @ K ) @ ( zero_zero @ int ) )
      = ( bit_se5641148757651400278ts_bit @ int @ K @ N2 ) ) ).

% signed_take_bit_negative_iff
thf(fact_2521_of__nat__0__less__iff,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [N2: nat] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( semiring_1_of_nat @ A @ N2 ) )
          = ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 ) ) ) ).

% of_nat_0_less_iff
thf(fact_2522_of__nat__less__of__nat__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [B2: nat,W: nat,X2: nat] :
          ( ( ord_less @ A @ ( power_power @ A @ ( semiring_1_of_nat @ A @ B2 ) @ W ) @ ( semiring_1_of_nat @ A @ X2 ) )
          = ( ord_less @ nat @ ( power_power @ nat @ B2 @ W ) @ X2 ) ) ) ).

% of_nat_less_of_nat_power_cancel_iff
thf(fact_2523_of__nat__power__less__of__nat__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [X2: nat,B2: nat,W: nat] :
          ( ( ord_less @ A @ ( semiring_1_of_nat @ A @ X2 ) @ ( power_power @ A @ ( semiring_1_of_nat @ A @ B2 ) @ W ) )
          = ( ord_less @ nat @ X2 @ ( power_power @ nat @ B2 @ W ) ) ) ) ).

% of_nat_power_less_of_nat_cancel_iff
thf(fact_2524_of__nat__le__of__nat__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [B2: nat,W: nat,X2: nat] :
          ( ( ord_less_eq @ A @ ( power_power @ A @ ( semiring_1_of_nat @ A @ B2 ) @ W ) @ ( semiring_1_of_nat @ A @ X2 ) )
          = ( ord_less_eq @ nat @ ( power_power @ nat @ B2 @ W ) @ X2 ) ) ) ).

% of_nat_le_of_nat_power_cancel_iff
thf(fact_2525_of__nat__power__le__of__nat__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [X2: nat,B2: nat,W: nat] :
          ( ( ord_less_eq @ A @ ( semiring_1_of_nat @ A @ X2 ) @ ( power_power @ A @ ( semiring_1_of_nat @ A @ B2 ) @ W ) )
          = ( ord_less_eq @ nat @ X2 @ ( power_power @ nat @ B2 @ W ) ) ) ) ).

% of_nat_power_le_of_nat_cancel_iff
thf(fact_2526_numeral__power__eq__of__nat__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [X2: num,N2: nat,Y2: nat] :
          ( ( ( power_power @ A @ ( numeral_numeral @ A @ X2 ) @ N2 )
            = ( semiring_1_of_nat @ A @ Y2 ) )
          = ( ( power_power @ nat @ ( numeral_numeral @ nat @ X2 ) @ N2 )
            = Y2 ) ) ) ).

% numeral_power_eq_of_nat_cancel_iff
thf(fact_2527_real__of__nat__eq__numeral__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [Y2: nat,X2: num,N2: nat] :
          ( ( ( semiring_1_of_nat @ A @ Y2 )
            = ( power_power @ A @ ( numeral_numeral @ A @ X2 ) @ N2 ) )
          = ( Y2
            = ( power_power @ nat @ ( numeral_numeral @ nat @ X2 ) @ N2 ) ) ) ) ).

% real_of_nat_eq_numeral_power_cancel_iff
thf(fact_2528_bit__numeral__simps_I2_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [W: num,N2: num] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( numeral_numeral @ A @ ( bit0 @ W ) ) @ ( numeral_numeral @ nat @ N2 ) )
          = ( bit_se5641148757651400278ts_bit @ A @ ( numeral_numeral @ A @ W ) @ ( pred_numeral @ N2 ) ) ) ) ).

% bit_numeral_simps(2)
thf(fact_2529_bit__minus__numeral__Bit0__Suc__iff,axiom,
    ! [W: num,N2: nat] :
      ( ( bit_se5641148757651400278ts_bit @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit0 @ W ) ) ) @ ( suc @ N2 ) )
      = ( bit_se5641148757651400278ts_bit @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ W ) ) @ N2 ) ) ).

% bit_minus_numeral_Bit0_Suc_iff
thf(fact_2530_bit__numeral__simps_I3_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [W: num,N2: num] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( numeral_numeral @ A @ ( bit1 @ W ) ) @ ( numeral_numeral @ nat @ N2 ) )
          = ( bit_se5641148757651400278ts_bit @ A @ ( numeral_numeral @ A @ W ) @ ( pred_numeral @ N2 ) ) ) ) ).

% bit_numeral_simps(3)
thf(fact_2531_bit__minus__numeral__Bit1__Suc__iff,axiom,
    ! [W: num,N2: nat] :
      ( ( bit_se5641148757651400278ts_bit @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit1 @ W ) ) ) @ ( suc @ N2 ) )
      = ( ~ ( bit_se5641148757651400278ts_bit @ int @ ( numeral_numeral @ int @ W ) @ N2 ) ) ) ).

% bit_minus_numeral_Bit1_Suc_iff
thf(fact_2532_of__nat__zero__less__power__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [X2: nat,N2: nat] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( power_power @ A @ ( semiring_1_of_nat @ A @ X2 ) @ N2 ) )
          = ( ( ord_less @ nat @ ( zero_zero @ nat ) @ X2 )
            | ( N2
              = ( zero_zero @ nat ) ) ) ) ) ).

% of_nat_zero_less_power_iff
thf(fact_2533_bit__0,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A] :
          ( ( bit_se5641148757651400278ts_bit @ A @ A2 @ ( zero_zero @ nat ) )
          = ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) ) ) ) ).

% bit_0
thf(fact_2534_bit__minus__numeral__int_I1_J,axiom,
    ! [W: num,N2: num] :
      ( ( bit_se5641148757651400278ts_bit @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit0 @ W ) ) ) @ ( numeral_numeral @ nat @ N2 ) )
      = ( bit_se5641148757651400278ts_bit @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ W ) ) @ ( pred_numeral @ N2 ) ) ) ).

% bit_minus_numeral_int(1)
thf(fact_2535_bit__minus__numeral__int_I2_J,axiom,
    ! [W: num,N2: num] :
      ( ( bit_se5641148757651400278ts_bit @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit1 @ W ) ) ) @ ( numeral_numeral @ nat @ N2 ) )
      = ( ~ ( bit_se5641148757651400278ts_bit @ int @ ( numeral_numeral @ int @ W ) @ ( pred_numeral @ N2 ) ) ) ) ).

% bit_minus_numeral_int(2)
thf(fact_2536_even__of__nat,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [N2: nat] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( semiring_1_of_nat @ A @ N2 ) )
          = ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) ) ).

% even_of_nat
thf(fact_2537_numeral__power__less__of__nat__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [I3: num,N2: nat,X2: nat] :
          ( ( ord_less @ A @ ( power_power @ A @ ( numeral_numeral @ A @ I3 ) @ N2 ) @ ( semiring_1_of_nat @ A @ X2 ) )
          = ( ord_less @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ I3 ) @ N2 ) @ X2 ) ) ) ).

% numeral_power_less_of_nat_cancel_iff
thf(fact_2538_of__nat__less__numeral__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [X2: nat,I3: num,N2: nat] :
          ( ( ord_less @ A @ ( semiring_1_of_nat @ A @ X2 ) @ ( power_power @ A @ ( numeral_numeral @ A @ I3 ) @ N2 ) )
          = ( ord_less @ nat @ X2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ I3 ) @ N2 ) ) ) ) ).

% of_nat_less_numeral_power_cancel_iff
thf(fact_2539_numeral__power__le__of__nat__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [I3: num,N2: nat,X2: nat] :
          ( ( ord_less_eq @ A @ ( power_power @ A @ ( numeral_numeral @ A @ I3 ) @ N2 ) @ ( semiring_1_of_nat @ A @ X2 ) )
          = ( ord_less_eq @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ I3 ) @ N2 ) @ X2 ) ) ) ).

% numeral_power_le_of_nat_cancel_iff
thf(fact_2540_of__nat__le__numeral__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [X2: nat,I3: num,N2: nat] :
          ( ( ord_less_eq @ A @ ( semiring_1_of_nat @ A @ X2 ) @ ( power_power @ A @ ( numeral_numeral @ A @ I3 ) @ N2 ) )
          = ( ord_less_eq @ nat @ X2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ I3 ) @ N2 ) ) ) ) ).

% of_nat_le_numeral_power_cancel_iff
thf(fact_2541_bit__mod__2__iff,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A,N2: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ N2 )
          = ( ( N2
              = ( zero_zero @ nat ) )
            & ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) ) ) ) ).

% bit_mod_2_iff
thf(fact_2542_bit__of__nat__iff__bit,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [M: nat,N2: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( semiring_1_of_nat @ A @ M ) @ N2 )
          = ( bit_se5641148757651400278ts_bit @ nat @ M @ N2 ) ) ) ).

% bit_of_nat_iff_bit
thf(fact_2543_bit__numeral__iff,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [M: num,N2: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( numeral_numeral @ A @ M ) @ N2 )
          = ( bit_se5641148757651400278ts_bit @ nat @ ( numeral_numeral @ nat @ M ) @ N2 ) ) ) ).

% bit_numeral_iff
thf(fact_2544_bit__disjunctive__add__iff,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A,B2: A,N2: nat] :
          ( ! [N: nat] :
              ( ~ ( bit_se5641148757651400278ts_bit @ A @ A2 @ N )
              | ~ ( bit_se5641148757651400278ts_bit @ A @ B2 @ N ) )
         => ( ( bit_se5641148757651400278ts_bit @ A @ ( plus_plus @ A @ A2 @ B2 ) @ N2 )
            = ( ( bit_se5641148757651400278ts_bit @ A @ A2 @ N2 )
              | ( bit_se5641148757651400278ts_bit @ A @ B2 @ N2 ) ) ) ) ) ).

% bit_disjunctive_add_iff
thf(fact_2545_real__arch__simple,axiom,
    ! [A: $tType] :
      ( ( archim462609752435547400_field @ A )
     => ! [X2: A] :
        ? [N: nat] : ( ord_less_eq @ A @ X2 @ ( semiring_1_of_nat @ A @ N ) ) ) ).

% real_arch_simple
thf(fact_2546_reals__Archimedean2,axiom,
    ! [A: $tType] :
      ( ( archim462609752435547400_field @ A )
     => ! [X2: A] :
        ? [N: nat] : ( ord_less @ A @ X2 @ ( semiring_1_of_nat @ A @ N ) ) ) ).

% reals_Archimedean2
thf(fact_2547_mult__of__nat__commute,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [X2: nat,Y2: A] :
          ( ( times_times @ A @ ( semiring_1_of_nat @ A @ X2 ) @ Y2 )
          = ( times_times @ A @ Y2 @ ( semiring_1_of_nat @ A @ X2 ) ) ) ) ).

% mult_of_nat_commute
thf(fact_2548_bit__unset__bit__iff,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M: nat,A2: A,N2: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( bit_se2638667681897837118et_bit @ A @ M @ A2 ) @ N2 )
          = ( ( bit_se5641148757651400278ts_bit @ A @ A2 @ N2 )
            & ( M != N2 ) ) ) ) ).

% bit_unset_bit_iff
thf(fact_2549_of__nat__less__of__int__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N2: nat,X2: int] :
          ( ( ord_less @ A @ ( semiring_1_of_nat @ A @ N2 ) @ ( ring_1_of_int @ A @ X2 ) )
          = ( ord_less @ int @ ( semiring_1_of_nat @ int @ N2 ) @ X2 ) ) ) ).

% of_nat_less_of_int_iff
thf(fact_2550_not__bit__1__Suc,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N2: nat] :
          ~ ( bit_se5641148757651400278ts_bit @ A @ ( one_one @ A ) @ ( suc @ N2 ) ) ) ).

% not_bit_1_Suc
thf(fact_2551_bit__1__iff,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [N2: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( one_one @ A ) @ N2 )
          = ( N2
            = ( zero_zero @ nat ) ) ) ) ).

% bit_1_iff
thf(fact_2552_bit__numeral__simps_I1_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [N2: num] :
          ~ ( bit_se5641148757651400278ts_bit @ A @ ( one_one @ A ) @ ( numeral_numeral @ nat @ N2 ) ) ) ).

% bit_numeral_simps(1)
thf(fact_2553_of__nat__0__le__iff,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [N2: nat] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( semiring_1_of_nat @ A @ N2 ) ) ) ).

% of_nat_0_le_iff
thf(fact_2554_of__nat__less__0__iff,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [M: nat] :
          ~ ( ord_less @ A @ ( semiring_1_of_nat @ A @ M ) @ ( zero_zero @ A ) ) ) ).

% of_nat_less_0_iff
thf(fact_2555_bit__take__bit__iff,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M: nat,A2: A,N2: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( bit_se2584673776208193580ke_bit @ A @ M @ A2 ) @ N2 )
          = ( ( ord_less @ nat @ N2 @ M )
            & ( bit_se5641148757651400278ts_bit @ A @ A2 @ N2 ) ) ) ) ).

% bit_take_bit_iff
thf(fact_2556_of__nat__neq__0,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [N2: nat] :
          ( ( semiring_1_of_nat @ A @ ( suc @ N2 ) )
         != ( zero_zero @ A ) ) ) ).

% of_nat_neq_0
thf(fact_2557_bit__of__bool__iff,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [B2: $o,N2: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( zero_neq_one_of_bool @ A @ B2 ) @ N2 )
          = ( B2
            & ( N2
              = ( zero_zero @ nat ) ) ) ) ) ).

% bit_of_bool_iff
thf(fact_2558_div__mult2__eq_H,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [A2: A,M: nat,N2: nat] :
          ( ( divide_divide @ A @ A2 @ ( times_times @ A @ ( semiring_1_of_nat @ A @ M ) @ ( semiring_1_of_nat @ A @ N2 ) ) )
          = ( divide_divide @ A @ ( divide_divide @ A @ A2 @ ( semiring_1_of_nat @ A @ M ) ) @ ( semiring_1_of_nat @ A @ N2 ) ) ) ) ).

% div_mult2_eq'
thf(fact_2559_less__imp__of__nat__less,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [M: nat,N2: nat] :
          ( ( ord_less @ nat @ M @ N2 )
         => ( ord_less @ A @ ( semiring_1_of_nat @ A @ M ) @ ( semiring_1_of_nat @ A @ N2 ) ) ) ) ).

% less_imp_of_nat_less
thf(fact_2560_of__nat__less__imp__less,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [M: nat,N2: nat] :
          ( ( ord_less @ A @ ( semiring_1_of_nat @ A @ M ) @ ( semiring_1_of_nat @ A @ N2 ) )
         => ( ord_less @ nat @ M @ N2 ) ) ) ).

% of_nat_less_imp_less
thf(fact_2561_of__nat__mono,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [I3: nat,J: nat] :
          ( ( ord_less_eq @ nat @ I3 @ J )
         => ( ord_less_eq @ A @ ( semiring_1_of_nat @ A @ I3 ) @ ( semiring_1_of_nat @ A @ J ) ) ) ) ).

% of_nat_mono
thf(fact_2562_unique__euclidean__semiring__with__nat__class_Oof__nat__div,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [M: nat,N2: nat] :
          ( ( semiring_1_of_nat @ A @ ( divide_divide @ nat @ M @ N2 ) )
          = ( divide_divide @ A @ ( semiring_1_of_nat @ A @ M ) @ ( semiring_1_of_nat @ A @ N2 ) ) ) ) ).

% unique_euclidean_semiring_with_nat_class.of_nat_div
thf(fact_2563_of__nat__dvd__iff,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [M: nat,N2: nat] :
          ( ( dvd_dvd @ A @ ( semiring_1_of_nat @ A @ M ) @ ( semiring_1_of_nat @ A @ N2 ) )
          = ( dvd_dvd @ nat @ M @ N2 ) ) ) ).

% of_nat_dvd_iff
thf(fact_2564_int__ops_I1_J,axiom,
    ( ( semiring_1_of_nat @ int @ ( zero_zero @ nat ) )
    = ( zero_zero @ int ) ) ).

% int_ops(1)
thf(fact_2565_signed__take__bit__eq__if__positive,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [A2: A,N2: nat] :
          ( ~ ( bit_se5641148757651400278ts_bit @ A @ A2 @ N2 )
         => ( ( bit_ri4674362597316999326ke_bit @ A @ N2 @ A2 )
            = ( bit_se2584673776208193580ke_bit @ A @ N2 @ A2 ) ) ) ) ).

% signed_take_bit_eq_if_positive
thf(fact_2566_int__ops_I3_J,axiom,
    ! [N2: num] :
      ( ( semiring_1_of_nat @ int @ ( numeral_numeral @ nat @ N2 ) )
      = ( numeral_numeral @ int @ N2 ) ) ).

% int_ops(3)
thf(fact_2567_nat__int__comparison_I2_J,axiom,
    ( ( ord_less @ nat )
    = ( ^ [A4: nat,B4: nat] : ( ord_less @ int @ ( semiring_1_of_nat @ int @ A4 ) @ ( semiring_1_of_nat @ int @ B4 ) ) ) ) ).

% nat_int_comparison(2)
thf(fact_2568_int__cases,axiom,
    ! [Z: int] :
      ( ! [N: nat] :
          ( Z
         != ( semiring_1_of_nat @ int @ N ) )
     => ~ ! [N: nat] :
            ( Z
           != ( uminus_uminus @ int @ ( semiring_1_of_nat @ int @ ( suc @ N ) ) ) ) ) ).

% int_cases
thf(fact_2569_int__of__nat__induct,axiom,
    ! [P: int > $o,Z: int] :
      ( ! [N: nat] : ( P @ ( semiring_1_of_nat @ int @ N ) )
     => ( ! [N: nat] : ( P @ ( uminus_uminus @ int @ ( semiring_1_of_nat @ int @ ( suc @ N ) ) ) )
       => ( P @ Z ) ) ) ).

% int_of_nat_induct
thf(fact_2570_nat__int__comparison_I3_J,axiom,
    ( ( ord_less_eq @ nat )
    = ( ^ [A4: nat,B4: nat] : ( ord_less_eq @ int @ ( semiring_1_of_nat @ int @ A4 ) @ ( semiring_1_of_nat @ int @ B4 ) ) ) ) ).

% nat_int_comparison(3)
thf(fact_2571_zle__int,axiom,
    ! [M: nat,N2: nat] :
      ( ( ord_less_eq @ int @ ( semiring_1_of_nat @ int @ M ) @ ( semiring_1_of_nat @ int @ N2 ) )
      = ( ord_less_eq @ nat @ M @ N2 ) ) ).

% zle_int
thf(fact_2572_zero__le__imp__eq__int,axiom,
    ! [K: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ K )
     => ? [N: nat] :
          ( K
          = ( semiring_1_of_nat @ int @ N ) ) ) ).

% zero_le_imp_eq_int
thf(fact_2573_nonneg__int__cases,axiom,
    ! [K: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ K )
     => ~ ! [N: nat] :
            ( K
           != ( semiring_1_of_nat @ int @ N ) ) ) ).

% nonneg_int_cases
thf(fact_2574_of__nat__mod,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [M: nat,N2: nat] :
          ( ( semiring_1_of_nat @ A @ ( modulo_modulo @ nat @ M @ N2 ) )
          = ( modulo_modulo @ A @ ( semiring_1_of_nat @ A @ M ) @ ( semiring_1_of_nat @ A @ N2 ) ) ) ) ).

% of_nat_mod
thf(fact_2575_int__plus,axiom,
    ! [N2: nat,M: nat] :
      ( ( semiring_1_of_nat @ int @ ( plus_plus @ nat @ N2 @ M ) )
      = ( plus_plus @ int @ ( semiring_1_of_nat @ int @ N2 ) @ ( semiring_1_of_nat @ int @ M ) ) ) ).

% int_plus
thf(fact_2576_int__ops_I5_J,axiom,
    ! [A2: nat,B2: nat] :
      ( ( semiring_1_of_nat @ int @ ( plus_plus @ nat @ A2 @ B2 ) )
      = ( plus_plus @ int @ ( semiring_1_of_nat @ int @ A2 ) @ ( semiring_1_of_nat @ int @ B2 ) ) ) ).

% int_ops(5)
thf(fact_2577_zadd__int__left,axiom,
    ! [M: nat,N2: nat,Z: int] :
      ( ( plus_plus @ int @ ( semiring_1_of_nat @ int @ M ) @ ( plus_plus @ int @ ( semiring_1_of_nat @ int @ N2 ) @ Z ) )
      = ( plus_plus @ int @ ( semiring_1_of_nat @ int @ ( plus_plus @ nat @ M @ N2 ) ) @ Z ) ) ).

% zadd_int_left
thf(fact_2578_int__ops_I7_J,axiom,
    ! [A2: nat,B2: nat] :
      ( ( semiring_1_of_nat @ int @ ( times_times @ nat @ A2 @ B2 ) )
      = ( times_times @ int @ ( semiring_1_of_nat @ int @ A2 ) @ ( semiring_1_of_nat @ int @ B2 ) ) ) ).

% int_ops(7)
thf(fact_2579_int__ops_I2_J,axiom,
    ( ( semiring_1_of_nat @ int @ ( one_one @ nat ) )
    = ( one_one @ int ) ) ).

% int_ops(2)
thf(fact_2580_zle__iff__zadd,axiom,
    ( ( ord_less_eq @ int )
    = ( ^ [W3: int,Z6: int] :
        ? [N3: nat] :
          ( Z6
          = ( plus_plus @ int @ W3 @ ( semiring_1_of_nat @ int @ N3 ) ) ) ) ) ).

% zle_iff_zadd
thf(fact_2581_not__int__zless__negative,axiom,
    ! [N2: nat,M: nat] :
      ~ ( ord_less @ int @ ( semiring_1_of_nat @ int @ N2 ) @ ( uminus_uminus @ int @ ( semiring_1_of_nat @ int @ M ) ) ) ).

% not_int_zless_negative
thf(fact_2582_zdiv__int,axiom,
    ! [A2: nat,B2: nat] :
      ( ( semiring_1_of_nat @ int @ ( divide_divide @ nat @ A2 @ B2 ) )
      = ( divide_divide @ int @ ( semiring_1_of_nat @ int @ A2 ) @ ( semiring_1_of_nat @ int @ B2 ) ) ) ).

% zdiv_int
thf(fact_2583_of__nat__max,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [X2: nat,Y2: nat] :
          ( ( semiring_1_of_nat @ A @ ( ord_max @ nat @ X2 @ Y2 ) )
          = ( ord_max @ A @ ( semiring_1_of_nat @ A @ X2 ) @ ( semiring_1_of_nat @ A @ Y2 ) ) ) ) ).

% of_nat_max
thf(fact_2584_take__bit__of__nat,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N2: nat,M: nat] :
          ( ( bit_se2584673776208193580ke_bit @ A @ N2 @ ( semiring_1_of_nat @ A @ M ) )
          = ( semiring_1_of_nat @ A @ ( bit_se2584673776208193580ke_bit @ nat @ N2 @ M ) ) ) ) ).

% take_bit_of_nat
thf(fact_2585_nat__less__as__int,axiom,
    ( ( ord_less @ nat )
    = ( ^ [A4: nat,B4: nat] : ( ord_less @ int @ ( semiring_1_of_nat @ int @ A4 ) @ ( semiring_1_of_nat @ int @ B4 ) ) ) ) ).

% nat_less_as_int
thf(fact_2586_of__nat__mask__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N2: nat] :
          ( ( semiring_1_of_nat @ A @ ( bit_se2239418461657761734s_mask @ nat @ N2 ) )
          = ( bit_se2239418461657761734s_mask @ A @ N2 ) ) ) ).

% of_nat_mask_eq
thf(fact_2587_nat__leq__as__int,axiom,
    ( ( ord_less_eq @ nat )
    = ( ^ [A4: nat,B4: nat] : ( ord_less_eq @ int @ ( semiring_1_of_nat @ int @ A4 ) @ ( semiring_1_of_nat @ int @ B4 ) ) ) ) ).

% nat_leq_as_int
thf(fact_2588_ex__less__of__nat__mult,axiom,
    ! [A: $tType] :
      ( ( archim462609752435547400_field @ A )
     => ! [X2: A,Y2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ X2 )
         => ? [N: nat] : ( ord_less @ A @ Y2 @ ( times_times @ A @ ( semiring_1_of_nat @ A @ N ) @ X2 ) ) ) ) ).

% ex_less_of_nat_mult
thf(fact_2589_of__nat__diff,axiom,
    ! [A: $tType] :
      ( ( semiring_1_cancel @ A )
     => ! [N2: nat,M: nat] :
          ( ( ord_less_eq @ nat @ N2 @ M )
         => ( ( semiring_1_of_nat @ A @ ( minus_minus @ nat @ M @ N2 ) )
            = ( minus_minus @ A @ ( semiring_1_of_nat @ A @ M ) @ ( semiring_1_of_nat @ A @ N2 ) ) ) ) ) ).

% of_nat_diff
thf(fact_2590_bit__not__int__iff_H,axiom,
    ! [K: int,N2: nat] :
      ( ( bit_se5641148757651400278ts_bit @ int @ ( minus_minus @ int @ ( uminus_uminus @ int @ K ) @ ( one_one @ int ) ) @ N2 )
      = ( ~ ( bit_se5641148757651400278ts_bit @ int @ K @ N2 ) ) ) ).

% bit_not_int_iff'
thf(fact_2591_reals__Archimedean3,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
     => ! [Y: real] :
        ? [N: nat] : ( ord_less @ real @ Y @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N ) @ X2 ) ) ) ).

% reals_Archimedean3
thf(fact_2592_int__cases4,axiom,
    ! [M: int] :
      ( ! [N: nat] :
          ( M
         != ( semiring_1_of_nat @ int @ N ) )
     => ~ ! [N: nat] :
            ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
           => ( M
             != ( uminus_uminus @ int @ ( semiring_1_of_nat @ int @ N ) ) ) ) ) ).

% int_cases4
thf(fact_2593_real__of__nat__div4,axiom,
    ! [N2: nat,X2: nat] : ( ord_less_eq @ real @ ( semiring_1_of_nat @ real @ ( divide_divide @ nat @ N2 @ X2 ) ) @ ( divide_divide @ real @ ( semiring_1_of_nat @ real @ N2 ) @ ( semiring_1_of_nat @ real @ X2 ) ) ) ).

% real_of_nat_div4
thf(fact_2594_int__zle__neg,axiom,
    ! [N2: nat,M: nat] :
      ( ( ord_less_eq @ int @ ( semiring_1_of_nat @ int @ N2 ) @ ( uminus_uminus @ int @ ( semiring_1_of_nat @ int @ M ) ) )
      = ( ( N2
          = ( zero_zero @ nat ) )
        & ( M
          = ( zero_zero @ nat ) ) ) ) ).

% int_zle_neg
thf(fact_2595_int__Suc,axiom,
    ! [N2: nat] :
      ( ( semiring_1_of_nat @ int @ ( suc @ N2 ) )
      = ( plus_plus @ int @ ( semiring_1_of_nat @ int @ N2 ) @ ( one_one @ int ) ) ) ).

% int_Suc
thf(fact_2596_int__ops_I4_J,axiom,
    ! [A2: nat] :
      ( ( semiring_1_of_nat @ int @ ( suc @ A2 ) )
      = ( plus_plus @ int @ ( semiring_1_of_nat @ int @ A2 ) @ ( one_one @ int ) ) ) ).

% int_ops(4)
thf(fact_2597_zless__iff__Suc__zadd,axiom,
    ( ( ord_less @ int )
    = ( ^ [W3: int,Z6: int] :
        ? [N3: nat] :
          ( Z6
          = ( plus_plus @ int @ W3 @ ( semiring_1_of_nat @ int @ ( suc @ N3 ) ) ) ) ) ) ).

% zless_iff_Suc_zadd
thf(fact_2598_nonpos__int__cases,axiom,
    ! [K: int] :
      ( ( ord_less_eq @ int @ K @ ( zero_zero @ int ) )
     => ~ ! [N: nat] :
            ( K
           != ( uminus_uminus @ int @ ( semiring_1_of_nat @ int @ N ) ) ) ) ).

% nonpos_int_cases
thf(fact_2599_negative__zle__0,axiom,
    ! [N2: nat] : ( ord_less_eq @ int @ ( uminus_uminus @ int @ ( semiring_1_of_nat @ int @ N2 ) ) @ ( zero_zero @ int ) ) ).

% negative_zle_0
thf(fact_2600_real__of__nat__div,axiom,
    ! [D2: nat,N2: nat] :
      ( ( dvd_dvd @ nat @ D2 @ N2 )
     => ( ( semiring_1_of_nat @ real @ ( divide_divide @ nat @ N2 @ D2 ) )
        = ( divide_divide @ real @ ( semiring_1_of_nat @ real @ N2 ) @ ( semiring_1_of_nat @ real @ D2 ) ) ) ) ).

% real_of_nat_div
thf(fact_2601_flip__bit__eq__if,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se8732182000553998342ip_bit @ A )
        = ( ^ [N3: nat,A4: A] : ( if @ ( nat > A > A ) @ ( bit_se5641148757651400278ts_bit @ A @ A4 @ N3 ) @ ( bit_se2638667681897837118et_bit @ A ) @ ( bit_se5668285175392031749et_bit @ A ) @ N3 @ A4 ) ) ) ) ).

% flip_bit_eq_if
thf(fact_2602_mod__mult2__eq_H,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [A2: A,M: nat,N2: nat] :
          ( ( modulo_modulo @ A @ A2 @ ( times_times @ A @ ( semiring_1_of_nat @ A @ M ) @ ( semiring_1_of_nat @ A @ N2 ) ) )
          = ( plus_plus @ A @ ( times_times @ A @ ( semiring_1_of_nat @ A @ M ) @ ( modulo_modulo @ A @ ( divide_divide @ A @ A2 @ ( semiring_1_of_nat @ A @ M ) ) @ ( semiring_1_of_nat @ A @ N2 ) ) ) @ ( modulo_modulo @ A @ A2 @ ( semiring_1_of_nat @ A @ M ) ) ) ) ) ).

% mod_mult2_eq'
thf(fact_2603_bit__imp__take__bit__positive,axiom,
    ! [N2: nat,M: nat,K: int] :
      ( ( ord_less @ nat @ N2 @ M )
     => ( ( bit_se5641148757651400278ts_bit @ int @ K @ N2 )
       => ( ord_less @ int @ ( zero_zero @ int ) @ ( bit_se2584673776208193580ke_bit @ int @ M @ K ) ) ) ) ).

% bit_imp_take_bit_positive
thf(fact_2604_field__char__0__class_Oof__nat__div,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [M: nat,N2: nat] :
          ( ( semiring_1_of_nat @ A @ ( divide_divide @ nat @ M @ N2 ) )
          = ( divide_divide @ A @ ( minus_minus @ A @ ( semiring_1_of_nat @ A @ M ) @ ( semiring_1_of_nat @ A @ ( modulo_modulo @ nat @ M @ N2 ) ) ) @ ( semiring_1_of_nat @ A @ N2 ) ) ) ) ).

% field_char_0_class.of_nat_div
thf(fact_2605_bit__concat__bit__iff,axiom,
    ! [M: nat,K: int,L: int,N2: nat] :
      ( ( bit_se5641148757651400278ts_bit @ int @ ( bit_concat_bit @ M @ K @ L ) @ N2 )
      = ( ( ( ord_less @ nat @ N2 @ M )
          & ( bit_se5641148757651400278ts_bit @ int @ K @ N2 ) )
        | ( ( ord_less_eq @ nat @ M @ N2 )
          & ( bit_se5641148757651400278ts_bit @ int @ L @ ( minus_minus @ nat @ N2 @ M ) ) ) ) ) ).

% bit_concat_bit_iff
thf(fact_2606_pos__int__cases,axiom,
    ! [K: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ K )
     => ~ ! [N: nat] :
            ( ( K
              = ( semiring_1_of_nat @ int @ N ) )
           => ~ ( ord_less @ nat @ ( zero_zero @ nat ) @ N ) ) ) ).

% pos_int_cases
thf(fact_2607_zero__less__imp__eq__int,axiom,
    ! [K: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ K )
     => ? [N: nat] :
          ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
          & ( K
            = ( semiring_1_of_nat @ int @ N ) ) ) ) ).

% zero_less_imp_eq_int
thf(fact_2608_int__cases3,axiom,
    ! [K: int] :
      ( ( K
       != ( zero_zero @ int ) )
     => ( ! [N: nat] :
            ( ( K
              = ( semiring_1_of_nat @ int @ N ) )
           => ~ ( ord_less @ nat @ ( zero_zero @ nat ) @ N ) )
       => ~ ! [N: nat] :
              ( ( K
                = ( uminus_uminus @ int @ ( semiring_1_of_nat @ int @ N ) ) )
             => ~ ( ord_less @ nat @ ( zero_zero @ nat ) @ N ) ) ) ) ).

% int_cases3
thf(fact_2609_nat__less__real__le,axiom,
    ( ( ord_less @ nat )
    = ( ^ [N3: nat,M6: nat] : ( ord_less_eq @ real @ ( plus_plus @ real @ ( semiring_1_of_nat @ real @ N3 ) @ ( one_one @ real ) ) @ ( semiring_1_of_nat @ real @ M6 ) ) ) ) ).

% nat_less_real_le
thf(fact_2610_nat__le__real__less,axiom,
    ( ( ord_less_eq @ nat )
    = ( ^ [N3: nat,M6: nat] : ( ord_less @ real @ ( semiring_1_of_nat @ real @ N3 ) @ ( plus_plus @ real @ ( semiring_1_of_nat @ real @ M6 ) @ ( one_one @ real ) ) ) ) ) ).

% nat_le_real_less
thf(fact_2611_zmult__zless__mono2__lemma,axiom,
    ! [I3: int,J: int,K: nat] :
      ( ( ord_less @ int @ I3 @ J )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
       => ( ord_less @ int @ ( times_times @ int @ ( semiring_1_of_nat @ int @ K ) @ I3 ) @ ( times_times @ int @ ( semiring_1_of_nat @ int @ K ) @ J ) ) ) ) ).

% zmult_zless_mono2_lemma
thf(fact_2612_not__zle__0__negative,axiom,
    ! [N2: nat] :
      ~ ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( uminus_uminus @ int @ ( semiring_1_of_nat @ int @ ( suc @ N2 ) ) ) ) ).

% not_zle_0_negative
thf(fact_2613_negative__zless__0,axiom,
    ! [N2: nat] : ( ord_less @ int @ ( uminus_uminus @ int @ ( semiring_1_of_nat @ int @ ( suc @ N2 ) ) ) @ ( zero_zero @ int ) ) ).

% negative_zless_0
thf(fact_2614_negD,axiom,
    ! [X2: int] :
      ( ( ord_less @ int @ X2 @ ( zero_zero @ int ) )
     => ? [N: nat] :
          ( X2
          = ( uminus_uminus @ int @ ( semiring_1_of_nat @ int @ ( suc @ N ) ) ) ) ) ).

% negD
thf(fact_2615_int__ops_I6_J,axiom,
    ! [A2: nat,B2: nat] :
      ( ( ( ord_less @ int @ ( semiring_1_of_nat @ int @ A2 ) @ ( semiring_1_of_nat @ int @ B2 ) )
       => ( ( semiring_1_of_nat @ int @ ( minus_minus @ nat @ A2 @ B2 ) )
          = ( zero_zero @ int ) ) )
      & ( ~ ( ord_less @ int @ ( semiring_1_of_nat @ int @ A2 ) @ ( semiring_1_of_nat @ int @ B2 ) )
       => ( ( semiring_1_of_nat @ int @ ( minus_minus @ nat @ A2 @ B2 ) )
          = ( minus_minus @ int @ ( semiring_1_of_nat @ int @ A2 ) @ ( semiring_1_of_nat @ int @ B2 ) ) ) ) ) ).

% int_ops(6)
thf(fact_2616_real__of__nat__div__aux,axiom,
    ! [X2: nat,D2: nat] :
      ( ( divide_divide @ real @ ( semiring_1_of_nat @ real @ X2 ) @ ( semiring_1_of_nat @ real @ D2 ) )
      = ( plus_plus @ real @ ( semiring_1_of_nat @ real @ ( divide_divide @ nat @ X2 @ D2 ) ) @ ( divide_divide @ real @ ( semiring_1_of_nat @ real @ ( modulo_modulo @ nat @ X2 @ D2 ) ) @ ( semiring_1_of_nat @ real @ D2 ) ) ) ) ).

% real_of_nat_div_aux
thf(fact_2617_signed__take__bit__eq__concat__bit,axiom,
    ( ( bit_ri4674362597316999326ke_bit @ int )
    = ( ^ [N3: nat,K3: int] : ( bit_concat_bit @ N3 @ K3 @ ( uminus_uminus @ int @ ( zero_neq_one_of_bool @ int @ ( bit_se5641148757651400278ts_bit @ int @ K3 @ N3 ) ) ) ) ) ) ).

% signed_take_bit_eq_concat_bit
thf(fact_2618_exp__eq__0__imp__not__bit,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [N2: nat,A2: A] :
          ( ( ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N2 )
            = ( zero_zero @ A ) )
         => ~ ( bit_se5641148757651400278ts_bit @ A @ A2 @ N2 ) ) ) ).

% exp_eq_0_imp_not_bit
thf(fact_2619_bit__Suc,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A,N2: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ A2 @ ( suc @ N2 ) )
          = ( bit_se5641148757651400278ts_bit @ A @ ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ N2 ) ) ) ).

% bit_Suc
thf(fact_2620_bit__iff__idd__imp__stable,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A] :
          ( ! [N: nat] :
              ( ( bit_se5641148757651400278ts_bit @ A @ A2 @ N )
              = ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) ) )
         => ( ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
            = A2 ) ) ) ).

% bit_iff_idd_imp_stable
thf(fact_2621_stable__imp__bit__iff__odd,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A,N2: nat] :
          ( ( ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
            = A2 )
         => ( ( bit_se5641148757651400278ts_bit @ A @ A2 @ N2 )
            = ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) ) ) ) ) ).

% stable_imp_bit_iff_odd
thf(fact_2622_nat__approx__posE,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [E2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ E2 )
         => ~ ! [N: nat] :
                ~ ( ord_less @ A @ ( divide_divide @ A @ ( one_one @ A ) @ ( semiring_1_of_nat @ A @ ( suc @ N ) ) ) @ E2 ) ) ) ).

% nat_approx_posE
thf(fact_2623_of__nat__less__two__power,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N2: nat] : ( ord_less @ A @ ( semiring_1_of_nat @ A @ N2 ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N2 ) ) ) ).

% of_nat_less_two_power
thf(fact_2624_int__bit__bound,axiom,
    ! [K: int] :
      ~ ! [N: nat] :
          ( ! [M2: nat] :
              ( ( ord_less_eq @ nat @ N @ M2 )
             => ( ( bit_se5641148757651400278ts_bit @ int @ K @ M2 )
                = ( bit_se5641148757651400278ts_bit @ int @ K @ N ) ) )
         => ~ ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
             => ( ( bit_se5641148757651400278ts_bit @ int @ K @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) )
                = ( ~ ( bit_se5641148757651400278ts_bit @ int @ K @ N ) ) ) ) ) ).

% int_bit_bound
thf(fact_2625_inverse__of__nat__le,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [N2: nat,M: nat] :
          ( ( ord_less_eq @ nat @ N2 @ M )
         => ( ( N2
             != ( zero_zero @ nat ) )
           => ( ord_less_eq @ A @ ( divide_divide @ A @ ( one_one @ A ) @ ( semiring_1_of_nat @ A @ M ) ) @ ( divide_divide @ A @ ( one_one @ A ) @ ( semiring_1_of_nat @ A @ N2 ) ) ) ) ) ) ).

% inverse_of_nat_le
thf(fact_2626_real__archimedian__rdiv__eq__0,axiom,
    ! [X2: real,C2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ C2 )
       => ( ! [M3: nat] :
              ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M3 )
             => ( ord_less_eq @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ M3 ) @ X2 ) @ C2 ) )
         => ( X2
            = ( zero_zero @ real ) ) ) ) ) ).

% real_archimedian_rdiv_eq_0
thf(fact_2627_neg__int__cases,axiom,
    ! [K: int] :
      ( ( ord_less @ int @ K @ ( zero_zero @ int ) )
     => ~ ! [N: nat] :
            ( ( K
              = ( uminus_uminus @ int @ ( semiring_1_of_nat @ int @ N ) ) )
           => ~ ( ord_less @ nat @ ( zero_zero @ nat ) @ N ) ) ) ).

% neg_int_cases
thf(fact_2628_zdiff__int__split,axiom,
    ! [P: int > $o,X2: nat,Y2: nat] :
      ( ( P @ ( semiring_1_of_nat @ int @ ( minus_minus @ nat @ X2 @ Y2 ) ) )
      = ( ( ( ord_less_eq @ nat @ Y2 @ X2 )
         => ( P @ ( minus_minus @ int @ ( semiring_1_of_nat @ int @ X2 ) @ ( semiring_1_of_nat @ int @ Y2 ) ) ) )
        & ( ( ord_less @ nat @ X2 @ Y2 )
         => ( P @ ( zero_zero @ int ) ) ) ) ) ).

% zdiff_int_split
thf(fact_2629_real__of__nat__div2,axiom,
    ! [N2: nat,X2: nat] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( minus_minus @ real @ ( divide_divide @ real @ ( semiring_1_of_nat @ real @ N2 ) @ ( semiring_1_of_nat @ real @ X2 ) ) @ ( semiring_1_of_nat @ real @ ( divide_divide @ nat @ N2 @ X2 ) ) ) ) ).

% real_of_nat_div2
thf(fact_2630_real__of__nat__div3,axiom,
    ! [N2: nat,X2: nat] : ( ord_less_eq @ real @ ( minus_minus @ real @ ( divide_divide @ real @ ( semiring_1_of_nat @ real @ N2 ) @ ( semiring_1_of_nat @ real @ X2 ) ) @ ( semiring_1_of_nat @ real @ ( divide_divide @ nat @ N2 @ X2 ) ) ) @ ( one_one @ real ) ) ).

% real_of_nat_div3
thf(fact_2631_bit__iff__odd,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ( ( bit_se5641148757651400278ts_bit @ A )
        = ( ^ [A4: A,N3: nat] :
              ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( divide_divide @ A @ A4 @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N3 ) ) ) ) ) ) ).

% bit_iff_odd
thf(fact_2632_bit__int__def,axiom,
    ( ( bit_se5641148757651400278ts_bit @ int )
    = ( ^ [K3: int,N3: nat] :
          ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( divide_divide @ int @ K3 @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N3 ) ) ) ) ) ).

% bit_int_def
thf(fact_2633_linear__plus__1__le__power,axiom,
    ! [X2: real,N2: nat] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X2 )
     => ( ord_less_eq @ real @ ( plus_plus @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N2 ) @ X2 ) @ ( one_one @ real ) ) @ ( power_power @ real @ ( plus_plus @ real @ X2 @ ( one_one @ real ) ) @ N2 ) ) ) ).

% linear_plus_1_le_power
thf(fact_2634_Bernoulli__inequality,axiom,
    ! [X2: real,N2: nat] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ X2 )
     => ( ord_less_eq @ real @ ( plus_plus @ real @ ( one_one @ real ) @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N2 ) @ X2 ) ) @ ( power_power @ real @ ( plus_plus @ real @ ( one_one @ real ) @ X2 ) @ N2 ) ) ) ).

% Bernoulli_inequality
thf(fact_2635_even__bit__succ__iff,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A,N2: nat] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
         => ( ( bit_se5641148757651400278ts_bit @ A @ ( plus_plus @ A @ ( one_one @ A ) @ A2 ) @ N2 )
            = ( ( bit_se5641148757651400278ts_bit @ A @ A2 @ N2 )
              | ( N2
                = ( zero_zero @ nat ) ) ) ) ) ) ).

% even_bit_succ_iff
thf(fact_2636_odd__bit__iff__bit__pred,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A,N2: nat] :
          ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
         => ( ( bit_se5641148757651400278ts_bit @ A @ A2 @ N2 )
            = ( ( bit_se5641148757651400278ts_bit @ A @ ( minus_minus @ A @ A2 @ ( one_one @ A ) ) @ N2 )
              | ( N2
                = ( zero_zero @ nat ) ) ) ) ) ) ).

% odd_bit_iff_bit_pred
thf(fact_2637_bit__sum__mult__2__cases,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A,B2: A,N2: nat] :
          ( ! [J2: nat] :
              ~ ( bit_se5641148757651400278ts_bit @ A @ A2 @ ( suc @ J2 ) )
         => ( ( bit_se5641148757651400278ts_bit @ A @ ( plus_plus @ A @ A2 @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B2 ) ) @ N2 )
            = ( ( ( N2
                  = ( zero_zero @ nat ) )
               => ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) )
              & ( ( N2
                 != ( zero_zero @ nat ) )
               => ( bit_se5641148757651400278ts_bit @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B2 ) @ N2 ) ) ) ) ) ) ).

% bit_sum_mult_2_cases
thf(fact_2638_bit__rec,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ( ( bit_se5641148757651400278ts_bit @ A )
        = ( ^ [A4: A,N3: nat] :
              ( ( ( N3
                  = ( zero_zero @ nat ) )
               => ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A4 ) )
              & ( ( N3
                 != ( zero_zero @ nat ) )
               => ( bit_se5641148757651400278ts_bit @ A @ ( divide_divide @ A @ A4 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( minus_minus @ nat @ N3 @ ( one_one @ nat ) ) ) ) ) ) ) ) ).

% bit_rec
thf(fact_2639_double__gauss__sum,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [N2: nat] :
          ( ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( groups7311177749621191930dd_sum @ nat @ A @ ( semiring_1_of_nat @ A ) @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N2 ) ) )
          = ( times_times @ A @ ( semiring_1_of_nat @ A @ N2 ) @ ( plus_plus @ A @ ( semiring_1_of_nat @ A @ N2 ) @ ( one_one @ A ) ) ) ) ) ).

% double_gauss_sum
thf(fact_2640_double__arith__series,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [A2: A,D2: A,N2: nat] :
          ( ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) )
            @ ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [I4: nat] : ( plus_plus @ A @ A2 @ ( times_times @ A @ ( semiring_1_of_nat @ A @ I4 ) @ D2 ) )
              @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N2 ) ) )
          = ( times_times @ A @ ( plus_plus @ A @ ( semiring_1_of_nat @ A @ N2 ) @ ( one_one @ A ) ) @ ( plus_plus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) @ ( times_times @ A @ ( semiring_1_of_nat @ A @ N2 ) @ D2 ) ) ) ) ) ).

% double_arith_series
thf(fact_2641_set__bit__eq,axiom,
    ( ( bit_se5668285175392031749et_bit @ int )
    = ( ^ [N3: nat,K3: int] :
          ( plus_plus @ int @ K3
          @ ( times_times @ int
            @ ( zero_neq_one_of_bool @ int
              @ ~ ( bit_se5641148757651400278ts_bit @ int @ K3 @ N3 ) )
            @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N3 ) ) ) ) ) ).

% set_bit_eq
thf(fact_2642_unset__bit__eq,axiom,
    ( ( bit_se2638667681897837118et_bit @ int )
    = ( ^ [N3: nat,K3: int] : ( minus_minus @ int @ K3 @ ( times_times @ int @ ( zero_neq_one_of_bool @ int @ ( bit_se5641148757651400278ts_bit @ int @ K3 @ N3 ) ) @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N3 ) ) ) ) ) ).

% unset_bit_eq
thf(fact_2643_take__bit__Suc__from__most,axiom,
    ! [N2: nat,K: int] :
      ( ( bit_se2584673776208193580ke_bit @ int @ ( suc @ N2 ) @ K )
      = ( plus_plus @ int @ ( times_times @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N2 ) @ ( zero_neq_one_of_bool @ int @ ( bit_se5641148757651400278ts_bit @ int @ K @ N2 ) ) ) @ ( bit_se2584673776208193580ke_bit @ int @ N2 @ K ) ) ) ).

% take_bit_Suc_from_most
thf(fact_2644_gauss__sum,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [N2: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ ( semiring_1_of_nat @ A ) @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N2 ) )
          = ( divide_divide @ A @ ( times_times @ A @ ( semiring_1_of_nat @ A @ N2 ) @ ( plus_plus @ A @ ( semiring_1_of_nat @ A @ N2 ) @ ( one_one @ A ) ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% gauss_sum
thf(fact_2645_arith__series,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [A2: A,D2: A,N2: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [I4: nat] : ( plus_plus @ A @ A2 @ ( times_times @ A @ ( semiring_1_of_nat @ A @ I4 ) @ D2 ) )
            @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N2 ) )
          = ( divide_divide @ A @ ( times_times @ A @ ( plus_plus @ A @ ( semiring_1_of_nat @ A @ N2 ) @ ( one_one @ A ) ) @ ( plus_plus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) @ ( times_times @ A @ ( semiring_1_of_nat @ A @ N2 ) @ D2 ) ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% arith_series
thf(fact_2646_double__gauss__sum__from__Suc__0,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [N2: nat] :
          ( ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( groups7311177749621191930dd_sum @ nat @ A @ ( semiring_1_of_nat @ A ) @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ ( zero_zero @ nat ) ) @ N2 ) ) )
          = ( times_times @ A @ ( semiring_1_of_nat @ A @ N2 ) @ ( plus_plus @ A @ ( semiring_1_of_nat @ A @ N2 ) @ ( one_one @ A ) ) ) ) ) ).

% double_gauss_sum_from_Suc_0
thf(fact_2647_Bernoulli__inequality__even,axiom,
    ! [N2: nat,X2: real] :
      ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 )
     => ( ord_less_eq @ real @ ( plus_plus @ real @ ( one_one @ real ) @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N2 ) @ X2 ) ) @ ( power_power @ real @ ( plus_plus @ real @ ( one_one @ real ) @ X2 ) @ N2 ) ) ) ).

% Bernoulli_inequality_even
thf(fact_2648_sum__gp__offset,axiom,
    ! [A: $tType] :
      ( ( ( division_ring @ A )
        & ( comm_ring @ A ) )
     => ! [X2: A,M: nat,N2: nat] :
          ( ( ( X2
              = ( one_one @ A ) )
           => ( ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X2 ) @ ( set_or1337092689740270186AtMost @ nat @ M @ ( plus_plus @ nat @ M @ N2 ) ) )
              = ( plus_plus @ A @ ( semiring_1_of_nat @ A @ N2 ) @ ( one_one @ A ) ) ) )
          & ( ( X2
             != ( one_one @ A ) )
           => ( ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X2 ) @ ( set_or1337092689740270186AtMost @ nat @ M @ ( plus_plus @ nat @ M @ N2 ) ) )
              = ( divide_divide @ A @ ( times_times @ A @ ( power_power @ A @ X2 @ M ) @ ( minus_minus @ A @ ( one_one @ A ) @ ( power_power @ A @ X2 @ ( suc @ N2 ) ) ) ) @ ( minus_minus @ A @ ( one_one @ A ) @ X2 ) ) ) ) ) ) ).

% sum_gp_offset
thf(fact_2649_of__nat__code__if,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ( ( semiring_1_of_nat @ A )
        = ( ^ [N3: nat] :
              ( if @ A
              @ ( N3
                = ( zero_zero @ nat ) )
              @ ( zero_zero @ A )
              @ ( product_case_prod @ nat @ nat @ A
                @ ^ [M6: nat,Q4: nat] :
                    ( if @ A
                    @ ( Q4
                      = ( zero_zero @ nat ) )
                    @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( semiring_1_of_nat @ A @ M6 ) )
                    @ ( plus_plus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( semiring_1_of_nat @ A @ M6 ) ) @ ( one_one @ A ) ) )
                @ ( divmod_nat @ N3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% of_nat_code_if
thf(fact_2650_fold__atLeastAtMost__nat_Opelims,axiom,
    ! [A: $tType,X2: nat > A > A,Xa2: nat,Xb3: nat,Xc: A,Y2: A] :
      ( ( ( set_fo6178422350223883121st_nat @ A @ X2 @ Xa2 @ Xb3 @ Xc )
        = Y2 )
     => ( ( accp @ ( product_prod @ ( nat > A > A ) @ ( product_prod @ nat @ ( product_prod @ nat @ A ) ) ) @ ( set_fo1817059534552279752at_rel @ A ) @ ( product_Pair @ ( nat > A > A ) @ ( product_prod @ nat @ ( product_prod @ nat @ A ) ) @ X2 @ ( product_Pair @ nat @ ( product_prod @ nat @ A ) @ Xa2 @ ( product_Pair @ nat @ A @ Xb3 @ Xc ) ) ) )
       => ~ ( ( ( ( ord_less @ nat @ Xb3 @ Xa2 )
               => ( Y2 = Xc ) )
              & ( ~ ( ord_less @ nat @ Xb3 @ Xa2 )
               => ( Y2
                  = ( set_fo6178422350223883121st_nat @ A @ X2 @ ( plus_plus @ nat @ Xa2 @ ( one_one @ nat ) ) @ Xb3 @ ( X2 @ Xa2 @ Xc ) ) ) ) )
           => ~ ( accp @ ( product_prod @ ( nat > A > A ) @ ( product_prod @ nat @ ( product_prod @ nat @ A ) ) ) @ ( set_fo1817059534552279752at_rel @ A ) @ ( product_Pair @ ( nat > A > A ) @ ( product_prod @ nat @ ( product_prod @ nat @ A ) ) @ X2 @ ( product_Pair @ nat @ ( product_prod @ nat @ A ) @ Xa2 @ ( product_Pair @ nat @ A @ Xb3 @ Xc ) ) ) ) ) ) ) ).

% fold_atLeastAtMost_nat.pelims
thf(fact_2651_fold__atLeastAtMost__nat_Opsimps,axiom,
    ! [A: $tType,F2: nat > A > A,A2: nat,B2: nat,Acc2: A] :
      ( ( accp @ ( product_prod @ ( nat > A > A ) @ ( product_prod @ nat @ ( product_prod @ nat @ A ) ) ) @ ( set_fo1817059534552279752at_rel @ A ) @ ( product_Pair @ ( nat > A > A ) @ ( product_prod @ nat @ ( product_prod @ nat @ A ) ) @ F2 @ ( product_Pair @ nat @ ( product_prod @ nat @ A ) @ A2 @ ( product_Pair @ nat @ A @ B2 @ Acc2 ) ) ) )
     => ( ( ( ord_less @ nat @ B2 @ A2 )
         => ( ( set_fo6178422350223883121st_nat @ A @ F2 @ A2 @ B2 @ Acc2 )
            = Acc2 ) )
        & ( ~ ( ord_less @ nat @ B2 @ A2 )
         => ( ( set_fo6178422350223883121st_nat @ A @ F2 @ A2 @ B2 @ Acc2 )
            = ( set_fo6178422350223883121st_nat @ A @ F2 @ ( plus_plus @ nat @ A2 @ ( one_one @ nat ) ) @ B2 @ ( F2 @ A2 @ Acc2 ) ) ) ) ) ) ).

% fold_atLeastAtMost_nat.psimps
thf(fact_2652_lemma__termdiff3,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [H2: A,Z: A,K5: real,N2: nat] :
          ( ( H2
           != ( zero_zero @ A ) )
         => ( ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ Z ) @ K5 )
           => ( ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( plus_plus @ A @ Z @ H2 ) ) @ K5 )
             => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ ( divide_divide @ A @ ( minus_minus @ A @ ( power_power @ A @ ( plus_plus @ A @ Z @ H2 ) @ N2 ) @ ( power_power @ A @ Z @ N2 ) ) @ H2 ) @ ( times_times @ A @ ( semiring_1_of_nat @ A @ N2 ) @ ( power_power @ A @ Z @ ( minus_minus @ nat @ N2 @ ( suc @ ( zero_zero @ nat ) ) ) ) ) ) ) @ ( times_times @ real @ ( times_times @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N2 ) @ ( semiring_1_of_nat @ real @ ( minus_minus @ nat @ N2 @ ( suc @ ( zero_zero @ nat ) ) ) ) ) @ ( power_power @ real @ K5 @ ( minus_minus @ nat @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( real_V7770717601297561774m_norm @ A @ H2 ) ) ) ) ) ) ) ).

% lemma_termdiff3
thf(fact_2653_pochhammer__double,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [Z: A,N2: nat] :
          ( ( comm_s3205402744901411588hammer @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ Z ) @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) )
          = ( times_times @ A @ ( times_times @ A @ ( semiring_1_of_nat @ A @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) ) @ ( comm_s3205402744901411588hammer @ A @ Z @ N2 ) ) @ ( comm_s3205402744901411588hammer @ A @ ( plus_plus @ A @ Z @ ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) @ N2 ) ) ) ) ).

% pochhammer_double
thf(fact_2654_of__nat__code,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ( ( semiring_1_of_nat @ A )
        = ( ^ [N3: nat] :
              ( semiri8178284476397505188at_aux @ A
              @ ^ [I4: A] : ( plus_plus @ A @ I4 @ ( one_one @ A ) )
              @ N3
              @ ( zero_zero @ A ) ) ) ) ) ).

% of_nat_code
thf(fact_2655_pochhammer__1,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [A2: A] :
          ( ( comm_s3205402744901411588hammer @ A @ A2 @ ( one_one @ nat ) )
          = A2 ) ) ).

% pochhammer_1
thf(fact_2656_pochhammer__0,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [A2: A] :
          ( ( comm_s3205402744901411588hammer @ A @ A2 @ ( zero_zero @ nat ) )
          = ( one_one @ A ) ) ) ).

% pochhammer_0
thf(fact_2657_pochhammer__Suc0,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [A2: A] :
          ( ( comm_s3205402744901411588hammer @ A @ A2 @ ( suc @ ( zero_zero @ nat ) ) )
          = A2 ) ) ).

% pochhammer_Suc0
thf(fact_2658_not__bit__Suc__0__Suc,axiom,
    ! [N2: nat] :
      ~ ( bit_se5641148757651400278ts_bit @ nat @ ( suc @ ( zero_zero @ nat ) ) @ ( suc @ N2 ) ) ).

% not_bit_Suc_0_Suc
thf(fact_2659_bit__Suc__0__iff,axiom,
    ! [N2: nat] :
      ( ( bit_se5641148757651400278ts_bit @ nat @ ( suc @ ( zero_zero @ nat ) ) @ N2 )
      = ( N2
        = ( zero_zero @ nat ) ) ) ).

% bit_Suc_0_iff
thf(fact_2660_pochhammer__pos,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [X2: A,N2: nat] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ X2 )
         => ( ord_less @ A @ ( zero_zero @ A ) @ ( comm_s3205402744901411588hammer @ A @ X2 @ N2 ) ) ) ) ).

% pochhammer_pos
thf(fact_2661_pochhammer__neq__0__mono,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: A,M: nat,N2: nat] :
          ( ( ( comm_s3205402744901411588hammer @ A @ A2 @ M )
           != ( zero_zero @ A ) )
         => ( ( ord_less_eq @ nat @ N2 @ M )
           => ( ( comm_s3205402744901411588hammer @ A @ A2 @ N2 )
             != ( zero_zero @ A ) ) ) ) ) ).

% pochhammer_neq_0_mono
thf(fact_2662_pochhammer__eq__0__mono,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: A,N2: nat,M: nat] :
          ( ( ( comm_s3205402744901411588hammer @ A @ A2 @ N2 )
            = ( zero_zero @ A ) )
         => ( ( ord_less_eq @ nat @ N2 @ M )
           => ( ( comm_s3205402744901411588hammer @ A @ A2 @ M )
              = ( zero_zero @ A ) ) ) ) ) ).

% pochhammer_eq_0_mono
thf(fact_2663_not__bit__Suc__0__numeral,axiom,
    ! [N2: num] :
      ~ ( bit_se5641148757651400278ts_bit @ nat @ ( suc @ ( zero_zero @ nat ) ) @ ( numeral_numeral @ nat @ N2 ) ) ).

% not_bit_Suc_0_numeral
thf(fact_2664_pochhammer__nonneg,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [X2: A,N2: nat] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ X2 )
         => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( comm_s3205402744901411588hammer @ A @ X2 @ N2 ) ) ) ) ).

% pochhammer_nonneg
thf(fact_2665_of__nat__aux_Osimps_I2_J,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [Inc: A > A,N2: nat,I3: A] :
          ( ( semiri8178284476397505188at_aux @ A @ Inc @ ( suc @ N2 ) @ I3 )
          = ( semiri8178284476397505188at_aux @ A @ Inc @ N2 @ ( Inc @ I3 ) ) ) ) ).

% of_nat_aux.simps(2)
thf(fact_2666_of__nat__aux_Osimps_I1_J,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [Inc: A > A,I3: A] :
          ( ( semiri8178284476397505188at_aux @ A @ Inc @ ( zero_zero @ nat ) @ I3 )
          = I3 ) ) ).

% of_nat_aux.simps(1)
thf(fact_2667_pochhammer__0__left,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [N2: nat] :
          ( ( ( N2
              = ( zero_zero @ nat ) )
           => ( ( comm_s3205402744901411588hammer @ A @ ( zero_zero @ A ) @ N2 )
              = ( one_one @ A ) ) )
          & ( ( N2
             != ( zero_zero @ nat ) )
           => ( ( comm_s3205402744901411588hammer @ A @ ( zero_zero @ A ) @ N2 )
              = ( zero_zero @ A ) ) ) ) ) ).

% pochhammer_0_left
thf(fact_2668_lemma__NBseq__def2,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V822414075346904944vector @ B )
     => ! [X8: A > B] :
          ( ( ? [K6: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ K6 )
                & ! [N3: A] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ B @ ( X8 @ N3 ) ) @ K6 ) ) )
          = ( ? [N6: nat] :
              ! [N3: A] : ( ord_less @ real @ ( real_V7770717601297561774m_norm @ B @ ( X8 @ N3 ) ) @ ( semiring_1_of_nat @ real @ ( suc @ N6 ) ) ) ) ) ) ).

% lemma_NBseq_def2
thf(fact_2669_lemma__NBseq__def,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V822414075346904944vector @ B )
     => ! [X8: A > B] :
          ( ( ? [K6: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ K6 )
                & ! [N3: A] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ B @ ( X8 @ N3 ) ) @ K6 ) ) )
          = ( ? [N6: nat] :
              ! [N3: A] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ B @ ( X8 @ N3 ) ) @ ( semiring_1_of_nat @ real @ ( suc @ N6 ) ) ) ) ) ) ).

% lemma_NBseq_def
thf(fact_2670_pochhammer__rec,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [A2: A,N2: nat] :
          ( ( comm_s3205402744901411588hammer @ A @ A2 @ ( suc @ N2 ) )
          = ( times_times @ A @ A2 @ ( comm_s3205402744901411588hammer @ A @ ( plus_plus @ A @ A2 @ ( one_one @ A ) ) @ N2 ) ) ) ) ).

% pochhammer_rec
thf(fact_2671_pochhammer__Suc,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [A2: A,N2: nat] :
          ( ( comm_s3205402744901411588hammer @ A @ A2 @ ( suc @ N2 ) )
          = ( times_times @ A @ ( comm_s3205402744901411588hammer @ A @ A2 @ N2 ) @ ( plus_plus @ A @ A2 @ ( semiring_1_of_nat @ A @ N2 ) ) ) ) ) ).

% pochhammer_Suc
thf(fact_2672_pochhammer__rec_H,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [Z: A,N2: nat] :
          ( ( comm_s3205402744901411588hammer @ A @ Z @ ( suc @ N2 ) )
          = ( times_times @ A @ ( plus_plus @ A @ Z @ ( semiring_1_of_nat @ A @ N2 ) ) @ ( comm_s3205402744901411588hammer @ A @ Z @ N2 ) ) ) ) ).

% pochhammer_rec'
thf(fact_2673_pochhammer__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: A,N2: nat] :
          ( ( ( comm_s3205402744901411588hammer @ A @ A2 @ N2 )
            = ( zero_zero @ A ) )
          = ( ? [K3: nat] :
                ( ( ord_less @ nat @ K3 @ N2 )
                & ( A2
                  = ( uminus_uminus @ A @ ( semiring_1_of_nat @ A @ K3 ) ) ) ) ) ) ) ).

% pochhammer_eq_0_iff
thf(fact_2674_pochhammer__of__nat__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( ( ring_char_0 @ A )
        & ( idom @ A ) )
     => ! [N2: nat,K: nat] :
          ( ( ( comm_s3205402744901411588hammer @ A @ ( uminus_uminus @ A @ ( semiring_1_of_nat @ A @ N2 ) ) @ K )
            = ( zero_zero @ A ) )
          = ( ord_less @ nat @ N2 @ K ) ) ) ).

% pochhammer_of_nat_eq_0_iff
thf(fact_2675_pochhammer__of__nat__eq__0__lemma,axiom,
    ! [A: $tType] :
      ( ( idom @ A )
     => ! [N2: nat,K: nat] :
          ( ( ord_less @ nat @ N2 @ K )
         => ( ( comm_s3205402744901411588hammer @ A @ ( uminus_uminus @ A @ ( semiring_1_of_nat @ A @ N2 ) ) @ K )
            = ( zero_zero @ A ) ) ) ) ).

% pochhammer_of_nat_eq_0_lemma
thf(fact_2676_pochhammer__of__nat__eq__0__lemma_H,axiom,
    ! [A: $tType] :
      ( ( ( ring_char_0 @ A )
        & ( idom @ A ) )
     => ! [K: nat,N2: nat] :
          ( ( ord_less_eq @ nat @ K @ N2 )
         => ( ( comm_s3205402744901411588hammer @ A @ ( uminus_uminus @ A @ ( semiring_1_of_nat @ A @ N2 ) ) @ K )
           != ( zero_zero @ A ) ) ) ) ).

% pochhammer_of_nat_eq_0_lemma'
thf(fact_2677_pochhammer__product_H,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [Z: A,N2: nat,M: nat] :
          ( ( comm_s3205402744901411588hammer @ A @ Z @ ( plus_plus @ nat @ N2 @ M ) )
          = ( times_times @ A @ ( comm_s3205402744901411588hammer @ A @ Z @ N2 ) @ ( comm_s3205402744901411588hammer @ A @ ( plus_plus @ A @ Z @ ( semiring_1_of_nat @ A @ N2 ) ) @ M ) ) ) ) ).

% pochhammer_product'
thf(fact_2678_pochhammer__code,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ( ( comm_s3205402744901411588hammer @ A )
        = ( ^ [A4: A,N3: nat] :
              ( if @ A
              @ ( N3
                = ( zero_zero @ nat ) )
              @ ( one_one @ A )
              @ ( set_fo6178422350223883121st_nat @ A
                @ ^ [O: nat] : ( times_times @ A @ ( plus_plus @ A @ A4 @ ( semiring_1_of_nat @ A @ O ) ) )
                @ ( zero_zero @ nat )
                @ ( minus_minus @ nat @ N3 @ ( one_one @ nat ) )
                @ ( one_one @ A ) ) ) ) ) ) ).

% pochhammer_code
thf(fact_2679_fold__atLeastAtMost__nat_Osimps,axiom,
    ! [A: $tType] :
      ( ( set_fo6178422350223883121st_nat @ A )
      = ( ^ [F5: nat > A > A,A4: nat,B4: nat,Acc3: A] : ( if @ A @ ( ord_less @ nat @ B4 @ A4 ) @ Acc3 @ ( set_fo6178422350223883121st_nat @ A @ F5 @ ( plus_plus @ nat @ A4 @ ( one_one @ nat ) ) @ B4 @ ( F5 @ A4 @ Acc3 ) ) ) ) ) ).

% fold_atLeastAtMost_nat.simps
thf(fact_2680_fold__atLeastAtMost__nat_Oelims,axiom,
    ! [A: $tType,X2: nat > A > A,Xa2: nat,Xb3: nat,Xc: A,Y2: A] :
      ( ( ( set_fo6178422350223883121st_nat @ A @ X2 @ Xa2 @ Xb3 @ Xc )
        = Y2 )
     => ( ( ( ord_less @ nat @ Xb3 @ Xa2 )
         => ( Y2 = Xc ) )
        & ( ~ ( ord_less @ nat @ Xb3 @ Xa2 )
         => ( Y2
            = ( set_fo6178422350223883121st_nat @ A @ X2 @ ( plus_plus @ nat @ Xa2 @ ( one_one @ nat ) ) @ Xb3 @ ( X2 @ Xa2 @ Xc ) ) ) ) ) ) ).

% fold_atLeastAtMost_nat.elims
thf(fact_2681_pochhammer__product,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [M: nat,N2: nat,Z: A] :
          ( ( ord_less_eq @ nat @ M @ N2 )
         => ( ( comm_s3205402744901411588hammer @ A @ Z @ N2 )
            = ( times_times @ A @ ( comm_s3205402744901411588hammer @ A @ Z @ M ) @ ( comm_s3205402744901411588hammer @ A @ ( plus_plus @ A @ Z @ ( semiring_1_of_nat @ A @ M ) ) @ ( minus_minus @ nat @ N2 @ M ) ) ) ) ) ) ).

% pochhammer_product
thf(fact_2682_bit__nat__def,axiom,
    ( ( bit_se5641148757651400278ts_bit @ nat )
    = ( ^ [M6: nat,N3: nat] :
          ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( divide_divide @ nat @ M6 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N3 ) ) ) ) ) ).

% bit_nat_def
thf(fact_2683_pochhammer__absorb__comp,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [R3: A,K: nat] :
          ( ( times_times @ A @ ( minus_minus @ A @ R3 @ ( semiring_1_of_nat @ A @ K ) ) @ ( comm_s3205402744901411588hammer @ A @ ( uminus_uminus @ A @ R3 ) @ K ) )
          = ( times_times @ A @ R3 @ ( comm_s3205402744901411588hammer @ A @ ( plus_plus @ A @ ( uminus_uminus @ A @ R3 ) @ ( one_one @ A ) ) @ K ) ) ) ) ).

% pochhammer_absorb_comp
thf(fact_2684_sum__atLeastAtMost__code,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [F2: nat > A,A2: nat,B2: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_or1337092689740270186AtMost @ nat @ A2 @ B2 ) )
          = ( set_fo6178422350223883121st_nat @ A
            @ ^ [A4: nat] : ( plus_plus @ A @ ( F2 @ A4 ) )
            @ A2
            @ B2
            @ ( zero_zero @ A ) ) ) ) ).

% sum_atLeastAtMost_code
thf(fact_2685_pochhammer__minus_H,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [B2: A,K: nat] :
          ( ( comm_s3205402744901411588hammer @ A @ ( plus_plus @ A @ ( minus_minus @ A @ B2 @ ( semiring_1_of_nat @ A @ K ) ) @ ( one_one @ A ) ) @ K )
          = ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ K ) @ ( comm_s3205402744901411588hammer @ A @ ( uminus_uminus @ A @ B2 ) @ K ) ) ) ) ).

% pochhammer_minus'
thf(fact_2686_pochhammer__minus,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [B2: A,K: nat] :
          ( ( comm_s3205402744901411588hammer @ A @ ( uminus_uminus @ A @ B2 ) @ K )
          = ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ K ) @ ( comm_s3205402744901411588hammer @ A @ ( plus_plus @ A @ ( minus_minus @ A @ B2 @ ( semiring_1_of_nat @ A @ K ) ) @ ( one_one @ A ) ) @ K ) ) ) ) ).

% pochhammer_minus
thf(fact_2687_norm__divide__numeral,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [A2: A,W: num] :
          ( ( real_V7770717601297561774m_norm @ A @ ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ W ) ) )
          = ( divide_divide @ real @ ( real_V7770717601297561774m_norm @ A @ A2 ) @ ( numeral_numeral @ real @ W ) ) ) ) ).

% norm_divide_numeral
thf(fact_2688_norm__mult__numeral2,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [A2: A,W: num] :
          ( ( real_V7770717601297561774m_norm @ A @ ( times_times @ A @ A2 @ ( numeral_numeral @ A @ W ) ) )
          = ( times_times @ real @ ( real_V7770717601297561774m_norm @ A @ A2 ) @ ( numeral_numeral @ real @ W ) ) ) ) ).

% norm_mult_numeral2
thf(fact_2689_norm__mult__numeral1,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [W: num,A2: A] :
          ( ( real_V7770717601297561774m_norm @ A @ ( times_times @ A @ ( numeral_numeral @ A @ W ) @ A2 ) )
          = ( times_times @ real @ ( numeral_numeral @ real @ W ) @ ( real_V7770717601297561774m_norm @ A @ A2 ) ) ) ) ).

% norm_mult_numeral1
thf(fact_2690_norm__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( real_V2822296259951069270ebra_1 @ A )
     => ! [W: num] :
          ( ( real_V7770717601297561774m_norm @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) )
          = ( numeral_numeral @ real @ W ) ) ) ).

% norm_neg_numeral
thf(fact_2691_norm__le__zero__iff,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X2: A] :
          ( ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ X2 ) @ ( zero_zero @ real ) )
          = ( X2
            = ( zero_zero @ A ) ) ) ) ).

% norm_le_zero_iff
thf(fact_2692_zero__less__norm__iff,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X2: A] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ ( real_V7770717601297561774m_norm @ A @ X2 ) )
          = ( ( X2
             != ( zero_zero @ A ) ) ) ) ) ).

% zero_less_norm_iff
thf(fact_2693_norm__zero,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ( ( real_V7770717601297561774m_norm @ A @ ( zero_zero @ A ) )
        = ( zero_zero @ real ) ) ) ).

% norm_zero
thf(fact_2694_norm__eq__zero,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X2: A] :
          ( ( ( real_V7770717601297561774m_norm @ A @ X2 )
            = ( zero_zero @ real ) )
          = ( X2
            = ( zero_zero @ A ) ) ) ) ).

% norm_eq_zero
thf(fact_2695_norm__one,axiom,
    ! [A: $tType] :
      ( ( real_V2822296259951069270ebra_1 @ A )
     => ( ( real_V7770717601297561774m_norm @ A @ ( one_one @ A ) )
        = ( one_one @ real ) ) ) ).

% norm_one
thf(fact_2696_norm__numeral,axiom,
    ! [A: $tType] :
      ( ( real_V2822296259951069270ebra_1 @ A )
     => ! [W: num] :
          ( ( real_V7770717601297561774m_norm @ A @ ( numeral_numeral @ A @ W ) )
          = ( numeral_numeral @ real @ W ) ) ) ).

% norm_numeral
thf(fact_2697_norm__not__less__zero,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X2: A] :
          ~ ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ X2 ) @ ( zero_zero @ real ) ) ) ).

% norm_not_less_zero
thf(fact_2698_norm__ge__zero,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X2: A] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( real_V7770717601297561774m_norm @ A @ X2 ) ) ) ).

% norm_ge_zero
thf(fact_2699_norm__mult,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [X2: A,Y2: A] :
          ( ( real_V7770717601297561774m_norm @ A @ ( times_times @ A @ X2 @ Y2 ) )
          = ( times_times @ real @ ( real_V7770717601297561774m_norm @ A @ X2 ) @ ( real_V7770717601297561774m_norm @ A @ Y2 ) ) ) ) ).

% norm_mult
thf(fact_2700_sum__norm__le,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [S3: set @ B,F2: B > A,G: B > real] :
          ( ! [X3: B] :
              ( ( member @ B @ X3 @ S3 )
             => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( F2 @ X3 ) ) @ ( G @ X3 ) ) )
         => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ S3 ) ) @ ( groups7311177749621191930dd_sum @ B @ real @ G @ S3 ) ) ) ) ).

% sum_norm_le
thf(fact_2701_norm__divide,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [A2: A,B2: A] :
          ( ( real_V7770717601297561774m_norm @ A @ ( divide_divide @ A @ A2 @ B2 ) )
          = ( divide_divide @ real @ ( real_V7770717601297561774m_norm @ A @ A2 ) @ ( real_V7770717601297561774m_norm @ A @ B2 ) ) ) ) ).

% norm_divide
thf(fact_2702_norm__power,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [X2: A,N2: nat] :
          ( ( real_V7770717601297561774m_norm @ A @ ( power_power @ A @ X2 @ N2 ) )
          = ( power_power @ real @ ( real_V7770717601297561774m_norm @ A @ X2 ) @ N2 ) ) ) ).

% norm_power
thf(fact_2703_norm__sum,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: B > A,A3: set @ B] :
          ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ A3 ) )
          @ ( groups7311177749621191930dd_sum @ B @ real
            @ ^ [I4: B] : ( real_V7770717601297561774m_norm @ A @ ( F2 @ I4 ) )
            @ A3 ) ) ) ).

% norm_sum
thf(fact_2704_norm__uminus__minus,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X2: A,Y2: A] :
          ( ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ ( uminus_uminus @ A @ X2 ) @ Y2 ) )
          = ( real_V7770717601297561774m_norm @ A @ ( plus_plus @ A @ X2 @ Y2 ) ) ) ) ).

% norm_uminus_minus
thf(fact_2705_nonzero__norm__divide,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [B2: A,A2: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( real_V7770717601297561774m_norm @ A @ ( divide_divide @ A @ A2 @ B2 ) )
            = ( divide_divide @ real @ ( real_V7770717601297561774m_norm @ A @ A2 ) @ ( real_V7770717601297561774m_norm @ A @ B2 ) ) ) ) ) ).

% nonzero_norm_divide
thf(fact_2706_power__eq__imp__eq__norm,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [W: A,N2: nat,Z: A] :
          ( ( ( power_power @ A @ W @ N2 )
            = ( power_power @ A @ Z @ N2 ) )
         => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
           => ( ( real_V7770717601297561774m_norm @ A @ W )
              = ( real_V7770717601297561774m_norm @ A @ Z ) ) ) ) ) ).

% power_eq_imp_eq_norm
thf(fact_2707_norm__mult__less,axiom,
    ! [A: $tType] :
      ( ( real_V4412858255891104859lgebra @ A )
     => ! [X2: A,R3: real,Y2: A,S2: real] :
          ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ X2 ) @ R3 )
         => ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ Y2 ) @ S2 )
           => ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( times_times @ A @ X2 @ Y2 ) ) @ ( times_times @ real @ R3 @ S2 ) ) ) ) ) ).

% norm_mult_less
thf(fact_2708_norm__mult__ineq,axiom,
    ! [A: $tType] :
      ( ( real_V4412858255891104859lgebra @ A )
     => ! [X2: A,Y2: A] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( times_times @ A @ X2 @ Y2 ) ) @ ( times_times @ real @ ( real_V7770717601297561774m_norm @ A @ X2 ) @ ( real_V7770717601297561774m_norm @ A @ Y2 ) ) ) ) ).

% norm_mult_ineq
thf(fact_2709_norm__add__less,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X2: A,R3: real,Y2: A,S2: real] :
          ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ X2 ) @ R3 )
         => ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ Y2 ) @ S2 )
           => ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( plus_plus @ A @ X2 @ Y2 ) ) @ ( plus_plus @ real @ R3 @ S2 ) ) ) ) ) ).

% norm_add_less
thf(fact_2710_norm__triangle__lt,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X2: A,Y2: A,E2: real] :
          ( ( ord_less @ real @ ( plus_plus @ real @ ( real_V7770717601297561774m_norm @ A @ X2 ) @ ( real_V7770717601297561774m_norm @ A @ Y2 ) ) @ E2 )
         => ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( plus_plus @ A @ X2 @ Y2 ) ) @ E2 ) ) ) ).

% norm_triangle_lt
thf(fact_2711_norm__triangle__mono,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [A2: A,R3: real,B2: A,S2: real] :
          ( ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ A2 ) @ R3 )
         => ( ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ B2 ) @ S2 )
           => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( plus_plus @ A @ A2 @ B2 ) ) @ ( plus_plus @ real @ R3 @ S2 ) ) ) ) ) ).

% norm_triangle_mono
thf(fact_2712_norm__triangle__ineq,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X2: A,Y2: A] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( plus_plus @ A @ X2 @ Y2 ) ) @ ( plus_plus @ real @ ( real_V7770717601297561774m_norm @ A @ X2 ) @ ( real_V7770717601297561774m_norm @ A @ Y2 ) ) ) ) ).

% norm_triangle_ineq
thf(fact_2713_norm__triangle__le,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X2: A,Y2: A,E2: real] :
          ( ( ord_less_eq @ real @ ( plus_plus @ real @ ( real_V7770717601297561774m_norm @ A @ X2 ) @ ( real_V7770717601297561774m_norm @ A @ Y2 ) ) @ E2 )
         => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( plus_plus @ A @ X2 @ Y2 ) ) @ E2 ) ) ) ).

% norm_triangle_le
thf(fact_2714_norm__add__leD,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [A2: A,B2: A,C2: real] :
          ( ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( plus_plus @ A @ A2 @ B2 ) ) @ C2 )
         => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ B2 ) @ ( plus_plus @ real @ ( real_V7770717601297561774m_norm @ A @ A2 ) @ C2 ) ) ) ) ).

% norm_add_leD
thf(fact_2715_norm__power__ineq,axiom,
    ! [A: $tType] :
      ( ( real_V2822296259951069270ebra_1 @ A )
     => ! [X2: A,N2: nat] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( power_power @ A @ X2 @ N2 ) ) @ ( power_power @ real @ ( real_V7770717601297561774m_norm @ A @ X2 ) @ N2 ) ) ) ).

% norm_power_ineq
thf(fact_2716_norm__diff__triangle__less,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X2: A,Y2: A,E1: real,Z: A,E22: real] :
          ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ X2 @ Y2 ) ) @ E1 )
         => ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ Y2 @ Z ) ) @ E22 )
           => ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ X2 @ Z ) ) @ ( plus_plus @ real @ E1 @ E22 ) ) ) ) ) ).

% norm_diff_triangle_less
thf(fact_2717_norm__triangle__le__diff,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X2: A,Y2: A,E2: real] :
          ( ( ord_less_eq @ real @ ( plus_plus @ real @ ( real_V7770717601297561774m_norm @ A @ X2 ) @ ( real_V7770717601297561774m_norm @ A @ Y2 ) ) @ E2 )
         => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ X2 @ Y2 ) ) @ E2 ) ) ) ).

% norm_triangle_le_diff
thf(fact_2718_norm__diff__triangle__le,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X2: A,Y2: A,E1: real,Z: A,E22: real] :
          ( ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ X2 @ Y2 ) ) @ E1 )
         => ( ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ Y2 @ Z ) ) @ E22 )
           => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ X2 @ Z ) ) @ ( plus_plus @ real @ E1 @ E22 ) ) ) ) ) ).

% norm_diff_triangle_le
thf(fact_2719_norm__triangle__ineq4,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [A2: A,B2: A] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ A2 @ B2 ) ) @ ( plus_plus @ real @ ( real_V7770717601297561774m_norm @ A @ A2 ) @ ( real_V7770717601297561774m_norm @ A @ B2 ) ) ) ) ).

% norm_triangle_ineq4
thf(fact_2720_norm__triangle__sub,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X2: A,Y2: A] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ X2 ) @ ( plus_plus @ real @ ( real_V7770717601297561774m_norm @ A @ Y2 ) @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ X2 @ Y2 ) ) ) ) ) ).

% norm_triangle_sub
thf(fact_2721_norm__diff__ineq,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [A2: A,B2: A] : ( ord_less_eq @ real @ ( minus_minus @ real @ ( real_V7770717601297561774m_norm @ A @ A2 ) @ ( real_V7770717601297561774m_norm @ A @ B2 ) ) @ ( real_V7770717601297561774m_norm @ A @ ( plus_plus @ A @ A2 @ B2 ) ) ) ) ).

% norm_diff_ineq
thf(fact_2722_norm__triangle__ineq2,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [A2: A,B2: A] : ( ord_less_eq @ real @ ( minus_minus @ real @ ( real_V7770717601297561774m_norm @ A @ A2 ) @ ( real_V7770717601297561774m_norm @ A @ B2 ) ) @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ A2 @ B2 ) ) ) ) ).

% norm_triangle_ineq2
thf(fact_2723_power__eq__1__iff,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [W: A,N2: nat] :
          ( ( ( power_power @ A @ W @ N2 )
            = ( one_one @ A ) )
         => ( ( ( real_V7770717601297561774m_norm @ A @ W )
              = ( one_one @ real ) )
            | ( N2
              = ( zero_zero @ nat ) ) ) ) ) ).

% power_eq_1_iff
thf(fact_2724_norm__diff__triangle__ineq,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ ( plus_plus @ A @ A2 @ B2 ) @ ( plus_plus @ A @ C2 @ D2 ) ) ) @ ( plus_plus @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ A2 @ C2 ) ) @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ B2 @ D2 ) ) ) ) ) ).

% norm_diff_triangle_ineq
thf(fact_2725_square__norm__one,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [X2: A] :
          ( ( ( power_power @ A @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
            = ( one_one @ A ) )
         => ( ( real_V7770717601297561774m_norm @ A @ X2 )
            = ( one_one @ real ) ) ) ) ).

% square_norm_one
thf(fact_2726_norm__power__diff,axiom,
    ! [A: $tType] :
      ( ( ( comm_monoid_mult @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [Z: A,W: A,M: nat] :
          ( ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ Z ) @ ( one_one @ real ) )
         => ( ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ W ) @ ( one_one @ real ) )
           => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ ( power_power @ A @ Z @ M ) @ ( power_power @ A @ W @ M ) ) ) @ ( times_times @ real @ ( semiring_1_of_nat @ real @ M ) @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ Z @ W ) ) ) ) ) ) ) ).

% norm_power_diff
thf(fact_2727_arcosh__1,axiom,
    ! [A: $tType] :
      ( ( ln @ A )
     => ( ( arcosh @ A @ ( one_one @ A ) )
        = ( zero_zero @ A ) ) ) ).

% arcosh_1
thf(fact_2728_pochhammer__times__pochhammer__half,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [Z: A,N2: nat] :
          ( ( times_times @ A @ ( comm_s3205402744901411588hammer @ A @ Z @ ( suc @ N2 ) ) @ ( comm_s3205402744901411588hammer @ A @ ( plus_plus @ A @ Z @ ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) @ ( suc @ N2 ) ) )
          = ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [K3: nat] : ( plus_plus @ A @ Z @ ( divide_divide @ A @ ( semiring_1_of_nat @ A @ K3 ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) )
            @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ ( plus_plus @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) @ ( one_one @ nat ) ) ) ) ) ) ).

% pochhammer_times_pochhammer_half
thf(fact_2729_lemma__termdiff2,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [H2: A,Z: A,N2: nat] :
          ( ( H2
           != ( zero_zero @ A ) )
         => ( ( minus_minus @ A @ ( divide_divide @ A @ ( minus_minus @ A @ ( power_power @ A @ ( plus_plus @ A @ Z @ H2 ) @ N2 ) @ ( power_power @ A @ Z @ N2 ) ) @ H2 ) @ ( times_times @ A @ ( semiring_1_of_nat @ A @ N2 ) @ ( power_power @ A @ Z @ ( minus_minus @ nat @ N2 @ ( suc @ ( zero_zero @ nat ) ) ) ) ) )
            = ( times_times @ A @ H2
              @ ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [P6: nat] :
                    ( groups7311177749621191930dd_sum @ nat @ A
                    @ ^ [Q4: nat] : ( times_times @ A @ ( power_power @ A @ ( plus_plus @ A @ Z @ H2 ) @ Q4 ) @ ( power_power @ A @ Z @ ( minus_minus @ nat @ ( minus_minus @ nat @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ Q4 ) ) )
                    @ ( set_ord_lessThan @ nat @ ( minus_minus @ nat @ ( minus_minus @ nat @ N2 @ ( suc @ ( zero_zero @ nat ) ) ) @ P6 ) ) )
                @ ( set_ord_lessThan @ nat @ ( minus_minus @ nat @ N2 @ ( suc @ ( zero_zero @ nat ) ) ) ) ) ) ) ) ) ).

% lemma_termdiff2
thf(fact_2730_arsinh__0,axiom,
    ! [A: $tType] :
      ( ( ln @ A )
     => ( ( arsinh @ A @ ( zero_zero @ A ) )
        = ( zero_zero @ A ) ) ) ).

% arsinh_0
thf(fact_2731_artanh__0,axiom,
    ! [A: $tType] :
      ( ( ( real_V3459762299906320749_field @ A )
        & ( ln @ A ) )
     => ( ( artanh @ A @ ( zero_zero @ A ) )
        = ( zero_zero @ A ) ) ) ).

% artanh_0
thf(fact_2732_geometric__deriv__sums,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [Z: A] :
          ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ Z ) @ ( one_one @ real ) )
         => ( sums @ A
            @ ^ [N3: nat] : ( times_times @ A @ ( semiring_1_of_nat @ A @ ( suc @ N3 ) ) @ ( power_power @ A @ Z @ N3 ) )
            @ ( divide_divide @ A @ ( one_one @ A ) @ ( power_power @ A @ ( minus_minus @ A @ ( one_one @ A ) @ Z ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% geometric_deriv_sums
thf(fact_2733_lessThan__iff,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [I3: A,K: A] :
          ( ( member @ A @ I3 @ ( set_ord_lessThan @ A @ K ) )
          = ( ord_less @ A @ I3 @ K ) ) ) ).

% lessThan_iff
thf(fact_2734_prod_Oneutral__const,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A3: set @ B] :
          ( ( groups7121269368397514597t_prod @ B @ A
            @ ^ [Uu3: B] : ( one_one @ A )
            @ A3 )
          = ( one_one @ A ) ) ) ).

% prod.neutral_const
thf(fact_2735_lessThan__subset__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X2: A,Y2: A] :
          ( ( ord_less_eq @ ( set @ A ) @ ( set_ord_lessThan @ A @ X2 ) @ ( set_ord_lessThan @ A @ Y2 ) )
          = ( ord_less_eq @ A @ X2 @ Y2 ) ) ) ).

% lessThan_subset_iff
thf(fact_2736_sum_OlessThan__Suc,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,N2: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_ord_lessThan @ nat @ ( suc @ N2 ) ) )
          = ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_ord_lessThan @ nat @ N2 ) ) @ ( G @ N2 ) ) ) ) ).

% sum.lessThan_Suc
thf(fact_2737_prod_OlessThan__Suc,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,N2: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_ord_lessThan @ nat @ ( suc @ N2 ) ) )
          = ( times_times @ A @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_ord_lessThan @ nat @ N2 ) ) @ ( G @ N2 ) ) ) ) ).

% prod.lessThan_Suc
thf(fact_2738_powser__sums__zero__iff,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [A2: nat > A,X2: A] :
          ( ( sums @ A
            @ ^ [N3: nat] : ( times_times @ A @ ( A2 @ N3 ) @ ( power_power @ A @ ( zero_zero @ A ) @ N3 ) )
            @ X2 )
          = ( ( A2 @ ( zero_zero @ nat ) )
            = X2 ) ) ) ).

% powser_sums_zero_iff
thf(fact_2739_prod_Ocl__ivl__Suc,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [N2: nat,M: nat,G: nat > A] :
          ( ( ( ord_less @ nat @ ( suc @ N2 ) @ M )
           => ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ ( suc @ N2 ) ) )
              = ( one_one @ A ) ) )
          & ( ~ ( ord_less @ nat @ ( suc @ N2 ) @ M )
           => ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ ( suc @ N2 ) ) )
              = ( times_times @ A @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ N2 ) ) @ ( G @ ( suc @ N2 ) ) ) ) ) ) ) ).

% prod.cl_ivl_Suc
thf(fact_2740_prod_Oneutral,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A3: set @ B,G: B > A] :
          ( ! [X3: B] :
              ( ( member @ B @ X3 @ A3 )
             => ( ( G @ X3 )
                = ( one_one @ A ) ) )
         => ( ( groups7121269368397514597t_prod @ B @ A @ G @ A3 )
            = ( one_one @ A ) ) ) ) ).

% prod.neutral
thf(fact_2741_prod_Onot__neutral__contains__not__neutral,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: B > A,A3: set @ B] :
          ( ( ( groups7121269368397514597t_prod @ B @ A @ G @ A3 )
           != ( one_one @ A ) )
         => ~ ! [A5: B] :
                ( ( member @ B @ A5 @ A3 )
               => ( ( G @ A5 )
                  = ( one_one @ A ) ) ) ) ) ).

% prod.not_neutral_contains_not_neutral
thf(fact_2742_norm__prod__le,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( comm_monoid_mult @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [F2: B > A,A3: set @ B] :
          ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( groups7121269368397514597t_prod @ B @ A @ F2 @ A3 ) )
          @ ( groups7121269368397514597t_prod @ B @ real
            @ ^ [A4: B] : ( real_V7770717601297561774m_norm @ A @ ( F2 @ A4 ) )
            @ A3 ) ) ) ).

% norm_prod_le
thf(fact_2743_prod_Onat__diff__reindex,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,N2: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [I4: nat] : ( G @ ( minus_minus @ nat @ N2 @ ( suc @ I4 ) ) )
            @ ( set_ord_lessThan @ nat @ N2 ) )
          = ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_ord_lessThan @ nat @ N2 ) ) ) ) ).

% prod.nat_diff_reindex
thf(fact_2744_prod_Odistrib,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: B > A,H2: B > A,A3: set @ B] :
          ( ( groups7121269368397514597t_prod @ B @ A
            @ ^ [X5: B] : ( times_times @ A @ ( G @ X5 ) @ ( H2 @ X5 ) )
            @ A3 )
          = ( times_times @ A @ ( groups7121269368397514597t_prod @ B @ A @ G @ A3 ) @ ( groups7121269368397514597t_prod @ B @ A @ H2 @ A3 ) ) ) ) ).

% prod.distrib
thf(fact_2745_prod__dividef,axiom,
    ! [A: $tType,B: $tType] :
      ( ( field @ A )
     => ! [F2: B > A,G: B > A,A3: set @ B] :
          ( ( groups7121269368397514597t_prod @ B @ A
            @ ^ [X5: B] : ( divide_divide @ A @ ( F2 @ X5 ) @ ( G @ X5 ) )
            @ A3 )
          = ( divide_divide @ A @ ( groups7121269368397514597t_prod @ B @ A @ F2 @ A3 ) @ ( groups7121269368397514597t_prod @ B @ A @ G @ A3 ) ) ) ) ).

% prod_dividef
thf(fact_2746_prod__power__distrib,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comm_semiring_1 @ B )
     => ! [F2: A > B,A3: set @ A,N2: nat] :
          ( ( power_power @ B @ ( groups7121269368397514597t_prod @ A @ B @ F2 @ A3 ) @ N2 )
          = ( groups7121269368397514597t_prod @ A @ B
            @ ^ [X5: A] : ( power_power @ B @ ( F2 @ X5 ) @ N2 )
            @ A3 ) ) ) ).

% prod_power_distrib
thf(fact_2747_mod__prod__eq,axiom,
    ! [B: $tType,A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [F2: B > A,A2: A,A3: set @ B] :
          ( ( modulo_modulo @ A
            @ ( groups7121269368397514597t_prod @ B @ A
              @ ^ [I4: B] : ( modulo_modulo @ A @ ( F2 @ I4 ) @ A2 )
              @ A3 )
            @ A2 )
          = ( modulo_modulo @ A @ ( groups7121269368397514597t_prod @ B @ A @ F2 @ A3 ) @ A2 ) ) ) ).

% mod_prod_eq
thf(fact_2748_lessThan__def,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ( ( set_ord_lessThan @ A )
        = ( ^ [U2: A] :
              ( collect @ A
              @ ^ [X5: A] : ( ord_less @ A @ X5 @ U2 ) ) ) ) ) ).

% lessThan_def
thf(fact_2749_prod_OlessThan__Suc__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,N2: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_ord_lessThan @ nat @ ( suc @ N2 ) ) )
          = ( times_times @ A @ ( G @ ( zero_zero @ nat ) )
            @ ( groups7121269368397514597t_prod @ nat @ A
              @ ^ [I4: nat] : ( G @ ( suc @ I4 ) )
              @ ( set_ord_lessThan @ nat @ N2 ) ) ) ) ) ).

% prod.lessThan_Suc_shift
thf(fact_2750_prod_OatLeast1__atMost__eq,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,N2: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ ( zero_zero @ nat ) ) @ N2 ) )
          = ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [K3: nat] : ( G @ ( suc @ K3 ) )
            @ ( set_ord_lessThan @ nat @ N2 ) ) ) ) ).

% prod.atLeast1_atMost_eq
thf(fact_2751_prod__nonneg,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A3: set @ B,F2: B > A] :
          ( ! [X3: B] :
              ( ( member @ B @ X3 @ A3 )
             => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( F2 @ X3 ) ) )
         => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( groups7121269368397514597t_prod @ B @ A @ F2 @ A3 ) ) ) ) ).

% prod_nonneg
thf(fact_2752_prod__mono,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A3: set @ B,F2: B > A,G: B > A] :
          ( ! [I2: B] :
              ( ( member @ B @ I2 @ A3 )
             => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( F2 @ I2 ) )
                & ( ord_less_eq @ A @ ( F2 @ I2 ) @ ( G @ I2 ) ) ) )
         => ( ord_less_eq @ A @ ( groups7121269368397514597t_prod @ B @ A @ F2 @ A3 ) @ ( groups7121269368397514597t_prod @ B @ A @ G @ A3 ) ) ) ) ).

% prod_mono
thf(fact_2753_prod__pos,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A3: set @ B,F2: B > A] :
          ( ! [X3: B] :
              ( ( member @ B @ X3 @ A3 )
             => ( ord_less @ A @ ( zero_zero @ A ) @ ( F2 @ X3 ) ) )
         => ( ord_less @ A @ ( zero_zero @ A ) @ ( groups7121269368397514597t_prod @ B @ A @ F2 @ A3 ) ) ) ) ).

% prod_pos
thf(fact_2754_prod__ge__1,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [A3: set @ B,F2: B > A] :
          ( ! [X3: B] :
              ( ( member @ B @ X3 @ A3 )
             => ( ord_less_eq @ A @ ( one_one @ A ) @ ( F2 @ X3 ) ) )
         => ( ord_less_eq @ A @ ( one_one @ A ) @ ( groups7121269368397514597t_prod @ B @ A @ F2 @ A3 ) ) ) ) ).

% prod_ge_1
thf(fact_2755_lessThan__strict__subset__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [M: A,N2: A] :
          ( ( ord_less @ ( set @ A ) @ ( set_ord_lessThan @ A @ M ) @ ( set_ord_lessThan @ A @ N2 ) )
          = ( ord_less @ A @ M @ N2 ) ) ) ).

% lessThan_strict_subset_iff
thf(fact_2756_prod_Oshift__bounds__cl__Suc__ivl,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,M: nat,N2: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ M ) @ ( suc @ N2 ) ) )
          = ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [I4: nat] : ( G @ ( suc @ I4 ) )
            @ ( set_or1337092689740270186AtMost @ nat @ M @ N2 ) ) ) ) ).

% prod.shift_bounds_cl_Suc_ivl
thf(fact_2757_power__sum,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [C2: A,F2: B > nat,A3: set @ B] :
          ( ( power_power @ A @ C2 @ ( groups7311177749621191930dd_sum @ B @ nat @ F2 @ A3 ) )
          = ( groups7121269368397514597t_prod @ B @ A
            @ ^ [A4: B] : ( power_power @ A @ C2 @ ( F2 @ A4 ) )
            @ A3 ) ) ) ).

% power_sum
thf(fact_2758_prod_Oshift__bounds__cl__nat__ivl,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,M: nat,K: nat,N2: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( plus_plus @ nat @ M @ K ) @ ( plus_plus @ nat @ N2 @ K ) ) )
          = ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [I4: nat] : ( G @ ( plus_plus @ nat @ I4 @ K ) )
            @ ( set_or1337092689740270186AtMost @ nat @ M @ N2 ) ) ) ) ).

% prod.shift_bounds_cl_nat_ivl
thf(fact_2759_prod__le__1,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [A3: set @ B,F2: B > A] :
          ( ! [X3: B] :
              ( ( member @ B @ X3 @ A3 )
             => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( F2 @ X3 ) )
                & ( ord_less_eq @ A @ ( F2 @ X3 ) @ ( one_one @ A ) ) ) )
         => ( ord_less_eq @ A @ ( groups7121269368397514597t_prod @ B @ A @ F2 @ A3 ) @ ( one_one @ A ) ) ) ) ).

% prod_le_1
thf(fact_2760_prod_OatLeastAtMost__rev,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,N2: nat,M: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ N2 @ M ) )
          = ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [I4: nat] : ( G @ ( minus_minus @ nat @ ( plus_plus @ nat @ M @ N2 ) @ I4 ) )
            @ ( set_or1337092689740270186AtMost @ nat @ N2 @ M ) ) ) ) ).

% prod.atLeastAtMost_rev
thf(fact_2761_sum_Onat__diff__reindex,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,N2: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [I4: nat] : ( G @ ( minus_minus @ nat @ N2 @ ( suc @ I4 ) ) )
            @ ( set_ord_lessThan @ nat @ N2 ) )
          = ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_ord_lessThan @ nat @ N2 ) ) ) ) ).

% sum.nat_diff_reindex
thf(fact_2762_sum__diff__distrib,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [Q: A > nat,P: A > nat,N2: A] :
          ( ! [X3: A] : ( ord_less_eq @ nat @ ( Q @ X3 ) @ ( P @ X3 ) )
         => ( ( minus_minus @ nat @ ( groups7311177749621191930dd_sum @ A @ nat @ P @ ( set_ord_lessThan @ A @ N2 ) ) @ ( groups7311177749621191930dd_sum @ A @ nat @ Q @ ( set_ord_lessThan @ A @ N2 ) ) )
            = ( groups7311177749621191930dd_sum @ A @ nat
              @ ^ [X5: A] : ( minus_minus @ nat @ ( P @ X5 ) @ ( Q @ X5 ) )
              @ ( set_ord_lessThan @ A @ N2 ) ) ) ) ) ).

% sum_diff_distrib
thf(fact_2763_prod_OatLeast0__atMost__Suc,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,N2: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ ( suc @ N2 ) ) )
          = ( times_times @ A @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N2 ) ) @ ( G @ ( suc @ N2 ) ) ) ) ) ).

% prod.atLeast0_atMost_Suc
thf(fact_2764_powser__sums__zero,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [A2: nat > A] :
          ( sums @ A
          @ ^ [N3: nat] : ( times_times @ A @ ( A2 @ N3 ) @ ( power_power @ A @ ( zero_zero @ A ) @ N3 ) )
          @ ( A2 @ ( zero_zero @ nat ) ) ) ) ).

% powser_sums_zero
thf(fact_2765_prod_Onat__ivl__Suc_H,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [M: nat,N2: nat,G: nat > A] :
          ( ( ord_less_eq @ nat @ M @ ( suc @ N2 ) )
         => ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ ( suc @ N2 ) ) )
            = ( times_times @ A @ ( G @ ( suc @ N2 ) ) @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ N2 ) ) ) ) ) ) ).

% prod.nat_ivl_Suc'
thf(fact_2766_prod_OatLeast__Suc__atMost,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [M: nat,N2: nat,G: nat > A] :
          ( ( ord_less_eq @ nat @ M @ N2 )
         => ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ N2 ) )
            = ( times_times @ A @ ( G @ M ) @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ M ) @ N2 ) ) ) ) ) ) ).

% prod.atLeast_Suc_atMost
thf(fact_2767_norm__prod__diff,axiom,
    ! [A: $tType,I7: $tType] :
      ( ( ( comm_monoid_mult @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [I6: set @ I7,Z: I7 > A,W: I7 > A] :
          ( ! [I2: I7] :
              ( ( member @ I7 @ I2 @ I6 )
             => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( Z @ I2 ) ) @ ( one_one @ real ) ) )
         => ( ! [I2: I7] :
                ( ( member @ I7 @ I2 @ I6 )
               => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( W @ I2 ) ) @ ( one_one @ real ) ) )
           => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ ( groups7121269368397514597t_prod @ I7 @ A @ Z @ I6 ) @ ( groups7121269368397514597t_prod @ I7 @ A @ W @ I6 ) ) )
              @ ( groups7311177749621191930dd_sum @ I7 @ real
                @ ^ [I4: I7] : ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ ( Z @ I4 ) @ ( W @ I4 ) ) )
                @ I6 ) ) ) ) ) ).

% norm_prod_diff
thf(fact_2768_prod_OSuc__reindex__ivl,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [M: nat,N2: nat,G: nat > A] :
          ( ( ord_less_eq @ nat @ M @ N2 )
         => ( ( times_times @ A @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ N2 ) ) @ ( G @ ( suc @ N2 ) ) )
            = ( times_times @ A @ ( G @ M )
              @ ( groups7121269368397514597t_prod @ nat @ A
                @ ^ [I4: nat] : ( G @ ( suc @ I4 ) )
                @ ( set_or1337092689740270186AtMost @ nat @ M @ N2 ) ) ) ) ) ) ).

% prod.Suc_reindex_ivl
thf(fact_2769_sum_OlessThan__Suc__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,N2: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_ord_lessThan @ nat @ ( suc @ N2 ) ) )
          = ( plus_plus @ A @ ( G @ ( zero_zero @ nat ) )
            @ ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [I4: nat] : ( G @ ( suc @ I4 ) )
              @ ( set_ord_lessThan @ nat @ N2 ) ) ) ) ) ).

% sum.lessThan_Suc_shift
thf(fact_2770_sumr__diff__mult__const2,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [F2: nat > A,N2: nat,R3: A] :
          ( ( minus_minus @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_ord_lessThan @ nat @ N2 ) ) @ ( times_times @ A @ ( semiring_1_of_nat @ A @ N2 ) @ R3 ) )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [I4: nat] : ( minus_minus @ A @ ( F2 @ I4 ) @ R3 )
            @ ( set_ord_lessThan @ nat @ N2 ) ) ) ) ).

% sumr_diff_mult_const2
thf(fact_2771_sum__lessThan__telescope_H,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [F2: nat > A,M: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [N3: nat] : ( minus_minus @ A @ ( F2 @ N3 ) @ ( F2 @ ( suc @ N3 ) ) )
            @ ( set_ord_lessThan @ nat @ M ) )
          = ( minus_minus @ A @ ( F2 @ ( zero_zero @ nat ) ) @ ( F2 @ M ) ) ) ) ).

% sum_lessThan_telescope'
thf(fact_2772_sum__lessThan__telescope,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [F2: nat > A,M: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [N3: nat] : ( minus_minus @ A @ ( F2 @ ( suc @ N3 ) ) @ ( F2 @ N3 ) )
            @ ( set_ord_lessThan @ nat @ M ) )
          = ( minus_minus @ A @ ( F2 @ M ) @ ( F2 @ ( zero_zero @ nat ) ) ) ) ) ).

% sum_lessThan_telescope
thf(fact_2773_sum_OatLeast1__atMost__eq,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,N2: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ ( zero_zero @ nat ) ) @ N2 ) )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [K3: nat] : ( G @ ( suc @ K3 ) )
            @ ( set_ord_lessThan @ nat @ N2 ) ) ) ) ).

% sum.atLeast1_atMost_eq
thf(fact_2774_prod__atLeastAtMost__code,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [F2: nat > A,A2: nat,B2: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ F2 @ ( set_or1337092689740270186AtMost @ nat @ A2 @ B2 ) )
          = ( set_fo6178422350223883121st_nat @ A
            @ ^ [A4: nat] : ( times_times @ A @ ( F2 @ A4 ) )
            @ A2
            @ B2
            @ ( one_one @ A ) ) ) ) ).

% prod_atLeastAtMost_code
thf(fact_2775_prod_Oub__add__nat,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [M: nat,N2: nat,G: nat > A,P4: nat] :
          ( ( ord_less_eq @ nat @ M @ ( plus_plus @ nat @ N2 @ ( one_one @ nat ) ) )
         => ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ ( plus_plus @ nat @ N2 @ P4 ) ) )
            = ( times_times @ A @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ N2 ) ) @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( plus_plus @ nat @ N2 @ ( one_one @ nat ) ) @ ( plus_plus @ nat @ N2 @ P4 ) ) ) ) ) ) ) ).

% prod.ub_add_nat
thf(fact_2776_one__diff__power__eq,axiom,
    ! [A: $tType] :
      ( ( ( monoid_mult @ A )
        & ( comm_ring @ A ) )
     => ! [X2: A,N2: nat] :
          ( ( minus_minus @ A @ ( one_one @ A ) @ ( power_power @ A @ X2 @ N2 ) )
          = ( times_times @ A @ ( minus_minus @ A @ ( one_one @ A ) @ X2 ) @ ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X2 ) @ ( set_ord_lessThan @ nat @ N2 ) ) ) ) ) ).

% one_diff_power_eq
thf(fact_2777_power__diff__1__eq,axiom,
    ! [A: $tType] :
      ( ( ( monoid_mult @ A )
        & ( comm_ring @ A ) )
     => ! [X2: A,N2: nat] :
          ( ( minus_minus @ A @ ( power_power @ A @ X2 @ N2 ) @ ( one_one @ A ) )
          = ( times_times @ A @ ( minus_minus @ A @ X2 @ ( one_one @ A ) ) @ ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X2 ) @ ( set_ord_lessThan @ nat @ N2 ) ) ) ) ) ).

% power_diff_1_eq
thf(fact_2778_geometric__sum,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [X2: A,N2: nat] :
          ( ( X2
           != ( one_one @ A ) )
         => ( ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X2 ) @ ( set_ord_lessThan @ nat @ N2 ) )
            = ( divide_divide @ A @ ( minus_minus @ A @ ( power_power @ A @ X2 @ N2 ) @ ( one_one @ A ) ) @ ( minus_minus @ A @ X2 @ ( one_one @ A ) ) ) ) ) ) ).

% geometric_sum
thf(fact_2779_pochhammer__Suc__prod,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [A2: A,N2: nat] :
          ( ( comm_s3205402744901411588hammer @ A @ A2 @ ( suc @ N2 ) )
          = ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [I4: nat] : ( plus_plus @ A @ A2 @ ( semiring_1_of_nat @ A @ I4 ) )
            @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N2 ) ) ) ) ).

% pochhammer_Suc_prod
thf(fact_2780_sum__gp__strict,axiom,
    ! [A: $tType] :
      ( ( ( division_ring @ A )
        & ( comm_ring @ A ) )
     => ! [X2: A,N2: nat] :
          ( ( ( X2
              = ( one_one @ A ) )
           => ( ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X2 ) @ ( set_ord_lessThan @ nat @ N2 ) )
              = ( semiring_1_of_nat @ A @ N2 ) ) )
          & ( ( X2
             != ( one_one @ A ) )
           => ( ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X2 ) @ ( set_ord_lessThan @ nat @ N2 ) )
              = ( divide_divide @ A @ ( minus_minus @ A @ ( one_one @ A ) @ ( power_power @ A @ X2 @ N2 ) ) @ ( minus_minus @ A @ ( one_one @ A ) @ X2 ) ) ) ) ) ) ).

% sum_gp_strict
thf(fact_2781_lemma__termdiff1,axiom,
    ! [A: $tType] :
      ( ( ( monoid_mult @ A )
        & ( comm_ring @ A ) )
     => ! [Z: A,H2: A,M: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [P6: nat] : ( minus_minus @ A @ ( times_times @ A @ ( power_power @ A @ ( plus_plus @ A @ Z @ H2 ) @ ( minus_minus @ nat @ M @ P6 ) ) @ ( power_power @ A @ Z @ P6 ) ) @ ( power_power @ A @ Z @ M ) )
            @ ( set_ord_lessThan @ nat @ M ) )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [P6: nat] : ( times_times @ A @ ( power_power @ A @ Z @ P6 ) @ ( minus_minus @ A @ ( power_power @ A @ ( plus_plus @ A @ Z @ H2 ) @ ( minus_minus @ nat @ M @ P6 ) ) @ ( power_power @ A @ Z @ ( minus_minus @ nat @ M @ P6 ) ) ) )
            @ ( set_ord_lessThan @ nat @ M ) ) ) ) ).

% lemma_termdiff1
thf(fact_2782_power__diff__sumr2,axiom,
    ! [A: $tType] :
      ( ( ( monoid_mult @ A )
        & ( comm_ring @ A ) )
     => ! [X2: A,N2: nat,Y2: A] :
          ( ( minus_minus @ A @ ( power_power @ A @ X2 @ N2 ) @ ( power_power @ A @ Y2 @ N2 ) )
          = ( times_times @ A @ ( minus_minus @ A @ X2 @ Y2 )
            @ ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [I4: nat] : ( times_times @ A @ ( power_power @ A @ Y2 @ ( minus_minus @ nat @ N2 @ ( suc @ I4 ) ) ) @ ( power_power @ A @ X2 @ I4 ) )
              @ ( set_ord_lessThan @ nat @ N2 ) ) ) ) ) ).

% power_diff_sumr2
thf(fact_2783_diff__power__eq__sum,axiom,
    ! [A: $tType] :
      ( ( ( monoid_mult @ A )
        & ( comm_ring @ A ) )
     => ! [X2: A,N2: nat,Y2: A] :
          ( ( minus_minus @ A @ ( power_power @ A @ X2 @ ( suc @ N2 ) ) @ ( power_power @ A @ Y2 @ ( suc @ N2 ) ) )
          = ( times_times @ A @ ( minus_minus @ A @ X2 @ Y2 )
            @ ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [P6: nat] : ( times_times @ A @ ( power_power @ A @ X2 @ P6 ) @ ( power_power @ A @ Y2 @ ( minus_minus @ nat @ N2 @ P6 ) ) )
              @ ( set_ord_lessThan @ nat @ ( suc @ N2 ) ) ) ) ) ) ).

% diff_power_eq_sum
thf(fact_2784_pochhammer__prod__rev,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ( ( comm_s3205402744901411588hammer @ A )
        = ( ^ [A4: A,N3: nat] :
              ( groups7121269368397514597t_prod @ nat @ A
              @ ^ [I4: nat] : ( plus_plus @ A @ A4 @ ( semiring_1_of_nat @ A @ ( minus_minus @ nat @ N3 @ I4 ) ) )
              @ ( set_or1337092689740270186AtMost @ nat @ ( one_one @ nat ) @ N3 ) ) ) ) ) ).

% pochhammer_prod_rev
thf(fact_2785_real__sum__nat__ivl__bounded2,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [N2: nat,F2: nat > A,K5: A,K: nat] :
          ( ! [P7: nat] :
              ( ( ord_less @ nat @ P7 @ N2 )
             => ( ord_less_eq @ A @ ( F2 @ P7 ) @ K5 ) )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ K5 )
           => ( ord_less_eq @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_ord_lessThan @ nat @ ( minus_minus @ nat @ N2 @ K ) ) ) @ ( times_times @ A @ ( semiring_1_of_nat @ A @ N2 ) @ K5 ) ) ) ) ) ).

% real_sum_nat_ivl_bounded2
thf(fact_2786_prod_Oin__pairs,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,M: nat,N2: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M ) @ ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) ) )
          = ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [I4: nat] : ( times_times @ A @ ( G @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ I4 ) ) @ ( G @ ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ I4 ) ) ) )
            @ ( set_or1337092689740270186AtMost @ nat @ M @ N2 ) ) ) ) ).

% prod.in_pairs
thf(fact_2787_pochhammer__Suc__prod__rev,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [A2: A,N2: nat] :
          ( ( comm_s3205402744901411588hammer @ A @ A2 @ ( suc @ N2 ) )
          = ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [I4: nat] : ( plus_plus @ A @ A2 @ ( semiring_1_of_nat @ A @ ( minus_minus @ nat @ N2 @ I4 ) ) )
            @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N2 ) ) ) ) ).

% pochhammer_Suc_prod_rev
thf(fact_2788_one__diff__power__eq_H,axiom,
    ! [A: $tType] :
      ( ( ( monoid_mult @ A )
        & ( comm_ring @ A ) )
     => ! [X2: A,N2: nat] :
          ( ( minus_minus @ A @ ( one_one @ A ) @ ( power_power @ A @ X2 @ N2 ) )
          = ( times_times @ A @ ( minus_minus @ A @ ( one_one @ A ) @ X2 )
            @ ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [I4: nat] : ( power_power @ A @ X2 @ ( minus_minus @ nat @ N2 @ ( suc @ I4 ) ) )
              @ ( set_ord_lessThan @ nat @ N2 ) ) ) ) ) ).

% one_diff_power_eq'
thf(fact_2789_sums__if_H,axiom,
    ! [G: nat > real,X2: real] :
      ( ( sums @ real @ G @ X2 )
     => ( sums @ real
        @ ^ [N3: nat] : ( if @ real @ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N3 ) @ ( zero_zero @ real ) @ ( G @ ( divide_divide @ nat @ ( minus_minus @ nat @ N3 @ ( one_one @ nat ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
        @ X2 ) ) ).

% sums_if'
thf(fact_2790_sums__if,axiom,
    ! [G: nat > real,X2: real,F2: nat > real,Y2: real] :
      ( ( sums @ real @ G @ X2 )
     => ( ( sums @ real @ F2 @ Y2 )
       => ( sums @ real
          @ ^ [N3: nat] : ( if @ real @ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N3 ) @ ( F2 @ ( divide_divide @ nat @ N3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( G @ ( divide_divide @ nat @ ( minus_minus @ nat @ N3 @ ( one_one @ nat ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
          @ ( plus_plus @ real @ X2 @ Y2 ) ) ) ) ).

% sums_if
thf(fact_2791_sum__split__even__odd,axiom,
    ! [F2: nat > real,G: nat > real,N2: nat] :
      ( ( groups7311177749621191930dd_sum @ nat @ real
        @ ^ [I4: nat] : ( if @ real @ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ I4 ) @ ( F2 @ I4 ) @ ( G @ I4 ) )
        @ ( set_ord_lessThan @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) )
      = ( plus_plus @ real
        @ ( groups7311177749621191930dd_sum @ nat @ real
          @ ^ [I4: nat] : ( F2 @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ I4 ) )
          @ ( set_ord_lessThan @ nat @ N2 ) )
        @ ( groups7311177749621191930dd_sum @ nat @ real
          @ ^ [I4: nat] : ( G @ ( plus_plus @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ I4 ) @ ( one_one @ nat ) ) )
          @ ( set_ord_lessThan @ nat @ N2 ) ) ) ) ).

% sum_split_even_odd
thf(fact_2792_geometric__sums,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [C2: A] :
          ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ C2 ) @ ( one_one @ real ) )
         => ( sums @ A @ ( power_power @ A @ C2 ) @ ( divide_divide @ A @ ( one_one @ A ) @ ( minus_minus @ A @ ( one_one @ A ) @ C2 ) ) ) ) ) ).

% geometric_sums
thf(fact_2793_power__half__series,axiom,
    ( sums @ real
    @ ^ [N3: nat] : ( power_power @ real @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( suc @ N3 ) )
    @ ( one_one @ real ) ) ).

% power_half_series
thf(fact_2794_sums__zero,axiom,
    ! [A: $tType] :
      ( ( ( comm_monoid_add @ A )
        & ( topolo4958980785337419405_space @ A ) )
     => ( sums @ A
        @ ^ [N3: nat] : ( zero_zero @ A )
        @ ( zero_zero @ A ) ) ) ).

% sums_zero
thf(fact_2795_sum__bounds__lt__plus1,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [F2: nat > A,Mm: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [K3: nat] : ( F2 @ ( suc @ K3 ) )
            @ ( set_ord_lessThan @ nat @ Mm ) )
          = ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_or1337092689740270186AtMost @ nat @ ( one_one @ nat ) @ Mm ) ) ) ) ).

% sum_bounds_lt_plus1
thf(fact_2796_sums__split__initial__segment,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: nat > A,S2: A,N2: nat] :
          ( ( sums @ A @ F2 @ S2 )
         => ( sums @ A
            @ ^ [I4: nat] : ( F2 @ ( plus_plus @ nat @ I4 @ N2 ) )
            @ ( minus_minus @ A @ S2 @ ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_ord_lessThan @ nat @ N2 ) ) ) ) ) ) ).

% sums_split_initial_segment
thf(fact_2797_sums__iff__shift_H,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: nat > A,N2: nat,S2: A] :
          ( ( sums @ A
            @ ^ [I4: nat] : ( F2 @ ( plus_plus @ nat @ I4 @ N2 ) )
            @ ( minus_minus @ A @ S2 @ ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_ord_lessThan @ nat @ N2 ) ) ) )
          = ( sums @ A @ F2 @ S2 ) ) ) ).

% sums_iff_shift'
thf(fact_2798_prod__int__plus__eq,axiom,
    ! [I3: nat,J: nat] :
      ( ( groups7121269368397514597t_prod @ nat @ int @ ( semiring_1_of_nat @ int ) @ ( set_or1337092689740270186AtMost @ nat @ I3 @ ( plus_plus @ nat @ I3 @ J ) ) )
      = ( groups7121269368397514597t_prod @ int @ int
        @ ^ [X5: int] : X5
        @ ( set_or1337092689740270186AtMost @ int @ ( semiring_1_of_nat @ int @ I3 ) @ ( semiring_1_of_nat @ int @ ( plus_plus @ nat @ I3 @ J ) ) ) ) ) ).

% prod_int_plus_eq
thf(fact_2799_sums__le,axiom,
    ! [A: $tType] :
      ( ( ( ordere6911136660526730532id_add @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [F2: nat > A,G: nat > A,S2: A,T2: A] :
          ( ! [N: nat] : ( ord_less_eq @ A @ ( F2 @ N ) @ ( G @ N ) )
         => ( ( sums @ A @ F2 @ S2 )
           => ( ( sums @ A @ G @ T2 )
             => ( ord_less_eq @ A @ S2 @ T2 ) ) ) ) ) ).

% sums_le
thf(fact_2800_sums__0,axiom,
    ! [A: $tType] :
      ( ( ( comm_monoid_add @ A )
        & ( topolo4958980785337419405_space @ A ) )
     => ! [F2: nat > A] :
          ( ! [N: nat] :
              ( ( F2 @ N )
              = ( zero_zero @ A ) )
         => ( sums @ A @ F2 @ ( zero_zero @ A ) ) ) ) ).

% sums_0
thf(fact_2801_sums__single,axiom,
    ! [A: $tType] :
      ( ( ( comm_monoid_add @ A )
        & ( topolo4958980785337419405_space @ A ) )
     => ! [I3: nat,F2: nat > A] :
          ( sums @ A
          @ ^ [R5: nat] : ( if @ A @ ( R5 = I3 ) @ ( F2 @ R5 ) @ ( zero_zero @ A ) )
          @ ( F2 @ I3 ) ) ) ).

% sums_single
thf(fact_2802_sums__mult2,axiom,
    ! [A: $tType] :
      ( ( real_V4412858255891104859lgebra @ A )
     => ! [F2: nat > A,A2: A,C2: A] :
          ( ( sums @ A @ F2 @ A2 )
         => ( sums @ A
            @ ^ [N3: nat] : ( times_times @ A @ ( F2 @ N3 ) @ C2 )
            @ ( times_times @ A @ A2 @ C2 ) ) ) ) ).

% sums_mult2
thf(fact_2803_sums__mult,axiom,
    ! [A: $tType] :
      ( ( real_V4412858255891104859lgebra @ A )
     => ! [F2: nat > A,A2: A,C2: A] :
          ( ( sums @ A @ F2 @ A2 )
         => ( sums @ A
            @ ^ [N3: nat] : ( times_times @ A @ C2 @ ( F2 @ N3 ) )
            @ ( times_times @ A @ C2 @ A2 ) ) ) ) ).

% sums_mult
thf(fact_2804_sums__add,axiom,
    ! [A: $tType] :
      ( ( ( topolo5987344860129210374id_add @ A )
        & ( topological_t2_space @ A ) )
     => ! [F2: nat > A,A2: A,G: nat > A,B2: A] :
          ( ( sums @ A @ F2 @ A2 )
         => ( ( sums @ A @ G @ B2 )
           => ( sums @ A
              @ ^ [N3: nat] : ( plus_plus @ A @ ( F2 @ N3 ) @ ( G @ N3 ) )
              @ ( plus_plus @ A @ A2 @ B2 ) ) ) ) ) ).

% sums_add
thf(fact_2805_sums__divide,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: nat > A,A2: A,C2: A] :
          ( ( sums @ A @ F2 @ A2 )
         => ( sums @ A
            @ ^ [N3: nat] : ( divide_divide @ A @ ( F2 @ N3 ) @ C2 )
            @ ( divide_divide @ A @ A2 @ C2 ) ) ) ) ).

% sums_divide
thf(fact_2806_sums__mult__iff,axiom,
    ! [A: $tType] :
      ( ( ( field @ A )
        & ( real_V4412858255891104859lgebra @ A ) )
     => ! [C2: A,F2: nat > A,D2: A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( sums @ A
              @ ^ [N3: nat] : ( times_times @ A @ C2 @ ( F2 @ N3 ) )
              @ ( times_times @ A @ C2 @ D2 ) )
            = ( sums @ A @ F2 @ D2 ) ) ) ) ).

% sums_mult_iff
thf(fact_2807_sums__mult2__iff,axiom,
    ! [A: $tType] :
      ( ( ( field @ A )
        & ( real_V4412858255891104859lgebra @ A ) )
     => ! [C2: A,F2: nat > A,D2: A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( sums @ A
              @ ^ [N3: nat] : ( times_times @ A @ ( F2 @ N3 ) @ C2 )
              @ ( times_times @ A @ D2 @ C2 ) )
            = ( sums @ A @ F2 @ D2 ) ) ) ) ).

% sums_mult2_iff
thf(fact_2808_sums__mult__D,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [C2: A,F2: nat > A,A2: A] :
          ( ( sums @ A
            @ ^ [N3: nat] : ( times_times @ A @ C2 @ ( F2 @ N3 ) )
            @ A2 )
         => ( ( C2
             != ( zero_zero @ A ) )
           => ( sums @ A @ F2 @ ( divide_divide @ A @ A2 @ C2 ) ) ) ) ) ).

% sums_mult_D
thf(fact_2809_sums__Suc__imp,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: nat > A,S2: A] :
          ( ( ( F2 @ ( zero_zero @ nat ) )
            = ( zero_zero @ A ) )
         => ( ( sums @ A
              @ ^ [N3: nat] : ( F2 @ ( suc @ N3 ) )
              @ S2 )
           => ( sums @ A @ F2 @ S2 ) ) ) ) ).

% sums_Suc_imp
thf(fact_2810_sums__Suc__iff,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: nat > A,S2: A] :
          ( ( sums @ A
            @ ^ [N3: nat] : ( F2 @ ( suc @ N3 ) )
            @ S2 )
          = ( sums @ A @ F2 @ ( plus_plus @ A @ S2 @ ( F2 @ ( zero_zero @ nat ) ) ) ) ) ) ).

% sums_Suc_iff
thf(fact_2811_sums__Suc,axiom,
    ! [A: $tType] :
      ( ( ( topolo5987344860129210374id_add @ A )
        & ( topological_t2_space @ A ) )
     => ! [F2: nat > A,L: A] :
          ( ( sums @ A
            @ ^ [N3: nat] : ( F2 @ ( suc @ N3 ) )
            @ L )
         => ( sums @ A @ F2 @ ( plus_plus @ A @ L @ ( F2 @ ( zero_zero @ nat ) ) ) ) ) ) ).

% sums_Suc
thf(fact_2812_sums__zero__iff__shift,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [N2: nat,F2: nat > A,S2: A] :
          ( ! [I2: nat] :
              ( ( ord_less @ nat @ I2 @ N2 )
             => ( ( F2 @ I2 )
                = ( zero_zero @ A ) ) )
         => ( ( sums @ A
              @ ^ [I4: nat] : ( F2 @ ( plus_plus @ nat @ I4 @ N2 ) )
              @ S2 )
            = ( sums @ A @ F2 @ S2 ) ) ) ) ).

% sums_zero_iff_shift
thf(fact_2813_powser__sums__if,axiom,
    ! [A: $tType] :
      ( ( ( ring_1 @ A )
        & ( topolo4958980785337419405_space @ A ) )
     => ! [M: nat,Z: A] :
          ( sums @ A
          @ ^ [N3: nat] : ( times_times @ A @ ( if @ A @ ( N3 = M ) @ ( one_one @ A ) @ ( zero_zero @ A ) ) @ ( power_power @ A @ Z @ N3 ) )
          @ ( power_power @ A @ Z @ M ) ) ) ).

% powser_sums_if
thf(fact_2814_sums__iff__shift,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: nat > A,N2: nat,S2: A] :
          ( ( sums @ A
            @ ^ [I4: nat] : ( F2 @ ( plus_plus @ nat @ I4 @ N2 ) )
            @ S2 )
          = ( sums @ A @ F2 @ ( plus_plus @ A @ S2 @ ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_ord_lessThan @ nat @ N2 ) ) ) ) ) ) ).

% sums_iff_shift
thf(fact_2815_artanh__def,axiom,
    ! [A: $tType] :
      ( ( ( real_V3459762299906320749_field @ A )
        & ( ln @ A ) )
     => ( ( artanh @ A )
        = ( ^ [X5: A] : ( divide_divide @ A @ ( ln_ln @ A @ ( divide_divide @ A @ ( plus_plus @ A @ ( one_one @ A ) @ X5 ) @ ( minus_minus @ A @ ( one_one @ A ) @ X5 ) ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ).

% artanh_def
thf(fact_2816_sumr__cos__zero__one,axiom,
    ! [N2: nat] :
      ( ( groups7311177749621191930dd_sum @ nat @ real
        @ ^ [M6: nat] : ( times_times @ real @ ( cos_coeff @ M6 ) @ ( power_power @ real @ ( zero_zero @ real ) @ M6 ) )
        @ ( set_ord_lessThan @ nat @ ( suc @ N2 ) ) )
      = ( one_one @ real ) ) ).

% sumr_cos_zero_one
thf(fact_2817_gchoose__row__sum__weighted,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [R3: A,M: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [K3: nat] : ( times_times @ A @ ( gbinomial @ A @ R3 @ K3 ) @ ( minus_minus @ A @ ( divide_divide @ A @ R3 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( semiring_1_of_nat @ A @ K3 ) ) )
            @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ M ) )
          = ( times_times @ A @ ( divide_divide @ A @ ( semiring_1_of_nat @ A @ ( suc @ M ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( gbinomial @ A @ R3 @ ( suc @ M ) ) ) ) ) ).

% gchoose_row_sum_weighted
thf(fact_2818_ln__one__minus__pos__lower__bound,axiom,
    ! [X2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( ord_less_eq @ real @ X2 @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
       => ( ord_less_eq @ real @ ( minus_minus @ real @ ( uminus_uminus @ real @ X2 ) @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( power_power @ real @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( ln_ln @ real @ ( minus_minus @ real @ ( one_one @ real ) @ X2 ) ) ) ) ) ).

% ln_one_minus_pos_lower_bound
thf(fact_2819_central__binomial__lower__bound,axiom,
    ! [N2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ord_less_eq @ real @ ( divide_divide @ real @ ( power_power @ real @ ( numeral_numeral @ real @ ( bit0 @ ( bit0 @ one2 ) ) ) @ N2 ) @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( semiring_1_of_nat @ real @ N2 ) ) ) @ ( semiring_1_of_nat @ real @ ( binomial @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) @ N2 ) ) ) ) ).

% central_binomial_lower_bound
thf(fact_2820_fact__double,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [N2: nat] :
          ( ( semiring_char_0_fact @ A @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) )
          = ( times_times @ A @ ( times_times @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) @ ( comm_s3205402744901411588hammer @ A @ ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ N2 ) ) @ ( semiring_char_0_fact @ A @ N2 ) ) ) ) ).

% fact_double
thf(fact_2821_binomial__Suc__n,axiom,
    ! [N2: nat] :
      ( ( binomial @ ( suc @ N2 ) @ N2 )
      = ( suc @ N2 ) ) ).

% binomial_Suc_n
thf(fact_2822_binomial__n__n,axiom,
    ! [N2: nat] :
      ( ( binomial @ N2 @ N2 )
      = ( one_one @ nat ) ) ).

% binomial_n_n
thf(fact_2823_gbinomial__1,axiom,
    ! [A: $tType] :
      ( ( ( semiring_char_0 @ A )
        & ( semidom_divide @ A ) )
     => ! [A2: A] :
          ( ( gbinomial @ A @ A2 @ ( one_one @ nat ) )
          = A2 ) ) ).

% gbinomial_1
thf(fact_2824_ln__one,axiom,
    ! [A: $tType] :
      ( ( ln @ A )
     => ( ( ln_ln @ A @ ( one_one @ A ) )
        = ( zero_zero @ A ) ) ) ).

% ln_one
thf(fact_2825_fact__0,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ( ( semiring_char_0_fact @ A @ ( zero_zero @ nat ) )
        = ( one_one @ A ) ) ) ).

% fact_0
thf(fact_2826_gbinomial__0_I2_J,axiom,
    ! [B: $tType] :
      ( ( ( semiring_char_0 @ B )
        & ( semidom_divide @ B ) )
     => ! [K: nat] :
          ( ( gbinomial @ B @ ( zero_zero @ B ) @ ( suc @ K ) )
          = ( zero_zero @ B ) ) ) ).

% gbinomial_0(2)
thf(fact_2827_binomial__0__Suc,axiom,
    ! [K: nat] :
      ( ( binomial @ ( zero_zero @ nat ) @ ( suc @ K ) )
      = ( zero_zero @ nat ) ) ).

% binomial_0_Suc
thf(fact_2828_binomial__1,axiom,
    ! [N2: nat] :
      ( ( binomial @ N2 @ ( suc @ ( zero_zero @ nat ) ) )
      = N2 ) ).

% binomial_1
thf(fact_2829_binomial__eq__0__iff,axiom,
    ! [N2: nat,K: nat] :
      ( ( ( binomial @ N2 @ K )
        = ( zero_zero @ nat ) )
      = ( ord_less @ nat @ N2 @ K ) ) ).

% binomial_eq_0_iff
thf(fact_2830_fact__1,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ( ( semiring_char_0_fact @ A @ ( one_one @ nat ) )
        = ( one_one @ A ) ) ) ).

% fact_1
thf(fact_2831_gbinomial__0_I1_J,axiom,
    ! [A: $tType] :
      ( ( ( semiring_char_0 @ A )
        & ( semidom_divide @ A ) )
     => ! [A2: A] :
          ( ( gbinomial @ A @ A2 @ ( zero_zero @ nat ) )
          = ( one_one @ A ) ) ) ).

% gbinomial_0(1)
thf(fact_2832_binomial__Suc__Suc,axiom,
    ! [N2: nat,K: nat] :
      ( ( binomial @ ( suc @ N2 ) @ ( suc @ K ) )
      = ( plus_plus @ nat @ ( binomial @ N2 @ K ) @ ( binomial @ N2 @ ( suc @ K ) ) ) ) ).

% binomial_Suc_Suc
thf(fact_2833_ln__less__cancel__iff,axiom,
    ! [X2: real,Y2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ Y2 )
       => ( ( ord_less @ real @ ( ln_ln @ real @ X2 ) @ ( ln_ln @ real @ Y2 ) )
          = ( ord_less @ real @ X2 @ Y2 ) ) ) ) ).

% ln_less_cancel_iff
thf(fact_2834_ln__inj__iff,axiom,
    ! [X2: real,Y2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ Y2 )
       => ( ( ( ln_ln @ real @ X2 )
            = ( ln_ln @ real @ Y2 ) )
          = ( X2 = Y2 ) ) ) ) ).

% ln_inj_iff
thf(fact_2835_gbinomial__Suc0,axiom,
    ! [A: $tType] :
      ( ( ( semiring_char_0 @ A )
        & ( semidom_divide @ A ) )
     => ! [A2: A] :
          ( ( gbinomial @ A @ A2 @ ( suc @ ( zero_zero @ nat ) ) )
          = A2 ) ) ).

% gbinomial_Suc0
thf(fact_2836_binomial__n__0,axiom,
    ! [N2: nat] :
      ( ( binomial @ N2 @ ( zero_zero @ nat ) )
      = ( one_one @ nat ) ) ).

% binomial_n_0
thf(fact_2837_cos__coeff__0,axiom,
    ( ( cos_coeff @ ( zero_zero @ nat ) )
    = ( one_one @ real ) ) ).

% cos_coeff_0
thf(fact_2838_fact__Suc__0,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ( ( semiring_char_0_fact @ A @ ( suc @ ( zero_zero @ nat ) ) )
        = ( one_one @ A ) ) ) ).

% fact_Suc_0
thf(fact_2839_fact__Suc,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [N2: nat] :
          ( ( semiring_char_0_fact @ A @ ( suc @ N2 ) )
          = ( times_times @ A @ ( semiring_1_of_nat @ A @ ( suc @ N2 ) ) @ ( semiring_char_0_fact @ A @ N2 ) ) ) ) ).

% fact_Suc
thf(fact_2840_zero__less__binomial__iff,axiom,
    ! [N2: nat,K: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( binomial @ N2 @ K ) )
      = ( ord_less_eq @ nat @ K @ N2 ) ) ).

% zero_less_binomial_iff
thf(fact_2841_ln__le__cancel__iff,axiom,
    ! [X2: real,Y2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ Y2 )
       => ( ( ord_less_eq @ real @ ( ln_ln @ real @ X2 ) @ ( ln_ln @ real @ Y2 ) )
          = ( ord_less_eq @ real @ X2 @ Y2 ) ) ) ) ).

% ln_le_cancel_iff
thf(fact_2842_ln__eq__zero__iff,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( ( ln_ln @ real @ X2 )
          = ( zero_zero @ real ) )
        = ( X2
          = ( one_one @ real ) ) ) ) ).

% ln_eq_zero_iff
thf(fact_2843_ln__gt__zero__iff,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ ( ln_ln @ real @ X2 ) )
        = ( ord_less @ real @ ( one_one @ real ) @ X2 ) ) ) ).

% ln_gt_zero_iff
thf(fact_2844_ln__less__zero__iff,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( ord_less @ real @ ( ln_ln @ real @ X2 ) @ ( zero_zero @ real ) )
        = ( ord_less @ real @ X2 @ ( one_one @ real ) ) ) ) ).

% ln_less_zero_iff
thf(fact_2845_fact__2,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ( ( semiring_char_0_fact @ A @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
        = ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ).

% fact_2
thf(fact_2846_ln__ge__zero__iff,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( ln_ln @ real @ X2 ) )
        = ( ord_less_eq @ real @ ( one_one @ real ) @ X2 ) ) ) ).

% ln_ge_zero_iff
thf(fact_2847_ln__le__zero__iff,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( ord_less_eq @ real @ ( ln_ln @ real @ X2 ) @ ( zero_zero @ real ) )
        = ( ord_less_eq @ real @ X2 @ ( one_one @ real ) ) ) ) ).

% ln_le_zero_iff
thf(fact_2848_fact__mono__nat,axiom,
    ! [M: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ M @ N2 )
     => ( ord_less_eq @ nat @ ( semiring_char_0_fact @ nat @ M ) @ ( semiring_char_0_fact @ nat @ N2 ) ) ) ).

% fact_mono_nat
thf(fact_2849_fact__ge__self,axiom,
    ! [N2: nat] : ( ord_less_eq @ nat @ N2 @ ( semiring_char_0_fact @ nat @ N2 ) ) ).

% fact_ge_self
thf(fact_2850_choose__one,axiom,
    ! [N2: nat] :
      ( ( binomial @ N2 @ ( one_one @ nat ) )
      = N2 ) ).

% choose_one
thf(fact_2851_fact__nonzero,axiom,
    ! [A: $tType] :
      ( ( ( semiring_char_0 @ A )
        & ( semiri3467727345109120633visors @ A ) )
     => ! [N2: nat] :
          ( ( semiring_char_0_fact @ A @ N2 )
         != ( zero_zero @ A ) ) ) ).

% fact_nonzero
thf(fact_2852_binomial__fact__lemma,axiom,
    ! [K: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ K @ N2 )
     => ( ( times_times @ nat @ ( times_times @ nat @ ( semiring_char_0_fact @ nat @ K ) @ ( semiring_char_0_fact @ nat @ ( minus_minus @ nat @ N2 @ K ) ) ) @ ( binomial @ N2 @ K ) )
        = ( semiring_char_0_fact @ nat @ N2 ) ) ) ).

% binomial_fact_lemma
thf(fact_2853_binomial__altdef__nat,axiom,
    ! [K: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ K @ N2 )
     => ( ( binomial @ N2 @ K )
        = ( divide_divide @ nat @ ( semiring_char_0_fact @ nat @ N2 ) @ ( times_times @ nat @ ( semiring_char_0_fact @ nat @ K ) @ ( semiring_char_0_fact @ nat @ ( minus_minus @ nat @ N2 @ K ) ) ) ) ) ) ).

% binomial_altdef_nat
thf(fact_2854_binomial__eq__0,axiom,
    ! [N2: nat,K: nat] :
      ( ( ord_less @ nat @ N2 @ K )
     => ( ( binomial @ N2 @ K )
        = ( zero_zero @ nat ) ) ) ).

% binomial_eq_0
thf(fact_2855_ln__less__self,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
     => ( ord_less @ real @ ( ln_ln @ real @ X2 ) @ X2 ) ) ).

% ln_less_self
thf(fact_2856_Suc__times__binomial,axiom,
    ! [K: nat,N2: nat] :
      ( ( times_times @ nat @ ( suc @ K ) @ ( binomial @ ( suc @ N2 ) @ ( suc @ K ) ) )
      = ( times_times @ nat @ ( suc @ N2 ) @ ( binomial @ N2 @ K ) ) ) ).

% Suc_times_binomial
thf(fact_2857_Suc__times__binomial__eq,axiom,
    ! [N2: nat,K: nat] :
      ( ( times_times @ nat @ ( suc @ N2 ) @ ( binomial @ N2 @ K ) )
      = ( times_times @ nat @ ( binomial @ ( suc @ N2 ) @ ( suc @ K ) ) @ ( suc @ K ) ) ) ).

% Suc_times_binomial_eq
thf(fact_2858_fact__less__mono__nat,axiom,
    ! [M: nat,N2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M )
     => ( ( ord_less @ nat @ M @ N2 )
       => ( ord_less @ nat @ ( semiring_char_0_fact @ nat @ M ) @ ( semiring_char_0_fact @ nat @ N2 ) ) ) ) ).

% fact_less_mono_nat
thf(fact_2859_binomial__symmetric,axiom,
    ! [K: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ K @ N2 )
     => ( ( binomial @ N2 @ K )
        = ( binomial @ N2 @ ( minus_minus @ nat @ N2 @ K ) ) ) ) ).

% binomial_symmetric
thf(fact_2860_choose__mult__lemma,axiom,
    ! [M: nat,R3: nat,K: nat] :
      ( ( times_times @ nat @ ( binomial @ ( plus_plus @ nat @ ( plus_plus @ nat @ M @ R3 ) @ K ) @ ( plus_plus @ nat @ M @ K ) ) @ ( binomial @ ( plus_plus @ nat @ M @ K ) @ K ) )
      = ( times_times @ nat @ ( binomial @ ( plus_plus @ nat @ ( plus_plus @ nat @ M @ R3 ) @ K ) @ K ) @ ( binomial @ ( plus_plus @ nat @ M @ R3 ) @ M ) ) ) ).

% choose_mult_lemma
thf(fact_2861_binomial__le__pow,axiom,
    ! [R3: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ R3 @ N2 )
     => ( ord_less_eq @ nat @ ( binomial @ N2 @ R3 ) @ ( power_power @ nat @ N2 @ R3 ) ) ) ).

% binomial_le_pow
thf(fact_2862_fact__ge__zero,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [N2: nat] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( semiring_char_0_fact @ A @ N2 ) ) ) ).

% fact_ge_zero
thf(fact_2863_fact__not__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [N2: nat] :
          ~ ( ord_less @ A @ ( semiring_char_0_fact @ A @ N2 ) @ ( zero_zero @ A ) ) ) ).

% fact_not_neg
thf(fact_2864_fact__gt__zero,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [N2: nat] : ( ord_less @ A @ ( zero_zero @ A ) @ ( semiring_char_0_fact @ A @ N2 ) ) ) ).

% fact_gt_zero
thf(fact_2865_fact__ge__1,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [N2: nat] : ( ord_less_eq @ A @ ( one_one @ A ) @ ( semiring_char_0_fact @ A @ N2 ) ) ) ).

% fact_ge_1
thf(fact_2866_fact__mono,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [M: nat,N2: nat] :
          ( ( ord_less_eq @ nat @ M @ N2 )
         => ( ord_less_eq @ A @ ( semiring_char_0_fact @ A @ M ) @ ( semiring_char_0_fact @ A @ N2 ) ) ) ) ).

% fact_mono
thf(fact_2867_fact__dvd,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [N2: nat,M: nat] :
          ( ( ord_less_eq @ nat @ N2 @ M )
         => ( dvd_dvd @ A @ ( semiring_char_0_fact @ A @ N2 ) @ ( semiring_char_0_fact @ A @ M ) ) ) ) ).

% fact_dvd
thf(fact_2868_pochhammer__fact,axiom,
    ! [A: $tType] :
      ( ( ( semiring_char_0 @ A )
        & ( comm_semiring_1 @ A ) )
     => ( ( semiring_char_0_fact @ A )
        = ( comm_s3205402744901411588hammer @ A @ ( one_one @ A ) ) ) ) ).

% pochhammer_fact
thf(fact_2869_fact__binomial,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [K: nat,N2: nat] :
          ( ( ord_less_eq @ nat @ K @ N2 )
         => ( ( times_times @ A @ ( semiring_char_0_fact @ A @ K ) @ ( semiring_1_of_nat @ A @ ( binomial @ N2 @ K ) ) )
            = ( divide_divide @ A @ ( semiring_char_0_fact @ A @ N2 ) @ ( semiring_char_0_fact @ A @ ( minus_minus @ nat @ N2 @ K ) ) ) ) ) ) ).

% fact_binomial
thf(fact_2870_binomial__fact,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [K: nat,N2: nat] :
          ( ( ord_less_eq @ nat @ K @ N2 )
         => ( ( semiring_1_of_nat @ A @ ( binomial @ N2 @ K ) )
            = ( divide_divide @ A @ ( semiring_char_0_fact @ A @ N2 ) @ ( times_times @ A @ ( semiring_char_0_fact @ A @ K ) @ ( semiring_char_0_fact @ A @ ( minus_minus @ nat @ N2 @ K ) ) ) ) ) ) ) ).

% binomial_fact
thf(fact_2871_ln__bound,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
     => ( ord_less_eq @ real @ ( ln_ln @ real @ X2 ) @ X2 ) ) ).

% ln_bound
thf(fact_2872_zero__less__binomial,axiom,
    ! [K: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ K @ N2 )
     => ( ord_less @ nat @ ( zero_zero @ nat ) @ ( binomial @ N2 @ K ) ) ) ).

% zero_less_binomial
thf(fact_2873_ln__gt__zero__imp__gt__one,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ ( ln_ln @ real @ X2 ) )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
       => ( ord_less @ real @ ( one_one @ real ) @ X2 ) ) ) ).

% ln_gt_zero_imp_gt_one
thf(fact_2874_ln__less__zero,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( ord_less @ real @ X2 @ ( one_one @ real ) )
       => ( ord_less @ real @ ( ln_ln @ real @ X2 ) @ ( zero_zero @ real ) ) ) ) ).

% ln_less_zero
thf(fact_2875_ln__gt__zero,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ X2 )
     => ( ord_less @ real @ ( zero_zero @ real ) @ ( ln_ln @ real @ X2 ) ) ) ).

% ln_gt_zero
thf(fact_2876_ln__ge__zero,axiom,
    ! [X2: real] :
      ( ( ord_less_eq @ real @ ( one_one @ real ) @ X2 )
     => ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( ln_ln @ real @ X2 ) ) ) ).

% ln_ge_zero
thf(fact_2877_Suc__times__binomial__add,axiom,
    ! [A2: nat,B2: nat] :
      ( ( times_times @ nat @ ( suc @ A2 ) @ ( binomial @ ( suc @ ( plus_plus @ nat @ A2 @ B2 ) ) @ ( suc @ A2 ) ) )
      = ( times_times @ nat @ ( suc @ B2 ) @ ( binomial @ ( suc @ ( plus_plus @ nat @ A2 @ B2 ) ) @ A2 ) ) ) ).

% Suc_times_binomial_add
thf(fact_2878_fact__ge__Suc__0__nat,axiom,
    ! [N2: nat] : ( ord_less_eq @ nat @ ( suc @ ( zero_zero @ nat ) ) @ ( semiring_char_0_fact @ nat @ N2 ) ) ).

% fact_ge_Suc_0_nat
thf(fact_2879_choose__mult,axiom,
    ! [K: nat,M: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ K @ M )
     => ( ( ord_less_eq @ nat @ M @ N2 )
       => ( ( times_times @ nat @ ( binomial @ N2 @ M ) @ ( binomial @ M @ K ) )
          = ( times_times @ nat @ ( binomial @ N2 @ K ) @ ( binomial @ ( minus_minus @ nat @ N2 @ K ) @ ( minus_minus @ nat @ M @ K ) ) ) ) ) ) ).

% choose_mult
thf(fact_2880_binomial__Suc__Suc__eq__times,axiom,
    ! [N2: nat,K: nat] :
      ( ( binomial @ ( suc @ N2 ) @ ( suc @ K ) )
      = ( divide_divide @ nat @ ( times_times @ nat @ ( suc @ N2 ) @ ( binomial @ N2 @ K ) ) @ ( suc @ K ) ) ) ).

% binomial_Suc_Suc_eq_times
thf(fact_2881_binomial__absorb__comp,axiom,
    ! [N2: nat,K: nat] :
      ( ( times_times @ nat @ ( minus_minus @ nat @ N2 @ K ) @ ( binomial @ N2 @ K ) )
      = ( times_times @ nat @ N2 @ ( binomial @ ( minus_minus @ nat @ N2 @ ( one_one @ nat ) ) @ K ) ) ) ).

% binomial_absorb_comp
thf(fact_2882_gbinomial__pochhammer,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ( ( gbinomial @ A )
        = ( ^ [A4: A,K3: nat] : ( divide_divide @ A @ ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ K3 ) @ ( comm_s3205402744901411588hammer @ A @ ( uminus_uminus @ A @ A4 ) @ K3 ) ) @ ( semiring_char_0_fact @ A @ K3 ) ) ) ) ) ).

% gbinomial_pochhammer
thf(fact_2883_gbinomial__pochhammer_H,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ( ( gbinomial @ A )
        = ( ^ [A4: A,K3: nat] : ( divide_divide @ A @ ( comm_s3205402744901411588hammer @ A @ ( plus_plus @ A @ ( minus_minus @ A @ A4 @ ( semiring_1_of_nat @ A @ K3 ) ) @ ( one_one @ A ) ) @ K3 ) @ ( semiring_char_0_fact @ A @ K3 ) ) ) ) ) ).

% gbinomial_pochhammer'
thf(fact_2884_dvd__fact,axiom,
    ! [M: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ ( one_one @ nat ) @ M )
     => ( ( ord_less_eq @ nat @ M @ N2 )
       => ( dvd_dvd @ nat @ M @ ( semiring_char_0_fact @ nat @ N2 ) ) ) ) ).

% dvd_fact
thf(fact_2885_gbinomial__Suc__Suc,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: A,K: nat] :
          ( ( gbinomial @ A @ ( plus_plus @ A @ A2 @ ( one_one @ A ) ) @ ( suc @ K ) )
          = ( plus_plus @ A @ ( gbinomial @ A @ A2 @ K ) @ ( gbinomial @ A @ A2 @ ( suc @ K ) ) ) ) ) ).

% gbinomial_Suc_Suc
thf(fact_2886_fact__less__mono,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [M: nat,N2: nat] :
          ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M )
         => ( ( ord_less @ nat @ M @ N2 )
           => ( ord_less @ A @ ( semiring_char_0_fact @ A @ M ) @ ( semiring_char_0_fact @ A @ N2 ) ) ) ) ) ).

% fact_less_mono
thf(fact_2887_gbinomial__of__nat__symmetric,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [K: nat,N2: nat] :
          ( ( ord_less_eq @ nat @ K @ N2 )
         => ( ( gbinomial @ A @ ( semiring_1_of_nat @ A @ N2 ) @ K )
            = ( gbinomial @ A @ ( semiring_1_of_nat @ A @ N2 ) @ ( minus_minus @ nat @ N2 @ K ) ) ) ) ) ).

% gbinomial_of_nat_symmetric
thf(fact_2888_fact__fact__dvd__fact,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [K: nat,N2: nat] : ( dvd_dvd @ A @ ( times_times @ A @ ( semiring_char_0_fact @ A @ K ) @ ( semiring_char_0_fact @ A @ N2 ) ) @ ( semiring_char_0_fact @ A @ ( plus_plus @ nat @ K @ N2 ) ) ) ) ).

% fact_fact_dvd_fact
thf(fact_2889_fact__mod,axiom,
    ! [A: $tType] :
      ( ( ( linordered_semidom @ A )
        & ( semidom_modulo @ A ) )
     => ! [M: nat,N2: nat] :
          ( ( ord_less_eq @ nat @ M @ N2 )
         => ( ( modulo_modulo @ A @ ( semiring_char_0_fact @ A @ N2 ) @ ( semiring_char_0_fact @ A @ M ) )
            = ( zero_zero @ A ) ) ) ) ).

% fact_mod
thf(fact_2890_fact__le__power,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [N2: nat] : ( ord_less_eq @ A @ ( semiring_char_0_fact @ A @ N2 ) @ ( semiring_1_of_nat @ A @ ( power_power @ nat @ N2 @ N2 ) ) ) ) ).

% fact_le_power
thf(fact_2891_fact__prod,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ( ( semiring_char_0_fact @ A )
        = ( ^ [N3: nat] :
              ( semiring_1_of_nat @ A
              @ ( groups7121269368397514597t_prod @ nat @ nat
                @ ^ [X5: nat] : X5
                @ ( set_or1337092689740270186AtMost @ nat @ ( one_one @ nat ) @ N3 ) ) ) ) ) ) ).

% fact_prod
thf(fact_2892_gbinomial__Suc,axiom,
    ! [A: $tType] :
      ( ( ( semiring_char_0 @ A )
        & ( semidom_divide @ A ) )
     => ! [A2: A,K: nat] :
          ( ( gbinomial @ A @ A2 @ ( suc @ K ) )
          = ( divide_divide @ A
            @ ( groups7121269368397514597t_prod @ nat @ A
              @ ^ [I4: nat] : ( minus_minus @ A @ A2 @ ( semiring_1_of_nat @ A @ I4 ) )
              @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ K ) )
            @ ( semiring_char_0_fact @ A @ ( suc @ K ) ) ) ) ) ).

% gbinomial_Suc
thf(fact_2893_ln__ge__zero__imp__ge__one,axiom,
    ! [X2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( ln_ln @ real @ X2 ) )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
       => ( ord_less_eq @ real @ ( one_one @ real ) @ X2 ) ) ) ).

% ln_ge_zero_imp_ge_one
thf(fact_2894_ln__add__one__self__le__self,axiom,
    ! [X2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X2 )
     => ( ord_less_eq @ real @ ( ln_ln @ real @ ( plus_plus @ real @ ( one_one @ real ) @ X2 ) ) @ X2 ) ) ).

% ln_add_one_self_le_self
thf(fact_2895_ln__mult,axiom,
    ! [X2: real,Y2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ Y2 )
       => ( ( ln_ln @ real @ ( times_times @ real @ X2 @ Y2 ) )
          = ( plus_plus @ real @ ( ln_ln @ real @ X2 ) @ ( ln_ln @ real @ Y2 ) ) ) ) ) ).

% ln_mult
thf(fact_2896_binomial__absorption,axiom,
    ! [K: nat,N2: nat] :
      ( ( times_times @ nat @ ( suc @ K ) @ ( binomial @ N2 @ ( suc @ K ) ) )
      = ( times_times @ nat @ N2 @ ( binomial @ ( minus_minus @ nat @ N2 @ ( one_one @ nat ) ) @ K ) ) ) ).

% binomial_absorption
thf(fact_2897_ln__eq__minus__one,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( ( ln_ln @ real @ X2 )
          = ( minus_minus @ real @ X2 @ ( one_one @ real ) ) )
       => ( X2
          = ( one_one @ real ) ) ) ) ).

% ln_eq_minus_one
thf(fact_2898_ln__div,axiom,
    ! [X2: real,Y2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ Y2 )
       => ( ( ln_ln @ real @ ( divide_divide @ real @ X2 @ Y2 ) )
          = ( minus_minus @ real @ ( ln_ln @ real @ X2 ) @ ( ln_ln @ real @ Y2 ) ) ) ) ) ).

% ln_div
thf(fact_2899_fact__diff__Suc,axiom,
    ! [N2: nat,M: nat] :
      ( ( ord_less @ nat @ N2 @ ( suc @ M ) )
     => ( ( semiring_char_0_fact @ nat @ ( minus_minus @ nat @ ( suc @ M ) @ N2 ) )
        = ( times_times @ nat @ ( minus_minus @ nat @ ( suc @ M ) @ N2 ) @ ( semiring_char_0_fact @ nat @ ( minus_minus @ nat @ M @ N2 ) ) ) ) ) ).

% fact_diff_Suc
thf(fact_2900_fact__div__fact__le__pow,axiom,
    ! [R3: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ R3 @ N2 )
     => ( ord_less_eq @ nat @ ( divide_divide @ nat @ ( semiring_char_0_fact @ nat @ N2 ) @ ( semiring_char_0_fact @ nat @ ( minus_minus @ nat @ N2 @ R3 ) ) ) @ ( power_power @ nat @ N2 @ R3 ) ) ) ).

% fact_div_fact_le_pow
thf(fact_2901_gbinomial__addition__formula,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: A,K: nat] :
          ( ( gbinomial @ A @ A2 @ ( suc @ K ) )
          = ( plus_plus @ A @ ( gbinomial @ A @ ( minus_minus @ A @ A2 @ ( one_one @ A ) ) @ ( suc @ K ) ) @ ( gbinomial @ A @ ( minus_minus @ A @ A2 @ ( one_one @ A ) ) @ K ) ) ) ) ).

% gbinomial_addition_formula
thf(fact_2902_gbinomial__absorb__comp,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: A,K: nat] :
          ( ( times_times @ A @ ( minus_minus @ A @ A2 @ ( semiring_1_of_nat @ A @ K ) ) @ ( gbinomial @ A @ A2 @ K ) )
          = ( times_times @ A @ A2 @ ( gbinomial @ A @ ( minus_minus @ A @ A2 @ ( one_one @ A ) ) @ K ) ) ) ) ).

% gbinomial_absorb_comp
thf(fact_2903_gbinomial__ge__n__over__k__pow__k,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [K: nat,A2: A] :
          ( ( ord_less_eq @ A @ ( semiring_1_of_nat @ A @ K ) @ A2 )
         => ( ord_less_eq @ A @ ( power_power @ A @ ( divide_divide @ A @ A2 @ ( semiring_1_of_nat @ A @ K ) ) @ K ) @ ( gbinomial @ A @ A2 @ K ) ) ) ) ).

% gbinomial_ge_n_over_k_pow_k
thf(fact_2904_gbinomial__mult__1,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: A,K: nat] :
          ( ( times_times @ A @ A2 @ ( gbinomial @ A @ A2 @ K ) )
          = ( plus_plus @ A @ ( times_times @ A @ ( semiring_1_of_nat @ A @ K ) @ ( gbinomial @ A @ A2 @ K ) ) @ ( times_times @ A @ ( semiring_1_of_nat @ A @ ( suc @ K ) ) @ ( gbinomial @ A @ A2 @ ( suc @ K ) ) ) ) ) ) ).

% gbinomial_mult_1
thf(fact_2905_gbinomial__mult__1_H,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: A,K: nat] :
          ( ( times_times @ A @ ( gbinomial @ A @ A2 @ K ) @ A2 )
          = ( plus_plus @ A @ ( times_times @ A @ ( semiring_1_of_nat @ A @ K ) @ ( gbinomial @ A @ A2 @ K ) ) @ ( times_times @ A @ ( semiring_1_of_nat @ A @ ( suc @ K ) ) @ ( gbinomial @ A @ A2 @ ( suc @ K ) ) ) ) ) ) ).

% gbinomial_mult_1'
thf(fact_2906_choose__dvd,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [K: nat,N2: nat] :
          ( ( ord_less_eq @ nat @ K @ N2 )
         => ( dvd_dvd @ A @ ( times_times @ A @ ( semiring_char_0_fact @ A @ K ) @ ( semiring_char_0_fact @ A @ ( minus_minus @ nat @ N2 @ K ) ) ) @ ( semiring_char_0_fact @ A @ N2 ) ) ) ) ).

% choose_dvd
thf(fact_2907_fact__numeral,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [K: num] :
          ( ( semiring_char_0_fact @ A @ ( numeral_numeral @ nat @ K ) )
          = ( times_times @ A @ ( numeral_numeral @ A @ K ) @ ( semiring_char_0_fact @ A @ ( pred_numeral @ K ) ) ) ) ) ).

% fact_numeral
thf(fact_2908_fact__eq__fact__times,axiom,
    ! [N2: nat,M: nat] :
      ( ( ord_less_eq @ nat @ N2 @ M )
     => ( ( semiring_char_0_fact @ nat @ M )
        = ( times_times @ nat @ ( semiring_char_0_fact @ nat @ N2 )
          @ ( groups7121269368397514597t_prod @ nat @ nat
            @ ^ [X5: nat] : X5
            @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ N2 ) @ M ) ) ) ) ) ).

% fact_eq_fact_times
thf(fact_2909_binomial__code,axiom,
    ( binomial
    = ( ^ [N3: nat,K3: nat] : ( if @ nat @ ( ord_less @ nat @ N3 @ K3 ) @ ( zero_zero @ nat ) @ ( if @ nat @ ( ord_less @ nat @ N3 @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ K3 ) ) @ ( binomial @ N3 @ ( minus_minus @ nat @ N3 @ K3 ) ) @ ( divide_divide @ nat @ ( set_fo6178422350223883121st_nat @ nat @ ( times_times @ nat ) @ ( plus_plus @ nat @ ( minus_minus @ nat @ N3 @ K3 ) @ ( one_one @ nat ) ) @ N3 @ ( one_one @ nat ) ) @ ( semiring_char_0_fact @ nat @ K3 ) ) ) ) ) ) ).

% binomial_code
thf(fact_2910_binomial__ge__n__over__k__pow__k,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [K: nat,N2: nat] :
          ( ( ord_less_eq @ nat @ K @ N2 )
         => ( ord_less_eq @ A @ ( power_power @ A @ ( divide_divide @ A @ ( semiring_1_of_nat @ A @ N2 ) @ ( semiring_1_of_nat @ A @ K ) ) @ K ) @ ( semiring_1_of_nat @ A @ ( binomial @ N2 @ K ) ) ) ) ) ).

% binomial_ge_n_over_k_pow_k
thf(fact_2911_binomial__maximum_H,axiom,
    ! [N2: nat,K: nat] : ( ord_less_eq @ nat @ ( binomial @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) @ K ) @ ( binomial @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) @ N2 ) ) ).

% binomial_maximum'
thf(fact_2912_binomial__mono,axiom,
    ! [K: nat,K7: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ K @ K7 )
     => ( ( ord_less_eq @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ K7 ) @ N2 )
       => ( ord_less_eq @ nat @ ( binomial @ N2 @ K ) @ ( binomial @ N2 @ K7 ) ) ) ) ).

% binomial_mono
thf(fact_2913_binomial__antimono,axiom,
    ! [K: nat,K7: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ K @ K7 )
     => ( ( ord_less_eq @ nat @ ( divide_divide @ nat @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ K )
       => ( ( ord_less_eq @ nat @ K7 @ N2 )
         => ( ord_less_eq @ nat @ ( binomial @ N2 @ K7 ) @ ( binomial @ N2 @ K ) ) ) ) ) ).

% binomial_antimono
thf(fact_2914_binomial__maximum,axiom,
    ! [N2: nat,K: nat] : ( ord_less_eq @ nat @ ( binomial @ N2 @ K ) @ ( binomial @ N2 @ ( divide_divide @ nat @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ).

% binomial_maximum
thf(fact_2915_ln__2__less__1,axiom,
    ord_less @ real @ ( ln_ln @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( one_one @ real ) ).

% ln_2_less_1
thf(fact_2916_binomial__le__pow2,axiom,
    ! [N2: nat,K: nat] : ( ord_less_eq @ nat @ ( binomial @ N2 @ K ) @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) ).

% binomial_le_pow2
thf(fact_2917_choose__reduce__nat,axiom,
    ! [N2: nat,K: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
       => ( ( binomial @ N2 @ K )
          = ( plus_plus @ nat @ ( binomial @ ( minus_minus @ nat @ N2 @ ( one_one @ nat ) ) @ ( minus_minus @ nat @ K @ ( one_one @ nat ) ) ) @ ( binomial @ ( minus_minus @ nat @ N2 @ ( one_one @ nat ) ) @ K ) ) ) ) ) ).

% choose_reduce_nat
thf(fact_2918_gbinomial__code,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ( ( gbinomial @ A )
        = ( ^ [A4: A,K3: nat] :
              ( if @ A
              @ ( K3
                = ( zero_zero @ nat ) )
              @ ( one_one @ A )
              @ ( divide_divide @ A
                @ ( set_fo6178422350223883121st_nat @ A
                  @ ^ [L2: nat] : ( times_times @ A @ ( minus_minus @ A @ A4 @ ( semiring_1_of_nat @ A @ L2 ) ) )
                  @ ( zero_zero @ nat )
                  @ ( minus_minus @ nat @ K3 @ ( one_one @ nat ) )
                  @ ( one_one @ A ) )
                @ ( semiring_char_0_fact @ A @ K3 ) ) ) ) ) ) ).

% gbinomial_code
thf(fact_2919_times__binomial__minus1__eq,axiom,
    ! [K: nat,N2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
     => ( ( times_times @ nat @ K @ ( binomial @ N2 @ K ) )
        = ( times_times @ nat @ N2 @ ( binomial @ ( minus_minus @ nat @ N2 @ ( one_one @ nat ) ) @ ( minus_minus @ nat @ K @ ( one_one @ nat ) ) ) ) ) ) ).

% times_binomial_minus1_eq
thf(fact_2920_ln__le__minus__one,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
     => ( ord_less_eq @ real @ ( ln_ln @ real @ X2 ) @ ( minus_minus @ real @ X2 @ ( one_one @ real ) ) ) ) ).

% ln_le_minus_one
thf(fact_2921_ln__diff__le,axiom,
    ! [X2: real,Y2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ Y2 )
       => ( ord_less_eq @ real @ ( minus_minus @ real @ ( ln_ln @ real @ X2 ) @ ( ln_ln @ real @ Y2 ) ) @ ( divide_divide @ real @ ( minus_minus @ real @ X2 @ Y2 ) @ Y2 ) ) ) ) ).

% ln_diff_le
thf(fact_2922_ln__add__one__self__le__self2,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ X2 )
     => ( ord_less_eq @ real @ ( ln_ln @ real @ ( plus_plus @ real @ ( one_one @ real ) @ X2 ) ) @ X2 ) ) ).

% ln_add_one_self_le_self2
thf(fact_2923_ln__realpow,axiom,
    ! [X2: real,N2: nat] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( ln_ln @ real @ ( power_power @ real @ X2 @ N2 ) )
        = ( times_times @ real @ ( semiring_1_of_nat @ real @ N2 ) @ ( ln_ln @ real @ X2 ) ) ) ) ).

% ln_realpow
thf(fact_2924_Suc__times__gbinomial,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [K: nat,A2: A] :
          ( ( times_times @ A @ ( semiring_1_of_nat @ A @ ( suc @ K ) ) @ ( gbinomial @ A @ ( plus_plus @ A @ A2 @ ( one_one @ A ) ) @ ( suc @ K ) ) )
          = ( times_times @ A @ ( plus_plus @ A @ A2 @ ( one_one @ A ) ) @ ( gbinomial @ A @ A2 @ K ) ) ) ) ).

% Suc_times_gbinomial
thf(fact_2925_gbinomial__absorption,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [K: nat,A2: A] :
          ( ( times_times @ A @ ( semiring_1_of_nat @ A @ ( suc @ K ) ) @ ( gbinomial @ A @ A2 @ ( suc @ K ) ) )
          = ( times_times @ A @ A2 @ ( gbinomial @ A @ ( minus_minus @ A @ A2 @ ( one_one @ A ) ) @ K ) ) ) ) ).

% gbinomial_absorption
thf(fact_2926_gbinomial__trinomial__revision,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [K: nat,M: nat,A2: A] :
          ( ( ord_less_eq @ nat @ K @ M )
         => ( ( times_times @ A @ ( gbinomial @ A @ A2 @ M ) @ ( gbinomial @ A @ ( semiring_1_of_nat @ A @ M ) @ K ) )
            = ( times_times @ A @ ( gbinomial @ A @ A2 @ K ) @ ( gbinomial @ A @ ( minus_minus @ A @ A2 @ ( semiring_1_of_nat @ A @ K ) ) @ ( minus_minus @ nat @ M @ K ) ) ) ) ) ) ).

% gbinomial_trinomial_revision
thf(fact_2927_fact__div__fact,axiom,
    ! [N2: nat,M: nat] :
      ( ( ord_less_eq @ nat @ N2 @ M )
     => ( ( divide_divide @ nat @ ( semiring_char_0_fact @ nat @ M ) @ ( semiring_char_0_fact @ nat @ N2 ) )
        = ( groups7121269368397514597t_prod @ nat @ nat
          @ ^ [X5: nat] : X5
          @ ( set_or1337092689740270186AtMost @ nat @ ( plus_plus @ nat @ N2 @ ( one_one @ nat ) ) @ M ) ) ) ) ).

% fact_div_fact
thf(fact_2928_binomial__less__binomial__Suc,axiom,
    ! [K: nat,N2: nat] :
      ( ( ord_less @ nat @ K @ ( divide_divide @ nat @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
     => ( ord_less @ nat @ ( binomial @ N2 @ K ) @ ( binomial @ N2 @ ( suc @ K ) ) ) ) ).

% binomial_less_binomial_Suc
thf(fact_2929_binomial__strict__antimono,axiom,
    ! [K: nat,K7: nat,N2: nat] :
      ( ( ord_less @ nat @ K @ K7 )
     => ( ( ord_less_eq @ nat @ N2 @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ K ) )
       => ( ( ord_less_eq @ nat @ K7 @ N2 )
         => ( ord_less @ nat @ ( binomial @ N2 @ K7 ) @ ( binomial @ N2 @ K ) ) ) ) ) ).

% binomial_strict_antimono
thf(fact_2930_binomial__strict__mono,axiom,
    ! [K: nat,K7: nat,N2: nat] :
      ( ( ord_less @ nat @ K @ K7 )
     => ( ( ord_less_eq @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ K7 ) @ N2 )
       => ( ord_less @ nat @ ( binomial @ N2 @ K ) @ ( binomial @ N2 @ K7 ) ) ) ) ).

% binomial_strict_mono
thf(fact_2931_central__binomial__odd,axiom,
    ! [N2: nat] :
      ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 )
     => ( ( binomial @ N2 @ ( suc @ ( divide_divide @ nat @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
        = ( binomial @ N2 @ ( divide_divide @ nat @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% central_binomial_odd
thf(fact_2932_binomial__addition__formula,axiom,
    ! [N2: nat,K: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( binomial @ N2 @ ( suc @ K ) )
        = ( plus_plus @ nat @ ( binomial @ ( minus_minus @ nat @ N2 @ ( one_one @ nat ) ) @ ( suc @ K ) ) @ ( binomial @ ( minus_minus @ nat @ N2 @ ( one_one @ nat ) ) @ K ) ) ) ) ).

% binomial_addition_formula
thf(fact_2933_square__fact__le__2__fact,axiom,
    ! [N2: nat] : ( ord_less_eq @ real @ ( times_times @ real @ ( semiring_char_0_fact @ real @ N2 ) @ ( semiring_char_0_fact @ real @ N2 ) ) @ ( semiring_char_0_fact @ real @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) ) ).

% square_fact_le_2_fact
thf(fact_2934_ln__one__minus__pos__upper__bound,axiom,
    ! [X2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( ord_less @ real @ X2 @ ( one_one @ real ) )
       => ( ord_less_eq @ real @ ( ln_ln @ real @ ( minus_minus @ real @ ( one_one @ real ) @ X2 ) ) @ ( uminus_uminus @ real @ X2 ) ) ) ) ).

% ln_one_minus_pos_upper_bound
thf(fact_2935_cos__coeff__def,axiom,
    ( cos_coeff
    = ( ^ [N3: nat] : ( if @ real @ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N3 ) @ ( divide_divide @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ ( divide_divide @ nat @ N3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( semiring_char_0_fact @ real @ N3 ) ) @ ( zero_zero @ real ) ) ) ) ).

% cos_coeff_def
thf(fact_2936_gbinomial__factors,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: A,K: nat] :
          ( ( gbinomial @ A @ ( plus_plus @ A @ A2 @ ( one_one @ A ) ) @ ( suc @ K ) )
          = ( times_times @ A @ ( divide_divide @ A @ ( plus_plus @ A @ A2 @ ( one_one @ A ) ) @ ( semiring_1_of_nat @ A @ ( suc @ K ) ) ) @ ( gbinomial @ A @ A2 @ K ) ) ) ) ).

% gbinomial_factors
thf(fact_2937_gbinomial__rec,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: A,K: nat] :
          ( ( gbinomial @ A @ ( plus_plus @ A @ A2 @ ( one_one @ A ) ) @ ( suc @ K ) )
          = ( times_times @ A @ ( gbinomial @ A @ A2 @ K ) @ ( divide_divide @ A @ ( plus_plus @ A @ A2 @ ( one_one @ A ) ) @ ( semiring_1_of_nat @ A @ ( suc @ K ) ) ) ) ) ) ).

% gbinomial_rec
thf(fact_2938_gbinomial__index__swap,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [K: nat,N2: nat] :
          ( ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ K ) @ ( gbinomial @ A @ ( minus_minus @ A @ ( uminus_uminus @ A @ ( semiring_1_of_nat @ A @ N2 ) ) @ ( one_one @ A ) ) @ K ) )
          = ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ N2 ) @ ( gbinomial @ A @ ( minus_minus @ A @ ( uminus_uminus @ A @ ( semiring_1_of_nat @ A @ K ) ) @ ( one_one @ A ) ) @ N2 ) ) ) ) ).

% gbinomial_index_swap
thf(fact_2939_gbinomial__negated__upper,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ( ( gbinomial @ A )
        = ( ^ [A4: A,K3: nat] : ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ K3 ) @ ( gbinomial @ A @ ( minus_minus @ A @ ( minus_minus @ A @ ( semiring_1_of_nat @ A @ K3 ) @ A4 ) @ ( one_one @ A ) ) @ K3 ) ) ) ) ) ).

% gbinomial_negated_upper
thf(fact_2940_fact__num__eq__if,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ( ( semiring_char_0_fact @ A )
        = ( ^ [M6: nat] :
              ( if @ A
              @ ( M6
                = ( zero_zero @ nat ) )
              @ ( one_one @ A )
              @ ( times_times @ A @ ( semiring_1_of_nat @ A @ M6 ) @ ( semiring_char_0_fact @ A @ ( minus_minus @ nat @ M6 @ ( one_one @ nat ) ) ) ) ) ) ) ) ).

% fact_num_eq_if
thf(fact_2941_fact__code,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ( ( semiring_char_0_fact @ A )
        = ( ^ [N3: nat] : ( semiring_1_of_nat @ A @ ( set_fo6178422350223883121st_nat @ nat @ ( times_times @ nat ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N3 @ ( one_one @ nat ) ) ) ) ) ) ).

% fact_code
thf(fact_2942_fact__reduce,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [N2: nat] :
          ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
         => ( ( semiring_char_0_fact @ A @ N2 )
            = ( times_times @ A @ ( semiring_1_of_nat @ A @ N2 ) @ ( semiring_char_0_fact @ A @ ( minus_minus @ nat @ N2 @ ( one_one @ nat ) ) ) ) ) ) ) ).

% fact_reduce
thf(fact_2943_pochhammer__same,axiom,
    ! [A: $tType] :
      ( ( ( semiring_char_0 @ A )
        & ( comm_ring_1 @ A )
        & ( semiri3467727345109120633visors @ A ) )
     => ! [N2: nat] :
          ( ( comm_s3205402744901411588hammer @ A @ ( uminus_uminus @ A @ ( semiring_1_of_nat @ A @ N2 ) ) @ N2 )
          = ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ N2 ) @ ( semiring_char_0_fact @ A @ N2 ) ) ) ) ).

% pochhammer_same
thf(fact_2944_choose__two,axiom,
    ! [N2: nat] :
      ( ( binomial @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
      = ( divide_divide @ nat @ ( times_times @ nat @ N2 @ ( minus_minus @ nat @ N2 @ ( one_one @ nat ) ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ).

% choose_two
thf(fact_2945_gbinomial__minus,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: A,K: nat] :
          ( ( gbinomial @ A @ ( uminus_uminus @ A @ A2 ) @ K )
          = ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ K ) @ ( gbinomial @ A @ ( minus_minus @ A @ ( plus_plus @ A @ A2 @ ( semiring_1_of_nat @ A @ K ) ) @ ( one_one @ A ) ) @ K ) ) ) ) ).

% gbinomial_minus
thf(fact_2946_gbinomial__reduce__nat,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [K: nat,A2: A] :
          ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
         => ( ( gbinomial @ A @ A2 @ K )
            = ( plus_plus @ A @ ( gbinomial @ A @ ( minus_minus @ A @ A2 @ ( one_one @ A ) ) @ ( minus_minus @ nat @ K @ ( one_one @ nat ) ) ) @ ( gbinomial @ A @ ( minus_minus @ A @ A2 @ ( one_one @ A ) ) @ K ) ) ) ) ) ).

% gbinomial_reduce_nat
thf(fact_2947_Maclaurin__zero,axiom,
    ! [A: $tType] :
      ( ( zero @ A )
     => ! [X2: real,N2: nat,Diff: nat > A > real] :
          ( ( X2
            = ( zero_zero @ real ) )
         => ( ( N2
             != ( zero_zero @ nat ) )
           => ( ( groups7311177749621191930dd_sum @ nat @ real
                @ ^ [M6: nat] : ( times_times @ real @ ( divide_divide @ real @ ( Diff @ M6 @ ( zero_zero @ A ) ) @ ( semiring_char_0_fact @ real @ M6 ) ) @ ( power_power @ real @ X2 @ M6 ) )
                @ ( set_ord_lessThan @ nat @ N2 ) )
              = ( Diff @ ( zero_zero @ nat ) @ ( zero_zero @ A ) ) ) ) ) ) ).

% Maclaurin_zero
thf(fact_2948_Maclaurin__lemma,axiom,
    ! [H2: real,F2: real > real,J: nat > real,N2: nat] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ H2 )
     => ? [B9: real] :
          ( ( F2 @ H2 )
          = ( plus_plus @ real
            @ ( groups7311177749621191930dd_sum @ nat @ real
              @ ^ [M6: nat] : ( times_times @ real @ ( divide_divide @ real @ ( J @ M6 ) @ ( semiring_char_0_fact @ real @ M6 ) ) @ ( power_power @ real @ H2 @ M6 ) )
              @ ( set_ord_lessThan @ nat @ N2 ) )
            @ ( times_times @ real @ B9 @ ( divide_divide @ real @ ( power_power @ real @ H2 @ N2 ) @ ( semiring_char_0_fact @ real @ N2 ) ) ) ) ) ) ).

% Maclaurin_lemma
thf(fact_2949_ln__one__plus__pos__lower__bound,axiom,
    ! [X2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( ord_less_eq @ real @ X2 @ ( one_one @ real ) )
       => ( ord_less_eq @ real @ ( minus_minus @ real @ X2 @ ( power_power @ real @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( ln_ln @ real @ ( plus_plus @ real @ ( one_one @ real ) @ X2 ) ) ) ) ) ).

% ln_one_plus_pos_lower_bound
thf(fact_2950_gbinomial__sum__up__index,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [K: nat,N2: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [J3: nat] : ( gbinomial @ A @ ( semiring_1_of_nat @ A @ J3 ) @ K )
            @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N2 ) )
          = ( gbinomial @ A @ ( plus_plus @ A @ ( semiring_1_of_nat @ A @ N2 ) @ ( one_one @ A ) ) @ ( plus_plus @ nat @ K @ ( one_one @ nat ) ) ) ) ) ).

% gbinomial_sum_up_index
thf(fact_2951_gbinomial__absorption_H,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [K: nat,A2: A] :
          ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
         => ( ( gbinomial @ A @ A2 @ K )
            = ( times_times @ A @ ( divide_divide @ A @ A2 @ ( semiring_1_of_nat @ A @ K ) ) @ ( gbinomial @ A @ ( minus_minus @ A @ A2 @ ( one_one @ A ) ) @ ( minus_minus @ nat @ K @ ( one_one @ nat ) ) ) ) ) ) ) ).

% gbinomial_absorption'
thf(fact_2952_sin__coeff__def,axiom,
    ( sin_coeff
    = ( ^ [N3: nat] : ( if @ real @ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N3 ) @ ( zero_zero @ real ) @ ( divide_divide @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ ( divide_divide @ nat @ ( minus_minus @ nat @ N3 @ ( suc @ ( zero_zero @ nat ) ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( semiring_char_0_fact @ real @ N3 ) ) ) ) ) ).

% sin_coeff_def
thf(fact_2953_ln__series,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( ord_less @ real @ X2 @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) )
       => ( ( ln_ln @ real @ X2 )
          = ( suminf @ real
            @ ^ [N3: nat] : ( times_times @ real @ ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ N3 ) @ ( divide_divide @ real @ ( one_one @ real ) @ ( semiring_1_of_nat @ real @ ( plus_plus @ nat @ N3 @ ( one_one @ nat ) ) ) ) ) @ ( power_power @ real @ ( minus_minus @ real @ X2 @ ( one_one @ real ) ) @ ( suc @ N3 ) ) ) ) ) ) ) ).

% ln_series
thf(fact_2954_abs__ln__one__plus__x__minus__x__bound__nonpos,axiom,
    ! [X2: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ X2 )
     => ( ( ord_less_eq @ real @ X2 @ ( zero_zero @ real ) )
       => ( ord_less_eq @ real @ ( abs_abs @ real @ ( minus_minus @ real @ ( ln_ln @ real @ ( plus_plus @ real @ ( one_one @ real ) @ X2 ) ) @ X2 ) ) @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( power_power @ real @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% abs_ln_one_plus_x_minus_x_bound_nonpos
thf(fact_2955_tanh__ln__real,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( tanh @ real @ ( ln_ln @ real @ X2 ) )
        = ( divide_divide @ real @ ( minus_minus @ real @ ( power_power @ real @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ real ) ) @ ( plus_plus @ real @ ( power_power @ real @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ real ) ) ) ) ) ).

% tanh_ln_real
thf(fact_2956_gbinomial__partial__row__sum,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: A,M: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [K3: nat] : ( times_times @ A @ ( gbinomial @ A @ A2 @ K3 ) @ ( minus_minus @ A @ ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( semiring_1_of_nat @ A @ K3 ) ) )
            @ ( set_ord_atMost @ nat @ M ) )
          = ( times_times @ A @ ( divide_divide @ A @ ( plus_plus @ A @ ( semiring_1_of_nat @ A @ M ) @ ( one_one @ A ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( gbinomial @ A @ A2 @ ( plus_plus @ nat @ M @ ( one_one @ nat ) ) ) ) ) ) ).

% gbinomial_partial_row_sum
thf(fact_2957_choose__even__sum,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [N2: nat] :
          ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
         => ( ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) )
              @ ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I4: nat] : ( if @ A @ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ I4 ) @ ( semiring_1_of_nat @ A @ ( binomial @ N2 @ I4 ) ) @ ( zero_zero @ A ) )
                @ ( set_ord_atMost @ nat @ N2 ) ) )
            = ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N2 ) ) ) ) ).

% choose_even_sum
thf(fact_2958_abs__idempotent,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A] :
          ( ( abs_abs @ A @ ( abs_abs @ A @ A2 ) )
          = ( abs_abs @ A @ A2 ) ) ) ).

% abs_idempotent
thf(fact_2959_abs__abs,axiom,
    ! [A: $tType] :
      ( ( idom_abs_sgn @ A )
     => ! [A2: A] :
          ( ( abs_abs @ A @ ( abs_abs @ A @ A2 ) )
          = ( abs_abs @ A @ A2 ) ) ) ).

% abs_abs
thf(fact_2960_abs__0,axiom,
    ! [A: $tType] :
      ( ( idom_abs_sgn @ A )
     => ( ( abs_abs @ A @ ( zero_zero @ A ) )
        = ( zero_zero @ A ) ) ) ).

% abs_0
thf(fact_2961_abs__0__eq,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A] :
          ( ( ( zero_zero @ A )
            = ( abs_abs @ A @ A2 ) )
          = ( A2
            = ( zero_zero @ A ) ) ) ) ).

% abs_0_eq
thf(fact_2962_abs__eq__0,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A] :
          ( ( ( abs_abs @ A @ A2 )
            = ( zero_zero @ A ) )
          = ( A2
            = ( zero_zero @ A ) ) ) ) ).

% abs_eq_0
thf(fact_2963_abs__zero,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ( ( abs_abs @ A @ ( zero_zero @ A ) )
        = ( zero_zero @ A ) ) ) ).

% abs_zero
thf(fact_2964_abs__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N2: num] :
          ( ( abs_abs @ A @ ( numeral_numeral @ A @ N2 ) )
          = ( numeral_numeral @ A @ N2 ) ) ) ).

% abs_numeral
thf(fact_2965_abs__mult__self__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A] :
          ( ( times_times @ A @ ( abs_abs @ A @ A2 ) @ ( abs_abs @ A @ A2 ) )
          = ( times_times @ A @ A2 @ A2 ) ) ) ).

% abs_mult_self_eq
thf(fact_2966_abs__1,axiom,
    ! [A: $tType] :
      ( ( idom_abs_sgn @ A )
     => ( ( abs_abs @ A @ ( one_one @ A ) )
        = ( one_one @ A ) ) ) ).

% abs_1
thf(fact_2967_abs__add__abs,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A,B2: A] :
          ( ( abs_abs @ A @ ( plus_plus @ A @ ( abs_abs @ A @ A2 ) @ ( abs_abs @ A @ B2 ) ) )
          = ( plus_plus @ A @ ( abs_abs @ A @ A2 ) @ ( abs_abs @ A @ B2 ) ) ) ) ).

% abs_add_abs
thf(fact_2968_abs__divide,axiom,
    ! [A: $tType] :
      ( ( field_abs_sgn @ A )
     => ! [A2: A,B2: A] :
          ( ( abs_abs @ A @ ( divide_divide @ A @ A2 @ B2 ) )
          = ( divide_divide @ A @ ( abs_abs @ A @ A2 ) @ ( abs_abs @ A @ B2 ) ) ) ) ).

% abs_divide
thf(fact_2969_abs__minus__cancel,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A] :
          ( ( abs_abs @ A @ ( uminus_uminus @ A @ A2 ) )
          = ( abs_abs @ A @ A2 ) ) ) ).

% abs_minus_cancel
thf(fact_2970_abs__minus,axiom,
    ! [A: $tType] :
      ( ( idom_abs_sgn @ A )
     => ! [A2: A] :
          ( ( abs_abs @ A @ ( uminus_uminus @ A @ A2 ) )
          = ( abs_abs @ A @ A2 ) ) ) ).

% abs_minus
thf(fact_2971_dvd__abs__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M: A,K: A] :
          ( ( dvd_dvd @ A @ M @ ( abs_abs @ A @ K ) )
          = ( dvd_dvd @ A @ M @ K ) ) ) ).

% dvd_abs_iff
thf(fact_2972_abs__dvd__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M: A,K: A] :
          ( ( dvd_dvd @ A @ ( abs_abs @ A @ M ) @ K )
          = ( dvd_dvd @ A @ M @ K ) ) ) ).

% abs_dvd_iff
thf(fact_2973_atMost__iff,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [I3: A,K: A] :
          ( ( member @ A @ I3 @ ( set_ord_atMost @ A @ K ) )
          = ( ord_less_eq @ A @ I3 @ K ) ) ) ).

% atMost_iff
thf(fact_2974_abs__of__nat,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N2: nat] :
          ( ( abs_abs @ A @ ( semiring_1_of_nat @ A @ N2 ) )
          = ( semiring_1_of_nat @ A @ N2 ) ) ) ).

% abs_of_nat
thf(fact_2975_abs__bool__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [P: $o] :
          ( ( abs_abs @ A @ ( zero_neq_one_of_bool @ A @ P ) )
          = ( zero_neq_one_of_bool @ A @ P ) ) ) ).

% abs_bool_eq
thf(fact_2976_tanh__0,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ( ( tanh @ A @ ( zero_zero @ A ) )
        = ( zero_zero @ A ) ) ) ).

% tanh_0
thf(fact_2977_tanh__real__zero__iff,axiom,
    ! [X2: real] :
      ( ( ( tanh @ real @ X2 )
        = ( zero_zero @ real ) )
      = ( X2
        = ( zero_zero @ real ) ) ) ).

% tanh_real_zero_iff
thf(fact_2978_tanh__real__less__iff,axiom,
    ! [X2: real,Y2: real] :
      ( ( ord_less @ real @ ( tanh @ real @ X2 ) @ ( tanh @ real @ Y2 ) )
      = ( ord_less @ real @ X2 @ Y2 ) ) ).

% tanh_real_less_iff
thf(fact_2979_tanh__real__le__iff,axiom,
    ! [X2: real,Y2: real] :
      ( ( ord_less_eq @ real @ ( tanh @ real @ X2 ) @ ( tanh @ real @ Y2 ) )
      = ( ord_less_eq @ real @ X2 @ Y2 ) ) ).

% tanh_real_le_iff
thf(fact_2980_suminf__zero,axiom,
    ! [A: $tType] :
      ( ( ( comm_monoid_add @ A )
        & ( topological_t2_space @ A ) )
     => ( ( suminf @ A
          @ ^ [N3: nat] : ( zero_zero @ A ) )
        = ( zero_zero @ A ) ) ) ).

% suminf_zero
thf(fact_2981_abs__of__nonneg,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( abs_abs @ A @ A2 )
            = A2 ) ) ) ).

% abs_of_nonneg
thf(fact_2982_abs__le__self__iff,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ ( abs_abs @ A @ A2 ) @ A2 )
          = ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 ) ) ) ).

% abs_le_self_iff
thf(fact_2983_abs__le__zero__iff,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ ( abs_abs @ A @ A2 ) @ ( zero_zero @ A ) )
          = ( A2
            = ( zero_zero @ A ) ) ) ) ).

% abs_le_zero_iff
thf(fact_2984_zero__less__abs__iff,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( abs_abs @ A @ A2 ) )
          = ( ( A2
             != ( zero_zero @ A ) ) ) ) ) ).

% zero_less_abs_iff
thf(fact_2985_abs__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N2: num] :
          ( ( abs_abs @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N2 ) ) )
          = ( numeral_numeral @ A @ N2 ) ) ) ).

% abs_neg_numeral
thf(fact_2986_abs__neg__one,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ( ( abs_abs @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
        = ( one_one @ A ) ) ) ).

% abs_neg_one
thf(fact_2987_abs__power__minus,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A,N2: nat] :
          ( ( abs_abs @ A @ ( power_power @ A @ ( uminus_uminus @ A @ A2 ) @ N2 ) )
          = ( abs_abs @ A @ ( power_power @ A @ A2 @ N2 ) ) ) ) ).

% abs_power_minus
thf(fact_2988_atMost__subset__iff,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [X2: A,Y2: A] :
          ( ( ord_less_eq @ ( set @ A ) @ ( set_ord_atMost @ A @ X2 ) @ ( set_ord_atMost @ A @ Y2 ) )
          = ( ord_less_eq @ A @ X2 @ Y2 ) ) ) ).

% atMost_subset_iff
thf(fact_2989_tanh__real__neg__iff,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( tanh @ real @ X2 ) @ ( zero_zero @ real ) )
      = ( ord_less @ real @ X2 @ ( zero_zero @ real ) ) ) ).

% tanh_real_neg_iff
thf(fact_2990_tanh__real__pos__iff,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ ( tanh @ real @ X2 ) )
      = ( ord_less @ real @ ( zero_zero @ real ) @ X2 ) ) ).

% tanh_real_pos_iff
thf(fact_2991_tanh__real__nonneg__iff,axiom,
    ! [X2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( tanh @ real @ X2 ) )
      = ( ord_less_eq @ real @ ( zero_zero @ real ) @ X2 ) ) ).

% tanh_real_nonneg_iff
thf(fact_2992_tanh__real__nonpos__iff,axiom,
    ! [X2: real] :
      ( ( ord_less_eq @ real @ ( tanh @ real @ X2 ) @ ( zero_zero @ real ) )
      = ( ord_less_eq @ real @ X2 @ ( zero_zero @ real ) ) ) ).

% tanh_real_nonpos_iff
thf(fact_2993_sin__coeff__0,axiom,
    ( ( sin_coeff @ ( zero_zero @ nat ) )
    = ( zero_zero @ real ) ) ).

% sin_coeff_0
thf(fact_2994_sum__abs,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ordere166539214618696060dd_abs @ B )
     => ! [F2: A > B,A3: set @ A] :
          ( ord_less_eq @ B @ ( abs_abs @ B @ ( groups7311177749621191930dd_sum @ A @ B @ F2 @ A3 ) )
          @ ( groups7311177749621191930dd_sum @ A @ B
            @ ^ [I4: A] : ( abs_abs @ B @ ( F2 @ I4 ) )
            @ A3 ) ) ) ).

% sum_abs
thf(fact_2995_divide__le__0__abs__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( divide_divide @ A @ A2 @ ( abs_abs @ A @ B2 ) ) @ ( zero_zero @ A ) )
          = ( ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) )
            | ( B2
              = ( zero_zero @ A ) ) ) ) ) ).

% divide_le_0_abs_iff
thf(fact_2996_zero__le__divide__abs__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( divide_divide @ A @ A2 @ ( abs_abs @ A @ B2 ) ) )
          = ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
            | ( B2
              = ( zero_zero @ A ) ) ) ) ) ).

% zero_le_divide_abs_iff
thf(fact_2997_abs__of__nonpos,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) )
         => ( ( abs_abs @ A @ A2 )
            = ( uminus_uminus @ A @ A2 ) ) ) ) ).

% abs_of_nonpos
thf(fact_2998_Icc__subset__Iic__iff,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [L: A,H2: A,H3: A] :
          ( ( ord_less_eq @ ( set @ A ) @ ( set_or1337092689740270186AtMost @ A @ L @ H2 ) @ ( set_ord_atMost @ A @ H3 ) )
          = ( ~ ( ord_less_eq @ A @ L @ H2 )
            | ( ord_less_eq @ A @ H2 @ H3 ) ) ) ) ).

% Icc_subset_Iic_iff
thf(fact_2999_sum_OatMost__Suc,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,N2: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_ord_atMost @ nat @ ( suc @ N2 ) ) )
          = ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_ord_atMost @ nat @ N2 ) ) @ ( G @ ( suc @ N2 ) ) ) ) ) ).

% sum.atMost_Suc
thf(fact_3000_prod_OatMost__Suc,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,N2: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_ord_atMost @ nat @ ( suc @ N2 ) ) )
          = ( times_times @ A @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_ord_atMost @ nat @ N2 ) ) @ ( G @ ( suc @ N2 ) ) ) ) ) ).

% prod.atMost_Suc
thf(fact_3001_artanh__minus__real,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( abs_abs @ real @ X2 ) @ ( one_one @ real ) )
     => ( ( artanh @ real @ ( uminus_uminus @ real @ X2 ) )
        = ( uminus_uminus @ real @ ( artanh @ real @ X2 ) ) ) ) ).

% artanh_minus_real
thf(fact_3002_sum__abs__ge__zero,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ordere166539214618696060dd_abs @ B )
     => ! [F2: A > B,A3: set @ A] :
          ( ord_less_eq @ B @ ( zero_zero @ B )
          @ ( groups7311177749621191930dd_sum @ A @ B
            @ ^ [I4: A] : ( abs_abs @ B @ ( F2 @ I4 ) )
            @ A3 ) ) ) ).

% sum_abs_ge_zero
thf(fact_3003_zero__less__power__abs__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A,N2: nat] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( power_power @ A @ ( abs_abs @ A @ A2 ) @ N2 ) )
          = ( ( A2
             != ( zero_zero @ A ) )
            | ( N2
              = ( zero_zero @ nat ) ) ) ) ) ).

% zero_less_power_abs_iff
thf(fact_3004_abs__power2,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A] :
          ( ( abs_abs @ A @ ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
          = ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ).

% abs_power2
thf(fact_3005_power2__abs,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A] :
          ( ( power_power @ A @ ( abs_abs @ A @ A2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
          = ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ).

% power2_abs
thf(fact_3006_powser__zero,axiom,
    ! [A: $tType] :
      ( ( real_V2822296259951069270ebra_1 @ A )
     => ! [F2: nat > A] :
          ( ( suminf @ A
            @ ^ [N3: nat] : ( times_times @ A @ ( F2 @ N3 ) @ ( power_power @ A @ ( zero_zero @ A ) @ N3 ) ) )
          = ( F2 @ ( zero_zero @ nat ) ) ) ) ).

% powser_zero
thf(fact_3007_power__even__abs__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [W: num,A2: A] :
          ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( numeral_numeral @ nat @ W ) )
         => ( ( power_power @ A @ ( abs_abs @ A @ A2 ) @ ( numeral_numeral @ nat @ W ) )
            = ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ W ) ) ) ) ) ).

% power_even_abs_numeral
thf(fact_3008_abs__minus__commute,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A,B2: A] :
          ( ( abs_abs @ A @ ( minus_minus @ A @ A2 @ B2 ) )
          = ( abs_abs @ A @ ( minus_minus @ A @ B2 @ A2 ) ) ) ) ).

% abs_minus_commute
thf(fact_3009_abs__eq__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_ring @ A )
     => ! [X2: A,Y2: A] :
          ( ( ( abs_abs @ A @ X2 )
            = ( abs_abs @ A @ Y2 ) )
          = ( ( X2 = Y2 )
            | ( X2
              = ( uminus_uminus @ A @ Y2 ) ) ) ) ) ).

% abs_eq_iff
thf(fact_3010_abs__ge__self,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A] : ( ord_less_eq @ A @ A2 @ ( abs_abs @ A @ A2 ) ) ) ).

% abs_ge_self
thf(fact_3011_abs__le__D1,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( abs_abs @ A @ A2 ) @ B2 )
         => ( ord_less_eq @ A @ A2 @ B2 ) ) ) ).

% abs_le_D1
thf(fact_3012_abs__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( idom_abs_sgn @ A )
     => ! [A2: A] :
          ( ( ( abs_abs @ A @ A2 )
            = ( zero_zero @ A ) )
          = ( A2
            = ( zero_zero @ A ) ) ) ) ).

% abs_eq_0_iff
thf(fact_3013_abs__one,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ( ( abs_abs @ A @ ( one_one @ A ) )
        = ( one_one @ A ) ) ) ).

% abs_one
thf(fact_3014_abs__mult,axiom,
    ! [A: $tType] :
      ( ( idom_abs_sgn @ A )
     => ! [A2: A,B2: A] :
          ( ( abs_abs @ A @ ( times_times @ A @ A2 @ B2 ) )
          = ( times_times @ A @ ( abs_abs @ A @ A2 ) @ ( abs_abs @ A @ B2 ) ) ) ) ).

% abs_mult
thf(fact_3015_power__abs,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A,N2: nat] :
          ( ( abs_abs @ A @ ( power_power @ A @ A2 @ N2 ) )
          = ( power_power @ A @ ( abs_abs @ A @ A2 ) @ N2 ) ) ) ).

% power_abs
thf(fact_3016_dvd__if__abs__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [L: A,K: A] :
          ( ( ( abs_abs @ A @ L )
            = ( abs_abs @ A @ K ) )
         => ( dvd_dvd @ A @ L @ K ) ) ) ).

% dvd_if_abs_eq
thf(fact_3017_atMost__def,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ( ( set_ord_atMost @ A )
        = ( ^ [U2: A] :
              ( collect @ A
              @ ^ [X5: A] : ( ord_less_eq @ A @ X5 @ U2 ) ) ) ) ) ).

% atMost_def
thf(fact_3018_abs__ge__zero,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( abs_abs @ A @ A2 ) ) ) ).

% abs_ge_zero
thf(fact_3019_abs__of__pos,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( abs_abs @ A @ A2 )
            = A2 ) ) ) ).

% abs_of_pos
thf(fact_3020_abs__not__less__zero,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A] :
          ~ ( ord_less @ A @ ( abs_abs @ A @ A2 ) @ ( zero_zero @ A ) ) ) ).

% abs_not_less_zero
thf(fact_3021_abs__triangle__ineq,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A,B2: A] : ( ord_less_eq @ A @ ( abs_abs @ A @ ( plus_plus @ A @ A2 @ B2 ) ) @ ( plus_plus @ A @ ( abs_abs @ A @ A2 ) @ ( abs_abs @ A @ B2 ) ) ) ) ).

% abs_triangle_ineq
thf(fact_3022_abs__mult__less,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A,C2: A,B2: A,D2: A] :
          ( ( ord_less @ A @ ( abs_abs @ A @ A2 ) @ C2 )
         => ( ( ord_less @ A @ ( abs_abs @ A @ B2 ) @ D2 )
           => ( ord_less @ A @ ( times_times @ A @ ( abs_abs @ A @ A2 ) @ ( abs_abs @ A @ B2 ) ) @ ( times_times @ A @ C2 @ D2 ) ) ) ) ) ).

% abs_mult_less
thf(fact_3023_abs__triangle__ineq2,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A,B2: A] : ( ord_less_eq @ A @ ( minus_minus @ A @ ( abs_abs @ A @ A2 ) @ ( abs_abs @ A @ B2 ) ) @ ( abs_abs @ A @ ( minus_minus @ A @ A2 @ B2 ) ) ) ) ).

% abs_triangle_ineq2
thf(fact_3024_abs__triangle__ineq3,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A,B2: A] : ( ord_less_eq @ A @ ( abs_abs @ A @ ( minus_minus @ A @ ( abs_abs @ A @ A2 ) @ ( abs_abs @ A @ B2 ) ) ) @ ( abs_abs @ A @ ( minus_minus @ A @ A2 @ B2 ) ) ) ) ).

% abs_triangle_ineq3
thf(fact_3025_abs__triangle__ineq2__sym,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A,B2: A] : ( ord_less_eq @ A @ ( minus_minus @ A @ ( abs_abs @ A @ A2 ) @ ( abs_abs @ A @ B2 ) ) @ ( abs_abs @ A @ ( minus_minus @ A @ B2 @ A2 ) ) ) ) ).

% abs_triangle_ineq2_sym
thf(fact_3026_nonzero__abs__divide,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,A2: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( abs_abs @ A @ ( divide_divide @ A @ A2 @ B2 ) )
            = ( divide_divide @ A @ ( abs_abs @ A @ A2 ) @ ( abs_abs @ A @ B2 ) ) ) ) ) ).

% nonzero_abs_divide
thf(fact_3027_abs__ge__minus__self,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A] : ( ord_less_eq @ A @ ( uminus_uminus @ A @ A2 ) @ ( abs_abs @ A @ A2 ) ) ) ).

% abs_ge_minus_self
thf(fact_3028_abs__le__iff,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( abs_abs @ A @ A2 ) @ B2 )
          = ( ( ord_less_eq @ A @ A2 @ B2 )
            & ( ord_less_eq @ A @ ( uminus_uminus @ A @ A2 ) @ B2 ) ) ) ) ).

% abs_le_iff
thf(fact_3029_abs__le__D2,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( abs_abs @ A @ A2 ) @ B2 )
         => ( ord_less_eq @ A @ ( uminus_uminus @ A @ A2 ) @ B2 ) ) ) ).

% abs_le_D2
thf(fact_3030_abs__leI,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ A2 ) @ B2 )
           => ( ord_less_eq @ A @ ( abs_abs @ A @ A2 ) @ B2 ) ) ) ) ).

% abs_leI
thf(fact_3031_abs__less__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( abs_abs @ A @ A2 ) @ B2 )
          = ( ( ord_less @ A @ A2 @ B2 )
            & ( ord_less @ A @ ( uminus_uminus @ A @ A2 ) @ B2 ) ) ) ) ).

% abs_less_iff
thf(fact_3032_atMost__atLeast0,axiom,
    ( ( set_ord_atMost @ nat )
    = ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) ) ) ).

% atMost_atLeast0
thf(fact_3033_lessThan__Suc__atMost,axiom,
    ! [K: nat] :
      ( ( set_ord_lessThan @ nat @ ( suc @ K ) )
      = ( set_ord_atMost @ nat @ K ) ) ).

% lessThan_Suc_atMost
thf(fact_3034_not__Iic__le__Icc,axiom,
    ! [A: $tType] :
      ( ( no_bot @ A )
     => ! [H2: A,L3: A,H3: A] :
          ~ ( ord_less_eq @ ( set @ A ) @ ( set_ord_atMost @ A @ H2 ) @ ( set_or1337092689740270186AtMost @ A @ L3 @ H3 ) ) ) ).

% not_Iic_le_Icc
thf(fact_3035_tanh__real__lt__1,axiom,
    ! [X2: real] : ( ord_less @ real @ ( tanh @ real @ X2 ) @ ( one_one @ real ) ) ).

% tanh_real_lt_1
thf(fact_3036_dense__eq0__I,axiom,
    ! [A: $tType] :
      ( ( ( ordere166539214618696060dd_abs @ A )
        & ( dense_linorder @ A ) )
     => ! [X2: A] :
          ( ! [E: A] :
              ( ( ord_less @ A @ ( zero_zero @ A ) @ E )
             => ( ord_less_eq @ A @ ( abs_abs @ A @ X2 ) @ E ) )
         => ( X2
            = ( zero_zero @ A ) ) ) ) ).

% dense_eq0_I
thf(fact_3037_abs__mult__pos,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X2: A,Y2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X2 )
         => ( ( times_times @ A @ ( abs_abs @ A @ Y2 ) @ X2 )
            = ( abs_abs @ A @ ( times_times @ A @ Y2 @ X2 ) ) ) ) ) ).

% abs_mult_pos
thf(fact_3038_abs__eq__mult,axiom,
    ! [A: $tType] :
      ( ( ordered_ring_abs @ A )
     => ! [A2: A,B2: A] :
          ( ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
              | ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) ) )
            & ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 )
              | ( ord_less_eq @ A @ B2 @ ( zero_zero @ A ) ) ) )
         => ( ( abs_abs @ A @ ( times_times @ A @ A2 @ B2 ) )
            = ( times_times @ A @ ( abs_abs @ A @ A2 ) @ ( abs_abs @ A @ B2 ) ) ) ) ) ).

% abs_eq_mult
thf(fact_3039_abs__eq__iff_H,axiom,
    ! [A: $tType] :
      ( ( linordered_ring @ A )
     => ! [A2: A,B2: A] :
          ( ( ( abs_abs @ A @ A2 )
            = B2 )
          = ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 )
            & ( ( A2 = B2 )
              | ( A2
                = ( uminus_uminus @ A @ B2 ) ) ) ) ) ) ).

% abs_eq_iff'
thf(fact_3040_eq__abs__iff_H,axiom,
    ! [A: $tType] :
      ( ( linordered_ring @ A )
     => ! [A2: A,B2: A] :
          ( ( A2
            = ( abs_abs @ A @ B2 ) )
          = ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
            & ( ( B2 = A2 )
              | ( B2
                = ( uminus_uminus @ A @ A2 ) ) ) ) ) ) ).

% eq_abs_iff'
thf(fact_3041_abs__minus__le__zero,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A] : ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( abs_abs @ A @ A2 ) ) @ ( zero_zero @ A ) ) ) ).

% abs_minus_le_zero
thf(fact_3042_abs__div__pos,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [Y2: A,X2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ Y2 )
         => ( ( divide_divide @ A @ ( abs_abs @ A @ X2 ) @ Y2 )
            = ( abs_abs @ A @ ( divide_divide @ A @ X2 @ Y2 ) ) ) ) ) ).

% abs_div_pos
thf(fact_3043_zero__le__power__abs,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A,N2: nat] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( power_power @ A @ ( abs_abs @ A @ A2 ) @ N2 ) ) ) ).

% zero_le_power_abs
thf(fact_3044_abs__if__raw,axiom,
    ! [A: $tType] :
      ( ( abs_if @ A )
     => ( ( abs_abs @ A )
        = ( ^ [A4: A] : ( if @ A @ ( ord_less @ A @ A4 @ ( zero_zero @ A ) ) @ ( uminus_uminus @ A @ A4 ) @ A4 ) ) ) ) ).

% abs_if_raw
thf(fact_3045_abs__if,axiom,
    ! [A: $tType] :
      ( ( abs_if @ A )
     => ( ( abs_abs @ A )
        = ( ^ [A4: A] : ( if @ A @ ( ord_less @ A @ A4 @ ( zero_zero @ A ) ) @ ( uminus_uminus @ A @ A4 ) @ A4 ) ) ) ) ).

% abs_if
thf(fact_3046_abs__of__neg,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
         => ( ( abs_abs @ A @ A2 )
            = ( uminus_uminus @ A @ A2 ) ) ) ) ).

% abs_of_neg
thf(fact_3047_abs__diff__le__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X2: A,A2: A,R3: A] :
          ( ( ord_less_eq @ A @ ( abs_abs @ A @ ( minus_minus @ A @ X2 @ A2 ) ) @ R3 )
          = ( ( ord_less_eq @ A @ ( minus_minus @ A @ A2 @ R3 ) @ X2 )
            & ( ord_less_eq @ A @ X2 @ ( plus_plus @ A @ A2 @ R3 ) ) ) ) ) ).

% abs_diff_le_iff
thf(fact_3048_abs__triangle__ineq4,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A,B2: A] : ( ord_less_eq @ A @ ( abs_abs @ A @ ( minus_minus @ A @ A2 @ B2 ) ) @ ( plus_plus @ A @ ( abs_abs @ A @ A2 ) @ ( abs_abs @ A @ B2 ) ) ) ) ).

% abs_triangle_ineq4
thf(fact_3049_abs__diff__triangle__ineq,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] : ( ord_less_eq @ A @ ( abs_abs @ A @ ( minus_minus @ A @ ( plus_plus @ A @ A2 @ B2 ) @ ( plus_plus @ A @ C2 @ D2 ) ) ) @ ( plus_plus @ A @ ( abs_abs @ A @ ( minus_minus @ A @ A2 @ C2 ) ) @ ( abs_abs @ A @ ( minus_minus @ A @ B2 @ D2 ) ) ) ) ) ).

% abs_diff_triangle_ineq
thf(fact_3050_abs__diff__less__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X2: A,A2: A,R3: A] :
          ( ( ord_less @ A @ ( abs_abs @ A @ ( minus_minus @ A @ X2 @ A2 ) ) @ R3 )
          = ( ( ord_less @ A @ ( minus_minus @ A @ A2 @ R3 ) @ X2 )
            & ( ord_less @ A @ X2 @ ( plus_plus @ A @ A2 @ R3 ) ) ) ) ) ).

% abs_diff_less_iff
thf(fact_3051_abs__real__def,axiom,
    ( ( abs_abs @ real )
    = ( ^ [A4: real] : ( if @ real @ ( ord_less @ real @ A4 @ ( zero_zero @ real ) ) @ ( uminus_uminus @ real @ A4 ) @ A4 ) ) ) ).

% abs_real_def
thf(fact_3052_lemma__interval__lt,axiom,
    ! [A2: real,X2: real,B2: real] :
      ( ( ord_less @ real @ A2 @ X2 )
     => ( ( ord_less @ real @ X2 @ B2 )
       => ? [D4: real] :
            ( ( ord_less @ real @ ( zero_zero @ real ) @ D4 )
            & ! [Y: real] :
                ( ( ord_less @ real @ ( abs_abs @ real @ ( minus_minus @ real @ X2 @ Y ) ) @ D4 )
               => ( ( ord_less @ real @ A2 @ Y )
                  & ( ord_less @ real @ Y @ B2 ) ) ) ) ) ) ).

% lemma_interval_lt
thf(fact_3053_sin__bound__lemma,axiom,
    ! [X2: real,Y2: real,U: real,V: real] :
      ( ( X2 = Y2 )
     => ( ( ord_less_eq @ real @ ( abs_abs @ real @ U ) @ V )
       => ( ord_less_eq @ real @ ( abs_abs @ real @ ( minus_minus @ real @ ( plus_plus @ real @ X2 @ U ) @ Y2 ) ) @ V ) ) ) ).

% sin_bound_lemma
thf(fact_3054_Iic__subset__Iio__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ ( set @ A ) @ ( set_ord_atMost @ A @ A2 ) @ ( set_ord_lessThan @ A @ B2 ) )
          = ( ord_less @ A @ A2 @ B2 ) ) ) ).

% Iic_subset_Iio_iff
thf(fact_3055_sum__choose__upper,axiom,
    ! [M: nat,N2: nat] :
      ( ( groups7311177749621191930dd_sum @ nat @ nat
        @ ^ [K3: nat] : ( binomial @ K3 @ M )
        @ ( set_ord_atMost @ nat @ N2 ) )
      = ( binomial @ ( suc @ N2 ) @ ( suc @ M ) ) ) ).

% sum_choose_upper
thf(fact_3056_tanh__real__gt__neg1,axiom,
    ! [X2: real] : ( ord_less @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ ( tanh @ real @ X2 ) ) ).

% tanh_real_gt_neg1
thf(fact_3057_abs__add__one__gt__zero,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X2: A] : ( ord_less @ A @ ( zero_zero @ A ) @ ( plus_plus @ A @ ( one_one @ A ) @ ( abs_abs @ A @ X2 ) ) ) ) ).

% abs_add_one_gt_zero
thf(fact_3058_of__int__leD,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N2: int,X2: A] :
          ( ( ord_less_eq @ A @ ( abs_abs @ A @ ( ring_1_of_int @ A @ N2 ) ) @ X2 )
         => ( ( N2
              = ( zero_zero @ int ) )
            | ( ord_less_eq @ A @ ( one_one @ A ) @ X2 ) ) ) ) ).

% of_int_leD
thf(fact_3059_of__int__lessD,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N2: int,X2: A] :
          ( ( ord_less @ A @ ( abs_abs @ A @ ( ring_1_of_int @ A @ N2 ) ) @ X2 )
         => ( ( N2
              = ( zero_zero @ int ) )
            | ( ord_less @ A @ ( one_one @ A ) @ X2 ) ) ) ) ).

% of_int_lessD
thf(fact_3060_lemma__interval,axiom,
    ! [A2: real,X2: real,B2: real] :
      ( ( ord_less @ real @ A2 @ X2 )
     => ( ( ord_less @ real @ X2 @ B2 )
       => ? [D4: real] :
            ( ( ord_less @ real @ ( zero_zero @ real ) @ D4 )
            & ! [Y: real] :
                ( ( ord_less @ real @ ( abs_abs @ real @ ( minus_minus @ real @ X2 @ Y ) ) @ D4 )
               => ( ( ord_less_eq @ real @ A2 @ Y )
                  & ( ord_less_eq @ real @ Y @ B2 ) ) ) ) ) ) ).

% lemma_interval
thf(fact_3061_norm__triangle__ineq3,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [A2: A,B2: A] : ( ord_less_eq @ real @ ( abs_abs @ real @ ( minus_minus @ real @ ( real_V7770717601297561774m_norm @ A @ A2 ) @ ( real_V7770717601297561774m_norm @ A @ B2 ) ) ) @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ A2 @ B2 ) ) ) ) ).

% norm_triangle_ineq3
thf(fact_3062_round__diff__minimal,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [Z: A,M: int] : ( ord_less_eq @ A @ ( abs_abs @ A @ ( minus_minus @ A @ Z @ ( ring_1_of_int @ A @ ( archimedean_round @ A @ Z ) ) ) ) @ ( abs_abs @ A @ ( minus_minus @ A @ Z @ ( ring_1_of_int @ A @ M ) ) ) ) ) ).

% round_diff_minimal
thf(fact_3063_sum_OatMost__Suc__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,N2: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_ord_atMost @ nat @ ( suc @ N2 ) ) )
          = ( plus_plus @ A @ ( G @ ( zero_zero @ nat ) )
            @ ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [I4: nat] : ( G @ ( suc @ I4 ) )
              @ ( set_ord_atMost @ nat @ N2 ) ) ) ) ) ).

% sum.atMost_Suc_shift
thf(fact_3064_sum__telescope,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [F2: nat > A,I3: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [I4: nat] : ( minus_minus @ A @ ( F2 @ I4 ) @ ( F2 @ ( suc @ I4 ) ) )
            @ ( set_ord_atMost @ nat @ I3 ) )
          = ( minus_minus @ A @ ( F2 @ ( zero_zero @ nat ) ) @ ( F2 @ ( suc @ I3 ) ) ) ) ) ).

% sum_telescope
thf(fact_3065_polyfun__eq__coeffs,axiom,
    ! [A: $tType] :
      ( ( ( real_V8999393235501362500lgebra @ A )
        & ( idom @ A ) )
     => ! [C2: nat > A,N2: nat,D2: nat > A] :
          ( ( ! [X5: A] :
                ( ( groups7311177749621191930dd_sum @ nat @ A
                  @ ^ [I4: nat] : ( times_times @ A @ ( C2 @ I4 ) @ ( power_power @ A @ X5 @ I4 ) )
                  @ ( set_ord_atMost @ nat @ N2 ) )
                = ( groups7311177749621191930dd_sum @ nat @ A
                  @ ^ [I4: nat] : ( times_times @ A @ ( D2 @ I4 ) @ ( power_power @ A @ X5 @ I4 ) )
                  @ ( set_ord_atMost @ nat @ N2 ) ) ) )
          = ( ! [I4: nat] :
                ( ( ord_less_eq @ nat @ I4 @ N2 )
               => ( ( C2 @ I4 )
                  = ( D2 @ I4 ) ) ) ) ) ) ).

% polyfun_eq_coeffs
thf(fact_3066_prod_OatMost__Suc__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,N2: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_ord_atMost @ nat @ ( suc @ N2 ) ) )
          = ( times_times @ A @ ( G @ ( zero_zero @ nat ) )
            @ ( groups7121269368397514597t_prod @ nat @ A
              @ ^ [I4: nat] : ( G @ ( suc @ I4 ) )
              @ ( set_ord_atMost @ nat @ N2 ) ) ) ) ) ).

% prod.atMost_Suc_shift
thf(fact_3067_sum_Onested__swap_H,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A2: nat > nat > A,N2: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [I4: nat] : ( groups7311177749621191930dd_sum @ nat @ A @ ( A2 @ I4 ) @ ( set_ord_lessThan @ nat @ I4 ) )
            @ ( set_ord_atMost @ nat @ N2 ) )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [J3: nat] :
                ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I4: nat] : ( A2 @ I4 @ J3 )
                @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ J3 ) @ N2 ) )
            @ ( set_ord_lessThan @ nat @ N2 ) ) ) ) ).

% sum.nested_swap'
thf(fact_3068_prod_Onested__swap_H,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A2: nat > nat > A,N2: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [I4: nat] : ( groups7121269368397514597t_prod @ nat @ A @ ( A2 @ I4 ) @ ( set_ord_lessThan @ nat @ I4 ) )
            @ ( set_ord_atMost @ nat @ N2 ) )
          = ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [J3: nat] :
                ( groups7121269368397514597t_prod @ nat @ A
                @ ^ [I4: nat] : ( A2 @ I4 @ J3 )
                @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ J3 ) @ N2 ) )
            @ ( set_ord_lessThan @ nat @ N2 ) ) ) ) ).

% prod.nested_swap'
thf(fact_3069_sum__choose__lower,axiom,
    ! [R3: nat,N2: nat] :
      ( ( groups7311177749621191930dd_sum @ nat @ nat
        @ ^ [K3: nat] : ( binomial @ ( plus_plus @ nat @ R3 @ K3 ) @ K3 )
        @ ( set_ord_atMost @ nat @ N2 ) )
      = ( binomial @ ( suc @ ( plus_plus @ nat @ R3 @ N2 ) ) @ N2 ) ) ).

% sum_choose_lower
thf(fact_3070_choose__rising__sum_I2_J,axiom,
    ! [N2: nat,M: nat] :
      ( ( groups7311177749621191930dd_sum @ nat @ nat
        @ ^ [J3: nat] : ( binomial @ ( plus_plus @ nat @ N2 @ J3 ) @ N2 )
        @ ( set_ord_atMost @ nat @ M ) )
      = ( binomial @ ( plus_plus @ nat @ ( plus_plus @ nat @ N2 @ M ) @ ( one_one @ nat ) ) @ M ) ) ).

% choose_rising_sum(2)
thf(fact_3071_choose__rising__sum_I1_J,axiom,
    ! [N2: nat,M: nat] :
      ( ( groups7311177749621191930dd_sum @ nat @ nat
        @ ^ [J3: nat] : ( binomial @ ( plus_plus @ nat @ N2 @ J3 ) @ N2 )
        @ ( set_ord_atMost @ nat @ M ) )
      = ( binomial @ ( plus_plus @ nat @ ( plus_plus @ nat @ N2 @ M ) @ ( one_one @ nat ) ) @ ( plus_plus @ nat @ N2 @ ( one_one @ nat ) ) ) ) ).

% choose_rising_sum(1)
thf(fact_3072_abs__le__square__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X2: A,Y2: A] :
          ( ( ord_less_eq @ A @ ( abs_abs @ A @ X2 ) @ ( abs_abs @ A @ Y2 ) )
          = ( ord_less_eq @ A @ ( power_power @ A @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ A @ Y2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% abs_le_square_iff
thf(fact_3073_abs__square__eq__1,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X2: A] :
          ( ( ( power_power @ A @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
            = ( one_one @ A ) )
          = ( ( abs_abs @ A @ X2 )
            = ( one_one @ A ) ) ) ) ).

% abs_square_eq_1
thf(fact_3074_power__even__abs,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N2: nat,A2: A] :
          ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 )
         => ( ( power_power @ A @ ( abs_abs @ A @ A2 ) @ N2 )
            = ( power_power @ A @ A2 @ N2 ) ) ) ) ).

% power_even_abs
thf(fact_3075_zero__polynom__imp__zero__coeffs,axiom,
    ! [A: $tType] :
      ( ( ( ab_semigroup_mult @ A )
        & ( real_V8999393235501362500lgebra @ A ) )
     => ! [C2: nat > A,N2: nat,K: nat] :
          ( ! [W2: A] :
              ( ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I4: nat] : ( times_times @ A @ ( C2 @ I4 ) @ ( power_power @ A @ W2 @ I4 ) )
                @ ( set_ord_atMost @ nat @ N2 ) )
              = ( zero_zero @ A ) )
         => ( ( ord_less_eq @ nat @ K @ N2 )
           => ( ( C2 @ K )
              = ( zero_zero @ A ) ) ) ) ) ).

% zero_polynom_imp_zero_coeffs
thf(fact_3076_polyfun__eq__0,axiom,
    ! [A: $tType] :
      ( ( ( real_V8999393235501362500lgebra @ A )
        & ( idom @ A ) )
     => ! [C2: nat > A,N2: nat] :
          ( ( ! [X5: A] :
                ( ( groups7311177749621191930dd_sum @ nat @ A
                  @ ^ [I4: nat] : ( times_times @ A @ ( C2 @ I4 ) @ ( power_power @ A @ X5 @ I4 ) )
                  @ ( set_ord_atMost @ nat @ N2 ) )
                = ( zero_zero @ A ) ) )
          = ( ! [I4: nat] :
                ( ( ord_less_eq @ nat @ I4 @ N2 )
               => ( ( C2 @ I4 )
                  = ( zero_zero @ A ) ) ) ) ) ) ).

% polyfun_eq_0
thf(fact_3077_sum_OatMost__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,N2: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_ord_atMost @ nat @ N2 ) )
          = ( plus_plus @ A @ ( G @ ( zero_zero @ nat ) )
            @ ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [I4: nat] : ( G @ ( suc @ I4 ) )
              @ ( set_ord_lessThan @ nat @ N2 ) ) ) ) ) ).

% sum.atMost_shift
thf(fact_3078_sum__up__index__split,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [F2: nat > A,M: nat,N2: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_ord_atMost @ nat @ ( plus_plus @ nat @ M @ N2 ) ) )
          = ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_ord_atMost @ nat @ M ) ) @ ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ M ) @ ( plus_plus @ nat @ M @ N2 ) ) ) ) ) ) ).

% sum_up_index_split
thf(fact_3079_prod_OatMost__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,N2: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_ord_atMost @ nat @ N2 ) )
          = ( times_times @ A @ ( G @ ( zero_zero @ nat ) )
            @ ( groups7121269368397514597t_prod @ nat @ A
              @ ^ [I4: nat] : ( G @ ( suc @ I4 ) )
              @ ( set_ord_lessThan @ nat @ N2 ) ) ) ) ) ).

% prod.atMost_shift
thf(fact_3080_gbinomial__parallel__sum,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: A,N2: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [K3: nat] : ( gbinomial @ A @ ( plus_plus @ A @ A2 @ ( semiring_1_of_nat @ A @ K3 ) ) @ K3 )
            @ ( set_ord_atMost @ nat @ N2 ) )
          = ( gbinomial @ A @ ( plus_plus @ A @ ( plus_plus @ A @ A2 @ ( semiring_1_of_nat @ A @ N2 ) ) @ ( one_one @ A ) ) @ N2 ) ) ) ).

% gbinomial_parallel_sum
thf(fact_3081_sum_Otriangle__reindex__eq,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > nat > A,N2: nat] :
          ( ( groups7311177749621191930dd_sum @ ( product_prod @ nat @ nat ) @ A @ ( product_case_prod @ nat @ nat @ A @ G )
            @ ( collect @ ( product_prod @ nat @ nat )
              @ ( product_case_prod @ nat @ nat @ $o
                @ ^ [I4: nat,J3: nat] : ( ord_less_eq @ nat @ ( plus_plus @ nat @ I4 @ J3 ) @ N2 ) ) ) )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [K3: nat] :
                ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I4: nat] : ( G @ I4 @ ( minus_minus @ nat @ K3 @ I4 ) )
                @ ( set_ord_atMost @ nat @ K3 ) )
            @ ( set_ord_atMost @ nat @ N2 ) ) ) ) ).

% sum.triangle_reindex_eq
thf(fact_3082_prod_Otriangle__reindex__eq,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > nat > A,N2: nat] :
          ( ( groups7121269368397514597t_prod @ ( product_prod @ nat @ nat ) @ A @ ( product_case_prod @ nat @ nat @ A @ G )
            @ ( collect @ ( product_prod @ nat @ nat )
              @ ( product_case_prod @ nat @ nat @ $o
                @ ^ [I4: nat,J3: nat] : ( ord_less_eq @ nat @ ( plus_plus @ nat @ I4 @ J3 ) @ N2 ) ) ) )
          = ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [K3: nat] :
                ( groups7121269368397514597t_prod @ nat @ A
                @ ^ [I4: nat] : ( G @ I4 @ ( minus_minus @ nat @ K3 @ I4 ) )
                @ ( set_ord_atMost @ nat @ K3 ) )
            @ ( set_ord_atMost @ nat @ N2 ) ) ) ) ).

% prod.triangle_reindex_eq
thf(fact_3083_sum__choose__diagonal,axiom,
    ! [M: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ M @ N2 )
     => ( ( groups7311177749621191930dd_sum @ nat @ nat
          @ ^ [K3: nat] : ( binomial @ ( minus_minus @ nat @ N2 @ K3 ) @ ( minus_minus @ nat @ M @ K3 ) )
          @ ( set_ord_atMost @ nat @ M ) )
        = ( binomial @ ( suc @ N2 ) @ M ) ) ) ).

% sum_choose_diagonal
thf(fact_3084_vandermonde,axiom,
    ! [M: nat,N2: nat,R3: nat] :
      ( ( groups7311177749621191930dd_sum @ nat @ nat
        @ ^ [K3: nat] : ( times_times @ nat @ ( binomial @ M @ K3 ) @ ( binomial @ N2 @ ( minus_minus @ nat @ R3 @ K3 ) ) )
        @ ( set_ord_atMost @ nat @ R3 ) )
      = ( binomial @ ( plus_plus @ nat @ M @ N2 ) @ R3 ) ) ).

% vandermonde
thf(fact_3085_power2__le__iff__abs__le,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [Y2: A,X2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ Y2 )
         => ( ( ord_less_eq @ A @ ( power_power @ A @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ A @ Y2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
            = ( ord_less_eq @ A @ ( abs_abs @ A @ X2 ) @ Y2 ) ) ) ) ).

% power2_le_iff_abs_le
thf(fact_3086_abs__square__le__1,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X2: A] :
          ( ( ord_less_eq @ A @ ( power_power @ A @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ A ) )
          = ( ord_less_eq @ A @ ( abs_abs @ A @ X2 ) @ ( one_one @ A ) ) ) ) ).

% abs_square_le_1
thf(fact_3087_abs__square__less__1,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X2: A] :
          ( ( ord_less @ A @ ( power_power @ A @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ A ) )
          = ( ord_less @ A @ ( abs_abs @ A @ X2 ) @ ( one_one @ A ) ) ) ) ).

% abs_square_less_1
thf(fact_3088_power__mono__even,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N2: nat,A2: A,B2: A] :
          ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 )
         => ( ( ord_less_eq @ A @ ( abs_abs @ A @ A2 ) @ ( abs_abs @ A @ B2 ) )
           => ( ord_less_eq @ A @ ( power_power @ A @ A2 @ N2 ) @ ( power_power @ A @ B2 @ N2 ) ) ) ) ) ).

% power_mono_even
thf(fact_3089_convex__sum__bound__le,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linordered_idom @ B )
     => ! [I6: set @ A,X2: A > B,A2: A > B,B2: B,Delta: B] :
          ( ! [I2: A] :
              ( ( member @ A @ I2 @ I6 )
             => ( ord_less_eq @ B @ ( zero_zero @ B ) @ ( X2 @ I2 ) ) )
         => ( ( ( groups7311177749621191930dd_sum @ A @ B @ X2 @ I6 )
              = ( one_one @ B ) )
           => ( ! [I2: A] :
                  ( ( member @ A @ I2 @ I6 )
                 => ( ord_less_eq @ B @ ( abs_abs @ B @ ( minus_minus @ B @ ( A2 @ I2 ) @ B2 ) ) @ Delta ) )
             => ( ord_less_eq @ B
                @ ( abs_abs @ B
                  @ ( minus_minus @ B
                    @ ( groups7311177749621191930dd_sum @ A @ B
                      @ ^ [I4: A] : ( times_times @ B @ ( A2 @ I4 ) @ ( X2 @ I4 ) )
                      @ I6 )
                    @ B2 ) )
                @ Delta ) ) ) ) ) ).

% convex_sum_bound_le
thf(fact_3090_sum__gp__basic,axiom,
    ! [A: $tType] :
      ( ( ( monoid_mult @ A )
        & ( comm_ring @ A ) )
     => ! [X2: A,N2: nat] :
          ( ( times_times @ A @ ( minus_minus @ A @ ( one_one @ A ) @ X2 ) @ ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X2 ) @ ( set_ord_atMost @ nat @ N2 ) ) )
          = ( minus_minus @ A @ ( one_one @ A ) @ ( power_power @ A @ X2 @ ( suc @ N2 ) ) ) ) ) ).

% sum_gp_basic
thf(fact_3091_polyfun__linear__factor__root,axiom,
    ! [A: $tType] :
      ( ( idom @ A )
     => ! [C2: nat > A,A2: A,N2: nat] :
          ( ( ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [I4: nat] : ( times_times @ A @ ( C2 @ I4 ) @ ( power_power @ A @ A2 @ I4 ) )
              @ ( set_ord_atMost @ nat @ N2 ) )
            = ( zero_zero @ A ) )
         => ~ ! [B5: nat > A] :
                ~ ! [Z4: A] :
                    ( ( groups7311177749621191930dd_sum @ nat @ A
                      @ ^ [I4: nat] : ( times_times @ A @ ( C2 @ I4 ) @ ( power_power @ A @ Z4 @ I4 ) )
                      @ ( set_ord_atMost @ nat @ N2 ) )
                    = ( times_times @ A @ ( minus_minus @ A @ Z4 @ A2 )
                      @ ( groups7311177749621191930dd_sum @ nat @ A
                        @ ^ [I4: nat] : ( times_times @ A @ ( B5 @ I4 ) @ ( power_power @ A @ Z4 @ I4 ) )
                        @ ( set_ord_lessThan @ nat @ N2 ) ) ) ) ) ) ).

% polyfun_linear_factor_root
thf(fact_3092_polyfun__linear__factor,axiom,
    ! [A: $tType] :
      ( ( idom @ A )
     => ! [C2: nat > A,N2: nat,A2: A] :
        ? [B5: nat > A] :
        ! [Z4: A] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [I4: nat] : ( times_times @ A @ ( C2 @ I4 ) @ ( power_power @ A @ Z4 @ I4 ) )
            @ ( set_ord_atMost @ nat @ N2 ) )
          = ( plus_plus @ A
            @ ( times_times @ A @ ( minus_minus @ A @ Z4 @ A2 )
              @ ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I4: nat] : ( times_times @ A @ ( B5 @ I4 ) @ ( power_power @ A @ Z4 @ I4 ) )
                @ ( set_ord_lessThan @ nat @ N2 ) ) )
            @ ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [I4: nat] : ( times_times @ A @ ( C2 @ I4 ) @ ( power_power @ A @ A2 @ I4 ) )
              @ ( set_ord_atMost @ nat @ N2 ) ) ) ) ) ).

% polyfun_linear_factor
thf(fact_3093_sum__power__shift,axiom,
    ! [A: $tType] :
      ( ( ( monoid_mult @ A )
        & ( comm_ring @ A ) )
     => ! [M: nat,N2: nat,X2: A] :
          ( ( ord_less_eq @ nat @ M @ N2 )
         => ( ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X2 ) @ ( set_or1337092689740270186AtMost @ nat @ M @ N2 ) )
            = ( times_times @ A @ ( power_power @ A @ X2 @ M ) @ ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X2 ) @ ( set_ord_atMost @ nat @ ( minus_minus @ nat @ N2 @ M ) ) ) ) ) ) ) ).

% sum_power_shift
thf(fact_3094_sum_Otriangle__reindex,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > nat > A,N2: nat] :
          ( ( groups7311177749621191930dd_sum @ ( product_prod @ nat @ nat ) @ A @ ( product_case_prod @ nat @ nat @ A @ G )
            @ ( collect @ ( product_prod @ nat @ nat )
              @ ( product_case_prod @ nat @ nat @ $o
                @ ^ [I4: nat,J3: nat] : ( ord_less @ nat @ ( plus_plus @ nat @ I4 @ J3 ) @ N2 ) ) ) )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [K3: nat] :
                ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I4: nat] : ( G @ I4 @ ( minus_minus @ nat @ K3 @ I4 ) )
                @ ( set_ord_atMost @ nat @ K3 ) )
            @ ( set_ord_lessThan @ nat @ N2 ) ) ) ) ).

% sum.triangle_reindex
thf(fact_3095_prod_Otriangle__reindex,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > nat > A,N2: nat] :
          ( ( groups7121269368397514597t_prod @ ( product_prod @ nat @ nat ) @ A @ ( product_case_prod @ nat @ nat @ A @ G )
            @ ( collect @ ( product_prod @ nat @ nat )
              @ ( product_case_prod @ nat @ nat @ $o
                @ ^ [I4: nat,J3: nat] : ( ord_less @ nat @ ( plus_plus @ nat @ I4 @ J3 ) @ N2 ) ) ) )
          = ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [K3: nat] :
                ( groups7121269368397514597t_prod @ nat @ A
                @ ^ [I4: nat] : ( G @ I4 @ ( minus_minus @ nat @ K3 @ I4 ) )
                @ ( set_ord_atMost @ nat @ K3 ) )
            @ ( set_ord_lessThan @ nat @ N2 ) ) ) ) ).

% prod.triangle_reindex
thf(fact_3096_choose__row__sum,axiom,
    ! [N2: nat] :
      ( ( groups7311177749621191930dd_sum @ nat @ nat @ ( binomial @ N2 ) @ ( set_ord_atMost @ nat @ N2 ) )
      = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) ).

% choose_row_sum
thf(fact_3097_binomial,axiom,
    ! [A2: nat,B2: nat,N2: nat] :
      ( ( power_power @ nat @ ( plus_plus @ nat @ A2 @ B2 ) @ N2 )
      = ( groups7311177749621191930dd_sum @ nat @ nat
        @ ^ [K3: nat] : ( times_times @ nat @ ( times_times @ nat @ ( semiring_1_of_nat @ nat @ ( binomial @ N2 @ K3 ) ) @ ( power_power @ nat @ A2 @ K3 ) ) @ ( power_power @ nat @ B2 @ ( minus_minus @ nat @ N2 @ K3 ) ) )
        @ ( set_ord_atMost @ nat @ N2 ) ) ) ).

% binomial
thf(fact_3098_suminf__geometric,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [C2: A] :
          ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ C2 ) @ ( one_one @ real ) )
         => ( ( suminf @ A @ ( power_power @ A @ C2 ) )
            = ( divide_divide @ A @ ( one_one @ A ) @ ( minus_minus @ A @ ( one_one @ A ) @ C2 ) ) ) ) ) ).

% suminf_geometric
thf(fact_3099_sin__coeff__Suc,axiom,
    ! [N2: nat] :
      ( ( sin_coeff @ ( suc @ N2 ) )
      = ( divide_divide @ real @ ( cos_coeff @ N2 ) @ ( semiring_1_of_nat @ real @ ( suc @ N2 ) ) ) ) ).

% sin_coeff_Suc
thf(fact_3100_sum_Oin__pairs__0,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,N2: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_ord_atMost @ nat @ ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) ) )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [I4: nat] : ( plus_plus @ A @ ( G @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ I4 ) ) @ ( G @ ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ I4 ) ) ) )
            @ ( set_ord_atMost @ nat @ N2 ) ) ) ) ).

% sum.in_pairs_0
thf(fact_3101_polynomial__product,axiom,
    ! [A: $tType] :
      ( ( idom @ A )
     => ! [M: nat,A2: nat > A,N2: nat,B2: nat > A,X2: A] :
          ( ! [I2: nat] :
              ( ( ord_less @ nat @ M @ I2 )
             => ( ( A2 @ I2 )
                = ( zero_zero @ A ) ) )
         => ( ! [J2: nat] :
                ( ( ord_less @ nat @ N2 @ J2 )
               => ( ( B2 @ J2 )
                  = ( zero_zero @ A ) ) )
           => ( ( times_times @ A
                @ ( groups7311177749621191930dd_sum @ nat @ A
                  @ ^ [I4: nat] : ( times_times @ A @ ( A2 @ I4 ) @ ( power_power @ A @ X2 @ I4 ) )
                  @ ( set_ord_atMost @ nat @ M ) )
                @ ( groups7311177749621191930dd_sum @ nat @ A
                  @ ^ [J3: nat] : ( times_times @ A @ ( B2 @ J3 ) @ ( power_power @ A @ X2 @ J3 ) )
                  @ ( set_ord_atMost @ nat @ N2 ) ) )
              = ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [R5: nat] :
                    ( times_times @ A
                    @ ( groups7311177749621191930dd_sum @ nat @ A
                      @ ^ [K3: nat] : ( times_times @ A @ ( A2 @ K3 ) @ ( B2 @ ( minus_minus @ nat @ R5 @ K3 ) ) )
                      @ ( set_ord_atMost @ nat @ R5 ) )
                    @ ( power_power @ A @ X2 @ R5 ) )
                @ ( set_ord_atMost @ nat @ ( plus_plus @ nat @ M @ N2 ) ) ) ) ) ) ) ).

% polynomial_product
thf(fact_3102_prod_Oin__pairs__0,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,N2: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_ord_atMost @ nat @ ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) ) )
          = ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [I4: nat] : ( times_times @ A @ ( G @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ I4 ) ) @ ( G @ ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ I4 ) ) ) )
            @ ( set_ord_atMost @ nat @ N2 ) ) ) ) ).

% prod.in_pairs_0
thf(fact_3103_polyfun__eq__const,axiom,
    ! [A: $tType] :
      ( ( ( real_V8999393235501362500lgebra @ A )
        & ( idom @ A ) )
     => ! [C2: nat > A,N2: nat,K: A] :
          ( ( ! [X5: A] :
                ( ( groups7311177749621191930dd_sum @ nat @ A
                  @ ^ [I4: nat] : ( times_times @ A @ ( C2 @ I4 ) @ ( power_power @ A @ X5 @ I4 ) )
                  @ ( set_ord_atMost @ nat @ N2 ) )
                = K ) )
          = ( ( ( C2 @ ( zero_zero @ nat ) )
              = K )
            & ! [X5: nat] :
                ( ( member @ nat @ X5 @ ( set_or1337092689740270186AtMost @ nat @ ( one_one @ nat ) @ N2 ) )
               => ( ( C2 @ X5 )
                  = ( zero_zero @ A ) ) ) ) ) ) ).

% polyfun_eq_const
thf(fact_3104_gbinomial__sum__lower__neg,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: A,M: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [K3: nat] : ( times_times @ A @ ( gbinomial @ A @ A2 @ K3 ) @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ K3 ) )
            @ ( set_ord_atMost @ nat @ M ) )
          = ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ M ) @ ( gbinomial @ A @ ( minus_minus @ A @ A2 @ ( one_one @ A ) ) @ M ) ) ) ) ).

% gbinomial_sum_lower_neg
thf(fact_3105_binomial__ring,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [A2: A,B2: A,N2: nat] :
          ( ( power_power @ A @ ( plus_plus @ A @ A2 @ B2 ) @ N2 )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [K3: nat] : ( times_times @ A @ ( times_times @ A @ ( semiring_1_of_nat @ A @ ( binomial @ N2 @ K3 ) ) @ ( power_power @ A @ A2 @ K3 ) ) @ ( power_power @ A @ B2 @ ( minus_minus @ nat @ N2 @ K3 ) ) )
            @ ( set_ord_atMost @ nat @ N2 ) ) ) ) ).

% binomial_ring
thf(fact_3106_pochhammer__binomial__sum,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [A2: A,B2: A,N2: nat] :
          ( ( comm_s3205402744901411588hammer @ A @ ( plus_plus @ A @ A2 @ B2 ) @ N2 )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [K3: nat] : ( times_times @ A @ ( times_times @ A @ ( semiring_1_of_nat @ A @ ( binomial @ N2 @ K3 ) ) @ ( comm_s3205402744901411588hammer @ A @ A2 @ K3 ) ) @ ( comm_s3205402744901411588hammer @ A @ B2 @ ( minus_minus @ nat @ N2 @ K3 ) ) )
            @ ( set_ord_atMost @ nat @ N2 ) ) ) ) ).

% pochhammer_binomial_sum
thf(fact_3107_polynomial__product__nat,axiom,
    ! [M: nat,A2: nat > nat,N2: nat,B2: nat > nat,X2: nat] :
      ( ! [I2: nat] :
          ( ( ord_less @ nat @ M @ I2 )
         => ( ( A2 @ I2 )
            = ( zero_zero @ nat ) ) )
     => ( ! [J2: nat] :
            ( ( ord_less @ nat @ N2 @ J2 )
           => ( ( B2 @ J2 )
              = ( zero_zero @ nat ) ) )
       => ( ( times_times @ nat
            @ ( groups7311177749621191930dd_sum @ nat @ nat
              @ ^ [I4: nat] : ( times_times @ nat @ ( A2 @ I4 ) @ ( power_power @ nat @ X2 @ I4 ) )
              @ ( set_ord_atMost @ nat @ M ) )
            @ ( groups7311177749621191930dd_sum @ nat @ nat
              @ ^ [J3: nat] : ( times_times @ nat @ ( B2 @ J3 ) @ ( power_power @ nat @ X2 @ J3 ) )
              @ ( set_ord_atMost @ nat @ N2 ) ) )
          = ( groups7311177749621191930dd_sum @ nat @ nat
            @ ^ [R5: nat] :
                ( times_times @ nat
                @ ( groups7311177749621191930dd_sum @ nat @ nat
                  @ ^ [K3: nat] : ( times_times @ nat @ ( A2 @ K3 ) @ ( B2 @ ( minus_minus @ nat @ R5 @ K3 ) ) )
                  @ ( set_ord_atMost @ nat @ R5 ) )
                @ ( power_power @ nat @ X2 @ R5 ) )
            @ ( set_ord_atMost @ nat @ ( plus_plus @ nat @ M @ N2 ) ) ) ) ) ) ).

% polynomial_product_nat
thf(fact_3108_choose__square__sum,axiom,
    ! [N2: nat] :
      ( ( groups7311177749621191930dd_sum @ nat @ nat
        @ ^ [K3: nat] : ( power_power @ nat @ ( binomial @ N2 @ K3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
        @ ( set_ord_atMost @ nat @ N2 ) )
      = ( binomial @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) @ N2 ) ) ).

% choose_square_sum
thf(fact_3109_sum_Ozero__middle,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [P4: nat,K: nat,G: nat > A,H2: nat > A] :
          ( ( ord_less_eq @ nat @ ( one_one @ nat ) @ P4 )
         => ( ( ord_less_eq @ nat @ K @ P4 )
           => ( ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [J3: nat] : ( if @ A @ ( ord_less @ nat @ J3 @ K ) @ ( G @ J3 ) @ ( if @ A @ ( J3 = K ) @ ( zero_zero @ A ) @ ( H2 @ ( minus_minus @ nat @ J3 @ ( suc @ ( zero_zero @ nat ) ) ) ) ) )
                @ ( set_ord_atMost @ nat @ P4 ) )
              = ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [J3: nat] : ( if @ A @ ( ord_less @ nat @ J3 @ K ) @ ( G @ J3 ) @ ( H2 @ J3 ) )
                @ ( set_ord_atMost @ nat @ ( minus_minus @ nat @ P4 @ ( suc @ ( zero_zero @ nat ) ) ) ) ) ) ) ) ) ).

% sum.zero_middle
thf(fact_3110_prod_Ozero__middle,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [P4: nat,K: nat,G: nat > A,H2: nat > A] :
          ( ( ord_less_eq @ nat @ ( one_one @ nat ) @ P4 )
         => ( ( ord_less_eq @ nat @ K @ P4 )
           => ( ( groups7121269368397514597t_prod @ nat @ A
                @ ^ [J3: nat] : ( if @ A @ ( ord_less @ nat @ J3 @ K ) @ ( G @ J3 ) @ ( if @ A @ ( J3 = K ) @ ( one_one @ A ) @ ( H2 @ ( minus_minus @ nat @ J3 @ ( suc @ ( zero_zero @ nat ) ) ) ) ) )
                @ ( set_ord_atMost @ nat @ P4 ) )
              = ( groups7121269368397514597t_prod @ nat @ A
                @ ^ [J3: nat] : ( if @ A @ ( ord_less @ nat @ J3 @ K ) @ ( G @ J3 ) @ ( H2 @ J3 ) )
                @ ( set_ord_atMost @ nat @ ( minus_minus @ nat @ P4 @ ( suc @ ( zero_zero @ nat ) ) ) ) ) ) ) ) ) ).

% prod.zero_middle
thf(fact_3111_gbinomial__partial__sum__poly,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [M: nat,A2: A,X2: A,Y2: A] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [K3: nat] : ( times_times @ A @ ( times_times @ A @ ( gbinomial @ A @ ( plus_plus @ A @ ( semiring_1_of_nat @ A @ M ) @ A2 ) @ K3 ) @ ( power_power @ A @ X2 @ K3 ) ) @ ( power_power @ A @ Y2 @ ( minus_minus @ nat @ M @ K3 ) ) )
            @ ( set_ord_atMost @ nat @ M ) )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [K3: nat] : ( times_times @ A @ ( times_times @ A @ ( gbinomial @ A @ ( uminus_uminus @ A @ A2 ) @ K3 ) @ ( power_power @ A @ ( uminus_uminus @ A @ X2 ) @ K3 ) ) @ ( power_power @ A @ ( plus_plus @ A @ X2 @ Y2 ) @ ( minus_minus @ nat @ M @ K3 ) ) )
            @ ( set_ord_atMost @ nat @ M ) ) ) ) ).

% gbinomial_partial_sum_poly
thf(fact_3112_cos__coeff__Suc,axiom,
    ! [N2: nat] :
      ( ( cos_coeff @ ( suc @ N2 ) )
      = ( divide_divide @ real @ ( uminus_uminus @ real @ ( sin_coeff @ N2 ) ) @ ( semiring_1_of_nat @ real @ ( suc @ N2 ) ) ) ) ).

% cos_coeff_Suc
thf(fact_3113_of__int__round__abs__le,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A] : ( ord_less_eq @ A @ ( abs_abs @ A @ ( minus_minus @ A @ ( ring_1_of_int @ A @ ( archimedean_round @ A @ X2 ) ) @ X2 ) ) @ ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% of_int_round_abs_le
thf(fact_3114_round__unique_H,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A,N2: int] :
          ( ( ord_less @ A @ ( abs_abs @ A @ ( minus_minus @ A @ X2 @ ( ring_1_of_int @ A @ N2 ) ) ) @ ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) )
         => ( ( archimedean_round @ A @ X2 )
            = N2 ) ) ) ).

% round_unique'
thf(fact_3115_root__polyfun,axiom,
    ! [A: $tType] :
      ( ( idom @ A )
     => ! [N2: nat,Z: A,A2: A] :
          ( ( ord_less_eq @ nat @ ( one_one @ nat ) @ N2 )
         => ( ( ( power_power @ A @ Z @ N2 )
              = A2 )
            = ( ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I4: nat] :
                    ( times_times @ A
                    @ ( if @ A
                      @ ( I4
                        = ( zero_zero @ nat ) )
                      @ ( uminus_uminus @ A @ A2 )
                      @ ( if @ A @ ( I4 = N2 ) @ ( one_one @ A ) @ ( zero_zero @ A ) ) )
                    @ ( power_power @ A @ Z @ I4 ) )
                @ ( set_ord_atMost @ nat @ N2 ) )
              = ( zero_zero @ A ) ) ) ) ) ).

% root_polyfun
thf(fact_3116_sum__gp0,axiom,
    ! [A: $tType] :
      ( ( ( division_ring @ A )
        & ( comm_ring @ A ) )
     => ! [X2: A,N2: nat] :
          ( ( ( X2
              = ( one_one @ A ) )
           => ( ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X2 ) @ ( set_ord_atMost @ nat @ N2 ) )
              = ( semiring_1_of_nat @ A @ ( plus_plus @ nat @ N2 @ ( one_one @ nat ) ) ) ) )
          & ( ( X2
             != ( one_one @ A ) )
           => ( ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X2 ) @ ( set_ord_atMost @ nat @ N2 ) )
              = ( divide_divide @ A @ ( minus_minus @ A @ ( one_one @ A ) @ ( power_power @ A @ X2 @ ( suc @ N2 ) ) ) @ ( minus_minus @ A @ ( one_one @ A ) @ X2 ) ) ) ) ) ) ).

% sum_gp0
thf(fact_3117_choose__alternating__linear__sum,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [N2: nat] :
          ( ( N2
           != ( one_one @ nat ) )
         => ( ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [I4: nat] : ( times_times @ A @ ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ I4 ) @ ( semiring_1_of_nat @ A @ I4 ) ) @ ( semiring_1_of_nat @ A @ ( binomial @ N2 @ I4 ) ) )
              @ ( set_ord_atMost @ nat @ N2 ) )
            = ( zero_zero @ A ) ) ) ) ).

% choose_alternating_linear_sum
thf(fact_3118_gbinomial__sum__nat__pow2,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [M: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [K3: nat] : ( divide_divide @ A @ ( gbinomial @ A @ ( semiring_1_of_nat @ A @ ( plus_plus @ nat @ M @ K3 ) ) @ K3 ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ K3 ) )
            @ ( set_ord_atMost @ nat @ M ) )
          = ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M ) ) ) ).

% gbinomial_sum_nat_pow2
thf(fact_3119_gbinomial__partial__sum__poly__xpos,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [M: nat,A2: A,X2: A,Y2: A] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [K3: nat] : ( times_times @ A @ ( times_times @ A @ ( gbinomial @ A @ ( plus_plus @ A @ ( semiring_1_of_nat @ A @ M ) @ A2 ) @ K3 ) @ ( power_power @ A @ X2 @ K3 ) ) @ ( power_power @ A @ Y2 @ ( minus_minus @ nat @ M @ K3 ) ) )
            @ ( set_ord_atMost @ nat @ M ) )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [K3: nat] : ( times_times @ A @ ( times_times @ A @ ( gbinomial @ A @ ( minus_minus @ A @ ( plus_plus @ A @ ( semiring_1_of_nat @ A @ K3 ) @ A2 ) @ ( one_one @ A ) ) @ K3 ) @ ( power_power @ A @ X2 @ K3 ) ) @ ( power_power @ A @ ( plus_plus @ A @ X2 @ Y2 ) @ ( minus_minus @ nat @ M @ K3 ) ) )
            @ ( set_ord_atMost @ nat @ M ) ) ) ) ).

% gbinomial_partial_sum_poly_xpos
thf(fact_3120_polyfun__diff__alt,axiom,
    ! [A: $tType] :
      ( ( idom @ A )
     => ! [N2: nat,A2: nat > A,X2: A,Y2: A] :
          ( ( ord_less_eq @ nat @ ( one_one @ nat ) @ N2 )
         => ( ( minus_minus @ A
              @ ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I4: nat] : ( times_times @ A @ ( A2 @ I4 ) @ ( power_power @ A @ X2 @ I4 ) )
                @ ( set_ord_atMost @ nat @ N2 ) )
              @ ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I4: nat] : ( times_times @ A @ ( A2 @ I4 ) @ ( power_power @ A @ Y2 @ I4 ) )
                @ ( set_ord_atMost @ nat @ N2 ) ) )
            = ( times_times @ A @ ( minus_minus @ A @ X2 @ Y2 )
              @ ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [J3: nat] :
                    ( groups7311177749621191930dd_sum @ nat @ A
                    @ ^ [K3: nat] : ( times_times @ A @ ( times_times @ A @ ( A2 @ ( plus_plus @ nat @ ( plus_plus @ nat @ J3 @ K3 ) @ ( one_one @ nat ) ) ) @ ( power_power @ A @ Y2 @ K3 ) ) @ ( power_power @ A @ X2 @ J3 ) )
                    @ ( set_ord_lessThan @ nat @ ( minus_minus @ nat @ N2 @ J3 ) ) )
                @ ( set_ord_lessThan @ nat @ N2 ) ) ) ) ) ) ).

% polyfun_diff_alt
thf(fact_3121_binomial__r__part__sum,axiom,
    ! [M: nat] :
      ( ( groups7311177749621191930dd_sum @ nat @ nat @ ( binomial @ ( plus_plus @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M ) @ ( one_one @ nat ) ) ) @ ( set_ord_atMost @ nat @ M ) )
      = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M ) ) ) ).

% binomial_r_part_sum
thf(fact_3122_choose__linear__sum,axiom,
    ! [N2: nat] :
      ( ( groups7311177749621191930dd_sum @ nat @ nat
        @ ^ [I4: nat] : ( times_times @ nat @ I4 @ ( binomial @ N2 @ I4 ) )
        @ ( set_ord_atMost @ nat @ N2 ) )
      = ( times_times @ nat @ N2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ N2 @ ( one_one @ nat ) ) ) ) ) ).

% choose_linear_sum
thf(fact_3123_choose__alternating__sum,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [N2: nat] :
          ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
         => ( ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [I4: nat] : ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ I4 ) @ ( semiring_1_of_nat @ A @ ( binomial @ N2 @ I4 ) ) )
              @ ( set_ord_atMost @ nat @ N2 ) )
            = ( zero_zero @ A ) ) ) ) ).

% choose_alternating_sum
thf(fact_3124_polyfun__extremal__lemma,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [E2: real,C2: nat > A,N2: nat] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ E2 )
         => ? [M8: real] :
            ! [Z4: A] :
              ( ( ord_less_eq @ real @ M8 @ ( real_V7770717601297561774m_norm @ A @ Z4 ) )
             => ( ord_less_eq @ real
                @ ( real_V7770717601297561774m_norm @ A
                  @ ( groups7311177749621191930dd_sum @ nat @ A
                    @ ^ [I4: nat] : ( times_times @ A @ ( C2 @ I4 ) @ ( power_power @ A @ Z4 @ I4 ) )
                    @ ( set_ord_atMost @ nat @ N2 ) ) )
                @ ( times_times @ real @ E2 @ ( power_power @ real @ ( real_V7770717601297561774m_norm @ A @ Z4 ) @ ( suc @ N2 ) ) ) ) ) ) ) ).

% polyfun_extremal_lemma
thf(fact_3125_abs__ln__one__plus__x__minus__x__bound__nonneg,axiom,
    ! [X2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( ord_less_eq @ real @ X2 @ ( one_one @ real ) )
       => ( ord_less_eq @ real @ ( abs_abs @ real @ ( minus_minus @ real @ ( ln_ln @ real @ ( plus_plus @ real @ ( one_one @ real ) @ X2 ) ) @ X2 ) ) @ ( power_power @ real @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% abs_ln_one_plus_x_minus_x_bound_nonneg
thf(fact_3126_polyfun__diff,axiom,
    ! [A: $tType] :
      ( ( idom @ A )
     => ! [N2: nat,A2: nat > A,X2: A,Y2: A] :
          ( ( ord_less_eq @ nat @ ( one_one @ nat ) @ N2 )
         => ( ( minus_minus @ A
              @ ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I4: nat] : ( times_times @ A @ ( A2 @ I4 ) @ ( power_power @ A @ X2 @ I4 ) )
                @ ( set_ord_atMost @ nat @ N2 ) )
              @ ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I4: nat] : ( times_times @ A @ ( A2 @ I4 ) @ ( power_power @ A @ Y2 @ I4 ) )
                @ ( set_ord_atMost @ nat @ N2 ) ) )
            = ( times_times @ A @ ( minus_minus @ A @ X2 @ Y2 )
              @ ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [J3: nat] :
                    ( times_times @ A
                    @ ( groups7311177749621191930dd_sum @ nat @ A
                      @ ^ [I4: nat] : ( times_times @ A @ ( A2 @ I4 ) @ ( power_power @ A @ Y2 @ ( minus_minus @ nat @ ( minus_minus @ nat @ I4 @ J3 ) @ ( one_one @ nat ) ) ) )
                      @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ J3 ) @ N2 ) )
                    @ ( power_power @ A @ X2 @ J3 ) )
                @ ( set_ord_lessThan @ nat @ N2 ) ) ) ) ) ) ).

% polyfun_diff
thf(fact_3127_gbinomial__r__part__sum,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [M: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ ( gbinomial @ A @ ( plus_plus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( semiring_1_of_nat @ A @ M ) ) @ ( one_one @ A ) ) ) @ ( set_ord_atMost @ nat @ M ) )
          = ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M ) ) ) ) ).

% gbinomial_r_part_sum
thf(fact_3128_abs__ln__one__plus__x__minus__x__bound,axiom,
    ! [X2: real] :
      ( ( ord_less_eq @ real @ ( abs_abs @ real @ X2 ) @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
     => ( ord_less_eq @ real @ ( abs_abs @ real @ ( minus_minus @ real @ ( ln_ln @ real @ ( plus_plus @ real @ ( one_one @ real ) @ X2 ) ) @ X2 ) ) @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( power_power @ real @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% abs_ln_one_plus_x_minus_x_bound
thf(fact_3129_choose__odd__sum,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [N2: nat] :
          ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
         => ( ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) )
              @ ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I4: nat] :
                    ( if @ A
                    @ ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ I4 )
                    @ ( semiring_1_of_nat @ A @ ( binomial @ N2 @ I4 ) )
                    @ ( zero_zero @ A ) )
                @ ( set_ord_atMost @ nat @ N2 ) ) )
            = ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N2 ) ) ) ) ).

% choose_odd_sum
thf(fact_3130_abs__sqrt__wlog,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [P: A > A > $o,X2: A] :
          ( ! [X3: A] :
              ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X3 )
             => ( P @ X3 @ ( power_power @ A @ X3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
         => ( P @ ( abs_abs @ A @ X2 ) @ ( power_power @ A @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% abs_sqrt_wlog
thf(fact_3131_monoseq__arctan__series,axiom,
    ! [X2: real] :
      ( ( ord_less_eq @ real @ ( abs_abs @ real @ X2 ) @ ( one_one @ real ) )
     => ( topological_monoseq @ real
        @ ^ [N3: nat] : ( times_times @ real @ ( divide_divide @ real @ ( one_one @ real ) @ ( semiring_1_of_nat @ real @ ( plus_plus @ nat @ ( times_times @ nat @ N3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ nat ) ) ) ) @ ( power_power @ real @ X2 @ ( plus_plus @ nat @ ( times_times @ nat @ N3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ nat ) ) ) ) ) ) ).

% monoseq_arctan_series
thf(fact_3132_arctan__series,axiom,
    ! [X2: real] :
      ( ( ord_less_eq @ real @ ( abs_abs @ real @ X2 ) @ ( one_one @ real ) )
     => ( ( arctan @ X2 )
        = ( suminf @ real
          @ ^ [K3: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ K3 ) @ ( times_times @ real @ ( divide_divide @ real @ ( one_one @ real ) @ ( semiring_1_of_nat @ real @ ( plus_plus @ nat @ ( times_times @ nat @ K3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ nat ) ) ) ) @ ( power_power @ real @ X2 @ ( plus_plus @ nat @ ( times_times @ nat @ K3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ nat ) ) ) ) ) ) ) ) ).

% arctan_series
thf(fact_3133_pi__series,axiom,
    ( ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ ( bit0 @ one2 ) ) ) )
    = ( suminf @ real
      @ ^ [K3: nat] : ( divide_divide @ real @ ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ K3 ) @ ( one_one @ real ) ) @ ( semiring_1_of_nat @ real @ ( plus_plus @ nat @ ( times_times @ nat @ K3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ nat ) ) ) ) ) ) ).

% pi_series
thf(fact_3134_sin__paired,axiom,
    ! [X2: real] :
      ( sums @ real
      @ ^ [N3: nat] : ( times_times @ real @ ( divide_divide @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ N3 ) @ ( semiring_char_0_fact @ real @ ( plus_plus @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N3 ) @ ( one_one @ nat ) ) ) ) @ ( power_power @ real @ X2 @ ( plus_plus @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N3 ) @ ( one_one @ nat ) ) ) )
      @ ( sin @ real @ X2 ) ) ).

% sin_paired
thf(fact_3135_of__nat__id,axiom,
    ( ( semiring_1_of_nat @ nat )
    = ( ^ [N3: nat] : N3 ) ) ).

% of_nat_id
thf(fact_3136_sin__zero,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ( ( sin @ A @ ( zero_zero @ A ) )
        = ( zero_zero @ A ) ) ) ).

% sin_zero
thf(fact_3137_arctan__eq__zero__iff,axiom,
    ! [X2: real] :
      ( ( ( arctan @ X2 )
        = ( zero_zero @ real ) )
      = ( X2
        = ( zero_zero @ real ) ) ) ).

% arctan_eq_zero_iff
thf(fact_3138_arctan__zero__zero,axiom,
    ( ( arctan @ ( zero_zero @ real ) )
    = ( zero_zero @ real ) ) ).

% arctan_zero_zero
thf(fact_3139_zabs__less__one__iff,axiom,
    ! [Z: int] :
      ( ( ord_less @ int @ ( abs_abs @ int @ Z ) @ ( one_one @ int ) )
      = ( Z
        = ( zero_zero @ int ) ) ) ).

% zabs_less_one_iff
thf(fact_3140_sin__pi,axiom,
    ( ( sin @ real @ pi )
    = ( zero_zero @ real ) ) ).

% sin_pi
thf(fact_3141_zero__less__arctan__iff,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ ( arctan @ X2 ) )
      = ( ord_less @ real @ ( zero_zero @ real ) @ X2 ) ) ).

% zero_less_arctan_iff
thf(fact_3142_arctan__less__zero__iff,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( arctan @ X2 ) @ ( zero_zero @ real ) )
      = ( ord_less @ real @ X2 @ ( zero_zero @ real ) ) ) ).

% arctan_less_zero_iff
thf(fact_3143_zero__le__arctan__iff,axiom,
    ! [X2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( arctan @ X2 ) )
      = ( ord_less_eq @ real @ ( zero_zero @ real ) @ X2 ) ) ).

% zero_le_arctan_iff
thf(fact_3144_arctan__le__zero__iff,axiom,
    ! [X2: real] :
      ( ( ord_less_eq @ real @ ( arctan @ X2 ) @ ( zero_zero @ real ) )
      = ( ord_less_eq @ real @ X2 @ ( zero_zero @ real ) ) ) ).

% arctan_le_zero_iff
thf(fact_3145_sin__npi,axiom,
    ! [N2: nat] :
      ( ( sin @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N2 ) @ pi ) )
      = ( zero_zero @ real ) ) ).

% sin_npi
thf(fact_3146_sin__npi2,axiom,
    ! [N2: nat] :
      ( ( sin @ real @ ( times_times @ real @ pi @ ( semiring_1_of_nat @ real @ N2 ) ) )
      = ( zero_zero @ real ) ) ).

% sin_npi2
thf(fact_3147_sin__npi__int,axiom,
    ! [N2: int] :
      ( ( sin @ real @ ( times_times @ real @ pi @ ( ring_1_of_int @ real @ N2 ) ) )
      = ( zero_zero @ real ) ) ).

% sin_npi_int
thf(fact_3148_sin__two__pi,axiom,
    ( ( sin @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) )
    = ( zero_zero @ real ) ) ).

% sin_two_pi
thf(fact_3149_sin__pi__half,axiom,
    ( ( sin @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
    = ( one_one @ real ) ) ).

% sin_pi_half
thf(fact_3150_sin__periodic,axiom,
    ! [X2: real] :
      ( ( sin @ real @ ( plus_plus @ real @ X2 @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) ) )
      = ( sin @ real @ X2 ) ) ).

% sin_periodic
thf(fact_3151_sin__2npi,axiom,
    ! [N2: nat] :
      ( ( sin @ real @ ( times_times @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( semiring_1_of_nat @ real @ N2 ) ) @ pi ) )
      = ( zero_zero @ real ) ) ).

% sin_2npi
thf(fact_3152_sin__2pi__minus,axiom,
    ! [X2: real] :
      ( ( sin @ real @ ( minus_minus @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) @ X2 ) )
      = ( uminus_uminus @ real @ ( sin @ real @ X2 ) ) ) ).

% sin_2pi_minus
thf(fact_3153_sin__int__2pin,axiom,
    ! [N2: int] :
      ( ( sin @ real @ ( times_times @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) @ ( ring_1_of_int @ real @ N2 ) ) )
      = ( zero_zero @ real ) ) ).

% sin_int_2pin
thf(fact_3154_sin__3over2__pi,axiom,
    ( ( sin @ real @ ( times_times @ real @ ( divide_divide @ real @ ( numeral_numeral @ real @ ( bit1 @ one2 ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ pi ) )
    = ( uminus_uminus @ real @ ( one_one @ real ) ) ) ).

% sin_3over2_pi
thf(fact_3155_sin__cos__npi,axiom,
    ! [N2: nat] :
      ( ( sin @ real @ ( divide_divide @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) ) @ pi ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
      = ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ N2 ) ) ).

% sin_cos_npi
thf(fact_3156_sin__gt__zero,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( ord_less @ real @ X2 @ pi )
       => ( ord_less @ real @ ( zero_zero @ real ) @ ( sin @ real @ X2 ) ) ) ) ).

% sin_gt_zero
thf(fact_3157_sin__ge__zero,axiom,
    ! [X2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( ord_less_eq @ real @ X2 @ pi )
       => ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( sin @ real @ X2 ) ) ) ) ).

% sin_ge_zero
thf(fact_3158_pi__neq__zero,axiom,
    pi
 != ( zero_zero @ real ) ).

% pi_neq_zero
thf(fact_3159_arctan__monotone,axiom,
    ! [X2: real,Y2: real] :
      ( ( ord_less @ real @ X2 @ Y2 )
     => ( ord_less @ real @ ( arctan @ X2 ) @ ( arctan @ Y2 ) ) ) ).

% arctan_monotone
thf(fact_3160_arctan__less__iff,axiom,
    ! [X2: real,Y2: real] :
      ( ( ord_less @ real @ ( arctan @ X2 ) @ ( arctan @ Y2 ) )
      = ( ord_less @ real @ X2 @ Y2 ) ) ).

% arctan_less_iff
thf(fact_3161_arctan__le__iff,axiom,
    ! [X2: real,Y2: real] :
      ( ( ord_less_eq @ real @ ( arctan @ X2 ) @ ( arctan @ Y2 ) )
      = ( ord_less_eq @ real @ X2 @ Y2 ) ) ).

% arctan_le_iff
thf(fact_3162_arctan__monotone_H,axiom,
    ! [X2: real,Y2: real] :
      ( ( ord_less_eq @ real @ X2 @ Y2 )
     => ( ord_less_eq @ real @ ( arctan @ X2 ) @ ( arctan @ Y2 ) ) ) ).

% arctan_monotone'
thf(fact_3163_sin__eq__0__pi,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ pi ) @ X2 )
     => ( ( ord_less @ real @ X2 @ pi )
       => ( ( ( sin @ real @ X2 )
            = ( zero_zero @ real ) )
         => ( X2
            = ( zero_zero @ real ) ) ) ) ) ).

% sin_eq_0_pi
thf(fact_3164_sin__zero__pi__iff,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( abs_abs @ real @ X2 ) @ pi )
     => ( ( ( sin @ real @ X2 )
          = ( zero_zero @ real ) )
        = ( X2
          = ( zero_zero @ real ) ) ) ) ).

% sin_zero_pi_iff
thf(fact_3165_sin__zero__iff__int2,axiom,
    ! [X2: real] :
      ( ( ( sin @ real @ X2 )
        = ( zero_zero @ real ) )
      = ( ? [I4: int] :
            ( X2
            = ( times_times @ real @ ( ring_1_of_int @ real @ I4 ) @ pi ) ) ) ) ).

% sin_zero_iff_int2
thf(fact_3166_sin__x__le__x,axiom,
    ! [X2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X2 )
     => ( ord_less_eq @ real @ ( sin @ real @ X2 ) @ X2 ) ) ).

% sin_x_le_x
thf(fact_3167_sin__le__one,axiom,
    ! [X2: real] : ( ord_less_eq @ real @ ( sin @ real @ X2 ) @ ( one_one @ real ) ) ).

% sin_le_one
thf(fact_3168_abs__sin__x__le__abs__x,axiom,
    ! [X2: real] : ( ord_less_eq @ real @ ( abs_abs @ real @ ( sin @ real @ X2 ) ) @ ( abs_abs @ real @ X2 ) ) ).

% abs_sin_x_le_abs_x
thf(fact_3169_abs__zmult__eq__1,axiom,
    ! [M: int,N2: int] :
      ( ( ( abs_abs @ int @ ( times_times @ int @ M @ N2 ) )
        = ( one_one @ int ) )
     => ( ( abs_abs @ int @ M )
        = ( one_one @ int ) ) ) ).

% abs_zmult_eq_1
thf(fact_3170_pi__not__less__zero,axiom,
    ~ ( ord_less @ real @ pi @ ( zero_zero @ real ) ) ).

% pi_not_less_zero
thf(fact_3171_pi__gt__zero,axiom,
    ord_less @ real @ ( zero_zero @ real ) @ pi ).

% pi_gt_zero
thf(fact_3172_pi__ge__zero,axiom,
    ord_less_eq @ real @ ( zero_zero @ real ) @ pi ).

% pi_ge_zero
thf(fact_3173_abs__div,axiom,
    ! [Y2: int,X2: int] :
      ( ( dvd_dvd @ int @ Y2 @ X2 )
     => ( ( abs_abs @ int @ ( divide_divide @ int @ X2 @ Y2 ) )
        = ( divide_divide @ int @ ( abs_abs @ int @ X2 ) @ ( abs_abs @ int @ Y2 ) ) ) ) ).

% abs_div
thf(fact_3174_sin__pi__divide__n__ge__0,axiom,
    ! [N2: nat] :
      ( ( N2
       != ( zero_zero @ nat ) )
     => ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( sin @ real @ ( divide_divide @ real @ pi @ ( semiring_1_of_nat @ real @ N2 ) ) ) ) ) ).

% sin_pi_divide_n_ge_0
thf(fact_3175_arctan__ubound,axiom,
    ! [Y2: real] : ( ord_less @ real @ ( arctan @ Y2 ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ).

% arctan_ubound
thf(fact_3176_arctan__one,axiom,
    ( ( arctan @ ( one_one @ real ) )
    = ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ ( bit0 @ one2 ) ) ) ) ) ).

% arctan_one
thf(fact_3177_sin__gt__zero2,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( ord_less @ real @ X2 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
       => ( ord_less @ real @ ( zero_zero @ real ) @ ( sin @ real @ X2 ) ) ) ) ).

% sin_gt_zero2
thf(fact_3178_sin__lt__zero,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ pi @ X2 )
     => ( ( ord_less @ real @ X2 @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) )
       => ( ord_less @ real @ ( sin @ real @ X2 ) @ ( zero_zero @ real ) ) ) ) ).

% sin_lt_zero
thf(fact_3179_sin__30,axiom,
    ( ( sin @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ ( bit1 @ one2 ) ) ) ) )
    = ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ).

% sin_30
thf(fact_3180_sin__inj__pi,axiom,
    ! [X2: real,Y2: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ X2 )
     => ( ( ord_less_eq @ real @ X2 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
       => ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ Y2 )
         => ( ( ord_less_eq @ real @ Y2 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
           => ( ( ( sin @ real @ X2 )
                = ( sin @ real @ Y2 ) )
             => ( X2 = Y2 ) ) ) ) ) ) ).

% sin_inj_pi
thf(fact_3181_sin__mono__le__eq,axiom,
    ! [X2: real,Y2: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ X2 )
     => ( ( ord_less_eq @ real @ X2 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
       => ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ Y2 )
         => ( ( ord_less_eq @ real @ Y2 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
           => ( ( ord_less_eq @ real @ ( sin @ real @ X2 ) @ ( sin @ real @ Y2 ) )
              = ( ord_less_eq @ real @ X2 @ Y2 ) ) ) ) ) ) ).

% sin_mono_le_eq
thf(fact_3182_sin__monotone__2pi__le,axiom,
    ! [Y2: real,X2: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ Y2 )
     => ( ( ord_less_eq @ real @ Y2 @ X2 )
       => ( ( ord_less_eq @ real @ X2 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
         => ( ord_less_eq @ real @ ( sin @ real @ Y2 ) @ ( sin @ real @ X2 ) ) ) ) ) ).

% sin_monotone_2pi_le
thf(fact_3183_sin__x__ge__neg__x,axiom,
    ! [X2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X2 )
     => ( ord_less_eq @ real @ ( uminus_uminus @ real @ X2 ) @ ( sin @ real @ X2 ) ) ) ).

% sin_x_ge_neg_x
thf(fact_3184_sin__ge__minus__one,axiom,
    ! [X2: real] : ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ ( sin @ real @ X2 ) ) ).

% sin_ge_minus_one
thf(fact_3185_abs__sin__le__one,axiom,
    ! [X2: real] : ( ord_less_eq @ real @ ( abs_abs @ real @ ( sin @ real @ X2 ) ) @ ( one_one @ real ) ) ).

% abs_sin_le_one
thf(fact_3186_arctan__lbound,axiom,
    ! [Y2: real] : ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ ( arctan @ Y2 ) ) ).

% arctan_lbound
thf(fact_3187_arctan__bounded,axiom,
    ! [Y2: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ ( arctan @ Y2 ) )
      & ( ord_less @ real @ ( arctan @ Y2 ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ).

% arctan_bounded
thf(fact_3188_zabs__def,axiom,
    ( ( abs_abs @ int )
    = ( ^ [I4: int] : ( if @ int @ ( ord_less @ int @ I4 @ ( zero_zero @ int ) ) @ ( uminus_uminus @ int @ I4 ) @ I4 ) ) ) ).

% zabs_def
thf(fact_3189_dvd__imp__le__int,axiom,
    ! [I3: int,D2: int] :
      ( ( I3
       != ( zero_zero @ int ) )
     => ( ( dvd_dvd @ int @ D2 @ I3 )
       => ( ord_less_eq @ int @ ( abs_abs @ int @ D2 ) @ ( abs_abs @ int @ I3 ) ) ) ) ).

% dvd_imp_le_int
thf(fact_3190_abs__mod__less,axiom,
    ! [L: int,K: int] :
      ( ( L
       != ( zero_zero @ int ) )
     => ( ord_less @ int @ ( abs_abs @ int @ ( modulo_modulo @ int @ K @ L ) ) @ ( abs_abs @ int @ L ) ) ) ).

% abs_mod_less
thf(fact_3191_sin__le__zero,axiom,
    ! [X2: real] :
      ( ( ord_less_eq @ real @ pi @ X2 )
     => ( ( ord_less @ real @ X2 @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) )
       => ( ord_less_eq @ real @ ( sin @ real @ X2 ) @ ( zero_zero @ real ) ) ) ) ).

% sin_le_zero
thf(fact_3192_sin__less__zero,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( divide_divide @ real @ ( uminus_uminus @ real @ pi ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ X2 )
     => ( ( ord_less @ real @ X2 @ ( zero_zero @ real ) )
       => ( ord_less @ real @ ( sin @ real @ X2 ) @ ( zero_zero @ real ) ) ) ) ).

% sin_less_zero
thf(fact_3193_sin__mono__less__eq,axiom,
    ! [X2: real,Y2: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ X2 )
     => ( ( ord_less_eq @ real @ X2 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
       => ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ Y2 )
         => ( ( ord_less_eq @ real @ Y2 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
           => ( ( ord_less @ real @ ( sin @ real @ X2 ) @ ( sin @ real @ Y2 ) )
              = ( ord_less @ real @ X2 @ Y2 ) ) ) ) ) ) ).

% sin_mono_less_eq
thf(fact_3194_sin__monotone__2pi,axiom,
    ! [Y2: real,X2: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ Y2 )
     => ( ( ord_less @ real @ Y2 @ X2 )
       => ( ( ord_less_eq @ real @ X2 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
         => ( ord_less @ real @ ( sin @ real @ Y2 ) @ ( sin @ real @ X2 ) ) ) ) ) ).

% sin_monotone_2pi
thf(fact_3195_sin__total,axiom,
    ! [Y2: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ Y2 )
     => ( ( ord_less_eq @ real @ Y2 @ ( one_one @ real ) )
       => ? [X3: real] :
            ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ X3 )
            & ( ord_less_eq @ real @ X3 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
            & ( ( sin @ real @ X3 )
              = Y2 )
            & ! [Y: real] :
                ( ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ Y )
                  & ( ord_less_eq @ real @ Y @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
                  & ( ( sin @ real @ Y )
                    = Y2 ) )
               => ( Y = X3 ) ) ) ) ) ).

% sin_total
thf(fact_3196_sin__pi__divide__n__gt__0,axiom,
    ! [N2: nat] :
      ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 )
     => ( ord_less @ real @ ( zero_zero @ real ) @ ( sin @ real @ ( divide_divide @ real @ pi @ ( semiring_1_of_nat @ real @ N2 ) ) ) ) ) ).

% sin_pi_divide_n_gt_0
thf(fact_3197_machin__Euler,axiom,
    ( ( plus_plus @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit1 @ ( bit0 @ one2 ) ) ) @ ( arctan @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit1 @ ( bit1 @ one2 ) ) ) ) ) ) @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( arctan @ ( divide_divide @ real @ ( numeral_numeral @ real @ ( bit1 @ one2 ) ) @ ( numeral_numeral @ real @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit0 @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) )
    = ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ ( bit0 @ one2 ) ) ) ) ) ).

% machin_Euler
thf(fact_3198_machin,axiom,
    ( ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ ( bit0 @ one2 ) ) ) )
    = ( minus_minus @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ ( bit0 @ one2 ) ) ) @ ( arctan @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit1 @ ( bit0 @ one2 ) ) ) ) ) ) @ ( arctan @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit0 @ ( bit1 @ ( bit1 @ one2 ) ) ) ) ) ) ) ) ) ) ) ) ).

% machin
thf(fact_3199_pi__less__4,axiom,
    ord_less @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ ( bit0 @ one2 ) ) ) ).

% pi_less_4
thf(fact_3200_pi__ge__two,axiom,
    ord_less_eq @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ).

% pi_ge_two
thf(fact_3201_zdvd__mult__cancel1,axiom,
    ! [M: int,N2: int] :
      ( ( M
       != ( zero_zero @ int ) )
     => ( ( dvd_dvd @ int @ ( times_times @ int @ M @ N2 ) @ M )
        = ( ( abs_abs @ int @ N2 )
          = ( one_one @ int ) ) ) ) ).

% zdvd_mult_cancel1
thf(fact_3202_pi__half__neq__two,axiom,
    ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) )
 != ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ).

% pi_half_neq_two
thf(fact_3203_sin__zero__iff__int,axiom,
    ! [X2: real] :
      ( ( ( sin @ real @ X2 )
        = ( zero_zero @ real ) )
      = ( ? [I4: int] :
            ( ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ I4 )
            & ( X2
              = ( times_times @ real @ ( ring_1_of_int @ real @ I4 ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% sin_zero_iff_int
thf(fact_3204_sin__gt__zero__02,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( ord_less @ real @ X2 @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) )
       => ( ord_less @ real @ ( zero_zero @ real ) @ ( sin @ real @ X2 ) ) ) ) ).

% sin_gt_zero_02
thf(fact_3205_sin__zero__lemma,axiom,
    ! [X2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( ( sin @ real @ X2 )
          = ( zero_zero @ real ) )
       => ? [N: nat] :
            ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
            & ( X2
              = ( times_times @ real @ ( semiring_1_of_nat @ real @ N ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% sin_zero_lemma
thf(fact_3206_sin__zero__iff,axiom,
    ! [X2: real] :
      ( ( ( sin @ real @ X2 )
        = ( zero_zero @ real ) )
      = ( ? [N3: nat] :
            ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N3 )
            & ( X2
              = ( times_times @ real @ ( semiring_1_of_nat @ real @ N3 ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) )
        | ? [N3: nat] :
            ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N3 )
            & ( X2
              = ( uminus_uminus @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N3 ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ).

% sin_zero_iff
thf(fact_3207_even__abs__add__iff,axiom,
    ! [K: int,L: int] :
      ( ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( plus_plus @ int @ ( abs_abs @ int @ K ) @ L ) )
      = ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( plus_plus @ int @ K @ L ) ) ) ).

% even_abs_add_iff
thf(fact_3208_even__add__abs__iff,axiom,
    ! [K: int,L: int] :
      ( ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( plus_plus @ int @ K @ ( abs_abs @ int @ L ) ) )
      = ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( plus_plus @ int @ K @ L ) ) ) ).

% even_add_abs_iff
thf(fact_3209_pi__half__neq__zero,axiom,
    ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) )
 != ( zero_zero @ real ) ).

% pi_half_neq_zero
thf(fact_3210_pi__half__less__two,axiom,
    ord_less @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ).

% pi_half_less_two
thf(fact_3211_pi__half__le__two,axiom,
    ord_less_eq @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ).

% pi_half_le_two
thf(fact_3212_monoseq__realpow,axiom,
    ! [X2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( ord_less_eq @ real @ X2 @ ( one_one @ real ) )
       => ( topological_monoseq @ real @ ( power_power @ real @ X2 ) ) ) ) ).

% monoseq_realpow
thf(fact_3213_nat__intermed__int__val,axiom,
    ! [M: nat,N2: nat,F2: nat > int,K: int] :
      ( ! [I2: nat] :
          ( ( ( ord_less_eq @ nat @ M @ I2 )
            & ( ord_less @ nat @ I2 @ N2 ) )
         => ( ord_less_eq @ int @ ( abs_abs @ int @ ( minus_minus @ int @ ( F2 @ ( suc @ I2 ) ) @ ( F2 @ I2 ) ) ) @ ( one_one @ int ) ) )
     => ( ( ord_less_eq @ nat @ M @ N2 )
       => ( ( ord_less_eq @ int @ ( F2 @ M ) @ K )
         => ( ( ord_less_eq @ int @ K @ ( F2 @ N2 ) )
           => ? [I2: nat] :
                ( ( ord_less_eq @ nat @ M @ I2 )
                & ( ord_less_eq @ nat @ I2 @ N2 )
                & ( ( F2 @ I2 )
                  = K ) ) ) ) ) ) ).

% nat_intermed_int_val
thf(fact_3214_decr__lemma,axiom,
    ! [D2: int,X2: int,Z: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D2 )
     => ( ord_less @ int @ ( minus_minus @ int @ X2 @ ( times_times @ int @ ( plus_plus @ int @ ( abs_abs @ int @ ( minus_minus @ int @ X2 @ Z ) ) @ ( one_one @ int ) ) @ D2 ) ) @ Z ) ) ).

% decr_lemma
thf(fact_3215_incr__lemma,axiom,
    ! [D2: int,Z: int,X2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D2 )
     => ( ord_less @ int @ Z @ ( plus_plus @ int @ X2 @ ( times_times @ int @ ( plus_plus @ int @ ( abs_abs @ int @ ( minus_minus @ int @ X2 @ Z ) ) @ ( one_one @ int ) ) @ D2 ) ) ) ) ).

% incr_lemma
thf(fact_3216_pi__half__gt__zero,axiom,
    ord_less @ real @ ( zero_zero @ real ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ).

% pi_half_gt_zero
thf(fact_3217_pi__half__ge__zero,axiom,
    ord_less_eq @ real @ ( zero_zero @ real ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ).

% pi_half_ge_zero
thf(fact_3218_m2pi__less__pi,axiom,
    ord_less @ real @ ( uminus_uminus @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) ) @ pi ).

% m2pi_less_pi
thf(fact_3219_Maclaurin__sin__expansion,axiom,
    ! [X2: real,N2: nat] :
    ? [T4: real] :
      ( ( sin @ real @ X2 )
      = ( plus_plus @ real
        @ ( groups7311177749621191930dd_sum @ nat @ real
          @ ^ [M6: nat] : ( times_times @ real @ ( sin_coeff @ M6 ) @ ( power_power @ real @ X2 @ M6 ) )
          @ ( set_ord_lessThan @ nat @ N2 ) )
        @ ( times_times @ real @ ( divide_divide @ real @ ( sin @ real @ ( plus_plus @ real @ T4 @ ( times_times @ real @ ( times_times @ real @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( semiring_1_of_nat @ real @ N2 ) ) @ pi ) ) ) @ ( semiring_char_0_fact @ real @ N2 ) ) @ ( power_power @ real @ X2 @ N2 ) ) ) ) ).

% Maclaurin_sin_expansion
thf(fact_3220_nat__ivt__aux,axiom,
    ! [N2: nat,F2: nat > int,K: int] :
      ( ! [I2: nat] :
          ( ( ord_less @ nat @ I2 @ N2 )
         => ( ord_less_eq @ int @ ( abs_abs @ int @ ( minus_minus @ int @ ( F2 @ ( suc @ I2 ) ) @ ( F2 @ I2 ) ) ) @ ( one_one @ int ) ) )
     => ( ( ord_less_eq @ int @ ( F2 @ ( zero_zero @ nat ) ) @ K )
       => ( ( ord_less_eq @ int @ K @ ( F2 @ N2 ) )
         => ? [I2: nat] :
              ( ( ord_less_eq @ nat @ I2 @ N2 )
              & ( ( F2 @ I2 )
                = K ) ) ) ) ) ).

% nat_ivt_aux
thf(fact_3221_complex__mod__minus__le__complex__mod,axiom,
    ! [X2: complex] : ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( real_V7770717601297561774m_norm @ complex @ X2 ) ) @ ( real_V7770717601297561774m_norm @ complex @ X2 ) ) ).

% complex_mod_minus_le_complex_mod
thf(fact_3222_minus__pi__half__less__zero,axiom,
    ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ ( zero_zero @ real ) ).

% minus_pi_half_less_zero
thf(fact_3223_complex__mod__triangle__ineq2,axiom,
    ! [B2: complex,A2: complex] : ( ord_less_eq @ real @ ( minus_minus @ real @ ( real_V7770717601297561774m_norm @ complex @ ( plus_plus @ complex @ B2 @ A2 ) ) @ ( real_V7770717601297561774m_norm @ complex @ B2 ) ) @ ( real_V7770717601297561774m_norm @ complex @ A2 ) ) ).

% complex_mod_triangle_ineq2
thf(fact_3224_Maclaurin__sin__expansion2,axiom,
    ! [X2: real,N2: nat] :
    ? [T4: real] :
      ( ( ord_less_eq @ real @ ( abs_abs @ real @ T4 ) @ ( abs_abs @ real @ X2 ) )
      & ( ( sin @ real @ X2 )
        = ( plus_plus @ real
          @ ( groups7311177749621191930dd_sum @ nat @ real
            @ ^ [M6: nat] : ( times_times @ real @ ( sin_coeff @ M6 ) @ ( power_power @ real @ X2 @ M6 ) )
            @ ( set_ord_lessThan @ nat @ N2 ) )
          @ ( times_times @ real @ ( divide_divide @ real @ ( sin @ real @ ( plus_plus @ real @ T4 @ ( times_times @ real @ ( times_times @ real @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( semiring_1_of_nat @ real @ N2 ) ) @ pi ) ) ) @ ( semiring_char_0_fact @ real @ N2 ) ) @ ( power_power @ real @ X2 @ N2 ) ) ) ) ) ).

% Maclaurin_sin_expansion2
thf(fact_3225_nat0__intermed__int__val,axiom,
    ! [N2: nat,F2: nat > int,K: int] :
      ( ! [I2: nat] :
          ( ( ord_less @ nat @ I2 @ N2 )
         => ( ord_less_eq @ int @ ( abs_abs @ int @ ( minus_minus @ int @ ( F2 @ ( plus_plus @ nat @ I2 @ ( one_one @ nat ) ) ) @ ( F2 @ I2 ) ) ) @ ( one_one @ int ) ) )
     => ( ( ord_less_eq @ int @ ( F2 @ ( zero_zero @ nat ) ) @ K )
       => ( ( ord_less_eq @ int @ K @ ( F2 @ N2 ) )
         => ? [I2: nat] :
              ( ( ord_less_eq @ nat @ I2 @ N2 )
              & ( ( F2 @ I2 )
                = K ) ) ) ) ) ).

% nat0_intermed_int_val
thf(fact_3226_Maclaurin__sin__expansion4,axiom,
    ! [X2: real,N2: nat] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
     => ? [T4: real] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ T4 )
          & ( ord_less_eq @ real @ T4 @ X2 )
          & ( ( sin @ real @ X2 )
            = ( plus_plus @ real
              @ ( groups7311177749621191930dd_sum @ nat @ real
                @ ^ [M6: nat] : ( times_times @ real @ ( sin_coeff @ M6 ) @ ( power_power @ real @ X2 @ M6 ) )
                @ ( set_ord_lessThan @ nat @ N2 ) )
              @ ( times_times @ real @ ( divide_divide @ real @ ( sin @ real @ ( plus_plus @ real @ T4 @ ( times_times @ real @ ( times_times @ real @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( semiring_1_of_nat @ real @ N2 ) ) @ pi ) ) ) @ ( semiring_char_0_fact @ real @ N2 ) ) @ ( power_power @ real @ X2 @ N2 ) ) ) ) ) ) ).

% Maclaurin_sin_expansion4
thf(fact_3227_sum__nth__roots,axiom,
    ! [N2: nat,C2: complex] :
      ( ( ord_less @ nat @ ( one_one @ nat ) @ N2 )
     => ( ( groups7311177749621191930dd_sum @ complex @ complex
          @ ^ [X5: complex] : X5
          @ ( collect @ complex
            @ ^ [Z6: complex] :
                ( ( power_power @ complex @ Z6 @ N2 )
                = C2 ) ) )
        = ( zero_zero @ complex ) ) ) ).

% sum_nth_roots
thf(fact_3228_sum__roots__unity,axiom,
    ! [N2: nat] :
      ( ( ord_less @ nat @ ( one_one @ nat ) @ N2 )
     => ( ( groups7311177749621191930dd_sum @ complex @ complex
          @ ^ [X5: complex] : X5
          @ ( collect @ complex
            @ ^ [Z6: complex] :
                ( ( power_power @ complex @ Z6 @ N2 )
                = ( one_one @ complex ) ) ) )
        = ( zero_zero @ complex ) ) ) ).

% sum_roots_unity
thf(fact_3229_arctan__add,axiom,
    ! [X2: real,Y2: real] :
      ( ( ord_less_eq @ real @ ( abs_abs @ real @ X2 ) @ ( one_one @ real ) )
     => ( ( ord_less @ real @ ( abs_abs @ real @ Y2 ) @ ( one_one @ real ) )
       => ( ( plus_plus @ real @ ( arctan @ X2 ) @ ( arctan @ Y2 ) )
          = ( arctan @ ( divide_divide @ real @ ( plus_plus @ real @ X2 @ Y2 ) @ ( minus_minus @ real @ ( one_one @ real ) @ ( times_times @ real @ X2 @ Y2 ) ) ) ) ) ) ) ).

% arctan_add
thf(fact_3230_Maclaurin__sin__expansion3,axiom,
    ! [N2: nat,X2: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
       => ? [T4: real] :
            ( ( ord_less @ real @ ( zero_zero @ real ) @ T4 )
            & ( ord_less @ real @ T4 @ X2 )
            & ( ( sin @ real @ X2 )
              = ( plus_plus @ real
                @ ( groups7311177749621191930dd_sum @ nat @ real
                  @ ^ [M6: nat] : ( times_times @ real @ ( sin_coeff @ M6 ) @ ( power_power @ real @ X2 @ M6 ) )
                  @ ( set_ord_lessThan @ nat @ N2 ) )
                @ ( times_times @ real @ ( divide_divide @ real @ ( sin @ real @ ( plus_plus @ real @ T4 @ ( times_times @ real @ ( times_times @ real @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( semiring_1_of_nat @ real @ N2 ) ) @ pi ) ) ) @ ( semiring_char_0_fact @ real @ N2 ) ) @ ( power_power @ real @ X2 @ N2 ) ) ) ) ) ) ) ).

% Maclaurin_sin_expansion3
thf(fact_3231_arctan__double,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( abs_abs @ real @ X2 ) @ ( one_one @ real ) )
     => ( ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( arctan @ X2 ) )
        = ( arctan @ ( divide_divide @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ X2 ) @ ( minus_minus @ real @ ( one_one @ real ) @ ( power_power @ real @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% arctan_double
thf(fact_3232_sin__x__sin__y,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X2: A,Y2: A] :
          ( sums @ A
          @ ^ [P6: nat] :
              ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [N3: nat] :
                  ( if @ A
                  @ ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ P6 )
                    & ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N3 ) )
                  @ ( times_times @ A @ ( real_V8093663219630862766scaleR @ A @ ( uminus_uminus @ real @ ( divide_divide @ real @ ( ring_1_of_int @ real @ ( times_times @ int @ ( power_power @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( divide_divide @ nat @ P6 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( semiring_1_of_nat @ int @ ( binomial @ P6 @ N3 ) ) ) ) @ ( semiring_char_0_fact @ real @ P6 ) ) ) @ ( power_power @ A @ X2 @ N3 ) ) @ ( power_power @ A @ Y2 @ ( minus_minus @ nat @ P6 @ N3 ) ) )
                  @ ( zero_zero @ A ) )
              @ ( set_ord_atMost @ nat @ P6 ) )
          @ ( times_times @ A @ ( sin @ A @ X2 ) @ ( sin @ A @ Y2 ) ) ) ) ).

% sin_x_sin_y
thf(fact_3233_Maclaurin__minus__cos__expansion,axiom,
    ! [N2: nat,X2: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( ord_less @ real @ X2 @ ( zero_zero @ real ) )
       => ? [T4: real] :
            ( ( ord_less @ real @ X2 @ T4 )
            & ( ord_less @ real @ T4 @ ( zero_zero @ real ) )
            & ( ( cos @ real @ X2 )
              = ( plus_plus @ real
                @ ( groups7311177749621191930dd_sum @ nat @ real
                  @ ^ [M6: nat] : ( times_times @ real @ ( cos_coeff @ M6 ) @ ( power_power @ real @ X2 @ M6 ) )
                  @ ( set_ord_lessThan @ nat @ N2 ) )
                @ ( times_times @ real @ ( divide_divide @ real @ ( cos @ real @ ( plus_plus @ real @ T4 @ ( times_times @ real @ ( times_times @ real @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( semiring_1_of_nat @ real @ N2 ) ) @ pi ) ) ) @ ( semiring_char_0_fact @ real @ N2 ) ) @ ( power_power @ real @ X2 @ N2 ) ) ) ) ) ) ) ).

% Maclaurin_minus_cos_expansion
thf(fact_3234_Maclaurin__cos__expansion2,axiom,
    ! [X2: real,N2: nat] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
       => ? [T4: real] :
            ( ( ord_less @ real @ ( zero_zero @ real ) @ T4 )
            & ( ord_less @ real @ T4 @ X2 )
            & ( ( cos @ real @ X2 )
              = ( plus_plus @ real
                @ ( groups7311177749621191930dd_sum @ nat @ real
                  @ ^ [M6: nat] : ( times_times @ real @ ( cos_coeff @ M6 ) @ ( power_power @ real @ X2 @ M6 ) )
                  @ ( set_ord_lessThan @ nat @ N2 ) )
                @ ( times_times @ real @ ( divide_divide @ real @ ( cos @ real @ ( plus_plus @ real @ T4 @ ( times_times @ real @ ( times_times @ real @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( semiring_1_of_nat @ real @ N2 ) ) @ pi ) ) ) @ ( semiring_char_0_fact @ real @ N2 ) ) @ ( power_power @ real @ X2 @ N2 ) ) ) ) ) ) ) ).

% Maclaurin_cos_expansion2
thf(fact_3235_Maclaurin__cos__expansion,axiom,
    ! [X2: real,N2: nat] :
    ? [T4: real] :
      ( ( ord_less_eq @ real @ ( abs_abs @ real @ T4 ) @ ( abs_abs @ real @ X2 ) )
      & ( ( cos @ real @ X2 )
        = ( plus_plus @ real
          @ ( groups7311177749621191930dd_sum @ nat @ real
            @ ^ [M6: nat] : ( times_times @ real @ ( cos_coeff @ M6 ) @ ( power_power @ real @ X2 @ M6 ) )
            @ ( set_ord_lessThan @ nat @ N2 ) )
          @ ( times_times @ real @ ( divide_divide @ real @ ( cos @ real @ ( plus_plus @ real @ T4 @ ( times_times @ real @ ( times_times @ real @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( semiring_1_of_nat @ real @ N2 ) ) @ pi ) ) ) @ ( semiring_char_0_fact @ real @ N2 ) ) @ ( power_power @ real @ X2 @ N2 ) ) ) ) ) ).

% Maclaurin_cos_expansion
thf(fact_3236_summable__arctan__series,axiom,
    ! [X2: real] :
      ( ( ord_less_eq @ real @ ( abs_abs @ real @ X2 ) @ ( one_one @ real ) )
     => ( summable @ real
        @ ^ [K3: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ K3 ) @ ( times_times @ real @ ( divide_divide @ real @ ( one_one @ real ) @ ( semiring_1_of_nat @ real @ ( plus_plus @ nat @ ( times_times @ nat @ K3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ nat ) ) ) ) @ ( power_power @ real @ X2 @ ( plus_plus @ nat @ ( times_times @ nat @ K3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ nat ) ) ) ) ) ) ) ).

% summable_arctan_series
thf(fact_3237_scaleR__cancel__right,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [A2: real,X2: A,B2: real] :
          ( ( ( real_V8093663219630862766scaleR @ A @ A2 @ X2 )
            = ( real_V8093663219630862766scaleR @ A @ B2 @ X2 ) )
          = ( ( A2 = B2 )
            | ( X2
              = ( zero_zero @ A ) ) ) ) ) ).

% scaleR_cancel_right
thf(fact_3238_scaleR__zero__right,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [A2: real] :
          ( ( real_V8093663219630862766scaleR @ A @ A2 @ ( zero_zero @ A ) )
          = ( zero_zero @ A ) ) ) ).

% scaleR_zero_right
thf(fact_3239_mult__scaleR__right,axiom,
    ! [A: $tType] :
      ( ( real_V6157519004096292374lgebra @ A )
     => ! [X2: A,A2: real,Y2: A] :
          ( ( times_times @ A @ X2 @ ( real_V8093663219630862766scaleR @ A @ A2 @ Y2 ) )
          = ( real_V8093663219630862766scaleR @ A @ A2 @ ( times_times @ A @ X2 @ Y2 ) ) ) ) ).

% mult_scaleR_right
thf(fact_3240_mult__scaleR__left,axiom,
    ! [A: $tType] :
      ( ( real_V6157519004096292374lgebra @ A )
     => ! [A2: real,X2: A,Y2: A] :
          ( ( times_times @ A @ ( real_V8093663219630862766scaleR @ A @ A2 @ X2 ) @ Y2 )
          = ( real_V8093663219630862766scaleR @ A @ A2 @ ( times_times @ A @ X2 @ Y2 ) ) ) ) ).

% mult_scaleR_left
thf(fact_3241_scaleR__cancel__left,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [A2: real,X2: A,Y2: A] :
          ( ( ( real_V8093663219630862766scaleR @ A @ A2 @ X2 )
            = ( real_V8093663219630862766scaleR @ A @ A2 @ Y2 ) )
          = ( ( X2 = Y2 )
            | ( A2
              = ( zero_zero @ real ) ) ) ) ) ).

% scaleR_cancel_left
thf(fact_3242_scaleR__scaleR,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [A2: real,B2: real,X2: A] :
          ( ( real_V8093663219630862766scaleR @ A @ A2 @ ( real_V8093663219630862766scaleR @ A @ B2 @ X2 ) )
          = ( real_V8093663219630862766scaleR @ A @ ( times_times @ real @ A2 @ B2 ) @ X2 ) ) ) ).

% scaleR_scaleR
thf(fact_3243_summable__zero,axiom,
    ! [A: $tType] :
      ( ( ( comm_monoid_add @ A )
        & ( topolo4958980785337419405_space @ A ) )
     => ( summable @ A
        @ ^ [N3: nat] : ( zero_zero @ A ) ) ) ).

% summable_zero
thf(fact_3244_summable__single,axiom,
    ! [A: $tType] :
      ( ( ( comm_monoid_add @ A )
        & ( topolo4958980785337419405_space @ A ) )
     => ! [I3: nat,F2: nat > A] :
          ( summable @ A
          @ ^ [R5: nat] : ( if @ A @ ( R5 = I3 ) @ ( F2 @ R5 ) @ ( zero_zero @ A ) ) ) ) ).

% summable_single
thf(fact_3245_summable__iff__shift,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: nat > A,K: nat] :
          ( ( summable @ A
            @ ^ [N3: nat] : ( F2 @ ( plus_plus @ nat @ N3 @ K ) ) )
          = ( summable @ A @ F2 ) ) ) ).

% summable_iff_shift
thf(fact_3246_cos__zero,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ( ( cos @ A @ ( zero_zero @ A ) )
        = ( one_one @ A ) ) ) ).

% cos_zero
thf(fact_3247_scaleR__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [A2: real,X2: A] :
          ( ( ( real_V8093663219630862766scaleR @ A @ A2 @ X2 )
            = ( zero_zero @ A ) )
          = ( ( A2
              = ( zero_zero @ real ) )
            | ( X2
              = ( zero_zero @ A ) ) ) ) ) ).

% scaleR_eq_0_iff
thf(fact_3248_scaleR__zero__left,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [X2: A] :
          ( ( real_V8093663219630862766scaleR @ A @ ( zero_zero @ real ) @ X2 )
          = ( zero_zero @ A ) ) ) ).

% scaleR_zero_left
thf(fact_3249_scaleR__eq__iff,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [B2: A,U: real,A2: A] :
          ( ( ( plus_plus @ A @ B2 @ ( real_V8093663219630862766scaleR @ A @ U @ A2 ) )
            = ( plus_plus @ A @ A2 @ ( real_V8093663219630862766scaleR @ A @ U @ B2 ) ) )
          = ( ( A2 = B2 )
            | ( U
              = ( one_one @ real ) ) ) ) ) ).

% scaleR_eq_iff
thf(fact_3250_scaleR__power,axiom,
    ! [A: $tType] :
      ( ( real_V2822296259951069270ebra_1 @ A )
     => ! [X2: real,Y2: A,N2: nat] :
          ( ( power_power @ A @ ( real_V8093663219630862766scaleR @ A @ X2 @ Y2 ) @ N2 )
          = ( real_V8093663219630862766scaleR @ A @ ( power_power @ real @ X2 @ N2 ) @ ( power_power @ A @ Y2 @ N2 ) ) ) ) ).

% scaleR_power
thf(fact_3251_summable__cmult__iff,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [C2: A,F2: nat > A] :
          ( ( summable @ A
            @ ^ [N3: nat] : ( times_times @ A @ C2 @ ( F2 @ N3 ) ) )
          = ( ( C2
              = ( zero_zero @ A ) )
            | ( summable @ A @ F2 ) ) ) ) ).

% summable_cmult_iff
thf(fact_3252_summable__divide__iff,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: nat > A,C2: A] :
          ( ( summable @ A
            @ ^ [N3: nat] : ( divide_divide @ A @ ( F2 @ N3 ) @ C2 ) )
          = ( ( C2
              = ( zero_zero @ A ) )
            | ( summable @ A @ F2 ) ) ) ) ).

% summable_divide_iff
thf(fact_3253_scaleR__collapse,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [U: real,A2: A] :
          ( ( plus_plus @ A @ ( real_V8093663219630862766scaleR @ A @ ( minus_minus @ real @ ( one_one @ real ) @ U ) @ A2 ) @ ( real_V8093663219630862766scaleR @ A @ U @ A2 ) )
          = A2 ) ) ).

% scaleR_collapse
thf(fact_3254_norm__scaleR,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [A2: real,X2: A] :
          ( ( real_V7770717601297561774m_norm @ A @ ( real_V8093663219630862766scaleR @ A @ A2 @ X2 ) )
          = ( times_times @ real @ ( abs_abs @ real @ A2 ) @ ( real_V7770717601297561774m_norm @ A @ X2 ) ) ) ) ).

% norm_scaleR
thf(fact_3255_scaleR__times,axiom,
    ! [A: $tType] :
      ( ( real_V2191834092415804123ebra_1 @ A )
     => ! [U: num,W: num,A2: A] :
          ( ( real_V8093663219630862766scaleR @ A @ ( numeral_numeral @ real @ U ) @ ( times_times @ A @ ( numeral_numeral @ A @ W ) @ A2 ) )
          = ( real_V8093663219630862766scaleR @ A @ ( times_times @ real @ ( numeral_numeral @ real @ U ) @ ( numeral_numeral @ real @ W ) ) @ A2 ) ) ) ).

% scaleR_times
thf(fact_3256_sin__cos__squared__add3,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X2: A] :
          ( ( plus_plus @ A @ ( times_times @ A @ ( cos @ A @ X2 ) @ ( cos @ A @ X2 ) ) @ ( times_times @ A @ ( sin @ A @ X2 ) @ ( sin @ A @ X2 ) ) )
          = ( one_one @ A ) ) ) ).

% sin_cos_squared_add3
thf(fact_3257_summable__geometric__iff,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [C2: A] :
          ( ( summable @ A @ ( power_power @ A @ C2 ) )
          = ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ C2 ) @ ( one_one @ real ) ) ) ) ).

% summable_geometric_iff
thf(fact_3258_inverse__scaleR__times,axiom,
    ! [A: $tType] :
      ( ( real_V2191834092415804123ebra_1 @ A )
     => ! [V: num,W: num,A2: A] :
          ( ( real_V8093663219630862766scaleR @ A @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ V ) ) @ ( times_times @ A @ ( numeral_numeral @ A @ W ) @ A2 ) )
          = ( real_V8093663219630862766scaleR @ A @ ( divide_divide @ real @ ( numeral_numeral @ real @ W ) @ ( numeral_numeral @ real @ V ) ) @ A2 ) ) ) ).

% inverse_scaleR_times
thf(fact_3259_fraction__scaleR__times,axiom,
    ! [A: $tType] :
      ( ( real_V2191834092415804123ebra_1 @ A )
     => ! [U: num,V: num,W: num,A2: A] :
          ( ( real_V8093663219630862766scaleR @ A @ ( divide_divide @ real @ ( numeral_numeral @ real @ U ) @ ( numeral_numeral @ real @ V ) ) @ ( times_times @ A @ ( numeral_numeral @ A @ W ) @ A2 ) )
          = ( real_V8093663219630862766scaleR @ A @ ( divide_divide @ real @ ( times_times @ real @ ( numeral_numeral @ real @ U ) @ ( numeral_numeral @ real @ W ) ) @ ( numeral_numeral @ real @ V ) ) @ A2 ) ) ) ).

% fraction_scaleR_times
thf(fact_3260_scaleR__half__double,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [A2: A] :
          ( ( real_V8093663219630862766scaleR @ A @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( plus_plus @ A @ A2 @ A2 ) )
          = A2 ) ) ).

% scaleR_half_double
thf(fact_3261_cos__pi__half,axiom,
    ( ( cos @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
    = ( zero_zero @ real ) ) ).

% cos_pi_half
thf(fact_3262_cos__two__pi,axiom,
    ( ( cos @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) )
    = ( one_one @ real ) ) ).

% cos_two_pi
thf(fact_3263_cos__periodic,axiom,
    ! [X2: real] :
      ( ( cos @ real @ ( plus_plus @ real @ X2 @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) ) )
      = ( cos @ real @ X2 ) ) ).

% cos_periodic
thf(fact_3264_cos__2pi__minus,axiom,
    ! [X2: real] :
      ( ( cos @ real @ ( minus_minus @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) @ X2 ) )
      = ( cos @ real @ X2 ) ) ).

% cos_2pi_minus
thf(fact_3265_cos__npi,axiom,
    ! [N2: nat] :
      ( ( cos @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N2 ) @ pi ) )
      = ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ N2 ) ) ).

% cos_npi
thf(fact_3266_cos__npi2,axiom,
    ! [N2: nat] :
      ( ( cos @ real @ ( times_times @ real @ pi @ ( semiring_1_of_nat @ real @ N2 ) ) )
      = ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ N2 ) ) ).

% cos_npi2
thf(fact_3267_sin__cos__squared__add,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X2: A] :
          ( ( plus_plus @ A @ ( power_power @ A @ ( sin @ A @ X2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ A @ ( cos @ A @ X2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
          = ( one_one @ A ) ) ) ).

% sin_cos_squared_add
thf(fact_3268_sin__cos__squared__add2,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X2: A] :
          ( ( plus_plus @ A @ ( power_power @ A @ ( cos @ A @ X2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ A @ ( sin @ A @ X2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
          = ( one_one @ A ) ) ) ).

% sin_cos_squared_add2
thf(fact_3269_cos__2npi,axiom,
    ! [N2: nat] :
      ( ( cos @ real @ ( times_times @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( semiring_1_of_nat @ real @ N2 ) ) @ pi ) )
      = ( one_one @ real ) ) ).

% cos_2npi
thf(fact_3270_cos__int__2pin,axiom,
    ! [N2: int] :
      ( ( cos @ real @ ( times_times @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) @ ( ring_1_of_int @ real @ N2 ) ) )
      = ( one_one @ real ) ) ).

% cos_int_2pin
thf(fact_3271_cos__3over2__pi,axiom,
    ( ( cos @ real @ ( times_times @ real @ ( divide_divide @ real @ ( numeral_numeral @ real @ ( bit1 @ one2 ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ pi ) )
    = ( zero_zero @ real ) ) ).

% cos_3over2_pi
thf(fact_3272_cos__npi__int,axiom,
    ! [N2: int] :
      ( ( ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N2 )
       => ( ( cos @ real @ ( times_times @ real @ pi @ ( ring_1_of_int @ real @ N2 ) ) )
          = ( one_one @ real ) ) )
      & ( ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N2 )
       => ( ( cos @ real @ ( times_times @ real @ pi @ ( ring_1_of_int @ real @ N2 ) ) )
          = ( uminus_uminus @ real @ ( one_one @ real ) ) ) ) ) ).

% cos_npi_int
thf(fact_3273_cos__pi__eq__zero,axiom,
    ! [M: nat] :
      ( ( cos @ real @ ( divide_divide @ real @ ( times_times @ real @ pi @ ( semiring_1_of_nat @ real @ ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M ) ) ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
      = ( zero_zero @ real ) ) ).

% cos_pi_eq_zero
thf(fact_3274_scaleR__left__imp__eq,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [A2: real,X2: A,Y2: A] :
          ( ( A2
           != ( zero_zero @ real ) )
         => ( ( ( real_V8093663219630862766scaleR @ A @ A2 @ X2 )
              = ( real_V8093663219630862766scaleR @ A @ A2 @ Y2 ) )
           => ( X2 = Y2 ) ) ) ) ).

% scaleR_left_imp_eq
thf(fact_3275_real__scaleR__def,axiom,
    ( ( real_V8093663219630862766scaleR @ real )
    = ( times_times @ real ) ) ).

% real_scaleR_def
thf(fact_3276_scaleR__right__distrib,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [A2: real,X2: A,Y2: A] :
          ( ( real_V8093663219630862766scaleR @ A @ A2 @ ( plus_plus @ A @ X2 @ Y2 ) )
          = ( plus_plus @ A @ ( real_V8093663219630862766scaleR @ A @ A2 @ X2 ) @ ( real_V8093663219630862766scaleR @ A @ A2 @ Y2 ) ) ) ) ).

% scaleR_right_distrib
thf(fact_3277_scaleR__right__imp__eq,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [X2: A,A2: real,B2: real] :
          ( ( X2
           != ( zero_zero @ A ) )
         => ( ( ( real_V8093663219630862766scaleR @ A @ A2 @ X2 )
              = ( real_V8093663219630862766scaleR @ A @ B2 @ X2 ) )
           => ( A2 = B2 ) ) ) ) ).

% scaleR_right_imp_eq
thf(fact_3278_summable__const__iff,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [C2: A] :
          ( ( summable @ A
            @ ^ [Uu3: nat] : C2 )
          = ( C2
            = ( zero_zero @ A ) ) ) ) ).

% summable_const_iff
thf(fact_3279_summable__comparison__test_H,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach @ A )
     => ! [G: nat > real,N4: nat,F2: nat > A] :
          ( ( summable @ real @ G )
         => ( ! [N: nat] :
                ( ( ord_less_eq @ nat @ N4 @ N )
               => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( F2 @ N ) ) @ ( G @ N ) ) )
           => ( summable @ A @ F2 ) ) ) ) ).

% summable_comparison_test'
thf(fact_3280_summable__comparison__test,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach @ A )
     => ! [F2: nat > A,G: nat > real] :
          ( ? [N7: nat] :
            ! [N: nat] :
              ( ( ord_less_eq @ nat @ N7 @ N )
             => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( F2 @ N ) ) @ ( G @ N ) ) )
         => ( ( summable @ real @ G )
           => ( summable @ A @ F2 ) ) ) ) ).

% summable_comparison_test
thf(fact_3281_summable__mult2,axiom,
    ! [A: $tType] :
      ( ( real_V4412858255891104859lgebra @ A )
     => ! [F2: nat > A,C2: A] :
          ( ( summable @ A @ F2 )
         => ( summable @ A
            @ ^ [N3: nat] : ( times_times @ A @ ( F2 @ N3 ) @ C2 ) ) ) ) ).

% summable_mult2
thf(fact_3282_summable__mult,axiom,
    ! [A: $tType] :
      ( ( real_V4412858255891104859lgebra @ A )
     => ! [F2: nat > A,C2: A] :
          ( ( summable @ A @ F2 )
         => ( summable @ A
            @ ^ [N3: nat] : ( times_times @ A @ C2 @ ( F2 @ N3 ) ) ) ) ) ).

% summable_mult
thf(fact_3283_summable__add,axiom,
    ! [A: $tType] :
      ( ( ( topolo5987344860129210374id_add @ A )
        & ( topological_t2_space @ A ) )
     => ! [F2: nat > A,G: nat > A] :
          ( ( summable @ A @ F2 )
         => ( ( summable @ A @ G )
           => ( summable @ A
              @ ^ [N3: nat] : ( plus_plus @ A @ ( F2 @ N3 ) @ ( G @ N3 ) ) ) ) ) ) ).

% summable_add
thf(fact_3284_summable__divide,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: nat > A,C2: A] :
          ( ( summable @ A @ F2 )
         => ( summable @ A
            @ ^ [N3: nat] : ( divide_divide @ A @ ( F2 @ N3 ) @ C2 ) ) ) ) ).

% summable_divide
thf(fact_3285_summable__Suc__iff,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: nat > A] :
          ( ( summable @ A
            @ ^ [N3: nat] : ( F2 @ ( suc @ N3 ) ) )
          = ( summable @ A @ F2 ) ) ) ).

% summable_Suc_iff
thf(fact_3286_summable__ignore__initial__segment,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: nat > A,K: nat] :
          ( ( summable @ A @ F2 )
         => ( summable @ A
            @ ^ [N3: nat] : ( F2 @ ( plus_plus @ nat @ N3 @ K ) ) ) ) ) ).

% summable_ignore_initial_segment
thf(fact_3287_summable__norm__sin,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [X2: A] :
          ( summable @ real
          @ ^ [N3: nat] : ( real_V7770717601297561774m_norm @ A @ ( real_V8093663219630862766scaleR @ A @ ( sin_coeff @ N3 ) @ ( power_power @ A @ X2 @ N3 ) ) ) ) ) ).

% summable_norm_sin
thf(fact_3288_summable__norm__cos,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [X2: A] :
          ( summable @ real
          @ ^ [N3: nat] : ( real_V7770717601297561774m_norm @ A @ ( real_V8093663219630862766scaleR @ A @ ( cos_coeff @ N3 ) @ ( power_power @ A @ X2 @ N3 ) ) ) ) ) ).

% summable_norm_cos
thf(fact_3289_cos__converges,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [X2: A] :
          ( sums @ A
          @ ^ [N3: nat] : ( real_V8093663219630862766scaleR @ A @ ( cos_coeff @ N3 ) @ ( power_power @ A @ X2 @ N3 ) )
          @ ( cos @ A @ X2 ) ) ) ).

% cos_converges
thf(fact_3290_cos__def,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ( ( cos @ A )
        = ( ^ [X5: A] :
              ( suminf @ A
              @ ^ [N3: nat] : ( real_V8093663219630862766scaleR @ A @ ( cos_coeff @ N3 ) @ ( power_power @ A @ X5 @ N3 ) ) ) ) ) ) ).

% cos_def
thf(fact_3291_powser__insidea,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [F2: nat > A,X2: A,Z: A] :
          ( ( summable @ A
            @ ^ [N3: nat] : ( times_times @ A @ ( F2 @ N3 ) @ ( power_power @ A @ X2 @ N3 ) ) )
         => ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ Z ) @ ( real_V7770717601297561774m_norm @ A @ X2 ) )
           => ( summable @ real
              @ ^ [N3: nat] : ( real_V7770717601297561774m_norm @ A @ ( times_times @ A @ ( F2 @ N3 ) @ ( power_power @ A @ Z @ N3 ) ) ) ) ) ) ) ).

% powser_insidea
thf(fact_3292_suminf__le,axiom,
    ! [A: $tType] :
      ( ( ( ordere6911136660526730532id_add @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [F2: nat > A,G: nat > A] :
          ( ! [N: nat] : ( ord_less_eq @ A @ ( F2 @ N ) @ ( G @ N ) )
         => ( ( summable @ A @ F2 )
           => ( ( summable @ A @ G )
             => ( ord_less_eq @ A @ ( suminf @ A @ F2 ) @ ( suminf @ A @ G ) ) ) ) ) ) ).

% suminf_le
thf(fact_3293_cos__le__one,axiom,
    ! [X2: real] : ( ord_less_eq @ real @ ( cos @ real @ X2 ) @ ( one_one @ real ) ) ).

% cos_le_one
thf(fact_3294_scaleR__left__distrib,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [A2: real,B2: real,X2: A] :
          ( ( real_V8093663219630862766scaleR @ A @ ( plus_plus @ real @ A2 @ B2 ) @ X2 )
          = ( plus_plus @ A @ ( real_V8093663219630862766scaleR @ A @ A2 @ X2 ) @ ( real_V8093663219630862766scaleR @ A @ B2 @ X2 ) ) ) ) ).

% scaleR_left_distrib
thf(fact_3295_scaleR__left_Oadd,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [X2: real,Y2: real,Xa2: A] :
          ( ( real_V8093663219630862766scaleR @ A @ ( plus_plus @ real @ X2 @ Y2 ) @ Xa2 )
          = ( plus_plus @ A @ ( real_V8093663219630862766scaleR @ A @ X2 @ Xa2 ) @ ( real_V8093663219630862766scaleR @ A @ Y2 @ Xa2 ) ) ) ) ).

% scaleR_left.add
thf(fact_3296_summable__mult__D,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [C2: A,F2: nat > A] :
          ( ( summable @ A
            @ ^ [N3: nat] : ( times_times @ A @ C2 @ ( F2 @ N3 ) ) )
         => ( ( C2
             != ( zero_zero @ A ) )
           => ( summable @ A @ F2 ) ) ) ) ).

% summable_mult_D
thf(fact_3297_polar__Ex,axiom,
    ! [X2: real,Y2: real] :
    ? [R4: real,A5: real] :
      ( ( X2
        = ( times_times @ real @ R4 @ ( cos @ real @ A5 ) ) )
      & ( Y2
        = ( times_times @ real @ R4 @ ( sin @ real @ A5 ) ) ) ) ).

% polar_Ex
thf(fact_3298_summable__zero__power,axiom,
    ! [A: $tType] :
      ( ( ( comm_ring_1 @ A )
        & ( topolo4958980785337419405_space @ A ) )
     => ( summable @ A @ ( power_power @ A @ ( zero_zero @ A ) ) ) ) ).

% summable_zero_power
thf(fact_3299_cos__arctan__not__zero,axiom,
    ! [X2: real] :
      ( ( cos @ real @ ( arctan @ X2 ) )
     != ( zero_zero @ real ) ) ).

% cos_arctan_not_zero
thf(fact_3300_cos__minus__converges,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [X2: A] :
          ( sums @ A
          @ ^ [N3: nat] : ( real_V8093663219630862766scaleR @ A @ ( cos_coeff @ N3 ) @ ( power_power @ A @ ( uminus_uminus @ A @ X2 ) @ N3 ) )
          @ ( cos @ A @ X2 ) ) ) ).

% cos_minus_converges
thf(fact_3301_suminf__mult,axiom,
    ! [A: $tType] :
      ( ( real_V4412858255891104859lgebra @ A )
     => ! [F2: nat > A,C2: A] :
          ( ( summable @ A @ F2 )
         => ( ( suminf @ A
              @ ^ [N3: nat] : ( times_times @ A @ C2 @ ( F2 @ N3 ) ) )
            = ( times_times @ A @ C2 @ ( suminf @ A @ F2 ) ) ) ) ) ).

% suminf_mult
thf(fact_3302_suminf__mult2,axiom,
    ! [A: $tType] :
      ( ( real_V4412858255891104859lgebra @ A )
     => ! [F2: nat > A,C2: A] :
          ( ( summable @ A @ F2 )
         => ( ( times_times @ A @ ( suminf @ A @ F2 ) @ C2 )
            = ( suminf @ A
              @ ^ [N3: nat] : ( times_times @ A @ ( F2 @ N3 ) @ C2 ) ) ) ) ) ).

% suminf_mult2
thf(fact_3303_suminf__add,axiom,
    ! [A: $tType] :
      ( ( ( topolo5987344860129210374id_add @ A )
        & ( topological_t2_space @ A ) )
     => ! [F2: nat > A,G: nat > A] :
          ( ( summable @ A @ F2 )
         => ( ( summable @ A @ G )
           => ( ( plus_plus @ A @ ( suminf @ A @ F2 ) @ ( suminf @ A @ G ) )
              = ( suminf @ A
                @ ^ [N3: nat] : ( plus_plus @ A @ ( F2 @ N3 ) @ ( G @ N3 ) ) ) ) ) ) ) ).

% suminf_add
thf(fact_3304_suminf__divide,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: nat > A,C2: A] :
          ( ( summable @ A @ F2 )
         => ( ( suminf @ A
              @ ^ [N3: nat] : ( divide_divide @ A @ ( F2 @ N3 ) @ C2 ) )
            = ( divide_divide @ A @ ( suminf @ A @ F2 ) @ C2 ) ) ) ) ).

% suminf_divide
thf(fact_3305_summable__Cauchy__product,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V4412858255891104859lgebra @ A ) )
     => ! [A2: nat > A,B2: nat > A] :
          ( ( summable @ real
            @ ^ [K3: nat] : ( real_V7770717601297561774m_norm @ A @ ( A2 @ K3 ) ) )
         => ( ( summable @ real
              @ ^ [K3: nat] : ( real_V7770717601297561774m_norm @ A @ ( B2 @ K3 ) ) )
           => ( summable @ A
              @ ^ [K3: nat] :
                  ( groups7311177749621191930dd_sum @ nat @ A
                  @ ^ [I4: nat] : ( times_times @ A @ ( A2 @ I4 ) @ ( B2 @ ( minus_minus @ nat @ K3 @ I4 ) ) )
                  @ ( set_ord_atMost @ nat @ K3 ) ) ) ) ) ) ).

% summable_Cauchy_product
thf(fact_3306_suminf__eq__zero__iff,axiom,
    ! [A: $tType] :
      ( ( ( ordere6911136660526730532id_add @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [F2: nat > A] :
          ( ( summable @ A @ F2 )
         => ( ! [N: nat] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( F2 @ N ) )
           => ( ( ( suminf @ A @ F2 )
                = ( zero_zero @ A ) )
              = ( ! [N3: nat] :
                    ( ( F2 @ N3 )
                    = ( zero_zero @ A ) ) ) ) ) ) ) ).

% suminf_eq_zero_iff
thf(fact_3307_suminf__nonneg,axiom,
    ! [A: $tType] :
      ( ( ( ordere6911136660526730532id_add @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [F2: nat > A] :
          ( ( summable @ A @ F2 )
         => ( ! [N: nat] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( F2 @ N ) )
           => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( suminf @ A @ F2 ) ) ) ) ) ).

% suminf_nonneg
thf(fact_3308_suminf__pos,axiom,
    ! [A: $tType] :
      ( ( ( ordere6911136660526730532id_add @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [F2: nat > A] :
          ( ( summable @ A @ F2 )
         => ( ! [N: nat] : ( ord_less @ A @ ( zero_zero @ A ) @ ( F2 @ N ) )
           => ( ord_less @ A @ ( zero_zero @ A ) @ ( suminf @ A @ F2 ) ) ) ) ) ).

% suminf_pos
thf(fact_3309_cos__one__sin__zero,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X2: A] :
          ( ( ( cos @ A @ X2 )
            = ( one_one @ A ) )
         => ( ( sin @ A @ X2 )
            = ( zero_zero @ A ) ) ) ) ).

% cos_one_sin_zero
thf(fact_3310_sin__add,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X2: A,Y2: A] :
          ( ( sin @ A @ ( plus_plus @ A @ X2 @ Y2 ) )
          = ( plus_plus @ A @ ( times_times @ A @ ( sin @ A @ X2 ) @ ( cos @ A @ Y2 ) ) @ ( times_times @ A @ ( cos @ A @ X2 ) @ ( sin @ A @ Y2 ) ) ) ) ) ).

% sin_add
thf(fact_3311_sin__diff,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X2: A,Y2: A] :
          ( ( sin @ A @ ( minus_minus @ A @ X2 @ Y2 ) )
          = ( minus_minus @ A @ ( times_times @ A @ ( sin @ A @ X2 ) @ ( cos @ A @ Y2 ) ) @ ( times_times @ A @ ( cos @ A @ X2 ) @ ( sin @ A @ Y2 ) ) ) ) ) ).

% sin_diff
thf(fact_3312_scaleR__right__mono,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [A2: real,B2: real,X2: A] :
          ( ( ord_less_eq @ real @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X2 )
           => ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ A2 @ X2 ) @ ( real_V8093663219630862766scaleR @ A @ B2 @ X2 ) ) ) ) ) ).

% scaleR_right_mono
thf(fact_3313_scaleR__right__mono__neg,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [B2: real,A2: real,C2: A] :
          ( ( ord_less_eq @ real @ B2 @ A2 )
         => ( ( ord_less_eq @ A @ C2 @ ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ A2 @ C2 ) @ ( real_V8093663219630862766scaleR @ A @ B2 @ C2 ) ) ) ) ) ).

% scaleR_right_mono_neg
thf(fact_3314_scaleR__le__cancel__left,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ C2 @ A2 ) @ ( real_V8093663219630862766scaleR @ A @ C2 @ B2 ) )
          = ( ( ( ord_less @ real @ ( zero_zero @ real ) @ C2 )
             => ( ord_less_eq @ A @ A2 @ B2 ) )
            & ( ( ord_less @ real @ C2 @ ( zero_zero @ real ) )
             => ( ord_less_eq @ A @ B2 @ A2 ) ) ) ) ) ).

% scaleR_le_cancel_left
thf(fact_3315_scaleR__le__cancel__left__neg,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,A2: A,B2: A] :
          ( ( ord_less @ real @ C2 @ ( zero_zero @ real ) )
         => ( ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ C2 @ A2 ) @ ( real_V8093663219630862766scaleR @ A @ C2 @ B2 ) )
            = ( ord_less_eq @ A @ B2 @ A2 ) ) ) ) ).

% scaleR_le_cancel_left_neg
thf(fact_3316_scaleR__le__cancel__left__pos,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,A2: A,B2: A] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ C2 )
         => ( ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ C2 @ A2 ) @ ( real_V8093663219630862766scaleR @ A @ C2 @ B2 ) )
            = ( ord_less_eq @ A @ A2 @ B2 ) ) ) ) ).

% scaleR_le_cancel_left_pos
thf(fact_3317_scaleR__left__mono__neg,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [B2: A,A2: A,C2: real] :
          ( ( ord_less_eq @ A @ B2 @ A2 )
         => ( ( ord_less_eq @ real @ C2 @ ( zero_zero @ real ) )
           => ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ C2 @ A2 ) @ ( real_V8093663219630862766scaleR @ A @ C2 @ B2 ) ) ) ) ) ).

% scaleR_left_mono_neg
thf(fact_3318_scaleR__left__mono,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [X2: A,Y2: A,A2: real] :
          ( ( ord_less_eq @ A @ X2 @ Y2 )
         => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ A2 )
           => ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ A2 @ X2 ) @ ( real_V8093663219630862766scaleR @ A @ A2 @ Y2 ) ) ) ) ) ).

% scaleR_left_mono
thf(fact_3319_summable__zero__power_H,axiom,
    ! [A: $tType] :
      ( ( ( ring_1 @ A )
        & ( topolo4958980785337419405_space @ A ) )
     => ! [F2: nat > A] :
          ( summable @ A
          @ ^ [N3: nat] : ( times_times @ A @ ( F2 @ N3 ) @ ( power_power @ A @ ( zero_zero @ A ) @ N3 ) ) ) ) ).

% summable_zero_power'
thf(fact_3320_summable__0__powser,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [F2: nat > A] :
          ( summable @ A
          @ ^ [N3: nat] : ( times_times @ A @ ( F2 @ N3 ) @ ( power_power @ A @ ( zero_zero @ A ) @ N3 ) ) ) ) ).

% summable_0_powser
thf(fact_3321_eq__vector__fraction__iff,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [X2: A,U: real,V: real,A2: A] :
          ( ( X2
            = ( real_V8093663219630862766scaleR @ A @ ( divide_divide @ real @ U @ V ) @ A2 ) )
          = ( ( ( V
                = ( zero_zero @ real ) )
             => ( X2
                = ( zero_zero @ A ) ) )
            & ( ( V
               != ( zero_zero @ real ) )
             => ( ( real_V8093663219630862766scaleR @ A @ V @ X2 )
                = ( real_V8093663219630862766scaleR @ A @ U @ A2 ) ) ) ) ) ) ).

% eq_vector_fraction_iff
thf(fact_3322_vector__fraction__eq__iff,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [U: real,V: real,A2: A,X2: A] :
          ( ( ( real_V8093663219630862766scaleR @ A @ ( divide_divide @ real @ U @ V ) @ A2 )
            = X2 )
          = ( ( ( V
                = ( zero_zero @ real ) )
             => ( X2
                = ( zero_zero @ A ) ) )
            & ( ( V
               != ( zero_zero @ real ) )
             => ( ( real_V8093663219630862766scaleR @ A @ U @ A2 )
                = ( real_V8093663219630862766scaleR @ A @ V @ X2 ) ) ) ) ) ) ).

% vector_fraction_eq_iff
thf(fact_3323_cos__monotone__0__pi__le,axiom,
    ! [Y2: real,X2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y2 )
     => ( ( ord_less_eq @ real @ Y2 @ X2 )
       => ( ( ord_less_eq @ real @ X2 @ pi )
         => ( ord_less_eq @ real @ ( cos @ real @ X2 ) @ ( cos @ real @ Y2 ) ) ) ) ) ).

% cos_monotone_0_pi_le
thf(fact_3324_cos__mono__le__eq,axiom,
    ! [X2: real,Y2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( ord_less_eq @ real @ X2 @ pi )
       => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y2 )
         => ( ( ord_less_eq @ real @ Y2 @ pi )
           => ( ( ord_less_eq @ real @ ( cos @ real @ X2 ) @ ( cos @ real @ Y2 ) )
              = ( ord_less_eq @ real @ Y2 @ X2 ) ) ) ) ) ) ).

% cos_mono_le_eq
thf(fact_3325_cos__inj__pi,axiom,
    ! [X2: real,Y2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( ord_less_eq @ real @ X2 @ pi )
       => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y2 )
         => ( ( ord_less_eq @ real @ Y2 @ pi )
           => ( ( ( cos @ real @ X2 )
                = ( cos @ real @ Y2 ) )
             => ( X2 = Y2 ) ) ) ) ) ) ).

% cos_inj_pi
thf(fact_3326_summable__powser__split__head,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [F2: nat > A,Z: A] :
          ( ( summable @ A
            @ ^ [N3: nat] : ( times_times @ A @ ( F2 @ ( suc @ N3 ) ) @ ( power_power @ A @ Z @ N3 ) ) )
          = ( summable @ A
            @ ^ [N3: nat] : ( times_times @ A @ ( F2 @ N3 ) @ ( power_power @ A @ Z @ N3 ) ) ) ) ) ).

% summable_powser_split_head
thf(fact_3327_powser__split__head_I3_J,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V8999393235501362500lgebra @ A ) )
     => ! [F2: nat > A,Z: A] :
          ( ( summable @ A
            @ ^ [N3: nat] : ( times_times @ A @ ( F2 @ N3 ) @ ( power_power @ A @ Z @ N3 ) ) )
         => ( summable @ A
            @ ^ [N3: nat] : ( times_times @ A @ ( F2 @ ( suc @ N3 ) ) @ ( power_power @ A @ Z @ N3 ) ) ) ) ) ).

% powser_split_head(3)
thf(fact_3328_cos__ge__minus__one,axiom,
    ! [X2: real] : ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ ( cos @ real @ X2 ) ) ).

% cos_ge_minus_one
thf(fact_3329_Real__Vector__Spaces_Ole__add__iff2,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [A2: real,E2: A,C2: A,B2: real,D2: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ ( real_V8093663219630862766scaleR @ A @ A2 @ E2 ) @ C2 ) @ ( plus_plus @ A @ ( real_V8093663219630862766scaleR @ A @ B2 @ E2 ) @ D2 ) )
          = ( ord_less_eq @ A @ C2 @ ( plus_plus @ A @ ( real_V8093663219630862766scaleR @ A @ ( minus_minus @ real @ B2 @ A2 ) @ E2 ) @ D2 ) ) ) ) ).

% Real_Vector_Spaces.le_add_iff2
thf(fact_3330_Real__Vector__Spaces_Ole__add__iff1,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [A2: real,E2: A,C2: A,B2: real,D2: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ ( real_V8093663219630862766scaleR @ A @ A2 @ E2 ) @ C2 ) @ ( plus_plus @ A @ ( real_V8093663219630862766scaleR @ A @ B2 @ E2 ) @ D2 ) )
          = ( ord_less_eq @ A @ ( plus_plus @ A @ ( real_V8093663219630862766scaleR @ A @ ( minus_minus @ real @ A2 @ B2 ) @ E2 ) @ C2 ) @ D2 ) ) ) ).

% Real_Vector_Spaces.le_add_iff1
thf(fact_3331_summable__powser__ignore__initial__segment,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [F2: nat > A,M: nat,Z: A] :
          ( ( summable @ A
            @ ^ [N3: nat] : ( times_times @ A @ ( F2 @ ( plus_plus @ nat @ N3 @ M ) ) @ ( power_power @ A @ Z @ N3 ) ) )
          = ( summable @ A
            @ ^ [N3: nat] : ( times_times @ A @ ( F2 @ N3 ) @ ( power_power @ A @ Z @ N3 ) ) ) ) ) ).

% summable_powser_ignore_initial_segment
thf(fact_3332_abs__cos__le__one,axiom,
    ! [X2: real] : ( ord_less_eq @ real @ ( abs_abs @ real @ ( cos @ real @ X2 ) ) @ ( one_one @ real ) ) ).

% abs_cos_le_one
thf(fact_3333_summable__norm__comparison__test,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: nat > A,G: nat > real] :
          ( ? [N7: nat] :
            ! [N: nat] :
              ( ( ord_less_eq @ nat @ N7 @ N )
             => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( F2 @ N ) ) @ ( G @ N ) ) )
         => ( ( summable @ real @ G )
           => ( summable @ real
              @ ^ [N3: nat] : ( real_V7770717601297561774m_norm @ A @ ( F2 @ N3 ) ) ) ) ) ) ).

% summable_norm_comparison_test
thf(fact_3334_summable__rabs__comparison__test,axiom,
    ! [F2: nat > real,G: nat > real] :
      ( ? [N7: nat] :
        ! [N: nat] :
          ( ( ord_less_eq @ nat @ N7 @ N )
         => ( ord_less_eq @ real @ ( abs_abs @ real @ ( F2 @ N ) ) @ ( G @ N ) ) )
     => ( ( summable @ real @ G )
       => ( summable @ real
          @ ^ [N3: nat] : ( abs_abs @ real @ ( F2 @ N3 ) ) ) ) ) ).

% summable_rabs_comparison_test
thf(fact_3335_summable__rabs,axiom,
    ! [F2: nat > real] :
      ( ( summable @ real
        @ ^ [N3: nat] : ( abs_abs @ real @ ( F2 @ N3 ) ) )
     => ( ord_less_eq @ real @ ( abs_abs @ real @ ( suminf @ real @ F2 ) )
        @ ( suminf @ real
          @ ^ [N3: nat] : ( abs_abs @ real @ ( F2 @ N3 ) ) ) ) ) ).

% summable_rabs
thf(fact_3336_suminf__pos__iff,axiom,
    ! [A: $tType] :
      ( ( ( ordere6911136660526730532id_add @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [F2: nat > A] :
          ( ( summable @ A @ F2 )
         => ( ! [N: nat] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( F2 @ N ) )
           => ( ( ord_less @ A @ ( zero_zero @ A ) @ ( suminf @ A @ F2 ) )
              = ( ? [I4: nat] : ( ord_less @ A @ ( zero_zero @ A ) @ ( F2 @ I4 ) ) ) ) ) ) ) ).

% suminf_pos_iff
thf(fact_3337_suminf__pos2,axiom,
    ! [A: $tType] :
      ( ( ( ordere6911136660526730532id_add @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [F2: nat > A,I3: nat] :
          ( ( summable @ A @ F2 )
         => ( ! [N: nat] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( F2 @ N ) )
           => ( ( ord_less @ A @ ( zero_zero @ A ) @ ( F2 @ I3 ) )
             => ( ord_less @ A @ ( zero_zero @ A ) @ ( suminf @ A @ F2 ) ) ) ) ) ) ).

% suminf_pos2
thf(fact_3338_cos__add,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X2: A,Y2: A] :
          ( ( cos @ A @ ( plus_plus @ A @ X2 @ Y2 ) )
          = ( minus_minus @ A @ ( times_times @ A @ ( cos @ A @ X2 ) @ ( cos @ A @ Y2 ) ) @ ( times_times @ A @ ( sin @ A @ X2 ) @ ( sin @ A @ Y2 ) ) ) ) ) ).

% cos_add
thf(fact_3339_cos__diff,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X2: A,Y2: A] :
          ( ( cos @ A @ ( minus_minus @ A @ X2 @ Y2 ) )
          = ( plus_plus @ A @ ( times_times @ A @ ( cos @ A @ X2 ) @ ( cos @ A @ Y2 ) ) @ ( times_times @ A @ ( sin @ A @ X2 ) @ ( sin @ A @ Y2 ) ) ) ) ) ).

% cos_diff
thf(fact_3340_suminf__le__const,axiom,
    ! [A: $tType] :
      ( ( ( ordere6911136660526730532id_add @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [F2: nat > A,X2: A] :
          ( ( summable @ A @ F2 )
         => ( ! [N: nat] : ( ord_less_eq @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_ord_lessThan @ nat @ N ) ) @ X2 )
           => ( ord_less_eq @ A @ ( suminf @ A @ F2 ) @ X2 ) ) ) ) ).

% suminf_le_const
thf(fact_3341_sin__zero__norm__cos__one,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X2: A] :
          ( ( ( sin @ A @ X2 )
            = ( zero_zero @ A ) )
         => ( ( real_V7770717601297561774m_norm @ A @ ( cos @ A @ X2 ) )
            = ( one_one @ real ) ) ) ) ).

% sin_zero_norm_cos_one
thf(fact_3342_cos__two__neq__zero,axiom,
    ( cos @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) )
 != ( zero_zero @ real ) ).

% cos_two_neq_zero
thf(fact_3343_scaleR__le__0__iff,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [A2: real,B2: A] :
          ( ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ A2 @ B2 ) @ ( zero_zero @ A ) )
          = ( ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
              & ( ord_less_eq @ A @ B2 @ ( zero_zero @ A ) ) )
            | ( ( ord_less @ real @ A2 @ ( zero_zero @ real ) )
              & ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 ) )
            | ( A2
              = ( zero_zero @ real ) ) ) ) ) ).

% scaleR_le_0_iff
thf(fact_3344_zero__le__scaleR__iff,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [A2: real,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( real_V8093663219630862766scaleR @ A @ A2 @ B2 ) )
          = ( ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
              & ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 ) )
            | ( ( ord_less @ real @ A2 @ ( zero_zero @ real ) )
              & ( ord_less_eq @ A @ B2 @ ( zero_zero @ A ) ) )
            | ( A2
              = ( zero_zero @ real ) ) ) ) ) ).

% zero_le_scaleR_iff
thf(fact_3345_scaleR__mono,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [A2: real,B2: real,X2: A,Y2: A] :
          ( ( ord_less_eq @ real @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ X2 @ Y2 )
           => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ B2 )
             => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X2 )
               => ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ A2 @ X2 ) @ ( real_V8093663219630862766scaleR @ A @ B2 @ Y2 ) ) ) ) ) ) ) ).

% scaleR_mono
thf(fact_3346_scaleR__mono_H,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [A2: real,B2: real,C2: A,D2: A] :
          ( ( ord_less_eq @ real @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ C2 @ D2 )
           => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ A2 )
             => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
               => ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ A2 @ C2 ) @ ( real_V8093663219630862766scaleR @ A @ B2 @ D2 ) ) ) ) ) ) ) ).

% scaleR_mono'
thf(fact_3347_split__scaleR__neg__le,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [A2: real,X2: A] :
          ( ( ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ A2 )
              & ( ord_less_eq @ A @ X2 @ ( zero_zero @ A ) ) )
            | ( ( ord_less_eq @ real @ A2 @ ( zero_zero @ real ) )
              & ( ord_less_eq @ A @ ( zero_zero @ A ) @ X2 ) ) )
         => ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ A2 @ X2 ) @ ( zero_zero @ A ) ) ) ) ).

% split_scaleR_neg_le
thf(fact_3348_split__scaleR__pos__le,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [A2: real,B2: A] :
          ( ( ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ A2 )
              & ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 ) )
            | ( ( ord_less_eq @ real @ A2 @ ( zero_zero @ real ) )
              & ( ord_less_eq @ A @ B2 @ ( zero_zero @ A ) ) ) )
         => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( real_V8093663219630862766scaleR @ A @ A2 @ B2 ) ) ) ) ).

% split_scaleR_pos_le
thf(fact_3349_scaleR__nonneg__nonneg,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [A2: real,X2: A] :
          ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ A2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X2 )
           => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( real_V8093663219630862766scaleR @ A @ A2 @ X2 ) ) ) ) ) ).

% scaleR_nonneg_nonneg
thf(fact_3350_scaleR__nonneg__nonpos,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [A2: real,X2: A] :
          ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ A2 )
         => ( ( ord_less_eq @ A @ X2 @ ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ A2 @ X2 ) @ ( zero_zero @ A ) ) ) ) ) ).

% scaleR_nonneg_nonpos
thf(fact_3351_scaleR__nonpos__nonneg,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [A2: real,X2: A] :
          ( ( ord_less_eq @ real @ A2 @ ( zero_zero @ real ) )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X2 )
           => ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ A2 @ X2 ) @ ( zero_zero @ A ) ) ) ) ) ).

% scaleR_nonpos_nonneg
thf(fact_3352_scaleR__nonpos__nonpos,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [A2: real,B2: A] :
          ( ( ord_less_eq @ real @ A2 @ ( zero_zero @ real ) )
         => ( ( ord_less_eq @ A @ B2 @ ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( real_V8093663219630862766scaleR @ A @ A2 @ B2 ) ) ) ) ) ).

% scaleR_nonpos_nonpos
thf(fact_3353_scaleR__left__le__one__le,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [X2: A,A2: real] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X2 )
         => ( ( ord_less_eq @ real @ A2 @ ( one_one @ real ) )
           => ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ A2 @ X2 ) @ X2 ) ) ) ) ).

% scaleR_left_le_one_le
thf(fact_3354_powser__inside,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V8999393235501362500lgebra @ A ) )
     => ! [F2: nat > A,X2: A,Z: A] :
          ( ( summable @ A
            @ ^ [N3: nat] : ( times_times @ A @ ( F2 @ N3 ) @ ( power_power @ A @ X2 @ N3 ) ) )
         => ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ Z ) @ ( real_V7770717601297561774m_norm @ A @ X2 ) )
           => ( summable @ A
              @ ^ [N3: nat] : ( times_times @ A @ ( F2 @ N3 ) @ ( power_power @ A @ Z @ N3 ) ) ) ) ) ) ).

% powser_inside
thf(fact_3355_scaleR__2,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [X2: A] :
          ( ( real_V8093663219630862766scaleR @ A @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ X2 )
          = ( plus_plus @ A @ X2 @ X2 ) ) ) ).

% scaleR_2
thf(fact_3356_cos__monotone__0__pi,axiom,
    ! [Y2: real,X2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y2 )
     => ( ( ord_less @ real @ Y2 @ X2 )
       => ( ( ord_less_eq @ real @ X2 @ pi )
         => ( ord_less @ real @ ( cos @ real @ X2 ) @ ( cos @ real @ Y2 ) ) ) ) ) ).

% cos_monotone_0_pi
thf(fact_3357_cos__mono__less__eq,axiom,
    ! [X2: real,Y2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( ord_less_eq @ real @ X2 @ pi )
       => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y2 )
         => ( ( ord_less_eq @ real @ Y2 @ pi )
           => ( ( ord_less @ real @ ( cos @ real @ X2 ) @ ( cos @ real @ Y2 ) )
              = ( ord_less @ real @ Y2 @ X2 ) ) ) ) ) ) ).

% cos_mono_less_eq
thf(fact_3358_summableI__nonneg__bounded,axiom,
    ! [A: $tType] :
      ( ( ( condit6923001295902523014norder @ A )
        & ( ordere6911136660526730532id_add @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [F2: nat > A,X2: A] :
          ( ! [N: nat] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( F2 @ N ) )
         => ( ! [N: nat] : ( ord_less_eq @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_ord_lessThan @ nat @ N ) ) @ X2 )
           => ( summable @ A @ F2 ) ) ) ) ).

% summableI_nonneg_bounded
thf(fact_3359_bounded__imp__summable,axiom,
    ! [A: $tType] :
      ( ( ( condit6923001295902523014norder @ A )
        & ( linord2810124833399127020strict @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [A2: nat > A,B3: A] :
          ( ! [N: nat] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( A2 @ N ) )
         => ( ! [N: nat] : ( ord_less_eq @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ A2 @ ( set_ord_atMost @ nat @ N ) ) @ B3 )
           => ( summable @ A @ A2 ) ) ) ) ).

% bounded_imp_summable
thf(fact_3360_summable__geometric,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [C2: A] :
          ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ C2 ) @ ( one_one @ real ) )
         => ( summable @ A @ ( power_power @ A @ C2 ) ) ) ) ).

% summable_geometric
thf(fact_3361_complete__algebra__summable__geometric,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [X2: A] :
          ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ X2 ) @ ( one_one @ real ) )
         => ( summable @ A @ ( power_power @ A @ X2 ) ) ) ) ).

% complete_algebra_summable_geometric
thf(fact_3362_cos__monotone__minus__pi__0_H,axiom,
    ! [Y2: real,X2: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ pi ) @ Y2 )
     => ( ( ord_less_eq @ real @ Y2 @ X2 )
       => ( ( ord_less_eq @ real @ X2 @ ( zero_zero @ real ) )
         => ( ord_less_eq @ real @ ( cos @ real @ Y2 ) @ ( cos @ real @ X2 ) ) ) ) ) ).

% cos_monotone_minus_pi_0'
thf(fact_3363_suminf__split__head,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: nat > A] :
          ( ( summable @ A @ F2 )
         => ( ( suminf @ A
              @ ^ [N3: nat] : ( F2 @ ( suc @ N3 ) ) )
            = ( minus_minus @ A @ ( suminf @ A @ F2 ) @ ( F2 @ ( zero_zero @ nat ) ) ) ) ) ) ).

% suminf_split_head
thf(fact_3364_sin__zero__abs__cos__one,axiom,
    ! [X2: real] :
      ( ( ( sin @ real @ X2 )
        = ( zero_zero @ real ) )
     => ( ( abs_abs @ real @ ( cos @ real @ X2 ) )
        = ( one_one @ real ) ) ) ).

% sin_zero_abs_cos_one
thf(fact_3365_summable__norm,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach @ A )
     => ! [F2: nat > A] :
          ( ( summable @ real
            @ ^ [N3: nat] : ( real_V7770717601297561774m_norm @ A @ ( F2 @ N3 ) ) )
         => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( suminf @ A @ F2 ) )
            @ ( suminf @ real
              @ ^ [N3: nat] : ( real_V7770717601297561774m_norm @ A @ ( F2 @ N3 ) ) ) ) ) ) ).

% summable_norm
thf(fact_3366_sin__double,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X2: A] :
          ( ( sin @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ X2 ) )
          = ( times_times @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( sin @ A @ X2 ) ) @ ( cos @ A @ X2 ) ) ) ) ).

% sin_double
thf(fact_3367_cos__two__less__zero,axiom,
    ord_less @ real @ ( cos @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( zero_zero @ real ) ).

% cos_two_less_zero
thf(fact_3368_sin__converges,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [X2: A] :
          ( sums @ A
          @ ^ [N3: nat] : ( real_V8093663219630862766scaleR @ A @ ( sin_coeff @ N3 ) @ ( power_power @ A @ X2 @ N3 ) )
          @ ( sin @ A @ X2 ) ) ) ).

% sin_converges
thf(fact_3369_sin__def,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ( ( sin @ A )
        = ( ^ [X5: A] :
              ( suminf @ A
              @ ^ [N3: nat] : ( real_V8093663219630862766scaleR @ A @ ( sin_coeff @ N3 ) @ ( power_power @ A @ X5 @ N3 ) ) ) ) ) ) ).

% sin_def
thf(fact_3370_cos__two__le__zero,axiom,
    ord_less_eq @ real @ ( cos @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( zero_zero @ real ) ).

% cos_two_le_zero
thf(fact_3371_cos__is__zero,axiom,
    ? [X3: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X3 )
      & ( ord_less_eq @ real @ X3 @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) )
      & ( ( cos @ real @ X3 )
        = ( zero_zero @ real ) )
      & ! [Y: real] :
          ( ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y )
            & ( ord_less_eq @ real @ Y @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) )
            & ( ( cos @ real @ Y )
              = ( zero_zero @ real ) ) )
         => ( Y = X3 ) ) ) ).

% cos_is_zero
thf(fact_3372_cos__monotone__minus__pi__0,axiom,
    ! [Y2: real,X2: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ pi ) @ Y2 )
     => ( ( ord_less @ real @ Y2 @ X2 )
       => ( ( ord_less_eq @ real @ X2 @ ( zero_zero @ real ) )
         => ( ord_less @ real @ ( cos @ real @ Y2 ) @ ( cos @ real @ X2 ) ) ) ) ) ).

% cos_monotone_minus_pi_0
thf(fact_3373_cos__total,axiom,
    ! [Y2: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ Y2 )
     => ( ( ord_less_eq @ real @ Y2 @ ( one_one @ real ) )
       => ? [X3: real] :
            ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X3 )
            & ( ord_less_eq @ real @ X3 @ pi )
            & ( ( cos @ real @ X3 )
              = Y2 )
            & ! [Y: real] :
                ( ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y )
                  & ( ord_less_eq @ real @ Y @ pi )
                  & ( ( cos @ real @ Y )
                    = Y2 ) )
               => ( Y = X3 ) ) ) ) ) ).

% cos_total
thf(fact_3374_suminf__split__initial__segment,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: nat > A,K: nat] :
          ( ( summable @ A @ F2 )
         => ( ( suminf @ A @ F2 )
            = ( plus_plus @ A
              @ ( suminf @ A
                @ ^ [N3: nat] : ( F2 @ ( plus_plus @ nat @ N3 @ K ) ) )
              @ ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_ord_lessThan @ nat @ K ) ) ) ) ) ) ).

% suminf_split_initial_segment
thf(fact_3375_suminf__minus__initial__segment,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: nat > A,K: nat] :
          ( ( summable @ A @ F2 )
         => ( ( suminf @ A
              @ ^ [N3: nat] : ( F2 @ ( plus_plus @ nat @ N3 @ K ) ) )
            = ( minus_minus @ A @ ( suminf @ A @ F2 ) @ ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_ord_lessThan @ nat @ K ) ) ) ) ) ) ).

% suminf_minus_initial_segment
thf(fact_3376_sincos__principal__value,axiom,
    ! [X2: real] :
    ? [Y4: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ pi ) @ Y4 )
      & ( ord_less_eq @ real @ Y4 @ pi )
      & ( ( sin @ real @ Y4 )
        = ( sin @ real @ X2 ) )
      & ( ( cos @ real @ Y4 )
        = ( cos @ real @ X2 ) ) ) ).

% sincos_principal_value
thf(fact_3377_sum__less__suminf,axiom,
    ! [A: $tType] :
      ( ( ( ordere8940638589300402666id_add @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [F2: nat > A,N2: nat] :
          ( ( summable @ A @ F2 )
         => ( ! [M3: nat] :
                ( ( ord_less_eq @ nat @ N2 @ M3 )
               => ( ord_less @ A @ ( zero_zero @ A ) @ ( F2 @ M3 ) ) )
           => ( ord_less @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_ord_lessThan @ nat @ N2 ) ) @ ( suminf @ A @ F2 ) ) ) ) ) ).

% sum_less_suminf
thf(fact_3378_powser__split__head_I1_J,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V8999393235501362500lgebra @ A ) )
     => ! [F2: nat > A,Z: A] :
          ( ( summable @ A
            @ ^ [N3: nat] : ( times_times @ A @ ( F2 @ N3 ) @ ( power_power @ A @ Z @ N3 ) ) )
         => ( ( suminf @ A
              @ ^ [N3: nat] : ( times_times @ A @ ( F2 @ N3 ) @ ( power_power @ A @ Z @ N3 ) ) )
            = ( plus_plus @ A @ ( F2 @ ( zero_zero @ nat ) )
              @ ( times_times @ A
                @ ( suminf @ A
                  @ ^ [N3: nat] : ( times_times @ A @ ( F2 @ ( suc @ N3 ) ) @ ( power_power @ A @ Z @ N3 ) ) )
                @ Z ) ) ) ) ) ).

% powser_split_head(1)
thf(fact_3379_powser__split__head_I2_J,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V8999393235501362500lgebra @ A ) )
     => ! [F2: nat > A,Z: A] :
          ( ( summable @ A
            @ ^ [N3: nat] : ( times_times @ A @ ( F2 @ N3 ) @ ( power_power @ A @ Z @ N3 ) ) )
         => ( ( times_times @ A
              @ ( suminf @ A
                @ ^ [N3: nat] : ( times_times @ A @ ( F2 @ ( suc @ N3 ) ) @ ( power_power @ A @ Z @ N3 ) ) )
              @ Z )
            = ( minus_minus @ A
              @ ( suminf @ A
                @ ^ [N3: nat] : ( times_times @ A @ ( F2 @ N3 ) @ ( power_power @ A @ Z @ N3 ) ) )
              @ ( F2 @ ( zero_zero @ nat ) ) ) ) ) ) ).

% powser_split_head(2)
thf(fact_3380_sin__minus__converges,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [X2: A] :
          ( sums @ A
          @ ^ [N3: nat] : ( uminus_uminus @ A @ ( real_V8093663219630862766scaleR @ A @ ( sin_coeff @ N3 ) @ ( power_power @ A @ ( uminus_uminus @ A @ X2 ) @ N3 ) ) )
          @ ( sin @ A @ X2 ) ) ) ).

% sin_minus_converges
thf(fact_3381_summable__partial__sum__bound,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach @ A )
     => ! [F2: nat > A,E2: real] :
          ( ( summable @ A @ F2 )
         => ( ( ord_less @ real @ ( zero_zero @ real ) @ E2 )
           => ~ ! [N8: nat] :
                  ~ ! [M2: nat] :
                      ( ( ord_less_eq @ nat @ N8 @ M2 )
                     => ! [N9: nat] : ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_or1337092689740270186AtMost @ nat @ M2 @ N9 ) ) ) @ E2 ) ) ) ) ) ).

% summable_partial_sum_bound
thf(fact_3382_suminf__exist__split,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [R3: real,F2: nat > A] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ R3 )
         => ( ( summable @ A @ F2 )
           => ? [N8: nat] :
              ! [N9: nat] :
                ( ( ord_less_eq @ nat @ N8 @ N9 )
               => ( ord_less @ real
                  @ ( real_V7770717601297561774m_norm @ A
                    @ ( suminf @ A
                      @ ^ [I4: nat] : ( F2 @ ( plus_plus @ nat @ I4 @ N9 ) ) ) )
                  @ R3 ) ) ) ) ) ).

% suminf_exist_split
thf(fact_3383_summable__power__series,axiom,
    ! [F2: nat > real,Z: real] :
      ( ! [I2: nat] : ( ord_less_eq @ real @ ( F2 @ I2 ) @ ( one_one @ real ) )
     => ( ! [I2: nat] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( F2 @ I2 ) )
       => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Z )
         => ( ( ord_less @ real @ Z @ ( one_one @ real ) )
           => ( summable @ real
              @ ^ [I4: nat] : ( times_times @ real @ ( F2 @ I4 ) @ ( power_power @ real @ Z @ I4 ) ) ) ) ) ) ) ).

% summable_power_series
thf(fact_3384_Abel__lemma,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [R3: real,R0: real,A2: nat > A,M7: real] :
          ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ R3 )
         => ( ( ord_less @ real @ R3 @ R0 )
           => ( ! [N: nat] : ( ord_less_eq @ real @ ( times_times @ real @ ( real_V7770717601297561774m_norm @ A @ ( A2 @ N ) ) @ ( power_power @ real @ R0 @ N ) ) @ M7 )
             => ( summable @ real
                @ ^ [N3: nat] : ( times_times @ real @ ( real_V7770717601297561774m_norm @ A @ ( A2 @ N3 ) ) @ ( power_power @ real @ R3 @ N3 ) ) ) ) ) ) ) ).

% Abel_lemma
thf(fact_3385_Cauchy__product,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V4412858255891104859lgebra @ A ) )
     => ! [A2: nat > A,B2: nat > A] :
          ( ( summable @ real
            @ ^ [K3: nat] : ( real_V7770717601297561774m_norm @ A @ ( A2 @ K3 ) ) )
         => ( ( summable @ real
              @ ^ [K3: nat] : ( real_V7770717601297561774m_norm @ A @ ( B2 @ K3 ) ) )
           => ( ( times_times @ A @ ( suminf @ A @ A2 ) @ ( suminf @ A @ B2 ) )
              = ( suminf @ A
                @ ^ [K3: nat] :
                    ( groups7311177749621191930dd_sum @ nat @ A
                    @ ^ [I4: nat] : ( times_times @ A @ ( A2 @ I4 ) @ ( B2 @ ( minus_minus @ nat @ K3 @ I4 ) ) )
                    @ ( set_ord_atMost @ nat @ K3 ) ) ) ) ) ) ) ).

% Cauchy_product
thf(fact_3386_sin__cos__le1,axiom,
    ! [X2: real,Y2: real] : ( ord_less_eq @ real @ ( abs_abs @ real @ ( plus_plus @ real @ ( times_times @ real @ ( sin @ real @ X2 ) @ ( sin @ real @ Y2 ) ) @ ( times_times @ real @ ( cos @ real @ X2 ) @ ( cos @ real @ Y2 ) ) ) ) @ ( one_one @ real ) ) ).

% sin_cos_le1
thf(fact_3387_cos__plus__cos,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [W: A,Z: A] :
          ( ( plus_plus @ A @ ( cos @ A @ W ) @ ( cos @ A @ Z ) )
          = ( times_times @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( cos @ A @ ( divide_divide @ A @ ( plus_plus @ A @ W @ Z ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) @ ( cos @ A @ ( divide_divide @ A @ ( minus_minus @ A @ W @ Z ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% cos_plus_cos
thf(fact_3388_cos__times__cos,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [W: A,Z: A] :
          ( ( times_times @ A @ ( cos @ A @ W ) @ ( cos @ A @ Z ) )
          = ( divide_divide @ A @ ( plus_plus @ A @ ( cos @ A @ ( minus_minus @ A @ W @ Z ) ) @ ( cos @ A @ ( plus_plus @ A @ W @ Z ) ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% cos_times_cos
thf(fact_3389_summable__ratio__test,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach @ A )
     => ! [C2: real,N4: nat,F2: nat > A] :
          ( ( ord_less @ real @ C2 @ ( one_one @ real ) )
         => ( ! [N: nat] :
                ( ( ord_less_eq @ nat @ N4 @ N )
               => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( F2 @ ( suc @ N ) ) ) @ ( times_times @ real @ C2 @ ( real_V7770717601297561774m_norm @ A @ ( F2 @ N ) ) ) ) )
           => ( summable @ A @ F2 ) ) ) ) ).

% summable_ratio_test
thf(fact_3390_sum__less__suminf2,axiom,
    ! [A: $tType] :
      ( ( ( ordere8940638589300402666id_add @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [F2: nat > A,N2: nat,I3: nat] :
          ( ( summable @ A @ F2 )
         => ( ! [M3: nat] :
                ( ( ord_less_eq @ nat @ N2 @ M3 )
               => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( F2 @ M3 ) ) )
           => ( ( ord_less_eq @ nat @ N2 @ I3 )
             => ( ( ord_less @ A @ ( zero_zero @ A ) @ ( F2 @ I3 ) )
               => ( ord_less @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_ord_lessThan @ nat @ N2 ) ) @ ( suminf @ A @ F2 ) ) ) ) ) ) ) ).

% sum_less_suminf2
thf(fact_3391_cos__squared__eq,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X2: A] :
          ( ( power_power @ A @ ( cos @ A @ X2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
          = ( minus_minus @ A @ ( one_one @ A ) @ ( power_power @ A @ ( sin @ A @ X2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% cos_squared_eq
thf(fact_3392_sin__squared__eq,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X2: A] :
          ( ( power_power @ A @ ( sin @ A @ X2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
          = ( minus_minus @ A @ ( one_one @ A ) @ ( power_power @ A @ ( cos @ A @ X2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% sin_squared_eq
thf(fact_3393_cos__double__less__one,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( ord_less @ real @ X2 @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) )
       => ( ord_less @ real @ ( cos @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ X2 ) ) @ ( one_one @ real ) ) ) ) ).

% cos_double_less_one
thf(fact_3394_cos__gt__zero,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( ord_less @ real @ X2 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
       => ( ord_less @ real @ ( zero_zero @ real ) @ ( cos @ real @ X2 ) ) ) ) ).

% cos_gt_zero
thf(fact_3395_cos__60,axiom,
    ( ( cos @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit1 @ one2 ) ) ) )
    = ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ).

% cos_60
thf(fact_3396_cos__one__2pi__int,axiom,
    ! [X2: real] :
      ( ( ( cos @ real @ X2 )
        = ( one_one @ real ) )
      = ( ? [X5: int] :
            ( X2
            = ( times_times @ real @ ( times_times @ real @ ( ring_1_of_int @ real @ X5 ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ pi ) ) ) ) ).

% cos_one_2pi_int
thf(fact_3397_Cauchy__product__sums,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V4412858255891104859lgebra @ A ) )
     => ! [A2: nat > A,B2: nat > A] :
          ( ( summable @ real
            @ ^ [K3: nat] : ( real_V7770717601297561774m_norm @ A @ ( A2 @ K3 ) ) )
         => ( ( summable @ real
              @ ^ [K3: nat] : ( real_V7770717601297561774m_norm @ A @ ( B2 @ K3 ) ) )
           => ( sums @ A
              @ ^ [K3: nat] :
                  ( groups7311177749621191930dd_sum @ nat @ A
                  @ ^ [I4: nat] : ( times_times @ A @ ( A2 @ I4 ) @ ( B2 @ ( minus_minus @ nat @ K3 @ I4 ) ) )
                  @ ( set_ord_atMost @ nat @ K3 ) )
              @ ( times_times @ A @ ( suminf @ A @ A2 ) @ ( suminf @ A @ B2 ) ) ) ) ) ) ).

% Cauchy_product_sums
thf(fact_3398_cos__double__cos,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [W: A] :
          ( ( cos @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ W ) )
          = ( minus_minus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( power_power @ A @ ( cos @ A @ W ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( one_one @ A ) ) ) ) ).

% cos_double_cos
thf(fact_3399_cos__treble__cos,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X2: A] :
          ( ( cos @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit1 @ one2 ) ) @ X2 ) )
          = ( minus_minus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ ( bit0 @ one2 ) ) ) @ ( power_power @ A @ ( cos @ A @ X2 ) @ ( numeral_numeral @ nat @ ( bit1 @ one2 ) ) ) ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit1 @ one2 ) ) @ ( cos @ A @ X2 ) ) ) ) ) ).

% cos_treble_cos
thf(fact_3400_cos__diff__cos,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [W: A,Z: A] :
          ( ( minus_minus @ A @ ( cos @ A @ W ) @ ( cos @ A @ Z ) )
          = ( times_times @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( sin @ A @ ( divide_divide @ A @ ( plus_plus @ A @ W @ Z ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) @ ( sin @ A @ ( divide_divide @ A @ ( minus_minus @ A @ Z @ W ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% cos_diff_cos
thf(fact_3401_sin__diff__sin,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [W: A,Z: A] :
          ( ( minus_minus @ A @ ( sin @ A @ W ) @ ( sin @ A @ Z ) )
          = ( times_times @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( sin @ A @ ( divide_divide @ A @ ( minus_minus @ A @ W @ Z ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) @ ( cos @ A @ ( divide_divide @ A @ ( plus_plus @ A @ W @ Z ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% sin_diff_sin
thf(fact_3402_sin__plus__sin,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [W: A,Z: A] :
          ( ( plus_plus @ A @ ( sin @ A @ W ) @ ( sin @ A @ Z ) )
          = ( times_times @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( sin @ A @ ( divide_divide @ A @ ( plus_plus @ A @ W @ Z ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) @ ( cos @ A @ ( divide_divide @ A @ ( minus_minus @ A @ W @ Z ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% sin_plus_sin
thf(fact_3403_cos__times__sin,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [W: A,Z: A] :
          ( ( times_times @ A @ ( cos @ A @ W ) @ ( sin @ A @ Z ) )
          = ( divide_divide @ A @ ( minus_minus @ A @ ( sin @ A @ ( plus_plus @ A @ W @ Z ) ) @ ( sin @ A @ ( minus_minus @ A @ W @ Z ) ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% cos_times_sin
thf(fact_3404_sin__times__cos,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [W: A,Z: A] :
          ( ( times_times @ A @ ( sin @ A @ W ) @ ( cos @ A @ Z ) )
          = ( divide_divide @ A @ ( plus_plus @ A @ ( sin @ A @ ( plus_plus @ A @ W @ Z ) ) @ ( sin @ A @ ( minus_minus @ A @ W @ Z ) ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% sin_times_cos
thf(fact_3405_sin__times__sin,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [W: A,Z: A] :
          ( ( times_times @ A @ ( sin @ A @ W ) @ ( sin @ A @ Z ) )
          = ( divide_divide @ A @ ( minus_minus @ A @ ( cos @ A @ ( minus_minus @ A @ W @ Z ) ) @ ( cos @ A @ ( plus_plus @ A @ W @ Z ) ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% sin_times_sin
thf(fact_3406_cos__double,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X2: A] :
          ( ( cos @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ X2 ) )
          = ( minus_minus @ A @ ( power_power @ A @ ( cos @ A @ X2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ A @ ( sin @ A @ X2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% cos_double
thf(fact_3407_cos__gt__zero__pi,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ X2 )
     => ( ( ord_less @ real @ X2 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
       => ( ord_less @ real @ ( zero_zero @ real ) @ ( cos @ real @ X2 ) ) ) ) ).

% cos_gt_zero_pi
thf(fact_3408_cos__ge__zero,axiom,
    ! [X2: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ X2 )
     => ( ( ord_less_eq @ real @ X2 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
       => ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( cos @ real @ X2 ) ) ) ) ).

% cos_ge_zero
thf(fact_3409_cos__one__2pi,axiom,
    ! [X2: real] :
      ( ( ( cos @ real @ X2 )
        = ( one_one @ real ) )
      = ( ? [X5: nat] :
            ( X2
            = ( times_times @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ X5 ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ pi ) )
        | ? [X5: nat] :
            ( X2
            = ( uminus_uminus @ real @ ( times_times @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ X5 ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ pi ) ) ) ) ) ).

% cos_one_2pi
thf(fact_3410_cos__double__sin,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [W: A] :
          ( ( cos @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ W ) )
          = ( minus_minus @ A @ ( one_one @ A ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( power_power @ A @ ( sin @ A @ W ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% cos_double_sin
thf(fact_3411_sincos__total__pi,axiom,
    ! [Y2: real,X2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y2 )
     => ( ( ( plus_plus @ real @ ( power_power @ real @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Y2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
          = ( one_one @ real ) )
       => ? [T4: real] :
            ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ T4 )
            & ( ord_less_eq @ real @ T4 @ pi )
            & ( X2
              = ( cos @ real @ T4 ) )
            & ( Y2
              = ( sin @ real @ T4 ) ) ) ) ) ).

% sincos_total_pi
thf(fact_3412_sin__expansion__lemma,axiom,
    ! [X2: real,M: nat] :
      ( ( sin @ real @ ( plus_plus @ real @ X2 @ ( divide_divide @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ ( suc @ M ) ) @ pi ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) )
      = ( cos @ real @ ( plus_plus @ real @ X2 @ ( divide_divide @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ M ) @ pi ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ).

% sin_expansion_lemma
thf(fact_3413_cos__zero__iff__int,axiom,
    ! [X2: real] :
      ( ( ( cos @ real @ X2 )
        = ( zero_zero @ real ) )
      = ( ? [I4: int] :
            ( ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ I4 )
            & ( X2
              = ( times_times @ real @ ( ring_1_of_int @ real @ I4 ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% cos_zero_iff_int
thf(fact_3414_cos__x__cos__y,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X2: A,Y2: A] :
          ( sums @ A
          @ ^ [P6: nat] :
              ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [N3: nat] :
                  ( if @ A
                  @ ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ P6 )
                    & ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N3 ) )
                  @ ( times_times @ A @ ( real_V8093663219630862766scaleR @ A @ ( divide_divide @ real @ ( ring_1_of_int @ real @ ( times_times @ int @ ( power_power @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( divide_divide @ nat @ P6 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( semiring_1_of_nat @ int @ ( binomial @ P6 @ N3 ) ) ) ) @ ( semiring_char_0_fact @ real @ P6 ) ) @ ( power_power @ A @ X2 @ N3 ) ) @ ( power_power @ A @ Y2 @ ( minus_minus @ nat @ P6 @ N3 ) ) )
                  @ ( zero_zero @ A ) )
              @ ( set_ord_atMost @ nat @ P6 ) )
          @ ( times_times @ A @ ( cos @ A @ X2 ) @ ( cos @ A @ Y2 ) ) ) ) ).

% cos_x_cos_y
thf(fact_3415_sum__pos__lt__pair,axiom,
    ! [F2: nat > real,K: nat] :
      ( ( summable @ real @ F2 )
     => ( ! [D4: nat] : ( ord_less @ real @ ( zero_zero @ real ) @ ( plus_plus @ real @ ( F2 @ ( plus_plus @ nat @ K @ ( times_times @ nat @ ( suc @ ( suc @ ( zero_zero @ nat ) ) ) @ D4 ) ) ) @ ( F2 @ ( plus_plus @ nat @ K @ ( plus_plus @ nat @ ( times_times @ nat @ ( suc @ ( suc @ ( zero_zero @ nat ) ) ) @ D4 ) @ ( one_one @ nat ) ) ) ) ) )
       => ( ord_less @ real @ ( groups7311177749621191930dd_sum @ nat @ real @ F2 @ ( set_ord_lessThan @ nat @ K ) ) @ ( suminf @ real @ F2 ) ) ) ) ).

% sum_pos_lt_pair
thf(fact_3416_cos__zero__lemma,axiom,
    ! [X2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( ( cos @ real @ X2 )
          = ( zero_zero @ real ) )
       => ? [N: nat] :
            ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
            & ( X2
              = ( times_times @ real @ ( semiring_1_of_nat @ real @ N ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% cos_zero_lemma
thf(fact_3417_cos__zero__iff,axiom,
    ! [X2: real] :
      ( ( ( cos @ real @ X2 )
        = ( zero_zero @ real ) )
      = ( ? [N3: nat] :
            ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N3 )
            & ( X2
              = ( times_times @ real @ ( semiring_1_of_nat @ real @ N3 ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) )
        | ? [N3: nat] :
            ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N3 )
            & ( X2
              = ( uminus_uminus @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N3 ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ).

% cos_zero_iff
thf(fact_3418_sums__cos__x__plus__y,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X2: A,Y2: A] :
          ( sums @ A
          @ ^ [P6: nat] :
              ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [N3: nat] : ( if @ A @ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ P6 ) @ ( times_times @ A @ ( real_V8093663219630862766scaleR @ A @ ( divide_divide @ real @ ( ring_1_of_int @ real @ ( times_times @ int @ ( power_power @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( divide_divide @ nat @ P6 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( semiring_1_of_nat @ int @ ( binomial @ P6 @ N3 ) ) ) ) @ ( semiring_char_0_fact @ real @ P6 ) ) @ ( power_power @ A @ X2 @ N3 ) ) @ ( power_power @ A @ Y2 @ ( minus_minus @ nat @ P6 @ N3 ) ) ) @ ( zero_zero @ A ) )
              @ ( set_ord_atMost @ nat @ P6 ) )
          @ ( cos @ A @ ( plus_plus @ A @ X2 @ Y2 ) ) ) ) ).

% sums_cos_x_plus_y
thf(fact_3419_cos__expansion__lemma,axiom,
    ! [X2: real,M: nat] :
      ( ( cos @ real @ ( plus_plus @ real @ X2 @ ( divide_divide @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ ( suc @ M ) ) @ pi ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) )
      = ( uminus_uminus @ real @ ( sin @ real @ ( plus_plus @ real @ X2 @ ( divide_divide @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ M ) @ pi ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% cos_expansion_lemma
thf(fact_3420_cos__paired,axiom,
    ! [X2: real] :
      ( sums @ real
      @ ^ [N3: nat] : ( times_times @ real @ ( divide_divide @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ N3 ) @ ( semiring_char_0_fact @ real @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N3 ) ) ) @ ( power_power @ real @ X2 @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N3 ) ) )
      @ ( cos @ real @ X2 ) ) ).

% cos_paired
thf(fact_3421_sincos__total__pi__half,axiom,
    ! [X2: real,Y2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y2 )
       => ( ( ( plus_plus @ real @ ( power_power @ real @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Y2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
            = ( one_one @ real ) )
         => ? [T4: real] :
              ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ T4 )
              & ( ord_less_eq @ real @ T4 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
              & ( X2
                = ( cos @ real @ T4 ) )
              & ( Y2
                = ( sin @ real @ T4 ) ) ) ) ) ) ).

% sincos_total_pi_half
thf(fact_3422_sincos__total__2pi__le,axiom,
    ! [X2: real,Y2: real] :
      ( ( ( plus_plus @ real @ ( power_power @ real @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Y2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
        = ( one_one @ real ) )
     => ? [T4: real] :
          ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ T4 )
          & ( ord_less_eq @ real @ T4 @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) )
          & ( X2
            = ( cos @ real @ T4 ) )
          & ( Y2
            = ( sin @ real @ T4 ) ) ) ) ).

% sincos_total_2pi_le
thf(fact_3423_sincos__total__2pi,axiom,
    ! [X2: real,Y2: real] :
      ( ( ( plus_plus @ real @ ( power_power @ real @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Y2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
        = ( one_one @ real ) )
     => ~ ! [T4: real] :
            ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ T4 )
           => ( ( ord_less @ real @ T4 @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) )
             => ( ( X2
                  = ( cos @ real @ T4 ) )
               => ( Y2
                 != ( sin @ real @ T4 ) ) ) ) ) ) ).

% sincos_total_2pi
thf(fact_3424_diffs__equiv,axiom,
    ! [A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( ring_1 @ A ) )
     => ! [C2: nat > A,X2: A] :
          ( ( summable @ A
            @ ^ [N3: nat] : ( times_times @ A @ ( diffs @ A @ C2 @ N3 ) @ ( power_power @ A @ X2 @ N3 ) ) )
         => ( sums @ A
            @ ^ [N3: nat] : ( times_times @ A @ ( times_times @ A @ ( semiring_1_of_nat @ A @ N3 ) @ ( C2 @ N3 ) ) @ ( power_power @ A @ X2 @ ( minus_minus @ nat @ N3 @ ( suc @ ( zero_zero @ nat ) ) ) ) )
            @ ( suminf @ A
              @ ^ [N3: nat] : ( times_times @ A @ ( diffs @ A @ C2 @ N3 ) @ ( power_power @ A @ X2 @ N3 ) ) ) ) ) ) ).

% diffs_equiv
thf(fact_3425_tan__double,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X2: A] :
          ( ( ( cos @ A @ X2 )
           != ( zero_zero @ A ) )
         => ( ( ( cos @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ X2 ) )
             != ( zero_zero @ A ) )
           => ( ( tan @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ X2 ) )
              = ( divide_divide @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( tan @ A @ X2 ) ) @ ( minus_minus @ A @ ( one_one @ A ) @ ( power_power @ A @ ( tan @ A @ X2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ).

% tan_double
thf(fact_3426_complex__unimodular__polar,axiom,
    ! [Z: complex] :
      ( ( ( real_V7770717601297561774m_norm @ complex @ Z )
        = ( one_one @ real ) )
     => ~ ! [T4: real] :
            ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ T4 )
           => ( ( ord_less @ real @ T4 @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) )
             => ( Z
               != ( complex2 @ ( cos @ real @ T4 ) @ ( sin @ real @ T4 ) ) ) ) ) ) ).

% complex_unimodular_polar
thf(fact_3427_Maclaurin__exp__lt,axiom,
    ! [X2: real,N2: nat] :
      ( ( X2
       != ( zero_zero @ real ) )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
       => ? [T4: real] :
            ( ( ord_less @ real @ ( zero_zero @ real ) @ ( abs_abs @ real @ T4 ) )
            & ( ord_less @ real @ ( abs_abs @ real @ T4 ) @ ( abs_abs @ real @ X2 ) )
            & ( ( exp @ real @ X2 )
              = ( plus_plus @ real
                @ ( groups7311177749621191930dd_sum @ nat @ real
                  @ ^ [M6: nat] : ( divide_divide @ real @ ( power_power @ real @ X2 @ M6 ) @ ( semiring_char_0_fact @ real @ M6 ) )
                  @ ( set_ord_lessThan @ nat @ N2 ) )
                @ ( times_times @ real @ ( divide_divide @ real @ ( exp @ real @ T4 ) @ ( semiring_char_0_fact @ real @ N2 ) ) @ ( power_power @ real @ X2 @ N2 ) ) ) ) ) ) ) ).

% Maclaurin_exp_lt
thf(fact_3428_monoI1,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [X8: nat > A] :
          ( ! [M3: nat,N: nat] :
              ( ( ord_less_eq @ nat @ M3 @ N )
             => ( ord_less_eq @ A @ ( X8 @ M3 ) @ ( X8 @ N ) ) )
         => ( topological_monoseq @ A @ X8 ) ) ) ).

% monoI1
thf(fact_3429_tan__pi,axiom,
    ( ( tan @ real @ pi )
    = ( zero_zero @ real ) ) ).

% tan_pi
thf(fact_3430_tan__zero,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ( ( tan @ A @ ( zero_zero @ A ) )
        = ( zero_zero @ A ) ) ) ).

% tan_zero
thf(fact_3431_exp__less__cancel__iff,axiom,
    ! [X2: real,Y2: real] :
      ( ( ord_less @ real @ ( exp @ real @ X2 ) @ ( exp @ real @ Y2 ) )
      = ( ord_less @ real @ X2 @ Y2 ) ) ).

% exp_less_cancel_iff
thf(fact_3432_exp__less__mono,axiom,
    ! [X2: real,Y2: real] :
      ( ( ord_less @ real @ X2 @ Y2 )
     => ( ord_less @ real @ ( exp @ real @ X2 ) @ ( exp @ real @ Y2 ) ) ) ).

% exp_less_mono
thf(fact_3433_exp__le__cancel__iff,axiom,
    ! [X2: real,Y2: real] :
      ( ( ord_less_eq @ real @ ( exp @ real @ X2 ) @ ( exp @ real @ Y2 ) )
      = ( ord_less_eq @ real @ X2 @ Y2 ) ) ).

% exp_le_cancel_iff
thf(fact_3434_exp__zero,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ( ( exp @ A @ ( zero_zero @ A ) )
        = ( one_one @ A ) ) ) ).

% exp_zero
thf(fact_3435_exp__eq__one__iff,axiom,
    ! [X2: real] :
      ( ( ( exp @ real @ X2 )
        = ( one_one @ real ) )
      = ( X2
        = ( zero_zero @ real ) ) ) ).

% exp_eq_one_iff
thf(fact_3436_tan__npi,axiom,
    ! [N2: nat] :
      ( ( tan @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N2 ) @ pi ) )
      = ( zero_zero @ real ) ) ).

% tan_npi
thf(fact_3437_exp__less__one__iff,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( exp @ real @ X2 ) @ ( one_one @ real ) )
      = ( ord_less @ real @ X2 @ ( zero_zero @ real ) ) ) ).

% exp_less_one_iff
thf(fact_3438_one__less__exp__iff,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ ( exp @ real @ X2 ) )
      = ( ord_less @ real @ ( zero_zero @ real ) @ X2 ) ) ).

% one_less_exp_iff
thf(fact_3439_exp__le__one__iff,axiom,
    ! [X2: real] :
      ( ( ord_less_eq @ real @ ( exp @ real @ X2 ) @ ( one_one @ real ) )
      = ( ord_less_eq @ real @ X2 @ ( zero_zero @ real ) ) ) ).

% exp_le_one_iff
thf(fact_3440_one__le__exp__iff,axiom,
    ! [X2: real] :
      ( ( ord_less_eq @ real @ ( one_one @ real ) @ ( exp @ real @ X2 ) )
      = ( ord_less_eq @ real @ ( zero_zero @ real ) @ X2 ) ) ).

% one_le_exp_iff
thf(fact_3441_tan__periodic__n,axiom,
    ! [X2: real,N2: num] :
      ( ( tan @ real @ ( plus_plus @ real @ X2 @ ( times_times @ real @ ( numeral_numeral @ real @ N2 ) @ pi ) ) )
      = ( tan @ real @ X2 ) ) ).

% tan_periodic_n
thf(fact_3442_tan__periodic__nat,axiom,
    ! [X2: real,N2: nat] :
      ( ( tan @ real @ ( plus_plus @ real @ X2 @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N2 ) @ pi ) ) )
      = ( tan @ real @ X2 ) ) ).

% tan_periodic_nat
thf(fact_3443_exp__ln__iff,axiom,
    ! [X2: real] :
      ( ( ( exp @ real @ ( ln_ln @ real @ X2 ) )
        = X2 )
      = ( ord_less @ real @ ( zero_zero @ real ) @ X2 ) ) ).

% exp_ln_iff
thf(fact_3444_exp__ln,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( exp @ real @ ( ln_ln @ real @ X2 ) )
        = X2 ) ) ).

% exp_ln
thf(fact_3445_tan__periodic__int,axiom,
    ! [X2: real,I3: int] :
      ( ( tan @ real @ ( plus_plus @ real @ X2 @ ( times_times @ real @ ( ring_1_of_int @ real @ I3 ) @ pi ) ) )
      = ( tan @ real @ X2 ) ) ).

% tan_periodic_int
thf(fact_3446_tan__periodic,axiom,
    ! [X2: real] :
      ( ( tan @ real @ ( plus_plus @ real @ X2 @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) ) )
      = ( tan @ real @ X2 ) ) ).

% tan_periodic
thf(fact_3447_complex__scaleR,axiom,
    ! [R3: real,A2: real,B2: real] :
      ( ( real_V8093663219630862766scaleR @ complex @ R3 @ ( complex2 @ A2 @ B2 ) )
      = ( complex2 @ ( times_times @ real @ R3 @ A2 ) @ ( times_times @ real @ R3 @ B2 ) ) ) ).

% complex_scaleR
thf(fact_3448_norm__exp,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [X2: A] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( exp @ A @ X2 ) ) @ ( exp @ real @ ( real_V7770717601297561774m_norm @ A @ X2 ) ) ) ) ).

% norm_exp
thf(fact_3449_exp__not__eq__zero,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [X2: A] :
          ( ( exp @ A @ X2 )
         != ( zero_zero @ A ) ) ) ).

% exp_not_eq_zero
thf(fact_3450_exp__less__cancel,axiom,
    ! [X2: real,Y2: real] :
      ( ( ord_less @ real @ ( exp @ real @ X2 ) @ ( exp @ real @ Y2 ) )
     => ( ord_less @ real @ X2 @ Y2 ) ) ).

% exp_less_cancel
thf(fact_3451_exp__times__arg__commute,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [A3: A] :
          ( ( times_times @ A @ ( exp @ A @ A3 ) @ A3 )
          = ( times_times @ A @ A3 @ ( exp @ A @ A3 ) ) ) ) ).

% exp_times_arg_commute
thf(fact_3452_not__exp__less__zero,axiom,
    ! [X2: real] :
      ~ ( ord_less @ real @ ( exp @ real @ X2 ) @ ( zero_zero @ real ) ) ).

% not_exp_less_zero
thf(fact_3453_exp__gt__zero,axiom,
    ! [X2: real] : ( ord_less @ real @ ( zero_zero @ real ) @ ( exp @ real @ X2 ) ) ).

% exp_gt_zero
thf(fact_3454_exp__total,axiom,
    ! [Y2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ Y2 )
     => ? [X3: real] :
          ( ( exp @ real @ X3 )
          = Y2 ) ) ).

% exp_total
thf(fact_3455_exp__ge__zero,axiom,
    ! [X2: real] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( exp @ real @ X2 ) ) ).

% exp_ge_zero
thf(fact_3456_not__exp__le__zero,axiom,
    ! [X2: real] :
      ~ ( ord_less_eq @ real @ ( exp @ real @ X2 ) @ ( zero_zero @ real ) ) ).

% not_exp_le_zero
thf(fact_3457_mult__exp__exp,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X2: A,Y2: A] :
          ( ( times_times @ A @ ( exp @ A @ X2 ) @ ( exp @ A @ Y2 ) )
          = ( exp @ A @ ( plus_plus @ A @ X2 @ Y2 ) ) ) ) ).

% mult_exp_exp
thf(fact_3458_exp__add__commuting,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [X2: A,Y2: A] :
          ( ( ( times_times @ A @ X2 @ Y2 )
            = ( times_times @ A @ Y2 @ X2 ) )
         => ( ( exp @ A @ ( plus_plus @ A @ X2 @ Y2 ) )
            = ( times_times @ A @ ( exp @ A @ X2 ) @ ( exp @ A @ Y2 ) ) ) ) ) ).

% exp_add_commuting
thf(fact_3459_exp__diff,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X2: A,Y2: A] :
          ( ( exp @ A @ ( minus_minus @ A @ X2 @ Y2 ) )
          = ( divide_divide @ A @ ( exp @ A @ X2 ) @ ( exp @ A @ Y2 ) ) ) ) ).

% exp_diff
thf(fact_3460_Complex__eq__numeral,axiom,
    ! [A2: real,B2: real,W: num] :
      ( ( ( complex2 @ A2 @ B2 )
        = ( numeral_numeral @ complex @ W ) )
      = ( ( A2
          = ( numeral_numeral @ real @ W ) )
        & ( B2
          = ( zero_zero @ real ) ) ) ) ).

% Complex_eq_numeral
thf(fact_3461_Complex__eq__0,axiom,
    ! [A2: real,B2: real] :
      ( ( ( complex2 @ A2 @ B2 )
        = ( zero_zero @ complex ) )
      = ( ( A2
          = ( zero_zero @ real ) )
        & ( B2
          = ( zero_zero @ real ) ) ) ) ).

% Complex_eq_0
thf(fact_3462_zero__complex_Ocode,axiom,
    ( ( zero_zero @ complex )
    = ( complex2 @ ( zero_zero @ real ) @ ( zero_zero @ real ) ) ) ).

% zero_complex.code
thf(fact_3463_exp__gt__one,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
     => ( ord_less @ real @ ( one_one @ real ) @ ( exp @ real @ X2 ) ) ) ).

% exp_gt_one
thf(fact_3464_exp__ge__add__one__self,axiom,
    ! [X2: real] : ( ord_less_eq @ real @ ( plus_plus @ real @ ( one_one @ real ) @ X2 ) @ ( exp @ real @ X2 ) ) ).

% exp_ge_add_one_self
thf(fact_3465_exp__minus__inverse,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [X2: A] :
          ( ( times_times @ A @ ( exp @ A @ X2 ) @ ( exp @ A @ ( uminus_uminus @ A @ X2 ) ) )
          = ( one_one @ A ) ) ) ).

% exp_minus_inverse
thf(fact_3466_exp__of__nat__mult,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [N2: nat,X2: A] :
          ( ( exp @ A @ ( times_times @ A @ ( semiring_1_of_nat @ A @ N2 ) @ X2 ) )
          = ( power_power @ A @ ( exp @ A @ X2 ) @ N2 ) ) ) ).

% exp_of_nat_mult
thf(fact_3467_exp__of__nat2__mult,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X2: A,N2: nat] :
          ( ( exp @ A @ ( times_times @ A @ X2 @ ( semiring_1_of_nat @ A @ N2 ) ) )
          = ( power_power @ A @ ( exp @ A @ X2 ) @ N2 ) ) ) ).

% exp_of_nat2_mult
thf(fact_3468_Complex__eq__neg__numeral,axiom,
    ! [A2: real,B2: real,W: num] :
      ( ( ( complex2 @ A2 @ B2 )
        = ( uminus_uminus @ complex @ ( numeral_numeral @ complex @ W ) ) )
      = ( ( A2
          = ( uminus_uminus @ real @ ( numeral_numeral @ real @ W ) ) )
        & ( B2
          = ( zero_zero @ real ) ) ) ) ).

% Complex_eq_neg_numeral
thf(fact_3469_complex__mult,axiom,
    ! [A2: real,B2: real,C2: real,D2: real] :
      ( ( times_times @ complex @ ( complex2 @ A2 @ B2 ) @ ( complex2 @ C2 @ D2 ) )
      = ( complex2 @ ( minus_minus @ real @ ( times_times @ real @ A2 @ C2 ) @ ( times_times @ real @ B2 @ D2 ) ) @ ( plus_plus @ real @ ( times_times @ real @ A2 @ D2 ) @ ( times_times @ real @ B2 @ C2 ) ) ) ) ).

% complex_mult
thf(fact_3470_one__complex_Ocode,axiom,
    ( ( one_one @ complex )
    = ( complex2 @ ( one_one @ real ) @ ( zero_zero @ real ) ) ) ).

% one_complex.code
thf(fact_3471_Complex__eq__1,axiom,
    ! [A2: real,B2: real] :
      ( ( ( complex2 @ A2 @ B2 )
        = ( one_one @ complex ) )
      = ( ( A2
          = ( one_one @ real ) )
        & ( B2
          = ( zero_zero @ real ) ) ) ) ).

% Complex_eq_1
thf(fact_3472_tan__def,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ( ( tan @ A )
        = ( ^ [X5: A] : ( divide_divide @ A @ ( sin @ A @ X5 ) @ ( cos @ A @ X5 ) ) ) ) ) ).

% tan_def
thf(fact_3473_exp__ge__add__one__self__aux,axiom,
    ! [X2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X2 )
     => ( ord_less_eq @ real @ ( plus_plus @ real @ ( one_one @ real ) @ X2 ) @ ( exp @ real @ X2 ) ) ) ).

% exp_ge_add_one_self_aux
thf(fact_3474_lemma__exp__total,axiom,
    ! [Y2: real] :
      ( ( ord_less_eq @ real @ ( one_one @ real ) @ Y2 )
     => ? [X3: real] :
          ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X3 )
          & ( ord_less_eq @ real @ X3 @ ( minus_minus @ real @ Y2 @ ( one_one @ real ) ) )
          & ( ( exp @ real @ X3 )
            = Y2 ) ) ) ).

% lemma_exp_total
thf(fact_3475_ln__ge__iff,axiom,
    ! [X2: real,Y2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( ord_less_eq @ real @ Y2 @ ( ln_ln @ real @ X2 ) )
        = ( ord_less_eq @ real @ ( exp @ real @ Y2 ) @ X2 ) ) ) ).

% ln_ge_iff
thf(fact_3476_ln__x__over__x__mono,axiom,
    ! [X2: real,Y2: real] :
      ( ( ord_less_eq @ real @ ( exp @ real @ ( one_one @ real ) ) @ X2 )
     => ( ( ord_less_eq @ real @ X2 @ Y2 )
       => ( ord_less_eq @ real @ ( divide_divide @ real @ ( ln_ln @ real @ Y2 ) @ Y2 ) @ ( divide_divide @ real @ ( ln_ln @ real @ X2 ) @ X2 ) ) ) ) ).

% ln_x_over_x_mono
thf(fact_3477_Complex__sum_H,axiom,
    ! [A: $tType,F2: A > real,S2: set @ A] :
      ( ( groups7311177749621191930dd_sum @ A @ complex
        @ ^ [X5: A] : ( complex2 @ ( F2 @ X5 ) @ ( zero_zero @ real ) )
        @ S2 )
      = ( complex2 @ ( groups7311177749621191930dd_sum @ A @ real @ F2 @ S2 ) @ ( zero_zero @ real ) ) ) ).

% Complex_sum'
thf(fact_3478_diffs__def,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ( ( diffs @ A )
        = ( ^ [C4: nat > A,N3: nat] : ( times_times @ A @ ( semiring_1_of_nat @ A @ ( suc @ N3 ) ) @ ( C4 @ ( suc @ N3 ) ) ) ) ) ) ).

% diffs_def
thf(fact_3479_Complex__eq__neg__1,axiom,
    ! [A2: real,B2: real] :
      ( ( ( complex2 @ A2 @ B2 )
        = ( uminus_uminus @ complex @ ( one_one @ complex ) ) )
      = ( ( A2
          = ( uminus_uminus @ real @ ( one_one @ real ) ) )
        & ( B2
          = ( zero_zero @ real ) ) ) ) ).

% Complex_eq_neg_1
thf(fact_3480_exp__le,axiom,
    ord_less_eq @ real @ ( exp @ real @ ( one_one @ real ) ) @ ( numeral_numeral @ real @ ( bit1 @ one2 ) ) ).

% exp_le
thf(fact_3481_termdiff__converges__all,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [C2: nat > A,X2: A] :
          ( ! [X3: A] :
              ( summable @ A
              @ ^ [N3: nat] : ( times_times @ A @ ( C2 @ N3 ) @ ( power_power @ A @ X3 @ N3 ) ) )
         => ( summable @ A
            @ ^ [N3: nat] : ( times_times @ A @ ( diffs @ A @ C2 @ N3 ) @ ( power_power @ A @ X2 @ N3 ) ) ) ) ) ).

% termdiff_converges_all
thf(fact_3482_exp__divide__power__eq,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [N2: nat,X2: A] :
          ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
         => ( ( power_power @ A @ ( exp @ A @ ( divide_divide @ A @ X2 @ ( semiring_1_of_nat @ A @ N2 ) ) ) @ N2 )
            = ( exp @ A @ X2 ) ) ) ) ).

% exp_divide_power_eq
thf(fact_3483_tanh__altdef,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ( ( tanh @ A )
        = ( ^ [X5: A] : ( divide_divide @ A @ ( minus_minus @ A @ ( exp @ A @ X5 ) @ ( exp @ A @ ( uminus_uminus @ A @ X5 ) ) ) @ ( plus_plus @ A @ ( exp @ A @ X5 ) @ ( exp @ A @ ( uminus_uminus @ A @ X5 ) ) ) ) ) ) ) ).

% tanh_altdef
thf(fact_3484_exp__half__le2,axiom,
    ord_less_eq @ real @ ( exp @ real @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ).

% exp_half_le2
thf(fact_3485_tan__45,axiom,
    ( ( tan @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ ( bit0 @ one2 ) ) ) ) )
    = ( one_one @ real ) ) ).

% tan_45
thf(fact_3486_exp__double,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [Z: A] :
          ( ( exp @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ Z ) )
          = ( power_power @ A @ ( exp @ A @ Z ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ).

% exp_double
thf(fact_3487_tan__gt__zero,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( ord_less @ real @ X2 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
       => ( ord_less @ real @ ( zero_zero @ real ) @ ( tan @ real @ X2 ) ) ) ) ).

% tan_gt_zero
thf(fact_3488_lemma__tan__total,axiom,
    ! [Y2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ Y2 )
     => ? [X3: real] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ X3 )
          & ( ord_less @ real @ X3 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
          & ( ord_less @ real @ Y2 @ ( tan @ real @ X3 ) ) ) ) ).

% lemma_tan_total
thf(fact_3489_tan__total,axiom,
    ! [Y2: real] :
    ? [X3: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ X3 )
      & ( ord_less @ real @ X3 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
      & ( ( tan @ real @ X3 )
        = Y2 )
      & ! [Y: real] :
          ( ( ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ Y )
            & ( ord_less @ real @ Y @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
            & ( ( tan @ real @ Y )
              = Y2 ) )
         => ( Y = X3 ) ) ) ).

% tan_total
thf(fact_3490_tan__monotone,axiom,
    ! [Y2: real,X2: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ Y2 )
     => ( ( ord_less @ real @ Y2 @ X2 )
       => ( ( ord_less @ real @ X2 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
         => ( ord_less @ real @ ( tan @ real @ Y2 ) @ ( tan @ real @ X2 ) ) ) ) ) ).

% tan_monotone
thf(fact_3491_tan__monotone_H,axiom,
    ! [Y2: real,X2: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ Y2 )
     => ( ( ord_less @ real @ Y2 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
       => ( ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ X2 )
         => ( ( ord_less @ real @ X2 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
           => ( ( ord_less @ real @ Y2 @ X2 )
              = ( ord_less @ real @ ( tan @ real @ Y2 ) @ ( tan @ real @ X2 ) ) ) ) ) ) ) ).

% tan_monotone'
thf(fact_3492_tan__mono__lt__eq,axiom,
    ! [X2: real,Y2: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ X2 )
     => ( ( ord_less @ real @ X2 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
       => ( ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ Y2 )
         => ( ( ord_less @ real @ Y2 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
           => ( ( ord_less @ real @ ( tan @ real @ X2 ) @ ( tan @ real @ Y2 ) )
              = ( ord_less @ real @ X2 @ Y2 ) ) ) ) ) ) ).

% tan_mono_lt_eq
thf(fact_3493_lemma__tan__total1,axiom,
    ! [Y2: real] :
    ? [X3: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ X3 )
      & ( ord_less @ real @ X3 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
      & ( ( tan @ real @ X3 )
        = Y2 ) ) ).

% lemma_tan_total1
thf(fact_3494_tan__minus__45,axiom,
    ( ( tan @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ ( bit0 @ one2 ) ) ) ) ) )
    = ( uminus_uminus @ real @ ( one_one @ real ) ) ) ).

% tan_minus_45
thf(fact_3495_tan__inverse,axiom,
    ! [Y2: real] :
      ( ( divide_divide @ real @ ( one_one @ real ) @ ( tan @ real @ Y2 ) )
      = ( tan @ real @ ( minus_minus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ Y2 ) ) ) ).

% tan_inverse
thf(fact_3496_exp__bound__half,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [Z: A] :
          ( ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ Z ) @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
         => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( exp @ A @ Z ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ).

% exp_bound_half
thf(fact_3497_add__tan__eq,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X2: A,Y2: A] :
          ( ( ( cos @ A @ X2 )
           != ( zero_zero @ A ) )
         => ( ( ( cos @ A @ Y2 )
             != ( zero_zero @ A ) )
           => ( ( plus_plus @ A @ ( tan @ A @ X2 ) @ ( tan @ A @ Y2 ) )
              = ( divide_divide @ A @ ( sin @ A @ ( plus_plus @ A @ X2 @ Y2 ) ) @ ( times_times @ A @ ( cos @ A @ X2 ) @ ( cos @ A @ Y2 ) ) ) ) ) ) ) ).

% add_tan_eq
thf(fact_3498_termdiff__converges,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X2: A,K5: real,C2: nat > A] :
          ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ X2 ) @ K5 )
         => ( ! [X3: A] :
                ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ X3 ) @ K5 )
               => ( summable @ A
                  @ ^ [N3: nat] : ( times_times @ A @ ( C2 @ N3 ) @ ( power_power @ A @ X3 @ N3 ) ) ) )
           => ( summable @ A
              @ ^ [N3: nat] : ( times_times @ A @ ( diffs @ A @ C2 @ N3 ) @ ( power_power @ A @ X2 @ N3 ) ) ) ) ) ) ).

% termdiff_converges
thf(fact_3499_exp__bound,axiom,
    ! [X2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( ord_less_eq @ real @ X2 @ ( one_one @ real ) )
       => ( ord_less_eq @ real @ ( exp @ real @ X2 ) @ ( plus_plus @ real @ ( plus_plus @ real @ ( one_one @ real ) @ X2 ) @ ( power_power @ real @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% exp_bound
thf(fact_3500_tan__total__pos,axiom,
    ! [Y2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y2 )
     => ? [X3: real] :
          ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X3 )
          & ( ord_less @ real @ X3 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
          & ( ( tan @ real @ X3 )
            = Y2 ) ) ) ).

% tan_total_pos
thf(fact_3501_tan__pos__pi2__le,axiom,
    ! [X2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( ord_less @ real @ X2 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
       => ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( tan @ real @ X2 ) ) ) ) ).

% tan_pos_pi2_le
thf(fact_3502_tan__less__zero,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( divide_divide @ real @ ( uminus_uminus @ real @ pi ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ X2 )
     => ( ( ord_less @ real @ X2 @ ( zero_zero @ real ) )
       => ( ord_less @ real @ ( tan @ real @ X2 ) @ ( zero_zero @ real ) ) ) ) ).

% tan_less_zero
thf(fact_3503_tan__mono__le,axiom,
    ! [X2: real,Y2: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ X2 )
     => ( ( ord_less_eq @ real @ X2 @ Y2 )
       => ( ( ord_less @ real @ Y2 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
         => ( ord_less_eq @ real @ ( tan @ real @ X2 ) @ ( tan @ real @ Y2 ) ) ) ) ) ).

% tan_mono_le
thf(fact_3504_tan__mono__le__eq,axiom,
    ! [X2: real,Y2: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ X2 )
     => ( ( ord_less @ real @ X2 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
       => ( ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ Y2 )
         => ( ( ord_less @ real @ Y2 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
           => ( ( ord_less_eq @ real @ ( tan @ real @ X2 ) @ ( tan @ real @ Y2 ) )
              = ( ord_less_eq @ real @ X2 @ Y2 ) ) ) ) ) ) ).

% tan_mono_le_eq
thf(fact_3505_tan__bound__pi2,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( abs_abs @ real @ X2 ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ ( bit0 @ one2 ) ) ) ) )
     => ( ord_less @ real @ ( abs_abs @ real @ ( tan @ real @ X2 ) ) @ ( one_one @ real ) ) ) ).

% tan_bound_pi2
thf(fact_3506_arctan__unique,axiom,
    ! [X2: real,Y2: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ X2 )
     => ( ( ord_less @ real @ X2 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
       => ( ( ( tan @ real @ X2 )
            = Y2 )
         => ( ( arctan @ Y2 )
            = X2 ) ) ) ) ).

% arctan_unique
thf(fact_3507_arctan__tan,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ X2 )
     => ( ( ord_less @ real @ X2 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
       => ( ( arctan @ ( tan @ real @ X2 ) )
          = X2 ) ) ) ).

% arctan_tan
thf(fact_3508_arctan,axiom,
    ! [Y2: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ ( arctan @ Y2 ) )
      & ( ord_less @ real @ ( arctan @ Y2 ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
      & ( ( tan @ real @ ( arctan @ Y2 ) )
        = Y2 ) ) ).

% arctan
thf(fact_3509_lemma__tan__add1,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X2: A,Y2: A] :
          ( ( ( cos @ A @ X2 )
           != ( zero_zero @ A ) )
         => ( ( ( cos @ A @ Y2 )
             != ( zero_zero @ A ) )
           => ( ( minus_minus @ A @ ( one_one @ A ) @ ( times_times @ A @ ( tan @ A @ X2 ) @ ( tan @ A @ Y2 ) ) )
              = ( divide_divide @ A @ ( cos @ A @ ( plus_plus @ A @ X2 @ Y2 ) ) @ ( times_times @ A @ ( cos @ A @ X2 ) @ ( cos @ A @ Y2 ) ) ) ) ) ) ) ).

% lemma_tan_add1
thf(fact_3510_tan__diff,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X2: A,Y2: A] :
          ( ( ( cos @ A @ X2 )
           != ( zero_zero @ A ) )
         => ( ( ( cos @ A @ Y2 )
             != ( zero_zero @ A ) )
           => ( ( ( cos @ A @ ( minus_minus @ A @ X2 @ Y2 ) )
               != ( zero_zero @ A ) )
             => ( ( tan @ A @ ( minus_minus @ A @ X2 @ Y2 ) )
                = ( divide_divide @ A @ ( minus_minus @ A @ ( tan @ A @ X2 ) @ ( tan @ A @ Y2 ) ) @ ( plus_plus @ A @ ( one_one @ A ) @ ( times_times @ A @ ( tan @ A @ X2 ) @ ( tan @ A @ Y2 ) ) ) ) ) ) ) ) ) ).

% tan_diff
thf(fact_3511_tan__add,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X2: A,Y2: A] :
          ( ( ( cos @ A @ X2 )
           != ( zero_zero @ A ) )
         => ( ( ( cos @ A @ Y2 )
             != ( zero_zero @ A ) )
           => ( ( ( cos @ A @ ( plus_plus @ A @ X2 @ Y2 ) )
               != ( zero_zero @ A ) )
             => ( ( tan @ A @ ( plus_plus @ A @ X2 @ Y2 ) )
                = ( divide_divide @ A @ ( plus_plus @ A @ ( tan @ A @ X2 ) @ ( tan @ A @ Y2 ) ) @ ( minus_minus @ A @ ( one_one @ A ) @ ( times_times @ A @ ( tan @ A @ X2 ) @ ( tan @ A @ Y2 ) ) ) ) ) ) ) ) ) ).

% tan_add
thf(fact_3512_real__exp__bound__lemma,axiom,
    ! [X2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( ord_less_eq @ real @ X2 @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
       => ( ord_less_eq @ real @ ( exp @ real @ X2 ) @ ( plus_plus @ real @ ( one_one @ real ) @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ X2 ) ) ) ) ) ).

% real_exp_bound_lemma
thf(fact_3513_exp__ge__one__plus__x__over__n__power__n,axiom,
    ! [N2: nat,X2: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( semiring_1_of_nat @ real @ N2 ) ) @ X2 )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
       => ( ord_less_eq @ real @ ( power_power @ real @ ( plus_plus @ real @ ( one_one @ real ) @ ( divide_divide @ real @ X2 @ ( semiring_1_of_nat @ real @ N2 ) ) ) @ N2 ) @ ( exp @ real @ X2 ) ) ) ) ).

% exp_ge_one_plus_x_over_n_power_n
thf(fact_3514_exp__ge__one__minus__x__over__n__power__n,axiom,
    ! [X2: real,N2: nat] :
      ( ( ord_less_eq @ real @ X2 @ ( semiring_1_of_nat @ real @ N2 ) )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
       => ( ord_less_eq @ real @ ( power_power @ real @ ( minus_minus @ real @ ( one_one @ real ) @ ( divide_divide @ real @ X2 @ ( semiring_1_of_nat @ real @ N2 ) ) ) @ N2 ) @ ( exp @ real @ ( uminus_uminus @ real @ X2 ) ) ) ) ) ).

% exp_ge_one_minus_x_over_n_power_n
thf(fact_3515_tan__total__pi4,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( abs_abs @ real @ X2 ) @ ( one_one @ real ) )
     => ? [Z3: real] :
          ( ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ ( bit0 @ one2 ) ) ) ) ) @ Z3 )
          & ( ord_less @ real @ Z3 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ ( bit0 @ one2 ) ) ) ) )
          & ( ( tan @ real @ Z3 )
            = X2 ) ) ) ).

% tan_total_pi4
thf(fact_3516_exp__bound__lemma,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [Z: A] :
          ( ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ Z ) @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
         => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( exp @ A @ Z ) ) @ ( plus_plus @ real @ ( one_one @ real ) @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( real_V7770717601297561774m_norm @ A @ Z ) ) ) ) ) ) ).

% exp_bound_lemma
thf(fact_3517_Maclaurin__exp__le,axiom,
    ! [X2: real,N2: nat] :
    ? [T4: real] :
      ( ( ord_less_eq @ real @ ( abs_abs @ real @ T4 ) @ ( abs_abs @ real @ X2 ) )
      & ( ( exp @ real @ X2 )
        = ( plus_plus @ real
          @ ( groups7311177749621191930dd_sum @ nat @ real
            @ ^ [M6: nat] : ( divide_divide @ real @ ( power_power @ real @ X2 @ M6 ) @ ( semiring_char_0_fact @ real @ M6 ) )
            @ ( set_ord_lessThan @ nat @ N2 ) )
          @ ( times_times @ real @ ( divide_divide @ real @ ( exp @ real @ T4 ) @ ( semiring_char_0_fact @ real @ N2 ) ) @ ( power_power @ real @ X2 @ N2 ) ) ) ) ) ).

% Maclaurin_exp_le
thf(fact_3518_exp__lower__Taylor__quadratic,axiom,
    ! [X2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X2 )
     => ( ord_less_eq @ real @ ( plus_plus @ real @ ( plus_plus @ real @ ( one_one @ real ) @ X2 ) @ ( divide_divide @ real @ ( power_power @ real @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ ( exp @ real @ X2 ) ) ) ).

% exp_lower_Taylor_quadratic
thf(fact_3519_tanh__real__altdef,axiom,
    ( ( tanh @ real )
    = ( ^ [X5: real] : ( divide_divide @ real @ ( minus_minus @ real @ ( one_one @ real ) @ ( exp @ real @ ( times_times @ real @ ( uminus_uminus @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ X5 ) ) ) @ ( plus_plus @ real @ ( one_one @ real ) @ ( exp @ real @ ( times_times @ real @ ( uminus_uminus @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ X5 ) ) ) ) ) ) ).

% tanh_real_altdef
thf(fact_3520_tan__half,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ( ( tan @ A )
        = ( ^ [X5: A] : ( divide_divide @ A @ ( sin @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ X5 ) ) @ ( plus_plus @ A @ ( cos @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ X5 ) ) @ ( one_one @ A ) ) ) ) ) ) ).

% tan_half
thf(fact_3521_monoseq__Suc,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( topological_monoseq @ A )
        = ( ^ [X4: nat > A] :
              ( ! [N3: nat] : ( ord_less_eq @ A @ ( X4 @ N3 ) @ ( X4 @ ( suc @ N3 ) ) )
              | ! [N3: nat] : ( ord_less_eq @ A @ ( X4 @ ( suc @ N3 ) ) @ ( X4 @ N3 ) ) ) ) ) ) ).

% monoseq_Suc
thf(fact_3522_mono__SucI2,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [X8: nat > A] :
          ( ! [N: nat] : ( ord_less_eq @ A @ ( X8 @ ( suc @ N ) ) @ ( X8 @ N ) )
         => ( topological_monoseq @ A @ X8 ) ) ) ).

% mono_SucI2
thf(fact_3523_mono__SucI1,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [X8: nat > A] :
          ( ! [N: nat] : ( ord_less_eq @ A @ ( X8 @ N ) @ ( X8 @ ( suc @ N ) ) )
         => ( topological_monoseq @ A @ X8 ) ) ) ).

% mono_SucI1
thf(fact_3524_monoseq__def,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( topological_monoseq @ A )
        = ( ^ [X4: nat > A] :
              ( ! [M6: nat,N3: nat] :
                  ( ( ord_less_eq @ nat @ M6 @ N3 )
                 => ( ord_less_eq @ A @ ( X4 @ M6 ) @ ( X4 @ N3 ) ) )
              | ! [M6: nat,N3: nat] :
                  ( ( ord_less_eq @ nat @ M6 @ N3 )
                 => ( ord_less_eq @ A @ ( X4 @ N3 ) @ ( X4 @ M6 ) ) ) ) ) ) ) ).

% monoseq_def
thf(fact_3525_monoI2,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [X8: nat > A] :
          ( ! [M3: nat,N: nat] :
              ( ( ord_less_eq @ nat @ M3 @ N )
             => ( ord_less_eq @ A @ ( X8 @ N ) @ ( X8 @ M3 ) ) )
         => ( topological_monoseq @ A @ X8 ) ) ) ).

% monoI2
thf(fact_3526_sin__tan,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( abs_abs @ real @ X2 ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
     => ( ( sin @ real @ X2 )
        = ( divide_divide @ real @ ( tan @ real @ X2 ) @ ( sqrt @ ( plus_plus @ real @ ( one_one @ real ) @ ( power_power @ real @ ( tan @ real @ X2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% sin_tan
thf(fact_3527_cos__tan,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( abs_abs @ real @ X2 ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
     => ( ( cos @ real @ X2 )
        = ( divide_divide @ real @ ( one_one @ real ) @ ( sqrt @ ( plus_plus @ real @ ( one_one @ real ) @ ( power_power @ real @ ( tan @ real @ X2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% cos_tan
thf(fact_3528_exp__first__two__terms,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ( ( exp @ A )
        = ( ^ [X5: A] :
              ( plus_plus @ A @ ( plus_plus @ A @ ( one_one @ A ) @ X5 )
              @ ( suminf @ A
                @ ^ [N3: nat] : ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ ( semiring_char_0_fact @ real @ ( plus_plus @ nat @ N3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( power_power @ A @ X5 @ ( plus_plus @ nat @ N3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ).

% exp_first_two_terms
thf(fact_3529_Maclaurin__sin__bound,axiom,
    ! [X2: real,N2: nat] :
      ( ord_less_eq @ real
      @ ( abs_abs @ real
        @ ( minus_minus @ real @ ( sin @ real @ X2 )
          @ ( groups7311177749621191930dd_sum @ nat @ real
            @ ^ [M6: nat] : ( times_times @ real @ ( sin_coeff @ M6 ) @ ( power_power @ real @ X2 @ M6 ) )
            @ ( set_ord_lessThan @ nat @ N2 ) ) ) )
      @ ( times_times @ real @ ( inverse_inverse @ real @ ( semiring_char_0_fact @ real @ N2 ) ) @ ( power_power @ real @ ( abs_abs @ real @ X2 ) @ N2 ) ) ) ).

% Maclaurin_sin_bound
thf(fact_3530_cot__less__zero,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( divide_divide @ real @ ( uminus_uminus @ real @ pi ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ X2 )
     => ( ( ord_less @ real @ X2 @ ( zero_zero @ real ) )
       => ( ord_less @ real @ ( cot @ real @ X2 ) @ ( zero_zero @ real ) ) ) ) ).

% cot_less_zero
thf(fact_3531_inverse__inverse__eq,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A] :
          ( ( inverse_inverse @ A @ ( inverse_inverse @ A @ A2 ) )
          = A2 ) ) ).

% inverse_inverse_eq
thf(fact_3532_inverse__eq__iff__eq,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A,B2: A] :
          ( ( ( inverse_inverse @ A @ A2 )
            = ( inverse_inverse @ A @ B2 ) )
          = ( A2 = B2 ) ) ) ).

% inverse_eq_iff_eq
thf(fact_3533_inverse__zero,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ( ( inverse_inverse @ A @ ( zero_zero @ A ) )
        = ( zero_zero @ A ) ) ) ).

% inverse_zero
thf(fact_3534_inverse__nonzero__iff__nonzero,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A] :
          ( ( ( inverse_inverse @ A @ A2 )
            = ( zero_zero @ A ) )
          = ( A2
            = ( zero_zero @ A ) ) ) ) ).

% inverse_nonzero_iff_nonzero
thf(fact_3535_inverse__mult__distrib,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A2: A,B2: A] :
          ( ( inverse_inverse @ A @ ( times_times @ A @ A2 @ B2 ) )
          = ( times_times @ A @ ( inverse_inverse @ A @ A2 ) @ ( inverse_inverse @ A @ B2 ) ) ) ) ).

% inverse_mult_distrib
thf(fact_3536_inverse__eq__1__iff,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [X2: A] :
          ( ( ( inverse_inverse @ A @ X2 )
            = ( one_one @ A ) )
          = ( X2
            = ( one_one @ A ) ) ) ) ).

% inverse_eq_1_iff
thf(fact_3537_inverse__1,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ( ( inverse_inverse @ A @ ( one_one @ A ) )
        = ( one_one @ A ) ) ) ).

% inverse_1
thf(fact_3538_inverse__divide,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A2: A,B2: A] :
          ( ( inverse_inverse @ A @ ( divide_divide @ A @ A2 @ B2 ) )
          = ( divide_divide @ A @ B2 @ A2 ) ) ) ).

% inverse_divide
thf(fact_3539_inverse__minus__eq,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A] :
          ( ( inverse_inverse @ A @ ( uminus_uminus @ A @ A2 ) )
          = ( uminus_uminus @ A @ ( inverse_inverse @ A @ A2 ) ) ) ) ).

% inverse_minus_eq
thf(fact_3540_abs__inverse,axiom,
    ! [A: $tType] :
      ( ( field_abs_sgn @ A )
     => ! [A2: A] :
          ( ( abs_abs @ A @ ( inverse_inverse @ A @ A2 ) )
          = ( inverse_inverse @ A @ ( abs_abs @ A @ A2 ) ) ) ) ).

% abs_inverse
thf(fact_3541_real__sqrt__zero,axiom,
    ( ( sqrt @ ( zero_zero @ real ) )
    = ( zero_zero @ real ) ) ).

% real_sqrt_zero
thf(fact_3542_real__sqrt__eq__zero__cancel__iff,axiom,
    ! [X2: real] :
      ( ( ( sqrt @ X2 )
        = ( zero_zero @ real ) )
      = ( X2
        = ( zero_zero @ real ) ) ) ).

% real_sqrt_eq_zero_cancel_iff
thf(fact_3543_real__sqrt__less__iff,axiom,
    ! [X2: real,Y2: real] :
      ( ( ord_less @ real @ ( sqrt @ X2 ) @ ( sqrt @ Y2 ) )
      = ( ord_less @ real @ X2 @ Y2 ) ) ).

% real_sqrt_less_iff
thf(fact_3544_real__sqrt__le__iff,axiom,
    ! [X2: real,Y2: real] :
      ( ( ord_less_eq @ real @ ( sqrt @ X2 ) @ ( sqrt @ Y2 ) )
      = ( ord_less_eq @ real @ X2 @ Y2 ) ) ).

% real_sqrt_le_iff
thf(fact_3545_cot__zero,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ( ( cot @ A @ ( zero_zero @ A ) )
        = ( zero_zero @ A ) ) ) ).

% cot_zero
thf(fact_3546_inverse__nonnegative__iff__nonnegative,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( inverse_inverse @ A @ A2 ) )
          = ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 ) ) ) ).

% inverse_nonnegative_iff_nonnegative
thf(fact_3547_inverse__nonpositive__iff__nonpositive,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ ( inverse_inverse @ A @ A2 ) @ ( zero_zero @ A ) )
          = ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) ) ) ) ).

% inverse_nonpositive_iff_nonpositive
thf(fact_3548_inverse__less__iff__less,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ B2 )
           => ( ( ord_less @ A @ ( inverse_inverse @ A @ A2 ) @ ( inverse_inverse @ A @ B2 ) )
              = ( ord_less @ A @ B2 @ A2 ) ) ) ) ) ).

% inverse_less_iff_less
thf(fact_3549_inverse__less__iff__less__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ B2 @ ( zero_zero @ A ) )
           => ( ( ord_less @ A @ ( inverse_inverse @ A @ A2 ) @ ( inverse_inverse @ A @ B2 ) )
              = ( ord_less @ A @ B2 @ A2 ) ) ) ) ) ).

% inverse_less_iff_less_neg
thf(fact_3550_inverse__negative__iff__negative,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( inverse_inverse @ A @ A2 ) @ ( zero_zero @ A ) )
          = ( ord_less @ A @ A2 @ ( zero_zero @ A ) ) ) ) ).

% inverse_negative_iff_negative
thf(fact_3551_inverse__positive__iff__positive,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( inverse_inverse @ A @ A2 ) )
          = ( ord_less @ A @ ( zero_zero @ A ) @ A2 ) ) ) ).

% inverse_positive_iff_positive
thf(fact_3552_real__sqrt__lt__0__iff,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( sqrt @ X2 ) @ ( zero_zero @ real ) )
      = ( ord_less @ real @ X2 @ ( zero_zero @ real ) ) ) ).

% real_sqrt_lt_0_iff
thf(fact_3553_real__sqrt__gt__0__iff,axiom,
    ! [Y2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ ( sqrt @ Y2 ) )
      = ( ord_less @ real @ ( zero_zero @ real ) @ Y2 ) ) ).

% real_sqrt_gt_0_iff
thf(fact_3554_real__sqrt__ge__0__iff,axiom,
    ! [Y2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( sqrt @ Y2 ) )
      = ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y2 ) ) ).

% real_sqrt_ge_0_iff
thf(fact_3555_real__sqrt__le__0__iff,axiom,
    ! [X2: real] :
      ( ( ord_less_eq @ real @ ( sqrt @ X2 ) @ ( zero_zero @ real ) )
      = ( ord_less_eq @ real @ X2 @ ( zero_zero @ real ) ) ) ).

% real_sqrt_le_0_iff
thf(fact_3556_real__sqrt__lt__1__iff,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( sqrt @ X2 ) @ ( one_one @ real ) )
      = ( ord_less @ real @ X2 @ ( one_one @ real ) ) ) ).

% real_sqrt_lt_1_iff
thf(fact_3557_real__sqrt__gt__1__iff,axiom,
    ! [Y2: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ ( sqrt @ Y2 ) )
      = ( ord_less @ real @ ( one_one @ real ) @ Y2 ) ) ).

% real_sqrt_gt_1_iff
thf(fact_3558_real__sqrt__le__1__iff,axiom,
    ! [X2: real] :
      ( ( ord_less_eq @ real @ ( sqrt @ X2 ) @ ( one_one @ real ) )
      = ( ord_less_eq @ real @ X2 @ ( one_one @ real ) ) ) ).

% real_sqrt_le_1_iff
thf(fact_3559_real__sqrt__ge__1__iff,axiom,
    ! [Y2: real] :
      ( ( ord_less_eq @ real @ ( one_one @ real ) @ ( sqrt @ Y2 ) )
      = ( ord_less_eq @ real @ ( one_one @ real ) @ Y2 ) ) ).

% real_sqrt_ge_1_iff
thf(fact_3560_real__sqrt__abs2,axiom,
    ! [X2: real] :
      ( ( sqrt @ ( times_times @ real @ X2 @ X2 ) )
      = ( abs_abs @ real @ X2 ) ) ).

% real_sqrt_abs2
thf(fact_3561_real__sqrt__mult__self,axiom,
    ! [A2: real] :
      ( ( times_times @ real @ ( sqrt @ A2 ) @ ( sqrt @ A2 ) )
      = ( abs_abs @ real @ A2 ) ) ).

% real_sqrt_mult_self
thf(fact_3562_cot__pi,axiom,
    ( ( cot @ real @ pi )
    = ( zero_zero @ real ) ) ).

% cot_pi
thf(fact_3563_inverse__le__iff__le,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ B2 )
           => ( ( ord_less_eq @ A @ ( inverse_inverse @ A @ A2 ) @ ( inverse_inverse @ A @ B2 ) )
              = ( ord_less_eq @ A @ B2 @ A2 ) ) ) ) ) ).

% inverse_le_iff_le
thf(fact_3564_inverse__le__iff__le__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ B2 @ ( zero_zero @ A ) )
           => ( ( ord_less_eq @ A @ ( inverse_inverse @ A @ A2 ) @ ( inverse_inverse @ A @ B2 ) )
              = ( ord_less_eq @ A @ B2 @ A2 ) ) ) ) ) ).

% inverse_le_iff_le_neg
thf(fact_3565_left__inverse,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( times_times @ A @ ( inverse_inverse @ A @ A2 ) @ A2 )
            = ( one_one @ A ) ) ) ) ).

% left_inverse
thf(fact_3566_right__inverse,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( times_times @ A @ A2 @ ( inverse_inverse @ A @ A2 ) )
            = ( one_one @ A ) ) ) ) ).

% right_inverse
thf(fact_3567_inverse__eq__divide__numeral,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [W: num] :
          ( ( inverse_inverse @ A @ ( numeral_numeral @ A @ W ) )
          = ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ W ) ) ) ) ).

% inverse_eq_divide_numeral
thf(fact_3568_real__sqrt__four,axiom,
    ( ( sqrt @ ( numeral_numeral @ real @ ( bit0 @ ( bit0 @ one2 ) ) ) )
    = ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ).

% real_sqrt_four
thf(fact_3569_inverse__eq__divide__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [W: num] :
          ( ( inverse_inverse @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) )
          = ( divide_divide @ A @ ( one_one @ A ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) ) ) ) ).

% inverse_eq_divide_neg_numeral
thf(fact_3570_cot__npi,axiom,
    ! [N2: nat] :
      ( ( cot @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N2 ) @ pi ) )
      = ( zero_zero @ real ) ) ).

% cot_npi
thf(fact_3571_real__sqrt__abs,axiom,
    ! [X2: real] :
      ( ( sqrt @ ( power_power @ real @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
      = ( abs_abs @ real @ X2 ) ) ).

% real_sqrt_abs
thf(fact_3572_real__sqrt__pow2,axiom,
    ! [X2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( power_power @ real @ ( sqrt @ X2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
        = X2 ) ) ).

% real_sqrt_pow2
thf(fact_3573_real__sqrt__pow2__iff,axiom,
    ! [X2: real] :
      ( ( ( power_power @ real @ ( sqrt @ X2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
        = X2 )
      = ( ord_less_eq @ real @ ( zero_zero @ real ) @ X2 ) ) ).

% real_sqrt_pow2_iff
thf(fact_3574_real__sqrt__sum__squares__mult__squared__eq,axiom,
    ! [X2: real,Y2: real,Xa2: real,Ya: real] :
      ( ( power_power @ real @ ( sqrt @ ( times_times @ real @ ( plus_plus @ real @ ( power_power @ real @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Y2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( plus_plus @ real @ ( power_power @ real @ Xa2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Ya @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
      = ( times_times @ real @ ( plus_plus @ real @ ( power_power @ real @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Y2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( plus_plus @ real @ ( power_power @ real @ Xa2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Ya @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% real_sqrt_sum_squares_mult_squared_eq
thf(fact_3575_cot__periodic,axiom,
    ! [X2: real] :
      ( ( cot @ real @ ( plus_plus @ real @ X2 @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) ) )
      = ( cot @ real @ X2 ) ) ).

% cot_periodic
thf(fact_3576_real__sqrt__less__mono,axiom,
    ! [X2: real,Y2: real] :
      ( ( ord_less @ real @ X2 @ Y2 )
     => ( ord_less @ real @ ( sqrt @ X2 ) @ ( sqrt @ Y2 ) ) ) ).

% real_sqrt_less_mono
thf(fact_3577_real__sqrt__le__mono,axiom,
    ! [X2: real,Y2: real] :
      ( ( ord_less_eq @ real @ X2 @ Y2 )
     => ( ord_less_eq @ real @ ( sqrt @ X2 ) @ ( sqrt @ Y2 ) ) ) ).

% real_sqrt_le_mono
thf(fact_3578_inverse__eq__imp__eq,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A,B2: A] :
          ( ( ( inverse_inverse @ A @ A2 )
            = ( inverse_inverse @ A @ B2 ) )
         => ( A2 = B2 ) ) ) ).

% inverse_eq_imp_eq
thf(fact_3579_mult__commute__imp__mult__inverse__commute,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [Y2: A,X2: A] :
          ( ( ( times_times @ A @ Y2 @ X2 )
            = ( times_times @ A @ X2 @ Y2 ) )
         => ( ( times_times @ A @ ( inverse_inverse @ A @ Y2 ) @ X2 )
            = ( times_times @ A @ X2 @ ( inverse_inverse @ A @ Y2 ) ) ) ) ) ).

% mult_commute_imp_mult_inverse_commute
thf(fact_3580_real__sqrt__mult,axiom,
    ! [X2: real,Y2: real] :
      ( ( sqrt @ ( times_times @ real @ X2 @ Y2 ) )
      = ( times_times @ real @ ( sqrt @ X2 ) @ ( sqrt @ Y2 ) ) ) ).

% real_sqrt_mult
thf(fact_3581_real__sqrt__divide,axiom,
    ! [X2: real,Y2: real] :
      ( ( sqrt @ ( divide_divide @ real @ X2 @ Y2 ) )
      = ( divide_divide @ real @ ( sqrt @ X2 ) @ ( sqrt @ Y2 ) ) ) ).

% real_sqrt_divide
thf(fact_3582_power__inverse,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A,N2: nat] :
          ( ( power_power @ A @ ( inverse_inverse @ A @ A2 ) @ N2 )
          = ( inverse_inverse @ A @ ( power_power @ A @ A2 @ N2 ) ) ) ) ).

% power_inverse
thf(fact_3583_real__sqrt__power,axiom,
    ! [X2: real,K: nat] :
      ( ( sqrt @ ( power_power @ real @ X2 @ K ) )
      = ( power_power @ real @ ( sqrt @ X2 ) @ K ) ) ).

% real_sqrt_power
thf(fact_3584_field__class_Ofield__inverse__zero,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ( ( inverse_inverse @ A @ ( zero_zero @ A ) )
        = ( zero_zero @ A ) ) ) ).

% field_class.field_inverse_zero
thf(fact_3585_inverse__zero__imp__zero,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A] :
          ( ( ( inverse_inverse @ A @ A2 )
            = ( zero_zero @ A ) )
         => ( A2
            = ( zero_zero @ A ) ) ) ) ).

% inverse_zero_imp_zero
thf(fact_3586_nonzero__inverse__eq__imp__eq,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A,B2: A] :
          ( ( ( inverse_inverse @ A @ A2 )
            = ( inverse_inverse @ A @ B2 ) )
         => ( ( A2
             != ( zero_zero @ A ) )
           => ( ( B2
               != ( zero_zero @ A ) )
             => ( A2 = B2 ) ) ) ) ) ).

% nonzero_inverse_eq_imp_eq
thf(fact_3587_nonzero__inverse__inverse__eq,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( inverse_inverse @ A @ ( inverse_inverse @ A @ A2 ) )
            = A2 ) ) ) ).

% nonzero_inverse_inverse_eq
thf(fact_3588_nonzero__imp__inverse__nonzero,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( inverse_inverse @ A @ A2 )
           != ( zero_zero @ A ) ) ) ) ).

% nonzero_imp_inverse_nonzero
thf(fact_3589_nonzero__norm__inverse,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [A2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( real_V7770717601297561774m_norm @ A @ ( inverse_inverse @ A @ A2 ) )
            = ( inverse_inverse @ real @ ( real_V7770717601297561774m_norm @ A @ A2 ) ) ) ) ) ).

% nonzero_norm_inverse
thf(fact_3590_nonzero__inverse__scaleR__distrib,axiom,
    ! [A: $tType] :
      ( ( real_V5047593784448816457lgebra @ A )
     => ! [A2: real,X2: A] :
          ( ( A2
           != ( zero_zero @ real ) )
         => ( ( X2
             != ( zero_zero @ A ) )
           => ( ( inverse_inverse @ A @ ( real_V8093663219630862766scaleR @ A @ A2 @ X2 ) )
              = ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ A2 ) @ ( inverse_inverse @ A @ X2 ) ) ) ) ) ) ).

% nonzero_inverse_scaleR_distrib
thf(fact_3591_sqrt__divide__self__eq,axiom,
    ! [X2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( divide_divide @ real @ ( sqrt @ X2 ) @ X2 )
        = ( inverse_inverse @ real @ ( sqrt @ X2 ) ) ) ) ).

% sqrt_divide_self_eq
thf(fact_3592_norm__inverse__le__norm,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [R3: real,X2: A] :
          ( ( ord_less_eq @ real @ R3 @ ( real_V7770717601297561774m_norm @ A @ X2 ) )
         => ( ( ord_less @ real @ ( zero_zero @ real ) @ R3 )
           => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( inverse_inverse @ A @ X2 ) ) @ ( inverse_inverse @ real @ R3 ) ) ) ) ) ).

% norm_inverse_le_norm
thf(fact_3593_inverse__less__imp__less,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( inverse_inverse @ A @ A2 ) @ ( inverse_inverse @ A @ B2 ) )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
           => ( ord_less @ A @ B2 @ A2 ) ) ) ) ).

% inverse_less_imp_less
thf(fact_3594_less__imp__inverse__less,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
           => ( ord_less @ A @ ( inverse_inverse @ A @ B2 ) @ ( inverse_inverse @ A @ A2 ) ) ) ) ) ).

% less_imp_inverse_less
thf(fact_3595_inverse__less__imp__less__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( inverse_inverse @ A @ A2 ) @ ( inverse_inverse @ A @ B2 ) )
         => ( ( ord_less @ A @ B2 @ ( zero_zero @ A ) )
           => ( ord_less @ A @ B2 @ A2 ) ) ) ) ).

% inverse_less_imp_less_neg
thf(fact_3596_less__imp__inverse__less__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_less @ A @ B2 @ ( zero_zero @ A ) )
           => ( ord_less @ A @ ( inverse_inverse @ A @ B2 ) @ ( inverse_inverse @ A @ A2 ) ) ) ) ) ).

% less_imp_inverse_less_neg
thf(fact_3597_inverse__negative__imp__negative,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( inverse_inverse @ A @ A2 ) @ ( zero_zero @ A ) )
         => ( ( A2
             != ( zero_zero @ A ) )
           => ( ord_less @ A @ A2 @ ( zero_zero @ A ) ) ) ) ) ).

% inverse_negative_imp_negative
thf(fact_3598_inverse__positive__imp__positive,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( inverse_inverse @ A @ A2 ) )
         => ( ( A2
             != ( zero_zero @ A ) )
           => ( ord_less @ A @ ( zero_zero @ A ) @ A2 ) ) ) ) ).

% inverse_positive_imp_positive
thf(fact_3599_negative__imp__inverse__negative,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
         => ( ord_less @ A @ ( inverse_inverse @ A @ A2 ) @ ( zero_zero @ A ) ) ) ) ).

% negative_imp_inverse_negative
thf(fact_3600_positive__imp__inverse__positive,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ord_less @ A @ ( zero_zero @ A ) @ ( inverse_inverse @ A @ A2 ) ) ) ) ).

% positive_imp_inverse_positive
thf(fact_3601_nonzero__inverse__mult__distrib,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A,B2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( B2
             != ( zero_zero @ A ) )
           => ( ( inverse_inverse @ A @ ( times_times @ A @ A2 @ B2 ) )
              = ( times_times @ A @ ( inverse_inverse @ A @ B2 ) @ ( inverse_inverse @ A @ A2 ) ) ) ) ) ) ).

% nonzero_inverse_mult_distrib
thf(fact_3602_nonzero__inverse__minus__eq,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( inverse_inverse @ A @ ( uminus_uminus @ A @ A2 ) )
            = ( uminus_uminus @ A @ ( inverse_inverse @ A @ A2 ) ) ) ) ) ).

% nonzero_inverse_minus_eq
thf(fact_3603_inverse__numeral__1,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ( ( inverse_inverse @ A @ ( numeral_numeral @ A @ one2 ) )
        = ( numeral_numeral @ A @ one2 ) ) ) ).

% inverse_numeral_1
thf(fact_3604_inverse__unique,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A,B2: A] :
          ( ( ( times_times @ A @ A2 @ B2 )
            = ( one_one @ A ) )
         => ( ( inverse_inverse @ A @ A2 )
            = B2 ) ) ) ).

% inverse_unique
thf(fact_3605_divide__inverse__commute,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ( ( divide_divide @ A )
        = ( ^ [A4: A,B4: A] : ( times_times @ A @ ( inverse_inverse @ A @ B4 ) @ A4 ) ) ) ) ).

% divide_inverse_commute
thf(fact_3606_divide__inverse,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ( ( divide_divide @ A )
        = ( ^ [A4: A,B4: A] : ( times_times @ A @ A4 @ ( inverse_inverse @ A @ B4 ) ) ) ) ) ).

% divide_inverse
thf(fact_3607_field__class_Ofield__divide__inverse,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ( ( divide_divide @ A )
        = ( ^ [A4: A,B4: A] : ( times_times @ A @ A4 @ ( inverse_inverse @ A @ B4 ) ) ) ) ) ).

% field_class.field_divide_inverse
thf(fact_3608_real__sqrt__gt__zero,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
     => ( ord_less @ real @ ( zero_zero @ real ) @ ( sqrt @ X2 ) ) ) ).

% real_sqrt_gt_zero
thf(fact_3609_inverse__eq__divide,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ( ( inverse_inverse @ A )
        = ( divide_divide @ A @ ( one_one @ A ) ) ) ) ).

% inverse_eq_divide
thf(fact_3610_power__mult__inverse__distrib,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [X2: A,M: nat] :
          ( ( times_times @ A @ ( power_power @ A @ X2 @ M ) @ ( inverse_inverse @ A @ X2 ) )
          = ( times_times @ A @ ( inverse_inverse @ A @ X2 ) @ ( power_power @ A @ X2 @ M ) ) ) ) ).

% power_mult_inverse_distrib
thf(fact_3611_power__mult__power__inverse__commute,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [X2: A,M: nat,N2: nat] :
          ( ( times_times @ A @ ( power_power @ A @ X2 @ M ) @ ( power_power @ A @ ( inverse_inverse @ A @ X2 ) @ N2 ) )
          = ( times_times @ A @ ( power_power @ A @ ( inverse_inverse @ A @ X2 ) @ N2 ) @ ( power_power @ A @ X2 @ M ) ) ) ) ).

% power_mult_power_inverse_commute
thf(fact_3612_real__sqrt__ge__zero,axiom,
    ! [X2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X2 )
     => ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( sqrt @ X2 ) ) ) ).

% real_sqrt_ge_zero
thf(fact_3613_real__sqrt__eq__zero__cancel,axiom,
    ! [X2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( ( sqrt @ X2 )
          = ( zero_zero @ real ) )
       => ( X2
          = ( zero_zero @ real ) ) ) ) ).

% real_sqrt_eq_zero_cancel
thf(fact_3614_mult__inverse__of__nat__commute,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [Xa2: nat,X2: A] :
          ( ( times_times @ A @ ( inverse_inverse @ A @ ( semiring_1_of_nat @ A @ Xa2 ) ) @ X2 )
          = ( times_times @ A @ X2 @ ( inverse_inverse @ A @ ( semiring_1_of_nat @ A @ Xa2 ) ) ) ) ) ).

% mult_inverse_of_nat_commute
thf(fact_3615_nonzero__abs__inverse,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( abs_abs @ A @ ( inverse_inverse @ A @ A2 ) )
            = ( inverse_inverse @ A @ ( abs_abs @ A @ A2 ) ) ) ) ) ).

% nonzero_abs_inverse
thf(fact_3616_real__sqrt__ge__one,axiom,
    ! [X2: real] :
      ( ( ord_less_eq @ real @ ( one_one @ real ) @ X2 )
     => ( ord_less_eq @ real @ ( one_one @ real ) @ ( sqrt @ X2 ) ) ) ).

% real_sqrt_ge_one
thf(fact_3617_mult__inverse__of__int__commute,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [Xa2: int,X2: A] :
          ( ( times_times @ A @ ( inverse_inverse @ A @ ( ring_1_of_int @ A @ Xa2 ) ) @ X2 )
          = ( times_times @ A @ X2 @ ( inverse_inverse @ A @ ( ring_1_of_int @ A @ Xa2 ) ) ) ) ) ).

% mult_inverse_of_int_commute
thf(fact_3618_divide__real__def,axiom,
    ( ( divide_divide @ real )
    = ( ^ [X5: real,Y5: real] : ( times_times @ real @ X5 @ ( inverse_inverse @ real @ Y5 ) ) ) ) ).

% divide_real_def
thf(fact_3619_real__inv__sqrt__pow2,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( power_power @ real @ ( inverse_inverse @ real @ ( sqrt @ X2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
        = ( inverse_inverse @ real @ X2 ) ) ) ).

% real_inv_sqrt_pow2
thf(fact_3620_inverse__le__imp__le,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( inverse_inverse @ A @ A2 ) @ ( inverse_inverse @ A @ B2 ) )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
           => ( ord_less_eq @ A @ B2 @ A2 ) ) ) ) ).

% inverse_le_imp_le
thf(fact_3621_le__imp__inverse__le,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
           => ( ord_less_eq @ A @ ( inverse_inverse @ A @ B2 ) @ ( inverse_inverse @ A @ A2 ) ) ) ) ) ).

% le_imp_inverse_le
thf(fact_3622_inverse__le__imp__le__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( inverse_inverse @ A @ A2 ) @ ( inverse_inverse @ A @ B2 ) )
         => ( ( ord_less @ A @ B2 @ ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ B2 @ A2 ) ) ) ) ).

% inverse_le_imp_le_neg
thf(fact_3623_le__imp__inverse__le__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less @ A @ B2 @ ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ ( inverse_inverse @ A @ B2 ) @ ( inverse_inverse @ A @ A2 ) ) ) ) ) ).

% le_imp_inverse_le_neg
thf(fact_3624_inverse__le__1__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X2: A] :
          ( ( ord_less_eq @ A @ ( inverse_inverse @ A @ X2 ) @ ( one_one @ A ) )
          = ( ( ord_less_eq @ A @ X2 @ ( zero_zero @ A ) )
            | ( ord_less_eq @ A @ ( one_one @ A ) @ X2 ) ) ) ) ).

% inverse_le_1_iff
thf(fact_3625_one__less__inverse,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less @ A @ A2 @ ( one_one @ A ) )
           => ( ord_less @ A @ ( one_one @ A ) @ ( inverse_inverse @ A @ A2 ) ) ) ) ) ).

% one_less_inverse
thf(fact_3626_one__less__inverse__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X2: A] :
          ( ( ord_less @ A @ ( one_one @ A ) @ ( inverse_inverse @ A @ X2 ) )
          = ( ( ord_less @ A @ ( zero_zero @ A ) @ X2 )
            & ( ord_less @ A @ X2 @ ( one_one @ A ) ) ) ) ) ).

% one_less_inverse_iff
thf(fact_3627_field__class_Ofield__inverse,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( times_times @ A @ ( inverse_inverse @ A @ A2 ) @ A2 )
            = ( one_one @ A ) ) ) ) ).

% field_class.field_inverse
thf(fact_3628_inverse__add,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A2: A,B2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( B2
             != ( zero_zero @ A ) )
           => ( ( plus_plus @ A @ ( inverse_inverse @ A @ A2 ) @ ( inverse_inverse @ A @ B2 ) )
              = ( times_times @ A @ ( times_times @ A @ ( plus_plus @ A @ A2 @ B2 ) @ ( inverse_inverse @ A @ A2 ) ) @ ( inverse_inverse @ A @ B2 ) ) ) ) ) ) ).

% inverse_add
thf(fact_3629_division__ring__inverse__add,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A,B2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( B2
             != ( zero_zero @ A ) )
           => ( ( plus_plus @ A @ ( inverse_inverse @ A @ A2 ) @ ( inverse_inverse @ A @ B2 ) )
              = ( times_times @ A @ ( times_times @ A @ ( inverse_inverse @ A @ A2 ) @ ( plus_plus @ A @ A2 @ B2 ) ) @ ( inverse_inverse @ A @ B2 ) ) ) ) ) ) ).

% division_ring_inverse_add
thf(fact_3630_division__ring__inverse__diff,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A,B2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( B2
             != ( zero_zero @ A ) )
           => ( ( minus_minus @ A @ ( inverse_inverse @ A @ A2 ) @ ( inverse_inverse @ A @ B2 ) )
              = ( times_times @ A @ ( times_times @ A @ ( inverse_inverse @ A @ A2 ) @ ( minus_minus @ A @ B2 @ A2 ) ) @ ( inverse_inverse @ A @ B2 ) ) ) ) ) ) ).

% division_ring_inverse_diff
thf(fact_3631_nonzero__inverse__eq__divide,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( inverse_inverse @ A @ A2 )
            = ( divide_divide @ A @ ( one_one @ A ) @ A2 ) ) ) ) ).

% nonzero_inverse_eq_divide
thf(fact_3632_real__div__sqrt,axiom,
    ! [X2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( divide_divide @ real @ X2 @ ( sqrt @ X2 ) )
        = ( sqrt @ X2 ) ) ) ).

% real_div_sqrt
thf(fact_3633_sqrt__add__le__add__sqrt,axiom,
    ! [X2: real,Y2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y2 )
       => ( ord_less_eq @ real @ ( sqrt @ ( plus_plus @ real @ X2 @ Y2 ) ) @ ( plus_plus @ real @ ( sqrt @ X2 ) @ ( sqrt @ Y2 ) ) ) ) ) ).

% sqrt_add_le_add_sqrt
thf(fact_3634_le__real__sqrt__sumsq,axiom,
    ! [X2: real,Y2: real] : ( ord_less_eq @ real @ X2 @ ( sqrt @ ( plus_plus @ real @ ( times_times @ real @ X2 @ X2 ) @ ( times_times @ real @ Y2 @ Y2 ) ) ) ) ).

% le_real_sqrt_sumsq
thf(fact_3635_inverse__le__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( inverse_inverse @ A @ A2 ) @ ( inverse_inverse @ A @ B2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A2 @ B2 ) )
             => ( ord_less_eq @ A @ B2 @ A2 ) )
            & ( ( ord_less_eq @ A @ ( times_times @ A @ A2 @ B2 ) @ ( zero_zero @ A ) )
             => ( ord_less_eq @ A @ A2 @ B2 ) ) ) ) ) ).

% inverse_le_iff
thf(fact_3636_inverse__less__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( inverse_inverse @ A @ A2 ) @ ( inverse_inverse @ A @ B2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A2 @ B2 ) )
             => ( ord_less @ A @ B2 @ A2 ) )
            & ( ( ord_less_eq @ A @ ( times_times @ A @ A2 @ B2 ) @ ( zero_zero @ A ) )
             => ( ord_less @ A @ A2 @ B2 ) ) ) ) ) ).

% inverse_less_iff
thf(fact_3637_one__le__inverse,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less_eq @ A @ A2 @ ( one_one @ A ) )
           => ( ord_less_eq @ A @ ( one_one @ A ) @ ( inverse_inverse @ A @ A2 ) ) ) ) ) ).

% one_le_inverse
thf(fact_3638_inverse__less__1__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X2: A] :
          ( ( ord_less @ A @ ( inverse_inverse @ A @ X2 ) @ ( one_one @ A ) )
          = ( ( ord_less_eq @ A @ X2 @ ( zero_zero @ A ) )
            | ( ord_less @ A @ ( one_one @ A ) @ X2 ) ) ) ) ).

% inverse_less_1_iff
thf(fact_3639_one__le__inverse__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X2: A] :
          ( ( ord_less_eq @ A @ ( one_one @ A ) @ ( inverse_inverse @ A @ X2 ) )
          = ( ( ord_less @ A @ ( zero_zero @ A ) @ X2 )
            & ( ord_less_eq @ A @ X2 @ ( one_one @ A ) ) ) ) ) ).

% one_le_inverse_iff
thf(fact_3640_inverse__diff__inverse,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A,B2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( B2
             != ( zero_zero @ A ) )
           => ( ( minus_minus @ A @ ( inverse_inverse @ A @ A2 ) @ ( inverse_inverse @ A @ B2 ) )
              = ( uminus_uminus @ A @ ( times_times @ A @ ( times_times @ A @ ( inverse_inverse @ A @ A2 ) @ ( minus_minus @ A @ A2 @ B2 ) ) @ ( inverse_inverse @ A @ B2 ) ) ) ) ) ) ) ).

% inverse_diff_inverse
thf(fact_3641_reals__Archimedean,axiom,
    ! [A: $tType] :
      ( ( archim462609752435547400_field @ A )
     => ! [X2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ X2 )
         => ? [N: nat] : ( ord_less @ A @ ( inverse_inverse @ A @ ( semiring_1_of_nat @ A @ ( suc @ N ) ) ) @ X2 ) ) ) ).

% reals_Archimedean
thf(fact_3642_sqrt2__less__2,axiom,
    ord_less @ real @ ( sqrt @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ).

% sqrt2_less_2
thf(fact_3643_real__vector__affinity__eq,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [M: real,X2: A,C2: A,Y2: A] :
          ( ( M
           != ( zero_zero @ real ) )
         => ( ( ( plus_plus @ A @ ( real_V8093663219630862766scaleR @ A @ M @ X2 ) @ C2 )
              = Y2 )
            = ( X2
              = ( minus_minus @ A @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ M ) @ Y2 ) @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ M ) @ C2 ) ) ) ) ) ) ).

% real_vector_affinity_eq
thf(fact_3644_real__vector__eq__affinity,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [M: real,Y2: A,X2: A,C2: A] :
          ( ( M
           != ( zero_zero @ real ) )
         => ( ( Y2
              = ( plus_plus @ A @ ( real_V8093663219630862766scaleR @ A @ M @ X2 ) @ C2 ) )
            = ( ( minus_minus @ A @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ M ) @ Y2 ) @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ M ) @ C2 ) )
              = X2 ) ) ) ) ).

% real_vector_eq_affinity
thf(fact_3645_neg__le__divideR__eq,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,A2: A,B2: A] :
          ( ( ord_less @ real @ C2 @ ( zero_zero @ real ) )
         => ( ( ord_less_eq @ A @ A2 @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ C2 ) @ B2 ) )
            = ( ord_less_eq @ A @ B2 @ ( real_V8093663219630862766scaleR @ A @ C2 @ A2 ) ) ) ) ) ).

% neg_le_divideR_eq
thf(fact_3646_neg__divideR__le__eq,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,B2: A,A2: A] :
          ( ( ord_less @ real @ C2 @ ( zero_zero @ real ) )
         => ( ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ C2 ) @ B2 ) @ A2 )
            = ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ C2 @ A2 ) @ B2 ) ) ) ) ).

% neg_divideR_le_eq
thf(fact_3647_pos__le__divideR__eq,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,A2: A,B2: A] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ C2 )
         => ( ( ord_less_eq @ A @ A2 @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ C2 ) @ B2 ) )
            = ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ C2 @ A2 ) @ B2 ) ) ) ) ).

% pos_le_divideR_eq
thf(fact_3648_pos__divideR__le__eq,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,B2: A,A2: A] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ C2 )
         => ( ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ C2 ) @ B2 ) @ A2 )
            = ( ord_less_eq @ A @ B2 @ ( real_V8093663219630862766scaleR @ A @ C2 @ A2 ) ) ) ) ) ).

% pos_divideR_le_eq
thf(fact_3649_pos__divideR__less__eq,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,B2: A,A2: A] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ C2 )
         => ( ( ord_less @ A @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ C2 ) @ B2 ) @ A2 )
            = ( ord_less @ A @ B2 @ ( real_V8093663219630862766scaleR @ A @ C2 @ A2 ) ) ) ) ) ).

% pos_divideR_less_eq
thf(fact_3650_pos__less__divideR__eq,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,A2: A,B2: A] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ C2 )
         => ( ( ord_less @ A @ A2 @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ C2 ) @ B2 ) )
            = ( ord_less @ A @ ( real_V8093663219630862766scaleR @ A @ C2 @ A2 ) @ B2 ) ) ) ) ).

% pos_less_divideR_eq
thf(fact_3651_neg__divideR__less__eq,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,B2: A,A2: A] :
          ( ( ord_less @ real @ C2 @ ( zero_zero @ real ) )
         => ( ( ord_less @ A @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ C2 ) @ B2 ) @ A2 )
            = ( ord_less @ A @ ( real_V8093663219630862766scaleR @ A @ C2 @ A2 ) @ B2 ) ) ) ) ).

% neg_divideR_less_eq
thf(fact_3652_neg__less__divideR__eq,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,A2: A,B2: A] :
          ( ( ord_less @ real @ C2 @ ( zero_zero @ real ) )
         => ( ( ord_less @ A @ A2 @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ C2 ) @ B2 ) )
            = ( ord_less @ A @ B2 @ ( real_V8093663219630862766scaleR @ A @ C2 @ A2 ) ) ) ) ) ).

% neg_less_divideR_eq
thf(fact_3653_forall__pos__mono__1,axiom,
    ! [P: real > $o,E2: real] :
      ( ! [D4: real,E: real] :
          ( ( ord_less @ real @ D4 @ E )
         => ( ( P @ D4 )
           => ( P @ E ) ) )
     => ( ! [N: nat] : ( P @ ( inverse_inverse @ real @ ( semiring_1_of_nat @ real @ ( suc @ N ) ) ) )
       => ( ( ord_less @ real @ ( zero_zero @ real ) @ E2 )
         => ( P @ E2 ) ) ) ) ).

% forall_pos_mono_1
thf(fact_3654_real__arch__inverse,axiom,
    ! [E2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ E2 )
      = ( ? [N3: nat] :
            ( ( N3
             != ( zero_zero @ nat ) )
            & ( ord_less @ real @ ( zero_zero @ real ) @ ( inverse_inverse @ real @ ( semiring_1_of_nat @ real @ N3 ) ) )
            & ( ord_less @ real @ ( inverse_inverse @ real @ ( semiring_1_of_nat @ real @ N3 ) ) @ E2 ) ) ) ) ).

% real_arch_inverse
thf(fact_3655_forall__pos__mono,axiom,
    ! [P: real > $o,E2: real] :
      ( ! [D4: real,E: real] :
          ( ( ord_less @ real @ D4 @ E )
         => ( ( P @ D4 )
           => ( P @ E ) ) )
     => ( ! [N: nat] :
            ( ( N
             != ( zero_zero @ nat ) )
           => ( P @ ( inverse_inverse @ real @ ( semiring_1_of_nat @ real @ N ) ) ) )
       => ( ( ord_less @ real @ ( zero_zero @ real ) @ E2 )
         => ( P @ E2 ) ) ) ) ).

% forall_pos_mono
thf(fact_3656_ln__inverse,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( ln_ln @ real @ ( inverse_inverse @ real @ X2 ) )
        = ( uminus_uminus @ real @ ( ln_ln @ real @ X2 ) ) ) ) ).

% ln_inverse
thf(fact_3657_summable__exp,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X2: A] :
          ( summable @ A
          @ ^ [N3: nat] : ( times_times @ A @ ( inverse_inverse @ A @ ( semiring_char_0_fact @ A @ N3 ) ) @ ( power_power @ A @ X2 @ N3 ) ) ) ) ).

% summable_exp
thf(fact_3658_summable__exp__generic,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [X2: A] :
          ( summable @ A
          @ ^ [N3: nat] : ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ ( semiring_char_0_fact @ real @ N3 ) ) @ ( power_power @ A @ X2 @ N3 ) ) ) ) ).

% summable_exp_generic
thf(fact_3659_real__less__rsqrt,axiom,
    ! [X2: real,Y2: real] :
      ( ( ord_less @ real @ ( power_power @ real @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ Y2 )
     => ( ord_less @ real @ X2 @ ( sqrt @ Y2 ) ) ) ).

% real_less_rsqrt
thf(fact_3660_sqrt__le__D,axiom,
    ! [X2: real,Y2: real] :
      ( ( ord_less_eq @ real @ ( sqrt @ X2 ) @ Y2 )
     => ( ord_less_eq @ real @ X2 @ ( power_power @ real @ Y2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ).

% sqrt_le_D
thf(fact_3661_real__le__rsqrt,axiom,
    ! [X2: real,Y2: real] :
      ( ( ord_less_eq @ real @ ( power_power @ real @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ Y2 )
     => ( ord_less_eq @ real @ X2 @ ( sqrt @ Y2 ) ) ) ).

% real_le_rsqrt
thf(fact_3662_ex__inverse__of__nat__less,axiom,
    ! [A: $tType] :
      ( ( archim462609752435547400_field @ A )
     => ! [X2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ X2 )
         => ? [N: nat] :
              ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
              & ( ord_less @ A @ ( inverse_inverse @ A @ ( semiring_1_of_nat @ A @ N ) ) @ X2 ) ) ) ) ).

% ex_inverse_of_nat_less
thf(fact_3663_power__diff__conv__inverse,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [X2: A,M: nat,N2: nat] :
          ( ( X2
           != ( zero_zero @ A ) )
         => ( ( ord_less_eq @ nat @ M @ N2 )
           => ( ( power_power @ A @ X2 @ ( minus_minus @ nat @ N2 @ M ) )
              = ( times_times @ A @ ( power_power @ A @ X2 @ N2 ) @ ( power_power @ A @ ( inverse_inverse @ A @ X2 ) @ M ) ) ) ) ) ) ).

% power_diff_conv_inverse
thf(fact_3664_tan__60,axiom,
    ( ( tan @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit1 @ one2 ) ) ) )
    = ( sqrt @ ( numeral_numeral @ real @ ( bit1 @ one2 ) ) ) ) ).

% tan_60
thf(fact_3665_neg__minus__divideR__le__eq,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,B2: A,A2: A] :
          ( ( ord_less @ real @ C2 @ ( zero_zero @ real ) )
         => ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ C2 ) @ B2 ) ) @ A2 )
            = ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ C2 @ A2 ) @ ( uminus_uminus @ A @ B2 ) ) ) ) ) ).

% neg_minus_divideR_le_eq
thf(fact_3666_neg__le__minus__divideR__eq,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,A2: A,B2: A] :
          ( ( ord_less @ real @ C2 @ ( zero_zero @ real ) )
         => ( ( ord_less_eq @ A @ A2 @ ( uminus_uminus @ A @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ C2 ) @ B2 ) ) )
            = ( ord_less_eq @ A @ ( uminus_uminus @ A @ B2 ) @ ( real_V8093663219630862766scaleR @ A @ C2 @ A2 ) ) ) ) ) ).

% neg_le_minus_divideR_eq
thf(fact_3667_pos__minus__divideR__le__eq,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,B2: A,A2: A] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ C2 )
         => ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ C2 ) @ B2 ) ) @ A2 )
            = ( ord_less_eq @ A @ ( uminus_uminus @ A @ B2 ) @ ( real_V8093663219630862766scaleR @ A @ C2 @ A2 ) ) ) ) ) ).

% pos_minus_divideR_le_eq
thf(fact_3668_pos__le__minus__divideR__eq,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,A2: A,B2: A] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ C2 )
         => ( ( ord_less_eq @ A @ A2 @ ( uminus_uminus @ A @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ C2 ) @ B2 ) ) )
            = ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ C2 @ A2 ) @ ( uminus_uminus @ A @ B2 ) ) ) ) ) ).

% pos_le_minus_divideR_eq
thf(fact_3669_cot__def,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ( ( cot @ A )
        = ( ^ [X5: A] : ( divide_divide @ A @ ( cos @ A @ X5 ) @ ( sin @ A @ X5 ) ) ) ) ) ).

% cot_def
thf(fact_3670_neg__minus__divideR__less__eq,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,B2: A,A2: A] :
          ( ( ord_less @ real @ C2 @ ( zero_zero @ real ) )
         => ( ( ord_less @ A @ ( uminus_uminus @ A @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ C2 ) @ B2 ) ) @ A2 )
            = ( ord_less @ A @ ( real_V8093663219630862766scaleR @ A @ C2 @ A2 ) @ ( uminus_uminus @ A @ B2 ) ) ) ) ) ).

% neg_minus_divideR_less_eq
thf(fact_3671_neg__less__minus__divideR__eq,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,A2: A,B2: A] :
          ( ( ord_less @ real @ C2 @ ( zero_zero @ real ) )
         => ( ( ord_less @ A @ A2 @ ( uminus_uminus @ A @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ C2 ) @ B2 ) ) )
            = ( ord_less @ A @ ( uminus_uminus @ A @ B2 ) @ ( real_V8093663219630862766scaleR @ A @ C2 @ A2 ) ) ) ) ) ).

% neg_less_minus_divideR_eq
thf(fact_3672_pos__minus__divideR__less__eq,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,B2: A,A2: A] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ C2 )
         => ( ( ord_less @ A @ ( uminus_uminus @ A @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ C2 ) @ B2 ) ) @ A2 )
            = ( ord_less @ A @ ( uminus_uminus @ A @ B2 ) @ ( real_V8093663219630862766scaleR @ A @ C2 @ A2 ) ) ) ) ) ).

% pos_minus_divideR_less_eq
thf(fact_3673_pos__less__minus__divideR__eq,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,A2: A,B2: A] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ C2 )
         => ( ( ord_less @ A @ A2 @ ( uminus_uminus @ A @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ C2 ) @ B2 ) ) )
            = ( ord_less @ A @ ( real_V8093663219630862766scaleR @ A @ C2 @ A2 ) @ ( uminus_uminus @ A @ B2 ) ) ) ) ) ).

% pos_less_minus_divideR_eq
thf(fact_3674_real__le__lsqrt,axiom,
    ! [X2: real,Y2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y2 )
       => ( ( ord_less_eq @ real @ X2 @ ( power_power @ real @ Y2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
         => ( ord_less_eq @ real @ ( sqrt @ X2 ) @ Y2 ) ) ) ) ).

% real_le_lsqrt
thf(fact_3675_real__sqrt__unique,axiom,
    ! [Y2: real,X2: real] :
      ( ( ( power_power @ real @ Y2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
        = X2 )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y2 )
       => ( ( sqrt @ X2 )
          = Y2 ) ) ) ).

% real_sqrt_unique
thf(fact_3676_exp__converges,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [X2: A] :
          ( sums @ A
          @ ^ [N3: nat] : ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ ( semiring_char_0_fact @ real @ N3 ) ) @ ( power_power @ A @ X2 @ N3 ) )
          @ ( exp @ A @ X2 ) ) ) ).

% exp_converges
thf(fact_3677_exp__def,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ( ( exp @ A )
        = ( ^ [X5: A] :
              ( suminf @ A
              @ ^ [N3: nat] : ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ ( semiring_char_0_fact @ real @ N3 ) ) @ ( power_power @ A @ X5 @ N3 ) ) ) ) ) ) ).

% exp_def
thf(fact_3678_lemma__real__divide__sqrt__less,axiom,
    ! [U: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ U )
     => ( ord_less @ real @ ( divide_divide @ real @ U @ ( sqrt @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ U ) ) ).

% lemma_real_divide_sqrt_less
thf(fact_3679_summable__norm__exp,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [X2: A] :
          ( summable @ real
          @ ^ [N3: nat] : ( real_V7770717601297561774m_norm @ A @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ ( semiring_char_0_fact @ real @ N3 ) ) @ ( power_power @ A @ X2 @ N3 ) ) ) ) ) ).

% summable_norm_exp
thf(fact_3680_real__sqrt__sum__squares__eq__cancel,axiom,
    ! [X2: real,Y2: real] :
      ( ( ( sqrt @ ( plus_plus @ real @ ( power_power @ real @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Y2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
        = X2 )
     => ( Y2
        = ( zero_zero @ real ) ) ) ).

% real_sqrt_sum_squares_eq_cancel
thf(fact_3681_real__sqrt__sum__squares__eq__cancel2,axiom,
    ! [X2: real,Y2: real] :
      ( ( ( sqrt @ ( plus_plus @ real @ ( power_power @ real @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Y2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
        = Y2 )
     => ( X2
        = ( zero_zero @ real ) ) ) ).

% real_sqrt_sum_squares_eq_cancel2
thf(fact_3682_real__sqrt__sum__squares__ge1,axiom,
    ! [X2: real,Y2: real] : ( ord_less_eq @ real @ X2 @ ( sqrt @ ( plus_plus @ real @ ( power_power @ real @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Y2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% real_sqrt_sum_squares_ge1
thf(fact_3683_real__sqrt__sum__squares__ge2,axiom,
    ! [Y2: real,X2: real] : ( ord_less_eq @ real @ Y2 @ ( sqrt @ ( plus_plus @ real @ ( power_power @ real @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Y2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% real_sqrt_sum_squares_ge2
thf(fact_3684_real__sqrt__sum__squares__triangle__ineq,axiom,
    ! [A2: real,C2: real,B2: real,D2: real] : ( ord_less_eq @ real @ ( sqrt @ ( plus_plus @ real @ ( power_power @ real @ ( plus_plus @ real @ A2 @ C2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ ( plus_plus @ real @ B2 @ D2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( plus_plus @ real @ ( sqrt @ ( plus_plus @ real @ ( power_power @ real @ A2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ B2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( sqrt @ ( plus_plus @ real @ ( power_power @ real @ C2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ D2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% real_sqrt_sum_squares_triangle_ineq
thf(fact_3685_sqrt__ge__absD,axiom,
    ! [X2: real,Y2: real] :
      ( ( ord_less_eq @ real @ ( abs_abs @ real @ X2 ) @ ( sqrt @ Y2 ) )
     => ( ord_less_eq @ real @ ( power_power @ real @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ Y2 ) ) ).

% sqrt_ge_absD
thf(fact_3686_cos__45,axiom,
    ( ( cos @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ ( bit0 @ one2 ) ) ) ) )
    = ( divide_divide @ real @ ( sqrt @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ).

% cos_45
thf(fact_3687_sin__45,axiom,
    ( ( sin @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ ( bit0 @ one2 ) ) ) ) )
    = ( divide_divide @ real @ ( sqrt @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ).

% sin_45
thf(fact_3688_tan__cot,axiom,
    ! [X2: real] :
      ( ( tan @ real @ ( minus_minus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ X2 ) )
      = ( inverse_inverse @ real @ ( tan @ real @ X2 ) ) ) ).

% tan_cot
thf(fact_3689_exp__plus__inverse__exp,axiom,
    ! [X2: real] : ( ord_less_eq @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( plus_plus @ real @ ( exp @ real @ X2 ) @ ( inverse_inverse @ real @ ( exp @ real @ X2 ) ) ) ) ).

% exp_plus_inverse_exp
thf(fact_3690_real__less__lsqrt,axiom,
    ! [X2: real,Y2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y2 )
       => ( ( ord_less @ real @ X2 @ ( power_power @ real @ Y2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
         => ( ord_less @ real @ ( sqrt @ X2 ) @ Y2 ) ) ) ) ).

% real_less_lsqrt
thf(fact_3691_sqrt__sum__squares__le__sum,axiom,
    ! [X2: real,Y2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y2 )
       => ( ord_less_eq @ real @ ( sqrt @ ( plus_plus @ real @ ( power_power @ real @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Y2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( plus_plus @ real @ X2 @ Y2 ) ) ) ) ).

% sqrt_sum_squares_le_sum
thf(fact_3692_tan__30,axiom,
    ( ( tan @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ ( bit1 @ one2 ) ) ) ) )
    = ( divide_divide @ real @ ( one_one @ real ) @ ( sqrt @ ( numeral_numeral @ real @ ( bit1 @ one2 ) ) ) ) ) ).

% tan_30
thf(fact_3693_sqrt__even__pow2,axiom,
    ! [N2: nat] :
      ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 )
     => ( ( sqrt @ ( power_power @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ N2 ) )
        = ( power_power @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( divide_divide @ nat @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% sqrt_even_pow2
thf(fact_3694_sqrt__sum__squares__le__sum__abs,axiom,
    ! [X2: real,Y2: real] : ( ord_less_eq @ real @ ( sqrt @ ( plus_plus @ real @ ( power_power @ real @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Y2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( plus_plus @ real @ ( abs_abs @ real @ X2 ) @ ( abs_abs @ real @ Y2 ) ) ) ).

% sqrt_sum_squares_le_sum_abs
thf(fact_3695_real__sqrt__ge__abs2,axiom,
    ! [Y2: real,X2: real] : ( ord_less_eq @ real @ ( abs_abs @ real @ Y2 ) @ ( sqrt @ ( plus_plus @ real @ ( power_power @ real @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Y2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% real_sqrt_ge_abs2
thf(fact_3696_real__sqrt__ge__abs1,axiom,
    ! [X2: real,Y2: real] : ( ord_less_eq @ real @ ( abs_abs @ real @ X2 ) @ ( sqrt @ ( plus_plus @ real @ ( power_power @ real @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Y2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% real_sqrt_ge_abs1
thf(fact_3697_ln__sqrt,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( ln_ln @ real @ ( sqrt @ X2 ) )
        = ( divide_divide @ real @ ( ln_ln @ real @ X2 ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ).

% ln_sqrt
thf(fact_3698_arsinh__real__def,axiom,
    ( ( arsinh @ real )
    = ( ^ [X5: real] : ( ln_ln @ real @ ( plus_plus @ real @ X5 @ ( sqrt @ ( plus_plus @ real @ ( power_power @ real @ X5 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ real ) ) ) ) ) ) ) ).

% arsinh_real_def
thf(fact_3699_cos__30,axiom,
    ( ( cos @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ ( bit1 @ one2 ) ) ) ) )
    = ( divide_divide @ real @ ( sqrt @ ( numeral_numeral @ real @ ( bit1 @ one2 ) ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ).

% cos_30
thf(fact_3700_sin__60,axiom,
    ( ( sin @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit1 @ one2 ) ) ) )
    = ( divide_divide @ real @ ( sqrt @ ( numeral_numeral @ real @ ( bit1 @ one2 ) ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ).

% sin_60
thf(fact_3701_complex__norm,axiom,
    ! [X2: real,Y2: real] :
      ( ( real_V7770717601297561774m_norm @ complex @ ( complex2 @ X2 @ Y2 ) )
      = ( sqrt @ ( plus_plus @ real @ ( power_power @ real @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Y2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% complex_norm
thf(fact_3702_plus__inverse__ge__2,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
     => ( ord_less_eq @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( plus_plus @ real @ X2 @ ( inverse_inverse @ real @ X2 ) ) ) ) ).

% plus_inverse_ge_2
thf(fact_3703_arsinh__real__aux,axiom,
    ! [X2: real] : ( ord_less @ real @ ( zero_zero @ real ) @ ( plus_plus @ real @ X2 @ ( sqrt @ ( plus_plus @ real @ ( power_power @ real @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ real ) ) ) ) ) ).

% arsinh_real_aux
thf(fact_3704_real__sqrt__sum__squares__mult__ge__zero,axiom,
    ! [X2: real,Y2: real,Xa2: real,Ya: real] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( sqrt @ ( times_times @ real @ ( plus_plus @ real @ ( power_power @ real @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Y2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( plus_plus @ real @ ( power_power @ real @ Xa2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Ya @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% real_sqrt_sum_squares_mult_ge_zero
thf(fact_3705_real__sqrt__power__even,axiom,
    ! [N2: nat,X2: real] :
      ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X2 )
       => ( ( power_power @ real @ ( sqrt @ X2 ) @ N2 )
          = ( power_power @ real @ X2 @ ( divide_divide @ nat @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% real_sqrt_power_even
thf(fact_3706_arith__geo__mean__sqrt,axiom,
    ! [X2: real,Y2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y2 )
       => ( ord_less_eq @ real @ ( sqrt @ ( times_times @ real @ X2 @ Y2 ) ) @ ( divide_divide @ real @ ( plus_plus @ real @ X2 @ Y2 ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ).

% arith_geo_mean_sqrt
thf(fact_3707_real__le__x__sinh,axiom,
    ! [X2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X2 )
     => ( ord_less_eq @ real @ X2 @ ( divide_divide @ real @ ( minus_minus @ real @ ( exp @ real @ X2 ) @ ( inverse_inverse @ real @ ( exp @ real @ X2 ) ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ).

% real_le_x_sinh
thf(fact_3708_real__le__abs__sinh,axiom,
    ! [X2: real] : ( ord_less_eq @ real @ ( abs_abs @ real @ X2 ) @ ( abs_abs @ real @ ( divide_divide @ real @ ( minus_minus @ real @ ( exp @ real @ X2 ) @ ( inverse_inverse @ real @ ( exp @ real @ X2 ) ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ).

% real_le_abs_sinh
thf(fact_3709_tan__cot_H,axiom,
    ! [X2: real] :
      ( ( tan @ real @ ( minus_minus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ X2 ) )
      = ( cot @ real @ X2 ) ) ).

% tan_cot'
thf(fact_3710_exp__series__add__commuting,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [X2: A,Y2: A,N2: nat] :
          ( ( ( times_times @ A @ X2 @ Y2 )
            = ( times_times @ A @ Y2 @ X2 ) )
         => ( ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ ( semiring_char_0_fact @ real @ N2 ) ) @ ( power_power @ A @ ( plus_plus @ A @ X2 @ Y2 ) @ N2 ) )
            = ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [I4: nat] : ( times_times @ A @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ ( semiring_char_0_fact @ real @ I4 ) ) @ ( power_power @ A @ X2 @ I4 ) ) @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ ( semiring_char_0_fact @ real @ ( minus_minus @ nat @ N2 @ I4 ) ) ) @ ( power_power @ A @ Y2 @ ( minus_minus @ nat @ N2 @ I4 ) ) ) )
              @ ( set_ord_atMost @ nat @ N2 ) ) ) ) ) ).

% exp_series_add_commuting
thf(fact_3711_exp__first__term,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ( ( exp @ A )
        = ( ^ [X5: A] :
              ( plus_plus @ A @ ( one_one @ A )
              @ ( suminf @ A
                @ ^ [N3: nat] : ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ ( semiring_char_0_fact @ real @ ( suc @ N3 ) ) ) @ ( power_power @ A @ X5 @ ( suc @ N3 ) ) ) ) ) ) ) ) ).

% exp_first_term
thf(fact_3712_tan__sec,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X2: A] :
          ( ( ( cos @ A @ X2 )
           != ( zero_zero @ A ) )
         => ( ( plus_plus @ A @ ( one_one @ A ) @ ( power_power @ A @ ( tan @ A @ X2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
            = ( power_power @ A @ ( inverse_inverse @ A @ ( cos @ A @ X2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% tan_sec
thf(fact_3713_cos__x__y__le__one,axiom,
    ! [X2: real,Y2: real] : ( ord_less_eq @ real @ ( abs_abs @ real @ ( divide_divide @ real @ X2 @ ( sqrt @ ( plus_plus @ real @ ( power_power @ real @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Y2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) @ ( one_one @ real ) ) ).

% cos_x_y_le_one
thf(fact_3714_real__sqrt__sum__squares__less,axiom,
    ! [X2: real,U: real,Y2: real] :
      ( ( ord_less @ real @ ( abs_abs @ real @ X2 ) @ ( divide_divide @ real @ U @ ( sqrt @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) )
     => ( ( ord_less @ real @ ( abs_abs @ real @ Y2 ) @ ( divide_divide @ real @ U @ ( sqrt @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) )
       => ( ord_less @ real @ ( sqrt @ ( plus_plus @ real @ ( power_power @ real @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Y2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ U ) ) ) ).

% real_sqrt_sum_squares_less
thf(fact_3715_arcosh__real__def,axiom,
    ! [X2: real] :
      ( ( ord_less_eq @ real @ ( one_one @ real ) @ X2 )
     => ( ( arcosh @ real @ X2 )
        = ( ln_ln @ real @ ( plus_plus @ real @ X2 @ ( sqrt @ ( minus_minus @ real @ ( power_power @ real @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ real ) ) ) ) ) ) ) ).

% arcosh_real_def
thf(fact_3716_cos__arctan,axiom,
    ! [X2: real] :
      ( ( cos @ real @ ( arctan @ X2 ) )
      = ( divide_divide @ real @ ( one_one @ real ) @ ( sqrt @ ( plus_plus @ real @ ( one_one @ real ) @ ( power_power @ real @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% cos_arctan
thf(fact_3717_sin__arctan,axiom,
    ! [X2: real] :
      ( ( sin @ real @ ( arctan @ X2 ) )
      = ( divide_divide @ real @ X2 @ ( sqrt @ ( plus_plus @ real @ ( one_one @ real ) @ ( power_power @ real @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% sin_arctan
thf(fact_3718_cot__gt__zero,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( ord_less @ real @ X2 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
       => ( ord_less @ real @ ( zero_zero @ real ) @ ( cot @ real @ X2 ) ) ) ) ).

% cot_gt_zero
thf(fact_3719_sqrt__sum__squares__half__less,axiom,
    ! [X2: real,U: real,Y2: real] :
      ( ( ord_less @ real @ X2 @ ( divide_divide @ real @ U @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
     => ( ( ord_less @ real @ Y2 @ ( divide_divide @ real @ U @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
       => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X2 )
         => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y2 )
           => ( ord_less @ real @ ( sqrt @ ( plus_plus @ real @ ( power_power @ real @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Y2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ U ) ) ) ) ) ).

% sqrt_sum_squares_half_less
thf(fact_3720_exp__first__terms,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [K: nat] :
          ( ( exp @ A )
          = ( ^ [X5: A] :
                ( plus_plus @ A
                @ ( groups7311177749621191930dd_sum @ nat @ A
                  @ ^ [N3: nat] : ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ ( semiring_char_0_fact @ real @ N3 ) ) @ ( power_power @ A @ X5 @ N3 ) )
                  @ ( set_ord_lessThan @ nat @ K ) )
                @ ( suminf @ A
                  @ ^ [N3: nat] : ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ ( semiring_char_0_fact @ real @ ( plus_plus @ nat @ N3 @ K ) ) ) @ ( power_power @ A @ X5 @ ( plus_plus @ nat @ N3 @ K ) ) ) ) ) ) ) ) ).

% exp_first_terms
thf(fact_3721_sin__cos__sqrt,axiom,
    ! [X2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( sin @ real @ X2 ) )
     => ( ( sin @ real @ X2 )
        = ( sqrt @ ( minus_minus @ real @ ( one_one @ real ) @ ( power_power @ real @ ( cos @ real @ X2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% sin_cos_sqrt
thf(fact_3722_arctan__half,axiom,
    ( arctan
    = ( ^ [X5: real] : ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( arctan @ ( divide_divide @ real @ X5 @ ( plus_plus @ real @ ( one_one @ real ) @ ( sqrt @ ( plus_plus @ real @ ( one_one @ real ) @ ( power_power @ real @ X5 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ) ).

% arctan_half
thf(fact_3723_sinh__converges,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [X2: A] :
          ( sums @ A
          @ ^ [N3: nat] : ( if @ A @ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N3 ) @ ( zero_zero @ A ) @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ ( semiring_char_0_fact @ real @ N3 ) ) @ ( power_power @ A @ X2 @ N3 ) ) )
          @ ( sinh @ A @ X2 ) ) ) ).

% sinh_converges
thf(fact_3724_cos__arcsin,axiom,
    ! [X2: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ X2 )
     => ( ( ord_less_eq @ real @ X2 @ ( one_one @ real ) )
       => ( ( cos @ real @ ( arcsin @ X2 ) )
          = ( sqrt @ ( minus_minus @ real @ ( one_one @ real ) @ ( power_power @ real @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% cos_arcsin
thf(fact_3725_cosh__converges,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [X2: A] :
          ( sums @ A
          @ ^ [N3: nat] : ( if @ A @ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N3 ) @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ ( semiring_char_0_fact @ real @ N3 ) ) @ ( power_power @ A @ X2 @ N3 ) ) @ ( zero_zero @ A ) )
          @ ( cosh @ A @ X2 ) ) ) ).

% cosh_converges
thf(fact_3726_sin__arccos__abs,axiom,
    ! [Y2: real] :
      ( ( ord_less_eq @ real @ ( abs_abs @ real @ Y2 ) @ ( one_one @ real ) )
     => ( ( sin @ real @ ( arccos @ Y2 ) )
        = ( sqrt @ ( minus_minus @ real @ ( one_one @ real ) @ ( power_power @ real @ Y2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% sin_arccos_abs
thf(fact_3727_sin__arccos,axiom,
    ! [X2: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ X2 )
     => ( ( ord_less_eq @ real @ X2 @ ( one_one @ real ) )
       => ( ( sin @ real @ ( arccos @ X2 ) )
          = ( sqrt @ ( minus_minus @ real @ ( one_one @ real ) @ ( power_power @ real @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% sin_arccos
thf(fact_3728_sinh__real__zero__iff,axiom,
    ! [X2: real] :
      ( ( ( sinh @ real @ X2 )
        = ( zero_zero @ real ) )
      = ( X2
        = ( zero_zero @ real ) ) ) ).

% sinh_real_zero_iff
thf(fact_3729_sinh__real__less__iff,axiom,
    ! [X2: real,Y2: real] :
      ( ( ord_less @ real @ ( sinh @ real @ X2 ) @ ( sinh @ real @ Y2 ) )
      = ( ord_less @ real @ X2 @ Y2 ) ) ).

% sinh_real_less_iff
thf(fact_3730_sinh__real__le__iff,axiom,
    ! [X2: real,Y2: real] :
      ( ( ord_less_eq @ real @ ( sinh @ real @ X2 ) @ ( sinh @ real @ Y2 ) )
      = ( ord_less_eq @ real @ X2 @ Y2 ) ) ).

% sinh_real_le_iff
thf(fact_3731_sinh__real__pos__iff,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ ( sinh @ real @ X2 ) )
      = ( ord_less @ real @ ( zero_zero @ real ) @ X2 ) ) ).

% sinh_real_pos_iff
thf(fact_3732_sinh__real__neg__iff,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( sinh @ real @ X2 ) @ ( zero_zero @ real ) )
      = ( ord_less @ real @ X2 @ ( zero_zero @ real ) ) ) ).

% sinh_real_neg_iff
thf(fact_3733_sinh__real__nonpos__iff,axiom,
    ! [X2: real] :
      ( ( ord_less_eq @ real @ ( sinh @ real @ X2 ) @ ( zero_zero @ real ) )
      = ( ord_less_eq @ real @ X2 @ ( zero_zero @ real ) ) ) ).

% sinh_real_nonpos_iff
thf(fact_3734_sinh__real__nonneg__iff,axiom,
    ! [X2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( sinh @ real @ X2 ) )
      = ( ord_less_eq @ real @ ( zero_zero @ real ) @ X2 ) ) ).

% sinh_real_nonneg_iff
thf(fact_3735_sinh__0,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ( ( sinh @ A @ ( zero_zero @ A ) )
        = ( zero_zero @ A ) ) ) ).

% sinh_0
thf(fact_3736_arcsin__0,axiom,
    ( ( arcsin @ ( zero_zero @ real ) )
    = ( zero_zero @ real ) ) ).

% arcsin_0
thf(fact_3737_cosh__0,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ( ( cosh @ A @ ( zero_zero @ A ) )
        = ( one_one @ A ) ) ) ).

% cosh_0
thf(fact_3738_arccos__1,axiom,
    ( ( arccos @ ( one_one @ real ) )
    = ( zero_zero @ real ) ) ).

% arccos_1
thf(fact_3739_cos__arccos,axiom,
    ! [Y2: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ Y2 )
     => ( ( ord_less_eq @ real @ Y2 @ ( one_one @ real ) )
       => ( ( cos @ real @ ( arccos @ Y2 ) )
          = Y2 ) ) ) ).

% cos_arccos
thf(fact_3740_sin__arcsin,axiom,
    ! [Y2: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ Y2 )
     => ( ( ord_less_eq @ real @ Y2 @ ( one_one @ real ) )
       => ( ( sin @ real @ ( arcsin @ Y2 ) )
          = Y2 ) ) ) ).

% sin_arcsin
thf(fact_3741_arccos__0,axiom,
    ( ( arccos @ ( zero_zero @ real ) )
    = ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ).

% arccos_0
thf(fact_3742_arcsin__1,axiom,
    ( ( arcsin @ ( one_one @ real ) )
    = ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ).

% arcsin_1
thf(fact_3743_arcsin__minus__1,axiom,
    ( ( arcsin @ ( uminus_uminus @ real @ ( one_one @ real ) ) )
    = ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ).

% arcsin_minus_1
thf(fact_3744_sinh__plus__cosh,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [X2: A] :
          ( ( plus_plus @ A @ ( sinh @ A @ X2 ) @ ( cosh @ A @ X2 ) )
          = ( exp @ A @ X2 ) ) ) ).

% sinh_plus_cosh
thf(fact_3745_cosh__plus__sinh,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [X2: A] :
          ( ( plus_plus @ A @ ( cosh @ A @ X2 ) @ ( sinh @ A @ X2 ) )
          = ( exp @ A @ X2 ) ) ) ).

% cosh_plus_sinh
thf(fact_3746_divide__complex__def,axiom,
    ( ( divide_divide @ complex )
    = ( ^ [X5: complex,Y5: complex] : ( times_times @ complex @ X5 @ ( inverse_inverse @ complex @ Y5 ) ) ) ) ).

% divide_complex_def
thf(fact_3747_sinh__diff,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X2: A,Y2: A] :
          ( ( sinh @ A @ ( minus_minus @ A @ X2 @ Y2 ) )
          = ( minus_minus @ A @ ( times_times @ A @ ( sinh @ A @ X2 ) @ ( cosh @ A @ Y2 ) ) @ ( times_times @ A @ ( cosh @ A @ X2 ) @ ( sinh @ A @ Y2 ) ) ) ) ) ).

% sinh_diff
thf(fact_3748_cosh__diff,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X2: A,Y2: A] :
          ( ( cosh @ A @ ( minus_minus @ A @ X2 @ Y2 ) )
          = ( minus_minus @ A @ ( times_times @ A @ ( cosh @ A @ X2 ) @ ( cosh @ A @ Y2 ) ) @ ( times_times @ A @ ( sinh @ A @ X2 ) @ ( sinh @ A @ Y2 ) ) ) ) ) ).

% cosh_diff
thf(fact_3749_cosh__add,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X2: A,Y2: A] :
          ( ( cosh @ A @ ( plus_plus @ A @ X2 @ Y2 ) )
          = ( plus_plus @ A @ ( times_times @ A @ ( cosh @ A @ X2 ) @ ( cosh @ A @ Y2 ) ) @ ( times_times @ A @ ( sinh @ A @ X2 ) @ ( sinh @ A @ Y2 ) ) ) ) ) ).

% cosh_add
thf(fact_3750_sinh__add,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X2: A,Y2: A] :
          ( ( sinh @ A @ ( plus_plus @ A @ X2 @ Y2 ) )
          = ( plus_plus @ A @ ( times_times @ A @ ( sinh @ A @ X2 ) @ ( cosh @ A @ Y2 ) ) @ ( times_times @ A @ ( cosh @ A @ X2 ) @ ( sinh @ A @ Y2 ) ) ) ) ) ).

% sinh_add
thf(fact_3751_cosh__real__nonzero,axiom,
    ! [X2: real] :
      ( ( cosh @ real @ X2 )
     != ( zero_zero @ real ) ) ).

% cosh_real_nonzero
thf(fact_3752_sinh__less__cosh__real,axiom,
    ! [X2: real] : ( ord_less @ real @ ( sinh @ real @ X2 ) @ ( cosh @ real @ X2 ) ) ).

% sinh_less_cosh_real
thf(fact_3753_sinh__le__cosh__real,axiom,
    ! [X2: real] : ( ord_less_eq @ real @ ( sinh @ real @ X2 ) @ ( cosh @ real @ X2 ) ) ).

% sinh_le_cosh_real
thf(fact_3754_tanh__def,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ( ( tanh @ A )
        = ( ^ [X5: A] : ( divide_divide @ A @ ( sinh @ A @ X5 ) @ ( cosh @ A @ X5 ) ) ) ) ) ).

% tanh_def
thf(fact_3755_cosh__real__pos,axiom,
    ! [X2: real] : ( ord_less @ real @ ( zero_zero @ real ) @ ( cosh @ real @ X2 ) ) ).

% cosh_real_pos
thf(fact_3756_arcosh__cosh__real,axiom,
    ! [X2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( arcosh @ real @ ( cosh @ real @ X2 ) )
        = X2 ) ) ).

% arcosh_cosh_real
thf(fact_3757_cosh__real__nonpos__le__iff,axiom,
    ! [X2: real,Y2: real] :
      ( ( ord_less_eq @ real @ X2 @ ( zero_zero @ real ) )
     => ( ( ord_less_eq @ real @ Y2 @ ( zero_zero @ real ) )
       => ( ( ord_less_eq @ real @ ( cosh @ real @ X2 ) @ ( cosh @ real @ Y2 ) )
          = ( ord_less_eq @ real @ Y2 @ X2 ) ) ) ) ).

% cosh_real_nonpos_le_iff
thf(fact_3758_cosh__real__nonneg__le__iff,axiom,
    ! [X2: real,Y2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y2 )
       => ( ( ord_less_eq @ real @ ( cosh @ real @ X2 ) @ ( cosh @ real @ Y2 ) )
          = ( ord_less_eq @ real @ X2 @ Y2 ) ) ) ) ).

% cosh_real_nonneg_le_iff
thf(fact_3759_cosh__real__nonneg,axiom,
    ! [X2: real] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( cosh @ real @ X2 ) ) ).

% cosh_real_nonneg
thf(fact_3760_cosh__real__ge__1,axiom,
    ! [X2: real] : ( ord_less_eq @ real @ ( one_one @ real ) @ ( cosh @ real @ X2 ) ) ).

% cosh_real_ge_1
thf(fact_3761_sinh__double,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X2: A] :
          ( ( sinh @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ X2 ) )
          = ( times_times @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( sinh @ A @ X2 ) ) @ ( cosh @ A @ X2 ) ) ) ) ).

% sinh_double
thf(fact_3762_cosh__real__nonpos__less__iff,axiom,
    ! [X2: real,Y2: real] :
      ( ( ord_less_eq @ real @ X2 @ ( zero_zero @ real ) )
     => ( ( ord_less_eq @ real @ Y2 @ ( zero_zero @ real ) )
       => ( ( ord_less @ real @ ( cosh @ real @ X2 ) @ ( cosh @ real @ Y2 ) )
          = ( ord_less @ real @ Y2 @ X2 ) ) ) ) ).

% cosh_real_nonpos_less_iff
thf(fact_3763_cosh__real__nonneg__less__iff,axiom,
    ! [X2: real,Y2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y2 )
       => ( ( ord_less @ real @ ( cosh @ real @ X2 ) @ ( cosh @ real @ Y2 ) )
          = ( ord_less @ real @ X2 @ Y2 ) ) ) ) ).

% cosh_real_nonneg_less_iff
thf(fact_3764_cosh__real__strict__mono,axiom,
    ! [X2: real,Y2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( ord_less @ real @ X2 @ Y2 )
       => ( ord_less @ real @ ( cosh @ real @ X2 ) @ ( cosh @ real @ Y2 ) ) ) ) ).

% cosh_real_strict_mono
thf(fact_3765_cosh__square__eq,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X2: A] :
          ( ( power_power @ A @ ( cosh @ A @ X2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
          = ( plus_plus @ A @ ( power_power @ A @ ( sinh @ A @ X2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ A ) ) ) ) ).

% cosh_square_eq
thf(fact_3766_hyperbolic__pythagoras,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X2: A] :
          ( ( minus_minus @ A @ ( power_power @ A @ ( cosh @ A @ X2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ A @ ( sinh @ A @ X2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
          = ( one_one @ A ) ) ) ).

% hyperbolic_pythagoras
thf(fact_3767_sinh__square__eq,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X2: A] :
          ( ( power_power @ A @ ( sinh @ A @ X2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
          = ( minus_minus @ A @ ( power_power @ A @ ( cosh @ A @ X2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ A ) ) ) ) ).

% sinh_square_eq
thf(fact_3768_arccos__le__arccos,axiom,
    ! [X2: real,Y2: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ X2 )
     => ( ( ord_less_eq @ real @ X2 @ Y2 )
       => ( ( ord_less_eq @ real @ Y2 @ ( one_one @ real ) )
         => ( ord_less_eq @ real @ ( arccos @ Y2 ) @ ( arccos @ X2 ) ) ) ) ) ).

% arccos_le_arccos
thf(fact_3769_arccos__eq__iff,axiom,
    ! [X2: real,Y2: real] :
      ( ( ( ord_less_eq @ real @ ( abs_abs @ real @ X2 ) @ ( one_one @ real ) )
        & ( ord_less_eq @ real @ ( abs_abs @ real @ Y2 ) @ ( one_one @ real ) ) )
     => ( ( ( arccos @ X2 )
          = ( arccos @ Y2 ) )
        = ( X2 = Y2 ) ) ) ).

% arccos_eq_iff
thf(fact_3770_arccos__le__mono,axiom,
    ! [X2: real,Y2: real] :
      ( ( ord_less_eq @ real @ ( abs_abs @ real @ X2 ) @ ( one_one @ real ) )
     => ( ( ord_less_eq @ real @ ( abs_abs @ real @ Y2 ) @ ( one_one @ real ) )
       => ( ( ord_less_eq @ real @ ( arccos @ X2 ) @ ( arccos @ Y2 ) )
          = ( ord_less_eq @ real @ Y2 @ X2 ) ) ) ) ).

% arccos_le_mono
thf(fact_3771_arcsin__minus,axiom,
    ! [X2: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ X2 )
     => ( ( ord_less_eq @ real @ X2 @ ( one_one @ real ) )
       => ( ( arcsin @ ( uminus_uminus @ real @ X2 ) )
          = ( uminus_uminus @ real @ ( arcsin @ X2 ) ) ) ) ) ).

% arcsin_minus
thf(fact_3772_arcsin__le__arcsin,axiom,
    ! [X2: real,Y2: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ X2 )
     => ( ( ord_less_eq @ real @ X2 @ Y2 )
       => ( ( ord_less_eq @ real @ Y2 @ ( one_one @ real ) )
         => ( ord_less_eq @ real @ ( arcsin @ X2 ) @ ( arcsin @ Y2 ) ) ) ) ) ).

% arcsin_le_arcsin
thf(fact_3773_arcsin__eq__iff,axiom,
    ! [X2: real,Y2: real] :
      ( ( ord_less_eq @ real @ ( abs_abs @ real @ X2 ) @ ( one_one @ real ) )
     => ( ( ord_less_eq @ real @ ( abs_abs @ real @ Y2 ) @ ( one_one @ real ) )
       => ( ( ( arcsin @ X2 )
            = ( arcsin @ Y2 ) )
          = ( X2 = Y2 ) ) ) ) ).

% arcsin_eq_iff
thf(fact_3774_arcsin__le__mono,axiom,
    ! [X2: real,Y2: real] :
      ( ( ord_less_eq @ real @ ( abs_abs @ real @ X2 ) @ ( one_one @ real ) )
     => ( ( ord_less_eq @ real @ ( abs_abs @ real @ Y2 ) @ ( one_one @ real ) )
       => ( ( ord_less_eq @ real @ ( arcsin @ X2 ) @ ( arcsin @ Y2 ) )
          = ( ord_less_eq @ real @ X2 @ Y2 ) ) ) ) ).

% arcsin_le_mono
thf(fact_3775_cosh__double,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X2: A] :
          ( ( cosh @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ X2 ) )
          = ( plus_plus @ A @ ( power_power @ A @ ( cosh @ A @ X2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ A @ ( sinh @ A @ X2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% cosh_double
thf(fact_3776_arccos__lbound,axiom,
    ! [Y2: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ Y2 )
     => ( ( ord_less_eq @ real @ Y2 @ ( one_one @ real ) )
       => ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( arccos @ Y2 ) ) ) ) ).

% arccos_lbound
thf(fact_3777_arccos__less__arccos,axiom,
    ! [X2: real,Y2: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ X2 )
     => ( ( ord_less @ real @ X2 @ Y2 )
       => ( ( ord_less_eq @ real @ Y2 @ ( one_one @ real ) )
         => ( ord_less @ real @ ( arccos @ Y2 ) @ ( arccos @ X2 ) ) ) ) ) ).

% arccos_less_arccos
thf(fact_3778_arccos__less__mono,axiom,
    ! [X2: real,Y2: real] :
      ( ( ord_less_eq @ real @ ( abs_abs @ real @ X2 ) @ ( one_one @ real ) )
     => ( ( ord_less_eq @ real @ ( abs_abs @ real @ Y2 ) @ ( one_one @ real ) )
       => ( ( ord_less @ real @ ( arccos @ X2 ) @ ( arccos @ Y2 ) )
          = ( ord_less @ real @ Y2 @ X2 ) ) ) ) ).

% arccos_less_mono
thf(fact_3779_arccos__ubound,axiom,
    ! [Y2: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ Y2 )
     => ( ( ord_less_eq @ real @ Y2 @ ( one_one @ real ) )
       => ( ord_less_eq @ real @ ( arccos @ Y2 ) @ pi ) ) ) ).

% arccos_ubound
thf(fact_3780_arccos__cos,axiom,
    ! [X2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( ord_less_eq @ real @ X2 @ pi )
       => ( ( arccos @ ( cos @ real @ X2 ) )
          = X2 ) ) ) ).

% arccos_cos
thf(fact_3781_arcsin__less__arcsin,axiom,
    ! [X2: real,Y2: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ X2 )
     => ( ( ord_less @ real @ X2 @ Y2 )
       => ( ( ord_less_eq @ real @ Y2 @ ( one_one @ real ) )
         => ( ord_less @ real @ ( arcsin @ X2 ) @ ( arcsin @ Y2 ) ) ) ) ) ).

% arcsin_less_arcsin
thf(fact_3782_arcsin__less__mono,axiom,
    ! [X2: real,Y2: real] :
      ( ( ord_less_eq @ real @ ( abs_abs @ real @ X2 ) @ ( one_one @ real ) )
     => ( ( ord_less_eq @ real @ ( abs_abs @ real @ Y2 ) @ ( one_one @ real ) )
       => ( ( ord_less @ real @ ( arcsin @ X2 ) @ ( arcsin @ Y2 ) )
          = ( ord_less @ real @ X2 @ Y2 ) ) ) ) ).

% arcsin_less_mono
thf(fact_3783_cos__arccos__abs,axiom,
    ! [Y2: real] :
      ( ( ord_less_eq @ real @ ( abs_abs @ real @ Y2 ) @ ( one_one @ real ) )
     => ( ( cos @ real @ ( arccos @ Y2 ) )
        = Y2 ) ) ).

% cos_arccos_abs
thf(fact_3784_arccos__cos__eq__abs,axiom,
    ! [Theta: real] :
      ( ( ord_less_eq @ real @ ( abs_abs @ real @ Theta ) @ pi )
     => ( ( arccos @ ( cos @ real @ Theta ) )
        = ( abs_abs @ real @ Theta ) ) ) ).

% arccos_cos_eq_abs
thf(fact_3785_arccos__lt__bounded,axiom,
    ! [Y2: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ Y2 )
     => ( ( ord_less @ real @ Y2 @ ( one_one @ real ) )
       => ( ( ord_less @ real @ ( zero_zero @ real ) @ ( arccos @ Y2 ) )
          & ( ord_less @ real @ ( arccos @ Y2 ) @ pi ) ) ) ) ).

% arccos_lt_bounded
thf(fact_3786_arccos__bounded,axiom,
    ! [Y2: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ Y2 )
     => ( ( ord_less_eq @ real @ Y2 @ ( one_one @ real ) )
       => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( arccos @ Y2 ) )
          & ( ord_less_eq @ real @ ( arccos @ Y2 ) @ pi ) ) ) ) ).

% arccos_bounded
thf(fact_3787_sin__arccos__nonzero,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ X2 )
     => ( ( ord_less @ real @ X2 @ ( one_one @ real ) )
       => ( ( sin @ real @ ( arccos @ X2 ) )
         != ( zero_zero @ real ) ) ) ) ).

% sin_arccos_nonzero
thf(fact_3788_arccos__cos2,axiom,
    ! [X2: real] :
      ( ( ord_less_eq @ real @ X2 @ ( zero_zero @ real ) )
     => ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ pi ) @ X2 )
       => ( ( arccos @ ( cos @ real @ X2 ) )
          = ( uminus_uminus @ real @ X2 ) ) ) ) ).

% arccos_cos2
thf(fact_3789_arccos__minus,axiom,
    ! [X2: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ X2 )
     => ( ( ord_less_eq @ real @ X2 @ ( one_one @ real ) )
       => ( ( arccos @ ( uminus_uminus @ real @ X2 ) )
          = ( minus_minus @ real @ pi @ ( arccos @ X2 ) ) ) ) ) ).

% arccos_minus
thf(fact_3790_cos__arcsin__nonzero,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ X2 )
     => ( ( ord_less @ real @ X2 @ ( one_one @ real ) )
       => ( ( cos @ real @ ( arcsin @ X2 ) )
         != ( zero_zero @ real ) ) ) ) ).

% cos_arcsin_nonzero
thf(fact_3791_tanh__add,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X2: A,Y2: A] :
          ( ( ( cosh @ A @ X2 )
           != ( zero_zero @ A ) )
         => ( ( ( cosh @ A @ Y2 )
             != ( zero_zero @ A ) )
           => ( ( tanh @ A @ ( plus_plus @ A @ X2 @ Y2 ) )
              = ( divide_divide @ A @ ( plus_plus @ A @ ( tanh @ A @ X2 ) @ ( tanh @ A @ Y2 ) ) @ ( plus_plus @ A @ ( one_one @ A ) @ ( times_times @ A @ ( tanh @ A @ X2 ) @ ( tanh @ A @ Y2 ) ) ) ) ) ) ) ) ).

% tanh_add
thf(fact_3792_arccos,axiom,
    ! [Y2: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ Y2 )
     => ( ( ord_less_eq @ real @ Y2 @ ( one_one @ real ) )
       => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( arccos @ Y2 ) )
          & ( ord_less_eq @ real @ ( arccos @ Y2 ) @ pi )
          & ( ( cos @ real @ ( arccos @ Y2 ) )
            = Y2 ) ) ) ) ).

% arccos
thf(fact_3793_arccos__minus__abs,axiom,
    ! [X2: real] :
      ( ( ord_less_eq @ real @ ( abs_abs @ real @ X2 ) @ ( one_one @ real ) )
     => ( ( arccos @ ( uminus_uminus @ real @ X2 ) )
        = ( minus_minus @ real @ pi @ ( arccos @ X2 ) ) ) ) ).

% arccos_minus_abs
thf(fact_3794_cosh__field__def,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ( ( cosh @ A )
        = ( ^ [Z6: A] : ( divide_divide @ A @ ( plus_plus @ A @ ( exp @ A @ Z6 ) @ ( exp @ A @ ( uminus_uminus @ A @ Z6 ) ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ).

% cosh_field_def
thf(fact_3795_complex__inverse,axiom,
    ! [A2: real,B2: real] :
      ( ( inverse_inverse @ complex @ ( complex2 @ A2 @ B2 ) )
      = ( complex2 @ ( divide_divide @ real @ A2 @ ( plus_plus @ real @ ( power_power @ real @ A2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ B2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( divide_divide @ real @ ( uminus_uminus @ real @ B2 ) @ ( plus_plus @ real @ ( power_power @ real @ A2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ B2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% complex_inverse
thf(fact_3796_sinh__field__def,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ( ( sinh @ A )
        = ( ^ [Z6: A] : ( divide_divide @ A @ ( minus_minus @ A @ ( exp @ A @ Z6 ) @ ( exp @ A @ ( uminus_uminus @ A @ Z6 ) ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ).

% sinh_field_def
thf(fact_3797_cosh__zero__iff,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X2: A] :
          ( ( ( cosh @ A @ X2 )
            = ( zero_zero @ A ) )
          = ( ( power_power @ A @ ( exp @ A @ X2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
            = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ) ).

% cosh_zero_iff
thf(fact_3798_cosh__def,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ( ( cosh @ A )
        = ( ^ [X5: A] : ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( plus_plus @ A @ ( exp @ A @ X5 ) @ ( exp @ A @ ( uminus_uminus @ A @ X5 ) ) ) ) ) ) ) ).

% cosh_def
thf(fact_3799_arccos__le__pi2,axiom,
    ! [Y2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y2 )
     => ( ( ord_less_eq @ real @ Y2 @ ( one_one @ real ) )
       => ( ord_less_eq @ real @ ( arccos @ Y2 ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ).

% arccos_le_pi2
thf(fact_3800_cosh__ln__real,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( cosh @ real @ ( ln_ln @ real @ X2 ) )
        = ( divide_divide @ real @ ( plus_plus @ real @ X2 @ ( inverse_inverse @ real @ X2 ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ).

% cosh_ln_real
thf(fact_3801_arcsin__lt__bounded,axiom,
    ! [Y2: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ Y2 )
     => ( ( ord_less @ real @ Y2 @ ( one_one @ real ) )
       => ( ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ ( arcsin @ Y2 ) )
          & ( ord_less @ real @ ( arcsin @ Y2 ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% arcsin_lt_bounded
thf(fact_3802_arcsin__lbound,axiom,
    ! [Y2: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ Y2 )
     => ( ( ord_less_eq @ real @ Y2 @ ( one_one @ real ) )
       => ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ ( arcsin @ Y2 ) ) ) ) ).

% arcsin_lbound
thf(fact_3803_arcsin__ubound,axiom,
    ! [Y2: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ Y2 )
     => ( ( ord_less_eq @ real @ Y2 @ ( one_one @ real ) )
       => ( ord_less_eq @ real @ ( arcsin @ Y2 ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ).

% arcsin_ubound
thf(fact_3804_arcsin__bounded,axiom,
    ! [Y2: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ Y2 )
     => ( ( ord_less_eq @ real @ Y2 @ ( one_one @ real ) )
       => ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ ( arcsin @ Y2 ) )
          & ( ord_less_eq @ real @ ( arcsin @ Y2 ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% arcsin_bounded
thf(fact_3805_arcsin__sin,axiom,
    ! [X2: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ X2 )
     => ( ( ord_less_eq @ real @ X2 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
       => ( ( arcsin @ ( sin @ real @ X2 ) )
          = X2 ) ) ) ).

% arcsin_sin
thf(fact_3806_sinh__def,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ( ( sinh @ A )
        = ( ^ [X5: A] : ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( minus_minus @ A @ ( exp @ A @ X5 ) @ ( exp @ A @ ( uminus_uminus @ A @ X5 ) ) ) ) ) ) ) ).

% sinh_def
thf(fact_3807_sinh__ln__real,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( sinh @ real @ ( ln_ln @ real @ X2 ) )
        = ( divide_divide @ real @ ( minus_minus @ real @ X2 @ ( inverse_inverse @ real @ X2 ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ).

% sinh_ln_real
thf(fact_3808_arcsin,axiom,
    ! [Y2: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ Y2 )
     => ( ( ord_less_eq @ real @ Y2 @ ( one_one @ real ) )
       => ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ ( arcsin @ Y2 ) )
          & ( ord_less_eq @ real @ ( arcsin @ Y2 ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
          & ( ( sin @ real @ ( arcsin @ Y2 ) )
            = Y2 ) ) ) ) ).

% arcsin
thf(fact_3809_arcsin__pi,axiom,
    ! [Y2: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ Y2 )
     => ( ( ord_less_eq @ real @ Y2 @ ( one_one @ real ) )
       => ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ ( arcsin @ Y2 ) )
          & ( ord_less_eq @ real @ ( arcsin @ Y2 ) @ pi )
          & ( ( sin @ real @ ( arcsin @ Y2 ) )
            = Y2 ) ) ) ) ).

% arcsin_pi
thf(fact_3810_arcsin__le__iff,axiom,
    ! [X2: real,Y2: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ X2 )
     => ( ( ord_less_eq @ real @ X2 @ ( one_one @ real ) )
       => ( ( ord_less_eq @ real @ ( divide_divide @ real @ ( uminus_uminus @ real @ pi ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ Y2 )
         => ( ( ord_less_eq @ real @ Y2 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
           => ( ( ord_less_eq @ real @ ( arcsin @ X2 ) @ Y2 )
              = ( ord_less_eq @ real @ X2 @ ( sin @ real @ Y2 ) ) ) ) ) ) ) ).

% arcsin_le_iff
thf(fact_3811_le__arcsin__iff,axiom,
    ! [X2: real,Y2: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ X2 )
     => ( ( ord_less_eq @ real @ X2 @ ( one_one @ real ) )
       => ( ( ord_less_eq @ real @ ( divide_divide @ real @ ( uminus_uminus @ real @ pi ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ Y2 )
         => ( ( ord_less_eq @ real @ Y2 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
           => ( ( ord_less_eq @ real @ Y2 @ ( arcsin @ X2 ) )
              = ( ord_less_eq @ real @ ( sin @ real @ Y2 ) @ X2 ) ) ) ) ) ) ).

% le_arcsin_iff
thf(fact_3812_arccos__cos__eq__abs__2pi,axiom,
    ! [Theta: real] :
      ~ ! [K2: int] :
          ( ( arccos @ ( cos @ real @ Theta ) )
         != ( abs_abs @ real @ ( minus_minus @ real @ Theta @ ( times_times @ real @ ( ring_1_of_int @ real @ K2 ) @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) ) ) ) ) ).

% arccos_cos_eq_abs_2pi
thf(fact_3813_i__even__power,axiom,
    ! [N2: nat] :
      ( ( power_power @ complex @ imaginary_unit @ ( times_times @ nat @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
      = ( power_power @ complex @ ( uminus_uminus @ complex @ ( one_one @ complex ) ) @ N2 ) ) ).

% i_even_power
thf(fact_3814_log__base__10__eq1,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( log @ ( numeral_numeral @ real @ ( bit0 @ ( bit1 @ ( bit0 @ one2 ) ) ) ) @ X2 )
        = ( times_times @ real @ ( divide_divide @ real @ ( ln_ln @ real @ ( exp @ real @ ( one_one @ real ) ) ) @ ( ln_ln @ real @ ( numeral_numeral @ real @ ( bit0 @ ( bit1 @ ( bit0 @ one2 ) ) ) ) ) ) @ ( ln_ln @ real @ X2 ) ) ) ) ).

% log_base_10_eq1
thf(fact_3815_arctan__def,axiom,
    ( arctan
    = ( ^ [Y5: real] :
          ( the @ real
          @ ^ [X5: real] :
              ( ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ X5 )
              & ( ord_less @ real @ X5 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
              & ( ( tan @ real @ X5 )
                = Y5 ) ) ) ) ) ).

% arctan_def
thf(fact_3816_arcsin__def,axiom,
    ( arcsin
    = ( ^ [Y5: real] :
          ( the @ real
          @ ^ [X5: real] :
              ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ X5 )
              & ( ord_less_eq @ real @ X5 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
              & ( ( sin @ real @ X5 )
                = Y5 ) ) ) ) ) ).

% arcsin_def
thf(fact_3817_log__one,axiom,
    ! [A2: real] :
      ( ( log @ A2 @ ( one_one @ real ) )
      = ( zero_zero @ real ) ) ).

% log_one
thf(fact_3818_complex__i__mult__minus,axiom,
    ! [X2: complex] :
      ( ( times_times @ complex @ imaginary_unit @ ( times_times @ complex @ imaginary_unit @ X2 ) )
      = ( uminus_uminus @ complex @ X2 ) ) ).

% complex_i_mult_minus
thf(fact_3819_zero__less__log__cancel__iff,axiom,
    ! [A2: real,X2: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ A2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
       => ( ( ord_less @ real @ ( zero_zero @ real ) @ ( log @ A2 @ X2 ) )
          = ( ord_less @ real @ ( one_one @ real ) @ X2 ) ) ) ) ).

% zero_less_log_cancel_iff
thf(fact_3820_log__less__zero__cancel__iff,axiom,
    ! [A2: real,X2: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ A2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
       => ( ( ord_less @ real @ ( log @ A2 @ X2 ) @ ( zero_zero @ real ) )
          = ( ord_less @ real @ X2 @ ( one_one @ real ) ) ) ) ) ).

% log_less_zero_cancel_iff
thf(fact_3821_one__less__log__cancel__iff,axiom,
    ! [A2: real,X2: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ A2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
       => ( ( ord_less @ real @ ( one_one @ real ) @ ( log @ A2 @ X2 ) )
          = ( ord_less @ real @ A2 @ X2 ) ) ) ) ).

% one_less_log_cancel_iff
thf(fact_3822_log__less__one__cancel__iff,axiom,
    ! [A2: real,X2: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ A2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
       => ( ( ord_less @ real @ ( log @ A2 @ X2 ) @ ( one_one @ real ) )
          = ( ord_less @ real @ X2 @ A2 ) ) ) ) ).

% log_less_one_cancel_iff
thf(fact_3823_log__less__cancel__iff,axiom,
    ! [A2: real,X2: real,Y2: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ A2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
       => ( ( ord_less @ real @ ( zero_zero @ real ) @ Y2 )
         => ( ( ord_less @ real @ ( log @ A2 @ X2 ) @ ( log @ A2 @ Y2 ) )
            = ( ord_less @ real @ X2 @ Y2 ) ) ) ) ) ).

% log_less_cancel_iff
thf(fact_3824_log__eq__one,axiom,
    ! [A2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
     => ( ( A2
         != ( one_one @ real ) )
       => ( ( log @ A2 @ A2 )
          = ( one_one @ real ) ) ) ) ).

% log_eq_one
thf(fact_3825_divide__i,axiom,
    ! [X2: complex] :
      ( ( divide_divide @ complex @ X2 @ imaginary_unit )
      = ( times_times @ complex @ ( uminus_uminus @ complex @ imaginary_unit ) @ X2 ) ) ).

% divide_i
thf(fact_3826_i__squared,axiom,
    ( ( times_times @ complex @ imaginary_unit @ imaginary_unit )
    = ( uminus_uminus @ complex @ ( one_one @ complex ) ) ) ).

% i_squared
thf(fact_3827_zero__le__log__cancel__iff,axiom,
    ! [A2: real,X2: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ A2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
       => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( log @ A2 @ X2 ) )
          = ( ord_less_eq @ real @ ( one_one @ real ) @ X2 ) ) ) ) ).

% zero_le_log_cancel_iff
thf(fact_3828_log__le__zero__cancel__iff,axiom,
    ! [A2: real,X2: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ A2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
       => ( ( ord_less_eq @ real @ ( log @ A2 @ X2 ) @ ( zero_zero @ real ) )
          = ( ord_less_eq @ real @ X2 @ ( one_one @ real ) ) ) ) ) ).

% log_le_zero_cancel_iff
thf(fact_3829_one__le__log__cancel__iff,axiom,
    ! [A2: real,X2: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ A2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
       => ( ( ord_less_eq @ real @ ( one_one @ real ) @ ( log @ A2 @ X2 ) )
          = ( ord_less_eq @ real @ A2 @ X2 ) ) ) ) ).

% one_le_log_cancel_iff
thf(fact_3830_log__le__one__cancel__iff,axiom,
    ! [A2: real,X2: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ A2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
       => ( ( ord_less_eq @ real @ ( log @ A2 @ X2 ) @ ( one_one @ real ) )
          = ( ord_less_eq @ real @ X2 @ A2 ) ) ) ) ).

% log_le_one_cancel_iff
thf(fact_3831_log__le__cancel__iff,axiom,
    ! [A2: real,X2: real,Y2: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ A2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
       => ( ( ord_less @ real @ ( zero_zero @ real ) @ Y2 )
         => ( ( ord_less_eq @ real @ ( log @ A2 @ X2 ) @ ( log @ A2 @ Y2 ) )
            = ( ord_less_eq @ real @ X2 @ Y2 ) ) ) ) ) ).

% log_le_cancel_iff
thf(fact_3832_divide__numeral__i,axiom,
    ! [Z: complex,N2: num] :
      ( ( divide_divide @ complex @ Z @ ( times_times @ complex @ ( numeral_numeral @ complex @ N2 ) @ imaginary_unit ) )
      = ( divide_divide @ complex @ ( uminus_uminus @ complex @ ( times_times @ complex @ imaginary_unit @ Z ) ) @ ( numeral_numeral @ complex @ N2 ) ) ) ).

% divide_numeral_i
thf(fact_3833_log__pow__cancel,axiom,
    ! [A2: real,B2: nat] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
     => ( ( A2
         != ( one_one @ real ) )
       => ( ( log @ A2 @ ( power_power @ real @ A2 @ B2 ) )
          = ( semiring_1_of_nat @ real @ B2 ) ) ) ) ).

% log_pow_cancel
thf(fact_3834_power2__i,axiom,
    ( ( power_power @ complex @ imaginary_unit @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
    = ( uminus_uminus @ complex @ ( one_one @ complex ) ) ) ).

% power2_i
thf(fact_3835_complex__i__not__zero,axiom,
    imaginary_unit
 != ( zero_zero @ complex ) ).

% complex_i_not_zero
thf(fact_3836_complex__i__not__numeral,axiom,
    ! [W: num] :
      ( imaginary_unit
     != ( numeral_numeral @ complex @ W ) ) ).

% complex_i_not_numeral
thf(fact_3837_log__def,axiom,
    ( log
    = ( ^ [A4: real,X5: real] : ( divide_divide @ real @ ( ln_ln @ real @ X5 ) @ ( ln_ln @ real @ A4 ) ) ) ) ).

% log_def
thf(fact_3838_i__times__eq__iff,axiom,
    ! [W: complex,Z: complex] :
      ( ( ( times_times @ complex @ imaginary_unit @ W )
        = Z )
      = ( W
        = ( uminus_uminus @ complex @ ( times_times @ complex @ imaginary_unit @ Z ) ) ) ) ).

% i_times_eq_iff
thf(fact_3839_complex__i__not__neg__numeral,axiom,
    ! [W: num] :
      ( imaginary_unit
     != ( uminus_uminus @ complex @ ( numeral_numeral @ complex @ W ) ) ) ).

% complex_i_not_neg_numeral
thf(fact_3840_Complex__eq__i,axiom,
    ! [X2: real,Y2: real] :
      ( ( ( complex2 @ X2 @ Y2 )
        = imaginary_unit )
      = ( ( X2
          = ( zero_zero @ real ) )
        & ( Y2
          = ( one_one @ real ) ) ) ) ).

% Complex_eq_i
thf(fact_3841_imaginary__unit_Ocode,axiom,
    ( imaginary_unit
    = ( complex2 @ ( zero_zero @ real ) @ ( one_one @ real ) ) ) ).

% imaginary_unit.code
thf(fact_3842_ln__neg__is__const,axiom,
    ! [X2: real] :
      ( ( ord_less_eq @ real @ X2 @ ( zero_zero @ real ) )
     => ( ( ln_ln @ real @ X2 )
        = ( the @ real
          @ ^ [X5: real] : $false ) ) ) ).

% ln_neg_is_const
thf(fact_3843_i__mult__Complex,axiom,
    ! [A2: real,B2: real] :
      ( ( times_times @ complex @ imaginary_unit @ ( complex2 @ A2 @ B2 ) )
      = ( complex2 @ ( uminus_uminus @ real @ B2 ) @ A2 ) ) ).

% i_mult_Complex
thf(fact_3844_Complex__mult__i,axiom,
    ! [A2: real,B2: real] :
      ( ( times_times @ complex @ ( complex2 @ A2 @ B2 ) @ imaginary_unit )
      = ( complex2 @ ( uminus_uminus @ real @ B2 ) @ A2 ) ) ).

% Complex_mult_i
thf(fact_3845_log__base__change,axiom,
    ! [A2: real,B2: real,X2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
     => ( ( A2
         != ( one_one @ real ) )
       => ( ( log @ B2 @ X2 )
          = ( divide_divide @ real @ ( log @ A2 @ X2 ) @ ( log @ A2 @ B2 ) ) ) ) ) ).

% log_base_change
thf(fact_3846_less__log__of__power,axiom,
    ! [B2: real,N2: nat,M: real] :
      ( ( ord_less @ real @ ( power_power @ real @ B2 @ N2 ) @ M )
     => ( ( ord_less @ real @ ( one_one @ real ) @ B2 )
       => ( ord_less @ real @ ( semiring_1_of_nat @ real @ N2 ) @ ( log @ B2 @ M ) ) ) ) ).

% less_log_of_power
thf(fact_3847_log__of__power__eq,axiom,
    ! [M: nat,B2: real,N2: nat] :
      ( ( ( semiring_1_of_nat @ real @ M )
        = ( power_power @ real @ B2 @ N2 ) )
     => ( ( ord_less @ real @ ( one_one @ real ) @ B2 )
       => ( ( semiring_1_of_nat @ real @ N2 )
          = ( log @ B2 @ ( semiring_1_of_nat @ real @ M ) ) ) ) ) ).

% log_of_power_eq
thf(fact_3848_log__mult,axiom,
    ! [A2: real,X2: real,Y2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
     => ( ( A2
         != ( one_one @ real ) )
       => ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
         => ( ( ord_less @ real @ ( zero_zero @ real ) @ Y2 )
           => ( ( log @ A2 @ ( times_times @ real @ X2 @ Y2 ) )
              = ( plus_plus @ real @ ( log @ A2 @ X2 ) @ ( log @ A2 @ Y2 ) ) ) ) ) ) ) ).

% log_mult
thf(fact_3849_log__divide,axiom,
    ! [A2: real,X2: real,Y2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
     => ( ( A2
         != ( one_one @ real ) )
       => ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
         => ( ( ord_less @ real @ ( zero_zero @ real ) @ Y2 )
           => ( ( log @ A2 @ ( divide_divide @ real @ X2 @ Y2 ) )
              = ( minus_minus @ real @ ( log @ A2 @ X2 ) @ ( log @ A2 @ Y2 ) ) ) ) ) ) ) ).

% log_divide
thf(fact_3850_le__log__of__power,axiom,
    ! [B2: real,N2: nat,M: real] :
      ( ( ord_less_eq @ real @ ( power_power @ real @ B2 @ N2 ) @ M )
     => ( ( ord_less @ real @ ( one_one @ real ) @ B2 )
       => ( ord_less_eq @ real @ ( semiring_1_of_nat @ real @ N2 ) @ ( log @ B2 @ M ) ) ) ) ).

% le_log_of_power
thf(fact_3851_log__base__pow,axiom,
    ! [A2: real,N2: nat,X2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
     => ( ( log @ ( power_power @ real @ A2 @ N2 ) @ X2 )
        = ( divide_divide @ real @ ( log @ A2 @ X2 ) @ ( semiring_1_of_nat @ real @ N2 ) ) ) ) ).

% log_base_pow
thf(fact_3852_log__nat__power,axiom,
    ! [X2: real,B2: real,N2: nat] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( log @ B2 @ ( power_power @ real @ X2 @ N2 ) )
        = ( times_times @ real @ ( semiring_1_of_nat @ real @ N2 ) @ ( log @ B2 @ X2 ) ) ) ) ).

% log_nat_power
thf(fact_3853_log__inverse,axiom,
    ! [A2: real,X2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
     => ( ( A2
         != ( one_one @ real ) )
       => ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
         => ( ( log @ A2 @ ( inverse_inverse @ real @ X2 ) )
            = ( uminus_uminus @ real @ ( log @ A2 @ X2 ) ) ) ) ) ) ).

% log_inverse
thf(fact_3854_log2__of__power__eq,axiom,
    ! [M: nat,N2: nat] :
      ( ( M
        = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) )
     => ( ( semiring_1_of_nat @ real @ N2 )
        = ( log @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( semiring_1_of_nat @ real @ M ) ) ) ) ).

% log2_of_power_eq
thf(fact_3855_log__of__power__less,axiom,
    ! [M: nat,B2: real,N2: nat] :
      ( ( ord_less @ real @ ( semiring_1_of_nat @ real @ M ) @ ( power_power @ real @ B2 @ N2 ) )
     => ( ( ord_less @ real @ ( one_one @ real ) @ B2 )
       => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M )
         => ( ord_less @ real @ ( log @ B2 @ ( semiring_1_of_nat @ real @ M ) ) @ ( semiring_1_of_nat @ real @ N2 ) ) ) ) ) ).

% log_of_power_less
thf(fact_3856_log__eq__div__ln__mult__log,axiom,
    ! [A2: real,B2: real,X2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
     => ( ( A2
         != ( one_one @ real ) )
       => ( ( ord_less @ real @ ( zero_zero @ real ) @ B2 )
         => ( ( B2
             != ( one_one @ real ) )
           => ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
             => ( ( log @ A2 @ X2 )
                = ( times_times @ real @ ( divide_divide @ real @ ( ln_ln @ real @ B2 ) @ ( ln_ln @ real @ A2 ) ) @ ( log @ B2 @ X2 ) ) ) ) ) ) ) ) ).

% log_eq_div_ln_mult_log
thf(fact_3857_arccos__def,axiom,
    ( arccos
    = ( ^ [Y5: real] :
          ( the @ real
          @ ^ [X5: real] :
              ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X5 )
              & ( ord_less_eq @ real @ X5 @ pi )
              & ( ( cos @ real @ X5 )
                = Y5 ) ) ) ) ) ).

% arccos_def
thf(fact_3858_log__of__power__le,axiom,
    ! [M: nat,B2: real,N2: nat] :
      ( ( ord_less_eq @ real @ ( semiring_1_of_nat @ real @ M ) @ ( power_power @ real @ B2 @ N2 ) )
     => ( ( ord_less @ real @ ( one_one @ real ) @ B2 )
       => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M )
         => ( ord_less_eq @ real @ ( log @ B2 @ ( semiring_1_of_nat @ real @ M ) ) @ ( semiring_1_of_nat @ real @ N2 ) ) ) ) ) ).

% log_of_power_le
thf(fact_3859_less__log2__of__power,axiom,
    ! [N2: nat,M: nat] :
      ( ( ord_less @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) @ M )
     => ( ord_less @ real @ ( semiring_1_of_nat @ real @ N2 ) @ ( log @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( semiring_1_of_nat @ real @ M ) ) ) ) ).

% less_log2_of_power
thf(fact_3860_le__log2__of__power,axiom,
    ! [N2: nat,M: nat] :
      ( ( ord_less_eq @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) @ M )
     => ( ord_less_eq @ real @ ( semiring_1_of_nat @ real @ N2 ) @ ( log @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( semiring_1_of_nat @ real @ M ) ) ) ) ).

% le_log2_of_power
thf(fact_3861_log2__of__power__less,axiom,
    ! [M: nat,N2: nat] :
      ( ( ord_less @ nat @ M @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M )
       => ( ord_less @ real @ ( log @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( semiring_1_of_nat @ real @ M ) ) @ ( semiring_1_of_nat @ real @ N2 ) ) ) ) ).

% log2_of_power_less
thf(fact_3862_pi__half,axiom,
    ( ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) )
    = ( the @ real
      @ ^ [X5: real] :
          ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X5 )
          & ( ord_less_eq @ real @ X5 @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) )
          & ( ( cos @ real @ X5 )
            = ( zero_zero @ real ) ) ) ) ) ).

% pi_half
thf(fact_3863_pi__def,axiom,
    ( pi
    = ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) )
      @ ( the @ real
        @ ^ [X5: real] :
            ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X5 )
            & ( ord_less_eq @ real @ X5 @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) )
            & ( ( cos @ real @ X5 )
              = ( zero_zero @ real ) ) ) ) ) ) ).

% pi_def
thf(fact_3864_log2__of__power__le,axiom,
    ! [M: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ M @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M )
       => ( ord_less_eq @ real @ ( log @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( semiring_1_of_nat @ real @ M ) ) @ ( semiring_1_of_nat @ real @ N2 ) ) ) ) ).

% log2_of_power_le
thf(fact_3865_log__base__10__eq2,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( log @ ( numeral_numeral @ real @ ( bit0 @ ( bit1 @ ( bit0 @ one2 ) ) ) ) @ X2 )
        = ( times_times @ real @ ( log @ ( numeral_numeral @ real @ ( bit0 @ ( bit1 @ ( bit0 @ one2 ) ) ) ) @ ( exp @ real @ ( one_one @ real ) ) ) @ ( ln_ln @ real @ X2 ) ) ) ) ).

% log_base_10_eq2
thf(fact_3866_Arg__minus__ii,axiom,
    ( ( arg @ ( uminus_uminus @ complex @ imaginary_unit ) )
    = ( divide_divide @ real @ ( uminus_uminus @ real @ pi ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ).

% Arg_minus_ii
thf(fact_3867_ceiling__log__nat__eq__powr__iff,axiom,
    ! [B2: nat,K: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ B2 )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
       => ( ( ( archimedean_ceiling @ real @ ( log @ ( semiring_1_of_nat @ real @ B2 ) @ ( semiring_1_of_nat @ real @ K ) ) )
            = ( plus_plus @ int @ ( semiring_1_of_nat @ int @ N2 ) @ ( one_one @ int ) ) )
          = ( ( ord_less @ nat @ ( power_power @ nat @ B2 @ N2 ) @ K )
            & ( ord_less_eq @ nat @ K @ ( power_power @ nat @ B2 @ ( plus_plus @ nat @ N2 @ ( one_one @ nat ) ) ) ) ) ) ) ) ).

% ceiling_log_nat_eq_powr_iff
thf(fact_3868_Arg__ii,axiom,
    ( ( arg @ imaginary_unit )
    = ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ).

% Arg_ii
thf(fact_3869_ceiling__log__nat__eq__if,axiom,
    ! [B2: nat,N2: nat,K: nat] :
      ( ( ord_less @ nat @ ( power_power @ nat @ B2 @ N2 ) @ K )
     => ( ( ord_less_eq @ nat @ K @ ( power_power @ nat @ B2 @ ( plus_plus @ nat @ N2 @ ( one_one @ nat ) ) ) )
       => ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ B2 )
         => ( ( archimedean_ceiling @ real @ ( log @ ( semiring_1_of_nat @ real @ B2 ) @ ( semiring_1_of_nat @ real @ K ) ) )
            = ( plus_plus @ int @ ( semiring_1_of_nat @ int @ N2 ) @ ( one_one @ int ) ) ) ) ) ) ).

% ceiling_log_nat_eq_if
thf(fact_3870_of__int__ceiling__cancel,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A] :
          ( ( ( ring_1_of_int @ A @ ( archimedean_ceiling @ A @ X2 ) )
            = X2 )
          = ( ? [N3: int] :
                ( X2
                = ( ring_1_of_int @ A @ N3 ) ) ) ) ) ).

% of_int_ceiling_cancel
thf(fact_3871_ceiling__zero,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ( ( archimedean_ceiling @ A @ ( zero_zero @ A ) )
        = ( zero_zero @ int ) ) ) ).

% ceiling_zero
thf(fact_3872_ceiling__numeral,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [V: num] :
          ( ( archimedean_ceiling @ A @ ( numeral_numeral @ A @ V ) )
          = ( numeral_numeral @ int @ V ) ) ) ).

% ceiling_numeral
thf(fact_3873_ceiling__one,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ( ( archimedean_ceiling @ A @ ( one_one @ A ) )
        = ( one_one @ int ) ) ) ).

% ceiling_one
thf(fact_3874_ceiling__add__of__int,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A,Z: int] :
          ( ( archimedean_ceiling @ A @ ( plus_plus @ A @ X2 @ ( ring_1_of_int @ A @ Z ) ) )
          = ( plus_plus @ int @ ( archimedean_ceiling @ A @ X2 ) @ Z ) ) ) ).

% ceiling_add_of_int
thf(fact_3875_ceiling__le__zero,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A] :
          ( ( ord_less_eq @ int @ ( archimedean_ceiling @ A @ X2 ) @ ( zero_zero @ int ) )
          = ( ord_less_eq @ A @ X2 @ ( zero_zero @ A ) ) ) ) ).

% ceiling_le_zero
thf(fact_3876_zero__less__ceiling,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A] :
          ( ( ord_less @ int @ ( zero_zero @ int ) @ ( archimedean_ceiling @ A @ X2 ) )
          = ( ord_less @ A @ ( zero_zero @ A ) @ X2 ) ) ) ).

% zero_less_ceiling
thf(fact_3877_ceiling__le__numeral,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A,V: num] :
          ( ( ord_less_eq @ int @ ( archimedean_ceiling @ A @ X2 ) @ ( numeral_numeral @ int @ V ) )
          = ( ord_less_eq @ A @ X2 @ ( numeral_numeral @ A @ V ) ) ) ) ).

% ceiling_le_numeral
thf(fact_3878_ceiling__less__one,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A] :
          ( ( ord_less @ int @ ( archimedean_ceiling @ A @ X2 ) @ ( one_one @ int ) )
          = ( ord_less_eq @ A @ X2 @ ( zero_zero @ A ) ) ) ) ).

% ceiling_less_one
thf(fact_3879_one__le__ceiling,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A] :
          ( ( ord_less_eq @ int @ ( one_one @ int ) @ ( archimedean_ceiling @ A @ X2 ) )
          = ( ord_less @ A @ ( zero_zero @ A ) @ X2 ) ) ) ).

% one_le_ceiling
thf(fact_3880_numeral__less__ceiling,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [V: num,X2: A] :
          ( ( ord_less @ int @ ( numeral_numeral @ int @ V ) @ ( archimedean_ceiling @ A @ X2 ) )
          = ( ord_less @ A @ ( numeral_numeral @ A @ V ) @ X2 ) ) ) ).

% numeral_less_ceiling
thf(fact_3881_ceiling__le__one,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A] :
          ( ( ord_less_eq @ int @ ( archimedean_ceiling @ A @ X2 ) @ ( one_one @ int ) )
          = ( ord_less_eq @ A @ X2 @ ( one_one @ A ) ) ) ) ).

% ceiling_le_one
thf(fact_3882_one__less__ceiling,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A] :
          ( ( ord_less @ int @ ( one_one @ int ) @ ( archimedean_ceiling @ A @ X2 ) )
          = ( ord_less @ A @ ( one_one @ A ) @ X2 ) ) ) ).

% one_less_ceiling
thf(fact_3883_ceiling__add__numeral,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A,V: num] :
          ( ( archimedean_ceiling @ A @ ( plus_plus @ A @ X2 @ ( numeral_numeral @ A @ V ) ) )
          = ( plus_plus @ int @ ( archimedean_ceiling @ A @ X2 ) @ ( numeral_numeral @ int @ V ) ) ) ) ).

% ceiling_add_numeral
thf(fact_3884_ceiling__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [V: num] :
          ( ( archimedean_ceiling @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) )
          = ( uminus_uminus @ int @ ( numeral_numeral @ int @ V ) ) ) ) ).

% ceiling_neg_numeral
thf(fact_3885_ceiling__add__one,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A] :
          ( ( archimedean_ceiling @ A @ ( plus_plus @ A @ X2 @ ( one_one @ A ) ) )
          = ( plus_plus @ int @ ( archimedean_ceiling @ A @ X2 ) @ ( one_one @ int ) ) ) ) ).

% ceiling_add_one
thf(fact_3886_ceiling__diff__numeral,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A,V: num] :
          ( ( archimedean_ceiling @ A @ ( minus_minus @ A @ X2 @ ( numeral_numeral @ A @ V ) ) )
          = ( minus_minus @ int @ ( archimedean_ceiling @ A @ X2 ) @ ( numeral_numeral @ int @ V ) ) ) ) ).

% ceiling_diff_numeral
thf(fact_3887_ceiling__diff__one,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A] :
          ( ( archimedean_ceiling @ A @ ( minus_minus @ A @ X2 @ ( one_one @ A ) ) )
          = ( minus_minus @ int @ ( archimedean_ceiling @ A @ X2 ) @ ( one_one @ int ) ) ) ) ).

% ceiling_diff_one
thf(fact_3888_ceiling__numeral__power,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: num,N2: nat] :
          ( ( archimedean_ceiling @ A @ ( power_power @ A @ ( numeral_numeral @ A @ X2 ) @ N2 ) )
          = ( power_power @ int @ ( numeral_numeral @ int @ X2 ) @ N2 ) ) ) ).

% ceiling_numeral_power
thf(fact_3889_ceiling__less__zero,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A] :
          ( ( ord_less @ int @ ( archimedean_ceiling @ A @ X2 ) @ ( zero_zero @ int ) )
          = ( ord_less_eq @ A @ X2 @ ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ) ).

% ceiling_less_zero
thf(fact_3890_zero__le__ceiling,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A] :
          ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( archimedean_ceiling @ A @ X2 ) )
          = ( ord_less @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ X2 ) ) ) ).

% zero_le_ceiling
thf(fact_3891_ceiling__divide__eq__div__numeral,axiom,
    ! [A2: num,B2: num] :
      ( ( archimedean_ceiling @ real @ ( divide_divide @ real @ ( numeral_numeral @ real @ A2 ) @ ( numeral_numeral @ real @ B2 ) ) )
      = ( uminus_uminus @ int @ ( divide_divide @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ A2 ) ) @ ( numeral_numeral @ int @ B2 ) ) ) ) ).

% ceiling_divide_eq_div_numeral
thf(fact_3892_ceiling__less__numeral,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A,V: num] :
          ( ( ord_less @ int @ ( archimedean_ceiling @ A @ X2 ) @ ( numeral_numeral @ int @ V ) )
          = ( ord_less_eq @ A @ X2 @ ( minus_minus @ A @ ( numeral_numeral @ A @ V ) @ ( one_one @ A ) ) ) ) ) ).

% ceiling_less_numeral
thf(fact_3893_numeral__le__ceiling,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [V: num,X2: A] :
          ( ( ord_less_eq @ int @ ( numeral_numeral @ int @ V ) @ ( archimedean_ceiling @ A @ X2 ) )
          = ( ord_less @ A @ ( minus_minus @ A @ ( numeral_numeral @ A @ V ) @ ( one_one @ A ) ) @ X2 ) ) ) ).

% numeral_le_ceiling
thf(fact_3894_ceiling__le__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A,V: num] :
          ( ( ord_less_eq @ int @ ( archimedean_ceiling @ A @ X2 ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ V ) ) )
          = ( ord_less_eq @ A @ X2 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) ) ) ) ).

% ceiling_le_neg_numeral
thf(fact_3895_neg__numeral__less__ceiling,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [V: num,X2: A] :
          ( ( ord_less @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ V ) ) @ ( archimedean_ceiling @ A @ X2 ) )
          = ( ord_less @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) @ X2 ) ) ) ).

% neg_numeral_less_ceiling
thf(fact_3896_ceiling__minus__divide__eq__div__numeral,axiom,
    ! [A2: num,B2: num] :
      ( ( archimedean_ceiling @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ ( numeral_numeral @ real @ A2 ) @ ( numeral_numeral @ real @ B2 ) ) ) )
      = ( uminus_uminus @ int @ ( divide_divide @ int @ ( numeral_numeral @ int @ A2 ) @ ( numeral_numeral @ int @ B2 ) ) ) ) ).

% ceiling_minus_divide_eq_div_numeral
thf(fact_3897_ceiling__less__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A,V: num] :
          ( ( ord_less @ int @ ( archimedean_ceiling @ A @ X2 ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ V ) ) )
          = ( ord_less_eq @ A @ X2 @ ( minus_minus @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) @ ( one_one @ A ) ) ) ) ) ).

% ceiling_less_neg_numeral
thf(fact_3898_neg__numeral__le__ceiling,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [V: num,X2: A] :
          ( ( ord_less_eq @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ V ) ) @ ( archimedean_ceiling @ A @ X2 ) )
          = ( ord_less @ A @ ( minus_minus @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) @ ( one_one @ A ) ) @ X2 ) ) ) ).

% neg_numeral_le_ceiling
thf(fact_3899_ceiling__mono,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [Y2: A,X2: A] :
          ( ( ord_less_eq @ A @ Y2 @ X2 )
         => ( ord_less_eq @ int @ ( archimedean_ceiling @ A @ Y2 ) @ ( archimedean_ceiling @ A @ X2 ) ) ) ) ).

% ceiling_mono
thf(fact_3900_le__of__int__ceiling,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A] : ( ord_less_eq @ A @ X2 @ ( ring_1_of_int @ A @ ( archimedean_ceiling @ A @ X2 ) ) ) ) ).

% le_of_int_ceiling
thf(fact_3901_ceiling__less__cancel,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A,Y2: A] :
          ( ( ord_less @ int @ ( archimedean_ceiling @ A @ X2 ) @ ( archimedean_ceiling @ A @ Y2 ) )
         => ( ord_less @ A @ X2 @ Y2 ) ) ) ).

% ceiling_less_cancel
thf(fact_3902_ceiling__ge__round,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A] : ( ord_less_eq @ int @ ( archimedean_round @ A @ X2 ) @ ( archimedean_ceiling @ A @ X2 ) ) ) ).

% ceiling_ge_round
thf(fact_3903_ceiling__le,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A,A2: int] :
          ( ( ord_less_eq @ A @ X2 @ ( ring_1_of_int @ A @ A2 ) )
         => ( ord_less_eq @ int @ ( archimedean_ceiling @ A @ X2 ) @ A2 ) ) ) ).

% ceiling_le
thf(fact_3904_ceiling__le__iff,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A,Z: int] :
          ( ( ord_less_eq @ int @ ( archimedean_ceiling @ A @ X2 ) @ Z )
          = ( ord_less_eq @ A @ X2 @ ( ring_1_of_int @ A @ Z ) ) ) ) ).

% ceiling_le_iff
thf(fact_3905_less__ceiling__iff,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [Z: int,X2: A] :
          ( ( ord_less @ int @ Z @ ( archimedean_ceiling @ A @ X2 ) )
          = ( ord_less @ A @ ( ring_1_of_int @ A @ Z ) @ X2 ) ) ) ).

% less_ceiling_iff
thf(fact_3906_ceiling__add__le,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A,Y2: A] : ( ord_less_eq @ int @ ( archimedean_ceiling @ A @ ( plus_plus @ A @ X2 @ Y2 ) ) @ ( plus_plus @ int @ ( archimedean_ceiling @ A @ X2 ) @ ( archimedean_ceiling @ A @ Y2 ) ) ) ) ).

% ceiling_add_le
thf(fact_3907_Arg__zero,axiom,
    ( ( arg @ ( zero_zero @ complex ) )
    = ( zero_zero @ real ) ) ).

% Arg_zero
thf(fact_3908_of__int__ceiling__le__add__one,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [R3: A] : ( ord_less_eq @ A @ ( ring_1_of_int @ A @ ( archimedean_ceiling @ A @ R3 ) ) @ ( plus_plus @ A @ R3 @ ( one_one @ A ) ) ) ) ).

% of_int_ceiling_le_add_one
thf(fact_3909_of__int__ceiling__diff__one__le,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [R3: A] : ( ord_less_eq @ A @ ( minus_minus @ A @ ( ring_1_of_int @ A @ ( archimedean_ceiling @ A @ R3 ) ) @ ( one_one @ A ) ) @ R3 ) ) ).

% of_int_ceiling_diff_one_le
thf(fact_3910_ceiling__divide__eq__div,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [A2: int,B2: int] :
          ( ( archimedean_ceiling @ A @ ( divide_divide @ A @ ( ring_1_of_int @ A @ A2 ) @ ( ring_1_of_int @ A @ B2 ) ) )
          = ( uminus_uminus @ int @ ( divide_divide @ int @ ( uminus_uminus @ int @ A2 ) @ B2 ) ) ) ) ).

% ceiling_divide_eq_div
thf(fact_3911_ceiling__correct,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A] :
          ( ( ord_less @ A @ ( minus_minus @ A @ ( ring_1_of_int @ A @ ( archimedean_ceiling @ A @ X2 ) ) @ ( one_one @ A ) ) @ X2 )
          & ( ord_less_eq @ A @ X2 @ ( ring_1_of_int @ A @ ( archimedean_ceiling @ A @ X2 ) ) ) ) ) ).

% ceiling_correct
thf(fact_3912_ceiling__unique,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [Z: int,X2: A] :
          ( ( ord_less @ A @ ( minus_minus @ A @ ( ring_1_of_int @ A @ Z ) @ ( one_one @ A ) ) @ X2 )
         => ( ( ord_less_eq @ A @ X2 @ ( ring_1_of_int @ A @ Z ) )
           => ( ( archimedean_ceiling @ A @ X2 )
              = Z ) ) ) ) ).

% ceiling_unique
thf(fact_3913_ceiling__eq__iff,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A,A2: int] :
          ( ( ( archimedean_ceiling @ A @ X2 )
            = A2 )
          = ( ( ord_less @ A @ ( minus_minus @ A @ ( ring_1_of_int @ A @ A2 ) @ ( one_one @ A ) ) @ X2 )
            & ( ord_less_eq @ A @ X2 @ ( ring_1_of_int @ A @ A2 ) ) ) ) ) ).

% ceiling_eq_iff
thf(fact_3914_ceiling__split,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [P: int > $o,T2: A] :
          ( ( P @ ( archimedean_ceiling @ A @ T2 ) )
          = ( ! [I4: int] :
                ( ( ( ord_less @ A @ ( minus_minus @ A @ ( ring_1_of_int @ A @ I4 ) @ ( one_one @ A ) ) @ T2 )
                  & ( ord_less_eq @ A @ T2 @ ( ring_1_of_int @ A @ I4 ) ) )
               => ( P @ I4 ) ) ) ) ) ).

% ceiling_split
thf(fact_3915_mult__ceiling__le,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 )
           => ( ord_less_eq @ int @ ( archimedean_ceiling @ A @ ( times_times @ A @ A2 @ B2 ) ) @ ( times_times @ int @ ( archimedean_ceiling @ A @ A2 ) @ ( archimedean_ceiling @ A @ B2 ) ) ) ) ) ) ).

% mult_ceiling_le
thf(fact_3916_ceiling__less__iff,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A,Z: int] :
          ( ( ord_less @ int @ ( archimedean_ceiling @ A @ X2 ) @ Z )
          = ( ord_less_eq @ A @ X2 @ ( minus_minus @ A @ ( ring_1_of_int @ A @ Z ) @ ( one_one @ A ) ) ) ) ) ).

% ceiling_less_iff
thf(fact_3917_le__ceiling__iff,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [Z: int,X2: A] :
          ( ( ord_less_eq @ int @ Z @ ( archimedean_ceiling @ A @ X2 ) )
          = ( ord_less @ A @ ( minus_minus @ A @ ( ring_1_of_int @ A @ Z ) @ ( one_one @ A ) ) @ X2 ) ) ) ).

% le_ceiling_iff
thf(fact_3918_ceiling__divide__upper,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [Q3: A,P4: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ Q3 )
         => ( ord_less_eq @ A @ P4 @ ( times_times @ A @ ( ring_1_of_int @ A @ ( archimedean_ceiling @ A @ ( divide_divide @ A @ P4 @ Q3 ) ) ) @ Q3 ) ) ) ) ).

% ceiling_divide_upper
thf(fact_3919_Arg__bounded,axiom,
    ! [Z: complex] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ pi ) @ ( arg @ Z ) )
      & ( ord_less_eq @ real @ ( arg @ Z ) @ pi ) ) ).

% Arg_bounded
thf(fact_3920_ceiling__divide__lower,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [Q3: A,P4: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ Q3 )
         => ( ord_less @ A @ ( times_times @ A @ ( minus_minus @ A @ ( ring_1_of_int @ A @ ( archimedean_ceiling @ A @ ( divide_divide @ A @ P4 @ Q3 ) ) ) @ ( one_one @ A ) ) @ Q3 ) @ P4 ) ) ) ).

% ceiling_divide_lower
thf(fact_3921_ceiling__eq,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [N2: int,X2: A] :
          ( ( ord_less @ A @ ( ring_1_of_int @ A @ N2 ) @ X2 )
         => ( ( ord_less_eq @ A @ X2 @ ( plus_plus @ A @ ( ring_1_of_int @ A @ N2 ) @ ( one_one @ A ) ) )
           => ( ( archimedean_ceiling @ A @ X2 )
              = ( plus_plus @ int @ N2 @ ( one_one @ int ) ) ) ) ) ) ).

% ceiling_eq
thf(fact_3922_ceiling__log2__div2,axiom,
    ! [N2: nat] :
      ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 )
     => ( ( archimedean_ceiling @ real @ ( log @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( semiring_1_of_nat @ real @ N2 ) ) )
        = ( plus_plus @ int @ ( archimedean_ceiling @ real @ ( log @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( semiring_1_of_nat @ real @ ( plus_plus @ nat @ ( divide_divide @ nat @ ( minus_minus @ nat @ N2 @ ( one_one @ nat ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ nat ) ) ) ) ) @ ( one_one @ int ) ) ) ) ).

% ceiling_log2_div2
thf(fact_3923_cis__minus__pi__half,axiom,
    ( ( cis @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) )
    = ( uminus_uminus @ complex @ imaginary_unit ) ) ).

% cis_minus_pi_half
thf(fact_3924_ceiling__log__eq__powr__iff,axiom,
    ! [X2: real,B2: real,K: nat] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( ord_less @ real @ ( one_one @ real ) @ B2 )
       => ( ( ( archimedean_ceiling @ real @ ( log @ B2 @ X2 ) )
            = ( plus_plus @ int @ ( semiring_1_of_nat @ int @ K ) @ ( one_one @ int ) ) )
          = ( ( ord_less @ real @ ( powr @ real @ B2 @ ( semiring_1_of_nat @ real @ K ) ) @ X2 )
            & ( ord_less_eq @ real @ X2 @ ( powr @ real @ B2 @ ( semiring_1_of_nat @ real @ ( plus_plus @ nat @ K @ ( one_one @ nat ) ) ) ) ) ) ) ) ) ).

% ceiling_log_eq_powr_iff
thf(fact_3925_floor__log__nat__eq__powr__iff,axiom,
    ! [B2: nat,K: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ B2 )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
       => ( ( ( archim6421214686448440834_floor @ real @ ( log @ ( semiring_1_of_nat @ real @ B2 ) @ ( semiring_1_of_nat @ real @ K ) ) )
            = ( semiring_1_of_nat @ int @ N2 ) )
          = ( ( ord_less_eq @ nat @ ( power_power @ nat @ B2 @ N2 ) @ K )
            & ( ord_less @ nat @ K @ ( power_power @ nat @ B2 @ ( plus_plus @ nat @ N2 @ ( one_one @ nat ) ) ) ) ) ) ) ) ).

% floor_log_nat_eq_powr_iff
thf(fact_3926_floor__log__nat__eq__if,axiom,
    ! [B2: nat,N2: nat,K: nat] :
      ( ( ord_less_eq @ nat @ ( power_power @ nat @ B2 @ N2 ) @ K )
     => ( ( ord_less @ nat @ K @ ( power_power @ nat @ B2 @ ( plus_plus @ nat @ N2 @ ( one_one @ nat ) ) ) )
       => ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ B2 )
         => ( ( archim6421214686448440834_floor @ real @ ( log @ ( semiring_1_of_nat @ real @ B2 ) @ ( semiring_1_of_nat @ real @ K ) ) )
            = ( semiring_1_of_nat @ int @ N2 ) ) ) ) ) ).

% floor_log_nat_eq_if
thf(fact_3927_powr__0,axiom,
    ! [A: $tType] :
      ( ( ln @ A )
     => ! [Z: A] :
          ( ( powr @ A @ ( zero_zero @ A ) @ Z )
          = ( zero_zero @ A ) ) ) ).

% powr_0
thf(fact_3928_powr__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( ln @ A )
     => ! [W: A,Z: A] :
          ( ( ( powr @ A @ W @ Z )
            = ( zero_zero @ A ) )
          = ( W
            = ( zero_zero @ A ) ) ) ) ).

% powr_eq_0_iff
thf(fact_3929_powr__one__eq__one,axiom,
    ! [A: $tType] :
      ( ( ln @ A )
     => ! [A2: A] :
          ( ( powr @ A @ ( one_one @ A ) @ A2 )
          = ( one_one @ A ) ) ) ).

% powr_one_eq_one
thf(fact_3930_of__int__floor__cancel,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A] :
          ( ( ( ring_1_of_int @ A @ ( archim6421214686448440834_floor @ A @ X2 ) )
            = X2 )
          = ( ? [N3: int] :
                ( X2
                = ( ring_1_of_int @ A @ N3 ) ) ) ) ) ).

% of_int_floor_cancel
thf(fact_3931_powr__zero__eq__one,axiom,
    ! [A: $tType] :
      ( ( ln @ A )
     => ! [X2: A] :
          ( ( ( X2
              = ( zero_zero @ A ) )
           => ( ( powr @ A @ X2 @ ( zero_zero @ A ) )
              = ( zero_zero @ A ) ) )
          & ( ( X2
             != ( zero_zero @ A ) )
           => ( ( powr @ A @ X2 @ ( zero_zero @ A ) )
              = ( one_one @ A ) ) ) ) ) ).

% powr_zero_eq_one
thf(fact_3932_floor__zero,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ( ( archim6421214686448440834_floor @ A @ ( zero_zero @ A ) )
        = ( zero_zero @ int ) ) ) ).

% floor_zero
thf(fact_3933_floor__numeral,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [V: num] :
          ( ( archim6421214686448440834_floor @ A @ ( numeral_numeral @ A @ V ) )
          = ( numeral_numeral @ int @ V ) ) ) ).

% floor_numeral
thf(fact_3934_powr__gt__zero,axiom,
    ! [X2: real,A2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ ( powr @ real @ X2 @ A2 ) )
      = ( ( X2
         != ( zero_zero @ real ) ) ) ) ).

% powr_gt_zero
thf(fact_3935_floor__one,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ( ( archim6421214686448440834_floor @ A @ ( one_one @ A ) )
        = ( one_one @ int ) ) ) ).

% floor_one
thf(fact_3936_powr__nonneg__iff,axiom,
    ! [A2: real,X2: real] :
      ( ( ord_less_eq @ real @ ( powr @ real @ A2 @ X2 ) @ ( zero_zero @ real ) )
      = ( A2
        = ( zero_zero @ real ) ) ) ).

% powr_nonneg_iff
thf(fact_3937_powr__less__cancel__iff,axiom,
    ! [X2: real,A2: real,B2: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ X2 )
     => ( ( ord_less @ real @ ( powr @ real @ X2 @ A2 ) @ ( powr @ real @ X2 @ B2 ) )
        = ( ord_less @ real @ A2 @ B2 ) ) ) ).

% powr_less_cancel_iff
thf(fact_3938_cis__zero,axiom,
    ( ( cis @ ( zero_zero @ real ) )
    = ( one_one @ complex ) ) ).

% cis_zero
thf(fact_3939_powr__eq__one__iff,axiom,
    ! [A2: real,X2: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ A2 )
     => ( ( ( powr @ real @ A2 @ X2 )
          = ( one_one @ real ) )
        = ( X2
          = ( zero_zero @ real ) ) ) ) ).

% powr_eq_one_iff
thf(fact_3940_powr__one__gt__zero__iff,axiom,
    ! [X2: real] :
      ( ( ( powr @ real @ X2 @ ( one_one @ real ) )
        = X2 )
      = ( ord_less_eq @ real @ ( zero_zero @ real ) @ X2 ) ) ).

% powr_one_gt_zero_iff
thf(fact_3941_powr__one,axiom,
    ! [X2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( powr @ real @ X2 @ ( one_one @ real ) )
        = X2 ) ) ).

% powr_one
thf(fact_3942_powr__le__cancel__iff,axiom,
    ! [X2: real,A2: real,B2: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ X2 )
     => ( ( ord_less_eq @ real @ ( powr @ real @ X2 @ A2 ) @ ( powr @ real @ X2 @ B2 ) )
        = ( ord_less_eq @ real @ A2 @ B2 ) ) ) ).

% powr_le_cancel_iff
thf(fact_3943_numeral__powr__numeral__real,axiom,
    ! [M: num,N2: num] :
      ( ( powr @ real @ ( numeral_numeral @ real @ M ) @ ( numeral_numeral @ real @ N2 ) )
      = ( power_power @ real @ ( numeral_numeral @ real @ M ) @ ( numeral_numeral @ nat @ N2 ) ) ) ).

% numeral_powr_numeral_real
thf(fact_3944_zero__le__floor,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A] :
          ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( archim6421214686448440834_floor @ A @ X2 ) )
          = ( ord_less_eq @ A @ ( zero_zero @ A ) @ X2 ) ) ) ).

% zero_le_floor
thf(fact_3945_floor__less__zero,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A] :
          ( ( ord_less @ int @ ( archim6421214686448440834_floor @ A @ X2 ) @ ( zero_zero @ int ) )
          = ( ord_less @ A @ X2 @ ( zero_zero @ A ) ) ) ) ).

% floor_less_zero
thf(fact_3946_numeral__le__floor,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [V: num,X2: A] :
          ( ( ord_less_eq @ int @ ( numeral_numeral @ int @ V ) @ ( archim6421214686448440834_floor @ A @ X2 ) )
          = ( ord_less_eq @ A @ ( numeral_numeral @ A @ V ) @ X2 ) ) ) ).

% numeral_le_floor
thf(fact_3947_zero__less__floor,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A] :
          ( ( ord_less @ int @ ( zero_zero @ int ) @ ( archim6421214686448440834_floor @ A @ X2 ) )
          = ( ord_less_eq @ A @ ( one_one @ A ) @ X2 ) ) ) ).

% zero_less_floor
thf(fact_3948_floor__le__zero,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A] :
          ( ( ord_less_eq @ int @ ( archim6421214686448440834_floor @ A @ X2 ) @ ( zero_zero @ int ) )
          = ( ord_less @ A @ X2 @ ( one_one @ A ) ) ) ) ).

% floor_le_zero
thf(fact_3949_floor__less__numeral,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A,V: num] :
          ( ( ord_less @ int @ ( archim6421214686448440834_floor @ A @ X2 ) @ ( numeral_numeral @ int @ V ) )
          = ( ord_less @ A @ X2 @ ( numeral_numeral @ A @ V ) ) ) ) ).

% floor_less_numeral
thf(fact_3950_one__le__floor,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A] :
          ( ( ord_less_eq @ int @ ( one_one @ int ) @ ( archim6421214686448440834_floor @ A @ X2 ) )
          = ( ord_less_eq @ A @ ( one_one @ A ) @ X2 ) ) ) ).

% one_le_floor
thf(fact_3951_floor__less__one,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A] :
          ( ( ord_less @ int @ ( archim6421214686448440834_floor @ A @ X2 ) @ ( one_one @ int ) )
          = ( ord_less @ A @ X2 @ ( one_one @ A ) ) ) ) ).

% floor_less_one
thf(fact_3952_floor__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [V: num] :
          ( ( archim6421214686448440834_floor @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) )
          = ( uminus_uminus @ int @ ( numeral_numeral @ int @ V ) ) ) ) ).

% floor_neg_numeral
thf(fact_3953_floor__diff__numeral,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A,V: num] :
          ( ( archim6421214686448440834_floor @ A @ ( minus_minus @ A @ X2 @ ( numeral_numeral @ A @ V ) ) )
          = ( minus_minus @ int @ ( archim6421214686448440834_floor @ A @ X2 ) @ ( numeral_numeral @ int @ V ) ) ) ) ).

% floor_diff_numeral
thf(fact_3954_floor__diff__one,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A] :
          ( ( archim6421214686448440834_floor @ A @ ( minus_minus @ A @ X2 @ ( one_one @ A ) ) )
          = ( minus_minus @ int @ ( archim6421214686448440834_floor @ A @ X2 ) @ ( one_one @ int ) ) ) ) ).

% floor_diff_one
thf(fact_3955_floor__numeral__power,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: num,N2: nat] :
          ( ( archim6421214686448440834_floor @ A @ ( power_power @ A @ ( numeral_numeral @ A @ X2 ) @ N2 ) )
          = ( power_power @ int @ ( numeral_numeral @ int @ X2 ) @ N2 ) ) ) ).

% floor_numeral_power
thf(fact_3956_log__powr__cancel,axiom,
    ! [A2: real,Y2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
     => ( ( A2
         != ( one_one @ real ) )
       => ( ( log @ A2 @ ( powr @ real @ A2 @ Y2 ) )
          = Y2 ) ) ) ).

% log_powr_cancel
thf(fact_3957_powr__log__cancel,axiom,
    ! [A2: real,X2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
     => ( ( A2
         != ( one_one @ real ) )
       => ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
         => ( ( powr @ real @ A2 @ ( log @ A2 @ X2 ) )
            = X2 ) ) ) ) ).

% powr_log_cancel
thf(fact_3958_floor__divide__eq__div__numeral,axiom,
    ! [A2: num,B2: num] :
      ( ( archim6421214686448440834_floor @ real @ ( divide_divide @ real @ ( numeral_numeral @ real @ A2 ) @ ( numeral_numeral @ real @ B2 ) ) )
      = ( divide_divide @ int @ ( numeral_numeral @ int @ A2 ) @ ( numeral_numeral @ int @ B2 ) ) ) ).

% floor_divide_eq_div_numeral
thf(fact_3959_powr__numeral,axiom,
    ! [X2: real,N2: num] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( powr @ real @ X2 @ ( numeral_numeral @ real @ N2 ) )
        = ( power_power @ real @ X2 @ ( numeral_numeral @ nat @ N2 ) ) ) ) ).

% powr_numeral
thf(fact_3960_numeral__less__floor,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [V: num,X2: A] :
          ( ( ord_less @ int @ ( numeral_numeral @ int @ V ) @ ( archim6421214686448440834_floor @ A @ X2 ) )
          = ( ord_less_eq @ A @ ( plus_plus @ A @ ( numeral_numeral @ A @ V ) @ ( one_one @ A ) ) @ X2 ) ) ) ).

% numeral_less_floor
thf(fact_3961_floor__le__numeral,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A,V: num] :
          ( ( ord_less_eq @ int @ ( archim6421214686448440834_floor @ A @ X2 ) @ ( numeral_numeral @ int @ V ) )
          = ( ord_less @ A @ X2 @ ( plus_plus @ A @ ( numeral_numeral @ A @ V ) @ ( one_one @ A ) ) ) ) ) ).

% floor_le_numeral
thf(fact_3962_one__less__floor,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A] :
          ( ( ord_less @ int @ ( one_one @ int ) @ ( archim6421214686448440834_floor @ A @ X2 ) )
          = ( ord_less_eq @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ X2 ) ) ) ).

% one_less_floor
thf(fact_3963_floor__le__one,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A] :
          ( ( ord_less_eq @ int @ ( archim6421214686448440834_floor @ A @ X2 ) @ ( one_one @ int ) )
          = ( ord_less @ A @ X2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% floor_le_one
thf(fact_3964_neg__numeral__le__floor,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [V: num,X2: A] :
          ( ( ord_less_eq @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ V ) ) @ ( archim6421214686448440834_floor @ A @ X2 ) )
          = ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) @ X2 ) ) ) ).

% neg_numeral_le_floor
thf(fact_3965_floor__less__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A,V: num] :
          ( ( ord_less @ int @ ( archim6421214686448440834_floor @ A @ X2 ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ V ) ) )
          = ( ord_less @ A @ X2 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) ) ) ) ).

% floor_less_neg_numeral
thf(fact_3966_cis__pi__half,axiom,
    ( ( cis @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
    = imaginary_unit ) ).

% cis_pi_half
thf(fact_3967_floor__one__divide__eq__div__numeral,axiom,
    ! [B2: num] :
      ( ( archim6421214686448440834_floor @ real @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ B2 ) ) )
      = ( divide_divide @ int @ ( one_one @ int ) @ ( numeral_numeral @ int @ B2 ) ) ) ).

% floor_one_divide_eq_div_numeral
thf(fact_3968_cis__2pi,axiom,
    ( ( cis @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) )
    = ( one_one @ complex ) ) ).

% cis_2pi
thf(fact_3969_floor__minus__divide__eq__div__numeral,axiom,
    ! [A2: num,B2: num] :
      ( ( archim6421214686448440834_floor @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ ( numeral_numeral @ real @ A2 ) @ ( numeral_numeral @ real @ B2 ) ) ) )
      = ( divide_divide @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ A2 ) ) @ ( numeral_numeral @ int @ B2 ) ) ) ).

% floor_minus_divide_eq_div_numeral
thf(fact_3970_neg__numeral__less__floor,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [V: num,X2: A] :
          ( ( ord_less @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ V ) ) @ ( archim6421214686448440834_floor @ A @ X2 ) )
          = ( ord_less_eq @ A @ ( plus_plus @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) @ ( one_one @ A ) ) @ X2 ) ) ) ).

% neg_numeral_less_floor
thf(fact_3971_floor__le__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A,V: num] :
          ( ( ord_less_eq @ int @ ( archim6421214686448440834_floor @ A @ X2 ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ V ) ) )
          = ( ord_less @ A @ X2 @ ( plus_plus @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) @ ( one_one @ A ) ) ) ) ) ).

% floor_le_neg_numeral
thf(fact_3972_square__powr__half,axiom,
    ! [X2: real] :
      ( ( powr @ real @ ( power_power @ real @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
      = ( abs_abs @ real @ X2 ) ) ).

% square_powr_half
thf(fact_3973_floor__minus__one__divide__eq__div__numeral,axiom,
    ! [B2: num] :
      ( ( archim6421214686448440834_floor @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ B2 ) ) ) )
      = ( divide_divide @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( numeral_numeral @ int @ B2 ) ) ) ).

% floor_minus_one_divide_eq_div_numeral
thf(fact_3974_powr__powr,axiom,
    ! [X2: real,A2: real,B2: real] :
      ( ( powr @ real @ ( powr @ real @ X2 @ A2 ) @ B2 )
      = ( powr @ real @ X2 @ ( times_times @ real @ A2 @ B2 ) ) ) ).

% powr_powr
thf(fact_3975_cis__neq__zero,axiom,
    ! [A2: real] :
      ( ( cis @ A2 )
     != ( zero_zero @ complex ) ) ).

% cis_neq_zero
thf(fact_3976_floor__mono,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A,Y2: A] :
          ( ( ord_less_eq @ A @ X2 @ Y2 )
         => ( ord_less_eq @ int @ ( archim6421214686448440834_floor @ A @ X2 ) @ ( archim6421214686448440834_floor @ A @ Y2 ) ) ) ) ).

% floor_mono
thf(fact_3977_of__int__floor__le,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A] : ( ord_less_eq @ A @ ( ring_1_of_int @ A @ ( archim6421214686448440834_floor @ A @ X2 ) ) @ X2 ) ) ).

% of_int_floor_le
thf(fact_3978_floor__less__cancel,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A,Y2: A] :
          ( ( ord_less @ int @ ( archim6421214686448440834_floor @ A @ X2 ) @ ( archim6421214686448440834_floor @ A @ Y2 ) )
         => ( ord_less @ A @ X2 @ Y2 ) ) ) ).

% floor_less_cancel
thf(fact_3979_powr__non__neg,axiom,
    ! [A2: real,X2: real] :
      ~ ( ord_less @ real @ ( powr @ real @ A2 @ X2 ) @ ( zero_zero @ real ) ) ).

% powr_non_neg
thf(fact_3980_powr__less__mono2__neg,axiom,
    ! [A2: real,X2: real,Y2: real] :
      ( ( ord_less @ real @ A2 @ ( zero_zero @ real ) )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
       => ( ( ord_less @ real @ X2 @ Y2 )
         => ( ord_less @ real @ ( powr @ real @ Y2 @ A2 ) @ ( powr @ real @ X2 @ A2 ) ) ) ) ) ).

% powr_less_mono2_neg
thf(fact_3981_powr__ge__pzero,axiom,
    ! [X2: real,Y2: real] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( powr @ real @ X2 @ Y2 ) ) ).

% powr_ge_pzero
thf(fact_3982_powr__mono2,axiom,
    ! [A2: real,X2: real,Y2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ A2 )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X2 )
       => ( ( ord_less_eq @ real @ X2 @ Y2 )
         => ( ord_less_eq @ real @ ( powr @ real @ X2 @ A2 ) @ ( powr @ real @ Y2 @ A2 ) ) ) ) ) ).

% powr_mono2
thf(fact_3983_powr__less__mono,axiom,
    ! [A2: real,B2: real,X2: real] :
      ( ( ord_less @ real @ A2 @ B2 )
     => ( ( ord_less @ real @ ( one_one @ real ) @ X2 )
       => ( ord_less @ real @ ( powr @ real @ X2 @ A2 ) @ ( powr @ real @ X2 @ B2 ) ) ) ) ).

% powr_less_mono
thf(fact_3984_powr__less__cancel,axiom,
    ! [X2: real,A2: real,B2: real] :
      ( ( ord_less @ real @ ( powr @ real @ X2 @ A2 ) @ ( powr @ real @ X2 @ B2 ) )
     => ( ( ord_less @ real @ ( one_one @ real ) @ X2 )
       => ( ord_less @ real @ A2 @ B2 ) ) ) ).

% powr_less_cancel
thf(fact_3985_powr__mono,axiom,
    ! [A2: real,B2: real,X2: real] :
      ( ( ord_less_eq @ real @ A2 @ B2 )
     => ( ( ord_less_eq @ real @ ( one_one @ real ) @ X2 )
       => ( ord_less_eq @ real @ ( powr @ real @ X2 @ A2 ) @ ( powr @ real @ X2 @ B2 ) ) ) ) ).

% powr_mono
thf(fact_3986_floor__le__ceiling,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A] : ( ord_less_eq @ int @ ( archim6421214686448440834_floor @ A @ X2 ) @ ( archimedean_ceiling @ A @ X2 ) ) ) ).

% floor_le_ceiling
thf(fact_3987_floor__le__round,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A] : ( ord_less_eq @ int @ ( archim6421214686448440834_floor @ A @ X2 ) @ ( archimedean_round @ A @ X2 ) ) ) ).

% floor_le_round
thf(fact_3988_cis__mult,axiom,
    ! [A2: real,B2: real] :
      ( ( times_times @ complex @ ( cis @ A2 ) @ ( cis @ B2 ) )
      = ( cis @ ( plus_plus @ real @ A2 @ B2 ) ) ) ).

% cis_mult
thf(fact_3989_cis__divide,axiom,
    ! [A2: real,B2: real] :
      ( ( divide_divide @ complex @ ( cis @ A2 ) @ ( cis @ B2 ) )
      = ( cis @ ( minus_minus @ real @ A2 @ B2 ) ) ) ).

% cis_divide
thf(fact_3990_le__floor__iff,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [Z: int,X2: A] :
          ( ( ord_less_eq @ int @ Z @ ( archim6421214686448440834_floor @ A @ X2 ) )
          = ( ord_less_eq @ A @ ( ring_1_of_int @ A @ Z ) @ X2 ) ) ) ).

% le_floor_iff
thf(fact_3991_floor__less__iff,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A,Z: int] :
          ( ( ord_less @ int @ ( archim6421214686448440834_floor @ A @ X2 ) @ Z )
          = ( ord_less @ A @ X2 @ ( ring_1_of_int @ A @ Z ) ) ) ) ).

% floor_less_iff
thf(fact_3992_powr__less__mono2,axiom,
    ! [A2: real,X2: real,Y2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X2 )
       => ( ( ord_less @ real @ X2 @ Y2 )
         => ( ord_less @ real @ ( powr @ real @ X2 @ A2 ) @ ( powr @ real @ Y2 @ A2 ) ) ) ) ) ).

% powr_less_mono2
thf(fact_3993_powr__mono2_H,axiom,
    ! [A2: real,X2: real,Y2: real] :
      ( ( ord_less_eq @ real @ A2 @ ( zero_zero @ real ) )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
       => ( ( ord_less_eq @ real @ X2 @ Y2 )
         => ( ord_less_eq @ real @ ( powr @ real @ Y2 @ A2 ) @ ( powr @ real @ X2 @ A2 ) ) ) ) ) ).

% powr_mono2'
thf(fact_3994_le__floor__add,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A,Y2: A] : ( ord_less_eq @ int @ ( plus_plus @ int @ ( archim6421214686448440834_floor @ A @ X2 ) @ ( archim6421214686448440834_floor @ A @ Y2 ) ) @ ( archim6421214686448440834_floor @ A @ ( plus_plus @ A @ X2 @ Y2 ) ) ) ) ).

% le_floor_add
thf(fact_3995_powr__inj,axiom,
    ! [A2: real,X2: real,Y2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
     => ( ( A2
         != ( one_one @ real ) )
       => ( ( ( powr @ real @ A2 @ X2 )
            = ( powr @ real @ A2 @ Y2 ) )
          = ( X2 = Y2 ) ) ) ) ).

% powr_inj
thf(fact_3996_gr__one__powr,axiom,
    ! [X2: real,Y2: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ X2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ Y2 )
       => ( ord_less @ real @ ( one_one @ real ) @ ( powr @ real @ X2 @ Y2 ) ) ) ) ).

% gr_one_powr
thf(fact_3997_floor__add__int,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A,Z: int] :
          ( ( plus_plus @ int @ ( archim6421214686448440834_floor @ A @ X2 ) @ Z )
          = ( archim6421214686448440834_floor @ A @ ( plus_plus @ A @ X2 @ ( ring_1_of_int @ A @ Z ) ) ) ) ) ).

% floor_add_int
thf(fact_3998_int__add__floor,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [Z: int,X2: A] :
          ( ( plus_plus @ int @ Z @ ( archim6421214686448440834_floor @ A @ X2 ) )
          = ( archim6421214686448440834_floor @ A @ ( plus_plus @ A @ ( ring_1_of_int @ A @ Z ) @ X2 ) ) ) ) ).

% int_add_floor
thf(fact_3999_ge__one__powr__ge__zero,axiom,
    ! [X2: real,A2: real] :
      ( ( ord_less_eq @ real @ ( one_one @ real ) @ X2 )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ A2 )
       => ( ord_less_eq @ real @ ( one_one @ real ) @ ( powr @ real @ X2 @ A2 ) ) ) ) ).

% ge_one_powr_ge_zero
thf(fact_4000_powr__mono__both,axiom,
    ! [A2: real,B2: real,X2: real,Y2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ A2 )
     => ( ( ord_less_eq @ real @ A2 @ B2 )
       => ( ( ord_less_eq @ real @ ( one_one @ real ) @ X2 )
         => ( ( ord_less_eq @ real @ X2 @ Y2 )
           => ( ord_less_eq @ real @ ( powr @ real @ X2 @ A2 ) @ ( powr @ real @ Y2 @ B2 ) ) ) ) ) ) ).

% powr_mono_both
thf(fact_4001_powr__le1,axiom,
    ! [A2: real,X2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ A2 )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X2 )
       => ( ( ord_less_eq @ real @ X2 @ ( one_one @ real ) )
         => ( ord_less_eq @ real @ ( powr @ real @ X2 @ A2 ) @ ( one_one @ real ) ) ) ) ) ).

% powr_le1
thf(fact_4002_powr__divide,axiom,
    ! [X2: real,Y2: real,A2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y2 )
       => ( ( powr @ real @ ( divide_divide @ real @ X2 @ Y2 ) @ A2 )
          = ( divide_divide @ real @ ( powr @ real @ X2 @ A2 ) @ ( powr @ real @ Y2 @ A2 ) ) ) ) ) ).

% powr_divide
thf(fact_4003_powr__mult,axiom,
    ! [X2: real,Y2: real,A2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y2 )
       => ( ( powr @ real @ ( times_times @ real @ X2 @ Y2 ) @ A2 )
          = ( times_times @ real @ ( powr @ real @ X2 @ A2 ) @ ( powr @ real @ Y2 @ A2 ) ) ) ) ) ).

% powr_mult
thf(fact_4004_floor__divide__of__int__eq,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [K: int,L: int] :
          ( ( archim6421214686448440834_floor @ A @ ( divide_divide @ A @ ( ring_1_of_int @ A @ K ) @ ( ring_1_of_int @ A @ L ) ) )
          = ( divide_divide @ int @ K @ L ) ) ) ).

% floor_divide_of_int_eq
thf(fact_4005_inverse__powr,axiom,
    ! [Y2: real,A2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y2 )
     => ( ( powr @ real @ ( inverse_inverse @ real @ Y2 ) @ A2 )
        = ( inverse_inverse @ real @ ( powr @ real @ Y2 @ A2 ) ) ) ) ).

% inverse_powr
thf(fact_4006_floor__power,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A,N2: nat] :
          ( ( X2
            = ( ring_1_of_int @ A @ ( archim6421214686448440834_floor @ A @ X2 ) ) )
         => ( ( archim6421214686448440834_floor @ A @ ( power_power @ A @ X2 @ N2 ) )
            = ( power_power @ int @ ( archim6421214686448440834_floor @ A @ X2 ) @ N2 ) ) ) ) ).

% floor_power
thf(fact_4007_divide__powr__uminus,axiom,
    ! [A2: real,B2: real,C2: real] :
      ( ( divide_divide @ real @ A2 @ ( powr @ real @ B2 @ C2 ) )
      = ( times_times @ real @ A2 @ ( powr @ real @ B2 @ ( uminus_uminus @ real @ C2 ) ) ) ) ).

% divide_powr_uminus
thf(fact_4008_log__base__powr,axiom,
    ! [A2: real,B2: real,X2: real] :
      ( ( A2
       != ( zero_zero @ real ) )
     => ( ( log @ ( powr @ real @ A2 @ B2 ) @ X2 )
        = ( divide_divide @ real @ ( log @ A2 @ X2 ) @ B2 ) ) ) ).

% log_base_powr
thf(fact_4009_ln__powr,axiom,
    ! [X2: real,Y2: real] :
      ( ( X2
       != ( zero_zero @ real ) )
     => ( ( ln_ln @ real @ ( powr @ real @ X2 @ Y2 ) )
        = ( times_times @ real @ Y2 @ ( ln_ln @ real @ X2 ) ) ) ) ).

% ln_powr
thf(fact_4010_log__powr,axiom,
    ! [X2: real,B2: real,Y2: real] :
      ( ( X2
       != ( zero_zero @ real ) )
     => ( ( log @ B2 @ ( powr @ real @ X2 @ Y2 ) )
        = ( times_times @ real @ Y2 @ ( log @ B2 @ X2 ) ) ) ) ).

% log_powr
thf(fact_4011_powr__add,axiom,
    ! [A: $tType] :
      ( ( ( real_V3459762299906320749_field @ A )
        & ( ln @ A ) )
     => ! [X2: A,A2: A,B2: A] :
          ( ( powr @ A @ X2 @ ( plus_plus @ A @ A2 @ B2 ) )
          = ( times_times @ A @ ( powr @ A @ X2 @ A2 ) @ ( powr @ A @ X2 @ B2 ) ) ) ) ).

% powr_add
thf(fact_4012_powr__diff,axiom,
    ! [A: $tType] :
      ( ( ( real_V3459762299906320749_field @ A )
        & ( ln @ A ) )
     => ! [W: A,Z1: A,Z22: A] :
          ( ( powr @ A @ W @ ( minus_minus @ A @ Z1 @ Z22 ) )
          = ( divide_divide @ A @ ( powr @ A @ W @ Z1 ) @ ( powr @ A @ W @ Z22 ) ) ) ) ).

% powr_diff
thf(fact_4013_one__add__floor,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A] :
          ( ( plus_plus @ int @ ( archim6421214686448440834_floor @ A @ X2 ) @ ( one_one @ int ) )
          = ( archim6421214686448440834_floor @ A @ ( plus_plus @ A @ X2 @ ( one_one @ A ) ) ) ) ) ).

% one_add_floor
thf(fact_4014_floor__log__eq__powr__iff,axiom,
    ! [X2: real,B2: real,K: int] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( ord_less @ real @ ( one_one @ real ) @ B2 )
       => ( ( ( archim6421214686448440834_floor @ real @ ( log @ B2 @ X2 ) )
            = K )
          = ( ( ord_less_eq @ real @ ( powr @ real @ B2 @ ( ring_1_of_int @ real @ K ) ) @ X2 )
            & ( ord_less @ real @ X2 @ ( powr @ real @ B2 @ ( ring_1_of_int @ real @ ( plus_plus @ int @ K @ ( one_one @ int ) ) ) ) ) ) ) ) ) ).

% floor_log_eq_powr_iff
thf(fact_4015_floor__divide__of__nat__eq,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [M: nat,N2: nat] :
          ( ( archim6421214686448440834_floor @ A @ ( divide_divide @ A @ ( semiring_1_of_nat @ A @ M ) @ ( semiring_1_of_nat @ A @ N2 ) ) )
          = ( semiring_1_of_nat @ int @ ( divide_divide @ nat @ M @ N2 ) ) ) ) ).

% floor_divide_of_nat_eq
thf(fact_4016_powr__realpow,axiom,
    ! [X2: real,N2: nat] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( powr @ real @ X2 @ ( semiring_1_of_nat @ real @ N2 ) )
        = ( power_power @ real @ X2 @ N2 ) ) ) ).

% powr_realpow
thf(fact_4017_powr__less__iff,axiom,
    ! [B2: real,X2: real,Y2: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ B2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
       => ( ( ord_less @ real @ ( powr @ real @ B2 @ Y2 ) @ X2 )
          = ( ord_less @ real @ Y2 @ ( log @ B2 @ X2 ) ) ) ) ) ).

% powr_less_iff
thf(fact_4018_less__powr__iff,axiom,
    ! [B2: real,X2: real,Y2: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ B2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
       => ( ( ord_less @ real @ X2 @ ( powr @ real @ B2 @ Y2 ) )
          = ( ord_less @ real @ ( log @ B2 @ X2 ) @ Y2 ) ) ) ) ).

% less_powr_iff
thf(fact_4019_log__less__iff,axiom,
    ! [B2: real,X2: real,Y2: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ B2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
       => ( ( ord_less @ real @ ( log @ B2 @ X2 ) @ Y2 )
          = ( ord_less @ real @ X2 @ ( powr @ real @ B2 @ Y2 ) ) ) ) ) ).

% log_less_iff
thf(fact_4020_less__log__iff,axiom,
    ! [B2: real,X2: real,Y2: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ B2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
       => ( ( ord_less @ real @ Y2 @ ( log @ B2 @ X2 ) )
          = ( ord_less @ real @ ( powr @ real @ B2 @ Y2 ) @ X2 ) ) ) ) ).

% less_log_iff
thf(fact_4021_ceiling__diff__floor__le__1,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A] : ( ord_less_eq @ int @ ( minus_minus @ int @ ( archimedean_ceiling @ A @ X2 ) @ ( archim6421214686448440834_floor @ A @ X2 ) ) @ ( one_one @ int ) ) ) ).

% ceiling_diff_floor_le_1
thf(fact_4022_floor__eq,axiom,
    ! [N2: int,X2: real] :
      ( ( ord_less @ real @ ( ring_1_of_int @ real @ N2 ) @ X2 )
     => ( ( ord_less @ real @ X2 @ ( plus_plus @ real @ ( ring_1_of_int @ real @ N2 ) @ ( one_one @ real ) ) )
       => ( ( archim6421214686448440834_floor @ real @ X2 )
          = N2 ) ) ) ).

% floor_eq
thf(fact_4023_real__of__int__floor__add__one__gt,axiom,
    ! [R3: real] : ( ord_less @ real @ R3 @ ( plus_plus @ real @ ( ring_1_of_int @ real @ ( archim6421214686448440834_floor @ real @ R3 ) ) @ ( one_one @ real ) ) ) ).

% real_of_int_floor_add_one_gt
thf(fact_4024_real__of__int__floor__add__one__ge,axiom,
    ! [R3: real] : ( ord_less_eq @ real @ R3 @ ( plus_plus @ real @ ( ring_1_of_int @ real @ ( archim6421214686448440834_floor @ real @ R3 ) ) @ ( one_one @ real ) ) ) ).

% real_of_int_floor_add_one_ge
thf(fact_4025_real__of__int__floor__gt__diff__one,axiom,
    ! [R3: real] : ( ord_less @ real @ ( minus_minus @ real @ R3 @ ( one_one @ real ) ) @ ( ring_1_of_int @ real @ ( archim6421214686448440834_floor @ real @ R3 ) ) ) ).

% real_of_int_floor_gt_diff_one
thf(fact_4026_real__of__int__floor__ge__diff__one,axiom,
    ! [R3: real] : ( ord_less_eq @ real @ ( minus_minus @ real @ R3 @ ( one_one @ real ) ) @ ( ring_1_of_int @ real @ ( archim6421214686448440834_floor @ real @ R3 ) ) ) ).

% real_of_int_floor_ge_diff_one
thf(fact_4027_DeMoivre,axiom,
    ! [A2: real,N2: nat] :
      ( ( power_power @ complex @ ( cis @ A2 ) @ N2 )
      = ( cis @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N2 ) @ A2 ) ) ) ).

% DeMoivre
thf(fact_4028_floor__split,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [P: int > $o,T2: A] :
          ( ( P @ ( archim6421214686448440834_floor @ A @ T2 ) )
          = ( ! [I4: int] :
                ( ( ( ord_less_eq @ A @ ( ring_1_of_int @ A @ I4 ) @ T2 )
                  & ( ord_less @ A @ T2 @ ( plus_plus @ A @ ( ring_1_of_int @ A @ I4 ) @ ( one_one @ A ) ) ) )
               => ( P @ I4 ) ) ) ) ) ).

% floor_split
thf(fact_4029_floor__eq__iff,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A,A2: int] :
          ( ( ( archim6421214686448440834_floor @ A @ X2 )
            = A2 )
          = ( ( ord_less_eq @ A @ ( ring_1_of_int @ A @ A2 ) @ X2 )
            & ( ord_less @ A @ X2 @ ( plus_plus @ A @ ( ring_1_of_int @ A @ A2 ) @ ( one_one @ A ) ) ) ) ) ) ).

% floor_eq_iff
thf(fact_4030_floor__unique,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [Z: int,X2: A] :
          ( ( ord_less_eq @ A @ ( ring_1_of_int @ A @ Z ) @ X2 )
         => ( ( ord_less @ A @ X2 @ ( plus_plus @ A @ ( ring_1_of_int @ A @ Z ) @ ( one_one @ A ) ) )
           => ( ( archim6421214686448440834_floor @ A @ X2 )
              = Z ) ) ) ) ).

% floor_unique
thf(fact_4031_powr__minus__divide,axiom,
    ! [A: $tType] :
      ( ( ( real_V3459762299906320749_field @ A )
        & ( ln @ A ) )
     => ! [X2: A,A2: A] :
          ( ( powr @ A @ X2 @ ( uminus_uminus @ A @ A2 ) )
          = ( divide_divide @ A @ ( one_one @ A ) @ ( powr @ A @ X2 @ A2 ) ) ) ) ).

% powr_minus_divide
thf(fact_4032_le__mult__floor,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 )
           => ( ord_less_eq @ int @ ( times_times @ int @ ( archim6421214686448440834_floor @ A @ A2 ) @ ( archim6421214686448440834_floor @ A @ B2 ) ) @ ( archim6421214686448440834_floor @ A @ ( times_times @ A @ A2 @ B2 ) ) ) ) ) ) ).

% le_mult_floor
thf(fact_4033_less__floor__iff,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [Z: int,X2: A] :
          ( ( ord_less @ int @ Z @ ( archim6421214686448440834_floor @ A @ X2 ) )
          = ( ord_less_eq @ A @ ( plus_plus @ A @ ( ring_1_of_int @ A @ Z ) @ ( one_one @ A ) ) @ X2 ) ) ) ).

% less_floor_iff
thf(fact_4034_floor__le__iff,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A,Z: int] :
          ( ( ord_less_eq @ int @ ( archim6421214686448440834_floor @ A @ X2 ) @ Z )
          = ( ord_less @ A @ X2 @ ( plus_plus @ A @ ( ring_1_of_int @ A @ Z ) @ ( one_one @ A ) ) ) ) ) ).

% floor_le_iff
thf(fact_4035_floor__correct,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A] :
          ( ( ord_less_eq @ A @ ( ring_1_of_int @ A @ ( archim6421214686448440834_floor @ A @ X2 ) ) @ X2 )
          & ( ord_less @ A @ X2 @ ( ring_1_of_int @ A @ ( plus_plus @ int @ ( archim6421214686448440834_floor @ A @ X2 ) @ ( one_one @ int ) ) ) ) ) ) ).

% floor_correct
thf(fact_4036_powr__neg__one,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( powr @ real @ X2 @ ( uminus_uminus @ real @ ( one_one @ real ) ) )
        = ( divide_divide @ real @ ( one_one @ real ) @ X2 ) ) ) ).

% powr_neg_one
thf(fact_4037_powr__mult__base,axiom,
    ! [X2: real,Y2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( times_times @ real @ X2 @ ( powr @ real @ X2 @ Y2 ) )
        = ( powr @ real @ X2 @ ( plus_plus @ real @ ( one_one @ real ) @ Y2 ) ) ) ) ).

% powr_mult_base
thf(fact_4038_powr__le__iff,axiom,
    ! [B2: real,X2: real,Y2: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ B2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
       => ( ( ord_less_eq @ real @ ( powr @ real @ B2 @ Y2 ) @ X2 )
          = ( ord_less_eq @ real @ Y2 @ ( log @ B2 @ X2 ) ) ) ) ) ).

% powr_le_iff
thf(fact_4039_le__powr__iff,axiom,
    ! [B2: real,X2: real,Y2: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ B2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
       => ( ( ord_less_eq @ real @ X2 @ ( powr @ real @ B2 @ Y2 ) )
          = ( ord_less_eq @ real @ ( log @ B2 @ X2 ) @ Y2 ) ) ) ) ).

% le_powr_iff
thf(fact_4040_log__le__iff,axiom,
    ! [B2: real,X2: real,Y2: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ B2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
       => ( ( ord_less_eq @ real @ ( log @ B2 @ X2 ) @ Y2 )
          = ( ord_less_eq @ real @ X2 @ ( powr @ real @ B2 @ Y2 ) ) ) ) ) ).

% log_le_iff
thf(fact_4041_le__log__iff,axiom,
    ! [B2: real,X2: real,Y2: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ B2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
       => ( ( ord_less_eq @ real @ Y2 @ ( log @ B2 @ X2 ) )
          = ( ord_less_eq @ real @ ( powr @ real @ B2 @ Y2 ) @ X2 ) ) ) ) ).

% le_log_iff
thf(fact_4042_floor__eq2,axiom,
    ! [N2: int,X2: real] :
      ( ( ord_less_eq @ real @ ( ring_1_of_int @ real @ N2 ) @ X2 )
     => ( ( ord_less @ real @ X2 @ ( plus_plus @ real @ ( ring_1_of_int @ real @ N2 ) @ ( one_one @ real ) ) )
       => ( ( archim6421214686448440834_floor @ real @ X2 )
          = N2 ) ) ) ).

% floor_eq2
thf(fact_4043_floor__divide__real__eq__div,axiom,
    ! [B2: int,A2: real] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ B2 )
     => ( ( archim6421214686448440834_floor @ real @ ( divide_divide @ real @ A2 @ ( ring_1_of_int @ real @ B2 ) ) )
        = ( divide_divide @ int @ ( archim6421214686448440834_floor @ real @ A2 ) @ B2 ) ) ) ).

% floor_divide_real_eq_div
thf(fact_4044_floor__divide__lower,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [Q3: A,P4: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ Q3 )
         => ( ord_less_eq @ A @ ( times_times @ A @ ( ring_1_of_int @ A @ ( archim6421214686448440834_floor @ A @ ( divide_divide @ A @ P4 @ Q3 ) ) ) @ Q3 ) @ P4 ) ) ) ).

% floor_divide_lower
thf(fact_4045_ln__powr__bound,axiom,
    ! [X2: real,A2: real] :
      ( ( ord_less_eq @ real @ ( one_one @ real ) @ X2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
       => ( ord_less_eq @ real @ ( ln_ln @ real @ X2 ) @ ( divide_divide @ real @ ( powr @ real @ X2 @ A2 ) @ A2 ) ) ) ) ).

% ln_powr_bound
thf(fact_4046_ln__powr__bound2,axiom,
    ! [X2: real,A2: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ X2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
       => ( ord_less_eq @ real @ ( powr @ real @ ( ln_ln @ real @ X2 ) @ A2 ) @ ( times_times @ real @ ( powr @ real @ A2 @ A2 ) @ X2 ) ) ) ) ).

% ln_powr_bound2
thf(fact_4047_add__log__eq__powr,axiom,
    ! [B2: real,X2: real,Y2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ B2 )
     => ( ( B2
         != ( one_one @ real ) )
       => ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
         => ( ( plus_plus @ real @ Y2 @ ( log @ B2 @ X2 ) )
            = ( log @ B2 @ ( times_times @ real @ ( powr @ real @ B2 @ Y2 ) @ X2 ) ) ) ) ) ) ).

% add_log_eq_powr
thf(fact_4048_log__add__eq__powr,axiom,
    ! [B2: real,X2: real,Y2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ B2 )
     => ( ( B2
         != ( one_one @ real ) )
       => ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
         => ( ( plus_plus @ real @ ( log @ B2 @ X2 ) @ Y2 )
            = ( log @ B2 @ ( times_times @ real @ X2 @ ( powr @ real @ B2 @ Y2 ) ) ) ) ) ) ) ).

% log_add_eq_powr
thf(fact_4049_minus__log__eq__powr,axiom,
    ! [B2: real,X2: real,Y2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ B2 )
     => ( ( B2
         != ( one_one @ real ) )
       => ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
         => ( ( minus_minus @ real @ Y2 @ ( log @ B2 @ X2 ) )
            = ( log @ B2 @ ( divide_divide @ real @ ( powr @ real @ B2 @ Y2 ) @ X2 ) ) ) ) ) ) ).

% minus_log_eq_powr
thf(fact_4050_powr__def,axiom,
    ! [A: $tType] :
      ( ( ln @ A )
     => ( ( powr @ A )
        = ( ^ [X5: A,A4: A] :
              ( if @ A
              @ ( X5
                = ( zero_zero @ A ) )
              @ ( zero_zero @ A )
              @ ( exp @ A @ ( times_times @ A @ A4 @ ( ln_ln @ A @ X5 ) ) ) ) ) ) ) ).

% powr_def
thf(fact_4051_floor__divide__upper,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [Q3: A,P4: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ Q3 )
         => ( ord_less @ A @ P4 @ ( times_times @ A @ ( plus_plus @ A @ ( ring_1_of_int @ A @ ( archim6421214686448440834_floor @ A @ ( divide_divide @ A @ P4 @ Q3 ) ) ) @ ( one_one @ A ) ) @ Q3 ) ) ) ) ).

% floor_divide_upper
thf(fact_4052_round__def,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ( ( archimedean_round @ A )
        = ( ^ [X5: A] : ( archim6421214686448440834_floor @ A @ ( plus_plus @ A @ X5 @ ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% round_def
thf(fact_4053_log__minus__eq__powr,axiom,
    ! [B2: real,X2: real,Y2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ B2 )
     => ( ( B2
         != ( one_one @ real ) )
       => ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
         => ( ( minus_minus @ real @ ( log @ B2 @ X2 ) @ Y2 )
            = ( log @ B2 @ ( times_times @ real @ X2 @ ( powr @ real @ B2 @ ( uminus_uminus @ real @ Y2 ) ) ) ) ) ) ) ) ).

% log_minus_eq_powr
thf(fact_4054_powr__half__sqrt,axiom,
    ! [X2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( powr @ real @ X2 @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
        = ( sqrt @ X2 ) ) ) ).

% powr_half_sqrt
thf(fact_4055_powr__neg__numeral,axiom,
    ! [X2: real,N2: num] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( powr @ real @ X2 @ ( uminus_uminus @ real @ ( numeral_numeral @ real @ N2 ) ) )
        = ( divide_divide @ real @ ( one_one @ real ) @ ( power_power @ real @ X2 @ ( numeral_numeral @ nat @ N2 ) ) ) ) ) ).

% powr_neg_numeral
thf(fact_4056_floor__log2__div2,axiom,
    ! [N2: nat] :
      ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 )
     => ( ( archim6421214686448440834_floor @ real @ ( log @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( semiring_1_of_nat @ real @ N2 ) ) )
        = ( plus_plus @ int @ ( archim6421214686448440834_floor @ real @ ( log @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( semiring_1_of_nat @ real @ ( divide_divide @ nat @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) @ ( one_one @ int ) ) ) ) ).

% floor_log2_div2
thf(fact_4057_bij__betw__roots__unity,axiom,
    ! [N2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( bij_betw @ nat @ complex
        @ ^ [K3: nat] : ( cis @ ( divide_divide @ real @ ( times_times @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) @ ( semiring_1_of_nat @ real @ K3 ) ) @ ( semiring_1_of_nat @ real @ N2 ) ) )
        @ ( set_ord_lessThan @ nat @ N2 )
        @ ( collect @ complex
          @ ^ [Z6: complex] :
              ( ( power_power @ complex @ Z6 @ N2 )
              = ( one_one @ complex ) ) ) ) ) ).

% bij_betw_roots_unity
thf(fact_4058_arcosh__def,axiom,
    ! [A: $tType] :
      ( ( ln @ A )
     => ( ( arcosh @ A )
        = ( ^ [X5: A] : ( ln_ln @ A @ ( plus_plus @ A @ X5 @ ( powr @ A @ ( minus_minus @ A @ ( power_power @ A @ X5 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ A ) ) @ ( real_Vector_of_real @ A @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ).

% arcosh_def
thf(fact_4059_round__altdef,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ( ( archimedean_round @ A )
        = ( ^ [X5: A] : ( if @ int @ ( ord_less_eq @ A @ ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( archimedean_frac @ A @ X5 ) ) @ ( archimedean_ceiling @ A @ X5 ) @ ( archim6421214686448440834_floor @ A @ X5 ) ) ) ) ) ).

% round_altdef
thf(fact_4060_arsinh__def,axiom,
    ! [A: $tType] :
      ( ( ln @ A )
     => ( ( arsinh @ A )
        = ( ^ [X5: A] : ( ln_ln @ A @ ( plus_plus @ A @ X5 @ ( powr @ A @ ( plus_plus @ A @ ( power_power @ A @ X5 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ A ) ) @ ( real_Vector_of_real @ A @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ).

% arsinh_def
thf(fact_4061_of__real__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( real_V2191834092415804123ebra_1 @ A )
     => ! [X2: real] :
          ( ( ( real_Vector_of_real @ A @ X2 )
            = ( zero_zero @ A ) )
          = ( X2
            = ( zero_zero @ real ) ) ) ) ).

% of_real_eq_0_iff
thf(fact_4062_of__real__0,axiom,
    ! [A: $tType] :
      ( ( real_V2191834092415804123ebra_1 @ A )
     => ( ( real_Vector_of_real @ A @ ( zero_zero @ real ) )
        = ( zero_zero @ A ) ) ) ).

% of_real_0
thf(fact_4063_of__real__eq__1__iff,axiom,
    ! [A: $tType] :
      ( ( real_V2191834092415804123ebra_1 @ A )
     => ! [X2: real] :
          ( ( ( real_Vector_of_real @ A @ X2 )
            = ( one_one @ A ) )
          = ( X2
            = ( one_one @ real ) ) ) ) ).

% of_real_eq_1_iff
thf(fact_4064_of__real__1,axiom,
    ! [A: $tType] :
      ( ( real_V2191834092415804123ebra_1 @ A )
     => ( ( real_Vector_of_real @ A @ ( one_one @ real ) )
        = ( one_one @ A ) ) ) ).

% of_real_1
thf(fact_4065_of__real__mult,axiom,
    ! [A: $tType] :
      ( ( real_V2191834092415804123ebra_1 @ A )
     => ! [X2: real,Y2: real] :
          ( ( real_Vector_of_real @ A @ ( times_times @ real @ X2 @ Y2 ) )
          = ( times_times @ A @ ( real_Vector_of_real @ A @ X2 ) @ ( real_Vector_of_real @ A @ Y2 ) ) ) ) ).

% of_real_mult
thf(fact_4066_of__real__numeral,axiom,
    ! [A: $tType] :
      ( ( real_V2191834092415804123ebra_1 @ A )
     => ! [W: num] :
          ( ( real_Vector_of_real @ A @ ( numeral_numeral @ real @ W ) )
          = ( numeral_numeral @ A @ W ) ) ) ).

% of_real_numeral
thf(fact_4067_of__real__divide,axiom,
    ! [A: $tType] :
      ( ( real_V5047593784448816457lgebra @ A )
     => ! [X2: real,Y2: real] :
          ( ( real_Vector_of_real @ A @ ( divide_divide @ real @ X2 @ Y2 ) )
          = ( divide_divide @ A @ ( real_Vector_of_real @ A @ X2 ) @ ( real_Vector_of_real @ A @ Y2 ) ) ) ) ).

% of_real_divide
thf(fact_4068_of__real__add,axiom,
    ! [A: $tType] :
      ( ( real_V2191834092415804123ebra_1 @ A )
     => ! [X2: real,Y2: real] :
          ( ( real_Vector_of_real @ A @ ( plus_plus @ real @ X2 @ Y2 ) )
          = ( plus_plus @ A @ ( real_Vector_of_real @ A @ X2 ) @ ( real_Vector_of_real @ A @ Y2 ) ) ) ) ).

% of_real_add
thf(fact_4069_of__real__power,axiom,
    ! [A: $tType] :
      ( ( real_V2191834092415804123ebra_1 @ A )
     => ! [X2: real,N2: nat] :
          ( ( real_Vector_of_real @ A @ ( power_power @ real @ X2 @ N2 ) )
          = ( power_power @ A @ ( real_Vector_of_real @ A @ X2 ) @ N2 ) ) ) ).

% of_real_power
thf(fact_4070_frac__of__int,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [Z: int] :
          ( ( archimedean_frac @ A @ ( ring_1_of_int @ A @ Z ) )
          = ( zero_zero @ A ) ) ) ).

% frac_of_int
thf(fact_4071_sin__of__real__pi,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ( ( sin @ A @ ( real_Vector_of_real @ A @ pi ) )
        = ( zero_zero @ A ) ) ) ).

% sin_of_real_pi
thf(fact_4072_of__real__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( real_V2191834092415804123ebra_1 @ A )
     => ! [W: num] :
          ( ( real_Vector_of_real @ A @ ( uminus_uminus @ real @ ( numeral_numeral @ real @ W ) ) )
          = ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) ) ) ).

% of_real_neg_numeral
thf(fact_4073_cos__of__real__pi,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ( ( cos @ A @ ( real_Vector_of_real @ A @ pi ) )
        = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% cos_of_real_pi
thf(fact_4074_exp__pi__i_H,axiom,
    ( ( exp @ complex @ ( times_times @ complex @ imaginary_unit @ ( real_Vector_of_real @ complex @ pi ) ) )
    = ( uminus_uminus @ complex @ ( one_one @ complex ) ) ) ).

% exp_pi_i'
thf(fact_4075_exp__pi__i,axiom,
    ( ( exp @ complex @ ( times_times @ complex @ ( real_Vector_of_real @ complex @ pi ) @ imaginary_unit ) )
    = ( uminus_uminus @ complex @ ( one_one @ complex ) ) ) ).

% exp_pi_i
thf(fact_4076_norm__of__real__add1,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [X2: real] :
          ( ( real_V7770717601297561774m_norm @ A @ ( plus_plus @ A @ ( real_Vector_of_real @ A @ X2 ) @ ( one_one @ A ) ) )
          = ( abs_abs @ real @ ( plus_plus @ real @ X2 @ ( one_one @ real ) ) ) ) ) ).

% norm_of_real_add1
thf(fact_4077_norm__of__real__addn,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [X2: real,B2: num] :
          ( ( real_V7770717601297561774m_norm @ A @ ( plus_plus @ A @ ( real_Vector_of_real @ A @ X2 ) @ ( numeral_numeral @ A @ B2 ) ) )
          = ( abs_abs @ real @ ( plus_plus @ real @ X2 @ ( numeral_numeral @ real @ B2 ) ) ) ) ) ).

% norm_of_real_addn
thf(fact_4078_exp__two__pi__i,axiom,
    ( ( exp @ complex @ ( times_times @ complex @ ( times_times @ complex @ ( numeral_numeral @ complex @ ( bit0 @ one2 ) ) @ ( real_Vector_of_real @ complex @ pi ) ) @ imaginary_unit ) )
    = ( one_one @ complex ) ) ).

% exp_two_pi_i
thf(fact_4079_exp__two__pi__i_H,axiom,
    ( ( exp @ complex @ ( times_times @ complex @ imaginary_unit @ ( times_times @ complex @ ( real_Vector_of_real @ complex @ pi ) @ ( numeral_numeral @ complex @ ( bit0 @ one2 ) ) ) ) )
    = ( one_one @ complex ) ) ).

% exp_two_pi_i'
thf(fact_4080_cos__of__real__pi__half,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V7773925162809079976_field @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ( ( cos @ A @ ( divide_divide @ A @ ( real_Vector_of_real @ A @ pi ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) )
        = ( zero_zero @ A ) ) ) ).

% cos_of_real_pi_half
thf(fact_4081_sin__of__real__pi__half,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V7773925162809079976_field @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ( ( sin @ A @ ( divide_divide @ A @ ( real_Vector_of_real @ A @ pi ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) )
        = ( one_one @ A ) ) ) ).

% sin_of_real_pi_half
thf(fact_4082_complex__exp__exists,axiom,
    ! [Z: complex] :
    ? [A5: complex,R4: real] :
      ( Z
      = ( times_times @ complex @ ( real_Vector_of_real @ complex @ R4 ) @ ( exp @ complex @ A5 ) ) ) ).

% complex_exp_exists
thf(fact_4083_scaleR__conv__of__real,axiom,
    ! [A: $tType] :
      ( ( real_V2191834092415804123ebra_1 @ A )
     => ( ( real_V8093663219630862766scaleR @ A )
        = ( ^ [R5: real] : ( times_times @ A @ ( real_Vector_of_real @ A @ R5 ) ) ) ) ) ).

% scaleR_conv_of_real
thf(fact_4084_of__real__def,axiom,
    ! [A: $tType] :
      ( ( real_V2191834092415804123ebra_1 @ A )
     => ( ( real_Vector_of_real @ A )
        = ( ^ [R5: real] : ( real_V8093663219630862766scaleR @ A @ R5 @ ( one_one @ A ) ) ) ) ) ).

% of_real_def
thf(fact_4085_complex__of__real__def,axiom,
    ( ( real_Vector_of_real @ complex )
    = ( ^ [R5: real] : ( complex2 @ R5 @ ( zero_zero @ real ) ) ) ) ).

% complex_of_real_def
thf(fact_4086_complex__of__real__code,axiom,
    ( ( real_Vector_of_real @ complex )
    = ( ^ [X5: real] : ( complex2 @ X5 @ ( zero_zero @ real ) ) ) ) ).

% complex_of_real_code
thf(fact_4087_complex__eq__cancel__iff2,axiom,
    ! [X2: real,Y2: real,Xa2: real] :
      ( ( ( complex2 @ X2 @ Y2 )
        = ( real_Vector_of_real @ complex @ Xa2 ) )
      = ( ( X2 = Xa2 )
        & ( Y2
          = ( zero_zero @ real ) ) ) ) ).

% complex_eq_cancel_iff2
thf(fact_4088_frac__ge__0,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( archimedean_frac @ A @ X2 ) ) ) ).

% frac_ge_0
thf(fact_4089_frac__lt__1,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A] : ( ord_less @ A @ ( archimedean_frac @ A @ X2 ) @ ( one_one @ A ) ) ) ).

% frac_lt_1
thf(fact_4090_frac__1__eq,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A] :
          ( ( archimedean_frac @ A @ ( plus_plus @ A @ X2 @ ( one_one @ A ) ) )
          = ( archimedean_frac @ A @ X2 ) ) ) ).

% frac_1_eq
thf(fact_4091_nonzero__of__real__divide,axiom,
    ! [A: $tType] :
      ( ( real_V7773925162809079976_field @ A )
     => ! [Y2: real,X2: real] :
          ( ( Y2
           != ( zero_zero @ real ) )
         => ( ( real_Vector_of_real @ A @ ( divide_divide @ real @ X2 @ Y2 ) )
            = ( divide_divide @ A @ ( real_Vector_of_real @ A @ X2 ) @ ( real_Vector_of_real @ A @ Y2 ) ) ) ) ) ).

% nonzero_of_real_divide
thf(fact_4092_nonzero__of__real__inverse,axiom,
    ! [A: $tType] :
      ( ( real_V5047593784448816457lgebra @ A )
     => ! [X2: real] :
          ( ( X2
           != ( zero_zero @ real ) )
         => ( ( real_Vector_of_real @ A @ ( inverse_inverse @ real @ X2 ) )
            = ( inverse_inverse @ A @ ( real_Vector_of_real @ A @ X2 ) ) ) ) ) ).

% nonzero_of_real_inverse
thf(fact_4093_Complex__mult__complex__of__real,axiom,
    ! [X2: real,Y2: real,R3: real] :
      ( ( times_times @ complex @ ( complex2 @ X2 @ Y2 ) @ ( real_Vector_of_real @ complex @ R3 ) )
      = ( complex2 @ ( times_times @ real @ X2 @ R3 ) @ ( times_times @ real @ Y2 @ R3 ) ) ) ).

% Complex_mult_complex_of_real
thf(fact_4094_complex__of__real__mult__Complex,axiom,
    ! [R3: real,X2: real,Y2: real] :
      ( ( times_times @ complex @ ( real_Vector_of_real @ complex @ R3 ) @ ( complex2 @ X2 @ Y2 ) )
      = ( complex2 @ ( times_times @ real @ R3 @ X2 ) @ ( times_times @ real @ R3 @ Y2 ) ) ) ).

% complex_of_real_mult_Complex
thf(fact_4095_cis__conv__exp,axiom,
    ( cis
    = ( ^ [B4: real] : ( exp @ complex @ ( times_times @ complex @ imaginary_unit @ ( real_Vector_of_real @ complex @ B4 ) ) ) ) ) ).

% cis_conv_exp
thf(fact_4096_norm__less__p1,axiom,
    ! [A: $tType] :
      ( ( real_V2822296259951069270ebra_1 @ A )
     => ! [X2: A] : ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ X2 ) @ ( real_V7770717601297561774m_norm @ A @ ( plus_plus @ A @ ( real_Vector_of_real @ A @ ( real_V7770717601297561774m_norm @ A @ X2 ) ) @ ( one_one @ A ) ) ) ) ) ).

% norm_less_p1
thf(fact_4097_complex__of__real__i,axiom,
    ! [R3: real] :
      ( ( times_times @ complex @ ( real_Vector_of_real @ complex @ R3 ) @ imaginary_unit )
      = ( complex2 @ ( zero_zero @ real ) @ R3 ) ) ).

% complex_of_real_i
thf(fact_4098_i__complex__of__real,axiom,
    ! [R3: real] :
      ( ( times_times @ complex @ imaginary_unit @ ( real_Vector_of_real @ complex @ R3 ) )
      = ( complex2 @ ( zero_zero @ real ) @ R3 ) ) ).

% i_complex_of_real
thf(fact_4099_Complex__eq,axiom,
    ( complex2
    = ( ^ [A4: real,B4: real] : ( plus_plus @ complex @ ( real_Vector_of_real @ complex @ A4 ) @ ( times_times @ complex @ imaginary_unit @ ( real_Vector_of_real @ complex @ B4 ) ) ) ) ) ).

% Complex_eq
thf(fact_4100_norm__of__real__diff,axiom,
    ! [A: $tType] :
      ( ( real_V2822296259951069270ebra_1 @ A )
     => ! [B2: real,A2: real] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ ( real_Vector_of_real @ A @ B2 ) @ ( real_Vector_of_real @ A @ A2 ) ) ) @ ( abs_abs @ real @ ( minus_minus @ real @ B2 @ A2 ) ) ) ) ).

% norm_of_real_diff
thf(fact_4101_frac__eq,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A] :
          ( ( ( archimedean_frac @ A @ X2 )
            = X2 )
          = ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X2 )
            & ( ord_less @ A @ X2 @ ( one_one @ A ) ) ) ) ) ).

% frac_eq
thf(fact_4102_frac__add,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A,Y2: A] :
          ( ( ( ord_less @ A @ ( plus_plus @ A @ ( archimedean_frac @ A @ X2 ) @ ( archimedean_frac @ A @ Y2 ) ) @ ( one_one @ A ) )
           => ( ( archimedean_frac @ A @ ( plus_plus @ A @ X2 @ Y2 ) )
              = ( plus_plus @ A @ ( archimedean_frac @ A @ X2 ) @ ( archimedean_frac @ A @ Y2 ) ) ) )
          & ( ~ ( ord_less @ A @ ( plus_plus @ A @ ( archimedean_frac @ A @ X2 ) @ ( archimedean_frac @ A @ Y2 ) ) @ ( one_one @ A ) )
           => ( ( archimedean_frac @ A @ ( plus_plus @ A @ X2 @ Y2 ) )
              = ( minus_minus @ A @ ( plus_plus @ A @ ( archimedean_frac @ A @ X2 ) @ ( archimedean_frac @ A @ Y2 ) ) @ ( one_one @ A ) ) ) ) ) ) ).

% frac_add
thf(fact_4103_complex__split__polar,axiom,
    ! [Z: complex] :
    ? [R4: real,A5: real] :
      ( Z
      = ( times_times @ complex @ ( real_Vector_of_real @ complex @ R4 ) @ ( plus_plus @ complex @ ( real_Vector_of_real @ complex @ ( cos @ real @ A5 ) ) @ ( times_times @ complex @ imaginary_unit @ ( real_Vector_of_real @ complex @ ( sin @ real @ A5 ) ) ) ) ) ) ).

% complex_split_polar
thf(fact_4104_cos__int__times__real,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [M: int,X2: real] :
          ( ( cos @ A @ ( times_times @ A @ ( ring_1_of_int @ A @ M ) @ ( real_Vector_of_real @ A @ X2 ) ) )
          = ( real_Vector_of_real @ A @ ( cos @ real @ ( times_times @ real @ ( ring_1_of_int @ real @ M ) @ X2 ) ) ) ) ) ).

% cos_int_times_real
thf(fact_4105_sin__int__times__real,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [M: int,X2: real] :
          ( ( sin @ A @ ( times_times @ A @ ( ring_1_of_int @ A @ M ) @ ( real_Vector_of_real @ A @ X2 ) ) )
          = ( real_Vector_of_real @ A @ ( sin @ real @ ( times_times @ real @ ( ring_1_of_int @ real @ M ) @ X2 ) ) ) ) ) ).

% sin_int_times_real
thf(fact_4106_sin__cos__eq,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ( ( sin @ A )
        = ( ^ [X5: A] : ( cos @ A @ ( minus_minus @ A @ ( divide_divide @ A @ ( real_Vector_of_real @ A @ pi ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ X5 ) ) ) ) ) ).

% sin_cos_eq
thf(fact_4107_cos__sin__eq,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ( ( cos @ A )
        = ( ^ [X5: A] : ( sin @ A @ ( minus_minus @ A @ ( divide_divide @ A @ ( real_Vector_of_real @ A @ pi ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ X5 ) ) ) ) ) ).

% cos_sin_eq
thf(fact_4108_cmod__unit__one,axiom,
    ! [A2: real] :
      ( ( real_V7770717601297561774m_norm @ complex @ ( plus_plus @ complex @ ( real_Vector_of_real @ complex @ ( cos @ real @ A2 ) ) @ ( times_times @ complex @ imaginary_unit @ ( real_Vector_of_real @ complex @ ( sin @ real @ A2 ) ) ) ) )
      = ( one_one @ real ) ) ).

% cmod_unit_one
thf(fact_4109_cmod__complex__polar,axiom,
    ! [R3: real,A2: real] :
      ( ( real_V7770717601297561774m_norm @ complex @ ( times_times @ complex @ ( real_Vector_of_real @ complex @ R3 ) @ ( plus_plus @ complex @ ( real_Vector_of_real @ complex @ ( cos @ real @ A2 ) ) @ ( times_times @ complex @ imaginary_unit @ ( real_Vector_of_real @ complex @ ( sin @ real @ A2 ) ) ) ) ) )
      = ( abs_abs @ real @ R3 ) ) ).

% cmod_complex_polar
thf(fact_4110_floor__add,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A,Y2: A] :
          ( ( ( ord_less @ A @ ( plus_plus @ A @ ( archimedean_frac @ A @ X2 ) @ ( archimedean_frac @ A @ Y2 ) ) @ ( one_one @ A ) )
           => ( ( archim6421214686448440834_floor @ A @ ( plus_plus @ A @ X2 @ Y2 ) )
              = ( plus_plus @ int @ ( archim6421214686448440834_floor @ A @ X2 ) @ ( archim6421214686448440834_floor @ A @ Y2 ) ) ) )
          & ( ~ ( ord_less @ A @ ( plus_plus @ A @ ( archimedean_frac @ A @ X2 ) @ ( archimedean_frac @ A @ Y2 ) ) @ ( one_one @ A ) )
           => ( ( archim6421214686448440834_floor @ A @ ( plus_plus @ A @ X2 @ Y2 ) )
              = ( plus_plus @ int @ ( plus_plus @ int @ ( archim6421214686448440834_floor @ A @ X2 ) @ ( archim6421214686448440834_floor @ A @ Y2 ) ) @ ( one_one @ int ) ) ) ) ) ) ).

% floor_add
thf(fact_4111_minus__sin__cos__eq,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X2: A] :
          ( ( uminus_uminus @ A @ ( sin @ A @ X2 ) )
          = ( cos @ A @ ( plus_plus @ A @ X2 @ ( divide_divide @ A @ ( real_Vector_of_real @ A @ pi ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% minus_sin_cos_eq
thf(fact_4112_csqrt__ii,axiom,
    ( ( csqrt @ imaginary_unit )
    = ( divide_divide @ complex @ ( plus_plus @ complex @ ( one_one @ complex ) @ imaginary_unit ) @ ( real_Vector_of_real @ complex @ ( sqrt @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ).

% csqrt_ii
thf(fact_4113_modulo__int__unfold,axiom,
    ! [L: int,K: int,N2: nat,M: nat] :
      ( ( ( ( ( sgn_sgn @ int @ L )
            = ( zero_zero @ int ) )
          | ( ( sgn_sgn @ int @ K )
            = ( zero_zero @ int ) )
          | ( N2
            = ( zero_zero @ nat ) ) )
       => ( ( modulo_modulo @ int @ ( times_times @ int @ ( sgn_sgn @ int @ K ) @ ( semiring_1_of_nat @ int @ M ) ) @ ( times_times @ int @ ( sgn_sgn @ int @ L ) @ ( semiring_1_of_nat @ int @ N2 ) ) )
          = ( times_times @ int @ ( sgn_sgn @ int @ K ) @ ( semiring_1_of_nat @ int @ M ) ) ) )
      & ( ~ ( ( ( sgn_sgn @ int @ L )
              = ( zero_zero @ int ) )
            | ( ( sgn_sgn @ int @ K )
              = ( zero_zero @ int ) )
            | ( N2
              = ( zero_zero @ nat ) ) )
       => ( ( ( ( sgn_sgn @ int @ K )
              = ( sgn_sgn @ int @ L ) )
           => ( ( modulo_modulo @ int @ ( times_times @ int @ ( sgn_sgn @ int @ K ) @ ( semiring_1_of_nat @ int @ M ) ) @ ( times_times @ int @ ( sgn_sgn @ int @ L ) @ ( semiring_1_of_nat @ int @ N2 ) ) )
              = ( times_times @ int @ ( sgn_sgn @ int @ L ) @ ( semiring_1_of_nat @ int @ ( modulo_modulo @ nat @ M @ N2 ) ) ) ) )
          & ( ( ( sgn_sgn @ int @ K )
             != ( sgn_sgn @ int @ L ) )
           => ( ( modulo_modulo @ int @ ( times_times @ int @ ( sgn_sgn @ int @ K ) @ ( semiring_1_of_nat @ int @ M ) ) @ ( times_times @ int @ ( sgn_sgn @ int @ L ) @ ( semiring_1_of_nat @ int @ N2 ) ) )
              = ( times_times @ int @ ( sgn_sgn @ int @ L )
                @ ( minus_minus @ int
                  @ ( semiring_1_of_nat @ int
                    @ ( times_times @ nat @ N2
                      @ ( zero_neq_one_of_bool @ nat
                        @ ~ ( dvd_dvd @ nat @ N2 @ M ) ) ) )
                  @ ( semiring_1_of_nat @ int @ ( modulo_modulo @ nat @ M @ N2 ) ) ) ) ) ) ) ) ) ).

% modulo_int_unfold
thf(fact_4114_powr__int,axiom,
    ! [X2: real,I3: int] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ I3 )
         => ( ( powr @ real @ X2 @ ( ring_1_of_int @ real @ I3 ) )
            = ( power_power @ real @ X2 @ ( nat2 @ I3 ) ) ) )
        & ( ~ ( ord_less_eq @ int @ ( zero_zero @ int ) @ I3 )
         => ( ( powr @ real @ X2 @ ( ring_1_of_int @ real @ I3 ) )
            = ( divide_divide @ real @ ( one_one @ real ) @ ( power_power @ real @ X2 @ ( nat2 @ ( uminus_uminus @ int @ I3 ) ) ) ) ) ) ) ) ).

% powr_int
thf(fact_4115_divide__int__unfold,axiom,
    ! [L: int,K: int,N2: nat,M: nat] :
      ( ( ( ( ( sgn_sgn @ int @ L )
            = ( zero_zero @ int ) )
          | ( ( sgn_sgn @ int @ K )
            = ( zero_zero @ int ) )
          | ( N2
            = ( zero_zero @ nat ) ) )
       => ( ( divide_divide @ int @ ( times_times @ int @ ( sgn_sgn @ int @ K ) @ ( semiring_1_of_nat @ int @ M ) ) @ ( times_times @ int @ ( sgn_sgn @ int @ L ) @ ( semiring_1_of_nat @ int @ N2 ) ) )
          = ( zero_zero @ int ) ) )
      & ( ~ ( ( ( sgn_sgn @ int @ L )
              = ( zero_zero @ int ) )
            | ( ( sgn_sgn @ int @ K )
              = ( zero_zero @ int ) )
            | ( N2
              = ( zero_zero @ nat ) ) )
       => ( ( ( ( sgn_sgn @ int @ K )
              = ( sgn_sgn @ int @ L ) )
           => ( ( divide_divide @ int @ ( times_times @ int @ ( sgn_sgn @ int @ K ) @ ( semiring_1_of_nat @ int @ M ) ) @ ( times_times @ int @ ( sgn_sgn @ int @ L ) @ ( semiring_1_of_nat @ int @ N2 ) ) )
              = ( semiring_1_of_nat @ int @ ( divide_divide @ nat @ M @ N2 ) ) ) )
          & ( ( ( sgn_sgn @ int @ K )
             != ( sgn_sgn @ int @ L ) )
           => ( ( divide_divide @ int @ ( times_times @ int @ ( sgn_sgn @ int @ K ) @ ( semiring_1_of_nat @ int @ M ) ) @ ( times_times @ int @ ( sgn_sgn @ int @ L ) @ ( semiring_1_of_nat @ int @ N2 ) ) )
              = ( uminus_uminus @ int
                @ ( semiring_1_of_nat @ int
                  @ ( plus_plus @ nat @ ( divide_divide @ nat @ M @ N2 )
                    @ ( zero_neq_one_of_bool @ nat
                      @ ~ ( dvd_dvd @ nat @ N2 @ M ) ) ) ) ) ) ) ) ) ) ).

% divide_int_unfold
thf(fact_4116_sgn__sgn,axiom,
    ! [A: $tType] :
      ( ( idom_abs_sgn @ A )
     => ! [A2: A] :
          ( ( sgn_sgn @ A @ ( sgn_sgn @ A @ A2 ) )
          = ( sgn_sgn @ A @ A2 ) ) ) ).

% sgn_sgn
thf(fact_4117_sgn__0,axiom,
    ! [A: $tType] :
      ( ( idom_abs_sgn @ A )
     => ( ( sgn_sgn @ A @ ( zero_zero @ A ) )
        = ( zero_zero @ A ) ) ) ).

% sgn_0
thf(fact_4118_sgn__zero,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ( ( sgn_sgn @ A @ ( zero_zero @ A ) )
        = ( zero_zero @ A ) ) ) ).

% sgn_zero
thf(fact_4119_sgn__1,axiom,
    ! [A: $tType] :
      ( ( idom_abs_sgn @ A )
     => ( ( sgn_sgn @ A @ ( one_one @ A ) )
        = ( one_one @ A ) ) ) ).

% sgn_1
thf(fact_4120_sgn__one,axiom,
    ! [A: $tType] :
      ( ( real_V2822296259951069270ebra_1 @ A )
     => ( ( sgn_sgn @ A @ ( one_one @ A ) )
        = ( one_one @ A ) ) ) ).

% sgn_one
thf(fact_4121_sgn__divide,axiom,
    ! [A: $tType] :
      ( ( field_abs_sgn @ A )
     => ! [A2: A,B2: A] :
          ( ( sgn_sgn @ A @ ( divide_divide @ A @ A2 @ B2 ) )
          = ( divide_divide @ A @ ( sgn_sgn @ A @ A2 ) @ ( sgn_sgn @ A @ B2 ) ) ) ) ).

% sgn_divide
thf(fact_4122_idom__abs__sgn__class_Osgn__minus,axiom,
    ! [A: $tType] :
      ( ( idom_abs_sgn @ A )
     => ! [A2: A] :
          ( ( sgn_sgn @ A @ ( uminus_uminus @ A @ A2 ) )
          = ( uminus_uminus @ A @ ( sgn_sgn @ A @ A2 ) ) ) ) ).

% idom_abs_sgn_class.sgn_minus
thf(fact_4123_power__sgn,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A,N2: nat] :
          ( ( sgn_sgn @ A @ ( power_power @ A @ A2 @ N2 ) )
          = ( power_power @ A @ ( sgn_sgn @ A @ A2 ) @ N2 ) ) ) ).

% power_sgn
thf(fact_4124_sgn__inverse,axiom,
    ! [A: $tType] :
      ( ( field_abs_sgn @ A )
     => ! [A2: A] :
          ( ( sgn_sgn @ A @ ( inverse_inverse @ A @ A2 ) )
          = ( inverse_inverse @ A @ ( sgn_sgn @ A @ A2 ) ) ) ) ).

% sgn_inverse
thf(fact_4125_inverse__sgn,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A] :
          ( ( inverse_inverse @ A @ ( sgn_sgn @ A @ A2 ) )
          = ( sgn_sgn @ A @ A2 ) ) ) ).

% inverse_sgn
thf(fact_4126_csqrt__0,axiom,
    ( ( csqrt @ ( zero_zero @ complex ) )
    = ( zero_zero @ complex ) ) ).

% csqrt_0
thf(fact_4127_csqrt__eq__0,axiom,
    ! [Z: complex] :
      ( ( ( csqrt @ Z )
        = ( zero_zero @ complex ) )
      = ( Z
        = ( zero_zero @ complex ) ) ) ).

% csqrt_eq_0
thf(fact_4128_sgn__less,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( sgn_sgn @ A @ A2 ) @ ( zero_zero @ A ) )
          = ( ord_less @ A @ A2 @ ( zero_zero @ A ) ) ) ) ).

% sgn_less
thf(fact_4129_sgn__greater,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( sgn_sgn @ A @ A2 ) )
          = ( ord_less @ A @ ( zero_zero @ A ) @ A2 ) ) ) ).

% sgn_greater
thf(fact_4130_divide__sgn,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( divide_divide @ A @ A2 @ ( sgn_sgn @ A @ B2 ) )
          = ( times_times @ A @ A2 @ ( sgn_sgn @ A @ B2 ) ) ) ) ).

% divide_sgn
thf(fact_4131_nat__numeral,axiom,
    ! [K: num] :
      ( ( nat2 @ ( numeral_numeral @ int @ K ) )
      = ( numeral_numeral @ nat @ K ) ) ).

% nat_numeral
thf(fact_4132_sgn__pos,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( sgn_sgn @ A @ A2 )
            = ( one_one @ A ) ) ) ) ).

% sgn_pos
thf(fact_4133_abs__sgn__eq__1,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( abs_abs @ A @ ( sgn_sgn @ A @ A2 ) )
            = ( one_one @ A ) ) ) ) ).

% abs_sgn_eq_1
thf(fact_4134_nat__1,axiom,
    ( ( nat2 @ ( one_one @ int ) )
    = ( suc @ ( zero_zero @ nat ) ) ) ).

% nat_1
thf(fact_4135_sgn__mult__self__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A] :
          ( ( times_times @ A @ ( sgn_sgn @ A @ A2 ) @ ( sgn_sgn @ A @ A2 ) )
          = ( zero_neq_one_of_bool @ A
            @ ( A2
             != ( zero_zero @ A ) ) ) ) ) ).

% sgn_mult_self_eq
thf(fact_4136_nat__le__0,axiom,
    ! [Z: int] :
      ( ( ord_less_eq @ int @ Z @ ( zero_zero @ int ) )
     => ( ( nat2 @ Z )
        = ( zero_zero @ nat ) ) ) ).

% nat_le_0
thf(fact_4137_nat__0__iff,axiom,
    ! [I3: int] :
      ( ( ( nat2 @ I3 )
        = ( zero_zero @ nat ) )
      = ( ord_less_eq @ int @ I3 @ ( zero_zero @ int ) ) ) ).

% nat_0_iff
thf(fact_4138_zless__nat__conj,axiom,
    ! [W: int,Z: int] :
      ( ( ord_less @ nat @ ( nat2 @ W ) @ ( nat2 @ Z ) )
      = ( ( ord_less @ int @ ( zero_zero @ int ) @ Z )
        & ( ord_less @ int @ W @ Z ) ) ) ).

% zless_nat_conj
thf(fact_4139_nat__neg__numeral,axiom,
    ! [K: num] :
      ( ( nat2 @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ K ) ) )
      = ( zero_zero @ nat ) ) ).

% nat_neg_numeral
thf(fact_4140_idom__abs__sgn__class_Oabs__sgn,axiom,
    ! [A: $tType] :
      ( ( idom_abs_sgn @ A )
     => ! [A2: A] :
          ( ( sgn_sgn @ A @ ( abs_abs @ A @ A2 ) )
          = ( zero_neq_one_of_bool @ A
            @ ( A2
             != ( zero_zero @ A ) ) ) ) ) ).

% idom_abs_sgn_class.abs_sgn
thf(fact_4141_sgn__abs,axiom,
    ! [A: $tType] :
      ( ( idom_abs_sgn @ A )
     => ! [A2: A] :
          ( ( abs_abs @ A @ ( sgn_sgn @ A @ A2 ) )
          = ( zero_neq_one_of_bool @ A
            @ ( A2
             != ( zero_zero @ A ) ) ) ) ) ).

% sgn_abs
thf(fact_4142_nat__zminus__int,axiom,
    ! [N2: nat] :
      ( ( nat2 @ ( uminus_uminus @ int @ ( semiring_1_of_nat @ int @ N2 ) ) )
      = ( zero_zero @ nat ) ) ).

% nat_zminus_int
thf(fact_4143_int__nat__eq,axiom,
    ! [Z: int] :
      ( ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Z )
       => ( ( semiring_1_of_nat @ int @ ( nat2 @ Z ) )
          = Z ) )
      & ( ~ ( ord_less_eq @ int @ ( zero_zero @ int ) @ Z )
       => ( ( semiring_1_of_nat @ int @ ( nat2 @ Z ) )
          = ( zero_zero @ int ) ) ) ) ).

% int_nat_eq
thf(fact_4144_of__nat__nat__take__bit__eq,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [N2: nat,K: int] :
          ( ( semiring_1_of_nat @ A @ ( nat2 @ ( bit_se2584673776208193580ke_bit @ int @ N2 @ K ) ) )
          = ( ring_1_of_int @ A @ ( bit_se2584673776208193580ke_bit @ int @ N2 @ K ) ) ) ) ).

% of_nat_nat_take_bit_eq
thf(fact_4145_dvd__mult__sgn__iff,axiom,
    ! [L: int,K: int,R3: int] :
      ( ( dvd_dvd @ int @ L @ ( times_times @ int @ K @ ( sgn_sgn @ int @ R3 ) ) )
      = ( ( dvd_dvd @ int @ L @ K )
        | ( R3
          = ( zero_zero @ int ) ) ) ) ).

% dvd_mult_sgn_iff
thf(fact_4146_dvd__sgn__mult__iff,axiom,
    ! [L: int,R3: int,K: int] :
      ( ( dvd_dvd @ int @ L @ ( times_times @ int @ ( sgn_sgn @ int @ R3 ) @ K ) )
      = ( ( dvd_dvd @ int @ L @ K )
        | ( R3
          = ( zero_zero @ int ) ) ) ) ).

% dvd_sgn_mult_iff
thf(fact_4147_mult__sgn__dvd__iff,axiom,
    ! [L: int,R3: int,K: int] :
      ( ( dvd_dvd @ int @ ( times_times @ int @ L @ ( sgn_sgn @ int @ R3 ) ) @ K )
      = ( ( dvd_dvd @ int @ L @ K )
        & ( ( R3
            = ( zero_zero @ int ) )
         => ( K
            = ( zero_zero @ int ) ) ) ) ) ).

% mult_sgn_dvd_iff
thf(fact_4148_sgn__mult__dvd__iff,axiom,
    ! [R3: int,L: int,K: int] :
      ( ( dvd_dvd @ int @ ( times_times @ int @ ( sgn_sgn @ int @ R3 ) @ L ) @ K )
      = ( ( dvd_dvd @ int @ L @ K )
        & ( ( R3
            = ( zero_zero @ int ) )
         => ( K
            = ( zero_zero @ int ) ) ) ) ) ).

% sgn_mult_dvd_iff
thf(fact_4149_sgn__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
         => ( ( sgn_sgn @ A @ A2 )
            = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ) ).

% sgn_neg
thf(fact_4150_zero__less__nat__eq,axiom,
    ! [Z: int] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( nat2 @ Z ) )
      = ( ord_less @ int @ ( zero_zero @ int ) @ Z ) ) ).

% zero_less_nat_eq
thf(fact_4151_of__nat__nat,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [Z: int] :
          ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Z )
         => ( ( semiring_1_of_nat @ A @ ( nat2 @ Z ) )
            = ( ring_1_of_int @ A @ Z ) ) ) ) ).

% of_nat_nat
thf(fact_4152_sgn__of__nat,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N2: nat] :
          ( ( sgn_sgn @ A @ ( semiring_1_of_nat @ A @ N2 ) )
          = ( zero_neq_one_of_bool @ A @ ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 ) ) ) ) ).

% sgn_of_nat
thf(fact_4153_diff__nat__numeral,axiom,
    ! [V: num,V4: num] :
      ( ( minus_minus @ nat @ ( numeral_numeral @ nat @ V ) @ ( numeral_numeral @ nat @ V4 ) )
      = ( nat2 @ ( minus_minus @ int @ ( numeral_numeral @ int @ V ) @ ( numeral_numeral @ int @ V4 ) ) ) ) ).

% diff_nat_numeral
thf(fact_4154_nat__eq__numeral__power__cancel__iff,axiom,
    ! [Y2: int,X2: num,N2: nat] :
      ( ( ( nat2 @ Y2 )
        = ( power_power @ nat @ ( numeral_numeral @ nat @ X2 ) @ N2 ) )
      = ( Y2
        = ( power_power @ int @ ( numeral_numeral @ int @ X2 ) @ N2 ) ) ) ).

% nat_eq_numeral_power_cancel_iff
thf(fact_4155_numeral__power__eq__nat__cancel__iff,axiom,
    ! [X2: num,N2: nat,Y2: int] :
      ( ( ( power_power @ nat @ ( numeral_numeral @ nat @ X2 ) @ N2 )
        = ( nat2 @ Y2 ) )
      = ( ( power_power @ int @ ( numeral_numeral @ int @ X2 ) @ N2 )
        = Y2 ) ) ).

% numeral_power_eq_nat_cancel_iff
thf(fact_4156_power2__csqrt,axiom,
    ! [Z: complex] :
      ( ( power_power @ complex @ ( csqrt @ Z ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
      = Z ) ).

% power2_csqrt
thf(fact_4157_nat__ceiling__le__eq,axiom,
    ! [X2: real,A2: nat] :
      ( ( ord_less_eq @ nat @ ( nat2 @ ( archimedean_ceiling @ real @ X2 ) ) @ A2 )
      = ( ord_less_eq @ real @ X2 @ ( semiring_1_of_nat @ real @ A2 ) ) ) ).

% nat_ceiling_le_eq
thf(fact_4158_one__less__nat__eq,axiom,
    ! [Z: int] :
      ( ( ord_less @ nat @ ( suc @ ( zero_zero @ nat ) ) @ ( nat2 @ Z ) )
      = ( ord_less @ int @ ( one_one @ int ) @ Z ) ) ).

% one_less_nat_eq
thf(fact_4159_nat__numeral__diff__1,axiom,
    ! [V: num] :
      ( ( minus_minus @ nat @ ( numeral_numeral @ nat @ V ) @ ( one_one @ nat ) )
      = ( nat2 @ ( minus_minus @ int @ ( numeral_numeral @ int @ V ) @ ( one_one @ int ) ) ) ) ).

% nat_numeral_diff_1
thf(fact_4160_nat__less__numeral__power__cancel__iff,axiom,
    ! [A2: int,X2: num,N2: nat] :
      ( ( ord_less @ nat @ ( nat2 @ A2 ) @ ( power_power @ nat @ ( numeral_numeral @ nat @ X2 ) @ N2 ) )
      = ( ord_less @ int @ A2 @ ( power_power @ int @ ( numeral_numeral @ int @ X2 ) @ N2 ) ) ) ).

% nat_less_numeral_power_cancel_iff
thf(fact_4161_numeral__power__less__nat__cancel__iff,axiom,
    ! [X2: num,N2: nat,A2: int] :
      ( ( ord_less @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ X2 ) @ N2 ) @ ( nat2 @ A2 ) )
      = ( ord_less @ int @ ( power_power @ int @ ( numeral_numeral @ int @ X2 ) @ N2 ) @ A2 ) ) ).

% numeral_power_less_nat_cancel_iff
thf(fact_4162_nat__le__numeral__power__cancel__iff,axiom,
    ! [A2: int,X2: num,N2: nat] :
      ( ( ord_less_eq @ nat @ ( nat2 @ A2 ) @ ( power_power @ nat @ ( numeral_numeral @ nat @ X2 ) @ N2 ) )
      = ( ord_less_eq @ int @ A2 @ ( power_power @ int @ ( numeral_numeral @ int @ X2 ) @ N2 ) ) ) ).

% nat_le_numeral_power_cancel_iff
thf(fact_4163_numeral__power__le__nat__cancel__iff,axiom,
    ! [X2: num,N2: nat,A2: int] :
      ( ( ord_less_eq @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ X2 ) @ N2 ) @ ( nat2 @ A2 ) )
      = ( ord_less_eq @ int @ ( power_power @ int @ ( numeral_numeral @ int @ X2 ) @ N2 ) @ A2 ) ) ).

% numeral_power_le_nat_cancel_iff
thf(fact_4164_sgn__zero__iff,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X2: A] :
          ( ( ( sgn_sgn @ A @ X2 )
            = ( zero_zero @ A ) )
          = ( X2
            = ( zero_zero @ A ) ) ) ) ).

% sgn_zero_iff
thf(fact_4165_sgn__0__0,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A] :
          ( ( ( sgn_sgn @ A @ A2 )
            = ( zero_zero @ A ) )
          = ( A2
            = ( zero_zero @ A ) ) ) ) ).

% sgn_0_0
thf(fact_4166_sgn__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( idom_abs_sgn @ A )
     => ! [A2: A] :
          ( ( ( sgn_sgn @ A @ A2 )
            = ( zero_zero @ A ) )
          = ( A2
            = ( zero_zero @ A ) ) ) ) ).

% sgn_eq_0_iff
thf(fact_4167_same__sgn__sgn__add,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [B2: A,A2: A] :
          ( ( ( sgn_sgn @ A @ B2 )
            = ( sgn_sgn @ A @ A2 ) )
         => ( ( sgn_sgn @ A @ ( plus_plus @ A @ A2 @ B2 ) )
            = ( sgn_sgn @ A @ A2 ) ) ) ) ).

% same_sgn_sgn_add
thf(fact_4168_Real__Vector__Spaces_Osgn__mult,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [X2: A,Y2: A] :
          ( ( sgn_sgn @ A @ ( times_times @ A @ X2 @ Y2 ) )
          = ( times_times @ A @ ( sgn_sgn @ A @ X2 ) @ ( sgn_sgn @ A @ Y2 ) ) ) ) ).

% Real_Vector_Spaces.sgn_mult
thf(fact_4169_sgn__mult,axiom,
    ! [A: $tType] :
      ( ( idom_abs_sgn @ A )
     => ! [A2: A,B2: A] :
          ( ( sgn_sgn @ A @ ( times_times @ A @ A2 @ B2 ) )
          = ( times_times @ A @ ( sgn_sgn @ A @ A2 ) @ ( sgn_sgn @ A @ B2 ) ) ) ) ).

% sgn_mult
thf(fact_4170_sgn__not__eq__imp,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [B2: A,A2: A] :
          ( ( ( sgn_sgn @ A @ B2 )
           != ( sgn_sgn @ A @ A2 ) )
         => ( ( ( sgn_sgn @ A @ A2 )
             != ( zero_zero @ A ) )
           => ( ( ( sgn_sgn @ A @ B2 )
               != ( zero_zero @ A ) )
             => ( ( sgn_sgn @ A @ A2 )
                = ( uminus_uminus @ A @ ( sgn_sgn @ A @ B2 ) ) ) ) ) ) ) ).

% sgn_not_eq_imp
thf(fact_4171_sgn__minus__1,axiom,
    ! [A: $tType] :
      ( ( idom_abs_sgn @ A )
     => ( ( sgn_sgn @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
        = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% sgn_minus_1
thf(fact_4172_nat__zero__as__int,axiom,
    ( ( zero_zero @ nat )
    = ( nat2 @ ( zero_zero @ int ) ) ) ).

% nat_zero_as_int
thf(fact_4173_nat__numeral__as__int,axiom,
    ( ( numeral_numeral @ nat )
    = ( ^ [I4: num] : ( nat2 @ ( numeral_numeral @ int @ I4 ) ) ) ) ).

% nat_numeral_as_int
thf(fact_4174_linordered__idom__class_Oabs__sgn,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ( ( abs_abs @ A )
        = ( ^ [K3: A] : ( times_times @ A @ K3 @ ( sgn_sgn @ A @ K3 ) ) ) ) ) ).

% linordered_idom_class.abs_sgn
thf(fact_4175_abs__mult__sgn,axiom,
    ! [A: $tType] :
      ( ( idom_abs_sgn @ A )
     => ! [A2: A] :
          ( ( times_times @ A @ ( abs_abs @ A @ A2 ) @ ( sgn_sgn @ A @ A2 ) )
          = A2 ) ) ).

% abs_mult_sgn
thf(fact_4176_sgn__mult__abs,axiom,
    ! [A: $tType] :
      ( ( idom_abs_sgn @ A )
     => ! [A2: A] :
          ( ( times_times @ A @ ( sgn_sgn @ A @ A2 ) @ ( abs_abs @ A @ A2 ) )
          = A2 ) ) ).

% sgn_mult_abs
thf(fact_4177_mult__sgn__abs,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X2: A] :
          ( ( times_times @ A @ ( sgn_sgn @ A @ X2 ) @ ( abs_abs @ A @ X2 ) )
          = X2 ) ) ).

% mult_sgn_abs
thf(fact_4178_nat__mono,axiom,
    ! [X2: int,Y2: int] :
      ( ( ord_less_eq @ int @ X2 @ Y2 )
     => ( ord_less_eq @ nat @ ( nat2 @ X2 ) @ ( nat2 @ Y2 ) ) ) ).

% nat_mono
thf(fact_4179_int__sgnE,axiom,
    ! [K: int] :
      ~ ! [N: nat,L4: int] :
          ( K
         != ( times_times @ int @ ( sgn_sgn @ int @ L4 ) @ ( semiring_1_of_nat @ int @ N ) ) ) ).

% int_sgnE
thf(fact_4180_same__sgn__abs__add,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [B2: A,A2: A] :
          ( ( ( sgn_sgn @ A @ B2 )
            = ( sgn_sgn @ A @ A2 ) )
         => ( ( abs_abs @ A @ ( plus_plus @ A @ A2 @ B2 ) )
            = ( plus_plus @ A @ ( abs_abs @ A @ A2 ) @ ( abs_abs @ A @ B2 ) ) ) ) ) ).

% same_sgn_abs_add
thf(fact_4181_eq__nat__nat__iff,axiom,
    ! [Z: int,Z7: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Z )
     => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Z7 )
       => ( ( ( nat2 @ Z )
            = ( nat2 @ Z7 ) )
          = ( Z = Z7 ) ) ) ) ).

% eq_nat_nat_iff
thf(fact_4182_all__nat,axiom,
    ( ( ^ [P2: nat > $o] :
        ! [X6: nat] : ( P2 @ X6 ) )
    = ( ^ [P3: nat > $o] :
        ! [X5: int] :
          ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ X5 )
         => ( P3 @ ( nat2 @ X5 ) ) ) ) ) ).

% all_nat
thf(fact_4183_ex__nat,axiom,
    ( ( ^ [P2: nat > $o] :
        ? [X6: nat] : ( P2 @ X6 ) )
    = ( ^ [P3: nat > $o] :
        ? [X5: int] :
          ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ X5 )
          & ( P3 @ ( nat2 @ X5 ) ) ) ) ) ).

% ex_nat
thf(fact_4184_nat__one__as__int,axiom,
    ( ( one_one @ nat )
    = ( nat2 @ ( one_one @ int ) ) ) ).

% nat_one_as_int
thf(fact_4185_div__eq__sgn__abs,axiom,
    ! [K: int,L: int] :
      ( ( ( sgn_sgn @ int @ K )
        = ( sgn_sgn @ int @ L ) )
     => ( ( divide_divide @ int @ K @ L )
        = ( divide_divide @ int @ ( abs_abs @ int @ K ) @ ( abs_abs @ int @ L ) ) ) ) ).

% div_eq_sgn_abs
thf(fact_4186_unset__bit__nat__def,axiom,
    ( ( bit_se2638667681897837118et_bit @ nat )
    = ( ^ [M6: nat,N3: nat] : ( nat2 @ ( bit_se2638667681897837118et_bit @ int @ M6 @ ( semiring_1_of_nat @ int @ N3 ) ) ) ) ) ).

% unset_bit_nat_def
thf(fact_4187_nat__mask__eq,axiom,
    ! [N2: nat] :
      ( ( nat2 @ ( bit_se2239418461657761734s_mask @ int @ N2 ) )
      = ( bit_se2239418461657761734s_mask @ nat @ N2 ) ) ).

% nat_mask_eq
thf(fact_4188_sgn__1__pos,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A] :
          ( ( ( sgn_sgn @ A @ A2 )
            = ( one_one @ A ) )
          = ( ord_less @ A @ ( zero_zero @ A ) @ A2 ) ) ) ).

% sgn_1_pos
thf(fact_4189_abs__sgn__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A] :
          ( ( ( A2
              = ( zero_zero @ A ) )
           => ( ( abs_abs @ A @ ( sgn_sgn @ A @ A2 ) )
              = ( zero_zero @ A ) ) )
          & ( ( A2
             != ( zero_zero @ A ) )
           => ( ( abs_abs @ A @ ( sgn_sgn @ A @ A2 ) )
              = ( one_one @ A ) ) ) ) ) ).

% abs_sgn_eq
thf(fact_4190_nat__mono__iff,axiom,
    ! [Z: int,W: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ Z )
     => ( ( ord_less @ nat @ ( nat2 @ W ) @ ( nat2 @ Z ) )
        = ( ord_less @ int @ W @ Z ) ) ) ).

% nat_mono_iff
thf(fact_4191_of__nat__ceiling,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [R3: A] : ( ord_less_eq @ A @ R3 @ ( semiring_1_of_nat @ A @ ( nat2 @ ( archimedean_ceiling @ A @ R3 ) ) ) ) ) ).

% of_nat_ceiling
thf(fact_4192_zless__nat__eq__int__zless,axiom,
    ! [M: nat,Z: int] :
      ( ( ord_less @ nat @ M @ ( nat2 @ Z ) )
      = ( ord_less @ int @ ( semiring_1_of_nat @ int @ M ) @ Z ) ) ).

% zless_nat_eq_int_zless
thf(fact_4193_nat__le__iff,axiom,
    ! [X2: int,N2: nat] :
      ( ( ord_less_eq @ nat @ ( nat2 @ X2 ) @ N2 )
      = ( ord_less_eq @ int @ X2 @ ( semiring_1_of_nat @ int @ N2 ) ) ) ).

% nat_le_iff
thf(fact_4194_int__eq__iff,axiom,
    ! [M: nat,Z: int] :
      ( ( ( semiring_1_of_nat @ int @ M )
        = Z )
      = ( ( M
          = ( nat2 @ Z ) )
        & ( ord_less_eq @ int @ ( zero_zero @ int ) @ Z ) ) ) ).

% int_eq_iff
thf(fact_4195_nat__0__le,axiom,
    ! [Z: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Z )
     => ( ( semiring_1_of_nat @ int @ ( nat2 @ Z ) )
        = Z ) ) ).

% nat_0_le
thf(fact_4196_nat__int__add,axiom,
    ! [A2: nat,B2: nat] :
      ( ( nat2 @ ( plus_plus @ int @ ( semiring_1_of_nat @ int @ A2 ) @ ( semiring_1_of_nat @ int @ B2 ) ) )
      = ( plus_plus @ nat @ A2 @ B2 ) ) ).

% nat_int_add
thf(fact_4197_sgn__mod,axiom,
    ! [L: int,K: int] :
      ( ( L
       != ( zero_zero @ int ) )
     => ( ~ ( dvd_dvd @ int @ L @ K )
       => ( ( sgn_sgn @ int @ ( modulo_modulo @ int @ K @ L ) )
          = ( sgn_sgn @ int @ L ) ) ) ) ).

% sgn_mod
thf(fact_4198_nat__abs__mult__distrib,axiom,
    ! [W: int,Z: int] :
      ( ( nat2 @ ( abs_abs @ int @ ( times_times @ int @ W @ Z ) ) )
      = ( times_times @ nat @ ( nat2 @ ( abs_abs @ int @ W ) ) @ ( nat2 @ ( abs_abs @ int @ Z ) ) ) ) ).

% nat_abs_mult_distrib
thf(fact_4199_nat__plus__as__int,axiom,
    ( ( plus_plus @ nat )
    = ( ^ [A4: nat,B4: nat] : ( nat2 @ ( plus_plus @ int @ ( semiring_1_of_nat @ int @ A4 ) @ ( semiring_1_of_nat @ int @ B4 ) ) ) ) ) ).

% nat_plus_as_int
thf(fact_4200_nat__times__as__int,axiom,
    ( ( times_times @ nat )
    = ( ^ [A4: nat,B4: nat] : ( nat2 @ ( times_times @ int @ ( semiring_1_of_nat @ int @ A4 ) @ ( semiring_1_of_nat @ int @ B4 ) ) ) ) ) ).

% nat_times_as_int
thf(fact_4201_real__nat__ceiling__ge,axiom,
    ! [X2: real] : ( ord_less_eq @ real @ X2 @ ( semiring_1_of_nat @ real @ ( nat2 @ ( archimedean_ceiling @ real @ X2 ) ) ) ) ).

% real_nat_ceiling_ge
thf(fact_4202_nat__div__as__int,axiom,
    ( ( divide_divide @ nat )
    = ( ^ [A4: nat,B4: nat] : ( nat2 @ ( divide_divide @ int @ ( semiring_1_of_nat @ int @ A4 ) @ ( semiring_1_of_nat @ int @ B4 ) ) ) ) ) ).

% nat_div_as_int
thf(fact_4203_sgn__if,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ( ( sgn_sgn @ A )
        = ( ^ [X5: A] :
              ( if @ A
              @ ( X5
                = ( zero_zero @ A ) )
              @ ( zero_zero @ A )
              @ ( if @ A @ ( ord_less @ A @ ( zero_zero @ A ) @ X5 ) @ ( one_one @ A ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ) ) ) ).

% sgn_if
thf(fact_4204_sgn__1__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A] :
          ( ( ( sgn_sgn @ A @ A2 )
            = ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( ord_less @ A @ A2 @ ( zero_zero @ A ) ) ) ) ).

% sgn_1_neg
thf(fact_4205_of__nat__floor,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [R3: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ R3 )
         => ( ord_less_eq @ A @ ( semiring_1_of_nat @ A @ ( nat2 @ ( archim6421214686448440834_floor @ A @ R3 ) ) ) @ R3 ) ) ) ).

% of_nat_floor
thf(fact_4206_zsgn__def,axiom,
    ( ( sgn_sgn @ int )
    = ( ^ [I4: int] :
          ( if @ int
          @ ( I4
            = ( zero_zero @ int ) )
          @ ( zero_zero @ int )
          @ ( if @ int @ ( ord_less @ int @ ( zero_zero @ int ) @ I4 ) @ ( one_one @ int ) @ ( uminus_uminus @ int @ ( one_one @ int ) ) ) ) ) ) ).

% zsgn_def
thf(fact_4207_nat__less__eq__zless,axiom,
    ! [W: int,Z: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ W )
     => ( ( ord_less @ nat @ ( nat2 @ W ) @ ( nat2 @ Z ) )
        = ( ord_less @ int @ W @ Z ) ) ) ).

% nat_less_eq_zless
thf(fact_4208_norm__sgn,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X2: A] :
          ( ( ( X2
              = ( zero_zero @ A ) )
           => ( ( real_V7770717601297561774m_norm @ A @ ( sgn_sgn @ A @ X2 ) )
              = ( zero_zero @ real ) ) )
          & ( ( X2
             != ( zero_zero @ A ) )
           => ( ( real_V7770717601297561774m_norm @ A @ ( sgn_sgn @ A @ X2 ) )
              = ( one_one @ real ) ) ) ) ) ).

% norm_sgn
thf(fact_4209_nat__le__eq__zle,axiom,
    ! [W: int,Z: int] :
      ( ( ( ord_less @ int @ ( zero_zero @ int ) @ W )
        | ( ord_less_eq @ int @ ( zero_zero @ int ) @ Z ) )
     => ( ( ord_less_eq @ nat @ ( nat2 @ W ) @ ( nat2 @ Z ) )
        = ( ord_less_eq @ int @ W @ Z ) ) ) ).

% nat_le_eq_zle
thf(fact_4210_nat__eq__iff2,axiom,
    ! [M: nat,W: int] :
      ( ( M
        = ( nat2 @ W ) )
      = ( ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ W )
         => ( W
            = ( semiring_1_of_nat @ int @ M ) ) )
        & ( ~ ( ord_less_eq @ int @ ( zero_zero @ int ) @ W )
         => ( M
            = ( zero_zero @ nat ) ) ) ) ) ).

% nat_eq_iff2
thf(fact_4211_nat__eq__iff,axiom,
    ! [W: int,M: nat] :
      ( ( ( nat2 @ W )
        = M )
      = ( ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ W )
         => ( W
            = ( semiring_1_of_nat @ int @ M ) ) )
        & ( ~ ( ord_less_eq @ int @ ( zero_zero @ int ) @ W )
         => ( M
            = ( zero_zero @ nat ) ) ) ) ) ).

% nat_eq_iff
thf(fact_4212_split__nat,axiom,
    ! [P: nat > $o,I3: int] :
      ( ( P @ ( nat2 @ I3 ) )
      = ( ! [N3: nat] :
            ( ( I3
              = ( semiring_1_of_nat @ int @ N3 ) )
           => ( P @ N3 ) )
        & ( ( ord_less @ int @ I3 @ ( zero_zero @ int ) )
         => ( P @ ( zero_zero @ nat ) ) ) ) ) ).

% split_nat
thf(fact_4213_le__mult__nat__floor,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [A2: A,B2: A] : ( ord_less_eq @ nat @ ( times_times @ nat @ ( nat2 @ ( archim6421214686448440834_floor @ A @ A2 ) ) @ ( nat2 @ ( archim6421214686448440834_floor @ A @ B2 ) ) ) @ ( nat2 @ ( archim6421214686448440834_floor @ A @ ( times_times @ A @ A2 @ B2 ) ) ) ) ) ).

% le_mult_nat_floor
thf(fact_4214_le__nat__iff,axiom,
    ! [K: int,N2: nat] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ K )
     => ( ( ord_less_eq @ nat @ N2 @ ( nat2 @ K ) )
        = ( ord_less_eq @ int @ ( semiring_1_of_nat @ int @ N2 ) @ K ) ) ) ).

% le_nat_iff
thf(fact_4215_nat__add__distrib,axiom,
    ! [Z: int,Z7: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Z )
     => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Z7 )
       => ( ( nat2 @ ( plus_plus @ int @ Z @ Z7 ) )
          = ( plus_plus @ nat @ ( nat2 @ Z ) @ ( nat2 @ Z7 ) ) ) ) ) ).

% nat_add_distrib
thf(fact_4216_div__sgn__abs__cancel,axiom,
    ! [V: int,K: int,L: int] :
      ( ( V
       != ( zero_zero @ int ) )
     => ( ( divide_divide @ int @ ( times_times @ int @ ( sgn_sgn @ int @ V ) @ ( abs_abs @ int @ K ) ) @ ( times_times @ int @ ( sgn_sgn @ int @ V ) @ ( abs_abs @ int @ L ) ) )
        = ( divide_divide @ int @ ( abs_abs @ int @ K ) @ ( abs_abs @ int @ L ) ) ) ) ).

% div_sgn_abs_cancel
thf(fact_4217_nat__mult__distrib,axiom,
    ! [Z: int,Z7: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Z )
     => ( ( nat2 @ ( times_times @ int @ Z @ Z7 ) )
        = ( times_times @ nat @ ( nat2 @ Z ) @ ( nat2 @ Z7 ) ) ) ) ).

% nat_mult_distrib
thf(fact_4218_Suc__as__int,axiom,
    ( suc
    = ( ^ [A4: nat] : ( nat2 @ ( plus_plus @ int @ ( semiring_1_of_nat @ int @ A4 ) @ ( one_one @ int ) ) ) ) ) ).

% Suc_as_int
thf(fact_4219_nat__diff__distrib,axiom,
    ! [Z7: int,Z: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Z7 )
     => ( ( ord_less_eq @ int @ Z7 @ Z )
       => ( ( nat2 @ ( minus_minus @ int @ Z @ Z7 ) )
          = ( minus_minus @ nat @ ( nat2 @ Z ) @ ( nat2 @ Z7 ) ) ) ) ) ).

% nat_diff_distrib
thf(fact_4220_nat__diff__distrib_H,axiom,
    ! [X2: int,Y2: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ X2 )
     => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Y2 )
       => ( ( nat2 @ ( minus_minus @ int @ X2 @ Y2 ) )
          = ( minus_minus @ nat @ ( nat2 @ X2 ) @ ( nat2 @ Y2 ) ) ) ) ) ).

% nat_diff_distrib'
thf(fact_4221_nat__abs__triangle__ineq,axiom,
    ! [K: int,L: int] : ( ord_less_eq @ nat @ ( nat2 @ ( abs_abs @ int @ ( plus_plus @ int @ K @ L ) ) ) @ ( plus_plus @ nat @ ( nat2 @ ( abs_abs @ int @ K ) ) @ ( nat2 @ ( abs_abs @ int @ L ) ) ) ) ).

% nat_abs_triangle_ineq
thf(fact_4222_nat__div__distrib_H,axiom,
    ! [Y2: int,X2: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Y2 )
     => ( ( nat2 @ ( divide_divide @ int @ X2 @ Y2 ) )
        = ( divide_divide @ nat @ ( nat2 @ X2 ) @ ( nat2 @ Y2 ) ) ) ) ).

% nat_div_distrib'
thf(fact_4223_nat__div__distrib,axiom,
    ! [X2: int,Y2: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ X2 )
     => ( ( nat2 @ ( divide_divide @ int @ X2 @ Y2 ) )
        = ( divide_divide @ nat @ ( nat2 @ X2 ) @ ( nat2 @ Y2 ) ) ) ) ).

% nat_div_distrib
thf(fact_4224_div__dvd__sgn__abs,axiom,
    ! [L: int,K: int] :
      ( ( dvd_dvd @ int @ L @ K )
     => ( ( divide_divide @ int @ K @ L )
        = ( times_times @ int @ ( times_times @ int @ ( sgn_sgn @ int @ K ) @ ( sgn_sgn @ int @ L ) ) @ ( divide_divide @ int @ ( abs_abs @ int @ K ) @ ( abs_abs @ int @ L ) ) ) ) ) ).

% div_dvd_sgn_abs
thf(fact_4225_nat__floor__neg,axiom,
    ! [X2: real] :
      ( ( ord_less_eq @ real @ X2 @ ( zero_zero @ real ) )
     => ( ( nat2 @ ( archim6421214686448440834_floor @ real @ X2 ) )
        = ( zero_zero @ nat ) ) ) ).

% nat_floor_neg
thf(fact_4226_nat__power__eq,axiom,
    ! [Z: int,N2: nat] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Z )
     => ( ( nat2 @ ( power_power @ int @ Z @ N2 ) )
        = ( power_power @ nat @ ( nat2 @ Z ) @ N2 ) ) ) ).

% nat_power_eq
thf(fact_4227_nat__mod__distrib,axiom,
    ! [X2: int,Y2: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ X2 )
     => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Y2 )
       => ( ( nat2 @ ( modulo_modulo @ int @ X2 @ Y2 ) )
          = ( modulo_modulo @ nat @ ( nat2 @ X2 ) @ ( nat2 @ Y2 ) ) ) ) ) ).

% nat_mod_distrib
thf(fact_4228_div__abs__eq__div__nat,axiom,
    ! [K: int,L: int] :
      ( ( divide_divide @ int @ ( abs_abs @ int @ K ) @ ( abs_abs @ int @ L ) )
      = ( semiring_1_of_nat @ int @ ( divide_divide @ nat @ ( nat2 @ ( abs_abs @ int @ K ) ) @ ( nat2 @ ( abs_abs @ int @ L ) ) ) ) ) ).

% div_abs_eq_div_nat
thf(fact_4229_floor__eq3,axiom,
    ! [N2: nat,X2: real] :
      ( ( ord_less @ real @ ( semiring_1_of_nat @ real @ N2 ) @ X2 )
     => ( ( ord_less @ real @ X2 @ ( semiring_1_of_nat @ real @ ( suc @ N2 ) ) )
       => ( ( nat2 @ ( archim6421214686448440834_floor @ real @ X2 ) )
          = N2 ) ) ) ).

% floor_eq3
thf(fact_4230_le__nat__floor,axiom,
    ! [X2: nat,A2: real] :
      ( ( ord_less_eq @ real @ ( semiring_1_of_nat @ real @ X2 ) @ A2 )
     => ( ord_less_eq @ nat @ X2 @ ( nat2 @ ( archim6421214686448440834_floor @ real @ A2 ) ) ) ) ).

% le_nat_floor
thf(fact_4231_take__bit__nat__eq,axiom,
    ! [K: int,N2: nat] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ K )
     => ( ( bit_se2584673776208193580ke_bit @ nat @ N2 @ ( nat2 @ K ) )
        = ( nat2 @ ( bit_se2584673776208193580ke_bit @ int @ N2 @ K ) ) ) ) ).

% take_bit_nat_eq
thf(fact_4232_nat__take__bit__eq,axiom,
    ! [K: int,N2: nat] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ K )
     => ( ( nat2 @ ( bit_se2584673776208193580ke_bit @ int @ N2 @ K ) )
        = ( bit_se2584673776208193580ke_bit @ nat @ N2 @ ( nat2 @ K ) ) ) ) ).

% nat_take_bit_eq
thf(fact_4233_bit__nat__iff,axiom,
    ! [K: int,N2: nat] :
      ( ( bit_se5641148757651400278ts_bit @ nat @ ( nat2 @ K ) @ N2 )
      = ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ K )
        & ( bit_se5641148757651400278ts_bit @ int @ K @ N2 ) ) ) ).

% bit_nat_iff
thf(fact_4234_divide__int__def,axiom,
    ( ( divide_divide @ int )
    = ( ^ [K3: int,L2: int] :
          ( if @ int
          @ ( L2
            = ( zero_zero @ int ) )
          @ ( zero_zero @ int )
          @ ( if @ int
            @ ( ( sgn_sgn @ int @ K3 )
              = ( sgn_sgn @ int @ L2 ) )
            @ ( semiring_1_of_nat @ int @ ( divide_divide @ nat @ ( nat2 @ ( abs_abs @ int @ K3 ) ) @ ( nat2 @ ( abs_abs @ int @ L2 ) ) ) )
            @ ( uminus_uminus @ int
              @ ( semiring_1_of_nat @ int
                @ ( plus_plus @ nat @ ( divide_divide @ nat @ ( nat2 @ ( abs_abs @ int @ K3 ) ) @ ( nat2 @ ( abs_abs @ int @ L2 ) ) )
                  @ ( zero_neq_one_of_bool @ nat
                    @ ~ ( dvd_dvd @ int @ L2 @ K3 ) ) ) ) ) ) ) ) ) ).

% divide_int_def
thf(fact_4235_of__real__sqrt,axiom,
    ! [X2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( real_Vector_of_real @ complex @ ( sqrt @ X2 ) )
        = ( csqrt @ ( real_Vector_of_real @ complex @ X2 ) ) ) ) ).

% of_real_sqrt
thf(fact_4236_modulo__int__def,axiom,
    ( ( modulo_modulo @ int )
    = ( ^ [K3: int,L2: int] :
          ( if @ int
          @ ( L2
            = ( zero_zero @ int ) )
          @ K3
          @ ( if @ int
            @ ( ( sgn_sgn @ int @ K3 )
              = ( sgn_sgn @ int @ L2 ) )
            @ ( times_times @ int @ ( sgn_sgn @ int @ L2 ) @ ( semiring_1_of_nat @ int @ ( modulo_modulo @ nat @ ( nat2 @ ( abs_abs @ int @ K3 ) ) @ ( nat2 @ ( abs_abs @ int @ L2 ) ) ) ) )
            @ ( times_times @ int @ ( sgn_sgn @ int @ L2 )
              @ ( minus_minus @ int
                @ ( times_times @ int @ ( abs_abs @ int @ L2 )
                  @ ( zero_neq_one_of_bool @ int
                    @ ~ ( dvd_dvd @ int @ L2 @ K3 ) ) )
                @ ( semiring_1_of_nat @ int @ ( modulo_modulo @ nat @ ( nat2 @ ( abs_abs @ int @ K3 ) ) @ ( nat2 @ ( abs_abs @ int @ L2 ) ) ) ) ) ) ) ) ) ) ).

% modulo_int_def
thf(fact_4237_nat__2,axiom,
    ( ( nat2 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) )
    = ( suc @ ( suc @ ( zero_zero @ nat ) ) ) ) ).

% nat_2
thf(fact_4238_Suc__nat__eq__nat__zadd1,axiom,
    ! [Z: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Z )
     => ( ( suc @ ( nat2 @ Z ) )
        = ( nat2 @ ( plus_plus @ int @ ( one_one @ int ) @ Z ) ) ) ) ).

% Suc_nat_eq_nat_zadd1
thf(fact_4239_nat__less__iff,axiom,
    ! [W: int,M: nat] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ W )
     => ( ( ord_less @ nat @ ( nat2 @ W ) @ M )
        = ( ord_less @ int @ W @ ( semiring_1_of_nat @ int @ M ) ) ) ) ).

% nat_less_iff
thf(fact_4240_nat__mult__distrib__neg,axiom,
    ! [Z: int,Z7: int] :
      ( ( ord_less_eq @ int @ Z @ ( zero_zero @ int ) )
     => ( ( nat2 @ ( times_times @ int @ Z @ Z7 ) )
        = ( times_times @ nat @ ( nat2 @ ( uminus_uminus @ int @ Z ) ) @ ( nat2 @ ( uminus_uminus @ int @ Z7 ) ) ) ) ) ).

% nat_mult_distrib_neg
thf(fact_4241_nat__abs__int__diff,axiom,
    ! [A2: nat,B2: nat] :
      ( ( ( ord_less_eq @ nat @ A2 @ B2 )
       => ( ( nat2 @ ( abs_abs @ int @ ( minus_minus @ int @ ( semiring_1_of_nat @ int @ A2 ) @ ( semiring_1_of_nat @ int @ B2 ) ) ) )
          = ( minus_minus @ nat @ B2 @ A2 ) ) )
      & ( ~ ( ord_less_eq @ nat @ A2 @ B2 )
       => ( ( nat2 @ ( abs_abs @ int @ ( minus_minus @ int @ ( semiring_1_of_nat @ int @ A2 ) @ ( semiring_1_of_nat @ int @ B2 ) ) ) )
          = ( minus_minus @ nat @ A2 @ B2 ) ) ) ) ).

% nat_abs_int_diff
thf(fact_4242_floor__eq4,axiom,
    ! [N2: nat,X2: real] :
      ( ( ord_less_eq @ real @ ( semiring_1_of_nat @ real @ N2 ) @ X2 )
     => ( ( ord_less @ real @ X2 @ ( semiring_1_of_nat @ real @ ( suc @ N2 ) ) )
       => ( ( nat2 @ ( archim6421214686448440834_floor @ real @ X2 ) )
          = N2 ) ) ) ).

% floor_eq4
thf(fact_4243_diff__nat__eq__if,axiom,
    ! [Z7: int,Z: int] :
      ( ( ( ord_less @ int @ Z7 @ ( zero_zero @ int ) )
       => ( ( minus_minus @ nat @ ( nat2 @ Z ) @ ( nat2 @ Z7 ) )
          = ( nat2 @ Z ) ) )
      & ( ~ ( ord_less @ int @ Z7 @ ( zero_zero @ int ) )
       => ( ( minus_minus @ nat @ ( nat2 @ Z ) @ ( nat2 @ Z7 ) )
          = ( if @ nat @ ( ord_less @ int @ ( minus_minus @ int @ Z @ Z7 ) @ ( zero_zero @ int ) ) @ ( zero_zero @ nat ) @ ( nat2 @ ( minus_minus @ int @ Z @ Z7 ) ) ) ) ) ) ).

% diff_nat_eq_if
thf(fact_4244_of__int__of__nat,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ( ( ring_1_of_int @ A )
        = ( ^ [K3: int] : ( if @ A @ ( ord_less @ int @ K3 @ ( zero_zero @ int ) ) @ ( uminus_uminus @ A @ ( semiring_1_of_nat @ A @ ( nat2 @ ( uminus_uminus @ int @ K3 ) ) ) ) @ ( semiring_1_of_nat @ A @ ( nat2 @ K3 ) ) ) ) ) ) ).

% of_int_of_nat
thf(fact_4245_nat__dvd__iff,axiom,
    ! [Z: int,M: nat] :
      ( ( dvd_dvd @ nat @ ( nat2 @ Z ) @ M )
      = ( ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Z )
         => ( dvd_dvd @ int @ Z @ ( semiring_1_of_nat @ int @ M ) ) )
        & ( ~ ( ord_less_eq @ int @ ( zero_zero @ int ) @ Z )
         => ( M
            = ( zero_zero @ nat ) ) ) ) ) ).

% nat_dvd_iff
thf(fact_4246_eucl__rel__int__remainderI,axiom,
    ! [R3: int,L: int,K: int,Q3: int] :
      ( ( ( sgn_sgn @ int @ R3 )
        = ( sgn_sgn @ int @ L ) )
     => ( ( ord_less @ int @ ( abs_abs @ int @ R3 ) @ ( abs_abs @ int @ L ) )
       => ( ( K
            = ( plus_plus @ int @ ( times_times @ int @ Q3 @ L ) @ R3 ) )
         => ( eucl_rel_int @ K @ L @ ( product_Pair @ int @ int @ Q3 @ R3 ) ) ) ) ) ).

% eucl_rel_int_remainderI
thf(fact_4247_eucl__rel__int_Ocases,axiom,
    ! [A1: int,A22: int,A32: product_prod @ int @ int] :
      ( ( eucl_rel_int @ A1 @ A22 @ A32 )
     => ( ( ( A22
            = ( zero_zero @ int ) )
         => ( A32
           != ( product_Pair @ int @ int @ ( zero_zero @ int ) @ A1 ) ) )
       => ( ! [Q2: int] :
              ( ( A32
                = ( product_Pair @ int @ int @ Q2 @ ( zero_zero @ int ) ) )
             => ( ( A22
                 != ( zero_zero @ int ) )
               => ( A1
                 != ( times_times @ int @ Q2 @ A22 ) ) ) )
         => ~ ! [R4: int,Q2: int] :
                ( ( A32
                  = ( product_Pair @ int @ int @ Q2 @ R4 ) )
               => ( ( ( sgn_sgn @ int @ R4 )
                    = ( sgn_sgn @ int @ A22 ) )
                 => ( ( ord_less @ int @ ( abs_abs @ int @ R4 ) @ ( abs_abs @ int @ A22 ) )
                   => ( A1
                     != ( plus_plus @ int @ ( times_times @ int @ Q2 @ A22 ) @ R4 ) ) ) ) ) ) ) ) ).

% eucl_rel_int.cases
thf(fact_4248_eucl__rel__int_Osimps,axiom,
    ( eucl_rel_int
    = ( ^ [A12: int,A23: int,A33: product_prod @ int @ int] :
          ( ? [K3: int] :
              ( ( A12 = K3 )
              & ( A23
                = ( zero_zero @ int ) )
              & ( A33
                = ( product_Pair @ int @ int @ ( zero_zero @ int ) @ K3 ) ) )
          | ? [L2: int,K3: int,Q4: int] :
              ( ( A12 = K3 )
              & ( A23 = L2 )
              & ( A33
                = ( product_Pair @ int @ int @ Q4 @ ( zero_zero @ int ) ) )
              & ( L2
               != ( zero_zero @ int ) )
              & ( K3
                = ( times_times @ int @ Q4 @ L2 ) ) )
          | ? [R5: int,L2: int,K3: int,Q4: int] :
              ( ( A12 = K3 )
              & ( A23 = L2 )
              & ( A33
                = ( product_Pair @ int @ int @ Q4 @ R5 ) )
              & ( ( sgn_sgn @ int @ R5 )
                = ( sgn_sgn @ int @ L2 ) )
              & ( ord_less @ int @ ( abs_abs @ int @ R5 ) @ ( abs_abs @ int @ L2 ) )
              & ( K3
                = ( plus_plus @ int @ ( times_times @ int @ Q4 @ L2 ) @ R5 ) ) ) ) ) ) ).

% eucl_rel_int.simps
thf(fact_4249_div__noneq__sgn__abs,axiom,
    ! [L: int,K: int] :
      ( ( L
       != ( zero_zero @ int ) )
     => ( ( ( sgn_sgn @ int @ K )
         != ( sgn_sgn @ int @ L ) )
       => ( ( divide_divide @ int @ K @ L )
          = ( minus_minus @ int @ ( uminus_uminus @ int @ ( divide_divide @ int @ ( abs_abs @ int @ K ) @ ( abs_abs @ int @ L ) ) )
            @ ( zero_neq_one_of_bool @ int
              @ ~ ( dvd_dvd @ int @ L @ K ) ) ) ) ) ) ).

% div_noneq_sgn_abs
thf(fact_4250_even__nat__iff,axiom,
    ! [K: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ K )
     => ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( nat2 @ K ) )
        = ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ K ) ) ) ).

% even_nat_iff
thf(fact_4251_powr__real__of__int,axiom,
    ! [X2: real,N2: int] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ N2 )
         => ( ( powr @ real @ X2 @ ( ring_1_of_int @ real @ N2 ) )
            = ( power_power @ real @ X2 @ ( nat2 @ N2 ) ) ) )
        & ( ~ ( ord_less_eq @ int @ ( zero_zero @ int ) @ N2 )
         => ( ( powr @ real @ X2 @ ( ring_1_of_int @ real @ N2 ) )
            = ( inverse_inverse @ real @ ( power_power @ real @ X2 @ ( nat2 @ ( uminus_uminus @ int @ N2 ) ) ) ) ) ) ) ) ).

% powr_real_of_int
thf(fact_4252_and__int__unfold,axiom,
    ( ( bit_se5824344872417868541ns_and @ int )
    = ( ^ [K3: int,L2: int] :
          ( if @ int
          @ ( ( K3
              = ( zero_zero @ int ) )
            | ( L2
              = ( zero_zero @ int ) ) )
          @ ( zero_zero @ int )
          @ ( if @ int
            @ ( K3
              = ( uminus_uminus @ int @ ( one_one @ int ) ) )
            @ L2
            @ ( if @ int
              @ ( L2
                = ( uminus_uminus @ int @ ( one_one @ int ) ) )
              @ K3
              @ ( plus_plus @ int @ ( times_times @ int @ ( modulo_modulo @ int @ K3 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( modulo_modulo @ int @ L2 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se5824344872417868541ns_and @ int @ ( divide_divide @ int @ K3 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ int @ L2 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ) ).

% and_int_unfold
thf(fact_4253_buildup__gives__empty,axiom,
    ! [N2: nat] :
      ( ( vEBT_VEBT_set_vebt @ ( vEBT_vebt_buildup @ N2 ) )
      = ( bot_bot @ ( set @ nat ) ) ) ).

% buildup_gives_empty
thf(fact_4254_or__int__unfold,axiom,
    ( ( bit_se1065995026697491101ons_or @ int )
    = ( ^ [K3: int,L2: int] :
          ( if @ int
          @ ( ( K3
              = ( uminus_uminus @ int @ ( one_one @ int ) ) )
            | ( L2
              = ( uminus_uminus @ int @ ( one_one @ int ) ) ) )
          @ ( uminus_uminus @ int @ ( one_one @ int ) )
          @ ( if @ int
            @ ( K3
              = ( zero_zero @ int ) )
            @ L2
            @ ( if @ int
              @ ( L2
                = ( zero_zero @ int ) )
              @ K3
              @ ( plus_plus @ int @ ( ord_max @ int @ ( modulo_modulo @ int @ K3 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( modulo_modulo @ int @ L2 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se1065995026697491101ons_or @ int @ ( divide_divide @ int @ K3 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ int @ L2 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ) ).

% or_int_unfold
thf(fact_4255_arctan__inverse,axiom,
    ! [X2: real] :
      ( ( X2
       != ( zero_zero @ real ) )
     => ( ( arctan @ ( divide_divide @ real @ ( one_one @ real ) @ X2 ) )
        = ( minus_minus @ real @ ( divide_divide @ real @ ( times_times @ real @ ( sgn_sgn @ real @ X2 ) @ pi ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( arctan @ X2 ) ) ) ) ).

% arctan_inverse
thf(fact_4256_and_Oidem,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ A2 @ A2 )
          = A2 ) ) ).

% and.idem
thf(fact_4257_and_Oleft__idem,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A,B2: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ A2 @ ( bit_se5824344872417868541ns_and @ A @ A2 @ B2 ) )
          = ( bit_se5824344872417868541ns_and @ A @ A2 @ B2 ) ) ) ).

% and.left_idem
thf(fact_4258_and_Oright__idem,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A,B2: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( bit_se5824344872417868541ns_and @ A @ A2 @ B2 ) @ B2 )
          = ( bit_se5824344872417868541ns_and @ A @ A2 @ B2 ) ) ) ).

% and.right_idem
thf(fact_4259_or_Oidem,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A] :
          ( ( bit_se1065995026697491101ons_or @ A @ A2 @ A2 )
          = A2 ) ) ).

% or.idem
thf(fact_4260_or_Oleft__idem,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A,B2: A] :
          ( ( bit_se1065995026697491101ons_or @ A @ A2 @ ( bit_se1065995026697491101ons_or @ A @ A2 @ B2 ) )
          = ( bit_se1065995026697491101ons_or @ A @ A2 @ B2 ) ) ) ).

% or.left_idem
thf(fact_4261_or_Oright__idem,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A,B2: A] :
          ( ( bit_se1065995026697491101ons_or @ A @ ( bit_se1065995026697491101ons_or @ A @ A2 @ B2 ) @ B2 )
          = ( bit_se1065995026697491101ons_or @ A @ A2 @ B2 ) ) ) ).

% or.right_idem
thf(fact_4262_subset__empty,axiom,
    ! [A: $tType,A3: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ ( bot_bot @ ( set @ A ) ) )
      = ( A3
        = ( bot_bot @ ( set @ A ) ) ) ) ).

% subset_empty
thf(fact_4263_empty__subsetI,axiom,
    ! [A: $tType,A3: set @ A] : ( ord_less_eq @ ( set @ A ) @ ( bot_bot @ ( set @ A ) ) @ A3 ) ).

% empty_subsetI
thf(fact_4264_and__zero__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ A2 @ ( zero_zero @ A ) )
          = ( zero_zero @ A ) ) ) ).

% and_zero_eq
thf(fact_4265_zero__and__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( zero_zero @ A ) @ A2 )
          = ( zero_zero @ A ) ) ) ).

% zero_and_eq
thf(fact_4266_bit_Oconj__zero__left,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X2: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( zero_zero @ A ) @ X2 )
          = ( zero_zero @ A ) ) ) ).

% bit.conj_zero_left
thf(fact_4267_bit_Oconj__zero__right,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X2: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ X2 @ ( zero_zero @ A ) )
          = ( zero_zero @ A ) ) ) ).

% bit.conj_zero_right
thf(fact_4268_or_Oleft__neutral,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A] :
          ( ( bit_se1065995026697491101ons_or @ A @ ( zero_zero @ A ) @ A2 )
          = A2 ) ) ).

% or.left_neutral
thf(fact_4269_or_Oright__neutral,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A] :
          ( ( bit_se1065995026697491101ons_or @ A @ A2 @ ( zero_zero @ A ) )
          = A2 ) ) ).

% or.right_neutral
thf(fact_4270_take__bit__and,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N2: nat,A2: A,B2: A] :
          ( ( bit_se2584673776208193580ke_bit @ A @ N2 @ ( bit_se5824344872417868541ns_and @ A @ A2 @ B2 ) )
          = ( bit_se5824344872417868541ns_and @ A @ ( bit_se2584673776208193580ke_bit @ A @ N2 @ A2 ) @ ( bit_se2584673776208193580ke_bit @ A @ N2 @ B2 ) ) ) ) ).

% take_bit_and
thf(fact_4271_take__bit__or,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N2: nat,A2: A,B2: A] :
          ( ( bit_se2584673776208193580ke_bit @ A @ N2 @ ( bit_se1065995026697491101ons_or @ A @ A2 @ B2 ) )
          = ( bit_se1065995026697491101ons_or @ A @ ( bit_se2584673776208193580ke_bit @ A @ N2 @ A2 ) @ ( bit_se2584673776208193580ke_bit @ A @ N2 @ B2 ) ) ) ) ).

% take_bit_or
thf(fact_4272_sum_Oempty,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: B > A] :
          ( ( groups7311177749621191930dd_sum @ B @ A @ G @ ( bot_bot @ ( set @ B ) ) )
          = ( zero_zero @ A ) ) ) ).

% sum.empty
thf(fact_4273_atLeastatMost__empty__iff,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ( set_or1337092689740270186AtMost @ A @ A2 @ B2 )
            = ( bot_bot @ ( set @ A ) ) )
          = ( ~ ( ord_less_eq @ A @ A2 @ B2 ) ) ) ) ).

% atLeastatMost_empty_iff
thf(fact_4274_atLeastatMost__empty__iff2,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ( bot_bot @ ( set @ A ) )
            = ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) )
          = ( ~ ( ord_less_eq @ A @ A2 @ B2 ) ) ) ) ).

% atLeastatMost_empty_iff2
thf(fact_4275_atLeastatMost__empty,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less @ A @ B2 @ A2 )
         => ( ( set_or1337092689740270186AtMost @ A @ A2 @ B2 )
            = ( bot_bot @ ( set @ A ) ) ) ) ) ).

% atLeastatMost_empty
thf(fact_4276_prod_Oempty,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: B > A] :
          ( ( groups7121269368397514597t_prod @ B @ A @ G @ ( bot_bot @ ( set @ B ) ) )
          = ( one_one @ A ) ) ) ).

% prod.empty
thf(fact_4277_Diff__eq__empty__iff,axiom,
    ! [A: $tType,A3: set @ A,B3: set @ A] :
      ( ( ( minus_minus @ ( set @ A ) @ A3 @ B3 )
        = ( bot_bot @ ( set @ A ) ) )
      = ( ord_less_eq @ ( set @ A ) @ A3 @ B3 ) ) ).

% Diff_eq_empty_iff
thf(fact_4278_and_Oleft__neutral,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [A2: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ A2 )
          = A2 ) ) ).

% and.left_neutral
thf(fact_4279_and_Oright__neutral,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [A2: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ A2 @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = A2 ) ) ).

% and.right_neutral
thf(fact_4280_bit_Oconj__one__right,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X2: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ X2 @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = X2 ) ) ).

% bit.conj_one_right
thf(fact_4281_bit_Odisj__one__left,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X2: A] :
          ( ( bit_se1065995026697491101ons_or @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ X2 )
          = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% bit.disj_one_left
thf(fact_4282_bit_Odisj__one__right,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X2: A] :
          ( ( bit_se1065995026697491101ons_or @ A @ X2 @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% bit.disj_one_right
thf(fact_4283_and__nonnegative__int__iff,axiom,
    ! [K: int,L: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( bit_se5824344872417868541ns_and @ int @ K @ L ) )
      = ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ K )
        | ( ord_less_eq @ int @ ( zero_zero @ int ) @ L ) ) ) ).

% and_nonnegative_int_iff
thf(fact_4284_and__negative__int__iff,axiom,
    ! [K: int,L: int] :
      ( ( ord_less @ int @ ( bit_se5824344872417868541ns_and @ int @ K @ L ) @ ( zero_zero @ int ) )
      = ( ( ord_less @ int @ K @ ( zero_zero @ int ) )
        & ( ord_less @ int @ L @ ( zero_zero @ int ) ) ) ) ).

% and_negative_int_iff
thf(fact_4285_or__nonnegative__int__iff,axiom,
    ! [K: int,L: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( bit_se1065995026697491101ons_or @ int @ K @ L ) )
      = ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ K )
        & ( ord_less_eq @ int @ ( zero_zero @ int ) @ L ) ) ) ).

% or_nonnegative_int_iff
thf(fact_4286_or__negative__int__iff,axiom,
    ! [K: int,L: int] :
      ( ( ord_less @ int @ ( bit_se1065995026697491101ons_or @ int @ K @ L ) @ ( zero_zero @ int ) )
      = ( ( ord_less @ int @ K @ ( zero_zero @ int ) )
        | ( ord_less @ int @ L @ ( zero_zero @ int ) ) ) ) ).

% or_negative_int_iff
thf(fact_4287_zero__le__sgn__iff,axiom,
    ! [X2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( sgn_sgn @ real @ X2 ) )
      = ( ord_less_eq @ real @ ( zero_zero @ real ) @ X2 ) ) ).

% zero_le_sgn_iff
thf(fact_4288_sgn__le__0__iff,axiom,
    ! [X2: real] :
      ( ( ord_less_eq @ real @ ( sgn_sgn @ real @ X2 ) @ ( zero_zero @ real ) )
      = ( ord_less_eq @ real @ X2 @ ( zero_zero @ real ) ) ) ).

% sgn_le_0_iff
thf(fact_4289_lessThan__0,axiom,
    ( ( set_ord_lessThan @ nat @ ( zero_zero @ nat ) )
    = ( bot_bot @ ( set @ nat ) ) ) ).

% lessThan_0
thf(fact_4290_set__decode__zero,axiom,
    ( ( nat_set_decode @ ( zero_zero @ nat ) )
    = ( bot_bot @ ( set @ nat ) ) ) ).

% set_decode_zero
thf(fact_4291_and__numerals_I8_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X2: num] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( numeral_numeral @ A @ ( bit1 @ X2 ) ) @ ( one_one @ A ) )
          = ( one_one @ A ) ) ) ).

% and_numerals(8)
thf(fact_4292_and__numerals_I2_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [Y2: num] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit1 @ Y2 ) ) )
          = ( one_one @ A ) ) ) ).

% and_numerals(2)
thf(fact_4293_or__numerals_I8_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X2: num] :
          ( ( bit_se1065995026697491101ons_or @ A @ ( numeral_numeral @ A @ ( bit1 @ X2 ) ) @ ( one_one @ A ) )
          = ( numeral_numeral @ A @ ( bit1 @ X2 ) ) ) ) ).

% or_numerals(8)
thf(fact_4294_or__numerals_I2_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [Y2: num] :
          ( ( bit_se1065995026697491101ons_or @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit1 @ Y2 ) ) )
          = ( numeral_numeral @ A @ ( bit1 @ Y2 ) ) ) ) ).

% or_numerals(2)
thf(fact_4295_and__numerals_I1_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [Y2: num] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ Y2 ) ) )
          = ( zero_zero @ A ) ) ) ).

% and_numerals(1)
thf(fact_4296_and__numerals_I5_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X2: num] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( numeral_numeral @ A @ ( bit0 @ X2 ) ) @ ( one_one @ A ) )
          = ( zero_zero @ A ) ) ) ).

% and_numerals(5)
thf(fact_4297_and__numerals_I3_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X2: num,Y2: num] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( numeral_numeral @ A @ ( bit0 @ X2 ) ) @ ( numeral_numeral @ A @ ( bit0 @ Y2 ) ) )
          = ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se5824344872417868541ns_and @ A @ ( numeral_numeral @ A @ X2 ) @ ( numeral_numeral @ A @ Y2 ) ) ) ) ) ).

% and_numerals(3)
thf(fact_4298_or__numerals_I3_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X2: num,Y2: num] :
          ( ( bit_se1065995026697491101ons_or @ A @ ( numeral_numeral @ A @ ( bit0 @ X2 ) ) @ ( numeral_numeral @ A @ ( bit0 @ Y2 ) ) )
          = ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se1065995026697491101ons_or @ A @ ( numeral_numeral @ A @ X2 ) @ ( numeral_numeral @ A @ Y2 ) ) ) ) ) ).

% or_numerals(3)
thf(fact_4299_or__numerals_I1_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [Y2: num] :
          ( ( bit_se1065995026697491101ons_or @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ Y2 ) ) )
          = ( numeral_numeral @ A @ ( bit1 @ Y2 ) ) ) ) ).

% or_numerals(1)
thf(fact_4300_or__numerals_I5_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X2: num] :
          ( ( bit_se1065995026697491101ons_or @ A @ ( numeral_numeral @ A @ ( bit0 @ X2 ) ) @ ( one_one @ A ) )
          = ( numeral_numeral @ A @ ( bit1 @ X2 ) ) ) ) ).

% or_numerals(5)
thf(fact_4301_and__minus__numerals_I6_J,axiom,
    ! [N2: num] :
      ( ( bit_se5824344872417868541ns_and @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit1 @ N2 ) ) ) @ ( one_one @ int ) )
      = ( one_one @ int ) ) ).

% and_minus_numerals(6)
thf(fact_4302_and__minus__numerals_I2_J,axiom,
    ! [N2: num] :
      ( ( bit_se5824344872417868541ns_and @ int @ ( one_one @ int ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit1 @ N2 ) ) ) )
      = ( one_one @ int ) ) ).

% and_minus_numerals(2)
thf(fact_4303_or__minus__numerals_I6_J,axiom,
    ! [N2: num] :
      ( ( bit_se1065995026697491101ons_or @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit1 @ N2 ) ) ) @ ( one_one @ int ) )
      = ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit1 @ N2 ) ) ) ) ).

% or_minus_numerals(6)
thf(fact_4304_or__minus__numerals_I2_J,axiom,
    ! [N2: num] :
      ( ( bit_se1065995026697491101ons_or @ int @ ( one_one @ int ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit1 @ N2 ) ) ) )
      = ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit1 @ N2 ) ) ) ) ).

% or_minus_numerals(2)
thf(fact_4305_and__numerals_I4_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X2: num,Y2: num] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( numeral_numeral @ A @ ( bit0 @ X2 ) ) @ ( numeral_numeral @ A @ ( bit1 @ Y2 ) ) )
          = ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se5824344872417868541ns_and @ A @ ( numeral_numeral @ A @ X2 ) @ ( numeral_numeral @ A @ Y2 ) ) ) ) ) ).

% and_numerals(4)
thf(fact_4306_and__numerals_I6_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X2: num,Y2: num] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( numeral_numeral @ A @ ( bit1 @ X2 ) ) @ ( numeral_numeral @ A @ ( bit0 @ Y2 ) ) )
          = ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se5824344872417868541ns_and @ A @ ( numeral_numeral @ A @ X2 ) @ ( numeral_numeral @ A @ Y2 ) ) ) ) ) ).

% and_numerals(6)
thf(fact_4307_and__minus__numerals_I5_J,axiom,
    ! [N2: num] :
      ( ( bit_se5824344872417868541ns_and @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit0 @ N2 ) ) ) @ ( one_one @ int ) )
      = ( zero_zero @ int ) ) ).

% and_minus_numerals(5)
thf(fact_4308_and__minus__numerals_I1_J,axiom,
    ! [N2: num] :
      ( ( bit_se5824344872417868541ns_and @ int @ ( one_one @ int ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit0 @ N2 ) ) ) )
      = ( zero_zero @ int ) ) ).

% and_minus_numerals(1)
thf(fact_4309_and__numerals_I7_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X2: num,Y2: num] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( numeral_numeral @ A @ ( bit1 @ X2 ) ) @ ( numeral_numeral @ A @ ( bit1 @ Y2 ) ) )
          = ( plus_plus @ A @ ( one_one @ A ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se5824344872417868541ns_and @ A @ ( numeral_numeral @ A @ X2 ) @ ( numeral_numeral @ A @ Y2 ) ) ) ) ) ) ).

% and_numerals(7)
thf(fact_4310_or__numerals_I4_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X2: num,Y2: num] :
          ( ( bit_se1065995026697491101ons_or @ A @ ( numeral_numeral @ A @ ( bit0 @ X2 ) ) @ ( numeral_numeral @ A @ ( bit1 @ Y2 ) ) )
          = ( plus_plus @ A @ ( one_one @ A ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se1065995026697491101ons_or @ A @ ( numeral_numeral @ A @ X2 ) @ ( numeral_numeral @ A @ Y2 ) ) ) ) ) ) ).

% or_numerals(4)
thf(fact_4311_or__numerals_I6_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X2: num,Y2: num] :
          ( ( bit_se1065995026697491101ons_or @ A @ ( numeral_numeral @ A @ ( bit1 @ X2 ) ) @ ( numeral_numeral @ A @ ( bit0 @ Y2 ) ) )
          = ( plus_plus @ A @ ( one_one @ A ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se1065995026697491101ons_or @ A @ ( numeral_numeral @ A @ X2 ) @ ( numeral_numeral @ A @ Y2 ) ) ) ) ) ) ).

% or_numerals(6)
thf(fact_4312_or__numerals_I7_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X2: num,Y2: num] :
          ( ( bit_se1065995026697491101ons_or @ A @ ( numeral_numeral @ A @ ( bit1 @ X2 ) ) @ ( numeral_numeral @ A @ ( bit1 @ Y2 ) ) )
          = ( plus_plus @ A @ ( one_one @ A ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se1065995026697491101ons_or @ A @ ( numeral_numeral @ A @ X2 ) @ ( numeral_numeral @ A @ Y2 ) ) ) ) ) ) ).

% or_numerals(7)
thf(fact_4313_plus__and__or,axiom,
    ! [X2: int,Y2: int] :
      ( ( plus_plus @ int @ ( bit_se5824344872417868541ns_and @ int @ X2 @ Y2 ) @ ( bit_se1065995026697491101ons_or @ int @ X2 @ Y2 ) )
      = ( plus_plus @ int @ X2 @ Y2 ) ) ).

% plus_and_or
thf(fact_4314_bit_Odisj__zero__right,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X2: A] :
          ( ( bit_se1065995026697491101ons_or @ A @ X2 @ ( zero_zero @ A ) )
          = X2 ) ) ).

% bit.disj_zero_right
thf(fact_4315_or__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A,B2: A] :
          ( ( ( bit_se1065995026697491101ons_or @ A @ A2 @ B2 )
            = ( zero_zero @ A ) )
          = ( ( A2
              = ( zero_zero @ A ) )
            & ( B2
              = ( zero_zero @ A ) ) ) ) ) ).

% or_eq_0_iff
thf(fact_4316_bot_Oextremum__strict,axiom,
    ! [A: $tType] :
      ( ( order_bot @ A )
     => ! [A2: A] :
          ~ ( ord_less @ A @ A2 @ ( bot_bot @ A ) ) ) ).

% bot.extremum_strict
thf(fact_4317_bot_Onot__eq__extremum,axiom,
    ! [A: $tType] :
      ( ( order_bot @ A )
     => ! [A2: A] :
          ( ( ( A2
             != ( bot_bot @ A ) ) )
          = ( ord_less @ A @ ( bot_bot @ A ) @ A2 ) ) ) ).

% bot.not_eq_extremum
thf(fact_4318_bit__and__iff,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A,B2: A,N2: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( bit_se5824344872417868541ns_and @ A @ A2 @ B2 ) @ N2 )
          = ( ( bit_se5641148757651400278ts_bit @ A @ A2 @ N2 )
            & ( bit_se5641148757651400278ts_bit @ A @ B2 @ N2 ) ) ) ) ).

% bit_and_iff
thf(fact_4319_of__int__or__eq,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [K: int,L: int] :
          ( ( ring_1_of_int @ A @ ( bit_se1065995026697491101ons_or @ int @ K @ L ) )
          = ( bit_se1065995026697491101ons_or @ A @ ( ring_1_of_int @ A @ K ) @ ( ring_1_of_int @ A @ L ) ) ) ) ).

% of_int_or_eq
thf(fact_4320_of__int__and__eq,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [K: int,L: int] :
          ( ( ring_1_of_int @ A @ ( bit_se5824344872417868541ns_and @ int @ K @ L ) )
          = ( bit_se5824344872417868541ns_and @ A @ ( ring_1_of_int @ A @ K ) @ ( ring_1_of_int @ A @ L ) ) ) ) ).

% of_int_and_eq
thf(fact_4321_or_Oassoc,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( bit_se1065995026697491101ons_or @ A @ ( bit_se1065995026697491101ons_or @ A @ A2 @ B2 ) @ C2 )
          = ( bit_se1065995026697491101ons_or @ A @ A2 @ ( bit_se1065995026697491101ons_or @ A @ B2 @ C2 ) ) ) ) ).

% or.assoc
thf(fact_4322_and_Oassoc,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( bit_se5824344872417868541ns_and @ A @ A2 @ B2 ) @ C2 )
          = ( bit_se5824344872417868541ns_and @ A @ A2 @ ( bit_se5824344872417868541ns_and @ A @ B2 @ C2 ) ) ) ) ).

% and.assoc
thf(fact_4323_or_Ocommute,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se1065995026697491101ons_or @ A )
        = ( ^ [A4: A,B4: A] : ( bit_se1065995026697491101ons_or @ A @ B4 @ A4 ) ) ) ) ).

% or.commute
thf(fact_4324_and_Ocommute,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se5824344872417868541ns_and @ A )
        = ( ^ [A4: A,B4: A] : ( bit_se5824344872417868541ns_and @ A @ B4 @ A4 ) ) ) ) ).

% and.commute
thf(fact_4325_or_Oleft__commute,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( bit_se1065995026697491101ons_or @ A @ B2 @ ( bit_se1065995026697491101ons_or @ A @ A2 @ C2 ) )
          = ( bit_se1065995026697491101ons_or @ A @ A2 @ ( bit_se1065995026697491101ons_or @ A @ B2 @ C2 ) ) ) ) ).

% or.left_commute
thf(fact_4326_and_Oleft__commute,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ B2 @ ( bit_se5824344872417868541ns_and @ A @ A2 @ C2 ) )
          = ( bit_se5824344872417868541ns_and @ A @ A2 @ ( bit_se5824344872417868541ns_and @ A @ B2 @ C2 ) ) ) ) ).

% and.left_commute
thf(fact_4327_bit_Oconj__disj__distrib,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X2: A,Y2: A,Z: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ X2 @ ( bit_se1065995026697491101ons_or @ A @ Y2 @ Z ) )
          = ( bit_se1065995026697491101ons_or @ A @ ( bit_se5824344872417868541ns_and @ A @ X2 @ Y2 ) @ ( bit_se5824344872417868541ns_and @ A @ X2 @ Z ) ) ) ) ).

% bit.conj_disj_distrib
thf(fact_4328_bit_Odisj__conj__distrib,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X2: A,Y2: A,Z: A] :
          ( ( bit_se1065995026697491101ons_or @ A @ X2 @ ( bit_se5824344872417868541ns_and @ A @ Y2 @ Z ) )
          = ( bit_se5824344872417868541ns_and @ A @ ( bit_se1065995026697491101ons_or @ A @ X2 @ Y2 ) @ ( bit_se1065995026697491101ons_or @ A @ X2 @ Z ) ) ) ) ).

% bit.disj_conj_distrib
thf(fact_4329_bit_Oconj__disj__distrib2,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [Y2: A,Z: A,X2: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( bit_se1065995026697491101ons_or @ A @ Y2 @ Z ) @ X2 )
          = ( bit_se1065995026697491101ons_or @ A @ ( bit_se5824344872417868541ns_and @ A @ Y2 @ X2 ) @ ( bit_se5824344872417868541ns_and @ A @ Z @ X2 ) ) ) ) ).

% bit.conj_disj_distrib2
thf(fact_4330_bit_Odisj__conj__distrib2,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [Y2: A,Z: A,X2: A] :
          ( ( bit_se1065995026697491101ons_or @ A @ ( bit_se5824344872417868541ns_and @ A @ Y2 @ Z ) @ X2 )
          = ( bit_se5824344872417868541ns_and @ A @ ( bit_se1065995026697491101ons_or @ A @ Y2 @ X2 ) @ ( bit_se1065995026697491101ons_or @ A @ Z @ X2 ) ) ) ) ).

% bit.disj_conj_distrib2
thf(fact_4331_bot_Oextremum,axiom,
    ! [A: $tType] :
      ( ( order_bot @ A )
     => ! [A2: A] : ( ord_less_eq @ A @ ( bot_bot @ A ) @ A2 ) ) ).

% bot.extremum
thf(fact_4332_bot_Oextremum__unique,axiom,
    ! [A: $tType] :
      ( ( order_bot @ A )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ A2 @ ( bot_bot @ A ) )
          = ( A2
            = ( bot_bot @ A ) ) ) ) ).

% bot.extremum_unique
thf(fact_4333_bot_Oextremum__uniqueI,axiom,
    ! [A: $tType] :
      ( ( order_bot @ A )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ A2 @ ( bot_bot @ A ) )
         => ( A2
            = ( bot_bot @ A ) ) ) ) ).

% bot.extremum_uniqueI
thf(fact_4334_bit__or__iff,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A,B2: A,N2: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( bit_se1065995026697491101ons_or @ A @ A2 @ B2 ) @ N2 )
          = ( ( bit_se5641148757651400278ts_bit @ A @ A2 @ N2 )
            | ( bit_se5641148757651400278ts_bit @ A @ B2 @ N2 ) ) ) ) ).

% bit_or_iff
thf(fact_4335_of__nat__and__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M: nat,N2: nat] :
          ( ( semiring_1_of_nat @ A @ ( bit_se5824344872417868541ns_and @ nat @ M @ N2 ) )
          = ( bit_se5824344872417868541ns_and @ A @ ( semiring_1_of_nat @ A @ M ) @ ( semiring_1_of_nat @ A @ N2 ) ) ) ) ).

% of_nat_and_eq
thf(fact_4336_of__nat__or__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M: nat,N2: nat] :
          ( ( semiring_1_of_nat @ A @ ( bit_se1065995026697491101ons_or @ nat @ M @ N2 ) )
          = ( bit_se1065995026697491101ons_or @ A @ ( semiring_1_of_nat @ A @ M ) @ ( semiring_1_of_nat @ A @ N2 ) ) ) ) ).

% of_nat_or_eq
thf(fact_4337_bit__and__int__iff,axiom,
    ! [K: int,L: int,N2: nat] :
      ( ( bit_se5641148757651400278ts_bit @ int @ ( bit_se5824344872417868541ns_and @ int @ K @ L ) @ N2 )
      = ( ( bit_se5641148757651400278ts_bit @ int @ K @ N2 )
        & ( bit_se5641148757651400278ts_bit @ int @ L @ N2 ) ) ) ).

% bit_and_int_iff
thf(fact_4338_bit__or__int__iff,axiom,
    ! [K: int,L: int,N2: nat] :
      ( ( bit_se5641148757651400278ts_bit @ int @ ( bit_se1065995026697491101ons_or @ int @ K @ L ) @ N2 )
      = ( ( bit_se5641148757651400278ts_bit @ int @ K @ N2 )
        | ( bit_se5641148757651400278ts_bit @ int @ L @ N2 ) ) ) ).

% bit_or_int_iff
thf(fact_4339_not__psubset__empty,axiom,
    ! [A: $tType,A3: set @ A] :
      ~ ( ord_less @ ( set @ A ) @ A3 @ ( bot_bot @ ( set @ A ) ) ) ).

% not_psubset_empty
thf(fact_4340_bit_Ocomplement__unique,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [A2: A,X2: A,Y2: A] :
          ( ( ( bit_se5824344872417868541ns_and @ A @ A2 @ X2 )
            = ( zero_zero @ A ) )
         => ( ( ( bit_se1065995026697491101ons_or @ A @ A2 @ X2 )
              = ( uminus_uminus @ A @ ( one_one @ A ) ) )
           => ( ( ( bit_se5824344872417868541ns_and @ A @ A2 @ Y2 )
                = ( zero_zero @ A ) )
             => ( ( ( bit_se1065995026697491101ons_or @ A @ A2 @ Y2 )
                  = ( uminus_uminus @ A @ ( one_one @ A ) ) )
               => ( X2 = Y2 ) ) ) ) ) ) ).

% bit.complement_unique
thf(fact_4341_and__eq__minus__1__iff,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [A2: A,B2: A] :
          ( ( ( bit_se5824344872417868541ns_and @ A @ A2 @ B2 )
            = ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( ( A2
              = ( uminus_uminus @ A @ ( one_one @ A ) ) )
            & ( B2
              = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ) ) ).

% and_eq_minus_1_iff
thf(fact_4342_diff__shunt__var,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [X2: A,Y2: A] :
          ( ( ( minus_minus @ A @ X2 @ Y2 )
            = ( bot_bot @ A ) )
          = ( ord_less_eq @ A @ X2 @ Y2 ) ) ) ).

% diff_shunt_var
thf(fact_4343_or__greater__eq,axiom,
    ! [L: int,K: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ L )
     => ( ord_less_eq @ int @ K @ ( bit_se1065995026697491101ons_or @ int @ K @ L ) ) ) ).

% or_greater_eq
thf(fact_4344_OR__lower,axiom,
    ! [X2: int,Y2: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ X2 )
     => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Y2 )
       => ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( bit_se1065995026697491101ons_or @ int @ X2 @ Y2 ) ) ) ) ).

% OR_lower
thf(fact_4345_AND__upper2_H,axiom,
    ! [Y2: int,Z: int,X2: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Y2 )
     => ( ( ord_less_eq @ int @ Y2 @ Z )
       => ( ord_less_eq @ int @ ( bit_se5824344872417868541ns_and @ int @ X2 @ Y2 ) @ Z ) ) ) ).

% AND_upper2'
thf(fact_4346_AND__upper1_H,axiom,
    ! [Y2: int,Z: int,Ya: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Y2 )
     => ( ( ord_less_eq @ int @ Y2 @ Z )
       => ( ord_less_eq @ int @ ( bit_se5824344872417868541ns_and @ int @ Y2 @ Ya ) @ Z ) ) ) ).

% AND_upper1'
thf(fact_4347_AND__upper2,axiom,
    ! [Y2: int,X2: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Y2 )
     => ( ord_less_eq @ int @ ( bit_se5824344872417868541ns_and @ int @ X2 @ Y2 ) @ Y2 ) ) ).

% AND_upper2
thf(fact_4348_AND__upper1,axiom,
    ! [X2: int,Y2: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ X2 )
     => ( ord_less_eq @ int @ ( bit_se5824344872417868541ns_and @ int @ X2 @ Y2 ) @ X2 ) ) ).

% AND_upper1
thf(fact_4349_AND__lower,axiom,
    ! [X2: int,Y2: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ X2 )
     => ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( bit_se5824344872417868541ns_and @ int @ X2 @ Y2 ) ) ) ).

% AND_lower
thf(fact_4350_disjunctive__add,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A,B2: A] :
          ( ! [N: nat] :
              ( ~ ( bit_se5641148757651400278ts_bit @ A @ A2 @ N )
              | ~ ( bit_se5641148757651400278ts_bit @ A @ B2 @ N ) )
         => ( ( plus_plus @ A @ A2 @ B2 )
            = ( bit_se1065995026697491101ons_or @ A @ A2 @ B2 ) ) ) ) ).

% disjunctive_add
thf(fact_4351_real__sgn__eq,axiom,
    ( ( sgn_sgn @ real )
    = ( ^ [X5: real] : ( divide_divide @ real @ X5 @ ( abs_abs @ real @ X5 ) ) ) ) ).

% real_sgn_eq
thf(fact_4352_take__bit__eq__mask,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se2584673776208193580ke_bit @ A )
        = ( ^ [N3: nat,A4: A] : ( bit_se5824344872417868541ns_and @ A @ A4 @ ( bit_se2239418461657761734s_mask @ A @ N3 ) ) ) ) ) ).

% take_bit_eq_mask
thf(fact_4353_lessThan__empty__iff,axiom,
    ! [N2: nat] :
      ( ( ( set_ord_lessThan @ nat @ N2 )
        = ( bot_bot @ ( set @ nat ) ) )
      = ( N2
        = ( zero_zero @ nat ) ) ) ).

% lessThan_empty_iff
thf(fact_4354_subset__Compl__self__eq,axiom,
    ! [A: $tType,A3: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ ( uminus_uminus @ ( set @ A ) @ A3 ) )
      = ( A3
        = ( bot_bot @ ( set @ A ) ) ) ) ).

% subset_Compl_self_eq
thf(fact_4355_AND__upper2_H_H,axiom,
    ! [Y2: int,Z: int,X2: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Y2 )
     => ( ( ord_less @ int @ Y2 @ Z )
       => ( ord_less @ int @ ( bit_se5824344872417868541ns_and @ int @ X2 @ Y2 ) @ Z ) ) ) ).

% AND_upper2''
thf(fact_4356_AND__upper1_H_H,axiom,
    ! [Y2: int,Z: int,Ya: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Y2 )
     => ( ( ord_less @ int @ Y2 @ Z )
       => ( ord_less @ int @ ( bit_se5824344872417868541ns_and @ int @ Y2 @ Ya ) @ Z ) ) ) ).

% AND_upper1''
thf(fact_4357_and__less__eq,axiom,
    ! [L: int,K: int] :
      ( ( ord_less @ int @ L @ ( zero_zero @ int ) )
     => ( ord_less_eq @ int @ ( bit_se5824344872417868541ns_and @ int @ K @ L ) @ K ) ) ).

% and_less_eq
thf(fact_4358_sgn__eq,axiom,
    ( ( sgn_sgn @ complex )
    = ( ^ [Z6: complex] : ( divide_divide @ complex @ Z6 @ ( real_Vector_of_real @ complex @ ( real_V7770717601297561774m_norm @ complex @ Z6 ) ) ) ) ) ).

% sgn_eq
thf(fact_4359_cis__Arg,axiom,
    ! [Z: complex] :
      ( ( Z
       != ( zero_zero @ complex ) )
     => ( ( cis @ ( arg @ Z ) )
        = ( sgn_sgn @ complex @ Z ) ) ) ).

% cis_Arg
thf(fact_4360_even__and__iff,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A,B2: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se5824344872417868541ns_and @ A @ A2 @ B2 ) )
          = ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
            | ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B2 ) ) ) ) ).

% even_and_iff
thf(fact_4361_even__or__iff,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A,B2: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se1065995026697491101ons_or @ A @ A2 @ B2 ) )
          = ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
            & ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B2 ) ) ) ) ).

% even_or_iff
thf(fact_4362_sgn__real__def,axiom,
    ( ( sgn_sgn @ real )
    = ( ^ [A4: real] :
          ( if @ real
          @ ( A4
            = ( zero_zero @ real ) )
          @ ( zero_zero @ real )
          @ ( if @ real @ ( ord_less @ real @ ( zero_zero @ real ) @ A4 ) @ ( one_one @ real ) @ ( uminus_uminus @ real @ ( one_one @ real ) ) ) ) ) ) ).

% sgn_real_def
thf(fact_4363_even__and__iff__int,axiom,
    ! [K: int,L: int] :
      ( ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se5824344872417868541ns_and @ int @ K @ L ) )
      = ( ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ K )
        | ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ L ) ) ) ).

% even_and_iff_int
thf(fact_4364_one__and__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( one_one @ A ) @ A2 )
          = ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% one_and_eq
thf(fact_4365_and__one__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ A2 @ ( one_one @ A ) )
          = ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% and_one_eq
thf(fact_4366_sgn__power__injE,axiom,
    ! [A2: real,N2: nat,X2: real,B2: real] :
      ( ( ( times_times @ real @ ( sgn_sgn @ real @ A2 ) @ ( power_power @ real @ ( abs_abs @ real @ A2 ) @ N2 ) )
        = X2 )
     => ( ( X2
          = ( times_times @ real @ ( sgn_sgn @ real @ B2 ) @ ( power_power @ real @ ( abs_abs @ real @ B2 ) @ N2 ) ) )
       => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
         => ( A2 = B2 ) ) ) ) ).

% sgn_power_injE
thf(fact_4367_and__exp__eq__0__iff__not__bit,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A,N2: nat] :
          ( ( ( bit_se5824344872417868541ns_and @ A @ A2 @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N2 ) )
            = ( zero_zero @ A ) )
          = ( ~ ( bit_se5641148757651400278ts_bit @ A @ A2 @ N2 ) ) ) ) ).

% and_exp_eq_0_iff_not_bit
thf(fact_4368_mask__Suc__exp,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N2: nat] :
          ( ( bit_se2239418461657761734s_mask @ A @ ( suc @ N2 ) )
          = ( bit_se1065995026697491101ons_or @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N2 ) @ ( bit_se2239418461657761734s_mask @ A @ N2 ) ) ) ) ).

% mask_Suc_exp
thf(fact_4369_cis__Arg__unique,axiom,
    ! [Z: complex,X2: real] :
      ( ( ( sgn_sgn @ complex @ Z )
        = ( cis @ X2 ) )
     => ( ( ord_less @ real @ ( uminus_uminus @ real @ pi ) @ X2 )
       => ( ( ord_less_eq @ real @ X2 @ pi )
         => ( ( arg @ Z )
            = X2 ) ) ) ) ).

% cis_Arg_unique
thf(fact_4370_or__one__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A] :
          ( ( bit_se1065995026697491101ons_or @ A @ A2 @ ( one_one @ A ) )
          = ( plus_plus @ A @ A2 @ ( zero_neq_one_of_bool @ A @ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) ) ) ) ) ).

% or_one_eq
thf(fact_4371_one__or__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A] :
          ( ( bit_se1065995026697491101ons_or @ A @ ( one_one @ A ) @ A2 )
          = ( plus_plus @ A @ A2 @ ( zero_neq_one_of_bool @ A @ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) ) ) ) ) ).

% one_or_eq
thf(fact_4372_mask__Suc__double,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N2: nat] :
          ( ( bit_se2239418461657761734s_mask @ A @ ( suc @ N2 ) )
          = ( bit_se1065995026697491101ons_or @ A @ ( one_one @ A ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se2239418461657761734s_mask @ A @ N2 ) ) ) ) ) ).

% mask_Suc_double
thf(fact_4373_OR__upper,axiom,
    ! [X2: int,N2: nat,Y2: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ X2 )
     => ( ( ord_less @ int @ X2 @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N2 ) )
       => ( ( ord_less @ int @ Y2 @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N2 ) )
         => ( ord_less @ int @ ( bit_se1065995026697491101ons_or @ int @ X2 @ Y2 ) @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N2 ) ) ) ) ) ).

% OR_upper
thf(fact_4374_Arg__correct,axiom,
    ! [Z: complex] :
      ( ( Z
       != ( zero_zero @ complex ) )
     => ( ( ( sgn_sgn @ complex @ Z )
          = ( cis @ ( arg @ Z ) ) )
        & ( ord_less @ real @ ( uminus_uminus @ real @ pi ) @ ( arg @ Z ) )
        & ( ord_less_eq @ real @ ( arg @ Z ) @ pi ) ) ) ).

% Arg_correct
thf(fact_4375_or__int__rec,axiom,
    ( ( bit_se1065995026697491101ons_or @ int )
    = ( ^ [K3: int,L2: int] :
          ( plus_plus @ int
          @ ( zero_neq_one_of_bool @ int
            @ ( ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ K3 )
              | ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ L2 ) ) )
          @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se1065995026697491101ons_or @ int @ ( divide_divide @ int @ K3 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ int @ L2 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% or_int_rec
thf(fact_4376_and__int__rec,axiom,
    ( ( bit_se5824344872417868541ns_and @ int )
    = ( ^ [K3: int,L2: int] :
          ( plus_plus @ int
          @ ( zero_neq_one_of_bool @ int
            @ ( ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ K3 )
              & ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ L2 ) ) )
          @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se5824344872417868541ns_and @ int @ ( divide_divide @ int @ K3 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ int @ L2 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% and_int_rec
thf(fact_4377_or__minus__numerals_I5_J,axiom,
    ! [N2: num] :
      ( ( bit_se1065995026697491101ons_or @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit0 @ N2 ) ) ) @ ( one_one @ int ) )
      = ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit_or_not_num_neg @ one2 @ ( bitM @ N2 ) ) ) ) ) ).

% or_minus_numerals(5)
thf(fact_4378_or__minus__numerals_I1_J,axiom,
    ! [N2: num] :
      ( ( bit_se1065995026697491101ons_or @ int @ ( one_one @ int ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit0 @ N2 ) ) ) )
      = ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit_or_not_num_neg @ one2 @ ( bitM @ N2 ) ) ) ) ) ).

% or_minus_numerals(1)
thf(fact_4379_Arg__def,axiom,
    ( arg
    = ( ^ [Z6: complex] :
          ( if @ real
          @ ( Z6
            = ( zero_zero @ complex ) )
          @ ( zero_zero @ real )
          @ ( fChoice @ real
            @ ^ [A4: real] :
                ( ( ( sgn_sgn @ complex @ Z6 )
                  = ( cis @ A4 ) )
                & ( ord_less @ real @ ( uminus_uminus @ real @ pi ) @ A4 )
                & ( ord_less_eq @ real @ A4 @ pi ) ) ) ) ) ) ).

% Arg_def
thf(fact_4380_VEBT__internal_OminNull_Opelims_I1_J,axiom,
    ! [X2: vEBT_VEBT,Y2: $o] :
      ( ( ( vEBT_VEBT_minNull @ X2 )
        = Y2 )
     => ( ( accp @ vEBT_VEBT @ vEBT_V6963167321098673237ll_rel @ X2 )
       => ( ( ( X2
              = ( vEBT_Leaf @ $false @ $false ) )
           => ( Y2
             => ~ ( accp @ vEBT_VEBT @ vEBT_V6963167321098673237ll_rel @ ( vEBT_Leaf @ $false @ $false ) ) ) )
         => ( ! [Uv: $o] :
                ( ( X2
                  = ( vEBT_Leaf @ $true @ Uv ) )
               => ( ~ Y2
                 => ~ ( accp @ vEBT_VEBT @ vEBT_V6963167321098673237ll_rel @ ( vEBT_Leaf @ $true @ Uv ) ) ) )
           => ( ! [Uu: $o] :
                  ( ( X2
                    = ( vEBT_Leaf @ Uu @ $true ) )
                 => ( ~ Y2
                   => ~ ( accp @ vEBT_VEBT @ vEBT_V6963167321098673237ll_rel @ ( vEBT_Leaf @ Uu @ $true ) ) ) )
             => ( ! [Uw: nat,Ux: list @ vEBT_VEBT,Uy: vEBT_VEBT] :
                    ( ( X2
                      = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ Uw @ Ux @ Uy ) )
                   => ( Y2
                     => ~ ( accp @ vEBT_VEBT @ vEBT_V6963167321098673237ll_rel @ ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ Uw @ Ux @ Uy ) ) ) )
               => ~ ! [Uz: product_prod @ nat @ nat,Va2: nat,Vb2: list @ vEBT_VEBT,Vc2: vEBT_VEBT] :
                      ( ( X2
                        = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ Uz ) @ Va2 @ Vb2 @ Vc2 ) )
                     => ( ~ Y2
                       => ~ ( accp @ vEBT_VEBT @ vEBT_V6963167321098673237ll_rel @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ Uz ) @ Va2 @ Vb2 @ Vc2 ) ) ) ) ) ) ) ) ) ) ).

% VEBT_internal.minNull.pelims(1)
thf(fact_4381_bit__0__eq,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ( ( bit_se5641148757651400278ts_bit @ A @ ( zero_zero @ A ) )
        = ( bot_bot @ ( nat > $o ) ) ) ) ).

% bit_0_eq
thf(fact_4382_and__nat__numerals_I3_J,axiom,
    ! [X2: num] :
      ( ( bit_se5824344872417868541ns_and @ nat @ ( numeral_numeral @ nat @ ( bit0 @ X2 ) ) @ ( suc @ ( zero_zero @ nat ) ) )
      = ( zero_zero @ nat ) ) ).

% and_nat_numerals(3)
thf(fact_4383_and__nat__numerals_I1_J,axiom,
    ! [Y2: num] :
      ( ( bit_se5824344872417868541ns_and @ nat @ ( suc @ ( zero_zero @ nat ) ) @ ( numeral_numeral @ nat @ ( bit0 @ Y2 ) ) )
      = ( zero_zero @ nat ) ) ).

% and_nat_numerals(1)
thf(fact_4384_or__nat__numerals_I4_J,axiom,
    ! [X2: num] :
      ( ( bit_se1065995026697491101ons_or @ nat @ ( numeral_numeral @ nat @ ( bit1 @ X2 ) ) @ ( suc @ ( zero_zero @ nat ) ) )
      = ( numeral_numeral @ nat @ ( bit1 @ X2 ) ) ) ).

% or_nat_numerals(4)
thf(fact_4385_or__nat__numerals_I2_J,axiom,
    ! [Y2: num] :
      ( ( bit_se1065995026697491101ons_or @ nat @ ( suc @ ( zero_zero @ nat ) ) @ ( numeral_numeral @ nat @ ( bit1 @ Y2 ) ) )
      = ( numeral_numeral @ nat @ ( bit1 @ Y2 ) ) ) ).

% or_nat_numerals(2)
thf(fact_4386_or__nat__numerals_I3_J,axiom,
    ! [X2: num] :
      ( ( bit_se1065995026697491101ons_or @ nat @ ( numeral_numeral @ nat @ ( bit0 @ X2 ) ) @ ( suc @ ( zero_zero @ nat ) ) )
      = ( numeral_numeral @ nat @ ( bit1 @ X2 ) ) ) ).

% or_nat_numerals(3)
thf(fact_4387_or__nat__numerals_I1_J,axiom,
    ! [Y2: num] :
      ( ( bit_se1065995026697491101ons_or @ nat @ ( suc @ ( zero_zero @ nat ) ) @ ( numeral_numeral @ nat @ ( bit0 @ Y2 ) ) )
      = ( numeral_numeral @ nat @ ( bit1 @ Y2 ) ) ) ).

% or_nat_numerals(1)
thf(fact_4388_and__nat__numerals_I4_J,axiom,
    ! [X2: num] :
      ( ( bit_se5824344872417868541ns_and @ nat @ ( numeral_numeral @ nat @ ( bit1 @ X2 ) ) @ ( suc @ ( zero_zero @ nat ) ) )
      = ( one_one @ nat ) ) ).

% and_nat_numerals(4)
thf(fact_4389_and__nat__numerals_I2_J,axiom,
    ! [Y2: num] :
      ( ( bit_se5824344872417868541ns_and @ nat @ ( suc @ ( zero_zero @ nat ) ) @ ( numeral_numeral @ nat @ ( bit1 @ Y2 ) ) )
      = ( one_one @ nat ) ) ).

% and_nat_numerals(2)
thf(fact_4390_or__minus__numerals_I4_J,axiom,
    ! [M: num,N2: num] :
      ( ( bit_se1065995026697491101ons_or @ int @ ( numeral_numeral @ int @ M ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit1 @ N2 ) ) ) )
      = ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit_or_not_num_neg @ M @ ( bit0 @ N2 ) ) ) ) ) ).

% or_minus_numerals(4)
thf(fact_4391_or__minus__numerals_I8_J,axiom,
    ! [N2: num,M: num] :
      ( ( bit_se1065995026697491101ons_or @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit1 @ N2 ) ) ) @ ( numeral_numeral @ int @ M ) )
      = ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit_or_not_num_neg @ M @ ( bit0 @ N2 ) ) ) ) ) ).

% or_minus_numerals(8)
thf(fact_4392_or__minus__numerals_I3_J,axiom,
    ! [M: num,N2: num] :
      ( ( bit_se1065995026697491101ons_or @ int @ ( numeral_numeral @ int @ M ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit0 @ N2 ) ) ) )
      = ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit_or_not_num_neg @ M @ ( bitM @ N2 ) ) ) ) ) ).

% or_minus_numerals(3)
thf(fact_4393_or__minus__numerals_I7_J,axiom,
    ! [N2: num,M: num] :
      ( ( bit_se1065995026697491101ons_or @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit0 @ N2 ) ) ) @ ( numeral_numeral @ int @ M ) )
      = ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit_or_not_num_neg @ M @ ( bitM @ N2 ) ) ) ) ) ).

% or_minus_numerals(7)
thf(fact_4394_Suc__0__and__eq,axiom,
    ! [N2: nat] :
      ( ( bit_se5824344872417868541ns_and @ nat @ ( suc @ ( zero_zero @ nat ) ) @ N2 )
      = ( modulo_modulo @ nat @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ).

% Suc_0_and_eq
thf(fact_4395_and__Suc__0__eq,axiom,
    ! [N2: nat] :
      ( ( bit_se5824344872417868541ns_and @ nat @ N2 @ ( suc @ ( zero_zero @ nat ) ) )
      = ( modulo_modulo @ nat @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ).

% and_Suc_0_eq
thf(fact_4396_bot__enat__def,axiom,
    ( ( bot_bot @ extended_enat )
    = ( zero_zero @ extended_enat ) ) ).

% bot_enat_def
thf(fact_4397_bot__nat__def,axiom,
    ( ( bot_bot @ nat )
    = ( zero_zero @ nat ) ) ).

% bot_nat_def
thf(fact_4398_bot__empty__eq2,axiom,
    ! [B: $tType,A: $tType] :
      ( ( bot_bot @ ( A > B > $o ) )
      = ( ^ [X5: A,Y5: B] : ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X5 @ Y5 ) @ ( bot_bot @ ( set @ ( product_prod @ A @ B ) ) ) ) ) ) ).

% bot_empty_eq2
thf(fact_4399_or__not__num__neg_Osimps_I1_J,axiom,
    ( ( bit_or_not_num_neg @ one2 @ one2 )
    = one2 ) ).

% or_not_num_neg.simps(1)
thf(fact_4400_or__not__num__neg_Osimps_I4_J,axiom,
    ! [N2: num] :
      ( ( bit_or_not_num_neg @ ( bit0 @ N2 ) @ one2 )
      = ( bit0 @ one2 ) ) ).

% or_not_num_neg.simps(4)
thf(fact_4401_or__not__num__neg_Osimps_I6_J,axiom,
    ! [N2: num,M: num] :
      ( ( bit_or_not_num_neg @ ( bit0 @ N2 ) @ ( bit1 @ M ) )
      = ( bit0 @ ( bit_or_not_num_neg @ N2 @ M ) ) ) ).

% or_not_num_neg.simps(6)
thf(fact_4402_or__not__num__neg_Osimps_I7_J,axiom,
    ! [N2: num] :
      ( ( bit_or_not_num_neg @ ( bit1 @ N2 ) @ one2 )
      = one2 ) ).

% or_not_num_neg.simps(7)
thf(fact_4403_or__not__num__neg_Osimps_I3_J,axiom,
    ! [M: num] :
      ( ( bit_or_not_num_neg @ one2 @ ( bit1 @ M ) )
      = ( bit1 @ M ) ) ).

% or_not_num_neg.simps(3)
thf(fact_4404_or__not__num__neg_Osimps_I5_J,axiom,
    ! [N2: num,M: num] :
      ( ( bit_or_not_num_neg @ ( bit0 @ N2 ) @ ( bit0 @ M ) )
      = ( bitM @ ( bit_or_not_num_neg @ N2 @ M ) ) ) ).

% or_not_num_neg.simps(5)
thf(fact_4405_or__not__num__neg_Osimps_I9_J,axiom,
    ! [N2: num,M: num] :
      ( ( bit_or_not_num_neg @ ( bit1 @ N2 ) @ ( bit1 @ M ) )
      = ( bitM @ ( bit_or_not_num_neg @ N2 @ M ) ) ) ).

% or_not_num_neg.simps(9)
thf(fact_4406_or__nat__def,axiom,
    ( ( bit_se1065995026697491101ons_or @ nat )
    = ( ^ [M6: nat,N3: nat] : ( nat2 @ ( bit_se1065995026697491101ons_or @ int @ ( semiring_1_of_nat @ int @ M6 ) @ ( semiring_1_of_nat @ int @ N3 ) ) ) ) ) ).

% or_nat_def
thf(fact_4407_and__nat__def,axiom,
    ( ( bit_se5824344872417868541ns_and @ nat )
    = ( ^ [M6: nat,N3: nat] : ( nat2 @ ( bit_se5824344872417868541ns_and @ int @ ( semiring_1_of_nat @ int @ M6 ) @ ( semiring_1_of_nat @ int @ N3 ) ) ) ) ) ).

% and_nat_def
thf(fact_4408_or__not__num__neg_Osimps_I2_J,axiom,
    ! [M: num] :
      ( ( bit_or_not_num_neg @ one2 @ ( bit0 @ M ) )
      = ( bit1 @ M ) ) ).

% or_not_num_neg.simps(2)
thf(fact_4409_or__not__num__neg_Osimps_I8_J,axiom,
    ! [N2: num,M: num] :
      ( ( bit_or_not_num_neg @ ( bit1 @ N2 ) @ ( bit0 @ M ) )
      = ( bitM @ ( bit_or_not_num_neg @ N2 @ M ) ) ) ).

% or_not_num_neg.simps(8)
thf(fact_4410_or__not__num__neg_Oelims,axiom,
    ! [X2: num,Xa2: num,Y2: num] :
      ( ( ( bit_or_not_num_neg @ X2 @ Xa2 )
        = Y2 )
     => ( ( ( X2 = one2 )
         => ( ( Xa2 = one2 )
           => ( Y2 != one2 ) ) )
       => ( ( ( X2 = one2 )
           => ! [M3: num] :
                ( ( Xa2
                  = ( bit0 @ M3 ) )
               => ( Y2
                 != ( bit1 @ M3 ) ) ) )
         => ( ( ( X2 = one2 )
             => ! [M3: num] :
                  ( ( Xa2
                    = ( bit1 @ M3 ) )
                 => ( Y2
                   != ( bit1 @ M3 ) ) ) )
           => ( ( ? [N: num] :
                    ( X2
                    = ( bit0 @ N ) )
               => ( ( Xa2 = one2 )
                 => ( Y2
                   != ( bit0 @ one2 ) ) ) )
             => ( ! [N: num] :
                    ( ( X2
                      = ( bit0 @ N ) )
                   => ! [M3: num] :
                        ( ( Xa2
                          = ( bit0 @ M3 ) )
                       => ( Y2
                         != ( bitM @ ( bit_or_not_num_neg @ N @ M3 ) ) ) ) )
               => ( ! [N: num] :
                      ( ( X2
                        = ( bit0 @ N ) )
                     => ! [M3: num] :
                          ( ( Xa2
                            = ( bit1 @ M3 ) )
                         => ( Y2
                           != ( bit0 @ ( bit_or_not_num_neg @ N @ M3 ) ) ) ) )
                 => ( ( ? [N: num] :
                          ( X2
                          = ( bit1 @ N ) )
                     => ( ( Xa2 = one2 )
                       => ( Y2 != one2 ) ) )
                   => ( ! [N: num] :
                          ( ( X2
                            = ( bit1 @ N ) )
                         => ! [M3: num] :
                              ( ( Xa2
                                = ( bit0 @ M3 ) )
                             => ( Y2
                               != ( bitM @ ( bit_or_not_num_neg @ N @ M3 ) ) ) ) )
                     => ~ ! [N: num] :
                            ( ( X2
                              = ( bit1 @ N ) )
                           => ! [M3: num] :
                                ( ( Xa2
                                  = ( bit1 @ M3 ) )
                               => ( Y2
                                 != ( bitM @ ( bit_or_not_num_neg @ N @ M3 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ).

% or_not_num_neg.elims
thf(fact_4411_and__nat__unfold,axiom,
    ( ( bit_se5824344872417868541ns_and @ nat )
    = ( ^ [M6: nat,N3: nat] :
          ( if @ nat
          @ ( ( M6
              = ( zero_zero @ nat ) )
            | ( N3
              = ( zero_zero @ nat ) ) )
          @ ( zero_zero @ nat )
          @ ( plus_plus @ nat @ ( times_times @ nat @ ( modulo_modulo @ nat @ M6 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( modulo_modulo @ nat @ N3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( bit_se5824344872417868541ns_and @ nat @ ( divide_divide @ nat @ M6 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ nat @ N3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ).

% and_nat_unfold
thf(fact_4412_VEBT__internal_OminNull_Opelims_I3_J,axiom,
    ! [X2: vEBT_VEBT] :
      ( ~ ( vEBT_VEBT_minNull @ X2 )
     => ( ( accp @ vEBT_VEBT @ vEBT_V6963167321098673237ll_rel @ X2 )
       => ( ! [Uv: $o] :
              ( ( X2
                = ( vEBT_Leaf @ $true @ Uv ) )
             => ~ ( accp @ vEBT_VEBT @ vEBT_V6963167321098673237ll_rel @ ( vEBT_Leaf @ $true @ Uv ) ) )
         => ( ! [Uu: $o] :
                ( ( X2
                  = ( vEBT_Leaf @ Uu @ $true ) )
               => ~ ( accp @ vEBT_VEBT @ vEBT_V6963167321098673237ll_rel @ ( vEBT_Leaf @ Uu @ $true ) ) )
           => ~ ! [Uz: product_prod @ nat @ nat,Va2: nat,Vb2: list @ vEBT_VEBT,Vc2: vEBT_VEBT] :
                  ( ( X2
                    = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ Uz ) @ Va2 @ Vb2 @ Vc2 ) )
                 => ~ ( accp @ vEBT_VEBT @ vEBT_V6963167321098673237ll_rel @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ Uz ) @ Va2 @ Vb2 @ Vc2 ) ) ) ) ) ) ) ).

% VEBT_internal.minNull.pelims(3)
thf(fact_4413_VEBT__internal_OminNull_Opelims_I2_J,axiom,
    ! [X2: vEBT_VEBT] :
      ( ( vEBT_VEBT_minNull @ X2 )
     => ( ( accp @ vEBT_VEBT @ vEBT_V6963167321098673237ll_rel @ X2 )
       => ( ( ( X2
              = ( vEBT_Leaf @ $false @ $false ) )
           => ~ ( accp @ vEBT_VEBT @ vEBT_V6963167321098673237ll_rel @ ( vEBT_Leaf @ $false @ $false ) ) )
         => ~ ! [Uw: nat,Ux: list @ vEBT_VEBT,Uy: vEBT_VEBT] :
                ( ( X2
                  = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ Uw @ Ux @ Uy ) )
               => ~ ( accp @ vEBT_VEBT @ vEBT_V6963167321098673237ll_rel @ ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ Uw @ Ux @ Uy ) ) ) ) ) ) ).

% VEBT_internal.minNull.pelims(2)
thf(fact_4414_Suc__0__or__eq,axiom,
    ! [N2: nat] :
      ( ( bit_se1065995026697491101ons_or @ nat @ ( suc @ ( zero_zero @ nat ) ) @ N2 )
      = ( plus_plus @ nat @ N2 @ ( zero_neq_one_of_bool @ nat @ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) ) ) ).

% Suc_0_or_eq
thf(fact_4415_or__Suc__0__eq,axiom,
    ! [N2: nat] :
      ( ( bit_se1065995026697491101ons_or @ nat @ N2 @ ( suc @ ( zero_zero @ nat ) ) )
      = ( plus_plus @ nat @ N2 @ ( zero_neq_one_of_bool @ nat @ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) ) ) ).

% or_Suc_0_eq
thf(fact_4416_or__nat__rec,axiom,
    ( ( bit_se1065995026697491101ons_or @ nat )
    = ( ^ [M6: nat,N3: nat] :
          ( plus_plus @ nat
          @ ( zero_neq_one_of_bool @ nat
            @ ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M6 )
              | ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N3 ) ) )
          @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( bit_se1065995026697491101ons_or @ nat @ ( divide_divide @ nat @ M6 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ nat @ N3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% or_nat_rec
thf(fact_4417_and__nat__rec,axiom,
    ( ( bit_se5824344872417868541ns_and @ nat )
    = ( ^ [M6: nat,N3: nat] :
          ( plus_plus @ nat
          @ ( zero_neq_one_of_bool @ nat
            @ ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M6 )
              & ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N3 ) ) )
          @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( bit_se5824344872417868541ns_and @ nat @ ( divide_divide @ nat @ M6 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ nat @ N3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% and_nat_rec
thf(fact_4418_or__nat__unfold,axiom,
    ( ( bit_se1065995026697491101ons_or @ nat )
    = ( ^ [M6: nat,N3: nat] :
          ( if @ nat
          @ ( M6
            = ( zero_zero @ nat ) )
          @ N3
          @ ( if @ nat
            @ ( N3
              = ( zero_zero @ nat ) )
            @ M6
            @ ( plus_plus @ nat @ ( ord_max @ nat @ ( modulo_modulo @ nat @ M6 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( modulo_modulo @ nat @ N3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( bit_se1065995026697491101ons_or @ nat @ ( divide_divide @ nat @ M6 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ nat @ N3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ).

% or_nat_unfold
thf(fact_4419_and__int_Oelims,axiom,
    ! [X2: int,Xa2: int,Y2: int] :
      ( ( ( bit_se5824344872417868541ns_and @ int @ X2 @ Xa2 )
        = Y2 )
     => ( ( ( ( member @ int @ X2 @ ( insert @ int @ ( zero_zero @ int ) @ ( insert @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) )
            & ( member @ int @ Xa2 @ ( insert @ int @ ( zero_zero @ int ) @ ( insert @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) ) )
         => ( Y2
            = ( uminus_uminus @ int
              @ ( zero_neq_one_of_bool @ int
                @ ( ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ X2 )
                  & ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ Xa2 ) ) ) ) ) )
        & ( ~ ( ( member @ int @ X2 @ ( insert @ int @ ( zero_zero @ int ) @ ( insert @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) )
              & ( member @ int @ Xa2 @ ( insert @ int @ ( zero_zero @ int ) @ ( insert @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) ) )
         => ( Y2
            = ( plus_plus @ int
              @ ( zero_neq_one_of_bool @ int
                @ ( ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ X2 )
                  & ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ Xa2 ) ) )
              @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se5824344872417868541ns_and @ int @ ( divide_divide @ int @ X2 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ int @ Xa2 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ).

% and_int.elims
thf(fact_4420_and__int_Osimps,axiom,
    ( ( bit_se5824344872417868541ns_and @ int )
    = ( ^ [K3: int,L2: int] :
          ( if @ int
          @ ( ( member @ int @ K3 @ ( insert @ int @ ( zero_zero @ int ) @ ( insert @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) )
            & ( member @ int @ L2 @ ( insert @ int @ ( zero_zero @ int ) @ ( insert @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) ) )
          @ ( uminus_uminus @ int
            @ ( zero_neq_one_of_bool @ int
              @ ( ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ K3 )
                & ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ L2 ) ) ) )
          @ ( plus_plus @ int
            @ ( zero_neq_one_of_bool @ int
              @ ( ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ K3 )
                & ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ L2 ) ) )
            @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se5824344872417868541ns_and @ int @ ( divide_divide @ int @ K3 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ int @ L2 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ).

% and_int.simps
thf(fact_4421_or__not__num__neg_Opelims,axiom,
    ! [X2: num,Xa2: num,Y2: num] :
      ( ( ( bit_or_not_num_neg @ X2 @ Xa2 )
        = Y2 )
     => ( ( accp @ ( product_prod @ num @ num ) @ bit_or3848514188828904588eg_rel @ ( product_Pair @ num @ num @ X2 @ Xa2 ) )
       => ( ( ( X2 = one2 )
           => ( ( Xa2 = one2 )
             => ( ( Y2 = one2 )
               => ~ ( accp @ ( product_prod @ num @ num ) @ bit_or3848514188828904588eg_rel @ ( product_Pair @ num @ num @ one2 @ one2 ) ) ) ) )
         => ( ( ( X2 = one2 )
             => ! [M3: num] :
                  ( ( Xa2
                    = ( bit0 @ M3 ) )
                 => ( ( Y2
                      = ( bit1 @ M3 ) )
                   => ~ ( accp @ ( product_prod @ num @ num ) @ bit_or3848514188828904588eg_rel @ ( product_Pair @ num @ num @ one2 @ ( bit0 @ M3 ) ) ) ) ) )
           => ( ( ( X2 = one2 )
               => ! [M3: num] :
                    ( ( Xa2
                      = ( bit1 @ M3 ) )
                   => ( ( Y2
                        = ( bit1 @ M3 ) )
                     => ~ ( accp @ ( product_prod @ num @ num ) @ bit_or3848514188828904588eg_rel @ ( product_Pair @ num @ num @ one2 @ ( bit1 @ M3 ) ) ) ) ) )
             => ( ! [N: num] :
                    ( ( X2
                      = ( bit0 @ N ) )
                   => ( ( Xa2 = one2 )
                     => ( ( Y2
                          = ( bit0 @ one2 ) )
                       => ~ ( accp @ ( product_prod @ num @ num ) @ bit_or3848514188828904588eg_rel @ ( product_Pair @ num @ num @ ( bit0 @ N ) @ one2 ) ) ) ) )
               => ( ! [N: num] :
                      ( ( X2
                        = ( bit0 @ N ) )
                     => ! [M3: num] :
                          ( ( Xa2
                            = ( bit0 @ M3 ) )
                         => ( ( Y2
                              = ( bitM @ ( bit_or_not_num_neg @ N @ M3 ) ) )
                           => ~ ( accp @ ( product_prod @ num @ num ) @ bit_or3848514188828904588eg_rel @ ( product_Pair @ num @ num @ ( bit0 @ N ) @ ( bit0 @ M3 ) ) ) ) ) )
                 => ( ! [N: num] :
                        ( ( X2
                          = ( bit0 @ N ) )
                       => ! [M3: num] :
                            ( ( Xa2
                              = ( bit1 @ M3 ) )
                           => ( ( Y2
                                = ( bit0 @ ( bit_or_not_num_neg @ N @ M3 ) ) )
                             => ~ ( accp @ ( product_prod @ num @ num ) @ bit_or3848514188828904588eg_rel @ ( product_Pair @ num @ num @ ( bit0 @ N ) @ ( bit1 @ M3 ) ) ) ) ) )
                   => ( ! [N: num] :
                          ( ( X2
                            = ( bit1 @ N ) )
                         => ( ( Xa2 = one2 )
                           => ( ( Y2 = one2 )
                             => ~ ( accp @ ( product_prod @ num @ num ) @ bit_or3848514188828904588eg_rel @ ( product_Pair @ num @ num @ ( bit1 @ N ) @ one2 ) ) ) ) )
                     => ( ! [N: num] :
                            ( ( X2
                              = ( bit1 @ N ) )
                           => ! [M3: num] :
                                ( ( Xa2
                                  = ( bit0 @ M3 ) )
                               => ( ( Y2
                                    = ( bitM @ ( bit_or_not_num_neg @ N @ M3 ) ) )
                                 => ~ ( accp @ ( product_prod @ num @ num ) @ bit_or3848514188828904588eg_rel @ ( product_Pair @ num @ num @ ( bit1 @ N ) @ ( bit0 @ M3 ) ) ) ) ) )
                       => ~ ! [N: num] :
                              ( ( X2
                                = ( bit1 @ N ) )
                             => ! [M3: num] :
                                  ( ( Xa2
                                    = ( bit1 @ M3 ) )
                                 => ( ( Y2
                                      = ( bitM @ ( bit_or_not_num_neg @ N @ M3 ) ) )
                                   => ~ ( accp @ ( product_prod @ num @ num ) @ bit_or3848514188828904588eg_rel @ ( product_Pair @ num @ num @ ( bit1 @ N ) @ ( bit1 @ M3 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ).

% or_not_num_neg.pelims
thf(fact_4422_and__int_Opsimps,axiom,
    ! [K: int,L: int] :
      ( ( accp @ ( product_prod @ int @ int ) @ bit_and_int_rel @ ( product_Pair @ int @ int @ K @ L ) )
     => ( ( ( ( member @ int @ K @ ( insert @ int @ ( zero_zero @ int ) @ ( insert @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) )
            & ( member @ int @ L @ ( insert @ int @ ( zero_zero @ int ) @ ( insert @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) ) )
         => ( ( bit_se5824344872417868541ns_and @ int @ K @ L )
            = ( uminus_uminus @ int
              @ ( zero_neq_one_of_bool @ int
                @ ( ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ K )
                  & ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ L ) ) ) ) ) )
        & ( ~ ( ( member @ int @ K @ ( insert @ int @ ( zero_zero @ int ) @ ( insert @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) )
              & ( member @ int @ L @ ( insert @ int @ ( zero_zero @ int ) @ ( insert @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) ) )
         => ( ( bit_se5824344872417868541ns_and @ int @ K @ L )
            = ( plus_plus @ int
              @ ( zero_neq_one_of_bool @ int
                @ ( ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ K )
                  & ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ L ) ) )
              @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se5824344872417868541ns_and @ int @ ( divide_divide @ int @ K @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ int @ L @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ).

% and_int.psimps
thf(fact_4423_insert__subset,axiom,
    ! [A: $tType,X2: A,A3: set @ A,B3: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ ( insert @ A @ X2 @ A3 ) @ B3 )
      = ( ( member @ A @ X2 @ B3 )
        & ( ord_less_eq @ ( set @ A ) @ A3 @ B3 ) ) ) ).

% insert_subset
thf(fact_4424_singleton__insert__inj__eq_H,axiom,
    ! [A: $tType,A2: A,A3: set @ A,B2: A] :
      ( ( ( insert @ A @ A2 @ A3 )
        = ( insert @ A @ B2 @ ( bot_bot @ ( set @ A ) ) ) )
      = ( ( A2 = B2 )
        & ( ord_less_eq @ ( set @ A ) @ A3 @ ( insert @ A @ B2 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% singleton_insert_inj_eq'
thf(fact_4425_singleton__insert__inj__eq,axiom,
    ! [A: $tType,B2: A,A2: A,A3: set @ A] :
      ( ( ( insert @ A @ B2 @ ( bot_bot @ ( set @ A ) ) )
        = ( insert @ A @ A2 @ A3 ) )
      = ( ( A2 = B2 )
        & ( ord_less_eq @ ( set @ A ) @ A3 @ ( insert @ A @ B2 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% singleton_insert_inj_eq
thf(fact_4426_subset__Compl__singleton,axiom,
    ! [A: $tType,A3: set @ A,B2: A] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ ( uminus_uminus @ ( set @ A ) @ ( insert @ A @ B2 @ ( bot_bot @ ( set @ A ) ) ) ) )
      = ( ~ ( member @ A @ B2 @ A3 ) ) ) ).

% subset_Compl_singleton
thf(fact_4427_set__replicate,axiom,
    ! [A: $tType,N2: nat,X2: A] :
      ( ( N2
       != ( zero_zero @ nat ) )
     => ( ( set2 @ A @ ( replicate @ A @ N2 @ X2 ) )
        = ( insert @ A @ X2 @ ( bot_bot @ ( set @ A ) ) ) ) ) ).

% set_replicate
thf(fact_4428_subset__insertI2,axiom,
    ! [A: $tType,A3: set @ A,B3: set @ A,B2: A] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ B3 )
     => ( ord_less_eq @ ( set @ A ) @ A3 @ ( insert @ A @ B2 @ B3 ) ) ) ).

% subset_insertI2
thf(fact_4429_subset__insertI,axiom,
    ! [A: $tType,B3: set @ A,A2: A] : ( ord_less_eq @ ( set @ A ) @ B3 @ ( insert @ A @ A2 @ B3 ) ) ).

% subset_insertI
thf(fact_4430_subset__insert,axiom,
    ! [A: $tType,X2: A,A3: set @ A,B3: set @ A] :
      ( ~ ( member @ A @ X2 @ A3 )
     => ( ( ord_less_eq @ ( set @ A ) @ A3 @ ( insert @ A @ X2 @ B3 ) )
        = ( ord_less_eq @ ( set @ A ) @ A3 @ B3 ) ) ) ).

% subset_insert
thf(fact_4431_insert__mono,axiom,
    ! [A: $tType,C6: set @ A,D5: set @ A,A2: A] :
      ( ( ord_less_eq @ ( set @ A ) @ C6 @ D5 )
     => ( ord_less_eq @ ( set @ A ) @ ( insert @ A @ A2 @ C6 ) @ ( insert @ A @ A2 @ D5 ) ) ) ).

% insert_mono
thf(fact_4432_subset__singleton__iff,axiom,
    ! [A: $tType,X8: set @ A,A2: A] :
      ( ( ord_less_eq @ ( set @ A ) @ X8 @ ( insert @ A @ A2 @ ( bot_bot @ ( set @ A ) ) ) )
      = ( ( X8
          = ( bot_bot @ ( set @ A ) ) )
        | ( X8
          = ( insert @ A @ A2 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% subset_singleton_iff
thf(fact_4433_subset__singletonD,axiom,
    ! [A: $tType,A3: set @ A,X2: A] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ ( insert @ A @ X2 @ ( bot_bot @ ( set @ A ) ) ) )
     => ( ( A3
          = ( bot_bot @ ( set @ A ) ) )
        | ( A3
          = ( insert @ A @ X2 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% subset_singletonD
thf(fact_4434_subset__Diff__insert,axiom,
    ! [A: $tType,A3: set @ A,B3: set @ A,X2: A,C6: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ ( minus_minus @ ( set @ A ) @ B3 @ ( insert @ A @ X2 @ C6 ) ) )
      = ( ( ord_less_eq @ ( set @ A ) @ A3 @ ( minus_minus @ ( set @ A ) @ B3 @ C6 ) )
        & ~ ( member @ A @ X2 @ A3 ) ) ) ).

% subset_Diff_insert
thf(fact_4435_subset__insert__iff,axiom,
    ! [A: $tType,A3: set @ A,X2: A,B3: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ ( insert @ A @ X2 @ B3 ) )
      = ( ( ( member @ A @ X2 @ A3 )
         => ( ord_less_eq @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X2 @ ( bot_bot @ ( set @ A ) ) ) ) @ B3 ) )
        & ( ~ ( member @ A @ X2 @ A3 )
         => ( ord_less_eq @ ( set @ A ) @ A3 @ B3 ) ) ) ) ).

% subset_insert_iff
thf(fact_4436_Diff__single__insert,axiom,
    ! [A: $tType,A3: set @ A,X2: A,B3: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X2 @ ( bot_bot @ ( set @ A ) ) ) ) @ B3 )
     => ( ord_less_eq @ ( set @ A ) @ A3 @ ( insert @ A @ X2 @ B3 ) ) ) ).

% Diff_single_insert
thf(fact_4437_set__update__subset__insert,axiom,
    ! [A: $tType,Xs: list @ A,I3: nat,X2: A] : ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ ( list_update @ A @ Xs @ I3 @ X2 ) ) @ ( insert @ A @ X2 @ ( set2 @ A @ Xs ) ) ) ).

% set_update_subset_insert
thf(fact_4438_psubset__insert__iff,axiom,
    ! [A: $tType,A3: set @ A,X2: A,B3: set @ A] :
      ( ( ord_less @ ( set @ A ) @ A3 @ ( insert @ A @ X2 @ B3 ) )
      = ( ( ( member @ A @ X2 @ B3 )
         => ( ord_less @ ( set @ A ) @ A3 @ B3 ) )
        & ( ~ ( member @ A @ X2 @ B3 )
         => ( ( ( member @ A @ X2 @ A3 )
             => ( ord_less @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X2 @ ( bot_bot @ ( set @ A ) ) ) ) @ B3 ) )
            & ( ~ ( member @ A @ X2 @ A3 )
             => ( ord_less_eq @ ( set @ A ) @ A3 @ B3 ) ) ) ) ) ) ).

% psubset_insert_iff
thf(fact_4439_set__replicate__Suc,axiom,
    ! [A: $tType,N2: nat,X2: A] :
      ( ( set2 @ A @ ( replicate @ A @ ( suc @ N2 ) @ X2 ) )
      = ( insert @ A @ X2 @ ( bot_bot @ ( set @ A ) ) ) ) ).

% set_replicate_Suc
thf(fact_4440_set__replicate__conv__if,axiom,
    ! [A: $tType,N2: nat,X2: A] :
      ( ( ( N2
          = ( zero_zero @ nat ) )
       => ( ( set2 @ A @ ( replicate @ A @ N2 @ X2 ) )
          = ( bot_bot @ ( set @ A ) ) ) )
      & ( ( N2
         != ( zero_zero @ nat ) )
       => ( ( set2 @ A @ ( replicate @ A @ N2 @ X2 ) )
          = ( insert @ A @ X2 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% set_replicate_conv_if
thf(fact_4441_atLeastAtMostPlus1__int__conv,axiom,
    ! [M: int,N2: int] :
      ( ( ord_less_eq @ int @ M @ ( plus_plus @ int @ ( one_one @ int ) @ N2 ) )
     => ( ( set_or1337092689740270186AtMost @ int @ M @ ( plus_plus @ int @ ( one_one @ int ) @ N2 ) )
        = ( insert @ int @ ( plus_plus @ int @ ( one_one @ int ) @ N2 ) @ ( set_or1337092689740270186AtMost @ int @ M @ N2 ) ) ) ) ).

% atLeastAtMostPlus1_int_conv
thf(fact_4442_simp__from__to,axiom,
    ( ( set_or1337092689740270186AtMost @ int )
    = ( ^ [I4: int,J3: int] : ( if @ ( set @ int ) @ ( ord_less @ int @ J3 @ I4 ) @ ( bot_bot @ ( set @ int ) ) @ ( insert @ int @ I4 @ ( set_or1337092689740270186AtMost @ int @ ( plus_plus @ int @ I4 @ ( one_one @ int ) ) @ J3 ) ) ) ) ) ).

% simp_from_to
thf(fact_4443_sinh__zero__iff,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X2: A] :
          ( ( ( sinh @ A @ X2 )
            = ( zero_zero @ A ) )
          = ( member @ A @ ( exp @ A @ X2 ) @ ( insert @ A @ ( one_one @ A ) @ ( insert @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ).

% sinh_zero_iff
thf(fact_4444_and__int_Opinduct,axiom,
    ! [A0: int,A1: int,P: int > int > $o] :
      ( ( accp @ ( product_prod @ int @ int ) @ bit_and_int_rel @ ( product_Pair @ int @ int @ A0 @ A1 ) )
     => ( ! [K2: int,L4: int] :
            ( ( accp @ ( product_prod @ int @ int ) @ bit_and_int_rel @ ( product_Pair @ int @ int @ K2 @ L4 ) )
           => ( ( ~ ( ( member @ int @ K2 @ ( insert @ int @ ( zero_zero @ int ) @ ( insert @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) )
                    & ( member @ int @ L4 @ ( insert @ int @ ( zero_zero @ int ) @ ( insert @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) ) )
               => ( P @ ( divide_divide @ int @ K2 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ int @ L4 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) )
             => ( P @ K2 @ L4 ) ) )
       => ( P @ A0 @ A1 ) ) ) ).

% and_int.pinduct
thf(fact_4445_and__int_Opelims,axiom,
    ! [X2: int,Xa2: int,Y2: int] :
      ( ( ( bit_se5824344872417868541ns_and @ int @ X2 @ Xa2 )
        = Y2 )
     => ( ( accp @ ( product_prod @ int @ int ) @ bit_and_int_rel @ ( product_Pair @ int @ int @ X2 @ Xa2 ) )
       => ~ ( ( ( ( ( member @ int @ X2 @ ( insert @ int @ ( zero_zero @ int ) @ ( insert @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) )
                  & ( member @ int @ Xa2 @ ( insert @ int @ ( zero_zero @ int ) @ ( insert @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) ) )
               => ( Y2
                  = ( uminus_uminus @ int
                    @ ( zero_neq_one_of_bool @ int
                      @ ( ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ X2 )
                        & ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ Xa2 ) ) ) ) ) )
              & ( ~ ( ( member @ int @ X2 @ ( insert @ int @ ( zero_zero @ int ) @ ( insert @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) )
                    & ( member @ int @ Xa2 @ ( insert @ int @ ( zero_zero @ int ) @ ( insert @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) ) )
               => ( Y2
                  = ( plus_plus @ int
                    @ ( zero_neq_one_of_bool @ int
                      @ ( ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ X2 )
                        & ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ Xa2 ) ) )
                    @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se5824344872417868541ns_and @ int @ ( divide_divide @ int @ X2 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ int @ Xa2 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) ) ) ) )
           => ~ ( accp @ ( product_prod @ int @ int ) @ bit_and_int_rel @ ( product_Pair @ int @ int @ X2 @ Xa2 ) ) ) ) ) ).

% and_int.pelims
thf(fact_4446_cis__multiple__2pi,axiom,
    ! [N2: real] :
      ( ( member @ real @ N2 @ ( ring_1_Ints @ real ) )
     => ( ( cis @ ( times_times @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) @ N2 ) )
        = ( one_one @ complex ) ) ) ).

% cis_multiple_2pi
thf(fact_4447_xor__Suc__0__eq,axiom,
    ! [N2: nat] :
      ( ( bit_se5824344971392196577ns_xor @ nat @ N2 @ ( suc @ ( zero_zero @ nat ) ) )
      = ( minus_minus @ nat @ ( plus_plus @ nat @ N2 @ ( zero_neq_one_of_bool @ nat @ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) )
        @ ( zero_neq_one_of_bool @ nat
          @ ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) ) ) ).

% xor_Suc_0_eq
thf(fact_4448_Suc__0__xor__eq,axiom,
    ! [N2: nat] :
      ( ( bit_se5824344971392196577ns_xor @ nat @ ( suc @ ( zero_zero @ nat ) ) @ N2 )
      = ( minus_minus @ nat @ ( plus_plus @ nat @ N2 @ ( zero_neq_one_of_bool @ nat @ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) )
        @ ( zero_neq_one_of_bool @ nat
          @ ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) ) ) ).

% Suc_0_xor_eq
thf(fact_4449_horner__sum__of__bool__2__less,axiom,
    ! [Bs: list @ $o] : ( ord_less @ int @ ( groups4207007520872428315er_sum @ $o @ int @ ( zero_neq_one_of_bool @ int ) @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ Bs ) @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( size_size @ ( list @ $o ) @ Bs ) ) ) ).

% horner_sum_of_bool_2_less
thf(fact_4450_bit_Oxor__left__self,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X2: A,Y2: A] :
          ( ( bit_se5824344971392196577ns_xor @ A @ X2 @ ( bit_se5824344971392196577ns_xor @ A @ X2 @ Y2 ) )
          = Y2 ) ) ).

% bit.xor_left_self
thf(fact_4451_xor_Oright__neutral,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A] :
          ( ( bit_se5824344971392196577ns_xor @ A @ A2 @ ( zero_zero @ A ) )
          = A2 ) ) ).

% xor.right_neutral
thf(fact_4452_xor_Oleft__neutral,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A] :
          ( ( bit_se5824344971392196577ns_xor @ A @ ( zero_zero @ A ) @ A2 )
          = A2 ) ) ).

% xor.left_neutral
thf(fact_4453_xor__self__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A] :
          ( ( bit_se5824344971392196577ns_xor @ A @ A2 @ A2 )
          = ( zero_zero @ A ) ) ) ).

% xor_self_eq
thf(fact_4454_bit_Oxor__self,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X2: A] :
          ( ( bit_se5824344971392196577ns_xor @ A @ X2 @ X2 )
          = ( zero_zero @ A ) ) ) ).

% bit.xor_self
thf(fact_4455_take__bit__xor,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N2: nat,A2: A,B2: A] :
          ( ( bit_se2584673776208193580ke_bit @ A @ N2 @ ( bit_se5824344971392196577ns_xor @ A @ A2 @ B2 ) )
          = ( bit_se5824344971392196577ns_xor @ A @ ( bit_se2584673776208193580ke_bit @ A @ N2 @ A2 ) @ ( bit_se2584673776208193580ke_bit @ A @ N2 @ B2 ) ) ) ) ).

% take_bit_xor
thf(fact_4456_atMost__0,axiom,
    ( ( set_ord_atMost @ nat @ ( zero_zero @ nat ) )
    = ( insert @ nat @ ( zero_zero @ nat ) @ ( bot_bot @ ( set @ nat ) ) ) ) ).

% atMost_0
thf(fact_4457_frac__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A] :
          ( ( ( archimedean_frac @ A @ X2 )
            = ( zero_zero @ A ) )
          = ( member @ A @ X2 @ ( ring_1_Ints @ A ) ) ) ) ).

% frac_eq_0_iff
thf(fact_4458_floor__add2,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A,Y2: A] :
          ( ( ( member @ A @ X2 @ ( ring_1_Ints @ A ) )
            | ( member @ A @ Y2 @ ( ring_1_Ints @ A ) ) )
         => ( ( archim6421214686448440834_floor @ A @ ( plus_plus @ A @ X2 @ Y2 ) )
            = ( plus_plus @ int @ ( archim6421214686448440834_floor @ A @ X2 ) @ ( archim6421214686448440834_floor @ A @ Y2 ) ) ) ) ) ).

% floor_add2
thf(fact_4459_frac__gt__0__iff,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( archimedean_frac @ A @ X2 ) )
          = ( ~ ( member @ A @ X2 @ ( ring_1_Ints @ A ) ) ) ) ) ).

% frac_gt_0_iff
thf(fact_4460_xor__numerals_I3_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X2: num,Y2: num] :
          ( ( bit_se5824344971392196577ns_xor @ A @ ( numeral_numeral @ A @ ( bit0 @ X2 ) ) @ ( numeral_numeral @ A @ ( bit0 @ Y2 ) ) )
          = ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se5824344971392196577ns_xor @ A @ ( numeral_numeral @ A @ X2 ) @ ( numeral_numeral @ A @ Y2 ) ) ) ) ) ).

% xor_numerals(3)
thf(fact_4461_xor__numerals_I8_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X2: num] :
          ( ( bit_se5824344971392196577ns_xor @ A @ ( numeral_numeral @ A @ ( bit1 @ X2 ) ) @ ( one_one @ A ) )
          = ( numeral_numeral @ A @ ( bit0 @ X2 ) ) ) ) ).

% xor_numerals(8)
thf(fact_4462_xor__numerals_I5_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X2: num] :
          ( ( bit_se5824344971392196577ns_xor @ A @ ( numeral_numeral @ A @ ( bit0 @ X2 ) ) @ ( one_one @ A ) )
          = ( numeral_numeral @ A @ ( bit1 @ X2 ) ) ) ) ).

% xor_numerals(5)
thf(fact_4463_xor__numerals_I2_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [Y2: num] :
          ( ( bit_se5824344971392196577ns_xor @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit1 @ Y2 ) ) )
          = ( numeral_numeral @ A @ ( bit0 @ Y2 ) ) ) ) ).

% xor_numerals(2)
thf(fact_4464_xor__numerals_I1_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [Y2: num] :
          ( ( bit_se5824344971392196577ns_xor @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ Y2 ) ) )
          = ( numeral_numeral @ A @ ( bit1 @ Y2 ) ) ) ) ).

% xor_numerals(1)
thf(fact_4465_xor__numerals_I7_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X2: num,Y2: num] :
          ( ( bit_se5824344971392196577ns_xor @ A @ ( numeral_numeral @ A @ ( bit1 @ X2 ) ) @ ( numeral_numeral @ A @ ( bit1 @ Y2 ) ) )
          = ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se5824344971392196577ns_xor @ A @ ( numeral_numeral @ A @ X2 ) @ ( numeral_numeral @ A @ Y2 ) ) ) ) ) ).

% xor_numerals(7)
thf(fact_4466_xor__nat__numerals_I4_J,axiom,
    ! [X2: num] :
      ( ( bit_se5824344971392196577ns_xor @ nat @ ( numeral_numeral @ nat @ ( bit1 @ X2 ) ) @ ( suc @ ( zero_zero @ nat ) ) )
      = ( numeral_numeral @ nat @ ( bit0 @ X2 ) ) ) ).

% xor_nat_numerals(4)
thf(fact_4467_xor__nat__numerals_I3_J,axiom,
    ! [X2: num] :
      ( ( bit_se5824344971392196577ns_xor @ nat @ ( numeral_numeral @ nat @ ( bit0 @ X2 ) ) @ ( suc @ ( zero_zero @ nat ) ) )
      = ( numeral_numeral @ nat @ ( bit1 @ X2 ) ) ) ).

% xor_nat_numerals(3)
thf(fact_4468_xor__nat__numerals_I2_J,axiom,
    ! [Y2: num] :
      ( ( bit_se5824344971392196577ns_xor @ nat @ ( suc @ ( zero_zero @ nat ) ) @ ( numeral_numeral @ nat @ ( bit1 @ Y2 ) ) )
      = ( numeral_numeral @ nat @ ( bit0 @ Y2 ) ) ) ).

% xor_nat_numerals(2)
thf(fact_4469_xor__nat__numerals_I1_J,axiom,
    ! [Y2: num] :
      ( ( bit_se5824344971392196577ns_xor @ nat @ ( suc @ ( zero_zero @ nat ) ) @ ( numeral_numeral @ nat @ ( bit0 @ Y2 ) ) )
      = ( numeral_numeral @ nat @ ( bit1 @ Y2 ) ) ) ).

% xor_nat_numerals(1)
thf(fact_4470_xor__numerals_I6_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X2: num,Y2: num] :
          ( ( bit_se5824344971392196577ns_xor @ A @ ( numeral_numeral @ A @ ( bit1 @ X2 ) ) @ ( numeral_numeral @ A @ ( bit0 @ Y2 ) ) )
          = ( plus_plus @ A @ ( one_one @ A ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se5824344971392196577ns_xor @ A @ ( numeral_numeral @ A @ X2 ) @ ( numeral_numeral @ A @ Y2 ) ) ) ) ) ) ).

% xor_numerals(6)
thf(fact_4471_xor__numerals_I4_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X2: num,Y2: num] :
          ( ( bit_se5824344971392196577ns_xor @ A @ ( numeral_numeral @ A @ ( bit0 @ X2 ) ) @ ( numeral_numeral @ A @ ( bit1 @ Y2 ) ) )
          = ( plus_plus @ A @ ( one_one @ A ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se5824344971392196577ns_xor @ A @ ( numeral_numeral @ A @ X2 ) @ ( numeral_numeral @ A @ Y2 ) ) ) ) ) ) ).

% xor_numerals(4)
thf(fact_4472_Ints__add,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [A2: A,B2: A] :
          ( ( member @ A @ A2 @ ( ring_1_Ints @ A ) )
         => ( ( member @ A @ B2 @ ( ring_1_Ints @ A ) )
           => ( member @ A @ ( plus_plus @ A @ A2 @ B2 ) @ ( ring_1_Ints @ A ) ) ) ) ) ).

% Ints_add
thf(fact_4473_Ints__power,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [A2: A,N2: nat] :
          ( ( member @ A @ A2 @ ( ring_1_Ints @ A ) )
         => ( member @ A @ ( power_power @ A @ A2 @ N2 ) @ ( ring_1_Ints @ A ) ) ) ) ).

% Ints_power
thf(fact_4474_bit__xor__iff,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A,B2: A,N2: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( bit_se5824344971392196577ns_xor @ A @ A2 @ B2 ) @ N2 )
          = ( ( ( bit_se5641148757651400278ts_bit @ A @ A2 @ N2 )
             != ( bit_se5641148757651400278ts_bit @ A @ B2 @ N2 ) ) ) ) ) ).

% bit_xor_iff
thf(fact_4475_of__nat__xor__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M: nat,N2: nat] :
          ( ( semiring_1_of_nat @ A @ ( bit_se5824344971392196577ns_xor @ nat @ M @ N2 ) )
          = ( bit_se5824344971392196577ns_xor @ A @ ( semiring_1_of_nat @ A @ M ) @ ( semiring_1_of_nat @ A @ N2 ) ) ) ) ).

% of_nat_xor_eq
thf(fact_4476_xor_Oleft__commute,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( bit_se5824344971392196577ns_xor @ A @ B2 @ ( bit_se5824344971392196577ns_xor @ A @ A2 @ C2 ) )
          = ( bit_se5824344971392196577ns_xor @ A @ A2 @ ( bit_se5824344971392196577ns_xor @ A @ B2 @ C2 ) ) ) ) ).

% xor.left_commute
thf(fact_4477_xor_Ocommute,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se5824344971392196577ns_xor @ A )
        = ( ^ [A4: A,B4: A] : ( bit_se5824344971392196577ns_xor @ A @ B4 @ A4 ) ) ) ) ).

% xor.commute
thf(fact_4478_xor_Oassoc,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( bit_se5824344971392196577ns_xor @ A @ ( bit_se5824344971392196577ns_xor @ A @ A2 @ B2 ) @ C2 )
          = ( bit_se5824344971392196577ns_xor @ A @ A2 @ ( bit_se5824344971392196577ns_xor @ A @ B2 @ C2 ) ) ) ) ).

% xor.assoc
thf(fact_4479_of__int__xor__eq,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [K: int,L: int] :
          ( ( ring_1_of_int @ A @ ( bit_se5824344971392196577ns_xor @ int @ K @ L ) )
          = ( bit_se5824344971392196577ns_xor @ A @ ( ring_1_of_int @ A @ K ) @ ( ring_1_of_int @ A @ L ) ) ) ) ).

% of_int_xor_eq
thf(fact_4480_Ints__1,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ( member @ A @ ( one_one @ A ) @ ( ring_1_Ints @ A ) ) ) ).

% Ints_1
thf(fact_4481_Ints__0,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ( member @ A @ ( zero_zero @ A ) @ ( ring_1_Ints @ A ) ) ) ).

% Ints_0
thf(fact_4482_Ints__numeral,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [N2: num] : ( member @ A @ ( numeral_numeral @ A @ N2 ) @ ( ring_1_Ints @ A ) ) ) ).

% Ints_numeral
thf(fact_4483_Ints__mult,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [A2: A,B2: A] :
          ( ( member @ A @ A2 @ ( ring_1_Ints @ A ) )
         => ( ( member @ A @ B2 @ ( ring_1_Ints @ A ) )
           => ( member @ A @ ( times_times @ A @ A2 @ B2 ) @ ( ring_1_Ints @ A ) ) ) ) ) ).

% Ints_mult
thf(fact_4484_bit_Oconj__xor__distrib2,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [Y2: A,Z: A,X2: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( bit_se5824344971392196577ns_xor @ A @ Y2 @ Z ) @ X2 )
          = ( bit_se5824344971392196577ns_xor @ A @ ( bit_se5824344872417868541ns_and @ A @ Y2 @ X2 ) @ ( bit_se5824344872417868541ns_and @ A @ Z @ X2 ) ) ) ) ).

% bit.conj_xor_distrib2
thf(fact_4485_bit_Oconj__xor__distrib,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X2: A,Y2: A,Z: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ X2 @ ( bit_se5824344971392196577ns_xor @ A @ Y2 @ Z ) )
          = ( bit_se5824344971392196577ns_xor @ A @ ( bit_se5824344872417868541ns_and @ A @ X2 @ Y2 ) @ ( bit_se5824344872417868541ns_and @ A @ X2 @ Z ) ) ) ) ).

% bit.conj_xor_distrib
thf(fact_4486_Ints__double__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [A2: A] :
          ( ( member @ A @ A2 @ ( ring_1_Ints @ A ) )
         => ( ( ( plus_plus @ A @ A2 @ A2 )
              = ( zero_zero @ A ) )
            = ( A2
              = ( zero_zero @ A ) ) ) ) ) ).

% Ints_double_eq_0_iff
thf(fact_4487_lessThan__Suc,axiom,
    ! [K: nat] :
      ( ( set_ord_lessThan @ nat @ ( suc @ K ) )
      = ( insert @ nat @ K @ ( set_ord_lessThan @ nat @ K ) ) ) ).

% lessThan_Suc
thf(fact_4488_atMost__Suc,axiom,
    ! [K: nat] :
      ( ( set_ord_atMost @ nat @ ( suc @ K ) )
      = ( insert @ nat @ ( suc @ K ) @ ( set_ord_atMost @ nat @ K ) ) ) ).

% atMost_Suc
thf(fact_4489_atLeast0__atMost__Suc,axiom,
    ! [N2: nat] :
      ( ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ ( suc @ N2 ) )
      = ( insert @ nat @ ( suc @ N2 ) @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N2 ) ) ) ).

% atLeast0_atMost_Suc
thf(fact_4490_Ints__odd__nonzero,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [A2: A] :
          ( ( member @ A @ A2 @ ( ring_1_Ints @ A ) )
         => ( ( plus_plus @ A @ ( plus_plus @ A @ ( one_one @ A ) @ A2 ) @ A2 )
           != ( zero_zero @ A ) ) ) ) ).

% Ints_odd_nonzero
thf(fact_4491_Icc__eq__insert__lb__nat,axiom,
    ! [M: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ M @ N2 )
     => ( ( set_or1337092689740270186AtMost @ nat @ M @ N2 )
        = ( insert @ nat @ M @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ M ) @ N2 ) ) ) ) ).

% Icc_eq_insert_lb_nat
thf(fact_4492_atLeastAtMostSuc__conv,axiom,
    ! [M: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ M @ ( suc @ N2 ) )
     => ( ( set_or1337092689740270186AtMost @ nat @ M @ ( suc @ N2 ) )
        = ( insert @ nat @ ( suc @ N2 ) @ ( set_or1337092689740270186AtMost @ nat @ M @ N2 ) ) ) ) ).

% atLeastAtMostSuc_conv
thf(fact_4493_atLeastAtMost__insertL,axiom,
    ! [M: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ M @ N2 )
     => ( ( insert @ nat @ M @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ M ) @ N2 ) )
        = ( set_or1337092689740270186AtMost @ nat @ M @ N2 ) ) ) ).

% atLeastAtMost_insertL
thf(fact_4494_lessThan__nat__numeral,axiom,
    ! [K: num] :
      ( ( set_ord_lessThan @ nat @ ( numeral_numeral @ nat @ K ) )
      = ( insert @ nat @ ( pred_numeral @ K ) @ ( set_ord_lessThan @ nat @ ( pred_numeral @ K ) ) ) ) ).

% lessThan_nat_numeral
thf(fact_4495_atMost__nat__numeral,axiom,
    ! [K: num] :
      ( ( set_ord_atMost @ nat @ ( numeral_numeral @ nat @ K ) )
      = ( insert @ nat @ ( numeral_numeral @ nat @ K ) @ ( set_ord_atMost @ nat @ ( pred_numeral @ K ) ) ) ) ).

% atMost_nat_numeral
thf(fact_4496_of__int__divide__in__Ints,axiom,
    ! [A: $tType] :
      ( ( idom_divide @ A )
     => ! [B2: int,A2: int] :
          ( ( dvd_dvd @ int @ B2 @ A2 )
         => ( member @ A @ ( divide_divide @ A @ ( ring_1_of_int @ A @ A2 ) @ ( ring_1_of_int @ A @ B2 ) ) @ ( ring_1_Ints @ A ) ) ) ) ).

% of_int_divide_in_Ints
thf(fact_4497_even__xor__iff,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A,B2: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se5824344971392196577ns_xor @ A @ A2 @ B2 ) )
          = ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
            = ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B2 ) ) ) ) ).

% even_xor_iff
thf(fact_4498_Ints__odd__less__0,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A] :
          ( ( member @ A @ A2 @ ( ring_1_Ints @ A ) )
         => ( ( ord_less @ A @ ( plus_plus @ A @ ( plus_plus @ A @ ( one_one @ A ) @ A2 ) @ A2 ) @ ( zero_zero @ A ) )
            = ( ord_less @ A @ A2 @ ( zero_zero @ A ) ) ) ) ) ).

% Ints_odd_less_0
thf(fact_4499_Ints__nonzero__abs__ge1,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X2: A] :
          ( ( member @ A @ X2 @ ( ring_1_Ints @ A ) )
         => ( ( X2
             != ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ ( one_one @ A ) @ ( abs_abs @ A @ X2 ) ) ) ) ) ).

% Ints_nonzero_abs_ge1
thf(fact_4500_Ints__nonzero__abs__less1,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X2: A] :
          ( ( member @ A @ X2 @ ( ring_1_Ints @ A ) )
         => ( ( ord_less @ A @ ( abs_abs @ A @ X2 ) @ ( one_one @ A ) )
           => ( X2
              = ( zero_zero @ A ) ) ) ) ) ).

% Ints_nonzero_abs_less1
thf(fact_4501_Ints__eq__abs__less1,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X2: A,Y2: A] :
          ( ( member @ A @ X2 @ ( ring_1_Ints @ A ) )
         => ( ( member @ A @ Y2 @ ( ring_1_Ints @ A ) )
           => ( ( X2 = Y2 )
              = ( ord_less @ A @ ( abs_abs @ A @ ( minus_minus @ A @ X2 @ Y2 ) ) @ ( one_one @ A ) ) ) ) ) ) ).

% Ints_eq_abs_less1
thf(fact_4502_sin__times__pi__eq__0,axiom,
    ! [X2: real] :
      ( ( ( sin @ real @ ( times_times @ real @ X2 @ pi ) )
        = ( zero_zero @ real ) )
      = ( member @ real @ X2 @ ( ring_1_Ints @ real ) ) ) ).

% sin_times_pi_eq_0
thf(fact_4503_atLeast1__atMost__eq__remove0,axiom,
    ! [N2: nat] :
      ( ( set_or1337092689740270186AtMost @ nat @ ( suc @ ( zero_zero @ nat ) ) @ N2 )
      = ( minus_minus @ ( set @ nat ) @ ( set_ord_atMost @ nat @ N2 ) @ ( insert @ nat @ ( zero_zero @ nat ) @ ( bot_bot @ ( set @ nat ) ) ) ) ) ).

% atLeast1_atMost_eq_remove0
thf(fact_4504_frac__neg,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A] :
          ( ( ( member @ A @ X2 @ ( ring_1_Ints @ A ) )
           => ( ( archimedean_frac @ A @ ( uminus_uminus @ A @ X2 ) )
              = ( zero_zero @ A ) ) )
          & ( ~ ( member @ A @ X2 @ ( ring_1_Ints @ A ) )
           => ( ( archimedean_frac @ A @ ( uminus_uminus @ A @ X2 ) )
              = ( minus_minus @ A @ ( one_one @ A ) @ ( archimedean_frac @ A @ X2 ) ) ) ) ) ) ).

% frac_neg
thf(fact_4505_set__decode__plus__power__2,axiom,
    ! [N2: nat,Z: nat] :
      ( ~ ( member @ nat @ N2 @ ( nat_set_decode @ Z ) )
     => ( ( nat_set_decode @ ( plus_plus @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) @ Z ) )
        = ( insert @ nat @ N2 @ ( nat_set_decode @ Z ) ) ) ) ).

% set_decode_plus_power_2
thf(fact_4506_le__mult__floor__Ints,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( archim2362893244070406136eiling @ B )
        & ( linordered_idom @ A ) )
     => ! [A2: B,B2: B] :
          ( ( ord_less_eq @ B @ ( zero_zero @ B ) @ A2 )
         => ( ( member @ B @ A2 @ ( ring_1_Ints @ B ) )
           => ( ord_less_eq @ A @ ( ring_1_of_int @ A @ ( times_times @ int @ ( archim6421214686448440834_floor @ B @ A2 ) @ ( archim6421214686448440834_floor @ B @ B2 ) ) ) @ ( ring_1_of_int @ A @ ( archim6421214686448440834_floor @ B @ ( times_times @ B @ A2 @ B2 ) ) ) ) ) ) ) ).

% le_mult_floor_Ints
thf(fact_4507_frac__unique__iff,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X2: A,A2: A] :
          ( ( ( archimedean_frac @ A @ X2 )
            = A2 )
          = ( ( member @ A @ ( minus_minus @ A @ X2 @ A2 ) @ ( ring_1_Ints @ A ) )
            & ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
            & ( ord_less @ A @ A2 @ ( one_one @ A ) ) ) ) ) ).

% frac_unique_iff
thf(fact_4508_mult__ceiling__le__Ints,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( archim2362893244070406136eiling @ B )
        & ( linordered_idom @ A ) )
     => ! [A2: B,B2: B] :
          ( ( ord_less_eq @ B @ ( zero_zero @ B ) @ A2 )
         => ( ( member @ B @ A2 @ ( ring_1_Ints @ B ) )
           => ( ord_less_eq @ A @ ( ring_1_of_int @ A @ ( archimedean_ceiling @ B @ ( times_times @ B @ A2 @ B2 ) ) ) @ ( ring_1_of_int @ A @ ( times_times @ int @ ( archimedean_ceiling @ B @ A2 ) @ ( archimedean_ceiling @ B @ B2 ) ) ) ) ) ) ) ).

% mult_ceiling_le_Ints
thf(fact_4509_sin__integer__2pi,axiom,
    ! [N2: real] :
      ( ( member @ real @ N2 @ ( ring_1_Ints @ real ) )
     => ( ( sin @ real @ ( times_times @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) @ N2 ) )
        = ( zero_zero @ real ) ) ) ).

% sin_integer_2pi
thf(fact_4510_cos__integer__2pi,axiom,
    ! [N2: real] :
      ( ( member @ real @ N2 @ ( ring_1_Ints @ real ) )
     => ( ( cos @ real @ ( times_times @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) @ N2 ) )
        = ( one_one @ real ) ) ) ).

% cos_integer_2pi
thf(fact_4511_xor__nat__unfold,axiom,
    ( ( bit_se5824344971392196577ns_xor @ nat )
    = ( ^ [M6: nat,N3: nat] :
          ( if @ nat
          @ ( M6
            = ( zero_zero @ nat ) )
          @ N3
          @ ( if @ nat
            @ ( N3
              = ( zero_zero @ nat ) )
            @ M6
            @ ( plus_plus @ nat @ ( modulo_modulo @ nat @ ( plus_plus @ nat @ ( modulo_modulo @ nat @ M6 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( modulo_modulo @ nat @ N3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( bit_se5824344971392196577ns_xor @ nat @ ( divide_divide @ nat @ M6 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ nat @ N3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ).

% xor_nat_unfold
thf(fact_4512_xor__nat__rec,axiom,
    ( ( bit_se5824344971392196577ns_xor @ nat )
    = ( ^ [M6: nat,N3: nat] :
          ( plus_plus @ nat
          @ ( zero_neq_one_of_bool @ nat
            @ ( ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M6 ) )
             != ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N3 ) ) ) )
          @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( bit_se5824344971392196577ns_xor @ nat @ ( divide_divide @ nat @ M6 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ nat @ N3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% xor_nat_rec
thf(fact_4513_one__xor__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A] :
          ( ( bit_se5824344971392196577ns_xor @ A @ ( one_one @ A ) @ A2 )
          = ( minus_minus @ A @ ( plus_plus @ A @ A2 @ ( zero_neq_one_of_bool @ A @ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) ) )
            @ ( zero_neq_one_of_bool @ A
              @ ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) ) ) ) ) ).

% one_xor_eq
thf(fact_4514_xor__one__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A] :
          ( ( bit_se5824344971392196577ns_xor @ A @ A2 @ ( one_one @ A ) )
          = ( minus_minus @ A @ ( plus_plus @ A @ A2 @ ( zero_neq_one_of_bool @ A @ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) ) )
            @ ( zero_neq_one_of_bool @ A
              @ ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) ) ) ) ) ).

% xor_one_eq
thf(fact_4515_bit__horner__sum__bit__iff,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [Bs: list @ $o,N2: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( groups4207007520872428315er_sum @ $o @ A @ ( zero_neq_one_of_bool @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ Bs ) @ N2 )
          = ( ( ord_less @ nat @ N2 @ ( size_size @ ( list @ $o ) @ Bs ) )
            & ( nth @ $o @ Bs @ N2 ) ) ) ) ).

% bit_horner_sum_bit_iff
thf(fact_4516_case__prod__Pair__iden,axiom,
    ! [B: $tType,A: $tType,P4: product_prod @ A @ B] :
      ( ( product_case_prod @ A @ B @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B ) @ P4 )
      = P4 ) ).

% case_prod_Pair_iden
thf(fact_4517_push__bit__numeral__minus__1,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N2: num] :
          ( ( bit_se4730199178511100633sh_bit @ A @ ( numeral_numeral @ nat @ N2 ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( uminus_uminus @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( numeral_numeral @ nat @ N2 ) ) ) ) ) ).

% push_bit_numeral_minus_1
thf(fact_4518_set__encode__def,axiom,
    ( nat_set_encode
    = ( groups7311177749621191930dd_sum @ nat @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ).

% set_encode_def
thf(fact_4519_Sum__Ico__nat,axiom,
    ! [M: nat,N2: nat] :
      ( ( groups7311177749621191930dd_sum @ nat @ nat
        @ ^ [X5: nat] : X5
        @ ( set_or7035219750837199246ssThan @ nat @ M @ N2 ) )
      = ( divide_divide @ nat @ ( minus_minus @ nat @ ( times_times @ nat @ N2 @ ( minus_minus @ nat @ N2 @ ( one_one @ nat ) ) ) @ ( times_times @ nat @ M @ ( minus_minus @ nat @ M @ ( one_one @ nat ) ) ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ).

% Sum_Ico_nat
thf(fact_4520_push__bit__nonnegative__int__iff,axiom,
    ! [N2: nat,K: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( bit_se4730199178511100633sh_bit @ int @ N2 @ K ) )
      = ( ord_less_eq @ int @ ( zero_zero @ int ) @ K ) ) ).

% push_bit_nonnegative_int_iff
thf(fact_4521_push__bit__negative__int__iff,axiom,
    ! [N2: nat,K: int] :
      ( ( ord_less @ int @ ( bit_se4730199178511100633sh_bit @ int @ N2 @ K ) @ ( zero_zero @ int ) )
      = ( ord_less @ int @ K @ ( zero_zero @ int ) ) ) ).

% push_bit_negative_int_iff
thf(fact_4522_push__bit__of__0,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N2: nat] :
          ( ( bit_se4730199178511100633sh_bit @ A @ N2 @ ( zero_zero @ A ) )
          = ( zero_zero @ A ) ) ) ).

% push_bit_of_0
thf(fact_4523_push__bit__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [N2: nat,A2: A] :
          ( ( ( bit_se4730199178511100633sh_bit @ A @ N2 @ A2 )
            = ( zero_zero @ A ) )
          = ( A2
            = ( zero_zero @ A ) ) ) ) ).

% push_bit_eq_0_iff
thf(fact_4524_push__bit__push__bit,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M: nat,N2: nat,A2: A] :
          ( ( bit_se4730199178511100633sh_bit @ A @ M @ ( bit_se4730199178511100633sh_bit @ A @ N2 @ A2 ) )
          = ( bit_se4730199178511100633sh_bit @ A @ ( plus_plus @ nat @ M @ N2 ) @ A2 ) ) ) ).

% push_bit_push_bit
thf(fact_4525_push__bit__and,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N2: nat,A2: A,B2: A] :
          ( ( bit_se4730199178511100633sh_bit @ A @ N2 @ ( bit_se5824344872417868541ns_and @ A @ A2 @ B2 ) )
          = ( bit_se5824344872417868541ns_and @ A @ ( bit_se4730199178511100633sh_bit @ A @ N2 @ A2 ) @ ( bit_se4730199178511100633sh_bit @ A @ N2 @ B2 ) ) ) ) ).

% push_bit_and
thf(fact_4526_push__bit__or,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N2: nat,A2: A,B2: A] :
          ( ( bit_se4730199178511100633sh_bit @ A @ N2 @ ( bit_se1065995026697491101ons_or @ A @ A2 @ B2 ) )
          = ( bit_se1065995026697491101ons_or @ A @ ( bit_se4730199178511100633sh_bit @ A @ N2 @ A2 ) @ ( bit_se4730199178511100633sh_bit @ A @ N2 @ B2 ) ) ) ) ).

% push_bit_or
thf(fact_4527_push__bit__xor,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N2: nat,A2: A,B2: A] :
          ( ( bit_se4730199178511100633sh_bit @ A @ N2 @ ( bit_se5824344971392196577ns_xor @ A @ A2 @ B2 ) )
          = ( bit_se5824344971392196577ns_xor @ A @ ( bit_se4730199178511100633sh_bit @ A @ N2 @ A2 ) @ ( bit_se4730199178511100633sh_bit @ A @ N2 @ B2 ) ) ) ) ).

% push_bit_xor
thf(fact_4528_concat__bit__of__zero__1,axiom,
    ! [N2: nat,L: int] :
      ( ( bit_concat_bit @ N2 @ ( zero_zero @ int ) @ L )
      = ( bit_se4730199178511100633sh_bit @ int @ N2 @ L ) ) ).

% concat_bit_of_zero_1
thf(fact_4529_atLeastLessThan__iff,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [I3: A,L: A,U: A] :
          ( ( member @ A @ I3 @ ( set_or7035219750837199246ssThan @ A @ L @ U ) )
          = ( ( ord_less_eq @ A @ L @ I3 )
            & ( ord_less @ A @ I3 @ U ) ) ) ) ).

% atLeastLessThan_iff
thf(fact_4530_atLeastLessThan__empty,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less_eq @ A @ B2 @ A2 )
         => ( ( set_or7035219750837199246ssThan @ A @ A2 @ B2 )
            = ( bot_bot @ ( set @ A ) ) ) ) ) ).

% atLeastLessThan_empty
thf(fact_4531_ivl__subset,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [I3: A,J: A,M: A,N2: A] :
          ( ( ord_less_eq @ ( set @ A ) @ ( set_or7035219750837199246ssThan @ A @ I3 @ J ) @ ( set_or7035219750837199246ssThan @ A @ M @ N2 ) )
          = ( ( ord_less_eq @ A @ J @ I3 )
            | ( ( ord_less_eq @ A @ M @ I3 )
              & ( ord_less_eq @ A @ J @ N2 ) ) ) ) ) ).

% ivl_subset
thf(fact_4532_atLeastLessThan__empty__iff,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ( set_or7035219750837199246ssThan @ A @ A2 @ B2 )
            = ( bot_bot @ ( set @ A ) ) )
          = ( ~ ( ord_less @ A @ A2 @ B2 ) ) ) ) ).

% atLeastLessThan_empty_iff
thf(fact_4533_atLeastLessThan__empty__iff2,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ( bot_bot @ ( set @ A ) )
            = ( set_or7035219750837199246ssThan @ A @ A2 @ B2 ) )
          = ( ~ ( ord_less @ A @ A2 @ B2 ) ) ) ) ).

% atLeastLessThan_empty_iff2
thf(fact_4534_ivl__diff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [I3: A,N2: A,M: A] :
          ( ( ord_less_eq @ A @ I3 @ N2 )
         => ( ( minus_minus @ ( set @ A ) @ ( set_or7035219750837199246ssThan @ A @ I3 @ M ) @ ( set_or7035219750837199246ssThan @ A @ I3 @ N2 ) )
            = ( set_or7035219750837199246ssThan @ A @ N2 @ M ) ) ) ) ).

% ivl_diff
thf(fact_4535_xor__nonnegative__int__iff,axiom,
    ! [K: int,L: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( bit_se5824344971392196577ns_xor @ int @ K @ L ) )
      = ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ K )
        = ( ord_less_eq @ int @ ( zero_zero @ int ) @ L ) ) ) ).

% xor_nonnegative_int_iff
thf(fact_4536_xor__negative__int__iff,axiom,
    ! [K: int,L: int] :
      ( ( ord_less @ int @ ( bit_se5824344971392196577ns_xor @ int @ K @ L ) @ ( zero_zero @ int ) )
      = ( ( ( ord_less @ int @ K @ ( zero_zero @ int ) )
         != ( ord_less @ int @ L @ ( zero_zero @ int ) ) ) ) ) ).

% xor_negative_int_iff
thf(fact_4537_set__encode__empty,axiom,
    ( ( nat_set_encode @ ( bot_bot @ ( set @ nat ) ) )
    = ( zero_zero @ nat ) ) ).

% set_encode_empty
thf(fact_4538_push__bit__Suc__numeral,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N2: nat,K: num] :
          ( ( bit_se4730199178511100633sh_bit @ A @ ( suc @ N2 ) @ ( numeral_numeral @ A @ K ) )
          = ( bit_se4730199178511100633sh_bit @ A @ N2 @ ( numeral_numeral @ A @ ( bit0 @ K ) ) ) ) ) ).

% push_bit_Suc_numeral
thf(fact_4539_atLeastLessThan__singleton,axiom,
    ! [M: nat] :
      ( ( set_or7035219750837199246ssThan @ nat @ M @ ( suc @ M ) )
      = ( insert @ nat @ M @ ( bot_bot @ ( set @ nat ) ) ) ) ).

% atLeastLessThan_singleton
thf(fact_4540_push__bit__Suc__minus__numeral,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N2: nat,K: num] :
          ( ( bit_se4730199178511100633sh_bit @ A @ ( suc @ N2 ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ K ) ) )
          = ( bit_se4730199178511100633sh_bit @ A @ N2 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( bit0 @ K ) ) ) ) ) ) ).

% push_bit_Suc_minus_numeral
thf(fact_4541_push__bit__numeral,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [L: num,K: num] :
          ( ( bit_se4730199178511100633sh_bit @ A @ ( numeral_numeral @ nat @ L ) @ ( numeral_numeral @ A @ K ) )
          = ( bit_se4730199178511100633sh_bit @ A @ ( pred_numeral @ L ) @ ( numeral_numeral @ A @ ( bit0 @ K ) ) ) ) ) ).

% push_bit_numeral
thf(fact_4542_push__bit__Suc,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N2: nat,A2: A] :
          ( ( bit_se4730199178511100633sh_bit @ A @ ( suc @ N2 ) @ A2 )
          = ( bit_se4730199178511100633sh_bit @ A @ N2 @ ( times_times @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ).

% push_bit_Suc
thf(fact_4543_push__bit__of__Suc__0,axiom,
    ! [N2: nat] :
      ( ( bit_se4730199178511100633sh_bit @ nat @ N2 @ ( suc @ ( zero_zero @ nat ) ) )
      = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) ).

% push_bit_of_Suc_0
thf(fact_4544_push__bit__of__1,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N2: nat] :
          ( ( bit_se4730199178511100633sh_bit @ A @ N2 @ ( one_one @ A ) )
          = ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N2 ) ) ) ).

% push_bit_of_1
thf(fact_4545_even__push__bit__iff,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N2: nat,A2: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se4730199178511100633sh_bit @ A @ N2 @ A2 ) )
          = ( ( N2
             != ( zero_zero @ nat ) )
            | ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) ) ) ) ).

% even_push_bit_iff
thf(fact_4546_sum_Oop__ivl__Suc,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [N2: nat,M: nat,G: nat > A] :
          ( ( ( ord_less @ nat @ N2 @ M )
           => ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ M @ ( suc @ N2 ) ) )
              = ( zero_zero @ A ) ) )
          & ( ~ ( ord_less @ nat @ N2 @ M )
           => ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ M @ ( suc @ N2 ) ) )
              = ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ M @ N2 ) ) @ ( G @ N2 ) ) ) ) ) ) ).

% sum.op_ivl_Suc
thf(fact_4547_prod_Oop__ivl__Suc,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [N2: nat,M: nat,G: nat > A] :
          ( ( ( ord_less @ nat @ N2 @ M )
           => ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ M @ ( suc @ N2 ) ) )
              = ( one_one @ A ) ) )
          & ( ~ ( ord_less @ nat @ N2 @ M )
           => ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ M @ ( suc @ N2 ) ) )
              = ( times_times @ A @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ M @ N2 ) ) @ ( G @ N2 ) ) ) ) ) ) ).

% prod.op_ivl_Suc
thf(fact_4548_push__bit__minus__numeral,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [L: num,K: num] :
          ( ( bit_se4730199178511100633sh_bit @ A @ ( numeral_numeral @ nat @ L ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ K ) ) )
          = ( bit_se4730199178511100633sh_bit @ A @ ( pred_numeral @ L ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( bit0 @ K ) ) ) ) ) ) ).

% push_bit_minus_numeral
thf(fact_4549_bit__xor__int__iff,axiom,
    ! [K: int,L: int,N2: nat] :
      ( ( bit_se5641148757651400278ts_bit @ int @ ( bit_se5824344971392196577ns_xor @ int @ K @ L ) @ N2 )
      = ( ( ( bit_se5641148757651400278ts_bit @ int @ K @ N2 )
         != ( bit_se5641148757651400278ts_bit @ int @ L @ N2 ) ) ) ) ).

% bit_xor_int_iff
thf(fact_4550_flip__bit__int__def,axiom,
    ( ( bit_se8732182000553998342ip_bit @ int )
    = ( ^ [N3: nat,K3: int] : ( bit_se5824344971392196577ns_xor @ int @ K3 @ ( bit_se4730199178511100633sh_bit @ int @ N3 @ ( one_one @ int ) ) ) ) ) ).

% flip_bit_int_def
thf(fact_4551_push__bit__nat__eq,axiom,
    ! [N2: nat,K: int] :
      ( ( bit_se4730199178511100633sh_bit @ nat @ N2 @ ( nat2 @ K ) )
      = ( nat2 @ ( bit_se4730199178511100633sh_bit @ int @ N2 @ K ) ) ) ).

% push_bit_nat_eq
thf(fact_4552_push__bit__minus,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N2: nat,A2: A] :
          ( ( bit_se4730199178511100633sh_bit @ A @ N2 @ ( uminus_uminus @ A @ A2 ) )
          = ( uminus_uminus @ A @ ( bit_se4730199178511100633sh_bit @ A @ N2 @ A2 ) ) ) ) ).

% push_bit_minus
thf(fact_4553_push__bit__add,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N2: nat,A2: A,B2: A] :
          ( ( bit_se4730199178511100633sh_bit @ A @ N2 @ ( plus_plus @ A @ A2 @ B2 ) )
          = ( plus_plus @ A @ ( bit_se4730199178511100633sh_bit @ A @ N2 @ A2 ) @ ( bit_se4730199178511100633sh_bit @ A @ N2 @ B2 ) ) ) ) ).

% push_bit_add
thf(fact_4554_push__bit__of__int,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N2: nat,K: int] :
          ( ( bit_se4730199178511100633sh_bit @ A @ N2 @ ( ring_1_of_int @ A @ K ) )
          = ( ring_1_of_int @ A @ ( bit_se4730199178511100633sh_bit @ int @ N2 @ K ) ) ) ) ).

% push_bit_of_int
thf(fact_4555_atLeastLessThan__inj_I2_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ( set_or7035219750837199246ssThan @ A @ A2 @ B2 )
            = ( set_or7035219750837199246ssThan @ A @ C2 @ D2 ) )
         => ( ( ord_less @ A @ A2 @ B2 )
           => ( ( ord_less @ A @ C2 @ D2 )
             => ( B2 = D2 ) ) ) ) ) ).

% atLeastLessThan_inj(2)
thf(fact_4556_atLeastLessThan__inj_I1_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ( set_or7035219750837199246ssThan @ A @ A2 @ B2 )
            = ( set_or7035219750837199246ssThan @ A @ C2 @ D2 ) )
         => ( ( ord_less @ A @ A2 @ B2 )
           => ( ( ord_less @ A @ C2 @ D2 )
             => ( A2 = C2 ) ) ) ) ) ).

% atLeastLessThan_inj(1)
thf(fact_4557_atLeastLessThan__eq__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_less @ A @ C2 @ D2 )
           => ( ( ( set_or7035219750837199246ssThan @ A @ A2 @ B2 )
                = ( set_or7035219750837199246ssThan @ A @ C2 @ D2 ) )
              = ( ( A2 = C2 )
                & ( B2 = D2 ) ) ) ) ) ) ).

% atLeastLessThan_eq_iff
thf(fact_4558_push__bit__of__nat,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N2: nat,M: nat] :
          ( ( bit_se4730199178511100633sh_bit @ A @ N2 @ ( semiring_1_of_nat @ A @ M ) )
          = ( semiring_1_of_nat @ A @ ( bit_se4730199178511100633sh_bit @ nat @ N2 @ M ) ) ) ) ).

% push_bit_of_nat
thf(fact_4559_of__nat__push__bit,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M: nat,N2: nat] :
          ( ( semiring_1_of_nat @ A @ ( bit_se4730199178511100633sh_bit @ nat @ M @ N2 ) )
          = ( bit_se4730199178511100633sh_bit @ A @ M @ ( semiring_1_of_nat @ A @ N2 ) ) ) ) ).

% of_nat_push_bit
thf(fact_4560_atLeastLessThan__subset__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ord_less_eq @ ( set @ A ) @ ( set_or7035219750837199246ssThan @ A @ A2 @ B2 ) @ ( set_or7035219750837199246ssThan @ A @ C2 @ D2 ) )
         => ( ( ord_less_eq @ A @ B2 @ A2 )
            | ( ( ord_less_eq @ A @ C2 @ A2 )
              & ( ord_less_eq @ A @ B2 @ D2 ) ) ) ) ) ).

% atLeastLessThan_subset_iff
thf(fact_4561_atLeast0__lessThan__Suc,axiom,
    ! [N2: nat] :
      ( ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( suc @ N2 ) )
      = ( insert @ nat @ N2 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N2 ) ) ) ).

% atLeast0_lessThan_Suc
thf(fact_4562_XOR__lower,axiom,
    ! [X2: int,Y2: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ X2 )
     => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Y2 )
       => ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( bit_se5824344971392196577ns_xor @ int @ X2 @ Y2 ) ) ) ) ).

% XOR_lower
thf(fact_4563_all__nat__less__eq,axiom,
    ! [N2: nat,P: nat > $o] :
      ( ( ! [M6: nat] :
            ( ( ord_less @ nat @ M6 @ N2 )
           => ( P @ M6 ) ) )
      = ( ! [X5: nat] :
            ( ( member @ nat @ X5 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N2 ) )
           => ( P @ X5 ) ) ) ) ).

% all_nat_less_eq
thf(fact_4564_ex__nat__less__eq,axiom,
    ! [N2: nat,P: nat > $o] :
      ( ( ? [M6: nat] :
            ( ( ord_less @ nat @ M6 @ N2 )
            & ( P @ M6 ) ) )
      = ( ? [X5: nat] :
            ( ( member @ nat @ X5 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N2 ) )
            & ( P @ X5 ) ) ) ) ).

% ex_nat_less_eq
thf(fact_4565_atLeastLessThanSuc__atLeastAtMost,axiom,
    ! [L: nat,U: nat] :
      ( ( set_or7035219750837199246ssThan @ nat @ L @ ( suc @ U ) )
      = ( set_or1337092689740270186AtMost @ nat @ L @ U ) ) ).

% atLeastLessThanSuc_atLeastAtMost
thf(fact_4566_lessThan__atLeast0,axiom,
    ( ( set_ord_lessThan @ nat )
    = ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) ) ) ).

% lessThan_atLeast0
thf(fact_4567_atLeastLessThan0,axiom,
    ! [M: nat] :
      ( ( set_or7035219750837199246ssThan @ nat @ M @ ( zero_zero @ nat ) )
      = ( bot_bot @ ( set @ nat ) ) ) ).

% atLeastLessThan0
thf(fact_4568_push__bit__take__bit,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M: nat,N2: nat,A2: A] :
          ( ( bit_se4730199178511100633sh_bit @ A @ M @ ( bit_se2584673776208193580ke_bit @ A @ N2 @ A2 ) )
          = ( bit_se2584673776208193580ke_bit @ A @ ( plus_plus @ nat @ M @ N2 ) @ ( bit_se4730199178511100633sh_bit @ A @ M @ A2 ) ) ) ) ).

% push_bit_take_bit
thf(fact_4569_take__bit__push__bit,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M: nat,N2: nat,A2: A] :
          ( ( bit_se2584673776208193580ke_bit @ A @ M @ ( bit_se4730199178511100633sh_bit @ A @ N2 @ A2 ) )
          = ( bit_se4730199178511100633sh_bit @ A @ N2 @ ( bit_se2584673776208193580ke_bit @ A @ ( minus_minus @ nat @ M @ N2 ) @ A2 ) ) ) ) ).

% take_bit_push_bit
thf(fact_4570_set__bit__nat__def,axiom,
    ( ( bit_se5668285175392031749et_bit @ nat )
    = ( ^ [M6: nat,N3: nat] : ( bit_se1065995026697491101ons_or @ nat @ N3 @ ( bit_se4730199178511100633sh_bit @ nat @ M6 @ ( one_one @ nat ) ) ) ) ) ).

% set_bit_nat_def
thf(fact_4571_flip__bit__nat__def,axiom,
    ( ( bit_se8732182000553998342ip_bit @ nat )
    = ( ^ [M6: nat,N3: nat] : ( bit_se5824344971392196577ns_xor @ nat @ N3 @ ( bit_se4730199178511100633sh_bit @ nat @ M6 @ ( one_one @ nat ) ) ) ) ) ).

% flip_bit_nat_def
thf(fact_4572_sum_Oshift__bounds__Suc__ivl,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,M: nat,N2: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ ( suc @ M ) @ ( suc @ N2 ) ) )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [I4: nat] : ( G @ ( suc @ I4 ) )
            @ ( set_or7035219750837199246ssThan @ nat @ M @ N2 ) ) ) ) ).

% sum.shift_bounds_Suc_ivl
thf(fact_4573_sum_Oshift__bounds__nat__ivl,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,M: nat,K: nat,N2: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ ( plus_plus @ nat @ M @ K ) @ ( plus_plus @ nat @ N2 @ K ) ) )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [I4: nat] : ( G @ ( plus_plus @ nat @ I4 @ K ) )
            @ ( set_or7035219750837199246ssThan @ nat @ M @ N2 ) ) ) ) ).

% sum.shift_bounds_nat_ivl
thf(fact_4574_prod_Oshift__bounds__Suc__ivl,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,M: nat,N2: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ ( suc @ M ) @ ( suc @ N2 ) ) )
          = ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [I4: nat] : ( G @ ( suc @ I4 ) )
            @ ( set_or7035219750837199246ssThan @ nat @ M @ N2 ) ) ) ) ).

% prod.shift_bounds_Suc_ivl
thf(fact_4575_prod_Oshift__bounds__nat__ivl,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,M: nat,K: nat,N2: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ ( plus_plus @ nat @ M @ K ) @ ( plus_plus @ nat @ N2 @ K ) ) )
          = ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [I4: nat] : ( G @ ( plus_plus @ nat @ I4 @ K ) )
            @ ( set_or7035219750837199246ssThan @ nat @ M @ N2 ) ) ) ) ).

% prod.shift_bounds_nat_ivl
thf(fact_4576_take__bit__sum,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ( ( bit_se2584673776208193580ke_bit @ A )
        = ( ^ [N3: nat,A4: A] :
              ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [K3: nat] : ( bit_se4730199178511100633sh_bit @ A @ K3 @ ( zero_neq_one_of_bool @ A @ ( bit_se5641148757651400278ts_bit @ A @ A4 @ K3 ) ) )
              @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N3 ) ) ) ) ) ).

% take_bit_sum
thf(fact_4577_sum_Oivl__cong,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( ord @ B )
        & ( comm_monoid_add @ A ) )
     => ! [A2: B,C2: B,B2: B,D2: B,G: B > A,H2: B > A] :
          ( ( A2 = C2 )
         => ( ( B2 = D2 )
           => ( ! [X3: B] :
                  ( ( ord_less_eq @ B @ C2 @ X3 )
                 => ( ( ord_less @ B @ X3 @ D2 )
                   => ( ( G @ X3 )
                      = ( H2 @ X3 ) ) ) )
             => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ ( set_or7035219750837199246ssThan @ B @ A2 @ B2 ) )
                = ( groups7311177749621191930dd_sum @ B @ A @ H2 @ ( set_or7035219750837199246ssThan @ B @ C2 @ D2 ) ) ) ) ) ) ) ).

% sum.ivl_cong
thf(fact_4578_prod_Oivl__cong,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( ord @ B )
        & ( comm_monoid_mult @ A ) )
     => ! [A2: B,C2: B,B2: B,D2: B,G: B > A,H2: B > A] :
          ( ( A2 = C2 )
         => ( ( B2 = D2 )
           => ( ! [X3: B] :
                  ( ( ord_less_eq @ B @ C2 @ X3 )
                 => ( ( ord_less @ B @ X3 @ D2 )
                   => ( ( G @ X3 )
                      = ( H2 @ X3 ) ) ) )
             => ( ( groups7121269368397514597t_prod @ B @ A @ G @ ( set_or7035219750837199246ssThan @ B @ A2 @ B2 ) )
                = ( groups7121269368397514597t_prod @ B @ A @ H2 @ ( set_or7035219750837199246ssThan @ B @ C2 @ D2 ) ) ) ) ) ) ) ).

% prod.ivl_cong
thf(fact_4579_sum_OatLeastLessThan__concat,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [M: nat,N2: nat,P4: nat,G: nat > A] :
          ( ( ord_less_eq @ nat @ M @ N2 )
         => ( ( ord_less_eq @ nat @ N2 @ P4 )
           => ( ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ M @ N2 ) ) @ ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ N2 @ P4 ) ) )
              = ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ M @ P4 ) ) ) ) ) ) ).

% sum.atLeastLessThan_concat
thf(fact_4580_sum__diff__nat__ivl,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [M: nat,N2: nat,P4: nat,F2: nat > A] :
          ( ( ord_less_eq @ nat @ M @ N2 )
         => ( ( ord_less_eq @ nat @ N2 @ P4 )
           => ( ( minus_minus @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_or7035219750837199246ssThan @ nat @ M @ P4 ) ) @ ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_or7035219750837199246ssThan @ nat @ M @ N2 ) ) )
              = ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_or7035219750837199246ssThan @ nat @ N2 @ P4 ) ) ) ) ) ) ).

% sum_diff_nat_ivl
thf(fact_4581_prod_OatLeastLessThan__concat,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [M: nat,N2: nat,P4: nat,G: nat > A] :
          ( ( ord_less_eq @ nat @ M @ N2 )
         => ( ( ord_less_eq @ nat @ N2 @ P4 )
           => ( ( times_times @ A @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ M @ N2 ) ) @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ N2 @ P4 ) ) )
              = ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ M @ P4 ) ) ) ) ) ) ).

% prod.atLeastLessThan_concat
thf(fact_4582_bit__push__bit__iff__int,axiom,
    ! [M: nat,K: int,N2: nat] :
      ( ( bit_se5641148757651400278ts_bit @ int @ ( bit_se4730199178511100633sh_bit @ int @ M @ K ) @ N2 )
      = ( ( ord_less_eq @ nat @ M @ N2 )
        & ( bit_se5641148757651400278ts_bit @ int @ K @ ( minus_minus @ nat @ N2 @ M ) ) ) ) ).

% bit_push_bit_iff_int
thf(fact_4583_atLeastLessThanSuc,axiom,
    ! [M: nat,N2: nat] :
      ( ( ( ord_less_eq @ nat @ M @ N2 )
       => ( ( set_or7035219750837199246ssThan @ nat @ M @ ( suc @ N2 ) )
          = ( insert @ nat @ N2 @ ( set_or7035219750837199246ssThan @ nat @ M @ N2 ) ) ) )
      & ( ~ ( ord_less_eq @ nat @ M @ N2 )
       => ( ( set_or7035219750837199246ssThan @ nat @ M @ ( suc @ N2 ) )
          = ( bot_bot @ ( set @ nat ) ) ) ) ) ).

% atLeastLessThanSuc
thf(fact_4584_xor__nat__def,axiom,
    ( ( bit_se5824344971392196577ns_xor @ nat )
    = ( ^ [M6: nat,N3: nat] : ( nat2 @ ( bit_se5824344971392196577ns_xor @ int @ ( semiring_1_of_nat @ int @ M6 ) @ ( semiring_1_of_nat @ int @ N3 ) ) ) ) ) ).

% xor_nat_def
thf(fact_4585_bit__push__bit__iff__nat,axiom,
    ! [M: nat,Q3: nat,N2: nat] :
      ( ( bit_se5641148757651400278ts_bit @ nat @ ( bit_se4730199178511100633sh_bit @ nat @ M @ Q3 ) @ N2 )
      = ( ( ord_less_eq @ nat @ M @ N2 )
        & ( bit_se5641148757651400278ts_bit @ nat @ Q3 @ ( minus_minus @ nat @ N2 @ M ) ) ) ) ).

% bit_push_bit_iff_nat
thf(fact_4586_concat__bit__eq,axiom,
    ( bit_concat_bit
    = ( ^ [N3: nat,K3: int,L2: int] : ( plus_plus @ int @ ( bit_se2584673776208193580ke_bit @ int @ N3 @ K3 ) @ ( bit_se4730199178511100633sh_bit @ int @ N3 @ L2 ) ) ) ) ).

% concat_bit_eq
thf(fact_4587_set__bit__eq__or,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se5668285175392031749et_bit @ A )
        = ( ^ [N3: nat,A4: A] : ( bit_se1065995026697491101ons_or @ A @ A4 @ ( bit_se4730199178511100633sh_bit @ A @ N3 @ ( one_one @ A ) ) ) ) ) ) ).

% set_bit_eq_or
thf(fact_4588_concat__bit__def,axiom,
    ( bit_concat_bit
    = ( ^ [N3: nat,K3: int,L2: int] : ( bit_se1065995026697491101ons_or @ int @ ( bit_se2584673776208193580ke_bit @ int @ N3 @ K3 ) @ ( bit_se4730199178511100633sh_bit @ int @ N3 @ L2 ) ) ) ) ).

% concat_bit_def
thf(fact_4589_flip__bit__eq__xor,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se8732182000553998342ip_bit @ A )
        = ( ^ [N3: nat,A4: A] : ( bit_se5824344971392196577ns_xor @ A @ A4 @ ( bit_se4730199178511100633sh_bit @ A @ N3 @ ( one_one @ A ) ) ) ) ) ) ).

% flip_bit_eq_xor
thf(fact_4590_set__bit__int__def,axiom,
    ( ( bit_se5668285175392031749et_bit @ int )
    = ( ^ [N3: nat,K3: int] : ( bit_se1065995026697491101ons_or @ int @ K3 @ ( bit_se4730199178511100633sh_bit @ int @ N3 @ ( one_one @ int ) ) ) ) ) ).

% set_bit_int_def
thf(fact_4591_predicate2D__conj,axiom,
    ! [A: $tType,B: $tType,P: A > B > $o,Q: A > B > $o,R: $o,X2: A,Y2: B] :
      ( ( ( ord_less_eq @ ( A > B > $o ) @ P @ Q )
        & R )
     => ( R
        & ( ( P @ X2 @ Y2 )
         => ( Q @ X2 @ Y2 ) ) ) ) ).

% predicate2D_conj
thf(fact_4592_atLeastLessThan__subseteq__atLeastAtMost__iff,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ord_less_eq @ ( set @ A ) @ ( set_or7035219750837199246ssThan @ A @ A2 @ B2 ) @ ( set_or1337092689740270186AtMost @ A @ C2 @ D2 ) )
          = ( ( ord_less @ A @ A2 @ B2 )
           => ( ( ord_less_eq @ A @ C2 @ A2 )
              & ( ord_less_eq @ A @ B2 @ D2 ) ) ) ) ) ).

% atLeastLessThan_subseteq_atLeastAtMost_iff
thf(fact_4593_atLeastAtMost__subseteq__atLeastLessThan__iff,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ord_less_eq @ ( set @ A ) @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) @ ( set_or7035219750837199246ssThan @ A @ C2 @ D2 ) )
          = ( ( ord_less_eq @ A @ A2 @ B2 )
           => ( ( ord_less_eq @ A @ C2 @ A2 )
              & ( ord_less @ A @ B2 @ D2 ) ) ) ) ) ).

% atLeastAtMost_subseteq_atLeastLessThan_iff
thf(fact_4594_sum__shift__lb__Suc0__0__upt,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [F2: nat > A,K: nat] :
          ( ( ( F2 @ ( zero_zero @ nat ) )
            = ( zero_zero @ A ) )
         => ( ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_or7035219750837199246ssThan @ nat @ ( suc @ ( zero_zero @ nat ) ) @ K ) )
            = ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ K ) ) ) ) ) ).

% sum_shift_lb_Suc0_0_upt
thf(fact_4595_sum_OatLeast0__lessThan__Suc,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,N2: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( suc @ N2 ) ) )
          = ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N2 ) ) @ ( G @ N2 ) ) ) ) ).

% sum.atLeast0_lessThan_Suc
thf(fact_4596_sum_OatLeast__Suc__lessThan,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [M: nat,N2: nat,G: nat > A] :
          ( ( ord_less @ nat @ M @ N2 )
         => ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ M @ N2 ) )
            = ( plus_plus @ A @ ( G @ M ) @ ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ ( suc @ M ) @ N2 ) ) ) ) ) ) ).

% sum.atLeast_Suc_lessThan
thf(fact_4597_sum_OatLeastLessThan__Suc,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A2: nat,B2: nat,G: nat > A] :
          ( ( ord_less_eq @ nat @ A2 @ B2 )
         => ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ A2 @ ( suc @ B2 ) ) )
            = ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ A2 @ B2 ) ) @ ( G @ B2 ) ) ) ) ) ).

% sum.atLeastLessThan_Suc
thf(fact_4598_prod_OatLeast0__lessThan__Suc,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,N2: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( suc @ N2 ) ) )
          = ( times_times @ A @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N2 ) ) @ ( G @ N2 ) ) ) ) ).

% prod.atLeast0_lessThan_Suc
thf(fact_4599_prod_OatLeast__Suc__lessThan,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [M: nat,N2: nat,G: nat > A] :
          ( ( ord_less @ nat @ M @ N2 )
         => ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ M @ N2 ) )
            = ( times_times @ A @ ( G @ M ) @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ ( suc @ M ) @ N2 ) ) ) ) ) ) ).

% prod.atLeast_Suc_lessThan
thf(fact_4600_prod_OatLeastLessThan__Suc,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A2: nat,B2: nat,G: nat > A] :
          ( ( ord_less_eq @ nat @ A2 @ B2 )
         => ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ A2 @ ( suc @ B2 ) ) )
            = ( times_times @ A @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ A2 @ B2 ) ) @ ( G @ B2 ) ) ) ) ) ).

% prod.atLeastLessThan_Suc
thf(fact_4601_sum_Olast__plus,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [M: nat,N2: nat,G: nat > A] :
          ( ( ord_less_eq @ nat @ M @ N2 )
         => ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ N2 ) )
            = ( plus_plus @ A @ ( G @ N2 ) @ ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ M @ N2 ) ) ) ) ) ) ).

% sum.last_plus
thf(fact_4602_prod_Olast__plus,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [M: nat,N2: nat,G: nat > A] :
          ( ( ord_less_eq @ nat @ M @ N2 )
         => ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ N2 ) )
            = ( times_times @ A @ ( G @ N2 ) @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ M @ N2 ) ) ) ) ) ) ).

% prod.last_plus
thf(fact_4603_push__bit__double,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N2: nat,A2: A] :
          ( ( bit_se4730199178511100633sh_bit @ A @ N2 @ ( times_times @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) )
          = ( times_times @ A @ ( bit_se4730199178511100633sh_bit @ A @ N2 @ A2 ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% push_bit_double
thf(fact_4604_atLeast1__lessThan__eq__remove0,axiom,
    ! [N2: nat] :
      ( ( set_or7035219750837199246ssThan @ nat @ ( suc @ ( zero_zero @ nat ) ) @ N2 )
      = ( minus_minus @ ( set @ nat ) @ ( set_ord_lessThan @ nat @ N2 ) @ ( insert @ nat @ ( zero_zero @ nat ) @ ( bot_bot @ ( set @ nat ) ) ) ) ) ).

% atLeast1_lessThan_eq_remove0
thf(fact_4605_sum__Suc__diff_H,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [M: nat,N2: nat,F2: nat > A] :
          ( ( ord_less_eq @ nat @ M @ N2 )
         => ( ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [I4: nat] : ( minus_minus @ A @ ( F2 @ ( suc @ I4 ) ) @ ( F2 @ I4 ) )
              @ ( set_or7035219750837199246ssThan @ nat @ M @ N2 ) )
            = ( minus_minus @ A @ ( F2 @ N2 ) @ ( F2 @ M ) ) ) ) ) ).

% sum_Suc_diff'
thf(fact_4606_atLeastLessThan__nat__numeral,axiom,
    ! [M: nat,K: num] :
      ( ( ( ord_less_eq @ nat @ M @ ( pred_numeral @ K ) )
       => ( ( set_or7035219750837199246ssThan @ nat @ M @ ( numeral_numeral @ nat @ K ) )
          = ( insert @ nat @ ( pred_numeral @ K ) @ ( set_or7035219750837199246ssThan @ nat @ M @ ( pred_numeral @ K ) ) ) ) )
      & ( ~ ( ord_less_eq @ nat @ M @ ( pred_numeral @ K ) )
       => ( ( set_or7035219750837199246ssThan @ nat @ M @ ( numeral_numeral @ nat @ K ) )
          = ( bot_bot @ ( set @ nat ) ) ) ) ) ).

% atLeastLessThan_nat_numeral
thf(fact_4607_bit__iff__and__push__bit__not__eq__0,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se5641148757651400278ts_bit @ A )
        = ( ^ [A4: A,N3: nat] :
              ( ( bit_se5824344872417868541ns_and @ A @ A4 @ ( bit_se4730199178511100633sh_bit @ A @ N3 @ ( one_one @ A ) ) )
             != ( zero_zero @ A ) ) ) ) ) ).

% bit_iff_and_push_bit_not_eq_0
thf(fact_4608_sum_OatLeastLessThan__rev,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,N2: nat,M: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ N2 @ M ) )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [I4: nat] : ( G @ ( minus_minus @ nat @ ( plus_plus @ nat @ M @ N2 ) @ ( suc @ I4 ) ) )
            @ ( set_or7035219750837199246ssThan @ nat @ N2 @ M ) ) ) ) ).

% sum.atLeastLessThan_rev
thf(fact_4609_sum_Onested__swap,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A2: nat > nat > A,N2: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [I4: nat] : ( groups7311177749621191930dd_sum @ nat @ A @ ( A2 @ I4 ) @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ I4 ) )
            @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N2 ) )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [J3: nat] :
                ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I4: nat] : ( A2 @ I4 @ J3 )
                @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ J3 ) @ N2 ) )
            @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N2 ) ) ) ) ).

% sum.nested_swap
thf(fact_4610_prod_OatLeastLessThan__rev,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,N2: nat,M: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ N2 @ M ) )
          = ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [I4: nat] : ( G @ ( minus_minus @ nat @ ( plus_plus @ nat @ M @ N2 ) @ ( suc @ I4 ) ) )
            @ ( set_or7035219750837199246ssThan @ nat @ N2 @ M ) ) ) ) ).

% prod.atLeastLessThan_rev
thf(fact_4611_prod_Onested__swap,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A2: nat > nat > A,N2: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [I4: nat] : ( groups7121269368397514597t_prod @ nat @ A @ ( A2 @ I4 ) @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ I4 ) )
            @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N2 ) )
          = ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [J3: nat] :
                ( groups7121269368397514597t_prod @ nat @ A
                @ ^ [I4: nat] : ( A2 @ I4 @ J3 )
                @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ J3 ) @ N2 ) )
            @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N2 ) ) ) ) ).

% prod.nested_swap
thf(fact_4612_sum_Onat__group,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,K: nat,N2: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [M6: nat] : ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ ( times_times @ nat @ M6 @ K ) @ ( plus_plus @ nat @ ( times_times @ nat @ M6 @ K ) @ K ) ) )
            @ ( set_ord_lessThan @ nat @ N2 ) )
          = ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_ord_lessThan @ nat @ ( times_times @ nat @ N2 @ K ) ) ) ) ) ).

% sum.nat_group
thf(fact_4613_prod_Onat__group,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,K: nat,N2: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [M6: nat] : ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ ( times_times @ nat @ M6 @ K ) @ ( plus_plus @ nat @ ( times_times @ nat @ M6 @ K ) @ K ) ) )
            @ ( set_ord_lessThan @ nat @ N2 ) )
          = ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_ord_lessThan @ nat @ ( times_times @ nat @ N2 @ K ) ) ) ) ) ).

% prod.nat_group
thf(fact_4614_prod__Suc__fact,axiom,
    ! [N2: nat] :
      ( ( groups7121269368397514597t_prod @ nat @ nat @ suc @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N2 ) )
      = ( semiring_char_0_fact @ nat @ N2 ) ) ).

% prod_Suc_fact
thf(fact_4615_prod__Suc__Suc__fact,axiom,
    ! [N2: nat] :
      ( ( groups7121269368397514597t_prod @ nat @ nat @ suc @ ( set_or7035219750837199246ssThan @ nat @ ( suc @ ( zero_zero @ nat ) ) @ N2 ) )
      = ( semiring_char_0_fact @ nat @ N2 ) ) ).

% prod_Suc_Suc_fact
thf(fact_4616_fun__cong__unused__0,axiom,
    ! [A: $tType,B: $tType,C: $tType] :
      ( ( zero @ B )
     => ! [F2: ( A > B ) > C,G: C] :
          ( ( F2
            = ( ^ [X5: A > B] : G ) )
         => ( ( F2
              @ ^ [X5: A] : ( zero_zero @ B ) )
            = G ) ) ) ).

% fun_cong_unused_0
thf(fact_4617_sum_Ohead__if,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [N2: nat,M: nat,G: nat > A] :
          ( ( ( ord_less @ nat @ N2 @ M )
           => ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ N2 ) )
              = ( zero_zero @ A ) ) )
          & ( ~ ( ord_less @ nat @ N2 @ M )
           => ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ N2 ) )
              = ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ M @ N2 ) ) @ ( G @ N2 ) ) ) ) ) ) ).

% sum.head_if
thf(fact_4618_prod_Ohead__if,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [N2: nat,M: nat,G: nat > A] :
          ( ( ( ord_less @ nat @ N2 @ M )
           => ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ N2 ) )
              = ( one_one @ A ) ) )
          & ( ~ ( ord_less @ nat @ N2 @ M )
           => ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ N2 ) )
              = ( times_times @ A @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ M @ N2 ) ) @ ( G @ N2 ) ) ) ) ) ) ).

% prod.head_if
thf(fact_4619_push__bit__int__def,axiom,
    ( ( bit_se4730199178511100633sh_bit @ int )
    = ( ^ [N3: nat,K3: int] : ( times_times @ int @ K3 @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N3 ) ) ) ) ).

% push_bit_int_def
thf(fact_4620_push__bit__nat__def,axiom,
    ( ( bit_se4730199178511100633sh_bit @ nat )
    = ( ^ [N3: nat,M6: nat] : ( times_times @ nat @ M6 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N3 ) ) ) ) ).

% push_bit_nat_def
thf(fact_4621_push__bit__eq__mult,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se4730199178511100633sh_bit @ A )
        = ( ^ [N3: nat,A4: A] : ( times_times @ A @ A4 @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N3 ) ) ) ) ) ).

% push_bit_eq_mult
thf(fact_4622_exp__dvdE,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N2: nat,A2: A] :
          ( ( dvd_dvd @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N2 ) @ A2 )
         => ~ ! [B5: A] :
                ( A2
               != ( bit_se4730199178511100633sh_bit @ A @ N2 @ B5 ) ) ) ) ).

% exp_dvdE
thf(fact_4623_eq__subset,axiom,
    ! [A: $tType,P: A > A > $o] :
      ( ord_less_eq @ ( A > A > $o )
      @ ^ [Y3: A,Z2: A] : ( Y3 = Z2 )
      @ ^ [A4: A,B4: A] :
          ( ( P @ A4 @ B4 )
          | ( A4 = B4 ) ) ) ).

% eq_subset
thf(fact_4624_fact__prod__Suc,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ( ( semiring_char_0_fact @ A )
        = ( ^ [N3: nat] : ( semiring_1_of_nat @ A @ ( groups7121269368397514597t_prod @ nat @ nat @ suc @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N3 ) ) ) ) ) ) ).

% fact_prod_Suc
thf(fact_4625_sum_OatLeastLessThan__rev__at__least__Suc__atMost,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,N2: nat,M: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ N2 @ M ) )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [I4: nat] : ( G @ ( minus_minus @ nat @ ( plus_plus @ nat @ M @ N2 ) @ I4 ) )
            @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ N2 ) @ M ) ) ) ) ).

% sum.atLeastLessThan_rev_at_least_Suc_atMost
thf(fact_4626_prod_OatLeastLessThan__rev__at__least__Suc__atMost,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,N2: nat,M: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ N2 @ M ) )
          = ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [I4: nat] : ( G @ ( minus_minus @ nat @ ( plus_plus @ nat @ M @ N2 ) @ I4 ) )
            @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ N2 ) @ M ) ) ) ) ).

% prod.atLeastLessThan_rev_at_least_Suc_atMost
thf(fact_4627_pochhammer__prod,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ( ( comm_s3205402744901411588hammer @ A )
        = ( ^ [A4: A,N3: nat] :
              ( groups7121269368397514597t_prod @ nat @ A
              @ ^ [I4: nat] : ( plus_plus @ A @ A4 @ ( semiring_1_of_nat @ A @ I4 ) )
              @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N3 ) ) ) ) ) ).

% pochhammer_prod
thf(fact_4628_fact__prod__rev,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ( ( semiring_char_0_fact @ A )
        = ( ^ [N3: nat] : ( semiring_1_of_nat @ A @ ( groups7121269368397514597t_prod @ nat @ nat @ ( minus_minus @ nat @ N3 ) @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N3 ) ) ) ) ) ) ).

% fact_prod_rev
thf(fact_4629_summable__Cauchy,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach @ A )
     => ( ( summable @ A )
        = ( ^ [F5: nat > A] :
            ! [E4: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ E4 )
             => ? [N6: nat] :
                ! [M6: nat] :
                  ( ( ord_less_eq @ nat @ N6 @ M6 )
                 => ! [N3: nat] : ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ F5 @ ( set_or7035219750837199246ssThan @ nat @ M6 @ N3 ) ) ) @ E4 ) ) ) ) ) ) ).

% summable_Cauchy
thf(fact_4630_push__bit__minus__one,axiom,
    ! [N2: nat] :
      ( ( bit_se4730199178511100633sh_bit @ int @ N2 @ ( uminus_uminus @ int @ ( one_one @ int ) ) )
      = ( uminus_uminus @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N2 ) ) ) ).

% push_bit_minus_one
thf(fact_4631_sums__group,axiom,
    ! [A: $tType] :
      ( ( ( comm_monoid_add @ A )
        & ( topolo4958980785337419405_space @ A ) )
     => ! [F2: nat > A,S2: A,K: nat] :
          ( ( sums @ A @ F2 @ S2 )
         => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
           => ( sums @ A
              @ ^ [N3: nat] : ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_or7035219750837199246ssThan @ nat @ ( times_times @ nat @ N3 @ K ) @ ( plus_plus @ nat @ ( times_times @ nat @ N3 @ K ) @ K ) ) )
              @ S2 ) ) ) ) ).

% sums_group
thf(fact_4632_XOR__upper,axiom,
    ! [X2: int,N2: nat,Y2: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ X2 )
     => ( ( ord_less @ int @ X2 @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N2 ) )
       => ( ( ord_less @ int @ Y2 @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N2 ) )
         => ( ord_less @ int @ ( bit_se5824344971392196577ns_xor @ int @ X2 @ Y2 ) @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N2 ) ) ) ) ) ).

% XOR_upper
thf(fact_4633_fact__split,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [K: nat,N2: nat] :
          ( ( ord_less_eq @ nat @ K @ N2 )
         => ( ( semiring_char_0_fact @ A @ N2 )
            = ( times_times @ A @ ( semiring_1_of_nat @ A @ ( groups7121269368397514597t_prod @ nat @ nat @ suc @ ( set_or7035219750837199246ssThan @ nat @ ( minus_minus @ nat @ N2 @ K ) @ N2 ) ) ) @ ( semiring_char_0_fact @ A @ ( minus_minus @ nat @ N2 @ K ) ) ) ) ) ) ).

% fact_split
thf(fact_4634_binomial__altdef__of__nat,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [K: nat,N2: nat] :
          ( ( ord_less_eq @ nat @ K @ N2 )
         => ( ( semiring_1_of_nat @ A @ ( binomial @ N2 @ K ) )
            = ( groups7121269368397514597t_prod @ nat @ A
              @ ^ [I4: nat] : ( divide_divide @ A @ ( semiring_1_of_nat @ A @ ( minus_minus @ nat @ N2 @ I4 ) ) @ ( semiring_1_of_nat @ A @ ( minus_minus @ nat @ K @ I4 ) ) )
              @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ K ) ) ) ) ) ).

% binomial_altdef_of_nat
thf(fact_4635_gbinomial__altdef__of__nat,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ( ( gbinomial @ A )
        = ( ^ [A4: A,K3: nat] :
              ( groups7121269368397514597t_prod @ nat @ A
              @ ^ [I4: nat] : ( divide_divide @ A @ ( minus_minus @ A @ A4 @ ( semiring_1_of_nat @ A @ I4 ) ) @ ( semiring_1_of_nat @ A @ ( minus_minus @ nat @ K3 @ I4 ) ) )
              @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ K3 ) ) ) ) ) ).

% gbinomial_altdef_of_nat
thf(fact_4636_gbinomial__mult__fact_H,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: A,K: nat] :
          ( ( times_times @ A @ ( gbinomial @ A @ A2 @ K ) @ ( semiring_char_0_fact @ A @ K ) )
          = ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [I4: nat] : ( minus_minus @ A @ A2 @ ( semiring_1_of_nat @ A @ I4 ) )
            @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ K ) ) ) ) ).

% gbinomial_mult_fact'
thf(fact_4637_gbinomial__mult__fact,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [K: nat,A2: A] :
          ( ( times_times @ A @ ( semiring_char_0_fact @ A @ K ) @ ( gbinomial @ A @ A2 @ K ) )
          = ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [I4: nat] : ( minus_minus @ A @ A2 @ ( semiring_1_of_nat @ A @ I4 ) )
            @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ K ) ) ) ) ).

% gbinomial_mult_fact
thf(fact_4638_gbinomial__prod__rev,axiom,
    ! [A: $tType] :
      ( ( ( semiring_char_0 @ A )
        & ( semidom_divide @ A ) )
     => ( ( gbinomial @ A )
        = ( ^ [A4: A,K3: nat] :
              ( divide_divide @ A
              @ ( groups7121269368397514597t_prod @ nat @ A
                @ ^ [I4: nat] : ( minus_minus @ A @ A4 @ ( semiring_1_of_nat @ A @ I4 ) )
                @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ K3 ) )
              @ ( semiring_char_0_fact @ A @ K3 ) ) ) ) ) ).

% gbinomial_prod_rev
thf(fact_4639_signed__take__bit__code,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( ( bit_ri4674362597316999326ke_bit @ A )
        = ( ^ [N3: nat,A4: A] : ( if @ A @ ( bit_se5641148757651400278ts_bit @ A @ ( bit_se2584673776208193580ke_bit @ A @ ( suc @ N3 ) @ A4 ) @ N3 ) @ ( plus_plus @ A @ ( bit_se2584673776208193580ke_bit @ A @ ( suc @ N3 ) @ A4 ) @ ( bit_se4730199178511100633sh_bit @ A @ ( suc @ N3 ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) @ ( bit_se2584673776208193580ke_bit @ A @ ( suc @ N3 ) @ A4 ) ) ) ) ) ).

% signed_take_bit_code
thf(fact_4640_xor__int__rec,axiom,
    ( ( bit_se5824344971392196577ns_xor @ int )
    = ( ^ [K3: int,L2: int] :
          ( plus_plus @ int
          @ ( zero_neq_one_of_bool @ int
            @ ( ( ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ K3 ) )
             != ( ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ L2 ) ) ) )
          @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se5824344971392196577ns_xor @ int @ ( divide_divide @ int @ K3 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ int @ L2 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% xor_int_rec
thf(fact_4641_sum__power2,axiom,
    ! [K: nat] :
      ( ( groups7311177749621191930dd_sum @ nat @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ K ) )
      = ( minus_minus @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ K ) @ ( one_one @ nat ) ) ) ).

% sum_power2
thf(fact_4642_horner__sum__eq__sum,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_semiring_1 @ A )
     => ( ( groups4207007520872428315er_sum @ B @ A )
        = ( ^ [F5: B > A,A4: A,Xs3: list @ B] :
              ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [N3: nat] : ( times_times @ A @ ( F5 @ ( nth @ B @ Xs3 @ N3 ) ) @ ( power_power @ A @ A4 @ N3 ) )
              @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( size_size @ ( list @ B ) @ Xs3 ) ) ) ) ) ) ).

% horner_sum_eq_sum
thf(fact_4643_Chebyshev__sum__upper,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N2: nat,A2: nat > A,B2: nat > A] :
          ( ! [I2: nat,J2: nat] :
              ( ( ord_less_eq @ nat @ I2 @ J2 )
             => ( ( ord_less @ nat @ J2 @ N2 )
               => ( ord_less_eq @ A @ ( A2 @ I2 ) @ ( A2 @ J2 ) ) ) )
         => ( ! [I2: nat,J2: nat] :
                ( ( ord_less_eq @ nat @ I2 @ J2 )
               => ( ( ord_less @ nat @ J2 @ N2 )
                 => ( ord_less_eq @ A @ ( B2 @ J2 ) @ ( B2 @ I2 ) ) ) )
           => ( ord_less_eq @ A
              @ ( times_times @ A @ ( semiring_1_of_nat @ A @ N2 )
                @ ( groups7311177749621191930dd_sum @ nat @ A
                  @ ^ [K3: nat] : ( times_times @ A @ ( A2 @ K3 ) @ ( B2 @ K3 ) )
                  @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N2 ) ) )
              @ ( times_times @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ A2 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N2 ) ) @ ( groups7311177749621191930dd_sum @ nat @ A @ B2 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N2 ) ) ) ) ) ) ) ).

% Chebyshev_sum_upper
thf(fact_4644_Chebyshev__sum__upper__nat,axiom,
    ! [N2: nat,A2: nat > nat,B2: nat > nat] :
      ( ! [I2: nat,J2: nat] :
          ( ( ord_less_eq @ nat @ I2 @ J2 )
         => ( ( ord_less @ nat @ J2 @ N2 )
           => ( ord_less_eq @ nat @ ( A2 @ I2 ) @ ( A2 @ J2 ) ) ) )
     => ( ! [I2: nat,J2: nat] :
            ( ( ord_less_eq @ nat @ I2 @ J2 )
           => ( ( ord_less @ nat @ J2 @ N2 )
             => ( ord_less_eq @ nat @ ( B2 @ J2 ) @ ( B2 @ I2 ) ) ) )
       => ( ord_less_eq @ nat
          @ ( times_times @ nat @ N2
            @ ( groups7311177749621191930dd_sum @ nat @ nat
              @ ^ [I4: nat] : ( times_times @ nat @ ( A2 @ I4 ) @ ( B2 @ I4 ) )
              @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N2 ) ) )
          @ ( times_times @ nat @ ( groups7311177749621191930dd_sum @ nat @ nat @ A2 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N2 ) ) @ ( groups7311177749621191930dd_sum @ nat @ nat @ B2 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N2 ) ) ) ) ) ) ).

% Chebyshev_sum_upper_nat
thf(fact_4645_xor__int__unfold,axiom,
    ( ( bit_se5824344971392196577ns_xor @ int )
    = ( ^ [K3: int,L2: int] :
          ( if @ int
          @ ( K3
            = ( uminus_uminus @ int @ ( one_one @ int ) ) )
          @ ( bit_ri4277139882892585799ns_not @ int @ L2 )
          @ ( if @ int
            @ ( L2
              = ( uminus_uminus @ int @ ( one_one @ int ) ) )
            @ ( bit_ri4277139882892585799ns_not @ int @ K3 )
            @ ( if @ int
              @ ( K3
                = ( zero_zero @ int ) )
              @ L2
              @ ( if @ int
                @ ( L2
                  = ( zero_zero @ int ) )
                @ K3
                @ ( plus_plus @ int @ ( abs_abs @ int @ ( minus_minus @ int @ ( modulo_modulo @ int @ K3 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( modulo_modulo @ int @ L2 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se5824344971392196577ns_xor @ int @ ( divide_divide @ int @ K3 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ int @ L2 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ) ) ).

% xor_int_unfold
thf(fact_4646_bit_Ocompl__eq__compl__iff,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X2: A,Y2: A] :
          ( ( ( bit_ri4277139882892585799ns_not @ A @ X2 )
            = ( bit_ri4277139882892585799ns_not @ A @ Y2 ) )
          = ( X2 = Y2 ) ) ) ).

% bit.compl_eq_compl_iff
thf(fact_4647_bit_Odouble__compl,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X2: A] :
          ( ( bit_ri4277139882892585799ns_not @ A @ ( bit_ri4277139882892585799ns_not @ A @ X2 ) )
          = X2 ) ) ).

% bit.double_compl
thf(fact_4648_bit_Oxor__compl__right,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X2: A,Y2: A] :
          ( ( bit_se5824344971392196577ns_xor @ A @ X2 @ ( bit_ri4277139882892585799ns_not @ A @ Y2 ) )
          = ( bit_ri4277139882892585799ns_not @ A @ ( bit_se5824344971392196577ns_xor @ A @ X2 @ Y2 ) ) ) ) ).

% bit.xor_compl_right
thf(fact_4649_bit_Oxor__compl__left,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X2: A,Y2: A] :
          ( ( bit_se5824344971392196577ns_xor @ A @ ( bit_ri4277139882892585799ns_not @ A @ X2 ) @ Y2 )
          = ( bit_ri4277139882892585799ns_not @ A @ ( bit_se5824344971392196577ns_xor @ A @ X2 @ Y2 ) ) ) ) ).

% bit.xor_compl_left
thf(fact_4650_bit_Oconj__cancel__left,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X2: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( bit_ri4277139882892585799ns_not @ A @ X2 ) @ X2 )
          = ( zero_zero @ A ) ) ) ).

% bit.conj_cancel_left
thf(fact_4651_bit_Oconj__cancel__right,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X2: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ X2 @ ( bit_ri4277139882892585799ns_not @ A @ X2 ) )
          = ( zero_zero @ A ) ) ) ).

% bit.conj_cancel_right
thf(fact_4652_bit_Ode__Morgan__disj,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X2: A,Y2: A] :
          ( ( bit_ri4277139882892585799ns_not @ A @ ( bit_se1065995026697491101ons_or @ A @ X2 @ Y2 ) )
          = ( bit_se5824344872417868541ns_and @ A @ ( bit_ri4277139882892585799ns_not @ A @ X2 ) @ ( bit_ri4277139882892585799ns_not @ A @ Y2 ) ) ) ) ).

% bit.de_Morgan_disj
thf(fact_4653_bit_Ode__Morgan__conj,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X2: A,Y2: A] :
          ( ( bit_ri4277139882892585799ns_not @ A @ ( bit_se5824344872417868541ns_and @ A @ X2 @ Y2 ) )
          = ( bit_se1065995026697491101ons_or @ A @ ( bit_ri4277139882892585799ns_not @ A @ X2 ) @ ( bit_ri4277139882892585799ns_not @ A @ Y2 ) ) ) ) ).

% bit.de_Morgan_conj
thf(fact_4654_bit_Ocompl__one,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( ( bit_ri4277139882892585799ns_not @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
        = ( zero_zero @ A ) ) ) ).

% bit.compl_one
thf(fact_4655_bit_Ocompl__zero,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( ( bit_ri4277139882892585799ns_not @ A @ ( zero_zero @ A ) )
        = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% bit.compl_zero
thf(fact_4656_bit_Odisj__cancel__right,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X2: A] :
          ( ( bit_se1065995026697491101ons_or @ A @ X2 @ ( bit_ri4277139882892585799ns_not @ A @ X2 ) )
          = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% bit.disj_cancel_right
thf(fact_4657_bit_Odisj__cancel__left,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X2: A] :
          ( ( bit_se1065995026697491101ons_or @ A @ ( bit_ri4277139882892585799ns_not @ A @ X2 ) @ X2 )
          = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% bit.disj_cancel_left
thf(fact_4658_bit_Oxor__cancel__right,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X2: A] :
          ( ( bit_se5824344971392196577ns_xor @ A @ X2 @ ( bit_ri4277139882892585799ns_not @ A @ X2 ) )
          = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% bit.xor_cancel_right
thf(fact_4659_bit_Oxor__cancel__left,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X2: A] :
          ( ( bit_se5824344971392196577ns_xor @ A @ ( bit_ri4277139882892585799ns_not @ A @ X2 ) @ X2 )
          = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% bit.xor_cancel_left
thf(fact_4660_bit_Oxor__one__right,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X2: A] :
          ( ( bit_se5824344971392196577ns_xor @ A @ X2 @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( bit_ri4277139882892585799ns_not @ A @ X2 ) ) ) ).

% bit.xor_one_right
thf(fact_4661_bit_Oxor__one__left,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X2: A] :
          ( ( bit_se5824344971392196577ns_xor @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ X2 )
          = ( bit_ri4277139882892585799ns_not @ A @ X2 ) ) ) ).

% bit.xor_one_left
thf(fact_4662_not__negative__int__iff,axiom,
    ! [K: int] :
      ( ( ord_less @ int @ ( bit_ri4277139882892585799ns_not @ int @ K ) @ ( zero_zero @ int ) )
      = ( ord_less_eq @ int @ ( zero_zero @ int ) @ K ) ) ).

% not_negative_int_iff
thf(fact_4663_not__nonnegative__int__iff,axiom,
    ! [K: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( bit_ri4277139882892585799ns_not @ int @ K ) )
      = ( ord_less @ int @ K @ ( zero_zero @ int ) ) ) ).

% not_nonnegative_int_iff
thf(fact_4664_minus__not__numeral__eq,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N2: num] :
          ( ( uminus_uminus @ A @ ( bit_ri4277139882892585799ns_not @ A @ ( numeral_numeral @ A @ N2 ) ) )
          = ( numeral_numeral @ A @ ( inc @ N2 ) ) ) ) ).

% minus_not_numeral_eq
thf(fact_4665_even__not__iff,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [A2: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_ri4277139882892585799ns_not @ A @ A2 ) )
          = ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) ) ) ) ).

% even_not_iff
thf(fact_4666_push__bit__minus__one__eq__not__mask,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N2: nat] :
          ( ( bit_se4730199178511100633sh_bit @ A @ N2 @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( bit_ri4277139882892585799ns_not @ A @ ( bit_se2239418461657761734s_mask @ A @ N2 ) ) ) ) ).

% push_bit_minus_one_eq_not_mask
thf(fact_4667_not__one__eq,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( ( bit_ri4277139882892585799ns_not @ A @ ( one_one @ A ) )
        = ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% not_one_eq
thf(fact_4668_or__minus__minus__numerals,axiom,
    ! [M: num,N2: num] :
      ( ( bit_se1065995026697491101ons_or @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ M ) ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N2 ) ) )
      = ( bit_ri4277139882892585799ns_not @ int @ ( bit_se5824344872417868541ns_and @ int @ ( minus_minus @ int @ ( numeral_numeral @ int @ M ) @ ( one_one @ int ) ) @ ( minus_minus @ int @ ( numeral_numeral @ int @ N2 ) @ ( one_one @ int ) ) ) ) ) ).

% or_minus_minus_numerals
thf(fact_4669_and__minus__minus__numerals,axiom,
    ! [M: num,N2: num] :
      ( ( bit_se5824344872417868541ns_and @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ M ) ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N2 ) ) )
      = ( bit_ri4277139882892585799ns_not @ int @ ( bit_se1065995026697491101ons_or @ int @ ( minus_minus @ int @ ( numeral_numeral @ int @ M ) @ ( one_one @ int ) ) @ ( minus_minus @ int @ ( numeral_numeral @ int @ N2 ) @ ( one_one @ int ) ) ) ) ) ).

% and_minus_minus_numerals
thf(fact_4670_of__int__not__numeral,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [K: num] :
          ( ( ring_1_of_int @ A @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ K ) ) )
          = ( bit_ri4277139882892585799ns_not @ A @ ( numeral_numeral @ A @ K ) ) ) ) ).

% of_int_not_numeral
thf(fact_4671_take__bit__not__iff,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N2: nat,A2: A,B2: A] :
          ( ( ( bit_se2584673776208193580ke_bit @ A @ N2 @ ( bit_ri4277139882892585799ns_not @ A @ A2 ) )
            = ( bit_se2584673776208193580ke_bit @ A @ N2 @ ( bit_ri4277139882892585799ns_not @ A @ B2 ) ) )
          = ( ( bit_se2584673776208193580ke_bit @ A @ N2 @ A2 )
            = ( bit_se2584673776208193580ke_bit @ A @ N2 @ B2 ) ) ) ) ).

% take_bit_not_iff
thf(fact_4672_take__bit__not__take__bit,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N2: nat,A2: A] :
          ( ( bit_se2584673776208193580ke_bit @ A @ N2 @ ( bit_ri4277139882892585799ns_not @ A @ ( bit_se2584673776208193580ke_bit @ A @ N2 @ A2 ) ) )
          = ( bit_se2584673776208193580ke_bit @ A @ N2 @ ( bit_ri4277139882892585799ns_not @ A @ A2 ) ) ) ) ).

% take_bit_not_take_bit
thf(fact_4673_bit__not__int__iff,axiom,
    ! [K: int,N2: nat] :
      ( ( bit_se5641148757651400278ts_bit @ int @ ( bit_ri4277139882892585799ns_not @ int @ K ) @ N2 )
      = ( ~ ( bit_se5641148757651400278ts_bit @ int @ K @ N2 ) ) ) ).

% bit_not_int_iff
thf(fact_4674_of__int__not__eq,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [K: int] :
          ( ( ring_1_of_int @ A @ ( bit_ri4277139882892585799ns_not @ int @ K ) )
          = ( bit_ri4277139882892585799ns_not @ A @ ( ring_1_of_int @ A @ K ) ) ) ) ).

% of_int_not_eq
thf(fact_4675_not__diff__distrib,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [A2: A,B2: A] :
          ( ( bit_ri4277139882892585799ns_not @ A @ ( minus_minus @ A @ A2 @ B2 ) )
          = ( plus_plus @ A @ ( bit_ri4277139882892585799ns_not @ A @ A2 ) @ B2 ) ) ) ).

% not_diff_distrib
thf(fact_4676_not__add__distrib,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [A2: A,B2: A] :
          ( ( bit_ri4277139882892585799ns_not @ A @ ( plus_plus @ A @ A2 @ B2 ) )
          = ( minus_minus @ A @ ( bit_ri4277139882892585799ns_not @ A @ A2 ) @ B2 ) ) ) ).

% not_add_distrib
thf(fact_4677_or__eq__not__not__and,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( ( bit_se1065995026697491101ons_or @ A )
        = ( ^ [A4: A,B4: A] : ( bit_ri4277139882892585799ns_not @ A @ ( bit_se5824344872417868541ns_and @ A @ ( bit_ri4277139882892585799ns_not @ A @ A4 ) @ ( bit_ri4277139882892585799ns_not @ A @ B4 ) ) ) ) ) ) ).

% or_eq_not_not_and
thf(fact_4678_and__eq__not__not__or,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( ( bit_se5824344872417868541ns_and @ A )
        = ( ^ [A4: A,B4: A] : ( bit_ri4277139882892585799ns_not @ A @ ( bit_se1065995026697491101ons_or @ A @ ( bit_ri4277139882892585799ns_not @ A @ A4 ) @ ( bit_ri4277139882892585799ns_not @ A @ B4 ) ) ) ) ) ) ).

% and_eq_not_not_or
thf(fact_4679_or__int__def,axiom,
    ( ( bit_se1065995026697491101ons_or @ int )
    = ( ^ [K3: int,L2: int] : ( bit_ri4277139882892585799ns_not @ int @ ( bit_se5824344872417868541ns_and @ int @ ( bit_ri4277139882892585799ns_not @ int @ K3 ) @ ( bit_ri4277139882892585799ns_not @ int @ L2 ) ) ) ) ) ).

% or_int_def
thf(fact_4680_minus__eq__not__plus__1,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( ( uminus_uminus @ A )
        = ( ^ [A4: A] : ( plus_plus @ A @ ( bit_ri4277139882892585799ns_not @ A @ A4 ) @ ( one_one @ A ) ) ) ) ) ).

% minus_eq_not_plus_1
thf(fact_4681_not__eq__complement,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( ( bit_ri4277139882892585799ns_not @ A )
        = ( ^ [A4: A] : ( minus_minus @ A @ ( uminus_uminus @ A @ A4 ) @ ( one_one @ A ) ) ) ) ) ).

% not_eq_complement
thf(fact_4682_minus__eq__not__minus__1,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( ( uminus_uminus @ A )
        = ( ^ [A4: A] : ( bit_ri4277139882892585799ns_not @ A @ ( minus_minus @ A @ A4 @ ( one_one @ A ) ) ) ) ) ) ).

% minus_eq_not_minus_1
thf(fact_4683_not__int__def,axiom,
    ( ( bit_ri4277139882892585799ns_not @ int )
    = ( ^ [K3: int] : ( minus_minus @ int @ ( uminus_uminus @ int @ K3 ) @ ( one_one @ int ) ) ) ) ).

% not_int_def
thf(fact_4684_and__not__numerals_I1_J,axiom,
    ( ( bit_se5824344872417868541ns_and @ int @ ( one_one @ int ) @ ( bit_ri4277139882892585799ns_not @ int @ ( one_one @ int ) ) )
    = ( zero_zero @ int ) ) ).

% and_not_numerals(1)
thf(fact_4685_or__not__numerals_I1_J,axiom,
    ( ( bit_se1065995026697491101ons_or @ int @ ( one_one @ int ) @ ( bit_ri4277139882892585799ns_not @ int @ ( one_one @ int ) ) )
    = ( bit_ri4277139882892585799ns_not @ int @ ( zero_zero @ int ) ) ) ).

% or_not_numerals(1)
thf(fact_4686_disjunctive__diff,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [B2: A,A2: A] :
          ( ! [N: nat] :
              ( ( bit_se5641148757651400278ts_bit @ A @ B2 @ N )
             => ( bit_se5641148757651400278ts_bit @ A @ A2 @ N ) )
         => ( ( minus_minus @ A @ A2 @ B2 )
            = ( bit_se5824344872417868541ns_and @ A @ A2 @ ( bit_ri4277139882892585799ns_not @ A @ B2 ) ) ) ) ) ).

% disjunctive_diff
thf(fact_4687_take__bit__not__eq__mask__diff,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N2: nat,A2: A] :
          ( ( bit_se2584673776208193580ke_bit @ A @ N2 @ ( bit_ri4277139882892585799ns_not @ A @ A2 ) )
          = ( minus_minus @ A @ ( bit_se2239418461657761734s_mask @ A @ N2 ) @ ( bit_se2584673776208193580ke_bit @ A @ N2 @ A2 ) ) ) ) ).

% take_bit_not_eq_mask_diff
thf(fact_4688_minus__numeral__inc__eq,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N2: num] :
          ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( inc @ N2 ) ) )
          = ( bit_ri4277139882892585799ns_not @ A @ ( numeral_numeral @ A @ N2 ) ) ) ) ).

% minus_numeral_inc_eq
thf(fact_4689_bit_Oxor__def2,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( ( bit_se5824344971392196577ns_xor @ A )
        = ( ^ [X5: A,Y5: A] : ( bit_se5824344872417868541ns_and @ A @ ( bit_se1065995026697491101ons_or @ A @ X5 @ Y5 ) @ ( bit_se1065995026697491101ons_or @ A @ ( bit_ri4277139882892585799ns_not @ A @ X5 ) @ ( bit_ri4277139882892585799ns_not @ A @ Y5 ) ) ) ) ) ) ).

% bit.xor_def2
thf(fact_4690_bit_Oxor__def,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( ( bit_se5824344971392196577ns_xor @ A )
        = ( ^ [X5: A,Y5: A] : ( bit_se1065995026697491101ons_or @ A @ ( bit_se5824344872417868541ns_and @ A @ X5 @ ( bit_ri4277139882892585799ns_not @ A @ Y5 ) ) @ ( bit_se5824344872417868541ns_and @ A @ ( bit_ri4277139882892585799ns_not @ A @ X5 ) @ Y5 ) ) ) ) ) ).

% bit.xor_def
thf(fact_4691_unset__bit__int__def,axiom,
    ( ( bit_se2638667681897837118et_bit @ int )
    = ( ^ [N3: nat,K3: int] : ( bit_se5824344872417868541ns_and @ int @ K3 @ ( bit_ri4277139882892585799ns_not @ int @ ( bit_se4730199178511100633sh_bit @ int @ N3 @ ( one_one @ int ) ) ) ) ) ) ).

% unset_bit_int_def
thf(fact_4692_xor__int__def,axiom,
    ( ( bit_se5824344971392196577ns_xor @ int )
    = ( ^ [K3: int,L2: int] : ( bit_se1065995026697491101ons_or @ int @ ( bit_se5824344872417868541ns_and @ int @ K3 @ ( bit_ri4277139882892585799ns_not @ int @ L2 ) ) @ ( bit_se5824344872417868541ns_and @ int @ ( bit_ri4277139882892585799ns_not @ int @ K3 ) @ L2 ) ) ) ) ).

% xor_int_def
thf(fact_4693_not__int__div__2,axiom,
    ! [K: int] :
      ( ( divide_divide @ int @ ( bit_ri4277139882892585799ns_not @ int @ K ) @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) )
      = ( bit_ri4277139882892585799ns_not @ int @ ( divide_divide @ int @ K @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) ).

% not_int_div_2
thf(fact_4694_even__not__iff__int,axiom,
    ! [K: int] :
      ( ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_ri4277139882892585799ns_not @ int @ K ) )
      = ( ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ K ) ) ) ).

% even_not_iff_int
thf(fact_4695_not__numeral__Bit0__eq,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N2: num] :
          ( ( bit_ri4277139882892585799ns_not @ A @ ( numeral_numeral @ A @ ( bit0 @ N2 ) ) )
          = ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( bit1 @ N2 ) ) ) ) ) ).

% not_numeral_Bit0_eq
thf(fact_4696_and__not__numerals_I4_J,axiom,
    ! [M: num] :
      ( ( bit_se5824344872417868541ns_and @ int @ ( numeral_numeral @ int @ ( bit0 @ M ) ) @ ( bit_ri4277139882892585799ns_not @ int @ ( one_one @ int ) ) )
      = ( numeral_numeral @ int @ ( bit0 @ M ) ) ) ).

% and_not_numerals(4)
thf(fact_4697_and__not__numerals_I2_J,axiom,
    ! [N2: num] :
      ( ( bit_se5824344872417868541ns_and @ int @ ( one_one @ int ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ ( bit0 @ N2 ) ) ) )
      = ( one_one @ int ) ) ).

% and_not_numerals(2)
thf(fact_4698_or__not__numerals_I4_J,axiom,
    ! [M: num] :
      ( ( bit_se1065995026697491101ons_or @ int @ ( numeral_numeral @ int @ ( bit0 @ M ) ) @ ( bit_ri4277139882892585799ns_not @ int @ ( one_one @ int ) ) )
      = ( bit_ri4277139882892585799ns_not @ int @ ( one_one @ int ) ) ) ).

% or_not_numerals(4)
thf(fact_4699_or__not__numerals_I2_J,axiom,
    ! [N2: num] :
      ( ( bit_se1065995026697491101ons_or @ int @ ( one_one @ int ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ ( bit0 @ N2 ) ) ) )
      = ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ ( bit0 @ N2 ) ) ) ) ).

% or_not_numerals(2)
thf(fact_4700_bit__minus__int__iff,axiom,
    ! [K: int,N2: nat] :
      ( ( bit_se5641148757651400278ts_bit @ int @ ( uminus_uminus @ int @ K ) @ N2 )
      = ( bit_se5641148757651400278ts_bit @ int @ ( bit_ri4277139882892585799ns_not @ int @ ( minus_minus @ int @ K @ ( one_one @ int ) ) ) @ N2 ) ) ).

% bit_minus_int_iff
thf(fact_4701_not__numeral__BitM__eq,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N2: num] :
          ( ( bit_ri4277139882892585799ns_not @ A @ ( numeral_numeral @ A @ ( bitM @ N2 ) ) )
          = ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( bit0 @ N2 ) ) ) ) ) ).

% not_numeral_BitM_eq
thf(fact_4702_take__bit__not__mask__eq__0,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [M: nat,N2: nat] :
          ( ( ord_less_eq @ nat @ M @ N2 )
         => ( ( bit_se2584673776208193580ke_bit @ A @ M @ ( bit_ri4277139882892585799ns_not @ A @ ( bit_se2239418461657761734s_mask @ A @ N2 ) ) )
            = ( zero_zero @ A ) ) ) ) ).

% take_bit_not_mask_eq_0
thf(fact_4703_int__numeral__or__not__num__neg,axiom,
    ! [M: num,N2: num] :
      ( ( bit_se1065995026697491101ons_or @ int @ ( numeral_numeral @ int @ M ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ N2 ) ) )
      = ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit_or_not_num_neg @ M @ N2 ) ) ) ) ).

% int_numeral_or_not_num_neg
thf(fact_4704_int__numeral__not__or__num__neg,axiom,
    ! [M: num,N2: num] :
      ( ( bit_se1065995026697491101ons_or @ int @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ M ) ) @ ( numeral_numeral @ int @ N2 ) )
      = ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit_or_not_num_neg @ N2 @ M ) ) ) ) ).

% int_numeral_not_or_num_neg
thf(fact_4705_numeral__or__not__num__eq,axiom,
    ! [M: num,N2: num] :
      ( ( numeral_numeral @ int @ ( bit_or_not_num_neg @ M @ N2 ) )
      = ( uminus_uminus @ int @ ( bit_se1065995026697491101ons_or @ int @ ( numeral_numeral @ int @ M ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ N2 ) ) ) ) ) ).

% numeral_or_not_num_eq
thf(fact_4706_push__bit__mask__eq,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [M: nat,N2: nat] :
          ( ( bit_se4730199178511100633sh_bit @ A @ M @ ( bit_se2239418461657761734s_mask @ A @ N2 ) )
          = ( bit_se5824344872417868541ns_and @ A @ ( bit_se2239418461657761734s_mask @ A @ ( plus_plus @ nat @ N2 @ M ) ) @ ( bit_ri4277139882892585799ns_not @ A @ ( bit_se2239418461657761734s_mask @ A @ M ) ) ) ) ) ).

% push_bit_mask_eq
thf(fact_4707_unset__bit__eq__and__not,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( ( bit_se2638667681897837118et_bit @ A )
        = ( ^ [N3: nat,A4: A] : ( bit_se5824344872417868541ns_and @ A @ A4 @ ( bit_ri4277139882892585799ns_not @ A @ ( bit_se4730199178511100633sh_bit @ A @ N3 @ ( one_one @ A ) ) ) ) ) ) ) ).

% unset_bit_eq_and_not
thf(fact_4708_and__not__numerals_I5_J,axiom,
    ! [M: num,N2: num] :
      ( ( bit_se5824344872417868541ns_and @ int @ ( numeral_numeral @ int @ ( bit0 @ M ) ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ ( bit0 @ N2 ) ) ) )
      = ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se5824344872417868541ns_and @ int @ ( numeral_numeral @ int @ M ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ N2 ) ) ) ) ) ).

% and_not_numerals(5)
thf(fact_4709_and__not__numerals_I7_J,axiom,
    ! [M: num] :
      ( ( bit_se5824344872417868541ns_and @ int @ ( numeral_numeral @ int @ ( bit1 @ M ) ) @ ( bit_ri4277139882892585799ns_not @ int @ ( one_one @ int ) ) )
      = ( numeral_numeral @ int @ ( bit0 @ M ) ) ) ).

% and_not_numerals(7)
thf(fact_4710_or__not__numerals_I3_J,axiom,
    ! [N2: num] :
      ( ( bit_se1065995026697491101ons_or @ int @ ( one_one @ int ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ ( bit1 @ N2 ) ) ) )
      = ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ ( bit0 @ N2 ) ) ) ) ).

% or_not_numerals(3)
thf(fact_4711_and__not__numerals_I3_J,axiom,
    ! [N2: num] :
      ( ( bit_se5824344872417868541ns_and @ int @ ( one_one @ int ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ ( bit1 @ N2 ) ) ) )
      = ( zero_zero @ int ) ) ).

% and_not_numerals(3)
thf(fact_4712_or__not__numerals_I7_J,axiom,
    ! [M: num] :
      ( ( bit_se1065995026697491101ons_or @ int @ ( numeral_numeral @ int @ ( bit1 @ M ) ) @ ( bit_ri4277139882892585799ns_not @ int @ ( one_one @ int ) ) )
      = ( bit_ri4277139882892585799ns_not @ int @ ( zero_zero @ int ) ) ) ).

% or_not_numerals(7)
thf(fact_4713_bit_Ocompl__unique,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X2: A,Y2: A] :
          ( ( ( bit_se5824344872417868541ns_and @ A @ X2 @ Y2 )
            = ( zero_zero @ A ) )
         => ( ( ( bit_se1065995026697491101ons_or @ A @ X2 @ Y2 )
              = ( uminus_uminus @ A @ ( one_one @ A ) ) )
           => ( ( bit_ri4277139882892585799ns_not @ A @ X2 )
              = Y2 ) ) ) ) ).

% bit.compl_unique
thf(fact_4714_signed__take__bit__eq__if__negative,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [A2: A,N2: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ A2 @ N2 )
         => ( ( bit_ri4674362597316999326ke_bit @ A @ N2 @ A2 )
            = ( bit_se1065995026697491101ons_or @ A @ ( bit_se2584673776208193580ke_bit @ A @ N2 @ A2 ) @ ( bit_ri4277139882892585799ns_not @ A @ ( bit_se2239418461657761734s_mask @ A @ N2 ) ) ) ) ) ) ).

% signed_take_bit_eq_if_negative
thf(fact_4715_and__not__numerals_I6_J,axiom,
    ! [M: num,N2: num] :
      ( ( bit_se5824344872417868541ns_and @ int @ ( numeral_numeral @ int @ ( bit0 @ M ) ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ ( bit1 @ N2 ) ) ) )
      = ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se5824344872417868541ns_and @ int @ ( numeral_numeral @ int @ M ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ N2 ) ) ) ) ) ).

% and_not_numerals(6)
thf(fact_4716_and__not__numerals_I9_J,axiom,
    ! [M: num,N2: num] :
      ( ( bit_se5824344872417868541ns_and @ int @ ( numeral_numeral @ int @ ( bit1 @ M ) ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ ( bit1 @ N2 ) ) ) )
      = ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se5824344872417868541ns_and @ int @ ( numeral_numeral @ int @ M ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ N2 ) ) ) ) ) ).

% and_not_numerals(9)
thf(fact_4717_or__not__numerals_I6_J,axiom,
    ! [M: num,N2: num] :
      ( ( bit_se1065995026697491101ons_or @ int @ ( numeral_numeral @ int @ ( bit0 @ M ) ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ ( bit1 @ N2 ) ) ) )
      = ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se1065995026697491101ons_or @ int @ ( numeral_numeral @ int @ M ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ N2 ) ) ) ) ) ).

% or_not_numerals(6)
thf(fact_4718_bit__not__iff__eq,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [A2: A,N2: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( bit_ri4277139882892585799ns_not @ A @ A2 ) @ N2 )
          = ( ( ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N2 )
             != ( zero_zero @ A ) )
            & ~ ( bit_se5641148757651400278ts_bit @ A @ A2 @ N2 ) ) ) ) ).

% bit_not_iff_eq
thf(fact_4719_minus__exp__eq__not__mask,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N2: nat] :
          ( ( uminus_uminus @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N2 ) )
          = ( bit_ri4277139882892585799ns_not @ A @ ( bit_se2239418461657761734s_mask @ A @ N2 ) ) ) ) ).

% minus_exp_eq_not_mask
thf(fact_4720_or__not__numerals_I5_J,axiom,
    ! [M: num,N2: num] :
      ( ( bit_se1065995026697491101ons_or @ int @ ( numeral_numeral @ int @ ( bit0 @ M ) ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ ( bit0 @ N2 ) ) ) )
      = ( plus_plus @ int @ ( one_one @ int ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se1065995026697491101ons_or @ int @ ( numeral_numeral @ int @ M ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ N2 ) ) ) ) ) ) ).

% or_not_numerals(5)
thf(fact_4721_signed__take__bit__def,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( ( bit_ri4674362597316999326ke_bit @ A )
        = ( ^ [N3: nat,A4: A] : ( bit_se1065995026697491101ons_or @ A @ ( bit_se2584673776208193580ke_bit @ A @ N3 @ A4 ) @ ( times_times @ A @ ( zero_neq_one_of_bool @ A @ ( bit_se5641148757651400278ts_bit @ A @ A4 @ N3 ) ) @ ( bit_ri4277139882892585799ns_not @ A @ ( bit_se2239418461657761734s_mask @ A @ N3 ) ) ) ) ) ) ) ).

% signed_take_bit_def
thf(fact_4722_and__not__numerals_I8_J,axiom,
    ! [M: num,N2: num] :
      ( ( bit_se5824344872417868541ns_and @ int @ ( numeral_numeral @ int @ ( bit1 @ M ) ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ ( bit0 @ N2 ) ) ) )
      = ( plus_plus @ int @ ( one_one @ int ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se5824344872417868541ns_and @ int @ ( numeral_numeral @ int @ M ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ N2 ) ) ) ) ) ) ).

% and_not_numerals(8)
thf(fact_4723_or__not__numerals_I9_J,axiom,
    ! [M: num,N2: num] :
      ( ( bit_se1065995026697491101ons_or @ int @ ( numeral_numeral @ int @ ( bit1 @ M ) ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ ( bit1 @ N2 ) ) ) )
      = ( plus_plus @ int @ ( one_one @ int ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se1065995026697491101ons_or @ int @ ( numeral_numeral @ int @ M ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ N2 ) ) ) ) ) ) ).

% or_not_numerals(9)
thf(fact_4724_or__not__numerals_I8_J,axiom,
    ! [M: num,N2: num] :
      ( ( bit_se1065995026697491101ons_or @ int @ ( numeral_numeral @ int @ ( bit1 @ M ) ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ ( bit0 @ N2 ) ) ) )
      = ( plus_plus @ int @ ( one_one @ int ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se1065995026697491101ons_or @ int @ ( numeral_numeral @ int @ M ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ N2 ) ) ) ) ) ) ).

% or_not_numerals(8)
thf(fact_4725_not__int__rec,axiom,
    ( ( bit_ri4277139882892585799ns_not @ int )
    = ( ^ [K3: int] : ( plus_plus @ int @ ( zero_neq_one_of_bool @ int @ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ K3 ) ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_ri4277139882892585799ns_not @ int @ ( divide_divide @ int @ K3 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% not_int_rec
thf(fact_4726_bit_Oabstract__boolean__algebra__sym__diff__axioms,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( boolea3799213064322606851m_diff @ A @ ( bit_se5824344872417868541ns_and @ A ) @ ( bit_se1065995026697491101ons_or @ A ) @ ( bit_ri4277139882892585799ns_not @ A ) @ ( zero_zero @ A ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( bit_se5824344971392196577ns_xor @ A ) ) ) ).

% bit.abstract_boolean_algebra_sym_diff_axioms
thf(fact_4727_set__encode__insert,axiom,
    ! [A3: set @ nat,N2: nat] :
      ( ( finite_finite @ nat @ A3 )
     => ( ~ ( member @ nat @ N2 @ A3 )
       => ( ( nat_set_encode @ ( insert @ nat @ N2 @ A3 ) )
          = ( plus_plus @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) @ ( nat_set_encode @ A3 ) ) ) ) ) ).

% set_encode_insert
thf(fact_4728_VEBT_Osize_I3_J,axiom,
    ! [X11: option @ ( product_prod @ nat @ nat ),X12: nat,X13: list @ vEBT_VEBT,X14: vEBT_VEBT] :
      ( ( size_size @ vEBT_VEBT @ ( vEBT_Node @ X11 @ X12 @ X13 @ X14 ) )
      = ( plus_plus @ nat @ ( plus_plus @ nat @ ( size_list @ vEBT_VEBT @ ( size_size @ vEBT_VEBT ) @ X13 ) @ ( size_size @ vEBT_VEBT @ X14 ) ) @ ( suc @ ( zero_zero @ nat ) ) ) ) ).

% VEBT.size(3)
thf(fact_4729_set__vebt__finite,axiom,
    ! [T2: vEBT_VEBT,N2: nat] :
      ( ( vEBT_invar_vebt @ T2 @ N2 )
     => ( finite_finite @ nat @ ( vEBT_VEBT_set_vebt @ T2 ) ) ) ).

% set_vebt_finite
thf(fact_4730_List_Ofinite__set,axiom,
    ! [A: $tType,Xs: list @ A] : ( finite_finite @ A @ ( set2 @ A @ Xs ) ) ).

% List.finite_set
thf(fact_4731_sum_Oinfinite,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A3: set @ B,G: B > A] :
          ( ~ ( finite_finite @ B @ A3 )
         => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ A3 )
            = ( zero_zero @ A ) ) ) ) ).

% sum.infinite
thf(fact_4732_sum__eq__0__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ! [F3: set @ B,F2: B > A] :
          ( ( finite_finite @ B @ F3 )
         => ( ( ( groups7311177749621191930dd_sum @ B @ A @ F2 @ F3 )
              = ( zero_zero @ A ) )
            = ( ! [X5: B] :
                  ( ( member @ B @ X5 @ F3 )
                 => ( ( F2 @ X5 )
                    = ( zero_zero @ A ) ) ) ) ) ) ) ).

% sum_eq_0_iff
thf(fact_4733_prod__zero__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( semidom @ A )
     => ! [A3: set @ B,F2: B > A] :
          ( ( finite_finite @ B @ A3 )
         => ( ( ( groups7121269368397514597t_prod @ B @ A @ F2 @ A3 )
              = ( zero_zero @ A ) )
            = ( ? [X5: B] :
                  ( ( member @ B @ X5 @ A3 )
                  & ( ( F2 @ X5 )
                    = ( zero_zero @ A ) ) ) ) ) ) ) ).

% prod_zero_iff
thf(fact_4734_infinite__Icc__iff,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ~ ( finite_finite @ A @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) ) )
          = ( ord_less @ A @ A2 @ B2 ) ) ) ).

% infinite_Icc_iff
thf(fact_4735_infinite__Ico__iff,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ~ ( finite_finite @ A @ ( set_or7035219750837199246ssThan @ A @ A2 @ B2 ) ) )
          = ( ord_less @ A @ A2 @ B2 ) ) ) ).

% infinite_Ico_iff
thf(fact_4736_prod_Oinfinite,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A3: set @ B,G: B > A] :
          ( ~ ( finite_finite @ B @ A3 )
         => ( ( groups7121269368397514597t_prod @ B @ A @ G @ A3 )
            = ( one_one @ A ) ) ) ) ).

% prod.infinite
thf(fact_4737_sum_Odelta_H,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [S3: set @ B,A2: B,B2: B > A] :
          ( ( finite_finite @ B @ S3 )
         => ( ( ( member @ B @ A2 @ S3 )
             => ( ( groups7311177749621191930dd_sum @ B @ A
                  @ ^ [K3: B] : ( if @ A @ ( A2 = K3 ) @ ( B2 @ K3 ) @ ( zero_zero @ A ) )
                  @ S3 )
                = ( B2 @ A2 ) ) )
            & ( ~ ( member @ B @ A2 @ S3 )
             => ( ( groups7311177749621191930dd_sum @ B @ A
                  @ ^ [K3: B] : ( if @ A @ ( A2 = K3 ) @ ( B2 @ K3 ) @ ( zero_zero @ A ) )
                  @ S3 )
                = ( zero_zero @ A ) ) ) ) ) ) ).

% sum.delta'
thf(fact_4738_sum_Odelta,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [S3: set @ B,A2: B,B2: B > A] :
          ( ( finite_finite @ B @ S3 )
         => ( ( ( member @ B @ A2 @ S3 )
             => ( ( groups7311177749621191930dd_sum @ B @ A
                  @ ^ [K3: B] : ( if @ A @ ( K3 = A2 ) @ ( B2 @ K3 ) @ ( zero_zero @ A ) )
                  @ S3 )
                = ( B2 @ A2 ) ) )
            & ( ~ ( member @ B @ A2 @ S3 )
             => ( ( groups7311177749621191930dd_sum @ B @ A
                  @ ^ [K3: B] : ( if @ A @ ( K3 = A2 ) @ ( B2 @ K3 ) @ ( zero_zero @ A ) )
                  @ S3 )
                = ( zero_zero @ A ) ) ) ) ) ) ).

% sum.delta
thf(fact_4739_prod__eq__1__iff,axiom,
    ! [A: $tType,A3: set @ A,F2: A > nat] :
      ( ( finite_finite @ A @ A3 )
     => ( ( ( groups7121269368397514597t_prod @ A @ nat @ F2 @ A3 )
          = ( one_one @ nat ) )
        = ( ! [X5: A] :
              ( ( member @ A @ X5 @ A3 )
             => ( ( F2 @ X5 )
                = ( one_one @ nat ) ) ) ) ) ) ).

% prod_eq_1_iff
thf(fact_4740_prod_Odelta_H,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [S3: set @ B,A2: B,B2: B > A] :
          ( ( finite_finite @ B @ S3 )
         => ( ( ( member @ B @ A2 @ S3 )
             => ( ( groups7121269368397514597t_prod @ B @ A
                  @ ^ [K3: B] : ( if @ A @ ( A2 = K3 ) @ ( B2 @ K3 ) @ ( one_one @ A ) )
                  @ S3 )
                = ( B2 @ A2 ) ) )
            & ( ~ ( member @ B @ A2 @ S3 )
             => ( ( groups7121269368397514597t_prod @ B @ A
                  @ ^ [K3: B] : ( if @ A @ ( A2 = K3 ) @ ( B2 @ K3 ) @ ( one_one @ A ) )
                  @ S3 )
                = ( one_one @ A ) ) ) ) ) ) ).

% prod.delta'
thf(fact_4741_prod_Odelta,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [S3: set @ B,A2: B,B2: B > A] :
          ( ( finite_finite @ B @ S3 )
         => ( ( ( member @ B @ A2 @ S3 )
             => ( ( groups7121269368397514597t_prod @ B @ A
                  @ ^ [K3: B] : ( if @ A @ ( K3 = A2 ) @ ( B2 @ K3 ) @ ( one_one @ A ) )
                  @ S3 )
                = ( B2 @ A2 ) ) )
            & ( ~ ( member @ B @ A2 @ S3 )
             => ( ( groups7121269368397514597t_prod @ B @ A
                  @ ^ [K3: B] : ( if @ A @ ( K3 = A2 ) @ ( B2 @ K3 ) @ ( one_one @ A ) )
                  @ S3 )
                = ( one_one @ A ) ) ) ) ) ) ).

% prod.delta
thf(fact_4742_summable__If__finite,axiom,
    ! [A: $tType] :
      ( ( ( comm_monoid_add @ A )
        & ( topolo4958980785337419405_space @ A ) )
     => ! [P: nat > $o,F2: nat > A] :
          ( ( finite_finite @ nat @ ( collect @ nat @ P ) )
         => ( summable @ A
            @ ^ [R5: nat] : ( if @ A @ ( P @ R5 ) @ ( F2 @ R5 ) @ ( zero_zero @ A ) ) ) ) ) ).

% summable_If_finite
thf(fact_4743_summable__If__finite__set,axiom,
    ! [A: $tType] :
      ( ( ( comm_monoid_add @ A )
        & ( topolo4958980785337419405_space @ A ) )
     => ! [A3: set @ nat,F2: nat > A] :
          ( ( finite_finite @ nat @ A3 )
         => ( summable @ A
            @ ^ [R5: nat] : ( if @ A @ ( member @ nat @ R5 @ A3 ) @ ( F2 @ R5 ) @ ( zero_zero @ A ) ) ) ) ) ).

% summable_If_finite_set
thf(fact_4744_sum_Oinsert,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A3: set @ B,X2: B,G: B > A] :
          ( ( finite_finite @ B @ A3 )
         => ( ~ ( member @ B @ X2 @ A3 )
           => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ ( insert @ B @ X2 @ A3 ) )
              = ( plus_plus @ A @ ( G @ X2 ) @ ( groups7311177749621191930dd_sum @ B @ A @ G @ A3 ) ) ) ) ) ) ).

% sum.insert
thf(fact_4745_prod_Oinsert,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A3: set @ B,X2: B,G: B > A] :
          ( ( finite_finite @ B @ A3 )
         => ( ~ ( member @ B @ X2 @ A3 )
           => ( ( groups7121269368397514597t_prod @ B @ A @ G @ ( insert @ B @ X2 @ A3 ) )
              = ( times_times @ A @ ( G @ X2 ) @ ( groups7121269368397514597t_prod @ B @ A @ G @ A3 ) ) ) ) ) ) ).

% prod.insert
thf(fact_4746_prod__pos__nat__iff,axiom,
    ! [A: $tType,A3: set @ A,F2: A > nat] :
      ( ( finite_finite @ A @ A3 )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( groups7121269368397514597t_prod @ A @ nat @ F2 @ A3 ) )
        = ( ! [X5: A] :
              ( ( member @ A @ X5 @ A3 )
             => ( ord_less @ nat @ ( zero_zero @ nat ) @ ( F2 @ X5 ) ) ) ) ) ) ).

% prod_pos_nat_iff
thf(fact_4747_sum__zero__power,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A3: set @ nat,C2: nat > A] :
          ( ( ( ( finite_finite @ nat @ A3 )
              & ( member @ nat @ ( zero_zero @ nat ) @ A3 ) )
           => ( ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I4: nat] : ( times_times @ A @ ( C2 @ I4 ) @ ( power_power @ A @ ( zero_zero @ A ) @ I4 ) )
                @ A3 )
              = ( C2 @ ( zero_zero @ nat ) ) ) )
          & ( ~ ( ( finite_finite @ nat @ A3 )
                & ( member @ nat @ ( zero_zero @ nat ) @ A3 ) )
           => ( ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I4: nat] : ( times_times @ A @ ( C2 @ I4 ) @ ( power_power @ A @ ( zero_zero @ A ) @ I4 ) )
                @ A3 )
              = ( zero_zero @ A ) ) ) ) ) ).

% sum_zero_power
thf(fact_4748_sum__zero__power_H,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A3: set @ nat,C2: nat > A,D2: nat > A] :
          ( ( ( ( finite_finite @ nat @ A3 )
              & ( member @ nat @ ( zero_zero @ nat ) @ A3 ) )
           => ( ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I4: nat] : ( divide_divide @ A @ ( times_times @ A @ ( C2 @ I4 ) @ ( power_power @ A @ ( zero_zero @ A ) @ I4 ) ) @ ( D2 @ I4 ) )
                @ A3 )
              = ( divide_divide @ A @ ( C2 @ ( zero_zero @ nat ) ) @ ( D2 @ ( zero_zero @ nat ) ) ) ) )
          & ( ~ ( ( finite_finite @ nat @ A3 )
                & ( member @ nat @ ( zero_zero @ nat ) @ A3 ) )
           => ( ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I4: nat] : ( divide_divide @ A @ ( times_times @ A @ ( C2 @ I4 ) @ ( power_power @ A @ ( zero_zero @ A ) @ I4 ) ) @ ( D2 @ I4 ) )
                @ A3 )
              = ( zero_zero @ A ) ) ) ) ) ).

% sum_zero_power'
thf(fact_4749_finite__lists__length__eq,axiom,
    ! [A: $tType,A3: set @ A,N2: nat] :
      ( ( finite_finite @ A @ A3 )
     => ( finite_finite @ ( list @ A )
        @ ( collect @ ( list @ A )
          @ ^ [Xs3: list @ A] :
              ( ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ Xs3 ) @ A3 )
              & ( ( size_size @ ( list @ A ) @ Xs3 )
                = N2 ) ) ) ) ) ).

% finite_lists_length_eq
thf(fact_4750_finite__M__bounded__by__nat,axiom,
    ! [P: nat > $o,I3: nat] :
      ( finite_finite @ nat
      @ ( collect @ nat
        @ ^ [K3: nat] :
            ( ( P @ K3 )
            & ( ord_less @ nat @ K3 @ I3 ) ) ) ) ).

% finite_M_bounded_by_nat
thf(fact_4751_finite__less__ub,axiom,
    ! [F2: nat > nat,U: nat] :
      ( ! [N: nat] : ( ord_less_eq @ nat @ N @ ( F2 @ N ) )
     => ( finite_finite @ nat
        @ ( collect @ nat
          @ ^ [N3: nat] : ( ord_less_eq @ nat @ ( F2 @ N3 ) @ U ) ) ) ) ).

% finite_less_ub
thf(fact_4752_finite__nat__set__iff__bounded,axiom,
    ( ( finite_finite @ nat )
    = ( ^ [N6: set @ nat] :
        ? [M6: nat] :
        ! [X5: nat] :
          ( ( member @ nat @ X5 @ N6 )
         => ( ord_less @ nat @ X5 @ M6 ) ) ) ) ).

% finite_nat_set_iff_bounded
thf(fact_4753_bounded__nat__set__is__finite,axiom,
    ! [N4: set @ nat,N2: nat] :
      ( ! [X3: nat] :
          ( ( member @ nat @ X3 @ N4 )
         => ( ord_less @ nat @ X3 @ N2 ) )
     => ( finite_finite @ nat @ N4 ) ) ).

% bounded_nat_set_is_finite
thf(fact_4754_finite__nat__set__iff__bounded__le,axiom,
    ( ( finite_finite @ nat )
    = ( ^ [N6: set @ nat] :
        ? [M6: nat] :
        ! [X5: nat] :
          ( ( member @ nat @ X5 @ N6 )
         => ( ord_less_eq @ nat @ X5 @ M6 ) ) ) ) ).

% finite_nat_set_iff_bounded_le
thf(fact_4755_finite__list,axiom,
    ! [A: $tType,A3: set @ A] :
      ( ( finite_finite @ A @ A3 )
     => ? [Xs2: list @ A] :
          ( ( set2 @ A @ Xs2 )
          = A3 ) ) ).

% finite_list
thf(fact_4756_infinite__growing,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X8: set @ A] :
          ( ( X8
           != ( bot_bot @ ( set @ A ) ) )
         => ( ! [X3: A] :
                ( ( member @ A @ X3 @ X8 )
               => ? [Xa: A] :
                    ( ( member @ A @ Xa @ X8 )
                    & ( ord_less @ A @ X3 @ Xa ) ) )
           => ~ ( finite_finite @ A @ X8 ) ) ) ) ).

% infinite_growing
thf(fact_4757_ex__min__if__finite,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [S3: set @ A] :
          ( ( finite_finite @ A @ S3 )
         => ( ( S3
             != ( bot_bot @ ( set @ A ) ) )
           => ? [X3: A] :
                ( ( member @ A @ X3 @ S3 )
                & ~ ? [Xa: A] :
                      ( ( member @ A @ Xa @ S3 )
                      & ( ord_less @ A @ Xa @ X3 ) ) ) ) ) ) ).

% ex_min_if_finite
thf(fact_4758_sum__mono__inv,axiom,
    ! [A: $tType,I7: $tType] :
      ( ( ordere8940638589300402666id_add @ A )
     => ! [F2: I7 > A,I6: set @ I7,G: I7 > A,I3: I7] :
          ( ( ( groups7311177749621191930dd_sum @ I7 @ A @ F2 @ I6 )
            = ( groups7311177749621191930dd_sum @ I7 @ A @ G @ I6 ) )
         => ( ! [I2: I7] :
                ( ( member @ I7 @ I2 @ I6 )
               => ( ord_less_eq @ A @ ( F2 @ I2 ) @ ( G @ I2 ) ) )
           => ( ( member @ I7 @ I3 @ I6 )
             => ( ( finite_finite @ I7 @ I6 )
               => ( ( F2 @ I3 )
                  = ( G @ I3 ) ) ) ) ) ) ) ).

% sum_mono_inv
thf(fact_4759_prod__zero,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [A3: set @ B,F2: B > A] :
          ( ( finite_finite @ B @ A3 )
         => ( ? [X: B] :
                ( ( member @ B @ X @ A3 )
                & ( ( F2 @ X )
                  = ( zero_zero @ A ) ) )
           => ( ( groups7121269368397514597t_prod @ B @ A @ F2 @ A3 )
              = ( zero_zero @ A ) ) ) ) ) ).

% prod_zero
thf(fact_4760_infinite__Icc,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ~ ( finite_finite @ A @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) ) ) ) ).

% infinite_Icc
thf(fact_4761_infinite__Ico,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ~ ( finite_finite @ A @ ( set_or7035219750837199246ssThan @ A @ A2 @ B2 ) ) ) ) ).

% infinite_Ico
thf(fact_4762_finite__lists__length__le,axiom,
    ! [A: $tType,A3: set @ A,N2: nat] :
      ( ( finite_finite @ A @ A3 )
     => ( finite_finite @ ( list @ A )
        @ ( collect @ ( list @ A )
          @ ^ [Xs3: list @ A] :
              ( ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ Xs3 ) @ A3 )
              & ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ Xs3 ) @ N2 ) ) ) ) ) ).

% finite_lists_length_le
thf(fact_4763_summable__finite,axiom,
    ! [A: $tType] :
      ( ( ( comm_monoid_add @ A )
        & ( topolo4958980785337419405_space @ A ) )
     => ! [N4: set @ nat,F2: nat > A] :
          ( ( finite_finite @ nat @ N4 )
         => ( ! [N: nat] :
                ( ~ ( member @ nat @ N @ N4 )
               => ( ( F2 @ N )
                  = ( zero_zero @ A ) ) )
           => ( summable @ A @ F2 ) ) ) ) ).

% summable_finite
thf(fact_4764_sum_Ofinite__Collect__op,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [I6: set @ B,X2: B > A,Y2: B > A] :
          ( ( finite_finite @ B
            @ ( collect @ B
              @ ^ [I4: B] :
                  ( ( member @ B @ I4 @ I6 )
                  & ( ( X2 @ I4 )
                   != ( zero_zero @ A ) ) ) ) )
         => ( ( finite_finite @ B
              @ ( collect @ B
                @ ^ [I4: B] :
                    ( ( member @ B @ I4 @ I6 )
                    & ( ( Y2 @ I4 )
                     != ( zero_zero @ A ) ) ) ) )
           => ( finite_finite @ B
              @ ( collect @ B
                @ ^ [I4: B] :
                    ( ( member @ B @ I4 @ I6 )
                    & ( ( plus_plus @ A @ ( X2 @ I4 ) @ ( Y2 @ I4 ) )
                     != ( zero_zero @ A ) ) ) ) ) ) ) ) ).

% sum.finite_Collect_op
thf(fact_4765_prod_Ofinite__Collect__op,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [I6: set @ B,X2: B > A,Y2: B > A] :
          ( ( finite_finite @ B
            @ ( collect @ B
              @ ^ [I4: B] :
                  ( ( member @ B @ I4 @ I6 )
                  & ( ( X2 @ I4 )
                   != ( one_one @ A ) ) ) ) )
         => ( ( finite_finite @ B
              @ ( collect @ B
                @ ^ [I4: B] :
                    ( ( member @ B @ I4 @ I6 )
                    & ( ( Y2 @ I4 )
                     != ( one_one @ A ) ) ) ) )
           => ( finite_finite @ B
              @ ( collect @ B
                @ ^ [I4: B] :
                    ( ( member @ B @ I4 @ I6 )
                    & ( ( times_times @ A @ ( X2 @ I4 ) @ ( Y2 @ I4 ) )
                     != ( one_one @ A ) ) ) ) ) ) ) ) ).

% prod.finite_Collect_op
thf(fact_4766_sum_Ointer__filter,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A3: set @ B,G: B > A,P: B > $o] :
          ( ( finite_finite @ B @ A3 )
         => ( ( groups7311177749621191930dd_sum @ B @ A @ G
              @ ( collect @ B
                @ ^ [X5: B] :
                    ( ( member @ B @ X5 @ A3 )
                    & ( P @ X5 ) ) ) )
            = ( groups7311177749621191930dd_sum @ B @ A
              @ ^ [X5: B] : ( if @ A @ ( P @ X5 ) @ ( G @ X5 ) @ ( zero_zero @ A ) )
              @ A3 ) ) ) ) ).

% sum.inter_filter
thf(fact_4767_set__encode__inf,axiom,
    ! [A3: set @ nat] :
      ( ~ ( finite_finite @ nat @ A3 )
     => ( ( nat_set_encode @ A3 )
        = ( zero_zero @ nat ) ) ) ).

% set_encode_inf
thf(fact_4768_prod_Ointer__filter,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A3: set @ B,G: B > A,P: B > $o] :
          ( ( finite_finite @ B @ A3 )
         => ( ( groups7121269368397514597t_prod @ B @ A @ G
              @ ( collect @ B
                @ ^ [X5: B] :
                    ( ( member @ B @ X5 @ A3 )
                    & ( P @ X5 ) ) ) )
            = ( groups7121269368397514597t_prod @ B @ A
              @ ^ [X5: B] : ( if @ A @ ( P @ X5 ) @ ( G @ X5 ) @ ( one_one @ A ) )
              @ A3 ) ) ) ) ).

% prod.inter_filter
thf(fact_4769_finite__int__segment,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [A2: A,B2: A] :
          ( finite_finite @ A
          @ ( collect @ A
            @ ^ [X5: A] :
                ( ( member @ A @ X5 @ ( ring_1_Ints @ A ) )
                & ( ord_less_eq @ A @ A2 @ X5 )
                & ( ord_less_eq @ A @ X5 @ B2 ) ) ) ) ) ).

% finite_int_segment
thf(fact_4770_size__list__estimation,axiom,
    ! [A: $tType,X2: A,Xs: list @ A,Y2: nat,F2: A > nat] :
      ( ( member @ A @ X2 @ ( set2 @ A @ Xs ) )
     => ( ( ord_less @ nat @ Y2 @ ( F2 @ X2 ) )
       => ( ord_less @ nat @ Y2 @ ( size_list @ A @ F2 @ Xs ) ) ) ) ).

% size_list_estimation
thf(fact_4771_size__list__estimation_H,axiom,
    ! [A: $tType,X2: A,Xs: list @ A,Y2: nat,F2: A > nat] :
      ( ( member @ A @ X2 @ ( set2 @ A @ Xs ) )
     => ( ( ord_less_eq @ nat @ Y2 @ ( F2 @ X2 ) )
       => ( ord_less_eq @ nat @ Y2 @ ( size_list @ A @ F2 @ Xs ) ) ) ) ).

% size_list_estimation'
thf(fact_4772_size__list__pointwise,axiom,
    ! [A: $tType,Xs: list @ A,F2: A > nat,G: A > nat] :
      ( ! [X3: A] :
          ( ( member @ A @ X3 @ ( set2 @ A @ Xs ) )
         => ( ord_less_eq @ nat @ ( F2 @ X3 ) @ ( G @ X3 ) ) )
     => ( ord_less_eq @ nat @ ( size_list @ A @ F2 @ Xs ) @ ( size_list @ A @ G @ Xs ) ) ) ).

% size_list_pointwise
thf(fact_4773_sum__nonneg__eq__0__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [A3: set @ B,F2: B > A] :
          ( ( finite_finite @ B @ A3 )
         => ( ! [X3: B] :
                ( ( member @ B @ X3 @ A3 )
               => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( F2 @ X3 ) ) )
           => ( ( ( groups7311177749621191930dd_sum @ B @ A @ F2 @ A3 )
                = ( zero_zero @ A ) )
              = ( ! [X5: B] :
                    ( ( member @ B @ X5 @ A3 )
                   => ( ( F2 @ X5 )
                      = ( zero_zero @ A ) ) ) ) ) ) ) ) ).

% sum_nonneg_eq_0_iff
thf(fact_4774_sum__le__included,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [S2: set @ B,T2: set @ C,G: C > A,I3: C > B,F2: B > A] :
          ( ( finite_finite @ B @ S2 )
         => ( ( finite_finite @ C @ T2 )
           => ( ! [X3: C] :
                  ( ( member @ C @ X3 @ T2 )
                 => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( G @ X3 ) ) )
             => ( ! [X3: B] :
                    ( ( member @ B @ X3 @ S2 )
                   => ? [Xa: C] :
                        ( ( member @ C @ Xa @ T2 )
                        & ( ( I3 @ Xa )
                          = X3 )
                        & ( ord_less_eq @ A @ ( F2 @ X3 ) @ ( G @ Xa ) ) ) )
               => ( ord_less_eq @ A @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ S2 ) @ ( groups7311177749621191930dd_sum @ C @ A @ G @ T2 ) ) ) ) ) ) ) ).

% sum_le_included
thf(fact_4775_sum__strict__mono__ex1,axiom,
    ! [A: $tType,I7: $tType] :
      ( ( ordere8940638589300402666id_add @ A )
     => ! [A3: set @ I7,F2: I7 > A,G: I7 > A] :
          ( ( finite_finite @ I7 @ A3 )
         => ( ! [X3: I7] :
                ( ( member @ I7 @ X3 @ A3 )
               => ( ord_less_eq @ A @ ( F2 @ X3 ) @ ( G @ X3 ) ) )
           => ( ? [X: I7] :
                  ( ( member @ I7 @ X @ A3 )
                  & ( ord_less @ A @ ( F2 @ X ) @ ( G @ X ) ) )
             => ( ord_less @ A @ ( groups7311177749621191930dd_sum @ I7 @ A @ F2 @ A3 ) @ ( groups7311177749621191930dd_sum @ I7 @ A @ G @ A3 ) ) ) ) ) ) ).

% sum_strict_mono_ex1
thf(fact_4776_sum_Orelated,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [R: A > A > $o,S3: set @ B,H2: B > A,G: B > A] :
          ( ( R @ ( zero_zero @ A ) @ ( zero_zero @ A ) )
         => ( ! [X15: A,Y15: A,X23: A,Y23: A] :
                ( ( ( R @ X15 @ X23 )
                  & ( R @ Y15 @ Y23 ) )
               => ( R @ ( plus_plus @ A @ X15 @ Y15 ) @ ( plus_plus @ A @ X23 @ Y23 ) ) )
           => ( ( finite_finite @ B @ S3 )
             => ( ! [X3: B] :
                    ( ( member @ B @ X3 @ S3 )
                   => ( R @ ( H2 @ X3 ) @ ( G @ X3 ) ) )
               => ( R @ ( groups7311177749621191930dd_sum @ B @ A @ H2 @ S3 ) @ ( groups7311177749621191930dd_sum @ B @ A @ G @ S3 ) ) ) ) ) ) ) ).

% sum.related
thf(fact_4777_finite__ranking__induct,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [S3: set @ B,P: ( set @ B ) > $o,F2: B > A] :
          ( ( finite_finite @ B @ S3 )
         => ( ( P @ ( bot_bot @ ( set @ B ) ) )
           => ( ! [X3: B,S4: set @ B] :
                  ( ( finite_finite @ B @ S4 )
                 => ( ! [Y: B] :
                        ( ( member @ B @ Y @ S4 )
                       => ( ord_less_eq @ A @ ( F2 @ Y ) @ ( F2 @ X3 ) ) )
                   => ( ( P @ S4 )
                     => ( P @ ( insert @ B @ X3 @ S4 ) ) ) ) )
             => ( P @ S3 ) ) ) ) ) ).

% finite_ranking_induct
thf(fact_4778_finite__linorder__max__induct,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A,P: ( set @ A ) > $o] :
          ( ( finite_finite @ A @ A3 )
         => ( ( P @ ( bot_bot @ ( set @ A ) ) )
           => ( ! [B5: A,A8: set @ A] :
                  ( ( finite_finite @ A @ A8 )
                 => ( ! [X: A] :
                        ( ( member @ A @ X @ A8 )
                       => ( ord_less @ A @ X @ B5 ) )
                   => ( ( P @ A8 )
                     => ( P @ ( insert @ A @ B5 @ A8 ) ) ) ) )
             => ( P @ A3 ) ) ) ) ) ).

% finite_linorder_max_induct
thf(fact_4779_finite__linorder__min__induct,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A,P: ( set @ A ) > $o] :
          ( ( finite_finite @ A @ A3 )
         => ( ( P @ ( bot_bot @ ( set @ A ) ) )
           => ( ! [B5: A,A8: set @ A] :
                  ( ( finite_finite @ A @ A8 )
                 => ( ! [X: A] :
                        ( ( member @ A @ X @ A8 )
                       => ( ord_less @ A @ B5 @ X ) )
                   => ( ( P @ A8 )
                     => ( P @ ( insert @ A @ B5 @ A8 ) ) ) ) )
             => ( P @ A3 ) ) ) ) ) ).

% finite_linorder_min_induct
thf(fact_4780_sum__strict__mono,axiom,
    ! [A: $tType,B: $tType] :
      ( ( strict7427464778891057005id_add @ A )
     => ! [A3: set @ B,F2: B > A,G: B > A] :
          ( ( finite_finite @ B @ A3 )
         => ( ( A3
             != ( bot_bot @ ( set @ B ) ) )
           => ( ! [X3: B] :
                  ( ( member @ B @ X3 @ A3 )
                 => ( ord_less @ A @ ( F2 @ X3 ) @ ( G @ X3 ) ) )
             => ( ord_less @ A @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ A3 ) @ ( groups7311177749621191930dd_sum @ B @ A @ G @ A3 ) ) ) ) ) ) ).

% sum_strict_mono
thf(fact_4781_prod_Orelated,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [R: A > A > $o,S3: set @ B,H2: B > A,G: B > A] :
          ( ( R @ ( one_one @ A ) @ ( one_one @ A ) )
         => ( ! [X15: A,Y15: A,X23: A,Y23: A] :
                ( ( ( R @ X15 @ X23 )
                  & ( R @ Y15 @ Y23 ) )
               => ( R @ ( times_times @ A @ X15 @ Y15 ) @ ( times_times @ A @ X23 @ Y23 ) ) )
           => ( ( finite_finite @ B @ S3 )
             => ( ! [X3: B] :
                    ( ( member @ B @ X3 @ S3 )
                   => ( R @ ( H2 @ X3 ) @ ( G @ X3 ) ) )
               => ( R @ ( groups7121269368397514597t_prod @ B @ A @ H2 @ S3 ) @ ( groups7121269368397514597t_prod @ B @ A @ G @ S3 ) ) ) ) ) ) ) ).

% prod.related
thf(fact_4782_sum_Oinsert__if,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A3: set @ B,X2: B,G: B > A] :
          ( ( finite_finite @ B @ A3 )
         => ( ( ( member @ B @ X2 @ A3 )
             => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ ( insert @ B @ X2 @ A3 ) )
                = ( groups7311177749621191930dd_sum @ B @ A @ G @ A3 ) ) )
            & ( ~ ( member @ B @ X2 @ A3 )
             => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ ( insert @ B @ X2 @ A3 ) )
                = ( plus_plus @ A @ ( G @ X2 ) @ ( groups7311177749621191930dd_sum @ B @ A @ G @ A3 ) ) ) ) ) ) ) ).

% sum.insert_if
thf(fact_4783_sum_Oreindex__bij__witness__not__neutral,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [S5: set @ B,T5: set @ C,S3: set @ B,I3: C > B,J: B > C,T6: set @ C,G: B > A,H2: C > A] :
          ( ( finite_finite @ B @ S5 )
         => ( ( finite_finite @ C @ T5 )
           => ( ! [A5: B] :
                  ( ( member @ B @ A5 @ ( minus_minus @ ( set @ B ) @ S3 @ S5 ) )
                 => ( ( I3 @ ( J @ A5 ) )
                    = A5 ) )
             => ( ! [A5: B] :
                    ( ( member @ B @ A5 @ ( minus_minus @ ( set @ B ) @ S3 @ S5 ) )
                   => ( member @ C @ ( J @ A5 ) @ ( minus_minus @ ( set @ C ) @ T6 @ T5 ) ) )
               => ( ! [B5: C] :
                      ( ( member @ C @ B5 @ ( minus_minus @ ( set @ C ) @ T6 @ T5 ) )
                     => ( ( J @ ( I3 @ B5 ) )
                        = B5 ) )
                 => ( ! [B5: C] :
                        ( ( member @ C @ B5 @ ( minus_minus @ ( set @ C ) @ T6 @ T5 ) )
                       => ( member @ B @ ( I3 @ B5 ) @ ( minus_minus @ ( set @ B ) @ S3 @ S5 ) ) )
                   => ( ! [A5: B] :
                          ( ( member @ B @ A5 @ S5 )
                         => ( ( G @ A5 )
                            = ( zero_zero @ A ) ) )
                     => ( ! [B5: C] :
                            ( ( member @ C @ B5 @ T5 )
                           => ( ( H2 @ B5 )
                              = ( zero_zero @ A ) ) )
                       => ( ! [A5: B] :
                              ( ( member @ B @ A5 @ S3 )
                             => ( ( H2 @ ( J @ A5 ) )
                                = ( G @ A5 ) ) )
                         => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ S3 )
                            = ( groups7311177749621191930dd_sum @ C @ A @ H2 @ T6 ) ) ) ) ) ) ) ) ) ) ) ) ).

% sum.reindex_bij_witness_not_neutral
thf(fact_4784_prod_Oinsert__if,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A3: set @ B,X2: B,G: B > A] :
          ( ( finite_finite @ B @ A3 )
         => ( ( ( member @ B @ X2 @ A3 )
             => ( ( groups7121269368397514597t_prod @ B @ A @ G @ ( insert @ B @ X2 @ A3 ) )
                = ( groups7121269368397514597t_prod @ B @ A @ G @ A3 ) ) )
            & ( ~ ( member @ B @ X2 @ A3 )
             => ( ( groups7121269368397514597t_prod @ B @ A @ G @ ( insert @ B @ X2 @ A3 ) )
                = ( times_times @ A @ ( G @ X2 ) @ ( groups7121269368397514597t_prod @ B @ A @ G @ A3 ) ) ) ) ) ) ) ).

% prod.insert_if
thf(fact_4785_prod__dvd__prod__subset,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [B3: set @ B,A3: set @ B,F2: B > A] :
          ( ( finite_finite @ B @ B3 )
         => ( ( ord_less_eq @ ( set @ B ) @ A3 @ B3 )
           => ( dvd_dvd @ A @ ( groups7121269368397514597t_prod @ B @ A @ F2 @ A3 ) @ ( groups7121269368397514597t_prod @ B @ A @ F2 @ B3 ) ) ) ) ) ).

% prod_dvd_prod_subset
thf(fact_4786_prod__dvd__prod__subset2,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [B3: set @ B,A3: set @ B,F2: B > A,G: B > A] :
          ( ( finite_finite @ B @ B3 )
         => ( ( ord_less_eq @ ( set @ B ) @ A3 @ B3 )
           => ( ! [A5: B] :
                  ( ( member @ B @ A5 @ A3 )
                 => ( dvd_dvd @ A @ ( F2 @ A5 ) @ ( G @ A5 ) ) )
             => ( dvd_dvd @ A @ ( groups7121269368397514597t_prod @ B @ A @ F2 @ A3 ) @ ( groups7121269368397514597t_prod @ B @ A @ G @ B3 ) ) ) ) ) ) ).

% prod_dvd_prod_subset2
thf(fact_4787_prod_Oreindex__bij__witness__not__neutral,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [S5: set @ B,T5: set @ C,S3: set @ B,I3: C > B,J: B > C,T6: set @ C,G: B > A,H2: C > A] :
          ( ( finite_finite @ B @ S5 )
         => ( ( finite_finite @ C @ T5 )
           => ( ! [A5: B] :
                  ( ( member @ B @ A5 @ ( minus_minus @ ( set @ B ) @ S3 @ S5 ) )
                 => ( ( I3 @ ( J @ A5 ) )
                    = A5 ) )
             => ( ! [A5: B] :
                    ( ( member @ B @ A5 @ ( minus_minus @ ( set @ B ) @ S3 @ S5 ) )
                   => ( member @ C @ ( J @ A5 ) @ ( minus_minus @ ( set @ C ) @ T6 @ T5 ) ) )
               => ( ! [B5: C] :
                      ( ( member @ C @ B5 @ ( minus_minus @ ( set @ C ) @ T6 @ T5 ) )
                     => ( ( J @ ( I3 @ B5 ) )
                        = B5 ) )
                 => ( ! [B5: C] :
                        ( ( member @ C @ B5 @ ( minus_minus @ ( set @ C ) @ T6 @ T5 ) )
                       => ( member @ B @ ( I3 @ B5 ) @ ( minus_minus @ ( set @ B ) @ S3 @ S5 ) ) )
                   => ( ! [A5: B] :
                          ( ( member @ B @ A5 @ S5 )
                         => ( ( G @ A5 )
                            = ( one_one @ A ) ) )
                     => ( ! [B5: C] :
                            ( ( member @ C @ B5 @ T5 )
                           => ( ( H2 @ B5 )
                              = ( one_one @ A ) ) )
                       => ( ! [A5: B] :
                              ( ( member @ B @ A5 @ S3 )
                             => ( ( H2 @ ( J @ A5 ) )
                                = ( G @ A5 ) ) )
                         => ( ( groups7121269368397514597t_prod @ B @ A @ G @ S3 )
                            = ( groups7121269368397514597t_prod @ C @ A @ H2 @ T6 ) ) ) ) ) ) ) ) ) ) ) ) ).

% prod.reindex_bij_witness_not_neutral
thf(fact_4788_sum__eq__Suc0__iff,axiom,
    ! [A: $tType,A3: set @ A,F2: A > nat] :
      ( ( finite_finite @ A @ A3 )
     => ( ( ( groups7311177749621191930dd_sum @ A @ nat @ F2 @ A3 )
          = ( suc @ ( zero_zero @ nat ) ) )
        = ( ? [X5: A] :
              ( ( member @ A @ X5 @ A3 )
              & ( ( F2 @ X5 )
                = ( suc @ ( zero_zero @ nat ) ) )
              & ! [Y5: A] :
                  ( ( member @ A @ Y5 @ A3 )
                 => ( ( X5 != Y5 )
                   => ( ( F2 @ Y5 )
                      = ( zero_zero @ nat ) ) ) ) ) ) ) ) ).

% sum_eq_Suc0_iff
thf(fact_4789_sum__eq__1__iff,axiom,
    ! [A: $tType,A3: set @ A,F2: A > nat] :
      ( ( finite_finite @ A @ A3 )
     => ( ( ( groups7311177749621191930dd_sum @ A @ nat @ F2 @ A3 )
          = ( one_one @ nat ) )
        = ( ? [X5: A] :
              ( ( member @ A @ X5 @ A3 )
              & ( ( F2 @ X5 )
                = ( one_one @ nat ) )
              & ! [Y5: A] :
                  ( ( member @ A @ Y5 @ A3 )
                 => ( ( X5 != Y5 )
                   => ( ( F2 @ Y5 )
                      = ( zero_zero @ nat ) ) ) ) ) ) ) ) ).

% sum_eq_1_iff
thf(fact_4790_sum__nonneg__leq__bound,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [S2: set @ B,F2: B > A,B3: A,I3: B] :
          ( ( finite_finite @ B @ S2 )
         => ( ! [I2: B] :
                ( ( member @ B @ I2 @ S2 )
               => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( F2 @ I2 ) ) )
           => ( ( ( groups7311177749621191930dd_sum @ B @ A @ F2 @ S2 )
                = B3 )
             => ( ( member @ B @ I3 @ S2 )
               => ( ord_less_eq @ A @ ( F2 @ I3 ) @ B3 ) ) ) ) ) ) ).

% sum_nonneg_leq_bound
thf(fact_4791_sum__nonneg__0,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [S2: set @ B,F2: B > A,I3: B] :
          ( ( finite_finite @ B @ S2 )
         => ( ! [I2: B] :
                ( ( member @ B @ I2 @ S2 )
               => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( F2 @ I2 ) ) )
           => ( ( ( groups7311177749621191930dd_sum @ B @ A @ F2 @ S2 )
                = ( zero_zero @ A ) )
             => ( ( member @ B @ I3 @ S2 )
               => ( ( F2 @ I3 )
                  = ( zero_zero @ A ) ) ) ) ) ) ) ).

% sum_nonneg_0
thf(fact_4792_sum_Osetdiff__irrelevant,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A3: set @ B,G: B > A] :
          ( ( finite_finite @ B @ A3 )
         => ( ( groups7311177749621191930dd_sum @ B @ A @ G
              @ ( minus_minus @ ( set @ B ) @ A3
                @ ( collect @ B
                  @ ^ [X5: B] :
                      ( ( G @ X5 )
                      = ( zero_zero @ A ) ) ) ) )
            = ( groups7311177749621191930dd_sum @ B @ A @ G @ A3 ) ) ) ) ).

% sum.setdiff_irrelevant
thf(fact_4793_finite__divisors__nat,axiom,
    ! [M: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M )
     => ( finite_finite @ nat
        @ ( collect @ nat
          @ ^ [D3: nat] : ( dvd_dvd @ nat @ D3 @ M ) ) ) ) ).

% finite_divisors_nat
thf(fact_4794_prod_Osetdiff__irrelevant,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A3: set @ B,G: B > A] :
          ( ( finite_finite @ B @ A3 )
         => ( ( groups7121269368397514597t_prod @ B @ A @ G
              @ ( minus_minus @ ( set @ B ) @ A3
                @ ( collect @ B
                  @ ^ [X5: B] :
                      ( ( G @ X5 )
                      = ( one_one @ A ) ) ) ) )
            = ( groups7121269368397514597t_prod @ B @ A @ G @ A3 ) ) ) ) ).

% prod.setdiff_irrelevant
thf(fact_4795_sums__finite,axiom,
    ! [A: $tType] :
      ( ( ( comm_monoid_add @ A )
        & ( topolo4958980785337419405_space @ A ) )
     => ! [N4: set @ nat,F2: nat > A] :
          ( ( finite_finite @ nat @ N4 )
         => ( ! [N: nat] :
                ( ~ ( member @ nat @ N @ N4 )
               => ( ( F2 @ N )
                  = ( zero_zero @ A ) ) )
           => ( sums @ A @ F2 @ ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ N4 ) ) ) ) ) ).

% sums_finite
thf(fact_4796_sums__If__finite,axiom,
    ! [A: $tType] :
      ( ( ( comm_monoid_add @ A )
        & ( topolo4958980785337419405_space @ A ) )
     => ! [P: nat > $o,F2: nat > A] :
          ( ( finite_finite @ nat @ ( collect @ nat @ P ) )
         => ( sums @ A
            @ ^ [R5: nat] : ( if @ A @ ( P @ R5 ) @ ( F2 @ R5 ) @ ( zero_zero @ A ) )
            @ ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( collect @ nat @ P ) ) ) ) ) ).

% sums_If_finite
thf(fact_4797_sums__If__finite__set,axiom,
    ! [A: $tType] :
      ( ( ( comm_monoid_add @ A )
        & ( topolo4958980785337419405_space @ A ) )
     => ! [A3: set @ nat,F2: nat > A] :
          ( ( finite_finite @ nat @ A3 )
         => ( sums @ A
            @ ^ [R5: nat] : ( if @ A @ ( member @ nat @ R5 @ A3 ) @ ( F2 @ R5 ) @ ( zero_zero @ A ) )
            @ ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ A3 ) ) ) ) ).

% sums_If_finite_set
thf(fact_4798_suminf__finite,axiom,
    ! [A: $tType] :
      ( ( ( comm_monoid_add @ A )
        & ( topological_t2_space @ A ) )
     => ! [N4: set @ nat,F2: nat > A] :
          ( ( finite_finite @ nat @ N4 )
         => ( ! [N: nat] :
                ( ~ ( member @ nat @ N @ N4 )
               => ( ( F2 @ N )
                  = ( zero_zero @ A ) ) )
           => ( ( suminf @ A @ F2 )
              = ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ N4 ) ) ) ) ) ).

% suminf_finite
thf(fact_4799_finite__abs__int__segment,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [A2: A] :
          ( finite_finite @ A
          @ ( collect @ A
            @ ^ [K3: A] :
                ( ( member @ A @ K3 @ ( ring_1_Ints @ A ) )
                & ( ord_less_eq @ A @ ( abs_abs @ A @ K3 ) @ A2 ) ) ) ) ) ).

% finite_abs_int_segment
thf(fact_4800_subset__eq__atLeast0__atMost__finite,axiom,
    ! [N4: set @ nat,N2: nat] :
      ( ( ord_less_eq @ ( set @ nat ) @ N4 @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N2 ) )
     => ( finite_finite @ nat @ N4 ) ) ).

% subset_eq_atLeast0_atMost_finite
thf(fact_4801_subset__eq__atLeast0__lessThan__finite,axiom,
    ! [N4: set @ nat,N2: nat] :
      ( ( ord_less_eq @ ( set @ nat ) @ N4 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N2 ) )
     => ( finite_finite @ nat @ N4 ) ) ).

% subset_eq_atLeast0_lessThan_finite
thf(fact_4802_sum__pos2,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [I6: set @ B,I3: B,F2: B > A] :
          ( ( finite_finite @ B @ I6 )
         => ( ( member @ B @ I3 @ I6 )
           => ( ( ord_less @ A @ ( zero_zero @ A ) @ ( F2 @ I3 ) )
             => ( ! [I2: B] :
                    ( ( member @ B @ I2 @ I6 )
                   => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( F2 @ I2 ) ) )
               => ( ord_less @ A @ ( zero_zero @ A ) @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ I6 ) ) ) ) ) ) ) ).

% sum_pos2
thf(fact_4803_sum__pos,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [I6: set @ B,F2: B > A] :
          ( ( finite_finite @ B @ I6 )
         => ( ( I6
             != ( bot_bot @ ( set @ B ) ) )
           => ( ! [I2: B] :
                  ( ( member @ B @ I2 @ I6 )
                 => ( ord_less @ A @ ( zero_zero @ A ) @ ( F2 @ I2 ) ) )
             => ( ord_less @ A @ ( zero_zero @ A ) @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ I6 ) ) ) ) ) ) ).

% sum_pos
thf(fact_4804_less__1__prod2,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linordered_idom @ B )
     => ! [I6: set @ A,I3: A,F2: A > B] :
          ( ( finite_finite @ A @ I6 )
         => ( ( member @ A @ I3 @ I6 )
           => ( ( ord_less @ B @ ( one_one @ B ) @ ( F2 @ I3 ) )
             => ( ! [I2: A] :
                    ( ( member @ A @ I2 @ I6 )
                   => ( ord_less_eq @ B @ ( one_one @ B ) @ ( F2 @ I2 ) ) )
               => ( ord_less @ B @ ( one_one @ B ) @ ( groups7121269368397514597t_prod @ A @ B @ F2 @ I6 ) ) ) ) ) ) ) ).

% less_1_prod2
thf(fact_4805_less__1__prod,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linordered_idom @ B )
     => ! [I6: set @ A,F2: A > B] :
          ( ( finite_finite @ A @ I6 )
         => ( ( I6
             != ( bot_bot @ ( set @ A ) ) )
           => ( ! [I2: A] :
                  ( ( member @ A @ I2 @ I6 )
                 => ( ord_less @ B @ ( one_one @ B ) @ ( F2 @ I2 ) ) )
             => ( ord_less @ B @ ( one_one @ B ) @ ( groups7121269368397514597t_prod @ A @ B @ F2 @ I6 ) ) ) ) ) ) ).

% less_1_prod
thf(fact_4806_sum_Osame__carrier,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [C6: set @ B,A3: set @ B,B3: set @ B,G: B > A,H2: B > A] :
          ( ( finite_finite @ B @ C6 )
         => ( ( ord_less_eq @ ( set @ B ) @ A3 @ C6 )
           => ( ( ord_less_eq @ ( set @ B ) @ B3 @ C6 )
             => ( ! [A5: B] :
                    ( ( member @ B @ A5 @ ( minus_minus @ ( set @ B ) @ C6 @ A3 ) )
                   => ( ( G @ A5 )
                      = ( zero_zero @ A ) ) )
               => ( ! [B5: B] :
                      ( ( member @ B @ B5 @ ( minus_minus @ ( set @ B ) @ C6 @ B3 ) )
                     => ( ( H2 @ B5 )
                        = ( zero_zero @ A ) ) )
                 => ( ( ( groups7311177749621191930dd_sum @ B @ A @ G @ A3 )
                      = ( groups7311177749621191930dd_sum @ B @ A @ H2 @ B3 ) )
                    = ( ( groups7311177749621191930dd_sum @ B @ A @ G @ C6 )
                      = ( groups7311177749621191930dd_sum @ B @ A @ H2 @ C6 ) ) ) ) ) ) ) ) ) ).

% sum.same_carrier
thf(fact_4807_sum_Osame__carrierI,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [C6: set @ B,A3: set @ B,B3: set @ B,G: B > A,H2: B > A] :
          ( ( finite_finite @ B @ C6 )
         => ( ( ord_less_eq @ ( set @ B ) @ A3 @ C6 )
           => ( ( ord_less_eq @ ( set @ B ) @ B3 @ C6 )
             => ( ! [A5: B] :
                    ( ( member @ B @ A5 @ ( minus_minus @ ( set @ B ) @ C6 @ A3 ) )
                   => ( ( G @ A5 )
                      = ( zero_zero @ A ) ) )
               => ( ! [B5: B] :
                      ( ( member @ B @ B5 @ ( minus_minus @ ( set @ B ) @ C6 @ B3 ) )
                     => ( ( H2 @ B5 )
                        = ( zero_zero @ A ) ) )
                 => ( ( ( groups7311177749621191930dd_sum @ B @ A @ G @ C6 )
                      = ( groups7311177749621191930dd_sum @ B @ A @ H2 @ C6 ) )
                   => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ A3 )
                      = ( groups7311177749621191930dd_sum @ B @ A @ H2 @ B3 ) ) ) ) ) ) ) ) ) ).

% sum.same_carrierI
thf(fact_4808_sum_Omono__neutral__left,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [T6: set @ B,S3: set @ B,G: B > A] :
          ( ( finite_finite @ B @ T6 )
         => ( ( ord_less_eq @ ( set @ B ) @ S3 @ T6 )
           => ( ! [X3: B] :
                  ( ( member @ B @ X3 @ ( minus_minus @ ( set @ B ) @ T6 @ S3 ) )
                 => ( ( G @ X3 )
                    = ( zero_zero @ A ) ) )
             => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ S3 )
                = ( groups7311177749621191930dd_sum @ B @ A @ G @ T6 ) ) ) ) ) ) ).

% sum.mono_neutral_left
thf(fact_4809_sum_Omono__neutral__right,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [T6: set @ B,S3: set @ B,G: B > A] :
          ( ( finite_finite @ B @ T6 )
         => ( ( ord_less_eq @ ( set @ B ) @ S3 @ T6 )
           => ( ! [X3: B] :
                  ( ( member @ B @ X3 @ ( minus_minus @ ( set @ B ) @ T6 @ S3 ) )
                 => ( ( G @ X3 )
                    = ( zero_zero @ A ) ) )
             => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ T6 )
                = ( groups7311177749621191930dd_sum @ B @ A @ G @ S3 ) ) ) ) ) ) ).

% sum.mono_neutral_right
thf(fact_4810_sum_Omono__neutral__cong__left,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [T6: set @ B,S3: set @ B,H2: B > A,G: B > A] :
          ( ( finite_finite @ B @ T6 )
         => ( ( ord_less_eq @ ( set @ B ) @ S3 @ T6 )
           => ( ! [X3: B] :
                  ( ( member @ B @ X3 @ ( minus_minus @ ( set @ B ) @ T6 @ S3 ) )
                 => ( ( H2 @ X3 )
                    = ( zero_zero @ A ) ) )
             => ( ! [X3: B] :
                    ( ( member @ B @ X3 @ S3 )
                   => ( ( G @ X3 )
                      = ( H2 @ X3 ) ) )
               => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ S3 )
                  = ( groups7311177749621191930dd_sum @ B @ A @ H2 @ T6 ) ) ) ) ) ) ) ).

% sum.mono_neutral_cong_left
thf(fact_4811_sum_Omono__neutral__cong__right,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [T6: set @ B,S3: set @ B,G: B > A,H2: B > A] :
          ( ( finite_finite @ B @ T6 )
         => ( ( ord_less_eq @ ( set @ B ) @ S3 @ T6 )
           => ( ! [X3: B] :
                  ( ( member @ B @ X3 @ ( minus_minus @ ( set @ B ) @ T6 @ S3 ) )
                 => ( ( G @ X3 )
                    = ( zero_zero @ A ) ) )
             => ( ! [X3: B] :
                    ( ( member @ B @ X3 @ S3 )
                   => ( ( G @ X3 )
                      = ( H2 @ X3 ) ) )
               => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ T6 )
                  = ( groups7311177749621191930dd_sum @ B @ A @ H2 @ S3 ) ) ) ) ) ) ) ).

% sum.mono_neutral_cong_right
thf(fact_4812_sum_Osubset__diff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [B3: set @ B,A3: set @ B,G: B > A] :
          ( ( ord_less_eq @ ( set @ B ) @ B3 @ A3 )
         => ( ( finite_finite @ B @ A3 )
           => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ A3 )
              = ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ B @ A @ G @ ( minus_minus @ ( set @ B ) @ A3 @ B3 ) ) @ ( groups7311177749621191930dd_sum @ B @ A @ G @ B3 ) ) ) ) ) ) ).

% sum.subset_diff
thf(fact_4813_sum__diff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ab_group_add @ A )
     => ! [A3: set @ B,B3: set @ B,F2: B > A] :
          ( ( finite_finite @ B @ A3 )
         => ( ( ord_less_eq @ ( set @ B ) @ B3 @ A3 )
           => ( ( groups7311177749621191930dd_sum @ B @ A @ F2 @ ( minus_minus @ ( set @ B ) @ A3 @ B3 ) )
              = ( minus_minus @ A @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ A3 ) @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ B3 ) ) ) ) ) ) ).

% sum_diff
thf(fact_4814_prod_Osubset__diff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [B3: set @ B,A3: set @ B,G: B > A] :
          ( ( ord_less_eq @ ( set @ B ) @ B3 @ A3 )
         => ( ( finite_finite @ B @ A3 )
           => ( ( groups7121269368397514597t_prod @ B @ A @ G @ A3 )
              = ( times_times @ A @ ( groups7121269368397514597t_prod @ B @ A @ G @ ( minus_minus @ ( set @ B ) @ A3 @ B3 ) ) @ ( groups7121269368397514597t_prod @ B @ A @ G @ B3 ) ) ) ) ) ) ).

% prod.subset_diff
thf(fact_4815_prod_Omono__neutral__cong__right,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [T6: set @ B,S3: set @ B,G: B > A,H2: B > A] :
          ( ( finite_finite @ B @ T6 )
         => ( ( ord_less_eq @ ( set @ B ) @ S3 @ T6 )
           => ( ! [X3: B] :
                  ( ( member @ B @ X3 @ ( minus_minus @ ( set @ B ) @ T6 @ S3 ) )
                 => ( ( G @ X3 )
                    = ( one_one @ A ) ) )
             => ( ! [X3: B] :
                    ( ( member @ B @ X3 @ S3 )
                   => ( ( G @ X3 )
                      = ( H2 @ X3 ) ) )
               => ( ( groups7121269368397514597t_prod @ B @ A @ G @ T6 )
                  = ( groups7121269368397514597t_prod @ B @ A @ H2 @ S3 ) ) ) ) ) ) ) ).

% prod.mono_neutral_cong_right
thf(fact_4816_prod_Omono__neutral__cong__left,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [T6: set @ B,S3: set @ B,H2: B > A,G: B > A] :
          ( ( finite_finite @ B @ T6 )
         => ( ( ord_less_eq @ ( set @ B ) @ S3 @ T6 )
           => ( ! [X3: B] :
                  ( ( member @ B @ X3 @ ( minus_minus @ ( set @ B ) @ T6 @ S3 ) )
                 => ( ( H2 @ X3 )
                    = ( one_one @ A ) ) )
             => ( ! [X3: B] :
                    ( ( member @ B @ X3 @ S3 )
                   => ( ( G @ X3 )
                      = ( H2 @ X3 ) ) )
               => ( ( groups7121269368397514597t_prod @ B @ A @ G @ S3 )
                  = ( groups7121269368397514597t_prod @ B @ A @ H2 @ T6 ) ) ) ) ) ) ) ).

% prod.mono_neutral_cong_left
thf(fact_4817_prod_Omono__neutral__right,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [T6: set @ B,S3: set @ B,G: B > A] :
          ( ( finite_finite @ B @ T6 )
         => ( ( ord_less_eq @ ( set @ B ) @ S3 @ T6 )
           => ( ! [X3: B] :
                  ( ( member @ B @ X3 @ ( minus_minus @ ( set @ B ) @ T6 @ S3 ) )
                 => ( ( G @ X3 )
                    = ( one_one @ A ) ) )
             => ( ( groups7121269368397514597t_prod @ B @ A @ G @ T6 )
                = ( groups7121269368397514597t_prod @ B @ A @ G @ S3 ) ) ) ) ) ) ).

% prod.mono_neutral_right
thf(fact_4818_prod_Omono__neutral__left,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [T6: set @ B,S3: set @ B,G: B > A] :
          ( ( finite_finite @ B @ T6 )
         => ( ( ord_less_eq @ ( set @ B ) @ S3 @ T6 )
           => ( ! [X3: B] :
                  ( ( member @ B @ X3 @ ( minus_minus @ ( set @ B ) @ T6 @ S3 ) )
                 => ( ( G @ X3 )
                    = ( one_one @ A ) ) )
             => ( ( groups7121269368397514597t_prod @ B @ A @ G @ S3 )
                = ( groups7121269368397514597t_prod @ B @ A @ G @ T6 ) ) ) ) ) ) ).

% prod.mono_neutral_left
thf(fact_4819_prod_Osame__carrierI,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [C6: set @ B,A3: set @ B,B3: set @ B,G: B > A,H2: B > A] :
          ( ( finite_finite @ B @ C6 )
         => ( ( ord_less_eq @ ( set @ B ) @ A3 @ C6 )
           => ( ( ord_less_eq @ ( set @ B ) @ B3 @ C6 )
             => ( ! [A5: B] :
                    ( ( member @ B @ A5 @ ( minus_minus @ ( set @ B ) @ C6 @ A3 ) )
                   => ( ( G @ A5 )
                      = ( one_one @ A ) ) )
               => ( ! [B5: B] :
                      ( ( member @ B @ B5 @ ( minus_minus @ ( set @ B ) @ C6 @ B3 ) )
                     => ( ( H2 @ B5 )
                        = ( one_one @ A ) ) )
                 => ( ( ( groups7121269368397514597t_prod @ B @ A @ G @ C6 )
                      = ( groups7121269368397514597t_prod @ B @ A @ H2 @ C6 ) )
                   => ( ( groups7121269368397514597t_prod @ B @ A @ G @ A3 )
                      = ( groups7121269368397514597t_prod @ B @ A @ H2 @ B3 ) ) ) ) ) ) ) ) ) ).

% prod.same_carrierI
thf(fact_4820_prod_Osame__carrier,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [C6: set @ B,A3: set @ B,B3: set @ B,G: B > A,H2: B > A] :
          ( ( finite_finite @ B @ C6 )
         => ( ( ord_less_eq @ ( set @ B ) @ A3 @ C6 )
           => ( ( ord_less_eq @ ( set @ B ) @ B3 @ C6 )
             => ( ! [A5: B] :
                    ( ( member @ B @ A5 @ ( minus_minus @ ( set @ B ) @ C6 @ A3 ) )
                   => ( ( G @ A5 )
                      = ( one_one @ A ) ) )
               => ( ! [B5: B] :
                      ( ( member @ B @ B5 @ ( minus_minus @ ( set @ B ) @ C6 @ B3 ) )
                     => ( ( H2 @ B5 )
                        = ( one_one @ A ) ) )
                 => ( ( ( groups7121269368397514597t_prod @ B @ A @ G @ A3 )
                      = ( groups7121269368397514597t_prod @ B @ A @ H2 @ B3 ) )
                    = ( ( groups7121269368397514597t_prod @ B @ A @ G @ C6 )
                      = ( groups7121269368397514597t_prod @ B @ A @ H2 @ C6 ) ) ) ) ) ) ) ) ) ).

% prod.same_carrier
thf(fact_4821_sum__diff__nat,axiom,
    ! [A: $tType,B3: set @ A,A3: set @ A,F2: A > nat] :
      ( ( finite_finite @ A @ B3 )
     => ( ( ord_less_eq @ ( set @ A ) @ B3 @ A3 )
       => ( ( groups7311177749621191930dd_sum @ A @ nat @ F2 @ ( minus_minus @ ( set @ A ) @ A3 @ B3 ) )
          = ( minus_minus @ nat @ ( groups7311177749621191930dd_sum @ A @ nat @ F2 @ A3 ) @ ( groups7311177749621191930dd_sum @ A @ nat @ F2 @ B3 ) ) ) ) ) ).

% sum_diff_nat
thf(fact_4822_finite__roots__unity,axiom,
    ! [A: $tType] :
      ( ( ( real_V8999393235501362500lgebra @ A )
        & ( idom @ A ) )
     => ! [N2: nat] :
          ( ( ord_less_eq @ nat @ ( one_one @ nat ) @ N2 )
         => ( finite_finite @ A
            @ ( collect @ A
              @ ^ [Z6: A] :
                  ( ( power_power @ A @ Z6 @ N2 )
                  = ( one_one @ A ) ) ) ) ) ) ).

% finite_roots_unity
thf(fact_4823_sum_Oreindex__bij__betw__not__neutral,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [S5: set @ B,T5: set @ C,H2: B > C,S3: set @ B,T6: set @ C,G: C > A] :
          ( ( finite_finite @ B @ S5 )
         => ( ( finite_finite @ C @ T5 )
           => ( ( bij_betw @ B @ C @ H2 @ ( minus_minus @ ( set @ B ) @ S3 @ S5 ) @ ( minus_minus @ ( set @ C ) @ T6 @ T5 ) )
             => ( ! [A5: B] :
                    ( ( member @ B @ A5 @ S5 )
                   => ( ( G @ ( H2 @ A5 ) )
                      = ( zero_zero @ A ) ) )
               => ( ! [B5: C] :
                      ( ( member @ C @ B5 @ T5 )
                     => ( ( G @ B5 )
                        = ( zero_zero @ A ) ) )
                 => ( ( groups7311177749621191930dd_sum @ B @ A
                      @ ^ [X5: B] : ( G @ ( H2 @ X5 ) )
                      @ S3 )
                    = ( groups7311177749621191930dd_sum @ C @ A @ G @ T6 ) ) ) ) ) ) ) ) ).

% sum.reindex_bij_betw_not_neutral
thf(fact_4824_sums__If__finite__set_H,axiom,
    ! [A: $tType] :
      ( ( ( topolo1287966508704411220up_add @ A )
        & ( topological_t2_space @ A ) )
     => ! [G: nat > A,S3: A,A3: set @ nat,S5: A,F2: nat > A] :
          ( ( sums @ A @ G @ S3 )
         => ( ( finite_finite @ nat @ A3 )
           => ( ( S5
                = ( plus_plus @ A @ S3
                  @ ( groups7311177749621191930dd_sum @ nat @ A
                    @ ^ [N3: nat] : ( minus_minus @ A @ ( F2 @ N3 ) @ ( G @ N3 ) )
                    @ A3 ) ) )
             => ( sums @ A
                @ ^ [N3: nat] : ( if @ A @ ( member @ nat @ N3 @ A3 ) @ ( F2 @ N3 ) @ ( G @ N3 ) )
                @ S5 ) ) ) ) ) ).

% sums_If_finite_set'
thf(fact_4825_prod_Oreindex__bij__betw__not__neutral,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [S5: set @ B,T5: set @ C,H2: B > C,S3: set @ B,T6: set @ C,G: C > A] :
          ( ( finite_finite @ B @ S5 )
         => ( ( finite_finite @ C @ T5 )
           => ( ( bij_betw @ B @ C @ H2 @ ( minus_minus @ ( set @ B ) @ S3 @ S5 ) @ ( minus_minus @ ( set @ C ) @ T6 @ T5 ) )
             => ( ! [A5: B] :
                    ( ( member @ B @ A5 @ S5 )
                   => ( ( G @ ( H2 @ A5 ) )
                      = ( one_one @ A ) ) )
               => ( ! [B5: C] :
                      ( ( member @ C @ B5 @ T5 )
                     => ( ( G @ B5 )
                        = ( one_one @ A ) ) )
                 => ( ( groups7121269368397514597t_prod @ B @ A
                      @ ^ [X5: B] : ( G @ ( H2 @ X5 ) )
                      @ S3 )
                    = ( groups7121269368397514597t_prod @ C @ A @ G @ T6 ) ) ) ) ) ) ) ) ).

% prod.reindex_bij_betw_not_neutral
thf(fact_4826_prod__mono__strict,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A3: set @ B,F2: B > A,G: B > A] :
          ( ( finite_finite @ B @ A3 )
         => ( ! [I2: B] :
                ( ( member @ B @ I2 @ A3 )
               => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( F2 @ I2 ) )
                  & ( ord_less @ A @ ( F2 @ I2 ) @ ( G @ I2 ) ) ) )
           => ( ( A3
               != ( bot_bot @ ( set @ B ) ) )
             => ( ord_less @ A @ ( groups7121269368397514597t_prod @ B @ A @ F2 @ A3 ) @ ( groups7121269368397514597t_prod @ B @ A @ G @ A3 ) ) ) ) ) ) ).

% prod_mono_strict
thf(fact_4827_sum__mono2,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [B3: set @ B,A3: set @ B,F2: B > A] :
          ( ( finite_finite @ B @ B3 )
         => ( ( ord_less_eq @ ( set @ B ) @ A3 @ B3 )
           => ( ! [B5: B] :
                  ( ( member @ B @ B5 @ ( minus_minus @ ( set @ B ) @ B3 @ A3 ) )
                 => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( F2 @ B5 ) ) )
             => ( ord_less_eq @ A @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ A3 ) @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ B3 ) ) ) ) ) ) ).

% sum_mono2
thf(fact_4828_even__prod__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( semiring_parity @ A )
     => ! [A3: set @ B,F2: B > A] :
          ( ( finite_finite @ B @ A3 )
         => ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( groups7121269368397514597t_prod @ B @ A @ F2 @ A3 ) )
            = ( ? [X5: B] :
                  ( ( member @ B @ X5 @ A3 )
                  & ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( F2 @ X5 ) ) ) ) ) ) ) ).

% even_prod_iff
thf(fact_4829_sum_Oinsert__remove,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A3: set @ B,G: B > A,X2: B] :
          ( ( finite_finite @ B @ A3 )
         => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ ( insert @ B @ X2 @ A3 ) )
            = ( plus_plus @ A @ ( G @ X2 ) @ ( groups7311177749621191930dd_sum @ B @ A @ G @ ( minus_minus @ ( set @ B ) @ A3 @ ( insert @ B @ X2 @ ( bot_bot @ ( set @ B ) ) ) ) ) ) ) ) ) ).

% sum.insert_remove
thf(fact_4830_sum_Oremove,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A3: set @ B,X2: B,G: B > A] :
          ( ( finite_finite @ B @ A3 )
         => ( ( member @ B @ X2 @ A3 )
           => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ A3 )
              = ( plus_plus @ A @ ( G @ X2 ) @ ( groups7311177749621191930dd_sum @ B @ A @ G @ ( minus_minus @ ( set @ B ) @ A3 @ ( insert @ B @ X2 @ ( bot_bot @ ( set @ B ) ) ) ) ) ) ) ) ) ) ).

% sum.remove
thf(fact_4831_prod_Oremove,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A3: set @ B,X2: B,G: B > A] :
          ( ( finite_finite @ B @ A3 )
         => ( ( member @ B @ X2 @ A3 )
           => ( ( groups7121269368397514597t_prod @ B @ A @ G @ A3 )
              = ( times_times @ A @ ( G @ X2 ) @ ( groups7121269368397514597t_prod @ B @ A @ G @ ( minus_minus @ ( set @ B ) @ A3 @ ( insert @ B @ X2 @ ( bot_bot @ ( set @ B ) ) ) ) ) ) ) ) ) ) ).

% prod.remove
thf(fact_4832_prod_Oinsert__remove,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A3: set @ B,G: B > A,X2: B] :
          ( ( finite_finite @ B @ A3 )
         => ( ( groups7121269368397514597t_prod @ B @ A @ G @ ( insert @ B @ X2 @ A3 ) )
            = ( times_times @ A @ ( G @ X2 ) @ ( groups7121269368397514597t_prod @ B @ A @ G @ ( minus_minus @ ( set @ B ) @ A3 @ ( insert @ B @ X2 @ ( bot_bot @ ( set @ B ) ) ) ) ) ) ) ) ) ).

% prod.insert_remove
thf(fact_4833_sum__le__suminf,axiom,
    ! [A: $tType] :
      ( ( ( ordere6911136660526730532id_add @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [F2: nat > A,I6: set @ nat] :
          ( ( summable @ A @ F2 )
         => ( ( finite_finite @ nat @ I6 )
           => ( ! [N: nat] :
                  ( ( member @ nat @ N @ ( uminus_uminus @ ( set @ nat ) @ I6 ) )
                 => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( F2 @ N ) ) )
             => ( ord_less_eq @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ I6 ) @ ( suminf @ A @ F2 ) ) ) ) ) ) ).

% sum_le_suminf
thf(fact_4834_sum_Odelta__remove,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [S3: set @ B,A2: B,B2: B > A,C2: B > A] :
          ( ( finite_finite @ B @ S3 )
         => ( ( ( member @ B @ A2 @ S3 )
             => ( ( groups7311177749621191930dd_sum @ B @ A
                  @ ^ [K3: B] : ( if @ A @ ( K3 = A2 ) @ ( B2 @ K3 ) @ ( C2 @ K3 ) )
                  @ S3 )
                = ( plus_plus @ A @ ( B2 @ A2 ) @ ( groups7311177749621191930dd_sum @ B @ A @ C2 @ ( minus_minus @ ( set @ B ) @ S3 @ ( insert @ B @ A2 @ ( bot_bot @ ( set @ B ) ) ) ) ) ) ) )
            & ( ~ ( member @ B @ A2 @ S3 )
             => ( ( groups7311177749621191930dd_sum @ B @ A
                  @ ^ [K3: B] : ( if @ A @ ( K3 = A2 ) @ ( B2 @ K3 ) @ ( C2 @ K3 ) )
                  @ S3 )
                = ( groups7311177749621191930dd_sum @ B @ A @ C2 @ ( minus_minus @ ( set @ B ) @ S3 @ ( insert @ B @ A2 @ ( bot_bot @ ( set @ B ) ) ) ) ) ) ) ) ) ) ).

% sum.delta_remove
thf(fact_4835_prod_Odelta__remove,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [S3: set @ B,A2: B,B2: B > A,C2: B > A] :
          ( ( finite_finite @ B @ S3 )
         => ( ( ( member @ B @ A2 @ S3 )
             => ( ( groups7121269368397514597t_prod @ B @ A
                  @ ^ [K3: B] : ( if @ A @ ( K3 = A2 ) @ ( B2 @ K3 ) @ ( C2 @ K3 ) )
                  @ S3 )
                = ( times_times @ A @ ( B2 @ A2 ) @ ( groups7121269368397514597t_prod @ B @ A @ C2 @ ( minus_minus @ ( set @ B ) @ S3 @ ( insert @ B @ A2 @ ( bot_bot @ ( set @ B ) ) ) ) ) ) ) )
            & ( ~ ( member @ B @ A2 @ S3 )
             => ( ( groups7121269368397514597t_prod @ B @ A
                  @ ^ [K3: B] : ( if @ A @ ( K3 = A2 ) @ ( B2 @ K3 ) @ ( C2 @ K3 ) )
                  @ S3 )
                = ( groups7121269368397514597t_prod @ B @ A @ C2 @ ( minus_minus @ ( set @ B ) @ S3 @ ( insert @ B @ A2 @ ( bot_bot @ ( set @ B ) ) ) ) ) ) ) ) ) ) ).

% prod.delta_remove
thf(fact_4836_sum__strict__mono2,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ordere8940638589300402666id_add @ B )
     => ! [B3: set @ A,A3: set @ A,B2: A,F2: A > B] :
          ( ( finite_finite @ A @ B3 )
         => ( ( ord_less_eq @ ( set @ A ) @ A3 @ B3 )
           => ( ( member @ A @ B2 @ ( minus_minus @ ( set @ A ) @ B3 @ A3 ) )
             => ( ( ord_less @ B @ ( zero_zero @ B ) @ ( F2 @ B2 ) )
               => ( ! [X3: A] :
                      ( ( member @ A @ X3 @ B3 )
                     => ( ord_less_eq @ B @ ( zero_zero @ B ) @ ( F2 @ X3 ) ) )
                 => ( ord_less @ B @ ( groups7311177749621191930dd_sum @ A @ B @ F2 @ A3 ) @ ( groups7311177749621191930dd_sum @ A @ B @ F2 @ B3 ) ) ) ) ) ) ) ) ).

% sum_strict_mono2
thf(fact_4837_member__le__sum,axiom,
    ! [B: $tType,C: $tType] :
      ( ( ( ordere6911136660526730532id_add @ B )
        & ( semiring_1 @ B ) )
     => ! [I3: C,A3: set @ C,F2: C > B] :
          ( ( member @ C @ I3 @ A3 )
         => ( ! [X3: C] :
                ( ( member @ C @ X3 @ ( minus_minus @ ( set @ C ) @ A3 @ ( insert @ C @ I3 @ ( bot_bot @ ( set @ C ) ) ) ) )
               => ( ord_less_eq @ B @ ( zero_zero @ B ) @ ( F2 @ X3 ) ) )
           => ( ( finite_finite @ C @ A3 )
             => ( ord_less_eq @ B @ ( F2 @ I3 ) @ ( groups7311177749621191930dd_sum @ C @ B @ F2 @ A3 ) ) ) ) ) ) ).

% member_le_sum
thf(fact_4838_prod__mono2,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linordered_idom @ B )
     => ! [B3: set @ A,A3: set @ A,F2: A > B] :
          ( ( finite_finite @ A @ B3 )
         => ( ( ord_less_eq @ ( set @ A ) @ A3 @ B3 )
           => ( ! [B5: A] :
                  ( ( member @ A @ B5 @ ( minus_minus @ ( set @ A ) @ B3 @ A3 ) )
                 => ( ord_less_eq @ B @ ( one_one @ B ) @ ( F2 @ B5 ) ) )
             => ( ! [A5: A] :
                    ( ( member @ A @ A5 @ A3 )
                   => ( ord_less_eq @ B @ ( zero_zero @ B ) @ ( F2 @ A5 ) ) )
               => ( ord_less_eq @ B @ ( groups7121269368397514597t_prod @ A @ B @ F2 @ A3 ) @ ( groups7121269368397514597t_prod @ A @ B @ F2 @ B3 ) ) ) ) ) ) ) ).

% prod_mono2
thf(fact_4839_prod__diff1,axiom,
    ! [A: $tType,B: $tType] :
      ( ( semidom_divide @ A )
     => ! [A3: set @ B,F2: B > A,A2: B] :
          ( ( finite_finite @ B @ A3 )
         => ( ( ( F2 @ A2 )
             != ( zero_zero @ A ) )
           => ( ( ( member @ B @ A2 @ A3 )
               => ( ( groups7121269368397514597t_prod @ B @ A @ F2 @ ( minus_minus @ ( set @ B ) @ A3 @ ( insert @ B @ A2 @ ( bot_bot @ ( set @ B ) ) ) ) )
                  = ( divide_divide @ A @ ( groups7121269368397514597t_prod @ B @ A @ F2 @ A3 ) @ ( F2 @ A2 ) ) ) )
              & ( ~ ( member @ B @ A2 @ A3 )
               => ( ( groups7121269368397514597t_prod @ B @ A @ F2 @ ( minus_minus @ ( set @ B ) @ A3 @ ( insert @ B @ A2 @ ( bot_bot @ ( set @ B ) ) ) ) )
                  = ( groups7121269368397514597t_prod @ B @ A @ F2 @ A3 ) ) ) ) ) ) ) ).

% prod_diff1
thf(fact_4840_ln__prod,axiom,
    ! [A: $tType,I6: set @ A,F2: A > real] :
      ( ( finite_finite @ A @ I6 )
     => ( ! [I2: A] :
            ( ( member @ A @ I2 @ I6 )
           => ( ord_less @ real @ ( zero_zero @ real ) @ ( F2 @ I2 ) ) )
       => ( ( ln_ln @ real @ ( groups7121269368397514597t_prod @ A @ real @ F2 @ I6 ) )
          = ( groups7311177749621191930dd_sum @ A @ real
            @ ^ [X5: A] : ( ln_ln @ real @ ( F2 @ X5 ) )
            @ I6 ) ) ) ) ).

% ln_prod
thf(fact_4841_even__set__encode__iff,axiom,
    ! [A3: set @ nat] :
      ( ( finite_finite @ nat @ A3 )
     => ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( nat_set_encode @ A3 ) )
        = ( ~ ( member @ nat @ ( zero_zero @ nat ) @ A3 ) ) ) ) ).

% even_set_encode_iff
thf(fact_4842_polyfun__roots__finite,axiom,
    ! [A: $tType] :
      ( ( ( real_V8999393235501362500lgebra @ A )
        & ( idom @ A ) )
     => ! [C2: nat > A,K: nat,N2: nat] :
          ( ( ( C2 @ K )
           != ( zero_zero @ A ) )
         => ( ( ord_less_eq @ nat @ K @ N2 )
           => ( finite_finite @ A
              @ ( collect @ A
                @ ^ [Z6: A] :
                    ( ( groups7311177749621191930dd_sum @ nat @ A
                      @ ^ [I4: nat] : ( times_times @ A @ ( C2 @ I4 ) @ ( power_power @ A @ Z6 @ I4 ) )
                      @ ( set_ord_atMost @ nat @ N2 ) )
                    = ( zero_zero @ A ) ) ) ) ) ) ) ).

% polyfun_roots_finite
thf(fact_4843_polyfun__finite__roots,axiom,
    ! [A: $tType] :
      ( ( ( real_V8999393235501362500lgebra @ A )
        & ( idom @ A ) )
     => ! [C2: nat > A,N2: nat] :
          ( ( finite_finite @ A
            @ ( collect @ A
              @ ^ [X5: A] :
                  ( ( groups7311177749621191930dd_sum @ nat @ A
                    @ ^ [I4: nat] : ( times_times @ A @ ( C2 @ I4 ) @ ( power_power @ A @ X5 @ I4 ) )
                    @ ( set_ord_atMost @ nat @ N2 ) )
                  = ( zero_zero @ A ) ) ) )
          = ( ? [I4: nat] :
                ( ( ord_less_eq @ nat @ I4 @ N2 )
                & ( ( C2 @ I4 )
                 != ( zero_zero @ A ) ) ) ) ) ) ).

% polyfun_finite_roots
thf(fact_4844_finite__Collect__le__nat,axiom,
    ! [K: nat] :
      ( finite_finite @ nat
      @ ( collect @ nat
        @ ^ [N3: nat] : ( ord_less_eq @ nat @ N3 @ K ) ) ) ).

% finite_Collect_le_nat
thf(fact_4845_finite__Collect__less__nat,axiom,
    ! [K: nat] :
      ( finite_finite @ nat
      @ ( collect @ nat
        @ ^ [N3: nat] : ( ord_less @ nat @ N3 @ K ) ) ) ).

% finite_Collect_less_nat
thf(fact_4846_finite__Collect__subsets,axiom,
    ! [A: $tType,A3: set @ A] :
      ( ( finite_finite @ A @ A3 )
     => ( finite_finite @ ( set @ A )
        @ ( collect @ ( set @ A )
          @ ^ [B8: set @ A] : ( ord_less_eq @ ( set @ A ) @ B8 @ A3 ) ) ) ) ).

% finite_Collect_subsets
thf(fact_4847_finite__interval__int1,axiom,
    ! [A2: int,B2: int] :
      ( finite_finite @ int
      @ ( collect @ int
        @ ^ [I4: int] :
            ( ( ord_less_eq @ int @ A2 @ I4 )
            & ( ord_less_eq @ int @ I4 @ B2 ) ) ) ) ).

% finite_interval_int1
thf(fact_4848_finite__interval__int4,axiom,
    ! [A2: int,B2: int] :
      ( finite_finite @ int
      @ ( collect @ int
        @ ^ [I4: int] :
            ( ( ord_less @ int @ A2 @ I4 )
            & ( ord_less @ int @ I4 @ B2 ) ) ) ) ).

% finite_interval_int4
thf(fact_4849_finite__interval__int2,axiom,
    ! [A2: int,B2: int] :
      ( finite_finite @ int
      @ ( collect @ int
        @ ^ [I4: int] :
            ( ( ord_less_eq @ int @ A2 @ I4 )
            & ( ord_less @ int @ I4 @ B2 ) ) ) ) ).

% finite_interval_int2
thf(fact_4850_finite__interval__int3,axiom,
    ! [A2: int,B2: int] :
      ( finite_finite @ int
      @ ( collect @ int
        @ ^ [I4: int] :
            ( ( ord_less @ int @ A2 @ I4 )
            & ( ord_less_eq @ int @ I4 @ B2 ) ) ) ) ).

% finite_interval_int3
thf(fact_4851_finite__nth__roots,axiom,
    ! [N2: nat,C2: complex] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( finite_finite @ complex
        @ ( collect @ complex
          @ ^ [Z6: complex] :
              ( ( power_power @ complex @ Z6 @ N2 )
              = C2 ) ) ) ) ).

% finite_nth_roots
thf(fact_4852_finite__atLeastZeroLessThan__int,axiom,
    ! [U: int] : ( finite_finite @ int @ ( set_or7035219750837199246ssThan @ int @ ( zero_zero @ int ) @ U ) ) ).

% finite_atLeastZeroLessThan_int
thf(fact_4853_finite__maxlen,axiom,
    ! [A: $tType,M7: set @ ( list @ A )] :
      ( ( finite_finite @ ( list @ A ) @ M7 )
     => ? [N: nat] :
        ! [X: list @ A] :
          ( ( member @ ( list @ A ) @ X @ M7 )
         => ( ord_less @ nat @ ( size_size @ ( list @ A ) @ X ) @ N ) ) ) ).

% finite_maxlen
thf(fact_4854_finite__divisors__int,axiom,
    ! [I3: int] :
      ( ( I3
       != ( zero_zero @ int ) )
     => ( finite_finite @ int
        @ ( collect @ int
          @ ^ [D3: int] : ( dvd_dvd @ int @ D3 @ I3 ) ) ) ) ).

% finite_divisors_int
thf(fact_4855_finite__has__minimal2,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [A3: set @ A,A2: A] :
          ( ( finite_finite @ A @ A3 )
         => ( ( member @ A @ A2 @ A3 )
           => ? [X3: A] :
                ( ( member @ A @ X3 @ A3 )
                & ( ord_less_eq @ A @ X3 @ A2 )
                & ! [Xa: A] :
                    ( ( member @ A @ Xa @ A3 )
                   => ( ( ord_less_eq @ A @ Xa @ X3 )
                     => ( X3 = Xa ) ) ) ) ) ) ) ).

% finite_has_minimal2
thf(fact_4856_finite__has__maximal2,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [A3: set @ A,A2: A] :
          ( ( finite_finite @ A @ A3 )
         => ( ( member @ A @ A2 @ A3 )
           => ? [X3: A] :
                ( ( member @ A @ X3 @ A3 )
                & ( ord_less_eq @ A @ A2 @ X3 )
                & ! [Xa: A] :
                    ( ( member @ A @ Xa @ A3 )
                   => ( ( ord_less_eq @ A @ X3 @ Xa )
                     => ( X3 = Xa ) ) ) ) ) ) ) ).

% finite_has_maximal2
thf(fact_4857_rev__finite__subset,axiom,
    ! [A: $tType,B3: set @ A,A3: set @ A] :
      ( ( finite_finite @ A @ B3 )
     => ( ( ord_less_eq @ ( set @ A ) @ A3 @ B3 )
       => ( finite_finite @ A @ A3 ) ) ) ).

% rev_finite_subset
thf(fact_4858_infinite__super,axiom,
    ! [A: $tType,S3: set @ A,T6: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ S3 @ T6 )
     => ( ~ ( finite_finite @ A @ S3 )
       => ~ ( finite_finite @ A @ T6 ) ) ) ).

% infinite_super
thf(fact_4859_finite__subset,axiom,
    ! [A: $tType,A3: set @ A,B3: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ B3 )
     => ( ( finite_finite @ A @ B3 )
       => ( finite_finite @ A @ A3 ) ) ) ).

% finite_subset
thf(fact_4860_finite__psubset__induct,axiom,
    ! [A: $tType,A3: set @ A,P: ( set @ A ) > $o] :
      ( ( finite_finite @ A @ A3 )
     => ( ! [A8: set @ A] :
            ( ( finite_finite @ A @ A8 )
           => ( ! [B10: set @ A] :
                  ( ( ord_less @ ( set @ A ) @ B10 @ A8 )
                 => ( P @ B10 ) )
             => ( P @ A8 ) ) )
       => ( P @ A3 ) ) ) ).

% finite_psubset_induct
thf(fact_4861_finite__has__minimal,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [A3: set @ A] :
          ( ( finite_finite @ A @ A3 )
         => ( ( A3
             != ( bot_bot @ ( set @ A ) ) )
           => ? [X3: A] :
                ( ( member @ A @ X3 @ A3 )
                & ! [Xa: A] :
                    ( ( member @ A @ Xa @ A3 )
                   => ( ( ord_less_eq @ A @ Xa @ X3 )
                     => ( X3 = Xa ) ) ) ) ) ) ) ).

% finite_has_minimal
thf(fact_4862_finite__has__maximal,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [A3: set @ A] :
          ( ( finite_finite @ A @ A3 )
         => ( ( A3
             != ( bot_bot @ ( set @ A ) ) )
           => ? [X3: A] :
                ( ( member @ A @ X3 @ A3 )
                & ! [Xa: A] :
                    ( ( member @ A @ Xa @ A3 )
                   => ( ( ord_less_eq @ A @ X3 @ Xa )
                     => ( X3 = Xa ) ) ) ) ) ) ) ).

% finite_has_maximal
thf(fact_4863_finite__subset__induct,axiom,
    ! [A: $tType,F3: set @ A,A3: set @ A,P: ( set @ A ) > $o] :
      ( ( finite_finite @ A @ F3 )
     => ( ( ord_less_eq @ ( set @ A ) @ F3 @ A3 )
       => ( ( P @ ( bot_bot @ ( set @ A ) ) )
         => ( ! [A5: A,F6: set @ A] :
                ( ( finite_finite @ A @ F6 )
               => ( ( member @ A @ A5 @ A3 )
                 => ( ~ ( member @ A @ A5 @ F6 )
                   => ( ( P @ F6 )
                     => ( P @ ( insert @ A @ A5 @ F6 ) ) ) ) ) )
           => ( P @ F3 ) ) ) ) ) ).

% finite_subset_induct
thf(fact_4864_finite__subset__induct_H,axiom,
    ! [A: $tType,F3: set @ A,A3: set @ A,P: ( set @ A ) > $o] :
      ( ( finite_finite @ A @ F3 )
     => ( ( ord_less_eq @ ( set @ A ) @ F3 @ A3 )
       => ( ( P @ ( bot_bot @ ( set @ A ) ) )
         => ( ! [A5: A,F6: set @ A] :
                ( ( finite_finite @ A @ F6 )
               => ( ( member @ A @ A5 @ A3 )
                 => ( ( ord_less_eq @ ( set @ A ) @ F6 @ A3 )
                   => ( ~ ( member @ A @ A5 @ F6 )
                     => ( ( P @ F6 )
                       => ( P @ ( insert @ A @ A5 @ F6 ) ) ) ) ) ) )
           => ( P @ F3 ) ) ) ) ) ).

% finite_subset_induct'
thf(fact_4865_finite__remove__induct,axiom,
    ! [A: $tType,B3: set @ A,P: ( set @ A ) > $o] :
      ( ( finite_finite @ A @ B3 )
     => ( ( P @ ( bot_bot @ ( set @ A ) ) )
       => ( ! [A8: set @ A] :
              ( ( finite_finite @ A @ A8 )
             => ( ( A8
                 != ( bot_bot @ ( set @ A ) ) )
               => ( ( ord_less_eq @ ( set @ A ) @ A8 @ B3 )
                 => ( ! [X: A] :
                        ( ( member @ A @ X @ A8 )
                       => ( P @ ( minus_minus @ ( set @ A ) @ A8 @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) )
                   => ( P @ A8 ) ) ) ) )
         => ( P @ B3 ) ) ) ) ).

% finite_remove_induct
thf(fact_4866_remove__induct,axiom,
    ! [A: $tType,P: ( set @ A ) > $o,B3: set @ A] :
      ( ( P @ ( bot_bot @ ( set @ A ) ) )
     => ( ( ~ ( finite_finite @ A @ B3 )
         => ( P @ B3 ) )
       => ( ! [A8: set @ A] :
              ( ( finite_finite @ A @ A8 )
             => ( ( A8
                 != ( bot_bot @ ( set @ A ) ) )
               => ( ( ord_less_eq @ ( set @ A ) @ A8 @ B3 )
                 => ( ! [X: A] :
                        ( ( member @ A @ X @ A8 )
                       => ( P @ ( minus_minus @ ( set @ A ) @ A8 @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) )
                   => ( P @ A8 ) ) ) ) )
         => ( P @ B3 ) ) ) ) ).

% remove_induct
thf(fact_4867_finite__induct__select,axiom,
    ! [A: $tType,S3: set @ A,P: ( set @ A ) > $o] :
      ( ( finite_finite @ A @ S3 )
     => ( ( P @ ( bot_bot @ ( set @ A ) ) )
       => ( ! [T7: set @ A] :
              ( ( ord_less @ ( set @ A ) @ T7 @ S3 )
             => ( ( P @ T7 )
               => ? [X: A] :
                    ( ( member @ A @ X @ ( minus_minus @ ( set @ A ) @ S3 @ T7 ) )
                    & ( P @ ( insert @ A @ X @ T7 ) ) ) ) )
         => ( P @ S3 ) ) ) ) ).

% finite_induct_select
thf(fact_4868_VEBT_Osize__gen_I1_J,axiom,
    ! [X11: option @ ( product_prod @ nat @ nat ),X12: nat,X13: list @ vEBT_VEBT,X14: vEBT_VEBT] :
      ( ( vEBT_size_VEBT @ ( vEBT_Node @ X11 @ X12 @ X13 @ X14 ) )
      = ( plus_plus @ nat @ ( plus_plus @ nat @ ( size_list @ vEBT_VEBT @ vEBT_size_VEBT @ X13 ) @ ( vEBT_size_VEBT @ X14 ) ) @ ( suc @ ( zero_zero @ nat ) ) ) ) ).

% VEBT.size_gen(1)
thf(fact_4869_finite__nat__iff__bounded__le,axiom,
    ( ( finite_finite @ nat )
    = ( ^ [S6: set @ nat] :
        ? [K3: nat] : ( ord_less_eq @ ( set @ nat ) @ S6 @ ( set_ord_atMost @ nat @ K3 ) ) ) ) ).

% finite_nat_iff_bounded_le
thf(fact_4870_bij__betw__nth__root__unity,axiom,
    ! [C2: complex,N2: nat] :
      ( ( C2
       != ( zero_zero @ complex ) )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
       => ( bij_betw @ complex @ complex @ ( times_times @ complex @ ( times_times @ complex @ ( real_Vector_of_real @ complex @ ( root @ N2 @ ( real_V7770717601297561774m_norm @ complex @ C2 ) ) ) @ ( cis @ ( divide_divide @ real @ ( arg @ C2 ) @ ( semiring_1_of_nat @ real @ N2 ) ) ) ) )
          @ ( collect @ complex
            @ ^ [Z6: complex] :
                ( ( power_power @ complex @ Z6 @ N2 )
                = ( one_one @ complex ) ) )
          @ ( collect @ complex
            @ ^ [Z6: complex] :
                ( ( power_power @ complex @ Z6 @ N2 )
                = C2 ) ) ) ) ) ).

% bij_betw_nth_root_unity
thf(fact_4871_real__root__zero,axiom,
    ! [N2: nat] :
      ( ( root @ N2 @ ( zero_zero @ real ) )
      = ( zero_zero @ real ) ) ).

% real_root_zero
thf(fact_4872_real__root__Suc__0,axiom,
    ! [X2: real] :
      ( ( root @ ( suc @ ( zero_zero @ nat ) ) @ X2 )
      = X2 ) ).

% real_root_Suc_0
thf(fact_4873_root__0,axiom,
    ! [X2: real] :
      ( ( root @ ( zero_zero @ nat ) @ X2 )
      = ( zero_zero @ real ) ) ).

% root_0
thf(fact_4874_real__root__eq__iff,axiom,
    ! [N2: nat,X2: real,Y2: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( ( root @ N2 @ X2 )
          = ( root @ N2 @ Y2 ) )
        = ( X2 = Y2 ) ) ) ).

% real_root_eq_iff
thf(fact_4875_real__root__eq__0__iff,axiom,
    ! [N2: nat,X2: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( ( root @ N2 @ X2 )
          = ( zero_zero @ real ) )
        = ( X2
          = ( zero_zero @ real ) ) ) ) ).

% real_root_eq_0_iff
thf(fact_4876_real__root__less__iff,axiom,
    ! [N2: nat,X2: real,Y2: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( ord_less @ real @ ( root @ N2 @ X2 ) @ ( root @ N2 @ Y2 ) )
        = ( ord_less @ real @ X2 @ Y2 ) ) ) ).

% real_root_less_iff
thf(fact_4877_real__root__le__iff,axiom,
    ! [N2: nat,X2: real,Y2: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( ord_less_eq @ real @ ( root @ N2 @ X2 ) @ ( root @ N2 @ Y2 ) )
        = ( ord_less_eq @ real @ X2 @ Y2 ) ) ) ).

% real_root_le_iff
thf(fact_4878_real__root__eq__1__iff,axiom,
    ! [N2: nat,X2: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( ( root @ N2 @ X2 )
          = ( one_one @ real ) )
        = ( X2
          = ( one_one @ real ) ) ) ) ).

% real_root_eq_1_iff
thf(fact_4879_real__root__one,axiom,
    ! [N2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( root @ N2 @ ( one_one @ real ) )
        = ( one_one @ real ) ) ) ).

% real_root_one
thf(fact_4880_real__root__lt__0__iff,axiom,
    ! [N2: nat,X2: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( ord_less @ real @ ( root @ N2 @ X2 ) @ ( zero_zero @ real ) )
        = ( ord_less @ real @ X2 @ ( zero_zero @ real ) ) ) ) ).

% real_root_lt_0_iff
thf(fact_4881_real__root__gt__0__iff,axiom,
    ! [N2: nat,Y2: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ ( root @ N2 @ Y2 ) )
        = ( ord_less @ real @ ( zero_zero @ real ) @ Y2 ) ) ) ).

% real_root_gt_0_iff
thf(fact_4882_real__root__le__0__iff,axiom,
    ! [N2: nat,X2: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( ord_less_eq @ real @ ( root @ N2 @ X2 ) @ ( zero_zero @ real ) )
        = ( ord_less_eq @ real @ X2 @ ( zero_zero @ real ) ) ) ) ).

% real_root_le_0_iff
thf(fact_4883_real__root__ge__0__iff,axiom,
    ! [N2: nat,Y2: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( root @ N2 @ Y2 ) )
        = ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y2 ) ) ) ).

% real_root_ge_0_iff
thf(fact_4884_real__root__lt__1__iff,axiom,
    ! [N2: nat,X2: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( ord_less @ real @ ( root @ N2 @ X2 ) @ ( one_one @ real ) )
        = ( ord_less @ real @ X2 @ ( one_one @ real ) ) ) ) ).

% real_root_lt_1_iff
thf(fact_4885_real__root__gt__1__iff,axiom,
    ! [N2: nat,Y2: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( ord_less @ real @ ( one_one @ real ) @ ( root @ N2 @ Y2 ) )
        = ( ord_less @ real @ ( one_one @ real ) @ Y2 ) ) ) ).

% real_root_gt_1_iff
thf(fact_4886_real__root__le__1__iff,axiom,
    ! [N2: nat,X2: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( ord_less_eq @ real @ ( root @ N2 @ X2 ) @ ( one_one @ real ) )
        = ( ord_less_eq @ real @ X2 @ ( one_one @ real ) ) ) ) ).

% real_root_le_1_iff
thf(fact_4887_real__root__ge__1__iff,axiom,
    ! [N2: nat,Y2: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( ord_less_eq @ real @ ( one_one @ real ) @ ( root @ N2 @ Y2 ) )
        = ( ord_less_eq @ real @ ( one_one @ real ) @ Y2 ) ) ) ).

% real_root_ge_1_iff
thf(fact_4888_real__root__pow__pos2,axiom,
    ! [N2: nat,X2: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X2 )
       => ( ( power_power @ real @ ( root @ N2 @ X2 ) @ N2 )
          = X2 ) ) ) ).

% real_root_pow_pos2
thf(fact_4889_real__root__divide,axiom,
    ! [N2: nat,X2: real,Y2: real] :
      ( ( root @ N2 @ ( divide_divide @ real @ X2 @ Y2 ) )
      = ( divide_divide @ real @ ( root @ N2 @ X2 ) @ ( root @ N2 @ Y2 ) ) ) ).

% real_root_divide
thf(fact_4890_real__root__mult,axiom,
    ! [N2: nat,X2: real,Y2: real] :
      ( ( root @ N2 @ ( times_times @ real @ X2 @ Y2 ) )
      = ( times_times @ real @ ( root @ N2 @ X2 ) @ ( root @ N2 @ Y2 ) ) ) ).

% real_root_mult
thf(fact_4891_real__root__mult__exp,axiom,
    ! [M: nat,N2: nat,X2: real] :
      ( ( root @ ( times_times @ nat @ M @ N2 ) @ X2 )
      = ( root @ M @ ( root @ N2 @ X2 ) ) ) ).

% real_root_mult_exp
thf(fact_4892_real__root__pos__pos__le,axiom,
    ! [X2: real,N2: nat] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X2 )
     => ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( root @ N2 @ X2 ) ) ) ).

% real_root_pos_pos_le
thf(fact_4893_real__root__less__mono,axiom,
    ! [N2: nat,X2: real,Y2: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( ord_less @ real @ X2 @ Y2 )
       => ( ord_less @ real @ ( root @ N2 @ X2 ) @ ( root @ N2 @ Y2 ) ) ) ) ).

% real_root_less_mono
thf(fact_4894_real__root__le__mono,axiom,
    ! [N2: nat,X2: real,Y2: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( ord_less_eq @ real @ X2 @ Y2 )
       => ( ord_less_eq @ real @ ( root @ N2 @ X2 ) @ ( root @ N2 @ Y2 ) ) ) ) ).

% real_root_le_mono
thf(fact_4895_real__root__power,axiom,
    ! [N2: nat,X2: real,K: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( root @ N2 @ ( power_power @ real @ X2 @ K ) )
        = ( power_power @ real @ ( root @ N2 @ X2 ) @ K ) ) ) ).

% real_root_power
thf(fact_4896_real__root__abs,axiom,
    ! [N2: nat,X2: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( root @ N2 @ ( abs_abs @ real @ X2 ) )
        = ( abs_abs @ real @ ( root @ N2 @ X2 ) ) ) ) ).

% real_root_abs
thf(fact_4897_sgn__root,axiom,
    ! [N2: nat,X2: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( sgn_sgn @ real @ ( root @ N2 @ X2 ) )
        = ( sgn_sgn @ real @ X2 ) ) ) ).

% sgn_root
thf(fact_4898_real__root__gt__zero,axiom,
    ! [N2: nat,X2: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
       => ( ord_less @ real @ ( zero_zero @ real ) @ ( root @ N2 @ X2 ) ) ) ) ).

% real_root_gt_zero
thf(fact_4899_real__root__strict__decreasing,axiom,
    ! [N2: nat,N4: nat,X2: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( ord_less @ nat @ N2 @ N4 )
       => ( ( ord_less @ real @ ( one_one @ real ) @ X2 )
         => ( ord_less @ real @ ( root @ N4 @ X2 ) @ ( root @ N2 @ X2 ) ) ) ) ) ).

% real_root_strict_decreasing
thf(fact_4900_sqrt__def,axiom,
    ( sqrt
    = ( root @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ).

% sqrt_def
thf(fact_4901_root__abs__power,axiom,
    ! [N2: nat,Y2: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( abs_abs @ real @ ( root @ N2 @ ( power_power @ real @ Y2 @ N2 ) ) )
        = ( abs_abs @ real @ Y2 ) ) ) ).

% root_abs_power
thf(fact_4902_real__root__pos__pos,axiom,
    ! [N2: nat,X2: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
       => ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( root @ N2 @ X2 ) ) ) ) ).

% real_root_pos_pos
thf(fact_4903_real__root__strict__increasing,axiom,
    ! [N2: nat,N4: nat,X2: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( ord_less @ nat @ N2 @ N4 )
       => ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
         => ( ( ord_less @ real @ X2 @ ( one_one @ real ) )
           => ( ord_less @ real @ ( root @ N2 @ X2 ) @ ( root @ N4 @ X2 ) ) ) ) ) ) ).

% real_root_strict_increasing
thf(fact_4904_real__root__decreasing,axiom,
    ! [N2: nat,N4: nat,X2: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( ord_less_eq @ nat @ N2 @ N4 )
       => ( ( ord_less_eq @ real @ ( one_one @ real ) @ X2 )
         => ( ord_less_eq @ real @ ( root @ N4 @ X2 ) @ ( root @ N2 @ X2 ) ) ) ) ) ).

% real_root_decreasing
thf(fact_4905_real__root__pow__pos,axiom,
    ! [N2: nat,X2: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
       => ( ( power_power @ real @ ( root @ N2 @ X2 ) @ N2 )
          = X2 ) ) ) ).

% real_root_pow_pos
thf(fact_4906_real__root__pos__unique,axiom,
    ! [N2: nat,Y2: real,X2: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y2 )
       => ( ( ( power_power @ real @ Y2 @ N2 )
            = X2 )
         => ( ( root @ N2 @ X2 )
            = Y2 ) ) ) ) ).

% real_root_pos_unique
thf(fact_4907_real__root__power__cancel,axiom,
    ! [N2: nat,X2: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X2 )
       => ( ( root @ N2 @ ( power_power @ real @ X2 @ N2 ) )
          = X2 ) ) ) ).

% real_root_power_cancel
thf(fact_4908_odd__real__root__power__cancel,axiom,
    ! [N2: nat,X2: real] :
      ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 )
     => ( ( root @ N2 @ ( power_power @ real @ X2 @ N2 ) )
        = X2 ) ) ).

% odd_real_root_power_cancel
thf(fact_4909_odd__real__root__unique,axiom,
    ! [N2: nat,Y2: real,X2: real] :
      ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 )
     => ( ( ( power_power @ real @ Y2 @ N2 )
          = X2 )
       => ( ( root @ N2 @ X2 )
          = Y2 ) ) ) ).

% odd_real_root_unique
thf(fact_4910_odd__real__root__pow,axiom,
    ! [N2: nat,X2: real] :
      ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 )
     => ( ( power_power @ real @ ( root @ N2 @ X2 ) @ N2 )
        = X2 ) ) ).

% odd_real_root_pow
thf(fact_4911_real__root__increasing,axiom,
    ! [N2: nat,N4: nat,X2: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( ord_less_eq @ nat @ N2 @ N4 )
       => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X2 )
         => ( ( ord_less_eq @ real @ X2 @ ( one_one @ real ) )
           => ( ord_less_eq @ real @ ( root @ N2 @ X2 ) @ ( root @ N4 @ X2 ) ) ) ) ) ) ).

% real_root_increasing
thf(fact_4912_sgn__power__root,axiom,
    ! [N2: nat,X2: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( times_times @ real @ ( sgn_sgn @ real @ ( root @ N2 @ X2 ) ) @ ( power_power @ real @ ( abs_abs @ real @ ( root @ N2 @ X2 ) ) @ N2 ) )
        = X2 ) ) ).

% sgn_power_root
thf(fact_4913_root__sgn__power,axiom,
    ! [N2: nat,Y2: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( root @ N2 @ ( times_times @ real @ ( sgn_sgn @ real @ Y2 ) @ ( power_power @ real @ ( abs_abs @ real @ Y2 ) @ N2 ) ) )
        = Y2 ) ) ).

% root_sgn_power
thf(fact_4914_VEBT_Osize__gen_I2_J,axiom,
    ! [X21: $o,X222: $o] :
      ( ( vEBT_size_VEBT @ ( vEBT_Leaf @ X21 @ X222 ) )
      = ( zero_zero @ nat ) ) ).

% VEBT.size_gen(2)
thf(fact_4915_ln__root,axiom,
    ! [N2: nat,B2: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ B2 )
       => ( ( ln_ln @ real @ ( root @ N2 @ B2 ) )
          = ( divide_divide @ real @ ( ln_ln @ real @ B2 ) @ ( semiring_1_of_nat @ real @ N2 ) ) ) ) ) ).

% ln_root
thf(fact_4916_log__root,axiom,
    ! [N2: nat,A2: real,B2: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
       => ( ( log @ B2 @ ( root @ N2 @ A2 ) )
          = ( divide_divide @ real @ ( log @ B2 @ A2 ) @ ( semiring_1_of_nat @ real @ N2 ) ) ) ) ) ).

% log_root
thf(fact_4917_log__base__root,axiom,
    ! [N2: nat,B2: real,X2: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ B2 )
       => ( ( log @ ( root @ N2 @ B2 ) @ X2 )
          = ( times_times @ real @ ( semiring_1_of_nat @ real @ N2 ) @ ( log @ B2 @ X2 ) ) ) ) ) ).

% log_base_root
thf(fact_4918_split__root,axiom,
    ! [P: real > $o,N2: nat,X2: real] :
      ( ( P @ ( root @ N2 @ X2 ) )
      = ( ( ( N2
            = ( zero_zero @ nat ) )
         => ( P @ ( zero_zero @ real ) ) )
        & ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
         => ! [Y5: real] :
              ( ( ( times_times @ real @ ( sgn_sgn @ real @ Y5 ) @ ( power_power @ real @ ( abs_abs @ real @ Y5 ) @ N2 ) )
                = X2 )
             => ( P @ Y5 ) ) ) ) ) ).

% split_root
thf(fact_4919_infinite__int__iff__unbounded__le,axiom,
    ! [S3: set @ int] :
      ( ( ~ ( finite_finite @ int @ S3 ) )
      = ( ! [M6: int] :
          ? [N3: int] :
            ( ( ord_less_eq @ int @ M6 @ ( abs_abs @ int @ N3 ) )
            & ( member @ int @ N3 @ S3 ) ) ) ) ).

% infinite_int_iff_unbounded_le
thf(fact_4920_infinite__int__iff__unbounded,axiom,
    ! [S3: set @ int] :
      ( ( ~ ( finite_finite @ int @ S3 ) )
      = ( ! [M6: int] :
          ? [N3: int] :
            ( ( ord_less @ int @ M6 @ ( abs_abs @ int @ N3 ) )
            & ( member @ int @ N3 @ S3 ) ) ) ) ).

% infinite_int_iff_unbounded
thf(fact_4921_infinite__nat__iff__unbounded,axiom,
    ! [S3: set @ nat] :
      ( ( ~ ( finite_finite @ nat @ S3 ) )
      = ( ! [M6: nat] :
          ? [N3: nat] :
            ( ( ord_less @ nat @ M6 @ N3 )
            & ( member @ nat @ N3 @ S3 ) ) ) ) ).

% infinite_nat_iff_unbounded
thf(fact_4922_unbounded__k__infinite,axiom,
    ! [K: nat,S3: set @ nat] :
      ( ! [M3: nat] :
          ( ( ord_less @ nat @ K @ M3 )
         => ? [N9: nat] :
              ( ( ord_less @ nat @ M3 @ N9 )
              & ( member @ nat @ N9 @ S3 ) ) )
     => ~ ( finite_finite @ nat @ S3 ) ) ).

% unbounded_k_infinite
thf(fact_4923_infinite__nat__iff__unbounded__le,axiom,
    ! [S3: set @ nat] :
      ( ( ~ ( finite_finite @ nat @ S3 ) )
      = ( ! [M6: nat] :
          ? [N3: nat] :
            ( ( ord_less_eq @ nat @ M6 @ N3 )
            & ( member @ nat @ N3 @ S3 ) ) ) ) ).

% infinite_nat_iff_unbounded_le
thf(fact_4924_root__powr__inverse,axiom,
    ! [N2: nat,X2: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
       => ( ( root @ N2 @ X2 )
          = ( powr @ real @ X2 @ ( divide_divide @ real @ ( one_one @ real ) @ ( semiring_1_of_nat @ real @ N2 ) ) ) ) ) ) ).

% root_powr_inverse
thf(fact_4925_finite__nat__iff__bounded,axiom,
    ( ( finite_finite @ nat )
    = ( ^ [S6: set @ nat] :
        ? [K3: nat] : ( ord_less_eq @ ( set @ nat ) @ S6 @ ( set_ord_lessThan @ nat @ K3 ) ) ) ) ).

% finite_nat_iff_bounded
thf(fact_4926_finite__nat__bounded,axiom,
    ! [S3: set @ nat] :
      ( ( finite_finite @ nat @ S3 )
     => ? [K2: nat] : ( ord_less_eq @ ( set @ nat ) @ S3 @ ( set_ord_lessThan @ nat @ K2 ) ) ) ).

% finite_nat_bounded
thf(fact_4927_in__finite__psubset,axiom,
    ! [A: $tType,A3: set @ A,B3: set @ A] :
      ( ( member @ ( product_prod @ ( set @ A ) @ ( set @ A ) ) @ ( product_Pair @ ( set @ A ) @ ( set @ A ) @ A3 @ B3 ) @ ( finite_psubset @ A ) )
      = ( ( ord_less @ ( set @ A ) @ A3 @ B3 )
        & ( finite_finite @ A @ B3 ) ) ) ).

% in_finite_psubset
thf(fact_4928_sum__count__set,axiom,
    ! [A: $tType,Xs: list @ A,X8: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ Xs ) @ X8 )
     => ( ( finite_finite @ A @ X8 )
       => ( ( groups7311177749621191930dd_sum @ A @ nat @ ( count_list @ A @ Xs ) @ X8 )
          = ( size_size @ ( list @ A ) @ Xs ) ) ) ) ).

% sum_count_set
thf(fact_4929_sum__diff1_H__aux,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ab_group_add @ B )
     => ! [F3: set @ A,I6: set @ A,F2: A > B,I3: A] :
          ( ( finite_finite @ A @ F3 )
         => ( ( ord_less_eq @ ( set @ A )
              @ ( collect @ A
                @ ^ [I4: A] :
                    ( ( member @ A @ I4 @ I6 )
                    & ( ( F2 @ I4 )
                     != ( zero_zero @ B ) ) ) )
              @ F3 )
           => ( ( ( member @ A @ I3 @ I6 )
               => ( ( groups1027152243600224163dd_sum @ A @ B @ F2 @ ( minus_minus @ ( set @ A ) @ I6 @ ( insert @ A @ I3 @ ( bot_bot @ ( set @ A ) ) ) ) )
                  = ( minus_minus @ B @ ( groups1027152243600224163dd_sum @ A @ B @ F2 @ I6 ) @ ( F2 @ I3 ) ) ) )
              & ( ~ ( member @ A @ I3 @ I6 )
               => ( ( groups1027152243600224163dd_sum @ A @ B @ F2 @ ( minus_minus @ ( set @ A ) @ I6 @ ( insert @ A @ I3 @ ( bot_bot @ ( set @ A ) ) ) ) )
                  = ( groups1027152243600224163dd_sum @ A @ B @ F2 @ I6 ) ) ) ) ) ) ) ).

% sum_diff1'_aux
thf(fact_4930_sum_Oempty_H,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [P4: B > A] :
          ( ( groups1027152243600224163dd_sum @ B @ A @ P4 @ ( bot_bot @ ( set @ B ) ) )
          = ( zero_zero @ A ) ) ) ).

% sum.empty'
thf(fact_4931_count__notin,axiom,
    ! [A: $tType,X2: A,Xs: list @ A] :
      ( ~ ( member @ A @ X2 @ ( set2 @ A @ Xs ) )
     => ( ( count_list @ A @ Xs @ X2 )
        = ( zero_zero @ nat ) ) ) ).

% count_notin
thf(fact_4932_sum_Oinsert_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [I6: set @ B,P4: B > A,I3: B] :
          ( ( finite_finite @ B
            @ ( collect @ B
              @ ^ [X5: B] :
                  ( ( member @ B @ X5 @ I6 )
                  & ( ( P4 @ X5 )
                   != ( zero_zero @ A ) ) ) ) )
         => ( ( ( member @ B @ I3 @ I6 )
             => ( ( groups1027152243600224163dd_sum @ B @ A @ P4 @ ( insert @ B @ I3 @ I6 ) )
                = ( groups1027152243600224163dd_sum @ B @ A @ P4 @ I6 ) ) )
            & ( ~ ( member @ B @ I3 @ I6 )
             => ( ( groups1027152243600224163dd_sum @ B @ A @ P4 @ ( insert @ B @ I3 @ I6 ) )
                = ( plus_plus @ A @ ( P4 @ I3 ) @ ( groups1027152243600224163dd_sum @ B @ A @ P4 @ I6 ) ) ) ) ) ) ) ).

% sum.insert'
thf(fact_4933_sum_Onon__neutral_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: B > A,I6: set @ B] :
          ( ( groups1027152243600224163dd_sum @ B @ A @ G
            @ ( collect @ B
              @ ^ [X5: B] :
                  ( ( member @ B @ X5 @ I6 )
                  & ( ( G @ X5 )
                   != ( zero_zero @ A ) ) ) ) )
          = ( groups1027152243600224163dd_sum @ B @ A @ G @ I6 ) ) ) ).

% sum.non_neutral'
thf(fact_4934_sum_Odistrib__triv_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [I6: set @ B,G: B > A,H2: B > A] :
          ( ( finite_finite @ B @ I6 )
         => ( ( groups1027152243600224163dd_sum @ B @ A
              @ ^ [I4: B] : ( plus_plus @ A @ ( G @ I4 ) @ ( H2 @ I4 ) )
              @ I6 )
            = ( plus_plus @ A @ ( groups1027152243600224163dd_sum @ B @ A @ G @ I6 ) @ ( groups1027152243600224163dd_sum @ B @ A @ H2 @ I6 ) ) ) ) ) ).

% sum.distrib_triv'
thf(fact_4935_sum_Omono__neutral__left_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [S3: set @ B,T6: set @ B,G: B > A] :
          ( ( ord_less_eq @ ( set @ B ) @ S3 @ T6 )
         => ( ! [X3: B] :
                ( ( member @ B @ X3 @ ( minus_minus @ ( set @ B ) @ T6 @ S3 ) )
               => ( ( G @ X3 )
                  = ( zero_zero @ A ) ) )
           => ( ( groups1027152243600224163dd_sum @ B @ A @ G @ S3 )
              = ( groups1027152243600224163dd_sum @ B @ A @ G @ T6 ) ) ) ) ) ).

% sum.mono_neutral_left'
thf(fact_4936_sum_Omono__neutral__right_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [S3: set @ B,T6: set @ B,G: B > A] :
          ( ( ord_less_eq @ ( set @ B ) @ S3 @ T6 )
         => ( ! [X3: B] :
                ( ( member @ B @ X3 @ ( minus_minus @ ( set @ B ) @ T6 @ S3 ) )
               => ( ( G @ X3 )
                  = ( zero_zero @ A ) ) )
           => ( ( groups1027152243600224163dd_sum @ B @ A @ G @ T6 )
              = ( groups1027152243600224163dd_sum @ B @ A @ G @ S3 ) ) ) ) ) ).

% sum.mono_neutral_right'
thf(fact_4937_sum_Omono__neutral__cong__left_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [S3: set @ B,T6: set @ B,H2: B > A,G: B > A] :
          ( ( ord_less_eq @ ( set @ B ) @ S3 @ T6 )
         => ( ! [I2: B] :
                ( ( member @ B @ I2 @ ( minus_minus @ ( set @ B ) @ T6 @ S3 ) )
               => ( ( H2 @ I2 )
                  = ( zero_zero @ A ) ) )
           => ( ! [X3: B] :
                  ( ( member @ B @ X3 @ S3 )
                 => ( ( G @ X3 )
                    = ( H2 @ X3 ) ) )
             => ( ( groups1027152243600224163dd_sum @ B @ A @ G @ S3 )
                = ( groups1027152243600224163dd_sum @ B @ A @ H2 @ T6 ) ) ) ) ) ) ).

% sum.mono_neutral_cong_left'
thf(fact_4938_sum_Omono__neutral__cong__right_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [S3: set @ B,T6: set @ B,G: B > A,H2: B > A] :
          ( ( ord_less_eq @ ( set @ B ) @ S3 @ T6 )
         => ( ! [X3: B] :
                ( ( member @ B @ X3 @ ( minus_minus @ ( set @ B ) @ T6 @ S3 ) )
               => ( ( G @ X3 )
                  = ( zero_zero @ A ) ) )
           => ( ! [X3: B] :
                  ( ( member @ B @ X3 @ S3 )
                 => ( ( G @ X3 )
                    = ( H2 @ X3 ) ) )
             => ( ( groups1027152243600224163dd_sum @ B @ A @ G @ T6 )
                = ( groups1027152243600224163dd_sum @ B @ A @ H2 @ S3 ) ) ) ) ) ) ).

% sum.mono_neutral_cong_right'
thf(fact_4939_sum_Odistrib_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [I6: set @ B,G: B > A,H2: B > A] :
          ( ( finite_finite @ B
            @ ( collect @ B
              @ ^ [X5: B] :
                  ( ( member @ B @ X5 @ I6 )
                  & ( ( G @ X5 )
                   != ( zero_zero @ A ) ) ) ) )
         => ( ( finite_finite @ B
              @ ( collect @ B
                @ ^ [X5: B] :
                    ( ( member @ B @ X5 @ I6 )
                    & ( ( H2 @ X5 )
                     != ( zero_zero @ A ) ) ) ) )
           => ( ( groups1027152243600224163dd_sum @ B @ A
                @ ^ [I4: B] : ( plus_plus @ A @ ( G @ I4 ) @ ( H2 @ I4 ) )
                @ I6 )
              = ( plus_plus @ A @ ( groups1027152243600224163dd_sum @ B @ A @ G @ I6 ) @ ( groups1027152243600224163dd_sum @ B @ A @ H2 @ I6 ) ) ) ) ) ) ).

% sum.distrib'
thf(fact_4940_sum_OG__def,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ( ( groups1027152243600224163dd_sum @ B @ A )
        = ( ^ [P6: B > A,I8: set @ B] :
              ( if @ A
              @ ( finite_finite @ B
                @ ( collect @ B
                  @ ^ [X5: B] :
                      ( ( member @ B @ X5 @ I8 )
                      & ( ( P6 @ X5 )
                       != ( zero_zero @ A ) ) ) ) )
              @ ( groups7311177749621191930dd_sum @ B @ A @ P6
                @ ( collect @ B
                  @ ^ [X5: B] :
                      ( ( member @ B @ X5 @ I8 )
                      & ( ( P6 @ X5 )
                       != ( zero_zero @ A ) ) ) ) )
              @ ( zero_zero @ A ) ) ) ) ) ).

% sum.G_def
thf(fact_4941_count__le__length,axiom,
    ! [A: $tType,Xs: list @ A,X2: A] : ( ord_less_eq @ nat @ ( count_list @ A @ Xs @ X2 ) @ ( size_size @ ( list @ A ) @ Xs ) ) ).

% count_le_length
thf(fact_4942_sum__diff1_H,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ab_group_add @ B )
     => ! [I6: set @ A,F2: A > B,I3: A] :
          ( ( finite_finite @ A
            @ ( collect @ A
              @ ^ [I4: A] :
                  ( ( member @ A @ I4 @ I6 )
                  & ( ( F2 @ I4 )
                   != ( zero_zero @ B ) ) ) ) )
         => ( ( ( member @ A @ I3 @ I6 )
             => ( ( groups1027152243600224163dd_sum @ A @ B @ F2 @ ( minus_minus @ ( set @ A ) @ I6 @ ( insert @ A @ I3 @ ( bot_bot @ ( set @ A ) ) ) ) )
                = ( minus_minus @ B @ ( groups1027152243600224163dd_sum @ A @ B @ F2 @ I6 ) @ ( F2 @ I3 ) ) ) )
            & ( ~ ( member @ A @ I3 @ I6 )
             => ( ( groups1027152243600224163dd_sum @ A @ B @ F2 @ ( minus_minus @ ( set @ A ) @ I6 @ ( insert @ A @ I3 @ ( bot_bot @ ( set @ A ) ) ) ) )
                = ( groups1027152243600224163dd_sum @ A @ B @ F2 @ I6 ) ) ) ) ) ) ).

% sum_diff1'
thf(fact_4943_finite__psubset__def,axiom,
    ! [A: $tType] :
      ( ( finite_psubset @ A )
      = ( collect @ ( product_prod @ ( set @ A ) @ ( set @ A ) )
        @ ( product_case_prod @ ( set @ A ) @ ( set @ A ) @ $o
          @ ^ [A7: set @ A,B8: set @ A] :
              ( ( ord_less @ ( set @ A ) @ A7 @ B8 )
              & ( finite_finite @ A @ B8 ) ) ) ) ) ).

% finite_psubset_def
thf(fact_4944_Cauchy__iff2,axiom,
    ( ( topolo3814608138187158403Cauchy @ real )
    = ( ^ [X4: nat > real] :
        ! [J3: nat] :
        ? [M9: nat] :
        ! [M6: nat] :
          ( ( ord_less_eq @ nat @ M9 @ M6 )
         => ! [N3: nat] :
              ( ( ord_less_eq @ nat @ M9 @ N3 )
             => ( ord_less @ real @ ( abs_abs @ real @ ( minus_minus @ real @ ( X4 @ M6 ) @ ( X4 @ N3 ) ) ) @ ( inverse_inverse @ real @ ( semiring_1_of_nat @ real @ ( suc @ J3 ) ) ) ) ) ) ) ) ).

% Cauchy_iff2
thf(fact_4945_length__subseqs,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( size_size @ ( list @ ( list @ A ) ) @ ( subseqs @ A @ Xs ) )
      = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( size_size @ ( list @ A ) @ Xs ) ) ) ).

% length_subseqs
thf(fact_4946_Code__Target__Int_Opositive__def,axiom,
    ( code_Target_positive
    = ( numeral_numeral @ int ) ) ).

% Code_Target_Int.positive_def
thf(fact_4947_subseqs__refl,axiom,
    ! [A: $tType,Xs: list @ A] : ( member @ ( list @ A ) @ Xs @ ( set2 @ ( list @ A ) @ ( subseqs @ A @ Xs ) ) ) ).

% subseqs_refl
thf(fact_4948_CauchyD,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X8: nat > A,E2: real] :
          ( ( topolo3814608138187158403Cauchy @ A @ X8 )
         => ( ( ord_less @ real @ ( zero_zero @ real ) @ E2 )
           => ? [M8: nat] :
              ! [M2: nat] :
                ( ( ord_less_eq @ nat @ M8 @ M2 )
               => ! [N9: nat] :
                    ( ( ord_less_eq @ nat @ M8 @ N9 )
                   => ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ ( X8 @ M2 ) @ ( X8 @ N9 ) ) ) @ E2 ) ) ) ) ) ) ).

% CauchyD
thf(fact_4949_CauchyI,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X8: nat > A] :
          ( ! [E: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ E )
             => ? [M10: nat] :
                ! [M3: nat] :
                  ( ( ord_less_eq @ nat @ M10 @ M3 )
                 => ! [N: nat] :
                      ( ( ord_less_eq @ nat @ M10 @ N )
                     => ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ ( X8 @ M3 ) @ ( X8 @ N ) ) ) @ E ) ) ) )
         => ( topolo3814608138187158403Cauchy @ A @ X8 ) ) ) ).

% CauchyI
thf(fact_4950_Cauchy__iff,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ( ( topolo3814608138187158403Cauchy @ A )
        = ( ^ [X4: nat > A] :
            ! [E4: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ E4 )
             => ? [M9: nat] :
                ! [M6: nat] :
                  ( ( ord_less_eq @ nat @ M9 @ M6 )
                 => ! [N3: nat] :
                      ( ( ord_less_eq @ nat @ M9 @ N3 )
                     => ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ ( X4 @ M6 ) @ ( X4 @ N3 ) ) ) @ E4 ) ) ) ) ) ) ) ).

% Cauchy_iff
thf(fact_4951_length__mul__elem,axiom,
    ! [A: $tType,Xs: list @ ( list @ A ),N2: nat] :
      ( ! [X3: list @ A] :
          ( ( member @ ( list @ A ) @ X3 @ ( set2 @ ( list @ A ) @ Xs ) )
         => ( ( size_size @ ( list @ A ) @ X3 )
            = N2 ) )
     => ( ( size_size @ ( list @ A ) @ ( concat @ A @ Xs ) )
        = ( times_times @ nat @ ( size_size @ ( list @ ( list @ A ) ) @ Xs ) @ N2 ) ) ) ).

% length_mul_elem
thf(fact_4952_divmod__step__integer__def,axiom,
    ( ( unique1321980374590559556d_step @ code_integer )
    = ( ^ [L2: num] :
          ( product_case_prod @ code_integer @ code_integer @ ( product_prod @ code_integer @ code_integer )
          @ ^ [Q4: code_integer,R5: code_integer] : ( if @ ( product_prod @ code_integer @ code_integer ) @ ( ord_less_eq @ code_integer @ ( numeral_numeral @ code_integer @ L2 ) @ R5 ) @ ( product_Pair @ code_integer @ code_integer @ ( plus_plus @ code_integer @ ( times_times @ code_integer @ ( numeral_numeral @ code_integer @ ( bit0 @ one2 ) ) @ Q4 ) @ ( one_one @ code_integer ) ) @ ( minus_minus @ code_integer @ R5 @ ( numeral_numeral @ code_integer @ L2 ) ) ) @ ( product_Pair @ code_integer @ code_integer @ ( times_times @ code_integer @ ( numeral_numeral @ code_integer @ ( bit0 @ one2 ) ) @ Q4 ) @ R5 ) ) ) ) ) ).

% divmod_step_integer_def
thf(fact_4953_csqrt_Osimps_I1_J,axiom,
    ! [Z: complex] :
      ( ( re @ ( csqrt @ Z ) )
      = ( sqrt @ ( divide_divide @ real @ ( plus_plus @ real @ ( real_V7770717601297561774m_norm @ complex @ Z ) @ ( re @ Z ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ).

% csqrt.simps(1)
thf(fact_4954_complex__Re__numeral,axiom,
    ! [V: num] :
      ( ( re @ ( numeral_numeral @ complex @ V ) )
      = ( numeral_numeral @ real @ V ) ) ).

% complex_Re_numeral
thf(fact_4955_Re__divide__of__nat,axiom,
    ! [Z: complex,N2: nat] :
      ( ( re @ ( divide_divide @ complex @ Z @ ( semiring_1_of_nat @ complex @ N2 ) ) )
      = ( divide_divide @ real @ ( re @ Z ) @ ( semiring_1_of_nat @ real @ N2 ) ) ) ).

% Re_divide_of_nat
thf(fact_4956_Re__divide__of__real,axiom,
    ! [Z: complex,R3: real] :
      ( ( re @ ( divide_divide @ complex @ Z @ ( real_Vector_of_real @ complex @ R3 ) ) )
      = ( divide_divide @ real @ ( re @ Z ) @ R3 ) ) ).

% Re_divide_of_real
thf(fact_4957_Re__sgn,axiom,
    ! [Z: complex] :
      ( ( re @ ( sgn_sgn @ complex @ Z ) )
      = ( divide_divide @ real @ ( re @ Z ) @ ( real_V7770717601297561774m_norm @ complex @ Z ) ) ) ).

% Re_sgn
thf(fact_4958_Re__divide__numeral,axiom,
    ! [Z: complex,W: num] :
      ( ( re @ ( divide_divide @ complex @ Z @ ( numeral_numeral @ complex @ W ) ) )
      = ( divide_divide @ real @ ( re @ Z ) @ ( numeral_numeral @ real @ W ) ) ) ).

% Re_divide_numeral
thf(fact_4959_cos__Arg__i__mult__zero,axiom,
    ! [Y2: complex] :
      ( ( Y2
       != ( zero_zero @ complex ) )
     => ( ( ( re @ Y2 )
          = ( zero_zero @ real ) )
       => ( ( cos @ real @ ( arg @ Y2 ) )
          = ( zero_zero @ real ) ) ) ) ).

% cos_Arg_i_mult_zero
thf(fact_4960_minus__integer__code_I1_J,axiom,
    ! [K: code_integer] :
      ( ( minus_minus @ code_integer @ K @ ( zero_zero @ code_integer ) )
      = K ) ).

% minus_integer_code(1)
thf(fact_4961_less__eq__integer__code_I1_J,axiom,
    ord_less_eq @ code_integer @ ( zero_zero @ code_integer ) @ ( zero_zero @ code_integer ) ).

% less_eq_integer_code(1)
thf(fact_4962_plus__integer__code_I1_J,axiom,
    ! [K: code_integer] :
      ( ( plus_plus @ code_integer @ K @ ( zero_zero @ code_integer ) )
      = K ) ).

% plus_integer_code(1)
thf(fact_4963_plus__integer__code_I2_J,axiom,
    ! [L: code_integer] :
      ( ( plus_plus @ code_integer @ ( zero_zero @ code_integer ) @ L )
      = L ) ).

% plus_integer_code(2)
thf(fact_4964_times__integer__code_I2_J,axiom,
    ! [L: code_integer] :
      ( ( times_times @ code_integer @ ( zero_zero @ code_integer ) @ L )
      = ( zero_zero @ code_integer ) ) ).

% times_integer_code(2)
thf(fact_4965_times__integer__code_I1_J,axiom,
    ! [K: code_integer] :
      ( ( times_times @ code_integer @ K @ ( zero_zero @ code_integer ) )
      = ( zero_zero @ code_integer ) ) ).

% times_integer_code(1)
thf(fact_4966_sgn__integer__code,axiom,
    ( ( sgn_sgn @ code_integer )
    = ( ^ [K3: code_integer] :
          ( if @ code_integer
          @ ( K3
            = ( zero_zero @ code_integer ) )
          @ ( zero_zero @ code_integer )
          @ ( if @ code_integer @ ( ord_less @ code_integer @ K3 @ ( zero_zero @ code_integer ) ) @ ( uminus_uminus @ code_integer @ ( one_one @ code_integer ) ) @ ( one_one @ code_integer ) ) ) ) ) ).

% sgn_integer_code
thf(fact_4967_minus__integer__code_I2_J,axiom,
    ! [L: code_integer] :
      ( ( minus_minus @ code_integer @ ( zero_zero @ code_integer ) @ L )
      = ( uminus_uminus @ code_integer @ L ) ) ).

% minus_integer_code(2)
thf(fact_4968_divmod__integer_H__def,axiom,
    ( ( unique8689654367752047608divmod @ code_integer )
    = ( ^ [M6: num,N3: num] : ( product_Pair @ code_integer @ code_integer @ ( divide_divide @ code_integer @ ( numeral_numeral @ code_integer @ M6 ) @ ( numeral_numeral @ code_integer @ N3 ) ) @ ( modulo_modulo @ code_integer @ ( numeral_numeral @ code_integer @ M6 ) @ ( numeral_numeral @ code_integer @ N3 ) ) ) ) ) ).

% divmod_integer'_def
thf(fact_4969_imaginary__unit_Osimps_I1_J,axiom,
    ( ( re @ imaginary_unit )
    = ( zero_zero @ real ) ) ).

% imaginary_unit.simps(1)
thf(fact_4970_complex__Re__le__cmod,axiom,
    ! [X2: complex] : ( ord_less_eq @ real @ ( re @ X2 ) @ ( real_V7770717601297561774m_norm @ complex @ X2 ) ) ).

% complex_Re_le_cmod
thf(fact_4971_zero__complex_Osimps_I1_J,axiom,
    ( ( re @ ( zero_zero @ complex ) )
    = ( zero_zero @ real ) ) ).

% zero_complex.simps(1)
thf(fact_4972_scaleR__complex_Osimps_I1_J,axiom,
    ! [R3: real,X2: complex] :
      ( ( re @ ( real_V8093663219630862766scaleR @ complex @ R3 @ X2 ) )
      = ( times_times @ real @ R3 @ ( re @ X2 ) ) ) ).

% scaleR_complex.simps(1)
thf(fact_4973_abs__Re__le__cmod,axiom,
    ! [X2: complex] : ( ord_less_eq @ real @ ( abs_abs @ real @ ( re @ X2 ) ) @ ( real_V7770717601297561774m_norm @ complex @ X2 ) ) ).

% abs_Re_le_cmod
thf(fact_4974_Re__csqrt,axiom,
    ! [Z: complex] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( re @ ( csqrt @ Z ) ) ) ).

% Re_csqrt
thf(fact_4975_zero__natural_Orsp,axiom,
    ( ( zero_zero @ nat )
    = ( zero_zero @ nat ) ) ).

% zero_natural.rsp
thf(fact_4976_zero__integer_Orsp,axiom,
    ( ( zero_zero @ int )
    = ( zero_zero @ int ) ) ).

% zero_integer.rsp
thf(fact_4977_one__natural_Orsp,axiom,
    ( ( one_one @ nat )
    = ( one_one @ nat ) ) ).

% one_natural.rsp
thf(fact_4978_cmod__plus__Re__le__0__iff,axiom,
    ! [Z: complex] :
      ( ( ord_less_eq @ real @ ( plus_plus @ real @ ( real_V7770717601297561774m_norm @ complex @ Z ) @ ( re @ Z ) ) @ ( zero_zero @ real ) )
      = ( ( re @ Z )
        = ( uminus_uminus @ real @ ( real_V7770717601297561774m_norm @ complex @ Z ) ) ) ) ).

% cmod_plus_Re_le_0_iff
thf(fact_4979_cos__n__Re__cis__pow__n,axiom,
    ! [N2: nat,A2: real] :
      ( ( cos @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N2 ) @ A2 ) )
      = ( re @ ( power_power @ complex @ ( cis @ A2 ) @ N2 ) ) ) ).

% cos_n_Re_cis_pow_n
thf(fact_4980_csqrt_Ocode,axiom,
    ( csqrt
    = ( ^ [Z6: complex] :
          ( complex2 @ ( sqrt @ ( divide_divide @ real @ ( plus_plus @ real @ ( real_V7770717601297561774m_norm @ complex @ Z6 ) @ ( re @ Z6 ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
          @ ( times_times @ real
            @ ( if @ real
              @ ( ( im @ Z6 )
                = ( zero_zero @ real ) )
              @ ( one_one @ real )
              @ ( sgn_sgn @ real @ ( im @ Z6 ) ) )
            @ ( sqrt @ ( divide_divide @ real @ ( minus_minus @ real @ ( real_V7770717601297561774m_norm @ complex @ Z6 ) @ ( re @ Z6 ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% csqrt.code
thf(fact_4981_csqrt_Osimps_I2_J,axiom,
    ! [Z: complex] :
      ( ( im @ ( csqrt @ Z ) )
      = ( times_times @ real
        @ ( if @ real
          @ ( ( im @ Z )
            = ( zero_zero @ real ) )
          @ ( one_one @ real )
          @ ( sgn_sgn @ real @ ( im @ Z ) ) )
        @ ( sqrt @ ( divide_divide @ real @ ( minus_minus @ real @ ( real_V7770717601297561774m_norm @ complex @ Z ) @ ( re @ Z ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ).

% csqrt.simps(2)
thf(fact_4982_integer__of__int__code,axiom,
    ( code_integer_of_int
    = ( ^ [K3: int] :
          ( if @ code_integer @ ( ord_less @ int @ K3 @ ( zero_zero @ int ) ) @ ( uminus_uminus @ code_integer @ ( code_integer_of_int @ ( uminus_uminus @ int @ K3 ) ) )
          @ ( if @ code_integer
            @ ( K3
              = ( zero_zero @ int ) )
            @ ( zero_zero @ code_integer )
            @ ( if @ code_integer
              @ ( ( modulo_modulo @ int @ K3 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) )
                = ( zero_zero @ int ) )
              @ ( times_times @ code_integer @ ( numeral_numeral @ code_integer @ ( bit0 @ one2 ) ) @ ( code_integer_of_int @ ( divide_divide @ int @ K3 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) )
              @ ( plus_plus @ code_integer @ ( times_times @ code_integer @ ( numeral_numeral @ code_integer @ ( bit0 @ one2 ) ) @ ( code_integer_of_int @ ( divide_divide @ int @ K3 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) @ ( one_one @ code_integer ) ) ) ) ) ) ) ).

% integer_of_int_code
thf(fact_4983_complex__Im__of__int,axiom,
    ! [Z: int] :
      ( ( im @ ( ring_1_of_int @ complex @ Z ) )
      = ( zero_zero @ real ) ) ).

% complex_Im_of_int
thf(fact_4984_complex__Im__fact,axiom,
    ! [N2: nat] :
      ( ( im @ ( semiring_char_0_fact @ complex @ N2 ) )
      = ( zero_zero @ real ) ) ).

% complex_Im_fact
thf(fact_4985_Im__complex__of__real,axiom,
    ! [Z: real] :
      ( ( im @ ( real_Vector_of_real @ complex @ Z ) )
      = ( zero_zero @ real ) ) ).

% Im_complex_of_real
thf(fact_4986_Im__power__real,axiom,
    ! [X2: complex,N2: nat] :
      ( ( ( im @ X2 )
        = ( zero_zero @ real ) )
     => ( ( im @ ( power_power @ complex @ X2 @ N2 ) )
        = ( zero_zero @ real ) ) ) ).

% Im_power_real
thf(fact_4987_complex__Im__numeral,axiom,
    ! [V: num] :
      ( ( im @ ( numeral_numeral @ complex @ V ) )
      = ( zero_zero @ real ) ) ).

% complex_Im_numeral
thf(fact_4988_complex__Im__of__nat,axiom,
    ! [N2: nat] :
      ( ( im @ ( semiring_1_of_nat @ complex @ N2 ) )
      = ( zero_zero @ real ) ) ).

% complex_Im_of_nat
thf(fact_4989_Im__i__times,axiom,
    ! [Z: complex] :
      ( ( im @ ( times_times @ complex @ imaginary_unit @ Z ) )
      = ( re @ Z ) ) ).

% Im_i_times
thf(fact_4990_Im__divide__of__real,axiom,
    ! [Z: complex,R3: real] :
      ( ( im @ ( divide_divide @ complex @ Z @ ( real_Vector_of_real @ complex @ R3 ) ) )
      = ( divide_divide @ real @ ( im @ Z ) @ R3 ) ) ).

% Im_divide_of_real
thf(fact_4991_Im__sgn,axiom,
    ! [Z: complex] :
      ( ( im @ ( sgn_sgn @ complex @ Z ) )
      = ( divide_divide @ real @ ( im @ Z ) @ ( real_V7770717601297561774m_norm @ complex @ Z ) ) ) ).

% Im_sgn
thf(fact_4992_Re__power__real,axiom,
    ! [X2: complex,N2: nat] :
      ( ( ( im @ X2 )
        = ( zero_zero @ real ) )
     => ( ( re @ ( power_power @ complex @ X2 @ N2 ) )
        = ( power_power @ real @ ( re @ X2 ) @ N2 ) ) ) ).

% Re_power_real
thf(fact_4993_Re__i__times,axiom,
    ! [Z: complex] :
      ( ( re @ ( times_times @ complex @ imaginary_unit @ Z ) )
      = ( uminus_uminus @ real @ ( im @ Z ) ) ) ).

% Re_i_times
thf(fact_4994_Im__divide__numeral,axiom,
    ! [Z: complex,W: num] :
      ( ( im @ ( divide_divide @ complex @ Z @ ( numeral_numeral @ complex @ W ) ) )
      = ( divide_divide @ real @ ( im @ Z ) @ ( numeral_numeral @ real @ W ) ) ) ).

% Im_divide_numeral
thf(fact_4995_Im__divide__of__nat,axiom,
    ! [Z: complex,N2: nat] :
      ( ( im @ ( divide_divide @ complex @ Z @ ( semiring_1_of_nat @ complex @ N2 ) ) )
      = ( divide_divide @ real @ ( im @ Z ) @ ( semiring_1_of_nat @ real @ N2 ) ) ) ).

% Im_divide_of_nat
thf(fact_4996_csqrt__of__real__nonneg,axiom,
    ! [X2: complex] :
      ( ( ( im @ X2 )
        = ( zero_zero @ real ) )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( re @ X2 ) )
       => ( ( csqrt @ X2 )
          = ( real_Vector_of_real @ complex @ ( sqrt @ ( re @ X2 ) ) ) ) ) ) ).

% csqrt_of_real_nonneg
thf(fact_4997_csqrt__minus,axiom,
    ! [X2: complex] :
      ( ( ( ord_less @ real @ ( im @ X2 ) @ ( zero_zero @ real ) )
        | ( ( ( im @ X2 )
            = ( zero_zero @ real ) )
          & ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( re @ X2 ) ) ) )
     => ( ( csqrt @ ( uminus_uminus @ complex @ X2 ) )
        = ( times_times @ complex @ imaginary_unit @ ( csqrt @ X2 ) ) ) ) ).

% csqrt_minus
thf(fact_4998_csqrt__of__real__nonpos,axiom,
    ! [X2: complex] :
      ( ( ( im @ X2 )
        = ( zero_zero @ real ) )
     => ( ( ord_less_eq @ real @ ( re @ X2 ) @ ( zero_zero @ real ) )
       => ( ( csqrt @ X2 )
          = ( times_times @ complex @ imaginary_unit @ ( real_Vector_of_real @ complex @ ( sqrt @ ( abs_abs @ real @ ( re @ X2 ) ) ) ) ) ) ) ) ).

% csqrt_of_real_nonpos
thf(fact_4999_less__integer_Oabs__eq,axiom,
    ! [Xa2: int,X2: int] :
      ( ( ord_less @ code_integer @ ( code_integer_of_int @ Xa2 ) @ ( code_integer_of_int @ X2 ) )
      = ( ord_less @ int @ Xa2 @ X2 ) ) ).

% less_integer.abs_eq
thf(fact_5000_zero__integer__def,axiom,
    ( ( zero_zero @ code_integer )
    = ( code_integer_of_int @ ( zero_zero @ int ) ) ) ).

% zero_integer_def
thf(fact_5001_less__integer__code_I1_J,axiom,
    ~ ( ord_less @ code_integer @ ( zero_zero @ code_integer ) @ ( zero_zero @ code_integer ) ) ).

% less_integer_code(1)
thf(fact_5002_divide__integer_Oabs__eq,axiom,
    ! [Xa2: int,X2: int] :
      ( ( divide_divide @ code_integer @ ( code_integer_of_int @ Xa2 ) @ ( code_integer_of_int @ X2 ) )
      = ( code_integer_of_int @ ( divide_divide @ int @ Xa2 @ X2 ) ) ) ).

% divide_integer.abs_eq
thf(fact_5003_uminus__integer__code_I1_J,axiom,
    ( ( uminus_uminus @ code_integer @ ( zero_zero @ code_integer ) )
    = ( zero_zero @ code_integer ) ) ).

% uminus_integer_code(1)
thf(fact_5004_abs__integer__code,axiom,
    ( ( abs_abs @ code_integer )
    = ( ^ [K3: code_integer] : ( if @ code_integer @ ( ord_less @ code_integer @ K3 @ ( zero_zero @ code_integer ) ) @ ( uminus_uminus @ code_integer @ K3 ) @ K3 ) ) ) ).

% abs_integer_code
thf(fact_5005_zero__complex_Osimps_I2_J,axiom,
    ( ( im @ ( zero_zero @ complex ) )
    = ( zero_zero @ real ) ) ).

% zero_complex.simps(2)
thf(fact_5006_one__complex_Osimps_I2_J,axiom,
    ( ( im @ ( one_one @ complex ) )
    = ( zero_zero @ real ) ) ).

% one_complex.simps(2)
thf(fact_5007_times__integer_Oabs__eq,axiom,
    ! [Xa2: int,X2: int] :
      ( ( times_times @ code_integer @ ( code_integer_of_int @ Xa2 ) @ ( code_integer_of_int @ X2 ) )
      = ( code_integer_of_int @ ( times_times @ int @ Xa2 @ X2 ) ) ) ).

% times_integer.abs_eq
thf(fact_5008_less__eq__integer_Oabs__eq,axiom,
    ! [Xa2: int,X2: int] :
      ( ( ord_less_eq @ code_integer @ ( code_integer_of_int @ Xa2 ) @ ( code_integer_of_int @ X2 ) )
      = ( ord_less_eq @ int @ Xa2 @ X2 ) ) ).

% less_eq_integer.abs_eq
thf(fact_5009_scaleR__complex_Osimps_I2_J,axiom,
    ! [R3: real,X2: complex] :
      ( ( im @ ( real_V8093663219630862766scaleR @ complex @ R3 @ X2 ) )
      = ( times_times @ real @ R3 @ ( im @ X2 ) ) ) ).

% scaleR_complex.simps(2)
thf(fact_5010_complex__is__Int__iff,axiom,
    ! [Z: complex] :
      ( ( member @ complex @ Z @ ( ring_1_Ints @ complex ) )
      = ( ( ( im @ Z )
          = ( zero_zero @ real ) )
        & ? [I4: int] :
            ( ( re @ Z )
            = ( ring_1_of_int @ real @ I4 ) ) ) ) ).

% complex_is_Int_iff
thf(fact_5011_abs__Im__le__cmod,axiom,
    ! [X2: complex] : ( ord_less_eq @ real @ ( abs_abs @ real @ ( im @ X2 ) ) @ ( real_V7770717601297561774m_norm @ complex @ X2 ) ) ).

% abs_Im_le_cmod
thf(fact_5012_times__complex_Osimps_I2_J,axiom,
    ! [X2: complex,Y2: complex] :
      ( ( im @ ( times_times @ complex @ X2 @ Y2 ) )
      = ( plus_plus @ real @ ( times_times @ real @ ( re @ X2 ) @ ( im @ Y2 ) ) @ ( times_times @ real @ ( im @ X2 ) @ ( re @ Y2 ) ) ) ) ).

% times_complex.simps(2)
thf(fact_5013_Im__eq__0,axiom,
    ! [Z: complex] :
      ( ( ( abs_abs @ real @ ( re @ Z ) )
        = ( real_V7770717601297561774m_norm @ complex @ Z ) )
     => ( ( im @ Z )
        = ( zero_zero @ real ) ) ) ).

% Im_eq_0
thf(fact_5014_cmod__eq__Im,axiom,
    ! [Z: complex] :
      ( ( ( re @ Z )
        = ( zero_zero @ real ) )
     => ( ( real_V7770717601297561774m_norm @ complex @ Z )
        = ( abs_abs @ real @ ( im @ Z ) ) ) ) ).

% cmod_eq_Im
thf(fact_5015_cmod__eq__Re,axiom,
    ! [Z: complex] :
      ( ( ( im @ Z )
        = ( zero_zero @ real ) )
     => ( ( real_V7770717601297561774m_norm @ complex @ Z )
        = ( abs_abs @ real @ ( re @ Z ) ) ) ) ).

% cmod_eq_Re
thf(fact_5016_cmod__Re__le__iff,axiom,
    ! [X2: complex,Y2: complex] :
      ( ( ( im @ X2 )
        = ( im @ Y2 ) )
     => ( ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ complex @ X2 ) @ ( real_V7770717601297561774m_norm @ complex @ Y2 ) )
        = ( ord_less_eq @ real @ ( abs_abs @ real @ ( re @ X2 ) ) @ ( abs_abs @ real @ ( re @ Y2 ) ) ) ) ) ).

% cmod_Re_le_iff
thf(fact_5017_cmod__Im__le__iff,axiom,
    ! [X2: complex,Y2: complex] :
      ( ( ( re @ X2 )
        = ( re @ Y2 ) )
     => ( ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ complex @ X2 ) @ ( real_V7770717601297561774m_norm @ complex @ Y2 ) )
        = ( ord_less_eq @ real @ ( abs_abs @ real @ ( im @ X2 ) ) @ ( abs_abs @ real @ ( im @ Y2 ) ) ) ) ) ).

% cmod_Im_le_iff
thf(fact_5018_times__complex_Osimps_I1_J,axiom,
    ! [X2: complex,Y2: complex] :
      ( ( re @ ( times_times @ complex @ X2 @ Y2 ) )
      = ( minus_minus @ real @ ( times_times @ real @ ( re @ X2 ) @ ( re @ Y2 ) ) @ ( times_times @ real @ ( im @ X2 ) @ ( im @ Y2 ) ) ) ) ).

% times_complex.simps(1)
thf(fact_5019_scaleR__complex_Ocode,axiom,
    ( ( real_V8093663219630862766scaleR @ complex )
    = ( ^ [R5: real,X5: complex] : ( complex2 @ ( times_times @ real @ R5 @ ( re @ X5 ) ) @ ( times_times @ real @ R5 @ ( im @ X5 ) ) ) ) ) ).

% scaleR_complex.code
thf(fact_5020_csqrt__principal,axiom,
    ! [Z: complex] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ ( re @ ( csqrt @ Z ) ) )
      | ( ( ( re @ ( csqrt @ Z ) )
          = ( zero_zero @ real ) )
        & ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( im @ ( csqrt @ Z ) ) ) ) ) ).

% csqrt_principal
thf(fact_5021_cmod__le,axiom,
    ! [Z: complex] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ complex @ Z ) @ ( plus_plus @ real @ ( abs_abs @ real @ ( re @ Z ) ) @ ( abs_abs @ real @ ( im @ Z ) ) ) ) ).

% cmod_le
thf(fact_5022_sin__n__Im__cis__pow__n,axiom,
    ! [N2: nat,A2: real] :
      ( ( sin @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N2 ) @ A2 ) )
      = ( im @ ( power_power @ complex @ ( cis @ A2 ) @ N2 ) ) ) ).

% sin_n_Im_cis_pow_n
thf(fact_5023_Re__exp,axiom,
    ! [Z: complex] :
      ( ( re @ ( exp @ complex @ Z ) )
      = ( times_times @ real @ ( exp @ real @ ( re @ Z ) ) @ ( cos @ real @ ( im @ Z ) ) ) ) ).

% Re_exp
thf(fact_5024_Im__exp,axiom,
    ! [Z: complex] :
      ( ( im @ ( exp @ complex @ Z ) )
      = ( times_times @ real @ ( exp @ real @ ( re @ Z ) ) @ ( sin @ real @ ( im @ Z ) ) ) ) ).

% Im_exp
thf(fact_5025_fun__complex__eq,axiom,
    ! [A: $tType,F2: A > complex] :
      ( F2
      = ( ^ [X5: A] : ( plus_plus @ complex @ ( real_Vector_of_real @ complex @ ( re @ ( F2 @ X5 ) ) ) @ ( times_times @ complex @ imaginary_unit @ ( real_Vector_of_real @ complex @ ( im @ ( F2 @ X5 ) ) ) ) ) ) ) ).

% fun_complex_eq
thf(fact_5026_complex__eq,axiom,
    ! [A2: complex] :
      ( A2
      = ( plus_plus @ complex @ ( real_Vector_of_real @ complex @ ( re @ A2 ) ) @ ( times_times @ complex @ imaginary_unit @ ( real_Vector_of_real @ complex @ ( im @ A2 ) ) ) ) ) ).

% complex_eq
thf(fact_5027_times__complex_Ocode,axiom,
    ( ( times_times @ complex )
    = ( ^ [X5: complex,Y5: complex] : ( complex2 @ ( minus_minus @ real @ ( times_times @ real @ ( re @ X5 ) @ ( re @ Y5 ) ) @ ( times_times @ real @ ( im @ X5 ) @ ( im @ Y5 ) ) ) @ ( plus_plus @ real @ ( times_times @ real @ ( re @ X5 ) @ ( im @ Y5 ) ) @ ( times_times @ real @ ( im @ X5 ) @ ( re @ Y5 ) ) ) ) ) ) ).

% times_complex.code
thf(fact_5028_exp__eq__polar,axiom,
    ( ( exp @ complex )
    = ( ^ [Z6: complex] : ( times_times @ complex @ ( real_Vector_of_real @ complex @ ( exp @ real @ ( re @ Z6 ) ) ) @ ( cis @ ( im @ Z6 ) ) ) ) ) ).

% exp_eq_polar
thf(fact_5029_cmod__power2,axiom,
    ! [Z: complex] :
      ( ( power_power @ real @ ( real_V7770717601297561774m_norm @ complex @ Z ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
      = ( plus_plus @ real @ ( power_power @ real @ ( re @ Z ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ ( im @ Z ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ).

% cmod_power2
thf(fact_5030_Im__power2,axiom,
    ! [X2: complex] :
      ( ( im @ ( power_power @ complex @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
      = ( times_times @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( re @ X2 ) ) @ ( im @ X2 ) ) ) ).

% Im_power2
thf(fact_5031_Re__power2,axiom,
    ! [X2: complex] :
      ( ( re @ ( power_power @ complex @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
      = ( minus_minus @ real @ ( power_power @ real @ ( re @ X2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ ( im @ X2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ).

% Re_power2
thf(fact_5032_complex__eq__0,axiom,
    ! [Z: complex] :
      ( ( Z
        = ( zero_zero @ complex ) )
      = ( ( plus_plus @ real @ ( power_power @ real @ ( re @ Z ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ ( im @ Z ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
        = ( zero_zero @ real ) ) ) ).

% complex_eq_0
thf(fact_5033_norm__complex__def,axiom,
    ( ( real_V7770717601297561774m_norm @ complex )
    = ( ^ [Z6: complex] : ( sqrt @ ( plus_plus @ real @ ( power_power @ real @ ( re @ Z6 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ ( im @ Z6 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% norm_complex_def
thf(fact_5034_inverse__complex_Osimps_I1_J,axiom,
    ! [X2: complex] :
      ( ( re @ ( inverse_inverse @ complex @ X2 ) )
      = ( divide_divide @ real @ ( re @ X2 ) @ ( plus_plus @ real @ ( power_power @ real @ ( re @ X2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ ( im @ X2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% inverse_complex.simps(1)
thf(fact_5035_complex__neq__0,axiom,
    ! [Z: complex] :
      ( ( ( Z
         != ( zero_zero @ complex ) ) )
      = ( ord_less @ real @ ( zero_zero @ real ) @ ( plus_plus @ real @ ( power_power @ real @ ( re @ Z ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ ( im @ Z ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% complex_neq_0
thf(fact_5036_Re__divide,axiom,
    ! [X2: complex,Y2: complex] :
      ( ( re @ ( divide_divide @ complex @ X2 @ Y2 ) )
      = ( divide_divide @ real @ ( plus_plus @ real @ ( times_times @ real @ ( re @ X2 ) @ ( re @ Y2 ) ) @ ( times_times @ real @ ( im @ X2 ) @ ( im @ Y2 ) ) ) @ ( plus_plus @ real @ ( power_power @ real @ ( re @ Y2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ ( im @ Y2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% Re_divide
thf(fact_5037_csqrt__square,axiom,
    ! [B2: complex] :
      ( ( ( ord_less @ real @ ( zero_zero @ real ) @ ( re @ B2 ) )
        | ( ( ( re @ B2 )
            = ( zero_zero @ real ) )
          & ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( im @ B2 ) ) ) )
     => ( ( csqrt @ ( power_power @ complex @ B2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
        = B2 ) ) ).

% csqrt_square
thf(fact_5038_csqrt__unique,axiom,
    ! [W: complex,Z: complex] :
      ( ( ( power_power @ complex @ W @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
        = Z )
     => ( ( ( ord_less @ real @ ( zero_zero @ real ) @ ( re @ W ) )
          | ( ( ( re @ W )
              = ( zero_zero @ real ) )
            & ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( im @ W ) ) ) )
       => ( ( csqrt @ Z )
          = W ) ) ) ).

% csqrt_unique
thf(fact_5039_inverse__complex_Osimps_I2_J,axiom,
    ! [X2: complex] :
      ( ( im @ ( inverse_inverse @ complex @ X2 ) )
      = ( divide_divide @ real @ ( uminus_uminus @ real @ ( im @ X2 ) ) @ ( plus_plus @ real @ ( power_power @ real @ ( re @ X2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ ( im @ X2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% inverse_complex.simps(2)
thf(fact_5040_Im__divide,axiom,
    ! [X2: complex,Y2: complex] :
      ( ( im @ ( divide_divide @ complex @ X2 @ Y2 ) )
      = ( divide_divide @ real @ ( minus_minus @ real @ ( times_times @ real @ ( im @ X2 ) @ ( re @ Y2 ) ) @ ( times_times @ real @ ( re @ X2 ) @ ( im @ Y2 ) ) ) @ ( plus_plus @ real @ ( power_power @ real @ ( re @ Y2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ ( im @ Y2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% Im_divide
thf(fact_5041_complex__abs__le__norm,axiom,
    ! [Z: complex] : ( ord_less_eq @ real @ ( plus_plus @ real @ ( abs_abs @ real @ ( re @ Z ) ) @ ( abs_abs @ real @ ( im @ Z ) ) ) @ ( times_times @ real @ ( sqrt @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( real_V7770717601297561774m_norm @ complex @ Z ) ) ) ).

% complex_abs_le_norm
thf(fact_5042_complex__unit__circle,axiom,
    ! [Z: complex] :
      ( ( Z
       != ( zero_zero @ complex ) )
     => ( ( plus_plus @ real @ ( power_power @ real @ ( divide_divide @ real @ ( re @ Z ) @ ( real_V7770717601297561774m_norm @ complex @ Z ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ ( divide_divide @ real @ ( im @ Z ) @ ( real_V7770717601297561774m_norm @ complex @ Z ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
        = ( one_one @ real ) ) ) ).

% complex_unit_circle
thf(fact_5043_inverse__complex_Ocode,axiom,
    ( ( inverse_inverse @ complex )
    = ( ^ [X5: complex] : ( complex2 @ ( divide_divide @ real @ ( re @ X5 ) @ ( plus_plus @ real @ ( power_power @ real @ ( re @ X5 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ ( im @ X5 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( divide_divide @ real @ ( uminus_uminus @ real @ ( im @ X5 ) ) @ ( plus_plus @ real @ ( power_power @ real @ ( re @ X5 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ ( im @ X5 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% inverse_complex.code
thf(fact_5044_Complex__divide,axiom,
    ( ( divide_divide @ complex )
    = ( ^ [X5: complex,Y5: complex] : ( complex2 @ ( divide_divide @ real @ ( plus_plus @ real @ ( times_times @ real @ ( re @ X5 ) @ ( re @ Y5 ) ) @ ( times_times @ real @ ( im @ X5 ) @ ( im @ Y5 ) ) ) @ ( plus_plus @ real @ ( power_power @ real @ ( re @ Y5 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ ( im @ Y5 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( divide_divide @ real @ ( minus_minus @ real @ ( times_times @ real @ ( im @ X5 ) @ ( re @ Y5 ) ) @ ( times_times @ real @ ( re @ X5 ) @ ( im @ Y5 ) ) ) @ ( plus_plus @ real @ ( power_power @ real @ ( re @ Y5 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ ( im @ Y5 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% Complex_divide
thf(fact_5045_Im__Reals__divide,axiom,
    ! [R3: complex,Z: complex] :
      ( ( member @ complex @ R3 @ ( real_Vector_Reals @ complex ) )
     => ( ( im @ ( divide_divide @ complex @ R3 @ Z ) )
        = ( divide_divide @ real @ ( times_times @ real @ ( uminus_uminus @ real @ ( re @ R3 ) ) @ ( im @ Z ) ) @ ( power_power @ real @ ( real_V7770717601297561774m_norm @ complex @ Z ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% Im_Reals_divide
thf(fact_5046_Re__Reals__divide,axiom,
    ! [R3: complex,Z: complex] :
      ( ( member @ complex @ R3 @ ( real_Vector_Reals @ complex ) )
     => ( ( re @ ( divide_divide @ complex @ R3 @ Z ) )
        = ( divide_divide @ real @ ( times_times @ real @ ( re @ R3 ) @ ( re @ Z ) ) @ ( power_power @ real @ ( real_V7770717601297561774m_norm @ complex @ Z ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% Re_Reals_divide
thf(fact_5047_Code__Numeral_Opositive__def,axiom,
    ( code_positive
    = ( numeral_numeral @ code_integer ) ) ).

% Code_Numeral.positive_def
thf(fact_5048_Re__divide__Reals,axiom,
    ! [R3: complex,Z: complex] :
      ( ( member @ complex @ R3 @ ( real_Vector_Reals @ complex ) )
     => ( ( re @ ( divide_divide @ complex @ Z @ R3 ) )
        = ( divide_divide @ real @ ( re @ Z ) @ ( re @ R3 ) ) ) ) ).

% Re_divide_Reals
thf(fact_5049_imaginary__eq__real__iff,axiom,
    ! [Y2: complex,X2: complex] :
      ( ( member @ complex @ Y2 @ ( real_Vector_Reals @ complex ) )
     => ( ( member @ complex @ X2 @ ( real_Vector_Reals @ complex ) )
       => ( ( ( times_times @ complex @ imaginary_unit @ Y2 )
            = X2 )
          = ( ( X2
              = ( zero_zero @ complex ) )
            & ( Y2
              = ( zero_zero @ complex ) ) ) ) ) ) ).

% imaginary_eq_real_iff
thf(fact_5050_real__eq__imaginary__iff,axiom,
    ! [Y2: complex,X2: complex] :
      ( ( member @ complex @ Y2 @ ( real_Vector_Reals @ complex ) )
     => ( ( member @ complex @ X2 @ ( real_Vector_Reals @ complex ) )
       => ( ( X2
            = ( times_times @ complex @ imaginary_unit @ Y2 ) )
          = ( ( X2
              = ( zero_zero @ complex ) )
            & ( Y2
              = ( zero_zero @ complex ) ) ) ) ) ) ).

% real_eq_imaginary_iff
thf(fact_5051_Im__divide__Reals,axiom,
    ! [R3: complex,Z: complex] :
      ( ( member @ complex @ R3 @ ( real_Vector_Reals @ complex ) )
     => ( ( im @ ( divide_divide @ complex @ Z @ R3 ) )
        = ( divide_divide @ real @ ( im @ Z ) @ ( re @ R3 ) ) ) ) ).

% Im_divide_Reals
thf(fact_5052_Reals__divide,axiom,
    ! [A: $tType] :
      ( ( real_V7773925162809079976_field @ A )
     => ! [A2: A,B2: A] :
          ( ( member @ A @ A2 @ ( real_Vector_Reals @ A ) )
         => ( ( member @ A @ B2 @ ( real_Vector_Reals @ A ) )
           => ( member @ A @ ( divide_divide @ A @ A2 @ B2 ) @ ( real_Vector_Reals @ A ) ) ) ) ) ).

% Reals_divide
thf(fact_5053_Reals__0,axiom,
    ! [A: $tType] :
      ( ( real_V2191834092415804123ebra_1 @ A )
     => ( member @ A @ ( zero_zero @ A ) @ ( real_Vector_Reals @ A ) ) ) ).

% Reals_0
thf(fact_5054_Reals__power,axiom,
    ! [A: $tType] :
      ( ( real_V2191834092415804123ebra_1 @ A )
     => ! [A2: A,N2: nat] :
          ( ( member @ A @ A2 @ ( real_Vector_Reals @ A ) )
         => ( member @ A @ ( power_power @ A @ A2 @ N2 ) @ ( real_Vector_Reals @ A ) ) ) ) ).

% Reals_power
thf(fact_5055_Reals__numeral,axiom,
    ! [A: $tType] :
      ( ( real_V2191834092415804123ebra_1 @ A )
     => ! [W: num] : ( member @ A @ ( numeral_numeral @ A @ W ) @ ( real_Vector_Reals @ A ) ) ) ).

% Reals_numeral
thf(fact_5056_Reals__mult,axiom,
    ! [A: $tType] :
      ( ( real_V2191834092415804123ebra_1 @ A )
     => ! [A2: A,B2: A] :
          ( ( member @ A @ A2 @ ( real_Vector_Reals @ A ) )
         => ( ( member @ A @ B2 @ ( real_Vector_Reals @ A ) )
           => ( member @ A @ ( times_times @ A @ A2 @ B2 ) @ ( real_Vector_Reals @ A ) ) ) ) ) ).

% Reals_mult
thf(fact_5057_Reals__1,axiom,
    ! [B: $tType] :
      ( ( real_V2191834092415804123ebra_1 @ B )
     => ( member @ B @ ( one_one @ B ) @ ( real_Vector_Reals @ B ) ) ) ).

% Reals_1
thf(fact_5058_Reals__add,axiom,
    ! [A: $tType] :
      ( ( real_V2191834092415804123ebra_1 @ A )
     => ! [A2: A,B2: A] :
          ( ( member @ A @ A2 @ ( real_Vector_Reals @ A ) )
         => ( ( member @ A @ B2 @ ( real_Vector_Reals @ A ) )
           => ( member @ A @ ( plus_plus @ A @ A2 @ B2 ) @ ( real_Vector_Reals @ A ) ) ) ) ) ).

% Reals_add
thf(fact_5059_complex__is__Real__iff,axiom,
    ! [Z: complex] :
      ( ( member @ complex @ Z @ ( real_Vector_Reals @ complex ) )
      = ( ( im @ Z )
        = ( zero_zero @ real ) ) ) ).

% complex_is_Real_iff
thf(fact_5060_nonzero__Reals__divide,axiom,
    ! [A: $tType] :
      ( ( real_V7773925162809079976_field @ A )
     => ! [A2: A,B2: A] :
          ( ( member @ A @ A2 @ ( real_Vector_Reals @ A ) )
         => ( ( member @ A @ B2 @ ( real_Vector_Reals @ A ) )
           => ( ( B2
               != ( zero_zero @ A ) )
             => ( member @ A @ ( divide_divide @ A @ A2 @ B2 ) @ ( real_Vector_Reals @ A ) ) ) ) ) ) ).

% nonzero_Reals_divide
thf(fact_5061_Complex__in__Reals,axiom,
    ! [X2: real] : ( member @ complex @ ( complex2 @ X2 @ ( zero_zero @ real ) ) @ ( real_Vector_Reals @ complex ) ) ).

% Complex_in_Reals
thf(fact_5062_nonzero__Reals__inverse,axiom,
    ! [A: $tType] :
      ( ( real_V5047593784448816457lgebra @ A )
     => ! [A2: A] :
          ( ( member @ A @ A2 @ ( real_Vector_Reals @ A ) )
         => ( ( A2
             != ( zero_zero @ A ) )
           => ( member @ A @ ( inverse_inverse @ A @ A2 ) @ ( real_Vector_Reals @ A ) ) ) ) ) ).

% nonzero_Reals_inverse
thf(fact_5063_series__comparison__complex,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach @ A )
     => ! [G: nat > complex,N4: nat,F2: nat > A] :
          ( ( summable @ complex @ G )
         => ( ! [N: nat] : ( member @ complex @ ( G @ N ) @ ( real_Vector_Reals @ complex ) )
           => ( ! [N: nat] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( re @ ( G @ N ) ) )
             => ( ! [N: nat] :
                    ( ( ord_less_eq @ nat @ N4 @ N )
                   => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( F2 @ N ) ) @ ( real_V7770717601297561774m_norm @ complex @ ( G @ N ) ) ) )
               => ( summable @ A @ F2 ) ) ) ) ) ) ).

% series_comparison_complex
thf(fact_5064_set__n__lists,axiom,
    ! [A: $tType,N2: nat,Xs: list @ A] :
      ( ( set2 @ ( list @ A ) @ ( n_lists @ A @ N2 @ Xs ) )
      = ( collect @ ( list @ A )
        @ ^ [Ys3: list @ A] :
            ( ( ( size_size @ ( list @ A ) @ Ys3 )
              = N2 )
            & ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ Ys3 ) @ ( set2 @ A @ Xs ) ) ) ) ) ).

% set_n_lists
thf(fact_5065_complex__mult__cnj,axiom,
    ! [Z: complex] :
      ( ( times_times @ complex @ Z @ ( cnj @ Z ) )
      = ( real_Vector_of_real @ complex @ ( plus_plus @ real @ ( power_power @ real @ ( re @ Z ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ ( im @ Z ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% complex_mult_cnj
thf(fact_5066_int__of__integer__code,axiom,
    ( code_int_of_integer
    = ( ^ [K3: code_integer] :
          ( if @ int @ ( ord_less @ code_integer @ K3 @ ( zero_zero @ code_integer ) ) @ ( uminus_uminus @ int @ ( code_int_of_integer @ ( uminus_uminus @ code_integer @ K3 ) ) )
          @ ( if @ int
            @ ( K3
              = ( zero_zero @ code_integer ) )
            @ ( zero_zero @ int )
            @ ( product_case_prod @ code_integer @ code_integer @ int
              @ ^ [L2: code_integer,J3: code_integer] :
                  ( if @ int
                  @ ( J3
                    = ( zero_zero @ code_integer ) )
                  @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( code_int_of_integer @ L2 ) )
                  @ ( plus_plus @ int @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( code_int_of_integer @ L2 ) ) @ ( one_one @ int ) ) )
              @ ( code_divmod_integer @ K3 @ ( numeral_numeral @ code_integer @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% int_of_integer_code
thf(fact_5067_complex__cnj__mult,axiom,
    ! [X2: complex,Y2: complex] :
      ( ( cnj @ ( times_times @ complex @ X2 @ Y2 ) )
      = ( times_times @ complex @ ( cnj @ X2 ) @ ( cnj @ Y2 ) ) ) ).

% complex_cnj_mult
thf(fact_5068_complex__cnj__divide,axiom,
    ! [X2: complex,Y2: complex] :
      ( ( cnj @ ( divide_divide @ complex @ X2 @ Y2 ) )
      = ( divide_divide @ complex @ ( cnj @ X2 ) @ ( cnj @ Y2 ) ) ) ).

% complex_cnj_divide
thf(fact_5069_complex__cnj__zero__iff,axiom,
    ! [Z: complex] :
      ( ( ( cnj @ Z )
        = ( zero_zero @ complex ) )
      = ( Z
        = ( zero_zero @ complex ) ) ) ).

% complex_cnj_zero_iff
thf(fact_5070_complex__cnj__zero,axiom,
    ( ( cnj @ ( zero_zero @ complex ) )
    = ( zero_zero @ complex ) ) ).

% complex_cnj_zero
thf(fact_5071_complex__cnj__power,axiom,
    ! [X2: complex,N2: nat] :
      ( ( cnj @ ( power_power @ complex @ X2 @ N2 ) )
      = ( power_power @ complex @ ( cnj @ X2 ) @ N2 ) ) ).

% complex_cnj_power
thf(fact_5072_complex__cnj__numeral,axiom,
    ! [W: num] :
      ( ( cnj @ ( numeral_numeral @ complex @ W ) )
      = ( numeral_numeral @ complex @ W ) ) ).

% complex_cnj_numeral
thf(fact_5073_zero__integer_Orep__eq,axiom,
    ( ( code_int_of_integer @ ( zero_zero @ code_integer ) )
    = ( zero_zero @ int ) ) ).

% zero_integer.rep_eq
thf(fact_5074_int__of__integer__numeral,axiom,
    ! [K: num] :
      ( ( code_int_of_integer @ ( numeral_numeral @ code_integer @ K ) )
      = ( numeral_numeral @ int @ K ) ) ).

% int_of_integer_numeral
thf(fact_5075_times__integer_Orep__eq,axiom,
    ! [X2: code_integer,Xa2: code_integer] :
      ( ( code_int_of_integer @ ( times_times @ code_integer @ X2 @ Xa2 ) )
      = ( times_times @ int @ ( code_int_of_integer @ X2 ) @ ( code_int_of_integer @ Xa2 ) ) ) ).

% times_integer.rep_eq
thf(fact_5076_divide__integer_Orep__eq,axiom,
    ! [X2: code_integer,Xa2: code_integer] :
      ( ( code_int_of_integer @ ( divide_divide @ code_integer @ X2 @ Xa2 ) )
      = ( divide_divide @ int @ ( code_int_of_integer @ X2 ) @ ( code_int_of_integer @ Xa2 ) ) ) ).

% divide_integer.rep_eq
thf(fact_5077_complex__cnj__neg__numeral,axiom,
    ! [W: num] :
      ( ( cnj @ ( uminus_uminus @ complex @ ( numeral_numeral @ complex @ W ) ) )
      = ( uminus_uminus @ complex @ ( numeral_numeral @ complex @ W ) ) ) ).

% complex_cnj_neg_numeral
thf(fact_5078_complex__In__mult__cnj__zero,axiom,
    ! [Z: complex] :
      ( ( im @ ( times_times @ complex @ Z @ ( cnj @ Z ) ) )
      = ( zero_zero @ real ) ) ).

% complex_In_mult_cnj_zero
thf(fact_5079_integer__less__iff,axiom,
    ( ( ord_less @ code_integer )
    = ( ^ [K3: code_integer,L2: code_integer] : ( ord_less @ int @ ( code_int_of_integer @ K3 ) @ ( code_int_of_integer @ L2 ) ) ) ) ).

% integer_less_iff
thf(fact_5080_less__integer_Orep__eq,axiom,
    ( ( ord_less @ code_integer )
    = ( ^ [X5: code_integer,Xa4: code_integer] : ( ord_less @ int @ ( code_int_of_integer @ X5 ) @ ( code_int_of_integer @ Xa4 ) ) ) ) ).

% less_integer.rep_eq
thf(fact_5081_integer__less__eq__iff,axiom,
    ( ( ord_less_eq @ code_integer )
    = ( ^ [K3: code_integer,L2: code_integer] : ( ord_less_eq @ int @ ( code_int_of_integer @ K3 ) @ ( code_int_of_integer @ L2 ) ) ) ) ).

% integer_less_eq_iff
thf(fact_5082_less__eq__integer_Orep__eq,axiom,
    ( ( ord_less_eq @ code_integer )
    = ( ^ [X5: code_integer,Xa4: code_integer] : ( ord_less_eq @ int @ ( code_int_of_integer @ X5 ) @ ( code_int_of_integer @ Xa4 ) ) ) ) ).

% less_eq_integer.rep_eq
thf(fact_5083_Re__complex__div__eq__0,axiom,
    ! [A2: complex,B2: complex] :
      ( ( ( re @ ( divide_divide @ complex @ A2 @ B2 ) )
        = ( zero_zero @ real ) )
      = ( ( re @ ( times_times @ complex @ A2 @ ( cnj @ B2 ) ) )
        = ( zero_zero @ real ) ) ) ).

% Re_complex_div_eq_0
thf(fact_5084_Im__complex__div__eq__0,axiom,
    ! [A2: complex,B2: complex] :
      ( ( ( im @ ( divide_divide @ complex @ A2 @ B2 ) )
        = ( zero_zero @ real ) )
      = ( ( im @ ( times_times @ complex @ A2 @ ( cnj @ B2 ) ) )
        = ( zero_zero @ real ) ) ) ).

% Im_complex_div_eq_0
thf(fact_5085_complex__mod__sqrt__Re__mult__cnj,axiom,
    ( ( real_V7770717601297561774m_norm @ complex )
    = ( ^ [Z6: complex] : ( sqrt @ ( re @ ( times_times @ complex @ Z6 @ ( cnj @ Z6 ) ) ) ) ) ) ).

% complex_mod_sqrt_Re_mult_cnj
thf(fact_5086_length__n__lists__elem,axiom,
    ! [A: $tType,Ys: list @ A,N2: nat,Xs: list @ A] :
      ( ( member @ ( list @ A ) @ Ys @ ( set2 @ ( list @ A ) @ ( n_lists @ A @ N2 @ Xs ) ) )
     => ( ( size_size @ ( list @ A ) @ Ys )
        = N2 ) ) ).

% length_n_lists_elem
thf(fact_5087_Re__complex__div__lt__0,axiom,
    ! [A2: complex,B2: complex] :
      ( ( ord_less @ real @ ( re @ ( divide_divide @ complex @ A2 @ B2 ) ) @ ( zero_zero @ real ) )
      = ( ord_less @ real @ ( re @ ( times_times @ complex @ A2 @ ( cnj @ B2 ) ) ) @ ( zero_zero @ real ) ) ) ).

% Re_complex_div_lt_0
thf(fact_5088_Re__complex__div__gt__0,axiom,
    ! [A2: complex,B2: complex] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ ( re @ ( divide_divide @ complex @ A2 @ B2 ) ) )
      = ( ord_less @ real @ ( zero_zero @ real ) @ ( re @ ( times_times @ complex @ A2 @ ( cnj @ B2 ) ) ) ) ) ).

% Re_complex_div_gt_0
thf(fact_5089_Re__complex__div__ge__0,axiom,
    ! [A2: complex,B2: complex] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( re @ ( divide_divide @ complex @ A2 @ B2 ) ) )
      = ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( re @ ( times_times @ complex @ A2 @ ( cnj @ B2 ) ) ) ) ) ).

% Re_complex_div_ge_0
thf(fact_5090_Re__complex__div__le__0,axiom,
    ! [A2: complex,B2: complex] :
      ( ( ord_less_eq @ real @ ( re @ ( divide_divide @ complex @ A2 @ B2 ) ) @ ( zero_zero @ real ) )
      = ( ord_less_eq @ real @ ( re @ ( times_times @ complex @ A2 @ ( cnj @ B2 ) ) ) @ ( zero_zero @ real ) ) ) ).

% Re_complex_div_le_0
thf(fact_5091_Im__complex__div__lt__0,axiom,
    ! [A2: complex,B2: complex] :
      ( ( ord_less @ real @ ( im @ ( divide_divide @ complex @ A2 @ B2 ) ) @ ( zero_zero @ real ) )
      = ( ord_less @ real @ ( im @ ( times_times @ complex @ A2 @ ( cnj @ B2 ) ) ) @ ( zero_zero @ real ) ) ) ).

% Im_complex_div_lt_0
thf(fact_5092_Im__complex__div__gt__0,axiom,
    ! [A2: complex,B2: complex] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ ( im @ ( divide_divide @ complex @ A2 @ B2 ) ) )
      = ( ord_less @ real @ ( zero_zero @ real ) @ ( im @ ( times_times @ complex @ A2 @ ( cnj @ B2 ) ) ) ) ) ).

% Im_complex_div_gt_0
thf(fact_5093_Im__complex__div__ge__0,axiom,
    ! [A2: complex,B2: complex] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( im @ ( divide_divide @ complex @ A2 @ B2 ) ) )
      = ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( im @ ( times_times @ complex @ A2 @ ( cnj @ B2 ) ) ) ) ) ).

% Im_complex_div_ge_0
thf(fact_5094_Im__complex__div__le__0,axiom,
    ! [A2: complex,B2: complex] :
      ( ( ord_less_eq @ real @ ( im @ ( divide_divide @ complex @ A2 @ B2 ) ) @ ( zero_zero @ real ) )
      = ( ord_less_eq @ real @ ( im @ ( times_times @ complex @ A2 @ ( cnj @ B2 ) ) ) @ ( zero_zero @ real ) ) ) ).

% Im_complex_div_le_0
thf(fact_5095_complex__mod__mult__cnj,axiom,
    ! [Z: complex] :
      ( ( real_V7770717601297561774m_norm @ complex @ ( times_times @ complex @ Z @ ( cnj @ Z ) ) )
      = ( power_power @ real @ ( real_V7770717601297561774m_norm @ complex @ Z ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ).

% complex_mod_mult_cnj
thf(fact_5096_complex__div__gt__0,axiom,
    ! [A2: complex,B2: complex] :
      ( ( ( ord_less @ real @ ( zero_zero @ real ) @ ( re @ ( divide_divide @ complex @ A2 @ B2 ) ) )
        = ( ord_less @ real @ ( zero_zero @ real ) @ ( re @ ( times_times @ complex @ A2 @ ( cnj @ B2 ) ) ) ) )
      & ( ( ord_less @ real @ ( zero_zero @ real ) @ ( im @ ( divide_divide @ complex @ A2 @ B2 ) ) )
        = ( ord_less @ real @ ( zero_zero @ real ) @ ( im @ ( times_times @ complex @ A2 @ ( cnj @ B2 ) ) ) ) ) ) ).

% complex_div_gt_0
thf(fact_5097_length__n__lists,axiom,
    ! [A: $tType,N2: nat,Xs: list @ A] :
      ( ( size_size @ ( list @ ( list @ A ) ) @ ( n_lists @ A @ N2 @ Xs ) )
      = ( power_power @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ N2 ) ) ).

% length_n_lists
thf(fact_5098_complex__norm__square,axiom,
    ! [Z: complex] :
      ( ( real_Vector_of_real @ complex @ ( power_power @ real @ ( real_V7770717601297561774m_norm @ complex @ Z ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
      = ( times_times @ complex @ Z @ ( cnj @ Z ) ) ) ).

% complex_norm_square
thf(fact_5099_complex__add__cnj,axiom,
    ! [Z: complex] :
      ( ( plus_plus @ complex @ Z @ ( cnj @ Z ) )
      = ( real_Vector_of_real @ complex @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( re @ Z ) ) ) ) ).

% complex_add_cnj
thf(fact_5100_complex__diff__cnj,axiom,
    ! [Z: complex] :
      ( ( minus_minus @ complex @ Z @ ( cnj @ Z ) )
      = ( times_times @ complex @ ( real_Vector_of_real @ complex @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( im @ Z ) ) ) @ imaginary_unit ) ) ).

% complex_diff_cnj
thf(fact_5101_complex__div__cnj,axiom,
    ( ( divide_divide @ complex )
    = ( ^ [A4: complex,B4: complex] : ( divide_divide @ complex @ ( times_times @ complex @ A4 @ ( cnj @ B4 ) ) @ ( real_Vector_of_real @ complex @ ( power_power @ real @ ( real_V7770717601297561774m_norm @ complex @ B4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% complex_div_cnj
thf(fact_5102_cnj__add__mult__eq__Re,axiom,
    ! [Z: complex,W: complex] :
      ( ( plus_plus @ complex @ ( times_times @ complex @ Z @ ( cnj @ W ) ) @ ( times_times @ complex @ ( cnj @ Z ) @ W ) )
      = ( real_Vector_of_real @ complex @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( re @ ( times_times @ complex @ Z @ ( cnj @ W ) ) ) ) ) ) ).

% cnj_add_mult_eq_Re
thf(fact_5103_divmod__integer__def,axiom,
    ( code_divmod_integer
    = ( ^ [K3: code_integer,L2: code_integer] : ( product_Pair @ code_integer @ code_integer @ ( divide_divide @ code_integer @ K3 @ L2 ) @ ( modulo_modulo @ code_integer @ K3 @ L2 ) ) ) ) ).

% divmod_integer_def
thf(fact_5104_num__of__integer__code,axiom,
    ( code_num_of_integer
    = ( ^ [K3: code_integer] :
          ( if @ num @ ( ord_less_eq @ code_integer @ K3 @ ( one_one @ code_integer ) ) @ one2
          @ ( product_case_prod @ code_integer @ code_integer @ num
            @ ^ [L2: code_integer,J3: code_integer] :
                ( if @ num
                @ ( J3
                  = ( zero_zero @ code_integer ) )
                @ ( plus_plus @ num @ ( code_num_of_integer @ L2 ) @ ( code_num_of_integer @ L2 ) )
                @ ( plus_plus @ num @ ( plus_plus @ num @ ( code_num_of_integer @ L2 ) @ ( code_num_of_integer @ L2 ) ) @ one2 ) )
            @ ( code_divmod_integer @ K3 @ ( numeral_numeral @ code_integer @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% num_of_integer_code
thf(fact_5105_nat__of__integer__code,axiom,
    ( code_nat_of_integer
    = ( ^ [K3: code_integer] :
          ( if @ nat @ ( ord_less_eq @ code_integer @ K3 @ ( zero_zero @ code_integer ) ) @ ( zero_zero @ nat )
          @ ( product_case_prod @ code_integer @ code_integer @ nat
            @ ^ [L2: code_integer,J3: code_integer] :
                ( if @ nat
                @ ( J3
                  = ( zero_zero @ code_integer ) )
                @ ( plus_plus @ nat @ ( code_nat_of_integer @ L2 ) @ ( code_nat_of_integer @ L2 ) )
                @ ( plus_plus @ nat @ ( plus_plus @ nat @ ( code_nat_of_integer @ L2 ) @ ( code_nat_of_integer @ L2 ) ) @ ( one_one @ nat ) ) )
            @ ( code_divmod_integer @ K3 @ ( numeral_numeral @ code_integer @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% nat_of_integer_code
thf(fact_5106_bit__cut__integer__def,axiom,
    ( code_bit_cut_integer
    = ( ^ [K3: code_integer] :
          ( product_Pair @ code_integer @ $o @ ( divide_divide @ code_integer @ K3 @ ( numeral_numeral @ code_integer @ ( bit0 @ one2 ) ) )
          @ ~ ( dvd_dvd @ code_integer @ ( numeral_numeral @ code_integer @ ( bit0 @ one2 ) ) @ K3 ) ) ) ) ).

% bit_cut_integer_def
thf(fact_5107_of__nat__of__integer,axiom,
    ! [K: code_integer] :
      ( ( semiring_1_of_nat @ code_integer @ ( code_nat_of_integer @ K ) )
      = ( ord_max @ code_integer @ ( zero_zero @ code_integer ) @ K ) ) ).

% of_nat_of_integer
thf(fact_5108_nat__of__integer__non__positive,axiom,
    ! [K: code_integer] :
      ( ( ord_less_eq @ code_integer @ K @ ( zero_zero @ code_integer ) )
     => ( ( code_nat_of_integer @ K )
        = ( zero_zero @ nat ) ) ) ).

% nat_of_integer_non_positive
thf(fact_5109_nat__of__integer__code__post_I1_J,axiom,
    ( ( code_nat_of_integer @ ( zero_zero @ code_integer ) )
    = ( zero_zero @ nat ) ) ).

% nat_of_integer_code_post(1)
thf(fact_5110_nat__of__integer__code__post_I3_J,axiom,
    ! [K: num] :
      ( ( code_nat_of_integer @ ( numeral_numeral @ code_integer @ K ) )
      = ( numeral_numeral @ nat @ K ) ) ).

% nat_of_integer_code_post(3)
thf(fact_5111_nat__of__integer__code__post_I2_J,axiom,
    ( ( code_nat_of_integer @ ( one_one @ code_integer ) )
    = ( one_one @ nat ) ) ).

% nat_of_integer_code_post(2)
thf(fact_5112_bit__cut__integer__code,axiom,
    ( code_bit_cut_integer
    = ( ^ [K3: code_integer] :
          ( if @ ( product_prod @ code_integer @ $o )
          @ ( K3
            = ( zero_zero @ code_integer ) )
          @ ( product_Pair @ code_integer @ $o @ ( zero_zero @ code_integer ) @ $false )
          @ ( product_case_prod @ code_integer @ code_integer @ ( product_prod @ code_integer @ $o )
            @ ^ [R5: code_integer,S7: code_integer] :
                ( product_Pair @ code_integer @ $o @ ( if @ code_integer @ ( ord_less @ code_integer @ ( zero_zero @ code_integer ) @ K3 ) @ R5 @ ( minus_minus @ code_integer @ ( uminus_uminus @ code_integer @ R5 ) @ S7 ) )
                @ ( S7
                  = ( one_one @ code_integer ) ) )
            @ ( code_divmod_abs @ K3 @ ( numeral_numeral @ code_integer @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% bit_cut_integer_code
thf(fact_5113_even__sum__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( semiring_parity @ A )
     => ! [A3: set @ B,F2: B > A] :
          ( ( finite_finite @ B @ A3 )
         => ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ A3 ) )
            = ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) )
              @ ( finite_card @ B
                @ ( collect @ B
                  @ ^ [A4: B] :
                      ( ( member @ B @ A4 @ A3 )
                      & ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( F2 @ A4 ) ) ) ) ) ) ) ) ) ).

% even_sum_iff
thf(fact_5114_divmod__abs__def,axiom,
    ( code_divmod_abs
    = ( ^ [K3: code_integer,L2: code_integer] : ( product_Pair @ code_integer @ code_integer @ ( divide_divide @ code_integer @ ( abs_abs @ code_integer @ K3 ) @ ( abs_abs @ code_integer @ L2 ) ) @ ( modulo_modulo @ code_integer @ ( abs_abs @ code_integer @ K3 ) @ ( abs_abs @ code_integer @ L2 ) ) ) ) ) ).

% divmod_abs_def
thf(fact_5115_card__Collect__less__nat,axiom,
    ! [N2: nat] :
      ( ( finite_card @ nat
        @ ( collect @ nat
          @ ^ [I4: nat] : ( ord_less @ nat @ I4 @ N2 ) ) )
      = N2 ) ).

% card_Collect_less_nat
thf(fact_5116_card__atMost,axiom,
    ! [U: nat] :
      ( ( finite_card @ nat @ ( set_ord_atMost @ nat @ U ) )
      = ( suc @ U ) ) ).

% card_atMost
thf(fact_5117_card__Collect__le__nat,axiom,
    ! [N2: nat] :
      ( ( finite_card @ nat
        @ ( collect @ nat
          @ ^ [I4: nat] : ( ord_less_eq @ nat @ I4 @ N2 ) ) )
      = ( suc @ N2 ) ) ).

% card_Collect_le_nat
thf(fact_5118_card_Oempty,axiom,
    ! [A: $tType] :
      ( ( finite_card @ A @ ( bot_bot @ ( set @ A ) ) )
      = ( zero_zero @ nat ) ) ).

% card.empty
thf(fact_5119_card_Oinfinite,axiom,
    ! [A: $tType,A3: set @ A] :
      ( ~ ( finite_finite @ A @ A3 )
     => ( ( finite_card @ A @ A3 )
        = ( zero_zero @ nat ) ) ) ).

% card.infinite
thf(fact_5120_card__atLeastAtMost,axiom,
    ! [L: nat,U: nat] :
      ( ( finite_card @ nat @ ( set_or1337092689740270186AtMost @ nat @ L @ U ) )
      = ( minus_minus @ nat @ ( suc @ U ) @ L ) ) ).

% card_atLeastAtMost
thf(fact_5121_prod__constant,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [Y2: A,A3: set @ B] :
          ( ( groups7121269368397514597t_prod @ B @ A
            @ ^ [X5: B] : Y2
            @ A3 )
          = ( power_power @ A @ Y2 @ ( finite_card @ B @ A3 ) ) ) ) ).

% prod_constant
thf(fact_5122_card__0__eq,axiom,
    ! [A: $tType,A3: set @ A] :
      ( ( finite_finite @ A @ A3 )
     => ( ( ( finite_card @ A @ A3 )
          = ( zero_zero @ nat ) )
        = ( A3
          = ( bot_bot @ ( set @ A ) ) ) ) ) ).

% card_0_eq
thf(fact_5123_card__insert__disjoint,axiom,
    ! [A: $tType,A3: set @ A,X2: A] :
      ( ( finite_finite @ A @ A3 )
     => ( ~ ( member @ A @ X2 @ A3 )
       => ( ( finite_card @ A @ ( insert @ A @ X2 @ A3 ) )
          = ( suc @ ( finite_card @ A @ A3 ) ) ) ) ) ).

% card_insert_disjoint
thf(fact_5124_sum__constant,axiom,
    ! [B: $tType,A: $tType] :
      ( ( semiring_1 @ A )
     => ! [Y2: A,A3: set @ B] :
          ( ( groups7311177749621191930dd_sum @ B @ A
            @ ^ [X5: B] : Y2
            @ A3 )
          = ( times_times @ A @ ( semiring_1_of_nat @ A @ ( finite_card @ B @ A3 ) ) @ Y2 ) ) ) ).

% sum_constant
thf(fact_5125_card__Diff__insert,axiom,
    ! [A: $tType,A2: A,A3: set @ A,B3: set @ A] :
      ( ( member @ A @ A2 @ A3 )
     => ( ~ ( member @ A @ A2 @ B3 )
       => ( ( finite_card @ A @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ A2 @ B3 ) ) )
          = ( minus_minus @ nat @ ( finite_card @ A @ ( minus_minus @ ( set @ A ) @ A3 @ B3 ) ) @ ( one_one @ nat ) ) ) ) ) ).

% card_Diff_insert
thf(fact_5126_n__subsets,axiom,
    ! [A: $tType,A3: set @ A,K: nat] :
      ( ( finite_finite @ A @ A3 )
     => ( ( finite_card @ ( set @ A )
          @ ( collect @ ( set @ A )
            @ ^ [B8: set @ A] :
                ( ( ord_less_eq @ ( set @ A ) @ B8 @ A3 )
                & ( ( finite_card @ A @ B8 )
                  = K ) ) ) )
        = ( binomial @ ( finite_card @ A @ A3 ) @ K ) ) ) ).

% n_subsets
thf(fact_5127_card__subset__eq,axiom,
    ! [A: $tType,B3: set @ A,A3: set @ A] :
      ( ( finite_finite @ A @ B3 )
     => ( ( ord_less_eq @ ( set @ A ) @ A3 @ B3 )
       => ( ( ( finite_card @ A @ A3 )
            = ( finite_card @ A @ B3 ) )
         => ( A3 = B3 ) ) ) ) ).

% card_subset_eq
thf(fact_5128_infinite__arbitrarily__large,axiom,
    ! [A: $tType,A3: set @ A,N2: nat] :
      ( ~ ( finite_finite @ A @ A3 )
     => ? [B9: set @ A] :
          ( ( finite_finite @ A @ B9 )
          & ( ( finite_card @ A @ B9 )
            = N2 )
          & ( ord_less_eq @ ( set @ A ) @ B9 @ A3 ) ) ) ).

% infinite_arbitrarily_large
thf(fact_5129_card__le__if__inj__on__rel,axiom,
    ! [B: $tType,A: $tType,B3: set @ A,A3: set @ B,R3: B > A > $o] :
      ( ( finite_finite @ A @ B3 )
     => ( ! [A5: B] :
            ( ( member @ B @ A5 @ A3 )
           => ? [B11: A] :
                ( ( member @ A @ B11 @ B3 )
                & ( R3 @ A5 @ B11 ) ) )
       => ( ! [A13: B,A24: B,B5: A] :
              ( ( member @ B @ A13 @ A3 )
             => ( ( member @ B @ A24 @ A3 )
               => ( ( member @ A @ B5 @ B3 )
                 => ( ( R3 @ A13 @ B5 )
                   => ( ( R3 @ A24 @ B5 )
                     => ( A13 = A24 ) ) ) ) ) )
         => ( ord_less_eq @ nat @ ( finite_card @ B @ A3 ) @ ( finite_card @ A @ B3 ) ) ) ) ) ).

% card_le_if_inj_on_rel
thf(fact_5130_card__insert__le,axiom,
    ! [A: $tType,A3: set @ A,X2: A] : ( ord_less_eq @ nat @ ( finite_card @ A @ A3 ) @ ( finite_card @ A @ ( insert @ A @ X2 @ A3 ) ) ) ).

% card_insert_le
thf(fact_5131_card__lists__length__eq,axiom,
    ! [A: $tType,A3: set @ A,N2: nat] :
      ( ( finite_finite @ A @ A3 )
     => ( ( finite_card @ ( list @ A )
          @ ( collect @ ( list @ A )
            @ ^ [Xs3: list @ A] :
                ( ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ Xs3 ) @ A3 )
                & ( ( size_size @ ( list @ A ) @ Xs3 )
                  = N2 ) ) ) )
        = ( power_power @ nat @ ( finite_card @ A @ A3 ) @ N2 ) ) ) ).

% card_lists_length_eq
thf(fact_5132_card__eq__sum,axiom,
    ! [A: $tType] :
      ( ( finite_card @ A )
      = ( groups7311177749621191930dd_sum @ A @ nat
        @ ^ [X5: A] : ( one_one @ nat ) ) ) ).

% card_eq_sum
thf(fact_5133_card__2__iff_H,axiom,
    ! [A: $tType,S3: set @ A] :
      ( ( ( finite_card @ A @ S3 )
        = ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
      = ( ? [X5: A] :
            ( ( member @ A @ X5 @ S3 )
            & ? [Y5: A] :
                ( ( member @ A @ Y5 @ S3 )
                & ( X5 != Y5 )
                & ! [Z6: A] :
                    ( ( member @ A @ Z6 @ S3 )
                   => ( ( Z6 = X5 )
                      | ( Z6 = Y5 ) ) ) ) ) ) ) ).

% card_2_iff'
thf(fact_5134_card__eq__0__iff,axiom,
    ! [A: $tType,A3: set @ A] :
      ( ( ( finite_card @ A @ A3 )
        = ( zero_zero @ nat ) )
      = ( ( A3
          = ( bot_bot @ ( set @ A ) ) )
        | ~ ( finite_finite @ A @ A3 ) ) ) ).

% card_eq_0_iff
thf(fact_5135_card__ge__0__finite,axiom,
    ! [A: $tType,A3: set @ A] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( finite_card @ A @ A3 ) )
     => ( finite_finite @ A @ A3 ) ) ).

% card_ge_0_finite
thf(fact_5136_card__Suc__eq__finite,axiom,
    ! [A: $tType,A3: set @ A,K: nat] :
      ( ( ( finite_card @ A @ A3 )
        = ( suc @ K ) )
      = ( ? [B4: A,B8: set @ A] :
            ( ( A3
              = ( insert @ A @ B4 @ B8 ) )
            & ~ ( member @ A @ B4 @ B8 )
            & ( ( finite_card @ A @ B8 )
              = K )
            & ( finite_finite @ A @ B8 ) ) ) ) ).

% card_Suc_eq_finite
thf(fact_5137_card__insert__if,axiom,
    ! [A: $tType,A3: set @ A,X2: A] :
      ( ( finite_finite @ A @ A3 )
     => ( ( ( member @ A @ X2 @ A3 )
         => ( ( finite_card @ A @ ( insert @ A @ X2 @ A3 ) )
            = ( finite_card @ A @ A3 ) ) )
        & ( ~ ( member @ A @ X2 @ A3 )
         => ( ( finite_card @ A @ ( insert @ A @ X2 @ A3 ) )
            = ( suc @ ( finite_card @ A @ A3 ) ) ) ) ) ) ).

% card_insert_if
thf(fact_5138_obtain__subset__with__card__n,axiom,
    ! [A: $tType,N2: nat,S3: set @ A] :
      ( ( ord_less_eq @ nat @ N2 @ ( finite_card @ A @ S3 ) )
     => ~ ! [T7: set @ A] :
            ( ( ord_less_eq @ ( set @ A ) @ T7 @ S3 )
           => ( ( ( finite_card @ A @ T7 )
                = N2 )
             => ~ ( finite_finite @ A @ T7 ) ) ) ) ).

% obtain_subset_with_card_n
thf(fact_5139_card__mono,axiom,
    ! [A: $tType,B3: set @ A,A3: set @ A] :
      ( ( finite_finite @ A @ B3 )
     => ( ( ord_less_eq @ ( set @ A ) @ A3 @ B3 )
       => ( ord_less_eq @ nat @ ( finite_card @ A @ A3 ) @ ( finite_card @ A @ B3 ) ) ) ) ).

% card_mono
thf(fact_5140_card__seteq,axiom,
    ! [A: $tType,B3: set @ A,A3: set @ A] :
      ( ( finite_finite @ A @ B3 )
     => ( ( ord_less_eq @ ( set @ A ) @ A3 @ B3 )
       => ( ( ord_less_eq @ nat @ ( finite_card @ A @ B3 ) @ ( finite_card @ A @ A3 ) )
         => ( A3 = B3 ) ) ) ) ).

% card_seteq
thf(fact_5141_finite__if__finite__subsets__card__bdd,axiom,
    ! [A: $tType,F3: set @ A,C6: nat] :
      ( ! [G5: set @ A] :
          ( ( ord_less_eq @ ( set @ A ) @ G5 @ F3 )
         => ( ( finite_finite @ A @ G5 )
           => ( ord_less_eq @ nat @ ( finite_card @ A @ G5 ) @ C6 ) ) )
     => ( ( finite_finite @ A @ F3 )
        & ( ord_less_eq @ nat @ ( finite_card @ A @ F3 ) @ C6 ) ) ) ).

% finite_if_finite_subsets_card_bdd
thf(fact_5142_card__less__sym__Diff,axiom,
    ! [A: $tType,A3: set @ A,B3: set @ A] :
      ( ( finite_finite @ A @ A3 )
     => ( ( finite_finite @ A @ B3 )
       => ( ( ord_less @ nat @ ( finite_card @ A @ A3 ) @ ( finite_card @ A @ B3 ) )
         => ( ord_less @ nat @ ( finite_card @ A @ ( minus_minus @ ( set @ A ) @ A3 @ B3 ) ) @ ( finite_card @ A @ ( minus_minus @ ( set @ A ) @ B3 @ A3 ) ) ) ) ) ) ).

% card_less_sym_Diff
thf(fact_5143_card__le__sym__Diff,axiom,
    ! [A: $tType,A3: set @ A,B3: set @ A] :
      ( ( finite_finite @ A @ A3 )
     => ( ( finite_finite @ A @ B3 )
       => ( ( ord_less_eq @ nat @ ( finite_card @ A @ A3 ) @ ( finite_card @ A @ B3 ) )
         => ( ord_less_eq @ nat @ ( finite_card @ A @ ( minus_minus @ ( set @ A ) @ A3 @ B3 ) ) @ ( finite_card @ A @ ( minus_minus @ ( set @ A ) @ B3 @ A3 ) ) ) ) ) ) ).

% card_le_sym_Diff
thf(fact_5144_card__length,axiom,
    ! [A: $tType,Xs: list @ A] : ( ord_less_eq @ nat @ ( finite_card @ A @ ( set2 @ A @ Xs ) ) @ ( size_size @ ( list @ A ) @ Xs ) ) ).

% card_length
thf(fact_5145_card__1__singletonE,axiom,
    ! [A: $tType,A3: set @ A] :
      ( ( ( finite_card @ A @ A3 )
        = ( one_one @ nat ) )
     => ~ ! [X3: A] :
            ( A3
           != ( insert @ A @ X3 @ ( bot_bot @ ( set @ A ) ) ) ) ) ).

% card_1_singletonE
thf(fact_5146_ex__bij__betw__finite__nat,axiom,
    ! [A: $tType,M7: set @ A] :
      ( ( finite_finite @ A @ M7 )
     => ? [H4: A > nat] : ( bij_betw @ A @ nat @ H4 @ M7 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( finite_card @ A @ M7 ) ) ) ) ).

% ex_bij_betw_finite_nat
thf(fact_5147_psubset__card__mono,axiom,
    ! [A: $tType,B3: set @ A,A3: set @ A] :
      ( ( finite_finite @ A @ B3 )
     => ( ( ord_less @ ( set @ A ) @ A3 @ B3 )
       => ( ord_less @ nat @ ( finite_card @ A @ A3 ) @ ( finite_card @ A @ B3 ) ) ) ) ).

% psubset_card_mono
thf(fact_5148_card__less__Suc2,axiom,
    ! [M7: set @ nat,I3: nat] :
      ( ~ ( member @ nat @ ( zero_zero @ nat ) @ M7 )
     => ( ( finite_card @ nat
          @ ( collect @ nat
            @ ^ [K3: nat] :
                ( ( member @ nat @ ( suc @ K3 ) @ M7 )
                & ( ord_less @ nat @ K3 @ I3 ) ) ) )
        = ( finite_card @ nat
          @ ( collect @ nat
            @ ^ [K3: nat] :
                ( ( member @ nat @ K3 @ M7 )
                & ( ord_less @ nat @ K3 @ ( suc @ I3 ) ) ) ) ) ) ) ).

% card_less_Suc2
thf(fact_5149_card__less__Suc,axiom,
    ! [M7: set @ nat,I3: nat] :
      ( ( member @ nat @ ( zero_zero @ nat ) @ M7 )
     => ( ( suc
          @ ( finite_card @ nat
            @ ( collect @ nat
              @ ^ [K3: nat] :
                  ( ( member @ nat @ ( suc @ K3 ) @ M7 )
                  & ( ord_less @ nat @ K3 @ I3 ) ) ) ) )
        = ( finite_card @ nat
          @ ( collect @ nat
            @ ^ [K3: nat] :
                ( ( member @ nat @ K3 @ M7 )
                & ( ord_less @ nat @ K3 @ ( suc @ I3 ) ) ) ) ) ) ) ).

% card_less_Suc
thf(fact_5150_card__less,axiom,
    ! [M7: set @ nat,I3: nat] :
      ( ( member @ nat @ ( zero_zero @ nat ) @ M7 )
     => ( ( finite_card @ nat
          @ ( collect @ nat
            @ ^ [K3: nat] :
                ( ( member @ nat @ K3 @ M7 )
                & ( ord_less @ nat @ K3 @ ( suc @ I3 ) ) ) ) )
       != ( zero_zero @ nat ) ) ) ).

% card_less
thf(fact_5151_card__atLeastZeroLessThan__int,axiom,
    ! [U: int] :
      ( ( finite_card @ int @ ( set_or7035219750837199246ssThan @ int @ ( zero_zero @ int ) @ U ) )
      = ( nat2 @ U ) ) ).

% card_atLeastZeroLessThan_int
thf(fact_5152_sum__Suc,axiom,
    ! [A: $tType,F2: A > nat,A3: set @ A] :
      ( ( groups7311177749621191930dd_sum @ A @ nat
        @ ^ [X5: A] : ( suc @ ( F2 @ X5 ) )
        @ A3 )
      = ( plus_plus @ nat @ ( groups7311177749621191930dd_sum @ A @ nat @ F2 @ A3 ) @ ( finite_card @ A @ A3 ) ) ) ).

% sum_Suc
thf(fact_5153_subset__card__intvl__is__intvl,axiom,
    ! [A3: set @ nat,K: nat] :
      ( ( ord_less_eq @ ( set @ nat ) @ A3 @ ( set_or7035219750837199246ssThan @ nat @ K @ ( plus_plus @ nat @ K @ ( finite_card @ nat @ A3 ) ) ) )
     => ( A3
        = ( set_or7035219750837199246ssThan @ nat @ K @ ( plus_plus @ nat @ K @ ( finite_card @ nat @ A3 ) ) ) ) ) ).

% subset_card_intvl_is_intvl
thf(fact_5154_sum__multicount,axiom,
    ! [A: $tType,B: $tType,S3: set @ A,T6: set @ B,R: A > B > $o,K: nat] :
      ( ( finite_finite @ A @ S3 )
     => ( ( finite_finite @ B @ T6 )
       => ( ! [X3: B] :
              ( ( member @ B @ X3 @ T6 )
             => ( ( finite_card @ A
                  @ ( collect @ A
                    @ ^ [I4: A] :
                        ( ( member @ A @ I4 @ S3 )
                        & ( R @ I4 @ X3 ) ) ) )
                = K ) )
         => ( ( groups7311177749621191930dd_sum @ A @ nat
              @ ^ [I4: A] :
                  ( finite_card @ B
                  @ ( collect @ B
                    @ ^ [J3: B] :
                        ( ( member @ B @ J3 @ T6 )
                        & ( R @ I4 @ J3 ) ) ) )
              @ S3 )
            = ( times_times @ nat @ K @ ( finite_card @ B @ T6 ) ) ) ) ) ) ).

% sum_multicount
thf(fact_5155_real__of__card,axiom,
    ! [A: $tType,A3: set @ A] :
      ( ( semiring_1_of_nat @ real @ ( finite_card @ A @ A3 ) )
      = ( groups7311177749621191930dd_sum @ A @ real
        @ ^ [X5: A] : ( one_one @ real )
        @ A3 ) ) ).

% real_of_card
thf(fact_5156_divmod__abs__code_I6_J,axiom,
    ! [J: code_integer] :
      ( ( code_divmod_abs @ ( zero_zero @ code_integer ) @ J )
      = ( product_Pair @ code_integer @ code_integer @ ( zero_zero @ code_integer ) @ ( zero_zero @ code_integer ) ) ) ).

% divmod_abs_code(6)
thf(fact_5157_sum__bounded__below,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( ordere6911136660526730532id_add @ A )
        & ( semiring_1 @ A ) )
     => ! [A3: set @ B,K5: A,F2: B > A] :
          ( ! [I2: B] :
              ( ( member @ B @ I2 @ A3 )
             => ( ord_less_eq @ A @ K5 @ ( F2 @ I2 ) ) )
         => ( ord_less_eq @ A @ ( times_times @ A @ ( semiring_1_of_nat @ A @ ( finite_card @ B @ A3 ) ) @ K5 ) @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ A3 ) ) ) ) ).

% sum_bounded_below
thf(fact_5158_sum__bounded__above,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( ordere6911136660526730532id_add @ A )
        & ( semiring_1 @ A ) )
     => ! [A3: set @ B,F2: B > A,K5: A] :
          ( ! [I2: B] :
              ( ( member @ B @ I2 @ A3 )
             => ( ord_less_eq @ A @ ( F2 @ I2 ) @ K5 ) )
         => ( ord_less_eq @ A @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ A3 ) @ ( times_times @ A @ ( semiring_1_of_nat @ A @ ( finite_card @ B @ A3 ) ) @ K5 ) ) ) ) ).

% sum_bounded_above
thf(fact_5159_card__gt__0__iff,axiom,
    ! [A: $tType,A3: set @ A] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( finite_card @ A @ A3 ) )
      = ( ( A3
         != ( bot_bot @ ( set @ A ) ) )
        & ( finite_finite @ A @ A3 ) ) ) ).

% card_gt_0_iff
thf(fact_5160_card__Suc__eq,axiom,
    ! [A: $tType,A3: set @ A,K: nat] :
      ( ( ( finite_card @ A @ A3 )
        = ( suc @ K ) )
      = ( ? [B4: A,B8: set @ A] :
            ( ( A3
              = ( insert @ A @ B4 @ B8 ) )
            & ~ ( member @ A @ B4 @ B8 )
            & ( ( finite_card @ A @ B8 )
              = K )
            & ( ( K
                = ( zero_zero @ nat ) )
             => ( B8
                = ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ).

% card_Suc_eq
thf(fact_5161_card__eq__SucD,axiom,
    ! [A: $tType,A3: set @ A,K: nat] :
      ( ( ( finite_card @ A @ A3 )
        = ( suc @ K ) )
     => ? [B5: A,B9: set @ A] :
          ( ( A3
            = ( insert @ A @ B5 @ B9 ) )
          & ~ ( member @ A @ B5 @ B9 )
          & ( ( finite_card @ A @ B9 )
            = K )
          & ( ( K
              = ( zero_zero @ nat ) )
           => ( B9
              = ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% card_eq_SucD
thf(fact_5162_card__1__singleton__iff,axiom,
    ! [A: $tType,A3: set @ A] :
      ( ( ( finite_card @ A @ A3 )
        = ( suc @ ( zero_zero @ nat ) ) )
      = ( ? [X5: A] :
            ( A3
            = ( insert @ A @ X5 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% card_1_singleton_iff
thf(fact_5163_card__le__Suc0__iff__eq,axiom,
    ! [A: $tType,A3: set @ A] :
      ( ( finite_finite @ A @ A3 )
     => ( ( ord_less_eq @ nat @ ( finite_card @ A @ A3 ) @ ( suc @ ( zero_zero @ nat ) ) )
        = ( ! [X5: A] :
              ( ( member @ A @ X5 @ A3 )
             => ! [Y5: A] :
                  ( ( member @ A @ Y5 @ A3 )
                 => ( X5 = Y5 ) ) ) ) ) ) ).

% card_le_Suc0_iff_eq
thf(fact_5164_card__le__Suc__iff,axiom,
    ! [A: $tType,N2: nat,A3: set @ A] :
      ( ( ord_less_eq @ nat @ ( suc @ N2 ) @ ( finite_card @ A @ A3 ) )
      = ( ? [A4: A,B8: set @ A] :
            ( ( A3
              = ( insert @ A @ A4 @ B8 ) )
            & ~ ( member @ A @ A4 @ B8 )
            & ( ord_less_eq @ nat @ N2 @ ( finite_card @ A @ B8 ) )
            & ( finite_finite @ A @ B8 ) ) ) ) ).

% card_le_Suc_iff
thf(fact_5165_card__Diff1__le,axiom,
    ! [A: $tType,A3: set @ A,X2: A] : ( ord_less_eq @ nat @ ( finite_card @ A @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X2 @ ( bot_bot @ ( set @ A ) ) ) ) ) @ ( finite_card @ A @ A3 ) ) ).

% card_Diff1_le
thf(fact_5166_card__Diff__subset,axiom,
    ! [A: $tType,B3: set @ A,A3: set @ A] :
      ( ( finite_finite @ A @ B3 )
     => ( ( ord_less_eq @ ( set @ A ) @ B3 @ A3 )
       => ( ( finite_card @ A @ ( minus_minus @ ( set @ A ) @ A3 @ B3 ) )
          = ( minus_minus @ nat @ ( finite_card @ A @ A3 ) @ ( finite_card @ A @ B3 ) ) ) ) ) ).

% card_Diff_subset
thf(fact_5167_card__psubset,axiom,
    ! [A: $tType,B3: set @ A,A3: set @ A] :
      ( ( finite_finite @ A @ B3 )
     => ( ( ord_less_eq @ ( set @ A ) @ A3 @ B3 )
       => ( ( ord_less @ nat @ ( finite_card @ A @ A3 ) @ ( finite_card @ A @ B3 ) )
         => ( ord_less @ ( set @ A ) @ A3 @ B3 ) ) ) ) ).

% card_psubset
thf(fact_5168_diff__card__le__card__Diff,axiom,
    ! [A: $tType,B3: set @ A,A3: set @ A] :
      ( ( finite_finite @ A @ B3 )
     => ( ord_less_eq @ nat @ ( minus_minus @ nat @ ( finite_card @ A @ A3 ) @ ( finite_card @ A @ B3 ) ) @ ( finite_card @ A @ ( minus_minus @ ( set @ A ) @ A3 @ B3 ) ) ) ) ).

% diff_card_le_card_Diff
thf(fact_5169_card__lists__length__le,axiom,
    ! [A: $tType,A3: set @ A,N2: nat] :
      ( ( finite_finite @ A @ A3 )
     => ( ( finite_card @ ( list @ A )
          @ ( collect @ ( list @ A )
            @ ^ [Xs3: list @ A] :
                ( ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ Xs3 ) @ A3 )
                & ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ Xs3 ) @ N2 ) ) ) )
        = ( groups7311177749621191930dd_sum @ nat @ nat @ ( power_power @ nat @ ( finite_card @ A @ A3 ) ) @ ( set_ord_atMost @ nat @ N2 ) ) ) ) ).

% card_lists_length_le
thf(fact_5170_ex__bij__betw__nat__finite,axiom,
    ! [A: $tType,M7: set @ A] :
      ( ( finite_finite @ A @ M7 )
     => ? [H4: nat > A] : ( bij_betw @ nat @ A @ H4 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( finite_card @ A @ M7 ) ) @ M7 ) ) ).

% ex_bij_betw_nat_finite
thf(fact_5171_ex__bij__betw__nat__finite__1,axiom,
    ! [A: $tType,M7: set @ A] :
      ( ( finite_finite @ A @ M7 )
     => ? [H4: nat > A] : ( bij_betw @ nat @ A @ H4 @ ( set_or1337092689740270186AtMost @ nat @ ( one_one @ nat ) @ ( finite_card @ A @ M7 ) ) @ M7 ) ) ).

% ex_bij_betw_nat_finite_1
thf(fact_5172_card__roots__unity,axiom,
    ! [A: $tType] :
      ( ( ( real_V8999393235501362500lgebra @ A )
        & ( idom @ A ) )
     => ! [N2: nat] :
          ( ( ord_less_eq @ nat @ ( one_one @ nat ) @ N2 )
         => ( ord_less_eq @ nat
            @ ( finite_card @ A
              @ ( collect @ A
                @ ^ [Z6: A] :
                    ( ( power_power @ A @ Z6 @ N2 )
                    = ( one_one @ A ) ) ) )
            @ N2 ) ) ) ).

% card_roots_unity
thf(fact_5173_subset__eq__atLeast0__lessThan__card,axiom,
    ! [N4: set @ nat,N2: nat] :
      ( ( ord_less_eq @ ( set @ nat ) @ N4 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N2 ) )
     => ( ord_less_eq @ nat @ ( finite_card @ nat @ N4 ) @ N2 ) ) ).

% subset_eq_atLeast0_lessThan_card
thf(fact_5174_card__sum__le__nat__sum,axiom,
    ! [S3: set @ nat] :
      ( ord_less_eq @ nat
      @ ( groups7311177749621191930dd_sum @ nat @ nat
        @ ^ [X5: nat] : X5
        @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( finite_card @ nat @ S3 ) ) )
      @ ( groups7311177749621191930dd_sum @ nat @ nat
        @ ^ [X5: nat] : X5
        @ S3 ) ) ).

% card_sum_le_nat_sum
thf(fact_5175_card__nth__roots,axiom,
    ! [C2: complex,N2: nat] :
      ( ( C2
       != ( zero_zero @ complex ) )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
       => ( ( finite_card @ complex
            @ ( collect @ complex
              @ ^ [Z6: complex] :
                  ( ( power_power @ complex @ Z6 @ N2 )
                  = C2 ) ) )
          = N2 ) ) ) ).

% card_nth_roots
thf(fact_5176_card__roots__unity__eq,axiom,
    ! [N2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( finite_card @ complex
          @ ( collect @ complex
            @ ^ [Z6: complex] :
                ( ( power_power @ complex @ Z6 @ N2 )
                = ( one_one @ complex ) ) ) )
        = N2 ) ) ).

% card_roots_unity_eq
thf(fact_5177_card__2__iff,axiom,
    ! [A: $tType,S3: set @ A] :
      ( ( ( finite_card @ A @ S3 )
        = ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
      = ( ? [X5: A,Y5: A] :
            ( ( S3
              = ( insert @ A @ X5 @ ( insert @ A @ Y5 @ ( bot_bot @ ( set @ A ) ) ) ) )
            & ( X5 != Y5 ) ) ) ) ).

% card_2_iff
thf(fact_5178_card__3__iff,axiom,
    ! [A: $tType,S3: set @ A] :
      ( ( ( finite_card @ A @ S3 )
        = ( numeral_numeral @ nat @ ( bit1 @ one2 ) ) )
      = ( ? [X5: A,Y5: A,Z6: A] :
            ( ( S3
              = ( insert @ A @ X5 @ ( insert @ A @ Y5 @ ( insert @ A @ Z6 @ ( bot_bot @ ( set @ A ) ) ) ) ) )
            & ( X5 != Y5 )
            & ( Y5 != Z6 )
            & ( X5 != Z6 ) ) ) ) ).

% card_3_iff
thf(fact_5179_odd__card__imp__not__empty,axiom,
    ! [A: $tType,A3: set @ A] :
      ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( finite_card @ A @ A3 ) )
     => ( A3
       != ( bot_bot @ ( set @ A ) ) ) ) ).

% odd_card_imp_not_empty
thf(fact_5180_card__Suc__Diff1,axiom,
    ! [A: $tType,A3: set @ A,X2: A] :
      ( ( finite_finite @ A @ A3 )
     => ( ( member @ A @ X2 @ A3 )
       => ( ( suc @ ( finite_card @ A @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X2 @ ( bot_bot @ ( set @ A ) ) ) ) ) )
          = ( finite_card @ A @ A3 ) ) ) ) ).

% card_Suc_Diff1
thf(fact_5181_card_Oinsert__remove,axiom,
    ! [A: $tType,A3: set @ A,X2: A] :
      ( ( finite_finite @ A @ A3 )
     => ( ( finite_card @ A @ ( insert @ A @ X2 @ A3 ) )
        = ( suc @ ( finite_card @ A @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X2 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ).

% card.insert_remove
thf(fact_5182_card_Oremove,axiom,
    ! [A: $tType,A3: set @ A,X2: A] :
      ( ( finite_finite @ A @ A3 )
     => ( ( member @ A @ X2 @ A3 )
       => ( ( finite_card @ A @ A3 )
          = ( suc @ ( finite_card @ A @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X2 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ) ).

% card.remove
thf(fact_5183_card__Diff1__less,axiom,
    ! [A: $tType,A3: set @ A,X2: A] :
      ( ( finite_finite @ A @ A3 )
     => ( ( member @ A @ X2 @ A3 )
       => ( ord_less @ nat @ ( finite_card @ A @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X2 @ ( bot_bot @ ( set @ A ) ) ) ) ) @ ( finite_card @ A @ A3 ) ) ) ) ).

% card_Diff1_less
thf(fact_5184_card__Diff2__less,axiom,
    ! [A: $tType,A3: set @ A,X2: A,Y2: A] :
      ( ( finite_finite @ A @ A3 )
     => ( ( member @ A @ X2 @ A3 )
       => ( ( member @ A @ Y2 @ A3 )
         => ( ord_less @ nat @ ( finite_card @ A @ ( minus_minus @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X2 @ ( bot_bot @ ( set @ A ) ) ) ) @ ( insert @ A @ Y2 @ ( bot_bot @ ( set @ A ) ) ) ) ) @ ( finite_card @ A @ A3 ) ) ) ) ) ).

% card_Diff2_less
thf(fact_5185_card__Diff1__less__iff,axiom,
    ! [A: $tType,A3: set @ A,X2: A] :
      ( ( ord_less @ nat @ ( finite_card @ A @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X2 @ ( bot_bot @ ( set @ A ) ) ) ) ) @ ( finite_card @ A @ A3 ) )
      = ( ( finite_finite @ A @ A3 )
        & ( member @ A @ X2 @ A3 ) ) ) ).

% card_Diff1_less_iff
thf(fact_5186_card__Diff__singleton,axiom,
    ! [A: $tType,X2: A,A3: set @ A] :
      ( ( member @ A @ X2 @ A3 )
     => ( ( finite_card @ A @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X2 @ ( bot_bot @ ( set @ A ) ) ) ) )
        = ( minus_minus @ nat @ ( finite_card @ A @ A3 ) @ ( one_one @ nat ) ) ) ) ).

% card_Diff_singleton
thf(fact_5187_card__Diff__singleton__if,axiom,
    ! [A: $tType,X2: A,A3: set @ A] :
      ( ( ( member @ A @ X2 @ A3 )
       => ( ( finite_card @ A @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X2 @ ( bot_bot @ ( set @ A ) ) ) ) )
          = ( minus_minus @ nat @ ( finite_card @ A @ A3 ) @ ( one_one @ nat ) ) ) )
      & ( ~ ( member @ A @ X2 @ A3 )
       => ( ( finite_card @ A @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X2 @ ( bot_bot @ ( set @ A ) ) ) ) )
          = ( finite_card @ A @ A3 ) ) ) ) ).

% card_Diff_singleton_if
thf(fact_5188_sum__norm__bound,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [S3: set @ B,F2: B > A,K5: real] :
          ( ! [X3: B] :
              ( ( member @ B @ X3 @ S3 )
             => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( F2 @ X3 ) ) @ K5 ) )
         => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ S3 ) ) @ ( times_times @ real @ ( semiring_1_of_nat @ real @ ( finite_card @ B @ S3 ) ) @ K5 ) ) ) ) ).

% sum_norm_bound
thf(fact_5189_divmod__abs__code_I5_J,axiom,
    ! [J: code_integer] :
      ( ( code_divmod_abs @ J @ ( zero_zero @ code_integer ) )
      = ( product_Pair @ code_integer @ code_integer @ ( zero_zero @ code_integer ) @ ( abs_abs @ code_integer @ J ) ) ) ).

% divmod_abs_code(5)
thf(fact_5190_prod__le__power,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A3: set @ B,F2: B > A,N2: A,K: nat] :
          ( ! [I2: B] :
              ( ( member @ B @ I2 @ A3 )
             => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( F2 @ I2 ) )
                & ( ord_less_eq @ A @ ( F2 @ I2 ) @ N2 ) ) )
         => ( ( ord_less_eq @ nat @ ( finite_card @ B @ A3 ) @ K )
           => ( ( ord_less_eq @ A @ ( one_one @ A ) @ N2 )
             => ( ord_less_eq @ A @ ( groups7121269368397514597t_prod @ B @ A @ F2 @ A3 ) @ ( power_power @ A @ N2 @ K ) ) ) ) ) ) ).

% prod_le_power
thf(fact_5191_sum__bounded__above__strict,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( ordere8940638589300402666id_add @ A )
        & ( semiring_1 @ A ) )
     => ! [A3: set @ B,F2: B > A,K5: A] :
          ( ! [I2: B] :
              ( ( member @ B @ I2 @ A3 )
             => ( ord_less @ A @ ( F2 @ I2 ) @ K5 ) )
         => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( finite_card @ B @ A3 ) )
           => ( ord_less @ A @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ A3 ) @ ( times_times @ A @ ( semiring_1_of_nat @ A @ ( finite_card @ B @ A3 ) ) @ K5 ) ) ) ) ) ).

% sum_bounded_above_strict
thf(fact_5192_sum__bounded__above__divide,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linordered_field @ A )
     => ! [A3: set @ B,F2: B > A,K5: A] :
          ( ! [I2: B] :
              ( ( member @ B @ I2 @ A3 )
             => ( ord_less_eq @ A @ ( F2 @ I2 ) @ ( divide_divide @ A @ K5 @ ( semiring_1_of_nat @ A @ ( finite_card @ B @ A3 ) ) ) ) )
         => ( ( finite_finite @ B @ A3 )
           => ( ( A3
               != ( bot_bot @ ( set @ B ) ) )
             => ( ord_less_eq @ A @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ A3 ) @ K5 ) ) ) ) ) ).

% sum_bounded_above_divide
thf(fact_5193_card__insert__le__m1,axiom,
    ! [A: $tType,N2: nat,Y2: set @ A,X2: A] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( ord_less_eq @ nat @ ( finite_card @ A @ Y2 ) @ ( minus_minus @ nat @ N2 @ ( one_one @ nat ) ) )
       => ( ord_less_eq @ nat @ ( finite_card @ A @ ( insert @ A @ X2 @ Y2 ) ) @ N2 ) ) ) ).

% card_insert_le_m1
thf(fact_5194_polyfun__roots__card,axiom,
    ! [A: $tType] :
      ( ( ( real_V8999393235501362500lgebra @ A )
        & ( idom @ A ) )
     => ! [C2: nat > A,K: nat,N2: nat] :
          ( ( ( C2 @ K )
           != ( zero_zero @ A ) )
         => ( ( ord_less_eq @ nat @ K @ N2 )
           => ( ord_less_eq @ nat
              @ ( finite_card @ A
                @ ( collect @ A
                  @ ^ [Z6: A] :
                      ( ( groups7311177749621191930dd_sum @ nat @ A
                        @ ^ [I4: nat] : ( times_times @ A @ ( C2 @ I4 ) @ ( power_power @ A @ Z6 @ I4 ) )
                        @ ( set_ord_atMost @ nat @ N2 ) )
                      = ( zero_zero @ A ) ) ) )
              @ N2 ) ) ) ) ).

% polyfun_roots_card
thf(fact_5195_prod__gen__delta,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [S3: set @ B,A2: B,B2: B > A,C2: A] :
          ( ( finite_finite @ B @ S3 )
         => ( ( ( member @ B @ A2 @ S3 )
             => ( ( groups7121269368397514597t_prod @ B @ A
                  @ ^ [K3: B] : ( if @ A @ ( K3 = A2 ) @ ( B2 @ K3 ) @ C2 )
                  @ S3 )
                = ( times_times @ A @ ( B2 @ A2 ) @ ( power_power @ A @ C2 @ ( minus_minus @ nat @ ( finite_card @ B @ S3 ) @ ( one_one @ nat ) ) ) ) ) )
            & ( ~ ( member @ B @ A2 @ S3 )
             => ( ( groups7121269368397514597t_prod @ B @ A
                  @ ^ [K3: B] : ( if @ A @ ( K3 = A2 ) @ ( B2 @ K3 ) @ C2 )
                  @ S3 )
                = ( power_power @ A @ C2 @ ( finite_card @ B @ S3 ) ) ) ) ) ) ) ).

% prod_gen_delta
thf(fact_5196_polyfun__rootbound,axiom,
    ! [A: $tType] :
      ( ( ( real_V8999393235501362500lgebra @ A )
        & ( idom @ A ) )
     => ! [C2: nat > A,K: nat,N2: nat] :
          ( ( ( C2 @ K )
           != ( zero_zero @ A ) )
         => ( ( ord_less_eq @ nat @ K @ N2 )
           => ( ( finite_finite @ A
                @ ( collect @ A
                  @ ^ [Z6: A] :
                      ( ( groups7311177749621191930dd_sum @ nat @ A
                        @ ^ [I4: nat] : ( times_times @ A @ ( C2 @ I4 ) @ ( power_power @ A @ Z6 @ I4 ) )
                        @ ( set_ord_atMost @ nat @ N2 ) )
                      = ( zero_zero @ A ) ) ) )
              & ( ord_less_eq @ nat
                @ ( finite_card @ A
                  @ ( collect @ A
                    @ ^ [Z6: A] :
                        ( ( groups7311177749621191930dd_sum @ nat @ A
                          @ ^ [I4: nat] : ( times_times @ A @ ( C2 @ I4 ) @ ( power_power @ A @ Z6 @ I4 ) )
                          @ ( set_ord_atMost @ nat @ N2 ) )
                        = ( zero_zero @ A ) ) ) )
                @ N2 ) ) ) ) ) ).

% polyfun_rootbound
thf(fact_5197_divmod__integer__code,axiom,
    ( code_divmod_integer
    = ( ^ [K3: code_integer,L2: code_integer] :
          ( if @ ( product_prod @ code_integer @ code_integer )
          @ ( K3
            = ( zero_zero @ code_integer ) )
          @ ( product_Pair @ code_integer @ code_integer @ ( zero_zero @ code_integer ) @ ( zero_zero @ code_integer ) )
          @ ( if @ ( product_prod @ code_integer @ code_integer ) @ ( ord_less @ code_integer @ ( zero_zero @ code_integer ) @ L2 )
            @ ( if @ ( product_prod @ code_integer @ code_integer ) @ ( ord_less @ code_integer @ ( zero_zero @ code_integer ) @ K3 ) @ ( code_divmod_abs @ K3 @ L2 )
              @ ( product_case_prod @ code_integer @ code_integer @ ( product_prod @ code_integer @ code_integer )
                @ ^ [R5: code_integer,S7: code_integer] :
                    ( if @ ( product_prod @ code_integer @ code_integer )
                    @ ( S7
                      = ( zero_zero @ code_integer ) )
                    @ ( product_Pair @ code_integer @ code_integer @ ( uminus_uminus @ code_integer @ R5 ) @ ( zero_zero @ code_integer ) )
                    @ ( product_Pair @ code_integer @ code_integer @ ( minus_minus @ code_integer @ ( uminus_uminus @ code_integer @ R5 ) @ ( one_one @ code_integer ) ) @ ( minus_minus @ code_integer @ L2 @ S7 ) ) )
                @ ( code_divmod_abs @ K3 @ L2 ) ) )
            @ ( if @ ( product_prod @ code_integer @ code_integer )
              @ ( L2
                = ( zero_zero @ code_integer ) )
              @ ( product_Pair @ code_integer @ code_integer @ ( zero_zero @ code_integer ) @ K3 )
              @ ( product_apsnd @ code_integer @ code_integer @ code_integer @ ( uminus_uminus @ code_integer )
                @ ( if @ ( product_prod @ code_integer @ code_integer ) @ ( ord_less @ code_integer @ K3 @ ( zero_zero @ code_integer ) ) @ ( code_divmod_abs @ K3 @ L2 )
                  @ ( product_case_prod @ code_integer @ code_integer @ ( product_prod @ code_integer @ code_integer )
                    @ ^ [R5: code_integer,S7: code_integer] :
                        ( if @ ( product_prod @ code_integer @ code_integer )
                        @ ( S7
                          = ( zero_zero @ code_integer ) )
                        @ ( product_Pair @ code_integer @ code_integer @ ( uminus_uminus @ code_integer @ R5 ) @ ( zero_zero @ code_integer ) )
                        @ ( product_Pair @ code_integer @ code_integer @ ( minus_minus @ code_integer @ ( uminus_uminus @ code_integer @ R5 ) @ ( one_one @ code_integer ) ) @ ( minus_minus @ code_integer @ ( uminus_uminus @ code_integer @ L2 ) @ S7 ) ) )
                    @ ( code_divmod_abs @ K3 @ L2 ) ) ) ) ) ) ) ) ) ).

% divmod_integer_code
thf(fact_5198_card__lists__distinct__length__eq,axiom,
    ! [A: $tType,A3: set @ A,K: nat] :
      ( ( finite_finite @ A @ A3 )
     => ( ( ord_less_eq @ nat @ K @ ( finite_card @ A @ A3 ) )
       => ( ( finite_card @ ( list @ A )
            @ ( collect @ ( list @ A )
              @ ^ [Xs3: list @ A] :
                  ( ( ( size_size @ ( list @ A ) @ Xs3 )
                    = K )
                  & ( distinct @ A @ Xs3 )
                  & ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ Xs3 ) @ A3 ) ) ) )
          = ( groups7121269368397514597t_prod @ nat @ nat
            @ ^ [X5: nat] : X5
            @ ( set_or1337092689740270186AtMost @ nat @ ( plus_plus @ nat @ ( minus_minus @ nat @ ( finite_card @ A @ A3 ) @ K ) @ ( one_one @ nat ) ) @ ( finite_card @ A @ A3 ) ) ) ) ) ) ).

% card_lists_distinct_length_eq
thf(fact_5199_card__lists__distinct__length__eq_H,axiom,
    ! [A: $tType,K: nat,A3: set @ A] :
      ( ( ord_less @ nat @ K @ ( finite_card @ A @ A3 ) )
     => ( ( finite_card @ ( list @ A )
          @ ( collect @ ( list @ A )
            @ ^ [Xs3: list @ A] :
                ( ( ( size_size @ ( list @ A ) @ Xs3 )
                  = K )
                & ( distinct @ A @ Xs3 )
                & ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ Xs3 ) @ A3 ) ) ) )
        = ( groups7121269368397514597t_prod @ nat @ nat
          @ ^ [X5: nat] : X5
          @ ( set_or1337092689740270186AtMost @ nat @ ( plus_plus @ nat @ ( minus_minus @ nat @ ( finite_card @ A @ A3 ) @ K ) @ ( one_one @ nat ) ) @ ( finite_card @ A @ A3 ) ) ) ) ) ).

% card_lists_distinct_length_eq'
thf(fact_5200_apsnd__conv,axiom,
    ! [A: $tType,B: $tType,C: $tType,F2: C > B,X2: A,Y2: C] :
      ( ( product_apsnd @ C @ B @ A @ F2 @ ( product_Pair @ A @ C @ X2 @ Y2 ) )
      = ( product_Pair @ A @ B @ X2 @ ( F2 @ Y2 ) ) ) ).

% apsnd_conv
thf(fact_5201_distinct__swap,axiom,
    ! [A: $tType,I3: nat,Xs: list @ A,J: nat] :
      ( ( ord_less @ nat @ I3 @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( ( ord_less @ nat @ J @ ( size_size @ ( list @ A ) @ Xs ) )
       => ( ( distinct @ A @ ( list_update @ A @ ( list_update @ A @ Xs @ I3 @ ( nth @ A @ Xs @ J ) ) @ J @ ( nth @ A @ Xs @ I3 ) ) )
          = ( distinct @ A @ Xs ) ) ) ) ).

% distinct_swap
thf(fact_5202_finite__lists__distinct__length__eq,axiom,
    ! [A: $tType,A3: set @ A,N2: nat] :
      ( ( finite_finite @ A @ A3 )
     => ( finite_finite @ ( list @ A )
        @ ( collect @ ( list @ A )
          @ ^ [Xs3: list @ A] :
              ( ( ( size_size @ ( list @ A ) @ Xs3 )
                = N2 )
              & ( distinct @ A @ Xs3 )
              & ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ Xs3 ) @ A3 ) ) ) ) ) ).

% finite_lists_distinct_length_eq
thf(fact_5203_distinct__product,axiom,
    ! [A: $tType,B: $tType,Xs: list @ A,Ys: list @ B] :
      ( ( distinct @ A @ Xs )
     => ( ( distinct @ B @ Ys )
       => ( distinct @ ( product_prod @ A @ B ) @ ( product @ A @ B @ Xs @ Ys ) ) ) ) ).

% distinct_product
thf(fact_5204_sorted__list__of__set_Odistinct__if__distinct__map,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A] :
          ( ( distinct @ A @ Xs )
         => ( distinct @ A @ Xs ) ) ) ).

% sorted_list_of_set.distinct_if_distinct_map
thf(fact_5205_finite__distinct__list,axiom,
    ! [A: $tType,A3: set @ A] :
      ( ( finite_finite @ A @ A3 )
     => ? [Xs2: list @ A] :
          ( ( ( set2 @ A @ Xs2 )
            = A3 )
          & ( distinct @ A @ Xs2 ) ) ) ).

% finite_distinct_list
thf(fact_5206_subseqs__distinctD,axiom,
    ! [A: $tType,Ys: list @ A,Xs: list @ A] :
      ( ( member @ ( list @ A ) @ Ys @ ( set2 @ ( list @ A ) @ ( subseqs @ A @ Xs ) ) )
     => ( ( distinct @ A @ Xs )
       => ( distinct @ A @ Ys ) ) ) ).

% subseqs_distinctD
thf(fact_5207_distinct__conv__nth,axiom,
    ! [A: $tType] :
      ( ( distinct @ A )
      = ( ^ [Xs3: list @ A] :
          ! [I4: nat] :
            ( ( ord_less @ nat @ I4 @ ( size_size @ ( list @ A ) @ Xs3 ) )
           => ! [J3: nat] :
                ( ( ord_less @ nat @ J3 @ ( size_size @ ( list @ A ) @ Xs3 ) )
               => ( ( I4 != J3 )
                 => ( ( nth @ A @ Xs3 @ I4 )
                   != ( nth @ A @ Xs3 @ J3 ) ) ) ) ) ) ) ).

% distinct_conv_nth
thf(fact_5208_nth__eq__iff__index__eq,axiom,
    ! [A: $tType,Xs: list @ A,I3: nat,J: nat] :
      ( ( distinct @ A @ Xs )
     => ( ( ord_less @ nat @ I3 @ ( size_size @ ( list @ A ) @ Xs ) )
       => ( ( ord_less @ nat @ J @ ( size_size @ ( list @ A ) @ Xs ) )
         => ( ( ( nth @ A @ Xs @ I3 )
              = ( nth @ A @ Xs @ J ) )
            = ( I3 = J ) ) ) ) ) ).

% nth_eq_iff_index_eq
thf(fact_5209_card__distinct,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( ( finite_card @ A @ ( set2 @ A @ Xs ) )
        = ( size_size @ ( list @ A ) @ Xs ) )
     => ( distinct @ A @ Xs ) ) ).

% card_distinct
thf(fact_5210_distinct__card,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( distinct @ A @ Xs )
     => ( ( finite_card @ A @ ( set2 @ A @ Xs ) )
        = ( size_size @ ( list @ A ) @ Xs ) ) ) ).

% distinct_card
thf(fact_5211_distinct__Ex1,axiom,
    ! [A: $tType,Xs: list @ A,X2: A] :
      ( ( distinct @ A @ Xs )
     => ( ( member @ A @ X2 @ ( set2 @ A @ Xs ) )
       => ? [X3: nat] :
            ( ( ord_less @ nat @ X3 @ ( size_size @ ( list @ A ) @ Xs ) )
            & ( ( nth @ A @ Xs @ X3 )
              = X2 )
            & ! [Y: nat] :
                ( ( ( ord_less @ nat @ Y @ ( size_size @ ( list @ A ) @ Xs ) )
                  & ( ( nth @ A @ Xs @ Y )
                    = X2 ) )
               => ( Y = X3 ) ) ) ) ) ).

% distinct_Ex1
thf(fact_5212_bij__betw__nth,axiom,
    ! [A: $tType,Xs: list @ A,A3: set @ nat,B3: set @ A] :
      ( ( distinct @ A @ Xs )
     => ( ( A3
          = ( set_ord_lessThan @ nat @ ( size_size @ ( list @ A ) @ Xs ) ) )
       => ( ( B3
            = ( set2 @ A @ Xs ) )
         => ( bij_betw @ nat @ A @ ( nth @ A @ Xs ) @ A3 @ B3 ) ) ) ) ).

% bij_betw_nth
thf(fact_5213_distinct__list__update,axiom,
    ! [A: $tType,Xs: list @ A,A2: A,I3: nat] :
      ( ( distinct @ A @ Xs )
     => ( ~ ( member @ A @ A2 @ ( minus_minus @ ( set @ A ) @ ( set2 @ A @ Xs ) @ ( insert @ A @ ( nth @ A @ Xs @ I3 ) @ ( bot_bot @ ( set @ A ) ) ) ) )
       => ( distinct @ A @ ( list_update @ A @ Xs @ I3 @ A2 ) ) ) ) ).

% distinct_list_update
thf(fact_5214_set__update__distinct,axiom,
    ! [A: $tType,Xs: list @ A,N2: nat,X2: A] :
      ( ( distinct @ A @ Xs )
     => ( ( ord_less @ nat @ N2 @ ( size_size @ ( list @ A ) @ Xs ) )
       => ( ( set2 @ A @ ( list_update @ A @ Xs @ N2 @ X2 ) )
          = ( insert @ A @ X2 @ ( minus_minus @ ( set @ A ) @ ( set2 @ A @ Xs ) @ ( insert @ A @ ( nth @ A @ Xs @ N2 ) @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ).

% set_update_distinct
thf(fact_5215_distinct__union,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A] :
      ( ( distinct @ A @ ( union @ A @ Xs @ Ys ) )
      = ( distinct @ A @ Ys ) ) ).

% distinct_union
thf(fact_5216_card__Pow,axiom,
    ! [A: $tType,A3: set @ A] :
      ( ( finite_finite @ A @ A3 )
     => ( ( finite_card @ ( set @ A ) @ ( pow2 @ A @ A3 ) )
        = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( finite_card @ A @ A3 ) ) ) ) ).

% card_Pow
thf(fact_5217_rec__nat__add__eq__if,axiom,
    ! [A: $tType,A2: A,F2: nat > A > A,V: num,N2: nat] :
      ( ( rec_nat @ A @ A2 @ F2 @ ( plus_plus @ nat @ ( numeral_numeral @ nat @ V ) @ N2 ) )
      = ( F2 @ ( plus_plus @ nat @ ( pred_numeral @ V ) @ N2 ) @ ( rec_nat @ A @ A2 @ F2 @ ( plus_plus @ nat @ ( pred_numeral @ V ) @ N2 ) ) ) ) ).

% rec_nat_add_eq_if
thf(fact_5218_PowI,axiom,
    ! [A: $tType,A3: set @ A,B3: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ B3 )
     => ( member @ ( set @ A ) @ A3 @ ( pow2 @ A @ B3 ) ) ) ).

% PowI
thf(fact_5219_Pow__iff,axiom,
    ! [A: $tType,A3: set @ A,B3: set @ A] :
      ( ( member @ ( set @ A ) @ A3 @ ( pow2 @ A @ B3 ) )
      = ( ord_less_eq @ ( set @ A ) @ A3 @ B3 ) ) ).

% Pow_iff
thf(fact_5220_old_Onat_Osimps_I7_J,axiom,
    ! [T: $tType,F1: T,F22: nat > T > T,Nat: nat] :
      ( ( rec_nat @ T @ F1 @ F22 @ ( suc @ Nat ) )
      = ( F22 @ Nat @ ( rec_nat @ T @ F1 @ F22 @ Nat ) ) ) ).

% old.nat.simps(7)
thf(fact_5221_old_Onat_Osimps_I6_J,axiom,
    ! [T: $tType,F1: T,F22: nat > T > T] :
      ( ( rec_nat @ T @ F1 @ F22 @ ( zero_zero @ nat ) )
      = F1 ) ).

% old.nat.simps(6)
thf(fact_5222_rec__nat__numeral,axiom,
    ! [A: $tType,A2: A,F2: nat > A > A,V: num] :
      ( ( rec_nat @ A @ A2 @ F2 @ ( numeral_numeral @ nat @ V ) )
      = ( F2 @ ( pred_numeral @ V ) @ ( rec_nat @ A @ A2 @ F2 @ ( pred_numeral @ V ) ) ) ) ).

% rec_nat_numeral
thf(fact_5223_Pow__def,axiom,
    ! [A: $tType] :
      ( ( pow2 @ A )
      = ( ^ [A7: set @ A] :
            ( collect @ ( set @ A )
            @ ^ [B8: set @ A] : ( ord_less_eq @ ( set @ A ) @ B8 @ A7 ) ) ) ) ).

% Pow_def
thf(fact_5224_PowD,axiom,
    ! [A: $tType,A3: set @ A,B3: set @ A] :
      ( ( member @ ( set @ A ) @ A3 @ ( pow2 @ A @ B3 ) )
     => ( ord_less_eq @ ( set @ A ) @ A3 @ B3 ) ) ).

% PowD
thf(fact_5225_Pow__mono,axiom,
    ! [A: $tType,A3: set @ A,B3: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ B3 )
     => ( ord_less_eq @ ( set @ ( set @ A ) ) @ ( pow2 @ A @ A3 ) @ ( pow2 @ A @ B3 ) ) ) ).

% Pow_mono
thf(fact_5226_binomial__def,axiom,
    ( binomial
    = ( ^ [N3: nat,K3: nat] :
          ( finite_card @ ( set @ nat )
          @ ( collect @ ( set @ nat )
            @ ^ [K6: set @ nat] :
                ( ( member @ ( set @ nat ) @ K6 @ ( pow2 @ nat @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N3 ) ) )
                & ( ( finite_card @ nat @ K6 )
                  = K3 ) ) ) ) ) ) ).

% binomial_def
thf(fact_5227_old_Orec__nat__def,axiom,
    ! [T: $tType] :
      ( ( rec_nat @ T )
      = ( ^ [F12: T,F23: nat > T > T,X5: nat] : ( the @ T @ ( rec_set_nat @ T @ F12 @ F23 @ X5 ) ) ) ) ).

% old.rec_nat_def
thf(fact_5228_rec__nat__0__imp,axiom,
    ! [A: $tType,F2: nat > A,F1: A,F22: nat > A > A] :
      ( ( F2
        = ( rec_nat @ A @ F1 @ F22 ) )
     => ( ( F2 @ ( zero_zero @ nat ) )
        = F1 ) ) ).

% rec_nat_0_imp
thf(fact_5229_rec__nat__Suc__imp,axiom,
    ! [A: $tType,F2: nat > A,F1: A,F22: nat > A > A,N2: nat] :
      ( ( F2
        = ( rec_nat @ A @ F1 @ F22 ) )
     => ( ( F2 @ ( suc @ N2 ) )
        = ( F22 @ N2 @ ( F2 @ N2 ) ) ) ) ).

% rec_nat_Suc_imp
thf(fact_5230_The__split__eq,axiom,
    ! [A: $tType,B: $tType,X2: A,Y2: B] :
      ( ( the @ ( product_prod @ A @ B )
        @ ( product_case_prod @ A @ B @ $o
          @ ^ [X9: A,Y6: B] :
              ( ( X2 = X9 )
              & ( Y2 = Y6 ) ) ) )
      = ( product_Pair @ A @ B @ X2 @ Y2 ) ) ).

% The_split_eq
thf(fact_5231_subset__CollectI,axiom,
    ! [A: $tType,B3: set @ A,A3: set @ A,Q: A > $o,P: A > $o] :
      ( ( ord_less_eq @ ( set @ A ) @ B3 @ A3 )
     => ( ! [X3: A] :
            ( ( member @ A @ X3 @ B3 )
           => ( ( Q @ X3 )
             => ( P @ X3 ) ) )
       => ( ord_less_eq @ ( set @ A )
          @ ( collect @ A
            @ ^ [X5: A] :
                ( ( member @ A @ X5 @ B3 )
                & ( Q @ X5 ) ) )
          @ ( collect @ A
            @ ^ [X5: A] :
                ( ( member @ A @ X5 @ A3 )
                & ( P @ X5 ) ) ) ) ) ) ).

% subset_CollectI
thf(fact_5232_subset__Collect__iff,axiom,
    ! [A: $tType,B3: set @ A,A3: set @ A,P: A > $o] :
      ( ( ord_less_eq @ ( set @ A ) @ B3 @ A3 )
     => ( ( ord_less_eq @ ( set @ A ) @ B3
          @ ( collect @ A
            @ ^ [X5: A] :
                ( ( member @ A @ X5 @ A3 )
                & ( P @ X5 ) ) ) )
        = ( ! [X5: A] :
              ( ( member @ A @ X5 @ B3 )
             => ( P @ X5 ) ) ) ) ) ).

% subset_Collect_iff
thf(fact_5233_floor__real__def,axiom,
    ( ( archim6421214686448440834_floor @ real )
    = ( ^ [X5: real] :
          ( the @ int
          @ ^ [Z6: int] :
              ( ( ord_less_eq @ real @ ( ring_1_of_int @ real @ Z6 ) @ X5 )
              & ( ord_less @ real @ X5 @ ( ring_1_of_int @ real @ ( plus_plus @ int @ Z6 @ ( one_one @ int ) ) ) ) ) ) ) ) ).

% floor_real_def
thf(fact_5234_floor__rat__def,axiom,
    ( ( archim6421214686448440834_floor @ rat )
    = ( ^ [X5: rat] :
          ( the @ int
          @ ^ [Z6: int] :
              ( ( ord_less_eq @ rat @ ( ring_1_of_int @ rat @ Z6 ) @ X5 )
              & ( ord_less @ rat @ X5 @ ( ring_1_of_int @ rat @ ( plus_plus @ int @ Z6 @ ( one_one @ int ) ) ) ) ) ) ) ) ).

% floor_rat_def
thf(fact_5235_case__nat__add__eq__if,axiom,
    ! [A: $tType,A2: A,F2: nat > A,V: num,N2: nat] :
      ( ( case_nat @ A @ A2 @ F2 @ ( plus_plus @ nat @ ( numeral_numeral @ nat @ V ) @ N2 ) )
      = ( F2 @ ( plus_plus @ nat @ ( pred_numeral @ V ) @ N2 ) ) ) ).

% case_nat_add_eq_if
thf(fact_5236_bezw__0,axiom,
    ! [X2: nat] :
      ( ( bezw @ X2 @ ( zero_zero @ nat ) )
      = ( product_Pair @ int @ int @ ( one_one @ int ) @ ( zero_zero @ int ) ) ) ).

% bezw_0
thf(fact_5237_case__nat__numeral,axiom,
    ! [A: $tType,A2: A,F2: nat > A,V: num] :
      ( ( case_nat @ A @ A2 @ F2 @ ( numeral_numeral @ nat @ V ) )
      = ( F2 @ ( pred_numeral @ V ) ) ) ).

% case_nat_numeral
thf(fact_5238_less__eq__rat__def,axiom,
    ( ( ord_less_eq @ rat )
    = ( ^ [X5: rat,Y5: rat] :
          ( ( ord_less @ rat @ X5 @ Y5 )
          | ( X5 = Y5 ) ) ) ) ).

% less_eq_rat_def
thf(fact_5239_nat_Ocase__distrib,axiom,
    ! [B: $tType,A: $tType,H2: A > B,F1: A,F22: nat > A,Nat: nat] :
      ( ( H2 @ ( case_nat @ A @ F1 @ F22 @ Nat ) )
      = ( case_nat @ B @ ( H2 @ F1 )
        @ ^ [X5: nat] : ( H2 @ ( F22 @ X5 ) )
        @ Nat ) ) ).

% nat.case_distrib
thf(fact_5240_old_Onat_Osimps_I5_J,axiom,
    ! [A: $tType,F1: A,F22: nat > A,X22: nat] :
      ( ( case_nat @ A @ F1 @ F22 @ ( suc @ X22 ) )
      = ( F22 @ X22 ) ) ).

% old.nat.simps(5)
thf(fact_5241_abs__rat__def,axiom,
    ( ( abs_abs @ rat )
    = ( ^ [A4: rat] : ( if @ rat @ ( ord_less @ rat @ A4 @ ( zero_zero @ rat ) ) @ ( uminus_uminus @ rat @ A4 ) @ A4 ) ) ) ).

% abs_rat_def
thf(fact_5242_sgn__rat__def,axiom,
    ( ( sgn_sgn @ rat )
    = ( ^ [A4: rat] :
          ( if @ rat
          @ ( A4
            = ( zero_zero @ rat ) )
          @ ( zero_zero @ rat )
          @ ( if @ rat @ ( ord_less @ rat @ ( zero_zero @ rat ) @ A4 ) @ ( one_one @ rat ) @ ( uminus_uminus @ rat @ ( one_one @ rat ) ) ) ) ) ) ).

% sgn_rat_def
thf(fact_5243_obtain__pos__sum,axiom,
    ! [R3: rat] :
      ( ( ord_less @ rat @ ( zero_zero @ rat ) @ R3 )
     => ~ ! [S: rat] :
            ( ( ord_less @ rat @ ( zero_zero @ rat ) @ S )
           => ! [T4: rat] :
                ( ( ord_less @ rat @ ( zero_zero @ rat ) @ T4 )
               => ( R3
                 != ( plus_plus @ rat @ S @ T4 ) ) ) ) ) ).

% obtain_pos_sum
thf(fact_5244_old_Onat_Osimps_I4_J,axiom,
    ! [A: $tType,F1: A,F22: nat > A] :
      ( ( case_nat @ A @ F1 @ F22 @ ( zero_zero @ nat ) )
      = F1 ) ).

% old.nat.simps(4)
thf(fact_5245_nat_Odisc__eq__case_I1_J,axiom,
    ! [Nat: nat] :
      ( ( Nat
        = ( zero_zero @ nat ) )
      = ( case_nat @ $o @ $true
        @ ^ [Uu3: nat] : $false
        @ Nat ) ) ).

% nat.disc_eq_case(1)
thf(fact_5246_nat_Odisc__eq__case_I2_J,axiom,
    ! [Nat: nat] :
      ( ( ( Nat
         != ( zero_zero @ nat ) ) )
      = ( case_nat @ $o @ $false
        @ ^ [Uu3: nat] : $true
        @ Nat ) ) ).

% nat.disc_eq_case(2)
thf(fact_5247_less__eq__nat_Osimps_I2_J,axiom,
    ! [M: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ ( suc @ M ) @ N2 )
      = ( case_nat @ $o @ $false @ ( ord_less_eq @ nat @ M ) @ N2 ) ) ).

% less_eq_nat.simps(2)
thf(fact_5248_max__Suc2,axiom,
    ! [M: nat,N2: nat] :
      ( ( ord_max @ nat @ M @ ( suc @ N2 ) )
      = ( case_nat @ nat @ ( suc @ N2 )
        @ ^ [M4: nat] : ( suc @ ( ord_max @ nat @ M4 @ N2 ) )
        @ M ) ) ).

% max_Suc2
thf(fact_5249_max__Suc1,axiom,
    ! [N2: nat,M: nat] :
      ( ( ord_max @ nat @ ( suc @ N2 ) @ M )
      = ( case_nat @ nat @ ( suc @ N2 )
        @ ^ [M4: nat] : ( suc @ ( ord_max @ nat @ N2 @ M4 ) )
        @ M ) ) ).

% max_Suc1
thf(fact_5250_diff__Suc,axiom,
    ! [M: nat,N2: nat] :
      ( ( minus_minus @ nat @ M @ ( suc @ N2 ) )
      = ( case_nat @ nat @ ( zero_zero @ nat )
        @ ^ [K3: nat] : K3
        @ ( minus_minus @ nat @ M @ N2 ) ) ) ).

% diff_Suc
thf(fact_5251_bit__numeral__rec_I1_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [W: num,N2: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( numeral_numeral @ A @ ( bit0 @ W ) ) @ N2 )
          = ( case_nat @ $o @ $false @ ( bit_se5641148757651400278ts_bit @ A @ ( numeral_numeral @ A @ W ) ) @ N2 ) ) ) ).

% bit_numeral_rec(1)
thf(fact_5252_bit__numeral__rec_I2_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [W: num,N2: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( numeral_numeral @ A @ ( bit1 @ W ) ) @ N2 )
          = ( case_nat @ $o @ $true @ ( bit_se5641148757651400278ts_bit @ A @ ( numeral_numeral @ A @ W ) ) @ N2 ) ) ) ).

% bit_numeral_rec(2)
thf(fact_5253_Nitpick_Ocase__nat__unfold,axiom,
    ! [A: $tType] :
      ( ( case_nat @ A )
      = ( ^ [X5: A,F5: nat > A,N3: nat] :
            ( if @ A
            @ ( N3
              = ( zero_zero @ nat ) )
            @ X5
            @ ( F5 @ ( minus_minus @ nat @ N3 @ ( one_one @ nat ) ) ) ) ) ) ).

% Nitpick.case_nat_unfold
thf(fact_5254_rat__inverse__code,axiom,
    ! [P4: rat] :
      ( ( quotient_of @ ( inverse_inverse @ rat @ P4 ) )
      = ( product_case_prod @ int @ int @ ( product_prod @ int @ int )
        @ ^ [A4: int,B4: int] :
            ( if @ ( product_prod @ int @ int )
            @ ( A4
              = ( zero_zero @ int ) )
            @ ( product_Pair @ int @ int @ ( zero_zero @ int ) @ ( one_one @ int ) )
            @ ( product_Pair @ int @ int @ ( times_times @ int @ ( sgn_sgn @ int @ A4 ) @ B4 ) @ ( abs_abs @ int @ A4 ) ) )
        @ ( quotient_of @ P4 ) ) ) ).

% rat_inverse_code
thf(fact_5255_normalize__negative,axiom,
    ! [Q3: int,P4: int] :
      ( ( ord_less @ int @ Q3 @ ( zero_zero @ int ) )
     => ( ( normalize @ ( product_Pair @ int @ int @ P4 @ Q3 ) )
        = ( normalize @ ( product_Pair @ int @ int @ ( uminus_uminus @ int @ P4 ) @ ( uminus_uminus @ int @ Q3 ) ) ) ) ) ).

% normalize_negative
thf(fact_5256_nat_Osplit__sels_I1_J,axiom,
    ! [A: $tType,P: A > $o,F1: A,F22: nat > A,Nat: nat] :
      ( ( P @ ( case_nat @ A @ F1 @ F22 @ Nat ) )
      = ( ( ( Nat
            = ( zero_zero @ nat ) )
         => ( P @ F1 ) )
        & ( ( Nat
            = ( suc @ ( pred @ Nat ) ) )
         => ( P @ ( F22 @ ( pred @ Nat ) ) ) ) ) ) ).

% nat.split_sels(1)
thf(fact_5257_quotient__of__number_I3_J,axiom,
    ! [K: num] :
      ( ( quotient_of @ ( numeral_numeral @ rat @ K ) )
      = ( product_Pair @ int @ int @ ( numeral_numeral @ int @ K ) @ ( one_one @ int ) ) ) ).

% quotient_of_number(3)
thf(fact_5258_normalize__denom__zero,axiom,
    ! [P4: int] :
      ( ( normalize @ ( product_Pair @ int @ int @ P4 @ ( zero_zero @ int ) ) )
      = ( product_Pair @ int @ int @ ( zero_zero @ int ) @ ( one_one @ int ) ) ) ).

% normalize_denom_zero
thf(fact_5259_rat__zero__code,axiom,
    ( ( quotient_of @ ( zero_zero @ rat ) )
    = ( product_Pair @ int @ int @ ( zero_zero @ int ) @ ( one_one @ int ) ) ) ).

% rat_zero_code
thf(fact_5260_quotient__of__number_I5_J,axiom,
    ! [K: num] :
      ( ( quotient_of @ ( uminus_uminus @ rat @ ( numeral_numeral @ rat @ K ) ) )
      = ( product_Pair @ int @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ K ) ) @ ( one_one @ int ) ) ) ).

% quotient_of_number(5)
thf(fact_5261_divide__rat__def,axiom,
    ( ( divide_divide @ rat )
    = ( ^ [Q4: rat,R5: rat] : ( times_times @ rat @ Q4 @ ( inverse_inverse @ rat @ R5 ) ) ) ) ).

% divide_rat_def
thf(fact_5262_rat__divide__code,axiom,
    ! [P4: rat,Q3: rat] :
      ( ( quotient_of @ ( divide_divide @ rat @ P4 @ Q3 ) )
      = ( product_case_prod @ int @ int @ ( product_prod @ int @ int )
        @ ^ [A4: int,C4: int] :
            ( product_case_prod @ int @ int @ ( product_prod @ int @ int )
            @ ^ [B4: int,D3: int] : ( normalize @ ( product_Pair @ int @ int @ ( times_times @ int @ A4 @ D3 ) @ ( times_times @ int @ C4 @ B4 ) ) )
            @ ( quotient_of @ Q3 ) )
        @ ( quotient_of @ P4 ) ) ) ).

% rat_divide_code
thf(fact_5263_rat__times__code,axiom,
    ! [P4: rat,Q3: rat] :
      ( ( quotient_of @ ( times_times @ rat @ P4 @ Q3 ) )
      = ( product_case_prod @ int @ int @ ( product_prod @ int @ int )
        @ ^ [A4: int,C4: int] :
            ( product_case_prod @ int @ int @ ( product_prod @ int @ int )
            @ ^ [B4: int,D3: int] : ( normalize @ ( product_Pair @ int @ int @ ( times_times @ int @ A4 @ B4 ) @ ( times_times @ int @ C4 @ D3 ) ) )
            @ ( quotient_of @ Q3 ) )
        @ ( quotient_of @ P4 ) ) ) ).

% rat_times_code
thf(fact_5264_quotient__of__div,axiom,
    ! [R3: rat,N2: int,D2: int] :
      ( ( ( quotient_of @ R3 )
        = ( product_Pair @ int @ int @ N2 @ D2 ) )
     => ( R3
        = ( divide_divide @ rat @ ( ring_1_of_int @ rat @ N2 ) @ ( ring_1_of_int @ rat @ D2 ) ) ) ) ).

% quotient_of_div
thf(fact_5265_rat__plus__code,axiom,
    ! [P4: rat,Q3: rat] :
      ( ( quotient_of @ ( plus_plus @ rat @ P4 @ Q3 ) )
      = ( product_case_prod @ int @ int @ ( product_prod @ int @ int )
        @ ^ [A4: int,C4: int] :
            ( product_case_prod @ int @ int @ ( product_prod @ int @ int )
            @ ^ [B4: int,D3: int] : ( normalize @ ( product_Pair @ int @ int @ ( plus_plus @ int @ ( times_times @ int @ A4 @ D3 ) @ ( times_times @ int @ B4 @ C4 ) ) @ ( times_times @ int @ C4 @ D3 ) ) )
            @ ( quotient_of @ Q3 ) )
        @ ( quotient_of @ P4 ) ) ) ).

% rat_plus_code
thf(fact_5266_rat__minus__code,axiom,
    ! [P4: rat,Q3: rat] :
      ( ( quotient_of @ ( minus_minus @ rat @ P4 @ Q3 ) )
      = ( product_case_prod @ int @ int @ ( product_prod @ int @ int )
        @ ^ [A4: int,C4: int] :
            ( product_case_prod @ int @ int @ ( product_prod @ int @ int )
            @ ^ [B4: int,D3: int] : ( normalize @ ( product_Pair @ int @ int @ ( minus_minus @ int @ ( times_times @ int @ A4 @ D3 ) @ ( times_times @ int @ B4 @ C4 ) ) @ ( times_times @ int @ C4 @ D3 ) ) )
            @ ( quotient_of @ Q3 ) )
        @ ( quotient_of @ P4 ) ) ) ).

% rat_minus_code
thf(fact_5267_quotient__of__denom__pos,axiom,
    ! [R3: rat,P4: int,Q3: int] :
      ( ( ( quotient_of @ R3 )
        = ( product_Pair @ int @ int @ P4 @ Q3 ) )
     => ( ord_less @ int @ ( zero_zero @ int ) @ Q3 ) ) ).

% quotient_of_denom_pos
thf(fact_5268_pred__def,axiom,
    ( pred
    = ( case_nat @ nat @ ( zero_zero @ nat )
      @ ^ [X24: nat] : X24 ) ) ).

% pred_def
thf(fact_5269_normalize__denom__pos,axiom,
    ! [R3: product_prod @ int @ int,P4: int,Q3: int] :
      ( ( ( normalize @ R3 )
        = ( product_Pair @ int @ int @ P4 @ Q3 ) )
     => ( ord_less @ int @ ( zero_zero @ int ) @ Q3 ) ) ).

% normalize_denom_pos
thf(fact_5270_normalize__crossproduct,axiom,
    ! [Q3: int,S2: int,P4: int,R3: int] :
      ( ( Q3
       != ( zero_zero @ int ) )
     => ( ( S2
         != ( zero_zero @ int ) )
       => ( ( ( normalize @ ( product_Pair @ int @ int @ P4 @ Q3 ) )
            = ( normalize @ ( product_Pair @ int @ int @ R3 @ S2 ) ) )
         => ( ( times_times @ int @ P4 @ S2 )
            = ( times_times @ int @ R3 @ Q3 ) ) ) ) ) ).

% normalize_crossproduct
thf(fact_5271_rat__less__code,axiom,
    ( ( ord_less @ rat )
    = ( ^ [P6: rat,Q4: rat] :
          ( product_case_prod @ int @ int @ $o
          @ ^ [A4: int,C4: int] :
              ( product_case_prod @ int @ int @ $o
              @ ^ [B4: int,D3: int] : ( ord_less @ int @ ( times_times @ int @ A4 @ D3 ) @ ( times_times @ int @ C4 @ B4 ) )
              @ ( quotient_of @ Q4 ) )
          @ ( quotient_of @ P6 ) ) ) ) ).

% rat_less_code
thf(fact_5272_rat__floor__code,axiom,
    ( ( archim6421214686448440834_floor @ rat )
    = ( ^ [P6: rat] : ( product_case_prod @ int @ int @ int @ ( divide_divide @ int ) @ ( quotient_of @ P6 ) ) ) ) ).

% rat_floor_code
thf(fact_5273_rat__less__eq__code,axiom,
    ( ( ord_less_eq @ rat )
    = ( ^ [P6: rat,Q4: rat] :
          ( product_case_prod @ int @ int @ $o
          @ ^ [A4: int,C4: int] :
              ( product_case_prod @ int @ int @ $o
              @ ^ [B4: int,D3: int] : ( ord_less_eq @ int @ ( times_times @ int @ A4 @ D3 ) @ ( times_times @ int @ C4 @ B4 ) )
              @ ( quotient_of @ Q4 ) )
          @ ( quotient_of @ P6 ) ) ) ) ).

% rat_less_eq_code
thf(fact_5274_nat_Osplit__sels_I2_J,axiom,
    ! [A: $tType,P: A > $o,F1: A,F22: nat > A,Nat: nat] :
      ( ( P @ ( case_nat @ A @ F1 @ F22 @ Nat ) )
      = ( ~ ( ( ( Nat
                = ( zero_zero @ nat ) )
              & ~ ( P @ F1 ) )
            | ( ( Nat
                = ( suc @ ( pred @ Nat ) ) )
              & ~ ( P @ ( F22 @ ( pred @ Nat ) ) ) ) ) ) ) ).

% nat.split_sels(2)
thf(fact_5275_prod__decode__aux_Oelims,axiom,
    ! [X2: nat,Xa2: nat,Y2: product_prod @ nat @ nat] :
      ( ( ( nat_prod_decode_aux @ X2 @ Xa2 )
        = Y2 )
     => ( ( ( ord_less_eq @ nat @ Xa2 @ X2 )
         => ( Y2
            = ( product_Pair @ nat @ nat @ Xa2 @ ( minus_minus @ nat @ X2 @ Xa2 ) ) ) )
        & ( ~ ( ord_less_eq @ nat @ Xa2 @ X2 )
         => ( Y2
            = ( nat_prod_decode_aux @ ( suc @ X2 ) @ ( minus_minus @ nat @ Xa2 @ ( suc @ X2 ) ) ) ) ) ) ) ).

% prod_decode_aux.elims
thf(fact_5276_prod__decode__aux_Osimps,axiom,
    ( nat_prod_decode_aux
    = ( ^ [K3: nat,M6: nat] : ( if @ ( product_prod @ nat @ nat ) @ ( ord_less_eq @ nat @ M6 @ K3 ) @ ( product_Pair @ nat @ nat @ M6 @ ( minus_minus @ nat @ K3 @ M6 ) ) @ ( nat_prod_decode_aux @ ( suc @ K3 ) @ ( minus_minus @ nat @ M6 @ ( suc @ K3 ) ) ) ) ) ) ).

% prod_decode_aux.simps
thf(fact_5277_Suc__0__div__numeral,axiom,
    ! [K: num] :
      ( ( divide_divide @ nat @ ( suc @ ( zero_zero @ nat ) ) @ ( numeral_numeral @ nat @ K ) )
      = ( product_fst @ nat @ nat @ ( unique8689654367752047608divmod @ nat @ one2 @ K ) ) ) ).

% Suc_0_div_numeral
thf(fact_5278_numeral__div__numeral,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [K: num,L: num] :
          ( ( divide_divide @ A @ ( numeral_numeral @ A @ K ) @ ( numeral_numeral @ A @ L ) )
          = ( product_fst @ A @ A @ ( unique8689654367752047608divmod @ A @ K @ L ) ) ) ) ).

% numeral_div_numeral
thf(fact_5279_fst__divmod__nat,axiom,
    ! [M: nat,N2: nat] :
      ( ( product_fst @ nat @ nat @ ( divmod_nat @ M @ N2 ) )
      = ( divide_divide @ nat @ M @ N2 ) ) ).

% fst_divmod_nat
thf(fact_5280_one__div__numeral,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [N2: num] :
          ( ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ N2 ) )
          = ( product_fst @ A @ A @ ( unique8689654367752047608divmod @ A @ one2 @ N2 ) ) ) ) ).

% one_div_numeral
thf(fact_5281_fst__eqD,axiom,
    ! [B: $tType,A: $tType,X2: A,Y2: B,A2: A] :
      ( ( ( product_fst @ A @ B @ ( product_Pair @ A @ B @ X2 @ Y2 ) )
        = A2 )
     => ( X2 = A2 ) ) ).

% fst_eqD
thf(fact_5282_fst__conv,axiom,
    ! [B: $tType,A: $tType,X1: A,X22: B] :
      ( ( product_fst @ A @ B @ ( product_Pair @ A @ B @ X1 @ X22 ) )
      = X1 ) ).

% fst_conv
thf(fact_5283_fst__divmod,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [M: num,N2: num] :
          ( ( product_fst @ A @ A @ ( unique8689654367752047608divmod @ A @ M @ N2 ) )
          = ( divide_divide @ A @ ( numeral_numeral @ A @ M ) @ ( numeral_numeral @ A @ N2 ) ) ) ) ).

% fst_divmod
thf(fact_5284_prod__decode__aux_Opelims,axiom,
    ! [X2: nat,Xa2: nat,Y2: product_prod @ nat @ nat] :
      ( ( ( nat_prod_decode_aux @ X2 @ Xa2 )
        = Y2 )
     => ( ( accp @ ( product_prod @ nat @ nat ) @ nat_pr5047031295181774490ux_rel @ ( product_Pair @ nat @ nat @ X2 @ Xa2 ) )
       => ~ ( ( ( ( ord_less_eq @ nat @ Xa2 @ X2 )
               => ( Y2
                  = ( product_Pair @ nat @ nat @ Xa2 @ ( minus_minus @ nat @ X2 @ Xa2 ) ) ) )
              & ( ~ ( ord_less_eq @ nat @ Xa2 @ X2 )
               => ( Y2
                  = ( nat_prod_decode_aux @ ( suc @ X2 ) @ ( minus_minus @ nat @ Xa2 @ ( suc @ X2 ) ) ) ) ) )
           => ~ ( accp @ ( product_prod @ nat @ nat ) @ nat_pr5047031295181774490ux_rel @ ( product_Pair @ nat @ nat @ X2 @ Xa2 ) ) ) ) ) ).

% prod_decode_aux.pelims
thf(fact_5285_Frct__code__post_I5_J,axiom,
    ! [K: num] :
      ( ( frct @ ( product_Pair @ int @ int @ ( one_one @ int ) @ ( numeral_numeral @ int @ K ) ) )
      = ( divide_divide @ rat @ ( one_one @ rat ) @ ( numeral_numeral @ rat @ K ) ) ) ).

% Frct_code_post(5)
thf(fact_5286_Frct__code__post_I6_J,axiom,
    ! [K: num,L: num] :
      ( ( frct @ ( product_Pair @ int @ int @ ( numeral_numeral @ int @ K ) @ ( numeral_numeral @ int @ L ) ) )
      = ( divide_divide @ rat @ ( numeral_numeral @ rat @ K ) @ ( numeral_numeral @ rat @ L ) ) ) ).

% Frct_code_post(6)
thf(fact_5287_fst__divmod__integer,axiom,
    ! [K: code_integer,L: code_integer] :
      ( ( product_fst @ code_integer @ code_integer @ ( code_divmod_integer @ K @ L ) )
      = ( divide_divide @ code_integer @ K @ L ) ) ).

% fst_divmod_integer
thf(fact_5288_fst__divmod__abs,axiom,
    ! [K: code_integer,L: code_integer] :
      ( ( product_fst @ code_integer @ code_integer @ ( code_divmod_abs @ K @ L ) )
      = ( divide_divide @ code_integer @ ( abs_abs @ code_integer @ K ) @ ( abs_abs @ code_integer @ L ) ) ) ).

% fst_divmod_abs
thf(fact_5289_Frct__code__post_I2_J,axiom,
    ! [A2: int] :
      ( ( frct @ ( product_Pair @ int @ int @ A2 @ ( zero_zero @ int ) ) )
      = ( zero_zero @ rat ) ) ).

% Frct_code_post(2)
thf(fact_5290_Frct__code__post_I1_J,axiom,
    ! [A2: int] :
      ( ( frct @ ( product_Pair @ int @ int @ ( zero_zero @ int ) @ A2 ) )
      = ( zero_zero @ rat ) ) ).

% Frct_code_post(1)
thf(fact_5291_Frct__code__post_I4_J,axiom,
    ! [K: num] :
      ( ( frct @ ( product_Pair @ int @ int @ ( numeral_numeral @ int @ K ) @ ( one_one @ int ) ) )
      = ( numeral_numeral @ rat @ K ) ) ).

% Frct_code_post(4)
thf(fact_5292_bezw_Osimps,axiom,
    ( bezw
    = ( ^ [X5: nat,Y5: nat] :
          ( if @ ( product_prod @ int @ int )
          @ ( Y5
            = ( zero_zero @ nat ) )
          @ ( product_Pair @ int @ int @ ( one_one @ int ) @ ( zero_zero @ int ) )
          @ ( product_Pair @ int @ int @ ( product_snd @ int @ int @ ( bezw @ Y5 @ ( modulo_modulo @ nat @ X5 @ Y5 ) ) ) @ ( minus_minus @ int @ ( product_fst @ int @ int @ ( bezw @ Y5 @ ( modulo_modulo @ nat @ X5 @ Y5 ) ) ) @ ( times_times @ int @ ( product_snd @ int @ int @ ( bezw @ Y5 @ ( modulo_modulo @ nat @ X5 @ Y5 ) ) ) @ ( semiring_1_of_nat @ int @ ( divide_divide @ nat @ X5 @ Y5 ) ) ) ) ) ) ) ) ).

% bezw.simps
thf(fact_5293_bezw_Oelims,axiom,
    ! [X2: nat,Xa2: nat,Y2: product_prod @ int @ int] :
      ( ( ( bezw @ X2 @ Xa2 )
        = Y2 )
     => ( ( ( Xa2
            = ( zero_zero @ nat ) )
         => ( Y2
            = ( product_Pair @ int @ int @ ( one_one @ int ) @ ( zero_zero @ int ) ) ) )
        & ( ( Xa2
           != ( zero_zero @ nat ) )
         => ( Y2
            = ( product_Pair @ int @ int @ ( product_snd @ int @ int @ ( bezw @ Xa2 @ ( modulo_modulo @ nat @ X2 @ Xa2 ) ) ) @ ( minus_minus @ int @ ( product_fst @ int @ int @ ( bezw @ Xa2 @ ( modulo_modulo @ nat @ X2 @ Xa2 ) ) ) @ ( times_times @ int @ ( product_snd @ int @ int @ ( bezw @ Xa2 @ ( modulo_modulo @ nat @ X2 @ Xa2 ) ) ) @ ( semiring_1_of_nat @ int @ ( divide_divide @ nat @ X2 @ Xa2 ) ) ) ) ) ) ) ) ) ).

% bezw.elims
thf(fact_5294_bezw_Opelims,axiom,
    ! [X2: nat,Xa2: nat,Y2: product_prod @ int @ int] :
      ( ( ( bezw @ X2 @ Xa2 )
        = Y2 )
     => ( ( accp @ ( product_prod @ nat @ nat ) @ bezw_rel @ ( product_Pair @ nat @ nat @ X2 @ Xa2 ) )
       => ~ ( ( ( ( Xa2
                  = ( zero_zero @ nat ) )
               => ( Y2
                  = ( product_Pair @ int @ int @ ( one_one @ int ) @ ( zero_zero @ int ) ) ) )
              & ( ( Xa2
                 != ( zero_zero @ nat ) )
               => ( Y2
                  = ( product_Pair @ int @ int @ ( product_snd @ int @ int @ ( bezw @ Xa2 @ ( modulo_modulo @ nat @ X2 @ Xa2 ) ) ) @ ( minus_minus @ int @ ( product_fst @ int @ int @ ( bezw @ Xa2 @ ( modulo_modulo @ nat @ X2 @ Xa2 ) ) ) @ ( times_times @ int @ ( product_snd @ int @ int @ ( bezw @ Xa2 @ ( modulo_modulo @ nat @ X2 @ Xa2 ) ) ) @ ( semiring_1_of_nat @ int @ ( divide_divide @ nat @ X2 @ Xa2 ) ) ) ) ) ) ) )
           => ~ ( accp @ ( product_prod @ nat @ nat ) @ bezw_rel @ ( product_Pair @ nat @ nat @ X2 @ Xa2 ) ) ) ) ) ).

% bezw.pelims
thf(fact_5295_prod_Ocollapse,axiom,
    ! [B: $tType,A: $tType,Prod: product_prod @ A @ B] :
      ( ( product_Pair @ A @ B @ ( product_fst @ A @ B @ Prod ) @ ( product_snd @ A @ B @ Prod ) )
      = Prod ) ).

% prod.collapse
thf(fact_5296_numeral__mod__numeral,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [K: num,L: num] :
          ( ( modulo_modulo @ A @ ( numeral_numeral @ A @ K ) @ ( numeral_numeral @ A @ L ) )
          = ( product_snd @ A @ A @ ( unique8689654367752047608divmod @ A @ K @ L ) ) ) ) ).

% numeral_mod_numeral
thf(fact_5297_one__mod__numeral,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [N2: num] :
          ( ( modulo_modulo @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ N2 ) )
          = ( product_snd @ A @ A @ ( unique8689654367752047608divmod @ A @ one2 @ N2 ) ) ) ) ).

% one_mod_numeral
thf(fact_5298_snd__eqD,axiom,
    ! [B: $tType,A: $tType,X2: B,Y2: A,A2: A] :
      ( ( ( product_snd @ B @ A @ ( product_Pair @ B @ A @ X2 @ Y2 ) )
        = A2 )
     => ( Y2 = A2 ) ) ).

% snd_eqD
thf(fact_5299_snd__conv,axiom,
    ! [Aa: $tType,A: $tType,X1: Aa,X22: A] :
      ( ( product_snd @ Aa @ A @ ( product_Pair @ Aa @ A @ X1 @ X22 ) )
      = X22 ) ).

% snd_conv
thf(fact_5300_BNF__Greatest__Fixpoint_Osubst__Pair,axiom,
    ! [B: $tType,A: $tType,P: A > B > $o,X2: A,Y2: B,A2: product_prod @ A @ B] :
      ( ( P @ X2 @ Y2 )
     => ( ( A2
          = ( product_Pair @ A @ B @ X2 @ Y2 ) )
       => ( P @ ( product_fst @ A @ B @ A2 ) @ ( product_snd @ A @ B @ A2 ) ) ) ) ).

% BNF_Greatest_Fixpoint.subst_Pair
thf(fact_5301_surjective__pairing,axiom,
    ! [B: $tType,A: $tType,T2: product_prod @ A @ B] :
      ( T2
      = ( product_Pair @ A @ B @ ( product_fst @ A @ B @ T2 ) @ ( product_snd @ A @ B @ T2 ) ) ) ).

% surjective_pairing
thf(fact_5302_prod_Oexhaust__sel,axiom,
    ! [B: $tType,A: $tType,Prod: product_prod @ A @ B] :
      ( Prod
      = ( product_Pair @ A @ B @ ( product_fst @ A @ B @ Prod ) @ ( product_snd @ A @ B @ Prod ) ) ) ).

% prod.exhaust_sel
thf(fact_5303_divides__aux__def,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ( ( unique5940410009612947441es_aux @ A )
        = ( ^ [Qr: product_prod @ A @ A] :
              ( ( product_snd @ A @ A @ Qr )
              = ( zero_zero @ A ) ) ) ) ) ).

% divides_aux_def
thf(fact_5304_prod_Osplit__sel,axiom,
    ! [C: $tType,B: $tType,A: $tType,P: C > $o,F2: A > B > C,Prod: product_prod @ A @ B] :
      ( ( P @ ( product_case_prod @ A @ B @ C @ F2 @ Prod ) )
      = ( ( Prod
          = ( product_Pair @ A @ B @ ( product_fst @ A @ B @ Prod ) @ ( product_snd @ A @ B @ Prod ) ) )
       => ( P @ ( F2 @ ( product_fst @ A @ B @ Prod ) @ ( product_snd @ A @ B @ Prod ) ) ) ) ) ).

% prod.split_sel
thf(fact_5305_prod_Osplit__sel__asm,axiom,
    ! [C: $tType,B: $tType,A: $tType,P: C > $o,F2: A > B > C,Prod: product_prod @ A @ B] :
      ( ( P @ ( product_case_prod @ A @ B @ C @ F2 @ Prod ) )
      = ( ~ ( ( Prod
              = ( product_Pair @ A @ B @ ( product_fst @ A @ B @ Prod ) @ ( product_snd @ A @ B @ Prod ) ) )
            & ~ ( P @ ( F2 @ ( product_fst @ A @ B @ Prod ) @ ( product_snd @ A @ B @ Prod ) ) ) ) ) ) ).

% prod.split_sel_asm
thf(fact_5306_snd__divmod,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [M: num,N2: num] :
          ( ( product_snd @ A @ A @ ( unique8689654367752047608divmod @ A @ M @ N2 ) )
          = ( modulo_modulo @ A @ ( numeral_numeral @ A @ M ) @ ( numeral_numeral @ A @ N2 ) ) ) ) ).

% snd_divmod
thf(fact_5307_quotient__of__denom__pos_H,axiom,
    ! [R3: rat] : ( ord_less @ int @ ( zero_zero @ int ) @ ( product_snd @ int @ int @ ( quotient_of @ R3 ) ) ) ).

% quotient_of_denom_pos'
thf(fact_5308_bezw__non__0,axiom,
    ! [Y2: nat,X2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ Y2 )
     => ( ( bezw @ X2 @ Y2 )
        = ( product_Pair @ int @ int @ ( product_snd @ int @ int @ ( bezw @ Y2 @ ( modulo_modulo @ nat @ X2 @ Y2 ) ) ) @ ( minus_minus @ int @ ( product_fst @ int @ int @ ( bezw @ Y2 @ ( modulo_modulo @ nat @ X2 @ Y2 ) ) ) @ ( times_times @ int @ ( product_snd @ int @ int @ ( bezw @ Y2 @ ( modulo_modulo @ nat @ X2 @ Y2 ) ) ) @ ( semiring_1_of_nat @ int @ ( divide_divide @ nat @ X2 @ Y2 ) ) ) ) ) ) ) ).

% bezw_non_0
thf(fact_5309_one__mod__minus__numeral,axiom,
    ! [N2: num] :
      ( ( modulo_modulo @ int @ ( one_one @ int ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N2 ) ) )
      = ( uminus_uminus @ int @ ( adjust_mod @ ( numeral_numeral @ int @ N2 ) @ ( product_snd @ int @ int @ ( unique8689654367752047608divmod @ int @ one2 @ N2 ) ) ) ) ) ).

% one_mod_minus_numeral
thf(fact_5310_minus__one__mod__numeral,axiom,
    ! [N2: num] :
      ( ( modulo_modulo @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( numeral_numeral @ int @ N2 ) )
      = ( adjust_mod @ ( numeral_numeral @ int @ N2 ) @ ( product_snd @ int @ int @ ( unique8689654367752047608divmod @ int @ one2 @ N2 ) ) ) ) ).

% minus_one_mod_numeral
thf(fact_5311_numeral__mod__minus__numeral,axiom,
    ! [M: num,N2: num] :
      ( ( modulo_modulo @ int @ ( numeral_numeral @ int @ M ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N2 ) ) )
      = ( uminus_uminus @ int @ ( adjust_mod @ ( numeral_numeral @ int @ N2 ) @ ( product_snd @ int @ int @ ( unique8689654367752047608divmod @ int @ M @ N2 ) ) ) ) ) ).

% numeral_mod_minus_numeral
thf(fact_5312_Suc__0__mod__numeral,axiom,
    ! [K: num] :
      ( ( modulo_modulo @ nat @ ( suc @ ( zero_zero @ nat ) ) @ ( numeral_numeral @ nat @ K ) )
      = ( product_snd @ nat @ nat @ ( unique8689654367752047608divmod @ nat @ one2 @ K ) ) ) ).

% Suc_0_mod_numeral
thf(fact_5313_minus__numeral__mod__numeral,axiom,
    ! [M: num,N2: num] :
      ( ( modulo_modulo @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ M ) ) @ ( numeral_numeral @ int @ N2 ) )
      = ( adjust_mod @ ( numeral_numeral @ int @ N2 ) @ ( product_snd @ int @ int @ ( unique8689654367752047608divmod @ int @ M @ N2 ) ) ) ) ).

% minus_numeral_mod_numeral
thf(fact_5314_Divides_Oadjust__mod__def,axiom,
    ( adjust_mod
    = ( ^ [L2: int,R5: int] :
          ( if @ int
          @ ( R5
            = ( zero_zero @ int ) )
          @ ( zero_zero @ int )
          @ ( minus_minus @ int @ L2 @ R5 ) ) ) ) ).

% Divides.adjust_mod_def
thf(fact_5315_in__set__enumerate__eq,axiom,
    ! [A: $tType,P4: product_prod @ nat @ A,N2: nat,Xs: list @ A] :
      ( ( member @ ( product_prod @ nat @ A ) @ P4 @ ( set2 @ ( product_prod @ nat @ A ) @ ( enumerate @ A @ N2 @ Xs ) ) )
      = ( ( ord_less_eq @ nat @ N2 @ ( product_fst @ nat @ A @ P4 ) )
        & ( ord_less @ nat @ ( product_fst @ nat @ A @ P4 ) @ ( plus_plus @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ N2 ) )
        & ( ( nth @ A @ Xs @ ( minus_minus @ nat @ ( product_fst @ nat @ A @ P4 ) @ N2 ) )
          = ( product_snd @ nat @ A @ P4 ) ) ) ) ).

% in_set_enumerate_eq
thf(fact_5316_exI__realizer,axiom,
    ! [B: $tType,A: $tType,P: A > B > $o,Y2: A,X2: B] :
      ( ( P @ Y2 @ X2 )
     => ( P @ ( product_snd @ B @ A @ ( product_Pair @ B @ A @ X2 @ Y2 ) ) @ ( product_fst @ B @ A @ ( product_Pair @ B @ A @ X2 @ Y2 ) ) ) ) ).

% exI_realizer
thf(fact_5317_conjI__realizer,axiom,
    ! [A: $tType,B: $tType,P: A > $o,P4: A,Q: B > $o,Q3: B] :
      ( ( P @ P4 )
     => ( ( Q @ Q3 )
       => ( ( P @ ( product_fst @ A @ B @ ( product_Pair @ A @ B @ P4 @ Q3 ) ) )
          & ( Q @ ( product_snd @ A @ B @ ( product_Pair @ A @ B @ P4 @ Q3 ) ) ) ) ) ) ).

% conjI_realizer
thf(fact_5318_length__enumerate,axiom,
    ! [A: $tType,N2: nat,Xs: list @ A] :
      ( ( size_size @ ( list @ ( product_prod @ nat @ A ) ) @ ( enumerate @ A @ N2 @ Xs ) )
      = ( size_size @ ( list @ A ) @ Xs ) ) ).

% length_enumerate
thf(fact_5319_distinct__enumerate,axiom,
    ! [A: $tType,N2: nat,Xs: list @ A] : ( distinct @ ( product_prod @ nat @ A ) @ ( enumerate @ A @ N2 @ Xs ) ) ).

% distinct_enumerate
thf(fact_5320_nth__enumerate__eq,axiom,
    ! [A: $tType,M: nat,Xs: list @ A,N2: nat] :
      ( ( ord_less @ nat @ M @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( ( nth @ ( product_prod @ nat @ A ) @ ( enumerate @ A @ N2 @ Xs ) @ M )
        = ( product_Pair @ nat @ A @ ( plus_plus @ nat @ N2 @ M ) @ ( nth @ A @ Xs @ M ) ) ) ) ).

% nth_enumerate_eq
thf(fact_5321_normalize__def,axiom,
    ( normalize
    = ( ^ [P6: product_prod @ int @ int] :
          ( if @ ( product_prod @ int @ int ) @ ( ord_less @ int @ ( zero_zero @ int ) @ ( product_snd @ int @ int @ P6 ) ) @ ( product_Pair @ int @ int @ ( divide_divide @ int @ ( product_fst @ int @ int @ P6 ) @ ( gcd_gcd @ int @ ( product_fst @ int @ int @ P6 ) @ ( product_snd @ int @ int @ P6 ) ) ) @ ( divide_divide @ int @ ( product_snd @ int @ int @ P6 ) @ ( gcd_gcd @ int @ ( product_fst @ int @ int @ P6 ) @ ( product_snd @ int @ int @ P6 ) ) ) )
          @ ( if @ ( product_prod @ int @ int )
            @ ( ( product_snd @ int @ int @ P6 )
              = ( zero_zero @ int ) )
            @ ( product_Pair @ int @ int @ ( zero_zero @ int ) @ ( one_one @ int ) )
            @ ( product_Pair @ int @ int @ ( divide_divide @ int @ ( product_fst @ int @ int @ P6 ) @ ( uminus_uminus @ int @ ( gcd_gcd @ int @ ( product_fst @ int @ int @ P6 ) @ ( product_snd @ int @ int @ P6 ) ) ) ) @ ( divide_divide @ int @ ( product_snd @ int @ int @ P6 ) @ ( uminus_uminus @ int @ ( gcd_gcd @ int @ ( product_fst @ int @ int @ P6 ) @ ( product_snd @ int @ int @ P6 ) ) ) ) ) ) ) ) ) ).

% normalize_def
thf(fact_5322_size__prod__simp,axiom,
    ! [B: $tType,A: $tType] :
      ( ( basic_BNF_size_prod @ A @ B )
      = ( ^ [F5: A > nat,G4: B > nat,P6: product_prod @ A @ B] : ( plus_plus @ nat @ ( plus_plus @ nat @ ( F5 @ ( product_fst @ A @ B @ P6 ) ) @ ( G4 @ ( product_snd @ A @ B @ P6 ) ) ) @ ( suc @ ( zero_zero @ nat ) ) ) ) ) ).

% size_prod_simp
thf(fact_5323_drop__bit__numeral__minus__bit1,axiom,
    ! [L: num,K: num] :
      ( ( bit_se4197421643247451524op_bit @ int @ ( numeral_numeral @ nat @ L ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit1 @ K ) ) ) )
      = ( bit_se4197421643247451524op_bit @ int @ ( pred_numeral @ L ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( inc @ K ) ) ) ) ) ).

% drop_bit_numeral_minus_bit1
thf(fact_5324_gcd__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A2: A,B2: A] :
          ( ( ( gcd_gcd @ A @ A2 @ B2 )
            = ( zero_zero @ A ) )
          = ( ( A2
              = ( zero_zero @ A ) )
            & ( B2
              = ( zero_zero @ A ) ) ) ) ) ).

% gcd_eq_0_iff
thf(fact_5325_gcd_Obottom__left__bottom,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A2: A] :
          ( ( gcd_gcd @ A @ ( one_one @ A ) @ A2 )
          = ( one_one @ A ) ) ) ).

% gcd.bottom_left_bottom
thf(fact_5326_gcd_Obottom__right__bottom,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A2: A] :
          ( ( gcd_gcd @ A @ A2 @ ( one_one @ A ) )
          = ( one_one @ A ) ) ) ).

% gcd.bottom_right_bottom
thf(fact_5327_gcd__add1,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [M: A,N2: A] :
          ( ( gcd_gcd @ A @ ( plus_plus @ A @ M @ N2 ) @ N2 )
          = ( gcd_gcd @ A @ M @ N2 ) ) ) ).

% gcd_add1
thf(fact_5328_gcd__add2,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [M: A,N2: A] :
          ( ( gcd_gcd @ A @ M @ ( plus_plus @ A @ M @ N2 ) )
          = ( gcd_gcd @ A @ M @ N2 ) ) ) ).

% gcd_add2
thf(fact_5329_gcd__exp,axiom,
    ! [A: $tType] :
      ( ( semiri6843258321239162965malize @ A )
     => ! [A2: A,N2: nat,B2: A] :
          ( ( gcd_gcd @ A @ ( power_power @ A @ A2 @ N2 ) @ ( power_power @ A @ B2 @ N2 ) )
          = ( power_power @ A @ ( gcd_gcd @ A @ A2 @ B2 ) @ N2 ) ) ) ).

% gcd_exp
thf(fact_5330_drop__bit__of__0,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N2: nat] :
          ( ( bit_se4197421643247451524op_bit @ A @ N2 @ ( zero_zero @ A ) )
          = ( zero_zero @ A ) ) ) ).

% drop_bit_of_0
thf(fact_5331_drop__bit__drop__bit,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M: nat,N2: nat,A2: A] :
          ( ( bit_se4197421643247451524op_bit @ A @ M @ ( bit_se4197421643247451524op_bit @ A @ N2 @ A2 ) )
          = ( bit_se4197421643247451524op_bit @ A @ ( plus_plus @ nat @ M @ N2 ) @ A2 ) ) ) ).

% drop_bit_drop_bit
thf(fact_5332_drop__bit__and,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N2: nat,A2: A,B2: A] :
          ( ( bit_se4197421643247451524op_bit @ A @ N2 @ ( bit_se5824344872417868541ns_and @ A @ A2 @ B2 ) )
          = ( bit_se5824344872417868541ns_and @ A @ ( bit_se4197421643247451524op_bit @ A @ N2 @ A2 ) @ ( bit_se4197421643247451524op_bit @ A @ N2 @ B2 ) ) ) ) ).

% drop_bit_and
thf(fact_5333_drop__bit__or,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N2: nat,A2: A,B2: A] :
          ( ( bit_se4197421643247451524op_bit @ A @ N2 @ ( bit_se1065995026697491101ons_or @ A @ A2 @ B2 ) )
          = ( bit_se1065995026697491101ons_or @ A @ ( bit_se4197421643247451524op_bit @ A @ N2 @ A2 ) @ ( bit_se4197421643247451524op_bit @ A @ N2 @ B2 ) ) ) ) ).

% drop_bit_or
thf(fact_5334_drop__bit__xor,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N2: nat,A2: A,B2: A] :
          ( ( bit_se4197421643247451524op_bit @ A @ N2 @ ( bit_se5824344971392196577ns_xor @ A @ A2 @ B2 ) )
          = ( bit_se5824344971392196577ns_xor @ A @ ( bit_se4197421643247451524op_bit @ A @ N2 @ A2 ) @ ( bit_se4197421643247451524op_bit @ A @ N2 @ B2 ) ) ) ) ).

% drop_bit_xor
thf(fact_5335_gcd__neg__numeral__1,axiom,
    ! [A: $tType] :
      ( ( ring_gcd @ A )
     => ! [N2: num,A2: A] :
          ( ( gcd_gcd @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N2 ) ) @ A2 )
          = ( gcd_gcd @ A @ ( numeral_numeral @ A @ N2 ) @ A2 ) ) ) ).

% gcd_neg_numeral_1
thf(fact_5336_gcd__neg__numeral__2,axiom,
    ! [A: $tType] :
      ( ( ring_gcd @ A )
     => ! [A2: A,N2: num] :
          ( ( gcd_gcd @ A @ A2 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N2 ) ) )
          = ( gcd_gcd @ A @ A2 @ ( numeral_numeral @ A @ N2 ) ) ) ) ).

% gcd_neg_numeral_2
thf(fact_5337_is__unit__gcd__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A2: A,B2: A] :
          ( ( dvd_dvd @ A @ ( gcd_gcd @ A @ A2 @ B2 ) @ ( one_one @ A ) )
          = ( ( gcd_gcd @ A @ A2 @ B2 )
            = ( one_one @ A ) ) ) ) ).

% is_unit_gcd_iff
thf(fact_5338_gcd__pos__int,axiom,
    ! [M: int,N2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ ( gcd_gcd @ int @ M @ N2 ) )
      = ( ( M
         != ( zero_zero @ int ) )
        | ( N2
         != ( zero_zero @ int ) ) ) ) ).

% gcd_pos_int
thf(fact_5339_drop__bit__of__bool,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N2: nat,B2: $o] :
          ( ( bit_se4197421643247451524op_bit @ A @ N2 @ ( zero_neq_one_of_bool @ A @ B2 ) )
          = ( zero_neq_one_of_bool @ A
            @ ( ( N2
                = ( zero_zero @ nat ) )
              & B2 ) ) ) ) ).

% drop_bit_of_bool
thf(fact_5340_gcd__neg__numeral__1__int,axiom,
    ! [N2: num,X2: int] :
      ( ( gcd_gcd @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N2 ) ) @ X2 )
      = ( gcd_gcd @ int @ ( numeral_numeral @ int @ N2 ) @ X2 ) ) ).

% gcd_neg_numeral_1_int
thf(fact_5341_gcd__neg__numeral__2__int,axiom,
    ! [X2: int,N2: num] :
      ( ( gcd_gcd @ int @ X2 @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N2 ) ) )
      = ( gcd_gcd @ int @ X2 @ ( numeral_numeral @ int @ N2 ) ) ) ).

% gcd_neg_numeral_2_int
thf(fact_5342_gcd__0__left__int,axiom,
    ! [X2: int] :
      ( ( gcd_gcd @ int @ ( zero_zero @ int ) @ X2 )
      = ( abs_abs @ int @ X2 ) ) ).

% gcd_0_left_int
thf(fact_5343_gcd__0__int,axiom,
    ! [X2: int] :
      ( ( gcd_gcd @ int @ X2 @ ( zero_zero @ int ) )
      = ( abs_abs @ int @ X2 ) ) ).

% gcd_0_int
thf(fact_5344_drop__bit__nonnegative__int__iff,axiom,
    ! [N2: nat,K: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( bit_se4197421643247451524op_bit @ int @ N2 @ K ) )
      = ( ord_less_eq @ int @ ( zero_zero @ int ) @ K ) ) ).

% drop_bit_nonnegative_int_iff
thf(fact_5345_drop__bit__negative__int__iff,axiom,
    ! [N2: nat,K: int] :
      ( ( ord_less @ int @ ( bit_se4197421643247451524op_bit @ int @ N2 @ K ) @ ( zero_zero @ int ) )
      = ( ord_less @ int @ K @ ( zero_zero @ int ) ) ) ).

% drop_bit_negative_int_iff
thf(fact_5346_drop__bit__minus__one,axiom,
    ! [N2: nat] :
      ( ( bit_se4197421643247451524op_bit @ int @ N2 @ ( uminus_uminus @ int @ ( one_one @ int ) ) )
      = ( uminus_uminus @ int @ ( one_one @ int ) ) ) ).

% drop_bit_minus_one
thf(fact_5347_drop__bit__Suc__bit0,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [N2: nat,K: num] :
          ( ( bit_se4197421643247451524op_bit @ A @ ( suc @ N2 ) @ ( numeral_numeral @ A @ ( bit0 @ K ) ) )
          = ( bit_se4197421643247451524op_bit @ A @ N2 @ ( numeral_numeral @ A @ K ) ) ) ) ).

% drop_bit_Suc_bit0
thf(fact_5348_drop__bit__Suc__bit1,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [N2: nat,K: num] :
          ( ( bit_se4197421643247451524op_bit @ A @ ( suc @ N2 ) @ ( numeral_numeral @ A @ ( bit1 @ K ) ) )
          = ( bit_se4197421643247451524op_bit @ A @ N2 @ ( numeral_numeral @ A @ K ) ) ) ) ).

% drop_bit_Suc_bit1
thf(fact_5349_drop__bit__of__1,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N2: nat] :
          ( ( bit_se4197421643247451524op_bit @ A @ N2 @ ( one_one @ A ) )
          = ( zero_neq_one_of_bool @ A
            @ ( N2
              = ( zero_zero @ nat ) ) ) ) ) ).

% drop_bit_of_1
thf(fact_5350_drop__bit__numeral__bit0,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [L: num,K: num] :
          ( ( bit_se4197421643247451524op_bit @ A @ ( numeral_numeral @ nat @ L ) @ ( numeral_numeral @ A @ ( bit0 @ K ) ) )
          = ( bit_se4197421643247451524op_bit @ A @ ( pred_numeral @ L ) @ ( numeral_numeral @ A @ K ) ) ) ) ).

% drop_bit_numeral_bit0
thf(fact_5351_drop__bit__numeral__bit1,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [L: num,K: num] :
          ( ( bit_se4197421643247451524op_bit @ A @ ( numeral_numeral @ nat @ L ) @ ( numeral_numeral @ A @ ( bit1 @ K ) ) )
          = ( bit_se4197421643247451524op_bit @ A @ ( pred_numeral @ L ) @ ( numeral_numeral @ A @ K ) ) ) ) ).

% drop_bit_numeral_bit1
thf(fact_5352_drop__bit__Suc__minus__bit0,axiom,
    ! [N2: nat,K: num] :
      ( ( bit_se4197421643247451524op_bit @ int @ ( suc @ N2 ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit0 @ K ) ) ) )
      = ( bit_se4197421643247451524op_bit @ int @ N2 @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ K ) ) ) ) ).

% drop_bit_Suc_minus_bit0
thf(fact_5353_drop__bit__numeral__minus__bit0,axiom,
    ! [L: num,K: num] :
      ( ( bit_se4197421643247451524op_bit @ int @ ( numeral_numeral @ nat @ L ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit0 @ K ) ) ) )
      = ( bit_se4197421643247451524op_bit @ int @ ( pred_numeral @ L ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ K ) ) ) ) ).

% drop_bit_numeral_minus_bit0
thf(fact_5354_drop__bit__Suc__minus__bit1,axiom,
    ! [N2: nat,K: num] :
      ( ( bit_se4197421643247451524op_bit @ int @ ( suc @ N2 ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit1 @ K ) ) ) )
      = ( bit_se4197421643247451524op_bit @ int @ N2 @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( inc @ K ) ) ) ) ) ).

% drop_bit_Suc_minus_bit1
thf(fact_5355_gcd__add__mult,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [M: A,K: A,N2: A] :
          ( ( gcd_gcd @ A @ M @ ( plus_plus @ A @ ( times_times @ A @ K @ M ) @ N2 ) )
          = ( gcd_gcd @ A @ M @ N2 ) ) ) ).

% gcd_add_mult
thf(fact_5356_gcd__dvd__prod,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A2: A,B2: A,K: A] : ( dvd_dvd @ A @ ( gcd_gcd @ A @ A2 @ B2 ) @ ( times_times @ A @ K @ B2 ) ) ) ).

% gcd_dvd_prod
thf(fact_5357_drop__bit__of__nat,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [N2: nat,M: nat] :
          ( ( bit_se4197421643247451524op_bit @ A @ N2 @ ( semiring_1_of_nat @ A @ M ) )
          = ( semiring_1_of_nat @ A @ ( bit_se4197421643247451524op_bit @ nat @ N2 @ M ) ) ) ) ).

% drop_bit_of_nat
thf(fact_5358_of__nat__drop__bit,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [M: nat,N2: nat] :
          ( ( semiring_1_of_nat @ A @ ( bit_se4197421643247451524op_bit @ nat @ M @ N2 ) )
          = ( bit_se4197421643247451524op_bit @ A @ M @ ( semiring_1_of_nat @ A @ N2 ) ) ) ) ).

% of_nat_drop_bit
thf(fact_5359_gcd__ge__0__int,axiom,
    ! [X2: int,Y2: int] : ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( gcd_gcd @ int @ X2 @ Y2 ) ) ).

% gcd_ge_0_int
thf(fact_5360_bezout__int,axiom,
    ! [X2: int,Y2: int] :
    ? [U3: int,V3: int] :
      ( ( plus_plus @ int @ ( times_times @ int @ U3 @ X2 ) @ ( times_times @ int @ V3 @ Y2 ) )
      = ( gcd_gcd @ int @ X2 @ Y2 ) ) ).

% bezout_int
thf(fact_5361_gcd__mult__distrib__int,axiom,
    ! [K: int,M: int,N2: int] :
      ( ( times_times @ int @ ( abs_abs @ int @ K ) @ ( gcd_gcd @ int @ M @ N2 ) )
      = ( gcd_gcd @ int @ ( times_times @ int @ K @ M ) @ ( times_times @ int @ K @ N2 ) ) ) ).

% gcd_mult_distrib_int
thf(fact_5362_take__bit__eq__self__iff__drop__bit__eq__0,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N2: nat,A2: A] :
          ( ( ( bit_se2584673776208193580ke_bit @ A @ N2 @ A2 )
            = A2 )
          = ( ( bit_se4197421643247451524op_bit @ A @ N2 @ A2 )
            = ( zero_zero @ A ) ) ) ) ).

% take_bit_eq_self_iff_drop_bit_eq_0
thf(fact_5363_drop__bit__push__bit__int,axiom,
    ! [M: nat,N2: nat,K: int] :
      ( ( bit_se4197421643247451524op_bit @ int @ M @ ( bit_se4730199178511100633sh_bit @ int @ N2 @ K ) )
      = ( bit_se4197421643247451524op_bit @ int @ ( minus_minus @ nat @ M @ N2 ) @ ( bit_se4730199178511100633sh_bit @ int @ ( minus_minus @ nat @ N2 @ M ) @ K ) ) ) ).

% drop_bit_push_bit_int
thf(fact_5364_take__bit__drop__bit,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M: nat,N2: nat,A2: A] :
          ( ( bit_se2584673776208193580ke_bit @ A @ M @ ( bit_se4197421643247451524op_bit @ A @ N2 @ A2 ) )
          = ( bit_se4197421643247451524op_bit @ A @ N2 @ ( bit_se2584673776208193580ke_bit @ A @ ( plus_plus @ nat @ M @ N2 ) @ A2 ) ) ) ) ).

% take_bit_drop_bit
thf(fact_5365_drop__bit__take__bit,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M: nat,N2: nat,A2: A] :
          ( ( bit_se4197421643247451524op_bit @ A @ M @ ( bit_se2584673776208193580ke_bit @ A @ N2 @ A2 ) )
          = ( bit_se2584673776208193580ke_bit @ A @ ( minus_minus @ nat @ N2 @ M ) @ ( bit_se4197421643247451524op_bit @ A @ M @ A2 ) ) ) ) ).

% drop_bit_take_bit
thf(fact_5366_gcd__mult__unit1,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( dvd_dvd @ A @ A2 @ ( one_one @ A ) )
         => ( ( gcd_gcd @ A @ ( times_times @ A @ B2 @ A2 ) @ C2 )
            = ( gcd_gcd @ A @ B2 @ C2 ) ) ) ) ).

% gcd_mult_unit1
thf(fact_5367_gcd__mult__unit2,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( dvd_dvd @ A @ A2 @ ( one_one @ A ) )
         => ( ( gcd_gcd @ A @ B2 @ ( times_times @ A @ C2 @ A2 ) )
            = ( gcd_gcd @ A @ B2 @ C2 ) ) ) ) ).

% gcd_mult_unit2
thf(fact_5368_gcd__div__unit1,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( dvd_dvd @ A @ A2 @ ( one_one @ A ) )
         => ( ( gcd_gcd @ A @ ( divide_divide @ A @ B2 @ A2 ) @ C2 )
            = ( gcd_gcd @ A @ B2 @ C2 ) ) ) ) ).

% gcd_div_unit1
thf(fact_5369_gcd__div__unit2,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( dvd_dvd @ A @ A2 @ ( one_one @ A ) )
         => ( ( gcd_gcd @ A @ B2 @ ( divide_divide @ A @ C2 @ A2 ) )
            = ( gcd_gcd @ A @ B2 @ C2 ) ) ) ) ).

% gcd_div_unit2
thf(fact_5370_gcd__le2__int,axiom,
    ! [B2: int,A2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ B2 )
     => ( ord_less_eq @ int @ ( gcd_gcd @ int @ A2 @ B2 ) @ B2 ) ) ).

% gcd_le2_int
thf(fact_5371_gcd__le1__int,axiom,
    ! [A2: int,B2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ A2 )
     => ( ord_less_eq @ int @ ( gcd_gcd @ int @ A2 @ B2 ) @ A2 ) ) ).

% gcd_le1_int
thf(fact_5372_gcd__cases__int,axiom,
    ! [X2: int,Y2: int,P: int > $o] :
      ( ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ X2 )
       => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Y2 )
         => ( P @ ( gcd_gcd @ int @ X2 @ Y2 ) ) ) )
     => ( ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ X2 )
         => ( ( ord_less_eq @ int @ Y2 @ ( zero_zero @ int ) )
           => ( P @ ( gcd_gcd @ int @ X2 @ ( uminus_uminus @ int @ Y2 ) ) ) ) )
       => ( ( ( ord_less_eq @ int @ X2 @ ( zero_zero @ int ) )
           => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Y2 )
             => ( P @ ( gcd_gcd @ int @ ( uminus_uminus @ int @ X2 ) @ Y2 ) ) ) )
         => ( ( ( ord_less_eq @ int @ X2 @ ( zero_zero @ int ) )
             => ( ( ord_less_eq @ int @ Y2 @ ( zero_zero @ int ) )
               => ( P @ ( gcd_gcd @ int @ ( uminus_uminus @ int @ X2 ) @ ( uminus_uminus @ int @ Y2 ) ) ) ) )
           => ( P @ ( gcd_gcd @ int @ X2 @ Y2 ) ) ) ) ) ) ).

% gcd_cases_int
thf(fact_5373_gcd__unique__int,axiom,
    ! [D2: int,A2: int,B2: int] :
      ( ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ D2 )
        & ( dvd_dvd @ int @ D2 @ A2 )
        & ( dvd_dvd @ int @ D2 @ B2 )
        & ! [E4: int] :
            ( ( ( dvd_dvd @ int @ E4 @ A2 )
              & ( dvd_dvd @ int @ E4 @ B2 ) )
           => ( dvd_dvd @ int @ E4 @ D2 ) ) )
      = ( D2
        = ( gcd_gcd @ int @ A2 @ B2 ) ) ) ).

% gcd_unique_int
thf(fact_5374_gcd__non__0__int,axiom,
    ! [Y2: int,X2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ Y2 )
     => ( ( gcd_gcd @ int @ X2 @ Y2 )
        = ( gcd_gcd @ int @ Y2 @ ( modulo_modulo @ int @ X2 @ Y2 ) ) ) ) ).

% gcd_non_0_int
thf(fact_5375_gcd__code__int,axiom,
    ( ( gcd_gcd @ int )
    = ( ^ [K3: int,L2: int] :
          ( abs_abs @ int
          @ ( if @ int
            @ ( L2
              = ( zero_zero @ int ) )
            @ K3
            @ ( gcd_gcd @ int @ L2 @ ( modulo_modulo @ int @ ( abs_abs @ int @ K3 ) @ ( abs_abs @ int @ L2 ) ) ) ) ) ) ) ).

% gcd_code_int
thf(fact_5376_div__push__bit__of__1__eq__drop__bit,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A,N2: nat] :
          ( ( divide_divide @ A @ A2 @ ( bit_se4730199178511100633sh_bit @ A @ N2 @ ( one_one @ A ) ) )
          = ( bit_se4197421643247451524op_bit @ A @ N2 @ A2 ) ) ) ).

% div_push_bit_of_1_eq_drop_bit
thf(fact_5377_bit__iff__and__drop__bit__eq__1,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se5641148757651400278ts_bit @ A )
        = ( ^ [A4: A,N3: nat] :
              ( ( bit_se5824344872417868541ns_and @ A @ ( bit_se4197421643247451524op_bit @ A @ N3 @ A4 ) @ ( one_one @ A ) )
              = ( one_one @ A ) ) ) ) ) ).

% bit_iff_and_drop_bit_eq_1
thf(fact_5378_bits__ident,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N2: nat,A2: A] :
          ( ( plus_plus @ A @ ( bit_se4730199178511100633sh_bit @ A @ N2 @ ( bit_se4197421643247451524op_bit @ A @ N2 @ A2 ) ) @ ( bit_se2584673776208193580ke_bit @ A @ N2 @ A2 ) )
          = A2 ) ) ).

% bits_ident
thf(fact_5379_drop__bit__half,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N2: nat,A2: A] :
          ( ( bit_se4197421643247451524op_bit @ A @ N2 @ ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) )
          = ( divide_divide @ A @ ( bit_se4197421643247451524op_bit @ A @ N2 @ A2 ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% drop_bit_half
thf(fact_5380_stable__imp__drop__bit__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A,N2: nat] :
          ( ( ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
            = A2 )
         => ( ( bit_se4197421643247451524op_bit @ A @ N2 @ A2 )
            = A2 ) ) ) ).

% stable_imp_drop_bit_eq
thf(fact_5381_drop__bit__int__def,axiom,
    ( ( bit_se4197421643247451524op_bit @ int )
    = ( ^ [N3: nat,K3: int] : ( divide_divide @ int @ K3 @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N3 ) ) ) ) ).

% drop_bit_int_def
thf(fact_5382_drop__bit__Suc,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N2: nat,A2: A] :
          ( ( bit_se4197421643247451524op_bit @ A @ ( suc @ N2 ) @ A2 )
          = ( bit_se4197421643247451524op_bit @ A @ N2 @ ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ).

% drop_bit_Suc
thf(fact_5383_drop__bit__eq__div,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se4197421643247451524op_bit @ A )
        = ( ^ [N3: nat,A4: A] : ( divide_divide @ A @ A4 @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N3 ) ) ) ) ) ).

% drop_bit_eq_div
thf(fact_5384_bit__iff__odd__drop__bit,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se5641148757651400278ts_bit @ A )
        = ( ^ [A4: A,N3: nat] :
              ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se4197421643247451524op_bit @ A @ N3 @ A4 ) ) ) ) ) ).

% bit_iff_odd_drop_bit
thf(fact_5385_even__drop__bit__iff__not__bit,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N2: nat,A2: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se4197421643247451524op_bit @ A @ N2 @ A2 ) )
          = ( ~ ( bit_se5641148757651400278ts_bit @ A @ A2 @ N2 ) ) ) ) ).

% even_drop_bit_iff_not_bit
thf(fact_5386_nat__descend__induct,axiom,
    ! [N2: nat,P: nat > $o,M: nat] :
      ( ! [K2: nat] :
          ( ( ord_less @ nat @ N2 @ K2 )
         => ( P @ K2 ) )
     => ( ! [K2: nat] :
            ( ( ord_less_eq @ nat @ K2 @ N2 )
           => ( ! [I: nat] :
                  ( ( ord_less @ nat @ K2 @ I )
                 => ( P @ I ) )
             => ( P @ K2 ) ) )
       => ( P @ M ) ) ) ).

% nat_descend_induct
thf(fact_5387_split__cong,axiom,
    ! [C: $tType,B: $tType,A: $tType,Q3: product_prod @ A @ B,F2: A > B > C,G: A > B > C,P4: product_prod @ A @ B] :
      ( ! [X3: A,Y4: B] :
          ( ( ( product_Pair @ A @ B @ X3 @ Y4 )
            = Q3 )
         => ( ( F2 @ X3 @ Y4 )
            = ( G @ X3 @ Y4 ) ) )
     => ( ( P4 = Q3 )
       => ( ( product_case_prod @ A @ B @ C @ F2 @ P4 )
          = ( product_case_prod @ A @ B @ C @ G @ Q3 ) ) ) ) ).

% split_cong
thf(fact_5388_slice__eq__mask,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N2: nat,M: nat,A2: A] :
          ( ( bit_se4730199178511100633sh_bit @ A @ N2 @ ( bit_se2584673776208193580ke_bit @ A @ M @ ( bit_se4197421643247451524op_bit @ A @ N2 @ A2 ) ) )
          = ( bit_se5824344872417868541ns_and @ A @ A2 @ ( bit_se5824344872417868541ns_and @ A @ ( bit_se2239418461657761734s_mask @ A @ ( plus_plus @ nat @ M @ N2 ) ) @ ( bit_ri4277139882892585799ns_not @ A @ ( bit_se2239418461657761734s_mask @ A @ N2 ) ) ) ) ) ) ).

% slice_eq_mask
thf(fact_5389_drop__bit__rec,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se4197421643247451524op_bit @ A )
        = ( ^ [N3: nat,A4: A] :
              ( if @ A
              @ ( N3
                = ( zero_zero @ nat ) )
              @ A4
              @ ( bit_se4197421643247451524op_bit @ A @ ( minus_minus @ nat @ N3 @ ( one_one @ nat ) ) @ ( divide_divide @ A @ A4 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% drop_bit_rec
thf(fact_5390_less__by__empty,axiom,
    ! [A: $tType,A3: set @ ( product_prod @ A @ A ),B3: set @ ( product_prod @ A @ A )] :
      ( ( A3
        = ( bot_bot @ ( set @ ( product_prod @ A @ A ) ) ) )
     => ( ord_less_eq @ ( set @ ( product_prod @ A @ A ) ) @ A3 @ B3 ) ) ).

% less_by_empty
thf(fact_5391_finite__enumerate,axiom,
    ! [S3: set @ nat] :
      ( ( finite_finite @ nat @ S3 )
     => ? [R4: nat > nat] :
          ( ( strict_mono_on @ nat @ nat @ R4 @ ( set_ord_lessThan @ nat @ ( finite_card @ nat @ S3 ) ) )
          & ! [N9: nat] :
              ( ( ord_less @ nat @ N9 @ ( finite_card @ nat @ S3 ) )
             => ( member @ nat @ ( R4 @ N9 ) @ S3 ) ) ) ) ).

% finite_enumerate
thf(fact_5392_divmod__integer__eq__cases,axiom,
    ( code_divmod_integer
    = ( ^ [K3: code_integer,L2: code_integer] :
          ( if @ ( product_prod @ code_integer @ code_integer )
          @ ( K3
            = ( zero_zero @ code_integer ) )
          @ ( product_Pair @ code_integer @ code_integer @ ( zero_zero @ code_integer ) @ ( zero_zero @ code_integer ) )
          @ ( if @ ( product_prod @ code_integer @ code_integer )
            @ ( L2
              = ( zero_zero @ code_integer ) )
            @ ( product_Pair @ code_integer @ code_integer @ ( zero_zero @ code_integer ) @ K3 )
            @ ( comp @ code_integer @ ( ( product_prod @ code_integer @ code_integer ) > ( product_prod @ code_integer @ code_integer ) ) @ code_integer @ ( comp @ ( code_integer > code_integer ) @ ( ( product_prod @ code_integer @ code_integer ) > ( product_prod @ code_integer @ code_integer ) ) @ code_integer @ ( product_apsnd @ code_integer @ code_integer @ code_integer ) @ ( times_times @ code_integer ) ) @ ( sgn_sgn @ code_integer ) @ L2
              @ ( if @ ( product_prod @ code_integer @ code_integer )
                @ ( ( sgn_sgn @ code_integer @ K3 )
                  = ( sgn_sgn @ code_integer @ L2 ) )
                @ ( code_divmod_abs @ K3 @ L2 )
                @ ( product_case_prod @ code_integer @ code_integer @ ( product_prod @ code_integer @ code_integer )
                  @ ^ [R5: code_integer,S7: code_integer] :
                      ( if @ ( product_prod @ code_integer @ code_integer )
                      @ ( S7
                        = ( zero_zero @ code_integer ) )
                      @ ( product_Pair @ code_integer @ code_integer @ ( uminus_uminus @ code_integer @ R5 ) @ ( zero_zero @ code_integer ) )
                      @ ( product_Pair @ code_integer @ code_integer @ ( minus_minus @ code_integer @ ( uminus_uminus @ code_integer @ R5 ) @ ( one_one @ code_integer ) ) @ ( minus_minus @ code_integer @ ( abs_abs @ code_integer @ L2 ) @ S7 ) ) )
                  @ ( code_divmod_abs @ K3 @ L2 ) ) ) ) ) ) ) ) ).

% divmod_integer_eq_cases
thf(fact_5393_nth__rotate1,axiom,
    ! [A: $tType,N2: nat,Xs: list @ A] :
      ( ( ord_less @ nat @ N2 @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( ( nth @ A @ ( rotate1 @ A @ Xs ) @ N2 )
        = ( nth @ A @ Xs @ ( modulo_modulo @ nat @ ( suc @ N2 ) @ ( size_size @ ( list @ A ) @ Xs ) ) ) ) ) ).

% nth_rotate1
thf(fact_5394_gcd__0__left__nat,axiom,
    ! [X2: nat] :
      ( ( gcd_gcd @ nat @ ( zero_zero @ nat ) @ X2 )
      = X2 ) ).

% gcd_0_left_nat
thf(fact_5395_gcd__0__nat,axiom,
    ! [X2: nat] :
      ( ( gcd_gcd @ nat @ X2 @ ( zero_zero @ nat ) )
      = X2 ) ).

% gcd_0_nat
thf(fact_5396_gcd__nat_Oright__neutral,axiom,
    ! [A2: nat] :
      ( ( gcd_gcd @ nat @ A2 @ ( zero_zero @ nat ) )
      = A2 ) ).

% gcd_nat.right_neutral
thf(fact_5397_gcd__nat_Oneutr__eq__iff,axiom,
    ! [A2: nat,B2: nat] :
      ( ( ( zero_zero @ nat )
        = ( gcd_gcd @ nat @ A2 @ B2 ) )
      = ( ( A2
          = ( zero_zero @ nat ) )
        & ( B2
          = ( zero_zero @ nat ) ) ) ) ).

% gcd_nat.neutr_eq_iff
thf(fact_5398_gcd__nat_Oleft__neutral,axiom,
    ! [A2: nat] :
      ( ( gcd_gcd @ nat @ ( zero_zero @ nat ) @ A2 )
      = A2 ) ).

% gcd_nat.left_neutral
thf(fact_5399_gcd__nat_Oeq__neutr__iff,axiom,
    ! [A2: nat,B2: nat] :
      ( ( ( gcd_gcd @ nat @ A2 @ B2 )
        = ( zero_zero @ nat ) )
      = ( ( A2
          = ( zero_zero @ nat ) )
        & ( B2
          = ( zero_zero @ nat ) ) ) ) ).

% gcd_nat.eq_neutr_iff
thf(fact_5400_gcd__1__nat,axiom,
    ! [M: nat] :
      ( ( gcd_gcd @ nat @ M @ ( one_one @ nat ) )
      = ( one_one @ nat ) ) ).

% gcd_1_nat
thf(fact_5401_gcd__Suc__0,axiom,
    ! [M: nat] :
      ( ( gcd_gcd @ nat @ M @ ( suc @ ( zero_zero @ nat ) ) )
      = ( suc @ ( zero_zero @ nat ) ) ) ).

% gcd_Suc_0
thf(fact_5402_gcd__pos__nat,axiom,
    ! [M: nat,N2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( gcd_gcd @ nat @ M @ N2 ) )
      = ( ( M
         != ( zero_zero @ nat ) )
        | ( N2
         != ( zero_zero @ nat ) ) ) ) ).

% gcd_pos_nat
thf(fact_5403_set__rotate1,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( set2 @ A @ ( rotate1 @ A @ Xs ) )
      = ( set2 @ A @ Xs ) ) ).

% set_rotate1
thf(fact_5404_length__rotate1,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( size_size @ ( list @ A ) @ ( rotate1 @ A @ Xs ) )
      = ( size_size @ ( list @ A ) @ Xs ) ) ).

% length_rotate1
thf(fact_5405_distinct1__rotate,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( distinct @ A @ ( rotate1 @ A @ Xs ) )
      = ( distinct @ A @ Xs ) ) ).

% distinct1_rotate
thf(fact_5406_rotate1__length01,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ ( one_one @ nat ) )
     => ( ( rotate1 @ A @ Xs )
        = Xs ) ) ).

% rotate1_length01
thf(fact_5407_drop__bit__of__Suc__0,axiom,
    ! [N2: nat] :
      ( ( bit_se4197421643247451524op_bit @ nat @ N2 @ ( suc @ ( zero_zero @ nat ) ) )
      = ( zero_neq_one_of_bool @ nat
        @ ( N2
          = ( zero_zero @ nat ) ) ) ) ).

% drop_bit_of_Suc_0
thf(fact_5408_gcd__mult__distrib__nat,axiom,
    ! [K: nat,M: nat,N2: nat] :
      ( ( times_times @ nat @ K @ ( gcd_gcd @ nat @ M @ N2 ) )
      = ( gcd_gcd @ nat @ ( times_times @ nat @ K @ M ) @ ( times_times @ nat @ K @ N2 ) ) ) ).

% gcd_mult_distrib_nat
thf(fact_5409_gcd__le2__nat,axiom,
    ! [B2: nat,A2: nat] :
      ( ( B2
       != ( zero_zero @ nat ) )
     => ( ord_less_eq @ nat @ ( gcd_gcd @ nat @ A2 @ B2 ) @ B2 ) ) ).

% gcd_le2_nat
thf(fact_5410_gcd__le1__nat,axiom,
    ! [A2: nat,B2: nat] :
      ( ( A2
       != ( zero_zero @ nat ) )
     => ( ord_less_eq @ nat @ ( gcd_gcd @ nat @ A2 @ B2 ) @ A2 ) ) ).

% gcd_le1_nat
thf(fact_5411_gcd__diff2__nat,axiom,
    ! [M: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ M @ N2 )
     => ( ( gcd_gcd @ nat @ ( minus_minus @ nat @ N2 @ M ) @ N2 )
        = ( gcd_gcd @ nat @ M @ N2 ) ) ) ).

% gcd_diff2_nat
thf(fact_5412_gcd__diff1__nat,axiom,
    ! [N2: nat,M: nat] :
      ( ( ord_less_eq @ nat @ N2 @ M )
     => ( ( gcd_gcd @ nat @ ( minus_minus @ nat @ M @ N2 ) @ N2 )
        = ( gcd_gcd @ nat @ M @ N2 ) ) ) ).

% gcd_diff1_nat
thf(fact_5413_gcd__non__0__nat,axiom,
    ! [Y2: nat,X2: nat] :
      ( ( Y2
       != ( zero_zero @ nat ) )
     => ( ( gcd_gcd @ nat @ X2 @ Y2 )
        = ( gcd_gcd @ nat @ Y2 @ ( modulo_modulo @ nat @ X2 @ Y2 ) ) ) ) ).

% gcd_non_0_nat
thf(fact_5414_gcd__nat_Osimps,axiom,
    ( ( gcd_gcd @ nat )
    = ( ^ [X5: nat,Y5: nat] :
          ( if @ nat
          @ ( Y5
            = ( zero_zero @ nat ) )
          @ X5
          @ ( gcd_gcd @ nat @ Y5 @ ( modulo_modulo @ nat @ X5 @ Y5 ) ) ) ) ) ).

% gcd_nat.simps
thf(fact_5415_gcd__nat_Oelims,axiom,
    ! [X2: nat,Xa2: nat,Y2: nat] :
      ( ( ( gcd_gcd @ nat @ X2 @ Xa2 )
        = Y2 )
     => ( ( ( Xa2
            = ( zero_zero @ nat ) )
         => ( Y2 = X2 ) )
        & ( ( Xa2
           != ( zero_zero @ nat ) )
         => ( Y2
            = ( gcd_gcd @ nat @ Xa2 @ ( modulo_modulo @ nat @ X2 @ Xa2 ) ) ) ) ) ) ).

% gcd_nat.elims
thf(fact_5416_drop__bit__nat__eq,axiom,
    ! [N2: nat,K: int] :
      ( ( bit_se4197421643247451524op_bit @ nat @ N2 @ ( nat2 @ K ) )
      = ( nat2 @ ( bit_se4197421643247451524op_bit @ int @ N2 @ K ) ) ) ).

% drop_bit_nat_eq
thf(fact_5417_sum__comp__morphism,axiom,
    ! [A: $tType,B: $tType,C: $tType] :
      ( ( ( comm_monoid_add @ B )
        & ( comm_monoid_add @ A ) )
     => ! [H2: B > A,G: C > B,A3: set @ C] :
          ( ( ( H2 @ ( zero_zero @ B ) )
            = ( zero_zero @ A ) )
         => ( ! [X3: B,Y4: B] :
                ( ( H2 @ ( plus_plus @ B @ X3 @ Y4 ) )
                = ( plus_plus @ A @ ( H2 @ X3 ) @ ( H2 @ Y4 ) ) )
           => ( ( groups7311177749621191930dd_sum @ C @ A @ ( comp @ B @ A @ C @ H2 @ G ) @ A3 )
              = ( H2 @ ( groups7311177749621191930dd_sum @ C @ B @ G @ A3 ) ) ) ) ) ) ).

% sum_comp_morphism
thf(fact_5418_bezout__nat,axiom,
    ! [A2: nat,B2: nat] :
      ( ( A2
       != ( zero_zero @ nat ) )
     => ? [X3: nat,Y4: nat] :
          ( ( times_times @ nat @ A2 @ X3 )
          = ( plus_plus @ nat @ ( times_times @ nat @ B2 @ Y4 ) @ ( gcd_gcd @ nat @ A2 @ B2 ) ) ) ) ).

% bezout_nat
thf(fact_5419_bezout__gcd__nat_H,axiom,
    ! [B2: nat,A2: nat] :
    ? [X3: nat,Y4: nat] :
      ( ( ( ord_less_eq @ nat @ ( times_times @ nat @ B2 @ Y4 ) @ ( times_times @ nat @ A2 @ X3 ) )
        & ( ( minus_minus @ nat @ ( times_times @ nat @ A2 @ X3 ) @ ( times_times @ nat @ B2 @ Y4 ) )
          = ( gcd_gcd @ nat @ A2 @ B2 ) ) )
      | ( ( ord_less_eq @ nat @ ( times_times @ nat @ A2 @ Y4 ) @ ( times_times @ nat @ B2 @ X3 ) )
        & ( ( minus_minus @ nat @ ( times_times @ nat @ B2 @ X3 ) @ ( times_times @ nat @ A2 @ Y4 ) )
          = ( gcd_gcd @ nat @ A2 @ B2 ) ) ) ) ).

% bezout_gcd_nat'
thf(fact_5420_gcd__code__integer,axiom,
    ( ( gcd_gcd @ code_integer )
    = ( ^ [K3: code_integer,L2: code_integer] :
          ( abs_abs @ code_integer
          @ ( if @ code_integer
            @ ( L2
              = ( zero_zero @ code_integer ) )
            @ K3
            @ ( gcd_gcd @ code_integer @ L2 @ ( modulo_modulo @ code_integer @ ( abs_abs @ code_integer @ K3 ) @ ( abs_abs @ code_integer @ L2 ) ) ) ) ) ) ) ).

% gcd_code_integer
thf(fact_5421_drop__bit__nat__def,axiom,
    ( ( bit_se4197421643247451524op_bit @ nat )
    = ( ^ [N3: nat,M6: nat] : ( divide_divide @ nat @ M6 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N3 ) ) ) ) ).

% drop_bit_nat_def
thf(fact_5422_bezw__aux,axiom,
    ! [X2: nat,Y2: nat] :
      ( ( semiring_1_of_nat @ int @ ( gcd_gcd @ nat @ X2 @ Y2 ) )
      = ( plus_plus @ int @ ( times_times @ int @ ( product_fst @ int @ int @ ( bezw @ X2 @ Y2 ) ) @ ( semiring_1_of_nat @ int @ X2 ) ) @ ( times_times @ int @ ( product_snd @ int @ int @ ( bezw @ X2 @ Y2 ) ) @ ( semiring_1_of_nat @ int @ Y2 ) ) ) ) ).

% bezw_aux
thf(fact_5423_gcd__nat_Opelims,axiom,
    ! [X2: nat,Xa2: nat,Y2: nat] :
      ( ( ( gcd_gcd @ nat @ X2 @ Xa2 )
        = Y2 )
     => ( ( accp @ ( product_prod @ nat @ nat ) @ gcd_nat_rel @ ( product_Pair @ nat @ nat @ X2 @ Xa2 ) )
       => ~ ( ( ( ( Xa2
                  = ( zero_zero @ nat ) )
               => ( Y2 = X2 ) )
              & ( ( Xa2
                 != ( zero_zero @ nat ) )
               => ( Y2
                  = ( gcd_gcd @ nat @ Xa2 @ ( modulo_modulo @ nat @ X2 @ Xa2 ) ) ) ) )
           => ~ ( accp @ ( product_prod @ nat @ nat ) @ gcd_nat_rel @ ( product_Pair @ nat @ nat @ X2 @ Xa2 ) ) ) ) ) ).

% gcd_nat.pelims
thf(fact_5424_strict__mono__onD,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( ord @ A )
        & ( ord @ B ) )
     => ! [F2: A > B,A3: set @ A,R3: A,S2: A] :
          ( ( strict_mono_on @ A @ B @ F2 @ A3 )
         => ( ( member @ A @ R3 @ A3 )
           => ( ( member @ A @ S2 @ A3 )
             => ( ( ord_less @ A @ R3 @ S2 )
               => ( ord_less @ B @ ( F2 @ R3 ) @ ( F2 @ S2 ) ) ) ) ) ) ) ).

% strict_mono_onD
thf(fact_5425_strict__mono__onI,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( ord @ A )
        & ( ord @ B ) )
     => ! [A3: set @ A,F2: A > B] :
          ( ! [R4: A,S: A] :
              ( ( member @ A @ R4 @ A3 )
             => ( ( member @ A @ S @ A3 )
               => ( ( ord_less @ A @ R4 @ S )
                 => ( ord_less @ B @ ( F2 @ R4 ) @ ( F2 @ S ) ) ) ) )
         => ( strict_mono_on @ A @ B @ F2 @ A3 ) ) ) ).

% strict_mono_onI
thf(fact_5426_card_Ocomp__fun__commute__on,axiom,
    ( ( comp @ nat @ nat @ nat @ suc @ suc )
    = ( comp @ nat @ nat @ nat @ suc @ suc ) ) ).

% card.comp_fun_commute_on
thf(fact_5427_fst__diag__fst,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comp @ ( product_prod @ A @ A ) @ A @ ( product_prod @ A @ B ) @ ( product_fst @ A @ A )
        @ ( comp @ A @ ( product_prod @ A @ A ) @ ( product_prod @ A @ B )
          @ ^ [X5: A] : ( product_Pair @ A @ A @ X5 @ X5 )
          @ ( product_fst @ A @ B ) ) )
      = ( product_fst @ A @ B ) ) ).

% fst_diag_fst
thf(fact_5428_snd__diag__snd,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comp @ ( product_prod @ B @ B ) @ B @ ( product_prod @ A @ B ) @ ( product_snd @ B @ B )
        @ ( comp @ B @ ( product_prod @ B @ B ) @ ( product_prod @ A @ B )
          @ ^ [X5: B] : ( product_Pair @ B @ B @ X5 @ X5 )
          @ ( product_snd @ A @ B ) ) )
      = ( product_snd @ A @ B ) ) ).

% snd_diag_snd
thf(fact_5429_snd__diag__fst,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comp @ ( product_prod @ A @ A ) @ A @ ( product_prod @ A @ B ) @ ( product_snd @ A @ A )
        @ ( comp @ A @ ( product_prod @ A @ A ) @ ( product_prod @ A @ B )
          @ ^ [X5: A] : ( product_Pair @ A @ A @ X5 @ X5 )
          @ ( product_fst @ A @ B ) ) )
      = ( product_fst @ A @ B ) ) ).

% snd_diag_fst
thf(fact_5430_fst__diag__snd,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comp @ ( product_prod @ B @ B ) @ B @ ( product_prod @ A @ B ) @ ( product_fst @ B @ B )
        @ ( comp @ B @ ( product_prod @ B @ B ) @ ( product_prod @ A @ B )
          @ ^ [X5: B] : ( product_Pair @ B @ B @ X5 @ X5 )
          @ ( product_snd @ A @ B ) ) )
      = ( product_snd @ A @ B ) ) ).

% fst_diag_snd
thf(fact_5431_sum_OatLeast__Suc__atMost__Suc__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,M: nat,N2: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ M ) @ ( suc @ N2 ) ) )
          = ( groups7311177749621191930dd_sum @ nat @ A @ ( comp @ nat @ A @ nat @ G @ suc ) @ ( set_or1337092689740270186AtMost @ nat @ M @ N2 ) ) ) ) ).

% sum.atLeast_Suc_atMost_Suc_shift
thf(fact_5432_sum_OatLeast__Suc__lessThan__Suc__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,M: nat,N2: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ ( suc @ M ) @ ( suc @ N2 ) ) )
          = ( groups7311177749621191930dd_sum @ nat @ A @ ( comp @ nat @ A @ nat @ G @ suc ) @ ( set_or7035219750837199246ssThan @ nat @ M @ N2 ) ) ) ) ).

% sum.atLeast_Suc_lessThan_Suc_shift
thf(fact_5433_sum_OatLeastAtMost__shift__bounds,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,M: nat,K: nat,N2: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( plus_plus @ nat @ M @ K ) @ ( plus_plus @ nat @ N2 @ K ) ) )
          = ( groups7311177749621191930dd_sum @ nat @ A @ ( comp @ nat @ A @ nat @ G @ ( plus_plus @ nat @ K ) ) @ ( set_or1337092689740270186AtMost @ nat @ M @ N2 ) ) ) ) ).

% sum.atLeastAtMost_shift_bounds
thf(fact_5434_sum_OatLeastLessThan__shift__bounds,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,M: nat,K: nat,N2: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ ( plus_plus @ nat @ M @ K ) @ ( plus_plus @ nat @ N2 @ K ) ) )
          = ( groups7311177749621191930dd_sum @ nat @ A @ ( comp @ nat @ A @ nat @ G @ ( plus_plus @ nat @ K ) ) @ ( set_or7035219750837199246ssThan @ nat @ M @ N2 ) ) ) ) ).

% sum.atLeastLessThan_shift_bounds
thf(fact_5435_prod_OatLeast__Suc__atMost__Suc__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,M: nat,N2: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ M ) @ ( suc @ N2 ) ) )
          = ( groups7121269368397514597t_prod @ nat @ A @ ( comp @ nat @ A @ nat @ G @ suc ) @ ( set_or1337092689740270186AtMost @ nat @ M @ N2 ) ) ) ) ).

% prod.atLeast_Suc_atMost_Suc_shift
thf(fact_5436_prod_OatLeast__Suc__lessThan__Suc__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,M: nat,N2: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ ( suc @ M ) @ ( suc @ N2 ) ) )
          = ( groups7121269368397514597t_prod @ nat @ A @ ( comp @ nat @ A @ nat @ G @ suc ) @ ( set_or7035219750837199246ssThan @ nat @ M @ N2 ) ) ) ) ).

% prod.atLeast_Suc_lessThan_Suc_shift
thf(fact_5437_prod_OatLeastAtMost__shift__bounds,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,M: nat,K: nat,N2: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( plus_plus @ nat @ M @ K ) @ ( plus_plus @ nat @ N2 @ K ) ) )
          = ( groups7121269368397514597t_prod @ nat @ A @ ( comp @ nat @ A @ nat @ G @ ( plus_plus @ nat @ K ) ) @ ( set_or1337092689740270186AtMost @ nat @ M @ N2 ) ) ) ) ).

% prod.atLeastAtMost_shift_bounds
thf(fact_5438_prod_OatLeastLessThan__shift__bounds,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,M: nat,K: nat,N2: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ ( plus_plus @ nat @ M @ K ) @ ( plus_plus @ nat @ N2 @ K ) ) )
          = ( groups7121269368397514597t_prod @ nat @ A @ ( comp @ nat @ A @ nat @ G @ ( plus_plus @ nat @ K ) ) @ ( set_or7035219750837199246ssThan @ nat @ M @ N2 ) ) ) ) ).

% prod.atLeastLessThan_shift_bounds
thf(fact_5439_bit__drop__bit__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N2: nat,A2: A] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( bit_se4197421643247451524op_bit @ A @ N2 @ A2 ) )
          = ( comp @ nat @ $o @ nat @ ( bit_se5641148757651400278ts_bit @ A @ A2 ) @ ( plus_plus @ nat @ N2 ) ) ) ) ).

% bit_drop_bit_eq
thf(fact_5440_summable__inverse__divide,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: nat > A,C2: A] :
          ( ( summable @ A @ ( comp @ A @ A @ nat @ ( inverse_inverse @ A ) @ F2 ) )
         => ( summable @ A
            @ ^ [N3: nat] : ( divide_divide @ A @ C2 @ ( F2 @ N3 ) ) ) ) ) ).

% summable_inverse_divide
thf(fact_5441_sum_OatLeast0__atMost__Suc__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,N2: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ ( suc @ N2 ) ) )
          = ( plus_plus @ A @ ( G @ ( zero_zero @ nat ) ) @ ( groups7311177749621191930dd_sum @ nat @ A @ ( comp @ nat @ A @ nat @ G @ suc ) @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N2 ) ) ) ) ) ).

% sum.atLeast0_atMost_Suc_shift
thf(fact_5442_sum_OatLeast0__lessThan__Suc__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,N2: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( suc @ N2 ) ) )
          = ( plus_plus @ A @ ( G @ ( zero_zero @ nat ) ) @ ( groups7311177749621191930dd_sum @ nat @ A @ ( comp @ nat @ A @ nat @ G @ suc ) @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N2 ) ) ) ) ) ).

% sum.atLeast0_lessThan_Suc_shift
thf(fact_5443_prod_OatLeast0__atMost__Suc__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,N2: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ ( suc @ N2 ) ) )
          = ( times_times @ A @ ( G @ ( zero_zero @ nat ) ) @ ( groups7121269368397514597t_prod @ nat @ A @ ( comp @ nat @ A @ nat @ G @ suc ) @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N2 ) ) ) ) ) ).

% prod.atLeast0_atMost_Suc_shift
thf(fact_5444_prod_OatLeast0__lessThan__Suc__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,N2: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( suc @ N2 ) ) )
          = ( times_times @ A @ ( G @ ( zero_zero @ nat ) ) @ ( groups7121269368397514597t_prod @ nat @ A @ ( comp @ nat @ A @ nat @ G @ suc ) @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N2 ) ) ) ) ) ).

% prod.atLeast0_lessThan_Suc_shift
thf(fact_5445_sum_OatLeastLessThan__shift__0,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,M: nat,N2: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ M @ N2 ) )
          = ( groups7311177749621191930dd_sum @ nat @ A @ ( comp @ nat @ A @ nat @ G @ ( plus_plus @ nat @ M ) ) @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( minus_minus @ nat @ N2 @ M ) ) ) ) ) ).

% sum.atLeastLessThan_shift_0
thf(fact_5446_prod_OatLeastLessThan__shift__0,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,M: nat,N2: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ M @ N2 ) )
          = ( groups7121269368397514597t_prod @ nat @ A @ ( comp @ nat @ A @ nat @ G @ ( plus_plus @ nat @ M ) ) @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( minus_minus @ nat @ N2 @ M ) ) ) ) ) ).

% prod.atLeastLessThan_shift_0
thf(fact_5447_sum_OatLeast__atMost__pred__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,M: nat,N2: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ( comp @ nat @ A @ nat @ G
              @ ^ [N3: nat] : ( minus_minus @ nat @ N3 @ ( suc @ ( zero_zero @ nat ) ) ) )
            @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ M ) @ ( suc @ N2 ) ) )
          = ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ N2 ) ) ) ) ).

% sum.atLeast_atMost_pred_shift
thf(fact_5448_sum_OatLeast__lessThan__pred__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,M: nat,N2: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ( comp @ nat @ A @ nat @ G
              @ ^ [N3: nat] : ( minus_minus @ nat @ N3 @ ( suc @ ( zero_zero @ nat ) ) ) )
            @ ( set_or7035219750837199246ssThan @ nat @ ( suc @ M ) @ ( suc @ N2 ) ) )
          = ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ M @ N2 ) ) ) ) ).

% sum.atLeast_lessThan_pred_shift
thf(fact_5449_prod_OatLeast__atMost__pred__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,M: nat,N2: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A
            @ ( comp @ nat @ A @ nat @ G
              @ ^ [N3: nat] : ( minus_minus @ nat @ N3 @ ( suc @ ( zero_zero @ nat ) ) ) )
            @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ M ) @ ( suc @ N2 ) ) )
          = ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ N2 ) ) ) ) ).

% prod.atLeast_atMost_pred_shift
thf(fact_5450_prod_OatLeast__lessThan__pred__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,M: nat,N2: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A
            @ ( comp @ nat @ A @ nat @ G
              @ ^ [N3: nat] : ( minus_minus @ nat @ N3 @ ( suc @ ( zero_zero @ nat ) ) ) )
            @ ( set_or7035219750837199246ssThan @ nat @ ( suc @ M ) @ ( suc @ N2 ) ) )
          = ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ M @ N2 ) ) ) ) ).

% prod.atLeast_lessThan_pred_shift
thf(fact_5451_sum_OatLeastAtMost__shift__0,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [M: nat,N2: nat,G: nat > A] :
          ( ( ord_less_eq @ nat @ M @ N2 )
         => ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ N2 ) )
            = ( groups7311177749621191930dd_sum @ nat @ A @ ( comp @ nat @ A @ nat @ G @ ( plus_plus @ nat @ M ) ) @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ ( minus_minus @ nat @ N2 @ M ) ) ) ) ) ) ).

% sum.atLeastAtMost_shift_0
thf(fact_5452_prod_OatLeastAtMost__shift__0,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [M: nat,N2: nat,G: nat > A] :
          ( ( ord_less_eq @ nat @ M @ N2 )
         => ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ N2 ) )
            = ( groups7121269368397514597t_prod @ nat @ A @ ( comp @ nat @ A @ nat @ G @ ( plus_plus @ nat @ M ) ) @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ ( minus_minus @ nat @ N2 @ M ) ) ) ) ) ) ).

% prod.atLeastAtMost_shift_0
thf(fact_5453_strict__mono__on__leD,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( linorder @ A )
        & ( preorder @ B ) )
     => ! [F2: A > B,A3: set @ A,X2: A,Y2: A] :
          ( ( strict_mono_on @ A @ B @ F2 @ A3 )
         => ( ( member @ A @ X2 @ A3 )
           => ( ( member @ A @ Y2 @ A3 )
             => ( ( ord_less_eq @ A @ X2 @ Y2 )
               => ( ord_less_eq @ B @ ( F2 @ X2 ) @ ( F2 @ Y2 ) ) ) ) ) ) ) ).

% strict_mono_on_leD
thf(fact_5454_strict__mono__on__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( ord @ A )
        & ( ord @ B ) )
     => ( ( strict_mono_on @ A @ B )
        = ( ^ [F5: A > B,A7: set @ A] :
            ! [R5: A,S7: A] :
              ( ( ( member @ A @ R5 @ A7 )
                & ( member @ A @ S7 @ A7 )
                & ( ord_less @ A @ R5 @ S7 ) )
             => ( ord_less @ B @ ( F5 @ R5 ) @ ( F5 @ S7 ) ) ) ) ) ) ).

% strict_mono_on_def
thf(fact_5455_Code__Numeral_Onegative__def,axiom,
    ( code_negative
    = ( comp @ code_integer @ code_integer @ num @ ( uminus_uminus @ code_integer ) @ ( numeral_numeral @ code_integer ) ) ) ).

% Code_Numeral.negative_def
thf(fact_5456_fst__snd__flip,axiom,
    ! [B: $tType,A: $tType] :
      ( ( product_fst @ A @ B )
      = ( comp @ ( product_prod @ B @ A ) @ A @ ( product_prod @ A @ B ) @ ( product_snd @ B @ A )
        @ ( product_case_prod @ A @ B @ ( product_prod @ B @ A )
          @ ^ [X5: A,Y5: B] : ( product_Pair @ B @ A @ Y5 @ X5 ) ) ) ) ).

% fst_snd_flip
thf(fact_5457_snd__fst__flip,axiom,
    ! [A: $tType,B: $tType] :
      ( ( product_snd @ B @ A )
      = ( comp @ ( product_prod @ A @ B ) @ A @ ( product_prod @ B @ A ) @ ( product_fst @ A @ B )
        @ ( product_case_prod @ B @ A @ ( product_prod @ A @ B )
          @ ^ [X5: B,Y5: A] : ( product_Pair @ A @ B @ Y5 @ X5 ) ) ) ) ).

% snd_fst_flip
thf(fact_5458_ge__eq__refl,axiom,
    ! [A: $tType,R: A > A > $o,X2: A] :
      ( ( ord_less_eq @ ( A > A > $o )
        @ ^ [Y3: A,Z2: A] : ( Y3 = Z2 )
        @ R )
     => ( R @ X2 @ X2 ) ) ).

% ge_eq_refl
thf(fact_5459_refl__ge__eq,axiom,
    ! [A: $tType,R: A > A > $o] :
      ( ! [X3: A] : ( R @ X3 @ X3 )
     => ( ord_less_eq @ ( A > A > $o )
        @ ^ [Y3: A,Z2: A] : ( Y3 = Z2 )
        @ R ) ) ).

% refl_ge_eq
thf(fact_5460_fstI,axiom,
    ! [B: $tType,A: $tType,X2: product_prod @ A @ B,Y2: A,Z: B] :
      ( ( X2
        = ( product_Pair @ A @ B @ Y2 @ Z ) )
     => ( ( product_fst @ A @ B @ X2 )
        = Y2 ) ) ).

% fstI
thf(fact_5461_sndI,axiom,
    ! [A: $tType,B: $tType,X2: product_prod @ A @ B,Y2: A,Z: B] :
      ( ( X2
        = ( product_Pair @ A @ B @ Y2 @ Z ) )
     => ( ( product_snd @ A @ B @ X2 )
        = Z ) ) ).

% sndI
thf(fact_5462_Code__Target__Int_Onegative__def,axiom,
    ( code_Target_negative
    = ( comp @ int @ int @ num @ ( uminus_uminus @ int ) @ ( numeral_numeral @ int ) ) ) ).

% Code_Target_Int.negative_def
thf(fact_5463_set__remove1__eq,axiom,
    ! [A: $tType,Xs: list @ A,X2: A] :
      ( ( distinct @ A @ Xs )
     => ( ( set2 @ A @ ( remove1 @ A @ X2 @ Xs ) )
        = ( minus_minus @ ( set @ A ) @ ( set2 @ A @ Xs ) @ ( insert @ A @ X2 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% set_remove1_eq
thf(fact_5464_xor__minus__numerals_I1_J,axiom,
    ! [N2: num,K: int] :
      ( ( bit_se5824344971392196577ns_xor @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N2 ) ) @ K )
      = ( bit_ri4277139882892585799ns_not @ int @ ( bit_se5824344971392196577ns_xor @ int @ ( neg_numeral_sub @ int @ N2 @ one2 ) @ K ) ) ) ).

% xor_minus_numerals(1)
thf(fact_5465_in__set__remove1,axiom,
    ! [A: $tType,A2: A,B2: A,Xs: list @ A] :
      ( ( A2 != B2 )
     => ( ( member @ A @ A2 @ ( set2 @ A @ ( remove1 @ A @ B2 @ Xs ) ) )
        = ( member @ A @ A2 @ ( set2 @ A @ Xs ) ) ) ) ).

% in_set_remove1
thf(fact_5466_sub__num__simps_I1_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( neg_numeral_sub @ A @ one2 @ one2 )
        = ( zero_zero @ A ) ) ) ).

% sub_num_simps(1)
thf(fact_5467_diff__numeral__simps_I1_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [M: num,N2: num] :
          ( ( minus_minus @ A @ ( numeral_numeral @ A @ M ) @ ( numeral_numeral @ A @ N2 ) )
          = ( neg_numeral_sub @ A @ M @ N2 ) ) ) ).

% diff_numeral_simps(1)
thf(fact_5468_sub__num__simps_I6_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [K: num,L: num] :
          ( ( neg_numeral_sub @ A @ ( bit0 @ K ) @ ( bit0 @ L ) )
          = ( neg_numeral_dbl @ A @ ( neg_numeral_sub @ A @ K @ L ) ) ) ) ).

% sub_num_simps(6)
thf(fact_5469_sub__num__simps_I9_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [K: num,L: num] :
          ( ( neg_numeral_sub @ A @ ( bit1 @ K ) @ ( bit1 @ L ) )
          = ( neg_numeral_dbl @ A @ ( neg_numeral_sub @ A @ K @ L ) ) ) ) ).

% sub_num_simps(9)
thf(fact_5470_semiring__norm_I167_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [V: num,W: num,Y2: A] :
          ( ( plus_plus @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) @ ( plus_plus @ A @ ( numeral_numeral @ A @ W ) @ Y2 ) )
          = ( plus_plus @ A @ ( neg_numeral_sub @ A @ W @ V ) @ Y2 ) ) ) ).

% semiring_norm(167)
thf(fact_5471_semiring__norm_I166_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [V: num,W: num,Y2: A] :
          ( ( plus_plus @ A @ ( numeral_numeral @ A @ V ) @ ( plus_plus @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) @ Y2 ) )
          = ( plus_plus @ A @ ( neg_numeral_sub @ A @ V @ W ) @ Y2 ) ) ) ).

% semiring_norm(166)
thf(fact_5472_add__neg__numeral__simps_I2_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [M: num,N2: num] :
          ( ( plus_plus @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) @ ( numeral_numeral @ A @ N2 ) )
          = ( neg_numeral_sub @ A @ N2 @ M ) ) ) ).

% add_neg_numeral_simps(2)
thf(fact_5473_add__neg__numeral__simps_I1_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [M: num,N2: num] :
          ( ( plus_plus @ A @ ( numeral_numeral @ A @ M ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N2 ) ) )
          = ( neg_numeral_sub @ A @ M @ N2 ) ) ) ).

% add_neg_numeral_simps(1)
thf(fact_5474_diff__numeral__simps_I4_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [M: num,N2: num] :
          ( ( minus_minus @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N2 ) ) )
          = ( neg_numeral_sub @ A @ N2 @ M ) ) ) ).

% diff_numeral_simps(4)
thf(fact_5475_sub__num__simps_I7_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [K: num,L: num] :
          ( ( neg_numeral_sub @ A @ ( bit0 @ K ) @ ( bit1 @ L ) )
          = ( neg_numeral_dbl_dec @ A @ ( neg_numeral_sub @ A @ K @ L ) ) ) ) ).

% sub_num_simps(7)
thf(fact_5476_sub__num__simps_I8_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [K: num,L: num] :
          ( ( neg_numeral_sub @ A @ ( bit1 @ K ) @ ( bit0 @ L ) )
          = ( neg_numeral_dbl_inc @ A @ ( neg_numeral_sub @ A @ K @ L ) ) ) ) ).

% sub_num_simps(8)
thf(fact_5477_diff__numeral__special_I2_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [M: num] :
          ( ( minus_minus @ A @ ( numeral_numeral @ A @ M ) @ ( one_one @ A ) )
          = ( neg_numeral_sub @ A @ M @ one2 ) ) ) ).

% diff_numeral_special(2)
thf(fact_5478_diff__numeral__special_I1_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [N2: num] :
          ( ( minus_minus @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ N2 ) )
          = ( neg_numeral_sub @ A @ one2 @ N2 ) ) ) ).

% diff_numeral_special(1)
thf(fact_5479_sub__num__simps_I5_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [K: num] :
          ( ( neg_numeral_sub @ A @ ( bit1 @ K ) @ one2 )
          = ( numeral_numeral @ A @ ( bit0 @ K ) ) ) ) ).

% sub_num_simps(5)
thf(fact_5480_not__minus__numeral__eq,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N2: num] :
          ( ( bit_ri4277139882892585799ns_not @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N2 ) ) )
          = ( neg_numeral_sub @ A @ N2 @ one2 ) ) ) ).

% not_minus_numeral_eq
thf(fact_5481_sub__num__simps_I4_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [K: num] :
          ( ( neg_numeral_sub @ A @ ( bit0 @ K ) @ one2 )
          = ( numeral_numeral @ A @ ( bitM @ K ) ) ) ) ).

% sub_num_simps(4)
thf(fact_5482_add__neg__numeral__special_I4_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [N2: num] :
          ( ( plus_plus @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( numeral_numeral @ A @ N2 ) )
          = ( neg_numeral_sub @ A @ N2 @ one2 ) ) ) ).

% add_neg_numeral_special(4)
thf(fact_5483_add__neg__numeral__special_I3_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [M: num] :
          ( ( plus_plus @ A @ ( numeral_numeral @ A @ M ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( neg_numeral_sub @ A @ M @ one2 ) ) ) ).

% add_neg_numeral_special(3)
thf(fact_5484_add__neg__numeral__special_I2_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [M: num] :
          ( ( plus_plus @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) @ ( one_one @ A ) )
          = ( neg_numeral_sub @ A @ one2 @ M ) ) ) ).

% add_neg_numeral_special(2)
thf(fact_5485_add__neg__numeral__special_I1_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [M: num] :
          ( ( plus_plus @ A @ ( one_one @ A ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) )
          = ( neg_numeral_sub @ A @ one2 @ M ) ) ) ).

% add_neg_numeral_special(1)
thf(fact_5486_minus__sub__one__diff__one,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [M: num] :
          ( ( minus_minus @ A @ ( uminus_uminus @ A @ ( neg_numeral_sub @ A @ M @ one2 ) ) @ ( one_one @ A ) )
          = ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) ) ) ).

% minus_sub_one_diff_one
thf(fact_5487_diff__numeral__special_I7_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [N2: num] :
          ( ( minus_minus @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N2 ) ) )
          = ( neg_numeral_sub @ A @ N2 @ one2 ) ) ) ).

% diff_numeral_special(7)
thf(fact_5488_diff__numeral__special_I8_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [M: num] :
          ( ( minus_minus @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( neg_numeral_sub @ A @ one2 @ M ) ) ) ).

% diff_numeral_special(8)
thf(fact_5489_sub__num__simps_I3_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [L: num] :
          ( ( neg_numeral_sub @ A @ one2 @ ( bit1 @ L ) )
          = ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( bit0 @ L ) ) ) ) ) ).

% sub_num_simps(3)
thf(fact_5490_sub__num__simps_I2_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [L: num] :
          ( ( neg_numeral_sub @ A @ one2 @ ( bit0 @ L ) )
          = ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( bitM @ L ) ) ) ) ) ).

% sub_num_simps(2)
thf(fact_5491_xor__minus__numerals_I2_J,axiom,
    ! [K: int,N2: num] :
      ( ( bit_se5824344971392196577ns_xor @ int @ K @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N2 ) ) )
      = ( bit_ri4277139882892585799ns_not @ int @ ( bit_se5824344971392196577ns_xor @ int @ K @ ( neg_numeral_sub @ int @ N2 @ one2 ) ) ) ) ).

% xor_minus_numerals(2)
thf(fact_5492_notin__set__remove1,axiom,
    ! [A: $tType,X2: A,Xs: list @ A,Y2: A] :
      ( ~ ( member @ A @ X2 @ ( set2 @ A @ Xs ) )
     => ~ ( member @ A @ X2 @ ( set2 @ A @ ( remove1 @ A @ Y2 @ Xs ) ) ) ) ).

% notin_set_remove1
thf(fact_5493_remove1__idem,axiom,
    ! [A: $tType,X2: A,Xs: list @ A] :
      ( ~ ( member @ A @ X2 @ ( set2 @ A @ Xs ) )
     => ( ( remove1 @ A @ X2 @ Xs )
        = Xs ) ) ).

% remove1_idem
thf(fact_5494_remove1__commute,axiom,
    ! [A: $tType,X2: A,Y2: A,Zs: list @ A] :
      ( ( remove1 @ A @ X2 @ ( remove1 @ A @ Y2 @ Zs ) )
      = ( remove1 @ A @ Y2 @ ( remove1 @ A @ X2 @ Zs ) ) ) ).

% remove1_commute
thf(fact_5495_distinct__remove1,axiom,
    ! [A: $tType,Xs: list @ A,X2: A] :
      ( ( distinct @ A @ Xs )
     => ( distinct @ A @ ( remove1 @ A @ X2 @ Xs ) ) ) ).

% distinct_remove1
thf(fact_5496_neg__numeral__class_Osub__def,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( neg_numeral_sub @ A )
        = ( ^ [K3: num,L2: num] : ( minus_minus @ A @ ( numeral_numeral @ A @ K3 ) @ ( numeral_numeral @ A @ L2 ) ) ) ) ) ).

% neg_numeral_class.sub_def
thf(fact_5497_set__remove1__subset,axiom,
    ! [A: $tType,X2: A,Xs: list @ A] : ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ ( remove1 @ A @ X2 @ Xs ) ) @ ( set2 @ A @ Xs ) ) ).

% set_remove1_subset
thf(fact_5498_sub__non__negative,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N2: num,M: num] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( neg_numeral_sub @ A @ N2 @ M ) )
          = ( ord_less_eq @ num @ M @ N2 ) ) ) ).

% sub_non_negative
thf(fact_5499_sub__non__positive,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N2: num,M: num] :
          ( ( ord_less_eq @ A @ ( neg_numeral_sub @ A @ N2 @ M ) @ ( zero_zero @ A ) )
          = ( ord_less_eq @ num @ N2 @ M ) ) ) ).

% sub_non_positive
thf(fact_5500_sub__negative,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N2: num,M: num] :
          ( ( ord_less @ A @ ( neg_numeral_sub @ A @ N2 @ M ) @ ( zero_zero @ A ) )
          = ( ord_less @ num @ N2 @ M ) ) ) ).

% sub_negative
thf(fact_5501_sub__positive,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N2: num,M: num] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( neg_numeral_sub @ A @ N2 @ M ) )
          = ( ord_less @ num @ M @ N2 ) ) ) ).

% sub_positive
thf(fact_5502_sub__inc__One__eq,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [N2: num] :
          ( ( neg_numeral_sub @ A @ ( inc @ N2 ) @ one2 )
          = ( numeral_numeral @ A @ N2 ) ) ) ).

% sub_inc_One_eq
thf(fact_5503_minus__numeral__eq__not__sub__one,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N2: num] :
          ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ N2 ) )
          = ( bit_ri4277139882892585799ns_not @ A @ ( neg_numeral_sub @ A @ N2 @ one2 ) ) ) ) ).

% minus_numeral_eq_not_sub_one
thf(fact_5504_length__remove1,axiom,
    ! [A: $tType,X2: A,Xs: list @ A] :
      ( ( ( member @ A @ X2 @ ( set2 @ A @ Xs ) )
       => ( ( size_size @ ( list @ A ) @ ( remove1 @ A @ X2 @ Xs ) )
          = ( minus_minus @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ ( one_one @ nat ) ) ) )
      & ( ~ ( member @ A @ X2 @ ( set2 @ A @ Xs ) )
       => ( ( size_size @ ( list @ A ) @ ( remove1 @ A @ X2 @ Xs ) )
          = ( size_size @ ( list @ A ) @ Xs ) ) ) ) ).

% length_remove1
thf(fact_5505_sub__BitM__One__eq,axiom,
    ! [N2: num] :
      ( ( neg_numeral_sub @ int @ ( bitM @ N2 ) @ one2 )
      = ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( neg_numeral_sub @ int @ N2 @ one2 ) ) ) ).

% sub_BitM_One_eq
thf(fact_5506_div__add__self1__no__field,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( euclid4440199948858584721cancel @ A )
        & ( field @ B ) )
     => ! [X2: B,B2: A,A2: A] :
          ( ( nO_MATCH @ B @ A @ X2 @ B2 )
         => ( ( B2
             != ( zero_zero @ A ) )
           => ( ( divide_divide @ A @ ( plus_plus @ A @ B2 @ A2 ) @ B2 )
              = ( plus_plus @ A @ ( divide_divide @ A @ A2 @ B2 ) @ ( one_one @ A ) ) ) ) ) ) ).

% div_add_self1_no_field
thf(fact_5507_div__add__self2__no__field,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( euclid4440199948858584721cancel @ A )
        & ( field @ B ) )
     => ! [X2: B,B2: A,A2: A] :
          ( ( nO_MATCH @ B @ A @ X2 @ B2 )
         => ( ( B2
             != ( zero_zero @ A ) )
           => ( ( divide_divide @ A @ ( plus_plus @ A @ A2 @ B2 ) @ B2 )
              = ( plus_plus @ A @ ( divide_divide @ A @ A2 @ B2 ) @ ( one_one @ A ) ) ) ) ) ) ).

% div_add_self2_no_field
thf(fact_5508_bounded__linear__axioms_Ointro,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F2: A > B] :
          ( ? [K8: real] :
            ! [X3: A] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ B @ ( F2 @ X3 ) ) @ ( times_times @ real @ ( real_V7770717601297561774m_norm @ A @ X3 ) @ K8 ) )
         => ( real_V4916620083959148203axioms @ A @ B @ F2 ) ) ) ).

% bounded_linear_axioms.intro
thf(fact_5509_scale__right__distrib__NO__MATCH,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [X2: A,Y2: A,A2: real] :
          ( ( nO_MATCH @ A @ real @ ( divide_divide @ A @ X2 @ Y2 ) @ A2 )
         => ( ( real_V8093663219630862766scaleR @ A @ A2 @ ( plus_plus @ A @ X2 @ Y2 ) )
            = ( plus_plus @ A @ ( real_V8093663219630862766scaleR @ A @ A2 @ X2 ) @ ( real_V8093663219630862766scaleR @ A @ A2 @ Y2 ) ) ) ) ) ).

% scale_right_distrib_NO_MATCH
thf(fact_5510_scale__right__diff__distrib__NO__MATCH,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [X2: A,Y2: A,A2: real] :
          ( ( nO_MATCH @ A @ real @ ( divide_divide @ A @ X2 @ Y2 ) @ A2 )
         => ( ( real_V8093663219630862766scaleR @ A @ A2 @ ( minus_minus @ A @ X2 @ Y2 ) )
            = ( minus_minus @ A @ ( real_V8093663219630862766scaleR @ A @ A2 @ X2 ) @ ( real_V8093663219630862766scaleR @ A @ A2 @ Y2 ) ) ) ) ) ).

% scale_right_diff_distrib_NO_MATCH
thf(fact_5511_distrib__right__NO__MATCH,axiom,
    ! [B: $tType,A: $tType] :
      ( ( semiring @ A )
     => ! [X2: B,Y2: B,C2: A,A2: A,B2: A] :
          ( ( nO_MATCH @ B @ A @ ( divide_divide @ B @ X2 @ Y2 ) @ C2 )
         => ( ( times_times @ A @ ( plus_plus @ A @ A2 @ B2 ) @ C2 )
            = ( plus_plus @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) ) ) ) ) ).

% distrib_right_NO_MATCH
thf(fact_5512_distrib__left__NO__MATCH,axiom,
    ! [B: $tType,A: $tType] :
      ( ( semiring @ A )
     => ! [X2: B,Y2: B,A2: A,B2: A,C2: A] :
          ( ( nO_MATCH @ B @ A @ ( divide_divide @ B @ X2 @ Y2 ) @ A2 )
         => ( ( times_times @ A @ A2 @ ( plus_plus @ A @ B2 @ C2 ) )
            = ( plus_plus @ A @ ( times_times @ A @ A2 @ B2 ) @ ( times_times @ A @ A2 @ C2 ) ) ) ) ) ).

% distrib_left_NO_MATCH
thf(fact_5513_right__diff__distrib__NO__MATCH,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ring @ A )
     => ! [X2: B,Y2: B,A2: A,B2: A,C2: A] :
          ( ( nO_MATCH @ B @ A @ ( divide_divide @ B @ X2 @ Y2 ) @ A2 )
         => ( ( times_times @ A @ A2 @ ( minus_minus @ A @ B2 @ C2 ) )
            = ( minus_minus @ A @ ( times_times @ A @ A2 @ B2 ) @ ( times_times @ A @ A2 @ C2 ) ) ) ) ) ).

% right_diff_distrib_NO_MATCH
thf(fact_5514_left__diff__distrib__NO__MATCH,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ring @ A )
     => ! [X2: B,Y2: B,C2: A,A2: A,B2: A] :
          ( ( nO_MATCH @ B @ A @ ( divide_divide @ B @ X2 @ Y2 ) @ C2 )
         => ( ( times_times @ A @ ( minus_minus @ A @ A2 @ B2 ) @ C2 )
            = ( minus_minus @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) ) ) ) ) ).

% left_diff_distrib_NO_MATCH
thf(fact_5515_power__minus_H,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [X2: A,N2: nat] :
          ( ( nO_MATCH @ A @ A @ ( one_one @ A ) @ X2 )
         => ( ( power_power @ A @ ( uminus_uminus @ A @ X2 ) @ N2 )
            = ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ N2 ) @ ( power_power @ A @ X2 @ N2 ) ) ) ) ) ).

% power_minus'
thf(fact_5516_scale__left__distrib__NO__MATCH,axiom,
    ! [C: $tType,A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [X2: A,Y2: A,C2: C,A2: real,B2: real] :
          ( ( nO_MATCH @ A @ C @ ( divide_divide @ A @ X2 @ Y2 ) @ C2 )
         => ( ( real_V8093663219630862766scaleR @ A @ ( plus_plus @ real @ A2 @ B2 ) @ X2 )
            = ( plus_plus @ A @ ( real_V8093663219630862766scaleR @ A @ A2 @ X2 ) @ ( real_V8093663219630862766scaleR @ A @ B2 @ X2 ) ) ) ) ) ).

% scale_left_distrib_NO_MATCH
thf(fact_5517_scale__left__diff__distrib__NO__MATCH,axiom,
    ! [C: $tType,A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [X2: A,Y2: A,C2: C,A2: real,B2: real] :
          ( ( nO_MATCH @ A @ C @ ( divide_divide @ A @ X2 @ Y2 ) @ C2 )
         => ( ( real_V8093663219630862766scaleR @ A @ ( minus_minus @ real @ A2 @ B2 ) @ X2 )
            = ( minus_minus @ A @ ( real_V8093663219630862766scaleR @ A @ A2 @ X2 ) @ ( real_V8093663219630862766scaleR @ A @ B2 @ X2 ) ) ) ) ) ).

% scale_left_diff_distrib_NO_MATCH
thf(fact_5518_bounded__linear__axioms__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ( ( real_V4916620083959148203axioms @ A @ B )
        = ( ^ [F5: A > B] :
            ? [K6: real] :
            ! [X5: A] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ B @ ( F5 @ X5 ) ) @ ( times_times @ real @ ( real_V7770717601297561774m_norm @ A @ X5 ) @ K6 ) ) ) ) ) ).

% bounded_linear_axioms_def
thf(fact_5519_horner__sum__eq__sum__funpow,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_semiring_0 @ A )
     => ( ( groups4207007520872428315er_sum @ B @ A )
        = ( ^ [F5: B > A,A4: A,Xs3: list @ B] :
              ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [N3: nat] : ( compow @ ( A > A ) @ N3 @ ( times_times @ A @ A4 ) @ ( F5 @ ( nth @ B @ Xs3 @ N3 ) ) )
              @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( size_size @ ( list @ B ) @ Xs3 ) ) ) ) ) ) ).

% horner_sum_eq_sum_funpow
thf(fact_5520_apsnd__apfst,axiom,
    ! [A: $tType,B: $tType,C: $tType,D: $tType,F2: C > B,G: D > A,X2: product_prod @ D @ C] :
      ( ( product_apsnd @ C @ B @ A @ F2 @ ( product_apfst @ D @ A @ C @ G @ X2 ) )
      = ( product_Pair @ A @ B @ ( G @ ( product_fst @ D @ C @ X2 ) ) @ ( F2 @ ( product_snd @ D @ C @ X2 ) ) ) ) ).

% apsnd_apfst
thf(fact_5521_apfst__apsnd,axiom,
    ! [A: $tType,B: $tType,D: $tType,C: $tType,F2: C > A,G: D > B,X2: product_prod @ C @ D] :
      ( ( product_apfst @ C @ A @ B @ F2 @ ( product_apsnd @ D @ B @ C @ G @ X2 ) )
      = ( product_Pair @ A @ B @ ( F2 @ ( product_fst @ C @ D @ X2 ) ) @ ( G @ ( product_snd @ C @ D @ X2 ) ) ) ) ).

% apfst_apsnd
thf(fact_5522_Suc__funpow,axiom,
    ! [N2: nat] :
      ( ( compow @ ( nat > nat ) @ N2 @ suc )
      = ( plus_plus @ nat @ N2 ) ) ).

% Suc_funpow
thf(fact_5523_funpow__0,axiom,
    ! [A: $tType,F2: A > A,X2: A] :
      ( ( compow @ ( A > A ) @ ( zero_zero @ nat ) @ F2 @ X2 )
      = X2 ) ).

% funpow_0
thf(fact_5524_apfst__conv,axiom,
    ! [C: $tType,A: $tType,B: $tType,F2: C > A,X2: C,Y2: B] :
      ( ( product_apfst @ C @ A @ B @ F2 @ ( product_Pair @ C @ B @ X2 @ Y2 ) )
      = ( product_Pair @ A @ B @ ( F2 @ X2 ) @ Y2 ) ) ).

% apfst_conv
thf(fact_5525_funpow__times__power,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [F2: A > nat,X2: A] :
          ( ( compow @ ( A > A ) @ ( F2 @ X2 ) @ ( times_times @ A @ X2 ) )
          = ( times_times @ A @ ( power_power @ A @ X2 @ ( F2 @ X2 ) ) ) ) ) ).

% funpow_times_power
thf(fact_5526_funpow__mult,axiom,
    ! [A: $tType,N2: nat,M: nat,F2: A > A] :
      ( ( compow @ ( A > A ) @ N2 @ ( compow @ ( A > A ) @ M @ F2 ) )
      = ( compow @ ( A > A ) @ ( times_times @ nat @ M @ N2 ) @ F2 ) ) ).

% funpow_mult
thf(fact_5527_funpow__mod__eq,axiom,
    ! [A: $tType,N2: nat,F2: A > A,X2: A,M: nat] :
      ( ( ( compow @ ( A > A ) @ N2 @ F2 @ X2 )
        = X2 )
     => ( ( compow @ ( A > A ) @ ( modulo_modulo @ nat @ M @ N2 ) @ F2 @ X2 )
        = ( compow @ ( A > A ) @ M @ F2 @ X2 ) ) ) ).

% funpow_mod_eq
thf(fact_5528_funpow__swap1,axiom,
    ! [A: $tType,F2: A > A,N2: nat,X2: A] :
      ( ( F2 @ ( compow @ ( A > A ) @ N2 @ F2 @ X2 ) )
      = ( compow @ ( A > A ) @ N2 @ F2 @ ( F2 @ X2 ) ) ) ).

% funpow_swap1
thf(fact_5529_bij__betw__funpow,axiom,
    ! [A: $tType,F2: A > A,S3: set @ A,N2: nat] :
      ( ( bij_betw @ A @ A @ F2 @ S3 @ S3 )
     => ( bij_betw @ A @ A @ ( compow @ ( A > A ) @ N2 @ F2 ) @ S3 @ S3 ) ) ).

% bij_betw_funpow
thf(fact_5530_funpow_Osimps_I2_J,axiom,
    ! [A: $tType,N2: nat,F2: A > A] :
      ( ( compow @ ( A > A ) @ ( suc @ N2 ) @ F2 )
      = ( comp @ A @ A @ A @ F2 @ ( compow @ ( A > A ) @ N2 @ F2 ) ) ) ).

% funpow.simps(2)
thf(fact_5531_funpow__Suc__right,axiom,
    ! [A: $tType,N2: nat,F2: A > A] :
      ( ( compow @ ( A > A ) @ ( suc @ N2 ) @ F2 )
      = ( comp @ A @ A @ A @ ( compow @ ( A > A ) @ N2 @ F2 ) @ F2 ) ) ).

% funpow_Suc_right
thf(fact_5532_comp__funpow,axiom,
    ! [B: $tType,A: $tType,N2: nat,F2: A > A] :
      ( ( compow @ ( ( B > A ) > B > A ) @ N2 @ ( comp @ A @ A @ B @ F2 ) )
      = ( comp @ A @ A @ B @ ( compow @ ( A > A ) @ N2 @ F2 ) ) ) ).

% comp_funpow
thf(fact_5533_funpow__add,axiom,
    ! [A: $tType,M: nat,N2: nat,F2: A > A] :
      ( ( compow @ ( A > A ) @ ( plus_plus @ nat @ M @ N2 ) @ F2 )
      = ( comp @ A @ A @ A @ ( compow @ ( A > A ) @ M @ F2 ) @ ( compow @ ( A > A ) @ N2 @ F2 ) ) ) ).

% funpow_add
thf(fact_5534_of__nat__def,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ( ( semiring_1_of_nat @ A )
        = ( ^ [N3: nat] : ( compow @ ( A > A ) @ N3 @ ( plus_plus @ A @ ( one_one @ A ) ) @ ( zero_zero @ A ) ) ) ) ) ).

% of_nat_def
thf(fact_5535_numeral__add__unfold__funpow,axiom,
    ! [A: $tType] :
      ( ( semiring_numeral @ A )
     => ! [K: num,A2: A] :
          ( ( plus_plus @ A @ ( numeral_numeral @ A @ K ) @ A2 )
          = ( compow @ ( A > A ) @ ( numeral_numeral @ nat @ K ) @ ( plus_plus @ A @ ( one_one @ A ) ) @ A2 ) ) ) ).

% numeral_add_unfold_funpow
thf(fact_5536_numeral__unfold__funpow,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ( ( numeral_numeral @ A )
        = ( ^ [K3: num] : ( compow @ ( A > A ) @ ( numeral_numeral @ nat @ K3 ) @ ( plus_plus @ A @ ( one_one @ A ) ) @ ( zero_zero @ A ) ) ) ) ) ).

% numeral_unfold_funpow
thf(fact_5537_relpowp__bot,axiom,
    ! [A: $tType,N2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( compow @ ( A > A > $o ) @ N2 @ ( bot_bot @ ( A > A > $o ) ) )
        = ( bot_bot @ ( A > A > $o ) ) ) ) ).

% relpowp_bot
thf(fact_5538_relpowp__fun__conv,axiom,
    ! [A: $tType] :
      ( ( compow @ ( A > A > $o ) )
      = ( ^ [N3: nat,P3: A > A > $o,X5: A,Y5: A] :
          ? [F5: nat > A] :
            ( ( ( F5 @ ( zero_zero @ nat ) )
              = X5 )
            & ( ( F5 @ N3 )
              = Y5 )
            & ! [I4: nat] :
                ( ( ord_less @ nat @ I4 @ N3 )
               => ( P3 @ ( F5 @ I4 ) @ ( F5 @ ( suc @ I4 ) ) ) ) ) ) ) ).

% relpowp_fun_conv
thf(fact_5539_relpowp__1,axiom,
    ! [A: $tType,P: A > A > $o] :
      ( ( compow @ ( A > A > $o ) @ ( one_one @ nat ) @ P )
      = P ) ).

% relpowp_1
thf(fact_5540_relpowp__Suc__E,axiom,
    ! [A: $tType,N2: nat,P: A > A > $o,X2: A,Z: A] :
      ( ( compow @ ( A > A > $o ) @ ( suc @ N2 ) @ P @ X2 @ Z )
     => ~ ! [Y4: A] :
            ( ( compow @ ( A > A > $o ) @ N2 @ P @ X2 @ Y4 )
           => ~ ( P @ Y4 @ Z ) ) ) ).

% relpowp_Suc_E
thf(fact_5541_relpowp__Suc__I,axiom,
    ! [A: $tType,N2: nat,P: A > A > $o,X2: A,Y2: A,Z: A] :
      ( ( compow @ ( A > A > $o ) @ N2 @ P @ X2 @ Y2 )
     => ( ( P @ Y2 @ Z )
       => ( compow @ ( A > A > $o ) @ ( suc @ N2 ) @ P @ X2 @ Z ) ) ) ).

% relpowp_Suc_I
thf(fact_5542_relpowp__Suc__D2,axiom,
    ! [A: $tType,N2: nat,P: A > A > $o,X2: A,Z: A] :
      ( ( compow @ ( A > A > $o ) @ ( suc @ N2 ) @ P @ X2 @ Z )
     => ? [Y4: A] :
          ( ( P @ X2 @ Y4 )
          & ( compow @ ( A > A > $o ) @ N2 @ P @ Y4 @ Z ) ) ) ).

% relpowp_Suc_D2
thf(fact_5543_relpowp__Suc__E2,axiom,
    ! [A: $tType,N2: nat,P: A > A > $o,X2: A,Z: A] :
      ( ( compow @ ( A > A > $o ) @ ( suc @ N2 ) @ P @ X2 @ Z )
     => ~ ! [Y4: A] :
            ( ( P @ X2 @ Y4 )
           => ~ ( compow @ ( A > A > $o ) @ N2 @ P @ Y4 @ Z ) ) ) ).

% relpowp_Suc_E2
thf(fact_5544_relpowp__Suc__I2,axiom,
    ! [A: $tType,P: A > A > $o,X2: A,Y2: A,N2: nat,Z: A] :
      ( ( P @ X2 @ Y2 )
     => ( ( compow @ ( A > A > $o ) @ N2 @ P @ Y2 @ Z )
       => ( compow @ ( A > A > $o ) @ ( suc @ N2 ) @ P @ X2 @ Z ) ) ) ).

% relpowp_Suc_I2
thf(fact_5545_relpowp__0__I,axiom,
    ! [A: $tType,P: A > A > $o,X2: A] : ( compow @ ( A > A > $o ) @ ( zero_zero @ nat ) @ P @ X2 @ X2 ) ).

% relpowp_0_I
thf(fact_5546_relpowp__0__E,axiom,
    ! [A: $tType,P: A > A > $o,X2: A,Y2: A] :
      ( ( compow @ ( A > A > $o ) @ ( zero_zero @ nat ) @ P @ X2 @ Y2 )
     => ( X2 = Y2 ) ) ).

% relpowp_0_E
thf(fact_5547_relpowp_Osimps_I1_J,axiom,
    ! [A: $tType,R: A > A > $o] :
      ( ( compow @ ( A > A > $o ) @ ( zero_zero @ nat ) @ R )
      = ( ^ [Y3: A,Z2: A] : ( Y3 = Z2 ) ) ) ).

% relpowp.simps(1)
thf(fact_5548_relpowp__E2,axiom,
    ! [A: $tType,N2: nat,P: A > A > $o,X2: A,Z: A] :
      ( ( compow @ ( A > A > $o ) @ N2 @ P @ X2 @ Z )
     => ( ( ( N2
            = ( zero_zero @ nat ) )
         => ( X2 != Z ) )
       => ~ ! [Y4: A,M3: nat] :
              ( ( N2
                = ( suc @ M3 ) )
             => ( ( P @ X2 @ Y4 )
               => ~ ( compow @ ( A > A > $o ) @ M3 @ P @ Y4 @ Z ) ) ) ) ) ).

% relpowp_E2
thf(fact_5549_relpowp__E,axiom,
    ! [A: $tType,N2: nat,P: A > A > $o,X2: A,Z: A] :
      ( ( compow @ ( A > A > $o ) @ N2 @ P @ X2 @ Z )
     => ( ( ( N2
            = ( zero_zero @ nat ) )
         => ( X2 != Z ) )
       => ~ ! [Y4: A,M3: nat] :
              ( ( N2
                = ( suc @ M3 ) )
             => ( ( compow @ ( A > A > $o ) @ M3 @ P @ X2 @ Y4 )
               => ~ ( P @ Y4 @ Z ) ) ) ) ) ).

% relpowp_E
thf(fact_5550_Nat_Ofunpow__code__def,axiom,
    ! [A: $tType] :
      ( ( funpow @ A )
      = ( compow @ ( A > A ) ) ) ).

% Nat.funpow_code_def
thf(fact_5551_apfst__convE,axiom,
    ! [C: $tType,A: $tType,B: $tType,Q3: product_prod @ A @ B,F2: C > A,P4: product_prod @ C @ B] :
      ( ( Q3
        = ( product_apfst @ C @ A @ B @ F2 @ P4 ) )
     => ~ ! [X3: C,Y4: B] :
            ( ( P4
              = ( product_Pair @ C @ B @ X3 @ Y4 ) )
           => ( Q3
             != ( product_Pair @ A @ B @ ( F2 @ X3 ) @ Y4 ) ) ) ) ).

% apfst_convE
thf(fact_5552_max__nat_Osemilattice__neutr__order__axioms,axiom,
    ( semila1105856199041335345_order @ nat @ ( ord_max @ nat ) @ ( zero_zero @ nat )
    @ ^ [X5: nat,Y5: nat] : ( ord_less_eq @ nat @ Y5 @ X5 )
    @ ^ [X5: nat,Y5: nat] : ( ord_less @ nat @ Y5 @ X5 ) ) ).

% max_nat.semilattice_neutr_order_axioms
thf(fact_5553_gcd__nat_Osemilattice__neutr__order__axioms,axiom,
    ( semila1105856199041335345_order @ nat @ ( gcd_gcd @ nat ) @ ( zero_zero @ nat ) @ ( dvd_dvd @ nat )
    @ ^ [M6: nat,N3: nat] :
        ( ( dvd_dvd @ nat @ M6 @ N3 )
        & ( M6 != N3 ) ) ) ).

% gcd_nat.semilattice_neutr_order_axioms
thf(fact_5554_card__UNION,axiom,
    ! [A: $tType,A3: set @ ( set @ A )] :
      ( ( finite_finite @ ( set @ A ) @ A3 )
     => ( ! [X3: set @ A] :
            ( ( member @ ( set @ A ) @ X3 @ A3 )
           => ( finite_finite @ A @ X3 ) )
       => ( ( finite_card @ A @ ( complete_Sup_Sup @ ( set @ A ) @ A3 ) )
          = ( nat2
            @ ( groups7311177749621191930dd_sum @ ( set @ ( set @ A ) ) @ int
              @ ^ [I8: set @ ( set @ A )] : ( times_times @ int @ ( power_power @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( plus_plus @ nat @ ( finite_card @ ( set @ A ) @ I8 ) @ ( one_one @ nat ) ) ) @ ( semiring_1_of_nat @ int @ ( finite_card @ A @ ( complete_Inf_Inf @ ( set @ A ) @ I8 ) ) ) )
              @ ( collect @ ( set @ ( set @ A ) )
                @ ^ [I8: set @ ( set @ A )] :
                    ( ( ord_less_eq @ ( set @ ( set @ A ) ) @ I8 @ A3 )
                    & ( I8
                     != ( bot_bot @ ( set @ ( set @ A ) ) ) ) ) ) ) ) ) ) ) ).

% card_UNION
thf(fact_5555_set__removeAll,axiom,
    ! [A: $tType,X2: A,Xs: list @ A] :
      ( ( set2 @ A @ ( removeAll @ A @ X2 @ Xs ) )
      = ( minus_minus @ ( set @ A ) @ ( set2 @ A @ Xs ) @ ( insert @ A @ X2 @ ( bot_bot @ ( set @ A ) ) ) ) ) ).

% set_removeAll
thf(fact_5556_bit_Oabstract__boolean__algebra__axioms,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( boolea2506097494486148201lgebra @ A @ ( bit_se5824344872417868541ns_and @ A ) @ ( bit_se1065995026697491101ons_or @ A ) @ ( bit_ri4277139882892585799ns_not @ A ) @ ( zero_zero @ A ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% bit.abstract_boolean_algebra_axioms
thf(fact_5557_removeAll__id,axiom,
    ! [A: $tType,X2: A,Xs: list @ A] :
      ( ~ ( member @ A @ X2 @ ( set2 @ A @ Xs ) )
     => ( ( removeAll @ A @ X2 @ Xs )
        = Xs ) ) ).

% removeAll_id
thf(fact_5558_Sup__atLeastAtMost,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [X2: A,Y2: A] :
          ( ( ord_less_eq @ A @ X2 @ Y2 )
         => ( ( complete_Sup_Sup @ A @ ( set_or1337092689740270186AtMost @ A @ X2 @ Y2 ) )
            = Y2 ) ) ) ).

% Sup_atLeastAtMost
thf(fact_5559_Inf__atLeastAtMost,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [X2: A,Y2: A] :
          ( ( ord_less_eq @ A @ X2 @ Y2 )
         => ( ( complete_Inf_Inf @ A @ ( set_or1337092689740270186AtMost @ A @ X2 @ Y2 ) )
            = X2 ) ) ) ).

% Inf_atLeastAtMost
thf(fact_5560_Sup__atLeastLessThan,axiom,
    ! [A: $tType] :
      ( ( ( comple6319245703460814977attice @ A )
        & ( dense_linorder @ A ) )
     => ! [X2: A,Y2: A] :
          ( ( ord_less @ A @ X2 @ Y2 )
         => ( ( complete_Sup_Sup @ A @ ( set_or7035219750837199246ssThan @ A @ X2 @ Y2 ) )
            = Y2 ) ) ) ).

% Sup_atLeastLessThan
thf(fact_5561_Inf__atLeastLessThan,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [X2: A,Y2: A] :
          ( ( ord_less @ A @ X2 @ Y2 )
         => ( ( complete_Inf_Inf @ A @ ( set_or7035219750837199246ssThan @ A @ X2 @ Y2 ) )
            = X2 ) ) ) ).

% Inf_atLeastLessThan
thf(fact_5562_distinct__removeAll,axiom,
    ! [A: $tType,Xs: list @ A,X2: A] :
      ( ( distinct @ A @ Xs )
     => ( distinct @ A @ ( removeAll @ A @ X2 @ Xs ) ) ) ).

% distinct_removeAll
thf(fact_5563_card__Union__le__sum__card,axiom,
    ! [A: $tType,U4: set @ ( set @ A )] : ( ord_less_eq @ nat @ ( finite_card @ A @ ( complete_Sup_Sup @ ( set @ A ) @ U4 ) ) @ ( groups7311177749621191930dd_sum @ ( set @ A ) @ nat @ ( finite_card @ A ) @ U4 ) ) ).

% card_Union_le_sum_card
thf(fact_5564_length__removeAll__less__eq,axiom,
    ! [A: $tType,X2: A,Xs: list @ A] : ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ ( removeAll @ A @ X2 @ Xs ) ) @ ( size_size @ ( list @ A ) @ Xs ) ) ).

% length_removeAll_less_eq
thf(fact_5565_cInf__abs__ge,axiom,
    ! [A: $tType] :
      ( ( ( condit6923001295902523014norder @ A )
        & ( linordered_idom @ A ) )
     => ! [S3: set @ A,A2: A] :
          ( ( S3
           != ( bot_bot @ ( set @ A ) ) )
         => ( ! [X3: A] :
                ( ( member @ A @ X3 @ S3 )
               => ( ord_less_eq @ A @ ( abs_abs @ A @ X3 ) @ A2 ) )
           => ( ord_less_eq @ A @ ( abs_abs @ A @ ( complete_Inf_Inf @ A @ S3 ) ) @ A2 ) ) ) ) ).

% cInf_abs_ge
thf(fact_5566_sum_OUnion__comp,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [B3: set @ ( set @ B ),G: B > A] :
          ( ! [X3: set @ B] :
              ( ( member @ ( set @ B ) @ X3 @ B3 )
             => ( finite_finite @ B @ X3 ) )
         => ( ! [A14: set @ B] :
                ( ( member @ ( set @ B ) @ A14 @ B3 )
               => ! [A25: set @ B] :
                    ( ( member @ ( set @ B ) @ A25 @ B3 )
                   => ( ( A14 != A25 )
                     => ! [X3: B] :
                          ( ( member @ B @ X3 @ A14 )
                         => ( ( member @ B @ X3 @ A25 )
                           => ( ( G @ X3 )
                              = ( zero_zero @ A ) ) ) ) ) ) )
           => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ ( complete_Sup_Sup @ ( set @ B ) @ B3 ) )
              = ( comp @ ( ( set @ B ) > A ) @ ( ( set @ ( set @ B ) ) > A ) @ ( B > A ) @ ( groups7311177749621191930dd_sum @ ( set @ B ) @ A ) @ ( groups7311177749621191930dd_sum @ B @ A ) @ G @ B3 ) ) ) ) ) ).

% sum.Union_comp
thf(fact_5567_prod_OUnion__comp,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [B3: set @ ( set @ B ),G: B > A] :
          ( ! [X3: set @ B] :
              ( ( member @ ( set @ B ) @ X3 @ B3 )
             => ( finite_finite @ B @ X3 ) )
         => ( ! [A14: set @ B] :
                ( ( member @ ( set @ B ) @ A14 @ B3 )
               => ! [A25: set @ B] :
                    ( ( member @ ( set @ B ) @ A25 @ B3 )
                   => ( ( A14 != A25 )
                     => ! [X3: B] :
                          ( ( member @ B @ X3 @ A14 )
                         => ( ( member @ B @ X3 @ A25 )
                           => ( ( G @ X3 )
                              = ( one_one @ A ) ) ) ) ) ) )
           => ( ( groups7121269368397514597t_prod @ B @ A @ G @ ( complete_Sup_Sup @ ( set @ B ) @ B3 ) )
              = ( comp @ ( ( set @ B ) > A ) @ ( ( set @ ( set @ B ) ) > A ) @ ( B > A ) @ ( groups7121269368397514597t_prod @ ( set @ B ) @ A ) @ ( groups7121269368397514597t_prod @ B @ A ) @ G @ B3 ) ) ) ) ) ).

% prod.Union_comp
thf(fact_5568_card__Union__le__sum__card__weak,axiom,
    ! [A: $tType,U4: set @ ( set @ A )] :
      ( ! [X3: set @ A] :
          ( ( member @ ( set @ A ) @ X3 @ U4 )
         => ( finite_finite @ A @ X3 ) )
     => ( ord_less_eq @ nat @ ( finite_card @ A @ ( complete_Sup_Sup @ ( set @ A ) @ U4 ) ) @ ( groups7311177749621191930dd_sum @ ( set @ A ) @ nat @ ( finite_card @ A ) @ U4 ) ) ) ).

% card_Union_le_sum_card_weak
thf(fact_5569_distinct__remove1__removeAll,axiom,
    ! [A: $tType,Xs: list @ A,X2: A] :
      ( ( distinct @ A @ Xs )
     => ( ( remove1 @ A @ X2 @ Xs )
        = ( removeAll @ A @ X2 @ Xs ) ) ) ).

% distinct_remove1_removeAll
thf(fact_5570_cInf__asclose,axiom,
    ! [A: $tType] :
      ( ( ( condit6923001295902523014norder @ A )
        & ( linordered_idom @ A ) )
     => ! [S3: set @ A,L: A,E2: A] :
          ( ( S3
           != ( bot_bot @ ( set @ A ) ) )
         => ( ! [X3: A] :
                ( ( member @ A @ X3 @ S3 )
               => ( ord_less_eq @ A @ ( abs_abs @ A @ ( minus_minus @ A @ X3 @ L ) ) @ E2 ) )
           => ( ord_less_eq @ A @ ( abs_abs @ A @ ( minus_minus @ A @ ( complete_Inf_Inf @ A @ S3 ) @ L ) ) @ E2 ) ) ) ) ).

% cInf_asclose
thf(fact_5571_cSup__asclose,axiom,
    ! [A: $tType] :
      ( ( ( condit6923001295902523014norder @ A )
        & ( linordered_idom @ A ) )
     => ! [S3: set @ A,L: A,E2: A] :
          ( ( S3
           != ( bot_bot @ ( set @ A ) ) )
         => ( ! [X3: A] :
                ( ( member @ A @ X3 @ S3 )
               => ( ord_less_eq @ A @ ( abs_abs @ A @ ( minus_minus @ A @ X3 @ L ) ) @ E2 ) )
           => ( ord_less_eq @ A @ ( abs_abs @ A @ ( minus_minus @ A @ ( complete_Sup_Sup @ A @ S3 ) @ L ) ) @ E2 ) ) ) ) ).

% cSup_asclose
thf(fact_5572_length__removeAll__less,axiom,
    ! [A: $tType,X2: A,Xs: list @ A] :
      ( ( member @ A @ X2 @ ( set2 @ A @ Xs ) )
     => ( ord_less @ nat @ ( size_size @ ( list @ A ) @ ( removeAll @ A @ X2 @ Xs ) ) @ ( size_size @ ( list @ A ) @ Xs ) ) ) ).

% length_removeAll_less
thf(fact_5573_cInf__atLeastLessThan,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [Y2: A,X2: A] :
          ( ( ord_less @ A @ Y2 @ X2 )
         => ( ( complete_Inf_Inf @ A @ ( set_or7035219750837199246ssThan @ A @ Y2 @ X2 ) )
            = Y2 ) ) ) ).

% cInf_atLeastLessThan
thf(fact_5574_cSup__atLeastLessThan,axiom,
    ! [A: $tType] :
      ( ( ( condit6923001295902523014norder @ A )
        & ( dense_linorder @ A ) )
     => ! [Y2: A,X2: A] :
          ( ( ord_less @ A @ Y2 @ X2 )
         => ( ( complete_Sup_Sup @ A @ ( set_or7035219750837199246ssThan @ A @ Y2 @ X2 ) )
            = X2 ) ) ) ).

% cSup_atLeastLessThan
thf(fact_5575_cInf__atLeastAtMost,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [Y2: A,X2: A] :
          ( ( ord_less_eq @ A @ Y2 @ X2 )
         => ( ( complete_Inf_Inf @ A @ ( set_or1337092689740270186AtMost @ A @ Y2 @ X2 ) )
            = Y2 ) ) ) ).

% cInf_atLeastAtMost
thf(fact_5576_Sup__nat__empty,axiom,
    ( ( complete_Sup_Sup @ nat @ ( bot_bot @ ( set @ nat ) ) )
    = ( zero_zero @ nat ) ) ).

% Sup_nat_empty
thf(fact_5577_cSup__atLeastAtMost,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [Y2: A,X2: A] :
          ( ( ord_less_eq @ A @ Y2 @ X2 )
         => ( ( complete_Sup_Sup @ A @ ( set_or1337092689740270186AtMost @ A @ Y2 @ X2 ) )
            = X2 ) ) ) ).

% cSup_atLeastAtMost
thf(fact_5578_ex__gt__or__lt,axiom,
    ! [A: $tType] :
      ( ( condit5016429287641298734tinuum @ A )
     => ! [A2: A] :
        ? [B5: A] :
          ( ( ord_less @ A @ A2 @ B5 )
          | ( ord_less @ A @ B5 @ A2 ) ) ) ).

% ex_gt_or_lt
thf(fact_5579_complete__interval,axiom,
    ! [A: $tType] :
      ( ( condit6923001295902523014norder @ A )
     => ! [A2: A,B2: A,P: A > $o] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( P @ A2 )
           => ( ~ ( P @ B2 )
             => ? [C3: A] :
                  ( ( ord_less_eq @ A @ A2 @ C3 )
                  & ( ord_less_eq @ A @ C3 @ B2 )
                  & ! [X: A] :
                      ( ( ( ord_less_eq @ A @ A2 @ X )
                        & ( ord_less @ A @ X @ C3 ) )
                     => ( P @ X ) )
                  & ! [D6: A] :
                      ( ! [X3: A] :
                          ( ( ( ord_less_eq @ A @ A2 @ X3 )
                            & ( ord_less @ A @ X3 @ D6 ) )
                         => ( P @ X3 ) )
                     => ( ord_less_eq @ A @ D6 @ C3 ) ) ) ) ) ) ) ).

% complete_interval
thf(fact_5580_cSup__eq,axiom,
    ! [A: $tType] :
      ( ( ( condit1219197933456340205attice @ A )
        & ( no_bot @ A ) )
     => ! [X8: set @ A,A2: A] :
          ( ! [X3: A] :
              ( ( member @ A @ X3 @ X8 )
             => ( ord_less_eq @ A @ X3 @ A2 ) )
         => ( ! [Y4: A] :
                ( ! [X: A] :
                    ( ( member @ A @ X @ X8 )
                   => ( ord_less_eq @ A @ X @ Y4 ) )
               => ( ord_less_eq @ A @ A2 @ Y4 ) )
           => ( ( complete_Sup_Sup @ A @ X8 )
              = A2 ) ) ) ) ).

% cSup_eq
thf(fact_5581_cSup__eq__maximum,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [Z: A,X8: set @ A] :
          ( ( member @ A @ Z @ X8 )
         => ( ! [X3: A] :
                ( ( member @ A @ X3 @ X8 )
               => ( ord_less_eq @ A @ X3 @ Z ) )
           => ( ( complete_Sup_Sup @ A @ X8 )
              = Z ) ) ) ) ).

% cSup_eq_maximum
thf(fact_5582_cInf__eq,axiom,
    ! [A: $tType] :
      ( ( ( condit1219197933456340205attice @ A )
        & ( no_top @ A ) )
     => ! [X8: set @ A,A2: A] :
          ( ! [X3: A] :
              ( ( member @ A @ X3 @ X8 )
             => ( ord_less_eq @ A @ A2 @ X3 ) )
         => ( ! [Y4: A] :
                ( ! [X: A] :
                    ( ( member @ A @ X @ X8 )
                   => ( ord_less_eq @ A @ Y4 @ X ) )
               => ( ord_less_eq @ A @ Y4 @ A2 ) )
           => ( ( complete_Inf_Inf @ A @ X8 )
              = A2 ) ) ) ) ).

% cInf_eq
thf(fact_5583_cInf__eq__minimum,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [Z: A,X8: set @ A] :
          ( ( member @ A @ Z @ X8 )
         => ( ! [X3: A] :
                ( ( member @ A @ X3 @ X8 )
               => ( ord_less_eq @ A @ Z @ X3 ) )
           => ( ( complete_Inf_Inf @ A @ X8 )
              = Z ) ) ) ) ).

% cInf_eq_minimum
thf(fact_5584_cSup__least,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [X8: set @ A,Z: A] :
          ( ( X8
           != ( bot_bot @ ( set @ A ) ) )
         => ( ! [X3: A] :
                ( ( member @ A @ X3 @ X8 )
               => ( ord_less_eq @ A @ X3 @ Z ) )
           => ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ X8 ) @ Z ) ) ) ) ).

% cSup_least
thf(fact_5585_cSup__eq__non__empty,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [X8: set @ A,A2: A] :
          ( ( X8
           != ( bot_bot @ ( set @ A ) ) )
         => ( ! [X3: A] :
                ( ( member @ A @ X3 @ X8 )
               => ( ord_less_eq @ A @ X3 @ A2 ) )
           => ( ! [Y4: A] :
                  ( ! [X: A] :
                      ( ( member @ A @ X @ X8 )
                     => ( ord_less_eq @ A @ X @ Y4 ) )
                 => ( ord_less_eq @ A @ A2 @ Y4 ) )
             => ( ( complete_Sup_Sup @ A @ X8 )
                = A2 ) ) ) ) ) ).

% cSup_eq_non_empty
thf(fact_5586_le__cSup__finite,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [X8: set @ A,X2: A] :
          ( ( finite_finite @ A @ X8 )
         => ( ( member @ A @ X2 @ X8 )
           => ( ord_less_eq @ A @ X2 @ ( complete_Sup_Sup @ A @ X8 ) ) ) ) ) ).

% le_cSup_finite
thf(fact_5587_less__cSupE,axiom,
    ! [A: $tType] :
      ( ( condit6923001295902523014norder @ A )
     => ! [Y2: A,X8: set @ A] :
          ( ( ord_less @ A @ Y2 @ ( complete_Sup_Sup @ A @ X8 ) )
         => ( ( X8
             != ( bot_bot @ ( set @ A ) ) )
           => ~ ! [X3: A] :
                  ( ( member @ A @ X3 @ X8 )
                 => ~ ( ord_less @ A @ Y2 @ X3 ) ) ) ) ) ).

% less_cSupE
thf(fact_5588_less__cSupD,axiom,
    ! [A: $tType] :
      ( ( condit6923001295902523014norder @ A )
     => ! [X8: set @ A,Z: A] :
          ( ( X8
           != ( bot_bot @ ( set @ A ) ) )
         => ( ( ord_less @ A @ Z @ ( complete_Sup_Sup @ A @ X8 ) )
           => ? [X3: A] :
                ( ( member @ A @ X3 @ X8 )
                & ( ord_less @ A @ Z @ X3 ) ) ) ) ) ).

% less_cSupD
thf(fact_5589_finite__imp__Sup__less,axiom,
    ! [A: $tType] :
      ( ( condit6923001295902523014norder @ A )
     => ! [X8: set @ A,X2: A,A2: A] :
          ( ( finite_finite @ A @ X8 )
         => ( ( member @ A @ X2 @ X8 )
           => ( ! [X3: A] :
                  ( ( member @ A @ X3 @ X8 )
                 => ( ord_less @ A @ X3 @ A2 ) )
             => ( ord_less @ A @ ( complete_Sup_Sup @ A @ X8 ) @ A2 ) ) ) ) ) ).

% finite_imp_Sup_less
thf(fact_5590_cInf__greatest,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [X8: set @ A,Z: A] :
          ( ( X8
           != ( bot_bot @ ( set @ A ) ) )
         => ( ! [X3: A] :
                ( ( member @ A @ X3 @ X8 )
               => ( ord_less_eq @ A @ Z @ X3 ) )
           => ( ord_less_eq @ A @ Z @ ( complete_Inf_Inf @ A @ X8 ) ) ) ) ) ).

% cInf_greatest
thf(fact_5591_cInf__eq__non__empty,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [X8: set @ A,A2: A] :
          ( ( X8
           != ( bot_bot @ ( set @ A ) ) )
         => ( ! [X3: A] :
                ( ( member @ A @ X3 @ X8 )
               => ( ord_less_eq @ A @ A2 @ X3 ) )
           => ( ! [Y4: A] :
                  ( ! [X: A] :
                      ( ( member @ A @ X @ X8 )
                     => ( ord_less_eq @ A @ Y4 @ X ) )
                 => ( ord_less_eq @ A @ Y4 @ A2 ) )
             => ( ( complete_Inf_Inf @ A @ X8 )
                = A2 ) ) ) ) ) ).

% cInf_eq_non_empty
thf(fact_5592_cInf__le__finite,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [X8: set @ A,X2: A] :
          ( ( finite_finite @ A @ X8 )
         => ( ( member @ A @ X2 @ X8 )
           => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ X8 ) @ X2 ) ) ) ) ).

% cInf_le_finite
thf(fact_5593_cInf__lessD,axiom,
    ! [A: $tType] :
      ( ( condit6923001295902523014norder @ A )
     => ! [X8: set @ A,Z: A] :
          ( ( X8
           != ( bot_bot @ ( set @ A ) ) )
         => ( ( ord_less @ A @ ( complete_Inf_Inf @ A @ X8 ) @ Z )
           => ? [X3: A] :
                ( ( member @ A @ X3 @ X8 )
                & ( ord_less @ A @ X3 @ Z ) ) ) ) ) ).

% cInf_lessD
thf(fact_5594_finite__imp__less__Inf,axiom,
    ! [A: $tType] :
      ( ( condit6923001295902523014norder @ A )
     => ! [X8: set @ A,X2: A,A2: A] :
          ( ( finite_finite @ A @ X8 )
         => ( ( member @ A @ X2 @ X8 )
           => ( ! [X3: A] :
                  ( ( member @ A @ X3 @ X8 )
                 => ( ord_less @ A @ A2 @ X3 ) )
             => ( ord_less @ A @ A2 @ ( complete_Inf_Inf @ A @ X8 ) ) ) ) ) ) ).

% finite_imp_less_Inf
thf(fact_5595_finite__Sup__less__iff,axiom,
    ! [A: $tType] :
      ( ( condit6923001295902523014norder @ A )
     => ! [X8: set @ A,A2: A] :
          ( ( finite_finite @ A @ X8 )
         => ( ( X8
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ord_less @ A @ ( complete_Sup_Sup @ A @ X8 ) @ A2 )
              = ( ! [X5: A] :
                    ( ( member @ A @ X5 @ X8 )
                   => ( ord_less @ A @ X5 @ A2 ) ) ) ) ) ) ) ).

% finite_Sup_less_iff
thf(fact_5596_finite__less__Inf__iff,axiom,
    ! [A: $tType] :
      ( ( condit6923001295902523014norder @ A )
     => ! [X8: set @ A,A2: A] :
          ( ( finite_finite @ A @ X8 )
         => ( ( X8
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ord_less @ A @ A2 @ ( complete_Inf_Inf @ A @ X8 ) )
              = ( ! [X5: A] :
                    ( ( member @ A @ X5 @ X8 )
                   => ( ord_less @ A @ A2 @ X5 ) ) ) ) ) ) ) ).

% finite_less_Inf_iff
thf(fact_5597_cSup__abs__le,axiom,
    ! [A: $tType] :
      ( ( ( condit6923001295902523014norder @ A )
        & ( linordered_idom @ A ) )
     => ! [S3: set @ A,A2: A] :
          ( ( S3
           != ( bot_bot @ ( set @ A ) ) )
         => ( ! [X3: A] :
                ( ( member @ A @ X3 @ S3 )
               => ( ord_less_eq @ A @ ( abs_abs @ A @ X3 ) @ A2 ) )
           => ( ord_less_eq @ A @ ( abs_abs @ A @ ( complete_Sup_Sup @ A @ S3 ) ) @ A2 ) ) ) ) ).

% cSup_abs_le
thf(fact_5598_Inf__eq__bot__iff,axiom,
    ! [A: $tType] :
      ( ( comple5582772986160207858norder @ A )
     => ! [A3: set @ A] :
          ( ( ( complete_Inf_Inf @ A @ A3 )
            = ( bot_bot @ A ) )
          = ( ! [X5: A] :
                ( ( ord_less @ A @ ( bot_bot @ A ) @ X5 )
               => ? [Y5: A] :
                    ( ( member @ A @ Y5 @ A3 )
                    & ( ord_less @ A @ Y5 @ X5 ) ) ) ) ) ) ).

% Inf_eq_bot_iff
thf(fact_5599_finite__subset__Union,axiom,
    ! [A: $tType,A3: set @ A,B12: set @ ( set @ A )] :
      ( ( finite_finite @ A @ A3 )
     => ( ( ord_less_eq @ ( set @ A ) @ A3 @ ( complete_Sup_Sup @ ( set @ A ) @ B12 ) )
       => ~ ! [F7: set @ ( set @ A )] :
              ( ( finite_finite @ ( set @ A ) @ F7 )
             => ( ( ord_less_eq @ ( set @ ( set @ A ) ) @ F7 @ B12 )
               => ~ ( ord_less_eq @ ( set @ A ) @ A3 @ ( complete_Sup_Sup @ ( set @ A ) @ F7 ) ) ) ) ) ) ).

% finite_subset_Union
thf(fact_5600_Inf__le__Sup,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A3: set @ A] :
          ( ( A3
           != ( bot_bot @ ( set @ A ) ) )
         => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ A3 ) @ ( complete_Sup_Sup @ A @ A3 ) ) ) ) ).

% Inf_le_Sup
thf(fact_5601_Sup__eqI,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A3: set @ A,X2: A] :
          ( ! [Y4: A] :
              ( ( member @ A @ Y4 @ A3 )
             => ( ord_less_eq @ A @ Y4 @ X2 ) )
         => ( ! [Y4: A] :
                ( ! [Z4: A] :
                    ( ( member @ A @ Z4 @ A3 )
                   => ( ord_less_eq @ A @ Z4 @ Y4 ) )
               => ( ord_less_eq @ A @ X2 @ Y4 ) )
           => ( ( complete_Sup_Sup @ A @ A3 )
              = X2 ) ) ) ) ).

% Sup_eqI
thf(fact_5602_Sup__mono,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A3: set @ A,B3: set @ A] :
          ( ! [A5: A] :
              ( ( member @ A @ A5 @ A3 )
             => ? [X: A] :
                  ( ( member @ A @ X @ B3 )
                  & ( ord_less_eq @ A @ A5 @ X ) ) )
         => ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ A3 ) @ ( complete_Sup_Sup @ A @ B3 ) ) ) ) ).

% Sup_mono
thf(fact_5603_Sup__least,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A3: set @ A,Z: A] :
          ( ! [X3: A] :
              ( ( member @ A @ X3 @ A3 )
             => ( ord_less_eq @ A @ X3 @ Z ) )
         => ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ A3 ) @ Z ) ) ) ).

% Sup_least
thf(fact_5604_Sup__upper,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [X2: A,A3: set @ A] :
          ( ( member @ A @ X2 @ A3 )
         => ( ord_less_eq @ A @ X2 @ ( complete_Sup_Sup @ A @ A3 ) ) ) ) ).

% Sup_upper
thf(fact_5605_Sup__le__iff,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A3: set @ A,B2: A] :
          ( ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ A3 ) @ B2 )
          = ( ! [X5: A] :
                ( ( member @ A @ X5 @ A3 )
               => ( ord_less_eq @ A @ X5 @ B2 ) ) ) ) ) ).

% Sup_le_iff
thf(fact_5606_Sup__upper2,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [U: A,A3: set @ A,V: A] :
          ( ( member @ A @ U @ A3 )
         => ( ( ord_less_eq @ A @ V @ U )
           => ( ord_less_eq @ A @ V @ ( complete_Sup_Sup @ A @ A3 ) ) ) ) ) ).

% Sup_upper2
thf(fact_5607_less__Sup__iff,axiom,
    ! [A: $tType] :
      ( ( comple5582772986160207858norder @ A )
     => ! [A2: A,S3: set @ A] :
          ( ( ord_less @ A @ A2 @ ( complete_Sup_Sup @ A @ S3 ) )
          = ( ? [X5: A] :
                ( ( member @ A @ X5 @ S3 )
                & ( ord_less @ A @ A2 @ X5 ) ) ) ) ) ).

% less_Sup_iff
thf(fact_5608_Inf__eqI,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A3: set @ A,X2: A] :
          ( ! [I2: A] :
              ( ( member @ A @ I2 @ A3 )
             => ( ord_less_eq @ A @ X2 @ I2 ) )
         => ( ! [Y4: A] :
                ( ! [I: A] :
                    ( ( member @ A @ I @ A3 )
                   => ( ord_less_eq @ A @ Y4 @ I ) )
               => ( ord_less_eq @ A @ Y4 @ X2 ) )
           => ( ( complete_Inf_Inf @ A @ A3 )
              = X2 ) ) ) ) ).

% Inf_eqI
thf(fact_5609_Inf__mono,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [B3: set @ A,A3: set @ A] :
          ( ! [B5: A] :
              ( ( member @ A @ B5 @ B3 )
             => ? [X: A] :
                  ( ( member @ A @ X @ A3 )
                  & ( ord_less_eq @ A @ X @ B5 ) ) )
         => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ A3 ) @ ( complete_Inf_Inf @ A @ B3 ) ) ) ) ).

% Inf_mono
thf(fact_5610_Inf__lower,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [X2: A,A3: set @ A] :
          ( ( member @ A @ X2 @ A3 )
         => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ A3 ) @ X2 ) ) ) ).

% Inf_lower
thf(fact_5611_Inf__lower2,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [U: A,A3: set @ A,V: A] :
          ( ( member @ A @ U @ A3 )
         => ( ( ord_less_eq @ A @ U @ V )
           => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ A3 ) @ V ) ) ) ) ).

% Inf_lower2
thf(fact_5612_le__Inf__iff,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [B2: A,A3: set @ A] :
          ( ( ord_less_eq @ A @ B2 @ ( complete_Inf_Inf @ A @ A3 ) )
          = ( ! [X5: A] :
                ( ( member @ A @ X5 @ A3 )
               => ( ord_less_eq @ A @ B2 @ X5 ) ) ) ) ) ).

% le_Inf_iff
thf(fact_5613_Inf__greatest,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A3: set @ A,Z: A] :
          ( ! [X3: A] :
              ( ( member @ A @ X3 @ A3 )
             => ( ord_less_eq @ A @ Z @ X3 ) )
         => ( ord_less_eq @ A @ Z @ ( complete_Inf_Inf @ A @ A3 ) ) ) ) ).

% Inf_greatest
thf(fact_5614_dependent__nat__choice,axiom,
    ! [A: $tType,P: nat > A > $o,Q: nat > A > A > $o] :
      ( ? [X_1: A] : ( P @ ( zero_zero @ nat ) @ X_1 )
     => ( ! [X3: A,N: nat] :
            ( ( P @ N @ X3 )
           => ? [Y: A] :
                ( ( P @ ( suc @ N ) @ Y )
                & ( Q @ N @ X3 @ Y ) ) )
       => ? [F4: nat > A] :
          ! [N9: nat] :
            ( ( P @ N9 @ ( F4 @ N9 ) )
            & ( Q @ N9 @ ( F4 @ N9 ) @ ( F4 @ ( suc @ N9 ) ) ) ) ) ) ).

% dependent_nat_choice
thf(fact_5615_Inf__less__iff,axiom,
    ! [A: $tType] :
      ( ( comple5582772986160207858norder @ A )
     => ! [S3: set @ A,A2: A] :
          ( ( ord_less @ A @ ( complete_Inf_Inf @ A @ S3 ) @ A2 )
          = ( ? [X5: A] :
                ( ( member @ A @ X5 @ S3 )
                & ( ord_less @ A @ X5 @ A2 ) ) ) ) ) ).

% Inf_less_iff
thf(fact_5616_Union__subsetI,axiom,
    ! [A: $tType,A3: set @ ( set @ A ),B3: set @ ( set @ A )] :
      ( ! [X3: set @ A] :
          ( ( member @ ( set @ A ) @ X3 @ A3 )
         => ? [Y: set @ A] :
              ( ( member @ ( set @ A ) @ Y @ B3 )
              & ( ord_less_eq @ ( set @ A ) @ X3 @ Y ) ) )
     => ( ord_less_eq @ ( set @ A ) @ ( complete_Sup_Sup @ ( set @ A ) @ A3 ) @ ( complete_Sup_Sup @ ( set @ A ) @ B3 ) ) ) ).

% Union_subsetI
thf(fact_5617_Union__upper,axiom,
    ! [A: $tType,B3: set @ A,A3: set @ ( set @ A )] :
      ( ( member @ ( set @ A ) @ B3 @ A3 )
     => ( ord_less_eq @ ( set @ A ) @ B3 @ ( complete_Sup_Sup @ ( set @ A ) @ A3 ) ) ) ).

% Union_upper
thf(fact_5618_Union__least,axiom,
    ! [A: $tType,A3: set @ ( set @ A ),C6: set @ A] :
      ( ! [X10: set @ A] :
          ( ( member @ ( set @ A ) @ X10 @ A3 )
         => ( ord_less_eq @ ( set @ A ) @ X10 @ C6 ) )
     => ( ord_less_eq @ ( set @ A ) @ ( complete_Sup_Sup @ ( set @ A ) @ A3 ) @ C6 ) ) ).

% Union_least
thf(fact_5619_Inter__greatest,axiom,
    ! [A: $tType,A3: set @ ( set @ A ),C6: set @ A] :
      ( ! [X10: set @ A] :
          ( ( member @ ( set @ A ) @ X10 @ A3 )
         => ( ord_less_eq @ ( set @ A ) @ C6 @ X10 ) )
     => ( ord_less_eq @ ( set @ A ) @ C6 @ ( complete_Inf_Inf @ ( set @ A ) @ A3 ) ) ) ).

% Inter_greatest
thf(fact_5620_Inter__lower,axiom,
    ! [A: $tType,B3: set @ A,A3: set @ ( set @ A )] :
      ( ( member @ ( set @ A ) @ B3 @ A3 )
     => ( ord_less_eq @ ( set @ A ) @ ( complete_Inf_Inf @ ( set @ A ) @ A3 ) @ B3 ) ) ).

% Inter_lower
thf(fact_5621_le__Sup__iff,axiom,
    ! [A: $tType] :
      ( ( comple5582772986160207858norder @ A )
     => ! [X2: A,A3: set @ A] :
          ( ( ord_less_eq @ A @ X2 @ ( complete_Sup_Sup @ A @ A3 ) )
          = ( ! [Y5: A] :
                ( ( ord_less @ A @ Y5 @ X2 )
               => ? [X5: A] :
                    ( ( member @ A @ X5 @ A3 )
                    & ( ord_less @ A @ Y5 @ X5 ) ) ) ) ) ) ).

% le_Sup_iff
thf(fact_5622_Inf__le__iff,axiom,
    ! [A: $tType] :
      ( ( comple5582772986160207858norder @ A )
     => ! [A3: set @ A,X2: A] :
          ( ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ A3 ) @ X2 )
          = ( ! [Y5: A] :
                ( ( ord_less @ A @ X2 @ Y5 )
               => ? [X5: A] :
                    ( ( member @ A @ X5 @ A3 )
                    & ( ord_less @ A @ X5 @ Y5 ) ) ) ) ) ) ).

% Inf_le_iff
thf(fact_5623_less__eq__Sup,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A3: set @ A,U: A] :
          ( ! [V3: A] :
              ( ( member @ A @ V3 @ A3 )
             => ( ord_less_eq @ A @ U @ V3 ) )
         => ( ( A3
             != ( bot_bot @ ( set @ A ) ) )
           => ( ord_less_eq @ A @ U @ ( complete_Sup_Sup @ A @ A3 ) ) ) ) ) ).

% less_eq_Sup
thf(fact_5624_Sup__subset__mono,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A3: set @ A,B3: set @ A] :
          ( ( ord_less_eq @ ( set @ A ) @ A3 @ B3 )
         => ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ A3 ) @ ( complete_Sup_Sup @ A @ B3 ) ) ) ) ).

% Sup_subset_mono
thf(fact_5625_Inf__less__eq,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A3: set @ A,U: A] :
          ( ! [V3: A] :
              ( ( member @ A @ V3 @ A3 )
             => ( ord_less_eq @ A @ V3 @ U ) )
         => ( ( A3
             != ( bot_bot @ ( set @ A ) ) )
           => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ A3 ) @ U ) ) ) ) ).

% Inf_less_eq
thf(fact_5626_Inf__superset__mono,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [B3: set @ A,A3: set @ A] :
          ( ( ord_less_eq @ ( set @ A ) @ B3 @ A3 )
         => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ A3 ) @ ( complete_Inf_Inf @ A @ B3 ) ) ) ) ).

% Inf_superset_mono
thf(fact_5627_Union__mono,axiom,
    ! [A: $tType,A3: set @ ( set @ A ),B3: set @ ( set @ A )] :
      ( ( ord_less_eq @ ( set @ ( set @ A ) ) @ A3 @ B3 )
     => ( ord_less_eq @ ( set @ A ) @ ( complete_Sup_Sup @ ( set @ A ) @ A3 ) @ ( complete_Sup_Sup @ ( set @ A ) @ B3 ) ) ) ).

% Union_mono
thf(fact_5628_Inter__anti__mono,axiom,
    ! [A: $tType,B3: set @ ( set @ A ),A3: set @ ( set @ A )] :
      ( ( ord_less_eq @ ( set @ ( set @ A ) ) @ B3 @ A3 )
     => ( ord_less_eq @ ( set @ A ) @ ( complete_Inf_Inf @ ( set @ A ) @ A3 ) @ ( complete_Inf_Inf @ ( set @ A ) @ B3 ) ) ) ).

% Inter_anti_mono
thf(fact_5629_Inter__subset,axiom,
    ! [A: $tType,A3: set @ ( set @ A ),B3: set @ A] :
      ( ! [X10: set @ A] :
          ( ( member @ ( set @ A ) @ X10 @ A3 )
         => ( ord_less_eq @ ( set @ A ) @ X10 @ B3 ) )
     => ( ( A3
         != ( bot_bot @ ( set @ ( set @ A ) ) ) )
       => ( ord_less_eq @ ( set @ A ) @ ( complete_Inf_Inf @ ( set @ A ) @ A3 ) @ B3 ) ) ) ).

% Inter_subset
thf(fact_5630_subset__Pow__Union,axiom,
    ! [A: $tType,A3: set @ ( set @ A )] : ( ord_less_eq @ ( set @ ( set @ A ) ) @ A3 @ ( pow2 @ A @ ( complete_Sup_Sup @ ( set @ A ) @ A3 ) ) ) ).

% subset_Pow_Union
thf(fact_5631_card__partition,axiom,
    ! [A: $tType,C6: set @ ( set @ A ),K: nat] :
      ( ( finite_finite @ ( set @ A ) @ C6 )
     => ( ( finite_finite @ A @ ( complete_Sup_Sup @ ( set @ A ) @ C6 ) )
       => ( ! [C3: set @ A] :
              ( ( member @ ( set @ A ) @ C3 @ C6 )
             => ( ( finite_card @ A @ C3 )
                = K ) )
         => ( ! [C1: set @ A,C22: set @ A] :
                ( ( member @ ( set @ A ) @ C1 @ C6 )
               => ( ( member @ ( set @ A ) @ C22 @ C6 )
                 => ( ( C1 != C22 )
                   => ( ( inf_inf @ ( set @ A ) @ C1 @ C22 )
                      = ( bot_bot @ ( set @ A ) ) ) ) ) )
           => ( ( times_times @ nat @ K @ ( finite_card @ ( set @ A ) @ C6 ) )
              = ( finite_card @ A @ ( complete_Sup_Sup @ ( set @ A ) @ C6 ) ) ) ) ) ) ) ).

% card_partition
thf(fact_5632_arg__min__if__finite_I2_J,axiom,
    ! [B: $tType,A: $tType] :
      ( ( order @ B )
     => ! [S3: set @ A,F2: A > B] :
          ( ( finite_finite @ A @ S3 )
         => ( ( S3
             != ( bot_bot @ ( set @ A ) ) )
           => ~ ? [X: A] :
                  ( ( member @ A @ X @ S3 )
                  & ( ord_less @ B @ ( F2 @ X ) @ ( F2 @ ( lattic7623131987881927897min_on @ A @ B @ F2 @ S3 ) ) ) ) ) ) ) ).

% arg_min_if_finite(2)
thf(fact_5633_arg__min__least,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linorder @ B )
     => ! [S3: set @ A,Y2: A,F2: A > B] :
          ( ( finite_finite @ A @ S3 )
         => ( ( S3
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( member @ A @ Y2 @ S3 )
             => ( ord_less_eq @ B @ ( F2 @ ( lattic7623131987881927897min_on @ A @ B @ F2 @ S3 ) ) @ ( F2 @ Y2 ) ) ) ) ) ) ).

% arg_min_least
thf(fact_5634_le__inf__iff,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [X2: A,Y2: A,Z: A] :
          ( ( ord_less_eq @ A @ X2 @ ( inf_inf @ A @ Y2 @ Z ) )
          = ( ( ord_less_eq @ A @ X2 @ Y2 )
            & ( ord_less_eq @ A @ X2 @ Z ) ) ) ) ).

% le_inf_iff
thf(fact_5635_inf_Obounded__iff,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ ( inf_inf @ A @ B2 @ C2 ) )
          = ( ( ord_less_eq @ A @ A2 @ B2 )
            & ( ord_less_eq @ A @ A2 @ C2 ) ) ) ) ).

% inf.bounded_iff
thf(fact_5636_Int__subset__iff,axiom,
    ! [A: $tType,C6: set @ A,A3: set @ A,B3: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ C6 @ ( inf_inf @ ( set @ A ) @ A3 @ B3 ) )
      = ( ( ord_less_eq @ ( set @ A ) @ C6 @ A3 )
        & ( ord_less_eq @ ( set @ A ) @ C6 @ B3 ) ) ) ).

% Int_subset_iff
thf(fact_5637_sum__of__bool__mult__eq,axiom,
    ! [A: $tType,B: $tType] :
      ( ( semiring_1 @ A )
     => ! [A3: set @ B,P: B > $o,F2: B > A] :
          ( ( finite_finite @ B @ A3 )
         => ( ( groups7311177749621191930dd_sum @ B @ A
              @ ^ [X5: B] : ( times_times @ A @ ( zero_neq_one_of_bool @ A @ ( P @ X5 ) ) @ ( F2 @ X5 ) )
              @ A3 )
            = ( groups7311177749621191930dd_sum @ B @ A @ F2 @ ( inf_inf @ ( set @ B ) @ A3 @ ( collect @ B @ P ) ) ) ) ) ) ).

% sum_of_bool_mult_eq
thf(fact_5638_sum__mult__of__bool__eq,axiom,
    ! [A: $tType,B: $tType] :
      ( ( semiring_1 @ A )
     => ! [A3: set @ B,F2: B > A,P: B > $o] :
          ( ( finite_finite @ B @ A3 )
         => ( ( groups7311177749621191930dd_sum @ B @ A
              @ ^ [X5: B] : ( times_times @ A @ ( F2 @ X5 ) @ ( zero_neq_one_of_bool @ A @ ( P @ X5 ) ) )
              @ A3 )
            = ( groups7311177749621191930dd_sum @ B @ A @ F2 @ ( inf_inf @ ( set @ B ) @ A3 @ ( collect @ B @ P ) ) ) ) ) ) ).

% sum_mult_of_bool_eq
thf(fact_5639_Sup__inter__less__eq,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A3: set @ A,B3: set @ A] : ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ ( inf_inf @ ( set @ A ) @ A3 @ B3 ) ) @ ( inf_inf @ A @ ( complete_Sup_Sup @ A @ A3 ) @ ( complete_Sup_Sup @ A @ B3 ) ) ) ) ).

% Sup_inter_less_eq
thf(fact_5640_Union__Int__subset,axiom,
    ! [A: $tType,A3: set @ ( set @ A ),B3: set @ ( set @ A )] : ( ord_less_eq @ ( set @ A ) @ ( complete_Sup_Sup @ ( set @ A ) @ ( inf_inf @ ( set @ ( set @ A ) ) @ A3 @ B3 ) ) @ ( inf_inf @ ( set @ A ) @ ( complete_Sup_Sup @ ( set @ A ) @ A3 ) @ ( complete_Sup_Sup @ ( set @ A ) @ B3 ) ) ) ).

% Union_Int_subset
thf(fact_5641_inf__sup__ord_I2_J,axiom,
    ! [A: $tType] :
      ( ( lattice @ A )
     => ! [X2: A,Y2: A] : ( ord_less_eq @ A @ ( inf_inf @ A @ X2 @ Y2 ) @ Y2 ) ) ).

% inf_sup_ord(2)
thf(fact_5642_inf__sup__ord_I1_J,axiom,
    ! [A: $tType] :
      ( ( lattice @ A )
     => ! [X2: A,Y2: A] : ( ord_less_eq @ A @ ( inf_inf @ A @ X2 @ Y2 ) @ X2 ) ) ).

% inf_sup_ord(1)
thf(fact_5643_inf__le1,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [X2: A,Y2: A] : ( ord_less_eq @ A @ ( inf_inf @ A @ X2 @ Y2 ) @ X2 ) ) ).

% inf_le1
thf(fact_5644_inf__le2,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [X2: A,Y2: A] : ( ord_less_eq @ A @ ( inf_inf @ A @ X2 @ Y2 ) @ Y2 ) ) ).

% inf_le2
thf(fact_5645_le__infE,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [X2: A,A2: A,B2: A] :
          ( ( ord_less_eq @ A @ X2 @ ( inf_inf @ A @ A2 @ B2 ) )
         => ~ ( ( ord_less_eq @ A @ X2 @ A2 )
             => ~ ( ord_less_eq @ A @ X2 @ B2 ) ) ) ) ).

% le_infE
thf(fact_5646_le__infI,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [X2: A,A2: A,B2: A] :
          ( ( ord_less_eq @ A @ X2 @ A2 )
         => ( ( ord_less_eq @ A @ X2 @ B2 )
           => ( ord_less_eq @ A @ X2 @ ( inf_inf @ A @ A2 @ B2 ) ) ) ) ) ).

% le_infI
thf(fact_5647_inf__mono,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A2: A,C2: A,B2: A,D2: A] :
          ( ( ord_less_eq @ A @ A2 @ C2 )
         => ( ( ord_less_eq @ A @ B2 @ D2 )
           => ( ord_less_eq @ A @ ( inf_inf @ A @ A2 @ B2 ) @ ( inf_inf @ A @ C2 @ D2 ) ) ) ) ) ).

% inf_mono
thf(fact_5648_le__infI1,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A2: A,X2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ X2 )
         => ( ord_less_eq @ A @ ( inf_inf @ A @ A2 @ B2 ) @ X2 ) ) ) ).

% le_infI1
thf(fact_5649_le__infI2,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [B2: A,X2: A,A2: A] :
          ( ( ord_less_eq @ A @ B2 @ X2 )
         => ( ord_less_eq @ A @ ( inf_inf @ A @ A2 @ B2 ) @ X2 ) ) ) ).

% le_infI2
thf(fact_5650_inf_OorderE,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( A2
            = ( inf_inf @ A @ A2 @ B2 ) ) ) ) ).

% inf.orderE
thf(fact_5651_inf_OorderI,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A2: A,B2: A] :
          ( ( A2
            = ( inf_inf @ A @ A2 @ B2 ) )
         => ( ord_less_eq @ A @ A2 @ B2 ) ) ) ).

% inf.orderI
thf(fact_5652_inf__unique,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [F2: A > A > A,X2: A,Y2: A] :
          ( ! [X3: A,Y4: A] : ( ord_less_eq @ A @ ( F2 @ X3 @ Y4 ) @ X3 )
         => ( ! [X3: A,Y4: A] : ( ord_less_eq @ A @ ( F2 @ X3 @ Y4 ) @ Y4 )
           => ( ! [X3: A,Y4: A,Z3: A] :
                  ( ( ord_less_eq @ A @ X3 @ Y4 )
                 => ( ( ord_less_eq @ A @ X3 @ Z3 )
                   => ( ord_less_eq @ A @ X3 @ ( F2 @ Y4 @ Z3 ) ) ) )
             => ( ( inf_inf @ A @ X2 @ Y2 )
                = ( F2 @ X2 @ Y2 ) ) ) ) ) ) ).

% inf_unique
thf(fact_5653_le__iff__inf,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [X5: A,Y5: A] :
              ( ( inf_inf @ A @ X5 @ Y5 )
              = X5 ) ) ) ) ).

% le_iff_inf
thf(fact_5654_inf_Oabsorb1,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( inf_inf @ A @ A2 @ B2 )
            = A2 ) ) ) ).

% inf.absorb1
thf(fact_5655_inf_Oabsorb2,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less_eq @ A @ B2 @ A2 )
         => ( ( inf_inf @ A @ A2 @ B2 )
            = B2 ) ) ) ).

% inf.absorb2
thf(fact_5656_inf__absorb1,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [X2: A,Y2: A] :
          ( ( ord_less_eq @ A @ X2 @ Y2 )
         => ( ( inf_inf @ A @ X2 @ Y2 )
            = X2 ) ) ) ).

% inf_absorb1
thf(fact_5657_inf__absorb2,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [Y2: A,X2: A] :
          ( ( ord_less_eq @ A @ Y2 @ X2 )
         => ( ( inf_inf @ A @ X2 @ Y2 )
            = Y2 ) ) ) ).

% inf_absorb2
thf(fact_5658_inf_OboundedE,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ ( inf_inf @ A @ B2 @ C2 ) )
         => ~ ( ( ord_less_eq @ A @ A2 @ B2 )
             => ~ ( ord_less_eq @ A @ A2 @ C2 ) ) ) ) ).

% inf.boundedE
thf(fact_5659_inf_OboundedI,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ A2 @ C2 )
           => ( ord_less_eq @ A @ A2 @ ( inf_inf @ A @ B2 @ C2 ) ) ) ) ) ).

% inf.boundedI
thf(fact_5660_inf__greatest,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [X2: A,Y2: A,Z: A] :
          ( ( ord_less_eq @ A @ X2 @ Y2 )
         => ( ( ord_less_eq @ A @ X2 @ Z )
           => ( ord_less_eq @ A @ X2 @ ( inf_inf @ A @ Y2 @ Z ) ) ) ) ) ).

% inf_greatest
thf(fact_5661_inf_Oorder__iff,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [A4: A,B4: A] :
              ( A4
              = ( inf_inf @ A @ A4 @ B4 ) ) ) ) ) ).

% inf.order_iff
thf(fact_5662_inf_Ocobounded1,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A2: A,B2: A] : ( ord_less_eq @ A @ ( inf_inf @ A @ A2 @ B2 ) @ A2 ) ) ).

% inf.cobounded1
thf(fact_5663_inf_Ocobounded2,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A2: A,B2: A] : ( ord_less_eq @ A @ ( inf_inf @ A @ A2 @ B2 ) @ B2 ) ) ).

% inf.cobounded2
thf(fact_5664_inf_Oabsorb__iff1,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [A4: A,B4: A] :
              ( ( inf_inf @ A @ A4 @ B4 )
              = A4 ) ) ) ) ).

% inf.absorb_iff1
thf(fact_5665_inf_Oabsorb__iff2,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [B4: A,A4: A] :
              ( ( inf_inf @ A @ A4 @ B4 )
              = B4 ) ) ) ) ).

% inf.absorb_iff2
thf(fact_5666_inf_OcoboundedI1,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ C2 )
         => ( ord_less_eq @ A @ ( inf_inf @ A @ A2 @ B2 ) @ C2 ) ) ) ).

% inf.coboundedI1
thf(fact_5667_inf_OcoboundedI2,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( ord_less_eq @ A @ B2 @ C2 )
         => ( ord_less_eq @ A @ ( inf_inf @ A @ A2 @ B2 ) @ C2 ) ) ) ).

% inf.coboundedI2
thf(fact_5668_Int__Collect__mono,axiom,
    ! [A: $tType,A3: set @ A,B3: set @ A,P: A > $o,Q: A > $o] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ B3 )
     => ( ! [X3: A] :
            ( ( member @ A @ X3 @ A3 )
           => ( ( P @ X3 )
             => ( Q @ X3 ) ) )
       => ( ord_less_eq @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ A3 @ ( collect @ A @ P ) ) @ ( inf_inf @ ( set @ A ) @ B3 @ ( collect @ A @ Q ) ) ) ) ) ).

% Int_Collect_mono
thf(fact_5669_Int__greatest,axiom,
    ! [A: $tType,C6: set @ A,A3: set @ A,B3: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ C6 @ A3 )
     => ( ( ord_less_eq @ ( set @ A ) @ C6 @ B3 )
       => ( ord_less_eq @ ( set @ A ) @ C6 @ ( inf_inf @ ( set @ A ) @ A3 @ B3 ) ) ) ) ).

% Int_greatest
thf(fact_5670_Int__absorb2,axiom,
    ! [A: $tType,A3: set @ A,B3: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ B3 )
     => ( ( inf_inf @ ( set @ A ) @ A3 @ B3 )
        = A3 ) ) ).

% Int_absorb2
thf(fact_5671_Int__absorb1,axiom,
    ! [A: $tType,B3: set @ A,A3: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ B3 @ A3 )
     => ( ( inf_inf @ ( set @ A ) @ A3 @ B3 )
        = B3 ) ) ).

% Int_absorb1
thf(fact_5672_Int__lower2,axiom,
    ! [A: $tType,A3: set @ A,B3: set @ A] : ( ord_less_eq @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ A3 @ B3 ) @ B3 ) ).

% Int_lower2
thf(fact_5673_Int__lower1,axiom,
    ! [A: $tType,A3: set @ A,B3: set @ A] : ( ord_less_eq @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ A3 @ B3 ) @ A3 ) ).

% Int_lower1
thf(fact_5674_Int__mono,axiom,
    ! [A: $tType,A3: set @ A,C6: set @ A,B3: set @ A,D5: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ C6 )
     => ( ( ord_less_eq @ ( set @ A ) @ B3 @ D5 )
       => ( ord_less_eq @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ A3 @ B3 ) @ ( inf_inf @ ( set @ A ) @ C6 @ D5 ) ) ) ) ).

% Int_mono
thf(fact_5675_inf_Ostrict__coboundedI2,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( ord_less @ A @ B2 @ C2 )
         => ( ord_less @ A @ ( inf_inf @ A @ A2 @ B2 ) @ C2 ) ) ) ).

% inf.strict_coboundedI2
thf(fact_5676_inf_Ostrict__coboundedI1,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ C2 )
         => ( ord_less @ A @ ( inf_inf @ A @ A2 @ B2 ) @ C2 ) ) ) ).

% inf.strict_coboundedI1
thf(fact_5677_inf_Ostrict__order__iff,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ( ( ord_less @ A )
        = ( ^ [A4: A,B4: A] :
              ( ( A4
                = ( inf_inf @ A @ A4 @ B4 ) )
              & ( A4 != B4 ) ) ) ) ) ).

% inf.strict_order_iff
thf(fact_5678_inf_Ostrict__boundedE,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less @ A @ A2 @ ( inf_inf @ A @ B2 @ C2 ) )
         => ~ ( ( ord_less @ A @ A2 @ B2 )
             => ~ ( ord_less @ A @ A2 @ C2 ) ) ) ) ).

% inf.strict_boundedE
thf(fact_5679_inf_Oabsorb4,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less @ A @ B2 @ A2 )
         => ( ( inf_inf @ A @ A2 @ B2 )
            = B2 ) ) ) ).

% inf.absorb4
thf(fact_5680_inf_Oabsorb3,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( inf_inf @ A @ A2 @ B2 )
            = A2 ) ) ) ).

% inf.absorb3
thf(fact_5681_less__infI2,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [B2: A,X2: A,A2: A] :
          ( ( ord_less @ A @ B2 @ X2 )
         => ( ord_less @ A @ ( inf_inf @ A @ A2 @ B2 ) @ X2 ) ) ) ).

% less_infI2
thf(fact_5682_less__infI1,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A2: A,X2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ X2 )
         => ( ord_less @ A @ ( inf_inf @ A @ A2 @ B2 ) @ X2 ) ) ) ).

% less_infI1
thf(fact_5683_inf__shunt,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [X2: A,Y2: A] :
          ( ( ( inf_inf @ A @ X2 @ Y2 )
            = ( bot_bot @ A ) )
          = ( ord_less_eq @ A @ X2 @ ( uminus_uminus @ A @ Y2 ) ) ) ) ).

% inf_shunt
thf(fact_5684_disjoint__eq__subset__Compl,axiom,
    ! [A: $tType,A3: set @ A,B3: set @ A] :
      ( ( ( inf_inf @ ( set @ A ) @ A3 @ B3 )
        = ( bot_bot @ ( set @ A ) ) )
      = ( ord_less_eq @ ( set @ A ) @ A3 @ ( uminus_uminus @ ( set @ A ) @ B3 ) ) ) ).

% disjoint_eq_subset_Compl
thf(fact_5685_sum_Ointer__restrict,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A3: set @ B,G: B > A,B3: set @ B] :
          ( ( finite_finite @ B @ A3 )
         => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ ( inf_inf @ ( set @ B ) @ A3 @ B3 ) )
            = ( groups7311177749621191930dd_sum @ B @ A
              @ ^ [X5: B] : ( if @ A @ ( member @ B @ X5 @ B3 ) @ ( G @ X5 ) @ ( zero_zero @ A ) )
              @ A3 ) ) ) ) ).

% sum.inter_restrict
thf(fact_5686_prod_Ointer__restrict,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A3: set @ B,G: B > A,B3: set @ B] :
          ( ( finite_finite @ B @ A3 )
         => ( ( groups7121269368397514597t_prod @ B @ A @ G @ ( inf_inf @ ( set @ B ) @ A3 @ B3 ) )
            = ( groups7121269368397514597t_prod @ B @ A
              @ ^ [X5: B] : ( if @ A @ ( member @ B @ X5 @ B3 ) @ ( G @ X5 ) @ ( one_one @ A ) )
              @ A3 ) ) ) ) ).

% prod.inter_restrict
thf(fact_5687_sum_Omono__neutral__cong,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [T6: set @ B,S3: set @ B,H2: B > A,G: B > A] :
          ( ( finite_finite @ B @ T6 )
         => ( ( finite_finite @ B @ S3 )
           => ( ! [I2: B] :
                  ( ( member @ B @ I2 @ ( minus_minus @ ( set @ B ) @ T6 @ S3 ) )
                 => ( ( H2 @ I2 )
                    = ( zero_zero @ A ) ) )
             => ( ! [I2: B] :
                    ( ( member @ B @ I2 @ ( minus_minus @ ( set @ B ) @ S3 @ T6 ) )
                   => ( ( G @ I2 )
                      = ( zero_zero @ A ) ) )
               => ( ! [X3: B] :
                      ( ( member @ B @ X3 @ ( inf_inf @ ( set @ B ) @ S3 @ T6 ) )
                     => ( ( G @ X3 )
                        = ( H2 @ X3 ) ) )
                 => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ S3 )
                    = ( groups7311177749621191930dd_sum @ B @ A @ H2 @ T6 ) ) ) ) ) ) ) ) ).

% sum.mono_neutral_cong
thf(fact_5688_Iio__Int__singleton,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [X2: A,K: A] :
          ( ( ( ord_less @ A @ X2 @ K )
           => ( ( inf_inf @ ( set @ A ) @ ( set_ord_lessThan @ A @ K ) @ ( insert @ A @ X2 @ ( bot_bot @ ( set @ A ) ) ) )
              = ( insert @ A @ X2 @ ( bot_bot @ ( set @ A ) ) ) ) )
          & ( ~ ( ord_less @ A @ X2 @ K )
           => ( ( inf_inf @ ( set @ A ) @ ( set_ord_lessThan @ A @ K ) @ ( insert @ A @ X2 @ ( bot_bot @ ( set @ A ) ) ) )
              = ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% Iio_Int_singleton
thf(fact_5689_sum_OInt__Diff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A3: set @ B,G: B > A,B3: set @ B] :
          ( ( finite_finite @ B @ A3 )
         => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ A3 )
            = ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ B @ A @ G @ ( inf_inf @ ( set @ B ) @ A3 @ B3 ) ) @ ( groups7311177749621191930dd_sum @ B @ A @ G @ ( minus_minus @ ( set @ B ) @ A3 @ B3 ) ) ) ) ) ) ).

% sum.Int_Diff
thf(fact_5690_prod_OInt__Diff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A3: set @ B,G: B > A,B3: set @ B] :
          ( ( finite_finite @ B @ A3 )
         => ( ( groups7121269368397514597t_prod @ B @ A @ G @ A3 )
            = ( times_times @ A @ ( groups7121269368397514597t_prod @ B @ A @ G @ ( inf_inf @ ( set @ B ) @ A3 @ B3 ) ) @ ( groups7121269368397514597t_prod @ B @ A @ G @ ( minus_minus @ ( set @ B ) @ A3 @ B3 ) ) ) ) ) ) ).

% prod.Int_Diff
thf(fact_5691_prod_Omono__neutral__cong,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [T6: set @ B,S3: set @ B,H2: B > A,G: B > A] :
          ( ( finite_finite @ B @ T6 )
         => ( ( finite_finite @ B @ S3 )
           => ( ! [I2: B] :
                  ( ( member @ B @ I2 @ ( minus_minus @ ( set @ B ) @ T6 @ S3 ) )
                 => ( ( H2 @ I2 )
                    = ( one_one @ A ) ) )
             => ( ! [I2: B] :
                    ( ( member @ B @ I2 @ ( minus_minus @ ( set @ B ) @ S3 @ T6 ) )
                   => ( ( G @ I2 )
                      = ( one_one @ A ) ) )
               => ( ! [X3: B] :
                      ( ( member @ B @ X3 @ ( inf_inf @ ( set @ B ) @ S3 @ T6 ) )
                     => ( ( G @ X3 )
                        = ( H2 @ X3 ) ) )
                 => ( ( groups7121269368397514597t_prod @ B @ A @ G @ S3 )
                    = ( groups7121269368397514597t_prod @ B @ A @ H2 @ T6 ) ) ) ) ) ) ) ) ).

% prod.mono_neutral_cong
thf(fact_5692_sum_OIf__cases,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A3: set @ B,P: B > $o,H2: B > A,G: B > A] :
          ( ( finite_finite @ B @ A3 )
         => ( ( groups7311177749621191930dd_sum @ B @ A
              @ ^ [X5: B] : ( if @ A @ ( P @ X5 ) @ ( H2 @ X5 ) @ ( G @ X5 ) )
              @ A3 )
            = ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ B @ A @ H2 @ ( inf_inf @ ( set @ B ) @ A3 @ ( collect @ B @ P ) ) ) @ ( groups7311177749621191930dd_sum @ B @ A @ G @ ( inf_inf @ ( set @ B ) @ A3 @ ( uminus_uminus @ ( set @ B ) @ ( collect @ B @ P ) ) ) ) ) ) ) ) ).

% sum.If_cases
thf(fact_5693_prod_OIf__cases,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A3: set @ B,P: B > $o,H2: B > A,G: B > A] :
          ( ( finite_finite @ B @ A3 )
         => ( ( groups7121269368397514597t_prod @ B @ A
              @ ^ [X5: B] : ( if @ A @ ( P @ X5 ) @ ( H2 @ X5 ) @ ( G @ X5 ) )
              @ A3 )
            = ( times_times @ A @ ( groups7121269368397514597t_prod @ B @ A @ H2 @ ( inf_inf @ ( set @ B ) @ A3 @ ( collect @ B @ P ) ) ) @ ( groups7121269368397514597t_prod @ B @ A @ G @ ( inf_inf @ ( set @ B ) @ A3 @ ( uminus_uminus @ ( set @ B ) @ ( collect @ B @ P ) ) ) ) ) ) ) ) ).

% prod.If_cases
thf(fact_5694_sum__div__partition,axiom,
    ! [B: $tType,A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [A3: set @ B,F2: B > A,B2: A] :
          ( ( finite_finite @ B @ A3 )
         => ( ( divide_divide @ A @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ A3 ) @ B2 )
            = ( plus_plus @ A
              @ ( groups7311177749621191930dd_sum @ B @ A
                @ ^ [A4: B] : ( divide_divide @ A @ ( F2 @ A4 ) @ B2 )
                @ ( inf_inf @ ( set @ B ) @ A3
                  @ ( collect @ B
                    @ ^ [A4: B] : ( dvd_dvd @ A @ B2 @ ( F2 @ A4 ) ) ) ) )
              @ ( divide_divide @ A
                @ ( groups7311177749621191930dd_sum @ B @ A @ F2
                  @ ( inf_inf @ ( set @ B ) @ A3
                    @ ( collect @ B
                      @ ^ [A4: B] :
                          ~ ( dvd_dvd @ A @ B2 @ ( F2 @ A4 ) ) ) ) )
                @ B2 ) ) ) ) ) ).

% sum_div_partition
thf(fact_5695_distinct__concat,axiom,
    ! [A: $tType,Xs: list @ ( list @ A )] :
      ( ( distinct @ ( list @ A ) @ Xs )
     => ( ! [Ys4: list @ A] :
            ( ( member @ ( list @ A ) @ Ys4 @ ( set2 @ ( list @ A ) @ Xs ) )
           => ( distinct @ A @ Ys4 ) )
       => ( ! [Ys4: list @ A,Zs2: list @ A] :
              ( ( member @ ( list @ A ) @ Ys4 @ ( set2 @ ( list @ A ) @ Xs ) )
             => ( ( member @ ( list @ A ) @ Zs2 @ ( set2 @ ( list @ A ) @ Xs ) )
               => ( ( Ys4 != Zs2 )
                 => ( ( inf_inf @ ( set @ A ) @ ( set2 @ A @ Ys4 ) @ ( set2 @ A @ Zs2 ) )
                    = ( bot_bot @ ( set @ A ) ) ) ) ) )
         => ( distinct @ A @ ( concat @ A @ Xs ) ) ) ) ) ).

% distinct_concat
thf(fact_5696_card__disjoint__shuffles,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A] :
      ( ( ( inf_inf @ ( set @ A ) @ ( set2 @ A @ Xs ) @ ( set2 @ A @ Ys ) )
        = ( bot_bot @ ( set @ A ) ) )
     => ( ( finite_card @ ( list @ A ) @ ( shuffles @ A @ Xs @ Ys ) )
        = ( binomial @ ( plus_plus @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ ( size_size @ ( list @ A ) @ Ys ) ) @ ( size_size @ ( list @ A ) @ Xs ) ) ) ) ).

% card_disjoint_shuffles
thf(fact_5697_times__int_Oabs__eq,axiom,
    ! [Xa2: product_prod @ nat @ nat,X2: product_prod @ nat @ nat] :
      ( ( times_times @ int @ ( abs_Integ @ Xa2 ) @ ( abs_Integ @ X2 ) )
      = ( abs_Integ
        @ ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) )
          @ ^ [X5: nat,Y5: nat] :
              ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
              @ ^ [U2: nat,V5: nat] : ( product_Pair @ nat @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ X5 @ U2 ) @ ( times_times @ nat @ Y5 @ V5 ) ) @ ( plus_plus @ nat @ ( times_times @ nat @ X5 @ V5 ) @ ( times_times @ nat @ Y5 @ U2 ) ) ) )
          @ Xa2
          @ X2 ) ) ) ).

% times_int.abs_eq
thf(fact_5698_Gcd__remove0__nat,axiom,
    ! [M7: set @ nat] :
      ( ( finite_finite @ nat @ M7 )
     => ( ( gcd_Gcd @ nat @ M7 )
        = ( gcd_Gcd @ nat @ ( minus_minus @ ( set @ nat ) @ M7 @ ( insert @ nat @ ( zero_zero @ nat ) @ ( bot_bot @ ( set @ nat ) ) ) ) ) ) ) ).

% Gcd_remove0_nat
thf(fact_5699_finite__shuffles,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A] : ( finite_finite @ ( list @ A ) @ ( shuffles @ A @ Xs @ Ys ) ) ).

% finite_shuffles
thf(fact_5700_Gcd__empty,axiom,
    ! [A: $tType] :
      ( ( semiring_Gcd @ A )
     => ( ( gcd_Gcd @ A @ ( bot_bot @ ( set @ A ) ) )
        = ( zero_zero @ A ) ) ) ).

% Gcd_empty
thf(fact_5701_Gcd__0__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_Gcd @ A )
     => ! [A3: set @ A] :
          ( ( ( gcd_Gcd @ A @ A3 )
            = ( zero_zero @ A ) )
          = ( ord_less_eq @ ( set @ A ) @ A3 @ ( insert @ A @ ( zero_zero @ A ) @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% Gcd_0_iff
thf(fact_5702_inf__Int__eq2,axiom,
    ! [B: $tType,A: $tType,R: set @ ( product_prod @ A @ B ),S3: set @ ( product_prod @ A @ B )] :
      ( ( inf_inf @ ( A > B > $o )
        @ ^ [X5: A,Y5: B] : ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X5 @ Y5 ) @ R )
        @ ^ [X5: A,Y5: B] : ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X5 @ Y5 ) @ S3 ) )
      = ( ^ [X5: A,Y5: B] : ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X5 @ Y5 ) @ ( inf_inf @ ( set @ ( product_prod @ A @ B ) ) @ R @ S3 ) ) ) ) ).

% inf_Int_eq2
thf(fact_5703_Gcd__nat__eq__one,axiom,
    ! [N4: set @ nat] :
      ( ( member @ nat @ ( one_one @ nat ) @ N4 )
     => ( ( gcd_Gcd @ nat @ N4 )
        = ( one_one @ nat ) ) ) ).

% Gcd_nat_eq_one
thf(fact_5704_Gcd__1,axiom,
    ! [A: $tType] :
      ( ( semiring_Gcd @ A )
     => ! [A3: set @ A] :
          ( ( member @ A @ ( one_one @ A ) @ A3 )
         => ( ( gcd_Gcd @ A @ A3 )
            = ( one_one @ A ) ) ) ) ).

% Gcd_1
thf(fact_5705_eq__Abs__Integ,axiom,
    ! [Z: int] :
      ~ ! [X3: nat,Y4: nat] :
          ( Z
         != ( abs_Integ @ ( product_Pair @ nat @ nat @ X3 @ Y4 ) ) ) ).

% eq_Abs_Integ
thf(fact_5706_shuffles__commutes,axiom,
    ! [A: $tType] :
      ( ( shuffles @ A )
      = ( ^ [Xs3: list @ A,Ys3: list @ A] : ( shuffles @ A @ Ys3 @ Xs3 ) ) ) ).

% shuffles_commutes
thf(fact_5707_length__shuffles,axiom,
    ! [A: $tType,Zs: list @ A,Xs: list @ A,Ys: list @ A] :
      ( ( member @ ( list @ A ) @ Zs @ ( shuffles @ A @ Xs @ Ys ) )
     => ( ( size_size @ ( list @ A ) @ Zs )
        = ( plus_plus @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ ( size_size @ ( list @ A ) @ Ys ) ) ) ) ).

% length_shuffles
thf(fact_5708_Gcd__eq__1__I,axiom,
    ! [A: $tType] :
      ( ( semiring_Gcd @ A )
     => ! [A2: A,A3: set @ A] :
          ( ( dvd_dvd @ A @ A2 @ ( one_one @ A ) )
         => ( ( member @ A @ A2 @ A3 )
           => ( ( gcd_Gcd @ A @ A3 )
              = ( one_one @ A ) ) ) ) ) ).

% Gcd_eq_1_I
thf(fact_5709_zero__int__def,axiom,
    ( ( zero_zero @ int )
    = ( abs_Integ @ ( product_Pair @ nat @ nat @ ( zero_zero @ nat ) @ ( zero_zero @ nat ) ) ) ) ).

% zero_int_def
thf(fact_5710_int__def,axiom,
    ( ( semiring_1_of_nat @ int )
    = ( ^ [N3: nat] : ( abs_Integ @ ( product_Pair @ nat @ nat @ N3 @ ( zero_zero @ nat ) ) ) ) ) ).

% int_def
thf(fact_5711_distinct__disjoint__shuffles,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A,Zs: list @ A] :
      ( ( distinct @ A @ Xs )
     => ( ( distinct @ A @ Ys )
       => ( ( ( inf_inf @ ( set @ A ) @ ( set2 @ A @ Xs ) @ ( set2 @ A @ Ys ) )
            = ( bot_bot @ ( set @ A ) ) )
         => ( ( member @ ( list @ A ) @ Zs @ ( shuffles @ A @ Xs @ Ys ) )
           => ( distinct @ A @ Zs ) ) ) ) ) ).

% distinct_disjoint_shuffles
thf(fact_5712_uminus__int_Oabs__eq,axiom,
    ! [X2: product_prod @ nat @ nat] :
      ( ( uminus_uminus @ int @ ( abs_Integ @ X2 ) )
      = ( abs_Integ
        @ ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
          @ ^ [X5: nat,Y5: nat] : ( product_Pair @ nat @ nat @ Y5 @ X5 )
          @ X2 ) ) ) ).

% uminus_int.abs_eq
thf(fact_5713_one__int__def,axiom,
    ( ( one_one @ int )
    = ( abs_Integ @ ( product_Pair @ nat @ nat @ ( one_one @ nat ) @ ( zero_zero @ nat ) ) ) ) ).

% one_int_def
thf(fact_5714_less__int_Oabs__eq,axiom,
    ! [Xa2: product_prod @ nat @ nat,X2: product_prod @ nat @ nat] :
      ( ( ord_less @ int @ ( abs_Integ @ Xa2 ) @ ( abs_Integ @ X2 ) )
      = ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > $o )
        @ ^ [X5: nat,Y5: nat] :
            ( product_case_prod @ nat @ nat @ $o
            @ ^ [U2: nat,V5: nat] : ( ord_less @ nat @ ( plus_plus @ nat @ X5 @ V5 ) @ ( plus_plus @ nat @ U2 @ Y5 ) ) )
        @ Xa2
        @ X2 ) ) ).

% less_int.abs_eq
thf(fact_5715_less__eq__int_Oabs__eq,axiom,
    ! [Xa2: product_prod @ nat @ nat,X2: product_prod @ nat @ nat] :
      ( ( ord_less_eq @ int @ ( abs_Integ @ Xa2 ) @ ( abs_Integ @ X2 ) )
      = ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > $o )
        @ ^ [X5: nat,Y5: nat] :
            ( product_case_prod @ nat @ nat @ $o
            @ ^ [U2: nat,V5: nat] : ( ord_less_eq @ nat @ ( plus_plus @ nat @ X5 @ V5 ) @ ( plus_plus @ nat @ U2 @ Y5 ) ) )
        @ Xa2
        @ X2 ) ) ).

% less_eq_int.abs_eq
thf(fact_5716_plus__int_Oabs__eq,axiom,
    ! [Xa2: product_prod @ nat @ nat,X2: product_prod @ nat @ nat] :
      ( ( plus_plus @ int @ ( abs_Integ @ Xa2 ) @ ( abs_Integ @ X2 ) )
      = ( abs_Integ
        @ ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) )
          @ ^ [X5: nat,Y5: nat] :
              ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
              @ ^ [U2: nat,V5: nat] : ( product_Pair @ nat @ nat @ ( plus_plus @ nat @ X5 @ U2 ) @ ( plus_plus @ nat @ Y5 @ V5 ) ) )
          @ Xa2
          @ X2 ) ) ) ).

% plus_int.abs_eq
thf(fact_5717_minus__int_Oabs__eq,axiom,
    ! [Xa2: product_prod @ nat @ nat,X2: product_prod @ nat @ nat] :
      ( ( minus_minus @ int @ ( abs_Integ @ Xa2 ) @ ( abs_Integ @ X2 ) )
      = ( abs_Integ
        @ ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) )
          @ ^ [X5: nat,Y5: nat] :
              ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
              @ ^ [U2: nat,V5: nat] : ( product_Pair @ nat @ nat @ ( plus_plus @ nat @ X5 @ V5 ) @ ( plus_plus @ nat @ Y5 @ U2 ) ) )
          @ Xa2
          @ X2 ) ) ) ).

% minus_int.abs_eq
thf(fact_5718_distinct__concat__iff,axiom,
    ! [A: $tType,Xs: list @ ( list @ A )] :
      ( ( distinct @ A @ ( concat @ A @ Xs ) )
      = ( ( distinct @ ( list @ A ) @ ( removeAll @ ( list @ A ) @ ( nil @ A ) @ Xs ) )
        & ! [Ys3: list @ A] :
            ( ( member @ ( list @ A ) @ Ys3 @ ( set2 @ ( list @ A ) @ Xs ) )
           => ( distinct @ A @ Ys3 ) )
        & ! [Ys3: list @ A,Zs3: list @ A] :
            ( ( ( member @ ( list @ A ) @ Ys3 @ ( set2 @ ( list @ A ) @ Xs ) )
              & ( member @ ( list @ A ) @ Zs3 @ ( set2 @ ( list @ A ) @ Xs ) )
              & ( Ys3 != Zs3 ) )
           => ( ( inf_inf @ ( set @ A ) @ ( set2 @ A @ Ys3 ) @ ( set2 @ A @ Zs3 ) )
              = ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% distinct_concat_iff
thf(fact_5719_distinct__product__lists,axiom,
    ! [A: $tType,Xss: list @ ( list @ A )] :
      ( ! [X3: list @ A] :
          ( ( member @ ( list @ A ) @ X3 @ ( set2 @ ( list @ A ) @ Xss ) )
         => ( distinct @ A @ X3 ) )
     => ( distinct @ ( list @ A ) @ ( product_lists @ A @ Xss ) ) ) ).

% distinct_product_lists
thf(fact_5720_semiring__char__def,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ( ( semiri4206861660011772517g_char @ A )
        = ( ^ [Uu4: itself @ A] :
              ( gcd_Gcd @ nat
              @ ( collect @ nat
                @ ^ [N3: nat] :
                    ( ( semiring_1_of_nat @ A @ N3 )
                    = ( zero_zero @ A ) ) ) ) ) ) ) ).

% semiring_char_def
thf(fact_5721_list__update__nonempty,axiom,
    ! [A: $tType,Xs: list @ A,K: nat,X2: A] :
      ( ( ( list_update @ A @ Xs @ K @ X2 )
        = ( nil @ A ) )
      = ( Xs
        = ( nil @ A ) ) ) ).

% list_update_nonempty
thf(fact_5722_concat__replicate__trivial,axiom,
    ! [A: $tType,I3: nat] :
      ( ( concat @ A @ ( replicate @ ( list @ A ) @ I3 @ ( nil @ A ) ) )
      = ( nil @ A ) ) ).

% concat_replicate_trivial
thf(fact_5723_Nil__in__shuffles,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A] :
      ( ( member @ ( list @ A ) @ ( nil @ A ) @ ( shuffles @ A @ Xs @ Ys ) )
      = ( ( Xs
          = ( nil @ A ) )
        & ( Ys
          = ( nil @ A ) ) ) ) ).

% Nil_in_shuffles
thf(fact_5724_enumerate__simps_I1_J,axiom,
    ! [A: $tType,N2: nat] :
      ( ( enumerate @ A @ N2 @ ( nil @ A ) )
      = ( nil @ ( product_prod @ nat @ A ) ) ) ).

% enumerate_simps(1)
thf(fact_5725_rotate1__is__Nil__conv,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( ( rotate1 @ A @ Xs )
        = ( nil @ A ) )
      = ( Xs
        = ( nil @ A ) ) ) ).

% rotate1_is_Nil_conv
thf(fact_5726_set__empty,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( ( set2 @ A @ Xs )
        = ( bot_bot @ ( set @ A ) ) )
      = ( Xs
        = ( nil @ A ) ) ) ).

% set_empty
thf(fact_5727_set__empty2,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( ( bot_bot @ ( set @ A ) )
        = ( set2 @ A @ Xs ) )
      = ( Xs
        = ( nil @ A ) ) ) ).

% set_empty2
thf(fact_5728_length__0__conv,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( ( size_size @ ( list @ A ) @ Xs )
        = ( zero_zero @ nat ) )
      = ( Xs
        = ( nil @ A ) ) ) ).

% length_0_conv
thf(fact_5729_replicate__empty,axiom,
    ! [A: $tType,N2: nat,X2: A] :
      ( ( ( replicate @ A @ N2 @ X2 )
        = ( nil @ A ) )
      = ( N2
        = ( zero_zero @ nat ) ) ) ).

% replicate_empty
thf(fact_5730_empty__replicate,axiom,
    ! [A: $tType,N2: nat,X2: A] :
      ( ( ( nil @ A )
        = ( replicate @ A @ N2 @ X2 ) )
      = ( N2
        = ( zero_zero @ nat ) ) ) ).

% empty_replicate
thf(fact_5731_horner__sum__simps_I1_J,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comm_semiring_0 @ A )
     => ! [F2: B > A,A2: A] :
          ( ( groups4207007520872428315er_sum @ B @ A @ F2 @ A2 @ ( nil @ B ) )
          = ( zero_zero @ A ) ) ) ).

% horner_sum_simps(1)
thf(fact_5732_Nil__eq__concat__conv,axiom,
    ! [A: $tType,Xss: list @ ( list @ A )] :
      ( ( ( nil @ A )
        = ( concat @ A @ Xss ) )
      = ( ! [X5: list @ A] :
            ( ( member @ ( list @ A ) @ X5 @ ( set2 @ ( list @ A ) @ Xss ) )
           => ( X5
              = ( nil @ A ) ) ) ) ) ).

% Nil_eq_concat_conv
thf(fact_5733_concat__eq__Nil__conv,axiom,
    ! [A: $tType,Xss: list @ ( list @ A )] :
      ( ( ( concat @ A @ Xss )
        = ( nil @ A ) )
      = ( ! [X5: list @ A] :
            ( ( member @ ( list @ A ) @ X5 @ ( set2 @ ( list @ A ) @ Xss ) )
           => ( X5
              = ( nil @ A ) ) ) ) ) ).

% concat_eq_Nil_conv
thf(fact_5734_length__greater__0__conv,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( size_size @ ( list @ A ) @ Xs ) )
      = ( ( Xs
         != ( nil @ A ) ) ) ) ).

% length_greater_0_conv
thf(fact_5735_distinct_Osimps_I1_J,axiom,
    ! [A: $tType] : ( distinct @ A @ ( nil @ A ) ) ).

% distinct.simps(1)
thf(fact_5736_Nil__in__shufflesI,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A] :
      ( ( Xs
        = ( nil @ A ) )
     => ( ( Ys
          = ( nil @ A ) )
       => ( member @ ( list @ A ) @ ( nil @ A ) @ ( shuffles @ A @ Xs @ Ys ) ) ) ) ).

% Nil_in_shufflesI
thf(fact_5737_shuffles_Osimps_I2_J,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( shuffles @ A @ Xs @ ( nil @ A ) )
      = ( insert @ ( list @ A ) @ Xs @ ( bot_bot @ ( set @ ( list @ A ) ) ) ) ) ).

% shuffles.simps(2)
thf(fact_5738_shuffles_Osimps_I1_J,axiom,
    ! [A: $tType,Ys: list @ A] :
      ( ( shuffles @ A @ ( nil @ A ) @ Ys )
      = ( insert @ ( list @ A ) @ Ys @ ( bot_bot @ ( set @ ( list @ A ) ) ) ) ) ).

% shuffles.simps(1)
thf(fact_5739_removeAll_Osimps_I1_J,axiom,
    ! [A: $tType,X2: A] :
      ( ( removeAll @ A @ X2 @ ( nil @ A ) )
      = ( nil @ A ) ) ).

% removeAll.simps(1)
thf(fact_5740_rotate1_Osimps_I1_J,axiom,
    ! [A: $tType] :
      ( ( rotate1 @ A @ ( nil @ A ) )
      = ( nil @ A ) ) ).

% rotate1.simps(1)
thf(fact_5741_product_Osimps_I1_J,axiom,
    ! [B: $tType,A: $tType,Uu2: list @ B] :
      ( ( product @ A @ B @ ( nil @ A ) @ Uu2 )
      = ( nil @ ( product_prod @ A @ B ) ) ) ).

% product.simps(1)
thf(fact_5742_list__update__code_I1_J,axiom,
    ! [A: $tType,I3: nat,Y2: A] :
      ( ( list_update @ A @ ( nil @ A ) @ I3 @ Y2 )
      = ( nil @ A ) ) ).

% list_update_code(1)
thf(fact_5743_list__update_Osimps_I1_J,axiom,
    ! [A: $tType,I3: nat,V: A] :
      ( ( list_update @ A @ ( nil @ A ) @ I3 @ V )
      = ( nil @ A ) ) ).

% list_update.simps(1)
thf(fact_5744_concat_Osimps_I1_J,axiom,
    ! [A: $tType] :
      ( ( concat @ A @ ( nil @ ( list @ A ) ) )
      = ( nil @ A ) ) ).

% concat.simps(1)
thf(fact_5745_remove1_Osimps_I1_J,axiom,
    ! [A: $tType,X2: A] :
      ( ( remove1 @ A @ X2 @ ( nil @ A ) )
      = ( nil @ A ) ) ).

% remove1.simps(1)
thf(fact_5746_empty__set,axiom,
    ! [A: $tType] :
      ( ( bot_bot @ ( set @ A ) )
      = ( set2 @ A @ ( nil @ A ) ) ) ).

% empty_set
thf(fact_5747_list_Osize_I3_J,axiom,
    ! [A: $tType] :
      ( ( size_size @ ( list @ A ) @ ( nil @ A ) )
      = ( zero_zero @ nat ) ) ).

% list.size(3)
thf(fact_5748_replicate__0,axiom,
    ! [A: $tType,X2: A] :
      ( ( replicate @ A @ ( zero_zero @ nat ) @ X2 )
      = ( nil @ A ) ) ).

% replicate_0
thf(fact_5749_Gcd__int__greater__eq__0,axiom,
    ! [K5: set @ int] : ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( gcd_Gcd @ int @ K5 ) ) ).

% Gcd_int_greater_eq_0
thf(fact_5750_list_Osize__gen_I1_J,axiom,
    ! [A: $tType,X2: A > nat] :
      ( ( size_list @ A @ X2 @ ( nil @ A ) )
      = ( zero_zero @ nat ) ) ).

% list.size_gen(1)
thf(fact_5751_count__list_Osimps_I1_J,axiom,
    ! [A: $tType,Y2: A] :
      ( ( count_list @ A @ ( nil @ A ) @ Y2 )
      = ( zero_zero @ nat ) ) ).

% count_list.simps(1)
thf(fact_5752_Pow__set_I1_J,axiom,
    ! [A: $tType] :
      ( ( pow2 @ A @ ( set2 @ A @ ( nil @ A ) ) )
      = ( insert @ ( set @ A ) @ ( bot_bot @ ( set @ A ) ) @ ( bot_bot @ ( set @ ( set @ A ) ) ) ) ) ).

% Pow_set(1)
thf(fact_5753_in__set__product__lists__length,axiom,
    ! [A: $tType,Xs: list @ A,Xss: list @ ( list @ A )] :
      ( ( member @ ( list @ A ) @ Xs @ ( set2 @ ( list @ A ) @ ( product_lists @ A @ Xss ) ) )
     => ( ( size_size @ ( list @ A ) @ Xs )
        = ( size_size @ ( list @ ( list @ A ) ) @ Xss ) ) ) ).

% in_set_product_lists_length
thf(fact_5754_less__eq__int_Orep__eq,axiom,
    ( ( ord_less_eq @ int )
    = ( ^ [X5: int,Xa4: int] :
          ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > $o )
          @ ^ [Y5: nat,Z6: nat] :
              ( product_case_prod @ nat @ nat @ $o
              @ ^ [U2: nat,V5: nat] : ( ord_less_eq @ nat @ ( plus_plus @ nat @ Y5 @ V5 ) @ ( plus_plus @ nat @ U2 @ Z6 ) ) )
          @ ( rep_Integ @ X5 )
          @ ( rep_Integ @ Xa4 ) ) ) ) ).

% less_eq_int.rep_eq
thf(fact_5755_less__int_Orep__eq,axiom,
    ( ( ord_less @ int )
    = ( ^ [X5: int,Xa4: int] :
          ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > $o )
          @ ^ [Y5: nat,Z6: nat] :
              ( product_case_prod @ nat @ nat @ $o
              @ ^ [U2: nat,V5: nat] : ( ord_less @ nat @ ( plus_plus @ nat @ Y5 @ V5 ) @ ( plus_plus @ nat @ U2 @ Z6 ) ) )
          @ ( rep_Integ @ X5 )
          @ ( rep_Integ @ Xa4 ) ) ) ) ).

% less_int.rep_eq
thf(fact_5756_lex__prod__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( lex_prod @ A @ B )
      = ( ^ [Ra: set @ ( product_prod @ A @ A ),Rb: set @ ( product_prod @ B @ B )] :
            ( collect @ ( product_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) )
            @ ( product_case_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) @ $o
              @ ( product_case_prod @ A @ B @ ( ( product_prod @ A @ B ) > $o )
                @ ^ [A4: A,B4: B] :
                    ( product_case_prod @ A @ B @ $o
                    @ ^ [A9: A,B13: B] :
                        ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A4 @ A9 ) @ Ra )
                        | ( ( A4 = A9 )
                          & ( member @ ( product_prod @ B @ B ) @ ( product_Pair @ B @ B @ B4 @ B13 ) @ Rb ) ) ) ) ) ) ) ) ) ).

% lex_prod_def
thf(fact_5757_in__lex__prod,axiom,
    ! [A: $tType,B: $tType,A2: A,B2: B,A6: A,B6: B,R3: set @ ( product_prod @ A @ A ),S2: set @ ( product_prod @ B @ B )] :
      ( ( member @ ( product_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) ) @ ( product_Pair @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ A2 @ B2 ) @ ( product_Pair @ A @ B @ A6 @ B6 ) ) @ ( lex_prod @ A @ B @ R3 @ S2 ) )
      = ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ A6 ) @ R3 )
        | ( ( A2 = A6 )
          & ( member @ ( product_prod @ B @ B ) @ ( product_Pair @ B @ B @ B2 @ B6 ) @ S2 ) ) ) ) ).

% in_lex_prod
thf(fact_5758_listset_Osimps_I1_J,axiom,
    ! [A: $tType] :
      ( ( listset @ A @ ( nil @ ( set @ A ) ) )
      = ( insert @ ( list @ A ) @ ( nil @ A ) @ ( bot_bot @ ( set @ ( list @ A ) ) ) ) ) ).

% listset.simps(1)
thf(fact_5759_shuffles_Opsimps_I1_J,axiom,
    ! [A: $tType,Ys: list @ A] :
      ( ( accp @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( shuffles_rel @ A ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( nil @ A ) @ Ys ) )
     => ( ( shuffles @ A @ ( nil @ A ) @ Ys )
        = ( insert @ ( list @ A ) @ Ys @ ( bot_bot @ ( set @ ( list @ A ) ) ) ) ) ) ).

% shuffles.psimps(1)
thf(fact_5760_shuffles_Opsimps_I2_J,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( accp @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( shuffles_rel @ A ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ ( nil @ A ) ) )
     => ( ( shuffles @ A @ Xs @ ( nil @ A ) )
        = ( insert @ ( list @ A ) @ Xs @ ( bot_bot @ ( set @ ( list @ A ) ) ) ) ) ) ).

% shuffles.psimps(2)
thf(fact_5761_same__fst__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( same_fst @ A @ B )
      = ( ^ [P3: A > $o,R6: A > ( set @ ( product_prod @ B @ B ) )] :
            ( collect @ ( product_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) )
            @ ( product_case_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) @ $o
              @ ( product_case_prod @ A @ B @ ( ( product_prod @ A @ B ) > $o )
                @ ^ [X9: A,Y6: B] :
                    ( product_case_prod @ A @ B @ $o
                    @ ^ [X5: A,Y5: B] :
                        ( ( X9 = X5 )
                        & ( P3 @ X5 )
                        & ( member @ ( product_prod @ B @ B ) @ ( product_Pair @ B @ B @ Y6 @ Y5 ) @ ( R6 @ X5 ) ) ) ) ) ) ) ) ) ).

% same_fst_def
thf(fact_5762_uminus__int__def,axiom,
    ( ( uminus_uminus @ int )
    = ( map_fun @ int @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ int @ rep_Integ @ abs_Integ
      @ ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
        @ ^ [X5: nat,Y5: nat] : ( product_Pair @ nat @ nat @ Y5 @ X5 ) ) ) ) ).

% uminus_int_def
thf(fact_5763_eq__snd__iff,axiom,
    ! [A: $tType,B: $tType,B2: A,P4: product_prod @ B @ A] :
      ( ( B2
        = ( product_snd @ B @ A @ P4 ) )
      = ( ? [A4: B] :
            ( P4
            = ( product_Pair @ B @ A @ A4 @ B2 ) ) ) ) ).

% eq_snd_iff
thf(fact_5764_same__fstI,axiom,
    ! [B: $tType,A: $tType,P: A > $o,X2: A,Y7: B,Y2: B,R: A > ( set @ ( product_prod @ B @ B ) )] :
      ( ( P @ X2 )
     => ( ( member @ ( product_prod @ B @ B ) @ ( product_Pair @ B @ B @ Y7 @ Y2 ) @ ( R @ X2 ) )
       => ( member @ ( product_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) ) @ ( product_Pair @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X2 @ Y7 ) @ ( product_Pair @ A @ B @ X2 @ Y2 ) ) @ ( same_fst @ A @ B @ P @ R ) ) ) ) ).

% same_fstI
thf(fact_5765_sum_Osize__neq,axiom,
    ! [A: $tType,B: $tType,X2: sum_sum @ A @ B] :
      ( ( size_size @ ( sum_sum @ A @ B ) @ X2 )
     != ( zero_zero @ nat ) ) ).

% sum.size_neq
thf(fact_5766_prod_Osize__neq,axiom,
    ! [A: $tType,B: $tType,X2: product_prod @ A @ B] :
      ( ( size_size @ ( product_prod @ A @ B ) @ X2 )
     != ( zero_zero @ nat ) ) ).

% prod.size_neq
thf(fact_5767_eq__fst__iff,axiom,
    ! [A: $tType,B: $tType,A2: A,P4: product_prod @ A @ B] :
      ( ( A2
        = ( product_fst @ A @ B @ P4 ) )
      = ( ? [B4: B] :
            ( P4
            = ( product_Pair @ A @ B @ A2 @ B4 ) ) ) ) ).

% eq_fst_iff
thf(fact_5768_times__int__def,axiom,
    ( ( times_times @ int )
    = ( map_fun @ int @ ( product_prod @ nat @ nat ) @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) ) @ ( int > int ) @ rep_Integ @ ( map_fun @ int @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ int @ rep_Integ @ abs_Integ )
      @ ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) )
        @ ^ [X5: nat,Y5: nat] :
            ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
            @ ^ [U2: nat,V5: nat] : ( product_Pair @ nat @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ X5 @ U2 ) @ ( times_times @ nat @ Y5 @ V5 ) ) @ ( plus_plus @ nat @ ( times_times @ nat @ X5 @ V5 ) @ ( times_times @ nat @ Y5 @ U2 ) ) ) ) ) ) ) ).

% times_int_def
thf(fact_5769_minus__int__def,axiom,
    ( ( minus_minus @ int )
    = ( map_fun @ int @ ( product_prod @ nat @ nat ) @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) ) @ ( int > int ) @ rep_Integ @ ( map_fun @ int @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ int @ rep_Integ @ abs_Integ )
      @ ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) )
        @ ^ [X5: nat,Y5: nat] :
            ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
            @ ^ [U2: nat,V5: nat] : ( product_Pair @ nat @ nat @ ( plus_plus @ nat @ X5 @ V5 ) @ ( plus_plus @ nat @ Y5 @ U2 ) ) ) ) ) ) ).

% minus_int_def
thf(fact_5770_plus__int__def,axiom,
    ( ( plus_plus @ int )
    = ( map_fun @ int @ ( product_prod @ nat @ nat ) @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) ) @ ( int > int ) @ rep_Integ @ ( map_fun @ int @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ int @ rep_Integ @ abs_Integ )
      @ ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) )
        @ ^ [X5: nat,Y5: nat] :
            ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
            @ ^ [U2: nat,V5: nat] : ( product_Pair @ nat @ nat @ ( plus_plus @ nat @ X5 @ U2 ) @ ( plus_plus @ nat @ Y5 @ V5 ) ) ) ) ) ) ).

% plus_int_def
thf(fact_5771_insert__subsetI,axiom,
    ! [A: $tType,X2: A,A3: set @ A,X8: set @ A] :
      ( ( member @ A @ X2 @ A3 )
     => ( ( ord_less_eq @ ( set @ A ) @ X8 @ A3 )
       => ( ord_less_eq @ ( set @ A ) @ ( insert @ A @ X2 @ X8 ) @ A3 ) ) ) ).

% insert_subsetI
thf(fact_5772_listrel1__iff__update,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A,R3: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Ys ) @ ( listrel1 @ A @ R3 ) )
      = ( ? [Y5: A,N3: nat] :
            ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ ( nth @ A @ Xs @ N3 ) @ Y5 ) @ R3 )
            & ( ord_less @ nat @ N3 @ ( size_size @ ( list @ A ) @ Xs ) )
            & ( Ys
              = ( list_update @ A @ Xs @ N3 @ Y5 ) ) ) ) ) ).

% listrel1_iff_update
thf(fact_5773_eq__numeral__iff__iszero_I7_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [X2: num] :
          ( ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ X2 ) )
            = ( one_one @ A ) )
          = ( ring_1_iszero @ A @ ( numeral_numeral @ A @ ( plus_plus @ num @ X2 @ one2 ) ) ) ) ) ).

% eq_numeral_iff_iszero(7)
thf(fact_5774_iszero__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [W: num] :
          ( ( ring_1_iszero @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) )
          = ( ring_1_iszero @ A @ ( numeral_numeral @ A @ W ) ) ) ) ).

% iszero_neg_numeral
thf(fact_5775_iszero__0,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ( ring_1_iszero @ A @ ( zero_zero @ A ) ) ) ).

% iszero_0
thf(fact_5776_iszero__def,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ( ( ring_1_iszero @ A )
        = ( ^ [Z6: A] :
              ( Z6
              = ( zero_zero @ A ) ) ) ) ) ).

% iszero_def
thf(fact_5777_not__iszero__1,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ~ ( ring_1_iszero @ A @ ( one_one @ A ) ) ) ).

% not_iszero_1
thf(fact_5778_listrel1__mono,axiom,
    ! [A: $tType,R3: set @ ( product_prod @ A @ A ),S2: set @ ( product_prod @ A @ A )] :
      ( ( ord_less_eq @ ( set @ ( product_prod @ A @ A ) ) @ R3 @ S2 )
     => ( ord_less_eq @ ( set @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) ) @ ( listrel1 @ A @ R3 ) @ ( listrel1 @ A @ S2 ) ) ) ).

% listrel1_mono
thf(fact_5779_not__iszero__numeral,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [W: num] :
          ~ ( ring_1_iszero @ A @ ( numeral_numeral @ A @ W ) ) ) ).

% not_iszero_numeral
thf(fact_5780_eq__iff__iszero__diff,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ( ( ^ [Y3: A,Z2: A] : ( Y3 = Z2 ) )
        = ( ^ [X5: A,Y5: A] : ( ring_1_iszero @ A @ ( minus_minus @ A @ X5 @ Y5 ) ) ) ) ) ).

% eq_iff_iszero_diff
thf(fact_5781_not__Nil__listrel1,axiom,
    ! [A: $tType,Xs: list @ A,R3: set @ ( product_prod @ A @ A )] :
      ~ ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( nil @ A ) @ Xs ) @ ( listrel1 @ A @ R3 ) ) ).

% not_Nil_listrel1
thf(fact_5782_not__listrel1__Nil,axiom,
    ! [A: $tType,Xs: list @ A,R3: set @ ( product_prod @ A @ A )] :
      ~ ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ ( nil @ A ) ) @ ( listrel1 @ A @ R3 ) ) ).

% not_listrel1_Nil
thf(fact_5783_listrel1__eq__len,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A,R3: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Ys ) @ ( listrel1 @ A @ R3 ) )
     => ( ( size_size @ ( list @ A ) @ Xs )
        = ( size_size @ ( list @ A ) @ Ys ) ) ) ).

% listrel1_eq_len
thf(fact_5784_eq__numeral__iff__iszero_I9_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [X2: num] :
          ( ( ( numeral_numeral @ A @ X2 )
            = ( zero_zero @ A ) )
          = ( ring_1_iszero @ A @ ( numeral_numeral @ A @ X2 ) ) ) ) ).

% eq_numeral_iff_iszero(9)
thf(fact_5785_eq__numeral__iff__iszero_I10_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [Y2: num] :
          ( ( ( zero_zero @ A )
            = ( numeral_numeral @ A @ Y2 ) )
          = ( ring_1_iszero @ A @ ( numeral_numeral @ A @ Y2 ) ) ) ) ).

% eq_numeral_iff_iszero(10)
thf(fact_5786_not__iszero__Numeral1,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ~ ( ring_1_iszero @ A @ ( numeral_numeral @ A @ one2 ) ) ) ).

% not_iszero_Numeral1
thf(fact_5787_not__iszero__neg__1,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ~ ( ring_1_iszero @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% not_iszero_neg_1
thf(fact_5788_eq__numeral__iff__iszero_I1_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [X2: num,Y2: num] :
          ( ( ( numeral_numeral @ A @ X2 )
            = ( numeral_numeral @ A @ Y2 ) )
          = ( ring_1_iszero @ A @ ( neg_numeral_sub @ A @ X2 @ Y2 ) ) ) ) ).

% eq_numeral_iff_iszero(1)
thf(fact_5789_ssubst__Pair__rhs,axiom,
    ! [B: $tType,A: $tType,R3: A,S2: B,R: set @ ( product_prod @ A @ B ),S8: B] :
      ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ R3 @ S2 ) @ R )
     => ( ( S8 = S2 )
       => ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ R3 @ S8 ) @ R ) ) ) ).

% ssubst_Pair_rhs
thf(fact_5790_eq__numeral__iff__iszero_I11_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [X2: num] :
          ( ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ X2 ) )
            = ( zero_zero @ A ) )
          = ( ring_1_iszero @ A @ ( numeral_numeral @ A @ X2 ) ) ) ) ).

% eq_numeral_iff_iszero(11)
thf(fact_5791_eq__numeral__iff__iszero_I12_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [Y2: num] :
          ( ( ( zero_zero @ A )
            = ( uminus_uminus @ A @ ( numeral_numeral @ A @ Y2 ) ) )
          = ( ring_1_iszero @ A @ ( numeral_numeral @ A @ Y2 ) ) ) ) ).

% eq_numeral_iff_iszero(12)
thf(fact_5792_not__iszero__neg__Numeral1,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ~ ( ring_1_iszero @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ one2 ) ) ) ) ).

% not_iszero_neg_Numeral1
thf(fact_5793_eq__numeral__iff__iszero_I3_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [X2: num,Y2: num] :
          ( ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ X2 ) )
            = ( numeral_numeral @ A @ Y2 ) )
          = ( ring_1_iszero @ A @ ( numeral_numeral @ A @ ( plus_plus @ num @ X2 @ Y2 ) ) ) ) ) ).

% eq_numeral_iff_iszero(3)
thf(fact_5794_eq__numeral__iff__iszero_I2_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [X2: num,Y2: num] :
          ( ( ( numeral_numeral @ A @ X2 )
            = ( uminus_uminus @ A @ ( numeral_numeral @ A @ Y2 ) ) )
          = ( ring_1_iszero @ A @ ( numeral_numeral @ A @ ( plus_plus @ num @ X2 @ Y2 ) ) ) ) ) ).

% eq_numeral_iff_iszero(2)
thf(fact_5795_eq__numeral__iff__iszero_I4_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [X2: num,Y2: num] :
          ( ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ X2 ) )
            = ( uminus_uminus @ A @ ( numeral_numeral @ A @ Y2 ) ) )
          = ( ring_1_iszero @ A @ ( neg_numeral_sub @ A @ Y2 @ X2 ) ) ) ) ).

% eq_numeral_iff_iszero(4)
thf(fact_5796_Collect__restrict,axiom,
    ! [A: $tType,X8: set @ A,P: A > $o] :
      ( ord_less_eq @ ( set @ A )
      @ ( collect @ A
        @ ^ [X5: A] :
            ( ( member @ A @ X5 @ X8 )
            & ( P @ X5 ) ) )
      @ X8 ) ).

% Collect_restrict
thf(fact_5797_prop__restrict,axiom,
    ! [A: $tType,X2: A,Z8: set @ A,X8: set @ A,P: A > $o] :
      ( ( member @ A @ X2 @ Z8 )
     => ( ( ord_less_eq @ ( set @ A ) @ Z8
          @ ( collect @ A
            @ ^ [X5: A] :
                ( ( member @ A @ X5 @ X8 )
                & ( P @ X5 ) ) ) )
       => ( P @ X2 ) ) ) ).

% prop_restrict
thf(fact_5798_eq__numeral__iff__iszero_I5_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [X2: num] :
          ( ( ( numeral_numeral @ A @ X2 )
            = ( one_one @ A ) )
          = ( ring_1_iszero @ A @ ( neg_numeral_sub @ A @ X2 @ one2 ) ) ) ) ).

% eq_numeral_iff_iszero(5)
thf(fact_5799_eq__numeral__iff__iszero_I6_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [Y2: num] :
          ( ( ( one_one @ A )
            = ( numeral_numeral @ A @ Y2 ) )
          = ( ring_1_iszero @ A @ ( neg_numeral_sub @ A @ one2 @ Y2 ) ) ) ) ).

% eq_numeral_iff_iszero(6)
thf(fact_5800_subset__emptyI,axiom,
    ! [A: $tType,A3: set @ A] :
      ( ! [X3: A] :
          ~ ( member @ A @ X3 @ A3 )
     => ( ord_less_eq @ ( set @ A ) @ A3 @ ( bot_bot @ ( set @ A ) ) ) ) ).

% subset_emptyI
thf(fact_5801_eq__numeral__iff__iszero_I8_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [Y2: num] :
          ( ( ( one_one @ A )
            = ( uminus_uminus @ A @ ( numeral_numeral @ A @ Y2 ) ) )
          = ( ring_1_iszero @ A @ ( numeral_numeral @ A @ ( plus_plus @ num @ one2 @ Y2 ) ) ) ) ) ).

% eq_numeral_iff_iszero(8)
thf(fact_5802_listrel1p__def,axiom,
    ! [A: $tType] :
      ( ( listrel1p @ A )
      = ( ^ [R5: A > A > $o,Xs3: list @ A,Ys3: list @ A] : ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs3 @ Ys3 ) @ ( listrel1 @ A @ ( collect @ ( product_prod @ A @ A ) @ ( product_case_prod @ A @ A @ $o @ R5 ) ) ) ) ) ) ).

% listrel1p_def
thf(fact_5803_num__of__nat_Osimps_I2_J,axiom,
    ! [N2: nat] :
      ( ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
       => ( ( num_of_nat @ ( suc @ N2 ) )
          = ( inc @ ( num_of_nat @ N2 ) ) ) )
      & ( ~ ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
       => ( ( num_of_nat @ ( suc @ N2 ) )
          = one2 ) ) ) ).

% num_of_nat.simps(2)
thf(fact_5804_pred__nat__def,axiom,
    ( pred_nat
    = ( collect @ ( product_prod @ nat @ nat )
      @ ( product_case_prod @ nat @ nat @ $o
        @ ^ [M6: nat,N3: nat] :
            ( N3
            = ( suc @ M6 ) ) ) ) ) ).

% pred_nat_def
thf(fact_5805_num__of__nat__numeral__eq,axiom,
    ! [Q3: num] :
      ( ( num_of_nat @ ( numeral_numeral @ nat @ Q3 ) )
      = Q3 ) ).

% num_of_nat_numeral_eq
thf(fact_5806_num__of__nat_Osimps_I1_J,axiom,
    ( ( num_of_nat @ ( zero_zero @ nat ) )
    = one2 ) ).

% num_of_nat.simps(1)
thf(fact_5807_numeral__num__of__nat,axiom,
    ! [N2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( numeral_numeral @ nat @ ( num_of_nat @ N2 ) )
        = N2 ) ) ).

% numeral_num_of_nat
thf(fact_5808_num__of__nat__One,axiom,
    ! [N2: nat] :
      ( ( ord_less_eq @ nat @ N2 @ ( one_one @ nat ) )
     => ( ( num_of_nat @ N2 )
        = one2 ) ) ).

% num_of_nat_One
thf(fact_5809_numeral__num__of__nat__unfold,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [N2: nat] :
          ( ( ( N2
              = ( zero_zero @ nat ) )
           => ( ( numeral_numeral @ A @ ( num_of_nat @ N2 ) )
              = ( one_one @ A ) ) )
          & ( ( N2
             != ( zero_zero @ nat ) )
           => ( ( numeral_numeral @ A @ ( num_of_nat @ N2 ) )
              = ( semiring_1_of_nat @ A @ N2 ) ) ) ) ) ).

% numeral_num_of_nat_unfold
thf(fact_5810_num__of__nat__double,axiom,
    ! [N2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( num_of_nat @ ( plus_plus @ nat @ N2 @ N2 ) )
        = ( bit0 @ ( num_of_nat @ N2 ) ) ) ) ).

% num_of_nat_double
thf(fact_5811_num__of__nat__plus__distrib,axiom,
    ! [M: nat,N2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
       => ( ( num_of_nat @ ( plus_plus @ nat @ M @ N2 ) )
          = ( plus_plus @ num @ ( num_of_nat @ M ) @ ( num_of_nat @ N2 ) ) ) ) ) ).

% num_of_nat_plus_distrib
thf(fact_5812_prod_Oinsert_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [I6: set @ B,P4: B > A,I3: B] :
          ( ( finite_finite @ B
            @ ( collect @ B
              @ ^ [X5: B] :
                  ( ( member @ B @ X5 @ I6 )
                  & ( ( P4 @ X5 )
                   != ( one_one @ A ) ) ) ) )
         => ( ( ( member @ B @ I3 @ I6 )
             => ( ( groups1962203154675924110t_prod @ B @ A @ P4 @ ( insert @ B @ I3 @ I6 ) )
                = ( groups1962203154675924110t_prod @ B @ A @ P4 @ I6 ) ) )
            & ( ~ ( member @ B @ I3 @ I6 )
             => ( ( groups1962203154675924110t_prod @ B @ A @ P4 @ ( insert @ B @ I3 @ I6 ) )
                = ( times_times @ A @ ( P4 @ I3 ) @ ( groups1962203154675924110t_prod @ B @ A @ P4 @ I6 ) ) ) ) ) ) ) ).

% prod.insert'
thf(fact_5813_sorted__list__of__set_Osorted__key__list__of__set__remove,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A,X2: A] :
          ( ( finite_finite @ A @ A3 )
         => ( ( linord4507533701916653071of_set @ A @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X2 @ ( bot_bot @ ( set @ A ) ) ) ) )
            = ( remove1 @ A @ X2 @ ( linord4507533701916653071of_set @ A @ A3 ) ) ) ) ) ).

% sorted_list_of_set.sorted_key_list_of_set_remove
thf(fact_5814_pow_Osimps_I3_J,axiom,
    ! [X2: num,Y2: num] :
      ( ( pow @ X2 @ ( bit1 @ Y2 ) )
      = ( times_times @ num @ ( sqr @ ( pow @ X2 @ Y2 ) ) @ X2 ) ) ).

% pow.simps(3)
thf(fact_5815_sorted__list__of__set_Osorted__key__list__of__set__empty,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( ( linord4507533701916653071of_set @ A @ ( bot_bot @ ( set @ A ) ) )
        = ( nil @ A ) ) ) ).

% sorted_list_of_set.sorted_key_list_of_set_empty
thf(fact_5816_sorted__list__of__set_Ofold__insort__key_Oinfinite,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A] :
          ( ~ ( finite_finite @ A @ A3 )
         => ( ( linord4507533701916653071of_set @ A @ A3 )
            = ( nil @ A ) ) ) ) ).

% sorted_list_of_set.fold_insort_key.infinite
thf(fact_5817_sorted__list__of__set_Oset__sorted__key__list__of__set,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A] :
          ( ( finite_finite @ A @ A3 )
         => ( ( set2 @ A @ ( linord4507533701916653071of_set @ A @ A3 ) )
            = A3 ) ) ) ).

% sorted_list_of_set.set_sorted_key_list_of_set
thf(fact_5818_prod_Oempty_H,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [P4: B > A] :
          ( ( groups1962203154675924110t_prod @ B @ A @ P4 @ ( bot_bot @ ( set @ B ) ) )
          = ( one_one @ A ) ) ) ).

% prod.empty'
thf(fact_5819_sorted__list__of__set_Olength__sorted__key__list__of__set,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A] :
          ( ( size_size @ ( list @ A ) @ ( linord4507533701916653071of_set @ A @ A3 ) )
          = ( finite_card @ A @ A3 ) ) ) ).

% sorted_list_of_set.length_sorted_key_list_of_set
thf(fact_5820_sorted__list__of__set_Osorted__key__list__of__set__eq__Nil__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A] :
          ( ( finite_finite @ A @ A3 )
         => ( ( ( linord4507533701916653071of_set @ A @ A3 )
              = ( nil @ A ) )
            = ( A3
              = ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% sorted_list_of_set.sorted_key_list_of_set_eq_Nil_iff
thf(fact_5821_sqr_Osimps_I2_J,axiom,
    ! [N2: num] :
      ( ( sqr @ ( bit0 @ N2 ) )
      = ( bit0 @ ( bit0 @ ( sqr @ N2 ) ) ) ) ).

% sqr.simps(2)
thf(fact_5822_sqr_Osimps_I1_J,axiom,
    ( ( sqr @ one2 )
    = one2 ) ).

% sqr.simps(1)
thf(fact_5823_prod_Onon__neutral_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: B > A,I6: set @ B] :
          ( ( groups1962203154675924110t_prod @ B @ A @ G
            @ ( collect @ B
              @ ^ [X5: B] :
                  ( ( member @ B @ X5 @ I6 )
                  & ( ( G @ X5 )
                   != ( one_one @ A ) ) ) ) )
          = ( groups1962203154675924110t_prod @ B @ A @ G @ I6 ) ) ) ).

% prod.non_neutral'
thf(fact_5824_sorted__list__of__set_Osorted__key__list__of__set__inject,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A,B3: set @ A] :
          ( ( ( linord4507533701916653071of_set @ A @ A3 )
            = ( linord4507533701916653071of_set @ A @ B3 ) )
         => ( ( finite_finite @ A @ A3 )
           => ( ( finite_finite @ A @ B3 )
             => ( A3 = B3 ) ) ) ) ) ).

% sorted_list_of_set.sorted_key_list_of_set_inject
thf(fact_5825_sorted__list__of__set_Odistinct__sorted__key__list__of__set,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A] : ( distinct @ A @ ( linord4507533701916653071of_set @ A @ A3 ) ) ) ).

% sorted_list_of_set.distinct_sorted_key_list_of_set
thf(fact_5826_sqr__conv__mult,axiom,
    ( sqr
    = ( ^ [X5: num] : ( times_times @ num @ X5 @ X5 ) ) ) ).

% sqr_conv_mult
thf(fact_5827_prod_Odistrib__triv_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [I6: set @ B,G: B > A,H2: B > A] :
          ( ( finite_finite @ B @ I6 )
         => ( ( groups1962203154675924110t_prod @ B @ A
              @ ^ [I4: B] : ( times_times @ A @ ( G @ I4 ) @ ( H2 @ I4 ) )
              @ I6 )
            = ( times_times @ A @ ( groups1962203154675924110t_prod @ B @ A @ G @ I6 ) @ ( groups1962203154675924110t_prod @ B @ A @ H2 @ I6 ) ) ) ) ) ).

% prod.distrib_triv'
thf(fact_5828_numeral__sqr,axiom,
    ! [A: $tType] :
      ( ( semiring_numeral @ A )
     => ! [K: num] :
          ( ( numeral_numeral @ A @ ( sqr @ K ) )
          = ( times_times @ A @ ( numeral_numeral @ A @ K ) @ ( numeral_numeral @ A @ K ) ) ) ) ).

% numeral_sqr
thf(fact_5829_prod_Omono__neutral__cong__right_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [S3: set @ B,T6: set @ B,G: B > A,H2: B > A] :
          ( ( ord_less_eq @ ( set @ B ) @ S3 @ T6 )
         => ( ! [X3: B] :
                ( ( member @ B @ X3 @ ( minus_minus @ ( set @ B ) @ T6 @ S3 ) )
               => ( ( G @ X3 )
                  = ( one_one @ A ) ) )
           => ( ! [X3: B] :
                  ( ( member @ B @ X3 @ S3 )
                 => ( ( G @ X3 )
                    = ( H2 @ X3 ) ) )
             => ( ( groups1962203154675924110t_prod @ B @ A @ G @ T6 )
                = ( groups1962203154675924110t_prod @ B @ A @ H2 @ S3 ) ) ) ) ) ) ).

% prod.mono_neutral_cong_right'
thf(fact_5830_prod_Omono__neutral__cong__left_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [S3: set @ B,T6: set @ B,H2: B > A,G: B > A] :
          ( ( ord_less_eq @ ( set @ B ) @ S3 @ T6 )
         => ( ! [I2: B] :
                ( ( member @ B @ I2 @ ( minus_minus @ ( set @ B ) @ T6 @ S3 ) )
               => ( ( H2 @ I2 )
                  = ( one_one @ A ) ) )
           => ( ! [X3: B] :
                  ( ( member @ B @ X3 @ S3 )
                 => ( ( G @ X3 )
                    = ( H2 @ X3 ) ) )
             => ( ( groups1962203154675924110t_prod @ B @ A @ G @ S3 )
                = ( groups1962203154675924110t_prod @ B @ A @ H2 @ T6 ) ) ) ) ) ) ).

% prod.mono_neutral_cong_left'
thf(fact_5831_prod_Omono__neutral__right_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [S3: set @ B,T6: set @ B,G: B > A] :
          ( ( ord_less_eq @ ( set @ B ) @ S3 @ T6 )
         => ( ! [X3: B] :
                ( ( member @ B @ X3 @ ( minus_minus @ ( set @ B ) @ T6 @ S3 ) )
               => ( ( G @ X3 )
                  = ( one_one @ A ) ) )
           => ( ( groups1962203154675924110t_prod @ B @ A @ G @ T6 )
              = ( groups1962203154675924110t_prod @ B @ A @ G @ S3 ) ) ) ) ) ).

% prod.mono_neutral_right'
thf(fact_5832_prod_Omono__neutral__left_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [S3: set @ B,T6: set @ B,G: B > A] :
          ( ( ord_less_eq @ ( set @ B ) @ S3 @ T6 )
         => ( ! [X3: B] :
                ( ( member @ B @ X3 @ ( minus_minus @ ( set @ B ) @ T6 @ S3 ) )
               => ( ( G @ X3 )
                  = ( one_one @ A ) ) )
           => ( ( groups1962203154675924110t_prod @ B @ A @ G @ S3 )
              = ( groups1962203154675924110t_prod @ B @ A @ G @ T6 ) ) ) ) ) ).

% prod.mono_neutral_left'
thf(fact_5833_prod_Odistrib_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [I6: set @ B,G: B > A,H2: B > A] :
          ( ( finite_finite @ B
            @ ( collect @ B
              @ ^ [X5: B] :
                  ( ( member @ B @ X5 @ I6 )
                  & ( ( G @ X5 )
                   != ( one_one @ A ) ) ) ) )
         => ( ( finite_finite @ B
              @ ( collect @ B
                @ ^ [X5: B] :
                    ( ( member @ B @ X5 @ I6 )
                    & ( ( H2 @ X5 )
                     != ( one_one @ A ) ) ) ) )
           => ( ( groups1962203154675924110t_prod @ B @ A
                @ ^ [I4: B] : ( times_times @ A @ ( G @ I4 ) @ ( H2 @ I4 ) )
                @ I6 )
              = ( times_times @ A @ ( groups1962203154675924110t_prod @ B @ A @ G @ I6 ) @ ( groups1962203154675924110t_prod @ B @ A @ H2 @ I6 ) ) ) ) ) ) ).

% prod.distrib'
thf(fact_5834_prod_OG__def,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ( ( groups1962203154675924110t_prod @ B @ A )
        = ( ^ [P6: B > A,I8: set @ B] :
              ( if @ A
              @ ( finite_finite @ B
                @ ( collect @ B
                  @ ^ [X5: B] :
                      ( ( member @ B @ X5 @ I8 )
                      & ( ( P6 @ X5 )
                       != ( one_one @ A ) ) ) ) )
              @ ( groups7121269368397514597t_prod @ B @ A @ P6
                @ ( collect @ B
                  @ ^ [X5: B] :
                      ( ( member @ B @ X5 @ I8 )
                      & ( ( P6 @ X5 )
                       != ( one_one @ A ) ) ) ) )
              @ ( one_one @ A ) ) ) ) ) ).

% prod.G_def
thf(fact_5835_pow_Osimps_I2_J,axiom,
    ! [X2: num,Y2: num] :
      ( ( pow @ X2 @ ( bit0 @ Y2 ) )
      = ( sqr @ ( pow @ X2 @ Y2 ) ) ) ).

% pow.simps(2)
thf(fact_5836_sqr_Osimps_I3_J,axiom,
    ! [N2: num] :
      ( ( sqr @ ( bit1 @ N2 ) )
      = ( bit1 @ ( bit0 @ ( plus_plus @ num @ ( sqr @ N2 ) @ N2 ) ) ) ) ).

% sqr.simps(3)
thf(fact_5837_sorted__list__of__set_Osorted__key__list__of__set__insert__remove,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A,X2: A] :
          ( ( finite_finite @ A @ A3 )
         => ( ( linord4507533701916653071of_set @ A @ ( insert @ A @ X2 @ A3 ) )
            = ( linorder_insort_key @ A @ A
              @ ^ [X5: A] : X5
              @ X2
              @ ( linord4507533701916653071of_set @ A @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X2 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ) ).

% sorted_list_of_set.sorted_key_list_of_set_insert_remove
thf(fact_5838_sorted__list__of__set__def,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( ( linord4507533701916653071of_set @ A )
        = ( linord144544945434240204of_set @ A @ A
          @ ^ [X5: A] : X5 ) ) ) ).

% sorted_list_of_set_def
thf(fact_5839_integer__of__num__triv_I2_J,axiom,
    ( ( code_integer_of_num @ ( bit0 @ one2 ) )
    = ( numeral_numeral @ code_integer @ ( bit0 @ one2 ) ) ) ).

% integer_of_num_triv(2)
thf(fact_5840_remove1__insort__key,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [X2: B,F2: B > A,Xs: list @ B] :
          ( ( remove1 @ B @ X2 @ ( linorder_insort_key @ B @ A @ F2 @ X2 @ Xs ) )
          = Xs ) ) ).

% remove1_insort_key
thf(fact_5841_length__insort,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F2: B > A,X2: B,Xs: list @ B] :
          ( ( size_size @ ( list @ B ) @ ( linorder_insort_key @ B @ A @ F2 @ X2 @ Xs ) )
          = ( suc @ ( size_size @ ( list @ B ) @ Xs ) ) ) ) ).

% length_insort
thf(fact_5842_sorted__list__of__set_Osorted__key__list__of__set__insert,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A,X2: A] :
          ( ( finite_finite @ A @ A3 )
         => ( ~ ( member @ A @ X2 @ A3 )
           => ( ( linord4507533701916653071of_set @ A @ ( insert @ A @ X2 @ A3 ) )
              = ( linorder_insort_key @ A @ A
                @ ^ [X5: A] : X5
                @ X2
                @ ( linord4507533701916653071of_set @ A @ A3 ) ) ) ) ) ) ).

% sorted_list_of_set.sorted_key_list_of_set_insert
thf(fact_5843_insort__key__left__comm,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F2: B > A,X2: B,Y2: B,Xs: list @ B] :
          ( ( ( F2 @ X2 )
           != ( F2 @ Y2 ) )
         => ( ( linorder_insort_key @ B @ A @ F2 @ Y2 @ ( linorder_insort_key @ B @ A @ F2 @ X2 @ Xs ) )
            = ( linorder_insort_key @ B @ A @ F2 @ X2 @ ( linorder_insort_key @ B @ A @ F2 @ Y2 @ Xs ) ) ) ) ) ).

% insort_key_left_comm
thf(fact_5844_insort__left__comm,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X2: A,Y2: A,Xs: list @ A] :
          ( ( linorder_insort_key @ A @ A
            @ ^ [X5: A] : X5
            @ X2
            @ ( linorder_insort_key @ A @ A
              @ ^ [X5: A] : X5
              @ Y2
              @ Xs ) )
          = ( linorder_insort_key @ A @ A
            @ ^ [X5: A] : X5
            @ Y2
            @ ( linorder_insort_key @ A @ A
              @ ^ [X5: A] : X5
              @ X2
              @ Xs ) ) ) ) ).

% insort_left_comm
thf(fact_5845_sorted__list__of__set_Ofold__insort__key_Ocomp__fun__commute__on,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Y2: A,X2: A] :
          ( ( comp @ ( list @ A ) @ ( list @ A ) @ ( list @ A )
            @ ( linorder_insort_key @ A @ A
              @ ^ [X5: A] : X5
              @ Y2 )
            @ ( linorder_insort_key @ A @ A
              @ ^ [X5: A] : X5
              @ X2 ) )
          = ( comp @ ( list @ A ) @ ( list @ A ) @ ( list @ A )
            @ ( linorder_insort_key @ A @ A
              @ ^ [X5: A] : X5
              @ X2 )
            @ ( linorder_insort_key @ A @ A
              @ ^ [X5: A] : X5
              @ Y2 ) ) ) ) ).

% sorted_list_of_set.fold_insort_key.comp_fun_commute_on
thf(fact_5846_insort__not__Nil,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F2: B > A,A2: B,Xs: list @ B] :
          ( ( linorder_insort_key @ B @ A @ F2 @ A2 @ Xs )
         != ( nil @ B ) ) ) ).

% insort_not_Nil
thf(fact_5847_set__insort__key,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F2: B > A,X2: B,Xs: list @ B] :
          ( ( set2 @ B @ ( linorder_insort_key @ B @ A @ F2 @ X2 @ Xs ) )
          = ( insert @ B @ X2 @ ( set2 @ B @ Xs ) ) ) ) ).

% set_insort_key
thf(fact_5848_distinct__insort,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F2: B > A,X2: B,Xs: list @ B] :
          ( ( distinct @ B @ ( linorder_insort_key @ B @ A @ F2 @ X2 @ Xs ) )
          = ( ~ ( member @ B @ X2 @ ( set2 @ B @ Xs ) )
            & ( distinct @ B @ Xs ) ) ) ) ).

% distinct_insort
thf(fact_5849_integer__of__num__def,axiom,
    ( code_integer_of_num
    = ( numeral_numeral @ code_integer ) ) ).

% integer_of_num_def
thf(fact_5850_integer__of__num__triv_I1_J,axiom,
    ( ( code_integer_of_num @ one2 )
    = ( one_one @ code_integer ) ) ).

% integer_of_num_triv(1)
thf(fact_5851_integer__of__num_I2_J,axiom,
    ! [N2: num] :
      ( ( code_integer_of_num @ ( bit0 @ N2 ) )
      = ( plus_plus @ code_integer @ ( code_integer_of_num @ N2 ) @ ( code_integer_of_num @ N2 ) ) ) ).

% integer_of_num(2)
thf(fact_5852_sorted__list__of__set_Ofold__insort__key_Oremove,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A,X2: A] :
          ( ( finite_finite @ A @ A3 )
         => ( ( member @ A @ X2 @ A3 )
           => ( ( linord4507533701916653071of_set @ A @ A3 )
              = ( linorder_insort_key @ A @ A
                @ ^ [X5: A] : X5
                @ X2
                @ ( linord4507533701916653071of_set @ A @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X2 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ) ) ).

% sorted_list_of_set.fold_insort_key.remove
thf(fact_5853_image__minus__const__atLeastLessThan__nat,axiom,
    ! [C2: nat,Y2: nat,X2: nat] :
      ( ( ( ord_less @ nat @ C2 @ Y2 )
       => ( ( image @ nat @ nat
            @ ^ [I4: nat] : ( minus_minus @ nat @ I4 @ C2 )
            @ ( set_or7035219750837199246ssThan @ nat @ X2 @ Y2 ) )
          = ( set_or7035219750837199246ssThan @ nat @ ( minus_minus @ nat @ X2 @ C2 ) @ ( minus_minus @ nat @ Y2 @ C2 ) ) ) )
      & ( ~ ( ord_less @ nat @ C2 @ Y2 )
       => ( ( ( ord_less @ nat @ X2 @ Y2 )
           => ( ( image @ nat @ nat
                @ ^ [I4: nat] : ( minus_minus @ nat @ I4 @ C2 )
                @ ( set_or7035219750837199246ssThan @ nat @ X2 @ Y2 ) )
              = ( insert @ nat @ ( zero_zero @ nat ) @ ( bot_bot @ ( set @ nat ) ) ) ) )
          & ( ~ ( ord_less @ nat @ X2 @ Y2 )
           => ( ( image @ nat @ nat
                @ ^ [I4: nat] : ( minus_minus @ nat @ I4 @ C2 )
                @ ( set_or7035219750837199246ssThan @ nat @ X2 @ Y2 ) )
              = ( bot_bot @ ( set @ nat ) ) ) ) ) ) ) ).

% image_minus_const_atLeastLessThan_nat
thf(fact_5854_rat__floor__lemma,axiom,
    ! [A2: int,B2: int] :
      ( ( ord_less_eq @ rat @ ( ring_1_of_int @ rat @ ( divide_divide @ int @ A2 @ B2 ) ) @ ( fract @ A2 @ B2 ) )
      & ( ord_less @ rat @ ( fract @ A2 @ B2 ) @ ( ring_1_of_int @ rat @ ( plus_plus @ int @ ( divide_divide @ int @ A2 @ B2 ) @ ( one_one @ int ) ) ) ) ) ).

% rat_floor_lemma
thf(fact_5855_sorted__key__list__of__set__def,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ( ( linord144544945434240204of_set @ B @ A )
        = ( ^ [F5: B > A] : ( finite_folding_F @ B @ ( list @ B ) @ ( linorder_insort_key @ B @ A @ F5 ) @ ( nil @ B ) ) ) ) ) ).

% sorted_key_list_of_set_def
thf(fact_5856_bij__betw__Suc,axiom,
    ! [M7: set @ nat,N4: set @ nat] :
      ( ( bij_betw @ nat @ nat @ suc @ M7 @ N4 )
      = ( ( image @ nat @ nat @ suc @ M7 )
        = N4 ) ) ).

% bij_betw_Suc
thf(fact_5857_image__add__0,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [S3: set @ A] :
          ( ( image @ A @ A @ ( plus_plus @ A @ ( zero_zero @ A ) ) @ S3 )
          = S3 ) ) ).

% image_add_0
thf(fact_5858_image__add__atLeastAtMost,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [K: A,I3: A,J: A] :
          ( ( image @ A @ A @ ( plus_plus @ A @ K ) @ ( set_or1337092689740270186AtMost @ A @ I3 @ J ) )
          = ( set_or1337092689740270186AtMost @ A @ ( plus_plus @ A @ I3 @ K ) @ ( plus_plus @ A @ J @ K ) ) ) ) ).

% image_add_atLeastAtMost
thf(fact_5859_image__add__atLeastLessThan,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [K: A,I3: A,J: A] :
          ( ( image @ A @ A @ ( plus_plus @ A @ K ) @ ( set_or7035219750837199246ssThan @ A @ I3 @ J ) )
          = ( set_or7035219750837199246ssThan @ A @ ( plus_plus @ A @ I3 @ K ) @ ( plus_plus @ A @ J @ K ) ) ) ) ).

% image_add_atLeastLessThan
thf(fact_5860_image__add__atMost,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [C2: A,A2: A] :
          ( ( image @ A @ A @ ( plus_plus @ A @ C2 ) @ ( set_ord_atMost @ A @ A2 ) )
          = ( set_ord_atMost @ A @ ( plus_plus @ A @ C2 @ A2 ) ) ) ) ).

% image_add_atMost
thf(fact_5861_bij__betw__add,axiom,
    ! [A: $tType] :
      ( ( cancel_semigroup_add @ A )
     => ! [A2: A,A3: set @ A,B3: set @ A] :
          ( ( bij_betw @ A @ A @ ( plus_plus @ A @ A2 ) @ A3 @ B3 )
          = ( ( image @ A @ A @ ( plus_plus @ A @ A2 ) @ A3 )
            = B3 ) ) ) ).

% bij_betw_add
thf(fact_5862_image__Suc__atLeastAtMost,axiom,
    ! [I3: nat,J: nat] :
      ( ( image @ nat @ nat @ suc @ ( set_or1337092689740270186AtMost @ nat @ I3 @ J ) )
      = ( set_or1337092689740270186AtMost @ nat @ ( suc @ I3 ) @ ( suc @ J ) ) ) ).

% image_Suc_atLeastAtMost
thf(fact_5863_image__Suc__atLeastLessThan,axiom,
    ! [I3: nat,J: nat] :
      ( ( image @ nat @ nat @ suc @ ( set_or7035219750837199246ssThan @ nat @ I3 @ J ) )
      = ( set_or7035219750837199246ssThan @ nat @ ( suc @ I3 ) @ ( suc @ J ) ) ) ).

% image_Suc_atLeastLessThan
thf(fact_5864_image__add__atLeastAtMost_H,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [K: A,I3: A,J: A] :
          ( ( image @ A @ A
            @ ^ [N3: A] : ( plus_plus @ A @ N3 @ K )
            @ ( set_or1337092689740270186AtMost @ A @ I3 @ J ) )
          = ( set_or1337092689740270186AtMost @ A @ ( plus_plus @ A @ I3 @ K ) @ ( plus_plus @ A @ J @ K ) ) ) ) ).

% image_add_atLeastAtMost'
thf(fact_5865_image__add__atLeastLessThan_H,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [K: A,I3: A,J: A] :
          ( ( image @ A @ A
            @ ^ [N3: A] : ( plus_plus @ A @ N3 @ K )
            @ ( set_or7035219750837199246ssThan @ A @ I3 @ J ) )
          = ( set_or7035219750837199246ssThan @ A @ ( plus_plus @ A @ I3 @ K ) @ ( plus_plus @ A @ J @ K ) ) ) ) ).

% image_add_atLeastLessThan'
thf(fact_5866_mult__rat,axiom,
    ! [A2: int,B2: int,C2: int,D2: int] :
      ( ( times_times @ rat @ ( fract @ A2 @ B2 ) @ ( fract @ C2 @ D2 ) )
      = ( fract @ ( times_times @ int @ A2 @ C2 ) @ ( times_times @ int @ B2 @ D2 ) ) ) ).

% mult_rat
thf(fact_5867_divide__rat,axiom,
    ! [A2: int,B2: int,C2: int,D2: int] :
      ( ( divide_divide @ rat @ ( fract @ A2 @ B2 ) @ ( fract @ C2 @ D2 ) )
      = ( fract @ ( times_times @ int @ A2 @ D2 ) @ ( times_times @ int @ B2 @ C2 ) ) ) ).

% divide_rat
thf(fact_5868_floor__Fract,axiom,
    ! [A2: int,B2: int] :
      ( ( archim6421214686448440834_floor @ rat @ ( fract @ A2 @ B2 ) )
      = ( divide_divide @ int @ A2 @ B2 ) ) ).

% floor_Fract
thf(fact_5869_INF__eq__bot__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comple5582772986160207858norder @ A )
     => ! [F2: B > A,A3: set @ B] :
          ( ( ( complete_Inf_Inf @ A @ ( image @ B @ A @ F2 @ A3 ) )
            = ( bot_bot @ A ) )
          = ( ! [X5: A] :
                ( ( ord_less @ A @ ( bot_bot @ A ) @ X5 )
               => ? [Y5: B] :
                    ( ( member @ B @ Y5 @ A3 )
                    & ( ord_less @ A @ ( F2 @ Y5 ) @ X5 ) ) ) ) ) ) ).

% INF_eq_bot_iff
thf(fact_5870_image__mult__atLeastAtMost,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [D2: A,A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ D2 )
         => ( ( image @ A @ A @ ( times_times @ A @ D2 ) @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) )
            = ( set_or1337092689740270186AtMost @ A @ ( times_times @ A @ D2 @ A2 ) @ ( times_times @ A @ D2 @ B2 ) ) ) ) ) ).

% image_mult_atLeastAtMost
thf(fact_5871_image__divide__atLeastAtMost,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [D2: A,A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ D2 )
         => ( ( image @ A @ A
              @ ^ [C4: A] : ( divide_divide @ A @ C4 @ D2 )
              @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) )
            = ( set_or1337092689740270186AtMost @ A @ ( divide_divide @ A @ A2 @ D2 ) @ ( divide_divide @ A @ B2 @ D2 ) ) ) ) ) ).

% image_divide_atLeastAtMost
thf(fact_5872_less__rat,axiom,
    ! [B2: int,D2: int,A2: int,C2: int] :
      ( ( B2
       != ( zero_zero @ int ) )
     => ( ( D2
         != ( zero_zero @ int ) )
       => ( ( ord_less @ rat @ ( fract @ A2 @ B2 ) @ ( fract @ C2 @ D2 ) )
          = ( ord_less @ int @ ( times_times @ int @ ( times_times @ int @ A2 @ D2 ) @ ( times_times @ int @ B2 @ D2 ) ) @ ( times_times @ int @ ( times_times @ int @ C2 @ B2 ) @ ( times_times @ int @ B2 @ D2 ) ) ) ) ) ) ).

% less_rat
thf(fact_5873_add__rat,axiom,
    ! [B2: int,D2: int,A2: int,C2: int] :
      ( ( B2
       != ( zero_zero @ int ) )
     => ( ( D2
         != ( zero_zero @ int ) )
       => ( ( plus_plus @ rat @ ( fract @ A2 @ B2 ) @ ( fract @ C2 @ D2 ) )
          = ( fract @ ( plus_plus @ int @ ( times_times @ int @ A2 @ D2 ) @ ( times_times @ int @ C2 @ B2 ) ) @ ( times_times @ int @ B2 @ D2 ) ) ) ) ) ).

% add_rat
thf(fact_5874_le__rat,axiom,
    ! [B2: int,D2: int,A2: int,C2: int] :
      ( ( B2
       != ( zero_zero @ int ) )
     => ( ( D2
         != ( zero_zero @ int ) )
       => ( ( ord_less_eq @ rat @ ( fract @ A2 @ B2 ) @ ( fract @ C2 @ D2 ) )
          = ( ord_less_eq @ int @ ( times_times @ int @ ( times_times @ int @ A2 @ D2 ) @ ( times_times @ int @ B2 @ D2 ) ) @ ( times_times @ int @ ( times_times @ int @ C2 @ B2 ) @ ( times_times @ int @ B2 @ D2 ) ) ) ) ) ) ).

% le_rat
thf(fact_5875_diff__rat,axiom,
    ! [B2: int,D2: int,A2: int,C2: int] :
      ( ( B2
       != ( zero_zero @ int ) )
     => ( ( D2
         != ( zero_zero @ int ) )
       => ( ( minus_minus @ rat @ ( fract @ A2 @ B2 ) @ ( fract @ C2 @ D2 ) )
          = ( fract @ ( minus_minus @ int @ ( times_times @ int @ A2 @ D2 ) @ ( times_times @ int @ C2 @ B2 ) ) @ ( times_times @ int @ B2 @ D2 ) ) ) ) ) ).

% diff_rat
thf(fact_5876_sgn__rat,axiom,
    ! [A2: int,B2: int] :
      ( ( sgn_sgn @ rat @ ( fract @ A2 @ B2 ) )
      = ( ring_1_of_int @ rat @ ( times_times @ int @ ( sgn_sgn @ int @ A2 ) @ ( sgn_sgn @ int @ B2 ) ) ) ) ).

% sgn_rat
thf(fact_5877_image__Collect__subsetI,axiom,
    ! [A: $tType,B: $tType,P: A > $o,F2: A > B,B3: set @ B] :
      ( ! [X3: A] :
          ( ( P @ X3 )
         => ( member @ B @ ( F2 @ X3 ) @ B3 ) )
     => ( ord_less_eq @ ( set @ B ) @ ( image @ A @ B @ F2 @ ( collect @ A @ P ) ) @ B3 ) ) ).

% image_Collect_subsetI
thf(fact_5878_INF__eq,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A3: set @ B,B3: set @ C,G: C > A,F2: B > A] :
          ( ! [I2: B] :
              ( ( member @ B @ I2 @ A3 )
             => ? [X: C] :
                  ( ( member @ C @ X @ B3 )
                  & ( ord_less_eq @ A @ ( G @ X ) @ ( F2 @ I2 ) ) ) )
         => ( ! [J2: C] :
                ( ( member @ C @ J2 @ B3 )
               => ? [X: B] :
                    ( ( member @ B @ X @ A3 )
                    & ( ord_less_eq @ A @ ( F2 @ X ) @ ( G @ J2 ) ) ) )
           => ( ( complete_Inf_Inf @ A @ ( image @ B @ A @ F2 @ A3 ) )
              = ( complete_Inf_Inf @ A @ ( image @ C @ A @ G @ B3 ) ) ) ) ) ) ).

% INF_eq
thf(fact_5879_SUP__eq,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A3: set @ B,B3: set @ C,F2: B > A,G: C > A] :
          ( ! [I2: B] :
              ( ( member @ B @ I2 @ A3 )
             => ? [X: C] :
                  ( ( member @ C @ X @ B3 )
                  & ( ord_less_eq @ A @ ( F2 @ I2 ) @ ( G @ X ) ) ) )
         => ( ! [J2: C] :
                ( ( member @ C @ J2 @ B3 )
               => ? [X: B] :
                    ( ( member @ B @ X @ A3 )
                    & ( ord_less_eq @ A @ ( G @ J2 ) @ ( F2 @ X ) ) ) )
           => ( ( complete_Sup_Sup @ A @ ( image @ B @ A @ F2 @ A3 ) )
              = ( complete_Sup_Sup @ A @ ( image @ C @ A @ G @ B3 ) ) ) ) ) ) ).

% SUP_eq
thf(fact_5880_bij__betw__subset,axiom,
    ! [A: $tType,B: $tType,F2: A > B,A3: set @ A,A10: set @ B,B3: set @ A,B14: set @ B] :
      ( ( bij_betw @ A @ B @ F2 @ A3 @ A10 )
     => ( ( ord_less_eq @ ( set @ A ) @ B3 @ A3 )
       => ( ( ( image @ A @ B @ F2 @ B3 )
            = B14 )
         => ( bij_betw @ A @ B @ F2 @ B3 @ B14 ) ) ) ) ).

% bij_betw_subset
thf(fact_5881_bij__betw__byWitness,axiom,
    ! [A: $tType,B: $tType,A3: set @ A,F8: B > A,F2: A > B,A10: set @ B] :
      ( ! [X3: A] :
          ( ( member @ A @ X3 @ A3 )
         => ( ( F8 @ ( F2 @ X3 ) )
            = X3 ) )
     => ( ! [X3: B] :
            ( ( member @ B @ X3 @ A10 )
           => ( ( F2 @ ( F8 @ X3 ) )
              = X3 ) )
       => ( ( ord_less_eq @ ( set @ B ) @ ( image @ A @ B @ F2 @ A3 ) @ A10 )
         => ( ( ord_less_eq @ ( set @ A ) @ ( image @ B @ A @ F8 @ A10 ) @ A3 )
           => ( bij_betw @ A @ B @ F2 @ A3 @ A10 ) ) ) ) ) ).

% bij_betw_byWitness
thf(fact_5882_image__diff__subset,axiom,
    ! [A: $tType,B: $tType,F2: B > A,A3: set @ B,B3: set @ B] : ( ord_less_eq @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ ( image @ B @ A @ F2 @ A3 ) @ ( image @ B @ A @ F2 @ B3 ) ) @ ( image @ B @ A @ F2 @ ( minus_minus @ ( set @ B ) @ A3 @ B3 ) ) ) ).

% image_diff_subset
thf(fact_5883_image__Pow__mono,axiom,
    ! [B: $tType,A: $tType,F2: B > A,A3: set @ B,B3: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ ( image @ B @ A @ F2 @ A3 ) @ B3 )
     => ( ord_less_eq @ ( set @ ( set @ A ) ) @ ( image @ ( set @ B ) @ ( set @ A ) @ ( image @ B @ A @ F2 ) @ ( pow2 @ B @ A3 ) ) @ ( pow2 @ A @ B3 ) ) ) ).

% image_Pow_mono
thf(fact_5884_all__subset__image,axiom,
    ! [A: $tType,B: $tType,F2: B > A,A3: set @ B,P: ( set @ A ) > $o] :
      ( ( ! [B8: set @ A] :
            ( ( ord_less_eq @ ( set @ A ) @ B8 @ ( image @ B @ A @ F2 @ A3 ) )
           => ( P @ B8 ) ) )
      = ( ! [B8: set @ B] :
            ( ( ord_less_eq @ ( set @ B ) @ B8 @ A3 )
           => ( P @ ( image @ B @ A @ F2 @ B8 ) ) ) ) ) ).

% all_subset_image
thf(fact_5885_subset__image__iff,axiom,
    ! [A: $tType,B: $tType,B3: set @ A,F2: B > A,A3: set @ B] :
      ( ( ord_less_eq @ ( set @ A ) @ B3 @ ( image @ B @ A @ F2 @ A3 ) )
      = ( ? [AA: set @ B] :
            ( ( ord_less_eq @ ( set @ B ) @ AA @ A3 )
            & ( B3
              = ( image @ B @ A @ F2 @ AA ) ) ) ) ) ).

% subset_image_iff
thf(fact_5886_image__subset__iff,axiom,
    ! [A: $tType,B: $tType,F2: B > A,A3: set @ B,B3: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ ( image @ B @ A @ F2 @ A3 ) @ B3 )
      = ( ! [X5: B] :
            ( ( member @ B @ X5 @ A3 )
           => ( member @ A @ ( F2 @ X5 ) @ B3 ) ) ) ) ).

% image_subset_iff
thf(fact_5887_subset__imageE,axiom,
    ! [A: $tType,B: $tType,B3: set @ A,F2: B > A,A3: set @ B] :
      ( ( ord_less_eq @ ( set @ A ) @ B3 @ ( image @ B @ A @ F2 @ A3 ) )
     => ~ ! [C7: set @ B] :
            ( ( ord_less_eq @ ( set @ B ) @ C7 @ A3 )
           => ( B3
             != ( image @ B @ A @ F2 @ C7 ) ) ) ) ).

% subset_imageE
thf(fact_5888_image__subsetI,axiom,
    ! [A: $tType,B: $tType,A3: set @ A,F2: A > B,B3: set @ B] :
      ( ! [X3: A] :
          ( ( member @ A @ X3 @ A3 )
         => ( member @ B @ ( F2 @ X3 ) @ B3 ) )
     => ( ord_less_eq @ ( set @ B ) @ ( image @ A @ B @ F2 @ A3 ) @ B3 ) ) ).

% image_subsetI
thf(fact_5889_image__mono,axiom,
    ! [B: $tType,A: $tType,A3: set @ A,B3: set @ A,F2: A > B] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ B3 )
     => ( ord_less_eq @ ( set @ B ) @ ( image @ A @ B @ F2 @ A3 ) @ ( image @ A @ B @ F2 @ B3 ) ) ) ).

% image_mono
thf(fact_5890_finite__surj,axiom,
    ! [A: $tType,B: $tType,A3: set @ A,B3: set @ B,F2: A > B] :
      ( ( finite_finite @ A @ A3 )
     => ( ( ord_less_eq @ ( set @ B ) @ B3 @ ( image @ A @ B @ F2 @ A3 ) )
       => ( finite_finite @ B @ B3 ) ) ) ).

% finite_surj
thf(fact_5891_finite__subset__image,axiom,
    ! [A: $tType,B: $tType,B3: set @ A,F2: B > A,A3: set @ B] :
      ( ( finite_finite @ A @ B3 )
     => ( ( ord_less_eq @ ( set @ A ) @ B3 @ ( image @ B @ A @ F2 @ A3 ) )
       => ? [C7: set @ B] :
            ( ( ord_less_eq @ ( set @ B ) @ C7 @ A3 )
            & ( finite_finite @ B @ C7 )
            & ( B3
              = ( image @ B @ A @ F2 @ C7 ) ) ) ) ) ).

% finite_subset_image
thf(fact_5892_ex__finite__subset__image,axiom,
    ! [A: $tType,B: $tType,F2: B > A,A3: set @ B,P: ( set @ A ) > $o] :
      ( ( ? [B8: set @ A] :
            ( ( finite_finite @ A @ B8 )
            & ( ord_less_eq @ ( set @ A ) @ B8 @ ( image @ B @ A @ F2 @ A3 ) )
            & ( P @ B8 ) ) )
      = ( ? [B8: set @ B] :
            ( ( finite_finite @ B @ B8 )
            & ( ord_less_eq @ ( set @ B ) @ B8 @ A3 )
            & ( P @ ( image @ B @ A @ F2 @ B8 ) ) ) ) ) ).

% ex_finite_subset_image
thf(fact_5893_all__finite__subset__image,axiom,
    ! [A: $tType,B: $tType,F2: B > A,A3: set @ B,P: ( set @ A ) > $o] :
      ( ( ! [B8: set @ A] :
            ( ( ( finite_finite @ A @ B8 )
              & ( ord_less_eq @ ( set @ A ) @ B8 @ ( image @ B @ A @ F2 @ A3 ) ) )
           => ( P @ B8 ) ) )
      = ( ! [B8: set @ B] :
            ( ( ( finite_finite @ B @ B8 )
              & ( ord_less_eq @ ( set @ B ) @ B8 @ A3 ) )
           => ( P @ ( image @ B @ A @ F2 @ B8 ) ) ) ) ) ).

% all_finite_subset_image
thf(fact_5894_image__Int__subset,axiom,
    ! [A: $tType,B: $tType,F2: B > A,A3: set @ B,B3: set @ B] : ( ord_less_eq @ ( set @ A ) @ ( image @ B @ A @ F2 @ ( inf_inf @ ( set @ B ) @ A3 @ B3 ) ) @ ( inf_inf @ ( set @ A ) @ ( image @ B @ A @ F2 @ A3 ) @ ( image @ B @ A @ F2 @ B3 ) ) ) ).

% image_Int_subset
thf(fact_5895_translation__Int,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [A2: A,S2: set @ A,T2: set @ A] :
          ( ( image @ A @ A @ ( plus_plus @ A @ A2 ) @ ( inf_inf @ ( set @ A ) @ S2 @ T2 ) )
          = ( inf_inf @ ( set @ A ) @ ( image @ A @ A @ ( plus_plus @ A @ A2 ) @ S2 ) @ ( image @ A @ A @ ( plus_plus @ A @ A2 ) @ T2 ) ) ) ) ).

% translation_Int
thf(fact_5896_eq__rat_I2_J,axiom,
    ! [A2: int] :
      ( ( fract @ A2 @ ( zero_zero @ int ) )
      = ( fract @ ( zero_zero @ int ) @ ( one_one @ int ) ) ) ).

% eq_rat(2)
thf(fact_5897_Rat__induct__pos,axiom,
    ! [P: rat > $o,Q3: rat] :
      ( ! [A5: int,B5: int] :
          ( ( ord_less @ int @ ( zero_zero @ int ) @ B5 )
         => ( P @ ( fract @ A5 @ B5 ) ) )
     => ( P @ Q3 ) ) ).

% Rat_induct_pos
thf(fact_5898_zero__notin__Suc__image,axiom,
    ! [A3: set @ nat] :
      ~ ( member @ nat @ ( zero_zero @ nat ) @ ( image @ nat @ nat @ suc @ A3 ) ) ).

% zero_notin_Suc_image
thf(fact_5899_eq__rat_I3_J,axiom,
    ! [A2: int,C2: int] :
      ( ( fract @ ( zero_zero @ int ) @ A2 )
      = ( fract @ ( zero_zero @ int ) @ C2 ) ) ).

% eq_rat(3)
thf(fact_5900_translation__diff,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [A2: A,S2: set @ A,T2: set @ A] :
          ( ( image @ A @ A @ ( plus_plus @ A @ A2 ) @ ( minus_minus @ ( set @ A ) @ S2 @ T2 ) )
          = ( minus_minus @ ( set @ A ) @ ( image @ A @ A @ ( plus_plus @ A @ A2 ) @ S2 ) @ ( image @ A @ A @ ( plus_plus @ A @ A2 ) @ T2 ) ) ) ) ).

% translation_diff
thf(fact_5901_eq__rat_I1_J,axiom,
    ! [B2: int,D2: int,A2: int,C2: int] :
      ( ( B2
       != ( zero_zero @ int ) )
     => ( ( D2
         != ( zero_zero @ int ) )
       => ( ( ( fract @ A2 @ B2 )
            = ( fract @ C2 @ D2 ) )
          = ( ( times_times @ int @ A2 @ D2 )
            = ( times_times @ int @ C2 @ B2 ) ) ) ) ) ).

% eq_rat(1)
thf(fact_5902_mult__rat__cancel,axiom,
    ! [C2: int,A2: int,B2: int] :
      ( ( C2
       != ( zero_zero @ int ) )
     => ( ( fract @ ( times_times @ int @ C2 @ A2 ) @ ( times_times @ int @ C2 @ B2 ) )
        = ( fract @ A2 @ B2 ) ) ) ).

% mult_rat_cancel
thf(fact_5903_translation__Compl,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [A2: A,T2: set @ A] :
          ( ( image @ A @ A @ ( plus_plus @ A @ A2 ) @ ( uminus_uminus @ ( set @ A ) @ T2 ) )
          = ( uminus_uminus @ ( set @ A ) @ ( image @ A @ A @ ( plus_plus @ A @ A2 ) @ T2 ) ) ) ) ).

% translation_Compl
thf(fact_5904_rat__number__collapse_I1_J,axiom,
    ! [K: int] :
      ( ( fract @ ( zero_zero @ int ) @ K )
      = ( zero_zero @ rat ) ) ).

% rat_number_collapse(1)
thf(fact_5905_rat__number__collapse_I6_J,axiom,
    ! [K: int] :
      ( ( fract @ K @ ( zero_zero @ int ) )
      = ( zero_zero @ rat ) ) ).

% rat_number_collapse(6)
thf(fact_5906_Fract__coprime,axiom,
    ! [A2: int,B2: int] :
      ( ( fract @ ( divide_divide @ int @ A2 @ ( gcd_gcd @ int @ A2 @ B2 ) ) @ ( divide_divide @ int @ B2 @ ( gcd_gcd @ int @ A2 @ B2 ) ) )
      = ( fract @ A2 @ B2 ) ) ).

% Fract_coprime
thf(fact_5907_SUP__upper2,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [I3: B,A3: set @ B,U: A,F2: B > A] :
          ( ( member @ B @ I3 @ A3 )
         => ( ( ord_less_eq @ A @ U @ ( F2 @ I3 ) )
           => ( ord_less_eq @ A @ U @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F2 @ A3 ) ) ) ) ) ) ).

% SUP_upper2
thf(fact_5908_SUP__le__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [F2: B > A,A3: set @ B,U: A] :
          ( ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F2 @ A3 ) ) @ U )
          = ( ! [X5: B] :
                ( ( member @ B @ X5 @ A3 )
               => ( ord_less_eq @ A @ ( F2 @ X5 ) @ U ) ) ) ) ) ).

% SUP_le_iff
thf(fact_5909_SUP__upper,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [I3: B,A3: set @ B,F2: B > A] :
          ( ( member @ B @ I3 @ A3 )
         => ( ord_less_eq @ A @ ( F2 @ I3 ) @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F2 @ A3 ) ) ) ) ) ).

% SUP_upper
thf(fact_5910_SUP__mono_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [F2: B > A,G: B > A,A3: set @ B] :
          ( ! [X3: B] : ( ord_less_eq @ A @ ( F2 @ X3 ) @ ( G @ X3 ) )
         => ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F2 @ A3 ) ) @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ G @ A3 ) ) ) ) ) ).

% SUP_mono'
thf(fact_5911_SUP__least,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A3: set @ B,F2: B > A,U: A] :
          ( ! [I2: B] :
              ( ( member @ B @ I2 @ A3 )
             => ( ord_less_eq @ A @ ( F2 @ I2 ) @ U ) )
         => ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F2 @ A3 ) ) @ U ) ) ) ).

% SUP_least
thf(fact_5912_SUP__mono,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A3: set @ B,B3: set @ C,F2: B > A,G: C > A] :
          ( ! [N: B] :
              ( ( member @ B @ N @ A3 )
             => ? [X: C] :
                  ( ( member @ C @ X @ B3 )
                  & ( ord_less_eq @ A @ ( F2 @ N ) @ ( G @ X ) ) ) )
         => ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F2 @ A3 ) ) @ ( complete_Sup_Sup @ A @ ( image @ C @ A @ G @ B3 ) ) ) ) ) ).

% SUP_mono
thf(fact_5913_SUP__eqI,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A3: set @ B,F2: B > A,X2: A] :
          ( ! [I2: B] :
              ( ( member @ B @ I2 @ A3 )
             => ( ord_less_eq @ A @ ( F2 @ I2 ) @ X2 ) )
         => ( ! [Y4: A] :
                ( ! [I: B] :
                    ( ( member @ B @ I @ A3 )
                   => ( ord_less_eq @ A @ ( F2 @ I ) @ Y4 ) )
               => ( ord_less_eq @ A @ X2 @ Y4 ) )
           => ( ( complete_Sup_Sup @ A @ ( image @ B @ A @ F2 @ A3 ) )
              = X2 ) ) ) ) ).

% SUP_eqI
thf(fact_5914_less__SUP__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple5582772986160207858norder @ A )
     => ! [A2: A,F2: B > A,A3: set @ B] :
          ( ( ord_less @ A @ A2 @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F2 @ A3 ) ) )
          = ( ? [X5: B] :
                ( ( member @ B @ X5 @ A3 )
                & ( ord_less @ A @ A2 @ ( F2 @ X5 ) ) ) ) ) ) ).

% less_SUP_iff
thf(fact_5915_SUP__lessD,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [F2: B > A,A3: set @ B,Y2: A,I3: B] :
          ( ( ord_less @ A @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F2 @ A3 ) ) @ Y2 )
         => ( ( member @ B @ I3 @ A3 )
           => ( ord_less @ A @ ( F2 @ I3 ) @ Y2 ) ) ) ) ).

% SUP_lessD
thf(fact_5916_INF__greatest,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A3: set @ B,U: A,F2: B > A] :
          ( ! [I2: B] :
              ( ( member @ B @ I2 @ A3 )
             => ( ord_less_eq @ A @ U @ ( F2 @ I2 ) ) )
         => ( ord_less_eq @ A @ U @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ F2 @ A3 ) ) ) ) ) ).

% INF_greatest
thf(fact_5917_le__INF__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [U: A,F2: B > A,A3: set @ B] :
          ( ( ord_less_eq @ A @ U @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ F2 @ A3 ) ) )
          = ( ! [X5: B] :
                ( ( member @ B @ X5 @ A3 )
               => ( ord_less_eq @ A @ U @ ( F2 @ X5 ) ) ) ) ) ) ).

% le_INF_iff
thf(fact_5918_INF__lower2,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [I3: B,A3: set @ B,F2: B > A,U: A] :
          ( ( member @ B @ I3 @ A3 )
         => ( ( ord_less_eq @ A @ ( F2 @ I3 ) @ U )
           => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ F2 @ A3 ) ) @ U ) ) ) ) ).

% INF_lower2
thf(fact_5919_INF__mono_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [F2: B > A,G: B > A,A3: set @ B] :
          ( ! [X3: B] : ( ord_less_eq @ A @ ( F2 @ X3 ) @ ( G @ X3 ) )
         => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ F2 @ A3 ) ) @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ G @ A3 ) ) ) ) ) ).

% INF_mono'
thf(fact_5920_INF__lower,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [I3: B,A3: set @ B,F2: B > A] :
          ( ( member @ B @ I3 @ A3 )
         => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ F2 @ A3 ) ) @ ( F2 @ I3 ) ) ) ) ).

% INF_lower
thf(fact_5921_INF__mono,axiom,
    ! [C: $tType,A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [B3: set @ B,A3: set @ C,F2: C > A,G: B > A] :
          ( ! [M3: B] :
              ( ( member @ B @ M3 @ B3 )
             => ? [X: C] :
                  ( ( member @ C @ X @ A3 )
                  & ( ord_less_eq @ A @ ( F2 @ X ) @ ( G @ M3 ) ) ) )
         => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ ( image @ C @ A @ F2 @ A3 ) ) @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ G @ B3 ) ) ) ) ) ).

% INF_mono
thf(fact_5922_INF__eqI,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A3: set @ B,X2: A,F2: B > A] :
          ( ! [I2: B] :
              ( ( member @ B @ I2 @ A3 )
             => ( ord_less_eq @ A @ X2 @ ( F2 @ I2 ) ) )
         => ( ! [Y4: A] :
                ( ! [I: B] :
                    ( ( member @ B @ I @ A3 )
                   => ( ord_less_eq @ A @ Y4 @ ( F2 @ I ) ) )
               => ( ord_less_eq @ A @ Y4 @ X2 ) )
           => ( ( complete_Inf_Inf @ A @ ( image @ B @ A @ F2 @ A3 ) )
              = X2 ) ) ) ) ).

% INF_eqI
thf(fact_5923_INF__less__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple5582772986160207858norder @ A )
     => ! [F2: B > A,A3: set @ B,A2: A] :
          ( ( ord_less @ A @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ F2 @ A3 ) ) @ A2 )
          = ( ? [X5: B] :
                ( ( member @ B @ X5 @ A3 )
                & ( ord_less @ A @ ( F2 @ X5 ) @ A2 ) ) ) ) ) ).

% INF_less_iff
thf(fact_5924_less__INF__D,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [Y2: A,F2: B > A,A3: set @ B,I3: B] :
          ( ( ord_less @ A @ Y2 @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ F2 @ A3 ) ) )
         => ( ( member @ B @ I3 @ A3 )
           => ( ord_less @ A @ Y2 @ ( F2 @ I3 ) ) ) ) ) ).

% less_INF_D
thf(fact_5925_finite__conv__nat__seg__image,axiom,
    ! [A: $tType] :
      ( ( finite_finite @ A )
      = ( ^ [A7: set @ A] :
          ? [N3: nat,F5: nat > A] :
            ( A7
            = ( image @ nat @ A @ F5
              @ ( collect @ nat
                @ ^ [I4: nat] : ( ord_less @ nat @ I4 @ N3 ) ) ) ) ) ) ).

% finite_conv_nat_seg_image
thf(fact_5926_nat__seg__image__imp__finite,axiom,
    ! [A: $tType,A3: set @ A,F2: nat > A,N2: nat] :
      ( ( A3
        = ( image @ nat @ A @ F2
          @ ( collect @ nat
            @ ^ [I4: nat] : ( ord_less @ nat @ I4 @ N2 ) ) ) )
     => ( finite_finite @ A @ A3 ) ) ).

% nat_seg_image_imp_finite
thf(fact_5927_Fract__of__int__quotient,axiom,
    ( fract
    = ( ^ [K3: int,L2: int] : ( divide_divide @ rat @ ( ring_1_of_int @ rat @ K3 ) @ ( ring_1_of_int @ rat @ L2 ) ) ) ) ).

% Fract_of_int_quotient
thf(fact_5928_le__SUP__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comple5582772986160207858norder @ A )
     => ! [X2: A,F2: B > A,A3: set @ B] :
          ( ( ord_less_eq @ A @ X2 @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F2 @ A3 ) ) )
          = ( ! [Y5: A] :
                ( ( ord_less @ A @ Y5 @ X2 )
               => ? [X5: B] :
                    ( ( member @ B @ X5 @ A3 )
                    & ( ord_less @ A @ Y5 @ ( F2 @ X5 ) ) ) ) ) ) ) ).

% le_SUP_iff
thf(fact_5929_INF__le__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comple5582772986160207858norder @ A )
     => ! [F2: B > A,A3: set @ B,X2: A] :
          ( ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ F2 @ A3 ) ) @ X2 )
          = ( ! [Y5: A] :
                ( ( ord_less @ A @ X2 @ Y5 )
               => ? [X5: B] :
                    ( ( member @ B @ X5 @ A3 )
                    & ( ord_less @ A @ ( F2 @ X5 ) @ Y5 ) ) ) ) ) ) ).

% INF_le_iff
thf(fact_5930_SUP__eq__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [I6: set @ B,C2: A,F2: B > A] :
          ( ( I6
           != ( bot_bot @ ( set @ B ) ) )
         => ( ! [I2: B] :
                ( ( member @ B @ I2 @ I6 )
               => ( ord_less_eq @ A @ C2 @ ( F2 @ I2 ) ) )
           => ( ( ( complete_Sup_Sup @ A @ ( image @ B @ A @ F2 @ I6 ) )
                = C2 )
              = ( ! [X5: B] :
                    ( ( member @ B @ X5 @ I6 )
                   => ( ( F2 @ X5 )
                      = C2 ) ) ) ) ) ) ) ).

% SUP_eq_iff
thf(fact_5931_cSUP__least,axiom,
    ! [B: $tType,A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [A3: set @ B,F2: B > A,M7: A] :
          ( ( A3
           != ( bot_bot @ ( set @ B ) ) )
         => ( ! [X3: B] :
                ( ( member @ B @ X3 @ A3 )
               => ( ord_less_eq @ A @ ( F2 @ X3 ) @ M7 ) )
           => ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F2 @ A3 ) ) @ M7 ) ) ) ) ).

% cSUP_least
thf(fact_5932_INF__eq__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [I6: set @ B,F2: B > A,C2: A] :
          ( ( I6
           != ( bot_bot @ ( set @ B ) ) )
         => ( ! [I2: B] :
                ( ( member @ B @ I2 @ I6 )
               => ( ord_less_eq @ A @ ( F2 @ I2 ) @ C2 ) )
           => ( ( ( complete_Inf_Inf @ A @ ( image @ B @ A @ F2 @ I6 ) )
                = C2 )
              = ( ! [X5: B] :
                    ( ( member @ B @ X5 @ I6 )
                   => ( ( F2 @ X5 )
                      = C2 ) ) ) ) ) ) ) ).

% INF_eq_iff
thf(fact_5933_cINF__greatest,axiom,
    ! [A: $tType,B: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [A3: set @ B,M: A,F2: B > A] :
          ( ( A3
           != ( bot_bot @ ( set @ B ) ) )
         => ( ! [X3: B] :
                ( ( member @ B @ X3 @ A3 )
               => ( ord_less_eq @ A @ M @ ( F2 @ X3 ) ) )
           => ( ord_less_eq @ A @ M @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ F2 @ A3 ) ) ) ) ) ) ).

% cINF_greatest
thf(fact_5934_card__image__le,axiom,
    ! [B: $tType,A: $tType,A3: set @ A,F2: A > B] :
      ( ( finite_finite @ A @ A3 )
     => ( ord_less_eq @ nat @ ( finite_card @ B @ ( image @ A @ B @ F2 @ A3 ) ) @ ( finite_card @ A @ A3 ) ) ) ).

% card_image_le
thf(fact_5935_bij__betw__comp__iff2,axiom,
    ! [C: $tType,A: $tType,B: $tType,F8: A > B,A10: set @ A,A11: set @ B,F2: C > A,A3: set @ C] :
      ( ( bij_betw @ A @ B @ F8 @ A10 @ A11 )
     => ( ( ord_less_eq @ ( set @ A ) @ ( image @ C @ A @ F2 @ A3 ) @ A10 )
       => ( ( bij_betw @ C @ A @ F2 @ A3 @ A10 )
          = ( bij_betw @ C @ B @ ( comp @ A @ B @ C @ F8 @ F2 ) @ A3 @ A11 ) ) ) ) ).

% bij_betw_comp_iff2
thf(fact_5936_Zero__rat__def,axiom,
    ( ( zero_zero @ rat )
    = ( fract @ ( zero_zero @ int ) @ ( one_one @ int ) ) ) ).

% Zero_rat_def
thf(fact_5937_SUP__subset__mono,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A3: set @ B,B3: set @ B,F2: B > A,G: B > A] :
          ( ( ord_less_eq @ ( set @ B ) @ A3 @ B3 )
         => ( ! [X3: B] :
                ( ( member @ B @ X3 @ A3 )
               => ( ord_less_eq @ A @ ( F2 @ X3 ) @ ( G @ X3 ) ) )
           => ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F2 @ A3 ) ) @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ G @ B3 ) ) ) ) ) ) ).

% SUP_subset_mono
thf(fact_5938_INF__superset__mono,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [B3: set @ B,A3: set @ B,F2: B > A,G: B > A] :
          ( ( ord_less_eq @ ( set @ B ) @ B3 @ A3 )
         => ( ! [X3: B] :
                ( ( member @ B @ X3 @ B3 )
               => ( ord_less_eq @ A @ ( F2 @ X3 ) @ ( G @ X3 ) ) )
           => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ F2 @ A3 ) ) @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ G @ B3 ) ) ) ) ) ) ).

% INF_superset_mono
thf(fact_5939_sum_Ogroup,axiom,
    ! [C: $tType,A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [S3: set @ B,T6: set @ C,G: B > C,H2: B > A] :
          ( ( finite_finite @ B @ S3 )
         => ( ( finite_finite @ C @ T6 )
           => ( ( ord_less_eq @ ( set @ C ) @ ( image @ B @ C @ G @ S3 ) @ T6 )
             => ( ( groups7311177749621191930dd_sum @ C @ A
                  @ ^ [Y5: C] :
                      ( groups7311177749621191930dd_sum @ B @ A @ H2
                      @ ( collect @ B
                        @ ^ [X5: B] :
                            ( ( member @ B @ X5 @ S3 )
                            & ( ( G @ X5 )
                              = Y5 ) ) ) )
                  @ T6 )
                = ( groups7311177749621191930dd_sum @ B @ A @ H2 @ S3 ) ) ) ) ) ) ).

% sum.group
thf(fact_5940_prod_Ogroup,axiom,
    ! [C: $tType,A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [S3: set @ B,T6: set @ C,G: B > C,H2: B > A] :
          ( ( finite_finite @ B @ S3 )
         => ( ( finite_finite @ C @ T6 )
           => ( ( ord_less_eq @ ( set @ C ) @ ( image @ B @ C @ G @ S3 ) @ T6 )
             => ( ( groups7121269368397514597t_prod @ C @ A
                  @ ^ [Y5: C] :
                      ( groups7121269368397514597t_prod @ B @ A @ H2
                      @ ( collect @ B
                        @ ^ [X5: B] :
                            ( ( member @ B @ X5 @ S3 )
                            & ( ( G @ X5 )
                              = Y5 ) ) ) )
                  @ T6 )
                = ( groups7121269368397514597t_prod @ B @ A @ H2 @ S3 ) ) ) ) ) ) ).

% prod.group
thf(fact_5941_rat__number__expand_I3_J,axiom,
    ( ( numeral_numeral @ rat )
    = ( ^ [K3: num] : ( fract @ ( numeral_numeral @ int @ K3 ) @ ( one_one @ int ) ) ) ) ).

% rat_number_expand(3)
thf(fact_5942_rat__number__collapse_I3_J,axiom,
    ! [W: num] :
      ( ( fract @ ( numeral_numeral @ int @ W ) @ ( one_one @ int ) )
      = ( numeral_numeral @ rat @ W ) ) ).

% rat_number_collapse(3)
thf(fact_5943_sum_Oreindex__nontrivial,axiom,
    ! [C: $tType,A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A3: set @ B,H2: B > C,G: C > A] :
          ( ( finite_finite @ B @ A3 )
         => ( ! [X3: B,Y4: B] :
                ( ( member @ B @ X3 @ A3 )
               => ( ( member @ B @ Y4 @ A3 )
                 => ( ( X3 != Y4 )
                   => ( ( ( H2 @ X3 )
                        = ( H2 @ Y4 ) )
                     => ( ( G @ ( H2 @ X3 ) )
                        = ( zero_zero @ A ) ) ) ) ) )
           => ( ( groups7311177749621191930dd_sum @ C @ A @ G @ ( image @ B @ C @ H2 @ A3 ) )
              = ( groups7311177749621191930dd_sum @ B @ A @ ( comp @ C @ A @ B @ G @ H2 ) @ A3 ) ) ) ) ) ).

% sum.reindex_nontrivial
thf(fact_5944_INF__le__SUP,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A3: set @ B,F2: B > A] :
          ( ( A3
           != ( bot_bot @ ( set @ B ) ) )
         => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ F2 @ A3 ) ) @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F2 @ A3 ) ) ) ) ) ).

% INF_le_SUP
thf(fact_5945_prod_Oreindex__nontrivial,axiom,
    ! [C: $tType,A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A3: set @ B,H2: B > C,G: C > A] :
          ( ( finite_finite @ B @ A3 )
         => ( ! [X3: B,Y4: B] :
                ( ( member @ B @ X3 @ A3 )
               => ( ( member @ B @ Y4 @ A3 )
                 => ( ( X3 != Y4 )
                   => ( ( ( H2 @ X3 )
                        = ( H2 @ Y4 ) )
                     => ( ( G @ ( H2 @ X3 ) )
                        = ( one_one @ A ) ) ) ) ) )
           => ( ( groups7121269368397514597t_prod @ C @ A @ G @ ( image @ B @ C @ H2 @ A3 ) )
              = ( groups7121269368397514597t_prod @ B @ A @ ( comp @ C @ A @ B @ G @ H2 ) @ A3 ) ) ) ) ) ).

% prod.reindex_nontrivial
thf(fact_5946_surj__card__le,axiom,
    ! [B: $tType,A: $tType,A3: set @ A,B3: set @ B,F2: A > B] :
      ( ( finite_finite @ A @ A3 )
     => ( ( ord_less_eq @ ( set @ B ) @ B3 @ ( image @ A @ B @ F2 @ A3 ) )
       => ( ord_less_eq @ nat @ ( finite_card @ B @ B3 ) @ ( finite_card @ A @ A3 ) ) ) ) ).

% surj_card_le
thf(fact_5947_scaleR__image__atLeastAtMost,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,X2: A,Y2: A] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ C2 )
         => ( ( image @ A @ A @ ( real_V8093663219630862766scaleR @ A @ C2 ) @ ( set_or1337092689740270186AtMost @ A @ X2 @ Y2 ) )
            = ( set_or1337092689740270186AtMost @ A @ ( real_V8093663219630862766scaleR @ A @ C2 @ X2 ) @ ( real_V8093663219630862766scaleR @ A @ C2 @ Y2 ) ) ) ) ) ).

% scaleR_image_atLeastAtMost
thf(fact_5948_image__Suc__lessThan,axiom,
    ! [N2: nat] :
      ( ( image @ nat @ nat @ suc @ ( set_ord_lessThan @ nat @ N2 ) )
      = ( set_or1337092689740270186AtMost @ nat @ ( one_one @ nat ) @ N2 ) ) ).

% image_Suc_lessThan
thf(fact_5949_image__Suc__atMost,axiom,
    ! [N2: nat] :
      ( ( image @ nat @ nat @ suc @ ( set_ord_atMost @ nat @ N2 ) )
      = ( set_or1337092689740270186AtMost @ nat @ ( one_one @ nat ) @ ( suc @ N2 ) ) ) ).

% image_Suc_atMost
thf(fact_5950_atLeast0__atMost__Suc__eq__insert__0,axiom,
    ! [N2: nat] :
      ( ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ ( suc @ N2 ) )
      = ( insert @ nat @ ( zero_zero @ nat ) @ ( image @ nat @ nat @ suc @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N2 ) ) ) ) ).

% atLeast0_atMost_Suc_eq_insert_0
thf(fact_5951_atLeast0__lessThan__Suc__eq__insert__0,axiom,
    ! [N2: nat] :
      ( ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( suc @ N2 ) )
      = ( insert @ nat @ ( zero_zero @ nat ) @ ( image @ nat @ nat @ suc @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N2 ) ) ) ) ).

% atLeast0_lessThan_Suc_eq_insert_0
thf(fact_5952_lessThan__Suc__eq__insert__0,axiom,
    ! [N2: nat] :
      ( ( set_ord_lessThan @ nat @ ( suc @ N2 ) )
      = ( insert @ nat @ ( zero_zero @ nat ) @ ( image @ nat @ nat @ suc @ ( set_ord_lessThan @ nat @ N2 ) ) ) ) ).

% lessThan_Suc_eq_insert_0
thf(fact_5953_atMost__Suc__eq__insert__0,axiom,
    ! [N2: nat] :
      ( ( set_ord_atMost @ nat @ ( suc @ N2 ) )
      = ( insert @ nat @ ( zero_zero @ nat ) @ ( image @ nat @ nat @ suc @ ( set_ord_atMost @ nat @ N2 ) ) ) ) ).

% atMost_Suc_eq_insert_0
thf(fact_5954_Fract__less__zero__iff,axiom,
    ! [B2: int,A2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ B2 )
     => ( ( ord_less @ rat @ ( fract @ A2 @ B2 ) @ ( zero_zero @ rat ) )
        = ( ord_less @ int @ A2 @ ( zero_zero @ int ) ) ) ) ).

% Fract_less_zero_iff
thf(fact_5955_zero__less__Fract__iff,axiom,
    ! [B2: int,A2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ B2 )
     => ( ( ord_less @ rat @ ( zero_zero @ rat ) @ ( fract @ A2 @ B2 ) )
        = ( ord_less @ int @ ( zero_zero @ int ) @ A2 ) ) ) ).

% zero_less_Fract_iff
thf(fact_5956_Fract__less__one__iff,axiom,
    ! [B2: int,A2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ B2 )
     => ( ( ord_less @ rat @ ( fract @ A2 @ B2 ) @ ( one_one @ rat ) )
        = ( ord_less @ int @ A2 @ B2 ) ) ) ).

% Fract_less_one_iff
thf(fact_5957_one__less__Fract__iff,axiom,
    ! [B2: int,A2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ B2 )
     => ( ( ord_less @ rat @ ( one_one @ rat ) @ ( fract @ A2 @ B2 ) )
        = ( ord_less @ int @ B2 @ A2 ) ) ) ).

% one_less_Fract_iff
thf(fact_5958_Fract__add__one,axiom,
    ! [N2: int,M: int] :
      ( ( N2
       != ( zero_zero @ int ) )
     => ( ( fract @ ( plus_plus @ int @ M @ N2 ) @ N2 )
        = ( plus_plus @ rat @ ( fract @ M @ N2 ) @ ( one_one @ rat ) ) ) ) ).

% Fract_add_one
thf(fact_5959_sum__image__le,axiom,
    ! [A: $tType,B: $tType,C: $tType] :
      ( ( ordere6911136660526730532id_add @ B )
     => ! [I6: set @ C,G: A > B,F2: C > A] :
          ( ( finite_finite @ C @ I6 )
         => ( ! [I2: C] :
                ( ( member @ C @ I2 @ I6 )
               => ( ord_less_eq @ B @ ( zero_zero @ B ) @ ( G @ ( F2 @ I2 ) ) ) )
           => ( ord_less_eq @ B @ ( groups7311177749621191930dd_sum @ A @ B @ G @ ( image @ C @ A @ F2 @ I6 ) ) @ ( groups7311177749621191930dd_sum @ C @ B @ ( comp @ A @ B @ C @ G @ F2 ) @ I6 ) ) ) ) ) ).

% sum_image_le
thf(fact_5960_Fract__le__zero__iff,axiom,
    ! [B2: int,A2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ B2 )
     => ( ( ord_less_eq @ rat @ ( fract @ A2 @ B2 ) @ ( zero_zero @ rat ) )
        = ( ord_less_eq @ int @ A2 @ ( zero_zero @ int ) ) ) ) ).

% Fract_le_zero_iff
thf(fact_5961_zero__le__Fract__iff,axiom,
    ! [B2: int,A2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ B2 )
     => ( ( ord_less_eq @ rat @ ( zero_zero @ rat ) @ ( fract @ A2 @ B2 ) )
        = ( ord_less_eq @ int @ ( zero_zero @ int ) @ A2 ) ) ) ).

% zero_le_Fract_iff
thf(fact_5962_one__le__Fract__iff,axiom,
    ! [B2: int,A2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ B2 )
     => ( ( ord_less_eq @ rat @ ( one_one @ rat ) @ ( fract @ A2 @ B2 ) )
        = ( ord_less_eq @ int @ B2 @ A2 ) ) ) ).

% one_le_Fract_iff
thf(fact_5963_Fract__le__one__iff,axiom,
    ! [B2: int,A2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ B2 )
     => ( ( ord_less_eq @ rat @ ( fract @ A2 @ B2 ) @ ( one_one @ rat ) )
        = ( ord_less_eq @ int @ A2 @ B2 ) ) ) ).

% Fract_le_one_iff
thf(fact_5964_rat__number__expand_I5_J,axiom,
    ! [K: num] :
      ( ( uminus_uminus @ rat @ ( numeral_numeral @ rat @ K ) )
      = ( fract @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ K ) ) @ ( one_one @ int ) ) ) ).

% rat_number_expand(5)
thf(fact_5965_rat__number__collapse_I4_J,axiom,
    ! [W: num] :
      ( ( fract @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ W ) ) @ ( one_one @ int ) )
      = ( uminus_uminus @ rat @ ( numeral_numeral @ rat @ W ) ) ) ).

% rat_number_collapse(4)
thf(fact_5966_image__mult__atLeastAtMost__if,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,X2: A,Y2: A] :
          ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
           => ( ( image @ A @ A @ ( times_times @ A @ C2 ) @ ( set_or1337092689740270186AtMost @ A @ X2 @ Y2 ) )
              = ( set_or1337092689740270186AtMost @ A @ ( times_times @ A @ C2 @ X2 ) @ ( times_times @ A @ C2 @ Y2 ) ) ) )
          & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
           => ( ( ( ord_less_eq @ A @ X2 @ Y2 )
               => ( ( image @ A @ A @ ( times_times @ A @ C2 ) @ ( set_or1337092689740270186AtMost @ A @ X2 @ Y2 ) )
                  = ( set_or1337092689740270186AtMost @ A @ ( times_times @ A @ C2 @ Y2 ) @ ( times_times @ A @ C2 @ X2 ) ) ) )
              & ( ~ ( ord_less_eq @ A @ X2 @ Y2 )
               => ( ( image @ A @ A @ ( times_times @ A @ C2 ) @ ( set_or1337092689740270186AtMost @ A @ X2 @ Y2 ) )
                  = ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ).

% image_mult_atLeastAtMost_if
thf(fact_5967_image__mult__atLeastAtMost__if_H,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X2: A,Y2: A,C2: A] :
          ( ( ( ord_less_eq @ A @ X2 @ Y2 )
           => ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
               => ( ( image @ A @ A
                    @ ^ [X5: A] : ( times_times @ A @ X5 @ C2 )
                    @ ( set_or1337092689740270186AtMost @ A @ X2 @ Y2 ) )
                  = ( set_or1337092689740270186AtMost @ A @ ( times_times @ A @ X2 @ C2 ) @ ( times_times @ A @ Y2 @ C2 ) ) ) )
              & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
               => ( ( image @ A @ A
                    @ ^ [X5: A] : ( times_times @ A @ X5 @ C2 )
                    @ ( set_or1337092689740270186AtMost @ A @ X2 @ Y2 ) )
                  = ( set_or1337092689740270186AtMost @ A @ ( times_times @ A @ Y2 @ C2 ) @ ( times_times @ A @ X2 @ C2 ) ) ) ) ) )
          & ( ~ ( ord_less_eq @ A @ X2 @ Y2 )
           => ( ( image @ A @ A
                @ ^ [X5: A] : ( times_times @ A @ X5 @ C2 )
                @ ( set_or1337092689740270186AtMost @ A @ X2 @ Y2 ) )
              = ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% image_mult_atLeastAtMost_if'
thf(fact_5968_image__affinity__atLeastAtMost,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A,M: A,C2: A] :
          ( ( ( ( set_or1337092689740270186AtMost @ A @ A2 @ B2 )
              = ( bot_bot @ ( set @ A ) ) )
           => ( ( image @ A @ A
                @ ^ [X5: A] : ( plus_plus @ A @ ( times_times @ A @ M @ X5 ) @ C2 )
                @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) )
              = ( bot_bot @ ( set @ A ) ) ) )
          & ( ( ( set_or1337092689740270186AtMost @ A @ A2 @ B2 )
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ M )
               => ( ( image @ A @ A
                    @ ^ [X5: A] : ( plus_plus @ A @ ( times_times @ A @ M @ X5 ) @ C2 )
                    @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) )
                  = ( set_or1337092689740270186AtMost @ A @ ( plus_plus @ A @ ( times_times @ A @ M @ A2 ) @ C2 ) @ ( plus_plus @ A @ ( times_times @ A @ M @ B2 ) @ C2 ) ) ) )
              & ( ~ ( ord_less_eq @ A @ ( zero_zero @ A ) @ M )
               => ( ( image @ A @ A
                    @ ^ [X5: A] : ( plus_plus @ A @ ( times_times @ A @ M @ X5 ) @ C2 )
                    @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) )
                  = ( set_or1337092689740270186AtMost @ A @ ( plus_plus @ A @ ( times_times @ A @ M @ B2 ) @ C2 ) @ ( plus_plus @ A @ ( times_times @ A @ M @ A2 ) @ C2 ) ) ) ) ) ) ) ) ).

% image_affinity_atLeastAtMost
thf(fact_5969_image__affinity__atLeastAtMost__diff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A,M: A,C2: A] :
          ( ( ( ( set_or1337092689740270186AtMost @ A @ A2 @ B2 )
              = ( bot_bot @ ( set @ A ) ) )
           => ( ( image @ A @ A
                @ ^ [X5: A] : ( minus_minus @ A @ ( times_times @ A @ M @ X5 ) @ C2 )
                @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) )
              = ( bot_bot @ ( set @ A ) ) ) )
          & ( ( ( set_or1337092689740270186AtMost @ A @ A2 @ B2 )
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ M )
               => ( ( image @ A @ A
                    @ ^ [X5: A] : ( minus_minus @ A @ ( times_times @ A @ M @ X5 ) @ C2 )
                    @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) )
                  = ( set_or1337092689740270186AtMost @ A @ ( minus_minus @ A @ ( times_times @ A @ M @ A2 ) @ C2 ) @ ( minus_minus @ A @ ( times_times @ A @ M @ B2 ) @ C2 ) ) ) )
              & ( ~ ( ord_less_eq @ A @ ( zero_zero @ A ) @ M )
               => ( ( image @ A @ A
                    @ ^ [X5: A] : ( minus_minus @ A @ ( times_times @ A @ M @ X5 ) @ C2 )
                    @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) )
                  = ( set_or1337092689740270186AtMost @ A @ ( minus_minus @ A @ ( times_times @ A @ M @ B2 ) @ C2 ) @ ( minus_minus @ A @ ( times_times @ A @ M @ A2 ) @ C2 ) ) ) ) ) ) ) ) ).

% image_affinity_atLeastAtMost_diff
thf(fact_5970_image__affinity__atLeastAtMost__div,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A,M: A,C2: A] :
          ( ( ( ( set_or1337092689740270186AtMost @ A @ A2 @ B2 )
              = ( bot_bot @ ( set @ A ) ) )
           => ( ( image @ A @ A
                @ ^ [X5: A] : ( plus_plus @ A @ ( divide_divide @ A @ X5 @ M ) @ C2 )
                @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) )
              = ( bot_bot @ ( set @ A ) ) ) )
          & ( ( ( set_or1337092689740270186AtMost @ A @ A2 @ B2 )
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ M )
               => ( ( image @ A @ A
                    @ ^ [X5: A] : ( plus_plus @ A @ ( divide_divide @ A @ X5 @ M ) @ C2 )
                    @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) )
                  = ( set_or1337092689740270186AtMost @ A @ ( plus_plus @ A @ ( divide_divide @ A @ A2 @ M ) @ C2 ) @ ( plus_plus @ A @ ( divide_divide @ A @ B2 @ M ) @ C2 ) ) ) )
              & ( ~ ( ord_less_eq @ A @ ( zero_zero @ A ) @ M )
               => ( ( image @ A @ A
                    @ ^ [X5: A] : ( plus_plus @ A @ ( divide_divide @ A @ X5 @ M ) @ C2 )
                    @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) )
                  = ( set_or1337092689740270186AtMost @ A @ ( plus_plus @ A @ ( divide_divide @ A @ B2 @ M ) @ C2 ) @ ( plus_plus @ A @ ( divide_divide @ A @ A2 @ M ) @ C2 ) ) ) ) ) ) ) ) ).

% image_affinity_atLeastAtMost_div
thf(fact_5971_image__affinity__atLeastAtMost__div__diff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A,M: A,C2: A] :
          ( ( ( ( set_or1337092689740270186AtMost @ A @ A2 @ B2 )
              = ( bot_bot @ ( set @ A ) ) )
           => ( ( image @ A @ A
                @ ^ [X5: A] : ( minus_minus @ A @ ( divide_divide @ A @ X5 @ M ) @ C2 )
                @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) )
              = ( bot_bot @ ( set @ A ) ) ) )
          & ( ( ( set_or1337092689740270186AtMost @ A @ A2 @ B2 )
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ M )
               => ( ( image @ A @ A
                    @ ^ [X5: A] : ( minus_minus @ A @ ( divide_divide @ A @ X5 @ M ) @ C2 )
                    @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) )
                  = ( set_or1337092689740270186AtMost @ A @ ( minus_minus @ A @ ( divide_divide @ A @ A2 @ M ) @ C2 ) @ ( minus_minus @ A @ ( divide_divide @ A @ B2 @ M ) @ C2 ) ) ) )
              & ( ~ ( ord_less_eq @ A @ ( zero_zero @ A ) @ M )
               => ( ( image @ A @ A
                    @ ^ [X5: A] : ( minus_minus @ A @ ( divide_divide @ A @ X5 @ M ) @ C2 )
                    @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) )
                  = ( set_or1337092689740270186AtMost @ A @ ( minus_minus @ A @ ( divide_divide @ A @ B2 @ M ) @ C2 ) @ ( minus_minus @ A @ ( divide_divide @ A @ A2 @ M ) @ C2 ) ) ) ) ) ) ) ) ).

% image_affinity_atLeastAtMost_div_diff
thf(fact_5972_sum__fun__comp,axiom,
    ! [A: $tType,C: $tType,B: $tType] :
      ( ( semiring_1 @ C )
     => ! [S3: set @ A,R: set @ B,G: A > B,F2: B > C] :
          ( ( finite_finite @ A @ S3 )
         => ( ( finite_finite @ B @ R )
           => ( ( ord_less_eq @ ( set @ B ) @ ( image @ A @ B @ G @ S3 ) @ R )
             => ( ( groups7311177749621191930dd_sum @ A @ C
                  @ ^ [X5: A] : ( F2 @ ( G @ X5 ) )
                  @ S3 )
                = ( groups7311177749621191930dd_sum @ B @ C
                  @ ^ [Y5: B] :
                      ( times_times @ C
                      @ ( semiring_1_of_nat @ C
                        @ ( finite_card @ A
                          @ ( collect @ A
                            @ ^ [X5: A] :
                                ( ( member @ A @ X5 @ S3 )
                                & ( ( G @ X5 )
                                  = Y5 ) ) ) ) )
                      @ ( F2 @ Y5 ) )
                  @ R ) ) ) ) ) ) ).

% sum_fun_comp
thf(fact_5973_INF__nat__binary,axiom,
    ! [A: $tType] :
      ( ( counta3822494911875563373attice @ A )
     => ! [A3: A,B3: A] :
          ( ( inf_inf @ A @ A3
            @ ( complete_Inf_Inf @ A
              @ ( image @ nat @ A
                @ ^ [X5: nat] : B3
                @ ( collect @ nat @ ( ord_less @ nat @ ( zero_zero @ nat ) ) ) ) ) )
          = ( inf_inf @ A @ A3 @ B3 ) ) ) ).

% INF_nat_binary
thf(fact_5974_folding__on_Oinsert__remove,axiom,
    ! [B: $tType,A: $tType,S3: set @ A,F2: A > B > B,X2: A,A3: set @ A,Z: B] :
      ( ( finite_folding_on @ A @ B @ S3 @ F2 )
     => ( ( ord_less_eq @ ( set @ A ) @ ( insert @ A @ X2 @ A3 ) @ S3 )
       => ( ( finite_finite @ A @ A3 )
         => ( ( finite_folding_F @ A @ B @ F2 @ Z @ ( insert @ A @ X2 @ A3 ) )
            = ( F2 @ X2 @ ( finite_folding_F @ A @ B @ F2 @ Z @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X2 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ) ) ).

% folding_on.insert_remove
thf(fact_5975_folding__on_Oremove,axiom,
    ! [B: $tType,A: $tType,S3: set @ A,F2: A > B > B,A3: set @ A,X2: A,Z: B] :
      ( ( finite_folding_on @ A @ B @ S3 @ F2 )
     => ( ( ord_less_eq @ ( set @ A ) @ A3 @ S3 )
       => ( ( finite_finite @ A @ A3 )
         => ( ( member @ A @ X2 @ A3 )
           => ( ( finite_folding_F @ A @ B @ F2 @ Z @ A3 )
              = ( F2 @ X2 @ ( finite_folding_F @ A @ B @ F2 @ Z @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X2 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ) ) ) ).

% folding_on.remove
thf(fact_5976_pair__imageI,axiom,
    ! [C: $tType,B: $tType,A: $tType,A2: A,B2: B,A3: set @ ( product_prod @ A @ B ),F2: A > B > C] :
      ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ A2 @ B2 ) @ A3 )
     => ( member @ C @ ( F2 @ A2 @ B2 ) @ ( image @ ( product_prod @ A @ B ) @ C @ ( product_case_prod @ A @ B @ C @ F2 ) @ A3 ) ) ) ).

% pair_imageI
thf(fact_5977_set__concat,axiom,
    ! [A: $tType,Xs: list @ ( list @ A )] :
      ( ( set2 @ A @ ( concat @ A @ Xs ) )
      = ( complete_Sup_Sup @ ( set @ A ) @ ( image @ ( list @ A ) @ ( set @ A ) @ ( set2 @ A ) @ ( set2 @ ( list @ A ) @ Xs ) ) ) ) ).

% set_concat
thf(fact_5978_UN__Pow__subset,axiom,
    ! [A: $tType,B: $tType,B3: B > ( set @ A ),A3: set @ B] :
      ( ord_less_eq @ ( set @ ( set @ A ) )
      @ ( complete_Sup_Sup @ ( set @ ( set @ A ) )
        @ ( image @ B @ ( set @ ( set @ A ) )
          @ ^ [X5: B] : ( pow2 @ A @ ( B3 @ X5 ) )
          @ A3 ) )
      @ ( pow2 @ A @ ( complete_Sup_Sup @ ( set @ A ) @ ( image @ B @ ( set @ A ) @ B3 @ A3 ) ) ) ) ).

% UN_Pow_subset
thf(fact_5979_Inf__INT__eq2,axiom,
    ! [B: $tType,A: $tType] :
      ( ( complete_Inf_Inf @ ( A > B > $o ) )
      = ( ^ [S6: set @ ( A > B > $o ),X5: A,Y5: B] : ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X5 @ Y5 ) @ ( complete_Inf_Inf @ ( set @ ( product_prod @ A @ B ) ) @ ( image @ ( ( product_prod @ A @ B ) > $o ) @ ( set @ ( product_prod @ A @ B ) ) @ ( collect @ ( product_prod @ A @ B ) ) @ ( image @ ( A > B > $o ) @ ( ( product_prod @ A @ B ) > $o ) @ ( product_case_prod @ A @ B @ $o ) @ S6 ) ) ) ) ) ) ).

% Inf_INT_eq2
thf(fact_5980_Sup__SUP__eq2,axiom,
    ! [B: $tType,A: $tType] :
      ( ( complete_Sup_Sup @ ( A > B > $o ) )
      = ( ^ [S6: set @ ( A > B > $o ),X5: A,Y5: B] : ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X5 @ Y5 ) @ ( complete_Sup_Sup @ ( set @ ( product_prod @ A @ B ) ) @ ( image @ ( ( product_prod @ A @ B ) > $o ) @ ( set @ ( product_prod @ A @ B ) ) @ ( collect @ ( product_prod @ A @ B ) ) @ ( image @ ( A > B > $o ) @ ( ( product_prod @ A @ B ) > $o ) @ ( product_case_prod @ A @ B @ $o ) @ S6 ) ) ) ) ) ) ).

% Sup_SUP_eq2
thf(fact_5981_SUP__Sup__eq2,axiom,
    ! [B: $tType,A: $tType,S3: set @ ( set @ ( product_prod @ A @ B ) )] :
      ( ( complete_Sup_Sup @ ( A > B > $o )
        @ ( image @ ( set @ ( product_prod @ A @ B ) ) @ ( A > B > $o )
          @ ^ [I4: set @ ( product_prod @ A @ B ),X5: A,Y5: B] : ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X5 @ Y5 ) @ I4 )
          @ S3 ) )
      = ( ^ [X5: A,Y5: B] : ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X5 @ Y5 ) @ ( complete_Sup_Sup @ ( set @ ( product_prod @ A @ B ) ) @ S3 ) ) ) ) ).

% SUP_Sup_eq2
thf(fact_5982_SUP__UN__eq2,axiom,
    ! [B: $tType,C: $tType,A: $tType,R3: C > ( set @ ( product_prod @ A @ B ) ),S3: set @ C] :
      ( ( complete_Sup_Sup @ ( A > B > $o )
        @ ( image @ C @ ( A > B > $o )
          @ ^ [I4: C,X5: A,Y5: B] : ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X5 @ Y5 ) @ ( R3 @ I4 ) )
          @ S3 ) )
      = ( ^ [X5: A,Y5: B] : ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X5 @ Y5 ) @ ( complete_Sup_Sup @ ( set @ ( product_prod @ A @ B ) ) @ ( image @ C @ ( set @ ( product_prod @ A @ B ) ) @ R3 @ S3 ) ) ) ) ) ).

% SUP_UN_eq2
thf(fact_5983_INF__INT__eq2,axiom,
    ! [B: $tType,C: $tType,A: $tType,R3: C > ( set @ ( product_prod @ A @ B ) ),S3: set @ C] :
      ( ( complete_Inf_Inf @ ( A > B > $o )
        @ ( image @ C @ ( A > B > $o )
          @ ^ [I4: C,X5: A,Y5: B] : ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X5 @ Y5 ) @ ( R3 @ I4 ) )
          @ S3 ) )
      = ( ^ [X5: A,Y5: B] : ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X5 @ Y5 ) @ ( complete_Inf_Inf @ ( set @ ( product_prod @ A @ B ) ) @ ( image @ C @ ( set @ ( product_prod @ A @ B ) ) @ R3 @ S3 ) ) ) ) ) ).

% INF_INT_eq2
thf(fact_5984_INF__Int__eq2,axiom,
    ! [B: $tType,A: $tType,S3: set @ ( set @ ( product_prod @ A @ B ) )] :
      ( ( complete_Inf_Inf @ ( A > B > $o )
        @ ( image @ ( set @ ( product_prod @ A @ B ) ) @ ( A > B > $o )
          @ ^ [I4: set @ ( product_prod @ A @ B ),X5: A,Y5: B] : ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X5 @ Y5 ) @ I4 )
          @ S3 ) )
      = ( ^ [X5: A,Y5: B] : ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X5 @ Y5 ) @ ( complete_Inf_Inf @ ( set @ ( product_prod @ A @ B ) ) @ S3 ) ) ) ) ).

% INF_Int_eq2
thf(fact_5985_None__notin__image__Some,axiom,
    ! [A: $tType,A3: set @ A] :
      ~ ( member @ ( option @ A ) @ ( none @ A ) @ ( image @ A @ ( option @ A ) @ ( some @ A ) @ A3 ) ) ).

% None_notin_image_Some
thf(fact_5986_Inf__real__def,axiom,
    ( ( complete_Inf_Inf @ real )
    = ( ^ [X4: set @ real] : ( uminus_uminus @ real @ ( complete_Sup_Sup @ real @ ( image @ real @ real @ ( uminus_uminus @ real ) @ X4 ) ) ) ) ) ).

% Inf_real_def
thf(fact_5987_finite__int__iff__bounded,axiom,
    ( ( finite_finite @ int )
    = ( ^ [S6: set @ int] :
        ? [K3: int] : ( ord_less_eq @ ( set @ int ) @ ( image @ int @ int @ ( abs_abs @ int ) @ S6 ) @ ( set_ord_lessThan @ int @ K3 ) ) ) ) ).

% finite_int_iff_bounded
thf(fact_5988_finite__int__iff__bounded__le,axiom,
    ( ( finite_finite @ int )
    = ( ^ [S6: set @ int] :
        ? [K3: int] : ( ord_less_eq @ ( set @ int ) @ ( image @ int @ int @ ( abs_abs @ int ) @ S6 ) @ ( set_ord_atMost @ int @ K3 ) ) ) ) ).

% finite_int_iff_bounded_le
thf(fact_5989_UN__mono,axiom,
    ! [B: $tType,A: $tType,A3: set @ A,B3: set @ A,F2: A > ( set @ B ),G: A > ( set @ B )] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ B3 )
     => ( ! [X3: A] :
            ( ( member @ A @ X3 @ A3 )
           => ( ord_less_eq @ ( set @ B ) @ ( F2 @ X3 ) @ ( G @ X3 ) ) )
       => ( ord_less_eq @ ( set @ B ) @ ( complete_Sup_Sup @ ( set @ B ) @ ( image @ A @ ( set @ B ) @ F2 @ A3 ) ) @ ( complete_Sup_Sup @ ( set @ B ) @ ( image @ A @ ( set @ B ) @ G @ B3 ) ) ) ) ) ).

% UN_mono
thf(fact_5990_UN__least,axiom,
    ! [A: $tType,B: $tType,A3: set @ A,B3: A > ( set @ B ),C6: set @ B] :
      ( ! [X3: A] :
          ( ( member @ A @ X3 @ A3 )
         => ( ord_less_eq @ ( set @ B ) @ ( B3 @ X3 ) @ C6 ) )
     => ( ord_less_eq @ ( set @ B ) @ ( complete_Sup_Sup @ ( set @ B ) @ ( image @ A @ ( set @ B ) @ B3 @ A3 ) ) @ C6 ) ) ).

% UN_least
thf(fact_5991_UN__upper,axiom,
    ! [B: $tType,A: $tType,A2: A,A3: set @ A,B3: A > ( set @ B )] :
      ( ( member @ A @ A2 @ A3 )
     => ( ord_less_eq @ ( set @ B ) @ ( B3 @ A2 ) @ ( complete_Sup_Sup @ ( set @ B ) @ ( image @ A @ ( set @ B ) @ B3 @ A3 ) ) ) ) ).

% UN_upper
thf(fact_5992_UN__subset__iff,axiom,
    ! [A: $tType,B: $tType,A3: B > ( set @ A ),I6: set @ B,B3: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ ( complete_Sup_Sup @ ( set @ A ) @ ( image @ B @ ( set @ A ) @ A3 @ I6 ) ) @ B3 )
      = ( ! [X5: B] :
            ( ( member @ B @ X5 @ I6 )
           => ( ord_less_eq @ ( set @ A ) @ ( A3 @ X5 ) @ B3 ) ) ) ) ).

% UN_subset_iff
thf(fact_5993_INT__lower,axiom,
    ! [B: $tType,A: $tType,A2: A,A3: set @ A,B3: A > ( set @ B )] :
      ( ( member @ A @ A2 @ A3 )
     => ( ord_less_eq @ ( set @ B ) @ ( complete_Inf_Inf @ ( set @ B ) @ ( image @ A @ ( set @ B ) @ B3 @ A3 ) ) @ ( B3 @ A2 ) ) ) ).

% INT_lower
thf(fact_5994_INT__greatest,axiom,
    ! [B: $tType,A: $tType,A3: set @ A,C6: set @ B,B3: A > ( set @ B )] :
      ( ! [X3: A] :
          ( ( member @ A @ X3 @ A3 )
         => ( ord_less_eq @ ( set @ B ) @ C6 @ ( B3 @ X3 ) ) )
     => ( ord_less_eq @ ( set @ B ) @ C6 @ ( complete_Inf_Inf @ ( set @ B ) @ ( image @ A @ ( set @ B ) @ B3 @ A3 ) ) ) ) ).

% INT_greatest
thf(fact_5995_INT__anti__mono,axiom,
    ! [B: $tType,A: $tType,A3: set @ A,B3: set @ A,F2: A > ( set @ B ),G: A > ( set @ B )] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ B3 )
     => ( ! [X3: A] :
            ( ( member @ A @ X3 @ A3 )
           => ( ord_less_eq @ ( set @ B ) @ ( F2 @ X3 ) @ ( G @ X3 ) ) )
       => ( ord_less_eq @ ( set @ B ) @ ( complete_Inf_Inf @ ( set @ B ) @ ( image @ A @ ( set @ B ) @ F2 @ B3 ) ) @ ( complete_Inf_Inf @ ( set @ B ) @ ( image @ A @ ( set @ B ) @ G @ A3 ) ) ) ) ) ).

% INT_anti_mono
thf(fact_5996_INT__subset__iff,axiom,
    ! [A: $tType,B: $tType,B3: set @ A,A3: B > ( set @ A ),I6: set @ B] :
      ( ( ord_less_eq @ ( set @ A ) @ B3 @ ( complete_Inf_Inf @ ( set @ A ) @ ( image @ B @ ( set @ A ) @ A3 @ I6 ) ) )
      = ( ! [X5: B] :
            ( ( member @ B @ X5 @ I6 )
           => ( ord_less_eq @ ( set @ A ) @ B3 @ ( A3 @ X5 ) ) ) ) ) ).

% INT_subset_iff
thf(fact_5997_bij__betw__UNION__chain,axiom,
    ! [B: $tType,C: $tType,A: $tType,I6: set @ A,A3: A > ( set @ B ),F2: B > C,A10: A > ( set @ C )] :
      ( ! [I2: A,J2: A] :
          ( ( member @ A @ I2 @ I6 )
         => ( ( member @ A @ J2 @ I6 )
           => ( ( ord_less_eq @ ( set @ B ) @ ( A3 @ I2 ) @ ( A3 @ J2 ) )
              | ( ord_less_eq @ ( set @ B ) @ ( A3 @ J2 ) @ ( A3 @ I2 ) ) ) ) )
     => ( ! [I2: A] :
            ( ( member @ A @ I2 @ I6 )
           => ( bij_betw @ B @ C @ F2 @ ( A3 @ I2 ) @ ( A10 @ I2 ) ) )
       => ( bij_betw @ B @ C @ F2 @ ( complete_Sup_Sup @ ( set @ B ) @ ( image @ A @ ( set @ B ) @ A3 @ I6 ) ) @ ( complete_Sup_Sup @ ( set @ C ) @ ( image @ A @ ( set @ C ) @ A10 @ I6 ) ) ) ) ) ).

% bij_betw_UNION_chain
thf(fact_5998_Collect__split__mono__strong,axiom,
    ! [B: $tType,A: $tType,X8: set @ A,A3: set @ ( product_prod @ A @ B ),Y8: set @ B,P: A > B > $o,Q: A > B > $o] :
      ( ( X8
        = ( image @ ( product_prod @ A @ B ) @ A @ ( product_fst @ A @ B ) @ A3 ) )
     => ( ( Y8
          = ( image @ ( product_prod @ A @ B ) @ B @ ( product_snd @ A @ B ) @ A3 ) )
       => ( ! [X3: A] :
              ( ( member @ A @ X3 @ X8 )
             => ! [Xa3: B] :
                  ( ( member @ B @ Xa3 @ Y8 )
                 => ( ( P @ X3 @ Xa3 )
                   => ( Q @ X3 @ Xa3 ) ) ) )
         => ( ( ord_less_eq @ ( set @ ( product_prod @ A @ B ) ) @ A3 @ ( collect @ ( product_prod @ A @ B ) @ ( product_case_prod @ A @ B @ $o @ P ) ) )
           => ( ord_less_eq @ ( set @ ( product_prod @ A @ B ) ) @ A3 @ ( collect @ ( product_prod @ A @ B ) @ ( product_case_prod @ A @ B @ $o @ Q ) ) ) ) ) ) ) ).

% Collect_split_mono_strong
thf(fact_5999_UN__le__add__shift__strict,axiom,
    ! [A: $tType,M7: nat > ( set @ A ),K: nat,N2: nat] :
      ( ( complete_Sup_Sup @ ( set @ A )
        @ ( image @ nat @ ( set @ A )
          @ ^ [I4: nat] : ( M7 @ ( plus_plus @ nat @ I4 @ K ) )
          @ ( set_ord_lessThan @ nat @ N2 ) ) )
      = ( complete_Sup_Sup @ ( set @ A ) @ ( image @ nat @ ( set @ A ) @ M7 @ ( set_or7035219750837199246ssThan @ nat @ K @ ( plus_plus @ nat @ N2 @ K ) ) ) ) ) ).

% UN_le_add_shift_strict
thf(fact_6000_UN__le__add__shift,axiom,
    ! [A: $tType,M7: nat > ( set @ A ),K: nat,N2: nat] :
      ( ( complete_Sup_Sup @ ( set @ A )
        @ ( image @ nat @ ( set @ A )
          @ ^ [I4: nat] : ( M7 @ ( plus_plus @ nat @ I4 @ K ) )
          @ ( set_ord_atMost @ nat @ N2 ) ) )
      = ( complete_Sup_Sup @ ( set @ A ) @ ( image @ nat @ ( set @ A ) @ M7 @ ( set_or1337092689740270186AtMost @ nat @ K @ ( plus_plus @ nat @ N2 @ K ) ) ) ) ) ).

% UN_le_add_shift
thf(fact_6001_subset__subseqs,axiom,
    ! [A: $tType,X8: set @ A,Xs: list @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ X8 @ ( set2 @ A @ Xs ) )
     => ( member @ ( set @ A ) @ X8 @ ( image @ ( list @ A ) @ ( set @ A ) @ ( set2 @ A ) @ ( set2 @ ( list @ A ) @ ( subseqs @ A @ Xs ) ) ) ) ) ).

% subset_subseqs
thf(fact_6002_subseqs__powset,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( image @ ( list @ A ) @ ( set @ A ) @ ( set2 @ A ) @ ( set2 @ ( list @ A ) @ ( subseqs @ A @ Xs ) ) )
      = ( pow2 @ A @ ( set2 @ A @ Xs ) ) ) ).

% subseqs_powset
thf(fact_6003_image__add__int__atLeastLessThan,axiom,
    ! [L: int,U: int] :
      ( ( image @ int @ int
        @ ^ [X5: int] : ( plus_plus @ int @ X5 @ L )
        @ ( set_or7035219750837199246ssThan @ int @ ( zero_zero @ int ) @ ( minus_minus @ int @ U @ L ) ) )
      = ( set_or7035219750837199246ssThan @ int @ L @ U ) ) ).

% image_add_int_atLeastLessThan
thf(fact_6004_card__def,axiom,
    ! [B: $tType] :
      ( ( finite_card @ B )
      = ( finite_folding_F @ B @ nat
        @ ^ [Uu3: B] : suc
        @ ( zero_zero @ nat ) ) ) ).

% card_def
thf(fact_6005_card__UN__le,axiom,
    ! [B: $tType,A: $tType,I6: set @ A,A3: A > ( set @ B )] :
      ( ( finite_finite @ A @ I6 )
     => ( ord_less_eq @ nat @ ( finite_card @ B @ ( complete_Sup_Sup @ ( set @ B ) @ ( image @ A @ ( set @ B ) @ A3 @ I6 ) ) )
        @ ( groups7311177749621191930dd_sum @ A @ nat
          @ ^ [I4: A] : ( finite_card @ B @ ( A3 @ I4 ) )
          @ I6 ) ) ) ).

% card_UN_le
thf(fact_6006_image__atLeastZeroLessThan__int,axiom,
    ! [U: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ U )
     => ( ( set_or7035219750837199246ssThan @ int @ ( zero_zero @ int ) @ U )
        = ( image @ nat @ int @ ( semiring_1_of_nat @ int ) @ ( set_ord_lessThan @ nat @ ( nat2 @ U ) ) ) ) ) ).

% image_atLeastZeroLessThan_int
thf(fact_6007_folding__on_Oinsert,axiom,
    ! [B: $tType,A: $tType,S3: set @ A,F2: A > B > B,X2: A,A3: set @ A,Z: B] :
      ( ( finite_folding_on @ A @ B @ S3 @ F2 )
     => ( ( ord_less_eq @ ( set @ A ) @ ( insert @ A @ X2 @ A3 ) @ S3 )
       => ( ( finite_finite @ A @ A3 )
         => ( ~ ( member @ A @ X2 @ A3 )
           => ( ( finite_folding_F @ A @ B @ F2 @ Z @ ( insert @ A @ X2 @ A3 ) )
              = ( F2 @ X2 @ ( finite_folding_F @ A @ B @ F2 @ Z @ A3 ) ) ) ) ) ) ) ).

% folding_on.insert
thf(fact_6008_UN__image__subset,axiom,
    ! [C: $tType,A: $tType,B: $tType,F2: B > ( set @ A ),G: C > ( set @ B ),X2: C,X8: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ ( complete_Sup_Sup @ ( set @ A ) @ ( image @ B @ ( set @ A ) @ F2 @ ( G @ X2 ) ) ) @ X8 )
      = ( ord_less_eq @ ( set @ B ) @ ( G @ X2 )
        @ ( collect @ B
          @ ^ [X5: B] : ( ord_less_eq @ ( set @ A ) @ ( F2 @ X5 ) @ X8 ) ) ) ) ).

% UN_image_subset
thf(fact_6009_folding__idem__on_Oinsert__idem,axiom,
    ! [B: $tType,A: $tType,S3: set @ A,F2: A > B > B,X2: A,A3: set @ A,Z: B] :
      ( ( finite1890593828518410140dem_on @ A @ B @ S3 @ F2 )
     => ( ( ord_less_eq @ ( set @ A ) @ ( insert @ A @ X2 @ A3 ) @ S3 )
       => ( ( finite_finite @ A @ A3 )
         => ( ( finite_folding_F @ A @ B @ F2 @ Z @ ( insert @ A @ X2 @ A3 ) )
            = ( F2 @ X2 @ ( finite_folding_F @ A @ B @ F2 @ Z @ A3 ) ) ) ) ) ) ).

% folding_idem_on.insert_idem
thf(fact_6010_conj__subset__def,axiom,
    ! [A: $tType,A3: set @ A,P: A > $o,Q: A > $o] :
      ( ( ord_less_eq @ ( set @ A ) @ A3
        @ ( collect @ A
          @ ^ [X5: A] :
              ( ( P @ X5 )
              & ( Q @ X5 ) ) ) )
      = ( ( ord_less_eq @ ( set @ A ) @ A3 @ ( collect @ A @ P ) )
        & ( ord_less_eq @ ( set @ A ) @ A3 @ ( collect @ A @ Q ) ) ) ) ).

% conj_subset_def
thf(fact_6011_length__remdups__concat,axiom,
    ! [A: $tType,Xss: list @ ( list @ A )] :
      ( ( size_size @ ( list @ A ) @ ( remdups @ A @ ( concat @ A @ Xss ) ) )
      = ( finite_card @ A @ ( complete_Sup_Sup @ ( set @ A ) @ ( image @ ( list @ A ) @ ( set @ A ) @ ( set2 @ A ) @ ( set2 @ ( list @ A ) @ Xss ) ) ) ) ) ).

% length_remdups_concat
thf(fact_6012_suminf__eq__SUP__real,axiom,
    ! [X8: nat > real] :
      ( ( summable @ real @ X8 )
     => ( ! [I2: nat] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( X8 @ I2 ) )
       => ( ( suminf @ real @ X8 )
          = ( complete_Sup_Sup @ real
            @ ( image @ nat @ real
              @ ^ [I4: nat] : ( groups7311177749621191930dd_sum @ nat @ real @ X8 @ ( set_ord_lessThan @ nat @ I4 ) )
              @ ( top_top @ ( set @ nat ) ) ) ) ) ) ) ).

% suminf_eq_SUP_real
thf(fact_6013_remdups__eq__nil__iff,axiom,
    ! [A: $tType,X2: list @ A] :
      ( ( ( remdups @ A @ X2 )
        = ( nil @ A ) )
      = ( X2
        = ( nil @ A ) ) ) ).

% remdups_eq_nil_iff
thf(fact_6014_remdups__eq__nil__right__iff,axiom,
    ! [A: $tType,X2: list @ A] :
      ( ( ( nil @ A )
        = ( remdups @ A @ X2 ) )
      = ( X2
        = ( nil @ A ) ) ) ).

% remdups_eq_nil_right_iff
thf(fact_6015_set__remdups,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( set2 @ A @ ( remdups @ A @ Xs ) )
      = ( set2 @ A @ Xs ) ) ).

% set_remdups
thf(fact_6016_length__remdups__eq,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( ( size_size @ ( list @ A ) @ ( remdups @ A @ Xs ) )
        = ( size_size @ ( list @ A ) @ Xs ) )
      = ( ( remdups @ A @ Xs )
        = Xs ) ) ).

% length_remdups_eq
thf(fact_6017_remdups__id__iff__distinct,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( ( remdups @ A @ Xs )
        = Xs )
      = ( distinct @ A @ Xs ) ) ).

% remdups_id_iff_distinct
thf(fact_6018_distinct__remdups,axiom,
    ! [A: $tType,Xs: list @ A] : ( distinct @ A @ ( remdups @ A @ Xs ) ) ).

% distinct_remdups
thf(fact_6019_range__add,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A] :
          ( ( image @ A @ A @ ( plus_plus @ A @ A2 ) @ ( top_top @ ( set @ A ) ) )
          = ( top_top @ ( set @ A ) ) ) ) ).

% range_add
thf(fact_6020_surj__plus,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [A2: A] :
          ( ( image @ A @ A @ ( plus_plus @ A @ A2 ) @ ( top_top @ ( set @ A ) ) )
          = ( top_top @ ( set @ A ) ) ) ) ).

% surj_plus
thf(fact_6021_Sup__eq__top__iff,axiom,
    ! [A: $tType] :
      ( ( comple5582772986160207858norder @ A )
     => ! [A3: set @ A] :
          ( ( ( complete_Sup_Sup @ A @ A3 )
            = ( top_top @ A ) )
          = ( ! [X5: A] :
                ( ( ord_less @ A @ X5 @ ( top_top @ A ) )
               => ? [Y5: A] :
                    ( ( member @ A @ Y5 @ A3 )
                    & ( ord_less @ A @ X5 @ Y5 ) ) ) ) ) ) ).

% Sup_eq_top_iff
thf(fact_6022_surj__fn,axiom,
    ! [A: $tType,F2: A > A,N2: nat] :
      ( ( ( image @ A @ A @ F2 @ ( top_top @ ( set @ A ) ) )
        = ( top_top @ ( set @ A ) ) )
     => ( ( image @ A @ A @ ( compow @ ( A > A ) @ N2 @ F2 ) @ ( top_top @ ( set @ A ) ) )
        = ( top_top @ ( set @ A ) ) ) ) ).

% surj_fn
thf(fact_6023_Gcd__UNIV,axiom,
    ! [A: $tType] :
      ( ( semiring_Gcd @ A )
     => ( ( gcd_Gcd @ A @ ( top_top @ ( set @ A ) ) )
        = ( one_one @ A ) ) ) ).

% Gcd_UNIV
thf(fact_6024_length__remdups__leq,axiom,
    ! [A: $tType,Xs: list @ A] : ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ ( remdups @ A @ Xs ) ) @ ( size_size @ ( list @ A ) @ Xs ) ) ).

% length_remdups_leq
thf(fact_6025_SUP__eq__top__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comple5582772986160207858norder @ A )
     => ! [F2: B > A,A3: set @ B] :
          ( ( ( complete_Sup_Sup @ A @ ( image @ B @ A @ F2 @ A3 ) )
            = ( top_top @ A ) )
          = ( ! [X5: A] :
                ( ( ord_less @ A @ X5 @ ( top_top @ A ) )
               => ? [Y5: B] :
                    ( ( member @ B @ Y5 @ A3 )
                    & ( ord_less @ A @ X5 @ ( F2 @ Y5 ) ) ) ) ) ) ) ).

% SUP_eq_top_iff
thf(fact_6026_Inf__atMostLessThan,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [X2: A] :
          ( ( ord_less @ A @ ( top_top @ A ) @ X2 )
         => ( ( complete_Inf_Inf @ A @ ( set_ord_lessThan @ A @ X2 ) )
            = ( bot_bot @ A ) ) ) ) ).

% Inf_atMostLessThan
thf(fact_6027_UNIV__option__conv,axiom,
    ! [A: $tType] :
      ( ( top_top @ ( set @ ( option @ A ) ) )
      = ( insert @ ( option @ A ) @ ( none @ A ) @ ( image @ A @ ( option @ A ) @ ( some @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ).

% UNIV_option_conv
thf(fact_6028_range__subsetD,axiom,
    ! [B: $tType,A: $tType,F2: B > A,B3: set @ A,I3: B] :
      ( ( ord_less_eq @ ( set @ A ) @ ( image @ B @ A @ F2 @ ( top_top @ ( set @ B ) ) ) @ B3 )
     => ( member @ A @ ( F2 @ I3 ) @ B3 ) ) ).

% range_subsetD
thf(fact_6029_top__greatest,axiom,
    ! [A: $tType] :
      ( ( order_top @ A )
     => ! [A2: A] : ( ord_less_eq @ A @ A2 @ ( top_top @ A ) ) ) ).

% top_greatest
thf(fact_6030_top_Oextremum__unique,axiom,
    ! [A: $tType] :
      ( ( order_top @ A )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ ( top_top @ A ) @ A2 )
          = ( A2
            = ( top_top @ A ) ) ) ) ).

% top.extremum_unique
thf(fact_6031_top_Oextremum__uniqueI,axiom,
    ! [A: $tType] :
      ( ( order_top @ A )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ ( top_top @ A ) @ A2 )
         => ( A2
            = ( top_top @ A ) ) ) ) ).

% top.extremum_uniqueI
thf(fact_6032_subset__UNIV,axiom,
    ! [A: $tType,A3: set @ A] : ( ord_less_eq @ ( set @ A ) @ A3 @ ( top_top @ ( set @ A ) ) ) ).

% subset_UNIV
thf(fact_6033_not__UNIV__le__Icc,axiom,
    ! [A: $tType] :
      ( ( no_top @ A )
     => ! [L: A,H2: A] :
          ~ ( ord_less_eq @ ( set @ A ) @ ( top_top @ ( set @ A ) ) @ ( set_or1337092689740270186AtMost @ A @ L @ H2 ) ) ) ).

% not_UNIV_le_Icc
thf(fact_6034_distinct__remdups__id,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( distinct @ A @ Xs )
     => ( ( remdups @ A @ Xs )
        = Xs ) ) ).

% distinct_remdups_id
thf(fact_6035_finite__fun__UNIVD1,axiom,
    ! [B: $tType,A: $tType] :
      ( ( finite_finite @ ( A > B ) @ ( top_top @ ( set @ ( A > B ) ) ) )
     => ( ( ( finite_card @ B @ ( top_top @ ( set @ B ) ) )
         != ( suc @ ( zero_zero @ nat ) ) )
       => ( finite_finite @ A @ ( top_top @ ( set @ A ) ) ) ) ) ).

% finite_fun_UNIVD1
thf(fact_6036_top_Onot__eq__extremum,axiom,
    ! [A: $tType] :
      ( ( order_top @ A )
     => ! [A2: A] :
          ( ( ( A2
             != ( top_top @ A ) ) )
          = ( ord_less @ A @ A2 @ ( top_top @ A ) ) ) ) ).

% top.not_eq_extremum
thf(fact_6037_top_Oextremum__strict,axiom,
    ! [A: $tType] :
      ( ( order_top @ A )
     => ! [A2: A] :
          ~ ( ord_less @ A @ ( top_top @ A ) @ A2 ) ) ).

% top.extremum_strict
thf(fact_6038_remdups__remdups,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( remdups @ A @ ( remdups @ A @ Xs ) )
      = ( remdups @ A @ Xs ) ) ).

% remdups_remdups
thf(fact_6039_remdups_Osimps_I1_J,axiom,
    ! [A: $tType] :
      ( ( remdups @ A @ ( nil @ A ) )
      = ( nil @ A ) ) ).

% remdups.simps(1)
thf(fact_6040_sorted__list__of__set_Ofold__insort__key_Ofolding__on__axioms,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( finite_folding_on @ A @ ( list @ A ) @ ( top_top @ ( set @ A ) )
        @ ( linorder_insort_key @ A @ A
          @ ^ [X5: A] : X5 ) ) ) ).

% sorted_list_of_set.fold_insort_key.folding_on_axioms
thf(fact_6041_card_Ofolding__on__axioms,axiom,
    ! [A: $tType] :
      ( finite_folding_on @ A @ nat @ ( top_top @ ( set @ A ) )
      @ ^ [Uu3: A] : suc ) ).

% card.folding_on_axioms
thf(fact_6042_not__UNIV__le__Iic,axiom,
    ! [A: $tType] :
      ( ( no_top @ A )
     => ! [H2: A] :
          ~ ( ord_less_eq @ ( set @ A ) @ ( top_top @ ( set @ A ) ) @ ( set_ord_atMost @ A @ H2 ) ) ) ).

% not_UNIV_le_Iic
thf(fact_6043_bij__fn,axiom,
    ! [A: $tType,F2: A > A,N2: nat] :
      ( ( bij_betw @ A @ A @ F2 @ ( top_top @ ( set @ A ) ) @ ( top_top @ ( set @ A ) ) )
     => ( bij_betw @ A @ A @ ( compow @ ( A > A ) @ N2 @ F2 ) @ ( top_top @ ( set @ A ) ) @ ( top_top @ ( set @ A ) ) ) ) ).

% bij_fn
thf(fact_6044_remove1__remdups,axiom,
    ! [A: $tType,Xs: list @ A,X2: A] :
      ( ( distinct @ A @ Xs )
     => ( ( remove1 @ A @ X2 @ ( remdups @ A @ Xs ) )
        = ( remdups @ A @ ( remove1 @ A @ X2 @ Xs ) ) ) ) ).

% remove1_remdups
thf(fact_6045_surj__Compl__image__subset,axiom,
    ! [A: $tType,B: $tType,F2: B > A,A3: set @ B] :
      ( ( ( image @ B @ A @ F2 @ ( top_top @ ( set @ B ) ) )
        = ( top_top @ ( set @ A ) ) )
     => ( ord_less_eq @ ( set @ A ) @ ( uminus_uminus @ ( set @ A ) @ ( image @ B @ A @ F2 @ A3 ) ) @ ( image @ B @ A @ F2 @ ( uminus_uminus @ ( set @ B ) @ A3 ) ) ) ) ).

% surj_Compl_image_subset
thf(fact_6046_length__remdups__card__conv,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( size_size @ ( list @ A ) @ ( remdups @ A @ Xs ) )
      = ( finite_card @ A @ ( set2 @ A @ Xs ) ) ) ).

% length_remdups_card_conv
thf(fact_6047_finite__range__Some,axiom,
    ! [A: $tType] :
      ( ( finite_finite @ ( option @ A ) @ ( image @ A @ ( option @ A ) @ ( some @ A ) @ ( top_top @ ( set @ A ) ) ) )
      = ( finite_finite @ A @ ( top_top @ ( set @ A ) ) ) ) ).

% finite_range_Some
thf(fact_6048_notin__range__Some,axiom,
    ! [A: $tType,X2: option @ A] :
      ( ( ~ ( member @ ( option @ A ) @ X2 @ ( image @ A @ ( option @ A ) @ ( some @ A ) @ ( top_top @ ( set @ A ) ) ) ) )
      = ( X2
        = ( none @ A ) ) ) ).

% notin_range_Some
thf(fact_6049_inf__top_Osemilattice__neutr__order__axioms,axiom,
    ! [A: $tType] :
      ( ( bounde4346867609351753570nf_top @ A )
     => ( semila1105856199041335345_order @ A @ ( inf_inf @ A ) @ ( top_top @ A ) @ ( ord_less_eq @ A ) @ ( ord_less @ A ) ) ) ).

% inf_top.semilattice_neutr_order_axioms
thf(fact_6050_finite__UNIV__card__ge__0,axiom,
    ! [A: $tType] :
      ( ( finite_finite @ A @ ( top_top @ ( set @ A ) ) )
     => ( ord_less @ nat @ ( zero_zero @ nat ) @ ( finite_card @ A @ ( top_top @ ( set @ A ) ) ) ) ) ).

% finite_UNIV_card_ge_0
thf(fact_6051_UN__UN__finite__eq,axiom,
    ! [A: $tType,A3: nat > ( set @ A )] :
      ( ( complete_Sup_Sup @ ( set @ A )
        @ ( image @ nat @ ( set @ A )
          @ ^ [N3: nat] : ( complete_Sup_Sup @ ( set @ A ) @ ( image @ nat @ ( set @ A ) @ A3 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N3 ) ) )
          @ ( top_top @ ( set @ nat ) ) ) )
      = ( complete_Sup_Sup @ ( set @ A ) @ ( image @ nat @ ( set @ A ) @ A3 @ ( top_top @ ( set @ nat ) ) ) ) ) ).

% UN_UN_finite_eq
thf(fact_6052_card__range__greater__zero,axiom,
    ! [A: $tType,B: $tType,F2: B > A] :
      ( ( finite_finite @ A @ ( image @ B @ A @ F2 @ ( top_top @ ( set @ B ) ) ) )
     => ( ord_less @ nat @ ( zero_zero @ nat ) @ ( finite_card @ A @ ( image @ B @ A @ F2 @ ( top_top @ ( set @ B ) ) ) ) ) ) ).

% card_range_greater_zero
thf(fact_6053_UN__finite__subset,axiom,
    ! [A: $tType,A3: nat > ( set @ A ),C6: set @ A] :
      ( ! [N: nat] : ( ord_less_eq @ ( set @ A ) @ ( complete_Sup_Sup @ ( set @ A ) @ ( image @ nat @ ( set @ A ) @ A3 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N ) ) ) @ C6 )
     => ( ord_less_eq @ ( set @ A ) @ ( complete_Sup_Sup @ ( set @ A ) @ ( image @ nat @ ( set @ A ) @ A3 @ ( top_top @ ( set @ nat ) ) ) ) @ C6 ) ) ).

% UN_finite_subset
thf(fact_6054_UN__finite2__eq,axiom,
    ! [A: $tType,A3: nat > ( set @ A ),B3: nat > ( set @ A ),K: nat] :
      ( ! [N: nat] :
          ( ( complete_Sup_Sup @ ( set @ A ) @ ( image @ nat @ ( set @ A ) @ A3 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N ) ) )
          = ( complete_Sup_Sup @ ( set @ A ) @ ( image @ nat @ ( set @ A ) @ B3 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( plus_plus @ nat @ N @ K ) ) ) ) )
     => ( ( complete_Sup_Sup @ ( set @ A ) @ ( image @ nat @ ( set @ A ) @ A3 @ ( top_top @ ( set @ nat ) ) ) )
        = ( complete_Sup_Sup @ ( set @ A ) @ ( image @ nat @ ( set @ A ) @ B3 @ ( top_top @ ( set @ nat ) ) ) ) ) ) ).

% UN_finite2_eq
thf(fact_6055_range__mod,axiom,
    ! [N2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( image @ nat @ nat
          @ ^ [M6: nat] : ( modulo_modulo @ nat @ M6 @ N2 )
          @ ( top_top @ ( set @ nat ) ) )
        = ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N2 ) ) ) ).

% range_mod
thf(fact_6056_UN__finite2__subset,axiom,
    ! [A: $tType,A3: nat > ( set @ A ),B3: nat > ( set @ A ),K: nat] :
      ( ! [N: nat] : ( ord_less_eq @ ( set @ A ) @ ( complete_Sup_Sup @ ( set @ A ) @ ( image @ nat @ ( set @ A ) @ A3 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N ) ) ) @ ( complete_Sup_Sup @ ( set @ A ) @ ( image @ nat @ ( set @ A ) @ B3 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( plus_plus @ nat @ N @ K ) ) ) ) )
     => ( ord_less_eq @ ( set @ A ) @ ( complete_Sup_Sup @ ( set @ A ) @ ( image @ nat @ ( set @ A ) @ A3 @ ( top_top @ ( set @ nat ) ) ) ) @ ( complete_Sup_Sup @ ( set @ A ) @ ( image @ nat @ ( set @ A ) @ B3 @ ( top_top @ ( set @ nat ) ) ) ) ) ) ).

% UN_finite2_subset
thf(fact_6057_finite__mono__strict__prefix__implies__finite__fixpoint,axiom,
    ! [A: $tType,F2: nat > ( set @ A ),S3: set @ A] :
      ( ! [I2: nat] : ( ord_less_eq @ ( set @ A ) @ ( F2 @ I2 ) @ S3 )
     => ( ( finite_finite @ A @ S3 )
       => ( ? [N7: nat] :
              ( ! [N: nat] :
                  ( ( ord_less_eq @ nat @ N @ N7 )
                 => ! [M3: nat] :
                      ( ( ord_less_eq @ nat @ M3 @ N7 )
                     => ( ( ord_less @ nat @ M3 @ N )
                       => ( ord_less @ ( set @ A ) @ ( F2 @ M3 ) @ ( F2 @ N ) ) ) ) )
              & ! [N: nat] :
                  ( ( ord_less_eq @ nat @ N7 @ N )
                 => ( ( F2 @ N7 )
                    = ( F2 @ N ) ) ) )
         => ( ( F2 @ ( finite_card @ A @ S3 ) )
            = ( complete_Sup_Sup @ ( set @ A ) @ ( image @ nat @ ( set @ A ) @ F2 @ ( top_top @ ( set @ nat ) ) ) ) ) ) ) ) ).

% finite_mono_strict_prefix_implies_finite_fixpoint
thf(fact_6058_UNIV__nat__eq,axiom,
    ( ( top_top @ ( set @ nat ) )
    = ( insert @ nat @ ( zero_zero @ nat ) @ ( image @ nat @ nat @ suc @ ( top_top @ ( set @ nat ) ) ) ) ) ).

% UNIV_nat_eq
thf(fact_6059_INF__filter__not__bot,axiom,
    ! [I7: $tType,A: $tType,B3: set @ I7,F3: I7 > ( filter @ A )] :
      ( ! [X10: set @ I7] :
          ( ( ord_less_eq @ ( set @ I7 ) @ X10 @ B3 )
         => ( ( finite_finite @ I7 @ X10 )
           => ( ( complete_Inf_Inf @ ( filter @ A ) @ ( image @ I7 @ ( filter @ A ) @ F3 @ X10 ) )
             != ( bot_bot @ ( filter @ A ) ) ) ) )
     => ( ( complete_Inf_Inf @ ( filter @ A ) @ ( image @ I7 @ ( filter @ A ) @ F3 @ B3 ) )
       != ( bot_bot @ ( filter @ A ) ) ) ) ).

% INF_filter_not_bot
thf(fact_6060_card__UNIV__unit,axiom,
    ( ( finite_card @ product_unit @ ( top_top @ ( set @ product_unit ) ) )
    = ( one_one @ nat ) ) ).

% card_UNIV_unit
thf(fact_6061_card__UNIV__bool,axiom,
    ( ( finite_card @ $o @ ( top_top @ ( set @ $o ) ) )
    = ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ).

% card_UNIV_bool
thf(fact_6062_range__mult,axiom,
    ! [A2: real] :
      ( ( ( A2
          = ( zero_zero @ real ) )
       => ( ( image @ real @ real @ ( times_times @ real @ A2 ) @ ( top_top @ ( set @ real ) ) )
          = ( insert @ real @ ( zero_zero @ real ) @ ( bot_bot @ ( set @ real ) ) ) ) )
      & ( ( A2
         != ( zero_zero @ real ) )
       => ( ( image @ real @ real @ ( times_times @ real @ A2 ) @ ( top_top @ ( set @ real ) ) )
          = ( top_top @ ( set @ real ) ) ) ) ) ).

% range_mult
thf(fact_6063_INF__filter__bot__base,axiom,
    ! [B: $tType,A: $tType,I6: set @ A,F3: A > ( filter @ B )] :
      ( ! [I2: A] :
          ( ( member @ A @ I2 @ I6 )
         => ! [J2: A] :
              ( ( member @ A @ J2 @ I6 )
             => ? [X: A] :
                  ( ( member @ A @ X @ I6 )
                  & ( ord_less_eq @ ( filter @ B ) @ ( F3 @ X ) @ ( inf_inf @ ( filter @ B ) @ ( F3 @ I2 ) @ ( F3 @ J2 ) ) ) ) ) )
     => ( ( ( complete_Inf_Inf @ ( filter @ B ) @ ( image @ A @ ( filter @ B ) @ F3 @ I6 ) )
          = ( bot_bot @ ( filter @ B ) ) )
        = ( ? [X5: A] :
              ( ( member @ A @ X5 @ I6 )
              & ( ( F3 @ X5 )
                = ( bot_bot @ ( filter @ B ) ) ) ) ) ) ) ).

% INF_filter_bot_base
thf(fact_6064_infinite__UNIV__listI,axiom,
    ! [A: $tType] :
      ~ ( finite_finite @ ( list @ A ) @ ( top_top @ ( set @ ( list @ A ) ) ) ) ).

% infinite_UNIV_listI
thf(fact_6065_top__empty__eq2,axiom,
    ! [B: $tType,A: $tType] :
      ( ( top_top @ ( A > B > $o ) )
      = ( ^ [X5: A,Y5: B] : ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X5 @ Y5 ) @ ( top_top @ ( set @ ( product_prod @ A @ B ) ) ) ) ) ) ).

% top_empty_eq2
thf(fact_6066_Inf__filter__not__bot,axiom,
    ! [A: $tType,B3: set @ ( filter @ A )] :
      ( ! [X10: set @ ( filter @ A )] :
          ( ( ord_less_eq @ ( set @ ( filter @ A ) ) @ X10 @ B3 )
         => ( ( finite_finite @ ( filter @ A ) @ X10 )
           => ( ( complete_Inf_Inf @ ( filter @ A ) @ X10 )
             != ( bot_bot @ ( filter @ A ) ) ) ) )
     => ( ( complete_Inf_Inf @ ( filter @ A ) @ B3 )
       != ( bot_bot @ ( filter @ A ) ) ) ) ).

% Inf_filter_not_bot
thf(fact_6067_root__def,axiom,
    ( root
    = ( ^ [N3: nat,X5: real] :
          ( if @ real
          @ ( N3
            = ( zero_zero @ nat ) )
          @ ( zero_zero @ real )
          @ ( the_inv_into @ real @ real @ ( top_top @ ( set @ real ) )
            @ ^ [Y5: real] : ( times_times @ real @ ( sgn_sgn @ real @ Y5 ) @ ( power_power @ real @ ( abs_abs @ real @ Y5 ) @ N3 ) )
            @ X5 ) ) ) ) ).

% root_def
thf(fact_6068_card__UNIV__char,axiom,
    ( ( finite_card @ char @ ( top_top @ ( set @ char ) ) )
    = ( numeral_numeral @ nat @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ).

% card_UNIV_char
thf(fact_6069_less__filter__def,axiom,
    ! [A: $tType] :
      ( ( ord_less @ ( filter @ A ) )
      = ( ^ [F9: filter @ A,F10: filter @ A] :
            ( ( ord_less_eq @ ( filter @ A ) @ F9 @ F10 )
            & ~ ( ord_less_eq @ ( filter @ A ) @ F10 @ F9 ) ) ) ) ).

% less_filter_def
thf(fact_6070_UNIV__char__of__nat,axiom,
    ( ( top_top @ ( set @ char ) )
    = ( image @ nat @ char @ ( unique5772411509450598832har_of @ nat ) @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( numeral_numeral @ nat @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ) ) ).

% UNIV_char_of_nat
thf(fact_6071_char__of__mod__256,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [N2: A] :
          ( ( unique5772411509450598832har_of @ A @ ( modulo_modulo @ A @ N2 @ ( numeral_numeral @ A @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) )
          = ( unique5772411509450598832har_of @ A @ N2 ) ) ) ).

% char_of_mod_256
thf(fact_6072_char__of__quasi__inj,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [M: A,N2: A] :
          ( ( ( unique5772411509450598832har_of @ A @ M )
            = ( unique5772411509450598832har_of @ A @ N2 ) )
          = ( ( modulo_modulo @ A @ M @ ( numeral_numeral @ A @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) )
            = ( modulo_modulo @ A @ N2 @ ( numeral_numeral @ A @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ) ) ) ).

% char_of_quasi_inj
thf(fact_6073_char__of__take__bit__eq,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [N2: nat,M: A] :
          ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ ( bit0 @ ( bit0 @ one2 ) ) ) ) @ N2 )
         => ( ( unique5772411509450598832har_of @ A @ ( bit_se2584673776208193580ke_bit @ A @ N2 @ M ) )
            = ( unique5772411509450598832har_of @ A @ M ) ) ) ) ).

% char_of_take_bit_eq
thf(fact_6074_of__char__of,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [A2: A] :
          ( ( comm_s6883823935334413003f_char @ A @ ( unique5772411509450598832har_of @ A @ A2 ) )
          = ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ) ) ).

% of_char_of
thf(fact_6075_char__of__def,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ( ( unique5772411509450598832har_of @ A )
        = ( ^ [N3: A] :
              ( char2
              @ ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N3 )
              @ ( bit_se5641148757651400278ts_bit @ A @ N3 @ ( one_one @ nat ) )
              @ ( bit_se5641148757651400278ts_bit @ A @ N3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
              @ ( bit_se5641148757651400278ts_bit @ A @ N3 @ ( numeral_numeral @ nat @ ( bit1 @ one2 ) ) )
              @ ( bit_se5641148757651400278ts_bit @ A @ N3 @ ( numeral_numeral @ nat @ ( bit0 @ ( bit0 @ one2 ) ) ) )
              @ ( bit_se5641148757651400278ts_bit @ A @ N3 @ ( numeral_numeral @ nat @ ( bit1 @ ( bit0 @ one2 ) ) ) )
              @ ( bit_se5641148757651400278ts_bit @ A @ N3 @ ( numeral_numeral @ nat @ ( bit0 @ ( bit1 @ one2 ) ) ) )
              @ ( bit_se5641148757651400278ts_bit @ A @ N3 @ ( numeral_numeral @ nat @ ( bit1 @ ( bit1 @ one2 ) ) ) ) ) ) ) ) ).

% char_of_def
thf(fact_6076_of__char__mod__256,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [C2: char] :
          ( ( modulo_modulo @ A @ ( comm_s6883823935334413003f_char @ A @ C2 ) @ ( numeral_numeral @ A @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) )
          = ( comm_s6883823935334413003f_char @ A @ C2 ) ) ) ).

% of_char_mod_256
thf(fact_6077_char_Osize_I2_J,axiom,
    ! [X1: $o,X22: $o,X32: $o,X42: $o,X52: $o,X62: $o,X72: $o,X82: $o] :
      ( ( size_size @ char @ ( char2 @ X1 @ X22 @ X32 @ X42 @ X52 @ X62 @ X72 @ X82 ) )
      = ( zero_zero @ nat ) ) ).

% char.size(2)
thf(fact_6078_nat__of__char__less__256,axiom,
    ! [C2: char] : ( ord_less @ nat @ ( comm_s6883823935334413003f_char @ nat @ C2 ) @ ( numeral_numeral @ nat @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ).

% nat_of_char_less_256
thf(fact_6079_range__nat__of__char,axiom,
    ( ( image @ char @ nat @ ( comm_s6883823935334413003f_char @ nat ) @ ( top_top @ ( set @ char ) ) )
    = ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( numeral_numeral @ nat @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ) ).

% range_nat_of_char
thf(fact_6080_char__of__eq__iff,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [N2: A,C2: char] :
          ( ( ( unique5772411509450598832har_of @ A @ N2 )
            = C2 )
          = ( ( bit_se2584673776208193580ke_bit @ A @ ( numeral_numeral @ nat @ ( bit0 @ ( bit0 @ ( bit0 @ one2 ) ) ) ) @ N2 )
            = ( comm_s6883823935334413003f_char @ A @ C2 ) ) ) ) ).

% char_of_eq_iff
thf(fact_6081_integer__of__char__code,axiom,
    ! [B0: $o,B1: $o,B22: $o,B32: $o,B42: $o,B52: $o,B62: $o,B72: $o] :
      ( ( integer_of_char @ ( char2 @ B0 @ B1 @ B22 @ B32 @ B42 @ B52 @ B62 @ B72 ) )
      = ( plus_plus @ code_integer @ ( times_times @ code_integer @ ( plus_plus @ code_integer @ ( times_times @ code_integer @ ( plus_plus @ code_integer @ ( times_times @ code_integer @ ( plus_plus @ code_integer @ ( times_times @ code_integer @ ( plus_plus @ code_integer @ ( times_times @ code_integer @ ( plus_plus @ code_integer @ ( times_times @ code_integer @ ( plus_plus @ code_integer @ ( times_times @ code_integer @ ( zero_neq_one_of_bool @ code_integer @ B72 ) @ ( numeral_numeral @ code_integer @ ( bit0 @ one2 ) ) ) @ ( zero_neq_one_of_bool @ code_integer @ B62 ) ) @ ( numeral_numeral @ code_integer @ ( bit0 @ one2 ) ) ) @ ( zero_neq_one_of_bool @ code_integer @ B52 ) ) @ ( numeral_numeral @ code_integer @ ( bit0 @ one2 ) ) ) @ ( zero_neq_one_of_bool @ code_integer @ B42 ) ) @ ( numeral_numeral @ code_integer @ ( bit0 @ one2 ) ) ) @ ( zero_neq_one_of_bool @ code_integer @ B32 ) ) @ ( numeral_numeral @ code_integer @ ( bit0 @ one2 ) ) ) @ ( zero_neq_one_of_bool @ code_integer @ B22 ) ) @ ( numeral_numeral @ code_integer @ ( bit0 @ one2 ) ) ) @ ( zero_neq_one_of_bool @ code_integer @ B1 ) ) @ ( numeral_numeral @ code_integer @ ( bit0 @ one2 ) ) ) @ ( zero_neq_one_of_bool @ code_integer @ B0 ) ) ) ).

% integer_of_char_code
thf(fact_6082_char_Osize__gen,axiom,
    ! [X1: $o,X22: $o,X32: $o,X42: $o,X52: $o,X62: $o,X72: $o,X82: $o] :
      ( ( size_char @ ( char2 @ X1 @ X22 @ X32 @ X42 @ X52 @ X62 @ X72 @ X82 ) )
      = ( zero_zero @ nat ) ) ).

% char.size_gen
thf(fact_6083_String_Ochar__of__ascii__of,axiom,
    ! [C2: char] :
      ( ( comm_s6883823935334413003f_char @ nat @ ( ascii_of @ C2 ) )
      = ( bit_se2584673776208193580ke_bit @ nat @ ( numeral_numeral @ nat @ ( bit1 @ ( bit1 @ one2 ) ) ) @ ( comm_s6883823935334413003f_char @ nat @ C2 ) ) ) ).

% String.char_of_ascii_of
thf(fact_6084_of__char__Char,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [B0: $o,B1: $o,B22: $o,B32: $o,B42: $o,B52: $o,B62: $o,B72: $o] :
          ( ( comm_s6883823935334413003f_char @ A @ ( char2 @ B0 @ B1 @ B22 @ B32 @ B42 @ B52 @ B62 @ B72 ) )
          = ( groups4207007520872428315er_sum @ $o @ A @ ( zero_neq_one_of_bool @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( cons @ $o @ B0 @ ( cons @ $o @ B1 @ ( cons @ $o @ B22 @ ( cons @ $o @ B32 @ ( cons @ $o @ B42 @ ( cons @ $o @ B52 @ ( cons @ $o @ B62 @ ( cons @ $o @ B72 @ ( nil @ $o ) ) ) ) ) ) ) ) ) ) ) ) ).

% of_char_Char
thf(fact_6085_list_Oinject,axiom,
    ! [A: $tType,X21: A,X222: list @ A,Y21: A,Y222: list @ A] :
      ( ( ( cons @ A @ X21 @ X222 )
        = ( cons @ A @ Y21 @ Y222 ) )
      = ( ( X21 = Y21 )
        & ( X222 = Y222 ) ) ) ).

% list.inject
thf(fact_6086_list_Osimps_I15_J,axiom,
    ! [A: $tType,X21: A,X222: list @ A] :
      ( ( set2 @ A @ ( cons @ A @ X21 @ X222 ) )
      = ( insert @ A @ X21 @ ( set2 @ A @ X222 ) ) ) ).

% list.simps(15)
thf(fact_6087_nth__Cons__Suc,axiom,
    ! [A: $tType,X2: A,Xs: list @ A,N2: nat] :
      ( ( nth @ A @ ( cons @ A @ X2 @ Xs ) @ ( suc @ N2 ) )
      = ( nth @ A @ Xs @ N2 ) ) ).

% nth_Cons_Suc
thf(fact_6088_nth__Cons__0,axiom,
    ! [A: $tType,X2: A,Xs: list @ A] :
      ( ( nth @ A @ ( cons @ A @ X2 @ Xs ) @ ( zero_zero @ nat ) )
      = X2 ) ).

% nth_Cons_0
thf(fact_6089_Cons__listrel1__Cons,axiom,
    ! [A: $tType,X2: A,Xs: list @ A,Y2: A,Ys: list @ A,R3: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X2 @ Xs ) @ ( cons @ A @ Y2 @ Ys ) ) @ ( listrel1 @ A @ R3 ) )
      = ( ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ Y2 ) @ R3 )
          & ( Xs = Ys ) )
        | ( ( X2 = Y2 )
          & ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Ys ) @ ( listrel1 @ A @ R3 ) ) ) ) ) ).

% Cons_listrel1_Cons
thf(fact_6090_horner__sum__simps_I2_J,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_semiring_0 @ A )
     => ! [F2: B > A,A2: A,X2: B,Xs: list @ B] :
          ( ( groups4207007520872428315er_sum @ B @ A @ F2 @ A2 @ ( cons @ B @ X2 @ Xs ) )
          = ( plus_plus @ A @ ( F2 @ X2 ) @ ( times_times @ A @ A2 @ ( groups4207007520872428315er_sum @ B @ A @ F2 @ A2 @ Xs ) ) ) ) ) ).

% horner_sum_simps(2)
thf(fact_6091_enumerate__simps_I2_J,axiom,
    ! [B: $tType,N2: nat,X2: B,Xs: list @ B] :
      ( ( enumerate @ B @ N2 @ ( cons @ B @ X2 @ Xs ) )
      = ( cons @ ( product_prod @ nat @ B ) @ ( product_Pair @ nat @ B @ N2 @ X2 ) @ ( enumerate @ B @ ( suc @ N2 ) @ Xs ) ) ) ).

% enumerate_simps(2)
thf(fact_6092_nth__Cons__numeral,axiom,
    ! [A: $tType,X2: A,Xs: list @ A,V: num] :
      ( ( nth @ A @ ( cons @ A @ X2 @ Xs ) @ ( numeral_numeral @ nat @ V ) )
      = ( nth @ A @ Xs @ ( minus_minus @ nat @ ( numeral_numeral @ nat @ V ) @ ( one_one @ nat ) ) ) ) ).

% nth_Cons_numeral
thf(fact_6093_nth__Cons__pos,axiom,
    ! [A: $tType,N2: nat,X2: A,Xs: list @ A] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( nth @ A @ ( cons @ A @ X2 @ Xs ) @ N2 )
        = ( nth @ A @ Xs @ ( minus_minus @ nat @ N2 @ ( one_one @ nat ) ) ) ) ) ).

% nth_Cons_pos
thf(fact_6094_impossible__Cons,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A,X2: A] :
      ( ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ ( size_size @ ( list @ A ) @ Ys ) )
     => ( Xs
       != ( cons @ A @ X2 @ Ys ) ) ) ).

% impossible_Cons
thf(fact_6095_length__Suc__conv,axiom,
    ! [A: $tType,Xs: list @ A,N2: nat] :
      ( ( ( size_size @ ( list @ A ) @ Xs )
        = ( suc @ N2 ) )
      = ( ? [Y5: A,Ys3: list @ A] :
            ( ( Xs
              = ( cons @ A @ Y5 @ Ys3 ) )
            & ( ( size_size @ ( list @ A ) @ Ys3 )
              = N2 ) ) ) ) ).

% length_Suc_conv
thf(fact_6096_Suc__length__conv,axiom,
    ! [A: $tType,N2: nat,Xs: list @ A] :
      ( ( ( suc @ N2 )
        = ( size_size @ ( list @ A ) @ Xs ) )
      = ( ? [Y5: A,Ys3: list @ A] :
            ( ( Xs
              = ( cons @ A @ Y5 @ Ys3 ) )
            & ( ( size_size @ ( list @ A ) @ Ys3 )
              = N2 ) ) ) ) ).

% Suc_length_conv
thf(fact_6097_length__Cons,axiom,
    ! [A: $tType,X2: A,Xs: list @ A] :
      ( ( size_size @ ( list @ A ) @ ( cons @ A @ X2 @ Xs ) )
      = ( suc @ ( size_size @ ( list @ A ) @ Xs ) ) ) ).

% length_Cons
thf(fact_6098_list__induct2,axiom,
    ! [A: $tType,B: $tType,Xs: list @ A,Ys: list @ B,P: ( list @ A ) > ( list @ B ) > $o] :
      ( ( ( size_size @ ( list @ A ) @ Xs )
        = ( size_size @ ( list @ B ) @ Ys ) )
     => ( ( P @ ( nil @ A ) @ ( nil @ B ) )
       => ( ! [X3: A,Xs2: list @ A,Y4: B,Ys4: list @ B] :
              ( ( ( size_size @ ( list @ A ) @ Xs2 )
                = ( size_size @ ( list @ B ) @ Ys4 ) )
             => ( ( P @ Xs2 @ Ys4 )
               => ( P @ ( cons @ A @ X3 @ Xs2 ) @ ( cons @ B @ Y4 @ Ys4 ) ) ) )
         => ( P @ Xs @ Ys ) ) ) ) ).

% list_induct2
thf(fact_6099_list__induct3,axiom,
    ! [B: $tType,A: $tType,C: $tType,Xs: list @ A,Ys: list @ B,Zs: list @ C,P: ( list @ A ) > ( list @ B ) > ( list @ C ) > $o] :
      ( ( ( size_size @ ( list @ A ) @ Xs )
        = ( size_size @ ( list @ B ) @ Ys ) )
     => ( ( ( size_size @ ( list @ B ) @ Ys )
          = ( size_size @ ( list @ C ) @ Zs ) )
       => ( ( P @ ( nil @ A ) @ ( nil @ B ) @ ( nil @ C ) )
         => ( ! [X3: A,Xs2: list @ A,Y4: B,Ys4: list @ B,Z3: C,Zs2: list @ C] :
                ( ( ( size_size @ ( list @ A ) @ Xs2 )
                  = ( size_size @ ( list @ B ) @ Ys4 ) )
               => ( ( ( size_size @ ( list @ B ) @ Ys4 )
                    = ( size_size @ ( list @ C ) @ Zs2 ) )
                 => ( ( P @ Xs2 @ Ys4 @ Zs2 )
                   => ( P @ ( cons @ A @ X3 @ Xs2 ) @ ( cons @ B @ Y4 @ Ys4 ) @ ( cons @ C @ Z3 @ Zs2 ) ) ) ) )
           => ( P @ Xs @ Ys @ Zs ) ) ) ) ) ).

% list_induct3
thf(fact_6100_list__induct4,axiom,
    ! [C: $tType,A: $tType,B: $tType,D: $tType,Xs: list @ A,Ys: list @ B,Zs: list @ C,Ws: list @ D,P: ( list @ A ) > ( list @ B ) > ( list @ C ) > ( list @ D ) > $o] :
      ( ( ( size_size @ ( list @ A ) @ Xs )
        = ( size_size @ ( list @ B ) @ Ys ) )
     => ( ( ( size_size @ ( list @ B ) @ Ys )
          = ( size_size @ ( list @ C ) @ Zs ) )
       => ( ( ( size_size @ ( list @ C ) @ Zs )
            = ( size_size @ ( list @ D ) @ Ws ) )
         => ( ( P @ ( nil @ A ) @ ( nil @ B ) @ ( nil @ C ) @ ( nil @ D ) )
           => ( ! [X3: A,Xs2: list @ A,Y4: B,Ys4: list @ B,Z3: C,Zs2: list @ C,W2: D,Ws2: list @ D] :
                  ( ( ( size_size @ ( list @ A ) @ Xs2 )
                    = ( size_size @ ( list @ B ) @ Ys4 ) )
                 => ( ( ( size_size @ ( list @ B ) @ Ys4 )
                      = ( size_size @ ( list @ C ) @ Zs2 ) )
                   => ( ( ( size_size @ ( list @ C ) @ Zs2 )
                        = ( size_size @ ( list @ D ) @ Ws2 ) )
                     => ( ( P @ Xs2 @ Ys4 @ Zs2 @ Ws2 )
                       => ( P @ ( cons @ A @ X3 @ Xs2 ) @ ( cons @ B @ Y4 @ Ys4 ) @ ( cons @ C @ Z3 @ Zs2 ) @ ( cons @ D @ W2 @ Ws2 ) ) ) ) ) )
             => ( P @ Xs @ Ys @ Zs @ Ws ) ) ) ) ) ) ).

% list_induct4
thf(fact_6101_Cons__shuffles__subset2,axiom,
    ! [A: $tType,Y2: A,Xs: list @ A,Ys: list @ A] : ( ord_less_eq @ ( set @ ( list @ A ) ) @ ( image @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ Y2 ) @ ( shuffles @ A @ Xs @ Ys ) ) @ ( shuffles @ A @ Xs @ ( cons @ A @ Y2 @ Ys ) ) ) ).

% Cons_shuffles_subset2
thf(fact_6102_Cons__shuffles__subset1,axiom,
    ! [A: $tType,X2: A,Xs: list @ A,Ys: list @ A] : ( ord_less_eq @ ( set @ ( list @ A ) ) @ ( image @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X2 ) @ ( shuffles @ A @ Xs @ Ys ) ) @ ( shuffles @ A @ ( cons @ A @ X2 @ Xs ) @ Ys ) ) ).

% Cons_shuffles_subset1
thf(fact_6103_insort__key_Osimps_I1_J,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F2: B > A,X2: B] :
          ( ( linorder_insort_key @ B @ A @ F2 @ X2 @ ( nil @ B ) )
          = ( cons @ B @ X2 @ ( nil @ B ) ) ) ) ).

% insort_key.simps(1)
thf(fact_6104_remdups_Osimps_I2_J,axiom,
    ! [A: $tType,X2: A,Xs: list @ A] :
      ( ( ( member @ A @ X2 @ ( set2 @ A @ Xs ) )
       => ( ( remdups @ A @ ( cons @ A @ X2 @ Xs ) )
          = ( remdups @ A @ Xs ) ) )
      & ( ~ ( member @ A @ X2 @ ( set2 @ A @ Xs ) )
       => ( ( remdups @ A @ ( cons @ A @ X2 @ Xs ) )
          = ( cons @ A @ X2 @ ( remdups @ A @ Xs ) ) ) ) ) ).

% remdups.simps(2)
thf(fact_6105_shufflesE,axiom,
    ! [A: $tType,Zs: list @ A,Xs: list @ A,Ys: list @ A] :
      ( ( member @ ( list @ A ) @ Zs @ ( shuffles @ A @ Xs @ Ys ) )
     => ( ( ( Zs = Xs )
         => ( Ys
           != ( nil @ A ) ) )
       => ( ( ( Zs = Ys )
           => ( Xs
             != ( nil @ A ) ) )
         => ( ! [X3: A,Xs4: list @ A] :
                ( ( Xs
                  = ( cons @ A @ X3 @ Xs4 ) )
               => ! [Z3: A,Zs4: list @ A] :
                    ( ( Zs
                      = ( cons @ A @ Z3 @ Zs4 ) )
                   => ( ( X3 = Z3 )
                     => ~ ( member @ ( list @ A ) @ Zs4 @ ( shuffles @ A @ Xs4 @ Ys ) ) ) ) )
           => ~ ! [Y4: A,Ys5: list @ A] :
                  ( ( Ys
                    = ( cons @ A @ Y4 @ Ys5 ) )
                 => ! [Z3: A,Zs4: list @ A] :
                      ( ( Zs
                        = ( cons @ A @ Z3 @ Zs4 ) )
                     => ( ( Y4 = Z3 )
                       => ~ ( member @ ( list @ A ) @ Zs4 @ ( shuffles @ A @ Xs @ Ys5 ) ) ) ) ) ) ) ) ) ).

% shufflesE
thf(fact_6106_distinct_Osimps_I2_J,axiom,
    ! [A: $tType,X2: A,Xs: list @ A] :
      ( ( distinct @ A @ ( cons @ A @ X2 @ Xs ) )
      = ( ~ ( member @ A @ X2 @ ( set2 @ A @ Xs ) )
        & ( distinct @ A @ Xs ) ) ) ).

% distinct.simps(2)
thf(fact_6107_distinct__length__2__or__more,axiom,
    ! [A: $tType,A2: A,B2: A,Xs: list @ A] :
      ( ( distinct @ A @ ( cons @ A @ A2 @ ( cons @ A @ B2 @ Xs ) ) )
      = ( ( A2 != B2 )
        & ( distinct @ A @ ( cons @ A @ A2 @ Xs ) )
        & ( distinct @ A @ ( cons @ A @ B2 @ Xs ) ) ) ) ).

% distinct_length_2_or_more
thf(fact_6108_Cons__in__shuffles__leftI,axiom,
    ! [A: $tType,Zs: list @ A,Xs: list @ A,Ys: list @ A,Z: A] :
      ( ( member @ ( list @ A ) @ Zs @ ( shuffles @ A @ Xs @ Ys ) )
     => ( member @ ( list @ A ) @ ( cons @ A @ Z @ Zs ) @ ( shuffles @ A @ ( cons @ A @ Z @ Xs ) @ Ys ) ) ) ).

% Cons_in_shuffles_leftI
thf(fact_6109_Cons__in__shuffles__rightI,axiom,
    ! [A: $tType,Zs: list @ A,Xs: list @ A,Ys: list @ A,Z: A] :
      ( ( member @ ( list @ A ) @ Zs @ ( shuffles @ A @ Xs @ Ys ) )
     => ( member @ ( list @ A ) @ ( cons @ A @ Z @ Zs ) @ ( shuffles @ A @ Xs @ ( cons @ A @ Z @ Ys ) ) ) ) ).

% Cons_in_shuffles_rightI
thf(fact_6110_set__ConsD,axiom,
    ! [A: $tType,Y2: A,X2: A,Xs: list @ A] :
      ( ( member @ A @ Y2 @ ( set2 @ A @ ( cons @ A @ X2 @ Xs ) ) )
     => ( ( Y2 = X2 )
        | ( member @ A @ Y2 @ ( set2 @ A @ Xs ) ) ) ) ).

% set_ConsD
thf(fact_6111_list_Oset__cases,axiom,
    ! [A: $tType,E2: A,A2: list @ A] :
      ( ( member @ A @ E2 @ ( set2 @ A @ A2 ) )
     => ( ! [Z23: list @ A] :
            ( A2
           != ( cons @ A @ E2 @ Z23 ) )
       => ~ ! [Z12: A,Z23: list @ A] :
              ( ( A2
                = ( cons @ A @ Z12 @ Z23 ) )
             => ~ ( member @ A @ E2 @ ( set2 @ A @ Z23 ) ) ) ) ) ).

% list.set_cases
thf(fact_6112_list_Oset__intros_I1_J,axiom,
    ! [A: $tType,X21: A,X222: list @ A] : ( member @ A @ X21 @ ( set2 @ A @ ( cons @ A @ X21 @ X222 ) ) ) ).

% list.set_intros(1)
thf(fact_6113_list_Oset__intros_I2_J,axiom,
    ! [A: $tType,Y2: A,X222: list @ A,X21: A] :
      ( ( member @ A @ Y2 @ ( set2 @ A @ X222 ) )
     => ( member @ A @ Y2 @ ( set2 @ A @ ( cons @ A @ X21 @ X222 ) ) ) ) ).

% list.set_intros(2)
thf(fact_6114_not__Cons__self2,axiom,
    ! [A: $tType,X2: A,Xs: list @ A] :
      ( ( cons @ A @ X2 @ Xs )
     != Xs ) ).

% not_Cons_self2
thf(fact_6115_list__update_Osimps_I2_J,axiom,
    ! [A: $tType,X2: A,Xs: list @ A,I3: nat,V: A] :
      ( ( list_update @ A @ ( cons @ A @ X2 @ Xs ) @ I3 @ V )
      = ( case_nat @ ( list @ A ) @ ( cons @ A @ V @ Xs )
        @ ^ [J3: nat] : ( cons @ A @ X2 @ ( list_update @ A @ Xs @ J3 @ V ) )
        @ I3 ) ) ).

% list_update.simps(2)
thf(fact_6116_remove1_Osimps_I2_J,axiom,
    ! [A: $tType,X2: A,Y2: A,Xs: list @ A] :
      ( ( ( X2 = Y2 )
       => ( ( remove1 @ A @ X2 @ ( cons @ A @ Y2 @ Xs ) )
          = Xs ) )
      & ( ( X2 != Y2 )
       => ( ( remove1 @ A @ X2 @ ( cons @ A @ Y2 @ Xs ) )
          = ( cons @ A @ Y2 @ ( remove1 @ A @ X2 @ Xs ) ) ) ) ) ).

% remove1.simps(2)
thf(fact_6117_removeAll_Osimps_I2_J,axiom,
    ! [A: $tType,X2: A,Y2: A,Xs: list @ A] :
      ( ( ( X2 = Y2 )
       => ( ( removeAll @ A @ X2 @ ( cons @ A @ Y2 @ Xs ) )
          = ( removeAll @ A @ X2 @ Xs ) ) )
      & ( ( X2 != Y2 )
       => ( ( removeAll @ A @ X2 @ ( cons @ A @ Y2 @ Xs ) )
          = ( cons @ A @ Y2 @ ( removeAll @ A @ X2 @ Xs ) ) ) ) ) ).

% removeAll.simps(2)
thf(fact_6118_sorted__wrt_Ocases,axiom,
    ! [A: $tType,X2: product_prod @ ( A > A > $o ) @ ( list @ A )] :
      ( ! [P8: A > A > $o] :
          ( X2
         != ( product_Pair @ ( A > A > $o ) @ ( list @ A ) @ P8 @ ( nil @ A ) ) )
     => ~ ! [P8: A > A > $o,X3: A,Ys4: list @ A] :
            ( X2
           != ( product_Pair @ ( A > A > $o ) @ ( list @ A ) @ P8 @ ( cons @ A @ X3 @ Ys4 ) ) ) ) ).

% sorted_wrt.cases
thf(fact_6119_arg__min__list_Ocases,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linorder @ B )
     => ! [X2: product_prod @ ( A > B ) @ ( list @ A )] :
          ( ! [F4: A > B,X3: A] :
              ( X2
             != ( product_Pair @ ( A > B ) @ ( list @ A ) @ F4 @ ( cons @ A @ X3 @ ( nil @ A ) ) ) )
         => ( ! [F4: A > B,X3: A,Y4: A,Zs2: list @ A] :
                ( X2
               != ( product_Pair @ ( A > B ) @ ( list @ A ) @ F4 @ ( cons @ A @ X3 @ ( cons @ A @ Y4 @ Zs2 ) ) ) )
           => ~ ! [A5: A > B] :
                  ( X2
                 != ( product_Pair @ ( A > B ) @ ( list @ A ) @ A5 @ ( nil @ A ) ) ) ) ) ) ).

% arg_min_list.cases
thf(fact_6120_successively_Ocases,axiom,
    ! [A: $tType,X2: product_prod @ ( A > A > $o ) @ ( list @ A )] :
      ( ! [P8: A > A > $o] :
          ( X2
         != ( product_Pair @ ( A > A > $o ) @ ( list @ A ) @ P8 @ ( nil @ A ) ) )
     => ( ! [P8: A > A > $o,X3: A] :
            ( X2
           != ( product_Pair @ ( A > A > $o ) @ ( list @ A ) @ P8 @ ( cons @ A @ X3 @ ( nil @ A ) ) ) )
       => ~ ! [P8: A > A > $o,X3: A,Y4: A,Xs2: list @ A] :
              ( X2
             != ( product_Pair @ ( A > A > $o ) @ ( list @ A ) @ P8 @ ( cons @ A @ X3 @ ( cons @ A @ Y4 @ Xs2 ) ) ) ) ) ) ).

% successively.cases
thf(fact_6121_list_Odistinct_I1_J,axiom,
    ! [A: $tType,X21: A,X222: list @ A] :
      ( ( nil @ A )
     != ( cons @ A @ X21 @ X222 ) ) ).

% list.distinct(1)
thf(fact_6122_list_OdiscI,axiom,
    ! [A: $tType,List: list @ A,X21: A,X222: list @ A] :
      ( ( List
        = ( cons @ A @ X21 @ X222 ) )
     => ( List
       != ( nil @ A ) ) ) ).

% list.discI
thf(fact_6123_list_Oexhaust,axiom,
    ! [A: $tType,Y2: list @ A] :
      ( ( Y2
       != ( nil @ A ) )
     => ~ ! [X212: A,X223: list @ A] :
            ( Y2
           != ( cons @ A @ X212 @ X223 ) ) ) ).

% list.exhaust
thf(fact_6124_min__list_Ocases,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [X2: list @ A] :
          ( ! [X3: A,Xs2: list @ A] :
              ( X2
             != ( cons @ A @ X3 @ Xs2 ) )
         => ( X2
            = ( nil @ A ) ) ) ) ).

% min_list.cases
thf(fact_6125_transpose_Ocases,axiom,
    ! [A: $tType,X2: list @ ( list @ A )] :
      ( ( X2
       != ( nil @ ( list @ A ) ) )
     => ( ! [Xss2: list @ ( list @ A )] :
            ( X2
           != ( cons @ ( list @ A ) @ ( nil @ A ) @ Xss2 ) )
       => ~ ! [X3: A,Xs2: list @ A,Xss2: list @ ( list @ A )] :
              ( X2
             != ( cons @ ( list @ A ) @ ( cons @ A @ X3 @ Xs2 ) @ Xss2 ) ) ) ) ).

% transpose.cases
thf(fact_6126_remdups__adj_Ocases,axiom,
    ! [A: $tType,X2: list @ A] :
      ( ( X2
       != ( nil @ A ) )
     => ( ! [X3: A] :
            ( X2
           != ( cons @ A @ X3 @ ( nil @ A ) ) )
       => ~ ! [X3: A,Y4: A,Xs2: list @ A] :
              ( X2
             != ( cons @ A @ X3 @ ( cons @ A @ Y4 @ Xs2 ) ) ) ) ) ).

% remdups_adj.cases
thf(fact_6127_neq__Nil__conv,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( ( Xs
         != ( nil @ A ) ) )
      = ( ? [Y5: A,Ys3: list @ A] :
            ( Xs
            = ( cons @ A @ Y5 @ Ys3 ) ) ) ) ).

% neq_Nil_conv
thf(fact_6128_list__induct2_H,axiom,
    ! [A: $tType,B: $tType,P: ( list @ A ) > ( list @ B ) > $o,Xs: list @ A,Ys: list @ B] :
      ( ( P @ ( nil @ A ) @ ( nil @ B ) )
     => ( ! [X3: A,Xs2: list @ A] : ( P @ ( cons @ A @ X3 @ Xs2 ) @ ( nil @ B ) )
       => ( ! [Y4: B,Ys4: list @ B] : ( P @ ( nil @ A ) @ ( cons @ B @ Y4 @ Ys4 ) )
         => ( ! [X3: A,Xs2: list @ A,Y4: B,Ys4: list @ B] :
                ( ( P @ Xs2 @ Ys4 )
               => ( P @ ( cons @ A @ X3 @ Xs2 ) @ ( cons @ B @ Y4 @ Ys4 ) ) )
           => ( P @ Xs @ Ys ) ) ) ) ) ).

% list_induct2'
thf(fact_6129_list__nonempty__induct,axiom,
    ! [A: $tType,Xs: list @ A,P: ( list @ A ) > $o] :
      ( ( Xs
       != ( nil @ A ) )
     => ( ! [X3: A] : ( P @ ( cons @ A @ X3 @ ( nil @ A ) ) )
       => ( ! [X3: A,Xs2: list @ A] :
              ( ( Xs2
               != ( nil @ A ) )
             => ( ( P @ Xs2 )
               => ( P @ ( cons @ A @ X3 @ Xs2 ) ) ) )
         => ( P @ Xs ) ) ) ) ).

% list_nonempty_induct
thf(fact_6130_distinct__singleton,axiom,
    ! [A: $tType,X2: A] : ( distinct @ A @ ( cons @ A @ X2 @ ( nil @ A ) ) ) ).

% distinct_singleton
thf(fact_6131_splice_Ocases,axiom,
    ! [A: $tType,X2: product_prod @ ( list @ A ) @ ( list @ A )] :
      ( ! [Ys4: list @ A] :
          ( X2
         != ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( nil @ A ) @ Ys4 ) )
     => ~ ! [X3: A,Xs2: list @ A,Ys4: list @ A] :
            ( X2
           != ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X3 @ Xs2 ) @ Ys4 ) ) ) ).

% splice.cases
thf(fact_6132_shuffles_Ocases,axiom,
    ! [A: $tType,X2: product_prod @ ( list @ A ) @ ( list @ A )] :
      ( ! [Ys4: list @ A] :
          ( X2
         != ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( nil @ A ) @ Ys4 ) )
     => ( ! [Xs2: list @ A] :
            ( X2
           != ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs2 @ ( nil @ A ) ) )
       => ~ ! [X3: A,Xs2: list @ A,Y4: A,Ys4: list @ A] :
              ( X2
             != ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X3 @ Xs2 ) @ ( cons @ A @ Y4 @ Ys4 ) ) ) ) ) ).

% shuffles.cases
thf(fact_6133_map__tailrec__rev_Ocases,axiom,
    ! [A: $tType,B: $tType,X2: product_prod @ ( A > B ) @ ( product_prod @ ( list @ A ) @ ( list @ B ) )] :
      ( ! [F4: A > B,Bs2: list @ B] :
          ( X2
         != ( product_Pair @ ( A > B ) @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ F4 @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ ( nil @ A ) @ Bs2 ) ) )
     => ~ ! [F4: A > B,A5: A,As: list @ A,Bs2: list @ B] :
            ( X2
           != ( product_Pair @ ( A > B ) @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ F4 @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ ( cons @ A @ A5 @ As ) @ Bs2 ) ) ) ) ).

% map_tailrec_rev.cases
thf(fact_6134_list__update__code_I2_J,axiom,
    ! [A: $tType,X2: A,Xs: list @ A,Y2: A] :
      ( ( list_update @ A @ ( cons @ A @ X2 @ Xs ) @ ( zero_zero @ nat ) @ Y2 )
      = ( cons @ A @ Y2 @ Xs ) ) ).

% list_update_code(2)
thf(fact_6135_list__update__code_I3_J,axiom,
    ! [A: $tType,X2: A,Xs: list @ A,I3: nat,Y2: A] :
      ( ( list_update @ A @ ( cons @ A @ X2 @ Xs ) @ ( suc @ I3 ) @ Y2 )
      = ( cons @ A @ X2 @ ( list_update @ A @ Xs @ I3 @ Y2 ) ) ) ).

% list_update_code(3)
thf(fact_6136_replicate__Suc,axiom,
    ! [A: $tType,N2: nat,X2: A] :
      ( ( replicate @ A @ ( suc @ N2 ) @ X2 )
      = ( cons @ A @ X2 @ ( replicate @ A @ N2 @ X2 ) ) ) ).

% replicate_Suc
thf(fact_6137_set__subset__Cons,axiom,
    ! [A: $tType,Xs: list @ A,X2: A] : ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ Xs ) @ ( set2 @ A @ ( cons @ A @ X2 @ Xs ) ) ) ).

% set_subset_Cons
thf(fact_6138_insort__key_Osimps_I2_J,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F2: B > A,X2: B,Y2: B,Ys: list @ B] :
          ( ( ( ord_less_eq @ A @ ( F2 @ X2 ) @ ( F2 @ Y2 ) )
           => ( ( linorder_insort_key @ B @ A @ F2 @ X2 @ ( cons @ B @ Y2 @ Ys ) )
              = ( cons @ B @ X2 @ ( cons @ B @ Y2 @ Ys ) ) ) )
          & ( ~ ( ord_less_eq @ A @ ( F2 @ X2 ) @ ( F2 @ Y2 ) )
           => ( ( linorder_insort_key @ B @ A @ F2 @ X2 @ ( cons @ B @ Y2 @ Ys ) )
              = ( cons @ B @ Y2 @ ( linorder_insort_key @ B @ A @ F2 @ X2 @ Ys ) ) ) ) ) ) ).

% insort_key.simps(2)
thf(fact_6139_listrel1I2,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A,R3: set @ ( product_prod @ A @ A ),X2: A] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Ys ) @ ( listrel1 @ A @ R3 ) )
     => ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X2 @ Xs ) @ ( cons @ A @ X2 @ Ys ) ) @ ( listrel1 @ A @ R3 ) ) ) ).

% listrel1I2
thf(fact_6140_Cons__in__subseqsD,axiom,
    ! [A: $tType,Y2: A,Ys: list @ A,Xs: list @ A] :
      ( ( member @ ( list @ A ) @ ( cons @ A @ Y2 @ Ys ) @ ( set2 @ ( list @ A ) @ ( subseqs @ A @ Xs ) ) )
     => ( member @ ( list @ A ) @ Ys @ ( set2 @ ( list @ A ) @ ( subseqs @ A @ Xs ) ) ) ) ).

% Cons_in_subseqsD
thf(fact_6141_nth__Cons,axiom,
    ! [A: $tType,X2: A,Xs: list @ A,N2: nat] :
      ( ( nth @ A @ ( cons @ A @ X2 @ Xs ) @ N2 )
      = ( case_nat @ A @ X2 @ ( nth @ A @ Xs ) @ N2 ) ) ).

% nth_Cons
thf(fact_6142_Suc__le__length__iff,axiom,
    ! [A: $tType,N2: nat,Xs: list @ A] :
      ( ( ord_less_eq @ nat @ ( suc @ N2 ) @ ( size_size @ ( list @ A ) @ Xs ) )
      = ( ? [X5: A,Ys3: list @ A] :
            ( ( Xs
              = ( cons @ A @ X5 @ Ys3 ) )
            & ( ord_less_eq @ nat @ N2 @ ( size_size @ ( list @ A ) @ Ys3 ) ) ) ) ) ).

% Suc_le_length_iff
thf(fact_6143_insort__is__Cons,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ B,F2: B > A,A2: B] :
          ( ! [X3: B] :
              ( ( member @ B @ X3 @ ( set2 @ B @ Xs ) )
             => ( ord_less_eq @ A @ ( F2 @ A2 ) @ ( F2 @ X3 ) ) )
         => ( ( linorder_insort_key @ B @ A @ F2 @ A2 @ Xs )
            = ( cons @ B @ A2 @ Xs ) ) ) ) ).

% insort_is_Cons
thf(fact_6144_listrel1I1,axiom,
    ! [A: $tType,X2: A,Y2: A,R3: set @ ( product_prod @ A @ A ),Xs: list @ A] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ Y2 ) @ R3 )
     => ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X2 @ Xs ) @ ( cons @ A @ Y2 @ Xs ) ) @ ( listrel1 @ A @ R3 ) ) ) ).

% listrel1I1
thf(fact_6145_Cons__listrel1E1,axiom,
    ! [A: $tType,X2: A,Xs: list @ A,Ys: list @ A,R3: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X2 @ Xs ) @ Ys ) @ ( listrel1 @ A @ R3 ) )
     => ( ! [Y4: A] :
            ( ( Ys
              = ( cons @ A @ Y4 @ Xs ) )
           => ~ ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ Y4 ) @ R3 ) )
       => ~ ! [Zs2: list @ A] :
              ( ( Ys
                = ( cons @ A @ X2 @ Zs2 ) )
             => ~ ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Zs2 ) @ ( listrel1 @ A @ R3 ) ) ) ) ) ).

% Cons_listrel1E1
thf(fact_6146_Cons__listrel1E2,axiom,
    ! [A: $tType,Xs: list @ A,Y2: A,Ys: list @ A,R3: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ ( cons @ A @ Y2 @ Ys ) ) @ ( listrel1 @ A @ R3 ) )
     => ( ! [X3: A] :
            ( ( Xs
              = ( cons @ A @ X3 @ Ys ) )
           => ~ ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X3 @ Y2 ) @ R3 ) )
       => ~ ! [Zs2: list @ A] :
              ( ( Xs
                = ( cons @ A @ Y2 @ Zs2 ) )
             => ~ ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Zs2 @ Ys ) @ ( listrel1 @ A @ R3 ) ) ) ) ) ).

% Cons_listrel1E2
thf(fact_6147_count__list_Osimps_I2_J,axiom,
    ! [A: $tType,X2: A,Y2: A,Xs: list @ A] :
      ( ( ( X2 = Y2 )
       => ( ( count_list @ A @ ( cons @ A @ X2 @ Xs ) @ Y2 )
          = ( plus_plus @ nat @ ( count_list @ A @ Xs @ Y2 ) @ ( one_one @ nat ) ) ) )
      & ( ( X2 != Y2 )
       => ( ( count_list @ A @ ( cons @ A @ X2 @ Xs ) @ Y2 )
          = ( count_list @ A @ Xs @ Y2 ) ) ) ) ).

% count_list.simps(2)
thf(fact_6148_list_Osize_I4_J,axiom,
    ! [A: $tType,X21: A,X222: list @ A] :
      ( ( size_size @ ( list @ A ) @ ( cons @ A @ X21 @ X222 ) )
      = ( plus_plus @ nat @ ( size_size @ ( list @ A ) @ X222 ) @ ( suc @ ( zero_zero @ nat ) ) ) ) ).

% list.size(4)
thf(fact_6149_nth__Cons_H,axiom,
    ! [A: $tType,N2: nat,X2: A,Xs: list @ A] :
      ( ( ( N2
          = ( zero_zero @ nat ) )
       => ( ( nth @ A @ ( cons @ A @ X2 @ Xs ) @ N2 )
          = X2 ) )
      & ( ( N2
         != ( zero_zero @ nat ) )
       => ( ( nth @ A @ ( cons @ A @ X2 @ Xs ) @ N2 )
          = ( nth @ A @ Xs @ ( minus_minus @ nat @ N2 @ ( one_one @ nat ) ) ) ) ) ) ).

% nth_Cons'
thf(fact_6150_list_Osize__gen_I2_J,axiom,
    ! [A: $tType,X2: A > nat,X21: A,X222: list @ A] :
      ( ( size_list @ A @ X2 @ ( cons @ A @ X21 @ X222 ) )
      = ( plus_plus @ nat @ ( plus_plus @ nat @ ( X2 @ X21 ) @ ( size_list @ A @ X2 @ X222 ) ) @ ( suc @ ( zero_zero @ nat ) ) ) ) ).

% list.size_gen(2)
thf(fact_6151_shuffles_Opinduct,axiom,
    ! [A: $tType,A0: list @ A,A1: list @ A,P: ( list @ A ) > ( list @ A ) > $o] :
      ( ( accp @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( shuffles_rel @ A ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ A0 @ A1 ) )
     => ( ! [Ys4: list @ A] :
            ( ( accp @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( shuffles_rel @ A ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( nil @ A ) @ Ys4 ) )
           => ( P @ ( nil @ A ) @ Ys4 ) )
       => ( ! [Xs2: list @ A] :
              ( ( accp @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( shuffles_rel @ A ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs2 @ ( nil @ A ) ) )
             => ( P @ Xs2 @ ( nil @ A ) ) )
         => ( ! [X3: A,Xs2: list @ A,Y4: A,Ys4: list @ A] :
                ( ( accp @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( shuffles_rel @ A ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X3 @ Xs2 ) @ ( cons @ A @ Y4 @ Ys4 ) ) )
               => ( ( P @ Xs2 @ ( cons @ A @ Y4 @ Ys4 ) )
                 => ( ( P @ ( cons @ A @ X3 @ Xs2 ) @ Ys4 )
                   => ( P @ ( cons @ A @ X3 @ Xs2 ) @ ( cons @ A @ Y4 @ Ys4 ) ) ) ) )
           => ( P @ A0 @ A1 ) ) ) ) ) ).

% shuffles.pinduct
thf(fact_6152_nth__equal__first__eq,axiom,
    ! [A: $tType,X2: A,Xs: list @ A,N2: nat] :
      ( ~ ( member @ A @ X2 @ ( set2 @ A @ Xs ) )
     => ( ( ord_less_eq @ nat @ N2 @ ( size_size @ ( list @ A ) @ Xs ) )
       => ( ( ( nth @ A @ ( cons @ A @ X2 @ Xs ) @ N2 )
            = X2 )
          = ( N2
            = ( zero_zero @ nat ) ) ) ) ) ).

% nth_equal_first_eq
thf(fact_6153_nth__non__equal__first__eq,axiom,
    ! [A: $tType,X2: A,Y2: A,Xs: list @ A,N2: nat] :
      ( ( X2 != Y2 )
     => ( ( ( nth @ A @ ( cons @ A @ X2 @ Xs ) @ N2 )
          = Y2 )
        = ( ( ( nth @ A @ Xs @ ( minus_minus @ nat @ N2 @ ( one_one @ nat ) ) )
            = Y2 )
          & ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 ) ) ) ) ).

% nth_non_equal_first_eq
thf(fact_6154_Cons__replicate__eq,axiom,
    ! [A: $tType,X2: A,Xs: list @ A,N2: nat,Y2: A] :
      ( ( ( cons @ A @ X2 @ Xs )
        = ( replicate @ A @ N2 @ Y2 ) )
      = ( ( X2 = Y2 )
        & ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
        & ( Xs
          = ( replicate @ A @ ( minus_minus @ nat @ N2 @ ( one_one @ nat ) ) @ X2 ) ) ) ) ).

% Cons_replicate_eq
thf(fact_6155_set__Cons__sing__Nil,axiom,
    ! [A: $tType,A3: set @ A] :
      ( ( set_Cons @ A @ A3 @ ( insert @ ( list @ A ) @ ( nil @ A ) @ ( bot_bot @ ( set @ ( list @ A ) ) ) ) )
      = ( image @ A @ ( list @ A )
        @ ^ [X5: A] : ( cons @ A @ X5 @ ( nil @ A ) )
        @ A3 ) ) ).

% set_Cons_sing_Nil
thf(fact_6156_concat__inth,axiom,
    ! [A: $tType,Xs: list @ A,X2: A,Ys: list @ A] :
      ( ( nth @ A @ ( append @ A @ Xs @ ( append @ A @ ( cons @ A @ X2 @ ( nil @ A ) ) @ Ys ) ) @ ( size_size @ ( list @ A ) @ Xs ) )
      = X2 ) ).

% concat_inth
thf(fact_6157_append_Oassoc,axiom,
    ! [A: $tType,A2: list @ A,B2: list @ A,C2: list @ A] :
      ( ( append @ A @ ( append @ A @ A2 @ B2 ) @ C2 )
      = ( append @ A @ A2 @ ( append @ A @ B2 @ C2 ) ) ) ).

% append.assoc
thf(fact_6158_append__assoc,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A,Zs: list @ A] :
      ( ( append @ A @ ( append @ A @ Xs @ Ys ) @ Zs )
      = ( append @ A @ Xs @ ( append @ A @ Ys @ Zs ) ) ) ).

% append_assoc
thf(fact_6159_append__same__eq,axiom,
    ! [A: $tType,Ys: list @ A,Xs: list @ A,Zs: list @ A] :
      ( ( ( append @ A @ Ys @ Xs )
        = ( append @ A @ Zs @ Xs ) )
      = ( Ys = Zs ) ) ).

% append_same_eq
thf(fact_6160_same__append__eq,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A,Zs: list @ A] :
      ( ( ( append @ A @ Xs @ Ys )
        = ( append @ A @ Xs @ Zs ) )
      = ( Ys = Zs ) ) ).

% same_append_eq
thf(fact_6161_append_Oright__neutral,axiom,
    ! [A: $tType,A2: list @ A] :
      ( ( append @ A @ A2 @ ( nil @ A ) )
      = A2 ) ).

% append.right_neutral
thf(fact_6162_append__Nil2,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( append @ A @ Xs @ ( nil @ A ) )
      = Xs ) ).

% append_Nil2
thf(fact_6163_append__self__conv,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A] :
      ( ( ( append @ A @ Xs @ Ys )
        = Xs )
      = ( Ys
        = ( nil @ A ) ) ) ).

% append_self_conv
thf(fact_6164_self__append__conv,axiom,
    ! [A: $tType,Y2: list @ A,Ys: list @ A] :
      ( ( Y2
        = ( append @ A @ Y2 @ Ys ) )
      = ( Ys
        = ( nil @ A ) ) ) ).

% self_append_conv
thf(fact_6165_append__self__conv2,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A] :
      ( ( ( append @ A @ Xs @ Ys )
        = Ys )
      = ( Xs
        = ( nil @ A ) ) ) ).

% append_self_conv2
thf(fact_6166_self__append__conv2,axiom,
    ! [A: $tType,Y2: list @ A,Xs: list @ A] :
      ( ( Y2
        = ( append @ A @ Xs @ Y2 ) )
      = ( Xs
        = ( nil @ A ) ) ) ).

% self_append_conv2
thf(fact_6167_Nil__is__append__conv,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A] :
      ( ( ( nil @ A )
        = ( append @ A @ Xs @ Ys ) )
      = ( ( Xs
          = ( nil @ A ) )
        & ( Ys
          = ( nil @ A ) ) ) ) ).

% Nil_is_append_conv
thf(fact_6168_append__is__Nil__conv,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A] :
      ( ( ( append @ A @ Xs @ Ys )
        = ( nil @ A ) )
      = ( ( Xs
          = ( nil @ A ) )
        & ( Ys
          = ( nil @ A ) ) ) ) ).

% append_is_Nil_conv
thf(fact_6169_append__eq__append__conv,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A,Us: list @ A,Vs: list @ A] :
      ( ( ( ( size_size @ ( list @ A ) @ Xs )
          = ( size_size @ ( list @ A ) @ Ys ) )
        | ( ( size_size @ ( list @ A ) @ Us )
          = ( size_size @ ( list @ A ) @ Vs ) ) )
     => ( ( ( append @ A @ Xs @ Us )
          = ( append @ A @ Ys @ Vs ) )
        = ( ( Xs = Ys )
          & ( Us = Vs ) ) ) ) ).

% append_eq_append_conv
thf(fact_6170_sorted__list__of__set__lessThan__Suc,axiom,
    ! [K: nat] :
      ( ( linord4507533701916653071of_set @ nat @ ( set_ord_lessThan @ nat @ ( suc @ K ) ) )
      = ( append @ nat @ ( linord4507533701916653071of_set @ nat @ ( set_ord_lessThan @ nat @ K ) ) @ ( cons @ nat @ K @ ( nil @ nat ) ) ) ) ).

% sorted_list_of_set_lessThan_Suc
thf(fact_6171_sorted__list__of__set__atMost__Suc,axiom,
    ! [K: nat] :
      ( ( linord4507533701916653071of_set @ nat @ ( set_ord_atMost @ nat @ ( suc @ K ) ) )
      = ( append @ nat @ ( linord4507533701916653071of_set @ nat @ ( set_ord_atMost @ nat @ K ) ) @ ( cons @ nat @ ( suc @ K ) @ ( nil @ nat ) ) ) ) ).

% sorted_list_of_set_atMost_Suc
thf(fact_6172_concat__append,axiom,
    ! [A: $tType,Xs: list @ ( list @ A ),Ys: list @ ( list @ A )] :
      ( ( concat @ A @ ( append @ ( list @ A ) @ Xs @ Ys ) )
      = ( append @ A @ ( concat @ A @ Xs ) @ ( concat @ A @ Ys ) ) ) ).

% concat_append
thf(fact_6173_removeAll__append,axiom,
    ! [A: $tType,X2: A,Xs: list @ A,Ys: list @ A] :
      ( ( removeAll @ A @ X2 @ ( append @ A @ Xs @ Ys ) )
      = ( append @ A @ ( removeAll @ A @ X2 @ Xs ) @ ( removeAll @ A @ X2 @ Ys ) ) ) ).

% removeAll_append
thf(fact_6174_append1__eq__conv,axiom,
    ! [A: $tType,Xs: list @ A,X2: A,Ys: list @ A,Y2: A] :
      ( ( ( append @ A @ Xs @ ( cons @ A @ X2 @ ( nil @ A ) ) )
        = ( append @ A @ Ys @ ( cons @ A @ Y2 @ ( nil @ A ) ) ) )
      = ( ( Xs = Ys )
        & ( X2 = Y2 ) ) ) ).

% append1_eq_conv
thf(fact_6175_length__append,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A] :
      ( ( size_size @ ( list @ A ) @ ( append @ A @ Xs @ Ys ) )
      = ( plus_plus @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ ( size_size @ ( list @ A ) @ Ys ) ) ) ).

% length_append
thf(fact_6176_size__list__append,axiom,
    ! [A: $tType,F2: A > nat,Xs: list @ A,Ys: list @ A] :
      ( ( size_list @ A @ F2 @ ( append @ A @ Xs @ Ys ) )
      = ( plus_plus @ nat @ ( size_list @ A @ F2 @ Xs ) @ ( size_list @ A @ F2 @ Ys ) ) ) ).

% size_list_append
thf(fact_6177_nth__append__length,axiom,
    ! [A: $tType,Xs: list @ A,X2: A,Ys: list @ A] :
      ( ( nth @ A @ ( append @ A @ Xs @ ( cons @ A @ X2 @ Ys ) ) @ ( size_size @ ( list @ A ) @ Xs ) )
      = X2 ) ).

% nth_append_length
thf(fact_6178_nth__append__length__plus,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A,N2: nat] :
      ( ( nth @ A @ ( append @ A @ Xs @ Ys ) @ ( plus_plus @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ N2 ) )
      = ( nth @ A @ Ys @ N2 ) ) ).

% nth_append_length_plus
thf(fact_6179_list__update__length,axiom,
    ! [A: $tType,Xs: list @ A,X2: A,Ys: list @ A,Y2: A] :
      ( ( list_update @ A @ ( append @ A @ Xs @ ( cons @ A @ X2 @ Ys ) ) @ ( size_size @ ( list @ A ) @ Xs ) @ Y2 )
      = ( append @ A @ Xs @ ( cons @ A @ Y2 @ Ys ) ) ) ).

% list_update_length
thf(fact_6180_distinct__append,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A] :
      ( ( distinct @ A @ ( append @ A @ Xs @ Ys ) )
      = ( ( distinct @ A @ Xs )
        & ( distinct @ A @ Ys )
        & ( ( inf_inf @ ( set @ A ) @ ( set2 @ A @ Xs ) @ ( set2 @ A @ Ys ) )
          = ( bot_bot @ ( set @ A ) ) ) ) ) ).

% distinct_append
thf(fact_6181_n__lists__Nil,axiom,
    ! [A: $tType,N2: nat] :
      ( ( ( N2
          = ( zero_zero @ nat ) )
       => ( ( n_lists @ A @ N2 @ ( nil @ A ) )
          = ( cons @ ( list @ A ) @ ( nil @ A ) @ ( nil @ ( list @ A ) ) ) ) )
      & ( ( N2
         != ( zero_zero @ nat ) )
       => ( ( n_lists @ A @ N2 @ ( nil @ A ) )
          = ( nil @ ( list @ A ) ) ) ) ) ).

% n_lists_Nil
thf(fact_6182_replicate__app__Cons__same,axiom,
    ! [A: $tType,N2: nat,X2: A,Xs: list @ A] :
      ( ( append @ A @ ( replicate @ A @ N2 @ X2 ) @ ( cons @ A @ X2 @ Xs ) )
      = ( cons @ A @ X2 @ ( append @ A @ ( replicate @ A @ N2 @ X2 ) @ Xs ) ) ) ).

% replicate_app_Cons_same
thf(fact_6183_split__list,axiom,
    ! [A: $tType,X2: A,Xs: list @ A] :
      ( ( member @ A @ X2 @ ( set2 @ A @ Xs ) )
     => ? [Ys4: list @ A,Zs2: list @ A] :
          ( Xs
          = ( append @ A @ Ys4 @ ( cons @ A @ X2 @ Zs2 ) ) ) ) ).

% split_list
thf(fact_6184_split__list__last,axiom,
    ! [A: $tType,X2: A,Xs: list @ A] :
      ( ( member @ A @ X2 @ ( set2 @ A @ Xs ) )
     => ? [Ys4: list @ A,Zs2: list @ A] :
          ( ( Xs
            = ( append @ A @ Ys4 @ ( cons @ A @ X2 @ Zs2 ) ) )
          & ~ ( member @ A @ X2 @ ( set2 @ A @ Zs2 ) ) ) ) ).

% split_list_last
thf(fact_6185_split__list__prop,axiom,
    ! [A: $tType,Xs: list @ A,P: A > $o] :
      ( ? [X: A] :
          ( ( member @ A @ X @ ( set2 @ A @ Xs ) )
          & ( P @ X ) )
     => ? [Ys4: list @ A,X3: A] :
          ( ? [Zs2: list @ A] :
              ( Xs
              = ( append @ A @ Ys4 @ ( cons @ A @ X3 @ Zs2 ) ) )
          & ( P @ X3 ) ) ) ).

% split_list_prop
thf(fact_6186_split__list__first,axiom,
    ! [A: $tType,X2: A,Xs: list @ A] :
      ( ( member @ A @ X2 @ ( set2 @ A @ Xs ) )
     => ? [Ys4: list @ A,Zs2: list @ A] :
          ( ( Xs
            = ( append @ A @ Ys4 @ ( cons @ A @ X2 @ Zs2 ) ) )
          & ~ ( member @ A @ X2 @ ( set2 @ A @ Ys4 ) ) ) ) ).

% split_list_first
thf(fact_6187_split__list__propE,axiom,
    ! [A: $tType,Xs: list @ A,P: A > $o] :
      ( ? [X: A] :
          ( ( member @ A @ X @ ( set2 @ A @ Xs ) )
          & ( P @ X ) )
     => ~ ! [Ys4: list @ A,X3: A] :
            ( ? [Zs2: list @ A] :
                ( Xs
                = ( append @ A @ Ys4 @ ( cons @ A @ X3 @ Zs2 ) ) )
           => ~ ( P @ X3 ) ) ) ).

% split_list_propE
thf(fact_6188_append__Cons__eq__iff,axiom,
    ! [A: $tType,X2: A,Xs: list @ A,Ys: list @ A,Xs5: list @ A,Ys6: list @ A] :
      ( ~ ( member @ A @ X2 @ ( set2 @ A @ Xs ) )
     => ( ~ ( member @ A @ X2 @ ( set2 @ A @ Ys ) )
       => ( ( ( append @ A @ Xs @ ( cons @ A @ X2 @ Ys ) )
            = ( append @ A @ Xs5 @ ( cons @ A @ X2 @ Ys6 ) ) )
          = ( ( Xs = Xs5 )
            & ( Ys = Ys6 ) ) ) ) ) ).

% append_Cons_eq_iff
thf(fact_6189_in__set__conv__decomp,axiom,
    ! [A: $tType,X2: A,Xs: list @ A] :
      ( ( member @ A @ X2 @ ( set2 @ A @ Xs ) )
      = ( ? [Ys3: list @ A,Zs3: list @ A] :
            ( Xs
            = ( append @ A @ Ys3 @ ( cons @ A @ X2 @ Zs3 ) ) ) ) ) ).

% in_set_conv_decomp
thf(fact_6190_split__list__last__prop,axiom,
    ! [A: $tType,Xs: list @ A,P: A > $o] :
      ( ? [X: A] :
          ( ( member @ A @ X @ ( set2 @ A @ Xs ) )
          & ( P @ X ) )
     => ? [Ys4: list @ A,X3: A,Zs2: list @ A] :
          ( ( Xs
            = ( append @ A @ Ys4 @ ( cons @ A @ X3 @ Zs2 ) ) )
          & ( P @ X3 )
          & ! [Xa: A] :
              ( ( member @ A @ Xa @ ( set2 @ A @ Zs2 ) )
             => ~ ( P @ Xa ) ) ) ) ).

% split_list_last_prop
thf(fact_6191_split__list__first__prop,axiom,
    ! [A: $tType,Xs: list @ A,P: A > $o] :
      ( ? [X: A] :
          ( ( member @ A @ X @ ( set2 @ A @ Xs ) )
          & ( P @ X ) )
     => ? [Ys4: list @ A,X3: A] :
          ( ? [Zs2: list @ A] :
              ( Xs
              = ( append @ A @ Ys4 @ ( cons @ A @ X3 @ Zs2 ) ) )
          & ( P @ X3 )
          & ! [Xa: A] :
              ( ( member @ A @ Xa @ ( set2 @ A @ Ys4 ) )
             => ~ ( P @ Xa ) ) ) ) ).

% split_list_first_prop
thf(fact_6192_split__list__last__propE,axiom,
    ! [A: $tType,Xs: list @ A,P: A > $o] :
      ( ? [X: A] :
          ( ( member @ A @ X @ ( set2 @ A @ Xs ) )
          & ( P @ X ) )
     => ~ ! [Ys4: list @ A,X3: A,Zs2: list @ A] :
            ( ( Xs
              = ( append @ A @ Ys4 @ ( cons @ A @ X3 @ Zs2 ) ) )
           => ( ( P @ X3 )
             => ~ ! [Xa: A] :
                    ( ( member @ A @ Xa @ ( set2 @ A @ Zs2 ) )
                   => ~ ( P @ Xa ) ) ) ) ) ).

% split_list_last_propE
thf(fact_6193_split__list__first__propE,axiom,
    ! [A: $tType,Xs: list @ A,P: A > $o] :
      ( ? [X: A] :
          ( ( member @ A @ X @ ( set2 @ A @ Xs ) )
          & ( P @ X ) )
     => ~ ! [Ys4: list @ A,X3: A] :
            ( ? [Zs2: list @ A] :
                ( Xs
                = ( append @ A @ Ys4 @ ( cons @ A @ X3 @ Zs2 ) ) )
           => ( ( P @ X3 )
             => ~ ! [Xa: A] :
                    ( ( member @ A @ Xa @ ( set2 @ A @ Ys4 ) )
                   => ~ ( P @ Xa ) ) ) ) ) ).

% split_list_first_propE
thf(fact_6194_in__set__conv__decomp__last,axiom,
    ! [A: $tType,X2: A,Xs: list @ A] :
      ( ( member @ A @ X2 @ ( set2 @ A @ Xs ) )
      = ( ? [Ys3: list @ A,Zs3: list @ A] :
            ( ( Xs
              = ( append @ A @ Ys3 @ ( cons @ A @ X2 @ Zs3 ) ) )
            & ~ ( member @ A @ X2 @ ( set2 @ A @ Zs3 ) ) ) ) ) ).

% in_set_conv_decomp_last
thf(fact_6195_in__set__conv__decomp__first,axiom,
    ! [A: $tType,X2: A,Xs: list @ A] :
      ( ( member @ A @ X2 @ ( set2 @ A @ Xs ) )
      = ( ? [Ys3: list @ A,Zs3: list @ A] :
            ( ( Xs
              = ( append @ A @ Ys3 @ ( cons @ A @ X2 @ Zs3 ) ) )
            & ~ ( member @ A @ X2 @ ( set2 @ A @ Ys3 ) ) ) ) ) ).

% in_set_conv_decomp_first
thf(fact_6196_split__list__last__prop__iff,axiom,
    ! [A: $tType,Xs: list @ A,P: A > $o] :
      ( ( ? [X5: A] :
            ( ( member @ A @ X5 @ ( set2 @ A @ Xs ) )
            & ( P @ X5 ) ) )
      = ( ? [Ys3: list @ A,X5: A,Zs3: list @ A] :
            ( ( Xs
              = ( append @ A @ Ys3 @ ( cons @ A @ X5 @ Zs3 ) ) )
            & ( P @ X5 )
            & ! [Y5: A] :
                ( ( member @ A @ Y5 @ ( set2 @ A @ Zs3 ) )
               => ~ ( P @ Y5 ) ) ) ) ) ).

% split_list_last_prop_iff
thf(fact_6197_split__list__first__prop__iff,axiom,
    ! [A: $tType,Xs: list @ A,P: A > $o] :
      ( ( ? [X5: A] :
            ( ( member @ A @ X5 @ ( set2 @ A @ Xs ) )
            & ( P @ X5 ) ) )
      = ( ? [Ys3: list @ A,X5: A] :
            ( ? [Zs3: list @ A] :
                ( Xs
                = ( append @ A @ Ys3 @ ( cons @ A @ X5 @ Zs3 ) ) )
            & ( P @ X5 )
            & ! [Y5: A] :
                ( ( member @ A @ Y5 @ ( set2 @ A @ Ys3 ) )
               => ~ ( P @ Y5 ) ) ) ) ) ).

% split_list_first_prop_iff
thf(fact_6198_Cons__eq__appendI,axiom,
    ! [A: $tType,X2: A,Xs1: list @ A,Ys: list @ A,Xs: list @ A,Zs: list @ A] :
      ( ( ( cons @ A @ X2 @ Xs1 )
        = Ys )
     => ( ( Xs
          = ( append @ A @ Xs1 @ Zs ) )
       => ( ( cons @ A @ X2 @ Xs )
          = ( append @ A @ Ys @ Zs ) ) ) ) ).

% Cons_eq_appendI
thf(fact_6199_append__Cons,axiom,
    ! [A: $tType,X2: A,Xs: list @ A,Ys: list @ A] :
      ( ( append @ A @ ( cons @ A @ X2 @ Xs ) @ Ys )
      = ( cons @ A @ X2 @ ( append @ A @ Xs @ Ys ) ) ) ).

% append_Cons
thf(fact_6200_concat_Osimps_I2_J,axiom,
    ! [A: $tType,X2: list @ A,Xs: list @ ( list @ A )] :
      ( ( concat @ A @ ( cons @ ( list @ A ) @ X2 @ Xs ) )
      = ( append @ A @ X2 @ ( concat @ A @ Xs ) ) ) ).

% concat.simps(2)
thf(fact_6201_listset_Osimps_I2_J,axiom,
    ! [A: $tType,A3: set @ A,As2: list @ ( set @ A )] :
      ( ( listset @ A @ ( cons @ ( set @ A ) @ A3 @ As2 ) )
      = ( set_Cons @ A @ A3 @ ( listset @ A @ As2 ) ) ) ).

% listset.simps(2)
thf(fact_6202_concat__eq__append__conv,axiom,
    ! [A: $tType,Xss: list @ ( list @ A ),Ys: list @ A,Zs: list @ A] :
      ( ( ( concat @ A @ Xss )
        = ( append @ A @ Ys @ Zs ) )
      = ( ( ( Xss
            = ( nil @ ( list @ A ) ) )
         => ( ( Ys
              = ( nil @ A ) )
            & ( Zs
              = ( nil @ A ) ) ) )
        & ( ( Xss
           != ( nil @ ( list @ A ) ) )
         => ? [Xss1: list @ ( list @ A ),Xs3: list @ A,Xs6: list @ A,Xss22: list @ ( list @ A )] :
              ( ( Xss
                = ( append @ ( list @ A ) @ Xss1 @ ( cons @ ( list @ A ) @ ( append @ A @ Xs3 @ Xs6 ) @ Xss22 ) ) )
              & ( Ys
                = ( append @ A @ ( concat @ A @ Xss1 ) @ Xs3 ) )
              & ( Zs
                = ( append @ A @ Xs6 @ ( concat @ A @ Xss22 ) ) ) ) ) ) ) ).

% concat_eq_append_conv
thf(fact_6203_concat__eq__appendD,axiom,
    ! [A: $tType,Xss: list @ ( list @ A ),Ys: list @ A,Zs: list @ A] :
      ( ( ( concat @ A @ Xss )
        = ( append @ A @ Ys @ Zs ) )
     => ( ( Xss
         != ( nil @ ( list @ A ) ) )
       => ? [Xss12: list @ ( list @ A ),Xs2: list @ A,Xs4: list @ A,Xss23: list @ ( list @ A )] :
            ( ( Xss
              = ( append @ ( list @ A ) @ Xss12 @ ( cons @ ( list @ A ) @ ( append @ A @ Xs2 @ Xs4 ) @ Xss23 ) ) )
            & ( Ys
              = ( append @ A @ ( concat @ A @ Xss12 ) @ Xs2 ) )
            & ( Zs
              = ( append @ A @ Xs4 @ ( concat @ A @ Xss23 ) ) ) ) ) ) ).

% concat_eq_appendD
thf(fact_6204_append__Nil,axiom,
    ! [A: $tType,Ys: list @ A] :
      ( ( append @ A @ ( nil @ A ) @ Ys )
      = Ys ) ).

% append_Nil
thf(fact_6205_append_Oleft__neutral,axiom,
    ! [A: $tType,A2: list @ A] :
      ( ( append @ A @ ( nil @ A ) @ A2 )
      = A2 ) ).

% append.left_neutral
thf(fact_6206_rev__induct,axiom,
    ! [A: $tType,P: ( list @ A ) > $o,Xs: list @ A] :
      ( ( P @ ( nil @ A ) )
     => ( ! [X3: A,Xs2: list @ A] :
            ( ( P @ Xs2 )
           => ( P @ ( append @ A @ Xs2 @ ( cons @ A @ X3 @ ( nil @ A ) ) ) ) )
       => ( P @ Xs ) ) ) ).

% rev_induct
thf(fact_6207_rev__exhaust,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( Xs
       != ( nil @ A ) )
     => ~ ! [Ys4: list @ A,Y4: A] :
            ( Xs
           != ( append @ A @ Ys4 @ ( cons @ A @ Y4 @ ( nil @ A ) ) ) ) ) ).

% rev_exhaust
thf(fact_6208_eq__Nil__appendI,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A] :
      ( ( Xs = Ys )
     => ( Xs
        = ( append @ A @ ( nil @ A ) @ Ys ) ) ) ).

% eq_Nil_appendI
thf(fact_6209_Cons__eq__append__conv,axiom,
    ! [A: $tType,X2: A,Xs: list @ A,Ys: list @ A,Zs: list @ A] :
      ( ( ( cons @ A @ X2 @ Xs )
        = ( append @ A @ Ys @ Zs ) )
      = ( ( ( Ys
            = ( nil @ A ) )
          & ( ( cons @ A @ X2 @ Xs )
            = Zs ) )
        | ? [Ys7: list @ A] :
            ( ( ( cons @ A @ X2 @ Ys7 )
              = Ys )
            & ( Xs
              = ( append @ A @ Ys7 @ Zs ) ) ) ) ) ).

% Cons_eq_append_conv
thf(fact_6210_append__eq__Cons__conv,axiom,
    ! [A: $tType,Ys: list @ A,Zs: list @ A,X2: A,Xs: list @ A] :
      ( ( ( append @ A @ Ys @ Zs )
        = ( cons @ A @ X2 @ Xs ) )
      = ( ( ( Ys
            = ( nil @ A ) )
          & ( Zs
            = ( cons @ A @ X2 @ Xs ) ) )
        | ? [Ys7: list @ A] :
            ( ( Ys
              = ( cons @ A @ X2 @ Ys7 ) )
            & ( ( append @ A @ Ys7 @ Zs )
              = Xs ) ) ) ) ).

% append_eq_Cons_conv
thf(fact_6211_rev__nonempty__induct,axiom,
    ! [A: $tType,Xs: list @ A,P: ( list @ A ) > $o] :
      ( ( Xs
       != ( nil @ A ) )
     => ( ! [X3: A] : ( P @ ( cons @ A @ X3 @ ( nil @ A ) ) )
       => ( ! [X3: A,Xs2: list @ A] :
              ( ( Xs2
               != ( nil @ A ) )
             => ( ( P @ Xs2 )
               => ( P @ ( append @ A @ Xs2 @ ( cons @ A @ X3 @ ( nil @ A ) ) ) ) ) )
         => ( P @ Xs ) ) ) ) ).

% rev_nonempty_induct
thf(fact_6212_remdups__append2,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A] :
      ( ( remdups @ A @ ( append @ A @ Xs @ ( remdups @ A @ Ys ) ) )
      = ( remdups @ A @ ( append @ A @ Xs @ Ys ) ) ) ).

% remdups_append2
thf(fact_6213_remove1__append,axiom,
    ! [A: $tType,X2: A,Xs: list @ A,Ys: list @ A] :
      ( ( ( member @ A @ X2 @ ( set2 @ A @ Xs ) )
       => ( ( remove1 @ A @ X2 @ ( append @ A @ Xs @ Ys ) )
          = ( append @ A @ ( remove1 @ A @ X2 @ Xs ) @ Ys ) ) )
      & ( ~ ( member @ A @ X2 @ ( set2 @ A @ Xs ) )
       => ( ( remove1 @ A @ X2 @ ( append @ A @ Xs @ Ys ) )
          = ( append @ A @ Xs @ ( remove1 @ A @ X2 @ Ys ) ) ) ) ) ).

% remove1_append
thf(fact_6214_replicate__add,axiom,
    ! [A: $tType,N2: nat,M: nat,X2: A] :
      ( ( replicate @ A @ ( plus_plus @ nat @ N2 @ M ) @ X2 )
      = ( append @ A @ ( replicate @ A @ N2 @ X2 ) @ ( replicate @ A @ M @ X2 ) ) ) ).

% replicate_add
thf(fact_6215_append__eq__appendI,axiom,
    ! [A: $tType,Xs: list @ A,Xs1: list @ A,Zs: list @ A,Ys: list @ A,Us: list @ A] :
      ( ( ( append @ A @ Xs @ Xs1 )
        = Zs )
     => ( ( Ys
          = ( append @ A @ Xs1 @ Us ) )
       => ( ( append @ A @ Xs @ Ys )
          = ( append @ A @ Zs @ Us ) ) ) ) ).

% append_eq_appendI
thf(fact_6216_append__eq__append__conv2,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A,Zs: list @ A,Ts: list @ A] :
      ( ( ( append @ A @ Xs @ Ys )
        = ( append @ A @ Zs @ Ts ) )
      = ( ? [Us2: list @ A] :
            ( ( ( Xs
                = ( append @ A @ Zs @ Us2 ) )
              & ( ( append @ A @ Us2 @ Ys )
                = Ts ) )
            | ( ( ( append @ A @ Xs @ Us2 )
                = Zs )
              & ( Ys
                = ( append @ A @ Us2 @ Ts ) ) ) ) ) ) ).

% append_eq_append_conv2
thf(fact_6217_append__replicate__commute,axiom,
    ! [A: $tType,N2: nat,X2: A,K: nat] :
      ( ( append @ A @ ( replicate @ A @ N2 @ X2 ) @ ( replicate @ A @ K @ X2 ) )
      = ( append @ A @ ( replicate @ A @ K @ X2 ) @ ( replicate @ A @ N2 @ X2 ) ) ) ).

% append_replicate_commute
thf(fact_6218_append__listrel1I,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A,R3: set @ ( product_prod @ A @ A ),Us: list @ A,Vs: list @ A] :
      ( ( ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Ys ) @ ( listrel1 @ A @ R3 ) )
          & ( Us = Vs ) )
        | ( ( Xs = Ys )
          & ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Us @ Vs ) @ ( listrel1 @ A @ R3 ) ) ) )
     => ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( append @ A @ Xs @ Us ) @ ( append @ A @ Ys @ Vs ) ) @ ( listrel1 @ A @ R3 ) ) ) ).

% append_listrel1I
thf(fact_6219_enumerate__append__eq,axiom,
    ! [A: $tType,N2: nat,Xs: list @ A,Ys: list @ A] :
      ( ( enumerate @ A @ N2 @ ( append @ A @ Xs @ Ys ) )
      = ( append @ ( product_prod @ nat @ A ) @ ( enumerate @ A @ N2 @ Xs ) @ ( enumerate @ A @ ( plus_plus @ nat @ N2 @ ( size_size @ ( list @ A ) @ Xs ) ) @ Ys ) ) ) ).

% enumerate_append_eq
thf(fact_6220_comm__append__are__replicate,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A] :
      ( ( ( append @ A @ Xs @ Ys )
        = ( append @ A @ Ys @ Xs ) )
     => ? [M3: nat,N: nat,Zs2: list @ A] :
          ( ( ( concat @ A @ ( replicate @ ( list @ A ) @ M3 @ Zs2 ) )
            = Xs )
          & ( ( concat @ A @ ( replicate @ ( list @ A ) @ N @ Zs2 ) )
            = Ys ) ) ) ).

% comm_append_are_replicate
thf(fact_6221_same__length__different,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A] :
      ( ( Xs != Ys )
     => ( ( ( size_size @ ( list @ A ) @ Xs )
          = ( size_size @ ( list @ A ) @ Ys ) )
       => ? [Pre: list @ A,X3: A,Xs4: list @ A,Y4: A,Ys5: list @ A] :
            ( ( X3 != Y4 )
            & ( Xs
              = ( append @ A @ Pre @ ( append @ A @ ( cons @ A @ X3 @ ( nil @ A ) ) @ Xs4 ) ) )
            & ( Ys
              = ( append @ A @ Pre @ ( append @ A @ ( cons @ A @ Y4 @ ( nil @ A ) ) @ Ys5 ) ) ) ) ) ) ).

% same_length_different
thf(fact_6222_not__distinct__decomp,axiom,
    ! [A: $tType,Ws: list @ A] :
      ( ~ ( distinct @ A @ Ws )
     => ? [Xs2: list @ A,Ys4: list @ A,Zs2: list @ A,Y4: A] :
          ( Ws
          = ( append @ A @ Xs2 @ ( append @ A @ ( cons @ A @ Y4 @ ( nil @ A ) ) @ ( append @ A @ Ys4 @ ( append @ A @ ( cons @ A @ Y4 @ ( nil @ A ) ) @ Zs2 ) ) ) ) ) ) ).

% not_distinct_decomp
thf(fact_6223_not__distinct__conv__prefix,axiom,
    ! [A: $tType,As3: list @ A] :
      ( ( ~ ( distinct @ A @ As3 ) )
      = ( ? [Xs3: list @ A,Y5: A,Ys3: list @ A] :
            ( ( member @ A @ Y5 @ ( set2 @ A @ Xs3 ) )
            & ( distinct @ A @ Xs3 )
            & ( As3
              = ( append @ A @ Xs3 @ ( cons @ A @ Y5 @ Ys3 ) ) ) ) ) ) ).

% not_distinct_conv_prefix
thf(fact_6224_replicate__append__same,axiom,
    ! [A: $tType,I3: nat,X2: A] :
      ( ( append @ A @ ( replicate @ A @ I3 @ X2 ) @ ( cons @ A @ X2 @ ( nil @ A ) ) )
      = ( cons @ A @ X2 @ ( replicate @ A @ I3 @ X2 ) ) ) ).

% replicate_append_same
thf(fact_6225_list__update__append1,axiom,
    ! [A: $tType,I3: nat,Xs: list @ A,Ys: list @ A,X2: A] :
      ( ( ord_less @ nat @ I3 @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( ( list_update @ A @ ( append @ A @ Xs @ Ys ) @ I3 @ X2 )
        = ( append @ A @ ( list_update @ A @ Xs @ I3 @ X2 ) @ Ys ) ) ) ).

% list_update_append1
thf(fact_6226_remove1__split,axiom,
    ! [A: $tType,A2: A,Xs: list @ A,Ys: list @ A] :
      ( ( member @ A @ A2 @ ( set2 @ A @ Xs ) )
     => ( ( ( remove1 @ A @ A2 @ Xs )
          = Ys )
        = ( ? [Ls: list @ A,Rs: list @ A] :
              ( ( Xs
                = ( append @ A @ Ls @ ( cons @ A @ A2 @ Rs ) ) )
              & ~ ( member @ A @ A2 @ ( set2 @ A @ Ls ) )
              & ( Ys
                = ( append @ A @ Ls @ Rs ) ) ) ) ) ) ).

% remove1_split
thf(fact_6227_rotate1_Osimps_I2_J,axiom,
    ! [A: $tType,X2: A,Xs: list @ A] :
      ( ( rotate1 @ A @ ( cons @ A @ X2 @ Xs ) )
      = ( append @ A @ Xs @ ( cons @ A @ X2 @ ( nil @ A ) ) ) ) ).

% rotate1.simps(2)
thf(fact_6228_subseqs_Osimps_I1_J,axiom,
    ! [A: $tType] :
      ( ( subseqs @ A @ ( nil @ A ) )
      = ( cons @ ( list @ A ) @ ( nil @ A ) @ ( nil @ ( list @ A ) ) ) ) ).

% subseqs.simps(1)
thf(fact_6229_product__lists_Osimps_I1_J,axiom,
    ! [A: $tType] :
      ( ( product_lists @ A @ ( nil @ ( list @ A ) ) )
      = ( cons @ ( list @ A ) @ ( nil @ A ) @ ( nil @ ( list @ A ) ) ) ) ).

% product_lists.simps(1)
thf(fact_6230_length__append__singleton,axiom,
    ! [A: $tType,Xs: list @ A,X2: A] :
      ( ( size_size @ ( list @ A ) @ ( append @ A @ Xs @ ( cons @ A @ X2 @ ( nil @ A ) ) ) )
      = ( suc @ ( size_size @ ( list @ A ) @ Xs ) ) ) ).

% length_append_singleton
thf(fact_6231_length__Suc__conv__rev,axiom,
    ! [A: $tType,Xs: list @ A,N2: nat] :
      ( ( ( size_size @ ( list @ A ) @ Xs )
        = ( suc @ N2 ) )
      = ( ? [Y5: A,Ys3: list @ A] :
            ( ( Xs
              = ( append @ A @ Ys3 @ ( cons @ A @ Y5 @ ( nil @ A ) ) ) )
            & ( ( size_size @ ( list @ A ) @ Ys3 )
              = N2 ) ) ) ) ).

% length_Suc_conv_rev
thf(fact_6232_nth__append,axiom,
    ! [A: $tType,N2: nat,Xs: list @ A,Ys: list @ A] :
      ( ( ( ord_less @ nat @ N2 @ ( size_size @ ( list @ A ) @ Xs ) )
       => ( ( nth @ A @ ( append @ A @ Xs @ Ys ) @ N2 )
          = ( nth @ A @ Xs @ N2 ) ) )
      & ( ~ ( ord_less @ nat @ N2 @ ( size_size @ ( list @ A ) @ Xs ) )
       => ( ( nth @ A @ ( append @ A @ Xs @ Ys ) @ N2 )
          = ( nth @ A @ Ys @ ( minus_minus @ nat @ N2 @ ( size_size @ ( list @ A ) @ Xs ) ) ) ) ) ) ).

% nth_append
thf(fact_6233_list__update__append,axiom,
    ! [A: $tType,N2: nat,Xs: list @ A,Ys: list @ A,X2: A] :
      ( ( ( ord_less @ nat @ N2 @ ( size_size @ ( list @ A ) @ Xs ) )
       => ( ( list_update @ A @ ( append @ A @ Xs @ Ys ) @ N2 @ X2 )
          = ( append @ A @ ( list_update @ A @ Xs @ N2 @ X2 ) @ Ys ) ) )
      & ( ~ ( ord_less @ nat @ N2 @ ( size_size @ ( list @ A ) @ Xs ) )
       => ( ( list_update @ A @ ( append @ A @ Xs @ Ys ) @ N2 @ X2 )
          = ( append @ A @ Xs @ ( list_update @ A @ Ys @ ( minus_minus @ nat @ N2 @ ( size_size @ ( list @ A ) @ Xs ) ) @ X2 ) ) ) ) ) ).

% list_update_append
thf(fact_6234_listrel1E,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A,R3: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Ys ) @ ( listrel1 @ A @ R3 ) )
     => ~ ! [X3: A,Y4: A] :
            ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X3 @ Y4 ) @ R3 )
           => ! [Us3: list @ A,Vs2: list @ A] :
                ( ( Xs
                  = ( append @ A @ Us3 @ ( cons @ A @ X3 @ Vs2 ) ) )
               => ( Ys
                 != ( append @ A @ Us3 @ ( cons @ A @ Y4 @ Vs2 ) ) ) ) ) ) ).

% listrel1E
thf(fact_6235_listrel1I,axiom,
    ! [A: $tType,X2: A,Y2: A,R3: set @ ( product_prod @ A @ A ),Xs: list @ A,Us: list @ A,Vs: list @ A,Ys: list @ A] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ Y2 ) @ R3 )
     => ( ( Xs
          = ( append @ A @ Us @ ( cons @ A @ X2 @ Vs ) ) )
       => ( ( Ys
            = ( append @ A @ Us @ ( cons @ A @ Y2 @ Vs ) ) )
         => ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Ys ) @ ( listrel1 @ A @ R3 ) ) ) ) ) ).

% listrel1I
thf(fact_6236_n__lists_Osimps_I1_J,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( n_lists @ A @ ( zero_zero @ nat ) @ Xs )
      = ( cons @ ( list @ A ) @ ( nil @ A ) @ ( nil @ ( list @ A ) ) ) ) ).

% n_lists.simps(1)
thf(fact_6237_snoc__listrel1__snoc__iff,axiom,
    ! [A: $tType,Xs: list @ A,X2: A,Ys: list @ A,Y2: A,R3: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( append @ A @ Xs @ ( cons @ A @ X2 @ ( nil @ A ) ) ) @ ( append @ A @ Ys @ ( cons @ A @ Y2 @ ( nil @ A ) ) ) ) @ ( listrel1 @ A @ R3 ) )
      = ( ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Ys ) @ ( listrel1 @ A @ R3 ) )
          & ( X2 = Y2 ) )
        | ( ( Xs = Ys )
          & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ Y2 ) @ R3 ) ) ) ) ).

% snoc_listrel1_snoc_iff
thf(fact_6238_horner__sum__append,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [F2: B > A,A2: A,Xs: list @ B,Ys: list @ B] :
          ( ( groups4207007520872428315er_sum @ B @ A @ F2 @ A2 @ ( append @ B @ Xs @ Ys ) )
          = ( plus_plus @ A @ ( groups4207007520872428315er_sum @ B @ A @ F2 @ A2 @ Xs ) @ ( times_times @ A @ ( power_power @ A @ A2 @ ( size_size @ ( list @ B ) @ Xs ) ) @ ( groups4207007520872428315er_sum @ B @ A @ F2 @ A2 @ Ys ) ) ) ) ) ).

% horner_sum_append
thf(fact_6239_comm__append__is__replicate,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A] :
      ( ( Xs
       != ( nil @ A ) )
     => ( ( Ys
         != ( nil @ A ) )
       => ( ( ( append @ A @ Xs @ Ys )
            = ( append @ A @ Ys @ Xs ) )
         => ? [N: nat,Zs2: list @ A] :
              ( ( ord_less @ nat @ ( one_one @ nat ) @ N )
              & ( ( concat @ A @ ( replicate @ ( list @ A ) @ N @ Zs2 ) )
                = ( append @ A @ Xs @ Ys ) ) ) ) ) ) ).

% comm_append_is_replicate
thf(fact_6240_shuffles_Opelims,axiom,
    ! [A: $tType,X2: list @ A,Xa2: list @ A,Y2: set @ ( list @ A )] :
      ( ( ( shuffles @ A @ X2 @ Xa2 )
        = Y2 )
     => ( ( accp @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( shuffles_rel @ A ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ X2 @ Xa2 ) )
       => ( ( ( X2
              = ( nil @ A ) )
           => ( ( Y2
                = ( insert @ ( list @ A ) @ Xa2 @ ( bot_bot @ ( set @ ( list @ A ) ) ) ) )
             => ~ ( accp @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( shuffles_rel @ A ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( nil @ A ) @ Xa2 ) ) ) )
         => ( ( ( Xa2
                = ( nil @ A ) )
             => ( ( Y2
                  = ( insert @ ( list @ A ) @ X2 @ ( bot_bot @ ( set @ ( list @ A ) ) ) ) )
               => ~ ( accp @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( shuffles_rel @ A ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ X2 @ ( nil @ A ) ) ) ) )
           => ~ ! [X3: A,Xs2: list @ A] :
                  ( ( X2
                    = ( cons @ A @ X3 @ Xs2 ) )
                 => ! [Y4: A,Ys4: list @ A] :
                      ( ( Xa2
                        = ( cons @ A @ Y4 @ Ys4 ) )
                     => ( ( Y2
                          = ( sup_sup @ ( set @ ( list @ A ) ) @ ( image @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X3 ) @ ( shuffles @ A @ Xs2 @ ( cons @ A @ Y4 @ Ys4 ) ) ) @ ( image @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ Y4 ) @ ( shuffles @ A @ ( cons @ A @ X3 @ Xs2 ) @ Ys4 ) ) ) )
                       => ~ ( accp @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( shuffles_rel @ A ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X3 @ Xs2 ) @ ( cons @ A @ Y4 @ Ys4 ) ) ) ) ) ) ) ) ) ) ).

% shuffles.pelims
thf(fact_6241_these__insert__Some,axiom,
    ! [A: $tType,X2: A,A3: set @ ( option @ A )] :
      ( ( these @ A @ ( insert @ ( option @ A ) @ ( some @ A @ X2 ) @ A3 ) )
      = ( insert @ A @ X2 @ ( these @ A @ A3 ) ) ) ).

% these_insert_Some
thf(fact_6242_le__sup__iff,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [X2: A,Y2: A,Z: A] :
          ( ( ord_less_eq @ A @ ( sup_sup @ A @ X2 @ Y2 ) @ Z )
          = ( ( ord_less_eq @ A @ X2 @ Z )
            & ( ord_less_eq @ A @ Y2 @ Z ) ) ) ) ).

% le_sup_iff
thf(fact_6243_sup_Obounded__iff,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( ord_less_eq @ A @ ( sup_sup @ A @ B2 @ C2 ) @ A2 )
          = ( ( ord_less_eq @ A @ B2 @ A2 )
            & ( ord_less_eq @ A @ C2 @ A2 ) ) ) ) ).

% sup.bounded_iff
thf(fact_6244_Un__subset__iff,axiom,
    ! [A: $tType,A3: set @ A,B3: set @ A,C6: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ ( sup_sup @ ( set @ A ) @ A3 @ B3 ) @ C6 )
      = ( ( ord_less_eq @ ( set @ A ) @ A3 @ C6 )
        & ( ord_less_eq @ ( set @ A ) @ B3 @ C6 ) ) ) ).

% Un_subset_iff
thf(fact_6245_set__append,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A] :
      ( ( set2 @ A @ ( append @ A @ Xs @ Ys ) )
      = ( sup_sup @ ( set @ A ) @ ( set2 @ A @ Xs ) @ ( set2 @ A @ Ys ) ) ) ).

% set_append
thf(fact_6246_these__image__Some__eq,axiom,
    ! [A: $tType,A3: set @ A] :
      ( ( these @ A @ ( image @ A @ ( option @ A ) @ ( some @ A ) @ A3 ) )
      = A3 ) ).

% these_image_Some_eq
thf(fact_6247_set__union,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A] :
      ( ( set2 @ A @ ( union @ A @ Xs @ Ys ) )
      = ( sup_sup @ ( set @ A ) @ ( set2 @ A @ Xs ) @ ( set2 @ A @ Ys ) ) ) ).

% set_union
thf(fact_6248_these__insert__None,axiom,
    ! [A: $tType,A3: set @ ( option @ A )] :
      ( ( these @ A @ ( insert @ ( option @ A ) @ ( none @ A ) @ A3 ) )
      = ( these @ A @ A3 ) ) ).

% these_insert_None
thf(fact_6249_Diff__partition,axiom,
    ! [A: $tType,A3: set @ A,B3: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ B3 )
     => ( ( sup_sup @ ( set @ A ) @ A3 @ ( minus_minus @ ( set @ A ) @ B3 @ A3 ) )
        = B3 ) ) ).

% Diff_partition
thf(fact_6250_Diff__subset__conv,axiom,
    ! [A: $tType,A3: set @ A,B3: set @ A,C6: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ A3 @ B3 ) @ C6 )
      = ( ord_less_eq @ ( set @ A ) @ A3 @ ( sup_sup @ ( set @ A ) @ B3 @ C6 ) ) ) ).

% Diff_subset_conv
thf(fact_6251_Un__Pow__subset,axiom,
    ! [A: $tType,A3: set @ A,B3: set @ A] : ( ord_less_eq @ ( set @ ( set @ A ) ) @ ( sup_sup @ ( set @ ( set @ A ) ) @ ( pow2 @ A @ A3 ) @ ( pow2 @ A @ B3 ) ) @ ( pow2 @ A @ ( sup_sup @ ( set @ A ) @ A3 @ B3 ) ) ) ).

% Un_Pow_subset
thf(fact_6252_inf__sup__ord_I4_J,axiom,
    ! [A: $tType] :
      ( ( lattice @ A )
     => ! [Y2: A,X2: A] : ( ord_less_eq @ A @ Y2 @ ( sup_sup @ A @ X2 @ Y2 ) ) ) ).

% inf_sup_ord(4)
thf(fact_6253_inf__sup__ord_I3_J,axiom,
    ! [A: $tType] :
      ( ( lattice @ A )
     => ! [X2: A,Y2: A] : ( ord_less_eq @ A @ X2 @ ( sup_sup @ A @ X2 @ Y2 ) ) ) ).

% inf_sup_ord(3)
thf(fact_6254_le__supE,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A2: A,B2: A,X2: A] :
          ( ( ord_less_eq @ A @ ( sup_sup @ A @ A2 @ B2 ) @ X2 )
         => ~ ( ( ord_less_eq @ A @ A2 @ X2 )
             => ~ ( ord_less_eq @ A @ B2 @ X2 ) ) ) ) ).

% le_supE
thf(fact_6255_le__supI,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A2: A,X2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ X2 )
         => ( ( ord_less_eq @ A @ B2 @ X2 )
           => ( ord_less_eq @ A @ ( sup_sup @ A @ A2 @ B2 ) @ X2 ) ) ) ) ).

% le_supI
thf(fact_6256_sup__ge1,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [X2: A,Y2: A] : ( ord_less_eq @ A @ X2 @ ( sup_sup @ A @ X2 @ Y2 ) ) ) ).

% sup_ge1
thf(fact_6257_sup__ge2,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [Y2: A,X2: A] : ( ord_less_eq @ A @ Y2 @ ( sup_sup @ A @ X2 @ Y2 ) ) ) ).

% sup_ge2
thf(fact_6258_le__supI1,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [X2: A,A2: A,B2: A] :
          ( ( ord_less_eq @ A @ X2 @ A2 )
         => ( ord_less_eq @ A @ X2 @ ( sup_sup @ A @ A2 @ B2 ) ) ) ) ).

% le_supI1
thf(fact_6259_le__supI2,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [X2: A,B2: A,A2: A] :
          ( ( ord_less_eq @ A @ X2 @ B2 )
         => ( ord_less_eq @ A @ X2 @ ( sup_sup @ A @ A2 @ B2 ) ) ) ) ).

% le_supI2
thf(fact_6260_sup_Omono,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [C2: A,A2: A,D2: A,B2: A] :
          ( ( ord_less_eq @ A @ C2 @ A2 )
         => ( ( ord_less_eq @ A @ D2 @ B2 )
           => ( ord_less_eq @ A @ ( sup_sup @ A @ C2 @ D2 ) @ ( sup_sup @ A @ A2 @ B2 ) ) ) ) ) ).

% sup.mono
thf(fact_6261_sup__mono,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A2: A,C2: A,B2: A,D2: A] :
          ( ( ord_less_eq @ A @ A2 @ C2 )
         => ( ( ord_less_eq @ A @ B2 @ D2 )
           => ( ord_less_eq @ A @ ( sup_sup @ A @ A2 @ B2 ) @ ( sup_sup @ A @ C2 @ D2 ) ) ) ) ) ).

% sup_mono
thf(fact_6262_sup__least,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [Y2: A,X2: A,Z: A] :
          ( ( ord_less_eq @ A @ Y2 @ X2 )
         => ( ( ord_less_eq @ A @ Z @ X2 )
           => ( ord_less_eq @ A @ ( sup_sup @ A @ Y2 @ Z ) @ X2 ) ) ) ) ).

% sup_least
thf(fact_6263_le__iff__sup,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [X5: A,Y5: A] :
              ( ( sup_sup @ A @ X5 @ Y5 )
              = Y5 ) ) ) ) ).

% le_iff_sup
thf(fact_6264_sup_OorderE,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less_eq @ A @ B2 @ A2 )
         => ( A2
            = ( sup_sup @ A @ A2 @ B2 ) ) ) ) ).

% sup.orderE
thf(fact_6265_sup_OorderI,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A2: A,B2: A] :
          ( ( A2
            = ( sup_sup @ A @ A2 @ B2 ) )
         => ( ord_less_eq @ A @ B2 @ A2 ) ) ) ).

% sup.orderI
thf(fact_6266_sup__unique,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [F2: A > A > A,X2: A,Y2: A] :
          ( ! [X3: A,Y4: A] : ( ord_less_eq @ A @ X3 @ ( F2 @ X3 @ Y4 ) )
         => ( ! [X3: A,Y4: A] : ( ord_less_eq @ A @ Y4 @ ( F2 @ X3 @ Y4 ) )
           => ( ! [X3: A,Y4: A,Z3: A] :
                  ( ( ord_less_eq @ A @ Y4 @ X3 )
                 => ( ( ord_less_eq @ A @ Z3 @ X3 )
                   => ( ord_less_eq @ A @ ( F2 @ Y4 @ Z3 ) @ X3 ) ) )
             => ( ( sup_sup @ A @ X2 @ Y2 )
                = ( F2 @ X2 @ Y2 ) ) ) ) ) ) ).

% sup_unique
thf(fact_6267_sup_Oabsorb1,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less_eq @ A @ B2 @ A2 )
         => ( ( sup_sup @ A @ A2 @ B2 )
            = A2 ) ) ) ).

% sup.absorb1
thf(fact_6268_sup_Oabsorb2,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( sup_sup @ A @ A2 @ B2 )
            = B2 ) ) ) ).

% sup.absorb2
thf(fact_6269_sup__absorb1,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [Y2: A,X2: A] :
          ( ( ord_less_eq @ A @ Y2 @ X2 )
         => ( ( sup_sup @ A @ X2 @ Y2 )
            = X2 ) ) ) ).

% sup_absorb1
thf(fact_6270_sup__absorb2,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [X2: A,Y2: A] :
          ( ( ord_less_eq @ A @ X2 @ Y2 )
         => ( ( sup_sup @ A @ X2 @ Y2 )
            = Y2 ) ) ) ).

% sup_absorb2
thf(fact_6271_sup_OboundedE,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( ord_less_eq @ A @ ( sup_sup @ A @ B2 @ C2 ) @ A2 )
         => ~ ( ( ord_less_eq @ A @ B2 @ A2 )
             => ~ ( ord_less_eq @ A @ C2 @ A2 ) ) ) ) ).

% sup.boundedE
thf(fact_6272_sup_OboundedI,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( ord_less_eq @ A @ B2 @ A2 )
         => ( ( ord_less_eq @ A @ C2 @ A2 )
           => ( ord_less_eq @ A @ ( sup_sup @ A @ B2 @ C2 ) @ A2 ) ) ) ) ).

% sup.boundedI
thf(fact_6273_sup_Oorder__iff,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [B4: A,A4: A] :
              ( A4
              = ( sup_sup @ A @ A4 @ B4 ) ) ) ) ) ).

% sup.order_iff
thf(fact_6274_sup_Ocobounded1,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A2: A,B2: A] : ( ord_less_eq @ A @ A2 @ ( sup_sup @ A @ A2 @ B2 ) ) ) ).

% sup.cobounded1
thf(fact_6275_sup_Ocobounded2,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [B2: A,A2: A] : ( ord_less_eq @ A @ B2 @ ( sup_sup @ A @ A2 @ B2 ) ) ) ).

% sup.cobounded2
thf(fact_6276_sup_Oabsorb__iff1,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [B4: A,A4: A] :
              ( ( sup_sup @ A @ A4 @ B4 )
              = A4 ) ) ) ) ).

% sup.absorb_iff1
thf(fact_6277_sup_Oabsorb__iff2,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [A4: A,B4: A] :
              ( ( sup_sup @ A @ A4 @ B4 )
              = B4 ) ) ) ) ).

% sup.absorb_iff2
thf(fact_6278_sup_OcoboundedI1,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less_eq @ A @ C2 @ A2 )
         => ( ord_less_eq @ A @ C2 @ ( sup_sup @ A @ A2 @ B2 ) ) ) ) ).

% sup.coboundedI1
thf(fact_6279_sup_OcoboundedI2,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( ord_less_eq @ A @ C2 @ B2 )
         => ( ord_less_eq @ A @ C2 @ ( sup_sup @ A @ A2 @ B2 ) ) ) ) ).

% sup.coboundedI2
thf(fact_6280_subset__Un__eq,axiom,
    ! [A: $tType] :
      ( ( ord_less_eq @ ( set @ A ) )
      = ( ^ [A7: set @ A,B8: set @ A] :
            ( ( sup_sup @ ( set @ A ) @ A7 @ B8 )
            = B8 ) ) ) ).

% subset_Un_eq
thf(fact_6281_subset__UnE,axiom,
    ! [A: $tType,C6: set @ A,A3: set @ A,B3: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ C6 @ ( sup_sup @ ( set @ A ) @ A3 @ B3 ) )
     => ~ ! [A15: set @ A] :
            ( ( ord_less_eq @ ( set @ A ) @ A15 @ A3 )
           => ! [B15: set @ A] :
                ( ( ord_less_eq @ ( set @ A ) @ B15 @ B3 )
               => ( C6
                 != ( sup_sup @ ( set @ A ) @ A15 @ B15 ) ) ) ) ) ).

% subset_UnE
thf(fact_6282_Un__absorb2,axiom,
    ! [A: $tType,B3: set @ A,A3: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ B3 @ A3 )
     => ( ( sup_sup @ ( set @ A ) @ A3 @ B3 )
        = A3 ) ) ).

% Un_absorb2
thf(fact_6283_Un__absorb1,axiom,
    ! [A: $tType,A3: set @ A,B3: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ B3 )
     => ( ( sup_sup @ ( set @ A ) @ A3 @ B3 )
        = B3 ) ) ).

% Un_absorb1
thf(fact_6284_Un__upper2,axiom,
    ! [A: $tType,B3: set @ A,A3: set @ A] : ( ord_less_eq @ ( set @ A ) @ B3 @ ( sup_sup @ ( set @ A ) @ A3 @ B3 ) ) ).

% Un_upper2
thf(fact_6285_Un__upper1,axiom,
    ! [A: $tType,A3: set @ A,B3: set @ A] : ( ord_less_eq @ ( set @ A ) @ A3 @ ( sup_sup @ ( set @ A ) @ A3 @ B3 ) ) ).

% Un_upper1
thf(fact_6286_Un__least,axiom,
    ! [A: $tType,A3: set @ A,C6: set @ A,B3: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ C6 )
     => ( ( ord_less_eq @ ( set @ A ) @ B3 @ C6 )
       => ( ord_less_eq @ ( set @ A ) @ ( sup_sup @ ( set @ A ) @ A3 @ B3 ) @ C6 ) ) ) ).

% Un_least
thf(fact_6287_Un__mono,axiom,
    ! [A: $tType,A3: set @ A,C6: set @ A,B3: set @ A,D5: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ C6 )
     => ( ( ord_less_eq @ ( set @ A ) @ B3 @ D5 )
       => ( ord_less_eq @ ( set @ A ) @ ( sup_sup @ ( set @ A ) @ A3 @ B3 ) @ ( sup_sup @ ( set @ A ) @ C6 @ D5 ) ) ) ) ).

% Un_mono
thf(fact_6288_ivl__disj__un__two__touch_I4_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L: A,M: A,U: A] :
          ( ( ord_less_eq @ A @ L @ M )
         => ( ( ord_less_eq @ A @ M @ U )
           => ( ( sup_sup @ ( set @ A ) @ ( set_or1337092689740270186AtMost @ A @ L @ M ) @ ( set_or1337092689740270186AtMost @ A @ M @ U ) )
              = ( set_or1337092689740270186AtMost @ A @ L @ U ) ) ) ) ) ).

% ivl_disj_un_two_touch(4)
thf(fact_6289_ivl__disj__un__two_I3_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L: A,M: A,U: A] :
          ( ( ord_less_eq @ A @ L @ M )
         => ( ( ord_less_eq @ A @ M @ U )
           => ( ( sup_sup @ ( set @ A ) @ ( set_or7035219750837199246ssThan @ A @ L @ M ) @ ( set_or7035219750837199246ssThan @ A @ M @ U ) )
              = ( set_or7035219750837199246ssThan @ A @ L @ U ) ) ) ) ) ).

% ivl_disj_un_two(3)
thf(fact_6290_Un__Int__assoc__eq,axiom,
    ! [A: $tType,A3: set @ A,B3: set @ A,C6: set @ A] :
      ( ( ( sup_sup @ ( set @ A ) @ ( inf_inf @ ( set @ A ) @ A3 @ B3 ) @ C6 )
        = ( inf_inf @ ( set @ A ) @ A3 @ ( sup_sup @ ( set @ A ) @ B3 @ C6 ) ) )
      = ( ord_less_eq @ ( set @ A ) @ C6 @ A3 ) ) ).

% Un_Int_assoc_eq
thf(fact_6291_distrib__sup__le,axiom,
    ! [A: $tType] :
      ( ( lattice @ A )
     => ! [X2: A,Y2: A,Z: A] : ( ord_less_eq @ A @ ( sup_sup @ A @ X2 @ ( inf_inf @ A @ Y2 @ Z ) ) @ ( inf_inf @ A @ ( sup_sup @ A @ X2 @ Y2 ) @ ( sup_sup @ A @ X2 @ Z ) ) ) ) ).

% distrib_sup_le
thf(fact_6292_distrib__inf__le,axiom,
    ! [A: $tType] :
      ( ( lattice @ A )
     => ! [X2: A,Y2: A,Z: A] : ( ord_less_eq @ A @ ( sup_sup @ A @ ( inf_inf @ A @ X2 @ Y2 ) @ ( inf_inf @ A @ X2 @ Z ) ) @ ( inf_inf @ A @ X2 @ ( sup_sup @ A @ Y2 @ Z ) ) ) ) ).

% distrib_inf_le
thf(fact_6293_less__supI1,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [X2: A,A2: A,B2: A] :
          ( ( ord_less @ A @ X2 @ A2 )
         => ( ord_less @ A @ X2 @ ( sup_sup @ A @ A2 @ B2 ) ) ) ) ).

% less_supI1
thf(fact_6294_less__supI2,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [X2: A,B2: A,A2: A] :
          ( ( ord_less @ A @ X2 @ B2 )
         => ( ord_less @ A @ X2 @ ( sup_sup @ A @ A2 @ B2 ) ) ) ) ).

% less_supI2
thf(fact_6295_sup_Oabsorb3,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less @ A @ B2 @ A2 )
         => ( ( sup_sup @ A @ A2 @ B2 )
            = A2 ) ) ) ).

% sup.absorb3
thf(fact_6296_sup_Oabsorb4,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( sup_sup @ A @ A2 @ B2 )
            = B2 ) ) ) ).

% sup.absorb4
thf(fact_6297_sup_Ostrict__boundedE,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( ord_less @ A @ ( sup_sup @ A @ B2 @ C2 ) @ A2 )
         => ~ ( ( ord_less @ A @ B2 @ A2 )
             => ~ ( ord_less @ A @ C2 @ A2 ) ) ) ) ).

% sup.strict_boundedE
thf(fact_6298_sup_Ostrict__order__iff,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ( ( ord_less @ A )
        = ( ^ [B4: A,A4: A] :
              ( ( A4
                = ( sup_sup @ A @ A4 @ B4 ) )
              & ( A4 != B4 ) ) ) ) ) ).

% sup.strict_order_iff
thf(fact_6299_sup_Ostrict__coboundedI1,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less @ A @ C2 @ A2 )
         => ( ord_less @ A @ C2 @ ( sup_sup @ A @ A2 @ B2 ) ) ) ) ).

% sup.strict_coboundedI1
thf(fact_6300_sup_Ostrict__coboundedI2,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( ord_less @ A @ C2 @ B2 )
         => ( ord_less @ A @ C2 @ ( sup_sup @ A @ A2 @ B2 ) ) ) ) ).

% sup.strict_coboundedI2
thf(fact_6301_in__these__eq,axiom,
    ! [A: $tType,X2: A,A3: set @ ( option @ A )] :
      ( ( member @ A @ X2 @ ( these @ A @ A3 ) )
      = ( member @ ( option @ A ) @ ( some @ A @ X2 ) @ A3 ) ) ).

% in_these_eq
thf(fact_6302_set__shuffles,axiom,
    ! [A: $tType,Zs: list @ A,Xs: list @ A,Ys: list @ A] :
      ( ( member @ ( list @ A ) @ Zs @ ( shuffles @ A @ Xs @ Ys ) )
     => ( ( set2 @ A @ Zs )
        = ( sup_sup @ ( set @ A ) @ ( set2 @ A @ Xs ) @ ( set2 @ A @ Ys ) ) ) ) ).

% set_shuffles
thf(fact_6303_sup__shunt,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [X2: A,Y2: A] :
          ( ( ( sup_sup @ A @ X2 @ Y2 )
            = ( top_top @ A ) )
          = ( ord_less_eq @ A @ ( uminus_uminus @ A @ X2 ) @ Y2 ) ) ) ).

% sup_shunt
thf(fact_6304_sup__neg__inf,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [P4: A,Q3: A,R3: A] :
          ( ( ord_less_eq @ A @ P4 @ ( sup_sup @ A @ Q3 @ R3 ) )
          = ( ord_less_eq @ A @ ( inf_inf @ A @ P4 @ ( uminus_uminus @ A @ Q3 ) ) @ R3 ) ) ) ).

% sup_neg_inf
thf(fact_6305_shunt2,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [X2: A,Y2: A,Z: A] :
          ( ( ord_less_eq @ A @ ( inf_inf @ A @ X2 @ ( uminus_uminus @ A @ Y2 ) ) @ Z )
          = ( ord_less_eq @ A @ X2 @ ( sup_sup @ A @ Y2 @ Z ) ) ) ) ).

% shunt2
thf(fact_6306_shunt1,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [X2: A,Y2: A,Z: A] :
          ( ( ord_less_eq @ A @ ( inf_inf @ A @ X2 @ Y2 ) @ Z )
          = ( ord_less_eq @ A @ X2 @ ( sup_sup @ A @ ( uminus_uminus @ A @ Y2 ) @ Z ) ) ) ) ).

% shunt1
thf(fact_6307_less__eq__Inf__inter,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A3: set @ A,B3: set @ A] : ( ord_less_eq @ A @ ( sup_sup @ A @ ( complete_Inf_Inf @ A @ A3 ) @ ( complete_Inf_Inf @ A @ B3 ) ) @ ( complete_Inf_Inf @ A @ ( inf_inf @ ( set @ A ) @ A3 @ B3 ) ) ) ) ).

% less_eq_Inf_inter
thf(fact_6308_ivl__disj__un__two_I7_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L: A,M: A,U: A] :
          ( ( ord_less_eq @ A @ L @ M )
         => ( ( ord_less_eq @ A @ M @ U )
           => ( ( sup_sup @ ( set @ A ) @ ( set_or7035219750837199246ssThan @ A @ L @ M ) @ ( set_or1337092689740270186AtMost @ A @ M @ U ) )
              = ( set_or1337092689740270186AtMost @ A @ L @ U ) ) ) ) ) ).

% ivl_disj_un_two(7)
thf(fact_6309_ivl__disj__un__one_I2_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L: A,U: A] :
          ( ( ord_less_eq @ A @ L @ U )
         => ( ( sup_sup @ ( set @ A ) @ ( set_ord_lessThan @ A @ L ) @ ( set_or7035219750837199246ssThan @ A @ L @ U ) )
            = ( set_ord_lessThan @ A @ U ) ) ) ) ).

% ivl_disj_un_one(2)
thf(fact_6310_card__Un__le,axiom,
    ! [A: $tType,A3: set @ A,B3: set @ A] : ( ord_less_eq @ nat @ ( finite_card @ A @ ( sup_sup @ ( set @ A ) @ A3 @ B3 ) ) @ ( plus_plus @ nat @ ( finite_card @ A @ A3 ) @ ( finite_card @ A @ B3 ) ) ) ).

% card_Un_le
thf(fact_6311_shuffles_Osimps_I3_J,axiom,
    ! [A: $tType,X2: A,Xs: list @ A,Y2: A,Ys: list @ A] :
      ( ( shuffles @ A @ ( cons @ A @ X2 @ Xs ) @ ( cons @ A @ Y2 @ Ys ) )
      = ( sup_sup @ ( set @ ( list @ A ) ) @ ( image @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X2 ) @ ( shuffles @ A @ Xs @ ( cons @ A @ Y2 @ Ys ) ) ) @ ( image @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ Y2 ) @ ( shuffles @ A @ ( cons @ A @ X2 @ Xs ) @ Ys ) ) ) ) ).

% shuffles.simps(3)
thf(fact_6312_Inter__Un__subset,axiom,
    ! [A: $tType,A3: set @ ( set @ A ),B3: set @ ( set @ A )] : ( ord_less_eq @ ( set @ A ) @ ( sup_sup @ ( set @ A ) @ ( complete_Inf_Inf @ ( set @ A ) @ A3 ) @ ( complete_Inf_Inf @ ( set @ A ) @ B3 ) ) @ ( complete_Inf_Inf @ ( set @ A ) @ ( inf_inf @ ( set @ ( set @ A ) ) @ A3 @ B3 ) ) ) ).

% Inter_Un_subset
thf(fact_6313_ivl__disj__un__two__touch_I2_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L: A,M: A,U: A] :
          ( ( ord_less_eq @ A @ L @ M )
         => ( ( ord_less @ A @ M @ U )
           => ( ( sup_sup @ ( set @ A ) @ ( set_or1337092689740270186AtMost @ A @ L @ M ) @ ( set_or7035219750837199246ssThan @ A @ M @ U ) )
              = ( set_or7035219750837199246ssThan @ A @ L @ U ) ) ) ) ) ).

% ivl_disj_un_two_touch(2)
thf(fact_6314_sum_Ounion__inter,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A3: set @ B,B3: set @ B,G: B > A] :
          ( ( finite_finite @ B @ A3 )
         => ( ( finite_finite @ B @ B3 )
           => ( ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ B @ A @ G @ ( sup_sup @ ( set @ B ) @ A3 @ B3 ) ) @ ( groups7311177749621191930dd_sum @ B @ A @ G @ ( inf_inf @ ( set @ B ) @ A3 @ B3 ) ) )
              = ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ B @ A @ G @ A3 ) @ ( groups7311177749621191930dd_sum @ B @ A @ G @ B3 ) ) ) ) ) ) ).

% sum.union_inter
thf(fact_6315_prod_Ounion__inter,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A3: set @ B,B3: set @ B,G: B > A] :
          ( ( finite_finite @ B @ A3 )
         => ( ( finite_finite @ B @ B3 )
           => ( ( times_times @ A @ ( groups7121269368397514597t_prod @ B @ A @ G @ ( sup_sup @ ( set @ B ) @ A3 @ B3 ) ) @ ( groups7121269368397514597t_prod @ B @ A @ G @ ( inf_inf @ ( set @ B ) @ A3 @ B3 ) ) )
              = ( times_times @ A @ ( groups7121269368397514597t_prod @ B @ A @ G @ A3 ) @ ( groups7121269368397514597t_prod @ B @ A @ G @ B3 ) ) ) ) ) ) ).

% prod.union_inter
thf(fact_6316_card__Un__Int,axiom,
    ! [A: $tType,A3: set @ A,B3: set @ A] :
      ( ( finite_finite @ A @ A3 )
     => ( ( finite_finite @ A @ B3 )
       => ( ( plus_plus @ nat @ ( finite_card @ A @ A3 ) @ ( finite_card @ A @ B3 ) )
          = ( plus_plus @ nat @ ( finite_card @ A @ ( sup_sup @ ( set @ A ) @ A3 @ B3 ) ) @ ( finite_card @ A @ ( inf_inf @ ( set @ A ) @ A3 @ B3 ) ) ) ) ) ) ).

% card_Un_Int
thf(fact_6317_ivl__disj__un__one_I4_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L: A,U: A] :
          ( ( ord_less_eq @ A @ L @ U )
         => ( ( sup_sup @ ( set @ A ) @ ( set_ord_lessThan @ A @ L ) @ ( set_or1337092689740270186AtMost @ A @ L @ U ) )
            = ( set_ord_atMost @ A @ U ) ) ) ) ).

% ivl_disj_un_one(4)
thf(fact_6318_SUP__nat__binary,axiom,
    ! [A: $tType] :
      ( ( counta3822494911875563373attice @ A )
     => ! [A3: A,B3: A] :
          ( ( sup_sup @ A @ A3
            @ ( complete_Sup_Sup @ A
              @ ( image @ nat @ A
                @ ^ [X5: nat] : B3
                @ ( collect @ nat @ ( ord_less @ nat @ ( zero_zero @ nat ) ) ) ) ) )
          = ( sup_sup @ A @ A3 @ B3 ) ) ) ).

% SUP_nat_binary
thf(fact_6319_sup__bot_Osemilattice__neutr__order__axioms,axiom,
    ! [A: $tType] :
      ( ( bounde4967611905675639751up_bot @ A )
     => ( semila1105856199041335345_order @ A @ ( sup_sup @ A ) @ ( bot_bot @ A )
        @ ^ [X5: A,Y5: A] : ( ord_less_eq @ A @ Y5 @ X5 )
        @ ^ [X5: A,Y5: A] : ( ord_less @ A @ Y5 @ X5 ) ) ) ).

% sup_bot.semilattice_neutr_order_axioms
thf(fact_6320_sum_Ounion__inter__neutral,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A3: set @ B,B3: set @ B,G: B > A] :
          ( ( finite_finite @ B @ A3 )
         => ( ( finite_finite @ B @ B3 )
           => ( ! [X3: B] :
                  ( ( member @ B @ X3 @ ( inf_inf @ ( set @ B ) @ A3 @ B3 ) )
                 => ( ( G @ X3 )
                    = ( zero_zero @ A ) ) )
             => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ ( sup_sup @ ( set @ B ) @ A3 @ B3 ) )
                = ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ B @ A @ G @ A3 ) @ ( groups7311177749621191930dd_sum @ B @ A @ G @ B3 ) ) ) ) ) ) ) ).

% sum.union_inter_neutral
thf(fact_6321_sum__Un,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ab_group_add @ A )
     => ! [A3: set @ B,B3: set @ B,F2: B > A] :
          ( ( finite_finite @ B @ A3 )
         => ( ( finite_finite @ B @ B3 )
           => ( ( groups7311177749621191930dd_sum @ B @ A @ F2 @ ( sup_sup @ ( set @ B ) @ A3 @ B3 ) )
              = ( minus_minus @ A @ ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ A3 ) @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ B3 ) ) @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ ( inf_inf @ ( set @ B ) @ A3 @ B3 ) ) ) ) ) ) ) ).

% sum_Un
thf(fact_6322_sum_Ounion__disjoint,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A3: set @ B,B3: set @ B,G: B > A] :
          ( ( finite_finite @ B @ A3 )
         => ( ( finite_finite @ B @ B3 )
           => ( ( ( inf_inf @ ( set @ B ) @ A3 @ B3 )
                = ( bot_bot @ ( set @ B ) ) )
             => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ ( sup_sup @ ( set @ B ) @ A3 @ B3 ) )
                = ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ B @ A @ G @ A3 ) @ ( groups7311177749621191930dd_sum @ B @ A @ G @ B3 ) ) ) ) ) ) ) ).

% sum.union_disjoint
thf(fact_6323_prod_Ounion__inter__neutral,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A3: set @ B,B3: set @ B,G: B > A] :
          ( ( finite_finite @ B @ A3 )
         => ( ( finite_finite @ B @ B3 )
           => ( ! [X3: B] :
                  ( ( member @ B @ X3 @ ( inf_inf @ ( set @ B ) @ A3 @ B3 ) )
                 => ( ( G @ X3 )
                    = ( one_one @ A ) ) )
             => ( ( groups7121269368397514597t_prod @ B @ A @ G @ ( sup_sup @ ( set @ B ) @ A3 @ B3 ) )
                = ( times_times @ A @ ( groups7121269368397514597t_prod @ B @ A @ G @ A3 ) @ ( groups7121269368397514597t_prod @ B @ A @ G @ B3 ) ) ) ) ) ) ) ).

% prod.union_inter_neutral
thf(fact_6324_prod_Ounion__disjoint,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A3: set @ B,B3: set @ B,G: B > A] :
          ( ( finite_finite @ B @ A3 )
         => ( ( finite_finite @ B @ B3 )
           => ( ( ( inf_inf @ ( set @ B ) @ A3 @ B3 )
                = ( bot_bot @ ( set @ B ) ) )
             => ( ( groups7121269368397514597t_prod @ B @ A @ G @ ( sup_sup @ ( set @ B ) @ A3 @ B3 ) )
                = ( times_times @ A @ ( groups7121269368397514597t_prod @ B @ A @ G @ A3 ) @ ( groups7121269368397514597t_prod @ B @ A @ G @ B3 ) ) ) ) ) ) ) ).

% prod.union_disjoint
thf(fact_6325_ivl__disj__un__singleton_I6_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L: A,U: A] :
          ( ( ord_less_eq @ A @ L @ U )
         => ( ( sup_sup @ ( set @ A ) @ ( set_or7035219750837199246ssThan @ A @ L @ U ) @ ( insert @ A @ U @ ( bot_bot @ ( set @ A ) ) ) )
            = ( set_or1337092689740270186AtMost @ A @ L @ U ) ) ) ) ).

% ivl_disj_un_singleton(6)
thf(fact_6326_sum_Ounion__diff2,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A3: set @ B,B3: set @ B,G: B > A] :
          ( ( finite_finite @ B @ A3 )
         => ( ( finite_finite @ B @ B3 )
           => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ ( sup_sup @ ( set @ B ) @ A3 @ B3 ) )
              = ( plus_plus @ A @ ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ B @ A @ G @ ( minus_minus @ ( set @ B ) @ A3 @ B3 ) ) @ ( groups7311177749621191930dd_sum @ B @ A @ G @ ( minus_minus @ ( set @ B ) @ B3 @ A3 ) ) ) @ ( groups7311177749621191930dd_sum @ B @ A @ G @ ( inf_inf @ ( set @ B ) @ A3 @ B3 ) ) ) ) ) ) ) ).

% sum.union_diff2
thf(fact_6327_sum__Un2,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comm_monoid_add @ B )
     => ! [A3: set @ A,B3: set @ A,F2: A > B] :
          ( ( finite_finite @ A @ ( sup_sup @ ( set @ A ) @ A3 @ B3 ) )
         => ( ( groups7311177749621191930dd_sum @ A @ B @ F2 @ ( sup_sup @ ( set @ A ) @ A3 @ B3 ) )
            = ( plus_plus @ B @ ( plus_plus @ B @ ( groups7311177749621191930dd_sum @ A @ B @ F2 @ ( minus_minus @ ( set @ A ) @ A3 @ B3 ) ) @ ( groups7311177749621191930dd_sum @ A @ B @ F2 @ ( minus_minus @ ( set @ A ) @ B3 @ A3 ) ) ) @ ( groups7311177749621191930dd_sum @ A @ B @ F2 @ ( inf_inf @ ( set @ A ) @ A3 @ B3 ) ) ) ) ) ) ).

% sum_Un2
thf(fact_6328_prod_Ounion__diff2,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A3: set @ B,B3: set @ B,G: B > A] :
          ( ( finite_finite @ B @ A3 )
         => ( ( finite_finite @ B @ B3 )
           => ( ( groups7121269368397514597t_prod @ B @ A @ G @ ( sup_sup @ ( set @ B ) @ A3 @ B3 ) )
              = ( times_times @ A @ ( times_times @ A @ ( groups7121269368397514597t_prod @ B @ A @ G @ ( minus_minus @ ( set @ B ) @ A3 @ B3 ) ) @ ( groups7121269368397514597t_prod @ B @ A @ G @ ( minus_minus @ ( set @ B ) @ B3 @ A3 ) ) ) @ ( groups7121269368397514597t_prod @ B @ A @ G @ ( inf_inf @ ( set @ B ) @ A3 @ B3 ) ) ) ) ) ) ) ).

% prod.union_diff2
thf(fact_6329_card__Un__disjoint,axiom,
    ! [A: $tType,A3: set @ A,B3: set @ A] :
      ( ( finite_finite @ A @ A3 )
     => ( ( finite_finite @ A @ B3 )
       => ( ( ( inf_inf @ ( set @ A ) @ A3 @ B3 )
            = ( bot_bot @ ( set @ A ) ) )
         => ( ( finite_card @ A @ ( sup_sup @ ( set @ A ) @ A3 @ B3 ) )
            = ( plus_plus @ nat @ ( finite_card @ A @ A3 ) @ ( finite_card @ A @ B3 ) ) ) ) ) ) ).

% card_Un_disjoint
thf(fact_6330_sum__Un__nat,axiom,
    ! [A: $tType,A3: set @ A,B3: set @ A,F2: A > nat] :
      ( ( finite_finite @ A @ A3 )
     => ( ( finite_finite @ A @ B3 )
       => ( ( groups7311177749621191930dd_sum @ A @ nat @ F2 @ ( sup_sup @ ( set @ A ) @ A3 @ B3 ) )
          = ( minus_minus @ nat @ ( plus_plus @ nat @ ( groups7311177749621191930dd_sum @ A @ nat @ F2 @ A3 ) @ ( groups7311177749621191930dd_sum @ A @ nat @ F2 @ B3 ) ) @ ( groups7311177749621191930dd_sum @ A @ nat @ F2 @ ( inf_inf @ ( set @ A ) @ A3 @ B3 ) ) ) ) ) ) ).

% sum_Un_nat
thf(fact_6331_prod__Un,axiom,
    ! [A: $tType,B: $tType] :
      ( ( field @ A )
     => ! [A3: set @ B,B3: set @ B,F2: B > A] :
          ( ( finite_finite @ B @ A3 )
         => ( ( finite_finite @ B @ B3 )
           => ( ! [X3: B] :
                  ( ( member @ B @ X3 @ ( inf_inf @ ( set @ B ) @ A3 @ B3 ) )
                 => ( ( F2 @ X3 )
                   != ( zero_zero @ A ) ) )
             => ( ( groups7121269368397514597t_prod @ B @ A @ F2 @ ( sup_sup @ ( set @ B ) @ A3 @ B3 ) )
                = ( divide_divide @ A @ ( times_times @ A @ ( groups7121269368397514597t_prod @ B @ A @ F2 @ A3 ) @ ( groups7121269368397514597t_prod @ B @ A @ F2 @ B3 ) ) @ ( groups7121269368397514597t_prod @ B @ A @ F2 @ ( inf_inf @ ( set @ B ) @ A3 @ B3 ) ) ) ) ) ) ) ) ).

% prod_Un
thf(fact_6332_these__empty__eq,axiom,
    ! [A: $tType,B3: set @ ( option @ A )] :
      ( ( ( these @ A @ B3 )
        = ( bot_bot @ ( set @ A ) ) )
      = ( ( B3
          = ( bot_bot @ ( set @ ( option @ A ) ) ) )
        | ( B3
          = ( insert @ ( option @ A ) @ ( none @ A ) @ ( bot_bot @ ( set @ ( option @ A ) ) ) ) ) ) ) ).

% these_empty_eq
thf(fact_6333_these__not__empty__eq,axiom,
    ! [A: $tType,B3: set @ ( option @ A )] :
      ( ( ( ( these @ A @ B3 )
         != ( bot_bot @ ( set @ A ) ) ) )
      = ( ( B3
         != ( bot_bot @ ( set @ ( option @ A ) ) ) )
        & ( B3
         != ( insert @ ( option @ A ) @ ( none @ A ) @ ( bot_bot @ ( set @ ( option @ A ) ) ) ) ) ) ) ).

% these_not_empty_eq
thf(fact_6334_Some__image__these__eq,axiom,
    ! [A: $tType,A3: set @ ( option @ A )] :
      ( ( image @ A @ ( option @ A ) @ ( some @ A ) @ ( these @ A @ A3 ) )
      = ( collect @ ( option @ A )
        @ ^ [X5: option @ A] :
            ( ( member @ ( option @ A ) @ X5 @ A3 )
            & ( X5
             != ( none @ A ) ) ) ) ) ).

% Some_image_these_eq
thf(fact_6335_UN__le__eq__Un0,axiom,
    ! [A: $tType,M7: nat > ( set @ A ),N2: nat] :
      ( ( complete_Sup_Sup @ ( set @ A ) @ ( image @ nat @ ( set @ A ) @ M7 @ ( set_ord_atMost @ nat @ N2 ) ) )
      = ( sup_sup @ ( set @ A ) @ ( complete_Sup_Sup @ ( set @ A ) @ ( image @ nat @ ( set @ A ) @ M7 @ ( set_or1337092689740270186AtMost @ nat @ ( one_one @ nat ) @ N2 ) ) ) @ ( M7 @ ( zero_zero @ nat ) ) ) ) ).

% UN_le_eq_Un0
thf(fact_6336_shuffles_Oelims,axiom,
    ! [A: $tType,X2: list @ A,Xa2: list @ A,Y2: set @ ( list @ A )] :
      ( ( ( shuffles @ A @ X2 @ Xa2 )
        = Y2 )
     => ( ( ( X2
            = ( nil @ A ) )
         => ( Y2
           != ( insert @ ( list @ A ) @ Xa2 @ ( bot_bot @ ( set @ ( list @ A ) ) ) ) ) )
       => ( ( ( Xa2
              = ( nil @ A ) )
           => ( Y2
             != ( insert @ ( list @ A ) @ X2 @ ( bot_bot @ ( set @ ( list @ A ) ) ) ) ) )
         => ~ ! [X3: A,Xs2: list @ A] :
                ( ( X2
                  = ( cons @ A @ X3 @ Xs2 ) )
               => ! [Y4: A,Ys4: list @ A] :
                    ( ( Xa2
                      = ( cons @ A @ Y4 @ Ys4 ) )
                   => ( Y2
                     != ( sup_sup @ ( set @ ( list @ A ) ) @ ( image @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X3 ) @ ( shuffles @ A @ Xs2 @ ( cons @ A @ Y4 @ Ys4 ) ) ) @ ( image @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ Y4 ) @ ( shuffles @ A @ ( cons @ A @ X3 @ Xs2 ) @ Ys4 ) ) ) ) ) ) ) ) ) ).

% shuffles.elims
thf(fact_6337_shuffles_Opsimps_I3_J,axiom,
    ! [A: $tType,X2: A,Xs: list @ A,Y2: A,Ys: list @ A] :
      ( ( accp @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( shuffles_rel @ A ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X2 @ Xs ) @ ( cons @ A @ Y2 @ Ys ) ) )
     => ( ( shuffles @ A @ ( cons @ A @ X2 @ Xs ) @ ( cons @ A @ Y2 @ Ys ) )
        = ( sup_sup @ ( set @ ( list @ A ) ) @ ( image @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X2 ) @ ( shuffles @ A @ Xs @ ( cons @ A @ Y2 @ Ys ) ) ) @ ( image @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ Y2 ) @ ( shuffles @ A @ ( cons @ A @ X2 @ Xs ) @ Ys ) ) ) ) ) ).

% shuffles.psimps(3)
thf(fact_6338_upto__aux__rec,axiom,
    ( upto_aux
    = ( ^ [I4: int,J3: int,Js: list @ int] : ( if @ ( list @ int ) @ ( ord_less @ int @ J3 @ I4 ) @ Js @ ( upto_aux @ I4 @ ( minus_minus @ int @ J3 @ ( one_one @ int ) ) @ ( cons @ int @ J3 @ Js ) ) ) ) ) ).

% upto_aux_rec
thf(fact_6339_splice_Opinduct,axiom,
    ! [A: $tType,A0: list @ A,A1: list @ A,P: ( list @ A ) > ( list @ A ) > $o] :
      ( ( accp @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( splice_rel @ A ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ A0 @ A1 ) )
     => ( ! [Ys4: list @ A] :
            ( ( accp @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( splice_rel @ A ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( nil @ A ) @ Ys4 ) )
           => ( P @ ( nil @ A ) @ Ys4 ) )
       => ( ! [X3: A,Xs2: list @ A,Ys4: list @ A] :
              ( ( accp @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( splice_rel @ A ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X3 @ Xs2 ) @ Ys4 ) )
             => ( ( P @ Ys4 @ Xs2 )
               => ( P @ ( cons @ A @ X3 @ Xs2 ) @ Ys4 ) ) )
         => ( P @ A0 @ A1 ) ) ) ) ).

% splice.pinduct
thf(fact_6340_sup__Un__eq2,axiom,
    ! [B: $tType,A: $tType,R: set @ ( product_prod @ A @ B ),S3: set @ ( product_prod @ A @ B )] :
      ( ( sup_sup @ ( A > B > $o )
        @ ^ [X5: A,Y5: B] : ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X5 @ Y5 ) @ R )
        @ ^ [X5: A,Y5: B] : ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X5 @ Y5 ) @ S3 ) )
      = ( ^ [X5: A,Y5: B] : ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X5 @ Y5 ) @ ( sup_sup @ ( set @ ( product_prod @ A @ B ) ) @ R @ S3 ) ) ) ) ).

% sup_Un_eq2
thf(fact_6341_sup__nat__def,axiom,
    ( ( sup_sup @ nat )
    = ( ord_max @ nat ) ) ).

% sup_nat_def
thf(fact_6342_atLeastLessThan__add__Un,axiom,
    ! [I3: nat,J: nat,K: nat] :
      ( ( ord_less_eq @ nat @ I3 @ J )
     => ( ( set_or7035219750837199246ssThan @ nat @ I3 @ ( plus_plus @ nat @ J @ K ) )
        = ( sup_sup @ ( set @ nat ) @ ( set_or7035219750837199246ssThan @ nat @ I3 @ J ) @ ( set_or7035219750837199246ssThan @ nat @ J @ ( plus_plus @ nat @ J @ K ) ) ) ) ) ).

% atLeastLessThan_add_Un
thf(fact_6343_Pow__set_I2_J,axiom,
    ! [B: $tType,X2: B,Xs: list @ B] :
      ( ( pow2 @ B @ ( set2 @ B @ ( cons @ B @ X2 @ Xs ) ) )
      = ( sup_sup @ ( set @ ( set @ B ) ) @ ( pow2 @ B @ ( set2 @ B @ Xs ) ) @ ( image @ ( set @ B ) @ ( set @ B ) @ ( insert @ B @ X2 ) @ ( pow2 @ B @ ( set2 @ B @ Xs ) ) ) ) ) ).

% Pow_set(2)
thf(fact_6344_upto_Opelims,axiom,
    ! [X2: int,Xa2: int,Y2: list @ int] :
      ( ( ( upto @ X2 @ Xa2 )
        = Y2 )
     => ( ( accp @ ( product_prod @ int @ int ) @ upto_rel @ ( product_Pair @ int @ int @ X2 @ Xa2 ) )
       => ~ ( ( ( ( ord_less_eq @ int @ X2 @ Xa2 )
               => ( Y2
                  = ( cons @ int @ X2 @ ( upto @ ( plus_plus @ int @ X2 @ ( one_one @ int ) ) @ Xa2 ) ) ) )
              & ( ~ ( ord_less_eq @ int @ X2 @ Xa2 )
               => ( Y2
                  = ( nil @ int ) ) ) )
           => ~ ( accp @ ( product_prod @ int @ int ) @ upto_rel @ ( product_Pair @ int @ int @ X2 @ Xa2 ) ) ) ) ) ).

% upto.pelims
thf(fact_6345_upto_Opsimps,axiom,
    ! [I3: int,J: int] :
      ( ( accp @ ( product_prod @ int @ int ) @ upto_rel @ ( product_Pair @ int @ int @ I3 @ J ) )
     => ( ( ( ord_less_eq @ int @ I3 @ J )
         => ( ( upto @ I3 @ J )
            = ( cons @ int @ I3 @ ( upto @ ( plus_plus @ int @ I3 @ ( one_one @ int ) ) @ J ) ) ) )
        & ( ~ ( ord_less_eq @ int @ I3 @ J )
         => ( ( upto @ I3 @ J )
            = ( nil @ int ) ) ) ) ) ).

% upto.psimps
thf(fact_6346_upto__empty,axiom,
    ! [J: int,I3: int] :
      ( ( ord_less @ int @ J @ I3 )
     => ( ( upto @ I3 @ J )
        = ( nil @ int ) ) ) ).

% upto_empty
thf(fact_6347_upto__Nil2,axiom,
    ! [I3: int,J: int] :
      ( ( ( nil @ int )
        = ( upto @ I3 @ J ) )
      = ( ord_less @ int @ J @ I3 ) ) ).

% upto_Nil2
thf(fact_6348_upto__Nil,axiom,
    ! [I3: int,J: int] :
      ( ( ( upto @ I3 @ J )
        = ( nil @ int ) )
      = ( ord_less @ int @ J @ I3 ) ) ).

% upto_Nil
thf(fact_6349_upto__single,axiom,
    ! [I3: int] :
      ( ( upto @ I3 @ I3 )
      = ( cons @ int @ I3 @ ( nil @ int ) ) ) ).

% upto_single
thf(fact_6350_nth__upto,axiom,
    ! [I3: int,K: nat,J: int] :
      ( ( ord_less_eq @ int @ ( plus_plus @ int @ I3 @ ( semiring_1_of_nat @ int @ K ) ) @ J )
     => ( ( nth @ int @ ( upto @ I3 @ J ) @ K )
        = ( plus_plus @ int @ I3 @ ( semiring_1_of_nat @ int @ K ) ) ) ) ).

% nth_upto
thf(fact_6351_length__upto,axiom,
    ! [I3: int,J: int] :
      ( ( size_size @ ( list @ int ) @ ( upto @ I3 @ J ) )
      = ( nat2 @ ( plus_plus @ int @ ( minus_minus @ int @ J @ I3 ) @ ( one_one @ int ) ) ) ) ).

% length_upto
thf(fact_6352_upto__rec__numeral_I1_J,axiom,
    ! [M: num,N2: num] :
      ( ( ( ord_less_eq @ int @ ( numeral_numeral @ int @ M ) @ ( numeral_numeral @ int @ N2 ) )
       => ( ( upto @ ( numeral_numeral @ int @ M ) @ ( numeral_numeral @ int @ N2 ) )
          = ( cons @ int @ ( numeral_numeral @ int @ M ) @ ( upto @ ( plus_plus @ int @ ( numeral_numeral @ int @ M ) @ ( one_one @ int ) ) @ ( numeral_numeral @ int @ N2 ) ) ) ) )
      & ( ~ ( ord_less_eq @ int @ ( numeral_numeral @ int @ M ) @ ( numeral_numeral @ int @ N2 ) )
       => ( ( upto @ ( numeral_numeral @ int @ M ) @ ( numeral_numeral @ int @ N2 ) )
          = ( nil @ int ) ) ) ) ).

% upto_rec_numeral(1)
thf(fact_6353_upto__rec__numeral_I4_J,axiom,
    ! [M: num,N2: num] :
      ( ( ( ord_less_eq @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ M ) ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N2 ) ) )
       => ( ( upto @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ M ) ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N2 ) ) )
          = ( cons @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ M ) ) @ ( upto @ ( plus_plus @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ M ) ) @ ( one_one @ int ) ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N2 ) ) ) ) ) )
      & ( ~ ( ord_less_eq @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ M ) ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N2 ) ) )
       => ( ( upto @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ M ) ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N2 ) ) )
          = ( nil @ int ) ) ) ) ).

% upto_rec_numeral(4)
thf(fact_6354_upto__rec__numeral_I3_J,axiom,
    ! [M: num,N2: num] :
      ( ( ( ord_less_eq @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ M ) ) @ ( numeral_numeral @ int @ N2 ) )
       => ( ( upto @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ M ) ) @ ( numeral_numeral @ int @ N2 ) )
          = ( cons @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ M ) ) @ ( upto @ ( plus_plus @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ M ) ) @ ( one_one @ int ) ) @ ( numeral_numeral @ int @ N2 ) ) ) ) )
      & ( ~ ( ord_less_eq @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ M ) ) @ ( numeral_numeral @ int @ N2 ) )
       => ( ( upto @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ M ) ) @ ( numeral_numeral @ int @ N2 ) )
          = ( nil @ int ) ) ) ) ).

% upto_rec_numeral(3)
thf(fact_6355_upto__rec__numeral_I2_J,axiom,
    ! [M: num,N2: num] :
      ( ( ( ord_less_eq @ int @ ( numeral_numeral @ int @ M ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N2 ) ) )
       => ( ( upto @ ( numeral_numeral @ int @ M ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N2 ) ) )
          = ( cons @ int @ ( numeral_numeral @ int @ M ) @ ( upto @ ( plus_plus @ int @ ( numeral_numeral @ int @ M ) @ ( one_one @ int ) ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N2 ) ) ) ) ) )
      & ( ~ ( ord_less_eq @ int @ ( numeral_numeral @ int @ M ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N2 ) ) )
       => ( ( upto @ ( numeral_numeral @ int @ M ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N2 ) ) )
          = ( nil @ int ) ) ) ) ).

% upto_rec_numeral(2)
thf(fact_6356_upto__aux__def,axiom,
    ( upto_aux
    = ( ^ [I4: int,J3: int] : ( append @ int @ ( upto @ I4 @ J3 ) ) ) ) ).

% upto_aux_def
thf(fact_6357_upto__code,axiom,
    ( upto
    = ( ^ [I4: int,J3: int] : ( upto_aux @ I4 @ J3 @ ( nil @ int ) ) ) ) ).

% upto_code
thf(fact_6358_distinct__upto,axiom,
    ! [I3: int,J: int] : ( distinct @ int @ ( upto @ I3 @ J ) ) ).

% distinct_upto
thf(fact_6359_atLeastAtMost__upto,axiom,
    ( ( set_or1337092689740270186AtMost @ int )
    = ( ^ [I4: int,J3: int] : ( set2 @ int @ ( upto @ I4 @ J3 ) ) ) ) ).

% atLeastAtMost_upto
thf(fact_6360_upto__split2,axiom,
    ! [I3: int,J: int,K: int] :
      ( ( ord_less_eq @ int @ I3 @ J )
     => ( ( ord_less_eq @ int @ J @ K )
       => ( ( upto @ I3 @ K )
          = ( append @ int @ ( upto @ I3 @ J ) @ ( upto @ ( plus_plus @ int @ J @ ( one_one @ int ) ) @ K ) ) ) ) ) ).

% upto_split2
thf(fact_6361_upto__split1,axiom,
    ! [I3: int,J: int,K: int] :
      ( ( ord_less_eq @ int @ I3 @ J )
     => ( ( ord_less_eq @ int @ J @ K )
       => ( ( upto @ I3 @ K )
          = ( append @ int @ ( upto @ I3 @ ( minus_minus @ int @ J @ ( one_one @ int ) ) ) @ ( upto @ J @ K ) ) ) ) ) ).

% upto_split1
thf(fact_6362_atLeastLessThan__upto,axiom,
    ( ( set_or7035219750837199246ssThan @ int )
    = ( ^ [I4: int,J3: int] : ( set2 @ int @ ( upto @ I4 @ ( minus_minus @ int @ J3 @ ( one_one @ int ) ) ) ) ) ) ).

% atLeastLessThan_upto
thf(fact_6363_upto__rec1,axiom,
    ! [I3: int,J: int] :
      ( ( ord_less_eq @ int @ I3 @ J )
     => ( ( upto @ I3 @ J )
        = ( cons @ int @ I3 @ ( upto @ ( plus_plus @ int @ I3 @ ( one_one @ int ) ) @ J ) ) ) ) ).

% upto_rec1
thf(fact_6364_upto_Oelims,axiom,
    ! [X2: int,Xa2: int,Y2: list @ int] :
      ( ( ( upto @ X2 @ Xa2 )
        = Y2 )
     => ( ( ( ord_less_eq @ int @ X2 @ Xa2 )
         => ( Y2
            = ( cons @ int @ X2 @ ( upto @ ( plus_plus @ int @ X2 @ ( one_one @ int ) ) @ Xa2 ) ) ) )
        & ( ~ ( ord_less_eq @ int @ X2 @ Xa2 )
         => ( Y2
            = ( nil @ int ) ) ) ) ) ).

% upto.elims
thf(fact_6365_upto_Osimps,axiom,
    ( upto
    = ( ^ [I4: int,J3: int] : ( if @ ( list @ int ) @ ( ord_less_eq @ int @ I4 @ J3 ) @ ( cons @ int @ I4 @ ( upto @ ( plus_plus @ int @ I4 @ ( one_one @ int ) ) @ J3 ) ) @ ( nil @ int ) ) ) ) ).

% upto.simps
thf(fact_6366_upto__rec2,axiom,
    ! [I3: int,J: int] :
      ( ( ord_less_eq @ int @ I3 @ J )
     => ( ( upto @ I3 @ J )
        = ( append @ int @ ( upto @ I3 @ ( minus_minus @ int @ J @ ( one_one @ int ) ) ) @ ( cons @ int @ J @ ( nil @ int ) ) ) ) ) ).

% upto_rec2
thf(fact_6367_upto__split3,axiom,
    ! [I3: int,J: int,K: int] :
      ( ( ord_less_eq @ int @ I3 @ J )
     => ( ( ord_less_eq @ int @ J @ K )
       => ( ( upto @ I3 @ K )
          = ( append @ int @ ( upto @ I3 @ ( minus_minus @ int @ J @ ( one_one @ int ) ) ) @ ( cons @ int @ J @ ( upto @ ( plus_plus @ int @ J @ ( one_one @ int ) ) @ K ) ) ) ) ) ) ).

% upto_split3
thf(fact_6368_splice_Opelims,axiom,
    ! [A: $tType,X2: list @ A,Xa2: list @ A,Y2: list @ A] :
      ( ( ( splice @ A @ X2 @ Xa2 )
        = Y2 )
     => ( ( accp @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( splice_rel @ A ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ X2 @ Xa2 ) )
       => ( ( ( X2
              = ( nil @ A ) )
           => ( ( Y2 = Xa2 )
             => ~ ( accp @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( splice_rel @ A ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( nil @ A ) @ Xa2 ) ) ) )
         => ~ ! [X3: A,Xs2: list @ A] :
                ( ( X2
                  = ( cons @ A @ X3 @ Xs2 ) )
               => ( ( Y2
                    = ( cons @ A @ X3 @ ( splice @ A @ Xa2 @ Xs2 ) ) )
                 => ~ ( accp @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( splice_rel @ A ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X3 @ Xs2 ) @ Xa2 ) ) ) ) ) ) ) ).

% splice.pelims
thf(fact_6369_extract__Some__iff,axiom,
    ! [A: $tType,P: A > $o,Xs: list @ A,Ys: list @ A,Y2: A,Zs: list @ A] :
      ( ( ( extract @ A @ P @ Xs )
        = ( some @ ( product_prod @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) ) @ ( product_Pair @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) @ Ys @ ( product_Pair @ A @ ( list @ A ) @ Y2 @ Zs ) ) ) )
      = ( ( Xs
          = ( append @ A @ Ys @ ( cons @ A @ Y2 @ Zs ) ) )
        & ( P @ Y2 )
        & ~ ? [X5: A] :
              ( ( member @ A @ X5 @ ( set2 @ A @ Ys ) )
              & ( P @ X5 ) ) ) ) ).

% extract_Some_iff
thf(fact_6370_splice__Nil2,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( splice @ A @ Xs @ ( nil @ A ) )
      = Xs ) ).

% splice_Nil2
thf(fact_6371_split__Nil__iff,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A] :
      ( ( ( splice @ A @ Xs @ Ys )
        = ( nil @ A ) )
      = ( ( Xs
          = ( nil @ A ) )
        & ( Ys
          = ( nil @ A ) ) ) ) ).

% split_Nil_iff
thf(fact_6372_splice__in__shuffles,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A] : ( member @ ( list @ A ) @ ( splice @ A @ Xs @ Ys ) @ ( shuffles @ A @ Xs @ Ys ) ) ).

% splice_in_shuffles
thf(fact_6373_length__splice,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A] :
      ( ( size_size @ ( list @ A ) @ ( splice @ A @ Xs @ Ys ) )
      = ( plus_plus @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ ( size_size @ ( list @ A ) @ Ys ) ) ) ).

% length_splice
thf(fact_6374_splice__replicate,axiom,
    ! [A: $tType,M: nat,X2: A,N2: nat] :
      ( ( splice @ A @ ( replicate @ A @ M @ X2 ) @ ( replicate @ A @ N2 @ X2 ) )
      = ( replicate @ A @ ( plus_plus @ nat @ M @ N2 ) @ X2 ) ) ).

% splice_replicate
thf(fact_6375_extract__Nil__code,axiom,
    ! [A: $tType,P: A > $o] :
      ( ( extract @ A @ P @ ( nil @ A ) )
      = ( none @ ( product_prod @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) ) ) ) ).

% extract_Nil_code
thf(fact_6376_splice_Osimps_I1_J,axiom,
    ! [A: $tType,Ys: list @ A] :
      ( ( splice @ A @ ( nil @ A ) @ Ys )
      = Ys ) ).

% splice.simps(1)
thf(fact_6377_extract__None__iff,axiom,
    ! [A: $tType,P: A > $o,Xs: list @ A] :
      ( ( ( extract @ A @ P @ Xs )
        = ( none @ ( product_prod @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) ) ) )
      = ( ~ ? [X5: A] :
              ( ( member @ A @ X5 @ ( set2 @ A @ Xs ) )
              & ( P @ X5 ) ) ) ) ).

% extract_None_iff
thf(fact_6378_splice_Osimps_I2_J,axiom,
    ! [A: $tType,X2: A,Xs: list @ A,Ys: list @ A] :
      ( ( splice @ A @ ( cons @ A @ X2 @ Xs ) @ Ys )
      = ( cons @ A @ X2 @ ( splice @ A @ Ys @ Xs ) ) ) ).

% splice.simps(2)
thf(fact_6379_splice_Oelims,axiom,
    ! [A: $tType,X2: list @ A,Xa2: list @ A,Y2: list @ A] :
      ( ( ( splice @ A @ X2 @ Xa2 )
        = Y2 )
     => ( ( ( X2
            = ( nil @ A ) )
         => ( Y2 != Xa2 ) )
       => ~ ! [X3: A,Xs2: list @ A] :
              ( ( X2
                = ( cons @ A @ X3 @ Xs2 ) )
             => ( Y2
               != ( cons @ A @ X3 @ ( splice @ A @ Xa2 @ Xs2 ) ) ) ) ) ) ).

% splice.elims
thf(fact_6380_splice_Opsimps_I2_J,axiom,
    ! [A: $tType,X2: A,Xs: list @ A,Ys: list @ A] :
      ( ( accp @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( splice_rel @ A ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X2 @ Xs ) @ Ys ) )
     => ( ( splice @ A @ ( cons @ A @ X2 @ Xs ) @ Ys )
        = ( cons @ A @ X2 @ ( splice @ A @ Ys @ Xs ) ) ) ) ).

% splice.psimps(2)
thf(fact_6381_splice_Opsimps_I1_J,axiom,
    ! [A: $tType,Ys: list @ A] :
      ( ( accp @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( splice_rel @ A ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( nil @ A ) @ Ys ) )
     => ( ( splice @ A @ ( nil @ A ) @ Ys )
        = Ys ) ) ).

% splice.psimps(1)
thf(fact_6382_extract__SomeE,axiom,
    ! [A: $tType,P: A > $o,Xs: list @ A,Ys: list @ A,Y2: A,Zs: list @ A] :
      ( ( ( extract @ A @ P @ Xs )
        = ( some @ ( product_prod @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) ) @ ( product_Pair @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) @ Ys @ ( product_Pair @ A @ ( list @ A ) @ Y2 @ Zs ) ) ) )
     => ( ( Xs
          = ( append @ A @ Ys @ ( cons @ A @ Y2 @ Zs ) ) )
        & ( P @ Y2 )
        & ~ ? [X: A] :
              ( ( member @ A @ X @ ( set2 @ A @ Ys ) )
              & ( P @ X ) ) ) ) ).

% extract_SomeE
thf(fact_6383_extract__Cons__code,axiom,
    ! [A: $tType,P: A > $o,X2: A,Xs: list @ A] :
      ( ( ( P @ X2 )
       => ( ( extract @ A @ P @ ( cons @ A @ X2 @ Xs ) )
          = ( some @ ( product_prod @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) ) @ ( product_Pair @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) @ ( nil @ A ) @ ( product_Pair @ A @ ( list @ A ) @ X2 @ Xs ) ) ) ) )
      & ( ~ ( P @ X2 )
       => ( ( extract @ A @ P @ ( cons @ A @ X2 @ Xs ) )
          = ( case_option @ ( option @ ( product_prod @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) ) ) @ ( product_prod @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) ) @ ( none @ ( product_prod @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) ) )
            @ ( product_case_prod @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) @ ( option @ ( product_prod @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) ) )
              @ ^ [Ys3: list @ A] :
                  ( product_case_prod @ A @ ( list @ A ) @ ( option @ ( product_prod @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) ) )
                  @ ^ [Y5: A,Zs3: list @ A] : ( some @ ( product_prod @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) ) @ ( product_Pair @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) @ ( cons @ A @ X2 @ Ys3 ) @ ( product_Pair @ A @ ( list @ A ) @ Y5 @ Zs3 ) ) ) ) )
            @ ( extract @ A @ P @ Xs ) ) ) ) ) ).

% extract_Cons_code
thf(fact_6384_DERIV__real__root__generic,axiom,
    ! [N2: nat,X2: real,D5: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( X2
         != ( zero_zero @ real ) )
       => ( ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 )
           => ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
             => ( D5
                = ( inverse_inverse @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N2 ) @ ( power_power @ real @ ( root @ N2 @ X2 ) @ ( minus_minus @ nat @ N2 @ ( suc @ ( zero_zero @ nat ) ) ) ) ) ) ) ) )
         => ( ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 )
             => ( ( ord_less @ real @ X2 @ ( zero_zero @ real ) )
               => ( D5
                  = ( uminus_uminus @ real @ ( inverse_inverse @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N2 ) @ ( power_power @ real @ ( root @ N2 @ X2 ) @ ( minus_minus @ nat @ N2 @ ( suc @ ( zero_zero @ nat ) ) ) ) ) ) ) ) ) )
           => ( ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 )
               => ( D5
                  = ( inverse_inverse @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N2 ) @ ( power_power @ real @ ( root @ N2 @ X2 ) @ ( minus_minus @ nat @ N2 @ ( suc @ ( zero_zero @ nat ) ) ) ) ) ) ) )
             => ( has_field_derivative @ real @ ( root @ N2 ) @ D5 @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) ) ) ) ) ) ) ).

% DERIV_real_root_generic
thf(fact_6385_option_Osimps_I5_J,axiom,
    ! [B: $tType,A: $tType,F1: B,F22: A > B,X22: A] :
      ( ( case_option @ B @ A @ F1 @ F22 @ ( some @ A @ X22 ) )
      = ( F22 @ X22 ) ) ).

% option.simps(5)
thf(fact_6386_DERIV__ln,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
     => ( has_field_derivative @ real @ ( ln_ln @ real ) @ ( inverse_inverse @ real @ X2 ) @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) ) ) ).

% DERIV_ln
thf(fact_6387_DERIV__fun__cos,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [G: A > A,M: A,X2: A] :
          ( ( has_field_derivative @ A @ G @ M @ ( topolo174197925503356063within @ A @ X2 @ ( top_top @ ( set @ A ) ) ) )
         => ( has_field_derivative @ A
            @ ^ [X5: A] : ( cos @ A @ ( G @ X5 ) )
            @ ( times_times @ A @ ( uminus_uminus @ A @ ( sin @ A @ ( G @ X2 ) ) ) @ M )
            @ ( topolo174197925503356063within @ A @ X2 @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% DERIV_fun_cos
thf(fact_6388_DERIV__cos__add,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [K: A,Xa2: A] :
          ( has_field_derivative @ A
          @ ^ [X5: A] : ( cos @ A @ ( plus_plus @ A @ X5 @ K ) )
          @ ( uminus_uminus @ A @ ( sin @ A @ ( plus_plus @ A @ Xa2 @ K ) ) )
          @ ( topolo174197925503356063within @ A @ Xa2 @ ( top_top @ ( set @ A ) ) ) ) ) ).

% DERIV_cos_add
thf(fact_6389_deriv__nonneg__imp__mono,axiom,
    ! [A2: real,B2: real,G: real > real,G6: real > real] :
      ( ! [X3: real] :
          ( ( member @ real @ X3 @ ( set_or1337092689740270186AtMost @ real @ A2 @ B2 ) )
         => ( has_field_derivative @ real @ G @ ( G6 @ X3 ) @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) ) )
     => ( ! [X3: real] :
            ( ( member @ real @ X3 @ ( set_or1337092689740270186AtMost @ real @ A2 @ B2 ) )
           => ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( G6 @ X3 ) ) )
       => ( ( ord_less_eq @ real @ A2 @ B2 )
         => ( ord_less_eq @ real @ ( G @ A2 ) @ ( G @ B2 ) ) ) ) ) ).

% deriv_nonneg_imp_mono
thf(fact_6390_DERIV__nonneg__imp__nondecreasing,axiom,
    ! [A2: real,B2: real,F2: real > real] :
      ( ( ord_less_eq @ real @ A2 @ B2 )
     => ( ! [X3: real] :
            ( ( ord_less_eq @ real @ A2 @ X3 )
           => ( ( ord_less_eq @ real @ X3 @ B2 )
             => ? [Y: real] :
                  ( ( has_field_derivative @ real @ F2 @ Y @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) )
                  & ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y ) ) ) )
       => ( ord_less_eq @ real @ ( F2 @ A2 ) @ ( F2 @ B2 ) ) ) ) ).

% DERIV_nonneg_imp_nondecreasing
thf(fact_6391_DERIV__nonpos__imp__nonincreasing,axiom,
    ! [A2: real,B2: real,F2: real > real] :
      ( ( ord_less_eq @ real @ A2 @ B2 )
     => ( ! [X3: real] :
            ( ( ord_less_eq @ real @ A2 @ X3 )
           => ( ( ord_less_eq @ real @ X3 @ B2 )
             => ? [Y: real] :
                  ( ( has_field_derivative @ real @ F2 @ Y @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) )
                  & ( ord_less_eq @ real @ Y @ ( zero_zero @ real ) ) ) ) )
       => ( ord_less_eq @ real @ ( F2 @ B2 ) @ ( F2 @ A2 ) ) ) ) ).

% DERIV_nonpos_imp_nonincreasing
thf(fact_6392_DERIV__subset,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,F8: A,X2: A,S2: set @ A,T2: set @ A] :
          ( ( has_field_derivative @ A @ F2 @ F8 @ ( topolo174197925503356063within @ A @ X2 @ S2 ) )
         => ( ( ord_less_eq @ ( set @ A ) @ T2 @ S2 )
           => ( has_field_derivative @ A @ F2 @ F8 @ ( topolo174197925503356063within @ A @ X2 @ T2 ) ) ) ) ) ).

% DERIV_subset
thf(fact_6393_has__field__derivative__subset,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,Y2: A,X2: A,S2: set @ A,T2: set @ A] :
          ( ( has_field_derivative @ A @ F2 @ Y2 @ ( topolo174197925503356063within @ A @ X2 @ S2 ) )
         => ( ( ord_less_eq @ ( set @ A ) @ T2 @ S2 )
           => ( has_field_derivative @ A @ F2 @ Y2 @ ( topolo174197925503356063within @ A @ X2 @ T2 ) ) ) ) ) ).

% has_field_derivative_subset
thf(fact_6394_at__le,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [S2: set @ A,T2: set @ A,X2: A] :
          ( ( ord_less_eq @ ( set @ A ) @ S2 @ T2 )
         => ( ord_less_eq @ ( filter @ A ) @ ( topolo174197925503356063within @ A @ X2 @ S2 ) @ ( topolo174197925503356063within @ A @ X2 @ T2 ) ) ) ) ).

% at_le
thf(fact_6395_DERIV__pos__imp__increasing,axiom,
    ! [A2: real,B2: real,F2: real > real] :
      ( ( ord_less @ real @ A2 @ B2 )
     => ( ! [X3: real] :
            ( ( ord_less_eq @ real @ A2 @ X3 )
           => ( ( ord_less_eq @ real @ X3 @ B2 )
             => ? [Y: real] :
                  ( ( has_field_derivative @ real @ F2 @ Y @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) )
                  & ( ord_less @ real @ ( zero_zero @ real ) @ Y ) ) ) )
       => ( ord_less @ real @ ( F2 @ A2 ) @ ( F2 @ B2 ) ) ) ) ).

% DERIV_pos_imp_increasing
thf(fact_6396_DERIV__neg__imp__decreasing,axiom,
    ! [A2: real,B2: real,F2: real > real] :
      ( ( ord_less @ real @ A2 @ B2 )
     => ( ! [X3: real] :
            ( ( ord_less_eq @ real @ A2 @ X3 )
           => ( ( ord_less_eq @ real @ X3 @ B2 )
             => ? [Y: real] :
                  ( ( has_field_derivative @ real @ F2 @ Y @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) )
                  & ( ord_less @ real @ Y @ ( zero_zero @ real ) ) ) ) )
       => ( ord_less @ real @ ( F2 @ B2 ) @ ( F2 @ A2 ) ) ) ) ).

% DERIV_neg_imp_decreasing
thf(fact_6397_DERIV__at__within__shift,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,Y2: A,Z: A,X2: A,S3: set @ A] :
          ( ( has_field_derivative @ A @ F2 @ Y2 @ ( topolo174197925503356063within @ A @ ( plus_plus @ A @ Z @ X2 ) @ ( image @ A @ A @ ( plus_plus @ A @ Z ) @ S3 ) ) )
          = ( has_field_derivative @ A
            @ ^ [X5: A] : ( F2 @ ( plus_plus @ A @ Z @ X5 ) )
            @ Y2
            @ ( topolo174197925503356063within @ A @ X2 @ S3 ) ) ) ) ).

% DERIV_at_within_shift
thf(fact_6398_DERIV__at__within__shift__lemma,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,Y2: A,Z: A,X2: A,S3: set @ A] :
          ( ( has_field_derivative @ A @ F2 @ Y2 @ ( topolo174197925503356063within @ A @ ( plus_plus @ A @ Z @ X2 ) @ ( image @ A @ A @ ( plus_plus @ A @ Z ) @ S3 ) ) )
         => ( has_field_derivative @ A @ ( comp @ A @ A @ A @ F2 @ ( plus_plus @ A @ Z ) ) @ Y2 @ ( topolo174197925503356063within @ A @ X2 @ S3 ) ) ) ) ).

% DERIV_at_within_shift_lemma
thf(fact_6399_DERIV__image__chain,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,Da: A,G: A > A,X2: A,S2: set @ A,Db: A] :
          ( ( has_field_derivative @ A @ F2 @ Da @ ( topolo174197925503356063within @ A @ ( G @ X2 ) @ ( image @ A @ A @ G @ S2 ) ) )
         => ( ( has_field_derivative @ A @ G @ Db @ ( topolo174197925503356063within @ A @ X2 @ S2 ) )
           => ( has_field_derivative @ A @ ( comp @ A @ A @ A @ F2 @ G ) @ ( times_times @ A @ Da @ Db ) @ ( topolo174197925503356063within @ A @ X2 @ S2 ) ) ) ) ) ).

% DERIV_image_chain
thf(fact_6400_DERIV__pos__inc__left,axiom,
    ! [F2: real > real,L: real,X2: real] :
      ( ( has_field_derivative @ real @ F2 @ L @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ L )
       => ? [D4: real] :
            ( ( ord_less @ real @ ( zero_zero @ real ) @ D4 )
            & ! [H5: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ H5 )
               => ( ( ord_less @ real @ H5 @ D4 )
                 => ( ord_less @ real @ ( F2 @ ( minus_minus @ real @ X2 @ H5 ) ) @ ( F2 @ X2 ) ) ) ) ) ) ) ).

% DERIV_pos_inc_left
thf(fact_6401_DERIV__neg__dec__left,axiom,
    ! [F2: real > real,L: real,X2: real] :
      ( ( has_field_derivative @ real @ F2 @ L @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) )
     => ( ( ord_less @ real @ L @ ( zero_zero @ real ) )
       => ? [D4: real] :
            ( ( ord_less @ real @ ( zero_zero @ real ) @ D4 )
            & ! [H5: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ H5 )
               => ( ( ord_less @ real @ H5 @ D4 )
                 => ( ord_less @ real @ ( F2 @ X2 ) @ ( F2 @ ( minus_minus @ real @ X2 @ H5 ) ) ) ) ) ) ) ) ).

% DERIV_neg_dec_left
thf(fact_6402_DERIV__neg__dec__right,axiom,
    ! [F2: real > real,L: real,X2: real] :
      ( ( has_field_derivative @ real @ F2 @ L @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) )
     => ( ( ord_less @ real @ L @ ( zero_zero @ real ) )
       => ? [D4: real] :
            ( ( ord_less @ real @ ( zero_zero @ real ) @ D4 )
            & ! [H5: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ H5 )
               => ( ( ord_less @ real @ H5 @ D4 )
                 => ( ord_less @ real @ ( F2 @ ( plus_plus @ real @ X2 @ H5 ) ) @ ( F2 @ X2 ) ) ) ) ) ) ) ).

% DERIV_neg_dec_right
thf(fact_6403_DERIV__pos__inc__right,axiom,
    ! [F2: real > real,L: real,X2: real] :
      ( ( has_field_derivative @ real @ F2 @ L @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ L )
       => ? [D4: real] :
            ( ( ord_less @ real @ ( zero_zero @ real ) @ D4 )
            & ! [H5: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ H5 )
               => ( ( ord_less @ real @ H5 @ D4 )
                 => ( ord_less @ real @ ( F2 @ X2 ) @ ( F2 @ ( plus_plus @ real @ X2 @ H5 ) ) ) ) ) ) ) ) ).

% DERIV_pos_inc_right
thf(fact_6404_has__real__derivative__pos__inc__right,axiom,
    ! [F2: real > real,L: real,X2: real,S3: set @ real] :
      ( ( has_field_derivative @ real @ F2 @ L @ ( topolo174197925503356063within @ real @ X2 @ S3 ) )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ L )
       => ? [D4: real] :
            ( ( ord_less @ real @ ( zero_zero @ real ) @ D4 )
            & ! [H5: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ H5 )
               => ( ( member @ real @ ( plus_plus @ real @ X2 @ H5 ) @ S3 )
                 => ( ( ord_less @ real @ H5 @ D4 )
                   => ( ord_less @ real @ ( F2 @ X2 ) @ ( F2 @ ( plus_plus @ real @ X2 @ H5 ) ) ) ) ) ) ) ) ) ).

% has_real_derivative_pos_inc_right
thf(fact_6405_has__real__derivative__neg__dec__right,axiom,
    ! [F2: real > real,L: real,X2: real,S3: set @ real] :
      ( ( has_field_derivative @ real @ F2 @ L @ ( topolo174197925503356063within @ real @ X2 @ S3 ) )
     => ( ( ord_less @ real @ L @ ( zero_zero @ real ) )
       => ? [D4: real] :
            ( ( ord_less @ real @ ( zero_zero @ real ) @ D4 )
            & ! [H5: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ H5 )
               => ( ( member @ real @ ( plus_plus @ real @ X2 @ H5 ) @ S3 )
                 => ( ( ord_less @ real @ H5 @ D4 )
                   => ( ord_less @ real @ ( F2 @ ( plus_plus @ real @ X2 @ H5 ) ) @ ( F2 @ X2 ) ) ) ) ) ) ) ) ).

% has_real_derivative_neg_dec_right
thf(fact_6406_has__real__derivative__pos__inc__left,axiom,
    ! [F2: real > real,L: real,X2: real,S3: set @ real] :
      ( ( has_field_derivative @ real @ F2 @ L @ ( topolo174197925503356063within @ real @ X2 @ S3 ) )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ L )
       => ? [D4: real] :
            ( ( ord_less @ real @ ( zero_zero @ real ) @ D4 )
            & ! [H5: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ H5 )
               => ( ( member @ real @ ( minus_minus @ real @ X2 @ H5 ) @ S3 )
                 => ( ( ord_less @ real @ H5 @ D4 )
                   => ( ord_less @ real @ ( F2 @ ( minus_minus @ real @ X2 @ H5 ) ) @ ( F2 @ X2 ) ) ) ) ) ) ) ) ).

% has_real_derivative_pos_inc_left
thf(fact_6407_has__real__derivative__neg__dec__left,axiom,
    ! [F2: real > real,L: real,X2: real,S3: set @ real] :
      ( ( has_field_derivative @ real @ F2 @ L @ ( topolo174197925503356063within @ real @ X2 @ S3 ) )
     => ( ( ord_less @ real @ L @ ( zero_zero @ real ) )
       => ? [D4: real] :
            ( ( ord_less @ real @ ( zero_zero @ real ) @ D4 )
            & ! [H5: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ H5 )
               => ( ( member @ real @ ( minus_minus @ real @ X2 @ H5 ) @ S3 )
                 => ( ( ord_less @ real @ H5 @ D4 )
                   => ( ord_less @ real @ ( F2 @ X2 ) @ ( F2 @ ( minus_minus @ real @ X2 @ H5 ) ) ) ) ) ) ) ) ) ).

% has_real_derivative_neg_dec_left
thf(fact_6408_DERIV__divide,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,D5: A,X2: A,S2: set @ A,G: A > A,E5: A] :
          ( ( has_field_derivative @ A @ F2 @ D5 @ ( topolo174197925503356063within @ A @ X2 @ S2 ) )
         => ( ( has_field_derivative @ A @ G @ E5 @ ( topolo174197925503356063within @ A @ X2 @ S2 ) )
           => ( ( ( G @ X2 )
               != ( zero_zero @ A ) )
             => ( has_field_derivative @ A
                @ ^ [X5: A] : ( divide_divide @ A @ ( F2 @ X5 ) @ ( G @ X5 ) )
                @ ( divide_divide @ A @ ( minus_minus @ A @ ( times_times @ A @ D5 @ ( G @ X2 ) ) @ ( times_times @ A @ ( F2 @ X2 ) @ E5 ) ) @ ( times_times @ A @ ( G @ X2 ) @ ( G @ X2 ) ) )
                @ ( topolo174197925503356063within @ A @ X2 @ S2 ) ) ) ) ) ) ).

% DERIV_divide
thf(fact_6409_DERIV__mult_H,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,D5: A,X2: A,S2: set @ A,G: A > A,E5: A] :
          ( ( has_field_derivative @ A @ F2 @ D5 @ ( topolo174197925503356063within @ A @ X2 @ S2 ) )
         => ( ( has_field_derivative @ A @ G @ E5 @ ( topolo174197925503356063within @ A @ X2 @ S2 ) )
           => ( has_field_derivative @ A
              @ ^ [X5: A] : ( times_times @ A @ ( F2 @ X5 ) @ ( G @ X5 ) )
              @ ( plus_plus @ A @ ( times_times @ A @ ( F2 @ X2 ) @ E5 ) @ ( times_times @ A @ D5 @ ( G @ X2 ) ) )
              @ ( topolo174197925503356063within @ A @ X2 @ S2 ) ) ) ) ) ).

% DERIV_mult'
thf(fact_6410_DERIV__mult,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,Da: A,X2: A,S2: set @ A,G: A > A,Db: A] :
          ( ( has_field_derivative @ A @ F2 @ Da @ ( topolo174197925503356063within @ A @ X2 @ S2 ) )
         => ( ( has_field_derivative @ A @ G @ Db @ ( topolo174197925503356063within @ A @ X2 @ S2 ) )
           => ( has_field_derivative @ A
              @ ^ [X5: A] : ( times_times @ A @ ( F2 @ X5 ) @ ( G @ X5 ) )
              @ ( plus_plus @ A @ ( times_times @ A @ Da @ ( G @ X2 ) ) @ ( times_times @ A @ Db @ ( F2 @ X2 ) ) )
              @ ( topolo174197925503356063within @ A @ X2 @ S2 ) ) ) ) ) ).

% DERIV_mult
thf(fact_6411_DERIV__inverse_H,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,D5: A,X2: A,S2: set @ A] :
          ( ( has_field_derivative @ A @ F2 @ D5 @ ( topolo174197925503356063within @ A @ X2 @ S2 ) )
         => ( ( ( F2 @ X2 )
             != ( zero_zero @ A ) )
           => ( has_field_derivative @ A
              @ ^ [X5: A] : ( inverse_inverse @ A @ ( F2 @ X5 ) )
              @ ( uminus_uminus @ A @ ( times_times @ A @ ( times_times @ A @ ( inverse_inverse @ A @ ( F2 @ X2 ) ) @ D5 ) @ ( inverse_inverse @ A @ ( F2 @ X2 ) ) ) )
              @ ( topolo174197925503356063within @ A @ X2 @ S2 ) ) ) ) ) ).

% DERIV_inverse'
thf(fact_6412_DERIV__cdivide,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,D5: A,X2: A,S2: set @ A,C2: A] :
          ( ( has_field_derivative @ A @ F2 @ D5 @ ( topolo174197925503356063within @ A @ X2 @ S2 ) )
         => ( has_field_derivative @ A
            @ ^ [X5: A] : ( divide_divide @ A @ ( F2 @ X5 ) @ C2 )
            @ ( divide_divide @ A @ D5 @ C2 )
            @ ( topolo174197925503356063within @ A @ X2 @ S2 ) ) ) ) ).

% DERIV_cdivide
thf(fact_6413_DERIV__cmult,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,D5: A,X2: A,S2: set @ A,C2: A] :
          ( ( has_field_derivative @ A @ F2 @ D5 @ ( topolo174197925503356063within @ A @ X2 @ S2 ) )
         => ( has_field_derivative @ A
            @ ^ [X5: A] : ( times_times @ A @ C2 @ ( F2 @ X5 ) )
            @ ( times_times @ A @ C2 @ D5 )
            @ ( topolo174197925503356063within @ A @ X2 @ S2 ) ) ) ) ).

% DERIV_cmult
thf(fact_6414_DERIV__cmult__right,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,D5: A,X2: A,S2: set @ A,C2: A] :
          ( ( has_field_derivative @ A @ F2 @ D5 @ ( topolo174197925503356063within @ A @ X2 @ S2 ) )
         => ( has_field_derivative @ A
            @ ^ [X5: A] : ( times_times @ A @ ( F2 @ X5 ) @ C2 )
            @ ( times_times @ A @ D5 @ C2 )
            @ ( topolo174197925503356063within @ A @ X2 @ S2 ) ) ) ) ).

% DERIV_cmult_right
thf(fact_6415_has__field__derivative__sinh,axiom,
    ! [A16: $tType] :
      ( ( ( real_Vector_banach @ A16 )
        & ( real_V3459762299906320749_field @ A16 ) )
     => ! [G: A16 > A16,Db: A16,X2: A16,S2: set @ A16] :
          ( ( has_field_derivative @ A16 @ G @ Db @ ( topolo174197925503356063within @ A16 @ X2 @ S2 ) )
         => ( has_field_derivative @ A16
            @ ^ [X5: A16] : ( sinh @ A16 @ ( G @ X5 ) )
            @ ( times_times @ A16 @ ( cosh @ A16 @ ( G @ X2 ) ) @ Db )
            @ ( topolo174197925503356063within @ A16 @ X2 @ S2 ) ) ) ) ).

% has_field_derivative_sinh
thf(fact_6416_has__field__derivative__cosh,axiom,
    ! [A16: $tType] :
      ( ( ( real_Vector_banach @ A16 )
        & ( real_V3459762299906320749_field @ A16 ) )
     => ! [G: A16 > A16,Db: A16,X2: A16,S2: set @ A16] :
          ( ( has_field_derivative @ A16 @ G @ Db @ ( topolo174197925503356063within @ A16 @ X2 @ S2 ) )
         => ( has_field_derivative @ A16
            @ ^ [X5: A16] : ( cosh @ A16 @ ( G @ X5 ) )
            @ ( times_times @ A16 @ ( sinh @ A16 @ ( G @ X2 ) ) @ Db )
            @ ( topolo174197925503356063within @ A16 @ X2 @ S2 ) ) ) ) ).

% has_field_derivative_cosh
thf(fact_6417_DERIV__cmult__Id,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [C2: A,X2: A,S2: set @ A] : ( has_field_derivative @ A @ ( times_times @ A @ C2 ) @ C2 @ ( topolo174197925503356063within @ A @ X2 @ S2 ) ) ) ).

% DERIV_cmult_Id
thf(fact_6418_option_Osimps_I4_J,axiom,
    ! [A: $tType,B: $tType,F1: B,F22: A > B] :
      ( ( case_option @ B @ A @ F1 @ F22 @ ( none @ A ) )
      = F1 ) ).

% option.simps(4)
thf(fact_6419_DERIV__const,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [K: A,F3: filter @ A] :
          ( has_field_derivative @ A
          @ ^ [X5: A] : K
          @ ( zero_zero @ A )
          @ F3 ) ) ).

% DERIV_const
thf(fact_6420_DERIV__add,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,D5: A,X2: A,S2: set @ A,G: A > A,E5: A] :
          ( ( has_field_derivative @ A @ F2 @ D5 @ ( topolo174197925503356063within @ A @ X2 @ S2 ) )
         => ( ( has_field_derivative @ A @ G @ E5 @ ( topolo174197925503356063within @ A @ X2 @ S2 ) )
           => ( has_field_derivative @ A
              @ ^ [X5: A] : ( plus_plus @ A @ ( F2 @ X5 ) @ ( G @ X5 ) )
              @ ( plus_plus @ A @ D5 @ E5 )
              @ ( topolo174197925503356063within @ A @ X2 @ S2 ) ) ) ) ) ).

% DERIV_add
thf(fact_6421_field__differentiable__add,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,F8: A,F3: filter @ A,G: A > A,G6: A] :
          ( ( has_field_derivative @ A @ F2 @ F8 @ F3 )
         => ( ( has_field_derivative @ A @ G @ G6 @ F3 )
           => ( has_field_derivative @ A
              @ ^ [Z6: A] : ( plus_plus @ A @ ( F2 @ Z6 ) @ ( G @ Z6 ) )
              @ ( plus_plus @ A @ F8 @ G6 )
              @ F3 ) ) ) ) ).

% field_differentiable_add
thf(fact_6422_DERIV__ident,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F3: filter @ A] :
          ( has_field_derivative @ A
          @ ^ [X5: A] : X5
          @ ( one_one @ A )
          @ F3 ) ) ).

% DERIV_ident
thf(fact_6423_DERIV__isconst__all,axiom,
    ! [F2: real > real,X2: real,Y2: real] :
      ( ! [X3: real] : ( has_field_derivative @ real @ F2 @ ( zero_zero @ real ) @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) )
     => ( ( F2 @ X2 )
        = ( F2 @ Y2 ) ) ) ).

% DERIV_isconst_all
thf(fact_6424_DERIV__shift,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,Y2: A,X2: A,Z: A] :
          ( ( has_field_derivative @ A @ F2 @ Y2 @ ( topolo174197925503356063within @ A @ ( plus_plus @ A @ X2 @ Z ) @ ( top_top @ ( set @ A ) ) ) )
          = ( has_field_derivative @ A
            @ ^ [X5: A] : ( F2 @ ( plus_plus @ A @ X5 @ Z ) )
            @ Y2
            @ ( topolo174197925503356063within @ A @ X2 @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% DERIV_shift
thf(fact_6425_DERIV__const__ratio__const,axiom,
    ! [A2: real,B2: real,F2: real > real,K: real] :
      ( ( A2 != B2 )
     => ( ! [X3: real] : ( has_field_derivative @ real @ F2 @ K @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) )
       => ( ( minus_minus @ real @ ( F2 @ B2 ) @ ( F2 @ A2 ) )
          = ( times_times @ real @ ( minus_minus @ real @ B2 @ A2 ) @ K ) ) ) ) ).

% DERIV_const_ratio_const
thf(fact_6426_DERIV__const__ratio__const2,axiom,
    ! [A2: real,B2: real,F2: real > real,K: real] :
      ( ( A2 != B2 )
     => ( ! [X3: real] : ( has_field_derivative @ real @ F2 @ K @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) )
       => ( ( divide_divide @ real @ ( minus_minus @ real @ ( F2 @ B2 ) @ ( F2 @ A2 ) ) @ ( minus_minus @ real @ B2 @ A2 ) )
          = K ) ) ) ).

% DERIV_const_ratio_const2
thf(fact_6427_DERIV__chain__s,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [S2: set @ A,G: A > A,G6: A > A,F2: A > A,F8: A,X2: A] :
          ( ! [X3: A] :
              ( ( member @ A @ X3 @ S2 )
             => ( has_field_derivative @ A @ G @ ( G6 @ X3 ) @ ( topolo174197925503356063within @ A @ X3 @ ( top_top @ ( set @ A ) ) ) ) )
         => ( ( has_field_derivative @ A @ F2 @ F8 @ ( topolo174197925503356063within @ A @ X2 @ ( top_top @ ( set @ A ) ) ) )
           => ( ( member @ A @ ( F2 @ X2 ) @ S2 )
             => ( has_field_derivative @ A
                @ ^ [X5: A] : ( G @ ( F2 @ X5 ) )
                @ ( times_times @ A @ F8 @ ( G6 @ ( F2 @ X2 ) ) )
                @ ( topolo174197925503356063within @ A @ X2 @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ) ).

% DERIV_chain_s
thf(fact_6428_DERIV__chain3,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [G: A > A,G6: A > A,F2: A > A,F8: A,X2: A] :
          ( ! [X3: A] : ( has_field_derivative @ A @ G @ ( G6 @ X3 ) @ ( topolo174197925503356063within @ A @ X3 @ ( top_top @ ( set @ A ) ) ) )
         => ( ( has_field_derivative @ A @ F2 @ F8 @ ( topolo174197925503356063within @ A @ X2 @ ( top_top @ ( set @ A ) ) ) )
           => ( has_field_derivative @ A
              @ ^ [X5: A] : ( G @ ( F2 @ X5 ) )
              @ ( times_times @ A @ F8 @ ( G6 @ ( F2 @ X2 ) ) )
              @ ( topolo174197925503356063within @ A @ X2 @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ).

% DERIV_chain3
thf(fact_6429_DERIV__chain2,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,Da: A,G: A > A,X2: A,Db: A,S2: set @ A] :
          ( ( has_field_derivative @ A @ F2 @ Da @ ( topolo174197925503356063within @ A @ ( G @ X2 ) @ ( top_top @ ( set @ A ) ) ) )
         => ( ( has_field_derivative @ A @ G @ Db @ ( topolo174197925503356063within @ A @ X2 @ S2 ) )
           => ( has_field_derivative @ A
              @ ^ [X5: A] : ( F2 @ ( G @ X5 ) )
              @ ( times_times @ A @ Da @ Db )
              @ ( topolo174197925503356063within @ A @ X2 @ S2 ) ) ) ) ) ).

% DERIV_chain2
thf(fact_6430_DERIV__chain_H,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,D5: A,X2: A,S2: set @ A,G: A > A,E5: A] :
          ( ( has_field_derivative @ A @ F2 @ D5 @ ( topolo174197925503356063within @ A @ X2 @ S2 ) )
         => ( ( has_field_derivative @ A @ G @ E5 @ ( topolo174197925503356063within @ A @ ( F2 @ X2 ) @ ( top_top @ ( set @ A ) ) ) )
           => ( has_field_derivative @ A
              @ ^ [X5: A] : ( G @ ( F2 @ X5 ) )
              @ ( times_times @ A @ E5 @ D5 )
              @ ( topolo174197925503356063within @ A @ X2 @ S2 ) ) ) ) ) ).

% DERIV_chain'
thf(fact_6431_DERIV__fun__sin,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [G: A > A,M: A,X2: A] :
          ( ( has_field_derivative @ A @ G @ M @ ( topolo174197925503356063within @ A @ X2 @ ( top_top @ ( set @ A ) ) ) )
         => ( has_field_derivative @ A
            @ ^ [X5: A] : ( sin @ A @ ( G @ X5 ) )
            @ ( times_times @ A @ ( cos @ A @ ( G @ X2 ) ) @ M )
            @ ( topolo174197925503356063within @ A @ X2 @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% DERIV_fun_sin
thf(fact_6432_DERIV__fun__exp,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [G: A > A,M: A,X2: A] :
          ( ( has_field_derivative @ A @ G @ M @ ( topolo174197925503356063within @ A @ X2 @ ( top_top @ ( set @ A ) ) ) )
         => ( has_field_derivative @ A
            @ ^ [X5: A] : ( exp @ A @ ( G @ X5 ) )
            @ ( times_times @ A @ ( exp @ A @ ( G @ X2 ) ) @ M )
            @ ( topolo174197925503356063within @ A @ X2 @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% DERIV_fun_exp
thf(fact_6433_DERIV__chain,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,Da: A,G: A > A,X2: A,Db: A,S2: set @ A] :
          ( ( has_field_derivative @ A @ F2 @ Da @ ( topolo174197925503356063within @ A @ ( G @ X2 ) @ ( top_top @ ( set @ A ) ) ) )
         => ( ( has_field_derivative @ A @ G @ Db @ ( topolo174197925503356063within @ A @ X2 @ S2 ) )
           => ( has_field_derivative @ A @ ( comp @ A @ A @ A @ F2 @ G ) @ ( times_times @ A @ Da @ Db ) @ ( topolo174197925503356063within @ A @ X2 @ S2 ) ) ) ) ) ).

% DERIV_chain
thf(fact_6434_DERIV__local__const,axiom,
    ! [F2: real > real,L: real,X2: real,D2: real] :
      ( ( has_field_derivative @ real @ F2 @ L @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ D2 )
       => ( ! [Y4: real] :
              ( ( ord_less @ real @ ( abs_abs @ real @ ( minus_minus @ real @ X2 @ Y4 ) ) @ D2 )
             => ( ( F2 @ X2 )
                = ( F2 @ Y4 ) ) )
         => ( L
            = ( zero_zero @ real ) ) ) ) ) ).

% DERIV_local_const
thf(fact_6435_MVT2,axiom,
    ! [A2: real,B2: real,F2: real > real,F8: real > real] :
      ( ( ord_less @ real @ A2 @ B2 )
     => ( ! [X3: real] :
            ( ( ord_less_eq @ real @ A2 @ X3 )
           => ( ( ord_less_eq @ real @ X3 @ B2 )
             => ( has_field_derivative @ real @ F2 @ ( F8 @ X3 ) @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) ) ) )
       => ? [Z3: real] :
            ( ( ord_less @ real @ A2 @ Z3 )
            & ( ord_less @ real @ Z3 @ B2 )
            & ( ( minus_minus @ real @ ( F2 @ B2 ) @ ( F2 @ A2 ) )
              = ( times_times @ real @ ( minus_minus @ real @ B2 @ A2 ) @ ( F8 @ Z3 ) ) ) ) ) ) ).

% MVT2
thf(fact_6436_DERIV__power__Suc,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,D5: A,X2: A,S2: set @ A,N2: nat] :
          ( ( has_field_derivative @ A @ F2 @ D5 @ ( topolo174197925503356063within @ A @ X2 @ S2 ) )
         => ( has_field_derivative @ A
            @ ^ [X5: A] : ( power_power @ A @ ( F2 @ X5 ) @ ( suc @ N2 ) )
            @ ( times_times @ A @ ( plus_plus @ A @ ( one_one @ A ) @ ( semiring_1_of_nat @ A @ N2 ) ) @ ( times_times @ A @ D5 @ ( power_power @ A @ ( F2 @ X2 ) @ N2 ) ) )
            @ ( topolo174197925503356063within @ A @ X2 @ S2 ) ) ) ) ).

% DERIV_power_Suc
thf(fact_6437_DERIV__const__average,axiom,
    ! [A2: real,B2: real,V: real > real,K: real] :
      ( ( A2 != B2 )
     => ( ! [X3: real] : ( has_field_derivative @ real @ V @ K @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) )
       => ( ( V @ ( divide_divide @ real @ ( plus_plus @ real @ A2 @ B2 ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
          = ( divide_divide @ real @ ( plus_plus @ real @ ( V @ A2 ) @ ( V @ B2 ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ).

% DERIV_const_average
thf(fact_6438_DERIV__inverse,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [X2: A,S2: set @ A] :
          ( ( X2
           != ( zero_zero @ A ) )
         => ( has_field_derivative @ A @ ( inverse_inverse @ A ) @ ( uminus_uminus @ A @ ( power_power @ A @ ( inverse_inverse @ A @ X2 ) @ ( suc @ ( suc @ ( zero_zero @ nat ) ) ) ) ) @ ( topolo174197925503356063within @ A @ X2 @ S2 ) ) ) ) ).

% DERIV_inverse
thf(fact_6439_DERIV__power,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,D5: A,X2: A,S2: set @ A,N2: nat] :
          ( ( has_field_derivative @ A @ F2 @ D5 @ ( topolo174197925503356063within @ A @ X2 @ S2 ) )
         => ( has_field_derivative @ A
            @ ^ [X5: A] : ( power_power @ A @ ( F2 @ X5 ) @ N2 )
            @ ( times_times @ A @ ( semiring_1_of_nat @ A @ N2 ) @ ( times_times @ A @ D5 @ ( power_power @ A @ ( F2 @ X2 ) @ ( minus_minus @ nat @ N2 @ ( suc @ ( zero_zero @ nat ) ) ) ) ) )
            @ ( topolo174197925503356063within @ A @ X2 @ S2 ) ) ) ) ).

% DERIV_power
thf(fact_6440_DERIV__local__max,axiom,
    ! [F2: real > real,L: real,X2: real,D2: real] :
      ( ( has_field_derivative @ real @ F2 @ L @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ D2 )
       => ( ! [Y4: real] :
              ( ( ord_less @ real @ ( abs_abs @ real @ ( minus_minus @ real @ X2 @ Y4 ) ) @ D2 )
             => ( ord_less_eq @ real @ ( F2 @ Y4 ) @ ( F2 @ X2 ) ) )
         => ( L
            = ( zero_zero @ real ) ) ) ) ) ).

% DERIV_local_max
thf(fact_6441_DERIV__local__min,axiom,
    ! [F2: real > real,L: real,X2: real,D2: real] :
      ( ( has_field_derivative @ real @ F2 @ L @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ D2 )
       => ( ! [Y4: real] :
              ( ( ord_less @ real @ ( abs_abs @ real @ ( minus_minus @ real @ X2 @ Y4 ) ) @ D2 )
             => ( ord_less_eq @ real @ ( F2 @ X2 ) @ ( F2 @ Y4 ) ) )
         => ( L
            = ( zero_zero @ real ) ) ) ) ) ).

% DERIV_local_min
thf(fact_6442_DERIV__ln__divide,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
     => ( has_field_derivative @ real @ ( ln_ln @ real ) @ ( divide_divide @ real @ ( one_one @ real ) @ X2 ) @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) ) ) ).

% DERIV_ln_divide
thf(fact_6443_DERIV__pow,axiom,
    ! [N2: nat,X2: real,S2: set @ real] :
      ( has_field_derivative @ real
      @ ^ [X5: real] : ( power_power @ real @ X5 @ N2 )
      @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N2 ) @ ( power_power @ real @ X2 @ ( minus_minus @ nat @ N2 @ ( suc @ ( zero_zero @ nat ) ) ) ) )
      @ ( topolo174197925503356063within @ real @ X2 @ S2 ) ) ).

% DERIV_pow
thf(fact_6444_termdiffs__strong__converges__everywhere,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [C2: nat > A,X2: A] :
          ( ! [Y4: A] :
              ( summable @ A
              @ ^ [N3: nat] : ( times_times @ A @ ( C2 @ N3 ) @ ( power_power @ A @ Y4 @ N3 ) ) )
         => ( has_field_derivative @ A
            @ ^ [X5: A] :
                ( suminf @ A
                @ ^ [N3: nat] : ( times_times @ A @ ( C2 @ N3 ) @ ( power_power @ A @ X5 @ N3 ) ) )
            @ ( suminf @ A
              @ ^ [N3: nat] : ( times_times @ A @ ( diffs @ A @ C2 @ N3 ) @ ( power_power @ A @ X2 @ N3 ) ) )
            @ ( topolo174197925503356063within @ A @ X2 @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% termdiffs_strong_converges_everywhere
thf(fact_6445_at__within__Icc__at,axiom,
    ! [A: $tType] :
      ( ( topolo2564578578187576103pology @ A )
     => ! [A2: A,X2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ X2 )
         => ( ( ord_less @ A @ X2 @ B2 )
           => ( ( topolo174197925503356063within @ A @ X2 @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) )
              = ( topolo174197925503356063within @ A @ X2 @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ).

% at_within_Icc_at
thf(fact_6446_DERIV__fun__pow,axiom,
    ! [G: real > real,M: real,X2: real,N2: nat] :
      ( ( has_field_derivative @ real @ G @ M @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) )
     => ( has_field_derivative @ real
        @ ^ [X5: real] : ( power_power @ real @ ( G @ X5 ) @ N2 )
        @ ( times_times @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N2 ) @ ( power_power @ real @ ( G @ X2 ) @ ( minus_minus @ nat @ N2 @ ( one_one @ nat ) ) ) ) @ M )
        @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) ) ) ).

% DERIV_fun_pow
thf(fact_6447_at__within__Icc__at__left,axiom,
    ! [A: $tType] :
      ( ( topolo2564578578187576103pology @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( topolo174197925503356063within @ A @ B2 @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) )
            = ( topolo174197925503356063within @ A @ B2 @ ( set_ord_lessThan @ A @ B2 ) ) ) ) ) ).

% at_within_Icc_at_left
thf(fact_6448_DERIV__quotient,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,D2: A,X2: A,S2: set @ A,G: A > A,E2: A] :
          ( ( has_field_derivative @ A @ F2 @ D2 @ ( topolo174197925503356063within @ A @ X2 @ S2 ) )
         => ( ( has_field_derivative @ A @ G @ E2 @ ( topolo174197925503356063within @ A @ X2 @ S2 ) )
           => ( ( ( G @ X2 )
               != ( zero_zero @ A ) )
             => ( has_field_derivative @ A
                @ ^ [Y5: A] : ( divide_divide @ A @ ( F2 @ Y5 ) @ ( G @ Y5 ) )
                @ ( divide_divide @ A @ ( minus_minus @ A @ ( times_times @ A @ D2 @ ( G @ X2 ) ) @ ( times_times @ A @ E2 @ ( F2 @ X2 ) ) ) @ ( power_power @ A @ ( G @ X2 ) @ ( suc @ ( suc @ ( zero_zero @ nat ) ) ) ) )
                @ ( topolo174197925503356063within @ A @ X2 @ S2 ) ) ) ) ) ) ).

% DERIV_quotient
thf(fact_6449_DERIV__inverse__fun,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,D2: A,X2: A,S2: set @ A] :
          ( ( has_field_derivative @ A @ F2 @ D2 @ ( topolo174197925503356063within @ A @ X2 @ S2 ) )
         => ( ( ( F2 @ X2 )
             != ( zero_zero @ A ) )
           => ( has_field_derivative @ A
              @ ^ [X5: A] : ( inverse_inverse @ A @ ( F2 @ X5 ) )
              @ ( uminus_uminus @ A @ ( times_times @ A @ D2 @ ( inverse_inverse @ A @ ( power_power @ A @ ( F2 @ X2 ) @ ( suc @ ( suc @ ( zero_zero @ nat ) ) ) ) ) ) )
              @ ( topolo174197925503356063within @ A @ X2 @ S2 ) ) ) ) ) ).

% DERIV_inverse_fun
thf(fact_6450_termdiffs__sums__strong,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [K5: real,C2: nat > A,F2: A > A,F8: A,Z: A] :
          ( ! [Z3: A] :
              ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ Z3 ) @ K5 )
             => ( sums @ A
                @ ^ [N3: nat] : ( times_times @ A @ ( C2 @ N3 ) @ ( power_power @ A @ Z3 @ N3 ) )
                @ ( F2 @ Z3 ) ) )
         => ( ( has_field_derivative @ A @ F2 @ F8 @ ( topolo174197925503356063within @ A @ Z @ ( top_top @ ( set @ A ) ) ) )
           => ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ Z ) @ K5 )
             => ( sums @ A
                @ ^ [N3: nat] : ( times_times @ A @ ( diffs @ A @ C2 @ N3 ) @ ( power_power @ A @ Z @ N3 ) )
                @ F8 ) ) ) ) ) ).

% termdiffs_sums_strong
thf(fact_6451_has__real__derivative__powr,axiom,
    ! [Z: real,R3: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ Z )
     => ( has_field_derivative @ real
        @ ^ [Z6: real] : ( powr @ real @ Z6 @ R3 )
        @ ( times_times @ real @ R3 @ ( powr @ real @ Z @ ( minus_minus @ real @ R3 @ ( one_one @ real ) ) ) )
        @ ( topolo174197925503356063within @ real @ Z @ ( top_top @ ( set @ real ) ) ) ) ) ).

% has_real_derivative_powr
thf(fact_6452_termdiffs,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [C2: nat > A,K5: A,X2: A] :
          ( ( summable @ A
            @ ^ [N3: nat] : ( times_times @ A @ ( C2 @ N3 ) @ ( power_power @ A @ K5 @ N3 ) ) )
         => ( ( summable @ A
              @ ^ [N3: nat] : ( times_times @ A @ ( diffs @ A @ C2 @ N3 ) @ ( power_power @ A @ K5 @ N3 ) ) )
           => ( ( summable @ A
                @ ^ [N3: nat] : ( times_times @ A @ ( diffs @ A @ ( diffs @ A @ C2 ) @ N3 ) @ ( power_power @ A @ K5 @ N3 ) ) )
             => ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ X2 ) @ ( real_V7770717601297561774m_norm @ A @ K5 ) )
               => ( has_field_derivative @ A
                  @ ^ [X5: A] :
                      ( suminf @ A
                      @ ^ [N3: nat] : ( times_times @ A @ ( C2 @ N3 ) @ ( power_power @ A @ X5 @ N3 ) ) )
                  @ ( suminf @ A
                    @ ^ [N3: nat] : ( times_times @ A @ ( diffs @ A @ C2 @ N3 ) @ ( power_power @ A @ X2 @ N3 ) ) )
                  @ ( topolo174197925503356063within @ A @ X2 @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ) ) ).

% termdiffs
thf(fact_6453_termdiffs__strong,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [C2: nat > A,K5: A,X2: A] :
          ( ( summable @ A
            @ ^ [N3: nat] : ( times_times @ A @ ( C2 @ N3 ) @ ( power_power @ A @ K5 @ N3 ) ) )
         => ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ X2 ) @ ( real_V7770717601297561774m_norm @ A @ K5 ) )
           => ( has_field_derivative @ A
              @ ^ [X5: A] :
                  ( suminf @ A
                  @ ^ [N3: nat] : ( times_times @ A @ ( C2 @ N3 ) @ ( power_power @ A @ X5 @ N3 ) ) )
              @ ( suminf @ A
                @ ^ [N3: nat] : ( times_times @ A @ ( diffs @ A @ C2 @ N3 ) @ ( power_power @ A @ X2 @ N3 ) ) )
              @ ( topolo174197925503356063within @ A @ X2 @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ).

% termdiffs_strong
thf(fact_6454_termdiffs__strong_H,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [K5: real,C2: nat > A,Z: A] :
          ( ! [Z3: A] :
              ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ Z3 ) @ K5 )
             => ( summable @ A
                @ ^ [N3: nat] : ( times_times @ A @ ( C2 @ N3 ) @ ( power_power @ A @ Z3 @ N3 ) ) ) )
         => ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ Z ) @ K5 )
           => ( has_field_derivative @ A
              @ ^ [Z6: A] :
                  ( suminf @ A
                  @ ^ [N3: nat] : ( times_times @ A @ ( C2 @ N3 ) @ ( power_power @ A @ Z6 @ N3 ) ) )
              @ ( suminf @ A
                @ ^ [N3: nat] : ( times_times @ A @ ( diffs @ A @ C2 @ N3 ) @ ( power_power @ A @ Z @ N3 ) ) )
              @ ( topolo174197925503356063within @ A @ Z @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ).

% termdiffs_strong'
thf(fact_6455_DERIV__log,axiom,
    ! [X2: real,B2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
     => ( has_field_derivative @ real @ ( log @ B2 ) @ ( divide_divide @ real @ ( one_one @ real ) @ ( times_times @ real @ ( ln_ln @ real @ B2 ) @ X2 ) ) @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) ) ) ).

% DERIV_log
thf(fact_6456_DERIV__fun__powr,axiom,
    ! [G: real > real,M: real,X2: real,R3: real] :
      ( ( has_field_derivative @ real @ G @ M @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ ( G @ X2 ) )
       => ( has_field_derivative @ real
          @ ^ [X5: real] : ( powr @ real @ ( G @ X5 ) @ R3 )
          @ ( times_times @ real @ ( times_times @ real @ R3 @ ( powr @ real @ ( G @ X2 ) @ ( minus_minus @ real @ R3 @ ( semiring_1_of_nat @ real @ ( one_one @ nat ) ) ) ) ) @ M )
          @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) ) ) ) ).

% DERIV_fun_powr
thf(fact_6457_DERIV__powr,axiom,
    ! [G: real > real,M: real,X2: real,F2: real > real,R3: real] :
      ( ( has_field_derivative @ real @ G @ M @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ ( G @ X2 ) )
       => ( ( has_field_derivative @ real @ F2 @ R3 @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) )
         => ( has_field_derivative @ real
            @ ^ [X5: real] : ( powr @ real @ ( G @ X5 ) @ ( F2 @ X5 ) )
            @ ( times_times @ real @ ( powr @ real @ ( G @ X2 ) @ ( F2 @ X2 ) ) @ ( plus_plus @ real @ ( times_times @ real @ R3 @ ( ln_ln @ real @ ( G @ X2 ) ) ) @ ( divide_divide @ real @ ( times_times @ real @ M @ ( F2 @ X2 ) ) @ ( G @ X2 ) ) ) )
            @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) ) ) ) ) ).

% DERIV_powr
thf(fact_6458_DERIV__tan,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X2: A] :
          ( ( ( cos @ A @ X2 )
           != ( zero_zero @ A ) )
         => ( has_field_derivative @ A @ ( tan @ A ) @ ( inverse_inverse @ A @ ( power_power @ A @ ( cos @ A @ X2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( topolo174197925503356063within @ A @ X2 @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% DERIV_tan
thf(fact_6459_DERIV__real__sqrt,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
     => ( has_field_derivative @ real @ sqrt @ ( divide_divide @ real @ ( inverse_inverse @ real @ ( sqrt @ X2 ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) ) ) ).

% DERIV_real_sqrt
thf(fact_6460_DERIV__arctan,axiom,
    ! [X2: real] : ( has_field_derivative @ real @ arctan @ ( inverse_inverse @ real @ ( plus_plus @ real @ ( one_one @ real ) @ ( power_power @ real @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) ) ).

% DERIV_arctan
thf(fact_6461_arsinh__real__has__field__derivative,axiom,
    ! [X2: real,A3: set @ real] : ( has_field_derivative @ real @ ( arsinh @ real ) @ ( divide_divide @ real @ ( one_one @ real ) @ ( sqrt @ ( plus_plus @ real @ ( power_power @ real @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ real ) ) ) ) @ ( topolo174197925503356063within @ real @ X2 @ A3 ) ) ).

% arsinh_real_has_field_derivative
thf(fact_6462_DERIV__cot,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X2: A] :
          ( ( ( sin @ A @ X2 )
           != ( zero_zero @ A ) )
         => ( has_field_derivative @ A @ ( cot @ A ) @ ( uminus_uminus @ A @ ( inverse_inverse @ A @ ( power_power @ A @ ( sin @ A @ X2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( topolo174197925503356063within @ A @ X2 @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% DERIV_cot
thf(fact_6463_has__field__derivative__tanh,axiom,
    ! [A16: $tType] :
      ( ( ( real_Vector_banach @ A16 )
        & ( real_V3459762299906320749_field @ A16 ) )
     => ! [G: A16 > A16,X2: A16,Db: A16,S2: set @ A16] :
          ( ( ( cosh @ A16 @ ( G @ X2 ) )
           != ( zero_zero @ A16 ) )
         => ( ( has_field_derivative @ A16 @ G @ Db @ ( topolo174197925503356063within @ A16 @ X2 @ S2 ) )
           => ( has_field_derivative @ A16
              @ ^ [X5: A16] : ( tanh @ A16 @ ( G @ X5 ) )
              @ ( times_times @ A16 @ ( minus_minus @ A16 @ ( one_one @ A16 ) @ ( power_power @ A16 @ ( tanh @ A16 @ ( G @ X2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ Db )
              @ ( topolo174197925503356063within @ A16 @ X2 @ S2 ) ) ) ) ) ).

% has_field_derivative_tanh
thf(fact_6464_DERIV__real__sqrt__generic,axiom,
    ! [X2: real,D5: real] :
      ( ( X2
       != ( zero_zero @ real ) )
     => ( ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
         => ( D5
            = ( divide_divide @ real @ ( inverse_inverse @ real @ ( sqrt @ X2 ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) )
       => ( ( ( ord_less @ real @ X2 @ ( zero_zero @ real ) )
           => ( D5
              = ( divide_divide @ real @ ( uminus_uminus @ real @ ( inverse_inverse @ real @ ( sqrt @ X2 ) ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) )
         => ( has_field_derivative @ real @ sqrt @ D5 @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) ) ) ) ) ).

% DERIV_real_sqrt_generic
thf(fact_6465_arcosh__real__has__field__derivative,axiom,
    ! [X2: real,A3: set @ real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ X2 )
     => ( has_field_derivative @ real @ ( arcosh @ real ) @ ( divide_divide @ real @ ( one_one @ real ) @ ( sqrt @ ( minus_minus @ real @ ( power_power @ real @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ real ) ) ) ) @ ( topolo174197925503356063within @ real @ X2 @ A3 ) ) ) ).

% arcosh_real_has_field_derivative
thf(fact_6466_artanh__real__has__field__derivative,axiom,
    ! [X2: real,A3: set @ real] :
      ( ( ord_less @ real @ ( abs_abs @ real @ X2 ) @ ( one_one @ real ) )
     => ( has_field_derivative @ real @ ( artanh @ real ) @ ( divide_divide @ real @ ( one_one @ real ) @ ( minus_minus @ real @ ( one_one @ real ) @ ( power_power @ real @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( topolo174197925503356063within @ real @ X2 @ A3 ) ) ) ).

% artanh_real_has_field_derivative
thf(fact_6467_DERIV__real__root,axiom,
    ! [N2: nat,X2: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X2 )
       => ( has_field_derivative @ real @ ( root @ N2 ) @ ( inverse_inverse @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N2 ) @ ( power_power @ real @ ( root @ N2 @ X2 ) @ ( minus_minus @ nat @ N2 @ ( suc @ ( zero_zero @ nat ) ) ) ) ) ) @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) ) ) ) ).

% DERIV_real_root
thf(fact_6468_DERIV__arccos,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ X2 )
     => ( ( ord_less @ real @ X2 @ ( one_one @ real ) )
       => ( has_field_derivative @ real @ arccos @ ( inverse_inverse @ real @ ( uminus_uminus @ real @ ( sqrt @ ( minus_minus @ real @ ( one_one @ real ) @ ( power_power @ real @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) ) ) ) ).

% DERIV_arccos
thf(fact_6469_DERIV__arcsin,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ X2 )
     => ( ( ord_less @ real @ X2 @ ( one_one @ real ) )
       => ( has_field_derivative @ real @ arcsin @ ( inverse_inverse @ real @ ( sqrt @ ( minus_minus @ real @ ( one_one @ real ) @ ( power_power @ real @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) ) ) ) ).

% DERIV_arcsin
thf(fact_6470_Maclaurin__all__le__objl,axiom,
    ! [Diff: nat > real > real,F2: real > real,X2: real,N2: nat] :
      ( ( ( ( Diff @ ( zero_zero @ nat ) )
          = F2 )
        & ! [M3: nat,X3: real] : ( has_field_derivative @ real @ ( Diff @ M3 ) @ ( Diff @ ( suc @ M3 ) @ X3 ) @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) ) )
     => ? [T4: real] :
          ( ( ord_less_eq @ real @ ( abs_abs @ real @ T4 ) @ ( abs_abs @ real @ X2 ) )
          & ( ( F2 @ X2 )
            = ( plus_plus @ real
              @ ( groups7311177749621191930dd_sum @ nat @ real
                @ ^ [M6: nat] : ( times_times @ real @ ( divide_divide @ real @ ( Diff @ M6 @ ( zero_zero @ real ) ) @ ( semiring_char_0_fact @ real @ M6 ) ) @ ( power_power @ real @ X2 @ M6 ) )
                @ ( set_ord_lessThan @ nat @ N2 ) )
              @ ( times_times @ real @ ( divide_divide @ real @ ( Diff @ N2 @ T4 ) @ ( semiring_char_0_fact @ real @ N2 ) ) @ ( power_power @ real @ X2 @ N2 ) ) ) ) ) ) ).

% Maclaurin_all_le_objl
thf(fact_6471_Maclaurin__all__le,axiom,
    ! [Diff: nat > real > real,F2: real > real,X2: real,N2: nat] :
      ( ( ( Diff @ ( zero_zero @ nat ) )
        = F2 )
     => ( ! [M3: nat,X3: real] : ( has_field_derivative @ real @ ( Diff @ M3 ) @ ( Diff @ ( suc @ M3 ) @ X3 ) @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) )
       => ? [T4: real] :
            ( ( ord_less_eq @ real @ ( abs_abs @ real @ T4 ) @ ( abs_abs @ real @ X2 ) )
            & ( ( F2 @ X2 )
              = ( plus_plus @ real
                @ ( groups7311177749621191930dd_sum @ nat @ real
                  @ ^ [M6: nat] : ( times_times @ real @ ( divide_divide @ real @ ( Diff @ M6 @ ( zero_zero @ real ) ) @ ( semiring_char_0_fact @ real @ M6 ) ) @ ( power_power @ real @ X2 @ M6 ) )
                  @ ( set_ord_lessThan @ nat @ N2 ) )
                @ ( times_times @ real @ ( divide_divide @ real @ ( Diff @ N2 @ T4 ) @ ( semiring_char_0_fact @ real @ N2 ) ) @ ( power_power @ real @ X2 @ N2 ) ) ) ) ) ) ) ).

% Maclaurin_all_le
thf(fact_6472_DERIV__odd__real__root,axiom,
    ! [N2: nat,X2: real] :
      ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 )
     => ( ( X2
         != ( zero_zero @ real ) )
       => ( has_field_derivative @ real @ ( root @ N2 ) @ ( inverse_inverse @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N2 ) @ ( power_power @ real @ ( root @ N2 @ X2 ) @ ( minus_minus @ nat @ N2 @ ( suc @ ( zero_zero @ nat ) ) ) ) ) ) @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) ) ) ) ).

% DERIV_odd_real_root
thf(fact_6473_Maclaurin,axiom,
    ! [H2: real,N2: nat,Diff: nat > real > real,F2: real > real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ H2 )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
       => ( ( ( Diff @ ( zero_zero @ nat ) )
            = F2 )
         => ( ! [M3: nat,T4: real] :
                ( ( ( ord_less @ nat @ M3 @ N2 )
                  & ( ord_less_eq @ real @ ( zero_zero @ real ) @ T4 )
                  & ( ord_less_eq @ real @ T4 @ H2 ) )
               => ( has_field_derivative @ real @ ( Diff @ M3 ) @ ( Diff @ ( suc @ M3 ) @ T4 ) @ ( topolo174197925503356063within @ real @ T4 @ ( top_top @ ( set @ real ) ) ) ) )
           => ? [T4: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ T4 )
                & ( ord_less @ real @ T4 @ H2 )
                & ( ( F2 @ H2 )
                  = ( plus_plus @ real
                    @ ( groups7311177749621191930dd_sum @ nat @ real
                      @ ^ [M6: nat] : ( times_times @ real @ ( divide_divide @ real @ ( Diff @ M6 @ ( zero_zero @ real ) ) @ ( semiring_char_0_fact @ real @ M6 ) ) @ ( power_power @ real @ H2 @ M6 ) )
                      @ ( set_ord_lessThan @ nat @ N2 ) )
                    @ ( times_times @ real @ ( divide_divide @ real @ ( Diff @ N2 @ T4 ) @ ( semiring_char_0_fact @ real @ N2 ) ) @ ( power_power @ real @ H2 @ N2 ) ) ) ) ) ) ) ) ) ).

% Maclaurin
thf(fact_6474_Maclaurin2,axiom,
    ! [H2: real,Diff: nat > real > real,F2: real > real,N2: nat] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ H2 )
     => ( ( ( Diff @ ( zero_zero @ nat ) )
          = F2 )
       => ( ! [M3: nat,T4: real] :
              ( ( ( ord_less @ nat @ M3 @ N2 )
                & ( ord_less_eq @ real @ ( zero_zero @ real ) @ T4 )
                & ( ord_less_eq @ real @ T4 @ H2 ) )
             => ( has_field_derivative @ real @ ( Diff @ M3 ) @ ( Diff @ ( suc @ M3 ) @ T4 ) @ ( topolo174197925503356063within @ real @ T4 @ ( top_top @ ( set @ real ) ) ) ) )
         => ? [T4: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ T4 )
              & ( ord_less_eq @ real @ T4 @ H2 )
              & ( ( F2 @ H2 )
                = ( plus_plus @ real
                  @ ( groups7311177749621191930dd_sum @ nat @ real
                    @ ^ [M6: nat] : ( times_times @ real @ ( divide_divide @ real @ ( Diff @ M6 @ ( zero_zero @ real ) ) @ ( semiring_char_0_fact @ real @ M6 ) ) @ ( power_power @ real @ H2 @ M6 ) )
                    @ ( set_ord_lessThan @ nat @ N2 ) )
                  @ ( times_times @ real @ ( divide_divide @ real @ ( Diff @ N2 @ T4 ) @ ( semiring_char_0_fact @ real @ N2 ) ) @ ( power_power @ real @ H2 @ N2 ) ) ) ) ) ) ) ) ).

% Maclaurin2
thf(fact_6475_Maclaurin__minus,axiom,
    ! [H2: real,N2: nat,Diff: nat > real > real,F2: real > real] :
      ( ( ord_less @ real @ H2 @ ( zero_zero @ real ) )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
       => ( ( ( Diff @ ( zero_zero @ nat ) )
            = F2 )
         => ( ! [M3: nat,T4: real] :
                ( ( ( ord_less @ nat @ M3 @ N2 )
                  & ( ord_less_eq @ real @ H2 @ T4 )
                  & ( ord_less_eq @ real @ T4 @ ( zero_zero @ real ) ) )
               => ( has_field_derivative @ real @ ( Diff @ M3 ) @ ( Diff @ ( suc @ M3 ) @ T4 ) @ ( topolo174197925503356063within @ real @ T4 @ ( top_top @ ( set @ real ) ) ) ) )
           => ? [T4: real] :
                ( ( ord_less @ real @ H2 @ T4 )
                & ( ord_less @ real @ T4 @ ( zero_zero @ real ) )
                & ( ( F2 @ H2 )
                  = ( plus_plus @ real
                    @ ( groups7311177749621191930dd_sum @ nat @ real
                      @ ^ [M6: nat] : ( times_times @ real @ ( divide_divide @ real @ ( Diff @ M6 @ ( zero_zero @ real ) ) @ ( semiring_char_0_fact @ real @ M6 ) ) @ ( power_power @ real @ H2 @ M6 ) )
                      @ ( set_ord_lessThan @ nat @ N2 ) )
                    @ ( times_times @ real @ ( divide_divide @ real @ ( Diff @ N2 @ T4 ) @ ( semiring_char_0_fact @ real @ N2 ) ) @ ( power_power @ real @ H2 @ N2 ) ) ) ) ) ) ) ) ) ).

% Maclaurin_minus
thf(fact_6476_Maclaurin__all__lt,axiom,
    ! [Diff: nat > real > real,F2: real > real,N2: nat,X2: real] :
      ( ( ( Diff @ ( zero_zero @ nat ) )
        = F2 )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
       => ( ( X2
           != ( zero_zero @ real ) )
         => ( ! [M3: nat,X3: real] : ( has_field_derivative @ real @ ( Diff @ M3 ) @ ( Diff @ ( suc @ M3 ) @ X3 ) @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) )
           => ? [T4: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ ( abs_abs @ real @ T4 ) )
                & ( ord_less @ real @ ( abs_abs @ real @ T4 ) @ ( abs_abs @ real @ X2 ) )
                & ( ( F2 @ X2 )
                  = ( plus_plus @ real
                    @ ( groups7311177749621191930dd_sum @ nat @ real
                      @ ^ [M6: nat] : ( times_times @ real @ ( divide_divide @ real @ ( Diff @ M6 @ ( zero_zero @ real ) ) @ ( semiring_char_0_fact @ real @ M6 ) ) @ ( power_power @ real @ X2 @ M6 ) )
                      @ ( set_ord_lessThan @ nat @ N2 ) )
                    @ ( times_times @ real @ ( divide_divide @ real @ ( Diff @ N2 @ T4 ) @ ( semiring_char_0_fact @ real @ N2 ) ) @ ( power_power @ real @ X2 @ N2 ) ) ) ) ) ) ) ) ) ).

% Maclaurin_all_lt
thf(fact_6477_Maclaurin__bi__le,axiom,
    ! [Diff: nat > real > real,F2: real > real,N2: nat,X2: real] :
      ( ( ( Diff @ ( zero_zero @ nat ) )
        = F2 )
     => ( ! [M3: nat,T4: real] :
            ( ( ( ord_less @ nat @ M3 @ N2 )
              & ( ord_less_eq @ real @ ( abs_abs @ real @ T4 ) @ ( abs_abs @ real @ X2 ) ) )
           => ( has_field_derivative @ real @ ( Diff @ M3 ) @ ( Diff @ ( suc @ M3 ) @ T4 ) @ ( topolo174197925503356063within @ real @ T4 @ ( top_top @ ( set @ real ) ) ) ) )
       => ? [T4: real] :
            ( ( ord_less_eq @ real @ ( abs_abs @ real @ T4 ) @ ( abs_abs @ real @ X2 ) )
            & ( ( F2 @ X2 )
              = ( plus_plus @ real
                @ ( groups7311177749621191930dd_sum @ nat @ real
                  @ ^ [M6: nat] : ( times_times @ real @ ( divide_divide @ real @ ( Diff @ M6 @ ( zero_zero @ real ) ) @ ( semiring_char_0_fact @ real @ M6 ) ) @ ( power_power @ real @ X2 @ M6 ) )
                  @ ( set_ord_lessThan @ nat @ N2 ) )
                @ ( times_times @ real @ ( divide_divide @ real @ ( Diff @ N2 @ T4 ) @ ( semiring_char_0_fact @ real @ N2 ) ) @ ( power_power @ real @ X2 @ N2 ) ) ) ) ) ) ) ).

% Maclaurin_bi_le
thf(fact_6478_Taylor,axiom,
    ! [N2: nat,Diff: nat > real > real,F2: real > real,A2: real,B2: real,C2: real,X2: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( ( Diff @ ( zero_zero @ nat ) )
          = F2 )
       => ( ! [M3: nat,T4: real] :
              ( ( ( ord_less @ nat @ M3 @ N2 )
                & ( ord_less_eq @ real @ A2 @ T4 )
                & ( ord_less_eq @ real @ T4 @ B2 ) )
             => ( has_field_derivative @ real @ ( Diff @ M3 ) @ ( Diff @ ( suc @ M3 ) @ T4 ) @ ( topolo174197925503356063within @ real @ T4 @ ( top_top @ ( set @ real ) ) ) ) )
         => ( ( ord_less_eq @ real @ A2 @ C2 )
           => ( ( ord_less_eq @ real @ C2 @ B2 )
             => ( ( ord_less_eq @ real @ A2 @ X2 )
               => ( ( ord_less_eq @ real @ X2 @ B2 )
                 => ( ( X2 != C2 )
                   => ? [T4: real] :
                        ( ( ( ord_less @ real @ X2 @ C2 )
                         => ( ( ord_less @ real @ X2 @ T4 )
                            & ( ord_less @ real @ T4 @ C2 ) ) )
                        & ( ~ ( ord_less @ real @ X2 @ C2 )
                         => ( ( ord_less @ real @ C2 @ T4 )
                            & ( ord_less @ real @ T4 @ X2 ) ) )
                        & ( ( F2 @ X2 )
                          = ( plus_plus @ real
                            @ ( groups7311177749621191930dd_sum @ nat @ real
                              @ ^ [M6: nat] : ( times_times @ real @ ( divide_divide @ real @ ( Diff @ M6 @ C2 ) @ ( semiring_char_0_fact @ real @ M6 ) ) @ ( power_power @ real @ ( minus_minus @ real @ X2 @ C2 ) @ M6 ) )
                              @ ( set_ord_lessThan @ nat @ N2 ) )
                            @ ( times_times @ real @ ( divide_divide @ real @ ( Diff @ N2 @ T4 ) @ ( semiring_char_0_fact @ real @ N2 ) ) @ ( power_power @ real @ ( minus_minus @ real @ X2 @ C2 ) @ N2 ) ) ) ) ) ) ) ) ) ) ) ) ) ).

% Taylor
thf(fact_6479_Taylor__up,axiom,
    ! [N2: nat,Diff: nat > real > real,F2: real > real,A2: real,B2: real,C2: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( ( Diff @ ( zero_zero @ nat ) )
          = F2 )
       => ( ! [M3: nat,T4: real] :
              ( ( ( ord_less @ nat @ M3 @ N2 )
                & ( ord_less_eq @ real @ A2 @ T4 )
                & ( ord_less_eq @ real @ T4 @ B2 ) )
             => ( has_field_derivative @ real @ ( Diff @ M3 ) @ ( Diff @ ( suc @ M3 ) @ T4 ) @ ( topolo174197925503356063within @ real @ T4 @ ( top_top @ ( set @ real ) ) ) ) )
         => ( ( ord_less_eq @ real @ A2 @ C2 )
           => ( ( ord_less @ real @ C2 @ B2 )
             => ? [T4: real] :
                  ( ( ord_less @ real @ C2 @ T4 )
                  & ( ord_less @ real @ T4 @ B2 )
                  & ( ( F2 @ B2 )
                    = ( plus_plus @ real
                      @ ( groups7311177749621191930dd_sum @ nat @ real
                        @ ^ [M6: nat] : ( times_times @ real @ ( divide_divide @ real @ ( Diff @ M6 @ C2 ) @ ( semiring_char_0_fact @ real @ M6 ) ) @ ( power_power @ real @ ( minus_minus @ real @ B2 @ C2 ) @ M6 ) )
                        @ ( set_ord_lessThan @ nat @ N2 ) )
                      @ ( times_times @ real @ ( divide_divide @ real @ ( Diff @ N2 @ T4 ) @ ( semiring_char_0_fact @ real @ N2 ) ) @ ( power_power @ real @ ( minus_minus @ real @ B2 @ C2 ) @ N2 ) ) ) ) ) ) ) ) ) ) ).

% Taylor_up
thf(fact_6480_Taylor__down,axiom,
    ! [N2: nat,Diff: nat > real > real,F2: real > real,A2: real,B2: real,C2: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( ( Diff @ ( zero_zero @ nat ) )
          = F2 )
       => ( ! [M3: nat,T4: real] :
              ( ( ( ord_less @ nat @ M3 @ N2 )
                & ( ord_less_eq @ real @ A2 @ T4 )
                & ( ord_less_eq @ real @ T4 @ B2 ) )
             => ( has_field_derivative @ real @ ( Diff @ M3 ) @ ( Diff @ ( suc @ M3 ) @ T4 ) @ ( topolo174197925503356063within @ real @ T4 @ ( top_top @ ( set @ real ) ) ) ) )
         => ( ( ord_less @ real @ A2 @ C2 )
           => ( ( ord_less_eq @ real @ C2 @ B2 )
             => ? [T4: real] :
                  ( ( ord_less @ real @ A2 @ T4 )
                  & ( ord_less @ real @ T4 @ C2 )
                  & ( ( F2 @ A2 )
                    = ( plus_plus @ real
                      @ ( groups7311177749621191930dd_sum @ nat @ real
                        @ ^ [M6: nat] : ( times_times @ real @ ( divide_divide @ real @ ( Diff @ M6 @ C2 ) @ ( semiring_char_0_fact @ real @ M6 ) ) @ ( power_power @ real @ ( minus_minus @ real @ A2 @ C2 ) @ M6 ) )
                        @ ( set_ord_lessThan @ nat @ N2 ) )
                      @ ( times_times @ real @ ( divide_divide @ real @ ( Diff @ N2 @ T4 ) @ ( semiring_char_0_fact @ real @ N2 ) ) @ ( power_power @ real @ ( minus_minus @ real @ A2 @ C2 ) @ N2 ) ) ) ) ) ) ) ) ) ) ).

% Taylor_down
thf(fact_6481_Maclaurin__lemma2,axiom,
    ! [N2: nat,H2: real,Diff: nat > real > real,K: nat,B3: real] :
      ( ! [M3: nat,T4: real] :
          ( ( ( ord_less @ nat @ M3 @ N2 )
            & ( ord_less_eq @ real @ ( zero_zero @ real ) @ T4 )
            & ( ord_less_eq @ real @ T4 @ H2 ) )
         => ( has_field_derivative @ real @ ( Diff @ M3 ) @ ( Diff @ ( suc @ M3 ) @ T4 ) @ ( topolo174197925503356063within @ real @ T4 @ ( top_top @ ( set @ real ) ) ) ) )
     => ( ( N2
          = ( suc @ K ) )
       => ! [M2: nat,T8: real] :
            ( ( ( ord_less @ nat @ M2 @ N2 )
              & ( ord_less_eq @ real @ ( zero_zero @ real ) @ T8 )
              & ( ord_less_eq @ real @ T8 @ H2 ) )
           => ( has_field_derivative @ real
              @ ^ [U2: real] :
                  ( minus_minus @ real @ ( Diff @ M2 @ U2 )
                  @ ( plus_plus @ real
                    @ ( groups7311177749621191930dd_sum @ nat @ real
                      @ ^ [P6: nat] : ( times_times @ real @ ( divide_divide @ real @ ( Diff @ ( plus_plus @ nat @ M2 @ P6 ) @ ( zero_zero @ real ) ) @ ( semiring_char_0_fact @ real @ P6 ) ) @ ( power_power @ real @ U2 @ P6 ) )
                      @ ( set_ord_lessThan @ nat @ ( minus_minus @ nat @ N2 @ M2 ) ) )
                    @ ( times_times @ real @ B3 @ ( divide_divide @ real @ ( power_power @ real @ U2 @ ( minus_minus @ nat @ N2 @ M2 ) ) @ ( semiring_char_0_fact @ real @ ( minus_minus @ nat @ N2 @ M2 ) ) ) ) ) )
              @ ( minus_minus @ real @ ( Diff @ ( suc @ M2 ) @ T8 )
                @ ( plus_plus @ real
                  @ ( groups7311177749621191930dd_sum @ nat @ real
                    @ ^ [P6: nat] : ( times_times @ real @ ( divide_divide @ real @ ( Diff @ ( plus_plus @ nat @ ( suc @ M2 ) @ P6 ) @ ( zero_zero @ real ) ) @ ( semiring_char_0_fact @ real @ P6 ) ) @ ( power_power @ real @ T8 @ P6 ) )
                    @ ( set_ord_lessThan @ nat @ ( minus_minus @ nat @ N2 @ ( suc @ M2 ) ) ) )
                  @ ( times_times @ real @ B3 @ ( divide_divide @ real @ ( power_power @ real @ T8 @ ( minus_minus @ nat @ N2 @ ( suc @ M2 ) ) ) @ ( semiring_char_0_fact @ real @ ( minus_minus @ nat @ N2 @ ( suc @ M2 ) ) ) ) ) ) )
              @ ( topolo174197925503356063within @ real @ T8 @ ( top_top @ ( set @ real ) ) ) ) ) ) ) ).

% Maclaurin_lemma2
thf(fact_6482_DERIV__arctan__series,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( abs_abs @ real @ X2 ) @ ( one_one @ real ) )
     => ( has_field_derivative @ real
        @ ^ [X9: real] :
            ( suminf @ real
            @ ^ [K3: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ K3 ) @ ( times_times @ real @ ( divide_divide @ real @ ( one_one @ real ) @ ( semiring_1_of_nat @ real @ ( plus_plus @ nat @ ( times_times @ nat @ K3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ nat ) ) ) ) @ ( power_power @ real @ X9 @ ( plus_plus @ nat @ ( times_times @ nat @ K3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ nat ) ) ) ) ) )
        @ ( suminf @ real
          @ ^ [K3: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ K3 ) @ ( power_power @ real @ X2 @ ( times_times @ nat @ K3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
        @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) ) ) ).

% DERIV_arctan_series
thf(fact_6483_DERIV__even__real__root,axiom,
    ! [N2: nat,X2: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 )
       => ( ( ord_less @ real @ X2 @ ( zero_zero @ real ) )
         => ( has_field_derivative @ real @ ( root @ N2 ) @ ( inverse_inverse @ real @ ( times_times @ real @ ( uminus_uminus @ real @ ( semiring_1_of_nat @ real @ N2 ) ) @ ( power_power @ real @ ( root @ N2 @ X2 ) @ ( minus_minus @ nat @ N2 @ ( suc @ ( zero_zero @ nat ) ) ) ) ) ) @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) ) ) ) ) ).

% DERIV_even_real_root
thf(fact_6484_DERIV__power__series_H,axiom,
    ! [R: real,F2: nat > real,X0: real] :
      ( ! [X3: real] :
          ( ( member @ real @ X3 @ ( set_or5935395276787703475ssThan @ real @ ( uminus_uminus @ real @ R ) @ R ) )
         => ( summable @ real
            @ ^ [N3: nat] : ( times_times @ real @ ( times_times @ real @ ( F2 @ N3 ) @ ( semiring_1_of_nat @ real @ ( suc @ N3 ) ) ) @ ( power_power @ real @ X3 @ N3 ) ) ) )
     => ( ( member @ real @ X0 @ ( set_or5935395276787703475ssThan @ real @ ( uminus_uminus @ real @ R ) @ R ) )
       => ( ( ord_less @ real @ ( zero_zero @ real ) @ R )
         => ( has_field_derivative @ real
            @ ^ [X5: real] :
                ( suminf @ real
                @ ^ [N3: nat] : ( times_times @ real @ ( F2 @ N3 ) @ ( power_power @ real @ X5 @ ( suc @ N3 ) ) ) )
            @ ( suminf @ real
              @ ^ [N3: nat] : ( times_times @ real @ ( times_times @ real @ ( F2 @ N3 ) @ ( semiring_1_of_nat @ real @ ( suc @ N3 ) ) ) @ ( power_power @ real @ X0 @ N3 ) ) )
            @ ( topolo174197925503356063within @ real @ X0 @ ( top_top @ ( set @ real ) ) ) ) ) ) ) ).

% DERIV_power_series'
thf(fact_6485_has__derivative__arcsin,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [G: A > real,X2: A,G6: A > real,S2: set @ A] :
          ( ( ord_less @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ ( G @ X2 ) )
         => ( ( ord_less @ real @ ( G @ X2 ) @ ( one_one @ real ) )
           => ( ( has_derivative @ A @ real @ G @ G6 @ ( topolo174197925503356063within @ A @ X2 @ S2 ) )
             => ( has_derivative @ A @ real
                @ ^ [X5: A] : ( arcsin @ ( G @ X5 ) )
                @ ^ [X5: A] : ( times_times @ real @ ( G6 @ X5 ) @ ( inverse_inverse @ real @ ( sqrt @ ( minus_minus @ real @ ( one_one @ real ) @ ( power_power @ real @ ( G @ X2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) )
                @ ( topolo174197925503356063within @ A @ X2 @ S2 ) ) ) ) ) ) ).

% has_derivative_arcsin
thf(fact_6486_greaterThanLessThan__iff,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [I3: A,L: A,U: A] :
          ( ( member @ A @ I3 @ ( set_or5935395276787703475ssThan @ A @ L @ U ) )
          = ( ( ord_less @ A @ L @ I3 )
            & ( ord_less @ A @ I3 @ U ) ) ) ) ).

% greaterThanLessThan_iff
thf(fact_6487_greaterThanLessThan__empty,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [L: A,K: A] :
          ( ( ord_less_eq @ A @ L @ K )
         => ( ( set_or5935395276787703475ssThan @ A @ K @ L )
            = ( bot_bot @ ( set @ A ) ) ) ) ) ).

% greaterThanLessThan_empty
thf(fact_6488_greaterThanLessThan__empty__iff,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ( set_or5935395276787703475ssThan @ A @ A2 @ B2 )
            = ( bot_bot @ ( set @ A ) ) )
          = ( ord_less_eq @ A @ B2 @ A2 ) ) ) ).

% greaterThanLessThan_empty_iff
thf(fact_6489_greaterThanLessThan__empty__iff2,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ( bot_bot @ ( set @ A ) )
            = ( set_or5935395276787703475ssThan @ A @ A2 @ B2 ) )
          = ( ord_less_eq @ A @ B2 @ A2 ) ) ) ).

% greaterThanLessThan_empty_iff2
thf(fact_6490_infinite__Ioo__iff,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ~ ( finite_finite @ A @ ( set_or5935395276787703475ssThan @ A @ A2 @ B2 ) ) )
          = ( ord_less @ A @ A2 @ B2 ) ) ) ).

% infinite_Ioo_iff
thf(fact_6491_Sup__greaterThanLessThan,axiom,
    ! [A: $tType] :
      ( ( ( comple6319245703460814977attice @ A )
        & ( dense_linorder @ A ) )
     => ! [X2: A,Y2: A] :
          ( ( ord_less @ A @ X2 @ Y2 )
         => ( ( complete_Sup_Sup @ A @ ( set_or5935395276787703475ssThan @ A @ X2 @ Y2 ) )
            = Y2 ) ) ) ).

% Sup_greaterThanLessThan
thf(fact_6492_cSup__greaterThanLessThan,axiom,
    ! [A: $tType] :
      ( ( ( condit6923001295902523014norder @ A )
        & ( dense_linorder @ A ) )
     => ! [Y2: A,X2: A] :
          ( ( ord_less @ A @ Y2 @ X2 )
         => ( ( complete_Sup_Sup @ A @ ( set_or5935395276787703475ssThan @ A @ Y2 @ X2 ) )
            = X2 ) ) ) ).

% cSup_greaterThanLessThan
thf(fact_6493_Inf__greaterThanLessThan,axiom,
    ! [A: $tType] :
      ( ( ( comple6319245703460814977attice @ A )
        & ( dense_linorder @ A ) )
     => ! [X2: A,Y2: A] :
          ( ( ord_less @ A @ X2 @ Y2 )
         => ( ( complete_Inf_Inf @ A @ ( set_or5935395276787703475ssThan @ A @ X2 @ Y2 ) )
            = X2 ) ) ) ).

% Inf_greaterThanLessThan
thf(fact_6494_cInf__greaterThanLessThan,axiom,
    ! [A: $tType] :
      ( ( ( condit6923001295902523014norder @ A )
        & ( dense_linorder @ A ) )
     => ! [Y2: A,X2: A] :
          ( ( ord_less @ A @ Y2 @ X2 )
         => ( ( complete_Inf_Inf @ A @ ( set_or5935395276787703475ssThan @ A @ Y2 @ X2 ) )
            = Y2 ) ) ) ).

% cInf_greaterThanLessThan
thf(fact_6495_has__derivative__subset,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F2: A > B,F8: A > B,X2: A,S2: set @ A,T2: set @ A] :
          ( ( has_derivative @ A @ B @ F2 @ F8 @ ( topolo174197925503356063within @ A @ X2 @ S2 ) )
         => ( ( ord_less_eq @ ( set @ A ) @ T2 @ S2 )
           => ( has_derivative @ A @ B @ F2 @ F8 @ ( topolo174197925503356063within @ A @ X2 @ T2 ) ) ) ) ) ).

% has_derivative_subset
thf(fact_6496_has__field__derivative__def,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ( ( has_field_derivative @ A )
        = ( ^ [F5: A > A,D7: A] : ( has_derivative @ A @ A @ F5 @ ( times_times @ A @ D7 ) ) ) ) ) ).

% has_field_derivative_def
thf(fact_6497_has__derivative__imp__has__field__derivative,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,D5: A > A,F3: filter @ A,D8: A] :
          ( ( has_derivative @ A @ A @ F2 @ D5 @ F3 )
         => ( ! [X3: A] :
                ( ( times_times @ A @ X3 @ D8 )
                = ( D5 @ X3 ) )
           => ( has_field_derivative @ A @ F2 @ D8 @ F3 ) ) ) ) ).

% has_derivative_imp_has_field_derivative
thf(fact_6498_has__field__derivative__imp__has__derivative,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,D5: A,F3: filter @ A] :
          ( ( has_field_derivative @ A @ F2 @ D5 @ F3 )
         => ( has_derivative @ A @ A @ F2 @ ( times_times @ A @ D5 ) @ F3 ) ) ) ).

% has_field_derivative_imp_has_derivative
thf(fact_6499_has__derivative__scaleR,axiom,
    ! [C: $tType,D: $tType] :
      ( ( ( real_V822414075346904944vector @ D )
        & ( real_V822414075346904944vector @ C ) )
     => ! [F2: D > real,F8: D > real,X2: D,S2: set @ D,G: D > C,G6: D > C] :
          ( ( has_derivative @ D @ real @ F2 @ F8 @ ( topolo174197925503356063within @ D @ X2 @ S2 ) )
         => ( ( has_derivative @ D @ C @ G @ G6 @ ( topolo174197925503356063within @ D @ X2 @ S2 ) )
           => ( has_derivative @ D @ C
              @ ^ [X5: D] : ( real_V8093663219630862766scaleR @ C @ ( F2 @ X5 ) @ ( G @ X5 ) )
              @ ^ [H: D] : ( plus_plus @ C @ ( real_V8093663219630862766scaleR @ C @ ( F2 @ X2 ) @ ( G6 @ H ) ) @ ( real_V8093663219630862766scaleR @ C @ ( F8 @ H ) @ ( G @ X2 ) ) )
              @ ( topolo174197925503356063within @ D @ X2 @ S2 ) ) ) ) ) ).

% has_derivative_scaleR
thf(fact_6500_option_Odisc__eq__case_I2_J,axiom,
    ! [A: $tType,Option: option @ A] :
      ( ( ( Option
         != ( none @ A ) ) )
      = ( case_option @ $o @ A @ $false
        @ ^ [Uu3: A] : $true
        @ Option ) ) ).

% option.disc_eq_case(2)
thf(fact_6501_option_Odisc__eq__case_I1_J,axiom,
    ! [A: $tType,Option: option @ A] :
      ( ( Option
        = ( none @ A ) )
      = ( case_option @ $o @ A @ $true
        @ ^ [Uu3: A] : $false
        @ Option ) ) ).

% option.disc_eq_case(1)
thf(fact_6502_has__derivative__add,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F2: A > B,F8: A > B,F3: filter @ A,G: A > B,G6: A > B] :
          ( ( has_derivative @ A @ B @ F2 @ F8 @ F3 )
         => ( ( has_derivative @ A @ B @ G @ G6 @ F3 )
           => ( has_derivative @ A @ B
              @ ^ [X5: A] : ( plus_plus @ B @ ( F2 @ X5 ) @ ( G @ X5 ) )
              @ ^ [X5: A] : ( plus_plus @ B @ ( F8 @ X5 ) @ ( G6 @ X5 ) )
              @ F3 ) ) ) ) ).

% has_derivative_add
thf(fact_6503_has__derivative__const,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [C2: B,F3: filter @ A] :
          ( has_derivative @ A @ B
          @ ^ [X5: A] : C2
          @ ^ [X5: A] : ( zero_zero @ B )
          @ F3 ) ) ).

% has_derivative_const
thf(fact_6504_has__derivative__mult__right,axiom,
    ! [A: $tType,C: $tType] :
      ( ( ( real_V822414075346904944vector @ C )
        & ( real_V4412858255891104859lgebra @ A ) )
     => ! [G: C > A,G6: C > A,F3: filter @ C,X2: A] :
          ( ( has_derivative @ C @ A @ G @ G6 @ F3 )
         => ( has_derivative @ C @ A
            @ ^ [X5: C] : ( times_times @ A @ X2 @ ( G @ X5 ) )
            @ ^ [X5: C] : ( times_times @ A @ X2 @ ( G6 @ X5 ) )
            @ F3 ) ) ) ).

% has_derivative_mult_right
thf(fact_6505_has__derivative__mult__left,axiom,
    ! [A: $tType,C: $tType] :
      ( ( ( real_V822414075346904944vector @ C )
        & ( real_V4412858255891104859lgebra @ A ) )
     => ! [G: C > A,G6: C > A,F3: filter @ C,Y2: A] :
          ( ( has_derivative @ C @ A @ G @ G6 @ F3 )
         => ( has_derivative @ C @ A
            @ ^ [X5: C] : ( times_times @ A @ ( G @ X5 ) @ Y2 )
            @ ^ [X5: C] : ( times_times @ A @ ( G6 @ X5 ) @ Y2 )
            @ F3 ) ) ) ).

% has_derivative_mult_left
thf(fact_6506_infinite__Ioo,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ~ ( finite_finite @ A @ ( set_or5935395276787703475ssThan @ A @ A2 @ B2 ) ) ) ) ).

% infinite_Ioo
thf(fact_6507_has__derivative__zero__unique,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F3: A > B,X2: A] :
          ( ( has_derivative @ A @ B
            @ ^ [X5: A] : ( zero_zero @ B )
            @ F3
            @ ( topolo174197925503356063within @ A @ X2 @ ( top_top @ ( set @ A ) ) ) )
         => ( F3
            = ( ^ [H: A] : ( zero_zero @ B ) ) ) ) ) ).

% has_derivative_zero_unique
thf(fact_6508_has__derivative__mult,axiom,
    ! [A: $tType,D: $tType] :
      ( ( ( real_V822414075346904944vector @ D )
        & ( real_V4412858255891104859lgebra @ A ) )
     => ! [F2: D > A,F8: D > A,X2: D,S2: set @ D,G: D > A,G6: D > A] :
          ( ( has_derivative @ D @ A @ F2 @ F8 @ ( topolo174197925503356063within @ D @ X2 @ S2 ) )
         => ( ( has_derivative @ D @ A @ G @ G6 @ ( topolo174197925503356063within @ D @ X2 @ S2 ) )
           => ( has_derivative @ D @ A
              @ ^ [X5: D] : ( times_times @ A @ ( F2 @ X5 ) @ ( G @ X5 ) )
              @ ^ [H: D] : ( plus_plus @ A @ ( times_times @ A @ ( F2 @ X2 ) @ ( G6 @ H ) ) @ ( times_times @ A @ ( F8 @ H ) @ ( G @ X2 ) ) )
              @ ( topolo174197925503356063within @ D @ X2 @ S2 ) ) ) ) ) ).

% has_derivative_mult
thf(fact_6509_has__derivative__in__compose2,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( ( real_V822414075346904944vector @ C )
        & ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [T2: set @ A,G: A > B,G6: A > A > B,F2: C > A,S2: set @ C,X2: C,F8: C > A] :
          ( ! [X3: A] :
              ( ( member @ A @ X3 @ T2 )
             => ( has_derivative @ A @ B @ G @ ( G6 @ X3 ) @ ( topolo174197925503356063within @ A @ X3 @ T2 ) ) )
         => ( ( ord_less_eq @ ( set @ A ) @ ( image @ C @ A @ F2 @ S2 ) @ T2 )
           => ( ( member @ C @ X2 @ S2 )
             => ( ( has_derivative @ C @ A @ F2 @ F8 @ ( topolo174197925503356063within @ C @ X2 @ S2 ) )
               => ( has_derivative @ C @ B
                  @ ^ [X5: C] : ( G @ ( F2 @ X5 ) )
                  @ ^ [Y5: C] : ( G6 @ ( F2 @ X2 ) @ ( F8 @ Y5 ) )
                  @ ( topolo174197925503356063within @ C @ X2 @ S2 ) ) ) ) ) ) ) ).

% has_derivative_in_compose2
thf(fact_6510_has__derivative__exp,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [G: A > real,G6: A > real,X2: A,S2: set @ A] :
          ( ( has_derivative @ A @ real @ G @ G6 @ ( topolo174197925503356063within @ A @ X2 @ S2 ) )
         => ( has_derivative @ A @ real
            @ ^ [X5: A] : ( exp @ real @ ( G @ X5 ) )
            @ ^ [X5: A] : ( times_times @ real @ ( G6 @ X5 ) @ ( exp @ real @ ( G @ X2 ) ) )
            @ ( topolo174197925503356063within @ A @ X2 @ S2 ) ) ) ) ).

% has_derivative_exp
thf(fact_6511_case__optionE,axiom,
    ! [A: $tType,P: $o,Q: A > $o,X2: option @ A] :
      ( ( case_option @ $o @ A @ P @ Q @ X2 )
     => ( ( ( X2
            = ( none @ A ) )
         => ~ P )
       => ~ ! [Y4: A] :
              ( ( X2
                = ( some @ A @ Y4 ) )
             => ~ ( Q @ Y4 ) ) ) ) ).

% case_optionE
thf(fact_6512_greaterThanLessThan__subseteq__greaterThanLessThan,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ord_less_eq @ ( set @ A ) @ ( set_or5935395276787703475ssThan @ A @ A2 @ B2 ) @ ( set_or5935395276787703475ssThan @ A @ C2 @ D2 ) )
          = ( ( ord_less @ A @ A2 @ B2 )
           => ( ( ord_less_eq @ A @ C2 @ A2 )
              & ( ord_less_eq @ A @ B2 @ D2 ) ) ) ) ) ).

% greaterThanLessThan_subseteq_greaterThanLessThan
thf(fact_6513_has__derivative__sin,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [G: A > real,G6: A > real,X2: A,S2: set @ A] :
          ( ( has_derivative @ A @ real @ G @ G6 @ ( topolo174197925503356063within @ A @ X2 @ S2 ) )
         => ( has_derivative @ A @ real
            @ ^ [X5: A] : ( sin @ real @ ( G @ X5 ) )
            @ ^ [X5: A] : ( times_times @ real @ ( G6 @ X5 ) @ ( cos @ real @ ( G @ X2 ) ) )
            @ ( topolo174197925503356063within @ A @ X2 @ S2 ) ) ) ) ).

% has_derivative_sin
thf(fact_6514_has__derivative__cosh,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [G: A > A,Db: A,X2: A,S2: set @ A] :
          ( ( has_derivative @ A @ A @ G @ ( times_times @ A @ Db ) @ ( topolo174197925503356063within @ A @ X2 @ S2 ) )
         => ( has_derivative @ A @ A
            @ ^ [X5: A] : ( cosh @ A @ ( G @ X5 ) )
            @ ( times_times @ A @ ( times_times @ A @ ( sinh @ A @ ( G @ X2 ) ) @ Db ) )
            @ ( topolo174197925503356063within @ A @ X2 @ S2 ) ) ) ) ).

% has_derivative_cosh
thf(fact_6515_has__derivative__sinh,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [G: A > A,Db: A,X2: A,S2: set @ A] :
          ( ( has_derivative @ A @ A @ G @ ( times_times @ A @ Db ) @ ( topolo174197925503356063within @ A @ X2 @ S2 ) )
         => ( has_derivative @ A @ A
            @ ^ [X5: A] : ( sinh @ A @ ( G @ X5 ) )
            @ ( times_times @ A @ ( times_times @ A @ ( cosh @ A @ ( G @ X2 ) ) @ Db ) )
            @ ( topolo174197925503356063within @ A @ X2 @ S2 ) ) ) ) ).

% has_derivative_sinh
thf(fact_6516_greaterThanLessThan__subseteq__atLeastAtMost__iff,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ord_less_eq @ ( set @ A ) @ ( set_or5935395276787703475ssThan @ A @ A2 @ B2 ) @ ( set_or1337092689740270186AtMost @ A @ C2 @ D2 ) )
          = ( ( ord_less @ A @ A2 @ B2 )
           => ( ( ord_less_eq @ A @ C2 @ A2 )
              & ( ord_less_eq @ A @ B2 @ D2 ) ) ) ) ) ).

% greaterThanLessThan_subseteq_atLeastAtMost_iff
thf(fact_6517_greaterThanLessThan__subseteq__atLeastLessThan__iff,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ord_less_eq @ ( set @ A ) @ ( set_or5935395276787703475ssThan @ A @ A2 @ B2 ) @ ( set_or7035219750837199246ssThan @ A @ C2 @ D2 ) )
          = ( ( ord_less @ A @ A2 @ B2 )
           => ( ( ord_less_eq @ A @ C2 @ A2 )
              & ( ord_less_eq @ A @ B2 @ D2 ) ) ) ) ) ).

% greaterThanLessThan_subseteq_atLeastLessThan_iff
thf(fact_6518_ivl__disj__un__two_I1_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L: A,M: A,U: A] :
          ( ( ord_less @ A @ L @ M )
         => ( ( ord_less_eq @ A @ M @ U )
           => ( ( sup_sup @ ( set @ A ) @ ( set_or5935395276787703475ssThan @ A @ L @ M ) @ ( set_or7035219750837199246ssThan @ A @ M @ U ) )
              = ( set_or5935395276787703475ssThan @ A @ L @ U ) ) ) ) ) ).

% ivl_disj_un_two(1)
thf(fact_6519_ivl__disj__un__one_I1_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L: A,U: A] :
          ( ( ord_less @ A @ L @ U )
         => ( ( sup_sup @ ( set @ A ) @ ( set_ord_atMost @ A @ L ) @ ( set_or5935395276787703475ssThan @ A @ L @ U ) )
            = ( set_ord_lessThan @ A @ U ) ) ) ) ).

% ivl_disj_un_one(1)
thf(fact_6520_has__derivative__divide_H,axiom,
    ! [A: $tType,C: $tType] :
      ( ( ( real_V822414075346904944vector @ C )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [F2: C > A,F8: C > A,X2: C,S3: set @ C,G: C > A,G6: C > A] :
          ( ( has_derivative @ C @ A @ F2 @ F8 @ ( topolo174197925503356063within @ C @ X2 @ S3 ) )
         => ( ( has_derivative @ C @ A @ G @ G6 @ ( topolo174197925503356063within @ C @ X2 @ S3 ) )
           => ( ( ( G @ X2 )
               != ( zero_zero @ A ) )
             => ( has_derivative @ C @ A
                @ ^ [X5: C] : ( divide_divide @ A @ ( F2 @ X5 ) @ ( G @ X5 ) )
                @ ^ [H: C] : ( divide_divide @ A @ ( minus_minus @ A @ ( times_times @ A @ ( F8 @ H ) @ ( G @ X2 ) ) @ ( times_times @ A @ ( F2 @ X2 ) @ ( G6 @ H ) ) ) @ ( times_times @ A @ ( G @ X2 ) @ ( G @ X2 ) ) )
                @ ( topolo174197925503356063within @ C @ X2 @ S3 ) ) ) ) ) ) ).

% has_derivative_divide'
thf(fact_6521_has__derivative__inverse,axiom,
    ! [A: $tType,C: $tType] :
      ( ( ( real_V822414075346904944vector @ C )
        & ( real_V8999393235501362500lgebra @ A ) )
     => ! [F2: C > A,X2: C,F8: C > A,S3: set @ C] :
          ( ( ( F2 @ X2 )
           != ( zero_zero @ A ) )
         => ( ( has_derivative @ C @ A @ F2 @ F8 @ ( topolo174197925503356063within @ C @ X2 @ S3 ) )
           => ( has_derivative @ C @ A
              @ ^ [X5: C] : ( inverse_inverse @ A @ ( F2 @ X5 ) )
              @ ^ [H: C] : ( uminus_uminus @ A @ ( times_times @ A @ ( times_times @ A @ ( inverse_inverse @ A @ ( F2 @ X2 ) ) @ ( F8 @ H ) ) @ ( inverse_inverse @ A @ ( F2 @ X2 ) ) ) )
              @ ( topolo174197925503356063within @ C @ X2 @ S3 ) ) ) ) ) ).

% has_derivative_inverse
thf(fact_6522_has__derivative__inverse_H,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [X2: A,S3: set @ A] :
          ( ( X2
           != ( zero_zero @ A ) )
         => ( has_derivative @ A @ A @ ( inverse_inverse @ A )
            @ ^ [H: A] : ( uminus_uminus @ A @ ( times_times @ A @ ( times_times @ A @ ( inverse_inverse @ A @ X2 ) @ H ) @ ( inverse_inverse @ A @ X2 ) ) )
            @ ( topolo174197925503356063within @ A @ X2 @ S3 ) ) ) ) ).

% has_derivative_inverse'
thf(fact_6523_DERIV__compose__FDERIV,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: real > real,F8: real,G: A > real,X2: A,G6: A > real,S2: set @ A] :
          ( ( has_field_derivative @ real @ F2 @ F8 @ ( topolo174197925503356063within @ real @ ( G @ X2 ) @ ( top_top @ ( set @ real ) ) ) )
         => ( ( has_derivative @ A @ real @ G @ G6 @ ( topolo174197925503356063within @ A @ X2 @ S2 ) )
           => ( has_derivative @ A @ real
              @ ^ [X5: A] : ( F2 @ ( G @ X5 ) )
              @ ^ [X5: A] : ( times_times @ real @ ( G6 @ X5 ) @ F8 )
              @ ( topolo174197925503356063within @ A @ X2 @ S2 ) ) ) ) ) ).

% DERIV_compose_FDERIV
thf(fact_6524_has__derivative__cos,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [G: A > real,G6: A > real,X2: A,S2: set @ A] :
          ( ( has_derivative @ A @ real @ G @ G6 @ ( topolo174197925503356063within @ A @ X2 @ S2 ) )
         => ( has_derivative @ A @ real
            @ ^ [X5: A] : ( cos @ real @ ( G @ X5 ) )
            @ ^ [X5: A] : ( times_times @ real @ ( G6 @ X5 ) @ ( uminus_uminus @ real @ ( sin @ real @ ( G @ X2 ) ) ) )
            @ ( topolo174197925503356063within @ A @ X2 @ S2 ) ) ) ) ).

% has_derivative_cos
thf(fact_6525_DERIV__isconst3,axiom,
    ! [A2: real,B2: real,X2: real,Y2: real,F2: real > real] :
      ( ( ord_less @ real @ A2 @ B2 )
     => ( ( member @ real @ X2 @ ( set_or5935395276787703475ssThan @ real @ A2 @ B2 ) )
       => ( ( member @ real @ Y2 @ ( set_or5935395276787703475ssThan @ real @ A2 @ B2 ) )
         => ( ! [X3: real] :
                ( ( member @ real @ X3 @ ( set_or5935395276787703475ssThan @ real @ A2 @ B2 ) )
               => ( has_field_derivative @ real @ F2 @ ( zero_zero @ real ) @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) ) )
           => ( ( F2 @ X2 )
              = ( F2 @ Y2 ) ) ) ) ) ) ).

% DERIV_isconst3
thf(fact_6526_ivl__disj__un__two_I4_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L: A,M: A,U: A] :
          ( ( ord_less_eq @ A @ L @ M )
         => ( ( ord_less @ A @ M @ U )
           => ( ( sup_sup @ ( set @ A ) @ ( set_or1337092689740270186AtMost @ A @ L @ M ) @ ( set_or5935395276787703475ssThan @ A @ M @ U ) )
              = ( set_or7035219750837199246ssThan @ A @ L @ U ) ) ) ) ) ).

% ivl_disj_un_two(4)
thf(fact_6527_ivl__disj__un__singleton_I3_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L: A,U: A] :
          ( ( ord_less @ A @ L @ U )
         => ( ( sup_sup @ ( set @ A ) @ ( insert @ A @ L @ ( bot_bot @ ( set @ A ) ) ) @ ( set_or5935395276787703475ssThan @ A @ L @ U ) )
            = ( set_or7035219750837199246ssThan @ A @ L @ U ) ) ) ) ).

% ivl_disj_un_singleton(3)
thf(fact_6528_has__derivative__power,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V3459762299906320749_field @ B ) )
     => ! [F2: A > B,F8: A > B,X2: A,S3: set @ A,N2: nat] :
          ( ( has_derivative @ A @ B @ F2 @ F8 @ ( topolo174197925503356063within @ A @ X2 @ S3 ) )
         => ( has_derivative @ A @ B
            @ ^ [X5: A] : ( power_power @ B @ ( F2 @ X5 ) @ N2 )
            @ ^ [Y5: A] : ( times_times @ B @ ( times_times @ B @ ( semiring_1_of_nat @ B @ N2 ) @ ( F8 @ Y5 ) ) @ ( power_power @ B @ ( F2 @ X2 ) @ ( minus_minus @ nat @ N2 @ ( one_one @ nat ) ) ) )
            @ ( topolo174197925503356063within @ A @ X2 @ S3 ) ) ) ) ).

% has_derivative_power
thf(fact_6529_has__derivative__ln,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [G: A > real,X2: A,G6: A > real,S2: set @ A] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ ( G @ X2 ) )
         => ( ( has_derivative @ A @ real @ G @ G6 @ ( topolo174197925503356063within @ A @ X2 @ S2 ) )
           => ( has_derivative @ A @ real
              @ ^ [X5: A] : ( ln_ln @ real @ ( G @ X5 ) )
              @ ^ [X5: A] : ( times_times @ real @ ( G6 @ X5 ) @ ( inverse_inverse @ real @ ( G @ X2 ) ) )
              @ ( topolo174197925503356063within @ A @ X2 @ S2 ) ) ) ) ) ).

% has_derivative_ln
thf(fact_6530_has__derivative__divide,axiom,
    ! [A: $tType,C: $tType] :
      ( ( ( real_V822414075346904944vector @ C )
        & ( real_V8999393235501362500lgebra @ A ) )
     => ! [F2: C > A,F8: C > A,X2: C,S3: set @ C,G: C > A,G6: C > A] :
          ( ( has_derivative @ C @ A @ F2 @ F8 @ ( topolo174197925503356063within @ C @ X2 @ S3 ) )
         => ( ( has_derivative @ C @ A @ G @ G6 @ ( topolo174197925503356063within @ C @ X2 @ S3 ) )
           => ( ( ( G @ X2 )
               != ( zero_zero @ A ) )
             => ( has_derivative @ C @ A
                @ ^ [X5: C] : ( divide_divide @ A @ ( F2 @ X5 ) @ ( G @ X5 ) )
                @ ^ [H: C] : ( plus_plus @ A @ ( times_times @ A @ ( uminus_uminus @ A @ ( F2 @ X2 ) ) @ ( times_times @ A @ ( times_times @ A @ ( inverse_inverse @ A @ ( G @ X2 ) ) @ ( G6 @ H ) ) @ ( inverse_inverse @ A @ ( G @ X2 ) ) ) ) @ ( divide_divide @ A @ ( F8 @ H ) @ ( G @ X2 ) ) )
                @ ( topolo174197925503356063within @ C @ X2 @ S3 ) ) ) ) ) ) ).

% has_derivative_divide
thf(fact_6531_has__derivative__prod,axiom,
    ! [B: $tType,I7: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V3459762299906320749_field @ B ) )
     => ! [I6: set @ I7,F2: I7 > A > B,F8: I7 > A > B,X2: A,S3: set @ A] :
          ( ! [I2: I7] :
              ( ( member @ I7 @ I2 @ I6 )
             => ( has_derivative @ A @ B @ ( F2 @ I2 ) @ ( F8 @ I2 ) @ ( topolo174197925503356063within @ A @ X2 @ S3 ) ) )
         => ( has_derivative @ A @ B
            @ ^ [X5: A] :
                ( groups7121269368397514597t_prod @ I7 @ B
                @ ^ [I4: I7] : ( F2 @ I4 @ X5 )
                @ I6 )
            @ ^ [Y5: A] :
                ( groups7311177749621191930dd_sum @ I7 @ B
                @ ^ [I4: I7] :
                    ( times_times @ B @ ( F8 @ I4 @ Y5 )
                    @ ( groups7121269368397514597t_prod @ I7 @ B
                      @ ^ [J3: I7] : ( F2 @ J3 @ X2 )
                      @ ( minus_minus @ ( set @ I7 ) @ I6 @ ( insert @ I7 @ I4 @ ( bot_bot @ ( set @ I7 ) ) ) ) ) )
                @ I6 )
            @ ( topolo174197925503356063within @ A @ X2 @ S3 ) ) ) ) ).

% has_derivative_prod
thf(fact_6532_has__derivative__powr,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [G: A > real,G6: A > real,X2: A,X8: set @ A,F2: A > real,F8: A > real] :
          ( ( has_derivative @ A @ real @ G @ G6 @ ( topolo174197925503356063within @ A @ X2 @ X8 ) )
         => ( ( has_derivative @ A @ real @ F2 @ F8 @ ( topolo174197925503356063within @ A @ X2 @ X8 ) )
           => ( ( ord_less @ real @ ( zero_zero @ real ) @ ( G @ X2 ) )
             => ( ( member @ A @ X2 @ X8 )
               => ( has_derivative @ A @ real
                  @ ^ [X5: A] : ( powr @ real @ ( G @ X5 ) @ ( F2 @ X5 ) )
                  @ ^ [H: A] : ( times_times @ real @ ( powr @ real @ ( G @ X2 ) @ ( F2 @ X2 ) ) @ ( plus_plus @ real @ ( times_times @ real @ ( F8 @ H ) @ ( ln_ln @ real @ ( G @ X2 ) ) ) @ ( divide_divide @ real @ ( times_times @ real @ ( G6 @ H ) @ ( F2 @ X2 ) ) @ ( G @ X2 ) ) ) )
                  @ ( topolo174197925503356063within @ A @ X2 @ X8 ) ) ) ) ) ) ) ).

% has_derivative_powr
thf(fact_6533_has__derivative__real__sqrt,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [G: A > real,X2: A,G6: A > real,S2: set @ A] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ ( G @ X2 ) )
         => ( ( has_derivative @ A @ real @ G @ G6 @ ( topolo174197925503356063within @ A @ X2 @ S2 ) )
           => ( has_derivative @ A @ real
              @ ^ [X5: A] : ( sqrt @ ( G @ X5 ) )
              @ ^ [X5: A] : ( times_times @ real @ ( G6 @ X5 ) @ ( divide_divide @ real @ ( inverse_inverse @ real @ ( sqrt @ ( G @ X2 ) ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
              @ ( topolo174197925503356063within @ A @ X2 @ S2 ) ) ) ) ) ).

% has_derivative_real_sqrt
thf(fact_6534_has__derivative__arctan,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [G: A > real,G6: A > real,X2: A,S2: set @ A] :
          ( ( has_derivative @ A @ real @ G @ G6 @ ( topolo174197925503356063within @ A @ X2 @ S2 ) )
         => ( has_derivative @ A @ real
            @ ^ [X5: A] : ( arctan @ ( G @ X5 ) )
            @ ^ [X5: A] : ( times_times @ real @ ( G6 @ X5 ) @ ( inverse_inverse @ real @ ( plus_plus @ real @ ( one_one @ real ) @ ( power_power @ real @ ( G @ X2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
            @ ( topolo174197925503356063within @ A @ X2 @ S2 ) ) ) ) ).

% has_derivative_arctan
thf(fact_6535_has__derivative__tan,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [G: A > real,X2: A,G6: A > real,S2: set @ A] :
          ( ( ( cos @ real @ ( G @ X2 ) )
           != ( zero_zero @ real ) )
         => ( ( has_derivative @ A @ real @ G @ G6 @ ( topolo174197925503356063within @ A @ X2 @ S2 ) )
           => ( has_derivative @ A @ real
              @ ^ [X5: A] : ( tan @ real @ ( G @ X5 ) )
              @ ^ [X5: A] : ( times_times @ real @ ( G6 @ X5 ) @ ( inverse_inverse @ real @ ( power_power @ real @ ( cos @ real @ ( G @ X2 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
              @ ( topolo174197925503356063within @ A @ X2 @ S2 ) ) ) ) ) ).

% has_derivative_tan
thf(fact_6536_DERIV__series_H,axiom,
    ! [F2: real > nat > real,F8: real > nat > real,X0: real,A2: real,B2: real,L5: nat > real] :
      ( ! [N: nat] :
          ( has_field_derivative @ real
          @ ^ [X5: real] : ( F2 @ X5 @ N )
          @ ( F8 @ X0 @ N )
          @ ( topolo174197925503356063within @ real @ X0 @ ( top_top @ ( set @ real ) ) ) )
     => ( ! [X3: real] :
            ( ( member @ real @ X3 @ ( set_or5935395276787703475ssThan @ real @ A2 @ B2 ) )
           => ( summable @ real @ ( F2 @ X3 ) ) )
       => ( ( member @ real @ X0 @ ( set_or5935395276787703475ssThan @ real @ A2 @ B2 ) )
         => ( ( summable @ real @ ( F8 @ X0 ) )
           => ( ( summable @ real @ L5 )
             => ( ! [N: nat,X3: real,Y4: real] :
                    ( ( member @ real @ X3 @ ( set_or5935395276787703475ssThan @ real @ A2 @ B2 ) )
                   => ( ( member @ real @ Y4 @ ( set_or5935395276787703475ssThan @ real @ A2 @ B2 ) )
                     => ( ord_less_eq @ real @ ( abs_abs @ real @ ( minus_minus @ real @ ( F2 @ X3 @ N ) @ ( F2 @ Y4 @ N ) ) ) @ ( times_times @ real @ ( L5 @ N ) @ ( abs_abs @ real @ ( minus_minus @ real @ X3 @ Y4 ) ) ) ) ) )
               => ( has_field_derivative @ real
                  @ ^ [X5: real] : ( suminf @ real @ ( F2 @ X5 ) )
                  @ ( suminf @ real @ ( F8 @ X0 ) )
                  @ ( topolo174197925503356063within @ real @ X0 @ ( top_top @ ( set @ real ) ) ) ) ) ) ) ) ) ) ).

% DERIV_series'
thf(fact_6537_has__derivative__arccos,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [G: A > real,X2: A,G6: A > real,S2: set @ A] :
          ( ( ord_less @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ ( G @ X2 ) )
         => ( ( ord_less @ real @ ( G @ X2 ) @ ( one_one @ real ) )
           => ( ( has_derivative @ A @ real @ G @ G6 @ ( topolo174197925503356063within @ A @ X2 @ S2 ) )
             => ( has_derivative @ A @ real
                @ ^ [X5: A] : ( arccos @ ( G @ X5 ) )
                @ ^ [X5: A] : ( times_times @ real @ ( G6 @ X5 ) @ ( inverse_inverse @ real @ ( uminus_uminus @ real @ ( sqrt @ ( minus_minus @ real @ ( one_one @ real ) @ ( power_power @ real @ ( G @ X2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) )
                @ ( topolo174197925503356063within @ A @ X2 @ S2 ) ) ) ) ) ) ).

% has_derivative_arccos
thf(fact_6538_take__bit__numeral__minus__numeral__int,axiom,
    ! [M: num,N2: num] :
      ( ( bit_se2584673776208193580ke_bit @ int @ ( numeral_numeral @ nat @ M ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N2 ) ) )
      = ( case_option @ int @ num @ ( zero_zero @ int )
        @ ^ [Q4: num] : ( bit_se2584673776208193580ke_bit @ int @ ( numeral_numeral @ nat @ M ) @ ( minus_minus @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( numeral_numeral @ nat @ M ) ) @ ( numeral_numeral @ int @ Q4 ) ) )
        @ ( bit_take_bit_num @ ( numeral_numeral @ nat @ M ) @ N2 ) ) ) ).

% take_bit_numeral_minus_numeral_int
thf(fact_6539_and__minus__numerals_I7_J,axiom,
    ! [N2: num,M: num] :
      ( ( bit_se5824344872417868541ns_and @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit0 @ N2 ) ) ) @ ( numeral_numeral @ int @ M ) )
      = ( case_option @ int @ num @ ( zero_zero @ int ) @ ( numeral_numeral @ int ) @ ( bit_and_not_num @ M @ ( bitM @ N2 ) ) ) ) ).

% and_minus_numerals(7)
thf(fact_6540_take__bit__num__simps_I1_J,axiom,
    ! [M: num] :
      ( ( bit_take_bit_num @ ( zero_zero @ nat ) @ M )
      = ( none @ num ) ) ).

% take_bit_num_simps(1)
thf(fact_6541_take__bit__num__simps_I2_J,axiom,
    ! [N2: nat] :
      ( ( bit_take_bit_num @ ( suc @ N2 ) @ one2 )
      = ( some @ num @ one2 ) ) ).

% take_bit_num_simps(2)
thf(fact_6542_take__bit__num__simps_I5_J,axiom,
    ! [R3: num] :
      ( ( bit_take_bit_num @ ( numeral_numeral @ nat @ R3 ) @ one2 )
      = ( some @ num @ one2 ) ) ).

% take_bit_num_simps(5)
thf(fact_6543_card__greaterThanLessThan,axiom,
    ! [L: nat,U: nat] :
      ( ( finite_card @ nat @ ( set_or5935395276787703475ssThan @ nat @ L @ U ) )
      = ( minus_minus @ nat @ U @ ( suc @ L ) ) ) ).

% card_greaterThanLessThan
thf(fact_6544_take__bit__num__simps_I3_J,axiom,
    ! [N2: nat,M: num] :
      ( ( bit_take_bit_num @ ( suc @ N2 ) @ ( bit0 @ M ) )
      = ( case_option @ ( option @ num ) @ num @ ( none @ num )
        @ ^ [Q4: num] : ( some @ num @ ( bit0 @ Q4 ) )
        @ ( bit_take_bit_num @ N2 @ M ) ) ) ).

% take_bit_num_simps(3)
thf(fact_6545_take__bit__num__simps_I4_J,axiom,
    ! [N2: nat,M: num] :
      ( ( bit_take_bit_num @ ( suc @ N2 ) @ ( bit1 @ M ) )
      = ( some @ num @ ( case_option @ num @ num @ one2 @ bit1 @ ( bit_take_bit_num @ N2 @ M ) ) ) ) ).

% take_bit_num_simps(4)
thf(fact_6546_take__bit__num__simps_I6_J,axiom,
    ! [R3: num,M: num] :
      ( ( bit_take_bit_num @ ( numeral_numeral @ nat @ R3 ) @ ( bit0 @ M ) )
      = ( case_option @ ( option @ num ) @ num @ ( none @ num )
        @ ^ [Q4: num] : ( some @ num @ ( bit0 @ Q4 ) )
        @ ( bit_take_bit_num @ ( pred_numeral @ R3 ) @ M ) ) ) ).

% take_bit_num_simps(6)
thf(fact_6547_take__bit__num__simps_I7_J,axiom,
    ! [R3: num,M: num] :
      ( ( bit_take_bit_num @ ( numeral_numeral @ nat @ R3 ) @ ( bit1 @ M ) )
      = ( some @ num @ ( case_option @ num @ num @ one2 @ bit1 @ ( bit_take_bit_num @ ( pred_numeral @ R3 ) @ M ) ) ) ) ).

% take_bit_num_simps(7)
thf(fact_6548_take__bit__numeral__numeral,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M: num,N2: num] :
          ( ( bit_se2584673776208193580ke_bit @ A @ ( numeral_numeral @ nat @ M ) @ ( numeral_numeral @ A @ N2 ) )
          = ( case_option @ A @ num @ ( zero_zero @ A ) @ ( numeral_numeral @ A ) @ ( bit_take_bit_num @ ( numeral_numeral @ nat @ M ) @ N2 ) ) ) ) ).

% take_bit_numeral_numeral
thf(fact_6549_and__minus__numerals_I4_J,axiom,
    ! [M: num,N2: num] :
      ( ( bit_se5824344872417868541ns_and @ int @ ( numeral_numeral @ int @ M ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit1 @ N2 ) ) ) )
      = ( case_option @ int @ num @ ( zero_zero @ int ) @ ( numeral_numeral @ int ) @ ( bit_and_not_num @ M @ ( bit0 @ N2 ) ) ) ) ).

% and_minus_numerals(4)
thf(fact_6550_and__minus__numerals_I8_J,axiom,
    ! [N2: num,M: num] :
      ( ( bit_se5824344872417868541ns_and @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit1 @ N2 ) ) ) @ ( numeral_numeral @ int @ M ) )
      = ( case_option @ int @ num @ ( zero_zero @ int ) @ ( numeral_numeral @ int ) @ ( bit_and_not_num @ M @ ( bit0 @ N2 ) ) ) ) ).

% and_minus_numerals(8)
thf(fact_6551_and__minus__numerals_I3_J,axiom,
    ! [M: num,N2: num] :
      ( ( bit_se5824344872417868541ns_and @ int @ ( numeral_numeral @ int @ M ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit0 @ N2 ) ) ) )
      = ( case_option @ int @ num @ ( zero_zero @ int ) @ ( numeral_numeral @ int ) @ ( bit_and_not_num @ M @ ( bitM @ N2 ) ) ) ) ).

% and_minus_numerals(3)
thf(fact_6552_Code__Abstract__Nat_Otake__bit__num__code_I2_J,axiom,
    ! [N2: nat,M: num] :
      ( ( bit_take_bit_num @ N2 @ ( bit0 @ M ) )
      = ( case_nat @ ( option @ num ) @ ( none @ num )
        @ ^ [N3: nat] :
            ( case_option @ ( option @ num ) @ num @ ( none @ num )
            @ ^ [Q4: num] : ( some @ num @ ( bit0 @ Q4 ) )
            @ ( bit_take_bit_num @ N3 @ M ) )
        @ N2 ) ) ).

% Code_Abstract_Nat.take_bit_num_code(2)
thf(fact_6553_atLeastSucLessThan__greaterThanLessThan,axiom,
    ! [L: nat,U: nat] :
      ( ( set_or7035219750837199246ssThan @ nat @ ( suc @ L ) @ U )
      = ( set_or5935395276787703475ssThan @ nat @ L @ U ) ) ).

% atLeastSucLessThan_greaterThanLessThan
thf(fact_6554_and__not__num_Osimps_I2_J,axiom,
    ! [N2: num] :
      ( ( bit_and_not_num @ one2 @ ( bit0 @ N2 ) )
      = ( some @ num @ one2 ) ) ).

% and_not_num.simps(2)
thf(fact_6555_and__not__num_Osimps_I4_J,axiom,
    ! [M: num] :
      ( ( bit_and_not_num @ ( bit0 @ M ) @ one2 )
      = ( some @ num @ ( bit0 @ M ) ) ) ).

% and_not_num.simps(4)
thf(fact_6556_and__not__num_Osimps_I1_J,axiom,
    ( ( bit_and_not_num @ one2 @ one2 )
    = ( none @ num ) ) ).

% and_not_num.simps(1)
thf(fact_6557_Code__Abstract__Nat_Otake__bit__num__code_I1_J,axiom,
    ! [N2: nat] :
      ( ( bit_take_bit_num @ N2 @ one2 )
      = ( case_nat @ ( option @ num ) @ ( none @ num )
        @ ^ [N3: nat] : ( some @ num @ one2 )
        @ N2 ) ) ).

% Code_Abstract_Nat.take_bit_num_code(1)
thf(fact_6558_and__not__num_Osimps_I3_J,axiom,
    ! [N2: num] :
      ( ( bit_and_not_num @ one2 @ ( bit1 @ N2 ) )
      = ( none @ num ) ) ).

% and_not_num.simps(3)
thf(fact_6559_take__bit__num__eq__Some__imp,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M: nat,N2: num,Q3: num] :
          ( ( ( bit_take_bit_num @ M @ N2 )
            = ( some @ num @ Q3 ) )
         => ( ( bit_se2584673776208193580ke_bit @ A @ M @ ( numeral_numeral @ A @ N2 ) )
            = ( numeral_numeral @ A @ Q3 ) ) ) ) ).

% take_bit_num_eq_Some_imp
thf(fact_6560_Code__Abstract__Nat_Otake__bit__num__code_I3_J,axiom,
    ! [N2: nat,M: num] :
      ( ( bit_take_bit_num @ N2 @ ( bit1 @ M ) )
      = ( case_nat @ ( option @ num ) @ ( none @ num )
        @ ^ [N3: nat] : ( some @ num @ ( case_option @ num @ num @ one2 @ bit1 @ ( bit_take_bit_num @ N3 @ M ) ) )
        @ N2 ) ) ).

% Code_Abstract_Nat.take_bit_num_code(3)
thf(fact_6561_and__not__num_Osimps_I7_J,axiom,
    ! [M: num] :
      ( ( bit_and_not_num @ ( bit1 @ M ) @ one2 )
      = ( some @ num @ ( bit0 @ M ) ) ) ).

% and_not_num.simps(7)
thf(fact_6562_take__bit__num__eq__None__imp,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M: nat,N2: num] :
          ( ( ( bit_take_bit_num @ M @ N2 )
            = ( none @ num ) )
         => ( ( bit_se2584673776208193580ke_bit @ A @ M @ ( numeral_numeral @ A @ N2 ) )
            = ( zero_zero @ A ) ) ) ) ).

% take_bit_num_eq_None_imp
thf(fact_6563_and__not__num__eq__Some__iff,axiom,
    ! [M: num,N2: num,Q3: num] :
      ( ( ( bit_and_not_num @ M @ N2 )
        = ( some @ num @ Q3 ) )
      = ( ( bit_se5824344872417868541ns_and @ int @ ( numeral_numeral @ int @ M ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ N2 ) ) )
        = ( numeral_numeral @ int @ Q3 ) ) ) ).

% and_not_num_eq_Some_iff
thf(fact_6564_and__not__num_Osimps_I8_J,axiom,
    ! [M: num,N2: num] :
      ( ( bit_and_not_num @ ( bit1 @ M ) @ ( bit0 @ N2 ) )
      = ( case_option @ ( option @ num ) @ num @ ( some @ num @ one2 )
        @ ^ [N10: num] : ( some @ num @ ( bit1 @ N10 ) )
        @ ( bit_and_not_num @ M @ N2 ) ) ) ).

% and_not_num.simps(8)
thf(fact_6565_sorted__list__of__set__greaterThanLessThan,axiom,
    ! [I3: nat,J: nat] :
      ( ( ord_less @ nat @ ( suc @ I3 ) @ J )
     => ( ( linord4507533701916653071of_set @ nat @ ( set_or5935395276787703475ssThan @ nat @ I3 @ J ) )
        = ( cons @ nat @ ( suc @ I3 ) @ ( linord4507533701916653071of_set @ nat @ ( set_or5935395276787703475ssThan @ nat @ ( suc @ I3 ) @ J ) ) ) ) ) ).

% sorted_list_of_set_greaterThanLessThan
thf(fact_6566_and__not__num__eq__None__iff,axiom,
    ! [M: num,N2: num] :
      ( ( ( bit_and_not_num @ M @ N2 )
        = ( none @ num ) )
      = ( ( bit_se5824344872417868541ns_and @ int @ ( numeral_numeral @ int @ M ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ N2 ) ) )
        = ( zero_zero @ int ) ) ) ).

% and_not_num_eq_None_iff
thf(fact_6567_nth__sorted__list__of__set__greaterThanLessThan,axiom,
    ! [N2: nat,J: nat,I3: nat] :
      ( ( ord_less @ nat @ N2 @ ( minus_minus @ nat @ J @ ( suc @ I3 ) ) )
     => ( ( nth @ nat @ ( linord4507533701916653071of_set @ nat @ ( set_or5935395276787703475ssThan @ nat @ I3 @ J ) ) @ N2 )
        = ( suc @ ( plus_plus @ nat @ I3 @ N2 ) ) ) ) ).

% nth_sorted_list_of_set_greaterThanLessThan
thf(fact_6568_int__numeral__not__and__num,axiom,
    ! [M: num,N2: num] :
      ( ( bit_se5824344872417868541ns_and @ int @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ M ) ) @ ( numeral_numeral @ int @ N2 ) )
      = ( case_option @ int @ num @ ( zero_zero @ int ) @ ( numeral_numeral @ int ) @ ( bit_and_not_num @ N2 @ M ) ) ) ).

% int_numeral_not_and_num
thf(fact_6569_int__numeral__and__not__num,axiom,
    ! [M: num,N2: num] :
      ( ( bit_se5824344872417868541ns_and @ int @ ( numeral_numeral @ int @ M ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ N2 ) ) )
      = ( case_option @ int @ num @ ( zero_zero @ int ) @ ( numeral_numeral @ int ) @ ( bit_and_not_num @ M @ N2 ) ) ) ).

% int_numeral_and_not_num
thf(fact_6570_take__bit__num__def,axiom,
    ( bit_take_bit_num
    = ( ^ [N3: nat,M6: num] :
          ( if @ ( option @ num )
          @ ( ( bit_se2584673776208193580ke_bit @ nat @ N3 @ ( numeral_numeral @ nat @ M6 ) )
            = ( zero_zero @ nat ) )
          @ ( none @ num )
          @ ( some @ num @ ( num_of_nat @ ( bit_se2584673776208193580ke_bit @ nat @ N3 @ ( numeral_numeral @ nat @ M6 ) ) ) ) ) ) ) ).

% take_bit_num_def
thf(fact_6571_greaterThanLessThan__upto,axiom,
    ( ( set_or5935395276787703475ssThan @ int )
    = ( ^ [I4: int,J3: int] : ( set2 @ int @ ( upto @ ( plus_plus @ int @ I4 @ ( one_one @ int ) ) @ ( minus_minus @ int @ J3 @ ( one_one @ int ) ) ) ) ) ) ).

% greaterThanLessThan_upto
thf(fact_6572_has__derivative__floor,axiom,
    ! [Aa: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( archim2362893244070406136eiling @ Aa )
        & ( topolo2564578578187576103pology @ Aa ) )
     => ! [G: A > real,X2: A,F2: real > Aa,G6: A > real,S2: set @ A] :
          ( ( topolo3448309680560233919inuous @ real @ Aa @ ( topolo174197925503356063within @ real @ ( G @ X2 ) @ ( top_top @ ( set @ real ) ) ) @ F2 )
         => ( ~ ( member @ Aa @ ( F2 @ ( G @ X2 ) ) @ ( ring_1_Ints @ Aa ) )
           => ( ( has_derivative @ A @ real @ G @ G6 @ ( topolo174197925503356063within @ A @ X2 @ S2 ) )
             => ( has_derivative @ A @ real
                @ ^ [X5: A] : ( ring_1_of_int @ real @ ( archim6421214686448440834_floor @ Aa @ ( F2 @ ( G @ X5 ) ) ) )
                @ ^ [X5: A] : ( times_times @ real @ ( G6 @ X5 ) @ ( zero_zero @ real ) )
                @ ( topolo174197925503356063within @ A @ X2 @ S2 ) ) ) ) ) ) ).

% has_derivative_floor
thf(fact_6573_Bit__Operations_Otake__bit__num__code,axiom,
    ( bit_take_bit_num
    = ( ^ [N3: nat,M6: num] :
          ( product_case_prod @ nat @ num @ ( option @ num )
          @ ^ [A4: nat,X5: num] :
              ( case_nat @ ( option @ num ) @ ( none @ num )
              @ ^ [O: nat] :
                  ( case_num @ ( option @ num ) @ ( some @ num @ one2 )
                  @ ^ [P6: num] :
                      ( case_option @ ( option @ num ) @ num @ ( none @ num )
                      @ ^ [Q4: num] : ( some @ num @ ( bit0 @ Q4 ) )
                      @ ( bit_take_bit_num @ O @ P6 ) )
                  @ ^ [P6: num] : ( some @ num @ ( case_option @ num @ num @ one2 @ bit1 @ ( bit_take_bit_num @ O @ P6 ) ) )
                  @ X5 )
              @ A4 )
          @ ( product_Pair @ nat @ num @ N3 @ M6 ) ) ) ) ).

% Bit_Operations.take_bit_num_code
thf(fact_6574_verit__eq__simplify_I17_J,axiom,
    ! [A: $tType,F1: A,F22: num > A,F32: num > A,X22: num] :
      ( ( case_num @ A @ F1 @ F22 @ F32 @ ( bit0 @ X22 ) )
      = ( F22 @ X22 ) ) ).

% verit_eq_simplify(17)
thf(fact_6575_continuous__add,axiom,
    ! [B: $tType,D: $tType] :
      ( ( ( topological_t2_space @ D )
        & ( topolo6943815403480290642id_add @ B ) )
     => ! [F3: filter @ D,F2: D > B,G: D > B] :
          ( ( topolo3448309680560233919inuous @ D @ B @ F3 @ F2 )
         => ( ( topolo3448309680560233919inuous @ D @ B @ F3 @ G )
           => ( topolo3448309680560233919inuous @ D @ B @ F3
              @ ^ [X5: D] : ( plus_plus @ B @ ( F2 @ X5 ) @ ( G @ X5 ) ) ) ) ) ) ).

% continuous_add
thf(fact_6576_continuous__power,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topological_t2_space @ A )
        & ( power @ B )
        & ( real_V4412858255891104859lgebra @ B ) )
     => ! [F3: filter @ A,F2: A > B,N2: nat] :
          ( ( topolo3448309680560233919inuous @ A @ B @ F3 @ F2 )
         => ( topolo3448309680560233919inuous @ A @ B @ F3
            @ ^ [X5: A] : ( power_power @ B @ ( F2 @ X5 ) @ N2 ) ) ) ) ).

% continuous_power
thf(fact_6577_num_Ocase__distrib,axiom,
    ! [B: $tType,A: $tType,H2: A > B,F1: A,F22: num > A,F32: num > A,Num: num] :
      ( ( H2 @ ( case_num @ A @ F1 @ F22 @ F32 @ Num ) )
      = ( case_num @ B @ ( H2 @ F1 )
        @ ^ [X5: num] : ( H2 @ ( F22 @ X5 ) )
        @ ^ [X5: num] : ( H2 @ ( F32 @ X5 ) )
        @ Num ) ) ).

% num.case_distrib
thf(fact_6578_continuous__power_H,axiom,
    ! [B: $tType,C: $tType] :
      ( ( ( topological_t2_space @ C )
        & ( topolo1898628316856586783d_mult @ B ) )
     => ! [F3: filter @ C,F2: C > B,G: C > nat] :
          ( ( topolo3448309680560233919inuous @ C @ B @ F3 @ F2 )
         => ( ( topolo3448309680560233919inuous @ C @ nat @ F3 @ G )
           => ( topolo3448309680560233919inuous @ C @ B @ F3
              @ ^ [X5: C] : ( power_power @ B @ ( F2 @ X5 ) @ ( G @ X5 ) ) ) ) ) ) ).

% continuous_power'
thf(fact_6579_continuous__mult__right,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( topological_t2_space @ B )
        & ( real_V4412858255891104859lgebra @ A ) )
     => ! [F3: filter @ B,F2: B > A,C2: A] :
          ( ( topolo3448309680560233919inuous @ B @ A @ F3 @ F2 )
         => ( topolo3448309680560233919inuous @ B @ A @ F3
            @ ^ [X5: B] : ( times_times @ A @ ( F2 @ X5 ) @ C2 ) ) ) ) ).

% continuous_mult_right
thf(fact_6580_continuous__mult__left,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( topological_t2_space @ B )
        & ( real_V4412858255891104859lgebra @ A ) )
     => ! [F3: filter @ B,F2: B > A,C2: A] :
          ( ( topolo3448309680560233919inuous @ B @ A @ F3 @ F2 )
         => ( topolo3448309680560233919inuous @ B @ A @ F3
            @ ^ [X5: B] : ( times_times @ A @ C2 @ ( F2 @ X5 ) ) ) ) ) ).

% continuous_mult_left
thf(fact_6581_continuous__mult_H,axiom,
    ! [B: $tType,D: $tType] :
      ( ( ( topological_t2_space @ D )
        & ( topolo4211221413907600880p_mult @ B ) )
     => ! [F3: filter @ D,F2: D > B,G: D > B] :
          ( ( topolo3448309680560233919inuous @ D @ B @ F3 @ F2 )
         => ( ( topolo3448309680560233919inuous @ D @ B @ F3 @ G )
           => ( topolo3448309680560233919inuous @ D @ B @ F3
              @ ^ [X5: D] : ( times_times @ B @ ( F2 @ X5 ) @ ( G @ X5 ) ) ) ) ) ) ).

% continuous_mult'
thf(fact_6582_continuous__mult,axiom,
    ! [A: $tType,D: $tType] :
      ( ( ( topological_t2_space @ D )
        & ( real_V4412858255891104859lgebra @ A ) )
     => ! [F3: filter @ D,F2: D > A,G: D > A] :
          ( ( topolo3448309680560233919inuous @ D @ A @ F3 @ F2 )
         => ( ( topolo3448309680560233919inuous @ D @ A @ F3 @ G )
           => ( topolo3448309680560233919inuous @ D @ A @ F3
              @ ^ [X5: D] : ( times_times @ A @ ( F2 @ X5 ) @ ( G @ X5 ) ) ) ) ) ) ).

% continuous_mult
thf(fact_6583_verit__eq__simplify_I16_J,axiom,
    ! [A: $tType,F1: A,F22: num > A,F32: num > A] :
      ( ( case_num @ A @ F1 @ F22 @ F32 @ one2 )
      = F1 ) ).

% verit_eq_simplify(16)
thf(fact_6584_continuous__Pair,axiom,
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( ( topological_t2_space @ A )
        & ( topolo4958980785337419405_space @ B )
        & ( topolo4958980785337419405_space @ C ) )
     => ! [F3: filter @ A,F2: A > B,G: A > C] :
          ( ( topolo3448309680560233919inuous @ A @ B @ F3 @ F2 )
         => ( ( topolo3448309680560233919inuous @ A @ C @ F3 @ G )
           => ( topolo3448309680560233919inuous @ A @ ( product_prod @ B @ C ) @ F3
              @ ^ [X5: A] : ( product_Pair @ B @ C @ ( F2 @ X5 ) @ ( G @ X5 ) ) ) ) ) ) ).

% continuous_Pair
thf(fact_6585_isCont__Pair,axiom,
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( ( topological_t2_space @ A )
        & ( topolo4958980785337419405_space @ B )
        & ( topolo4958980785337419405_space @ C ) )
     => ! [A2: A,F2: A > B,G: A > C] :
          ( ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) @ F2 )
         => ( ( topolo3448309680560233919inuous @ A @ C @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) @ G )
           => ( topolo3448309680560233919inuous @ A @ ( product_prod @ B @ C ) @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) )
              @ ^ [X5: A] : ( product_Pair @ B @ C @ ( F2 @ X5 ) @ ( G @ X5 ) ) ) ) ) ) ).

% isCont_Pair
thf(fact_6586_IVT2,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( topolo1944317154257567458pology @ B )
        & ( topolo8458572112393995274pology @ A ) )
     => ! [F2: A > B,B2: A,Y2: B,A2: A] :
          ( ( ord_less_eq @ B @ ( F2 @ B2 ) @ Y2 )
         => ( ( ord_less_eq @ B @ Y2 @ ( F2 @ A2 ) )
           => ( ( ord_less_eq @ A @ A2 @ B2 )
             => ( ! [X3: A] :
                    ( ( ( ord_less_eq @ A @ A2 @ X3 )
                      & ( ord_less_eq @ A @ X3 @ B2 ) )
                   => ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ X3 @ ( top_top @ ( set @ A ) ) ) @ F2 ) )
               => ? [X3: A] :
                    ( ( ord_less_eq @ A @ A2 @ X3 )
                    & ( ord_less_eq @ A @ X3 @ B2 )
                    & ( ( F2 @ X3 )
                      = Y2 ) ) ) ) ) ) ) ).

% IVT2
thf(fact_6587_IVT,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( topolo1944317154257567458pology @ B )
        & ( topolo8458572112393995274pology @ A ) )
     => ! [F2: A > B,A2: A,Y2: B,B2: A] :
          ( ( ord_less_eq @ B @ ( F2 @ A2 ) @ Y2 )
         => ( ( ord_less_eq @ B @ Y2 @ ( F2 @ B2 ) )
           => ( ( ord_less_eq @ A @ A2 @ B2 )
             => ( ! [X3: A] :
                    ( ( ( ord_less_eq @ A @ A2 @ X3 )
                      & ( ord_less_eq @ A @ X3 @ B2 ) )
                   => ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ X3 @ ( top_top @ ( set @ A ) ) ) @ F2 ) )
               => ? [X3: A] :
                    ( ( ord_less_eq @ A @ A2 @ X3 )
                    & ( ord_less_eq @ A @ X3 @ B2 )
                    & ( ( F2 @ X3 )
                      = Y2 ) ) ) ) ) ) ) ).

% IVT
thf(fact_6588_isCont__Lb__Ub,axiom,
    ! [A2: real,B2: real,F2: real > real] :
      ( ( ord_less_eq @ real @ A2 @ B2 )
     => ( ! [X3: real] :
            ( ( ( ord_less_eq @ real @ A2 @ X3 )
              & ( ord_less_eq @ real @ X3 @ B2 ) )
           => ( topolo3448309680560233919inuous @ real @ real @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) @ F2 ) )
       => ? [L6: real,M8: real] :
            ( ! [X: real] :
                ( ( ( ord_less_eq @ real @ A2 @ X )
                  & ( ord_less_eq @ real @ X @ B2 ) )
               => ( ( ord_less_eq @ real @ L6 @ ( F2 @ X ) )
                  & ( ord_less_eq @ real @ ( F2 @ X ) @ M8 ) ) )
            & ! [Y: real] :
                ( ( ( ord_less_eq @ real @ L6 @ Y )
                  & ( ord_less_eq @ real @ Y @ M8 ) )
               => ? [X3: real] :
                    ( ( ord_less_eq @ real @ A2 @ X3 )
                    & ( ord_less_eq @ real @ X3 @ B2 )
                    & ( ( F2 @ X3 )
                      = Y ) ) ) ) ) ) ).

% isCont_Lb_Ub
thf(fact_6589_continuous__at__within__divide,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topological_t2_space @ A )
        & ( real_V3459762299906320749_field @ B ) )
     => ! [A2: A,S2: set @ A,F2: A > B,G: A > B] :
          ( ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ S2 ) @ F2 )
         => ( ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ S2 ) @ G )
           => ( ( ( G @ A2 )
               != ( zero_zero @ B ) )
             => ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ S2 )
                @ ^ [X5: A] : ( divide_divide @ B @ ( F2 @ X5 ) @ ( G @ X5 ) ) ) ) ) ) ) ).

% continuous_at_within_divide
thf(fact_6590_isCont__mult,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topological_t2_space @ A )
        & ( real_V4412858255891104859lgebra @ B ) )
     => ! [A2: A,F2: A > B,G: A > B] :
          ( ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) @ F2 )
         => ( ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) @ G )
           => ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) )
              @ ^ [X5: A] : ( times_times @ B @ ( F2 @ X5 ) @ ( G @ X5 ) ) ) ) ) ) ).

% isCont_mult
thf(fact_6591_isCont__add,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topological_t2_space @ A )
        & ( topolo6943815403480290642id_add @ B ) )
     => ! [A2: A,F2: A > B,G: A > B] :
          ( ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) @ F2 )
         => ( ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) @ G )
           => ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) )
              @ ^ [X5: A] : ( plus_plus @ B @ ( F2 @ X5 ) @ ( G @ X5 ) ) ) ) ) ) ).

% isCont_add
thf(fact_6592_isCont__power,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topological_t2_space @ A )
        & ( power @ B )
        & ( real_V4412858255891104859lgebra @ B ) )
     => ! [A2: A,F2: A > B,N2: nat] :
          ( ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) @ F2 )
         => ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) )
            @ ^ [X5: A] : ( power_power @ B @ ( F2 @ X5 ) @ N2 ) ) ) ) ).

% isCont_power
thf(fact_6593_continuous__at__within__inverse,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topological_t2_space @ A )
        & ( real_V8999393235501362500lgebra @ B ) )
     => ! [A2: A,S2: set @ A,F2: A > B] :
          ( ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ S2 ) @ F2 )
         => ( ( ( F2 @ A2 )
             != ( zero_zero @ B ) )
           => ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ S2 )
              @ ^ [X5: A] : ( inverse_inverse @ B @ ( F2 @ X5 ) ) ) ) ) ) ).

% continuous_at_within_inverse
thf(fact_6594_continuous__at__within__sgn,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topological_t2_space @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [A2: A,S2: set @ A,F2: A > B] :
          ( ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ S2 ) @ F2 )
         => ( ( ( F2 @ A2 )
             != ( zero_zero @ B ) )
           => ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ S2 )
              @ ^ [X5: A] : ( sgn_sgn @ B @ ( F2 @ X5 ) ) ) ) ) ) ).

% continuous_at_within_sgn
thf(fact_6595_isCont__eq__Lb,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [A2: real,B2: real,F2: real > A] :
          ( ( ord_less_eq @ real @ A2 @ B2 )
         => ( ! [X3: real] :
                ( ( ( ord_less_eq @ real @ A2 @ X3 )
                  & ( ord_less_eq @ real @ X3 @ B2 ) )
               => ( topolo3448309680560233919inuous @ real @ A @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) @ F2 ) )
           => ? [M8: A] :
                ( ! [X: real] :
                    ( ( ( ord_less_eq @ real @ A2 @ X )
                      & ( ord_less_eq @ real @ X @ B2 ) )
                   => ( ord_less_eq @ A @ M8 @ ( F2 @ X ) ) )
                & ? [X3: real] :
                    ( ( ord_less_eq @ real @ A2 @ X3 )
                    & ( ord_less_eq @ real @ X3 @ B2 )
                    & ( ( F2 @ X3 )
                      = M8 ) ) ) ) ) ) ).

% isCont_eq_Lb
thf(fact_6596_isCont__eq__Ub,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [A2: real,B2: real,F2: real > A] :
          ( ( ord_less_eq @ real @ A2 @ B2 )
         => ( ! [X3: real] :
                ( ( ( ord_less_eq @ real @ A2 @ X3 )
                  & ( ord_less_eq @ real @ X3 @ B2 ) )
               => ( topolo3448309680560233919inuous @ real @ A @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) @ F2 ) )
           => ? [M8: A] :
                ( ! [X: real] :
                    ( ( ( ord_less_eq @ real @ A2 @ X )
                      & ( ord_less_eq @ real @ X @ B2 ) )
                   => ( ord_less_eq @ A @ ( F2 @ X ) @ M8 ) )
                & ? [X3: real] :
                    ( ( ord_less_eq @ real @ A2 @ X3 )
                    & ( ord_less_eq @ real @ X3 @ B2 )
                    & ( ( F2 @ X3 )
                      = M8 ) ) ) ) ) ) ).

% isCont_eq_Ub
thf(fact_6597_isCont__bounded,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [A2: real,B2: real,F2: real > A] :
          ( ( ord_less_eq @ real @ A2 @ B2 )
         => ( ! [X3: real] :
                ( ( ( ord_less_eq @ real @ A2 @ X3 )
                  & ( ord_less_eq @ real @ X3 @ B2 ) )
               => ( topolo3448309680560233919inuous @ real @ A @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) @ F2 ) )
           => ? [M8: A] :
              ! [X: real] :
                ( ( ( ord_less_eq @ real @ A2 @ X )
                  & ( ord_less_eq @ real @ X @ B2 ) )
               => ( ord_less_eq @ A @ ( F2 @ X ) @ M8 ) ) ) ) ) ).

% isCont_bounded
thf(fact_6598_isCont__inverse__function2,axiom,
    ! [A2: real,X2: real,B2: real,G: real > real,F2: real > real] :
      ( ( ord_less @ real @ A2 @ X2 )
     => ( ( ord_less @ real @ X2 @ B2 )
       => ( ! [Z3: real] :
              ( ( ord_less_eq @ real @ A2 @ Z3 )
             => ( ( ord_less_eq @ real @ Z3 @ B2 )
               => ( ( G @ ( F2 @ Z3 ) )
                  = Z3 ) ) )
         => ( ! [Z3: real] :
                ( ( ord_less_eq @ real @ A2 @ Z3 )
               => ( ( ord_less_eq @ real @ Z3 @ B2 )
                 => ( topolo3448309680560233919inuous @ real @ real @ ( topolo174197925503356063within @ real @ Z3 @ ( top_top @ ( set @ real ) ) ) @ F2 ) ) )
           => ( topolo3448309680560233919inuous @ real @ real @ ( topolo174197925503356063within @ real @ ( F2 @ X2 ) @ ( top_top @ ( set @ real ) ) ) @ G ) ) ) ) ) ).

% isCont_inverse_function2
thf(fact_6599_isCont__ln,axiom,
    ! [X2: real] :
      ( ( X2
       != ( zero_zero @ real ) )
     => ( topolo3448309680560233919inuous @ real @ real @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) @ ( ln_ln @ real ) ) ) ).

% isCont_ln
thf(fact_6600_isCont__divide,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topological_t2_space @ A )
        & ( real_V3459762299906320749_field @ B ) )
     => ! [A2: A,F2: A > B,G: A > B] :
          ( ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) @ F2 )
         => ( ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) @ G )
           => ( ( ( G @ A2 )
               != ( zero_zero @ B ) )
             => ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) )
                @ ^ [X5: A] : ( divide_divide @ B @ ( F2 @ X5 ) @ ( G @ X5 ) ) ) ) ) ) ) ).

% isCont_divide
thf(fact_6601_isCont__sgn,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topological_t2_space @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [A2: A,F2: A > B] :
          ( ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) @ F2 )
         => ( ( ( F2 @ A2 )
             != ( zero_zero @ B ) )
           => ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) )
              @ ^ [X5: A] : ( sgn_sgn @ B @ ( F2 @ X5 ) ) ) ) ) ) ).

% isCont_sgn
thf(fact_6602_continuous__within__tan,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X2: A,S2: set @ A,F2: A > A] :
          ( ( topolo3448309680560233919inuous @ A @ A @ ( topolo174197925503356063within @ A @ X2 @ S2 ) @ F2 )
         => ( ( ( cos @ A @ ( F2 @ X2 ) )
             != ( zero_zero @ A ) )
           => ( topolo3448309680560233919inuous @ A @ A @ ( topolo174197925503356063within @ A @ X2 @ S2 )
              @ ^ [X5: A] : ( tan @ A @ ( F2 @ X5 ) ) ) ) ) ) ).

% continuous_within_tan
thf(fact_6603_continuous__within__cot,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X2: A,S2: set @ A,F2: A > A] :
          ( ( topolo3448309680560233919inuous @ A @ A @ ( topolo174197925503356063within @ A @ X2 @ S2 ) @ F2 )
         => ( ( ( sin @ A @ ( F2 @ X2 ) )
             != ( zero_zero @ A ) )
           => ( topolo3448309680560233919inuous @ A @ A @ ( topolo174197925503356063within @ A @ X2 @ S2 )
              @ ^ [X5: A] : ( cot @ A @ ( F2 @ X5 ) ) ) ) ) ) ).

% continuous_within_cot
thf(fact_6604_continuous__at__within__tanh,axiom,
    ! [A: $tType,C: $tType] :
      ( ( ( topological_t2_space @ C )
        & ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X2: C,A3: set @ C,F2: C > A] :
          ( ( topolo3448309680560233919inuous @ C @ A @ ( topolo174197925503356063within @ C @ X2 @ A3 ) @ F2 )
         => ( ( ( cosh @ A @ ( F2 @ X2 ) )
             != ( zero_zero @ A ) )
           => ( topolo3448309680560233919inuous @ C @ A @ ( topolo174197925503356063within @ C @ X2 @ A3 )
              @ ^ [X5: C] : ( tanh @ A @ ( F2 @ X5 ) ) ) ) ) ) ).

% continuous_at_within_tanh
thf(fact_6605_CARAT__DERIV,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,L: A,X2: A] :
          ( ( has_field_derivative @ A @ F2 @ L @ ( topolo174197925503356063within @ A @ X2 @ ( top_top @ ( set @ A ) ) ) )
          = ( ? [G4: A > A] :
                ( ! [Z6: A] :
                    ( ( minus_minus @ A @ ( F2 @ Z6 ) @ ( F2 @ X2 ) )
                    = ( times_times @ A @ ( G4 @ Z6 ) @ ( minus_minus @ A @ Z6 @ X2 ) ) )
                & ( topolo3448309680560233919inuous @ A @ A @ ( topolo174197925503356063within @ A @ X2 @ ( top_top @ ( set @ A ) ) ) @ G4 )
                & ( ( G4 @ X2 )
                  = L ) ) ) ) ) ).

% CARAT_DERIV
thf(fact_6606_isCont__has__Ub,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [A2: real,B2: real,F2: real > A] :
          ( ( ord_less_eq @ real @ A2 @ B2 )
         => ( ! [X3: real] :
                ( ( ( ord_less_eq @ real @ A2 @ X3 )
                  & ( ord_less_eq @ real @ X3 @ B2 ) )
               => ( topolo3448309680560233919inuous @ real @ A @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) @ F2 ) )
           => ? [M8: A] :
                ( ! [X: real] :
                    ( ( ( ord_less_eq @ real @ A2 @ X )
                      & ( ord_less_eq @ real @ X @ B2 ) )
                   => ( ord_less_eq @ A @ ( F2 @ X ) @ M8 ) )
                & ! [N7: A] :
                    ( ( ord_less @ A @ N7 @ M8 )
                   => ? [X3: real] :
                        ( ( ord_less_eq @ real @ A2 @ X3 )
                        & ( ord_less_eq @ real @ X3 @ B2 )
                        & ( ord_less @ A @ N7 @ ( F2 @ X3 ) ) ) ) ) ) ) ) ).

% isCont_has_Ub
thf(fact_6607_isCont__tan,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X2: A] :
          ( ( ( cos @ A @ X2 )
           != ( zero_zero @ A ) )
         => ( topolo3448309680560233919inuous @ A @ A @ ( topolo174197925503356063within @ A @ X2 @ ( top_top @ ( set @ A ) ) ) @ ( tan @ A ) ) ) ) ).

% isCont_tan
thf(fact_6608_isCont__cot,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X2: A] :
          ( ( ( sin @ A @ X2 )
           != ( zero_zero @ A ) )
         => ( topolo3448309680560233919inuous @ A @ A @ ( topolo174197925503356063within @ A @ X2 @ ( top_top @ ( set @ A ) ) ) @ ( cot @ A ) ) ) ) ).

% isCont_cot
thf(fact_6609_isCont__tanh,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X2: A] :
          ( ( ( cosh @ A @ X2 )
           != ( zero_zero @ A ) )
         => ( topolo3448309680560233919inuous @ A @ A @ ( topolo174197925503356063within @ A @ X2 @ ( top_top @ ( set @ A ) ) ) @ ( tanh @ A ) ) ) ) ).

% isCont_tanh
thf(fact_6610_isCont__tan_H,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [A2: A,F2: A > A] :
          ( ( topolo3448309680560233919inuous @ A @ A @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) @ F2 )
         => ( ( ( cos @ A @ ( F2 @ A2 ) )
             != ( zero_zero @ A ) )
           => ( topolo3448309680560233919inuous @ A @ A @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) )
              @ ^ [X5: A] : ( tan @ A @ ( F2 @ X5 ) ) ) ) ) ) ).

% isCont_tan'
thf(fact_6611_isCont__arcosh,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ X2 )
     => ( topolo3448309680560233919inuous @ real @ real @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) @ ( arcosh @ real ) ) ) ).

% isCont_arcosh
thf(fact_6612_isCont__cot_H,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [A2: A,F2: A > A] :
          ( ( topolo3448309680560233919inuous @ A @ A @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) @ F2 )
         => ( ( ( sin @ A @ ( F2 @ A2 ) )
             != ( zero_zero @ A ) )
           => ( topolo3448309680560233919inuous @ A @ A @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) )
              @ ^ [X5: A] : ( cot @ A @ ( F2 @ X5 ) ) ) ) ) ) ).

% isCont_cot'
thf(fact_6613_DERIV__inverse__function,axiom,
    ! [F2: real > real,D5: real,G: real > real,X2: real,A2: real,B2: real] :
      ( ( has_field_derivative @ real @ F2 @ D5 @ ( topolo174197925503356063within @ real @ ( G @ X2 ) @ ( top_top @ ( set @ real ) ) ) )
     => ( ( D5
         != ( zero_zero @ real ) )
       => ( ( ord_less @ real @ A2 @ X2 )
         => ( ( ord_less @ real @ X2 @ B2 )
           => ( ! [Y4: real] :
                  ( ( ord_less @ real @ A2 @ Y4 )
                 => ( ( ord_less @ real @ Y4 @ B2 )
                   => ( ( F2 @ ( G @ Y4 ) )
                      = Y4 ) ) )
             => ( ( topolo3448309680560233919inuous @ real @ real @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) @ G )
               => ( has_field_derivative @ real @ G @ ( inverse_inverse @ real @ D5 ) @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) ) ) ) ) ) ) ) ).

% DERIV_inverse_function
thf(fact_6614_isCont__polynom,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [A2: A,C2: nat > A,N2: nat] :
          ( topolo3448309680560233919inuous @ A @ A @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) )
          @ ^ [W3: A] :
              ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [I4: nat] : ( times_times @ A @ ( C2 @ I4 ) @ ( power_power @ A @ W3 @ I4 ) )
              @ ( set_ord_atMost @ nat @ N2 ) ) ) ) ).

% isCont_polynom
thf(fact_6615_isCont__arccos,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ X2 )
     => ( ( ord_less @ real @ X2 @ ( one_one @ real ) )
       => ( topolo3448309680560233919inuous @ real @ real @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) @ arccos ) ) ) ).

% isCont_arccos
thf(fact_6616_isCont__arcsin,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ X2 )
     => ( ( ord_less @ real @ X2 @ ( one_one @ real ) )
       => ( topolo3448309680560233919inuous @ real @ real @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) @ arcsin ) ) ) ).

% isCont_arcsin
thf(fact_6617_isCont__powser__converges__everywhere,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [C2: nat > A,X2: A] :
          ( ! [Y4: A] :
              ( summable @ A
              @ ^ [N3: nat] : ( times_times @ A @ ( C2 @ N3 ) @ ( power_power @ A @ Y4 @ N3 ) ) )
         => ( topolo3448309680560233919inuous @ A @ A @ ( topolo174197925503356063within @ A @ X2 @ ( top_top @ ( set @ A ) ) )
            @ ^ [X5: A] :
                ( suminf @ A
                @ ^ [N3: nat] : ( times_times @ A @ ( C2 @ N3 ) @ ( power_power @ A @ X5 @ N3 ) ) ) ) ) ) ).

% isCont_powser_converges_everywhere
thf(fact_6618_LIM__less__bound,axiom,
    ! [B2: real,X2: real,F2: real > real] :
      ( ( ord_less @ real @ B2 @ X2 )
     => ( ! [X3: real] :
            ( ( member @ real @ X3 @ ( set_or5935395276787703475ssThan @ real @ B2 @ X2 ) )
           => ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( F2 @ X3 ) ) )
       => ( ( topolo3448309680560233919inuous @ real @ real @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) @ F2 )
         => ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( F2 @ X2 ) ) ) ) ) ).

% LIM_less_bound
thf(fact_6619_isCont__artanh,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ X2 )
     => ( ( ord_less @ real @ X2 @ ( one_one @ real ) )
       => ( topolo3448309680560233919inuous @ real @ real @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) @ ( artanh @ real ) ) ) ) ).

% isCont_artanh
thf(fact_6620_isCont__inverse__function,axiom,
    ! [D2: real,X2: real,G: real > real,F2: real > real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ D2 )
     => ( ! [Z3: real] :
            ( ( ord_less_eq @ real @ ( abs_abs @ real @ ( minus_minus @ real @ Z3 @ X2 ) ) @ D2 )
           => ( ( G @ ( F2 @ Z3 ) )
              = Z3 ) )
       => ( ! [Z3: real] :
              ( ( ord_less_eq @ real @ ( abs_abs @ real @ ( minus_minus @ real @ Z3 @ X2 ) ) @ D2 )
             => ( topolo3448309680560233919inuous @ real @ real @ ( topolo174197925503356063within @ real @ Z3 @ ( top_top @ ( set @ real ) ) ) @ F2 ) )
         => ( topolo3448309680560233919inuous @ real @ real @ ( topolo174197925503356063within @ real @ ( F2 @ X2 ) @ ( top_top @ ( set @ real ) ) ) @ G ) ) ) ) ).

% isCont_inverse_function
thf(fact_6621_GMVT_H,axiom,
    ! [A2: real,B2: real,F2: real > real,G: real > real,G6: real > real,F8: real > real] :
      ( ( ord_less @ real @ A2 @ B2 )
     => ( ! [Z3: real] :
            ( ( ord_less_eq @ real @ A2 @ Z3 )
           => ( ( ord_less_eq @ real @ Z3 @ B2 )
             => ( topolo3448309680560233919inuous @ real @ real @ ( topolo174197925503356063within @ real @ Z3 @ ( top_top @ ( set @ real ) ) ) @ F2 ) ) )
       => ( ! [Z3: real] :
              ( ( ord_less_eq @ real @ A2 @ Z3 )
             => ( ( ord_less_eq @ real @ Z3 @ B2 )
               => ( topolo3448309680560233919inuous @ real @ real @ ( topolo174197925503356063within @ real @ Z3 @ ( top_top @ ( set @ real ) ) ) @ G ) ) )
         => ( ! [Z3: real] :
                ( ( ord_less @ real @ A2 @ Z3 )
               => ( ( ord_less @ real @ Z3 @ B2 )
                 => ( has_field_derivative @ real @ G @ ( G6 @ Z3 ) @ ( topolo174197925503356063within @ real @ Z3 @ ( top_top @ ( set @ real ) ) ) ) ) )
           => ( ! [Z3: real] :
                  ( ( ord_less @ real @ A2 @ Z3 )
                 => ( ( ord_less @ real @ Z3 @ B2 )
                   => ( has_field_derivative @ real @ F2 @ ( F8 @ Z3 ) @ ( topolo174197925503356063within @ real @ Z3 @ ( top_top @ ( set @ real ) ) ) ) ) )
             => ? [C3: real] :
                  ( ( ord_less @ real @ A2 @ C3 )
                  & ( ord_less @ real @ C3 @ B2 )
                  & ( ( times_times @ real @ ( minus_minus @ real @ ( F2 @ B2 ) @ ( F2 @ A2 ) ) @ ( G6 @ C3 ) )
                    = ( times_times @ real @ ( minus_minus @ real @ ( G @ B2 ) @ ( G @ A2 ) ) @ ( F8 @ C3 ) ) ) ) ) ) ) ) ) ).

% GMVT'
thf(fact_6622_floor__has__real__derivative,axiom,
    ! [A: $tType] :
      ( ( ( archim2362893244070406136eiling @ A )
        & ( topolo2564578578187576103pology @ A ) )
     => ! [X2: real,F2: real > A] :
          ( ( topolo3448309680560233919inuous @ real @ A @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) @ F2 )
         => ( ~ ( member @ A @ ( F2 @ X2 ) @ ( ring_1_Ints @ A ) )
           => ( has_field_derivative @ real
              @ ^ [X5: real] : ( ring_1_of_int @ real @ ( archim6421214686448440834_floor @ A @ ( F2 @ X5 ) ) )
              @ ( zero_zero @ real )
              @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) ) ) ) ) ).

% floor_has_real_derivative
thf(fact_6623_isCont__powser,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [C2: nat > A,K5: A,X2: A] :
          ( ( summable @ A
            @ ^ [N3: nat] : ( times_times @ A @ ( C2 @ N3 ) @ ( power_power @ A @ K5 @ N3 ) ) )
         => ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ X2 ) @ ( real_V7770717601297561774m_norm @ A @ K5 ) )
           => ( topolo3448309680560233919inuous @ A @ A @ ( topolo174197925503356063within @ A @ X2 @ ( top_top @ ( set @ A ) ) )
              @ ^ [X5: A] :
                  ( suminf @ A
                  @ ^ [N3: nat] : ( times_times @ A @ ( C2 @ N3 ) @ ( power_power @ A @ X5 @ N3 ) ) ) ) ) ) ) ).

% isCont_powser
thf(fact_6624_isCont__powser_H,axiom,
    ! [Aa: $tType,A: $tType] :
      ( ( ( topological_t2_space @ A )
        & ( real_Vector_banach @ Aa )
        & ( real_V3459762299906320749_field @ Aa ) )
     => ! [A2: A,F2: A > Aa,C2: nat > Aa,K5: Aa] :
          ( ( topolo3448309680560233919inuous @ A @ Aa @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) @ F2 )
         => ( ( summable @ Aa
              @ ^ [N3: nat] : ( times_times @ Aa @ ( C2 @ N3 ) @ ( power_power @ Aa @ K5 @ N3 ) ) )
           => ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ Aa @ ( F2 @ A2 ) ) @ ( real_V7770717601297561774m_norm @ Aa @ K5 ) )
             => ( topolo3448309680560233919inuous @ A @ Aa @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) )
                @ ^ [X5: A] :
                    ( suminf @ Aa
                    @ ^ [N3: nat] : ( times_times @ Aa @ ( C2 @ N3 ) @ ( power_power @ Aa @ ( F2 @ X5 ) @ N3 ) ) ) ) ) ) ) ) ).

% isCont_powser'
thf(fact_6625_termdiffs__aux,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [C2: nat > A,K5: A,X2: A] :
          ( ( summable @ A
            @ ^ [N3: nat] : ( times_times @ A @ ( diffs @ A @ ( diffs @ A @ C2 ) @ N3 ) @ ( power_power @ A @ K5 @ N3 ) ) )
         => ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ X2 ) @ ( real_V7770717601297561774m_norm @ A @ K5 ) )
           => ( filterlim @ A @ A
              @ ^ [H: A] :
                  ( suminf @ A
                  @ ^ [N3: nat] : ( times_times @ A @ ( C2 @ N3 ) @ ( minus_minus @ A @ ( divide_divide @ A @ ( minus_minus @ A @ ( power_power @ A @ ( plus_plus @ A @ X2 @ H ) @ N3 ) @ ( power_power @ A @ X2 @ N3 ) ) @ H ) @ ( times_times @ A @ ( semiring_1_of_nat @ A @ N3 ) @ ( power_power @ A @ X2 @ ( minus_minus @ nat @ N3 @ ( suc @ ( zero_zero @ nat ) ) ) ) ) ) ) )
              @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) )
              @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ).

% termdiffs_aux
thf(fact_6626_image__Fpow__mono,axiom,
    ! [B: $tType,A: $tType,F2: B > A,A3: set @ B,B3: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ ( image @ B @ A @ F2 @ A3 ) @ B3 )
     => ( ord_less_eq @ ( set @ ( set @ A ) ) @ ( image @ ( set @ B ) @ ( set @ A ) @ ( image @ B @ A @ F2 ) @ ( finite_Fpow @ B @ A3 ) ) @ ( finite_Fpow @ A @ B3 ) ) ) ).

% image_Fpow_mono
thf(fact_6627_tendsto__mult__right__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( field @ A )
        & ( topolo4211221413907600880p_mult @ A ) )
     => ! [C2: A,F2: B > A,L: A,F3: filter @ B] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( filterlim @ B @ A
              @ ^ [X5: B] : ( times_times @ A @ ( F2 @ X5 ) @ C2 )
              @ ( topolo7230453075368039082e_nhds @ A @ ( times_times @ A @ L @ C2 ) )
              @ F3 )
            = ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ L ) @ F3 ) ) ) ) ).

% tendsto_mult_right_iff
thf(fact_6628_tendsto__mult__left__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( field @ A )
        & ( topolo4211221413907600880p_mult @ A ) )
     => ! [C2: A,F2: B > A,L: A,F3: filter @ B] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( filterlim @ B @ A
              @ ^ [X5: B] : ( times_times @ A @ C2 @ ( F2 @ X5 ) )
              @ ( topolo7230453075368039082e_nhds @ A @ ( times_times @ A @ C2 @ L ) )
              @ F3 )
            = ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ L ) @ F3 ) ) ) ) ).

% tendsto_mult_left_iff
thf(fact_6629_power__tendsto__0__iff,axiom,
    ! [A: $tType,N2: nat,F2: A > real,F3: filter @ A] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( filterlim @ A @ real
          @ ^ [X5: A] : ( power_power @ real @ ( F2 @ X5 ) @ N2 )
          @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
          @ F3 )
        = ( filterlim @ A @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ F3 ) ) ) ).

% power_tendsto_0_iff
thf(fact_6630_tendsto__Pair,axiom,
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( ( topolo4958980785337419405_space @ B )
        & ( topolo4958980785337419405_space @ C ) )
     => ! [F2: A > B,A2: B,F3: filter @ A,G: A > C,B2: C] :
          ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ A2 ) @ F3 )
         => ( ( filterlim @ A @ C @ G @ ( topolo7230453075368039082e_nhds @ C @ B2 ) @ F3 )
           => ( filterlim @ A @ ( product_prod @ B @ C )
              @ ^ [X5: A] : ( product_Pair @ B @ C @ ( F2 @ X5 ) @ ( G @ X5 ) )
              @ ( topolo7230453075368039082e_nhds @ ( product_prod @ B @ C ) @ ( product_Pair @ B @ C @ A2 @ B2 ) )
              @ F3 ) ) ) ) ).

% tendsto_Pair
thf(fact_6631_isCont__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( topolo4958980785337419405_space @ B ) )
     => ! [X2: A,F2: A > B] :
          ( ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ X2 @ ( top_top @ ( set @ A ) ) ) @ F2 )
          = ( filterlim @ A @ B
            @ ^ [H: A] : ( F2 @ ( plus_plus @ A @ X2 @ H ) )
            @ ( topolo7230453075368039082e_nhds @ B @ ( F2 @ X2 ) )
            @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% isCont_iff
thf(fact_6632_LIM__imp__LIM,axiom,
    ! [B: $tType,C: $tType,A: $tType] :
      ( ( ( topolo4958980785337419405_space @ A )
        & ( real_V822414075346904944vector @ C )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F2: A > B,L: B,A2: A,G: A > C,M: C] :
          ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ L ) @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) )
         => ( ! [X3: A] :
                ( ( X3 != A2 )
               => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ C @ ( minus_minus @ C @ ( G @ X3 ) @ M ) ) @ ( real_V7770717601297561774m_norm @ B @ ( minus_minus @ B @ ( F2 @ X3 ) @ L ) ) ) )
           => ( filterlim @ A @ C @ G @ ( topolo7230453075368039082e_nhds @ C @ M ) @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ).

% LIM_imp_LIM
thf(fact_6633_real__LIM__sandwich__zero,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [F2: A > real,A2: A,G: A > real] :
          ( ( filterlim @ A @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) )
         => ( ! [X3: A] :
                ( ( X3 != A2 )
               => ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( G @ X3 ) ) )
           => ( ! [X3: A] :
                  ( ( X3 != A2 )
                 => ( ord_less_eq @ real @ ( G @ X3 ) @ ( F2 @ X3 ) ) )
             => ( filterlim @ A @ real @ G @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ) ).

% real_LIM_sandwich_zero
thf(fact_6634_tendsto__within__subset,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [F2: A > B,L: filter @ B,X2: A,S3: set @ A,T6: set @ A] :
          ( ( filterlim @ A @ B @ F2 @ L @ ( topolo174197925503356063within @ A @ X2 @ S3 ) )
         => ( ( ord_less_eq @ ( set @ A ) @ T6 @ S3 )
           => ( filterlim @ A @ B @ F2 @ L @ ( topolo174197925503356063within @ A @ X2 @ T6 ) ) ) ) ) ).

% tendsto_within_subset
thf(fact_6635_has__field__derivative__iff,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,D5: A,X2: A,S3: set @ A] :
          ( ( has_field_derivative @ A @ F2 @ D5 @ ( topolo174197925503356063within @ A @ X2 @ S3 ) )
          = ( filterlim @ A @ A
            @ ^ [Y5: A] : ( divide_divide @ A @ ( minus_minus @ A @ ( F2 @ Y5 ) @ ( F2 @ X2 ) ) @ ( minus_minus @ A @ Y5 @ X2 ) )
            @ ( topolo7230453075368039082e_nhds @ A @ D5 )
            @ ( topolo174197925503356063within @ A @ X2 @ S3 ) ) ) ) ).

% has_field_derivative_iff
thf(fact_6636_has__field__derivativeD,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,D5: A,X2: A,S3: set @ A] :
          ( ( has_field_derivative @ A @ F2 @ D5 @ ( topolo174197925503356063within @ A @ X2 @ S3 ) )
         => ( filterlim @ A @ A
            @ ^ [Y5: A] : ( divide_divide @ A @ ( minus_minus @ A @ ( F2 @ Y5 ) @ ( F2 @ X2 ) ) @ ( minus_minus @ A @ Y5 @ X2 ) )
            @ ( topolo7230453075368039082e_nhds @ A @ D5 )
            @ ( topolo174197925503356063within @ A @ X2 @ S3 ) ) ) ) ).

% has_field_derivativeD
thf(fact_6637_LIM__not__zero,axiom,
    ! [Aa: $tType,A: $tType] :
      ( ( ( topolo8386298272705272623_space @ A )
        & ( zero @ Aa )
        & ( topological_t2_space @ Aa ) )
     => ! [K: Aa,A2: A] :
          ( ( K
           != ( zero_zero @ Aa ) )
         => ~ ( filterlim @ A @ Aa
              @ ^ [X5: A] : K
              @ ( topolo7230453075368039082e_nhds @ Aa @ ( zero_zero @ Aa ) )
              @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% LIM_not_zero
thf(fact_6638_LIM__isCont__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( topolo4958980785337419405_space @ B ) )
     => ! [F2: A > B,A2: A] :
          ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ ( F2 @ A2 ) ) @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) )
          = ( filterlim @ A @ B
            @ ^ [H: A] : ( F2 @ ( plus_plus @ A @ A2 @ H ) )
            @ ( topolo7230453075368039082e_nhds @ B @ ( F2 @ A2 ) )
            @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% LIM_isCont_iff
thf(fact_6639_LIM__offset__zero,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( topolo4958980785337419405_space @ B ) )
     => ! [F2: A > B,L5: B,A2: A] :
          ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ L5 ) @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) )
         => ( filterlim @ A @ B
            @ ^ [H: A] : ( F2 @ ( plus_plus @ A @ A2 @ H ) )
            @ ( topolo7230453075368039082e_nhds @ B @ L5 )
            @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% LIM_offset_zero
thf(fact_6640_LIM__offset__zero__cancel,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( topolo4958980785337419405_space @ B ) )
     => ! [F2: A > B,A2: A,L5: B] :
          ( ( filterlim @ A @ B
            @ ^ [H: A] : ( F2 @ ( plus_plus @ A @ A2 @ H ) )
            @ ( topolo7230453075368039082e_nhds @ B @ L5 )
            @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) )
         => ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ L5 ) @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% LIM_offset_zero_cancel
thf(fact_6641_LIM__offset,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( topolo4958980785337419405_space @ B ) )
     => ! [F2: A > B,L5: B,A2: A,K: A] :
          ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ L5 ) @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) )
         => ( filterlim @ A @ B
            @ ^ [X5: A] : ( F2 @ ( plus_plus @ A @ X5 @ K ) )
            @ ( topolo7230453075368039082e_nhds @ B @ L5 )
            @ ( topolo174197925503356063within @ A @ ( minus_minus @ A @ A2 @ K ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% LIM_offset
thf(fact_6642_filterlim__mono,axiom,
    ! [B: $tType,A: $tType,F2: A > B,F24: filter @ B,F13: filter @ A,F25: filter @ B,F14: filter @ A] :
      ( ( filterlim @ A @ B @ F2 @ F24 @ F13 )
     => ( ( ord_less_eq @ ( filter @ B ) @ F24 @ F25 )
       => ( ( ord_less_eq @ ( filter @ A ) @ F14 @ F13 )
         => ( filterlim @ A @ B @ F2 @ F25 @ F14 ) ) ) ) ).

% filterlim_mono
thf(fact_6643_tendsto__mono,axiom,
    ! [A: $tType,B: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [F3: filter @ B,F11: filter @ B,F2: B > A,L: A] :
          ( ( ord_less_eq @ ( filter @ B ) @ F3 @ F11 )
         => ( ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ L ) @ F11 )
           => ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ L ) @ F3 ) ) ) ) ).

% tendsto_mono
thf(fact_6644_tendsto__artanh,axiom,
    ! [A: $tType,F2: A > real,A2: real,F3: filter @ A] :
      ( ( filterlim @ A @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ A2 ) @ F3 )
     => ( ( ord_less @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ A2 )
       => ( ( ord_less @ real @ A2 @ ( one_one @ real ) )
         => ( filterlim @ A @ real
            @ ^ [X5: A] : ( artanh @ real @ ( F2 @ X5 ) )
            @ ( topolo7230453075368039082e_nhds @ real @ ( artanh @ real @ A2 ) )
            @ F3 ) ) ) ) ).

% tendsto_artanh
thf(fact_6645_tendsto__log,axiom,
    ! [A: $tType,F2: A > real,A2: real,F3: filter @ A,G: A > real,B2: real] :
      ( ( filterlim @ A @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ A2 ) @ F3 )
     => ( ( filterlim @ A @ real @ G @ ( topolo7230453075368039082e_nhds @ real @ B2 ) @ F3 )
       => ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
         => ( ( A2
             != ( one_one @ real ) )
           => ( ( ord_less @ real @ ( zero_zero @ real ) @ B2 )
             => ( filterlim @ A @ real
                @ ^ [X5: A] : ( log @ ( F2 @ X5 ) @ ( G @ X5 ) )
                @ ( topolo7230453075368039082e_nhds @ real @ ( log @ A2 @ B2 ) )
                @ F3 ) ) ) ) ) ) ).

% tendsto_log
thf(fact_6646_tendsto__arcosh,axiom,
    ! [B: $tType,F2: B > real,A2: real,F3: filter @ B] :
      ( ( filterlim @ B @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ A2 ) @ F3 )
     => ( ( ord_less @ real @ ( one_one @ real ) @ A2 )
       => ( filterlim @ B @ real
          @ ^ [X5: B] : ( arcosh @ real @ ( F2 @ X5 ) )
          @ ( topolo7230453075368039082e_nhds @ real @ ( arcosh @ real @ A2 ) )
          @ F3 ) ) ) ).

% tendsto_arcosh
thf(fact_6647_tendsto__null__power,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V2822296259951069270ebra_1 @ B )
     => ! [F2: A > B,F3: filter @ A,N2: nat] :
          ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ ( zero_zero @ B ) ) @ F3 )
         => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
           => ( filterlim @ A @ B
              @ ^ [X5: A] : ( power_power @ B @ ( F2 @ X5 ) @ N2 )
              @ ( topolo7230453075368039082e_nhds @ B @ ( zero_zero @ B ) )
              @ F3 ) ) ) ) ).

% tendsto_null_power
thf(fact_6648_LIM__zero,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector @ B )
     => ! [F2: A > B,L: B,F3: filter @ A] :
          ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ L ) @ F3 )
         => ( filterlim @ A @ B
            @ ^ [X5: A] : ( minus_minus @ B @ ( F2 @ X5 ) @ L )
            @ ( topolo7230453075368039082e_nhds @ B @ ( zero_zero @ B ) )
            @ F3 ) ) ) ).

% LIM_zero
thf(fact_6649_LIM__zero__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector @ B )
     => ! [F2: A > B,L: B,F3: filter @ A] :
          ( ( filterlim @ A @ B
            @ ^ [X5: A] : ( minus_minus @ B @ ( F2 @ X5 ) @ L )
            @ ( topolo7230453075368039082e_nhds @ B @ ( zero_zero @ B ) )
            @ F3 )
          = ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ L ) @ F3 ) ) ) ).

% LIM_zero_iff
thf(fact_6650_Lim__transform,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [G: B > A,A2: A,F3: filter @ B,F2: B > A] :
          ( ( filterlim @ B @ A @ G @ ( topolo7230453075368039082e_nhds @ A @ A2 ) @ F3 )
         => ( ( filterlim @ B @ A
              @ ^ [X5: B] : ( minus_minus @ A @ ( F2 @ X5 ) @ ( G @ X5 ) )
              @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) )
              @ F3 )
           => ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ A2 ) @ F3 ) ) ) ) ).

% Lim_transform
thf(fact_6651_Lim__transform2,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: B > A,A2: A,F3: filter @ B,G: B > A] :
          ( ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ A2 ) @ F3 )
         => ( ( filterlim @ B @ A
              @ ^ [X5: B] : ( minus_minus @ A @ ( F2 @ X5 ) @ ( G @ X5 ) )
              @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) )
              @ F3 )
           => ( filterlim @ B @ A @ G @ ( topolo7230453075368039082e_nhds @ A @ A2 ) @ F3 ) ) ) ) ).

% Lim_transform2
thf(fact_6652_LIM__zero__cancel,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector @ B )
     => ! [F2: A > B,L: B,F3: filter @ A] :
          ( ( filterlim @ A @ B
            @ ^ [X5: A] : ( minus_minus @ B @ ( F2 @ X5 ) @ L )
            @ ( topolo7230453075368039082e_nhds @ B @ ( zero_zero @ B ) )
            @ F3 )
         => ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ L ) @ F3 ) ) ) ).

% LIM_zero_cancel
thf(fact_6653_Lim__transform__eq,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: B > A,G: B > A,F3: filter @ B,A2: A] :
          ( ( filterlim @ B @ A
            @ ^ [X5: B] : ( minus_minus @ A @ ( F2 @ X5 ) @ ( G @ X5 ) )
            @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) )
            @ F3 )
         => ( ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ A2 ) @ F3 )
            = ( filterlim @ B @ A @ G @ ( topolo7230453075368039082e_nhds @ A @ A2 ) @ F3 ) ) ) ) ).

% Lim_transform_eq
thf(fact_6654_tendsto__mult__one,axiom,
    ! [B: $tType,D: $tType] :
      ( ( topolo1898628316856586783d_mult @ B )
     => ! [F2: D > B,F3: filter @ D,G: D > B] :
          ( ( filterlim @ D @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ ( one_one @ B ) ) @ F3 )
         => ( ( filterlim @ D @ B @ G @ ( topolo7230453075368039082e_nhds @ B @ ( one_one @ B ) ) @ F3 )
           => ( filterlim @ D @ B
              @ ^ [X5: D] : ( times_times @ B @ ( F2 @ X5 ) @ ( G @ X5 ) )
              @ ( topolo7230453075368039082e_nhds @ B @ ( one_one @ B ) )
              @ F3 ) ) ) ) ).

% tendsto_mult_one
thf(fact_6655_tendsto__divide,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: B > A,A2: A,F3: filter @ B,G: B > A,B2: A] :
          ( ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ A2 ) @ F3 )
         => ( ( filterlim @ B @ A @ G @ ( topolo7230453075368039082e_nhds @ A @ B2 ) @ F3 )
           => ( ( B2
               != ( zero_zero @ A ) )
             => ( filterlim @ B @ A
                @ ^ [X5: B] : ( divide_divide @ A @ ( F2 @ X5 ) @ ( G @ X5 ) )
                @ ( topolo7230453075368039082e_nhds @ A @ ( divide_divide @ A @ A2 @ B2 ) )
                @ F3 ) ) ) ) ) ).

% tendsto_divide
thf(fact_6656_tendsto__divide__zero,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: B > A,F3: filter @ B,C2: A] :
          ( ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) ) @ F3 )
         => ( filterlim @ B @ A
            @ ^ [X5: B] : ( divide_divide @ A @ ( F2 @ X5 ) @ C2 )
            @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) )
            @ F3 ) ) ) ).

% tendsto_divide_zero
thf(fact_6657_tendsto__mult__zero,axiom,
    ! [A: $tType,D: $tType] :
      ( ( real_V4412858255891104859lgebra @ A )
     => ! [F2: D > A,F3: filter @ D,G: D > A] :
          ( ( filterlim @ D @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) ) @ F3 )
         => ( ( filterlim @ D @ A @ G @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) ) @ F3 )
           => ( filterlim @ D @ A
              @ ^ [X5: D] : ( times_times @ A @ ( F2 @ X5 ) @ ( G @ X5 ) )
              @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) )
              @ F3 ) ) ) ) ).

% tendsto_mult_zero
thf(fact_6658_tendsto__mult__left__zero,axiom,
    ! [A: $tType,D: $tType] :
      ( ( real_V4412858255891104859lgebra @ A )
     => ! [F2: D > A,F3: filter @ D,C2: A] :
          ( ( filterlim @ D @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) ) @ F3 )
         => ( filterlim @ D @ A
            @ ^ [X5: D] : ( times_times @ A @ ( F2 @ X5 ) @ C2 )
            @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) )
            @ F3 ) ) ) ).

% tendsto_mult_left_zero
thf(fact_6659_tendsto__mult__right__zero,axiom,
    ! [A: $tType,D: $tType] :
      ( ( real_V4412858255891104859lgebra @ A )
     => ! [F2: D > A,F3: filter @ D,C2: A] :
          ( ( filterlim @ D @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) ) @ F3 )
         => ( filterlim @ D @ A
            @ ^ [X5: D] : ( times_times @ A @ C2 @ ( F2 @ X5 ) )
            @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) )
            @ F3 ) ) ) ).

% tendsto_mult_right_zero
thf(fact_6660_tendsto__mult,axiom,
    ! [A: $tType,B: $tType] :
      ( ( topolo4211221413907600880p_mult @ A )
     => ! [F2: B > A,A2: A,F3: filter @ B,G: B > A,B2: A] :
          ( ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ A2 ) @ F3 )
         => ( ( filterlim @ B @ A @ G @ ( topolo7230453075368039082e_nhds @ A @ B2 ) @ F3 )
           => ( filterlim @ B @ A
              @ ^ [X5: B] : ( times_times @ A @ ( F2 @ X5 ) @ ( G @ X5 ) )
              @ ( topolo7230453075368039082e_nhds @ A @ ( times_times @ A @ A2 @ B2 ) )
              @ F3 ) ) ) ) ).

% tendsto_mult
thf(fact_6661_tendsto__mult__left,axiom,
    ! [A: $tType,B: $tType] :
      ( ( topolo4211221413907600880p_mult @ A )
     => ! [F2: B > A,L: A,F3: filter @ B,C2: A] :
          ( ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ L ) @ F3 )
         => ( filterlim @ B @ A
            @ ^ [X5: B] : ( times_times @ A @ C2 @ ( F2 @ X5 ) )
            @ ( topolo7230453075368039082e_nhds @ A @ ( times_times @ A @ C2 @ L ) )
            @ F3 ) ) ) ).

% tendsto_mult_left
thf(fact_6662_tendsto__mult__right,axiom,
    ! [A: $tType,B: $tType] :
      ( ( topolo4211221413907600880p_mult @ A )
     => ! [F2: B > A,L: A,F3: filter @ B,C2: A] :
          ( ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ L ) @ F3 )
         => ( filterlim @ B @ A
            @ ^ [X5: B] : ( times_times @ A @ ( F2 @ X5 ) @ C2 )
            @ ( topolo7230453075368039082e_nhds @ A @ ( times_times @ A @ L @ C2 ) )
            @ F3 ) ) ) ).

% tendsto_mult_right
thf(fact_6663_tendsto__power,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( power @ B )
        & ( real_V4412858255891104859lgebra @ B ) )
     => ! [F2: A > B,A2: B,F3: filter @ A,N2: nat] :
          ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ A2 ) @ F3 )
         => ( filterlim @ A @ B
            @ ^ [X5: A] : ( power_power @ B @ ( F2 @ X5 ) @ N2 )
            @ ( topolo7230453075368039082e_nhds @ B @ ( power_power @ B @ A2 @ N2 ) )
            @ F3 ) ) ) ).

% tendsto_power
thf(fact_6664_tendsto__power__strong,axiom,
    ! [B: $tType,C: $tType] :
      ( ( topolo1898628316856586783d_mult @ B )
     => ! [F2: C > B,A2: B,F3: filter @ C,G: C > nat,B2: nat] :
          ( ( filterlim @ C @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ A2 ) @ F3 )
         => ( ( filterlim @ C @ nat @ G @ ( topolo7230453075368039082e_nhds @ nat @ B2 ) @ F3 )
           => ( filterlim @ C @ B
              @ ^ [X5: C] : ( power_power @ B @ ( F2 @ X5 ) @ ( G @ X5 ) )
              @ ( topolo7230453075368039082e_nhds @ B @ ( power_power @ B @ A2 @ B2 ) )
              @ F3 ) ) ) ) ).

% tendsto_power_strong
thf(fact_6665_tendsto__add__zero,axiom,
    ! [B: $tType,D: $tType] :
      ( ( topolo6943815403480290642id_add @ B )
     => ! [F2: D > B,F3: filter @ D,G: D > B] :
          ( ( filterlim @ D @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ ( zero_zero @ B ) ) @ F3 )
         => ( ( filterlim @ D @ B @ G @ ( topolo7230453075368039082e_nhds @ B @ ( zero_zero @ B ) ) @ F3 )
           => ( filterlim @ D @ B
              @ ^ [X5: D] : ( plus_plus @ B @ ( F2 @ X5 ) @ ( G @ X5 ) )
              @ ( topolo7230453075368039082e_nhds @ B @ ( zero_zero @ B ) )
              @ F3 ) ) ) ) ).

% tendsto_add_zero
thf(fact_6666_tendsto__cot,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [F2: A > A,A2: A,F3: filter @ A] :
          ( ( filterlim @ A @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ A2 ) @ F3 )
         => ( ( ( sin @ A @ A2 )
             != ( zero_zero @ A ) )
           => ( filterlim @ A @ A
              @ ^ [X5: A] : ( cot @ A @ ( F2 @ X5 ) )
              @ ( topolo7230453075368039082e_nhds @ A @ ( cot @ A @ A2 ) )
              @ F3 ) ) ) ) ).

% tendsto_cot
thf(fact_6667_tendsto__sgn,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: B > A,L: A,F3: filter @ B] :
          ( ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ L ) @ F3 )
         => ( ( L
             != ( zero_zero @ A ) )
           => ( filterlim @ B @ A
              @ ^ [X5: B] : ( sgn_sgn @ A @ ( F2 @ X5 ) )
              @ ( topolo7230453075368039082e_nhds @ A @ ( sgn_sgn @ A @ L ) )
              @ F3 ) ) ) ) ).

% tendsto_sgn
thf(fact_6668_tendsto__inverse,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [F2: B > A,A2: A,F3: filter @ B] :
          ( ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ A2 ) @ F3 )
         => ( ( A2
             != ( zero_zero @ A ) )
           => ( filterlim @ B @ A
              @ ^ [X5: B] : ( inverse_inverse @ A @ ( F2 @ X5 ) )
              @ ( topolo7230453075368039082e_nhds @ A @ ( inverse_inverse @ A @ A2 ) )
              @ F3 ) ) ) ) ).

% tendsto_inverse
thf(fact_6669_tendsto__norm__zero,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector @ B )
     => ! [F2: A > B,F3: filter @ A] :
          ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ ( zero_zero @ B ) ) @ F3 )
         => ( filterlim @ A @ real
            @ ^ [X5: A] : ( real_V7770717601297561774m_norm @ B @ ( F2 @ X5 ) )
            @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
            @ F3 ) ) ) ).

% tendsto_norm_zero
thf(fact_6670_tendsto__norm__zero__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector @ B )
     => ! [F2: A > B,F3: filter @ A] :
          ( ( filterlim @ A @ real
            @ ^ [X5: A] : ( real_V7770717601297561774m_norm @ B @ ( F2 @ X5 ) )
            @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
            @ F3 )
          = ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ ( zero_zero @ B ) ) @ F3 ) ) ) ).

% tendsto_norm_zero_iff
thf(fact_6671_tendsto__norm__zero__cancel,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector @ B )
     => ! [F2: A > B,F3: filter @ A] :
          ( ( filterlim @ A @ real
            @ ^ [X5: A] : ( real_V7770717601297561774m_norm @ B @ ( F2 @ X5 ) )
            @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
            @ F3 )
         => ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ ( zero_zero @ B ) ) @ F3 ) ) ) ).

% tendsto_norm_zero_cancel
thf(fact_6672_tendsto__ln,axiom,
    ! [A: $tType,F2: A > real,A2: real,F3: filter @ A] :
      ( ( filterlim @ A @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ A2 ) @ F3 )
     => ( ( A2
         != ( zero_zero @ real ) )
       => ( filterlim @ A @ real
          @ ^ [X5: A] : ( ln_ln @ real @ ( F2 @ X5 ) )
          @ ( topolo7230453075368039082e_nhds @ real @ ( ln_ln @ real @ A2 ) )
          @ F3 ) ) ) ).

% tendsto_ln
thf(fact_6673_tendsto__powr,axiom,
    ! [A: $tType,F2: A > real,A2: real,F3: filter @ A,G: A > real,B2: real] :
      ( ( filterlim @ A @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ A2 ) @ F3 )
     => ( ( filterlim @ A @ real @ G @ ( topolo7230453075368039082e_nhds @ real @ B2 ) @ F3 )
       => ( ( A2
           != ( zero_zero @ real ) )
         => ( filterlim @ A @ real
            @ ^ [X5: A] : ( powr @ real @ ( F2 @ X5 ) @ ( G @ X5 ) )
            @ ( topolo7230453075368039082e_nhds @ real @ ( powr @ real @ A2 @ B2 ) )
            @ F3 ) ) ) ) ).

% tendsto_powr
thf(fact_6674_tendsto__tan,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [F2: A > A,A2: A,F3: filter @ A] :
          ( ( filterlim @ A @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ A2 ) @ F3 )
         => ( ( ( cos @ A @ A2 )
             != ( zero_zero @ A ) )
           => ( filterlim @ A @ A
              @ ^ [X5: A] : ( tan @ A @ ( F2 @ X5 ) )
              @ ( topolo7230453075368039082e_nhds @ A @ ( tan @ A @ A2 ) )
              @ F3 ) ) ) ) ).

% tendsto_tan
thf(fact_6675_tendsto__tanh,axiom,
    ! [A: $tType,C: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [F2: C > A,A2: A,F3: filter @ C] :
          ( ( filterlim @ C @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ A2 ) @ F3 )
         => ( ( ( cosh @ A @ A2 )
             != ( zero_zero @ A ) )
           => ( filterlim @ C @ A
              @ ^ [X5: C] : ( tanh @ A @ ( F2 @ X5 ) )
              @ ( topolo7230453075368039082e_nhds @ A @ ( tanh @ A @ A2 ) )
              @ F3 ) ) ) ) ).

% tendsto_tanh
thf(fact_6676_tendsto__add,axiom,
    ! [A: $tType,B: $tType] :
      ( ( topolo6943815403480290642id_add @ A )
     => ! [F2: B > A,A2: A,F3: filter @ B,G: B > A,B2: A] :
          ( ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ A2 ) @ F3 )
         => ( ( filterlim @ B @ A @ G @ ( topolo7230453075368039082e_nhds @ A @ B2 ) @ F3 )
           => ( filterlim @ B @ A
              @ ^ [X5: B] : ( plus_plus @ A @ ( F2 @ X5 ) @ ( G @ X5 ) )
              @ ( topolo7230453075368039082e_nhds @ A @ ( plus_plus @ A @ A2 @ B2 ) )
              @ F3 ) ) ) ) ).

% tendsto_add
thf(fact_6677_tendsto__add__const__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( topolo1633459387980952147up_add @ A )
     => ! [C2: A,F2: B > A,D2: A,F3: filter @ B] :
          ( ( filterlim @ B @ A
            @ ^ [X5: B] : ( plus_plus @ A @ C2 @ ( F2 @ X5 ) )
            @ ( topolo7230453075368039082e_nhds @ A @ ( plus_plus @ A @ C2 @ D2 ) )
            @ F3 )
          = ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ D2 ) @ F3 ) ) ) ).

% tendsto_add_const_iff
thf(fact_6678_tendsto__rabs__zero__cancel,axiom,
    ! [A: $tType,F2: A > real,F3: filter @ A] :
      ( ( filterlim @ A @ real
        @ ^ [X5: A] : ( abs_abs @ real @ ( F2 @ X5 ) )
        @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
        @ F3 )
     => ( filterlim @ A @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ F3 ) ) ).

% tendsto_rabs_zero_cancel
thf(fact_6679_tendsto__rabs__zero__iff,axiom,
    ! [A: $tType,F2: A > real,F3: filter @ A] :
      ( ( filterlim @ A @ real
        @ ^ [X5: A] : ( abs_abs @ real @ ( F2 @ X5 ) )
        @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
        @ F3 )
      = ( filterlim @ A @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ F3 ) ) ).

% tendsto_rabs_zero_iff
thf(fact_6680_tendsto__rabs__zero,axiom,
    ! [A: $tType,F2: A > real,F3: filter @ A] :
      ( ( filterlim @ A @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ F3 )
     => ( filterlim @ A @ real
        @ ^ [X5: A] : ( abs_abs @ real @ ( F2 @ X5 ) )
        @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
        @ F3 ) ) ).

% tendsto_rabs_zero
thf(fact_6681_tendsto__one__prod_H,axiom,
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( topolo4987421752381908075d_mult @ C )
     => ! [I6: set @ B,F2: A > B > C,F3: filter @ A] :
          ( ! [I2: B] :
              ( ( member @ B @ I2 @ I6 )
             => ( filterlim @ A @ C
                @ ^ [X5: A] : ( F2 @ X5 @ I2 )
                @ ( topolo7230453075368039082e_nhds @ C @ ( one_one @ C ) )
                @ F3 ) )
         => ( filterlim @ A @ C
            @ ^ [I4: A] : ( groups7121269368397514597t_prod @ B @ C @ ( F2 @ I4 ) @ I6 )
            @ ( topolo7230453075368039082e_nhds @ C @ ( one_one @ C ) )
            @ F3 ) ) ) ).

% tendsto_one_prod'
thf(fact_6682_tendsto__null__sum,axiom,
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( topolo5987344860129210374id_add @ C )
     => ! [I6: set @ B,F2: A > B > C,F3: filter @ A] :
          ( ! [I2: B] :
              ( ( member @ B @ I2 @ I6 )
             => ( filterlim @ A @ C
                @ ^ [X5: A] : ( F2 @ X5 @ I2 )
                @ ( topolo7230453075368039082e_nhds @ C @ ( zero_zero @ C ) )
                @ F3 ) )
         => ( filterlim @ A @ C
            @ ^ [I4: A] : ( groups7311177749621191930dd_sum @ B @ C @ ( F2 @ I4 ) @ I6 )
            @ ( topolo7230453075368039082e_nhds @ C @ ( zero_zero @ C ) )
            @ F3 ) ) ) ).

% tendsto_null_sum
thf(fact_6683_LIM__offset__zero__iff,axiom,
    ! [C: $tType,D: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( topolo4958980785337419405_space @ D )
        & ( zero @ C ) )
     => ! [A2: A,F2: A > D,L5: D] :
          ( ( nO_MATCH @ C @ A @ ( zero_zero @ C ) @ A2 )
         => ( ( filterlim @ A @ D @ F2 @ ( topolo7230453075368039082e_nhds @ D @ L5 ) @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) )
            = ( filterlim @ A @ D
              @ ^ [H: A] : ( F2 @ ( plus_plus @ A @ A2 @ H ) )
              @ ( topolo7230453075368039082e_nhds @ D @ L5 )
              @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ).

% LIM_offset_zero_iff
thf(fact_6684_LIM__equal2,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( topolo4958980785337419405_space @ B ) )
     => ! [R: real,A2: A,F2: A > B,G: A > B,L: B] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ R )
         => ( ! [X3: A] :
                ( ( X3 != A2 )
               => ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ X3 @ A2 ) ) @ R )
                 => ( ( F2 @ X3 )
                    = ( G @ X3 ) ) ) )
           => ( ( filterlim @ A @ B @ G @ ( topolo7230453075368039082e_nhds @ B @ L ) @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) )
             => ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ L ) @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ) ).

% LIM_equal2
thf(fact_6685_LIM__eq,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F2: A > B,L5: B,A2: A] :
          ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ L5 ) @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) )
          = ( ! [R5: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ R5 )
               => ? [S7: real] :
                    ( ( ord_less @ real @ ( zero_zero @ real ) @ S7 )
                    & ! [X5: A] :
                        ( ( ( X5 != A2 )
                          & ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ X5 @ A2 ) ) @ S7 ) )
                       => ( ord_less @ real @ ( real_V7770717601297561774m_norm @ B @ ( minus_minus @ B @ ( F2 @ X5 ) @ L5 ) ) @ R5 ) ) ) ) ) ) ) ).

% LIM_eq
thf(fact_6686_LIM__I,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [A2: A,F2: A > B,L5: B] :
          ( ! [R4: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ R4 )
             => ? [S9: real] :
                  ( ( ord_less @ real @ ( zero_zero @ real ) @ S9 )
                  & ! [X3: A] :
                      ( ( ( X3 != A2 )
                        & ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ X3 @ A2 ) ) @ S9 ) )
                     => ( ord_less @ real @ ( real_V7770717601297561774m_norm @ B @ ( minus_minus @ B @ ( F2 @ X3 ) @ L5 ) ) @ R4 ) ) ) )
         => ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ L5 ) @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% LIM_I
thf(fact_6687_LIM__D,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F2: A > B,L5: B,A2: A,R3: real] :
          ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ L5 ) @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) )
         => ( ( ord_less @ real @ ( zero_zero @ real ) @ R3 )
           => ? [S: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ S )
                & ! [X: A] :
                    ( ( ( X != A2 )
                      & ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ X @ A2 ) ) @ S ) )
                   => ( ord_less @ real @ ( real_V7770717601297561774m_norm @ B @ ( minus_minus @ B @ ( F2 @ X ) @ L5 ) ) @ R3 ) ) ) ) ) ) ).

% LIM_D
thf(fact_6688_DERIV__LIM__iff,axiom,
    ! [A: $tType] :
      ( ( ( inverse @ A )
        & ( real_V822414075346904944vector @ A ) )
     => ! [F2: A > A,A2: A,D5: A] :
          ( ( filterlim @ A @ A
            @ ^ [H: A] : ( divide_divide @ A @ ( minus_minus @ A @ ( F2 @ ( plus_plus @ A @ A2 @ H ) ) @ ( F2 @ A2 ) ) @ H )
            @ ( topolo7230453075368039082e_nhds @ A @ D5 )
            @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) )
          = ( filterlim @ A @ A
            @ ^ [X5: A] : ( divide_divide @ A @ ( minus_minus @ A @ ( F2 @ X5 ) @ ( F2 @ A2 ) ) @ ( minus_minus @ A @ X5 @ A2 ) )
            @ ( topolo7230453075368039082e_nhds @ A @ D5 )
            @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% DERIV_LIM_iff
thf(fact_6689_LIM__fun__less__zero,axiom,
    ! [F2: real > real,L: real,C2: real] :
      ( ( filterlim @ real @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ L ) @ ( topolo174197925503356063within @ real @ C2 @ ( top_top @ ( set @ real ) ) ) )
     => ( ( ord_less @ real @ L @ ( zero_zero @ real ) )
       => ? [R4: real] :
            ( ( ord_less @ real @ ( zero_zero @ real ) @ R4 )
            & ! [X: real] :
                ( ( ( X != C2 )
                  & ( ord_less @ real @ ( abs_abs @ real @ ( minus_minus @ real @ C2 @ X ) ) @ R4 ) )
               => ( ord_less @ real @ ( F2 @ X ) @ ( zero_zero @ real ) ) ) ) ) ) ).

% LIM_fun_less_zero
thf(fact_6690_LIM__fun__not__zero,axiom,
    ! [F2: real > real,L: real,C2: real] :
      ( ( filterlim @ real @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ L ) @ ( topolo174197925503356063within @ real @ C2 @ ( top_top @ ( set @ real ) ) ) )
     => ( ( L
         != ( zero_zero @ real ) )
       => ? [R4: real] :
            ( ( ord_less @ real @ ( zero_zero @ real ) @ R4 )
            & ! [X: real] :
                ( ( ( X != C2 )
                  & ( ord_less @ real @ ( abs_abs @ real @ ( minus_minus @ real @ C2 @ X ) ) @ R4 ) )
               => ( ( F2 @ X )
                 != ( zero_zero @ real ) ) ) ) ) ) ).

% LIM_fun_not_zero
thf(fact_6691_LIM__fun__gt__zero,axiom,
    ! [F2: real > real,L: real,C2: real] :
      ( ( filterlim @ real @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ L ) @ ( topolo174197925503356063within @ real @ C2 @ ( top_top @ ( set @ real ) ) ) )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ L )
       => ? [R4: real] :
            ( ( ord_less @ real @ ( zero_zero @ real ) @ R4 )
            & ! [X: real] :
                ( ( ( X != C2 )
                  & ( ord_less @ real @ ( abs_abs @ real @ ( minus_minus @ real @ C2 @ X ) ) @ R4 ) )
               => ( ord_less @ real @ ( zero_zero @ real ) @ ( F2 @ X ) ) ) ) ) ) ).

% LIM_fun_gt_zero
thf(fact_6692_LIM__compose2,axiom,
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( topolo4958980785337419405_space @ B )
        & ( topolo4958980785337419405_space @ C ) )
     => ! [F2: A > B,B2: B,A2: A,G: B > C,C2: C] :
          ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ B2 ) @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) )
         => ( ( filterlim @ B @ C @ G @ ( topolo7230453075368039082e_nhds @ C @ C2 ) @ ( topolo174197925503356063within @ B @ B2 @ ( top_top @ ( set @ B ) ) ) )
           => ( ? [D6: real] :
                  ( ( ord_less @ real @ ( zero_zero @ real ) @ D6 )
                  & ! [X3: A] :
                      ( ( ( X3 != A2 )
                        & ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ X3 @ A2 ) ) @ D6 ) )
                     => ( ( F2 @ X3 )
                       != B2 ) ) )
             => ( filterlim @ A @ C
                @ ^ [X5: A] : ( G @ ( F2 @ X5 ) )
                @ ( topolo7230453075368039082e_nhds @ C @ C2 )
                @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ) ).

% LIM_compose2
thf(fact_6693_continuous__at__within__powr,axiom,
    ! [C: $tType] :
      ( ( topological_t2_space @ C )
     => ! [A2: C,S2: set @ C,F2: C > real,G: C > real] :
          ( ( topolo3448309680560233919inuous @ C @ real @ ( topolo174197925503356063within @ C @ A2 @ S2 ) @ F2 )
         => ( ( topolo3448309680560233919inuous @ C @ real @ ( topolo174197925503356063within @ C @ A2 @ S2 ) @ G )
           => ( ( ( F2 @ A2 )
               != ( zero_zero @ real ) )
             => ( topolo3448309680560233919inuous @ C @ real @ ( topolo174197925503356063within @ C @ A2 @ S2 )
                @ ^ [X5: C] : ( powr @ real @ ( F2 @ X5 ) @ ( G @ X5 ) ) ) ) ) ) ) ).

% continuous_at_within_powr
thf(fact_6694_continuous__within__ln,axiom,
    ! [A: $tType] :
      ( ( topological_t2_space @ A )
     => ! [X2: A,S2: set @ A,F2: A > real] :
          ( ( topolo3448309680560233919inuous @ A @ real @ ( topolo174197925503356063within @ A @ X2 @ S2 ) @ F2 )
         => ( ( ( F2 @ X2 )
             != ( zero_zero @ real ) )
           => ( topolo3448309680560233919inuous @ A @ real @ ( topolo174197925503356063within @ A @ X2 @ S2 )
              @ ^ [X5: A] : ( ln_ln @ real @ ( F2 @ X5 ) ) ) ) ) ) ).

% continuous_within_ln
thf(fact_6695_DERIV__def,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,D5: A,X2: A] :
          ( ( has_field_derivative @ A @ F2 @ D5 @ ( topolo174197925503356063within @ A @ X2 @ ( top_top @ ( set @ A ) ) ) )
          = ( filterlim @ A @ A
            @ ^ [H: A] : ( divide_divide @ A @ ( minus_minus @ A @ ( F2 @ ( plus_plus @ A @ X2 @ H ) ) @ ( F2 @ X2 ) ) @ H )
            @ ( topolo7230453075368039082e_nhds @ A @ D5 )
            @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% DERIV_def
thf(fact_6696_DERIV__D,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,D5: A,X2: A] :
          ( ( has_field_derivative @ A @ F2 @ D5 @ ( topolo174197925503356063within @ A @ X2 @ ( top_top @ ( set @ A ) ) ) )
         => ( filterlim @ A @ A
            @ ^ [H: A] : ( divide_divide @ A @ ( minus_minus @ A @ ( F2 @ ( plus_plus @ A @ X2 @ H ) ) @ ( F2 @ X2 ) ) @ H )
            @ ( topolo7230453075368039082e_nhds @ A @ D5 )
            @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% DERIV_D
thf(fact_6697_lim__exp__minus__1,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ( filterlim @ A @ A
        @ ^ [Z6: A] : ( divide_divide @ A @ ( minus_minus @ A @ ( exp @ A @ Z6 ) @ ( one_one @ A ) ) @ Z6 )
        @ ( topolo7230453075368039082e_nhds @ A @ ( one_one @ A ) )
        @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ).

% lim_exp_minus_1
thf(fact_6698_isCont__LIM__compose2,axiom,
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( topolo4958980785337419405_space @ B )
        & ( topolo4958980785337419405_space @ C ) )
     => ! [A2: A,F2: A > B,G: B > C,L: C] :
          ( ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) @ F2 )
         => ( ( filterlim @ B @ C @ G @ ( topolo7230453075368039082e_nhds @ C @ L ) @ ( topolo174197925503356063within @ B @ ( F2 @ A2 ) @ ( top_top @ ( set @ B ) ) ) )
           => ( ? [D6: real] :
                  ( ( ord_less @ real @ ( zero_zero @ real ) @ D6 )
                  & ! [X3: A] :
                      ( ( ( X3 != A2 )
                        & ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ X3 @ A2 ) ) @ D6 ) )
                     => ( ( F2 @ X3 )
                       != ( F2 @ A2 ) ) ) )
             => ( filterlim @ A @ C
                @ ^ [X5: A] : ( G @ ( F2 @ X5 ) )
                @ ( topolo7230453075368039082e_nhds @ C @ L )
                @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ) ).

% isCont_LIM_compose2
thf(fact_6699_lemma__termdiff4,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [K: real,F2: A > B,K5: real] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ K )
         => ( ! [H4: A] :
                ( ( H4
                 != ( zero_zero @ A ) )
               => ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ H4 ) @ K )
                 => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ B @ ( F2 @ H4 ) ) @ ( times_times @ real @ K5 @ ( real_V7770717601297561774m_norm @ A @ H4 ) ) ) ) )
           => ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ ( zero_zero @ B ) ) @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ).

% lemma_termdiff4
thf(fact_6700_field__has__derivative__at,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,D5: A,X2: A] :
          ( ( has_derivative @ A @ A @ F2 @ ( times_times @ A @ D5 ) @ ( topolo174197925503356063within @ A @ X2 @ ( top_top @ ( set @ A ) ) ) )
          = ( filterlim @ A @ A
            @ ^ [H: A] : ( divide_divide @ A @ ( minus_minus @ A @ ( F2 @ ( plus_plus @ A @ X2 @ H ) ) @ ( F2 @ X2 ) ) @ H )
            @ ( topolo7230453075368039082e_nhds @ A @ D5 )
            @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% field_has_derivative_at
thf(fact_6701_Fpow__mono,axiom,
    ! [A: $tType,A3: set @ A,B3: set @ A] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ B3 )
     => ( ord_less_eq @ ( set @ ( set @ A ) ) @ ( finite_Fpow @ A @ A3 ) @ ( finite_Fpow @ A @ B3 ) ) ) ).

% Fpow_mono
thf(fact_6702_filterlim__at__to__0,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: A > B,F3: filter @ B,A2: A] :
          ( ( filterlim @ A @ B @ F2 @ F3 @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) )
          = ( filterlim @ A @ B
            @ ^ [X5: A] : ( F2 @ ( plus_plus @ A @ X5 @ A2 ) )
            @ F3
            @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% filterlim_at_to_0
thf(fact_6703_isCont__powr,axiom,
    ! [C: $tType] :
      ( ( topological_t2_space @ C )
     => ! [A2: C,F2: C > real,G: C > real] :
          ( ( topolo3448309680560233919inuous @ C @ real @ ( topolo174197925503356063within @ C @ A2 @ ( top_top @ ( set @ C ) ) ) @ F2 )
         => ( ( topolo3448309680560233919inuous @ C @ real @ ( topolo174197925503356063within @ C @ A2 @ ( top_top @ ( set @ C ) ) ) @ G )
           => ( ( ( F2 @ A2 )
               != ( zero_zero @ real ) )
             => ( topolo3448309680560233919inuous @ C @ real @ ( topolo174197925503356063within @ C @ A2 @ ( top_top @ ( set @ C ) ) )
                @ ^ [X5: C] : ( powr @ real @ ( F2 @ X5 ) @ ( G @ X5 ) ) ) ) ) ) ) ).

% isCont_powr
thf(fact_6704_isCont__ln_H,axiom,
    ! [A: $tType] :
      ( ( topological_t2_space @ A )
     => ! [X2: A,F2: A > real] :
          ( ( topolo3448309680560233919inuous @ A @ real @ ( topolo174197925503356063within @ A @ X2 @ ( top_top @ ( set @ A ) ) ) @ F2 )
         => ( ( ( F2 @ X2 )
             != ( zero_zero @ real ) )
           => ( topolo3448309680560233919inuous @ A @ real @ ( topolo174197925503356063within @ A @ X2 @ ( top_top @ ( set @ A ) ) )
              @ ^ [X5: A] : ( ln_ln @ real @ ( F2 @ X5 ) ) ) ) ) ) ).

% isCont_ln'
thf(fact_6705_Fpow__subset__Pow,axiom,
    ! [A: $tType,A3: set @ A] : ( ord_less_eq @ ( set @ ( set @ A ) ) @ ( finite_Fpow @ A @ A3 ) @ ( pow2 @ A @ A3 ) ) ).

% Fpow_subset_Pow
thf(fact_6706_Fpow__def,axiom,
    ! [A: $tType] :
      ( ( finite_Fpow @ A )
      = ( ^ [A7: set @ A] :
            ( collect @ ( set @ A )
            @ ^ [X4: set @ A] :
                ( ( ord_less_eq @ ( set @ A ) @ X4 @ A7 )
                & ( finite_finite @ A @ X4 ) ) ) ) ) ).

% Fpow_def
thf(fact_6707_filterlim__shift,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: A > B,F3: filter @ B,A2: A,D2: A] :
          ( ( filterlim @ A @ B @ F2 @ F3 @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) )
         => ( filterlim @ A @ B @ ( comp @ A @ B @ A @ F2 @ ( plus_plus @ A @ D2 ) ) @ F3 @ ( topolo174197925503356063within @ A @ ( minus_minus @ A @ A2 @ D2 ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% filterlim_shift
thf(fact_6708_filterlim__shift__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: A > B,D2: A,F3: filter @ B,A2: A] :
          ( ( filterlim @ A @ B @ ( comp @ A @ B @ A @ F2 @ ( plus_plus @ A @ D2 ) ) @ F3 @ ( topolo174197925503356063within @ A @ ( minus_minus @ A @ A2 @ D2 ) @ ( top_top @ ( set @ A ) ) ) )
          = ( filterlim @ A @ B @ F2 @ F3 @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% filterlim_shift_iff
thf(fact_6709_powser__limit__0,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [S2: real,A2: nat > A,F2: A > A] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ S2 )
         => ( ! [X3: A] :
                ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ X3 ) @ S2 )
               => ( sums @ A
                  @ ^ [N3: nat] : ( times_times @ A @ ( A2 @ N3 ) @ ( power_power @ A @ X3 @ N3 ) )
                  @ ( F2 @ X3 ) ) )
           => ( filterlim @ A @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ ( A2 @ ( zero_zero @ nat ) ) ) @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ).

% powser_limit_0
thf(fact_6710_powser__limit__0__strong,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [S2: real,A2: nat > A,F2: A > A] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ S2 )
         => ( ! [X3: A] :
                ( ( X3
                 != ( zero_zero @ A ) )
               => ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ X3 ) @ S2 )
                 => ( sums @ A
                    @ ^ [N3: nat] : ( times_times @ A @ ( A2 @ N3 ) @ ( power_power @ A @ X3 @ N3 ) )
                    @ ( F2 @ X3 ) ) ) )
           => ( filterlim @ A @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ ( A2 @ ( zero_zero @ nat ) ) ) @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ).

% powser_limit_0_strong
thf(fact_6711_lemma__termdiff5,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_Vector_banach @ B ) )
     => ! [K: real,F2: nat > real,G: A > nat > B] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ K )
         => ( ( summable @ real @ F2 )
           => ( ! [H4: A,N: nat] :
                  ( ( H4
                   != ( zero_zero @ A ) )
                 => ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ H4 ) @ K )
                   => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ B @ ( G @ H4 @ N ) ) @ ( times_times @ real @ ( F2 @ N ) @ ( real_V7770717601297561774m_norm @ A @ H4 ) ) ) ) )
             => ( filterlim @ A @ B
                @ ^ [H: A] : ( suminf @ B @ ( G @ H ) )
                @ ( topolo7230453075368039082e_nhds @ B @ ( zero_zero @ B ) )
                @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ) ).

% lemma_termdiff5
thf(fact_6712_continuous__at__within__log,axiom,
    ! [A: $tType] :
      ( ( topological_t2_space @ A )
     => ! [A2: A,S2: set @ A,F2: A > real,G: A > real] :
          ( ( topolo3448309680560233919inuous @ A @ real @ ( topolo174197925503356063within @ A @ A2 @ S2 ) @ F2 )
         => ( ( topolo3448309680560233919inuous @ A @ real @ ( topolo174197925503356063within @ A @ A2 @ S2 ) @ G )
           => ( ( ord_less @ real @ ( zero_zero @ real ) @ ( F2 @ A2 ) )
             => ( ( ( F2 @ A2 )
                 != ( one_one @ real ) )
               => ( ( ord_less @ real @ ( zero_zero @ real ) @ ( G @ A2 ) )
                 => ( topolo3448309680560233919inuous @ A @ real @ ( topolo174197925503356063within @ A @ A2 @ S2 )
                    @ ^ [X5: A] : ( log @ ( F2 @ X5 ) @ ( G @ X5 ) ) ) ) ) ) ) ) ) ).

% continuous_at_within_log
thf(fact_6713_LIM__cos__div__sin,axiom,
    ( filterlim @ real @ real
    @ ^ [X5: real] : ( divide_divide @ real @ ( cos @ real @ X5 ) @ ( sin @ real @ X5 ) )
    @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
    @ ( topolo174197925503356063within @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( top_top @ ( set @ real ) ) ) ) ).

% LIM_cos_div_sin
thf(fact_6714_isCont__log,axiom,
    ! [A: $tType] :
      ( ( topological_t2_space @ A )
     => ! [A2: A,F2: A > real,G: A > real] :
          ( ( topolo3448309680560233919inuous @ A @ real @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) @ F2 )
         => ( ( topolo3448309680560233919inuous @ A @ real @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) @ G )
           => ( ( ord_less @ real @ ( zero_zero @ real ) @ ( F2 @ A2 ) )
             => ( ( ( F2 @ A2 )
                 != ( one_one @ real ) )
               => ( ( ord_less @ real @ ( zero_zero @ real ) @ ( G @ A2 ) )
                 => ( topolo3448309680560233919inuous @ A @ real @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) )
                    @ ^ [X5: A] : ( log @ ( F2 @ X5 ) @ ( G @ X5 ) ) ) ) ) ) ) ) ) ).

% isCont_log
thf(fact_6715_summable__Leibniz_I2_J,axiom,
    ! [A2: nat > real] :
      ( ( filterlim @ nat @ real @ A2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( at_top @ nat ) )
     => ( ( topological_monoseq @ real @ A2 )
       => ( ( ord_less @ real @ ( zero_zero @ real ) @ ( A2 @ ( zero_zero @ nat ) ) )
         => ! [N9: nat] :
              ( member @ real
              @ ( suminf @ real
                @ ^ [I4: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I4 ) @ ( A2 @ I4 ) ) )
              @ ( set_or1337092689740270186AtMost @ real
                @ ( groups7311177749621191930dd_sum @ nat @ real
                  @ ^ [I4: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I4 ) @ ( A2 @ I4 ) )
                  @ ( set_ord_lessThan @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N9 ) ) )
                @ ( groups7311177749621191930dd_sum @ nat @ real
                  @ ^ [I4: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I4 ) @ ( A2 @ I4 ) )
                  @ ( set_ord_lessThan @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N9 ) @ ( one_one @ nat ) ) ) ) ) ) ) ) ) ).

% summable_Leibniz(2)
thf(fact_6716_summable__Leibniz_I3_J,axiom,
    ! [A2: nat > real] :
      ( ( filterlim @ nat @ real @ A2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( at_top @ nat ) )
     => ( ( topological_monoseq @ real @ A2 )
       => ( ( ord_less @ real @ ( A2 @ ( zero_zero @ nat ) ) @ ( zero_zero @ real ) )
         => ! [N9: nat] :
              ( member @ real
              @ ( suminf @ real
                @ ^ [I4: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I4 ) @ ( A2 @ I4 ) ) )
              @ ( set_or1337092689740270186AtMost @ real
                @ ( groups7311177749621191930dd_sum @ nat @ real
                  @ ^ [I4: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I4 ) @ ( A2 @ I4 ) )
                  @ ( set_ord_lessThan @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N9 ) @ ( one_one @ nat ) ) ) )
                @ ( groups7311177749621191930dd_sum @ nat @ real
                  @ ^ [I4: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I4 ) @ ( A2 @ I4 ) )
                  @ ( set_ord_lessThan @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N9 ) ) ) ) ) ) ) ) ).

% summable_Leibniz(3)
thf(fact_6717_tendsto__zero__mult__left__iff,axiom,
    ! [A: $tType] :
      ( ( ( field @ A )
        & ( topolo4211221413907600880p_mult @ A ) )
     => ! [C2: A,A2: nat > A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( filterlim @ nat @ A
              @ ^ [N3: nat] : ( times_times @ A @ C2 @ ( A2 @ N3 ) )
              @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) )
              @ ( at_top @ nat ) )
            = ( filterlim @ nat @ A @ A2 @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) ) @ ( at_top @ nat ) ) ) ) ) ).

% tendsto_zero_mult_left_iff
thf(fact_6718_tendsto__zero__mult__right__iff,axiom,
    ! [A: $tType] :
      ( ( ( field @ A )
        & ( topolo4211221413907600880p_mult @ A ) )
     => ! [C2: A,A2: nat > A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( filterlim @ nat @ A
              @ ^ [N3: nat] : ( times_times @ A @ ( A2 @ N3 ) @ C2 )
              @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) )
              @ ( at_top @ nat ) )
            = ( filterlim @ nat @ A @ A2 @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) ) @ ( at_top @ nat ) ) ) ) ) ).

% tendsto_zero_mult_right_iff
thf(fact_6719_tendsto__zero__divide__iff,axiom,
    ! [A: $tType] :
      ( ( ( field @ A )
        & ( topolo4211221413907600880p_mult @ A ) )
     => ! [C2: A,A2: nat > A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( filterlim @ nat @ A
              @ ^ [N3: nat] : ( divide_divide @ A @ ( A2 @ N3 ) @ C2 )
              @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) )
              @ ( at_top @ nat ) )
            = ( filterlim @ nat @ A @ A2 @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) ) @ ( at_top @ nat ) ) ) ) ) ).

% tendsto_zero_divide_iff
thf(fact_6720_approx__from__above__dense__linorder,axiom,
    ! [A: $tType] :
      ( ( ( dense_linorder @ A )
        & ( topolo3112930676232923870pology @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [X2: A,Y2: A] :
          ( ( ord_less @ A @ X2 @ Y2 )
         => ? [U3: nat > A] :
              ( ! [N9: nat] : ( ord_less @ A @ X2 @ ( U3 @ N9 ) )
              & ( filterlim @ nat @ A @ U3 @ ( topolo7230453075368039082e_nhds @ A @ X2 ) @ ( at_top @ nat ) ) ) ) ) ).

% approx_from_above_dense_linorder
thf(fact_6721_approx__from__below__dense__linorder,axiom,
    ! [A: $tType] :
      ( ( ( dense_linorder @ A )
        & ( topolo3112930676232923870pology @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [Y2: A,X2: A] :
          ( ( ord_less @ A @ Y2 @ X2 )
         => ? [U3: nat > A] :
              ( ! [N9: nat] : ( ord_less @ A @ ( U3 @ N9 ) @ X2 )
              & ( filterlim @ nat @ A @ U3 @ ( topolo7230453075368039082e_nhds @ A @ X2 ) @ ( at_top @ nat ) ) ) ) ) ).

% approx_from_below_dense_linorder
thf(fact_6722_filterlim__sequentially__Suc,axiom,
    ! [A: $tType,F2: nat > A,F3: filter @ A] :
      ( ( filterlim @ nat @ A
        @ ^ [X5: nat] : ( F2 @ ( suc @ X5 ) )
        @ F3
        @ ( at_top @ nat ) )
      = ( filterlim @ nat @ A @ F2 @ F3 @ ( at_top @ nat ) ) ) ).

% filterlim_sequentially_Suc
thf(fact_6723_filterlim__Suc,axiom,
    filterlim @ nat @ nat @ suc @ ( at_top @ nat ) @ ( at_top @ nat ) ).

% filterlim_Suc
thf(fact_6724_LIMSEQ__Suc,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [F2: nat > A,L: A] :
          ( ( filterlim @ nat @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ L ) @ ( at_top @ nat ) )
         => ( filterlim @ nat @ A
            @ ^ [N3: nat] : ( F2 @ ( suc @ N3 ) )
            @ ( topolo7230453075368039082e_nhds @ A @ L )
            @ ( at_top @ nat ) ) ) ) ).

% LIMSEQ_Suc
thf(fact_6725_LIMSEQ__imp__Suc,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [F2: nat > A,L: A] :
          ( ( filterlim @ nat @ A
            @ ^ [N3: nat] : ( F2 @ ( suc @ N3 ) )
            @ ( topolo7230453075368039082e_nhds @ A @ L )
            @ ( at_top @ nat ) )
         => ( filterlim @ nat @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ L ) @ ( at_top @ nat ) ) ) ) ).

% LIMSEQ_imp_Suc
thf(fact_6726_LIMSEQ__offset,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [F2: nat > A,K: nat,A2: A] :
          ( ( filterlim @ nat @ A
            @ ^ [N3: nat] : ( F2 @ ( plus_plus @ nat @ N3 @ K ) )
            @ ( topolo7230453075368039082e_nhds @ A @ A2 )
            @ ( at_top @ nat ) )
         => ( filterlim @ nat @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ A2 ) @ ( at_top @ nat ) ) ) ) ).

% LIMSEQ_offset
thf(fact_6727_LIMSEQ__ignore__initial__segment,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [F2: nat > A,A2: A,K: nat] :
          ( ( filterlim @ nat @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ A2 ) @ ( at_top @ nat ) )
         => ( filterlim @ nat @ A
            @ ^ [N3: nat] : ( F2 @ ( plus_plus @ nat @ N3 @ K ) )
            @ ( topolo7230453075368039082e_nhds @ A @ A2 )
            @ ( at_top @ nat ) ) ) ) ).

% LIMSEQ_ignore_initial_segment
thf(fact_6728_LIMSEQ__le__const2,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [X8: nat > A,X2: A,A2: A] :
          ( ( filterlim @ nat @ A @ X8 @ ( topolo7230453075368039082e_nhds @ A @ X2 ) @ ( at_top @ nat ) )
         => ( ? [N7: nat] :
              ! [N: nat] :
                ( ( ord_less_eq @ nat @ N7 @ N )
               => ( ord_less_eq @ A @ ( X8 @ N ) @ A2 ) )
           => ( ord_less_eq @ A @ X2 @ A2 ) ) ) ) ).

% LIMSEQ_le_const2
thf(fact_6729_LIMSEQ__le__const,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [X8: nat > A,X2: A,A2: A] :
          ( ( filterlim @ nat @ A @ X8 @ ( topolo7230453075368039082e_nhds @ A @ X2 ) @ ( at_top @ nat ) )
         => ( ? [N7: nat] :
              ! [N: nat] :
                ( ( ord_less_eq @ nat @ N7 @ N )
               => ( ord_less_eq @ A @ A2 @ ( X8 @ N ) ) )
           => ( ord_less_eq @ A @ A2 @ X2 ) ) ) ) ).

% LIMSEQ_le_const
thf(fact_6730_Lim__bounded2,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [F2: nat > A,L: A,N4: nat,C6: A] :
          ( ( filterlim @ nat @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ L ) @ ( at_top @ nat ) )
         => ( ! [N: nat] :
                ( ( ord_less_eq @ nat @ N4 @ N )
               => ( ord_less_eq @ A @ C6 @ ( F2 @ N ) ) )
           => ( ord_less_eq @ A @ C6 @ L ) ) ) ) ).

% Lim_bounded2
thf(fact_6731_Lim__bounded,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [F2: nat > A,L: A,M7: nat,C6: A] :
          ( ( filterlim @ nat @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ L ) @ ( at_top @ nat ) )
         => ( ! [N: nat] :
                ( ( ord_less_eq @ nat @ M7 @ N )
               => ( ord_less_eq @ A @ ( F2 @ N ) @ C6 ) )
           => ( ord_less_eq @ A @ L @ C6 ) ) ) ) ).

% Lim_bounded
thf(fact_6732_LIMSEQ__le,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [X8: nat > A,X2: A,Y8: nat > A,Y2: A] :
          ( ( filterlim @ nat @ A @ X8 @ ( topolo7230453075368039082e_nhds @ A @ X2 ) @ ( at_top @ nat ) )
         => ( ( filterlim @ nat @ A @ Y8 @ ( topolo7230453075368039082e_nhds @ A @ Y2 ) @ ( at_top @ nat ) )
           => ( ? [N7: nat] :
                ! [N: nat] :
                  ( ( ord_less_eq @ nat @ N7 @ N )
                 => ( ord_less_eq @ A @ ( X8 @ N ) @ ( Y8 @ N ) ) )
             => ( ord_less_eq @ A @ X2 @ Y2 ) ) ) ) ) ).

% LIMSEQ_le
thf(fact_6733_lim__mono,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [N4: nat,X8: nat > A,Y8: nat > A,X2: A,Y2: A] :
          ( ! [N: nat] :
              ( ( ord_less_eq @ nat @ N4 @ N )
             => ( ord_less_eq @ A @ ( X8 @ N ) @ ( Y8 @ N ) ) )
         => ( ( filterlim @ nat @ A @ X8 @ ( topolo7230453075368039082e_nhds @ A @ X2 ) @ ( at_top @ nat ) )
           => ( ( filterlim @ nat @ A @ Y8 @ ( topolo7230453075368039082e_nhds @ A @ Y2 ) @ ( at_top @ nat ) )
             => ( ord_less_eq @ A @ X2 @ Y2 ) ) ) ) ) ).

% lim_mono
thf(fact_6734_Sup__lim,axiom,
    ! [A: $tType] :
      ( ( ( comple5582772986160207858norder @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [B2: nat > A,S2: set @ A,A2: A] :
          ( ! [N: nat] : ( member @ A @ ( B2 @ N ) @ S2 )
         => ( ( filterlim @ nat @ A @ B2 @ ( topolo7230453075368039082e_nhds @ A @ A2 ) @ ( at_top @ nat ) )
           => ( ord_less_eq @ A @ A2 @ ( complete_Sup_Sup @ A @ S2 ) ) ) ) ) ).

% Sup_lim
thf(fact_6735_Inf__lim,axiom,
    ! [A: $tType] :
      ( ( ( comple5582772986160207858norder @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [B2: nat > A,S2: set @ A,A2: A] :
          ( ! [N: nat] : ( member @ A @ ( B2 @ N ) @ S2 )
         => ( ( filterlim @ nat @ A @ B2 @ ( topolo7230453075368039082e_nhds @ A @ A2 ) @ ( at_top @ nat ) )
           => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ S2 ) @ A2 ) ) ) ) ).

% Inf_lim
thf(fact_6736_summable__LIMSEQ__zero,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: nat > A] :
          ( ( summable @ A @ F2 )
         => ( filterlim @ nat @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) ) @ ( at_top @ nat ) ) ) ) ).

% summable_LIMSEQ_zero
thf(fact_6737_mult__nat__left__at__top,axiom,
    ! [C2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ C2 )
     => ( filterlim @ nat @ nat @ ( times_times @ nat @ C2 ) @ ( at_top @ nat ) @ ( at_top @ nat ) ) ) ).

% mult_nat_left_at_top
thf(fact_6738_mult__nat__right__at__top,axiom,
    ! [C2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ C2 )
     => ( filterlim @ nat @ nat
        @ ^ [X5: nat] : ( times_times @ nat @ X5 @ C2 )
        @ ( at_top @ nat )
        @ ( at_top @ nat ) ) ) ).

% mult_nat_right_at_top
thf(fact_6739_monoseq__convergent,axiom,
    ! [X8: nat > real,B3: real] :
      ( ( topological_monoseq @ real @ X8 )
     => ( ! [I2: nat] : ( ord_less_eq @ real @ ( abs_abs @ real @ ( X8 @ I2 ) ) @ B3 )
       => ~ ! [L6: real] :
              ~ ( filterlim @ nat @ real @ X8 @ ( topolo7230453075368039082e_nhds @ real @ L6 ) @ ( at_top @ nat ) ) ) ) ).

% monoseq_convergent
thf(fact_6740_monoseq__le,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [A2: nat > A,X2: A] :
          ( ( topological_monoseq @ A @ A2 )
         => ( ( filterlim @ nat @ A @ A2 @ ( topolo7230453075368039082e_nhds @ A @ X2 ) @ ( at_top @ nat ) )
           => ( ( ! [N9: nat] : ( ord_less_eq @ A @ ( A2 @ N9 ) @ X2 )
                & ! [M2: nat,N9: nat] :
                    ( ( ord_less_eq @ nat @ M2 @ N9 )
                   => ( ord_less_eq @ A @ ( A2 @ M2 ) @ ( A2 @ N9 ) ) ) )
              | ( ! [N9: nat] : ( ord_less_eq @ A @ X2 @ ( A2 @ N9 ) )
                & ! [M2: nat,N9: nat] :
                    ( ( ord_less_eq @ nat @ M2 @ N9 )
                   => ( ord_less_eq @ A @ ( A2 @ N9 ) @ ( A2 @ M2 ) ) ) ) ) ) ) ) ).

% monoseq_le
thf(fact_6741_lim__const__over__n,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [A2: A] :
          ( filterlim @ nat @ A
          @ ^ [N3: nat] : ( divide_divide @ A @ A2 @ ( semiring_1_of_nat @ A @ N3 ) )
          @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) )
          @ ( at_top @ nat ) ) ) ).

% lim_const_over_n
thf(fact_6742_lim__inverse__n,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ( filterlim @ nat @ A
        @ ^ [N3: nat] : ( inverse_inverse @ A @ ( semiring_1_of_nat @ A @ N3 ) )
        @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) )
        @ ( at_top @ nat ) ) ) ).

% lim_inverse_n
thf(fact_6743_LIMSEQ__linear,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [X8: nat > A,X2: A,L: nat] :
          ( ( filterlim @ nat @ A @ X8 @ ( topolo7230453075368039082e_nhds @ A @ X2 ) @ ( at_top @ nat ) )
         => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ L )
           => ( filterlim @ nat @ A
              @ ^ [N3: nat] : ( X8 @ ( times_times @ nat @ N3 @ L ) )
              @ ( topolo7230453075368039082e_nhds @ A @ X2 )
              @ ( at_top @ nat ) ) ) ) ) ).

% LIMSEQ_linear
thf(fact_6744_telescope__summable_H,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: nat > A,C2: A] :
          ( ( filterlim @ nat @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ C2 ) @ ( at_top @ nat ) )
         => ( summable @ A
            @ ^ [N3: nat] : ( minus_minus @ A @ ( F2 @ N3 ) @ ( F2 @ ( suc @ N3 ) ) ) ) ) ) ).

% telescope_summable'
thf(fact_6745_telescope__summable,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: nat > A,C2: A] :
          ( ( filterlim @ nat @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ C2 ) @ ( at_top @ nat ) )
         => ( summable @ A
            @ ^ [N3: nat] : ( minus_minus @ A @ ( F2 @ ( suc @ N3 ) ) @ ( F2 @ N3 ) ) ) ) ) ).

% telescope_summable
thf(fact_6746_nested__sequence__unique,axiom,
    ! [F2: nat > real,G: nat > real] :
      ( ! [N: nat] : ( ord_less_eq @ real @ ( F2 @ N ) @ ( F2 @ ( suc @ N ) ) )
     => ( ! [N: nat] : ( ord_less_eq @ real @ ( G @ ( suc @ N ) ) @ ( G @ N ) )
       => ( ! [N: nat] : ( ord_less_eq @ real @ ( F2 @ N ) @ ( G @ N ) )
         => ( ( filterlim @ nat @ real
              @ ^ [N3: nat] : ( minus_minus @ real @ ( F2 @ N3 ) @ ( G @ N3 ) )
              @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
              @ ( at_top @ nat ) )
           => ? [L4: real] :
                ( ! [N9: nat] : ( ord_less_eq @ real @ ( F2 @ N9 ) @ L4 )
                & ( filterlim @ nat @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ L4 ) @ ( at_top @ nat ) )
                & ! [N9: nat] : ( ord_less_eq @ real @ L4 @ ( G @ N9 ) )
                & ( filterlim @ nat @ real @ G @ ( topolo7230453075368039082e_nhds @ real @ L4 ) @ ( at_top @ nat ) ) ) ) ) ) ) ).

% nested_sequence_unique
thf(fact_6747_LIMSEQ__inverse__zero,axiom,
    ! [X8: nat > real] :
      ( ! [R4: real] :
        ? [N7: nat] :
        ! [N: nat] :
          ( ( ord_less_eq @ nat @ N7 @ N )
         => ( ord_less @ real @ R4 @ ( X8 @ N ) ) )
     => ( filterlim @ nat @ real
        @ ^ [N3: nat] : ( inverse_inverse @ real @ ( X8 @ N3 ) )
        @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
        @ ( at_top @ nat ) ) ) ).

% LIMSEQ_inverse_zero
thf(fact_6748_lim__inverse__n_H,axiom,
    ( filterlim @ nat @ real
    @ ^ [N3: nat] : ( divide_divide @ real @ ( one_one @ real ) @ ( semiring_1_of_nat @ real @ N3 ) )
    @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
    @ ( at_top @ nat ) ) ).

% lim_inverse_n'
thf(fact_6749_LIMSEQ__root__const,axiom,
    ! [C2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ C2 )
     => ( filterlim @ nat @ real
        @ ^ [N3: nat] : ( root @ N3 @ C2 )
        @ ( topolo7230453075368039082e_nhds @ real @ ( one_one @ real ) )
        @ ( at_top @ nat ) ) ) ).

% LIMSEQ_root_const
thf(fact_6750_LIMSEQ__inverse__real__of__nat,axiom,
    ( filterlim @ nat @ real
    @ ^ [N3: nat] : ( inverse_inverse @ real @ ( semiring_1_of_nat @ real @ ( suc @ N3 ) ) )
    @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
    @ ( at_top @ nat ) ) ).

% LIMSEQ_inverse_real_of_nat
thf(fact_6751_LIMSEQ__inverse__real__of__nat__add,axiom,
    ! [R3: real] :
      ( filterlim @ nat @ real
      @ ^ [N3: nat] : ( plus_plus @ real @ R3 @ ( inverse_inverse @ real @ ( semiring_1_of_nat @ real @ ( suc @ N3 ) ) ) )
      @ ( topolo7230453075368039082e_nhds @ real @ R3 )
      @ ( at_top @ nat ) ) ).

% LIMSEQ_inverse_real_of_nat_add
thf(fact_6752_increasing__LIMSEQ,axiom,
    ! [F2: nat > real,L: real] :
      ( ! [N: nat] : ( ord_less_eq @ real @ ( F2 @ N ) @ ( F2 @ ( suc @ N ) ) )
     => ( ! [N: nat] : ( ord_less_eq @ real @ ( F2 @ N ) @ L )
       => ( ! [E: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ E )
             => ? [N9: nat] : ( ord_less_eq @ real @ L @ ( plus_plus @ real @ ( F2 @ N9 ) @ E ) ) )
         => ( filterlim @ nat @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ L ) @ ( at_top @ nat ) ) ) ) ) ).

% increasing_LIMSEQ
thf(fact_6753_lim__1__over__n,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ( filterlim @ nat @ A
        @ ^ [N3: nat] : ( divide_divide @ A @ ( one_one @ A ) @ ( semiring_1_of_nat @ A @ N3 ) )
        @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) )
        @ ( at_top @ nat ) ) ) ).

% lim_1_over_n
thf(fact_6754_LIMSEQ__Suc__n__over__n,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ( filterlim @ nat @ A
        @ ^ [N3: nat] : ( divide_divide @ A @ ( semiring_1_of_nat @ A @ ( suc @ N3 ) ) @ ( semiring_1_of_nat @ A @ N3 ) )
        @ ( topolo7230453075368039082e_nhds @ A @ ( one_one @ A ) )
        @ ( at_top @ nat ) ) ) ).

% LIMSEQ_Suc_n_over_n
thf(fact_6755_LIMSEQ__n__over__Suc__n,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ( filterlim @ nat @ A
        @ ^ [N3: nat] : ( divide_divide @ A @ ( semiring_1_of_nat @ A @ N3 ) @ ( semiring_1_of_nat @ A @ ( suc @ N3 ) ) )
        @ ( topolo7230453075368039082e_nhds @ A @ ( one_one @ A ) )
        @ ( at_top @ nat ) ) ) ).

% LIMSEQ_n_over_Suc_n
thf(fact_6756_LIMSEQ__realpow__zero,axiom,
    ! [X2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( ord_less @ real @ X2 @ ( one_one @ real ) )
       => ( filterlim @ nat @ real @ ( power_power @ real @ X2 ) @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( at_top @ nat ) ) ) ) ).

% LIMSEQ_realpow_zero
thf(fact_6757_telescope__sums,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: nat > A,C2: A] :
          ( ( filterlim @ nat @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ C2 ) @ ( at_top @ nat ) )
         => ( sums @ A
            @ ^ [N3: nat] : ( minus_minus @ A @ ( F2 @ ( suc @ N3 ) ) @ ( F2 @ N3 ) )
            @ ( minus_minus @ A @ C2 @ ( F2 @ ( zero_zero @ nat ) ) ) ) ) ) ).

% telescope_sums
thf(fact_6758_telescope__sums_H,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: nat > A,C2: A] :
          ( ( filterlim @ nat @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ C2 ) @ ( at_top @ nat ) )
         => ( sums @ A
            @ ^ [N3: nat] : ( minus_minus @ A @ ( F2 @ N3 ) @ ( F2 @ ( suc @ N3 ) ) )
            @ ( minus_minus @ A @ ( F2 @ ( zero_zero @ nat ) ) @ C2 ) ) ) ) ).

% telescope_sums'
thf(fact_6759_LIMSEQ__divide__realpow__zero,axiom,
    ! [X2: real,A2: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ X2 )
     => ( filterlim @ nat @ real
        @ ^ [N3: nat] : ( divide_divide @ real @ A2 @ ( power_power @ real @ X2 @ N3 ) )
        @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
        @ ( at_top @ nat ) ) ) ).

% LIMSEQ_divide_realpow_zero
thf(fact_6760_LIMSEQ__abs__realpow__zero2,axiom,
    ! [C2: real] :
      ( ( ord_less @ real @ ( abs_abs @ real @ C2 ) @ ( one_one @ real ) )
     => ( filterlim @ nat @ real @ ( power_power @ real @ C2 ) @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( at_top @ nat ) ) ) ).

% LIMSEQ_abs_realpow_zero2
thf(fact_6761_LIMSEQ__abs__realpow__zero,axiom,
    ! [C2: real] :
      ( ( ord_less @ real @ ( abs_abs @ real @ C2 ) @ ( one_one @ real ) )
     => ( filterlim @ nat @ real @ ( power_power @ real @ ( abs_abs @ real @ C2 ) ) @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( at_top @ nat ) ) ) ).

% LIMSEQ_abs_realpow_zero
thf(fact_6762_LIMSEQ__inverse__realpow__zero,axiom,
    ! [X2: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ X2 )
     => ( filterlim @ nat @ real
        @ ^ [N3: nat] : ( inverse_inverse @ real @ ( power_power @ real @ X2 @ N3 ) )
        @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
        @ ( at_top @ nat ) ) ) ).

% LIMSEQ_inverse_realpow_zero
thf(fact_6763_sums__def_H,axiom,
    ! [A: $tType] :
      ( ( ( comm_monoid_add @ A )
        & ( topolo4958980785337419405_space @ A ) )
     => ( ( sums @ A )
        = ( ^ [F5: nat > A,S7: A] :
              ( filterlim @ nat @ A
              @ ^ [N3: nat] : ( groups7311177749621191930dd_sum @ nat @ A @ F5 @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N3 ) )
              @ ( topolo7230453075368039082e_nhds @ A @ S7 )
              @ ( at_top @ nat ) ) ) ) ) ).

% sums_def'
thf(fact_6764_root__test__convergence,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach @ A )
     => ! [F2: nat > A,X2: real] :
          ( ( filterlim @ nat @ real
            @ ^ [N3: nat] : ( root @ N3 @ ( real_V7770717601297561774m_norm @ A @ ( F2 @ N3 ) ) )
            @ ( topolo7230453075368039082e_nhds @ real @ X2 )
            @ ( at_top @ nat ) )
         => ( ( ord_less @ real @ X2 @ ( one_one @ real ) )
           => ( summable @ A @ F2 ) ) ) ) ).

% root_test_convergence
thf(fact_6765_LIMSEQ__inverse__real__of__nat__add__minus,axiom,
    ! [R3: real] :
      ( filterlim @ nat @ real
      @ ^ [N3: nat] : ( plus_plus @ real @ R3 @ ( uminus_uminus @ real @ ( inverse_inverse @ real @ ( semiring_1_of_nat @ real @ ( suc @ N3 ) ) ) ) )
      @ ( topolo7230453075368039082e_nhds @ real @ R3 )
      @ ( at_top @ nat ) ) ).

% LIMSEQ_inverse_real_of_nat_add_minus
thf(fact_6766_LIMSEQ__D,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X8: nat > A,L5: A,R3: real] :
          ( ( filterlim @ nat @ A @ X8 @ ( topolo7230453075368039082e_nhds @ A @ L5 ) @ ( at_top @ nat ) )
         => ( ( ord_less @ real @ ( zero_zero @ real ) @ R3 )
           => ? [No: nat] :
              ! [N9: nat] :
                ( ( ord_less_eq @ nat @ No @ N9 )
               => ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ ( X8 @ N9 ) @ L5 ) ) @ R3 ) ) ) ) ) ).

% LIMSEQ_D
thf(fact_6767_LIMSEQ__I,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X8: nat > A,L5: A] :
          ( ! [R4: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ R4 )
             => ? [No2: nat] :
                ! [N: nat] :
                  ( ( ord_less_eq @ nat @ No2 @ N )
                 => ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ ( X8 @ N ) @ L5 ) ) @ R4 ) ) )
         => ( filterlim @ nat @ A @ X8 @ ( topolo7230453075368039082e_nhds @ A @ L5 ) @ ( at_top @ nat ) ) ) ) ).

% LIMSEQ_I
thf(fact_6768_LIMSEQ__iff,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X8: nat > A,L5: A] :
          ( ( filterlim @ nat @ A @ X8 @ ( topolo7230453075368039082e_nhds @ A @ L5 ) @ ( at_top @ nat ) )
          = ( ! [R5: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ R5 )
               => ? [No3: nat] :
                  ! [N3: nat] :
                    ( ( ord_less_eq @ nat @ No3 @ N3 )
                   => ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ ( X8 @ N3 ) @ L5 ) ) @ R5 ) ) ) ) ) ) ).

% LIMSEQ_iff
thf(fact_6769_LIMSEQ__power__zero,axiom,
    ! [A: $tType] :
      ( ( real_V2822296259951069270ebra_1 @ A )
     => ! [X2: A] :
          ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ X2 ) @ ( one_one @ real ) )
         => ( filterlim @ nat @ A @ ( power_power @ A @ X2 ) @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) ) @ ( at_top @ nat ) ) ) ) ).

% LIMSEQ_power_zero
thf(fact_6770_tendsto__exp__limit__sequentially,axiom,
    ! [X2: real] :
      ( filterlim @ nat @ real
      @ ^ [N3: nat] : ( power_power @ real @ ( plus_plus @ real @ ( one_one @ real ) @ ( divide_divide @ real @ X2 @ ( semiring_1_of_nat @ real @ N3 ) ) ) @ N3 )
      @ ( topolo7230453075368039082e_nhds @ real @ ( exp @ real @ X2 ) )
      @ ( at_top @ nat ) ) ).

% tendsto_exp_limit_sequentially
thf(fact_6771_tendsto__power__zero,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V2822296259951069270ebra_1 @ A )
     => ! [F2: B > nat,F3: filter @ B,X2: A] :
          ( ( filterlim @ B @ nat @ F2 @ ( at_top @ nat ) @ F3 )
         => ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ X2 ) @ ( one_one @ real ) )
           => ( filterlim @ B @ A
              @ ^ [Y5: B] : ( power_power @ A @ X2 @ ( F2 @ Y5 ) )
              @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) )
              @ F3 ) ) ) ) ).

% tendsto_power_zero
thf(fact_6772_LIMSEQ__inverse__real__of__nat__add__minus__mult,axiom,
    ! [R3: real] :
      ( filterlim @ nat @ real
      @ ^ [N3: nat] : ( times_times @ real @ R3 @ ( plus_plus @ real @ ( one_one @ real ) @ ( uminus_uminus @ real @ ( inverse_inverse @ real @ ( semiring_1_of_nat @ real @ ( suc @ N3 ) ) ) ) ) )
      @ ( topolo7230453075368039082e_nhds @ real @ R3 )
      @ ( at_top @ nat ) ) ).

% LIMSEQ_inverse_real_of_nat_add_minus_mult
thf(fact_6773_LIMSEQ__norm__0,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: nat > A] :
          ( ! [N: nat] : ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( F2 @ N ) ) @ ( divide_divide @ real @ ( one_one @ real ) @ ( semiring_1_of_nat @ real @ ( suc @ N ) ) ) )
         => ( filterlim @ nat @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) ) @ ( at_top @ nat ) ) ) ) ).

% LIMSEQ_norm_0
thf(fact_6774_summable__Leibniz_I1_J,axiom,
    ! [A2: nat > real] :
      ( ( filterlim @ nat @ real @ A2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( at_top @ nat ) )
     => ( ( topological_monoseq @ real @ A2 )
       => ( summable @ real
          @ ^ [N3: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ N3 ) @ ( A2 @ N3 ) ) ) ) ) ).

% summable_Leibniz(1)
thf(fact_6775_field__derivative__lim__unique,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,Df: A,Z: A,S2: nat > A,A2: A] :
          ( ( has_field_derivative @ A @ F2 @ Df @ ( topolo174197925503356063within @ A @ Z @ ( top_top @ ( set @ A ) ) ) )
         => ( ( filterlim @ nat @ A @ S2 @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) ) @ ( at_top @ nat ) )
           => ( ! [N: nat] :
                  ( ( S2 @ N )
                 != ( zero_zero @ A ) )
             => ( ( filterlim @ nat @ A
                  @ ^ [N3: nat] : ( divide_divide @ A @ ( minus_minus @ A @ ( F2 @ ( plus_plus @ A @ Z @ ( S2 @ N3 ) ) ) @ ( F2 @ Z ) ) @ ( S2 @ N3 ) )
                  @ ( topolo7230453075368039082e_nhds @ A @ A2 )
                  @ ( at_top @ nat ) )
               => ( Df = A2 ) ) ) ) ) ) ).

% field_derivative_lim_unique
thf(fact_6776_powser__times__n__limit__0,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V8999393235501362500lgebra @ A ) )
     => ! [X2: A] :
          ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ X2 ) @ ( one_one @ real ) )
         => ( filterlim @ nat @ A
            @ ^ [N3: nat] : ( times_times @ A @ ( semiring_1_of_nat @ A @ N3 ) @ ( power_power @ A @ X2 @ N3 ) )
            @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) )
            @ ( at_top @ nat ) ) ) ) ).

% powser_times_n_limit_0
thf(fact_6777_lim__n__over__pown,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X2: A] :
          ( ( ord_less @ real @ ( one_one @ real ) @ ( real_V7770717601297561774m_norm @ A @ X2 ) )
         => ( filterlim @ nat @ A
            @ ^ [N3: nat] : ( divide_divide @ A @ ( semiring_1_of_nat @ A @ N3 ) @ ( power_power @ A @ X2 @ N3 ) )
            @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) )
            @ ( at_top @ nat ) ) ) ) ).

% lim_n_over_pown
thf(fact_6778_summable,axiom,
    ! [A2: nat > real] :
      ( ( filterlim @ nat @ real @ A2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( at_top @ nat ) )
     => ( ! [N: nat] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( A2 @ N ) )
       => ( ! [N: nat] : ( ord_less_eq @ real @ ( A2 @ ( suc @ N ) ) @ ( A2 @ N ) )
         => ( summable @ real
            @ ^ [N3: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ N3 ) @ ( A2 @ N3 ) ) ) ) ) ) ).

% summable
thf(fact_6779_cos__diff__limit__1,axiom,
    ! [Theta: nat > real,Theta2: real] :
      ( ( filterlim @ nat @ real
        @ ^ [J3: nat] : ( cos @ real @ ( minus_minus @ real @ ( Theta @ J3 ) @ Theta2 ) )
        @ ( topolo7230453075368039082e_nhds @ real @ ( one_one @ real ) )
        @ ( at_top @ nat ) )
     => ~ ! [K2: nat > int] :
            ~ ( filterlim @ nat @ real
              @ ^ [J3: nat] : ( minus_minus @ real @ ( Theta @ J3 ) @ ( times_times @ real @ ( ring_1_of_int @ real @ ( K2 @ J3 ) ) @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) ) )
              @ ( topolo7230453075368039082e_nhds @ real @ Theta2 )
              @ ( at_top @ nat ) ) ) ).

% cos_diff_limit_1
thf(fact_6780_cos__limit__1,axiom,
    ! [Theta: nat > real] :
      ( ( filterlim @ nat @ real
        @ ^ [J3: nat] : ( cos @ real @ ( Theta @ J3 ) )
        @ ( topolo7230453075368039082e_nhds @ real @ ( one_one @ real ) )
        @ ( at_top @ nat ) )
     => ? [K2: nat > int] :
          ( filterlim @ nat @ real
          @ ^ [J3: nat] : ( minus_minus @ real @ ( Theta @ J3 ) @ ( times_times @ real @ ( ring_1_of_int @ real @ ( K2 @ J3 ) ) @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) ) )
          @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
          @ ( at_top @ nat ) ) ) ).

% cos_limit_1
thf(fact_6781_summable__Leibniz_I4_J,axiom,
    ! [A2: nat > real] :
      ( ( filterlim @ nat @ real @ A2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( at_top @ nat ) )
     => ( ( topological_monoseq @ real @ A2 )
       => ( filterlim @ nat @ real
          @ ^ [N3: nat] :
              ( groups7311177749621191930dd_sum @ nat @ real
              @ ^ [I4: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I4 ) @ ( A2 @ I4 ) )
              @ ( set_ord_lessThan @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N3 ) ) )
          @ ( topolo7230453075368039082e_nhds @ real
            @ ( suminf @ real
              @ ^ [I4: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I4 ) @ ( A2 @ I4 ) ) ) )
          @ ( at_top @ nat ) ) ) ) ).

% summable_Leibniz(4)
thf(fact_6782_zeroseq__arctan__series,axiom,
    ! [X2: real] :
      ( ( ord_less_eq @ real @ ( abs_abs @ real @ X2 ) @ ( one_one @ real ) )
     => ( filterlim @ nat @ real
        @ ^ [N3: nat] : ( times_times @ real @ ( divide_divide @ real @ ( one_one @ real ) @ ( semiring_1_of_nat @ real @ ( plus_plus @ nat @ ( times_times @ nat @ N3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ nat ) ) ) ) @ ( power_power @ real @ X2 @ ( plus_plus @ nat @ ( times_times @ nat @ N3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ nat ) ) ) )
        @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
        @ ( at_top @ nat ) ) ) ).

% zeroseq_arctan_series
thf(fact_6783_summable__Leibniz_H_I3_J,axiom,
    ! [A2: nat > real] :
      ( ( filterlim @ nat @ real @ A2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( at_top @ nat ) )
     => ( ! [N: nat] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( A2 @ N ) )
       => ( ! [N: nat] : ( ord_less_eq @ real @ ( A2 @ ( suc @ N ) ) @ ( A2 @ N ) )
         => ( filterlim @ nat @ real
            @ ^ [N3: nat] :
                ( groups7311177749621191930dd_sum @ nat @ real
                @ ^ [I4: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I4 ) @ ( A2 @ I4 ) )
                @ ( set_ord_lessThan @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N3 ) ) )
            @ ( topolo7230453075368039082e_nhds @ real
              @ ( suminf @ real
                @ ^ [I4: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I4 ) @ ( A2 @ I4 ) ) ) )
            @ ( at_top @ nat ) ) ) ) ) ).

% summable_Leibniz'(3)
thf(fact_6784_summable__Leibniz_H_I2_J,axiom,
    ! [A2: nat > real,N2: nat] :
      ( ( filterlim @ nat @ real @ A2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( at_top @ nat ) )
     => ( ! [N: nat] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( A2 @ N ) )
       => ( ! [N: nat] : ( ord_less_eq @ real @ ( A2 @ ( suc @ N ) ) @ ( A2 @ N ) )
         => ( ord_less_eq @ real
            @ ( groups7311177749621191930dd_sum @ nat @ real
              @ ^ [I4: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I4 ) @ ( A2 @ I4 ) )
              @ ( set_ord_lessThan @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) )
            @ ( suminf @ real
              @ ^ [I4: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I4 ) @ ( A2 @ I4 ) ) ) ) ) ) ) ).

% summable_Leibniz'(2)
thf(fact_6785_sums__alternating__upper__lower,axiom,
    ! [A2: nat > real] :
      ( ! [N: nat] : ( ord_less_eq @ real @ ( A2 @ ( suc @ N ) ) @ ( A2 @ N ) )
     => ( ! [N: nat] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( A2 @ N ) )
       => ( ( filterlim @ nat @ real @ A2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( at_top @ nat ) )
         => ? [L4: real] :
              ( ! [N9: nat] :
                  ( ord_less_eq @ real
                  @ ( groups7311177749621191930dd_sum @ nat @ real
                    @ ^ [I4: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I4 ) @ ( A2 @ I4 ) )
                    @ ( set_ord_lessThan @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N9 ) ) )
                  @ L4 )
              & ( filterlim @ nat @ real
                @ ^ [N3: nat] :
                    ( groups7311177749621191930dd_sum @ nat @ real
                    @ ^ [I4: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I4 ) @ ( A2 @ I4 ) )
                    @ ( set_ord_lessThan @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N3 ) ) )
                @ ( topolo7230453075368039082e_nhds @ real @ L4 )
                @ ( at_top @ nat ) )
              & ! [N9: nat] :
                  ( ord_less_eq @ real @ L4
                  @ ( groups7311177749621191930dd_sum @ nat @ real
                    @ ^ [I4: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I4 ) @ ( A2 @ I4 ) )
                    @ ( set_ord_lessThan @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N9 ) @ ( one_one @ nat ) ) ) ) )
              & ( filterlim @ nat @ real
                @ ^ [N3: nat] :
                    ( groups7311177749621191930dd_sum @ nat @ real
                    @ ^ [I4: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I4 ) @ ( A2 @ I4 ) )
                    @ ( set_ord_lessThan @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N3 ) @ ( one_one @ nat ) ) ) )
                @ ( topolo7230453075368039082e_nhds @ real @ L4 )
                @ ( at_top @ nat ) ) ) ) ) ) ).

% sums_alternating_upper_lower
thf(fact_6786_summable__Leibniz_I5_J,axiom,
    ! [A2: nat > real] :
      ( ( filterlim @ nat @ real @ A2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( at_top @ nat ) )
     => ( ( topological_monoseq @ real @ A2 )
       => ( filterlim @ nat @ real
          @ ^ [N3: nat] :
              ( groups7311177749621191930dd_sum @ nat @ real
              @ ^ [I4: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I4 ) @ ( A2 @ I4 ) )
              @ ( set_ord_lessThan @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N3 ) @ ( one_one @ nat ) ) ) )
          @ ( topolo7230453075368039082e_nhds @ real
            @ ( suminf @ real
              @ ^ [I4: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I4 ) @ ( A2 @ I4 ) ) ) )
          @ ( at_top @ nat ) ) ) ) ).

% summable_Leibniz(5)
thf(fact_6787_summable__Leibniz_H_I5_J,axiom,
    ! [A2: nat > real] :
      ( ( filterlim @ nat @ real @ A2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( at_top @ nat ) )
     => ( ! [N: nat] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( A2 @ N ) )
       => ( ! [N: nat] : ( ord_less_eq @ real @ ( A2 @ ( suc @ N ) ) @ ( A2 @ N ) )
         => ( filterlim @ nat @ real
            @ ^ [N3: nat] :
                ( groups7311177749621191930dd_sum @ nat @ real
                @ ^ [I4: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I4 ) @ ( A2 @ I4 ) )
                @ ( set_ord_lessThan @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N3 ) @ ( one_one @ nat ) ) ) )
            @ ( topolo7230453075368039082e_nhds @ real
              @ ( suminf @ real
                @ ^ [I4: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I4 ) @ ( A2 @ I4 ) ) ) )
            @ ( at_top @ nat ) ) ) ) ) ).

% summable_Leibniz'(5)
thf(fact_6788_summable__Leibniz_H_I4_J,axiom,
    ! [A2: nat > real,N2: nat] :
      ( ( filterlim @ nat @ real @ A2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( at_top @ nat ) )
     => ( ! [N: nat] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( A2 @ N ) )
       => ( ! [N: nat] : ( ord_less_eq @ real @ ( A2 @ ( suc @ N ) ) @ ( A2 @ N ) )
         => ( ord_less_eq @ real
            @ ( suminf @ real
              @ ^ [I4: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I4 ) @ ( A2 @ I4 ) ) )
            @ ( groups7311177749621191930dd_sum @ nat @ real
              @ ^ [I4: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I4 ) @ ( A2 @ I4 ) )
              @ ( set_ord_lessThan @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) @ ( one_one @ nat ) ) ) ) ) ) ) ) ).

% summable_Leibniz'(4)
thf(fact_6789_has__derivative__at2,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F2: A > B,F8: A > B,X2: A] :
          ( ( has_derivative @ A @ B @ F2 @ F8 @ ( topolo174197925503356063within @ A @ X2 @ ( top_top @ ( set @ A ) ) ) )
          = ( ( real_V3181309239436604168linear @ A @ B @ F8 )
            & ( filterlim @ A @ B
              @ ^ [Y5: A] : ( real_V8093663219630862766scaleR @ B @ ( divide_divide @ real @ ( one_one @ real ) @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ Y5 @ X2 ) ) ) @ ( minus_minus @ B @ ( F2 @ Y5 ) @ ( plus_plus @ B @ ( F2 @ X2 ) @ ( F8 @ ( minus_minus @ A @ Y5 @ X2 ) ) ) ) )
              @ ( topolo7230453075368039082e_nhds @ B @ ( zero_zero @ B ) )
              @ ( topolo174197925503356063within @ A @ X2 @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ).

% has_derivative_at2
thf(fact_6790_has__derivative__at,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F2: A > B,D5: A > B,X2: A] :
          ( ( has_derivative @ A @ B @ F2 @ D5 @ ( topolo174197925503356063within @ A @ X2 @ ( top_top @ ( set @ A ) ) ) )
          = ( ( real_V3181309239436604168linear @ A @ B @ D5 )
            & ( filterlim @ A @ real
              @ ^ [H: A] : ( divide_divide @ real @ ( real_V7770717601297561774m_norm @ B @ ( minus_minus @ B @ ( minus_minus @ B @ ( F2 @ ( plus_plus @ A @ X2 @ H ) ) @ ( F2 @ X2 ) ) @ ( D5 @ H ) ) ) @ ( real_V7770717601297561774m_norm @ A @ H ) )
              @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
              @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ).

% has_derivative_at
thf(fact_6791_bounded__linear__divide,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [Y2: A] :
          ( real_V3181309239436604168linear @ A @ A
          @ ^ [X5: A] : ( divide_divide @ A @ X5 @ Y2 ) ) ) ).

% bounded_linear_divide
thf(fact_6792_bounded__linear__mult__right,axiom,
    ! [A: $tType] :
      ( ( real_V4412858255891104859lgebra @ A )
     => ! [X2: A] : ( real_V3181309239436604168linear @ A @ A @ ( times_times @ A @ X2 ) ) ) ).

% bounded_linear_mult_right
thf(fact_6793_bounded__linear__mult__const,axiom,
    ! [A: $tType,C: $tType] :
      ( ( ( real_V822414075346904944vector @ C )
        & ( real_V4412858255891104859lgebra @ A ) )
     => ! [G: C > A,Y2: A] :
          ( ( real_V3181309239436604168linear @ C @ A @ G )
         => ( real_V3181309239436604168linear @ C @ A
            @ ^ [X5: C] : ( times_times @ A @ ( G @ X5 ) @ Y2 ) ) ) ) ).

% bounded_linear_mult_const
thf(fact_6794_bounded__linear__const__mult,axiom,
    ! [A: $tType,C: $tType] :
      ( ( ( real_V822414075346904944vector @ C )
        & ( real_V4412858255891104859lgebra @ A ) )
     => ! [G: C > A,X2: A] :
          ( ( real_V3181309239436604168linear @ C @ A @ G )
         => ( real_V3181309239436604168linear @ C @ A
            @ ^ [X5: C] : ( times_times @ A @ X2 @ ( G @ X5 ) ) ) ) ) ).

% bounded_linear_const_mult
thf(fact_6795_bounded__linear__mult__left,axiom,
    ! [A: $tType] :
      ( ( real_V4412858255891104859lgebra @ A )
     => ! [Y2: A] :
          ( real_V3181309239436604168linear @ A @ A
          @ ^ [X5: A] : ( times_times @ A @ X5 @ Y2 ) ) ) ).

% bounded_linear_mult_left
thf(fact_6796_real__bounded__linear,axiom,
    ( ( real_V3181309239436604168linear @ real @ real )
    = ( ^ [F5: real > real] :
        ? [C4: real] :
          ( F5
          = ( ^ [X5: real] : ( times_times @ real @ X5 @ C4 ) ) ) ) ) ).

% real_bounded_linear
thf(fact_6797_bounded__linear__zero,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ( real_V3181309239436604168linear @ A @ B
        @ ^ [X5: A] : ( zero_zero @ B ) ) ) ).

% bounded_linear_zero
thf(fact_6798_bounded__linear__add,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F2: A > B,G: A > B] :
          ( ( real_V3181309239436604168linear @ A @ B @ F2 )
         => ( ( real_V3181309239436604168linear @ A @ B @ G )
           => ( real_V3181309239436604168linear @ A @ B
              @ ^ [X5: A] : ( plus_plus @ B @ ( F2 @ X5 ) @ ( G @ X5 ) ) ) ) ) ) ).

% bounded_linear_add
thf(fact_6799_bounded__linear_Obounded,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F2: A > B] :
          ( ( real_V3181309239436604168linear @ A @ B @ F2 )
         => ? [K9: real] :
            ! [X: A] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ B @ ( F2 @ X ) ) @ ( times_times @ real @ ( real_V7770717601297561774m_norm @ A @ X ) @ K9 ) ) ) ) ).

% bounded_linear.bounded
thf(fact_6800_bounded__linear_Otendsto__zero,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F2: A > B,G: C > A,F3: filter @ C] :
          ( ( real_V3181309239436604168linear @ A @ B @ F2 )
         => ( ( filterlim @ C @ A @ G @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) ) @ F3 )
           => ( filterlim @ C @ B
              @ ^ [X5: C] : ( F2 @ ( G @ X5 ) )
              @ ( topolo7230453075368039082e_nhds @ B @ ( zero_zero @ B ) )
              @ F3 ) ) ) ) ).

% bounded_linear.tendsto_zero
thf(fact_6801_bounded__linear_Ononneg__bounded,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F2: A > B] :
          ( ( real_V3181309239436604168linear @ A @ B @ F2 )
         => ? [K9: real] :
              ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ K9 )
              & ! [X: A] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ B @ ( F2 @ X ) ) @ ( times_times @ real @ ( real_V7770717601297561774m_norm @ A @ X ) @ K9 ) ) ) ) ) ).

% bounded_linear.nonneg_bounded
thf(fact_6802_bounded__linear_Opos__bounded,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F2: A > B] :
          ( ( real_V3181309239436604168linear @ A @ B @ F2 )
         => ? [K9: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ K9 )
              & ! [X: A] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ B @ ( F2 @ X ) ) @ ( times_times @ real @ ( real_V7770717601297561774m_norm @ A @ X ) @ K9 ) ) ) ) ) ).

% bounded_linear.pos_bounded
thf(fact_6803_bounded__linear__intro,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F2: A > B,K5: real] :
          ( ! [X3: A,Y4: A] :
              ( ( F2 @ ( plus_plus @ A @ X3 @ Y4 ) )
              = ( plus_plus @ B @ ( F2 @ X3 ) @ ( F2 @ Y4 ) ) )
         => ( ! [R4: real,X3: A] :
                ( ( F2 @ ( real_V8093663219630862766scaleR @ A @ R4 @ X3 ) )
                = ( real_V8093663219630862766scaleR @ B @ R4 @ ( F2 @ X3 ) ) )
           => ( ! [X3: A] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ B @ ( F2 @ X3 ) ) @ ( times_times @ real @ ( real_V7770717601297561774m_norm @ A @ X3 ) @ K5 ) )
             => ( real_V3181309239436604168linear @ A @ B @ F2 ) ) ) ) ) ).

% bounded_linear_intro
thf(fact_6804_has__derivative__iff__norm,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F2: A > B,F8: A > B,X2: A,S2: set @ A] :
          ( ( has_derivative @ A @ B @ F2 @ F8 @ ( topolo174197925503356063within @ A @ X2 @ S2 ) )
          = ( ( real_V3181309239436604168linear @ A @ B @ F8 )
            & ( filterlim @ A @ real
              @ ^ [Y5: A] : ( divide_divide @ real @ ( real_V7770717601297561774m_norm @ B @ ( minus_minus @ B @ ( minus_minus @ B @ ( F2 @ Y5 ) @ ( F2 @ X2 ) ) @ ( F8 @ ( minus_minus @ A @ Y5 @ X2 ) ) ) ) @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ Y5 @ X2 ) ) )
              @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
              @ ( topolo174197925503356063within @ A @ X2 @ S2 ) ) ) ) ) ).

% has_derivative_iff_norm
thf(fact_6805_has__derivative__at__within,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F2: A > B,F8: A > B,X2: A,S2: set @ A] :
          ( ( has_derivative @ A @ B @ F2 @ F8 @ ( topolo174197925503356063within @ A @ X2 @ S2 ) )
          = ( ( real_V3181309239436604168linear @ A @ B @ F8 )
            & ( filterlim @ A @ B
              @ ^ [Y5: A] : ( real_V8093663219630862766scaleR @ B @ ( inverse_inverse @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ Y5 @ X2 ) ) ) @ ( minus_minus @ B @ ( minus_minus @ B @ ( F2 @ Y5 ) @ ( F2 @ X2 ) ) @ ( F8 @ ( minus_minus @ A @ Y5 @ X2 ) ) ) )
              @ ( topolo7230453075368039082e_nhds @ B @ ( zero_zero @ B ) )
              @ ( topolo174197925503356063within @ A @ X2 @ S2 ) ) ) ) ) ).

% has_derivative_at_within
thf(fact_6806_has__derivativeI,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F8: A > B,X2: A,F2: A > B,S2: set @ A] :
          ( ( real_V3181309239436604168linear @ A @ B @ F8 )
         => ( ( filterlim @ A @ B
              @ ^ [Y5: A] : ( real_V8093663219630862766scaleR @ B @ ( inverse_inverse @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ Y5 @ X2 ) ) ) @ ( minus_minus @ B @ ( minus_minus @ B @ ( F2 @ Y5 ) @ ( F2 @ X2 ) ) @ ( F8 @ ( minus_minus @ A @ Y5 @ X2 ) ) ) )
              @ ( topolo7230453075368039082e_nhds @ B @ ( zero_zero @ B ) )
              @ ( topolo174197925503356063within @ A @ X2 @ S2 ) )
           => ( has_derivative @ A @ B @ F2 @ F8 @ ( topolo174197925503356063within @ A @ X2 @ S2 ) ) ) ) ) ).

% has_derivativeI
thf(fact_6807_has__derivative__iff__Ex,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F2: A > B,F8: A > B,X2: A] :
          ( ( has_derivative @ A @ B @ F2 @ F8 @ ( topolo174197925503356063within @ A @ X2 @ ( top_top @ ( set @ A ) ) ) )
          = ( ( real_V3181309239436604168linear @ A @ B @ F8 )
            & ? [E4: A > B] :
                ( ! [H: A] :
                    ( ( F2 @ ( plus_plus @ A @ X2 @ H ) )
                    = ( plus_plus @ B @ ( plus_plus @ B @ ( F2 @ X2 ) @ ( F8 @ H ) ) @ ( E4 @ H ) ) )
                & ( filterlim @ A @ real
                  @ ^ [H: A] : ( divide_divide @ real @ ( real_V7770717601297561774m_norm @ B @ ( E4 @ H ) ) @ ( real_V7770717601297561774m_norm @ A @ H ) )
                  @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
                  @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ) ).

% has_derivative_iff_Ex
thf(fact_6808_has__derivative__within,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F2: A > B,F8: A > B,X2: A,S2: set @ A] :
          ( ( has_derivative @ A @ B @ F2 @ F8 @ ( topolo174197925503356063within @ A @ X2 @ S2 ) )
          = ( ( real_V3181309239436604168linear @ A @ B @ F8 )
            & ( filterlim @ A @ B
              @ ^ [Y5: A] : ( real_V8093663219630862766scaleR @ B @ ( divide_divide @ real @ ( one_one @ real ) @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ Y5 @ X2 ) ) ) @ ( minus_minus @ B @ ( F2 @ Y5 ) @ ( plus_plus @ B @ ( F2 @ X2 ) @ ( F8 @ ( minus_minus @ A @ Y5 @ X2 ) ) ) ) )
              @ ( topolo7230453075368039082e_nhds @ B @ ( zero_zero @ B ) )
              @ ( topolo174197925503356063within @ A @ X2 @ S2 ) ) ) ) ) ).

% has_derivative_within
thf(fact_6809_has__derivative__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ( ( has_derivative @ A @ B )
        = ( ^ [F5: A > B,F15: A > B,F9: filter @ A] :
              ( ( real_V3181309239436604168linear @ A @ B @ F15 )
              & ( filterlim @ A @ B
                @ ^ [Y5: A] :
                    ( real_V8093663219630862766scaleR @ B
                    @ ( inverse_inverse @ real
                      @ ( real_V7770717601297561774m_norm @ A
                        @ ( minus_minus @ A @ Y5
                          @ ( topolo3827282254853284352ce_Lim @ A @ A @ F9
                            @ ^ [X5: A] : X5 ) ) ) )
                    @ ( minus_minus @ B
                      @ ( minus_minus @ B @ ( F5 @ Y5 )
                        @ ( F5
                          @ ( topolo3827282254853284352ce_Lim @ A @ A @ F9
                            @ ^ [X5: A] : X5 ) ) )
                      @ ( F15
                        @ ( minus_minus @ A @ Y5
                          @ ( topolo3827282254853284352ce_Lim @ A @ A @ F9
                            @ ^ [X5: A] : X5 ) ) ) ) )
                @ ( topolo7230453075368039082e_nhds @ B @ ( zero_zero @ B ) )
                @ F9 ) ) ) ) ) ).

% has_derivative_def
thf(fact_6810_has__derivative__at__within__iff__Ex,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [X2: A,S3: set @ A,F2: A > B,F8: A > B] :
          ( ( member @ A @ X2 @ S3 )
         => ( ( topolo1002775350975398744n_open @ A @ S3 )
           => ( ( has_derivative @ A @ B @ F2 @ F8 @ ( topolo174197925503356063within @ A @ X2 @ S3 ) )
              = ( ( real_V3181309239436604168linear @ A @ B @ F8 )
                & ? [E4: A > B] :
                    ( ! [H: A] :
                        ( ( member @ A @ ( plus_plus @ A @ X2 @ H ) @ S3 )
                       => ( ( F2 @ ( plus_plus @ A @ X2 @ H ) )
                          = ( plus_plus @ B @ ( plus_plus @ B @ ( F2 @ X2 ) @ ( F8 @ H ) ) @ ( E4 @ H ) ) ) )
                    & ( filterlim @ A @ real
                      @ ^ [H: A] : ( divide_divide @ real @ ( real_V7770717601297561774m_norm @ B @ ( E4 @ H ) ) @ ( real_V7770717601297561774m_norm @ A @ H ) )
                      @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
                      @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ) ) ) ).

% has_derivative_at_within_iff_Ex
thf(fact_6811_Inf__notin__open,axiom,
    ! [A: $tType] :
      ( ( topolo8458572112393995274pology @ A )
     => ! [A3: set @ A,X2: A] :
          ( ( topolo1002775350975398744n_open @ A @ A3 )
         => ( ! [X3: A] :
                ( ( member @ A @ X3 @ A3 )
               => ( ord_less @ A @ X2 @ X3 ) )
           => ~ ( member @ A @ ( complete_Inf_Inf @ A @ A3 ) @ A3 ) ) ) ) ).

% Inf_notin_open
thf(fact_6812_Sup__notin__open,axiom,
    ! [A: $tType] :
      ( ( topolo8458572112393995274pology @ A )
     => ! [A3: set @ A,X2: A] :
          ( ( topolo1002775350975398744n_open @ A @ A3 )
         => ( ! [X3: A] :
                ( ( member @ A @ X3 @ A3 )
               => ( ord_less @ A @ X3 @ X2 ) )
           => ~ ( member @ A @ ( complete_Sup_Sup @ A @ A3 ) @ A3 ) ) ) ) ).

% Sup_notin_open
thf(fact_6813_first__countable__basis,axiom,
    ! [A: $tType] :
      ( ( topolo3112930676232923870pology @ A )
     => ! [X2: A] :
        ? [A8: nat > ( set @ A )] :
          ( ! [I: nat] :
              ( ( member @ A @ X2 @ ( A8 @ I ) )
              & ( topolo1002775350975398744n_open @ A @ ( A8 @ I ) ) )
          & ! [S10: set @ A] :
              ( ( ( topolo1002775350975398744n_open @ A @ S10 )
                & ( member @ A @ X2 @ S10 ) )
             => ? [I2: nat] : ( ord_less_eq @ ( set @ A ) @ ( A8 @ I2 ) @ S10 ) ) ) ) ).

% first_countable_basis
thf(fact_6814_open__subopen,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ( ( topolo1002775350975398744n_open @ A )
        = ( ^ [S6: set @ A] :
            ! [X5: A] :
              ( ( member @ A @ X5 @ S6 )
             => ? [T9: set @ A] :
                  ( ( topolo1002775350975398744n_open @ A @ T9 )
                  & ( member @ A @ X5 @ T9 )
                  & ( ord_less_eq @ ( set @ A ) @ T9 @ S6 ) ) ) ) ) ) ).

% open_subopen
thf(fact_6815_openI,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [S3: set @ A] :
          ( ! [X3: A] :
              ( ( member @ A @ X3 @ S3 )
             => ? [T10: set @ A] :
                  ( ( topolo1002775350975398744n_open @ A @ T10 )
                  & ( member @ A @ X3 @ T10 )
                  & ( ord_less_eq @ ( set @ A ) @ T10 @ S3 ) ) )
         => ( topolo1002775350975398744n_open @ A @ S3 ) ) ) ).

% openI
thf(fact_6816_at__within__open__subset,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [A2: A,S3: set @ A,T6: set @ A] :
          ( ( member @ A @ A2 @ S3 )
         => ( ( topolo1002775350975398744n_open @ A @ S3 )
           => ( ( ord_less_eq @ ( set @ A ) @ S3 @ T6 )
             => ( ( topolo174197925503356063within @ A @ A2 @ T6 )
                = ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ) ).

% at_within_open_subset
thf(fact_6817_open__right,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [S3: set @ A,X2: A,Y2: A] :
          ( ( topolo1002775350975398744n_open @ A @ S3 )
         => ( ( member @ A @ X2 @ S3 )
           => ( ( ord_less @ A @ X2 @ Y2 )
             => ? [B5: A] :
                  ( ( ord_less @ A @ X2 @ B5 )
                  & ( ord_less_eq @ ( set @ A ) @ ( set_or7035219750837199246ssThan @ A @ X2 @ B5 ) @ S3 ) ) ) ) ) ) ).

% open_right
thf(fact_6818_lim__explicit,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [F2: nat > A,F0: A] :
          ( ( filterlim @ nat @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ F0 ) @ ( at_top @ nat ) )
          = ( ! [S6: set @ A] :
                ( ( topolo1002775350975398744n_open @ A @ S6 )
               => ( ( member @ A @ F0 @ S6 )
                 => ? [N6: nat] :
                    ! [N3: nat] :
                      ( ( ord_less_eq @ nat @ N6 @ N3 )
                     => ( member @ A @ ( F2 @ N3 ) @ S6 ) ) ) ) ) ) ) ).

% lim_explicit
thf(fact_6819_continuous__divide,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topological_t2_space @ A )
        & ( real_V3459762299906320749_field @ B ) )
     => ! [F3: filter @ A,F2: A > B,G: A > B] :
          ( ( topolo3448309680560233919inuous @ A @ B @ F3 @ F2 )
         => ( ( topolo3448309680560233919inuous @ A @ B @ F3 @ G )
           => ( ( ( G
                  @ ( topolo3827282254853284352ce_Lim @ A @ A @ F3
                    @ ^ [X5: A] : X5 ) )
               != ( zero_zero @ B ) )
             => ( topolo3448309680560233919inuous @ A @ B @ F3
                @ ^ [X5: A] : ( divide_divide @ B @ ( F2 @ X5 ) @ ( G @ X5 ) ) ) ) ) ) ) ).

% continuous_divide
thf(fact_6820_continuous__inverse,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topological_t2_space @ A )
        & ( real_V8999393235501362500lgebra @ B ) )
     => ! [F3: filter @ A,F2: A > B] :
          ( ( topolo3448309680560233919inuous @ A @ B @ F3 @ F2 )
         => ( ( ( F2
                @ ( topolo3827282254853284352ce_Lim @ A @ A @ F3
                  @ ^ [X5: A] : X5 ) )
             != ( zero_zero @ B ) )
           => ( topolo3448309680560233919inuous @ A @ B @ F3
              @ ^ [X5: A] : ( inverse_inverse @ B @ ( F2 @ X5 ) ) ) ) ) ) ).

% continuous_inverse
thf(fact_6821_continuous__sgn,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topological_t2_space @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F3: filter @ A,F2: A > B] :
          ( ( topolo3448309680560233919inuous @ A @ B @ F3 @ F2 )
         => ( ( ( F2
                @ ( topolo3827282254853284352ce_Lim @ A @ A @ F3
                  @ ^ [X5: A] : X5 ) )
             != ( zero_zero @ B ) )
           => ( topolo3448309680560233919inuous @ A @ B @ F3
              @ ^ [X5: A] : ( sgn_sgn @ B @ ( F2 @ X5 ) ) ) ) ) ) ).

% continuous_sgn
thf(fact_6822_continuous__powr,axiom,
    ! [A: $tType] :
      ( ( topological_t2_space @ A )
     => ! [F3: filter @ A,F2: A > real,G: A > real] :
          ( ( topolo3448309680560233919inuous @ A @ real @ F3 @ F2 )
         => ( ( topolo3448309680560233919inuous @ A @ real @ F3 @ G )
           => ( ( ( F2
                  @ ( topolo3827282254853284352ce_Lim @ A @ A @ F3
                    @ ^ [X5: A] : X5 ) )
               != ( zero_zero @ real ) )
             => ( topolo3448309680560233919inuous @ A @ real @ F3
                @ ^ [X5: A] : ( powr @ real @ ( F2 @ X5 ) @ ( G @ X5 ) ) ) ) ) ) ) ).

% continuous_powr
thf(fact_6823_continuous__ln,axiom,
    ! [A: $tType] :
      ( ( topological_t2_space @ A )
     => ! [F3: filter @ A,F2: A > real] :
          ( ( topolo3448309680560233919inuous @ A @ real @ F3 @ F2 )
         => ( ( ( F2
                @ ( topolo3827282254853284352ce_Lim @ A @ A @ F3
                  @ ^ [X5: A] : X5 ) )
             != ( zero_zero @ real ) )
           => ( topolo3448309680560233919inuous @ A @ real @ F3
              @ ^ [X5: A] : ( ln_ln @ real @ ( F2 @ X5 ) ) ) ) ) ) ).

% continuous_ln
thf(fact_6824_continuous__tan,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [F3: filter @ A,F2: A > A] :
          ( ( topolo3448309680560233919inuous @ A @ A @ F3 @ F2 )
         => ( ( ( cos @ A
                @ ( F2
                  @ ( topolo3827282254853284352ce_Lim @ A @ A @ F3
                    @ ^ [X5: A] : X5 ) ) )
             != ( zero_zero @ A ) )
           => ( topolo3448309680560233919inuous @ A @ A @ F3
              @ ^ [X5: A] : ( tan @ A @ ( F2 @ X5 ) ) ) ) ) ) ).

% continuous_tan
thf(fact_6825_continuous__cot,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [F3: filter @ A,F2: A > A] :
          ( ( topolo3448309680560233919inuous @ A @ A @ F3 @ F2 )
         => ( ( ( sin @ A
                @ ( F2
                  @ ( topolo3827282254853284352ce_Lim @ A @ A @ F3
                    @ ^ [X5: A] : X5 ) ) )
             != ( zero_zero @ A ) )
           => ( topolo3448309680560233919inuous @ A @ A @ F3
              @ ^ [X5: A] : ( cot @ A @ ( F2 @ X5 ) ) ) ) ) ) ).

% continuous_cot
thf(fact_6826_continuous__tanh,axiom,
    ! [A: $tType,C: $tType] :
      ( ( ( topological_t2_space @ C )
        & ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [F3: filter @ C,F2: C > A] :
          ( ( topolo3448309680560233919inuous @ C @ A @ F3 @ F2 )
         => ( ( ( cosh @ A
                @ ( F2
                  @ ( topolo3827282254853284352ce_Lim @ C @ C @ F3
                    @ ^ [X5: C] : X5 ) ) )
             != ( zero_zero @ A ) )
           => ( topolo3448309680560233919inuous @ C @ A @ F3
              @ ^ [X5: C] : ( tanh @ A @ ( F2 @ X5 ) ) ) ) ) ) ).

% continuous_tanh
thf(fact_6827_continuous__arcosh,axiom,
    ! [A: $tType] :
      ( ( topological_t2_space @ A )
     => ! [F3: filter @ A,F2: A > real] :
          ( ( topolo3448309680560233919inuous @ A @ real @ F3 @ F2 )
         => ( ( ord_less @ real @ ( one_one @ real )
              @ ( F2
                @ ( topolo3827282254853284352ce_Lim @ A @ A @ F3
                  @ ^ [X5: A] : X5 ) ) )
           => ( topolo3448309680560233919inuous @ A @ real @ F3
              @ ^ [X5: A] : ( arcosh @ real @ ( F2 @ X5 ) ) ) ) ) ) ).

% continuous_arcosh
thf(fact_6828_tendsto__offset__zero__iff,axiom,
    ! [C: $tType,D: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( topolo4958980785337419405_space @ D )
        & ( zero @ C ) )
     => ! [A2: A,S3: set @ A,F2: A > D,L5: D] :
          ( ( nO_MATCH @ C @ A @ ( zero_zero @ C ) @ A2 )
         => ( ( member @ A @ A2 @ S3 )
           => ( ( topolo1002775350975398744n_open @ A @ S3 )
             => ( ( filterlim @ A @ D @ F2 @ ( topolo7230453075368039082e_nhds @ D @ L5 ) @ ( topolo174197925503356063within @ A @ A2 @ S3 ) )
                = ( filterlim @ A @ D
                  @ ^ [H: A] : ( F2 @ ( plus_plus @ A @ A2 @ H ) )
                  @ ( topolo7230453075368039082e_nhds @ D @ L5 )
                  @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ) ) ).

% tendsto_offset_zero_iff
thf(fact_6829_continuous__log,axiom,
    ! [A: $tType] :
      ( ( topological_t2_space @ A )
     => ! [F3: filter @ A,F2: A > real,G: A > real] :
          ( ( topolo3448309680560233919inuous @ A @ real @ F3 @ F2 )
         => ( ( topolo3448309680560233919inuous @ A @ real @ F3 @ G )
           => ( ( ord_less @ real @ ( zero_zero @ real )
                @ ( F2
                  @ ( topolo3827282254853284352ce_Lim @ A @ A @ F3
                    @ ^ [X5: A] : X5 ) ) )
             => ( ( ( F2
                    @ ( topolo3827282254853284352ce_Lim @ A @ A @ F3
                      @ ^ [X5: A] : X5 ) )
                 != ( one_one @ real ) )
               => ( ( ord_less @ real @ ( zero_zero @ real )
                    @ ( G
                      @ ( topolo3827282254853284352ce_Lim @ A @ A @ F3
                        @ ^ [X5: A] : X5 ) ) )
                 => ( topolo3448309680560233919inuous @ A @ real @ F3
                    @ ^ [X5: A] : ( log @ ( F2 @ X5 ) @ ( G @ X5 ) ) ) ) ) ) ) ) ) ).

% continuous_log
thf(fact_6830_has__derivativeI__sandwich,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [E2: real,F8: A > B,S2: set @ A,X2: A,F2: A > B,H6: A > real] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ E2 )
         => ( ( real_V3181309239436604168linear @ A @ B @ F8 )
           => ( ! [Y4: A] :
                  ( ( member @ A @ Y4 @ S2 )
                 => ( ( Y4 != X2 )
                   => ( ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ Y4 @ X2 ) @ E2 )
                     => ( ord_less_eq @ real @ ( divide_divide @ real @ ( real_V7770717601297561774m_norm @ B @ ( minus_minus @ B @ ( minus_minus @ B @ ( F2 @ Y4 ) @ ( F2 @ X2 ) ) @ ( F8 @ ( minus_minus @ A @ Y4 @ X2 ) ) ) ) @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ Y4 @ X2 ) ) ) @ ( H6 @ Y4 ) ) ) ) )
             => ( ( filterlim @ A @ real @ H6 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( topolo174197925503356063within @ A @ X2 @ S2 ) )
               => ( has_derivative @ A @ B @ F2 @ F8 @ ( topolo174197925503356063within @ A @ X2 @ S2 ) ) ) ) ) ) ) ).

% has_derivativeI_sandwich
thf(fact_6831_tendsto__exp__limit__at__right,axiom,
    ! [X2: real] :
      ( filterlim @ real @ real
      @ ^ [Y5: real] : ( powr @ real @ ( plus_plus @ real @ ( one_one @ real ) @ ( times_times @ real @ X2 @ Y5 ) ) @ ( divide_divide @ real @ ( one_one @ real ) @ Y5 ) )
      @ ( topolo7230453075368039082e_nhds @ real @ ( exp @ real @ X2 ) )
      @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) ) ).

% tendsto_exp_limit_at_right
thf(fact_6832_greaterThan__iff,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [I3: A,K: A] :
          ( ( member @ A @ I3 @ ( set_ord_greaterThan @ A @ K ) )
          = ( ord_less @ A @ K @ I3 ) ) ) ).

% greaterThan_iff
thf(fact_6833_dist__add__cancel,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( real_V557655796197034286t_dist @ A @ ( plus_plus @ A @ A2 @ B2 ) @ ( plus_plus @ A @ A2 @ C2 ) )
          = ( real_V557655796197034286t_dist @ A @ B2 @ C2 ) ) ) ).

% dist_add_cancel
thf(fact_6834_dist__add__cancel2,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( real_V557655796197034286t_dist @ A @ ( plus_plus @ A @ B2 @ A2 ) @ ( plus_plus @ A @ C2 @ A2 ) )
          = ( real_V557655796197034286t_dist @ A @ B2 @ C2 ) ) ) ).

% dist_add_cancel2
thf(fact_6835_dist__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X2: A,Y2: A] :
          ( ( ( real_V557655796197034286t_dist @ A @ X2 @ Y2 )
            = ( zero_zero @ real ) )
          = ( X2 = Y2 ) ) ) ).

% dist_eq_0_iff
thf(fact_6836_dist__self,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X2: A] :
          ( ( real_V557655796197034286t_dist @ A @ X2 @ X2 )
          = ( zero_zero @ real ) ) ) ).

% dist_self
thf(fact_6837_greaterThan__subset__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X2: A,Y2: A] :
          ( ( ord_less_eq @ ( set @ A ) @ ( set_ord_greaterThan @ A @ X2 ) @ ( set_ord_greaterThan @ A @ Y2 ) )
          = ( ord_less_eq @ A @ Y2 @ X2 ) ) ) ).

% greaterThan_subset_iff
thf(fact_6838_dist__0__norm,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X2: A] :
          ( ( real_V557655796197034286t_dist @ A @ ( zero_zero @ A ) @ X2 )
          = ( real_V7770717601297561774m_norm @ A @ X2 ) ) ) ).

% dist_0_norm
thf(fact_6839_zero__less__dist__iff,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X2: A,Y2: A] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ ( real_V557655796197034286t_dist @ A @ X2 @ Y2 ) )
          = ( ( X2 != Y2 ) ) ) ) ).

% zero_less_dist_iff
thf(fact_6840_dist__le__zero__iff,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X2: A,Y2: A] :
          ( ( ord_less_eq @ real @ ( real_V557655796197034286t_dist @ A @ X2 @ Y2 ) @ ( zero_zero @ real ) )
          = ( X2 = Y2 ) ) ) ).

% dist_le_zero_iff
thf(fact_6841_Sup__greaterThanAtLeast,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [X2: A] :
          ( ( ord_less @ A @ X2 @ ( top_top @ A ) )
         => ( ( complete_Sup_Sup @ A @ ( set_ord_greaterThan @ A @ X2 ) )
            = ( top_top @ A ) ) ) ) ).

% Sup_greaterThanAtLeast
thf(fact_6842_dist__scaleR,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X2: real,A2: A,Y2: real] :
          ( ( real_V557655796197034286t_dist @ A @ ( real_V8093663219630862766scaleR @ A @ X2 @ A2 ) @ ( real_V8093663219630862766scaleR @ A @ Y2 @ A2 ) )
          = ( times_times @ real @ ( abs_abs @ real @ ( minus_minus @ real @ X2 @ Y2 ) ) @ ( real_V7770717601297561774m_norm @ A @ A2 ) ) ) ) ).

% dist_scaleR
thf(fact_6843_open__ball,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X2: A,D2: real] :
          ( topolo1002775350975398744n_open @ A
          @ ( collect @ A
            @ ^ [Y5: A] : ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X2 @ Y5 ) @ D2 ) ) ) ) ).

% open_ball
thf(fact_6844_dist__triangle,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X2: A,Z: A,Y2: A] : ( ord_less_eq @ real @ ( real_V557655796197034286t_dist @ A @ X2 @ Z ) @ ( plus_plus @ real @ ( real_V557655796197034286t_dist @ A @ X2 @ Y2 ) @ ( real_V557655796197034286t_dist @ A @ Y2 @ Z ) ) ) ) ).

% dist_triangle
thf(fact_6845_dist__triangle2,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X2: A,Y2: A,Z: A] : ( ord_less_eq @ real @ ( real_V557655796197034286t_dist @ A @ X2 @ Y2 ) @ ( plus_plus @ real @ ( real_V557655796197034286t_dist @ A @ X2 @ Z ) @ ( real_V557655796197034286t_dist @ A @ Y2 @ Z ) ) ) ) ).

% dist_triangle2
thf(fact_6846_dist__triangle3,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X2: A,Y2: A,A2: A] : ( ord_less_eq @ real @ ( real_V557655796197034286t_dist @ A @ X2 @ Y2 ) @ ( plus_plus @ real @ ( real_V557655796197034286t_dist @ A @ A2 @ X2 ) @ ( real_V557655796197034286t_dist @ A @ A2 @ Y2 ) ) ) ) ).

% dist_triangle3
thf(fact_6847_dist__triangle__le,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X2: A,Z: A,Y2: A,E2: real] :
          ( ( ord_less_eq @ real @ ( plus_plus @ real @ ( real_V557655796197034286t_dist @ A @ X2 @ Z ) @ ( real_V557655796197034286t_dist @ A @ Y2 @ Z ) ) @ E2 )
         => ( ord_less_eq @ real @ ( real_V557655796197034286t_dist @ A @ X2 @ Y2 ) @ E2 ) ) ) ).

% dist_triangle_le
thf(fact_6848_zero__le__dist,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X2: A,Y2: A] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( real_V557655796197034286t_dist @ A @ X2 @ Y2 ) ) ) ).

% zero_le_dist
thf(fact_6849_dist__pos__lt,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X2: A,Y2: A] :
          ( ( X2 != Y2 )
         => ( ord_less @ real @ ( zero_zero @ real ) @ ( real_V557655796197034286t_dist @ A @ X2 @ Y2 ) ) ) ) ).

% dist_pos_lt
thf(fact_6850_dist__not__less__zero,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X2: A,Y2: A] :
          ~ ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X2 @ Y2 ) @ ( zero_zero @ real ) ) ) ).

% dist_not_less_zero
thf(fact_6851_dist__commute__lessI,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [Y2: A,X2: A,E2: real] :
          ( ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ Y2 @ X2 ) @ E2 )
         => ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X2 @ Y2 ) @ E2 ) ) ) ).

% dist_commute_lessI
thf(fact_6852_greaterThan__def,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ( ( set_ord_greaterThan @ A )
        = ( ^ [L2: A] : ( collect @ A @ ( ord_less @ A @ L2 ) ) ) ) ) ).

% greaterThan_def
thf(fact_6853_dist__triangle__less__add,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X1: A,Y2: A,E1: real,X22: A,E22: real] :
          ( ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X1 @ Y2 ) @ E1 )
         => ( ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X22 @ Y2 ) @ E22 )
           => ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X1 @ X22 ) @ ( plus_plus @ real @ E1 @ E22 ) ) ) ) ) ).

% dist_triangle_less_add
thf(fact_6854_dist__triangle__lt,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X2: A,Z: A,Y2: A,E2: real] :
          ( ( ord_less @ real @ ( plus_plus @ real @ ( real_V557655796197034286t_dist @ A @ X2 @ Z ) @ ( real_V557655796197034286t_dist @ A @ Y2 @ Z ) ) @ E2 )
         => ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X2 @ Y2 ) @ E2 ) ) ) ).

% dist_triangle_lt
thf(fact_6855_norm__conv__dist,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ( ( real_V7770717601297561774m_norm @ A )
        = ( ^ [X5: A] : ( real_V557655796197034286t_dist @ A @ X5 @ ( zero_zero @ A ) ) ) ) ) ).

% norm_conv_dist
thf(fact_6856_open__dist,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ( ( topolo1002775350975398744n_open @ A )
        = ( ^ [S6: set @ A] :
            ! [X5: A] :
              ( ( member @ A @ X5 @ S6 )
             => ? [E4: real] :
                  ( ( ord_less @ real @ ( zero_zero @ real ) @ E4 )
                  & ! [Y5: A] :
                      ( ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ Y5 @ X5 ) @ E4 )
                     => ( member @ A @ Y5 @ S6 ) ) ) ) ) ) ) ).

% open_dist
thf(fact_6857_abs__dist__diff__le,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [A2: A,B2: A,C2: A] : ( ord_less_eq @ real @ ( abs_abs @ real @ ( minus_minus @ real @ ( real_V557655796197034286t_dist @ A @ A2 @ B2 ) @ ( real_V557655796197034286t_dist @ A @ B2 @ C2 ) ) ) @ ( real_V557655796197034286t_dist @ A @ A2 @ C2 ) ) ) ).

% abs_dist_diff_le
thf(fact_6858_at__within__Icc__at__right,axiom,
    ! [A: $tType] :
      ( ( topolo2564578578187576103pology @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( topolo174197925503356063within @ A @ A2 @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) )
            = ( topolo174197925503356063within @ A @ A2 @ ( set_ord_greaterThan @ A @ A2 ) ) ) ) ) ).

% at_within_Icc_at_right
thf(fact_6859_has__field__derivative__transform__within,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,F8: A,A2: A,S3: set @ A,D2: real,G: A > A] :
          ( ( has_field_derivative @ A @ F2 @ F8 @ ( topolo174197925503356063within @ A @ A2 @ S3 ) )
         => ( ( ord_less @ real @ ( zero_zero @ real ) @ D2 )
           => ( ( member @ A @ A2 @ S3 )
             => ( ! [X3: A] :
                    ( ( member @ A @ X3 @ S3 )
                   => ( ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X3 @ A2 ) @ D2 )
                     => ( ( F2 @ X3 )
                        = ( G @ X3 ) ) ) )
               => ( has_field_derivative @ A @ G @ F8 @ ( topolo174197925503356063within @ A @ A2 @ S3 ) ) ) ) ) ) ) ).

% has_field_derivative_transform_within
thf(fact_6860_has__derivative__transform__within,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F2: A > B,F8: A > B,X2: A,S2: set @ A,D2: real,G: A > B] :
          ( ( has_derivative @ A @ B @ F2 @ F8 @ ( topolo174197925503356063within @ A @ X2 @ S2 ) )
         => ( ( ord_less @ real @ ( zero_zero @ real ) @ D2 )
           => ( ( member @ A @ X2 @ S2 )
             => ( ! [X16: A] :
                    ( ( member @ A @ X16 @ S2 )
                   => ( ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X16 @ X2 ) @ D2 )
                     => ( ( F2 @ X16 )
                        = ( G @ X16 ) ) ) )
               => ( has_derivative @ A @ B @ G @ F8 @ ( topolo174197925503356063within @ A @ X2 @ S2 ) ) ) ) ) ) ) ).

% has_derivative_transform_within
thf(fact_6861_Cauchy__def,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ( ( topolo3814608138187158403Cauchy @ A )
        = ( ^ [X4: nat > A] :
            ! [E4: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ E4 )
             => ? [M9: nat] :
                ! [M6: nat] :
                  ( ( ord_less_eq @ nat @ M9 @ M6 )
                 => ! [N3: nat] :
                      ( ( ord_less_eq @ nat @ M9 @ N3 )
                     => ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ ( X4 @ M6 ) @ ( X4 @ N3 ) ) @ E4 ) ) ) ) ) ) ) ).

% Cauchy_def
thf(fact_6862_Cauchy__altdef2,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ( ( topolo3814608138187158403Cauchy @ A )
        = ( ^ [S7: nat > A] :
            ! [E4: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ E4 )
             => ? [N6: nat] :
                ! [N3: nat] :
                  ( ( ord_less_eq @ nat @ N6 @ N3 )
                 => ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ ( S7 @ N3 ) @ ( S7 @ N6 ) ) @ E4 ) ) ) ) ) ) ).

% Cauchy_altdef2
thf(fact_6863_metric__CauchyD,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X8: nat > A,E2: real] :
          ( ( topolo3814608138187158403Cauchy @ A @ X8 )
         => ( ( ord_less @ real @ ( zero_zero @ real ) @ E2 )
           => ? [M8: nat] :
              ! [M2: nat] :
                ( ( ord_less_eq @ nat @ M8 @ M2 )
               => ! [N9: nat] :
                    ( ( ord_less_eq @ nat @ M8 @ N9 )
                   => ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ ( X8 @ M2 ) @ ( X8 @ N9 ) ) @ E2 ) ) ) ) ) ) ).

% metric_CauchyD
thf(fact_6864_metric__CauchyI,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X8: nat > A] :
          ( ! [E: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ E )
             => ? [M10: nat] :
                ! [M3: nat] :
                  ( ( ord_less_eq @ nat @ M10 @ M3 )
                 => ! [N: nat] :
                      ( ( ord_less_eq @ nat @ M10 @ N )
                     => ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ ( X8 @ M3 ) @ ( X8 @ N ) ) @ E ) ) ) )
         => ( topolo3814608138187158403Cauchy @ A @ X8 ) ) ) ).

% metric_CauchyI
thf(fact_6865_less__separate,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [X2: A,Y2: A] :
          ( ( ord_less @ A @ X2 @ Y2 )
         => ? [A5: A,B5: A] :
              ( ( member @ A @ X2 @ ( set_ord_lessThan @ A @ A5 ) )
              & ( member @ A @ Y2 @ ( set_ord_greaterThan @ A @ B5 ) )
              & ( ( inf_inf @ ( set @ A ) @ ( set_ord_lessThan @ A @ A5 ) @ ( set_ord_greaterThan @ A @ B5 ) )
                = ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% less_separate
thf(fact_6866_filterlim__at__right__to__0,axiom,
    ! [A: $tType,F2: real > A,F3: filter @ A,A2: real] :
      ( ( filterlim @ real @ A @ F2 @ F3 @ ( topolo174197925503356063within @ real @ A2 @ ( set_ord_greaterThan @ real @ A2 ) ) )
      = ( filterlim @ real @ A
        @ ^ [X5: real] : ( F2 @ ( plus_plus @ real @ X5 @ A2 ) )
        @ F3
        @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) ) ) ).

% filterlim_at_right_to_0
thf(fact_6867_metric__LIM__imp__LIM,axiom,
    ! [A: $tType,B: $tType,C: $tType] :
      ( ( ( topolo4958980785337419405_space @ C )
        & ( real_V7819770556892013058_space @ B )
        & ( real_V7819770556892013058_space @ A ) )
     => ! [F2: C > A,L: A,A2: C,G: C > B,M: B] :
          ( ( filterlim @ C @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ L ) @ ( topolo174197925503356063within @ C @ A2 @ ( top_top @ ( set @ C ) ) ) )
         => ( ! [X3: C] :
                ( ( X3 != A2 )
               => ( ord_less_eq @ real @ ( real_V557655796197034286t_dist @ B @ ( G @ X3 ) @ M ) @ ( real_V557655796197034286t_dist @ A @ ( F2 @ X3 ) @ L ) ) )
           => ( filterlim @ C @ B @ G @ ( topolo7230453075368039082e_nhds @ B @ M ) @ ( topolo174197925503356063within @ C @ A2 @ ( top_top @ ( set @ C ) ) ) ) ) ) ) ).

% metric_LIM_imp_LIM
thf(fact_6868_Lim__transform__within,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V7819770556892013058_space @ A )
        & ( topolo4958980785337419405_space @ B ) )
     => ! [F2: A > B,L: B,X2: A,S3: set @ A,D2: real,G: A > B] :
          ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ L ) @ ( topolo174197925503356063within @ A @ X2 @ S3 ) )
         => ( ( ord_less @ real @ ( zero_zero @ real ) @ D2 )
           => ( ! [X16: A] :
                  ( ( member @ A @ X16 @ S3 )
                 => ( ( ord_less @ real @ ( zero_zero @ real ) @ ( real_V557655796197034286t_dist @ A @ X16 @ X2 ) )
                   => ( ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X16 @ X2 ) @ D2 )
                     => ( ( F2 @ X16 )
                        = ( G @ X16 ) ) ) ) )
             => ( filterlim @ A @ B @ G @ ( topolo7230453075368039082e_nhds @ B @ L ) @ ( topolo174197925503356063within @ A @ X2 @ S3 ) ) ) ) ) ) ).

% Lim_transform_within
thf(fact_6869_dist__triangle__half__l,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X1: A,Y2: A,E2: real,X22: A] :
          ( ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X1 @ Y2 ) @ ( divide_divide @ real @ E2 @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
         => ( ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X22 @ Y2 ) @ ( divide_divide @ real @ E2 @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
           => ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X1 @ X22 ) @ E2 ) ) ) ) ).

% dist_triangle_half_l
thf(fact_6870_dist__triangle__half__r,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [Y2: A,X1: A,E2: real,X22: A] :
          ( ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ Y2 @ X1 ) @ ( divide_divide @ real @ E2 @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
         => ( ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ Y2 @ X22 ) @ ( divide_divide @ real @ E2 @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
           => ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X1 @ X22 ) @ E2 ) ) ) ) ).

% dist_triangle_half_r
thf(fact_6871_dist__triangle__third,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X1: A,X22: A,E2: real,X32: A,X42: A] :
          ( ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X1 @ X22 ) @ ( divide_divide @ real @ E2 @ ( numeral_numeral @ real @ ( bit1 @ one2 ) ) ) )
         => ( ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X22 @ X32 ) @ ( divide_divide @ real @ E2 @ ( numeral_numeral @ real @ ( bit1 @ one2 ) ) ) )
           => ( ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X32 @ X42 ) @ ( divide_divide @ real @ E2 @ ( numeral_numeral @ real @ ( bit1 @ one2 ) ) ) )
             => ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X1 @ X42 ) @ E2 ) ) ) ) ) ).

% dist_triangle_third
thf(fact_6872_filterlim__transform__within,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [G: A > B,G7: filter @ B,X2: A,S3: set @ A,F3: filter @ B,D2: real,F2: A > B] :
          ( ( filterlim @ A @ B @ G @ G7 @ ( topolo174197925503356063within @ A @ X2 @ S3 ) )
         => ( ( ord_less_eq @ ( filter @ B ) @ G7 @ F3 )
           => ( ( ord_less @ real @ ( zero_zero @ real ) @ D2 )
             => ( ! [X16: A] :
                    ( ( member @ A @ X16 @ S3 )
                   => ( ( ord_less @ real @ ( zero_zero @ real ) @ ( real_V557655796197034286t_dist @ A @ X16 @ X2 ) )
                     => ( ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X16 @ X2 ) @ D2 )
                       => ( ( F2 @ X16 )
                          = ( G @ X16 ) ) ) ) )
               => ( filterlim @ A @ B @ F2 @ F3 @ ( topolo174197925503356063within @ A @ X2 @ S3 ) ) ) ) ) ) ) ).

% filterlim_transform_within
thf(fact_6873_Cauchy__altdef,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ( ( topolo3814608138187158403Cauchy @ A )
        = ( ^ [F5: nat > A] :
            ! [E4: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ E4 )
             => ? [M9: nat] :
                ! [M6: nat] :
                  ( ( ord_less_eq @ nat @ M9 @ M6 )
                 => ! [N3: nat] :
                      ( ( ord_less @ nat @ M6 @ N3 )
                     => ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ ( F5 @ M6 ) @ ( F5 @ N3 ) ) @ E4 ) ) ) ) ) ) ) ).

% Cauchy_altdef
thf(fact_6874_CauchyI_H,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X8: nat > A] :
          ( ! [E: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ E )
             => ? [M10: nat] :
                ! [M3: nat] :
                  ( ( ord_less_eq @ nat @ M10 @ M3 )
                 => ! [N: nat] :
                      ( ( ord_less @ nat @ M3 @ N )
                     => ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ ( X8 @ M3 ) @ ( X8 @ N ) ) @ E ) ) ) )
         => ( topolo3814608138187158403Cauchy @ A @ X8 ) ) ) ).

% CauchyI'
thf(fact_6875_tendsto__dist__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V7819770556892013058_space @ B )
     => ! [F2: A > B,L: B,F3: filter @ A] :
          ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ L ) @ F3 )
          = ( filterlim @ A @ real
            @ ^ [X5: A] : ( real_V557655796197034286t_dist @ B @ ( F2 @ X5 ) @ L )
            @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
            @ F3 ) ) ) ).

% tendsto_dist_iff
thf(fact_6876_filterlim__times__pos,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( linordered_field @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [F2: B > A,P4: A,F13: filter @ B,C2: A,L: A] :
          ( ( filterlim @ B @ A @ F2 @ ( topolo174197925503356063within @ A @ P4 @ ( set_ord_greaterThan @ A @ P4 ) ) @ F13 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
           => ( ( L
                = ( times_times @ A @ C2 @ P4 ) )
             => ( filterlim @ B @ A
                @ ^ [X5: B] : ( times_times @ A @ C2 @ ( F2 @ X5 ) )
                @ ( topolo174197925503356063within @ A @ L @ ( set_ord_greaterThan @ A @ L ) )
                @ F13 ) ) ) ) ) ).

% filterlim_times_pos
thf(fact_6877_LIM__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V7819770556892013058_space @ A )
        & ( real_V7819770556892013058_space @ B ) )
     => ! [F2: A > B,L5: B,A2: A] :
          ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ L5 ) @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) )
          = ( ! [R5: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ R5 )
               => ? [S7: real] :
                    ( ( ord_less @ real @ ( zero_zero @ real ) @ S7 )
                    & ! [X5: A] :
                        ( ( ( X5 != A2 )
                          & ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X5 @ A2 ) @ S7 ) )
                       => ( ord_less @ real @ ( real_V557655796197034286t_dist @ B @ ( F2 @ X5 ) @ L5 ) @ R5 ) ) ) ) ) ) ) ).

% LIM_def
thf(fact_6878_metric__LIM__D,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V7819770556892013058_space @ A )
        & ( real_V7819770556892013058_space @ B ) )
     => ! [F2: A > B,L5: B,A2: A,R3: real] :
          ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ L5 ) @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) )
         => ( ( ord_less @ real @ ( zero_zero @ real ) @ R3 )
           => ? [S: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ S )
                & ! [X: A] :
                    ( ( ( X != A2 )
                      & ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X @ A2 ) @ S ) )
                   => ( ord_less @ real @ ( real_V557655796197034286t_dist @ B @ ( F2 @ X ) @ L5 ) @ R3 ) ) ) ) ) ) ).

% metric_LIM_D
thf(fact_6879_metric__LIM__I,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V7819770556892013058_space @ A )
        & ( real_V7819770556892013058_space @ B ) )
     => ! [A2: A,F2: A > B,L5: B] :
          ( ! [R4: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ R4 )
             => ? [S9: real] :
                  ( ( ord_less @ real @ ( zero_zero @ real ) @ S9 )
                  & ! [X3: A] :
                      ( ( ( X3 != A2 )
                        & ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X3 @ A2 ) @ S9 ) )
                     => ( ord_less @ real @ ( real_V557655796197034286t_dist @ B @ ( F2 @ X3 ) @ L5 ) @ R4 ) ) ) )
         => ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ L5 ) @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% metric_LIM_I
thf(fact_6880_metric__LIM__equal2,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V7819770556892013058_space @ A )
        & ( topolo4958980785337419405_space @ B ) )
     => ! [G: A > B,L: B,A2: A,R: real,F2: A > B] :
          ( ( filterlim @ A @ B @ G @ ( topolo7230453075368039082e_nhds @ B @ L ) @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) )
         => ( ( ord_less @ real @ ( zero_zero @ real ) @ R )
           => ( ! [X3: A] :
                  ( ( X3 != A2 )
                 => ( ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X3 @ A2 ) @ R )
                   => ( ( F2 @ X3 )
                      = ( G @ X3 ) ) ) )
             => ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ L ) @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ) ).

% metric_LIM_equal2
thf(fact_6881_lim__sequentially,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X8: nat > A,L5: A] :
          ( ( filterlim @ nat @ A @ X8 @ ( topolo7230453075368039082e_nhds @ A @ L5 ) @ ( at_top @ nat ) )
          = ( ! [R5: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ R5 )
               => ? [No3: nat] :
                  ! [N3: nat] :
                    ( ( ord_less_eq @ nat @ No3 @ N3 )
                   => ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ ( X8 @ N3 ) @ L5 ) @ R5 ) ) ) ) ) ) ).

% lim_sequentially
thf(fact_6882_metric__LIMSEQ__I,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X8: nat > A,L5: A] :
          ( ! [R4: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ R4 )
             => ? [No2: nat] :
                ! [N: nat] :
                  ( ( ord_less_eq @ nat @ No2 @ N )
                 => ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ ( X8 @ N ) @ L5 ) @ R4 ) ) )
         => ( filterlim @ nat @ A @ X8 @ ( topolo7230453075368039082e_nhds @ A @ L5 ) @ ( at_top @ nat ) ) ) ) ).

% metric_LIMSEQ_I
thf(fact_6883_metric__LIMSEQ__D,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X8: nat > A,L5: A,R3: real] :
          ( ( filterlim @ nat @ A @ X8 @ ( topolo7230453075368039082e_nhds @ A @ L5 ) @ ( at_top @ nat ) )
         => ( ( ord_less @ real @ ( zero_zero @ real ) @ R3 )
           => ? [No: nat] :
              ! [N9: nat] :
                ( ( ord_less_eq @ nat @ No @ N9 )
               => ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ ( X8 @ N9 ) @ L5 ) @ R3 ) ) ) ) ) ).

% metric_LIMSEQ_D
thf(fact_6884_metric__Cauchy__iff2,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ( ( topolo3814608138187158403Cauchy @ A )
        = ( ^ [X4: nat > A] :
            ! [J3: nat] :
            ? [M9: nat] :
            ! [M6: nat] :
              ( ( ord_less_eq @ nat @ M9 @ M6 )
             => ! [N3: nat] :
                  ( ( ord_less_eq @ nat @ M9 @ N3 )
                 => ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ ( X4 @ M6 ) @ ( X4 @ N3 ) ) @ ( inverse_inverse @ real @ ( semiring_1_of_nat @ real @ ( suc @ J3 ) ) ) ) ) ) ) ) ) ).

% metric_Cauchy_iff2
thf(fact_6885_metric__LIM__compose2,axiom,
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( ( real_V7819770556892013058_space @ A )
        & ( topolo4958980785337419405_space @ B )
        & ( topolo4958980785337419405_space @ C ) )
     => ! [F2: A > B,B2: B,A2: A,G: B > C,C2: C] :
          ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ B2 ) @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) )
         => ( ( filterlim @ B @ C @ G @ ( topolo7230453075368039082e_nhds @ C @ C2 ) @ ( topolo174197925503356063within @ B @ B2 @ ( top_top @ ( set @ B ) ) ) )
           => ( ? [D6: real] :
                  ( ( ord_less @ real @ ( zero_zero @ real ) @ D6 )
                  & ! [X3: A] :
                      ( ( ( X3 != A2 )
                        & ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X3 @ A2 ) @ D6 ) )
                     => ( ( F2 @ X3 )
                       != B2 ) ) )
             => ( filterlim @ A @ C
                @ ^ [X5: A] : ( G @ ( F2 @ X5 ) )
                @ ( topolo7230453075368039082e_nhds @ C @ C2 )
                @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ) ).

% metric_LIM_compose2
thf(fact_6886_tendsto__arcosh__at__left__1,axiom,
    filterlim @ real @ real @ ( arcosh @ real ) @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( topolo174197925503356063within @ real @ ( one_one @ real ) @ ( set_ord_greaterThan @ real @ ( one_one @ real ) ) ) ).

% tendsto_arcosh_at_left_1
thf(fact_6887_metric__isCont__LIM__compose2,axiom,
    ! [D: $tType,C: $tType,A: $tType] :
      ( ( ( real_V7819770556892013058_space @ A )
        & ( topolo4958980785337419405_space @ C )
        & ( topolo4958980785337419405_space @ D ) )
     => ! [A2: A,F2: A > C,G: C > D,L: D] :
          ( ( topolo3448309680560233919inuous @ A @ C @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) @ F2 )
         => ( ( filterlim @ C @ D @ G @ ( topolo7230453075368039082e_nhds @ D @ L ) @ ( topolo174197925503356063within @ C @ ( F2 @ A2 ) @ ( top_top @ ( set @ C ) ) ) )
           => ( ? [D6: real] :
                  ( ( ord_less @ real @ ( zero_zero @ real ) @ D6 )
                  & ! [X3: A] :
                      ( ( ( X3 != A2 )
                        & ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X3 @ A2 ) @ D6 ) )
                     => ( ( F2 @ X3 )
                       != ( F2 @ A2 ) ) ) )
             => ( filterlim @ A @ D
                @ ^ [X5: A] : ( G @ ( F2 @ X5 ) )
                @ ( topolo7230453075368039082e_nhds @ D @ L )
                @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ) ).

% metric_isCont_LIM_compose2
thf(fact_6888_isCont__If__ge,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topolo1944317154257567458pology @ A )
        & ( topolo4958980785337419405_space @ B ) )
     => ! [A2: A,G: A > B,F2: A > B] :
          ( ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ ( set_ord_lessThan @ A @ A2 ) ) @ G )
         => ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ ( G @ A2 ) ) @ ( topolo174197925503356063within @ A @ A2 @ ( set_ord_greaterThan @ A @ A2 ) ) )
           => ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) )
              @ ^ [X5: A] : ( if @ B @ ( ord_less_eq @ A @ X5 @ A2 ) @ ( G @ X5 ) @ ( F2 @ X5 ) ) ) ) ) ) ).

% isCont_If_ge
thf(fact_6889_LIMSEQ__iff__nz,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X8: nat > A,L5: A] :
          ( ( filterlim @ nat @ A @ X8 @ ( topolo7230453075368039082e_nhds @ A @ L5 ) @ ( at_top @ nat ) )
          = ( ! [R5: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ R5 )
               => ? [No3: nat] :
                    ( ( ord_less @ nat @ ( zero_zero @ nat ) @ No3 )
                    & ! [N3: nat] :
                        ( ( ord_less_eq @ nat @ No3 @ N3 )
                       => ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ ( X8 @ N3 ) @ L5 ) @ R5 ) ) ) ) ) ) ) ).

% LIMSEQ_iff_nz
thf(fact_6890_totally__bounded__metric,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ( ( topolo6688025880775521714ounded @ A )
        = ( ^ [S6: set @ A] :
            ! [E4: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ E4 )
             => ? [K3: set @ A] :
                  ( ( finite_finite @ A @ K3 )
                  & ( ord_less_eq @ ( set @ A ) @ S6
                    @ ( complete_Sup_Sup @ ( set @ A )
                      @ ( image @ A @ ( set @ A )
                        @ ^ [X5: A] :
                            ( collect @ A
                            @ ^ [Y5: A] : ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X5 @ Y5 ) @ E4 ) )
                        @ K3 ) ) ) ) ) ) ) ) ).

% totally_bounded_metric
thf(fact_6891_filterlim__tan__at__right,axiom,
    filterlim @ real @ real @ ( tan @ real ) @ ( at_bot @ real ) @ ( topolo174197925503356063within @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ ( set_ord_greaterThan @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ).

% filterlim_tan_at_right
thf(fact_6892_totally__bounded__subset,axiom,
    ! [A: $tType] :
      ( ( topolo7287701948861334536_space @ A )
     => ! [S3: set @ A,T6: set @ A] :
          ( ( topolo6688025880775521714ounded @ A @ S3 )
         => ( ( ord_less_eq @ ( set @ A ) @ T6 @ S3 )
           => ( topolo6688025880775521714ounded @ A @ T6 ) ) ) ) ).

% totally_bounded_subset
thf(fact_6893_greaterThan__0,axiom,
    ( ( set_ord_greaterThan @ nat @ ( zero_zero @ nat ) )
    = ( image @ nat @ nat @ suc @ ( top_top @ ( set @ nat ) ) ) ) ).

% greaterThan_0
thf(fact_6894_exp__at__bot,axiom,
    filterlim @ real @ real @ ( exp @ real ) @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( at_bot @ real ) ).

% exp_at_bot
thf(fact_6895_greaterThan__Suc,axiom,
    ! [K: nat] :
      ( ( set_ord_greaterThan @ nat @ ( suc @ K ) )
      = ( minus_minus @ ( set @ nat ) @ ( set_ord_greaterThan @ nat @ K ) @ ( insert @ nat @ ( suc @ K ) @ ( bot_bot @ ( set @ nat ) ) ) ) ) ).

% greaterThan_Suc
thf(fact_6896_filterlim__inverse__at__bot__neg,axiom,
    filterlim @ real @ real @ ( inverse_inverse @ real ) @ ( at_bot @ real ) @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_lessThan @ real @ ( zero_zero @ real ) ) ) ).

% filterlim_inverse_at_bot_neg
thf(fact_6897_filterlim__tendsto__pos__mult__at__bot,axiom,
    ! [A: $tType,F2: A > real,C2: real,F3: filter @ A,G: A > real] :
      ( ( filterlim @ A @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ C2 ) @ F3 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ C2 )
       => ( ( filterlim @ A @ real @ G @ ( at_bot @ real ) @ F3 )
         => ( filterlim @ A @ real
            @ ^ [X5: A] : ( times_times @ real @ ( F2 @ X5 ) @ ( G @ X5 ) )
            @ ( at_bot @ real )
            @ F3 ) ) ) ) ).

% filterlim_tendsto_pos_mult_at_bot
thf(fact_6898_ln__at__0,axiom,
    filterlim @ real @ real @ ( ln_ln @ real ) @ ( at_bot @ real ) @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) ).

% ln_at_0
thf(fact_6899_DERIV__pos__imp__increasing__at__bot,axiom,
    ! [B2: real,F2: real > real,Flim: real] :
      ( ! [X3: real] :
          ( ( ord_less_eq @ real @ X3 @ B2 )
         => ? [Y: real] :
              ( ( has_field_derivative @ real @ F2 @ Y @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) )
              & ( ord_less @ real @ ( zero_zero @ real ) @ Y ) ) )
     => ( ( filterlim @ real @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ Flim ) @ ( at_bot @ real ) )
       => ( ord_less @ real @ Flim @ ( F2 @ B2 ) ) ) ) ).

% DERIV_pos_imp_increasing_at_bot
thf(fact_6900_filterlim__pow__at__bot__odd,axiom,
    ! [N2: nat,F2: real > real,F3: filter @ real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( filterlim @ real @ real @ F2 @ ( at_bot @ real ) @ F3 )
       => ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 )
         => ( filterlim @ real @ real
            @ ^ [X5: real] : ( power_power @ real @ ( F2 @ X5 ) @ N2 )
            @ ( at_bot @ real )
            @ F3 ) ) ) ) ).

% filterlim_pow_at_bot_odd
thf(fact_6901_tendsto__arctan__at__bot,axiom,
    filterlim @ real @ real @ arctan @ ( topolo7230453075368039082e_nhds @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) @ ( at_bot @ real ) ).

% tendsto_arctan_at_bot
thf(fact_6902_filterlim__pow__at__bot__even,axiom,
    ! [N2: nat,F2: real > real,F3: filter @ real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( filterlim @ real @ real @ F2 @ ( at_bot @ real ) @ F3 )
       => ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 )
         => ( filterlim @ real @ real
            @ ^ [X5: real] : ( power_power @ real @ ( F2 @ X5 ) @ N2 )
            @ ( at_top @ real )
            @ F3 ) ) ) ) ).

% filterlim_pow_at_bot_even
thf(fact_6903_lim__zero__infinity,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,L: A] :
          ( ( filterlim @ A @ A
            @ ^ [X5: A] : ( F2 @ ( divide_divide @ A @ ( one_one @ A ) @ X5 ) )
            @ ( topolo7230453075368039082e_nhds @ A @ L )
            @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) )
         => ( filterlim @ A @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ L ) @ ( at_infinity @ A ) ) ) ) ).

% lim_zero_infinity
thf(fact_6904_filterlim__at__top__mult__at__top,axiom,
    ! [A: $tType,F2: A > real,F3: filter @ A,G: A > real] :
      ( ( filterlim @ A @ real @ F2 @ ( at_top @ real ) @ F3 )
     => ( ( filterlim @ A @ real @ G @ ( at_top @ real ) @ F3 )
       => ( filterlim @ A @ real
          @ ^ [X5: A] : ( times_times @ real @ ( F2 @ X5 ) @ ( G @ X5 ) )
          @ ( at_top @ real )
          @ F3 ) ) ) ).

% filterlim_at_top_mult_at_top
thf(fact_6905_at__bot__le__at__infinity,axiom,
    ord_less_eq @ ( filter @ real ) @ ( at_bot @ real ) @ ( at_infinity @ real ) ).

% at_bot_le_at_infinity
thf(fact_6906_at__top__le__at__infinity,axiom,
    ord_less_eq @ ( filter @ real ) @ ( at_top @ real ) @ ( at_infinity @ real ) ).

% at_top_le_at_infinity
thf(fact_6907_filterlim__pow__at__top,axiom,
    ! [A: $tType,N2: nat,F2: A > real,F3: filter @ A] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( filterlim @ A @ real @ F2 @ ( at_top @ real ) @ F3 )
       => ( filterlim @ A @ real
          @ ^ [X5: A] : ( power_power @ real @ ( F2 @ X5 ) @ N2 )
          @ ( at_top @ real )
          @ F3 ) ) ) ).

% filterlim_pow_at_top
thf(fact_6908_tendsto__add__filterlim__at__infinity,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector @ B )
     => ! [F2: A > B,C2: B,F3: filter @ A,G: A > B] :
          ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ C2 ) @ F3 )
         => ( ( filterlim @ A @ B @ G @ ( at_infinity @ B ) @ F3 )
           => ( filterlim @ A @ B
              @ ^ [X5: A] : ( plus_plus @ B @ ( F2 @ X5 ) @ ( G @ X5 ) )
              @ ( at_infinity @ B )
              @ F3 ) ) ) ) ).

% tendsto_add_filterlim_at_infinity
thf(fact_6909_tendsto__add__filterlim__at__infinity_H,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector @ B )
     => ! [F2: A > B,F3: filter @ A,G: A > B,C2: B] :
          ( ( filterlim @ A @ B @ F2 @ ( at_infinity @ B ) @ F3 )
         => ( ( filterlim @ A @ B @ G @ ( topolo7230453075368039082e_nhds @ B @ C2 ) @ F3 )
           => ( filterlim @ A @ B
              @ ^ [X5: A] : ( plus_plus @ B @ ( F2 @ X5 ) @ ( G @ X5 ) )
              @ ( at_infinity @ B )
              @ F3 ) ) ) ) ).

% tendsto_add_filterlim_at_infinity'
thf(fact_6910_real__tendsto__divide__at__top,axiom,
    ! [A: $tType,F2: A > real,C2: real,F3: filter @ A,G: A > real] :
      ( ( filterlim @ A @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ C2 ) @ F3 )
     => ( ( filterlim @ A @ real @ G @ ( at_top @ real ) @ F3 )
       => ( filterlim @ A @ real
          @ ^ [X5: A] : ( divide_divide @ real @ ( F2 @ X5 ) @ ( G @ X5 ) )
          @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
          @ F3 ) ) ) ).

% real_tendsto_divide_at_top
thf(fact_6911_tendsto__inverse__0__at__top,axiom,
    ! [A: $tType,F2: A > real,F3: filter @ A] :
      ( ( filterlim @ A @ real @ F2 @ ( at_top @ real ) @ F3 )
     => ( filterlim @ A @ real
        @ ^ [X5: A] : ( inverse_inverse @ real @ ( F2 @ X5 ) )
        @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
        @ F3 ) ) ).

% tendsto_inverse_0_at_top
thf(fact_6912_tendsto__inverse__0,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ( filterlim @ A @ A @ ( inverse_inverse @ A ) @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) ) @ ( at_infinity @ A ) ) ) ).

% tendsto_inverse_0
thf(fact_6913_filterlim__tendsto__pos__mult__at__top,axiom,
    ! [A: $tType,F2: A > real,C2: real,F3: filter @ A,G: A > real] :
      ( ( filterlim @ A @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ C2 ) @ F3 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ C2 )
       => ( ( filterlim @ A @ real @ G @ ( at_top @ real ) @ F3 )
         => ( filterlim @ A @ real
            @ ^ [X5: A] : ( times_times @ real @ ( F2 @ X5 ) @ ( G @ X5 ) )
            @ ( at_top @ real )
            @ F3 ) ) ) ) ).

% filterlim_tendsto_pos_mult_at_top
thf(fact_6914_filterlim__at__top__mult__tendsto__pos,axiom,
    ! [A: $tType,F2: A > real,C2: real,F3: filter @ A,G: A > real] :
      ( ( filterlim @ A @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ C2 ) @ F3 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ C2 )
       => ( ( filterlim @ A @ real @ G @ ( at_top @ real ) @ F3 )
         => ( filterlim @ A @ real
            @ ^ [X5: A] : ( times_times @ real @ ( G @ X5 ) @ ( F2 @ X5 ) )
            @ ( at_top @ real )
            @ F3 ) ) ) ) ).

% filterlim_at_top_mult_tendsto_pos
thf(fact_6915_tendsto__neg__powr,axiom,
    ! [A: $tType,S2: real,F2: A > real,F3: filter @ A] :
      ( ( ord_less @ real @ S2 @ ( zero_zero @ real ) )
     => ( ( filterlim @ A @ real @ F2 @ ( at_top @ real ) @ F3 )
       => ( filterlim @ A @ real
          @ ^ [X5: A] : ( powr @ real @ ( F2 @ X5 ) @ S2 )
          @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
          @ F3 ) ) ) ).

% tendsto_neg_powr
thf(fact_6916_tendsto__mult__filterlim__at__infinity,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: B > A,C2: A,F3: filter @ B,G: B > A] :
          ( ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ C2 ) @ F3 )
         => ( ( C2
             != ( zero_zero @ A ) )
           => ( ( filterlim @ B @ A @ G @ ( at_infinity @ A ) @ F3 )
             => ( filterlim @ B @ A
                @ ^ [X5: B] : ( times_times @ A @ ( F2 @ X5 ) @ ( G @ X5 ) )
                @ ( at_infinity @ A )
                @ F3 ) ) ) ) ) ).

% tendsto_mult_filterlim_at_infinity
thf(fact_6917_ln__x__over__x__tendsto__0,axiom,
    ( filterlim @ real @ real
    @ ^ [X5: real] : ( divide_divide @ real @ ( ln_ln @ real @ X5 ) @ X5 )
    @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
    @ ( at_top @ real ) ) ).

% ln_x_over_x_tendsto_0
thf(fact_6918_tendsto__divide__0,axiom,
    ! [A: $tType,C: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [F2: C > A,C2: A,F3: filter @ C,G: C > A] :
          ( ( filterlim @ C @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ C2 ) @ F3 )
         => ( ( filterlim @ C @ A @ G @ ( at_infinity @ A ) @ F3 )
           => ( filterlim @ C @ A
              @ ^ [X5: C] : ( divide_divide @ A @ ( F2 @ X5 ) @ ( G @ X5 ) )
              @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) )
              @ F3 ) ) ) ) ).

% tendsto_divide_0
thf(fact_6919_filterlim__at__top__to__right,axiom,
    ! [A: $tType,F2: real > A,F3: filter @ A] :
      ( ( filterlim @ real @ A @ F2 @ F3 @ ( at_top @ real ) )
      = ( filterlim @ real @ A
        @ ^ [X5: real] : ( F2 @ ( inverse_inverse @ real @ X5 ) )
        @ F3
        @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) ) ) ).

% filterlim_at_top_to_right
thf(fact_6920_filterlim__at__right__to__top,axiom,
    ! [A: $tType,F2: real > A,F3: filter @ A] :
      ( ( filterlim @ real @ A @ F2 @ F3 @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) )
      = ( filterlim @ real @ A
        @ ^ [X5: real] : ( F2 @ ( inverse_inverse @ real @ X5 ) )
        @ F3
        @ ( at_top @ real ) ) ) ).

% filterlim_at_right_to_top
thf(fact_6921_filterlim__power__at__infinity,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V8999393235501362500lgebra @ B )
     => ! [F2: A > B,F3: filter @ A,N2: nat] :
          ( ( filterlim @ A @ B @ F2 @ ( at_infinity @ B ) @ F3 )
         => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
           => ( filterlim @ A @ B
              @ ^ [X5: A] : ( power_power @ B @ ( F2 @ X5 ) @ N2 )
              @ ( at_infinity @ B )
              @ F3 ) ) ) ) ).

% filterlim_power_at_infinity
thf(fact_6922_filterlim__inverse__at__top__right,axiom,
    filterlim @ real @ real @ ( inverse_inverse @ real ) @ ( at_top @ real ) @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) ).

% filterlim_inverse_at_top_right
thf(fact_6923_filterlim__inverse__at__right__top,axiom,
    filterlim @ real @ real @ ( inverse_inverse @ real ) @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) @ ( at_top @ real ) ).

% filterlim_inverse_at_right_top
thf(fact_6924_filterlim__inverse__at__infinity,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ( filterlim @ A @ A @ ( inverse_inverse @ A ) @ ( at_infinity @ A ) @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ).

% filterlim_inverse_at_infinity
thf(fact_6925_filterlim__tendsto__neg__mult__at__bot,axiom,
    ! [A: $tType,F2: A > real,C2: real,F3: filter @ A,G: A > real] :
      ( ( filterlim @ A @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ C2 ) @ F3 )
     => ( ( ord_less @ real @ C2 @ ( zero_zero @ real ) )
       => ( ( filterlim @ A @ real @ G @ ( at_top @ real ) @ F3 )
         => ( filterlim @ A @ real
            @ ^ [X5: A] : ( times_times @ real @ ( F2 @ X5 ) @ ( G @ X5 ) )
            @ ( at_bot @ real )
            @ F3 ) ) ) ) ).

% filterlim_tendsto_neg_mult_at_bot
thf(fact_6926_tendsto__power__div__exp__0,axiom,
    ! [K: nat] :
      ( filterlim @ real @ real
      @ ^ [X5: real] : ( divide_divide @ real @ ( power_power @ real @ X5 @ K ) @ ( exp @ real @ X5 ) )
      @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
      @ ( at_top @ real ) ) ).

% tendsto_power_div_exp_0
thf(fact_6927_filterlim__inverse__at__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V8999393235501362500lgebra @ B )
     => ! [G: A > B,F3: filter @ A] :
          ( ( filterlim @ A @ B
            @ ^ [X5: A] : ( inverse_inverse @ B @ ( G @ X5 ) )
            @ ( topolo174197925503356063within @ B @ ( zero_zero @ B ) @ ( top_top @ ( set @ B ) ) )
            @ F3 )
          = ( filterlim @ A @ B @ G @ ( at_infinity @ B ) @ F3 ) ) ) ).

% filterlim_inverse_at_iff
thf(fact_6928_tendsto__exp__limit__at__top,axiom,
    ! [X2: real] :
      ( filterlim @ real @ real
      @ ^ [Y5: real] : ( powr @ real @ ( plus_plus @ real @ ( one_one @ real ) @ ( divide_divide @ real @ X2 @ Y5 ) ) @ Y5 )
      @ ( topolo7230453075368039082e_nhds @ real @ ( exp @ real @ X2 ) )
      @ ( at_top @ real ) ) ).

% tendsto_exp_limit_at_top
thf(fact_6929_filterlim__divide__at__infinity,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,C2: A,F3: filter @ A,G: A > A] :
          ( ( filterlim @ A @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ C2 ) @ F3 )
         => ( ( filterlim @ A @ A @ G @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) @ F3 )
           => ( ( C2
               != ( zero_zero @ A ) )
             => ( filterlim @ A @ A
                @ ^ [X5: A] : ( divide_divide @ A @ ( F2 @ X5 ) @ ( G @ X5 ) )
                @ ( at_infinity @ A )
                @ F3 ) ) ) ) ) ).

% filterlim_divide_at_infinity
thf(fact_6930_filterlim__tan__at__left,axiom,
    filterlim @ real @ real @ ( tan @ real ) @ ( at_top @ real ) @ ( topolo174197925503356063within @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( set_ord_lessThan @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ).

% filterlim_tan_at_left
thf(fact_6931_DERIV__neg__imp__decreasing__at__top,axiom,
    ! [B2: real,F2: real > real,Flim: real] :
      ( ! [X3: real] :
          ( ( ord_less_eq @ real @ B2 @ X3 )
         => ? [Y: real] :
              ( ( has_field_derivative @ real @ F2 @ Y @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) )
              & ( ord_less @ real @ Y @ ( zero_zero @ real ) ) ) )
     => ( ( filterlim @ real @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ Flim ) @ ( at_top @ real ) )
       => ( ord_less @ real @ Flim @ ( F2 @ B2 ) ) ) ) ).

% DERIV_neg_imp_decreasing_at_top
thf(fact_6932_tendsto__arctan__at__top,axiom,
    filterlim @ real @ real @ arctan @ ( topolo7230453075368039082e_nhds @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ ( at_top @ real ) ).

% tendsto_arctan_at_top
thf(fact_6933_filterlim__realpow__sequentially__gt1,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [X2: A] :
          ( ( ord_less @ real @ ( one_one @ real ) @ ( real_V7770717601297561774m_norm @ A @ X2 ) )
         => ( filterlim @ nat @ A @ ( power_power @ A @ X2 ) @ ( at_infinity @ A ) @ ( at_top @ nat ) ) ) ) ).

% filterlim_realpow_sequentially_gt1
thf(fact_6934_lim__at__infinity__0,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,L: A] :
          ( ( filterlim @ A @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ L ) @ ( at_infinity @ A ) )
          = ( filterlim @ A @ A @ ( comp @ A @ A @ A @ F2 @ ( inverse_inverse @ A ) ) @ ( topolo7230453075368039082e_nhds @ A @ L ) @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% lim_at_infinity_0
thf(fact_6935_polyfun__extremal,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [C2: nat > A,K: nat,N2: nat,B3: real] :
          ( ( ( C2 @ K )
           != ( zero_zero @ A ) )
         => ( ( ord_less_eq @ nat @ ( one_one @ nat ) @ K )
           => ( ( ord_less_eq @ nat @ K @ N2 )
             => ( eventually @ A
                @ ^ [Z6: A] :
                    ( ord_less_eq @ real @ B3
                    @ ( real_V7770717601297561774m_norm @ A
                      @ ( groups7311177749621191930dd_sum @ nat @ A
                        @ ^ [I4: nat] : ( times_times @ A @ ( C2 @ I4 ) @ ( power_power @ A @ Z6 @ I4 ) )
                        @ ( set_ord_atMost @ nat @ N2 ) ) ) )
                @ ( at_infinity @ A ) ) ) ) ) ) ).

% polyfun_extremal
thf(fact_6936_lhopital__left__at__top,axiom,
    ! [G: real > real,X2: real,G6: real > real,F2: real > real,F8: real > real,Y2: real] :
      ( ( filterlim @ real @ real @ G @ ( at_top @ real ) @ ( topolo174197925503356063within @ real @ X2 @ ( set_ord_lessThan @ real @ X2 ) ) )
     => ( ( eventually @ real
          @ ^ [X5: real] :
              ( ( G6 @ X5 )
             != ( zero_zero @ real ) )
          @ ( topolo174197925503356063within @ real @ X2 @ ( set_ord_lessThan @ real @ X2 ) ) )
       => ( ( eventually @ real
            @ ^ [X5: real] : ( has_field_derivative @ real @ F2 @ ( F8 @ X5 ) @ ( topolo174197925503356063within @ real @ X5 @ ( top_top @ ( set @ real ) ) ) )
            @ ( topolo174197925503356063within @ real @ X2 @ ( set_ord_lessThan @ real @ X2 ) ) )
         => ( ( eventually @ real
              @ ^ [X5: real] : ( has_field_derivative @ real @ G @ ( G6 @ X5 ) @ ( topolo174197925503356063within @ real @ X5 @ ( top_top @ ( set @ real ) ) ) )
              @ ( topolo174197925503356063within @ real @ X2 @ ( set_ord_lessThan @ real @ X2 ) ) )
           => ( ( filterlim @ real @ real
                @ ^ [X5: real] : ( divide_divide @ real @ ( F8 @ X5 ) @ ( G6 @ X5 ) )
                @ ( topolo7230453075368039082e_nhds @ real @ Y2 )
                @ ( topolo174197925503356063within @ real @ X2 @ ( set_ord_lessThan @ real @ X2 ) ) )
             => ( filterlim @ real @ real
                @ ^ [X5: real] : ( divide_divide @ real @ ( F2 @ X5 ) @ ( G @ X5 ) )
                @ ( topolo7230453075368039082e_nhds @ real @ Y2 )
                @ ( topolo174197925503356063within @ real @ X2 @ ( set_ord_lessThan @ real @ X2 ) ) ) ) ) ) ) ) ).

% lhopital_left_at_top
thf(fact_6937_eventually__sequentially__Suc,axiom,
    ! [P: nat > $o] :
      ( ( eventually @ nat
        @ ^ [I4: nat] : ( P @ ( suc @ I4 ) )
        @ ( at_top @ nat ) )
      = ( eventually @ nat @ P @ ( at_top @ nat ) ) ) ).

% eventually_sequentially_Suc
thf(fact_6938_eventually__sequentially__seg,axiom,
    ! [P: nat > $o,K: nat] :
      ( ( eventually @ nat
        @ ^ [N3: nat] : ( P @ ( plus_plus @ nat @ N3 @ K ) )
        @ ( at_top @ nat ) )
      = ( eventually @ nat @ P @ ( at_top @ nat ) ) ) ).

% eventually_sequentially_seg
thf(fact_6939_sequentially__offset,axiom,
    ! [P: nat > $o,K: nat] :
      ( ( eventually @ nat @ P @ ( at_top @ nat ) )
     => ( eventually @ nat
        @ ^ [I4: nat] : ( P @ ( plus_plus @ nat @ I4 @ K ) )
        @ ( at_top @ nat ) ) ) ).

% sequentially_offset
thf(fact_6940_eventually__at__top__dense,axiom,
    ! [A: $tType] :
      ( ( ( linorder @ A )
        & ( no_top @ A ) )
     => ! [P: A > $o] :
          ( ( eventually @ A @ P @ ( at_top @ A ) )
          = ( ? [N6: A] :
              ! [N3: A] :
                ( ( ord_less @ A @ N6 @ N3 )
               => ( P @ N3 ) ) ) ) ) ).

% eventually_at_top_dense
thf(fact_6941_eventually__gt__at__top,axiom,
    ! [A: $tType] :
      ( ( ( linorder @ A )
        & ( no_top @ A ) )
     => ! [C2: A] : ( eventually @ A @ ( ord_less @ A @ C2 ) @ ( at_top @ A ) ) ) ).

% eventually_gt_at_top
thf(fact_6942_le__sequentially,axiom,
    ! [F3: filter @ nat] :
      ( ( ord_less_eq @ ( filter @ nat ) @ F3 @ ( at_top @ nat ) )
      = ( ! [N6: nat] : ( eventually @ nat @ ( ord_less_eq @ nat @ N6 ) @ F3 ) ) ) ).

% le_sequentially
thf(fact_6943_eventually__ge__at__top,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [C2: A] : ( eventually @ A @ ( ord_less_eq @ A @ C2 ) @ ( at_top @ A ) ) ) ).

% eventually_ge_at_top
thf(fact_6944_eventually__at__top__linorderI,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [C2: A,P: A > $o] :
          ( ! [X3: A] :
              ( ( ord_less_eq @ A @ C2 @ X3 )
             => ( P @ X3 ) )
         => ( eventually @ A @ P @ ( at_top @ A ) ) ) ) ).

% eventually_at_top_linorderI
thf(fact_6945_eventually__at__top__linorder,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [P: A > $o] :
          ( ( eventually @ A @ P @ ( at_top @ A ) )
          = ( ? [N6: A] :
              ! [N3: A] :
                ( ( ord_less_eq @ A @ N6 @ N3 )
               => ( P @ N3 ) ) ) ) ) ).

% eventually_at_top_linorder
thf(fact_6946_eventually__sequentiallyI,axiom,
    ! [C2: nat,P: nat > $o] :
      ( ! [X3: nat] :
          ( ( ord_less_eq @ nat @ C2 @ X3 )
         => ( P @ X3 ) )
     => ( eventually @ nat @ P @ ( at_top @ nat ) ) ) ).

% eventually_sequentiallyI
thf(fact_6947_eventually__sequentially,axiom,
    ! [P: nat > $o] :
      ( ( eventually @ nat @ P @ ( at_top @ nat ) )
      = ( ? [N6: nat] :
          ! [N3: nat] :
            ( ( ord_less_eq @ nat @ N6 @ N3 )
           => ( P @ N3 ) ) ) ) ).

% eventually_sequentially
thf(fact_6948_le__filter__def,axiom,
    ! [A: $tType] :
      ( ( ord_less_eq @ ( filter @ A ) )
      = ( ^ [F9: filter @ A,F10: filter @ A] :
          ! [P3: A > $o] :
            ( ( eventually @ A @ P3 @ F10 )
           => ( eventually @ A @ P3 @ F9 ) ) ) ) ).

% le_filter_def
thf(fact_6949_filter__leI,axiom,
    ! [A: $tType,F11: filter @ A,F3: filter @ A] :
      ( ! [P8: A > $o] :
          ( ( eventually @ A @ P8 @ F11 )
         => ( eventually @ A @ P8 @ F3 ) )
     => ( ord_less_eq @ ( filter @ A ) @ F3 @ F11 ) ) ).

% filter_leI
thf(fact_6950_filter__leD,axiom,
    ! [A: $tType,F3: filter @ A,F11: filter @ A,P: A > $o] :
      ( ( ord_less_eq @ ( filter @ A ) @ F3 @ F11 )
     => ( ( eventually @ A @ P @ F11 )
       => ( eventually @ A @ P @ F3 ) ) ) ).

% filter_leD
thf(fact_6951_eventually__at__bot__linorder,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [P: A > $o] :
          ( ( eventually @ A @ P @ ( at_bot @ A ) )
          = ( ? [N6: A] :
              ! [N3: A] :
                ( ( ord_less_eq @ A @ N3 @ N6 )
               => ( P @ N3 ) ) ) ) ) ).

% eventually_at_bot_linorder
thf(fact_6952_eventually__le__at__bot,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [C2: A] :
          ( eventually @ A
          @ ^ [X5: A] : ( ord_less_eq @ A @ X5 @ C2 )
          @ ( at_bot @ A ) ) ) ).

% eventually_le_at_bot
thf(fact_6953_eventually__gt__at__bot,axiom,
    ! [A: $tType] :
      ( ( unboun7993243217541854897norder @ A )
     => ! [C2: A] :
          ( eventually @ A
          @ ^ [X5: A] : ( ord_less @ A @ X5 @ C2 )
          @ ( at_bot @ A ) ) ) ).

% eventually_gt_at_bot
thf(fact_6954_eventually__at__bot__dense,axiom,
    ! [A: $tType] :
      ( ( ( linorder @ A )
        & ( no_bot @ A ) )
     => ! [P: A > $o] :
          ( ( eventually @ A @ P @ ( at_bot @ A ) )
          = ( ? [N6: A] :
              ! [N3: A] :
                ( ( ord_less @ A @ N3 @ N6 )
               => ( P @ N3 ) ) ) ) ) ).

% eventually_at_bot_dense
thf(fact_6955_filterlim__mono__eventually,axiom,
    ! [B: $tType,A: $tType,F2: A > B,F3: filter @ B,G7: filter @ A,F11: filter @ B,G8: filter @ A,F8: A > B] :
      ( ( filterlim @ A @ B @ F2 @ F3 @ G7 )
     => ( ( ord_less_eq @ ( filter @ B ) @ F3 @ F11 )
       => ( ( ord_less_eq @ ( filter @ A ) @ G8 @ G7 )
         => ( ( eventually @ A
              @ ^ [X5: A] :
                  ( ( F2 @ X5 )
                  = ( F8 @ X5 ) )
              @ G8 )
           => ( filterlim @ A @ B @ F8 @ F11 @ G8 ) ) ) ) ) ).

% filterlim_mono_eventually
thf(fact_6956_eventually__nhds__top,axiom,
    ! [A: $tType] :
      ( ( ( order_top @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [B2: A,P: A > $o] :
          ( ( ord_less @ A @ B2 @ ( top_top @ A ) )
         => ( ( eventually @ A @ P @ ( topolo7230453075368039082e_nhds @ A @ ( top_top @ A ) ) )
            = ( ? [B4: A] :
                  ( ( ord_less @ A @ B4 @ ( top_top @ A ) )
                  & ! [Z6: A] :
                      ( ( ord_less @ A @ B4 @ Z6 )
                     => ( P @ Z6 ) ) ) ) ) ) ) ).

% eventually_nhds_top
thf(fact_6957_filterlim__at__top__at__top,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( linorder @ A )
        & ( linorder @ B ) )
     => ! [Q: A > $o,F2: A > B,P: B > $o,G: B > A] :
          ( ! [X3: A,Y4: A] :
              ( ( Q @ X3 )
             => ( ( Q @ Y4 )
               => ( ( ord_less_eq @ A @ X3 @ Y4 )
                 => ( ord_less_eq @ B @ ( F2 @ X3 ) @ ( F2 @ Y4 ) ) ) ) )
         => ( ! [X3: B] :
                ( ( P @ X3 )
               => ( ( F2 @ ( G @ X3 ) )
                  = X3 ) )
           => ( ! [X3: B] :
                  ( ( P @ X3 )
                 => ( Q @ ( G @ X3 ) ) )
             => ( ( eventually @ A @ Q @ ( at_top @ A ) )
               => ( ( eventually @ B @ P @ ( at_top @ B ) )
                 => ( filterlim @ A @ B @ F2 @ ( at_top @ B ) @ ( at_top @ A ) ) ) ) ) ) ) ) ).

% filterlim_at_top_at_top
thf(fact_6958_eventually__at__left,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [Y2: A,X2: A,P: A > $o] :
          ( ( ord_less @ A @ Y2 @ X2 )
         => ( ( eventually @ A @ P @ ( topolo174197925503356063within @ A @ X2 @ ( set_ord_lessThan @ A @ X2 ) ) )
            = ( ? [B4: A] :
                  ( ( ord_less @ A @ B4 @ X2 )
                  & ! [Y5: A] :
                      ( ( ord_less @ A @ B4 @ Y5 )
                     => ( ( ord_less @ A @ Y5 @ X2 )
                       => ( P @ Y5 ) ) ) ) ) ) ) ) ).

% eventually_at_left
thf(fact_6959_eventually__at__left__field,axiom,
    ! [A: $tType] :
      ( ( ( linordered_field @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [P: A > $o,X2: A] :
          ( ( eventually @ A @ P @ ( topolo174197925503356063within @ A @ X2 @ ( set_ord_lessThan @ A @ X2 ) ) )
          = ( ? [B4: A] :
                ( ( ord_less @ A @ B4 @ X2 )
                & ! [Y5: A] :
                    ( ( ord_less @ A @ B4 @ Y5 )
                   => ( ( ord_less @ A @ Y5 @ X2 )
                     => ( P @ Y5 ) ) ) ) ) ) ) ).

% eventually_at_left_field
thf(fact_6960_eventually__at__right__field,axiom,
    ! [A: $tType] :
      ( ( ( linordered_field @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [P: A > $o,X2: A] :
          ( ( eventually @ A @ P @ ( topolo174197925503356063within @ A @ X2 @ ( set_ord_greaterThan @ A @ X2 ) ) )
          = ( ? [B4: A] :
                ( ( ord_less @ A @ X2 @ B4 )
                & ! [Y5: A] :
                    ( ( ord_less @ A @ X2 @ Y5 )
                   => ( ( ord_less @ A @ Y5 @ B4 )
                     => ( P @ Y5 ) ) ) ) ) ) ) ).

% eventually_at_right_field
thf(fact_6961_eventually__at__right,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [X2: A,Y2: A,P: A > $o] :
          ( ( ord_less @ A @ X2 @ Y2 )
         => ( ( eventually @ A @ P @ ( topolo174197925503356063within @ A @ X2 @ ( set_ord_greaterThan @ A @ X2 ) ) )
            = ( ? [B4: A] :
                  ( ( ord_less @ A @ X2 @ B4 )
                  & ! [Y5: A] :
                      ( ( ord_less @ A @ X2 @ Y5 )
                     => ( ( ord_less @ A @ Y5 @ B4 )
                       => ( P @ Y5 ) ) ) ) ) ) ) ) ).

% eventually_at_right
thf(fact_6962_eventually__at__infinity,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [P: A > $o] :
          ( ( eventually @ A @ P @ ( at_infinity @ A ) )
          = ( ? [B4: real] :
              ! [X5: A] :
                ( ( ord_less_eq @ real @ B4 @ ( real_V7770717601297561774m_norm @ A @ X5 ) )
               => ( P @ X5 ) ) ) ) ) ).

% eventually_at_infinity
thf(fact_6963_tendsto__sandwich,axiom,
    ! [A: $tType,B: $tType] :
      ( ( topolo2564578578187576103pology @ A )
     => ! [F2: B > A,G: B > A,Net: filter @ B,H2: B > A,C2: A] :
          ( ( eventually @ B
            @ ^ [N3: B] : ( ord_less_eq @ A @ ( F2 @ N3 ) @ ( G @ N3 ) )
            @ Net )
         => ( ( eventually @ B
              @ ^ [N3: B] : ( ord_less_eq @ A @ ( G @ N3 ) @ ( H2 @ N3 ) )
              @ Net )
           => ( ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ C2 ) @ Net )
             => ( ( filterlim @ B @ A @ H2 @ ( topolo7230453075368039082e_nhds @ A @ C2 ) @ Net )
               => ( filterlim @ B @ A @ G @ ( topolo7230453075368039082e_nhds @ A @ C2 ) @ Net ) ) ) ) ) ) ).

% tendsto_sandwich
thf(fact_6964_order__tendsto__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo2564578578187576103pology @ A )
     => ! [F2: B > A,X2: A,F3: filter @ B] :
          ( ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ X2 ) @ F3 )
          = ( ! [L2: A] :
                ( ( ord_less @ A @ L2 @ X2 )
               => ( eventually @ B
                  @ ^ [X5: B] : ( ord_less @ A @ L2 @ ( F2 @ X5 ) )
                  @ F3 ) )
            & ! [U2: A] :
                ( ( ord_less @ A @ X2 @ U2 )
               => ( eventually @ B
                  @ ^ [X5: B] : ( ord_less @ A @ ( F2 @ X5 ) @ U2 )
                  @ F3 ) ) ) ) ) ).

% order_tendsto_iff
thf(fact_6965_order__tendstoI,axiom,
    ! [A: $tType,B: $tType] :
      ( ( topolo2564578578187576103pology @ A )
     => ! [Y2: A,F2: B > A,F3: filter @ B] :
          ( ! [A5: A] :
              ( ( ord_less @ A @ A5 @ Y2 )
             => ( eventually @ B
                @ ^ [X5: B] : ( ord_less @ A @ A5 @ ( F2 @ X5 ) )
                @ F3 ) )
         => ( ! [A5: A] :
                ( ( ord_less @ A @ Y2 @ A5 )
               => ( eventually @ B
                  @ ^ [X5: B] : ( ord_less @ A @ ( F2 @ X5 ) @ A5 )
                  @ F3 ) )
           => ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ Y2 ) @ F3 ) ) ) ) ).

% order_tendstoI
thf(fact_6966_order__tendstoD_I1_J,axiom,
    ! [A: $tType,B: $tType] :
      ( ( topolo2564578578187576103pology @ A )
     => ! [F2: B > A,Y2: A,F3: filter @ B,A2: A] :
          ( ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ Y2 ) @ F3 )
         => ( ( ord_less @ A @ A2 @ Y2 )
           => ( eventually @ B
              @ ^ [X5: B] : ( ord_less @ A @ A2 @ ( F2 @ X5 ) )
              @ F3 ) ) ) ) ).

% order_tendstoD(1)
thf(fact_6967_order__tendstoD_I2_J,axiom,
    ! [A: $tType,B: $tType] :
      ( ( topolo2564578578187576103pology @ A )
     => ! [F2: B > A,Y2: A,F3: filter @ B,A2: A] :
          ( ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ Y2 ) @ F3 )
         => ( ( ord_less @ A @ Y2 @ A2 )
           => ( eventually @ B
              @ ^ [X5: B] : ( ord_less @ A @ ( F2 @ X5 ) @ A2 )
              @ F3 ) ) ) ) ).

% order_tendstoD(2)
thf(fact_6968_filterlim__at__top__mono,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F2: B > A,F3: filter @ B,G: B > A] :
          ( ( filterlim @ B @ A @ F2 @ ( at_top @ A ) @ F3 )
         => ( ( eventually @ B
              @ ^ [X5: B] : ( ord_less_eq @ A @ ( F2 @ X5 ) @ ( G @ X5 ) )
              @ F3 )
           => ( filterlim @ B @ A @ G @ ( at_top @ A ) @ F3 ) ) ) ) ).

% filterlim_at_top_mono
thf(fact_6969_filterlim__at__top__ge,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ B )
     => ! [F2: A > B,F3: filter @ A,C2: B] :
          ( ( filterlim @ A @ B @ F2 @ ( at_top @ B ) @ F3 )
          = ( ! [Z9: B] :
                ( ( ord_less_eq @ B @ C2 @ Z9 )
               => ( eventually @ A
                  @ ^ [X5: A] : ( ord_less_eq @ B @ Z9 @ ( F2 @ X5 ) )
                  @ F3 ) ) ) ) ) ).

% filterlim_at_top_ge
thf(fact_6970_filterlim__at__top,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ B )
     => ! [F2: A > B,F3: filter @ A] :
          ( ( filterlim @ A @ B @ F2 @ ( at_top @ B ) @ F3 )
          = ( ! [Z9: B] :
                ( eventually @ A
                @ ^ [X5: A] : ( ord_less_eq @ B @ Z9 @ ( F2 @ X5 ) )
                @ F3 ) ) ) ) ).

% filterlim_at_top
thf(fact_6971_filterlim__at__top__dense,axiom,
    ! [A: $tType,B: $tType] :
      ( ( unboun7993243217541854897norder @ B )
     => ! [F2: A > B,F3: filter @ A] :
          ( ( filterlim @ A @ B @ F2 @ ( at_top @ B ) @ F3 )
          = ( ! [Z9: B] :
                ( eventually @ A
                @ ^ [X5: A] : ( ord_less @ B @ Z9 @ ( F2 @ X5 ) )
                @ F3 ) ) ) ) ).

% filterlim_at_top_dense
thf(fact_6972_eventually__at__right__less,axiom,
    ! [A: $tType] :
      ( ( ( no_top @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [X2: A] : ( eventually @ A @ ( ord_less @ A @ X2 ) @ ( topolo174197925503356063within @ A @ X2 @ ( set_ord_greaterThan @ A @ X2 ) ) ) ) ).

% eventually_at_right_less
thf(fact_6973_filterlim__at__bot__le,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ B )
     => ! [F2: A > B,F3: filter @ A,C2: B] :
          ( ( filterlim @ A @ B @ F2 @ ( at_bot @ B ) @ F3 )
          = ( ! [Z9: B] :
                ( ( ord_less_eq @ B @ Z9 @ C2 )
               => ( eventually @ A
                  @ ^ [X5: A] : ( ord_less_eq @ B @ ( F2 @ X5 ) @ Z9 )
                  @ F3 ) ) ) ) ) ).

% filterlim_at_bot_le
thf(fact_6974_filterlim__at__bot,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ B )
     => ! [F2: A > B,F3: filter @ A] :
          ( ( filterlim @ A @ B @ F2 @ ( at_bot @ B ) @ F3 )
          = ( ! [Z9: B] :
                ( eventually @ A
                @ ^ [X5: A] : ( ord_less_eq @ B @ ( F2 @ X5 ) @ Z9 )
                @ F3 ) ) ) ) ).

% filterlim_at_bot
thf(fact_6975_filterlim__at__bot__dense,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( dense_linorder @ B )
        & ( no_bot @ B ) )
     => ! [F2: A > B,F3: filter @ A] :
          ( ( filterlim @ A @ B @ F2 @ ( at_bot @ B ) @ F3 )
          = ( ! [Z9: B] :
                ( eventually @ A
                @ ^ [X5: A] : ( ord_less @ B @ ( F2 @ X5 ) @ Z9 )
                @ F3 ) ) ) ) ).

% filterlim_at_bot_dense
thf(fact_6976_real__tendsto__sandwich,axiom,
    ! [B: $tType,F2: B > real,G: B > real,Net: filter @ B,H2: B > real,C2: real] :
      ( ( eventually @ B
        @ ^ [N3: B] : ( ord_less_eq @ real @ ( F2 @ N3 ) @ ( G @ N3 ) )
        @ Net )
     => ( ( eventually @ B
          @ ^ [N3: B] : ( ord_less_eq @ real @ ( G @ N3 ) @ ( H2 @ N3 ) )
          @ Net )
       => ( ( filterlim @ B @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ C2 ) @ Net )
         => ( ( filterlim @ B @ real @ H2 @ ( topolo7230453075368039082e_nhds @ real @ C2 ) @ Net )
           => ( filterlim @ B @ real @ G @ ( topolo7230453075368039082e_nhds @ real @ C2 ) @ Net ) ) ) ) ) ).

% real_tendsto_sandwich
thf(fact_6977_countable__basis__at__decseq,axiom,
    ! [A: $tType] :
      ( ( topolo3112930676232923870pology @ A )
     => ! [X2: A] :
          ~ ! [A8: nat > ( set @ A )] :
              ( ! [I: nat] : ( topolo1002775350975398744n_open @ A @ ( A8 @ I ) )
             => ( ! [I: nat] : ( member @ A @ X2 @ ( A8 @ I ) )
               => ~ ! [S10: set @ A] :
                      ( ( topolo1002775350975398744n_open @ A @ S10 )
                     => ( ( member @ A @ X2 @ S10 )
                       => ( eventually @ nat
                          @ ^ [I4: nat] : ( ord_less_eq @ ( set @ A ) @ ( A8 @ I4 ) @ S10 )
                          @ ( at_top @ nat ) ) ) ) ) ) ) ).

% countable_basis_at_decseq
thf(fact_6978_eventually__Inf__base,axiom,
    ! [A: $tType,B3: set @ ( filter @ A ),P: A > $o] :
      ( ( B3
       != ( bot_bot @ ( set @ ( filter @ A ) ) ) )
     => ( ! [F6: filter @ A] :
            ( ( member @ ( filter @ A ) @ F6 @ B3 )
           => ! [G5: filter @ A] :
                ( ( member @ ( filter @ A ) @ G5 @ B3 )
               => ? [X: filter @ A] :
                    ( ( member @ ( filter @ A ) @ X @ B3 )
                    & ( ord_less_eq @ ( filter @ A ) @ X @ ( inf_inf @ ( filter @ A ) @ F6 @ G5 ) ) ) ) )
       => ( ( eventually @ A @ P @ ( complete_Inf_Inf @ ( filter @ A ) @ B3 ) )
          = ( ? [X5: filter @ A] :
                ( ( member @ ( filter @ A ) @ X5 @ B3 )
                & ( eventually @ A @ P @ X5 ) ) ) ) ) ) ).

% eventually_Inf_base
thf(fact_6979_eventually__at,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [P: A > $o,A2: A,S3: set @ A] :
          ( ( eventually @ A @ P @ ( topolo174197925503356063within @ A @ A2 @ S3 ) )
          = ( ? [D3: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ D3 )
                & ! [X5: A] :
                    ( ( member @ A @ X5 @ S3 )
                   => ( ( ( X5 != A2 )
                        & ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X5 @ A2 ) @ D3 ) )
                     => ( P @ X5 ) ) ) ) ) ) ) ).

% eventually_at
thf(fact_6980_eventually__nhds__metric,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [P: A > $o,A2: A] :
          ( ( eventually @ A @ P @ ( topolo7230453075368039082e_nhds @ A @ A2 ) )
          = ( ? [D3: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ D3 )
                & ! [X5: A] :
                    ( ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X5 @ A2 ) @ D3 )
                   => ( P @ X5 ) ) ) ) ) ) ).

% eventually_nhds_metric
thf(fact_6981_eventually__at__leftI,axiom,
    ! [A: $tType] :
      ( ( topolo2564578578187576103pology @ A )
     => ! [A2: A,B2: A,P: A > $o] :
          ( ! [X3: A] :
              ( ( member @ A @ X3 @ ( set_or5935395276787703475ssThan @ A @ A2 @ B2 ) )
             => ( P @ X3 ) )
         => ( ( ord_less @ A @ A2 @ B2 )
           => ( eventually @ A @ P @ ( topolo174197925503356063within @ A @ B2 @ ( set_ord_lessThan @ A @ B2 ) ) ) ) ) ) ).

% eventually_at_leftI
thf(fact_6982_eventually__at__rightI,axiom,
    ! [A: $tType] :
      ( ( topolo2564578578187576103pology @ A )
     => ! [A2: A,B2: A,P: A > $o] :
          ( ! [X3: A] :
              ( ( member @ A @ X3 @ ( set_or5935395276787703475ssThan @ A @ A2 @ B2 ) )
             => ( P @ X3 ) )
         => ( ( ord_less @ A @ A2 @ B2 )
           => ( eventually @ A @ P @ ( topolo174197925503356063within @ A @ A2 @ ( set_ord_greaterThan @ A @ A2 ) ) ) ) ) ) ).

% eventually_at_rightI
thf(fact_6983_eventually__at__to__0,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [P: A > $o,A2: A] :
          ( ( eventually @ A @ P @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) )
          = ( eventually @ A
            @ ^ [X5: A] : ( P @ ( plus_plus @ A @ X5 @ A2 ) )
            @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% eventually_at_to_0
thf(fact_6984_increasing__tendsto,axiom,
    ! [A: $tType,B: $tType] :
      ( ( topolo2564578578187576103pology @ A )
     => ! [F2: B > A,L: A,F3: filter @ B] :
          ( ( eventually @ B
            @ ^ [N3: B] : ( ord_less_eq @ A @ ( F2 @ N3 ) @ L )
            @ F3 )
         => ( ! [X3: A] :
                ( ( ord_less @ A @ X3 @ L )
               => ( eventually @ B
                  @ ^ [N3: B] : ( ord_less @ A @ X3 @ ( F2 @ N3 ) )
                  @ F3 ) )
           => ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ L ) @ F3 ) ) ) ) ).

% increasing_tendsto
thf(fact_6985_decreasing__tendsto,axiom,
    ! [A: $tType,B: $tType] :
      ( ( topolo2564578578187576103pology @ A )
     => ! [L: A,F2: B > A,F3: filter @ B] :
          ( ( eventually @ B
            @ ^ [N3: B] : ( ord_less_eq @ A @ L @ ( F2 @ N3 ) )
            @ F3 )
         => ( ! [X3: A] :
                ( ( ord_less @ A @ L @ X3 )
               => ( eventually @ B
                  @ ^ [N3: B] : ( ord_less @ A @ ( F2 @ N3 ) @ X3 )
                  @ F3 ) )
           => ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ L ) @ F3 ) ) ) ) ).

% decreasing_tendsto
thf(fact_6986_filterlim__at__top__gt,axiom,
    ! [A: $tType,B: $tType] :
      ( ( unboun7993243217541854897norder @ B )
     => ! [F2: A > B,F3: filter @ A,C2: B] :
          ( ( filterlim @ A @ B @ F2 @ ( at_top @ B ) @ F3 )
          = ( ! [Z9: B] :
                ( ( ord_less @ B @ C2 @ Z9 )
               => ( eventually @ A
                  @ ^ [X5: A] : ( ord_less_eq @ B @ Z9 @ ( F2 @ X5 ) )
                  @ F3 ) ) ) ) ) ).

% filterlim_at_top_gt
thf(fact_6987_filterlim__at__bot__lt,axiom,
    ! [A: $tType,B: $tType] :
      ( ( unboun7993243217541854897norder @ B )
     => ! [F2: A > B,F3: filter @ A,C2: B] :
          ( ( filterlim @ A @ B @ F2 @ ( at_bot @ B ) @ F3 )
          = ( ! [Z9: B] :
                ( ( ord_less @ B @ Z9 @ C2 )
               => ( eventually @ A
                  @ ^ [X5: A] : ( ord_less_eq @ B @ ( F2 @ X5 ) @ Z9 )
                  @ F3 ) ) ) ) ) ).

% filterlim_at_bot_lt
thf(fact_6988_tendsto__upperbound,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [F2: B > A,X2: A,F3: filter @ B,A2: A] :
          ( ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ X2 ) @ F3 )
         => ( ( eventually @ B
              @ ^ [I4: B] : ( ord_less_eq @ A @ ( F2 @ I4 ) @ A2 )
              @ F3 )
           => ( ( F3
               != ( bot_bot @ ( filter @ B ) ) )
             => ( ord_less_eq @ A @ X2 @ A2 ) ) ) ) ) ).

% tendsto_upperbound
thf(fact_6989_tendsto__lowerbound,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [F2: B > A,X2: A,F3: filter @ B,A2: A] :
          ( ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ X2 ) @ F3 )
         => ( ( eventually @ B
              @ ^ [I4: B] : ( ord_less_eq @ A @ A2 @ ( F2 @ I4 ) )
              @ F3 )
           => ( ( F3
               != ( bot_bot @ ( filter @ B ) ) )
             => ( ord_less_eq @ A @ A2 @ X2 ) ) ) ) ) ).

% tendsto_lowerbound
thf(fact_6990_tendsto__le,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [F3: filter @ B,F2: B > A,X2: A,G: B > A,Y2: A] :
          ( ( F3
           != ( bot_bot @ ( filter @ B ) ) )
         => ( ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ X2 ) @ F3 )
           => ( ( filterlim @ B @ A @ G @ ( topolo7230453075368039082e_nhds @ A @ Y2 ) @ F3 )
             => ( ( eventually @ B
                  @ ^ [X5: B] : ( ord_less_eq @ A @ ( G @ X5 ) @ ( F2 @ X5 ) )
                  @ F3 )
               => ( ord_less_eq @ A @ Y2 @ X2 ) ) ) ) ) ) ).

% tendsto_le
thf(fact_6991_metric__tendsto__imp__tendsto,axiom,
    ! [A: $tType,B: $tType,C: $tType] :
      ( ( ( real_V7819770556892013058_space @ B )
        & ( real_V7819770556892013058_space @ A ) )
     => ! [F2: C > A,A2: A,F3: filter @ C,G: C > B,B2: B] :
          ( ( filterlim @ C @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ A2 ) @ F3 )
         => ( ( eventually @ C
              @ ^ [X5: C] : ( ord_less_eq @ real @ ( real_V557655796197034286t_dist @ B @ ( G @ X5 ) @ B2 ) @ ( real_V557655796197034286t_dist @ A @ ( F2 @ X5 ) @ A2 ) )
              @ F3 )
           => ( filterlim @ C @ B @ G @ ( topolo7230453075368039082e_nhds @ B @ B2 ) @ F3 ) ) ) ) ).

% metric_tendsto_imp_tendsto
thf(fact_6992_filterlim__at__infinity__imp__filterlim__at__top,axiom,
    ! [A: $tType,F2: A > real,F3: filter @ A] :
      ( ( filterlim @ A @ real @ F2 @ ( at_infinity @ real ) @ F3 )
     => ( ( eventually @ A
          @ ^ [X5: A] : ( ord_less @ real @ ( zero_zero @ real ) @ ( F2 @ X5 ) )
          @ F3 )
       => ( filterlim @ A @ real @ F2 @ ( at_top @ real ) @ F3 ) ) ) ).

% filterlim_at_infinity_imp_filterlim_at_top
thf(fact_6993_filterlim__at__infinity__imp__filterlim__at__bot,axiom,
    ! [A: $tType,F2: A > real,F3: filter @ A] :
      ( ( filterlim @ A @ real @ F2 @ ( at_infinity @ real ) @ F3 )
     => ( ( eventually @ A
          @ ^ [X5: A] : ( ord_less @ real @ ( F2 @ X5 ) @ ( zero_zero @ real ) )
          @ F3 )
       => ( filterlim @ A @ real @ F2 @ ( at_bot @ real ) @ F3 ) ) ) ).

% filterlim_at_infinity_imp_filterlim_at_bot
thf(fact_6994_eventually__at__right__to__0,axiom,
    ! [P: real > $o,A2: real] :
      ( ( eventually @ real @ P @ ( topolo174197925503356063within @ real @ A2 @ ( set_ord_greaterThan @ real @ A2 ) ) )
      = ( eventually @ real
        @ ^ [X5: real] : ( P @ ( plus_plus @ real @ X5 @ A2 ) )
        @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) ) ) ).

% eventually_at_right_to_0
thf(fact_6995_eventually__INF,axiom,
    ! [A: $tType,B: $tType,P: A > $o,F3: B > ( filter @ A ),B3: set @ B] :
      ( ( eventually @ A @ P @ ( complete_Inf_Inf @ ( filter @ A ) @ ( image @ B @ ( filter @ A ) @ F3 @ B3 ) ) )
      = ( ? [X4: set @ B] :
            ( ( ord_less_eq @ ( set @ B ) @ X4 @ B3 )
            & ( finite_finite @ B @ X4 )
            & ( eventually @ A @ P @ ( complete_Inf_Inf @ ( filter @ A ) @ ( image @ B @ ( filter @ A ) @ F3 @ X4 ) ) ) ) ) ) ).

% eventually_INF
thf(fact_6996_continuous__arcosh__strong,axiom,
    ! [A: $tType] :
      ( ( topological_t2_space @ A )
     => ! [F3: filter @ A,F2: A > real] :
          ( ( topolo3448309680560233919inuous @ A @ real @ F3 @ F2 )
         => ( ( eventually @ A
              @ ^ [X5: A] : ( ord_less_eq @ real @ ( one_one @ real ) @ ( F2 @ X5 ) )
              @ F3 )
           => ( topolo3448309680560233919inuous @ A @ real @ F3
              @ ^ [X5: A] : ( arcosh @ real @ ( F2 @ X5 ) ) ) ) ) ) ).

% continuous_arcosh_strong
thf(fact_6997_eventually__at__right__real,axiom,
    ! [A2: real,B2: real] :
      ( ( ord_less @ real @ A2 @ B2 )
     => ( eventually @ real
        @ ^ [X5: real] : ( member @ real @ X5 @ ( set_or5935395276787703475ssThan @ real @ A2 @ B2 ) )
        @ ( topolo174197925503356063within @ real @ A2 @ ( set_ord_greaterThan @ real @ A2 ) ) ) ) ).

% eventually_at_right_real
thf(fact_6998_eventually__at__left__real,axiom,
    ! [B2: real,A2: real] :
      ( ( ord_less @ real @ B2 @ A2 )
     => ( eventually @ real
        @ ^ [X5: real] : ( member @ real @ X5 @ ( set_or5935395276787703475ssThan @ real @ B2 @ A2 ) )
        @ ( topolo174197925503356063within @ real @ A2 @ ( set_ord_lessThan @ real @ A2 ) ) ) ) ).

% eventually_at_left_real
thf(fact_6999_eventually__at__le,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [P: A > $o,A2: A,S3: set @ A] :
          ( ( eventually @ A @ P @ ( topolo174197925503356063within @ A @ A2 @ S3 ) )
          = ( ? [D3: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ D3 )
                & ! [X5: A] :
                    ( ( member @ A @ X5 @ S3 )
                   => ( ( ( X5 != A2 )
                        & ( ord_less_eq @ real @ ( real_V557655796197034286t_dist @ A @ X5 @ A2 ) @ D3 ) )
                     => ( P @ X5 ) ) ) ) ) ) ) ).

% eventually_at_le
thf(fact_7000_eventually__at__infinity__pos,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [P4: A > $o] :
          ( ( eventually @ A @ P4 @ ( at_infinity @ A ) )
          = ( ? [B4: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ B4 )
                & ! [X5: A] :
                    ( ( ord_less_eq @ real @ B4 @ ( real_V7770717601297561774m_norm @ A @ X5 ) )
                   => ( P4 @ X5 ) ) ) ) ) ) ).

% eventually_at_infinity_pos
thf(fact_7001_tendsto__imp__filterlim__at__left,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo2564578578187576103pology @ B )
     => ! [F2: A > B,L5: B,F3: filter @ A] :
          ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ L5 ) @ F3 )
         => ( ( eventually @ A
              @ ^ [X5: A] : ( ord_less @ B @ ( F2 @ X5 ) @ L5 )
              @ F3 )
           => ( filterlim @ A @ B @ F2 @ ( topolo174197925503356063within @ B @ L5 @ ( set_ord_lessThan @ B @ L5 ) ) @ F3 ) ) ) ) ).

% tendsto_imp_filterlim_at_left
thf(fact_7002_tendsto__imp__filterlim__at__right,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo2564578578187576103pology @ B )
     => ! [F2: A > B,L5: B,F3: filter @ A] :
          ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ L5 ) @ F3 )
         => ( ( eventually @ A
              @ ^ [X5: A] : ( ord_less @ B @ L5 @ ( F2 @ X5 ) )
              @ F3 )
           => ( filterlim @ A @ B @ F2 @ ( topolo174197925503356063within @ B @ L5 @ ( set_ord_greaterThan @ B @ L5 ) ) @ F3 ) ) ) ) ).

% tendsto_imp_filterlim_at_right
thf(fact_7003_tendsto__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [F2: B > A,L: A,F3: filter @ B] :
          ( ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ L ) @ F3 )
          = ( ! [E4: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ E4 )
               => ( eventually @ B
                  @ ^ [X5: B] : ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ ( F2 @ X5 ) @ L ) @ E4 )
                  @ F3 ) ) ) ) ) ).

% tendsto_iff
thf(fact_7004_tendstoI,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [F2: B > A,L: A,F3: filter @ B] :
          ( ! [E: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ E )
             => ( eventually @ B
                @ ^ [X5: B] : ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ ( F2 @ X5 ) @ L ) @ E )
                @ F3 ) )
         => ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ L ) @ F3 ) ) ) ).

% tendstoI
thf(fact_7005_tendstoD,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [F2: B > A,L: A,F3: filter @ B,E2: real] :
          ( ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ L ) @ F3 )
         => ( ( ord_less @ real @ ( zero_zero @ real ) @ E2 )
           => ( eventually @ B
              @ ^ [X5: B] : ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ ( F2 @ X5 ) @ L ) @ E2 )
              @ F3 ) ) ) ) ).

% tendstoD
thf(fact_7006_eventually__Inf,axiom,
    ! [A: $tType,P: A > $o,B3: set @ ( filter @ A )] :
      ( ( eventually @ A @ P @ ( complete_Inf_Inf @ ( filter @ A ) @ B3 ) )
      = ( ? [X4: set @ ( filter @ A )] :
            ( ( ord_less_eq @ ( set @ ( filter @ A ) ) @ X4 @ B3 )
            & ( finite_finite @ ( filter @ A ) @ X4 )
            & ( eventually @ A @ P @ ( complete_Inf_Inf @ ( filter @ A ) @ X4 ) ) ) ) ) ).

% eventually_Inf
thf(fact_7007_summable__comparison__test__ev,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach @ A )
     => ! [F2: nat > A,G: nat > real] :
          ( ( eventually @ nat
            @ ^ [N3: nat] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( F2 @ N3 ) ) @ ( G @ N3 ) )
            @ ( at_top @ nat ) )
         => ( ( summable @ real @ G )
           => ( summable @ A @ F2 ) ) ) ) ).

% summable_comparison_test_ev
thf(fact_7008_eventually__at__right__to__top,axiom,
    ! [P: real > $o] :
      ( ( eventually @ real @ P @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) )
      = ( eventually @ real
        @ ^ [X5: real] : ( P @ ( inverse_inverse @ real @ X5 ) )
        @ ( at_top @ real ) ) ) ).

% eventually_at_right_to_top
thf(fact_7009_eventually__at__top__to__right,axiom,
    ! [P: real > $o] :
      ( ( eventually @ real @ P @ ( at_top @ real ) )
      = ( eventually @ real
        @ ^ [X5: real] : ( P @ ( inverse_inverse @ real @ X5 ) )
        @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) ) ) ).

% eventually_at_top_to_right
thf(fact_7010_tendsto__arcosh__strong,axiom,
    ! [B: $tType,F2: B > real,A2: real,F3: filter @ B] :
      ( ( filterlim @ B @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ A2 ) @ F3 )
     => ( ( ord_less_eq @ real @ ( one_one @ real ) @ A2 )
       => ( ( eventually @ B
            @ ^ [X5: B] : ( ord_less_eq @ real @ ( one_one @ real ) @ ( F2 @ X5 ) )
            @ F3 )
         => ( filterlim @ B @ real
            @ ^ [X5: B] : ( arcosh @ real @ ( F2 @ X5 ) )
            @ ( topolo7230453075368039082e_nhds @ real @ ( arcosh @ real @ A2 ) )
            @ F3 ) ) ) ) ).

% tendsto_arcosh_strong
thf(fact_7011_filterlim__at__top__at__left,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topolo1944317154257567458pology @ A )
        & ( linorder @ B ) )
     => ! [Q: A > $o,F2: A > B,P: B > $o,G: B > A,A2: A] :
          ( ! [X3: A,Y4: A] :
              ( ( Q @ X3 )
             => ( ( Q @ Y4 )
               => ( ( ord_less_eq @ A @ X3 @ Y4 )
                 => ( ord_less_eq @ B @ ( F2 @ X3 ) @ ( F2 @ Y4 ) ) ) ) )
         => ( ! [X3: B] :
                ( ( P @ X3 )
               => ( ( F2 @ ( G @ X3 ) )
                  = X3 ) )
           => ( ! [X3: B] :
                  ( ( P @ X3 )
                 => ( Q @ ( G @ X3 ) ) )
             => ( ( eventually @ A @ Q @ ( topolo174197925503356063within @ A @ A2 @ ( set_ord_lessThan @ A @ A2 ) ) )
               => ( ! [B5: A] :
                      ( ( Q @ B5 )
                     => ( ord_less @ A @ B5 @ A2 ) )
                 => ( ( eventually @ B @ P @ ( at_top @ B ) )
                   => ( filterlim @ A @ B @ F2 @ ( at_top @ B ) @ ( topolo174197925503356063within @ A @ A2 @ ( set_ord_lessThan @ A @ A2 ) ) ) ) ) ) ) ) ) ) ).

% filterlim_at_top_at_left
thf(fact_7012_eventually__INF__base,axiom,
    ! [B: $tType,A: $tType,B3: set @ A,F3: A > ( filter @ B ),P: B > $o] :
      ( ( B3
       != ( bot_bot @ ( set @ A ) ) )
     => ( ! [A5: A] :
            ( ( member @ A @ A5 @ B3 )
           => ! [B5: A] :
                ( ( member @ A @ B5 @ B3 )
               => ? [X: A] :
                    ( ( member @ A @ X @ B3 )
                    & ( ord_less_eq @ ( filter @ B ) @ ( F3 @ X ) @ ( inf_inf @ ( filter @ B ) @ ( F3 @ A5 ) @ ( F3 @ B5 ) ) ) ) ) )
       => ( ( eventually @ B @ P @ ( complete_Inf_Inf @ ( filter @ B ) @ ( image @ A @ ( filter @ B ) @ F3 @ B3 ) ) )
          = ( ? [X5: A] :
                ( ( member @ A @ X5 @ B3 )
                & ( eventually @ B @ P @ ( F3 @ X5 ) ) ) ) ) ) ) ).

% eventually_INF_base
thf(fact_7013_filterlim__at__bot__at__right,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topolo1944317154257567458pology @ A )
        & ( linorder @ B ) )
     => ! [Q: A > $o,F2: A > B,P: B > $o,G: B > A,A2: A] :
          ( ! [X3: A,Y4: A] :
              ( ( Q @ X3 )
             => ( ( Q @ Y4 )
               => ( ( ord_less_eq @ A @ X3 @ Y4 )
                 => ( ord_less_eq @ B @ ( F2 @ X3 ) @ ( F2 @ Y4 ) ) ) ) )
         => ( ! [X3: B] :
                ( ( P @ X3 )
               => ( ( F2 @ ( G @ X3 ) )
                  = X3 ) )
           => ( ! [X3: B] :
                  ( ( P @ X3 )
                 => ( Q @ ( G @ X3 ) ) )
             => ( ( eventually @ A @ Q @ ( topolo174197925503356063within @ A @ A2 @ ( set_ord_greaterThan @ A @ A2 ) ) )
               => ( ! [B5: A] :
                      ( ( Q @ B5 )
                     => ( ord_less @ A @ A2 @ B5 ) )
                 => ( ( eventually @ B @ P @ ( at_bot @ B ) )
                   => ( filterlim @ A @ B @ F2 @ ( at_bot @ B ) @ ( topolo174197925503356063within @ A @ A2 @ ( set_ord_greaterThan @ A @ A2 ) ) ) ) ) ) ) ) ) ) ).

% filterlim_at_bot_at_right
thf(fact_7014_tendsto__0__le,axiom,
    ! [B: $tType,C: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ C )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F2: A > B,F3: filter @ A,G: A > C,K5: real] :
          ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ ( zero_zero @ B ) ) @ F3 )
         => ( ( eventually @ A
              @ ^ [X5: A] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ C @ ( G @ X5 ) ) @ ( times_times @ real @ ( real_V7770717601297561774m_norm @ B @ ( F2 @ X5 ) ) @ K5 ) )
              @ F3 )
           => ( filterlim @ A @ C @ G @ ( topolo7230453075368039082e_nhds @ C @ ( zero_zero @ C ) ) @ F3 ) ) ) ) ).

% tendsto_0_le
thf(fact_7015_filterlim__at__infinity,axiom,
    ! [C: $tType,A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [C2: real,F2: C > A,F3: filter @ C] :
          ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ C2 )
         => ( ( filterlim @ C @ A @ F2 @ ( at_infinity @ A ) @ F3 )
            = ( ! [R5: real] :
                  ( ( ord_less @ real @ C2 @ R5 )
                 => ( eventually @ C
                    @ ^ [X5: C] : ( ord_less_eq @ real @ R5 @ ( real_V7770717601297561774m_norm @ A @ ( F2 @ X5 ) ) )
                    @ F3 ) ) ) ) ) ) ).

% filterlim_at_infinity
thf(fact_7016_tendsto__powr_H,axiom,
    ! [A: $tType,F2: A > real,A2: real,F3: filter @ A,G: A > real,B2: real] :
      ( ( filterlim @ A @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ A2 ) @ F3 )
     => ( ( filterlim @ A @ real @ G @ ( topolo7230453075368039082e_nhds @ real @ B2 ) @ F3 )
       => ( ( ( A2
             != ( zero_zero @ real ) )
            | ( ( ord_less @ real @ ( zero_zero @ real ) @ B2 )
              & ( eventually @ A
                @ ^ [X5: A] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( F2 @ X5 ) )
                @ F3 ) ) )
         => ( filterlim @ A @ real
            @ ^ [X5: A] : ( powr @ real @ ( F2 @ X5 ) @ ( G @ X5 ) )
            @ ( topolo7230453075368039082e_nhds @ real @ ( powr @ real @ A2 @ B2 ) )
            @ F3 ) ) ) ) ).

% tendsto_powr'
thf(fact_7017_tendsto__powr2,axiom,
    ! [A: $tType,F2: A > real,A2: real,F3: filter @ A,G: A > real,B2: real] :
      ( ( filterlim @ A @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ A2 ) @ F3 )
     => ( ( filterlim @ A @ real @ G @ ( topolo7230453075368039082e_nhds @ real @ B2 ) @ F3 )
       => ( ( eventually @ A
            @ ^ [X5: A] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( F2 @ X5 ) )
            @ F3 )
         => ( ( ord_less @ real @ ( zero_zero @ real ) @ B2 )
           => ( filterlim @ A @ real
              @ ^ [X5: A] : ( powr @ real @ ( F2 @ X5 ) @ ( G @ X5 ) )
              @ ( topolo7230453075368039082e_nhds @ real @ ( powr @ real @ A2 @ B2 ) )
              @ F3 ) ) ) ) ) ).

% tendsto_powr2
thf(fact_7018_tendsto__zero__powrI,axiom,
    ! [A: $tType,F2: A > real,F3: filter @ A,G: A > real,B2: real] :
      ( ( filterlim @ A @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ F3 )
     => ( ( filterlim @ A @ real @ G @ ( topolo7230453075368039082e_nhds @ real @ B2 ) @ F3 )
       => ( ( eventually @ A
            @ ^ [X5: A] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( F2 @ X5 ) )
            @ F3 )
         => ( ( ord_less @ real @ ( zero_zero @ real ) @ B2 )
           => ( filterlim @ A @ real
              @ ^ [X5: A] : ( powr @ real @ ( F2 @ X5 ) @ ( G @ X5 ) )
              @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
              @ F3 ) ) ) ) ) ).

% tendsto_zero_powrI
thf(fact_7019_eventually__floor__less,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( archim2362893244070406136eiling @ B )
        & ( topolo2564578578187576103pology @ B ) )
     => ! [F2: A > B,L: B,F3: filter @ A] :
          ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ L ) @ F3 )
         => ( ~ ( member @ B @ L @ ( ring_1_Ints @ B ) )
           => ( eventually @ A
              @ ^ [X5: A] : ( ord_less @ B @ ( ring_1_of_int @ B @ ( archim6421214686448440834_floor @ B @ L ) ) @ ( F2 @ X5 ) )
              @ F3 ) ) ) ) ).

% eventually_floor_less
thf(fact_7020_LIM__at__top__divide,axiom,
    ! [A: $tType,F2: A > real,A2: real,F3: filter @ A,G: A > real] :
      ( ( filterlim @ A @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ A2 ) @ F3 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
       => ( ( filterlim @ A @ real @ G @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ F3 )
         => ( ( eventually @ A
              @ ^ [X5: A] : ( ord_less @ real @ ( zero_zero @ real ) @ ( G @ X5 ) )
              @ F3 )
           => ( filterlim @ A @ real
              @ ^ [X5: A] : ( divide_divide @ real @ ( F2 @ X5 ) @ ( G @ X5 ) )
              @ ( at_top @ real )
              @ F3 ) ) ) ) ) ).

% LIM_at_top_divide
thf(fact_7021_eventually__less__ceiling,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( archim2362893244070406136eiling @ B )
        & ( topolo2564578578187576103pology @ B ) )
     => ! [F2: A > B,L: B,F3: filter @ A] :
          ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ L ) @ F3 )
         => ( ~ ( member @ B @ L @ ( ring_1_Ints @ B ) )
           => ( eventually @ A
              @ ^ [X5: A] : ( ord_less @ B @ ( F2 @ X5 ) @ ( ring_1_of_int @ B @ ( archimedean_ceiling @ B @ L ) ) )
              @ F3 ) ) ) ) ).

% eventually_less_ceiling
thf(fact_7022_filterlim__at__top__iff__inverse__0,axiom,
    ! [A: $tType,F2: A > real,F3: filter @ A] :
      ( ( eventually @ A
        @ ^ [X5: A] : ( ord_less @ real @ ( zero_zero @ real ) @ ( F2 @ X5 ) )
        @ F3 )
     => ( ( filterlim @ A @ real @ F2 @ ( at_top @ real ) @ F3 )
        = ( filterlim @ A @ real @ ( comp @ real @ real @ A @ ( inverse_inverse @ real ) @ F2 ) @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ F3 ) ) ) ).

% filterlim_at_top_iff_inverse_0
thf(fact_7023_filterlim__inverse__at__top__iff,axiom,
    ! [A: $tType,F2: A > real,F3: filter @ A] :
      ( ( eventually @ A
        @ ^ [X5: A] : ( ord_less @ real @ ( zero_zero @ real ) @ ( F2 @ X5 ) )
        @ F3 )
     => ( ( filterlim @ A @ real
          @ ^ [X5: A] : ( inverse_inverse @ real @ ( F2 @ X5 ) )
          @ ( at_top @ real )
          @ F3 )
        = ( filterlim @ A @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ F3 ) ) ) ).

% filterlim_inverse_at_top_iff
thf(fact_7024_filterlim__inverse__at__top,axiom,
    ! [A: $tType,F2: A > real,F3: filter @ A] :
      ( ( filterlim @ A @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ F3 )
     => ( ( eventually @ A
          @ ^ [X5: A] : ( ord_less @ real @ ( zero_zero @ real ) @ ( F2 @ X5 ) )
          @ F3 )
       => ( filterlim @ A @ real
          @ ^ [X5: A] : ( inverse_inverse @ real @ ( F2 @ X5 ) )
          @ ( at_top @ real )
          @ F3 ) ) ) ).

% filterlim_inverse_at_top
thf(fact_7025_filterlim__inverse__at__bot,axiom,
    ! [A: $tType,F2: A > real,F3: filter @ A] :
      ( ( filterlim @ A @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ F3 )
     => ( ( eventually @ A
          @ ^ [X5: A] : ( ord_less @ real @ ( F2 @ X5 ) @ ( zero_zero @ real ) )
          @ F3 )
       => ( filterlim @ A @ real
          @ ^ [X5: A] : ( inverse_inverse @ real @ ( F2 @ X5 ) )
          @ ( at_bot @ real )
          @ F3 ) ) ) ).

% filterlim_inverse_at_bot
thf(fact_7026_lhopital__at__top__at__top,axiom,
    ! [F2: real > real,A2: real,G: real > real,F8: real > real,G6: real > real] :
      ( ( filterlim @ real @ real @ F2 @ ( at_top @ real ) @ ( topolo174197925503356063within @ real @ A2 @ ( top_top @ ( set @ real ) ) ) )
     => ( ( filterlim @ real @ real @ G @ ( at_top @ real ) @ ( topolo174197925503356063within @ real @ A2 @ ( top_top @ ( set @ real ) ) ) )
       => ( ( eventually @ real
            @ ^ [X5: real] : ( has_field_derivative @ real @ F2 @ ( F8 @ X5 ) @ ( topolo174197925503356063within @ real @ X5 @ ( top_top @ ( set @ real ) ) ) )
            @ ( topolo174197925503356063within @ real @ A2 @ ( top_top @ ( set @ real ) ) ) )
         => ( ( eventually @ real
              @ ^ [X5: real] : ( has_field_derivative @ real @ G @ ( G6 @ X5 ) @ ( topolo174197925503356063within @ real @ X5 @ ( top_top @ ( set @ real ) ) ) )
              @ ( topolo174197925503356063within @ real @ A2 @ ( top_top @ ( set @ real ) ) ) )
           => ( ( filterlim @ real @ real
                @ ^ [X5: real] : ( divide_divide @ real @ ( F8 @ X5 ) @ ( G6 @ X5 ) )
                @ ( at_top @ real )
                @ ( topolo174197925503356063within @ real @ A2 @ ( top_top @ ( set @ real ) ) ) )
             => ( filterlim @ real @ real
                @ ^ [X5: real] : ( divide_divide @ real @ ( F2 @ X5 ) @ ( G @ X5 ) )
                @ ( at_top @ real )
                @ ( topolo174197925503356063within @ real @ A2 @ ( top_top @ ( set @ real ) ) ) ) ) ) ) ) ) ).

% lhopital_at_top_at_top
thf(fact_7027_lhopital,axiom,
    ! [F2: real > real,X2: real,G: real > real,G6: real > real,F8: real > real,F3: filter @ real] :
      ( ( filterlim @ real @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) )
     => ( ( filterlim @ real @ real @ G @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) )
       => ( ( eventually @ real
            @ ^ [X5: real] :
                ( ( G @ X5 )
               != ( zero_zero @ real ) )
            @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) )
         => ( ( eventually @ real
              @ ^ [X5: real] :
                  ( ( G6 @ X5 )
                 != ( zero_zero @ real ) )
              @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) )
           => ( ( eventually @ real
                @ ^ [X5: real] : ( has_field_derivative @ real @ F2 @ ( F8 @ X5 ) @ ( topolo174197925503356063within @ real @ X5 @ ( top_top @ ( set @ real ) ) ) )
                @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) )
             => ( ( eventually @ real
                  @ ^ [X5: real] : ( has_field_derivative @ real @ G @ ( G6 @ X5 ) @ ( topolo174197925503356063within @ real @ X5 @ ( top_top @ ( set @ real ) ) ) )
                  @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) )
               => ( ( filterlim @ real @ real
                    @ ^ [X5: real] : ( divide_divide @ real @ ( F8 @ X5 ) @ ( G6 @ X5 ) )
                    @ F3
                    @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) )
                 => ( filterlim @ real @ real
                    @ ^ [X5: real] : ( divide_divide @ real @ ( F2 @ X5 ) @ ( G @ X5 ) )
                    @ F3
                    @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) ) ) ) ) ) ) ) ) ).

% lhopital
thf(fact_7028_lhopital__right__at__top__at__top,axiom,
    ! [F2: real > real,A2: real,G: real > real,F8: real > real,G6: real > real] :
      ( ( filterlim @ real @ real @ F2 @ ( at_top @ real ) @ ( topolo174197925503356063within @ real @ A2 @ ( set_ord_greaterThan @ real @ A2 ) ) )
     => ( ( filterlim @ real @ real @ G @ ( at_top @ real ) @ ( topolo174197925503356063within @ real @ A2 @ ( set_ord_greaterThan @ real @ A2 ) ) )
       => ( ( eventually @ real
            @ ^ [X5: real] : ( has_field_derivative @ real @ F2 @ ( F8 @ X5 ) @ ( topolo174197925503356063within @ real @ X5 @ ( top_top @ ( set @ real ) ) ) )
            @ ( topolo174197925503356063within @ real @ A2 @ ( set_ord_greaterThan @ real @ A2 ) ) )
         => ( ( eventually @ real
              @ ^ [X5: real] : ( has_field_derivative @ real @ G @ ( G6 @ X5 ) @ ( topolo174197925503356063within @ real @ X5 @ ( top_top @ ( set @ real ) ) ) )
              @ ( topolo174197925503356063within @ real @ A2 @ ( set_ord_greaterThan @ real @ A2 ) ) )
           => ( ( filterlim @ real @ real
                @ ^ [X5: real] : ( divide_divide @ real @ ( F8 @ X5 ) @ ( G6 @ X5 ) )
                @ ( at_top @ real )
                @ ( topolo174197925503356063within @ real @ A2 @ ( set_ord_greaterThan @ real @ A2 ) ) )
             => ( filterlim @ real @ real
                @ ^ [X5: real] : ( divide_divide @ real @ ( F2 @ X5 ) @ ( G @ X5 ) )
                @ ( at_top @ real )
                @ ( topolo174197925503356063within @ real @ A2 @ ( set_ord_greaterThan @ real @ A2 ) ) ) ) ) ) ) ) ).

% lhopital_right_at_top_at_top
thf(fact_7029_lhopital__at__top__at__bot,axiom,
    ! [F2: real > real,A2: real,G: real > real,F8: real > real,G6: real > real] :
      ( ( filterlim @ real @ real @ F2 @ ( at_top @ real ) @ ( topolo174197925503356063within @ real @ A2 @ ( top_top @ ( set @ real ) ) ) )
     => ( ( filterlim @ real @ real @ G @ ( at_bot @ real ) @ ( topolo174197925503356063within @ real @ A2 @ ( top_top @ ( set @ real ) ) ) )
       => ( ( eventually @ real
            @ ^ [X5: real] : ( has_field_derivative @ real @ F2 @ ( F8 @ X5 ) @ ( topolo174197925503356063within @ real @ X5 @ ( top_top @ ( set @ real ) ) ) )
            @ ( topolo174197925503356063within @ real @ A2 @ ( top_top @ ( set @ real ) ) ) )
         => ( ( eventually @ real
              @ ^ [X5: real] : ( has_field_derivative @ real @ G @ ( G6 @ X5 ) @ ( topolo174197925503356063within @ real @ X5 @ ( top_top @ ( set @ real ) ) ) )
              @ ( topolo174197925503356063within @ real @ A2 @ ( top_top @ ( set @ real ) ) ) )
           => ( ( filterlim @ real @ real
                @ ^ [X5: real] : ( divide_divide @ real @ ( F8 @ X5 ) @ ( G6 @ X5 ) )
                @ ( at_bot @ real )
                @ ( topolo174197925503356063within @ real @ A2 @ ( top_top @ ( set @ real ) ) ) )
             => ( filterlim @ real @ real
                @ ^ [X5: real] : ( divide_divide @ real @ ( F2 @ X5 ) @ ( G @ X5 ) )
                @ ( at_bot @ real )
                @ ( topolo174197925503356063within @ real @ A2 @ ( top_top @ ( set @ real ) ) ) ) ) ) ) ) ) ).

% lhopital_at_top_at_bot
thf(fact_7030_lhopital__left__at__top__at__top,axiom,
    ! [F2: real > real,A2: real,G: real > real,F8: real > real,G6: real > real] :
      ( ( filterlim @ real @ real @ F2 @ ( at_top @ real ) @ ( topolo174197925503356063within @ real @ A2 @ ( set_ord_lessThan @ real @ A2 ) ) )
     => ( ( filterlim @ real @ real @ G @ ( at_top @ real ) @ ( topolo174197925503356063within @ real @ A2 @ ( set_ord_lessThan @ real @ A2 ) ) )
       => ( ( eventually @ real
            @ ^ [X5: real] : ( has_field_derivative @ real @ F2 @ ( F8 @ X5 ) @ ( topolo174197925503356063within @ real @ X5 @ ( top_top @ ( set @ real ) ) ) )
            @ ( topolo174197925503356063within @ real @ A2 @ ( set_ord_lessThan @ real @ A2 ) ) )
         => ( ( eventually @ real
              @ ^ [X5: real] : ( has_field_derivative @ real @ G @ ( G6 @ X5 ) @ ( topolo174197925503356063within @ real @ X5 @ ( top_top @ ( set @ real ) ) ) )
              @ ( topolo174197925503356063within @ real @ A2 @ ( set_ord_lessThan @ real @ A2 ) ) )
           => ( ( filterlim @ real @ real
                @ ^ [X5: real] : ( divide_divide @ real @ ( F8 @ X5 ) @ ( G6 @ X5 ) )
                @ ( at_top @ real )
                @ ( topolo174197925503356063within @ real @ A2 @ ( set_ord_lessThan @ real @ A2 ) ) )
             => ( filterlim @ real @ real
                @ ^ [X5: real] : ( divide_divide @ real @ ( F2 @ X5 ) @ ( G @ X5 ) )
                @ ( at_top @ real )
                @ ( topolo174197925503356063within @ real @ A2 @ ( set_ord_lessThan @ real @ A2 ) ) ) ) ) ) ) ) ).

% lhopital_left_at_top_at_top
thf(fact_7031_lhopital__at__top,axiom,
    ! [G: real > real,X2: real,G6: real > real,F2: real > real,F8: real > real,Y2: real] :
      ( ( filterlim @ real @ real @ G @ ( at_top @ real ) @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) )
     => ( ( eventually @ real
          @ ^ [X5: real] :
              ( ( G6 @ X5 )
             != ( zero_zero @ real ) )
          @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) )
       => ( ( eventually @ real
            @ ^ [X5: real] : ( has_field_derivative @ real @ F2 @ ( F8 @ X5 ) @ ( topolo174197925503356063within @ real @ X5 @ ( top_top @ ( set @ real ) ) ) )
            @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) )
         => ( ( eventually @ real
              @ ^ [X5: real] : ( has_field_derivative @ real @ G @ ( G6 @ X5 ) @ ( topolo174197925503356063within @ real @ X5 @ ( top_top @ ( set @ real ) ) ) )
              @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) )
           => ( ( filterlim @ real @ real
                @ ^ [X5: real] : ( divide_divide @ real @ ( F8 @ X5 ) @ ( G6 @ X5 ) )
                @ ( topolo7230453075368039082e_nhds @ real @ Y2 )
                @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) )
             => ( filterlim @ real @ real
                @ ^ [X5: real] : ( divide_divide @ real @ ( F2 @ X5 ) @ ( G @ X5 ) )
                @ ( topolo7230453075368039082e_nhds @ real @ Y2 )
                @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) ) ) ) ) ) ) ).

% lhopital_at_top
thf(fact_7032_lhospital__at__top__at__top,axiom,
    ! [G: real > real,G6: real > real,F2: real > real,F8: real > real,X2: real] :
      ( ( filterlim @ real @ real @ G @ ( at_top @ real ) @ ( at_top @ real ) )
     => ( ( eventually @ real
          @ ^ [X5: real] :
              ( ( G6 @ X5 )
             != ( zero_zero @ real ) )
          @ ( at_top @ real ) )
       => ( ( eventually @ real
            @ ^ [X5: real] : ( has_field_derivative @ real @ F2 @ ( F8 @ X5 ) @ ( topolo174197925503356063within @ real @ X5 @ ( top_top @ ( set @ real ) ) ) )
            @ ( at_top @ real ) )
         => ( ( eventually @ real
              @ ^ [X5: real] : ( has_field_derivative @ real @ G @ ( G6 @ X5 ) @ ( topolo174197925503356063within @ real @ X5 @ ( top_top @ ( set @ real ) ) ) )
              @ ( at_top @ real ) )
           => ( ( filterlim @ real @ real
                @ ^ [X5: real] : ( divide_divide @ real @ ( F8 @ X5 ) @ ( G6 @ X5 ) )
                @ ( topolo7230453075368039082e_nhds @ real @ X2 )
                @ ( at_top @ real ) )
             => ( filterlim @ real @ real
                @ ^ [X5: real] : ( divide_divide @ real @ ( F2 @ X5 ) @ ( G @ X5 ) )
                @ ( topolo7230453075368039082e_nhds @ real @ X2 )
                @ ( at_top @ real ) ) ) ) ) ) ) ).

% lhospital_at_top_at_top
thf(fact_7033_lhopital__right,axiom,
    ! [F2: real > real,X2: real,G: real > real,G6: real > real,F8: real > real,F3: filter @ real] :
      ( ( filterlim @ real @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( topolo174197925503356063within @ real @ X2 @ ( set_ord_greaterThan @ real @ X2 ) ) )
     => ( ( filterlim @ real @ real @ G @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( topolo174197925503356063within @ real @ X2 @ ( set_ord_greaterThan @ real @ X2 ) ) )
       => ( ( eventually @ real
            @ ^ [X5: real] :
                ( ( G @ X5 )
               != ( zero_zero @ real ) )
            @ ( topolo174197925503356063within @ real @ X2 @ ( set_ord_greaterThan @ real @ X2 ) ) )
         => ( ( eventually @ real
              @ ^ [X5: real] :
                  ( ( G6 @ X5 )
                 != ( zero_zero @ real ) )
              @ ( topolo174197925503356063within @ real @ X2 @ ( set_ord_greaterThan @ real @ X2 ) ) )
           => ( ( eventually @ real
                @ ^ [X5: real] : ( has_field_derivative @ real @ F2 @ ( F8 @ X5 ) @ ( topolo174197925503356063within @ real @ X5 @ ( top_top @ ( set @ real ) ) ) )
                @ ( topolo174197925503356063within @ real @ X2 @ ( set_ord_greaterThan @ real @ X2 ) ) )
             => ( ( eventually @ real
                  @ ^ [X5: real] : ( has_field_derivative @ real @ G @ ( G6 @ X5 ) @ ( topolo174197925503356063within @ real @ X5 @ ( top_top @ ( set @ real ) ) ) )
                  @ ( topolo174197925503356063within @ real @ X2 @ ( set_ord_greaterThan @ real @ X2 ) ) )
               => ( ( filterlim @ real @ real
                    @ ^ [X5: real] : ( divide_divide @ real @ ( F8 @ X5 ) @ ( G6 @ X5 ) )
                    @ F3
                    @ ( topolo174197925503356063within @ real @ X2 @ ( set_ord_greaterThan @ real @ X2 ) ) )
                 => ( filterlim @ real @ real
                    @ ^ [X5: real] : ( divide_divide @ real @ ( F2 @ X5 ) @ ( G @ X5 ) )
                    @ F3
                    @ ( topolo174197925503356063within @ real @ X2 @ ( set_ord_greaterThan @ real @ X2 ) ) ) ) ) ) ) ) ) ) ).

% lhopital_right
thf(fact_7034_lhopital__right__0,axiom,
    ! [F0: real > real,G0: real > real,G6: real > real,F8: real > real,F3: filter @ real] :
      ( ( filterlim @ real @ real @ F0 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) )
     => ( ( filterlim @ real @ real @ G0 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) )
       => ( ( eventually @ real
            @ ^ [X5: real] :
                ( ( G0 @ X5 )
               != ( zero_zero @ real ) )
            @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) )
         => ( ( eventually @ real
              @ ^ [X5: real] :
                  ( ( G6 @ X5 )
                 != ( zero_zero @ real ) )
              @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) )
           => ( ( eventually @ real
                @ ^ [X5: real] : ( has_field_derivative @ real @ F0 @ ( F8 @ X5 ) @ ( topolo174197925503356063within @ real @ X5 @ ( top_top @ ( set @ real ) ) ) )
                @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) )
             => ( ( eventually @ real
                  @ ^ [X5: real] : ( has_field_derivative @ real @ G0 @ ( G6 @ X5 ) @ ( topolo174197925503356063within @ real @ X5 @ ( top_top @ ( set @ real ) ) ) )
                  @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) )
               => ( ( filterlim @ real @ real
                    @ ^ [X5: real] : ( divide_divide @ real @ ( F8 @ X5 ) @ ( G6 @ X5 ) )
                    @ F3
                    @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) )
                 => ( filterlim @ real @ real
                    @ ^ [X5: real] : ( divide_divide @ real @ ( F0 @ X5 ) @ ( G0 @ X5 ) )
                    @ F3
                    @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) ) ) ) ) ) ) ) ) ).

% lhopital_right_0
thf(fact_7035_lhopital__left,axiom,
    ! [F2: real > real,X2: real,G: real > real,G6: real > real,F8: real > real,F3: filter @ real] :
      ( ( filterlim @ real @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( topolo174197925503356063within @ real @ X2 @ ( set_ord_lessThan @ real @ X2 ) ) )
     => ( ( filterlim @ real @ real @ G @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( topolo174197925503356063within @ real @ X2 @ ( set_ord_lessThan @ real @ X2 ) ) )
       => ( ( eventually @ real
            @ ^ [X5: real] :
                ( ( G @ X5 )
               != ( zero_zero @ real ) )
            @ ( topolo174197925503356063within @ real @ X2 @ ( set_ord_lessThan @ real @ X2 ) ) )
         => ( ( eventually @ real
              @ ^ [X5: real] :
                  ( ( G6 @ X5 )
                 != ( zero_zero @ real ) )
              @ ( topolo174197925503356063within @ real @ X2 @ ( set_ord_lessThan @ real @ X2 ) ) )
           => ( ( eventually @ real
                @ ^ [X5: real] : ( has_field_derivative @ real @ F2 @ ( F8 @ X5 ) @ ( topolo174197925503356063within @ real @ X5 @ ( top_top @ ( set @ real ) ) ) )
                @ ( topolo174197925503356063within @ real @ X2 @ ( set_ord_lessThan @ real @ X2 ) ) )
             => ( ( eventually @ real
                  @ ^ [X5: real] : ( has_field_derivative @ real @ G @ ( G6 @ X5 ) @ ( topolo174197925503356063within @ real @ X5 @ ( top_top @ ( set @ real ) ) ) )
                  @ ( topolo174197925503356063within @ real @ X2 @ ( set_ord_lessThan @ real @ X2 ) ) )
               => ( ( filterlim @ real @ real
                    @ ^ [X5: real] : ( divide_divide @ real @ ( F8 @ X5 ) @ ( G6 @ X5 ) )
                    @ F3
                    @ ( topolo174197925503356063within @ real @ X2 @ ( set_ord_lessThan @ real @ X2 ) ) )
                 => ( filterlim @ real @ real
                    @ ^ [X5: real] : ( divide_divide @ real @ ( F2 @ X5 ) @ ( G @ X5 ) )
                    @ F3
                    @ ( topolo174197925503356063within @ real @ X2 @ ( set_ord_lessThan @ real @ X2 ) ) ) ) ) ) ) ) ) ) ).

% lhopital_left
thf(fact_7036_lhopital__right__at__top__at__bot,axiom,
    ! [F2: real > real,A2: real,G: real > real,F8: real > real,G6: real > real] :
      ( ( filterlim @ real @ real @ F2 @ ( at_top @ real ) @ ( topolo174197925503356063within @ real @ A2 @ ( set_ord_greaterThan @ real @ A2 ) ) )
     => ( ( filterlim @ real @ real @ G @ ( at_bot @ real ) @ ( topolo174197925503356063within @ real @ A2 @ ( set_ord_greaterThan @ real @ A2 ) ) )
       => ( ( eventually @ real
            @ ^ [X5: real] : ( has_field_derivative @ real @ F2 @ ( F8 @ X5 ) @ ( topolo174197925503356063within @ real @ X5 @ ( top_top @ ( set @ real ) ) ) )
            @ ( topolo174197925503356063within @ real @ A2 @ ( set_ord_greaterThan @ real @ A2 ) ) )
         => ( ( eventually @ real
              @ ^ [X5: real] : ( has_field_derivative @ real @ G @ ( G6 @ X5 ) @ ( topolo174197925503356063within @ real @ X5 @ ( top_top @ ( set @ real ) ) ) )
              @ ( topolo174197925503356063within @ real @ A2 @ ( set_ord_greaterThan @ real @ A2 ) ) )
           => ( ( filterlim @ real @ real
                @ ^ [X5: real] : ( divide_divide @ real @ ( F8 @ X5 ) @ ( G6 @ X5 ) )
                @ ( at_bot @ real )
                @ ( topolo174197925503356063within @ real @ A2 @ ( set_ord_greaterThan @ real @ A2 ) ) )
             => ( filterlim @ real @ real
                @ ^ [X5: real] : ( divide_divide @ real @ ( F2 @ X5 ) @ ( G @ X5 ) )
                @ ( at_bot @ real )
                @ ( topolo174197925503356063within @ real @ A2 @ ( set_ord_greaterThan @ real @ A2 ) ) ) ) ) ) ) ) ).

% lhopital_right_at_top_at_bot
thf(fact_7037_lhopital__left__at__top__at__bot,axiom,
    ! [F2: real > real,A2: real,G: real > real,F8: real > real,G6: real > real] :
      ( ( filterlim @ real @ real @ F2 @ ( at_top @ real ) @ ( topolo174197925503356063within @ real @ A2 @ ( set_ord_lessThan @ real @ A2 ) ) )
     => ( ( filterlim @ real @ real @ G @ ( at_bot @ real ) @ ( topolo174197925503356063within @ real @ A2 @ ( set_ord_lessThan @ real @ A2 ) ) )
       => ( ( eventually @ real
            @ ^ [X5: real] : ( has_field_derivative @ real @ F2 @ ( F8 @ X5 ) @ ( topolo174197925503356063within @ real @ X5 @ ( top_top @ ( set @ real ) ) ) )
            @ ( topolo174197925503356063within @ real @ A2 @ ( set_ord_lessThan @ real @ A2 ) ) )
         => ( ( eventually @ real
              @ ^ [X5: real] : ( has_field_derivative @ real @ G @ ( G6 @ X5 ) @ ( topolo174197925503356063within @ real @ X5 @ ( top_top @ ( set @ real ) ) ) )
              @ ( topolo174197925503356063within @ real @ A2 @ ( set_ord_lessThan @ real @ A2 ) ) )
           => ( ( filterlim @ real @ real
                @ ^ [X5: real] : ( divide_divide @ real @ ( F8 @ X5 ) @ ( G6 @ X5 ) )
                @ ( at_bot @ real )
                @ ( topolo174197925503356063within @ real @ A2 @ ( set_ord_lessThan @ real @ A2 ) ) )
             => ( filterlim @ real @ real
                @ ^ [X5: real] : ( divide_divide @ real @ ( F2 @ X5 ) @ ( G @ X5 ) )
                @ ( at_bot @ real )
                @ ( topolo174197925503356063within @ real @ A2 @ ( set_ord_lessThan @ real @ A2 ) ) ) ) ) ) ) ) ).

% lhopital_left_at_top_at_bot
thf(fact_7038_lhopital__right__at__top,axiom,
    ! [G: real > real,X2: real,G6: real > real,F2: real > real,F8: real > real,Y2: real] :
      ( ( filterlim @ real @ real @ G @ ( at_top @ real ) @ ( topolo174197925503356063within @ real @ X2 @ ( set_ord_greaterThan @ real @ X2 ) ) )
     => ( ( eventually @ real
          @ ^ [X5: real] :
              ( ( G6 @ X5 )
             != ( zero_zero @ real ) )
          @ ( topolo174197925503356063within @ real @ X2 @ ( set_ord_greaterThan @ real @ X2 ) ) )
       => ( ( eventually @ real
            @ ^ [X5: real] : ( has_field_derivative @ real @ F2 @ ( F8 @ X5 ) @ ( topolo174197925503356063within @ real @ X5 @ ( top_top @ ( set @ real ) ) ) )
            @ ( topolo174197925503356063within @ real @ X2 @ ( set_ord_greaterThan @ real @ X2 ) ) )
         => ( ( eventually @ real
              @ ^ [X5: real] : ( has_field_derivative @ real @ G @ ( G6 @ X5 ) @ ( topolo174197925503356063within @ real @ X5 @ ( top_top @ ( set @ real ) ) ) )
              @ ( topolo174197925503356063within @ real @ X2 @ ( set_ord_greaterThan @ real @ X2 ) ) )
           => ( ( filterlim @ real @ real
                @ ^ [X5: real] : ( divide_divide @ real @ ( F8 @ X5 ) @ ( G6 @ X5 ) )
                @ ( topolo7230453075368039082e_nhds @ real @ Y2 )
                @ ( topolo174197925503356063within @ real @ X2 @ ( set_ord_greaterThan @ real @ X2 ) ) )
             => ( filterlim @ real @ real
                @ ^ [X5: real] : ( divide_divide @ real @ ( F2 @ X5 ) @ ( G @ X5 ) )
                @ ( topolo7230453075368039082e_nhds @ real @ Y2 )
                @ ( topolo174197925503356063within @ real @ X2 @ ( set_ord_greaterThan @ real @ X2 ) ) ) ) ) ) ) ) ).

% lhopital_right_at_top
thf(fact_7039_lhopital__right__0__at__top,axiom,
    ! [G: real > real,G6: real > real,F2: real > real,F8: real > real,X2: real] :
      ( ( filterlim @ real @ real @ G @ ( at_top @ real ) @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) )
     => ( ( eventually @ real
          @ ^ [X5: real] :
              ( ( G6 @ X5 )
             != ( zero_zero @ real ) )
          @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) )
       => ( ( eventually @ real
            @ ^ [X5: real] : ( has_field_derivative @ real @ F2 @ ( F8 @ X5 ) @ ( topolo174197925503356063within @ real @ X5 @ ( top_top @ ( set @ real ) ) ) )
            @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) )
         => ( ( eventually @ real
              @ ^ [X5: real] : ( has_field_derivative @ real @ G @ ( G6 @ X5 ) @ ( topolo174197925503356063within @ real @ X5 @ ( top_top @ ( set @ real ) ) ) )
              @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) )
           => ( ( filterlim @ real @ real
                @ ^ [X5: real] : ( divide_divide @ real @ ( F8 @ X5 ) @ ( G6 @ X5 ) )
                @ ( topolo7230453075368039082e_nhds @ real @ X2 )
                @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) )
             => ( filterlim @ real @ real
                @ ^ [X5: real] : ( divide_divide @ real @ ( F2 @ X5 ) @ ( G @ X5 ) )
                @ ( topolo7230453075368039082e_nhds @ real @ X2 )
                @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) ) ) ) ) ) ) ).

% lhopital_right_0_at_top
thf(fact_7040_summable__Cauchy_H,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach @ A )
     => ! [F2: nat > A,G: nat > real] :
          ( ( eventually @ nat
            @ ^ [M6: nat] :
              ! [N3: nat] :
                ( ( ord_less_eq @ nat @ M6 @ N3 )
               => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_or7035219750837199246ssThan @ nat @ M6 @ N3 ) ) ) @ ( G @ M6 ) ) )
            @ ( at_top @ nat ) )
         => ( ( filterlim @ nat @ real @ G @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( at_top @ nat ) )
           => ( summable @ A @ F2 ) ) ) ) ).

% summable_Cauchy'
thf(fact_7041_Bfun__metric__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V7819770556892013058_space @ B )
     => ( ( bfun @ A @ B )
        = ( ^ [F5: A > B,F9: filter @ A] :
            ? [Y5: B,K6: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ K6 )
              & ( eventually @ A
                @ ^ [X5: A] : ( ord_less_eq @ real @ ( real_V557655796197034286t_dist @ B @ ( F5 @ X5 ) @ Y5 ) @ K6 )
                @ F9 ) ) ) ) ) ).

% Bfun_metric_def
thf(fact_7042_Bseq__mult,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: nat > A,G: nat > A] :
          ( ( bfun @ nat @ A @ F2 @ ( at_top @ nat ) )
         => ( ( bfun @ nat @ A @ G @ ( at_top @ nat ) )
           => ( bfun @ nat @ A
              @ ^ [X5: nat] : ( times_times @ A @ ( F2 @ X5 ) @ ( G @ X5 ) )
              @ ( at_top @ nat ) ) ) ) ) ).

% Bseq_mult
thf(fact_7043_Bseq__Suc__iff,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: nat > A] :
          ( ( bfun @ nat @ A
            @ ^ [N3: nat] : ( F2 @ ( suc @ N3 ) )
            @ ( at_top @ nat ) )
          = ( bfun @ nat @ A @ F2 @ ( at_top @ nat ) ) ) ) ).

% Bseq_Suc_iff
thf(fact_7044_Bseq__add,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: nat > A,C2: A] :
          ( ( bfun @ nat @ A @ F2 @ ( at_top @ nat ) )
         => ( bfun @ nat @ A
            @ ^ [X5: nat] : ( plus_plus @ A @ ( F2 @ X5 ) @ C2 )
            @ ( at_top @ nat ) ) ) ) ).

% Bseq_add
thf(fact_7045_Bseq__offset,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X8: nat > A,K: nat] :
          ( ( bfun @ nat @ A
            @ ^ [N3: nat] : ( X8 @ ( plus_plus @ nat @ N3 @ K ) )
            @ ( at_top @ nat ) )
         => ( bfun @ nat @ A @ X8 @ ( at_top @ nat ) ) ) ) ).

% Bseq_offset
thf(fact_7046_Bseq__add__iff,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: nat > A,C2: A] :
          ( ( bfun @ nat @ A
            @ ^ [X5: nat] : ( plus_plus @ A @ ( F2 @ X5 ) @ C2 )
            @ ( at_top @ nat ) )
          = ( bfun @ nat @ A @ F2 @ ( at_top @ nat ) ) ) ) ).

% Bseq_add_iff
thf(fact_7047_Bseq__ignore__initial__segment,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X8: nat > A,K: nat] :
          ( ( bfun @ nat @ A @ X8 @ ( at_top @ nat ) )
         => ( bfun @ nat @ A
            @ ^ [N3: nat] : ( X8 @ ( plus_plus @ nat @ N3 @ K ) )
            @ ( at_top @ nat ) ) ) ) ).

% Bseq_ignore_initial_segment
thf(fact_7048_eventually__all__ge__at__top,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [P: A > $o] :
          ( ( eventually @ A @ P @ ( at_top @ A ) )
         => ( eventually @ A
            @ ^ [X5: A] :
              ! [Y5: A] :
                ( ( ord_less_eq @ A @ X5 @ Y5 )
               => ( P @ Y5 ) )
            @ ( at_top @ A ) ) ) ) ).

% eventually_all_ge_at_top
thf(fact_7049_BseqI_H,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X8: nat > A,K5: real] :
          ( ! [N: nat] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( X8 @ N ) ) @ K5 )
         => ( bfun @ nat @ A @ X8 @ ( at_top @ nat ) ) ) ) ).

% BseqI'
thf(fact_7050_Bseq__cmult__iff,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [C2: A,F2: nat > A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( bfun @ nat @ A
              @ ^ [X5: nat] : ( times_times @ A @ C2 @ ( F2 @ X5 ) )
              @ ( at_top @ nat ) )
            = ( bfun @ nat @ A @ F2 @ ( at_top @ nat ) ) ) ) ) ).

% Bseq_cmult_iff
thf(fact_7051_Bseq__eventually__mono,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F2: nat > A,G: nat > B] :
          ( ( eventually @ nat
            @ ^ [N3: nat] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( F2 @ N3 ) ) @ ( real_V7770717601297561774m_norm @ B @ ( G @ N3 ) ) )
            @ ( at_top @ nat ) )
         => ( ( bfun @ nat @ B @ G @ ( at_top @ nat ) )
           => ( bfun @ nat @ A @ F2 @ ( at_top @ nat ) ) ) ) ) ).

% Bseq_eventually_mono
thf(fact_7052_Bseq__eq__bounded,axiom,
    ! [F2: nat > real,A2: real,B2: real] :
      ( ( ord_less_eq @ ( set @ real ) @ ( image @ nat @ real @ F2 @ ( top_top @ ( set @ nat ) ) ) @ ( set_or1337092689740270186AtMost @ real @ A2 @ B2 ) )
     => ( bfun @ nat @ real @ F2 @ ( at_top @ nat ) ) ) ).

% Bseq_eq_bounded
thf(fact_7053_Bseq__def,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X8: nat > A] :
          ( ( bfun @ nat @ A @ X8 @ ( at_top @ nat ) )
          = ( ? [K6: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ K6 )
                & ! [N3: nat] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( X8 @ N3 ) ) @ K6 ) ) ) ) ) ).

% Bseq_def
thf(fact_7054_BseqI,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [K5: real,X8: nat > A] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ K5 )
         => ( ! [N: nat] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( X8 @ N ) ) @ K5 )
           => ( bfun @ nat @ A @ X8 @ ( at_top @ nat ) ) ) ) ) ).

% BseqI
thf(fact_7055_BseqE,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X8: nat > A] :
          ( ( bfun @ nat @ A @ X8 @ ( at_top @ nat ) )
         => ~ ! [K9: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ K9 )
               => ~ ! [N9: nat] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( X8 @ N9 ) ) @ K9 ) ) ) ) ).

% BseqE
thf(fact_7056_BseqD,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X8: nat > A] :
          ( ( bfun @ nat @ A @ X8 @ ( at_top @ nat ) )
         => ? [K9: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ K9 )
              & ! [N9: nat] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( X8 @ N9 ) ) @ K9 ) ) ) ) ).

% BseqD
thf(fact_7057_Bseq__iff1a,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X8: nat > A] :
          ( ( bfun @ nat @ A @ X8 @ ( at_top @ nat ) )
          = ( ? [N6: nat] :
              ! [N3: nat] : ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( X8 @ N3 ) ) @ ( semiring_1_of_nat @ real @ ( suc @ N6 ) ) ) ) ) ) ).

% Bseq_iff1a
thf(fact_7058_Bseq__iff,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X8: nat > A] :
          ( ( bfun @ nat @ A @ X8 @ ( at_top @ nat ) )
          = ( ? [N6: nat] :
              ! [N3: nat] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( X8 @ N3 ) ) @ ( semiring_1_of_nat @ real @ ( suc @ N6 ) ) ) ) ) ) ).

% Bseq_iff
thf(fact_7059_Bseq__realpow,axiom,
    ! [X2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( ord_less_eq @ real @ X2 @ ( one_one @ real ) )
       => ( bfun @ nat @ real @ ( power_power @ real @ X2 ) @ ( at_top @ nat ) ) ) ) ).

% Bseq_realpow
thf(fact_7060_BfunI,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector @ B )
     => ! [F2: A > B,K5: real,F3: filter @ A] :
          ( ( eventually @ A
            @ ^ [X5: A] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ B @ ( F2 @ X5 ) ) @ K5 )
            @ F3 )
         => ( bfun @ A @ B @ F2 @ F3 ) ) ) ).

% BfunI
thf(fact_7061_Bseq__iff2,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X8: nat > A] :
          ( ( bfun @ nat @ A @ X8 @ ( at_top @ nat ) )
          = ( ? [K3: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ K3 )
                & ? [X5: A] :
                  ! [N3: nat] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( plus_plus @ A @ ( X8 @ N3 ) @ ( uminus_uminus @ A @ X5 ) ) ) @ K3 ) ) ) ) ) ).

% Bseq_iff2
thf(fact_7062_Bseq__iff3,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X8: nat > A] :
          ( ( bfun @ nat @ A @ X8 @ ( at_top @ nat ) )
          = ( ? [K3: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ K3 )
                & ? [N6: nat] :
                  ! [N3: nat] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( plus_plus @ A @ ( X8 @ N3 ) @ ( uminus_uminus @ A @ ( X8 @ N6 ) ) ) ) @ K3 ) ) ) ) ) ).

% Bseq_iff3
thf(fact_7063_Bfun__inverse,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [F2: B > A,A2: A,F3: filter @ B] :
          ( ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ A2 ) @ F3 )
         => ( ( A2
             != ( zero_zero @ A ) )
           => ( bfun @ B @ A
              @ ^ [X5: B] : ( inverse_inverse @ A @ ( F2 @ X5 ) )
              @ F3 ) ) ) ) ).

% Bfun_inverse
thf(fact_7064_BfunE,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector @ B )
     => ! [F2: A > B,F3: filter @ A] :
          ( ( bfun @ A @ B @ F2 @ F3 )
         => ~ ! [B9: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ B9 )
               => ~ ( eventually @ A
                    @ ^ [X5: A] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ B @ ( F2 @ X5 ) ) @ B9 )
                    @ F3 ) ) ) ) ).

% BfunE
thf(fact_7065_Bfun__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector @ B )
     => ( ( bfun @ A @ B )
        = ( ^ [F5: A > B,F9: filter @ A] :
            ? [K6: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ K6 )
              & ( eventually @ A
                @ ^ [X5: A] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ B @ ( F5 @ X5 ) ) @ K6 )
                @ F9 ) ) ) ) ) ).

% Bfun_def
thf(fact_7066_summable__bounded__partials,axiom,
    ! [A: $tType] :
      ( ( ( real_V8037385150606011577_space @ A )
        & ( real_V822414075346904944vector @ A ) )
     => ! [F2: nat > A,G: nat > real] :
          ( ( eventually @ nat
            @ ^ [X02: nat] :
              ! [A4: nat] :
                ( ( ord_less_eq @ nat @ X02 @ A4 )
               => ! [B4: nat] :
                    ( ( ord_less @ nat @ A4 @ B4 )
                   => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_or3652927894154168847AtMost @ nat @ A4 @ B4 ) ) ) @ ( G @ A4 ) ) ) )
            @ ( at_top @ nat ) )
         => ( ( filterlim @ nat @ real @ G @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( at_top @ nat ) )
           => ( summable @ A @ F2 ) ) ) ) ).

% summable_bounded_partials
thf(fact_7067_Greatest__def,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( order_Greatest @ A )
        = ( ^ [P3: A > $o] :
              ( the @ A
              @ ^ [X5: A] :
                  ( ( P3 @ X5 )
                  & ! [Y5: A] :
                      ( ( P3 @ Y5 )
                     => ( ord_less_eq @ A @ Y5 @ X5 ) ) ) ) ) ) ) ).

% Greatest_def
thf(fact_7068_greaterThanAtMost__iff,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [I3: A,L: A,U: A] :
          ( ( member @ A @ I3 @ ( set_or3652927894154168847AtMost @ A @ L @ U ) )
          = ( ( ord_less @ A @ L @ I3 )
            & ( ord_less_eq @ A @ I3 @ U ) ) ) ) ).

% greaterThanAtMost_iff
thf(fact_7069_greaterThanAtMost__empty,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [L: A,K: A] :
          ( ( ord_less_eq @ A @ L @ K )
         => ( ( set_or3652927894154168847AtMost @ A @ K @ L )
            = ( bot_bot @ ( set @ A ) ) ) ) ) ).

% greaterThanAtMost_empty
thf(fact_7070_greaterThanAtMost__empty__iff,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [K: A,L: A] :
          ( ( ( set_or3652927894154168847AtMost @ A @ K @ L )
            = ( bot_bot @ ( set @ A ) ) )
          = ( ~ ( ord_less @ A @ K @ L ) ) ) ) ).

% greaterThanAtMost_empty_iff
thf(fact_7071_greaterThanAtMost__empty__iff2,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [K: A,L: A] :
          ( ( ( bot_bot @ ( set @ A ) )
            = ( set_or3652927894154168847AtMost @ A @ K @ L ) )
          = ( ~ ( ord_less @ A @ K @ L ) ) ) ) ).

% greaterThanAtMost_empty_iff2
thf(fact_7072_infinite__Ioc__iff,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ~ ( finite_finite @ A @ ( set_or3652927894154168847AtMost @ A @ A2 @ B2 ) ) )
          = ( ord_less @ A @ A2 @ B2 ) ) ) ).

% infinite_Ioc_iff
thf(fact_7073_image__add__greaterThanAtMost,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( image @ A @ A @ ( plus_plus @ A @ C2 ) @ ( set_or3652927894154168847AtMost @ A @ A2 @ B2 ) )
          = ( set_or3652927894154168847AtMost @ A @ ( plus_plus @ A @ C2 @ A2 ) @ ( plus_plus @ A @ C2 @ B2 ) ) ) ) ).

% image_add_greaterThanAtMost
thf(fact_7074_cSup__greaterThanAtMost,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [Y2: A,X2: A] :
          ( ( ord_less @ A @ Y2 @ X2 )
         => ( ( complete_Sup_Sup @ A @ ( set_or3652927894154168847AtMost @ A @ Y2 @ X2 ) )
            = X2 ) ) ) ).

% cSup_greaterThanAtMost
thf(fact_7075_Sup__greaterThanAtMost,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [X2: A,Y2: A] :
          ( ( ord_less @ A @ X2 @ Y2 )
         => ( ( complete_Sup_Sup @ A @ ( set_or3652927894154168847AtMost @ A @ X2 @ Y2 ) )
            = Y2 ) ) ) ).

% Sup_greaterThanAtMost
thf(fact_7076_cInf__greaterThanAtMost,axiom,
    ! [A: $tType] :
      ( ( ( condit6923001295902523014norder @ A )
        & ( dense_linorder @ A ) )
     => ! [Y2: A,X2: A] :
          ( ( ord_less @ A @ Y2 @ X2 )
         => ( ( complete_Inf_Inf @ A @ ( set_or3652927894154168847AtMost @ A @ Y2 @ X2 ) )
            = Y2 ) ) ) ).

% cInf_greaterThanAtMost
thf(fact_7077_Inf__greaterThanAtMost,axiom,
    ! [A: $tType] :
      ( ( ( comple6319245703460814977attice @ A )
        & ( dense_linorder @ A ) )
     => ! [X2: A,Y2: A] :
          ( ( ord_less @ A @ X2 @ Y2 )
         => ( ( complete_Inf_Inf @ A @ ( set_or3652927894154168847AtMost @ A @ X2 @ Y2 ) )
            = X2 ) ) ) ).

% Inf_greaterThanAtMost
thf(fact_7078_GreatestI__nat,axiom,
    ! [P: nat > $o,K: nat,B2: nat] :
      ( ( P @ K )
     => ( ! [Y4: nat] :
            ( ( P @ Y4 )
           => ( ord_less_eq @ nat @ Y4 @ B2 ) )
       => ( P @ ( order_Greatest @ nat @ P ) ) ) ) ).

% GreatestI_nat
thf(fact_7079_Greatest__le__nat,axiom,
    ! [P: nat > $o,K: nat,B2: nat] :
      ( ( P @ K )
     => ( ! [Y4: nat] :
            ( ( P @ Y4 )
           => ( ord_less_eq @ nat @ Y4 @ B2 ) )
       => ( ord_less_eq @ nat @ K @ ( order_Greatest @ nat @ P ) ) ) ) ).

% Greatest_le_nat
thf(fact_7080_GreatestI__ex__nat,axiom,
    ! [P: nat > $o,B2: nat] :
      ( ? [X_1: nat] : ( P @ X_1 )
     => ( ! [Y4: nat] :
            ( ( P @ Y4 )
           => ( ord_less_eq @ nat @ Y4 @ B2 ) )
       => ( P @ ( order_Greatest @ nat @ P ) ) ) ) ).

% GreatestI_ex_nat
thf(fact_7081_ivl__disj__un__two_I6_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L: A,M: A,U: A] :
          ( ( ord_less_eq @ A @ L @ M )
         => ( ( ord_less_eq @ A @ M @ U )
           => ( ( sup_sup @ ( set @ A ) @ ( set_or3652927894154168847AtMost @ A @ L @ M ) @ ( set_or3652927894154168847AtMost @ A @ M @ U ) )
              = ( set_or3652927894154168847AtMost @ A @ L @ U ) ) ) ) ) ).

% ivl_disj_un_two(6)
thf(fact_7082_Ioc__inj,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ( set_or3652927894154168847AtMost @ A @ A2 @ B2 )
            = ( set_or3652927894154168847AtMost @ A @ C2 @ D2 ) )
          = ( ( ( ord_less_eq @ A @ B2 @ A2 )
              & ( ord_less_eq @ A @ D2 @ C2 ) )
            | ( ( A2 = C2 )
              & ( B2 = D2 ) ) ) ) ) ).

% Ioc_inj
thf(fact_7083_Ioc__subset__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ord_less_eq @ ( set @ A ) @ ( set_or3652927894154168847AtMost @ A @ A2 @ B2 ) @ ( set_or3652927894154168847AtMost @ A @ C2 @ D2 ) )
          = ( ( ord_less_eq @ A @ B2 @ A2 )
            | ( ( ord_less_eq @ A @ C2 @ A2 )
              & ( ord_less_eq @ A @ B2 @ D2 ) ) ) ) ) ).

% Ioc_subset_iff
thf(fact_7084_infinite__Ioc,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ~ ( finite_finite @ A @ ( set_or3652927894154168847AtMost @ A @ A2 @ B2 ) ) ) ) ).

% infinite_Ioc
thf(fact_7085_atLeastSucAtMost__greaterThanAtMost,axiom,
    ! [L: nat,U: nat] :
      ( ( set_or1337092689740270186AtMost @ nat @ ( suc @ L ) @ U )
      = ( set_or3652927894154168847AtMost @ nat @ L @ U ) ) ).

% atLeastSucAtMost_greaterThanAtMost
thf(fact_7086_Ioc__disjoint,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ( inf_inf @ ( set @ A ) @ ( set_or3652927894154168847AtMost @ A @ A2 @ B2 ) @ ( set_or3652927894154168847AtMost @ A @ C2 @ D2 ) )
            = ( bot_bot @ ( set @ A ) ) )
          = ( ( ord_less_eq @ A @ B2 @ A2 )
            | ( ord_less_eq @ A @ D2 @ C2 )
            | ( ord_less_eq @ A @ B2 @ C2 )
            | ( ord_less_eq @ A @ D2 @ A2 ) ) ) ) ).

% Ioc_disjoint
thf(fact_7087_ivl__disj__un__two_I8_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L: A,M: A,U: A] :
          ( ( ord_less_eq @ A @ L @ M )
         => ( ( ord_less_eq @ A @ M @ U )
           => ( ( sup_sup @ ( set @ A ) @ ( set_or1337092689740270186AtMost @ A @ L @ M ) @ ( set_or3652927894154168847AtMost @ A @ M @ U ) )
              = ( set_or1337092689740270186AtMost @ A @ L @ U ) ) ) ) ) ).

% ivl_disj_un_two(8)
thf(fact_7088_open__left,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [S3: set @ A,X2: A,Y2: A] :
          ( ( topolo1002775350975398744n_open @ A @ S3 )
         => ( ( member @ A @ X2 @ S3 )
           => ( ( ord_less @ A @ Y2 @ X2 )
             => ? [B5: A] :
                  ( ( ord_less @ A @ B5 @ X2 )
                  & ( ord_less_eq @ ( set @ A ) @ ( set_or3652927894154168847AtMost @ A @ B5 @ X2 ) @ S3 ) ) ) ) ) ) ).

% open_left
thf(fact_7089_ivl__disj__un__one_I3_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L: A,U: A] :
          ( ( ord_less_eq @ A @ L @ U )
         => ( ( sup_sup @ ( set @ A ) @ ( set_ord_atMost @ A @ L ) @ ( set_or3652927894154168847AtMost @ A @ L @ U ) )
            = ( set_ord_atMost @ A @ U ) ) ) ) ).

% ivl_disj_un_one(3)
thf(fact_7090_ivl__disj__un__one_I5_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L: A,U: A] :
          ( ( ord_less_eq @ A @ L @ U )
         => ( ( sup_sup @ ( set @ A ) @ ( set_or3652927894154168847AtMost @ A @ L @ U ) @ ( set_ord_greaterThan @ A @ U ) )
            = ( set_ord_greaterThan @ A @ L ) ) ) ) ).

% ivl_disj_un_one(5)
thf(fact_7091_Greatest__equality,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [P: A > $o,X2: A] :
          ( ( P @ X2 )
         => ( ! [Y4: A] :
                ( ( P @ Y4 )
               => ( ord_less_eq @ A @ Y4 @ X2 ) )
           => ( ( order_Greatest @ A @ P )
              = X2 ) ) ) ) ).

% Greatest_equality
thf(fact_7092_GreatestI2__order,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [P: A > $o,X2: A,Q: A > $o] :
          ( ( P @ X2 )
         => ( ! [Y4: A] :
                ( ( P @ Y4 )
               => ( ord_less_eq @ A @ Y4 @ X2 ) )
           => ( ! [X3: A] :
                  ( ( P @ X3 )
                 => ( ! [Y: A] :
                        ( ( P @ Y )
                       => ( ord_less_eq @ A @ Y @ X3 ) )
                   => ( Q @ X3 ) ) )
             => ( Q @ ( order_Greatest @ A @ P ) ) ) ) ) ) ).

% GreatestI2_order
thf(fact_7093_sum_Ohead,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [M: nat,N2: nat,G: nat > A] :
          ( ( ord_less_eq @ nat @ M @ N2 )
         => ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ N2 ) )
            = ( plus_plus @ A @ ( G @ M ) @ ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or3652927894154168847AtMost @ nat @ M @ N2 ) ) ) ) ) ) ).

% sum.head
thf(fact_7094_prod_Ohead,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [M: nat,N2: nat,G: nat > A] :
          ( ( ord_less_eq @ nat @ M @ N2 )
         => ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ N2 ) )
            = ( times_times @ A @ ( G @ M ) @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or3652927894154168847AtMost @ nat @ M @ N2 ) ) ) ) ) ) ).

% prod.head
thf(fact_7095_greaterThanAtMost__subseteq__atLeastAtMost__iff,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ord_less_eq @ ( set @ A ) @ ( set_or3652927894154168847AtMost @ A @ A2 @ B2 ) @ ( set_or1337092689740270186AtMost @ A @ C2 @ D2 ) )
          = ( ( ord_less @ A @ A2 @ B2 )
           => ( ( ord_less_eq @ A @ C2 @ A2 )
              & ( ord_less_eq @ A @ B2 @ D2 ) ) ) ) ) ).

% greaterThanAtMost_subseteq_atLeastAtMost_iff
thf(fact_7096_greaterThanAtMost__subseteq__atLeastLessThan__iff,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ord_less_eq @ ( set @ A ) @ ( set_or3652927894154168847AtMost @ A @ A2 @ B2 ) @ ( set_or7035219750837199246ssThan @ A @ C2 @ D2 ) )
          = ( ( ord_less @ A @ A2 @ B2 )
           => ( ( ord_less_eq @ A @ C2 @ A2 )
              & ( ord_less @ A @ B2 @ D2 ) ) ) ) ) ).

% greaterThanAtMost_subseteq_atLeastLessThan_iff
thf(fact_7097_ivl__disj__un__two__touch_I3_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L: A,M: A,U: A] :
          ( ( ord_less @ A @ L @ M )
         => ( ( ord_less_eq @ A @ M @ U )
           => ( ( sup_sup @ ( set @ A ) @ ( set_or3652927894154168847AtMost @ A @ L @ M ) @ ( set_or1337092689740270186AtMost @ A @ M @ U ) )
              = ( set_or3652927894154168847AtMost @ A @ L @ U ) ) ) ) ) ).

% ivl_disj_un_two_touch(3)
thf(fact_7098_greaterThanLessThan__subseteq__greaterThanAtMost__iff,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ord_less_eq @ ( set @ A ) @ ( set_or5935395276787703475ssThan @ A @ A2 @ B2 ) @ ( set_or3652927894154168847AtMost @ A @ C2 @ D2 ) )
          = ( ( ord_less @ A @ A2 @ B2 )
           => ( ( ord_less_eq @ A @ C2 @ A2 )
              & ( ord_less_eq @ A @ B2 @ D2 ) ) ) ) ) ).

% greaterThanLessThan_subseteq_greaterThanAtMost_iff
thf(fact_7099_ivl__disj__un__two_I2_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L: A,M: A,U: A] :
          ( ( ord_less_eq @ A @ L @ M )
         => ( ( ord_less @ A @ M @ U )
           => ( ( sup_sup @ ( set @ A ) @ ( set_or3652927894154168847AtMost @ A @ L @ M ) @ ( set_or5935395276787703475ssThan @ A @ M @ U ) )
              = ( set_or5935395276787703475ssThan @ A @ L @ U ) ) ) ) ) ).

% ivl_disj_un_two(2)
thf(fact_7100_ivl__disj__un__two__touch_I1_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L: A,M: A,U: A] :
          ( ( ord_less @ A @ L @ M )
         => ( ( ord_less @ A @ M @ U )
           => ( ( sup_sup @ ( set @ A ) @ ( set_or3652927894154168847AtMost @ A @ L @ M ) @ ( set_or7035219750837199246ssThan @ A @ M @ U ) )
              = ( set_or5935395276787703475ssThan @ A @ L @ U ) ) ) ) ) ).

% ivl_disj_un_two_touch(1)
thf(fact_7101_sorted__list__of__set__greaterThanAtMost,axiom,
    ! [I3: nat,J: nat] :
      ( ( ord_less_eq @ nat @ ( suc @ I3 ) @ J )
     => ( ( linord4507533701916653071of_set @ nat @ ( set_or3652927894154168847AtMost @ nat @ I3 @ J ) )
        = ( cons @ nat @ ( suc @ I3 ) @ ( linord4507533701916653071of_set @ nat @ ( set_or3652927894154168847AtMost @ nat @ ( suc @ I3 ) @ J ) ) ) ) ) ).

% sorted_list_of_set_greaterThanAtMost
thf(fact_7102_ivl__disj__un__singleton_I5_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L: A,U: A] :
          ( ( ord_less_eq @ A @ L @ U )
         => ( ( sup_sup @ ( set @ A ) @ ( insert @ A @ L @ ( bot_bot @ ( set @ A ) ) ) @ ( set_or3652927894154168847AtMost @ A @ L @ U ) )
            = ( set_or1337092689740270186AtMost @ A @ L @ U ) ) ) ) ).

% ivl_disj_un_singleton(5)
thf(fact_7103_ivl__disj__un__two_I5_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L: A,M: A,U: A] :
          ( ( ord_less @ A @ L @ M )
         => ( ( ord_less_eq @ A @ M @ U )
           => ( ( sup_sup @ ( set @ A ) @ ( set_or5935395276787703475ssThan @ A @ L @ M ) @ ( set_or1337092689740270186AtMost @ A @ M @ U ) )
              = ( set_or3652927894154168847AtMost @ A @ L @ U ) ) ) ) ) ).

% ivl_disj_un_two(5)
thf(fact_7104_ivl__disj__un__singleton_I4_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L: A,U: A] :
          ( ( ord_less @ A @ L @ U )
         => ( ( sup_sup @ ( set @ A ) @ ( set_or5935395276787703475ssThan @ A @ L @ U ) @ ( insert @ A @ U @ ( bot_bot @ ( set @ A ) ) ) )
            = ( set_or3652927894154168847AtMost @ A @ L @ U ) ) ) ) ).

% ivl_disj_un_singleton(4)
thf(fact_7105_nth__sorted__list__of__set__greaterThanAtMost,axiom,
    ! [N2: nat,J: nat,I3: nat] :
      ( ( ord_less @ nat @ N2 @ ( minus_minus @ nat @ J @ I3 ) )
     => ( ( nth @ nat @ ( linord4507533701916653071of_set @ nat @ ( set_or3652927894154168847AtMost @ nat @ I3 @ J ) ) @ N2 )
        = ( suc @ ( plus_plus @ nat @ I3 @ N2 ) ) ) ) ).

% nth_sorted_list_of_set_greaterThanAtMost
thf(fact_7106_interval__cases,axiom,
    ! [A: $tType] :
      ( ( condit6923001295902523014norder @ A )
     => ! [S3: set @ A] :
          ( ! [A5: A,B5: A,X3: A] :
              ( ( member @ A @ A5 @ S3 )
             => ( ( member @ A @ B5 @ S3 )
               => ( ( ord_less_eq @ A @ A5 @ X3 )
                 => ( ( ord_less_eq @ A @ X3 @ B5 )
                   => ( member @ A @ X3 @ S3 ) ) ) ) )
         => ? [A5: A,B5: A] :
              ( ( S3
                = ( bot_bot @ ( set @ A ) ) )
              | ( S3
                = ( top_top @ ( set @ A ) ) )
              | ( S3
                = ( set_ord_lessThan @ A @ B5 ) )
              | ( S3
                = ( set_ord_atMost @ A @ B5 ) )
              | ( S3
                = ( set_ord_greaterThan @ A @ A5 ) )
              | ( S3
                = ( set_ord_atLeast @ A @ A5 ) )
              | ( S3
                = ( set_or5935395276787703475ssThan @ A @ A5 @ B5 ) )
              | ( S3
                = ( set_or3652927894154168847AtMost @ A @ A5 @ B5 ) )
              | ( S3
                = ( set_or7035219750837199246ssThan @ A @ A5 @ B5 ) )
              | ( S3
                = ( set_or1337092689740270186AtMost @ A @ A5 @ B5 ) ) ) ) ) ).

% interval_cases
thf(fact_7107_sequentially__imp__eventually__at__right,axiom,
    ! [A: $tType] :
      ( ( ( topolo3112930676232923870pology @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [A2: A,B2: A,P: A > $o] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ! [F4: nat > A] :
                ( ! [N9: nat] : ( ord_less @ A @ A2 @ ( F4 @ N9 ) )
               => ( ! [N9: nat] : ( ord_less @ A @ ( F4 @ N9 ) @ B2 )
                 => ( ( order_antimono @ nat @ A @ F4 )
                   => ( ( filterlim @ nat @ A @ F4 @ ( topolo7230453075368039082e_nhds @ A @ A2 ) @ ( at_top @ nat ) )
                     => ( eventually @ nat
                        @ ^ [N3: nat] : ( P @ ( F4 @ N3 ) )
                        @ ( at_top @ nat ) ) ) ) ) )
           => ( eventually @ A @ P @ ( topolo174197925503356063within @ A @ A2 @ ( set_ord_greaterThan @ A @ A2 ) ) ) ) ) ) ).

% sequentially_imp_eventually_at_right
thf(fact_7108_atLeast__0,axiom,
    ( ( set_ord_atLeast @ nat @ ( zero_zero @ nat ) )
    = ( top_top @ ( set @ nat ) ) ) ).

% atLeast_0
thf(fact_7109_atLeast__iff,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [I3: A,K: A] :
          ( ( member @ A @ I3 @ ( set_ord_atLeast @ A @ K ) )
          = ( ord_less_eq @ A @ K @ I3 ) ) ) ).

% atLeast_iff
thf(fact_7110_atLeast__subset__iff,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [X2: A,Y2: A] :
          ( ( ord_less_eq @ ( set @ A ) @ ( set_ord_atLeast @ A @ X2 ) @ ( set_ord_atLeast @ A @ Y2 ) )
          = ( ord_less_eq @ A @ Y2 @ X2 ) ) ) ).

% atLeast_subset_iff
thf(fact_7111_image__add__atLeast,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [K: A,I3: A] :
          ( ( image @ A @ A @ ( plus_plus @ A @ K ) @ ( set_ord_atLeast @ A @ I3 ) )
          = ( set_ord_atLeast @ A @ ( plus_plus @ A @ K @ I3 ) ) ) ) ).

% image_add_atLeast
thf(fact_7112_Icc__subset__Ici__iff,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [L: A,H2: A,L3: A] :
          ( ( ord_less_eq @ ( set @ A ) @ ( set_or1337092689740270186AtMost @ A @ L @ H2 ) @ ( set_ord_atLeast @ A @ L3 ) )
          = ( ~ ( ord_less_eq @ A @ L @ H2 )
            | ( ord_less_eq @ A @ L3 @ L ) ) ) ) ).

% Icc_subset_Ici_iff
thf(fact_7113_Ioi__le__Ico,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A2: A] : ( ord_less_eq @ ( set @ A ) @ ( set_ord_greaterThan @ A @ A2 ) @ ( set_ord_atLeast @ A @ A2 ) ) ) ).

% Ioi_le_Ico
thf(fact_7114_not__Ici__le__Iic,axiom,
    ! [A: $tType] :
      ( ( no_top @ A )
     => ! [L: A,H3: A] :
          ~ ( ord_less_eq @ ( set @ A ) @ ( set_ord_atLeast @ A @ L ) @ ( set_ord_atMost @ A @ H3 ) ) ) ).

% not_Ici_le_Iic
thf(fact_7115_not__Iic__le__Ici,axiom,
    ! [A: $tType] :
      ( ( no_bot @ A )
     => ! [H2: A,L3: A] :
          ~ ( ord_less_eq @ ( set @ A ) @ ( set_ord_atMost @ A @ H2 ) @ ( set_ord_atLeast @ A @ L3 ) ) ) ).

% not_Iic_le_Ici
thf(fact_7116_antimonoD,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( order @ A )
        & ( order @ B ) )
     => ! [F2: A > B,X2: A,Y2: A] :
          ( ( order_antimono @ A @ B @ F2 )
         => ( ( ord_less_eq @ A @ X2 @ Y2 )
           => ( ord_less_eq @ B @ ( F2 @ Y2 ) @ ( F2 @ X2 ) ) ) ) ) ).

% antimonoD
thf(fact_7117_antimonoE,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( order @ A )
        & ( order @ B ) )
     => ! [F2: A > B,X2: A,Y2: A] :
          ( ( order_antimono @ A @ B @ F2 )
         => ( ( ord_less_eq @ A @ X2 @ Y2 )
           => ( ord_less_eq @ B @ ( F2 @ Y2 ) @ ( F2 @ X2 ) ) ) ) ) ).

% antimonoE
thf(fact_7118_antimonoI,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( order @ A )
        & ( order @ B ) )
     => ! [F2: A > B] :
          ( ! [X3: A,Y4: A] :
              ( ( ord_less_eq @ A @ X3 @ Y4 )
             => ( ord_less_eq @ B @ ( F2 @ Y4 ) @ ( F2 @ X3 ) ) )
         => ( order_antimono @ A @ B @ F2 ) ) ) ).

% antimonoI
thf(fact_7119_antimono__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( order @ A )
        & ( order @ B ) )
     => ( ( order_antimono @ A @ B )
        = ( ^ [F5: A > B] :
            ! [X5: A,Y5: A] :
              ( ( ord_less_eq @ A @ X5 @ Y5 )
             => ( ord_less_eq @ B @ ( F5 @ Y5 ) @ ( F5 @ X5 ) ) ) ) ) ) ).

% antimono_def
thf(fact_7120_atLeast__def,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ( ( set_ord_atLeast @ A )
        = ( ^ [L2: A] : ( collect @ A @ ( ord_less_eq @ A @ L2 ) ) ) ) ) ).

% atLeast_def
thf(fact_7121_not__UNIV__le__Ici,axiom,
    ! [A: $tType] :
      ( ( no_bot @ A )
     => ! [L: A] :
          ~ ( ord_less_eq @ ( set @ A ) @ ( top_top @ ( set @ A ) ) @ ( set_ord_atLeast @ A @ L ) ) ) ).

% not_UNIV_le_Ici
thf(fact_7122_decseqD,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [F2: nat > A,I3: nat,J: nat] :
          ( ( order_antimono @ nat @ A @ F2 )
         => ( ( ord_less_eq @ nat @ I3 @ J )
           => ( ord_less_eq @ A @ ( F2 @ J ) @ ( F2 @ I3 ) ) ) ) ) ).

% decseqD
thf(fact_7123_decseq__def,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( order_antimono @ nat @ A )
        = ( ^ [X4: nat > A] :
            ! [M6: nat,N3: nat] :
              ( ( ord_less_eq @ nat @ M6 @ N3 )
             => ( ord_less_eq @ A @ ( X4 @ N3 ) @ ( X4 @ M6 ) ) ) ) ) ) ).

% decseq_def
thf(fact_7124_decseq__SucD,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [A3: nat > A,I3: nat] :
          ( ( order_antimono @ nat @ A @ A3 )
         => ( ord_less_eq @ A @ ( A3 @ ( suc @ I3 ) ) @ ( A3 @ I3 ) ) ) ) ).

% decseq_SucD
thf(fact_7125_decseq__SucI,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [X8: nat > A] :
          ( ! [N: nat] : ( ord_less_eq @ A @ ( X8 @ ( suc @ N ) ) @ ( X8 @ N ) )
         => ( order_antimono @ nat @ A @ X8 ) ) ) ).

% decseq_SucI
thf(fact_7126_decseq__Suc__iff,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( order_antimono @ nat @ A )
        = ( ^ [F5: nat > A] :
            ! [N3: nat] : ( ord_less_eq @ A @ ( F5 @ ( suc @ N3 ) ) @ ( F5 @ N3 ) ) ) ) ) ).

% decseq_Suc_iff
thf(fact_7127_not__Ici__le__Icc,axiom,
    ! [A: $tType] :
      ( ( no_top @ A )
     => ! [L: A,L3: A,H3: A] :
          ~ ( ord_less_eq @ ( set @ A ) @ ( set_ord_atLeast @ A @ L ) @ ( set_or1337092689740270186AtMost @ A @ L3 @ H3 ) ) ) ).

% not_Ici_le_Icc
thf(fact_7128_atLeast__Suc__greaterThan,axiom,
    ! [K: nat] :
      ( ( set_ord_atLeast @ nat @ ( suc @ K ) )
      = ( set_ord_greaterThan @ nat @ K ) ) ).

% atLeast_Suc_greaterThan
thf(fact_7129_ivl__disj__un__one_I8_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L: A,U: A] :
          ( ( ord_less_eq @ A @ L @ U )
         => ( ( sup_sup @ ( set @ A ) @ ( set_or7035219750837199246ssThan @ A @ L @ U ) @ ( set_ord_atLeast @ A @ U ) )
            = ( set_ord_atLeast @ A @ L ) ) ) ) ).

% ivl_disj_un_one(8)
thf(fact_7130_Ici__subset__Ioi__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ ( set @ A ) @ ( set_ord_atLeast @ A @ A2 ) @ ( set_ord_greaterThan @ A @ B2 ) )
          = ( ord_less @ A @ B2 @ A2 ) ) ) ).

% Ici_subset_Ioi_iff
thf(fact_7131_decseq__bounded,axiom,
    ! [X8: nat > real,B3: real] :
      ( ( order_antimono @ nat @ real @ X8 )
     => ( ! [I2: nat] : ( ord_less_eq @ real @ B3 @ ( X8 @ I2 ) )
       => ( bfun @ nat @ real @ X8 @ ( at_top @ nat ) ) ) ) ).

% decseq_bounded
thf(fact_7132_ivl__disj__un__one_I7_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L: A,U: A] :
          ( ( ord_less_eq @ A @ L @ U )
         => ( ( sup_sup @ ( set @ A ) @ ( set_or1337092689740270186AtMost @ A @ L @ U ) @ ( set_ord_greaterThan @ A @ U ) )
            = ( set_ord_atLeast @ A @ L ) ) ) ) ).

% ivl_disj_un_one(7)
thf(fact_7133_ivl__disj__un__one_I6_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L: A,U: A] :
          ( ( ord_less @ A @ L @ U )
         => ( ( sup_sup @ ( set @ A ) @ ( set_or5935395276787703475ssThan @ A @ L @ U ) @ ( set_ord_atLeast @ A @ U ) )
            = ( set_ord_greaterThan @ A @ L ) ) ) ) ).

% ivl_disj_un_one(6)
thf(fact_7134_decseq__ge,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [X8: nat > A,L5: A,N2: nat] :
          ( ( order_antimono @ nat @ A @ X8 )
         => ( ( filterlim @ nat @ A @ X8 @ ( topolo7230453075368039082e_nhds @ A @ L5 ) @ ( at_top @ nat ) )
           => ( ord_less_eq @ A @ L5 @ ( X8 @ N2 ) ) ) ) ) ).

% decseq_ge
thf(fact_7135_greaterThanAtMost__upto,axiom,
    ( ( set_or3652927894154168847AtMost @ int )
    = ( ^ [I4: int,J3: int] : ( set2 @ int @ ( upto @ ( plus_plus @ int @ I4 @ ( one_one @ int ) ) @ J3 ) ) ) ) ).

% greaterThanAtMost_upto
thf(fact_7136_decseq__convergent,axiom,
    ! [X8: nat > real,B3: real] :
      ( ( order_antimono @ nat @ real @ X8 )
     => ( ! [I2: nat] : ( ord_less_eq @ real @ B3 @ ( X8 @ I2 ) )
       => ~ ! [L6: real] :
              ( ( filterlim @ nat @ real @ X8 @ ( topolo7230453075368039082e_nhds @ real @ L6 ) @ ( at_top @ nat ) )
             => ~ ! [I: nat] : ( ord_less_eq @ real @ L6 @ ( X8 @ I ) ) ) ) ) ).

% decseq_convergent
thf(fact_7137_atLeast__Suc,axiom,
    ! [K: nat] :
      ( ( set_ord_atLeast @ nat @ ( suc @ K ) )
      = ( minus_minus @ ( set @ nat ) @ ( set_ord_atLeast @ nat @ K ) @ ( insert @ nat @ K @ ( bot_bot @ ( set @ nat ) ) ) ) ) ).

% atLeast_Suc
thf(fact_7138_tendsto__at__right__sequentially,axiom,
    ! [C: $tType,B: $tType] :
      ( ( ( topolo3112930676232923870pology @ B )
        & ( topolo1944317154257567458pology @ B )
        & ( topolo4958980785337419405_space @ C ) )
     => ! [A2: B,B2: B,X8: B > C,L5: C] :
          ( ( ord_less @ B @ A2 @ B2 )
         => ( ! [S4: nat > B] :
                ( ! [N9: nat] : ( ord_less @ B @ A2 @ ( S4 @ N9 ) )
               => ( ! [N9: nat] : ( ord_less @ B @ ( S4 @ N9 ) @ B2 )
                 => ( ( order_antimono @ nat @ B @ S4 )
                   => ( ( filterlim @ nat @ B @ S4 @ ( topolo7230453075368039082e_nhds @ B @ A2 ) @ ( at_top @ nat ) )
                     => ( filterlim @ nat @ C
                        @ ^ [N3: nat] : ( X8 @ ( S4 @ N3 ) )
                        @ ( topolo7230453075368039082e_nhds @ C @ L5 )
                        @ ( at_top @ nat ) ) ) ) ) )
           => ( filterlim @ B @ C @ X8 @ ( topolo7230453075368039082e_nhds @ C @ L5 ) @ ( topolo174197925503356063within @ B @ A2 @ ( set_ord_greaterThan @ B @ A2 ) ) ) ) ) ) ).

% tendsto_at_right_sequentially
thf(fact_7139_VEBT__internal_Ovalid_H_Oelims_I3_J,axiom,
    ! [X2: vEBT_VEBT,Xa2: nat] :
      ( ~ ( vEBT_VEBT_valid @ X2 @ Xa2 )
     => ( ( ? [Uu: $o,Uv: $o] :
              ( X2
              = ( vEBT_Leaf @ Uu @ Uv ) )
         => ( Xa2
            = ( one_one @ nat ) ) )
       => ~ ! [Mima: option @ ( product_prod @ nat @ nat ),Deg2: nat,TreeList2: list @ vEBT_VEBT,Summary2: vEBT_VEBT] :
              ( ( X2
                = ( vEBT_Node @ Mima @ Deg2 @ TreeList2 @ Summary2 ) )
             => ( ( Deg2 = Xa2 )
                & ! [X3: vEBT_VEBT] :
                    ( ( member @ vEBT_VEBT @ X3 @ ( set2 @ vEBT_VEBT @ TreeList2 ) )
                   => ( vEBT_VEBT_valid @ X3 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
                & ( vEBT_VEBT_valid @ Summary2 @ ( minus_minus @ nat @ Deg2 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
                & ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 )
                  = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ Deg2 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                & ( case_option @ $o @ ( product_prod @ nat @ nat )
                  @ ( ~ ? [X4: nat] : ( vEBT_V8194947554948674370ptions @ Summary2 @ X4 )
                    & ! [X5: vEBT_VEBT] :
                        ( ( member @ vEBT_VEBT @ X5 @ ( set2 @ vEBT_VEBT @ TreeList2 ) )
                       => ~ ? [X4: nat] : ( vEBT_V8194947554948674370ptions @ X5 @ X4 ) ) )
                  @ ( product_case_prod @ nat @ nat @ $o
                    @ ^ [Mi3: nat,Ma3: nat] :
                        ( ( ord_less_eq @ nat @ Mi3 @ Ma3 )
                        & ( ord_less @ nat @ Ma3 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg2 ) )
                        & ! [I4: nat] :
                            ( ( ord_less @ nat @ I4 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ Deg2 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                           => ( ( ? [X4: nat] : ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList2 @ I4 ) @ X4 ) )
                              = ( vEBT_V8194947554948674370ptions @ Summary2 @ I4 ) ) )
                        & ( ( Mi3 = Ma3 )
                         => ! [X5: vEBT_VEBT] :
                              ( ( member @ vEBT_VEBT @ X5 @ ( set2 @ vEBT_VEBT @ TreeList2 ) )
                             => ~ ? [X4: nat] : ( vEBT_V8194947554948674370ptions @ X5 @ X4 ) ) )
                        & ( ( Mi3 != Ma3 )
                         => ( ( vEBT_V5917875025757280293ildren @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ TreeList2 @ Ma3 )
                            & ! [X5: nat] :
                                ( ( ord_less @ nat @ X5 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg2 ) )
                               => ( ( vEBT_V5917875025757280293ildren @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ TreeList2 @ X5 )
                                 => ( ( ord_less @ nat @ Mi3 @ X5 )
                                    & ( ord_less_eq @ nat @ X5 @ Ma3 ) ) ) ) ) ) ) )
                  @ Mima ) ) ) ) ) ).

% VEBT_internal.valid'.elims(3)
thf(fact_7140_VEBT__internal_Ovalid_H_Oelims_I2_J,axiom,
    ! [X2: vEBT_VEBT,Xa2: nat] :
      ( ( vEBT_VEBT_valid @ X2 @ Xa2 )
     => ( ( ? [Uu: $o,Uv: $o] :
              ( X2
              = ( vEBT_Leaf @ Uu @ Uv ) )
         => ( Xa2
           != ( one_one @ nat ) ) )
       => ~ ! [Mima: option @ ( product_prod @ nat @ nat ),Deg2: nat,TreeList2: list @ vEBT_VEBT,Summary2: vEBT_VEBT] :
              ( ( X2
                = ( vEBT_Node @ Mima @ Deg2 @ TreeList2 @ Summary2 ) )
             => ~ ( ( Deg2 = Xa2 )
                  & ! [X: vEBT_VEBT] :
                      ( ( member @ vEBT_VEBT @ X @ ( set2 @ vEBT_VEBT @ TreeList2 ) )
                     => ( vEBT_VEBT_valid @ X @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
                  & ( vEBT_VEBT_valid @ Summary2 @ ( minus_minus @ nat @ Deg2 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
                  & ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 )
                    = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ Deg2 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                  & ( case_option @ $o @ ( product_prod @ nat @ nat )
                    @ ( ~ ? [X4: nat] : ( vEBT_V8194947554948674370ptions @ Summary2 @ X4 )
                      & ! [X5: vEBT_VEBT] :
                          ( ( member @ vEBT_VEBT @ X5 @ ( set2 @ vEBT_VEBT @ TreeList2 ) )
                         => ~ ? [X4: nat] : ( vEBT_V8194947554948674370ptions @ X5 @ X4 ) ) )
                    @ ( product_case_prod @ nat @ nat @ $o
                      @ ^ [Mi3: nat,Ma3: nat] :
                          ( ( ord_less_eq @ nat @ Mi3 @ Ma3 )
                          & ( ord_less @ nat @ Ma3 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg2 ) )
                          & ! [I4: nat] :
                              ( ( ord_less @ nat @ I4 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ Deg2 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                             => ( ( ? [X4: nat] : ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList2 @ I4 ) @ X4 ) )
                                = ( vEBT_V8194947554948674370ptions @ Summary2 @ I4 ) ) )
                          & ( ( Mi3 = Ma3 )
                           => ! [X5: vEBT_VEBT] :
                                ( ( member @ vEBT_VEBT @ X5 @ ( set2 @ vEBT_VEBT @ TreeList2 ) )
                               => ~ ? [X4: nat] : ( vEBT_V8194947554948674370ptions @ X5 @ X4 ) ) )
                          & ( ( Mi3 != Ma3 )
                           => ( ( vEBT_V5917875025757280293ildren @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ TreeList2 @ Ma3 )
                              & ! [X5: nat] :
                                  ( ( ord_less @ nat @ X5 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg2 ) )
                                 => ( ( vEBT_V5917875025757280293ildren @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ TreeList2 @ X5 )
                                   => ( ( ord_less @ nat @ Mi3 @ X5 )
                                      & ( ord_less_eq @ nat @ X5 @ Ma3 ) ) ) ) ) ) ) )
                    @ Mima ) ) ) ) ) ).

% VEBT_internal.valid'.elims(2)
thf(fact_7141_set__Cons__def,axiom,
    ! [A: $tType] :
      ( ( set_Cons @ A )
      = ( ^ [A7: set @ A,XS: set @ ( list @ A )] :
            ( collect @ ( list @ A )
            @ ^ [Z6: list @ A] :
              ? [X5: A,Xs3: list @ A] :
                ( ( Z6
                  = ( cons @ A @ X5 @ Xs3 ) )
                & ( member @ A @ X5 @ A7 )
                & ( member @ ( list @ A ) @ Xs3 @ XS ) ) ) ) ) ).

% set_Cons_def
thf(fact_7142_listrel1__def,axiom,
    ! [A: $tType] :
      ( ( listrel1 @ A )
      = ( ^ [R5: set @ ( product_prod @ A @ A )] :
            ( collect @ ( product_prod @ ( list @ A ) @ ( list @ A ) )
            @ ( product_case_prod @ ( list @ A ) @ ( list @ A ) @ $o
              @ ^ [Xs3: list @ A,Ys3: list @ A] :
                ? [Us2: list @ A,Z6: A,Z5: A,Vs3: list @ A] :
                  ( ( Xs3
                    = ( append @ A @ Us2 @ ( cons @ A @ Z6 @ Vs3 ) ) )
                  & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Z6 @ Z5 ) @ R5 )
                  & ( Ys3
                    = ( append @ A @ Us2 @ ( cons @ A @ Z5 @ Vs3 ) ) ) ) ) ) ) ) ).

% listrel1_def
thf(fact_7143_open__diagonal__complement,axiom,
    ! [A: $tType] :
      ( ( topological_t2_space @ A )
     => ( topolo1002775350975398744n_open @ ( product_prod @ A @ A )
        @ ( collect @ ( product_prod @ A @ A )
          @ ^ [Uu3: product_prod @ A @ A] :
            ? [X5: A,Y5: A] :
              ( ( Uu3
                = ( product_Pair @ A @ A @ X5 @ Y5 ) )
              & ( X5 != Y5 ) ) ) ) ) ).

% open_diagonal_complement
thf(fact_7144_open__subdiagonal,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ( topolo1002775350975398744n_open @ ( product_prod @ A @ A )
        @ ( collect @ ( product_prod @ A @ A )
          @ ^ [Uu3: product_prod @ A @ A] :
            ? [X5: A,Y5: A] :
              ( ( Uu3
                = ( product_Pair @ A @ A @ X5 @ Y5 ) )
              & ( ord_less @ A @ X5 @ Y5 ) ) ) ) ) ).

% open_subdiagonal
thf(fact_7145_open__superdiagonal,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ( topolo1002775350975398744n_open @ ( product_prod @ A @ A )
        @ ( collect @ ( product_prod @ A @ A )
          @ ^ [Uu3: product_prod @ A @ A] :
            ? [X5: A,Y5: A] :
              ( ( Uu3
                = ( product_Pair @ A @ A @ X5 @ Y5 ) )
              & ( ord_less @ A @ Y5 @ X5 ) ) ) ) ) ).

% open_superdiagonal
thf(fact_7146_Ball__Collect,axiom,
    ! [A: $tType] :
      ( ( ball @ A )
      = ( ^ [A7: set @ A,P3: A > $o] : ( ord_less_eq @ ( set @ A ) @ A7 @ ( collect @ A @ P3 ) ) ) ) ).

% Ball_Collect
thf(fact_7147_Sup__eq__Inf,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ( ( complete_Sup_Sup @ A )
        = ( ^ [A7: set @ A] :
              ( complete_Inf_Inf @ A
              @ ( collect @ A
                @ ^ [B4: A] :
                  ! [X5: A] :
                    ( ( member @ A @ X5 @ A7 )
                   => ( ord_less_eq @ A @ X5 @ B4 ) ) ) ) ) ) ) ).

% Sup_eq_Inf
thf(fact_7148_Inf__eq__Sup,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ( ( complete_Inf_Inf @ A )
        = ( ^ [A7: set @ A] :
              ( complete_Sup_Sup @ A
              @ ( collect @ A
                @ ^ [B4: A] :
                  ! [X5: A] :
                    ( ( member @ A @ X5 @ A7 )
                   => ( ord_less_eq @ A @ B4 @ X5 ) ) ) ) ) ) ) ).

% Inf_eq_Sup
thf(fact_7149_set__conv__nth,axiom,
    ! [A: $tType] :
      ( ( set2 @ A )
      = ( ^ [Xs3: list @ A] :
            ( collect @ A
            @ ^ [Uu3: A] :
              ? [I4: nat] :
                ( ( Uu3
                  = ( nth @ A @ Xs3 @ I4 ) )
                & ( ord_less @ nat @ I4 @ ( size_size @ ( list @ A ) @ Xs3 ) ) ) ) ) ) ).

% set_conv_nth
thf(fact_7150_VEBT__internal_Ovalid_H_Osimps_I2_J,axiom,
    ! [Mima2: option @ ( product_prod @ nat @ nat ),Deg: nat,TreeList: list @ vEBT_VEBT,Summary: vEBT_VEBT,Deg4: nat] :
      ( ( vEBT_VEBT_valid @ ( vEBT_Node @ Mima2 @ Deg @ TreeList @ Summary ) @ Deg4 )
      = ( ( Deg = Deg4 )
        & ! [X5: vEBT_VEBT] :
            ( ( member @ vEBT_VEBT @ X5 @ ( set2 @ vEBT_VEBT @ TreeList ) )
           => ( vEBT_VEBT_valid @ X5 @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
        & ( vEBT_VEBT_valid @ Summary @ ( minus_minus @ nat @ Deg @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
        & ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList )
          = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ Deg @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
        & ( case_option @ $o @ ( product_prod @ nat @ nat )
          @ ( ~ ? [X4: nat] : ( vEBT_V8194947554948674370ptions @ Summary @ X4 )
            & ! [X5: vEBT_VEBT] :
                ( ( member @ vEBT_VEBT @ X5 @ ( set2 @ vEBT_VEBT @ TreeList ) )
               => ~ ? [X4: nat] : ( vEBT_V8194947554948674370ptions @ X5 @ X4 ) ) )
          @ ( product_case_prod @ nat @ nat @ $o
            @ ^ [Mi3: nat,Ma3: nat] :
                ( ( ord_less_eq @ nat @ Mi3 @ Ma3 )
                & ( ord_less @ nat @ Ma3 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg ) )
                & ! [I4: nat] :
                    ( ( ord_less @ nat @ I4 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ Deg @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                   => ( ( ? [X4: nat] : ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList @ I4 ) @ X4 ) )
                      = ( vEBT_V8194947554948674370ptions @ Summary @ I4 ) ) )
                & ( ( Mi3 = Ma3 )
                 => ! [X5: vEBT_VEBT] :
                      ( ( member @ vEBT_VEBT @ X5 @ ( set2 @ vEBT_VEBT @ TreeList ) )
                     => ~ ? [X4: nat] : ( vEBT_V8194947554948674370ptions @ X5 @ X4 ) ) )
                & ( ( Mi3 != Ma3 )
                 => ( ( vEBT_V5917875025757280293ildren @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ TreeList @ Ma3 )
                    & ! [X5: nat] :
                        ( ( ord_less @ nat @ X5 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg ) )
                       => ( ( vEBT_V5917875025757280293ildren @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ TreeList @ X5 )
                         => ( ( ord_less @ nat @ Mi3 @ X5 )
                            & ( ord_less_eq @ nat @ X5 @ Ma3 ) ) ) ) ) ) ) )
          @ Mima2 ) ) ) ).

% VEBT_internal.valid'.simps(2)
thf(fact_7151_VEBT__internal_Ovalid_H_Oelims_I1_J,axiom,
    ! [X2: vEBT_VEBT,Xa2: nat,Y2: $o] :
      ( ( ( vEBT_VEBT_valid @ X2 @ Xa2 )
        = Y2 )
     => ( ( ? [Uu: $o,Uv: $o] :
              ( X2
              = ( vEBT_Leaf @ Uu @ Uv ) )
         => ( Y2
            = ( ( Xa2
               != ( one_one @ nat ) ) ) ) )
       => ~ ! [Mima: option @ ( product_prod @ nat @ nat ),Deg2: nat,TreeList2: list @ vEBT_VEBT,Summary2: vEBT_VEBT] :
              ( ( X2
                = ( vEBT_Node @ Mima @ Deg2 @ TreeList2 @ Summary2 ) )
             => ( Y2
                = ( ~ ( ( Deg2 = Xa2 )
                      & ! [X5: vEBT_VEBT] :
                          ( ( member @ vEBT_VEBT @ X5 @ ( set2 @ vEBT_VEBT @ TreeList2 ) )
                         => ( vEBT_VEBT_valid @ X5 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
                      & ( vEBT_VEBT_valid @ Summary2 @ ( minus_minus @ nat @ Deg2 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
                      & ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 )
                        = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ Deg2 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                      & ( case_option @ $o @ ( product_prod @ nat @ nat )
                        @ ( ~ ? [X4: nat] : ( vEBT_V8194947554948674370ptions @ Summary2 @ X4 )
                          & ! [X5: vEBT_VEBT] :
                              ( ( member @ vEBT_VEBT @ X5 @ ( set2 @ vEBT_VEBT @ TreeList2 ) )
                             => ~ ? [X4: nat] : ( vEBT_V8194947554948674370ptions @ X5 @ X4 ) ) )
                        @ ( product_case_prod @ nat @ nat @ $o
                          @ ^ [Mi3: nat,Ma3: nat] :
                              ( ( ord_less_eq @ nat @ Mi3 @ Ma3 )
                              & ( ord_less @ nat @ Ma3 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg2 ) )
                              & ! [I4: nat] :
                                  ( ( ord_less @ nat @ I4 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ Deg2 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                                 => ( ( ? [X4: nat] : ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList2 @ I4 ) @ X4 ) )
                                    = ( vEBT_V8194947554948674370ptions @ Summary2 @ I4 ) ) )
                              & ( ( Mi3 = Ma3 )
                               => ! [X5: vEBT_VEBT] :
                                    ( ( member @ vEBT_VEBT @ X5 @ ( set2 @ vEBT_VEBT @ TreeList2 ) )
                                   => ~ ? [X4: nat] : ( vEBT_V8194947554948674370ptions @ X5 @ X4 ) ) )
                              & ( ( Mi3 != Ma3 )
                               => ( ( vEBT_V5917875025757280293ildren @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ TreeList2 @ Ma3 )
                                  & ! [X5: nat] :
                                      ( ( ord_less @ nat @ X5 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg2 ) )
                                     => ( ( vEBT_V5917875025757280293ildren @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ TreeList2 @ X5 )
                                       => ( ( ord_less @ nat @ Mi3 @ X5 )
                                          & ( ord_less_eq @ nat @ X5 @ Ma3 ) ) ) ) ) ) ) )
                        @ Mima ) ) ) ) ) ) ) ).

% VEBT_internal.valid'.elims(1)
thf(fact_7152_VEBT__internal_Ovalid_H_Opelims_I1_J,axiom,
    ! [X2: vEBT_VEBT,Xa2: nat,Y2: $o] :
      ( ( ( vEBT_VEBT_valid @ X2 @ Xa2 )
        = Y2 )
     => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_VEBT_valid_rel @ ( product_Pair @ vEBT_VEBT @ nat @ X2 @ Xa2 ) )
       => ( ! [Uu: $o,Uv: $o] :
              ( ( X2
                = ( vEBT_Leaf @ Uu @ Uv ) )
             => ( ( Y2
                  = ( Xa2
                    = ( one_one @ nat ) ) )
               => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_VEBT_valid_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Leaf @ Uu @ Uv ) @ Xa2 ) ) ) )
         => ~ ! [Mima: option @ ( product_prod @ nat @ nat ),Deg2: nat,TreeList2: list @ vEBT_VEBT,Summary2: vEBT_VEBT] :
                ( ( X2
                  = ( vEBT_Node @ Mima @ Deg2 @ TreeList2 @ Summary2 ) )
               => ( ( Y2
                    = ( ( Deg2 = Xa2 )
                      & ! [X5: vEBT_VEBT] :
                          ( ( member @ vEBT_VEBT @ X5 @ ( set2 @ vEBT_VEBT @ TreeList2 ) )
                         => ( vEBT_VEBT_valid @ X5 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
                      & ( vEBT_VEBT_valid @ Summary2 @ ( minus_minus @ nat @ Deg2 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
                      & ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 )
                        = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ Deg2 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                      & ( case_option @ $o @ ( product_prod @ nat @ nat )
                        @ ( ~ ? [X4: nat] : ( vEBT_V8194947554948674370ptions @ Summary2 @ X4 )
                          & ! [X5: vEBT_VEBT] :
                              ( ( member @ vEBT_VEBT @ X5 @ ( set2 @ vEBT_VEBT @ TreeList2 ) )
                             => ~ ? [X4: nat] : ( vEBT_V8194947554948674370ptions @ X5 @ X4 ) ) )
                        @ ( product_case_prod @ nat @ nat @ $o
                          @ ^ [Mi3: nat,Ma3: nat] :
                              ( ( ord_less_eq @ nat @ Mi3 @ Ma3 )
                              & ( ord_less @ nat @ Ma3 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg2 ) )
                              & ! [I4: nat] :
                                  ( ( ord_less @ nat @ I4 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ Deg2 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                                 => ( ( ? [X4: nat] : ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList2 @ I4 ) @ X4 ) )
                                    = ( vEBT_V8194947554948674370ptions @ Summary2 @ I4 ) ) )
                              & ( ( Mi3 = Ma3 )
                               => ! [X5: vEBT_VEBT] :
                                    ( ( member @ vEBT_VEBT @ X5 @ ( set2 @ vEBT_VEBT @ TreeList2 ) )
                                   => ~ ? [X4: nat] : ( vEBT_V8194947554948674370ptions @ X5 @ X4 ) ) )
                              & ( ( Mi3 != Ma3 )
                               => ( ( vEBT_V5917875025757280293ildren @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ TreeList2 @ Ma3 )
                                  & ! [X5: nat] :
                                      ( ( ord_less @ nat @ X5 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg2 ) )
                                     => ( ( vEBT_V5917875025757280293ildren @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ TreeList2 @ X5 )
                                       => ( ( ord_less @ nat @ Mi3 @ X5 )
                                          & ( ord_less_eq @ nat @ X5 @ Ma3 ) ) ) ) ) ) ) )
                        @ Mima ) ) )
                 => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_VEBT_valid_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ Mima @ Deg2 @ TreeList2 @ Summary2 ) @ Xa2 ) ) ) ) ) ) ) ).

% VEBT_internal.valid'.pelims(1)
thf(fact_7153_VEBT__internal_Ovalid_H_Opelims_I2_J,axiom,
    ! [X2: vEBT_VEBT,Xa2: nat] :
      ( ( vEBT_VEBT_valid @ X2 @ Xa2 )
     => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_VEBT_valid_rel @ ( product_Pair @ vEBT_VEBT @ nat @ X2 @ Xa2 ) )
       => ( ! [Uu: $o,Uv: $o] :
              ( ( X2
                = ( vEBT_Leaf @ Uu @ Uv ) )
             => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_VEBT_valid_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Leaf @ Uu @ Uv ) @ Xa2 ) )
               => ( Xa2
                 != ( one_one @ nat ) ) ) )
         => ~ ! [Mima: option @ ( product_prod @ nat @ nat ),Deg2: nat,TreeList2: list @ vEBT_VEBT,Summary2: vEBT_VEBT] :
                ( ( X2
                  = ( vEBT_Node @ Mima @ Deg2 @ TreeList2 @ Summary2 ) )
               => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_VEBT_valid_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ Mima @ Deg2 @ TreeList2 @ Summary2 ) @ Xa2 ) )
                 => ~ ( ( Deg2 = Xa2 )
                      & ! [X: vEBT_VEBT] :
                          ( ( member @ vEBT_VEBT @ X @ ( set2 @ vEBT_VEBT @ TreeList2 ) )
                         => ( vEBT_VEBT_valid @ X @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
                      & ( vEBT_VEBT_valid @ Summary2 @ ( minus_minus @ nat @ Deg2 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
                      & ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 )
                        = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ Deg2 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                      & ( case_option @ $o @ ( product_prod @ nat @ nat )
                        @ ( ~ ? [X4: nat] : ( vEBT_V8194947554948674370ptions @ Summary2 @ X4 )
                          & ! [X5: vEBT_VEBT] :
                              ( ( member @ vEBT_VEBT @ X5 @ ( set2 @ vEBT_VEBT @ TreeList2 ) )
                             => ~ ? [X4: nat] : ( vEBT_V8194947554948674370ptions @ X5 @ X4 ) ) )
                        @ ( product_case_prod @ nat @ nat @ $o
                          @ ^ [Mi3: nat,Ma3: nat] :
                              ( ( ord_less_eq @ nat @ Mi3 @ Ma3 )
                              & ( ord_less @ nat @ Ma3 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg2 ) )
                              & ! [I4: nat] :
                                  ( ( ord_less @ nat @ I4 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ Deg2 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                                 => ( ( ? [X4: nat] : ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList2 @ I4 ) @ X4 ) )
                                    = ( vEBT_V8194947554948674370ptions @ Summary2 @ I4 ) ) )
                              & ( ( Mi3 = Ma3 )
                               => ! [X5: vEBT_VEBT] :
                                    ( ( member @ vEBT_VEBT @ X5 @ ( set2 @ vEBT_VEBT @ TreeList2 ) )
                                   => ~ ? [X4: nat] : ( vEBT_V8194947554948674370ptions @ X5 @ X4 ) ) )
                              & ( ( Mi3 != Ma3 )
                               => ( ( vEBT_V5917875025757280293ildren @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ TreeList2 @ Ma3 )
                                  & ! [X5: nat] :
                                      ( ( ord_less @ nat @ X5 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg2 ) )
                                     => ( ( vEBT_V5917875025757280293ildren @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ TreeList2 @ X5 )
                                       => ( ( ord_less @ nat @ Mi3 @ X5 )
                                          & ( ord_less_eq @ nat @ X5 @ Ma3 ) ) ) ) ) ) ) )
                        @ Mima ) ) ) ) ) ) ) ).

% VEBT_internal.valid'.pelims(2)
thf(fact_7154_Inf__Sup__le,axiom,
    ! [A: $tType] :
      ( ( comple592849572758109894attice @ A )
     => ! [A3: set @ ( set @ A )] :
          ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ ( image @ ( set @ A ) @ A @ ( complete_Sup_Sup @ A ) @ A3 ) )
          @ ( complete_Sup_Sup @ A
            @ ( image @ ( set @ A ) @ A @ ( complete_Inf_Inf @ A )
              @ ( collect @ ( set @ A )
                @ ^ [Uu3: set @ A] :
                  ? [F5: ( set @ A ) > A] :
                    ( ( Uu3
                      = ( image @ ( set @ A ) @ A @ F5 @ A3 ) )
                    & ! [X5: set @ A] :
                        ( ( member @ ( set @ A ) @ X5 @ A3 )
                       => ( member @ A @ ( F5 @ X5 ) @ X5 ) ) ) ) ) ) ) ) ).

% Inf_Sup_le
thf(fact_7155_Sup__Inf__le,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A3: set @ ( set @ A )] :
          ( ord_less_eq @ A
          @ ( complete_Sup_Sup @ A
            @ ( image @ ( set @ A ) @ A @ ( complete_Inf_Inf @ A )
              @ ( collect @ ( set @ A )
                @ ^ [Uu3: set @ A] :
                  ? [F5: ( set @ A ) > A] :
                    ( ( Uu3
                      = ( image @ ( set @ A ) @ A @ F5 @ A3 ) )
                    & ! [X5: set @ A] :
                        ( ( member @ ( set @ A ) @ X5 @ A3 )
                       => ( member @ A @ ( F5 @ X5 ) @ X5 ) ) ) ) ) )
          @ ( complete_Inf_Inf @ A @ ( image @ ( set @ A ) @ A @ ( complete_Sup_Sup @ A ) @ A3 ) ) ) ) ).

% Sup_Inf_le
thf(fact_7156_Inf__filter__def,axiom,
    ! [A: $tType] :
      ( ( complete_Inf_Inf @ ( filter @ A ) )
      = ( ^ [S6: set @ ( filter @ A )] :
            ( complete_Sup_Sup @ ( filter @ A )
            @ ( collect @ ( filter @ A )
              @ ^ [F9: filter @ A] :
                ! [X5: filter @ A] :
                  ( ( member @ ( filter @ A ) @ X5 @ S6 )
                 => ( ord_less_eq @ ( filter @ A ) @ F9 @ X5 ) ) ) ) ) ) ).

% Inf_filter_def
thf(fact_7157_Sup__int__def,axiom,
    ( ( complete_Sup_Sup @ int )
    = ( ^ [X4: set @ int] :
          ( the @ int
          @ ^ [X5: int] :
              ( ( member @ int @ X5 @ X4 )
              & ! [Y5: int] :
                  ( ( member @ int @ Y5 @ X4 )
                 => ( ord_less_eq @ int @ Y5 @ X5 ) ) ) ) ) ) ).

% Sup_int_def
thf(fact_7158_Union__maximal__sets,axiom,
    ! [A: $tType,F16: set @ ( set @ A )] :
      ( ( finite_finite @ ( set @ A ) @ F16 )
     => ( ( complete_Sup_Sup @ ( set @ A )
          @ ( collect @ ( set @ A )
            @ ^ [T9: set @ A] :
                ( ( member @ ( set @ A ) @ T9 @ F16 )
                & ! [X5: set @ A] :
                    ( ( member @ ( set @ A ) @ X5 @ F16 )
                   => ~ ( ord_less @ ( set @ A ) @ T9 @ X5 ) ) ) ) )
        = ( complete_Sup_Sup @ ( set @ A ) @ F16 ) ) ) ).

% Union_maximal_sets
thf(fact_7159_VEBT__internal_Ovalid_H_Opelims_I3_J,axiom,
    ! [X2: vEBT_VEBT,Xa2: nat] :
      ( ~ ( vEBT_VEBT_valid @ X2 @ Xa2 )
     => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_VEBT_valid_rel @ ( product_Pair @ vEBT_VEBT @ nat @ X2 @ Xa2 ) )
       => ( ! [Uu: $o,Uv: $o] :
              ( ( X2
                = ( vEBT_Leaf @ Uu @ Uv ) )
             => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_VEBT_valid_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Leaf @ Uu @ Uv ) @ Xa2 ) )
               => ( Xa2
                  = ( one_one @ nat ) ) ) )
         => ~ ! [Mima: option @ ( product_prod @ nat @ nat ),Deg2: nat,TreeList2: list @ vEBT_VEBT,Summary2: vEBT_VEBT] :
                ( ( X2
                  = ( vEBT_Node @ Mima @ Deg2 @ TreeList2 @ Summary2 ) )
               => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_VEBT_valid_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ Mima @ Deg2 @ TreeList2 @ Summary2 ) @ Xa2 ) )
                 => ( ( Deg2 = Xa2 )
                    & ! [X3: vEBT_VEBT] :
                        ( ( member @ vEBT_VEBT @ X3 @ ( set2 @ vEBT_VEBT @ TreeList2 ) )
                       => ( vEBT_VEBT_valid @ X3 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
                    & ( vEBT_VEBT_valid @ Summary2 @ ( minus_minus @ nat @ Deg2 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
                    & ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 )
                      = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ Deg2 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                    & ( case_option @ $o @ ( product_prod @ nat @ nat )
                      @ ( ~ ? [X4: nat] : ( vEBT_V8194947554948674370ptions @ Summary2 @ X4 )
                        & ! [X5: vEBT_VEBT] :
                            ( ( member @ vEBT_VEBT @ X5 @ ( set2 @ vEBT_VEBT @ TreeList2 ) )
                           => ~ ? [X4: nat] : ( vEBT_V8194947554948674370ptions @ X5 @ X4 ) ) )
                      @ ( product_case_prod @ nat @ nat @ $o
                        @ ^ [Mi3: nat,Ma3: nat] :
                            ( ( ord_less_eq @ nat @ Mi3 @ Ma3 )
                            & ( ord_less @ nat @ Ma3 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg2 ) )
                            & ! [I4: nat] :
                                ( ( ord_less @ nat @ I4 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ Deg2 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                               => ( ( ? [X4: nat] : ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList2 @ I4 ) @ X4 ) )
                                  = ( vEBT_V8194947554948674370ptions @ Summary2 @ I4 ) ) )
                            & ( ( Mi3 = Ma3 )
                             => ! [X5: vEBT_VEBT] :
                                  ( ( member @ vEBT_VEBT @ X5 @ ( set2 @ vEBT_VEBT @ TreeList2 ) )
                                 => ~ ? [X4: nat] : ( vEBT_V8194947554948674370ptions @ X5 @ X4 ) ) )
                            & ( ( Mi3 != Ma3 )
                             => ( ( vEBT_V5917875025757280293ildren @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ TreeList2 @ Ma3 )
                                & ! [X5: nat] :
                                    ( ( ord_less @ nat @ X5 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg2 ) )
                                   => ( ( vEBT_V5917875025757280293ildren @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ TreeList2 @ X5 )
                                     => ( ( ord_less @ nat @ Mi3 @ X5 )
                                        & ( ord_less_eq @ nat @ X5 @ Ma3 ) ) ) ) ) ) ) )
                      @ Mima ) ) ) ) ) ) ) ).

% VEBT_internal.valid'.pelims(3)
thf(fact_7160_finite__Inf__Sup,axiom,
    ! [A: $tType] :
      ( ( finite8700451911770168679attice @ A )
     => ! [A3: set @ ( set @ A )] :
          ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ ( image @ ( set @ A ) @ A @ ( complete_Sup_Sup @ A ) @ A3 ) )
          @ ( complete_Sup_Sup @ A
            @ ( image @ ( set @ A ) @ A @ ( complete_Inf_Inf @ A )
              @ ( collect @ ( set @ A )
                @ ^ [Uu3: set @ A] :
                  ? [F5: ( set @ A ) > A] :
                    ( ( Uu3
                      = ( image @ ( set @ A ) @ A @ F5 @ A3 ) )
                    & ! [X5: set @ A] :
                        ( ( member @ ( set @ A ) @ X5 @ A3 )
                       => ( member @ A @ ( F5 @ X5 ) @ X5 ) ) ) ) ) ) ) ) ).

% finite_Inf_Sup
thf(fact_7161_lexn__conv,axiom,
    ! [A: $tType] :
      ( ( lexn @ A )
      = ( ^ [R5: set @ ( product_prod @ A @ A ),N3: nat] :
            ( collect @ ( product_prod @ ( list @ A ) @ ( list @ A ) )
            @ ( product_case_prod @ ( list @ A ) @ ( list @ A ) @ $o
              @ ^ [Xs3: list @ A,Ys3: list @ A] :
                  ( ( ( size_size @ ( list @ A ) @ Xs3 )
                    = N3 )
                  & ( ( size_size @ ( list @ A ) @ Ys3 )
                    = N3 )
                  & ? [Xys: list @ A,X5: A,Y5: A,Xs6: list @ A,Ys7: list @ A] :
                      ( ( Xs3
                        = ( append @ A @ Xys @ ( cons @ A @ X5 @ Xs6 ) ) )
                      & ( Ys3
                        = ( append @ A @ Xys @ ( cons @ A @ Y5 @ Ys7 ) ) )
                      & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X5 @ Y5 ) @ R5 ) ) ) ) ) ) ) ).

% lexn_conv
thf(fact_7162_lexn_Osimps_I1_J,axiom,
    ! [A: $tType,R3: set @ ( product_prod @ A @ A )] :
      ( ( lexn @ A @ R3 @ ( zero_zero @ nat ) )
      = ( bot_bot @ ( set @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) ) ) ) ).

% lexn.simps(1)
thf(fact_7163_lexn__length,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A,R3: set @ ( product_prod @ A @ A ),N2: nat] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Ys ) @ ( lexn @ A @ R3 @ N2 ) )
     => ( ( ( size_size @ ( list @ A ) @ Xs )
          = N2 )
        & ( ( size_size @ ( list @ A ) @ Ys )
          = N2 ) ) ) ).

% lexn_length
thf(fact_7164_lex__conv,axiom,
    ! [A: $tType] :
      ( ( lex @ A )
      = ( ^ [R5: set @ ( product_prod @ A @ A )] :
            ( collect @ ( product_prod @ ( list @ A ) @ ( list @ A ) )
            @ ( product_case_prod @ ( list @ A ) @ ( list @ A ) @ $o
              @ ^ [Xs3: list @ A,Ys3: list @ A] :
                  ( ( ( size_size @ ( list @ A ) @ Xs3 )
                    = ( size_size @ ( list @ A ) @ Ys3 ) )
                  & ? [Xys: list @ A,X5: A,Y5: A,Xs6: list @ A,Ys7: list @ A] :
                      ( ( Xs3
                        = ( append @ A @ Xys @ ( cons @ A @ X5 @ Xs6 ) ) )
                      & ( Ys3
                        = ( append @ A @ Xys @ ( cons @ A @ Y5 @ Ys7 ) ) )
                      & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X5 @ Y5 ) @ R5 ) ) ) ) ) ) ) ).

% lex_conv
thf(fact_7165_mlex__eq,axiom,
    ! [A: $tType] :
      ( ( mlex_prod @ A )
      = ( ^ [F5: A > nat,R6: set @ ( product_prod @ A @ A )] :
            ( collect @ ( product_prod @ A @ A )
            @ ( product_case_prod @ A @ A @ $o
              @ ^ [X5: A,Y5: A] :
                  ( ( ord_less @ nat @ ( F5 @ X5 ) @ ( F5 @ Y5 ) )
                  | ( ( ord_less_eq @ nat @ ( F5 @ X5 ) @ ( F5 @ Y5 ) )
                    & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X5 @ Y5 ) @ R6 ) ) ) ) ) ) ) ).

% mlex_eq
thf(fact_7166_Cons__in__lex,axiom,
    ! [A: $tType,X2: A,Xs: list @ A,Y2: A,Ys: list @ A,R3: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X2 @ Xs ) @ ( cons @ A @ Y2 @ Ys ) ) @ ( lex @ A @ R3 ) )
      = ( ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ Y2 ) @ R3 )
          & ( ( size_size @ ( list @ A ) @ Xs )
            = ( size_size @ ( list @ A ) @ Ys ) ) )
        | ( ( X2 = Y2 )
          & ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Ys ) @ ( lex @ A @ R3 ) ) ) ) ) ).

% Cons_in_lex
thf(fact_7167_Nil2__notin__lex,axiom,
    ! [A: $tType,Xs: list @ A,R3: set @ ( product_prod @ A @ A )] :
      ~ ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ ( nil @ A ) ) @ ( lex @ A @ R3 ) ) ).

% Nil2_notin_lex
thf(fact_7168_Nil__notin__lex,axiom,
    ! [A: $tType,Ys: list @ A,R3: set @ ( product_prod @ A @ A )] :
      ~ ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( nil @ A ) @ Ys ) @ ( lex @ A @ R3 ) ) ).

% Nil_notin_lex
thf(fact_7169_lex__append__leftI,axiom,
    ! [A: $tType,Ys: list @ A,Zs: list @ A,R3: set @ ( product_prod @ A @ A ),Xs: list @ A] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Ys @ Zs ) @ ( lex @ A @ R3 ) )
     => ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( append @ A @ Xs @ Ys ) @ ( append @ A @ Xs @ Zs ) ) @ ( lex @ A @ R3 ) ) ) ).

% lex_append_leftI
thf(fact_7170_lex__def,axiom,
    ! [A: $tType] :
      ( ( lex @ A )
      = ( ^ [R5: set @ ( product_prod @ A @ A )] : ( complete_Sup_Sup @ ( set @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) ) @ ( image @ nat @ ( set @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) ) @ ( lexn @ A @ R5 ) @ ( top_top @ ( set @ nat ) ) ) ) ) ) ).

% lex_def
thf(fact_7171_lex__append__leftD,axiom,
    ! [A: $tType,R3: set @ ( product_prod @ A @ A ),Xs: list @ A,Ys: list @ A,Zs: list @ A] :
      ( ! [X3: A] :
          ~ ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X3 @ X3 ) @ R3 )
     => ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( append @ A @ Xs @ Ys ) @ ( append @ A @ Xs @ Zs ) ) @ ( lex @ A @ R3 ) )
       => ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Ys @ Zs ) @ ( lex @ A @ R3 ) ) ) ) ).

% lex_append_leftD
thf(fact_7172_lex__append__left__iff,axiom,
    ! [A: $tType,R3: set @ ( product_prod @ A @ A ),Xs: list @ A,Ys: list @ A,Zs: list @ A] :
      ( ! [X3: A] :
          ~ ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X3 @ X3 ) @ R3 )
     => ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( append @ A @ Xs @ Ys ) @ ( append @ A @ Xs @ Zs ) ) @ ( lex @ A @ R3 ) )
        = ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Ys @ Zs ) @ ( lex @ A @ R3 ) ) ) ) ).

% lex_append_left_iff
thf(fact_7173_lex__append__rightI,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A,R3: set @ ( product_prod @ A @ A ),Vs: list @ A,Us: list @ A] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Ys ) @ ( lex @ A @ R3 ) )
     => ( ( ( size_size @ ( list @ A ) @ Vs )
          = ( size_size @ ( list @ A ) @ Us ) )
       => ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( append @ A @ Xs @ Us ) @ ( append @ A @ Ys @ Vs ) ) @ ( lex @ A @ R3 ) ) ) ) ).

% lex_append_rightI
thf(fact_7174_mlex__iff,axiom,
    ! [A: $tType,X2: A,Y2: A,F2: A > nat,R: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ Y2 ) @ ( mlex_prod @ A @ F2 @ R ) )
      = ( ( ord_less @ nat @ ( F2 @ X2 ) @ ( F2 @ Y2 ) )
        | ( ( ( F2 @ X2 )
            = ( F2 @ Y2 ) )
          & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ Y2 ) @ R ) ) ) ) ).

% mlex_iff
thf(fact_7175_mlex__less,axiom,
    ! [A: $tType,F2: A > nat,X2: A,Y2: A,R: set @ ( product_prod @ A @ A )] :
      ( ( ord_less @ nat @ ( F2 @ X2 ) @ ( F2 @ Y2 ) )
     => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ Y2 ) @ ( mlex_prod @ A @ F2 @ R ) ) ) ).

% mlex_less
thf(fact_7176_mlex__leq,axiom,
    ! [A: $tType,F2: A > nat,X2: A,Y2: A,R: set @ ( product_prod @ A @ A )] :
      ( ( ord_less_eq @ nat @ ( F2 @ X2 ) @ ( F2 @ Y2 ) )
     => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ Y2 ) @ R )
       => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ Y2 ) @ ( mlex_prod @ A @ F2 @ R ) ) ) ) ).

% mlex_leq
thf(fact_7177_map__filter__on__comp,axiom,
    ! [A: $tType,C: $tType,B: $tType,G: B > A,Y8: set @ B,X8: set @ A,F3: filter @ B,F2: A > C] :
      ( ( ord_less_eq @ ( set @ A ) @ ( image @ B @ A @ G @ Y8 ) @ X8 )
     => ( ( eventually @ B
          @ ^ [X5: B] : ( member @ B @ X5 @ Y8 )
          @ F3 )
       => ( ( map_filter_on @ A @ C @ X8 @ F2 @ ( map_filter_on @ B @ A @ Y8 @ G @ F3 ) )
          = ( map_filter_on @ B @ C @ Y8 @ ( comp @ A @ C @ B @ F2 @ G ) @ F3 ) ) ) ) ).

% map_filter_on_comp
thf(fact_7178_cauchy__filter__metric,axiom,
    ! [A: $tType] :
      ( ( ( real_V768167426530841204y_dist @ A )
        & ( topolo7287701948861334536_space @ A ) )
     => ( ( topolo6773858410816713723filter @ A )
        = ( ^ [F9: filter @ A] :
            ! [E4: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ E4 )
             => ? [P3: A > $o] :
                  ( ( eventually @ A @ P3 @ F9 )
                  & ! [X5: A,Y5: A] :
                      ( ( ( P3 @ X5 )
                        & ( P3 @ Y5 ) )
                     => ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X5 @ Y5 ) @ E4 ) ) ) ) ) ) ) ).

% cauchy_filter_metric
thf(fact_7179_nhds__imp__cauchy__filter,axiom,
    ! [A: $tType] :
      ( ( topolo7287701948861334536_space @ A )
     => ! [F3: filter @ A,X2: A] :
          ( ( ord_less_eq @ ( filter @ A ) @ F3 @ ( topolo7230453075368039082e_nhds @ A @ X2 ) )
         => ( topolo6773858410816713723filter @ A @ F3 ) ) ) ).

% nhds_imp_cauchy_filter
thf(fact_7180_GMVT,axiom,
    ! [A2: real,B2: real,F2: real > real,G: real > real] :
      ( ( ord_less @ real @ A2 @ B2 )
     => ( ! [X3: real] :
            ( ( ( ord_less_eq @ real @ A2 @ X3 )
              & ( ord_less_eq @ real @ X3 @ B2 ) )
           => ( topolo3448309680560233919inuous @ real @ real @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) @ F2 ) )
       => ( ! [X3: real] :
              ( ( ( ord_less @ real @ A2 @ X3 )
                & ( ord_less @ real @ X3 @ B2 ) )
             => ( differentiable @ real @ real @ F2 @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) ) )
         => ( ! [X3: real] :
                ( ( ( ord_less_eq @ real @ A2 @ X3 )
                  & ( ord_less_eq @ real @ X3 @ B2 ) )
               => ( topolo3448309680560233919inuous @ real @ real @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) @ G ) )
           => ( ! [X3: real] :
                  ( ( ( ord_less @ real @ A2 @ X3 )
                    & ( ord_less @ real @ X3 @ B2 ) )
                 => ( differentiable @ real @ real @ G @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) ) )
             => ? [G_c: real,F_c: real,C3: real] :
                  ( ( has_field_derivative @ real @ G @ G_c @ ( topolo174197925503356063within @ real @ C3 @ ( top_top @ ( set @ real ) ) ) )
                  & ( has_field_derivative @ real @ F2 @ F_c @ ( topolo174197925503356063within @ real @ C3 @ ( top_top @ ( set @ real ) ) ) )
                  & ( ord_less @ real @ A2 @ C3 )
                  & ( ord_less @ real @ C3 @ B2 )
                  & ( ( times_times @ real @ ( minus_minus @ real @ ( F2 @ B2 ) @ ( F2 @ A2 ) ) @ G_c )
                    = ( times_times @ real @ ( minus_minus @ real @ ( G @ B2 ) @ ( G @ A2 ) ) @ F_c ) ) ) ) ) ) ) ) ).

% GMVT
thf(fact_7181_lenlex__conv,axiom,
    ! [A: $tType] :
      ( ( lenlex @ A )
      = ( ^ [R5: set @ ( product_prod @ A @ A )] :
            ( collect @ ( product_prod @ ( list @ A ) @ ( list @ A ) )
            @ ( product_case_prod @ ( list @ A ) @ ( list @ A ) @ $o
              @ ^ [Xs3: list @ A,Ys3: list @ A] :
                  ( ( ord_less @ nat @ ( size_size @ ( list @ A ) @ Xs3 ) @ ( size_size @ ( list @ A ) @ Ys3 ) )
                  | ( ( ( size_size @ ( list @ A ) @ Xs3 )
                      = ( size_size @ ( list @ A ) @ Ys3 ) )
                    & ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs3 @ Ys3 ) @ ( lex @ A @ R5 ) ) ) ) ) ) ) ) ).

% lenlex_conv
thf(fact_7182_Nil__lenlex__iff1,axiom,
    ! [A: $tType,Ns: list @ A,R3: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( nil @ A ) @ Ns ) @ ( lenlex @ A @ R3 ) )
      = ( ( Ns
         != ( nil @ A ) ) ) ) ).

% Nil_lenlex_iff1
thf(fact_7183_differentiable__cmult__left__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( real_V822414075346904944vector @ B )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [C2: A,Q3: B > A,T2: B] :
          ( ( differentiable @ B @ A
            @ ^ [T3: B] : ( times_times @ A @ C2 @ ( Q3 @ T3 ) )
            @ ( topolo174197925503356063within @ B @ T2 @ ( top_top @ ( set @ B ) ) ) )
          = ( ( C2
              = ( zero_zero @ A ) )
            | ( differentiable @ B @ A @ Q3 @ ( topolo174197925503356063within @ B @ T2 @ ( top_top @ ( set @ B ) ) ) ) ) ) ) ).

% differentiable_cmult_left_iff
thf(fact_7184_differentiable__cmult__right__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( real_V822414075346904944vector @ B )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [Q3: B > A,C2: A,T2: B] :
          ( ( differentiable @ B @ A
            @ ^ [T3: B] : ( times_times @ A @ ( Q3 @ T3 ) @ C2 )
            @ ( topolo174197925503356063within @ B @ T2 @ ( top_top @ ( set @ B ) ) ) )
          = ( ( C2
              = ( zero_zero @ A ) )
            | ( differentiable @ B @ A @ Q3 @ ( topolo174197925503356063within @ B @ T2 @ ( top_top @ ( set @ B ) ) ) ) ) ) ) ).

% differentiable_cmult_right_iff
thf(fact_7185_differentiable__within__subset,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F2: A > B,X2: A,S2: set @ A,T2: set @ A] :
          ( ( differentiable @ A @ B @ F2 @ ( topolo174197925503356063within @ A @ X2 @ S2 ) )
         => ( ( ord_less_eq @ ( set @ A ) @ T2 @ S2 )
           => ( differentiable @ A @ B @ F2 @ ( topolo174197925503356063within @ A @ X2 @ T2 ) ) ) ) ) ).

% differentiable_within_subset
thf(fact_7186_differentiable__add,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F2: A > B,F3: filter @ A,G: A > B] :
          ( ( differentiable @ A @ B @ F2 @ F3 )
         => ( ( differentiable @ A @ B @ G @ F3 )
           => ( differentiable @ A @ B
              @ ^ [X5: A] : ( plus_plus @ B @ ( F2 @ X5 ) @ ( G @ X5 ) )
              @ F3 ) ) ) ) ).

% differentiable_add
thf(fact_7187_differentiable__power,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V3459762299906320749_field @ B ) )
     => ! [F2: A > B,X2: A,S2: set @ A,N2: nat] :
          ( ( differentiable @ A @ B @ F2 @ ( topolo174197925503356063within @ A @ X2 @ S2 ) )
         => ( differentiable @ A @ B
            @ ^ [X5: A] : ( power_power @ B @ ( F2 @ X5 ) @ N2 )
            @ ( topolo174197925503356063within @ A @ X2 @ S2 ) ) ) ) ).

% differentiable_power
thf(fact_7188_differentiable__mult,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V4412858255891104859lgebra @ B ) )
     => ! [F2: A > B,X2: A,S2: set @ A,G: A > B] :
          ( ( differentiable @ A @ B @ F2 @ ( topolo174197925503356063within @ A @ X2 @ S2 ) )
         => ( ( differentiable @ A @ B @ G @ ( topolo174197925503356063within @ A @ X2 @ S2 ) )
           => ( differentiable @ A @ B
              @ ^ [X5: A] : ( times_times @ B @ ( F2 @ X5 ) @ ( G @ X5 ) )
              @ ( topolo174197925503356063within @ A @ X2 @ S2 ) ) ) ) ) ).

% differentiable_mult
thf(fact_7189_lenlex__irreflexive,axiom,
    ! [A: $tType,R3: set @ ( product_prod @ A @ A ),Xs: list @ A] :
      ( ! [X3: A] :
          ~ ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X3 @ X3 ) @ R3 )
     => ~ ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Xs ) @ ( lenlex @ A @ R3 ) ) ) ).

% lenlex_irreflexive
thf(fact_7190_Nil__lenlex__iff2,axiom,
    ! [A: $tType,Ns: list @ A,R3: set @ ( product_prod @ A @ A )] :
      ~ ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Ns @ ( nil @ A ) ) @ ( lenlex @ A @ R3 ) ) ).

% Nil_lenlex_iff2
thf(fact_7191_differentiable__divide,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V3459762299906320749_field @ B ) )
     => ! [F2: A > B,X2: A,S2: set @ A,G: A > B] :
          ( ( differentiable @ A @ B @ F2 @ ( topolo174197925503356063within @ A @ X2 @ S2 ) )
         => ( ( differentiable @ A @ B @ G @ ( topolo174197925503356063within @ A @ X2 @ S2 ) )
           => ( ( ( G @ X2 )
               != ( zero_zero @ B ) )
             => ( differentiable @ A @ B
                @ ^ [X5: A] : ( divide_divide @ B @ ( F2 @ X5 ) @ ( G @ X5 ) )
                @ ( topolo174197925503356063within @ A @ X2 @ S2 ) ) ) ) ) ) ).

% differentiable_divide
thf(fact_7192_differentiable__inverse,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V3459762299906320749_field @ B ) )
     => ! [F2: A > B,X2: A,S2: set @ A] :
          ( ( differentiable @ A @ B @ F2 @ ( topolo174197925503356063within @ A @ X2 @ S2 ) )
         => ( ( ( F2 @ X2 )
             != ( zero_zero @ B ) )
           => ( differentiable @ A @ B
              @ ^ [X5: A] : ( inverse_inverse @ B @ ( F2 @ X5 ) )
              @ ( topolo174197925503356063within @ A @ X2 @ S2 ) ) ) ) ) ).

% differentiable_inverse
thf(fact_7193_lenlex__length,axiom,
    ! [A: $tType,Ms: list @ A,Ns: list @ A,R3: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Ms @ Ns ) @ ( lenlex @ A @ R3 ) )
     => ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ Ms ) @ ( size_size @ ( list @ A ) @ Ns ) ) ) ).

% lenlex_length
thf(fact_7194_lenlex__append1,axiom,
    ! [A: $tType,Us: list @ A,Xs: list @ A,R: set @ ( product_prod @ A @ A ),Vs: list @ A,Ys: list @ A] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Us @ Xs ) @ ( lenlex @ A @ R ) )
     => ( ( ( size_size @ ( list @ A ) @ Vs )
          = ( size_size @ ( list @ A ) @ Ys ) )
       => ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( append @ A @ Us @ Vs ) @ ( append @ A @ Xs @ Ys ) ) @ ( lenlex @ A @ R ) ) ) ) ).

% lenlex_append1
thf(fact_7195_Cons__lenlex__iff,axiom,
    ! [A: $tType,M: A,Ms: list @ A,N2: A,Ns: list @ A,R3: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ M @ Ms ) @ ( cons @ A @ N2 @ Ns ) ) @ ( lenlex @ A @ R3 ) )
      = ( ( ord_less @ nat @ ( size_size @ ( list @ A ) @ Ms ) @ ( size_size @ ( list @ A ) @ Ns ) )
        | ( ( ( size_size @ ( list @ A ) @ Ms )
            = ( size_size @ ( list @ A ) @ Ns ) )
          & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ M @ N2 ) @ R3 ) )
        | ( ( M = N2 )
          & ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Ms @ Ns ) @ ( lenlex @ A @ R3 ) ) ) ) ) ).

% Cons_lenlex_iff
thf(fact_7196_MVT,axiom,
    ! [A2: real,B2: real,F2: real > real] :
      ( ( ord_less @ real @ A2 @ B2 )
     => ( ( topolo81223032696312382ous_on @ real @ real @ ( set_or1337092689740270186AtMost @ real @ A2 @ B2 ) @ F2 )
       => ( ! [X3: real] :
              ( ( ord_less @ real @ A2 @ X3 )
             => ( ( ord_less @ real @ X3 @ B2 )
               => ( differentiable @ real @ real @ F2 @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) ) ) )
         => ? [L4: real,Z3: real] :
              ( ( ord_less @ real @ A2 @ Z3 )
              & ( ord_less @ real @ Z3 @ B2 )
              & ( has_field_derivative @ real @ F2 @ L4 @ ( topolo174197925503356063within @ real @ Z3 @ ( top_top @ ( set @ real ) ) ) )
              & ( ( minus_minus @ real @ ( F2 @ B2 ) @ ( F2 @ A2 ) )
                = ( times_times @ real @ ( minus_minus @ real @ B2 @ A2 ) @ L4 ) ) ) ) ) ) ).

% MVT
thf(fact_7197_lexord__def,axiom,
    ! [A: $tType] :
      ( ( lexord @ A )
      = ( ^ [R5: set @ ( product_prod @ A @ A )] :
            ( collect @ ( product_prod @ ( list @ A ) @ ( list @ A ) )
            @ ( product_case_prod @ ( list @ A ) @ ( list @ A ) @ $o
              @ ^ [X5: list @ A,Y5: list @ A] :
                ? [A4: A,V5: list @ A] :
                  ( ( Y5
                    = ( append @ A @ X5 @ ( cons @ A @ A4 @ V5 ) ) )
                  | ? [U2: list @ A,B4: A,C4: A,W3: list @ A,Z6: list @ A] :
                      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ B4 @ C4 ) @ R5 )
                      & ( X5
                        = ( append @ A @ U2 @ ( cons @ A @ B4 @ W3 ) ) )
                      & ( Y5
                        = ( append @ A @ U2 @ ( cons @ A @ C4 @ Z6 ) ) ) ) ) ) ) ) ) ).

% lexord_def
thf(fact_7198_lexord__cons__cons,axiom,
    ! [A: $tType,A2: A,X2: list @ A,B2: A,Y2: list @ A,R3: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ A2 @ X2 ) @ ( cons @ A @ B2 @ Y2 ) ) @ ( lexord @ A @ R3 ) )
      = ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ B2 ) @ R3 )
        | ( ( A2 = B2 )
          & ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ X2 @ Y2 ) @ ( lexord @ A @ R3 ) ) ) ) ) ).

% lexord_cons_cons
thf(fact_7199_lexord__Nil__left,axiom,
    ! [A: $tType,Y2: list @ A,R3: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( nil @ A ) @ Y2 ) @ ( lexord @ A @ R3 ) )
      = ( ? [A4: A,X5: list @ A] :
            ( Y2
            = ( cons @ A @ A4 @ X5 ) ) ) ) ).

% lexord_Nil_left
thf(fact_7200_continuous__on__sgn,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topolo4958980785337419405_space @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [S2: set @ A,F2: A > B] :
          ( ( topolo81223032696312382ous_on @ A @ B @ S2 @ F2 )
         => ( ! [X3: A] :
                ( ( member @ A @ X3 @ S2 )
               => ( ( F2 @ X3 )
                 != ( zero_zero @ B ) ) )
           => ( topolo81223032696312382ous_on @ A @ B @ S2
              @ ^ [X5: A] : ( sgn_sgn @ B @ ( F2 @ X5 ) ) ) ) ) ) ).

% continuous_on_sgn
thf(fact_7201_continuous__on__inverse,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topolo4958980785337419405_space @ A )
        & ( real_V8999393235501362500lgebra @ B ) )
     => ! [S2: set @ A,F2: A > B] :
          ( ( topolo81223032696312382ous_on @ A @ B @ S2 @ F2 )
         => ( ! [X3: A] :
                ( ( member @ A @ X3 @ S2 )
               => ( ( F2 @ X3 )
                 != ( zero_zero @ B ) ) )
           => ( topolo81223032696312382ous_on @ A @ B @ S2
              @ ^ [X5: A] : ( inverse_inverse @ B @ ( F2 @ X5 ) ) ) ) ) ) ).

% continuous_on_inverse
thf(fact_7202_continuous__on__add,axiom,
    ! [B: $tType,D: $tType] :
      ( ( ( topolo4958980785337419405_space @ D )
        & ( topolo6943815403480290642id_add @ B ) )
     => ! [S2: set @ D,F2: D > B,G: D > B] :
          ( ( topolo81223032696312382ous_on @ D @ B @ S2 @ F2 )
         => ( ( topolo81223032696312382ous_on @ D @ B @ S2 @ G )
           => ( topolo81223032696312382ous_on @ D @ B @ S2
              @ ^ [X5: D] : ( plus_plus @ B @ ( F2 @ X5 ) @ ( G @ X5 ) ) ) ) ) ) ).

% continuous_on_add
thf(fact_7203_continuous__on__power,axiom,
    ! [B: $tType,C: $tType] :
      ( ( ( topolo4958980785337419405_space @ C )
        & ( power @ B )
        & ( real_V4412858255891104859lgebra @ B ) )
     => ! [S2: set @ C,F2: C > B,N2: nat] :
          ( ( topolo81223032696312382ous_on @ C @ B @ S2 @ F2 )
         => ( topolo81223032696312382ous_on @ C @ B @ S2
            @ ^ [X5: C] : ( power_power @ B @ ( F2 @ X5 ) @ N2 ) ) ) ) ).

% continuous_on_power
thf(fact_7204_continuous__on__power_H,axiom,
    ! [B: $tType,C: $tType] :
      ( ( ( topolo4958980785337419405_space @ C )
        & ( topolo1898628316856586783d_mult @ B ) )
     => ! [A3: set @ C,F2: C > B,G: C > nat] :
          ( ( topolo81223032696312382ous_on @ C @ B @ A3 @ F2 )
         => ( ( topolo81223032696312382ous_on @ C @ nat @ A3 @ G )
           => ( topolo81223032696312382ous_on @ C @ B @ A3
              @ ^ [X5: C] : ( power_power @ B @ ( F2 @ X5 ) @ ( G @ X5 ) ) ) ) ) ) ).

% continuous_on_power'
thf(fact_7205_continuous__on__mult__const,axiom,
    ! [A: $tType] :
      ( ( real_V4412858255891104859lgebra @ A )
     => ! [S2: set @ A,C2: A] : ( topolo81223032696312382ous_on @ A @ A @ S2 @ ( times_times @ A @ C2 ) ) ) ).

% continuous_on_mult_const
thf(fact_7206_continuous__on__mult__right,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( topolo4958980785337419405_space @ B )
        & ( real_V4412858255891104859lgebra @ A ) )
     => ! [S2: set @ B,F2: B > A,C2: A] :
          ( ( topolo81223032696312382ous_on @ B @ A @ S2 @ F2 )
         => ( topolo81223032696312382ous_on @ B @ A @ S2
            @ ^ [X5: B] : ( times_times @ A @ ( F2 @ X5 ) @ C2 ) ) ) ) ).

% continuous_on_mult_right
thf(fact_7207_continuous__on__mult__left,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( topolo4958980785337419405_space @ B )
        & ( real_V4412858255891104859lgebra @ A ) )
     => ! [S2: set @ B,F2: B > A,C2: A] :
          ( ( topolo81223032696312382ous_on @ B @ A @ S2 @ F2 )
         => ( topolo81223032696312382ous_on @ B @ A @ S2
            @ ^ [X5: B] : ( times_times @ A @ C2 @ ( F2 @ X5 ) ) ) ) ) ).

% continuous_on_mult_left
thf(fact_7208_continuous__on__mult_H,axiom,
    ! [B: $tType,D: $tType] :
      ( ( ( topolo4958980785337419405_space @ D )
        & ( topolo4211221413907600880p_mult @ B ) )
     => ! [A3: set @ D,F2: D > B,G: D > B] :
          ( ( topolo81223032696312382ous_on @ D @ B @ A3 @ F2 )
         => ( ( topolo81223032696312382ous_on @ D @ B @ A3 @ G )
           => ( topolo81223032696312382ous_on @ D @ B @ A3
              @ ^ [X5: D] : ( times_times @ B @ ( F2 @ X5 ) @ ( G @ X5 ) ) ) ) ) ) ).

% continuous_on_mult'
thf(fact_7209_continuous__on__mult,axiom,
    ! [A: $tType,D: $tType] :
      ( ( ( topolo4958980785337419405_space @ D )
        & ( real_V4412858255891104859lgebra @ A ) )
     => ! [S2: set @ D,F2: D > A,G: D > A] :
          ( ( topolo81223032696312382ous_on @ D @ A @ S2 @ F2 )
         => ( ( topolo81223032696312382ous_on @ D @ A @ S2 @ G )
           => ( topolo81223032696312382ous_on @ D @ A @ S2
              @ ^ [X5: D] : ( times_times @ A @ ( F2 @ X5 ) @ ( G @ X5 ) ) ) ) ) ) ).

% continuous_on_mult
thf(fact_7210_continuous__on__divide,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topolo4958980785337419405_space @ A )
        & ( real_V3459762299906320749_field @ B ) )
     => ! [S2: set @ A,F2: A > B,G: A > B] :
          ( ( topolo81223032696312382ous_on @ A @ B @ S2 @ F2 )
         => ( ( topolo81223032696312382ous_on @ A @ B @ S2 @ G )
           => ( ! [X3: A] :
                  ( ( member @ A @ X3 @ S2 )
                 => ( ( G @ X3 )
                   != ( zero_zero @ B ) ) )
             => ( topolo81223032696312382ous_on @ A @ B @ S2
                @ ^ [X5: A] : ( divide_divide @ B @ ( F2 @ X5 ) @ ( G @ X5 ) ) ) ) ) ) ) ).

% continuous_on_divide
thf(fact_7211_continuous__on__ln,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [S2: set @ A,F2: A > real] :
          ( ( topolo81223032696312382ous_on @ A @ real @ S2 @ F2 )
         => ( ! [X3: A] :
                ( ( member @ A @ X3 @ S2 )
               => ( ( F2 @ X3 )
                 != ( zero_zero @ real ) ) )
           => ( topolo81223032696312382ous_on @ A @ real @ S2
              @ ^ [X5: A] : ( ln_ln @ real @ ( F2 @ X5 ) ) ) ) ) ) ).

% continuous_on_ln
thf(fact_7212_continuous__on__powr,axiom,
    ! [C: $tType] :
      ( ( topolo4958980785337419405_space @ C )
     => ! [S2: set @ C,F2: C > real,G: C > real] :
          ( ( topolo81223032696312382ous_on @ C @ real @ S2 @ F2 )
         => ( ( topolo81223032696312382ous_on @ C @ real @ S2 @ G )
           => ( ! [X3: C] :
                  ( ( member @ C @ X3 @ S2 )
                 => ( ( F2 @ X3 )
                   != ( zero_zero @ real ) ) )
             => ( topolo81223032696312382ous_on @ C @ real @ S2
                @ ^ [X5: C] : ( powr @ real @ ( F2 @ X5 ) @ ( G @ X5 ) ) ) ) ) ) ) ).

% continuous_on_powr
thf(fact_7213_lexord__append__leftI,axiom,
    ! [A: $tType,U: list @ A,V: list @ A,R3: set @ ( product_prod @ A @ A ),X2: list @ A] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ U @ V ) @ ( lexord @ A @ R3 ) )
     => ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( append @ A @ X2 @ U ) @ ( append @ A @ X2 @ V ) ) @ ( lexord @ A @ R3 ) ) ) ).

% lexord_append_leftI
thf(fact_7214_lexord__irreflexive,axiom,
    ! [A: $tType,R3: set @ ( product_prod @ A @ A ),Xs: list @ A] :
      ( ! [X3: A] :
          ~ ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X3 @ X3 ) @ R3 )
     => ~ ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Xs ) @ ( lexord @ A @ R3 ) ) ) ).

% lexord_irreflexive
thf(fact_7215_lexord__linear,axiom,
    ! [A: $tType,R3: set @ ( product_prod @ A @ A ),X2: list @ A,Y2: list @ A] :
      ( ! [A5: A,B5: A] :
          ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A5 @ B5 ) @ R3 )
          | ( A5 = B5 )
          | ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ B5 @ A5 ) @ R3 ) )
     => ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ X2 @ Y2 ) @ ( lexord @ A @ R3 ) )
        | ( X2 = Y2 )
        | ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Y2 @ X2 ) @ ( lexord @ A @ R3 ) ) ) ) ).

% lexord_linear
thf(fact_7216_continuous__on__Pair,axiom,
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( ( topolo4958980785337419405_space @ A )
        & ( topolo4958980785337419405_space @ B )
        & ( topolo4958980785337419405_space @ C ) )
     => ! [S2: set @ A,F2: A > B,G: A > C] :
          ( ( topolo81223032696312382ous_on @ A @ B @ S2 @ F2 )
         => ( ( topolo81223032696312382ous_on @ A @ C @ S2 @ G )
           => ( topolo81223032696312382ous_on @ A @ ( product_prod @ B @ C ) @ S2
              @ ^ [X5: A] : ( product_Pair @ B @ C @ ( F2 @ X5 ) @ ( G @ X5 ) ) ) ) ) ) ).

% continuous_on_Pair
thf(fact_7217_lexord__Nil__right,axiom,
    ! [A: $tType,X2: list @ A,R3: set @ ( product_prod @ A @ A )] :
      ~ ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ X2 @ ( nil @ A ) ) @ ( lexord @ A @ R3 ) ) ).

% lexord_Nil_right
thf(fact_7218_IVT2_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( topolo1944317154257567458pology @ B )
        & ( topolo8458572112393995274pology @ A ) )
     => ! [F2: A > B,B2: A,Y2: B,A2: A] :
          ( ( ord_less_eq @ B @ ( F2 @ B2 ) @ Y2 )
         => ( ( ord_less_eq @ B @ Y2 @ ( F2 @ A2 ) )
           => ( ( ord_less_eq @ A @ A2 @ B2 )
             => ( ( topolo81223032696312382ous_on @ A @ B @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) @ F2 )
               => ? [X3: A] :
                    ( ( ord_less_eq @ A @ A2 @ X3 )
                    & ( ord_less_eq @ A @ X3 @ B2 )
                    & ( ( F2 @ X3 )
                      = Y2 ) ) ) ) ) ) ) ).

% IVT2'
thf(fact_7219_IVT_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( topolo1944317154257567458pology @ B )
        & ( topolo8458572112393995274pology @ A ) )
     => ! [F2: A > B,A2: A,Y2: B,B2: A] :
          ( ( ord_less_eq @ B @ ( F2 @ A2 ) @ Y2 )
         => ( ( ord_less_eq @ B @ Y2 @ ( F2 @ B2 ) )
           => ( ( ord_less_eq @ A @ A2 @ B2 )
             => ( ( topolo81223032696312382ous_on @ A @ B @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) @ F2 )
               => ? [X3: A] :
                    ( ( ord_less_eq @ A @ A2 @ X3 )
                    & ( ord_less_eq @ A @ X3 @ B2 )
                    & ( ( F2 @ X3 )
                      = Y2 ) ) ) ) ) ) ) ).

% IVT'
thf(fact_7220_continuous__on__subset,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topolo4958980785337419405_space @ A )
        & ( topolo4958980785337419405_space @ B ) )
     => ! [S2: set @ A,F2: A > B,T2: set @ A] :
          ( ( topolo81223032696312382ous_on @ A @ B @ S2 @ F2 )
         => ( ( ord_less_eq @ ( set @ A ) @ T2 @ S2 )
           => ( topolo81223032696312382ous_on @ A @ B @ T2 @ F2 ) ) ) ) ).

% continuous_on_subset
thf(fact_7221_continuous__onI__mono,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topolo1944317154257567458pology @ A )
        & ( dense_order @ B )
        & ( topolo1944317154257567458pology @ B ) )
     => ! [F2: A > B,A3: set @ A] :
          ( ( topolo1002775350975398744n_open @ B @ ( image @ A @ B @ F2 @ A3 ) )
         => ( ! [X3: A,Y4: A] :
                ( ( member @ A @ X3 @ A3 )
               => ( ( member @ A @ Y4 @ A3 )
                 => ( ( ord_less_eq @ A @ X3 @ Y4 )
                   => ( ord_less_eq @ B @ ( F2 @ X3 ) @ ( F2 @ Y4 ) ) ) ) )
           => ( topolo81223032696312382ous_on @ A @ B @ A3 @ F2 ) ) ) ) ).

% continuous_onI_mono
thf(fact_7222_continuous__on__compose2,axiom,
    ! [A: $tType,B: $tType,C: $tType] :
      ( ( ( topolo4958980785337419405_space @ C )
        & ( topolo4958980785337419405_space @ B )
        & ( topolo4958980785337419405_space @ A ) )
     => ! [T2: set @ A,G: A > B,S2: set @ C,F2: C > A] :
          ( ( topolo81223032696312382ous_on @ A @ B @ T2 @ G )
         => ( ( topolo81223032696312382ous_on @ C @ A @ S2 @ F2 )
           => ( ( ord_less_eq @ ( set @ A ) @ ( image @ C @ A @ F2 @ S2 ) @ T2 )
             => ( topolo81223032696312382ous_on @ C @ B @ S2
                @ ^ [X5: C] : ( G @ ( F2 @ X5 ) ) ) ) ) ) ) ).

% continuous_on_compose2
thf(fact_7223_open__Collect__less,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topolo4958980785337419405_space @ A )
        & ( topolo1944317154257567458pology @ B ) )
     => ! [F2: A > B,G: A > B] :
          ( ( topolo81223032696312382ous_on @ A @ B @ ( top_top @ ( set @ A ) ) @ F2 )
         => ( ( topolo81223032696312382ous_on @ A @ B @ ( top_top @ ( set @ A ) ) @ G )
           => ( topolo1002775350975398744n_open @ A
              @ ( collect @ A
                @ ^ [X5: A] : ( ord_less @ B @ ( F2 @ X5 ) @ ( G @ X5 ) ) ) ) ) ) ) ).

% open_Collect_less
thf(fact_7224_continuous__on__tan,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [S2: set @ A,F2: A > A] :
          ( ( topolo81223032696312382ous_on @ A @ A @ S2 @ F2 )
         => ( ! [X3: A] :
                ( ( member @ A @ X3 @ S2 )
               => ( ( cos @ A @ ( F2 @ X3 ) )
                 != ( zero_zero @ A ) ) )
           => ( topolo81223032696312382ous_on @ A @ A @ S2
              @ ^ [X5: A] : ( tan @ A @ ( F2 @ X5 ) ) ) ) ) ) ).

% continuous_on_tan
thf(fact_7225_open__Collect__less__Int,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [S2: set @ A,F2: A > real,G: A > real] :
          ( ( topolo81223032696312382ous_on @ A @ real @ S2 @ F2 )
         => ( ( topolo81223032696312382ous_on @ A @ real @ S2 @ G )
           => ? [A8: set @ A] :
                ( ( topolo1002775350975398744n_open @ A @ A8 )
                & ( ( inf_inf @ ( set @ A ) @ A8 @ S2 )
                  = ( collect @ A
                    @ ^ [X5: A] :
                        ( ( member @ A @ X5 @ S2 )
                        & ( ord_less @ real @ ( F2 @ X5 ) @ ( G @ X5 ) ) ) ) ) ) ) ) ) ).

% open_Collect_less_Int
thf(fact_7226_continuous__on__cot,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [S2: set @ A,F2: A > A] :
          ( ( topolo81223032696312382ous_on @ A @ A @ S2 @ F2 )
         => ( ! [X3: A] :
                ( ( member @ A @ X3 @ S2 )
               => ( ( sin @ A @ ( F2 @ X3 ) )
                 != ( zero_zero @ A ) ) )
           => ( topolo81223032696312382ous_on @ A @ A @ S2
              @ ^ [X5: A] : ( cot @ A @ ( F2 @ X5 ) ) ) ) ) ) ).

% continuous_on_cot
thf(fact_7227_continuous__on__tanh,axiom,
    ! [A: $tType,C: $tType] :
      ( ( ( topolo4958980785337419405_space @ C )
        & ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [A3: set @ C,F2: C > A] :
          ( ( topolo81223032696312382ous_on @ C @ A @ A3 @ F2 )
         => ( ! [X3: C] :
                ( ( member @ C @ X3 @ A3 )
               => ( ( cosh @ A @ ( F2 @ X3 ) )
                 != ( zero_zero @ A ) ) )
           => ( topolo81223032696312382ous_on @ C @ A @ A3
              @ ^ [X5: C] : ( tanh @ A @ ( F2 @ X5 ) ) ) ) ) ) ).

% continuous_on_tanh
thf(fact_7228_continuous__on__arcosh_H,axiom,
    ! [A3: set @ real,F2: real > real] :
      ( ( topolo81223032696312382ous_on @ real @ real @ A3 @ F2 )
     => ( ! [X3: real] :
            ( ( member @ real @ X3 @ A3 )
           => ( ord_less_eq @ real @ ( one_one @ real ) @ ( F2 @ X3 ) ) )
       => ( topolo81223032696312382ous_on @ real @ real @ A3
          @ ^ [X5: real] : ( arcosh @ real @ ( F2 @ X5 ) ) ) ) ) ).

% continuous_on_arcosh'
thf(fact_7229_lexord__partial__trans,axiom,
    ! [A: $tType,Xs: list @ A,R3: set @ ( product_prod @ A @ A ),Ys: list @ A,Zs: list @ A] :
      ( ! [X3: A,Y4: A,Z3: A] :
          ( ( member @ A @ X3 @ ( set2 @ A @ Xs ) )
         => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X3 @ Y4 ) @ R3 )
           => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Y4 @ Z3 ) @ R3 )
             => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X3 @ Z3 ) @ R3 ) ) ) )
     => ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Ys ) @ ( lexord @ A @ R3 ) )
       => ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Ys @ Zs ) @ ( lexord @ A @ R3 ) )
         => ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Zs ) @ ( lexord @ A @ R3 ) ) ) ) ) ).

% lexord_partial_trans
thf(fact_7230_lexord__append__leftD,axiom,
    ! [A: $tType,X2: list @ A,U: list @ A,V: list @ A,R3: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( append @ A @ X2 @ U ) @ ( append @ A @ X2 @ V ) ) @ ( lexord @ A @ R3 ) )
     => ( ! [A5: A] :
            ~ ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A5 @ A5 ) @ R3 )
       => ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ U @ V ) @ ( lexord @ A @ R3 ) ) ) ) ).

% lexord_append_leftD
thf(fact_7231_lexord__append__rightI,axiom,
    ! [A: $tType,Y2: list @ A,X2: list @ A,R3: set @ ( product_prod @ A @ A )] :
      ( ? [B11: A,Z4: list @ A] :
          ( Y2
          = ( cons @ A @ B11 @ Z4 ) )
     => ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ X2 @ ( append @ A @ X2 @ Y2 ) ) @ ( lexord @ A @ R3 ) ) ) ).

% lexord_append_rightI
thf(fact_7232_lexord__sufE,axiom,
    ! [A: $tType,Xs: list @ A,Zs: list @ A,Ys: list @ A,Qs: list @ A,R3: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( append @ A @ Xs @ Zs ) @ ( append @ A @ Ys @ Qs ) ) @ ( lexord @ A @ R3 ) )
     => ( ( Xs != Ys )
       => ( ( ( size_size @ ( list @ A ) @ Xs )
            = ( size_size @ ( list @ A ) @ Ys ) )
         => ( ( ( size_size @ ( list @ A ) @ Zs )
              = ( size_size @ ( list @ A ) @ Qs ) )
           => ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Ys ) @ ( lexord @ A @ R3 ) ) ) ) ) ) ).

% lexord_sufE
thf(fact_7233_continuous__image__closed__interval,axiom,
    ! [A2: real,B2: real,F2: real > real] :
      ( ( ord_less_eq @ real @ A2 @ B2 )
     => ( ( topolo81223032696312382ous_on @ real @ real @ ( set_or1337092689740270186AtMost @ real @ A2 @ B2 ) @ F2 )
       => ? [C3: real,D4: real] :
            ( ( ( image @ real @ real @ F2 @ ( set_or1337092689740270186AtMost @ real @ A2 @ B2 ) )
              = ( set_or1337092689740270186AtMost @ real @ C3 @ D4 ) )
            & ( ord_less_eq @ real @ C3 @ D4 ) ) ) ) ).

% continuous_image_closed_interval
thf(fact_7234_continuous__on__arcosh,axiom,
    ! [A3: set @ real] :
      ( ( ord_less_eq @ ( set @ real ) @ A3 @ ( set_ord_atLeast @ real @ ( one_one @ real ) ) )
     => ( topolo81223032696312382ous_on @ real @ real @ A3 @ ( arcosh @ real ) ) ) ).

% continuous_on_arcosh
thf(fact_7235_lexord__lex,axiom,
    ! [A: $tType,X2: list @ A,Y2: list @ A,R3: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ X2 @ Y2 ) @ ( lex @ A @ R3 ) )
      = ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ X2 @ Y2 ) @ ( lexord @ A @ R3 ) )
        & ( ( size_size @ ( list @ A ) @ X2 )
          = ( size_size @ ( list @ A ) @ Y2 ) ) ) ) ).

% lexord_lex
thf(fact_7236_open__Collect__positive,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [S2: set @ A,F2: A > real] :
          ( ( topolo81223032696312382ous_on @ A @ real @ S2 @ F2 )
         => ? [A8: set @ A] :
              ( ( topolo1002775350975398744n_open @ A @ A8 )
              & ( ( inf_inf @ ( set @ A ) @ A8 @ S2 )
                = ( collect @ A
                  @ ^ [X5: A] :
                      ( ( member @ A @ X5 @ S2 )
                      & ( ord_less @ real @ ( zero_zero @ real ) @ ( F2 @ X5 ) ) ) ) ) ) ) ) ).

% open_Collect_positive
thf(fact_7237_continuous__on__powr_H,axiom,
    ! [C: $tType] :
      ( ( topolo4958980785337419405_space @ C )
     => ! [S2: set @ C,F2: C > real,G: C > real] :
          ( ( topolo81223032696312382ous_on @ C @ real @ S2 @ F2 )
         => ( ( topolo81223032696312382ous_on @ C @ real @ S2 @ G )
           => ( ! [X3: C] :
                  ( ( member @ C @ X3 @ S2 )
                 => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( F2 @ X3 ) )
                    & ( ( ( F2 @ X3 )
                        = ( zero_zero @ real ) )
                     => ( ord_less @ real @ ( zero_zero @ real ) @ ( G @ X3 ) ) ) ) )
             => ( topolo81223032696312382ous_on @ C @ real @ S2
                @ ^ [X5: C] : ( powr @ real @ ( F2 @ X5 ) @ ( G @ X5 ) ) ) ) ) ) ) ).

% continuous_on_powr'
thf(fact_7238_continuous__on__log,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [S2: set @ A,F2: A > real,G: A > real] :
          ( ( topolo81223032696312382ous_on @ A @ real @ S2 @ F2 )
         => ( ( topolo81223032696312382ous_on @ A @ real @ S2 @ G )
           => ( ! [X3: A] :
                  ( ( member @ A @ X3 @ S2 )
                 => ( ord_less @ real @ ( zero_zero @ real ) @ ( F2 @ X3 ) ) )
             => ( ! [X3: A] :
                    ( ( member @ A @ X3 @ S2 )
                   => ( ( F2 @ X3 )
                     != ( one_one @ real ) ) )
               => ( ! [X3: A] :
                      ( ( member @ A @ X3 @ S2 )
                     => ( ord_less @ real @ ( zero_zero @ real ) @ ( G @ X3 ) ) )
                 => ( topolo81223032696312382ous_on @ A @ real @ S2
                    @ ^ [X5: A] : ( log @ ( F2 @ X5 ) @ ( G @ X5 ) ) ) ) ) ) ) ) ) ).

% continuous_on_log
thf(fact_7239_continuous__on__arccos,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [S2: set @ A,F2: A > real] :
          ( ( topolo81223032696312382ous_on @ A @ real @ S2 @ F2 )
         => ( ! [X3: A] :
                ( ( member @ A @ X3 @ S2 )
               => ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ ( F2 @ X3 ) )
                  & ( ord_less_eq @ real @ ( F2 @ X3 ) @ ( one_one @ real ) ) ) )
           => ( topolo81223032696312382ous_on @ A @ real @ S2
              @ ^ [X5: A] : ( arccos @ ( F2 @ X5 ) ) ) ) ) ) ).

% continuous_on_arccos
thf(fact_7240_continuous__on__arcsin,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [S2: set @ A,F2: A > real] :
          ( ( topolo81223032696312382ous_on @ A @ real @ S2 @ F2 )
         => ( ! [X3: A] :
                ( ( member @ A @ X3 @ S2 )
               => ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ ( F2 @ X3 ) )
                  & ( ord_less_eq @ real @ ( F2 @ X3 ) @ ( one_one @ real ) ) ) )
           => ( topolo81223032696312382ous_on @ A @ real @ S2
              @ ^ [X5: A] : ( arcsin @ ( F2 @ X5 ) ) ) ) ) ) ).

% continuous_on_arcsin
thf(fact_7241_DERIV__atLeastAtMost__imp__continuous__on,axiom,
    ! [A: $tType] :
      ( ( ( ord @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [A2: A,B2: A,F2: A > A] :
          ( ! [X3: A] :
              ( ( ord_less_eq @ A @ A2 @ X3 )
             => ( ( ord_less_eq @ A @ X3 @ B2 )
               => ? [Y: A] : ( has_field_derivative @ A @ F2 @ Y @ ( topolo174197925503356063within @ A @ X3 @ ( top_top @ ( set @ A ) ) ) ) ) )
         => ( topolo81223032696312382ous_on @ A @ A @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) @ F2 ) ) ) ).

% DERIV_atLeastAtMost_imp_continuous_on
thf(fact_7242_lexord__append__left__rightI,axiom,
    ! [A: $tType,A2: A,B2: A,R3: set @ ( product_prod @ A @ A ),U: list @ A,X2: list @ A,Y2: list @ A] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ B2 ) @ R3 )
     => ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( append @ A @ U @ ( cons @ A @ A2 @ X2 ) ) @ ( append @ A @ U @ ( cons @ A @ B2 @ Y2 ) ) ) @ ( lexord @ A @ R3 ) ) ) ).

% lexord_append_left_rightI
thf(fact_7243_lexord__same__pref__iff,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A,Zs: list @ A,R3: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( append @ A @ Xs @ Ys ) @ ( append @ A @ Xs @ Zs ) ) @ ( lexord @ A @ R3 ) )
      = ( ? [X5: A] :
            ( ( member @ A @ X5 @ ( set2 @ A @ Xs ) )
            & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X5 @ X5 ) @ R3 ) )
        | ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Ys @ Zs ) @ ( lexord @ A @ R3 ) ) ) ) ).

% lexord_same_pref_iff
thf(fact_7244_lexord__sufI,axiom,
    ! [A: $tType,U: list @ A,W: list @ A,R3: set @ ( product_prod @ A @ A ),V: list @ A,Z: list @ A] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ U @ W ) @ ( lexord @ A @ R3 ) )
     => ( ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ W ) @ ( size_size @ ( list @ A ) @ U ) )
       => ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( append @ A @ U @ V ) @ ( append @ A @ W @ Z ) ) @ ( lexord @ A @ R3 ) ) ) ) ).

% lexord_sufI
thf(fact_7245_Rolle__deriv,axiom,
    ! [A2: real,B2: real,F2: real > real,F8: real > real > real] :
      ( ( ord_less @ real @ A2 @ B2 )
     => ( ( ( F2 @ A2 )
          = ( F2 @ B2 ) )
       => ( ( topolo81223032696312382ous_on @ real @ real @ ( set_or1337092689740270186AtMost @ real @ A2 @ B2 ) @ F2 )
         => ( ! [X3: real] :
                ( ( ord_less @ real @ A2 @ X3 )
               => ( ( ord_less @ real @ X3 @ B2 )
                 => ( has_derivative @ real @ real @ F2 @ ( F8 @ X3 ) @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) ) ) )
           => ? [Z3: real] :
                ( ( ord_less @ real @ A2 @ Z3 )
                & ( ord_less @ real @ Z3 @ B2 )
                & ( ( F8 @ Z3 )
                  = ( ^ [V5: real] : ( zero_zero @ real ) ) ) ) ) ) ) ) ).

% Rolle_deriv
thf(fact_7246_mvt,axiom,
    ! [A2: real,B2: real,F2: real > real,F8: real > real > real] :
      ( ( ord_less @ real @ A2 @ B2 )
     => ( ( topolo81223032696312382ous_on @ real @ real @ ( set_or1337092689740270186AtMost @ real @ A2 @ B2 ) @ F2 )
       => ( ! [X3: real] :
              ( ( ord_less @ real @ A2 @ X3 )
             => ( ( ord_less @ real @ X3 @ B2 )
               => ( has_derivative @ real @ real @ F2 @ ( F8 @ X3 ) @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) ) ) )
         => ~ ! [Xi: real] :
                ( ( ord_less @ real @ A2 @ Xi )
               => ( ( ord_less @ real @ Xi @ B2 )
                 => ( ( minus_minus @ real @ ( F2 @ B2 ) @ ( F2 @ A2 ) )
                   != ( F8 @ Xi @ ( minus_minus @ real @ B2 @ A2 ) ) ) ) ) ) ) ) ).

% mvt
thf(fact_7247_continuous__on__Icc__at__leftD,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topolo1944317154257567458pology @ A )
        & ( topolo4958980785337419405_space @ B ) )
     => ! [A2: A,B2: A,F2: A > B] :
          ( ( topolo81223032696312382ous_on @ A @ B @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) @ F2 )
         => ( ( ord_less @ A @ A2 @ B2 )
           => ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ ( F2 @ B2 ) ) @ ( topolo174197925503356063within @ A @ B2 @ ( set_ord_lessThan @ A @ B2 ) ) ) ) ) ) ).

% continuous_on_Icc_at_leftD
thf(fact_7248_continuous__on__Icc__at__rightD,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topolo1944317154257567458pology @ A )
        & ( topolo4958980785337419405_space @ B ) )
     => ! [A2: A,B2: A,F2: A > B] :
          ( ( topolo81223032696312382ous_on @ A @ B @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) @ F2 )
         => ( ( ord_less @ A @ A2 @ B2 )
           => ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ ( F2 @ A2 ) ) @ ( topolo174197925503356063within @ A @ A2 @ ( set_ord_greaterThan @ A @ A2 ) ) ) ) ) ) ).

% continuous_on_Icc_at_rightD
thf(fact_7249_DERIV__isconst__end,axiom,
    ! [A2: real,B2: real,F2: real > real] :
      ( ( ord_less @ real @ A2 @ B2 )
     => ( ( topolo81223032696312382ous_on @ real @ real @ ( set_or1337092689740270186AtMost @ real @ A2 @ B2 ) @ F2 )
       => ( ! [X3: real] :
              ( ( ord_less @ real @ A2 @ X3 )
             => ( ( ord_less @ real @ X3 @ B2 )
               => ( has_field_derivative @ real @ F2 @ ( zero_zero @ real ) @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) ) ) )
         => ( ( F2 @ B2 )
            = ( F2 @ A2 ) ) ) ) ) ).

% DERIV_isconst_end
thf(fact_7250_DERIV__neg__imp__decreasing__open,axiom,
    ! [A2: real,B2: real,F2: real > real] :
      ( ( ord_less @ real @ A2 @ B2 )
     => ( ! [X3: real] :
            ( ( ord_less @ real @ A2 @ X3 )
           => ( ( ord_less @ real @ X3 @ B2 )
             => ? [Y: real] :
                  ( ( has_field_derivative @ real @ F2 @ Y @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) )
                  & ( ord_less @ real @ Y @ ( zero_zero @ real ) ) ) ) )
       => ( ( topolo81223032696312382ous_on @ real @ real @ ( set_or1337092689740270186AtMost @ real @ A2 @ B2 ) @ F2 )
         => ( ord_less @ real @ ( F2 @ B2 ) @ ( F2 @ A2 ) ) ) ) ) ).

% DERIV_neg_imp_decreasing_open
thf(fact_7251_DERIV__pos__imp__increasing__open,axiom,
    ! [A2: real,B2: real,F2: real > real] :
      ( ( ord_less @ real @ A2 @ B2 )
     => ( ! [X3: real] :
            ( ( ord_less @ real @ A2 @ X3 )
           => ( ( ord_less @ real @ X3 @ B2 )
             => ? [Y: real] :
                  ( ( has_field_derivative @ real @ F2 @ Y @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) )
                  & ( ord_less @ real @ ( zero_zero @ real ) @ Y ) ) ) )
       => ( ( topolo81223032696312382ous_on @ real @ real @ ( set_or1337092689740270186AtMost @ real @ A2 @ B2 ) @ F2 )
         => ( ord_less @ real @ ( F2 @ A2 ) @ ( F2 @ B2 ) ) ) ) ) ).

% DERIV_pos_imp_increasing_open
thf(fact_7252_continuous__on__artanh,axiom,
    ! [A3: set @ real] :
      ( ( ord_less_eq @ ( set @ real ) @ A3 @ ( set_or5935395276787703475ssThan @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ ( one_one @ real ) ) )
     => ( topolo81223032696312382ous_on @ real @ real @ A3 @ ( artanh @ real ) ) ) ).

% continuous_on_artanh
thf(fact_7253_DERIV__isconst2,axiom,
    ! [A2: real,B2: real,F2: real > real,X2: real] :
      ( ( ord_less @ real @ A2 @ B2 )
     => ( ( topolo81223032696312382ous_on @ real @ real @ ( set_or1337092689740270186AtMost @ real @ A2 @ B2 ) @ F2 )
       => ( ! [X3: real] :
              ( ( ord_less @ real @ A2 @ X3 )
             => ( ( ord_less @ real @ X3 @ B2 )
               => ( has_field_derivative @ real @ F2 @ ( zero_zero @ real ) @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) ) ) )
         => ( ( ord_less_eq @ real @ A2 @ X2 )
           => ( ( ord_less_eq @ real @ X2 @ B2 )
             => ( ( F2 @ X2 )
                = ( F2 @ A2 ) ) ) ) ) ) ) ).

% DERIV_isconst2
thf(fact_7254_continuous__on__IccI,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topolo1944317154257567458pology @ A )
        & ( topolo4958980785337419405_space @ B ) )
     => ! [F2: A > B,A2: A,B2: A] :
          ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ ( F2 @ A2 ) ) @ ( topolo174197925503356063within @ A @ A2 @ ( set_ord_greaterThan @ A @ A2 ) ) )
         => ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ ( F2 @ B2 ) ) @ ( topolo174197925503356063within @ A @ B2 @ ( set_ord_lessThan @ A @ B2 ) ) )
           => ( ! [X3: A] :
                  ( ( ord_less @ A @ A2 @ X3 )
                 => ( ( ord_less @ A @ X3 @ B2 )
                   => ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ ( F2 @ X3 ) ) @ ( topolo174197925503356063within @ A @ X3 @ ( top_top @ ( set @ A ) ) ) ) ) )
             => ( ( ord_less @ A @ A2 @ B2 )
               => ( topolo81223032696312382ous_on @ A @ B @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) @ F2 ) ) ) ) ) ) ).

% continuous_on_IccI
thf(fact_7255_Rolle,axiom,
    ! [A2: real,B2: real,F2: real > real] :
      ( ( ord_less @ real @ A2 @ B2 )
     => ( ( ( F2 @ A2 )
          = ( F2 @ B2 ) )
       => ( ( topolo81223032696312382ous_on @ real @ real @ ( set_or1337092689740270186AtMost @ real @ A2 @ B2 ) @ F2 )
         => ( ! [X3: real] :
                ( ( ord_less @ real @ A2 @ X3 )
               => ( ( ord_less @ real @ X3 @ B2 )
                 => ( differentiable @ real @ real @ F2 @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) ) ) )
           => ? [Z3: real] :
                ( ( ord_less @ real @ A2 @ Z3 )
                & ( ord_less @ real @ Z3 @ B2 )
                & ( has_field_derivative @ real @ F2 @ ( zero_zero @ real ) @ ( topolo174197925503356063within @ real @ Z3 @ ( top_top @ ( set @ real ) ) ) ) ) ) ) ) ) ).

% Rolle
thf(fact_7256_List_Olexordp__def,axiom,
    ! [A: $tType] :
      ( ( lexordp @ A )
      = ( ^ [R5: A > A > $o,Xs3: list @ A,Ys3: list @ A] : ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs3 @ Ys3 ) @ ( lexord @ A @ ( collect @ ( product_prod @ A @ A ) @ ( product_case_prod @ A @ A @ $o @ R5 ) ) ) ) ) ) ).

% List.lexordp_def
thf(fact_7257_relpow__finite__bounded1,axiom,
    ! [A: $tType,R: set @ ( product_prod @ A @ A ),K: nat] :
      ( ( finite_finite @ ( product_prod @ A @ A ) @ R )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
       => ( ord_less_eq @ ( set @ ( product_prod @ A @ A ) ) @ ( compow @ ( set @ ( product_prod @ A @ A ) ) @ K @ R )
          @ ( complete_Sup_Sup @ ( set @ ( product_prod @ A @ A ) )
            @ ( image @ nat @ ( set @ ( product_prod @ A @ A ) )
              @ ^ [N3: nat] : ( compow @ ( set @ ( product_prod @ A @ A ) ) @ N3 @ R )
              @ ( collect @ nat
                @ ^ [N3: nat] :
                    ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N3 )
                    & ( ord_less_eq @ nat @ N3 @ ( finite_card @ ( product_prod @ A @ A ) @ R ) ) ) ) ) ) ) ) ) ).

% relpow_finite_bounded1
thf(fact_7258_relpow__1,axiom,
    ! [A: $tType,R: set @ ( product_prod @ A @ A )] :
      ( ( compow @ ( set @ ( product_prod @ A @ A ) ) @ ( one_one @ nat ) @ R )
      = R ) ).

% relpow_1
thf(fact_7259_finite__relpow,axiom,
    ! [A: $tType,R: set @ ( product_prod @ A @ A ),N2: nat] :
      ( ( finite_finite @ ( product_prod @ A @ A ) @ R )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
       => ( finite_finite @ ( product_prod @ A @ A ) @ ( compow @ ( set @ ( product_prod @ A @ A ) ) @ N2 @ R ) ) ) ) ).

% finite_relpow
thf(fact_7260_relpow__Suc__I2,axiom,
    ! [A: $tType,X2: A,Y2: A,R: set @ ( product_prod @ A @ A ),Z: A,N2: nat] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ Y2 ) @ R )
     => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Y2 @ Z ) @ ( compow @ ( set @ ( product_prod @ A @ A ) ) @ N2 @ R ) )
       => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ Z ) @ ( compow @ ( set @ ( product_prod @ A @ A ) ) @ ( suc @ N2 ) @ R ) ) ) ) ).

% relpow_Suc_I2
thf(fact_7261_relpow__Suc__E2,axiom,
    ! [A: $tType,X2: A,Z: A,N2: nat,R: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ Z ) @ ( compow @ ( set @ ( product_prod @ A @ A ) ) @ ( suc @ N2 ) @ R ) )
     => ~ ! [Y4: A] :
            ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ Y4 ) @ R )
           => ~ ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Y4 @ Z ) @ ( compow @ ( set @ ( product_prod @ A @ A ) ) @ N2 @ R ) ) ) ) ).

% relpow_Suc_E2
thf(fact_7262_relpow__Suc__D2,axiom,
    ! [A: $tType,X2: A,Z: A,N2: nat,R: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ Z ) @ ( compow @ ( set @ ( product_prod @ A @ A ) ) @ ( suc @ N2 ) @ R ) )
     => ? [Y4: A] :
          ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ Y4 ) @ R )
          & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Y4 @ Z ) @ ( compow @ ( set @ ( product_prod @ A @ A ) ) @ N2 @ R ) ) ) ) ).

% relpow_Suc_D2
thf(fact_7263_relpow__Suc__I,axiom,
    ! [A: $tType,X2: A,Y2: A,N2: nat,R: set @ ( product_prod @ A @ A ),Z: A] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ Y2 ) @ ( compow @ ( set @ ( product_prod @ A @ A ) ) @ N2 @ R ) )
     => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Y2 @ Z ) @ R )
       => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ Z ) @ ( compow @ ( set @ ( product_prod @ A @ A ) ) @ ( suc @ N2 ) @ R ) ) ) ) ).

% relpow_Suc_I
thf(fact_7264_relpow__Suc__E,axiom,
    ! [A: $tType,X2: A,Z: A,N2: nat,R: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ Z ) @ ( compow @ ( set @ ( product_prod @ A @ A ) ) @ ( suc @ N2 ) @ R ) )
     => ~ ! [Y4: A] :
            ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ Y4 ) @ ( compow @ ( set @ ( product_prod @ A @ A ) ) @ N2 @ R ) )
           => ~ ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Y4 @ Z ) @ R ) ) ) ).

% relpow_Suc_E
thf(fact_7265_relpow__0__I,axiom,
    ! [A: $tType,X2: A,R: set @ ( product_prod @ A @ A )] : ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ X2 ) @ ( compow @ ( set @ ( product_prod @ A @ A ) ) @ ( zero_zero @ nat ) @ R ) ) ).

% relpow_0_I
thf(fact_7266_relpow__0__E,axiom,
    ! [A: $tType,X2: A,Y2: A,R: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ Y2 ) @ ( compow @ ( set @ ( product_prod @ A @ A ) ) @ ( zero_zero @ nat ) @ R ) )
     => ( X2 = Y2 ) ) ).

% relpow_0_E
thf(fact_7267_relpow__Suc__D2_H,axiom,
    ! [A: $tType,N2: nat,R: set @ ( product_prod @ A @ A ),X: A,Y: A,Z4: A] :
      ( ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y ) @ ( compow @ ( set @ ( product_prod @ A @ A ) ) @ N2 @ R ) )
        & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Y @ Z4 ) @ R ) )
     => ? [W2: A] :
          ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ W2 ) @ R )
          & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ W2 @ Z4 ) @ ( compow @ ( set @ ( product_prod @ A @ A ) ) @ N2 @ R ) ) ) ) ).

% relpow_Suc_D2'
thf(fact_7268_relpowp__relpow__eq,axiom,
    ! [A: $tType,N2: nat,R: set @ ( product_prod @ A @ A )] :
      ( ( compow @ ( A > A > $o ) @ N2
        @ ^ [X5: A,Y5: A] : ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X5 @ Y5 ) @ R ) )
      = ( ^ [X5: A,Y5: A] : ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X5 @ Y5 ) @ ( compow @ ( set @ ( product_prod @ A @ A ) ) @ N2 @ R ) ) ) ) ).

% relpowp_relpow_eq
thf(fact_7269_relpow__E,axiom,
    ! [A: $tType,X2: A,Z: A,N2: nat,R: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ Z ) @ ( compow @ ( set @ ( product_prod @ A @ A ) ) @ N2 @ R ) )
     => ( ( ( N2
            = ( zero_zero @ nat ) )
         => ( X2 != Z ) )
       => ~ ! [Y4: A,M3: nat] :
              ( ( N2
                = ( suc @ M3 ) )
             => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ Y4 ) @ ( compow @ ( set @ ( product_prod @ A @ A ) ) @ M3 @ R ) )
               => ~ ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Y4 @ Z ) @ R ) ) ) ) ) ).

% relpow_E
thf(fact_7270_relpow__E2,axiom,
    ! [A: $tType,X2: A,Z: A,N2: nat,R: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ Z ) @ ( compow @ ( set @ ( product_prod @ A @ A ) ) @ N2 @ R ) )
     => ( ( ( N2
            = ( zero_zero @ nat ) )
         => ( X2 != Z ) )
       => ~ ! [Y4: A,M3: nat] :
              ( ( N2
                = ( suc @ M3 ) )
             => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ Y4 ) @ R )
               => ~ ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Y4 @ Z ) @ ( compow @ ( set @ ( product_prod @ A @ A ) ) @ M3 @ R ) ) ) ) ) ) ).

% relpow_E2
thf(fact_7271_relpow__empty,axiom,
    ! [A: $tType,N2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( ( compow @ ( set @ ( product_prod @ A @ A ) ) @ N2 @ ( bot_bot @ ( set @ ( product_prod @ A @ A ) ) ) )
        = ( bot_bot @ ( set @ ( product_prod @ A @ A ) ) ) ) ) ).

% relpow_empty
thf(fact_7272_relpow__fun__conv,axiom,
    ! [A: $tType,A2: A,B2: A,N2: nat,R: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ B2 ) @ ( compow @ ( set @ ( product_prod @ A @ A ) ) @ N2 @ R ) )
      = ( ? [F5: nat > A] :
            ( ( ( F5 @ ( zero_zero @ nat ) )
              = A2 )
            & ( ( F5 @ N2 )
              = B2 )
            & ! [I4: nat] :
                ( ( ord_less @ nat @ I4 @ N2 )
               => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ ( F5 @ I4 ) @ ( F5 @ ( suc @ I4 ) ) ) @ R ) ) ) ) ) ).

% relpow_fun_conv
thf(fact_7273_relpow__finite__bounded,axiom,
    ! [A: $tType,R: set @ ( product_prod @ A @ A ),K: nat] :
      ( ( finite_finite @ ( product_prod @ A @ A ) @ R )
     => ( ord_less_eq @ ( set @ ( product_prod @ A @ A ) ) @ ( compow @ ( set @ ( product_prod @ A @ A ) ) @ K @ R )
        @ ( complete_Sup_Sup @ ( set @ ( product_prod @ A @ A ) )
          @ ( image @ nat @ ( set @ ( product_prod @ A @ A ) )
            @ ^ [N3: nat] : ( compow @ ( set @ ( product_prod @ A @ A ) ) @ N3 @ R )
            @ ( collect @ nat
              @ ^ [N3: nat] : ( ord_less_eq @ nat @ N3 @ ( finite_card @ ( product_prod @ A @ A ) @ R ) ) ) ) ) ) ) ).

% relpow_finite_bounded
thf(fact_7274_ntrancl__def,axiom,
    ! [A: $tType] :
      ( ( transitive_ntrancl @ A )
      = ( ^ [N3: nat,R6: set @ ( product_prod @ A @ A )] :
            ( complete_Sup_Sup @ ( set @ ( product_prod @ A @ A ) )
            @ ( image @ nat @ ( set @ ( product_prod @ A @ A ) )
              @ ^ [I4: nat] : ( compow @ ( set @ ( product_prod @ A @ A ) ) @ I4 @ R6 )
              @ ( collect @ nat
                @ ^ [I4: nat] :
                    ( ( ord_less @ nat @ ( zero_zero @ nat ) @ I4 )
                    & ( ord_less_eq @ nat @ I4 @ ( suc @ N3 ) ) ) ) ) ) ) ) ).

% ntrancl_def
thf(fact_7275_trancl__finite__eq__relpow,axiom,
    ! [A: $tType,R: set @ ( product_prod @ A @ A )] :
      ( ( finite_finite @ ( product_prod @ A @ A ) @ R )
     => ( ( transitive_trancl @ A @ R )
        = ( complete_Sup_Sup @ ( set @ ( product_prod @ A @ A ) )
          @ ( image @ nat @ ( set @ ( product_prod @ A @ A ) )
            @ ^ [N3: nat] : ( compow @ ( set @ ( product_prod @ A @ A ) ) @ N3 @ R )
            @ ( collect @ nat
              @ ^ [N3: nat] :
                  ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N3 )
                  & ( ord_less_eq @ nat @ N3 @ ( finite_card @ ( product_prod @ A @ A ) @ R ) ) ) ) ) ) ) ) ).

% trancl_finite_eq_relpow
thf(fact_7276_ntrancl__Zero,axiom,
    ! [A: $tType,R: set @ ( product_prod @ A @ A )] :
      ( ( transitive_ntrancl @ A @ ( zero_zero @ nat ) @ R )
      = R ) ).

% ntrancl_Zero
thf(fact_7277_trancl_Ocases,axiom,
    ! [A: $tType,A1: A,A22: A,R3: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A1 @ A22 ) @ ( transitive_trancl @ A @ R3 ) )
     => ( ~ ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A1 @ A22 ) @ R3 )
       => ~ ! [B5: A] :
              ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A1 @ B5 ) @ ( transitive_trancl @ A @ R3 ) )
             => ~ ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ B5 @ A22 ) @ R3 ) ) ) ) ).

% trancl.cases
thf(fact_7278_trancl_Osimps,axiom,
    ! [A: $tType,A1: A,A22: A,R3: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A1 @ A22 ) @ ( transitive_trancl @ A @ R3 ) )
      = ( ? [A4: A,B4: A] :
            ( ( A1 = A4 )
            & ( A22 = B4 )
            & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A4 @ B4 ) @ R3 ) )
        | ? [A4: A,B4: A,C4: A] :
            ( ( A1 = A4 )
            & ( A22 = C4 )
            & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A4 @ B4 ) @ ( transitive_trancl @ A @ R3 ) )
            & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ B4 @ C4 ) @ R3 ) ) ) ) ).

% trancl.simps
thf(fact_7279_trancl_Or__into__trancl,axiom,
    ! [A: $tType,A2: A,B2: A,R3: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ B2 ) @ R3 )
     => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ B2 ) @ ( transitive_trancl @ A @ R3 ) ) ) ).

% trancl.r_into_trancl
thf(fact_7280_tranclE,axiom,
    ! [A: $tType,A2: A,B2: A,R3: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ B2 ) @ ( transitive_trancl @ A @ R3 ) )
     => ( ~ ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ B2 ) @ R3 )
       => ~ ! [C3: A] :
              ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ C3 ) @ ( transitive_trancl @ A @ R3 ) )
             => ~ ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ C3 @ B2 ) @ R3 ) ) ) ) ).

% tranclE
thf(fact_7281_trancl__trans,axiom,
    ! [A: $tType,X2: A,Y2: A,R3: set @ ( product_prod @ A @ A ),Z: A] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ Y2 ) @ ( transitive_trancl @ A @ R3 ) )
     => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Y2 @ Z ) @ ( transitive_trancl @ A @ R3 ) )
       => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ Z ) @ ( transitive_trancl @ A @ R3 ) ) ) ) ).

% trancl_trans
thf(fact_7282_trancl__induct,axiom,
    ! [A: $tType,A2: A,B2: A,R3: set @ ( product_prod @ A @ A ),P: A > $o] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ B2 ) @ ( transitive_trancl @ A @ R3 ) )
     => ( ! [Y4: A] :
            ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ Y4 ) @ R3 )
           => ( P @ Y4 ) )
       => ( ! [Y4: A,Z3: A] :
              ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ Y4 ) @ ( transitive_trancl @ A @ R3 ) )
             => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Y4 @ Z3 ) @ R3 )
               => ( ( P @ Y4 )
                 => ( P @ Z3 ) ) ) )
         => ( P @ B2 ) ) ) ) ).

% trancl_induct
thf(fact_7283_r__r__into__trancl,axiom,
    ! [A: $tType,A2: A,B2: A,R: set @ ( product_prod @ A @ A ),C2: A] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ B2 ) @ R )
     => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ B2 @ C2 ) @ R )
       => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ C2 ) @ ( transitive_trancl @ A @ R ) ) ) ) ).

% r_r_into_trancl
thf(fact_7284_converse__tranclE,axiom,
    ! [A: $tType,X2: A,Z: A,R3: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ Z ) @ ( transitive_trancl @ A @ R3 ) )
     => ( ~ ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ Z ) @ R3 )
       => ~ ! [Y4: A] :
              ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ Y4 ) @ R3 )
             => ~ ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Y4 @ Z ) @ ( transitive_trancl @ A @ R3 ) ) ) ) ) ).

% converse_tranclE
thf(fact_7285_irrefl__trancl__rD,axiom,
    ! [A: $tType,R3: set @ ( product_prod @ A @ A ),X2: A,Y2: A] :
      ( ! [X3: A] :
          ~ ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X3 @ X3 ) @ ( transitive_trancl @ A @ R3 ) )
     => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ Y2 ) @ R3 )
       => ( X2 != Y2 ) ) ) ).

% irrefl_trancl_rD
thf(fact_7286_Transitive__Closure_Otrancl__into__trancl,axiom,
    ! [A: $tType,A2: A,B2: A,R3: set @ ( product_prod @ A @ A ),C2: A] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ B2 ) @ ( transitive_trancl @ A @ R3 ) )
     => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ B2 @ C2 ) @ R3 )
       => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ C2 ) @ ( transitive_trancl @ A @ R3 ) ) ) ) ).

% Transitive_Closure.trancl_into_trancl
thf(fact_7287_trancl__into__trancl2,axiom,
    ! [A: $tType,A2: A,B2: A,R3: set @ ( product_prod @ A @ A ),C2: A] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ B2 ) @ R3 )
     => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ B2 @ C2 ) @ ( transitive_trancl @ A @ R3 ) )
       => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ C2 ) @ ( transitive_trancl @ A @ R3 ) ) ) ) ).

% trancl_into_trancl2
thf(fact_7288_trancl__trans__induct,axiom,
    ! [A: $tType,X2: A,Y2: A,R3: set @ ( product_prod @ A @ A ),P: A > A > $o] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ Y2 ) @ ( transitive_trancl @ A @ R3 ) )
     => ( ! [X3: A,Y4: A] :
            ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X3 @ Y4 ) @ R3 )
           => ( P @ X3 @ Y4 ) )
       => ( ! [X3: A,Y4: A,Z3: A] :
              ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X3 @ Y4 ) @ ( transitive_trancl @ A @ R3 ) )
             => ( ( P @ X3 @ Y4 )
               => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Y4 @ Z3 ) @ ( transitive_trancl @ A @ R3 ) )
                 => ( ( P @ Y4 @ Z3 )
                   => ( P @ X3 @ Z3 ) ) ) ) )
         => ( P @ X2 @ Y2 ) ) ) ) ).

% trancl_trans_induct
thf(fact_7289_converse__trancl__induct,axiom,
    ! [A: $tType,A2: A,B2: A,R3: set @ ( product_prod @ A @ A ),P: A > $o] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ B2 ) @ ( transitive_trancl @ A @ R3 ) )
     => ( ! [Y4: A] :
            ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Y4 @ B2 ) @ R3 )
           => ( P @ Y4 ) )
       => ( ! [Y4: A,Z3: A] :
              ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Y4 @ Z3 ) @ R3 )
             => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Z3 @ B2 ) @ ( transitive_trancl @ A @ R3 ) )
               => ( ( P @ Z3 )
                 => ( P @ Y4 ) ) ) )
         => ( P @ A2 ) ) ) ) ).

% converse_trancl_induct
thf(fact_7290_trancl__induct2,axiom,
    ! [A: $tType,B: $tType,Ax: A,Ay: B,Bx: A,By: B,R3: set @ ( product_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) ),P: A > B > $o] :
      ( ( member @ ( product_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) ) @ ( product_Pair @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ Ax @ Ay ) @ ( product_Pair @ A @ B @ Bx @ By ) ) @ ( transitive_trancl @ ( product_prod @ A @ B ) @ R3 ) )
     => ( ! [A5: A,B5: B] :
            ( ( member @ ( product_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) ) @ ( product_Pair @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ Ax @ Ay ) @ ( product_Pair @ A @ B @ A5 @ B5 ) ) @ R3 )
           => ( P @ A5 @ B5 ) )
       => ( ! [A5: A,B5: B,Aa2: A,Ba: B] :
              ( ( member @ ( product_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) ) @ ( product_Pair @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ Ax @ Ay ) @ ( product_Pair @ A @ B @ A5 @ B5 ) ) @ ( transitive_trancl @ ( product_prod @ A @ B ) @ R3 ) )
             => ( ( member @ ( product_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) ) @ ( product_Pair @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ A5 @ B5 ) @ ( product_Pair @ A @ B @ Aa2 @ Ba ) ) @ R3 )
               => ( ( P @ A5 @ B5 )
                 => ( P @ Aa2 @ Ba ) ) ) )
         => ( P @ Bx @ By ) ) ) ) ).

% trancl_induct2
thf(fact_7291_trancl__mono,axiom,
    ! [A: $tType,P4: product_prod @ A @ A,R3: set @ ( product_prod @ A @ A ),S2: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ A @ A ) @ P4 @ ( transitive_trancl @ A @ R3 ) )
     => ( ( ord_less_eq @ ( set @ ( product_prod @ A @ A ) ) @ R3 @ S2 )
       => ( member @ ( product_prod @ A @ A ) @ P4 @ ( transitive_trancl @ A @ S2 ) ) ) ) ).

% trancl_mono
thf(fact_7292_finite__trancl__ntranl,axiom,
    ! [A: $tType,R: set @ ( product_prod @ A @ A )] :
      ( ( finite_finite @ ( product_prod @ A @ A ) @ R )
     => ( ( transitive_trancl @ A @ R )
        = ( transitive_ntrancl @ A @ ( minus_minus @ nat @ ( finite_card @ ( product_prod @ A @ A ) @ R ) @ ( one_one @ nat ) ) @ R ) ) ) ).

% finite_trancl_ntranl
thf(fact_7293_trancl__set__ntrancl,axiom,
    ! [A: $tType,Xs: list @ ( product_prod @ A @ A )] :
      ( ( transitive_trancl @ A @ ( set2 @ ( product_prod @ A @ A ) @ Xs ) )
      = ( transitive_ntrancl @ A @ ( minus_minus @ nat @ ( finite_card @ ( product_prod @ A @ A ) @ ( set2 @ ( product_prod @ A @ A ) @ Xs ) ) @ ( one_one @ nat ) ) @ ( set2 @ ( product_prod @ A @ A ) @ Xs ) ) ) ).

% trancl_set_ntrancl
thf(fact_7294_trancl__power,axiom,
    ! [A: $tType,P4: product_prod @ A @ A,R: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ A @ A ) @ P4 @ ( transitive_trancl @ A @ R ) )
      = ( ? [N3: nat] :
            ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N3 )
            & ( member @ ( product_prod @ A @ A ) @ P4 @ ( compow @ ( set @ ( product_prod @ A @ A ) ) @ N3 @ R ) ) ) ) ) ).

% trancl_power
thf(fact_7295_trancl__insert2,axiom,
    ! [A: $tType,A2: A,B2: A,R3: set @ ( product_prod @ A @ A )] :
      ( ( transitive_trancl @ A @ ( insert @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ B2 ) @ R3 ) )
      = ( sup_sup @ ( set @ ( product_prod @ A @ A ) ) @ ( transitive_trancl @ A @ R3 )
        @ ( collect @ ( product_prod @ A @ A )
          @ ( product_case_prod @ A @ A @ $o
            @ ^ [X5: A,Y5: A] :
                ( ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X5 @ A2 ) @ ( transitive_trancl @ A @ R3 ) )
                  | ( X5 = A2 ) )
                & ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ B2 @ Y5 ) @ ( transitive_trancl @ A @ R3 ) )
                  | ( Y5 = B2 ) ) ) ) ) ) ) ).

% trancl_insert2
thf(fact_7296_less__eq,axiom,
    ! [M: nat,N2: nat] :
      ( ( member @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ M @ N2 ) @ ( transitive_trancl @ nat @ pred_nat ) )
      = ( ord_less @ nat @ M @ N2 ) ) ).

% less_eq
thf(fact_7297_compactE__image,axiom,
    ! [A: $tType,B: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [S3: set @ A,C6: set @ B,F2: B > ( set @ A )] :
          ( ( topolo2193935891317330818ompact @ A @ S3 )
         => ( ! [T7: B] :
                ( ( member @ B @ T7 @ C6 )
               => ( topolo1002775350975398744n_open @ A @ ( F2 @ T7 ) ) )
           => ( ( ord_less_eq @ ( set @ A ) @ S3 @ ( complete_Sup_Sup @ ( set @ A ) @ ( image @ B @ ( set @ A ) @ F2 @ C6 ) ) )
             => ~ ! [C8: set @ B] :
                    ( ( ord_less_eq @ ( set @ B ) @ C8 @ C6 )
                   => ( ( finite_finite @ B @ C8 )
                     => ~ ( ord_less_eq @ ( set @ A ) @ S3 @ ( complete_Sup_Sup @ ( set @ A ) @ ( image @ B @ ( set @ A ) @ F2 @ C8 ) ) ) ) ) ) ) ) ) ).

% compactE_image
thf(fact_7298_compact__eq__Heine__Borel,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ( ( topolo2193935891317330818ompact @ A )
        = ( ^ [S6: set @ A] :
            ! [C9: set @ ( set @ A )] :
              ( ( ! [X5: set @ A] :
                    ( ( member @ ( set @ A ) @ X5 @ C9 )
                   => ( topolo1002775350975398744n_open @ A @ X5 ) )
                & ( ord_less_eq @ ( set @ A ) @ S6 @ ( complete_Sup_Sup @ ( set @ A ) @ C9 ) ) )
             => ? [D7: set @ ( set @ A )] :
                  ( ( ord_less_eq @ ( set @ ( set @ A ) ) @ D7 @ C9 )
                  & ( finite_finite @ ( set @ A ) @ D7 )
                  & ( ord_less_eq @ ( set @ A ) @ S6 @ ( complete_Sup_Sup @ ( set @ A ) @ D7 ) ) ) ) ) ) ) ).

% compact_eq_Heine_Borel
thf(fact_7299_compact__attains__sup,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [S3: set @ A] :
          ( ( topolo2193935891317330818ompact @ A @ S3 )
         => ( ( S3
             != ( bot_bot @ ( set @ A ) ) )
           => ? [X3: A] :
                ( ( member @ A @ X3 @ S3 )
                & ! [Xa: A] :
                    ( ( member @ A @ Xa @ S3 )
                   => ( ord_less_eq @ A @ Xa @ X3 ) ) ) ) ) ) ).

% compact_attains_sup
thf(fact_7300_compact__attains__inf,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [S3: set @ A] :
          ( ( topolo2193935891317330818ompact @ A @ S3 )
         => ( ( S3
             != ( bot_bot @ ( set @ A ) ) )
           => ? [X3: A] :
                ( ( member @ A @ X3 @ S3 )
                & ! [Xa: A] :
                    ( ( member @ A @ Xa @ S3 )
                   => ( ord_less_eq @ A @ X3 @ Xa ) ) ) ) ) ) ).

% compact_attains_inf
thf(fact_7301_continuous__attains__sup,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topolo4958980785337419405_space @ A )
        & ( topolo1944317154257567458pology @ B ) )
     => ! [S2: set @ A,F2: A > B] :
          ( ( topolo2193935891317330818ompact @ A @ S2 )
         => ( ( S2
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( topolo81223032696312382ous_on @ A @ B @ S2 @ F2 )
             => ? [X3: A] :
                  ( ( member @ A @ X3 @ S2 )
                  & ! [Xa: A] :
                      ( ( member @ A @ Xa @ S2 )
                     => ( ord_less_eq @ B @ ( F2 @ Xa ) @ ( F2 @ X3 ) ) ) ) ) ) ) ) ).

% continuous_attains_sup
thf(fact_7302_continuous__attains__inf,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topolo4958980785337419405_space @ A )
        & ( topolo1944317154257567458pology @ B ) )
     => ! [S2: set @ A,F2: A > B] :
          ( ( topolo2193935891317330818ompact @ A @ S2 )
         => ( ( S2
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( topolo81223032696312382ous_on @ A @ B @ S2 @ F2 )
             => ? [X3: A] :
                  ( ( member @ A @ X3 @ S2 )
                  & ! [Xa: A] :
                      ( ( member @ A @ Xa @ S2 )
                     => ( ord_less_eq @ B @ ( F2 @ X3 ) @ ( F2 @ Xa ) ) ) ) ) ) ) ) ).

% continuous_attains_inf
thf(fact_7303_compactE,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [S3: set @ A,T11: set @ ( set @ A )] :
          ( ( topolo2193935891317330818ompact @ A @ S3 )
         => ( ( ord_less_eq @ ( set @ A ) @ S3 @ ( complete_Sup_Sup @ ( set @ A ) @ T11 ) )
           => ( ! [B9: set @ A] :
                  ( ( member @ ( set @ A ) @ B9 @ T11 )
                 => ( topolo1002775350975398744n_open @ A @ B9 ) )
             => ~ ! [T12: set @ ( set @ A )] :
                    ( ( ord_less_eq @ ( set @ ( set @ A ) ) @ T12 @ T11 )
                   => ( ( finite_finite @ ( set @ A ) @ T12 )
                     => ~ ( ord_less_eq @ ( set @ A ) @ S3 @ ( complete_Sup_Sup @ ( set @ A ) @ T12 ) ) ) ) ) ) ) ) ).

% compactE
thf(fact_7304_compactI,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [S2: set @ A] :
          ( ! [C7: set @ ( set @ A )] :
              ( ! [X: set @ A] :
                  ( ( member @ ( set @ A ) @ X @ C7 )
                 => ( topolo1002775350975398744n_open @ A @ X ) )
             => ( ( ord_less_eq @ ( set @ A ) @ S2 @ ( complete_Sup_Sup @ ( set @ A ) @ C7 ) )
               => ? [C10: set @ ( set @ A )] :
                    ( ( ord_less_eq @ ( set @ ( set @ A ) ) @ C10 @ C7 )
                    & ( finite_finite @ ( set @ A ) @ C10 )
                    & ( ord_less_eq @ ( set @ A ) @ S2 @ ( complete_Sup_Sup @ ( set @ A ) @ C10 ) ) ) ) )
         => ( topolo2193935891317330818ompact @ A @ S2 ) ) ) ).

% compactI
thf(fact_7305_Id__on__def,axiom,
    ! [A: $tType] :
      ( ( id_on @ A )
      = ( ^ [A7: set @ A] :
            ( complete_Sup_Sup @ ( set @ ( product_prod @ A @ A ) )
            @ ( image @ A @ ( set @ ( product_prod @ A @ A ) )
              @ ^ [X5: A] : ( insert @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X5 @ X5 ) @ ( bot_bot @ ( set @ ( product_prod @ A @ A ) ) ) )
              @ A7 ) ) ) ) ).

% Id_on_def
thf(fact_7306_fold__union__pair,axiom,
    ! [B: $tType,A: $tType,B3: set @ A,X2: B,A3: set @ ( product_prod @ B @ A )] :
      ( ( finite_finite @ A @ B3 )
     => ( ( sup_sup @ ( set @ ( product_prod @ B @ A ) )
          @ ( complete_Sup_Sup @ ( set @ ( product_prod @ B @ A ) )
            @ ( image @ A @ ( set @ ( product_prod @ B @ A ) )
              @ ^ [Y5: A] : ( insert @ ( product_prod @ B @ A ) @ ( product_Pair @ B @ A @ X2 @ Y5 ) @ ( bot_bot @ ( set @ ( product_prod @ B @ A ) ) ) )
              @ B3 ) )
          @ A3 )
        = ( finite_fold @ A @ ( set @ ( product_prod @ B @ A ) )
          @ ^ [Y5: A] : ( insert @ ( product_prod @ B @ A ) @ ( product_Pair @ B @ A @ X2 @ Y5 ) )
          @ A3
          @ B3 ) ) ) ).

% fold_union_pair
thf(fact_7307_Id__onI,axiom,
    ! [A: $tType,A2: A,A3: set @ A] :
      ( ( member @ A @ A2 @ A3 )
     => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ A2 ) @ ( id_on @ A @ A3 ) ) ) ).

% Id_onI
thf(fact_7308_Id__on__fold,axiom,
    ! [A: $tType,A3: set @ A] :
      ( ( finite_finite @ A @ A3 )
     => ( ( id_on @ A @ A3 )
        = ( finite_fold @ A @ ( set @ ( product_prod @ A @ A ) )
          @ ^ [X5: A] : ( insert @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X5 @ X5 ) )
          @ ( bot_bot @ ( set @ ( product_prod @ A @ A ) ) )
          @ A3 ) ) ) ).

% Id_on_fold
thf(fact_7309_Id__on__iff,axiom,
    ! [A: $tType,X2: A,Y2: A,A3: set @ A] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ Y2 ) @ ( id_on @ A @ A3 ) )
      = ( ( X2 = Y2 )
        & ( member @ A @ X2 @ A3 ) ) ) ).

% Id_on_iff
thf(fact_7310_Id__on__eqI,axiom,
    ! [A: $tType,A2: A,B2: A,A3: set @ A] :
      ( ( A2 = B2 )
     => ( ( member @ A @ A2 @ A3 )
       => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ B2 ) @ ( id_on @ A @ A3 ) ) ) ) ).

% Id_on_eqI
thf(fact_7311_Id__onE,axiom,
    ! [A: $tType,C2: product_prod @ A @ A,A3: set @ A] :
      ( ( member @ ( product_prod @ A @ A ) @ C2 @ ( id_on @ A @ A3 ) )
     => ~ ! [X3: A] :
            ( ( member @ A @ X3 @ A3 )
           => ( C2
             != ( product_Pair @ A @ A @ X3 @ X3 ) ) ) ) ).

% Id_onE
thf(fact_7312_sum_Oeq__fold,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ( ( groups7311177749621191930dd_sum @ B @ A )
        = ( ^ [G4: B > A] : ( finite_fold @ B @ A @ ( comp @ A @ ( A > A ) @ B @ ( plus_plus @ A ) @ G4 ) @ ( zero_zero @ A ) ) ) ) ) ).

% sum.eq_fold
thf(fact_7313_prod_Oeq__fold,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ( ( groups7121269368397514597t_prod @ B @ A )
        = ( ^ [G4: B > A] : ( finite_fold @ B @ A @ ( comp @ A @ ( A > A ) @ B @ ( times_times @ A ) @ G4 ) @ ( one_one @ A ) ) ) ) ) ).

% prod.eq_fold
thf(fact_7314_the__elem__set,axiom,
    ! [A: $tType,X2: A] :
      ( ( the_elem @ A @ ( set2 @ A @ ( cons @ A @ X2 @ ( nil @ A ) ) ) )
      = X2 ) ).

% the_elem_set
thf(fact_7315_sequentially__imp__eventually__at__left,axiom,
    ! [A: $tType] :
      ( ( ( topolo3112930676232923870pology @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [B2: A,A2: A,P: A > $o] :
          ( ( ord_less @ A @ B2 @ A2 )
         => ( ! [F4: nat > A] :
                ( ! [N9: nat] : ( ord_less @ A @ B2 @ ( F4 @ N9 ) )
               => ( ! [N9: nat] : ( ord_less @ A @ ( F4 @ N9 ) @ A2 )
                 => ( ( order_mono @ nat @ A @ F4 )
                   => ( ( filterlim @ nat @ A @ F4 @ ( topolo7230453075368039082e_nhds @ A @ A2 ) @ ( at_top @ nat ) )
                     => ( eventually @ nat
                        @ ^ [N3: nat] : ( P @ ( F4 @ N3 ) )
                        @ ( at_top @ nat ) ) ) ) ) )
           => ( eventually @ A @ P @ ( topolo174197925503356063within @ A @ A2 @ ( set_ord_lessThan @ A @ A2 ) ) ) ) ) ) ).

% sequentially_imp_eventually_at_left
thf(fact_7316_mono__mult,axiom,
    ! [A: $tType] :
      ( ( ordered_semiring @ A )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( order_mono @ A @ A @ ( times_times @ A @ A2 ) ) ) ) ).

% mono_mult
thf(fact_7317_mono__sup,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( semilattice_sup @ A )
        & ( semilattice_sup @ B ) )
     => ! [F2: A > B,A3: A,B3: A] :
          ( ( order_mono @ A @ B @ F2 )
         => ( ord_less_eq @ B @ ( sup_sup @ B @ ( F2 @ A3 ) @ ( F2 @ B3 ) ) @ ( F2 @ ( sup_sup @ A @ A3 @ B3 ) ) ) ) ) ).

% mono_sup
thf(fact_7318_mono__invE,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( linorder @ A )
        & ( order @ B ) )
     => ! [F2: A > B,X2: A,Y2: A] :
          ( ( order_mono @ A @ B @ F2 )
         => ( ( ord_less @ B @ ( F2 @ X2 ) @ ( F2 @ Y2 ) )
           => ( ord_less_eq @ A @ X2 @ Y2 ) ) ) ) ).

% mono_invE
thf(fact_7319_mono__inf,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( semilattice_inf @ A )
        & ( semilattice_inf @ B ) )
     => ! [F2: A > B,A3: A,B3: A] :
          ( ( order_mono @ A @ B @ F2 )
         => ( ord_less_eq @ B @ ( F2 @ ( inf_inf @ A @ A3 @ B3 ) ) @ ( inf_inf @ B @ ( F2 @ A3 ) @ ( F2 @ B3 ) ) ) ) ) ).

% mono_inf
thf(fact_7320_incseqD,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [F2: nat > A,I3: nat,J: nat] :
          ( ( order_mono @ nat @ A @ F2 )
         => ( ( ord_less_eq @ nat @ I3 @ J )
           => ( ord_less_eq @ A @ ( F2 @ I3 ) @ ( F2 @ J ) ) ) ) ) ).

% incseqD
thf(fact_7321_incseq__def,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( order_mono @ nat @ A )
        = ( ^ [X4: nat > A] :
            ! [M6: nat,N3: nat] :
              ( ( ord_less_eq @ nat @ M6 @ N3 )
             => ( ord_less_eq @ A @ ( X4 @ M6 ) @ ( X4 @ N3 ) ) ) ) ) ) ).

% incseq_def
thf(fact_7322_mono__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( order @ A )
        & ( order @ B ) )
     => ( ( order_mono @ A @ B )
        = ( ^ [F5: A > B] :
            ! [X5: A,Y5: A] :
              ( ( ord_less_eq @ A @ X5 @ Y5 )
             => ( ord_less_eq @ B @ ( F5 @ X5 ) @ ( F5 @ Y5 ) ) ) ) ) ) ).

% mono_def
thf(fact_7323_monoI,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( order @ A )
        & ( order @ B ) )
     => ! [F2: A > B] :
          ( ! [X3: A,Y4: A] :
              ( ( ord_less_eq @ A @ X3 @ Y4 )
             => ( ord_less_eq @ B @ ( F2 @ X3 ) @ ( F2 @ Y4 ) ) )
         => ( order_mono @ A @ B @ F2 ) ) ) ).

% monoI
thf(fact_7324_monoE,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( order @ A )
        & ( order @ B ) )
     => ! [F2: A > B,X2: A,Y2: A] :
          ( ( order_mono @ A @ B @ F2 )
         => ( ( ord_less_eq @ A @ X2 @ Y2 )
           => ( ord_less_eq @ B @ ( F2 @ X2 ) @ ( F2 @ Y2 ) ) ) ) ) ).

% monoE
thf(fact_7325_monoD,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( order @ A )
        & ( order @ B ) )
     => ! [F2: A > B,X2: A,Y2: A] :
          ( ( order_mono @ A @ B @ F2 )
         => ( ( ord_less_eq @ A @ X2 @ Y2 )
           => ( ord_less_eq @ B @ ( F2 @ X2 ) @ ( F2 @ Y2 ) ) ) ) ) ).

% monoD
thf(fact_7326_incseq__SucD,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [A3: nat > A,I3: nat] :
          ( ( order_mono @ nat @ A @ A3 )
         => ( ord_less_eq @ A @ ( A3 @ I3 ) @ ( A3 @ ( suc @ I3 ) ) ) ) ) ).

% incseq_SucD
thf(fact_7327_incseq__SucI,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [X8: nat > A] :
          ( ! [N: nat] : ( ord_less_eq @ A @ ( X8 @ N ) @ ( X8 @ ( suc @ N ) ) )
         => ( order_mono @ nat @ A @ X8 ) ) ) ).

% incseq_SucI
thf(fact_7328_incseq__Suc__iff,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( order_mono @ nat @ A )
        = ( ^ [F5: nat > A] :
            ! [N3: nat] : ( ord_less_eq @ A @ ( F5 @ N3 ) @ ( F5 @ ( suc @ N3 ) ) ) ) ) ) ).

% incseq_Suc_iff
thf(fact_7329_mono__times__nat,axiom,
    ! [N2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( order_mono @ nat @ nat @ ( times_times @ nat @ N2 ) ) ) ).

% mono_times_nat
thf(fact_7330_mono__strict__invE,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( linorder @ A )
        & ( order @ B ) )
     => ! [F2: A > B,X2: A,Y2: A] :
          ( ( order_mono @ A @ B @ F2 )
         => ( ( ord_less @ B @ ( F2 @ X2 ) @ ( F2 @ Y2 ) )
           => ( ord_less @ A @ X2 @ Y2 ) ) ) ) ).

% mono_strict_invE
thf(fact_7331_mono__Suc,axiom,
    order_mono @ nat @ nat @ suc ).

% mono_Suc
thf(fact_7332_mono__add,axiom,
    ! [A: $tType] :
      ( ( ordere6658533253407199908up_add @ A )
     => ! [A2: A] : ( order_mono @ A @ A @ ( plus_plus @ A @ A2 ) ) ) ).

% mono_add
thf(fact_7333_Kleene__iter__lpfp,axiom,
    ! [A: $tType] :
      ( ( order_bot @ A )
     => ! [F2: A > A,P4: A,K: nat] :
          ( ( order_mono @ A @ A @ F2 )
         => ( ( ord_less_eq @ A @ ( F2 @ P4 ) @ P4 )
           => ( ord_less_eq @ A @ ( compow @ ( A > A ) @ K @ F2 @ ( bot_bot @ A ) ) @ P4 ) ) ) ) ).

% Kleene_iter_lpfp
thf(fact_7334_mono__funpow,axiom,
    ! [A: $tType] :
      ( ( ( lattice @ A )
        & ( order_bot @ A ) )
     => ! [Q: A > A] :
          ( ( order_mono @ A @ A @ Q )
         => ( order_mono @ nat @ A
            @ ^ [I4: nat] : ( compow @ ( A > A ) @ I4 @ Q @ ( bot_bot @ A ) ) ) ) ) ).

% mono_funpow
thf(fact_7335_mono__pow,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [F2: A > A,N2: nat] :
          ( ( order_mono @ A @ A @ F2 )
         => ( order_mono @ A @ A @ ( compow @ ( A > A ) @ N2 @ F2 ) ) ) ) ).

% mono_pow
thf(fact_7336_funpow__mono2,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [F2: A > A,I3: nat,J: nat,X2: A,Y2: A] :
          ( ( order_mono @ A @ A @ F2 )
         => ( ( ord_less_eq @ nat @ I3 @ J )
           => ( ( ord_less_eq @ A @ X2 @ Y2 )
             => ( ( ord_less_eq @ A @ X2 @ ( F2 @ X2 ) )
               => ( ord_less_eq @ A @ ( compow @ ( A > A ) @ I3 @ F2 @ X2 ) @ ( compow @ ( A > A ) @ J @ F2 @ Y2 ) ) ) ) ) ) ) ).

% funpow_mono2
thf(fact_7337_Kleene__iter__gpfp,axiom,
    ! [A: $tType] :
      ( ( order_top @ A )
     => ! [F2: A > A,P4: A,K: nat] :
          ( ( order_mono @ A @ A @ F2 )
         => ( ( ord_less_eq @ A @ P4 @ ( F2 @ P4 ) )
           => ( ord_less_eq @ A @ P4 @ ( compow @ ( A > A ) @ K @ F2 @ ( top_top @ A ) ) ) ) ) ) ).

% Kleene_iter_gpfp
thf(fact_7338_funpow__mono,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [F2: A > A,A3: A,B3: A,N2: nat] :
          ( ( order_mono @ A @ A @ F2 )
         => ( ( ord_less_eq @ A @ A3 @ B3 )
           => ( ord_less_eq @ A @ ( compow @ ( A > A ) @ N2 @ F2 @ A3 ) @ ( compow @ ( A > A ) @ N2 @ F2 @ B3 ) ) ) ) ) ).

% funpow_mono
thf(fact_7339_mono__image__least,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( order @ B )
        & ( order @ A ) )
     => ! [F2: A > B,M: A,N2: A,M5: B,N5: B] :
          ( ( order_mono @ A @ B @ F2 )
         => ( ( ( image @ A @ B @ F2 @ ( set_or7035219750837199246ssThan @ A @ M @ N2 ) )
              = ( set_or7035219750837199246ssThan @ B @ M5 @ N5 ) )
           => ( ( ord_less @ A @ M @ N2 )
             => ( ( F2 @ M )
                = M5 ) ) ) ) ) ).

% mono_image_least
thf(fact_7340_incseq__bounded,axiom,
    ! [X8: nat > real,B3: real] :
      ( ( order_mono @ nat @ real @ X8 )
     => ( ! [I2: nat] : ( ord_less_eq @ real @ ( X8 @ I2 ) @ B3 )
       => ( bfun @ nat @ real @ X8 @ ( at_top @ nat ) ) ) ) ).

% incseq_bounded
thf(fact_7341_mono__SUP,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( ( comple6319245703460814977attice @ A )
        & ( comple6319245703460814977attice @ B ) )
     => ! [F2: A > B,A3: C > A,I6: set @ C] :
          ( ( order_mono @ A @ B @ F2 )
         => ( ord_less_eq @ B
            @ ( complete_Sup_Sup @ B
              @ ( image @ C @ B
                @ ^ [X5: C] : ( F2 @ ( A3 @ X5 ) )
                @ I6 ) )
            @ ( F2 @ ( complete_Sup_Sup @ A @ ( image @ C @ A @ A3 @ I6 ) ) ) ) ) ) ).

% mono_SUP
thf(fact_7342_mono__Sup,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( comple6319245703460814977attice @ A )
        & ( comple6319245703460814977attice @ B ) )
     => ! [F2: A > B,A3: set @ A] :
          ( ( order_mono @ A @ B @ F2 )
         => ( ord_less_eq @ B @ ( complete_Sup_Sup @ B @ ( image @ A @ B @ F2 @ A3 ) ) @ ( F2 @ ( complete_Sup_Sup @ A @ A3 ) ) ) ) ) ).

% mono_Sup
thf(fact_7343_mono__INF,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( ( comple6319245703460814977attice @ A )
        & ( comple6319245703460814977attice @ B ) )
     => ! [F2: A > B,A3: C > A,I6: set @ C] :
          ( ( order_mono @ A @ B @ F2 )
         => ( ord_less_eq @ B @ ( F2 @ ( complete_Inf_Inf @ A @ ( image @ C @ A @ A3 @ I6 ) ) )
            @ ( complete_Inf_Inf @ B
              @ ( image @ C @ B
                @ ^ [X5: C] : ( F2 @ ( A3 @ X5 ) )
                @ I6 ) ) ) ) ) ).

% mono_INF
thf(fact_7344_mono__Inf,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( comple6319245703460814977attice @ A )
        & ( comple6319245703460814977attice @ B ) )
     => ! [F2: A > B,A3: set @ A] :
          ( ( order_mono @ A @ B @ F2 )
         => ( ord_less_eq @ B @ ( F2 @ ( complete_Inf_Inf @ A @ A3 ) ) @ ( complete_Inf_Inf @ B @ ( image @ A @ B @ F2 @ A3 ) ) ) ) ) ).

% mono_Inf
thf(fact_7345_antimono__funpow,axiom,
    ! [A: $tType] :
      ( ( ( lattice @ A )
        & ( order_top @ A ) )
     => ! [Q: A > A] :
          ( ( order_mono @ A @ A @ Q )
         => ( order_antimono @ nat @ A
            @ ^ [I4: nat] : ( compow @ ( A > A ) @ I4 @ Q @ ( top_top @ A ) ) ) ) ) ).

% antimono_funpow
thf(fact_7346_card_Oeq__fold,axiom,
    ! [A: $tType] :
      ( ( finite_card @ A )
      = ( finite_fold @ A @ nat
        @ ^ [Uu3: A] : suc
        @ ( zero_zero @ nat ) ) ) ).

% card.eq_fold
thf(fact_7347_incseq__le,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [X8: nat > A,L5: A,N2: nat] :
          ( ( order_mono @ nat @ A @ X8 )
         => ( ( filterlim @ nat @ A @ X8 @ ( topolo7230453075368039082e_nhds @ A @ L5 ) @ ( at_top @ nat ) )
           => ( ord_less_eq @ A @ ( X8 @ N2 ) @ L5 ) ) ) ) ).

% incseq_le
thf(fact_7348_funpow__increasing,axiom,
    ! [A: $tType] :
      ( ( ( lattice @ A )
        & ( order_top @ A ) )
     => ! [M: nat,N2: nat,F2: A > A] :
          ( ( ord_less_eq @ nat @ M @ N2 )
         => ( ( order_mono @ A @ A @ F2 )
           => ( ord_less_eq @ A @ ( compow @ ( A > A ) @ N2 @ F2 @ ( top_top @ A ) ) @ ( compow @ ( A > A ) @ M @ F2 @ ( top_top @ A ) ) ) ) ) ) ).

% funpow_increasing
thf(fact_7349_funpow__decreasing,axiom,
    ! [A: $tType] :
      ( ( ( lattice @ A )
        & ( order_bot @ A ) )
     => ! [M: nat,N2: nat,F2: A > A] :
          ( ( ord_less_eq @ nat @ M @ N2 )
         => ( ( order_mono @ A @ A @ F2 )
           => ( ord_less_eq @ A @ ( compow @ ( A > A ) @ M @ F2 @ ( bot_bot @ A ) ) @ ( compow @ ( A > A ) @ N2 @ F2 @ ( bot_bot @ A ) ) ) ) ) ) ).

% funpow_decreasing
thf(fact_7350_incseq__convergent,axiom,
    ! [X8: nat > real,B3: real] :
      ( ( order_mono @ nat @ real @ X8 )
     => ( ! [I2: nat] : ( ord_less_eq @ real @ ( X8 @ I2 ) @ B3 )
       => ~ ! [L6: real] :
              ( ( filterlim @ nat @ real @ X8 @ ( topolo7230453075368039082e_nhds @ real @ L6 ) @ ( at_top @ nat ) )
             => ~ ! [I: nat] : ( ord_less_eq @ real @ ( X8 @ I ) @ L6 ) ) ) ) ).

% incseq_convergent
thf(fact_7351_sorted__list__of__set_Ofold__insort__key_Oeq__fold,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( ( linord4507533701916653071of_set @ A )
        = ( finite_fold @ A @ ( list @ A )
          @ ( linorder_insort_key @ A @ A
            @ ^ [X5: A] : X5 )
          @ ( nil @ A ) ) ) ) ).

% sorted_list_of_set.fold_insort_key.eq_fold
thf(fact_7352_mono__ge2__power__minus__self,axiom,
    ! [K: nat] :
      ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ K )
     => ( order_mono @ nat @ nat
        @ ^ [M6: nat] : ( minus_minus @ nat @ ( power_power @ nat @ K @ M6 ) @ M6 ) ) ) ).

% mono_ge2_power_minus_self
thf(fact_7353_finite__mono__remains__stable__implies__strict__prefix,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [F2: nat > A] :
          ( ( finite_finite @ A @ ( image @ nat @ A @ F2 @ ( top_top @ ( set @ nat ) ) ) )
         => ( ( order_mono @ nat @ A @ F2 )
           => ( ! [N: nat] :
                  ( ( ( F2 @ N )
                    = ( F2 @ ( suc @ N ) ) )
                 => ( ( F2 @ ( suc @ N ) )
                    = ( F2 @ ( suc @ ( suc @ N ) ) ) ) )
             => ? [N8: nat] :
                  ( ! [N9: nat] :
                      ( ( ord_less_eq @ nat @ N9 @ N8 )
                     => ! [M2: nat] :
                          ( ( ord_less_eq @ nat @ M2 @ N8 )
                         => ( ( ord_less @ nat @ M2 @ N9 )
                           => ( ord_less @ A @ ( F2 @ M2 ) @ ( F2 @ N9 ) ) ) ) )
                  & ! [N9: nat] :
                      ( ( ord_less_eq @ nat @ N8 @ N9 )
                     => ( ( F2 @ N8 )
                        = ( F2 @ N9 ) ) ) ) ) ) ) ) ).

% finite_mono_remains_stable_implies_strict_prefix
thf(fact_7354_tendsto__at__left__sequentially,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( topolo3112930676232923870pology @ B )
        & ( topolo1944317154257567458pology @ B )
        & ( topolo4958980785337419405_space @ A ) )
     => ! [B2: B,A2: B,X8: B > A,L5: A] :
          ( ( ord_less @ B @ B2 @ A2 )
         => ( ! [S4: nat > B] :
                ( ! [N9: nat] : ( ord_less @ B @ ( S4 @ N9 ) @ A2 )
               => ( ! [N9: nat] : ( ord_less @ B @ B2 @ ( S4 @ N9 ) )
                 => ( ( order_mono @ nat @ B @ S4 )
                   => ( ( filterlim @ nat @ B @ S4 @ ( topolo7230453075368039082e_nhds @ B @ A2 ) @ ( at_top @ nat ) )
                     => ( filterlim @ nat @ A
                        @ ^ [N3: nat] : ( X8 @ ( S4 @ N3 ) )
                        @ ( topolo7230453075368039082e_nhds @ A @ L5 )
                        @ ( at_top @ nat ) ) ) ) ) )
           => ( filterlim @ B @ A @ X8 @ ( topolo7230453075368039082e_nhds @ A @ L5 ) @ ( topolo174197925503356063within @ B @ A2 @ ( set_ord_lessThan @ B @ A2 ) ) ) ) ) ) ).

% tendsto_at_left_sequentially
thf(fact_7355_remdups__adj__altdef,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A] :
      ( ( ( remdups_adj @ A @ Xs )
        = Ys )
      = ( ? [F5: nat > nat] :
            ( ( order_mono @ nat @ nat @ F5 )
            & ( ( image @ nat @ nat @ F5 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( size_size @ ( list @ A ) @ Xs ) ) )
              = ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( size_size @ ( list @ A ) @ Ys ) ) )
            & ! [I4: nat] :
                ( ( ord_less @ nat @ I4 @ ( size_size @ ( list @ A ) @ Xs ) )
               => ( ( nth @ A @ Xs @ I4 )
                  = ( nth @ A @ Ys @ ( F5 @ I4 ) ) ) )
            & ! [I4: nat] :
                ( ( ord_less @ nat @ ( plus_plus @ nat @ I4 @ ( one_one @ nat ) ) @ ( size_size @ ( list @ A ) @ Xs ) )
               => ( ( ( nth @ A @ Xs @ I4 )
                    = ( nth @ A @ Xs @ ( plus_plus @ nat @ I4 @ ( one_one @ nat ) ) ) )
                  = ( ( F5 @ I4 )
                    = ( F5 @ ( plus_plus @ nat @ I4 @ ( one_one @ nat ) ) ) ) ) ) ) ) ) ).

% remdups_adj_altdef
thf(fact_7356_insert__relcomp__union__fold,axiom,
    ! [C: $tType,B: $tType,A: $tType,S3: set @ ( product_prod @ A @ B ),X2: product_prod @ C @ A,X8: set @ ( product_prod @ C @ B )] :
      ( ( finite_finite @ ( product_prod @ A @ B ) @ S3 )
     => ( ( sup_sup @ ( set @ ( product_prod @ C @ B ) ) @ ( relcomp @ C @ A @ B @ ( insert @ ( product_prod @ C @ A ) @ X2 @ ( bot_bot @ ( set @ ( product_prod @ C @ A ) ) ) ) @ S3 ) @ X8 )
        = ( finite_fold @ ( product_prod @ A @ B ) @ ( set @ ( product_prod @ C @ B ) )
          @ ( product_case_prod @ A @ B @ ( ( set @ ( product_prod @ C @ B ) ) > ( set @ ( product_prod @ C @ B ) ) )
            @ ^ [W3: A,Z6: B,A17: set @ ( product_prod @ C @ B )] :
                ( if @ ( set @ ( product_prod @ C @ B ) )
                @ ( ( product_snd @ C @ A @ X2 )
                  = W3 )
                @ ( insert @ ( product_prod @ C @ B ) @ ( product_Pair @ C @ B @ ( product_fst @ C @ A @ X2 ) @ Z6 ) @ A17 )
                @ A17 ) )
          @ X8
          @ S3 ) ) ) ).

% insert_relcomp_union_fold
thf(fact_7357_remdups__adj__Nil__iff,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( ( remdups_adj @ A @ Xs )
        = ( nil @ A ) )
      = ( Xs
        = ( nil @ A ) ) ) ).

% remdups_adj_Nil_iff
thf(fact_7358_remdups__adj__set,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( set2 @ A @ ( remdups_adj @ A @ Xs ) )
      = ( set2 @ A @ Xs ) ) ).

% remdups_adj_set
thf(fact_7359_mono__Un,axiom,
    ! [B: $tType,A: $tType,F2: ( set @ A ) > ( set @ B ),A3: set @ A,B3: set @ A] :
      ( ( order_mono @ ( set @ A ) @ ( set @ B ) @ F2 )
     => ( ord_less_eq @ ( set @ B ) @ ( sup_sup @ ( set @ B ) @ ( F2 @ A3 ) @ ( F2 @ B3 ) ) @ ( F2 @ ( sup_sup @ ( set @ A ) @ A3 @ B3 ) ) ) ) ).

% mono_Un
thf(fact_7360_mono__Int,axiom,
    ! [B: $tType,A: $tType,F2: ( set @ A ) > ( set @ B ),A3: set @ A,B3: set @ A] :
      ( ( order_mono @ ( set @ A ) @ ( set @ B ) @ F2 )
     => ( ord_less_eq @ ( set @ B ) @ ( F2 @ ( inf_inf @ ( set @ A ) @ A3 @ B3 ) ) @ ( inf_inf @ ( set @ B ) @ ( F2 @ A3 ) @ ( F2 @ B3 ) ) ) ) ).

% mono_Int
thf(fact_7361_relpow_Osimps_I2_J,axiom,
    ! [A: $tType,N2: nat,R: set @ ( product_prod @ A @ A )] :
      ( ( compow @ ( set @ ( product_prod @ A @ A ) ) @ ( suc @ N2 ) @ R )
      = ( relcomp @ A @ A @ A @ ( compow @ ( set @ ( product_prod @ A @ A ) ) @ N2 @ R ) @ R ) ) ).

% relpow.simps(2)
thf(fact_7362_relpow__add,axiom,
    ! [A: $tType,M: nat,N2: nat,R: set @ ( product_prod @ A @ A )] :
      ( ( compow @ ( set @ ( product_prod @ A @ A ) ) @ ( plus_plus @ nat @ M @ N2 ) @ R )
      = ( relcomp @ A @ A @ A @ ( compow @ ( set @ ( product_prod @ A @ A ) ) @ M @ R ) @ ( compow @ ( set @ ( product_prod @ A @ A ) ) @ N2 @ R ) ) ) ).

% relpow_add
thf(fact_7363_remdups__adj_Osimps_I2_J,axiom,
    ! [A: $tType,X2: A] :
      ( ( remdups_adj @ A @ ( cons @ A @ X2 @ ( nil @ A ) ) )
      = ( cons @ A @ X2 @ ( nil @ A ) ) ) ).

% remdups_adj.simps(2)
thf(fact_7364_remdups__adj_Oelims,axiom,
    ! [A: $tType,X2: list @ A,Y2: list @ A] :
      ( ( ( remdups_adj @ A @ X2 )
        = Y2 )
     => ( ( ( X2
            = ( nil @ A ) )
         => ( Y2
           != ( nil @ A ) ) )
       => ( ! [X3: A] :
              ( ( X2
                = ( cons @ A @ X3 @ ( nil @ A ) ) )
             => ( Y2
               != ( cons @ A @ X3 @ ( nil @ A ) ) ) )
         => ~ ! [X3: A,Y4: A,Xs2: list @ A] :
                ( ( X2
                  = ( cons @ A @ X3 @ ( cons @ A @ Y4 @ Xs2 ) ) )
               => ~ ( ( ( X3 = Y4 )
                     => ( Y2
                        = ( remdups_adj @ A @ ( cons @ A @ X3 @ Xs2 ) ) ) )
                    & ( ( X3 != Y4 )
                     => ( Y2
                        = ( cons @ A @ X3 @ ( remdups_adj @ A @ ( cons @ A @ Y4 @ Xs2 ) ) ) ) ) ) ) ) ) ) ).

% remdups_adj.elims
thf(fact_7365_remdups__adj_Osimps_I1_J,axiom,
    ! [A: $tType] :
      ( ( remdups_adj @ A @ ( nil @ A ) )
      = ( nil @ A ) ) ).

% remdups_adj.simps(1)
thf(fact_7366_remdups__adj_Osimps_I3_J,axiom,
    ! [A: $tType,X2: A,Y2: A,Xs: list @ A] :
      ( ( ( X2 = Y2 )
       => ( ( remdups_adj @ A @ ( cons @ A @ X2 @ ( cons @ A @ Y2 @ Xs ) ) )
          = ( remdups_adj @ A @ ( cons @ A @ X2 @ Xs ) ) ) )
      & ( ( X2 != Y2 )
       => ( ( remdups_adj @ A @ ( cons @ A @ X2 @ ( cons @ A @ Y2 @ Xs ) ) )
          = ( cons @ A @ X2 @ ( remdups_adj @ A @ ( cons @ A @ Y2 @ Xs ) ) ) ) ) ) ).

% remdups_adj.simps(3)
thf(fact_7367_remdups__adj__distinct,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( distinct @ A @ Xs )
     => ( ( remdups_adj @ A @ Xs )
        = Xs ) ) ).

% remdups_adj_distinct
thf(fact_7368_relcomp_Ocases,axiom,
    ! [A: $tType,C: $tType,B: $tType,A1: A,A22: C,R3: set @ ( product_prod @ A @ B ),S2: set @ ( product_prod @ B @ C )] :
      ( ( member @ ( product_prod @ A @ C ) @ ( product_Pair @ A @ C @ A1 @ A22 ) @ ( relcomp @ A @ B @ C @ R3 @ S2 ) )
     => ~ ! [B5: B] :
            ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ A1 @ B5 ) @ R3 )
           => ~ ( member @ ( product_prod @ B @ C ) @ ( product_Pair @ B @ C @ B5 @ A22 ) @ S2 ) ) ) ).

% relcomp.cases
thf(fact_7369_relcomp_Osimps,axiom,
    ! [B: $tType,C: $tType,A: $tType,A1: A,A22: C,R3: set @ ( product_prod @ A @ B ),S2: set @ ( product_prod @ B @ C )] :
      ( ( member @ ( product_prod @ A @ C ) @ ( product_Pair @ A @ C @ A1 @ A22 ) @ ( relcomp @ A @ B @ C @ R3 @ S2 ) )
      = ( ? [A4: A,B4: B,C4: C] :
            ( ( A1 = A4 )
            & ( A22 = C4 )
            & ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ A4 @ B4 ) @ R3 )
            & ( member @ ( product_prod @ B @ C ) @ ( product_Pair @ B @ C @ B4 @ C4 ) @ S2 ) ) ) ) ).

% relcomp.simps
thf(fact_7370_relcomp_OrelcompI,axiom,
    ! [A: $tType,C: $tType,B: $tType,A2: A,B2: B,R3: set @ ( product_prod @ A @ B ),C2: C,S2: set @ ( product_prod @ B @ C )] :
      ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ A2 @ B2 ) @ R3 )
     => ( ( member @ ( product_prod @ B @ C ) @ ( product_Pair @ B @ C @ B2 @ C2 ) @ S2 )
       => ( member @ ( product_prod @ A @ C ) @ ( product_Pair @ A @ C @ A2 @ C2 ) @ ( relcomp @ A @ B @ C @ R3 @ S2 ) ) ) ) ).

% relcomp.relcompI
thf(fact_7371_relcompE,axiom,
    ! [A: $tType,B: $tType,C: $tType,Xz: product_prod @ A @ B,R3: set @ ( product_prod @ A @ C ),S2: set @ ( product_prod @ C @ B )] :
      ( ( member @ ( product_prod @ A @ B ) @ Xz @ ( relcomp @ A @ C @ B @ R3 @ S2 ) )
     => ~ ! [X3: A,Y4: C,Z3: B] :
            ( ( Xz
              = ( product_Pair @ A @ B @ X3 @ Z3 ) )
           => ( ( member @ ( product_prod @ A @ C ) @ ( product_Pair @ A @ C @ X3 @ Y4 ) @ R3 )
             => ~ ( member @ ( product_prod @ C @ B ) @ ( product_Pair @ C @ B @ Y4 @ Z3 ) @ S2 ) ) ) ) ).

% relcompE
thf(fact_7372_relcompEpair,axiom,
    ! [A: $tType,B: $tType,C: $tType,A2: A,C2: B,R3: set @ ( product_prod @ A @ C ),S2: set @ ( product_prod @ C @ B )] :
      ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ A2 @ C2 ) @ ( relcomp @ A @ C @ B @ R3 @ S2 ) )
     => ~ ! [B5: C] :
            ( ( member @ ( product_prod @ A @ C ) @ ( product_Pair @ A @ C @ A2 @ B5 ) @ R3 )
           => ~ ( member @ ( product_prod @ C @ B ) @ ( product_Pair @ C @ B @ B5 @ C2 ) @ S2 ) ) ) ).

% relcompEpair
thf(fact_7373_remdups__adj__length,axiom,
    ! [A: $tType,Xs: list @ A] : ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ ( remdups_adj @ A @ Xs ) ) @ ( size_size @ ( list @ A ) @ Xs ) ) ).

% remdups_adj_length
thf(fact_7374_relcomp__mono,axiom,
    ! [A: $tType,C: $tType,B: $tType,R2: set @ ( product_prod @ A @ B ),R3: set @ ( product_prod @ A @ B ),S8: set @ ( product_prod @ B @ C ),S2: set @ ( product_prod @ B @ C )] :
      ( ( ord_less_eq @ ( set @ ( product_prod @ A @ B ) ) @ R2 @ R3 )
     => ( ( ord_less_eq @ ( set @ ( product_prod @ B @ C ) ) @ S8 @ S2 )
       => ( ord_less_eq @ ( set @ ( product_prod @ A @ C ) ) @ ( relcomp @ A @ B @ C @ R2 @ S8 ) @ ( relcomp @ A @ B @ C @ R3 @ S2 ) ) ) ) ).

% relcomp_mono
thf(fact_7375_trancl__Int__subset,axiom,
    ! [A: $tType,R3: set @ ( product_prod @ A @ A ),S2: set @ ( product_prod @ A @ A )] :
      ( ( ord_less_eq @ ( set @ ( product_prod @ A @ A ) ) @ R3 @ S2 )
     => ( ( ord_less_eq @ ( set @ ( product_prod @ A @ A ) ) @ ( relcomp @ A @ A @ A @ ( inf_inf @ ( set @ ( product_prod @ A @ A ) ) @ ( transitive_trancl @ A @ R3 ) @ S2 ) @ R3 ) @ S2 )
       => ( ord_less_eq @ ( set @ ( product_prod @ A @ A ) ) @ ( transitive_trancl @ A @ R3 ) @ S2 ) ) ) ).

% trancl_Int_subset
thf(fact_7376_remdups__adj__append__two,axiom,
    ! [A: $tType,Xs: list @ A,X2: A,Y2: A] :
      ( ( remdups_adj @ A @ ( append @ A @ Xs @ ( cons @ A @ X2 @ ( cons @ A @ Y2 @ ( nil @ A ) ) ) ) )
      = ( append @ A @ ( remdups_adj @ A @ ( append @ A @ Xs @ ( cons @ A @ X2 @ ( nil @ A ) ) ) ) @ ( if @ ( list @ A ) @ ( X2 = Y2 ) @ ( nil @ A ) @ ( cons @ A @ Y2 @ ( nil @ A ) ) ) ) ) ).

% remdups_adj_append_two
thf(fact_7377_relcomp__unfold,axiom,
    ! [B: $tType,C: $tType,A: $tType] :
      ( ( relcomp @ A @ C @ B )
      = ( ^ [R5: set @ ( product_prod @ A @ C ),S7: set @ ( product_prod @ C @ B )] :
            ( collect @ ( product_prod @ A @ B )
            @ ( product_case_prod @ A @ B @ $o
              @ ^ [X5: A,Z6: B] :
                ? [Y5: C] :
                  ( ( member @ ( product_prod @ A @ C ) @ ( product_Pair @ A @ C @ X5 @ Y5 ) @ R5 )
                  & ( member @ ( product_prod @ C @ B ) @ ( product_Pair @ C @ B @ Y5 @ Z6 ) @ S7 ) ) ) ) ) ) ).

% relcomp_unfold
thf(fact_7378_ord_Olexordp_Omono,axiom,
    ! [A: $tType,Less: A > A > $o] :
      ( order_mono @ ( ( list @ A ) > ( list @ A ) > $o ) @ ( ( list @ A ) > ( list @ A ) > $o )
      @ ^ [P6: ( list @ A ) > ( list @ A ) > $o,X17: list @ A,X24: list @ A] :
          ( ? [Y5: A,Ys3: list @ A] :
              ( ( X17
                = ( nil @ A ) )
              & ( X24
                = ( cons @ A @ Y5 @ Ys3 ) ) )
          | ? [X5: A,Y5: A,Xs3: list @ A,Ys3: list @ A] :
              ( ( X17
                = ( cons @ A @ X5 @ Xs3 ) )
              & ( X24
                = ( cons @ A @ Y5 @ Ys3 ) )
              & ( Less @ X5 @ Y5 ) )
          | ? [X5: A,Y5: A,Xs3: list @ A,Ys3: list @ A] :
              ( ( X17
                = ( cons @ A @ X5 @ Xs3 ) )
              & ( X24
                = ( cons @ A @ Y5 @ Ys3 ) )
              & ~ ( Less @ X5 @ Y5 )
              & ~ ( Less @ Y5 @ X5 )
              & ( P6 @ Xs3 @ Ys3 ) ) ) ) ).

% ord.lexordp.mono
thf(fact_7379_remdups__adj__adjacent,axiom,
    ! [A: $tType,I3: nat,Xs: list @ A] :
      ( ( ord_less @ nat @ ( suc @ I3 ) @ ( size_size @ ( list @ A ) @ ( remdups_adj @ A @ Xs ) ) )
     => ( ( nth @ A @ ( remdups_adj @ A @ Xs ) @ I3 )
       != ( nth @ A @ ( remdups_adj @ A @ Xs ) @ ( suc @ I3 ) ) ) ) ).

% remdups_adj_adjacent
thf(fact_7380_remdups__adj__replicate,axiom,
    ! [A: $tType,N2: nat,X2: A] :
      ( ( ( N2
          = ( zero_zero @ nat ) )
       => ( ( remdups_adj @ A @ ( replicate @ A @ N2 @ X2 ) )
          = ( nil @ A ) ) )
      & ( ( N2
         != ( zero_zero @ nat ) )
       => ( ( remdups_adj @ A @ ( replicate @ A @ N2 @ X2 ) )
          = ( cons @ A @ X2 @ ( nil @ A ) ) ) ) ) ).

% remdups_adj_replicate
thf(fact_7381_remdups__adj__singleton,axiom,
    ! [A: $tType,Xs: list @ A,X2: A] :
      ( ( ( remdups_adj @ A @ Xs )
        = ( cons @ A @ X2 @ ( nil @ A ) ) )
     => ( Xs
        = ( replicate @ A @ ( size_size @ ( list @ A ) @ Xs ) @ X2 ) ) ) ).

% remdups_adj_singleton
thf(fact_7382_relcomp__fold,axiom,
    ! [C: $tType,B: $tType,A: $tType,R: set @ ( product_prod @ A @ B ),S3: set @ ( product_prod @ B @ C )] :
      ( ( finite_finite @ ( product_prod @ A @ B ) @ R )
     => ( ( finite_finite @ ( product_prod @ B @ C ) @ S3 )
       => ( ( relcomp @ A @ B @ C @ R @ S3 )
          = ( finite_fold @ ( product_prod @ A @ B ) @ ( set @ ( product_prod @ A @ C ) )
            @ ( product_case_prod @ A @ B @ ( ( set @ ( product_prod @ A @ C ) ) > ( set @ ( product_prod @ A @ C ) ) )
              @ ^ [X5: A,Y5: B,A7: set @ ( product_prod @ A @ C )] :
                  ( finite_fold @ ( product_prod @ B @ C ) @ ( set @ ( product_prod @ A @ C ) )
                  @ ( product_case_prod @ B @ C @ ( ( set @ ( product_prod @ A @ C ) ) > ( set @ ( product_prod @ A @ C ) ) )
                    @ ^ [W3: B,Z6: C,A17: set @ ( product_prod @ A @ C )] : ( if @ ( set @ ( product_prod @ A @ C ) ) @ ( Y5 = W3 ) @ ( insert @ ( product_prod @ A @ C ) @ ( product_Pair @ A @ C @ X5 @ Z6 ) @ A17 ) @ A17 ) )
                  @ A7
                  @ S3 ) )
            @ ( bot_bot @ ( set @ ( product_prod @ A @ C ) ) )
            @ R ) ) ) ) ).

% relcomp_fold
thf(fact_7383_lexordp_Omono,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ( order_mono @ ( ( list @ A ) > ( list @ A ) > $o ) @ ( ( list @ A ) > ( list @ A ) > $o )
        @ ^ [P6: ( list @ A ) > ( list @ A ) > $o,X17: list @ A,X24: list @ A] :
            ( ? [Y5: A,Ys3: list @ A] :
                ( ( X17
                  = ( nil @ A ) )
                & ( X24
                  = ( cons @ A @ Y5 @ Ys3 ) ) )
            | ? [X5: A,Y5: A,Xs3: list @ A,Ys3: list @ A] :
                ( ( X17
                  = ( cons @ A @ X5 @ Xs3 ) )
                & ( X24
                  = ( cons @ A @ Y5 @ Ys3 ) )
                & ( ord_less @ A @ X5 @ Y5 ) )
            | ? [X5: A,Y5: A,Xs3: list @ A,Ys3: list @ A] :
                ( ( X17
                  = ( cons @ A @ X5 @ Xs3 ) )
                & ( X24
                  = ( cons @ A @ Y5 @ Ys3 ) )
                & ~ ( ord_less @ A @ X5 @ Y5 )
                & ~ ( ord_less @ A @ Y5 @ X5 )
                & ( P6 @ Xs3 @ Ys3 ) ) ) ) ) ).

% lexordp.mono
thf(fact_7384_remdups__adj__length__ge1,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( Xs
       != ( nil @ A ) )
     => ( ord_less_eq @ nat @ ( suc @ ( zero_zero @ nat ) ) @ ( size_size @ ( list @ A ) @ ( remdups_adj @ A @ Xs ) ) ) ) ).

% remdups_adj_length_ge1
thf(fact_7385_insert__relcomp__fold,axiom,
    ! [C: $tType,B: $tType,A: $tType,S3: set @ ( product_prod @ A @ B ),X2: product_prod @ C @ A,R: set @ ( product_prod @ C @ A )] :
      ( ( finite_finite @ ( product_prod @ A @ B ) @ S3 )
     => ( ( relcomp @ C @ A @ B @ ( insert @ ( product_prod @ C @ A ) @ X2 @ R ) @ S3 )
        = ( finite_fold @ ( product_prod @ A @ B ) @ ( set @ ( product_prod @ C @ B ) )
          @ ( product_case_prod @ A @ B @ ( ( set @ ( product_prod @ C @ B ) ) > ( set @ ( product_prod @ C @ B ) ) )
            @ ^ [W3: A,Z6: B,A17: set @ ( product_prod @ C @ B )] :
                ( if @ ( set @ ( product_prod @ C @ B ) )
                @ ( ( product_snd @ C @ A @ X2 )
                  = W3 )
                @ ( insert @ ( product_prod @ C @ B ) @ ( product_Pair @ C @ B @ ( product_fst @ C @ A @ X2 ) @ Z6 ) @ A17 )
                @ A17 ) )
          @ ( relcomp @ C @ A @ B @ R @ S3 )
          @ S3 ) ) ) ).

% insert_relcomp_fold
thf(fact_7386_min__ext__compat,axiom,
    ! [A: $tType,R: set @ ( product_prod @ A @ A ),S3: set @ ( product_prod @ A @ A )] :
      ( ( ord_less_eq @ ( set @ ( product_prod @ A @ A ) ) @ ( relcomp @ A @ A @ A @ R @ S3 ) @ R )
     => ( ord_less_eq @ ( set @ ( product_prod @ ( set @ A ) @ ( set @ A ) ) ) @ ( relcomp @ ( set @ A ) @ ( set @ A ) @ ( set @ A ) @ ( min_ext @ A @ R ) @ ( sup_sup @ ( set @ ( product_prod @ ( set @ A ) @ ( set @ A ) ) ) @ ( min_ext @ A @ S3 ) @ ( insert @ ( product_prod @ ( set @ A ) @ ( set @ A ) ) @ ( product_Pair @ ( set @ A ) @ ( set @ A ) @ ( bot_bot @ ( set @ A ) ) @ ( bot_bot @ ( set @ A ) ) ) @ ( bot_bot @ ( set @ ( product_prod @ ( set @ A ) @ ( set @ A ) ) ) ) ) ) ) @ ( min_ext @ A @ R ) ) ) ).

% min_ext_compat
thf(fact_7387_comp__fun__commute__relcomp__fold,axiom,
    ! [A: $tType,B: $tType,C: $tType,S3: set @ ( product_prod @ A @ B )] :
      ( ( finite_finite @ ( product_prod @ A @ B ) @ S3 )
     => ( finite6289374366891150609ommute @ ( product_prod @ C @ A ) @ ( set @ ( product_prod @ C @ B ) )
        @ ( product_case_prod @ C @ A @ ( ( set @ ( product_prod @ C @ B ) ) > ( set @ ( product_prod @ C @ B ) ) )
          @ ^ [X5: C,Y5: A,A7: set @ ( product_prod @ C @ B )] :
              ( finite_fold @ ( product_prod @ A @ B ) @ ( set @ ( product_prod @ C @ B ) )
              @ ( product_case_prod @ A @ B @ ( ( set @ ( product_prod @ C @ B ) ) > ( set @ ( product_prod @ C @ B ) ) )
                @ ^ [W3: A,Z6: B,A17: set @ ( product_prod @ C @ B )] : ( if @ ( set @ ( product_prod @ C @ B ) ) @ ( Y5 = W3 ) @ ( insert @ ( product_prod @ C @ B ) @ ( product_Pair @ C @ B @ X5 @ Z6 ) @ A17 ) @ A17 ) )
              @ A7
              @ S3 ) ) ) ) ).

% comp_fun_commute_relcomp_fold
thf(fact_7388_comp__fun__commute__product__fold,axiom,
    ! [A: $tType,B: $tType,B3: set @ A] :
      ( ( finite_finite @ A @ B3 )
     => ( finite6289374366891150609ommute @ B @ ( set @ ( product_prod @ B @ A ) )
        @ ^ [X5: B,Z6: set @ ( product_prod @ B @ A )] :
            ( finite_fold @ A @ ( set @ ( product_prod @ B @ A ) )
            @ ^ [Y5: A] : ( insert @ ( product_prod @ B @ A ) @ ( product_Pair @ B @ A @ X5 @ Y5 ) )
            @ Z6
            @ B3 ) ) ) ).

% comp_fun_commute_product_fold
thf(fact_7389_max__ext__compat,axiom,
    ! [A: $tType,R: set @ ( product_prod @ A @ A ),S3: set @ ( product_prod @ A @ A )] :
      ( ( ord_less_eq @ ( set @ ( product_prod @ A @ A ) ) @ ( relcomp @ A @ A @ A @ R @ S3 ) @ R )
     => ( ord_less_eq @ ( set @ ( product_prod @ ( set @ A ) @ ( set @ A ) ) ) @ ( relcomp @ ( set @ A ) @ ( set @ A ) @ ( set @ A ) @ ( max_ext @ A @ R ) @ ( sup_sup @ ( set @ ( product_prod @ ( set @ A ) @ ( set @ A ) ) ) @ ( max_ext @ A @ S3 ) @ ( insert @ ( product_prod @ ( set @ A ) @ ( set @ A ) ) @ ( product_Pair @ ( set @ A ) @ ( set @ A ) @ ( bot_bot @ ( set @ A ) ) @ ( bot_bot @ ( set @ A ) ) ) @ ( bot_bot @ ( set @ ( product_prod @ ( set @ A ) @ ( set @ A ) ) ) ) ) ) ) @ ( max_ext @ A @ R ) ) ) ).

% max_ext_compat
thf(fact_7390_remdups__adj_Opelims,axiom,
    ! [A: $tType,X2: list @ A,Y2: list @ A] :
      ( ( ( remdups_adj @ A @ X2 )
        = Y2 )
     => ( ( accp @ ( list @ A ) @ ( remdups_adj_rel @ A ) @ X2 )
       => ( ( ( X2
              = ( nil @ A ) )
           => ( ( Y2
                = ( nil @ A ) )
             => ~ ( accp @ ( list @ A ) @ ( remdups_adj_rel @ A ) @ ( nil @ A ) ) ) )
         => ( ! [X3: A] :
                ( ( X2
                  = ( cons @ A @ X3 @ ( nil @ A ) ) )
               => ( ( Y2
                    = ( cons @ A @ X3 @ ( nil @ A ) ) )
                 => ~ ( accp @ ( list @ A ) @ ( remdups_adj_rel @ A ) @ ( cons @ A @ X3 @ ( nil @ A ) ) ) ) )
           => ~ ! [X3: A,Y4: A,Xs2: list @ A] :
                  ( ( X2
                    = ( cons @ A @ X3 @ ( cons @ A @ Y4 @ Xs2 ) ) )
                 => ( ( ( ( X3 = Y4 )
                       => ( Y2
                          = ( remdups_adj @ A @ ( cons @ A @ X3 @ Xs2 ) ) ) )
                      & ( ( X3 != Y4 )
                       => ( Y2
                          = ( cons @ A @ X3 @ ( remdups_adj @ A @ ( cons @ A @ Y4 @ Xs2 ) ) ) ) ) )
                   => ~ ( accp @ ( list @ A ) @ ( remdups_adj_rel @ A ) @ ( cons @ A @ X3 @ ( cons @ A @ Y4 @ Xs2 ) ) ) ) ) ) ) ) ) ).

% remdups_adj.pelims
thf(fact_7391_max__ext_Ocases,axiom,
    ! [A: $tType,A1: set @ A,A22: set @ A,R: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ ( set @ A ) @ ( set @ A ) ) @ ( product_Pair @ ( set @ A ) @ ( set @ A ) @ A1 @ A22 ) @ ( max_ext @ A @ R ) )
     => ~ ( ( finite_finite @ A @ A1 )
         => ( ( finite_finite @ A @ A22 )
           => ( ( A22
               != ( bot_bot @ ( set @ A ) ) )
             => ~ ! [X: A] :
                    ( ( member @ A @ X @ A1 )
                   => ? [Xa3: A] :
                        ( ( member @ A @ Xa3 @ A22 )
                        & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Xa3 ) @ R ) ) ) ) ) ) ) ).

% max_ext.cases
thf(fact_7392_max__ext_Osimps,axiom,
    ! [A: $tType,A1: set @ A,A22: set @ A,R: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ ( set @ A ) @ ( set @ A ) ) @ ( product_Pair @ ( set @ A ) @ ( set @ A ) @ A1 @ A22 ) @ ( max_ext @ A @ R ) )
      = ( ( finite_finite @ A @ A1 )
        & ( finite_finite @ A @ A22 )
        & ( A22
         != ( bot_bot @ ( set @ A ) ) )
        & ! [X5: A] :
            ( ( member @ A @ X5 @ A1 )
           => ? [Y5: A] :
                ( ( member @ A @ Y5 @ A22 )
                & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X5 @ Y5 ) @ R ) ) ) ) ) ).

% max_ext.simps
thf(fact_7393_max__ext_Omax__extI,axiom,
    ! [A: $tType,X8: set @ A,Y8: set @ A,R: set @ ( product_prod @ A @ A )] :
      ( ( finite_finite @ A @ X8 )
     => ( ( finite_finite @ A @ Y8 )
       => ( ( Y8
           != ( bot_bot @ ( set @ A ) ) )
         => ( ! [X3: A] :
                ( ( member @ A @ X3 @ X8 )
               => ? [Xa: A] :
                    ( ( member @ A @ Xa @ Y8 )
                    & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X3 @ Xa ) @ R ) ) )
           => ( member @ ( product_prod @ ( set @ A ) @ ( set @ A ) ) @ ( product_Pair @ ( set @ A ) @ ( set @ A ) @ X8 @ Y8 ) @ ( max_ext @ A @ R ) ) ) ) ) ) ).

% max_ext.max_extI
thf(fact_7394_max__ext__def,axiom,
    ! [A: $tType] :
      ( ( max_ext @ A )
      = ( ^ [R6: set @ ( product_prod @ A @ A )] :
            ( collect @ ( product_prod @ ( set @ A ) @ ( set @ A ) )
            @ ( product_case_prod @ ( set @ A ) @ ( set @ A ) @ $o
              @ ( max_extp @ A
                @ ^ [X5: A,Y5: A] : ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X5 @ Y5 ) @ R6 ) ) ) ) ) ) ).

% max_ext_def
thf(fact_7395_set__relcomp,axiom,
    ! [B: $tType,C: $tType,A: $tType,Xys2: list @ ( product_prod @ A @ C ),Yzs: list @ ( product_prod @ C @ B )] :
      ( ( relcomp @ A @ C @ B @ ( set2 @ ( product_prod @ A @ C ) @ Xys2 ) @ ( set2 @ ( product_prod @ C @ B ) @ Yzs ) )
      = ( set2 @ ( product_prod @ A @ B )
        @ ( concat @ ( product_prod @ A @ B )
          @ ( map @ ( product_prod @ A @ C ) @ ( list @ ( product_prod @ A @ B ) )
            @ ^ [Xy: product_prod @ A @ C] :
                ( concat @ ( product_prod @ A @ B )
                @ ( map @ ( product_prod @ C @ B ) @ ( list @ ( product_prod @ A @ B ) )
                  @ ^ [Yz: product_prod @ C @ B] :
                      ( if @ ( list @ ( product_prod @ A @ B ) )
                      @ ( ( product_snd @ A @ C @ Xy )
                        = ( product_fst @ C @ B @ Yz ) )
                      @ ( cons @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ ( product_fst @ A @ C @ Xy ) @ ( product_snd @ C @ B @ Yz ) ) @ ( nil @ ( product_prod @ A @ B ) ) )
                      @ ( nil @ ( product_prod @ A @ B ) ) )
                  @ Yzs ) )
            @ Xys2 ) ) ) ) ).

% set_relcomp
thf(fact_7396_map__ident,axiom,
    ! [A: $tType] :
      ( ( map @ A @ A
        @ ^ [X5: A] : X5 )
      = ( ^ [Xs3: list @ A] : Xs3 ) ) ).

% map_ident
thf(fact_7397_map__is__Nil__conv,axiom,
    ! [A: $tType,B: $tType,F2: B > A,Xs: list @ B] :
      ( ( ( map @ B @ A @ F2 @ Xs )
        = ( nil @ A ) )
      = ( Xs
        = ( nil @ B ) ) ) ).

% map_is_Nil_conv
thf(fact_7398_Nil__is__map__conv,axiom,
    ! [A: $tType,B: $tType,F2: B > A,Xs: list @ B] :
      ( ( ( nil @ A )
        = ( map @ B @ A @ F2 @ Xs ) )
      = ( Xs
        = ( nil @ B ) ) ) ).

% Nil_is_map_conv
thf(fact_7399_list_Omap__disc__iff,axiom,
    ! [B: $tType,A: $tType,F2: A > B,A2: list @ A] :
      ( ( ( map @ A @ B @ F2 @ A2 )
        = ( nil @ B ) )
      = ( A2
        = ( nil @ A ) ) ) ).

% list.map_disc_iff
thf(fact_7400_map__map,axiom,
    ! [B: $tType,A: $tType,C: $tType,F2: B > A,G: C > B,Xs: list @ C] :
      ( ( map @ B @ A @ F2 @ ( map @ C @ B @ G @ Xs ) )
      = ( map @ C @ A @ ( comp @ B @ A @ C @ F2 @ G ) @ Xs ) ) ).

% map_map
thf(fact_7401_List_Omap_Ocompositionality,axiom,
    ! [B: $tType,C: $tType,A: $tType,F2: B > C,G: A > B,List: list @ A] :
      ( ( map @ B @ C @ F2 @ ( map @ A @ B @ G @ List ) )
      = ( map @ A @ C @ ( comp @ B @ C @ A @ F2 @ G ) @ List ) ) ).

% List.map.compositionality
thf(fact_7402_list_Omap__comp,axiom,
    ! [B: $tType,C: $tType,A: $tType,G: B > C,F2: A > B,V: list @ A] :
      ( ( map @ B @ C @ G @ ( map @ A @ B @ F2 @ V ) )
      = ( map @ A @ C @ ( comp @ B @ C @ A @ G @ F2 ) @ V ) ) ).

% list.map_comp
thf(fact_7403_map__eq__conv,axiom,
    ! [A: $tType,B: $tType,F2: B > A,Xs: list @ B,G: B > A] :
      ( ( ( map @ B @ A @ F2 @ Xs )
        = ( map @ B @ A @ G @ Xs ) )
      = ( ! [X5: B] :
            ( ( member @ B @ X5 @ ( set2 @ B @ Xs ) )
           => ( ( F2 @ X5 )
              = ( G @ X5 ) ) ) ) ) ).

% map_eq_conv
thf(fact_7404_length__map,axiom,
    ! [A: $tType,B: $tType,F2: B > A,Xs: list @ B] :
      ( ( size_size @ ( list @ A ) @ ( map @ B @ A @ F2 @ Xs ) )
      = ( size_size @ ( list @ B ) @ Xs ) ) ).

% length_map
thf(fact_7405_map__append,axiom,
    ! [A: $tType,B: $tType,F2: B > A,Xs: list @ B,Ys: list @ B] :
      ( ( map @ B @ A @ F2 @ ( append @ B @ Xs @ Ys ) )
      = ( append @ A @ ( map @ B @ A @ F2 @ Xs ) @ ( map @ B @ A @ F2 @ Ys ) ) ) ).

% map_append
thf(fact_7406_map__replicate,axiom,
    ! [A: $tType,B: $tType,F2: B > A,N2: nat,X2: B] :
      ( ( map @ B @ A @ F2 @ ( replicate @ B @ N2 @ X2 ) )
      = ( replicate @ A @ N2 @ ( F2 @ X2 ) ) ) ).

% map_replicate
thf(fact_7407_list_Oset__map,axiom,
    ! [B: $tType,A: $tType,F2: A > B,V: list @ A] :
      ( ( set2 @ B @ ( map @ A @ B @ F2 @ V ) )
      = ( image @ A @ B @ F2 @ ( set2 @ A @ V ) ) ) ).

% list.set_map
thf(fact_7408_List_Omap_Ocomp,axiom,
    ! [C: $tType,B: $tType,A: $tType,F2: B > C,G: A > B] :
      ( ( comp @ ( list @ B ) @ ( list @ C ) @ ( list @ A ) @ ( map @ B @ C @ F2 ) @ ( map @ A @ B @ G ) )
      = ( map @ A @ C @ ( comp @ B @ C @ A @ F2 @ G ) ) ) ).

% List.map.comp
thf(fact_7409_map__comp__map,axiom,
    ! [B: $tType,C: $tType,A: $tType,F2: C > B,G: A > C] :
      ( ( comp @ ( list @ C ) @ ( list @ B ) @ ( list @ A ) @ ( map @ C @ B @ F2 ) @ ( map @ A @ C @ G ) )
      = ( map @ A @ B @ ( comp @ C @ B @ A @ F2 @ G ) ) ) ).

% map_comp_map
thf(fact_7410_size__list__map,axiom,
    ! [A: $tType,B: $tType,F2: A > nat,G: B > A,Xs: list @ B] :
      ( ( size_list @ A @ F2 @ ( map @ B @ A @ G @ Xs ) )
      = ( size_list @ B @ ( comp @ A @ nat @ B @ F2 @ G ) @ Xs ) ) ).

% size_list_map
thf(fact_7411_nth__map,axiom,
    ! [B: $tType,A: $tType,N2: nat,Xs: list @ A,F2: A > B] :
      ( ( ord_less @ nat @ N2 @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( ( nth @ B @ ( map @ A @ B @ F2 @ Xs ) @ N2 )
        = ( F2 @ ( nth @ A @ Xs @ N2 ) ) ) ) ).

% nth_map
thf(fact_7412_concat__map__singleton,axiom,
    ! [A: $tType,B: $tType,F2: B > A,Xs: list @ B] :
      ( ( concat @ A
        @ ( map @ B @ ( list @ A )
          @ ^ [X5: B] : ( cons @ A @ ( F2 @ X5 ) @ ( nil @ A ) )
          @ Xs ) )
      = ( map @ B @ A @ F2 @ Xs ) ) ).

% concat_map_singleton
thf(fact_7413_append__eq__map__conv,axiom,
    ! [A: $tType,B: $tType,Ys: list @ A,Zs: list @ A,F2: B > A,Xs: list @ B] :
      ( ( ( append @ A @ Ys @ Zs )
        = ( map @ B @ A @ F2 @ Xs ) )
      = ( ? [Us2: list @ B,Vs3: list @ B] :
            ( ( Xs
              = ( append @ B @ Us2 @ Vs3 ) )
            & ( Ys
              = ( map @ B @ A @ F2 @ Us2 ) )
            & ( Zs
              = ( map @ B @ A @ F2 @ Vs3 ) ) ) ) ) ).

% append_eq_map_conv
thf(fact_7414_map__eq__append__conv,axiom,
    ! [A: $tType,B: $tType,F2: B > A,Xs: list @ B,Ys: list @ A,Zs: list @ A] :
      ( ( ( map @ B @ A @ F2 @ Xs )
        = ( append @ A @ Ys @ Zs ) )
      = ( ? [Us2: list @ B,Vs3: list @ B] :
            ( ( Xs
              = ( append @ B @ Us2 @ Vs3 ) )
            & ( Ys
              = ( map @ B @ A @ F2 @ Us2 ) )
            & ( Zs
              = ( map @ B @ A @ F2 @ Vs3 ) ) ) ) ) ).

% map_eq_append_conv
thf(fact_7415_map__eq__imp__length__eq,axiom,
    ! [A: $tType,B: $tType,C: $tType,F2: B > A,Xs: list @ B,G: C > A,Ys: list @ C] :
      ( ( ( map @ B @ A @ F2 @ Xs )
        = ( map @ C @ A @ G @ Ys ) )
     => ( ( size_size @ ( list @ B ) @ Xs )
        = ( size_size @ ( list @ C ) @ Ys ) ) ) ).

% map_eq_imp_length_eq
thf(fact_7416_map__replicate__const,axiom,
    ! [B: $tType,A: $tType,K: A,Lst: list @ B] :
      ( ( map @ B @ A
        @ ^ [X5: B] : K
        @ Lst )
      = ( replicate @ A @ ( size_size @ ( list @ B ) @ Lst ) @ K ) ) ).

% map_replicate_const
thf(fact_7417_map__eq__Cons__conv,axiom,
    ! [A: $tType,B: $tType,F2: B > A,Xs: list @ B,Y2: A,Ys: list @ A] :
      ( ( ( map @ B @ A @ F2 @ Xs )
        = ( cons @ A @ Y2 @ Ys ) )
      = ( ? [Z6: B,Zs3: list @ B] :
            ( ( Xs
              = ( cons @ B @ Z6 @ Zs3 ) )
            & ( ( F2 @ Z6 )
              = Y2 )
            & ( ( map @ B @ A @ F2 @ Zs3 )
              = Ys ) ) ) ) ).

% map_eq_Cons_conv
thf(fact_7418_Cons__eq__map__conv,axiom,
    ! [A: $tType,B: $tType,X2: A,Xs: list @ A,F2: B > A,Ys: list @ B] :
      ( ( ( cons @ A @ X2 @ Xs )
        = ( map @ B @ A @ F2 @ Ys ) )
      = ( ? [Z6: B,Zs3: list @ B] :
            ( ( Ys
              = ( cons @ B @ Z6 @ Zs3 ) )
            & ( X2
              = ( F2 @ Z6 ) )
            & ( Xs
              = ( map @ B @ A @ F2 @ Zs3 ) ) ) ) ) ).

% Cons_eq_map_conv
thf(fact_7419_map__eq__Cons__D,axiom,
    ! [B: $tType,A: $tType,F2: B > A,Xs: list @ B,Y2: A,Ys: list @ A] :
      ( ( ( map @ B @ A @ F2 @ Xs )
        = ( cons @ A @ Y2 @ Ys ) )
     => ? [Z3: B,Zs2: list @ B] :
          ( ( Xs
            = ( cons @ B @ Z3 @ Zs2 ) )
          & ( ( F2 @ Z3 )
            = Y2 )
          & ( ( map @ B @ A @ F2 @ Zs2 )
            = Ys ) ) ) ).

% map_eq_Cons_D
thf(fact_7420_Cons__eq__map__D,axiom,
    ! [A: $tType,B: $tType,X2: A,Xs: list @ A,F2: B > A,Ys: list @ B] :
      ( ( ( cons @ A @ X2 @ Xs )
        = ( map @ B @ A @ F2 @ Ys ) )
     => ? [Z3: B,Zs2: list @ B] :
          ( ( Ys
            = ( cons @ B @ Z3 @ Zs2 ) )
          & ( X2
            = ( F2 @ Z3 ) )
          & ( Xs
            = ( map @ B @ A @ F2 @ Zs2 ) ) ) ) ).

% Cons_eq_map_D
thf(fact_7421_list_Osimps_I9_J,axiom,
    ! [B: $tType,A: $tType,F2: A > B,X21: A,X222: list @ A] :
      ( ( map @ A @ B @ F2 @ ( cons @ A @ X21 @ X222 ) )
      = ( cons @ B @ ( F2 @ X21 ) @ ( map @ A @ B @ F2 @ X222 ) ) ) ).

% list.simps(9)
thf(fact_7422_n__lists_Osimps_I2_J,axiom,
    ! [A: $tType,N2: nat,Xs: list @ A] :
      ( ( n_lists @ A @ ( suc @ N2 ) @ Xs )
      = ( concat @ ( list @ A )
        @ ( map @ ( list @ A ) @ ( list @ ( list @ A ) )
          @ ^ [Ys3: list @ A] :
              ( map @ A @ ( list @ A )
              @ ^ [Y5: A] : ( cons @ A @ Y5 @ Ys3 )
              @ Xs )
          @ ( n_lists @ A @ N2 @ Xs ) ) ) ) ).

% n_lists.simps(2)
thf(fact_7423_rotate1__map,axiom,
    ! [A: $tType,B: $tType,F2: B > A,Xs: list @ B] :
      ( ( rotate1 @ A @ ( map @ B @ A @ F2 @ Xs ) )
      = ( map @ B @ A @ F2 @ ( rotate1 @ B @ Xs ) ) ) ).

% rotate1_map
thf(fact_7424_pair__list__eqI,axiom,
    ! [B: $tType,A: $tType,Xs: list @ ( product_prod @ A @ B ),Ys: list @ ( product_prod @ A @ B )] :
      ( ( ( map @ ( product_prod @ A @ B ) @ A @ ( product_fst @ A @ B ) @ Xs )
        = ( map @ ( product_prod @ A @ B ) @ A @ ( product_fst @ A @ B ) @ Ys ) )
     => ( ( ( map @ ( product_prod @ A @ B ) @ B @ ( product_snd @ A @ B ) @ Xs )
          = ( map @ ( product_prod @ A @ B ) @ B @ ( product_snd @ A @ B ) @ Ys ) )
       => ( Xs = Ys ) ) ) ).

% pair_list_eqI
thf(fact_7425_map__update,axiom,
    ! [A: $tType,B: $tType,F2: B > A,Xs: list @ B,K: nat,Y2: B] :
      ( ( map @ B @ A @ F2 @ ( list_update @ B @ Xs @ K @ Y2 ) )
      = ( list_update @ A @ ( map @ B @ A @ F2 @ Xs ) @ K @ ( F2 @ Y2 ) ) ) ).

% map_update
thf(fact_7426_map__concat,axiom,
    ! [A: $tType,B: $tType,F2: B > A,Xs: list @ ( list @ B )] :
      ( ( map @ B @ A @ F2 @ ( concat @ B @ Xs ) )
      = ( concat @ A @ ( map @ ( list @ B ) @ ( list @ A ) @ ( map @ B @ A @ F2 ) @ Xs ) ) ) ).

% map_concat
thf(fact_7427_list_Omap__ident,axiom,
    ! [A: $tType,T2: list @ A] :
      ( ( map @ A @ A
        @ ^ [X5: A] : X5
        @ T2 )
      = T2 ) ).

% list.map_ident
thf(fact_7428_remdups__map__remdups,axiom,
    ! [A: $tType,B: $tType,F2: B > A,Xs: list @ B] :
      ( ( remdups @ A @ ( map @ B @ A @ F2 @ ( remdups @ B @ Xs ) ) )
      = ( remdups @ A @ ( map @ B @ A @ F2 @ Xs ) ) ) ).

% remdups_map_remdups
thf(fact_7429_list_Osimps_I8_J,axiom,
    ! [A: $tType,B: $tType,F2: A > B] :
      ( ( map @ A @ B @ F2 @ ( nil @ A ) )
      = ( nil @ B ) ) ).

% list.simps(8)
thf(fact_7430_image__set,axiom,
    ! [A: $tType,B: $tType,F2: B > A,Xs: list @ B] :
      ( ( image @ B @ A @ F2 @ ( set2 @ B @ Xs ) )
      = ( set2 @ A @ ( map @ B @ A @ F2 @ Xs ) ) ) ).

% image_set
thf(fact_7431_ex__map__conv,axiom,
    ! [A: $tType,B: $tType,Ys: list @ B,F2: A > B] :
      ( ( ? [Xs3: list @ A] :
            ( Ys
            = ( map @ A @ B @ F2 @ Xs3 ) ) )
      = ( ! [X5: B] :
            ( ( member @ B @ X5 @ ( set2 @ B @ Ys ) )
           => ? [Y5: A] :
                ( X5
                = ( F2 @ Y5 ) ) ) ) ) ).

% ex_map_conv
thf(fact_7432_map__cong,axiom,
    ! [B: $tType,A: $tType,Xs: list @ A,Ys: list @ A,F2: A > B,G: A > B] :
      ( ( Xs = Ys )
     => ( ! [X3: A] :
            ( ( member @ A @ X3 @ ( set2 @ A @ Ys ) )
           => ( ( F2 @ X3 )
              = ( G @ X3 ) ) )
       => ( ( map @ A @ B @ F2 @ Xs )
          = ( map @ A @ B @ G @ Ys ) ) ) ) ).

% map_cong
thf(fact_7433_map__idI,axiom,
    ! [A: $tType,Xs: list @ A,F2: A > A] :
      ( ! [X3: A] :
          ( ( member @ A @ X3 @ ( set2 @ A @ Xs ) )
         => ( ( F2 @ X3 )
            = X3 ) )
     => ( ( map @ A @ A @ F2 @ Xs )
        = Xs ) ) ).

% map_idI
thf(fact_7434_map__ext,axiom,
    ! [B: $tType,A: $tType,Xs: list @ A,F2: A > B,G: A > B] :
      ( ! [X3: A] :
          ( ( member @ A @ X3 @ ( set2 @ A @ Xs ) )
         => ( ( F2 @ X3 )
            = ( G @ X3 ) ) )
     => ( ( map @ A @ B @ F2 @ Xs )
        = ( map @ A @ B @ G @ Xs ) ) ) ).

% map_ext
thf(fact_7435_list_Oinj__map__strong,axiom,
    ! [B: $tType,A: $tType,X2: list @ A,Xa2: list @ A,F2: A > B,Fa: A > B] :
      ( ! [Z3: A,Za: A] :
          ( ( member @ A @ Z3 @ ( set2 @ A @ X2 ) )
         => ( ( member @ A @ Za @ ( set2 @ A @ Xa2 ) )
           => ( ( ( F2 @ Z3 )
                = ( Fa @ Za ) )
             => ( Z3 = Za ) ) ) )
     => ( ( ( map @ A @ B @ F2 @ X2 )
          = ( map @ A @ B @ Fa @ Xa2 ) )
       => ( X2 = Xa2 ) ) ) ).

% list.inj_map_strong
thf(fact_7436_list_Omap__cong0,axiom,
    ! [B: $tType,A: $tType,X2: list @ A,F2: A > B,G: A > B] :
      ( ! [Z3: A] :
          ( ( member @ A @ Z3 @ ( set2 @ A @ X2 ) )
         => ( ( F2 @ Z3 )
            = ( G @ Z3 ) ) )
     => ( ( map @ A @ B @ F2 @ X2 )
        = ( map @ A @ B @ G @ X2 ) ) ) ).

% list.map_cong0
thf(fact_7437_list_Omap__cong,axiom,
    ! [B: $tType,A: $tType,X2: list @ A,Ya: list @ A,F2: A > B,G: A > B] :
      ( ( X2 = Ya )
     => ( ! [Z3: A] :
            ( ( member @ A @ Z3 @ ( set2 @ A @ Ya ) )
           => ( ( F2 @ Z3 )
              = ( G @ Z3 ) ) )
       => ( ( map @ A @ B @ F2 @ X2 )
          = ( map @ A @ B @ G @ Ya ) ) ) ) ).

% list.map_cong
thf(fact_7438_list_Osize__gen__o__map,axiom,
    ! [B: $tType,A: $tType,F2: B > nat,G: A > B] :
      ( ( comp @ ( list @ B ) @ nat @ ( list @ A ) @ ( size_list @ B @ F2 ) @ ( map @ A @ B @ G ) )
      = ( size_list @ A @ ( comp @ B @ nat @ A @ F2 @ G ) ) ) ).

% list.size_gen_o_map
thf(fact_7439_distinct__insort__key,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F2: B > A,X2: B,Xs: list @ B] :
          ( ( distinct @ A @ ( map @ B @ A @ F2 @ ( linorder_insort_key @ B @ A @ F2 @ X2 @ Xs ) ) )
          = ( ~ ( member @ A @ ( F2 @ X2 ) @ ( image @ B @ A @ F2 @ ( set2 @ B @ Xs ) ) )
            & ( distinct @ A @ ( map @ B @ A @ F2 @ Xs ) ) ) ) ) ).

% distinct_insort_key
thf(fact_7440_max__extp__max__ext__eq,axiom,
    ! [A: $tType,R: set @ ( product_prod @ A @ A )] :
      ( ( max_extp @ A
        @ ^ [X5: A,Y5: A] : ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X5 @ Y5 ) @ R ) )
      = ( ^ [X5: set @ A,Y5: set @ A] : ( member @ ( product_prod @ ( set @ A ) @ ( set @ A ) ) @ ( product_Pair @ ( set @ A ) @ ( set @ A ) @ X5 @ Y5 ) @ ( max_ext @ A @ R ) ) ) ) ).

% max_extp_max_ext_eq
thf(fact_7441_eq__key__imp__eq__value,axiom,
    ! [A: $tType,B: $tType,Xs: list @ ( product_prod @ A @ B ),K: A,V1: B,V22: B] :
      ( ( distinct @ A @ ( map @ ( product_prod @ A @ B ) @ A @ ( product_fst @ A @ B ) @ Xs ) )
     => ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ K @ V1 ) @ ( set2 @ ( product_prod @ A @ B ) @ Xs ) )
       => ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ K @ V22 ) @ ( set2 @ ( product_prod @ A @ B ) @ Xs ) )
         => ( V1 = V22 ) ) ) ) ).

% eq_key_imp_eq_value
thf(fact_7442_image2__def,axiom,
    ! [A: $tType,B: $tType,C: $tType] :
      ( ( bNF_Greatest_image2 @ C @ A @ B )
      = ( ^ [A7: set @ C,F5: C > A,G4: C > B] :
            ( collect @ ( product_prod @ A @ B )
            @ ^ [Uu3: product_prod @ A @ B] :
              ? [A4: C] :
                ( ( Uu3
                  = ( product_Pair @ A @ B @ ( F5 @ A4 ) @ ( G4 @ A4 ) ) )
                & ( member @ C @ A4 @ A7 ) ) ) ) ) ).

% image2_def
thf(fact_7443_map__snd__enumerate,axiom,
    ! [A: $tType,N2: nat,Xs: list @ A] :
      ( ( map @ ( product_prod @ nat @ A ) @ A @ ( product_snd @ nat @ A ) @ ( enumerate @ A @ N2 @ Xs ) )
      = Xs ) ).

% map_snd_enumerate
thf(fact_7444_product__lists_Osimps_I2_J,axiom,
    ! [A: $tType,Xs: list @ A,Xss: list @ ( list @ A )] :
      ( ( product_lists @ A @ ( cons @ ( list @ A ) @ Xs @ Xss ) )
      = ( concat @ ( list @ A )
        @ ( map @ A @ ( list @ ( list @ A ) )
          @ ^ [X5: A] : ( map @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X5 ) @ ( product_lists @ A @ Xss ) )
          @ Xs ) ) ) ).

% product_lists.simps(2)
thf(fact_7445_enumerate__Suc__eq,axiom,
    ! [A: $tType,N2: nat,Xs: list @ A] :
      ( ( enumerate @ A @ ( suc @ N2 ) @ Xs )
      = ( map @ ( product_prod @ nat @ A ) @ ( product_prod @ nat @ A ) @ ( product_apfst @ nat @ nat @ A @ suc ) @ ( enumerate @ A @ N2 @ Xs ) ) ) ).

% enumerate_Suc_eq
thf(fact_7446_distinct__set__subseqs,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( distinct @ A @ Xs )
     => ( distinct @ ( set @ A ) @ ( map @ ( list @ A ) @ ( set @ A ) @ ( set2 @ A ) @ ( subseqs @ A @ Xs ) ) ) ) ).

% distinct_set_subseqs
thf(fact_7447_image2__eqI,axiom,
    ! [A: $tType,C: $tType,B: $tType,B2: A,F2: B > A,X2: B,C2: C,G: B > C,A3: set @ B] :
      ( ( B2
        = ( F2 @ X2 ) )
     => ( ( C2
          = ( G @ X2 ) )
       => ( ( member @ B @ X2 @ A3 )
         => ( member @ ( product_prod @ A @ C ) @ ( product_Pair @ A @ C @ B2 @ C2 ) @ ( bNF_Greatest_image2 @ B @ A @ C @ A3 @ F2 @ G ) ) ) ) ) ).

% image2_eqI
thf(fact_7448_subseqs_Osimps_I2_J,axiom,
    ! [A: $tType,X2: A,Xs: list @ A] :
      ( ( subseqs @ A @ ( cons @ A @ X2 @ Xs ) )
      = ( append @ ( list @ A ) @ ( map @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X2 ) @ ( subseqs @ A @ Xs ) ) @ ( subseqs @ A @ Xs ) ) ) ).

% subseqs.simps(2)
thf(fact_7449_Id__on__set,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( id_on @ A @ ( set2 @ A @ Xs ) )
      = ( set2 @ ( product_prod @ A @ A )
        @ ( map @ A @ ( product_prod @ A @ A )
          @ ^ [X5: A] : ( product_Pair @ A @ A @ X5 @ X5 )
          @ Xs ) ) ) ).

% Id_on_set
thf(fact_7450_product_Osimps_I2_J,axiom,
    ! [A: $tType,B: $tType,X2: A,Xs: list @ A,Ys: list @ B] :
      ( ( product @ A @ B @ ( cons @ A @ X2 @ Xs ) @ Ys )
      = ( append @ ( product_prod @ A @ B ) @ ( map @ B @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X2 ) @ Ys ) @ ( product @ A @ B @ Xs @ Ys ) ) ) ).

% product.simps(2)
thf(fact_7451_product__concat__map,axiom,
    ! [B: $tType,A: $tType] :
      ( ( product @ A @ B )
      = ( ^ [Xs3: list @ A,Ys3: list @ B] :
            ( concat @ ( product_prod @ A @ B )
            @ ( map @ A @ ( list @ ( product_prod @ A @ B ) )
              @ ^ [X5: A] : ( map @ B @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X5 ) @ Ys3 )
              @ Xs3 ) ) ) ) ).

% product_concat_map
thf(fact_7452_product__code,axiom,
    ! [B: $tType,A: $tType,Xs: list @ A,Ys: list @ B] :
      ( ( product_product @ A @ B @ ( set2 @ A @ Xs ) @ ( set2 @ B @ Ys ) )
      = ( set2 @ ( product_prod @ A @ B )
        @ ( concat @ ( product_prod @ A @ B )
          @ ( map @ A @ ( list @ ( product_prod @ A @ B ) )
            @ ^ [X5: A] : ( map @ B @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X5 ) @ Ys )
            @ Xs ) ) ) ) ).

% product_code
thf(fact_7453_list_Ocase__distrib,axiom,
    ! [B: $tType,C: $tType,A: $tType,H2: B > C,F1: B,F22: A > ( list @ A ) > B,List: list @ A] :
      ( ( H2 @ ( case_list @ B @ A @ F1 @ F22 @ List ) )
      = ( case_list @ C @ A @ ( H2 @ F1 )
        @ ^ [X17: A,X24: list @ A] : ( H2 @ ( F22 @ X17 @ X24 ) )
        @ List ) ) ).

% list.case_distrib
thf(fact_7454_list_Osimps_I4_J,axiom,
    ! [A: $tType,B: $tType,F1: B,F22: A > ( list @ A ) > B] :
      ( ( case_list @ B @ A @ F1 @ F22 @ ( nil @ A ) )
      = F1 ) ).

% list.simps(4)
thf(fact_7455_list_Osimps_I5_J,axiom,
    ! [B: $tType,A: $tType,F1: B,F22: A > ( list @ A ) > B,X21: A,X222: list @ A] :
      ( ( case_list @ B @ A @ F1 @ F22 @ ( cons @ A @ X21 @ X222 ) )
      = ( F22 @ X21 @ X222 ) ) ).

% list.simps(5)
thf(fact_7456_remdups__adj__Cons,axiom,
    ! [A: $tType,X2: A,Xs: list @ A] :
      ( ( remdups_adj @ A @ ( cons @ A @ X2 @ Xs ) )
      = ( case_list @ ( list @ A ) @ A @ ( cons @ A @ X2 @ ( nil @ A ) )
        @ ^ [Y5: A,Xs3: list @ A] : ( if @ ( list @ A ) @ ( X2 = Y5 ) @ ( cons @ A @ Y5 @ Xs3 ) @ ( cons @ A @ X2 @ ( cons @ A @ Y5 @ Xs3 ) ) )
        @ ( remdups_adj @ A @ Xs ) ) ) ).

% remdups_adj_Cons
thf(fact_7457_transpose_Opinduct,axiom,
    ! [A: $tType,A0: list @ ( list @ A ),P: ( list @ ( list @ A ) ) > $o] :
      ( ( accp @ ( list @ ( list @ A ) ) @ ( transpose_rel @ A ) @ A0 )
     => ( ( ( accp @ ( list @ ( list @ A ) ) @ ( transpose_rel @ A ) @ ( nil @ ( list @ A ) ) )
         => ( P @ ( nil @ ( list @ A ) ) ) )
       => ( ! [Xss2: list @ ( list @ A )] :
              ( ( accp @ ( list @ ( list @ A ) ) @ ( transpose_rel @ A ) @ ( cons @ ( list @ A ) @ ( nil @ A ) @ Xss2 ) )
             => ( ( P @ Xss2 )
               => ( P @ ( cons @ ( list @ A ) @ ( nil @ A ) @ Xss2 ) ) ) )
         => ( ! [X3: A,Xs2: list @ A,Xss2: list @ ( list @ A )] :
                ( ( accp @ ( list @ ( list @ A ) ) @ ( transpose_rel @ A ) @ ( cons @ ( list @ A ) @ ( cons @ A @ X3 @ Xs2 ) @ Xss2 ) )
               => ( ( P
                    @ ( cons @ ( list @ A ) @ Xs2
                      @ ( concat @ ( list @ A )
                        @ ( map @ ( list @ A ) @ ( list @ ( list @ A ) )
                          @ ( case_list @ ( list @ ( list @ A ) ) @ A @ ( nil @ ( list @ A ) )
                            @ ^ [H: A,T3: list @ A] : ( cons @ ( list @ A ) @ T3 @ ( nil @ ( list @ A ) ) ) )
                          @ Xss2 ) ) ) )
                 => ( P @ ( cons @ ( list @ A ) @ ( cons @ A @ X3 @ Xs2 ) @ Xss2 ) ) ) )
           => ( P @ A0 ) ) ) ) ) ).

% transpose.pinduct
thf(fact_7458_transpose_Oelims,axiom,
    ! [A: $tType,X2: list @ ( list @ A ),Y2: list @ ( list @ A )] :
      ( ( ( transpose @ A @ X2 )
        = Y2 )
     => ( ( ( X2
            = ( nil @ ( list @ A ) ) )
         => ( Y2
           != ( nil @ ( list @ A ) ) ) )
       => ( ! [Xss2: list @ ( list @ A )] :
              ( ( X2
                = ( cons @ ( list @ A ) @ ( nil @ A ) @ Xss2 ) )
             => ( Y2
               != ( transpose @ A @ Xss2 ) ) )
         => ~ ! [X3: A,Xs2: list @ A,Xss2: list @ ( list @ A )] :
                ( ( X2
                  = ( cons @ ( list @ A ) @ ( cons @ A @ X3 @ Xs2 ) @ Xss2 ) )
               => ( Y2
                 != ( cons @ ( list @ A )
                    @ ( cons @ A @ X3
                      @ ( concat @ A
                        @ ( map @ ( list @ A ) @ ( list @ A )
                          @ ( case_list @ ( list @ A ) @ A @ ( nil @ A )
                            @ ^ [H: A,T3: list @ A] : ( cons @ A @ H @ ( nil @ A ) ) )
                          @ Xss2 ) ) )
                    @ ( transpose @ A
                      @ ( cons @ ( list @ A ) @ Xs2
                        @ ( concat @ ( list @ A )
                          @ ( map @ ( list @ A ) @ ( list @ ( list @ A ) )
                            @ ( case_list @ ( list @ ( list @ A ) ) @ A @ ( nil @ ( list @ A ) )
                              @ ^ [H: A,T3: list @ A] : ( cons @ ( list @ A ) @ T3 @ ( nil @ ( list @ A ) ) ) )
                            @ Xss2 ) ) ) ) ) ) ) ) ) ) ).

% transpose.elims
thf(fact_7459_transpose__map__map,axiom,
    ! [A: $tType,B: $tType,F2: B > A,Xs: list @ ( list @ B )] :
      ( ( transpose @ A @ ( map @ ( list @ B ) @ ( list @ A ) @ ( map @ B @ A @ F2 ) @ Xs ) )
      = ( map @ ( list @ B ) @ ( list @ A ) @ ( map @ B @ A @ F2 ) @ ( transpose @ B @ Xs ) ) ) ).

% transpose_map_map
thf(fact_7460_list_Odisc__eq__case_I1_J,axiom,
    ! [A: $tType,List: list @ A] :
      ( ( List
        = ( nil @ A ) )
      = ( case_list @ $o @ A @ $true
        @ ^ [Uu3: A,Uv3: list @ A] : $false
        @ List ) ) ).

% list.disc_eq_case(1)
thf(fact_7461_list_Odisc__eq__case_I2_J,axiom,
    ! [A: $tType,List: list @ A] :
      ( ( ( List
         != ( nil @ A ) ) )
      = ( case_list @ $o @ A @ $false
        @ ^ [Uu3: A,Uv3: list @ A] : $true
        @ List ) ) ).

% list.disc_eq_case(2)
thf(fact_7462_transpose_Opsimps_I2_J,axiom,
    ! [A: $tType,Xss: list @ ( list @ A )] :
      ( ( accp @ ( list @ ( list @ A ) ) @ ( transpose_rel @ A ) @ ( cons @ ( list @ A ) @ ( nil @ A ) @ Xss ) )
     => ( ( transpose @ A @ ( cons @ ( list @ A ) @ ( nil @ A ) @ Xss ) )
        = ( transpose @ A @ Xss ) ) ) ).

% transpose.psimps(2)
thf(fact_7463_transpose_Osimps_I2_J,axiom,
    ! [A: $tType,Xss: list @ ( list @ A )] :
      ( ( transpose @ A @ ( cons @ ( list @ A ) @ ( nil @ A ) @ Xss ) )
      = ( transpose @ A @ Xss ) ) ).

% transpose.simps(2)
thf(fact_7464_transpose_Osimps_I1_J,axiom,
    ! [A: $tType] :
      ( ( transpose @ A @ ( nil @ ( list @ A ) ) )
      = ( nil @ ( list @ A ) ) ) ).

% transpose.simps(1)
thf(fact_7465_transpose_Opsimps_I1_J,axiom,
    ! [A: $tType] :
      ( ( accp @ ( list @ ( list @ A ) ) @ ( transpose_rel @ A ) @ ( nil @ ( list @ A ) ) )
     => ( ( transpose @ A @ ( nil @ ( list @ A ) ) )
        = ( nil @ ( list @ A ) ) ) ) ).

% transpose.psimps(1)
thf(fact_7466_transpose__empty,axiom,
    ! [A: $tType,Xs: list @ ( list @ A )] :
      ( ( ( transpose @ A @ Xs )
        = ( nil @ ( list @ A ) ) )
      = ( ! [X5: list @ A] :
            ( ( member @ ( list @ A ) @ X5 @ ( set2 @ ( list @ A ) @ Xs ) )
           => ( X5
              = ( nil @ A ) ) ) ) ) ).

% transpose_empty
thf(fact_7467_transpose_Opsimps_I3_J,axiom,
    ! [A: $tType,X2: A,Xs: list @ A,Xss: list @ ( list @ A )] :
      ( ( accp @ ( list @ ( list @ A ) ) @ ( transpose_rel @ A ) @ ( cons @ ( list @ A ) @ ( cons @ A @ X2 @ Xs ) @ Xss ) )
     => ( ( transpose @ A @ ( cons @ ( list @ A ) @ ( cons @ A @ X2 @ Xs ) @ Xss ) )
        = ( cons @ ( list @ A )
          @ ( cons @ A @ X2
            @ ( concat @ A
              @ ( map @ ( list @ A ) @ ( list @ A )
                @ ( case_list @ ( list @ A ) @ A @ ( nil @ A )
                  @ ^ [H: A,T3: list @ A] : ( cons @ A @ H @ ( nil @ A ) ) )
                @ Xss ) ) )
          @ ( transpose @ A
            @ ( cons @ ( list @ A ) @ Xs
              @ ( concat @ ( list @ A )
                @ ( map @ ( list @ A ) @ ( list @ ( list @ A ) )
                  @ ( case_list @ ( list @ ( list @ A ) ) @ A @ ( nil @ ( list @ A ) )
                    @ ^ [H: A,T3: list @ A] : ( cons @ ( list @ A ) @ T3 @ ( nil @ ( list @ A ) ) ) )
                  @ Xss ) ) ) ) ) ) ) ).

% transpose.psimps(3)
thf(fact_7468_transpose_Opelims,axiom,
    ! [A: $tType,X2: list @ ( list @ A ),Y2: list @ ( list @ A )] :
      ( ( ( transpose @ A @ X2 )
        = Y2 )
     => ( ( accp @ ( list @ ( list @ A ) ) @ ( transpose_rel @ A ) @ X2 )
       => ( ( ( X2
              = ( nil @ ( list @ A ) ) )
           => ( ( Y2
                = ( nil @ ( list @ A ) ) )
             => ~ ( accp @ ( list @ ( list @ A ) ) @ ( transpose_rel @ A ) @ ( nil @ ( list @ A ) ) ) ) )
         => ( ! [Xss2: list @ ( list @ A )] :
                ( ( X2
                  = ( cons @ ( list @ A ) @ ( nil @ A ) @ Xss2 ) )
               => ( ( Y2
                    = ( transpose @ A @ Xss2 ) )
                 => ~ ( accp @ ( list @ ( list @ A ) ) @ ( transpose_rel @ A ) @ ( cons @ ( list @ A ) @ ( nil @ A ) @ Xss2 ) ) ) )
           => ~ ! [X3: A,Xs2: list @ A,Xss2: list @ ( list @ A )] :
                  ( ( X2
                    = ( cons @ ( list @ A ) @ ( cons @ A @ X3 @ Xs2 ) @ Xss2 ) )
                 => ( ( Y2
                      = ( cons @ ( list @ A )
                        @ ( cons @ A @ X3
                          @ ( concat @ A
                            @ ( map @ ( list @ A ) @ ( list @ A )
                              @ ( case_list @ ( list @ A ) @ A @ ( nil @ A )
                                @ ^ [H: A,T3: list @ A] : ( cons @ A @ H @ ( nil @ A ) ) )
                              @ Xss2 ) ) )
                        @ ( transpose @ A
                          @ ( cons @ ( list @ A ) @ Xs2
                            @ ( concat @ ( list @ A )
                              @ ( map @ ( list @ A ) @ ( list @ ( list @ A ) )
                                @ ( case_list @ ( list @ ( list @ A ) ) @ A @ ( nil @ ( list @ A ) )
                                  @ ^ [H: A,T3: list @ A] : ( cons @ ( list @ A ) @ T3 @ ( nil @ ( list @ A ) ) ) )
                                @ Xss2 ) ) ) ) ) )
                   => ~ ( accp @ ( list @ ( list @ A ) ) @ ( transpose_rel @ A ) @ ( cons @ ( list @ A ) @ ( cons @ A @ X3 @ Xs2 ) @ Xss2 ) ) ) ) ) ) ) ) ).

% transpose.pelims
thf(fact_7469_transpose_Osimps_I3_J,axiom,
    ! [A: $tType,X2: A,Xs: list @ A,Xss: list @ ( list @ A )] :
      ( ( transpose @ A @ ( cons @ ( list @ A ) @ ( cons @ A @ X2 @ Xs ) @ Xss ) )
      = ( cons @ ( list @ A )
        @ ( cons @ A @ X2
          @ ( concat @ A
            @ ( map @ ( list @ A ) @ ( list @ A )
              @ ( case_list @ ( list @ A ) @ A @ ( nil @ A )
                @ ^ [H: A,T3: list @ A] : ( cons @ A @ H @ ( nil @ A ) ) )
              @ Xss ) ) )
        @ ( transpose @ A
          @ ( cons @ ( list @ A ) @ Xs
            @ ( concat @ ( list @ A )
              @ ( map @ ( list @ A ) @ ( list @ ( list @ A ) )
                @ ( case_list @ ( list @ ( list @ A ) ) @ A @ ( nil @ ( list @ A ) )
                  @ ^ [H: A,T3: list @ A] : ( cons @ ( list @ A ) @ T3 @ ( nil @ ( list @ A ) ) ) )
                @ Xss ) ) ) ) ) ) ).

% transpose.simps(3)
thf(fact_7470_horner__sum__bit__eq__take__bit,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A,N2: nat] :
          ( ( groups4207007520872428315er_sum @ $o @ A @ ( zero_neq_one_of_bool @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( map @ nat @ $o @ ( bit_se5641148757651400278ts_bit @ A @ A2 ) @ ( upt @ ( zero_zero @ nat ) @ N2 ) ) )
          = ( bit_se2584673776208193580ke_bit @ A @ N2 @ A2 ) ) ) ).

% horner_sum_bit_eq_take_bit
thf(fact_7471_map__of__eq__Some__iff,axiom,
    ! [B: $tType,A: $tType,Xys2: list @ ( product_prod @ A @ B ),X2: A,Y2: B] :
      ( ( distinct @ A @ ( map @ ( product_prod @ A @ B ) @ A @ ( product_fst @ A @ B ) @ Xys2 ) )
     => ( ( ( map_of @ A @ B @ Xys2 @ X2 )
          = ( some @ B @ Y2 ) )
        = ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X2 @ Y2 ) @ ( set2 @ ( product_prod @ A @ B ) @ Xys2 ) ) ) ) ).

% map_of_eq_Some_iff
thf(fact_7472_remdups__upt,axiom,
    ! [M: nat,N2: nat] :
      ( ( remdups @ nat @ ( upt @ M @ N2 ) )
      = ( upt @ M @ N2 ) ) ).

% remdups_upt
thf(fact_7473_length__upt,axiom,
    ! [I3: nat,J: nat] :
      ( ( size_size @ ( list @ nat ) @ ( upt @ I3 @ J ) )
      = ( minus_minus @ nat @ J @ I3 ) ) ).

% length_upt
thf(fact_7474_upt__conv__Nil,axiom,
    ! [J: nat,I3: nat] :
      ( ( ord_less_eq @ nat @ J @ I3 )
     => ( ( upt @ I3 @ J )
        = ( nil @ nat ) ) ) ).

% upt_conv_Nil
thf(fact_7475_map__of__eq__empty__iff,axiom,
    ! [B: $tType,A: $tType,Xys2: list @ ( product_prod @ A @ B )] :
      ( ( ( map_of @ A @ B @ Xys2 )
        = ( ^ [X5: A] : ( none @ B ) ) )
      = ( Xys2
        = ( nil @ ( product_prod @ A @ B ) ) ) ) ).

% map_of_eq_empty_iff
thf(fact_7476_sorted__list__of__set__range,axiom,
    ! [M: nat,N2: nat] :
      ( ( linord4507533701916653071of_set @ nat @ ( set_or7035219750837199246ssThan @ nat @ M @ N2 ) )
      = ( upt @ M @ N2 ) ) ).

% sorted_list_of_set_range
thf(fact_7477_empty__eq__map__of__iff,axiom,
    ! [B: $tType,A: $tType,Xys2: list @ ( product_prod @ A @ B )] :
      ( ( ( ^ [X5: A] : ( none @ B ) )
        = ( map_of @ A @ B @ Xys2 ) )
      = ( Xys2
        = ( nil @ ( product_prod @ A @ B ) ) ) ) ).

% empty_eq_map_of_iff
thf(fact_7478_upt__eq__Nil__conv,axiom,
    ! [I3: nat,J: nat] :
      ( ( ( upt @ I3 @ J )
        = ( nil @ nat ) )
      = ( ( J
          = ( zero_zero @ nat ) )
        | ( ord_less_eq @ nat @ J @ I3 ) ) ) ).

% upt_eq_Nil_conv
thf(fact_7479_nth__upt,axiom,
    ! [I3: nat,K: nat,J: nat] :
      ( ( ord_less @ nat @ ( plus_plus @ nat @ I3 @ K ) @ J )
     => ( ( nth @ nat @ ( upt @ I3 @ J ) @ K )
        = ( plus_plus @ nat @ I3 @ K ) ) ) ).

% nth_upt
thf(fact_7480_map__fst__enumerate,axiom,
    ! [A: $tType,N2: nat,Xs: list @ A] :
      ( ( map @ ( product_prod @ nat @ A ) @ nat @ ( product_fst @ nat @ A ) @ ( enumerate @ A @ N2 @ Xs ) )
      = ( upt @ N2 @ ( plus_plus @ nat @ N2 @ ( size_size @ ( list @ A ) @ Xs ) ) ) ) ).

% map_fst_enumerate
thf(fact_7481_upt__rec__numeral,axiom,
    ! [M: num,N2: num] :
      ( ( ( ord_less @ nat @ ( numeral_numeral @ nat @ M ) @ ( numeral_numeral @ nat @ N2 ) )
       => ( ( upt @ ( numeral_numeral @ nat @ M ) @ ( numeral_numeral @ nat @ N2 ) )
          = ( cons @ nat @ ( numeral_numeral @ nat @ M ) @ ( upt @ ( suc @ ( numeral_numeral @ nat @ M ) ) @ ( numeral_numeral @ nat @ N2 ) ) ) ) )
      & ( ~ ( ord_less @ nat @ ( numeral_numeral @ nat @ M ) @ ( numeral_numeral @ nat @ N2 ) )
       => ( ( upt @ ( numeral_numeral @ nat @ M ) @ ( numeral_numeral @ nat @ N2 ) )
          = ( nil @ nat ) ) ) ) ).

% upt_rec_numeral
thf(fact_7482_map__of__is__SomeI,axiom,
    ! [A: $tType,B: $tType,Xys2: list @ ( product_prod @ A @ B ),X2: A,Y2: B] :
      ( ( distinct @ A @ ( map @ ( product_prod @ A @ B ) @ A @ ( product_fst @ A @ B ) @ Xys2 ) )
     => ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X2 @ Y2 ) @ ( set2 @ ( product_prod @ A @ B ) @ Xys2 ) )
       => ( ( map_of @ A @ B @ Xys2 @ X2 )
          = ( some @ B @ Y2 ) ) ) ) ).

% map_of_is_SomeI
thf(fact_7483_Some__eq__map__of__iff,axiom,
    ! [B: $tType,A: $tType,Xys2: list @ ( product_prod @ A @ B ),Y2: B,X2: A] :
      ( ( distinct @ A @ ( map @ ( product_prod @ A @ B ) @ A @ ( product_fst @ A @ B ) @ Xys2 ) )
     => ( ( ( some @ B @ Y2 )
          = ( map_of @ A @ B @ Xys2 @ X2 ) )
        = ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ X2 @ Y2 ) @ ( set2 @ ( product_prod @ A @ B ) @ Xys2 ) ) ) ) ).

% Some_eq_map_of_iff
thf(fact_7484_map__of_Osimps_I1_J,axiom,
    ! [B: $tType,A: $tType] :
      ( ( map_of @ A @ B @ ( nil @ ( product_prod @ A @ B ) ) )
      = ( ^ [X5: A] : ( none @ B ) ) ) ).

% map_of.simps(1)
thf(fact_7485_map__of__Cons__code_I1_J,axiom,
    ! [B: $tType,A: $tType,K: B] :
      ( ( map_of @ B @ A @ ( nil @ ( product_prod @ B @ A ) ) @ K )
      = ( none @ A ) ) ).

% map_of_Cons_code(1)
thf(fact_7486_upt__0,axiom,
    ! [I3: nat] :
      ( ( upt @ I3 @ ( zero_zero @ nat ) )
      = ( nil @ nat ) ) ).

% upt_0
thf(fact_7487_atLeast__upt,axiom,
    ( ( set_ord_lessThan @ nat )
    = ( ^ [N3: nat] : ( set2 @ nat @ ( upt @ ( zero_zero @ nat ) @ N3 ) ) ) ) ).

% atLeast_upt
thf(fact_7488_atLeastLessThan__upt,axiom,
    ( ( set_or7035219750837199246ssThan @ nat )
    = ( ^ [I4: nat,J3: nat] : ( set2 @ nat @ ( upt @ I4 @ J3 ) ) ) ) ).

% atLeastLessThan_upt
thf(fact_7489_atLeastAtMost__upt,axiom,
    ( ( set_or1337092689740270186AtMost @ nat )
    = ( ^ [N3: nat,M6: nat] : ( set2 @ nat @ ( upt @ N3 @ ( suc @ M6 ) ) ) ) ) ).

% atLeastAtMost_upt
thf(fact_7490_greaterThanLessThan__upt,axiom,
    ( ( set_or5935395276787703475ssThan @ nat )
    = ( ^ [N3: nat,M6: nat] : ( set2 @ nat @ ( upt @ ( suc @ N3 ) @ M6 ) ) ) ) ).

% greaterThanLessThan_upt
thf(fact_7491_greaterThanAtMost__upt,axiom,
    ( ( set_or3652927894154168847AtMost @ nat )
    = ( ^ [N3: nat,M6: nat] : ( set2 @ nat @ ( upt @ ( suc @ N3 ) @ ( suc @ M6 ) ) ) ) ) ).

% greaterThanAtMost_upt
thf(fact_7492_atMost__upto,axiom,
    ( ( set_ord_atMost @ nat )
    = ( ^ [N3: nat] : ( set2 @ nat @ ( upt @ ( zero_zero @ nat ) @ ( suc @ N3 ) ) ) ) ) ).

% atMost_upto
thf(fact_7493_upt__conv__Cons__Cons,axiom,
    ! [M: nat,N2: nat,Ns: list @ nat,Q3: nat] :
      ( ( ( cons @ nat @ M @ ( cons @ nat @ N2 @ Ns ) )
        = ( upt @ M @ Q3 ) )
      = ( ( cons @ nat @ N2 @ Ns )
        = ( upt @ ( suc @ M ) @ Q3 ) ) ) ).

% upt_conv_Cons_Cons
thf(fact_7494_distinct__upt,axiom,
    ! [I3: nat,J: nat] : ( distinct @ nat @ ( upt @ I3 @ J ) ) ).

% distinct_upt
thf(fact_7495_map__add__upt,axiom,
    ! [N2: nat,M: nat] :
      ( ( map @ nat @ nat
        @ ^ [I4: nat] : ( plus_plus @ nat @ I4 @ N2 )
        @ ( upt @ ( zero_zero @ nat ) @ M ) )
      = ( upt @ N2 @ ( plus_plus @ nat @ M @ N2 ) ) ) ).

% map_add_upt
thf(fact_7496_map__Suc__upt,axiom,
    ! [M: nat,N2: nat] :
      ( ( map @ nat @ nat @ suc @ ( upt @ M @ N2 ) )
      = ( upt @ ( suc @ M ) @ ( suc @ N2 ) ) ) ).

% map_Suc_upt
thf(fact_7497_map__replicate__trivial,axiom,
    ! [A: $tType,X2: A,I3: nat] :
      ( ( map @ nat @ A
        @ ^ [I4: nat] : X2
        @ ( upt @ ( zero_zero @ nat ) @ I3 ) )
      = ( replicate @ A @ I3 @ X2 ) ) ).

% map_replicate_trivial
thf(fact_7498_enumerate__map__upt,axiom,
    ! [A: $tType,N2: nat,F2: nat > A,M: nat] :
      ( ( enumerate @ A @ N2 @ ( map @ nat @ A @ F2 @ ( upt @ N2 @ M ) ) )
      = ( map @ nat @ ( product_prod @ nat @ A )
        @ ^ [K3: nat] : ( product_Pair @ nat @ A @ K3 @ ( F2 @ K3 ) )
        @ ( upt @ N2 @ M ) ) ) ).

% enumerate_map_upt
thf(fact_7499_upt__conv__Cons,axiom,
    ! [I3: nat,J: nat] :
      ( ( ord_less @ nat @ I3 @ J )
     => ( ( upt @ I3 @ J )
        = ( cons @ nat @ I3 @ ( upt @ ( suc @ I3 ) @ J ) ) ) ) ).

% upt_conv_Cons
thf(fact_7500_map__upt__Suc,axiom,
    ! [A: $tType,F2: nat > A,N2: nat] :
      ( ( map @ nat @ A @ F2 @ ( upt @ ( zero_zero @ nat ) @ ( suc @ N2 ) ) )
      = ( cons @ A @ ( F2 @ ( zero_zero @ nat ) )
        @ ( map @ nat @ A
          @ ^ [I4: nat] : ( F2 @ ( suc @ I4 ) )
          @ ( upt @ ( zero_zero @ nat ) @ N2 ) ) ) ) ).

% map_upt_Suc
thf(fact_7501_map__decr__upt,axiom,
    ! [M: nat,N2: nat] :
      ( ( map @ nat @ nat
        @ ^ [N3: nat] : ( minus_minus @ nat @ N3 @ ( suc @ ( zero_zero @ nat ) ) )
        @ ( upt @ ( suc @ M ) @ ( suc @ N2 ) ) )
      = ( upt @ M @ N2 ) ) ).

% map_decr_upt
thf(fact_7502_map__nth,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( map @ nat @ A @ ( nth @ A @ Xs ) @ ( upt @ ( zero_zero @ nat ) @ ( size_size @ ( list @ A ) @ Xs ) ) )
      = Xs ) ).

% map_nth
thf(fact_7503_weak__map__of__SomeI,axiom,
    ! [A: $tType,B: $tType,K: A,X2: B,L: list @ ( product_prod @ A @ B )] :
      ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ K @ X2 ) @ ( set2 @ ( product_prod @ A @ B ) @ L ) )
     => ? [X3: B] :
          ( ( map_of @ A @ B @ L @ K )
          = ( some @ B @ X3 ) ) ) ).

% weak_map_of_SomeI
thf(fact_7504_map__of__SomeD,axiom,
    ! [A: $tType,B: $tType,Xs: list @ ( product_prod @ B @ A ),K: B,Y2: A] :
      ( ( ( map_of @ B @ A @ Xs @ K )
        = ( some @ A @ Y2 ) )
     => ( member @ ( product_prod @ B @ A ) @ ( product_Pair @ B @ A @ K @ Y2 ) @ ( set2 @ ( product_prod @ B @ A ) @ Xs ) ) ) ).

% map_of_SomeD
thf(fact_7505_map__of__eqI,axiom,
    ! [B: $tType,A: $tType,Xs: list @ ( product_prod @ A @ B ),Ys: list @ ( product_prod @ A @ B )] :
      ( ( ( set2 @ A @ ( map @ ( product_prod @ A @ B ) @ A @ ( product_fst @ A @ B ) @ Xs ) )
        = ( set2 @ A @ ( map @ ( product_prod @ A @ B ) @ A @ ( product_fst @ A @ B ) @ Ys ) ) )
     => ( ! [X3: A] :
            ( ( member @ A @ X3 @ ( set2 @ A @ ( map @ ( product_prod @ A @ B ) @ A @ ( product_fst @ A @ B ) @ Xs ) ) )
           => ( ( map_of @ A @ B @ Xs @ X3 )
              = ( map_of @ A @ B @ Ys @ X3 ) ) )
       => ( ( map_of @ A @ B @ Xs )
          = ( map_of @ A @ B @ Ys ) ) ) ) ).

% map_of_eqI
thf(fact_7506_upt__add__eq__append,axiom,
    ! [I3: nat,J: nat,K: nat] :
      ( ( ord_less_eq @ nat @ I3 @ J )
     => ( ( upt @ I3 @ ( plus_plus @ nat @ J @ K ) )
        = ( append @ nat @ ( upt @ I3 @ J ) @ ( upt @ J @ ( plus_plus @ nat @ J @ K ) ) ) ) ) ).

% upt_add_eq_append
thf(fact_7507_map__of__Cons__code_I2_J,axiom,
    ! [C: $tType,B: $tType,L: B,K: B,V: C,Ps: list @ ( product_prod @ B @ C )] :
      ( ( ( L = K )
       => ( ( map_of @ B @ C @ ( cons @ ( product_prod @ B @ C ) @ ( product_Pair @ B @ C @ L @ V ) @ Ps ) @ K )
          = ( some @ C @ V ) ) )
      & ( ( L != K )
       => ( ( map_of @ B @ C @ ( cons @ ( product_prod @ B @ C ) @ ( product_Pair @ B @ C @ L @ V ) @ Ps ) @ K )
          = ( map_of @ B @ C @ Ps @ K ) ) ) ) ).

% map_of_Cons_code(2)
thf(fact_7508_nth__map__upt,axiom,
    ! [A: $tType,I3: nat,N2: nat,M: nat,F2: nat > A] :
      ( ( ord_less @ nat @ I3 @ ( minus_minus @ nat @ N2 @ M ) )
     => ( ( nth @ A @ ( map @ nat @ A @ F2 @ ( upt @ M @ N2 ) ) @ I3 )
        = ( F2 @ ( plus_plus @ nat @ M @ I3 ) ) ) ) ).

% nth_map_upt
thf(fact_7509_upt__eq__Cons__conv,axiom,
    ! [I3: nat,J: nat,X2: nat,Xs: list @ nat] :
      ( ( ( upt @ I3 @ J )
        = ( cons @ nat @ X2 @ Xs ) )
      = ( ( ord_less @ nat @ I3 @ J )
        & ( I3 = X2 )
        & ( ( upt @ ( plus_plus @ nat @ I3 @ ( one_one @ nat ) ) @ J )
          = Xs ) ) ) ).

% upt_eq_Cons_conv
thf(fact_7510_upt__rec,axiom,
    ( upt
    = ( ^ [I4: nat,J3: nat] : ( if @ ( list @ nat ) @ ( ord_less @ nat @ I4 @ J3 ) @ ( cons @ nat @ I4 @ ( upt @ ( suc @ I4 ) @ J3 ) ) @ ( nil @ nat ) ) ) ) ).

% upt_rec
thf(fact_7511_map__of__eq__None__iff,axiom,
    ! [A: $tType,B: $tType,Xys2: list @ ( product_prod @ B @ A ),X2: B] :
      ( ( ( map_of @ B @ A @ Xys2 @ X2 )
        = ( none @ A ) )
      = ( ~ ( member @ B @ X2 @ ( image @ ( product_prod @ B @ A ) @ B @ ( product_fst @ B @ A ) @ ( set2 @ ( product_prod @ B @ A ) @ Xys2 ) ) ) ) ) ).

% map_of_eq_None_iff
thf(fact_7512_enumerate__replicate__eq,axiom,
    ! [A: $tType,N2: nat,M: nat,A2: A] :
      ( ( enumerate @ A @ N2 @ ( replicate @ A @ M @ A2 ) )
      = ( map @ nat @ ( product_prod @ nat @ A )
        @ ^ [Q4: nat] : ( product_Pair @ nat @ A @ Q4 @ A2 )
        @ ( upt @ N2 @ ( plus_plus @ nat @ N2 @ M ) ) ) ) ).

% enumerate_replicate_eq
thf(fact_7513_map__upt__eqI,axiom,
    ! [A: $tType,Xs: list @ A,N2: nat,M: nat,F2: nat > A] :
      ( ( ( size_size @ ( list @ A ) @ Xs )
        = ( minus_minus @ nat @ N2 @ M ) )
     => ( ! [I2: nat] :
            ( ( ord_less @ nat @ I2 @ ( size_size @ ( list @ A ) @ Xs ) )
           => ( ( nth @ A @ Xs @ I2 )
              = ( F2 @ ( plus_plus @ nat @ M @ I2 ) ) ) )
       => ( ( map @ nat @ A @ F2 @ ( upt @ M @ N2 ) )
          = Xs ) ) ) ).

% map_upt_eqI
thf(fact_7514_upt__Suc,axiom,
    ! [I3: nat,J: nat] :
      ( ( ( ord_less_eq @ nat @ I3 @ J )
       => ( ( upt @ I3 @ ( suc @ J ) )
          = ( append @ nat @ ( upt @ I3 @ J ) @ ( cons @ nat @ J @ ( nil @ nat ) ) ) ) )
      & ( ~ ( ord_less_eq @ nat @ I3 @ J )
       => ( ( upt @ I3 @ ( suc @ J ) )
          = ( nil @ nat ) ) ) ) ).

% upt_Suc
thf(fact_7515_upt__Suc__append,axiom,
    ! [I3: nat,J: nat] :
      ( ( ord_less_eq @ nat @ I3 @ J )
     => ( ( upt @ I3 @ ( suc @ J ) )
        = ( append @ nat @ ( upt @ I3 @ J ) @ ( cons @ nat @ J @ ( nil @ nat ) ) ) ) ) ).

% upt_Suc_append
thf(fact_7516_set__map__of__compr,axiom,
    ! [B: $tType,A: $tType,Xs: list @ ( product_prod @ A @ B )] :
      ( ( distinct @ A @ ( map @ ( product_prod @ A @ B ) @ A @ ( product_fst @ A @ B ) @ Xs ) )
     => ( ( set2 @ ( product_prod @ A @ B ) @ Xs )
        = ( collect @ ( product_prod @ A @ B )
          @ ( product_case_prod @ A @ B @ $o
            @ ^ [K3: A,V5: B] :
                ( ( map_of @ A @ B @ Xs @ K3 )
                = ( some @ B @ V5 ) ) ) ) ) ) ).

% set_map_of_compr
thf(fact_7517_transpose__rectangle,axiom,
    ! [A: $tType,Xs: list @ ( list @ A ),N2: nat] :
      ( ( ( Xs
          = ( nil @ ( list @ A ) ) )
       => ( N2
          = ( zero_zero @ nat ) ) )
     => ( ! [I2: nat] :
            ( ( ord_less @ nat @ I2 @ ( size_size @ ( list @ ( list @ A ) ) @ Xs ) )
           => ( ( size_size @ ( list @ A ) @ ( nth @ ( list @ A ) @ Xs @ I2 ) )
              = N2 ) )
       => ( ( transpose @ A @ Xs )
          = ( map @ nat @ ( list @ A )
            @ ^ [I4: nat] :
                ( map @ nat @ A
                @ ^ [J3: nat] : ( nth @ A @ ( nth @ ( list @ A ) @ Xs @ J3 ) @ I4 )
                @ ( upt @ ( zero_zero @ nat ) @ ( size_size @ ( list @ ( list @ A ) ) @ Xs ) ) )
            @ ( upt @ ( zero_zero @ nat ) @ N2 ) ) ) ) ) ).

% transpose_rectangle
thf(fact_7518_and__not__num_Oelims,axiom,
    ! [X2: num,Xa2: num,Y2: option @ num] :
      ( ( ( bit_and_not_num @ X2 @ Xa2 )
        = Y2 )
     => ( ( ( X2 = one2 )
         => ( ( Xa2 = one2 )
           => ( Y2
             != ( none @ num ) ) ) )
       => ( ( ( X2 = one2 )
           => ( ? [N: num] :
                  ( Xa2
                  = ( bit0 @ N ) )
             => ( Y2
               != ( some @ num @ one2 ) ) ) )
         => ( ( ( X2 = one2 )
             => ( ? [N: num] :
                    ( Xa2
                    = ( bit1 @ N ) )
               => ( Y2
                 != ( none @ num ) ) ) )
           => ( ! [M3: num] :
                  ( ( X2
                    = ( bit0 @ M3 ) )
                 => ( ( Xa2 = one2 )
                   => ( Y2
                     != ( some @ num @ ( bit0 @ M3 ) ) ) ) )
             => ( ! [M3: num] :
                    ( ( X2
                      = ( bit0 @ M3 ) )
                   => ! [N: num] :
                        ( ( Xa2
                          = ( bit0 @ N ) )
                       => ( Y2
                         != ( map_option @ num @ num @ bit0 @ ( bit_and_not_num @ M3 @ N ) ) ) ) )
               => ( ! [M3: num] :
                      ( ( X2
                        = ( bit0 @ M3 ) )
                     => ! [N: num] :
                          ( ( Xa2
                            = ( bit1 @ N ) )
                         => ( Y2
                           != ( map_option @ num @ num @ bit0 @ ( bit_and_not_num @ M3 @ N ) ) ) ) )
                 => ( ! [M3: num] :
                        ( ( X2
                          = ( bit1 @ M3 ) )
                       => ( ( Xa2 = one2 )
                         => ( Y2
                           != ( some @ num @ ( bit0 @ M3 ) ) ) ) )
                   => ( ! [M3: num] :
                          ( ( X2
                            = ( bit1 @ M3 ) )
                         => ! [N: num] :
                              ( ( Xa2
                                = ( bit0 @ N ) )
                             => ( Y2
                               != ( case_option @ ( option @ num ) @ num @ ( some @ num @ one2 )
                                  @ ^ [N10: num] : ( some @ num @ ( bit1 @ N10 ) )
                                  @ ( bit_and_not_num @ M3 @ N ) ) ) ) )
                     => ~ ! [M3: num] :
                            ( ( X2
                              = ( bit1 @ M3 ) )
                           => ! [N: num] :
                                ( ( Xa2
                                  = ( bit1 @ N ) )
                               => ( Y2
                                 != ( map_option @ num @ num @ bit0 @ ( bit_and_not_num @ M3 @ N ) ) ) ) ) ) ) ) ) ) ) ) ) ) ).

% and_not_num.elims
thf(fact_7519_nonneg__incseq__Bseq__subseq__iff,axiom,
    ! [F2: nat > real,G: nat > nat] :
      ( ! [X3: nat] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( F2 @ X3 ) )
     => ( ( order_mono @ nat @ real @ F2 )
       => ( ( order_strict_mono @ nat @ nat @ G )
         => ( ( bfun @ nat @ real
              @ ^ [X5: nat] : ( F2 @ ( G @ X5 ) )
              @ ( at_top @ nat ) )
            = ( bfun @ nat @ real @ F2 @ ( at_top @ nat ) ) ) ) ) ) ).

% nonneg_incseq_Bseq_subseq_iff
thf(fact_7520_map__option__eq__Some,axiom,
    ! [A: $tType,B: $tType,F2: B > A,Xo: option @ B,Y2: A] :
      ( ( ( map_option @ B @ A @ F2 @ Xo )
        = ( some @ A @ Y2 ) )
      = ( ? [Z6: B] :
            ( ( Xo
              = ( some @ B @ Z6 ) )
            & ( ( F2 @ Z6 )
              = Y2 ) ) ) ) ).

% map_option_eq_Some
thf(fact_7521_None__eq__map__option__iff,axiom,
    ! [A: $tType,B: $tType,F2: B > A,X2: option @ B] :
      ( ( ( none @ A )
        = ( map_option @ B @ A @ F2 @ X2 ) )
      = ( X2
        = ( none @ B ) ) ) ).

% None_eq_map_option_iff
thf(fact_7522_map__option__is__None,axiom,
    ! [A: $tType,B: $tType,F2: B > A,Opt: option @ B] :
      ( ( ( map_option @ B @ A @ F2 @ Opt )
        = ( none @ A ) )
      = ( Opt
        = ( none @ B ) ) ) ).

% map_option_is_None
thf(fact_7523_option_Omap__disc__iff,axiom,
    ! [B: $tType,A: $tType,F2: A > B,A2: option @ A] :
      ( ( ( map_option @ A @ B @ F2 @ A2 )
        = ( none @ B ) )
      = ( A2
        = ( none @ A ) ) ) ).

% option.map_disc_iff
thf(fact_7524_map__option__o__empty,axiom,
    ! [C: $tType,B: $tType,A: $tType,F2: C > B] :
      ( ( comp @ ( option @ C ) @ ( option @ B ) @ A @ ( map_option @ C @ B @ F2 )
        @ ^ [X5: A] : ( none @ C ) )
      = ( ^ [X5: A] : ( none @ B ) ) ) ).

% map_option_o_empty
thf(fact_7525_strict__mono__leD,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( order @ A )
        & ( order @ B ) )
     => ! [R3: A > B,M: A,N2: A] :
          ( ( order_strict_mono @ A @ B @ R3 )
         => ( ( ord_less_eq @ A @ M @ N2 )
           => ( ord_less_eq @ B @ ( R3 @ M ) @ ( R3 @ N2 ) ) ) ) ) ).

% strict_mono_leD
thf(fact_7526_strict__mono__less__eq,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( linorder @ A )
        & ( order @ B ) )
     => ! [F2: A > B,X2: A,Y2: A] :
          ( ( order_strict_mono @ A @ B @ F2 )
         => ( ( ord_less_eq @ B @ ( F2 @ X2 ) @ ( F2 @ Y2 ) )
            = ( ord_less_eq @ A @ X2 @ Y2 ) ) ) ) ).

% strict_mono_less_eq
thf(fact_7527_strict__mono__imp__increasing,axiom,
    ! [F2: nat > nat,N2: nat] :
      ( ( order_strict_mono @ nat @ nat @ F2 )
     => ( ord_less_eq @ nat @ N2 @ ( F2 @ N2 ) ) ) ).

% strict_mono_imp_increasing
thf(fact_7528_and__not__num_Osimps_I5_J,axiom,
    ! [M: num,N2: num] :
      ( ( bit_and_not_num @ ( bit0 @ M ) @ ( bit0 @ N2 ) )
      = ( map_option @ num @ num @ bit0 @ ( bit_and_not_num @ M @ N2 ) ) ) ).

% and_not_num.simps(5)
thf(fact_7529_strict__mono__add,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [K: A] :
          ( order_strict_mono @ A @ A
          @ ^ [N3: A] : ( plus_plus @ A @ N3 @ K ) ) ) ).

% strict_mono_add
thf(fact_7530_strict__mono__less,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( linorder @ A )
        & ( order @ B ) )
     => ! [F2: A > B,X2: A,Y2: A] :
          ( ( order_strict_mono @ A @ B @ F2 )
         => ( ( ord_less @ B @ ( F2 @ X2 ) @ ( F2 @ Y2 ) )
            = ( ord_less @ A @ X2 @ Y2 ) ) ) ) ).

% strict_mono_less
thf(fact_7531_strict__mono__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( order @ A )
        & ( order @ B ) )
     => ( ( order_strict_mono @ A @ B )
        = ( ^ [F5: A > B] :
            ! [X5: A,Y5: A] :
              ( ( ord_less @ A @ X5 @ Y5 )
             => ( ord_less @ B @ ( F5 @ X5 ) @ ( F5 @ Y5 ) ) ) ) ) ) ).

% strict_mono_def
thf(fact_7532_strict__monoI,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( order @ A )
        & ( order @ B ) )
     => ! [F2: A > B] :
          ( ! [X3: A,Y4: A] :
              ( ( ord_less @ A @ X3 @ Y4 )
             => ( ord_less @ B @ ( F2 @ X3 ) @ ( F2 @ Y4 ) ) )
         => ( order_strict_mono @ A @ B @ F2 ) ) ) ).

% strict_monoI
thf(fact_7533_strict__monoD,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( order @ A )
        & ( order @ B ) )
     => ! [F2: A > B,X2: A,Y2: A] :
          ( ( order_strict_mono @ A @ B @ F2 )
         => ( ( ord_less @ A @ X2 @ Y2 )
           => ( ord_less @ B @ ( F2 @ X2 ) @ ( F2 @ Y2 ) ) ) ) ) ).

% strict_monoD
thf(fact_7534_option_Osimps_I9_J,axiom,
    ! [B: $tType,A: $tType,F2: A > B,X22: A] :
      ( ( map_option @ A @ B @ F2 @ ( some @ A @ X22 ) )
      = ( some @ B @ ( F2 @ X22 ) ) ) ).

% option.simps(9)
thf(fact_7535_map__option__cong,axiom,
    ! [B: $tType,A: $tType,X2: option @ A,Y2: option @ A,F2: A > B,G: A > B] :
      ( ( X2 = Y2 )
     => ( ! [A5: A] :
            ( ( Y2
              = ( some @ A @ A5 ) )
           => ( ( F2 @ A5 )
              = ( G @ A5 ) ) )
       => ( ( map_option @ A @ B @ F2 @ X2 )
          = ( map_option @ A @ B @ G @ Y2 ) ) ) ) ).

% map_option_cong
thf(fact_7536_option_Osimps_I8_J,axiom,
    ! [A: $tType,B: $tType,F2: A > B] :
      ( ( map_option @ A @ B @ F2 @ ( none @ A ) )
      = ( none @ B ) ) ).

% option.simps(8)
thf(fact_7537_strict__mono__Suc__iff,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( order_strict_mono @ nat @ A )
        = ( ^ [F5: nat > A] :
            ! [N3: nat] : ( ord_less @ A @ ( F5 @ N3 ) @ ( F5 @ ( suc @ N3 ) ) ) ) ) ) ).

% strict_mono_Suc_iff
thf(fact_7538_and__not__num_Osimps_I6_J,axiom,
    ! [M: num,N2: num] :
      ( ( bit_and_not_num @ ( bit0 @ M ) @ ( bit1 @ N2 ) )
      = ( map_option @ num @ num @ bit0 @ ( bit_and_not_num @ M @ N2 ) ) ) ).

% and_not_num.simps(6)
thf(fact_7539_and__not__num_Osimps_I9_J,axiom,
    ! [M: num,N2: num] :
      ( ( bit_and_not_num @ ( bit1 @ M ) @ ( bit1 @ N2 ) )
      = ( map_option @ num @ num @ bit0 @ ( bit_and_not_num @ M @ N2 ) ) ) ).

% and_not_num.simps(9)
thf(fact_7540_map__option__case,axiom,
    ! [A: $tType,B: $tType] :
      ( ( map_option @ B @ A )
      = ( ^ [F5: B > A] :
            ( case_option @ ( option @ A ) @ B @ ( none @ A )
            @ ^ [X5: B] : ( some @ A @ ( F5 @ X5 ) ) ) ) ) ).

% map_option_case
thf(fact_7541_map__of__map,axiom,
    ! [B: $tType,C: $tType,A: $tType,F2: C > B,Xs: list @ ( product_prod @ A @ C )] :
      ( ( map_of @ A @ B
        @ ( map @ ( product_prod @ A @ C ) @ ( product_prod @ A @ B )
          @ ( product_case_prod @ A @ C @ ( product_prod @ A @ B )
            @ ^ [K3: A,V5: C] : ( product_Pair @ A @ B @ K3 @ ( F2 @ V5 ) ) )
          @ Xs ) )
      = ( comp @ ( option @ C ) @ ( option @ B ) @ A @ ( map_option @ C @ B @ F2 ) @ ( map_of @ A @ C @ Xs ) ) ) ).

% map_of_map
thf(fact_7542_summable__mono__reindex,axiom,
    ! [A: $tType] :
      ( ( ( comm_monoid_add @ A )
        & ( topolo4958980785337419405_space @ A ) )
     => ! [G: nat > nat,F2: nat > A] :
          ( ( order_strict_mono @ nat @ nat @ G )
         => ( ! [N: nat] :
                ( ~ ( member @ nat @ N @ ( image @ nat @ nat @ G @ ( top_top @ ( set @ nat ) ) ) )
               => ( ( F2 @ N )
                  = ( zero_zero @ A ) ) )
           => ( ( summable @ A
                @ ^ [N3: nat] : ( F2 @ ( G @ N3 ) ) )
              = ( summable @ A @ F2 ) ) ) ) ) ).

% summable_mono_reindex
thf(fact_7543_sums__mono__reindex,axiom,
    ! [A: $tType] :
      ( ( ( comm_monoid_add @ A )
        & ( topolo4958980785337419405_space @ A ) )
     => ! [G: nat > nat,F2: nat > A,C2: A] :
          ( ( order_strict_mono @ nat @ nat @ G )
         => ( ! [N: nat] :
                ( ~ ( member @ nat @ N @ ( image @ nat @ nat @ G @ ( top_top @ ( set @ nat ) ) ) )
               => ( ( F2 @ N )
                  = ( zero_zero @ A ) ) )
           => ( ( sums @ A
                @ ^ [N3: nat] : ( F2 @ ( G @ N3 ) )
                @ C2 )
              = ( sums @ A @ F2 @ C2 ) ) ) ) ) ).

% sums_mono_reindex
thf(fact_7544_suminf__mono__reindex,axiom,
    ! [A: $tType] :
      ( ( ( comm_monoid_add @ A )
        & ( topological_t2_space @ A ) )
     => ! [G: nat > nat,F2: nat > A] :
          ( ( order_strict_mono @ nat @ nat @ G )
         => ( ! [N: nat] :
                ( ~ ( member @ nat @ N @ ( image @ nat @ nat @ G @ ( top_top @ ( set @ nat ) ) ) )
               => ( ( F2 @ N )
                  = ( zero_zero @ A ) ) )
           => ( ( suminf @ A
                @ ^ [N3: nat] : ( F2 @ ( G @ N3 ) ) )
              = ( suminf @ A @ F2 ) ) ) ) ) ).

% suminf_mono_reindex
thf(fact_7545_increasing__Bseq__subseq__iff,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: nat > A,G: nat > nat] :
          ( ! [X3: nat,Y4: nat] :
              ( ( ord_less_eq @ nat @ X3 @ Y4 )
             => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( F2 @ X3 ) ) @ ( real_V7770717601297561774m_norm @ A @ ( F2 @ Y4 ) ) ) )
         => ( ( order_strict_mono @ nat @ nat @ G )
           => ( ( bfun @ nat @ A
                @ ^ [X5: nat] : ( F2 @ ( G @ X5 ) )
                @ ( at_top @ nat ) )
              = ( bfun @ nat @ A @ F2 @ ( at_top @ nat ) ) ) ) ) ) ).

% increasing_Bseq_subseq_iff
thf(fact_7546_and__not__num_Opelims,axiom,
    ! [X2: num,Xa2: num,Y2: option @ num] :
      ( ( ( bit_and_not_num @ X2 @ Xa2 )
        = Y2 )
     => ( ( accp @ ( product_prod @ num @ num ) @ bit_and_not_num_rel @ ( product_Pair @ num @ num @ X2 @ Xa2 ) )
       => ( ( ( X2 = one2 )
           => ( ( Xa2 = one2 )
             => ( ( Y2
                  = ( none @ num ) )
               => ~ ( accp @ ( product_prod @ num @ num ) @ bit_and_not_num_rel @ ( product_Pair @ num @ num @ one2 @ one2 ) ) ) ) )
         => ( ( ( X2 = one2 )
             => ! [N: num] :
                  ( ( Xa2
                    = ( bit0 @ N ) )
                 => ( ( Y2
                      = ( some @ num @ one2 ) )
                   => ~ ( accp @ ( product_prod @ num @ num ) @ bit_and_not_num_rel @ ( product_Pair @ num @ num @ one2 @ ( bit0 @ N ) ) ) ) ) )
           => ( ( ( X2 = one2 )
               => ! [N: num] :
                    ( ( Xa2
                      = ( bit1 @ N ) )
                   => ( ( Y2
                        = ( none @ num ) )
                     => ~ ( accp @ ( product_prod @ num @ num ) @ bit_and_not_num_rel @ ( product_Pair @ num @ num @ one2 @ ( bit1 @ N ) ) ) ) ) )
             => ( ! [M3: num] :
                    ( ( X2
                      = ( bit0 @ M3 ) )
                   => ( ( Xa2 = one2 )
                     => ( ( Y2
                          = ( some @ num @ ( bit0 @ M3 ) ) )
                       => ~ ( accp @ ( product_prod @ num @ num ) @ bit_and_not_num_rel @ ( product_Pair @ num @ num @ ( bit0 @ M3 ) @ one2 ) ) ) ) )
               => ( ! [M3: num] :
                      ( ( X2
                        = ( bit0 @ M3 ) )
                     => ! [N: num] :
                          ( ( Xa2
                            = ( bit0 @ N ) )
                         => ( ( Y2
                              = ( map_option @ num @ num @ bit0 @ ( bit_and_not_num @ M3 @ N ) ) )
                           => ~ ( accp @ ( product_prod @ num @ num ) @ bit_and_not_num_rel @ ( product_Pair @ num @ num @ ( bit0 @ M3 ) @ ( bit0 @ N ) ) ) ) ) )
                 => ( ! [M3: num] :
                        ( ( X2
                          = ( bit0 @ M3 ) )
                       => ! [N: num] :
                            ( ( Xa2
                              = ( bit1 @ N ) )
                           => ( ( Y2
                                = ( map_option @ num @ num @ bit0 @ ( bit_and_not_num @ M3 @ N ) ) )
                             => ~ ( accp @ ( product_prod @ num @ num ) @ bit_and_not_num_rel @ ( product_Pair @ num @ num @ ( bit0 @ M3 ) @ ( bit1 @ N ) ) ) ) ) )
                   => ( ! [M3: num] :
                          ( ( X2
                            = ( bit1 @ M3 ) )
                         => ( ( Xa2 = one2 )
                           => ( ( Y2
                                = ( some @ num @ ( bit0 @ M3 ) ) )
                             => ~ ( accp @ ( product_prod @ num @ num ) @ bit_and_not_num_rel @ ( product_Pair @ num @ num @ ( bit1 @ M3 ) @ one2 ) ) ) ) )
                     => ( ! [M3: num] :
                            ( ( X2
                              = ( bit1 @ M3 ) )
                           => ! [N: num] :
                                ( ( Xa2
                                  = ( bit0 @ N ) )
                               => ( ( Y2
                                    = ( case_option @ ( option @ num ) @ num @ ( some @ num @ one2 )
                                      @ ^ [N10: num] : ( some @ num @ ( bit1 @ N10 ) )
                                      @ ( bit_and_not_num @ M3 @ N ) ) )
                                 => ~ ( accp @ ( product_prod @ num @ num ) @ bit_and_not_num_rel @ ( product_Pair @ num @ num @ ( bit1 @ M3 ) @ ( bit0 @ N ) ) ) ) ) )
                       => ~ ! [M3: num] :
                              ( ( X2
                                = ( bit1 @ M3 ) )
                             => ! [N: num] :
                                  ( ( Xa2
                                    = ( bit1 @ N ) )
                                 => ( ( Y2
                                      = ( map_option @ num @ num @ bit0 @ ( bit_and_not_num @ M3 @ N ) ) )
                                   => ~ ( accp @ ( product_prod @ num @ num ) @ bit_and_not_num_rel @ ( product_Pair @ num @ num @ ( bit1 @ M3 ) @ ( bit1 @ N ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ).

% and_not_num.pelims
thf(fact_7547_and__num_Oelims,axiom,
    ! [X2: num,Xa2: num,Y2: option @ num] :
      ( ( ( bit_un7362597486090784418nd_num @ X2 @ Xa2 )
        = Y2 )
     => ( ( ( X2 = one2 )
         => ( ( Xa2 = one2 )
           => ( Y2
             != ( some @ num @ one2 ) ) ) )
       => ( ( ( X2 = one2 )
           => ( ? [N: num] :
                  ( Xa2
                  = ( bit0 @ N ) )
             => ( Y2
               != ( none @ num ) ) ) )
         => ( ( ( X2 = one2 )
             => ( ? [N: num] :
                    ( Xa2
                    = ( bit1 @ N ) )
               => ( Y2
                 != ( some @ num @ one2 ) ) ) )
           => ( ( ? [M3: num] :
                    ( X2
                    = ( bit0 @ M3 ) )
               => ( ( Xa2 = one2 )
                 => ( Y2
                   != ( none @ num ) ) ) )
             => ( ! [M3: num] :
                    ( ( X2
                      = ( bit0 @ M3 ) )
                   => ! [N: num] :
                        ( ( Xa2
                          = ( bit0 @ N ) )
                       => ( Y2
                         != ( map_option @ num @ num @ bit0 @ ( bit_un7362597486090784418nd_num @ M3 @ N ) ) ) ) )
               => ( ! [M3: num] :
                      ( ( X2
                        = ( bit0 @ M3 ) )
                     => ! [N: num] :
                          ( ( Xa2
                            = ( bit1 @ N ) )
                         => ( Y2
                           != ( map_option @ num @ num @ bit0 @ ( bit_un7362597486090784418nd_num @ M3 @ N ) ) ) ) )
                 => ( ( ? [M3: num] :
                          ( X2
                          = ( bit1 @ M3 ) )
                     => ( ( Xa2 = one2 )
                       => ( Y2
                         != ( some @ num @ one2 ) ) ) )
                   => ( ! [M3: num] :
                          ( ( X2
                            = ( bit1 @ M3 ) )
                         => ! [N: num] :
                              ( ( Xa2
                                = ( bit0 @ N ) )
                             => ( Y2
                               != ( map_option @ num @ num @ bit0 @ ( bit_un7362597486090784418nd_num @ M3 @ N ) ) ) ) )
                     => ~ ! [M3: num] :
                            ( ( X2
                              = ( bit1 @ M3 ) )
                           => ! [N: num] :
                                ( ( Xa2
                                  = ( bit1 @ N ) )
                               => ( Y2
                                 != ( case_option @ ( option @ num ) @ num @ ( some @ num @ one2 )
                                    @ ^ [N10: num] : ( some @ num @ ( bit1 @ N10 ) )
                                    @ ( bit_un7362597486090784418nd_num @ M3 @ N ) ) ) ) ) ) ) ) ) ) ) ) ) ) ).

% and_num.elims
thf(fact_7548_and__num_Osimps_I5_J,axiom,
    ! [M: num,N2: num] :
      ( ( bit_un7362597486090784418nd_num @ ( bit0 @ M ) @ ( bit0 @ N2 ) )
      = ( map_option @ num @ num @ bit0 @ ( bit_un7362597486090784418nd_num @ M @ N2 ) ) ) ).

% and_num.simps(5)
thf(fact_7549_and__num_Osimps_I1_J,axiom,
    ( ( bit_un7362597486090784418nd_num @ one2 @ one2 )
    = ( some @ num @ one2 ) ) ).

% and_num.simps(1)
thf(fact_7550_and__num_Osimps_I3_J,axiom,
    ! [N2: num] :
      ( ( bit_un7362597486090784418nd_num @ one2 @ ( bit1 @ N2 ) )
      = ( some @ num @ one2 ) ) ).

% and_num.simps(3)
thf(fact_7551_and__num_Osimps_I7_J,axiom,
    ! [M: num] :
      ( ( bit_un7362597486090784418nd_num @ ( bit1 @ M ) @ one2 )
      = ( some @ num @ one2 ) ) ).

% and_num.simps(7)
thf(fact_7552_and__num_Osimps_I4_J,axiom,
    ! [M: num] :
      ( ( bit_un7362597486090784418nd_num @ ( bit0 @ M ) @ one2 )
      = ( none @ num ) ) ).

% and_num.simps(4)
thf(fact_7553_and__num_Osimps_I2_J,axiom,
    ! [N2: num] :
      ( ( bit_un7362597486090784418nd_num @ one2 @ ( bit0 @ N2 ) )
      = ( none @ num ) ) ).

% and_num.simps(2)
thf(fact_7554_and__num__eq__Some__iff,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [M: num,N2: num,Q3: num] :
          ( ( ( bit_un7362597486090784418nd_num @ M @ N2 )
            = ( some @ num @ Q3 ) )
          = ( ( bit_se5824344872417868541ns_and @ A @ ( numeral_numeral @ A @ M ) @ ( numeral_numeral @ A @ N2 ) )
            = ( numeral_numeral @ A @ Q3 ) ) ) ) ).

% and_num_eq_Some_iff
thf(fact_7555_and__num_Osimps_I6_J,axiom,
    ! [M: num,N2: num] :
      ( ( bit_un7362597486090784418nd_num @ ( bit0 @ M ) @ ( bit1 @ N2 ) )
      = ( map_option @ num @ num @ bit0 @ ( bit_un7362597486090784418nd_num @ M @ N2 ) ) ) ).

% and_num.simps(6)
thf(fact_7556_and__num_Osimps_I8_J,axiom,
    ! [M: num,N2: num] :
      ( ( bit_un7362597486090784418nd_num @ ( bit1 @ M ) @ ( bit0 @ N2 ) )
      = ( map_option @ num @ num @ bit0 @ ( bit_un7362597486090784418nd_num @ M @ N2 ) ) ) ).

% and_num.simps(8)
thf(fact_7557_and__num__eq__None__iff,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [M: num,N2: num] :
          ( ( ( bit_un7362597486090784418nd_num @ M @ N2 )
            = ( none @ num ) )
          = ( ( bit_se5824344872417868541ns_and @ A @ ( numeral_numeral @ A @ M ) @ ( numeral_numeral @ A @ N2 ) )
            = ( zero_zero @ A ) ) ) ) ).

% and_num_eq_None_iff
thf(fact_7558_numeral__and__num,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [M: num,N2: num] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( numeral_numeral @ A @ M ) @ ( numeral_numeral @ A @ N2 ) )
          = ( case_option @ A @ num @ ( zero_zero @ A ) @ ( numeral_numeral @ A ) @ ( bit_un7362597486090784418nd_num @ M @ N2 ) ) ) ) ).

% numeral_and_num
thf(fact_7559_and__num_Osimps_I9_J,axiom,
    ! [M: num,N2: num] :
      ( ( bit_un7362597486090784418nd_num @ ( bit1 @ M ) @ ( bit1 @ N2 ) )
      = ( case_option @ ( option @ num ) @ num @ ( some @ num @ one2 )
        @ ^ [N10: num] : ( some @ num @ ( bit1 @ N10 ) )
        @ ( bit_un7362597486090784418nd_num @ M @ N2 ) ) ) ).

% and_num.simps(9)
thf(fact_7560_pos__deriv__imp__strict__mono,axiom,
    ! [F2: real > real,F8: real > real] :
      ( ! [X3: real] : ( has_field_derivative @ real @ F2 @ ( F8 @ X3 ) @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) )
     => ( ! [X3: real] : ( ord_less @ real @ ( zero_zero @ real ) @ ( F8 @ X3 ) )
       => ( order_strict_mono @ real @ real @ F2 ) ) ) ).

% pos_deriv_imp_strict_mono
thf(fact_7561_and__num_Opelims,axiom,
    ! [X2: num,Xa2: num,Y2: option @ num] :
      ( ( ( bit_un7362597486090784418nd_num @ X2 @ Xa2 )
        = Y2 )
     => ( ( accp @ ( product_prod @ num @ num ) @ bit_un4731106466462545111um_rel @ ( product_Pair @ num @ num @ X2 @ Xa2 ) )
       => ( ( ( X2 = one2 )
           => ( ( Xa2 = one2 )
             => ( ( Y2
                  = ( some @ num @ one2 ) )
               => ~ ( accp @ ( product_prod @ num @ num ) @ bit_un4731106466462545111um_rel @ ( product_Pair @ num @ num @ one2 @ one2 ) ) ) ) )
         => ( ( ( X2 = one2 )
             => ! [N: num] :
                  ( ( Xa2
                    = ( bit0 @ N ) )
                 => ( ( Y2
                      = ( none @ num ) )
                   => ~ ( accp @ ( product_prod @ num @ num ) @ bit_un4731106466462545111um_rel @ ( product_Pair @ num @ num @ one2 @ ( bit0 @ N ) ) ) ) ) )
           => ( ( ( X2 = one2 )
               => ! [N: num] :
                    ( ( Xa2
                      = ( bit1 @ N ) )
                   => ( ( Y2
                        = ( some @ num @ one2 ) )
                     => ~ ( accp @ ( product_prod @ num @ num ) @ bit_un4731106466462545111um_rel @ ( product_Pair @ num @ num @ one2 @ ( bit1 @ N ) ) ) ) ) )
             => ( ! [M3: num] :
                    ( ( X2
                      = ( bit0 @ M3 ) )
                   => ( ( Xa2 = one2 )
                     => ( ( Y2
                          = ( none @ num ) )
                       => ~ ( accp @ ( product_prod @ num @ num ) @ bit_un4731106466462545111um_rel @ ( product_Pair @ num @ num @ ( bit0 @ M3 ) @ one2 ) ) ) ) )
               => ( ! [M3: num] :
                      ( ( X2
                        = ( bit0 @ M3 ) )
                     => ! [N: num] :
                          ( ( Xa2
                            = ( bit0 @ N ) )
                         => ( ( Y2
                              = ( map_option @ num @ num @ bit0 @ ( bit_un7362597486090784418nd_num @ M3 @ N ) ) )
                           => ~ ( accp @ ( product_prod @ num @ num ) @ bit_un4731106466462545111um_rel @ ( product_Pair @ num @ num @ ( bit0 @ M3 ) @ ( bit0 @ N ) ) ) ) ) )
                 => ( ! [M3: num] :
                        ( ( X2
                          = ( bit0 @ M3 ) )
                       => ! [N: num] :
                            ( ( Xa2
                              = ( bit1 @ N ) )
                           => ( ( Y2
                                = ( map_option @ num @ num @ bit0 @ ( bit_un7362597486090784418nd_num @ M3 @ N ) ) )
                             => ~ ( accp @ ( product_prod @ num @ num ) @ bit_un4731106466462545111um_rel @ ( product_Pair @ num @ num @ ( bit0 @ M3 ) @ ( bit1 @ N ) ) ) ) ) )
                   => ( ! [M3: num] :
                          ( ( X2
                            = ( bit1 @ M3 ) )
                         => ( ( Xa2 = one2 )
                           => ( ( Y2
                                = ( some @ num @ one2 ) )
                             => ~ ( accp @ ( product_prod @ num @ num ) @ bit_un4731106466462545111um_rel @ ( product_Pair @ num @ num @ ( bit1 @ M3 ) @ one2 ) ) ) ) )
                     => ( ! [M3: num] :
                            ( ( X2
                              = ( bit1 @ M3 ) )
                           => ! [N: num] :
                                ( ( Xa2
                                  = ( bit0 @ N ) )
                               => ( ( Y2
                                    = ( map_option @ num @ num @ bit0 @ ( bit_un7362597486090784418nd_num @ M3 @ N ) ) )
                                 => ~ ( accp @ ( product_prod @ num @ num ) @ bit_un4731106466462545111um_rel @ ( product_Pair @ num @ num @ ( bit1 @ M3 ) @ ( bit0 @ N ) ) ) ) ) )
                       => ~ ! [M3: num] :
                              ( ( X2
                                = ( bit1 @ M3 ) )
                             => ! [N: num] :
                                  ( ( Xa2
                                    = ( bit1 @ N ) )
                                 => ( ( Y2
                                      = ( case_option @ ( option @ num ) @ num @ ( some @ num @ one2 )
                                        @ ^ [N10: num] : ( some @ num @ ( bit1 @ N10 ) )
                                        @ ( bit_un7362597486090784418nd_num @ M3 @ N ) ) )
                                   => ~ ( accp @ ( product_prod @ num @ num ) @ bit_un4731106466462545111um_rel @ ( product_Pair @ num @ num @ ( bit1 @ M3 ) @ ( bit1 @ N ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ).

% and_num.pelims
thf(fact_7562_xor__num_Oelims,axiom,
    ! [X2: num,Xa2: num,Y2: option @ num] :
      ( ( ( bit_un2480387367778600638or_num @ X2 @ Xa2 )
        = Y2 )
     => ( ( ( X2 = one2 )
         => ( ( Xa2 = one2 )
           => ( Y2
             != ( none @ num ) ) ) )
       => ( ( ( X2 = one2 )
           => ! [N: num] :
                ( ( Xa2
                  = ( bit0 @ N ) )
               => ( Y2
                 != ( some @ num @ ( bit1 @ N ) ) ) ) )
         => ( ( ( X2 = one2 )
             => ! [N: num] :
                  ( ( Xa2
                    = ( bit1 @ N ) )
                 => ( Y2
                   != ( some @ num @ ( bit0 @ N ) ) ) ) )
           => ( ! [M3: num] :
                  ( ( X2
                    = ( bit0 @ M3 ) )
                 => ( ( Xa2 = one2 )
                   => ( Y2
                     != ( some @ num @ ( bit1 @ M3 ) ) ) ) )
             => ( ! [M3: num] :
                    ( ( X2
                      = ( bit0 @ M3 ) )
                   => ! [N: num] :
                        ( ( Xa2
                          = ( bit0 @ N ) )
                       => ( Y2
                         != ( map_option @ num @ num @ bit0 @ ( bit_un2480387367778600638or_num @ M3 @ N ) ) ) ) )
               => ( ! [M3: num] :
                      ( ( X2
                        = ( bit0 @ M3 ) )
                     => ! [N: num] :
                          ( ( Xa2
                            = ( bit1 @ N ) )
                         => ( Y2
                           != ( some @ num @ ( case_option @ num @ num @ one2 @ bit1 @ ( bit_un2480387367778600638or_num @ M3 @ N ) ) ) ) ) )
                 => ( ! [M3: num] :
                        ( ( X2
                          = ( bit1 @ M3 ) )
                       => ( ( Xa2 = one2 )
                         => ( Y2
                           != ( some @ num @ ( bit0 @ M3 ) ) ) ) )
                   => ( ! [M3: num] :
                          ( ( X2
                            = ( bit1 @ M3 ) )
                         => ! [N: num] :
                              ( ( Xa2
                                = ( bit0 @ N ) )
                             => ( Y2
                               != ( some @ num @ ( case_option @ num @ num @ one2 @ bit1 @ ( bit_un2480387367778600638or_num @ M3 @ N ) ) ) ) ) )
                     => ~ ! [M3: num] :
                            ( ( X2
                              = ( bit1 @ M3 ) )
                           => ! [N: num] :
                                ( ( Xa2
                                  = ( bit1 @ N ) )
                               => ( Y2
                                 != ( map_option @ num @ num @ bit0 @ ( bit_un2480387367778600638or_num @ M3 @ N ) ) ) ) ) ) ) ) ) ) ) ) ) ) ).

% xor_num.elims
thf(fact_7563_xor__num_Osimps_I5_J,axiom,
    ! [M: num,N2: num] :
      ( ( bit_un2480387367778600638or_num @ ( bit0 @ M ) @ ( bit0 @ N2 ) )
      = ( map_option @ num @ num @ bit0 @ ( bit_un2480387367778600638or_num @ M @ N2 ) ) ) ).

% xor_num.simps(5)
thf(fact_7564_xor__num_Osimps_I1_J,axiom,
    ( ( bit_un2480387367778600638or_num @ one2 @ one2 )
    = ( none @ num ) ) ).

% xor_num.simps(1)
thf(fact_7565_xor__num__eq__Some__iff,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [M: num,N2: num,Q3: num] :
          ( ( ( bit_un2480387367778600638or_num @ M @ N2 )
            = ( some @ num @ Q3 ) )
          = ( ( bit_se5824344971392196577ns_xor @ A @ ( numeral_numeral @ A @ M ) @ ( numeral_numeral @ A @ N2 ) )
            = ( numeral_numeral @ A @ Q3 ) ) ) ) ).

% xor_num_eq_Some_iff
thf(fact_7566_xor__num_Osimps_I9_J,axiom,
    ! [M: num,N2: num] :
      ( ( bit_un2480387367778600638or_num @ ( bit1 @ M ) @ ( bit1 @ N2 ) )
      = ( map_option @ num @ num @ bit0 @ ( bit_un2480387367778600638or_num @ M @ N2 ) ) ) ).

% xor_num.simps(9)
thf(fact_7567_xor__num_Osimps_I2_J,axiom,
    ! [N2: num] :
      ( ( bit_un2480387367778600638or_num @ one2 @ ( bit0 @ N2 ) )
      = ( some @ num @ ( bit1 @ N2 ) ) ) ).

% xor_num.simps(2)
thf(fact_7568_xor__num_Osimps_I3_J,axiom,
    ! [N2: num] :
      ( ( bit_un2480387367778600638or_num @ one2 @ ( bit1 @ N2 ) )
      = ( some @ num @ ( bit0 @ N2 ) ) ) ).

% xor_num.simps(3)
thf(fact_7569_xor__num_Osimps_I4_J,axiom,
    ! [M: num] :
      ( ( bit_un2480387367778600638or_num @ ( bit0 @ M ) @ one2 )
      = ( some @ num @ ( bit1 @ M ) ) ) ).

% xor_num.simps(4)
thf(fact_7570_xor__num_Osimps_I7_J,axiom,
    ! [M: num] :
      ( ( bit_un2480387367778600638or_num @ ( bit1 @ M ) @ one2 )
      = ( some @ num @ ( bit0 @ M ) ) ) ).

% xor_num.simps(7)
thf(fact_7571_xor__num__eq__None__iff,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [M: num,N2: num] :
          ( ( ( bit_un2480387367778600638or_num @ M @ N2 )
            = ( none @ num ) )
          = ( ( bit_se5824344971392196577ns_xor @ A @ ( numeral_numeral @ A @ M ) @ ( numeral_numeral @ A @ N2 ) )
            = ( zero_zero @ A ) ) ) ) ).

% xor_num_eq_None_iff
thf(fact_7572_numeral__xor__num,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [M: num,N2: num] :
          ( ( bit_se5824344971392196577ns_xor @ A @ ( numeral_numeral @ A @ M ) @ ( numeral_numeral @ A @ N2 ) )
          = ( case_option @ A @ num @ ( zero_zero @ A ) @ ( numeral_numeral @ A ) @ ( bit_un2480387367778600638or_num @ M @ N2 ) ) ) ) ).

% numeral_xor_num
thf(fact_7573_xor__num_Osimps_I6_J,axiom,
    ! [M: num,N2: num] :
      ( ( bit_un2480387367778600638or_num @ ( bit0 @ M ) @ ( bit1 @ N2 ) )
      = ( some @ num @ ( case_option @ num @ num @ one2 @ bit1 @ ( bit_un2480387367778600638or_num @ M @ N2 ) ) ) ) ).

% xor_num.simps(6)
thf(fact_7574_xor__num_Osimps_I8_J,axiom,
    ! [M: num,N2: num] :
      ( ( bit_un2480387367778600638or_num @ ( bit1 @ M ) @ ( bit0 @ N2 ) )
      = ( some @ num @ ( case_option @ num @ num @ one2 @ bit1 @ ( bit_un2480387367778600638or_num @ M @ N2 ) ) ) ) ).

% xor_num.simps(8)
thf(fact_7575_xor__num_Opelims,axiom,
    ! [X2: num,Xa2: num,Y2: option @ num] :
      ( ( ( bit_un2480387367778600638or_num @ X2 @ Xa2 )
        = Y2 )
     => ( ( accp @ ( product_prod @ num @ num ) @ bit_un2901131394128224187um_rel @ ( product_Pair @ num @ num @ X2 @ Xa2 ) )
       => ( ( ( X2 = one2 )
           => ( ( Xa2 = one2 )
             => ( ( Y2
                  = ( none @ num ) )
               => ~ ( accp @ ( product_prod @ num @ num ) @ bit_un2901131394128224187um_rel @ ( product_Pair @ num @ num @ one2 @ one2 ) ) ) ) )
         => ( ( ( X2 = one2 )
             => ! [N: num] :
                  ( ( Xa2
                    = ( bit0 @ N ) )
                 => ( ( Y2
                      = ( some @ num @ ( bit1 @ N ) ) )
                   => ~ ( accp @ ( product_prod @ num @ num ) @ bit_un2901131394128224187um_rel @ ( product_Pair @ num @ num @ one2 @ ( bit0 @ N ) ) ) ) ) )
           => ( ( ( X2 = one2 )
               => ! [N: num] :
                    ( ( Xa2
                      = ( bit1 @ N ) )
                   => ( ( Y2
                        = ( some @ num @ ( bit0 @ N ) ) )
                     => ~ ( accp @ ( product_prod @ num @ num ) @ bit_un2901131394128224187um_rel @ ( product_Pair @ num @ num @ one2 @ ( bit1 @ N ) ) ) ) ) )
             => ( ! [M3: num] :
                    ( ( X2
                      = ( bit0 @ M3 ) )
                   => ( ( Xa2 = one2 )
                     => ( ( Y2
                          = ( some @ num @ ( bit1 @ M3 ) ) )
                       => ~ ( accp @ ( product_prod @ num @ num ) @ bit_un2901131394128224187um_rel @ ( product_Pair @ num @ num @ ( bit0 @ M3 ) @ one2 ) ) ) ) )
               => ( ! [M3: num] :
                      ( ( X2
                        = ( bit0 @ M3 ) )
                     => ! [N: num] :
                          ( ( Xa2
                            = ( bit0 @ N ) )
                         => ( ( Y2
                              = ( map_option @ num @ num @ bit0 @ ( bit_un2480387367778600638or_num @ M3 @ N ) ) )
                           => ~ ( accp @ ( product_prod @ num @ num ) @ bit_un2901131394128224187um_rel @ ( product_Pair @ num @ num @ ( bit0 @ M3 ) @ ( bit0 @ N ) ) ) ) ) )
                 => ( ! [M3: num] :
                        ( ( X2
                          = ( bit0 @ M3 ) )
                       => ! [N: num] :
                            ( ( Xa2
                              = ( bit1 @ N ) )
                           => ( ( Y2
                                = ( some @ num @ ( case_option @ num @ num @ one2 @ bit1 @ ( bit_un2480387367778600638or_num @ M3 @ N ) ) ) )
                             => ~ ( accp @ ( product_prod @ num @ num ) @ bit_un2901131394128224187um_rel @ ( product_Pair @ num @ num @ ( bit0 @ M3 ) @ ( bit1 @ N ) ) ) ) ) )
                   => ( ! [M3: num] :
                          ( ( X2
                            = ( bit1 @ M3 ) )
                         => ( ( Xa2 = one2 )
                           => ( ( Y2
                                = ( some @ num @ ( bit0 @ M3 ) ) )
                             => ~ ( accp @ ( product_prod @ num @ num ) @ bit_un2901131394128224187um_rel @ ( product_Pair @ num @ num @ ( bit1 @ M3 ) @ one2 ) ) ) ) )
                     => ( ! [M3: num] :
                            ( ( X2
                              = ( bit1 @ M3 ) )
                           => ! [N: num] :
                                ( ( Xa2
                                  = ( bit0 @ N ) )
                               => ( ( Y2
                                    = ( some @ num @ ( case_option @ num @ num @ one2 @ bit1 @ ( bit_un2480387367778600638or_num @ M3 @ N ) ) ) )
                                 => ~ ( accp @ ( product_prod @ num @ num ) @ bit_un2901131394128224187um_rel @ ( product_Pair @ num @ num @ ( bit1 @ M3 ) @ ( bit0 @ N ) ) ) ) ) )
                       => ~ ! [M3: num] :
                              ( ( X2
                                = ( bit1 @ M3 ) )
                             => ! [N: num] :
                                  ( ( Xa2
                                    = ( bit1 @ N ) )
                                 => ( ( Y2
                                      = ( map_option @ num @ num @ bit0 @ ( bit_un2480387367778600638or_num @ M3 @ N ) ) )
                                   => ~ ( accp @ ( product_prod @ num @ num ) @ bit_un2901131394128224187um_rel @ ( product_Pair @ num @ num @ ( bit1 @ M3 ) @ ( bit1 @ N ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ).

% xor_num.pelims
thf(fact_7576_and__num__rel__dict,axiom,
    bit_un4731106466462545111um_rel = bit_un5425074673868309765um_rel ).

% and_num_rel_dict
thf(fact_7577_xor__num__rel__dict,axiom,
    bit_un2901131394128224187um_rel = bit_un3595099601533988841um_rel ).

% xor_num_rel_dict
thf(fact_7578_and__num__dict,axiom,
    bit_un7362597486090784418nd_num = bit_un1837492267222099188nd_num ).

% and_num_dict
thf(fact_7579_xor__num__dict,axiom,
    bit_un2480387367778600638or_num = bit_un6178654185764691216or_num ).

% xor_num_dict
thf(fact_7580_map__of__map__restrict,axiom,
    ! [B: $tType,A: $tType,F2: A > B,Ks: list @ A] :
      ( ( map_of @ A @ B
        @ ( map @ A @ ( product_prod @ A @ B )
          @ ^ [K3: A] : ( product_Pair @ A @ B @ K3 @ ( F2 @ K3 ) )
          @ Ks ) )
      = ( restrict_map @ A @ B @ ( comp @ B @ ( option @ B ) @ A @ ( some @ B ) @ F2 ) @ ( set2 @ A @ Ks ) ) ) ).

% map_of_map_restrict
thf(fact_7581_restrict__out,axiom,
    ! [A: $tType,B: $tType,X2: A,A3: set @ A,M: A > ( option @ B )] :
      ( ~ ( member @ A @ X2 @ A3 )
     => ( ( restrict_map @ A @ B @ M @ A3 @ X2 )
        = ( none @ B ) ) ) ).

% restrict_out
thf(fact_7582_restrict__map__empty,axiom,
    ! [B: $tType,A: $tType,D5: set @ A] :
      ( ( restrict_map @ A @ B
        @ ^ [X5: A] : ( none @ B )
        @ D5 )
      = ( ^ [X5: A] : ( none @ B ) ) ) ).

% restrict_map_empty
thf(fact_7583_restrict__map__to__empty,axiom,
    ! [B: $tType,A: $tType,M: A > ( option @ B )] :
      ( ( restrict_map @ A @ B @ M @ ( bot_bot @ ( set @ A ) ) )
      = ( ^ [X5: A] : ( none @ B ) ) ) ).

% restrict_map_to_empty
thf(fact_7584_restrict__map__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( restrict_map @ A @ B )
      = ( ^ [M6: A > ( option @ B ),A7: set @ A,X5: A] : ( if @ ( option @ B ) @ ( member @ A @ X5 @ A7 ) @ ( M6 @ X5 ) @ ( none @ B ) ) ) ) ).

% restrict_map_def
thf(fact_7585_sum__list__map__eq__sum__count2,axiom,
    ! [A: $tType,Xs: list @ A,X8: set @ A,F2: A > nat] :
      ( ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ Xs ) @ X8 )
     => ( ( finite_finite @ A @ X8 )
       => ( ( groups8242544230860333062m_list @ nat @ ( map @ A @ nat @ F2 @ Xs ) )
          = ( groups7311177749621191930dd_sum @ A @ nat
            @ ^ [X5: A] : ( times_times @ nat @ ( count_list @ A @ Xs @ X5 ) @ ( F2 @ X5 ) )
            @ X8 ) ) ) ) ).

% sum_list_map_eq_sum_count2
thf(fact_7586_restrict__map__upds,axiom,
    ! [A: $tType,B: $tType,Xs: list @ A,Ys: list @ B,D5: set @ A,M: A > ( option @ B )] :
      ( ( ( size_size @ ( list @ A ) @ Xs )
        = ( size_size @ ( list @ B ) @ Ys ) )
     => ( ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ Xs ) @ D5 )
       => ( ( restrict_map @ A @ B @ ( map_upds @ A @ B @ M @ Xs @ Ys ) @ D5 )
          = ( map_upds @ A @ B @ ( restrict_map @ A @ B @ M @ ( minus_minus @ ( set @ A ) @ D5 @ ( set2 @ A @ Xs ) ) ) @ Xs @ Ys ) ) ) ) ).

% restrict_map_upds
thf(fact_7587_map__upds__apply__nontin,axiom,
    ! [B: $tType,A: $tType,X2: A,Xs: list @ A,F2: A > ( option @ B ),Ys: list @ B] :
      ( ~ ( member @ A @ X2 @ ( set2 @ A @ Xs ) )
     => ( ( map_upds @ A @ B @ F2 @ Xs @ Ys @ X2 )
        = ( F2 @ X2 ) ) ) ).

% map_upds_apply_nontin
thf(fact_7588_sum__list_ONil,axiom,
    ! [A: $tType] :
      ( ( monoid_add @ A )
     => ( ( groups8242544230860333062m_list @ A @ ( nil @ A ) )
        = ( zero_zero @ A ) ) ) ).

% sum_list.Nil
thf(fact_7589_sum__list__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ! [Ns: list @ A] :
          ( ( ( groups8242544230860333062m_list @ A @ Ns )
            = ( zero_zero @ A ) )
          = ( ! [X5: A] :
                ( ( member @ A @ X5 @ ( set2 @ A @ Ns ) )
               => ( X5
                  = ( zero_zero @ A ) ) ) ) ) ) ).

% sum_list_eq_0_iff
thf(fact_7590_sum__list_OCons,axiom,
    ! [A: $tType] :
      ( ( monoid_add @ A )
     => ! [X2: A,Xs: list @ A] :
          ( ( groups8242544230860333062m_list @ A @ ( cons @ A @ X2 @ Xs ) )
          = ( plus_plus @ A @ X2 @ ( groups8242544230860333062m_list @ A @ Xs ) ) ) ) ).

% sum_list.Cons
thf(fact_7591_sum__list__append,axiom,
    ! [A: $tType] :
      ( ( monoid_add @ A )
     => ! [Xs: list @ A,Ys: list @ A] :
          ( ( groups8242544230860333062m_list @ A @ ( append @ A @ Xs @ Ys ) )
          = ( plus_plus @ A @ ( groups8242544230860333062m_list @ A @ Xs ) @ ( groups8242544230860333062m_list @ A @ Ys ) ) ) ) ).

% sum_list_append
thf(fact_7592_fun__upds__append2__drop,axiom,
    ! [A: $tType,B: $tType,Xs: list @ A,Ys: list @ B,M: A > ( option @ B ),Zs: list @ B] :
      ( ( ( size_size @ ( list @ A ) @ Xs )
        = ( size_size @ ( list @ B ) @ Ys ) )
     => ( ( map_upds @ A @ B @ M @ Xs @ ( append @ B @ Ys @ Zs ) )
        = ( map_upds @ A @ B @ M @ Xs @ Ys ) ) ) ).

% fun_upds_append2_drop
thf(fact_7593_fun__upds__append__drop,axiom,
    ! [A: $tType,B: $tType,Xs: list @ A,Ys: list @ B,M: A > ( option @ B ),Zs: list @ A] :
      ( ( ( size_size @ ( list @ A ) @ Xs )
        = ( size_size @ ( list @ B ) @ Ys ) )
     => ( ( map_upds @ A @ B @ M @ ( append @ A @ Xs @ Zs ) @ Ys )
        = ( map_upds @ A @ B @ M @ Xs @ Ys ) ) ) ).

% fun_upds_append_drop
thf(fact_7594_sum__list__0,axiom,
    ! [B: $tType,A: $tType] :
      ( ( monoid_add @ A )
     => ! [Xs: list @ B] :
          ( ( groups8242544230860333062m_list @ A
            @ ( map @ B @ A
              @ ^ [X5: B] : ( zero_zero @ A )
              @ Xs ) )
          = ( zero_zero @ A ) ) ) ).

% sum_list_0
thf(fact_7595_map__upds__list__update2__drop,axiom,
    ! [A: $tType,B: $tType,Xs: list @ A,I3: nat,M: A > ( option @ B ),Ys: list @ B,Y2: B] :
      ( ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ I3 )
     => ( ( map_upds @ A @ B @ M @ Xs @ ( list_update @ B @ Ys @ I3 @ Y2 ) )
        = ( map_upds @ A @ B @ M @ Xs @ Ys ) ) ) ).

% map_upds_list_update2_drop
thf(fact_7596_sum__list__upt,axiom,
    ! [M: nat,N2: nat] :
      ( ( ord_less_eq @ nat @ M @ N2 )
     => ( ( groups8242544230860333062m_list @ nat @ ( upt @ M @ N2 ) )
        = ( groups7311177749621191930dd_sum @ nat @ nat
          @ ^ [X5: nat] : X5
          @ ( set_or7035219750837199246ssThan @ nat @ M @ N2 ) ) ) ) ).

% sum_list_upt
thf(fact_7597_sum__list__addf,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [F2: B > A,G: B > A,Xs: list @ B] :
          ( ( groups8242544230860333062m_list @ A
            @ ( map @ B @ A
              @ ^ [X5: B] : ( plus_plus @ A @ ( F2 @ X5 ) @ ( G @ X5 ) )
              @ Xs ) )
          = ( plus_plus @ A @ ( groups8242544230860333062m_list @ A @ ( map @ B @ A @ F2 @ Xs ) ) @ ( groups8242544230860333062m_list @ A @ ( map @ B @ A @ G @ Xs ) ) ) ) ) ).

% sum_list_addf
thf(fact_7598_sum__list__mult__const,axiom,
    ! [B: $tType,A: $tType] :
      ( ( semiring_0 @ A )
     => ! [F2: B > A,C2: A,Xs: list @ B] :
          ( ( groups8242544230860333062m_list @ A
            @ ( map @ B @ A
              @ ^ [X5: B] : ( times_times @ A @ ( F2 @ X5 ) @ C2 )
              @ Xs ) )
          = ( times_times @ A @ ( groups8242544230860333062m_list @ A @ ( map @ B @ A @ F2 @ Xs ) ) @ C2 ) ) ) ).

% sum_list_mult_const
thf(fact_7599_sum__list__const__mult,axiom,
    ! [A: $tType,B: $tType] :
      ( ( semiring_0 @ A )
     => ! [C2: A,F2: B > A,Xs: list @ B] :
          ( ( groups8242544230860333062m_list @ A
            @ ( map @ B @ A
              @ ^ [X5: B] : ( times_times @ A @ C2 @ ( F2 @ X5 ) )
              @ Xs ) )
          = ( times_times @ A @ C2 @ ( groups8242544230860333062m_list @ A @ ( map @ B @ A @ F2 @ Xs ) ) ) ) ) ).

% sum_list_const_mult
thf(fact_7600_length__concat,axiom,
    ! [B: $tType,Xss: list @ ( list @ B )] :
      ( ( size_size @ ( list @ B ) @ ( concat @ B @ Xss ) )
      = ( groups8242544230860333062m_list @ nat @ ( map @ ( list @ B ) @ nat @ ( size_size @ ( list @ B ) ) @ Xss ) ) ) ).

% length_concat
thf(fact_7601_Groups__List_Osum__list__nonneg,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [Xs: list @ A] :
          ( ! [X3: A] :
              ( ( member @ A @ X3 @ ( set2 @ A @ Xs ) )
             => ( ord_less_eq @ A @ ( zero_zero @ A ) @ X3 ) )
         => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( groups8242544230860333062m_list @ A @ Xs ) ) ) ) ).

% Groups_List.sum_list_nonneg
thf(fact_7602_sum__list__nonneg__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [Xs: list @ A] :
          ( ! [X3: A] :
              ( ( member @ A @ X3 @ ( set2 @ A @ Xs ) )
             => ( ord_less_eq @ A @ ( zero_zero @ A ) @ X3 ) )
         => ( ( ( groups8242544230860333062m_list @ A @ Xs )
              = ( zero_zero @ A ) )
            = ( ! [X5: A] :
                  ( ( member @ A @ X5 @ ( set2 @ A @ Xs ) )
                 => ( X5
                    = ( zero_zero @ A ) ) ) ) ) ) ) ).

% sum_list_nonneg_eq_0_iff
thf(fact_7603_sum__list__nonpos,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [Xs: list @ A] :
          ( ! [X3: A] :
              ( ( member @ A @ X3 @ ( set2 @ A @ Xs ) )
             => ( ord_less_eq @ A @ X3 @ ( zero_zero @ A ) ) )
         => ( ord_less_eq @ A @ ( groups8242544230860333062m_list @ A @ Xs ) @ ( zero_zero @ A ) ) ) ) ).

% sum_list_nonpos
thf(fact_7604_member__le__sum__list,axiom,
    ! [A: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ! [X2: A,Xs: list @ A] :
          ( ( member @ A @ X2 @ ( set2 @ A @ Xs ) )
         => ( ord_less_eq @ A @ X2 @ ( groups8242544230860333062m_list @ A @ Xs ) ) ) ) ).

% member_le_sum_list
thf(fact_7605_sum__list__abs,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [Xs: list @ A] : ( ord_less_eq @ A @ ( abs_abs @ A @ ( groups8242544230860333062m_list @ A @ Xs ) ) @ ( groups8242544230860333062m_list @ A @ ( map @ A @ A @ ( abs_abs @ A ) @ Xs ) ) ) ) ).

% sum_list_abs
thf(fact_7606_sum__list__replicate,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [N2: nat,C2: A] :
          ( ( groups8242544230860333062m_list @ A @ ( replicate @ A @ N2 @ C2 ) )
          = ( times_times @ A @ ( semiring_1_of_nat @ A @ N2 ) @ C2 ) ) ) ).

% sum_list_replicate
thf(fact_7607_sum__list__mono,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( monoid_add @ B )
        & ( ordere6658533253407199908up_add @ B ) )
     => ! [Xs: list @ A,F2: A > B,G: A > B] :
          ( ! [X3: A] :
              ( ( member @ A @ X3 @ ( set2 @ A @ Xs ) )
             => ( ord_less_eq @ B @ ( F2 @ X3 ) @ ( G @ X3 ) ) )
         => ( ord_less_eq @ B @ ( groups8242544230860333062m_list @ B @ ( map @ A @ B @ F2 @ Xs ) ) @ ( groups8242544230860333062m_list @ B @ ( map @ A @ B @ G @ Xs ) ) ) ) ) ).

% sum_list_mono
thf(fact_7608_distinct__sum__list__conv__Sum,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [Xs: list @ A] :
          ( ( distinct @ A @ Xs )
         => ( ( groups8242544230860333062m_list @ A @ Xs )
            = ( groups7311177749621191930dd_sum @ A @ A
              @ ^ [X5: A] : X5
              @ ( set2 @ A @ Xs ) ) ) ) ) ).

% distinct_sum_list_conv_Sum
thf(fact_7609_sum__list__strict__mono,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( monoid_add @ B )
        & ( strict9044650504122735259up_add @ B ) )
     => ! [Xs: list @ A,F2: A > B,G: A > B] :
          ( ( Xs
           != ( nil @ A ) )
         => ( ! [X3: A] :
                ( ( member @ A @ X3 @ ( set2 @ A @ Xs ) )
               => ( ord_less @ B @ ( F2 @ X3 ) @ ( G @ X3 ) ) )
           => ( ord_less @ B @ ( groups8242544230860333062m_list @ B @ ( map @ A @ B @ F2 @ Xs ) ) @ ( groups8242544230860333062m_list @ B @ ( map @ A @ B @ G @ Xs ) ) ) ) ) ) ).

% sum_list_strict_mono
thf(fact_7610_elem__le__sum__list,axiom,
    ! [A: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ! [K: nat,Ns: list @ A] :
          ( ( ord_less @ nat @ K @ ( size_size @ ( list @ A ) @ Ns ) )
         => ( ord_less_eq @ A @ ( nth @ A @ Ns @ K ) @ ( groups8242544230860333062m_list @ A @ Ns ) ) ) ) ).

% elem_le_sum_list
thf(fact_7611_sum__list__distinct__conv__sum__set,axiom,
    ! [C: $tType,B: $tType] :
      ( ( comm_monoid_add @ C )
     => ! [Xs: list @ B,F2: B > C] :
          ( ( distinct @ B @ Xs )
         => ( ( groups8242544230860333062m_list @ C @ ( map @ B @ C @ F2 @ Xs ) )
            = ( groups7311177749621191930dd_sum @ B @ C @ F2 @ ( set2 @ B @ Xs ) ) ) ) ) ).

% sum_list_distinct_conv_sum_set
thf(fact_7612_sum_Odistinct__set__conv__list,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [Xs: list @ B,G: B > A] :
          ( ( distinct @ B @ Xs )
         => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ ( set2 @ B @ Xs ) )
            = ( groups8242544230860333062m_list @ A @ ( map @ B @ A @ G @ Xs ) ) ) ) ) ).

% sum.distinct_set_conv_list
thf(fact_7613_sum__list__map__remove1,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [X2: B,Xs: list @ B,F2: B > A] :
          ( ( member @ B @ X2 @ ( set2 @ B @ Xs ) )
         => ( ( groups8242544230860333062m_list @ A @ ( map @ B @ A @ F2 @ Xs ) )
            = ( plus_plus @ A @ ( F2 @ X2 ) @ ( groups8242544230860333062m_list @ A @ ( map @ B @ A @ F2 @ ( remove1 @ B @ X2 @ Xs ) ) ) ) ) ) ) ).

% sum_list_map_remove1
thf(fact_7614_sum__code,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: B > A,Xs: list @ B] :
          ( ( groups7311177749621191930dd_sum @ B @ A @ G @ ( set2 @ B @ Xs ) )
          = ( groups8242544230860333062m_list @ A @ ( map @ B @ A @ G @ ( remdups @ B @ Xs ) ) ) ) ) ).

% sum_code
thf(fact_7615_size__list__conv__sum__list,axiom,
    ! [B: $tType] :
      ( ( size_list @ B )
      = ( ^ [F5: B > nat,Xs3: list @ B] : ( plus_plus @ nat @ ( groups8242544230860333062m_list @ nat @ ( map @ B @ nat @ F5 @ Xs3 ) ) @ ( size_size @ ( list @ B ) @ Xs3 ) ) ) ) ).

% size_list_conv_sum_list
thf(fact_7616_sum__list__triv,axiom,
    ! [C: $tType,B: $tType] :
      ( ( semiring_1 @ B )
     => ! [R3: B,Xs: list @ C] :
          ( ( groups8242544230860333062m_list @ B
            @ ( map @ C @ B
              @ ^ [X5: C] : R3
              @ Xs ) )
          = ( times_times @ B @ ( semiring_1_of_nat @ B @ ( size_size @ ( list @ C ) @ Xs ) ) @ R3 ) ) ) ).

% sum_list_triv
thf(fact_7617_sum__list__Suc,axiom,
    ! [A: $tType,F2: A > nat,Xs: list @ A] :
      ( ( groups8242544230860333062m_list @ nat
        @ ( map @ A @ nat
          @ ^ [X5: A] : ( suc @ ( F2 @ X5 ) )
          @ Xs ) )
      = ( plus_plus @ nat @ ( groups8242544230860333062m_list @ nat @ ( map @ A @ nat @ F2 @ Xs ) ) @ ( size_size @ ( list @ A ) @ Xs ) ) ) ).

% sum_list_Suc
thf(fact_7618_sum__list__sum__nth,axiom,
    ! [B: $tType] :
      ( ( comm_monoid_add @ B )
     => ( ( groups8242544230860333062m_list @ B )
        = ( ^ [Xs3: list @ B] : ( groups7311177749621191930dd_sum @ nat @ B @ ( nth @ B @ Xs3 ) @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( size_size @ ( list @ B ) @ Xs3 ) ) ) ) ) ) ).

% sum_list_sum_nth
thf(fact_7619_card__length__sum__list__rec,axiom,
    ! [M: nat,N4: nat] :
      ( ( ord_less_eq @ nat @ ( one_one @ nat ) @ M )
     => ( ( finite_card @ ( list @ nat )
          @ ( collect @ ( list @ nat )
            @ ^ [L2: list @ nat] :
                ( ( ( size_size @ ( list @ nat ) @ L2 )
                  = M )
                & ( ( groups8242544230860333062m_list @ nat @ L2 )
                  = N4 ) ) ) )
        = ( plus_plus @ nat
          @ ( finite_card @ ( list @ nat )
            @ ( collect @ ( list @ nat )
              @ ^ [L2: list @ nat] :
                  ( ( ( size_size @ ( list @ nat ) @ L2 )
                    = ( minus_minus @ nat @ M @ ( one_one @ nat ) ) )
                  & ( ( groups8242544230860333062m_list @ nat @ L2 )
                    = N4 ) ) ) )
          @ ( finite_card @ ( list @ nat )
            @ ( collect @ ( list @ nat )
              @ ^ [L2: list @ nat] :
                  ( ( ( size_size @ ( list @ nat ) @ L2 )
                    = M )
                  & ( ( plus_plus @ nat @ ( groups8242544230860333062m_list @ nat @ L2 ) @ ( one_one @ nat ) )
                    = N4 ) ) ) ) ) ) ) ).

% card_length_sum_list_rec
thf(fact_7620_card__length__sum__list,axiom,
    ! [M: nat,N4: nat] :
      ( ( finite_card @ ( list @ nat )
        @ ( collect @ ( list @ nat )
          @ ^ [L2: list @ nat] :
              ( ( ( size_size @ ( list @ nat ) @ L2 )
                = M )
              & ( ( groups8242544230860333062m_list @ nat @ L2 )
                = N4 ) ) ) )
      = ( binomial @ ( minus_minus @ nat @ ( plus_plus @ nat @ N4 @ M ) @ ( one_one @ nat ) ) @ N4 ) ) ).

% card_length_sum_list
thf(fact_7621_sum__list__map__eq__sum__count,axiom,
    ! [A: $tType,F2: A > nat,Xs: list @ A] :
      ( ( groups8242544230860333062m_list @ nat @ ( map @ A @ nat @ F2 @ Xs ) )
      = ( groups7311177749621191930dd_sum @ A @ nat
        @ ^ [X5: A] : ( times_times @ nat @ ( count_list @ A @ Xs @ X5 ) @ ( F2 @ X5 ) )
        @ ( set2 @ A @ Xs ) ) ) ).

% sum_list_map_eq_sum_count
thf(fact_7622_sum__list__update,axiom,
    ! [A: $tType] :
      ( ( ordere1170586879665033532d_diff @ A )
     => ! [K: nat,Xs: list @ A,X2: A] :
          ( ( ord_less @ nat @ K @ ( size_size @ ( list @ A ) @ Xs ) )
         => ( ( groups8242544230860333062m_list @ A @ ( list_update @ A @ Xs @ K @ X2 ) )
            = ( minus_minus @ A @ ( plus_plus @ A @ ( groups8242544230860333062m_list @ A @ Xs ) @ X2 ) @ ( nth @ A @ Xs @ K ) ) ) ) ) ).

% sum_list_update
thf(fact_7623_sorted__wrt__less__sum__mono__lowerbound,axiom,
    ! [B: $tType] :
      ( ( ordere6911136660526730532id_add @ B )
     => ! [F2: nat > B,Ns: list @ nat] :
          ( ! [X3: nat,Y4: nat] :
              ( ( ord_less_eq @ nat @ X3 @ Y4 )
             => ( ord_less_eq @ B @ ( F2 @ X3 ) @ ( F2 @ Y4 ) ) )
         => ( ( sorted_wrt @ nat @ ( ord_less @ nat ) @ Ns )
           => ( ord_less_eq @ B @ ( groups7311177749621191930dd_sum @ nat @ B @ F2 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( size_size @ ( list @ nat ) @ Ns ) ) ) @ ( groups8242544230860333062m_list @ B @ ( map @ nat @ B @ F2 @ Ns ) ) ) ) ) ) ).

% sorted_wrt_less_sum_mono_lowerbound
thf(fact_7624_map__upds__append1,axiom,
    ! [B: $tType,A: $tType,Xs: list @ A,Ys: list @ B,M: A > ( option @ B ),X2: A] :
      ( ( ord_less @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ ( size_size @ ( list @ B ) @ Ys ) )
     => ( ( map_upds @ A @ B @ M @ ( append @ A @ Xs @ ( cons @ A @ X2 @ ( nil @ A ) ) ) @ Ys )
        = ( fun_upd @ A @ ( option @ B ) @ ( map_upds @ A @ B @ M @ Xs @ Ys ) @ X2 @ ( some @ B @ ( nth @ B @ Ys @ ( size_size @ ( list @ A ) @ Xs ) ) ) ) ) ) ).

% map_upds_append1
thf(fact_7625_empty__upd__none,axiom,
    ! [B: $tType,A: $tType,X2: A] :
      ( ( fun_upd @ A @ ( option @ B )
        @ ^ [X5: A] : ( none @ B )
        @ X2
        @ ( none @ B ) )
      = ( ^ [X5: A] : ( none @ B ) ) ) ).

% empty_upd_none
thf(fact_7626_map__fun__upd,axiom,
    ! [B: $tType,A: $tType,Y2: A,Xs: list @ A,F2: A > B,V: B] :
      ( ~ ( member @ A @ Y2 @ ( set2 @ A @ Xs ) )
     => ( ( map @ A @ B @ ( fun_upd @ A @ B @ F2 @ Y2 @ V ) @ Xs )
        = ( map @ A @ B @ F2 @ Xs ) ) ) ).

% map_fun_upd
thf(fact_7627_image__map__upd,axiom,
    ! [B: $tType,A: $tType,X2: A,A3: set @ A,M: A > ( option @ B ),Y2: B] :
      ( ~ ( member @ A @ X2 @ A3 )
     => ( ( image @ A @ ( option @ B ) @ ( fun_upd @ A @ ( option @ B ) @ M @ X2 @ ( some @ B @ Y2 ) ) @ A3 )
        = ( image @ A @ ( option @ B ) @ M @ A3 ) ) ) ).

% image_map_upd
thf(fact_7628_map__upds__Cons,axiom,
    ! [A: $tType,B: $tType,M: A > ( option @ B ),A2: A,As3: list @ A,B2: B,Bs: list @ B] :
      ( ( map_upds @ A @ B @ M @ ( cons @ A @ A2 @ As3 ) @ ( cons @ B @ B2 @ Bs ) )
      = ( map_upds @ A @ B @ ( fun_upd @ A @ ( option @ B ) @ M @ A2 @ ( some @ B @ B2 ) ) @ As3 @ Bs ) ) ).

% map_upds_Cons
thf(fact_7629_map__upds__twist,axiom,
    ! [A: $tType,B: $tType,A2: A,As3: list @ A,M: A > ( option @ B ),B2: B,Bs: list @ B] :
      ( ~ ( member @ A @ A2 @ ( set2 @ A @ As3 ) )
     => ( ( map_upds @ A @ B @ ( fun_upd @ A @ ( option @ B ) @ M @ A2 @ ( some @ B @ B2 ) ) @ As3 @ Bs )
        = ( fun_upd @ A @ ( option @ B ) @ ( map_upds @ A @ B @ M @ As3 @ Bs ) @ A2 @ ( some @ B @ B2 ) ) ) ) ).

% map_upds_twist
thf(fact_7630_map__option__o__map__upd,axiom,
    ! [A: $tType,B: $tType,C: $tType,F2: C > B,M: A > ( option @ C ),A2: A,B2: C] :
      ( ( comp @ ( option @ C ) @ ( option @ B ) @ A @ ( map_option @ C @ B @ F2 ) @ ( fun_upd @ A @ ( option @ C ) @ M @ A2 @ ( some @ C @ B2 ) ) )
      = ( fun_upd @ A @ ( option @ B ) @ ( comp @ ( option @ C ) @ ( option @ B ) @ A @ ( map_option @ C @ B @ F2 ) @ M ) @ A2 @ ( some @ B @ ( F2 @ B2 ) ) ) ) ).

% map_option_o_map_upd
thf(fact_7631_fun__upd__None__restrict,axiom,
    ! [B: $tType,A: $tType,X2: A,D5: set @ A,M: A > ( option @ B )] :
      ( ( ( member @ A @ X2 @ D5 )
       => ( ( fun_upd @ A @ ( option @ B ) @ ( restrict_map @ A @ B @ M @ D5 ) @ X2 @ ( none @ B ) )
          = ( restrict_map @ A @ B @ M @ ( minus_minus @ ( set @ A ) @ D5 @ ( insert @ A @ X2 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) )
      & ( ~ ( member @ A @ X2 @ D5 )
       => ( ( fun_upd @ A @ ( option @ B ) @ ( restrict_map @ A @ B @ M @ D5 ) @ X2 @ ( none @ B ) )
          = ( restrict_map @ A @ B @ M @ D5 ) ) ) ) ).

% fun_upd_None_restrict
thf(fact_7632_restrict__upd__same,axiom,
    ! [B: $tType,A: $tType,M: A > ( option @ B ),X2: A,Y2: B] :
      ( ( restrict_map @ A @ B @ ( fun_upd @ A @ ( option @ B ) @ M @ X2 @ ( some @ B @ Y2 ) ) @ ( uminus_uminus @ ( set @ A ) @ ( insert @ A @ X2 @ ( bot_bot @ ( set @ A ) ) ) ) )
      = ( restrict_map @ A @ B @ M @ ( uminus_uminus @ ( set @ A ) @ ( insert @ A @ X2 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% restrict_upd_same
thf(fact_7633_sorted__map__remove1,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F2: B > A,Xs: list @ B,X2: B] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( map @ B @ A @ F2 @ Xs ) )
         => ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( map @ B @ A @ F2 @ ( remove1 @ B @ X2 @ Xs ) ) ) ) ) ).

% sorted_map_remove1
thf(fact_7634_sorted__map,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F2: B > A,Xs: list @ B] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( map @ B @ A @ F2 @ Xs ) )
          = ( sorted_wrt @ B
            @ ^ [X5: B,Y5: B] : ( ord_less_eq @ A @ ( F2 @ X5 ) @ ( F2 @ Y5 ) )
            @ Xs ) ) ) ).

% sorted_map
thf(fact_7635_sorted__insort__key,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F2: B > A,X2: B,Xs: list @ B] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( map @ B @ A @ F2 @ ( linorder_insort_key @ B @ A @ F2 @ X2 @ Xs ) ) )
          = ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( map @ B @ A @ F2 @ Xs ) ) ) ) ).

% sorted_insort_key
thf(fact_7636_sorted__wrt__map,axiom,
    ! [A: $tType,B: $tType,R: A > A > $o,F2: B > A,Xs: list @ B] :
      ( ( sorted_wrt @ A @ R @ ( map @ B @ A @ F2 @ Xs ) )
      = ( sorted_wrt @ B
        @ ^ [X5: B,Y5: B] : ( R @ ( F2 @ X5 ) @ ( F2 @ Y5 ) )
        @ Xs ) ) ).

% sorted_wrt_map
thf(fact_7637_sorted__wrt__append,axiom,
    ! [A: $tType,P: A > A > $o,Xs: list @ A,Ys: list @ A] :
      ( ( sorted_wrt @ A @ P @ ( append @ A @ Xs @ Ys ) )
      = ( ( sorted_wrt @ A @ P @ Xs )
        & ( sorted_wrt @ A @ P @ Ys )
        & ! [X5: A] :
            ( ( member @ A @ X5 @ ( set2 @ A @ Xs ) )
           => ! [Y5: A] :
                ( ( member @ A @ Y5 @ ( set2 @ A @ Ys ) )
               => ( P @ X5 @ Y5 ) ) ) ) ) ).

% sorted_wrt_append
thf(fact_7638_sorted__append,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A,Ys: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( append @ A @ Xs @ Ys ) )
          = ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs )
            & ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Ys )
            & ! [X5: A] :
                ( ( member @ A @ X5 @ ( set2 @ A @ Xs ) )
               => ! [Y5: A] :
                    ( ( member @ A @ Y5 @ ( set2 @ A @ Ys ) )
                   => ( ord_less_eq @ A @ X5 @ Y5 ) ) ) ) ) ) ).

% sorted_append
thf(fact_7639_sorted__distinct__set__unique,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A,Ys: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs )
         => ( ( distinct @ A @ Xs )
           => ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Ys )
             => ( ( distinct @ A @ Ys )
               => ( ( ( set2 @ A @ Xs )
                    = ( set2 @ A @ Ys ) )
                 => ( Xs = Ys ) ) ) ) ) ) ) ).

% sorted_distinct_set_unique
thf(fact_7640_strict__sorted__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less @ A ) @ L )
          = ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ L )
            & ( distinct @ A @ L ) ) ) ) ).

% strict_sorted_iff
thf(fact_7641_strict__sorted__simps_I2_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X2: A,Ys: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less @ A ) @ ( cons @ A @ X2 @ Ys ) )
          = ( ! [X5: A] :
                ( ( member @ A @ X5 @ ( set2 @ A @ Ys ) )
               => ( ord_less @ A @ X2 @ X5 ) )
            & ( sorted_wrt @ A @ ( ord_less @ A ) @ Ys ) ) ) ) ).

% strict_sorted_simps(2)
thf(fact_7642_sorted__wrt_Osimps_I2_J,axiom,
    ! [A: $tType,P: A > A > $o,X2: A,Ys: list @ A] :
      ( ( sorted_wrt @ A @ P @ ( cons @ A @ X2 @ Ys ) )
      = ( ! [X5: A] :
            ( ( member @ A @ X5 @ ( set2 @ A @ Ys ) )
           => ( P @ X2 @ X5 ) )
        & ( sorted_wrt @ A @ P @ Ys ) ) ) ).

% sorted_wrt.simps(2)
thf(fact_7643_sorted__wrt_Oelims_I3_J,axiom,
    ! [A: $tType,X2: A > A > $o,Xa2: list @ A] :
      ( ~ ( sorted_wrt @ A @ X2 @ Xa2 )
     => ~ ! [X3: A,Ys4: list @ A] :
            ( ( Xa2
              = ( cons @ A @ X3 @ Ys4 ) )
           => ( ! [Xa3: A] :
                  ( ( member @ A @ Xa3 @ ( set2 @ A @ Ys4 ) )
                 => ( X2 @ X3 @ Xa3 ) )
              & ( sorted_wrt @ A @ X2 @ Ys4 ) ) ) ) ).

% sorted_wrt.elims(3)
thf(fact_7644_sorted__simps_I2_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X2: A,Ys: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( cons @ A @ X2 @ Ys ) )
          = ( ! [X5: A] :
                ( ( member @ A @ X5 @ ( set2 @ A @ Ys ) )
               => ( ord_less_eq @ A @ X2 @ X5 ) )
            & ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Ys ) ) ) ) ).

% sorted_simps(2)
thf(fact_7645_sorted__remdups,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs )
         => ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( remdups @ A @ Xs ) ) ) ) ).

% sorted_remdups
thf(fact_7646_sorted__wrt01,axiom,
    ! [A: $tType,Xs: list @ A,P: A > A > $o] :
      ( ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ ( one_one @ nat ) )
     => ( sorted_wrt @ A @ P @ Xs ) ) ).

% sorted_wrt01
thf(fact_7647_sorted__wrt__mono__rel,axiom,
    ! [A: $tType,Xs: list @ A,P: A > A > $o,Q: A > A > $o] :
      ( ! [X3: A,Y4: A] :
          ( ( member @ A @ X3 @ ( set2 @ A @ Xs ) )
         => ( ( member @ A @ Y4 @ ( set2 @ A @ Xs ) )
           => ( ( P @ X3 @ Y4 )
             => ( Q @ X3 @ Y4 ) ) ) )
     => ( ( sorted_wrt @ A @ P @ Xs )
       => ( sorted_wrt @ A @ Q @ Xs ) ) ) ).

% sorted_wrt_mono_rel
thf(fact_7648_strict__sorted__equal,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A,Ys: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less @ A ) @ Xs )
         => ( ( sorted_wrt @ A @ ( ord_less @ A ) @ Ys )
           => ( ( ( set2 @ A @ Ys )
                = ( set2 @ A @ Xs ) )
             => ( Ys = Xs ) ) ) ) ) ).

% strict_sorted_equal
thf(fact_7649_sorted__wrt__nth__less,axiom,
    ! [A: $tType,P: A > A > $o,Xs: list @ A,I3: nat,J: nat] :
      ( ( sorted_wrt @ A @ P @ Xs )
     => ( ( ord_less @ nat @ I3 @ J )
       => ( ( ord_less @ nat @ J @ ( size_size @ ( list @ A ) @ Xs ) )
         => ( P @ ( nth @ A @ Xs @ I3 ) @ ( nth @ A @ Xs @ J ) ) ) ) ) ).

% sorted_wrt_nth_less
thf(fact_7650_sorted__wrt__iff__nth__less,axiom,
    ! [A: $tType] :
      ( ( sorted_wrt @ A )
      = ( ^ [P3: A > A > $o,Xs3: list @ A] :
          ! [I4: nat,J3: nat] :
            ( ( ord_less @ nat @ I4 @ J3 )
           => ( ( ord_less @ nat @ J3 @ ( size_size @ ( list @ A ) @ Xs3 ) )
             => ( P3 @ ( nth @ A @ Xs3 @ I4 ) @ ( nth @ A @ Xs3 @ J3 ) ) ) ) ) ) ).

% sorted_wrt_iff_nth_less
thf(fact_7651_map__upd__eqD1,axiom,
    ! [A: $tType,B: $tType,M: A > ( option @ B ),A2: A,X2: B,N2: A > ( option @ B ),Y2: B] :
      ( ( ( fun_upd @ A @ ( option @ B ) @ M @ A2 @ ( some @ B @ X2 ) )
        = ( fun_upd @ A @ ( option @ B ) @ N2 @ A2 @ ( some @ B @ Y2 ) ) )
     => ( X2 = Y2 ) ) ).

% map_upd_eqD1
thf(fact_7652_map__upd__triv,axiom,
    ! [A: $tType,B: $tType,T2: B > ( option @ A ),K: B,X2: A] :
      ( ( ( T2 @ K )
        = ( some @ A @ X2 ) )
     => ( ( fun_upd @ B @ ( option @ A ) @ T2 @ K @ ( some @ A @ X2 ) )
        = T2 ) ) ).

% map_upd_triv
thf(fact_7653_map__upd__Some__unfold,axiom,
    ! [B: $tType,A: $tType,M: B > ( option @ A ),A2: B,B2: A,X2: B,Y2: A] :
      ( ( ( fun_upd @ B @ ( option @ A ) @ M @ A2 @ ( some @ A @ B2 ) @ X2 )
        = ( some @ A @ Y2 ) )
      = ( ( ( X2 = A2 )
          & ( B2 = Y2 ) )
        | ( ( X2 != A2 )
          & ( ( M @ X2 )
            = ( some @ A @ Y2 ) ) ) ) ) ).

% map_upd_Some_unfold
thf(fact_7654_map__upd__nonempty,axiom,
    ! [B: $tType,A: $tType,T2: A > ( option @ B ),K: A,X2: B] :
      ( ( fun_upd @ A @ ( option @ B ) @ T2 @ K @ ( some @ B @ X2 ) )
     != ( ^ [X5: A] : ( none @ B ) ) ) ).

% map_upd_nonempty
thf(fact_7655_sorted__wrt__true,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( sorted_wrt @ A
      @ ^ [Uu3: A,Uv3: A] : $true
      @ Xs ) ).

% sorted_wrt_true
thf(fact_7656_sorted__list__of__set_Ostrict__sorted__key__list__of__set,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A] : ( sorted_wrt @ A @ ( ord_less @ A ) @ ( linord4507533701916653071of_set @ A @ A3 ) ) ) ).

% sorted_list_of_set.strict_sorted_key_list_of_set
thf(fact_7657_sorted__wrt_Osimps_I1_J,axiom,
    ! [A: $tType,P: A > A > $o] : ( sorted_wrt @ A @ P @ ( nil @ A ) ) ).

% sorted_wrt.simps(1)
thf(fact_7658_strict__sorted__simps_I1_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( sorted_wrt @ A @ ( ord_less @ A ) @ ( nil @ A ) ) ) ).

% strict_sorted_simps(1)
thf(fact_7659_sorted__replicate,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [N2: nat,X2: A] : ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( replicate @ A @ N2 @ X2 ) ) ) ).

% sorted_replicate
thf(fact_7660_sorted__remove1,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A,A2: A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs )
         => ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( remove1 @ A @ A2 @ Xs ) ) ) ) ).

% sorted_remove1
thf(fact_7661_sorted__insort,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X2: A,Xs: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A )
            @ ( linorder_insort_key @ A @ A
              @ ^ [X5: A] : X5
              @ X2
              @ Xs ) )
          = ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs ) ) ) ).

% sorted_insort
thf(fact_7662_strict__sorted__imp__sorted,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less @ A ) @ Xs )
         => ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs ) ) ) ).

% strict_sorted_imp_sorted
thf(fact_7663_sorted__list__of__set_Osorted__sorted__key__list__of__set,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A] : ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( linord4507533701916653071of_set @ A @ A3 ) ) ) ).

% sorted_list_of_set.sorted_sorted_key_list_of_set
thf(fact_7664_sorted0,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( nil @ A ) ) ) ).

% sorted0
thf(fact_7665_sorted__remdups__adj,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs )
         => ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( remdups_adj @ A @ Xs ) ) ) ) ).

% sorted_remdups_adj
thf(fact_7666_sorted2,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X2: A,Y2: A,Zs: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( cons @ A @ X2 @ ( cons @ A @ Y2 @ Zs ) ) )
          = ( ( ord_less_eq @ A @ X2 @ Y2 )
            & ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( cons @ A @ Y2 @ Zs ) ) ) ) ) ).

% sorted2
thf(fact_7667_sorted1,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X2: A] : ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( cons @ A @ X2 @ ( nil @ A ) ) ) ) ).

% sorted1
thf(fact_7668_sorted__wrt1,axiom,
    ! [A: $tType,P: A > A > $o,X2: A] : ( sorted_wrt @ A @ P @ ( cons @ A @ X2 @ ( nil @ A ) ) ) ).

% sorted_wrt1
thf(fact_7669_sorted__upt,axiom,
    ! [M: nat,N2: nat] : ( sorted_wrt @ nat @ ( ord_less_eq @ nat ) @ ( upt @ M @ N2 ) ) ).

% sorted_upt
thf(fact_7670_sorted__wrt__upt,axiom,
    ! [M: nat,N2: nat] : ( sorted_wrt @ nat @ ( ord_less @ nat ) @ ( upt @ M @ N2 ) ) ).

% sorted_wrt_upt
thf(fact_7671_sorted__iff__nth__mono__less,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs )
          = ( ! [I4: nat,J3: nat] :
                ( ( ord_less @ nat @ I4 @ J3 )
               => ( ( ord_less @ nat @ J3 @ ( size_size @ ( list @ A ) @ Xs ) )
                 => ( ord_less_eq @ A @ ( nth @ A @ Xs @ I4 ) @ ( nth @ A @ Xs @ J3 ) ) ) ) ) ) ) ).

% sorted_iff_nth_mono_less
thf(fact_7672_sorted01,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A] :
          ( ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ ( one_one @ nat ) )
         => ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs ) ) ) ).

% sorted01
thf(fact_7673_sorted__wrt_Oelims_I1_J,axiom,
    ! [A: $tType,X2: A > A > $o,Xa2: list @ A,Y2: $o] :
      ( ( ( sorted_wrt @ A @ X2 @ Xa2 )
        = Y2 )
     => ( ( ( Xa2
            = ( nil @ A ) )
         => ~ Y2 )
       => ~ ! [X3: A,Ys4: list @ A] :
              ( ( Xa2
                = ( cons @ A @ X3 @ Ys4 ) )
             => ( Y2
                = ( ~ ( ! [Y5: A] :
                          ( ( member @ A @ Y5 @ ( set2 @ A @ Ys4 ) )
                         => ( X2 @ X3 @ Y5 ) )
                      & ( sorted_wrt @ A @ X2 @ Ys4 ) ) ) ) ) ) ) ).

% sorted_wrt.elims(1)
thf(fact_7674_sorted__wrt_Oelims_I2_J,axiom,
    ! [A: $tType,X2: A > A > $o,Xa2: list @ A] :
      ( ( sorted_wrt @ A @ X2 @ Xa2 )
     => ( ( Xa2
         != ( nil @ A ) )
       => ~ ! [X3: A,Ys4: list @ A] :
              ( ( Xa2
                = ( cons @ A @ X3 @ Ys4 ) )
             => ~ ( ! [Xa: A] :
                      ( ( member @ A @ Xa @ ( set2 @ A @ Ys4 ) )
                     => ( X2 @ X3 @ Xa ) )
                  & ( sorted_wrt @ A @ X2 @ Ys4 ) ) ) ) ) ).

% sorted_wrt.elims(2)
thf(fact_7675_finite__sorted__distinct__unique,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A] :
          ( ( finite_finite @ A @ A3 )
         => ? [X3: list @ A] :
              ( ( ( set2 @ A @ X3 )
                = A3 )
              & ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ X3 )
              & ( distinct @ A @ X3 )
              & ! [Y: list @ A] :
                  ( ( ( ( set2 @ A @ Y )
                      = A3 )
                    & ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Y )
                    & ( distinct @ A @ Y ) )
                 => ( Y = X3 ) ) ) ) ) ).

% finite_sorted_distinct_unique
thf(fact_7676_sorted__list__of__set_Oidem__if__sorted__distinct,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs )
         => ( ( distinct @ A @ Xs )
           => ( ( linord4507533701916653071of_set @ A @ ( set2 @ A @ Xs ) )
              = Xs ) ) ) ) ).

% sorted_list_of_set.idem_if_sorted_distinct
thf(fact_7677_insort__remove1,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,Xs: list @ A] :
          ( ( member @ A @ A2 @ ( set2 @ A @ Xs ) )
         => ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs )
           => ( ( linorder_insort_key @ A @ A
                @ ^ [X5: A] : X5
                @ A2
                @ ( remove1 @ A @ A2 @ Xs ) )
              = Xs ) ) ) ) ).

% insort_remove1
thf(fact_7678_sorted__iff__nth__Suc,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs )
          = ( ! [I4: nat] :
                ( ( ord_less @ nat @ ( suc @ I4 ) @ ( size_size @ ( list @ A ) @ Xs ) )
               => ( ord_less_eq @ A @ ( nth @ A @ Xs @ I4 ) @ ( nth @ A @ Xs @ ( suc @ I4 ) ) ) ) ) ) ) ).

% sorted_iff_nth_Suc
thf(fact_7679_sorted__list__of__set_Ofinite__set__strict__sorted,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A] :
          ( ( finite_finite @ A @ A3 )
         => ~ ! [L4: list @ A] :
                ( ( sorted_wrt @ A @ ( ord_less @ A ) @ L4 )
               => ( ( ( set2 @ A @ L4 )
                    = A3 )
                 => ( ( size_size @ ( list @ A ) @ L4 )
                   != ( finite_card @ A @ A3 ) ) ) ) ) ) ).

% sorted_list_of_set.finite_set_strict_sorted
thf(fact_7680_sorted__nth__mono,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A,I3: nat,J: nat] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs )
         => ( ( ord_less_eq @ nat @ I3 @ J )
           => ( ( ord_less @ nat @ J @ ( size_size @ ( list @ A ) @ Xs ) )
             => ( ord_less_eq @ A @ ( nth @ A @ Xs @ I3 ) @ ( nth @ A @ Xs @ J ) ) ) ) ) ) ).

% sorted_nth_mono
thf(fact_7681_sorted__iff__nth__mono,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs )
          = ( ! [I4: nat,J3: nat] :
                ( ( ord_less_eq @ nat @ I4 @ J3 )
               => ( ( ord_less @ nat @ J3 @ ( size_size @ ( list @ A ) @ Xs ) )
                 => ( ord_less_eq @ A @ ( nth @ A @ Xs @ I4 ) @ ( nth @ A @ Xs @ J3 ) ) ) ) ) ) ) ).

% sorted_iff_nth_mono
thf(fact_7682_finite__range__updI,axiom,
    ! [A: $tType,B: $tType,F2: B > ( option @ A ),A2: B,B2: A] :
      ( ( finite_finite @ ( option @ A ) @ ( image @ B @ ( option @ A ) @ F2 @ ( top_top @ ( set @ B ) ) ) )
     => ( finite_finite @ ( option @ A ) @ ( image @ B @ ( option @ A ) @ ( fun_upd @ B @ ( option @ A ) @ F2 @ A2 @ ( some @ A @ B2 ) ) @ ( top_top @ ( set @ B ) ) ) ) ) ).

% finite_range_updI
thf(fact_7683_sorted__wrt__less__idx,axiom,
    ! [Ns: list @ nat,I3: nat] :
      ( ( sorted_wrt @ nat @ ( ord_less @ nat ) @ Ns )
     => ( ( ord_less @ nat @ I3 @ ( size_size @ ( list @ nat ) @ Ns ) )
       => ( ord_less_eq @ nat @ I3 @ ( nth @ nat @ Ns @ I3 ) ) ) ) ).

% sorted_wrt_less_idx
thf(fact_7684_restrict__complement__singleton__eq,axiom,
    ! [A: $tType,B: $tType,F2: A > ( option @ B ),X2: A] :
      ( ( restrict_map @ A @ B @ F2 @ ( uminus_uminus @ ( set @ A ) @ ( insert @ A @ X2 @ ( bot_bot @ ( set @ A ) ) ) ) )
      = ( fun_upd @ A @ ( option @ B ) @ F2 @ X2 @ ( none @ B ) ) ) ).

% restrict_complement_singleton_eq
thf(fact_7685_map__of_Osimps_I2_J,axiom,
    ! [B: $tType,A: $tType,P4: product_prod @ A @ B,Ps: list @ ( product_prod @ A @ B )] :
      ( ( map_of @ A @ B @ ( cons @ ( product_prod @ A @ B ) @ P4 @ Ps ) )
      = ( fun_upd @ A @ ( option @ B ) @ ( map_of @ A @ B @ Ps ) @ ( product_fst @ A @ B @ P4 ) @ ( some @ B @ ( product_snd @ A @ B @ P4 ) ) ) ) ).

% map_of.simps(2)
thf(fact_7686_sorted__enumerate,axiom,
    ! [A: $tType,N2: nat,Xs: list @ A] : ( sorted_wrt @ nat @ ( ord_less_eq @ nat ) @ ( map @ ( product_prod @ nat @ A ) @ nat @ ( product_fst @ nat @ A ) @ ( enumerate @ A @ N2 @ Xs ) ) ) ).

% sorted_enumerate
thf(fact_7687_sorted__list__of__set_Osorted__key__list__of__set__unique,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A3: set @ A,L: list @ A] :
          ( ( finite_finite @ A @ A3 )
         => ( ( ( sorted_wrt @ A @ ( ord_less @ A ) @ L )
              & ( ( set2 @ A @ L )
                = A3 )
              & ( ( size_size @ ( list @ A ) @ L )
                = ( finite_card @ A @ A3 ) ) )
            = ( ( linord4507533701916653071of_set @ A @ A3 )
              = L ) ) ) ) ).

% sorted_list_of_set.sorted_key_list_of_set_unique
thf(fact_7688_sorted__insort__is__snoc,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A,A2: A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs )
         => ( ! [X3: A] :
                ( ( member @ A @ X3 @ ( set2 @ A @ Xs ) )
               => ( ord_less_eq @ A @ X3 @ A2 ) )
           => ( ( linorder_insort_key @ A @ A
                @ ^ [X5: A] : X5
                @ A2
                @ Xs )
              = ( append @ A @ Xs @ ( cons @ A @ A2 @ ( nil @ A ) ) ) ) ) ) ) ).

% sorted_insort_is_snoc
thf(fact_7689_sorted__wrt_Opelims_I1_J,axiom,
    ! [A: $tType,X2: A > A > $o,Xa2: list @ A,Y2: $o] :
      ( ( ( sorted_wrt @ A @ X2 @ Xa2 )
        = Y2 )
     => ( ( accp @ ( product_prod @ ( A > A > $o ) @ ( list @ A ) ) @ ( sorted_wrt_rel @ A ) @ ( product_Pair @ ( A > A > $o ) @ ( list @ A ) @ X2 @ Xa2 ) )
       => ( ( ( Xa2
              = ( nil @ A ) )
           => ( Y2
             => ~ ( accp @ ( product_prod @ ( A > A > $o ) @ ( list @ A ) ) @ ( sorted_wrt_rel @ A ) @ ( product_Pair @ ( A > A > $o ) @ ( list @ A ) @ X2 @ ( nil @ A ) ) ) ) )
         => ~ ! [X3: A,Ys4: list @ A] :
                ( ( Xa2
                  = ( cons @ A @ X3 @ Ys4 ) )
               => ( ( Y2
                    = ( ! [Y5: A] :
                          ( ( member @ A @ Y5 @ ( set2 @ A @ Ys4 ) )
                         => ( X2 @ X3 @ Y5 ) )
                      & ( sorted_wrt @ A @ X2 @ Ys4 ) ) )
                 => ~ ( accp @ ( product_prod @ ( A > A > $o ) @ ( list @ A ) ) @ ( sorted_wrt_rel @ A ) @ ( product_Pair @ ( A > A > $o ) @ ( list @ A ) @ X2 @ ( cons @ A @ X3 @ Ys4 ) ) ) ) ) ) ) ) ).

% sorted_wrt.pelims(1)
thf(fact_7690_sorted__wrt_Opelims_I2_J,axiom,
    ! [A: $tType,X2: A > A > $o,Xa2: list @ A] :
      ( ( sorted_wrt @ A @ X2 @ Xa2 )
     => ( ( accp @ ( product_prod @ ( A > A > $o ) @ ( list @ A ) ) @ ( sorted_wrt_rel @ A ) @ ( product_Pair @ ( A > A > $o ) @ ( list @ A ) @ X2 @ Xa2 ) )
       => ( ( ( Xa2
              = ( nil @ A ) )
           => ~ ( accp @ ( product_prod @ ( A > A > $o ) @ ( list @ A ) ) @ ( sorted_wrt_rel @ A ) @ ( product_Pair @ ( A > A > $o ) @ ( list @ A ) @ X2 @ ( nil @ A ) ) ) )
         => ~ ! [X3: A,Ys4: list @ A] :
                ( ( Xa2
                  = ( cons @ A @ X3 @ Ys4 ) )
               => ( ( accp @ ( product_prod @ ( A > A > $o ) @ ( list @ A ) ) @ ( sorted_wrt_rel @ A ) @ ( product_Pair @ ( A > A > $o ) @ ( list @ A ) @ X2 @ ( cons @ A @ X3 @ Ys4 ) ) )
                 => ~ ( ! [Xa: A] :
                          ( ( member @ A @ Xa @ ( set2 @ A @ Ys4 ) )
                         => ( X2 @ X3 @ Xa ) )
                      & ( sorted_wrt @ A @ X2 @ Ys4 ) ) ) ) ) ) ) ).

% sorted_wrt.pelims(2)
thf(fact_7691_sorted__wrt__upto,axiom,
    ! [I3: int,J: int] : ( sorted_wrt @ int @ ( ord_less @ int ) @ ( upto @ I3 @ J ) ) ).

% sorted_wrt_upto
thf(fact_7692_sorted__upto,axiom,
    ! [M: int,N2: int] : ( sorted_wrt @ int @ ( ord_less_eq @ int ) @ ( upto @ M @ N2 ) ) ).

% sorted_upto
thf(fact_7693_sorted__wrt_Opelims_I3_J,axiom,
    ! [A: $tType,X2: A > A > $o,Xa2: list @ A] :
      ( ~ ( sorted_wrt @ A @ X2 @ Xa2 )
     => ( ( accp @ ( product_prod @ ( A > A > $o ) @ ( list @ A ) ) @ ( sorted_wrt_rel @ A ) @ ( product_Pair @ ( A > A > $o ) @ ( list @ A ) @ X2 @ Xa2 ) )
       => ~ ! [X3: A,Ys4: list @ A] :
              ( ( Xa2
                = ( cons @ A @ X3 @ Ys4 ) )
             => ( ( accp @ ( product_prod @ ( A > A > $o ) @ ( list @ A ) ) @ ( sorted_wrt_rel @ A ) @ ( product_Pair @ ( A > A > $o ) @ ( list @ A ) @ X2 @ ( cons @ A @ X3 @ Ys4 ) ) )
               => ( ! [Xa3: A] :
                      ( ( member @ A @ Xa3 @ ( set2 @ A @ Ys4 ) )
                     => ( X2 @ X3 @ Xa3 ) )
                  & ( sorted_wrt @ A @ X2 @ Ys4 ) ) ) ) ) ) ).

% sorted_wrt.pelims(3)
thf(fact_7694_length__transpose__sorted,axiom,
    ! [A: $tType,Xs: list @ ( list @ A )] :
      ( ( sorted_wrt @ nat @ ( ord_less_eq @ nat ) @ ( rev @ nat @ ( map @ ( list @ A ) @ nat @ ( size_size @ ( list @ A ) ) @ Xs ) ) )
     => ( ( ( Xs
            = ( nil @ ( list @ A ) ) )
         => ( ( size_size @ ( list @ ( list @ A ) ) @ ( transpose @ A @ Xs ) )
            = ( zero_zero @ nat ) ) )
        & ( ( Xs
           != ( nil @ ( list @ A ) ) )
         => ( ( size_size @ ( list @ ( list @ A ) ) @ ( transpose @ A @ Xs ) )
            = ( size_size @ ( list @ A ) @ ( nth @ ( list @ A ) @ Xs @ ( zero_zero @ nat ) ) ) ) ) ) ) ).

% length_transpose_sorted
thf(fact_7695_folding__insort__key_Ofinite__set__strict__sorted,axiom,
    ! [A: $tType,B: $tType,Less_eq: A > A > $o,Less: A > A > $o,S3: set @ B,F2: B > A,A3: set @ B] :
      ( ( folding_insort_key @ A @ B @ Less_eq @ Less @ S3 @ F2 )
     => ( ( ord_less_eq @ ( set @ B ) @ A3 @ S3 )
       => ( ( finite_finite @ B @ A3 )
         => ~ ! [L4: list @ B] :
                ( ( sorted_wrt @ A @ Less @ ( map @ B @ A @ F2 @ L4 ) )
               => ( ( ( set2 @ B @ L4 )
                    = A3 )
                 => ( ( size_size @ ( list @ B ) @ L4 )
                   != ( finite_card @ B @ A3 ) ) ) ) ) ) ) ).

% folding_insort_key.finite_set_strict_sorted
thf(fact_7696_rev__is__rev__conv,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A] :
      ( ( ( rev @ A @ Xs )
        = ( rev @ A @ Ys ) )
      = ( Xs = Ys ) ) ).

% rev_is_rev_conv
thf(fact_7697_rev__rev__ident,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( rev @ A @ ( rev @ A @ Xs ) )
      = Xs ) ).

% rev_rev_ident
thf(fact_7698_rev__is__Nil__conv,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( ( rev @ A @ Xs )
        = ( nil @ A ) )
      = ( Xs
        = ( nil @ A ) ) ) ).

% rev_is_Nil_conv
thf(fact_7699_Nil__is__rev__conv,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( ( nil @ A )
        = ( rev @ A @ Xs ) )
      = ( Xs
        = ( nil @ A ) ) ) ).

% Nil_is_rev_conv
thf(fact_7700_set__rev,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( set2 @ A @ ( rev @ A @ Xs ) )
      = ( set2 @ A @ Xs ) ) ).

% set_rev
thf(fact_7701_length__rev,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( size_size @ ( list @ A ) @ ( rev @ A @ Xs ) )
      = ( size_size @ ( list @ A ) @ Xs ) ) ).

% length_rev
thf(fact_7702_rev__append,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A] :
      ( ( rev @ A @ ( append @ A @ Xs @ Ys ) )
      = ( append @ A @ ( rev @ A @ Ys ) @ ( rev @ A @ Xs ) ) ) ).

% rev_append
thf(fact_7703_distinct__rev,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( distinct @ A @ ( rev @ A @ Xs ) )
      = ( distinct @ A @ Xs ) ) ).

% distinct_rev
thf(fact_7704_rev__replicate,axiom,
    ! [A: $tType,N2: nat,X2: A] :
      ( ( rev @ A @ ( replicate @ A @ N2 @ X2 ) )
      = ( replicate @ A @ N2 @ X2 ) ) ).

% rev_replicate
thf(fact_7705_remdups__adj__rev,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( remdups_adj @ A @ ( rev @ A @ Xs ) )
      = ( rev @ A @ ( remdups_adj @ A @ Xs ) ) ) ).

% remdups_adj_rev
thf(fact_7706_rev__singleton__conv,axiom,
    ! [A: $tType,Xs: list @ A,X2: A] :
      ( ( ( rev @ A @ Xs )
        = ( cons @ A @ X2 @ ( nil @ A ) ) )
      = ( Xs
        = ( cons @ A @ X2 @ ( nil @ A ) ) ) ) ).

% rev_singleton_conv
thf(fact_7707_singleton__rev__conv,axiom,
    ! [A: $tType,X2: A,Xs: list @ A] :
      ( ( ( cons @ A @ X2 @ ( nil @ A ) )
        = ( rev @ A @ Xs ) )
      = ( ( cons @ A @ X2 @ ( nil @ A ) )
        = Xs ) ) ).

% singleton_rev_conv
thf(fact_7708_rev__eq__Cons__iff,axiom,
    ! [A: $tType,Xs: list @ A,Y2: A,Ys: list @ A] :
      ( ( ( rev @ A @ Xs )
        = ( cons @ A @ Y2 @ Ys ) )
      = ( Xs
        = ( append @ A @ ( rev @ A @ Ys ) @ ( cons @ A @ Y2 @ ( nil @ A ) ) ) ) ) ).

% rev_eq_Cons_iff
thf(fact_7709_sorted__wrt__rev,axiom,
    ! [A: $tType,P: A > A > $o,Xs: list @ A] :
      ( ( sorted_wrt @ A @ P @ ( rev @ A @ Xs ) )
      = ( sorted_wrt @ A
        @ ^ [X5: A,Y5: A] : ( P @ Y5 @ X5 )
        @ Xs ) ) ).

% sorted_wrt_rev
thf(fact_7710_rev__swap,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A] :
      ( ( ( rev @ A @ Xs )
        = Ys )
      = ( Xs
        = ( rev @ A @ Ys ) ) ) ).

% rev_swap
thf(fact_7711_rev_Osimps_I1_J,axiom,
    ! [A: $tType] :
      ( ( rev @ A @ ( nil @ A ) )
      = ( nil @ A ) ) ).

% rev.simps(1)
thf(fact_7712_rev_Osimps_I2_J,axiom,
    ! [A: $tType,X2: A,Xs: list @ A] :
      ( ( rev @ A @ ( cons @ A @ X2 @ Xs ) )
      = ( append @ A @ ( rev @ A @ Xs ) @ ( cons @ A @ X2 @ ( nil @ A ) ) ) ) ).

% rev.simps(2)
thf(fact_7713_folding__insort__key_Odistinct__if__distinct__map,axiom,
    ! [A: $tType,B: $tType,Less_eq: A > A > $o,Less: A > A > $o,S3: set @ B,F2: B > A,Xs: list @ B] :
      ( ( folding_insort_key @ A @ B @ Less_eq @ Less @ S3 @ F2 )
     => ( ( distinct @ A @ ( map @ B @ A @ F2 @ Xs ) )
       => ( distinct @ B @ Xs ) ) ) ).

% folding_insort_key.distinct_if_distinct_map
thf(fact_7714_rev__map,axiom,
    ! [A: $tType,B: $tType,F2: B > A,Xs: list @ B] :
      ( ( rev @ A @ ( map @ B @ A @ F2 @ Xs ) )
      = ( map @ B @ A @ F2 @ ( rev @ B @ Xs ) ) ) ).

% rev_map
thf(fact_7715_rev__concat,axiom,
    ! [A: $tType,Xs: list @ ( list @ A )] :
      ( ( rev @ A @ ( concat @ A @ Xs ) )
      = ( concat @ A @ ( map @ ( list @ A ) @ ( list @ A ) @ ( rev @ A ) @ ( rev @ ( list @ A ) @ Xs ) ) ) ) ).

% rev_concat
thf(fact_7716_sorted__list__of__set_Ofolding__insort__key__axioms,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( folding_insort_key @ A @ A @ ( ord_less_eq @ A ) @ ( ord_less @ A ) @ ( top_top @ ( set @ A ) )
        @ ^ [X5: A] : X5 ) ) ).

% sorted_list_of_set.folding_insort_key_axioms
thf(fact_7717_rev__nth,axiom,
    ! [A: $tType,N2: nat,Xs: list @ A] :
      ( ( ord_less @ nat @ N2 @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( ( nth @ A @ ( rev @ A @ Xs ) @ N2 )
        = ( nth @ A @ Xs @ ( minus_minus @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ ( suc @ N2 ) ) ) ) ) ).

% rev_nth
thf(fact_7718_rev__update,axiom,
    ! [A: $tType,K: nat,Xs: list @ A,Y2: A] :
      ( ( ord_less @ nat @ K @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( ( rev @ A @ ( list_update @ A @ Xs @ K @ Y2 ) )
        = ( list_update @ A @ ( rev @ A @ Xs ) @ ( minus_minus @ nat @ ( minus_minus @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ K ) @ ( one_one @ nat ) ) @ Y2 ) ) ) ).

% rev_update
thf(fact_7719_sorted__transpose,axiom,
    ! [A: $tType,Xs: list @ ( list @ A )] : ( sorted_wrt @ nat @ ( ord_less_eq @ nat ) @ ( rev @ nat @ ( map @ ( list @ A ) @ nat @ ( size_size @ ( list @ A ) ) @ ( transpose @ A @ Xs ) ) ) ) ).

% sorted_transpose
thf(fact_7720_sorted__rev__iff__nth__Suc,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( rev @ A @ Xs ) )
          = ( ! [I4: nat] :
                ( ( ord_less @ nat @ ( suc @ I4 ) @ ( size_size @ ( list @ A ) @ Xs ) )
               => ( ord_less_eq @ A @ ( nth @ A @ Xs @ ( suc @ I4 ) ) @ ( nth @ A @ Xs @ I4 ) ) ) ) ) ) ).

% sorted_rev_iff_nth_Suc
thf(fact_7721_sorted__rev__iff__nth__mono,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( rev @ A @ Xs ) )
          = ( ! [I4: nat,J3: nat] :
                ( ( ord_less_eq @ nat @ I4 @ J3 )
               => ( ( ord_less @ nat @ J3 @ ( size_size @ ( list @ A ) @ Xs ) )
                 => ( ord_less_eq @ A @ ( nth @ A @ Xs @ J3 ) @ ( nth @ A @ Xs @ I4 ) ) ) ) ) ) ) ).

% sorted_rev_iff_nth_mono
thf(fact_7722_sorted__rev__nth__mono,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A,I3: nat,J: nat] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( rev @ A @ Xs ) )
         => ( ( ord_less_eq @ nat @ I3 @ J )
           => ( ( ord_less @ nat @ J @ ( size_size @ ( list @ A ) @ Xs ) )
             => ( ord_less_eq @ A @ ( nth @ A @ Xs @ J ) @ ( nth @ A @ Xs @ I3 ) ) ) ) ) ) ).

% sorted_rev_nth_mono
thf(fact_7723_nth__nth__transpose__sorted,axiom,
    ! [A: $tType,Xs: list @ ( list @ A ),I3: nat,J: nat] :
      ( ( sorted_wrt @ nat @ ( ord_less_eq @ nat ) @ ( rev @ nat @ ( map @ ( list @ A ) @ nat @ ( size_size @ ( list @ A ) ) @ Xs ) ) )
     => ( ( ord_less @ nat @ I3 @ ( size_size @ ( list @ ( list @ A ) ) @ ( transpose @ A @ Xs ) ) )
       => ( ( ord_less @ nat @ J
            @ ( size_size @ ( list @ ( list @ A ) )
              @ ( filter2 @ ( list @ A )
                @ ^ [Ys3: list @ A] : ( ord_less @ nat @ I3 @ ( size_size @ ( list @ A ) @ Ys3 ) )
                @ Xs ) ) )
         => ( ( nth @ A @ ( nth @ ( list @ A ) @ ( transpose @ A @ Xs ) @ I3 ) @ J )
            = ( nth @ A @ ( nth @ ( list @ A ) @ Xs @ J ) @ I3 ) ) ) ) ) ).

% nth_nth_transpose_sorted
thf(fact_7724_transpose__column,axiom,
    ! [A: $tType,Xs: list @ ( list @ A ),I3: nat] :
      ( ( sorted_wrt @ nat @ ( ord_less_eq @ nat ) @ ( rev @ nat @ ( map @ ( list @ A ) @ nat @ ( size_size @ ( list @ A ) ) @ Xs ) ) )
     => ( ( ord_less @ nat @ I3 @ ( size_size @ ( list @ ( list @ A ) ) @ Xs ) )
       => ( ( map @ ( list @ A ) @ A
            @ ^ [Ys3: list @ A] : ( nth @ A @ Ys3 @ I3 )
            @ ( filter2 @ ( list @ A )
              @ ^ [Ys3: list @ A] : ( ord_less @ nat @ I3 @ ( size_size @ ( list @ A ) @ Ys3 ) )
              @ ( transpose @ A @ Xs ) ) )
          = ( nth @ ( list @ A ) @ Xs @ I3 ) ) ) ) ).

% transpose_column
thf(fact_7725_filter__filter,axiom,
    ! [A: $tType,P: A > $o,Q: A > $o,Xs: list @ A] :
      ( ( filter2 @ A @ P @ ( filter2 @ A @ Q @ Xs ) )
      = ( filter2 @ A
        @ ^ [X5: A] :
            ( ( Q @ X5 )
            & ( P @ X5 ) )
        @ Xs ) ) ).

% filter_filter
thf(fact_7726_filter__True,axiom,
    ! [A: $tType,Xs: list @ A,P: A > $o] :
      ( ! [X3: A] :
          ( ( member @ A @ X3 @ ( set2 @ A @ Xs ) )
         => ( P @ X3 ) )
     => ( ( filter2 @ A @ P @ Xs )
        = Xs ) ) ).

% filter_True
thf(fact_7727_filter__append,axiom,
    ! [A: $tType,P: A > $o,Xs: list @ A,Ys: list @ A] :
      ( ( filter2 @ A @ P @ ( append @ A @ Xs @ Ys ) )
      = ( append @ A @ ( filter2 @ A @ P @ Xs ) @ ( filter2 @ A @ P @ Ys ) ) ) ).

% filter_append
thf(fact_7728_remove1__filter__not,axiom,
    ! [A: $tType,P: A > $o,X2: A,Xs: list @ A] :
      ( ~ ( P @ X2 )
     => ( ( remove1 @ A @ X2 @ ( filter2 @ A @ P @ Xs ) )
        = ( filter2 @ A @ P @ Xs ) ) ) ).

% remove1_filter_not
thf(fact_7729_removeAll__filter__not,axiom,
    ! [A: $tType,P: A > $o,X2: A,Xs: list @ A] :
      ( ~ ( P @ X2 )
     => ( ( removeAll @ A @ X2 @ ( filter2 @ A @ P @ Xs ) )
        = ( filter2 @ A @ P @ Xs ) ) ) ).

% removeAll_filter_not
thf(fact_7730_set__filter,axiom,
    ! [A: $tType,P: A > $o,Xs: list @ A] :
      ( ( set2 @ A @ ( filter2 @ A @ P @ Xs ) )
      = ( collect @ A
        @ ^ [X5: A] :
            ( ( member @ A @ X5 @ ( set2 @ A @ Xs ) )
            & ( P @ X5 ) ) ) ) ).

% set_filter
thf(fact_7731_filter__False,axiom,
    ! [A: $tType,Xs: list @ A,P: A > $o] :
      ( ! [X3: A] :
          ( ( member @ A @ X3 @ ( set2 @ A @ Xs ) )
         => ~ ( P @ X3 ) )
     => ( ( filter2 @ A @ P @ Xs )
        = ( nil @ A ) ) ) ).

% filter_False
thf(fact_7732_length__concat__rev,axiom,
    ! [A: $tType,Xs: list @ ( list @ A )] :
      ( ( size_size @ ( list @ A ) @ ( concat @ A @ ( rev @ ( list @ A ) @ Xs ) ) )
      = ( size_size @ ( list @ A ) @ ( concat @ A @ Xs ) ) ) ).

% length_concat_rev
thf(fact_7733_length__filter__map,axiom,
    ! [A: $tType,B: $tType,P: A > $o,F2: B > A,Xs: list @ B] :
      ( ( size_size @ ( list @ A ) @ ( filter2 @ A @ P @ ( map @ B @ A @ F2 @ Xs ) ) )
      = ( size_size @ ( list @ B ) @ ( filter2 @ B @ ( comp @ A @ $o @ B @ P @ F2 ) @ Xs ) ) ) ).

% length_filter_map
thf(fact_7734_sorted__filter,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F2: B > A,Xs: list @ B,P: B > $o] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( map @ B @ A @ F2 @ Xs ) )
         => ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( map @ B @ A @ F2 @ ( filter2 @ B @ P @ Xs ) ) ) ) ) ).

% sorted_filter
thf(fact_7735_sorted__map__same,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F2: B > A,G: ( list @ B ) > A,Xs: list @ B] :
          ( sorted_wrt @ A @ ( ord_less_eq @ A )
          @ ( map @ B @ A @ F2
            @ ( filter2 @ B
              @ ^ [X5: B] :
                  ( ( F2 @ X5 )
                  = ( G @ Xs ) )
              @ Xs ) ) ) ) ).

% sorted_map_same
thf(fact_7736_sorted__wrt__filter,axiom,
    ! [A: $tType,F2: A > A > $o,Xs: list @ A,P: A > $o] :
      ( ( sorted_wrt @ A @ F2 @ Xs )
     => ( sorted_wrt @ A @ F2 @ ( filter2 @ A @ P @ Xs ) ) ) ).

% sorted_wrt_filter
thf(fact_7737_sorted__same,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [G: ( list @ A ) > A,Xs: list @ A] :
          ( sorted_wrt @ A @ ( ord_less_eq @ A )
          @ ( filter2 @ A
            @ ^ [X5: A] :
                ( X5
                = ( G @ Xs ) )
            @ Xs ) ) ) ).

% sorted_same
thf(fact_7738_rev__filter,axiom,
    ! [A: $tType,P: A > $o,Xs: list @ A] :
      ( ( rev @ A @ ( filter2 @ A @ P @ Xs ) )
      = ( filter2 @ A @ P @ ( rev @ A @ Xs ) ) ) ).

% rev_filter
thf(fact_7739_filter__map,axiom,
    ! [A: $tType,B: $tType,P: A > $o,F2: B > A,Xs: list @ B] :
      ( ( filter2 @ A @ P @ ( map @ B @ A @ F2 @ Xs ) )
      = ( map @ B @ A @ F2 @ ( filter2 @ B @ ( comp @ A @ $o @ B @ P @ F2 ) @ Xs ) ) ) ).

% filter_map
thf(fact_7740_sum__list__map__filter_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( monoid_add @ A )
     => ! [F2: B > A,P: B > $o,Xs: list @ B] :
          ( ( groups8242544230860333062m_list @ A @ ( map @ B @ A @ F2 @ ( filter2 @ B @ P @ Xs ) ) )
          = ( groups8242544230860333062m_list @ A
            @ ( map @ B @ A
              @ ^ [X5: B] : ( if @ A @ ( P @ X5 ) @ ( F2 @ X5 ) @ ( zero_zero @ A ) )
              @ Xs ) ) ) ) ).

% sum_list_map_filter'
thf(fact_7741_filter__concat,axiom,
    ! [A: $tType,P4: A > $o,Xs: list @ ( list @ A )] :
      ( ( filter2 @ A @ P4 @ ( concat @ A @ Xs ) )
      = ( concat @ A @ ( map @ ( list @ A ) @ ( list @ A ) @ ( filter2 @ A @ P4 ) @ Xs ) ) ) ).

% filter_concat
thf(fact_7742_distinct__map__filter,axiom,
    ! [A: $tType,B: $tType,F2: B > A,Xs: list @ B,P: B > $o] :
      ( ( distinct @ A @ ( map @ B @ A @ F2 @ Xs ) )
     => ( distinct @ A @ ( map @ B @ A @ F2 @ ( filter2 @ B @ P @ Xs ) ) ) ) ).

% distinct_map_filter
thf(fact_7743_sum__list__filter__le__nat,axiom,
    ! [A: $tType,F2: A > nat,P: A > $o,Xs: list @ A] : ( ord_less_eq @ nat @ ( groups8242544230860333062m_list @ nat @ ( map @ A @ nat @ F2 @ ( filter2 @ A @ P @ Xs ) ) ) @ ( groups8242544230860333062m_list @ nat @ ( map @ A @ nat @ F2 @ Xs ) ) ) ).

% sum_list_filter_le_nat
thf(fact_7744_filter_Osimps_I2_J,axiom,
    ! [A: $tType,P: A > $o,X2: A,Xs: list @ A] :
      ( ( ( P @ X2 )
       => ( ( filter2 @ A @ P @ ( cons @ A @ X2 @ Xs ) )
          = ( cons @ A @ X2 @ ( filter2 @ A @ P @ Xs ) ) ) )
      & ( ~ ( P @ X2 )
       => ( ( filter2 @ A @ P @ ( cons @ A @ X2 @ Xs ) )
          = ( filter2 @ A @ P @ Xs ) ) ) ) ).

% filter.simps(2)
thf(fact_7745_filter__shuffles,axiom,
    ! [A: $tType,P: A > $o,Xs: list @ A,Ys: list @ A] :
      ( ( image @ ( list @ A ) @ ( list @ A ) @ ( filter2 @ A @ P ) @ ( shuffles @ A @ Xs @ Ys ) )
      = ( shuffles @ A @ ( filter2 @ A @ P @ Xs ) @ ( filter2 @ A @ P @ Ys ) ) ) ).

% filter_shuffles
thf(fact_7746_filter__replicate,axiom,
    ! [A: $tType,P: A > $o,X2: A,N2: nat] :
      ( ( ( P @ X2 )
       => ( ( filter2 @ A @ P @ ( replicate @ A @ N2 @ X2 ) )
          = ( replicate @ A @ N2 @ X2 ) ) )
      & ( ~ ( P @ X2 )
       => ( ( filter2 @ A @ P @ ( replicate @ A @ N2 @ X2 ) )
          = ( nil @ A ) ) ) ) ).

% filter_replicate
thf(fact_7747_filter_Osimps_I1_J,axiom,
    ! [A: $tType,P: A > $o] :
      ( ( filter2 @ A @ P @ ( nil @ A ) )
      = ( nil @ A ) ) ).

% filter.simps(1)
thf(fact_7748_filter__insort__triv,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [P: B > $o,X2: B,F2: B > A,Xs: list @ B] :
          ( ~ ( P @ X2 )
         => ( ( filter2 @ B @ P @ ( linorder_insort_key @ B @ A @ F2 @ X2 @ Xs ) )
            = ( filter2 @ B @ P @ Xs ) ) ) ) ).

% filter_insort_triv
thf(fact_7749_removeAll__filter__not__eq,axiom,
    ! [A: $tType] :
      ( ( removeAll @ A )
      = ( ^ [X5: A] :
            ( filter2 @ A
            @ ^ [Y5: A] : ( X5 != Y5 ) ) ) ) ).

% removeAll_filter_not_eq
thf(fact_7750_filter__remove1,axiom,
    ! [A: $tType,Q: A > $o,X2: A,Xs: list @ A] :
      ( ( filter2 @ A @ Q @ ( remove1 @ A @ X2 @ Xs ) )
      = ( remove1 @ A @ X2 @ ( filter2 @ A @ Q @ Xs ) ) ) ).

% filter_remove1
thf(fact_7751_partition__in__shuffles,axiom,
    ! [A: $tType,Xs: list @ A,P: A > $o] :
      ( member @ ( list @ A ) @ Xs
      @ ( shuffles @ A @ ( filter2 @ A @ P @ Xs )
        @ ( filter2 @ A
          @ ^ [X5: A] :
              ~ ( P @ X5 )
          @ Xs ) ) ) ).

% partition_in_shuffles
thf(fact_7752_sum__length__filter__compl,axiom,
    ! [A: $tType,P: A > $o,Xs: list @ A] :
      ( ( plus_plus @ nat @ ( size_size @ ( list @ A ) @ ( filter2 @ A @ P @ Xs ) )
        @ ( size_size @ ( list @ A )
          @ ( filter2 @ A
            @ ^ [X5: A] :
                ~ ( P @ X5 )
            @ Xs ) ) )
      = ( size_size @ ( list @ A ) @ Xs ) ) ).

% sum_length_filter_compl
thf(fact_7753_replicate__length__filter,axiom,
    ! [A: $tType,X2: A,Xs: list @ A] :
      ( ( replicate @ A
        @ ( size_size @ ( list @ A )
          @ ( filter2 @ A
            @ ( ^ [Y3: A,Z2: A] : ( Y3 = Z2 )
              @ X2 )
            @ Xs ) )
        @ X2 )
      = ( filter2 @ A
        @ ( ^ [Y3: A,Z2: A] : ( Y3 = Z2 )
          @ X2 )
        @ Xs ) ) ).

% replicate_length_filter
thf(fact_7754_remdups__filter,axiom,
    ! [A: $tType,P: A > $o,Xs: list @ A] :
      ( ( remdups @ A @ ( filter2 @ A @ P @ Xs ) )
      = ( filter2 @ A @ P @ ( remdups @ A @ Xs ) ) ) ).

% remdups_filter
thf(fact_7755_length__filter__less,axiom,
    ! [A: $tType,X2: A,Xs: list @ A,P: A > $o] :
      ( ( member @ A @ X2 @ ( set2 @ A @ Xs ) )
     => ( ~ ( P @ X2 )
       => ( ord_less @ nat @ ( size_size @ ( list @ A ) @ ( filter2 @ A @ P @ Xs ) ) @ ( size_size @ ( list @ A ) @ Xs ) ) ) ) ).

% length_filter_less
thf(fact_7756_filter__id__conv,axiom,
    ! [A: $tType,P: A > $o,Xs: list @ A] :
      ( ( ( filter2 @ A @ P @ Xs )
        = Xs )
      = ( ! [X5: A] :
            ( ( member @ A @ X5 @ ( set2 @ A @ Xs ) )
           => ( P @ X5 ) ) ) ) ).

% filter_id_conv
thf(fact_7757_filter__cong,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A,P: A > $o,Q: A > $o] :
      ( ( Xs = Ys )
     => ( ! [X3: A] :
            ( ( member @ A @ X3 @ ( set2 @ A @ Ys ) )
           => ( ( P @ X3 )
              = ( Q @ X3 ) ) )
       => ( ( filter2 @ A @ P @ Xs )
          = ( filter2 @ A @ Q @ Ys ) ) ) ) ).

% filter_cong
thf(fact_7758_inter__set__filter,axiom,
    ! [A: $tType,A3: set @ A,Xs: list @ A] :
      ( ( inf_inf @ ( set @ A ) @ A3 @ ( set2 @ A @ Xs ) )
      = ( set2 @ A
        @ ( filter2 @ A
          @ ^ [X5: A] : ( member @ A @ X5 @ A3 )
          @ Xs ) ) ) ).

% inter_set_filter
thf(fact_7759_empty__filter__conv,axiom,
    ! [A: $tType,P: A > $o,Xs: list @ A] :
      ( ( ( nil @ A )
        = ( filter2 @ A @ P @ Xs ) )
      = ( ! [X5: A] :
            ( ( member @ A @ X5 @ ( set2 @ A @ Xs ) )
           => ~ ( P @ X5 ) ) ) ) ).

% empty_filter_conv
thf(fact_7760_filter__empty__conv,axiom,
    ! [A: $tType,P: A > $o,Xs: list @ A] :
      ( ( ( filter2 @ A @ P @ Xs )
        = ( nil @ A ) )
      = ( ! [X5: A] :
            ( ( member @ A @ X5 @ ( set2 @ A @ Xs ) )
           => ~ ( P @ X5 ) ) ) ) ).

% filter_empty_conv
thf(fact_7761_filter__is__subset,axiom,
    ! [A: $tType,P: A > $o,Xs: list @ A] : ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ ( filter2 @ A @ P @ Xs ) ) @ ( set2 @ A @ Xs ) ) ).

% filter_is_subset
thf(fact_7762_length__filter__le,axiom,
    ! [A: $tType,P: A > $o,Xs: list @ A] : ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ ( filter2 @ A @ P @ Xs ) ) @ ( size_size @ ( list @ A ) @ Xs ) ) ).

% length_filter_le
thf(fact_7763_filter__eq__Cons__iff,axiom,
    ! [A: $tType,P: A > $o,Ys: list @ A,X2: A,Xs: list @ A] :
      ( ( ( filter2 @ A @ P @ Ys )
        = ( cons @ A @ X2 @ Xs ) )
      = ( ? [Us2: list @ A,Vs3: list @ A] :
            ( ( Ys
              = ( append @ A @ Us2 @ ( cons @ A @ X2 @ Vs3 ) ) )
            & ! [X5: A] :
                ( ( member @ A @ X5 @ ( set2 @ A @ Us2 ) )
               => ~ ( P @ X5 ) )
            & ( P @ X2 )
            & ( Xs
              = ( filter2 @ A @ P @ Vs3 ) ) ) ) ) ).

% filter_eq_Cons_iff
thf(fact_7764_Cons__eq__filter__iff,axiom,
    ! [A: $tType,X2: A,Xs: list @ A,P: A > $o,Ys: list @ A] :
      ( ( ( cons @ A @ X2 @ Xs )
        = ( filter2 @ A @ P @ Ys ) )
      = ( ? [Us2: list @ A,Vs3: list @ A] :
            ( ( Ys
              = ( append @ A @ Us2 @ ( cons @ A @ X2 @ Vs3 ) ) )
            & ! [X5: A] :
                ( ( member @ A @ X5 @ ( set2 @ A @ Us2 ) )
               => ~ ( P @ X5 ) )
            & ( P @ X2 )
            & ( Xs
              = ( filter2 @ A @ P @ Vs3 ) ) ) ) ) ).

% Cons_eq_filter_iff
thf(fact_7765_filter__eq__ConsD,axiom,
    ! [A: $tType,P: A > $o,Ys: list @ A,X2: A,Xs: list @ A] :
      ( ( ( filter2 @ A @ P @ Ys )
        = ( cons @ A @ X2 @ Xs ) )
     => ? [Us3: list @ A,Vs2: list @ A] :
          ( ( Ys
            = ( append @ A @ Us3 @ ( cons @ A @ X2 @ Vs2 ) ) )
          & ! [X: A] :
              ( ( member @ A @ X @ ( set2 @ A @ Us3 ) )
             => ~ ( P @ X ) )
          & ( P @ X2 )
          & ( Xs
            = ( filter2 @ A @ P @ Vs2 ) ) ) ) ).

% filter_eq_ConsD
thf(fact_7766_Cons__eq__filterD,axiom,
    ! [A: $tType,X2: A,Xs: list @ A,P: A > $o,Ys: list @ A] :
      ( ( ( cons @ A @ X2 @ Xs )
        = ( filter2 @ A @ P @ Ys ) )
     => ? [Us3: list @ A,Vs2: list @ A] :
          ( ( Ys
            = ( append @ A @ Us3 @ ( cons @ A @ X2 @ Vs2 ) ) )
          & ! [X: A] :
              ( ( member @ A @ X @ ( set2 @ A @ Us3 ) )
             => ~ ( P @ X ) )
          & ( P @ X2 )
          & ( Xs
            = ( filter2 @ A @ P @ Vs2 ) ) ) ) ).

% Cons_eq_filterD
thf(fact_7767_distinct__filter,axiom,
    ! [A: $tType,Xs: list @ A,P: A > $o] :
      ( ( distinct @ A @ Xs )
     => ( distinct @ A @ ( filter2 @ A @ P @ Xs ) ) ) ).

% distinct_filter
thf(fact_7768_sum__list__map__filter,axiom,
    ! [A: $tType,B: $tType] :
      ( ( monoid_add @ A )
     => ! [Xs: list @ B,P: B > $o,F2: B > A] :
          ( ! [X3: B] :
              ( ( member @ B @ X3 @ ( set2 @ B @ Xs ) )
             => ( ~ ( P @ X3 )
               => ( ( F2 @ X3 )
                  = ( zero_zero @ A ) ) ) )
         => ( ( groups8242544230860333062m_list @ A @ ( map @ B @ A @ F2 @ ( filter2 @ B @ P @ Xs ) ) )
            = ( groups8242544230860333062m_list @ A @ ( map @ B @ A @ F2 @ Xs ) ) ) ) ) ).

% sum_list_map_filter
thf(fact_7769_filter__insort,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F2: B > A,Xs: list @ B,P: B > $o,X2: B] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( map @ B @ A @ F2 @ Xs ) )
         => ( ( P @ X2 )
           => ( ( filter2 @ B @ P @ ( linorder_insort_key @ B @ A @ F2 @ X2 @ Xs ) )
              = ( linorder_insort_key @ B @ A @ F2 @ X2 @ ( filter2 @ B @ P @ Xs ) ) ) ) ) ) ).

% filter_insort
thf(fact_7770_set__minus__filter__out,axiom,
    ! [A: $tType,Xs: list @ A,Y2: A] :
      ( ( minus_minus @ ( set @ A ) @ ( set2 @ A @ Xs ) @ ( insert @ A @ Y2 @ ( bot_bot @ ( set @ A ) ) ) )
      = ( set2 @ A
        @ ( filter2 @ A
          @ ^ [X5: A] : ( X5 != Y2 )
          @ Xs ) ) ) ).

% set_minus_filter_out
thf(fact_7771_filter__shuffles__disjoint1_I2_J,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A,Zs: list @ A] :
      ( ( ( inf_inf @ ( set @ A ) @ ( set2 @ A @ Xs ) @ ( set2 @ A @ Ys ) )
        = ( bot_bot @ ( set @ A ) ) )
     => ( ( member @ ( list @ A ) @ Zs @ ( shuffles @ A @ Xs @ Ys ) )
       => ( ( filter2 @ A
            @ ^ [X5: A] :
                ~ ( member @ A @ X5 @ ( set2 @ A @ Xs ) )
            @ Zs )
          = Ys ) ) ) ).

% filter_shuffles_disjoint1(2)
thf(fact_7772_filter__shuffles__disjoint1_I1_J,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A,Zs: list @ A] :
      ( ( ( inf_inf @ ( set @ A ) @ ( set2 @ A @ Xs ) @ ( set2 @ A @ Ys ) )
        = ( bot_bot @ ( set @ A ) ) )
     => ( ( member @ ( list @ A ) @ Zs @ ( shuffles @ A @ Xs @ Ys ) )
       => ( ( filter2 @ A
            @ ^ [X5: A] : ( member @ A @ X5 @ ( set2 @ A @ Xs ) )
            @ Zs )
          = Xs ) ) ) ).

% filter_shuffles_disjoint1(1)
thf(fact_7773_filter__shuffles__disjoint2_I2_J,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A,Zs: list @ A] :
      ( ( ( inf_inf @ ( set @ A ) @ ( set2 @ A @ Xs ) @ ( set2 @ A @ Ys ) )
        = ( bot_bot @ ( set @ A ) ) )
     => ( ( member @ ( list @ A ) @ Zs @ ( shuffles @ A @ Xs @ Ys ) )
       => ( ( filter2 @ A
            @ ^ [X5: A] :
                ~ ( member @ A @ X5 @ ( set2 @ A @ Ys ) )
            @ Zs )
          = Xs ) ) ) ).

% filter_shuffles_disjoint2(2)
thf(fact_7774_filter__shuffles__disjoint2_I1_J,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A,Zs: list @ A] :
      ( ( ( inf_inf @ ( set @ A ) @ ( set2 @ A @ Xs ) @ ( set2 @ A @ Ys ) )
        = ( bot_bot @ ( set @ A ) ) )
     => ( ( member @ ( list @ A ) @ Zs @ ( shuffles @ A @ Xs @ Ys ) )
       => ( ( filter2 @ A
            @ ^ [X5: A] : ( member @ A @ X5 @ ( set2 @ A @ Ys ) )
            @ Zs )
          = Ys ) ) ) ).

% filter_shuffles_disjoint2(1)
thf(fact_7775_length__filter__conv__card,axiom,
    ! [A: $tType,P4: A > $o,Xs: list @ A] :
      ( ( size_size @ ( list @ A ) @ ( filter2 @ A @ P4 @ Xs ) )
      = ( finite_card @ nat
        @ ( collect @ nat
          @ ^ [I4: nat] :
              ( ( ord_less @ nat @ I4 @ ( size_size @ ( list @ A ) @ Xs ) )
              & ( P4 @ ( nth @ A @ Xs @ I4 ) ) ) ) ) ) ).

% length_filter_conv_card
thf(fact_7776_distinct__length__filter,axiom,
    ! [A: $tType,Xs: list @ A,P: A > $o] :
      ( ( distinct @ A @ Xs )
     => ( ( size_size @ ( list @ A ) @ ( filter2 @ A @ P @ Xs ) )
        = ( finite_card @ A @ ( inf_inf @ ( set @ A ) @ ( collect @ A @ P ) @ ( set2 @ A @ Xs ) ) ) ) ) ).

% distinct_length_filter
thf(fact_7777_nth__transpose,axiom,
    ! [A: $tType,I3: nat,Xs: list @ ( list @ A )] :
      ( ( ord_less @ nat @ I3 @ ( size_size @ ( list @ ( list @ A ) ) @ ( transpose @ A @ Xs ) ) )
     => ( ( nth @ ( list @ A ) @ ( transpose @ A @ Xs ) @ I3 )
        = ( map @ ( list @ A ) @ A
          @ ^ [Xs3: list @ A] : ( nth @ A @ Xs3 @ I3 )
          @ ( filter2 @ ( list @ A )
            @ ^ [Ys3: list @ A] : ( ord_less @ nat @ I3 @ ( size_size @ ( list @ A ) @ Ys3 ) )
            @ Xs ) ) ) ) ).

% nth_transpose
thf(fact_7778_transpose__column__length,axiom,
    ! [A: $tType,Xs: list @ ( list @ A ),I3: nat] :
      ( ( sorted_wrt @ nat @ ( ord_less_eq @ nat ) @ ( rev @ nat @ ( map @ ( list @ A ) @ nat @ ( size_size @ ( list @ A ) ) @ Xs ) ) )
     => ( ( ord_less @ nat @ I3 @ ( size_size @ ( list @ ( list @ A ) ) @ Xs ) )
       => ( ( size_size @ ( list @ ( list @ A ) )
            @ ( filter2 @ ( list @ A )
              @ ^ [Ys3: list @ A] : ( ord_less @ nat @ I3 @ ( size_size @ ( list @ A ) @ Ys3 ) )
              @ ( transpose @ A @ Xs ) ) )
          = ( size_size @ ( list @ A ) @ ( nth @ ( list @ A ) @ Xs @ I3 ) ) ) ) ) ).

% transpose_column_length
thf(fact_7779_folding__insort__key_Osorted__key__list__of__set__unique,axiom,
    ! [A: $tType,B: $tType,Less_eq: A > A > $o,Less: A > A > $o,S3: set @ B,F2: B > A,A3: set @ B,L: list @ B] :
      ( ( folding_insort_key @ A @ B @ Less_eq @ Less @ S3 @ F2 )
     => ( ( ord_less_eq @ ( set @ B ) @ A3 @ S3 )
       => ( ( finite_finite @ B @ A3 )
         => ( ( ( sorted_wrt @ A @ Less @ ( map @ B @ A @ F2 @ L ) )
              & ( ( set2 @ B @ L )
                = A3 )
              & ( ( size_size @ ( list @ B ) @ L )
                = ( finite_card @ B @ A3 ) ) )
            = ( ( sorted8670434370408473282of_set @ A @ B @ Less_eq @ F2 @ A3 )
              = L ) ) ) ) ) ).

% folding_insort_key.sorted_key_list_of_set_unique
thf(fact_7780_transpose__aux__filter__tail,axiom,
    ! [A: $tType,Xss: list @ ( list @ A )] :
      ( ( concat @ ( list @ A )
        @ ( map @ ( list @ A ) @ ( list @ ( list @ A ) )
          @ ( case_list @ ( list @ ( list @ A ) ) @ A @ ( nil @ ( list @ A ) )
            @ ^ [H: A,T3: list @ A] : ( cons @ ( list @ A ) @ T3 @ ( nil @ ( list @ A ) ) ) )
          @ Xss ) )
      = ( map @ ( list @ A ) @ ( list @ A ) @ ( tl @ A )
        @ ( filter2 @ ( list @ A )
          @ ^ [Ys3: list @ A] :
              ( Ys3
             != ( nil @ A ) )
          @ Xss ) ) ) ).

% transpose_aux_filter_tail
thf(fact_7781_tl__upt,axiom,
    ! [M: nat,N2: nat] :
      ( ( tl @ nat @ ( upt @ M @ N2 ) )
      = ( upt @ ( suc @ M ) @ N2 ) ) ).

% tl_upt
thf(fact_7782_tl__append2,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A] :
      ( ( Xs
       != ( nil @ A ) )
     => ( ( tl @ A @ ( append @ A @ Xs @ Ys ) )
        = ( append @ A @ ( tl @ A @ Xs ) @ Ys ) ) ) ).

% tl_append2
thf(fact_7783_remdups__adj__Cons__alt,axiom,
    ! [A: $tType,X2: A,Xs: list @ A] :
      ( ( cons @ A @ X2 @ ( tl @ A @ ( remdups_adj @ A @ ( cons @ A @ X2 @ Xs ) ) ) )
      = ( remdups_adj @ A @ ( cons @ A @ X2 @ Xs ) ) ) ).

% remdups_adj_Cons_alt
thf(fact_7784_length__tl,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( size_size @ ( list @ A ) @ ( tl @ A @ Xs ) )
      = ( minus_minus @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ ( one_one @ nat ) ) ) ).

% length_tl
thf(fact_7785_tl__replicate,axiom,
    ! [A: $tType,N2: nat,X2: A] :
      ( ( tl @ A @ ( replicate @ A @ N2 @ X2 ) )
      = ( replicate @ A @ ( minus_minus @ nat @ N2 @ ( one_one @ nat ) ) @ X2 ) ) ).

% tl_replicate
thf(fact_7786_list_Omap__sel_I2_J,axiom,
    ! [B: $tType,A: $tType,A2: list @ A,F2: A > B] :
      ( ( A2
       != ( nil @ A ) )
     => ( ( tl @ B @ ( map @ A @ B @ F2 @ A2 ) )
        = ( map @ A @ B @ F2 @ ( tl @ A @ A2 ) ) ) ) ).

% list.map_sel(2)
thf(fact_7787_map__tl,axiom,
    ! [A: $tType,B: $tType,F2: B > A,Xs: list @ B] :
      ( ( map @ B @ A @ F2 @ ( tl @ B @ Xs ) )
      = ( tl @ A @ ( map @ B @ A @ F2 @ Xs ) ) ) ).

% map_tl
thf(fact_7788_map__of__filter__in,axiom,
    ! [B: $tType,A: $tType,Xs: list @ ( product_prod @ B @ A ),K: B,Z: A,P: B > A > $o] :
      ( ( ( map_of @ B @ A @ Xs @ K )
        = ( some @ A @ Z ) )
     => ( ( P @ K @ Z )
       => ( ( map_of @ B @ A @ ( filter2 @ ( product_prod @ B @ A ) @ ( product_case_prod @ B @ A @ $o @ P ) @ Xs ) @ K )
          = ( some @ A @ Z ) ) ) ) ).

% map_of_filter_in
thf(fact_7789_distinct__tl,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( distinct @ A @ Xs )
     => ( distinct @ A @ ( tl @ A @ Xs ) ) ) ).

% distinct_tl
thf(fact_7790_list_Oset__sel_I2_J,axiom,
    ! [A: $tType,A2: list @ A,X2: A] :
      ( ( A2
       != ( nil @ A ) )
     => ( ( member @ A @ X2 @ ( set2 @ A @ ( tl @ A @ A2 ) ) )
       => ( member @ A @ X2 @ ( set2 @ A @ A2 ) ) ) ) ).

% list.set_sel(2)
thf(fact_7791_linorder_Osorted__key__list__of__set_Ocong,axiom,
    ! [B: $tType,A: $tType] :
      ( ( sorted8670434370408473282of_set @ A @ B )
      = ( sorted8670434370408473282of_set @ A @ B ) ) ).

% linorder.sorted_key_list_of_set.cong
thf(fact_7792_list_Osel_I2_J,axiom,
    ! [A: $tType] :
      ( ( tl @ A @ ( nil @ A ) )
      = ( nil @ A ) ) ).

% list.sel(2)
thf(fact_7793_Nil__tl,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( ( nil @ A )
        = ( tl @ A @ Xs ) )
      = ( ( Xs
          = ( nil @ A ) )
        | ? [X5: A] :
            ( Xs
            = ( cons @ A @ X5 @ ( nil @ A ) ) ) ) ) ).

% Nil_tl
thf(fact_7794_tl__Nil,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( ( tl @ A @ Xs )
        = ( nil @ A ) )
      = ( ( Xs
          = ( nil @ A ) )
        | ? [X5: A] :
            ( Xs
            = ( cons @ A @ X5 @ ( nil @ A ) ) ) ) ) ).

% tl_Nil
thf(fact_7795_list_Osel_I3_J,axiom,
    ! [A: $tType,X21: A,X222: list @ A] :
      ( ( tl @ A @ ( cons @ A @ X21 @ X222 ) )
      = X222 ) ).

% list.sel(3)
thf(fact_7796_tl__def,axiom,
    ! [A: $tType] :
      ( ( tl @ A )
      = ( case_list @ ( list @ A ) @ A @ ( nil @ A )
        @ ^ [X213: A,X224: list @ A] : X224 ) ) ).

% tl_def
thf(fact_7797_tl__append,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A] :
      ( ( tl @ A @ ( append @ A @ Xs @ Ys ) )
      = ( case_list @ ( list @ A ) @ A @ ( tl @ A @ Ys )
        @ ^ [Z6: A,Zs3: list @ A] : ( append @ A @ Zs3 @ Ys )
        @ Xs ) ) ).

% tl_append
thf(fact_7798_sorted__tl,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs )
         => ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( tl @ A @ Xs ) ) ) ) ).

% sorted_tl
thf(fact_7799_Nitpick_Osize__list__simp_I2_J,axiom,
    ! [A: $tType] :
      ( ( size_size @ ( list @ A ) )
      = ( ^ [Xs3: list @ A] :
            ( if @ nat
            @ ( Xs3
              = ( nil @ A ) )
            @ ( zero_zero @ nat )
            @ ( suc @ ( size_size @ ( list @ A ) @ ( tl @ A @ Xs3 ) ) ) ) ) ) ).

% Nitpick.size_list_simp(2)
thf(fact_7800_nth__tl,axiom,
    ! [A: $tType,N2: nat,Xs: list @ A] :
      ( ( ord_less @ nat @ N2 @ ( size_size @ ( list @ A ) @ ( tl @ A @ Xs ) ) )
     => ( ( nth @ A @ ( tl @ A @ Xs ) @ N2 )
        = ( nth @ A @ Xs @ ( suc @ N2 ) ) ) ) ).

% nth_tl
thf(fact_7801_remdups__adj__append,axiom,
    ! [A: $tType,Xs_1: list @ A,X2: A,Xs_2: list @ A] :
      ( ( remdups_adj @ A @ ( append @ A @ Xs_1 @ ( cons @ A @ X2 @ Xs_2 ) ) )
      = ( append @ A @ ( remdups_adj @ A @ ( append @ A @ Xs_1 @ ( cons @ A @ X2 @ ( nil @ A ) ) ) ) @ ( tl @ A @ ( remdups_adj @ A @ ( cons @ A @ X2 @ Xs_2 ) ) ) ) ) ).

% remdups_adj_append
thf(fact_7802_folding__insort__key_Osorted__key__list__of__set__inject,axiom,
    ! [A: $tType,B: $tType,Less_eq: A > A > $o,Less: A > A > $o,S3: set @ B,F2: B > A,A3: set @ B,B3: set @ B] :
      ( ( folding_insort_key @ A @ B @ Less_eq @ Less @ S3 @ F2 )
     => ( ( ord_less_eq @ ( set @ B ) @ A3 @ S3 )
       => ( ( ord_less_eq @ ( set @ B ) @ B3 @ S3 )
         => ( ( ( sorted8670434370408473282of_set @ A @ B @ Less_eq @ F2 @ A3 )
              = ( sorted8670434370408473282of_set @ A @ B @ Less_eq @ F2 @ B3 ) )
           => ( ( finite_finite @ B @ A3 )
             => ( ( finite_finite @ B @ B3 )
               => ( A3 = B3 ) ) ) ) ) ) ) ).

% folding_insort_key.sorted_key_list_of_set_inject
thf(fact_7803_folding__insort__key_Osorted__key__list__of__set__empty,axiom,
    ! [A: $tType,B: $tType,Less_eq: A > A > $o,Less: A > A > $o,S3: set @ B,F2: B > A] :
      ( ( folding_insort_key @ A @ B @ Less_eq @ Less @ S3 @ F2 )
     => ( ( sorted8670434370408473282of_set @ A @ B @ Less_eq @ F2 @ ( bot_bot @ ( set @ B ) ) )
        = ( nil @ B ) ) ) ).

% folding_insort_key.sorted_key_list_of_set_empty
thf(fact_7804_folding__insort__key_Oset__sorted__key__list__of__set,axiom,
    ! [A: $tType,B: $tType,Less_eq: A > A > $o,Less: A > A > $o,S3: set @ B,F2: B > A,A3: set @ B] :
      ( ( folding_insort_key @ A @ B @ Less_eq @ Less @ S3 @ F2 )
     => ( ( ord_less_eq @ ( set @ B ) @ A3 @ S3 )
       => ( ( finite_finite @ B @ A3 )
         => ( ( set2 @ B @ ( sorted8670434370408473282of_set @ A @ B @ Less_eq @ F2 @ A3 ) )
            = A3 ) ) ) ) ).

% folding_insort_key.set_sorted_key_list_of_set
thf(fact_7805_folding__insort__key_Olength__sorted__key__list__of__set,axiom,
    ! [A: $tType,B: $tType,Less_eq: A > A > $o,Less: A > A > $o,S3: set @ B,F2: B > A,A3: set @ B] :
      ( ( folding_insort_key @ A @ B @ Less_eq @ Less @ S3 @ F2 )
     => ( ( ord_less_eq @ ( set @ B ) @ A3 @ S3 )
       => ( ( size_size @ ( list @ B ) @ ( sorted8670434370408473282of_set @ A @ B @ Less_eq @ F2 @ A3 ) )
          = ( finite_card @ B @ A3 ) ) ) ) ).

% folding_insort_key.length_sorted_key_list_of_set
thf(fact_7806_folding__insort__key_Odistinct__sorted__key__list__of__set,axiom,
    ! [A: $tType,B: $tType,Less_eq: A > A > $o,Less: A > A > $o,S3: set @ B,F2: B > A,A3: set @ B] :
      ( ( folding_insort_key @ A @ B @ Less_eq @ Less @ S3 @ F2 )
     => ( ( ord_less_eq @ ( set @ B ) @ A3 @ S3 )
       => ( distinct @ A @ ( map @ B @ A @ F2 @ ( sorted8670434370408473282of_set @ A @ B @ Less_eq @ F2 @ A3 ) ) ) ) ) ).

% folding_insort_key.distinct_sorted_key_list_of_set
thf(fact_7807_folding__insort__key_Osorted__sorted__key__list__of__set,axiom,
    ! [A: $tType,B: $tType,Less_eq: A > A > $o,Less: A > A > $o,S3: set @ B,F2: B > A,A3: set @ B] :
      ( ( folding_insort_key @ A @ B @ Less_eq @ Less @ S3 @ F2 )
     => ( ( ord_less_eq @ ( set @ B ) @ A3 @ S3 )
       => ( sorted_wrt @ A @ Less_eq @ ( map @ B @ A @ F2 @ ( sorted8670434370408473282of_set @ A @ B @ Less_eq @ F2 @ A3 ) ) ) ) ) ).

% folding_insort_key.sorted_sorted_key_list_of_set
thf(fact_7808_folding__insort__key_Ostrict__sorted__key__list__of__set,axiom,
    ! [A: $tType,B: $tType,Less_eq: A > A > $o,Less: A > A > $o,S3: set @ B,F2: B > A,A3: set @ B] :
      ( ( folding_insort_key @ A @ B @ Less_eq @ Less @ S3 @ F2 )
     => ( ( ord_less_eq @ ( set @ B ) @ A3 @ S3 )
       => ( sorted_wrt @ A @ Less @ ( map @ B @ A @ F2 @ ( sorted8670434370408473282of_set @ A @ B @ Less_eq @ F2 @ A3 ) ) ) ) ) ).

% folding_insort_key.strict_sorted_key_list_of_set
thf(fact_7809_folding__insort__key_Osorted__key__list__of__set__eq__Nil__iff,axiom,
    ! [A: $tType,B: $tType,Less_eq: A > A > $o,Less: A > A > $o,S3: set @ B,F2: B > A,A3: set @ B] :
      ( ( folding_insort_key @ A @ B @ Less_eq @ Less @ S3 @ F2 )
     => ( ( ord_less_eq @ ( set @ B ) @ A3 @ S3 )
       => ( ( finite_finite @ B @ A3 )
         => ( ( ( sorted8670434370408473282of_set @ A @ B @ Less_eq @ F2 @ A3 )
              = ( nil @ B ) )
            = ( A3
              = ( bot_bot @ ( set @ B ) ) ) ) ) ) ) ).

% folding_insort_key.sorted_key_list_of_set_eq_Nil_iff
thf(fact_7810_folding__insort__key_Oidem__if__sorted__distinct,axiom,
    ! [A: $tType,B: $tType,Less_eq: A > A > $o,Less: A > A > $o,S3: set @ B,F2: B > A,Xs: list @ B] :
      ( ( folding_insort_key @ A @ B @ Less_eq @ Less @ S3 @ F2 )
     => ( ( ord_less_eq @ ( set @ B ) @ ( set2 @ B @ Xs ) @ S3 )
       => ( ( sorted_wrt @ A @ Less_eq @ ( map @ B @ A @ F2 @ Xs ) )
         => ( ( distinct @ B @ Xs )
           => ( ( sorted8670434370408473282of_set @ A @ B @ Less_eq @ F2 @ ( set2 @ B @ Xs ) )
              = Xs ) ) ) ) ) ).

% folding_insort_key.idem_if_sorted_distinct
thf(fact_7811_folding__insort__key_Osorted__key__list__of__set__remove,axiom,
    ! [A: $tType,B: $tType,Less_eq: A > A > $o,Less: A > A > $o,S3: set @ B,F2: B > A,X2: B,A3: set @ B] :
      ( ( folding_insort_key @ A @ B @ Less_eq @ Less @ S3 @ F2 )
     => ( ( ord_less_eq @ ( set @ B ) @ ( insert @ B @ X2 @ A3 ) @ S3 )
       => ( ( finite_finite @ B @ A3 )
         => ( ( sorted8670434370408473282of_set @ A @ B @ Less_eq @ F2 @ ( minus_minus @ ( set @ B ) @ A3 @ ( insert @ B @ X2 @ ( bot_bot @ ( set @ B ) ) ) ) )
            = ( remove1 @ B @ X2 @ ( sorted8670434370408473282of_set @ A @ B @ Less_eq @ F2 @ A3 ) ) ) ) ) ) ).

% folding_insort_key.sorted_key_list_of_set_remove
thf(fact_7812_folding__insort__key_Osorted__key__list__of__set__insert__remove,axiom,
    ! [A: $tType,B: $tType,Less_eq: A > A > $o,Less: A > A > $o,S3: set @ B,F2: B > A,X2: B,A3: set @ B] :
      ( ( folding_insort_key @ A @ B @ Less_eq @ Less @ S3 @ F2 )
     => ( ( ord_less_eq @ ( set @ B ) @ ( insert @ B @ X2 @ A3 ) @ S3 )
       => ( ( finite_finite @ B @ A3 )
         => ( ( sorted8670434370408473282of_set @ A @ B @ Less_eq @ F2 @ ( insert @ B @ X2 @ A3 ) )
            = ( insort_key @ A @ B @ Less_eq @ F2 @ X2 @ ( sorted8670434370408473282of_set @ A @ B @ Less_eq @ F2 @ ( minus_minus @ ( set @ B ) @ A3 @ ( insert @ B @ X2 @ ( bot_bot @ ( set @ B ) ) ) ) ) ) ) ) ) ) ).

% folding_insort_key.sorted_key_list_of_set_insert_remove
thf(fact_7813_folding__insort__key_Osorted__key__list__of__set__insert,axiom,
    ! [A: $tType,B: $tType,Less_eq: A > A > $o,Less: A > A > $o,S3: set @ B,F2: B > A,X2: B,A3: set @ B] :
      ( ( folding_insort_key @ A @ B @ Less_eq @ Less @ S3 @ F2 )
     => ( ( ord_less_eq @ ( set @ B ) @ ( insert @ B @ X2 @ A3 ) @ S3 )
       => ( ( finite_finite @ B @ A3 )
         => ( ~ ( member @ B @ X2 @ A3 )
           => ( ( sorted8670434370408473282of_set @ A @ B @ Less_eq @ F2 @ ( insert @ B @ X2 @ A3 ) )
              = ( insort_key @ A @ B @ Less_eq @ F2 @ X2 @ ( sorted8670434370408473282of_set @ A @ B @ Less_eq @ F2 @ A3 ) ) ) ) ) ) ) ).

% folding_insort_key.sorted_key_list_of_set_insert
thf(fact_7814_linorder_Oinsort__key_Ocong,axiom,
    ! [B: $tType,A: $tType] :
      ( ( insort_key @ A @ B )
      = ( insort_key @ A @ B ) ) ).

% linorder.insort_key.cong
thf(fact_7815_folding__insort__key_Oinsort__key__commute,axiom,
    ! [A: $tType,B: $tType,Less_eq: A > A > $o,Less: A > A > $o,S3: set @ B,F2: B > A,X2: B,Y2: B] :
      ( ( folding_insort_key @ A @ B @ Less_eq @ Less @ S3 @ F2 )
     => ( ( member @ B @ X2 @ S3 )
       => ( ( member @ B @ Y2 @ S3 )
         => ( ( comp @ ( list @ B ) @ ( list @ B ) @ ( list @ B ) @ ( insort_key @ A @ B @ Less_eq @ F2 @ Y2 ) @ ( insort_key @ A @ B @ Less_eq @ F2 @ X2 ) )
            = ( comp @ ( list @ B ) @ ( list @ B ) @ ( list @ B ) @ ( insort_key @ A @ B @ Less_eq @ F2 @ X2 ) @ ( insort_key @ A @ B @ Less_eq @ F2 @ Y2 ) ) ) ) ) ) ).

% folding_insort_key.insort_key_commute
thf(fact_7816_transpose__max__length,axiom,
    ! [A: $tType,Xs: list @ ( list @ A )] :
      ( ( foldr @ ( list @ A ) @ nat
        @ ^ [Xs3: list @ A] : ( ord_max @ nat @ ( size_size @ ( list @ A ) @ Xs3 ) )
        @ ( transpose @ A @ Xs )
        @ ( zero_zero @ nat ) )
      = ( size_size @ ( list @ ( list @ A ) )
        @ ( filter2 @ ( list @ A )
          @ ^ [X5: list @ A] :
              ( X5
             != ( nil @ A ) )
          @ Xs ) ) ) ).

% transpose_max_length
thf(fact_7817_map__filter__map__filter,axiom,
    ! [A: $tType,B: $tType,F2: B > A,P: B > $o,Xs: list @ B] :
      ( ( map @ B @ A @ F2 @ ( filter2 @ B @ P @ Xs ) )
      = ( map_filter @ B @ A
        @ ^ [X5: B] : ( if @ ( option @ A ) @ ( P @ X5 ) @ ( some @ A @ ( F2 @ X5 ) ) @ ( none @ A ) )
        @ Xs ) ) ).

% map_filter_map_filter
thf(fact_7818_foldr__append,axiom,
    ! [B: $tType,A: $tType,F2: B > A > A,Xs: list @ B,Ys: list @ B,A2: A] :
      ( ( foldr @ B @ A @ F2 @ ( append @ B @ Xs @ Ys ) @ A2 )
      = ( foldr @ B @ A @ F2 @ Xs @ ( foldr @ B @ A @ F2 @ Ys @ A2 ) ) ) ).

% foldr_append
thf(fact_7819_foldr__replicate,axiom,
    ! [A: $tType,B: $tType,F2: B > A > A,N2: nat,X2: B] :
      ( ( foldr @ B @ A @ F2 @ ( replicate @ B @ N2 @ X2 ) )
      = ( compow @ ( A > A ) @ N2 @ ( F2 @ X2 ) ) ) ).

% foldr_replicate
thf(fact_7820_map__filter__simps_I1_J,axiom,
    ! [A: $tType,B: $tType,F2: B > ( option @ A ),X2: B,Xs: list @ B] :
      ( ( map_filter @ B @ A @ F2 @ ( cons @ B @ X2 @ Xs ) )
      = ( case_option @ ( list @ A ) @ A @ ( map_filter @ B @ A @ F2 @ Xs )
        @ ^ [Y5: A] : ( cons @ A @ Y5 @ ( map_filter @ B @ A @ F2 @ Xs ) )
        @ ( F2 @ X2 ) ) ) ).

% map_filter_simps(1)
thf(fact_7821_foldr__cong,axiom,
    ! [B: $tType,A: $tType,A2: A,B2: A,L: list @ B,K: list @ B,F2: B > A > A,G: B > A > A] :
      ( ( A2 = B2 )
     => ( ( L = K )
       => ( ! [A5: A,X3: B] :
              ( ( member @ B @ X3 @ ( set2 @ B @ L ) )
             => ( ( F2 @ X3 @ A5 )
                = ( G @ X3 @ A5 ) ) )
         => ( ( foldr @ B @ A @ F2 @ L @ A2 )
            = ( foldr @ B @ A @ G @ K @ B2 ) ) ) ) ) ).

% foldr_cong
thf(fact_7822_map__filter__simps_I2_J,axiom,
    ! [B: $tType,A: $tType,F2: B > ( option @ A )] :
      ( ( map_filter @ B @ A @ F2 @ ( nil @ B ) )
      = ( nil @ A ) ) ).

% map_filter_simps(2)
thf(fact_7823_foldr__Cons,axiom,
    ! [B: $tType,A: $tType,F2: A > B > B,X2: A,Xs: list @ A] :
      ( ( foldr @ A @ B @ F2 @ ( cons @ A @ X2 @ Xs ) )
      = ( comp @ B @ B @ B @ ( F2 @ X2 ) @ ( foldr @ A @ B @ F2 @ Xs ) ) ) ).

% foldr_Cons
thf(fact_7824_foldr__map,axiom,
    ! [C: $tType,B: $tType,A: $tType,G: B > A > A,F2: C > B,Xs: list @ C,A2: A] :
      ( ( foldr @ B @ A @ G @ ( map @ C @ B @ F2 @ Xs ) @ A2 )
      = ( foldr @ C @ A @ ( comp @ B @ ( A > A ) @ C @ G @ F2 ) @ Xs @ A2 ) ) ).

% foldr_map
thf(fact_7825_sum__list_Oeq__foldr,axiom,
    ! [A: $tType] :
      ( ( monoid_add @ A )
     => ( ( groups8242544230860333062m_list @ A )
        = ( ^ [Xs3: list @ A] : ( foldr @ A @ A @ ( plus_plus @ A ) @ Xs3 @ ( zero_zero @ A ) ) ) ) ) ).

% sum_list.eq_foldr
thf(fact_7826_horner__sum__foldr,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_semiring_0 @ A )
     => ( ( groups4207007520872428315er_sum @ B @ A )
        = ( ^ [F5: B > A,A4: A,Xs3: list @ B] :
              ( foldr @ B @ A
              @ ^ [X5: B,B4: A] : ( plus_plus @ A @ ( F5 @ X5 ) @ ( times_times @ A @ A4 @ B4 ) )
              @ Xs3
              @ ( zero_zero @ A ) ) ) ) ) ).

% horner_sum_foldr
thf(fact_7827_length__transpose,axiom,
    ! [A: $tType,Xs: list @ ( list @ A )] :
      ( ( size_size @ ( list @ ( list @ A ) ) @ ( transpose @ A @ Xs ) )
      = ( foldr @ ( list @ A ) @ nat
        @ ^ [Xs3: list @ A] : ( ord_max @ nat @ ( size_size @ ( list @ A ) @ Xs3 ) )
        @ Xs
        @ ( zero_zero @ nat ) ) ) ).

% length_transpose
thf(fact_7828_foldr__max__sorted,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A,Y2: A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( rev @ A @ Xs ) )
         => ( ( ( Xs
                = ( nil @ A ) )
             => ( ( foldr @ A @ A @ ( ord_max @ A ) @ Xs @ Y2 )
                = Y2 ) )
            & ( ( Xs
               != ( nil @ A ) )
             => ( ( foldr @ A @ A @ ( ord_max @ A ) @ Xs @ Y2 )
                = ( ord_max @ A @ ( nth @ A @ Xs @ ( zero_zero @ nat ) ) @ Y2 ) ) ) ) ) ) ).

% foldr_max_sorted
thf(fact_7829_transpose__aux__max,axiom,
    ! [A: $tType,B: $tType,Xs: list @ A,Xss: list @ ( list @ B )] :
      ( ( ord_max @ nat @ ( suc @ ( size_size @ ( list @ A ) @ Xs ) )
        @ ( foldr @ ( list @ B ) @ nat
          @ ^ [Xs3: list @ B] : ( ord_max @ nat @ ( size_size @ ( list @ B ) @ Xs3 ) )
          @ Xss
          @ ( zero_zero @ nat ) ) )
      = ( suc
        @ ( ord_max @ nat @ ( size_size @ ( list @ A ) @ Xs )
          @ ( foldr @ ( list @ B ) @ nat
            @ ^ [X5: list @ B] : ( ord_max @ nat @ ( minus_minus @ nat @ ( size_size @ ( list @ B ) @ X5 ) @ ( suc @ ( zero_zero @ nat ) ) ) )
            @ ( filter2 @ ( list @ B )
              @ ^ [Ys3: list @ B] :
                  ( Ys3
                 != ( nil @ B ) )
              @ Xss )
            @ ( zero_zero @ nat ) ) ) ) ) ).

% transpose_aux_max
thf(fact_7830_transpose__transpose,axiom,
    ! [A: $tType,Xs: list @ ( list @ A )] :
      ( ( sorted_wrt @ nat @ ( ord_less_eq @ nat ) @ ( rev @ nat @ ( map @ ( list @ A ) @ nat @ ( size_size @ ( list @ A ) ) @ Xs ) ) )
     => ( ( transpose @ A @ ( transpose @ A @ Xs ) )
        = ( takeWhile @ ( list @ A )
          @ ^ [X5: list @ A] :
              ( X5
             != ( nil @ A ) )
          @ Xs ) ) ) ).

% transpose_transpose
thf(fact_7831_length__product__lists,axiom,
    ! [B: $tType,Xss: list @ ( list @ B )] :
      ( ( size_size @ ( list @ ( list @ B ) ) @ ( product_lists @ B @ Xss ) )
      = ( foldr @ nat @ nat @ ( times_times @ nat ) @ ( map @ ( list @ B ) @ nat @ ( size_size @ ( list @ B ) ) @ Xss ) @ ( one_one @ nat ) ) ) ).

% length_product_lists
thf(fact_7832_takeWhile__idem,axiom,
    ! [A: $tType,P: A > $o,Xs: list @ A] :
      ( ( takeWhile @ A @ P @ ( takeWhile @ A @ P @ Xs ) )
      = ( takeWhile @ A @ P @ Xs ) ) ).

% takeWhile_idem
thf(fact_7833_takeWhile__eq__all__conv,axiom,
    ! [A: $tType,P: A > $o,Xs: list @ A] :
      ( ( ( takeWhile @ A @ P @ Xs )
        = Xs )
      = ( ! [X5: A] :
            ( ( member @ A @ X5 @ ( set2 @ A @ Xs ) )
           => ( P @ X5 ) ) ) ) ).

% takeWhile_eq_all_conv
thf(fact_7834_takeWhile__append2,axiom,
    ! [A: $tType,Xs: list @ A,P: A > $o,Ys: list @ A] :
      ( ! [X3: A] :
          ( ( member @ A @ X3 @ ( set2 @ A @ Xs ) )
         => ( P @ X3 ) )
     => ( ( takeWhile @ A @ P @ ( append @ A @ Xs @ Ys ) )
        = ( append @ A @ Xs @ ( takeWhile @ A @ P @ Ys ) ) ) ) ).

% takeWhile_append2
thf(fact_7835_takeWhile__append1,axiom,
    ! [A: $tType,X2: A,Xs: list @ A,P: A > $o,Ys: list @ A] :
      ( ( member @ A @ X2 @ ( set2 @ A @ Xs ) )
     => ( ~ ( P @ X2 )
       => ( ( takeWhile @ A @ P @ ( append @ A @ Xs @ Ys ) )
          = ( takeWhile @ A @ P @ Xs ) ) ) ) ).

% takeWhile_append1
thf(fact_7836_takeWhile__replicate,axiom,
    ! [A: $tType,P: A > $o,X2: A,N2: nat] :
      ( ( ( P @ X2 )
       => ( ( takeWhile @ A @ P @ ( replicate @ A @ N2 @ X2 ) )
          = ( replicate @ A @ N2 @ X2 ) ) )
      & ( ~ ( P @ X2 )
       => ( ( takeWhile @ A @ P @ ( replicate @ A @ N2 @ X2 ) )
          = ( nil @ A ) ) ) ) ).

% takeWhile_replicate
thf(fact_7837_takeWhile__map,axiom,
    ! [A: $tType,B: $tType,P: A > $o,F2: B > A,Xs: list @ B] :
      ( ( takeWhile @ A @ P @ ( map @ B @ A @ F2 @ Xs ) )
      = ( map @ B @ A @ F2 @ ( takeWhile @ B @ ( comp @ A @ $o @ B @ P @ F2 ) @ Xs ) ) ) ).

% takeWhile_map
thf(fact_7838_sorted__takeWhile,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A,P: A > $o] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs )
         => ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( takeWhile @ A @ P @ Xs ) ) ) ) ).

% sorted_takeWhile
thf(fact_7839_takeWhile__tail,axiom,
    ! [A: $tType,P: A > $o,X2: A,Xs: list @ A,L: list @ A] :
      ( ~ ( P @ X2 )
     => ( ( takeWhile @ A @ P @ ( append @ A @ Xs @ ( cons @ A @ X2 @ L ) ) )
        = ( takeWhile @ A @ P @ Xs ) ) ) ).

% takeWhile_tail
thf(fact_7840_takeWhile_Osimps_I2_J,axiom,
    ! [A: $tType,P: A > $o,X2: A,Xs: list @ A] :
      ( ( ( P @ X2 )
       => ( ( takeWhile @ A @ P @ ( cons @ A @ X2 @ Xs ) )
          = ( cons @ A @ X2 @ ( takeWhile @ A @ P @ Xs ) ) ) )
      & ( ~ ( P @ X2 )
       => ( ( takeWhile @ A @ P @ ( cons @ A @ X2 @ Xs ) )
          = ( nil @ A ) ) ) ) ).

% takeWhile.simps(2)
thf(fact_7841_takeWhile_Osimps_I1_J,axiom,
    ! [A: $tType,P: A > $o] :
      ( ( takeWhile @ A @ P @ ( nil @ A ) )
      = ( nil @ A ) ) ).

% takeWhile.simps(1)
thf(fact_7842_takeWhile__cong,axiom,
    ! [A: $tType,L: list @ A,K: list @ A,P: A > $o,Q: A > $o] :
      ( ( L = K )
     => ( ! [X3: A] :
            ( ( member @ A @ X3 @ ( set2 @ A @ L ) )
           => ( ( P @ X3 )
              = ( Q @ X3 ) ) )
       => ( ( takeWhile @ A @ P @ L )
          = ( takeWhile @ A @ Q @ K ) ) ) ) ).

% takeWhile_cong
thf(fact_7843_set__takeWhileD,axiom,
    ! [A: $tType,X2: A,P: A > $o,Xs: list @ A] :
      ( ( member @ A @ X2 @ ( set2 @ A @ ( takeWhile @ A @ P @ Xs ) ) )
     => ( ( member @ A @ X2 @ ( set2 @ A @ Xs ) )
        & ( P @ X2 ) ) ) ).

% set_takeWhileD
thf(fact_7844_length__takeWhile__le,axiom,
    ! [A: $tType,P: A > $o,Xs: list @ A] : ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ ( takeWhile @ A @ P @ Xs ) ) @ ( size_size @ ( list @ A ) @ Xs ) ) ).

% length_takeWhile_le
thf(fact_7845_distinct__takeWhile,axiom,
    ! [A: $tType,Xs: list @ A,P: A > $o] :
      ( ( distinct @ A @ Xs )
     => ( distinct @ A @ ( takeWhile @ A @ P @ Xs ) ) ) ).

% distinct_takeWhile
thf(fact_7846_takeWhile__nth,axiom,
    ! [A: $tType,J: nat,P: A > $o,Xs: list @ A] :
      ( ( ord_less @ nat @ J @ ( size_size @ ( list @ A ) @ ( takeWhile @ A @ P @ Xs ) ) )
     => ( ( nth @ A @ ( takeWhile @ A @ P @ Xs ) @ J )
        = ( nth @ A @ Xs @ J ) ) ) ).

% takeWhile_nth
thf(fact_7847_nth__length__takeWhile,axiom,
    ! [A: $tType,P: A > $o,Xs: list @ A] :
      ( ( ord_less @ nat @ ( size_size @ ( list @ A ) @ ( takeWhile @ A @ P @ Xs ) ) @ ( size_size @ ( list @ A ) @ Xs ) )
     => ~ ( P @ ( nth @ A @ Xs @ ( size_size @ ( list @ A ) @ ( takeWhile @ A @ P @ Xs ) ) ) ) ) ).

% nth_length_takeWhile
thf(fact_7848_takeWhile__append,axiom,
    ! [A: $tType,Xs: list @ A,P: A > $o,Ys: list @ A] :
      ( ( ! [X3: A] :
            ( ( member @ A @ X3 @ ( set2 @ A @ Xs ) )
           => ( P @ X3 ) )
       => ( ( takeWhile @ A @ P @ ( append @ A @ Xs @ Ys ) )
          = ( append @ A @ Xs @ ( takeWhile @ A @ P @ Ys ) ) ) )
      & ( ~ ! [X: A] :
              ( ( member @ A @ X @ ( set2 @ A @ Xs ) )
             => ( P @ X ) )
       => ( ( takeWhile @ A @ P @ ( append @ A @ Xs @ Ys ) )
          = ( takeWhile @ A @ P @ Xs ) ) ) ) ).

% takeWhile_append
thf(fact_7849_concat__conv__foldr,axiom,
    ! [A: $tType] :
      ( ( concat @ A )
      = ( ^ [Xss3: list @ ( list @ A )] : ( foldr @ ( list @ A ) @ ( list @ A ) @ ( append @ A ) @ Xss3 @ ( nil @ A ) ) ) ) ).

% concat_conv_foldr
thf(fact_7850_length__takeWhile__less__P__nth,axiom,
    ! [A: $tType,J: nat,P: A > $o,Xs: list @ A] :
      ( ! [I2: nat] :
          ( ( ord_less @ nat @ I2 @ J )
         => ( P @ ( nth @ A @ Xs @ I2 ) ) )
     => ( ( ord_less_eq @ nat @ J @ ( size_size @ ( list @ A ) @ Xs ) )
       => ( ord_less_eq @ nat @ J @ ( size_size @ ( list @ A ) @ ( takeWhile @ A @ P @ Xs ) ) ) ) ) ).

% length_takeWhile_less_P_nth
thf(fact_7851_filter__equals__takeWhile__sorted__rev,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F2: B > A,Xs: list @ B,T2: A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( rev @ A @ ( map @ B @ A @ F2 @ Xs ) ) )
         => ( ( filter2 @ B
              @ ^ [X5: B] : ( ord_less @ A @ T2 @ ( F2 @ X5 ) )
              @ Xs )
            = ( takeWhile @ B
              @ ^ [X5: B] : ( ord_less @ A @ T2 @ ( F2 @ X5 ) )
              @ Xs ) ) ) ) ).

% filter_equals_takeWhile_sorted_rev
thf(fact_7852_extract__def,axiom,
    ! [A: $tType] :
      ( ( extract @ A )
      = ( ^ [P3: A > $o,Xs3: list @ A] :
            ( case_list @ ( option @ ( product_prod @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) ) ) @ A @ ( none @ ( product_prod @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) ) )
            @ ^ [Y5: A,Ys3: list @ A] : ( some @ ( product_prod @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) ) @ ( product_Pair @ ( list @ A ) @ ( product_prod @ A @ ( list @ A ) ) @ ( takeWhile @ A @ ( comp @ $o @ $o @ A @ (~) @ P3 ) @ Xs3 ) @ ( product_Pair @ A @ ( list @ A ) @ Y5 @ Ys3 ) ) )
            @ ( dropWhile @ A @ ( comp @ $o @ $o @ A @ (~) @ P3 ) @ Xs3 ) ) ) ) ).

% extract_def
thf(fact_7853_transpose__aux__filter__head,axiom,
    ! [A: $tType,Xss: list @ ( list @ A )] :
      ( ( concat @ A
        @ ( map @ ( list @ A ) @ ( list @ A )
          @ ( case_list @ ( list @ A ) @ A @ ( nil @ A )
            @ ^ [H: A,T3: list @ A] : ( cons @ A @ H @ ( nil @ A ) ) )
          @ Xss ) )
      = ( map @ ( list @ A ) @ A @ ( hd @ A )
        @ ( filter2 @ ( list @ A )
          @ ^ [Ys3: list @ A] :
              ( Ys3
             != ( nil @ A ) )
          @ Xss ) ) ) ).

% transpose_aux_filter_head
thf(fact_7854_dropWhile__idem,axiom,
    ! [A: $tType,P: A > $o,Xs: list @ A] :
      ( ( dropWhile @ A @ P @ ( dropWhile @ A @ P @ Xs ) )
      = ( dropWhile @ A @ P @ Xs ) ) ).

% dropWhile_idem
thf(fact_7855_hd__upt,axiom,
    ! [I3: nat,J: nat] :
      ( ( ord_less @ nat @ I3 @ J )
     => ( ( hd @ nat @ ( upt @ I3 @ J ) )
        = I3 ) ) ).

% hd_upt
thf(fact_7856_hd__remdups__adj,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( hd @ A @ ( remdups_adj @ A @ Xs ) )
      = ( hd @ A @ Xs ) ) ).

% hd_remdups_adj
thf(fact_7857_hd__append2,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A] :
      ( ( Xs
       != ( nil @ A ) )
     => ( ( hd @ A @ ( append @ A @ Xs @ Ys ) )
        = ( hd @ A @ Xs ) ) ) ).

% hd_append2
thf(fact_7858_dropWhile__eq__Nil__conv,axiom,
    ! [A: $tType,P: A > $o,Xs: list @ A] :
      ( ( ( dropWhile @ A @ P @ Xs )
        = ( nil @ A ) )
      = ( ! [X5: A] :
            ( ( member @ A @ X5 @ ( set2 @ A @ Xs ) )
           => ( P @ X5 ) ) ) ) ).

% dropWhile_eq_Nil_conv
thf(fact_7859_dropWhile__append1,axiom,
    ! [A: $tType,X2: A,Xs: list @ A,P: A > $o,Ys: list @ A] :
      ( ( member @ A @ X2 @ ( set2 @ A @ Xs ) )
     => ( ~ ( P @ X2 )
       => ( ( dropWhile @ A @ P @ ( append @ A @ Xs @ Ys ) )
          = ( append @ A @ ( dropWhile @ A @ P @ Xs ) @ Ys ) ) ) ) ).

% dropWhile_append1
thf(fact_7860_dropWhile__append2,axiom,
    ! [A: $tType,Xs: list @ A,P: A > $o,Ys: list @ A] :
      ( ! [X3: A] :
          ( ( member @ A @ X3 @ ( set2 @ A @ Xs ) )
         => ( P @ X3 ) )
     => ( ( dropWhile @ A @ P @ ( append @ A @ Xs @ Ys ) )
        = ( dropWhile @ A @ P @ Ys ) ) ) ).

% dropWhile_append2
thf(fact_7861_hd__replicate,axiom,
    ! [A: $tType,N2: nat,X2: A] :
      ( ( N2
       != ( zero_zero @ nat ) )
     => ( ( hd @ A @ ( replicate @ A @ N2 @ X2 ) )
        = X2 ) ) ).

% hd_replicate
thf(fact_7862_dropWhile__replicate,axiom,
    ! [A: $tType,P: A > $o,X2: A,N2: nat] :
      ( ( ( P @ X2 )
       => ( ( dropWhile @ A @ P @ ( replicate @ A @ N2 @ X2 ) )
          = ( nil @ A ) ) )
      & ( ~ ( P @ X2 )
       => ( ( dropWhile @ A @ P @ ( replicate @ A @ N2 @ X2 ) )
          = ( replicate @ A @ N2 @ X2 ) ) ) ) ).

% dropWhile_replicate
thf(fact_7863_takeWhile__dropWhile__id,axiom,
    ! [A: $tType,P: A > $o,Xs: list @ A] :
      ( ( append @ A @ ( takeWhile @ A @ P @ Xs ) @ ( dropWhile @ A @ P @ Xs ) )
      = Xs ) ).

% takeWhile_dropWhile_id
thf(fact_7864_list_Ocollapse,axiom,
    ! [A: $tType,List: list @ A] :
      ( ( List
       != ( nil @ A ) )
     => ( ( cons @ A @ ( hd @ A @ List ) @ ( tl @ A @ List ) )
        = List ) ) ).

% list.collapse
thf(fact_7865_hd__Cons__tl,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( Xs
       != ( nil @ A ) )
     => ( ( cons @ A @ ( hd @ A @ Xs ) @ ( tl @ A @ Xs ) )
        = Xs ) ) ).

% hd_Cons_tl
thf(fact_7866_takeWhile__eq__Nil__iff,axiom,
    ! [A: $tType,P: A > $o,Xs: list @ A] :
      ( ( ( takeWhile @ A @ P @ Xs )
        = ( nil @ A ) )
      = ( ( Xs
          = ( nil @ A ) )
        | ~ ( P @ ( hd @ A @ Xs ) ) ) ) ).

% takeWhile_eq_Nil_iff
thf(fact_7867_tl__remdups__adj,axiom,
    ! [A: $tType,Ys: list @ A] :
      ( ( Ys
       != ( nil @ A ) )
     => ( ( tl @ A @ ( remdups_adj @ A @ Ys ) )
        = ( remdups_adj @ A
          @ ( dropWhile @ A
            @ ^ [X5: A] :
                ( X5
                = ( hd @ A @ Ys ) )
            @ ( tl @ A @ Ys ) ) ) ) ) ).

% tl_remdups_adj
thf(fact_7868_list_Oexpand,axiom,
    ! [A: $tType,List: list @ A,List2: list @ A] :
      ( ( ( List
          = ( nil @ A ) )
        = ( List2
          = ( nil @ A ) ) )
     => ( ( ( List
           != ( nil @ A ) )
         => ( ( List2
             != ( nil @ A ) )
           => ( ( ( hd @ A @ List )
                = ( hd @ A @ List2 ) )
              & ( ( tl @ A @ List )
                = ( tl @ A @ List2 ) ) ) ) )
       => ( List = List2 ) ) ) ).

% list.expand
thf(fact_7869_list_Oexhaust__sel,axiom,
    ! [A: $tType,List: list @ A] :
      ( ( List
       != ( nil @ A ) )
     => ( List
        = ( cons @ A @ ( hd @ A @ List ) @ ( tl @ A @ List ) ) ) ) ).

% list.exhaust_sel
thf(fact_7870_list_Omap__sel_I1_J,axiom,
    ! [B: $tType,A: $tType,A2: list @ A,F2: A > B] :
      ( ( A2
       != ( nil @ A ) )
     => ( ( hd @ B @ ( map @ A @ B @ F2 @ A2 ) )
        = ( F2 @ ( hd @ A @ A2 ) ) ) ) ).

% list.map_sel(1)
thf(fact_7871_hd__map,axiom,
    ! [B: $tType,A: $tType,Xs: list @ A,F2: A > B] :
      ( ( Xs
       != ( nil @ A ) )
     => ( ( hd @ B @ ( map @ A @ B @ F2 @ Xs ) )
        = ( F2 @ ( hd @ A @ Xs ) ) ) ) ).

% hd_map
thf(fact_7872_distinct__dropWhile,axiom,
    ! [A: $tType,Xs: list @ A,P: A > $o] :
      ( ( distinct @ A @ Xs )
     => ( distinct @ A @ ( dropWhile @ A @ P @ Xs ) ) ) ).

% distinct_dropWhile
thf(fact_7873_length__dropWhile__le,axiom,
    ! [A: $tType,P: A > $o,Xs: list @ A] : ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ ( dropWhile @ A @ P @ Xs ) ) @ ( size_size @ ( list @ A ) @ Xs ) ) ).

% length_dropWhile_le
thf(fact_7874_hd__in__set,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( Xs
       != ( nil @ A ) )
     => ( member @ A @ ( hd @ A @ Xs ) @ ( set2 @ A @ Xs ) ) ) ).

% hd_in_set
thf(fact_7875_list_Oset__sel_I1_J,axiom,
    ! [A: $tType,A2: list @ A] :
      ( ( A2
       != ( nil @ A ) )
     => ( member @ A @ ( hd @ A @ A2 ) @ ( set2 @ A @ A2 ) ) ) ).

% list.set_sel(1)
thf(fact_7876_dropWhile__cong,axiom,
    ! [A: $tType,L: list @ A,K: list @ A,P: A > $o,Q: A > $o] :
      ( ( L = K )
     => ( ! [X3: A] :
            ( ( member @ A @ X3 @ ( set2 @ A @ L ) )
           => ( ( P @ X3 )
              = ( Q @ X3 ) ) )
       => ( ( dropWhile @ A @ P @ L )
          = ( dropWhile @ A @ Q @ K ) ) ) ) ).

% dropWhile_cong
thf(fact_7877_set__dropWhileD,axiom,
    ! [A: $tType,X2: A,P: A > $o,Xs: list @ A] :
      ( ( member @ A @ X2 @ ( set2 @ A @ ( dropWhile @ A @ P @ Xs ) ) )
     => ( member @ A @ X2 @ ( set2 @ A @ Xs ) ) ) ).

% set_dropWhileD
thf(fact_7878_hd__concat,axiom,
    ! [A: $tType,Xs: list @ ( list @ A )] :
      ( ( Xs
       != ( nil @ ( list @ A ) ) )
     => ( ( ( hd @ ( list @ A ) @ Xs )
         != ( nil @ A ) )
       => ( ( hd @ A @ ( concat @ A @ Xs ) )
          = ( hd @ A @ ( hd @ ( list @ A ) @ Xs ) ) ) ) ) ).

% hd_concat
thf(fact_7879_dropWhile__eq__self__iff,axiom,
    ! [A: $tType,P: A > $o,Xs: list @ A] :
      ( ( ( dropWhile @ A @ P @ Xs )
        = Xs )
      = ( ( Xs
          = ( nil @ A ) )
        | ~ ( P @ ( hd @ A @ Xs ) ) ) ) ).

% dropWhile_eq_self_iff
thf(fact_7880_hd__dropWhile,axiom,
    ! [A: $tType,P: A > $o,Xs: list @ A] :
      ( ( ( dropWhile @ A @ P @ Xs )
       != ( nil @ A ) )
     => ~ ( P @ ( hd @ A @ ( dropWhile @ A @ P @ Xs ) ) ) ) ).

% hd_dropWhile
thf(fact_7881_dropWhile_Osimps_I1_J,axiom,
    ! [A: $tType,P: A > $o] :
      ( ( dropWhile @ A @ P @ ( nil @ A ) )
      = ( nil @ A ) ) ).

% dropWhile.simps(1)
thf(fact_7882_list_Osel_I1_J,axiom,
    ! [A: $tType,X21: A,X222: list @ A] :
      ( ( hd @ A @ ( cons @ A @ X21 @ X222 ) )
      = X21 ) ).

% list.sel(1)
thf(fact_7883_dropWhile_Osimps_I2_J,axiom,
    ! [A: $tType,P: A > $o,X2: A,Xs: list @ A] :
      ( ( ( P @ X2 )
       => ( ( dropWhile @ A @ P @ ( cons @ A @ X2 @ Xs ) )
          = ( dropWhile @ A @ P @ Xs ) ) )
      & ( ~ ( P @ X2 )
       => ( ( dropWhile @ A @ P @ ( cons @ A @ X2 @ Xs ) )
          = ( cons @ A @ X2 @ Xs ) ) ) ) ).

% dropWhile.simps(2)
thf(fact_7884_remdups__adj__Cons_H,axiom,
    ! [A: $tType,X2: A,Xs: list @ A] :
      ( ( remdups_adj @ A @ ( cons @ A @ X2 @ Xs ) )
      = ( cons @ A @ X2
        @ ( remdups_adj @ A
          @ ( dropWhile @ A
            @ ^ [Y5: A] : ( Y5 = X2 )
            @ Xs ) ) ) ) ).

% remdups_adj_Cons'
thf(fact_7885_dropWhile__append3,axiom,
    ! [A: $tType,P: A > $o,Y2: A,Xs: list @ A,Ys: list @ A] :
      ( ~ ( P @ Y2 )
     => ( ( dropWhile @ A @ P @ ( append @ A @ Xs @ ( cons @ A @ Y2 @ Ys ) ) )
        = ( append @ A @ ( dropWhile @ A @ P @ Xs ) @ ( cons @ A @ Y2 @ Ys ) ) ) ) ).

% dropWhile_append3
thf(fact_7886_hd__append,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A] :
      ( ( ( Xs
          = ( nil @ A ) )
       => ( ( hd @ A @ ( append @ A @ Xs @ Ys ) )
          = ( hd @ A @ Ys ) ) )
      & ( ( Xs
         != ( nil @ A ) )
       => ( ( hd @ A @ ( append @ A @ Xs @ Ys ) )
          = ( hd @ A @ Xs ) ) ) ) ).

% hd_append
thf(fact_7887_longest__common__prefix,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A] :
    ? [Ps2: list @ A,Xs4: list @ A,Ys5: list @ A] :
      ( ( Xs
        = ( append @ A @ Ps2 @ Xs4 ) )
      & ( Ys
        = ( append @ A @ Ps2 @ Ys5 ) )
      & ( ( Xs4
          = ( nil @ A ) )
        | ( Ys5
          = ( nil @ A ) )
        | ( ( hd @ A @ Xs4 )
         != ( hd @ A @ Ys5 ) ) ) ) ).

% longest_common_prefix
thf(fact_7888_hd__conv__nth,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( Xs
       != ( nil @ A ) )
     => ( ( hd @ A @ Xs )
        = ( nth @ A @ Xs @ ( zero_zero @ nat ) ) ) ) ).

% hd_conv_nth
thf(fact_7889_sorted__dropWhile,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A,P: A > $o] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs )
         => ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( dropWhile @ A @ P @ Xs ) ) ) ) ).

% sorted_dropWhile
thf(fact_7890_dropWhile__map,axiom,
    ! [A: $tType,B: $tType,P: A > $o,F2: B > A,Xs: list @ B] :
      ( ( dropWhile @ A @ P @ ( map @ B @ A @ F2 @ Xs ) )
      = ( map @ B @ A @ F2 @ ( dropWhile @ B @ ( comp @ A @ $o @ B @ P @ F2 ) @ Xs ) ) ) ).

% dropWhile_map
thf(fact_7891_dropWhile__eq__Cons__conv,axiom,
    ! [A: $tType,P: A > $o,Xs: list @ A,Y2: A,Ys: list @ A] :
      ( ( ( dropWhile @ A @ P @ Xs )
        = ( cons @ A @ Y2 @ Ys ) )
      = ( ( Xs
          = ( append @ A @ ( takeWhile @ A @ P @ Xs ) @ ( cons @ A @ Y2 @ Ys ) ) )
        & ~ ( P @ Y2 ) ) ) ).

% dropWhile_eq_Cons_conv
thf(fact_7892_takeWhile__eq__filter,axiom,
    ! [A: $tType,P: A > $o,Xs: list @ A] :
      ( ! [X3: A] :
          ( ( member @ A @ X3 @ ( set2 @ A @ ( dropWhile @ A @ P @ Xs ) ) )
         => ~ ( P @ X3 ) )
     => ( ( takeWhile @ A @ P @ Xs )
        = ( filter2 @ A @ P @ Xs ) ) ) ).

% takeWhile_eq_filter
thf(fact_7893_list_Ocase__eq__if,axiom,
    ! [A: $tType,B: $tType] :
      ( ( case_list @ B @ A )
      = ( ^ [F12: B,F23: A > ( list @ A ) > B,List3: list @ A] :
            ( if @ B
            @ ( List3
              = ( nil @ A ) )
            @ F12
            @ ( F23 @ ( hd @ A @ List3 ) @ ( tl @ A @ List3 ) ) ) ) ) ).

% list.case_eq_if
thf(fact_7894_dropWhile__append,axiom,
    ! [A: $tType,Xs: list @ A,P: A > $o,Ys: list @ A] :
      ( ( ! [X3: A] :
            ( ( member @ A @ X3 @ ( set2 @ A @ Xs ) )
           => ( P @ X3 ) )
       => ( ( dropWhile @ A @ P @ ( append @ A @ Xs @ Ys ) )
          = ( dropWhile @ A @ P @ Ys ) ) )
      & ( ~ ! [X: A] :
              ( ( member @ A @ X @ ( set2 @ A @ Xs ) )
             => ( P @ X ) )
       => ( ( dropWhile @ A @ P @ ( append @ A @ Xs @ Ys ) )
          = ( append @ A @ ( dropWhile @ A @ P @ Xs ) @ Ys ) ) ) ) ).

% dropWhile_append
thf(fact_7895_Cons__in__shuffles__iff,axiom,
    ! [A: $tType,Z: A,Zs: list @ A,Xs: list @ A,Ys: list @ A] :
      ( ( member @ ( list @ A ) @ ( cons @ A @ Z @ Zs ) @ ( shuffles @ A @ Xs @ Ys ) )
      = ( ( ( Xs
           != ( nil @ A ) )
          & ( ( hd @ A @ Xs )
            = Z )
          & ( member @ ( list @ A ) @ Zs @ ( shuffles @ A @ ( tl @ A @ Xs ) @ Ys ) ) )
        | ( ( Ys
           != ( nil @ A ) )
          & ( ( hd @ A @ Ys )
            = Z )
          & ( member @ ( list @ A ) @ Zs @ ( shuffles @ A @ Xs @ ( tl @ A @ Ys ) ) ) ) ) ) ).

% Cons_in_shuffles_iff
thf(fact_7896_list_Osplit__sel__asm,axiom,
    ! [B: $tType,A: $tType,P: B > $o,F1: B,F22: A > ( list @ A ) > B,List: list @ A] :
      ( ( P @ ( case_list @ B @ A @ F1 @ F22 @ List ) )
      = ( ~ ( ( ( List
                = ( nil @ A ) )
              & ~ ( P @ F1 ) )
            | ( ( List
                = ( cons @ A @ ( hd @ A @ List ) @ ( tl @ A @ List ) ) )
              & ~ ( P @ ( F22 @ ( hd @ A @ List ) @ ( tl @ A @ List ) ) ) ) ) ) ) ).

% list.split_sel_asm
thf(fact_7897_list_Osplit__sel,axiom,
    ! [B: $tType,A: $tType,P: B > $o,F1: B,F22: A > ( list @ A ) > B,List: list @ A] :
      ( ( P @ ( case_list @ B @ A @ F1 @ F22 @ List ) )
      = ( ( ( List
            = ( nil @ A ) )
         => ( P @ F1 ) )
        & ( ( List
            = ( cons @ A @ ( hd @ A @ List ) @ ( tl @ A @ List ) ) )
         => ( P @ ( F22 @ ( hd @ A @ List ) @ ( tl @ A @ List ) ) ) ) ) ) ).

% list.split_sel
thf(fact_7898_remdups__adj__append__dropWhile,axiom,
    ! [A: $tType,Xs: list @ A,Y2: A,Ys: list @ A] :
      ( ( remdups_adj @ A @ ( append @ A @ Xs @ ( cons @ A @ Y2 @ Ys ) ) )
      = ( append @ A @ ( remdups_adj @ A @ ( append @ A @ Xs @ ( cons @ A @ Y2 @ ( nil @ A ) ) ) )
        @ ( remdups_adj @ A
          @ ( dropWhile @ A
            @ ^ [X5: A] : ( X5 = Y2 )
            @ Ys ) ) ) ) ).

% remdups_adj_append_dropWhile
thf(fact_7899_dropWhile__nth,axiom,
    ! [A: $tType,J: nat,P: A > $o,Xs: list @ A] :
      ( ( ord_less @ nat @ J @ ( size_size @ ( list @ A ) @ ( dropWhile @ A @ P @ Xs ) ) )
     => ( ( nth @ A @ ( dropWhile @ A @ P @ Xs ) @ J )
        = ( nth @ A @ Xs @ ( plus_plus @ nat @ J @ ( size_size @ ( list @ A ) @ ( takeWhile @ A @ P @ Xs ) ) ) ) ) ) ).

% dropWhile_nth
thf(fact_7900_rotate1__hd__tl,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( Xs
       != ( nil @ A ) )
     => ( ( rotate1 @ A @ Xs )
        = ( append @ A @ ( tl @ A @ Xs ) @ ( cons @ A @ ( hd @ A @ Xs ) @ ( nil @ A ) ) ) ) ) ).

% rotate1_hd_tl
thf(fact_7901_dropWhile__neq__rev,axiom,
    ! [A: $tType,Xs: list @ A,X2: A] :
      ( ( distinct @ A @ Xs )
     => ( ( member @ A @ X2 @ ( set2 @ A @ Xs ) )
       => ( ( dropWhile @ A
            @ ^ [Y5: A] : ( Y5 != X2 )
            @ ( rev @ A @ Xs ) )
          = ( cons @ A @ X2
            @ ( rev @ A
              @ ( takeWhile @ A
                @ ^ [Y5: A] : ( Y5 != X2 )
                @ Xs ) ) ) ) ) ) ).

% dropWhile_neq_rev
thf(fact_7902_takeWhile__neq__rev,axiom,
    ! [A: $tType,Xs: list @ A,X2: A] :
      ( ( distinct @ A @ Xs )
     => ( ( member @ A @ X2 @ ( set2 @ A @ Xs ) )
       => ( ( takeWhile @ A
            @ ^ [Y5: A] : ( Y5 != X2 )
            @ ( rev @ A @ Xs ) )
          = ( rev @ A
            @ ( tl @ A
              @ ( dropWhile @ A
                @ ^ [Y5: A] : ( Y5 != X2 )
                @ Xs ) ) ) ) ) ) ).

% takeWhile_neq_rev
thf(fact_7903_remdups__adj__singleton__iff,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( ( size_size @ ( list @ A ) @ ( remdups_adj @ A @ Xs ) )
        = ( suc @ ( zero_zero @ nat ) ) )
      = ( ( Xs
         != ( nil @ A ) )
        & ( Xs
          = ( replicate @ A @ ( size_size @ ( list @ A ) @ Xs ) @ ( hd @ A @ Xs ) ) ) ) ) ).

% remdups_adj_singleton_iff
thf(fact_7904_Nitpick_Osize__list__simp_I1_J,axiom,
    ! [A: $tType] :
      ( ( size_list @ A )
      = ( ^ [F5: A > nat,Xs3: list @ A] :
            ( if @ nat
            @ ( Xs3
              = ( nil @ A ) )
            @ ( zero_zero @ nat )
            @ ( suc @ ( plus_plus @ nat @ ( F5 @ ( hd @ A @ Xs3 ) ) @ ( size_list @ A @ F5 @ ( tl @ A @ Xs3 ) ) ) ) ) ) ) ).

% Nitpick.size_list_simp(1)
thf(fact_7905_insort__key__remove1,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [A2: B,Xs: list @ B,F2: B > A] :
          ( ( member @ B @ A2 @ ( set2 @ B @ Xs ) )
         => ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( map @ B @ A @ F2 @ Xs ) )
           => ( ( ( hd @ B
                  @ ( filter2 @ B
                    @ ^ [X5: B] :
                        ( ( F2 @ A2 )
                        = ( F2 @ X5 ) )
                    @ Xs ) )
                = A2 )
             => ( ( linorder_insort_key @ B @ A @ F2 @ A2 @ ( remove1 @ B @ A2 @ Xs ) )
                = Xs ) ) ) ) ) ).

% insort_key_remove1
thf(fact_7906_find__dropWhile,axiom,
    ! [A: $tType] :
      ( ( find @ A )
      = ( ^ [P3: A > $o,Xs3: list @ A] :
            ( case_list @ ( option @ A ) @ A @ ( none @ A )
            @ ^ [X5: A,Xa4: list @ A] : ( some @ A @ X5 )
            @ ( dropWhile @ A @ ( comp @ $o @ $o @ A @ (~) @ P3 ) @ Xs3 ) ) ) ) ).

% find_dropWhile
thf(fact_7907_partition__filter__conv,axiom,
    ! [A: $tType] :
      ( ( partition @ A )
      = ( ^ [F5: A > $o,Xs3: list @ A] : ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( filter2 @ A @ F5 @ Xs3 ) @ ( filter2 @ A @ ( comp @ $o @ $o @ A @ (~) @ F5 ) @ Xs3 ) ) ) ) ).

% partition_filter_conv
thf(fact_7908_find__cong,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A,P: A > $o,Q: A > $o] :
      ( ( Xs = Ys )
     => ( ! [X3: A] :
            ( ( member @ A @ X3 @ ( set2 @ A @ Ys ) )
           => ( ( P @ X3 )
              = ( Q @ X3 ) ) )
       => ( ( find @ A @ P @ Xs )
          = ( find @ A @ Q @ Ys ) ) ) ) ).

% find_cong
thf(fact_7909_partition__filter1,axiom,
    ! [A: $tType,P: A > $o,Xs: list @ A] :
      ( ( product_fst @ ( list @ A ) @ ( list @ A ) @ ( partition @ A @ P @ Xs ) )
      = ( filter2 @ A @ P @ Xs ) ) ).

% partition_filter1
thf(fact_7910_find_Osimps_I2_J,axiom,
    ! [A: $tType,P: A > $o,X2: A,Xs: list @ A] :
      ( ( ( P @ X2 )
       => ( ( find @ A @ P @ ( cons @ A @ X2 @ Xs ) )
          = ( some @ A @ X2 ) ) )
      & ( ~ ( P @ X2 )
       => ( ( find @ A @ P @ ( cons @ A @ X2 @ Xs ) )
          = ( find @ A @ P @ Xs ) ) ) ) ).

% find.simps(2)
thf(fact_7911_find_Osimps_I1_J,axiom,
    ! [A: $tType,Uu2: A > $o] :
      ( ( find @ A @ Uu2 @ ( nil @ A ) )
      = ( none @ A ) ) ).

% find.simps(1)
thf(fact_7912_find__None__iff,axiom,
    ! [A: $tType,P: A > $o,Xs: list @ A] :
      ( ( ( find @ A @ P @ Xs )
        = ( none @ A ) )
      = ( ~ ? [X5: A] :
              ( ( member @ A @ X5 @ ( set2 @ A @ Xs ) )
              & ( P @ X5 ) ) ) ) ).

% find_None_iff
thf(fact_7913_find__None__iff2,axiom,
    ! [A: $tType,P: A > $o,Xs: list @ A] :
      ( ( ( none @ A )
        = ( find @ A @ P @ Xs ) )
      = ( ~ ? [X5: A] :
              ( ( member @ A @ X5 @ ( set2 @ A @ Xs ) )
              & ( P @ X5 ) ) ) ) ).

% find_None_iff2
thf(fact_7914_partition_Osimps_I1_J,axiom,
    ! [A: $tType,P: A > $o] :
      ( ( partition @ A @ P @ ( nil @ A ) )
      = ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( nil @ A ) @ ( nil @ A ) ) ) ).

% partition.simps(1)
thf(fact_7915_partition__P,axiom,
    ! [A: $tType,P: A > $o,Xs: list @ A,Yes: list @ A,No4: list @ A] :
      ( ( ( partition @ A @ P @ Xs )
        = ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Yes @ No4 ) )
     => ( ! [X: A] :
            ( ( member @ A @ X @ ( set2 @ A @ Yes ) )
           => ( P @ X ) )
        & ! [X: A] :
            ( ( member @ A @ X @ ( set2 @ A @ No4 ) )
           => ~ ( P @ X ) ) ) ) ).

% partition_P
thf(fact_7916_partition_Osimps_I2_J,axiom,
    ! [A: $tType,P: A > $o,X2: A,Xs: list @ A] :
      ( ( partition @ A @ P @ ( cons @ A @ X2 @ Xs ) )
      = ( product_case_prod @ ( list @ A ) @ ( list @ A ) @ ( product_prod @ ( list @ A ) @ ( list @ A ) )
        @ ^ [Yes2: list @ A,No3: list @ A] : ( if @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( P @ X2 ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X2 @ Yes2 ) @ No3 ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Yes2 @ ( cons @ A @ X2 @ No3 ) ) )
        @ ( partition @ A @ P @ Xs ) ) ) ).

% partition.simps(2)
thf(fact_7917_partition__filter2,axiom,
    ! [A: $tType,P: A > $o,Xs: list @ A] :
      ( ( product_snd @ ( list @ A ) @ ( list @ A ) @ ( partition @ A @ P @ Xs ) )
      = ( filter2 @ A @ ( comp @ $o @ $o @ A @ (~) @ P ) @ Xs ) ) ).

% partition_filter2
thf(fact_7918_partition__set,axiom,
    ! [A: $tType,P: A > $o,Xs: list @ A,Yes: list @ A,No4: list @ A] :
      ( ( ( partition @ A @ P @ Xs )
        = ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Yes @ No4 ) )
     => ( ( sup_sup @ ( set @ A ) @ ( set2 @ A @ Yes ) @ ( set2 @ A @ No4 ) )
        = ( set2 @ A @ Xs ) ) ) ).

% partition_set
thf(fact_7919_find__Some__iff2,axiom,
    ! [A: $tType,X2: A,P: A > $o,Xs: list @ A] :
      ( ( ( some @ A @ X2 )
        = ( find @ A @ P @ Xs ) )
      = ( ? [I4: nat] :
            ( ( ord_less @ nat @ I4 @ ( size_size @ ( list @ A ) @ Xs ) )
            & ( P @ ( nth @ A @ Xs @ I4 ) )
            & ( X2
              = ( nth @ A @ Xs @ I4 ) )
            & ! [J3: nat] :
                ( ( ord_less @ nat @ J3 @ I4 )
               => ~ ( P @ ( nth @ A @ Xs @ J3 ) ) ) ) ) ) ).

% find_Some_iff2
thf(fact_7920_find__Some__iff,axiom,
    ! [A: $tType,P: A > $o,Xs: list @ A,X2: A] :
      ( ( ( find @ A @ P @ Xs )
        = ( some @ A @ X2 ) )
      = ( ? [I4: nat] :
            ( ( ord_less @ nat @ I4 @ ( size_size @ ( list @ A ) @ Xs ) )
            & ( P @ ( nth @ A @ Xs @ I4 ) )
            & ( X2
              = ( nth @ A @ Xs @ I4 ) )
            & ! [J3: nat] :
                ( ( ord_less @ nat @ J3 @ I4 )
               => ~ ( P @ ( nth @ A @ Xs @ J3 ) ) ) ) ) ) ).

% find_Some_iff
thf(fact_7921_graph__map__upd,axiom,
    ! [A: $tType,B: $tType,M: A > ( option @ B ),K: A,V: B] :
      ( ( graph @ A @ B @ ( fun_upd @ A @ ( option @ B ) @ M @ K @ ( some @ B @ V ) ) )
      = ( insert @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ K @ V ) @ ( graph @ A @ B @ ( fun_upd @ A @ ( option @ B ) @ M @ K @ ( none @ B ) ) ) ) ) ).

% graph_map_upd
thf(fact_7922_map__filter__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( map_filter @ A @ B )
      = ( ^ [F5: A > ( option @ B ),Xs3: list @ A] :
            ( map @ A @ B @ ( comp @ ( option @ B ) @ B @ A @ ( the2 @ B ) @ F5 )
            @ ( filter2 @ A
              @ ^ [X5: A] :
                  ( ( F5 @ X5 )
                 != ( none @ B ) )
              @ Xs3 ) ) ) ) ).

% map_filter_def
thf(fact_7923_option_Ocollapse,axiom,
    ! [A: $tType,Option: option @ A] :
      ( ( Option
       != ( none @ A ) )
     => ( ( some @ A @ ( the2 @ A @ Option ) )
        = Option ) ) ).

% option.collapse
thf(fact_7924_graph__empty,axiom,
    ! [B: $tType,A: $tType] :
      ( ( graph @ A @ B
        @ ^ [X5: A] : ( none @ B ) )
      = ( bot_bot @ ( set @ ( product_prod @ A @ B ) ) ) ) ).

% graph_empty
thf(fact_7925_option_Ocase__eq__if,axiom,
    ! [A: $tType,B: $tType] :
      ( ( case_option @ B @ A )
      = ( ^ [F12: B,F23: A > B,Option2: option @ A] :
            ( if @ B
            @ ( Option2
              = ( none @ A ) )
            @ F12
            @ ( F23 @ ( the2 @ A @ Option2 ) ) ) ) ) ).

% option.case_eq_if
thf(fact_7926_Option_Othese__def,axiom,
    ! [A: $tType] :
      ( ( these @ A )
      = ( ^ [A7: set @ ( option @ A )] :
            ( image @ ( option @ A ) @ A @ ( the2 @ A )
            @ ( collect @ ( option @ A )
              @ ^ [X5: option @ A] :
                  ( ( member @ ( option @ A ) @ X5 @ A7 )
                  & ( X5
                   != ( none @ A ) ) ) ) ) ) ) ).

% Option.these_def
thf(fact_7927_in__graphI,axiom,
    ! [A: $tType,B: $tType,M: B > ( option @ A ),K: B,V: A] :
      ( ( ( M @ K )
        = ( some @ A @ V ) )
     => ( member @ ( product_prod @ B @ A ) @ ( product_Pair @ B @ A @ K @ V ) @ ( graph @ B @ A @ M ) ) ) ).

% in_graphI
thf(fact_7928_in__graphD,axiom,
    ! [A: $tType,B: $tType,K: A,V: B,M: A > ( option @ B )] :
      ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ K @ V ) @ ( graph @ A @ B @ M ) )
     => ( ( M @ K )
        = ( some @ B @ V ) ) ) ).

% in_graphD
thf(fact_7929_option_Oexpand,axiom,
    ! [A: $tType,Option: option @ A,Option3: option @ A] :
      ( ( ( Option
          = ( none @ A ) )
        = ( Option3
          = ( none @ A ) ) )
     => ( ( ( Option
           != ( none @ A ) )
         => ( ( Option3
             != ( none @ A ) )
           => ( ( the2 @ A @ Option )
              = ( the2 @ A @ Option3 ) ) ) )
       => ( Option = Option3 ) ) ) ).

% option.expand
thf(fact_7930_option_Osel,axiom,
    ! [A: $tType,X22: A] :
      ( ( the2 @ A @ ( some @ A @ X22 ) )
      = X22 ) ).

% option.sel
thf(fact_7931_option_Oexhaust__sel,axiom,
    ! [A: $tType,Option: option @ A] :
      ( ( Option
       != ( none @ A ) )
     => ( Option
        = ( some @ A @ ( the2 @ A @ Option ) ) ) ) ).

% option.exhaust_sel
thf(fact_7932_option_Omap__sel,axiom,
    ! [B: $tType,A: $tType,A2: option @ A,F2: A > B] :
      ( ( A2
       != ( none @ A ) )
     => ( ( the2 @ B @ ( map_option @ A @ B @ F2 @ A2 ) )
        = ( F2 @ ( the2 @ A @ A2 ) ) ) ) ).

% option.map_sel
thf(fact_7933_graph__restrictD_I1_J,axiom,
    ! [B: $tType,A: $tType,K: A,V: B,M: A > ( option @ B ),A3: set @ A] :
      ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ K @ V ) @ ( graph @ A @ B @ ( restrict_map @ A @ B @ M @ A3 ) ) )
     => ( member @ A @ K @ A3 ) ) ).

% graph_restrictD(1)
thf(fact_7934_option_Osplit__sel,axiom,
    ! [B: $tType,A: $tType,P: B > $o,F1: B,F22: A > B,Option: option @ A] :
      ( ( P @ ( case_option @ B @ A @ F1 @ F22 @ Option ) )
      = ( ( ( Option
            = ( none @ A ) )
         => ( P @ F1 ) )
        & ( ( Option
            = ( some @ A @ ( the2 @ A @ Option ) ) )
         => ( P @ ( F22 @ ( the2 @ A @ Option ) ) ) ) ) ) ).

% option.split_sel
thf(fact_7935_option_Osplit__sel__asm,axiom,
    ! [B: $tType,A: $tType,P: B > $o,F1: B,F22: A > B,Option: option @ A] :
      ( ( P @ ( case_option @ B @ A @ F1 @ F22 @ Option ) )
      = ( ~ ( ( ( Option
                = ( none @ A ) )
              & ~ ( P @ F1 ) )
            | ( ( Option
                = ( some @ A @ ( the2 @ A @ Option ) ) )
              & ~ ( P @ ( F22 @ ( the2 @ A @ Option ) ) ) ) ) ) ) ).

% option.split_sel_asm
thf(fact_7936_graph__restrictD_I2_J,axiom,
    ! [A: $tType,B: $tType,K: A,V: B,M: A > ( option @ B ),A3: set @ A] :
      ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ K @ V ) @ ( graph @ A @ B @ ( restrict_map @ A @ B @ M @ A3 ) ) )
     => ( ( M @ K )
        = ( some @ B @ V ) ) ) ).

% graph_restrictD(2)
thf(fact_7937_graph__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( graph @ A @ B )
      = ( ^ [M6: A > ( option @ B )] :
            ( collect @ ( product_prod @ A @ B )
            @ ^ [Uu3: product_prod @ A @ B] :
              ? [A4: A,B4: B] :
                ( ( Uu3
                  = ( product_Pair @ A @ B @ A4 @ B4 ) )
                & ( ( M6 @ A4 )
                  = ( some @ B @ B4 ) ) ) ) ) ) ).

% graph_def
thf(fact_7938_graph__fun__upd__None,axiom,
    ! [B: $tType,A: $tType,M: A > ( option @ B ),K: A] :
      ( ( graph @ A @ B @ ( fun_upd @ A @ ( option @ B ) @ M @ K @ ( none @ B ) ) )
      = ( collect @ ( product_prod @ A @ B )
        @ ^ [E4: product_prod @ A @ B] :
            ( ( member @ ( product_prod @ A @ B ) @ E4 @ ( graph @ A @ B @ M ) )
            & ( ( product_fst @ A @ B @ E4 )
             != K ) ) ) ) ).

% graph_fun_upd_None
thf(fact_7939_ran__map__upd,axiom,
    ! [A: $tType,B: $tType,M: B > ( option @ A ),A2: B,B2: A] :
      ( ( ( M @ A2 )
        = ( none @ A ) )
     => ( ( ran @ B @ A @ ( fun_upd @ B @ ( option @ A ) @ M @ A2 @ ( some @ A @ B2 ) ) )
        = ( insert @ A @ B2 @ ( ran @ B @ A @ M ) ) ) ) ).

% ran_map_upd
thf(fact_7940_comp__fun__commute__on_Ofold__set__union__disj,axiom,
    ! [B: $tType,A: $tType,S3: set @ A,F2: A > B > B,A3: set @ A,B3: set @ A,Z: B] :
      ( ( finite4664212375090638736ute_on @ A @ B @ S3 @ F2 )
     => ( ( ord_less_eq @ ( set @ A ) @ A3 @ S3 )
       => ( ( ord_less_eq @ ( set @ A ) @ B3 @ S3 )
         => ( ( finite_finite @ A @ A3 )
           => ( ( finite_finite @ A @ B3 )
             => ( ( ( inf_inf @ ( set @ A ) @ A3 @ B3 )
                  = ( bot_bot @ ( set @ A ) ) )
               => ( ( finite_fold @ A @ B @ F2 @ Z @ ( sup_sup @ ( set @ A ) @ A3 @ B3 ) )
                  = ( finite_fold @ A @ B @ F2 @ ( finite_fold @ A @ B @ F2 @ Z @ A3 ) @ B3 ) ) ) ) ) ) ) ) ).

% comp_fun_commute_on.fold_set_union_disj
thf(fact_7941_ran__empty,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ran @ B @ A
        @ ^ [X5: B] : ( none @ A ) )
      = ( bot_bot @ ( set @ A ) ) ) ).

% ran_empty
thf(fact_7942_ran__restrictD,axiom,
    ! [B: $tType,A: $tType,Y2: A,M: B > ( option @ A ),A3: set @ B] :
      ( ( member @ A @ Y2 @ ( ran @ B @ A @ ( restrict_map @ B @ A @ M @ A3 ) ) )
     => ? [X3: B] :
          ( ( member @ B @ X3 @ A3 )
          & ( ( M @ X3 )
            = ( some @ A @ Y2 ) ) ) ) ).

% ran_restrictD
thf(fact_7943_ranI,axiom,
    ! [A: $tType,B: $tType,M: B > ( option @ A ),A2: B,B2: A] :
      ( ( ( M @ A2 )
        = ( some @ A @ B2 ) )
     => ( member @ A @ B2 @ ( ran @ B @ A @ M ) ) ) ).

% ranI
thf(fact_7944_ran__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ran @ A @ B )
      = ( ^ [M6: A > ( option @ B )] :
            ( collect @ B
            @ ^ [B4: B] :
              ? [A4: A] :
                ( ( M6 @ A4 )
                = ( some @ B @ B4 ) ) ) ) ) ).

% ran_def
thf(fact_7945_Finite__Set_Ofold__cong,axiom,
    ! [B: $tType,A: $tType,S3: set @ A,F2: A > B > B,G: A > B > B,A3: set @ A,S2: B,T2: B,B3: set @ A] :
      ( ( finite4664212375090638736ute_on @ A @ B @ S3 @ F2 )
     => ( ( finite4664212375090638736ute_on @ A @ B @ S3 @ G )
       => ( ( ord_less_eq @ ( set @ A ) @ A3 @ S3 )
         => ( ( finite_finite @ A @ A3 )
           => ( ! [X3: A] :
                  ( ( member @ A @ X3 @ A3 )
                 => ( ( F2 @ X3 )
                    = ( G @ X3 ) ) )
             => ( ( S2 = T2 )
               => ( ( A3 = B3 )
                 => ( ( finite_fold @ A @ B @ F2 @ S2 @ A3 )
                    = ( finite_fold @ A @ B @ G @ T2 @ B3 ) ) ) ) ) ) ) ) ) ).

% Finite_Set.fold_cong
thf(fact_7946_comp__fun__commute__on_Ocomp__comp__fun__commute__on,axiom,
    ! [B: $tType,A: $tType,C: $tType,S3: set @ A,F2: A > B > B,G: C > A,R: set @ C] :
      ( ( finite4664212375090638736ute_on @ A @ B @ S3 @ F2 )
     => ( ( ord_less_eq @ ( set @ A ) @ ( image @ C @ A @ G @ ( top_top @ ( set @ C ) ) ) @ S3 )
       => ( finite4664212375090638736ute_on @ C @ B @ R @ ( comp @ A @ ( B > B ) @ C @ F2 @ G ) ) ) ) ).

% comp_fun_commute_on.comp_comp_fun_commute_on
thf(fact_7947_comp__fun__commute__on_Ofold__fun__left__comm,axiom,
    ! [B: $tType,A: $tType,S3: set @ A,F2: A > B > B,X2: A,A3: set @ A,Z: B] :
      ( ( finite4664212375090638736ute_on @ A @ B @ S3 @ F2 )
     => ( ( ord_less_eq @ ( set @ A ) @ ( insert @ A @ X2 @ A3 ) @ S3 )
       => ( ( finite_finite @ A @ A3 )
         => ( ( F2 @ X2 @ ( finite_fold @ A @ B @ F2 @ Z @ A3 ) )
            = ( finite_fold @ A @ B @ F2 @ ( F2 @ X2 @ Z ) @ A3 ) ) ) ) ) ).

% comp_fun_commute_on.fold_fun_left_comm
thf(fact_7948_comp__fun__commute__on_Ofold__insert2,axiom,
    ! [B: $tType,A: $tType,S3: set @ A,F2: A > B > B,X2: A,A3: set @ A,Z: B] :
      ( ( finite4664212375090638736ute_on @ A @ B @ S3 @ F2 )
     => ( ( ord_less_eq @ ( set @ A ) @ ( insert @ A @ X2 @ A3 ) @ S3 )
       => ( ( finite_finite @ A @ A3 )
         => ( ~ ( member @ A @ X2 @ A3 )
           => ( ( finite_fold @ A @ B @ F2 @ Z @ ( insert @ A @ X2 @ A3 ) )
              = ( finite_fold @ A @ B @ F2 @ ( F2 @ X2 @ Z ) @ A3 ) ) ) ) ) ) ).

% comp_fun_commute_on.fold_insert2
thf(fact_7949_comp__fun__commute__on_Ofold__insert,axiom,
    ! [B: $tType,A: $tType,S3: set @ A,F2: A > B > B,X2: A,A3: set @ A,Z: B] :
      ( ( finite4664212375090638736ute_on @ A @ B @ S3 @ F2 )
     => ( ( ord_less_eq @ ( set @ A ) @ ( insert @ A @ X2 @ A3 ) @ S3 )
       => ( ( finite_finite @ A @ A3 )
         => ( ~ ( member @ A @ X2 @ A3 )
           => ( ( finite_fold @ A @ B @ F2 @ Z @ ( insert @ A @ X2 @ A3 ) )
              = ( F2 @ X2 @ ( finite_fold @ A @ B @ F2 @ Z @ A3 ) ) ) ) ) ) ) ).

% comp_fun_commute_on.fold_insert
thf(fact_7950_comp__fun__commute__on_Ofold__rec,axiom,
    ! [B: $tType,A: $tType,S3: set @ A,F2: A > B > B,A3: set @ A,X2: A,Z: B] :
      ( ( finite4664212375090638736ute_on @ A @ B @ S3 @ F2 )
     => ( ( ord_less_eq @ ( set @ A ) @ A3 @ S3 )
       => ( ( finite_finite @ A @ A3 )
         => ( ( member @ A @ X2 @ A3 )
           => ( ( finite_fold @ A @ B @ F2 @ Z @ A3 )
              = ( F2 @ X2 @ ( finite_fold @ A @ B @ F2 @ Z @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X2 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ) ) ) ).

% comp_fun_commute_on.fold_rec
thf(fact_7951_comp__fun__commute__on_Ofold__insert__remove,axiom,
    ! [B: $tType,A: $tType,S3: set @ A,F2: A > B > B,X2: A,A3: set @ A,Z: B] :
      ( ( finite4664212375090638736ute_on @ A @ B @ S3 @ F2 )
     => ( ( ord_less_eq @ ( set @ A ) @ ( insert @ A @ X2 @ A3 ) @ S3 )
       => ( ( finite_finite @ A @ A3 )
         => ( ( finite_fold @ A @ B @ F2 @ Z @ ( insert @ A @ X2 @ A3 ) )
            = ( F2 @ X2 @ ( finite_fold @ A @ B @ F2 @ Z @ ( minus_minus @ ( set @ A ) @ A3 @ ( insert @ A @ X2 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ) ) ).

% comp_fun_commute_on.fold_insert_remove
thf(fact_7952_compact__imp__fip__image,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [S2: set @ A,I6: set @ B,F2: B > ( set @ A )] :
          ( ( topolo2193935891317330818ompact @ A @ S2 )
         => ( ! [I2: B] :
                ( ( member @ B @ I2 @ I6 )
               => ( topolo7761053866217962861closed @ A @ ( F2 @ I2 ) ) )
           => ( ! [I9: set @ B] :
                  ( ( finite_finite @ B @ I9 )
                 => ( ( ord_less_eq @ ( set @ B ) @ I9 @ I6 )
                   => ( ( inf_inf @ ( set @ A ) @ S2 @ ( complete_Inf_Inf @ ( set @ A ) @ ( image @ B @ ( set @ A ) @ F2 @ I9 ) ) )
                     != ( bot_bot @ ( set @ A ) ) ) ) )
             => ( ( inf_inf @ ( set @ A ) @ S2 @ ( complete_Inf_Inf @ ( set @ A ) @ ( image @ B @ ( set @ A ) @ F2 @ I6 ) ) )
               != ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ).

% compact_imp_fip_image
thf(fact_7953_lenlex__append2,axiom,
    ! [A: $tType,R: set @ ( product_prod @ A @ A ),Us: list @ A,Xs: list @ A,Ys: list @ A] :
      ( ( irrefl @ A @ R )
     => ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( append @ A @ Us @ Xs ) @ ( append @ A @ Us @ Ys ) ) @ ( lenlex @ A @ R ) )
        = ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Ys ) @ ( lenlex @ A @ R ) ) ) ) ).

% lenlex_append2
thf(fact_7954_lexord__same__pref__if__irrefl,axiom,
    ! [A: $tType,R3: set @ ( product_prod @ A @ A ),Xs: list @ A,Ys: list @ A,Zs: list @ A] :
      ( ( irrefl @ A @ R3 )
     => ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( append @ A @ Xs @ Ys ) @ ( append @ A @ Xs @ Zs ) ) @ ( lexord @ A @ R3 ) )
        = ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Ys @ Zs ) @ ( lexord @ A @ R3 ) ) ) ) ).

% lexord_same_pref_if_irrefl
thf(fact_7955_closed__Collect__le,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topolo4958980785337419405_space @ A )
        & ( topolo1944317154257567458pology @ B ) )
     => ! [F2: A > B,G: A > B] :
          ( ( topolo81223032696312382ous_on @ A @ B @ ( top_top @ ( set @ A ) ) @ F2 )
         => ( ( topolo81223032696312382ous_on @ A @ B @ ( top_top @ ( set @ A ) ) @ G )
           => ( topolo7761053866217962861closed @ A
              @ ( collect @ A
                @ ^ [X5: A] : ( ord_less_eq @ B @ ( F2 @ X5 ) @ ( G @ X5 ) ) ) ) ) ) ) ).

% closed_Collect_le
thf(fact_7956_closed__subdiagonal,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ( topolo7761053866217962861closed @ ( product_prod @ A @ A )
        @ ( collect @ ( product_prod @ A @ A )
          @ ^ [Uu3: product_prod @ A @ A] :
            ? [X5: A,Y5: A] :
              ( ( Uu3
                = ( product_Pair @ A @ A @ X5 @ Y5 ) )
              & ( ord_less_eq @ A @ X5 @ Y5 ) ) ) ) ) ).

% closed_subdiagonal
thf(fact_7957_closed__superdiagonal,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ( topolo7761053866217962861closed @ ( product_prod @ A @ A )
        @ ( collect @ ( product_prod @ A @ A )
          @ ^ [Uu3: product_prod @ A @ A] :
            ? [X5: A,Y5: A] :
              ( ( Uu3
                = ( product_Pair @ A @ A @ X5 @ Y5 ) )
              & ( ord_less_eq @ A @ Y5 @ X5 ) ) ) ) ) ).

% closed_superdiagonal
thf(fact_7958_lexord__irrefl,axiom,
    ! [A: $tType,R: set @ ( product_prod @ A @ A )] :
      ( ( irrefl @ A @ R )
     => ( irrefl @ ( list @ A ) @ ( lexord @ A @ R ) ) ) ).

% lexord_irrefl
thf(fact_7959_closed__diagonal,axiom,
    ! [A: $tType] :
      ( ( topological_t2_space @ A )
     => ( topolo7761053866217962861closed @ ( product_prod @ A @ A )
        @ ( collect @ ( product_prod @ A @ A )
          @ ^ [Y5: product_prod @ A @ A] :
            ? [X5: A] :
              ( Y5
              = ( product_Pair @ A @ A @ X5 @ X5 ) ) ) ) ) ).

% closed_diagonal
thf(fact_7960_irrefl__def,axiom,
    ! [A: $tType] :
      ( ( irrefl @ A )
      = ( ^ [R5: set @ ( product_prod @ A @ A )] :
          ! [A4: A] :
            ~ ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A4 @ A4 ) @ R5 ) ) ) ).

% irrefl_def
thf(fact_7961_irreflI,axiom,
    ! [A: $tType,R: set @ ( product_prod @ A @ A )] :
      ( ! [A5: A] :
          ~ ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A5 @ A5 ) @ R )
     => ( irrefl @ A @ R ) ) ).

% irreflI
thf(fact_7962_irrefl__lex,axiom,
    ! [A: $tType,R3: set @ ( product_prod @ A @ A )] :
      ( ( irrefl @ A @ R3 )
     => ( irrefl @ ( list @ A ) @ ( lex @ A @ R3 ) ) ) ).

% irrefl_lex
thf(fact_7963_lexl__not__refl,axiom,
    ! [A: $tType,R3: set @ ( product_prod @ A @ A ),X2: list @ A] :
      ( ( irrefl @ A @ R3 )
     => ~ ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ X2 @ X2 ) @ ( lex @ A @ R3 ) ) ) ).

% lexl_not_refl
thf(fact_7964_t3__space,axiom,
    ! [A: $tType] :
      ( ( topological_t3_space @ A )
     => ! [S3: set @ A,Y2: A] :
          ( ( topolo7761053866217962861closed @ A @ S3 )
         => ( ~ ( member @ A @ Y2 @ S3 )
           => ? [U5: set @ A,V6: set @ A] :
                ( ( topolo1002775350975398744n_open @ A @ U5 )
                & ( topolo1002775350975398744n_open @ A @ V6 )
                & ( member @ A @ Y2 @ U5 )
                & ( ord_less_eq @ ( set @ A ) @ S3 @ V6 )
                & ( ( inf_inf @ ( set @ A ) @ U5 @ V6 )
                  = ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ).

% t3_space
thf(fact_7965_t4__space,axiom,
    ! [A: $tType] :
      ( ( topological_t4_space @ A )
     => ! [S3: set @ A,T6: set @ A] :
          ( ( topolo7761053866217962861closed @ A @ S3 )
         => ( ( topolo7761053866217962861closed @ A @ T6 )
           => ( ( ( inf_inf @ ( set @ A ) @ S3 @ T6 )
                = ( bot_bot @ ( set @ A ) ) )
             => ? [U5: set @ A,V6: set @ A] :
                  ( ( topolo1002775350975398744n_open @ A @ U5 )
                  & ( topolo1002775350975398744n_open @ A @ V6 )
                  & ( ord_less_eq @ ( set @ A ) @ S3 @ U5 )
                  & ( ord_less_eq @ ( set @ A ) @ T6 @ V6 )
                  & ( ( inf_inf @ ( set @ A ) @ U5 @ V6 )
                    = ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ).

% t4_space
thf(fact_7966_nhds__closed,axiom,
    ! [A: $tType] :
      ( ( topological_t3_space @ A )
     => ! [X2: A,A3: set @ A] :
          ( ( member @ A @ X2 @ A3 )
         => ( ( topolo1002775350975398744n_open @ A @ A3 )
           => ? [A15: set @ A] :
                ( ( member @ A @ X2 @ A15 )
                & ( topolo7761053866217962861closed @ A @ A15 )
                & ( ord_less_eq @ ( set @ A ) @ A15 @ A3 )
                & ( eventually @ A
                  @ ^ [Y5: A] : ( member @ A @ Y5 @ A15 )
                  @ ( topolo7230453075368039082e_nhds @ A @ X2 ) ) ) ) ) ) ).

% nhds_closed
thf(fact_7967_compact__imp__fip,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [S3: set @ A,F3: set @ ( set @ A )] :
          ( ( topolo2193935891317330818ompact @ A @ S3 )
         => ( ! [T7: set @ A] :
                ( ( member @ ( set @ A ) @ T7 @ F3 )
               => ( topolo7761053866217962861closed @ A @ T7 ) )
           => ( ! [F17: set @ ( set @ A )] :
                  ( ( finite_finite @ ( set @ A ) @ F17 )
                 => ( ( ord_less_eq @ ( set @ ( set @ A ) ) @ F17 @ F3 )
                   => ( ( inf_inf @ ( set @ A ) @ S3 @ ( complete_Inf_Inf @ ( set @ A ) @ F17 ) )
                     != ( bot_bot @ ( set @ A ) ) ) ) )
             => ( ( inf_inf @ ( set @ A ) @ S3 @ ( complete_Inf_Inf @ ( set @ A ) @ F3 ) )
               != ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ).

% compact_imp_fip
thf(fact_7968_compact__fip,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ( ( topolo2193935891317330818ompact @ A )
        = ( ^ [U6: set @ A] :
            ! [A7: set @ ( set @ A )] :
              ( ! [X5: set @ A] :
                  ( ( member @ ( set @ A ) @ X5 @ A7 )
                 => ( topolo7761053866217962861closed @ A @ X5 ) )
             => ( ! [B8: set @ ( set @ A )] :
                    ( ( ord_less_eq @ ( set @ ( set @ A ) ) @ B8 @ A7 )
                   => ( ( finite_finite @ ( set @ A ) @ B8 )
                     => ( ( inf_inf @ ( set @ A ) @ U6 @ ( complete_Inf_Inf @ ( set @ A ) @ B8 ) )
                       != ( bot_bot @ ( set @ A ) ) ) ) )
               => ( ( inf_inf @ ( set @ A ) @ U6 @ ( complete_Inf_Inf @ ( set @ A ) @ A7 ) )
                 != ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ).

% compact_fip
thf(fact_7969_inj__sgn__power,axiom,
    ! [N2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
     => ( inj_on @ real @ real
        @ ^ [Y5: real] : ( times_times @ real @ ( sgn_sgn @ real @ Y5 ) @ ( power_power @ real @ ( abs_abs @ real @ Y5 ) @ N2 ) )
        @ ( top_top @ ( set @ real ) ) ) ) ).

% inj_sgn_power
thf(fact_7970_rtrancl__finite__eq__relpow,axiom,
    ! [A: $tType,R: set @ ( product_prod @ A @ A )] :
      ( ( finite_finite @ ( product_prod @ A @ A ) @ R )
     => ( ( transitive_rtrancl @ A @ R )
        = ( complete_Sup_Sup @ ( set @ ( product_prod @ A @ A ) )
          @ ( image @ nat @ ( set @ ( product_prod @ A @ A ) )
            @ ^ [N3: nat] : ( compow @ ( set @ ( product_prod @ A @ A ) ) @ N3 @ R )
            @ ( collect @ nat
              @ ^ [N3: nat] : ( ord_less_eq @ nat @ N3 @ ( finite_card @ ( product_prod @ A @ A ) @ R ) ) ) ) ) ) ) ).

% rtrancl_finite_eq_relpow
thf(fact_7971_inj__map__eq__map,axiom,
    ! [B: $tType,A: $tType,F2: A > B,Xs: list @ A,Ys: list @ A] :
      ( ( inj_on @ A @ B @ F2 @ ( top_top @ ( set @ A ) ) )
     => ( ( ( map @ A @ B @ F2 @ Xs )
          = ( map @ A @ B @ F2 @ Ys ) )
        = ( Xs = Ys ) ) ) ).

% inj_map_eq_map
thf(fact_7972_inj__mult__left,axiom,
    ! [A: $tType] :
      ( ( idom @ A )
     => ! [A2: A] :
          ( ( inj_on @ A @ A @ ( times_times @ A @ A2 ) @ ( top_top @ ( set @ A ) ) )
          = ( ( A2
             != ( zero_zero @ A ) ) ) ) ) ).

% inj_mult_left
thf(fact_7973_inj__divide__right,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A2: A] :
          ( ( inj_on @ A @ A
            @ ^ [B4: A] : ( divide_divide @ A @ B4 @ A2 )
            @ ( top_top @ ( set @ A ) ) )
          = ( ( A2
             != ( zero_zero @ A ) ) ) ) ) ).

% inj_divide_right
thf(fact_7974_inj__map,axiom,
    ! [B: $tType,A: $tType,F2: A > B] :
      ( ( inj_on @ ( list @ A ) @ ( list @ B ) @ ( map @ A @ B @ F2 ) @ ( top_top @ ( set @ ( list @ A ) ) ) )
      = ( inj_on @ A @ B @ F2 @ ( top_top @ ( set @ A ) ) ) ) ).

% inj_map
thf(fact_7975_inj__mapI,axiom,
    ! [B: $tType,A: $tType,F2: A > B] :
      ( ( inj_on @ A @ B @ F2 @ ( top_top @ ( set @ A ) ) )
     => ( inj_on @ ( list @ A ) @ ( list @ B ) @ ( map @ A @ B @ F2 ) @ ( top_top @ ( set @ ( list @ A ) ) ) ) ) ).

% inj_mapI
thf(fact_7976_folding__insort__key_Oinj__on,axiom,
    ! [A: $tType,B: $tType,Less_eq: A > A > $o,Less: A > A > $o,S3: set @ B,F2: B > A] :
      ( ( folding_insort_key @ A @ B @ Less_eq @ Less @ S3 @ F2 )
     => ( inj_on @ B @ A @ F2 @ S3 ) ) ).

% folding_insort_key.inj_on
thf(fact_7977_injective__scaleR,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [C2: real] :
          ( ( C2
           != ( zero_zero @ real ) )
         => ( inj_on @ A @ A @ ( real_V8093663219630862766scaleR @ A @ C2 ) @ ( top_top @ ( set @ A ) ) ) ) ) ).

% injective_scaleR
thf(fact_7978_rtrancl__listrel1__ConsI2,axiom,
    ! [A: $tType,X2: A,Y2: A,R3: set @ ( product_prod @ A @ A ),Xs: list @ A,Ys: list @ A] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ Y2 ) @ ( transitive_rtrancl @ A @ R3 ) )
     => ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Ys ) @ ( transitive_rtrancl @ ( list @ A ) @ ( listrel1 @ A @ R3 ) ) )
       => ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X2 @ Xs ) @ ( cons @ A @ Y2 @ Ys ) ) @ ( transitive_rtrancl @ ( list @ A ) @ ( listrel1 @ A @ R3 ) ) ) ) ) ).

% rtrancl_listrel1_ConsI2
thf(fact_7979_rtrancl__Un__subset,axiom,
    ! [A: $tType,R: set @ ( product_prod @ A @ A ),S3: set @ ( product_prod @ A @ A )] : ( ord_less_eq @ ( set @ ( product_prod @ A @ A ) ) @ ( sup_sup @ ( set @ ( product_prod @ A @ A ) ) @ ( transitive_rtrancl @ A @ R ) @ ( transitive_rtrancl @ A @ S3 ) ) @ ( transitive_rtrancl @ A @ ( sup_sup @ ( set @ ( product_prod @ A @ A ) ) @ R @ S3 ) ) ) ).

% rtrancl_Un_subset
thf(fact_7980_linorder__inj__onI,axiom,
    ! [B: $tType,A: $tType] :
      ( ( order @ A )
     => ! [A3: set @ A,F2: A > B] :
          ( ! [X3: A,Y4: A] :
              ( ( ord_less @ A @ X3 @ Y4 )
             => ( ( member @ A @ X3 @ A3 )
               => ( ( member @ A @ Y4 @ A3 )
                 => ( ( F2 @ X3 )
                   != ( F2 @ Y4 ) ) ) ) )
         => ( ! [X3: A,Y4: A] :
                ( ( member @ A @ X3 @ A3 )
               => ( ( member @ A @ Y4 @ A3 )
                 => ( ( ord_less_eq @ A @ X3 @ Y4 )
                    | ( ord_less_eq @ A @ Y4 @ X3 ) ) ) )
           => ( inj_on @ A @ B @ F2 @ A3 ) ) ) ) ).

% linorder_inj_onI
thf(fact_7981_subset__inj__on,axiom,
    ! [B: $tType,A: $tType,F2: A > B,B3: set @ A,A3: set @ A] :
      ( ( inj_on @ A @ B @ F2 @ B3 )
     => ( ( ord_less_eq @ ( set @ A ) @ A3 @ B3 )
       => ( inj_on @ A @ B @ F2 @ A3 ) ) ) ).

% subset_inj_on
thf(fact_7982_inj__on__subset,axiom,
    ! [B: $tType,A: $tType,F2: A > B,A3: set @ A,B3: set @ A] :
      ( ( inj_on @ A @ B @ F2 @ A3 )
     => ( ( ord_less_eq @ ( set @ A ) @ B3 @ A3 )
       => ( inj_on @ A @ B @ F2 @ B3 ) ) ) ).

% inj_on_subset
thf(fact_7983_rtrancl__subset__rtrancl,axiom,
    ! [A: $tType,R3: set @ ( product_prod @ A @ A ),S2: set @ ( product_prod @ A @ A )] :
      ( ( ord_less_eq @ ( set @ ( product_prod @ A @ A ) ) @ R3 @ ( transitive_rtrancl @ A @ S2 ) )
     => ( ord_less_eq @ ( set @ ( product_prod @ A @ A ) ) @ ( transitive_rtrancl @ A @ R3 ) @ ( transitive_rtrancl @ A @ S2 ) ) ) ).

% rtrancl_subset_rtrancl
thf(fact_7984_rtrancl__subset,axiom,
    ! [A: $tType,R: set @ ( product_prod @ A @ A ),S3: set @ ( product_prod @ A @ A )] :
      ( ( ord_less_eq @ ( set @ ( product_prod @ A @ A ) ) @ R @ S3 )
     => ( ( ord_less_eq @ ( set @ ( product_prod @ A @ A ) ) @ S3 @ ( transitive_rtrancl @ A @ R ) )
       => ( ( transitive_rtrancl @ A @ S3 )
          = ( transitive_rtrancl @ A @ R ) ) ) ) ).

% rtrancl_subset
thf(fact_7985_rtrancl__mono,axiom,
    ! [A: $tType,R3: set @ ( product_prod @ A @ A ),S2: set @ ( product_prod @ A @ A )] :
      ( ( ord_less_eq @ ( set @ ( product_prod @ A @ A ) ) @ R3 @ S2 )
     => ( ord_less_eq @ ( set @ ( product_prod @ A @ A ) ) @ ( transitive_rtrancl @ A @ R3 ) @ ( transitive_rtrancl @ A @ S2 ) ) ) ).

% rtrancl_mono
thf(fact_7986_listrel1__rtrancl__subset__rtrancl__listrel1,axiom,
    ! [A: $tType,R3: set @ ( product_prod @ A @ A )] : ( ord_less_eq @ ( set @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) ) @ ( listrel1 @ A @ ( transitive_rtrancl @ A @ R3 ) ) @ ( transitive_rtrancl @ ( list @ A ) @ ( listrel1 @ A @ R3 ) ) ) ).

% listrel1_rtrancl_subset_rtrancl_listrel1
thf(fact_7987_rtrancl__Un__separatorE,axiom,
    ! [A: $tType,A2: A,B2: A,P: set @ ( product_prod @ A @ A ),Q: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ B2 ) @ ( transitive_rtrancl @ A @ ( sup_sup @ ( set @ ( product_prod @ A @ A ) ) @ P @ Q ) ) )
     => ( ! [X3: A,Y4: A] :
            ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ X3 ) @ ( transitive_rtrancl @ A @ P ) )
           => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X3 @ Y4 ) @ Q )
             => ( X3 = Y4 ) ) )
       => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ B2 ) @ ( transitive_rtrancl @ A @ P ) ) ) ) ).

% rtrancl_Un_separatorE
thf(fact_7988_rtrancl__Un__separator__converseE,axiom,
    ! [A: $tType,A2: A,B2: A,P: set @ ( product_prod @ A @ A ),Q: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ B2 ) @ ( transitive_rtrancl @ A @ ( sup_sup @ ( set @ ( product_prod @ A @ A ) ) @ P @ Q ) ) )
     => ( ! [X3: A,Y4: A] :
            ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X3 @ B2 ) @ ( transitive_rtrancl @ A @ P ) )
           => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Y4 @ X3 ) @ Q )
             => ( Y4 = X3 ) ) )
       => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ B2 ) @ ( transitive_rtrancl @ A @ P ) ) ) ) ).

% rtrancl_Un_separator_converseE
thf(fact_7989_tranclD,axiom,
    ! [A: $tType,X2: A,Y2: A,R: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ Y2 ) @ ( transitive_trancl @ A @ R ) )
     => ? [Z3: A] :
          ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ Z3 ) @ R )
          & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Z3 @ Y2 ) @ ( transitive_rtrancl @ A @ R ) ) ) ) ).

% tranclD
thf(fact_7990_rtranclD,axiom,
    ! [A: $tType,A2: A,B2: A,R: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ B2 ) @ ( transitive_rtrancl @ A @ R ) )
     => ( ( A2 = B2 )
        | ( ( A2 != B2 )
          & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ B2 ) @ ( transitive_trancl @ A @ R ) ) ) ) ) ).

% rtranclD
thf(fact_7991_tranclD2,axiom,
    ! [A: $tType,X2: A,Y2: A,R: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ Y2 ) @ ( transitive_trancl @ A @ R ) )
     => ? [Z3: A] :
          ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ Z3 ) @ ( transitive_rtrancl @ A @ R ) )
          & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Z3 @ Y2 ) @ R ) ) ) ).

% tranclD2
thf(fact_7992_trancl__into__rtrancl,axiom,
    ! [A: $tType,A2: A,B2: A,R3: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ B2 ) @ ( transitive_trancl @ A @ R3 ) )
     => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ B2 ) @ ( transitive_rtrancl @ A @ R3 ) ) ) ).

% trancl_into_rtrancl
thf(fact_7993_rtrancl__eq__or__trancl,axiom,
    ! [A: $tType,X2: A,Y2: A,R: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ Y2 ) @ ( transitive_rtrancl @ A @ R ) )
      = ( ( X2 = Y2 )
        | ( ( X2 != Y2 )
          & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ Y2 ) @ ( transitive_trancl @ A @ R ) ) ) ) ) ).

% rtrancl_eq_or_trancl
thf(fact_7994_rtrancl__into__trancl1,axiom,
    ! [A: $tType,A2: A,B2: A,R3: set @ ( product_prod @ A @ A ),C2: A] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ B2 ) @ ( transitive_rtrancl @ A @ R3 ) )
     => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ B2 @ C2 ) @ R3 )
       => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ C2 ) @ ( transitive_trancl @ A @ R3 ) ) ) ) ).

% rtrancl_into_trancl1
thf(fact_7995_rtrancl__into__trancl2,axiom,
    ! [A: $tType,A2: A,B2: A,R3: set @ ( product_prod @ A @ A ),C2: A] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ B2 ) @ R3 )
     => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ B2 @ C2 ) @ ( transitive_rtrancl @ A @ R3 ) )
       => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ C2 ) @ ( transitive_trancl @ A @ R3 ) ) ) ) ).

% rtrancl_into_trancl2
thf(fact_7996_rtrancl__trancl__trancl,axiom,
    ! [A: $tType,X2: A,Y2: A,R3: set @ ( product_prod @ A @ A ),Z: A] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ Y2 ) @ ( transitive_rtrancl @ A @ R3 ) )
     => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Y2 @ Z ) @ ( transitive_trancl @ A @ R3 ) )
       => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ Z ) @ ( transitive_trancl @ A @ R3 ) ) ) ) ).

% rtrancl_trancl_trancl
thf(fact_7997_trancl__rtrancl__trancl,axiom,
    ! [A: $tType,A2: A,B2: A,R3: set @ ( product_prod @ A @ A ),C2: A] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ B2 ) @ ( transitive_trancl @ A @ R3 ) )
     => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ B2 @ C2 ) @ ( transitive_rtrancl @ A @ R3 ) )
       => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ C2 ) @ ( transitive_trancl @ A @ R3 ) ) ) ) ).

% trancl_rtrancl_trancl
thf(fact_7998_continuous__inj__imp__mono,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topolo8458572112393995274pology @ A )
        & ( topolo1944317154257567458pology @ B ) )
     => ! [A2: A,X2: A,B2: A,F2: A > B] :
          ( ( ord_less @ A @ A2 @ X2 )
         => ( ( ord_less @ A @ X2 @ B2 )
           => ( ( topolo81223032696312382ous_on @ A @ B @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) @ F2 )
             => ( ( inj_on @ A @ B @ F2 @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) )
               => ( ( ( ord_less @ B @ ( F2 @ A2 ) @ ( F2 @ X2 ) )
                    & ( ord_less @ B @ ( F2 @ X2 ) @ ( F2 @ B2 ) ) )
                  | ( ( ord_less @ B @ ( F2 @ B2 ) @ ( F2 @ X2 ) )
                    & ( ord_less @ B @ ( F2 @ X2 ) @ ( F2 @ A2 ) ) ) ) ) ) ) ) ) ).

% continuous_inj_imp_mono
thf(fact_7999_inj__fn,axiom,
    ! [A: $tType,F2: A > A,N2: nat] :
      ( ( inj_on @ A @ A @ F2 @ ( top_top @ ( set @ A ) ) )
     => ( inj_on @ A @ A @ ( compow @ ( A > A ) @ N2 @ F2 ) @ ( top_top @ ( set @ A ) ) ) ) ).

% inj_fn
thf(fact_8000_sorted__list__of__set_Oinj__on,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( inj_on @ A @ A
        @ ^ [X5: A] : X5
        @ ( top_top @ ( set @ A ) ) ) ) ).

% sorted_list_of_set.inj_on
thf(fact_8001_inj__add__left,axiom,
    ! [A: $tType] :
      ( ( cancel_semigroup_add @ A )
     => ! [A2: A] : ( inj_on @ A @ A @ ( plus_plus @ A @ A2 ) @ ( top_top @ ( set @ A ) ) ) ) ).

% inj_add_left
thf(fact_8002_inj__on__add_H,axiom,
    ! [A: $tType] :
      ( ( cancel_semigroup_add @ A )
     => ! [A2: A,A3: set @ A] :
          ( inj_on @ A @ A
          @ ^ [B4: A] : ( plus_plus @ A @ B4 @ A2 )
          @ A3 ) ) ).

% inj_on_add'
thf(fact_8003_inj__on__add,axiom,
    ! [A: $tType] :
      ( ( cancel_semigroup_add @ A )
     => ! [A2: A,A3: set @ A] : ( inj_on @ A @ A @ ( plus_plus @ A @ A2 ) @ A3 ) ) ).

% inj_on_add
thf(fact_8004_inj__on__mult,axiom,
    ! [A: $tType] :
      ( ( semidom_divide @ A )
     => ! [A2: A,A3: set @ A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( inj_on @ A @ A @ ( times_times @ A @ A2 ) @ A3 ) ) ) ).

% inj_on_mult
thf(fact_8005_linorder__injI,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linorder @ A )
     => ! [F2: A > B] :
          ( ! [X3: A,Y4: A] :
              ( ( ord_less @ A @ X3 @ Y4 )
             => ( ( F2 @ X3 )
               != ( F2 @ Y4 ) ) )
         => ( inj_on @ A @ B @ F2 @ ( top_top @ ( set @ A ) ) ) ) ) ).

% linorder_injI
thf(fact_8006_rtrancl__induct2,axiom,
    ! [A: $tType,B: $tType,Ax: A,Ay: B,Bx: A,By: B,R3: set @ ( product_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) ),P: A > B > $o] :
      ( ( member @ ( product_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) ) @ ( product_Pair @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ Ax @ Ay ) @ ( product_Pair @ A @ B @ Bx @ By ) ) @ ( transitive_rtrancl @ ( product_prod @ A @ B ) @ R3 ) )
     => ( ( P @ Ax @ Ay )
       => ( ! [A5: A,B5: B,Aa2: A,Ba: B] :
              ( ( member @ ( product_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) ) @ ( product_Pair @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ Ax @ Ay ) @ ( product_Pair @ A @ B @ A5 @ B5 ) ) @ ( transitive_rtrancl @ ( product_prod @ A @ B ) @ R3 ) )
             => ( ( member @ ( product_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) ) @ ( product_Pair @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ A5 @ B5 ) @ ( product_Pair @ A @ B @ Aa2 @ Ba ) ) @ R3 )
               => ( ( P @ A5 @ B5 )
                 => ( P @ Aa2 @ Ba ) ) ) )
         => ( P @ Bx @ By ) ) ) ) ).

% rtrancl_induct2
thf(fact_8007_converse__rtranclE2,axiom,
    ! [B: $tType,A: $tType,Xa2: A,Xb3: B,Za2: A,Zb: B,R3: set @ ( product_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) )] :
      ( ( member @ ( product_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) ) @ ( product_Pair @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ Xa2 @ Xb3 ) @ ( product_Pair @ A @ B @ Za2 @ Zb ) ) @ ( transitive_rtrancl @ ( product_prod @ A @ B ) @ R3 ) )
     => ( ( ( product_Pair @ A @ B @ Xa2 @ Xb3 )
         != ( product_Pair @ A @ B @ Za2 @ Zb ) )
       => ~ ! [A5: A,B5: B] :
              ( ( member @ ( product_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) ) @ ( product_Pair @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ Xa2 @ Xb3 ) @ ( product_Pair @ A @ B @ A5 @ B5 ) ) @ R3 )
             => ~ ( member @ ( product_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) ) @ ( product_Pair @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ A5 @ B5 ) @ ( product_Pair @ A @ B @ Za2 @ Zb ) ) @ ( transitive_rtrancl @ ( product_prod @ A @ B ) @ R3 ) ) ) ) ) ).

% converse_rtranclE2
thf(fact_8008_converse__rtrancl__induct2,axiom,
    ! [A: $tType,B: $tType,Ax: A,Ay: B,Bx: A,By: B,R3: set @ ( product_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) ),P: A > B > $o] :
      ( ( member @ ( product_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) ) @ ( product_Pair @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ Ax @ Ay ) @ ( product_Pair @ A @ B @ Bx @ By ) ) @ ( transitive_rtrancl @ ( product_prod @ A @ B ) @ R3 ) )
     => ( ( P @ Bx @ By )
       => ( ! [A5: A,B5: B,Aa2: A,Ba: B] :
              ( ( member @ ( product_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) ) @ ( product_Pair @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ A5 @ B5 ) @ ( product_Pair @ A @ B @ Aa2 @ Ba ) ) @ R3 )
             => ( ( member @ ( product_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) ) @ ( product_Pair @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ Aa2 @ Ba ) @ ( product_Pair @ A @ B @ Bx @ By ) ) @ ( transitive_rtrancl @ ( product_prod @ A @ B ) @ R3 ) )
               => ( ( P @ Aa2 @ Ba )
                 => ( P @ A5 @ B5 ) ) ) )
         => ( P @ Ax @ Ay ) ) ) ) ).

% converse_rtrancl_induct2
thf(fact_8009_rtrancl_Ocases,axiom,
    ! [A: $tType,A1: A,A22: A,R3: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A1 @ A22 ) @ ( transitive_rtrancl @ A @ R3 ) )
     => ( ( A22 != A1 )
       => ~ ! [B5: A] :
              ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A1 @ B5 ) @ ( transitive_rtrancl @ A @ R3 ) )
             => ~ ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ B5 @ A22 ) @ R3 ) ) ) ) ).

% rtrancl.cases
thf(fact_8010_rtrancl_Osimps,axiom,
    ! [A: $tType,A1: A,A22: A,R3: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A1 @ A22 ) @ ( transitive_rtrancl @ A @ R3 ) )
      = ( ? [A4: A] :
            ( ( A1 = A4 )
            & ( A22 = A4 ) )
        | ? [A4: A,B4: A,C4: A] :
            ( ( A1 = A4 )
            & ( A22 = C4 )
            & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A4 @ B4 ) @ ( transitive_rtrancl @ A @ R3 ) )
            & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ B4 @ C4 ) @ R3 ) ) ) ) ).

% rtrancl.simps
thf(fact_8011_rtrancl_Ortrancl__refl,axiom,
    ! [A: $tType,A2: A,R3: set @ ( product_prod @ A @ A )] : ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ A2 ) @ ( transitive_rtrancl @ A @ R3 ) ) ).

% rtrancl.rtrancl_refl
thf(fact_8012_rtrancl_Ortrancl__into__rtrancl,axiom,
    ! [A: $tType,A2: A,B2: A,R3: set @ ( product_prod @ A @ A ),C2: A] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ B2 ) @ ( transitive_rtrancl @ A @ R3 ) )
     => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ B2 @ C2 ) @ R3 )
       => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ C2 ) @ ( transitive_rtrancl @ A @ R3 ) ) ) ) ).

% rtrancl.rtrancl_into_rtrancl
thf(fact_8013_rtranclE,axiom,
    ! [A: $tType,A2: A,B2: A,R3: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ B2 ) @ ( transitive_rtrancl @ A @ R3 ) )
     => ( ( A2 != B2 )
       => ~ ! [Y4: A] :
              ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ Y4 ) @ ( transitive_rtrancl @ A @ R3 ) )
             => ~ ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Y4 @ B2 ) @ R3 ) ) ) ) ).

% rtranclE
thf(fact_8014_rtrancl__trans,axiom,
    ! [A: $tType,X2: A,Y2: A,R3: set @ ( product_prod @ A @ A ),Z: A] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ Y2 ) @ ( transitive_rtrancl @ A @ R3 ) )
     => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Y2 @ Z ) @ ( transitive_rtrancl @ A @ R3 ) )
       => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ Z ) @ ( transitive_rtrancl @ A @ R3 ) ) ) ) ).

% rtrancl_trans
thf(fact_8015_rtrancl__induct,axiom,
    ! [A: $tType,A2: A,B2: A,R3: set @ ( product_prod @ A @ A ),P: A > $o] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ B2 ) @ ( transitive_rtrancl @ A @ R3 ) )
     => ( ( P @ A2 )
       => ( ! [Y4: A,Z3: A] :
              ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ Y4 ) @ ( transitive_rtrancl @ A @ R3 ) )
             => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Y4 @ Z3 ) @ R3 )
               => ( ( P @ Y4 )
                 => ( P @ Z3 ) ) ) )
         => ( P @ B2 ) ) ) ) ).

% rtrancl_induct
thf(fact_8016_converse__rtranclE,axiom,
    ! [A: $tType,X2: A,Z: A,R3: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ Z ) @ ( transitive_rtrancl @ A @ R3 ) )
     => ( ( X2 != Z )
       => ~ ! [Y4: A] :
              ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ Y4 ) @ R3 )
             => ~ ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Y4 @ Z ) @ ( transitive_rtrancl @ A @ R3 ) ) ) ) ) ).

% converse_rtranclE
thf(fact_8017_converse__rtrancl__induct,axiom,
    ! [A: $tType,A2: A,B2: A,R3: set @ ( product_prod @ A @ A ),P: A > $o] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ B2 ) @ ( transitive_rtrancl @ A @ R3 ) )
     => ( ( P @ B2 )
       => ( ! [Y4: A,Z3: A] :
              ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Y4 @ Z3 ) @ R3 )
             => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Z3 @ B2 ) @ ( transitive_rtrancl @ A @ R3 ) )
               => ( ( P @ Z3 )
                 => ( P @ Y4 ) ) ) )
         => ( P @ A2 ) ) ) ) ).

% converse_rtrancl_induct
thf(fact_8018_converse__rtrancl__into__rtrancl,axiom,
    ! [A: $tType,A2: A,B2: A,R3: set @ ( product_prod @ A @ A ),C2: A] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ B2 ) @ R3 )
     => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ B2 @ C2 ) @ ( transitive_rtrancl @ A @ R3 ) )
       => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ C2 ) @ ( transitive_rtrancl @ A @ R3 ) ) ) ) ).

% converse_rtrancl_into_rtrancl
thf(fact_8019_rtrancl__listrel1__ConsI1,axiom,
    ! [A: $tType,Xs: list @ A,Ys: list @ A,R3: set @ ( product_prod @ A @ A ),X2: A] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Ys ) @ ( transitive_rtrancl @ ( list @ A ) @ ( listrel1 @ A @ R3 ) ) )
     => ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X2 @ Xs ) @ ( cons @ A @ X2 @ Ys ) ) @ ( transitive_rtrancl @ ( list @ A ) @ ( listrel1 @ A @ R3 ) ) ) ) ).

% rtrancl_listrel1_ConsI1
thf(fact_8020_rtrancl__listrel1__eq__len,axiom,
    ! [A: $tType,X2: list @ A,Y2: list @ A,R3: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ X2 @ Y2 ) @ ( transitive_rtrancl @ ( list @ A ) @ ( listrel1 @ A @ R3 ) ) )
     => ( ( size_size @ ( list @ A ) @ X2 )
        = ( size_size @ ( list @ A ) @ Y2 ) ) ) ).

% rtrancl_listrel1_eq_len
thf(fact_8021_remdups__adj__map__injective,axiom,
    ! [B: $tType,A: $tType,F2: A > B,Xs: list @ A] :
      ( ( inj_on @ A @ B @ F2 @ ( top_top @ ( set @ A ) ) )
     => ( ( remdups_adj @ B @ ( map @ A @ B @ F2 @ Xs ) )
        = ( map @ A @ B @ F2 @ ( remdups_adj @ A @ Xs ) ) ) ) ).

% remdups_adj_map_injective
thf(fact_8022_inj__mapD,axiom,
    ! [B: $tType,A: $tType,F2: A > B] :
      ( ( inj_on @ ( list @ A ) @ ( list @ B ) @ ( map @ A @ B @ F2 ) @ ( top_top @ ( set @ ( list @ A ) ) ) )
     => ( inj_on @ A @ B @ F2 @ ( top_top @ ( set @ A ) ) ) ) ).

% inj_mapD
thf(fact_8023_map__injective,axiom,
    ! [A: $tType,B: $tType,F2: B > A,Xs: list @ B,Ys: list @ B] :
      ( ( ( map @ B @ A @ F2 @ Xs )
        = ( map @ B @ A @ F2 @ Ys ) )
     => ( ( inj_on @ B @ A @ F2 @ ( top_top @ ( set @ B ) ) )
       => ( Xs = Ys ) ) ) ).

% map_injective
thf(fact_8024_distinct__map,axiom,
    ! [A: $tType,B: $tType,F2: B > A,Xs: list @ B] :
      ( ( distinct @ A @ ( map @ B @ A @ F2 @ Xs ) )
      = ( ( distinct @ B @ Xs )
        & ( inj_on @ B @ A @ F2 @ ( set2 @ B @ Xs ) ) ) ) ).

% distinct_map
thf(fact_8025_map__inj__on,axiom,
    ! [A: $tType,B: $tType,F2: B > A,Xs: list @ B,Ys: list @ B] :
      ( ( ( map @ B @ A @ F2 @ Xs )
        = ( map @ B @ A @ F2 @ Ys ) )
     => ( ( inj_on @ B @ A @ F2 @ ( sup_sup @ ( set @ B ) @ ( set2 @ B @ Xs ) @ ( set2 @ B @ Ys ) ) )
       => ( Xs = Ys ) ) ) ).

% map_inj_on
thf(fact_8026_inj__on__map__eq__map,axiom,
    ! [B: $tType,A: $tType,F2: A > B,Xs: list @ A,Ys: list @ A] :
      ( ( inj_on @ A @ B @ F2 @ ( sup_sup @ ( set @ A ) @ ( set2 @ A @ Xs ) @ ( set2 @ A @ Ys ) ) )
     => ( ( ( map @ A @ B @ F2 @ Xs )
          = ( map @ A @ B @ F2 @ Ys ) )
        = ( Xs = Ys ) ) ) ).

% inj_on_map_eq_map
thf(fact_8027_map__removeAll__inj,axiom,
    ! [B: $tType,A: $tType,F2: A > B,X2: A,Xs: list @ A] :
      ( ( inj_on @ A @ B @ F2 @ ( top_top @ ( set @ A ) ) )
     => ( ( map @ A @ B @ F2 @ ( removeAll @ A @ X2 @ Xs ) )
        = ( removeAll @ B @ ( F2 @ X2 ) @ ( map @ A @ B @ F2 @ Xs ) ) ) ) ).

% map_removeAll_inj
thf(fact_8028_inj__on__filter__key__eq,axiom,
    ! [B: $tType,A: $tType,F2: A > B,Y2: A,Xs: list @ A] :
      ( ( inj_on @ A @ B @ F2 @ ( insert @ A @ Y2 @ ( set2 @ A @ Xs ) ) )
     => ( ( filter2 @ A
          @ ^ [X5: A] :
              ( ( F2 @ Y2 )
              = ( F2 @ X5 ) )
          @ Xs )
        = ( filter2 @ A
          @ ( ^ [Y3: A,Z2: A] : ( Y3 = Z2 )
            @ Y2 )
          @ Xs ) ) ) ).

% inj_on_filter_key_eq
thf(fact_8029_inj__on__mapI,axiom,
    ! [B: $tType,A: $tType,F2: A > B,A3: set @ ( list @ A )] :
      ( ( inj_on @ A @ B @ F2 @ ( complete_Sup_Sup @ ( set @ A ) @ ( image @ ( list @ A ) @ ( set @ A ) @ ( set2 @ A ) @ A3 ) ) )
     => ( inj_on @ ( list @ A ) @ ( list @ B ) @ ( map @ A @ B @ F2 ) @ A3 ) ) ).

% inj_on_mapI
thf(fact_8030_inj__on__UNION__chain,axiom,
    ! [C: $tType,B: $tType,A: $tType,I6: set @ A,A3: A > ( set @ B ),F2: B > C] :
      ( ! [I2: A,J2: A] :
          ( ( member @ A @ I2 @ I6 )
         => ( ( member @ A @ J2 @ I6 )
           => ( ( ord_less_eq @ ( set @ B ) @ ( A3 @ I2 ) @ ( A3 @ J2 ) )
              | ( ord_less_eq @ ( set @ B ) @ ( A3 @ J2 ) @ ( A3 @ I2 ) ) ) ) )
     => ( ! [I2: A] :
            ( ( member @ A @ I2 @ I6 )
           => ( inj_on @ B @ C @ F2 @ ( A3 @ I2 ) ) )
       => ( inj_on @ B @ C @ F2 @ ( complete_Sup_Sup @ ( set @ B ) @ ( image @ A @ ( set @ B ) @ A3 @ I6 ) ) ) ) ) ).

% inj_on_UNION_chain
thf(fact_8031_the__inv__into__into,axiom,
    ! [B: $tType,A: $tType,F2: A > B,A3: set @ A,X2: B,B3: set @ A] :
      ( ( inj_on @ A @ B @ F2 @ A3 )
     => ( ( member @ B @ X2 @ ( image @ A @ B @ F2 @ A3 ) )
       => ( ( ord_less_eq @ ( set @ A ) @ A3 @ B3 )
         => ( member @ A @ ( the_inv_into @ A @ B @ A3 @ F2 @ X2 ) @ B3 ) ) ) ) ).

% the_inv_into_into
thf(fact_8032_inj__on__strict__subset,axiom,
    ! [B: $tType,A: $tType,F2: A > B,B3: set @ A,A3: set @ A] :
      ( ( inj_on @ A @ B @ F2 @ B3 )
     => ( ( ord_less @ ( set @ A ) @ A3 @ B3 )
       => ( ord_less @ ( set @ B ) @ ( image @ A @ B @ F2 @ A3 ) @ ( image @ A @ B @ F2 @ B3 ) ) ) ) ).

% inj_on_strict_subset
thf(fact_8033_inj__on__iff__surj,axiom,
    ! [A: $tType,B: $tType,A3: set @ A,A10: set @ B] :
      ( ( A3
       != ( bot_bot @ ( set @ A ) ) )
     => ( ( ? [F5: A > B] :
              ( ( inj_on @ A @ B @ F5 @ A3 )
              & ( ord_less_eq @ ( set @ B ) @ ( image @ A @ B @ F5 @ A3 ) @ A10 ) ) )
        = ( ? [G4: B > A] :
              ( ( image @ B @ A @ G4 @ A10 )
              = A3 ) ) ) ) ).

% inj_on_iff_surj
thf(fact_8034_inj__on__image__mem__iff,axiom,
    ! [B: $tType,A: $tType,F2: A > B,B3: set @ A,A2: A,A3: set @ A] :
      ( ( inj_on @ A @ B @ F2 @ B3 )
     => ( ( member @ A @ A2 @ B3 )
       => ( ( ord_less_eq @ ( set @ A ) @ A3 @ B3 )
         => ( ( member @ B @ ( F2 @ A2 ) @ ( image @ A @ B @ F2 @ A3 ) )
            = ( member @ A @ A2 @ A3 ) ) ) ) ) ).

% inj_on_image_mem_iff
thf(fact_8035_inj__on__image__eq__iff,axiom,
    ! [B: $tType,A: $tType,F2: A > B,C6: set @ A,A3: set @ A,B3: set @ A] :
      ( ( inj_on @ A @ B @ F2 @ C6 )
     => ( ( ord_less_eq @ ( set @ A ) @ A3 @ C6 )
       => ( ( ord_less_eq @ ( set @ A ) @ B3 @ C6 )
         => ( ( ( image @ A @ B @ F2 @ A3 )
              = ( image @ A @ B @ F2 @ B3 ) )
            = ( A3 = B3 ) ) ) ) ) ).

% inj_on_image_eq_iff
thf(fact_8036_subset__image__inj,axiom,
    ! [A: $tType,B: $tType,S3: set @ A,F2: B > A,T6: set @ B] :
      ( ( ord_less_eq @ ( set @ A ) @ S3 @ ( image @ B @ A @ F2 @ T6 ) )
      = ( ? [U6: set @ B] :
            ( ( ord_less_eq @ ( set @ B ) @ U6 @ T6 )
            & ( inj_on @ B @ A @ F2 @ U6 )
            & ( S3
              = ( image @ B @ A @ F2 @ U6 ) ) ) ) ) ).

% subset_image_inj
thf(fact_8037_inj__image__subset__iff,axiom,
    ! [B: $tType,A: $tType,F2: A > B,A3: set @ A,B3: set @ A] :
      ( ( inj_on @ A @ B @ F2 @ ( top_top @ ( set @ A ) ) )
     => ( ( ord_less_eq @ ( set @ B ) @ ( image @ A @ B @ F2 @ A3 ) @ ( image @ A @ B @ F2 @ B3 ) )
        = ( ord_less_eq @ ( set @ A ) @ A3 @ B3 ) ) ) ).

% inj_image_subset_iff
thf(fact_8038_endo__inj__surj,axiom,
    ! [A: $tType,A3: set @ A,F2: A > A] :
      ( ( finite_finite @ A @ A3 )
     => ( ( ord_less_eq @ ( set @ A ) @ ( image @ A @ A @ F2 @ A3 ) @ A3 )
       => ( ( inj_on @ A @ A @ F2 @ A3 )
         => ( ( image @ A @ A @ F2 @ A3 )
            = A3 ) ) ) ) ).

% endo_inj_surj
thf(fact_8039_inj__on__finite,axiom,
    ! [B: $tType,A: $tType,F2: A > B,A3: set @ A,B3: set @ B] :
      ( ( inj_on @ A @ B @ F2 @ A3 )
     => ( ( ord_less_eq @ ( set @ B ) @ ( image @ A @ B @ F2 @ A3 ) @ B3 )
       => ( ( finite_finite @ B @ B3 )
         => ( finite_finite @ A @ A3 ) ) ) ) ).

% inj_on_finite
thf(fact_8040_finite__surj__inj,axiom,
    ! [A: $tType,A3: set @ A,F2: A > A] :
      ( ( finite_finite @ A @ A3 )
     => ( ( ord_less_eq @ ( set @ A ) @ A3 @ ( image @ A @ A @ F2 @ A3 ) )
       => ( inj_on @ A @ A @ F2 @ A3 ) ) ) ).

% finite_surj_inj
thf(fact_8041_inj__on__image__Int,axiom,
    ! [B: $tType,A: $tType,F2: A > B,C6: set @ A,A3: set @ A,B3: set @ A] :
      ( ( inj_on @ A @ B @ F2 @ C6 )
     => ( ( ord_less_eq @ ( set @ A ) @ A3 @ C6 )
       => ( ( ord_less_eq @ ( set @ A ) @ B3 @ C6 )
         => ( ( image @ A @ B @ F2 @ ( inf_inf @ ( set @ A ) @ A3 @ B3 ) )
            = ( inf_inf @ ( set @ B ) @ ( image @ A @ B @ F2 @ A3 ) @ ( image @ A @ B @ F2 @ B3 ) ) ) ) ) ) ).

% inj_on_image_Int
thf(fact_8042_inj__on__image__set__diff,axiom,
    ! [B: $tType,A: $tType,F2: A > B,C6: set @ A,A3: set @ A,B3: set @ A] :
      ( ( inj_on @ A @ B @ F2 @ C6 )
     => ( ( ord_less_eq @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ A3 @ B3 ) @ C6 )
       => ( ( ord_less_eq @ ( set @ A ) @ B3 @ C6 )
         => ( ( image @ A @ B @ F2 @ ( minus_minus @ ( set @ A ) @ A3 @ B3 ) )
            = ( minus_minus @ ( set @ B ) @ ( image @ A @ B @ F2 @ A3 ) @ ( image @ A @ B @ F2 @ B3 ) ) ) ) ) ) ).

% inj_on_image_set_diff
thf(fact_8043_pigeonhole,axiom,
    ! [A: $tType,B: $tType,F2: B > A,A3: set @ B] :
      ( ( ord_less @ nat @ ( finite_card @ A @ ( image @ B @ A @ F2 @ A3 ) ) @ ( finite_card @ B @ A3 ) )
     => ~ ( inj_on @ B @ A @ F2 @ A3 ) ) ).

% pigeonhole
thf(fact_8044_pred__nat__trancl__eq__le,axiom,
    ! [M: nat,N2: nat] :
      ( ( member @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ M @ N2 ) @ ( transitive_rtrancl @ nat @ pred_nat ) )
      = ( ord_less_eq @ nat @ M @ N2 ) ) ).

% pred_nat_trancl_eq_le
thf(fact_8045_card__bij__eq,axiom,
    ! [A: $tType,B: $tType,F2: A > B,A3: set @ A,B3: set @ B,G: B > A] :
      ( ( inj_on @ A @ B @ F2 @ A3 )
     => ( ( ord_less_eq @ ( set @ B ) @ ( image @ A @ B @ F2 @ A3 ) @ B3 )
       => ( ( inj_on @ B @ A @ G @ B3 )
         => ( ( ord_less_eq @ ( set @ A ) @ ( image @ B @ A @ G @ B3 ) @ A3 )
           => ( ( finite_finite @ A @ A3 )
             => ( ( finite_finite @ B @ B3 )
               => ( ( finite_card @ A @ A3 )
                  = ( finite_card @ B @ B3 ) ) ) ) ) ) ) ) ).

% card_bij_eq
thf(fact_8046_surjective__iff__injective__gen,axiom,
    ! [B: $tType,A: $tType,S3: set @ A,T6: set @ B,F2: A > B] :
      ( ( finite_finite @ A @ S3 )
     => ( ( finite_finite @ B @ T6 )
       => ( ( ( finite_card @ A @ S3 )
            = ( finite_card @ B @ T6 ) )
         => ( ( ord_less_eq @ ( set @ B ) @ ( image @ A @ B @ F2 @ S3 ) @ T6 )
           => ( ( ! [X5: B] :
                    ( ( member @ B @ X5 @ T6 )
                   => ? [Y5: A] :
                        ( ( member @ A @ Y5 @ S3 )
                        & ( ( F2 @ Y5 )
                          = X5 ) ) ) )
              = ( inj_on @ A @ B @ F2 @ S3 ) ) ) ) ) ) ).

% surjective_iff_injective_gen
thf(fact_8047_inj__image__Compl__subset,axiom,
    ! [B: $tType,A: $tType,F2: A > B,A3: set @ A] :
      ( ( inj_on @ A @ B @ F2 @ ( top_top @ ( set @ A ) ) )
     => ( ord_less_eq @ ( set @ B ) @ ( image @ A @ B @ F2 @ ( uminus_uminus @ ( set @ A ) @ A3 ) ) @ ( uminus_uminus @ ( set @ B ) @ ( image @ A @ B @ F2 @ A3 ) ) ) ) ).

% inj_image_Compl_subset
thf(fact_8048_map__removeAll__inj__on,axiom,
    ! [B: $tType,A: $tType,F2: A > B,X2: A,Xs: list @ A] :
      ( ( inj_on @ A @ B @ F2 @ ( insert @ A @ X2 @ ( set2 @ A @ Xs ) ) )
     => ( ( map @ A @ B @ F2 @ ( removeAll @ A @ X2 @ Xs ) )
        = ( removeAll @ B @ ( F2 @ X2 ) @ ( map @ A @ B @ F2 @ Xs ) ) ) ) ).

% map_removeAll_inj_on
thf(fact_8049_image__INT,axiom,
    ! [B: $tType,A: $tType,C: $tType,F2: A > B,C6: set @ A,A3: set @ C,B3: C > ( set @ A ),J: C] :
      ( ( inj_on @ A @ B @ F2 @ C6 )
     => ( ! [X3: C] :
            ( ( member @ C @ X3 @ A3 )
           => ( ord_less_eq @ ( set @ A ) @ ( B3 @ X3 ) @ C6 ) )
       => ( ( member @ C @ J @ A3 )
         => ( ( image @ A @ B @ F2 @ ( complete_Inf_Inf @ ( set @ A ) @ ( image @ C @ ( set @ A ) @ B3 @ A3 ) ) )
            = ( complete_Inf_Inf @ ( set @ B )
              @ ( image @ C @ ( set @ B )
                @ ^ [X5: C] : ( image @ A @ B @ F2 @ ( B3 @ X5 ) )
                @ A3 ) ) ) ) ) ) ).

% image_INT
thf(fact_8050_rtrancl__insert,axiom,
    ! [A: $tType,A2: A,B2: A,R3: set @ ( product_prod @ A @ A )] :
      ( ( transitive_rtrancl @ A @ ( insert @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ B2 ) @ R3 ) )
      = ( sup_sup @ ( set @ ( product_prod @ A @ A ) ) @ ( transitive_rtrancl @ A @ R3 )
        @ ( collect @ ( product_prod @ A @ A )
          @ ( product_case_prod @ A @ A @ $o
            @ ^ [X5: A,Y5: A] :
                ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X5 @ A2 ) @ ( transitive_rtrancl @ A @ R3 ) )
                & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ B2 @ Y5 ) @ ( transitive_rtrancl @ A @ R3 ) ) ) ) ) ) ) ).

% rtrancl_insert
thf(fact_8051_card__le__inj,axiom,
    ! [B: $tType,A: $tType,A3: set @ A,B3: set @ B] :
      ( ( finite_finite @ A @ A3 )
     => ( ( finite_finite @ B @ B3 )
       => ( ( ord_less_eq @ nat @ ( finite_card @ A @ A3 ) @ ( finite_card @ B @ B3 ) )
         => ? [F4: A > B] :
              ( ( ord_less_eq @ ( set @ B ) @ ( image @ A @ B @ F4 @ A3 ) @ B3 )
              & ( inj_on @ A @ B @ F4 @ A3 ) ) ) ) ) ).

% card_le_inj
thf(fact_8052_card__inj__on__le,axiom,
    ! [A: $tType,B: $tType,F2: A > B,A3: set @ A,B3: set @ B] :
      ( ( inj_on @ A @ B @ F2 @ A3 )
     => ( ( ord_less_eq @ ( set @ B ) @ ( image @ A @ B @ F2 @ A3 ) @ B3 )
       => ( ( finite_finite @ B @ B3 )
         => ( ord_less_eq @ nat @ ( finite_card @ A @ A3 ) @ ( finite_card @ B @ B3 ) ) ) ) ) ).

% card_inj_on_le
thf(fact_8053_inj__on__iff__card__le,axiom,
    ! [A: $tType,B: $tType,A3: set @ A,B3: set @ B] :
      ( ( finite_finite @ A @ A3 )
     => ( ( finite_finite @ B @ B3 )
       => ( ( ? [F5: A > B] :
                ( ( inj_on @ A @ B @ F5 @ A3 )
                & ( ord_less_eq @ ( set @ B ) @ ( image @ A @ B @ F5 @ A3 ) @ B3 ) ) )
          = ( ord_less_eq @ nat @ ( finite_card @ A @ A3 ) @ ( finite_card @ B @ B3 ) ) ) ) ) ).

% inj_on_iff_card_le
thf(fact_8054_log__inj,axiom,
    ! [B2: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ B2 )
     => ( inj_on @ real @ real @ ( log @ B2 ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) ) ).

% log_inj
thf(fact_8055_trancl__insert,axiom,
    ! [A: $tType,Y2: A,X2: A,R3: set @ ( product_prod @ A @ A )] :
      ( ( transitive_trancl @ A @ ( insert @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Y2 @ X2 ) @ R3 ) )
      = ( sup_sup @ ( set @ ( product_prod @ A @ A ) ) @ ( transitive_trancl @ A @ R3 )
        @ ( collect @ ( product_prod @ A @ A )
          @ ( product_case_prod @ A @ A @ $o
            @ ^ [A4: A,B4: A] :
                ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A4 @ Y2 ) @ ( transitive_rtrancl @ A @ R3 ) )
                & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ B4 ) @ ( transitive_rtrancl @ A @ R3 ) ) ) ) ) ) ) ).

% trancl_insert
thf(fact_8056_map__sorted__distinct__set__unique,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F2: B > A,Xs: list @ B,Ys: list @ B] :
          ( ( inj_on @ B @ A @ F2 @ ( sup_sup @ ( set @ B ) @ ( set2 @ B @ Xs ) @ ( set2 @ B @ Ys ) ) )
         => ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( map @ B @ A @ F2 @ Xs ) )
           => ( ( distinct @ A @ ( map @ B @ A @ F2 @ Xs ) )
             => ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( map @ B @ A @ F2 @ Ys ) )
               => ( ( distinct @ A @ ( map @ B @ A @ F2 @ Ys ) )
                 => ( ( ( set2 @ B @ Xs )
                      = ( set2 @ B @ Ys ) )
                   => ( Xs = Ys ) ) ) ) ) ) ) ) ).

% map_sorted_distinct_set_unique
thf(fact_8057_funpow__inj__finite,axiom,
    ! [A: $tType,P4: A > A,X2: A] :
      ( ( inj_on @ A @ A @ P4 @ ( top_top @ ( set @ A ) ) )
     => ( ( finite_finite @ A
          @ ( collect @ A
            @ ^ [Y5: A] :
              ? [N3: nat] :
                ( Y5
                = ( compow @ ( A > A ) @ N3 @ P4 @ X2 ) ) ) )
       => ~ ! [N: nat] :
              ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
             => ( ( compow @ ( A > A ) @ N @ P4 @ X2 )
               != X2 ) ) ) ) ).

% funpow_inj_finite
thf(fact_8058_map__of__mapk__SomeI,axiom,
    ! [A: $tType,B: $tType,C: $tType,F2: A > B,T2: list @ ( product_prod @ A @ C ),K: A,X2: C] :
      ( ( inj_on @ A @ B @ F2 @ ( top_top @ ( set @ A ) ) )
     => ( ( ( map_of @ A @ C @ T2 @ K )
          = ( some @ C @ X2 ) )
       => ( ( map_of @ B @ C
            @ ( map @ ( product_prod @ A @ C ) @ ( product_prod @ B @ C )
              @ ( product_case_prod @ A @ C @ ( product_prod @ B @ C )
                @ ^ [K3: A] : ( product_Pair @ B @ C @ ( F2 @ K3 ) ) )
              @ T2 )
            @ ( F2 @ K ) )
          = ( some @ C @ X2 ) ) ) ) ).

% map_of_mapk_SomeI
thf(fact_8059_Schroeder__Bernstein,axiom,
    ! [A: $tType,B: $tType,F2: A > B,A3: set @ A,B3: set @ B,G: B > A] :
      ( ( inj_on @ A @ B @ F2 @ A3 )
     => ( ( ord_less_eq @ ( set @ B ) @ ( image @ A @ B @ F2 @ A3 ) @ B3 )
       => ( ( inj_on @ B @ A @ G @ B3 )
         => ( ( ord_less_eq @ ( set @ A ) @ ( image @ B @ A @ G @ B3 ) @ A3 )
           => ? [H4: A > B] : ( bij_betw @ A @ B @ H4 @ A3 @ B3 ) ) ) ) ) ).

% Schroeder_Bernstein
thf(fact_8060_If__the__inv__into__in__Func,axiom,
    ! [B: $tType,A: $tType,G: A > B,C6: set @ A,B3: set @ A,X2: A] :
      ( ( inj_on @ A @ B @ G @ C6 )
     => ( ( ord_less_eq @ ( set @ A ) @ C6 @ ( sup_sup @ ( set @ A ) @ B3 @ ( insert @ A @ X2 @ ( bot_bot @ ( set @ A ) ) ) ) )
       => ( member @ ( B > A )
          @ ^ [I4: B] : ( if @ A @ ( member @ B @ I4 @ ( image @ A @ B @ G @ C6 ) ) @ ( the_inv_into @ A @ B @ C6 @ G @ I4 ) @ X2 )
          @ ( bNF_Wellorder_Func @ B @ A @ ( top_top @ ( set @ B ) ) @ ( sup_sup @ ( set @ A ) @ B3 @ ( insert @ A @ X2 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ).

% If_the_inv_into_in_Func
thf(fact_8061_inj__on__rev,axiom,
    ! [A: $tType,A3: set @ ( list @ A )] : ( inj_on @ ( list @ A ) @ ( list @ A ) @ ( rev @ A ) @ A3 ) ).

% inj_on_rev
thf(fact_8062_swap__inj__on,axiom,
    ! [B: $tType,A: $tType,A3: set @ ( product_prod @ A @ B )] :
      ( inj_on @ ( product_prod @ A @ B ) @ ( product_prod @ B @ A )
      @ ( product_case_prod @ A @ B @ ( product_prod @ B @ A )
        @ ^ [I4: A,J3: B] : ( product_Pair @ B @ A @ J3 @ I4 ) )
      @ A3 ) ).

% swap_inj_on
thf(fact_8063_inj__split__Cons,axiom,
    ! [A: $tType,X8: set @ ( product_prod @ ( list @ A ) @ A )] :
      ( inj_on @ ( product_prod @ ( list @ A ) @ A ) @ ( list @ A )
      @ ( product_case_prod @ ( list @ A ) @ A @ ( list @ A )
        @ ^ [Xs3: list @ A,N3: A] : ( cons @ A @ N3 @ Xs3 ) )
      @ X8 ) ).

% inj_split_Cons
thf(fact_8064_inj__on__Cons1,axiom,
    ! [A: $tType,X2: A,A3: set @ ( list @ A )] : ( inj_on @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ X2 ) @ A3 ) ).

% inj_on_Cons1
thf(fact_8065_inj__on__diff__nat,axiom,
    ! [N4: set @ nat,K: nat] :
      ( ! [N: nat] :
          ( ( member @ nat @ N @ N4 )
         => ( ord_less_eq @ nat @ K @ N ) )
     => ( inj_on @ nat @ nat
        @ ^ [N3: nat] : ( minus_minus @ nat @ N3 @ K )
        @ N4 ) ) ).

% inj_on_diff_nat
thf(fact_8066_inj__of__nat,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ( inj_on @ nat @ A @ ( semiring_1_of_nat @ A ) @ ( top_top @ ( set @ nat ) ) ) ) ).

% inj_of_nat
thf(fact_8067_inj__Suc,axiom,
    ! [N4: set @ nat] : ( inj_on @ nat @ nat @ suc @ N4 ) ).

% inj_Suc
thf(fact_8068_inj__Some,axiom,
    ! [A: $tType,A3: set @ A] : ( inj_on @ A @ ( option @ A ) @ ( some @ A ) @ A3 ) ).

% inj_Some
thf(fact_8069_inj__on__convol__ident,axiom,
    ! [B: $tType,A: $tType,F2: A > B,X8: set @ A] :
      ( inj_on @ A @ ( product_prod @ A @ B )
      @ ^ [X5: A] : ( product_Pair @ A @ B @ X5 @ ( F2 @ X5 ) )
      @ X8 ) ).

% inj_on_convol_ident
thf(fact_8070_finite__imp__inj__to__nat__seg,axiom,
    ! [A: $tType,A3: set @ A] :
      ( ( finite_finite @ A @ A3 )
     => ? [F4: A > nat,N: nat] :
          ( ( ( image @ A @ nat @ F4 @ A3 )
            = ( collect @ nat
              @ ^ [I4: nat] : ( ord_less @ nat @ I4 @ N ) ) )
          & ( inj_on @ A @ nat @ F4 @ A3 ) ) ) ).

% finite_imp_inj_to_nat_seg
thf(fact_8071_finite__imp__nat__seg__image__inj__on,axiom,
    ! [A: $tType,A3: set @ A] :
      ( ( finite_finite @ A @ A3 )
     => ? [N: nat,F4: nat > A] :
          ( ( A3
            = ( image @ nat @ A @ F4
              @ ( collect @ nat
                @ ^ [I4: nat] : ( ord_less @ nat @ I4 @ N ) ) ) )
          & ( inj_on @ nat @ A @ F4
            @ ( collect @ nat
              @ ^ [I4: nat] : ( ord_less @ nat @ I4 @ N ) ) ) ) ) ).

% finite_imp_nat_seg_image_inj_on
thf(fact_8072_le__rel__bool__arg__iff,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ( ( ord_less_eq @ ( $o > A ) )
        = ( ^ [X4: $o > A,Y9: $o > A] :
              ( ( ord_less_eq @ A @ ( X4 @ $false ) @ ( Y9 @ $false ) )
              & ( ord_less_eq @ A @ ( X4 @ $true ) @ ( Y9 @ $true ) ) ) ) ) ) ).

% le_rel_bool_arg_iff
thf(fact_8073_inj__on__nth,axiom,
    ! [A: $tType,Xs: list @ A,I6: set @ nat] :
      ( ( distinct @ A @ Xs )
     => ( ! [X3: nat] :
            ( ( member @ nat @ X3 @ I6 )
           => ( ord_less @ nat @ X3 @ ( size_size @ ( list @ A ) @ Xs ) ) )
       => ( inj_on @ nat @ A @ ( nth @ A @ Xs ) @ I6 ) ) ) ).

% inj_on_nth
thf(fact_8074_infinite__iff__countable__subset,axiom,
    ! [A: $tType,S3: set @ A] :
      ( ( ~ ( finite_finite @ A @ S3 ) )
      = ( ? [F5: nat > A] :
            ( ( inj_on @ nat @ A @ F5 @ ( top_top @ ( set @ nat ) ) )
            & ( ord_less_eq @ ( set @ A ) @ ( image @ nat @ A @ F5 @ ( top_top @ ( set @ nat ) ) ) @ S3 ) ) ) ) ).

% infinite_iff_countable_subset
thf(fact_8075_infinite__countable__subset,axiom,
    ! [A: $tType,S3: set @ A] :
      ( ~ ( finite_finite @ A @ S3 )
     => ? [F4: nat > A] :
          ( ( inj_on @ nat @ A @ F4 @ ( top_top @ ( set @ nat ) ) )
          & ( ord_less_eq @ ( set @ A ) @ ( image @ nat @ A @ F4 @ ( top_top @ ( set @ nat ) ) ) @ S3 ) ) ) ).

% infinite_countable_subset
thf(fact_8076_summable__reindex,axiom,
    ! [F2: nat > real,G: nat > nat] :
      ( ( summable @ real @ F2 )
     => ( ( inj_on @ nat @ nat @ G @ ( top_top @ ( set @ nat ) ) )
       => ( ! [X3: nat] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( F2 @ X3 ) )
         => ( summable @ real @ ( comp @ nat @ real @ nat @ F2 @ G ) ) ) ) ) ).

% summable_reindex
thf(fact_8077_inj__on__funpow__least,axiom,
    ! [A: $tType,N2: nat,F2: A > A,S2: A] :
      ( ( ( compow @ ( A > A ) @ N2 @ F2 @ S2 )
        = S2 )
     => ( ! [M3: nat] :
            ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M3 )
           => ( ( ord_less @ nat @ M3 @ N2 )
             => ( ( compow @ ( A > A ) @ M3 @ F2 @ S2 )
               != S2 ) ) )
       => ( inj_on @ nat @ A
          @ ^ [K3: nat] : ( compow @ ( A > A ) @ K3 @ F2 @ S2 )
          @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N2 ) ) ) ) ).

% inj_on_funpow_least
thf(fact_8078_suminf__reindex__mono,axiom,
    ! [F2: nat > real,G: nat > nat] :
      ( ( summable @ real @ F2 )
     => ( ( inj_on @ nat @ nat @ G @ ( top_top @ ( set @ nat ) ) )
       => ( ! [X3: nat] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( F2 @ X3 ) )
         => ( ord_less_eq @ real @ ( suminf @ real @ ( comp @ nat @ real @ nat @ F2 @ G ) ) @ ( suminf @ real @ F2 ) ) ) ) ) ).

% suminf_reindex_mono
thf(fact_8079_inj__on__char__of__nat,axiom,
    inj_on @ nat @ char @ ( unique5772411509450598832har_of @ nat ) @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( numeral_numeral @ nat @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ).

% inj_on_char_of_nat
thf(fact_8080_suminf__reindex,axiom,
    ! [F2: nat > real,G: nat > nat] :
      ( ( summable @ real @ F2 )
     => ( ( inj_on @ nat @ nat @ G @ ( top_top @ ( set @ nat ) ) )
       => ( ! [X3: nat] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( F2 @ X3 ) )
         => ( ! [X3: nat] :
                ( ~ ( member @ nat @ X3 @ ( image @ nat @ nat @ G @ ( top_top @ ( set @ nat ) ) ) )
               => ( ( F2 @ X3 )
                  = ( zero_zero @ real ) ) )
           => ( ( suminf @ real @ ( comp @ nat @ real @ nat @ F2 @ G ) )
              = ( suminf @ real @ F2 ) ) ) ) ) ) ).

% suminf_reindex
thf(fact_8081_Func__map__surj,axiom,
    ! [C: $tType,A: $tType,D: $tType,B: $tType,F1: B > A,A18: set @ B,B16: set @ A,F22: C > D,B23: set @ C,A26: set @ D] :
      ( ( ( image @ B @ A @ F1 @ A18 )
        = B16 )
     => ( ( inj_on @ C @ D @ F22 @ B23 )
       => ( ( ord_less_eq @ ( set @ D ) @ ( image @ C @ D @ F22 @ B23 ) @ A26 )
         => ( ( ( B23
                = ( bot_bot @ ( set @ C ) ) )
             => ( A26
                = ( bot_bot @ ( set @ D ) ) ) )
           => ( ( bNF_Wellorder_Func @ C @ A @ B23 @ B16 )
              = ( image @ ( D > B ) @ ( C > A ) @ ( bNF_We4925052301507509544nc_map @ C @ B @ A @ D @ B23 @ F1 @ F22 ) @ ( bNF_Wellorder_Func @ D @ B @ A26 @ A18 ) ) ) ) ) ) ) ).

% Func_map_surj
thf(fact_8082_all__subset__image__inj,axiom,
    ! [A: $tType,B: $tType,F2: B > A,S3: set @ B,P: ( set @ A ) > $o] :
      ( ( ! [T9: set @ A] :
            ( ( ord_less_eq @ ( set @ A ) @ T9 @ ( image @ B @ A @ F2 @ S3 ) )
           => ( P @ T9 ) ) )
      = ( ! [T9: set @ B] :
            ( ( ( ord_less_eq @ ( set @ B ) @ T9 @ S3 )
              & ( inj_on @ B @ A @ F2 @ T9 ) )
           => ( P @ ( image @ B @ A @ F2 @ T9 ) ) ) ) ) ).

% all_subset_image_inj
thf(fact_8083_Func__map,axiom,
    ! [A: $tType,B: $tType,D: $tType,C: $tType,G: A > B,A26: set @ A,A18: set @ B,F1: B > C,B16: set @ C,F22: D > A,B23: set @ D] :
      ( ( member @ ( A > B ) @ G @ ( bNF_Wellorder_Func @ A @ B @ A26 @ A18 ) )
     => ( ( ord_less_eq @ ( set @ C ) @ ( image @ B @ C @ F1 @ A18 ) @ B16 )
       => ( ( ord_less_eq @ ( set @ A ) @ ( image @ D @ A @ F22 @ B23 ) @ A26 )
         => ( member @ ( D > C ) @ ( bNF_We4925052301507509544nc_map @ D @ B @ C @ A @ B23 @ F1 @ F22 @ G ) @ ( bNF_Wellorder_Func @ D @ C @ B23 @ B16 ) ) ) ) ) ).

% Func_map
thf(fact_8084_ex__subset__image__inj,axiom,
    ! [A: $tType,B: $tType,F2: B > A,S3: set @ B,P: ( set @ A ) > $o] :
      ( ( ? [T9: set @ A] :
            ( ( ord_less_eq @ ( set @ A ) @ T9 @ ( image @ B @ A @ F2 @ S3 ) )
            & ( P @ T9 ) ) )
      = ( ? [T9: set @ B] :
            ( ( ord_less_eq @ ( set @ B ) @ T9 @ S3 )
            & ( inj_on @ B @ A @ F2 @ T9 )
            & ( P @ ( image @ B @ A @ F2 @ T9 ) ) ) ) ) ).

% ex_subset_image_inj
thf(fact_8085_ran__map__upd__Some,axiom,
    ! [B: $tType,A: $tType,M: B > ( option @ A ),X2: B,Y2: A,Z: A] :
      ( ( ( M @ X2 )
        = ( some @ A @ Y2 ) )
     => ( ( inj_on @ B @ ( option @ A ) @ M @ ( dom @ B @ A @ M ) )
       => ( ~ ( member @ A @ Z @ ( ran @ B @ A @ M ) )
         => ( ( ran @ B @ A @ ( fun_upd @ B @ ( option @ A ) @ M @ X2 @ ( some @ A @ Z ) ) )
            = ( sup_sup @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ ( ran @ B @ A @ M ) @ ( insert @ A @ Y2 @ ( bot_bot @ ( set @ A ) ) ) ) @ ( insert @ A @ Z @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ).

% ran_map_upd_Some
thf(fact_8086_set__list__bind,axiom,
    ! [A: $tType,B: $tType,Xs: list @ B,F2: B > ( list @ A )] :
      ( ( set2 @ A @ ( bind @ B @ A @ Xs @ F2 ) )
      = ( complete_Sup_Sup @ ( set @ A )
        @ ( image @ B @ ( set @ A )
          @ ^ [X5: B] : ( set2 @ A @ ( F2 @ X5 ) )
          @ ( set2 @ B @ Xs ) ) ) ) ).

% set_list_bind
thf(fact_8087_bind__simps_I1_J,axiom,
    ! [B: $tType,A: $tType,F2: B > ( list @ A )] :
      ( ( bind @ B @ A @ ( nil @ B ) @ F2 )
      = ( nil @ A ) ) ).

% bind_simps(1)
thf(fact_8088_dom__eq__empty__conv,axiom,
    ! [B: $tType,A: $tType,F2: A > ( option @ B )] :
      ( ( ( dom @ A @ B @ F2 )
        = ( bot_bot @ ( set @ A ) ) )
      = ( F2
        = ( ^ [X5: A] : ( none @ B ) ) ) ) ).

% dom_eq_empty_conv
thf(fact_8089_fun__upd__None__if__notin__dom,axiom,
    ! [B: $tType,A: $tType,K: A,M: A > ( option @ B )] :
      ( ~ ( member @ A @ K @ ( dom @ A @ B @ M ) )
     => ( ( fun_upd @ A @ ( option @ B ) @ M @ K @ ( none @ B ) )
        = M ) ) ).

% fun_upd_None_if_notin_dom
thf(fact_8090_bind__simps_I2_J,axiom,
    ! [A: $tType,B: $tType,X2: B,Xs: list @ B,F2: B > ( list @ A )] :
      ( ( bind @ B @ A @ ( cons @ B @ X2 @ Xs ) @ F2 )
      = ( append @ A @ ( F2 @ X2 ) @ ( bind @ B @ A @ Xs @ F2 ) ) ) ).

% bind_simps(2)
thf(fact_8091_dom__const,axiom,
    ! [B: $tType,A: $tType,F2: A > B] :
      ( ( dom @ A @ B
        @ ^ [X5: A] : ( some @ B @ ( F2 @ X5 ) ) )
      = ( top_top @ ( set @ A ) ) ) ).

% dom_const
thf(fact_8092_dom__empty,axiom,
    ! [B: $tType,A: $tType] :
      ( ( dom @ A @ B
        @ ^ [X5: A] : ( none @ B ) )
      = ( bot_bot @ ( set @ A ) ) ) ).

% dom_empty
thf(fact_8093_dom__fun__upd,axiom,
    ! [B: $tType,A: $tType,Y2: option @ B,F2: A > ( option @ B ),X2: A] :
      ( ( ( Y2
          = ( none @ B ) )
       => ( ( dom @ A @ B @ ( fun_upd @ A @ ( option @ B ) @ F2 @ X2 @ Y2 ) )
          = ( minus_minus @ ( set @ A ) @ ( dom @ A @ B @ F2 ) @ ( insert @ A @ X2 @ ( bot_bot @ ( set @ A ) ) ) ) ) )
      & ( ( Y2
         != ( none @ B ) )
       => ( ( dom @ A @ B @ ( fun_upd @ A @ ( option @ B ) @ F2 @ X2 @ Y2 ) )
          = ( insert @ A @ X2 @ ( dom @ A @ B @ F2 ) ) ) ) ) ).

% dom_fun_upd
thf(fact_8094_list__bind__cong,axiom,
    ! [B: $tType,A: $tType,Xs: list @ A,Ys: list @ A,F2: A > ( list @ B ),G: A > ( list @ B )] :
      ( ( Xs = Ys )
     => ( ! [X3: A] :
            ( ( member @ A @ X3 @ ( set2 @ A @ Xs ) )
           => ( ( F2 @ X3 )
              = ( G @ X3 ) ) )
       => ( ( bind @ A @ B @ Xs @ F2 )
          = ( bind @ A @ B @ Ys @ G ) ) ) ) ).

% list_bind_cong
thf(fact_8095_insert__dom,axiom,
    ! [A: $tType,B: $tType,F2: B > ( option @ A ),X2: B,Y2: A] :
      ( ( ( F2 @ X2 )
        = ( some @ A @ Y2 ) )
     => ( ( insert @ B @ X2 @ ( dom @ B @ A @ F2 ) )
        = ( dom @ B @ A @ F2 ) ) ) ).

% insert_dom
thf(fact_8096_dom__minus,axiom,
    ! [A: $tType,B: $tType,F2: B > ( option @ A ),X2: B,A3: set @ B] :
      ( ( ( F2 @ X2 )
        = ( none @ A ) )
     => ( ( minus_minus @ ( set @ B ) @ ( dom @ B @ A @ F2 ) @ ( insert @ B @ X2 @ A3 ) )
        = ( minus_minus @ ( set @ B ) @ ( dom @ B @ A @ F2 ) @ A3 ) ) ) ).

% dom_minus
thf(fact_8097_finite__map__freshness,axiom,
    ! [A: $tType,B: $tType,F2: A > ( option @ B )] :
      ( ( finite_finite @ A @ ( dom @ A @ B @ F2 ) )
     => ( ~ ( finite_finite @ A @ ( top_top @ ( set @ A ) ) )
       => ? [X3: A] :
            ( ( F2 @ X3 )
            = ( none @ B ) ) ) ) ).

% finite_map_freshness
thf(fact_8098_domD,axiom,
    ! [A: $tType,B: $tType,A2: A,M: A > ( option @ B )] :
      ( ( member @ A @ A2 @ ( dom @ A @ B @ M ) )
     => ? [B5: B] :
          ( ( M @ A2 )
          = ( some @ B @ B5 ) ) ) ).

% domD
thf(fact_8099_domI,axiom,
    ! [A: $tType,B: $tType,M: B > ( option @ A ),A2: B,B2: A] :
      ( ( ( M @ A2 )
        = ( some @ A @ B2 ) )
     => ( member @ B @ A2 @ ( dom @ B @ A @ M ) ) ) ).

% domI
thf(fact_8100_dom__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( dom @ A @ B )
      = ( ^ [M6: A > ( option @ B )] :
            ( collect @ A
            @ ^ [A4: A] :
                ( ( M6 @ A4 )
               != ( none @ B ) ) ) ) ) ).

% dom_def
thf(fact_8101_domIff,axiom,
    ! [A: $tType,B: $tType,A2: A,M: A > ( option @ B )] :
      ( ( member @ A @ A2 @ ( dom @ A @ B @ M ) )
      = ( ( ( M @ A2 )
         != ( none @ B ) ) ) ) ).

% domIff
thf(fact_8102_finite__set__of__finite__maps,axiom,
    ! [B: $tType,A: $tType,A3: set @ A,B3: set @ B] :
      ( ( finite_finite @ A @ A3 )
     => ( ( finite_finite @ B @ B3 )
       => ( finite_finite @ ( A > ( option @ B ) )
          @ ( collect @ ( A > ( option @ B ) )
            @ ^ [M6: A > ( option @ B )] :
                ( ( ( dom @ A @ B @ M6 )
                  = A3 )
                & ( ord_less_eq @ ( set @ B ) @ ( ran @ A @ B @ M6 ) @ B3 ) ) ) ) ) ) ).

% finite_set_of_finite_maps
thf(fact_8103_graph__eq__to__snd__dom,axiom,
    ! [B: $tType,A: $tType] :
      ( ( graph @ A @ B )
      = ( ^ [M6: A > ( option @ B )] :
            ( image @ A @ ( product_prod @ A @ B )
            @ ^ [X5: A] : ( product_Pair @ A @ B @ X5 @ ( the2 @ B @ ( M6 @ X5 ) ) )
            @ ( dom @ A @ B @ M6 ) ) ) ) ).

% graph_eq_to_snd_dom
thf(fact_8104_finite__Map__induct,axiom,
    ! [B: $tType,A: $tType,M: A > ( option @ B ),P: ( A > ( option @ B ) ) > $o] :
      ( ( finite_finite @ A @ ( dom @ A @ B @ M ) )
     => ( ( P
          @ ^ [X5: A] : ( none @ B ) )
       => ( ! [K2: A,V3: B,M3: A > ( option @ B )] :
              ( ( finite_finite @ A @ ( dom @ A @ B @ M3 ) )
             => ( ~ ( member @ A @ K2 @ ( dom @ A @ B @ M3 ) )
               => ( ( P @ M3 )
                 => ( P @ ( fun_upd @ A @ ( option @ B ) @ M3 @ K2 @ ( some @ B @ V3 ) ) ) ) ) )
         => ( P @ M ) ) ) ) ).

% finite_Map_induct
thf(fact_8105_List_Obind__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( bind @ A @ B )
      = ( ^ [Xs3: list @ A,F5: A > ( list @ B )] : ( concat @ B @ ( map @ A @ ( list @ B ) @ F5 @ Xs3 ) ) ) ) ).

% List.bind_def
thf(fact_8106_dom__eq__singleton__conv,axiom,
    ! [A: $tType,B: $tType,F2: A > ( option @ B ),X2: A] :
      ( ( ( dom @ A @ B @ F2 )
        = ( insert @ A @ X2 @ ( bot_bot @ ( set @ A ) ) ) )
      = ( ? [V5: B] :
            ( F2
            = ( fun_upd @ A @ ( option @ B )
              @ ^ [X5: A] : ( none @ B )
              @ X2
              @ ( some @ B @ V5 ) ) ) ) ) ).

% dom_eq_singleton_conv
thf(fact_8107_map__of__map__keys,axiom,
    ! [B: $tType,A: $tType,Xs: list @ A,M: A > ( option @ B )] :
      ( ( ( set2 @ A @ Xs )
        = ( dom @ A @ B @ M ) )
     => ( ( map_of @ A @ B
          @ ( map @ A @ ( product_prod @ A @ B )
            @ ^ [K3: A] : ( product_Pair @ A @ B @ K3 @ ( the2 @ B @ ( M @ K3 ) ) )
            @ Xs ) )
        = M ) ) ).

% map_of_map_keys
thf(fact_8108_has__derivative__power__int_H,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [X2: A,N2: int,S3: set @ A] :
          ( ( X2
           != ( zero_zero @ A ) )
         => ( has_derivative @ A @ A
            @ ^ [X5: A] : ( power_int @ A @ X5 @ N2 )
            @ ^ [Y5: A] : ( times_times @ A @ Y5 @ ( times_times @ A @ ( ring_1_of_int @ A @ N2 ) @ ( power_int @ A @ X2 @ ( minus_minus @ int @ N2 @ ( one_one @ int ) ) ) ) )
            @ ( topolo174197925503356063within @ A @ X2 @ S3 ) ) ) ) ).

% has_derivative_power_int'
thf(fact_8109_has__derivative__power__int,axiom,
    ! [A: $tType,C: $tType] :
      ( ( ( real_V822414075346904944vector @ C )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [F2: C > A,X2: C,F8: C > A,S3: set @ C,N2: int] :
          ( ( ( F2 @ X2 )
           != ( zero_zero @ A ) )
         => ( ( has_derivative @ C @ A @ F2 @ F8 @ ( topolo174197925503356063within @ C @ X2 @ S3 ) )
           => ( has_derivative @ C @ A
              @ ^ [X5: C] : ( power_int @ A @ ( F2 @ X5 ) @ N2 )
              @ ^ [H: C] : ( times_times @ A @ ( F8 @ H ) @ ( times_times @ A @ ( ring_1_of_int @ A @ N2 ) @ ( power_int @ A @ ( F2 @ X2 ) @ ( minus_minus @ int @ N2 @ ( one_one @ int ) ) ) ) )
              @ ( topolo174197925503356063within @ C @ X2 @ S3 ) ) ) ) ) ).

% has_derivative_power_int
thf(fact_8110_power__int__1__left,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [N2: int] :
          ( ( power_int @ A @ ( one_one @ A ) @ N2 )
          = ( one_one @ A ) ) ) ).

% power_int_1_left
thf(fact_8111_power__int__mult__distrib__numeral1,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [W: num,Y2: A,M: int] :
          ( ( power_int @ A @ ( times_times @ A @ ( numeral_numeral @ A @ W ) @ Y2 ) @ M )
          = ( times_times @ A @ ( power_int @ A @ ( numeral_numeral @ A @ W ) @ M ) @ ( power_int @ A @ Y2 @ M ) ) ) ) ).

% power_int_mult_distrib_numeral1
thf(fact_8112_power__int__mult__distrib__numeral2,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [X2: A,W: num,M: int] :
          ( ( power_int @ A @ ( times_times @ A @ X2 @ ( numeral_numeral @ A @ W ) ) @ M )
          = ( times_times @ A @ ( power_int @ A @ X2 @ M ) @ ( power_int @ A @ ( numeral_numeral @ A @ W ) @ M ) ) ) ) ).

% power_int_mult_distrib_numeral2
thf(fact_8113_power__int__0__left,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [M: int] :
          ( ( M
           != ( zero_zero @ int ) )
         => ( ( power_int @ A @ ( zero_zero @ A ) @ M )
            = ( zero_zero @ A ) ) ) ) ).

% power_int_0_left
thf(fact_8114_power__int__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [X2: A,N2: int] :
          ( ( ( power_int @ A @ X2 @ N2 )
            = ( zero_zero @ A ) )
          = ( ( X2
              = ( zero_zero @ A ) )
            & ( N2
             != ( zero_zero @ int ) ) ) ) ) ).

% power_int_eq_0_iff
thf(fact_8115_power__int__0__right,axiom,
    ! [B: $tType] :
      ( ( ( inverse @ B )
        & ( power @ B ) )
     => ! [X2: B] :
          ( ( power_int @ B @ X2 @ ( zero_zero @ int ) )
          = ( one_one @ B ) ) ) ).

% power_int_0_right
thf(fact_8116_power__int__of__nat,axiom,
    ! [A: $tType] :
      ( ( ( inverse @ A )
        & ( power @ A ) )
     => ! [X2: A,N2: nat] :
          ( ( power_int @ A @ X2 @ ( semiring_1_of_nat @ int @ N2 ) )
          = ( power_power @ A @ X2 @ N2 ) ) ) ).

% power_int_of_nat
thf(fact_8117_power__int__mult__numeral,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [X2: A,M: num,N2: num] :
          ( ( power_int @ A @ ( power_int @ A @ X2 @ ( numeral_numeral @ int @ M ) ) @ ( numeral_numeral @ int @ N2 ) )
          = ( power_int @ A @ X2 @ ( numeral_numeral @ int @ ( times_times @ num @ M @ N2 ) ) ) ) ) ).

% power_int_mult_numeral
thf(fact_8118_power__int__minus__one__mult__self,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [M: int] :
          ( ( times_times @ A @ ( power_int @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ M ) @ ( power_int @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ M ) )
          = ( one_one @ A ) ) ) ).

% power_int_minus_one_mult_self
thf(fact_8119_power__int__minus__one__mult__self_H,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [M: int,B2: A] :
          ( ( times_times @ A @ ( power_int @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ M ) @ ( times_times @ A @ ( power_int @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ M ) @ B2 ) )
          = B2 ) ) ).

% power_int_minus_one_mult_self'
thf(fact_8120_power__int__numeral,axiom,
    ! [A: $tType] :
      ( ( ( inverse @ A )
        & ( power @ A ) )
     => ! [X2: A,N2: num] :
          ( ( power_int @ A @ X2 @ ( numeral_numeral @ int @ N2 ) )
          = ( power_power @ A @ X2 @ ( numeral_numeral @ nat @ N2 ) ) ) ) ).

% power_int_numeral
thf(fact_8121_of__real__eq__numeral__power__int__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( real_V5047593784448816457lgebra @ A )
     => ! [Y2: real,X2: num,N2: int] :
          ( ( ( real_Vector_of_real @ A @ Y2 )
            = ( power_int @ A @ ( numeral_numeral @ A @ X2 ) @ N2 ) )
          = ( Y2
            = ( power_int @ real @ ( numeral_numeral @ real @ X2 ) @ N2 ) ) ) ) ).

% of_real_eq_numeral_power_int_cancel_iff
thf(fact_8122_numeral__power__int__eq__of__real__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( real_V5047593784448816457lgebra @ A )
     => ! [X2: num,N2: int,Y2: real] :
          ( ( ( power_int @ A @ ( numeral_numeral @ A @ X2 ) @ N2 )
            = ( real_Vector_of_real @ A @ Y2 ) )
          = ( ( power_int @ real @ ( numeral_numeral @ real @ X2 ) @ N2 )
            = Y2 ) ) ) ).

% numeral_power_int_eq_of_real_cancel_iff
thf(fact_8123_power__int__add__numeral,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [X2: A,M: num,N2: num] :
          ( ( times_times @ A @ ( power_int @ A @ X2 @ ( numeral_numeral @ int @ M ) ) @ ( power_int @ A @ X2 @ ( numeral_numeral @ int @ N2 ) ) )
          = ( power_int @ A @ X2 @ ( numeral_numeral @ int @ ( plus_plus @ num @ M @ N2 ) ) ) ) ) ).

% power_int_add_numeral
thf(fact_8124_power__int__add__numeral2,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [X2: A,M: num,N2: num,B2: A] :
          ( ( times_times @ A @ ( power_int @ A @ X2 @ ( numeral_numeral @ int @ M ) ) @ ( times_times @ A @ ( power_int @ A @ X2 @ ( numeral_numeral @ int @ N2 ) ) @ B2 ) )
          = ( times_times @ A @ ( power_int @ A @ X2 @ ( numeral_numeral @ int @ ( plus_plus @ num @ M @ N2 ) ) ) @ B2 ) ) ) ).

% power_int_add_numeral2
thf(fact_8125_power__int__mono__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A,N2: int] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 )
           => ( ( ord_less @ int @ ( zero_zero @ int ) @ N2 )
             => ( ( ord_less_eq @ A @ ( power_int @ A @ A2 @ N2 ) @ ( power_int @ A @ B2 @ N2 ) )
                = ( ord_less_eq @ A @ A2 @ B2 ) ) ) ) ) ) ).

% power_int_mono_iff
thf(fact_8126_power__int__minus__left__even,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [N2: int,A2: A] :
          ( ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N2 )
         => ( ( power_int @ A @ ( uminus_uminus @ A @ A2 ) @ N2 )
            = ( power_int @ A @ A2 @ N2 ) ) ) ) ).

% power_int_minus_left_even
thf(fact_8127_power__int__minus__left__odd,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [N2: int,A2: A] :
          ( ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N2 )
         => ( ( power_int @ A @ ( uminus_uminus @ A @ A2 ) @ N2 )
            = ( uminus_uminus @ A @ ( power_int @ A @ A2 @ N2 ) ) ) ) ) ).

% power_int_minus_left_odd
thf(fact_8128_power__int__numeral__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [M: num,N2: num] :
          ( ( power_int @ A @ ( numeral_numeral @ A @ M ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N2 ) ) )
          = ( inverse_inverse @ A @ ( numeral_numeral @ A @ ( pow @ M @ N2 ) ) ) ) ) ).

% power_int_numeral_neg_numeral
thf(fact_8129_differentiable__power__int,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V3459762299906320749_field @ B ) )
     => ! [F2: A > B,X2: A,S2: set @ A,N2: int] :
          ( ( differentiable @ A @ B @ F2 @ ( topolo174197925503356063within @ A @ X2 @ S2 ) )
         => ( ( ( F2 @ X2 )
             != ( zero_zero @ B ) )
           => ( differentiable @ A @ B
              @ ^ [X5: A] : ( power_int @ B @ ( F2 @ X5 ) @ N2 )
              @ ( topolo174197925503356063within @ A @ X2 @ S2 ) ) ) ) ) ).

% differentiable_power_int
thf(fact_8130_continuous__at__within__power__int,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topological_t2_space @ A )
        & ( real_V8999393235501362500lgebra @ B ) )
     => ! [A2: A,S2: set @ A,F2: A > B,N2: int] :
          ( ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ S2 ) @ F2 )
         => ( ( ( F2 @ A2 )
             != ( zero_zero @ B ) )
           => ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ S2 )
              @ ^ [X5: A] : ( power_int @ B @ ( F2 @ X5 ) @ N2 ) ) ) ) ) ).

% continuous_at_within_power_int
thf(fact_8131_tendsto__power__int,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [F2: B > A,A2: A,F3: filter @ B,N2: int] :
          ( ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ A2 ) @ F3 )
         => ( ( A2
             != ( zero_zero @ A ) )
           => ( filterlim @ B @ A
              @ ^ [X5: B] : ( power_int @ A @ ( F2 @ X5 ) @ N2 )
              @ ( topolo7230453075368039082e_nhds @ A @ ( power_int @ A @ A2 @ N2 ) )
              @ F3 ) ) ) ) ).

% tendsto_power_int
thf(fact_8132_continuous__on__power__int,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topolo4958980785337419405_space @ A )
        & ( real_V8999393235501362500lgebra @ B ) )
     => ! [S2: set @ A,F2: A > B,N2: int] :
          ( ( topolo81223032696312382ous_on @ A @ B @ S2 @ F2 )
         => ( ! [X3: A] :
                ( ( member @ A @ X3 @ S2 )
               => ( ( F2 @ X3 )
                 != ( zero_zero @ B ) ) )
           => ( topolo81223032696312382ous_on @ A @ B @ S2
              @ ^ [X5: A] : ( power_int @ B @ ( F2 @ X5 ) @ N2 ) ) ) ) ) ).

% continuous_on_power_int
thf(fact_8133_power__int__strict__increasing,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [N2: int,N4: int,A2: A] :
          ( ( ord_less @ int @ N2 @ N4 )
         => ( ( ord_less @ A @ ( one_one @ A ) @ A2 )
           => ( ord_less @ A @ ( power_int @ A @ A2 @ N2 ) @ ( power_int @ A @ A2 @ N4 ) ) ) ) ) ).

% power_int_strict_increasing
thf(fact_8134_power__int__minus__one__minus,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [N2: int] :
          ( ( power_int @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( uminus_uminus @ int @ N2 ) )
          = ( power_int @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ N2 ) ) ) ).

% power_int_minus_one_minus
thf(fact_8135_power__int__diff,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [X2: A,M: int,N2: int] :
          ( ( ( X2
             != ( zero_zero @ A ) )
            | ( M != N2 ) )
         => ( ( power_int @ A @ X2 @ ( minus_minus @ int @ M @ N2 ) )
            = ( divide_divide @ A @ ( power_int @ A @ X2 @ M ) @ ( power_int @ A @ X2 @ N2 ) ) ) ) ) ).

% power_int_diff
thf(fact_8136_power__int__not__zero,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [X2: A,N2: int] :
          ( ( ( X2
             != ( zero_zero @ A ) )
            | ( N2
              = ( zero_zero @ int ) ) )
         => ( ( power_int @ A @ X2 @ N2 )
           != ( zero_zero @ A ) ) ) ) ).

% power_int_not_zero
thf(fact_8137_power__int__divide__distrib,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [X2: A,Y2: A,M: int] :
          ( ( power_int @ A @ ( divide_divide @ A @ X2 @ Y2 ) @ M )
          = ( divide_divide @ A @ ( power_int @ A @ X2 @ M ) @ ( power_int @ A @ Y2 @ M ) ) ) ) ).

% power_int_divide_distrib
thf(fact_8138_power__int__commutes,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [X2: A,N2: int] :
          ( ( times_times @ A @ ( power_int @ A @ X2 @ N2 ) @ X2 )
          = ( times_times @ A @ X2 @ ( power_int @ A @ X2 @ N2 ) ) ) ) ).

% power_int_commutes
thf(fact_8139_power__int__mult__distrib,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [X2: A,Y2: A,M: int] :
          ( ( power_int @ A @ ( times_times @ A @ X2 @ Y2 ) @ M )
          = ( times_times @ A @ ( power_int @ A @ X2 @ M ) @ ( power_int @ A @ Y2 @ M ) ) ) ) ).

% power_int_mult_distrib
thf(fact_8140_power__int__mult,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [X2: A,M: int,N2: int] :
          ( ( power_int @ A @ X2 @ ( times_times @ int @ M @ N2 ) )
          = ( power_int @ A @ ( power_int @ A @ X2 @ M ) @ N2 ) ) ) ).

% power_int_mult
thf(fact_8141_power__int__one__over,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [X2: A,N2: int] :
          ( ( power_int @ A @ ( divide_divide @ A @ ( one_one @ A ) @ X2 ) @ N2 )
          = ( divide_divide @ A @ ( one_one @ A ) @ ( power_int @ A @ X2 @ N2 ) ) ) ) ).

% power_int_one_over
thf(fact_8142_zero__less__power__int,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X2: A,N2: int] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ X2 )
         => ( ord_less @ A @ ( zero_zero @ A ) @ ( power_int @ A @ X2 @ N2 ) ) ) ) ).

% zero_less_power_int
thf(fact_8143_power__int__0__left__If,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [M: int] :
          ( ( ( M
              = ( zero_zero @ int ) )
           => ( ( power_int @ A @ ( zero_zero @ A ) @ M )
              = ( one_one @ A ) ) )
          & ( ( M
             != ( zero_zero @ int ) )
           => ( ( power_int @ A @ ( zero_zero @ A ) @ M )
              = ( zero_zero @ A ) ) ) ) ) ).

% power_int_0_left_If
thf(fact_8144_power__int__minus__one__diff__commute,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: int,B2: int] :
          ( ( power_int @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( minus_minus @ int @ A2 @ B2 ) )
          = ( power_int @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( minus_minus @ int @ B2 @ A2 ) ) ) ) ).

% power_int_minus_one_diff_commute
thf(fact_8145_continuous__power__int,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topological_t2_space @ A )
        & ( real_V8999393235501362500lgebra @ B ) )
     => ! [F3: filter @ A,F2: A > B,N2: int] :
          ( ( topolo3448309680560233919inuous @ A @ B @ F3 @ F2 )
         => ( ( ( F2
                @ ( topolo3827282254853284352ce_Lim @ A @ A @ F3
                  @ ^ [X5: A] : X5 ) )
             != ( zero_zero @ B ) )
           => ( topolo3448309680560233919inuous @ A @ B @ F3
              @ ^ [X5: A] : ( power_int @ B @ ( F2 @ X5 ) @ N2 ) ) ) ) ) ).

% continuous_power_int
thf(fact_8146_power__int__increasing,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [N2: int,N4: int,A2: A] :
          ( ( ord_less_eq @ int @ N2 @ N4 )
         => ( ( ord_less_eq @ A @ ( one_one @ A ) @ A2 )
           => ( ord_less_eq @ A @ ( power_int @ A @ A2 @ N2 ) @ ( power_int @ A @ A2 @ N4 ) ) ) ) ) ).

% power_int_increasing
thf(fact_8147_zero__le__power__int,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X2: A,N2: int] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X2 )
         => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( power_int @ A @ X2 @ N2 ) ) ) ) ).

% zero_le_power_int
thf(fact_8148_power__int__strict__decreasing,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [N2: int,N4: int,A2: A] :
          ( ( ord_less @ int @ N2 @ N4 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
           => ( ( ord_less @ A @ A2 @ ( one_one @ A ) )
             => ( ord_less @ A @ ( power_int @ A @ A2 @ N4 ) @ ( power_int @ A @ A2 @ N2 ) ) ) ) ) ) ).

% power_int_strict_decreasing
thf(fact_8149_power__int__mono,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X2: A,Y2: A,N2: int] :
          ( ( ord_less_eq @ A @ X2 @ Y2 )
         => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ N2 )
           => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X2 )
             => ( ord_less_eq @ A @ ( power_int @ A @ X2 @ N2 ) @ ( power_int @ A @ Y2 @ N2 ) ) ) ) ) ) ).

% power_int_mono
thf(fact_8150_power__int__strict__antimono,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A,N2: int] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
           => ( ( ord_less @ int @ N2 @ ( zero_zero @ int ) )
             => ( ord_less @ A @ ( power_int @ A @ B2 @ N2 ) @ ( power_int @ A @ A2 @ N2 ) ) ) ) ) ) ).

% power_int_strict_antimono
thf(fact_8151_one__le__power__int,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X2: A,N2: int] :
          ( ( ord_less_eq @ A @ ( one_one @ A ) @ X2 )
         => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ N2 )
           => ( ord_less_eq @ A @ ( one_one @ A ) @ ( power_int @ A @ X2 @ N2 ) ) ) ) ) ).

% one_le_power_int
thf(fact_8152_one__less__power__int,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,N2: int] :
          ( ( ord_less @ A @ ( one_one @ A ) @ A2 )
         => ( ( ord_less @ int @ ( zero_zero @ int ) @ N2 )
           => ( ord_less @ A @ ( one_one @ A ) @ ( power_int @ A @ A2 @ N2 ) ) ) ) ) ).

% one_less_power_int
thf(fact_8153_power__int__add,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [X2: A,M: int,N2: int] :
          ( ( ( X2
             != ( zero_zero @ A ) )
            | ( ( plus_plus @ int @ M @ N2 )
             != ( zero_zero @ int ) ) )
         => ( ( power_int @ A @ X2 @ ( plus_plus @ int @ M @ N2 ) )
            = ( times_times @ A @ ( power_int @ A @ X2 @ M ) @ ( power_int @ A @ X2 @ N2 ) ) ) ) ) ).

% power_int_add
thf(fact_8154_power__int__minus__left__distrib,axiom,
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( ( division_ring @ A )
        & ( one @ B )
        & ( uminus @ B ) )
     => ! [X2: C,A2: A,N2: int] :
          ( ( nO_MATCH @ B @ C @ ( uminus_uminus @ B @ ( one_one @ B ) ) @ X2 )
         => ( ( power_int @ A @ ( uminus_uminus @ A @ A2 ) @ N2 )
            = ( times_times @ A @ ( power_int @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ N2 ) @ ( power_int @ A @ A2 @ N2 ) ) ) ) ) ).

% power_int_minus_left_distrib
thf(fact_8155_power__int__strict__mono,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A,N2: int] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
           => ( ( ord_less @ int @ ( zero_zero @ int ) @ N2 )
             => ( ord_less @ A @ ( power_int @ A @ A2 @ N2 ) @ ( power_int @ A @ B2 @ N2 ) ) ) ) ) ) ).

% power_int_strict_mono
thf(fact_8156_power__int__antimono,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A,N2: int] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
           => ( ( ord_less @ int @ N2 @ ( zero_zero @ int ) )
             => ( ord_less_eq @ A @ ( power_int @ A @ B2 @ N2 ) @ ( power_int @ A @ A2 @ N2 ) ) ) ) ) ) ).

% power_int_antimono
thf(fact_8157_power__int__decreasing,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [N2: int,N4: int,A2: A] :
          ( ( ord_less_eq @ int @ N2 @ N4 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
           => ( ( ord_less_eq @ A @ A2 @ ( one_one @ A ) )
             => ( ( ( A2
                   != ( zero_zero @ A ) )
                  | ( N4
                   != ( zero_zero @ int ) )
                  | ( N2
                    = ( zero_zero @ int ) ) )
               => ( ord_less_eq @ A @ ( power_int @ A @ A2 @ N4 ) @ ( power_int @ A @ A2 @ N2 ) ) ) ) ) ) ) ).

% power_int_decreasing
thf(fact_8158_power__int__le__one,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X2: A,N2: int] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X2 )
         => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ N2 )
           => ( ( ord_less_eq @ A @ X2 @ ( one_one @ A ) )
             => ( ord_less_eq @ A @ ( power_int @ A @ X2 @ N2 ) @ ( one_one @ A ) ) ) ) ) ) ).

% power_int_le_one
thf(fact_8159_power__int__le__imp__le__exp,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X2: A,M: int,N2: int] :
          ( ( ord_less @ A @ ( one_one @ A ) @ X2 )
         => ( ( ord_less_eq @ A @ ( power_int @ A @ X2 @ M ) @ ( power_int @ A @ X2 @ N2 ) )
           => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ N2 )
             => ( ord_less_eq @ int @ M @ N2 ) ) ) ) ) ).

% power_int_le_imp_le_exp
thf(fact_8160_power__int__le__imp__less__exp,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X2: A,M: int,N2: int] :
          ( ( ord_less @ A @ ( one_one @ A ) @ X2 )
         => ( ( ord_less @ A @ ( power_int @ A @ X2 @ M ) @ ( power_int @ A @ X2 @ N2 ) )
           => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ N2 )
             => ( ord_less @ int @ M @ N2 ) ) ) ) ) ).

% power_int_le_imp_less_exp
thf(fact_8161_power__int__minus__left,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [N2: int,A2: A] :
          ( ( ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N2 )
           => ( ( power_int @ A @ ( uminus_uminus @ A @ A2 ) @ N2 )
              = ( power_int @ A @ A2 @ N2 ) ) )
          & ( ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N2 )
           => ( ( power_int @ A @ ( uminus_uminus @ A @ A2 ) @ N2 )
              = ( uminus_uminus @ A @ ( power_int @ A @ A2 @ N2 ) ) ) ) ) ) ).

% power_int_minus_left
thf(fact_8162_power__int__minus__mult,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [X2: A,N2: int] :
          ( ( ( X2
             != ( zero_zero @ A ) )
            | ( N2
             != ( zero_zero @ int ) ) )
         => ( ( times_times @ A @ ( power_int @ A @ X2 @ ( minus_minus @ int @ N2 @ ( one_one @ int ) ) ) @ X2 )
            = ( power_int @ A @ X2 @ N2 ) ) ) ) ).

% power_int_minus_mult
thf(fact_8163_power__int__add__1_H,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [X2: A,M: int] :
          ( ( ( X2
             != ( zero_zero @ A ) )
            | ( M
             != ( uminus_uminus @ int @ ( one_one @ int ) ) ) )
         => ( ( power_int @ A @ X2 @ ( plus_plus @ int @ M @ ( one_one @ int ) ) )
            = ( times_times @ A @ X2 @ ( power_int @ A @ X2 @ M ) ) ) ) ) ).

% power_int_add_1'
thf(fact_8164_power__int__add__1,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [X2: A,M: int] :
          ( ( ( X2
             != ( zero_zero @ A ) )
            | ( M
             != ( uminus_uminus @ int @ ( one_one @ int ) ) ) )
         => ( ( power_int @ A @ X2 @ ( plus_plus @ int @ M @ ( one_one @ int ) ) )
            = ( times_times @ A @ ( power_int @ A @ X2 @ M ) @ X2 ) ) ) ) ).

% power_int_add_1
thf(fact_8165_power__int__def,axiom,
    ! [A: $tType] :
      ( ( ( inverse @ A )
        & ( power @ A ) )
     => ( ( power_int @ A )
        = ( ^ [X5: A,N3: int] : ( if @ A @ ( ord_less_eq @ int @ ( zero_zero @ int ) @ N3 ) @ ( power_power @ A @ X5 @ ( nat2 @ N3 ) ) @ ( power_power @ A @ ( inverse_inverse @ A @ X5 ) @ ( nat2 @ ( uminus_uminus @ int @ N3 ) ) ) ) ) ) ) ).

% power_int_def
thf(fact_8166_powr__real__of__int_H,axiom,
    ! [X2: real,N2: int] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X2 )
     => ( ( ( X2
           != ( zero_zero @ real ) )
          | ( ord_less @ int @ ( zero_zero @ int ) @ N2 ) )
       => ( ( powr @ real @ X2 @ ( ring_1_of_int @ real @ N2 ) )
          = ( power_int @ real @ X2 @ N2 ) ) ) ) ).

% powr_real_of_int'
thf(fact_8167_DERIV__power__int,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,D2: A,X2: A,S2: set @ A,N2: int] :
          ( ( has_field_derivative @ A @ F2 @ D2 @ ( topolo174197925503356063within @ A @ X2 @ S2 ) )
         => ( ( ( F2 @ X2 )
             != ( zero_zero @ A ) )
           => ( has_field_derivative @ A
              @ ^ [X5: A] : ( power_int @ A @ ( F2 @ X5 ) @ N2 )
              @ ( times_times @ A @ ( times_times @ A @ ( ring_1_of_int @ A @ N2 ) @ ( power_int @ A @ ( F2 @ X2 ) @ ( minus_minus @ int @ N2 @ ( one_one @ int ) ) ) ) @ D2 )
              @ ( topolo174197925503356063within @ A @ X2 @ S2 ) ) ) ) ) ).

% DERIV_power_int
thf(fact_8168_at__right__eq,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [X2: A,Y2: A] :
          ( ( ord_less @ A @ X2 @ Y2 )
         => ( ( topolo174197925503356063within @ A @ X2 @ ( set_ord_greaterThan @ A @ X2 ) )
            = ( complete_Inf_Inf @ ( filter @ A )
              @ ( image @ A @ ( filter @ A )
                @ ^ [A4: A] : ( principal @ A @ ( set_or5935395276787703475ssThan @ A @ X2 @ A4 ) )
                @ ( set_ord_greaterThan @ A @ X2 ) ) ) ) ) ) ).

% at_right_eq
thf(fact_8169_lists__length__Suc__eq,axiom,
    ! [A: $tType,A3: set @ A,N2: nat] :
      ( ( collect @ ( list @ A )
        @ ^ [Xs3: list @ A] :
            ( ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ Xs3 ) @ A3 )
            & ( ( size_size @ ( list @ A ) @ Xs3 )
              = ( suc @ N2 ) ) ) )
      = ( image @ ( product_prod @ ( list @ A ) @ A ) @ ( list @ A )
        @ ( product_case_prod @ ( list @ A ) @ A @ ( list @ A )
          @ ^ [Xs3: list @ A,N3: A] : ( cons @ A @ N3 @ Xs3 ) )
        @ ( product_Sigma @ ( list @ A ) @ A
          @ ( collect @ ( list @ A )
            @ ^ [Xs3: list @ A] :
                ( ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ Xs3 ) @ A3 )
                & ( ( size_size @ ( list @ A ) @ Xs3 )
                  = N2 ) ) )
          @ ^ [Uu3: list @ A] : A3 ) ) ) ).

% lists_length_Suc_eq
thf(fact_8170_mem__Sigma__iff,axiom,
    ! [B: $tType,A: $tType,A2: A,B2: B,A3: set @ A,B3: A > ( set @ B )] :
      ( ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ A2 @ B2 ) @ ( product_Sigma @ A @ B @ A3 @ B3 ) )
      = ( ( member @ A @ A2 @ A3 )
        & ( member @ B @ B2 @ ( B3 @ A2 ) ) ) ) ).

% mem_Sigma_iff
thf(fact_8171_SigmaI,axiom,
    ! [B: $tType,A: $tType,A2: A,A3: set @ A,B2: B,B3: A > ( set @ B )] :
      ( ( member @ A @ A2 @ A3 )
     => ( ( member @ B @ B2 @ ( B3 @ A2 ) )
       => ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ A2 @ B2 ) @ ( product_Sigma @ A @ B @ A3 @ B3 ) ) ) ) ).

% SigmaI
thf(fact_8172_principal__le__iff,axiom,
    ! [A: $tType,A3: set @ A,B3: set @ A] :
      ( ( ord_less_eq @ ( filter @ A ) @ ( principal @ A @ A3 ) @ ( principal @ A @ B3 ) )
      = ( ord_less_eq @ ( set @ A ) @ A3 @ B3 ) ) ).

% principal_le_iff
thf(fact_8173_set__product,axiom,
    ! [B: $tType,A: $tType,Xs: list @ A,Ys: list @ B] :
      ( ( set2 @ ( product_prod @ A @ B ) @ ( product @ A @ B @ Xs @ Ys ) )
      = ( product_Sigma @ A @ B @ ( set2 @ A @ Xs )
        @ ^ [Uu3: A] : ( set2 @ B @ Ys ) ) ) ).

% set_product
thf(fact_8174_insert__Times__insert,axiom,
    ! [B: $tType,A: $tType,A2: A,A3: set @ A,B2: B,B3: set @ B] :
      ( ( product_Sigma @ A @ B @ ( insert @ A @ A2 @ A3 )
        @ ^ [Uu3: A] : ( insert @ B @ B2 @ B3 ) )
      = ( insert @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ A2 @ B2 )
        @ ( sup_sup @ ( set @ ( product_prod @ A @ B ) )
          @ ( product_Sigma @ A @ B @ A3
            @ ^ [Uu3: A] : ( insert @ B @ B2 @ B3 ) )
          @ ( product_Sigma @ A @ B @ ( insert @ A @ A2 @ A3 )
            @ ^ [Uu3: A] : B3 ) ) ) ) ).

% insert_Times_insert
thf(fact_8175_image__paired__Times,axiom,
    ! [C: $tType,D: $tType,B: $tType,A: $tType,F2: C > A,G: D > B,A3: set @ C,B3: set @ D] :
      ( ( image @ ( product_prod @ C @ D ) @ ( product_prod @ A @ B )
        @ ( product_case_prod @ C @ D @ ( product_prod @ A @ B )
          @ ^ [X5: C,Y5: D] : ( product_Pair @ A @ B @ ( F2 @ X5 ) @ ( G @ Y5 ) ) )
        @ ( product_Sigma @ C @ D @ A3
          @ ^ [Uu3: C] : B3 ) )
      = ( product_Sigma @ A @ B @ ( image @ C @ A @ F2 @ A3 )
        @ ^ [Uu3: A] : ( image @ D @ B @ G @ B3 ) ) ) ).

% image_paired_Times
thf(fact_8176_swap__product,axiom,
    ! [B: $tType,A: $tType,A3: set @ B,B3: set @ A] :
      ( ( image @ ( product_prod @ B @ A ) @ ( product_prod @ A @ B )
        @ ( product_case_prod @ B @ A @ ( product_prod @ A @ B )
          @ ^ [I4: B,J3: A] : ( product_Pair @ A @ B @ J3 @ I4 ) )
        @ ( product_Sigma @ B @ A @ A3
          @ ^ [Uu3: B] : B3 ) )
      = ( product_Sigma @ A @ B @ B3
        @ ^ [Uu3: A] : A3 ) ) ).

% swap_product
thf(fact_8177_trancl__subset__Sigma__aux,axiom,
    ! [A: $tType,A2: A,B2: A,R3: set @ ( product_prod @ A @ A ),A3: set @ A] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ B2 ) @ ( transitive_rtrancl @ A @ R3 ) )
     => ( ( ord_less_eq @ ( set @ ( product_prod @ A @ A ) ) @ R3
          @ ( product_Sigma @ A @ A @ A3
            @ ^ [Uu3: A] : A3 ) )
       => ( ( A2 = B2 )
          | ( member @ A @ A2 @ A3 ) ) ) ) ).

% trancl_subset_Sigma_aux
thf(fact_8178_times__subset__iff,axiom,
    ! [A: $tType,B: $tType,A3: set @ A,C6: set @ B,B3: set @ A,D5: set @ B] :
      ( ( ord_less_eq @ ( set @ ( product_prod @ A @ B ) )
        @ ( product_Sigma @ A @ B @ A3
          @ ^ [Uu3: A] : C6 )
        @ ( product_Sigma @ A @ B @ B3
          @ ^ [Uu3: A] : D5 ) )
      = ( ( A3
          = ( bot_bot @ ( set @ A ) ) )
        | ( C6
          = ( bot_bot @ ( set @ B ) ) )
        | ( ( ord_less_eq @ ( set @ A ) @ A3 @ B3 )
          & ( ord_less_eq @ ( set @ B ) @ C6 @ D5 ) ) ) ) ).

% times_subset_iff
thf(fact_8179_relcomp__subset__Sigma,axiom,
    ! [B: $tType,C: $tType,A: $tType,R3: set @ ( product_prod @ A @ B ),A3: set @ A,B3: set @ B,S2: set @ ( product_prod @ B @ C ),C6: set @ C] :
      ( ( ord_less_eq @ ( set @ ( product_prod @ A @ B ) ) @ R3
        @ ( product_Sigma @ A @ B @ A3
          @ ^ [Uu3: A] : B3 ) )
     => ( ( ord_less_eq @ ( set @ ( product_prod @ B @ C ) ) @ S2
          @ ( product_Sigma @ B @ C @ B3
            @ ^ [Uu3: B] : C6 ) )
       => ( ord_less_eq @ ( set @ ( product_prod @ A @ C ) ) @ ( relcomp @ A @ B @ C @ R3 @ S2 )
          @ ( product_Sigma @ A @ C @ A3
            @ ^ [Uu3: A] : C6 ) ) ) ) ).

% relcomp_subset_Sigma
thf(fact_8180_Id__on__subset__Times,axiom,
    ! [A: $tType,A3: set @ A] :
      ( ord_less_eq @ ( set @ ( product_prod @ A @ A ) ) @ ( id_on @ A @ A3 )
      @ ( product_Sigma @ A @ A @ A3
        @ ^ [Uu3: A] : A3 ) ) ).

% Id_on_subset_Times
thf(fact_8181_Restr__subset,axiom,
    ! [A: $tType,A3: set @ A,B3: set @ A,R3: set @ ( product_prod @ A @ A )] :
      ( ( ord_less_eq @ ( set @ A ) @ A3 @ B3 )
     => ( ( inf_inf @ ( set @ ( product_prod @ A @ A ) )
          @ ( inf_inf @ ( set @ ( product_prod @ A @ A ) ) @ R3
            @ ( product_Sigma @ A @ A @ B3
              @ ^ [Uu3: A] : B3 ) )
          @ ( product_Sigma @ A @ A @ A3
            @ ^ [Uu3: A] : A3 ) )
        = ( inf_inf @ ( set @ ( product_prod @ A @ A ) ) @ R3
          @ ( product_Sigma @ A @ A @ A3
            @ ^ [Uu3: A] : A3 ) ) ) ) ).

% Restr_subset

% Type constructors (767)
thf(tcon_Product__Type_Ounit___Lattices_Obounded__lattice,axiom,
    bounded_lattice @ product_unit ).

thf(tcon_Extended__Nat_Oenat___Lattices_Obounded__lattice_1,axiom,
    bounded_lattice @ extended_enat ).

thf(tcon_Filter_Ofilter___Lattices_Obounded__lattice_2,axiom,
    ! [A16: $tType] : ( bounded_lattice @ ( filter @ A16 ) ) ).

thf(tcon_HOL_Obool___Lattices_Obounded__lattice_3,axiom,
    bounded_lattice @ $o ).

thf(tcon_Set_Oset___Lattices_Obounded__lattice_4,axiom,
    ! [A16: $tType] : ( bounded_lattice @ ( set @ A16 ) ) ).

thf(tcon_fun___Lattices_Obounded__lattice_5,axiom,
    ! [A16: $tType,A19: $tType] :
      ( ( bounded_lattice @ A19 )
     => ( bounded_lattice @ ( A16 > A19 ) ) ) ).

thf(tcon_fun___Conditionally__Complete__Lattices_Oconditionally__complete__lattice,axiom,
    ! [A16: $tType,A19: $tType] :
      ( ( comple6319245703460814977attice @ A19 )
     => ( condit1219197933456340205attice @ ( A16 > A19 ) ) ) ).

thf(tcon_fun___Countable__Complete__Lattices_Ocountable__complete__lattice,axiom,
    ! [A16: $tType,A19: $tType] :
      ( ( counta3822494911875563373attice @ A19 )
     => ( counta3822494911875563373attice @ ( A16 > A19 ) ) ) ).

thf(tcon_fun___Complete__Lattices_Ocomplete__distrib__lattice,axiom,
    ! [A16: $tType,A19: $tType] :
      ( ( comple592849572758109894attice @ A19 )
     => ( comple592849572758109894attice @ ( A16 > A19 ) ) ) ).

thf(tcon_fun___Lattices_Obounded__semilattice__sup__bot,axiom,
    ! [A16: $tType,A19: $tType] :
      ( ( bounded_lattice @ A19 )
     => ( bounde4967611905675639751up_bot @ ( A16 > A19 ) ) ) ).

thf(tcon_fun___Lattices_Obounded__semilattice__inf__top,axiom,
    ! [A16: $tType,A19: $tType] :
      ( ( bounded_lattice @ A19 )
     => ( bounde4346867609351753570nf_top @ ( A16 > A19 ) ) ) ).

thf(tcon_fun___Complete__Lattices_Ocomplete__lattice,axiom,
    ! [A16: $tType,A19: $tType] :
      ( ( comple6319245703460814977attice @ A19 )
     => ( comple6319245703460814977attice @ ( A16 > A19 ) ) ) ).

thf(tcon_fun___Boolean__Algebras_Oboolean__algebra,axiom,
    ! [A16: $tType,A19: $tType] :
      ( ( boolea8198339166811842893lgebra @ A19 )
     => ( boolea8198339166811842893lgebra @ ( A16 > A19 ) ) ) ).

thf(tcon_fun___Lattices_Osemilattice__sup,axiom,
    ! [A16: $tType,A19: $tType] :
      ( ( semilattice_sup @ A19 )
     => ( semilattice_sup @ ( A16 > A19 ) ) ) ).

thf(tcon_fun___Lattices_Osemilattice__inf,axiom,
    ! [A16: $tType,A19: $tType] :
      ( ( semilattice_inf @ A19 )
     => ( semilattice_inf @ ( A16 > A19 ) ) ) ).

thf(tcon_fun___Orderings_Oorder__top,axiom,
    ! [A16: $tType,A19: $tType] :
      ( ( order_top @ A19 )
     => ( order_top @ ( A16 > A19 ) ) ) ).

thf(tcon_fun___Orderings_Oorder__bot,axiom,
    ! [A16: $tType,A19: $tType] :
      ( ( order_bot @ A19 )
     => ( order_bot @ ( A16 > A19 ) ) ) ).

thf(tcon_fun___Orderings_Opreorder,axiom,
    ! [A16: $tType,A19: $tType] :
      ( ( preorder @ A19 )
     => ( preorder @ ( A16 > A19 ) ) ) ).

thf(tcon_fun___Lattices_Olattice,axiom,
    ! [A16: $tType,A19: $tType] :
      ( ( lattice @ A19 )
     => ( lattice @ ( A16 > A19 ) ) ) ).

thf(tcon_fun___Orderings_Oorder,axiom,
    ! [A16: $tType,A19: $tType] :
      ( ( order @ A19 )
     => ( order @ ( A16 > A19 ) ) ) ).

thf(tcon_fun___Orderings_Oord,axiom,
    ! [A16: $tType,A19: $tType] :
      ( ( ord @ A19 )
     => ( ord @ ( A16 > A19 ) ) ) ).

thf(tcon_fun___Groups_Ouminus,axiom,
    ! [A16: $tType,A19: $tType] :
      ( ( uminus @ A19 )
     => ( uminus @ ( A16 > A19 ) ) ) ).

thf(tcon_Int_Oint___Conditionally__Complete__Lattices_Oconditionally__complete__linorder,axiom,
    condit6923001295902523014norder @ int ).

thf(tcon_Int_Oint___Conditionally__Complete__Lattices_Oconditionally__complete__lattice_6,axiom,
    condit1219197933456340205attice @ int ).

thf(tcon_Int_Oint___Bit__Operations_Ounique__euclidean__semiring__with__bit__operations,axiom,
    bit_un5681908812861735899ations @ int ).

thf(tcon_Int_Oint___Semiring__Normalization_Ocomm__semiring__1__cancel__crossproduct,axiom,
    semiri1453513574482234551roduct @ int ).

thf(tcon_Int_Oint___Euclidean__Division_Ounique__euclidean__semiring__with__nat,axiom,
    euclid5411537665997757685th_nat @ int ).

thf(tcon_Int_Oint___Euclidean__Division_Ounique__euclidean__ring__with__nat,axiom,
    euclid8789492081693882211th_nat @ int ).

thf(tcon_Int_Oint___Groups_Oordered__ab__semigroup__monoid__add__imp__le,axiom,
    ordere1937475149494474687imp_le @ int ).

thf(tcon_Int_Oint___Euclidean__Division_Ounique__euclidean__semiring,axiom,
    euclid3128863361964157862miring @ int ).

thf(tcon_Int_Oint___Euclidean__Division_Oeuclidean__semiring__cancel,axiom,
    euclid4440199948858584721cancel @ int ).

thf(tcon_Int_Oint___Divides_Ounique__euclidean__semiring__numeral,axiom,
    unique1627219031080169319umeral @ int ).

thf(tcon_Int_Oint___Euclidean__Division_Oeuclidean__ring__cancel,axiom,
    euclid8851590272496341667cancel @ int ).

thf(tcon_Int_Oint___Rings_Osemiring__no__zero__divisors__cancel,axiom,
    semiri6575147826004484403cancel @ int ).

thf(tcon_Int_Oint___Groups_Ostrict__ordered__ab__semigroup__add,axiom,
    strict9044650504122735259up_add @ int ).

thf(tcon_Int_Oint___Groups_Oordered__cancel__ab__semigroup__add,axiom,
    ordere580206878836729694up_add @ int ).

thf(tcon_Int_Oint___Groups_Oordered__ab__semigroup__add__imp__le,axiom,
    ordere2412721322843649153imp_le @ int ).

thf(tcon_Int_Oint___Bit__Operations_Osemiring__bit__operations,axiom,
    bit_se359711467146920520ations @ int ).

thf(tcon_Int_Oint___Rings_Olinordered__comm__semiring__strict,axiom,
    linord2810124833399127020strict @ int ).

thf(tcon_Int_Oint___Groups_Ostrict__ordered__comm__monoid__add,axiom,
    strict7427464778891057005id_add @ int ).

thf(tcon_Int_Oint___Groups_Oordered__cancel__comm__monoid__add,axiom,
    ordere8940638589300402666id_add @ int ).

thf(tcon_Int_Oint___Euclidean__Division_Oeuclidean__semiring,axiom,
    euclid3725896446679973847miring @ int ).

thf(tcon_Int_Oint___Topological__Spaces_Otopological__space,axiom,
    topolo4958980785337419405_space @ int ).

thf(tcon_Int_Oint___Topological__Spaces_Olinorder__topology,axiom,
    topolo1944317154257567458pology @ int ).

thf(tcon_Int_Oint___Limits_Otopological__comm__monoid__mult,axiom,
    topolo4987421752381908075d_mult @ int ).

thf(tcon_Int_Oint___Rings_Olinordered__semiring__1__strict,axiom,
    linord715952674999750819strict @ int ).

thf(tcon_Int_Oint___Limits_Otopological__comm__monoid__add,axiom,
    topolo5987344860129210374id_add @ int ).

thf(tcon_Int_Oint___Bit__Operations_Oring__bit__operations,axiom,
    bit_ri3973907225187159222ations @ int ).

thf(tcon_Int_Oint___Topological__Spaces_Oorder__topology,axiom,
    topolo2564578578187576103pology @ int ).

thf(tcon_Int_Oint___Rings_Osemiring__1__no__zero__divisors,axiom,
    semiri2026040879449505780visors @ int ).

thf(tcon_Int_Oint___Rings_Olinordered__nonzero__semiring,axiom,
    linord181362715937106298miring @ int ).

thf(tcon_Int_Oint___Limits_Otopological__semigroup__mult,axiom,
    topolo4211221413907600880p_mult @ int ).

thf(tcon_Int_Oint___Euclidean__Division_Oeuclidean__ring,axiom,
    euclid5891614535332579305n_ring @ int ).

thf(tcon_Int_Oint___Rings_Olinordered__semiring__strict,axiom,
    linord8928482502909563296strict @ int ).

thf(tcon_Int_Oint___Rings_Osemiring__no__zero__divisors,axiom,
    semiri3467727345109120633visors @ int ).

thf(tcon_Int_Oint___Groups_Oordered__ab__semigroup__add,axiom,
    ordere6658533253407199908up_add @ int ).

thf(tcon_Int_Oint___Groups_Oordered__ab__group__add__abs,axiom,
    ordere166539214618696060dd_abs @ int ).

thf(tcon_Int_Oint___GCD_Osemiring__gcd__mult__normalize,axiom,
    semiri6843258321239162965malize @ int ).

thf(tcon_Int_Oint___Limits_Otopological__monoid__mult,axiom,
    topolo1898628316856586783d_mult @ int ).

thf(tcon_Int_Oint___Groups_Oordered__comm__monoid__add,axiom,
    ordere6911136660526730532id_add @ int ).

thf(tcon_Int_Oint___Groups_Olinordered__ab__group__add,axiom,
    linord5086331880401160121up_add @ int ).

thf(tcon_Int_Oint___Groups_Ocancel__ab__semigroup__add,axiom,
    cancel2418104881723323429up_add @ int ).

thf(tcon_Int_Oint___Rings_Oring__1__no__zero__divisors,axiom,
    ring_15535105094025558882visors @ int ).

thf(tcon_Int_Oint___Limits_Otopological__monoid__add,axiom,
    topolo6943815403480290642id_add @ int ).

thf(tcon_Int_Oint___Groups_Ocancel__comm__monoid__add,axiom,
    cancel1802427076303600483id_add @ int ).

thf(tcon_Int_Oint___Rings_Olinordered__ring__strict,axiom,
    linord4710134922213307826strict @ int ).

thf(tcon_Int_Oint___Rings_Ocomm__semiring__1__cancel,axiom,
    comm_s4317794764714335236cancel @ int ).

thf(tcon_Int_Oint___Bit__Operations_Osemiring__bits,axiom,
    bit_semiring_bits @ int ).

thf(tcon_Int_Oint___Topological__Spaces_Ot2__space,axiom,
    topological_t2_space @ int ).

thf(tcon_Int_Oint___Rings_Oordered__comm__semiring,axiom,
    ordere2520102378445227354miring @ int ).

thf(tcon_Int_Oint___Rings_Olinordered__semiring__1,axiom,
    linord6961819062388156250ring_1 @ int ).

thf(tcon_Int_Oint___Groups_Oordered__ab__group__add,axiom,
    ordered_ab_group_add @ int ).

thf(tcon_Int_Oint___Groups_Ocancel__semigroup__add,axiom,
    cancel_semigroup_add @ int ).

thf(tcon_Int_Oint___Rings_Olinordered__semiring,axiom,
    linordered_semiring @ int ).

thf(tcon_Int_Oint___Rings_Oordered__semiring__0,axiom,
    ordered_semiring_0 @ int ).

thf(tcon_Int_Oint___Rings_Olinordered__semidom,axiom,
    linordered_semidom @ int ).

thf(tcon_Int_Oint___Lattices_Osemilattice__sup_7,axiom,
    semilattice_sup @ int ).

thf(tcon_Int_Oint___Lattices_Osemilattice__inf_8,axiom,
    semilattice_inf @ int ).

thf(tcon_Int_Oint___Groups_Oab__semigroup__mult,axiom,
    ab_semigroup_mult @ int ).

thf(tcon_Int_Oint___Rings_Osemiring__1__cancel,axiom,
    semiring_1_cancel @ int ).

thf(tcon_Int_Oint___Rings_Oalgebraic__semidom,axiom,
    algebraic_semidom @ int ).

thf(tcon_Int_Oint___Groups_Ocomm__monoid__mult,axiom,
    comm_monoid_mult @ int ).

thf(tcon_Int_Oint___Groups_Oab__semigroup__add,axiom,
    ab_semigroup_add @ int ).

thf(tcon_Int_Oint___Rings_Oordered__semiring,axiom,
    ordered_semiring @ int ).

thf(tcon_Int_Oint___Rings_Oordered__ring__abs,axiom,
    ordered_ring_abs @ int ).

thf(tcon_Int_Oint___Parity_Osemiring__parity,axiom,
    semiring_parity @ int ).

thf(tcon_Int_Oint___Groups_Ocomm__monoid__add,axiom,
    comm_monoid_add @ int ).

thf(tcon_Int_Oint___Rings_Osemiring__modulo,axiom,
    semiring_modulo @ int ).

thf(tcon_Int_Oint___Rings_Olinordered__ring,axiom,
    linordered_ring @ int ).

thf(tcon_Int_Oint___Rings_Olinordered__idom,axiom,
    linordered_idom @ int ).

thf(tcon_Int_Oint___Rings_Ocomm__semiring__1,axiom,
    comm_semiring_1 @ int ).

thf(tcon_Int_Oint___Rings_Ocomm__semiring__0,axiom,
    comm_semiring_0 @ int ).

thf(tcon_Int_Oint___Groups_Osemigroup__mult,axiom,
    semigroup_mult @ int ).

thf(tcon_Int_Oint___Rings_Osemidom__modulo,axiom,
    semidom_modulo @ int ).

thf(tcon_Int_Oint___Rings_Osemidom__divide,axiom,
    semidom_divide @ int ).

thf(tcon_Int_Oint___Num_Osemiring__numeral,axiom,
    semiring_numeral @ int ).

thf(tcon_Int_Oint___Groups_Osemigroup__add,axiom,
    semigroup_add @ int ).

thf(tcon_Int_Oint___Rings_Ozero__less__one,axiom,
    zero_less_one @ int ).

thf(tcon_Int_Oint___Rings_Ocomm__semiring,axiom,
    comm_semiring @ int ).

thf(tcon_Int_Oint___Nat_Osemiring__char__0,axiom,
    semiring_char_0 @ int ).

thf(tcon_Int_Oint___Groups_Oab__group__add,axiom,
    ab_group_add @ int ).

thf(tcon_Int_Oint___Rings_Ozero__neq__one,axiom,
    zero_neq_one @ int ).

thf(tcon_Int_Oint___Rings_Oordered__ring,axiom,
    ordered_ring @ int ).

thf(tcon_Int_Oint___Rings_Oidom__abs__sgn,axiom,
    idom_abs_sgn @ int ).

thf(tcon_Int_Oint___Parity_Oring__parity,axiom,
    ring_parity @ int ).

thf(tcon_Int_Oint___Orderings_Opreorder_9,axiom,
    preorder @ int ).

thf(tcon_Int_Oint___Orderings_Olinorder,axiom,
    linorder @ int ).

thf(tcon_Int_Oint___Groups_Omonoid__mult,axiom,
    monoid_mult @ int ).

thf(tcon_Int_Oint___Rings_Oidom__modulo,axiom,
    idom_modulo @ int ).

thf(tcon_Int_Oint___Rings_Oidom__divide,axiom,
    idom_divide @ int ).

thf(tcon_Int_Oint___Rings_Ocomm__ring__1,axiom,
    comm_ring_1 @ int ).

thf(tcon_Int_Oint___Groups_Omonoid__add,axiom,
    monoid_add @ int ).

thf(tcon_Int_Oint___Rings_Osemiring__1,axiom,
    semiring_1 @ int ).

thf(tcon_Int_Oint___Rings_Osemiring__0,axiom,
    semiring_0 @ int ).

thf(tcon_Int_Oint___Orderings_Ono__top,axiom,
    no_top @ int ).

thf(tcon_Int_Oint___Orderings_Ono__bot,axiom,
    no_bot @ int ).

thf(tcon_Int_Oint___Lattices_Olattice_10,axiom,
    lattice @ int ).

thf(tcon_Int_Oint___Groups_Ogroup__add,axiom,
    group_add @ int ).

thf(tcon_Int_Oint___GCD_Osemiring__gcd,axiom,
    semiring_gcd @ int ).

thf(tcon_Int_Oint___GCD_Osemiring__Gcd,axiom,
    semiring_Gcd @ int ).

thf(tcon_Int_Oint___Rings_Omult__zero,axiom,
    mult_zero @ int ).

thf(tcon_Int_Oint___Rings_Ocomm__ring,axiom,
    comm_ring @ int ).

thf(tcon_Int_Oint___Orderings_Oorder_11,axiom,
    order @ int ).

thf(tcon_Int_Oint___Num_Oneg__numeral,axiom,
    neg_numeral @ int ).

thf(tcon_Int_Oint___Nat_Oring__char__0,axiom,
    ring_char_0 @ int ).

thf(tcon_Int_Oint___Rings_Osemiring,axiom,
    semiring @ int ).

thf(tcon_Int_Oint___Rings_Osemidom,axiom,
    semidom @ int ).

thf(tcon_Int_Oint___Orderings_Oord_12,axiom,
    ord @ int ).

thf(tcon_Int_Oint___Groups_Ouminus_13,axiom,
    uminus @ int ).

thf(tcon_Int_Oint___Rings_Oring__1,axiom,
    ring_1 @ int ).

thf(tcon_Int_Oint___Rings_Oabs__if,axiom,
    abs_if @ int ).

thf(tcon_Int_Oint___GCD_Oring__gcd,axiom,
    ring_gcd @ int ).

thf(tcon_Int_Oint___Power_Opower,axiom,
    power @ int ).

thf(tcon_Int_Oint___Num_Onumeral,axiom,
    numeral @ int ).

thf(tcon_Int_Oint___Groups_Ozero,axiom,
    zero @ int ).

thf(tcon_Int_Oint___Groups_Oplus,axiom,
    plus @ int ).

thf(tcon_Int_Oint___Rings_Oring,axiom,
    ring @ int ).

thf(tcon_Int_Oint___Rings_Oidom,axiom,
    idom @ int ).

thf(tcon_Int_Oint___Groups_Oone,axiom,
    one @ int ).

thf(tcon_Int_Oint___Rings_Odvd,axiom,
    dvd @ int ).

thf(tcon_Nat_Onat___Conditionally__Complete__Lattices_Oconditionally__complete__linorder_14,axiom,
    condit6923001295902523014norder @ nat ).

thf(tcon_Nat_Onat___Conditionally__Complete__Lattices_Oconditionally__complete__lattice_15,axiom,
    condit1219197933456340205attice @ nat ).

thf(tcon_Nat_Onat___Bit__Operations_Ounique__euclidean__semiring__with__bit__operations_16,axiom,
    bit_un5681908812861735899ations @ nat ).

thf(tcon_Nat_Onat___Semiring__Normalization_Ocomm__semiring__1__cancel__crossproduct_17,axiom,
    semiri1453513574482234551roduct @ nat ).

thf(tcon_Nat_Onat___Euclidean__Division_Ounique__euclidean__semiring__with__nat_18,axiom,
    euclid5411537665997757685th_nat @ nat ).

thf(tcon_Nat_Onat___Groups_Oordered__ab__semigroup__monoid__add__imp__le_19,axiom,
    ordere1937475149494474687imp_le @ nat ).

thf(tcon_Nat_Onat___Euclidean__Division_Ounique__euclidean__semiring_20,axiom,
    euclid3128863361964157862miring @ nat ).

thf(tcon_Nat_Onat___Euclidean__Division_Oeuclidean__semiring__cancel_21,axiom,
    euclid4440199948858584721cancel @ nat ).

thf(tcon_Nat_Onat___Divides_Ounique__euclidean__semiring__numeral_22,axiom,
    unique1627219031080169319umeral @ nat ).

thf(tcon_Nat_Onat___Rings_Osemiring__no__zero__divisors__cancel_23,axiom,
    semiri6575147826004484403cancel @ nat ).

thf(tcon_Nat_Onat___Groups_Ostrict__ordered__ab__semigroup__add_24,axiom,
    strict9044650504122735259up_add @ nat ).

thf(tcon_Nat_Onat___Groups_Oordered__cancel__comm__monoid__diff,axiom,
    ordere1170586879665033532d_diff @ nat ).

thf(tcon_Nat_Onat___Groups_Oordered__cancel__ab__semigroup__add_25,axiom,
    ordere580206878836729694up_add @ nat ).

thf(tcon_Nat_Onat___Groups_Oordered__ab__semigroup__add__imp__le_26,axiom,
    ordere2412721322843649153imp_le @ nat ).

thf(tcon_Nat_Onat___Bit__Operations_Osemiring__bit__operations_27,axiom,
    bit_se359711467146920520ations @ nat ).

thf(tcon_Nat_Onat___Rings_Olinordered__comm__semiring__strict_28,axiom,
    linord2810124833399127020strict @ nat ).

thf(tcon_Nat_Onat___Groups_Ostrict__ordered__comm__monoid__add_29,axiom,
    strict7427464778891057005id_add @ nat ).

thf(tcon_Nat_Onat___Groups_Oordered__cancel__comm__monoid__add_30,axiom,
    ordere8940638589300402666id_add @ nat ).

thf(tcon_Nat_Onat___Groups_Ocanonically__ordered__monoid__add,axiom,
    canoni5634975068530333245id_add @ nat ).

thf(tcon_Nat_Onat___Euclidean__Division_Oeuclidean__semiring_31,axiom,
    euclid3725896446679973847miring @ nat ).

thf(tcon_Nat_Onat___Topological__Spaces_Otopological__space_32,axiom,
    topolo4958980785337419405_space @ nat ).

thf(tcon_Nat_Onat___Topological__Spaces_Olinorder__topology_33,axiom,
    topolo1944317154257567458pology @ nat ).

thf(tcon_Nat_Onat___Limits_Otopological__comm__monoid__mult_34,axiom,
    topolo4987421752381908075d_mult @ nat ).

thf(tcon_Nat_Onat___Limits_Otopological__comm__monoid__add_35,axiom,
    topolo5987344860129210374id_add @ nat ).

thf(tcon_Nat_Onat___Topological__Spaces_Oorder__topology_36,axiom,
    topolo2564578578187576103pology @ nat ).

thf(tcon_Nat_Onat___Rings_Osemiring__1__no__zero__divisors_37,axiom,
    semiri2026040879449505780visors @ nat ).

thf(tcon_Nat_Onat___Rings_Olinordered__nonzero__semiring_38,axiom,
    linord181362715937106298miring @ nat ).

thf(tcon_Nat_Onat___Limits_Otopological__semigroup__mult_39,axiom,
    topolo4211221413907600880p_mult @ nat ).

thf(tcon_Nat_Onat___Rings_Olinordered__semiring__strict_40,axiom,
    linord8928482502909563296strict @ nat ).

thf(tcon_Nat_Onat___Rings_Osemiring__no__zero__divisors_41,axiom,
    semiri3467727345109120633visors @ nat ).

thf(tcon_Nat_Onat___Groups_Oordered__ab__semigroup__add_42,axiom,
    ordere6658533253407199908up_add @ nat ).

thf(tcon_Nat_Onat___GCD_Osemiring__gcd__mult__normalize_43,axiom,
    semiri6843258321239162965malize @ nat ).

thf(tcon_Nat_Onat___Limits_Otopological__monoid__mult_44,axiom,
    topolo1898628316856586783d_mult @ nat ).

thf(tcon_Nat_Onat___Groups_Oordered__comm__monoid__add_45,axiom,
    ordere6911136660526730532id_add @ nat ).

thf(tcon_Nat_Onat___Groups_Ocancel__ab__semigroup__add_46,axiom,
    cancel2418104881723323429up_add @ nat ).

thf(tcon_Nat_Onat___Limits_Otopological__monoid__add_47,axiom,
    topolo6943815403480290642id_add @ nat ).

thf(tcon_Nat_Onat___Groups_Ocancel__comm__monoid__add_48,axiom,
    cancel1802427076303600483id_add @ nat ).

thf(tcon_Nat_Onat___Rings_Ocomm__semiring__1__cancel_49,axiom,
    comm_s4317794764714335236cancel @ nat ).

thf(tcon_Nat_Onat___Bit__Operations_Osemiring__bits_50,axiom,
    bit_semiring_bits @ nat ).

thf(tcon_Nat_Onat___Topological__Spaces_Ot2__space_51,axiom,
    topological_t2_space @ nat ).

thf(tcon_Nat_Onat___Rings_Oordered__comm__semiring_52,axiom,
    ordere2520102378445227354miring @ nat ).

thf(tcon_Nat_Onat___Groups_Ocancel__semigroup__add_53,axiom,
    cancel_semigroup_add @ nat ).

thf(tcon_Nat_Onat___Rings_Olinordered__semiring_54,axiom,
    linordered_semiring @ nat ).

thf(tcon_Nat_Onat___Rings_Oordered__semiring__0_55,axiom,
    ordered_semiring_0 @ nat ).

thf(tcon_Nat_Onat___Rings_Olinordered__semidom_56,axiom,
    linordered_semidom @ nat ).

thf(tcon_Nat_Onat___Lattices_Osemilattice__sup_57,axiom,
    semilattice_sup @ nat ).

thf(tcon_Nat_Onat___Lattices_Osemilattice__inf_58,axiom,
    semilattice_inf @ nat ).

thf(tcon_Nat_Onat___Groups_Oab__semigroup__mult_59,axiom,
    ab_semigroup_mult @ nat ).

thf(tcon_Nat_Onat___Rings_Osemiring__1__cancel_60,axiom,
    semiring_1_cancel @ nat ).

thf(tcon_Nat_Onat___Rings_Oalgebraic__semidom_61,axiom,
    algebraic_semidom @ nat ).

thf(tcon_Nat_Onat___Groups_Ocomm__monoid__mult_62,axiom,
    comm_monoid_mult @ nat ).

thf(tcon_Nat_Onat___Groups_Ocomm__monoid__diff,axiom,
    comm_monoid_diff @ nat ).

thf(tcon_Nat_Onat___Groups_Oab__semigroup__add_63,axiom,
    ab_semigroup_add @ nat ).

thf(tcon_Nat_Onat___Rings_Oordered__semiring_64,axiom,
    ordered_semiring @ nat ).

thf(tcon_Nat_Onat___Parity_Osemiring__parity_65,axiom,
    semiring_parity @ nat ).

thf(tcon_Nat_Onat___Groups_Ocomm__monoid__add_66,axiom,
    comm_monoid_add @ nat ).

thf(tcon_Nat_Onat___Rings_Osemiring__modulo_67,axiom,
    semiring_modulo @ nat ).

thf(tcon_Nat_Onat___Rings_Ocomm__semiring__1_68,axiom,
    comm_semiring_1 @ nat ).

thf(tcon_Nat_Onat___Rings_Ocomm__semiring__0_69,axiom,
    comm_semiring_0 @ nat ).

thf(tcon_Nat_Onat___Groups_Osemigroup__mult_70,axiom,
    semigroup_mult @ nat ).

thf(tcon_Nat_Onat___Rings_Osemidom__modulo_71,axiom,
    semidom_modulo @ nat ).

thf(tcon_Nat_Onat___Rings_Osemidom__divide_72,axiom,
    semidom_divide @ nat ).

thf(tcon_Nat_Onat___Num_Osemiring__numeral_73,axiom,
    semiring_numeral @ nat ).

thf(tcon_Nat_Onat___Groups_Osemigroup__add_74,axiom,
    semigroup_add @ nat ).

thf(tcon_Nat_Onat___Rings_Ozero__less__one_75,axiom,
    zero_less_one @ nat ).

thf(tcon_Nat_Onat___Rings_Ocomm__semiring_76,axiom,
    comm_semiring @ nat ).

thf(tcon_Nat_Onat___Orderings_Owellorder,axiom,
    wellorder @ nat ).

thf(tcon_Nat_Onat___Orderings_Oorder__bot_77,axiom,
    order_bot @ nat ).

thf(tcon_Nat_Onat___Nat_Osemiring__char__0_78,axiom,
    semiring_char_0 @ nat ).

thf(tcon_Nat_Onat___Rings_Ozero__neq__one_79,axiom,
    zero_neq_one @ nat ).

thf(tcon_Nat_Onat___Orderings_Opreorder_80,axiom,
    preorder @ nat ).

thf(tcon_Nat_Onat___Orderings_Olinorder_81,axiom,
    linorder @ nat ).

thf(tcon_Nat_Onat___Groups_Omonoid__mult_82,axiom,
    monoid_mult @ nat ).

thf(tcon_Nat_Onat___Groups_Omonoid__add_83,axiom,
    monoid_add @ nat ).

thf(tcon_Nat_Onat___Rings_Osemiring__1_84,axiom,
    semiring_1 @ nat ).

thf(tcon_Nat_Onat___Rings_Osemiring__0_85,axiom,
    semiring_0 @ nat ).

thf(tcon_Nat_Onat___Orderings_Ono__top_86,axiom,
    no_top @ nat ).

thf(tcon_Nat_Onat___Lattices_Olattice_87,axiom,
    lattice @ nat ).

thf(tcon_Nat_Onat___GCD_Osemiring__gcd_88,axiom,
    semiring_gcd @ nat ).

thf(tcon_Nat_Onat___GCD_Osemiring__Gcd_89,axiom,
    semiring_Gcd @ nat ).

thf(tcon_Nat_Onat___Rings_Omult__zero_90,axiom,
    mult_zero @ nat ).

thf(tcon_Nat_Onat___Orderings_Oorder_91,axiom,
    order @ nat ).

thf(tcon_Nat_Onat___Rings_Osemiring_92,axiom,
    semiring @ nat ).

thf(tcon_Nat_Onat___Rings_Osemidom_93,axiom,
    semidom @ nat ).

thf(tcon_Nat_Onat___Orderings_Oord_94,axiom,
    ord @ nat ).

thf(tcon_Nat_Onat___Power_Opower_95,axiom,
    power @ nat ).

thf(tcon_Nat_Onat___Num_Onumeral_96,axiom,
    numeral @ nat ).

thf(tcon_Nat_Onat___Groups_Ozero_97,axiom,
    zero @ nat ).

thf(tcon_Nat_Onat___Groups_Oplus_98,axiom,
    plus @ nat ).

thf(tcon_Nat_Onat___Groups_Oone_99,axiom,
    one @ nat ).

thf(tcon_Nat_Onat___Rings_Odvd_100,axiom,
    dvd @ nat ).

thf(tcon_Nat_Onat___Nat_Osize,axiom,
    size @ nat ).

thf(tcon_Num_Onum___Orderings_Opreorder_101,axiom,
    preorder @ num ).

thf(tcon_Num_Onum___Orderings_Olinorder_102,axiom,
    linorder @ num ).

thf(tcon_Num_Onum___Orderings_Oorder_103,axiom,
    order @ num ).

thf(tcon_Num_Onum___Orderings_Oord_104,axiom,
    ord @ num ).

thf(tcon_Num_Onum___Groups_Oplus_105,axiom,
    plus @ num ).

thf(tcon_Num_Onum___Nat_Osize_106,axiom,
    size @ num ).

thf(tcon_Rat_Orat___Semiring__Normalization_Ocomm__semiring__1__cancel__crossproduct_107,axiom,
    semiri1453513574482234551roduct @ rat ).

thf(tcon_Rat_Orat___Groups_Oordered__ab__semigroup__monoid__add__imp__le_108,axiom,
    ordere1937475149494474687imp_le @ rat ).

thf(tcon_Rat_Orat___Rings_Osemiring__no__zero__divisors__cancel_109,axiom,
    semiri6575147826004484403cancel @ rat ).

thf(tcon_Rat_Orat___Groups_Ostrict__ordered__ab__semigroup__add_110,axiom,
    strict9044650504122735259up_add @ rat ).

thf(tcon_Rat_Orat___Groups_Oordered__cancel__ab__semigroup__add_111,axiom,
    ordere580206878836729694up_add @ rat ).

thf(tcon_Rat_Orat___Groups_Oordered__ab__semigroup__add__imp__le_112,axiom,
    ordere2412721322843649153imp_le @ rat ).

thf(tcon_Rat_Orat___Rings_Olinordered__comm__semiring__strict_113,axiom,
    linord2810124833399127020strict @ rat ).

thf(tcon_Rat_Orat___Groups_Ostrict__ordered__comm__monoid__add_114,axiom,
    strict7427464778891057005id_add @ rat ).

thf(tcon_Rat_Orat___Groups_Oordered__cancel__comm__monoid__add_115,axiom,
    ordere8940638589300402666id_add @ rat ).

thf(tcon_Rat_Orat___Archimedean__Field_Oarchimedean__field,axiom,
    archim462609752435547400_field @ rat ).

thf(tcon_Rat_Orat___Rings_Olinordered__semiring__1__strict_116,axiom,
    linord715952674999750819strict @ rat ).

thf(tcon_Rat_Orat___Orderings_Ounbounded__dense__linorder,axiom,
    unboun7993243217541854897norder @ rat ).

thf(tcon_Rat_Orat___Rings_Osemiring__1__no__zero__divisors_117,axiom,
    semiri2026040879449505780visors @ rat ).

thf(tcon_Rat_Orat___Rings_Olinordered__nonzero__semiring_118,axiom,
    linord181362715937106298miring @ rat ).

thf(tcon_Rat_Orat___Rings_Olinordered__semiring__strict_119,axiom,
    linord8928482502909563296strict @ rat ).

thf(tcon_Rat_Orat___Rings_Osemiring__no__zero__divisors_120,axiom,
    semiri3467727345109120633visors @ rat ).

thf(tcon_Rat_Orat___Groups_Oordered__ab__semigroup__add_121,axiom,
    ordere6658533253407199908up_add @ rat ).

thf(tcon_Rat_Orat___Groups_Oordered__ab__group__add__abs_122,axiom,
    ordere166539214618696060dd_abs @ rat ).

thf(tcon_Rat_Orat___Archimedean__Field_Ofloor__ceiling,axiom,
    archim2362893244070406136eiling @ rat ).

thf(tcon_Rat_Orat___Groups_Oordered__comm__monoid__add_123,axiom,
    ordere6911136660526730532id_add @ rat ).

thf(tcon_Rat_Orat___Groups_Olinordered__ab__group__add_124,axiom,
    linord5086331880401160121up_add @ rat ).

thf(tcon_Rat_Orat___Groups_Ocancel__ab__semigroup__add_125,axiom,
    cancel2418104881723323429up_add @ rat ).

thf(tcon_Rat_Orat___Rings_Oring__1__no__zero__divisors_126,axiom,
    ring_15535105094025558882visors @ rat ).

thf(tcon_Rat_Orat___Groups_Ocancel__comm__monoid__add_127,axiom,
    cancel1802427076303600483id_add @ rat ).

thf(tcon_Rat_Orat___Rings_Olinordered__ring__strict_128,axiom,
    linord4710134922213307826strict @ rat ).

thf(tcon_Rat_Orat___Rings_Ocomm__semiring__1__cancel_129,axiom,
    comm_s4317794764714335236cancel @ rat ).

thf(tcon_Rat_Orat___Rings_Oordered__comm__semiring_130,axiom,
    ordere2520102378445227354miring @ rat ).

thf(tcon_Rat_Orat___Rings_Olinordered__semiring__1_131,axiom,
    linord6961819062388156250ring_1 @ rat ).

thf(tcon_Rat_Orat___Groups_Oordered__ab__group__add_132,axiom,
    ordered_ab_group_add @ rat ).

thf(tcon_Rat_Orat___Groups_Ocancel__semigroup__add_133,axiom,
    cancel_semigroup_add @ rat ).

thf(tcon_Rat_Orat___Rings_Olinordered__semiring_134,axiom,
    linordered_semiring @ rat ).

thf(tcon_Rat_Orat___Rings_Oordered__semiring__0_135,axiom,
    ordered_semiring_0 @ rat ).

thf(tcon_Rat_Orat___Rings_Olinordered__semidom_136,axiom,
    linordered_semidom @ rat ).

thf(tcon_Rat_Orat___Orderings_Odense__linorder,axiom,
    dense_linorder @ rat ).

thf(tcon_Rat_Orat___Lattices_Osemilattice__sup_137,axiom,
    semilattice_sup @ rat ).

thf(tcon_Rat_Orat___Lattices_Osemilattice__inf_138,axiom,
    semilattice_inf @ rat ).

thf(tcon_Rat_Orat___Groups_Oab__semigroup__mult_139,axiom,
    ab_semigroup_mult @ rat ).

thf(tcon_Rat_Orat___Rings_Osemiring__1__cancel_140,axiom,
    semiring_1_cancel @ rat ).

thf(tcon_Rat_Orat___Groups_Ocomm__monoid__mult_141,axiom,
    comm_monoid_mult @ rat ).

thf(tcon_Rat_Orat___Groups_Oab__semigroup__add_142,axiom,
    ab_semigroup_add @ rat ).

thf(tcon_Rat_Orat___Fields_Olinordered__field,axiom,
    linordered_field @ rat ).

thf(tcon_Rat_Orat___Rings_Oordered__semiring_143,axiom,
    ordered_semiring @ rat ).

thf(tcon_Rat_Orat___Rings_Oordered__ring__abs_144,axiom,
    ordered_ring_abs @ rat ).

thf(tcon_Rat_Orat___Groups_Ocomm__monoid__add_145,axiom,
    comm_monoid_add @ rat ).

thf(tcon_Rat_Orat___Rings_Olinordered__ring_146,axiom,
    linordered_ring @ rat ).

thf(tcon_Rat_Orat___Rings_Olinordered__idom_147,axiom,
    linordered_idom @ rat ).

thf(tcon_Rat_Orat___Rings_Ocomm__semiring__1_148,axiom,
    comm_semiring_1 @ rat ).

thf(tcon_Rat_Orat___Rings_Ocomm__semiring__0_149,axiom,
    comm_semiring_0 @ rat ).

thf(tcon_Rat_Orat___Orderings_Odense__order,axiom,
    dense_order @ rat ).

thf(tcon_Rat_Orat___Groups_Osemigroup__mult_150,axiom,
    semigroup_mult @ rat ).

thf(tcon_Rat_Orat___Rings_Osemidom__divide_151,axiom,
    semidom_divide @ rat ).

thf(tcon_Rat_Orat___Num_Osemiring__numeral_152,axiom,
    semiring_numeral @ rat ).

thf(tcon_Rat_Orat___Groups_Osemigroup__add_153,axiom,
    semigroup_add @ rat ).

thf(tcon_Rat_Orat___Fields_Ofield__abs__sgn,axiom,
    field_abs_sgn @ rat ).

thf(tcon_Rat_Orat___Fields_Odivision__ring,axiom,
    division_ring @ rat ).

thf(tcon_Rat_Orat___Rings_Ozero__less__one_154,axiom,
    zero_less_one @ rat ).

thf(tcon_Rat_Orat___Rings_Ocomm__semiring_155,axiom,
    comm_semiring @ rat ).

thf(tcon_Rat_Orat___Nat_Osemiring__char__0_156,axiom,
    semiring_char_0 @ rat ).

thf(tcon_Rat_Orat___Groups_Oab__group__add_157,axiom,
    ab_group_add @ rat ).

thf(tcon_Rat_Orat___Fields_Ofield__char__0,axiom,
    field_char_0 @ rat ).

thf(tcon_Rat_Orat___Rings_Ozero__neq__one_158,axiom,
    zero_neq_one @ rat ).

thf(tcon_Rat_Orat___Rings_Oordered__ring_159,axiom,
    ordered_ring @ rat ).

thf(tcon_Rat_Orat___Rings_Oidom__abs__sgn_160,axiom,
    idom_abs_sgn @ rat ).

thf(tcon_Rat_Orat___Orderings_Opreorder_161,axiom,
    preorder @ rat ).

thf(tcon_Rat_Orat___Orderings_Olinorder_162,axiom,
    linorder @ rat ).

thf(tcon_Rat_Orat___Groups_Omonoid__mult_163,axiom,
    monoid_mult @ rat ).

thf(tcon_Rat_Orat___Rings_Oidom__divide_164,axiom,
    idom_divide @ rat ).

thf(tcon_Rat_Orat___Rings_Ocomm__ring__1_165,axiom,
    comm_ring_1 @ rat ).

thf(tcon_Rat_Orat___Groups_Omonoid__add_166,axiom,
    monoid_add @ rat ).

thf(tcon_Rat_Orat___Rings_Osemiring__1_167,axiom,
    semiring_1 @ rat ).

thf(tcon_Rat_Orat___Rings_Osemiring__0_168,axiom,
    semiring_0 @ rat ).

thf(tcon_Rat_Orat___Orderings_Ono__top_169,axiom,
    no_top @ rat ).

thf(tcon_Rat_Orat___Orderings_Ono__bot_170,axiom,
    no_bot @ rat ).

thf(tcon_Rat_Orat___Lattices_Olattice_171,axiom,
    lattice @ rat ).

thf(tcon_Rat_Orat___Groups_Ogroup__add_172,axiom,
    group_add @ rat ).

thf(tcon_Rat_Orat___Rings_Omult__zero_173,axiom,
    mult_zero @ rat ).

thf(tcon_Rat_Orat___Rings_Ocomm__ring_174,axiom,
    comm_ring @ rat ).

thf(tcon_Rat_Orat___Orderings_Oorder_175,axiom,
    order @ rat ).

thf(tcon_Rat_Orat___Num_Oneg__numeral_176,axiom,
    neg_numeral @ rat ).

thf(tcon_Rat_Orat___Nat_Oring__char__0_177,axiom,
    ring_char_0 @ rat ).

thf(tcon_Rat_Orat___Rings_Osemiring_178,axiom,
    semiring @ rat ).

thf(tcon_Rat_Orat___Fields_Oinverse,axiom,
    inverse @ rat ).

thf(tcon_Rat_Orat___Rings_Osemidom_179,axiom,
    semidom @ rat ).

thf(tcon_Rat_Orat___Orderings_Oord_180,axiom,
    ord @ rat ).

thf(tcon_Rat_Orat___Groups_Ouminus_181,axiom,
    uminus @ rat ).

thf(tcon_Rat_Orat___Rings_Oring__1_182,axiom,
    ring_1 @ rat ).

thf(tcon_Rat_Orat___Rings_Oabs__if_183,axiom,
    abs_if @ rat ).

thf(tcon_Rat_Orat___Fields_Ofield,axiom,
    field @ rat ).

thf(tcon_Rat_Orat___Power_Opower_184,axiom,
    power @ rat ).

thf(tcon_Rat_Orat___Num_Onumeral_185,axiom,
    numeral @ rat ).

thf(tcon_Rat_Orat___Groups_Ozero_186,axiom,
    zero @ rat ).

thf(tcon_Rat_Orat___Groups_Oplus_187,axiom,
    plus @ rat ).

thf(tcon_Rat_Orat___Rings_Oring_188,axiom,
    ring @ rat ).

thf(tcon_Rat_Orat___Rings_Oidom_189,axiom,
    idom @ rat ).

thf(tcon_Rat_Orat___Groups_Oone_190,axiom,
    one @ rat ).

thf(tcon_Rat_Orat___Rings_Odvd_191,axiom,
    dvd @ rat ).

thf(tcon_Set_Oset___Conditionally__Complete__Lattices_Oconditionally__complete__lattice_192,axiom,
    ! [A16: $tType] : ( condit1219197933456340205attice @ ( set @ A16 ) ) ).

thf(tcon_Set_Oset___Countable__Complete__Lattices_Ocountable__complete__lattice_193,axiom,
    ! [A16: $tType] : ( counta3822494911875563373attice @ ( set @ A16 ) ) ).

thf(tcon_Set_Oset___Complete__Lattices_Ocomplete__distrib__lattice_194,axiom,
    ! [A16: $tType] : ( comple592849572758109894attice @ ( set @ A16 ) ) ).

thf(tcon_Set_Oset___Lattices_Obounded__semilattice__sup__bot_195,axiom,
    ! [A16: $tType] : ( bounde4967611905675639751up_bot @ ( set @ A16 ) ) ).

thf(tcon_Set_Oset___Lattices_Obounded__semilattice__inf__top_196,axiom,
    ! [A16: $tType] : ( bounde4346867609351753570nf_top @ ( set @ A16 ) ) ).

thf(tcon_Set_Oset___Complete__Lattices_Ocomplete__lattice_197,axiom,
    ! [A16: $tType] : ( comple6319245703460814977attice @ ( set @ A16 ) ) ).

thf(tcon_Set_Oset___Boolean__Algebras_Oboolean__algebra_198,axiom,
    ! [A16: $tType] : ( boolea8198339166811842893lgebra @ ( set @ A16 ) ) ).

thf(tcon_Set_Oset___Lattices_Osemilattice__sup_199,axiom,
    ! [A16: $tType] : ( semilattice_sup @ ( set @ A16 ) ) ).

thf(tcon_Set_Oset___Lattices_Osemilattice__inf_200,axiom,
    ! [A16: $tType] : ( semilattice_inf @ ( set @ A16 ) ) ).

thf(tcon_Set_Oset___Orderings_Oorder__top_201,axiom,
    ! [A16: $tType] : ( order_top @ ( set @ A16 ) ) ).

thf(tcon_Set_Oset___Orderings_Oorder__bot_202,axiom,
    ! [A16: $tType] : ( order_bot @ ( set @ A16 ) ) ).

thf(tcon_Set_Oset___Orderings_Opreorder_203,axiom,
    ! [A16: $tType] : ( preorder @ ( set @ A16 ) ) ).

thf(tcon_Set_Oset___Lattices_Olattice_204,axiom,
    ! [A16: $tType] : ( lattice @ ( set @ A16 ) ) ).

thf(tcon_Set_Oset___Orderings_Oorder_205,axiom,
    ! [A16: $tType] : ( order @ ( set @ A16 ) ) ).

thf(tcon_Set_Oset___Orderings_Oord_206,axiom,
    ! [A16: $tType] : ( ord @ ( set @ A16 ) ) ).

thf(tcon_Set_Oset___Groups_Ouminus_207,axiom,
    ! [A16: $tType] : ( uminus @ ( set @ A16 ) ) ).

thf(tcon_HOL_Obool___Conditionally__Complete__Lattices_Oconditionally__complete__lattice_208,axiom,
    condit1219197933456340205attice @ $o ).

thf(tcon_HOL_Obool___Countable__Complete__Lattices_Ocountable__complete__lattice_209,axiom,
    counta3822494911875563373attice @ $o ).

thf(tcon_HOL_Obool___Complete__Lattices_Ocomplete__distrib__lattice_210,axiom,
    comple592849572758109894attice @ $o ).

thf(tcon_HOL_Obool___Topological__Spaces_Otopological__space_211,axiom,
    topolo4958980785337419405_space @ $o ).

thf(tcon_HOL_Obool___Topological__Spaces_Olinorder__topology_212,axiom,
    topolo1944317154257567458pology @ $o ).

thf(tcon_HOL_Obool___Lattices_Obounded__semilattice__sup__bot_213,axiom,
    bounde4967611905675639751up_bot @ $o ).

thf(tcon_HOL_Obool___Lattices_Obounded__semilattice__inf__top_214,axiom,
    bounde4346867609351753570nf_top @ $o ).

thf(tcon_HOL_Obool___Complete__Lattices_Ocomplete__lattice_215,axiom,
    comple6319245703460814977attice @ $o ).

thf(tcon_HOL_Obool___Topological__Spaces_Oorder__topology_216,axiom,
    topolo2564578578187576103pology @ $o ).

thf(tcon_HOL_Obool___Boolean__Algebras_Oboolean__algebra_217,axiom,
    boolea8198339166811842893lgebra @ $o ).

thf(tcon_HOL_Obool___Topological__Spaces_Ot2__space_218,axiom,
    topological_t2_space @ $o ).

thf(tcon_HOL_Obool___Lattices_Osemilattice__sup_219,axiom,
    semilattice_sup @ $o ).

thf(tcon_HOL_Obool___Lattices_Osemilattice__inf_220,axiom,
    semilattice_inf @ $o ).

thf(tcon_HOL_Obool___Orderings_Oorder__top_221,axiom,
    order_top @ $o ).

thf(tcon_HOL_Obool___Orderings_Oorder__bot_222,axiom,
    order_bot @ $o ).

thf(tcon_HOL_Obool___Orderings_Opreorder_223,axiom,
    preorder @ $o ).

thf(tcon_HOL_Obool___Orderings_Olinorder_224,axiom,
    linorder @ $o ).

thf(tcon_HOL_Obool___Lattices_Olattice_225,axiom,
    lattice @ $o ).

thf(tcon_HOL_Obool___Orderings_Oorder_226,axiom,
    order @ $o ).

thf(tcon_HOL_Obool___Orderings_Oord_227,axiom,
    ord @ $o ).

thf(tcon_HOL_Obool___Groups_Ouminus_228,axiom,
    uminus @ $o ).

thf(tcon_List_Olist___Nat_Osize_229,axiom,
    ! [A16: $tType] : ( size @ ( list @ A16 ) ) ).

thf(tcon_Real_Oreal___Conditionally__Complete__Lattices_Oconditionally__complete__linorder_230,axiom,
    condit6923001295902523014norder @ real ).

thf(tcon_Real_Oreal___Conditionally__Complete__Lattices_Oconditionally__complete__lattice_231,axiom,
    condit1219197933456340205attice @ real ).

thf(tcon_Real_Oreal___Semiring__Normalization_Ocomm__semiring__1__cancel__crossproduct_232,axiom,
    semiri1453513574482234551roduct @ real ).

thf(tcon_Real_Oreal___Conditionally__Complete__Lattices_Olinear__continuum,axiom,
    condit5016429287641298734tinuum @ real ).

thf(tcon_Real_Oreal___Groups_Oordered__ab__semigroup__monoid__add__imp__le_233,axiom,
    ordere1937475149494474687imp_le @ real ).

thf(tcon_Real_Oreal___Topological__Spaces_Olinear__continuum__topology,axiom,
    topolo8458572112393995274pology @ real ).

thf(tcon_Real_Oreal___Topological__Spaces_Ofirst__countable__topology,axiom,
    topolo3112930676232923870pology @ real ).

thf(tcon_Real_Oreal___Real__Vector__Spaces_Oreal__normed__div__algebra,axiom,
    real_V8999393235501362500lgebra @ real ).

thf(tcon_Real_Oreal___Real__Vector__Spaces_Oreal__normed__algebra__1,axiom,
    real_V2822296259951069270ebra_1 @ real ).

thf(tcon_Real_Oreal___Rings_Osemiring__no__zero__divisors__cancel_234,axiom,
    semiri6575147826004484403cancel @ real ).

thf(tcon_Real_Oreal___Real__Vector__Spaces_Oreal__normed__algebra,axiom,
    real_V4412858255891104859lgebra @ real ).

thf(tcon_Real_Oreal___Real__Vector__Spaces_Oordered__real__vector,axiom,
    real_V5355595471888546746vector @ real ).

thf(tcon_Real_Oreal___Groups_Ostrict__ordered__ab__semigroup__add_235,axiom,
    strict9044650504122735259up_add @ real ).

thf(tcon_Real_Oreal___Groups_Oordered__cancel__ab__semigroup__add_236,axiom,
    ordere580206878836729694up_add @ real ).

thf(tcon_Real_Oreal___Groups_Oordered__ab__semigroup__add__imp__le_237,axiom,
    ordere2412721322843649153imp_le @ real ).

thf(tcon_Real_Oreal___Rings_Olinordered__comm__semiring__strict_238,axiom,
    linord2810124833399127020strict @ real ).

thf(tcon_Real_Oreal___Real__Vector__Spaces_Oreal__normed__vector,axiom,
    real_V822414075346904944vector @ real ).

thf(tcon_Real_Oreal___Groups_Ostrict__ordered__comm__monoid__add_239,axiom,
    strict7427464778891057005id_add @ real ).

thf(tcon_Real_Oreal___Groups_Oordered__cancel__comm__monoid__add_240,axiom,
    ordere8940638589300402666id_add @ real ).

thf(tcon_Real_Oreal___Topological__Spaces_Otopological__space_241,axiom,
    topolo4958980785337419405_space @ real ).

thf(tcon_Real_Oreal___Topological__Spaces_Olinorder__topology_242,axiom,
    topolo1944317154257567458pology @ real ).

thf(tcon_Real_Oreal___Real__Vector__Spaces_Oreal__normed__field,axiom,
    real_V3459762299906320749_field @ real ).

thf(tcon_Real_Oreal___Real__Vector__Spaces_Oreal__div__algebra,axiom,
    real_V5047593784448816457lgebra @ real ).

thf(tcon_Real_Oreal___Archimedean__Field_Oarchimedean__field_243,axiom,
    archim462609752435547400_field @ real ).

thf(tcon_Real_Oreal___Rings_Olinordered__semiring__1__strict_244,axiom,
    linord715952674999750819strict @ real ).

thf(tcon_Real_Oreal___Real__Vector__Spaces_Ouniformity__dist,axiom,
    real_V768167426530841204y_dist @ real ).

thf(tcon_Real_Oreal___Orderings_Ounbounded__dense__linorder_245,axiom,
    unboun7993243217541854897norder @ real ).

thf(tcon_Real_Oreal___Limits_Otopological__comm__monoid__add_246,axiom,
    topolo5987344860129210374id_add @ real ).

thf(tcon_Real_Oreal___Topological__Spaces_Oorder__topology_247,axiom,
    topolo2564578578187576103pology @ real ).

thf(tcon_Real_Oreal___Rings_Osemiring__1__no__zero__divisors_248,axiom,
    semiri2026040879449505780visors @ real ).

thf(tcon_Real_Oreal___Rings_Olinordered__nonzero__semiring_249,axiom,
    linord181362715937106298miring @ real ).

thf(tcon_Real_Oreal___Real__Vector__Spaces_Oreal__algebra__1,axiom,
    real_V2191834092415804123ebra_1 @ real ).

thf(tcon_Real_Oreal___Real__Vector__Spaces_Ocomplete__space,axiom,
    real_V8037385150606011577_space @ real ).

thf(tcon_Real_Oreal___Limits_Otopological__semigroup__mult_250,axiom,
    topolo4211221413907600880p_mult @ real ).

thf(tcon_Real_Oreal___Topological__Spaces_Ouniform__space,axiom,
    topolo7287701948861334536_space @ real ).

thf(tcon_Real_Oreal___Topological__Spaces_Operfect__space,axiom,
    topolo8386298272705272623_space @ real ).

thf(tcon_Real_Oreal___Rings_Olinordered__semiring__strict_251,axiom,
    linord8928482502909563296strict @ real ).

thf(tcon_Real_Oreal___Rings_Osemiring__no__zero__divisors_252,axiom,
    semiri3467727345109120633visors @ real ).

thf(tcon_Real_Oreal___Real__Vector__Spaces_Oreal__algebra,axiom,
    real_V6157519004096292374lgebra @ real ).

thf(tcon_Real_Oreal___Real__Vector__Spaces_Ometric__space,axiom,
    real_V7819770556892013058_space @ real ).

thf(tcon_Real_Oreal___Limits_Otopological__ab__group__add,axiom,
    topolo1287966508704411220up_add @ real ).

thf(tcon_Real_Oreal___Groups_Oordered__ab__semigroup__add_253,axiom,
    ordere6658533253407199908up_add @ real ).

thf(tcon_Real_Oreal___Groups_Oordered__ab__group__add__abs_254,axiom,
    ordere166539214618696060dd_abs @ real ).

thf(tcon_Real_Oreal___Archimedean__Field_Ofloor__ceiling_255,axiom,
    archim2362893244070406136eiling @ real ).

thf(tcon_Real_Oreal___Real__Vector__Spaces_Oreal__vector,axiom,
    real_V4867850818363320053vector @ real ).

thf(tcon_Real_Oreal___Groups_Oordered__comm__monoid__add_256,axiom,
    ordere6911136660526730532id_add @ real ).

thf(tcon_Real_Oreal___Groups_Olinordered__ab__group__add_257,axiom,
    linord5086331880401160121up_add @ real ).

thf(tcon_Real_Oreal___Groups_Ocancel__ab__semigroup__add_258,axiom,
    cancel2418104881723323429up_add @ real ).

thf(tcon_Real_Oreal___Rings_Oring__1__no__zero__divisors_259,axiom,
    ring_15535105094025558882visors @ real ).

thf(tcon_Real_Oreal___Real__Vector__Spaces_Oreal__field,axiom,
    real_V7773925162809079976_field @ real ).

thf(tcon_Real_Oreal___Limits_Otopological__monoid__add_260,axiom,
    topolo6943815403480290642id_add @ real ).

thf(tcon_Real_Oreal___Groups_Ocancel__comm__monoid__add_261,axiom,
    cancel1802427076303600483id_add @ real ).

thf(tcon_Real_Oreal___Rings_Olinordered__ring__strict_262,axiom,
    linord4710134922213307826strict @ real ).

thf(tcon_Real_Oreal___Rings_Ocomm__semiring__1__cancel_263,axiom,
    comm_s4317794764714335236cancel @ real ).

thf(tcon_Real_Oreal___Limits_Otopological__group__add,axiom,
    topolo1633459387980952147up_add @ real ).

thf(tcon_Real_Oreal___Topological__Spaces_Ot2__space_264,axiom,
    topological_t2_space @ real ).

thf(tcon_Real_Oreal___Rings_Oordered__comm__semiring_265,axiom,
    ordere2520102378445227354miring @ real ).

thf(tcon_Real_Oreal___Rings_Olinordered__semiring__1_266,axiom,
    linord6961819062388156250ring_1 @ real ).

thf(tcon_Real_Oreal___Groups_Oordered__ab__group__add_267,axiom,
    ordered_ab_group_add @ real ).

thf(tcon_Real_Oreal___Groups_Ocancel__semigroup__add_268,axiom,
    cancel_semigroup_add @ real ).

thf(tcon_Real_Oreal___Rings_Olinordered__semiring_269,axiom,
    linordered_semiring @ real ).

thf(tcon_Real_Oreal___Real__Vector__Spaces_Obanach,axiom,
    real_Vector_banach @ real ).

thf(tcon_Real_Oreal___Rings_Oordered__semiring__0_270,axiom,
    ordered_semiring_0 @ real ).

thf(tcon_Real_Oreal___Rings_Olinordered__semidom_271,axiom,
    linordered_semidom @ real ).

thf(tcon_Real_Oreal___Orderings_Odense__linorder_272,axiom,
    dense_linorder @ real ).

thf(tcon_Real_Oreal___Lattices_Osemilattice__sup_273,axiom,
    semilattice_sup @ real ).

thf(tcon_Real_Oreal___Lattices_Osemilattice__inf_274,axiom,
    semilattice_inf @ real ).

thf(tcon_Real_Oreal___Groups_Oab__semigroup__mult_275,axiom,
    ab_semigroup_mult @ real ).

thf(tcon_Real_Oreal___Rings_Osemiring__1__cancel_276,axiom,
    semiring_1_cancel @ real ).

thf(tcon_Real_Oreal___Groups_Ocomm__monoid__mult_277,axiom,
    comm_monoid_mult @ real ).

thf(tcon_Real_Oreal___Groups_Oab__semigroup__add_278,axiom,
    ab_semigroup_add @ real ).

thf(tcon_Real_Oreal___Fields_Olinordered__field_279,axiom,
    linordered_field @ real ).

thf(tcon_Real_Oreal___Rings_Oordered__semiring_280,axiom,
    ordered_semiring @ real ).

thf(tcon_Real_Oreal___Rings_Oordered__ring__abs_281,axiom,
    ordered_ring_abs @ real ).

thf(tcon_Real_Oreal___Groups_Ocomm__monoid__add_282,axiom,
    comm_monoid_add @ real ).

thf(tcon_Real_Oreal___Rings_Olinordered__ring_283,axiom,
    linordered_ring @ real ).

thf(tcon_Real_Oreal___Rings_Olinordered__idom_284,axiom,
    linordered_idom @ real ).

thf(tcon_Real_Oreal___Rings_Ocomm__semiring__1_285,axiom,
    comm_semiring_1 @ real ).

thf(tcon_Real_Oreal___Rings_Ocomm__semiring__0_286,axiom,
    comm_semiring_0 @ real ).

thf(tcon_Real_Oreal___Orderings_Odense__order_287,axiom,
    dense_order @ real ).

thf(tcon_Real_Oreal___Groups_Osemigroup__mult_288,axiom,
    semigroup_mult @ real ).

thf(tcon_Real_Oreal___Rings_Osemidom__divide_289,axiom,
    semidom_divide @ real ).

thf(tcon_Real_Oreal___Num_Osemiring__numeral_290,axiom,
    semiring_numeral @ real ).

thf(tcon_Real_Oreal___Groups_Osemigroup__add_291,axiom,
    semigroup_add @ real ).

thf(tcon_Real_Oreal___Fields_Ofield__abs__sgn_292,axiom,
    field_abs_sgn @ real ).

thf(tcon_Real_Oreal___Fields_Odivision__ring_293,axiom,
    division_ring @ real ).

thf(tcon_Real_Oreal___Rings_Ozero__less__one_294,axiom,
    zero_less_one @ real ).

thf(tcon_Real_Oreal___Rings_Ocomm__semiring_295,axiom,
    comm_semiring @ real ).

thf(tcon_Real_Oreal___Nat_Osemiring__char__0_296,axiom,
    semiring_char_0 @ real ).

thf(tcon_Real_Oreal___Groups_Oab__group__add_297,axiom,
    ab_group_add @ real ).

thf(tcon_Real_Oreal___Fields_Ofield__char__0_298,axiom,
    field_char_0 @ real ).

thf(tcon_Real_Oreal___Rings_Ozero__neq__one_299,axiom,
    zero_neq_one @ real ).

thf(tcon_Real_Oreal___Rings_Oordered__ring_300,axiom,
    ordered_ring @ real ).

thf(tcon_Real_Oreal___Rings_Oidom__abs__sgn_301,axiom,
    idom_abs_sgn @ real ).

thf(tcon_Real_Oreal___Orderings_Opreorder_302,axiom,
    preorder @ real ).

thf(tcon_Real_Oreal___Orderings_Olinorder_303,axiom,
    linorder @ real ).

thf(tcon_Real_Oreal___Groups_Omonoid__mult_304,axiom,
    monoid_mult @ real ).

thf(tcon_Real_Oreal___Transcendental_Oln,axiom,
    ln @ real ).

thf(tcon_Real_Oreal___Rings_Oidom__divide_305,axiom,
    idom_divide @ real ).

thf(tcon_Real_Oreal___Rings_Ocomm__ring__1_306,axiom,
    comm_ring_1 @ real ).

thf(tcon_Real_Oreal___Groups_Omonoid__add_307,axiom,
    monoid_add @ real ).

thf(tcon_Real_Oreal___Rings_Osemiring__1_308,axiom,
    semiring_1 @ real ).

thf(tcon_Real_Oreal___Rings_Osemiring__0_309,axiom,
    semiring_0 @ real ).

thf(tcon_Real_Oreal___Orderings_Ono__top_310,axiom,
    no_top @ real ).

thf(tcon_Real_Oreal___Orderings_Ono__bot_311,axiom,
    no_bot @ real ).

thf(tcon_Real_Oreal___Lattices_Olattice_312,axiom,
    lattice @ real ).

thf(tcon_Real_Oreal___Groups_Ogroup__add_313,axiom,
    group_add @ real ).

thf(tcon_Real_Oreal___Rings_Omult__zero_314,axiom,
    mult_zero @ real ).

thf(tcon_Real_Oreal___Rings_Ocomm__ring_315,axiom,
    comm_ring @ real ).

thf(tcon_Real_Oreal___Orderings_Oorder_316,axiom,
    order @ real ).

thf(tcon_Real_Oreal___Num_Oneg__numeral_317,axiom,
    neg_numeral @ real ).

thf(tcon_Real_Oreal___Nat_Oring__char__0_318,axiom,
    ring_char_0 @ real ).

thf(tcon_Real_Oreal___Rings_Osemiring_319,axiom,
    semiring @ real ).

thf(tcon_Real_Oreal___Fields_Oinverse_320,axiom,
    inverse @ real ).

thf(tcon_Real_Oreal___Rings_Osemidom_321,axiom,
    semidom @ real ).

thf(tcon_Real_Oreal___Orderings_Oord_322,axiom,
    ord @ real ).

thf(tcon_Real_Oreal___Groups_Ouminus_323,axiom,
    uminus @ real ).

thf(tcon_Real_Oreal___Rings_Oring__1_324,axiom,
    ring_1 @ real ).

thf(tcon_Real_Oreal___Rings_Oabs__if_325,axiom,
    abs_if @ real ).

thf(tcon_Real_Oreal___Fields_Ofield_326,axiom,
    field @ real ).

thf(tcon_Real_Oreal___Power_Opower_327,axiom,
    power @ real ).

thf(tcon_Real_Oreal___Num_Onumeral_328,axiom,
    numeral @ real ).

thf(tcon_Real_Oreal___Groups_Ozero_329,axiom,
    zero @ real ).

thf(tcon_Real_Oreal___Groups_Oplus_330,axiom,
    plus @ real ).

thf(tcon_Real_Oreal___Rings_Oring_331,axiom,
    ring @ real ).

thf(tcon_Real_Oreal___Rings_Oidom_332,axiom,
    idom @ real ).

thf(tcon_Real_Oreal___Groups_Oone_333,axiom,
    one @ real ).

thf(tcon_Real_Oreal___Rings_Odvd_334,axiom,
    dvd @ real ).

thf(tcon_String_Ochar___Nat_Osize_335,axiom,
    size @ char ).

thf(tcon_Sum__Type_Osum___Nat_Osize_336,axiom,
    ! [A16: $tType,A19: $tType] : ( size @ ( sum_sum @ A16 @ A19 ) ) ).

thf(tcon_Filter_Ofilter___Conditionally__Complete__Lattices_Oconditionally__complete__lattice_337,axiom,
    ! [A16: $tType] : ( condit1219197933456340205attice @ ( filter @ A16 ) ) ).

thf(tcon_Filter_Ofilter___Countable__Complete__Lattices_Ocountable__complete__lattice_338,axiom,
    ! [A16: $tType] : ( counta3822494911875563373attice @ ( filter @ A16 ) ) ).

thf(tcon_Filter_Ofilter___Lattices_Obounded__semilattice__sup__bot_339,axiom,
    ! [A16: $tType] : ( bounde4967611905675639751up_bot @ ( filter @ A16 ) ) ).

thf(tcon_Filter_Ofilter___Lattices_Obounded__semilattice__inf__top_340,axiom,
    ! [A16: $tType] : ( bounde4346867609351753570nf_top @ ( filter @ A16 ) ) ).

thf(tcon_Filter_Ofilter___Complete__Lattices_Ocomplete__lattice_341,axiom,
    ! [A16: $tType] : ( comple6319245703460814977attice @ ( filter @ A16 ) ) ).

thf(tcon_Filter_Ofilter___Lattices_Osemilattice__sup_342,axiom,
    ! [A16: $tType] : ( semilattice_sup @ ( filter @ A16 ) ) ).

thf(tcon_Filter_Ofilter___Lattices_Osemilattice__inf_343,axiom,
    ! [A16: $tType] : ( semilattice_inf @ ( filter @ A16 ) ) ).

thf(tcon_Filter_Ofilter___Orderings_Oorder__top_344,axiom,
    ! [A16: $tType] : ( order_top @ ( filter @ A16 ) ) ).

thf(tcon_Filter_Ofilter___Orderings_Oorder__bot_345,axiom,
    ! [A16: $tType] : ( order_bot @ ( filter @ A16 ) ) ).

thf(tcon_Filter_Ofilter___Orderings_Opreorder_346,axiom,
    ! [A16: $tType] : ( preorder @ ( filter @ A16 ) ) ).

thf(tcon_Filter_Ofilter___Lattices_Olattice_347,axiom,
    ! [A16: $tType] : ( lattice @ ( filter @ A16 ) ) ).

thf(tcon_Filter_Ofilter___Orderings_Oorder_348,axiom,
    ! [A16: $tType] : ( order @ ( filter @ A16 ) ) ).

thf(tcon_Filter_Ofilter___Orderings_Oord_349,axiom,
    ! [A16: $tType] : ( ord @ ( filter @ A16 ) ) ).

thf(tcon_Option_Ooption___Nat_Osize_350,axiom,
    ! [A16: $tType] : ( size @ ( option @ A16 ) ) ).

thf(tcon_Complex_Ocomplex___Semiring__Normalization_Ocomm__semiring__1__cancel__crossproduct_351,axiom,
    semiri1453513574482234551roduct @ complex ).

thf(tcon_Complex_Ocomplex___Topological__Spaces_Ofirst__countable__topology_352,axiom,
    topolo3112930676232923870pology @ complex ).

thf(tcon_Complex_Ocomplex___Real__Vector__Spaces_Oreal__normed__div__algebra_353,axiom,
    real_V8999393235501362500lgebra @ complex ).

thf(tcon_Complex_Ocomplex___Real__Vector__Spaces_Oreal__normed__algebra__1_354,axiom,
    real_V2822296259951069270ebra_1 @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Osemiring__no__zero__divisors__cancel_355,axiom,
    semiri6575147826004484403cancel @ complex ).

thf(tcon_Complex_Ocomplex___Real__Vector__Spaces_Oreal__normed__algebra_356,axiom,
    real_V4412858255891104859lgebra @ complex ).

thf(tcon_Complex_Ocomplex___Real__Vector__Spaces_Oreal__normed__vector_357,axiom,
    real_V822414075346904944vector @ complex ).

thf(tcon_Complex_Ocomplex___Topological__Spaces_Otopological__space_358,axiom,
    topolo4958980785337419405_space @ complex ).

thf(tcon_Complex_Ocomplex___Real__Vector__Spaces_Oreal__normed__field_359,axiom,
    real_V3459762299906320749_field @ complex ).

thf(tcon_Complex_Ocomplex___Real__Vector__Spaces_Oreal__div__algebra_360,axiom,
    real_V5047593784448816457lgebra @ complex ).

thf(tcon_Complex_Ocomplex___Real__Vector__Spaces_Ouniformity__dist_361,axiom,
    real_V768167426530841204y_dist @ complex ).

thf(tcon_Complex_Ocomplex___Limits_Otopological__comm__monoid__add_362,axiom,
    topolo5987344860129210374id_add @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Osemiring__1__no__zero__divisors_363,axiom,
    semiri2026040879449505780visors @ complex ).

thf(tcon_Complex_Ocomplex___Real__Vector__Spaces_Oreal__algebra__1_364,axiom,
    real_V2191834092415804123ebra_1 @ complex ).

thf(tcon_Complex_Ocomplex___Real__Vector__Spaces_Ocomplete__space_365,axiom,
    real_V8037385150606011577_space @ complex ).

thf(tcon_Complex_Ocomplex___Limits_Otopological__semigroup__mult_366,axiom,
    topolo4211221413907600880p_mult @ complex ).

thf(tcon_Complex_Ocomplex___Topological__Spaces_Ouniform__space_367,axiom,
    topolo7287701948861334536_space @ complex ).

thf(tcon_Complex_Ocomplex___Topological__Spaces_Operfect__space_368,axiom,
    topolo8386298272705272623_space @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Osemiring__no__zero__divisors_369,axiom,
    semiri3467727345109120633visors @ complex ).

thf(tcon_Complex_Ocomplex___Real__Vector__Spaces_Oreal__algebra_370,axiom,
    real_V6157519004096292374lgebra @ complex ).

thf(tcon_Complex_Ocomplex___Real__Vector__Spaces_Ometric__space_371,axiom,
    real_V7819770556892013058_space @ complex ).

thf(tcon_Complex_Ocomplex___Limits_Otopological__ab__group__add_372,axiom,
    topolo1287966508704411220up_add @ complex ).

thf(tcon_Complex_Ocomplex___Real__Vector__Spaces_Oreal__vector_373,axiom,
    real_V4867850818363320053vector @ complex ).

thf(tcon_Complex_Ocomplex___Groups_Ocancel__ab__semigroup__add_374,axiom,
    cancel2418104881723323429up_add @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Oring__1__no__zero__divisors_375,axiom,
    ring_15535105094025558882visors @ complex ).

thf(tcon_Complex_Ocomplex___Real__Vector__Spaces_Oreal__field_376,axiom,
    real_V7773925162809079976_field @ complex ).

thf(tcon_Complex_Ocomplex___Limits_Otopological__monoid__add_377,axiom,
    topolo6943815403480290642id_add @ complex ).

thf(tcon_Complex_Ocomplex___Groups_Ocancel__comm__monoid__add_378,axiom,
    cancel1802427076303600483id_add @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Ocomm__semiring__1__cancel_379,axiom,
    comm_s4317794764714335236cancel @ complex ).

thf(tcon_Complex_Ocomplex___Limits_Otopological__group__add_380,axiom,
    topolo1633459387980952147up_add @ complex ).

thf(tcon_Complex_Ocomplex___Topological__Spaces_Ot2__space_381,axiom,
    topological_t2_space @ complex ).

thf(tcon_Complex_Ocomplex___Groups_Ocancel__semigroup__add_382,axiom,
    cancel_semigroup_add @ complex ).

thf(tcon_Complex_Ocomplex___Real__Vector__Spaces_Obanach_383,axiom,
    real_Vector_banach @ complex ).

thf(tcon_Complex_Ocomplex___Groups_Oab__semigroup__mult_384,axiom,
    ab_semigroup_mult @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Osemiring__1__cancel_385,axiom,
    semiring_1_cancel @ complex ).

thf(tcon_Complex_Ocomplex___Groups_Ocomm__monoid__mult_386,axiom,
    comm_monoid_mult @ complex ).

thf(tcon_Complex_Ocomplex___Groups_Oab__semigroup__add_387,axiom,
    ab_semigroup_add @ complex ).

thf(tcon_Complex_Ocomplex___Groups_Ocomm__monoid__add_388,axiom,
    comm_monoid_add @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Ocomm__semiring__1_389,axiom,
    comm_semiring_1 @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Ocomm__semiring__0_390,axiom,
    comm_semiring_0 @ complex ).

thf(tcon_Complex_Ocomplex___Groups_Osemigroup__mult_391,axiom,
    semigroup_mult @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Osemidom__divide_392,axiom,
    semidom_divide @ complex ).

thf(tcon_Complex_Ocomplex___Num_Osemiring__numeral_393,axiom,
    semiring_numeral @ complex ).

thf(tcon_Complex_Ocomplex___Groups_Osemigroup__add_394,axiom,
    semigroup_add @ complex ).

thf(tcon_Complex_Ocomplex___Fields_Ofield__abs__sgn_395,axiom,
    field_abs_sgn @ complex ).

thf(tcon_Complex_Ocomplex___Fields_Odivision__ring_396,axiom,
    division_ring @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Ocomm__semiring_397,axiom,
    comm_semiring @ complex ).

thf(tcon_Complex_Ocomplex___Nat_Osemiring__char__0_398,axiom,
    semiring_char_0 @ complex ).

thf(tcon_Complex_Ocomplex___Groups_Oab__group__add_399,axiom,
    ab_group_add @ complex ).

thf(tcon_Complex_Ocomplex___Fields_Ofield__char__0_400,axiom,
    field_char_0 @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Ozero__neq__one_401,axiom,
    zero_neq_one @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Oidom__abs__sgn_402,axiom,
    idom_abs_sgn @ complex ).

thf(tcon_Complex_Ocomplex___Groups_Omonoid__mult_403,axiom,
    monoid_mult @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Oidom__divide_404,axiom,
    idom_divide @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Ocomm__ring__1_405,axiom,
    comm_ring_1 @ complex ).

thf(tcon_Complex_Ocomplex___Groups_Omonoid__add_406,axiom,
    monoid_add @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Osemiring__1_407,axiom,
    semiring_1 @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Osemiring__0_408,axiom,
    semiring_0 @ complex ).

thf(tcon_Complex_Ocomplex___Groups_Ogroup__add_409,axiom,
    group_add @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Omult__zero_410,axiom,
    mult_zero @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Ocomm__ring_411,axiom,
    comm_ring @ complex ).

thf(tcon_Complex_Ocomplex___Num_Oneg__numeral_412,axiom,
    neg_numeral @ complex ).

thf(tcon_Complex_Ocomplex___Nat_Oring__char__0_413,axiom,
    ring_char_0 @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Osemiring_414,axiom,
    semiring @ complex ).

thf(tcon_Complex_Ocomplex___Fields_Oinverse_415,axiom,
    inverse @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Osemidom_416,axiom,
    semidom @ complex ).

thf(tcon_Complex_Ocomplex___Groups_Ouminus_417,axiom,
    uminus @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Oring__1_418,axiom,
    ring_1 @ complex ).

thf(tcon_Complex_Ocomplex___Fields_Ofield_419,axiom,
    field @ complex ).

thf(tcon_Complex_Ocomplex___Power_Opower_420,axiom,
    power @ complex ).

thf(tcon_Complex_Ocomplex___Num_Onumeral_421,axiom,
    numeral @ complex ).

thf(tcon_Complex_Ocomplex___Groups_Ozero_422,axiom,
    zero @ complex ).

thf(tcon_Complex_Ocomplex___Groups_Oplus_423,axiom,
    plus @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Oring_424,axiom,
    ring @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Oidom_425,axiom,
    idom @ complex ).

thf(tcon_Complex_Ocomplex___Groups_Oone_426,axiom,
    one @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Odvd_427,axiom,
    dvd @ complex ).

thf(tcon_Extended__Nat_Oenat___Conditionally__Complete__Lattices_Oconditionally__complete__linorder_428,axiom,
    condit6923001295902523014norder @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Conditionally__Complete__Lattices_Oconditionally__complete__lattice_429,axiom,
    condit1219197933456340205attice @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Countable__Complete__Lattices_Ocountable__complete__lattice_430,axiom,
    counta3822494911875563373attice @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Complete__Lattices_Ocomplete__distrib__lattice_431,axiom,
    comple592849572758109894attice @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Groups_Ostrict__ordered__ab__semigroup__add_432,axiom,
    strict9044650504122735259up_add @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Groups_Ostrict__ordered__comm__monoid__add_433,axiom,
    strict7427464778891057005id_add @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Groups_Ocanonically__ordered__monoid__add_434,axiom,
    canoni5634975068530333245id_add @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Lattices_Obounded__semilattice__sup__bot_435,axiom,
    bounde4967611905675639751up_bot @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Lattices_Obounded__semilattice__inf__top_436,axiom,
    bounde4346867609351753570nf_top @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Complete__Lattices_Ocomplete__linorder,axiom,
    comple5582772986160207858norder @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Complete__Lattices_Ocomplete__lattice_437,axiom,
    comple6319245703460814977attice @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Rings_Olinordered__nonzero__semiring_438,axiom,
    linord181362715937106298miring @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Rings_Osemiring__no__zero__divisors_439,axiom,
    semiri3467727345109120633visors @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Groups_Oordered__ab__semigroup__add_440,axiom,
    ordere6658533253407199908up_add @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Groups_Oordered__comm__monoid__add_441,axiom,
    ordere6911136660526730532id_add @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Rings_Oordered__comm__semiring_442,axiom,
    ordere2520102378445227354miring @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Lattices_Osemilattice__sup_443,axiom,
    semilattice_sup @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Lattices_Osemilattice__inf_444,axiom,
    semilattice_inf @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Groups_Oab__semigroup__mult_445,axiom,
    ab_semigroup_mult @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Groups_Ocomm__monoid__mult_446,axiom,
    comm_monoid_mult @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Groups_Oab__semigroup__add_447,axiom,
    ab_semigroup_add @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Rings_Oordered__semiring_448,axiom,
    ordered_semiring @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Groups_Ocomm__monoid__add_449,axiom,
    comm_monoid_add @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Rings_Ocomm__semiring__1_450,axiom,
    comm_semiring_1 @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Rings_Ocomm__semiring__0_451,axiom,
    comm_semiring_0 @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Groups_Osemigroup__mult_452,axiom,
    semigroup_mult @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Num_Osemiring__numeral_453,axiom,
    semiring_numeral @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Groups_Osemigroup__add_454,axiom,
    semigroup_add @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Rings_Ozero__less__one_455,axiom,
    zero_less_one @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Rings_Ocomm__semiring_456,axiom,
    comm_semiring @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Orderings_Owellorder_457,axiom,
    wellorder @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Orderings_Oorder__top_458,axiom,
    order_top @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Orderings_Oorder__bot_459,axiom,
    order_bot @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Nat_Osemiring__char__0_460,axiom,
    semiring_char_0 @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Rings_Ozero__neq__one_461,axiom,
    zero_neq_one @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Orderings_Opreorder_462,axiom,
    preorder @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Orderings_Olinorder_463,axiom,
    linorder @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Groups_Omonoid__mult_464,axiom,
    monoid_mult @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Groups_Omonoid__add_465,axiom,
    monoid_add @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Rings_Osemiring__1_466,axiom,
    semiring_1 @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Rings_Osemiring__0_467,axiom,
    semiring_0 @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Lattices_Olattice_468,axiom,
    lattice @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Rings_Omult__zero_469,axiom,
    mult_zero @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Orderings_Oorder_470,axiom,
    order @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Rings_Osemiring_471,axiom,
    semiring @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Orderings_Oord_472,axiom,
    ord @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Power_Opower_473,axiom,
    power @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Num_Onumeral_474,axiom,
    numeral @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Groups_Ozero_475,axiom,
    zero @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Groups_Oplus_476,axiom,
    plus @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Groups_Oone_477,axiom,
    one @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Rings_Odvd_478,axiom,
    dvd @ extended_enat ).

thf(tcon_Product__Type_Oprod___Topological__Spaces_Otopological__space_479,axiom,
    ! [A16: $tType,A19: $tType] :
      ( ( ( topolo4958980785337419405_space @ A16 )
        & ( topolo4958980785337419405_space @ A19 ) )
     => ( topolo4958980785337419405_space @ ( product_prod @ A16 @ A19 ) ) ) ).

thf(tcon_Product__Type_Oprod___Topological__Spaces_Ot2__space_480,axiom,
    ! [A16: $tType,A19: $tType] :
      ( ( ( topological_t2_space @ A16 )
        & ( topological_t2_space @ A19 ) )
     => ( topological_t2_space @ ( product_prod @ A16 @ A19 ) ) ) ).

thf(tcon_Product__Type_Oprod___Nat_Osize_481,axiom,
    ! [A16: $tType,A19: $tType] : ( size @ ( product_prod @ A16 @ A19 ) ) ).

thf(tcon_Product__Type_Ounit___Conditionally__Complete__Lattices_Oconditionally__complete__linorder_482,axiom,
    condit6923001295902523014norder @ product_unit ).

thf(tcon_Product__Type_Ounit___Conditionally__Complete__Lattices_Oconditionally__complete__lattice_483,axiom,
    condit1219197933456340205attice @ product_unit ).

thf(tcon_Product__Type_Ounit___Countable__Complete__Lattices_Ocountable__complete__lattice_484,axiom,
    counta3822494911875563373attice @ product_unit ).

thf(tcon_Product__Type_Ounit___Complete__Lattices_Ocomplete__distrib__lattice_485,axiom,
    comple592849572758109894attice @ product_unit ).

thf(tcon_Product__Type_Ounit___Lattices_Obounded__semilattice__sup__bot_486,axiom,
    bounde4967611905675639751up_bot @ product_unit ).

thf(tcon_Product__Type_Ounit___Lattices_Obounded__semilattice__inf__top_487,axiom,
    bounde4346867609351753570nf_top @ product_unit ).

thf(tcon_Product__Type_Ounit___Complete__Lattices_Ocomplete__linorder_488,axiom,
    comple5582772986160207858norder @ product_unit ).

thf(tcon_Product__Type_Ounit___Complete__Lattices_Ocomplete__lattice_489,axiom,
    comple6319245703460814977attice @ product_unit ).

thf(tcon_Product__Type_Ounit___Boolean__Algebras_Oboolean__algebra_490,axiom,
    boolea8198339166811842893lgebra @ product_unit ).

thf(tcon_Product__Type_Ounit___Lattices_Osemilattice__sup_491,axiom,
    semilattice_sup @ product_unit ).

thf(tcon_Product__Type_Ounit___Lattices_Osemilattice__inf_492,axiom,
    semilattice_inf @ product_unit ).

thf(tcon_Product__Type_Ounit___Orderings_Owellorder_493,axiom,
    wellorder @ product_unit ).

thf(tcon_Product__Type_Ounit___Orderings_Oorder__top_494,axiom,
    order_top @ product_unit ).

thf(tcon_Product__Type_Ounit___Orderings_Oorder__bot_495,axiom,
    order_bot @ product_unit ).

thf(tcon_Product__Type_Ounit___Orderings_Opreorder_496,axiom,
    preorder @ product_unit ).

thf(tcon_Product__Type_Ounit___Orderings_Olinorder_497,axiom,
    linorder @ product_unit ).

thf(tcon_Product__Type_Ounit___Lattices_Olattice_498,axiom,
    lattice @ product_unit ).

thf(tcon_Product__Type_Ounit___Orderings_Oorder_499,axiom,
    order @ product_unit ).

thf(tcon_Product__Type_Ounit___Orderings_Oord_500,axiom,
    ord @ product_unit ).

thf(tcon_Product__Type_Ounit___Groups_Ouminus_501,axiom,
    uminus @ product_unit ).

thf(tcon_Code__Numeral_Ointeger___Bit__Operations_Ounique__euclidean__semiring__with__bit__operations_502,axiom,
    bit_un5681908812861735899ations @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Semiring__Normalization_Ocomm__semiring__1__cancel__crossproduct_503,axiom,
    semiri1453513574482234551roduct @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Euclidean__Division_Ounique__euclidean__semiring__with__nat_504,axiom,
    euclid5411537665997757685th_nat @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Euclidean__Division_Ounique__euclidean__ring__with__nat_505,axiom,
    euclid8789492081693882211th_nat @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Oordered__ab__semigroup__monoid__add__imp__le_506,axiom,
    ordere1937475149494474687imp_le @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Euclidean__Division_Ounique__euclidean__semiring_507,axiom,
    euclid3128863361964157862miring @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Euclidean__Division_Oeuclidean__semiring__cancel_508,axiom,
    euclid4440199948858584721cancel @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Divides_Ounique__euclidean__semiring__numeral_509,axiom,
    unique1627219031080169319umeral @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Euclidean__Division_Oeuclidean__ring__cancel_510,axiom,
    euclid8851590272496341667cancel @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Osemiring__no__zero__divisors__cancel_511,axiom,
    semiri6575147826004484403cancel @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Ostrict__ordered__ab__semigroup__add_512,axiom,
    strict9044650504122735259up_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Oordered__cancel__ab__semigroup__add_513,axiom,
    ordere580206878836729694up_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Oordered__ab__semigroup__add__imp__le_514,axiom,
    ordere2412721322843649153imp_le @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Bit__Operations_Osemiring__bit__operations_515,axiom,
    bit_se359711467146920520ations @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Olinordered__comm__semiring__strict_516,axiom,
    linord2810124833399127020strict @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Ostrict__ordered__comm__monoid__add_517,axiom,
    strict7427464778891057005id_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Oordered__cancel__comm__monoid__add_518,axiom,
    ordere8940638589300402666id_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Euclidean__Division_Oeuclidean__semiring_519,axiom,
    euclid3725896446679973847miring @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Olinordered__semiring__1__strict_520,axiom,
    linord715952674999750819strict @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Bit__Operations_Oring__bit__operations_521,axiom,
    bit_ri3973907225187159222ations @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Osemiring__1__no__zero__divisors_522,axiom,
    semiri2026040879449505780visors @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Olinordered__nonzero__semiring_523,axiom,
    linord181362715937106298miring @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Euclidean__Division_Oeuclidean__ring_524,axiom,
    euclid5891614535332579305n_ring @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Olinordered__semiring__strict_525,axiom,
    linord8928482502909563296strict @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Osemiring__no__zero__divisors_526,axiom,
    semiri3467727345109120633visors @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Oordered__ab__semigroup__add_527,axiom,
    ordere6658533253407199908up_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Oordered__ab__group__add__abs_528,axiom,
    ordere166539214618696060dd_abs @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Oordered__comm__monoid__add_529,axiom,
    ordere6911136660526730532id_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Olinordered__ab__group__add_530,axiom,
    linord5086331880401160121up_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Ocancel__ab__semigroup__add_531,axiom,
    cancel2418104881723323429up_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Oring__1__no__zero__divisors_532,axiom,
    ring_15535105094025558882visors @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Ocancel__comm__monoid__add_533,axiom,
    cancel1802427076303600483id_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Olinordered__ring__strict_534,axiom,
    linord4710134922213307826strict @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Ocomm__semiring__1__cancel_535,axiom,
    comm_s4317794764714335236cancel @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Bit__Operations_Osemiring__bits_536,axiom,
    bit_semiring_bits @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Oordered__comm__semiring_537,axiom,
    ordere2520102378445227354miring @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Olinordered__semiring__1_538,axiom,
    linord6961819062388156250ring_1 @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Oordered__ab__group__add_539,axiom,
    ordered_ab_group_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Ocancel__semigroup__add_540,axiom,
    cancel_semigroup_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Olinordered__semiring_541,axiom,
    linordered_semiring @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Oordered__semiring__0_542,axiom,
    ordered_semiring_0 @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Olinordered__semidom_543,axiom,
    linordered_semidom @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Oab__semigroup__mult_544,axiom,
    ab_semigroup_mult @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Osemiring__1__cancel_545,axiom,
    semiring_1_cancel @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Oalgebraic__semidom_546,axiom,
    algebraic_semidom @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Ocomm__monoid__mult_547,axiom,
    comm_monoid_mult @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Oab__semigroup__add_548,axiom,
    ab_semigroup_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Oordered__semiring_549,axiom,
    ordered_semiring @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Oordered__ring__abs_550,axiom,
    ordered_ring_abs @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Parity_Osemiring__parity_551,axiom,
    semiring_parity @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Ocomm__monoid__add_552,axiom,
    comm_monoid_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Osemiring__modulo_553,axiom,
    semiring_modulo @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Olinordered__ring_554,axiom,
    linordered_ring @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Olinordered__idom_555,axiom,
    linordered_idom @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Ocomm__semiring__1_556,axiom,
    comm_semiring_1 @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Ocomm__semiring__0_557,axiom,
    comm_semiring_0 @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Osemigroup__mult_558,axiom,
    semigroup_mult @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Osemidom__modulo_559,axiom,
    semidom_modulo @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Osemidom__divide_560,axiom,
    semidom_divide @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Num_Osemiring__numeral_561,axiom,
    semiring_numeral @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Osemigroup__add_562,axiom,
    semigroup_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Ozero__less__one_563,axiom,
    zero_less_one @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Ocomm__semiring_564,axiom,
    comm_semiring @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Nat_Osemiring__char__0_565,axiom,
    semiring_char_0 @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Oab__group__add_566,axiom,
    ab_group_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Ozero__neq__one_567,axiom,
    zero_neq_one @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Oordered__ring_568,axiom,
    ordered_ring @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Oidom__abs__sgn_569,axiom,
    idom_abs_sgn @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Parity_Oring__parity_570,axiom,
    ring_parity @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Orderings_Opreorder_571,axiom,
    preorder @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Orderings_Olinorder_572,axiom,
    linorder @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Omonoid__mult_573,axiom,
    monoid_mult @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Oidom__modulo_574,axiom,
    idom_modulo @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Oidom__divide_575,axiom,
    idom_divide @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Ocomm__ring__1_576,axiom,
    comm_ring_1 @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Omonoid__add_577,axiom,
    monoid_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Osemiring__1_578,axiom,
    semiring_1 @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Osemiring__0_579,axiom,
    semiring_0 @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Ogroup__add_580,axiom,
    group_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Omult__zero_581,axiom,
    mult_zero @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Ocomm__ring_582,axiom,
    comm_ring @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Orderings_Oorder_583,axiom,
    order @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Num_Oneg__numeral_584,axiom,
    neg_numeral @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Nat_Oring__char__0_585,axiom,
    ring_char_0 @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Osemiring_586,axiom,
    semiring @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Osemidom_587,axiom,
    semidom @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Orderings_Oord_588,axiom,
    ord @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Ouminus_589,axiom,
    uminus @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Oring__1_590,axiom,
    ring_1 @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Oabs__if_591,axiom,
    abs_if @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Power_Opower_592,axiom,
    power @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Num_Onumeral_593,axiom,
    numeral @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Ozero_594,axiom,
    zero @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Oplus_595,axiom,
    plus @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Oring_596,axiom,
    ring @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Oidom_597,axiom,
    idom @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Oone_598,axiom,
    one @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Odvd_599,axiom,
    dvd @ code_integer ).

thf(tcon_VEBT__Definitions_OVEBT___Nat_Osize_600,axiom,
    size @ vEBT_VEBT ).

% Helper facts (4)
thf(help_If_3_1_T,axiom,
    ! [P: $o] :
      ( ( P = $true )
      | ( P = $false ) ) ).

thf(help_If_2_1_T,axiom,
    ! [A: $tType,X2: A,Y2: A] :
      ( ( if @ A @ $false @ X2 @ Y2 )
      = Y2 ) ).

thf(help_If_1_1_T,axiom,
    ! [A: $tType,X2: A,Y2: A] :
      ( ( if @ A @ $true @ X2 @ Y2 )
      = X2 ) ).

thf(help_fChoice_1_1_T,axiom,
    ! [A: $tType,P: A > $o] :
      ( ( P @ ( fChoice @ A @ P ) )
      = ( ? [X4: A] : ( P @ X4 ) ) ) ).

% Conjectures (1)
thf(conj_0,conjecture,
    vEBT_invar_vebt @ ( vEBT_vebt_insert @ ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ deg @ treeList @ summary ) @ xa ) @ deg ).

%------------------------------------------------------------------------------
