%------------------------------------------------------------------------------
% File     : VBT00030^2 : TPTP v7.6.0. Released v7.6.0.
% Domain   : Interactive Theorem Proving
% Problem  : Sledgehammer problem VEBT_InsertCorrectness 00411_025873
% Version  : [Des22] axioms.
% English  :

% Refs     : [BH+15] Blanchette et al. (2015), Mining the Archive of Formal
%          : [Des22] Desharnais (2022), Email to Geoff Sutcliffe
% Source   : [Des22]
% Names    : 0067_VEBT_InsertCorrectness_00411_025873 [Des22]

% Status   : Theorem
% Rating   : ? v7.6.0
% Syntax   : Number of formulae    : 9691 (2884 unt; 748 typ;   0 def)
%            Number of atoms       : 29556 (9389 equ;   0 cnn)
%            Maximal formula atoms :   71 (   3 avg)
%            Number of connectives : 163074 (2286   ~; 328   |;2186   &;144869   @)
%                                         (   0 <=>;13405  =>;   0  <=;   0 <~>)
%            Maximal formula depth :   40 (   7 avg)
%            Number of types       :   14 (  13 usr)
%            Number of type conns  : 4260 (4260   >;   0   *;   0   +;   0  <<)
%            Number of symbols     :  738 ( 735 usr;  23 con; 0-8 aty)
%            Number of variables   : 26810 (2634   ^22740   !; 795   ?;26810   :)
%                                         ( 641  !>;   0  ?*;   0  @-;   0  @+)
% SPC      : TH1_THM_EQU_NAR

% Comments : This file was generated by Isabelle (most likely Sledgehammer)
%            2022-02-17 20:56:56.626
%------------------------------------------------------------------------------
% Could-be-implicit typings (20)
thf(ty_t_VEBT__Definitions_OVEBT,type,
    vEBT_VEBT: $tType ).

thf(ty_t_Code__Numeral_Onatural,type,
    code_natural: $tType ).

thf(ty_t_Code__Numeral_Ointeger,type,
    code_integer: $tType ).

thf(ty_t_Product__Type_Ounit,type,
    product_unit: $tType ).

thf(ty_t_Product__Type_Oprod,type,
    product_prod: $tType > $tType > $tType ).

thf(ty_t_Extended__Nat_Oenat,type,
    extended_enat: $tType ).

thf(ty_t_Complex_Ocomplex,type,
    complex: $tType ).

thf(ty_t_String_Oliteral,type,
    literal: $tType ).

thf(ty_t_Sum__Type_Osum,type,
    sum_sum: $tType > $tType > $tType ).

thf(ty_t_Option_Ooption,type,
    option: $tType > $tType ).

thf(ty_t_Filter_Ofilter,type,
    filter: $tType > $tType ).

thf(ty_t_String_Ochar,type,
    char: $tType ).

thf(ty_t_Real_Oreal,type,
    real: $tType ).

thf(ty_t_List_Olist,type,
    list: $tType > $tType ).

thf(ty_t_Set_Oset,type,
    set: $tType > $tType ).

thf(ty_t_Rat_Orat,type,
    rat: $tType ).

thf(ty_t_Num_Onum,type,
    num: $tType ).

thf(ty_t_Nat_Onat,type,
    nat: $tType ).

thf(ty_t_Int_Oint,type,
    int: $tType ).

thf(ty_t_itself,type,
    itself: $tType > $tType ).

% Explicit typings (728)
thf(sy_cl_Lattices_Obounded__lattice,type,
    bounded_lattice: 
      !>[A: $tType] : $o ).

thf(sy_cl_HOL_Otype,type,
    type: 
      !>[A: $tType] : $o ).

thf(sy_cl_Nat_Osize,type,
    size: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Odvd,type,
    dvd: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Oone,type,
    one: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Oidom,type,
    idom: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Oring,type,
    ring: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Oplus,type,
    plus: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Ozero,type,
    zero: 
      !>[A: $tType] : $o ).

thf(sy_cl_Num_Onumeral,type,
    numeral: 
      !>[A: $tType] : $o ).

thf(sy_cl_Power_Opower,type,
    power: 
      !>[A: $tType] : $o ).

thf(sy_cl_Fields_Ofield,type,
    field: 
      !>[A: $tType] : $o ).

thf(sy_cl_GCD_Oring__gcd,type,
    ring_gcd: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Ominus,type,
    minus: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Oabs__if,type,
    abs_if: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Oring__1,type,
    ring_1: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Ouminus,type,
    uminus: 
      !>[A: $tType] : $o ).

thf(sy_cl_Orderings_Obot,type,
    bot: 
      !>[A: $tType] : $o ).

thf(sy_cl_Orderings_Oord,type,
    ord: 
      !>[A: $tType] : $o ).

thf(sy_cl_Orderings_Otop,type,
    top: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Osemidom,type,
    semidom: 
      !>[A: $tType] : $o ).

thf(sy_cl_Fields_Oinverse,type,
    inverse: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Osemiring,type,
    semiring: 
      !>[A: $tType] : $o ).

thf(sy_cl_Nat_Oring__char__0,type,
    ring_char_0: 
      !>[A: $tType] : $o ).

thf(sy_cl_Num_Oneg__numeral,type,
    neg_numeral: 
      !>[A: $tType] : $o ).

thf(sy_cl_Orderings_Oorder,type,
    order: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Ocomm__ring,type,
    comm_ring: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Omult__zero,type,
    mult_zero: 
      !>[A: $tType] : $o ).

thf(sy_cl_GCD_Osemiring__Gcd,type,
    semiring_Gcd: 
      !>[A: $tType] : $o ).

thf(sy_cl_GCD_Osemiring__gcd,type,
    semiring_gcd: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Ogroup__add,type,
    group_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Lattices_Olattice,type,
    lattice: 
      !>[A: $tType] : $o ).

thf(sy_cl_Orderings_Ono__bot,type,
    no_bot: 
      !>[A: $tType] : $o ).

thf(sy_cl_Orderings_Ono__top,type,
    no_top: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Osemiring__0,type,
    semiring_0: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Osemiring__1,type,
    semiring_1: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Omonoid__add,type,
    monoid_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Ocomm__ring__1,type,
    comm_ring_1: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Oidom__divide,type,
    idom_divide: 
      !>[A: $tType] : $o ).

thf(sy_cl_Transcendental_Oln,type,
    ln: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Omonoid__mult,type,
    monoid_mult: 
      !>[A: $tType] : $o ).

thf(sy_cl_Orderings_Olinorder,type,
    linorder: 
      !>[A: $tType] : $o ).

thf(sy_cl_Orderings_Opreorder,type,
    preorder: 
      !>[A: $tType] : $o ).

thf(sy_cl_Parity_Oring__parity,type,
    ring_parity: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Oidom__abs__sgn,type,
    idom_abs_sgn: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Oordered__ring,type,
    ordered_ring: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Ozero__neq__one,type,
    zero_neq_one: 
      !>[A: $tType] : $o ).

thf(sy_cl_Fields_Ofield__char__0,type,
    field_char_0: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Oab__group__add,type,
    ab_group_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Nat_Osemiring__char__0,type,
    semiring_char_0: 
      !>[A: $tType] : $o ).

thf(sy_cl_Orderings_Oorder__bot,type,
    order_bot: 
      !>[A: $tType] : $o ).

thf(sy_cl_Orderings_Oorder__top,type,
    order_top: 
      !>[A: $tType] : $o ).

thf(sy_cl_Orderings_Owellorder,type,
    wellorder: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Ozero__less__one,type,
    zero_less_one: 
      !>[A: $tType] : $o ).

thf(sy_cl_Fields_Odivision__ring,type,
    division_ring: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Osemigroup__add,type,
    semigroup_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Num_Osemiring__numeral,type,
    semiring_numeral: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Osemidom__divide,type,
    semidom_divide: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Osemidom__modulo,type,
    semidom_modulo: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Osemigroup__mult,type,
    semigroup_mult: 
      !>[A: $tType] : $o ).

thf(sy_cl_Orderings_Odense__order,type,
    dense_order: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Ocomm__semiring__0,type,
    comm_semiring_0: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Ocomm__semiring__1,type,
    comm_semiring_1: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Olinordered__idom,type,
    linordered_idom: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Olinordered__ring,type,
    linordered_ring: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Osemiring__modulo,type,
    semiring_modulo: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Ocomm__monoid__add,type,
    comm_monoid_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Parity_Osemiring__parity,type,
    semiring_parity: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Oordered__ring__abs,type,
    ordered_ring_abs: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Oordered__semiring,type,
    ordered_semiring: 
      !>[A: $tType] : $o ).

thf(sy_cl_Fields_Olinordered__field,type,
    linordered_field: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Oab__semigroup__add,type,
    ab_semigroup_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Ocomm__monoid__diff,type,
    comm_monoid_diff: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Ocomm__monoid__mult,type,
    comm_monoid_mult: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Oalgebraic__semidom,type,
    algebraic_semidom: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Osemiring__1__cancel,type,
    semiring_1_cancel: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Oab__semigroup__mult,type,
    ab_semigroup_mult: 
      !>[A: $tType] : $o ).

thf(sy_cl_Lattices_Odistrib__lattice,type,
    distrib_lattice: 
      !>[A: $tType] : $o ).

thf(sy_cl_Lattices_Osemilattice__inf,type,
    semilattice_inf: 
      !>[A: $tType] : $o ).

thf(sy_cl_Lattices_Osemilattice__sup,type,
    semilattice_sup: 
      !>[A: $tType] : $o ).

thf(sy_cl_Orderings_Odense__linorder,type,
    dense_linorder: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Olinordered__semidom,type,
    linordered_semidom: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Oordered__semiring__0,type,
    ordered_semiring_0: 
      !>[A: $tType] : $o ).

thf(sy_cl_Real__Vector__Spaces_Obanach,type,
    real_Vector_banach: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Olinordered__semiring,type,
    linordered_semiring: 
      !>[A: $tType] : $o ).

thf(sy_cl_Complete__Partial__Order_Occpo,type,
    comple9053668089753744459l_ccpo: 
      !>[A: $tType] : $o ).

thf(sy_cl_Enum_Ofinite__distrib__lattice,type,
    finite8700451911770168679attice: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Ocancel__semigroup__add,type,
    cancel_semigroup_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Oordered__ab__group__add,type,
    ordered_ab_group_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Olinordered__semiring__1,type,
    linord6961819062388156250ring_1: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Onormalization__semidom,type,
    normal8620421768224518004emidom: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Oordered__comm__semiring,type,
    ordere2520102378445227354miring: 
      !>[A: $tType] : $o ).

thf(sy_cl_Topological__Spaces_Ot2__space,type,
    topological_t2_space: 
      !>[A: $tType] : $o ).

thf(sy_cl_Bit__Operations_Osemiring__bits,type,
    bit_semiring_bits: 
      !>[A: $tType] : $o ).

thf(sy_cl_Lattices_Obounded__lattice__bot,type,
    bounded_lattice_bot: 
      !>[A: $tType] : $o ).

thf(sy_cl_Lattices_Obounded__lattice__top,type,
    bounded_lattice_top: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Olinordered__ring__strict,type,
    linord4710134922213307826strict: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Ocancel__comm__monoid__add,type,
    cancel1802427076303600483id_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Limits_Otopological__monoid__add,type,
    topolo6943815403480290642id_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Real__Vector__Spaces_Oreal__field,type,
    real_V7773925162809079976_field: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Oring__1__no__zero__divisors,type,
    ring_15535105094025558882visors: 
      !>[A: $tType] : $o ).

thf(sy_cl_Topological__Spaces_Ouniformity,type,
    topolo4638772830378233104ormity: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Ocancel__ab__semigroup__add,type,
    cancel2418104881723323429up_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Olinordered__ab__group__add,type,
    linord5086331880401160121up_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Oordered__comm__monoid__add,type,
    ordere6911136660526730532id_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Limits_Otopological__monoid__mult,type,
    topolo1898628316856586783d_mult: 
      !>[A: $tType] : $o ).

thf(sy_cl_Real__Vector__Spaces_Oreal__vector,type,
    real_V4867850818363320053vector: 
      !>[A: $tType] : $o ).

thf(sy_cl_Archimedean__Field_Ofloor__ceiling,type,
    archim2362893244070406136eiling: 
      !>[A: $tType] : $o ).

thf(sy_cl_GCD_Osemiring__gcd__mult__normalize,type,
    semiri6843258321239162965malize: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Oordered__ab__group__add__abs,type,
    ordere166539214618696060dd_abs: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Oordered__ab__semigroup__add,type,
    ordere6658533253407199908up_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Real__Vector__Spaces_Ometric__space,type,
    real_V7819770556892013058_space: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Osemiring__no__zero__divisors,type,
    semiri3467727345109120633visors: 
      !>[A: $tType] : $o ).

thf(sy_cl_Boolean__Algebras_Oboolean__algebra,type,
    boolea8198339166811842893lgebra: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Olinordered__semiring__strict,type,
    linord8928482502909563296strict: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Osemidom__divide__unit__factor,type,
    semido2269285787275462019factor: 
      !>[A: $tType] : $o ).

thf(sy_cl_Topological__Spaces_Operfect__space,type,
    topolo8386298272705272623_space: 
      !>[A: $tType] : $o ).

thf(sy_cl_Topological__Spaces_Ouniform__space,type,
    topolo7287701948861334536_space: 
      !>[A: $tType] : $o ).

thf(sy_cl_Limits_Otopological__semigroup__mult,type,
    topolo4211221413907600880p_mult: 
      !>[A: $tType] : $o ).

thf(sy_cl_Real__Vector__Spaces_Ocomplete__space,type,
    real_V8037385150606011577_space: 
      !>[A: $tType] : $o ).

thf(sy_cl_Real__Vector__Spaces_Oreal__algebra__1,type,
    real_V2191834092415804123ebra_1: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Olinordered__nonzero__semiring,type,
    linord181362715937106298miring: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Osemiring__1__no__zero__divisors,type,
    semiri2026040879449505780visors: 
      !>[A: $tType] : $o ).

thf(sy_cl_Topological__Spaces_Oorder__topology,type,
    topolo2564578578187576103pology: 
      !>[A: $tType] : $o ).

thf(sy_cl_Bit__Operations_Oring__bit__operations,type,
    bit_ri3973907225187159222ations: 
      !>[A: $tType] : $o ).

thf(sy_cl_Complete__Lattices_Ocomplete__lattice,type,
    comple6319245703460814977attice: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Olinordered__ab__semigroup__add,type,
    linord4140545234300271783up_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Limits_Otopological__comm__monoid__add,type,
    topolo5987344860129210374id_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Orderings_Ounbounded__dense__linorder,type,
    unboun7993243217541854897norder: 
      !>[A: $tType] : $o ).

thf(sy_cl_Real__Vector__Spaces_Ouniformity__dist,type,
    real_V768167426530841204y_dist: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Olinordered__semiring__1__strict,type,
    linord715952674999750819strict: 
      !>[A: $tType] : $o ).

thf(sy_cl_Archimedean__Field_Oarchimedean__field,type,
    archim462609752435547400_field: 
      !>[A: $tType] : $o ).

thf(sy_cl_Complete__Lattices_Ocomplete__linorder,type,
    comple5582772986160207858norder: 
      !>[A: $tType] : $o ).

thf(sy_cl_Real__Vector__Spaces_Oreal__div__algebra,type,
    real_V5047593784448816457lgebra: 
      !>[A: $tType] : $o ).

thf(sy_cl_Lattices_Obounded__semilattice__inf__top,type,
    bounde4346867609351753570nf_top: 
      !>[A: $tType] : $o ).

thf(sy_cl_Lattices_Obounded__semilattice__sup__bot,type,
    bounde4967611905675639751up_bot: 
      !>[A: $tType] : $o ).

thf(sy_cl_Real__Vector__Spaces_Oreal__normed__field,type,
    real_V3459762299906320749_field: 
      !>[A: $tType] : $o ).

thf(sy_cl_Topological__Spaces_Olinorder__topology,type,
    topolo1944317154257567458pology: 
      !>[A: $tType] : $o ).

thf(sy_cl_Topological__Spaces_Otopological__space,type,
    topolo4958980785337419405_space: 
      !>[A: $tType] : $o ).

thf(sy_cl_Euclidean__Division_Oeuclidean__semiring,type,
    euclid3725896446679973847miring: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Ocanonically__ordered__monoid__add,type,
    canoni5634975068530333245id_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Oordered__cancel__comm__monoid__add,type,
    ordere8940638589300402666id_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Ostrict__ordered__comm__monoid__add,type,
    strict7427464778891057005id_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Real__Vector__Spaces_Oreal__normed__vector,type,
    real_V822414075346904944vector: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Olinordered__comm__semiring__strict,type,
    linord2810124833399127020strict: 
      !>[A: $tType] : $o ).

thf(sy_cl_Bit__Operations_Osemiring__bit__operations,type,
    bit_se359711467146920520ations: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Oordered__ab__semigroup__add__imp__le,type,
    ordere2412721322843649153imp_le: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Oordered__cancel__ab__semigroup__add,type,
    ordere580206878836729694up_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Oordered__cancel__comm__monoid__diff,type,
    ordere1170586879665033532d_diff: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Ostrict__ordered__ab__semigroup__add,type,
    strict9044650504122735259up_add: 
      !>[A: $tType] : $o ).

thf(sy_cl_Real__Vector__Spaces_Oordered__real__vector,type,
    real_V5355595471888546746vector: 
      !>[A: $tType] : $o ).

thf(sy_cl_Real__Vector__Spaces_Oreal__normed__algebra,type,
    real_V4412858255891104859lgebra: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Osemiring__no__zero__divisors__cancel,type,
    semiri6575147826004484403cancel: 
      !>[A: $tType] : $o ).

thf(sy_cl_Euclidean__Division_Oeuclidean__ring__cancel,type,
    euclid8851590272496341667cancel: 
      !>[A: $tType] : $o ).

thf(sy_cl_Real__Vector__Spaces_Oreal__normed__algebra__1,type,
    real_V2822296259951069270ebra_1: 
      !>[A: $tType] : $o ).

thf(sy_cl_Divides_Ounique__euclidean__semiring__numeral,type,
    unique1627219031080169319umeral: 
      !>[A: $tType] : $o ).

thf(sy_cl_Complete__Lattices_Ocomplete__distrib__lattice,type,
    comple592849572758109894attice: 
      !>[A: $tType] : $o ).

thf(sy_cl_Real__Vector__Spaces_Oreal__normed__div__algebra,type,
    real_V8999393235501362500lgebra: 
      !>[A: $tType] : $o ).

thf(sy_cl_Rings_Onormalization__semidom__multiplicative,type,
    normal6328177297339901930cative: 
      !>[A: $tType] : $o ).

thf(sy_cl_Topological__Spaces_Ofirst__countable__topology,type,
    topolo3112930676232923870pology: 
      !>[A: $tType] : $o ).

thf(sy_cl_Euclidean__Division_Oeuclidean__semiring__cancel,type,
    euclid4440199948858584721cancel: 
      !>[A: $tType] : $o ).

thf(sy_cl_Euclidean__Division_Ounique__euclidean__semiring,type,
    euclid3128863361964157862miring: 
      !>[A: $tType] : $o ).

thf(sy_cl_Topological__Spaces_Olinear__continuum__topology,type,
    topolo8458572112393995274pology: 
      !>[A: $tType] : $o ).

thf(sy_cl_Groups_Oordered__ab__semigroup__monoid__add__imp__le,type,
    ordere1937475149494474687imp_le: 
      !>[A: $tType] : $o ).

thf(sy_cl_Conditionally__Complete__Lattices_Olinear__continuum,type,
    condit5016429287641298734tinuum: 
      !>[A: $tType] : $o ).

thf(sy_cl_Euclidean__Division_Ounique__euclidean__ring__with__nat,type,
    euclid8789492081693882211th_nat: 
      !>[A: $tType] : $o ).

thf(sy_cl_Euclidean__Division_Ounique__euclidean__semiring__with__nat,type,
    euclid5411537665997757685th_nat: 
      !>[A: $tType] : $o ).

thf(sy_cl_Countable__Complete__Lattices_Ocountable__complete__lattice,type,
    counta3822494911875563373attice: 
      !>[A: $tType] : $o ).

thf(sy_cl_Semiring__Normalization_Ocomm__semiring__1__cancel__crossproduct,type,
    semiri1453513574482234551roduct: 
      !>[A: $tType] : $o ).

thf(sy_cl_Bit__Operations_Ounique__euclidean__semiring__with__bit__operations,type,
    bit_un5681908812861735899ations: 
      !>[A: $tType] : $o ).

thf(sy_cl_Conditionally__Complete__Lattices_Oconditionally__complete__lattice,type,
    condit1219197933456340205attice: 
      !>[A: $tType] : $o ).

thf(sy_cl_Countable__Complete__Lattices_Ocountable__complete__distrib__lattice,type,
    counta4013691401010221786attice: 
      !>[A: $tType] : $o ).

thf(sy_cl_Conditionally__Complete__Lattices_Oconditionally__complete__linorder,type,
    condit6923001295902523014norder: 
      !>[A: $tType] : $o ).

thf(sy_c_Archimedean__Field_Oceiling,type,
    archimedean_ceiling: 
      !>[A: $tType] : ( A > int ) ).

thf(sy_c_Archimedean__Field_Ofloor__ceiling__class_Ofloor,type,
    archim6421214686448440834_floor: 
      !>[A: $tType] : ( A > int ) ).

thf(sy_c_Archimedean__Field_Ofrac,type,
    archimedean_frac: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Archimedean__Field_Oround,type,
    archimedean_round: 
      !>[A: $tType] : ( A > int ) ).

thf(sy_c_BNF__Cardinal__Order__Relation_OnatLeq,type,
    bNF_Ca8665028551170535155natLeq: set @ ( product_prod @ nat @ nat ) ).

thf(sy_c_BNF__Cardinal__Order__Relation_OnatLess,type,
    bNF_Ca8459412986667044542atLess: set @ ( product_prod @ nat @ nat ) ).

thf(sy_c_BNF__Cardinal__Order__Relation_OrelChain,type,
    bNF_Ca3754400796208372196lChain: 
      !>[A: $tType,B: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > ( A > B ) > $o ) ).

thf(sy_c_BNF__Def_Orel__fun,type,
    bNF_rel_fun: 
      !>[A: $tType,C: $tType,B: $tType,D: $tType] : ( ( A > C > $o ) > ( B > D > $o ) > ( A > B ) > ( C > D ) > $o ) ).

thf(sy_c_BNF__Wellorder__Relation_Owo__rel,type,
    bNF_Wellorder_wo_rel: 
      !>[A: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > $o ) ).

thf(sy_c_Basic__BNF__LFPs_Oprod_Osize__prod,type,
    basic_BNF_size_prod: 
      !>[A: $tType,B: $tType] : ( ( A > nat ) > ( B > nat ) > ( product_prod @ A @ B ) > nat ) ).

thf(sy_c_Binomial_Obinomial,type,
    binomial: nat > nat > nat ).

thf(sy_c_Binomial_Ogbinomial,type,
    gbinomial: 
      !>[A: $tType] : ( A > nat > A ) ).

thf(sy_c_Bit__Operations_Oand__int__rel,type,
    bit_and_int_rel: ( product_prod @ int @ int ) > ( product_prod @ int @ int ) > $o ).

thf(sy_c_Bit__Operations_Oand__not__num,type,
    bit_and_not_num: num > num > ( option @ num ) ).

thf(sy_c_Bit__Operations_Oand__not__num__rel,type,
    bit_and_not_num_rel: ( product_prod @ num @ num ) > ( product_prod @ num @ num ) > $o ).

thf(sy_c_Bit__Operations_Oconcat__bit,type,
    bit_concat_bit: nat > int > int > int ).

thf(sy_c_Bit__Operations_Oor__not__num__neg,type,
    bit_or_not_num_neg: num > num > num ).

thf(sy_c_Bit__Operations_Oor__not__num__neg__rel,type,
    bit_or3848514188828904588eg_rel: ( product_prod @ num @ num ) > ( product_prod @ num @ num ) > $o ).

thf(sy_c_Bit__Operations_Oring__bit__operations__class_Onot,type,
    bit_ri4277139882892585799ns_not: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Bit__Operations_Oring__bit__operations__class_Osigned__take__bit,type,
    bit_ri4674362597316999326ke_bit: 
      !>[A: $tType] : ( nat > A > A ) ).

thf(sy_c_Bit__Operations_Osemiring__bit__operations__class_Oand,type,
    bit_se5824344872417868541ns_and: 
      !>[A: $tType] : ( A > A > A ) ).

thf(sy_c_Bit__Operations_Osemiring__bit__operations__class_Odrop__bit,type,
    bit_se4197421643247451524op_bit: 
      !>[A: $tType] : ( nat > A > A ) ).

thf(sy_c_Bit__Operations_Osemiring__bit__operations__class_Oflip__bit,type,
    bit_se8732182000553998342ip_bit: 
      !>[A: $tType] : ( nat > A > A ) ).

thf(sy_c_Bit__Operations_Osemiring__bit__operations__class_Omask,type,
    bit_se2239418461657761734s_mask: 
      !>[A: $tType] : ( nat > A ) ).

thf(sy_c_Bit__Operations_Osemiring__bit__operations__class_Oor,type,
    bit_se1065995026697491101ons_or: 
      !>[A: $tType] : ( A > A > A ) ).

thf(sy_c_Bit__Operations_Osemiring__bit__operations__class_Opush__bit,type,
    bit_se4730199178511100633sh_bit: 
      !>[A: $tType] : ( nat > A > A ) ).

thf(sy_c_Bit__Operations_Osemiring__bit__operations__class_Oset__bit,type,
    bit_se5668285175392031749et_bit: 
      !>[A: $tType] : ( nat > A > A ) ).

thf(sy_c_Bit__Operations_Osemiring__bit__operations__class_Otake__bit,type,
    bit_se2584673776208193580ke_bit: 
      !>[A: $tType] : ( nat > A > A ) ).

thf(sy_c_Bit__Operations_Osemiring__bit__operations__class_Ounset__bit,type,
    bit_se2638667681897837118et_bit: 
      !>[A: $tType] : ( nat > A > A ) ).

thf(sy_c_Bit__Operations_Osemiring__bit__operations__class_Oxor,type,
    bit_se5824344971392196577ns_xor: 
      !>[A: $tType] : ( A > A > A ) ).

thf(sy_c_Bit__Operations_Osemiring__bits__class_Obit,type,
    bit_se5641148757651400278ts_bit: 
      !>[A: $tType] : ( A > nat > $o ) ).

thf(sy_c_Bit__Operations_Osemiring__bits__class_Opossible__bit,type,
    bit_se6407376104438227557le_bit: 
      !>[A: $tType] : ( ( itself @ A ) > nat > $o ) ).

thf(sy_c_Bit__Operations_Otake__bit__num,type,
    bit_take_bit_num: nat > num > ( option @ num ) ).

thf(sy_c_Bit__Operations_Ounique__euclidean__semiring__with__bit__operations_Oand__num,type,
    bit_un1837492267222099188nd_num: num > num > ( option @ num ) ).

thf(sy_c_Bit__Operations_Ounique__euclidean__semiring__with__bit__operations_Oand__num__rel,type,
    bit_un5425074673868309765um_rel: ( product_prod @ num @ num ) > ( product_prod @ num @ num ) > $o ).

thf(sy_c_Bit__Operations_Ounique__euclidean__semiring__with__bit__operations_Oor__num,type,
    bit_un2785000775030745342or_num: num > num > num ).

thf(sy_c_Bit__Operations_Ounique__euclidean__semiring__with__bit__operations_Oor__num__rel,type,
    bit_un6909899581280750971um_rel: ( product_prod @ num @ num ) > ( product_prod @ num @ num ) > $o ).

thf(sy_c_Bit__Operations_Ounique__euclidean__semiring__with__bit__operations_Oxor__num,type,
    bit_un6178654185764691216or_num: num > num > ( option @ num ) ).

thf(sy_c_Bit__Operations_Ounique__euclidean__semiring__with__bit__operations_Oxor__num__rel,type,
    bit_un3595099601533988841um_rel: ( product_prod @ num @ num ) > ( product_prod @ num @ num ) > $o ).

thf(sy_c_Bit__Operations_Ounique__euclidean__semiring__with__bit__operations__class_Oand__num,type,
    bit_un7362597486090784418nd_num: num > num > ( option @ num ) ).

thf(sy_c_Bit__Operations_Ounique__euclidean__semiring__with__bit__operations__class_Oand__num__rel,type,
    bit_un4731106466462545111um_rel: ( product_prod @ num @ num ) > ( product_prod @ num @ num ) > $o ).

thf(sy_c_Bit__Operations_Ounique__euclidean__semiring__with__bit__operations__class_Oor__num,type,
    bit_un6697907153464112080or_num: num > num > num ).

thf(sy_c_Bit__Operations_Ounique__euclidean__semiring__with__bit__operations__class_Oor__num__rel,type,
    bit_un4773296044027857193um_rel: ( product_prod @ num @ num ) > ( product_prod @ num @ num ) > $o ).

thf(sy_c_Bit__Operations_Ounique__euclidean__semiring__with__bit__operations__class_Oxor__num,type,
    bit_un2480387367778600638or_num: num > num > ( option @ num ) ).

thf(sy_c_Bit__Operations_Ounique__euclidean__semiring__with__bit__operations__class_Oxor__num__rel,type,
    bit_un2901131394128224187um_rel: ( product_prod @ num @ num ) > ( product_prod @ num @ num ) > $o ).

thf(sy_c_Boolean__Algebras_Oabstract__boolean__algebra,type,
    boolea2506097494486148201lgebra: 
      !>[A: $tType] : ( ( A > A > A ) > ( A > A > A ) > ( A > A ) > A > A > $o ) ).

thf(sy_c_Boolean__Algebras_Oabstract__boolean__algebra__sym__diff,type,
    boolea3799213064322606851m_diff: 
      !>[A: $tType] : ( ( A > A > A ) > ( A > A > A ) > ( A > A ) > A > A > ( A > A > A ) > $o ) ).

thf(sy_c_Code__Numeral_ONeg,type,
    code_Neg: num > code_integer ).

thf(sy_c_Code__Numeral_OPos,type,
    code_Pos: num > code_integer ).

thf(sy_c_Code__Numeral_Obit__cut__integer,type,
    code_bit_cut_integer: code_integer > ( product_prod @ code_integer @ $o ) ).

thf(sy_c_Code__Numeral_Odivmod__abs,type,
    code_divmod_abs: code_integer > code_integer > ( product_prod @ code_integer @ code_integer ) ).

thf(sy_c_Code__Numeral_Odivmod__integer,type,
    code_divmod_integer: code_integer > code_integer > ( product_prod @ code_integer @ code_integer ) ).

thf(sy_c_Code__Numeral_Odup,type,
    code_dup: code_integer > code_integer ).

thf(sy_c_Code__Numeral_Ointeger_Oint__of__integer,type,
    code_int_of_integer: code_integer > int ).

thf(sy_c_Code__Numeral_Ointeger_Ointeger__of__int,type,
    code_integer_of_int: int > code_integer ).

thf(sy_c_Code__Numeral_Ointeger__of__nat,type,
    code_integer_of_nat: nat > code_integer ).

thf(sy_c_Code__Numeral_Ointeger__of__natural,type,
    code_i5400310926305786745atural: code_natural > code_integer ).

thf(sy_c_Code__Numeral_Ointeger__of__num,type,
    code_integer_of_num: num > code_integer ).

thf(sy_c_Code__Numeral_Onat__of__integer,type,
    code_nat_of_integer: code_integer > nat ).

thf(sy_c_Code__Numeral_Onatural_Ocase__natural,type,
    code_case_natural: 
      !>[T: $tType] : ( T > ( code_natural > T ) > code_natural > T ) ).

thf(sy_c_Code__Numeral_Onatural_Onat__of__natural,type,
    code_nat_of_natural: code_natural > nat ).

thf(sy_c_Code__Numeral_Onatural_Onatural__of__nat,type,
    code_natural_of_nat: nat > code_natural ).

thf(sy_c_Code__Numeral_Onatural_Orec__natural,type,
    code_rec_natural: 
      !>[T: $tType] : ( T > ( code_natural > T > T ) > code_natural > T ) ).

thf(sy_c_Code__Numeral_Onatural__of__integer,type,
    code_n4118661773612635043nteger: code_integer > code_natural ).

thf(sy_c_Code__Numeral_Onum__of__integer,type,
    code_num_of_integer: code_integer > num ).

thf(sy_c_Code__Numeral_Opcr__integer,type,
    code_pcr_integer: int > code_integer > $o ).

thf(sy_c_Code__Numeral_Opcr__natural,type,
    code_pcr_natural: nat > code_natural > $o ).

thf(sy_c_Code__Numeral_Osub,type,
    code_sub: num > num > code_integer ).

thf(sy_c_Code__Target__Int_Onegative,type,
    code_Target_negative: num > int ).

thf(sy_c_Code__Target__Int_Opositive,type,
    code_Target_positive: num > int ).

thf(sy_c_Code__Target__Nat_Oint__of__nat,type,
    code_T6385005292777649522of_nat: nat > int ).

thf(sy_c_Complete__Lattices_OInf__class_OInf,type,
    complete_Inf_Inf: 
      !>[A: $tType] : ( ( set @ A ) > A ) ).

thf(sy_c_Complete__Lattices_OSup__class_OSup,type,
    complete_Sup_Sup: 
      !>[A: $tType] : ( ( set @ A ) > A ) ).

thf(sy_c_Complete__Partial__Order_Occpo_Oadmissible,type,
    comple1908693960933563346ssible: 
      !>[A: $tType] : ( ( ( set @ A ) > A ) > ( A > A > $o ) > ( A > $o ) > $o ) ).

thf(sy_c_Complete__Partial__Order_Occpo__class_Ofixp,type,
    comple115746919287870866o_fixp: 
      !>[A: $tType] : ( ( A > A ) > A ) ).

thf(sy_c_Complete__Partial__Order_Occpo__class_Oiterates,type,
    comple6359979572994053840erates: 
      !>[A: $tType] : ( ( A > A ) > ( set @ A ) ) ).

thf(sy_c_Complete__Partial__Order_Occpo__class_Oiteratesp,type,
    comple7512665784863727008ratesp: 
      !>[A: $tType] : ( ( A > A ) > A > $o ) ).

thf(sy_c_Complete__Partial__Order_Ochain,type,
    comple1602240252501008431_chain: 
      !>[A: $tType] : ( ( A > A > $o ) > ( set @ A ) > $o ) ).

thf(sy_c_Complete__Partial__Order_Omonotone,type,
    comple7038119648293358887notone: 
      !>[A: $tType,B: $tType] : ( ( A > A > $o ) > ( B > B > $o ) > ( A > B ) > $o ) ).

thf(sy_c_Complex_OArg,type,
    arg: complex > real ).

thf(sy_c_Complex_Ocis,type,
    cis: real > complex ).

thf(sy_c_Complex_Ocnj,type,
    cnj: complex > complex ).

thf(sy_c_Complex_Ocomplex_OComplex,type,
    complex2: real > real > complex ).

thf(sy_c_Complex_Ocomplex_OIm,type,
    im: complex > real ).

thf(sy_c_Complex_Ocomplex_ORe,type,
    re: complex > real ).

thf(sy_c_Complex_Ocsqrt,type,
    csqrt: complex > complex ).

thf(sy_c_Complex_Oimaginary__unit,type,
    imaginary_unit: complex ).

thf(sy_c_Complex_Orcis,type,
    rcis: real > real > complex ).

thf(sy_c_Conditionally__Complete__Lattices_Opreorder__class_Obdd__above,type,
    condit941137186595557371_above: 
      !>[A: $tType] : ( ( set @ A ) > $o ) ).

thf(sy_c_Conditionally__Complete__Lattices_Opreorder__class_Obdd__below,type,
    condit1013018076250108175_below: 
      !>[A: $tType] : ( ( set @ A ) > $o ) ).

thf(sy_c_Conditionally__Complete__Lattices_Opreordering__bdd,type,
    condit622319405099724424ng_bdd: 
      !>[A: $tType] : ( ( A > A > $o ) > ( A > A > $o ) > $o ) ).

thf(sy_c_Conditionally__Complete__Lattices_Opreordering__bdd_Obdd,type,
    condit16957441358409770ng_bdd: 
      !>[A: $tType] : ( ( A > A > $o ) > ( set @ A ) > $o ) ).

thf(sy_c_Countable__Set_Ocountable,type,
    countable_countable: 
      !>[A: $tType] : ( ( set @ A ) > $o ) ).

thf(sy_c_Deriv_Odifferentiable,type,
    differentiable: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > ( filter @ A ) > $o ) ).

thf(sy_c_Deriv_Ohas__derivative,type,
    has_derivative: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > ( A > B ) > ( filter @ A ) > $o ) ).

thf(sy_c_Deriv_Ohas__field__derivative,type,
    has_field_derivative: 
      !>[A: $tType] : ( ( A > A ) > A > ( filter @ A ) > $o ) ).

thf(sy_c_Divides_Oadjust__div,type,
    adjust_div: ( product_prod @ int @ int ) > int ).

thf(sy_c_Divides_Oadjust__mod,type,
    adjust_mod: int > int > int ).

thf(sy_c_Divides_Odivmod__nat,type,
    divmod_nat: nat > nat > ( product_prod @ nat @ nat ) ).

thf(sy_c_Divides_Oeucl__rel__int,type,
    eucl_rel_int: int > int > ( product_prod @ int @ int ) > $o ).

thf(sy_c_Divides_Ounique__euclidean__semiring__numeral__class_Odivides__aux,type,
    unique5940410009612947441es_aux: 
      !>[A: $tType] : ( ( product_prod @ A @ A ) > $o ) ).

thf(sy_c_Divides_Ounique__euclidean__semiring__numeral__class_Odivmod,type,
    unique8689654367752047608divmod: 
      !>[A: $tType] : ( num > num > ( product_prod @ A @ A ) ) ).

thf(sy_c_Divides_Ounique__euclidean__semiring__numeral__class_Odivmod__step,type,
    unique1321980374590559556d_step: 
      !>[A: $tType] : ( num > ( product_prod @ A @ A ) > ( product_prod @ A @ A ) ) ).

thf(sy_c_Euclidean__Division_Oeuclidean__semiring__class_Oeuclidean__size,type,
    euclid6346220572633701492n_size: 
      !>[A: $tType] : ( A > nat ) ).

thf(sy_c_Euclidean__Division_Ounique__euclidean__semiring__class_Odivision__segment,type,
    euclid7384307370059645450egment: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Extended__Nat_OeSuc,type,
    extended_eSuc: extended_enat > extended_enat ).

thf(sy_c_Extended__Nat_Oenat,type,
    extended_enat2: nat > extended_enat ).

thf(sy_c_Extended__Nat_Oenat_Ocase__enat,type,
    extended_case_enat: 
      !>[T: $tType] : ( ( nat > T ) > T > extended_enat > T ) ).

thf(sy_c_Extended__Nat_Oenat_Orec__enat,type,
    extended_rec_enat: 
      !>[T: $tType] : ( ( nat > T ) > T > extended_enat > T ) ).

thf(sy_c_Extended__Nat_Oenat_Orec__set__enat,type,
    extend4933016492236175606t_enat: 
      !>[T: $tType] : ( ( nat > T ) > T > extended_enat > T > $o ) ).

thf(sy_c_Extended__Nat_Oinfinity__class_Oinfinity,type,
    extend4730790105801354508finity: 
      !>[A: $tType] : A ).

thf(sy_c_Extended__Nat_Othe__enat,type,
    extended_the_enat: extended_enat > nat ).

thf(sy_c_Factorial_Ocomm__semiring__1__class_Opochhammer,type,
    comm_s3205402744901411588hammer: 
      !>[A: $tType] : ( A > nat > A ) ).

thf(sy_c_Factorial_Osemiring__char__0__class_Ofact,type,
    semiring_char_0_fact: 
      !>[A: $tType] : ( nat > A ) ).

thf(sy_c_Fields_Oinverse__class_Oinverse,type,
    inverse_inverse: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Filter_Oabstract__filter,type,
    abstract_filter: 
      !>[A: $tType] : ( ( product_unit > ( filter @ A ) ) > ( filter @ A ) ) ).

thf(sy_c_Filter_Oat__bot,type,
    at_bot: 
      !>[A: $tType] : ( filter @ A ) ).

thf(sy_c_Filter_Oat__top,type,
    at_top: 
      !>[A: $tType] : ( filter @ A ) ).

thf(sy_c_Filter_Oeventually,type,
    eventually: 
      !>[A: $tType] : ( ( A > $o ) > ( filter @ A ) > $o ) ).

thf(sy_c_Filter_Ofiltercomap,type,
    filtercomap: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > ( filter @ B ) > ( filter @ A ) ) ).

thf(sy_c_Filter_Ofilterlim,type,
    filterlim: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > ( filter @ B ) > ( filter @ A ) > $o ) ).

thf(sy_c_Filter_Ofiltermap,type,
    filtermap: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > ( filter @ A ) > ( filter @ B ) ) ).

thf(sy_c_Filter_Ofrequently,type,
    frequently: 
      !>[A: $tType] : ( ( A > $o ) > ( filter @ A ) > $o ) ).

thf(sy_c_Filter_Oprincipal,type,
    principal: 
      !>[A: $tType] : ( ( set @ A ) > ( filter @ A ) ) ).

thf(sy_c_Filter_Oprod__filter,type,
    prod_filter: 
      !>[A: $tType,B: $tType] : ( ( filter @ A ) > ( filter @ B ) > ( filter @ ( product_prod @ A @ B ) ) ) ).

thf(sy_c_Finite__Set_Ocard,type,
    finite_card: 
      !>[B: $tType] : ( ( set @ B ) > nat ) ).

thf(sy_c_Finite__Set_Ofinite,type,
    finite_finite: 
      !>[A: $tType] : ( ( set @ A ) > $o ) ).

thf(sy_c_Finite__Set_Ofold,type,
    finite_fold: 
      !>[A: $tType,B: $tType] : ( ( A > B > B ) > B > ( set @ A ) > B ) ).

thf(sy_c_Finite__Set_Ofolding__on_OF,type,
    finite_folding_F: 
      !>[A: $tType,B: $tType] : ( ( A > B > B ) > B > ( set @ A ) > B ) ).

thf(sy_c_Fun_Obij__betw,type,
    bij_betw: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > ( set @ A ) > ( set @ B ) > $o ) ).

thf(sy_c_Fun_Ocomp,type,
    comp: 
      !>[B: $tType,C: $tType,A: $tType] : ( ( B > C ) > ( A > B ) > A > C ) ).

thf(sy_c_Fun_Ofun__upd,type,
    fun_upd: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > A > B > A > B ) ).

thf(sy_c_Fun_Oid,type,
    id: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Fun_Oinj__on,type,
    inj_on: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > ( set @ A ) > $o ) ).

thf(sy_c_Fun_Omap__fun,type,
    map_fun: 
      !>[C: $tType,A: $tType,B: $tType,D: $tType] : ( ( C > A ) > ( B > D ) > ( A > B ) > C > D ) ).

thf(sy_c_Fun_Ostrict__mono__on,type,
    strict_mono_on: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > ( set @ A ) > $o ) ).

thf(sy_c_Fun_Othe__inv__into,type,
    the_inv_into: 
      !>[A: $tType,B: $tType] : ( ( set @ A ) > ( A > B ) > B > A ) ).

thf(sy_c_Fun__Def_Ois__measure,type,
    fun_is_measure: 
      !>[A: $tType] : ( ( A > nat ) > $o ) ).

thf(sy_c_Fun__Def_Omax__strict,type,
    fun_max_strict: set @ ( product_prod @ ( set @ ( product_prod @ nat @ nat ) ) @ ( set @ ( product_prod @ nat @ nat ) ) ) ).

thf(sy_c_Fun__Def_Omax__weak,type,
    fun_max_weak: set @ ( product_prod @ ( set @ ( product_prod @ nat @ nat ) ) @ ( set @ ( product_prod @ nat @ nat ) ) ) ).

thf(sy_c_Fun__Def_Omin__strict,type,
    fun_min_strict: set @ ( product_prod @ ( set @ ( product_prod @ nat @ nat ) ) @ ( set @ ( product_prod @ nat @ nat ) ) ) ).

thf(sy_c_Fun__Def_Omin__weak,type,
    fun_min_weak: set @ ( product_prod @ ( set @ ( product_prod @ nat @ nat ) ) @ ( set @ ( product_prod @ nat @ nat ) ) ) ).

thf(sy_c_Fun__Def_Opair__leq,type,
    fun_pair_leq: set @ ( product_prod @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) ) ).

thf(sy_c_Fun__Def_Opair__less,type,
    fun_pair_less: set @ ( product_prod @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) ) ).

thf(sy_c_Fun__Def_Oreduction__pair,type,
    fun_reduction_pair: 
      !>[A: $tType] : ( ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ A @ A ) ) ) > $o ) ).

thf(sy_c_Fun__Def_Orp__inv__image,type,
    fun_rp_inv_image: 
      !>[A: $tType,B: $tType] : ( ( product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ A @ A ) ) ) > ( B > A ) > ( product_prod @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ B @ B ) ) ) ) ).

thf(sy_c_GCD_OGcd__class_OGcd,type,
    gcd_Gcd: 
      !>[A: $tType] : ( ( set @ A ) > A ) ).

thf(sy_c_GCD_OGcd__class_OLcm,type,
    gcd_Lcm: 
      !>[A: $tType] : ( ( set @ A ) > A ) ).

thf(sy_c_GCD_Obezw,type,
    bezw: nat > nat > ( product_prod @ int @ int ) ).

thf(sy_c_GCD_Obezw__rel,type,
    bezw_rel: ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) > $o ).

thf(sy_c_GCD_Obounded__quasi__semilattice,type,
    bounde8507323023520639062attice: 
      !>[A: $tType] : ( ( A > A > A ) > A > A > ( A > A ) > $o ) ).

thf(sy_c_GCD_Obounded__quasi__semilattice__set,type,
    bounde6485984586167503788ce_set: 
      !>[A: $tType] : ( ( A > A > A ) > A > A > ( A > A ) > $o ) ).

thf(sy_c_GCD_Obounded__quasi__semilattice__set_OF,type,
    bounde2362111253966948842tice_F: 
      !>[A: $tType] : ( ( A > A > A ) > A > A > ( set @ A ) > A ) ).

thf(sy_c_GCD_Ogcd__class_Ogcd,type,
    gcd_gcd: 
      !>[A: $tType] : ( A > A > A ) ).

thf(sy_c_GCD_Ogcd__class_Olcm,type,
    gcd_lcm: 
      !>[A: $tType] : ( A > A > A ) ).

thf(sy_c_GCD_Ogcd__nat__rel,type,
    gcd_nat_rel: ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) > $o ).

thf(sy_c_GCD_Osemiring__1__class_Osemiring__char,type,
    semiri4206861660011772517g_char: 
      !>[A: $tType] : ( ( itself @ A ) > nat ) ).

thf(sy_c_GCD_Osemiring__gcd__class_OGcd__fin,type,
    semiring_gcd_Gcd_fin: 
      !>[A: $tType] : ( ( set @ A ) > A ) ).

thf(sy_c_GCD_Osemiring__gcd__class_OLcm__fin,type,
    semiring_gcd_Lcm_fin: 
      !>[A: $tType] : ( ( set @ A ) > A ) ).

thf(sy_c_Groups_Oabs__class_Oabs,type,
    abs_abs: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Groups_Ocomm__monoid,type,
    comm_monoid: 
      !>[A: $tType] : ( ( A > A > A ) > A > $o ) ).

thf(sy_c_Groups_Ogroup,type,
    group: 
      !>[A: $tType] : ( ( A > A > A ) > A > ( A > A ) > $o ) ).

thf(sy_c_Groups_Ogroup__axioms,type,
    group_axioms: 
      !>[A: $tType] : ( ( A > A > A ) > A > ( A > A ) > $o ) ).

thf(sy_c_Groups_Ominus__class_Ominus,type,
    minus_minus: 
      !>[A: $tType] : ( A > A > A ) ).

thf(sy_c_Groups_Omonoid,type,
    monoid: 
      !>[A: $tType] : ( ( A > A > A ) > A > $o ) ).

thf(sy_c_Groups_Omonoid__axioms,type,
    monoid_axioms: 
      !>[A: $tType] : ( ( A > A > A ) > A > $o ) ).

thf(sy_c_Groups_Oone__class_Oone,type,
    one_one: 
      !>[A: $tType] : A ).

thf(sy_c_Groups_Oplus__class_Oplus,type,
    plus_plus: 
      !>[A: $tType] : ( A > A > A ) ).

thf(sy_c_Groups_Osemigroup,type,
    semigroup: 
      !>[A: $tType] : ( ( A > A > A ) > $o ) ).

thf(sy_c_Groups_Osgn__class_Osgn,type,
    sgn_sgn: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Groups_Otimes__class_Otimes,type,
    times_times: 
      !>[A: $tType] : ( A > A > A ) ).

thf(sy_c_Groups_Ouminus__class_Ouminus,type,
    uminus_uminus: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Groups_Ozero__class_Ozero,type,
    zero_zero: 
      !>[A: $tType] : A ).

thf(sy_c_Groups__Big_Ocomm__monoid__add__class_Osum,type,
    groups7311177749621191930dd_sum: 
      !>[B: $tType,A: $tType] : ( ( B > A ) > ( set @ B ) > A ) ).

thf(sy_c_Groups__Big_Ocomm__monoid__add__class_Osum_H,type,
    groups1027152243600224163dd_sum: 
      !>[C: $tType,A: $tType] : ( ( C > A ) > ( set @ C ) > A ) ).

thf(sy_c_Groups__Big_Ocomm__monoid__mult__class_Oprod,type,
    groups7121269368397514597t_prod: 
      !>[B: $tType,A: $tType] : ( ( B > A ) > ( set @ B ) > A ) ).

thf(sy_c_Groups__Big_Ocomm__monoid__set_OG,type,
    groups_comm_monoid_G: 
      !>[A: $tType,B: $tType] : ( ( A > A > A ) > A > ( B > A ) > ( set @ B ) > A ) ).

thf(sy_c_Groups__List_Ocomm__monoid__list,type,
    groups1828464146339083142d_list: 
      !>[A: $tType] : ( ( A > A > A ) > A > $o ) ).

thf(sy_c_Groups__List_Ocomm__monoid__list__set,type,
    groups4802862169904069756st_set: 
      !>[A: $tType] : ( ( A > A > A ) > A > $o ) ).

thf(sy_c_Groups__List_Ocomm__semiring__0__class_Ohorner__sum,type,
    groups4207007520872428315er_sum: 
      !>[B: $tType,A: $tType] : ( ( B > A ) > A > ( list @ B ) > A ) ).

thf(sy_c_Groups__List_Omonoid__add__class_Osum__list,type,
    groups8242544230860333062m_list: 
      !>[A: $tType] : ( ( list @ A ) > A ) ).

thf(sy_c_Groups__List_Omonoid__list_OF,type,
    groups_monoid_F: 
      !>[A: $tType] : ( ( A > A > A ) > A > ( list @ A ) > A ) ).

thf(sy_c_HOL_ONO__MATCH,type,
    nO_MATCH: 
      !>[A: $tType,B: $tType] : ( A > B > $o ) ).

thf(sy_c_HOL_OThe,type,
    the: 
      !>[A: $tType] : ( ( A > $o ) > A ) ).

thf(sy_c_HOL_OUniq,type,
    uniq: 
      !>[A: $tType] : ( ( A > $o ) > $o ) ).

thf(sy_c_HOL_Oundefined,type,
    undefined: 
      !>[A: $tType] : A ).

thf(sy_c_If,type,
    if: 
      !>[A: $tType] : ( $o > A > A > A ) ).

thf(sy_c_Inductive_Ocomplete__lattice__class_Ogfp,type,
    complete_lattice_gfp: 
      !>[A: $tType] : ( ( A > A ) > A ) ).

thf(sy_c_Inductive_Ocomplete__lattice__class_Olfp,type,
    complete_lattice_lfp: 
      !>[A: $tType] : ( ( A > A ) > A ) ).

thf(sy_c_Infinite__Set_Owellorder__class_Oenumerate,type,
    infini527867602293511546merate: 
      !>[A: $tType] : ( ( set @ A ) > nat > A ) ).

thf(sy_c_Int_OAbs__Integ,type,
    abs_Integ: ( product_prod @ nat @ nat ) > int ).

thf(sy_c_Int_ONeg,type,
    neg: num > int ).

thf(sy_c_Int_OPos,type,
    pos: num > int ).

thf(sy_c_Int_ORep__Integ,type,
    rep_Integ: int > ( product_prod @ nat @ nat ) ).

thf(sy_c_Int_Ocr__int,type,
    cr_int: ( product_prod @ nat @ nat ) > int > $o ).

thf(sy_c_Int_Odup,type,
    dup: int > int ).

thf(sy_c_Int_Oint__ge__less__than,type,
    int_ge_less_than: int > ( set @ ( product_prod @ int @ int ) ) ).

thf(sy_c_Int_Oint__ge__less__than2,type,
    int_ge_less_than2: int > ( set @ ( product_prod @ int @ int ) ) ).

thf(sy_c_Int_Ointrel,type,
    intrel: ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) > $o ).

thf(sy_c_Int_Onat,type,
    nat2: int > nat ).

thf(sy_c_Int_Opcr__int,type,
    pcr_int: ( product_prod @ nat @ nat ) > int > $o ).

thf(sy_c_Int_Opower__int,type,
    power_int: 
      !>[A: $tType] : ( A > int > A ) ).

thf(sy_c_Int_Oring__1__class_OInts,type,
    ring_1_Ints: 
      !>[A: $tType] : ( set @ A ) ).

thf(sy_c_Int_Oring__1__class_Oof__int,type,
    ring_1_of_int: 
      !>[A: $tType] : ( int > A ) ).

thf(sy_c_Int_Osub,type,
    sub: num > num > int ).

thf(sy_c_Lattices_Oinf__class_Oinf,type,
    inf_inf: 
      !>[A: $tType] : ( A > A > A ) ).

thf(sy_c_Lattices_Osemilattice__neutr,type,
    semilattice_neutr: 
      !>[A: $tType] : ( ( A > A > A ) > A > $o ) ).

thf(sy_c_Lattices_Osemilattice__neutr__order,type,
    semila1105856199041335345_order: 
      !>[A: $tType] : ( ( A > A > A ) > A > ( A > A > $o ) > ( A > A > $o ) > $o ) ).

thf(sy_c_Lattices_Osemilattice__order,type,
    semilattice_order: 
      !>[A: $tType] : ( ( A > A > A ) > ( A > A > $o ) > ( A > A > $o ) > $o ) ).

thf(sy_c_Lattices_Osup__class_Osup,type,
    sup_sup: 
      !>[A: $tType] : ( A > A > A ) ).

thf(sy_c_Lattices__Big_Olinorder_OMax,type,
    lattices_Max: 
      !>[A: $tType] : ( ( A > A > $o ) > ( set @ A ) > A ) ).

thf(sy_c_Lattices__Big_Olinorder_OMin,type,
    lattices_Min: 
      !>[A: $tType] : ( ( A > A > $o ) > ( set @ A ) > A ) ).

thf(sy_c_Lattices__Big_Olinorder__class_OMax,type,
    lattic643756798349783984er_Max: 
      !>[A: $tType] : ( ( set @ A ) > A ) ).

thf(sy_c_Lattices__Big_Olinorder__class_OMin,type,
    lattic643756798350308766er_Min: 
      !>[A: $tType] : ( ( set @ A ) > A ) ).

thf(sy_c_Lattices__Big_Oord__class_Oarg__max,type,
    lattices_ord_arg_max: 
      !>[B: $tType,A: $tType] : ( ( B > A ) > ( B > $o ) > B ) ).

thf(sy_c_Lattices__Big_Oord__class_Oarg__max__on,type,
    lattic1883929316492267755max_on: 
      !>[B: $tType,A: $tType] : ( ( B > A ) > ( set @ B ) > B ) ).

thf(sy_c_Lattices__Big_Oord__class_Oarg__min,type,
    lattices_ord_arg_min: 
      !>[B: $tType,A: $tType] : ( ( B > A ) > ( B > $o ) > B ) ).

thf(sy_c_Lattices__Big_Oord__class_Oarg__min__on,type,
    lattic7623131987881927897min_on: 
      !>[B: $tType,A: $tType] : ( ( B > A ) > ( set @ B ) > B ) ).

thf(sy_c_Lattices__Big_Oord__class_Ois__arg__max,type,
    lattic501386751176901750rg_max: 
      !>[B: $tType,A: $tType] : ( ( B > A ) > ( B > $o ) > B > $o ) ).

thf(sy_c_Lattices__Big_Oord__class_Ois__arg__min,type,
    lattic501386751177426532rg_min: 
      !>[B: $tType,A: $tType] : ( ( B > A ) > ( B > $o ) > B > $o ) ).

thf(sy_c_Lattices__Big_Osemilattice__inf__class_OInf__fin,type,
    lattic7752659483105999362nf_fin: 
      !>[A: $tType] : ( ( set @ A ) > A ) ).

thf(sy_c_Lattices__Big_Osemilattice__neutr__set,type,
    lattic5652469242046573047tr_set: 
      !>[A: $tType] : ( ( A > A > A ) > A > $o ) ).

thf(sy_c_Lattices__Big_Osemilattice__neutr__set_OF,type,
    lattic5214292709420241887eutr_F: 
      !>[A: $tType] : ( ( A > A > A ) > A > ( set @ A ) > A ) ).

thf(sy_c_Lattices__Big_Osemilattice__order__neutr__set,type,
    lattic3600114342068043075tr_set: 
      !>[A: $tType] : ( ( A > A > A ) > A > ( A > A > $o ) > ( A > A > $o ) > $o ) ).

thf(sy_c_Lattices__Big_Osemilattice__order__set,type,
    lattic4895041142388067077er_set: 
      !>[A: $tType] : ( ( A > A > A ) > ( A > A > $o ) > ( A > A > $o ) > $o ) ).

thf(sy_c_Lattices__Big_Osemilattice__set,type,
    lattic149705377957585745ce_set: 
      !>[A: $tType] : ( ( A > A > A ) > $o ) ).

thf(sy_c_Lattices__Big_Osemilattice__set_OF,type,
    lattic1715443433743089157tice_F: 
      !>[A: $tType] : ( ( A > A > A ) > ( set @ A ) > A ) ).

thf(sy_c_Lattices__Big_Osemilattice__sup__class_OSup__fin,type,
    lattic5882676163264333800up_fin: 
      !>[A: $tType] : ( ( set @ A ) > A ) ).

thf(sy_c_Lifting_OQuotient,type,
    quotient: 
      !>[A: $tType,B: $tType] : ( ( A > A > $o ) > ( A > B ) > ( B > A ) > ( A > B > $o ) > $o ) ).

thf(sy_c_Limits_OBfun,type,
    bfun: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > ( filter @ A ) > $o ) ).

thf(sy_c_Limits_OZfun,type,
    zfun: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > ( filter @ A ) > $o ) ).

thf(sy_c_Limits_Oat__infinity,type,
    at_infinity: 
      !>[A: $tType] : ( filter @ A ) ).

thf(sy_c_List_Oappend,type,
    append: 
      !>[A: $tType] : ( ( list @ A ) > ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_Oarg__min__list,type,
    arg_min_list: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > ( list @ A ) > A ) ).

thf(sy_c_List_Oarg__min__list__rel,type,
    arg_min_list_rel: 
      !>[A: $tType,B: $tType] : ( ( product_prod @ ( A > B ) @ ( list @ A ) ) > ( product_prod @ ( A > B ) @ ( list @ A ) ) > $o ) ).

thf(sy_c_List_Obutlast,type,
    butlast: 
      !>[A: $tType] : ( ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_Oconcat,type,
    concat: 
      !>[A: $tType] : ( ( list @ ( list @ A ) ) > ( list @ A ) ) ).

thf(sy_c_List_Ocount__list,type,
    count_list: 
      !>[A: $tType] : ( ( list @ A ) > A > nat ) ).

thf(sy_c_List_Odistinct,type,
    distinct: 
      !>[A: $tType] : ( ( list @ A ) > $o ) ).

thf(sy_c_List_Odrop,type,
    drop: 
      !>[A: $tType] : ( nat > ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_OdropWhile,type,
    dropWhile: 
      !>[A: $tType] : ( ( A > $o ) > ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_Oenumerate,type,
    enumerate: 
      !>[A: $tType] : ( nat > ( list @ A ) > ( list @ ( product_prod @ nat @ A ) ) ) ).

thf(sy_c_List_Ofilter,type,
    filter2: 
      !>[A: $tType] : ( ( A > $o ) > ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_Ofind,type,
    find: 
      !>[A: $tType] : ( ( A > $o ) > ( list @ A ) > ( option @ A ) ) ).

thf(sy_c_List_Ofold,type,
    fold: 
      !>[A: $tType,B: $tType] : ( ( A > B > B ) > ( list @ A ) > B > B ) ).

thf(sy_c_List_Ofolding__insort__key,type,
    folding_insort_key: 
      !>[A: $tType,B: $tType] : ( ( A > A > $o ) > ( A > A > $o ) > ( set @ B ) > ( B > A ) > $o ) ).

thf(sy_c_List_Ofoldr,type,
    foldr: 
      !>[A: $tType,B: $tType] : ( ( A > B > B ) > ( list @ A ) > B > B ) ).

thf(sy_c_List_Ogen__length,type,
    gen_length: 
      !>[A: $tType] : ( nat > ( list @ A ) > nat ) ).

thf(sy_c_List_Olast,type,
    last: 
      !>[A: $tType] : ( ( list @ A ) > A ) ).

thf(sy_c_List_Olenlex,type,
    lenlex: 
      !>[A: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > ( set @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) ) ) ).

thf(sy_c_List_Olex,type,
    lex: 
      !>[A: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > ( set @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) ) ) ).

thf(sy_c_List_Olexord,type,
    lexord: 
      !>[A: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > ( set @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) ) ) ).

thf(sy_c_List_Olinorder__class_Oinsort__insert__key,type,
    linord329482645794927042rt_key: 
      !>[B: $tType,A: $tType] : ( ( B > A ) > B > ( list @ B ) > ( list @ B ) ) ).

thf(sy_c_List_Olinorder__class_Oinsort__key,type,
    linorder_insort_key: 
      !>[B: $tType,A: $tType] : ( ( B > A ) > B > ( list @ B ) > ( list @ B ) ) ).

thf(sy_c_List_Olinorder__class_Osort__key,type,
    linorder_sort_key: 
      !>[B: $tType,A: $tType] : ( ( B > A ) > ( list @ B ) > ( list @ B ) ) ).

thf(sy_c_List_Olinorder__class_Osorted__list__of__set,type,
    linord4507533701916653071of_set: 
      !>[A: $tType] : ( ( set @ A ) > ( list @ A ) ) ).

thf(sy_c_List_Olist_OCons,type,
    cons: 
      !>[A: $tType] : ( A > ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_Olist_ONil,type,
    nil: 
      !>[A: $tType] : ( list @ A ) ).

thf(sy_c_List_Olist_Ohd,type,
    hd: 
      !>[A: $tType] : ( ( list @ A ) > A ) ).

thf(sy_c_List_Olist_Olist__all,type,
    list_all: 
      !>[A: $tType] : ( ( A > $o ) > ( list @ A ) > $o ) ).

thf(sy_c_List_Olist_Olist__all2,type,
    list_all2: 
      !>[A: $tType,B: $tType] : ( ( A > B > $o ) > ( list @ A ) > ( list @ B ) > $o ) ).

thf(sy_c_List_Olist_Omap,type,
    map: 
      !>[A: $tType,Aa: $tType] : ( ( A > Aa ) > ( list @ A ) > ( list @ Aa ) ) ).

thf(sy_c_List_Olist_Oset,type,
    set2: 
      !>[A: $tType] : ( ( list @ A ) > ( set @ A ) ) ).

thf(sy_c_List_Olist_Osize__list,type,
    size_list: 
      !>[A: $tType] : ( ( A > nat ) > ( list @ A ) > nat ) ).

thf(sy_c_List_Olist_Otl,type,
    tl: 
      !>[A: $tType] : ( ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_Olist__ex,type,
    list_ex: 
      !>[A: $tType] : ( ( A > $o ) > ( list @ A ) > $o ) ).

thf(sy_c_List_Olist__update,type,
    list_update: 
      !>[A: $tType] : ( ( list @ A ) > nat > A > ( list @ A ) ) ).

thf(sy_c_List_Olistrel,type,
    listrel: 
      !>[A: $tType,B: $tType] : ( ( set @ ( product_prod @ A @ B ) ) > ( set @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) ) ) ).

thf(sy_c_List_Olistrel1,type,
    listrel1: 
      !>[A: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > ( set @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) ) ) ).

thf(sy_c_List_Omeasures,type,
    measures: 
      !>[A: $tType] : ( ( list @ ( A > nat ) ) > ( set @ ( product_prod @ A @ A ) ) ) ).

thf(sy_c_List_On__lists,type,
    n_lists: 
      !>[A: $tType] : ( nat > ( list @ A ) > ( list @ ( list @ A ) ) ) ).

thf(sy_c_List_Onth,type,
    nth: 
      !>[A: $tType] : ( ( list @ A ) > nat > A ) ).

thf(sy_c_List_Onths,type,
    nths: 
      !>[A: $tType] : ( ( list @ A ) > ( set @ nat ) > ( list @ A ) ) ).

thf(sy_c_List_Oord__class_Olexordp,type,
    ord_lexordp: 
      !>[A: $tType] : ( ( list @ A ) > ( list @ A ) > $o ) ).

thf(sy_c_List_Oord__class_Olexordp__eq,type,
    ord_lexordp_eq: 
      !>[A: $tType] : ( ( list @ A ) > ( list @ A ) > $o ) ).

thf(sy_c_List_Oproduct,type,
    product: 
      !>[A: $tType,B: $tType] : ( ( list @ A ) > ( list @ B ) > ( list @ ( product_prod @ A @ B ) ) ) ).

thf(sy_c_List_Oremdups__adj,type,
    remdups_adj: 
      !>[A: $tType] : ( ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_Oremove1,type,
    remove1: 
      !>[A: $tType] : ( A > ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_OremoveAll,type,
    removeAll: 
      !>[A: $tType] : ( A > ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_Oreplicate,type,
    replicate: 
      !>[A: $tType] : ( nat > A > ( list @ A ) ) ).

thf(sy_c_List_Orev,type,
    rev: 
      !>[A: $tType] : ( ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_Orotate,type,
    rotate: 
      !>[A: $tType] : ( nat > ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_Orotate1,type,
    rotate1: 
      !>[A: $tType] : ( ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_Osorted__wrt,type,
    sorted_wrt: 
      !>[A: $tType] : ( ( A > A > $o ) > ( list @ A ) > $o ) ).

thf(sy_c_List_Osubseqs,type,
    subseqs: 
      !>[A: $tType] : ( ( list @ A ) > ( list @ ( list @ A ) ) ) ).

thf(sy_c_List_Otake,type,
    take: 
      !>[A: $tType] : ( nat > ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_OtakeWhile,type,
    takeWhile: 
      !>[A: $tType] : ( ( A > $o ) > ( list @ A ) > ( list @ A ) ) ).

thf(sy_c_List_Otranspose,type,
    transpose: 
      !>[A: $tType] : ( ( list @ ( list @ A ) ) > ( list @ ( list @ A ) ) ) ).

thf(sy_c_List_Oupt,type,
    upt: nat > nat > ( list @ nat ) ).

thf(sy_c_List_Oupto,type,
    upto: int > int > ( list @ int ) ).

thf(sy_c_List_Oupto__aux,type,
    upto_aux: int > int > ( list @ int ) > ( list @ int ) ).

thf(sy_c_List_Oupto__rel,type,
    upto_rel: ( product_prod @ int @ int ) > ( product_prod @ int @ int ) > $o ).

thf(sy_c_List_Ozip,type,
    zip: 
      !>[A: $tType,B: $tType] : ( ( list @ A ) > ( list @ B ) > ( list @ ( product_prod @ A @ B ) ) ) ).

thf(sy_c_Map_Omap__of,type,
    map_of: 
      !>[A: $tType,B: $tType] : ( ( list @ ( product_prod @ A @ B ) ) > A > ( option @ B ) ) ).

thf(sy_c_Map_Omap__upds,type,
    map_upds: 
      !>[A: $tType,B: $tType] : ( ( A > ( option @ B ) ) > ( list @ A ) > ( list @ B ) > A > ( option @ B ) ) ).

thf(sy_c_Nat_OSuc,type,
    suc: nat > nat ).

thf(sy_c_Nat_Ocompow,type,
    compow: 
      !>[A: $tType] : ( nat > A > A ) ).

thf(sy_c_Nat_Ofunpow,type,
    funpow: 
      !>[A: $tType] : ( nat > ( A > A ) > A > A ) ).

thf(sy_c_Nat_Onat_Ocase__nat,type,
    case_nat: 
      !>[A: $tType] : ( A > ( nat > A ) > nat > A ) ).

thf(sy_c_Nat_Onat_Opred,type,
    pred: nat > nat ).

thf(sy_c_Nat_Oold_Onat_Orec__nat,type,
    rec_nat: 
      !>[T: $tType] : ( T > ( nat > T > T ) > nat > T ) ).

thf(sy_c_Nat_Oold_Onat_Orec__set__nat,type,
    rec_set_nat: 
      !>[T: $tType] : ( T > ( nat > T > T ) > nat > T > $o ) ).

thf(sy_c_Nat_Osemiring__1__class_ONats,type,
    semiring_1_Nats: 
      !>[A: $tType] : ( set @ A ) ).

thf(sy_c_Nat_Osemiring__1__class_Oof__nat,type,
    semiring_1_of_nat: 
      !>[A: $tType] : ( nat > A ) ).

thf(sy_c_Nat_Osemiring__1__class_Oof__nat__aux,type,
    semiri8178284476397505188at_aux: 
      !>[A: $tType] : ( ( A > A ) > nat > A > A ) ).

thf(sy_c_Nat_Osize__class_Osize,type,
    size_size: 
      !>[A: $tType] : ( A > nat ) ).

thf(sy_c_Nat__Bijection_Olist__decode,type,
    nat_list_decode: nat > ( list @ nat ) ).

thf(sy_c_Nat__Bijection_Olist__decode__rel,type,
    nat_list_decode_rel: nat > nat > $o ).

thf(sy_c_Nat__Bijection_Olist__encode,type,
    nat_list_encode: ( list @ nat ) > nat ).

thf(sy_c_Nat__Bijection_Olist__encode__rel,type,
    nat_list_encode_rel: ( list @ nat ) > ( list @ nat ) > $o ).

thf(sy_c_Nat__Bijection_Oprod__decode,type,
    nat_prod_decode: nat > ( product_prod @ nat @ nat ) ).

thf(sy_c_Nat__Bijection_Oprod__decode__aux,type,
    nat_prod_decode_aux: nat > nat > ( product_prod @ nat @ nat ) ).

thf(sy_c_Nat__Bijection_Oprod__decode__aux__rel,type,
    nat_pr5047031295181774490ux_rel: ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) > $o ).

thf(sy_c_Nat__Bijection_Oprod__encode,type,
    nat_prod_encode: ( product_prod @ nat @ nat ) > nat ).

thf(sy_c_Nat__Bijection_Oset__decode,type,
    nat_set_decode: nat > ( set @ nat ) ).

thf(sy_c_Nat__Bijection_Oset__encode,type,
    nat_set_encode: ( set @ nat ) > nat ).

thf(sy_c_Nat__Bijection_Osum__encode,type,
    nat_sum_encode: ( sum_sum @ nat @ nat ) > nat ).

thf(sy_c_Nat__Bijection_Otriangle,type,
    nat_triangle: nat > nat ).

thf(sy_c_NthRoot_Oroot,type,
    root: nat > real > real ).

thf(sy_c_NthRoot_Osqrt,type,
    sqrt: real > real ).

thf(sy_c_Num_OBitM,type,
    bitM: num > num ).

thf(sy_c_Num_Oinc,type,
    inc: num > num ).

thf(sy_c_Num_Onat__of__num,type,
    nat_of_num: num > nat ).

thf(sy_c_Num_Oneg__numeral__class_Odbl,type,
    neg_numeral_dbl: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Num_Oneg__numeral__class_Odbl__dec,type,
    neg_numeral_dbl_dec: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Num_Oneg__numeral__class_Odbl__inc,type,
    neg_numeral_dbl_inc: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Num_Oneg__numeral__class_Ois__num,type,
    neg_numeral_is_num: 
      !>[A: $tType] : ( A > $o ) ).

thf(sy_c_Num_Oneg__numeral__class_Osub,type,
    neg_numeral_sub: 
      !>[A: $tType] : ( num > num > A ) ).

thf(sy_c_Num_Onum_OBit0,type,
    bit0: num > num ).

thf(sy_c_Num_Onum_OBit1,type,
    bit1: num > num ).

thf(sy_c_Num_Onum_OOne,type,
    one2: num ).

thf(sy_c_Num_Onum_Ocase__num,type,
    case_num: 
      !>[A: $tType] : ( A > ( num > A ) > ( num > A ) > num > A ) ).

thf(sy_c_Num_Onum_Orec__num,type,
    rec_num: 
      !>[A: $tType] : ( A > ( num > A > A ) > ( num > A > A ) > num > A ) ).

thf(sy_c_Num_Onum_Osize__num,type,
    size_num: num > nat ).

thf(sy_c_Num_Onum__of__nat,type,
    num_of_nat: nat > num ).

thf(sy_c_Num_Onumeral__class_Onumeral,type,
    numeral_numeral: 
      !>[A: $tType] : ( num > A ) ).

thf(sy_c_Num_Opow,type,
    pow: num > num > num ).

thf(sy_c_Num_Opred__numeral,type,
    pred_numeral: num > nat ).

thf(sy_c_Num_Oring__1__class_Oiszero,type,
    ring_1_iszero: 
      !>[A: $tType] : ( A > $o ) ).

thf(sy_c_Num_Osqr,type,
    sqr: num > num ).

thf(sy_c_Option_Ooption_ONone,type,
    none: 
      !>[A: $tType] : ( option @ A ) ).

thf(sy_c_Option_Ooption_OSome,type,
    some: 
      !>[A: $tType] : ( A > ( option @ A ) ) ).

thf(sy_c_Option_Ooption_Ocase__option,type,
    case_option: 
      !>[B: $tType,A: $tType] : ( B > ( A > B ) > ( option @ A ) > B ) ).

thf(sy_c_Option_Ooption_Omap__option,type,
    map_option: 
      !>[A: $tType,Aa: $tType] : ( ( A > Aa ) > ( option @ A ) > ( option @ Aa ) ) ).

thf(sy_c_Option_Ooption_Osize__option,type,
    size_option: 
      !>[A: $tType] : ( ( A > nat ) > ( option @ A ) > nat ) ).

thf(sy_c_Option_Ooption_Othe,type,
    the2: 
      !>[A: $tType] : ( ( option @ A ) > A ) ).

thf(sy_c_Order__Continuity_Ocountable__complete__lattice__class_Occlfp,type,
    order_532582986084564980_cclfp: 
      !>[A: $tType] : ( ( A > A ) > A ) ).

thf(sy_c_Order__Continuity_Oinf__continuous,type,
    order_inf_continuous: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > $o ) ).

thf(sy_c_Order__Continuity_Osup__continuous,type,
    order_sup_continuous: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > $o ) ).

thf(sy_c_Order__Relation_OunderS,type,
    order_underS: 
      !>[A: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > A > ( set @ A ) ) ).

thf(sy_c_Order__Relation_Owell__order__on,type,
    order_well_order_on: 
      !>[A: $tType] : ( ( set @ A ) > ( set @ ( product_prod @ A @ A ) ) > $o ) ).

thf(sy_c_Orderings_Obot__class_Obot,type,
    bot_bot: 
      !>[A: $tType] : A ).

thf(sy_c_Orderings_Oord_OLeast,type,
    least: 
      !>[A: $tType] : ( ( A > A > $o ) > ( A > $o ) > A ) ).

thf(sy_c_Orderings_Oord_Omax,type,
    max: 
      !>[A: $tType] : ( ( A > A > $o ) > A > A > A ) ).

thf(sy_c_Orderings_Oord_Omin,type,
    min: 
      !>[A: $tType] : ( ( A > A > $o ) > A > A > A ) ).

thf(sy_c_Orderings_Oord__class_OLeast,type,
    ord_Least: 
      !>[A: $tType] : ( ( A > $o ) > A ) ).

thf(sy_c_Orderings_Oord__class_Oless,type,
    ord_less: 
      !>[A: $tType] : ( A > A > $o ) ).

thf(sy_c_Orderings_Oord__class_Oless__eq,type,
    ord_less_eq: 
      !>[A: $tType] : ( A > A > $o ) ).

thf(sy_c_Orderings_Oord__class_Omax,type,
    ord_max: 
      !>[A: $tType] : ( A > A > A ) ).

thf(sy_c_Orderings_Oord__class_Omin,type,
    ord_min: 
      !>[A: $tType] : ( A > A > A ) ).

thf(sy_c_Orderings_Oorder__class_OGreatest,type,
    order_Greatest: 
      !>[A: $tType] : ( ( A > $o ) > A ) ).

thf(sy_c_Orderings_Oorder__class_Oantimono,type,
    order_antimono: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > $o ) ).

thf(sy_c_Orderings_Oorder__class_Omono,type,
    order_mono: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > $o ) ).

thf(sy_c_Orderings_Oorder__class_Ostrict__mono,type,
    order_strict_mono: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > $o ) ).

thf(sy_c_Orderings_Oordering,type,
    ordering: 
      !>[A: $tType] : ( ( A > A > $o ) > ( A > A > $o ) > $o ) ).

thf(sy_c_Orderings_Oordering__top,type,
    ordering_top: 
      !>[A: $tType] : ( ( A > A > $o ) > ( A > A > $o ) > A > $o ) ).

thf(sy_c_Orderings_Oordering__top__axioms,type,
    ordering_top_axioms: 
      !>[A: $tType] : ( ( A > A > $o ) > A > $o ) ).

thf(sy_c_Orderings_Otop__class_Otop,type,
    top_top: 
      !>[A: $tType] : A ).

thf(sy_c_Power_Opower_Opower,type,
    power2: 
      !>[A: $tType] : ( A > ( A > A > A ) > A > nat > A ) ).

thf(sy_c_Power_Opower__class_Opower,type,
    power_power: 
      !>[A: $tType] : ( A > nat > A ) ).

thf(sy_c_Product__Type_OPair,type,
    product_Pair: 
      !>[A: $tType,B: $tType] : ( A > B > ( product_prod @ A @ B ) ) ).

thf(sy_c_Product__Type_OSigma,type,
    product_Sigma: 
      !>[A: $tType,B: $tType] : ( ( set @ A ) > ( A > ( set @ B ) ) > ( set @ ( product_prod @ A @ B ) ) ) ).

thf(sy_c_Product__Type_Oapsnd,type,
    product_apsnd: 
      !>[B: $tType,C: $tType,A: $tType] : ( ( B > C ) > ( product_prod @ A @ B ) > ( product_prod @ A @ C ) ) ).

thf(sy_c_Product__Type_Omap__prod,type,
    product_map_prod: 
      !>[A: $tType,C: $tType,B: $tType,D: $tType] : ( ( A > C ) > ( B > D ) > ( product_prod @ A @ B ) > ( product_prod @ C @ D ) ) ).

thf(sy_c_Product__Type_Oprod_Ocase__prod,type,
    product_case_prod: 
      !>[A: $tType,B: $tType,C: $tType] : ( ( A > B > C ) > ( product_prod @ A @ B ) > C ) ).

thf(sy_c_Product__Type_Oprod_Ofst,type,
    product_fst: 
      !>[A: $tType,B: $tType] : ( ( product_prod @ A @ B ) > A ) ).

thf(sy_c_Product__Type_Oprod_Osnd,type,
    product_snd: 
      !>[A: $tType,B: $tType] : ( ( product_prod @ A @ B ) > B ) ).

thf(sy_c_Product__Type_Oscomp,type,
    product_scomp: 
      !>[A: $tType,B: $tType,C: $tType,D: $tType] : ( ( A > ( product_prod @ B @ C ) ) > ( B > C > D ) > A > D ) ).

thf(sy_c_Pure_Otype,type,
    type2: 
      !>[A: $tType] : ( itself @ A ) ).

thf(sy_c_Quotient_OQuotient3,type,
    quotient3: 
      !>[A: $tType,B: $tType] : ( ( A > A > $o ) > ( A > B ) > ( B > A ) > $o ) ).

thf(sy_c_Random_Oinc__shift,type,
    inc_shift: code_natural > code_natural > code_natural ).

thf(sy_c_Random_Oiterate,type,
    iterate: 
      !>[B: $tType,A: $tType] : ( code_natural > ( B > A > ( product_prod @ B @ A ) ) > B > A > ( product_prod @ B @ A ) ) ).

thf(sy_c_Random_Oiterate__rel,type,
    iterate_rel: 
      !>[B: $tType,A: $tType] : ( ( product_prod @ code_natural @ ( product_prod @ ( B > A > ( product_prod @ B @ A ) ) @ B ) ) > ( product_prod @ code_natural @ ( product_prod @ ( B > A > ( product_prod @ B @ A ) ) @ B ) ) > $o ) ).

thf(sy_c_Random_Olog,type,
    log: code_natural > code_natural > code_natural ).

thf(sy_c_Random_Ominus__shift,type,
    minus_shift: code_natural > code_natural > code_natural > code_natural ).

thf(sy_c_Random_Onext,type,
    next: ( product_prod @ code_natural @ code_natural ) > ( product_prod @ code_natural @ ( product_prod @ code_natural @ code_natural ) ) ).

thf(sy_c_Random_Opick,type,
    pick: 
      !>[A: $tType] : ( ( list @ ( product_prod @ code_natural @ A ) ) > code_natural > A ) ).

thf(sy_c_Random_Orange,type,
    range: code_natural > ( product_prod @ code_natural @ code_natural ) > ( product_prod @ code_natural @ ( product_prod @ code_natural @ code_natural ) ) ).

thf(sy_c_Random_Oselect__weight,type,
    select_weight: 
      !>[A: $tType] : ( ( list @ ( product_prod @ code_natural @ A ) ) > ( product_prod @ code_natural @ code_natural ) > ( product_prod @ A @ ( product_prod @ code_natural @ code_natural ) ) ) ).

thf(sy_c_Random_Osplit__seed,type,
    split_seed: ( product_prod @ code_natural @ code_natural ) > ( product_prod @ ( product_prod @ code_natural @ code_natural ) @ ( product_prod @ code_natural @ code_natural ) ) ).

thf(sy_c_Rat_OAbs__Rat,type,
    abs_Rat: ( product_prod @ int @ int ) > rat ).

thf(sy_c_Rat_OFract,type,
    fract: int > int > rat ).

thf(sy_c_Rat_OFrct,type,
    frct: ( product_prod @ int @ int ) > rat ).

thf(sy_c_Rat_ORep__Rat,type,
    rep_Rat: rat > ( product_prod @ int @ int ) ).

thf(sy_c_Rat_Ofield__char__0__class_ORats,type,
    field_char_0_Rats: 
      !>[A: $tType] : ( set @ A ) ).

thf(sy_c_Rat_Ofield__char__0__class_Oof__rat,type,
    field_char_0_of_rat: 
      !>[A: $tType] : ( rat > A ) ).

thf(sy_c_Rat_Onormalize,type,
    normalize: ( product_prod @ int @ int ) > ( product_prod @ int @ int ) ).

thf(sy_c_Rat_Opcr__rat,type,
    pcr_rat: ( product_prod @ int @ int ) > rat > $o ).

thf(sy_c_Rat_Opositive,type,
    positive: rat > $o ).

thf(sy_c_Rat_Oquotient__of,type,
    quotient_of: rat > ( product_prod @ int @ int ) ).

thf(sy_c_Rat_Oratrel,type,
    ratrel: ( product_prod @ int @ int ) > ( product_prod @ int @ int ) > $o ).

thf(sy_c_Real_OReal,type,
    real2: ( nat > rat ) > real ).

thf(sy_c_Real_Ocauchy,type,
    cauchy: ( nat > rat ) > $o ).

thf(sy_c_Real_Ocr__real,type,
    cr_real: ( nat > rat ) > real > $o ).

thf(sy_c_Real_Opcr__real,type,
    pcr_real: ( nat > rat ) > real > $o ).

thf(sy_c_Real_Opositive,type,
    positive2: real > $o ).

thf(sy_c_Real_Orealrel,type,
    realrel: ( nat > rat ) > ( nat > rat ) > $o ).

thf(sy_c_Real_Orep__real,type,
    rep_real: real > nat > rat ).

thf(sy_c_Real_Ovanishes,type,
    vanishes: ( nat > rat ) > $o ).

thf(sy_c_Real__Vector__Spaces_OReals,type,
    real_Vector_Reals: 
      !>[A: $tType] : ( set @ A ) ).

thf(sy_c_Real__Vector__Spaces_Obounded__bilinear,type,
    real_V2442710119149674383linear: 
      !>[A: $tType,B: $tType,C: $tType] : ( ( A > B > C ) > $o ) ).

thf(sy_c_Real__Vector__Spaces_Obounded__linear,type,
    real_V3181309239436604168linear: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > $o ) ).

thf(sy_c_Real__Vector__Spaces_Obounded__linear__axioms,type,
    real_V4916620083959148203axioms: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > $o ) ).

thf(sy_c_Real__Vector__Spaces_Oconstruct,type,
    real_V4425403222259421789struct: 
      !>[A: $tType,B: $tType] : ( ( set @ A ) > ( A > B ) > A > B ) ).

thf(sy_c_Real__Vector__Spaces_Odependent,type,
    real_V358717886546972837endent: 
      !>[A: $tType] : ( ( set @ A ) > $o ) ).

thf(sy_c_Real__Vector__Spaces_Odim,type,
    real_Vector_dim: 
      !>[A: $tType] : ( ( set @ A ) > nat ) ).

thf(sy_c_Real__Vector__Spaces_Odist__class_Odist,type,
    real_V557655796197034286t_dist: 
      !>[A: $tType] : ( A > A > real ) ).

thf(sy_c_Real__Vector__Spaces_Oextend__basis,type,
    real_V4986007116245087402_basis: 
      !>[A: $tType] : ( ( set @ A ) > ( set @ A ) ) ).

thf(sy_c_Real__Vector__Spaces_Olinear,type,
    real_Vector_linear: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > $o ) ).

thf(sy_c_Real__Vector__Spaces_Onorm__class_Onorm,type,
    real_V7770717601297561774m_norm: 
      !>[A: $tType] : ( A > real ) ).

thf(sy_c_Real__Vector__Spaces_Oof__real,type,
    real_Vector_of_real: 
      !>[A: $tType] : ( real > A ) ).

thf(sy_c_Real__Vector__Spaces_Orepresentation,type,
    real_V7696804695334737415tation: 
      !>[A: $tType] : ( ( set @ A ) > A > A > real ) ).

thf(sy_c_Real__Vector__Spaces_OscaleR__class_OscaleR,type,
    real_V8093663219630862766scaleR: 
      !>[A: $tType] : ( real > A > A ) ).

thf(sy_c_Real__Vector__Spaces_Ospan,type,
    real_Vector_span: 
      !>[A: $tType] : ( ( set @ A ) > ( set @ A ) ) ).

thf(sy_c_Real__Vector__Spaces_Osubspace,type,
    real_Vector_subspace: 
      !>[A: $tType] : ( ( set @ A ) > $o ) ).

thf(sy_c_Relation_OField,type,
    field2: 
      !>[A: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > ( set @ A ) ) ).

thf(sy_c_Relation_Oinv__image,type,
    inv_image: 
      !>[B: $tType,A: $tType] : ( ( set @ ( product_prod @ B @ B ) ) > ( A > B ) > ( set @ ( product_prod @ A @ A ) ) ) ).

thf(sy_c_Relation_Orelcomp,type,
    relcomp: 
      !>[A: $tType,B: $tType,C: $tType] : ( ( set @ ( product_prod @ A @ B ) ) > ( set @ ( product_prod @ B @ C ) ) > ( set @ ( product_prod @ A @ C ) ) ) ).

thf(sy_c_Relation_Otransp,type,
    transp: 
      !>[A: $tType] : ( ( A > A > $o ) > $o ) ).

thf(sy_c_Rings_Oalgebraic__semidom__class_Ocoprime,type,
    algebr8660921524188924756oprime: 
      !>[A: $tType] : ( A > A > $o ) ).

thf(sy_c_Rings_Odivide__class_Odivide,type,
    divide_divide: 
      !>[A: $tType] : ( A > A > A ) ).

thf(sy_c_Rings_Odvd__class_Odvd,type,
    dvd_dvd: 
      !>[A: $tType] : ( A > A > $o ) ).

thf(sy_c_Rings_Omodulo__class_Omodulo,type,
    modulo_modulo: 
      !>[A: $tType] : ( A > A > A ) ).

thf(sy_c_Rings_Onormalization__semidom__class_Onormalize,type,
    normal6383669964737779283malize: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Rings_Ounit__factor__class_Ounit__factor,type,
    unit_f5069060285200089521factor: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Rings_Ozero__neq__one__class_Oof__bool,type,
    zero_neq_one_of_bool: 
      !>[A: $tType] : ( $o > A ) ).

thf(sy_c_Series_Osuminf,type,
    suminf: 
      !>[A: $tType] : ( ( nat > A ) > A ) ).

thf(sy_c_Series_Osummable,type,
    summable: 
      !>[A: $tType] : ( ( nat > A ) > $o ) ).

thf(sy_c_Series_Osums,type,
    sums: 
      !>[A: $tType] : ( ( nat > A ) > A > $o ) ).

thf(sy_c_Set_OBall,type,
    ball: 
      !>[A: $tType] : ( ( set @ A ) > ( A > $o ) > $o ) ).

thf(sy_c_Set_OBex,type,
    bex: 
      !>[A: $tType] : ( ( set @ A ) > ( A > $o ) > $o ) ).

thf(sy_c_Set_OCollect,type,
    collect: 
      !>[A: $tType] : ( ( A > $o ) > ( set @ A ) ) ).

thf(sy_c_Set_OPow,type,
    pow2: 
      !>[A: $tType] : ( ( set @ A ) > ( set @ ( set @ A ) ) ) ).

thf(sy_c_Set_Odisjnt,type,
    disjnt: 
      !>[A: $tType] : ( ( set @ A ) > ( set @ A ) > $o ) ).

thf(sy_c_Set_Oimage,type,
    image: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > ( set @ A ) > ( set @ B ) ) ).

thf(sy_c_Set_Oinsert,type,
    insert: 
      !>[A: $tType] : ( A > ( set @ A ) > ( set @ A ) ) ).

thf(sy_c_Set_Ovimage,type,
    vimage: 
      !>[A: $tType,B: $tType] : ( ( A > B ) > ( set @ B ) > ( set @ A ) ) ).

thf(sy_c_Set__Interval_Ofold__atLeastAtMost__nat,type,
    set_fo6178422350223883121st_nat: 
      !>[A: $tType] : ( ( nat > A > A ) > nat > nat > A > A ) ).

thf(sy_c_Set__Interval_Ofold__atLeastAtMost__nat__rel,type,
    set_fo1817059534552279752at_rel: 
      !>[A: $tType] : ( ( product_prod @ ( nat > A > A ) @ ( product_prod @ nat @ ( product_prod @ nat @ A ) ) ) > ( product_prod @ ( nat > A > A ) @ ( product_prod @ nat @ ( product_prod @ nat @ A ) ) ) > $o ) ).

thf(sy_c_Set__Interval_Oord__class_OatLeast,type,
    set_ord_atLeast: 
      !>[A: $tType] : ( A > ( set @ A ) ) ).

thf(sy_c_Set__Interval_Oord__class_OatLeastAtMost,type,
    set_or1337092689740270186AtMost: 
      !>[A: $tType] : ( A > A > ( set @ A ) ) ).

thf(sy_c_Set__Interval_Oord__class_OatLeastLessThan,type,
    set_or7035219750837199246ssThan: 
      !>[A: $tType] : ( A > A > ( set @ A ) ) ).

thf(sy_c_Set__Interval_Oord__class_OatMost,type,
    set_ord_atMost: 
      !>[A: $tType] : ( A > ( set @ A ) ) ).

thf(sy_c_Set__Interval_Oord__class_OgreaterThan,type,
    set_ord_greaterThan: 
      !>[A: $tType] : ( A > ( set @ A ) ) ).

thf(sy_c_Set__Interval_Oord__class_OgreaterThanAtMost,type,
    set_or3652927894154168847AtMost: 
      !>[A: $tType] : ( A > A > ( set @ A ) ) ).

thf(sy_c_Set__Interval_Oord__class_OgreaterThanLessThan,type,
    set_or5935395276787703475ssThan: 
      !>[A: $tType] : ( A > A > ( set @ A ) ) ).

thf(sy_c_Set__Interval_Oord__class_OlessThan,type,
    set_ord_lessThan: 
      !>[A: $tType] : ( A > ( set @ A ) ) ).

thf(sy_c_String_OCode_Oabort,type,
    abort: 
      !>[A: $tType] : ( literal > ( product_unit > A ) > A ) ).

thf(sy_c_String_OLiteral,type,
    literal2: $o > $o > $o > $o > $o > $o > $o > literal > literal ).

thf(sy_c_String_Oascii__of,type,
    ascii_of: char > char ).

thf(sy_c_String_Oasciis__of__literal,type,
    asciis_of_literal: literal > ( list @ code_integer ) ).

thf(sy_c_String_Ochar_OChar,type,
    char2: $o > $o > $o > $o > $o > $o > $o > $o > char ).

thf(sy_c_String_Ochar_Osize__char,type,
    size_char: char > nat ).

thf(sy_c_String_Ocomm__semiring__1__class_Oof__char,type,
    comm_s6883823935334413003f_char: 
      !>[A: $tType] : ( char > A ) ).

thf(sy_c_String_Ointeger__of__char,type,
    integer_of_char: char > code_integer ).

thf(sy_c_String_Oliteral__of__asciis,type,
    literal_of_asciis: ( list @ code_integer ) > literal ).

thf(sy_c_String_Ounique__euclidean__semiring__with__bit__operations__class_Ochar__of,type,
    unique5772411509450598832har_of: 
      !>[A: $tType] : ( A > char ) ).

thf(sy_c_Sum__Type_OPlus,type,
    sum_Plus: 
      !>[A: $tType,B: $tType] : ( ( set @ A ) > ( set @ B ) > ( set @ ( sum_sum @ A @ B ) ) ) ).

thf(sy_c_Sum__Type_Osum_Ocase__sum,type,
    sum_case_sum: 
      !>[A: $tType,C: $tType,B: $tType] : ( ( A > C ) > ( B > C ) > ( sum_sum @ A @ B ) > C ) ).

thf(sy_c_Topological__Spaces_Ocontinuous,type,
    topolo3448309680560233919inuous: 
      !>[A: $tType,B: $tType] : ( ( filter @ A ) > ( A > B ) > $o ) ).

thf(sy_c_Topological__Spaces_Ocontinuous__on,type,
    topolo81223032696312382ous_on: 
      !>[A: $tType,B: $tType] : ( ( set @ A ) > ( A > B ) > $o ) ).

thf(sy_c_Topological__Spaces_Omonoseq,type,
    topological_monoseq: 
      !>[A: $tType] : ( ( nat > A ) > $o ) ).

thf(sy_c_Topological__Spaces_Oopen__class_Oopen,type,
    topolo1002775350975398744n_open: 
      !>[A: $tType] : ( ( set @ A ) > $o ) ).

thf(sy_c_Topological__Spaces_Ot2__space__class_OLim,type,
    topolo3827282254853284352ce_Lim: 
      !>[F: $tType,A: $tType] : ( ( filter @ F ) > ( F > A ) > A ) ).

thf(sy_c_Topological__Spaces_Otopological__space__class_Oat__within,type,
    topolo174197925503356063within: 
      !>[A: $tType] : ( A > ( set @ A ) > ( filter @ A ) ) ).

thf(sy_c_Topological__Spaces_Otopological__space__class_Ocompact,type,
    topolo2193935891317330818ompact: 
      !>[A: $tType] : ( ( set @ A ) > $o ) ).

thf(sy_c_Topological__Spaces_Otopological__space__class_Oconnected,type,
    topolo1966860045006549960nected: 
      !>[A: $tType] : ( ( set @ A ) > $o ) ).

thf(sy_c_Topological__Spaces_Otopological__space__class_Oconvergent,type,
    topolo6863149650580417670ergent: 
      !>[A: $tType] : ( ( nat > A ) > $o ) ).

thf(sy_c_Topological__Spaces_Otopological__space__class_Onhds,type,
    topolo7230453075368039082e_nhds: 
      !>[A: $tType] : ( A > ( filter @ A ) ) ).

thf(sy_c_Topological__Spaces_Ouniform__space__class_OCauchy,type,
    topolo3814608138187158403Cauchy: 
      !>[A: $tType] : ( ( nat > A ) > $o ) ).

thf(sy_c_Topological__Spaces_Ouniform__space__class_Ocauchy__filter,type,
    topolo6773858410816713723filter: 
      !>[A: $tType] : ( ( filter @ A ) > $o ) ).

thf(sy_c_Topological__Spaces_Ouniform__space__class_Ototally__bounded,type,
    topolo6688025880775521714ounded: 
      !>[A: $tType] : ( ( set @ A ) > $o ) ).

thf(sy_c_Topological__Spaces_Ouniformity__class_Ouniformity,type,
    topolo7806501430040627800ormity: 
      !>[A: $tType] : ( filter @ ( product_prod @ A @ A ) ) ).

thf(sy_c_Topological__Spaces_Ouniformly__continuous__on,type,
    topolo6026614971017936543ous_on: 
      !>[A: $tType,B: $tType] : ( ( set @ A ) > ( A > B ) > $o ) ).

thf(sy_c_Transcendental_Oarccos,type,
    arccos: real > real ).

thf(sy_c_Transcendental_Oarcosh,type,
    arcosh: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Transcendental_Oarcsin,type,
    arcsin: real > real ).

thf(sy_c_Transcendental_Oarctan,type,
    arctan: real > real ).

thf(sy_c_Transcendental_Oarsinh,type,
    arsinh: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Transcendental_Oartanh,type,
    artanh: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Transcendental_Ocos,type,
    cos: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Transcendental_Ocos__coeff,type,
    cos_coeff: nat > real ).

thf(sy_c_Transcendental_Ocosh,type,
    cosh: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Transcendental_Ocot,type,
    cot: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Transcendental_Odiffs,type,
    diffs: 
      !>[A: $tType] : ( ( nat > A ) > nat > A ) ).

thf(sy_c_Transcendental_Oexp,type,
    exp: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Transcendental_Oln__class_Oln,type,
    ln_ln: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Transcendental_Olog,type,
    log2: real > real > real ).

thf(sy_c_Transcendental_Opi,type,
    pi: real ).

thf(sy_c_Transcendental_Opowr,type,
    powr: 
      !>[A: $tType] : ( A > A > A ) ).

thf(sy_c_Transcendental_Opowr__real,type,
    powr_real: real > real > real ).

thf(sy_c_Transcendental_Osin,type,
    sin: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Transcendental_Osin__coeff,type,
    sin_coeff: nat > real ).

thf(sy_c_Transcendental_Osinh,type,
    sinh: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Transcendental_Otan,type,
    tan: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Transcendental_Otanh,type,
    tanh: 
      !>[A: $tType] : ( A > A ) ).

thf(sy_c_Transfer_Obi__total,type,
    bi_total: 
      !>[A: $tType,B: $tType] : ( ( A > B > $o ) > $o ) ).

thf(sy_c_Transitive__Closure_Ontrancl,type,
    transitive_ntrancl: 
      !>[A: $tType] : ( nat > ( set @ ( product_prod @ A @ A ) ) > ( set @ ( product_prod @ A @ A ) ) ) ).

thf(sy_c_Transitive__Closure_Ortrancl,type,
    transitive_rtrancl: 
      !>[A: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > ( set @ ( product_prod @ A @ A ) ) ) ).

thf(sy_c_Transitive__Closure_Otrancl,type,
    transitive_trancl: 
      !>[A: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > ( set @ ( product_prod @ A @ A ) ) ) ).

thf(sy_c_VEBT__Definitions_OVEBT_OLeaf,type,
    vEBT_Leaf: $o > $o > vEBT_VEBT ).

thf(sy_c_VEBT__Definitions_OVEBT_ONode,type,
    vEBT_Node: ( option @ ( product_prod @ nat @ nat ) ) > nat > ( list @ vEBT_VEBT ) > vEBT_VEBT > vEBT_VEBT ).

thf(sy_c_VEBT__Definitions_OVEBT_Osize__VEBT,type,
    vEBT_size_VEBT: vEBT_VEBT > nat ).

thf(sy_c_VEBT__Definitions_OVEBT__internal_Oboth__member__options,type,
    vEBT_V8194947554948674370ptions: vEBT_VEBT > nat > $o ).

thf(sy_c_VEBT__Definitions_OVEBT__internal_Oelim__dead,type,
    vEBT_VEBT_elim_dead: vEBT_VEBT > extended_enat > vEBT_VEBT ).

thf(sy_c_VEBT__Definitions_OVEBT__internal_Oelim__dead__rel,type,
    vEBT_V312737461966249ad_rel: ( product_prod @ vEBT_VEBT @ extended_enat ) > ( product_prod @ vEBT_VEBT @ extended_enat ) > $o ).

thf(sy_c_VEBT__Definitions_OVEBT__internal_Ohigh,type,
    vEBT_VEBT_high: nat > nat > nat ).

thf(sy_c_VEBT__Definitions_OVEBT__internal_Oin__children,type,
    vEBT_V5917875025757280293ildren: nat > ( list @ vEBT_VEBT ) > nat > $o ).

thf(sy_c_VEBT__Definitions_OVEBT__internal_Olow,type,
    vEBT_VEBT_low: nat > nat > nat ).

thf(sy_c_VEBT__Definitions_OVEBT__internal_Omembermima,type,
    vEBT_VEBT_membermima: vEBT_VEBT > nat > $o ).

thf(sy_c_VEBT__Definitions_OVEBT__internal_Omembermima__rel,type,
    vEBT_V4351362008482014158ma_rel: ( product_prod @ vEBT_VEBT @ nat ) > ( product_prod @ vEBT_VEBT @ nat ) > $o ).

thf(sy_c_VEBT__Definitions_OVEBT__internal_Onaive__member,type,
    vEBT_V5719532721284313246member: vEBT_VEBT > nat > $o ).

thf(sy_c_VEBT__Definitions_OVEBT__internal_Onaive__member__rel,type,
    vEBT_V5765760719290551771er_rel: ( product_prod @ vEBT_VEBT @ nat ) > ( product_prod @ vEBT_VEBT @ nat ) > $o ).

thf(sy_c_VEBT__Definitions_OVEBT__internal_Ovalid_H,type,
    vEBT_VEBT_valid: vEBT_VEBT > nat > $o ).

thf(sy_c_VEBT__Definitions_OVEBT__internal_Ovalid_H__rel,type,
    vEBT_VEBT_valid_rel: ( product_prod @ vEBT_VEBT @ nat ) > ( product_prod @ vEBT_VEBT @ nat ) > $o ).

thf(sy_c_VEBT__Definitions_Oinvar__vebt,type,
    vEBT_invar_vebt: vEBT_VEBT > nat > $o ).

thf(sy_c_VEBT__Definitions_Oset__vebt,type,
    vEBT_set_vebt: vEBT_VEBT > ( set @ nat ) ).

thf(sy_c_VEBT__Definitions_Ovebt__buildup,type,
    vEBT_vebt_buildup: nat > vEBT_VEBT ).

thf(sy_c_VEBT__Definitions_Ovebt__buildup__rel,type,
    vEBT_v4011308405150292612up_rel: nat > nat > $o ).

thf(sy_c_VEBT__Insert_Ovebt__insert,type,
    vEBT_vebt_insert: vEBT_VEBT > nat > vEBT_VEBT ).

thf(sy_c_VEBT__Insert_Ovebt__insert__rel,type,
    vEBT_vebt_insert_rel: ( product_prod @ vEBT_VEBT @ nat ) > ( product_prod @ vEBT_VEBT @ nat ) > $o ).

thf(sy_c_VEBT__Member_OVEBT__internal_Obit__concat,type,
    vEBT_VEBT_bit_concat: nat > nat > nat > nat ).

thf(sy_c_VEBT__Member_OVEBT__internal_OminNull,type,
    vEBT_VEBT_minNull: vEBT_VEBT > $o ).

thf(sy_c_VEBT__Member_OVEBT__internal_Oset__vebt_H,type,
    vEBT_VEBT_set_vebt: vEBT_VEBT > ( set @ nat ) ).

thf(sy_c_VEBT__Member_Ovebt__member,type,
    vEBT_vebt_member: vEBT_VEBT > nat > $o ).

thf(sy_c_VEBT__Member_Ovebt__member__rel,type,
    vEBT_vebt_member_rel: ( product_prod @ vEBT_VEBT @ nat ) > ( product_prod @ vEBT_VEBT @ nat ) > $o ).

thf(sy_c_Wellfounded_Oaccp,type,
    accp: 
      !>[A: $tType] : ( ( A > A > $o ) > A > $o ) ).

thf(sy_c_Wellfounded_Oless__than,type,
    less_than: set @ ( product_prod @ nat @ nat ) ).

thf(sy_c_Wellfounded_Olex__prod,type,
    lex_prod: 
      !>[A: $tType,B: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > ( set @ ( product_prod @ B @ B ) ) > ( set @ ( product_prod @ ( product_prod @ A @ B ) @ ( product_prod @ A @ B ) ) ) ) ).

thf(sy_c_Wellfounded_Omax__ext,type,
    max_ext: 
      !>[A: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > ( set @ ( product_prod @ ( set @ A ) @ ( set @ A ) ) ) ) ).

thf(sy_c_Wellfounded_Omeasure,type,
    measure: 
      !>[A: $tType] : ( ( A > nat ) > ( set @ ( product_prod @ A @ A ) ) ) ).

thf(sy_c_Wellfounded_Omin__ext,type,
    min_ext: 
      !>[A: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > ( set @ ( product_prod @ ( set @ A ) @ ( set @ A ) ) ) ) ).

thf(sy_c_Wellfounded_Omlex__prod,type,
    mlex_prod: 
      !>[A: $tType] : ( ( A > nat ) > ( set @ ( product_prod @ A @ A ) ) > ( set @ ( product_prod @ A @ A ) ) ) ).

thf(sy_c_Wellfounded_Opred__nat,type,
    pred_nat: set @ ( product_prod @ nat @ nat ) ).

thf(sy_c_Wellfounded_Owf,type,
    wf: 
      !>[A: $tType] : ( ( set @ ( product_prod @ A @ A ) ) > $o ) ).

thf(sy_c_fChoice,type,
    fChoice: 
      !>[A: $tType] : ( ( A > $o ) > A ) ).

thf(sy_c_member,type,
    member: 
      !>[A: $tType] : ( A > ( set @ A ) > $o ) ).

thf(sy_v_deg____,type,
    deg: nat ).

thf(sy_v_m____,type,
    m: nat ).

thf(sy_v_ma____,type,
    ma: nat ).

thf(sy_v_mi____,type,
    mi: nat ).

thf(sy_v_na____,type,
    na: nat ).

thf(sy_v_summary____,type,
    summary: vEBT_VEBT ).

thf(sy_v_treeList____,type,
    treeList: list @ vEBT_VEBT ).

thf(sy_v_xa____,type,
    xa: nat ).

% Relevant facts (8080)
thf(fact_0_abcdef,axiom,
    ord_less @ nat @ xa @ mi ).

% abcdef
thf(fact_1__C4_Ohyps_C_I7_J,axiom,
    ord_less_eq @ nat @ mi @ ma ).

% "4.hyps"(7)
thf(fact_2_False,axiom,
    ~ ( ord_less @ nat @ mi @ xa ) ).

% False
thf(fact_3__C6_C,axiom,
    ( ( ord_less_eq @ nat @ mi @ ma )
    & ( ord_less @ nat @ ma @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ deg ) ) ) ).

% "6"
thf(fact_4__C4_Ohyps_C_I8_J,axiom,
    ord_less @ nat @ ma @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ deg ) ).

% "4.hyps"(8)
thf(fact_5__C4_Oprems_C,axiom,
    ord_less @ nat @ xa @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ deg ) ).

% "4.prems"
thf(fact_6_mimaxrel,axiom,
    ( ( xa != mi )
    & ( xa != ma ) ) ).

% mimaxrel
thf(fact_7_max__number__of_I1_J,axiom,
    ! [A: $tType] :
      ( ( ( numeral @ A )
        & ( ord @ A ) )
     => ! [U: num,V: num] :
          ( ( ( ord_less_eq @ A @ ( numeral_numeral @ A @ U ) @ ( numeral_numeral @ A @ V ) )
           => ( ( ord_max @ A @ ( numeral_numeral @ A @ U ) @ ( numeral_numeral @ A @ V ) )
              = ( numeral_numeral @ A @ V ) ) )
          & ( ~ ( ord_less_eq @ A @ ( numeral_numeral @ A @ U ) @ ( numeral_numeral @ A @ V ) )
           => ( ( ord_max @ A @ ( numeral_numeral @ A @ U ) @ ( numeral_numeral @ A @ V ) )
              = ( numeral_numeral @ A @ U ) ) ) ) ) ).

% max_number_of(1)
thf(fact_8_max_Oabsorb3,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less @ A @ B2 @ A2 )
         => ( ( ord_max @ A @ A2 @ B2 )
            = A2 ) ) ) ).

% max.absorb3
thf(fact_9_max_Oabsorb4,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_max @ A @ A2 @ B2 )
            = B2 ) ) ) ).

% max.absorb4
thf(fact_10_max__less__iff__conj,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A,Y: A,Z: A] :
          ( ( ord_less @ A @ ( ord_max @ A @ X @ Y ) @ Z )
          = ( ( ord_less @ A @ X @ Z )
            & ( ord_less @ A @ Y @ Z ) ) ) ) ).

% max_less_iff_conj
thf(fact_11_max_Oabsorb1,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less_eq @ A @ B2 @ A2 )
         => ( ( ord_max @ A @ A2 @ B2 )
            = A2 ) ) ) ).

% max.absorb1
thf(fact_12_max_Oabsorb2,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_max @ A @ A2 @ B2 )
            = B2 ) ) ) ).

% max.absorb2
thf(fact_13_max_Obounded__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( ord_less_eq @ A @ ( ord_max @ A @ B2 @ C2 ) @ A2 )
          = ( ( ord_less_eq @ A @ B2 @ A2 )
            & ( ord_less_eq @ A @ C2 @ A2 ) ) ) ) ).

% max.bounded_iff
thf(fact_14_self__le__ge2__pow,axiom,
    ! [K: nat,M: nat] :
      ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ K )
     => ( ord_less_eq @ nat @ M @ ( power_power @ nat @ K @ M ) ) ) ).

% self_le_ge2_pow
thf(fact_15_power2__nat__le__eq__le,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ ( power_power @ nat @ M @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
      = ( ord_less_eq @ nat @ M @ N ) ) ).

% power2_nat_le_eq_le
thf(fact_16_power2__nat__le__imp__le,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ ( power_power @ nat @ M @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ N )
     => ( ord_less_eq @ nat @ M @ N ) ) ).

% power2_nat_le_imp_le
thf(fact_17_less__exp,axiom,
    ! [N: nat] : ( ord_less @ nat @ N @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ).

% less_exp
thf(fact_18_semiring__norm_I85_J,axiom,
    ! [M: num] :
      ( ( bit0 @ M )
     != one2 ) ).

% semiring_norm(85)
thf(fact_19_numeral__eq__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [M: num,N: num] :
          ( ( ( numeral_numeral @ A @ M )
            = ( numeral_numeral @ A @ N ) )
          = ( M = N ) ) ) ).

% numeral_eq_iff
thf(fact_20_semiring__norm_I78_J,axiom,
    ! [M: num,N: num] :
      ( ( ord_less @ num @ ( bit0 @ M ) @ ( bit0 @ N ) )
      = ( ord_less @ num @ M @ N ) ) ).

% semiring_norm(78)
thf(fact_21_semiring__norm_I71_J,axiom,
    ! [M: num,N: num] :
      ( ( ord_less_eq @ num @ ( bit0 @ M ) @ ( bit0 @ N ) )
      = ( ord_less_eq @ num @ M @ N ) ) ).

% semiring_norm(71)
thf(fact_22_semiring__norm_I87_J,axiom,
    ! [M: num,N: num] :
      ( ( ( bit0 @ M )
        = ( bit0 @ N ) )
      = ( M = N ) ) ).

% semiring_norm(87)
thf(fact_23_semiring__norm_I75_J,axiom,
    ! [M: num] :
      ~ ( ord_less @ num @ M @ one2 ) ).

% semiring_norm(75)
thf(fact_24_semiring__norm_I68_J,axiom,
    ! [N: num] : ( ord_less_eq @ num @ one2 @ N ) ).

% semiring_norm(68)
thf(fact_25_max_Oright__idem,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_max @ A @ ( ord_max @ A @ A2 @ B2 ) @ B2 )
          = ( ord_max @ A @ A2 @ B2 ) ) ) ).

% max.right_idem
thf(fact_26_max_Oleft__idem,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_max @ A @ A2 @ ( ord_max @ A @ A2 @ B2 ) )
          = ( ord_max @ A @ A2 @ B2 ) ) ) ).

% max.left_idem
thf(fact_27_max_Oidem,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A] :
          ( ( ord_max @ A @ A2 @ A2 )
          = A2 ) ) ).

% max.idem
thf(fact_28_numeral__le__iff,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [M: num,N: num] :
          ( ( ord_less_eq @ A @ ( numeral_numeral @ A @ M ) @ ( numeral_numeral @ A @ N ) )
          = ( ord_less_eq @ num @ M @ N ) ) ) ).

% numeral_le_iff
thf(fact_29_numeral__less__iff,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [M: num,N: num] :
          ( ( ord_less @ A @ ( numeral_numeral @ A @ M ) @ ( numeral_numeral @ A @ N ) )
          = ( ord_less @ num @ M @ N ) ) ) ).

% numeral_less_iff
thf(fact_30_semiring__norm_I76_J,axiom,
    ! [N: num] : ( ord_less @ num @ one2 @ ( bit0 @ N ) ) ).

% semiring_norm(76)
thf(fact_31_semiring__norm_I69_J,axiom,
    ! [M: num] :
      ~ ( ord_less_eq @ num @ ( bit0 @ M ) @ one2 ) ).

% semiring_norm(69)
thf(fact_32_semiring__norm_I83_J,axiom,
    ! [N: num] :
      ( one2
     != ( bit0 @ N ) ) ).

% semiring_norm(83)
thf(fact_33_le__num__One__iff,axiom,
    ! [X: num] :
      ( ( ord_less_eq @ num @ X @ one2 )
      = ( X = one2 ) ) ).

% le_num_One_iff
thf(fact_34_max_Oleft__commute,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( ord_max @ A @ B2 @ ( ord_max @ A @ A2 @ C2 ) )
          = ( ord_max @ A @ A2 @ ( ord_max @ A @ B2 @ C2 ) ) ) ) ).

% max.left_commute
thf(fact_35_max_Ocommute,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( ( ord_max @ A )
        = ( ^ [A3: A,B3: A] : ( ord_max @ A @ B3 @ A3 ) ) ) ) ).

% max.commute
thf(fact_36_max_Oassoc,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_max @ A @ ( ord_max @ A @ A2 @ B2 ) @ C2 )
          = ( ord_max @ A @ A2 @ ( ord_max @ A @ B2 @ C2 ) ) ) ) ).

% max.assoc
thf(fact_37_max_OcoboundedI2,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( ord_less_eq @ A @ C2 @ B2 )
         => ( ord_less_eq @ A @ C2 @ ( ord_max @ A @ A2 @ B2 ) ) ) ) ).

% max.coboundedI2
thf(fact_38_max_OcoboundedI1,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less_eq @ A @ C2 @ A2 )
         => ( ord_less_eq @ A @ C2 @ ( ord_max @ A @ A2 @ B2 ) ) ) ) ).

% max.coboundedI1
thf(fact_39_max_Oabsorb__iff2,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [A3: A,B3: A] :
              ( ( ord_max @ A @ A3 @ B3 )
              = B3 ) ) ) ) ).

% max.absorb_iff2
thf(fact_40_max_Oabsorb__iff1,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [B3: A,A3: A] :
              ( ( ord_max @ A @ A3 @ B3 )
              = A3 ) ) ) ) ).

% max.absorb_iff1
thf(fact_41_le__max__iff__disj,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Z: A,X: A,Y: A] :
          ( ( ord_less_eq @ A @ Z @ ( ord_max @ A @ X @ Y ) )
          = ( ( ord_less_eq @ A @ Z @ X )
            | ( ord_less_eq @ A @ Z @ Y ) ) ) ) ).

% le_max_iff_disj
thf(fact_42_max_Ocobounded2,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [B2: A,A2: A] : ( ord_less_eq @ A @ B2 @ ( ord_max @ A @ A2 @ B2 ) ) ) ).

% max.cobounded2
thf(fact_43_mem__Collect__eq,axiom,
    ! [A: $tType,A2: A,P: A > $o] :
      ( ( member @ A @ A2 @ ( collect @ A @ P ) )
      = ( P @ A2 ) ) ).

% mem_Collect_eq
thf(fact_44_Collect__mem__eq,axiom,
    ! [A: $tType,A4: set @ A] :
      ( ( collect @ A
        @ ^ [X2: A] : ( member @ A @ X2 @ A4 ) )
      = A4 ) ).

% Collect_mem_eq
thf(fact_45_Collect__cong,axiom,
    ! [A: $tType,P: A > $o,Q: A > $o] :
      ( ! [X3: A] :
          ( ( P @ X3 )
          = ( Q @ X3 ) )
     => ( ( collect @ A @ P )
        = ( collect @ A @ Q ) ) ) ).

% Collect_cong
thf(fact_46_ext,axiom,
    ! [B: $tType,A: $tType,F2: A > B,G: A > B] :
      ( ! [X3: A] :
          ( ( F2 @ X3 )
          = ( G @ X3 ) )
     => ( F2 = G ) ) ).

% ext
thf(fact_47_max_Ocobounded1,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A] : ( ord_less_eq @ A @ A2 @ ( ord_max @ A @ A2 @ B2 ) ) ) ).

% max.cobounded1
thf(fact_48_max_Oorder__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [B3: A,A3: A] :
              ( A3
              = ( ord_max @ A @ A3 @ B3 ) ) ) ) ) ).

% max.order_iff
thf(fact_49_max_OboundedI,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( ord_less_eq @ A @ B2 @ A2 )
         => ( ( ord_less_eq @ A @ C2 @ A2 )
           => ( ord_less_eq @ A @ ( ord_max @ A @ B2 @ C2 ) @ A2 ) ) ) ) ).

% max.boundedI
thf(fact_50_max_OboundedE,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( ord_less_eq @ A @ ( ord_max @ A @ B2 @ C2 ) @ A2 )
         => ~ ( ( ord_less_eq @ A @ B2 @ A2 )
             => ~ ( ord_less_eq @ A @ C2 @ A2 ) ) ) ) ).

% max.boundedE
thf(fact_51_max_OorderI,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A] :
          ( ( A2
            = ( ord_max @ A @ A2 @ B2 ) )
         => ( ord_less_eq @ A @ B2 @ A2 ) ) ) ).

% max.orderI
thf(fact_52_max_OorderE,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less_eq @ A @ B2 @ A2 )
         => ( A2
            = ( ord_max @ A @ A2 @ B2 ) ) ) ) ).

% max.orderE
thf(fact_53_max_Omono,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [C2: A,A2: A,D2: A,B2: A] :
          ( ( ord_less_eq @ A @ C2 @ A2 )
         => ( ( ord_less_eq @ A @ D2 @ B2 )
           => ( ord_less_eq @ A @ ( ord_max @ A @ C2 @ D2 ) @ ( ord_max @ A @ A2 @ B2 ) ) ) ) ) ).

% max.mono
thf(fact_54_max_Ostrict__coboundedI2,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( ord_less @ A @ C2 @ B2 )
         => ( ord_less @ A @ C2 @ ( ord_max @ A @ A2 @ B2 ) ) ) ) ).

% max.strict_coboundedI2
thf(fact_55_max_Ostrict__coboundedI1,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less @ A @ C2 @ A2 )
         => ( ord_less @ A @ C2 @ ( ord_max @ A @ A2 @ B2 ) ) ) ) ).

% max.strict_coboundedI1
thf(fact_56_max_Ostrict__order__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( ( ord_less @ A )
        = ( ^ [B3: A,A3: A] :
              ( ( A3
                = ( ord_max @ A @ A3 @ B3 ) )
              & ( A3 != B3 ) ) ) ) ) ).

% max.strict_order_iff
thf(fact_57_max_Ostrict__boundedE,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( ord_less @ A @ ( ord_max @ A @ B2 @ C2 ) @ A2 )
         => ~ ( ( ord_less @ A @ B2 @ A2 )
             => ~ ( ord_less @ A @ C2 @ A2 ) ) ) ) ).

% max.strict_boundedE
thf(fact_58_less__max__iff__disj,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Z: A,X: A,Y: A] :
          ( ( ord_less @ A @ Z @ ( ord_max @ A @ X @ Y ) )
          = ( ( ord_less @ A @ Z @ X )
            | ( ord_less @ A @ Z @ Y ) ) ) ) ).

% less_max_iff_disj
thf(fact_59_enat__ord__number_I1_J,axiom,
    ! [M: num,N: num] :
      ( ( ord_less_eq @ extended_enat @ ( numeral_numeral @ extended_enat @ M ) @ ( numeral_numeral @ extended_enat @ N ) )
      = ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ M ) @ ( numeral_numeral @ nat @ N ) ) ) ).

% enat_ord_number(1)
thf(fact_60_enat__ord__number_I2_J,axiom,
    ! [M: num,N: num] :
      ( ( ord_less @ extended_enat @ ( numeral_numeral @ extended_enat @ M ) @ ( numeral_numeral @ extended_enat @ N ) )
      = ( ord_less @ nat @ ( numeral_numeral @ nat @ M ) @ ( numeral_numeral @ nat @ N ) ) ) ).

% enat_ord_number(2)
thf(fact_61_power__numeral,axiom,
    ! [A: $tType] :
      ( ( semiring_numeral @ A )
     => ! [K: num,L: num] :
          ( ( power_power @ A @ ( numeral_numeral @ A @ K ) @ ( numeral_numeral @ nat @ L ) )
          = ( numeral_numeral @ A @ ( pow @ K @ L ) ) ) ) ).

% power_numeral
thf(fact_62_verit__eq__simplify_I8_J,axiom,
    ! [X22: num,Y2: num] :
      ( ( ( bit0 @ X22 )
        = ( bit0 @ Y2 ) )
      = ( X22 = Y2 ) ) ).

% verit_eq_simplify(8)
thf(fact_63_dual__order_Orefl,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A2: A] : ( ord_less_eq @ A @ A2 @ A2 ) ) ).

% dual_order.refl
thf(fact_64_order__refl,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [X: A] : ( ord_less_eq @ A @ X @ X ) ) ).

% order_refl
thf(fact_65_max__absorb2,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ A @ X @ Y )
         => ( ( ord_max @ A @ X @ Y )
            = Y ) ) ) ).

% max_absorb2
thf(fact_66_max__absorb1,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [Y: A,X: A] :
          ( ( ord_less_eq @ A @ Y @ X )
         => ( ( ord_max @ A @ X @ Y )
            = X ) ) ) ).

% max_absorb1
thf(fact_67_max__def,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ( ( ord_max @ A )
        = ( ^ [A3: A,B3: A] : ( if @ A @ ( ord_less_eq @ A @ A3 @ B3 ) @ B3 @ A3 ) ) ) ) ).

% max_def
thf(fact_68_of__nat__le__numeral__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [X: nat,I: num,N: nat] :
          ( ( ord_less_eq @ A @ ( semiring_1_of_nat @ A @ X ) @ ( power_power @ A @ ( numeral_numeral @ A @ I ) @ N ) )
          = ( ord_less_eq @ nat @ X @ ( power_power @ nat @ ( numeral_numeral @ nat @ I ) @ N ) ) ) ) ).

% of_nat_le_numeral_power_cancel_iff
thf(fact_69_numeral__power__le__of__nat__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [I: num,N: nat,X: nat] :
          ( ( ord_less_eq @ A @ ( power_power @ A @ ( numeral_numeral @ A @ I ) @ N ) @ ( semiring_1_of_nat @ A @ X ) )
          = ( ord_less_eq @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ I ) @ N ) @ X ) ) ) ).

% numeral_power_le_of_nat_cancel_iff
thf(fact_70_of__nat__less__numeral__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [X: nat,I: num,N: nat] :
          ( ( ord_less @ A @ ( semiring_1_of_nat @ A @ X ) @ ( power_power @ A @ ( numeral_numeral @ A @ I ) @ N ) )
          = ( ord_less @ nat @ X @ ( power_power @ nat @ ( numeral_numeral @ nat @ I ) @ N ) ) ) ) ).

% of_nat_less_numeral_power_cancel_iff
thf(fact_71_of__nat__numeral,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [N: num] :
          ( ( semiring_1_of_nat @ A @ ( numeral_numeral @ nat @ N ) )
          = ( numeral_numeral @ A @ N ) ) ) ).

% of_nat_numeral
thf(fact_72_of__nat__power,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [M: nat,N: nat] :
          ( ( semiring_1_of_nat @ A @ ( power_power @ nat @ M @ N ) )
          = ( power_power @ A @ ( semiring_1_of_nat @ A @ M ) @ N ) ) ) ).

% of_nat_power
thf(fact_73_of__nat__eq__of__nat__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [B2: nat,W: nat,X: nat] :
          ( ( ( power_power @ A @ ( semiring_1_of_nat @ A @ B2 ) @ W )
            = ( semiring_1_of_nat @ A @ X ) )
          = ( ( power_power @ nat @ B2 @ W )
            = X ) ) ) ).

% of_nat_eq_of_nat_power_cancel_iff
thf(fact_74_of__nat__power__eq__of__nat__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [X: nat,B2: nat,W: nat] :
          ( ( ( semiring_1_of_nat @ A @ X )
            = ( power_power @ A @ ( semiring_1_of_nat @ A @ B2 ) @ W ) )
          = ( X
            = ( power_power @ nat @ B2 @ W ) ) ) ) ).

% of_nat_power_eq_of_nat_cancel_iff
thf(fact_75_of__nat__less__of__nat__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [B2: nat,W: nat,X: nat] :
          ( ( ord_less @ A @ ( power_power @ A @ ( semiring_1_of_nat @ A @ B2 ) @ W ) @ ( semiring_1_of_nat @ A @ X ) )
          = ( ord_less @ nat @ ( power_power @ nat @ B2 @ W ) @ X ) ) ) ).

% of_nat_less_of_nat_power_cancel_iff
thf(fact_76_of__nat__power__less__of__nat__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [X: nat,B2: nat,W: nat] :
          ( ( ord_less @ A @ ( semiring_1_of_nat @ A @ X ) @ ( power_power @ A @ ( semiring_1_of_nat @ A @ B2 ) @ W ) )
          = ( ord_less @ nat @ X @ ( power_power @ nat @ B2 @ W ) ) ) ) ).

% of_nat_power_less_of_nat_cancel_iff
thf(fact_77_of__nat__le__of__nat__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [B2: nat,W: nat,X: nat] :
          ( ( ord_less_eq @ A @ ( power_power @ A @ ( semiring_1_of_nat @ A @ B2 ) @ W ) @ ( semiring_1_of_nat @ A @ X ) )
          = ( ord_less_eq @ nat @ ( power_power @ nat @ B2 @ W ) @ X ) ) ) ).

% of_nat_le_of_nat_power_cancel_iff
thf(fact_78_of__nat__power__le__of__nat__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [X: nat,B2: nat,W: nat] :
          ( ( ord_less_eq @ A @ ( semiring_1_of_nat @ A @ X ) @ ( power_power @ A @ ( semiring_1_of_nat @ A @ B2 ) @ W ) )
          = ( ord_less_eq @ nat @ X @ ( power_power @ nat @ B2 @ W ) ) ) ) ).

% of_nat_power_le_of_nat_cancel_iff
thf(fact_79_numeral__power__eq__of__nat__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [X: num,N: nat,Y: nat] :
          ( ( ( power_power @ A @ ( numeral_numeral @ A @ X ) @ N )
            = ( semiring_1_of_nat @ A @ Y ) )
          = ( ( power_power @ nat @ ( numeral_numeral @ nat @ X ) @ N )
            = Y ) ) ) ).

% numeral_power_eq_of_nat_cancel_iff
thf(fact_80_real__of__nat__eq__numeral__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [Y: nat,X: num,N: nat] :
          ( ( ( semiring_1_of_nat @ A @ Y )
            = ( power_power @ A @ ( numeral_numeral @ A @ X ) @ N ) )
          = ( Y
            = ( power_power @ nat @ ( numeral_numeral @ nat @ X ) @ N ) ) ) ) ).

% real_of_nat_eq_numeral_power_cancel_iff
thf(fact_81_numeral__power__less__of__nat__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [I: num,N: nat,X: nat] :
          ( ( ord_less @ A @ ( power_power @ A @ ( numeral_numeral @ A @ I ) @ N ) @ ( semiring_1_of_nat @ A @ X ) )
          = ( ord_less @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ I ) @ N ) @ X ) ) ) ).

% numeral_power_less_of_nat_cancel_iff
thf(fact_82_enat__less__induct,axiom,
    ! [P: extended_enat > $o,N: extended_enat] :
      ( ! [N2: extended_enat] :
          ( ! [M2: extended_enat] :
              ( ( ord_less @ extended_enat @ M2 @ N2 )
             => ( P @ M2 ) )
         => ( P @ N2 ) )
     => ( P @ N ) ) ).

% enat_less_induct
thf(fact_83_int__ops_I3_J,axiom,
    ! [N: num] :
      ( ( semiring_1_of_nat @ int @ ( numeral_numeral @ nat @ N ) )
      = ( numeral_numeral @ int @ N ) ) ).

% int_ops(3)
thf(fact_84_nat__int__comparison_I2_J,axiom,
    ( ( ord_less @ nat )
    = ( ^ [A3: nat,B3: nat] : ( ord_less @ int @ ( semiring_1_of_nat @ int @ A3 ) @ ( semiring_1_of_nat @ int @ B3 ) ) ) ) ).

% nat_int_comparison(2)
thf(fact_85_nat__int__comparison_I3_J,axiom,
    ( ( ord_less_eq @ nat )
    = ( ^ [A3: nat,B3: nat] : ( ord_less_eq @ int @ ( semiring_1_of_nat @ int @ A3 ) @ ( semiring_1_of_nat @ int @ B3 ) ) ) ) ).

% nat_int_comparison(3)
thf(fact_86_pow_Osimps_I1_J,axiom,
    ! [X: num] :
      ( ( pow @ X @ one2 )
      = X ) ).

% pow.simps(1)
thf(fact_87_verit__comp__simplify1_I2_J,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [A2: A] : ( ord_less_eq @ A @ A2 @ A2 ) ) ).

% verit_comp_simplify1(2)
thf(fact_88_nle__le,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ~ ( ord_less_eq @ A @ A2 @ B2 ) )
          = ( ( ord_less_eq @ A @ B2 @ A2 )
            & ( B2 != A2 ) ) ) ) ).

% nle_le
thf(fact_89_le__cases3,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A,Y: A,Z: A] :
          ( ( ( ord_less_eq @ A @ X @ Y )
           => ~ ( ord_less_eq @ A @ Y @ Z ) )
         => ( ( ( ord_less_eq @ A @ Y @ X )
             => ~ ( ord_less_eq @ A @ X @ Z ) )
           => ( ( ( ord_less_eq @ A @ X @ Z )
               => ~ ( ord_less_eq @ A @ Z @ Y ) )
             => ( ( ( ord_less_eq @ A @ Z @ Y )
                 => ~ ( ord_less_eq @ A @ Y @ X ) )
               => ( ( ( ord_less_eq @ A @ Y @ Z )
                   => ~ ( ord_less_eq @ A @ Z @ X ) )
                 => ~ ( ( ord_less_eq @ A @ Z @ X )
                     => ~ ( ord_less_eq @ A @ X @ Y ) ) ) ) ) ) ) ) ).

% le_cases3
thf(fact_90_order__class_Oorder__eq__iff,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( ^ [Y3: A,Z2: A] : ( Y3 = Z2 ) )
        = ( ^ [X2: A,Y4: A] :
              ( ( ord_less_eq @ A @ X2 @ Y4 )
              & ( ord_less_eq @ A @ Y4 @ X2 ) ) ) ) ) ).

% order_class.order_eq_iff
thf(fact_91_ord__eq__le__trans,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( A2 = B2 )
         => ( ( ord_less_eq @ A @ B2 @ C2 )
           => ( ord_less_eq @ A @ A2 @ C2 ) ) ) ) ).

% ord_eq_le_trans
thf(fact_92_ord__le__eq__trans,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( B2 = C2 )
           => ( ord_less_eq @ A @ A2 @ C2 ) ) ) ) ).

% ord_le_eq_trans
thf(fact_93_order__antisym,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ A @ X @ Y )
         => ( ( ord_less_eq @ A @ Y @ X )
           => ( X = Y ) ) ) ) ).

% order_antisym
thf(fact_94_order_Otrans,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ B2 @ C2 )
           => ( ord_less_eq @ A @ A2 @ C2 ) ) ) ) ).

% order.trans
thf(fact_95_order__trans,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [X: A,Y: A,Z: A] :
          ( ( ord_less_eq @ A @ X @ Y )
         => ( ( ord_less_eq @ A @ Y @ Z )
           => ( ord_less_eq @ A @ X @ Z ) ) ) ) ).

% order_trans
thf(fact_96_linorder__wlog,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [P: A > A > $o,A2: A,B2: A] :
          ( ! [A5: A,B4: A] :
              ( ( ord_less_eq @ A @ A5 @ B4 )
             => ( P @ A5 @ B4 ) )
         => ( ! [A5: A,B4: A] :
                ( ( P @ B4 @ A5 )
               => ( P @ A5 @ B4 ) )
           => ( P @ A2 @ B2 ) ) ) ) ).

% linorder_wlog
thf(fact_97_dual__order_Oeq__iff,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( ^ [Y3: A,Z2: A] : ( Y3 = Z2 ) )
        = ( ^ [A3: A,B3: A] :
              ( ( ord_less_eq @ A @ B3 @ A3 )
              & ( ord_less_eq @ A @ A3 @ B3 ) ) ) ) ) ).

% dual_order.eq_iff
thf(fact_98_dual__order_Oantisym,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less_eq @ A @ B2 @ A2 )
         => ( ( ord_less_eq @ A @ A2 @ B2 )
           => ( A2 = B2 ) ) ) ) ).

% dual_order.antisym
thf(fact_99_dual__order_Otrans,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( ord_less_eq @ A @ B2 @ A2 )
         => ( ( ord_less_eq @ A @ C2 @ B2 )
           => ( ord_less_eq @ A @ C2 @ A2 ) ) ) ) ).

% dual_order.trans
thf(fact_100_antisym,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ B2 @ A2 )
           => ( A2 = B2 ) ) ) ) ).

% antisym
thf(fact_101_le__funD,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ord @ B )
     => ! [F2: A > B,G: A > B,X: A] :
          ( ( ord_less_eq @ ( A > B ) @ F2 @ G )
         => ( ord_less_eq @ B @ ( F2 @ X ) @ ( G @ X ) ) ) ) ).

% le_funD
thf(fact_102_le__funE,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ord @ B )
     => ! [F2: A > B,G: A > B,X: A] :
          ( ( ord_less_eq @ ( A > B ) @ F2 @ G )
         => ( ord_less_eq @ B @ ( F2 @ X ) @ ( G @ X ) ) ) ) ).

% le_funE
thf(fact_103_le__funI,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ord @ B )
     => ! [F2: A > B,G: A > B] :
          ( ! [X3: A] : ( ord_less_eq @ B @ ( F2 @ X3 ) @ ( G @ X3 ) )
         => ( ord_less_eq @ ( A > B ) @ F2 @ G ) ) ) ).

% le_funI
thf(fact_104_le__fun__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ord @ B )
     => ( ( ord_less_eq @ ( A > B ) )
        = ( ^ [F3: A > B,G2: A > B] :
            ! [X2: A] : ( ord_less_eq @ B @ ( F3 @ X2 ) @ ( G2 @ X2 ) ) ) ) ) ).

% le_fun_def
thf(fact_105_Orderings_Oorder__eq__iff,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( ^ [Y3: A,Z2: A] : ( Y3 = Z2 ) )
        = ( ^ [A3: A,B3: A] :
              ( ( ord_less_eq @ A @ A3 @ B3 )
              & ( ord_less_eq @ A @ B3 @ A3 ) ) ) ) ) ).

% Orderings.order_eq_iff
thf(fact_106_order__subst1,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( order @ B )
        & ( order @ A ) )
     => ! [A2: A,F2: B > A,B2: B,C2: B] :
          ( ( ord_less_eq @ A @ A2 @ ( F2 @ B2 ) )
         => ( ( ord_less_eq @ B @ B2 @ C2 )
           => ( ! [X3: B,Y5: B] :
                  ( ( ord_less_eq @ B @ X3 @ Y5 )
                 => ( ord_less_eq @ A @ ( F2 @ X3 ) @ ( F2 @ Y5 ) ) )
             => ( ord_less_eq @ A @ A2 @ ( F2 @ C2 ) ) ) ) ) ) ).

% order_subst1
thf(fact_107_order__subst2,axiom,
    ! [A: $tType,C: $tType] :
      ( ( ( order @ C )
        & ( order @ A ) )
     => ! [A2: A,B2: A,F2: A > C,C2: C] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ C @ ( F2 @ B2 ) @ C2 )
           => ( ! [X3: A,Y5: A] :
                  ( ( ord_less_eq @ A @ X3 @ Y5 )
                 => ( ord_less_eq @ C @ ( F2 @ X3 ) @ ( F2 @ Y5 ) ) )
             => ( ord_less_eq @ C @ ( F2 @ A2 ) @ C2 ) ) ) ) ) ).

% order_subst2
thf(fact_108_order__eq__refl,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [X: A,Y: A] :
          ( ( X = Y )
         => ( ord_less_eq @ A @ X @ Y ) ) ) ).

% order_eq_refl
thf(fact_109_verit__la__disequality,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A] :
          ( ( A2 = B2 )
          | ~ ( ord_less_eq @ A @ A2 @ B2 )
          | ~ ( ord_less_eq @ A @ B2 @ A2 ) ) ) ).

% verit_la_disequality
thf(fact_110_linorder__linear,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ A @ X @ Y )
          | ( ord_less_eq @ A @ Y @ X ) ) ) ).

% linorder_linear
thf(fact_111_ord__eq__le__subst,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( ord @ B )
        & ( ord @ A ) )
     => ! [A2: A,F2: B > A,B2: B,C2: B] :
          ( ( A2
            = ( F2 @ B2 ) )
         => ( ( ord_less_eq @ B @ B2 @ C2 )
           => ( ! [X3: B,Y5: B] :
                  ( ( ord_less_eq @ B @ X3 @ Y5 )
                 => ( ord_less_eq @ A @ ( F2 @ X3 ) @ ( F2 @ Y5 ) ) )
             => ( ord_less_eq @ A @ A2 @ ( F2 @ C2 ) ) ) ) ) ) ).

% ord_eq_le_subst
thf(fact_112_ord__le__eq__subst,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( ord @ B )
        & ( ord @ A ) )
     => ! [A2: A,B2: A,F2: A > B,C2: B] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ( F2 @ B2 )
              = C2 )
           => ( ! [X3: A,Y5: A] :
                  ( ( ord_less_eq @ A @ X3 @ Y5 )
                 => ( ord_less_eq @ B @ ( F2 @ X3 ) @ ( F2 @ Y5 ) ) )
             => ( ord_less_eq @ B @ ( F2 @ A2 ) @ C2 ) ) ) ) ) ).

% ord_le_eq_subst
thf(fact_113_linorder__le__cases,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A,Y: A] :
          ( ~ ( ord_less_eq @ A @ X @ Y )
         => ( ord_less_eq @ A @ Y @ X ) ) ) ).

% linorder_le_cases
thf(fact_114_order__antisym__conv,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [Y: A,X: A] :
          ( ( ord_less_eq @ A @ Y @ X )
         => ( ( ord_less_eq @ A @ X @ Y )
            = ( X = Y ) ) ) ) ).

% order_antisym_conv
thf(fact_115_verit__comp__simplify1_I1_J,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [A2: A] :
          ~ ( ord_less @ A @ A2 @ A2 ) ) ).

% verit_comp_simplify1(1)
thf(fact_116_lt__ex,axiom,
    ! [A: $tType] :
      ( ( no_bot @ A )
     => ! [X: A] :
        ? [Y5: A] : ( ord_less @ A @ Y5 @ X ) ) ).

% lt_ex
thf(fact_117_gt__ex,axiom,
    ! [A: $tType] :
      ( ( no_top @ A )
     => ! [X: A] :
        ? [X_1: A] : ( ord_less @ A @ X @ X_1 ) ) ).

% gt_ex
thf(fact_118_dense,axiom,
    ! [A: $tType] :
      ( ( dense_order @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less @ A @ X @ Y )
         => ? [Z3: A] :
              ( ( ord_less @ A @ X @ Z3 )
              & ( ord_less @ A @ Z3 @ Y ) ) ) ) ).

% dense
thf(fact_119_less__imp__neq,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less @ A @ X @ Y )
         => ( X != Y ) ) ) ).

% less_imp_neq
thf(fact_120_order_Oasym,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ~ ( ord_less @ A @ B2 @ A2 ) ) ) ).

% order.asym
thf(fact_121_ord__eq__less__trans,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( A2 = B2 )
         => ( ( ord_less @ A @ B2 @ C2 )
           => ( ord_less @ A @ A2 @ C2 ) ) ) ) ).

% ord_eq_less_trans
thf(fact_122_ord__less__eq__trans,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( B2 = C2 )
           => ( ord_less @ A @ A2 @ C2 ) ) ) ) ).

% ord_less_eq_trans
thf(fact_123_less__induct,axiom,
    ! [A: $tType] :
      ( ( wellorder @ A )
     => ! [P: A > $o,A2: A] :
          ( ! [X3: A] :
              ( ! [Y6: A] :
                  ( ( ord_less @ A @ Y6 @ X3 )
                 => ( P @ Y6 ) )
             => ( P @ X3 ) )
         => ( P @ A2 ) ) ) ).

% less_induct
thf(fact_124_antisym__conv3,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Y: A,X: A] :
          ( ~ ( ord_less @ A @ Y @ X )
         => ( ( ~ ( ord_less @ A @ X @ Y ) )
            = ( X = Y ) ) ) ) ).

% antisym_conv3
thf(fact_125_linorder__cases,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A,Y: A] :
          ( ~ ( ord_less @ A @ X @ Y )
         => ( ( X != Y )
           => ( ord_less @ A @ Y @ X ) ) ) ) ).

% linorder_cases
thf(fact_126_dual__order_Oasym,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less @ A @ B2 @ A2 )
         => ~ ( ord_less @ A @ A2 @ B2 ) ) ) ).

% dual_order.asym
thf(fact_127_dual__order_Oirrefl,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A2: A] :
          ~ ( ord_less @ A @ A2 @ A2 ) ) ).

% dual_order.irrefl
thf(fact_128_exists__least__iff,axiom,
    ! [A: $tType] :
      ( ( wellorder @ A )
     => ( ( ^ [P2: A > $o] :
            ? [X4: A] : ( P2 @ X4 ) )
        = ( ^ [P3: A > $o] :
            ? [N3: A] :
              ( ( P3 @ N3 )
              & ! [M3: A] :
                  ( ( ord_less @ A @ M3 @ N3 )
                 => ~ ( P3 @ M3 ) ) ) ) ) ) ).

% exists_least_iff
thf(fact_129_linorder__less__wlog,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [P: A > A > $o,A2: A,B2: A] :
          ( ! [A5: A,B4: A] :
              ( ( ord_less @ A @ A5 @ B4 )
             => ( P @ A5 @ B4 ) )
         => ( ! [A5: A] : ( P @ A5 @ A5 )
           => ( ! [A5: A,B4: A] :
                  ( ( P @ B4 @ A5 )
                 => ( P @ A5 @ B4 ) )
             => ( P @ A2 @ B2 ) ) ) ) ) ).

% linorder_less_wlog
thf(fact_130_order_Ostrict__trans,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_less @ A @ B2 @ C2 )
           => ( ord_less @ A @ A2 @ C2 ) ) ) ) ).

% order.strict_trans
thf(fact_131_not__less__iff__gr__or__eq,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A,Y: A] :
          ( ( ~ ( ord_less @ A @ X @ Y ) )
          = ( ( ord_less @ A @ Y @ X )
            | ( X = Y ) ) ) ) ).

% not_less_iff_gr_or_eq
thf(fact_132_dual__order_Ostrict__trans,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( ord_less @ A @ B2 @ A2 )
         => ( ( ord_less @ A @ C2 @ B2 )
           => ( ord_less @ A @ C2 @ A2 ) ) ) ) ).

% dual_order.strict_trans
thf(fact_133_order_Ostrict__implies__not__eq,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( A2 != B2 ) ) ) ).

% order.strict_implies_not_eq
thf(fact_134_dual__order_Ostrict__implies__not__eq,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less @ A @ B2 @ A2 )
         => ( A2 != B2 ) ) ) ).

% dual_order.strict_implies_not_eq
thf(fact_135_linorder__neqE,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A,Y: A] :
          ( ( X != Y )
         => ( ~ ( ord_less @ A @ X @ Y )
           => ( ord_less @ A @ Y @ X ) ) ) ) ).

% linorder_neqE
thf(fact_136_order__less__asym,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less @ A @ X @ Y )
         => ~ ( ord_less @ A @ Y @ X ) ) ) ).

% order_less_asym
thf(fact_137_linorder__neq__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A,Y: A] :
          ( ( ( X != Y ) )
          = ( ( ord_less @ A @ X @ Y )
            | ( ord_less @ A @ Y @ X ) ) ) ) ).

% linorder_neq_iff
thf(fact_138_order__less__asym_H,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ~ ( ord_less @ A @ B2 @ A2 ) ) ) ).

% order_less_asym'
thf(fact_139_order__less__trans,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [X: A,Y: A,Z: A] :
          ( ( ord_less @ A @ X @ Y )
         => ( ( ord_less @ A @ Y @ Z )
           => ( ord_less @ A @ X @ Z ) ) ) ) ).

% order_less_trans
thf(fact_140_ord__eq__less__subst,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( ord @ B )
        & ( ord @ A ) )
     => ! [A2: A,F2: B > A,B2: B,C2: B] :
          ( ( A2
            = ( F2 @ B2 ) )
         => ( ( ord_less @ B @ B2 @ C2 )
           => ( ! [X3: B,Y5: B] :
                  ( ( ord_less @ B @ X3 @ Y5 )
                 => ( ord_less @ A @ ( F2 @ X3 ) @ ( F2 @ Y5 ) ) )
             => ( ord_less @ A @ A2 @ ( F2 @ C2 ) ) ) ) ) ) ).

% ord_eq_less_subst
thf(fact_141_ord__less__eq__subst,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( ord @ B )
        & ( ord @ A ) )
     => ! [A2: A,B2: A,F2: A > B,C2: B] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ( F2 @ B2 )
              = C2 )
           => ( ! [X3: A,Y5: A] :
                  ( ( ord_less @ A @ X3 @ Y5 )
                 => ( ord_less @ B @ ( F2 @ X3 ) @ ( F2 @ Y5 ) ) )
             => ( ord_less @ B @ ( F2 @ A2 ) @ C2 ) ) ) ) ) ).

% ord_less_eq_subst
thf(fact_142_order__less__irrefl,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [X: A] :
          ~ ( ord_less @ A @ X @ X ) ) ).

% order_less_irrefl
thf(fact_143_order__less__subst1,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( order @ B )
        & ( order @ A ) )
     => ! [A2: A,F2: B > A,B2: B,C2: B] :
          ( ( ord_less @ A @ A2 @ ( F2 @ B2 ) )
         => ( ( ord_less @ B @ B2 @ C2 )
           => ( ! [X3: B,Y5: B] :
                  ( ( ord_less @ B @ X3 @ Y5 )
                 => ( ord_less @ A @ ( F2 @ X3 ) @ ( F2 @ Y5 ) ) )
             => ( ord_less @ A @ A2 @ ( F2 @ C2 ) ) ) ) ) ) ).

% order_less_subst1
thf(fact_144_order__less__subst2,axiom,
    ! [A: $tType,C: $tType] :
      ( ( ( order @ C )
        & ( order @ A ) )
     => ! [A2: A,B2: A,F2: A > C,C2: C] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_less @ C @ ( F2 @ B2 ) @ C2 )
           => ( ! [X3: A,Y5: A] :
                  ( ( ord_less @ A @ X3 @ Y5 )
                 => ( ord_less @ C @ ( F2 @ X3 ) @ ( F2 @ Y5 ) ) )
             => ( ord_less @ C @ ( F2 @ A2 ) @ C2 ) ) ) ) ) ).

% order_less_subst2
thf(fact_145_order__less__not__sym,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less @ A @ X @ Y )
         => ~ ( ord_less @ A @ Y @ X ) ) ) ).

% order_less_not_sym
thf(fact_146_order__less__imp__triv,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [X: A,Y: A,P: $o] :
          ( ( ord_less @ A @ X @ Y )
         => ( ( ord_less @ A @ Y @ X )
           => P ) ) ) ).

% order_less_imp_triv
thf(fact_147_linorder__less__linear,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less @ A @ X @ Y )
          | ( X = Y )
          | ( ord_less @ A @ Y @ X ) ) ) ).

% linorder_less_linear
thf(fact_148_order__less__imp__not__eq,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less @ A @ X @ Y )
         => ( X != Y ) ) ) ).

% order_less_imp_not_eq
thf(fact_149_order__less__imp__not__eq2,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less @ A @ X @ Y )
         => ( Y != X ) ) ) ).

% order_less_imp_not_eq2
thf(fact_150_order__less__imp__not__less,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less @ A @ X @ Y )
         => ~ ( ord_less @ A @ Y @ X ) ) ) ).

% order_less_imp_not_less
thf(fact_151_verit__comp__simplify1_I3_J,axiom,
    ! [B: $tType] :
      ( ( linorder @ B )
     => ! [B5: B,A6: B] :
          ( ( ~ ( ord_less_eq @ B @ B5 @ A6 ) )
          = ( ord_less @ B @ A6 @ B5 ) ) ) ).

% verit_comp_simplify1(3)
thf(fact_152_leD,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [Y: A,X: A] :
          ( ( ord_less_eq @ A @ Y @ X )
         => ~ ( ord_less @ A @ X @ Y ) ) ) ).

% leD
thf(fact_153_leI,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A,Y: A] :
          ( ~ ( ord_less @ A @ X @ Y )
         => ( ord_less_eq @ A @ Y @ X ) ) ) ).

% leI
thf(fact_154_nless__le,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [A2: A,B2: A] :
          ( ( ~ ( ord_less @ A @ A2 @ B2 ) )
          = ( ~ ( ord_less_eq @ A @ A2 @ B2 )
            | ( A2 = B2 ) ) ) ) ).

% nless_le
thf(fact_155_antisym__conv1,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [X: A,Y: A] :
          ( ~ ( ord_less @ A @ X @ Y )
         => ( ( ord_less_eq @ A @ X @ Y )
            = ( X = Y ) ) ) ) ).

% antisym_conv1
thf(fact_156_antisym__conv2,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ A @ X @ Y )
         => ( ( ~ ( ord_less @ A @ X @ Y ) )
            = ( X = Y ) ) ) ) ).

% antisym_conv2
thf(fact_157_dense__ge,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [Z: A,Y: A] :
          ( ! [X3: A] :
              ( ( ord_less @ A @ Z @ X3 )
             => ( ord_less_eq @ A @ Y @ X3 ) )
         => ( ord_less_eq @ A @ Y @ Z ) ) ) ).

% dense_ge
thf(fact_158_dense__le,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [Y: A,Z: A] :
          ( ! [X3: A] :
              ( ( ord_less @ A @ X3 @ Y )
             => ( ord_less_eq @ A @ X3 @ Z ) )
         => ( ord_less_eq @ A @ Y @ Z ) ) ) ).

% dense_le
thf(fact_159_less__le__not__le,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ( ( ord_less @ A )
        = ( ^ [X2: A,Y4: A] :
              ( ( ord_less_eq @ A @ X2 @ Y4 )
              & ~ ( ord_less_eq @ A @ Y4 @ X2 ) ) ) ) ) ).

% less_le_not_le
thf(fact_160_not__le__imp__less,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Y: A,X: A] :
          ( ~ ( ord_less_eq @ A @ Y @ X )
         => ( ord_less @ A @ X @ Y ) ) ) ).

% not_le_imp_less
thf(fact_161_order_Oorder__iff__strict,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [A3: A,B3: A] :
              ( ( ord_less @ A @ A3 @ B3 )
              | ( A3 = B3 ) ) ) ) ) ).

% order.order_iff_strict
thf(fact_162_order_Ostrict__iff__order,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( ord_less @ A )
        = ( ^ [A3: A,B3: A] :
              ( ( ord_less_eq @ A @ A3 @ B3 )
              & ( A3 != B3 ) ) ) ) ) ).

% order.strict_iff_order
thf(fact_163_order_Ostrict__trans1,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less @ A @ B2 @ C2 )
           => ( ord_less @ A @ A2 @ C2 ) ) ) ) ).

% order.strict_trans1
thf(fact_164_order_Ostrict__trans2,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ B2 @ C2 )
           => ( ord_less @ A @ A2 @ C2 ) ) ) ) ).

% order.strict_trans2
thf(fact_165_order_Ostrict__iff__not,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ( ( ord_less @ A )
        = ( ^ [A3: A,B3: A] :
              ( ( ord_less_eq @ A @ A3 @ B3 )
              & ~ ( ord_less_eq @ A @ B3 @ A3 ) ) ) ) ) ).

% order.strict_iff_not
thf(fact_166_dense__ge__bounded,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [Z: A,X: A,Y: A] :
          ( ( ord_less @ A @ Z @ X )
         => ( ! [W2: A] :
                ( ( ord_less @ A @ Z @ W2 )
               => ( ( ord_less @ A @ W2 @ X )
                 => ( ord_less_eq @ A @ Y @ W2 ) ) )
           => ( ord_less_eq @ A @ Y @ Z ) ) ) ) ).

% dense_ge_bounded
thf(fact_167_dense__le__bounded,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [X: A,Y: A,Z: A] :
          ( ( ord_less @ A @ X @ Y )
         => ( ! [W2: A] :
                ( ( ord_less @ A @ X @ W2 )
               => ( ( ord_less @ A @ W2 @ Y )
                 => ( ord_less_eq @ A @ W2 @ Z ) ) )
           => ( ord_less_eq @ A @ Y @ Z ) ) ) ) ).

% dense_le_bounded
thf(fact_168_dual__order_Oorder__iff__strict,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [B3: A,A3: A] :
              ( ( ord_less @ A @ B3 @ A3 )
              | ( A3 = B3 ) ) ) ) ) ).

% dual_order.order_iff_strict
thf(fact_169_dual__order_Ostrict__iff__order,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( ord_less @ A )
        = ( ^ [B3: A,A3: A] :
              ( ( ord_less_eq @ A @ B3 @ A3 )
              & ( A3 != B3 ) ) ) ) ) ).

% dual_order.strict_iff_order
thf(fact_170_dual__order_Ostrict__trans1,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( ord_less_eq @ A @ B2 @ A2 )
         => ( ( ord_less @ A @ C2 @ B2 )
           => ( ord_less @ A @ C2 @ A2 ) ) ) ) ).

% dual_order.strict_trans1
thf(fact_171_dual__order_Ostrict__trans2,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( ord_less @ A @ B2 @ A2 )
         => ( ( ord_less_eq @ A @ C2 @ B2 )
           => ( ord_less @ A @ C2 @ A2 ) ) ) ) ).

% dual_order.strict_trans2
thf(fact_172_dual__order_Ostrict__iff__not,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ( ( ord_less @ A )
        = ( ^ [B3: A,A3: A] :
              ( ( ord_less_eq @ A @ B3 @ A3 )
              & ~ ( ord_less_eq @ A @ A3 @ B3 ) ) ) ) ) ).

% dual_order.strict_iff_not
thf(fact_173_order_Ostrict__implies__order,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ord_less_eq @ A @ A2 @ B2 ) ) ) ).

% order.strict_implies_order
thf(fact_174_dual__order_Ostrict__implies__order,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less @ A @ B2 @ A2 )
         => ( ord_less_eq @ A @ B2 @ A2 ) ) ) ).

% dual_order.strict_implies_order
thf(fact_175_order__le__less,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [X2: A,Y4: A] :
              ( ( ord_less @ A @ X2 @ Y4 )
              | ( X2 = Y4 ) ) ) ) ) ).

% order_le_less
thf(fact_176_order__less__le,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( ord_less @ A )
        = ( ^ [X2: A,Y4: A] :
              ( ( ord_less_eq @ A @ X2 @ Y4 )
              & ( X2 != Y4 ) ) ) ) ) ).

% order_less_le
thf(fact_177_linorder__not__le,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A,Y: A] :
          ( ( ~ ( ord_less_eq @ A @ X @ Y ) )
          = ( ord_less @ A @ Y @ X ) ) ) ).

% linorder_not_le
thf(fact_178_linorder__not__less,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A,Y: A] :
          ( ( ~ ( ord_less @ A @ X @ Y ) )
          = ( ord_less_eq @ A @ Y @ X ) ) ) ).

% linorder_not_less
thf(fact_179_order__less__imp__le,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less @ A @ X @ Y )
         => ( ord_less_eq @ A @ X @ Y ) ) ) ).

% order_less_imp_le
thf(fact_180_order__le__neq__trans,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( A2 != B2 )
           => ( ord_less @ A @ A2 @ B2 ) ) ) ) ).

% order_le_neq_trans
thf(fact_181_order__neq__le__trans,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [A2: A,B2: A] :
          ( ( A2 != B2 )
         => ( ( ord_less_eq @ A @ A2 @ B2 )
           => ( ord_less @ A @ A2 @ B2 ) ) ) ) ).

% order_neq_le_trans
thf(fact_182_order__le__less__trans,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [X: A,Y: A,Z: A] :
          ( ( ord_less_eq @ A @ X @ Y )
         => ( ( ord_less @ A @ Y @ Z )
           => ( ord_less @ A @ X @ Z ) ) ) ) ).

% order_le_less_trans
thf(fact_183_order__less__le__trans,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [X: A,Y: A,Z: A] :
          ( ( ord_less @ A @ X @ Y )
         => ( ( ord_less_eq @ A @ Y @ Z )
           => ( ord_less @ A @ X @ Z ) ) ) ) ).

% order_less_le_trans
thf(fact_184_order__le__less__subst1,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( order @ B )
        & ( order @ A ) )
     => ! [A2: A,F2: B > A,B2: B,C2: B] :
          ( ( ord_less_eq @ A @ A2 @ ( F2 @ B2 ) )
         => ( ( ord_less @ B @ B2 @ C2 )
           => ( ! [X3: B,Y5: B] :
                  ( ( ord_less @ B @ X3 @ Y5 )
                 => ( ord_less @ A @ ( F2 @ X3 ) @ ( F2 @ Y5 ) ) )
             => ( ord_less @ A @ A2 @ ( F2 @ C2 ) ) ) ) ) ) ).

% order_le_less_subst1
thf(fact_185_order__le__less__subst2,axiom,
    ! [A: $tType,C: $tType] :
      ( ( ( order @ C )
        & ( order @ A ) )
     => ! [A2: A,B2: A,F2: A > C,C2: C] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less @ C @ ( F2 @ B2 ) @ C2 )
           => ( ! [X3: A,Y5: A] :
                  ( ( ord_less_eq @ A @ X3 @ Y5 )
                 => ( ord_less_eq @ C @ ( F2 @ X3 ) @ ( F2 @ Y5 ) ) )
             => ( ord_less @ C @ ( F2 @ A2 ) @ C2 ) ) ) ) ) ).

% order_le_less_subst2
thf(fact_186_order__less__le__subst1,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( order @ B )
        & ( order @ A ) )
     => ! [A2: A,F2: B > A,B2: B,C2: B] :
          ( ( ord_less @ A @ A2 @ ( F2 @ B2 ) )
         => ( ( ord_less_eq @ B @ B2 @ C2 )
           => ( ! [X3: B,Y5: B] :
                  ( ( ord_less_eq @ B @ X3 @ Y5 )
                 => ( ord_less_eq @ A @ ( F2 @ X3 ) @ ( F2 @ Y5 ) ) )
             => ( ord_less @ A @ A2 @ ( F2 @ C2 ) ) ) ) ) ) ).

% order_less_le_subst1
thf(fact_187_order__less__le__subst2,axiom,
    ! [A: $tType,C: $tType] :
      ( ( ( order @ C )
        & ( order @ A ) )
     => ! [A2: A,B2: A,F2: A > C,C2: C] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ C @ ( F2 @ B2 ) @ C2 )
           => ( ! [X3: A,Y5: A] :
                  ( ( ord_less @ A @ X3 @ Y5 )
                 => ( ord_less @ C @ ( F2 @ X3 ) @ ( F2 @ Y5 ) ) )
             => ( ord_less @ C @ ( F2 @ A2 ) @ C2 ) ) ) ) ) ).

% order_less_le_subst2
thf(fact_188_linorder__le__less__linear,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ A @ X @ Y )
          | ( ord_less @ A @ Y @ X ) ) ) ).

% linorder_le_less_linear
thf(fact_189_order__le__imp__less__or__eq,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ A @ X @ Y )
         => ( ( ord_less @ A @ X @ Y )
            | ( X = Y ) ) ) ) ).

% order_le_imp_less_or_eq
thf(fact_190_verit__eq__simplify_I10_J,axiom,
    ! [X22: num] :
      ( one2
     != ( bit0 @ X22 ) ) ).

% verit_eq_simplify(10)
thf(fact_191_of__nat__le__iff,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [M: nat,N: nat] :
          ( ( ord_less_eq @ A @ ( semiring_1_of_nat @ A @ M ) @ ( semiring_1_of_nat @ A @ N ) )
          = ( ord_less_eq @ nat @ M @ N ) ) ) ).

% of_nat_le_iff
thf(fact_192_of__nat__less__iff,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [M: nat,N: nat] :
          ( ( ord_less @ A @ ( semiring_1_of_nat @ A @ M ) @ ( semiring_1_of_nat @ A @ N ) )
          = ( ord_less @ nat @ M @ N ) ) ) ).

% of_nat_less_iff
thf(fact_193_of__nat__less__two__power,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N: nat] : ( ord_less @ A @ ( semiring_1_of_nat @ A @ N ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) ) ) ).

% of_nat_less_two_power
thf(fact_194_numeral__le__real__of__nat__iff,axiom,
    ! [N: num,M: nat] :
      ( ( ord_less_eq @ real @ ( numeral_numeral @ real @ N ) @ ( semiring_1_of_nat @ real @ M ) )
      = ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ N ) @ M ) ) ).

% numeral_le_real_of_nat_iff
thf(fact_195_numeral__less__real__of__nat__iff,axiom,
    ! [W: num,N: nat] :
      ( ( ord_less @ real @ ( numeral_numeral @ real @ W ) @ ( semiring_1_of_nat @ real @ N ) )
      = ( ord_less @ nat @ ( numeral_numeral @ nat @ W ) @ N ) ) ).

% numeral_less_real_of_nat_iff
thf(fact_196_real__of__nat__less__numeral__iff,axiom,
    ! [N: nat,W: num] :
      ( ( ord_less @ real @ ( semiring_1_of_nat @ real @ N ) @ ( numeral_numeral @ real @ W ) )
      = ( ord_less @ nat @ N @ ( numeral_numeral @ nat @ W ) ) ) ).

% real_of_nat_less_numeral_iff
thf(fact_197_of__nat__max,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [X: nat,Y: nat] :
          ( ( semiring_1_of_nat @ A @ ( ord_max @ nat @ X @ Y ) )
          = ( ord_max @ A @ ( semiring_1_of_nat @ A @ X ) @ ( semiring_1_of_nat @ A @ Y ) ) ) ) ).

% of_nat_max
thf(fact_198_of__nat__mono,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [I: nat,J: nat] :
          ( ( ord_less_eq @ nat @ I @ J )
         => ( ord_less_eq @ A @ ( semiring_1_of_nat @ A @ I ) @ ( semiring_1_of_nat @ A @ J ) ) ) ) ).

% of_nat_mono
thf(fact_199_less__imp__of__nat__less,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [M: nat,N: nat] :
          ( ( ord_less @ nat @ M @ N )
         => ( ord_less @ A @ ( semiring_1_of_nat @ A @ M ) @ ( semiring_1_of_nat @ A @ N ) ) ) ) ).

% less_imp_of_nat_less
thf(fact_200_of__nat__less__imp__less,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [M: nat,N: nat] :
          ( ( ord_less @ A @ ( semiring_1_of_nat @ A @ M ) @ ( semiring_1_of_nat @ A @ N ) )
         => ( ord_less @ nat @ M @ N ) ) ) ).

% of_nat_less_imp_less
thf(fact_201_of__nat__eq__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [M: nat,N: nat] :
          ( ( ( semiring_1_of_nat @ A @ M )
            = ( semiring_1_of_nat @ A @ N ) )
          = ( M = N ) ) ) ).

% of_nat_eq_iff
thf(fact_202_int__eq__iff__numeral,axiom,
    ! [M: nat,V: num] :
      ( ( ( semiring_1_of_nat @ int @ M )
        = ( numeral_numeral @ int @ V ) )
      = ( M
        = ( numeral_numeral @ nat @ V ) ) ) ).

% int_eq_iff_numeral
thf(fact_203_complete__real,axiom,
    ! [S: set @ real] :
      ( ? [X5: real] : ( member @ real @ X5 @ S )
     => ( ? [Z4: real] :
          ! [X3: real] :
            ( ( member @ real @ X3 @ S )
           => ( ord_less_eq @ real @ X3 @ Z4 ) )
       => ? [Y5: real] :
            ( ! [X5: real] :
                ( ( member @ real @ X5 @ S )
               => ( ord_less_eq @ real @ X5 @ Y5 ) )
            & ! [Z4: real] :
                ( ! [X3: real] :
                    ( ( member @ real @ X3 @ S )
                   => ( ord_less_eq @ real @ X3 @ Z4 ) )
               => ( ord_less_eq @ real @ Y5 @ Z4 ) ) ) ) ) ).

% complete_real
thf(fact_204_verit__la__generic,axiom,
    ! [A2: int,X: int] :
      ( ( ord_less_eq @ int @ A2 @ X )
      | ( A2 = X )
      | ( ord_less_eq @ int @ X @ A2 ) ) ).

% verit_la_generic
thf(fact_205_less__eq__real__def,axiom,
    ( ( ord_less_eq @ real )
    = ( ^ [X2: real,Y4: real] :
          ( ( ord_less @ real @ X2 @ Y4 )
          | ( X2 = Y4 ) ) ) ) ).

% less_eq_real_def
thf(fact_206_less__fun__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ord @ B )
     => ( ( ord_less @ ( A > B ) )
        = ( ^ [F3: A > B,G2: A > B] :
              ( ( ord_less_eq @ ( A > B ) @ F3 @ G2 )
              & ~ ( ord_less_eq @ ( A > B ) @ G2 @ F3 ) ) ) ) ) ).

% less_fun_def
thf(fact_207_int__int__eq,axiom,
    ! [M: nat,N: nat] :
      ( ( ( semiring_1_of_nat @ int @ M )
        = ( semiring_1_of_nat @ int @ N ) )
      = ( M = N ) ) ).

% int_int_eq
thf(fact_208_int__if,axiom,
    ! [P: $o,A2: nat,B2: nat] :
      ( ( P
       => ( ( semiring_1_of_nat @ int @ ( if @ nat @ P @ A2 @ B2 ) )
          = ( semiring_1_of_nat @ int @ A2 ) ) )
      & ( ~ P
       => ( ( semiring_1_of_nat @ int @ ( if @ nat @ P @ A2 @ B2 ) )
          = ( semiring_1_of_nat @ int @ B2 ) ) ) ) ).

% int_if
thf(fact_209_nat__int__comparison_I1_J,axiom,
    ( ( ^ [Y3: nat,Z2: nat] : ( Y3 = Z2 ) )
    = ( ^ [A3: nat,B3: nat] :
          ( ( semiring_1_of_nat @ int @ A3 )
          = ( semiring_1_of_nat @ int @ B3 ) ) ) ) ).

% nat_int_comparison(1)
thf(fact_210_measure__induct__rule,axiom,
    ! [B: $tType,A: $tType] :
      ( ( wellorder @ B )
     => ! [F2: A > B,P: A > $o,A2: A] :
          ( ! [X3: A] :
              ( ! [Y6: A] :
                  ( ( ord_less @ B @ ( F2 @ Y6 ) @ ( F2 @ X3 ) )
                 => ( P @ Y6 ) )
             => ( P @ X3 ) )
         => ( P @ A2 ) ) ) ).

% measure_induct_rule
thf(fact_211_measure__induct,axiom,
    ! [B: $tType,A: $tType] :
      ( ( wellorder @ B )
     => ! [F2: A > B,P: A > $o,A2: A] :
          ( ! [X3: A] :
              ( ! [Y6: A] :
                  ( ( ord_less @ B @ ( F2 @ Y6 ) @ ( F2 @ X3 ) )
                 => ( P @ Y6 ) )
             => ( P @ X3 ) )
         => ( P @ A2 ) ) ) ).

% measure_induct
thf(fact_212_infinite__descent__measure,axiom,
    ! [A: $tType,P: A > $o,V2: A > nat,X: A] :
      ( ! [X3: A] :
          ( ~ ( P @ X3 )
         => ? [Y6: A] :
              ( ( ord_less @ nat @ ( V2 @ Y6 ) @ ( V2 @ X3 ) )
              & ~ ( P @ Y6 ) ) )
     => ( P @ X ) ) ).

% infinite_descent_measure
thf(fact_213_linorder__neqE__nat,axiom,
    ! [X: nat,Y: nat] :
      ( ( X != Y )
     => ( ~ ( ord_less @ nat @ X @ Y )
       => ( ord_less @ nat @ Y @ X ) ) ) ).

% linorder_neqE_nat
thf(fact_214_infinite__descent,axiom,
    ! [P: nat > $o,N: nat] :
      ( ! [N2: nat] :
          ( ~ ( P @ N2 )
         => ? [M2: nat] :
              ( ( ord_less @ nat @ M2 @ N2 )
              & ~ ( P @ M2 ) ) )
     => ( P @ N ) ) ).

% infinite_descent
thf(fact_215_nat__less__induct,axiom,
    ! [P: nat > $o,N: nat] :
      ( ! [N2: nat] :
          ( ! [M2: nat] :
              ( ( ord_less @ nat @ M2 @ N2 )
             => ( P @ M2 ) )
         => ( P @ N2 ) )
     => ( P @ N ) ) ).

% nat_less_induct
thf(fact_216_less__irrefl__nat,axiom,
    ! [N: nat] :
      ~ ( ord_less @ nat @ N @ N ) ).

% less_irrefl_nat
thf(fact_217_less__not__refl3,axiom,
    ! [S2: nat,T2: nat] :
      ( ( ord_less @ nat @ S2 @ T2 )
     => ( S2 != T2 ) ) ).

% less_not_refl3
thf(fact_218_less__not__refl2,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less @ nat @ N @ M )
     => ( M != N ) ) ).

% less_not_refl2
thf(fact_219_less__not__refl,axiom,
    ! [N: nat] :
      ~ ( ord_less @ nat @ N @ N ) ).

% less_not_refl
thf(fact_220_nat__neq__iff,axiom,
    ! [M: nat,N: nat] :
      ( ( ( M != N ) )
      = ( ( ord_less @ nat @ M @ N )
        | ( ord_less @ nat @ N @ M ) ) ) ).

% nat_neq_iff
thf(fact_221_Nat_Oex__has__greatest__nat,axiom,
    ! [P: nat > $o,K: nat,B2: nat] :
      ( ( P @ K )
     => ( ! [Y5: nat] :
            ( ( P @ Y5 )
           => ( ord_less_eq @ nat @ Y5 @ B2 ) )
       => ? [X3: nat] :
            ( ( P @ X3 )
            & ! [Y6: nat] :
                ( ( P @ Y6 )
               => ( ord_less_eq @ nat @ Y6 @ X3 ) ) ) ) ) ).

% Nat.ex_has_greatest_nat
thf(fact_222_nat__le__linear,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ M @ N )
      | ( ord_less_eq @ nat @ N @ M ) ) ).

% nat_le_linear
thf(fact_223_le__antisym,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ M @ N )
     => ( ( ord_less_eq @ nat @ N @ M )
       => ( M = N ) ) ) ).

% le_antisym
thf(fact_224_eq__imp__le,axiom,
    ! [M: nat,N: nat] :
      ( ( M = N )
     => ( ord_less_eq @ nat @ M @ N ) ) ).

% eq_imp_le
thf(fact_225_le__trans,axiom,
    ! [I: nat,J: nat,K: nat] :
      ( ( ord_less_eq @ nat @ I @ J )
     => ( ( ord_less_eq @ nat @ J @ K )
       => ( ord_less_eq @ nat @ I @ K ) ) ) ).

% le_trans
thf(fact_226_le__refl,axiom,
    ! [N: nat] : ( ord_less_eq @ nat @ N @ N ) ).

% le_refl
thf(fact_227_zle__int,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less_eq @ int @ ( semiring_1_of_nat @ int @ M ) @ ( semiring_1_of_nat @ int @ N ) )
      = ( ord_less_eq @ nat @ M @ N ) ) ).

% zle_int
thf(fact_228_less__mono__imp__le__mono,axiom,
    ! [F2: nat > nat,I: nat,J: nat] :
      ( ! [I2: nat,J2: nat] :
          ( ( ord_less @ nat @ I2 @ J2 )
         => ( ord_less @ nat @ ( F2 @ I2 ) @ ( F2 @ J2 ) ) )
     => ( ( ord_less_eq @ nat @ I @ J )
       => ( ord_less_eq @ nat @ ( F2 @ I ) @ ( F2 @ J ) ) ) ) ).

% less_mono_imp_le_mono
thf(fact_229_le__neq__implies__less,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ M @ N )
     => ( ( M != N )
       => ( ord_less @ nat @ M @ N ) ) ) ).

% le_neq_implies_less
thf(fact_230_less__or__eq__imp__le,axiom,
    ! [M: nat,N: nat] :
      ( ( ( ord_less @ nat @ M @ N )
        | ( M = N ) )
     => ( ord_less_eq @ nat @ M @ N ) ) ).

% less_or_eq_imp_le
thf(fact_231_le__eq__less__or__eq,axiom,
    ( ( ord_less_eq @ nat )
    = ( ^ [M3: nat,N3: nat] :
          ( ( ord_less @ nat @ M3 @ N3 )
          | ( M3 = N3 ) ) ) ) ).

% le_eq_less_or_eq
thf(fact_232_less__imp__le__nat,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ M @ N )
     => ( ord_less_eq @ nat @ M @ N ) ) ).

% less_imp_le_nat
thf(fact_233_nat__less__le,axiom,
    ( ( ord_less @ nat )
    = ( ^ [M3: nat,N3: nat] :
          ( ( ord_less_eq @ nat @ M3 @ N3 )
          & ( M3 != N3 ) ) ) ) ).

% nat_less_le
thf(fact_234_Lattices__Big_Oex__has__greatest__nat,axiom,
    ! [A: $tType,P: A > $o,K: A,F2: A > nat,B2: nat] :
      ( ( P @ K )
     => ( ! [Y5: A] :
            ( ( P @ Y5 )
           => ( ord_less @ nat @ ( F2 @ Y5 ) @ B2 ) )
       => ? [X3: A] :
            ( ( P @ X3 )
            & ! [Y6: A] :
                ( ( P @ Y6 )
               => ( ord_less_eq @ nat @ ( F2 @ Y6 ) @ ( F2 @ X3 ) ) ) ) ) ) ).

% Lattices_Big.ex_has_greatest_nat
thf(fact_235_nat__descend__induct,axiom,
    ! [N: nat,P: nat > $o,M: nat] :
      ( ! [K2: nat] :
          ( ( ord_less @ nat @ N @ K2 )
         => ( P @ K2 ) )
     => ( ! [K2: nat] :
            ( ( ord_less_eq @ nat @ K2 @ N )
           => ( ! [I3: nat] :
                  ( ( ord_less @ nat @ K2 @ I3 )
                 => ( P @ I3 ) )
             => ( P @ K2 ) ) )
       => ( P @ M ) ) ) ).

% nat_descend_induct
thf(fact_236_reals__Archimedean2,axiom,
    ! [A: $tType] :
      ( ( archim462609752435547400_field @ A )
     => ! [X: A] :
        ? [N2: nat] : ( ord_less @ A @ X @ ( semiring_1_of_nat @ A @ N2 ) ) ) ).

% reals_Archimedean2
thf(fact_237_real__arch__simple,axiom,
    ! [A: $tType] :
      ( ( archim462609752435547400_field @ A )
     => ! [X: A] :
        ? [N2: nat] : ( ord_less_eq @ A @ X @ ( semiring_1_of_nat @ A @ N2 ) ) ) ).

% real_arch_simple
thf(fact_238_zero__less__power2,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
          = ( ( A2
             != ( zero_zero @ A ) ) ) ) ) ).

% zero_less_power2
thf(fact_239_complete__interval,axiom,
    ! [A: $tType] :
      ( ( condit6923001295902523014norder @ A )
     => ! [A2: A,B2: A,P: A > $o] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( P @ A2 )
           => ( ~ ( P @ B2 )
             => ? [C3: A] :
                  ( ( ord_less_eq @ A @ A2 @ C3 )
                  & ( ord_less_eq @ A @ C3 @ B2 )
                  & ! [X5: A] :
                      ( ( ( ord_less_eq @ A @ A2 @ X5 )
                        & ( ord_less @ A @ X5 @ C3 ) )
                     => ( P @ X5 ) )
                  & ! [D3: A] :
                      ( ! [X3: A] :
                          ( ( ( ord_less_eq @ A @ A2 @ X3 )
                            & ( ord_less @ A @ X3 @ D3 ) )
                         => ( P @ X3 ) )
                     => ( ord_less_eq @ A @ D3 @ C3 ) ) ) ) ) ) ) ).

% complete_interval
thf(fact_240_pinf_I6_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [T2: A] :
        ? [Z3: A] :
        ! [X5: A] :
          ( ( ord_less @ A @ Z3 @ X5 )
         => ~ ( ord_less_eq @ A @ X5 @ T2 ) ) ) ).

% pinf(6)
thf(fact_241_pinf_I8_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [T2: A] :
        ? [Z3: A] :
        ! [X5: A] :
          ( ( ord_less @ A @ Z3 @ X5 )
         => ( ord_less_eq @ A @ T2 @ X5 ) ) ) ).

% pinf(8)
thf(fact_242_minf_I6_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [T2: A] :
        ? [Z3: A] :
        ! [X5: A] :
          ( ( ord_less @ A @ X5 @ Z3 )
         => ( ord_less_eq @ A @ X5 @ T2 ) ) ) ).

% minf(6)
thf(fact_243_minf_I8_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [T2: A] :
        ? [Z3: A] :
        ! [X5: A] :
          ( ( ord_less @ A @ X5 @ Z3 )
         => ~ ( ord_less_eq @ A @ T2 @ X5 ) ) ) ).

% minf(8)
thf(fact_244_power2__eq__iff__nonneg,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ Y )
           => ( ( ( power_power @ A @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
                = ( power_power @ A @ Y @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
              = ( X = Y ) ) ) ) ) ).

% power2_eq_iff_nonneg
thf(fact_245_bot__nat__0_Onot__eq__extremum,axiom,
    ! [A2: nat] :
      ( ( ( A2
         != ( zero_zero @ nat ) ) )
      = ( ord_less @ nat @ ( zero_zero @ nat ) @ A2 ) ) ).

% bot_nat_0.not_eq_extremum
thf(fact_246_neq0__conv,axiom,
    ! [N: nat] :
      ( ( ( N
         != ( zero_zero @ nat ) ) )
      = ( ord_less @ nat @ ( zero_zero @ nat ) @ N ) ) ).

% neq0_conv
thf(fact_247_less__nat__zero__code,axiom,
    ! [N: nat] :
      ~ ( ord_less @ nat @ N @ ( zero_zero @ nat ) ) ).

% less_nat_zero_code
thf(fact_248_bot__nat__0_Oextremum,axiom,
    ! [A2: nat] : ( ord_less_eq @ nat @ ( zero_zero @ nat ) @ A2 ) ).

% bot_nat_0.extremum
thf(fact_249_le0,axiom,
    ! [N: nat] : ( ord_less_eq @ nat @ ( zero_zero @ nat ) @ N ) ).

% le0
thf(fact_250_max__nat_Oeq__neutr__iff,axiom,
    ! [A2: nat,B2: nat] :
      ( ( ( ord_max @ nat @ A2 @ B2 )
        = ( zero_zero @ nat ) )
      = ( ( A2
          = ( zero_zero @ nat ) )
        & ( B2
          = ( zero_zero @ nat ) ) ) ) ).

% max_nat.eq_neutr_iff
thf(fact_251_max__nat_Oleft__neutral,axiom,
    ! [A2: nat] :
      ( ( ord_max @ nat @ ( zero_zero @ nat ) @ A2 )
      = A2 ) ).

% max_nat.left_neutral
thf(fact_252_max__nat_Oneutr__eq__iff,axiom,
    ! [A2: nat,B2: nat] :
      ( ( ( zero_zero @ nat )
        = ( ord_max @ nat @ A2 @ B2 ) )
      = ( ( A2
          = ( zero_zero @ nat ) )
        & ( B2
          = ( zero_zero @ nat ) ) ) ) ).

% max_nat.neutr_eq_iff
thf(fact_253_max__nat_Oright__neutral,axiom,
    ! [A2: nat] :
      ( ( ord_max @ nat @ A2 @ ( zero_zero @ nat ) )
      = A2 ) ).

% max_nat.right_neutral
thf(fact_254_max__0L,axiom,
    ! [N: nat] :
      ( ( ord_max @ nat @ ( zero_zero @ nat ) @ N )
      = N ) ).

% max_0L
thf(fact_255_max__0R,axiom,
    ! [N: nat] :
      ( ( ord_max @ nat @ N @ ( zero_zero @ nat ) )
      = N ) ).

% max_0R
thf(fact_256_i0__less,axiom,
    ! [N: extended_enat] :
      ( ( ord_less @ extended_enat @ ( zero_zero @ extended_enat ) @ N )
      = ( ( N
         != ( zero_zero @ extended_enat ) ) ) ) ).

% i0_less
thf(fact_257_of__nat__0,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ( ( semiring_1_of_nat @ A @ ( zero_zero @ nat ) )
        = ( zero_zero @ A ) ) ) ).

% of_nat_0
thf(fact_258_of__nat__0__eq__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [N: nat] :
          ( ( ( zero_zero @ A )
            = ( semiring_1_of_nat @ A @ N ) )
          = ( ( zero_zero @ nat )
            = N ) ) ) ).

% of_nat_0_eq_iff
thf(fact_259_of__nat__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [M: nat] :
          ( ( ( semiring_1_of_nat @ A @ M )
            = ( zero_zero @ A ) )
          = ( M
            = ( zero_zero @ nat ) ) ) ) ).

% of_nat_eq_0_iff
thf(fact_260_nat__zero__less__power__iff,axiom,
    ! [X: nat,N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( power_power @ nat @ X @ N ) )
      = ( ( ord_less @ nat @ ( zero_zero @ nat ) @ X )
        | ( N
          = ( zero_zero @ nat ) ) ) ) ).

% nat_zero_less_power_iff
thf(fact_261_of__nat__le__0__iff,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [M: nat] :
          ( ( ord_less_eq @ A @ ( semiring_1_of_nat @ A @ M ) @ ( zero_zero @ A ) )
          = ( M
            = ( zero_zero @ nat ) ) ) ) ).

% of_nat_le_0_iff
thf(fact_262_power__zero__numeral,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [K: num] :
          ( ( power_power @ A @ ( zero_zero @ A ) @ ( numeral_numeral @ nat @ K ) )
          = ( zero_zero @ A ) ) ) ).

% power_zero_numeral
thf(fact_263_power__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( semiri2026040879449505780visors @ A )
     => ! [A2: A,N: nat] :
          ( ( ( power_power @ A @ A2 @ N )
            = ( zero_zero @ A ) )
          = ( ( A2
              = ( zero_zero @ A ) )
            & ( ord_less @ nat @ ( zero_zero @ nat ) @ N ) ) ) ) ).

% power_eq_0_iff
thf(fact_264_max__0__1_I4_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [X: num] :
          ( ( ord_max @ A @ ( numeral_numeral @ A @ X ) @ ( zero_zero @ A ) )
          = ( numeral_numeral @ A @ X ) ) ) ).

% max_0_1(4)
thf(fact_265_max__0__1_I3_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [X: num] :
          ( ( ord_max @ A @ ( zero_zero @ A ) @ ( numeral_numeral @ A @ X ) )
          = ( numeral_numeral @ A @ X ) ) ) ).

% max_0_1(3)
thf(fact_266_power__mono__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,B2: A,N: nat] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 )
           => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
             => ( ( ord_less_eq @ A @ ( power_power @ A @ A2 @ N ) @ ( power_power @ A @ B2 @ N ) )
                = ( ord_less_eq @ A @ A2 @ B2 ) ) ) ) ) ) ).

% power_mono_iff
thf(fact_267_of__nat__0__less__iff,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [N: nat] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( semiring_1_of_nat @ A @ N ) )
          = ( ord_less @ nat @ ( zero_zero @ nat ) @ N ) ) ) ).

% of_nat_0_less_iff
thf(fact_268_zero__eq__power2,axiom,
    ! [A: $tType] :
      ( ( semiri2026040879449505780visors @ A )
     => ! [A2: A] :
          ( ( ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
            = ( zero_zero @ A ) )
          = ( A2
            = ( zero_zero @ A ) ) ) ) ).

% zero_eq_power2
thf(fact_269_of__nat__zero__less__power__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [X: nat,N: nat] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( power_power @ A @ ( semiring_1_of_nat @ A @ X ) @ N ) )
          = ( ( ord_less @ nat @ ( zero_zero @ nat ) @ X )
            | ( N
              = ( zero_zero @ nat ) ) ) ) ) ).

% of_nat_zero_less_power_iff
thf(fact_270_power2__less__eq__zero__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( zero_zero @ A ) )
          = ( A2
            = ( zero_zero @ A ) ) ) ) ).

% power2_less_eq_zero_iff
thf(fact_271_int__ops_I1_J,axiom,
    ( ( semiring_1_of_nat @ int @ ( zero_zero @ nat ) )
    = ( zero_zero @ int ) ) ).

% int_ops(1)
thf(fact_272_conj__le__cong,axiom,
    ! [X: int,X6: int,P: $o,P4: $o] :
      ( ( X = X6 )
     => ( ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ X6 )
         => ( P = P4 ) )
       => ( ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ X )
            & P )
          = ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ X6 )
            & P4 ) ) ) ) ).

% conj_le_cong
thf(fact_273_imp__le__cong,axiom,
    ! [X: int,X6: int,P: $o,P4: $o] :
      ( ( X = X6 )
     => ( ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ X6 )
         => ( P = P4 ) )
       => ( ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ X )
           => P )
          = ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ X6 )
           => P4 ) ) ) ) ).

% imp_le_cong
thf(fact_274_zero__power,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [N: nat] :
          ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
         => ( ( power_power @ A @ ( zero_zero @ A ) @ N )
            = ( zero_zero @ A ) ) ) ) ).

% zero_power
thf(fact_275_le__numeral__extra_I3_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( zero_zero @ A ) ) ) ).

% le_numeral_extra(3)
thf(fact_276_less__numeral__extra_I3_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ~ ( ord_less @ A @ ( zero_zero @ A ) @ ( zero_zero @ A ) ) ) ).

% less_numeral_extra(3)
thf(fact_277_field__lbound__gt__zero,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [D1: A,D22: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ D1 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ D22 )
           => ? [E: A] :
                ( ( ord_less @ A @ ( zero_zero @ A ) @ E )
                & ( ord_less @ A @ E @ D1 )
                & ( ord_less @ A @ E @ D22 ) ) ) ) ) ).

% field_lbound_gt_zero
thf(fact_278_zero__neq__numeral,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [N: num] :
          ( ( zero_zero @ A )
         != ( numeral_numeral @ A @ N ) ) ) ).

% zero_neq_numeral
thf(fact_279_power__not__zero,axiom,
    ! [A: $tType] :
      ( ( semiri2026040879449505780visors @ A )
     => ! [A2: A,N: nat] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( power_power @ A @ A2 @ N )
           != ( zero_zero @ A ) ) ) ) ).

% power_not_zero
thf(fact_280_bot__nat__0_Oextremum__strict,axiom,
    ! [A2: nat] :
      ~ ( ord_less @ nat @ A2 @ ( zero_zero @ nat ) ) ).

% bot_nat_0.extremum_strict
thf(fact_281_gr0I,axiom,
    ! [N: nat] :
      ( ( N
       != ( zero_zero @ nat ) )
     => ( ord_less @ nat @ ( zero_zero @ nat ) @ N ) ) ).

% gr0I
thf(fact_282_not__gr0,axiom,
    ! [N: nat] :
      ( ( ~ ( ord_less @ nat @ ( zero_zero @ nat ) @ N ) )
      = ( N
        = ( zero_zero @ nat ) ) ) ).

% not_gr0
thf(fact_283_not__less0,axiom,
    ! [N: nat] :
      ~ ( ord_less @ nat @ N @ ( zero_zero @ nat ) ) ).

% not_less0
thf(fact_284_less__zeroE,axiom,
    ! [N: nat] :
      ~ ( ord_less @ nat @ N @ ( zero_zero @ nat ) ) ).

% less_zeroE
thf(fact_285_gr__implies__not0,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ M @ N )
     => ( N
       != ( zero_zero @ nat ) ) ) ).

% gr_implies_not0
thf(fact_286_infinite__descent0,axiom,
    ! [P: nat > $o,N: nat] :
      ( ( P @ ( zero_zero @ nat ) )
     => ( ! [N2: nat] :
            ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
           => ( ~ ( P @ N2 )
             => ? [M2: nat] :
                  ( ( ord_less @ nat @ M2 @ N2 )
                  & ~ ( P @ M2 ) ) ) )
       => ( P @ N ) ) ) ).

% infinite_descent0
thf(fact_287_infinite__descent0__measure,axiom,
    ! [A: $tType,V2: A > nat,P: A > $o,X: A] :
      ( ! [X3: A] :
          ( ( ( V2 @ X3 )
            = ( zero_zero @ nat ) )
         => ( P @ X3 ) )
     => ( ! [X3: A] :
            ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( V2 @ X3 ) )
           => ( ~ ( P @ X3 )
             => ? [Y6: A] :
                  ( ( ord_less @ nat @ ( V2 @ Y6 ) @ ( V2 @ X3 ) )
                  & ~ ( P @ Y6 ) ) ) )
       => ( P @ X ) ) ) ).

% infinite_descent0_measure
thf(fact_288_less__eq__nat_Osimps_I1_J,axiom,
    ! [N: nat] : ( ord_less_eq @ nat @ ( zero_zero @ nat ) @ N ) ).

% less_eq_nat.simps(1)
thf(fact_289_bot__nat__0_Oextremum__unique,axiom,
    ! [A2: nat] :
      ( ( ord_less_eq @ nat @ A2 @ ( zero_zero @ nat ) )
      = ( A2
        = ( zero_zero @ nat ) ) ) ).

% bot_nat_0.extremum_unique
thf(fact_290_bot__nat__0_Oextremum__uniqueI,axiom,
    ! [A2: nat] :
      ( ( ord_less_eq @ nat @ A2 @ ( zero_zero @ nat ) )
     => ( A2
        = ( zero_zero @ nat ) ) ) ).

% bot_nat_0.extremum_uniqueI
thf(fact_291_le__0__eq,axiom,
    ! [N: nat] :
      ( ( ord_less_eq @ nat @ N @ ( zero_zero @ nat ) )
      = ( N
        = ( zero_zero @ nat ) ) ) ).

% le_0_eq
thf(fact_292_less__eq__int__code_I1_J,axiom,
    ord_less_eq @ int @ ( zero_zero @ int ) @ ( zero_zero @ int ) ).

% less_eq_int_code(1)
thf(fact_293_less__int__code_I1_J,axiom,
    ~ ( ord_less @ int @ ( zero_zero @ int ) @ ( zero_zero @ int ) ) ).

% less_int_code(1)
thf(fact_294_not__iless0,axiom,
    ! [N: extended_enat] :
      ~ ( ord_less @ extended_enat @ N @ ( zero_zero @ extended_enat ) ) ).

% not_iless0
thf(fact_295_i0__lb,axiom,
    ! [N: extended_enat] : ( ord_less_eq @ extended_enat @ ( zero_zero @ extended_enat ) @ N ) ).

% i0_lb
thf(fact_296_ile0__eq,axiom,
    ! [N: extended_enat] :
      ( ( ord_less_eq @ extended_enat @ N @ ( zero_zero @ extended_enat ) )
      = ( N
        = ( zero_zero @ extended_enat ) ) ) ).

% ile0_eq
thf(fact_297_power__eq__iff__eq__base,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [N: nat,A2: A,B2: A] :
          ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
           => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 )
             => ( ( ( power_power @ A @ A2 @ N )
                  = ( power_power @ A @ B2 @ N ) )
                = ( A2 = B2 ) ) ) ) ) ) ).

% power_eq_iff_eq_base
thf(fact_298_power__eq__imp__eq__base,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,N: nat,B2: A] :
          ( ( ( power_power @ A @ A2 @ N )
            = ( power_power @ A @ B2 @ N ) )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
           => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 )
             => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
               => ( A2 = B2 ) ) ) ) ) ) ).

% power_eq_imp_eq_base
thf(fact_299_zero__less__imp__eq__int,axiom,
    ! [K: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ K )
     => ? [N2: nat] :
          ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
          & ( K
            = ( semiring_1_of_nat @ int @ N2 ) ) ) ) ).

% zero_less_imp_eq_int
thf(fact_300_pos__int__cases,axiom,
    ! [K: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ K )
     => ~ ! [N2: nat] :
            ( ( K
              = ( semiring_1_of_nat @ int @ N2 ) )
           => ~ ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 ) ) ) ).

% pos_int_cases
thf(fact_301_power__strict__mono,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,B2: A,N: nat] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
           => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
             => ( ord_less @ A @ ( power_power @ A @ A2 @ N ) @ ( power_power @ A @ B2 @ N ) ) ) ) ) ) ).

% power_strict_mono
thf(fact_302_zero__le__numeral,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [N: num] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( numeral_numeral @ A @ N ) ) ) ).

% zero_le_numeral
thf(fact_303_not__numeral__le__zero,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [N: num] :
          ~ ( ord_less_eq @ A @ ( numeral_numeral @ A @ N ) @ ( zero_zero @ A ) ) ) ).

% not_numeral_le_zero
thf(fact_304_zero__less__numeral,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [N: num] : ( ord_less @ A @ ( zero_zero @ A ) @ ( numeral_numeral @ A @ N ) ) ) ).

% zero_less_numeral
thf(fact_305_not__numeral__less__zero,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [N: num] :
          ~ ( ord_less @ A @ ( numeral_numeral @ A @ N ) @ ( zero_zero @ A ) ) ) ).

% not_numeral_less_zero
thf(fact_306_power__mono,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,B2: A,N: nat] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
           => ( ord_less_eq @ A @ ( power_power @ A @ A2 @ N ) @ ( power_power @ A @ B2 @ N ) ) ) ) ) ).

% power_mono
thf(fact_307_zero__le__power,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,N: nat] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( power_power @ A @ A2 @ N ) ) ) ) ).

% zero_le_power
thf(fact_308_zero__less__power,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,N: nat] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ord_less @ A @ ( zero_zero @ A ) @ ( power_power @ A @ A2 @ N ) ) ) ) ).

% zero_less_power
thf(fact_309_of__nat__0__le__iff,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [N: nat] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( semiring_1_of_nat @ A @ N ) ) ) ).

% of_nat_0_le_iff
thf(fact_310_of__nat__less__0__iff,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [M: nat] :
          ~ ( ord_less @ A @ ( semiring_1_of_nat @ A @ M ) @ ( zero_zero @ A ) ) ) ).

% of_nat_less_0_iff
thf(fact_311_ex__least__nat__le,axiom,
    ! [P: nat > $o,N: nat] :
      ( ( P @ N )
     => ( ~ ( P @ ( zero_zero @ nat ) )
       => ? [K2: nat] :
            ( ( ord_less_eq @ nat @ K2 @ N )
            & ! [I3: nat] :
                ( ( ord_less @ nat @ I3 @ K2 )
               => ~ ( P @ I3 ) )
            & ( P @ K2 ) ) ) ) ).

% ex_least_nat_le
thf(fact_312_nat__power__less__imp__less,axiom,
    ! [I: nat,M: nat,N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ I )
     => ( ( ord_less @ nat @ ( power_power @ nat @ I @ M ) @ ( power_power @ nat @ I @ N ) )
       => ( ord_less @ nat @ M @ N ) ) ) ).

% nat_power_less_imp_less
thf(fact_313_zero__le__imp__eq__int,axiom,
    ! [K: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ K )
     => ? [N2: nat] :
          ( K
          = ( semiring_1_of_nat @ int @ N2 ) ) ) ).

% zero_le_imp_eq_int
thf(fact_314_nonneg__int__cases,axiom,
    ! [K: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ K )
     => ~ ! [N2: nat] :
            ( K
           != ( semiring_1_of_nat @ int @ N2 ) ) ) ).

% nonneg_int_cases
thf(fact_315_minf_I11_J,axiom,
    ! [C: $tType,D: $tType] :
      ( ( ord @ C )
     => ! [F4: D] :
        ? [Z3: C] :
        ! [X5: C] :
          ( ( ord_less @ C @ X5 @ Z3 )
         => ( F4 = F4 ) ) ) ).

% minf(11)
thf(fact_316_minf_I7_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [T2: A] :
        ? [Z3: A] :
        ! [X5: A] :
          ( ( ord_less @ A @ X5 @ Z3 )
         => ~ ( ord_less @ A @ T2 @ X5 ) ) ) ).

% minf(7)
thf(fact_317_minf_I5_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [T2: A] :
        ? [Z3: A] :
        ! [X5: A] :
          ( ( ord_less @ A @ X5 @ Z3 )
         => ( ord_less @ A @ X5 @ T2 ) ) ) ).

% minf(5)
thf(fact_318_minf_I4_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [T2: A] :
        ? [Z3: A] :
        ! [X5: A] :
          ( ( ord_less @ A @ X5 @ Z3 )
         => ( X5 != T2 ) ) ) ).

% minf(4)
thf(fact_319_minf_I3_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [T2: A] :
        ? [Z3: A] :
        ! [X5: A] :
          ( ( ord_less @ A @ X5 @ Z3 )
         => ( X5 != T2 ) ) ) ).

% minf(3)
thf(fact_320_minf_I2_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [P: A > $o,P4: A > $o,Q: A > $o,Q2: A > $o] :
          ( ? [Z4: A] :
            ! [X3: A] :
              ( ( ord_less @ A @ X3 @ Z4 )
             => ( ( P @ X3 )
                = ( P4 @ X3 ) ) )
         => ( ? [Z4: A] :
              ! [X3: A] :
                ( ( ord_less @ A @ X3 @ Z4 )
               => ( ( Q @ X3 )
                  = ( Q2 @ X3 ) ) )
           => ? [Z3: A] :
              ! [X5: A] :
                ( ( ord_less @ A @ X5 @ Z3 )
               => ( ( ( P @ X5 )
                    | ( Q @ X5 ) )
                  = ( ( P4 @ X5 )
                    | ( Q2 @ X5 ) ) ) ) ) ) ) ).

% minf(2)
thf(fact_321_minf_I1_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [P: A > $o,P4: A > $o,Q: A > $o,Q2: A > $o] :
          ( ? [Z4: A] :
            ! [X3: A] :
              ( ( ord_less @ A @ X3 @ Z4 )
             => ( ( P @ X3 )
                = ( P4 @ X3 ) ) )
         => ( ? [Z4: A] :
              ! [X3: A] :
                ( ( ord_less @ A @ X3 @ Z4 )
               => ( ( Q @ X3 )
                  = ( Q2 @ X3 ) ) )
           => ? [Z3: A] :
              ! [X5: A] :
                ( ( ord_less @ A @ X5 @ Z3 )
               => ( ( ( P @ X5 )
                    & ( Q @ X5 ) )
                  = ( ( P4 @ X5 )
                    & ( Q2 @ X5 ) ) ) ) ) ) ) ).

% minf(1)
thf(fact_322_pinf_I11_J,axiom,
    ! [C: $tType,D: $tType] :
      ( ( ord @ C )
     => ! [F4: D] :
        ? [Z3: C] :
        ! [X5: C] :
          ( ( ord_less @ C @ Z3 @ X5 )
         => ( F4 = F4 ) ) ) ).

% pinf(11)
thf(fact_323_pinf_I7_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [T2: A] :
        ? [Z3: A] :
        ! [X5: A] :
          ( ( ord_less @ A @ Z3 @ X5 )
         => ( ord_less @ A @ T2 @ X5 ) ) ) ).

% pinf(7)
thf(fact_324_pinf_I5_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [T2: A] :
        ? [Z3: A] :
        ! [X5: A] :
          ( ( ord_less @ A @ Z3 @ X5 )
         => ~ ( ord_less @ A @ X5 @ T2 ) ) ) ).

% pinf(5)
thf(fact_325_pinf_I4_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [T2: A] :
        ? [Z3: A] :
        ! [X5: A] :
          ( ( ord_less @ A @ Z3 @ X5 )
         => ( X5 != T2 ) ) ) ).

% pinf(4)
thf(fact_326_pinf_I3_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [T2: A] :
        ? [Z3: A] :
        ! [X5: A] :
          ( ( ord_less @ A @ Z3 @ X5 )
         => ( X5 != T2 ) ) ) ).

% pinf(3)
thf(fact_327_pinf_I2_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [P: A > $o,P4: A > $o,Q: A > $o,Q2: A > $o] :
          ( ? [Z4: A] :
            ! [X3: A] :
              ( ( ord_less @ A @ Z4 @ X3 )
             => ( ( P @ X3 )
                = ( P4 @ X3 ) ) )
         => ( ? [Z4: A] :
              ! [X3: A] :
                ( ( ord_less @ A @ Z4 @ X3 )
               => ( ( Q @ X3 )
                  = ( Q2 @ X3 ) ) )
           => ? [Z3: A] :
              ! [X5: A] :
                ( ( ord_less @ A @ Z3 @ X5 )
               => ( ( ( P @ X5 )
                    | ( Q @ X5 ) )
                  = ( ( P4 @ X5 )
                    | ( Q2 @ X5 ) ) ) ) ) ) ) ).

% pinf(2)
thf(fact_328_pinf_I1_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [P: A > $o,P4: A > $o,Q: A > $o,Q2: A > $o] :
          ( ? [Z4: A] :
            ! [X3: A] :
              ( ( ord_less @ A @ Z4 @ X3 )
             => ( ( P @ X3 )
                = ( P4 @ X3 ) ) )
         => ( ? [Z4: A] :
              ! [X3: A] :
                ( ( ord_less @ A @ Z4 @ X3 )
               => ( ( Q @ X3 )
                  = ( Q2 @ X3 ) ) )
           => ? [Z3: A] :
              ! [X5: A] :
                ( ( ord_less @ A @ Z3 @ X5 )
               => ( ( ( P @ X5 )
                    & ( Q @ X5 ) )
                  = ( ( P4 @ X5 )
                    & ( Q2 @ X5 ) ) ) ) ) ) ) ).

% pinf(1)
thf(fact_329_ex__gt__or__lt,axiom,
    ! [A: $tType] :
      ( ( condit5016429287641298734tinuum @ A )
     => ! [A2: A] :
        ? [B4: A] :
          ( ( ord_less @ A @ A2 @ B4 )
          | ( ord_less @ A @ B4 @ A2 ) ) ) ).

% ex_gt_or_lt
thf(fact_330_power__less__imp__less__base,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,N: nat,B2: A] :
          ( ( ord_less @ A @ ( power_power @ A @ A2 @ N ) @ ( power_power @ A @ B2 @ N ) )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 )
           => ( ord_less @ A @ A2 @ B2 ) ) ) ) ).

% power_less_imp_less_base
thf(fact_331_ex__has__least__nat,axiom,
    ! [A: $tType,P: A > $o,K: A,M: A > nat] :
      ( ( P @ K )
     => ? [X3: A] :
          ( ( P @ X3 )
          & ! [Y6: A] :
              ( ( P @ Y6 )
             => ( ord_less_eq @ nat @ ( M @ X3 ) @ ( M @ Y6 ) ) ) ) ) ).

% ex_has_least_nat
thf(fact_332_zero__power2,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ( ( power_power @ A @ ( zero_zero @ A ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
        = ( zero_zero @ A ) ) ) ).

% zero_power2
thf(fact_333_zero__le__power2,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ).

% zero_le_power2
thf(fact_334_power2__eq__imp__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [X: A,Y: A] :
          ( ( ( power_power @ A @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
            = ( power_power @ A @ Y @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X )
           => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ Y )
             => ( X = Y ) ) ) ) ) ).

% power2_eq_imp_eq
thf(fact_335_power2__le__imp__le,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ A @ ( power_power @ A @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ A @ Y @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ Y )
           => ( ord_less_eq @ A @ X @ Y ) ) ) ) ).

% power2_le_imp_le
thf(fact_336_power2__less__0,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A] :
          ~ ( ord_less @ A @ ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( zero_zero @ A ) ) ) ).

% power2_less_0
thf(fact_337_power2__less__imp__less,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less @ A @ ( power_power @ A @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ A @ Y @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ Y )
           => ( ord_less @ A @ X @ Y ) ) ) ) ).

% power2_less_imp_less
thf(fact_338_not__gr__zero,axiom,
    ! [A: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ! [N: A] :
          ( ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ N ) )
          = ( N
            = ( zero_zero @ A ) ) ) ) ).

% not_gr_zero
thf(fact_339_le__zero__eq,axiom,
    ! [A: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ! [N: A] :
          ( ( ord_less_eq @ A @ N @ ( zero_zero @ A ) )
          = ( N
            = ( zero_zero @ A ) ) ) ) ).

% le_zero_eq
thf(fact_340_not__exp__less__eq__0__int,axiom,
    ! [N: nat] :
      ~ ( ord_less_eq @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) @ ( zero_zero @ int ) ) ).

% not_exp_less_eq_0_int
thf(fact_341_pos2,axiom,
    ord_less @ nat @ ( zero_zero @ nat ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ).

% pos2
thf(fact_342_realpow__pos__nth__unique,axiom,
    ! [N: nat,A2: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
       => ? [X3: real] :
            ( ( ord_less @ real @ ( zero_zero @ real ) @ X3 )
            & ( ( power_power @ real @ X3 @ N )
              = A2 )
            & ! [Y6: real] :
                ( ( ( ord_less @ real @ ( zero_zero @ real ) @ Y6 )
                  & ( ( power_power @ real @ Y6 @ N )
                    = A2 ) )
               => ( Y6 = X3 ) ) ) ) ) ).

% realpow_pos_nth_unique
thf(fact_343_realpow__pos__nth,axiom,
    ! [N: nat,A2: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
       => ? [R: real] :
            ( ( ord_less @ real @ ( zero_zero @ real ) @ R )
            & ( ( power_power @ real @ R @ N )
              = A2 ) ) ) ) ).

% realpow_pos_nth
thf(fact_344_gr__zeroI,axiom,
    ! [A: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ! [N: A] :
          ( ( N
           != ( zero_zero @ A ) )
         => ( ord_less @ A @ ( zero_zero @ A ) @ N ) ) ) ).

% gr_zeroI
thf(fact_345_not__less__zero,axiom,
    ! [A: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ! [N: A] :
          ~ ( ord_less @ A @ N @ ( zero_zero @ A ) ) ) ).

% not_less_zero
thf(fact_346_gr__implies__not__zero,axiom,
    ! [A: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ! [M: A,N: A] :
          ( ( ord_less @ A @ M @ N )
         => ( N
           != ( zero_zero @ A ) ) ) ) ).

% gr_implies_not_zero
thf(fact_347_zero__less__iff__neq__zero,axiom,
    ! [A: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ! [N: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ N )
          = ( ( N
             != ( zero_zero @ A ) ) ) ) ) ).

% zero_less_iff_neq_zero
thf(fact_348_max__enat__simps_I2_J,axiom,
    ! [Q3: extended_enat] :
      ( ( ord_max @ extended_enat @ Q3 @ ( zero_zero @ extended_enat ) )
      = Q3 ) ).

% max_enat_simps(2)
thf(fact_349_max__enat__simps_I3_J,axiom,
    ! [Q3: extended_enat] :
      ( ( ord_max @ extended_enat @ ( zero_zero @ extended_enat ) @ Q3 )
      = Q3 ) ).

% max_enat_simps(3)
thf(fact_350_zero__reorient,axiom,
    ! [A: $tType] :
      ( ( zero @ A )
     => ! [X: A] :
          ( ( ( zero_zero @ A )
            = X )
          = ( X
            = ( zero_zero @ A ) ) ) ) ).

% zero_reorient
thf(fact_351_zero__le,axiom,
    ! [A: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ! [X: A] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ X ) ) ).

% zero_le
thf(fact_352_log2__of__power__le,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ M @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M )
       => ( ord_less_eq @ real @ ( log2 @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( semiring_1_of_nat @ real @ M ) ) @ ( semiring_1_of_nat @ real @ N ) ) ) ) ).

% log2_of_power_le
thf(fact_353_numeral__power__le__nat__cancel__iff,axiom,
    ! [X: num,N: nat,A2: int] :
      ( ( ord_less_eq @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ X ) @ N ) @ ( nat2 @ A2 ) )
      = ( ord_less_eq @ int @ ( power_power @ int @ ( numeral_numeral @ int @ X ) @ N ) @ A2 ) ) ).

% numeral_power_le_nat_cancel_iff
thf(fact_354_nat__le__numeral__power__cancel__iff,axiom,
    ! [A2: int,X: num,N: nat] :
      ( ( ord_less_eq @ nat @ ( nat2 @ A2 ) @ ( power_power @ nat @ ( numeral_numeral @ nat @ X ) @ N ) )
      = ( ord_less_eq @ int @ A2 @ ( power_power @ int @ ( numeral_numeral @ int @ X ) @ N ) ) ) ).

% nat_le_numeral_power_cancel_iff
thf(fact_355_numeral__power__less__nat__cancel__iff,axiom,
    ! [X: num,N: nat,A2: int] :
      ( ( ord_less @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ X ) @ N ) @ ( nat2 @ A2 ) )
      = ( ord_less @ int @ ( power_power @ int @ ( numeral_numeral @ int @ X ) @ N ) @ A2 ) ) ).

% numeral_power_less_nat_cancel_iff
thf(fact_356_nat__less__numeral__power__cancel__iff,axiom,
    ! [A2: int,X: num,N: nat] :
      ( ( ord_less @ nat @ ( nat2 @ A2 ) @ ( power_power @ nat @ ( numeral_numeral @ nat @ X ) @ N ) )
      = ( ord_less @ int @ A2 @ ( power_power @ int @ ( numeral_numeral @ int @ X ) @ N ) ) ) ).

% nat_less_numeral_power_cancel_iff
thf(fact_357_of__int__less__numeral__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: int,X: num,N: nat] :
          ( ( ord_less @ A @ ( ring_1_of_int @ A @ A2 ) @ ( power_power @ A @ ( numeral_numeral @ A @ X ) @ N ) )
          = ( ord_less @ int @ A2 @ ( power_power @ int @ ( numeral_numeral @ int @ X ) @ N ) ) ) ) ).

% of_int_less_numeral_power_cancel_iff
thf(fact_358_numeral__power__less__of__int__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: num,N: nat,A2: int] :
          ( ( ord_less @ A @ ( power_power @ A @ ( numeral_numeral @ A @ X ) @ N ) @ ( ring_1_of_int @ A @ A2 ) )
          = ( ord_less @ int @ ( power_power @ int @ ( numeral_numeral @ int @ X ) @ N ) @ A2 ) ) ) ).

% numeral_power_less_of_int_cancel_iff
thf(fact_359_of__int__le__numeral__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: int,X: num,N: nat] :
          ( ( ord_less_eq @ A @ ( ring_1_of_int @ A @ A2 ) @ ( power_power @ A @ ( numeral_numeral @ A @ X ) @ N ) )
          = ( ord_less_eq @ int @ A2 @ ( power_power @ int @ ( numeral_numeral @ int @ X ) @ N ) ) ) ) ).

% of_int_le_numeral_power_cancel_iff
thf(fact_360_numeral__power__le__of__int__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: num,N: nat,A2: int] :
          ( ( ord_less_eq @ A @ ( power_power @ A @ ( numeral_numeral @ A @ X ) @ N ) @ ( ring_1_of_int @ A @ A2 ) )
          = ( ord_less_eq @ int @ ( power_power @ int @ ( numeral_numeral @ int @ X ) @ N ) @ A2 ) ) ) ).

% numeral_power_le_of_int_cancel_iff
thf(fact_361_take__bit__int__eq__self,axiom,
    ! [K: int,N: nat] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ K )
     => ( ( ord_less @ int @ K @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) )
       => ( ( bit_se2584673776208193580ke_bit @ int @ N @ K )
          = K ) ) ) ).

% take_bit_int_eq_self
thf(fact_362_take__bit__int__eq__self__iff,axiom,
    ! [N: nat,K: int] :
      ( ( ( bit_se2584673776208193580ke_bit @ int @ N @ K )
        = K )
      = ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ K )
        & ( ord_less @ int @ K @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) ) ) ) ).

% take_bit_int_eq_self_iff
thf(fact_363_of__int__eq__iff,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [W: int,Z: int] :
          ( ( ( ring_1_of_int @ A @ W )
            = ( ring_1_of_int @ A @ Z ) )
          = ( W = Z ) ) ) ).

% of_int_eq_iff
thf(fact_364_take__bit__of__0,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat] :
          ( ( bit_se2584673776208193580ke_bit @ A @ N @ ( zero_zero @ A ) )
          = ( zero_zero @ A ) ) ) ).

% take_bit_of_0
thf(fact_365_nat__int,axiom,
    ! [N: nat] :
      ( ( nat2 @ ( semiring_1_of_nat @ int @ N ) )
      = N ) ).

% nat_int
thf(fact_366_of__int__0,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ( ( ring_1_of_int @ A @ ( zero_zero @ int ) )
        = ( zero_zero @ A ) ) ) ).

% of_int_0
thf(fact_367_of__int__0__eq__iff,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [Z: int] :
          ( ( ( zero_zero @ A )
            = ( ring_1_of_int @ A @ Z ) )
          = ( Z
            = ( zero_zero @ int ) ) ) ) ).

% of_int_0_eq_iff
thf(fact_368_of__int__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [Z: int] :
          ( ( ( ring_1_of_int @ A @ Z )
            = ( zero_zero @ A ) )
          = ( Z
            = ( zero_zero @ int ) ) ) ) ).

% of_int_eq_0_iff
thf(fact_369_take__bit__0,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A] :
          ( ( bit_se2584673776208193580ke_bit @ A @ ( zero_zero @ nat ) @ A2 )
          = ( zero_zero @ A ) ) ) ).

% take_bit_0
thf(fact_370_of__int__le__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [W: int,Z: int] :
          ( ( ord_less_eq @ A @ ( ring_1_of_int @ A @ W ) @ ( ring_1_of_int @ A @ Z ) )
          = ( ord_less_eq @ int @ W @ Z ) ) ) ).

% of_int_le_iff
thf(fact_371_of__int__numeral,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [K: num] :
          ( ( ring_1_of_int @ A @ ( numeral_numeral @ int @ K ) )
          = ( numeral_numeral @ A @ K ) ) ) ).

% of_int_numeral
thf(fact_372_of__int__eq__numeral__iff,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [Z: int,N: num] :
          ( ( ( ring_1_of_int @ A @ Z )
            = ( numeral_numeral @ A @ N ) )
          = ( Z
            = ( numeral_numeral @ int @ N ) ) ) ) ).

% of_int_eq_numeral_iff
thf(fact_373_of__int__less__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [W: int,Z: int] :
          ( ( ord_less @ A @ ( ring_1_of_int @ A @ W ) @ ( ring_1_of_int @ A @ Z ) )
          = ( ord_less @ int @ W @ Z ) ) ) ).

% of_int_less_iff
thf(fact_374_nat__numeral,axiom,
    ! [K: num] :
      ( ( nat2 @ ( numeral_numeral @ int @ K ) )
      = ( numeral_numeral @ nat @ K ) ) ).

% nat_numeral
thf(fact_375_of__int__of__nat__eq,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [N: nat] :
          ( ( ring_1_of_int @ A @ ( semiring_1_of_nat @ int @ N ) )
          = ( semiring_1_of_nat @ A @ N ) ) ) ).

% of_int_of_nat_eq
thf(fact_376_of__int__power,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [Z: int,N: nat] :
          ( ( ring_1_of_int @ A @ ( power_power @ int @ Z @ N ) )
          = ( power_power @ A @ ( ring_1_of_int @ A @ Z ) @ N ) ) ) ).

% of_int_power
thf(fact_377_of__int__eq__of__int__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [B2: int,W: nat,X: int] :
          ( ( ( power_power @ A @ ( ring_1_of_int @ A @ B2 ) @ W )
            = ( ring_1_of_int @ A @ X ) )
          = ( ( power_power @ int @ B2 @ W )
            = X ) ) ) ).

% of_int_eq_of_int_power_cancel_iff
thf(fact_378_of__int__power__eq__of__int__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [X: int,B2: int,W: nat] :
          ( ( ( ring_1_of_int @ A @ X )
            = ( power_power @ A @ ( ring_1_of_int @ A @ B2 ) @ W ) )
          = ( X
            = ( power_power @ int @ B2 @ W ) ) ) ) ).

% of_int_power_eq_of_int_cancel_iff
thf(fact_379_nat__le__0,axiom,
    ! [Z: int] :
      ( ( ord_less_eq @ int @ Z @ ( zero_zero @ int ) )
     => ( ( nat2 @ Z )
        = ( zero_zero @ nat ) ) ) ).

% nat_le_0
thf(fact_380_nat__0__iff,axiom,
    ! [I: int] :
      ( ( ( nat2 @ I )
        = ( zero_zero @ nat ) )
      = ( ord_less_eq @ int @ I @ ( zero_zero @ int ) ) ) ).

% nat_0_iff
thf(fact_381_zless__nat__conj,axiom,
    ! [W: int,Z: int] :
      ( ( ord_less @ nat @ ( nat2 @ W ) @ ( nat2 @ Z ) )
      = ( ( ord_less @ int @ ( zero_zero @ int ) @ Z )
        & ( ord_less @ int @ W @ Z ) ) ) ).

% zless_nat_conj
thf(fact_382_int__nat__eq,axiom,
    ! [Z: int] :
      ( ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Z )
       => ( ( semiring_1_of_nat @ int @ ( nat2 @ Z ) )
          = Z ) )
      & ( ~ ( ord_less_eq @ int @ ( zero_zero @ int ) @ Z )
       => ( ( semiring_1_of_nat @ int @ ( nat2 @ Z ) )
          = ( zero_zero @ int ) ) ) ) ).

% int_nat_eq
thf(fact_383_of__nat__nat__take__bit__eq,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [N: nat,K: int] :
          ( ( semiring_1_of_nat @ A @ ( nat2 @ ( bit_se2584673776208193580ke_bit @ int @ N @ K ) ) )
          = ( ring_1_of_int @ A @ ( bit_se2584673776208193580ke_bit @ int @ N @ K ) ) ) ) ).

% of_nat_nat_take_bit_eq
thf(fact_384_of__int__le__0__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [Z: int] :
          ( ( ord_less_eq @ A @ ( ring_1_of_int @ A @ Z ) @ ( zero_zero @ A ) )
          = ( ord_less_eq @ int @ Z @ ( zero_zero @ int ) ) ) ) ).

% of_int_le_0_iff
thf(fact_385_of__int__0__le__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [Z: int] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( ring_1_of_int @ A @ Z ) )
          = ( ord_less_eq @ int @ ( zero_zero @ int ) @ Z ) ) ) ).

% of_int_0_le_iff
thf(fact_386_of__int__less__0__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [Z: int] :
          ( ( ord_less @ A @ ( ring_1_of_int @ A @ Z ) @ ( zero_zero @ A ) )
          = ( ord_less @ int @ Z @ ( zero_zero @ int ) ) ) ) ).

% of_int_less_0_iff
thf(fact_387_of__int__0__less__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [Z: int] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( ring_1_of_int @ A @ Z ) )
          = ( ord_less @ int @ ( zero_zero @ int ) @ Z ) ) ) ).

% of_int_0_less_iff
thf(fact_388_of__int__le__numeral__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [Z: int,N: num] :
          ( ( ord_less_eq @ A @ ( ring_1_of_int @ A @ Z ) @ ( numeral_numeral @ A @ N ) )
          = ( ord_less_eq @ int @ Z @ ( numeral_numeral @ int @ N ) ) ) ) ).

% of_int_le_numeral_iff
thf(fact_389_of__int__numeral__le__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N: num,Z: int] :
          ( ( ord_less_eq @ A @ ( numeral_numeral @ A @ N ) @ ( ring_1_of_int @ A @ Z ) )
          = ( ord_less_eq @ int @ ( numeral_numeral @ int @ N ) @ Z ) ) ) ).

% of_int_numeral_le_iff
thf(fact_390_of__int__less__numeral__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [Z: int,N: num] :
          ( ( ord_less @ A @ ( ring_1_of_int @ A @ Z ) @ ( numeral_numeral @ A @ N ) )
          = ( ord_less @ int @ Z @ ( numeral_numeral @ int @ N ) ) ) ) ).

% of_int_less_numeral_iff
thf(fact_391_of__int__numeral__less__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N: num,Z: int] :
          ( ( ord_less @ A @ ( numeral_numeral @ A @ N ) @ ( ring_1_of_int @ A @ Z ) )
          = ( ord_less @ int @ ( numeral_numeral @ int @ N ) @ Z ) ) ) ).

% of_int_numeral_less_iff
thf(fact_392_zero__less__nat__eq,axiom,
    ! [Z: int] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( nat2 @ Z ) )
      = ( ord_less @ int @ ( zero_zero @ int ) @ Z ) ) ).

% zero_less_nat_eq
thf(fact_393_of__int__le__of__int__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [B2: int,W: nat,X: int] :
          ( ( ord_less_eq @ A @ ( power_power @ A @ ( ring_1_of_int @ A @ B2 ) @ W ) @ ( ring_1_of_int @ A @ X ) )
          = ( ord_less_eq @ int @ ( power_power @ int @ B2 @ W ) @ X ) ) ) ).

% of_int_le_of_int_power_cancel_iff
thf(fact_394_of__int__power__le__of__int__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: int,B2: int,W: nat] :
          ( ( ord_less_eq @ A @ ( ring_1_of_int @ A @ X ) @ ( power_power @ A @ ( ring_1_of_int @ A @ B2 ) @ W ) )
          = ( ord_less_eq @ int @ X @ ( power_power @ int @ B2 @ W ) ) ) ) ).

% of_int_power_le_of_int_cancel_iff
thf(fact_395_numeral__power__eq__of__int__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [X: num,N: nat,Y: int] :
          ( ( ( power_power @ A @ ( numeral_numeral @ A @ X ) @ N )
            = ( ring_1_of_int @ A @ Y ) )
          = ( ( power_power @ int @ ( numeral_numeral @ int @ X ) @ N )
            = Y ) ) ) ).

% numeral_power_eq_of_int_cancel_iff
thf(fact_396_of__int__eq__numeral__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [Y: int,X: num,N: nat] :
          ( ( ( ring_1_of_int @ A @ Y )
            = ( power_power @ A @ ( numeral_numeral @ A @ X ) @ N ) )
          = ( Y
            = ( power_power @ int @ ( numeral_numeral @ int @ X ) @ N ) ) ) ) ).

% of_int_eq_numeral_power_cancel_iff
thf(fact_397_of__int__less__of__int__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [B2: int,W: nat,X: int] :
          ( ( ord_less @ A @ ( power_power @ A @ ( ring_1_of_int @ A @ B2 ) @ W ) @ ( ring_1_of_int @ A @ X ) )
          = ( ord_less @ int @ ( power_power @ int @ B2 @ W ) @ X ) ) ) ).

% of_int_less_of_int_power_cancel_iff
thf(fact_398_of__int__power__less__of__int__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: int,B2: int,W: nat] :
          ( ( ord_less @ A @ ( ring_1_of_int @ A @ X ) @ ( power_power @ A @ ( ring_1_of_int @ A @ B2 ) @ W ) )
          = ( ord_less @ int @ X @ ( power_power @ int @ B2 @ W ) ) ) ) ).

% of_int_power_less_of_int_cancel_iff
thf(fact_399_of__nat__nat,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [Z: int] :
          ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Z )
         => ( ( semiring_1_of_nat @ A @ ( nat2 @ Z ) )
            = ( ring_1_of_int @ A @ Z ) ) ) ) ).

% of_nat_nat
thf(fact_400_nat__eq__numeral__power__cancel__iff,axiom,
    ! [Y: int,X: num,N: nat] :
      ( ( ( nat2 @ Y )
        = ( power_power @ nat @ ( numeral_numeral @ nat @ X ) @ N ) )
      = ( Y
        = ( power_power @ int @ ( numeral_numeral @ int @ X ) @ N ) ) ) ).

% nat_eq_numeral_power_cancel_iff
thf(fact_401_numeral__power__eq__nat__cancel__iff,axiom,
    ! [X: num,N: nat,Y: int] :
      ( ( ( power_power @ nat @ ( numeral_numeral @ nat @ X ) @ N )
        = ( nat2 @ Y ) )
      = ( ( power_power @ int @ ( numeral_numeral @ int @ X ) @ N )
        = Y ) ) ).

% numeral_power_eq_nat_cancel_iff
thf(fact_402_take__bit__of__int,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N: nat,K: int] :
          ( ( bit_se2584673776208193580ke_bit @ A @ N @ ( ring_1_of_int @ A @ K ) )
          = ( ring_1_of_int @ A @ ( bit_se2584673776208193580ke_bit @ int @ N @ K ) ) ) ) ).

% take_bit_of_int
thf(fact_403_take__bit__of__nat,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,M: nat] :
          ( ( bit_se2584673776208193580ke_bit @ A @ N @ ( semiring_1_of_nat @ A @ M ) )
          = ( semiring_1_of_nat @ A @ ( bit_se2584673776208193580ke_bit @ nat @ N @ M ) ) ) ) ).

% take_bit_of_nat
thf(fact_404_take__bit__tightened,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,A2: A,B2: A,M: nat] :
          ( ( ( bit_se2584673776208193580ke_bit @ A @ N @ A2 )
            = ( bit_se2584673776208193580ke_bit @ A @ N @ B2 ) )
         => ( ( ord_less_eq @ nat @ M @ N )
           => ( ( bit_se2584673776208193580ke_bit @ A @ M @ A2 )
              = ( bit_se2584673776208193580ke_bit @ A @ M @ B2 ) ) ) ) ) ).

% take_bit_tightened
thf(fact_405_ex__le__of__int,axiom,
    ! [A: $tType] :
      ( ( archim462609752435547400_field @ A )
     => ! [X: A] :
        ? [Z3: int] : ( ord_less_eq @ A @ X @ ( ring_1_of_int @ A @ Z3 ) ) ) ).

% ex_le_of_int
thf(fact_406_ex__less__of__int,axiom,
    ! [A: $tType] :
      ( ( archim462609752435547400_field @ A )
     => ! [X: A] :
        ? [Z3: int] : ( ord_less @ A @ X @ ( ring_1_of_int @ A @ Z3 ) ) ) ).

% ex_less_of_int
thf(fact_407_ex__of__int__less,axiom,
    ! [A: $tType] :
      ( ( archim462609752435547400_field @ A )
     => ! [X: A] :
        ? [Z3: int] : ( ord_less @ A @ ( ring_1_of_int @ A @ Z3 ) @ X ) ) ).

% ex_of_int_less
thf(fact_408_of__int__max,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: int,Y: int] :
          ( ( ring_1_of_int @ A @ ( ord_max @ int @ X @ Y ) )
          = ( ord_max @ A @ ( ring_1_of_int @ A @ X ) @ ( ring_1_of_int @ A @ Y ) ) ) ) ).

% of_int_max
thf(fact_409_nat__zero__as__int,axiom,
    ( ( zero_zero @ nat )
    = ( nat2 @ ( zero_zero @ int ) ) ) ).

% nat_zero_as_int
thf(fact_410_take__bit__tightened__less__eq__int,axiom,
    ! [M: nat,N: nat,K: int] :
      ( ( ord_less_eq @ nat @ M @ N )
     => ( ord_less_eq @ int @ ( bit_se2584673776208193580ke_bit @ int @ M @ K ) @ ( bit_se2584673776208193580ke_bit @ int @ N @ K ) ) ) ).

% take_bit_tightened_less_eq_int
thf(fact_411_nat__numeral__as__int,axiom,
    ( ( numeral_numeral @ nat )
    = ( ^ [I4: num] : ( nat2 @ ( numeral_numeral @ int @ I4 ) ) ) ) ).

% nat_numeral_as_int
thf(fact_412_take__bit__nonnegative,axiom,
    ! [N: nat,K: int] : ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( bit_se2584673776208193580ke_bit @ int @ N @ K ) ) ).

% take_bit_nonnegative
thf(fact_413_take__bit__int__less__eq__self__iff,axiom,
    ! [N: nat,K: int] :
      ( ( ord_less_eq @ int @ ( bit_se2584673776208193580ke_bit @ int @ N @ K ) @ K )
      = ( ord_less_eq @ int @ ( zero_zero @ int ) @ K ) ) ).

% take_bit_int_less_eq_self_iff
thf(fact_414_not__take__bit__negative,axiom,
    ! [N: nat,K: int] :
      ~ ( ord_less @ int @ ( bit_se2584673776208193580ke_bit @ int @ N @ K ) @ ( zero_zero @ int ) ) ).

% not_take_bit_negative
thf(fact_415_take__bit__int__greater__self__iff,axiom,
    ! [K: int,N: nat] :
      ( ( ord_less @ int @ K @ ( bit_se2584673776208193580ke_bit @ int @ N @ K ) )
      = ( ord_less @ int @ K @ ( zero_zero @ int ) ) ) ).

% take_bit_int_greater_self_iff
thf(fact_416_nat__mono,axiom,
    ! [X: int,Y: int] :
      ( ( ord_less_eq @ int @ X @ Y )
     => ( ord_less_eq @ nat @ ( nat2 @ X ) @ ( nat2 @ Y ) ) ) ).

% nat_mono
thf(fact_417_eq__nat__nat__iff,axiom,
    ! [Z: int,Z5: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Z )
     => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Z5 )
       => ( ( ( nat2 @ Z )
            = ( nat2 @ Z5 ) )
          = ( Z = Z5 ) ) ) ) ).

% eq_nat_nat_iff
thf(fact_418_all__nat,axiom,
    ( ( ^ [P2: nat > $o] :
        ! [X4: nat] : ( P2 @ X4 ) )
    = ( ^ [P3: nat > $o] :
        ! [X2: int] :
          ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ X2 )
         => ( P3 @ ( nat2 @ X2 ) ) ) ) ) ).

% all_nat
thf(fact_419_ex__nat,axiom,
    ( ( ^ [P2: nat > $o] :
        ? [X4: nat] : ( P2 @ X4 ) )
    = ( ^ [P3: nat > $o] :
        ? [X2: int] :
          ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ X2 )
          & ( P3 @ ( nat2 @ X2 ) ) ) ) ) ).

% ex_nat
thf(fact_420_nat__mono__iff,axiom,
    ! [Z: int,W: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ Z )
     => ( ( ord_less @ nat @ ( nat2 @ W ) @ ( nat2 @ Z ) )
        = ( ord_less @ int @ W @ Z ) ) ) ).

% nat_mono_iff
thf(fact_421_zless__nat__eq__int__zless,axiom,
    ! [M: nat,Z: int] :
      ( ( ord_less @ nat @ M @ ( nat2 @ Z ) )
      = ( ord_less @ int @ ( semiring_1_of_nat @ int @ M ) @ Z ) ) ).

% zless_nat_eq_int_zless
thf(fact_422_nat__le__iff,axiom,
    ! [X: int,N: nat] :
      ( ( ord_less_eq @ nat @ ( nat2 @ X ) @ N )
      = ( ord_less_eq @ int @ X @ ( semiring_1_of_nat @ int @ N ) ) ) ).

% nat_le_iff
thf(fact_423_int__eq__iff,axiom,
    ! [M: nat,Z: int] :
      ( ( ( semiring_1_of_nat @ int @ M )
        = Z )
      = ( ( M
          = ( nat2 @ Z ) )
        & ( ord_less_eq @ int @ ( zero_zero @ int ) @ Z ) ) ) ).

% int_eq_iff
thf(fact_424_nat__0__le,axiom,
    ! [Z: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Z )
     => ( ( semiring_1_of_nat @ int @ ( nat2 @ Z ) )
        = Z ) ) ).

% nat_0_le
thf(fact_425_of__int__nonneg,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [Z: int] :
          ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Z )
         => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( ring_1_of_int @ A @ Z ) ) ) ) ).

% of_int_nonneg
thf(fact_426_of__int__pos,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [Z: int] :
          ( ( ord_less @ int @ ( zero_zero @ int ) @ Z )
         => ( ord_less @ A @ ( zero_zero @ A ) @ ( ring_1_of_int @ A @ Z ) ) ) ) ).

% of_int_pos
thf(fact_427_nat__less__eq__zless,axiom,
    ! [W: int,Z: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ W )
     => ( ( ord_less @ nat @ ( nat2 @ W ) @ ( nat2 @ Z ) )
        = ( ord_less @ int @ W @ Z ) ) ) ).

% nat_less_eq_zless
thf(fact_428_of__nat__less__of__int__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N: nat,X: int] :
          ( ( ord_less @ A @ ( semiring_1_of_nat @ A @ N ) @ ( ring_1_of_int @ A @ X ) )
          = ( ord_less @ int @ ( semiring_1_of_nat @ int @ N ) @ X ) ) ) ).

% of_nat_less_of_int_iff
thf(fact_429_nat__le__eq__zle,axiom,
    ! [W: int,Z: int] :
      ( ( ( ord_less @ int @ ( zero_zero @ int ) @ W )
        | ( ord_less_eq @ int @ ( zero_zero @ int ) @ Z ) )
     => ( ( ord_less_eq @ nat @ ( nat2 @ W ) @ ( nat2 @ Z ) )
        = ( ord_less_eq @ int @ W @ Z ) ) ) ).

% nat_le_eq_zle
thf(fact_430_nat__eq__iff2,axiom,
    ! [M: nat,W: int] :
      ( ( M
        = ( nat2 @ W ) )
      = ( ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ W )
         => ( W
            = ( semiring_1_of_nat @ int @ M ) ) )
        & ( ~ ( ord_less_eq @ int @ ( zero_zero @ int ) @ W )
         => ( M
            = ( zero_zero @ nat ) ) ) ) ) ).

% nat_eq_iff2
thf(fact_431_nat__eq__iff,axiom,
    ! [W: int,M: nat] :
      ( ( ( nat2 @ W )
        = M )
      = ( ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ W )
         => ( W
            = ( semiring_1_of_nat @ int @ M ) ) )
        & ( ~ ( ord_less_eq @ int @ ( zero_zero @ int ) @ W )
         => ( M
            = ( zero_zero @ nat ) ) ) ) ) ).

% nat_eq_iff
thf(fact_432_split__nat,axiom,
    ! [P: nat > $o,I: int] :
      ( ( P @ ( nat2 @ I ) )
      = ( ! [N3: nat] :
            ( ( I
              = ( semiring_1_of_nat @ int @ N3 ) )
           => ( P @ N3 ) )
        & ( ( ord_less @ int @ I @ ( zero_zero @ int ) )
         => ( P @ ( zero_zero @ nat ) ) ) ) ) ).

% split_nat
thf(fact_433_le__nat__iff,axiom,
    ! [K: int,N: nat] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ K )
     => ( ( ord_less_eq @ nat @ N @ ( nat2 @ K ) )
        = ( ord_less_eq @ int @ ( semiring_1_of_nat @ int @ N ) @ K ) ) ) ).

% le_nat_iff
thf(fact_434_nat__power__eq,axiom,
    ! [Z: int,N: nat] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Z )
     => ( ( nat2 @ ( power_power @ int @ Z @ N ) )
        = ( power_power @ nat @ ( nat2 @ Z ) @ N ) ) ) ).

% nat_power_eq
thf(fact_435_log2__of__power__eq,axiom,
    ! [M: nat,N: nat] :
      ( ( M
        = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) )
     => ( ( semiring_1_of_nat @ real @ N )
        = ( log2 @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( semiring_1_of_nat @ real @ M ) ) ) ) ).

% log2_of_power_eq
thf(fact_436_take__bit__int__less__exp,axiom,
    ! [N: nat,K: int] : ( ord_less @ int @ ( bit_se2584673776208193580ke_bit @ int @ N @ K ) @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) ) ).

% take_bit_int_less_exp
thf(fact_437_nat__less__iff,axiom,
    ! [W: int,M: nat] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ W )
     => ( ( ord_less @ nat @ ( nat2 @ W ) @ M )
        = ( ord_less @ int @ W @ ( semiring_1_of_nat @ int @ M ) ) ) ) ).

% nat_less_iff
thf(fact_438_less__log2__of__power,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) @ M )
     => ( ord_less @ real @ ( semiring_1_of_nat @ real @ N ) @ ( log2 @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( semiring_1_of_nat @ real @ M ) ) ) ) ).

% less_log2_of_power
thf(fact_439_le__log2__of__power,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less_eq @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) @ M )
     => ( ord_less_eq @ real @ ( semiring_1_of_nat @ real @ N ) @ ( log2 @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( semiring_1_of_nat @ real @ M ) ) ) ) ).

% le_log2_of_power
thf(fact_440_take__bit__int__greater__eq__self__iff,axiom,
    ! [K: int,N: nat] :
      ( ( ord_less_eq @ int @ K @ ( bit_se2584673776208193580ke_bit @ int @ N @ K ) )
      = ( ord_less @ int @ K @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) ) ) ).

% take_bit_int_greater_eq_self_iff
thf(fact_441_take__bit__int__less__self__iff,axiom,
    ! [N: nat,K: int] :
      ( ( ord_less @ int @ ( bit_se2584673776208193580ke_bit @ int @ N @ K ) @ K )
      = ( ord_less_eq @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) @ K ) ) ).

% take_bit_int_less_self_iff
thf(fact_442_log2__of__power__less,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ M @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M )
       => ( ord_less @ real @ ( log2 @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( semiring_1_of_nat @ real @ M ) ) @ ( semiring_1_of_nat @ real @ N ) ) ) ) ).

% log2_of_power_less
thf(fact_443_artanh__0,axiom,
    ! [A: $tType] :
      ( ( ( real_V3459762299906320749_field @ A )
        & ( ln @ A ) )
     => ( ( artanh @ A @ ( zero_zero @ A ) )
        = ( zero_zero @ A ) ) ) ).

% artanh_0
thf(fact_444_arsinh__0,axiom,
    ! [A: $tType] :
      ( ( ln @ A )
     => ( ( arsinh @ A @ ( zero_zero @ A ) )
        = ( zero_zero @ A ) ) ) ).

% arsinh_0
thf(fact_445_take__bit__int__greater__eq,axiom,
    ! [K: int,N: nat] :
      ( ( ord_less @ int @ K @ ( zero_zero @ int ) )
     => ( ord_less_eq @ int @ ( plus_plus @ int @ K @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) ) @ ( bit_se2584673776208193580ke_bit @ int @ N @ K ) ) ) ).

% take_bit_int_greater_eq
thf(fact_446_take__bit__int__less__eq,axiom,
    ! [N: nat,K: int] :
      ( ( ord_less_eq @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) @ K )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
       => ( ord_less_eq @ int @ ( bit_se2584673776208193580ke_bit @ int @ N @ K ) @ ( minus_minus @ int @ K @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) ) ) ) ) ).

% take_bit_int_less_eq
thf(fact_447_log__of__power__le,axiom,
    ! [M: nat,B2: real,N: nat] :
      ( ( ord_less_eq @ real @ ( semiring_1_of_nat @ real @ M ) @ ( power_power @ real @ B2 @ N ) )
     => ( ( ord_less @ real @ ( one_one @ real ) @ B2 )
       => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M )
         => ( ord_less_eq @ real @ ( log2 @ B2 @ ( semiring_1_of_nat @ real @ M ) ) @ ( semiring_1_of_nat @ real @ N ) ) ) ) ) ).

% log_of_power_le
thf(fact_448_log__pow__cancel,axiom,
    ! [A2: real,B2: nat] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
     => ( ( A2
         != ( one_one @ real ) )
       => ( ( log2 @ A2 @ ( power_power @ real @ A2 @ B2 ) )
          = ( semiring_1_of_nat @ real @ B2 ) ) ) ) ).

% log_pow_cancel
thf(fact_449_log__of__power__less,axiom,
    ! [M: nat,B2: real,N: nat] :
      ( ( ord_less @ real @ ( semiring_1_of_nat @ real @ M ) @ ( power_power @ real @ B2 @ N ) )
     => ( ( ord_less @ real @ ( one_one @ real ) @ B2 )
       => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M )
         => ( ord_less @ real @ ( log2 @ B2 @ ( semiring_1_of_nat @ real @ M ) ) @ ( semiring_1_of_nat @ real @ N ) ) ) ) ) ).

% log_of_power_less
thf(fact_450_XOR__upper,axiom,
    ! [X: int,N: nat,Y: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ X )
     => ( ( ord_less @ int @ X @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) )
       => ( ( ord_less @ int @ Y @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) )
         => ( ord_less @ int @ ( bit_se5824344971392196577ns_xor @ int @ X @ Y ) @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) ) ) ) ) ).

% XOR_upper
thf(fact_451_power__le__zero__eq__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A,W: num] :
          ( ( ord_less_eq @ A @ ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ W ) ) @ ( zero_zero @ A ) )
          = ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( numeral_numeral @ nat @ W ) )
            & ( ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( numeral_numeral @ nat @ W ) )
                & ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) ) )
              | ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( numeral_numeral @ nat @ W ) )
                & ( A2
                  = ( zero_zero @ A ) ) ) ) ) ) ) ).

% power_le_zero_eq_numeral
thf(fact_452_OR__upper,axiom,
    ! [X: int,N: nat,Y: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ X )
     => ( ( ord_less @ int @ X @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) )
       => ( ( ord_less @ int @ Y @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) )
         => ( ord_less @ int @ ( bit_se1065995026697491101ons_or @ int @ X @ Y ) @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) ) ) ) ) ).

% OR_upper
thf(fact_453_real__sqrt__pow2,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( power_power @ real @ ( sqrt @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
        = X ) ) ).

% real_sqrt_pow2
thf(fact_454_add__right__cancel,axiom,
    ! [A: $tType] :
      ( ( cancel_semigroup_add @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( ( plus_plus @ A @ B2 @ A2 )
            = ( plus_plus @ A @ C2 @ A2 ) )
          = ( B2 = C2 ) ) ) ).

% add_right_cancel
thf(fact_455_add__left__cancel,axiom,
    ! [A: $tType] :
      ( ( cancel_semigroup_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ( plus_plus @ A @ A2 @ B2 )
            = ( plus_plus @ A @ A2 @ C2 ) )
          = ( B2 = C2 ) ) ) ).

% add_left_cancel
thf(fact_456_minus__apply,axiom,
    ! [B: $tType,A: $tType] :
      ( ( minus @ B )
     => ( ( minus_minus @ ( A > B ) )
        = ( ^ [A7: A > B,B6: A > B,X2: A] : ( minus_minus @ B @ ( A7 @ X2 ) @ ( B6 @ X2 ) ) ) ) ) ).

% minus_apply
thf(fact_457_or_Oright__idem,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A,B2: A] :
          ( ( bit_se1065995026697491101ons_or @ A @ ( bit_se1065995026697491101ons_or @ A @ A2 @ B2 ) @ B2 )
          = ( bit_se1065995026697491101ons_or @ A @ A2 @ B2 ) ) ) ).

% or.right_idem
thf(fact_458_or_Oleft__idem,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A,B2: A] :
          ( ( bit_se1065995026697491101ons_or @ A @ A2 @ ( bit_se1065995026697491101ons_or @ A @ A2 @ B2 ) )
          = ( bit_se1065995026697491101ons_or @ A @ A2 @ B2 ) ) ) ).

% or.left_idem
thf(fact_459_or_Oidem,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A] :
          ( ( bit_se1065995026697491101ons_or @ A @ A2 @ A2 )
          = A2 ) ) ).

% or.idem
thf(fact_460_real__sqrt__eq__iff,axiom,
    ! [X: real,Y: real] :
      ( ( ( sqrt @ X )
        = ( sqrt @ Y ) )
      = ( X = Y ) ) ).

% real_sqrt_eq_iff
thf(fact_461_bit_Oxor__left__self,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X: A,Y: A] :
          ( ( bit_se5824344971392196577ns_xor @ A @ X @ ( bit_se5824344971392196577ns_xor @ A @ X @ Y ) )
          = Y ) ) ).

% bit.xor_left_self
thf(fact_462_add__le__cancel__right,axiom,
    ! [A: $tType] :
      ( ( ordere2412721322843649153imp_le @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ A2 @ C2 ) @ ( plus_plus @ A @ B2 @ C2 ) )
          = ( ord_less_eq @ A @ A2 @ B2 ) ) ) ).

% add_le_cancel_right
thf(fact_463_add__le__cancel__left,axiom,
    ! [A: $tType] :
      ( ( ordere2412721322843649153imp_le @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ C2 @ A2 ) @ ( plus_plus @ A @ C2 @ B2 ) )
          = ( ord_less_eq @ A @ A2 @ B2 ) ) ) ).

% add_le_cancel_left
thf(fact_464_add_Oright__neutral,axiom,
    ! [A: $tType] :
      ( ( monoid_add @ A )
     => ! [A2: A] :
          ( ( plus_plus @ A @ A2 @ ( zero_zero @ A ) )
          = A2 ) ) ).

% add.right_neutral
thf(fact_465_double__zero__sym,axiom,
    ! [A: $tType] :
      ( ( linord5086331880401160121up_add @ A )
     => ! [A2: A] :
          ( ( ( zero_zero @ A )
            = ( plus_plus @ A @ A2 @ A2 ) )
          = ( A2
            = ( zero_zero @ A ) ) ) ) ).

% double_zero_sym
thf(fact_466_add__cancel__left__left,axiom,
    ! [A: $tType] :
      ( ( cancel1802427076303600483id_add @ A )
     => ! [B2: A,A2: A] :
          ( ( ( plus_plus @ A @ B2 @ A2 )
            = A2 )
          = ( B2
            = ( zero_zero @ A ) ) ) ) ).

% add_cancel_left_left
thf(fact_467_add__cancel__left__right,axiom,
    ! [A: $tType] :
      ( ( cancel1802427076303600483id_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ( plus_plus @ A @ A2 @ B2 )
            = A2 )
          = ( B2
            = ( zero_zero @ A ) ) ) ) ).

% add_cancel_left_right
thf(fact_468_add__cancel__right__left,axiom,
    ! [A: $tType] :
      ( ( cancel1802427076303600483id_add @ A )
     => ! [A2: A,B2: A] :
          ( ( A2
            = ( plus_plus @ A @ B2 @ A2 ) )
          = ( B2
            = ( zero_zero @ A ) ) ) ) ).

% add_cancel_right_left
thf(fact_469_add__cancel__right__right,axiom,
    ! [A: $tType] :
      ( ( cancel1802427076303600483id_add @ A )
     => ! [A2: A,B2: A] :
          ( ( A2
            = ( plus_plus @ A @ A2 @ B2 ) )
          = ( B2
            = ( zero_zero @ A ) ) ) ) ).

% add_cancel_right_right
thf(fact_470_add__eq__0__iff__both__eq__0,axiom,
    ! [A: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ! [X: A,Y: A] :
          ( ( ( plus_plus @ A @ X @ Y )
            = ( zero_zero @ A ) )
          = ( ( X
              = ( zero_zero @ A ) )
            & ( Y
              = ( zero_zero @ A ) ) ) ) ) ).

% add_eq_0_iff_both_eq_0
thf(fact_471_zero__eq__add__iff__both__eq__0,axiom,
    ! [A: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ! [X: A,Y: A] :
          ( ( ( zero_zero @ A )
            = ( plus_plus @ A @ X @ Y ) )
          = ( ( X
              = ( zero_zero @ A ) )
            & ( Y
              = ( zero_zero @ A ) ) ) ) ) ).

% zero_eq_add_iff_both_eq_0
thf(fact_472_add__0,axiom,
    ! [A: $tType] :
      ( ( monoid_add @ A )
     => ! [A2: A] :
          ( ( plus_plus @ A @ ( zero_zero @ A ) @ A2 )
          = A2 ) ) ).

% add_0
thf(fact_473_double__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( linord5086331880401160121up_add @ A )
     => ! [A2: A] :
          ( ( ( plus_plus @ A @ A2 @ A2 )
            = ( zero_zero @ A ) )
          = ( A2
            = ( zero_zero @ A ) ) ) ) ).

% double_eq_0_iff
thf(fact_474_diff__self,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A] :
          ( ( minus_minus @ A @ A2 @ A2 )
          = ( zero_zero @ A ) ) ) ).

% diff_self
thf(fact_475_diff__0__right,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A] :
          ( ( minus_minus @ A @ A2 @ ( zero_zero @ A ) )
          = A2 ) ) ).

% diff_0_right
thf(fact_476_zero__diff,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_diff @ A )
     => ! [A2: A] :
          ( ( minus_minus @ A @ ( zero_zero @ A ) @ A2 )
          = ( zero_zero @ A ) ) ) ).

% zero_diff
thf(fact_477_diff__zero,axiom,
    ! [A: $tType] :
      ( ( cancel1802427076303600483id_add @ A )
     => ! [A2: A] :
          ( ( minus_minus @ A @ A2 @ ( zero_zero @ A ) )
          = A2 ) ) ).

% diff_zero
thf(fact_478_cancel__comm__monoid__add__class_Odiff__cancel,axiom,
    ! [A: $tType] :
      ( ( cancel1802427076303600483id_add @ A )
     => ! [A2: A] :
          ( ( minus_minus @ A @ A2 @ A2 )
          = ( zero_zero @ A ) ) ) ).

% cancel_comm_monoid_add_class.diff_cancel
thf(fact_479_add__less__cancel__right,axiom,
    ! [A: $tType] :
      ( ( ordere2412721322843649153imp_le @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ord_less @ A @ ( plus_plus @ A @ A2 @ C2 ) @ ( plus_plus @ A @ B2 @ C2 ) )
          = ( ord_less @ A @ A2 @ B2 ) ) ) ).

% add_less_cancel_right
thf(fact_480_add__less__cancel__left,axiom,
    ! [A: $tType] :
      ( ( ordere2412721322843649153imp_le @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less @ A @ ( plus_plus @ A @ C2 @ A2 ) @ ( plus_plus @ A @ C2 @ B2 ) )
          = ( ord_less @ A @ A2 @ B2 ) ) ) ).

% add_less_cancel_left
thf(fact_481_numeral__plus__numeral,axiom,
    ! [A: $tType] :
      ( ( numeral @ A )
     => ! [M: num,N: num] :
          ( ( plus_plus @ A @ ( numeral_numeral @ A @ M ) @ ( numeral_numeral @ A @ N ) )
          = ( numeral_numeral @ A @ ( plus_plus @ num @ M @ N ) ) ) ) ).

% numeral_plus_numeral
thf(fact_482_add__numeral__left,axiom,
    ! [A: $tType] :
      ( ( numeral @ A )
     => ! [V: num,W: num,Z: A] :
          ( ( plus_plus @ A @ ( numeral_numeral @ A @ V ) @ ( plus_plus @ A @ ( numeral_numeral @ A @ W ) @ Z ) )
          = ( plus_plus @ A @ ( numeral_numeral @ A @ ( plus_plus @ num @ V @ W ) ) @ Z ) ) ) ).

% add_numeral_left
thf(fact_483_add__diff__cancel__right_H,axiom,
    ! [A: $tType] :
      ( ( cancel2418104881723323429up_add @ A )
     => ! [A2: A,B2: A] :
          ( ( minus_minus @ A @ ( plus_plus @ A @ A2 @ B2 ) @ B2 )
          = A2 ) ) ).

% add_diff_cancel_right'
thf(fact_484_add__diff__cancel__right,axiom,
    ! [A: $tType] :
      ( ( cancel2418104881723323429up_add @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( minus_minus @ A @ ( plus_plus @ A @ A2 @ C2 ) @ ( plus_plus @ A @ B2 @ C2 ) )
          = ( minus_minus @ A @ A2 @ B2 ) ) ) ).

% add_diff_cancel_right
thf(fact_485_add__diff__cancel__left_H,axiom,
    ! [A: $tType] :
      ( ( cancel2418104881723323429up_add @ A )
     => ! [A2: A,B2: A] :
          ( ( minus_minus @ A @ ( plus_plus @ A @ A2 @ B2 ) @ A2 )
          = B2 ) ) ).

% add_diff_cancel_left'
thf(fact_486_add__diff__cancel__left,axiom,
    ! [A: $tType] :
      ( ( cancel2418104881723323429up_add @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( minus_minus @ A @ ( plus_plus @ A @ C2 @ A2 ) @ ( plus_plus @ A @ C2 @ B2 ) )
          = ( minus_minus @ A @ A2 @ B2 ) ) ) ).

% add_diff_cancel_left
thf(fact_487_diff__add__cancel,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( plus_plus @ A @ ( minus_minus @ A @ A2 @ B2 ) @ B2 )
          = A2 ) ) ).

% diff_add_cancel
thf(fact_488_add__diff__cancel,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( minus_minus @ A @ ( plus_plus @ A @ A2 @ B2 ) @ B2 )
          = A2 ) ) ).

% add_diff_cancel
thf(fact_489_power__one,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [N: nat] :
          ( ( power_power @ A @ ( one_one @ A ) @ N )
          = ( one_one @ A ) ) ) ).

% power_one
thf(fact_490_of__nat__eq__1__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [N: nat] :
          ( ( ( semiring_1_of_nat @ A @ N )
            = ( one_one @ A ) )
          = ( N
            = ( one_one @ nat ) ) ) ) ).

% of_nat_eq_1_iff
thf(fact_491_of__nat__1__eq__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [N: nat] :
          ( ( ( one_one @ A )
            = ( semiring_1_of_nat @ A @ N ) )
          = ( N
            = ( one_one @ nat ) ) ) ) ).

% of_nat_1_eq_iff
thf(fact_492_of__nat__1,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ( ( semiring_1_of_nat @ A @ ( one_one @ nat ) )
        = ( one_one @ A ) ) ) ).

% of_nat_1
thf(fact_493_of__nat__add,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [M: nat,N: nat] :
          ( ( semiring_1_of_nat @ A @ ( plus_plus @ nat @ M @ N ) )
          = ( plus_plus @ A @ ( semiring_1_of_nat @ A @ M ) @ ( semiring_1_of_nat @ A @ N ) ) ) ) ).

% of_nat_add
thf(fact_494_of__int__eq__1__iff,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [Z: int] :
          ( ( ( ring_1_of_int @ A @ Z )
            = ( one_one @ A ) )
          = ( Z
            = ( one_one @ int ) ) ) ) ).

% of_int_eq_1_iff
thf(fact_495_of__int__1,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ( ( ring_1_of_int @ A @ ( one_one @ int ) )
        = ( one_one @ A ) ) ) ).

% of_int_1
thf(fact_496_or_Oleft__neutral,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A] :
          ( ( bit_se1065995026697491101ons_or @ A @ ( zero_zero @ A ) @ A2 )
          = A2 ) ) ).

% or.left_neutral
thf(fact_497_or_Oright__neutral,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A] :
          ( ( bit_se1065995026697491101ons_or @ A @ A2 @ ( zero_zero @ A ) )
          = A2 ) ) ).

% or.right_neutral
thf(fact_498_bit_Oxor__self,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X: A] :
          ( ( bit_se5824344971392196577ns_xor @ A @ X @ X )
          = ( zero_zero @ A ) ) ) ).

% bit.xor_self
thf(fact_499_xor__self__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A] :
          ( ( bit_se5824344971392196577ns_xor @ A @ A2 @ A2 )
          = ( zero_zero @ A ) ) ) ).

% xor_self_eq
thf(fact_500_xor_Oleft__neutral,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A] :
          ( ( bit_se5824344971392196577ns_xor @ A @ ( zero_zero @ A ) @ A2 )
          = A2 ) ) ).

% xor.left_neutral
thf(fact_501_xor_Oright__neutral,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A] :
          ( ( bit_se5824344971392196577ns_xor @ A @ A2 @ ( zero_zero @ A ) )
          = A2 ) ) ).

% xor.right_neutral
thf(fact_502_real__sqrt__eq__zero__cancel__iff,axiom,
    ! [X: real] :
      ( ( ( sqrt @ X )
        = ( zero_zero @ real ) )
      = ( X
        = ( zero_zero @ real ) ) ) ).

% real_sqrt_eq_zero_cancel_iff
thf(fact_503_real__sqrt__zero,axiom,
    ( ( sqrt @ ( zero_zero @ real ) )
    = ( zero_zero @ real ) ) ).

% real_sqrt_zero
thf(fact_504_real__sqrt__less__iff,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less @ real @ ( sqrt @ X ) @ ( sqrt @ Y ) )
      = ( ord_less @ real @ X @ Y ) ) ).

% real_sqrt_less_iff
thf(fact_505_real__sqrt__le__iff,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less_eq @ real @ ( sqrt @ X ) @ ( sqrt @ Y ) )
      = ( ord_less_eq @ real @ X @ Y ) ) ).

% real_sqrt_le_iff
thf(fact_506_real__sqrt__eq__1__iff,axiom,
    ! [X: real] :
      ( ( ( sqrt @ X )
        = ( one_one @ real ) )
      = ( X
        = ( one_one @ real ) ) ) ).

% real_sqrt_eq_1_iff
thf(fact_507_real__sqrt__one,axiom,
    ( ( sqrt @ ( one_one @ real ) )
    = ( one_one @ real ) ) ).

% real_sqrt_one
thf(fact_508_take__bit__or,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,A2: A,B2: A] :
          ( ( bit_se2584673776208193580ke_bit @ A @ N @ ( bit_se1065995026697491101ons_or @ A @ A2 @ B2 ) )
          = ( bit_se1065995026697491101ons_or @ A @ ( bit_se2584673776208193580ke_bit @ A @ N @ A2 ) @ ( bit_se2584673776208193580ke_bit @ A @ N @ B2 ) ) ) ) ).

% take_bit_or
thf(fact_509_take__bit__xor,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,A2: A,B2: A] :
          ( ( bit_se2584673776208193580ke_bit @ A @ N @ ( bit_se5824344971392196577ns_xor @ A @ A2 @ B2 ) )
          = ( bit_se5824344971392196577ns_xor @ A @ ( bit_se2584673776208193580ke_bit @ A @ N @ A2 ) @ ( bit_se2584673776208193580ke_bit @ A @ N @ B2 ) ) ) ) ).

% take_bit_xor
thf(fact_510_zero__le__double__add__iff__zero__le__single__add,axiom,
    ! [A: $tType] :
      ( ( linord5086331880401160121up_add @ A )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( plus_plus @ A @ A2 @ A2 ) )
          = ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 ) ) ) ).

% zero_le_double_add_iff_zero_le_single_add
thf(fact_511_double__add__le__zero__iff__single__add__le__zero,axiom,
    ! [A: $tType] :
      ( ( linord5086331880401160121up_add @ A )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ A2 @ A2 ) @ ( zero_zero @ A ) )
          = ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) ) ) ) ).

% double_add_le_zero_iff_single_add_le_zero
thf(fact_512_le__add__same__cancel2,axiom,
    ! [A: $tType] :
      ( ( ordere1937475149494474687imp_le @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ ( plus_plus @ A @ B2 @ A2 ) )
          = ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 ) ) ) ).

% le_add_same_cancel2
thf(fact_513_le__add__same__cancel1,axiom,
    ! [A: $tType] :
      ( ( ordere1937475149494474687imp_le @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ ( plus_plus @ A @ A2 @ B2 ) )
          = ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 ) ) ) ).

% le_add_same_cancel1
thf(fact_514_add__le__same__cancel2,axiom,
    ! [A: $tType] :
      ( ( ordere1937475149494474687imp_le @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ A2 @ B2 ) @ B2 )
          = ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) ) ) ) ).

% add_le_same_cancel2
thf(fact_515_add__le__same__cancel1,axiom,
    ! [A: $tType] :
      ( ( ordere1937475149494474687imp_le @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ B2 @ A2 ) @ B2 )
          = ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) ) ) ) ).

% add_le_same_cancel1
thf(fact_516_diff__ge__0__iff__ge,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( minus_minus @ A @ A2 @ B2 ) )
          = ( ord_less_eq @ A @ B2 @ A2 ) ) ) ).

% diff_ge_0_iff_ge
thf(fact_517_zero__less__double__add__iff__zero__less__single__add,axiom,
    ! [A: $tType] :
      ( ( linord5086331880401160121up_add @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( plus_plus @ A @ A2 @ A2 ) )
          = ( ord_less @ A @ ( zero_zero @ A ) @ A2 ) ) ) ).

% zero_less_double_add_iff_zero_less_single_add
thf(fact_518_double__add__less__zero__iff__single__add__less__zero,axiom,
    ! [A: $tType] :
      ( ( linord5086331880401160121up_add @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( plus_plus @ A @ A2 @ A2 ) @ ( zero_zero @ A ) )
          = ( ord_less @ A @ A2 @ ( zero_zero @ A ) ) ) ) ).

% double_add_less_zero_iff_single_add_less_zero
thf(fact_519_less__add__same__cancel2,axiom,
    ! [A: $tType] :
      ( ( ordere1937475149494474687imp_le @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ ( plus_plus @ A @ B2 @ A2 ) )
          = ( ord_less @ A @ ( zero_zero @ A ) @ B2 ) ) ) ).

% less_add_same_cancel2
thf(fact_520_less__add__same__cancel1,axiom,
    ! [A: $tType] :
      ( ( ordere1937475149494474687imp_le @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ ( plus_plus @ A @ A2 @ B2 ) )
          = ( ord_less @ A @ ( zero_zero @ A ) @ B2 ) ) ) ).

% less_add_same_cancel1
thf(fact_521_add__less__same__cancel2,axiom,
    ! [A: $tType] :
      ( ( ordere1937475149494474687imp_le @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( plus_plus @ A @ A2 @ B2 ) @ B2 )
          = ( ord_less @ A @ A2 @ ( zero_zero @ A ) ) ) ) ).

% add_less_same_cancel2
thf(fact_522_add__less__same__cancel1,axiom,
    ! [A: $tType] :
      ( ( ordere1937475149494474687imp_le @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less @ A @ ( plus_plus @ A @ B2 @ A2 ) @ B2 )
          = ( ord_less @ A @ A2 @ ( zero_zero @ A ) ) ) ) ).

% add_less_same_cancel1
thf(fact_523_diff__gt__0__iff__gt,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( minus_minus @ A @ A2 @ B2 ) )
          = ( ord_less @ A @ B2 @ A2 ) ) ) ).

% diff_gt_0_iff_gt
thf(fact_524_diff__numeral__special_I9_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( minus_minus @ A @ ( one_one @ A ) @ ( one_one @ A ) )
        = ( zero_zero @ A ) ) ) ).

% diff_numeral_special(9)
thf(fact_525_diff__add__zero,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_diff @ A )
     => ! [A2: A,B2: A] :
          ( ( minus_minus @ A @ A2 @ ( plus_plus @ A @ A2 @ B2 ) )
          = ( zero_zero @ A ) ) ) ).

% diff_add_zero
thf(fact_526_one__eq__numeral__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [N: num] :
          ( ( ( one_one @ A )
            = ( numeral_numeral @ A @ N ) )
          = ( one2 = N ) ) ) ).

% one_eq_numeral_iff
thf(fact_527_numeral__eq__one__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [N: num] :
          ( ( ( numeral_numeral @ A @ N )
            = ( one_one @ A ) )
          = ( N = one2 ) ) ) ).

% numeral_eq_one_iff
thf(fact_528_power__inject__exp,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,M: nat,N: nat] :
          ( ( ord_less @ A @ ( one_one @ A ) @ A2 )
         => ( ( ( power_power @ A @ A2 @ M )
              = ( power_power @ A @ A2 @ N ) )
            = ( M = N ) ) ) ) ).

% power_inject_exp
thf(fact_529_max__0__1_I2_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ( ( ord_max @ A @ ( one_one @ A ) @ ( zero_zero @ A ) )
        = ( one_one @ A ) ) ) ).

% max_0_1(2)
thf(fact_530_max__0__1_I1_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ( ( ord_max @ A @ ( zero_zero @ A ) @ ( one_one @ A ) )
        = ( one_one @ A ) ) ) ).

% max_0_1(1)
thf(fact_531_max__0__1_I5_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [X: num] :
          ( ( ord_max @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ X ) )
          = ( numeral_numeral @ A @ X ) ) ) ).

% max_0_1(5)
thf(fact_532_max__0__1_I6_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [X: num] :
          ( ( ord_max @ A @ ( numeral_numeral @ A @ X ) @ ( one_one @ A ) )
          = ( numeral_numeral @ A @ X ) ) ) ).

% max_0_1(6)
thf(fact_533_take__bit__numeral__1,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [L: num] :
          ( ( bit_se2584673776208193580ke_bit @ A @ ( numeral_numeral @ nat @ L ) @ ( one_one @ A ) )
          = ( one_one @ A ) ) ) ).

% take_bit_numeral_1
thf(fact_534_of__int__add,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [W: int,Z: int] :
          ( ( ring_1_of_int @ A @ ( plus_plus @ int @ W @ Z ) )
          = ( plus_plus @ A @ ( ring_1_of_int @ A @ W ) @ ( ring_1_of_int @ A @ Z ) ) ) ) ).

% of_int_add
thf(fact_535_real__sqrt__lt__0__iff,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( sqrt @ X ) @ ( zero_zero @ real ) )
      = ( ord_less @ real @ X @ ( zero_zero @ real ) ) ) ).

% real_sqrt_lt_0_iff
thf(fact_536_real__sqrt__gt__0__iff,axiom,
    ! [Y: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ ( sqrt @ Y ) )
      = ( ord_less @ real @ ( zero_zero @ real ) @ Y ) ) ).

% real_sqrt_gt_0_iff
thf(fact_537_real__sqrt__le__0__iff,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( sqrt @ X ) @ ( zero_zero @ real ) )
      = ( ord_less_eq @ real @ X @ ( zero_zero @ real ) ) ) ).

% real_sqrt_le_0_iff
thf(fact_538_real__sqrt__ge__0__iff,axiom,
    ! [Y: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( sqrt @ Y ) )
      = ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y ) ) ).

% real_sqrt_ge_0_iff
thf(fact_539_of__int__diff,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [W: int,Z: int] :
          ( ( ring_1_of_int @ A @ ( minus_minus @ int @ W @ Z ) )
          = ( minus_minus @ A @ ( ring_1_of_int @ A @ W ) @ ( ring_1_of_int @ A @ Z ) ) ) ) ).

% of_int_diff
thf(fact_540_real__sqrt__gt__1__iff,axiom,
    ! [Y: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ ( sqrt @ Y ) )
      = ( ord_less @ real @ ( one_one @ real ) @ Y ) ) ).

% real_sqrt_gt_1_iff
thf(fact_541_real__sqrt__lt__1__iff,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( sqrt @ X ) @ ( one_one @ real ) )
      = ( ord_less @ real @ X @ ( one_one @ real ) ) ) ).

% real_sqrt_lt_1_iff
thf(fact_542_real__sqrt__le__1__iff,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( sqrt @ X ) @ ( one_one @ real ) )
      = ( ord_less_eq @ real @ X @ ( one_one @ real ) ) ) ).

% real_sqrt_le_1_iff
thf(fact_543_real__sqrt__ge__1__iff,axiom,
    ! [Y: real] :
      ( ( ord_less_eq @ real @ ( one_one @ real ) @ ( sqrt @ Y ) )
      = ( ord_less_eq @ real @ ( one_one @ real ) @ Y ) ) ).

% real_sqrt_ge_1_iff
thf(fact_544_log__one,axiom,
    ! [A2: real] :
      ( ( log2 @ A2 @ ( one_one @ real ) )
      = ( zero_zero @ real ) ) ).

% log_one
thf(fact_545_or__nonnegative__int__iff,axiom,
    ! [K: int,L: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( bit_se1065995026697491101ons_or @ int @ K @ L ) )
      = ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ K )
        & ( ord_less_eq @ int @ ( zero_zero @ int ) @ L ) ) ) ).

% or_nonnegative_int_iff
thf(fact_546_or__negative__int__iff,axiom,
    ! [K: int,L: int] :
      ( ( ord_less @ int @ ( bit_se1065995026697491101ons_or @ int @ K @ L ) @ ( zero_zero @ int ) )
      = ( ( ord_less @ int @ K @ ( zero_zero @ int ) )
        | ( ord_less @ int @ L @ ( zero_zero @ int ) ) ) ) ).

% or_negative_int_iff
thf(fact_547_xor__nonnegative__int__iff,axiom,
    ! [K: int,L: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( bit_se5824344971392196577ns_xor @ int @ K @ L ) )
      = ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ K )
        = ( ord_less_eq @ int @ ( zero_zero @ int ) @ L ) ) ) ).

% xor_nonnegative_int_iff
thf(fact_548_xor__negative__int__iff,axiom,
    ! [K: int,L: int] :
      ( ( ord_less @ int @ ( bit_se5824344971392196577ns_xor @ int @ K @ L ) @ ( zero_zero @ int ) )
      = ( ( ( ord_less @ int @ K @ ( zero_zero @ int ) )
         != ( ord_less @ int @ L @ ( zero_zero @ int ) ) ) ) ) ).

% xor_negative_int_iff
thf(fact_549_one__plus__numeral,axiom,
    ! [A: $tType] :
      ( ( numeral @ A )
     => ! [N: num] :
          ( ( plus_plus @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ N ) )
          = ( numeral_numeral @ A @ ( plus_plus @ num @ one2 @ N ) ) ) ) ).

% one_plus_numeral
thf(fact_550_numeral__plus__one,axiom,
    ! [A: $tType] :
      ( ( numeral @ A )
     => ! [N: num] :
          ( ( plus_plus @ A @ ( numeral_numeral @ A @ N ) @ ( one_one @ A ) )
          = ( numeral_numeral @ A @ ( plus_plus @ num @ N @ one2 ) ) ) ) ).

% numeral_plus_one
thf(fact_551_power__strict__increasing__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [B2: A,X: nat,Y: nat] :
          ( ( ord_less @ A @ ( one_one @ A ) @ B2 )
         => ( ( ord_less @ A @ ( power_power @ A @ B2 @ X ) @ ( power_power @ A @ B2 @ Y ) )
            = ( ord_less @ nat @ X @ Y ) ) ) ) ).

% power_strict_increasing_iff
thf(fact_552_take__bit__of__1__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [N: nat] :
          ( ( ( bit_se2584673776208193580ke_bit @ A @ N @ ( one_one @ A ) )
            = ( zero_zero @ A ) )
          = ( N
            = ( zero_zero @ nat ) ) ) ) ).

% take_bit_of_1_eq_0_iff
thf(fact_553_of__int__1__le__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [Z: int] :
          ( ( ord_less_eq @ A @ ( one_one @ A ) @ ( ring_1_of_int @ A @ Z ) )
          = ( ord_less_eq @ int @ ( one_one @ int ) @ Z ) ) ) ).

% of_int_1_le_iff
thf(fact_554_of__int__le__1__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [Z: int] :
          ( ( ord_less_eq @ A @ ( ring_1_of_int @ A @ Z ) @ ( one_one @ A ) )
          = ( ord_less_eq @ int @ Z @ ( one_one @ int ) ) ) ) ).

% of_int_le_1_iff
thf(fact_555_of__int__1__less__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [Z: int] :
          ( ( ord_less @ A @ ( one_one @ A ) @ ( ring_1_of_int @ A @ Z ) )
          = ( ord_less @ int @ ( one_one @ int ) @ Z ) ) ) ).

% of_int_1_less_iff
thf(fact_556_of__int__less__1__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [Z: int] :
          ( ( ord_less @ A @ ( ring_1_of_int @ A @ Z ) @ ( one_one @ A ) )
          = ( ord_less @ int @ Z @ ( one_one @ int ) ) ) ) ).

% of_int_less_1_iff
thf(fact_557_real__sqrt__four,axiom,
    ( ( sqrt @ ( numeral_numeral @ real @ ( bit0 @ ( bit0 @ one2 ) ) ) )
    = ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ).

% real_sqrt_four
thf(fact_558_log__eq__one,axiom,
    ! [A2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
     => ( ( A2
         != ( one_one @ real ) )
       => ( ( log2 @ A2 @ A2 )
          = ( one_one @ real ) ) ) ) ).

% log_eq_one
thf(fact_559_log__less__cancel__iff,axiom,
    ! [A2: real,X: real,Y: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ A2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
       => ( ( ord_less @ real @ ( zero_zero @ real ) @ Y )
         => ( ( ord_less @ real @ ( log2 @ A2 @ X ) @ ( log2 @ A2 @ Y ) )
            = ( ord_less @ real @ X @ Y ) ) ) ) ) ).

% log_less_cancel_iff
thf(fact_560_log__less__one__cancel__iff,axiom,
    ! [A2: real,X: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ A2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
       => ( ( ord_less @ real @ ( log2 @ A2 @ X ) @ ( one_one @ real ) )
          = ( ord_less @ real @ X @ A2 ) ) ) ) ).

% log_less_one_cancel_iff
thf(fact_561_one__less__log__cancel__iff,axiom,
    ! [A2: real,X: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ A2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
       => ( ( ord_less @ real @ ( one_one @ real ) @ ( log2 @ A2 @ X ) )
          = ( ord_less @ real @ A2 @ X ) ) ) ) ).

% one_less_log_cancel_iff
thf(fact_562_log__less__zero__cancel__iff,axiom,
    ! [A2: real,X: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ A2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
       => ( ( ord_less @ real @ ( log2 @ A2 @ X ) @ ( zero_zero @ real ) )
          = ( ord_less @ real @ X @ ( one_one @ real ) ) ) ) ) ).

% log_less_zero_cancel_iff
thf(fact_563_zero__less__log__cancel__iff,axiom,
    ! [A2: real,X: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ A2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
       => ( ( ord_less @ real @ ( zero_zero @ real ) @ ( log2 @ A2 @ X ) )
          = ( ord_less @ real @ ( one_one @ real ) @ X ) ) ) ) ).

% zero_less_log_cancel_iff
thf(fact_564_one__add__one,axiom,
    ! [A: $tType] :
      ( ( numeral @ A )
     => ( ( plus_plus @ A @ ( one_one @ A ) @ ( one_one @ A ) )
        = ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ).

% one_add_one
thf(fact_565_power__strict__decreasing__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [B2: A,M: nat,N: nat] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ B2 )
         => ( ( ord_less @ A @ B2 @ ( one_one @ A ) )
           => ( ( ord_less @ A @ ( power_power @ A @ B2 @ M ) @ ( power_power @ A @ B2 @ N ) )
              = ( ord_less @ nat @ N @ M ) ) ) ) ) ).

% power_strict_decreasing_iff
thf(fact_566_power__increasing__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [B2: A,X: nat,Y: nat] :
          ( ( ord_less @ A @ ( one_one @ A ) @ B2 )
         => ( ( ord_less_eq @ A @ ( power_power @ A @ B2 @ X ) @ ( power_power @ A @ B2 @ Y ) )
            = ( ord_less_eq @ nat @ X @ Y ) ) ) ) ).

% power_increasing_iff
thf(fact_567_even__add,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [A2: A,B2: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( plus_plus @ A @ A2 @ B2 ) )
          = ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
            = ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B2 ) ) ) ) ).

% even_add
thf(fact_568_odd__add,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [A2: A,B2: A] :
          ( ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( plus_plus @ A @ A2 @ B2 ) ) )
          = ( ( ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) )
             != ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B2 ) ) ) ) ) ) ).

% odd_add
thf(fact_569_numeral__le__one__iff,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [N: num] :
          ( ( ord_less_eq @ A @ ( numeral_numeral @ A @ N ) @ ( one_one @ A ) )
          = ( ord_less_eq @ num @ N @ one2 ) ) ) ).

% numeral_le_one_iff
thf(fact_570_log__le__cancel__iff,axiom,
    ! [A2: real,X: real,Y: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ A2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
       => ( ( ord_less @ real @ ( zero_zero @ real ) @ Y )
         => ( ( ord_less_eq @ real @ ( log2 @ A2 @ X ) @ ( log2 @ A2 @ Y ) )
            = ( ord_less_eq @ real @ X @ Y ) ) ) ) ) ).

% log_le_cancel_iff
thf(fact_571_log__le__one__cancel__iff,axiom,
    ! [A2: real,X: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ A2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
       => ( ( ord_less_eq @ real @ ( log2 @ A2 @ X ) @ ( one_one @ real ) )
          = ( ord_less_eq @ real @ X @ A2 ) ) ) ) ).

% log_le_one_cancel_iff
thf(fact_572_one__le__log__cancel__iff,axiom,
    ! [A2: real,X: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ A2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
       => ( ( ord_less_eq @ real @ ( one_one @ real ) @ ( log2 @ A2 @ X ) )
          = ( ord_less_eq @ real @ A2 @ X ) ) ) ) ).

% one_le_log_cancel_iff
thf(fact_573_log__le__zero__cancel__iff,axiom,
    ! [A2: real,X: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ A2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
       => ( ( ord_less_eq @ real @ ( log2 @ A2 @ X ) @ ( zero_zero @ real ) )
          = ( ord_less_eq @ real @ X @ ( one_one @ real ) ) ) ) ) ).

% log_le_zero_cancel_iff
thf(fact_574_zero__le__log__cancel__iff,axiom,
    ! [A2: real,X: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ A2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
       => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( log2 @ A2 @ X ) )
          = ( ord_less_eq @ real @ ( one_one @ real ) @ X ) ) ) ) ).

% zero_le_log_cancel_iff
thf(fact_575_one__less__numeral__iff,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [N: num] :
          ( ( ord_less @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ N ) )
          = ( ord_less @ num @ one2 @ N ) ) ) ).

% one_less_numeral_iff
thf(fact_576_power__decreasing__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [B2: A,M: nat,N: nat] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ B2 )
         => ( ( ord_less @ A @ B2 @ ( one_one @ A ) )
           => ( ( ord_less_eq @ A @ ( power_power @ A @ B2 @ M ) @ ( power_power @ A @ B2 @ N ) )
              = ( ord_less_eq @ nat @ N @ M ) ) ) ) ) ).

% power_decreasing_iff
thf(fact_577_even__plus__one__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [A2: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( plus_plus @ A @ A2 @ ( one_one @ A ) ) )
          = ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) ) ) ) ).

% even_plus_one_iff
thf(fact_578_sum__power2__eq__zero__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: A,Y: A] :
          ( ( ( plus_plus @ A @ ( power_power @ A @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ A @ Y @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
            = ( zero_zero @ A ) )
          = ( ( X
              = ( zero_zero @ A ) )
            & ( Y
              = ( zero_zero @ A ) ) ) ) ) ).

% sum_power2_eq_zero_iff
thf(fact_579_even__diff,axiom,
    ! [A: $tType] :
      ( ( ring_parity @ A )
     => ! [A2: A,B2: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( minus_minus @ A @ A2 @ B2 ) )
          = ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( plus_plus @ A @ A2 @ B2 ) ) ) ) ).

% even_diff
thf(fact_580_even__take__bit__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,A2: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se2584673776208193580ke_bit @ A @ N @ A2 ) )
          = ( ( N
              = ( zero_zero @ nat ) )
            | ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) ) ) ) ).

% even_take_bit_eq
thf(fact_581_zero__le__power__eq__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A,W: num] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ W ) ) )
          = ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( numeral_numeral @ nat @ W ) )
            | ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( numeral_numeral @ nat @ W ) )
              & ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 ) ) ) ) ) ).

% zero_le_power_eq_numeral
thf(fact_582_even__power,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [A2: A,N: nat] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( power_power @ A @ A2 @ N ) )
          = ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
            & ( ord_less @ nat @ ( zero_zero @ nat ) @ N ) ) ) ) ).

% even_power
thf(fact_583_power__less__zero__eq__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A,W: num] :
          ( ( ord_less @ A @ ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ W ) ) @ ( zero_zero @ A ) )
          = ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( numeral_numeral @ nat @ W ) )
            & ( ord_less @ A @ A2 @ ( zero_zero @ A ) ) ) ) ) ).

% power_less_zero_eq_numeral
thf(fact_584_power__less__zero__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A,N: nat] :
          ( ( ord_less @ A @ ( power_power @ A @ A2 @ N ) @ ( zero_zero @ A ) )
          = ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
            & ( ord_less @ A @ A2 @ ( zero_zero @ A ) ) ) ) ) ).

% power_less_zero_eq
thf(fact_585_even__of__nat,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [N: nat] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( semiring_1_of_nat @ A @ N ) )
          = ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ) ).

% even_of_nat
thf(fact_586_real__sqrt__pow2__iff,axiom,
    ! [X: real] :
      ( ( ( power_power @ real @ ( sqrt @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
        = X )
      = ( ord_less_eq @ real @ ( zero_zero @ real ) @ X ) ) ).

% real_sqrt_pow2_iff
thf(fact_587_semiring__parity__class_Oeven__mask__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [N: nat] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( minus_minus @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) @ ( one_one @ A ) ) )
          = ( N
            = ( zero_zero @ nat ) ) ) ) ).

% semiring_parity_class.even_mask_iff
thf(fact_588_zero__less__power__eq__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A,W: num] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ W ) ) )
          = ( ( ( numeral_numeral @ nat @ W )
              = ( zero_zero @ nat ) )
            | ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( numeral_numeral @ nat @ W ) )
              & ( A2
               != ( zero_zero @ A ) ) )
            | ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( numeral_numeral @ nat @ W ) )
              & ( ord_less @ A @ ( zero_zero @ A ) @ A2 ) ) ) ) ) ).

% zero_less_power_eq_numeral
thf(fact_589_fun__diff__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( minus @ B )
     => ( ( minus_minus @ ( A > B ) )
        = ( ^ [A7: A > B,B6: A > B,X2: A] : ( minus_minus @ B @ ( A7 @ X2 ) @ ( B6 @ X2 ) ) ) ) ) ).

% fun_diff_def
thf(fact_590_is__num__normalize_I1_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( plus_plus @ A @ ( plus_plus @ A @ A2 @ B2 ) @ C2 )
          = ( plus_plus @ A @ A2 @ ( plus_plus @ A @ B2 @ C2 ) ) ) ) ).

% is_num_normalize(1)
thf(fact_591_add__diff__add,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [A2: A,C2: A,B2: A,D2: A] :
          ( ( minus_minus @ A @ ( plus_plus @ A @ A2 @ C2 ) @ ( plus_plus @ A @ B2 @ D2 ) )
          = ( plus_plus @ A @ ( minus_minus @ A @ A2 @ B2 ) @ ( minus_minus @ A @ C2 @ D2 ) ) ) ) ).

% add_diff_add
thf(fact_592_dvd__antisym,axiom,
    ! [M: nat,N: nat] :
      ( ( dvd_dvd @ nat @ M @ N )
     => ( ( dvd_dvd @ nat @ N @ M )
       => ( M = N ) ) ) ).

% dvd_antisym
thf(fact_593_of__nat__or__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M: nat,N: nat] :
          ( ( semiring_1_of_nat @ A @ ( bit_se1065995026697491101ons_or @ nat @ M @ N ) )
          = ( bit_se1065995026697491101ons_or @ A @ ( semiring_1_of_nat @ A @ M ) @ ( semiring_1_of_nat @ A @ N ) ) ) ) ).

% of_nat_or_eq
thf(fact_594_one__reorient,axiom,
    ! [A: $tType] :
      ( ( one @ A )
     => ! [X: A] :
          ( ( ( one_one @ A )
            = X )
          = ( X
            = ( one_one @ A ) ) ) ) ).

% one_reorient
thf(fact_595_diff__diff__eq,axiom,
    ! [A: $tType] :
      ( ( cancel2418104881723323429up_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( minus_minus @ A @ ( minus_minus @ A @ A2 @ B2 ) @ C2 )
          = ( minus_minus @ A @ A2 @ ( plus_plus @ A @ B2 @ C2 ) ) ) ) ).

% diff_diff_eq
thf(fact_596_xor_Oleft__commute,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( bit_se5824344971392196577ns_xor @ A @ B2 @ ( bit_se5824344971392196577ns_xor @ A @ A2 @ C2 ) )
          = ( bit_se5824344971392196577ns_xor @ A @ A2 @ ( bit_se5824344971392196577ns_xor @ A @ B2 @ C2 ) ) ) ) ).

% xor.left_commute
thf(fact_597_or_Oleft__commute,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( bit_se1065995026697491101ons_or @ A @ B2 @ ( bit_se1065995026697491101ons_or @ A @ A2 @ C2 ) )
          = ( bit_se1065995026697491101ons_or @ A @ A2 @ ( bit_se1065995026697491101ons_or @ A @ B2 @ C2 ) ) ) ) ).

% or.left_commute
thf(fact_598_xor_Ocommute,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se5824344971392196577ns_xor @ A )
        = ( ^ [A3: A,B3: A] : ( bit_se5824344971392196577ns_xor @ A @ B3 @ A3 ) ) ) ) ).

% xor.commute
thf(fact_599_diff__right__commute,axiom,
    ! [A: $tType] :
      ( ( cancel2418104881723323429up_add @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( minus_minus @ A @ ( minus_minus @ A @ A2 @ C2 ) @ B2 )
          = ( minus_minus @ A @ ( minus_minus @ A @ A2 @ B2 ) @ C2 ) ) ) ).

% diff_right_commute
thf(fact_600_or_Ocommute,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se1065995026697491101ons_or @ A )
        = ( ^ [A3: A,B3: A] : ( bit_se1065995026697491101ons_or @ A @ B3 @ A3 ) ) ) ) ).

% or.commute
thf(fact_601_xor_Oassoc,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( bit_se5824344971392196577ns_xor @ A @ ( bit_se5824344971392196577ns_xor @ A @ A2 @ B2 ) @ C2 )
          = ( bit_se5824344971392196577ns_xor @ A @ A2 @ ( bit_se5824344971392196577ns_xor @ A @ B2 @ C2 ) ) ) ) ).

% xor.assoc
thf(fact_602_or_Oassoc,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( bit_se1065995026697491101ons_or @ A @ ( bit_se1065995026697491101ons_or @ A @ A2 @ B2 ) @ C2 )
          = ( bit_se1065995026697491101ons_or @ A @ A2 @ ( bit_se1065995026697491101ons_or @ A @ B2 @ C2 ) ) ) ) ).

% or.assoc
thf(fact_603_add__implies__diff,axiom,
    ! [A: $tType] :
      ( ( cancel1802427076303600483id_add @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( ( plus_plus @ A @ C2 @ B2 )
            = A2 )
         => ( C2
            = ( minus_minus @ A @ A2 @ B2 ) ) ) ) ).

% add_implies_diff
thf(fact_604_add__right__imp__eq,axiom,
    ! [A: $tType] :
      ( ( cancel_semigroup_add @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( ( plus_plus @ A @ B2 @ A2 )
            = ( plus_plus @ A @ C2 @ A2 ) )
         => ( B2 = C2 ) ) ) ).

% add_right_imp_eq
thf(fact_605_diff__add__eq__diff__diff__swap,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( minus_minus @ A @ A2 @ ( plus_plus @ A @ B2 @ C2 ) )
          = ( minus_minus @ A @ ( minus_minus @ A @ A2 @ C2 ) @ B2 ) ) ) ).

% diff_add_eq_diff_diff_swap
thf(fact_606_add__left__imp__eq,axiom,
    ! [A: $tType] :
      ( ( cancel_semigroup_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ( plus_plus @ A @ A2 @ B2 )
            = ( plus_plus @ A @ A2 @ C2 ) )
         => ( B2 = C2 ) ) ) ).

% add_left_imp_eq
thf(fact_607_add_Oleft__commute,axiom,
    ! [A: $tType] :
      ( ( ab_semigroup_add @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( plus_plus @ A @ B2 @ ( plus_plus @ A @ A2 @ C2 ) )
          = ( plus_plus @ A @ A2 @ ( plus_plus @ A @ B2 @ C2 ) ) ) ) ).

% add.left_commute
thf(fact_608_add_Ocommute,axiom,
    ! [A: $tType] :
      ( ( ab_semigroup_add @ A )
     => ( ( plus_plus @ A )
        = ( ^ [A3: A,B3: A] : ( plus_plus @ A @ B3 @ A3 ) ) ) ) ).

% add.commute
thf(fact_609_add_Oright__cancel,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( ( plus_plus @ A @ B2 @ A2 )
            = ( plus_plus @ A @ C2 @ A2 ) )
          = ( B2 = C2 ) ) ) ).

% add.right_cancel
thf(fact_610_diff__eq__diff__eq,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ( minus_minus @ A @ A2 @ B2 )
            = ( minus_minus @ A @ C2 @ D2 ) )
         => ( ( A2 = B2 )
            = ( C2 = D2 ) ) ) ) ).

% diff_eq_diff_eq
thf(fact_611_add_Oleft__cancel,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ( plus_plus @ A @ A2 @ B2 )
            = ( plus_plus @ A @ A2 @ C2 ) )
          = ( B2 = C2 ) ) ) ).

% add.left_cancel
thf(fact_612_diff__add__eq,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( plus_plus @ A @ ( minus_minus @ A @ A2 @ B2 ) @ C2 )
          = ( minus_minus @ A @ ( plus_plus @ A @ A2 @ C2 ) @ B2 ) ) ) ).

% diff_add_eq
thf(fact_613_add_Oassoc,axiom,
    ! [A: $tType] :
      ( ( semigroup_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( plus_plus @ A @ ( plus_plus @ A @ A2 @ B2 ) @ C2 )
          = ( plus_plus @ A @ A2 @ ( plus_plus @ A @ B2 @ C2 ) ) ) ) ).

% add.assoc
thf(fact_614_diff__diff__eq2,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( minus_minus @ A @ A2 @ ( minus_minus @ A @ B2 @ C2 ) )
          = ( minus_minus @ A @ ( plus_plus @ A @ A2 @ C2 ) @ B2 ) ) ) ).

% diff_diff_eq2
thf(fact_615_add__diff__eq,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( plus_plus @ A @ A2 @ ( minus_minus @ A @ B2 @ C2 ) )
          = ( minus_minus @ A @ ( plus_plus @ A @ A2 @ B2 ) @ C2 ) ) ) ).

% add_diff_eq
thf(fact_616_eq__diff__eq,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( A2
            = ( minus_minus @ A @ C2 @ B2 ) )
          = ( ( plus_plus @ A @ A2 @ B2 )
            = C2 ) ) ) ).

% eq_diff_eq
thf(fact_617_diff__eq__eq,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ( minus_minus @ A @ A2 @ B2 )
            = C2 )
          = ( A2
            = ( plus_plus @ A @ C2 @ B2 ) ) ) ) ).

% diff_eq_eq
thf(fact_618_group__cancel_Osub1,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [A4: A,K: A,A2: A,B2: A] :
          ( ( A4
            = ( plus_plus @ A @ K @ A2 ) )
         => ( ( minus_minus @ A @ A4 @ B2 )
            = ( plus_plus @ A @ K @ ( minus_minus @ A @ A2 @ B2 ) ) ) ) ) ).

% group_cancel.sub1
thf(fact_619_group__cancel_Oadd2,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [B7: A,K: A,B2: A,A2: A] :
          ( ( B7
            = ( plus_plus @ A @ K @ B2 ) )
         => ( ( plus_plus @ A @ A2 @ B7 )
            = ( plus_plus @ A @ K @ ( plus_plus @ A @ A2 @ B2 ) ) ) ) ) ).

% group_cancel.add2
thf(fact_620_group__cancel_Oadd1,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A4: A,K: A,A2: A,B2: A] :
          ( ( A4
            = ( plus_plus @ A @ K @ A2 ) )
         => ( ( plus_plus @ A @ A4 @ B2 )
            = ( plus_plus @ A @ K @ ( plus_plus @ A @ A2 @ B2 ) ) ) ) ) ).

% group_cancel.add1
thf(fact_621_add__mono__thms__linordered__semiring_I4_J,axiom,
    ! [A: $tType] :
      ( ( ordere6658533253407199908up_add @ A )
     => ! [I: A,J: A,K: A,L: A] :
          ( ( ( I = J )
            & ( K = L ) )
         => ( ( plus_plus @ A @ I @ K )
            = ( plus_plus @ A @ J @ L ) ) ) ) ).

% add_mono_thms_linordered_semiring(4)
thf(fact_622_ab__semigroup__add__class_Oadd__ac_I1_J,axiom,
    ! [A: $tType] :
      ( ( ab_semigroup_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( plus_plus @ A @ ( plus_plus @ A @ A2 @ B2 ) @ C2 )
          = ( plus_plus @ A @ A2 @ ( plus_plus @ A @ B2 @ C2 ) ) ) ) ).

% ab_semigroup_add_class.add_ac(1)
thf(fact_623_of__int__or__eq,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [K: int,L: int] :
          ( ( ring_1_of_int @ A @ ( bit_se1065995026697491101ons_or @ int @ K @ L ) )
          = ( bit_se1065995026697491101ons_or @ A @ ( ring_1_of_int @ A @ K ) @ ( ring_1_of_int @ A @ L ) ) ) ) ).

% of_int_or_eq
thf(fact_624_ordered__cancel__comm__monoid__diff__class_Ole__imp__diff__is__add,axiom,
    ! [A: $tType] :
      ( ( ordere1170586879665033532d_diff @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ A2 @ B2 )
           => ( ( ( minus_minus @ A @ B2 @ A2 )
                = C2 )
              = ( B2
                = ( plus_plus @ A @ C2 @ A2 ) ) ) ) ) ) ).

% ordered_cancel_comm_monoid_diff_class.le_imp_diff_is_add
thf(fact_625_ordered__cancel__comm__monoid__diff__class_Oadd__diff__inverse,axiom,
    ! [A: $tType] :
      ( ( ordere1170586879665033532d_diff @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( plus_plus @ A @ A2 @ ( minus_minus @ A @ B2 @ A2 ) )
            = B2 ) ) ) ).

% ordered_cancel_comm_monoid_diff_class.add_diff_inverse
thf(fact_626_ordered__cancel__comm__monoid__diff__class_Odiff__diff__right,axiom,
    ! [A: $tType] :
      ( ( ordere1170586879665033532d_diff @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( minus_minus @ A @ C2 @ ( minus_minus @ A @ B2 @ A2 ) )
            = ( minus_minus @ A @ ( plus_plus @ A @ C2 @ A2 ) @ B2 ) ) ) ) ).

% ordered_cancel_comm_monoid_diff_class.diff_diff_right
thf(fact_627_ordered__cancel__comm__monoid__diff__class_Odiff__add__assoc2,axiom,
    ! [A: $tType] :
      ( ( ordere1170586879665033532d_diff @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( minus_minus @ A @ ( plus_plus @ A @ B2 @ C2 ) @ A2 )
            = ( plus_plus @ A @ ( minus_minus @ A @ B2 @ A2 ) @ C2 ) ) ) ) ).

% ordered_cancel_comm_monoid_diff_class.diff_add_assoc2
thf(fact_628_ordered__cancel__comm__monoid__diff__class_Oadd__diff__assoc2,axiom,
    ! [A: $tType] :
      ( ( ordere1170586879665033532d_diff @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( plus_plus @ A @ ( minus_minus @ A @ B2 @ A2 ) @ C2 )
            = ( minus_minus @ A @ ( plus_plus @ A @ B2 @ C2 ) @ A2 ) ) ) ) ).

% ordered_cancel_comm_monoid_diff_class.add_diff_assoc2
thf(fact_629_ordered__cancel__comm__monoid__diff__class_Odiff__add__assoc,axiom,
    ! [A: $tType] :
      ( ( ordere1170586879665033532d_diff @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( minus_minus @ A @ ( plus_plus @ A @ C2 @ B2 ) @ A2 )
            = ( plus_plus @ A @ C2 @ ( minus_minus @ A @ B2 @ A2 ) ) ) ) ) ).

% ordered_cancel_comm_monoid_diff_class.diff_add_assoc
thf(fact_630_ordered__cancel__comm__monoid__diff__class_Oadd__diff__assoc,axiom,
    ! [A: $tType] :
      ( ( ordere1170586879665033532d_diff @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( plus_plus @ A @ C2 @ ( minus_minus @ A @ B2 @ A2 ) )
            = ( minus_minus @ A @ ( plus_plus @ A @ C2 @ B2 ) @ A2 ) ) ) ) ).

% ordered_cancel_comm_monoid_diff_class.add_diff_assoc
thf(fact_631_ordered__cancel__comm__monoid__diff__class_Ole__diff__conv2,axiom,
    ! [A: $tType] :
      ( ( ordere1170586879665033532d_diff @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ C2 @ ( minus_minus @ A @ B2 @ A2 ) )
            = ( ord_less_eq @ A @ ( plus_plus @ A @ C2 @ A2 ) @ B2 ) ) ) ) ).

% ordered_cancel_comm_monoid_diff_class.le_diff_conv2
thf(fact_632_le__add__diff,axiom,
    ! [A: $tType] :
      ( ( ordere1170586879665033532d_diff @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ord_less_eq @ A @ C2 @ ( minus_minus @ A @ ( plus_plus @ A @ B2 @ C2 ) @ A2 ) ) ) ) ).

% le_add_diff
thf(fact_633_diff__add,axiom,
    ! [A: $tType] :
      ( ( ordere1170586879665033532d_diff @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( plus_plus @ A @ ( minus_minus @ A @ B2 @ A2 ) @ A2 )
            = B2 ) ) ) ).

% diff_add
thf(fact_634_le__diff__eq,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ ( minus_minus @ A @ C2 @ B2 ) )
          = ( ord_less_eq @ A @ ( plus_plus @ A @ A2 @ B2 ) @ C2 ) ) ) ).

% le_diff_eq
thf(fact_635_diff__le__eq,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ ( minus_minus @ A @ A2 @ B2 ) @ C2 )
          = ( ord_less_eq @ A @ A2 @ ( plus_plus @ A @ C2 @ B2 ) ) ) ) ).

% diff_le_eq
thf(fact_636_pinf_I9_J,axiom,
    ! [B: $tType] :
      ( ( ( plus @ B )
        & ( linorder @ B )
        & ( dvd @ B ) )
     => ! [D2: B,S2: B] :
        ? [Z3: B] :
        ! [X5: B] :
          ( ( ord_less @ B @ Z3 @ X5 )
         => ( ( dvd_dvd @ B @ D2 @ ( plus_plus @ B @ X5 @ S2 ) )
            = ( dvd_dvd @ B @ D2 @ ( plus_plus @ B @ X5 @ S2 ) ) ) ) ) ).

% pinf(9)
thf(fact_637_pinf_I10_J,axiom,
    ! [B: $tType] :
      ( ( ( plus @ B )
        & ( linorder @ B )
        & ( dvd @ B ) )
     => ! [D2: B,S2: B] :
        ? [Z3: B] :
        ! [X5: B] :
          ( ( ord_less @ B @ Z3 @ X5 )
         => ( ( ~ ( dvd_dvd @ B @ D2 @ ( plus_plus @ B @ X5 @ S2 ) ) )
            = ( ~ ( dvd_dvd @ B @ D2 @ ( plus_plus @ B @ X5 @ S2 ) ) ) ) ) ) ).

% pinf(10)
thf(fact_638_minf_I9_J,axiom,
    ! [B: $tType] :
      ( ( ( plus @ B )
        & ( linorder @ B )
        & ( dvd @ B ) )
     => ! [D2: B,S2: B] :
        ? [Z3: B] :
        ! [X5: B] :
          ( ( ord_less @ B @ X5 @ Z3 )
         => ( ( dvd_dvd @ B @ D2 @ ( plus_plus @ B @ X5 @ S2 ) )
            = ( dvd_dvd @ B @ D2 @ ( plus_plus @ B @ X5 @ S2 ) ) ) ) ) ).

% minf(9)
thf(fact_639_minf_I10_J,axiom,
    ! [B: $tType] :
      ( ( ( plus @ B )
        & ( linorder @ B )
        & ( dvd @ B ) )
     => ! [D2: B,S2: B] :
        ? [Z3: B] :
        ! [X5: B] :
          ( ( ord_less @ B @ X5 @ Z3 )
         => ( ( ~ ( dvd_dvd @ B @ D2 @ ( plus_plus @ B @ X5 @ S2 ) ) )
            = ( ~ ( dvd_dvd @ B @ D2 @ ( plus_plus @ B @ X5 @ S2 ) ) ) ) ) ) ).

% minf(10)
thf(fact_640_diff__less__eq,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less @ A @ ( minus_minus @ A @ A2 @ B2 ) @ C2 )
          = ( ord_less @ A @ A2 @ ( plus_plus @ A @ C2 @ B2 ) ) ) ) ).

% diff_less_eq
thf(fact_641_less__diff__eq,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ ( minus_minus @ A @ C2 @ B2 ) )
          = ( ord_less @ A @ ( plus_plus @ A @ A2 @ B2 ) @ C2 ) ) ) ).

% less_diff_eq
thf(fact_642_of__nat__xor__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M: nat,N: nat] :
          ( ( semiring_1_of_nat @ A @ ( bit_se5824344971392196577ns_xor @ nat @ M @ N ) )
          = ( bit_se5824344971392196577ns_xor @ A @ ( semiring_1_of_nat @ A @ M ) @ ( semiring_1_of_nat @ A @ N ) ) ) ) ).

% of_nat_xor_eq
thf(fact_643_real__sqrt__ge__one,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( one_one @ real ) @ X )
     => ( ord_less_eq @ real @ ( one_one @ real ) @ ( sqrt @ X ) ) ) ).

% real_sqrt_ge_one
thf(fact_644_of__int__xor__eq,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [K: int,L: int] :
          ( ( ring_1_of_int @ A @ ( bit_se5824344971392196577ns_xor @ int @ K @ L ) )
          = ( bit_se5824344971392196577ns_xor @ A @ ( ring_1_of_int @ A @ K ) @ ( ring_1_of_int @ A @ L ) ) ) ) ).

% of_int_xor_eq
thf(fact_645_one__plus__numeral__commute,axiom,
    ! [A: $tType] :
      ( ( numeral @ A )
     => ! [X: num] :
          ( ( plus_plus @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ X ) )
          = ( plus_plus @ A @ ( numeral_numeral @ A @ X ) @ ( one_one @ A ) ) ) ) ).

% one_plus_numeral_commute
thf(fact_646_of__nat__diff,axiom,
    ! [A: $tType] :
      ( ( semiring_1_cancel @ A )
     => ! [N: nat,M: nat] :
          ( ( ord_less_eq @ nat @ N @ M )
         => ( ( semiring_1_of_nat @ A @ ( minus_minus @ nat @ M @ N ) )
            = ( minus_minus @ A @ ( semiring_1_of_nat @ A @ M ) @ ( semiring_1_of_nat @ A @ N ) ) ) ) ) ).

% of_nat_diff
thf(fact_647_is__unit__power__iff,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,N: nat] :
          ( ( dvd_dvd @ A @ ( power_power @ A @ A2 @ N ) @ ( one_one @ A ) )
          = ( ( dvd_dvd @ A @ A2 @ ( one_one @ A ) )
            | ( N
              = ( zero_zero @ nat ) ) ) ) ) ).

% is_unit_power_iff
thf(fact_648_or__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A,B2: A] :
          ( ( ( bit_se1065995026697491101ons_or @ A @ A2 @ B2 )
            = ( zero_zero @ A ) )
          = ( ( A2
              = ( zero_zero @ A ) )
            & ( B2
              = ( zero_zero @ A ) ) ) ) ) ).

% or_eq_0_iff
thf(fact_649_bit_Odisj__zero__right,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X: A] :
          ( ( bit_se1065995026697491101ons_or @ A @ X @ ( zero_zero @ A ) )
          = X ) ) ).

% bit.disj_zero_right
thf(fact_650_odd__even__add,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [A2: A,B2: A] :
          ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
         => ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B2 )
           => ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( plus_plus @ A @ A2 @ B2 ) ) ) ) ) ).

% odd_even_add
thf(fact_651_take__bit__tightened__less__eq__nat,axiom,
    ! [M: nat,N: nat,Q3: nat] :
      ( ( ord_less_eq @ nat @ M @ N )
     => ( ord_less_eq @ nat @ ( bit_se2584673776208193580ke_bit @ nat @ M @ Q3 ) @ ( bit_se2584673776208193580ke_bit @ nat @ N @ Q3 ) ) ) ).

% take_bit_tightened_less_eq_nat
thf(fact_652_take__bit__nat__less__eq__self,axiom,
    ! [N: nat,M: nat] : ( ord_less_eq @ nat @ ( bit_se2584673776208193580ke_bit @ nat @ N @ M ) @ M ) ).

% take_bit_nat_less_eq_self
thf(fact_653_real__sqrt__less__mono,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less @ real @ X @ Y )
     => ( ord_less @ real @ ( sqrt @ X ) @ ( sqrt @ Y ) ) ) ).

% real_sqrt_less_mono
thf(fact_654_real__sqrt__le__mono,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less_eq @ real @ X @ Y )
     => ( ord_less_eq @ real @ ( sqrt @ X ) @ ( sqrt @ Y ) ) ) ).

% real_sqrt_le_mono
thf(fact_655_odd__one,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( one_one @ A ) ) ) ).

% odd_one
thf(fact_656_real__sqrt__power,axiom,
    ! [X: real,K: nat] :
      ( ( sqrt @ ( power_power @ real @ X @ K ) )
      = ( power_power @ real @ ( sqrt @ X ) @ K ) ) ).

% real_sqrt_power
thf(fact_657_diff__eq__diff__less__eq,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ( minus_minus @ A @ A2 @ B2 )
            = ( minus_minus @ A @ C2 @ D2 ) )
         => ( ( ord_less_eq @ A @ A2 @ B2 )
            = ( ord_less_eq @ A @ C2 @ D2 ) ) ) ) ).

% diff_eq_diff_less_eq
thf(fact_658_diff__right__mono,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ord_less_eq @ A @ ( minus_minus @ A @ A2 @ C2 ) @ ( minus_minus @ A @ B2 @ C2 ) ) ) ) ).

% diff_right_mono
thf(fact_659_diff__left__mono,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( ord_less_eq @ A @ B2 @ A2 )
         => ( ord_less_eq @ A @ ( minus_minus @ A @ C2 @ A2 ) @ ( minus_minus @ A @ C2 @ B2 ) ) ) ) ).

% diff_left_mono
thf(fact_660_diff__mono,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A,B2: A,D2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ D2 @ C2 )
           => ( ord_less_eq @ A @ ( minus_minus @ A @ A2 @ C2 ) @ ( minus_minus @ A @ B2 @ D2 ) ) ) ) ) ).

% diff_mono
thf(fact_661_eq__iff__diff__eq__0,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ( ( ^ [Y3: A,Z2: A] : ( Y3 = Z2 ) )
        = ( ^ [A3: A,B3: A] :
              ( ( minus_minus @ A @ A3 @ B3 )
              = ( zero_zero @ A ) ) ) ) ) ).

% eq_iff_diff_eq_0
thf(fact_662_diff__strict__right__mono,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ord_less @ A @ ( minus_minus @ A @ A2 @ C2 ) @ ( minus_minus @ A @ B2 @ C2 ) ) ) ) ).

% diff_strict_right_mono
thf(fact_663_diff__strict__left__mono,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( ord_less @ A @ B2 @ A2 )
         => ( ord_less @ A @ ( minus_minus @ A @ C2 @ A2 ) @ ( minus_minus @ A @ C2 @ B2 ) ) ) ) ).

% diff_strict_left_mono
thf(fact_664_diff__eq__diff__less,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ( minus_minus @ A @ A2 @ B2 )
            = ( minus_minus @ A @ C2 @ D2 ) )
         => ( ( ord_less @ A @ A2 @ B2 )
            = ( ord_less @ A @ C2 @ D2 ) ) ) ) ).

% diff_eq_diff_less
thf(fact_665_diff__strict__mono,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A,B2: A,D2: A,C2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_less @ A @ D2 @ C2 )
           => ( ord_less @ A @ ( minus_minus @ A @ A2 @ C2 ) @ ( minus_minus @ A @ B2 @ D2 ) ) ) ) ) ).

% diff_strict_mono
thf(fact_666_add__le__imp__le__right,axiom,
    ! [A: $tType] :
      ( ( ordere2412721322843649153imp_le @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ A2 @ C2 ) @ ( plus_plus @ A @ B2 @ C2 ) )
         => ( ord_less_eq @ A @ A2 @ B2 ) ) ) ).

% add_le_imp_le_right
thf(fact_667_add__le__imp__le__left,axiom,
    ! [A: $tType] :
      ( ( ordere2412721322843649153imp_le @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ C2 @ A2 ) @ ( plus_plus @ A @ C2 @ B2 ) )
         => ( ord_less_eq @ A @ A2 @ B2 ) ) ) ).

% add_le_imp_le_left
thf(fact_668_le__iff__add,axiom,
    ! [A: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [A3: A,B3: A] :
            ? [C4: A] :
              ( B3
              = ( plus_plus @ A @ A3 @ C4 ) ) ) ) ) ).

% le_iff_add
thf(fact_669_add__right__mono,axiom,
    ! [A: $tType] :
      ( ( ordere6658533253407199908up_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ord_less_eq @ A @ ( plus_plus @ A @ A2 @ C2 ) @ ( plus_plus @ A @ B2 @ C2 ) ) ) ) ).

% add_right_mono
thf(fact_670_less__eqE,axiom,
    ! [A: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ~ ! [C3: A] :
                ( B2
               != ( plus_plus @ A @ A2 @ C3 ) ) ) ) ).

% less_eqE
thf(fact_671_add__left__mono,axiom,
    ! [A: $tType] :
      ( ( ordere6658533253407199908up_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ord_less_eq @ A @ ( plus_plus @ A @ C2 @ A2 ) @ ( plus_plus @ A @ C2 @ B2 ) ) ) ) ).

% add_left_mono
thf(fact_672_add__mono,axiom,
    ! [A: $tType] :
      ( ( ordere6658533253407199908up_add @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ C2 @ D2 )
           => ( ord_less_eq @ A @ ( plus_plus @ A @ A2 @ C2 ) @ ( plus_plus @ A @ B2 @ D2 ) ) ) ) ) ).

% add_mono
thf(fact_673_add__mono__thms__linordered__semiring_I1_J,axiom,
    ! [A: $tType] :
      ( ( ordere6658533253407199908up_add @ A )
     => ! [I: A,J: A,K: A,L: A] :
          ( ( ( ord_less_eq @ A @ I @ J )
            & ( ord_less_eq @ A @ K @ L ) )
         => ( ord_less_eq @ A @ ( plus_plus @ A @ I @ K ) @ ( plus_plus @ A @ J @ L ) ) ) ) ).

% add_mono_thms_linordered_semiring(1)
thf(fact_674_add__mono__thms__linordered__semiring_I2_J,axiom,
    ! [A: $tType] :
      ( ( ordere6658533253407199908up_add @ A )
     => ! [I: A,J: A,K: A,L: A] :
          ( ( ( I = J )
            & ( ord_less_eq @ A @ K @ L ) )
         => ( ord_less_eq @ A @ ( plus_plus @ A @ I @ K ) @ ( plus_plus @ A @ J @ L ) ) ) ) ).

% add_mono_thms_linordered_semiring(2)
thf(fact_675_add__mono__thms__linordered__semiring_I3_J,axiom,
    ! [A: $tType] :
      ( ( ordere6658533253407199908up_add @ A )
     => ! [I: A,J: A,K: A,L: A] :
          ( ( ( ord_less_eq @ A @ I @ J )
            & ( K = L ) )
         => ( ord_less_eq @ A @ ( plus_plus @ A @ I @ K ) @ ( plus_plus @ A @ J @ L ) ) ) ) ).

% add_mono_thms_linordered_semiring(3)
thf(fact_676_comm__monoid__add__class_Oadd__0,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A2: A] :
          ( ( plus_plus @ A @ ( zero_zero @ A ) @ A2 )
          = A2 ) ) ).

% comm_monoid_add_class.add_0
thf(fact_677_add_Ocomm__neutral,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A2: A] :
          ( ( plus_plus @ A @ A2 @ ( zero_zero @ A ) )
          = A2 ) ) ).

% add.comm_neutral
thf(fact_678_add_Ogroup__left__neutral,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A] :
          ( ( plus_plus @ A @ ( zero_zero @ A ) @ A2 )
          = A2 ) ) ).

% add.group_left_neutral
thf(fact_679_verit__sum__simplify,axiom,
    ! [A: $tType] :
      ( ( cancel1802427076303600483id_add @ A )
     => ! [A2: A] :
          ( ( plus_plus @ A @ A2 @ ( zero_zero @ A ) )
          = A2 ) ) ).

% verit_sum_simplify
thf(fact_680_dvd__power__same,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [X: A,Y: A,N: nat] :
          ( ( dvd_dvd @ A @ X @ Y )
         => ( dvd_dvd @ A @ ( power_power @ A @ X @ N ) @ ( power_power @ A @ Y @ N ) ) ) ) ).

% dvd_power_same
thf(fact_681_add__less__imp__less__right,axiom,
    ! [A: $tType] :
      ( ( ordere2412721322843649153imp_le @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ord_less @ A @ ( plus_plus @ A @ A2 @ C2 ) @ ( plus_plus @ A @ B2 @ C2 ) )
         => ( ord_less @ A @ A2 @ B2 ) ) ) ).

% add_less_imp_less_right
thf(fact_682_add__less__imp__less__left,axiom,
    ! [A: $tType] :
      ( ( ordere2412721322843649153imp_le @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less @ A @ ( plus_plus @ A @ C2 @ A2 ) @ ( plus_plus @ A @ C2 @ B2 ) )
         => ( ord_less @ A @ A2 @ B2 ) ) ) ).

% add_less_imp_less_left
thf(fact_683_add__strict__right__mono,axiom,
    ! [A: $tType] :
      ( ( ordere580206878836729694up_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ord_less @ A @ ( plus_plus @ A @ A2 @ C2 ) @ ( plus_plus @ A @ B2 @ C2 ) ) ) ) ).

% add_strict_right_mono
thf(fact_684_add__strict__left__mono,axiom,
    ! [A: $tType] :
      ( ( ordere580206878836729694up_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ord_less @ A @ ( plus_plus @ A @ C2 @ A2 ) @ ( plus_plus @ A @ C2 @ B2 ) ) ) ) ).

% add_strict_left_mono
thf(fact_685_add__strict__mono,axiom,
    ! [A: $tType] :
      ( ( strict9044650504122735259up_add @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_less @ A @ C2 @ D2 )
           => ( ord_less @ A @ ( plus_plus @ A @ A2 @ C2 ) @ ( plus_plus @ A @ B2 @ D2 ) ) ) ) ) ).

% add_strict_mono
thf(fact_686_add__mono__thms__linordered__field_I1_J,axiom,
    ! [A: $tType] :
      ( ( ordere580206878836729694up_add @ A )
     => ! [I: A,J: A,K: A,L: A] :
          ( ( ( ord_less @ A @ I @ J )
            & ( K = L ) )
         => ( ord_less @ A @ ( plus_plus @ A @ I @ K ) @ ( plus_plus @ A @ J @ L ) ) ) ) ).

% add_mono_thms_linordered_field(1)
thf(fact_687_add__mono__thms__linordered__field_I2_J,axiom,
    ! [A: $tType] :
      ( ( ordere580206878836729694up_add @ A )
     => ! [I: A,J: A,K: A,L: A] :
          ( ( ( I = J )
            & ( ord_less @ A @ K @ L ) )
         => ( ord_less @ A @ ( plus_plus @ A @ I @ K ) @ ( plus_plus @ A @ J @ L ) ) ) ) ).

% add_mono_thms_linordered_field(2)
thf(fact_688_add__mono__thms__linordered__field_I5_J,axiom,
    ! [A: $tType] :
      ( ( ordere580206878836729694up_add @ A )
     => ! [I: A,J: A,K: A,L: A] :
          ( ( ( ord_less @ A @ I @ J )
            & ( ord_less @ A @ K @ L ) )
         => ( ord_less @ A @ ( plus_plus @ A @ I @ K ) @ ( plus_plus @ A @ J @ L ) ) ) ) ).

% add_mono_thms_linordered_field(5)
thf(fact_689_minus__int__code_I1_J,axiom,
    ! [K: int] :
      ( ( minus_minus @ int @ K @ ( zero_zero @ int ) )
      = K ) ).

% minus_int_code(1)
thf(fact_690_le__numeral__extra_I4_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ( ord_less_eq @ A @ ( one_one @ A ) @ ( one_one @ A ) ) ) ).

% le_numeral_extra(4)
thf(fact_691_plus__int__code_I2_J,axiom,
    ! [L: int] :
      ( ( plus_plus @ int @ ( zero_zero @ int ) @ L )
      = L ) ).

% plus_int_code(2)
thf(fact_692_plus__int__code_I1_J,axiom,
    ! [K: int] :
      ( ( plus_plus @ int @ K @ ( zero_zero @ int ) )
      = K ) ).

% plus_int_code(1)
thf(fact_693_less__numeral__extra_I4_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ~ ( ord_less @ A @ ( one_one @ A ) @ ( one_one @ A ) ) ) ).

% less_numeral_extra(4)
thf(fact_694_int__diff__cases,axiom,
    ! [Z: int] :
      ~ ! [M4: nat,N2: nat] :
          ( Z
         != ( minus_minus @ int @ ( semiring_1_of_nat @ int @ M4 ) @ ( semiring_1_of_nat @ int @ N2 ) ) ) ).

% int_diff_cases
thf(fact_695_max__diff__distrib__left,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [X: A,Y: A,Z: A] :
          ( ( minus_minus @ A @ ( ord_max @ A @ X @ Y ) @ Z )
          = ( ord_max @ A @ ( minus_minus @ A @ X @ Z ) @ ( minus_minus @ A @ Y @ Z ) ) ) ) ).

% max_diff_distrib_left
thf(fact_696_max__add__distrib__right,axiom,
    ! [A: $tType] :
      ( ( ordere2412721322843649153imp_le @ A )
     => ! [X: A,Y: A,Z: A] :
          ( ( plus_plus @ A @ X @ ( ord_max @ A @ Y @ Z ) )
          = ( ord_max @ A @ ( plus_plus @ A @ X @ Y ) @ ( plus_plus @ A @ X @ Z ) ) ) ) ).

% max_add_distrib_right
thf(fact_697_max__add__distrib__left,axiom,
    ! [A: $tType] :
      ( ( ordere2412721322843649153imp_le @ A )
     => ! [X: A,Y: A,Z: A] :
          ( ( plus_plus @ A @ ( ord_max @ A @ X @ Y ) @ Z )
          = ( ord_max @ A @ ( plus_plus @ A @ X @ Z ) @ ( plus_plus @ A @ Y @ Z ) ) ) ) ).

% max_add_distrib_left
thf(fact_698_take__bit__add,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [N: nat,A2: A,B2: A] :
          ( ( bit_se2584673776208193580ke_bit @ A @ N @ ( plus_plus @ A @ ( bit_se2584673776208193580ke_bit @ A @ N @ A2 ) @ ( bit_se2584673776208193580ke_bit @ A @ N @ B2 ) ) )
          = ( bit_se2584673776208193580ke_bit @ A @ N @ ( plus_plus @ A @ A2 @ B2 ) ) ) ) ).

% take_bit_add
thf(fact_699_take__bit__diff,axiom,
    ! [N: nat,K: int,L: int] :
      ( ( bit_se2584673776208193580ke_bit @ int @ N @ ( minus_minus @ int @ ( bit_se2584673776208193580ke_bit @ int @ N @ K ) @ ( bit_se2584673776208193580ke_bit @ int @ N @ L ) ) )
      = ( bit_se2584673776208193580ke_bit @ int @ N @ ( minus_minus @ int @ K @ L ) ) ) ).

% take_bit_diff
thf(fact_700_even__or__iff,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A,B2: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se1065995026697491101ons_or @ A @ A2 @ B2 ) )
          = ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
            & ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B2 ) ) ) ) ).

% even_or_iff
thf(fact_701_even__xor__iff,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A,B2: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se5824344971392196577ns_xor @ A @ A2 @ B2 ) )
          = ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
            = ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B2 ) ) ) ) ).

% even_xor_iff
thf(fact_702_dvd__power__iff,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [X: A,M: nat,N: nat] :
          ( ( X
           != ( zero_zero @ A ) )
         => ( ( dvd_dvd @ A @ ( power_power @ A @ X @ M ) @ ( power_power @ A @ X @ N ) )
            = ( ( dvd_dvd @ A @ X @ ( one_one @ A ) )
              | ( ord_less_eq @ nat @ M @ N ) ) ) ) ) ).

% dvd_power_iff
thf(fact_703_dvd__power,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [N: nat,X: A] :
          ( ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
            | ( X
              = ( one_one @ A ) ) )
         => ( dvd_dvd @ A @ X @ ( power_power @ A @ X @ N ) ) ) ) ).

% dvd_power
thf(fact_704_real__sqrt__gt__zero,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ord_less @ real @ ( zero_zero @ real ) @ ( sqrt @ X ) ) ) ).

% real_sqrt_gt_zero
thf(fact_705_real__sqrt__eq__zero__cancel,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( ( sqrt @ X )
          = ( zero_zero @ real ) )
       => ( X
          = ( zero_zero @ real ) ) ) ) ).

% real_sqrt_eq_zero_cancel
thf(fact_706_real__sqrt__ge__zero,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( sqrt @ X ) ) ) ).

% real_sqrt_ge_zero
thf(fact_707_or__greater__eq,axiom,
    ! [L: int,K: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ L )
     => ( ord_less_eq @ int @ K @ ( bit_se1065995026697491101ons_or @ int @ K @ L ) ) ) ).

% or_greater_eq
thf(fact_708_OR__lower,axiom,
    ! [X: int,Y: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ X )
     => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Y )
       => ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( bit_se1065995026697491101ons_or @ int @ X @ Y ) ) ) ) ).

% OR_lower
thf(fact_709_even__numeral,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [N: num] : ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( numeral_numeral @ A @ ( bit0 @ N ) ) ) ) ).

% even_numeral
thf(fact_710_XOR__lower,axiom,
    ! [X: int,Y: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ X )
     => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Y )
       => ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( bit_se5824344971392196577ns_xor @ int @ X @ Y ) ) ) ) ).

% XOR_lower
thf(fact_711_le__iff__diff__le__0,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [A3: A,B3: A] : ( ord_less_eq @ A @ ( minus_minus @ A @ A3 @ B3 ) @ ( zero_zero @ A ) ) ) ) ) ).

% le_iff_diff_le_0
thf(fact_712_less__iff__diff__less__0,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ( ( ord_less @ A )
        = ( ^ [A3: A,B3: A] : ( ord_less @ A @ ( minus_minus @ A @ A3 @ B3 ) @ ( zero_zero @ A ) ) ) ) ) ).

% less_iff_diff_less_0
thf(fact_713_add__nonpos__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ A @ X @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ Y @ ( zero_zero @ A ) )
           => ( ( ( plus_plus @ A @ X @ Y )
                = ( zero_zero @ A ) )
              = ( ( X
                  = ( zero_zero @ A ) )
                & ( Y
                  = ( zero_zero @ A ) ) ) ) ) ) ) ).

% add_nonpos_eq_0_iff
thf(fact_714_add__nonneg__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ Y )
           => ( ( ( plus_plus @ A @ X @ Y )
                = ( zero_zero @ A ) )
              = ( ( X
                  = ( zero_zero @ A ) )
                & ( Y
                  = ( zero_zero @ A ) ) ) ) ) ) ) ).

% add_nonneg_eq_0_iff
thf(fact_715_add__nonpos__nonpos,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ B2 @ ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ ( plus_plus @ A @ A2 @ B2 ) @ ( zero_zero @ A ) ) ) ) ) ).

% add_nonpos_nonpos
thf(fact_716_add__nonneg__nonneg,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 )
           => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( plus_plus @ A @ A2 @ B2 ) ) ) ) ) ).

% add_nonneg_nonneg
thf(fact_717_add__increasing2,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
         => ( ( ord_less_eq @ A @ B2 @ A2 )
           => ( ord_less_eq @ A @ B2 @ ( plus_plus @ A @ A2 @ C2 ) ) ) ) ) ).

% add_increasing2
thf(fact_718_add__decreasing2,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less_eq @ A @ C2 @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ A2 @ B2 )
           => ( ord_less_eq @ A @ ( plus_plus @ A @ A2 @ C2 ) @ B2 ) ) ) ) ).

% add_decreasing2
thf(fact_719_add__increasing,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less_eq @ A @ B2 @ C2 )
           => ( ord_less_eq @ A @ B2 @ ( plus_plus @ A @ A2 @ C2 ) ) ) ) ) ).

% add_increasing
thf(fact_720_add__decreasing,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ C2 @ B2 )
           => ( ord_less_eq @ A @ ( plus_plus @ A @ A2 @ C2 ) @ B2 ) ) ) ) ).

% add_decreasing
thf(fact_721_add__less__le__mono,axiom,
    ! [A: $tType] :
      ( ( ordere580206878836729694up_add @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ C2 @ D2 )
           => ( ord_less @ A @ ( plus_plus @ A @ A2 @ C2 ) @ ( plus_plus @ A @ B2 @ D2 ) ) ) ) ) ).

% add_less_le_mono
thf(fact_722_add__le__less__mono,axiom,
    ! [A: $tType] :
      ( ( ordere580206878836729694up_add @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less @ A @ C2 @ D2 )
           => ( ord_less @ A @ ( plus_plus @ A @ A2 @ C2 ) @ ( plus_plus @ A @ B2 @ D2 ) ) ) ) ) ).

% add_le_less_mono
thf(fact_723_add__mono__thms__linordered__field_I3_J,axiom,
    ! [A: $tType] :
      ( ( ordere580206878836729694up_add @ A )
     => ! [I: A,J: A,K: A,L: A] :
          ( ( ( ord_less @ A @ I @ J )
            & ( ord_less_eq @ A @ K @ L ) )
         => ( ord_less @ A @ ( plus_plus @ A @ I @ K ) @ ( plus_plus @ A @ J @ L ) ) ) ) ).

% add_mono_thms_linordered_field(3)
thf(fact_724_add__mono__thms__linordered__field_I4_J,axiom,
    ! [A: $tType] :
      ( ( ordere580206878836729694up_add @ A )
     => ! [I: A,J: A,K: A,L: A] :
          ( ( ( ord_less_eq @ A @ I @ J )
            & ( ord_less @ A @ K @ L ) )
         => ( ord_less @ A @ ( plus_plus @ A @ I @ K ) @ ( plus_plus @ A @ J @ L ) ) ) ) ).

% add_mono_thms_linordered_field(4)
thf(fact_725_pos__add__strict,axiom,
    ! [A: $tType] :
      ( ( strict7427464778891057005id_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less @ A @ B2 @ C2 )
           => ( ord_less @ A @ B2 @ ( plus_plus @ A @ A2 @ C2 ) ) ) ) ) ).

% pos_add_strict
thf(fact_726_canonically__ordered__monoid__add__class_OlessE,axiom,
    ! [A: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ~ ! [C3: A] :
                ( ( B2
                  = ( plus_plus @ A @ A2 @ C3 ) )
               => ( C3
                  = ( zero_zero @ A ) ) ) ) ) ).

% canonically_ordered_monoid_add_class.lessE
thf(fact_727_add__pos__pos,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ B2 )
           => ( ord_less @ A @ ( zero_zero @ A ) @ ( plus_plus @ A @ A2 @ B2 ) ) ) ) ) ).

% add_pos_pos
thf(fact_728_add__neg__neg,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ B2 @ ( zero_zero @ A ) )
           => ( ord_less @ A @ ( plus_plus @ A @ A2 @ B2 ) @ ( zero_zero @ A ) ) ) ) ) ).

% add_neg_neg
thf(fact_729_numeral__Bit0,axiom,
    ! [A: $tType] :
      ( ( numeral @ A )
     => ! [N: num] :
          ( ( numeral_numeral @ A @ ( bit0 @ N ) )
          = ( plus_plus @ A @ ( numeral_numeral @ A @ N ) @ ( numeral_numeral @ A @ N ) ) ) ) ).

% numeral_Bit0
thf(fact_730_le__imp__power__dvd,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [M: nat,N: nat,A2: A] :
          ( ( ord_less_eq @ nat @ M @ N )
         => ( dvd_dvd @ A @ ( power_power @ A @ A2 @ M ) @ ( power_power @ A @ A2 @ N ) ) ) ) ).

% le_imp_power_dvd
thf(fact_731_power__le__dvd,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [A2: A,N: nat,B2: A,M: nat] :
          ( ( dvd_dvd @ A @ ( power_power @ A @ A2 @ N ) @ B2 )
         => ( ( ord_less_eq @ nat @ M @ N )
           => ( dvd_dvd @ A @ ( power_power @ A @ A2 @ M ) @ B2 ) ) ) ) ).

% power_le_dvd
thf(fact_732_dvd__power__le,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [X: A,Y: A,N: nat,M: nat] :
          ( ( dvd_dvd @ A @ X @ Y )
         => ( ( ord_less_eq @ nat @ N @ M )
           => ( dvd_dvd @ A @ ( power_power @ A @ X @ N ) @ ( power_power @ A @ Y @ M ) ) ) ) ) ).

% dvd_power_le
thf(fact_733_nat__dvd__not__less,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M )
     => ( ( ord_less @ nat @ M @ N )
       => ~ ( dvd_dvd @ nat @ N @ M ) ) ) ).

% nat_dvd_not_less
thf(fact_734_less__numeral__extra_I1_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ( ord_less @ A @ ( zero_zero @ A ) @ ( one_one @ A ) ) ) ).

% less_numeral_extra(1)
thf(fact_735_one__le__numeral,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [N: num] : ( ord_less_eq @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ N ) ) ) ).

% one_le_numeral
thf(fact_736_not__numeral__less__one,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [N: num] :
          ~ ( ord_less @ A @ ( numeral_numeral @ A @ N ) @ ( one_one @ A ) ) ) ).

% not_numeral_less_one
thf(fact_737_numeral__One,axiom,
    ! [A: $tType] :
      ( ( numeral @ A )
     => ( ( numeral_numeral @ A @ one2 )
        = ( one_one @ A ) ) ) ).

% numeral_One
thf(fact_738_one__le__power,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,N: nat] :
          ( ( ord_less_eq @ A @ ( one_one @ A ) @ A2 )
         => ( ord_less_eq @ A @ ( one_one @ A ) @ ( power_power @ A @ A2 @ N ) ) ) ) ).

% one_le_power
thf(fact_739_power__0,axiom,
    ! [A: $tType] :
      ( ( power @ A )
     => ! [A2: A] :
          ( ( power_power @ A @ A2 @ ( zero_zero @ nat ) )
          = ( one_one @ A ) ) ) ).

% power_0
thf(fact_740_zle__iff__zadd,axiom,
    ( ( ord_less_eq @ int )
    = ( ^ [W3: int,Z6: int] :
        ? [N3: nat] :
          ( Z6
          = ( plus_plus @ int @ W3 @ ( semiring_1_of_nat @ int @ N3 ) ) ) ) ) ).

% zle_iff_zadd
thf(fact_741_real__arch__pow,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ X )
     => ? [N2: nat] : ( ord_less @ real @ Y @ ( power_power @ real @ X @ N2 ) ) ) ).

% real_arch_pow
thf(fact_742_even__of__int__iff,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [K: int] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( ring_1_of_int @ A @ K ) )
          = ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ K ) ) ) ).

% even_of_int_iff
thf(fact_743_even__zero,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( zero_zero @ A ) ) ) ).

% even_zero
thf(fact_744_add__strict__increasing2,axiom,
    ! [A: $tType] :
      ( ( ordere8940638589300402666id_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less @ A @ B2 @ C2 )
           => ( ord_less @ A @ B2 @ ( plus_plus @ A @ A2 @ C2 ) ) ) ) ) ).

% add_strict_increasing2
thf(fact_745_add__strict__increasing,axiom,
    ! [A: $tType] :
      ( ( ordere8940638589300402666id_add @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less_eq @ A @ B2 @ C2 )
           => ( ord_less @ A @ B2 @ ( plus_plus @ A @ A2 @ C2 ) ) ) ) ) ).

% add_strict_increasing
thf(fact_746_add__pos__nonneg,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 )
           => ( ord_less @ A @ ( zero_zero @ A ) @ ( plus_plus @ A @ A2 @ B2 ) ) ) ) ) ).

% add_pos_nonneg
thf(fact_747_add__nonpos__neg,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ B2 @ ( zero_zero @ A ) )
           => ( ord_less @ A @ ( plus_plus @ A @ A2 @ B2 ) @ ( zero_zero @ A ) ) ) ) ) ).

% add_nonpos_neg
thf(fact_748_add__nonneg__pos,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ B2 )
           => ( ord_less @ A @ ( zero_zero @ A ) @ ( plus_plus @ A @ A2 @ B2 ) ) ) ) ) ).

% add_nonneg_pos
thf(fact_749_add__neg__nonpos,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ B2 @ ( zero_zero @ A ) )
           => ( ord_less @ A @ ( plus_plus @ A @ A2 @ B2 ) @ ( zero_zero @ A ) ) ) ) ) ).

% add_neg_nonpos
thf(fact_750_dvd__imp__le,axiom,
    ! [K: nat,N: nat] :
      ( ( dvd_dvd @ nat @ K @ N )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
       => ( ord_less_eq @ nat @ K @ N ) ) ) ).

% dvd_imp_le
thf(fact_751_power__le__one,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,N: nat] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less_eq @ A @ A2 @ ( one_one @ A ) )
           => ( ord_less_eq @ A @ ( power_power @ A @ A2 @ N ) @ ( one_one @ A ) ) ) ) ) ).

% power_le_one
thf(fact_752_power__0__left,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [N: nat] :
          ( ( ( N
              = ( zero_zero @ nat ) )
           => ( ( power_power @ A @ ( zero_zero @ A ) @ N )
              = ( one_one @ A ) ) )
          & ( ( N
             != ( zero_zero @ nat ) )
           => ( ( power_power @ A @ ( zero_zero @ A ) @ N )
              = ( zero_zero @ A ) ) ) ) ) ).

% power_0_left
thf(fact_753_power__strict__increasing,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [N: nat,N4: nat,A2: A] :
          ( ( ord_less @ nat @ N @ N4 )
         => ( ( ord_less @ A @ ( one_one @ A ) @ A2 )
           => ( ord_less @ A @ ( power_power @ A @ A2 @ N ) @ ( power_power @ A @ A2 @ N4 ) ) ) ) ) ).

% power_strict_increasing
thf(fact_754_power__less__imp__less__exp,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,M: nat,N: nat] :
          ( ( ord_less @ A @ ( one_one @ A ) @ A2 )
         => ( ( ord_less @ A @ ( power_power @ A @ A2 @ M ) @ ( power_power @ A @ A2 @ N ) )
           => ( ord_less @ nat @ M @ N ) ) ) ) ).

% power_less_imp_less_exp
thf(fact_755_power__increasing,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [N: nat,N4: nat,A2: A] :
          ( ( ord_less_eq @ nat @ N @ N4 )
         => ( ( ord_less_eq @ A @ ( one_one @ A ) @ A2 )
           => ( ord_less_eq @ A @ ( power_power @ A @ A2 @ N ) @ ( power_power @ A @ A2 @ N4 ) ) ) ) ) ).

% power_increasing
thf(fact_756_real__arch__pow__inv,axiom,
    ! [Y: real,X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ Y )
     => ( ( ord_less @ real @ X @ ( one_one @ real ) )
       => ? [N2: nat] : ( ord_less @ real @ ( power_power @ real @ X @ N2 ) @ Y ) ) ) ).

% real_arch_pow_inv
thf(fact_757_power__mono__odd,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N: nat,A2: A,B2: A] :
          ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
         => ( ( ord_less_eq @ A @ A2 @ B2 )
           => ( ord_less_eq @ A @ ( power_power @ A @ A2 @ N ) @ ( power_power @ A @ B2 @ N ) ) ) ) ) ).

% power_mono_odd
thf(fact_758_odd__pos,axiom,
    ! [N: nat] :
      ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
     => ( ord_less @ nat @ ( zero_zero @ nat ) @ N ) ) ).

% odd_pos
thf(fact_759_sqrt2__less__2,axiom,
    ord_less @ real @ ( sqrt @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ).

% sqrt2_less_2
thf(fact_760_nat__take__bit__eq,axiom,
    ! [K: int,N: nat] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ K )
     => ( ( nat2 @ ( bit_se2584673776208193580ke_bit @ int @ N @ K ) )
        = ( bit_se2584673776208193580ke_bit @ nat @ N @ ( nat2 @ K ) ) ) ) ).

% nat_take_bit_eq
thf(fact_761_take__bit__nat__eq,axiom,
    ! [K: int,N: nat] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ K )
     => ( ( bit_se2584673776208193580ke_bit @ nat @ N @ ( nat2 @ K ) )
        = ( nat2 @ ( bit_se2584673776208193580ke_bit @ int @ N @ K ) ) ) ) ).

% take_bit_nat_eq
thf(fact_762_power2__commute,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [X: A,Y: A] :
          ( ( power_power @ A @ ( minus_minus @ A @ X @ Y ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
          = ( power_power @ A @ ( minus_minus @ A @ Y @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ).

% power2_commute
thf(fact_763_power__strict__decreasing,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [N: nat,N4: nat,A2: A] :
          ( ( ord_less @ nat @ N @ N4 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
           => ( ( ord_less @ A @ A2 @ ( one_one @ A ) )
             => ( ord_less @ A @ ( power_power @ A @ A2 @ N4 ) @ ( power_power @ A @ A2 @ N ) ) ) ) ) ) ).

% power_strict_decreasing
thf(fact_764_power__decreasing,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [N: nat,N4: nat,A2: A] :
          ( ( ord_less_eq @ nat @ N @ N4 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
           => ( ( ord_less_eq @ A @ A2 @ ( one_one @ A ) )
             => ( ord_less_eq @ A @ ( power_power @ A @ A2 @ N4 ) @ ( power_power @ A @ A2 @ N ) ) ) ) ) ) ).

% power_decreasing
thf(fact_765_power__le__imp__le__exp,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,M: nat,N: nat] :
          ( ( ord_less @ A @ ( one_one @ A ) @ A2 )
         => ( ( ord_less_eq @ A @ ( power_power @ A @ A2 @ M ) @ ( power_power @ A @ A2 @ N ) )
           => ( ord_less_eq @ nat @ M @ N ) ) ) ) ).

% power_le_imp_le_exp
thf(fact_766_self__le__power,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,N: nat] :
          ( ( ord_less_eq @ A @ ( one_one @ A ) @ A2 )
         => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
           => ( ord_less_eq @ A @ A2 @ ( power_power @ A @ A2 @ N ) ) ) ) ) ).

% self_le_power
thf(fact_767_one__power2,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ( ( power_power @ A @ ( one_one @ A ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
        = ( one_one @ A ) ) ) ).

% one_power2
thf(fact_768_one__less__power,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,N: nat] :
          ( ( ord_less @ A @ ( one_one @ A ) @ A2 )
         => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
           => ( ord_less @ A @ ( one_one @ A ) @ ( power_power @ A @ A2 @ N ) ) ) ) ) ).

% one_less_power
thf(fact_769_zero__le__even__power,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N: nat,A2: A] :
          ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
         => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( power_power @ A @ A2 @ N ) ) ) ) ).

% zero_le_even_power
thf(fact_770_zero__le__odd__power,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N: nat,A2: A] :
          ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( power_power @ A @ A2 @ N ) )
            = ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 ) ) ) ) ).

% zero_le_odd_power
thf(fact_771_zero__le__power__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A,N: nat] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( power_power @ A @ A2 @ N ) )
          = ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
            | ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
              & ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 ) ) ) ) ) ).

% zero_le_power_eq
thf(fact_772_take__bit__nat__eq__self__iff,axiom,
    ! [N: nat,M: nat] :
      ( ( ( bit_se2584673776208193580ke_bit @ nat @ N @ M )
        = M )
      = ( ord_less @ nat @ M @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ) ).

% take_bit_nat_eq_self_iff
thf(fact_773_take__bit__nat__less__exp,axiom,
    ! [N: nat,M: nat] : ( ord_less @ nat @ ( bit_se2584673776208193580ke_bit @ nat @ N @ M ) @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ).

% take_bit_nat_less_exp
thf(fact_774_take__bit__nat__eq__self,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ M @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) )
     => ( ( bit_se2584673776208193580ke_bit @ nat @ N @ M )
        = M ) ) ).

% take_bit_nat_eq_self
thf(fact_775_log__of__power__eq,axiom,
    ! [M: nat,B2: real,N: nat] :
      ( ( ( semiring_1_of_nat @ real @ M )
        = ( power_power @ real @ B2 @ N ) )
     => ( ( ord_less @ real @ ( one_one @ real ) @ B2 )
       => ( ( semiring_1_of_nat @ real @ N )
          = ( log2 @ B2 @ ( semiring_1_of_nat @ real @ M ) ) ) ) ) ).

% log_of_power_eq
thf(fact_776_less__log__of__power,axiom,
    ! [B2: real,N: nat,M: real] :
      ( ( ord_less @ real @ ( power_power @ real @ B2 @ N ) @ M )
     => ( ( ord_less @ real @ ( one_one @ real ) @ B2 )
       => ( ord_less @ real @ ( semiring_1_of_nat @ real @ N ) @ ( log2 @ B2 @ M ) ) ) ) ).

% less_log_of_power
thf(fact_777_real__less__rsqrt,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less @ real @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ Y )
     => ( ord_less @ real @ X @ ( sqrt @ Y ) ) ) ).

% real_less_rsqrt
thf(fact_778_real__le__rsqrt,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less_eq @ real @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ Y )
     => ( ord_less_eq @ real @ X @ ( sqrt @ Y ) ) ) ).

% real_le_rsqrt
thf(fact_779_sqrt__le__D,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less_eq @ real @ ( sqrt @ X ) @ Y )
     => ( ord_less_eq @ real @ X @ ( power_power @ real @ Y @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ).

% sqrt_le_D
thf(fact_780_zero__less__power__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A,N: nat] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( power_power @ A @ A2 @ N ) )
          = ( ( N
              = ( zero_zero @ nat ) )
            | ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
              & ( A2
               != ( zero_zero @ A ) ) )
            | ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
              & ( ord_less @ A @ ( zero_zero @ A ) @ A2 ) ) ) ) ) ).

% zero_less_power_eq
thf(fact_781_dvd__power__iff__le,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ K )
     => ( ( dvd_dvd @ nat @ ( power_power @ nat @ K @ M ) @ ( power_power @ nat @ K @ N ) )
        = ( ord_less_eq @ nat @ M @ N ) ) ) ).

% dvd_power_iff_le
thf(fact_782_two__realpow__ge__one,axiom,
    ! [N: nat] : ( ord_less_eq @ real @ ( one_one @ real ) @ ( power_power @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ N ) ) ).

% two_realpow_ge_one
thf(fact_783_take__bit__nat__less__self__iff,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less @ nat @ ( bit_se2584673776208193580ke_bit @ nat @ N @ M ) @ M )
      = ( ord_less_eq @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) @ M ) ) ).

% take_bit_nat_less_self_iff
thf(fact_784_real__sqrt__unique,axiom,
    ! [Y: real,X: real] :
      ( ( ( power_power @ real @ Y @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
        = X )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y )
       => ( ( sqrt @ X )
          = Y ) ) ) ).

% real_sqrt_unique
thf(fact_785_real__le__lsqrt,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y )
       => ( ( ord_less_eq @ real @ X @ ( power_power @ real @ Y @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
         => ( ord_less_eq @ real @ ( sqrt @ X ) @ Y ) ) ) ) ).

% real_le_lsqrt
thf(fact_786_le__log__of__power,axiom,
    ! [B2: real,N: nat,M: real] :
      ( ( ord_less_eq @ real @ ( power_power @ real @ B2 @ N ) @ M )
     => ( ( ord_less @ real @ ( one_one @ real ) @ B2 )
       => ( ord_less_eq @ real @ ( semiring_1_of_nat @ real @ N ) @ ( log2 @ B2 @ M ) ) ) ) ).

% le_log_of_power
thf(fact_787_power__le__zero__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A,N: nat] :
          ( ( ord_less_eq @ A @ ( power_power @ A @ A2 @ N ) @ ( zero_zero @ A ) )
          = ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
            & ( ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
                & ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) ) )
              | ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
                & ( A2
                  = ( zero_zero @ A ) ) ) ) ) ) ) ).

% power_le_zero_eq
thf(fact_788_take__bit__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,A2: A] :
          ( ( ( bit_se2584673776208193580ke_bit @ A @ N @ A2 )
            = ( zero_zero @ A ) )
          = ( dvd_dvd @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) @ A2 ) ) ) ).

% take_bit_eq_0_iff
thf(fact_789_sum__power2__le__zero__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ ( power_power @ A @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ A @ Y @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( zero_zero @ A ) )
          = ( ( X
              = ( zero_zero @ A ) )
            & ( Y
              = ( zero_zero @ A ) ) ) ) ) ).

% sum_power2_le_zero_iff
thf(fact_790_sum__power2__ge__zero,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: A,Y: A] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( plus_plus @ A @ ( power_power @ A @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ A @ Y @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% sum_power2_ge_zero
thf(fact_791_sum__power2__gt__zero__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( plus_plus @ A @ ( power_power @ A @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ A @ Y @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
          = ( ( X
             != ( zero_zero @ A ) )
            | ( Y
             != ( zero_zero @ A ) ) ) ) ) ).

% sum_power2_gt_zero_iff
thf(fact_792_not__sum__power2__lt__zero,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: A,Y: A] :
          ~ ( ord_less @ A @ ( plus_plus @ A @ ( power_power @ A @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ A @ Y @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( zero_zero @ A ) ) ) ).

% not_sum_power2_lt_zero
thf(fact_793_real__less__lsqrt,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y )
       => ( ( ord_less @ real @ X @ ( power_power @ real @ Y @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
         => ( ord_less @ real @ ( sqrt @ X ) @ Y ) ) ) ) ).

% real_less_lsqrt
thf(fact_794_pow__divides__pow__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [N: nat,A2: A,B2: A] :
          ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
         => ( ( dvd_dvd @ A @ ( power_power @ A @ A2 @ N ) @ ( power_power @ A @ B2 @ N ) )
            = ( dvd_dvd @ A @ A2 @ B2 ) ) ) ) ).

% pow_divides_pow_iff
thf(fact_795_le__add__diff__inverse2,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less_eq @ A @ B2 @ A2 )
         => ( ( plus_plus @ A @ ( minus_minus @ A @ A2 @ B2 ) @ B2 )
            = A2 ) ) ) ).

% le_add_diff_inverse2
thf(fact_796_le__add__diff__inverse,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less_eq @ A @ B2 @ A2 )
         => ( ( plus_plus @ A @ B2 @ ( minus_minus @ A @ A2 @ B2 ) )
            = A2 ) ) ) ).

% le_add_diff_inverse
thf(fact_797_arcosh__1,axiom,
    ! [A: $tType] :
      ( ( ln @ A )
     => ( ( arcosh @ A @ ( one_one @ A ) )
        = ( zero_zero @ A ) ) ) ).

% arcosh_1
thf(fact_798_dvd__0__right,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [A2: A] : ( dvd_dvd @ A @ A2 @ ( zero_zero @ A ) ) ) ).

% dvd_0_right
thf(fact_799_dvd__0__left__iff,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [A2: A] :
          ( ( dvd_dvd @ A @ ( zero_zero @ A ) @ A2 )
          = ( A2
            = ( zero_zero @ A ) ) ) ) ).

% dvd_0_left_iff
thf(fact_800_zero__less__two,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ( ord_less @ A @ ( zero_zero @ A ) @ ( plus_plus @ A @ ( one_one @ A ) @ ( one_one @ A ) ) ) ) ).

% zero_less_two
thf(fact_801_discrete,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ( ( ord_less @ A )
        = ( ^ [A3: A] : ( ord_less_eq @ A @ ( plus_plus @ A @ A3 @ ( one_one @ A ) ) ) ) ) ) ).

% discrete
thf(fact_802_field__le__epsilon,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A,Y: A] :
          ( ! [E: A] :
              ( ( ord_less @ A @ ( zero_zero @ A ) @ E )
             => ( ord_less_eq @ A @ X @ ( plus_plus @ A @ Y @ E ) ) )
         => ( ord_less_eq @ A @ X @ Y ) ) ) ).

% field_le_epsilon
thf(fact_803_dbl__simps_I3_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( neg_numeral_dbl @ A @ ( one_one @ A ) )
        = ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ).

% dbl_simps(3)
thf(fact_804_of__nat__dvd__iff,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [M: nat,N: nat] :
          ( ( dvd_dvd @ A @ ( semiring_1_of_nat @ A @ M ) @ ( semiring_1_of_nat @ A @ N ) )
          = ( dvd_dvd @ nat @ M @ N ) ) ) ).

% of_nat_dvd_iff
thf(fact_805_idiff__0__right,axiom,
    ! [N: extended_enat] :
      ( ( minus_minus @ extended_enat @ N @ ( zero_zero @ extended_enat ) )
      = N ) ).

% idiff_0_right
thf(fact_806_idiff__0,axiom,
    ! [N: extended_enat] :
      ( ( minus_minus @ extended_enat @ ( zero_zero @ extended_enat ) @ N )
      = ( zero_zero @ extended_enat ) ) ).

% idiff_0
thf(fact_807_Nat_Oadd__0__right,axiom,
    ! [M: nat] :
      ( ( plus_plus @ nat @ M @ ( zero_zero @ nat ) )
      = M ) ).

% Nat.add_0_right
thf(fact_808_add__is__0,axiom,
    ! [M: nat,N: nat] :
      ( ( ( plus_plus @ nat @ M @ N )
        = ( zero_zero @ nat ) )
      = ( ( M
          = ( zero_zero @ nat ) )
        & ( N
          = ( zero_zero @ nat ) ) ) ) ).

% add_is_0
thf(fact_809_nat__add__left__cancel__less,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( ord_less @ nat @ ( plus_plus @ nat @ K @ M ) @ ( plus_plus @ nat @ K @ N ) )
      = ( ord_less @ nat @ M @ N ) ) ).

% nat_add_left_cancel_less
thf(fact_810_diff__self__eq__0,axiom,
    ! [M: nat] :
      ( ( minus_minus @ nat @ M @ M )
      = ( zero_zero @ nat ) ) ).

% diff_self_eq_0
thf(fact_811_diff__0__eq__0,axiom,
    ! [N: nat] :
      ( ( minus_minus @ nat @ ( zero_zero @ nat ) @ N )
      = ( zero_zero @ nat ) ) ).

% diff_0_eq_0
thf(fact_812_nat__add__left__cancel__le,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ ( plus_plus @ nat @ K @ M ) @ ( plus_plus @ nat @ K @ N ) )
      = ( ord_less_eq @ nat @ M @ N ) ) ).

% nat_add_left_cancel_le
thf(fact_813_power__one__right,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [A2: A] :
          ( ( power_power @ A @ A2 @ ( one_one @ nat ) )
          = A2 ) ) ).

% power_one_right
thf(fact_814_diff__diff__cancel,axiom,
    ! [I: nat,N: nat] :
      ( ( ord_less_eq @ nat @ I @ N )
     => ( ( minus_minus @ nat @ N @ ( minus_minus @ nat @ N @ I ) )
        = I ) ) ).

% diff_diff_cancel
thf(fact_815_diff__diff__left,axiom,
    ! [I: nat,J: nat,K: nat] :
      ( ( minus_minus @ nat @ ( minus_minus @ nat @ I @ J ) @ K )
      = ( minus_minus @ nat @ I @ ( plus_plus @ nat @ J @ K ) ) ) ).

% diff_diff_left
thf(fact_816_nat__dvd__1__iff__1,axiom,
    ! [M: nat] :
      ( ( dvd_dvd @ nat @ M @ ( one_one @ nat ) )
      = ( M
        = ( one_one @ nat ) ) ) ).

% nat_dvd_1_iff_1
thf(fact_817_semiring__norm_I6_J,axiom,
    ! [M: num,N: num] :
      ( ( plus_plus @ num @ ( bit0 @ M ) @ ( bit0 @ N ) )
      = ( bit0 @ ( plus_plus @ num @ M @ N ) ) ) ).

% semiring_norm(6)
thf(fact_818_dbl__simps_I2_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( neg_numeral_dbl @ A @ ( zero_zero @ A ) )
        = ( zero_zero @ A ) ) ) ).

% dbl_simps(2)
thf(fact_819_add__gr__0,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( plus_plus @ nat @ M @ N ) )
      = ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M )
        | ( ord_less @ nat @ ( zero_zero @ nat ) @ N ) ) ) ).

% add_gr_0
thf(fact_820_zero__less__diff,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( minus_minus @ nat @ N @ M ) )
      = ( ord_less @ nat @ M @ N ) ) ).

% zero_less_diff
thf(fact_821_diff__is__0__eq_H,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ M @ N )
     => ( ( minus_minus @ nat @ M @ N )
        = ( zero_zero @ nat ) ) ) ).

% diff_is_0_eq'
thf(fact_822_diff__is__0__eq,axiom,
    ! [M: nat,N: nat] :
      ( ( ( minus_minus @ nat @ M @ N )
        = ( zero_zero @ nat ) )
      = ( ord_less_eq @ nat @ M @ N ) ) ).

% diff_is_0_eq
thf(fact_823_less__one,axiom,
    ! [N: nat] :
      ( ( ord_less @ nat @ N @ ( one_one @ nat ) )
      = ( N
        = ( zero_zero @ nat ) ) ) ).

% less_one
thf(fact_824_Nat_Odiff__diff__right,axiom,
    ! [K: nat,J: nat,I: nat] :
      ( ( ord_less_eq @ nat @ K @ J )
     => ( ( minus_minus @ nat @ I @ ( minus_minus @ nat @ J @ K ) )
        = ( minus_minus @ nat @ ( plus_plus @ nat @ I @ K ) @ J ) ) ) ).

% Nat.diff_diff_right
thf(fact_825_Nat_Oadd__diff__assoc2,axiom,
    ! [K: nat,J: nat,I: nat] :
      ( ( ord_less_eq @ nat @ K @ J )
     => ( ( plus_plus @ nat @ ( minus_minus @ nat @ J @ K ) @ I )
        = ( minus_minus @ nat @ ( plus_plus @ nat @ J @ I ) @ K ) ) ) ).

% Nat.add_diff_assoc2
thf(fact_826_Nat_Oadd__diff__assoc,axiom,
    ! [K: nat,J: nat,I: nat] :
      ( ( ord_less_eq @ nat @ K @ J )
     => ( ( plus_plus @ nat @ I @ ( minus_minus @ nat @ J @ K ) )
        = ( minus_minus @ nat @ ( plus_plus @ nat @ I @ J ) @ K ) ) ) ).

% Nat.add_diff_assoc
thf(fact_827_semiring__norm_I2_J,axiom,
    ( ( plus_plus @ num @ one2 @ one2 )
    = ( bit0 @ one2 ) ) ).

% semiring_norm(2)
thf(fact_828_int__dvd__int__iff,axiom,
    ! [M: nat,N: nat] :
      ( ( dvd_dvd @ int @ ( semiring_1_of_nat @ int @ M ) @ ( semiring_1_of_nat @ int @ N ) )
      = ( dvd_dvd @ nat @ M @ N ) ) ).

% int_dvd_int_iff
thf(fact_829_dbl__simps_I5_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [K: num] :
          ( ( neg_numeral_dbl @ A @ ( numeral_numeral @ A @ K ) )
          = ( numeral_numeral @ A @ ( bit0 @ K ) ) ) ) ).

% dbl_simps(5)
thf(fact_830_zle__add1__eq__le,axiom,
    ! [W: int,Z: int] :
      ( ( ord_less @ int @ W @ ( plus_plus @ int @ Z @ ( one_one @ int ) ) )
      = ( ord_less_eq @ int @ W @ Z ) ) ).

% zle_add1_eq_le
thf(fact_831_zle__diff1__eq,axiom,
    ! [W: int,Z: int] :
      ( ( ord_less_eq @ int @ W @ ( minus_minus @ int @ Z @ ( one_one @ int ) ) )
      = ( ord_less @ int @ W @ Z ) ) ).

% zle_diff1_eq
thf(fact_832_diff__nat__numeral,axiom,
    ! [V: num,V3: num] :
      ( ( minus_minus @ nat @ ( numeral_numeral @ nat @ V ) @ ( numeral_numeral @ nat @ V3 ) )
      = ( nat2 @ ( minus_minus @ int @ ( numeral_numeral @ int @ V ) @ ( numeral_numeral @ int @ V3 ) ) ) ) ).

% diff_nat_numeral
thf(fact_833_even__diff__nat,axiom,
    ! [M: nat,N: nat] :
      ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ M @ N ) )
      = ( ( ord_less @ nat @ M @ N )
        | ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( plus_plus @ nat @ M @ N ) ) ) ) ).

% even_diff_nat
thf(fact_834_nat__numeral__diff__1,axiom,
    ! [V: num] :
      ( ( minus_minus @ nat @ ( numeral_numeral @ nat @ V ) @ ( one_one @ nat ) )
      = ( nat2 @ ( minus_minus @ int @ ( numeral_numeral @ int @ V ) @ ( one_one @ int ) ) ) ) ).

% nat_numeral_diff_1
thf(fact_835_diff__add__inverse2,axiom,
    ! [M: nat,N: nat] :
      ( ( minus_minus @ nat @ ( plus_plus @ nat @ M @ N ) @ N )
      = M ) ).

% diff_add_inverse2
thf(fact_836_diff__add__inverse,axiom,
    ! [N: nat,M: nat] :
      ( ( minus_minus @ nat @ ( plus_plus @ nat @ N @ M ) @ N )
      = M ) ).

% diff_add_inverse
thf(fact_837_diff__commute,axiom,
    ! [I: nat,J: nat,K: nat] :
      ( ( minus_minus @ nat @ ( minus_minus @ nat @ I @ J ) @ K )
      = ( minus_minus @ nat @ ( minus_minus @ nat @ I @ K ) @ J ) ) ).

% diff_commute
thf(fact_838_diff__cancel2,axiom,
    ! [M: nat,K: nat,N: nat] :
      ( ( minus_minus @ nat @ ( plus_plus @ nat @ M @ K ) @ ( plus_plus @ nat @ N @ K ) )
      = ( minus_minus @ nat @ M @ N ) ) ).

% diff_cancel2
thf(fact_839_Nat_Odiff__cancel,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( minus_minus @ nat @ ( plus_plus @ nat @ K @ M ) @ ( plus_plus @ nat @ K @ N ) )
      = ( minus_minus @ nat @ M @ N ) ) ).

% Nat.diff_cancel
thf(fact_840_diff__add__0,axiom,
    ! [N: nat,M: nat] :
      ( ( minus_minus @ nat @ N @ ( plus_plus @ nat @ N @ M ) )
      = ( zero_zero @ nat ) ) ).

% diff_add_0
thf(fact_841_add__diff__inverse__nat,axiom,
    ! [M: nat,N: nat] :
      ( ~ ( ord_less @ nat @ M @ N )
     => ( ( plus_plus @ nat @ N @ ( minus_minus @ nat @ M @ N ) )
        = M ) ) ).

% add_diff_inverse_nat
thf(fact_842_less__diff__conv,axiom,
    ! [I: nat,J: nat,K: nat] :
      ( ( ord_less @ nat @ I @ ( minus_minus @ nat @ J @ K ) )
      = ( ord_less @ nat @ ( plus_plus @ nat @ I @ K ) @ J ) ) ).

% less_diff_conv
thf(fact_843_Nat_Ole__imp__diff__is__add,axiom,
    ! [I: nat,J: nat,K: nat] :
      ( ( ord_less_eq @ nat @ I @ J )
     => ( ( ( minus_minus @ nat @ J @ I )
          = K )
        = ( J
          = ( plus_plus @ nat @ K @ I ) ) ) ) ).

% Nat.le_imp_diff_is_add
thf(fact_844_Nat_Odiff__add__assoc2,axiom,
    ! [K: nat,J: nat,I: nat] :
      ( ( ord_less_eq @ nat @ K @ J )
     => ( ( minus_minus @ nat @ ( plus_plus @ nat @ J @ I ) @ K )
        = ( plus_plus @ nat @ ( minus_minus @ nat @ J @ K ) @ I ) ) ) ).

% Nat.diff_add_assoc2
thf(fact_845_Nat_Odiff__add__assoc,axiom,
    ! [K: nat,J: nat,I: nat] :
      ( ( ord_less_eq @ nat @ K @ J )
     => ( ( minus_minus @ nat @ ( plus_plus @ nat @ I @ J ) @ K )
        = ( plus_plus @ nat @ I @ ( minus_minus @ nat @ J @ K ) ) ) ) ).

% Nat.diff_add_assoc
thf(fact_846_Nat_Ole__diff__conv2,axiom,
    ! [K: nat,J: nat,I: nat] :
      ( ( ord_less_eq @ nat @ K @ J )
     => ( ( ord_less_eq @ nat @ I @ ( minus_minus @ nat @ J @ K ) )
        = ( ord_less_eq @ nat @ ( plus_plus @ nat @ I @ K ) @ J ) ) ) ).

% Nat.le_diff_conv2
thf(fact_847_le__diff__conv,axiom,
    ! [J: nat,K: nat,I: nat] :
      ( ( ord_less_eq @ nat @ ( minus_minus @ nat @ J @ K ) @ I )
      = ( ord_less_eq @ nat @ J @ ( plus_plus @ nat @ I @ K ) ) ) ).

% le_diff_conv
thf(fact_848_int__ops_I2_J,axiom,
    ( ( semiring_1_of_nat @ int @ ( one_one @ nat ) )
    = ( one_one @ int ) ) ).

% int_ops(2)
thf(fact_849_nat__one__as__int,axiom,
    ( ( one_one @ nat )
    = ( nat2 @ ( one_one @ int ) ) ) ).

% nat_one_as_int
thf(fact_850_Euclid__induct,axiom,
    ! [P: nat > nat > $o,A2: nat,B2: nat] :
      ( ! [A5: nat,B4: nat] :
          ( ( P @ A5 @ B4 )
          = ( P @ B4 @ A5 ) )
     => ( ! [A5: nat] : ( P @ A5 @ ( zero_zero @ nat ) )
       => ( ! [A5: nat,B4: nat] :
              ( ( P @ A5 @ B4 )
             => ( P @ A5 @ ( plus_plus @ nat @ A5 @ B4 ) ) )
         => ( P @ A2 @ B2 ) ) ) ) ).

% Euclid_induct
thf(fact_851_nat__minus__add__max,axiom,
    ! [N: nat,M: nat] :
      ( ( plus_plus @ nat @ ( minus_minus @ nat @ N @ M ) @ M )
      = ( ord_max @ nat @ N @ M ) ) ).

% nat_minus_add_max
thf(fact_852_add__diff__assoc__enat,axiom,
    ! [Z: extended_enat,Y: extended_enat,X: extended_enat] :
      ( ( ord_less_eq @ extended_enat @ Z @ Y )
     => ( ( plus_plus @ extended_enat @ X @ ( minus_minus @ extended_enat @ Y @ Z ) )
        = ( minus_minus @ extended_enat @ ( plus_plus @ extended_enat @ X @ Y ) @ Z ) ) ) ).

% add_diff_assoc_enat
thf(fact_853_nat__diff__split,axiom,
    ! [P: nat > $o,A2: nat,B2: nat] :
      ( ( P @ ( minus_minus @ nat @ A2 @ B2 ) )
      = ( ( ( ord_less @ nat @ A2 @ B2 )
         => ( P @ ( zero_zero @ nat ) ) )
        & ! [D4: nat] :
            ( ( A2
              = ( plus_plus @ nat @ B2 @ D4 ) )
           => ( P @ D4 ) ) ) ) ).

% nat_diff_split
thf(fact_854_nat__diff__split__asm,axiom,
    ! [P: nat > $o,A2: nat,B2: nat] :
      ( ( P @ ( minus_minus @ nat @ A2 @ B2 ) )
      = ( ~ ( ( ( ord_less @ nat @ A2 @ B2 )
              & ~ ( P @ ( zero_zero @ nat ) ) )
            | ? [D4: nat] :
                ( ( A2
                  = ( plus_plus @ nat @ B2 @ D4 ) )
                & ~ ( P @ D4 ) ) ) ) ) ).

% nat_diff_split_asm
thf(fact_855_less__diff__conv2,axiom,
    ! [K: nat,J: nat,I: nat] :
      ( ( ord_less_eq @ nat @ K @ J )
     => ( ( ord_less @ nat @ ( minus_minus @ nat @ J @ K ) @ I )
        = ( ord_less @ nat @ J @ ( plus_plus @ nat @ I @ K ) ) ) ) ).

% less_diff_conv2
thf(fact_856_add__One__commute,axiom,
    ! [N: num] :
      ( ( plus_plus @ num @ one2 @ N )
      = ( plus_plus @ num @ N @ one2 ) ) ).

% add_One_commute
thf(fact_857_diffs0__imp__equal,axiom,
    ! [M: nat,N: nat] :
      ( ( ( minus_minus @ nat @ M @ N )
        = ( zero_zero @ nat ) )
     => ( ( ( minus_minus @ nat @ N @ M )
          = ( zero_zero @ nat ) )
       => ( M = N ) ) ) ).

% diffs0_imp_equal
thf(fact_858_minus__nat_Odiff__0,axiom,
    ! [M: nat] :
      ( ( minus_minus @ nat @ M @ ( zero_zero @ nat ) )
      = M ) ).

% minus_nat.diff_0
thf(fact_859_diff__less__mono2,axiom,
    ! [M: nat,N: nat,L: nat] :
      ( ( ord_less @ nat @ M @ N )
     => ( ( ord_less @ nat @ M @ L )
       => ( ord_less @ nat @ ( minus_minus @ nat @ L @ N ) @ ( minus_minus @ nat @ L @ M ) ) ) ) ).

% diff_less_mono2
thf(fact_860_less__imp__diff__less,axiom,
    ! [J: nat,K: nat,N: nat] :
      ( ( ord_less @ nat @ J @ K )
     => ( ord_less @ nat @ ( minus_minus @ nat @ J @ N ) @ K ) ) ).

% less_imp_diff_less
thf(fact_861_eq__diff__iff,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ K @ M )
     => ( ( ord_less_eq @ nat @ K @ N )
       => ( ( ( minus_minus @ nat @ M @ K )
            = ( minus_minus @ nat @ N @ K ) )
          = ( M = N ) ) ) ) ).

% eq_diff_iff
thf(fact_862_le__diff__iff,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ K @ M )
     => ( ( ord_less_eq @ nat @ K @ N )
       => ( ( ord_less_eq @ nat @ ( minus_minus @ nat @ M @ K ) @ ( minus_minus @ nat @ N @ K ) )
          = ( ord_less_eq @ nat @ M @ N ) ) ) ) ).

% le_diff_iff
thf(fact_863_Nat_Odiff__diff__eq,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ K @ M )
     => ( ( ord_less_eq @ nat @ K @ N )
       => ( ( minus_minus @ nat @ ( minus_minus @ nat @ M @ K ) @ ( minus_minus @ nat @ N @ K ) )
          = ( minus_minus @ nat @ M @ N ) ) ) ) ).

% Nat.diff_diff_eq
thf(fact_864_diff__le__mono,axiom,
    ! [M: nat,N: nat,L: nat] :
      ( ( ord_less_eq @ nat @ M @ N )
     => ( ord_less_eq @ nat @ ( minus_minus @ nat @ M @ L ) @ ( minus_minus @ nat @ N @ L ) ) ) ).

% diff_le_mono
thf(fact_865_diff__le__self,axiom,
    ! [M: nat,N: nat] : ( ord_less_eq @ nat @ ( minus_minus @ nat @ M @ N ) @ M ) ).

% diff_le_self
thf(fact_866_le__diff__iff_H,axiom,
    ! [A2: nat,C2: nat,B2: nat] :
      ( ( ord_less_eq @ nat @ A2 @ C2 )
     => ( ( ord_less_eq @ nat @ B2 @ C2 )
       => ( ( ord_less_eq @ nat @ ( minus_minus @ nat @ C2 @ A2 ) @ ( minus_minus @ nat @ C2 @ B2 ) )
          = ( ord_less_eq @ nat @ B2 @ A2 ) ) ) ) ).

% le_diff_iff'
thf(fact_867_diff__le__mono2,axiom,
    ! [M: nat,N: nat,L: nat] :
      ( ( ord_less_eq @ nat @ M @ N )
     => ( ord_less_eq @ nat @ ( minus_minus @ nat @ L @ N ) @ ( minus_minus @ nat @ L @ M ) ) ) ).

% diff_le_mono2
thf(fact_868_add__eq__self__zero,axiom,
    ! [M: nat,N: nat] :
      ( ( ( plus_plus @ nat @ M @ N )
        = M )
     => ( N
        = ( zero_zero @ nat ) ) ) ).

% add_eq_self_zero
thf(fact_869_plus__nat_Oadd__0,axiom,
    ! [N: nat] :
      ( ( plus_plus @ nat @ ( zero_zero @ nat ) @ N )
      = N ) ).

% plus_nat.add_0
thf(fact_870_add__lessD1,axiom,
    ! [I: nat,J: nat,K: nat] :
      ( ( ord_less @ nat @ ( plus_plus @ nat @ I @ J ) @ K )
     => ( ord_less @ nat @ I @ K ) ) ).

% add_lessD1
thf(fact_871_add__less__mono,axiom,
    ! [I: nat,J: nat,K: nat,L: nat] :
      ( ( ord_less @ nat @ I @ J )
     => ( ( ord_less @ nat @ K @ L )
       => ( ord_less @ nat @ ( plus_plus @ nat @ I @ K ) @ ( plus_plus @ nat @ J @ L ) ) ) ) ).

% add_less_mono
thf(fact_872_not__add__less1,axiom,
    ! [I: nat,J: nat] :
      ~ ( ord_less @ nat @ ( plus_plus @ nat @ I @ J ) @ I ) ).

% not_add_less1
thf(fact_873_not__add__less2,axiom,
    ! [J: nat,I: nat] :
      ~ ( ord_less @ nat @ ( plus_plus @ nat @ J @ I ) @ I ) ).

% not_add_less2
thf(fact_874_add__less__mono1,axiom,
    ! [I: nat,J: nat,K: nat] :
      ( ( ord_less @ nat @ I @ J )
     => ( ord_less @ nat @ ( plus_plus @ nat @ I @ K ) @ ( plus_plus @ nat @ J @ K ) ) ) ).

% add_less_mono1
thf(fact_875_trans__less__add1,axiom,
    ! [I: nat,J: nat,M: nat] :
      ( ( ord_less @ nat @ I @ J )
     => ( ord_less @ nat @ I @ ( plus_plus @ nat @ J @ M ) ) ) ).

% trans_less_add1
thf(fact_876_trans__less__add2,axiom,
    ! [I: nat,J: nat,M: nat] :
      ( ( ord_less @ nat @ I @ J )
     => ( ord_less @ nat @ I @ ( plus_plus @ nat @ M @ J ) ) ) ).

% trans_less_add2
thf(fact_877_less__add__eq__less,axiom,
    ! [K: nat,L: nat,M: nat,N: nat] :
      ( ( ord_less @ nat @ K @ L )
     => ( ( ( plus_plus @ nat @ M @ L )
          = ( plus_plus @ nat @ K @ N ) )
       => ( ord_less @ nat @ M @ N ) ) ) ).

% less_add_eq_less
thf(fact_878_add__leE,axiom,
    ! [M: nat,K: nat,N: nat] :
      ( ( ord_less_eq @ nat @ ( plus_plus @ nat @ M @ K ) @ N )
     => ~ ( ( ord_less_eq @ nat @ M @ N )
         => ~ ( ord_less_eq @ nat @ K @ N ) ) ) ).

% add_leE
thf(fact_879_le__add1,axiom,
    ! [N: nat,M: nat] : ( ord_less_eq @ nat @ N @ ( plus_plus @ nat @ N @ M ) ) ).

% le_add1
thf(fact_880_le__add2,axiom,
    ! [N: nat,M: nat] : ( ord_less_eq @ nat @ N @ ( plus_plus @ nat @ M @ N ) ) ).

% le_add2
thf(fact_881_add__leD1,axiom,
    ! [M: nat,K: nat,N: nat] :
      ( ( ord_less_eq @ nat @ ( plus_plus @ nat @ M @ K ) @ N )
     => ( ord_less_eq @ nat @ M @ N ) ) ).

% add_leD1
thf(fact_882_add__leD2,axiom,
    ! [M: nat,K: nat,N: nat] :
      ( ( ord_less_eq @ nat @ ( plus_plus @ nat @ M @ K ) @ N )
     => ( ord_less_eq @ nat @ K @ N ) ) ).

% add_leD2
thf(fact_883_le__Suc__ex,axiom,
    ! [K: nat,L: nat] :
      ( ( ord_less_eq @ nat @ K @ L )
     => ? [N2: nat] :
          ( L
          = ( plus_plus @ nat @ K @ N2 ) ) ) ).

% le_Suc_ex
thf(fact_884_add__le__mono,axiom,
    ! [I: nat,J: nat,K: nat,L: nat] :
      ( ( ord_less_eq @ nat @ I @ J )
     => ( ( ord_less_eq @ nat @ K @ L )
       => ( ord_less_eq @ nat @ ( plus_plus @ nat @ I @ K ) @ ( plus_plus @ nat @ J @ L ) ) ) ) ).

% add_le_mono
thf(fact_885_add__le__mono1,axiom,
    ! [I: nat,J: nat,K: nat] :
      ( ( ord_less_eq @ nat @ I @ J )
     => ( ord_less_eq @ nat @ ( plus_plus @ nat @ I @ K ) @ ( plus_plus @ nat @ J @ K ) ) ) ).

% add_le_mono1
thf(fact_886_trans__le__add1,axiom,
    ! [I: nat,J: nat,M: nat] :
      ( ( ord_less_eq @ nat @ I @ J )
     => ( ord_less_eq @ nat @ I @ ( plus_plus @ nat @ J @ M ) ) ) ).

% trans_le_add1
thf(fact_887_trans__le__add2,axiom,
    ! [I: nat,J: nat,M: nat] :
      ( ( ord_less_eq @ nat @ I @ J )
     => ( ord_less_eq @ nat @ I @ ( plus_plus @ nat @ M @ J ) ) ) ).

% trans_le_add2
thf(fact_888_nat__le__iff__add,axiom,
    ( ( ord_less_eq @ nat )
    = ( ^ [M3: nat,N3: nat] :
        ? [K3: nat] :
          ( N3
          = ( plus_plus @ nat @ M3 @ K3 ) ) ) ) ).

% nat_le_iff_add
thf(fact_889_zdvd__zdiffD,axiom,
    ! [K: int,M: int,N: int] :
      ( ( dvd_dvd @ int @ K @ ( minus_minus @ int @ M @ N ) )
     => ( ( dvd_dvd @ int @ K @ N )
       => ( dvd_dvd @ int @ K @ M ) ) ) ).

% zdvd_zdiffD
thf(fact_890_dvd__diff__nat,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( dvd_dvd @ nat @ K @ M )
     => ( ( dvd_dvd @ nat @ K @ N )
       => ( dvd_dvd @ nat @ K @ ( minus_minus @ nat @ M @ N ) ) ) ) ).

% dvd_diff_nat
thf(fact_891_iadd__is__0,axiom,
    ! [M: extended_enat,N: extended_enat] :
      ( ( ( plus_plus @ extended_enat @ M @ N )
        = ( zero_zero @ extended_enat ) )
      = ( ( M
          = ( zero_zero @ extended_enat ) )
        & ( N
          = ( zero_zero @ extended_enat ) ) ) ) ).

% iadd_is_0
thf(fact_892_nat__add__max__left,axiom,
    ! [M: nat,N: nat,Q3: nat] :
      ( ( plus_plus @ nat @ ( ord_max @ nat @ M @ N ) @ Q3 )
      = ( ord_max @ nat @ ( plus_plus @ nat @ M @ Q3 ) @ ( plus_plus @ nat @ N @ Q3 ) ) ) ).

% nat_add_max_left
thf(fact_893_nat__add__max__right,axiom,
    ! [M: nat,N: nat,Q3: nat] :
      ( ( plus_plus @ nat @ M @ ( ord_max @ nat @ N @ Q3 ) )
      = ( ord_max @ nat @ ( plus_plus @ nat @ M @ N ) @ ( plus_plus @ nat @ M @ Q3 ) ) ) ).

% nat_add_max_right
thf(fact_894_zero__one__enat__neq_I1_J,axiom,
    ( zero_zero @ extended_enat )
 != ( one_one @ extended_enat ) ).

% zero_one_enat_neq(1)
thf(fact_895_nat__1__add__1,axiom,
    ( ( plus_plus @ nat @ ( one_one @ nat ) @ ( one_one @ nat ) )
    = ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ).

% nat_1_add_1
thf(fact_896_nat__induct2,axiom,
    ! [P: nat > $o,N: nat] :
      ( ( P @ ( zero_zero @ nat ) )
     => ( ( P @ ( one_one @ nat ) )
       => ( ! [N2: nat] :
              ( ( P @ N2 )
             => ( P @ ( plus_plus @ nat @ N2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
         => ( P @ N ) ) ) ) ).

% nat_induct2
thf(fact_897_diff__less,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M )
       => ( ord_less @ nat @ ( minus_minus @ nat @ M @ N ) @ M ) ) ) ).

% diff_less
thf(fact_898_less__diff__iff,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ K @ M )
     => ( ( ord_less_eq @ nat @ K @ N )
       => ( ( ord_less @ nat @ ( minus_minus @ nat @ M @ K ) @ ( minus_minus @ nat @ N @ K ) )
          = ( ord_less @ nat @ M @ N ) ) ) ) ).

% less_diff_iff
thf(fact_899_diff__less__mono,axiom,
    ! [A2: nat,B2: nat,C2: nat] :
      ( ( ord_less @ nat @ A2 @ B2 )
     => ( ( ord_less_eq @ nat @ C2 @ A2 )
       => ( ord_less @ nat @ ( minus_minus @ nat @ A2 @ C2 ) @ ( minus_minus @ nat @ B2 @ C2 ) ) ) ) ).

% diff_less_mono
thf(fact_900_zdvd__antisym__nonneg,axiom,
    ! [M: int,N: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ M )
     => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ N )
       => ( ( dvd_dvd @ int @ M @ N )
         => ( ( dvd_dvd @ int @ N @ M )
           => ( M = N ) ) ) ) ) ).

% zdvd_antisym_nonneg
thf(fact_901_zdvd__not__zless,axiom,
    ! [M: int,N: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ M )
     => ( ( ord_less @ int @ M @ N )
       => ~ ( dvd_dvd @ int @ N @ M ) ) ) ).

% zdvd_not_zless
thf(fact_902_less__imp__add__positive,axiom,
    ! [I: nat,J: nat] :
      ( ( ord_less @ nat @ I @ J )
     => ? [K2: nat] :
          ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K2 )
          & ( ( plus_plus @ nat @ I @ K2 )
            = J ) ) ) ).

% less_imp_add_positive
thf(fact_903_ex__has__greatest__nat__lemma,axiom,
    ! [A: $tType,P: A > $o,K: A,F2: A > nat,N: nat] :
      ( ( P @ K )
     => ( ! [X3: A] :
            ( ( P @ X3 )
           => ? [Y6: A] :
                ( ( P @ Y6 )
                & ~ ( ord_less_eq @ nat @ ( F2 @ Y6 ) @ ( F2 @ X3 ) ) ) )
       => ? [Y5: A] :
            ( ( P @ Y5 )
            & ~ ( ord_less @ nat @ ( F2 @ Y5 ) @ ( plus_plus @ nat @ ( F2 @ K ) @ N ) ) ) ) ) ).

% ex_has_greatest_nat_lemma
thf(fact_904_mono__nat__linear__lb,axiom,
    ! [F2: nat > nat,M: nat,K: nat] :
      ( ! [M4: nat,N2: nat] :
          ( ( ord_less @ nat @ M4 @ N2 )
         => ( ord_less @ nat @ ( F2 @ M4 ) @ ( F2 @ N2 ) ) )
     => ( ord_less_eq @ nat @ ( plus_plus @ nat @ ( F2 @ M ) @ K ) @ ( F2 @ ( plus_plus @ nat @ M @ K ) ) ) ) ).

% mono_nat_linear_lb
thf(fact_905_dvd__minus__self,axiom,
    ! [M: nat,N: nat] :
      ( ( dvd_dvd @ nat @ M @ ( minus_minus @ nat @ N @ M ) )
      = ( ( ord_less @ nat @ N @ M )
        | ( dvd_dvd @ nat @ M @ N ) ) ) ).

% dvd_minus_self
thf(fact_906_dbl__def,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( neg_numeral_dbl @ A )
        = ( ^ [X2: A] : ( plus_plus @ A @ X2 @ X2 ) ) ) ) ).

% dbl_def
thf(fact_907_less__eq__dvd__minus,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ M @ N )
     => ( ( dvd_dvd @ nat @ M @ N )
        = ( dvd_dvd @ nat @ M @ ( minus_minus @ nat @ N @ M ) ) ) ) ).

% less_eq_dvd_minus
thf(fact_908_dvd__diffD1,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( dvd_dvd @ nat @ K @ ( minus_minus @ nat @ M @ N ) )
     => ( ( dvd_dvd @ nat @ K @ M )
       => ( ( ord_less_eq @ nat @ N @ M )
         => ( dvd_dvd @ nat @ K @ N ) ) ) ) ).

% dvd_diffD1
thf(fact_909_dvd__diffD,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( dvd_dvd @ nat @ K @ ( minus_minus @ nat @ M @ N ) )
     => ( ( dvd_dvd @ nat @ K @ N )
       => ( ( ord_less_eq @ nat @ N @ M )
         => ( dvd_dvd @ nat @ K @ M ) ) ) ) ).

% dvd_diffD
thf(fact_910_numerals_I1_J,axiom,
    ( ( numeral_numeral @ nat @ one2 )
    = ( one_one @ nat ) ) ).

% numerals(1)
thf(fact_911_int__ops_I5_J,axiom,
    ! [A2: nat,B2: nat] :
      ( ( semiring_1_of_nat @ int @ ( plus_plus @ nat @ A2 @ B2 ) )
      = ( plus_plus @ int @ ( semiring_1_of_nat @ int @ A2 ) @ ( semiring_1_of_nat @ int @ B2 ) ) ) ).

% int_ops(5)
thf(fact_912_int__plus,axiom,
    ! [N: nat,M: nat] :
      ( ( semiring_1_of_nat @ int @ ( plus_plus @ nat @ N @ M ) )
      = ( plus_plus @ int @ ( semiring_1_of_nat @ int @ N ) @ ( semiring_1_of_nat @ int @ M ) ) ) ).

% int_plus
thf(fact_913_zadd__int__left,axiom,
    ! [M: nat,N: nat,Z: int] :
      ( ( plus_plus @ int @ ( semiring_1_of_nat @ int @ M ) @ ( plus_plus @ int @ ( semiring_1_of_nat @ int @ N ) @ Z ) )
      = ( plus_plus @ int @ ( semiring_1_of_nat @ int @ ( plus_plus @ nat @ M @ N ) ) @ Z ) ) ).

% zadd_int_left
thf(fact_914_odd__nonzero,axiom,
    ! [Z: int] :
      ( ( plus_plus @ int @ ( plus_plus @ int @ ( one_one @ int ) @ Z ) @ Z )
     != ( zero_zero @ int ) ) ).

% odd_nonzero
thf(fact_915_int__ge__induct,axiom,
    ! [K: int,I: int,P: int > $o] :
      ( ( ord_less_eq @ int @ K @ I )
     => ( ( P @ K )
       => ( ! [I2: int] :
              ( ( ord_less_eq @ int @ K @ I2 )
             => ( ( P @ I2 )
               => ( P @ ( plus_plus @ int @ I2 @ ( one_one @ int ) ) ) ) )
         => ( P @ I ) ) ) ) ).

% int_ge_induct
thf(fact_916_zless__add1__eq,axiom,
    ! [W: int,Z: int] :
      ( ( ord_less @ int @ W @ ( plus_plus @ int @ Z @ ( one_one @ int ) ) )
      = ( ( ord_less @ int @ W @ Z )
        | ( W = Z ) ) ) ).

% zless_add1_eq
thf(fact_917_int__gr__induct,axiom,
    ! [K: int,I: int,P: int > $o] :
      ( ( ord_less @ int @ K @ I )
     => ( ( P @ ( plus_plus @ int @ K @ ( one_one @ int ) ) )
       => ( ! [I2: int] :
              ( ( ord_less @ int @ K @ I2 )
             => ( ( P @ I2 )
               => ( P @ ( plus_plus @ int @ I2 @ ( one_one @ int ) ) ) ) )
         => ( P @ I ) ) ) ) ).

% int_gr_induct
thf(fact_918_int__le__induct,axiom,
    ! [I: int,K: int,P: int > $o] :
      ( ( ord_less_eq @ int @ I @ K )
     => ( ( P @ K )
       => ( ! [I2: int] :
              ( ( ord_less_eq @ int @ I2 @ K )
             => ( ( P @ I2 )
               => ( P @ ( minus_minus @ int @ I2 @ ( one_one @ int ) ) ) ) )
         => ( P @ I ) ) ) ) ).

% int_le_induct
thf(fact_919_int__less__induct,axiom,
    ! [I: int,K: int,P: int > $o] :
      ( ( ord_less @ int @ I @ K )
     => ( ( P @ ( minus_minus @ int @ K @ ( one_one @ int ) ) )
       => ( ! [I2: int] :
              ( ( ord_less @ int @ I2 @ K )
             => ( ( P @ I2 )
               => ( P @ ( minus_minus @ int @ I2 @ ( one_one @ int ) ) ) ) )
         => ( P @ I ) ) ) ) ).

% int_less_induct
thf(fact_920_or__nat__def,axiom,
    ( ( bit_se1065995026697491101ons_or @ nat )
    = ( ^ [M3: nat,N3: nat] : ( nat2 @ ( bit_se1065995026697491101ons_or @ int @ ( semiring_1_of_nat @ int @ M3 ) @ ( semiring_1_of_nat @ int @ N3 ) ) ) ) ) ).

% or_nat_def
thf(fact_921_ex__power__ivl1,axiom,
    ! [B2: nat,K: nat] :
      ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ B2 )
     => ( ( ord_less_eq @ nat @ ( one_one @ nat ) @ K )
       => ? [N2: nat] :
            ( ( ord_less_eq @ nat @ ( power_power @ nat @ B2 @ N2 ) @ K )
            & ( ord_less @ nat @ K @ ( power_power @ nat @ B2 @ ( plus_plus @ nat @ N2 @ ( one_one @ nat ) ) ) ) ) ) ) ).

% ex_power_ivl1
thf(fact_922_ex__power__ivl2,axiom,
    ! [B2: nat,K: nat] :
      ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ B2 )
     => ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ K )
       => ? [N2: nat] :
            ( ( ord_less @ nat @ ( power_power @ nat @ B2 @ N2 ) @ K )
            & ( ord_less_eq @ nat @ K @ ( power_power @ nat @ B2 @ ( plus_plus @ nat @ N2 @ ( one_one @ nat ) ) ) ) ) ) ) ).

% ex_power_ivl2
thf(fact_923_zdvd__imp__le,axiom,
    ! [Z: int,N: int] :
      ( ( dvd_dvd @ int @ Z @ N )
     => ( ( ord_less @ int @ ( zero_zero @ int ) @ N )
       => ( ord_less_eq @ int @ Z @ N ) ) ) ).

% zdvd_imp_le
thf(fact_924_linordered__field__no__lb,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X5: A] :
        ? [Y5: A] : ( ord_less @ A @ Y5 @ X5 ) ) ).

% linordered_field_no_lb
thf(fact_925_linordered__field__no__ub,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X5: A] :
        ? [X_1: A] : ( ord_less @ A @ X5 @ X_1 ) ) ).

% linordered_field_no_ub
thf(fact_926_linorder__neqE__linordered__idom,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: A,Y: A] :
          ( ( X != Y )
         => ( ~ ( ord_less @ A @ X @ Y )
           => ( ord_less @ A @ Y @ X ) ) ) ) ).

% linorder_neqE_linordered_idom
thf(fact_927_int__le__real__less,axiom,
    ( ( ord_less_eq @ int )
    = ( ^ [N3: int,M3: int] : ( ord_less @ real @ ( ring_1_of_int @ real @ N3 ) @ ( plus_plus @ real @ ( ring_1_of_int @ real @ M3 ) @ ( one_one @ real ) ) ) ) ) ).

% int_le_real_less
thf(fact_928_int__less__real__le,axiom,
    ( ( ord_less @ int )
    = ( ^ [N3: int,M3: int] : ( ord_less_eq @ real @ ( plus_plus @ real @ ( ring_1_of_int @ real @ N3 ) @ ( one_one @ real ) ) @ ( ring_1_of_int @ real @ M3 ) ) ) ) ).

% int_less_real_le
thf(fact_929_sqrt__add__le__add__sqrt,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y )
       => ( ord_less_eq @ real @ ( sqrt @ ( plus_plus @ real @ X @ Y ) ) @ ( plus_plus @ real @ ( sqrt @ X ) @ ( sqrt @ Y ) ) ) ) ) ).

% sqrt_add_le_add_sqrt
thf(fact_930_xor__nat__def,axiom,
    ( ( bit_se5824344971392196577ns_xor @ nat )
    = ( ^ [M3: nat,N3: nat] : ( nat2 @ ( bit_se5824344971392196577ns_xor @ int @ ( semiring_1_of_nat @ int @ M3 ) @ ( semiring_1_of_nat @ int @ N3 ) ) ) ) ) ).

% xor_nat_def
thf(fact_931_int__minus,axiom,
    ! [N: nat,M: nat] :
      ( ( semiring_1_of_nat @ int @ ( minus_minus @ nat @ N @ M ) )
      = ( semiring_1_of_nat @ int @ ( nat2 @ ( minus_minus @ int @ ( semiring_1_of_nat @ int @ N ) @ ( semiring_1_of_nat @ int @ M ) ) ) ) ) ).

% int_minus
thf(fact_932_nat__int__add,axiom,
    ! [A2: nat,B2: nat] :
      ( ( nat2 @ ( plus_plus @ int @ ( semiring_1_of_nat @ int @ A2 ) @ ( semiring_1_of_nat @ int @ B2 ) ) )
      = ( plus_plus @ nat @ A2 @ B2 ) ) ).

% nat_int_add
thf(fact_933_int__one__le__iff__zero__less,axiom,
    ! [Z: int] :
      ( ( ord_less_eq @ int @ ( one_one @ int ) @ Z )
      = ( ord_less @ int @ ( zero_zero @ int ) @ Z ) ) ).

% int_one_le_iff_zero_less
thf(fact_934_odd__less__0__iff,axiom,
    ! [Z: int] :
      ( ( ord_less @ int @ ( plus_plus @ int @ ( plus_plus @ int @ ( one_one @ int ) @ Z ) @ Z ) @ ( zero_zero @ int ) )
      = ( ord_less @ int @ Z @ ( zero_zero @ int ) ) ) ).

% odd_less_0_iff
thf(fact_935_zless__imp__add1__zle,axiom,
    ! [W: int,Z: int] :
      ( ( ord_less @ int @ W @ Z )
     => ( ord_less_eq @ int @ ( plus_plus @ int @ W @ ( one_one @ int ) ) @ Z ) ) ).

% zless_imp_add1_zle
thf(fact_936_add1__zle__eq,axiom,
    ! [W: int,Z: int] :
      ( ( ord_less_eq @ int @ ( plus_plus @ int @ W @ ( one_one @ int ) ) @ Z )
      = ( ord_less @ int @ W @ Z ) ) ).

% add1_zle_eq
thf(fact_937_int__induct,axiom,
    ! [P: int > $o,K: int,I: int] :
      ( ( P @ K )
     => ( ! [I2: int] :
            ( ( ord_less_eq @ int @ K @ I2 )
           => ( ( P @ I2 )
             => ( P @ ( plus_plus @ int @ I2 @ ( one_one @ int ) ) ) ) )
       => ( ! [I2: int] :
              ( ( ord_less_eq @ int @ I2 @ K )
             => ( ( P @ I2 )
               => ( P @ ( minus_minus @ int @ I2 @ ( one_one @ int ) ) ) ) )
         => ( P @ I ) ) ) ) ).

% int_induct
thf(fact_938_take__bit__decr__eq,axiom,
    ! [N: nat,K: int] :
      ( ( ( bit_se2584673776208193580ke_bit @ int @ N @ K )
       != ( zero_zero @ int ) )
     => ( ( bit_se2584673776208193580ke_bit @ int @ N @ ( minus_minus @ int @ K @ ( one_one @ int ) ) )
        = ( minus_minus @ int @ ( bit_se2584673776208193580ke_bit @ int @ N @ K ) @ ( one_one @ int ) ) ) ) ).

% take_bit_decr_eq
thf(fact_939_nat__less__real__le,axiom,
    ( ( ord_less @ nat )
    = ( ^ [N3: nat,M3: nat] : ( ord_less_eq @ real @ ( plus_plus @ real @ ( semiring_1_of_nat @ real @ N3 ) @ ( one_one @ real ) ) @ ( semiring_1_of_nat @ real @ M3 ) ) ) ) ).

% nat_less_real_le
thf(fact_940_nat__le__real__less,axiom,
    ( ( ord_less_eq @ nat )
    = ( ^ [N3: nat,M3: nat] : ( ord_less @ real @ ( semiring_1_of_nat @ real @ N3 ) @ ( plus_plus @ real @ ( semiring_1_of_nat @ real @ M3 ) @ ( one_one @ real ) ) ) ) ) ).

% nat_le_real_less
thf(fact_941_int__ops_I6_J,axiom,
    ! [A2: nat,B2: nat] :
      ( ( ( ord_less @ int @ ( semiring_1_of_nat @ int @ A2 ) @ ( semiring_1_of_nat @ int @ B2 ) )
       => ( ( semiring_1_of_nat @ int @ ( minus_minus @ nat @ A2 @ B2 ) )
          = ( zero_zero @ int ) ) )
      & ( ~ ( ord_less @ int @ ( semiring_1_of_nat @ int @ A2 ) @ ( semiring_1_of_nat @ int @ B2 ) )
       => ( ( semiring_1_of_nat @ int @ ( minus_minus @ nat @ A2 @ B2 ) )
          = ( minus_minus @ int @ ( semiring_1_of_nat @ int @ A2 ) @ ( semiring_1_of_nat @ int @ B2 ) ) ) ) ) ).

% int_ops(6)
thf(fact_942_nat__diff__distrib_H,axiom,
    ! [X: int,Y: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ X )
     => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Y )
       => ( ( nat2 @ ( minus_minus @ int @ X @ Y ) )
          = ( minus_minus @ nat @ ( nat2 @ X ) @ ( nat2 @ Y ) ) ) ) ) ).

% nat_diff_distrib'
thf(fact_943_nat__diff__distrib,axiom,
    ! [Z5: int,Z: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Z5 )
     => ( ( ord_less_eq @ int @ Z5 @ Z )
       => ( ( nat2 @ ( minus_minus @ int @ Z @ Z5 ) )
          = ( minus_minus @ nat @ ( nat2 @ Z ) @ ( nat2 @ Z5 ) ) ) ) ) ).

% nat_diff_distrib
thf(fact_944_nat__add__distrib,axiom,
    ! [Z: int,Z5: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Z )
     => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Z5 )
       => ( ( nat2 @ ( plus_plus @ int @ Z @ Z5 ) )
          = ( plus_plus @ nat @ ( nat2 @ Z ) @ ( nat2 @ Z5 ) ) ) ) ) ).

% nat_add_distrib
thf(fact_945_floor__exists1,axiom,
    ! [A: $tType] :
      ( ( archim462609752435547400_field @ A )
     => ! [X: A] :
        ? [X3: int] :
          ( ( ord_less_eq @ A @ ( ring_1_of_int @ A @ X3 ) @ X )
          & ( ord_less @ A @ X @ ( ring_1_of_int @ A @ ( plus_plus @ int @ X3 @ ( one_one @ int ) ) ) )
          & ! [Y6: int] :
              ( ( ( ord_less_eq @ A @ ( ring_1_of_int @ A @ Y6 ) @ X )
                & ( ord_less @ A @ X @ ( ring_1_of_int @ A @ ( plus_plus @ int @ Y6 @ ( one_one @ int ) ) ) ) )
             => ( Y6 = X3 ) ) ) ) ).

% floor_exists1
thf(fact_946_floor__exists,axiom,
    ! [A: $tType] :
      ( ( archim462609752435547400_field @ A )
     => ! [X: A] :
        ? [Z3: int] :
          ( ( ord_less_eq @ A @ ( ring_1_of_int @ A @ Z3 ) @ X )
          & ( ord_less @ A @ X @ ( ring_1_of_int @ A @ ( plus_plus @ int @ Z3 @ ( one_one @ int ) ) ) ) ) ) ).

% floor_exists
thf(fact_947_power__dvd__imp__le,axiom,
    ! [I: nat,M: nat,N: nat] :
      ( ( dvd_dvd @ nat @ ( power_power @ nat @ I @ M ) @ ( power_power @ nat @ I @ N ) )
     => ( ( ord_less @ nat @ ( one_one @ nat ) @ I )
       => ( ord_less_eq @ nat @ M @ N ) ) ) ).

% power_dvd_imp_le
thf(fact_948_le__imp__0__less,axiom,
    ! [Z: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Z )
     => ( ord_less @ int @ ( zero_zero @ int ) @ ( plus_plus @ int @ ( one_one @ int ) @ Z ) ) ) ).

% le_imp_0_less
thf(fact_949_exp__not__zero__imp__exp__diff__not__zero,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [N: nat,M: nat] :
          ( ( ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N )
           != ( zero_zero @ A ) )
         => ( ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ N @ M ) )
           != ( zero_zero @ A ) ) ) ) ).

% exp_not_zero_imp_exp_diff_not_zero
thf(fact_950_exp__add__not__zero__imp__left,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [M: nat,N: nat] :
          ( ( ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( plus_plus @ nat @ M @ N ) )
           != ( zero_zero @ A ) )
         => ( ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M )
           != ( zero_zero @ A ) ) ) ) ).

% exp_add_not_zero_imp_left
thf(fact_951_exp__add__not__zero__imp__right,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [M: nat,N: nat] :
          ( ( ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( plus_plus @ nat @ M @ N ) )
           != ( zero_zero @ A ) )
         => ( ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N )
           != ( zero_zero @ A ) ) ) ) ).

% exp_add_not_zero_imp_right
thf(fact_952_even__diff__iff,axiom,
    ! [K: int,L: int] :
      ( ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( minus_minus @ int @ K @ L ) )
      = ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( plus_plus @ int @ K @ L ) ) ) ).

% even_diff_iff
thf(fact_953_diff__le__diff__pow,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ K )
     => ( ord_less_eq @ nat @ ( minus_minus @ nat @ M @ N ) @ ( minus_minus @ nat @ ( power_power @ nat @ K @ M ) @ ( power_power @ nat @ K @ N ) ) ) ) ).

% diff_le_diff_pow
thf(fact_954_zdiff__int__split,axiom,
    ! [P: int > $o,X: nat,Y: nat] :
      ( ( P @ ( semiring_1_of_nat @ int @ ( minus_minus @ nat @ X @ Y ) ) )
      = ( ( ( ord_less_eq @ nat @ Y @ X )
         => ( P @ ( minus_minus @ int @ ( semiring_1_of_nat @ int @ X ) @ ( semiring_1_of_nat @ int @ Y ) ) ) )
        & ( ( ord_less @ nat @ X @ Y )
         => ( P @ ( zero_zero @ int ) ) ) ) ) ).

% zdiff_int_split
thf(fact_955_nat__dvd__iff,axiom,
    ! [Z: int,M: nat] :
      ( ( dvd_dvd @ nat @ ( nat2 @ Z ) @ M )
      = ( ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Z )
         => ( dvd_dvd @ int @ Z @ ( semiring_1_of_nat @ int @ M ) ) )
        & ( ~ ( ord_less_eq @ int @ ( zero_zero @ int ) @ Z )
         => ( M
            = ( zero_zero @ nat ) ) ) ) ) ).

% nat_dvd_iff
thf(fact_956_real__sqrt__sum__squares__eq__cancel,axiom,
    ! [X: real,Y: real] :
      ( ( ( sqrt @ ( plus_plus @ real @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Y @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
        = X )
     => ( Y
        = ( zero_zero @ real ) ) ) ).

% real_sqrt_sum_squares_eq_cancel
thf(fact_957_real__sqrt__sum__squares__eq__cancel2,axiom,
    ! [X: real,Y: real] :
      ( ( ( sqrt @ ( plus_plus @ real @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Y @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
        = Y )
     => ( X
        = ( zero_zero @ real ) ) ) ).

% real_sqrt_sum_squares_eq_cancel2
thf(fact_958_real__sqrt__sum__squares__ge1,axiom,
    ! [X: real,Y: real] : ( ord_less_eq @ real @ X @ ( sqrt @ ( plus_plus @ real @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Y @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% real_sqrt_sum_squares_ge1
thf(fact_959_real__sqrt__sum__squares__ge2,axiom,
    ! [Y: real,X: real] : ( ord_less_eq @ real @ Y @ ( sqrt @ ( plus_plus @ real @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Y @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% real_sqrt_sum_squares_ge2
thf(fact_960_real__sqrt__sum__squares__triangle__ineq,axiom,
    ! [A2: real,C2: real,B2: real,D2: real] : ( ord_less_eq @ real @ ( sqrt @ ( plus_plus @ real @ ( power_power @ real @ ( plus_plus @ real @ A2 @ C2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ ( plus_plus @ real @ B2 @ D2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( plus_plus @ real @ ( sqrt @ ( plus_plus @ real @ ( power_power @ real @ A2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ B2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( sqrt @ ( plus_plus @ real @ ( power_power @ real @ C2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ D2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% real_sqrt_sum_squares_triangle_ineq
thf(fact_961_zero__neq__one,axiom,
    ! [A: $tType] :
      ( ( zero_neq_one @ A )
     => ( ( zero_zero @ A )
       != ( one_one @ A ) ) ) ).

% zero_neq_one
thf(fact_962_dvd__0__left,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [A2: A] :
          ( ( dvd_dvd @ A @ ( zero_zero @ A ) @ A2 )
         => ( A2
            = ( zero_zero @ A ) ) ) ) ).

% dvd_0_left
thf(fact_963_dvd__field__iff,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ( ( dvd_dvd @ A )
        = ( ^ [A3: A,B3: A] :
              ( ( A3
                = ( zero_zero @ A ) )
             => ( B3
                = ( zero_zero @ A ) ) ) ) ) ) ).

% dvd_field_iff
thf(fact_964_gcd__nat_Oextremum,axiom,
    ! [A2: nat] : ( dvd_dvd @ nat @ A2 @ ( zero_zero @ nat ) ) ).

% gcd_nat.extremum
thf(fact_965_gcd__nat_Oextremum__strict,axiom,
    ! [A2: nat] :
      ~ ( ( dvd_dvd @ nat @ ( zero_zero @ nat ) @ A2 )
        & ( ( zero_zero @ nat )
         != A2 ) ) ).

% gcd_nat.extremum_strict
thf(fact_966_gcd__nat_Oextremum__unique,axiom,
    ! [A2: nat] :
      ( ( dvd_dvd @ nat @ ( zero_zero @ nat ) @ A2 )
      = ( A2
        = ( zero_zero @ nat ) ) ) ).

% gcd_nat.extremum_unique
thf(fact_967_gcd__nat_Onot__eq__extremum,axiom,
    ! [A2: nat] :
      ( ( ( A2
         != ( zero_zero @ nat ) ) )
      = ( ( dvd_dvd @ nat @ A2 @ ( zero_zero @ nat ) )
        & ( A2
         != ( zero_zero @ nat ) ) ) ) ).

% gcd_nat.not_eq_extremum
thf(fact_968_gcd__nat_Oextremum__uniqueI,axiom,
    ! [A2: nat] :
      ( ( dvd_dvd @ nat @ ( zero_zero @ nat ) @ A2 )
     => ( A2
        = ( zero_zero @ nat ) ) ) ).

% gcd_nat.extremum_uniqueI
thf(fact_969_sqrt__sum__squares__le__sum,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y )
       => ( ord_less_eq @ real @ ( sqrt @ ( plus_plus @ real @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Y @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( plus_plus @ real @ X @ Y ) ) ) ) ).

% sqrt_sum_squares_le_sum
thf(fact_970_take__bit__incr__eq,axiom,
    ! [N: nat,K: int] :
      ( ( ( bit_se2584673776208193580ke_bit @ int @ N @ K )
       != ( minus_minus @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) @ ( one_one @ int ) ) )
     => ( ( bit_se2584673776208193580ke_bit @ int @ N @ ( plus_plus @ int @ K @ ( one_one @ int ) ) )
        = ( plus_plus @ int @ ( one_one @ int ) @ ( bit_se2584673776208193580ke_bit @ int @ N @ K ) ) ) ) ).

% take_bit_incr_eq
thf(fact_971_even__nat__iff,axiom,
    ! [K: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ K )
     => ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( nat2 @ K ) )
        = ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ K ) ) ) ).

% even_nat_iff
thf(fact_972_arsinh__real__aux,axiom,
    ! [X: real] : ( ord_less @ real @ ( zero_zero @ real ) @ ( plus_plus @ real @ X @ ( sqrt @ ( plus_plus @ real @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ real ) ) ) ) ) ).

% arsinh_real_aux
thf(fact_973_zero__less__one__class_Ozero__le__one,axiom,
    ! [A: $tType] :
      ( ( zero_less_one @ A )
     => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( one_one @ A ) ) ) ).

% zero_less_one_class.zero_le_one
thf(fact_974_linordered__nonzero__semiring__class_Ozero__le__one,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( one_one @ A ) ) ) ).

% linordered_nonzero_semiring_class.zero_le_one
thf(fact_975_not__one__le__zero,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ~ ( ord_less_eq @ A @ ( one_one @ A ) @ ( zero_zero @ A ) ) ) ).

% not_one_le_zero
thf(fact_976_zero__less__one,axiom,
    ! [A: $tType] :
      ( ( zero_less_one @ A )
     => ( ord_less @ A @ ( zero_zero @ A ) @ ( one_one @ A ) ) ) ).

% zero_less_one
thf(fact_977_not__one__less__zero,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ~ ( ord_less @ A @ ( one_one @ A ) @ ( zero_zero @ A ) ) ) ).

% not_one_less_zero
thf(fact_978_add__less__zeroD,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less @ A @ ( plus_plus @ A @ X @ Y ) @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ X @ ( zero_zero @ A ) )
            | ( ord_less @ A @ Y @ ( zero_zero @ A ) ) ) ) ) ).

% add_less_zeroD
thf(fact_979_add__le__imp__le__diff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [I: A,K: A,N: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ I @ K ) @ N )
         => ( ord_less_eq @ A @ I @ ( minus_minus @ A @ N @ K ) ) ) ) ).

% add_le_imp_le_diff
thf(fact_980_add__le__add__imp__diff__le,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [I: A,K: A,N: A,J: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ I @ K ) @ N )
         => ( ( ord_less_eq @ A @ N @ ( plus_plus @ A @ J @ K ) )
           => ( ( ord_less_eq @ A @ ( plus_plus @ A @ I @ K ) @ N )
             => ( ( ord_less_eq @ A @ N @ ( plus_plus @ A @ J @ K ) )
               => ( ord_less_eq @ A @ ( minus_minus @ A @ N @ K ) @ J ) ) ) ) ) ) ).

% add_le_add_imp_diff_le
thf(fact_981_add__mono1,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ord_less @ A @ ( plus_plus @ A @ A2 @ ( one_one @ A ) ) @ ( plus_plus @ A @ B2 @ ( one_one @ A ) ) ) ) ) ).

% add_mono1
thf(fact_982_less__add__one,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A] : ( ord_less @ A @ A2 @ ( plus_plus @ A @ A2 @ ( one_one @ A ) ) ) ) ).

% less_add_one
thf(fact_983_linordered__semidom__class_Oadd__diff__inverse,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,B2: A] :
          ( ~ ( ord_less @ A @ A2 @ B2 )
         => ( ( plus_plus @ A @ B2 @ ( minus_minus @ A @ A2 @ B2 ) )
            = A2 ) ) ) ).

% linordered_semidom_class.add_diff_inverse
thf(fact_984_not__is__unit__0,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ~ ( dvd_dvd @ A @ ( zero_zero @ A ) @ ( one_one @ A ) ) ) ).

% not_is_unit_0
thf(fact_985_dvd__pos__nat,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( dvd_dvd @ nat @ M @ N )
       => ( ord_less @ nat @ ( zero_zero @ nat ) @ M ) ) ) ).

% dvd_pos_nat
thf(fact_986_pow__sum,axiom,
    ! [A2: nat,B2: nat] :
      ( ( divide_divide @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( plus_plus @ nat @ A2 @ B2 ) ) @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ A2 ) )
      = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ B2 ) ) ).

% pow_sum
thf(fact_987_ceiling__log__nat__eq__powr__iff,axiom,
    ! [B2: nat,K: nat,N: nat] :
      ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ B2 )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
       => ( ( ( archimedean_ceiling @ real @ ( log2 @ ( semiring_1_of_nat @ real @ B2 ) @ ( semiring_1_of_nat @ real @ K ) ) )
            = ( plus_plus @ int @ ( semiring_1_of_nat @ int @ N ) @ ( one_one @ int ) ) )
          = ( ( ord_less @ nat @ ( power_power @ nat @ B2 @ N ) @ K )
            & ( ord_less_eq @ nat @ K @ ( power_power @ nat @ B2 @ ( plus_plus @ nat @ N @ ( one_one @ nat ) ) ) ) ) ) ) ) ).

% ceiling_log_nat_eq_powr_iff
thf(fact_988_high__bound__aux,axiom,
    ! [Ma: nat,N: nat,M: nat] :
      ( ( ord_less @ nat @ Ma @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( plus_plus @ nat @ N @ M ) ) )
     => ( ord_less @ nat @ ( vEBT_VEBT_high @ Ma @ N ) @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M ) ) ) ).

% high_bound_aux
thf(fact_989_ceiling__log__nat__eq__if,axiom,
    ! [B2: nat,N: nat,K: nat] :
      ( ( ord_less @ nat @ ( power_power @ nat @ B2 @ N ) @ K )
     => ( ( ord_less_eq @ nat @ K @ ( power_power @ nat @ B2 @ ( plus_plus @ nat @ N @ ( one_one @ nat ) ) ) )
       => ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ B2 )
         => ( ( archimedean_ceiling @ real @ ( log2 @ ( semiring_1_of_nat @ real @ B2 ) @ ( semiring_1_of_nat @ real @ K ) ) )
            = ( plus_plus @ int @ ( semiring_1_of_nat @ int @ N ) @ ( one_one @ int ) ) ) ) ) ) ).

% ceiling_log_nat_eq_if
thf(fact_990_floor__log__nat__eq__powr__iff,axiom,
    ! [B2: nat,K: nat,N: nat] :
      ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ B2 )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
       => ( ( ( archim6421214686448440834_floor @ real @ ( log2 @ ( semiring_1_of_nat @ real @ B2 ) @ ( semiring_1_of_nat @ real @ K ) ) )
            = ( semiring_1_of_nat @ int @ N ) )
          = ( ( ord_less_eq @ nat @ ( power_power @ nat @ B2 @ N ) @ K )
            & ( ord_less @ nat @ K @ ( power_power @ nat @ B2 @ ( plus_plus @ nat @ N @ ( one_one @ nat ) ) ) ) ) ) ) ) ).

% floor_log_nat_eq_powr_iff
thf(fact_991_high__def,axiom,
    ( vEBT_VEBT_high
    = ( ^ [X2: nat,N3: nat] : ( divide_divide @ nat @ X2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N3 ) ) ) ) ).

% high_def
thf(fact_992_bits__div__0,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A] :
          ( ( divide_divide @ A @ ( zero_zero @ A ) @ A2 )
          = ( zero_zero @ A ) ) ) ).

% bits_div_0
thf(fact_993_bits__div__by__0,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A] :
          ( ( divide_divide @ A @ A2 @ ( zero_zero @ A ) )
          = ( zero_zero @ A ) ) ) ).

% bits_div_by_0
thf(fact_994_div__0,axiom,
    ! [A: $tType] :
      ( ( semidom_divide @ A )
     => ! [A2: A] :
          ( ( divide_divide @ A @ ( zero_zero @ A ) @ A2 )
          = ( zero_zero @ A ) ) ) ).

% div_0
thf(fact_995_divide__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A2: A,B2: A] :
          ( ( ( divide_divide @ A @ A2 @ B2 )
            = ( zero_zero @ A ) )
          = ( ( A2
              = ( zero_zero @ A ) )
            | ( B2
              = ( zero_zero @ A ) ) ) ) ) ).

% divide_eq_0_iff
thf(fact_996_div__by__0,axiom,
    ! [A: $tType] :
      ( ( semidom_divide @ A )
     => ! [A2: A] :
          ( ( divide_divide @ A @ A2 @ ( zero_zero @ A ) )
          = ( zero_zero @ A ) ) ) ).

% div_by_0
thf(fact_997_divide__cancel__left,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ( divide_divide @ A @ C2 @ A2 )
            = ( divide_divide @ A @ C2 @ B2 ) )
          = ( ( C2
              = ( zero_zero @ A ) )
            | ( A2 = B2 ) ) ) ) ).

% divide_cancel_left
thf(fact_998_divide__cancel__right,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ( divide_divide @ A @ A2 @ C2 )
            = ( divide_divide @ A @ B2 @ C2 ) )
          = ( ( C2
              = ( zero_zero @ A ) )
            | ( A2 = B2 ) ) ) ) ).

% divide_cancel_right
thf(fact_999_division__ring__divide__zero,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A] :
          ( ( divide_divide @ A @ A2 @ ( zero_zero @ A ) )
          = ( zero_zero @ A ) ) ) ).

% division_ring_divide_zero
thf(fact_1000_bits__div__by__1,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A] :
          ( ( divide_divide @ A @ A2 @ ( one_one @ A ) )
          = A2 ) ) ).

% bits_div_by_1
thf(fact_1001_floor__of__int,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [Z: int] :
          ( ( archim6421214686448440834_floor @ A @ ( ring_1_of_int @ A @ Z ) )
          = Z ) ) ).

% floor_of_int
thf(fact_1002_of__int__floor__cancel,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( ( ring_1_of_int @ A @ ( archim6421214686448440834_floor @ A @ X ) )
            = X )
          = ( ? [N3: int] :
                ( X
                = ( ring_1_of_int @ A @ N3 ) ) ) ) ) ).

% of_int_floor_cancel
thf(fact_1003_ceiling__of__int,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [Z: int] :
          ( ( archimedean_ceiling @ A @ ( ring_1_of_int @ A @ Z ) )
          = Z ) ) ).

% ceiling_of_int
thf(fact_1004_of__int__ceiling__cancel,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( ( ring_1_of_int @ A @ ( archimedean_ceiling @ A @ X ) )
            = X )
          = ( ? [N3: int] :
                ( X
                = ( ring_1_of_int @ A @ N3 ) ) ) ) ) ).

% of_int_ceiling_cancel
thf(fact_1005_divide__eq__1__iff,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A2: A,B2: A] :
          ( ( ( divide_divide @ A @ A2 @ B2 )
            = ( one_one @ A ) )
          = ( ( B2
             != ( zero_zero @ A ) )
            & ( A2 = B2 ) ) ) ) ).

% divide_eq_1_iff
thf(fact_1006_div__self,axiom,
    ! [A: $tType] :
      ( ( semidom_divide @ A )
     => ! [A2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ A2 @ A2 )
            = ( one_one @ A ) ) ) ) ).

% div_self
thf(fact_1007_one__eq__divide__iff,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A2: A,B2: A] :
          ( ( ( one_one @ A )
            = ( divide_divide @ A @ A2 @ B2 ) )
          = ( ( B2
             != ( zero_zero @ A ) )
            & ( A2 = B2 ) ) ) ) ).

% one_eq_divide_iff
thf(fact_1008_divide__self,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ A2 @ A2 )
            = ( one_one @ A ) ) ) ) ).

% divide_self
thf(fact_1009_divide__self__if,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A] :
          ( ( ( A2
              = ( zero_zero @ A ) )
           => ( ( divide_divide @ A @ A2 @ A2 )
              = ( zero_zero @ A ) ) )
          & ( ( A2
             != ( zero_zero @ A ) )
           => ( ( divide_divide @ A @ A2 @ A2 )
              = ( one_one @ A ) ) ) ) ) ).

% divide_self_if
thf(fact_1010_divide__eq__eq__1,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,A2: A] :
          ( ( ( divide_divide @ A @ B2 @ A2 )
            = ( one_one @ A ) )
          = ( ( A2
             != ( zero_zero @ A ) )
            & ( A2 = B2 ) ) ) ) ).

% divide_eq_eq_1
thf(fact_1011_eq__divide__eq__1,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,A2: A] :
          ( ( ( one_one @ A )
            = ( divide_divide @ A @ B2 @ A2 ) )
          = ( ( A2
             != ( zero_zero @ A ) )
            & ( A2 = B2 ) ) ) ) ).

% eq_divide_eq_1
thf(fact_1012_one__divide__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A] :
          ( ( ( divide_divide @ A @ ( one_one @ A ) @ A2 )
            = ( zero_zero @ A ) )
          = ( A2
            = ( zero_zero @ A ) ) ) ) ).

% one_divide_eq_0_iff
thf(fact_1013_zero__eq__1__divide__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A] :
          ( ( ( zero_zero @ A )
            = ( divide_divide @ A @ ( one_one @ A ) @ A2 ) )
          = ( A2
            = ( zero_zero @ A ) ) ) ) ).

% zero_eq_1_divide_iff
thf(fact_1014_div__less,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ M @ N )
     => ( ( divide_divide @ nat @ M @ N )
        = ( zero_zero @ nat ) ) ) ).

% div_less
thf(fact_1015_floor__zero,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ( ( archim6421214686448440834_floor @ A @ ( zero_zero @ A ) )
        = ( zero_zero @ int ) ) ) ).

% floor_zero
thf(fact_1016_floor__numeral,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [V: num] :
          ( ( archim6421214686448440834_floor @ A @ ( numeral_numeral @ A @ V ) )
          = ( numeral_numeral @ int @ V ) ) ) ).

% floor_numeral
thf(fact_1017_ceiling__zero,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ( ( archimedean_ceiling @ A @ ( zero_zero @ A ) )
        = ( zero_zero @ int ) ) ) ).

% ceiling_zero
thf(fact_1018_floor__one,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ( ( archim6421214686448440834_floor @ A @ ( one_one @ A ) )
        = ( one_one @ int ) ) ) ).

% floor_one
thf(fact_1019_ceiling__numeral,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [V: num] :
          ( ( archimedean_ceiling @ A @ ( numeral_numeral @ A @ V ) )
          = ( numeral_numeral @ int @ V ) ) ) ).

% ceiling_numeral
thf(fact_1020_ceiling__one,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ( ( archimedean_ceiling @ A @ ( one_one @ A ) )
        = ( one_one @ int ) ) ) ).

% ceiling_one
thf(fact_1021_floor__of__nat,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [N: nat] :
          ( ( archim6421214686448440834_floor @ A @ ( semiring_1_of_nat @ A @ N ) )
          = ( semiring_1_of_nat @ int @ N ) ) ) ).

% floor_of_nat
thf(fact_1022_ceiling__of__nat,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [N: nat] :
          ( ( archimedean_ceiling @ A @ ( semiring_1_of_nat @ A @ N ) )
          = ( semiring_1_of_nat @ int @ N ) ) ) ).

% ceiling_of_nat
thf(fact_1023_zero__le__divide__1__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( divide_divide @ A @ ( one_one @ A ) @ A2 ) )
          = ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 ) ) ) ).

% zero_le_divide_1_iff
thf(fact_1024_divide__le__0__1__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ ( divide_divide @ A @ ( one_one @ A ) @ A2 ) @ ( zero_zero @ A ) )
          = ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) ) ) ) ).

% divide_le_0_1_iff
thf(fact_1025_zero__less__divide__1__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( divide_divide @ A @ ( one_one @ A ) @ A2 ) )
          = ( ord_less @ A @ ( zero_zero @ A ) @ A2 ) ) ) ).

% zero_less_divide_1_iff
thf(fact_1026_less__divide__eq__1__pos,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less @ A @ ( one_one @ A ) @ ( divide_divide @ A @ B2 @ A2 ) )
            = ( ord_less @ A @ A2 @ B2 ) ) ) ) ).

% less_divide_eq_1_pos
thf(fact_1027_less__divide__eq__1__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ ( one_one @ A ) @ ( divide_divide @ A @ B2 @ A2 ) )
            = ( ord_less @ A @ B2 @ A2 ) ) ) ) ).

% less_divide_eq_1_neg
thf(fact_1028_divide__less__eq__1__pos,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less @ A @ ( divide_divide @ A @ B2 @ A2 ) @ ( one_one @ A ) )
            = ( ord_less @ A @ B2 @ A2 ) ) ) ) ).

% divide_less_eq_1_pos
thf(fact_1029_divide__less__eq__1__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ ( divide_divide @ A @ B2 @ A2 ) @ ( one_one @ A ) )
            = ( ord_less @ A @ A2 @ B2 ) ) ) ) ).

% divide_less_eq_1_neg
thf(fact_1030_divide__less__0__1__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( divide_divide @ A @ ( one_one @ A ) @ A2 ) @ ( zero_zero @ A ) )
          = ( ord_less @ A @ A2 @ ( zero_zero @ A ) ) ) ) ).

% divide_less_0_1_iff
thf(fact_1031_ceiling__add__of__int,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,Z: int] :
          ( ( archimedean_ceiling @ A @ ( plus_plus @ A @ X @ ( ring_1_of_int @ A @ Z ) ) )
          = ( plus_plus @ int @ ( archimedean_ceiling @ A @ X ) @ Z ) ) ) ).

% ceiling_add_of_int
thf(fact_1032_floor__diff__of__int,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,Z: int] :
          ( ( archim6421214686448440834_floor @ A @ ( minus_minus @ A @ X @ ( ring_1_of_int @ A @ Z ) ) )
          = ( minus_minus @ int @ ( archim6421214686448440834_floor @ A @ X ) @ Z ) ) ) ).

% floor_diff_of_int
thf(fact_1033_ceiling__diff__of__int,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,Z: int] :
          ( ( archimedean_ceiling @ A @ ( minus_minus @ A @ X @ ( ring_1_of_int @ A @ Z ) ) )
          = ( minus_minus @ int @ ( archimedean_ceiling @ A @ X ) @ Z ) ) ) ).

% ceiling_diff_of_int
thf(fact_1034_le__divide__eq__1__pos,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less_eq @ A @ ( one_one @ A ) @ ( divide_divide @ A @ B2 @ A2 ) )
            = ( ord_less_eq @ A @ A2 @ B2 ) ) ) ) ).

% le_divide_eq_1_pos
thf(fact_1035_le__divide__eq__1__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ ( one_one @ A ) @ ( divide_divide @ A @ B2 @ A2 ) )
            = ( ord_less_eq @ A @ B2 @ A2 ) ) ) ) ).

% le_divide_eq_1_neg
thf(fact_1036_divide__le__eq__1__pos,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less_eq @ A @ ( divide_divide @ A @ B2 @ A2 ) @ ( one_one @ A ) )
            = ( ord_less_eq @ A @ B2 @ A2 ) ) ) ) ).

% divide_le_eq_1_pos
thf(fact_1037_divide__le__eq__1__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ ( divide_divide @ A @ B2 @ A2 ) @ ( one_one @ A ) )
            = ( ord_less_eq @ A @ A2 @ B2 ) ) ) ) ).

% divide_le_eq_1_neg
thf(fact_1038_add__self__div__2,axiom,
    ! [M: nat] :
      ( ( divide_divide @ nat @ ( plus_plus @ nat @ M @ M ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
      = M ) ).

% add_self_div_2
thf(fact_1039_zero__le__floor,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( archim6421214686448440834_floor @ A @ X ) )
          = ( ord_less_eq @ A @ ( zero_zero @ A ) @ X ) ) ) ).

% zero_le_floor
thf(fact_1040_floor__less__zero,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( ord_less @ int @ ( archim6421214686448440834_floor @ A @ X ) @ ( zero_zero @ int ) )
          = ( ord_less @ A @ X @ ( zero_zero @ A ) ) ) ) ).

% floor_less_zero
thf(fact_1041_numeral__le__floor,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [V: num,X: A] :
          ( ( ord_less_eq @ int @ ( numeral_numeral @ int @ V ) @ ( archim6421214686448440834_floor @ A @ X ) )
          = ( ord_less_eq @ A @ ( numeral_numeral @ A @ V ) @ X ) ) ) ).

% numeral_le_floor
thf(fact_1042_zero__less__floor,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( ord_less @ int @ ( zero_zero @ int ) @ ( archim6421214686448440834_floor @ A @ X ) )
          = ( ord_less_eq @ A @ ( one_one @ A ) @ X ) ) ) ).

% zero_less_floor
thf(fact_1043_floor__le__zero,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( ord_less_eq @ int @ ( archim6421214686448440834_floor @ A @ X ) @ ( zero_zero @ int ) )
          = ( ord_less @ A @ X @ ( one_one @ A ) ) ) ) ).

% floor_le_zero
thf(fact_1044_ceiling__le__zero,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( ord_less_eq @ int @ ( archimedean_ceiling @ A @ X ) @ ( zero_zero @ int ) )
          = ( ord_less_eq @ A @ X @ ( zero_zero @ A ) ) ) ) ).

% ceiling_le_zero
thf(fact_1045_floor__less__numeral,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,V: num] :
          ( ( ord_less @ int @ ( archim6421214686448440834_floor @ A @ X ) @ ( numeral_numeral @ int @ V ) )
          = ( ord_less @ A @ X @ ( numeral_numeral @ A @ V ) ) ) ) ).

% floor_less_numeral
thf(fact_1046_zero__less__ceiling,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( ord_less @ int @ ( zero_zero @ int ) @ ( archimedean_ceiling @ A @ X ) )
          = ( ord_less @ A @ ( zero_zero @ A ) @ X ) ) ) ).

% zero_less_ceiling
thf(fact_1047_one__le__floor,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( ord_less_eq @ int @ ( one_one @ int ) @ ( archim6421214686448440834_floor @ A @ X ) )
          = ( ord_less_eq @ A @ ( one_one @ A ) @ X ) ) ) ).

% one_le_floor
thf(fact_1048_ceiling__le__numeral,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,V: num] :
          ( ( ord_less_eq @ int @ ( archimedean_ceiling @ A @ X ) @ ( numeral_numeral @ int @ V ) )
          = ( ord_less_eq @ A @ X @ ( numeral_numeral @ A @ V ) ) ) ) ).

% ceiling_le_numeral
thf(fact_1049_floor__less__one,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( ord_less @ int @ ( archim6421214686448440834_floor @ A @ X ) @ ( one_one @ int ) )
          = ( ord_less @ A @ X @ ( one_one @ A ) ) ) ) ).

% floor_less_one
thf(fact_1050_ceiling__less__one,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( ord_less @ int @ ( archimedean_ceiling @ A @ X ) @ ( one_one @ int ) )
          = ( ord_less_eq @ A @ X @ ( zero_zero @ A ) ) ) ) ).

% ceiling_less_one
thf(fact_1051_one__le__ceiling,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( ord_less_eq @ int @ ( one_one @ int ) @ ( archimedean_ceiling @ A @ X ) )
          = ( ord_less @ A @ ( zero_zero @ A ) @ X ) ) ) ).

% one_le_ceiling
thf(fact_1052_numeral__less__ceiling,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [V: num,X: A] :
          ( ( ord_less @ int @ ( numeral_numeral @ int @ V ) @ ( archimedean_ceiling @ A @ X ) )
          = ( ord_less @ A @ ( numeral_numeral @ A @ V ) @ X ) ) ) ).

% numeral_less_ceiling
thf(fact_1053_ceiling__le__one,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( ord_less_eq @ int @ ( archimedean_ceiling @ A @ X ) @ ( one_one @ int ) )
          = ( ord_less_eq @ A @ X @ ( one_one @ A ) ) ) ) ).

% ceiling_le_one
thf(fact_1054_one__less__ceiling,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( ord_less @ int @ ( one_one @ int ) @ ( archimedean_ceiling @ A @ X ) )
          = ( ord_less @ A @ ( one_one @ A ) @ X ) ) ) ).

% one_less_ceiling
thf(fact_1055_ceiling__add__numeral,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,V: num] :
          ( ( archimedean_ceiling @ A @ ( plus_plus @ A @ X @ ( numeral_numeral @ A @ V ) ) )
          = ( plus_plus @ int @ ( archimedean_ceiling @ A @ X ) @ ( numeral_numeral @ int @ V ) ) ) ) ).

% ceiling_add_numeral
thf(fact_1056_floor__diff__numeral,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,V: num] :
          ( ( archim6421214686448440834_floor @ A @ ( minus_minus @ A @ X @ ( numeral_numeral @ A @ V ) ) )
          = ( minus_minus @ int @ ( archim6421214686448440834_floor @ A @ X ) @ ( numeral_numeral @ int @ V ) ) ) ) ).

% floor_diff_numeral
thf(fact_1057_ceiling__add__one,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( archimedean_ceiling @ A @ ( plus_plus @ A @ X @ ( one_one @ A ) ) )
          = ( plus_plus @ int @ ( archimedean_ceiling @ A @ X ) @ ( one_one @ int ) ) ) ) ).

% ceiling_add_one
thf(fact_1058_floor__diff__one,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( archim6421214686448440834_floor @ A @ ( minus_minus @ A @ X @ ( one_one @ A ) ) )
          = ( minus_minus @ int @ ( archim6421214686448440834_floor @ A @ X ) @ ( one_one @ int ) ) ) ) ).

% floor_diff_one
thf(fact_1059_ceiling__diff__numeral,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,V: num] :
          ( ( archimedean_ceiling @ A @ ( minus_minus @ A @ X @ ( numeral_numeral @ A @ V ) ) )
          = ( minus_minus @ int @ ( archimedean_ceiling @ A @ X ) @ ( numeral_numeral @ int @ V ) ) ) ) ).

% ceiling_diff_numeral
thf(fact_1060_ceiling__diff__one,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( archimedean_ceiling @ A @ ( minus_minus @ A @ X @ ( one_one @ A ) ) )
          = ( minus_minus @ int @ ( archimedean_ceiling @ A @ X ) @ ( one_one @ int ) ) ) ) ).

% ceiling_diff_one
thf(fact_1061_floor__numeral__power,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: num,N: nat] :
          ( ( archim6421214686448440834_floor @ A @ ( power_power @ A @ ( numeral_numeral @ A @ X ) @ N ) )
          = ( power_power @ int @ ( numeral_numeral @ int @ X ) @ N ) ) ) ).

% floor_numeral_power
thf(fact_1062_ceiling__numeral__power,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: num,N: nat] :
          ( ( archimedean_ceiling @ A @ ( power_power @ A @ ( numeral_numeral @ A @ X ) @ N ) )
          = ( power_power @ int @ ( numeral_numeral @ int @ X ) @ N ) ) ) ).

% ceiling_numeral_power
thf(fact_1063_nat__ceiling__le__eq,axiom,
    ! [X: real,A2: nat] :
      ( ( ord_less_eq @ nat @ ( nat2 @ ( archimedean_ceiling @ real @ X ) ) @ A2 )
      = ( ord_less_eq @ real @ X @ ( semiring_1_of_nat @ real @ A2 ) ) ) ).

% nat_ceiling_le_eq
thf(fact_1064_bits__1__div__2,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ( ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
        = ( zero_zero @ A ) ) ) ).

% bits_1_div_2
thf(fact_1065_one__div__two__eq__zero,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ( ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
        = ( zero_zero @ A ) ) ) ).

% one_div_two_eq_zero
thf(fact_1066_even__succ__div__two,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [A2: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
         => ( ( divide_divide @ A @ ( plus_plus @ A @ A2 @ ( one_one @ A ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
            = ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ).

% even_succ_div_two
thf(fact_1067_odd__succ__div__two,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [A2: A] :
          ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
         => ( ( divide_divide @ A @ ( plus_plus @ A @ A2 @ ( one_one @ A ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
            = ( plus_plus @ A @ ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( one_one @ A ) ) ) ) ) ).

% odd_succ_div_two
thf(fact_1068_even__succ__div__2,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
         => ( ( divide_divide @ A @ ( plus_plus @ A @ ( one_one @ A ) @ A2 ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
            = ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ).

% even_succ_div_2
thf(fact_1069_numeral__less__floor,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [V: num,X: A] :
          ( ( ord_less @ int @ ( numeral_numeral @ int @ V ) @ ( archim6421214686448440834_floor @ A @ X ) )
          = ( ord_less_eq @ A @ ( plus_plus @ A @ ( numeral_numeral @ A @ V ) @ ( one_one @ A ) ) @ X ) ) ) ).

% numeral_less_floor
thf(fact_1070_floor__le__numeral,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,V: num] :
          ( ( ord_less_eq @ int @ ( archim6421214686448440834_floor @ A @ X ) @ ( numeral_numeral @ int @ V ) )
          = ( ord_less @ A @ X @ ( plus_plus @ A @ ( numeral_numeral @ A @ V ) @ ( one_one @ A ) ) ) ) ) ).

% floor_le_numeral
thf(fact_1071_one__less__floor,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( ord_less @ int @ ( one_one @ int ) @ ( archim6421214686448440834_floor @ A @ X ) )
          = ( ord_less_eq @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ X ) ) ) ).

% one_less_floor
thf(fact_1072_floor__le__one,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( ord_less_eq @ int @ ( archim6421214686448440834_floor @ A @ X ) @ ( one_one @ int ) )
          = ( ord_less @ A @ X @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% floor_le_one
thf(fact_1073_ceiling__less__numeral,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,V: num] :
          ( ( ord_less @ int @ ( archimedean_ceiling @ A @ X ) @ ( numeral_numeral @ int @ V ) )
          = ( ord_less_eq @ A @ X @ ( minus_minus @ A @ ( numeral_numeral @ A @ V ) @ ( one_one @ A ) ) ) ) ) ).

% ceiling_less_numeral
thf(fact_1074_numeral__le__ceiling,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [V: num,X: A] :
          ( ( ord_less_eq @ int @ ( numeral_numeral @ int @ V ) @ ( archimedean_ceiling @ A @ X ) )
          = ( ord_less @ A @ ( minus_minus @ A @ ( numeral_numeral @ A @ V ) @ ( one_one @ A ) ) @ X ) ) ) ).

% numeral_le_ceiling
thf(fact_1075_even__succ__div__exp,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A,N: nat] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
         => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
           => ( ( divide_divide @ A @ ( plus_plus @ A @ ( one_one @ A ) @ A2 ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) )
              = ( divide_divide @ A @ A2 @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) ) ) ) ) ) ).

% even_succ_div_exp
thf(fact_1076_unique__euclidean__semiring__with__nat__class_Oof__nat__div,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [M: nat,N: nat] :
          ( ( semiring_1_of_nat @ A @ ( divide_divide @ nat @ M @ N ) )
          = ( divide_divide @ A @ ( semiring_1_of_nat @ A @ M ) @ ( semiring_1_of_nat @ A @ N ) ) ) ) ).

% unique_euclidean_semiring_with_nat_class.of_nat_div
thf(fact_1077_floor__divide__of__int__eq,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [K: int,L: int] :
          ( ( archim6421214686448440834_floor @ A @ ( divide_divide @ A @ ( ring_1_of_int @ A @ K ) @ ( ring_1_of_int @ A @ L ) ) )
          = ( divide_divide @ int @ K @ L ) ) ) ).

% floor_divide_of_int_eq
thf(fact_1078_floor__le__ceiling,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] : ( ord_less_eq @ int @ ( archim6421214686448440834_floor @ A @ X ) @ ( archimedean_ceiling @ A @ X ) ) ) ).

% floor_le_ceiling
thf(fact_1079_floor__divide__of__nat__eq,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [M: nat,N: nat] :
          ( ( archim6421214686448440834_floor @ A @ ( divide_divide @ A @ ( semiring_1_of_nat @ A @ M ) @ ( semiring_1_of_nat @ A @ N ) ) )
          = ( semiring_1_of_nat @ int @ ( divide_divide @ nat @ M @ N ) ) ) ) ).

% floor_divide_of_nat_eq
thf(fact_1080_power__divide,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A2: A,B2: A,N: nat] :
          ( ( power_power @ A @ ( divide_divide @ A @ A2 @ B2 ) @ N )
          = ( divide_divide @ A @ ( power_power @ A @ A2 @ N ) @ ( power_power @ A @ B2 @ N ) ) ) ) ).

% power_divide
thf(fact_1081_div__le__dividend,axiom,
    ! [M: nat,N: nat] : ( ord_less_eq @ nat @ ( divide_divide @ nat @ M @ N ) @ M ) ).

% div_le_dividend
thf(fact_1082_div__le__mono,axiom,
    ! [M: nat,N: nat,K: nat] :
      ( ( ord_less_eq @ nat @ M @ N )
     => ( ord_less_eq @ nat @ ( divide_divide @ nat @ M @ K ) @ ( divide_divide @ nat @ N @ K ) ) ) ).

% div_le_mono
thf(fact_1083_ceiling__altdef,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ( ( archimedean_ceiling @ A )
        = ( ^ [X2: A] :
              ( if @ int
              @ ( X2
                = ( ring_1_of_int @ A @ ( archim6421214686448440834_floor @ A @ X2 ) ) )
              @ ( archim6421214686448440834_floor @ A @ X2 )
              @ ( plus_plus @ int @ ( archim6421214686448440834_floor @ A @ X2 ) @ ( one_one @ int ) ) ) ) ) ) ).

% ceiling_altdef
thf(fact_1084_ceiling__diff__floor__le__1,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] : ( ord_less_eq @ int @ ( minus_minus @ int @ ( archimedean_ceiling @ A @ X ) @ ( archim6421214686448440834_floor @ A @ X ) ) @ ( one_one @ int ) ) ) ).

% ceiling_diff_floor_le_1
thf(fact_1085_floor__mono,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ A @ X @ Y )
         => ( ord_less_eq @ int @ ( archim6421214686448440834_floor @ A @ X ) @ ( archim6421214686448440834_floor @ A @ Y ) ) ) ) ).

% floor_mono
thf(fact_1086_of__int__floor__le,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] : ( ord_less_eq @ A @ ( ring_1_of_int @ A @ ( archim6421214686448440834_floor @ A @ X ) ) @ X ) ) ).

% of_int_floor_le
thf(fact_1087_floor__less__cancel,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less @ int @ ( archim6421214686448440834_floor @ A @ X ) @ ( archim6421214686448440834_floor @ A @ Y ) )
         => ( ord_less @ A @ X @ Y ) ) ) ).

% floor_less_cancel
thf(fact_1088_real__of__int__floor__add__one__gt,axiom,
    ! [R2: real] : ( ord_less @ real @ R2 @ ( plus_plus @ real @ ( ring_1_of_int @ real @ ( archim6421214686448440834_floor @ real @ R2 ) ) @ ( one_one @ real ) ) ) ).

% real_of_int_floor_add_one_gt
thf(fact_1089_floor__eq,axiom,
    ! [N: int,X: real] :
      ( ( ord_less @ real @ ( ring_1_of_int @ real @ N ) @ X )
     => ( ( ord_less @ real @ X @ ( plus_plus @ real @ ( ring_1_of_int @ real @ N ) @ ( one_one @ real ) ) )
       => ( ( archim6421214686448440834_floor @ real @ X )
          = N ) ) ) ).

% floor_eq
thf(fact_1090_real__of__int__floor__gt__diff__one,axiom,
    ! [R2: real] : ( ord_less @ real @ ( minus_minus @ real @ R2 @ ( one_one @ real ) ) @ ( ring_1_of_int @ real @ ( archim6421214686448440834_floor @ real @ R2 ) ) ) ).

% real_of_int_floor_gt_diff_one
thf(fact_1091_real__of__int__floor__add__one__ge,axiom,
    ! [R2: real] : ( ord_less_eq @ real @ R2 @ ( plus_plus @ real @ ( ring_1_of_int @ real @ ( archim6421214686448440834_floor @ real @ R2 ) ) @ ( one_one @ real ) ) ) ).

% real_of_int_floor_add_one_ge
thf(fact_1092_real__of__int__floor__ge__diff__one,axiom,
    ! [R2: real] : ( ord_less_eq @ real @ ( minus_minus @ real @ R2 @ ( one_one @ real ) ) @ ( ring_1_of_int @ real @ ( archim6421214686448440834_floor @ real @ R2 ) ) ) ).

% real_of_int_floor_ge_diff_one
thf(fact_1093_ceiling__mono,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [Y: A,X: A] :
          ( ( ord_less_eq @ A @ Y @ X )
         => ( ord_less_eq @ int @ ( archimedean_ceiling @ A @ Y ) @ ( archimedean_ceiling @ A @ X ) ) ) ) ).

% ceiling_mono
thf(fact_1094_le__of__int__ceiling,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] : ( ord_less_eq @ A @ X @ ( ring_1_of_int @ A @ ( archimedean_ceiling @ A @ X ) ) ) ) ).

% le_of_int_ceiling
thf(fact_1095_ceiling__less__cancel,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less @ int @ ( archimedean_ceiling @ A @ X ) @ ( archimedean_ceiling @ A @ Y ) )
         => ( ord_less @ A @ X @ Y ) ) ) ).

% ceiling_less_cancel
thf(fact_1096_divide__right__mono__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ C2 @ ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ ( divide_divide @ A @ B2 @ C2 ) @ ( divide_divide @ A @ A2 @ C2 ) ) ) ) ) ).

% divide_right_mono_neg
thf(fact_1097_divide__nonpos__nonpos,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ A @ X @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ Y @ ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( divide_divide @ A @ X @ Y ) ) ) ) ) ).

% divide_nonpos_nonpos
thf(fact_1098_divide__nonpos__nonneg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ A @ X @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ Y )
           => ( ord_less_eq @ A @ ( divide_divide @ A @ X @ Y ) @ ( zero_zero @ A ) ) ) ) ) ).

% divide_nonpos_nonneg
thf(fact_1099_divide__nonneg__nonpos,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X )
         => ( ( ord_less_eq @ A @ Y @ ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ ( divide_divide @ A @ X @ Y ) @ ( zero_zero @ A ) ) ) ) ) ).

% divide_nonneg_nonpos
thf(fact_1100_divide__nonneg__nonneg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ Y )
           => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( divide_divide @ A @ X @ Y ) ) ) ) ) ).

% divide_nonneg_nonneg
thf(fact_1101_zero__le__divide__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( divide_divide @ A @ A2 @ B2 ) )
          = ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
              & ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 ) )
            | ( ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) )
              & ( ord_less_eq @ A @ B2 @ ( zero_zero @ A ) ) ) ) ) ) ).

% zero_le_divide_iff
thf(fact_1102_divide__right__mono,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
           => ( ord_less_eq @ A @ ( divide_divide @ A @ A2 @ C2 ) @ ( divide_divide @ A @ B2 @ C2 ) ) ) ) ) ).

% divide_right_mono
thf(fact_1103_divide__le__0__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( divide_divide @ A @ A2 @ B2 ) @ ( zero_zero @ A ) )
          = ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
              & ( ord_less_eq @ A @ B2 @ ( zero_zero @ A ) ) )
            | ( ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) )
              & ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 ) ) ) ) ) ).

% divide_le_0_iff
thf(fact_1104_divide__strict__right__mono__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( ord_less @ A @ B2 @ A2 )
         => ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
           => ( ord_less @ A @ ( divide_divide @ A @ A2 @ C2 ) @ ( divide_divide @ A @ B2 @ C2 ) ) ) ) ) ).

% divide_strict_right_mono_neg
thf(fact_1105_divide__strict__right__mono,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
           => ( ord_less @ A @ ( divide_divide @ A @ A2 @ C2 ) @ ( divide_divide @ A @ B2 @ C2 ) ) ) ) ) ).

% divide_strict_right_mono
thf(fact_1106_zero__less__divide__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( divide_divide @ A @ A2 @ B2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
              & ( ord_less @ A @ ( zero_zero @ A ) @ B2 ) )
            | ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
              & ( ord_less @ A @ B2 @ ( zero_zero @ A ) ) ) ) ) ) ).

% zero_less_divide_iff
thf(fact_1107_divide__less__cancel,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ord_less @ A @ ( divide_divide @ A @ A2 @ C2 ) @ ( divide_divide @ A @ B2 @ C2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less @ A @ A2 @ B2 ) )
            & ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
             => ( ord_less @ A @ B2 @ A2 ) )
            & ( C2
             != ( zero_zero @ A ) ) ) ) ) ).

% divide_less_cancel
thf(fact_1108_divide__less__0__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( divide_divide @ A @ A2 @ B2 ) @ ( zero_zero @ A ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
              & ( ord_less @ A @ B2 @ ( zero_zero @ A ) ) )
            | ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
              & ( ord_less @ A @ ( zero_zero @ A ) @ B2 ) ) ) ) ) ).

% divide_less_0_iff
thf(fact_1109_divide__pos__pos,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ X )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ Y )
           => ( ord_less @ A @ ( zero_zero @ A ) @ ( divide_divide @ A @ X @ Y ) ) ) ) ) ).

% divide_pos_pos
thf(fact_1110_divide__pos__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ X )
         => ( ( ord_less @ A @ Y @ ( zero_zero @ A ) )
           => ( ord_less @ A @ ( divide_divide @ A @ X @ Y ) @ ( zero_zero @ A ) ) ) ) ) ).

% divide_pos_neg
thf(fact_1111_divide__neg__pos,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less @ A @ X @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ Y )
           => ( ord_less @ A @ ( divide_divide @ A @ X @ Y ) @ ( zero_zero @ A ) ) ) ) ) ).

% divide_neg_pos
thf(fact_1112_divide__neg__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less @ A @ X @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ Y @ ( zero_zero @ A ) )
           => ( ord_less @ A @ ( zero_zero @ A ) @ ( divide_divide @ A @ X @ Y ) ) ) ) ) ).

% divide_neg_neg
thf(fact_1113_right__inverse__eq,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [B2: A,A2: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( ( divide_divide @ A @ A2 @ B2 )
              = ( one_one @ A ) )
            = ( A2 = B2 ) ) ) ) ).

% right_inverse_eq
thf(fact_1114_divide__numeral__1,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A2: A] :
          ( ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ one2 ) )
          = A2 ) ) ).

% divide_numeral_1
thf(fact_1115_dvd__div__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( semidom_divide @ A )
     => ! [B2: A,A2: A] :
          ( ( dvd_dvd @ A @ B2 @ A2 )
         => ( ( ( divide_divide @ A @ A2 @ B2 )
              = ( zero_zero @ A ) )
            = ( A2
              = ( zero_zero @ A ) ) ) ) ) ).

% dvd_div_eq_0_iff
thf(fact_1116_power__one__over,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A,N: nat] :
          ( ( power_power @ A @ ( divide_divide @ A @ ( one_one @ A ) @ A2 ) @ N )
          = ( divide_divide @ A @ ( one_one @ A ) @ ( power_power @ A @ A2 @ N ) ) ) ) ).

% power_one_over
thf(fact_1117_div__power,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [B2: A,A2: A,N: nat] :
          ( ( dvd_dvd @ A @ B2 @ A2 )
         => ( ( power_power @ A @ ( divide_divide @ A @ A2 @ B2 ) @ N )
            = ( divide_divide @ A @ ( power_power @ A @ A2 @ N ) @ ( power_power @ A @ B2 @ N ) ) ) ) ) ).

% div_power
thf(fact_1118_Euclidean__Division_Odiv__eq__0__iff,axiom,
    ! [M: nat,N: nat] :
      ( ( ( divide_divide @ nat @ M @ N )
        = ( zero_zero @ nat ) )
      = ( ( ord_less @ nat @ M @ N )
        | ( N
          = ( zero_zero @ nat ) ) ) ) ).

% Euclidean_Division.div_eq_0_iff
thf(fact_1119_le__floor__iff,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [Z: int,X: A] :
          ( ( ord_less_eq @ int @ Z @ ( archim6421214686448440834_floor @ A @ X ) )
          = ( ord_less_eq @ A @ ( ring_1_of_int @ A @ Z ) @ X ) ) ) ).

% le_floor_iff
thf(fact_1120_floor__less__iff,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,Z: int] :
          ( ( ord_less @ int @ ( archim6421214686448440834_floor @ A @ X ) @ Z )
          = ( ord_less @ A @ X @ ( ring_1_of_int @ A @ Z ) ) ) ) ).

% floor_less_iff
thf(fact_1121_le__floor__add,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,Y: A] : ( ord_less_eq @ int @ ( plus_plus @ int @ ( archim6421214686448440834_floor @ A @ X ) @ ( archim6421214686448440834_floor @ A @ Y ) ) @ ( archim6421214686448440834_floor @ A @ ( plus_plus @ A @ X @ Y ) ) ) ) ).

% le_floor_add
thf(fact_1122_floor__add__int,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,Z: int] :
          ( ( plus_plus @ int @ ( archim6421214686448440834_floor @ A @ X ) @ Z )
          = ( archim6421214686448440834_floor @ A @ ( plus_plus @ A @ X @ ( ring_1_of_int @ A @ Z ) ) ) ) ) ).

% floor_add_int
thf(fact_1123_int__add__floor,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [Z: int,X: A] :
          ( ( plus_plus @ int @ Z @ ( archim6421214686448440834_floor @ A @ X ) )
          = ( archim6421214686448440834_floor @ A @ ( plus_plus @ A @ ( ring_1_of_int @ A @ Z ) @ X ) ) ) ) ).

% int_add_floor
thf(fact_1124_floor__eq2,axiom,
    ! [N: int,X: real] :
      ( ( ord_less_eq @ real @ ( ring_1_of_int @ real @ N ) @ X )
     => ( ( ord_less @ real @ X @ ( plus_plus @ real @ ( ring_1_of_int @ real @ N ) @ ( one_one @ real ) ) )
       => ( ( archim6421214686448440834_floor @ real @ X )
          = N ) ) ) ).

% floor_eq2
thf(fact_1125_floor__power,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,N: nat] :
          ( ( X
            = ( ring_1_of_int @ A @ ( archim6421214686448440834_floor @ A @ X ) ) )
         => ( ( archim6421214686448440834_floor @ A @ ( power_power @ A @ X @ N ) )
            = ( power_power @ int @ ( archim6421214686448440834_floor @ A @ X ) @ N ) ) ) ) ).

% floor_power
thf(fact_1126_of__nat__ceiling,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [R2: A] : ( ord_less_eq @ A @ R2 @ ( semiring_1_of_nat @ A @ ( nat2 @ ( archimedean_ceiling @ A @ R2 ) ) ) ) ) ).

% of_nat_ceiling
thf(fact_1127_ceiling__le,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,A2: int] :
          ( ( ord_less_eq @ A @ X @ ( ring_1_of_int @ A @ A2 ) )
         => ( ord_less_eq @ int @ ( archimedean_ceiling @ A @ X ) @ A2 ) ) ) ).

% ceiling_le
thf(fact_1128_ceiling__le__iff,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,Z: int] :
          ( ( ord_less_eq @ int @ ( archimedean_ceiling @ A @ X ) @ Z )
          = ( ord_less_eq @ A @ X @ ( ring_1_of_int @ A @ Z ) ) ) ) ).

% ceiling_le_iff
thf(fact_1129_less__ceiling__iff,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [Z: int,X: A] :
          ( ( ord_less @ int @ Z @ ( archimedean_ceiling @ A @ X ) )
          = ( ord_less @ A @ ( ring_1_of_int @ A @ Z ) @ X ) ) ) ).

% less_ceiling_iff
thf(fact_1130_div__positive,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ B2 )
         => ( ( ord_less_eq @ A @ B2 @ A2 )
           => ( ord_less @ A @ ( zero_zero @ A ) @ ( divide_divide @ A @ A2 @ B2 ) ) ) ) ) ).

% div_positive
thf(fact_1131_unique__euclidean__semiring__numeral__class_Odiv__less,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less @ A @ A2 @ B2 )
           => ( ( divide_divide @ A @ A2 @ B2 )
              = ( zero_zero @ A ) ) ) ) ) ).

% unique_euclidean_semiring_numeral_class.div_less
thf(fact_1132_divide__nonpos__pos,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ A @ X @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ Y )
           => ( ord_less_eq @ A @ ( divide_divide @ A @ X @ Y ) @ ( zero_zero @ A ) ) ) ) ) ).

% divide_nonpos_pos
thf(fact_1133_divide__nonpos__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ A @ X @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ Y @ ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( divide_divide @ A @ X @ Y ) ) ) ) ) ).

% divide_nonpos_neg
thf(fact_1134_divide__nonneg__pos,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ Y )
           => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( divide_divide @ A @ X @ Y ) ) ) ) ) ).

% divide_nonneg_pos
thf(fact_1135_divide__nonneg__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X )
         => ( ( ord_less @ A @ Y @ ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ ( divide_divide @ A @ X @ Y ) @ ( zero_zero @ A ) ) ) ) ) ).

% divide_nonneg_neg
thf(fact_1136_divide__le__cancel,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( divide_divide @ A @ A2 @ C2 ) @ ( divide_divide @ A @ B2 @ C2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less_eq @ A @ A2 @ B2 ) )
            & ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
             => ( ord_less_eq @ A @ B2 @ A2 ) ) ) ) ) ).

% divide_le_cancel
thf(fact_1137_frac__less2,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A,Y: A,W: A,Z: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ X )
         => ( ( ord_less_eq @ A @ X @ Y )
           => ( ( ord_less @ A @ ( zero_zero @ A ) @ W )
             => ( ( ord_less @ A @ W @ Z )
               => ( ord_less @ A @ ( divide_divide @ A @ X @ Z ) @ ( divide_divide @ A @ Y @ W ) ) ) ) ) ) ) ).

% frac_less2
thf(fact_1138_frac__less,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A,Y: A,W: A,Z: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X )
         => ( ( ord_less @ A @ X @ Y )
           => ( ( ord_less @ A @ ( zero_zero @ A ) @ W )
             => ( ( ord_less_eq @ A @ W @ Z )
               => ( ord_less @ A @ ( divide_divide @ A @ X @ Z ) @ ( divide_divide @ A @ Y @ W ) ) ) ) ) ) ) ).

% frac_less
thf(fact_1139_frac__le,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [Y: A,X: A,W: A,Z: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ Y )
         => ( ( ord_less_eq @ A @ X @ Y )
           => ( ( ord_less @ A @ ( zero_zero @ A ) @ W )
             => ( ( ord_less_eq @ A @ W @ Z )
               => ( ord_less_eq @ A @ ( divide_divide @ A @ X @ Z ) @ ( divide_divide @ A @ Y @ W ) ) ) ) ) ) ) ).

% frac_le
thf(fact_1140_ceiling__add__le,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,Y: A] : ( ord_less_eq @ int @ ( archimedean_ceiling @ A @ ( plus_plus @ A @ X @ Y ) ) @ ( plus_plus @ int @ ( archimedean_ceiling @ A @ X ) @ ( archimedean_ceiling @ A @ Y ) ) ) ) ).

% ceiling_add_le
thf(fact_1141_real__nat__ceiling__ge,axiom,
    ! [X: real] : ( ord_less_eq @ real @ X @ ( semiring_1_of_nat @ real @ ( nat2 @ ( archimedean_ceiling @ real @ X ) ) ) ) ).

% real_nat_ceiling_ge
thf(fact_1142_less__divide__eq__1,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less @ A @ ( one_one @ A ) @ ( divide_divide @ A @ B2 @ A2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
              & ( ord_less @ A @ A2 @ B2 ) )
            | ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
              & ( ord_less @ A @ B2 @ A2 ) ) ) ) ) ).

% less_divide_eq_1
thf(fact_1143_divide__less__eq__1,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less @ A @ ( divide_divide @ A @ B2 @ A2 ) @ ( one_one @ A ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
              & ( ord_less @ A @ B2 @ A2 ) )
            | ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
              & ( ord_less @ A @ A2 @ B2 ) )
            | ( A2
              = ( zero_zero @ A ) ) ) ) ) ).

% divide_less_eq_1
thf(fact_1144_div__add__self1,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [B2: A,A2: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ ( plus_plus @ A @ B2 @ A2 ) @ B2 )
            = ( plus_plus @ A @ ( divide_divide @ A @ A2 @ B2 ) @ ( one_one @ A ) ) ) ) ) ).

% div_add_self1
thf(fact_1145_div__add__self2,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [B2: A,A2: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ ( plus_plus @ A @ A2 @ B2 ) @ B2 )
            = ( plus_plus @ A @ ( divide_divide @ A @ A2 @ B2 ) @ ( one_one @ A ) ) ) ) ) ).

% div_add_self2
thf(fact_1146_gt__half__sum,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ord_less @ A @ ( divide_divide @ A @ ( plus_plus @ A @ A2 @ B2 ) @ ( plus_plus @ A @ ( one_one @ A ) @ ( one_one @ A ) ) ) @ B2 ) ) ) ).

% gt_half_sum
thf(fact_1147_less__half__sum,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ord_less @ A @ A2 @ ( divide_divide @ A @ ( plus_plus @ A @ A2 @ B2 ) @ ( plus_plus @ A @ ( one_one @ A ) @ ( one_one @ A ) ) ) ) ) ) ).

% less_half_sum
thf(fact_1148_numeral__Bit0__div__2,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [N: num] :
          ( ( divide_divide @ A @ ( numeral_numeral @ A @ ( bit0 @ N ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
          = ( numeral_numeral @ A @ N ) ) ) ).

% numeral_Bit0_div_2
thf(fact_1149_unit__div__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [B2: A,A2: A] :
          ( ( dvd_dvd @ A @ B2 @ ( one_one @ A ) )
         => ( ( ( divide_divide @ A @ A2 @ B2 )
              = ( zero_zero @ A ) )
            = ( A2
              = ( zero_zero @ A ) ) ) ) ) ).

% unit_div_eq_0_iff
thf(fact_1150_div__greater__zero__iff,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( divide_divide @ nat @ M @ N ) )
      = ( ( ord_less_eq @ nat @ N @ M )
        & ( ord_less @ nat @ ( zero_zero @ nat ) @ N ) ) ) ).

% div_greater_zero_iff
thf(fact_1151_div__le__mono2,axiom,
    ! [M: nat,N: nat,K: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M )
     => ( ( ord_less_eq @ nat @ M @ N )
       => ( ord_less_eq @ nat @ ( divide_divide @ nat @ K @ N ) @ ( divide_divide @ nat @ K @ M ) ) ) ) ).

% div_le_mono2
thf(fact_1152_div__less__dividend,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less @ nat @ ( one_one @ nat ) @ N )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M )
       => ( ord_less @ nat @ ( divide_divide @ nat @ M @ N ) @ M ) ) ) ).

% div_less_dividend
thf(fact_1153_div__eq__dividend__iff,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M )
     => ( ( ( divide_divide @ nat @ M @ N )
          = M )
        = ( N
          = ( one_one @ nat ) ) ) ) ).

% div_eq_dividend_iff
thf(fact_1154_bounded__Max__nat,axiom,
    ! [P: nat > $o,X: nat,M5: nat] :
      ( ( P @ X )
     => ( ! [X3: nat] :
            ( ( P @ X3 )
           => ( ord_less_eq @ nat @ X3 @ M5 ) )
       => ~ ! [M4: nat] :
              ( ( P @ M4 )
             => ~ ! [X5: nat] :
                    ( ( P @ X5 )
                   => ( ord_less_eq @ nat @ X5 @ M4 ) ) ) ) ) ).

% bounded_Max_nat
thf(fact_1155_of__nat__floor,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [R2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ R2 )
         => ( ord_less_eq @ A @ ( semiring_1_of_nat @ A @ ( nat2 @ ( archim6421214686448440834_floor @ A @ R2 ) ) ) @ R2 ) ) ) ).

% of_nat_floor
thf(fact_1156_one__add__floor,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( plus_plus @ int @ ( archim6421214686448440834_floor @ A @ X ) @ ( one_one @ int ) )
          = ( archim6421214686448440834_floor @ A @ ( plus_plus @ A @ X @ ( one_one @ A ) ) ) ) ) ).

% one_add_floor
thf(fact_1157_nat__floor__neg,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ X @ ( zero_zero @ real ) )
     => ( ( nat2 @ ( archim6421214686448440834_floor @ real @ X ) )
        = ( zero_zero @ nat ) ) ) ).

% nat_floor_neg
thf(fact_1158_of__int__ceiling__le__add__one,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [R2: A] : ( ord_less_eq @ A @ ( ring_1_of_int @ A @ ( archimedean_ceiling @ A @ R2 ) ) @ ( plus_plus @ A @ R2 @ ( one_one @ A ) ) ) ) ).

% of_int_ceiling_le_add_one
thf(fact_1159_of__int__ceiling__diff__one__le,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [R2: A] : ( ord_less_eq @ A @ ( minus_minus @ A @ ( ring_1_of_int @ A @ ( archimedean_ceiling @ A @ R2 ) ) @ ( one_one @ A ) ) @ R2 ) ) ).

% of_int_ceiling_diff_one_le
thf(fact_1160_le__nat__floor,axiom,
    ! [X: nat,A2: real] :
      ( ( ord_less_eq @ real @ ( semiring_1_of_nat @ real @ X ) @ A2 )
     => ( ord_less_eq @ nat @ X @ ( nat2 @ ( archim6421214686448440834_floor @ real @ A2 ) ) ) ) ).

% le_nat_floor
thf(fact_1161_divide__le__eq__1,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less_eq @ A @ ( divide_divide @ A @ B2 @ A2 ) @ ( one_one @ A ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
              & ( ord_less_eq @ A @ B2 @ A2 ) )
            | ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
              & ( ord_less_eq @ A @ A2 @ B2 ) )
            | ( A2
              = ( zero_zero @ A ) ) ) ) ) ).

% divide_le_eq_1
thf(fact_1162_le__divide__eq__1,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less_eq @ A @ ( one_one @ A ) @ ( divide_divide @ A @ B2 @ A2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
              & ( ord_less_eq @ A @ A2 @ B2 ) )
            | ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
              & ( ord_less_eq @ A @ B2 @ A2 ) ) ) ) ) ).

% le_divide_eq_1
thf(fact_1163_field__sum__of__halves,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A] :
          ( ( plus_plus @ A @ ( divide_divide @ A @ X @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ A @ X @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) )
          = X ) ) ).

% field_sum_of_halves
thf(fact_1164_bit__eq__rec,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ( ( ^ [Y3: A,Z2: A] : ( Y3 = Z2 ) )
        = ( ^ [A3: A,B3: A] :
              ( ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A3 )
                = ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B3 ) )
              & ( ( divide_divide @ A @ A3 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
                = ( divide_divide @ A @ B3 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% bit_eq_rec
thf(fact_1165_power__diff,axiom,
    ! [A: $tType] :
      ( ( semidom_divide @ A )
     => ! [A2: A,N: nat,M: nat] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( ord_less_eq @ nat @ N @ M )
           => ( ( power_power @ A @ A2 @ ( minus_minus @ nat @ M @ N ) )
              = ( divide_divide @ A @ ( power_power @ A @ A2 @ M ) @ ( power_power @ A @ A2 @ N ) ) ) ) ) ) ).

% power_diff
thf(fact_1166_floor__log2__div2,axiom,
    ! [N: nat] :
      ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
     => ( ( archim6421214686448440834_floor @ real @ ( log2 @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( semiring_1_of_nat @ real @ N ) ) )
        = ( plus_plus @ int @ ( archim6421214686448440834_floor @ real @ ( log2 @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( semiring_1_of_nat @ real @ ( divide_divide @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) @ ( one_one @ int ) ) ) ) ).

% floor_log2_div2
thf(fact_1167_floor__split,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [P: int > $o,T2: A] :
          ( ( P @ ( archim6421214686448440834_floor @ A @ T2 ) )
          = ( ! [I4: int] :
                ( ( ( ord_less_eq @ A @ ( ring_1_of_int @ A @ I4 ) @ T2 )
                  & ( ord_less @ A @ T2 @ ( plus_plus @ A @ ( ring_1_of_int @ A @ I4 ) @ ( one_one @ A ) ) ) )
               => ( P @ I4 ) ) ) ) ) ).

% floor_split
thf(fact_1168_floor__eq__iff,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,A2: int] :
          ( ( ( archim6421214686448440834_floor @ A @ X )
            = A2 )
          = ( ( ord_less_eq @ A @ ( ring_1_of_int @ A @ A2 ) @ X )
            & ( ord_less @ A @ X @ ( plus_plus @ A @ ( ring_1_of_int @ A @ A2 ) @ ( one_one @ A ) ) ) ) ) ) ).

% floor_eq_iff
thf(fact_1169_floor__unique,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [Z: int,X: A] :
          ( ( ord_less_eq @ A @ ( ring_1_of_int @ A @ Z ) @ X )
         => ( ( ord_less @ A @ X @ ( plus_plus @ A @ ( ring_1_of_int @ A @ Z ) @ ( one_one @ A ) ) )
           => ( ( archim6421214686448440834_floor @ A @ X )
              = Z ) ) ) ) ).

% floor_unique
thf(fact_1170_less__floor__iff,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [Z: int,X: A] :
          ( ( ord_less @ int @ Z @ ( archim6421214686448440834_floor @ A @ X ) )
          = ( ord_less_eq @ A @ ( plus_plus @ A @ ( ring_1_of_int @ A @ Z ) @ ( one_one @ A ) ) @ X ) ) ) ).

% less_floor_iff
thf(fact_1171_floor__le__iff,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,Z: int] :
          ( ( ord_less_eq @ int @ ( archim6421214686448440834_floor @ A @ X ) @ Z )
          = ( ord_less @ A @ X @ ( plus_plus @ A @ ( ring_1_of_int @ A @ Z ) @ ( one_one @ A ) ) ) ) ) ).

% floor_le_iff
thf(fact_1172_floor__correct,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( ord_less_eq @ A @ ( ring_1_of_int @ A @ ( archim6421214686448440834_floor @ A @ X ) ) @ X )
          & ( ord_less @ A @ X @ ( ring_1_of_int @ A @ ( plus_plus @ int @ ( archim6421214686448440834_floor @ A @ X ) @ ( one_one @ int ) ) ) ) ) ) ).

% floor_correct
thf(fact_1173_ceiling__split,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [P: int > $o,T2: A] :
          ( ( P @ ( archimedean_ceiling @ A @ T2 ) )
          = ( ! [I4: int] :
                ( ( ( ord_less @ A @ ( minus_minus @ A @ ( ring_1_of_int @ A @ I4 ) @ ( one_one @ A ) ) @ T2 )
                  & ( ord_less_eq @ A @ T2 @ ( ring_1_of_int @ A @ I4 ) ) )
               => ( P @ I4 ) ) ) ) ) ).

% ceiling_split
thf(fact_1174_ceiling__eq__iff,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,A2: int] :
          ( ( ( archimedean_ceiling @ A @ X )
            = A2 )
          = ( ( ord_less @ A @ ( minus_minus @ A @ ( ring_1_of_int @ A @ A2 ) @ ( one_one @ A ) ) @ X )
            & ( ord_less_eq @ A @ X @ ( ring_1_of_int @ A @ A2 ) ) ) ) ) ).

% ceiling_eq_iff
thf(fact_1175_ceiling__unique,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [Z: int,X: A] :
          ( ( ord_less @ A @ ( minus_minus @ A @ ( ring_1_of_int @ A @ Z ) @ ( one_one @ A ) ) @ X )
         => ( ( ord_less_eq @ A @ X @ ( ring_1_of_int @ A @ Z ) )
           => ( ( archimedean_ceiling @ A @ X )
              = Z ) ) ) ) ).

% ceiling_unique
thf(fact_1176_ceiling__correct,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( ord_less @ A @ ( minus_minus @ A @ ( ring_1_of_int @ A @ ( archimedean_ceiling @ A @ X ) ) @ ( one_one @ A ) ) @ X )
          & ( ord_less_eq @ A @ X @ ( ring_1_of_int @ A @ ( archimedean_ceiling @ A @ X ) ) ) ) ) ).

% ceiling_correct
thf(fact_1177_ceiling__less__iff,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,Z: int] :
          ( ( ord_less @ int @ ( archimedean_ceiling @ A @ X ) @ Z )
          = ( ord_less_eq @ A @ X @ ( minus_minus @ A @ ( ring_1_of_int @ A @ Z ) @ ( one_one @ A ) ) ) ) ) ).

% ceiling_less_iff
thf(fact_1178_le__ceiling__iff,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [Z: int,X: A] :
          ( ( ord_less_eq @ int @ Z @ ( archimedean_ceiling @ A @ X ) )
          = ( ord_less @ A @ ( minus_minus @ A @ ( ring_1_of_int @ A @ Z ) @ ( one_one @ A ) ) @ X ) ) ) ).

% le_ceiling_iff
thf(fact_1179_half__gt__zero__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) )
          = ( ord_less @ A @ ( zero_zero @ A ) @ A2 ) ) ) ).

% half_gt_zero_iff
thf(fact_1180_half__gt__zero,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ord_less @ A @ ( zero_zero @ A ) @ ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ).

% half_gt_zero
thf(fact_1181_field__less__half__sum,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less @ A @ X @ Y )
         => ( ord_less @ A @ X @ ( divide_divide @ A @ ( plus_plus @ A @ X @ Y ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ).

% field_less_half_sum
thf(fact_1182_div__exp__eq,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A,M: nat,N: nat] :
          ( ( divide_divide @ A @ ( divide_divide @ A @ A2 @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M ) ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) )
          = ( divide_divide @ A @ A2 @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( plus_plus @ nat @ M @ N ) ) ) ) ) ).

% div_exp_eq
thf(fact_1183_inverse__of__nat__le,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [N: nat,M: nat] :
          ( ( ord_less_eq @ nat @ N @ M )
         => ( ( N
             != ( zero_zero @ nat ) )
           => ( ord_less_eq @ A @ ( divide_divide @ A @ ( one_one @ A ) @ ( semiring_1_of_nat @ A @ M ) ) @ ( divide_divide @ A @ ( one_one @ A ) @ ( semiring_1_of_nat @ A @ N ) ) ) ) ) ) ).

% inverse_of_nat_le
thf(fact_1184_power__diff__power__eq,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [A2: A,N: nat,M: nat] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( ( ord_less_eq @ nat @ N @ M )
             => ( ( divide_divide @ A @ ( power_power @ A @ A2 @ M ) @ ( power_power @ A @ A2 @ N ) )
                = ( power_power @ A @ A2 @ ( minus_minus @ nat @ M @ N ) ) ) )
            & ( ~ ( ord_less_eq @ nat @ N @ M )
             => ( ( divide_divide @ A @ ( power_power @ A @ A2 @ M ) @ ( power_power @ A @ A2 @ N ) )
                = ( divide_divide @ A @ ( one_one @ A ) @ ( power_power @ A @ A2 @ ( minus_minus @ nat @ N @ M ) ) ) ) ) ) ) ) ).

% power_diff_power_eq
thf(fact_1185_ceiling__log2__div2,axiom,
    ! [N: nat] :
      ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
     => ( ( archimedean_ceiling @ real @ ( log2 @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( semiring_1_of_nat @ real @ N ) ) )
        = ( plus_plus @ int @ ( archimedean_ceiling @ real @ ( log2 @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( semiring_1_of_nat @ real @ ( plus_plus @ nat @ ( divide_divide @ nat @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ nat ) ) ) ) ) @ ( one_one @ int ) ) ) ) ).

% ceiling_log2_div2
thf(fact_1186_ceiling__eq,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [N: int,X: A] :
          ( ( ord_less @ A @ ( ring_1_of_int @ A @ N ) @ X )
         => ( ( ord_less_eq @ A @ X @ ( plus_plus @ A @ ( ring_1_of_int @ A @ N ) @ ( one_one @ A ) ) )
           => ( ( archimedean_ceiling @ A @ X )
              = ( plus_plus @ int @ N @ ( one_one @ int ) ) ) ) ) ) ).

% ceiling_eq
thf(fact_1187_sqrt__even__pow2,axiom,
    ! [N: nat] :
      ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
     => ( ( sqrt @ ( power_power @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ N ) )
        = ( power_power @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( divide_divide @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% sqrt_even_pow2
thf(fact_1188_even__mask__div__iff_H,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [M: nat,N: nat] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( divide_divide @ A @ ( minus_minus @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M ) @ ( one_one @ A ) ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) ) )
          = ( ord_less_eq @ nat @ M @ N ) ) ) ).

% even_mask_div_iff'
thf(fact_1189_real__sqrt__power__even,axiom,
    ! [N: nat,X: real] :
      ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
       => ( ( power_power @ real @ ( sqrt @ X ) @ N )
          = ( power_power @ real @ X @ ( divide_divide @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% real_sqrt_power_even
thf(fact_1190_even__mask__div__iff,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [M: nat,N: nat] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( divide_divide @ A @ ( minus_minus @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M ) @ ( one_one @ A ) ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) ) )
          = ( ( ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N )
              = ( zero_zero @ A ) )
            | ( ord_less_eq @ nat @ M @ N ) ) ) ) ).

% even_mask_div_iff
thf(fact_1191_stable__imp__take__bit__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A,N: nat] :
          ( ( ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
            = A2 )
         => ( ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
             => ( ( bit_se2584673776208193580ke_bit @ A @ N @ A2 )
                = ( zero_zero @ A ) ) )
            & ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
             => ( ( bit_se2584673776208193580ke_bit @ A @ N @ A2 )
                = ( minus_minus @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) @ ( one_one @ A ) ) ) ) ) ) ) ).

% stable_imp_take_bit_eq
thf(fact_1192_floor__log__nat__eq__if,axiom,
    ! [B2: nat,N: nat,K: nat] :
      ( ( ord_less_eq @ nat @ ( power_power @ nat @ B2 @ N ) @ K )
     => ( ( ord_less @ nat @ K @ ( power_power @ nat @ B2 @ ( plus_plus @ nat @ N @ ( one_one @ nat ) ) ) )
       => ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ B2 )
         => ( ( archim6421214686448440834_floor @ real @ ( log2 @ ( semiring_1_of_nat @ real @ B2 ) @ ( semiring_1_of_nat @ real @ K ) ) )
            = ( semiring_1_of_nat @ int @ N ) ) ) ) ) ).

% floor_log_nat_eq_if
thf(fact_1193_VEBT__internal_Oexp__split__high__low_I1_J,axiom,
    ! [X: nat,N: nat,M: nat] :
      ( ( ord_less @ nat @ X @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( plus_plus @ nat @ N @ M ) ) )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
       => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M )
         => ( ord_less @ nat @ ( vEBT_VEBT_high @ X @ N ) @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M ) ) ) ) ) ).

% VEBT_internal.exp_split_high_low(1)
thf(fact_1194_high__inv,axiom,
    ! [X: nat,N: nat,Y: nat] :
      ( ( ord_less @ nat @ X @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) )
     => ( ( vEBT_VEBT_high @ ( plus_plus @ nat @ ( times_times @ nat @ Y @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) @ X ) @ N )
        = Y ) ) ).

% high_inv
thf(fact_1195_artanh__def,axiom,
    ! [A: $tType] :
      ( ( ( real_V3459762299906320749_field @ A )
        & ( ln @ A ) )
     => ( ( artanh @ A )
        = ( ^ [X2: A] : ( divide_divide @ A @ ( ln_ln @ A @ ( divide_divide @ A @ ( plus_plus @ A @ ( one_one @ A ) @ X2 ) @ ( minus_minus @ A @ ( one_one @ A ) @ X2 ) ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ).

% artanh_def
thf(fact_1196_div2__even__ext__nat,axiom,
    ! [X: nat,Y: nat] :
      ( ( ( divide_divide @ nat @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
        = ( divide_divide @ nat @ Y @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
     => ( ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ X )
          = ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Y ) )
       => ( X = Y ) ) ) ).

% div2_even_ext_nat
thf(fact_1197_round__unique,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,Y: int] :
          ( ( ord_less @ A @ ( minus_minus @ A @ X @ ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) @ ( ring_1_of_int @ A @ Y ) )
         => ( ( ord_less_eq @ A @ ( ring_1_of_int @ A @ Y ) @ ( plus_plus @ A @ X @ ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) )
           => ( ( archimedean_round @ A @ X )
              = Y ) ) ) ) ).

% round_unique
thf(fact_1198_ceiling__log__eq__powr__iff,axiom,
    ! [X: real,B2: real,K: nat] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less @ real @ ( one_one @ real ) @ B2 )
       => ( ( ( archimedean_ceiling @ real @ ( log2 @ B2 @ X ) )
            = ( plus_plus @ int @ ( semiring_1_of_nat @ int @ K ) @ ( one_one @ int ) ) )
          = ( ( ord_less @ real @ ( powr @ real @ B2 @ ( semiring_1_of_nat @ real @ K ) ) @ X )
            & ( ord_less_eq @ real @ X @ ( powr @ real @ B2 @ ( semiring_1_of_nat @ real @ ( plus_plus @ nat @ K @ ( one_one @ nat ) ) ) ) ) ) ) ) ) ).

% ceiling_log_eq_powr_iff
thf(fact_1199_of__int__round__gt,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] : ( ord_less @ A @ ( minus_minus @ A @ X @ ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) @ ( ring_1_of_int @ A @ ( archimedean_round @ A @ X ) ) ) ) ).

% of_int_round_gt
thf(fact_1200_of__int__round__ge,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] : ( ord_less_eq @ A @ ( minus_minus @ A @ X @ ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) @ ( ring_1_of_int @ A @ ( archimedean_round @ A @ X ) ) ) ) ).

% of_int_round_ge
thf(fact_1201_of__int__round__le,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] : ( ord_less_eq @ A @ ( ring_1_of_int @ A @ ( archimedean_round @ A @ X ) ) @ ( plus_plus @ A @ X @ ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ).

% of_int_round_le
thf(fact_1202_mult__cancel__right,axiom,
    ! [A: $tType] :
      ( ( semiri6575147826004484403cancel @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ( times_times @ A @ A2 @ C2 )
            = ( times_times @ A @ B2 @ C2 ) )
          = ( ( C2
              = ( zero_zero @ A ) )
            | ( A2 = B2 ) ) ) ) ).

% mult_cancel_right
thf(fact_1203_mult__cancel__left,axiom,
    ! [A: $tType] :
      ( ( semiri6575147826004484403cancel @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ( times_times @ A @ C2 @ A2 )
            = ( times_times @ A @ C2 @ B2 ) )
          = ( ( C2
              = ( zero_zero @ A ) )
            | ( A2 = B2 ) ) ) ) ).

% mult_cancel_left
thf(fact_1204_mult__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( semiri3467727345109120633visors @ A )
     => ! [A2: A,B2: A] :
          ( ( ( times_times @ A @ A2 @ B2 )
            = ( zero_zero @ A ) )
          = ( ( A2
              = ( zero_zero @ A ) )
            | ( B2
              = ( zero_zero @ A ) ) ) ) ) ).

% mult_eq_0_iff
thf(fact_1205_mult__zero__right,axiom,
    ! [A: $tType] :
      ( ( mult_zero @ A )
     => ! [A2: A] :
          ( ( times_times @ A @ A2 @ ( zero_zero @ A ) )
          = ( zero_zero @ A ) ) ) ).

% mult_zero_right
thf(fact_1206_mult__zero__left,axiom,
    ! [A: $tType] :
      ( ( mult_zero @ A )
     => ! [A2: A] :
          ( ( times_times @ A @ ( zero_zero @ A ) @ A2 )
          = ( zero_zero @ A ) ) ) ).

% mult_zero_left
thf(fact_1207_numeral__times__numeral,axiom,
    ! [A: $tType] :
      ( ( semiring_numeral @ A )
     => ! [M: num,N: num] :
          ( ( times_times @ A @ ( numeral_numeral @ A @ M ) @ ( numeral_numeral @ A @ N ) )
          = ( numeral_numeral @ A @ ( times_times @ num @ M @ N ) ) ) ) ).

% numeral_times_numeral
thf(fact_1208_mult__numeral__left__semiring__numeral,axiom,
    ! [A: $tType] :
      ( ( semiring_numeral @ A )
     => ! [V: num,W: num,Z: A] :
          ( ( times_times @ A @ ( numeral_numeral @ A @ V ) @ ( times_times @ A @ ( numeral_numeral @ A @ W ) @ Z ) )
          = ( times_times @ A @ ( numeral_numeral @ A @ ( times_times @ num @ V @ W ) ) @ Z ) ) ) ).

% mult_numeral_left_semiring_numeral
thf(fact_1209_mult_Oright__neutral,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [A2: A] :
          ( ( times_times @ A @ A2 @ ( one_one @ A ) )
          = A2 ) ) ).

% mult.right_neutral
thf(fact_1210_mult__1,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [A2: A] :
          ( ( times_times @ A @ ( one_one @ A ) @ A2 )
          = A2 ) ) ).

% mult_1
thf(fact_1211_ln__inj__iff,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ Y )
       => ( ( ( ln_ln @ real @ X )
            = ( ln_ln @ real @ Y ) )
          = ( X = Y ) ) ) ) ).

% ln_inj_iff
thf(fact_1212_ln__less__cancel__iff,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ Y )
       => ( ( ord_less @ real @ ( ln_ln @ real @ X ) @ ( ln_ln @ real @ Y ) )
          = ( ord_less @ real @ X @ Y ) ) ) ) ).

% ln_less_cancel_iff
thf(fact_1213_of__int__mult,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [W: int,Z: int] :
          ( ( ring_1_of_int @ A @ ( times_times @ int @ W @ Z ) )
          = ( times_times @ A @ ( ring_1_of_int @ A @ W ) @ ( ring_1_of_int @ A @ Z ) ) ) ) ).

% of_int_mult
thf(fact_1214_mult__cancel2,axiom,
    ! [M: nat,K: nat,N: nat] :
      ( ( ( times_times @ nat @ M @ K )
        = ( times_times @ nat @ N @ K ) )
      = ( ( M = N )
        | ( K
          = ( zero_zero @ nat ) ) ) ) ).

% mult_cancel2
thf(fact_1215_mult__cancel1,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( ( times_times @ nat @ K @ M )
        = ( times_times @ nat @ K @ N ) )
      = ( ( M = N )
        | ( K
          = ( zero_zero @ nat ) ) ) ) ).

% mult_cancel1
thf(fact_1216_mult__0__right,axiom,
    ! [M: nat] :
      ( ( times_times @ nat @ M @ ( zero_zero @ nat ) )
      = ( zero_zero @ nat ) ) ).

% mult_0_right
thf(fact_1217_mult__is__0,axiom,
    ! [M: nat,N: nat] :
      ( ( ( times_times @ nat @ M @ N )
        = ( zero_zero @ nat ) )
      = ( ( M
          = ( zero_zero @ nat ) )
        | ( N
          = ( zero_zero @ nat ) ) ) ) ).

% mult_is_0
thf(fact_1218_powr__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( ln @ A )
     => ! [W: A,Z: A] :
          ( ( ( powr @ A @ W @ Z )
            = ( zero_zero @ A ) )
          = ( W
            = ( zero_zero @ A ) ) ) ) ).

% powr_eq_0_iff
thf(fact_1219_powr__0,axiom,
    ! [A: $tType] :
      ( ( ln @ A )
     => ! [Z: A] :
          ( ( powr @ A @ ( zero_zero @ A ) @ Z )
          = ( zero_zero @ A ) ) ) ).

% powr_0
thf(fact_1220_nat__mult__eq__1__iff,axiom,
    ! [M: nat,N: nat] :
      ( ( ( times_times @ nat @ M @ N )
        = ( one_one @ nat ) )
      = ( ( M
          = ( one_one @ nat ) )
        & ( N
          = ( one_one @ nat ) ) ) ) ).

% nat_mult_eq_1_iff
thf(fact_1221_nat__1__eq__mult__iff,axiom,
    ! [M: nat,N: nat] :
      ( ( ( one_one @ nat )
        = ( times_times @ nat @ M @ N ) )
      = ( ( M
          = ( one_one @ nat ) )
        & ( N
          = ( one_one @ nat ) ) ) ) ).

% nat_1_eq_mult_iff
thf(fact_1222_round__of__int,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [N: int] :
          ( ( archimedean_round @ A @ ( ring_1_of_int @ A @ N ) )
          = N ) ) ).

% round_of_int
thf(fact_1223_bit__concat__def,axiom,
    ( vEBT_VEBT_bit_concat
    = ( ^ [H: nat,L2: nat,D4: nat] : ( plus_plus @ nat @ ( times_times @ nat @ H @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ D4 ) ) @ L2 ) ) ) ).

% bit_concat_def
thf(fact_1224_mult__cancel__right2,axiom,
    ! [A: $tType] :
      ( ( ring_15535105094025558882visors @ A )
     => ! [A2: A,C2: A] :
          ( ( ( times_times @ A @ A2 @ C2 )
            = C2 )
          = ( ( C2
              = ( zero_zero @ A ) )
            | ( A2
              = ( one_one @ A ) ) ) ) ) ).

% mult_cancel_right2
thf(fact_1225_mult__cancel__right1,axiom,
    ! [A: $tType] :
      ( ( ring_15535105094025558882visors @ A )
     => ! [C2: A,B2: A] :
          ( ( C2
            = ( times_times @ A @ B2 @ C2 ) )
          = ( ( C2
              = ( zero_zero @ A ) )
            | ( B2
              = ( one_one @ A ) ) ) ) ) ).

% mult_cancel_right1
thf(fact_1226_mult__cancel__left2,axiom,
    ! [A: $tType] :
      ( ( ring_15535105094025558882visors @ A )
     => ! [C2: A,A2: A] :
          ( ( ( times_times @ A @ C2 @ A2 )
            = C2 )
          = ( ( C2
              = ( zero_zero @ A ) )
            | ( A2
              = ( one_one @ A ) ) ) ) ) ).

% mult_cancel_left2
thf(fact_1227_mult__cancel__left1,axiom,
    ! [A: $tType] :
      ( ( ring_15535105094025558882visors @ A )
     => ! [C2: A,B2: A] :
          ( ( C2
            = ( times_times @ A @ C2 @ B2 ) )
          = ( ( C2
              = ( zero_zero @ A ) )
            | ( B2
              = ( one_one @ A ) ) ) ) ) ).

% mult_cancel_left1
thf(fact_1228_sum__squares__eq__zero__iff,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [X: A,Y: A] :
          ( ( ( plus_plus @ A @ ( times_times @ A @ X @ X ) @ ( times_times @ A @ Y @ Y ) )
            = ( zero_zero @ A ) )
          = ( ( X
              = ( zero_zero @ A ) )
            & ( Y
              = ( zero_zero @ A ) ) ) ) ) ).

% sum_squares_eq_zero_iff
thf(fact_1229_mult__divide__mult__cancel__left__if,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ( C2
              = ( zero_zero @ A ) )
           => ( ( divide_divide @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) )
              = ( zero_zero @ A ) ) )
          & ( ( C2
             != ( zero_zero @ A ) )
           => ( ( divide_divide @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) )
              = ( divide_divide @ A @ A2 @ B2 ) ) ) ) ) ).

% mult_divide_mult_cancel_left_if
thf(fact_1230_nonzero__mult__divide__mult__cancel__left,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) )
            = ( divide_divide @ A @ A2 @ B2 ) ) ) ) ).

% nonzero_mult_divide_mult_cancel_left
thf(fact_1231_nonzero__mult__div__cancel__left,axiom,
    ! [A: $tType] :
      ( ( semidom_divide @ A )
     => ! [A2: A,B2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ ( times_times @ A @ A2 @ B2 ) @ A2 )
            = B2 ) ) ) ).

% nonzero_mult_div_cancel_left
thf(fact_1232_nonzero__mult__divide__mult__cancel__left2,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ B2 @ C2 ) )
            = ( divide_divide @ A @ A2 @ B2 ) ) ) ) ).

% nonzero_mult_divide_mult_cancel_left2
thf(fact_1233_nonzero__mult__divide__mult__cancel__right,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) )
            = ( divide_divide @ A @ A2 @ B2 ) ) ) ) ).

% nonzero_mult_divide_mult_cancel_right
thf(fact_1234_nonzero__mult__div__cancel__right,axiom,
    ! [A: $tType] :
      ( ( semidom_divide @ A )
     => ! [B2: A,A2: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ ( times_times @ A @ A2 @ B2 ) @ B2 )
            = A2 ) ) ) ).

% nonzero_mult_div_cancel_right
thf(fact_1235_nonzero__mult__divide__mult__cancel__right2,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ C2 @ B2 ) )
            = ( divide_divide @ A @ A2 @ B2 ) ) ) ) ).

% nonzero_mult_divide_mult_cancel_right2
thf(fact_1236_div__mult__mult1,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) )
            = ( divide_divide @ A @ A2 @ B2 ) ) ) ) ).

% div_mult_mult1
thf(fact_1237_div__mult__mult2,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) )
            = ( divide_divide @ A @ A2 @ B2 ) ) ) ) ).

% div_mult_mult2
thf(fact_1238_div__mult__mult1__if,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ( C2
              = ( zero_zero @ A ) )
           => ( ( divide_divide @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) )
              = ( zero_zero @ A ) ) )
          & ( ( C2
             != ( zero_zero @ A ) )
           => ( ( divide_divide @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) )
              = ( divide_divide @ A @ A2 @ B2 ) ) ) ) ) ).

% div_mult_mult1_if
thf(fact_1239_distrib__right__numeral,axiom,
    ! [A: $tType] :
      ( ( ( numeral @ A )
        & ( semiring @ A ) )
     => ! [A2: A,B2: A,V: num] :
          ( ( times_times @ A @ ( plus_plus @ A @ A2 @ B2 ) @ ( numeral_numeral @ A @ V ) )
          = ( plus_plus @ A @ ( times_times @ A @ A2 @ ( numeral_numeral @ A @ V ) ) @ ( times_times @ A @ B2 @ ( numeral_numeral @ A @ V ) ) ) ) ) ).

% distrib_right_numeral
thf(fact_1240_distrib__left__numeral,axiom,
    ! [A: $tType] :
      ( ( ( numeral @ A )
        & ( semiring @ A ) )
     => ! [V: num,B2: A,C2: A] :
          ( ( times_times @ A @ ( numeral_numeral @ A @ V ) @ ( plus_plus @ A @ B2 @ C2 ) )
          = ( plus_plus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ V ) @ B2 ) @ ( times_times @ A @ ( numeral_numeral @ A @ V ) @ C2 ) ) ) ) ).

% distrib_left_numeral
thf(fact_1241_right__diff__distrib__numeral,axiom,
    ! [A: $tType] :
      ( ( ( numeral @ A )
        & ( ring @ A ) )
     => ! [V: num,B2: A,C2: A] :
          ( ( times_times @ A @ ( numeral_numeral @ A @ V ) @ ( minus_minus @ A @ B2 @ C2 ) )
          = ( minus_minus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ V ) @ B2 ) @ ( times_times @ A @ ( numeral_numeral @ A @ V ) @ C2 ) ) ) ) ).

% right_diff_distrib_numeral
thf(fact_1242_left__diff__distrib__numeral,axiom,
    ! [A: $tType] :
      ( ( ( numeral @ A )
        & ( ring @ A ) )
     => ! [A2: A,B2: A,V: num] :
          ( ( times_times @ A @ ( minus_minus @ A @ A2 @ B2 ) @ ( numeral_numeral @ A @ V ) )
          = ( minus_minus @ A @ ( times_times @ A @ A2 @ ( numeral_numeral @ A @ V ) ) @ ( times_times @ A @ B2 @ ( numeral_numeral @ A @ V ) ) ) ) ) ).

% left_diff_distrib_numeral
thf(fact_1243_dvd__times__right__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( dvd_dvd @ A @ ( times_times @ A @ B2 @ A2 ) @ ( times_times @ A @ C2 @ A2 ) )
            = ( dvd_dvd @ A @ B2 @ C2 ) ) ) ) ).

% dvd_times_right_cancel_iff
thf(fact_1244_dvd__times__left__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( dvd_dvd @ A @ ( times_times @ A @ A2 @ B2 ) @ ( times_times @ A @ A2 @ C2 ) )
            = ( dvd_dvd @ A @ B2 @ C2 ) ) ) ) ).

% dvd_times_left_cancel_iff
thf(fact_1245_dvd__mult__cancel__right,axiom,
    ! [A: $tType] :
      ( ( idom @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( dvd_dvd @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) )
          = ( ( C2
              = ( zero_zero @ A ) )
            | ( dvd_dvd @ A @ A2 @ B2 ) ) ) ) ).

% dvd_mult_cancel_right
thf(fact_1246_dvd__mult__cancel__left,axiom,
    ! [A: $tType] :
      ( ( idom @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( dvd_dvd @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) )
          = ( ( C2
              = ( zero_zero @ A ) )
            | ( dvd_dvd @ A @ A2 @ B2 ) ) ) ) ).

% dvd_mult_cancel_left
thf(fact_1247_ln__le__cancel__iff,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ Y )
       => ( ( ord_less_eq @ real @ ( ln_ln @ real @ X ) @ ( ln_ln @ real @ Y ) )
          = ( ord_less_eq @ real @ X @ Y ) ) ) ) ).

% ln_le_cancel_iff
thf(fact_1248_of__nat__mult,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [M: nat,N: nat] :
          ( ( semiring_1_of_nat @ A @ ( times_times @ nat @ M @ N ) )
          = ( times_times @ A @ ( semiring_1_of_nat @ A @ M ) @ ( semiring_1_of_nat @ A @ N ) ) ) ) ).

% of_nat_mult
thf(fact_1249_ln__less__zero__iff,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less @ real @ ( ln_ln @ real @ X ) @ ( zero_zero @ real ) )
        = ( ord_less @ real @ X @ ( one_one @ real ) ) ) ) ).

% ln_less_zero_iff
thf(fact_1250_ln__gt__zero__iff,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ ( ln_ln @ real @ X ) )
        = ( ord_less @ real @ ( one_one @ real ) @ X ) ) ) ).

% ln_gt_zero_iff
thf(fact_1251_ln__eq__zero__iff,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( ( ln_ln @ real @ X )
          = ( zero_zero @ real ) )
        = ( X
          = ( one_one @ real ) ) ) ) ).

% ln_eq_zero_iff
thf(fact_1252_nat__mult__less__cancel__disj,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( ord_less @ nat @ ( times_times @ nat @ K @ M ) @ ( times_times @ nat @ K @ N ) )
      = ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
        & ( ord_less @ nat @ M @ N ) ) ) ).

% nat_mult_less_cancel_disj
thf(fact_1253_nat__0__less__mult__iff,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( times_times @ nat @ M @ N ) )
      = ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M )
        & ( ord_less @ nat @ ( zero_zero @ nat ) @ N ) ) ) ).

% nat_0_less_mult_iff
thf(fact_1254_mult__less__cancel2,axiom,
    ! [M: nat,K: nat,N: nat] :
      ( ( ord_less @ nat @ ( times_times @ nat @ M @ K ) @ ( times_times @ nat @ N @ K ) )
      = ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
        & ( ord_less @ nat @ M @ N ) ) ) ).

% mult_less_cancel2
thf(fact_1255_powr__zero__eq__one,axiom,
    ! [A: $tType] :
      ( ( ln @ A )
     => ! [X: A] :
          ( ( ( X
              = ( zero_zero @ A ) )
           => ( ( powr @ A @ X @ ( zero_zero @ A ) )
              = ( zero_zero @ A ) ) )
          & ( ( X
             != ( zero_zero @ A ) )
           => ( ( powr @ A @ X @ ( zero_zero @ A ) )
              = ( one_one @ A ) ) ) ) ) ).

% powr_zero_eq_one
thf(fact_1256_ln__one,axiom,
    ! [A: $tType] :
      ( ( ln @ A )
     => ( ( ln_ln @ A @ ( one_one @ A ) )
        = ( zero_zero @ A ) ) ) ).

% ln_one
thf(fact_1257_nat__mult__div__cancel__disj,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( ( K
          = ( zero_zero @ nat ) )
       => ( ( divide_divide @ nat @ ( times_times @ nat @ K @ M ) @ ( times_times @ nat @ K @ N ) )
          = ( zero_zero @ nat ) ) )
      & ( ( K
         != ( zero_zero @ nat ) )
       => ( ( divide_divide @ nat @ ( times_times @ nat @ K @ M ) @ ( times_times @ nat @ K @ N ) )
          = ( divide_divide @ nat @ M @ N ) ) ) ) ).

% nat_mult_div_cancel_disj
thf(fact_1258_nat__mult__dvd__cancel__disj,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( dvd_dvd @ nat @ ( times_times @ nat @ K @ M ) @ ( times_times @ nat @ K @ N ) )
      = ( ( K
          = ( zero_zero @ nat ) )
        | ( dvd_dvd @ nat @ M @ N ) ) ) ).

% nat_mult_dvd_cancel_disj
thf(fact_1259_zdiv__numeral__Bit0,axiom,
    ! [V: num,W: num] :
      ( ( divide_divide @ int @ ( numeral_numeral @ int @ ( bit0 @ V ) ) @ ( numeral_numeral @ int @ ( bit0 @ W ) ) )
      = ( divide_divide @ int @ ( numeral_numeral @ int @ V ) @ ( numeral_numeral @ int @ W ) ) ) ).

% zdiv_numeral_Bit0
thf(fact_1260_powr__gt__zero,axiom,
    ! [X: real,A2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ ( powr @ real @ X @ A2 ) )
      = ( ( X
         != ( zero_zero @ real ) ) ) ) ).

% powr_gt_zero
thf(fact_1261_powr__nonneg__iff,axiom,
    ! [A2: real,X: real] :
      ( ( ord_less_eq @ real @ ( powr @ real @ A2 @ X ) @ ( zero_zero @ real ) )
      = ( A2
        = ( zero_zero @ real ) ) ) ).

% powr_nonneg_iff
thf(fact_1262_powr__less__cancel__iff,axiom,
    ! [X: real,A2: real,B2: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ X )
     => ( ( ord_less @ real @ ( powr @ real @ X @ A2 ) @ ( powr @ real @ X @ B2 ) )
        = ( ord_less @ real @ A2 @ B2 ) ) ) ).

% powr_less_cancel_iff
thf(fact_1263_round__0,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ( ( archimedean_round @ A @ ( zero_zero @ A ) )
        = ( zero_zero @ int ) ) ) ).

% round_0
thf(fact_1264_round__numeral,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [N: num] :
          ( ( archimedean_round @ A @ ( numeral_numeral @ A @ N ) )
          = ( numeral_numeral @ int @ N ) ) ) ).

% round_numeral
thf(fact_1265_round__1,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ( ( archimedean_round @ A @ ( one_one @ A ) )
        = ( one_one @ int ) ) ) ).

% round_1
thf(fact_1266_round__of__nat,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [N: nat] :
          ( ( archimedean_round @ A @ ( semiring_1_of_nat @ A @ N ) )
          = ( semiring_1_of_nat @ int @ N ) ) ) ).

% round_of_nat
thf(fact_1267_divide__le__eq__numeral1_I1_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,W: num,A2: A] :
          ( ( ord_less_eq @ A @ ( divide_divide @ A @ B2 @ ( numeral_numeral @ A @ W ) ) @ A2 )
          = ( ord_less_eq @ A @ B2 @ ( times_times @ A @ A2 @ ( numeral_numeral @ A @ W ) ) ) ) ) ).

% divide_le_eq_numeral1(1)
thf(fact_1268_le__divide__eq__numeral1_I1_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A,W: num] :
          ( ( ord_less_eq @ A @ A2 @ ( divide_divide @ A @ B2 @ ( numeral_numeral @ A @ W ) ) )
          = ( ord_less_eq @ A @ ( times_times @ A @ A2 @ ( numeral_numeral @ A @ W ) ) @ B2 ) ) ) ).

% le_divide_eq_numeral1(1)
thf(fact_1269_divide__eq__eq__numeral1_I1_J,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [B2: A,W: num,A2: A] :
          ( ( ( divide_divide @ A @ B2 @ ( numeral_numeral @ A @ W ) )
            = A2 )
          = ( ( ( ( numeral_numeral @ A @ W )
               != ( zero_zero @ A ) )
             => ( B2
                = ( times_times @ A @ A2 @ ( numeral_numeral @ A @ W ) ) ) )
            & ( ( ( numeral_numeral @ A @ W )
                = ( zero_zero @ A ) )
             => ( A2
                = ( zero_zero @ A ) ) ) ) ) ) ).

% divide_eq_eq_numeral1(1)
thf(fact_1270_eq__divide__eq__numeral1_I1_J,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A,B2: A,W: num] :
          ( ( A2
            = ( divide_divide @ A @ B2 @ ( numeral_numeral @ A @ W ) ) )
          = ( ( ( ( numeral_numeral @ A @ W )
               != ( zero_zero @ A ) )
             => ( ( times_times @ A @ A2 @ ( numeral_numeral @ A @ W ) )
                = B2 ) )
            & ( ( ( numeral_numeral @ A @ W )
                = ( zero_zero @ A ) )
             => ( A2
                = ( zero_zero @ A ) ) ) ) ) ) ).

% eq_divide_eq_numeral1(1)
thf(fact_1271_divide__less__eq__numeral1_I1_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,W: num,A2: A] :
          ( ( ord_less @ A @ ( divide_divide @ A @ B2 @ ( numeral_numeral @ A @ W ) ) @ A2 )
          = ( ord_less @ A @ B2 @ ( times_times @ A @ A2 @ ( numeral_numeral @ A @ W ) ) ) ) ) ).

% divide_less_eq_numeral1(1)
thf(fact_1272_less__divide__eq__numeral1_I1_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A,W: num] :
          ( ( ord_less @ A @ A2 @ ( divide_divide @ A @ B2 @ ( numeral_numeral @ A @ W ) ) )
          = ( ord_less @ A @ ( times_times @ A @ A2 @ ( numeral_numeral @ A @ W ) ) @ B2 ) ) ) ).

% less_divide_eq_numeral1(1)
thf(fact_1273_nonzero__divide__mult__cancel__right,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [B2: A,A2: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ B2 @ ( times_times @ A @ A2 @ B2 ) )
            = ( divide_divide @ A @ ( one_one @ A ) @ A2 ) ) ) ) ).

% nonzero_divide_mult_cancel_right
thf(fact_1274_nonzero__divide__mult__cancel__left,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A2: A,B2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ A2 @ ( times_times @ A @ A2 @ B2 ) )
            = ( divide_divide @ A @ ( one_one @ A ) @ B2 ) ) ) ) ).

% nonzero_divide_mult_cancel_left
thf(fact_1275_div__mult__self4,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ ( plus_plus @ A @ ( times_times @ A @ B2 @ C2 ) @ A2 ) @ B2 )
            = ( plus_plus @ A @ C2 @ ( divide_divide @ A @ A2 @ B2 ) ) ) ) ) ).

% div_mult_self4
thf(fact_1276_div__mult__self3,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ ( plus_plus @ A @ ( times_times @ A @ C2 @ B2 ) @ A2 ) @ B2 )
            = ( plus_plus @ A @ C2 @ ( divide_divide @ A @ A2 @ B2 ) ) ) ) ) ).

% div_mult_self3
thf(fact_1277_div__mult__self2,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ ( plus_plus @ A @ A2 @ ( times_times @ A @ B2 @ C2 ) ) @ B2 )
            = ( plus_plus @ A @ C2 @ ( divide_divide @ A @ A2 @ B2 ) ) ) ) ) ).

% div_mult_self2
thf(fact_1278_div__mult__self1,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ ( plus_plus @ A @ A2 @ ( times_times @ A @ C2 @ B2 ) ) @ B2 )
            = ( plus_plus @ A @ C2 @ ( divide_divide @ A @ A2 @ B2 ) ) ) ) ) ).

% div_mult_self1
thf(fact_1279_ln__le__zero__iff,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less_eq @ real @ ( ln_ln @ real @ X ) @ ( zero_zero @ real ) )
        = ( ord_less_eq @ real @ X @ ( one_one @ real ) ) ) ) ).

% ln_le_zero_iff
thf(fact_1280_ln__ge__zero__iff,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( ln_ln @ real @ X ) )
        = ( ord_less_eq @ real @ ( one_one @ real ) @ X ) ) ) ).

% ln_ge_zero_iff
thf(fact_1281_nat__mult__le__cancel__disj,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ ( times_times @ nat @ K @ M ) @ ( times_times @ nat @ K @ N ) )
      = ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
       => ( ord_less_eq @ nat @ M @ N ) ) ) ).

% nat_mult_le_cancel_disj
thf(fact_1282_mult__le__cancel2,axiom,
    ! [M: nat,K: nat,N: nat] :
      ( ( ord_less_eq @ nat @ ( times_times @ nat @ M @ K ) @ ( times_times @ nat @ N @ K ) )
      = ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
       => ( ord_less_eq @ nat @ M @ N ) ) ) ).

% mult_le_cancel2
thf(fact_1283_div__mult__self1__is__m,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( divide_divide @ nat @ ( times_times @ nat @ N @ M ) @ N )
        = M ) ) ).

% div_mult_self1_is_m
thf(fact_1284_div__mult__self__is__m,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( divide_divide @ nat @ ( times_times @ nat @ M @ N ) @ N )
        = M ) ) ).

% div_mult_self_is_m
thf(fact_1285_power__add__numeral,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [A2: A,M: num,N: num] :
          ( ( times_times @ A @ ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ M ) ) @ ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ N ) ) )
          = ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ ( plus_plus @ num @ M @ N ) ) ) ) ) ).

% power_add_numeral
thf(fact_1286_power__add__numeral2,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [A2: A,M: num,N: num,B2: A] :
          ( ( times_times @ A @ ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ M ) ) @ ( times_times @ A @ ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ N ) ) @ B2 ) )
          = ( times_times @ A @ ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ ( plus_plus @ num @ M @ N ) ) ) @ B2 ) ) ) ).

% power_add_numeral2
thf(fact_1287_powr__eq__one__iff,axiom,
    ! [A2: real,X: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ A2 )
     => ( ( ( powr @ real @ A2 @ X )
          = ( one_one @ real ) )
        = ( X
          = ( zero_zero @ real ) ) ) ) ).

% powr_eq_one_iff
thf(fact_1288_powr__one__gt__zero__iff,axiom,
    ! [X: real] :
      ( ( ( powr @ real @ X @ ( one_one @ real ) )
        = X )
      = ( ord_less_eq @ real @ ( zero_zero @ real ) @ X ) ) ).

% powr_one_gt_zero_iff
thf(fact_1289_powr__one,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( powr @ real @ X @ ( one_one @ real ) )
        = X ) ) ).

% powr_one
thf(fact_1290_powr__le__cancel__iff,axiom,
    ! [X: real,A2: real,B2: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ X )
     => ( ( ord_less_eq @ real @ ( powr @ real @ X @ A2 ) @ ( powr @ real @ X @ B2 ) )
        = ( ord_less_eq @ real @ A2 @ B2 ) ) ) ).

% powr_le_cancel_iff
thf(fact_1291_div__pos__pos__trivial,axiom,
    ! [K: int,L: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ K )
     => ( ( ord_less @ int @ K @ L )
       => ( ( divide_divide @ int @ K @ L )
          = ( zero_zero @ int ) ) ) ) ).

% div_pos_pos_trivial
thf(fact_1292_div__neg__neg__trivial,axiom,
    ! [K: int,L: int] :
      ( ( ord_less_eq @ int @ K @ ( zero_zero @ int ) )
     => ( ( ord_less @ int @ L @ K )
       => ( ( divide_divide @ int @ K @ L )
          = ( zero_zero @ int ) ) ) ) ).

% div_neg_neg_trivial
thf(fact_1293_numeral__powr__numeral__real,axiom,
    ! [M: num,N: num] :
      ( ( powr @ real @ ( numeral_numeral @ real @ M ) @ ( numeral_numeral @ real @ N ) )
      = ( power_power @ real @ ( numeral_numeral @ real @ M ) @ ( numeral_numeral @ nat @ N ) ) ) ).

% numeral_powr_numeral_real
thf(fact_1294_floor__divide__eq__div__numeral,axiom,
    ! [A2: num,B2: num] :
      ( ( archim6421214686448440834_floor @ real @ ( divide_divide @ real @ ( numeral_numeral @ real @ A2 ) @ ( numeral_numeral @ real @ B2 ) ) )
      = ( divide_divide @ int @ ( numeral_numeral @ int @ A2 ) @ ( numeral_numeral @ int @ B2 ) ) ) ).

% floor_divide_eq_div_numeral
thf(fact_1295_even__mult__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [A2: A,B2: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( times_times @ A @ A2 @ B2 ) )
          = ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
            | ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B2 ) ) ) ) ).

% even_mult_iff
thf(fact_1296_or__numerals_I3_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X: num,Y: num] :
          ( ( bit_se1065995026697491101ons_or @ A @ ( numeral_numeral @ A @ ( bit0 @ X ) ) @ ( numeral_numeral @ A @ ( bit0 @ Y ) ) )
          = ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se1065995026697491101ons_or @ A @ ( numeral_numeral @ A @ X ) @ ( numeral_numeral @ A @ Y ) ) ) ) ) ).

% or_numerals(3)
thf(fact_1297_xor__numerals_I3_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X: num,Y: num] :
          ( ( bit_se5824344971392196577ns_xor @ A @ ( numeral_numeral @ A @ ( bit0 @ X ) ) @ ( numeral_numeral @ A @ ( bit0 @ Y ) ) )
          = ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se5824344971392196577ns_xor @ A @ ( numeral_numeral @ A @ X ) @ ( numeral_numeral @ A @ Y ) ) ) ) ) ).

% xor_numerals(3)
thf(fact_1298_log__powr__cancel,axiom,
    ! [A2: real,Y: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
     => ( ( A2
         != ( one_one @ real ) )
       => ( ( log2 @ A2 @ ( powr @ real @ A2 @ Y ) )
          = Y ) ) ) ).

% log_powr_cancel
thf(fact_1299_powr__log__cancel,axiom,
    ! [A2: real,X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
     => ( ( A2
         != ( one_one @ real ) )
       => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
         => ( ( powr @ real @ A2 @ ( log2 @ A2 @ X ) )
            = X ) ) ) ) ).

% powr_log_cancel
thf(fact_1300_half__nonnegative__int__iff,axiom,
    ! [K: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( divide_divide @ int @ K @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) )
      = ( ord_less_eq @ int @ ( zero_zero @ int ) @ K ) ) ).

% half_nonnegative_int_iff
thf(fact_1301_half__negative__int__iff,axiom,
    ! [K: int] :
      ( ( ord_less @ int @ ( divide_divide @ int @ K @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( zero_zero @ int ) )
      = ( ord_less @ int @ K @ ( zero_zero @ int ) ) ) ).

% half_negative_int_iff
thf(fact_1302_powr__numeral,axiom,
    ! [X: real,N: num] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( powr @ real @ X @ ( numeral_numeral @ real @ N ) )
        = ( power_power @ real @ X @ ( numeral_numeral @ nat @ N ) ) ) ) ).

% powr_numeral
thf(fact_1303_floor__one__divide__eq__div__numeral,axiom,
    ! [B2: num] :
      ( ( archim6421214686448440834_floor @ real @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ B2 ) ) )
      = ( divide_divide @ int @ ( one_one @ int ) @ ( numeral_numeral @ int @ B2 ) ) ) ).

% floor_one_divide_eq_div_numeral
thf(fact_1304_odd__two__times__div__two__succ,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [A2: A] :
          ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
         => ( ( plus_plus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) @ ( one_one @ A ) )
            = A2 ) ) ) ).

% odd_two_times_div_two_succ
thf(fact_1305_odd__two__times__div__two__nat,axiom,
    ! [N: nat] :
      ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
     => ( ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( divide_divide @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
        = ( minus_minus @ nat @ N @ ( one_one @ nat ) ) ) ) ).

% odd_two_times_div_two_nat
thf(fact_1306_ab__semigroup__mult__class_Omult__ac_I1_J,axiom,
    ! [A: $tType] :
      ( ( ab_semigroup_mult @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( times_times @ A @ ( times_times @ A @ A2 @ B2 ) @ C2 )
          = ( times_times @ A @ A2 @ ( times_times @ A @ B2 @ C2 ) ) ) ) ).

% ab_semigroup_mult_class.mult_ac(1)
thf(fact_1307_mult_Oassoc,axiom,
    ! [A: $tType] :
      ( ( semigroup_mult @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( times_times @ A @ ( times_times @ A @ A2 @ B2 ) @ C2 )
          = ( times_times @ A @ A2 @ ( times_times @ A @ B2 @ C2 ) ) ) ) ).

% mult.assoc
thf(fact_1308_mult_Ocommute,axiom,
    ! [A: $tType] :
      ( ( ab_semigroup_mult @ A )
     => ( ( times_times @ A )
        = ( ^ [A3: A,B3: A] : ( times_times @ A @ B3 @ A3 ) ) ) ) ).

% mult.commute
thf(fact_1309_mult_Oleft__commute,axiom,
    ! [A: $tType] :
      ( ( ab_semigroup_mult @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( times_times @ A @ B2 @ ( times_times @ A @ A2 @ C2 ) )
          = ( times_times @ A @ A2 @ ( times_times @ A @ B2 @ C2 ) ) ) ) ).

% mult.left_commute
thf(fact_1310_ln__div,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ Y )
       => ( ( ln_ln @ real @ ( divide_divide @ real @ X @ Y ) )
          = ( minus_minus @ real @ ( ln_ln @ real @ X ) @ ( ln_ln @ real @ Y ) ) ) ) ) ).

% ln_div
thf(fact_1311_powr__divide,axiom,
    ! [X: real,Y: real,A2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y )
       => ( ( powr @ real @ ( divide_divide @ real @ X @ Y ) @ A2 )
          = ( divide_divide @ real @ ( powr @ real @ X @ A2 ) @ ( powr @ real @ Y @ A2 ) ) ) ) ) ).

% powr_divide
thf(fact_1312_log__base__powr,axiom,
    ! [A2: real,B2: real,X: real] :
      ( ( A2
       != ( zero_zero @ real ) )
     => ( ( log2 @ ( powr @ real @ A2 @ B2 ) @ X )
        = ( divide_divide @ real @ ( log2 @ A2 @ X ) @ B2 ) ) ) ).

% log_base_powr
thf(fact_1313_real__of__int__div4,axiom,
    ! [N: int,X: int] : ( ord_less_eq @ real @ ( ring_1_of_int @ real @ ( divide_divide @ int @ N @ X ) ) @ ( divide_divide @ real @ ( ring_1_of_int @ real @ N ) @ ( ring_1_of_int @ real @ X ) ) ) ).

% real_of_int_div4
thf(fact_1314_real__of__int__div,axiom,
    ! [D2: int,N: int] :
      ( ( dvd_dvd @ int @ D2 @ N )
     => ( ( ring_1_of_int @ real @ ( divide_divide @ int @ N @ D2 ) )
        = ( divide_divide @ real @ ( ring_1_of_int @ real @ N ) @ ( ring_1_of_int @ real @ D2 ) ) ) ) ).

% real_of_int_div
thf(fact_1315_mult__right__cancel,axiom,
    ! [A: $tType] :
      ( ( semiri6575147826004484403cancel @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( ( times_times @ A @ A2 @ C2 )
              = ( times_times @ A @ B2 @ C2 ) )
            = ( A2 = B2 ) ) ) ) ).

% mult_right_cancel
thf(fact_1316_mult__left__cancel,axiom,
    ! [A: $tType] :
      ( ( semiri6575147826004484403cancel @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( ( times_times @ A @ C2 @ A2 )
              = ( times_times @ A @ C2 @ B2 ) )
            = ( A2 = B2 ) ) ) ) ).

% mult_left_cancel
thf(fact_1317_no__zero__divisors,axiom,
    ! [A: $tType] :
      ( ( semiri3467727345109120633visors @ A )
     => ! [A2: A,B2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( B2
             != ( zero_zero @ A ) )
           => ( ( times_times @ A @ A2 @ B2 )
             != ( zero_zero @ A ) ) ) ) ) ).

% no_zero_divisors
thf(fact_1318_divisors__zero,axiom,
    ! [A: $tType] :
      ( ( semiri3467727345109120633visors @ A )
     => ! [A2: A,B2: A] :
          ( ( ( times_times @ A @ A2 @ B2 )
            = ( zero_zero @ A ) )
         => ( ( A2
              = ( zero_zero @ A ) )
            | ( B2
              = ( zero_zero @ A ) ) ) ) ) ).

% divisors_zero
thf(fact_1319_mult__not__zero,axiom,
    ! [A: $tType] :
      ( ( mult_zero @ A )
     => ! [A2: A,B2: A] :
          ( ( ( times_times @ A @ A2 @ B2 )
           != ( zero_zero @ A ) )
         => ( ( A2
             != ( zero_zero @ A ) )
            & ( B2
             != ( zero_zero @ A ) ) ) ) ) ).

% mult_not_zero
thf(fact_1320_ln__powr__bound,axiom,
    ! [X: real,A2: real] :
      ( ( ord_less_eq @ real @ ( one_one @ real ) @ X )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
       => ( ord_less_eq @ real @ ( ln_ln @ real @ X ) @ ( divide_divide @ real @ ( powr @ real @ X @ A2 ) @ A2 ) ) ) ) ).

% ln_powr_bound
thf(fact_1321_comm__monoid__mult__class_Omult__1,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A2: A] :
          ( ( times_times @ A @ ( one_one @ A ) @ A2 )
          = A2 ) ) ).

% comm_monoid_mult_class.mult_1
thf(fact_1322_mult_Ocomm__neutral,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A2: A] :
          ( ( times_times @ A @ A2 @ ( one_one @ A ) )
          = A2 ) ) ).

% mult.comm_neutral
thf(fact_1323_inf__period_I2_J,axiom,
    ! [A: $tType] :
      ( ( ( comm_ring @ A )
        & ( dvd @ A ) )
     => ! [P: A > $o,D5: A,Q: A > $o] :
          ( ! [X3: A,K2: A] :
              ( ( P @ X3 )
              = ( P @ ( minus_minus @ A @ X3 @ ( times_times @ A @ K2 @ D5 ) ) ) )
         => ( ! [X3: A,K2: A] :
                ( ( Q @ X3 )
                = ( Q @ ( minus_minus @ A @ X3 @ ( times_times @ A @ K2 @ D5 ) ) ) )
           => ! [X5: A,K4: A] :
                ( ( ( P @ X5 )
                  | ( Q @ X5 ) )
                = ( ( P @ ( minus_minus @ A @ X5 @ ( times_times @ A @ K4 @ D5 ) ) )
                  | ( Q @ ( minus_minus @ A @ X5 @ ( times_times @ A @ K4 @ D5 ) ) ) ) ) ) ) ) ).

% inf_period(2)
thf(fact_1324_inf__period_I1_J,axiom,
    ! [A: $tType] :
      ( ( ( comm_ring @ A )
        & ( dvd @ A ) )
     => ! [P: A > $o,D5: A,Q: A > $o] :
          ( ! [X3: A,K2: A] :
              ( ( P @ X3 )
              = ( P @ ( minus_minus @ A @ X3 @ ( times_times @ A @ K2 @ D5 ) ) ) )
         => ( ! [X3: A,K2: A] :
                ( ( Q @ X3 )
                = ( Q @ ( minus_minus @ A @ X3 @ ( times_times @ A @ K2 @ D5 ) ) ) )
           => ! [X5: A,K4: A] :
                ( ( ( P @ X5 )
                  & ( Q @ X5 ) )
                = ( ( P @ ( minus_minus @ A @ X5 @ ( times_times @ A @ K4 @ D5 ) ) )
                  & ( Q @ ( minus_minus @ A @ X5 @ ( times_times @ A @ K4 @ D5 ) ) ) ) ) ) ) ) ).

% inf_period(1)
thf(fact_1325_power__commutes,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [A2: A,N: nat] :
          ( ( times_times @ A @ ( power_power @ A @ A2 @ N ) @ A2 )
          = ( times_times @ A @ A2 @ ( power_power @ A @ A2 @ N ) ) ) ) ).

% power_commutes
thf(fact_1326_power__mult__distrib,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A2: A,B2: A,N: nat] :
          ( ( power_power @ A @ ( times_times @ A @ A2 @ B2 ) @ N )
          = ( times_times @ A @ ( power_power @ A @ A2 @ N ) @ ( power_power @ A @ B2 @ N ) ) ) ) ).

% power_mult_distrib
thf(fact_1327_power__commuting__commutes,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [X: A,Y: A,N: nat] :
          ( ( ( times_times @ A @ X @ Y )
            = ( times_times @ A @ Y @ X ) )
         => ( ( times_times @ A @ ( power_power @ A @ X @ N ) @ Y )
            = ( times_times @ A @ Y @ ( power_power @ A @ X @ N ) ) ) ) ) ).

% power_commuting_commutes
thf(fact_1328_power__mult,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [A2: A,M: nat,N: nat] :
          ( ( power_power @ A @ A2 @ ( times_times @ nat @ M @ N ) )
          = ( power_power @ A @ ( power_power @ A @ A2 @ M ) @ N ) ) ) ).

% power_mult
thf(fact_1329_nat__mult__eq__cancel__disj,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( ( times_times @ nat @ K @ M )
        = ( times_times @ nat @ K @ N ) )
      = ( ( K
          = ( zero_zero @ nat ) )
        | ( M = N ) ) ) ).

% nat_mult_eq_cancel_disj
thf(fact_1330_mult__0,axiom,
    ! [N: nat] :
      ( ( times_times @ nat @ ( zero_zero @ nat ) @ N )
      = ( zero_zero @ nat ) ) ).

% mult_0
thf(fact_1331_mult__of__nat__commute,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [X: nat,Y: A] :
          ( ( times_times @ A @ ( semiring_1_of_nat @ A @ X ) @ Y )
          = ( times_times @ A @ Y @ ( semiring_1_of_nat @ A @ X ) ) ) ) ).

% mult_of_nat_commute
thf(fact_1332_le__cube,axiom,
    ! [M: nat] : ( ord_less_eq @ nat @ M @ ( times_times @ nat @ M @ ( times_times @ nat @ M @ M ) ) ) ).

% le_cube
thf(fact_1333_le__square,axiom,
    ! [M: nat] : ( ord_less_eq @ nat @ M @ ( times_times @ nat @ M @ M ) ) ).

% le_square
thf(fact_1334_mult__le__mono,axiom,
    ! [I: nat,J: nat,K: nat,L: nat] :
      ( ( ord_less_eq @ nat @ I @ J )
     => ( ( ord_less_eq @ nat @ K @ L )
       => ( ord_less_eq @ nat @ ( times_times @ nat @ I @ K ) @ ( times_times @ nat @ J @ L ) ) ) ) ).

% mult_le_mono
thf(fact_1335_mult__le__mono1,axiom,
    ! [I: nat,J: nat,K: nat] :
      ( ( ord_less_eq @ nat @ I @ J )
     => ( ord_less_eq @ nat @ ( times_times @ nat @ I @ K ) @ ( times_times @ nat @ J @ K ) ) ) ).

% mult_le_mono1
thf(fact_1336_mult__le__mono2,axiom,
    ! [I: nat,J: nat,K: nat] :
      ( ( ord_less_eq @ nat @ I @ J )
     => ( ord_less_eq @ nat @ ( times_times @ nat @ K @ I ) @ ( times_times @ nat @ K @ J ) ) ) ).

% mult_le_mono2
thf(fact_1337_left__add__mult__distrib,axiom,
    ! [I: nat,U: nat,J: nat,K: nat] :
      ( ( plus_plus @ nat @ ( times_times @ nat @ I @ U ) @ ( plus_plus @ nat @ ( times_times @ nat @ J @ U ) @ K ) )
      = ( plus_plus @ nat @ ( times_times @ nat @ ( plus_plus @ nat @ I @ J ) @ U ) @ K ) ) ).

% left_add_mult_distrib
thf(fact_1338_add__mult__distrib2,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( times_times @ nat @ K @ ( plus_plus @ nat @ M @ N ) )
      = ( plus_plus @ nat @ ( times_times @ nat @ K @ M ) @ ( times_times @ nat @ K @ N ) ) ) ).

% add_mult_distrib2
thf(fact_1339_add__mult__distrib,axiom,
    ! [M: nat,N: nat,K: nat] :
      ( ( times_times @ nat @ ( plus_plus @ nat @ M @ N ) @ K )
      = ( plus_plus @ nat @ ( times_times @ nat @ M @ K ) @ ( times_times @ nat @ N @ K ) ) ) ).

% add_mult_distrib
thf(fact_1340_diff__mult__distrib2,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( times_times @ nat @ K @ ( minus_minus @ nat @ M @ N ) )
      = ( minus_minus @ nat @ ( times_times @ nat @ K @ M ) @ ( times_times @ nat @ K @ N ) ) ) ).

% diff_mult_distrib2
thf(fact_1341_diff__mult__distrib,axiom,
    ! [M: nat,N: nat,K: nat] :
      ( ( times_times @ nat @ ( minus_minus @ nat @ M @ N ) @ K )
      = ( minus_minus @ nat @ ( times_times @ nat @ M @ K ) @ ( times_times @ nat @ N @ K ) ) ) ).

% diff_mult_distrib
thf(fact_1342_mult__of__int__commute,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [X: int,Y: A] :
          ( ( times_times @ A @ ( ring_1_of_int @ A @ X ) @ Y )
          = ( times_times @ A @ Y @ ( ring_1_of_int @ A @ X ) ) ) ) ).

% mult_of_int_commute
thf(fact_1343_nat__mult__1__right,axiom,
    ! [N: nat] :
      ( ( times_times @ nat @ N @ ( one_one @ nat ) )
      = N ) ).

% nat_mult_1_right
thf(fact_1344_nat__mult__1,axiom,
    ! [N: nat] :
      ( ( times_times @ nat @ ( one_one @ nat ) @ N )
      = N ) ).

% nat_mult_1
thf(fact_1345_real__sqrt__divide,axiom,
    ! [X: real,Y: real] :
      ( ( sqrt @ ( divide_divide @ real @ X @ Y ) )
      = ( divide_divide @ real @ ( sqrt @ X ) @ ( sqrt @ Y ) ) ) ).

% real_sqrt_divide
thf(fact_1346_nat__mult__max__left,axiom,
    ! [M: nat,N: nat,Q3: nat] :
      ( ( times_times @ nat @ ( ord_max @ nat @ M @ N ) @ Q3 )
      = ( ord_max @ nat @ ( times_times @ nat @ M @ Q3 ) @ ( times_times @ nat @ N @ Q3 ) ) ) ).

% nat_mult_max_left
thf(fact_1347_nat__mult__max__right,axiom,
    ! [M: nat,N: nat,Q3: nat] :
      ( ( times_times @ nat @ M @ ( ord_max @ nat @ N @ Q3 ) )
      = ( ord_max @ nat @ ( times_times @ nat @ M @ N ) @ ( times_times @ nat @ M @ Q3 ) ) ) ).

% nat_mult_max_right
thf(fact_1348_ln__diff__le,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ Y )
       => ( ord_less_eq @ real @ ( minus_minus @ real @ ( ln_ln @ real @ X ) @ ( ln_ln @ real @ Y ) ) @ ( divide_divide @ real @ ( minus_minus @ real @ X @ Y ) @ Y ) ) ) ) ).

% ln_diff_le
thf(fact_1349_real__of__int__div2,axiom,
    ! [N: int,X: int] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( minus_minus @ real @ ( divide_divide @ real @ ( ring_1_of_int @ real @ N ) @ ( ring_1_of_int @ real @ X ) ) @ ( ring_1_of_int @ real @ ( divide_divide @ int @ N @ X ) ) ) ) ).

% real_of_int_div2
thf(fact_1350_real__of__int__div3,axiom,
    ! [N: int,X: int] : ( ord_less_eq @ real @ ( minus_minus @ real @ ( divide_divide @ real @ ( ring_1_of_int @ real @ N ) @ ( ring_1_of_int @ real @ X ) ) @ ( ring_1_of_int @ real @ ( divide_divide @ int @ N @ X ) ) ) @ ( one_one @ real ) ) ).

% real_of_int_div3
thf(fact_1351_le__mult__nat__floor,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [A2: A,B2: A] : ( ord_less_eq @ nat @ ( times_times @ nat @ ( nat2 @ ( archim6421214686448440834_floor @ A @ A2 ) ) @ ( nat2 @ ( archim6421214686448440834_floor @ A @ B2 ) ) ) @ ( nat2 @ ( archim6421214686448440834_floor @ A @ ( times_times @ A @ A2 @ B2 ) ) ) ) ) ).

% le_mult_nat_floor
thf(fact_1352_ln__less__self,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ord_less @ real @ ( ln_ln @ real @ X ) @ X ) ) ).

% ln_less_self
thf(fact_1353_minus__log__eq__powr,axiom,
    ! [B2: real,X: real,Y: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ B2 )
     => ( ( B2
         != ( one_one @ real ) )
       => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
         => ( ( minus_minus @ real @ Y @ ( log2 @ B2 @ X ) )
            = ( log2 @ B2 @ ( divide_divide @ real @ ( powr @ real @ B2 @ Y ) @ X ) ) ) ) ) ) ).

% minus_log_eq_powr
thf(fact_1354_powr__non__neg,axiom,
    ! [A2: real,X: real] :
      ~ ( ord_less @ real @ ( powr @ real @ A2 @ X ) @ ( zero_zero @ real ) ) ).

% powr_non_neg
thf(fact_1355_powr__less__mono2__neg,axiom,
    ! [A2: real,X: real,Y: real] :
      ( ( ord_less @ real @ A2 @ ( zero_zero @ real ) )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
       => ( ( ord_less @ real @ X @ Y )
         => ( ord_less @ real @ ( powr @ real @ Y @ A2 ) @ ( powr @ real @ X @ A2 ) ) ) ) ) ).

% powr_less_mono2_neg
thf(fact_1356_powr__mono2,axiom,
    ! [A2: real,X: real,Y: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ A2 )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
       => ( ( ord_less_eq @ real @ X @ Y )
         => ( ord_less_eq @ real @ ( powr @ real @ X @ A2 ) @ ( powr @ real @ Y @ A2 ) ) ) ) ) ).

% powr_mono2
thf(fact_1357_powr__ge__pzero,axiom,
    ! [X: real,Y: real] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( powr @ real @ X @ Y ) ) ).

% powr_ge_pzero
thf(fact_1358_powr__less__cancel,axiom,
    ! [X: real,A2: real,B2: real] :
      ( ( ord_less @ real @ ( powr @ real @ X @ A2 ) @ ( powr @ real @ X @ B2 ) )
     => ( ( ord_less @ real @ ( one_one @ real ) @ X )
       => ( ord_less @ real @ A2 @ B2 ) ) ) ).

% powr_less_cancel
thf(fact_1359_powr__less__mono,axiom,
    ! [A2: real,B2: real,X: real] :
      ( ( ord_less @ real @ A2 @ B2 )
     => ( ( ord_less @ real @ ( one_one @ real ) @ X )
       => ( ord_less @ real @ ( powr @ real @ X @ A2 ) @ ( powr @ real @ X @ B2 ) ) ) ) ).

% powr_less_mono
thf(fact_1360_powr__mono,axiom,
    ! [A2: real,B2: real,X: real] :
      ( ( ord_less_eq @ real @ A2 @ B2 )
     => ( ( ord_less_eq @ real @ ( one_one @ real ) @ X )
       => ( ord_less_eq @ real @ ( powr @ real @ X @ A2 ) @ ( powr @ real @ X @ B2 ) ) ) ) ).

% powr_mono
thf(fact_1361_le__mult__floor,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 )
           => ( ord_less_eq @ int @ ( times_times @ int @ ( archim6421214686448440834_floor @ A @ A2 ) @ ( archim6421214686448440834_floor @ A @ B2 ) ) @ ( archim6421214686448440834_floor @ A @ ( times_times @ A @ A2 @ B2 ) ) ) ) ) ) ).

% le_mult_floor
thf(fact_1362_mult__ceiling__le,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 )
           => ( ord_less_eq @ int @ ( archimedean_ceiling @ A @ ( times_times @ A @ A2 @ B2 ) ) @ ( times_times @ int @ ( archimedean_ceiling @ A @ A2 ) @ ( archimedean_ceiling @ A @ B2 ) ) ) ) ) ) ).

% mult_ceiling_le
thf(fact_1363_mult__mono,axiom,
    ! [A: $tType] :
      ( ( ordered_semiring @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ C2 @ D2 )
           => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 )
             => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
               => ( ord_less_eq @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ D2 ) ) ) ) ) ) ) ).

% mult_mono
thf(fact_1364_mult__mono_H,axiom,
    ! [A: $tType] :
      ( ( ordered_semiring @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ C2 @ D2 )
           => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
             => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
               => ( ord_less_eq @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ D2 ) ) ) ) ) ) ) ).

% mult_mono'
thf(fact_1365_zero__le__square,axiom,
    ! [A: $tType] :
      ( ( linordered_ring @ A )
     => ! [A2: A] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A2 @ A2 ) ) ) ).

% zero_le_square
thf(fact_1366_split__mult__pos__le,axiom,
    ! [A: $tType] :
      ( ( ordered_ring @ A )
     => ! [A2: A,B2: A] :
          ( ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
              & ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 ) )
            | ( ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) )
              & ( ord_less_eq @ A @ B2 @ ( zero_zero @ A ) ) ) )
         => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A2 @ B2 ) ) ) ) ).

% split_mult_pos_le
thf(fact_1367_mult__left__mono__neg,axiom,
    ! [A: $tType] :
      ( ( ordered_ring @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( ord_less_eq @ A @ B2 @ A2 )
         => ( ( ord_less_eq @ A @ C2 @ ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) ) ) ) ) ).

% mult_left_mono_neg
thf(fact_1368_mult__nonpos__nonpos,axiom,
    ! [A: $tType] :
      ( ( ordered_ring @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ B2 @ ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A2 @ B2 ) ) ) ) ) ).

% mult_nonpos_nonpos
thf(fact_1369_mult__left__mono,axiom,
    ! [A: $tType] :
      ( ( ordered_semiring @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
           => ( ord_less_eq @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) ) ) ) ) ).

% mult_left_mono
thf(fact_1370_mult__right__mono__neg,axiom,
    ! [A: $tType] :
      ( ( ordered_ring @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( ord_less_eq @ A @ B2 @ A2 )
         => ( ( ord_less_eq @ A @ C2 @ ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) ) ) ) ) ).

% mult_right_mono_neg
thf(fact_1371_mult__right__mono,axiom,
    ! [A: $tType] :
      ( ( ordered_semiring @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
           => ( ord_less_eq @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) ) ) ) ) ).

% mult_right_mono
thf(fact_1372_mult__le__0__iff,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( times_times @ A @ A2 @ B2 ) @ ( zero_zero @ A ) )
          = ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
              & ( ord_less_eq @ A @ B2 @ ( zero_zero @ A ) ) )
            | ( ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) )
              & ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 ) ) ) ) ) ).

% mult_le_0_iff
thf(fact_1373_split__mult__neg__le,axiom,
    ! [A: $tType] :
      ( ( ordered_semiring_0 @ A )
     => ! [A2: A,B2: A] :
          ( ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
              & ( ord_less_eq @ A @ B2 @ ( zero_zero @ A ) ) )
            | ( ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) )
              & ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 ) ) )
         => ( ord_less_eq @ A @ ( times_times @ A @ A2 @ B2 ) @ ( zero_zero @ A ) ) ) ) ).

% split_mult_neg_le
thf(fact_1374_mult__nonneg__nonneg,axiom,
    ! [A: $tType] :
      ( ( ordered_semiring_0 @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 )
           => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A2 @ B2 ) ) ) ) ) ).

% mult_nonneg_nonneg
thf(fact_1375_mult__nonneg__nonpos,axiom,
    ! [A: $tType] :
      ( ( ordered_semiring_0 @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less_eq @ A @ B2 @ ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ ( times_times @ A @ A2 @ B2 ) @ ( zero_zero @ A ) ) ) ) ) ).

% mult_nonneg_nonpos
thf(fact_1376_mult__nonpos__nonneg,axiom,
    ! [A: $tType] :
      ( ( ordered_semiring_0 @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 )
           => ( ord_less_eq @ A @ ( times_times @ A @ A2 @ B2 ) @ ( zero_zero @ A ) ) ) ) ) ).

% mult_nonpos_nonneg
thf(fact_1377_mult__nonneg__nonpos2,axiom,
    ! [A: $tType] :
      ( ( ordered_semiring_0 @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less_eq @ A @ B2 @ ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ ( times_times @ A @ B2 @ A2 ) @ ( zero_zero @ A ) ) ) ) ) ).

% mult_nonneg_nonpos2
thf(fact_1378_zero__le__mult__iff,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A2 @ B2 ) )
          = ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
              & ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 ) )
            | ( ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) )
              & ( ord_less_eq @ A @ B2 @ ( zero_zero @ A ) ) ) ) ) ) ).

% zero_le_mult_iff
thf(fact_1379_ordered__comm__semiring__class_Ocomm__mult__left__mono,axiom,
    ! [A: $tType] :
      ( ( ordere2520102378445227354miring @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
           => ( ord_less_eq @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) ) ) ) ) ).

% ordered_comm_semiring_class.comm_mult_left_mono
thf(fact_1380_mult__neg__neg,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ B2 @ ( zero_zero @ A ) )
           => ( ord_less @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A2 @ B2 ) ) ) ) ) ).

% mult_neg_neg
thf(fact_1381_not__square__less__zero,axiom,
    ! [A: $tType] :
      ( ( linordered_ring @ A )
     => ! [A2: A] :
          ~ ( ord_less @ A @ ( times_times @ A @ A2 @ A2 ) @ ( zero_zero @ A ) ) ) ).

% not_square_less_zero
thf(fact_1382_mult__less__0__iff,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( times_times @ A @ A2 @ B2 ) @ ( zero_zero @ A ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
              & ( ord_less @ A @ B2 @ ( zero_zero @ A ) ) )
            | ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
              & ( ord_less @ A @ ( zero_zero @ A ) @ B2 ) ) ) ) ) ).

% mult_less_0_iff
thf(fact_1383_mult__neg__pos,axiom,
    ! [A: $tType] :
      ( ( linord8928482502909563296strict @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ B2 )
           => ( ord_less @ A @ ( times_times @ A @ A2 @ B2 ) @ ( zero_zero @ A ) ) ) ) ) ).

% mult_neg_pos
thf(fact_1384_mult__pos__neg,axiom,
    ! [A: $tType] :
      ( ( linord8928482502909563296strict @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less @ A @ B2 @ ( zero_zero @ A ) )
           => ( ord_less @ A @ ( times_times @ A @ A2 @ B2 ) @ ( zero_zero @ A ) ) ) ) ) ).

% mult_pos_neg
thf(fact_1385_mult__pos__pos,axiom,
    ! [A: $tType] :
      ( ( linord8928482502909563296strict @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ B2 )
           => ( ord_less @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A2 @ B2 ) ) ) ) ) ).

% mult_pos_pos
thf(fact_1386_mult__pos__neg2,axiom,
    ! [A: $tType] :
      ( ( linord8928482502909563296strict @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less @ A @ B2 @ ( zero_zero @ A ) )
           => ( ord_less @ A @ ( times_times @ A @ B2 @ A2 ) @ ( zero_zero @ A ) ) ) ) ) ).

% mult_pos_neg2
thf(fact_1387_zero__less__mult__iff,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A2 @ B2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
              & ( ord_less @ A @ ( zero_zero @ A ) @ B2 ) )
            | ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
              & ( ord_less @ A @ B2 @ ( zero_zero @ A ) ) ) ) ) ) ).

% zero_less_mult_iff
thf(fact_1388_zero__less__mult__pos,axiom,
    ! [A: $tType] :
      ( ( linord8928482502909563296strict @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A2 @ B2 ) )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
           => ( ord_less @ A @ ( zero_zero @ A ) @ B2 ) ) ) ) ).

% zero_less_mult_pos
thf(fact_1389_zero__less__mult__pos2,axiom,
    ! [A: $tType] :
      ( ( linord8928482502909563296strict @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( times_times @ A @ B2 @ A2 ) )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
           => ( ord_less @ A @ ( zero_zero @ A ) @ B2 ) ) ) ) ).

% zero_less_mult_pos2
thf(fact_1390_mult__less__cancel__left__neg,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) )
            = ( ord_less @ A @ B2 @ A2 ) ) ) ) ).

% mult_less_cancel_left_neg
thf(fact_1391_mult__less__cancel__left__pos,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
         => ( ( ord_less @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) )
            = ( ord_less @ A @ A2 @ B2 ) ) ) ) ).

% mult_less_cancel_left_pos
thf(fact_1392_mult__strict__left__mono__neg,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( ord_less @ A @ B2 @ A2 )
         => ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
           => ( ord_less @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) ) ) ) ) ).

% mult_strict_left_mono_neg
thf(fact_1393_mult__strict__left__mono,axiom,
    ! [A: $tType] :
      ( ( linord8928482502909563296strict @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
           => ( ord_less @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) ) ) ) ) ).

% mult_strict_left_mono
thf(fact_1394_mult__less__cancel__left__disj,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
              & ( ord_less @ A @ A2 @ B2 ) )
            | ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
              & ( ord_less @ A @ B2 @ A2 ) ) ) ) ) ).

% mult_less_cancel_left_disj
thf(fact_1395_mult__strict__right__mono__neg,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( ord_less @ A @ B2 @ A2 )
         => ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
           => ( ord_less @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) ) ) ) ) ).

% mult_strict_right_mono_neg
thf(fact_1396_mult__strict__right__mono,axiom,
    ! [A: $tType] :
      ( ( linord8928482502909563296strict @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
           => ( ord_less @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) ) ) ) ) ).

% mult_strict_right_mono
thf(fact_1397_mult__less__cancel__right__disj,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ord_less @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
              & ( ord_less @ A @ A2 @ B2 ) )
            | ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
              & ( ord_less @ A @ B2 @ A2 ) ) ) ) ) ).

% mult_less_cancel_right_disj
thf(fact_1398_linordered__comm__semiring__strict__class_Ocomm__mult__strict__left__mono,axiom,
    ! [A: $tType] :
      ( ( linord2810124833399127020strict @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
           => ( ord_less @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) ) ) ) ) ).

% linordered_comm_semiring_strict_class.comm_mult_strict_left_mono
thf(fact_1399_less__1__mult,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [M: A,N: A] :
          ( ( ord_less @ A @ ( one_one @ A ) @ M )
         => ( ( ord_less @ A @ ( one_one @ A ) @ N )
           => ( ord_less @ A @ ( one_one @ A ) @ ( times_times @ A @ M @ N ) ) ) ) ) ).

% less_1_mult
thf(fact_1400_frac__eq__eq,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [Y: A,Z: A,X: A,W: A] :
          ( ( Y
           != ( zero_zero @ A ) )
         => ( ( Z
             != ( zero_zero @ A ) )
           => ( ( ( divide_divide @ A @ X @ Y )
                = ( divide_divide @ A @ W @ Z ) )
              = ( ( times_times @ A @ X @ Z )
                = ( times_times @ A @ W @ Y ) ) ) ) ) ) ).

% frac_eq_eq
thf(fact_1401_divide__eq__eq,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( ( divide_divide @ A @ B2 @ C2 )
            = A2 )
          = ( ( ( C2
               != ( zero_zero @ A ) )
             => ( B2
                = ( times_times @ A @ A2 @ C2 ) ) )
            & ( ( C2
                = ( zero_zero @ A ) )
             => ( A2
                = ( zero_zero @ A ) ) ) ) ) ) ).

% divide_eq_eq
thf(fact_1402_eq__divide__eq,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( A2
            = ( divide_divide @ A @ B2 @ C2 ) )
          = ( ( ( C2
               != ( zero_zero @ A ) )
             => ( ( times_times @ A @ A2 @ C2 )
                = B2 ) )
            & ( ( C2
                = ( zero_zero @ A ) )
             => ( A2
                = ( zero_zero @ A ) ) ) ) ) ) ).

% eq_divide_eq
thf(fact_1403_divide__eq__imp,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( B2
              = ( times_times @ A @ A2 @ C2 ) )
           => ( ( divide_divide @ A @ B2 @ C2 )
              = A2 ) ) ) ) ).

% divide_eq_imp
thf(fact_1404_eq__divide__imp,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( ( times_times @ A @ A2 @ C2 )
              = B2 )
           => ( A2
              = ( divide_divide @ A @ B2 @ C2 ) ) ) ) ) ).

% eq_divide_imp
thf(fact_1405_nonzero__divide__eq__eq,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( ( divide_divide @ A @ B2 @ C2 )
              = A2 )
            = ( B2
              = ( times_times @ A @ A2 @ C2 ) ) ) ) ) ).

% nonzero_divide_eq_eq
thf(fact_1406_nonzero__eq__divide__eq,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( A2
              = ( divide_divide @ A @ B2 @ C2 ) )
            = ( ( times_times @ A @ A2 @ C2 )
              = B2 ) ) ) ) ).

% nonzero_eq_divide_eq
thf(fact_1407_mult__numeral__1,axiom,
    ! [A: $tType] :
      ( ( semiring_numeral @ A )
     => ! [A2: A] :
          ( ( times_times @ A @ ( numeral_numeral @ A @ one2 ) @ A2 )
          = A2 ) ) ).

% mult_numeral_1
thf(fact_1408_mult__numeral__1__right,axiom,
    ! [A: $tType] :
      ( ( semiring_numeral @ A )
     => ! [A2: A] :
          ( ( times_times @ A @ A2 @ ( numeral_numeral @ A @ one2 ) )
          = A2 ) ) ).

% mult_numeral_1_right
thf(fact_1409_mult__diff__mult,axiom,
    ! [A: $tType] :
      ( ( ring @ A )
     => ! [X: A,Y: A,A2: A,B2: A] :
          ( ( minus_minus @ A @ ( times_times @ A @ X @ Y ) @ ( times_times @ A @ A2 @ B2 ) )
          = ( plus_plus @ A @ ( times_times @ A @ X @ ( minus_minus @ A @ Y @ B2 ) ) @ ( times_times @ A @ ( minus_minus @ A @ X @ A2 ) @ B2 ) ) ) ) ).

% mult_diff_mult
thf(fact_1410_left__right__inverse__power,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [X: A,Y: A,N: nat] :
          ( ( ( times_times @ A @ X @ Y )
            = ( one_one @ A ) )
         => ( ( times_times @ A @ ( power_power @ A @ X @ N ) @ ( power_power @ A @ Y @ N ) )
            = ( one_one @ A ) ) ) ) ).

% left_right_inverse_power
thf(fact_1411_floor__divide__real__eq__div,axiom,
    ! [B2: int,A2: real] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ B2 )
     => ( ( archim6421214686448440834_floor @ real @ ( divide_divide @ real @ A2 @ ( ring_1_of_int @ real @ B2 ) ) )
        = ( divide_divide @ int @ ( archim6421214686448440834_floor @ real @ A2 ) @ B2 ) ) ) ).

% floor_divide_real_eq_div
thf(fact_1412_div__mult2__eq_H,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [A2: A,M: nat,N: nat] :
          ( ( divide_divide @ A @ A2 @ ( times_times @ A @ ( semiring_1_of_nat @ A @ M ) @ ( semiring_1_of_nat @ A @ N ) ) )
          = ( divide_divide @ A @ ( divide_divide @ A @ A2 @ ( semiring_1_of_nat @ A @ M ) ) @ ( semiring_1_of_nat @ A @ N ) ) ) ) ).

% div_mult2_eq'
thf(fact_1413_power__add,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [A2: A,M: nat,N: nat] :
          ( ( power_power @ A @ A2 @ ( plus_plus @ nat @ M @ N ) )
          = ( times_times @ A @ ( power_power @ A @ A2 @ M ) @ ( power_power @ A @ A2 @ N ) ) ) ) ).

% power_add
thf(fact_1414_nat__mult__less__cancel1,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
     => ( ( ord_less @ nat @ ( times_times @ nat @ K @ M ) @ ( times_times @ nat @ K @ N ) )
        = ( ord_less @ nat @ M @ N ) ) ) ).

% nat_mult_less_cancel1
thf(fact_1415_nat__mult__eq__cancel1,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
     => ( ( ( times_times @ nat @ K @ M )
          = ( times_times @ nat @ K @ N ) )
        = ( M = N ) ) ) ).

% nat_mult_eq_cancel1
thf(fact_1416_mult__less__mono2,axiom,
    ! [I: nat,J: nat,K: nat] :
      ( ( ord_less @ nat @ I @ J )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
       => ( ord_less @ nat @ ( times_times @ nat @ K @ I ) @ ( times_times @ nat @ K @ J ) ) ) ) ).

% mult_less_mono2
thf(fact_1417_mult__less__mono1,axiom,
    ! [I: nat,J: nat,K: nat] :
      ( ( ord_less @ nat @ I @ J )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
       => ( ord_less @ nat @ ( times_times @ nat @ I @ K ) @ ( times_times @ nat @ J @ K ) ) ) ) ).

% mult_less_mono1
thf(fact_1418_div__neg__pos__less0,axiom,
    ! [A2: int,B2: int] :
      ( ( ord_less @ int @ A2 @ ( zero_zero @ int ) )
     => ( ( ord_less @ int @ ( zero_zero @ int ) @ B2 )
       => ( ord_less @ int @ ( divide_divide @ int @ A2 @ B2 ) @ ( zero_zero @ int ) ) ) ) ).

% div_neg_pos_less0
thf(fact_1419_neg__imp__zdiv__neg__iff,axiom,
    ! [B2: int,A2: int] :
      ( ( ord_less @ int @ B2 @ ( zero_zero @ int ) )
     => ( ( ord_less @ int @ ( divide_divide @ int @ A2 @ B2 ) @ ( zero_zero @ int ) )
        = ( ord_less @ int @ ( zero_zero @ int ) @ A2 ) ) ) ).

% neg_imp_zdiv_neg_iff
thf(fact_1420_pos__imp__zdiv__neg__iff,axiom,
    ! [B2: int,A2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ B2 )
     => ( ( ord_less @ int @ ( divide_divide @ int @ A2 @ B2 ) @ ( zero_zero @ int ) )
        = ( ord_less @ int @ A2 @ ( zero_zero @ int ) ) ) ) ).

% pos_imp_zdiv_neg_iff
thf(fact_1421_mult__eq__self__implies__10,axiom,
    ! [M: nat,N: nat] :
      ( ( M
        = ( times_times @ nat @ M @ N ) )
     => ( ( N
          = ( one_one @ nat ) )
        | ( M
          = ( zero_zero @ nat ) ) ) ) ).

% mult_eq_self_implies_10
thf(fact_1422_zdiv__int,axiom,
    ! [A2: nat,B2: nat] :
      ( ( semiring_1_of_nat @ int @ ( divide_divide @ nat @ A2 @ B2 ) )
      = ( divide_divide @ int @ ( semiring_1_of_nat @ int @ A2 ) @ ( semiring_1_of_nat @ int @ B2 ) ) ) ).

% zdiv_int
thf(fact_1423_less__mult__imp__div__less,axiom,
    ! [M: nat,I: nat,N: nat] :
      ( ( ord_less @ nat @ M @ ( times_times @ nat @ I @ N ) )
     => ( ord_less @ nat @ ( divide_divide @ nat @ M @ N ) @ I ) ) ).

% less_mult_imp_div_less
thf(fact_1424_times__div__less__eq__dividend,axiom,
    ! [N: nat,M: nat] : ( ord_less_eq @ nat @ ( times_times @ nat @ N @ ( divide_divide @ nat @ M @ N ) ) @ M ) ).

% times_div_less_eq_dividend
thf(fact_1425_div__times__less__eq__dividend,axiom,
    ! [M: nat,N: nat] : ( ord_less_eq @ nat @ ( times_times @ nat @ ( divide_divide @ nat @ M @ N ) @ N ) @ M ) ).

% div_times_less_eq_dividend
thf(fact_1426_ln__bound,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ord_less_eq @ real @ ( ln_ln @ real @ X ) @ X ) ) ).

% ln_bound
thf(fact_1427_ln__eq__minus__one,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( ( ln_ln @ real @ X )
          = ( minus_minus @ real @ X @ ( one_one @ real ) ) )
       => ( X
          = ( one_one @ real ) ) ) ) ).

% ln_eq_minus_one
thf(fact_1428_ln__gt__zero__imp__gt__one,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ ( ln_ln @ real @ X ) )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
       => ( ord_less @ real @ ( one_one @ real ) @ X ) ) ) ).

% ln_gt_zero_imp_gt_one
thf(fact_1429_ln__less__zero,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less @ real @ X @ ( one_one @ real ) )
       => ( ord_less @ real @ ( ln_ln @ real @ X ) @ ( zero_zero @ real ) ) ) ) ).

% ln_less_zero
thf(fact_1430_ln__gt__zero,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ X )
     => ( ord_less @ real @ ( zero_zero @ real ) @ ( ln_ln @ real @ X ) ) ) ).

% ln_gt_zero
thf(fact_1431_ln__sqrt,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( ln_ln @ real @ ( sqrt @ X ) )
        = ( divide_divide @ real @ ( ln_ln @ real @ X ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ).

% ln_sqrt
thf(fact_1432_ln__ge__zero,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( one_one @ real ) @ X )
     => ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( ln_ln @ real @ X ) ) ) ).

% ln_ge_zero
thf(fact_1433_powr__less__mono2,axiom,
    ! [A2: real,X: real,Y: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
       => ( ( ord_less @ real @ X @ Y )
         => ( ord_less @ real @ ( powr @ real @ X @ A2 ) @ ( powr @ real @ Y @ A2 ) ) ) ) ) ).

% powr_less_mono2
thf(fact_1434_powr__mono2_H,axiom,
    ! [A2: real,X: real,Y: real] :
      ( ( ord_less_eq @ real @ A2 @ ( zero_zero @ real ) )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
       => ( ( ord_less_eq @ real @ X @ Y )
         => ( ord_less_eq @ real @ ( powr @ real @ Y @ A2 ) @ ( powr @ real @ X @ A2 ) ) ) ) ) ).

% powr_mono2'
thf(fact_1435_gr__one__powr,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ X )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ Y )
       => ( ord_less @ real @ ( one_one @ real ) @ ( powr @ real @ X @ Y ) ) ) ) ).

% gr_one_powr
thf(fact_1436_powr__inj,axiom,
    ! [A2: real,X: real,Y: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
     => ( ( A2
         != ( one_one @ real ) )
       => ( ( ( powr @ real @ A2 @ X )
            = ( powr @ real @ A2 @ Y ) )
          = ( X = Y ) ) ) ) ).

% powr_inj
thf(fact_1437_ge__one__powr__ge__zero,axiom,
    ! [X: real,A2: real] :
      ( ( ord_less_eq @ real @ ( one_one @ real ) @ X )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ A2 )
       => ( ord_less_eq @ real @ ( one_one @ real ) @ ( powr @ real @ X @ A2 ) ) ) ) ).

% ge_one_powr_ge_zero
thf(fact_1438_powr__mono__both,axiom,
    ! [A2: real,B2: real,X: real,Y: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ A2 )
     => ( ( ord_less_eq @ real @ A2 @ B2 )
       => ( ( ord_less_eq @ real @ ( one_one @ real ) @ X )
         => ( ( ord_less_eq @ real @ X @ Y )
           => ( ord_less_eq @ real @ ( powr @ real @ X @ A2 ) @ ( powr @ real @ Y @ B2 ) ) ) ) ) ) ).

% powr_mono_both
thf(fact_1439_powr__le1,axiom,
    ! [A2: real,X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ A2 )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
       => ( ( ord_less_eq @ real @ X @ ( one_one @ real ) )
         => ( ord_less_eq @ real @ ( powr @ real @ X @ A2 ) @ ( one_one @ real ) ) ) ) ) ).

% powr_le1
thf(fact_1440_round__mono,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ A @ X @ Y )
         => ( ord_less_eq @ int @ ( archimedean_round @ A @ X ) @ ( archimedean_round @ A @ Y ) ) ) ) ).

% round_mono
thf(fact_1441_mult__le__cancel__left,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less_eq @ A @ A2 @ B2 ) )
            & ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
             => ( ord_less_eq @ A @ B2 @ A2 ) ) ) ) ) ).

% mult_le_cancel_left
thf(fact_1442_mult__le__cancel__right,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less_eq @ A @ A2 @ B2 ) )
            & ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
             => ( ord_less_eq @ A @ B2 @ A2 ) ) ) ) ) ).

% mult_le_cancel_right
thf(fact_1443_mult__left__less__imp__less,axiom,
    ! [A: $tType] :
      ( ( linordered_semiring @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
           => ( ord_less @ A @ A2 @ B2 ) ) ) ) ).

% mult_left_less_imp_less
thf(fact_1444_mult__strict__mono,axiom,
    ! [A: $tType] :
      ( ( linord8928482502909563296strict @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_less @ A @ C2 @ D2 )
           => ( ( ord_less @ A @ ( zero_zero @ A ) @ B2 )
             => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
               => ( ord_less @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ D2 ) ) ) ) ) ) ) ).

% mult_strict_mono
thf(fact_1445_mult__less__cancel__left,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) )
          = ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less @ A @ A2 @ B2 ) )
            & ( ( ord_less_eq @ A @ C2 @ ( zero_zero @ A ) )
             => ( ord_less @ A @ B2 @ A2 ) ) ) ) ) ).

% mult_less_cancel_left
thf(fact_1446_mult__right__less__imp__less,axiom,
    ! [A: $tType] :
      ( ( linordered_semiring @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ord_less @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
           => ( ord_less @ A @ A2 @ B2 ) ) ) ) ).

% mult_right_less_imp_less
thf(fact_1447_mult__strict__mono_H,axiom,
    ! [A: $tType] :
      ( ( linord8928482502909563296strict @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_less @ A @ C2 @ D2 )
           => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
             => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
               => ( ord_less @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ D2 ) ) ) ) ) ) ) ).

% mult_strict_mono'
thf(fact_1448_mult__less__cancel__right,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ord_less @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) )
          = ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less @ A @ A2 @ B2 ) )
            & ( ( ord_less_eq @ A @ C2 @ ( zero_zero @ A ) )
             => ( ord_less @ A @ B2 @ A2 ) ) ) ) ) ).

% mult_less_cancel_right
thf(fact_1449_mult__le__cancel__left__neg,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) )
            = ( ord_less_eq @ A @ B2 @ A2 ) ) ) ) ).

% mult_le_cancel_left_neg
thf(fact_1450_mult__le__cancel__left__pos,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
         => ( ( ord_less_eq @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) )
            = ( ord_less_eq @ A @ A2 @ B2 ) ) ) ) ).

% mult_le_cancel_left_pos
thf(fact_1451_mult__left__le__imp__le,axiom,
    ! [A: $tType] :
      ( ( linord8928482502909563296strict @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( times_times @ A @ C2 @ A2 ) @ ( times_times @ A @ C2 @ B2 ) )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
           => ( ord_less_eq @ A @ A2 @ B2 ) ) ) ) ).

% mult_left_le_imp_le
thf(fact_1452_mult__right__le__imp__le,axiom,
    ! [A: $tType] :
      ( ( linord8928482502909563296strict @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ C2 ) )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
           => ( ord_less_eq @ A @ A2 @ B2 ) ) ) ) ).

% mult_right_le_imp_le
thf(fact_1453_mult__le__less__imp__less,axiom,
    ! [A: $tType] :
      ( ( linord8928482502909563296strict @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less @ A @ C2 @ D2 )
           => ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
             => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
               => ( ord_less @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ D2 ) ) ) ) ) ) ) ).

% mult_le_less_imp_less
thf(fact_1454_mult__less__le__imp__less,axiom,
    ! [A: $tType] :
      ( ( linord8928482502909563296strict @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ C2 @ D2 )
           => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
             => ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
               => ( ord_less @ A @ ( times_times @ A @ A2 @ C2 ) @ ( times_times @ A @ B2 @ D2 ) ) ) ) ) ) ) ).

% mult_less_le_imp_less
thf(fact_1455_mult__left__le__one__le,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ Y )
           => ( ( ord_less_eq @ A @ Y @ ( one_one @ A ) )
             => ( ord_less_eq @ A @ ( times_times @ A @ Y @ X ) @ X ) ) ) ) ) ).

% mult_left_le_one_le
thf(fact_1456_mult__right__le__one__le,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ Y )
           => ( ( ord_less_eq @ A @ Y @ ( one_one @ A ) )
             => ( ord_less_eq @ A @ ( times_times @ A @ X @ Y ) @ X ) ) ) ) ) ).

% mult_right_le_one_le
thf(fact_1457_mult__le__one,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ ( one_one @ A ) )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 )
           => ( ( ord_less_eq @ A @ B2 @ ( one_one @ A ) )
             => ( ord_less_eq @ A @ ( times_times @ A @ A2 @ B2 ) @ ( one_one @ A ) ) ) ) ) ) ).

% mult_le_one
thf(fact_1458_mult__left__le,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [C2: A,A2: A] :
          ( ( ord_less_eq @ A @ C2 @ ( one_one @ A ) )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
           => ( ord_less_eq @ A @ ( times_times @ A @ A2 @ C2 ) @ A2 ) ) ) ) ).

% mult_left_le
thf(fact_1459_sum__squares__ge__zero,axiom,
    ! [A: $tType] :
      ( ( linordered_ring @ A )
     => ! [X: A,Y: A] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( plus_plus @ A @ ( times_times @ A @ X @ X ) @ ( times_times @ A @ Y @ Y ) ) ) ) ).

% sum_squares_ge_zero
thf(fact_1460_sum__squares__le__zero__iff,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ ( times_times @ A @ X @ X ) @ ( times_times @ A @ Y @ Y ) ) @ ( zero_zero @ A ) )
          = ( ( X
              = ( zero_zero @ A ) )
            & ( Y
              = ( zero_zero @ A ) ) ) ) ) ).

% sum_squares_le_zero_iff
thf(fact_1461_not__sum__squares__lt__zero,axiom,
    ! [A: $tType] :
      ( ( linordered_ring @ A )
     => ! [X: A,Y: A] :
          ~ ( ord_less @ A @ ( plus_plus @ A @ ( times_times @ A @ X @ X ) @ ( times_times @ A @ Y @ Y ) ) @ ( zero_zero @ A ) ) ) ).

% not_sum_squares_lt_zero
thf(fact_1462_sum__squares__gt__zero__iff,axiom,
    ! [A: $tType] :
      ( ( linord4710134922213307826strict @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( plus_plus @ A @ ( times_times @ A @ X @ X ) @ ( times_times @ A @ Y @ Y ) ) )
          = ( ( X
             != ( zero_zero @ A ) )
            | ( Y
             != ( zero_zero @ A ) ) ) ) ) ).

% sum_squares_gt_zero_iff
thf(fact_1463_unique__euclidean__semiring__numeral__class_Odiv__mult2__eq,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
         => ( ( divide_divide @ A @ A2 @ ( times_times @ A @ B2 @ C2 ) )
            = ( divide_divide @ A @ ( divide_divide @ A @ A2 @ B2 ) @ C2 ) ) ) ) ).

% unique_euclidean_semiring_numeral_class.div_mult2_eq
thf(fact_1464_divide__less__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( ord_less @ A @ ( divide_divide @ A @ B2 @ C2 ) @ A2 )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less @ A @ B2 @ ( times_times @ A @ A2 @ C2 ) ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ ( times_times @ A @ A2 @ C2 ) @ B2 ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ ( zero_zero @ A ) @ A2 ) ) ) ) ) ) ) ).

% divide_less_eq
thf(fact_1465_less__divide__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less @ A @ A2 @ ( divide_divide @ A @ B2 @ C2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less @ A @ ( times_times @ A @ A2 @ C2 ) @ B2 ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ B2 @ ( times_times @ A @ A2 @ C2 ) ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ A2 @ ( zero_zero @ A ) ) ) ) ) ) ) ) ).

% less_divide_eq
thf(fact_1466_neg__divide__less__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ ( divide_divide @ A @ B2 @ C2 ) @ A2 )
            = ( ord_less @ A @ ( times_times @ A @ A2 @ C2 ) @ B2 ) ) ) ) ).

% neg_divide_less_eq
thf(fact_1467_neg__less__divide__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ A2 @ ( divide_divide @ A @ B2 @ C2 ) )
            = ( ord_less @ A @ B2 @ ( times_times @ A @ A2 @ C2 ) ) ) ) ) ).

% neg_less_divide_eq
thf(fact_1468_pos__divide__less__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
         => ( ( ord_less @ A @ ( divide_divide @ A @ B2 @ C2 ) @ A2 )
            = ( ord_less @ A @ B2 @ ( times_times @ A @ A2 @ C2 ) ) ) ) ) ).

% pos_divide_less_eq
thf(fact_1469_pos__less__divide__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
         => ( ( ord_less @ A @ A2 @ ( divide_divide @ A @ B2 @ C2 ) )
            = ( ord_less @ A @ ( times_times @ A @ A2 @ C2 ) @ B2 ) ) ) ) ).

% pos_less_divide_eq
thf(fact_1470_mult__imp__div__pos__less,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [Y: A,X: A,Z: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ Y )
         => ( ( ord_less @ A @ X @ ( times_times @ A @ Z @ Y ) )
           => ( ord_less @ A @ ( divide_divide @ A @ X @ Y ) @ Z ) ) ) ) ).

% mult_imp_div_pos_less
thf(fact_1471_mult__imp__less__div__pos,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [Y: A,Z: A,X: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ Y )
         => ( ( ord_less @ A @ ( times_times @ A @ Z @ Y ) @ X )
           => ( ord_less @ A @ Z @ ( divide_divide @ A @ X @ Y ) ) ) ) ) ).

% mult_imp_less_div_pos
thf(fact_1472_divide__strict__left__mono,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( ord_less @ A @ B2 @ A2 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
           => ( ( ord_less @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A2 @ B2 ) )
             => ( ord_less @ A @ ( divide_divide @ A @ C2 @ A2 ) @ ( divide_divide @ A @ C2 @ B2 ) ) ) ) ) ) ).

% divide_strict_left_mono
thf(fact_1473_divide__strict__left__mono__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
           => ( ( ord_less @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A2 @ B2 ) )
             => ( ord_less @ A @ ( divide_divide @ A @ C2 @ A2 ) @ ( divide_divide @ A @ C2 @ B2 ) ) ) ) ) ) ).

% divide_strict_left_mono_neg
thf(fact_1474_divide__eq__eq__numeral_I1_J,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [B2: A,C2: A,W: num] :
          ( ( ( divide_divide @ A @ B2 @ C2 )
            = ( numeral_numeral @ A @ W ) )
          = ( ( ( C2
               != ( zero_zero @ A ) )
             => ( B2
                = ( times_times @ A @ ( numeral_numeral @ A @ W ) @ C2 ) ) )
            & ( ( C2
                = ( zero_zero @ A ) )
             => ( ( numeral_numeral @ A @ W )
                = ( zero_zero @ A ) ) ) ) ) ) ).

% divide_eq_eq_numeral(1)
thf(fact_1475_eq__divide__eq__numeral_I1_J,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [W: num,B2: A,C2: A] :
          ( ( ( numeral_numeral @ A @ W )
            = ( divide_divide @ A @ B2 @ C2 ) )
          = ( ( ( C2
               != ( zero_zero @ A ) )
             => ( ( times_times @ A @ ( numeral_numeral @ A @ W ) @ C2 )
                = B2 ) )
            & ( ( C2
                = ( zero_zero @ A ) )
             => ( ( numeral_numeral @ A @ W )
                = ( zero_zero @ A ) ) ) ) ) ) ).

% eq_divide_eq_numeral(1)
thf(fact_1476_ordered__ring__class_Ole__add__iff1,axiom,
    ! [A: $tType] :
      ( ( ordered_ring @ A )
     => ! [A2: A,E2: A,C2: A,B2: A,D2: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ ( times_times @ A @ A2 @ E2 ) @ C2 ) @ ( plus_plus @ A @ ( times_times @ A @ B2 @ E2 ) @ D2 ) )
          = ( ord_less_eq @ A @ ( plus_plus @ A @ ( times_times @ A @ ( minus_minus @ A @ A2 @ B2 ) @ E2 ) @ C2 ) @ D2 ) ) ) ).

% ordered_ring_class.le_add_iff1
thf(fact_1477_ordered__ring__class_Ole__add__iff2,axiom,
    ! [A: $tType] :
      ( ( ordered_ring @ A )
     => ! [A2: A,E2: A,C2: A,B2: A,D2: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ ( times_times @ A @ A2 @ E2 ) @ C2 ) @ ( plus_plus @ A @ ( times_times @ A @ B2 @ E2 ) @ D2 ) )
          = ( ord_less_eq @ A @ C2 @ ( plus_plus @ A @ ( times_times @ A @ ( minus_minus @ A @ B2 @ A2 ) @ E2 ) @ D2 ) ) ) ) ).

% ordered_ring_class.le_add_iff2
thf(fact_1478_divide__add__eq__iff,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [Z: A,X: A,Y: A] :
          ( ( Z
           != ( zero_zero @ A ) )
         => ( ( plus_plus @ A @ ( divide_divide @ A @ X @ Z ) @ Y )
            = ( divide_divide @ A @ ( plus_plus @ A @ X @ ( times_times @ A @ Y @ Z ) ) @ Z ) ) ) ) ).

% divide_add_eq_iff
thf(fact_1479_add__divide__eq__iff,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [Z: A,X: A,Y: A] :
          ( ( Z
           != ( zero_zero @ A ) )
         => ( ( plus_plus @ A @ X @ ( divide_divide @ A @ Y @ Z ) )
            = ( divide_divide @ A @ ( plus_plus @ A @ ( times_times @ A @ X @ Z ) @ Y ) @ Z ) ) ) ) ).

% add_divide_eq_iff
thf(fact_1480_add__num__frac,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [Y: A,Z: A,X: A] :
          ( ( Y
           != ( zero_zero @ A ) )
         => ( ( plus_plus @ A @ Z @ ( divide_divide @ A @ X @ Y ) )
            = ( divide_divide @ A @ ( plus_plus @ A @ X @ ( times_times @ A @ Z @ Y ) ) @ Y ) ) ) ) ).

% add_num_frac
thf(fact_1481_add__frac__num,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [Y: A,X: A,Z: A] :
          ( ( Y
           != ( zero_zero @ A ) )
         => ( ( plus_plus @ A @ ( divide_divide @ A @ X @ Y ) @ Z )
            = ( divide_divide @ A @ ( plus_plus @ A @ X @ ( times_times @ A @ Z @ Y ) ) @ Y ) ) ) ) ).

% add_frac_num
thf(fact_1482_add__frac__eq,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [Y: A,Z: A,X: A,W: A] :
          ( ( Y
           != ( zero_zero @ A ) )
         => ( ( Z
             != ( zero_zero @ A ) )
           => ( ( plus_plus @ A @ ( divide_divide @ A @ X @ Y ) @ ( divide_divide @ A @ W @ Z ) )
              = ( divide_divide @ A @ ( plus_plus @ A @ ( times_times @ A @ X @ Z ) @ ( times_times @ A @ W @ Y ) ) @ ( times_times @ A @ Y @ Z ) ) ) ) ) ) ).

% add_frac_eq
thf(fact_1483_add__divide__eq__if__simps_I1_J,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [Z: A,A2: A,B2: A] :
          ( ( ( Z
              = ( zero_zero @ A ) )
           => ( ( plus_plus @ A @ A2 @ ( divide_divide @ A @ B2 @ Z ) )
              = A2 ) )
          & ( ( Z
             != ( zero_zero @ A ) )
           => ( ( plus_plus @ A @ A2 @ ( divide_divide @ A @ B2 @ Z ) )
              = ( divide_divide @ A @ ( plus_plus @ A @ ( times_times @ A @ A2 @ Z ) @ B2 ) @ Z ) ) ) ) ) ).

% add_divide_eq_if_simps(1)
thf(fact_1484_add__divide__eq__if__simps_I2_J,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [Z: A,A2: A,B2: A] :
          ( ( ( Z
              = ( zero_zero @ A ) )
           => ( ( plus_plus @ A @ ( divide_divide @ A @ A2 @ Z ) @ B2 )
              = B2 ) )
          & ( ( Z
             != ( zero_zero @ A ) )
           => ( ( plus_plus @ A @ ( divide_divide @ A @ A2 @ Z ) @ B2 )
              = ( divide_divide @ A @ ( plus_plus @ A @ A2 @ ( times_times @ A @ B2 @ Z ) ) @ Z ) ) ) ) ) ).

% add_divide_eq_if_simps(2)
thf(fact_1485_less__add__iff2,axiom,
    ! [A: $tType] :
      ( ( ordered_ring @ A )
     => ! [A2: A,E2: A,C2: A,B2: A,D2: A] :
          ( ( ord_less @ A @ ( plus_plus @ A @ ( times_times @ A @ A2 @ E2 ) @ C2 ) @ ( plus_plus @ A @ ( times_times @ A @ B2 @ E2 ) @ D2 ) )
          = ( ord_less @ A @ C2 @ ( plus_plus @ A @ ( times_times @ A @ ( minus_minus @ A @ B2 @ A2 ) @ E2 ) @ D2 ) ) ) ) ).

% less_add_iff2
thf(fact_1486_less__add__iff1,axiom,
    ! [A: $tType] :
      ( ( ordered_ring @ A )
     => ! [A2: A,E2: A,C2: A,B2: A,D2: A] :
          ( ( ord_less @ A @ ( plus_plus @ A @ ( times_times @ A @ A2 @ E2 ) @ C2 ) @ ( plus_plus @ A @ ( times_times @ A @ B2 @ E2 ) @ D2 ) )
          = ( ord_less @ A @ ( plus_plus @ A @ ( times_times @ A @ ( minus_minus @ A @ A2 @ B2 ) @ E2 ) @ C2 ) @ D2 ) ) ) ).

% less_add_iff1
thf(fact_1487_divide__diff__eq__iff,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [Z: A,X: A,Y: A] :
          ( ( Z
           != ( zero_zero @ A ) )
         => ( ( minus_minus @ A @ ( divide_divide @ A @ X @ Z ) @ Y )
            = ( divide_divide @ A @ ( minus_minus @ A @ X @ ( times_times @ A @ Y @ Z ) ) @ Z ) ) ) ) ).

% divide_diff_eq_iff
thf(fact_1488_diff__divide__eq__iff,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [Z: A,X: A,Y: A] :
          ( ( Z
           != ( zero_zero @ A ) )
         => ( ( minus_minus @ A @ X @ ( divide_divide @ A @ Y @ Z ) )
            = ( divide_divide @ A @ ( minus_minus @ A @ ( times_times @ A @ X @ Z ) @ Y ) @ Z ) ) ) ) ).

% diff_divide_eq_iff
thf(fact_1489_diff__frac__eq,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [Y: A,Z: A,X: A,W: A] :
          ( ( Y
           != ( zero_zero @ A ) )
         => ( ( Z
             != ( zero_zero @ A ) )
           => ( ( minus_minus @ A @ ( divide_divide @ A @ X @ Y ) @ ( divide_divide @ A @ W @ Z ) )
              = ( divide_divide @ A @ ( minus_minus @ A @ ( times_times @ A @ X @ Z ) @ ( times_times @ A @ W @ Y ) ) @ ( times_times @ A @ Y @ Z ) ) ) ) ) ) ).

% diff_frac_eq
thf(fact_1490_add__divide__eq__if__simps_I4_J,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [Z: A,A2: A,B2: A] :
          ( ( ( Z
              = ( zero_zero @ A ) )
           => ( ( minus_minus @ A @ A2 @ ( divide_divide @ A @ B2 @ Z ) )
              = A2 ) )
          & ( ( Z
             != ( zero_zero @ A ) )
           => ( ( minus_minus @ A @ A2 @ ( divide_divide @ A @ B2 @ Z ) )
              = ( divide_divide @ A @ ( minus_minus @ A @ ( times_times @ A @ A2 @ Z ) @ B2 ) @ Z ) ) ) ) ) ).

% add_divide_eq_if_simps(4)
thf(fact_1491_ex__less__of__nat__mult,axiom,
    ! [A: $tType] :
      ( ( archim462609752435547400_field @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ X )
         => ? [N2: nat] : ( ord_less @ A @ Y @ ( times_times @ A @ ( semiring_1_of_nat @ A @ N2 ) @ X ) ) ) ) ).

% ex_less_of_nat_mult
thf(fact_1492_power__gt1__lemma,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,N: nat] :
          ( ( ord_less @ A @ ( one_one @ A ) @ A2 )
         => ( ord_less @ A @ ( one_one @ A ) @ ( times_times @ A @ A2 @ ( power_power @ A @ A2 @ N ) ) ) ) ) ).

% power_gt1_lemma
thf(fact_1493_power__less__power__Suc,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,N: nat] :
          ( ( ord_less @ A @ ( one_one @ A ) @ A2 )
         => ( ord_less @ A @ ( power_power @ A @ A2 @ N ) @ ( times_times @ A @ A2 @ ( power_power @ A @ A2 @ N ) ) ) ) ) ).

% power_less_power_Suc
thf(fact_1494_unit__dvdE,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,B2: A] :
          ( ( dvd_dvd @ A @ A2 @ ( one_one @ A ) )
         => ~ ( ( A2
               != ( zero_zero @ A ) )
             => ! [C3: A] :
                  ( B2
                 != ( times_times @ A @ A2 @ C3 ) ) ) ) ) ).

% unit_dvdE
thf(fact_1495_unity__coeff__ex,axiom,
    ! [A: $tType] :
      ( ( ( dvd @ A )
        & ( semiring_0 @ A ) )
     => ! [P: A > $o,L: A] :
          ( ( ? [X2: A] : ( P @ ( times_times @ A @ L @ X2 ) ) )
          = ( ? [X2: A] :
                ( ( dvd_dvd @ A @ L @ ( plus_plus @ A @ X2 @ ( zero_zero @ A ) ) )
                & ( P @ X2 ) ) ) ) ) ).

% unity_coeff_ex
thf(fact_1496_dvd__div__div__eq__mult,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,C2: A,B2: A,D2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( C2
             != ( zero_zero @ A ) )
           => ( ( dvd_dvd @ A @ A2 @ B2 )
             => ( ( dvd_dvd @ A @ C2 @ D2 )
               => ( ( ( divide_divide @ A @ B2 @ A2 )
                    = ( divide_divide @ A @ D2 @ C2 ) )
                  = ( ( times_times @ A @ B2 @ C2 )
                    = ( times_times @ A @ A2 @ D2 ) ) ) ) ) ) ) ) ).

% dvd_div_div_eq_mult
thf(fact_1497_dvd__div__iff__mult,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( dvd_dvd @ A @ C2 @ B2 )
           => ( ( dvd_dvd @ A @ A2 @ ( divide_divide @ A @ B2 @ C2 ) )
              = ( dvd_dvd @ A @ ( times_times @ A @ A2 @ C2 ) @ B2 ) ) ) ) ) ).

% dvd_div_iff_mult
thf(fact_1498_div__dvd__iff__mult,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( dvd_dvd @ A @ B2 @ A2 )
           => ( ( dvd_dvd @ A @ ( divide_divide @ A @ A2 @ B2 ) @ C2 )
              = ( dvd_dvd @ A @ A2 @ ( times_times @ A @ C2 @ B2 ) ) ) ) ) ) ).

% div_dvd_iff_mult
thf(fact_1499_dvd__div__eq__mult,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( dvd_dvd @ A @ A2 @ B2 )
           => ( ( ( divide_divide @ A @ B2 @ A2 )
                = C2 )
              = ( B2
                = ( times_times @ A @ C2 @ A2 ) ) ) ) ) ) ).

% dvd_div_eq_mult
thf(fact_1500_inf__period_I4_J,axiom,
    ! [A: $tType] :
      ( ( ( comm_ring @ A )
        & ( dvd @ A ) )
     => ! [D2: A,D5: A,T2: A] :
          ( ( dvd_dvd @ A @ D2 @ D5 )
         => ! [X5: A,K4: A] :
              ( ( ~ ( dvd_dvd @ A @ D2 @ ( plus_plus @ A @ X5 @ T2 ) ) )
              = ( ~ ( dvd_dvd @ A @ D2 @ ( plus_plus @ A @ ( minus_minus @ A @ X5 @ ( times_times @ A @ K4 @ D5 ) ) @ T2 ) ) ) ) ) ) ).

% inf_period(4)
thf(fact_1501_inf__period_I3_J,axiom,
    ! [A: $tType] :
      ( ( ( comm_ring @ A )
        & ( dvd @ A ) )
     => ! [D2: A,D5: A,T2: A] :
          ( ( dvd_dvd @ A @ D2 @ D5 )
         => ! [X5: A,K4: A] :
              ( ( dvd_dvd @ A @ D2 @ ( plus_plus @ A @ X5 @ T2 ) )
              = ( dvd_dvd @ A @ D2 @ ( plus_plus @ A @ ( minus_minus @ A @ X5 @ ( times_times @ A @ K4 @ D5 ) ) @ T2 ) ) ) ) ) ).

% inf_period(3)
thf(fact_1502_nat__mult__le__cancel1,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
     => ( ( ord_less_eq @ nat @ ( times_times @ nat @ K @ M ) @ ( times_times @ nat @ K @ N ) )
        = ( ord_less_eq @ nat @ M @ N ) ) ) ).

% nat_mult_le_cancel1
thf(fact_1503_nonneg1__imp__zdiv__pos__iff,axiom,
    ! [A2: int,B2: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ A2 )
     => ( ( ord_less @ int @ ( zero_zero @ int ) @ ( divide_divide @ int @ A2 @ B2 ) )
        = ( ( ord_less_eq @ int @ B2 @ A2 )
          & ( ord_less @ int @ ( zero_zero @ int ) @ B2 ) ) ) ) ).

% nonneg1_imp_zdiv_pos_iff
thf(fact_1504_pos__imp__zdiv__nonneg__iff,axiom,
    ! [B2: int,A2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ B2 )
     => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( divide_divide @ int @ A2 @ B2 ) )
        = ( ord_less_eq @ int @ ( zero_zero @ int ) @ A2 ) ) ) ).

% pos_imp_zdiv_nonneg_iff
thf(fact_1505_neg__imp__zdiv__nonneg__iff,axiom,
    ! [B2: int,A2: int] :
      ( ( ord_less @ int @ B2 @ ( zero_zero @ int ) )
     => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( divide_divide @ int @ A2 @ B2 ) )
        = ( ord_less_eq @ int @ A2 @ ( zero_zero @ int ) ) ) ) ).

% neg_imp_zdiv_nonneg_iff
thf(fact_1506_pos__imp__zdiv__pos__iff,axiom,
    ! [K: int,I: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ K )
     => ( ( ord_less @ int @ ( zero_zero @ int ) @ ( divide_divide @ int @ I @ K ) )
        = ( ord_less_eq @ int @ K @ I ) ) ) ).

% pos_imp_zdiv_pos_iff
thf(fact_1507_div__nonpos__pos__le0,axiom,
    ! [A2: int,B2: int] :
      ( ( ord_less_eq @ int @ A2 @ ( zero_zero @ int ) )
     => ( ( ord_less @ int @ ( zero_zero @ int ) @ B2 )
       => ( ord_less_eq @ int @ ( divide_divide @ int @ A2 @ B2 ) @ ( zero_zero @ int ) ) ) ) ).

% div_nonpos_pos_le0
thf(fact_1508_div__nonneg__neg__le0,axiom,
    ! [A2: int,B2: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ A2 )
     => ( ( ord_less @ int @ B2 @ ( zero_zero @ int ) )
       => ( ord_less_eq @ int @ ( divide_divide @ int @ A2 @ B2 ) @ ( zero_zero @ int ) ) ) ) ).

% div_nonneg_neg_le0
thf(fact_1509_div__positive__int,axiom,
    ! [L: int,K: int] :
      ( ( ord_less_eq @ int @ L @ K )
     => ( ( ord_less @ int @ ( zero_zero @ int ) @ L )
       => ( ord_less @ int @ ( zero_zero @ int ) @ ( divide_divide @ int @ K @ L ) ) ) ) ).

% div_positive_int
thf(fact_1510_div__int__pos__iff,axiom,
    ! [K: int,L: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( divide_divide @ int @ K @ L ) )
      = ( ( K
          = ( zero_zero @ int ) )
        | ( L
          = ( zero_zero @ int ) )
        | ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ K )
          & ( ord_less_eq @ int @ ( zero_zero @ int ) @ L ) )
        | ( ( ord_less @ int @ K @ ( zero_zero @ int ) )
          & ( ord_less @ int @ L @ ( zero_zero @ int ) ) ) ) ) ).

% div_int_pos_iff
thf(fact_1511_zdiv__mono2__neg,axiom,
    ! [A2: int,B5: int,B2: int] :
      ( ( ord_less @ int @ A2 @ ( zero_zero @ int ) )
     => ( ( ord_less @ int @ ( zero_zero @ int ) @ B5 )
       => ( ( ord_less_eq @ int @ B5 @ B2 )
         => ( ord_less_eq @ int @ ( divide_divide @ int @ A2 @ B5 ) @ ( divide_divide @ int @ A2 @ B2 ) ) ) ) ) ).

% zdiv_mono2_neg
thf(fact_1512_zdiv__mono1__neg,axiom,
    ! [A2: int,A6: int,B2: int] :
      ( ( ord_less_eq @ int @ A2 @ A6 )
     => ( ( ord_less @ int @ B2 @ ( zero_zero @ int ) )
       => ( ord_less_eq @ int @ ( divide_divide @ int @ A6 @ B2 ) @ ( divide_divide @ int @ A2 @ B2 ) ) ) ) ).

% zdiv_mono1_neg
thf(fact_1513_zdiv__eq__0__iff,axiom,
    ! [I: int,K: int] :
      ( ( ( divide_divide @ int @ I @ K )
        = ( zero_zero @ int ) )
      = ( ( K
          = ( zero_zero @ int ) )
        | ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ I )
          & ( ord_less @ int @ I @ K ) )
        | ( ( ord_less_eq @ int @ I @ ( zero_zero @ int ) )
          & ( ord_less @ int @ K @ I ) ) ) ) ).

% zdiv_eq_0_iff
thf(fact_1514_zdiv__mono2,axiom,
    ! [A2: int,B5: int,B2: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ A2 )
     => ( ( ord_less @ int @ ( zero_zero @ int ) @ B5 )
       => ( ( ord_less_eq @ int @ B5 @ B2 )
         => ( ord_less_eq @ int @ ( divide_divide @ int @ A2 @ B2 ) @ ( divide_divide @ int @ A2 @ B5 ) ) ) ) ) ).

% zdiv_mono2
thf(fact_1515_zdiv__mono1,axiom,
    ! [A2: int,A6: int,B2: int] :
      ( ( ord_less_eq @ int @ A2 @ A6 )
     => ( ( ord_less @ int @ ( zero_zero @ int ) @ B2 )
       => ( ord_less_eq @ int @ ( divide_divide @ int @ A2 @ B2 ) @ ( divide_divide @ int @ A6 @ B2 ) ) ) ) ).

% zdiv_mono1
thf(fact_1516_int__div__less__self,axiom,
    ! [X: int,K: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ X )
     => ( ( ord_less @ int @ ( one_one @ int ) @ K )
       => ( ord_less @ int @ ( divide_divide @ int @ X @ K ) @ X ) ) ) ).

% int_div_less_self
thf(fact_1517_floor__le__round,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] : ( ord_less_eq @ int @ ( archim6421214686448440834_floor @ A @ X ) @ ( archimedean_round @ A @ X ) ) ) ).

% floor_le_round
thf(fact_1518_real__div__sqrt,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( divide_divide @ real @ X @ ( sqrt @ X ) )
        = ( sqrt @ X ) ) ) ).

% real_div_sqrt
thf(fact_1519_div__less__iff__less__mult,axiom,
    ! [Q3: nat,M: nat,N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ Q3 )
     => ( ( ord_less @ nat @ ( divide_divide @ nat @ M @ Q3 ) @ N )
        = ( ord_less @ nat @ M @ ( times_times @ nat @ N @ Q3 ) ) ) ) ).

% div_less_iff_less_mult
thf(fact_1520_nat__mult__div__cancel1,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
     => ( ( divide_divide @ nat @ ( times_times @ nat @ K @ M ) @ ( times_times @ nat @ K @ N ) )
        = ( divide_divide @ nat @ M @ N ) ) ) ).

% nat_mult_div_cancel1
thf(fact_1521_dvd__mult__cancel,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( dvd_dvd @ nat @ ( times_times @ nat @ K @ M ) @ ( times_times @ nat @ K @ N ) )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
       => ( dvd_dvd @ nat @ M @ N ) ) ) ).

% dvd_mult_cancel
thf(fact_1522_nat__mult__dvd__cancel1,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
     => ( ( dvd_dvd @ nat @ ( times_times @ nat @ K @ M ) @ ( times_times @ nat @ K @ N ) )
        = ( dvd_dvd @ nat @ M @ N ) ) ) ).

% nat_mult_dvd_cancel1
thf(fact_1523_nat__diff__add__eq2,axiom,
    ! [I: nat,J: nat,U: nat,M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ I @ J )
     => ( ( minus_minus @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ I @ U ) @ M ) @ ( plus_plus @ nat @ ( times_times @ nat @ J @ U ) @ N ) )
        = ( minus_minus @ nat @ M @ ( plus_plus @ nat @ ( times_times @ nat @ ( minus_minus @ nat @ J @ I ) @ U ) @ N ) ) ) ) ).

% nat_diff_add_eq2
thf(fact_1524_nat__diff__add__eq1,axiom,
    ! [J: nat,I: nat,U: nat,M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ J @ I )
     => ( ( minus_minus @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ I @ U ) @ M ) @ ( plus_plus @ nat @ ( times_times @ nat @ J @ U ) @ N ) )
        = ( minus_minus @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ ( minus_minus @ nat @ I @ J ) @ U ) @ M ) @ N ) ) ) ).

% nat_diff_add_eq1
thf(fact_1525_nat__le__add__iff2,axiom,
    ! [I: nat,J: nat,U: nat,M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ I @ J )
     => ( ( ord_less_eq @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ I @ U ) @ M ) @ ( plus_plus @ nat @ ( times_times @ nat @ J @ U ) @ N ) )
        = ( ord_less_eq @ nat @ M @ ( plus_plus @ nat @ ( times_times @ nat @ ( minus_minus @ nat @ J @ I ) @ U ) @ N ) ) ) ) ).

% nat_le_add_iff2
thf(fact_1526_nat__le__add__iff1,axiom,
    ! [J: nat,I: nat,U: nat,M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ J @ I )
     => ( ( ord_less_eq @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ I @ U ) @ M ) @ ( plus_plus @ nat @ ( times_times @ nat @ J @ U ) @ N ) )
        = ( ord_less_eq @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ ( minus_minus @ nat @ I @ J ) @ U ) @ M ) @ N ) ) ) ).

% nat_le_add_iff1
thf(fact_1527_nat__eq__add__iff2,axiom,
    ! [I: nat,J: nat,U: nat,M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ I @ J )
     => ( ( ( plus_plus @ nat @ ( times_times @ nat @ I @ U ) @ M )
          = ( plus_plus @ nat @ ( times_times @ nat @ J @ U ) @ N ) )
        = ( M
          = ( plus_plus @ nat @ ( times_times @ nat @ ( minus_minus @ nat @ J @ I ) @ U ) @ N ) ) ) ) ).

% nat_eq_add_iff2
thf(fact_1528_nat__eq__add__iff1,axiom,
    ! [J: nat,I: nat,U: nat,M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ J @ I )
     => ( ( ( plus_plus @ nat @ ( times_times @ nat @ I @ U ) @ M )
          = ( plus_plus @ nat @ ( times_times @ nat @ J @ U ) @ N ) )
        = ( ( plus_plus @ nat @ ( times_times @ nat @ ( minus_minus @ nat @ I @ J ) @ U ) @ M )
          = N ) ) ) ).

% nat_eq_add_iff1
thf(fact_1529_ceiling__ge__round,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] : ( ord_less_eq @ int @ ( archimedean_round @ A @ X ) @ ( archimedean_ceiling @ A @ X ) ) ) ).

% ceiling_ge_round
thf(fact_1530_bezout__add__strong__nat,axiom,
    ! [A2: nat,B2: nat] :
      ( ( A2
       != ( zero_zero @ nat ) )
     => ? [D6: nat,X3: nat,Y5: nat] :
          ( ( dvd_dvd @ nat @ D6 @ A2 )
          & ( dvd_dvd @ nat @ D6 @ B2 )
          & ( ( times_times @ nat @ A2 @ X3 )
            = ( plus_plus @ nat @ ( times_times @ nat @ B2 @ Y5 ) @ D6 ) ) ) ) ).

% bezout_add_strong_nat
thf(fact_1531_real__of__nat__div4,axiom,
    ! [N: nat,X: nat] : ( ord_less_eq @ real @ ( semiring_1_of_nat @ real @ ( divide_divide @ nat @ N @ X ) ) @ ( divide_divide @ real @ ( semiring_1_of_nat @ real @ N ) @ ( semiring_1_of_nat @ real @ X ) ) ) ).

% real_of_nat_div4
thf(fact_1532_real__of__nat__div,axiom,
    ! [D2: nat,N: nat] :
      ( ( dvd_dvd @ nat @ D2 @ N )
     => ( ( semiring_1_of_nat @ real @ ( divide_divide @ nat @ N @ D2 ) )
        = ( divide_divide @ real @ ( semiring_1_of_nat @ real @ N ) @ ( semiring_1_of_nat @ real @ D2 ) ) ) ) ).

% real_of_nat_div
thf(fact_1533_powr__half__sqrt,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( powr @ real @ X @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
        = ( sqrt @ X ) ) ) ).

% powr_half_sqrt
thf(fact_1534_ln__le__minus__one,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ord_less_eq @ real @ ( ln_ln @ real @ X ) @ ( minus_minus @ real @ X @ ( one_one @ real ) ) ) ) ).

% ln_le_minus_one
thf(fact_1535_ln__ge__zero__imp__ge__one,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( ln_ln @ real @ X ) )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
       => ( ord_less_eq @ real @ ( one_one @ real ) @ X ) ) ) ).

% ln_ge_zero_imp_ge_one
thf(fact_1536_ln__add__one__self__le__self,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ord_less_eq @ real @ ( ln_ln @ real @ ( plus_plus @ real @ ( one_one @ real ) @ X ) ) @ X ) ) ).

% ln_add_one_self_le_self
thf(fact_1537_powr__realpow,axiom,
    ! [X: real,N: nat] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( powr @ real @ X @ ( semiring_1_of_nat @ real @ N ) )
        = ( power_power @ real @ X @ N ) ) ) ).

% powr_realpow
thf(fact_1538_less__log__iff,axiom,
    ! [B2: real,X: real,Y: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ B2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
       => ( ( ord_less @ real @ Y @ ( log2 @ B2 @ X ) )
          = ( ord_less @ real @ ( powr @ real @ B2 @ Y ) @ X ) ) ) ) ).

% less_log_iff
thf(fact_1539_log__less__iff,axiom,
    ! [B2: real,X: real,Y: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ B2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
       => ( ( ord_less @ real @ ( log2 @ B2 @ X ) @ Y )
          = ( ord_less @ real @ X @ ( powr @ real @ B2 @ Y ) ) ) ) ) ).

% log_less_iff
thf(fact_1540_less__powr__iff,axiom,
    ! [B2: real,X: real,Y: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ B2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
       => ( ( ord_less @ real @ X @ ( powr @ real @ B2 @ Y ) )
          = ( ord_less @ real @ ( log2 @ B2 @ X ) @ Y ) ) ) ) ).

% less_powr_iff
thf(fact_1541_powr__less__iff,axiom,
    ! [B2: real,X: real,Y: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ B2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
       => ( ( ord_less @ real @ ( powr @ real @ B2 @ Y ) @ X )
          = ( ord_less @ real @ Y @ ( log2 @ B2 @ X ) ) ) ) ) ).

% powr_less_iff
thf(fact_1542_field__le__mult__one__interval,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A,Y: A] :
          ( ! [Z3: A] :
              ( ( ord_less @ A @ ( zero_zero @ A ) @ Z3 )
             => ( ( ord_less @ A @ Z3 @ ( one_one @ A ) )
               => ( ord_less_eq @ A @ ( times_times @ A @ Z3 @ X ) @ Y ) ) )
         => ( ord_less_eq @ A @ X @ Y ) ) ) ).

% field_le_mult_one_interval
thf(fact_1543_mult__less__cancel__right2,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A,C2: A] :
          ( ( ord_less @ A @ ( times_times @ A @ A2 @ C2 ) @ C2 )
          = ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less @ A @ A2 @ ( one_one @ A ) ) )
            & ( ( ord_less_eq @ A @ C2 @ ( zero_zero @ A ) )
             => ( ord_less @ A @ ( one_one @ A ) @ A2 ) ) ) ) ) ).

% mult_less_cancel_right2
thf(fact_1544_mult__less__cancel__right1,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [C2: A,B2: A] :
          ( ( ord_less @ A @ C2 @ ( times_times @ A @ B2 @ C2 ) )
          = ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less @ A @ ( one_one @ A ) @ B2 ) )
            & ( ( ord_less_eq @ A @ C2 @ ( zero_zero @ A ) )
             => ( ord_less @ A @ B2 @ ( one_one @ A ) ) ) ) ) ) ).

% mult_less_cancel_right1
thf(fact_1545_mult__less__cancel__left2,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [C2: A,A2: A] :
          ( ( ord_less @ A @ ( times_times @ A @ C2 @ A2 ) @ C2 )
          = ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less @ A @ A2 @ ( one_one @ A ) ) )
            & ( ( ord_less_eq @ A @ C2 @ ( zero_zero @ A ) )
             => ( ord_less @ A @ ( one_one @ A ) @ A2 ) ) ) ) ) ).

% mult_less_cancel_left2
thf(fact_1546_mult__less__cancel__left1,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [C2: A,B2: A] :
          ( ( ord_less @ A @ C2 @ ( times_times @ A @ C2 @ B2 ) )
          = ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less @ A @ ( one_one @ A ) @ B2 ) )
            & ( ( ord_less_eq @ A @ C2 @ ( zero_zero @ A ) )
             => ( ord_less @ A @ B2 @ ( one_one @ A ) ) ) ) ) ) ).

% mult_less_cancel_left1
thf(fact_1547_mult__le__cancel__right2,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A,C2: A] :
          ( ( ord_less_eq @ A @ ( times_times @ A @ A2 @ C2 ) @ C2 )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less_eq @ A @ A2 @ ( one_one @ A ) ) )
            & ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
             => ( ord_less_eq @ A @ ( one_one @ A ) @ A2 ) ) ) ) ) ).

% mult_le_cancel_right2
thf(fact_1548_mult__le__cancel__right1,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [C2: A,B2: A] :
          ( ( ord_less_eq @ A @ C2 @ ( times_times @ A @ B2 @ C2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less_eq @ A @ ( one_one @ A ) @ B2 ) )
            & ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
             => ( ord_less_eq @ A @ B2 @ ( one_one @ A ) ) ) ) ) ) ).

% mult_le_cancel_right1
thf(fact_1549_mult__le__cancel__left2,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [C2: A,A2: A] :
          ( ( ord_less_eq @ A @ ( times_times @ A @ C2 @ A2 ) @ C2 )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less_eq @ A @ A2 @ ( one_one @ A ) ) )
            & ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
             => ( ord_less_eq @ A @ ( one_one @ A ) @ A2 ) ) ) ) ) ).

% mult_le_cancel_left2
thf(fact_1550_mult__le__cancel__left1,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [C2: A,B2: A] :
          ( ( ord_less_eq @ A @ C2 @ ( times_times @ A @ C2 @ B2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less_eq @ A @ ( one_one @ A ) @ B2 ) )
            & ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
             => ( ord_less_eq @ A @ B2 @ ( one_one @ A ) ) ) ) ) ) ).

% mult_le_cancel_left1
thf(fact_1551_divide__left__mono__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ C2 @ ( zero_zero @ A ) )
           => ( ( ord_less @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A2 @ B2 ) )
             => ( ord_less_eq @ A @ ( divide_divide @ A @ C2 @ A2 ) @ ( divide_divide @ A @ C2 @ B2 ) ) ) ) ) ) ).

% divide_left_mono_neg
thf(fact_1552_mult__imp__le__div__pos,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [Y: A,Z: A,X: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ Y )
         => ( ( ord_less_eq @ A @ ( times_times @ A @ Z @ Y ) @ X )
           => ( ord_less_eq @ A @ Z @ ( divide_divide @ A @ X @ Y ) ) ) ) ) ).

% mult_imp_le_div_pos
thf(fact_1553_mult__imp__div__pos__le,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [Y: A,X: A,Z: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ Y )
         => ( ( ord_less_eq @ A @ X @ ( times_times @ A @ Z @ Y ) )
           => ( ord_less_eq @ A @ ( divide_divide @ A @ X @ Y ) @ Z ) ) ) ) ).

% mult_imp_div_pos_le
thf(fact_1554_pos__le__divide__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
         => ( ( ord_less_eq @ A @ A2 @ ( divide_divide @ A @ B2 @ C2 ) )
            = ( ord_less_eq @ A @ ( times_times @ A @ A2 @ C2 ) @ B2 ) ) ) ) ).

% pos_le_divide_eq
thf(fact_1555_pos__divide__le__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
         => ( ( ord_less_eq @ A @ ( divide_divide @ A @ B2 @ C2 ) @ A2 )
            = ( ord_less_eq @ A @ B2 @ ( times_times @ A @ A2 @ C2 ) ) ) ) ) ).

% pos_divide_le_eq
thf(fact_1556_neg__le__divide__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ A2 @ ( divide_divide @ A @ B2 @ C2 ) )
            = ( ord_less_eq @ A @ B2 @ ( times_times @ A @ A2 @ C2 ) ) ) ) ) ).

% neg_le_divide_eq
thf(fact_1557_neg__divide__le__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ ( divide_divide @ A @ B2 @ C2 ) @ A2 )
            = ( ord_less_eq @ A @ ( times_times @ A @ A2 @ C2 ) @ B2 ) ) ) ) ).

% neg_divide_le_eq
thf(fact_1558_divide__left__mono,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( ord_less_eq @ A @ B2 @ A2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
           => ( ( ord_less @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A2 @ B2 ) )
             => ( ord_less_eq @ A @ ( divide_divide @ A @ C2 @ A2 ) @ ( divide_divide @ A @ C2 @ B2 ) ) ) ) ) ) ).

% divide_left_mono
thf(fact_1559_le__divide__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ ( divide_divide @ A @ B2 @ C2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less_eq @ A @ ( times_times @ A @ A2 @ C2 ) @ B2 ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ B2 @ ( times_times @ A @ A2 @ C2 ) ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) ) ) ) ) ) ) ) ).

% le_divide_eq
thf(fact_1560_divide__le__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( ord_less_eq @ A @ ( divide_divide @ A @ B2 @ C2 ) @ A2 )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less_eq @ A @ B2 @ ( times_times @ A @ A2 @ C2 ) ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ ( times_times @ A @ A2 @ C2 ) @ B2 ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 ) ) ) ) ) ) ) ).

% divide_le_eq
thf(fact_1561_convex__bound__le,axiom,
    ! [A: $tType] :
      ( ( linord6961819062388156250ring_1 @ A )
     => ! [X: A,A2: A,Y: A,U: A,V: A] :
          ( ( ord_less_eq @ A @ X @ A2 )
         => ( ( ord_less_eq @ A @ Y @ A2 )
           => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ U )
             => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ V )
               => ( ( ( plus_plus @ A @ U @ V )
                    = ( one_one @ A ) )
                 => ( ord_less_eq @ A @ ( plus_plus @ A @ ( times_times @ A @ U @ X ) @ ( times_times @ A @ V @ Y ) ) @ A2 ) ) ) ) ) ) ) ).

% convex_bound_le
thf(fact_1562_divide__less__eq__numeral_I1_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,C2: A,W: num] :
          ( ( ord_less @ A @ ( divide_divide @ A @ B2 @ C2 ) @ ( numeral_numeral @ A @ W ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less @ A @ B2 @ ( times_times @ A @ ( numeral_numeral @ A @ W ) @ C2 ) ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ ( times_times @ A @ ( numeral_numeral @ A @ W ) @ C2 ) @ B2 ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ ( zero_zero @ A ) @ ( numeral_numeral @ A @ W ) ) ) ) ) ) ) ) ).

% divide_less_eq_numeral(1)
thf(fact_1563_less__divide__eq__numeral_I1_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [W: num,B2: A,C2: A] :
          ( ( ord_less @ A @ ( numeral_numeral @ A @ W ) @ ( divide_divide @ A @ B2 @ C2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less @ A @ ( times_times @ A @ ( numeral_numeral @ A @ W ) @ C2 ) @ B2 ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ B2 @ ( times_times @ A @ ( numeral_numeral @ A @ W ) @ C2 ) ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ ( numeral_numeral @ A @ W ) @ ( zero_zero @ A ) ) ) ) ) ) ) ) ).

% less_divide_eq_numeral(1)
thf(fact_1564_frac__le__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [Y: A,Z: A,X: A,W: A] :
          ( ( Y
           != ( zero_zero @ A ) )
         => ( ( Z
             != ( zero_zero @ A ) )
           => ( ( ord_less_eq @ A @ ( divide_divide @ A @ X @ Y ) @ ( divide_divide @ A @ W @ Z ) )
              = ( ord_less_eq @ A @ ( divide_divide @ A @ ( minus_minus @ A @ ( times_times @ A @ X @ Z ) @ ( times_times @ A @ W @ Y ) ) @ ( times_times @ A @ Y @ Z ) ) @ ( zero_zero @ A ) ) ) ) ) ) ).

% frac_le_eq
thf(fact_1565_frac__less__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [Y: A,Z: A,X: A,W: A] :
          ( ( Y
           != ( zero_zero @ A ) )
         => ( ( Z
             != ( zero_zero @ A ) )
           => ( ( ord_less @ A @ ( divide_divide @ A @ X @ Y ) @ ( divide_divide @ A @ W @ Z ) )
              = ( ord_less @ A @ ( divide_divide @ A @ ( minus_minus @ A @ ( times_times @ A @ X @ Z ) @ ( times_times @ A @ W @ Y ) ) @ ( times_times @ A @ Y @ Z ) ) @ ( zero_zero @ A ) ) ) ) ) ) ).

% frac_less_eq
thf(fact_1566_power__Suc__less,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,N: nat] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less @ A @ A2 @ ( one_one @ A ) )
           => ( ord_less @ A @ ( times_times @ A @ A2 @ ( power_power @ A @ A2 @ N ) ) @ ( power_power @ A @ A2 @ N ) ) ) ) ) ).

% power_Suc_less
thf(fact_1567_mult__2,axiom,
    ! [A: $tType] :
      ( ( semiring_numeral @ A )
     => ! [Z: A] :
          ( ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ Z )
          = ( plus_plus @ A @ Z @ Z ) ) ) ).

% mult_2
thf(fact_1568_mult__2__right,axiom,
    ! [A: $tType] :
      ( ( semiring_numeral @ A )
     => ! [Z: A] :
          ( ( times_times @ A @ Z @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
          = ( plus_plus @ A @ Z @ Z ) ) ) ).

% mult_2_right
thf(fact_1569_left__add__twice,axiom,
    ! [A: $tType] :
      ( ( semiring_numeral @ A )
     => ! [A2: A,B2: A] :
          ( ( plus_plus @ A @ A2 @ ( plus_plus @ A @ A2 @ B2 ) )
          = ( plus_plus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) @ B2 ) ) ) ).

% left_add_twice
thf(fact_1570_is__unit__div__mult__cancel__right,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,B2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( dvd_dvd @ A @ B2 @ ( one_one @ A ) )
           => ( ( divide_divide @ A @ A2 @ ( times_times @ A @ B2 @ A2 ) )
              = ( divide_divide @ A @ ( one_one @ A ) @ B2 ) ) ) ) ) ).

% is_unit_div_mult_cancel_right
thf(fact_1571_is__unit__div__mult__cancel__left,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,B2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( dvd_dvd @ A @ B2 @ ( one_one @ A ) )
           => ( ( divide_divide @ A @ A2 @ ( times_times @ A @ A2 @ B2 ) )
              = ( divide_divide @ A @ ( one_one @ A ) @ B2 ) ) ) ) ) ).

% is_unit_div_mult_cancel_left
thf(fact_1572_is__unitE,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A,C2: A] :
          ( ( dvd_dvd @ A @ A2 @ ( one_one @ A ) )
         => ~ ( ( A2
               != ( zero_zero @ A ) )
             => ! [B4: A] :
                  ( ( B4
                   != ( zero_zero @ A ) )
                 => ( ( dvd_dvd @ A @ B4 @ ( one_one @ A ) )
                   => ( ( ( divide_divide @ A @ ( one_one @ A ) @ A2 )
                        = B4 )
                     => ( ( ( divide_divide @ A @ ( one_one @ A ) @ B4 )
                          = A2 )
                       => ( ( ( times_times @ A @ A2 @ B4 )
                            = ( one_one @ A ) )
                         => ( ( divide_divide @ A @ C2 @ A2 )
                           != ( times_times @ A @ C2 @ B4 ) ) ) ) ) ) ) ) ) ) ).

% is_unitE
thf(fact_1573_evenE,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [A2: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
         => ~ ! [B4: A] :
                ( A2
               != ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B4 ) ) ) ) ).

% evenE
thf(fact_1574_power4__eq__xxxx,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [X: A] :
          ( ( power_power @ A @ X @ ( numeral_numeral @ nat @ ( bit0 @ ( bit0 @ one2 ) ) ) )
          = ( times_times @ A @ ( times_times @ A @ ( times_times @ A @ X @ X ) @ X ) @ X ) ) ) ).

% power4_eq_xxxx
thf(fact_1575_power2__eq__square,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [A2: A] :
          ( ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
          = ( times_times @ A @ A2 @ A2 ) ) ) ).

% power2_eq_square
thf(fact_1576_power__even__eq,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [A2: A,N: nat] :
          ( ( power_power @ A @ A2 @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) )
          = ( power_power @ A @ ( power_power @ A @ A2 @ N ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ).

% power_even_eq
thf(fact_1577_less__eq__div__iff__mult__less__eq,axiom,
    ! [Q3: nat,M: nat,N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ Q3 )
     => ( ( ord_less_eq @ nat @ M @ ( divide_divide @ nat @ N @ Q3 ) )
        = ( ord_less_eq @ nat @ ( times_times @ nat @ M @ Q3 ) @ N ) ) ) ).

% less_eq_div_iff_mult_less_eq
thf(fact_1578_nat__less__add__iff1,axiom,
    ! [J: nat,I: nat,U: nat,M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ J @ I )
     => ( ( ord_less @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ I @ U ) @ M ) @ ( plus_plus @ nat @ ( times_times @ nat @ J @ U ) @ N ) )
        = ( ord_less @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ ( minus_minus @ nat @ I @ J ) @ U ) @ M ) @ N ) ) ) ).

% nat_less_add_iff1
thf(fact_1579_nat__less__add__iff2,axiom,
    ! [I: nat,J: nat,U: nat,M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ I @ J )
     => ( ( ord_less @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ I @ U ) @ M ) @ ( plus_plus @ nat @ ( times_times @ nat @ J @ U ) @ N ) )
        = ( ord_less @ nat @ M @ ( plus_plus @ nat @ ( times_times @ nat @ ( minus_minus @ nat @ J @ I ) @ U ) @ N ) ) ) ) ).

% nat_less_add_iff2
thf(fact_1580_nat__div__distrib,axiom,
    ! [X: int,Y: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ X )
     => ( ( nat2 @ ( divide_divide @ int @ X @ Y ) )
        = ( divide_divide @ nat @ ( nat2 @ X ) @ ( nat2 @ Y ) ) ) ) ).

% nat_div_distrib
thf(fact_1581_nat__div__distrib_H,axiom,
    ! [Y: int,X: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Y )
     => ( ( nat2 @ ( divide_divide @ int @ X @ Y ) )
        = ( divide_divide @ nat @ ( nat2 @ X ) @ ( nat2 @ Y ) ) ) ) ).

% nat_div_distrib'
thf(fact_1582_real__of__nat__div2,axiom,
    ! [N: nat,X: nat] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( minus_minus @ real @ ( divide_divide @ real @ ( semiring_1_of_nat @ real @ N ) @ ( semiring_1_of_nat @ real @ X ) ) @ ( semiring_1_of_nat @ real @ ( divide_divide @ nat @ N @ X ) ) ) ) ).

% real_of_nat_div2
thf(fact_1583_dividend__less__times__div,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ord_less @ nat @ M @ ( plus_plus @ nat @ N @ ( times_times @ nat @ N @ ( divide_divide @ nat @ M @ N ) ) ) ) ) ).

% dividend_less_times_div
thf(fact_1584_dividend__less__div__times,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ord_less @ nat @ M @ ( plus_plus @ nat @ N @ ( times_times @ nat @ ( divide_divide @ nat @ M @ N ) @ N ) ) ) ) ).

% dividend_less_div_times
thf(fact_1585_split__div,axiom,
    ! [P: nat > $o,M: nat,N: nat] :
      ( ( P @ ( divide_divide @ nat @ M @ N ) )
      = ( ( ( N
            = ( zero_zero @ nat ) )
         => ( P @ ( zero_zero @ nat ) ) )
        & ( ( N
           != ( zero_zero @ nat ) )
         => ! [I4: nat,J3: nat] :
              ( ( ord_less @ nat @ J3 @ N )
             => ( ( M
                  = ( plus_plus @ nat @ ( times_times @ nat @ N @ I4 ) @ J3 ) )
               => ( P @ I4 ) ) ) ) ) ) ).

% split_div
thf(fact_1586_log__divide,axiom,
    ! [A2: real,X: real,Y: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
     => ( ( A2
         != ( one_one @ real ) )
       => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
         => ( ( ord_less @ real @ ( zero_zero @ real ) @ Y )
           => ( ( log2 @ A2 @ ( divide_divide @ real @ X @ Y ) )
              = ( minus_minus @ real @ ( log2 @ A2 @ X ) @ ( log2 @ A2 @ Y ) ) ) ) ) ) ) ).

% log_divide
thf(fact_1587_log__base__change,axiom,
    ! [A2: real,B2: real,X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
     => ( ( A2
         != ( one_one @ real ) )
       => ( ( log2 @ B2 @ X )
          = ( divide_divide @ real @ ( log2 @ A2 @ X ) @ ( log2 @ A2 @ B2 ) ) ) ) ) ).

% log_base_change
thf(fact_1588_real__of__nat__div3,axiom,
    ! [N: nat,X: nat] : ( ord_less_eq @ real @ ( minus_minus @ real @ ( divide_divide @ real @ ( semiring_1_of_nat @ real @ N ) @ ( semiring_1_of_nat @ real @ X ) ) @ ( semiring_1_of_nat @ real @ ( divide_divide @ nat @ N @ X ) ) ) @ ( one_one @ real ) ) ).

% real_of_nat_div3
thf(fact_1589_mult__eq__if,axiom,
    ( ( times_times @ nat )
    = ( ^ [M3: nat,N3: nat] :
          ( if @ nat
          @ ( M3
            = ( zero_zero @ nat ) )
          @ ( zero_zero @ nat )
          @ ( plus_plus @ nat @ N3 @ ( times_times @ nat @ ( minus_minus @ nat @ M3 @ ( one_one @ nat ) ) @ N3 ) ) ) ) ) ).

% mult_eq_if
thf(fact_1590_dvd__mult__cancel2,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M )
     => ( ( dvd_dvd @ nat @ ( times_times @ nat @ N @ M ) @ M )
        = ( N
          = ( one_one @ nat ) ) ) ) ).

% dvd_mult_cancel2
thf(fact_1591_dvd__mult__cancel1,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M )
     => ( ( dvd_dvd @ nat @ ( times_times @ nat @ M @ N ) @ M )
        = ( N
          = ( one_one @ nat ) ) ) ) ).

% dvd_mult_cancel1
thf(fact_1592_dvd__minus__add,axiom,
    ! [Q3: nat,N: nat,R2: nat,M: nat] :
      ( ( ord_less_eq @ nat @ Q3 @ N )
     => ( ( ord_less_eq @ nat @ Q3 @ ( times_times @ nat @ R2 @ M ) )
       => ( ( dvd_dvd @ nat @ M @ ( minus_minus @ nat @ N @ Q3 ) )
          = ( dvd_dvd @ nat @ M @ ( plus_plus @ nat @ N @ ( minus_minus @ nat @ ( times_times @ nat @ R2 @ M ) @ Q3 ) ) ) ) ) ) ).

% dvd_minus_add
thf(fact_1593_powr__le__iff,axiom,
    ! [B2: real,X: real,Y: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ B2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
       => ( ( ord_less_eq @ real @ ( powr @ real @ B2 @ Y ) @ X )
          = ( ord_less_eq @ real @ Y @ ( log2 @ B2 @ X ) ) ) ) ) ).

% powr_le_iff
thf(fact_1594_le__powr__iff,axiom,
    ! [B2: real,X: real,Y: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ B2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
       => ( ( ord_less_eq @ real @ X @ ( powr @ real @ B2 @ Y ) )
          = ( ord_less_eq @ real @ ( log2 @ B2 @ X ) @ Y ) ) ) ) ).

% le_powr_iff
thf(fact_1595_log__le__iff,axiom,
    ! [B2: real,X: real,Y: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ B2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
       => ( ( ord_less_eq @ real @ ( log2 @ B2 @ X ) @ Y )
          = ( ord_less_eq @ real @ X @ ( powr @ real @ B2 @ Y ) ) ) ) ) ).

% log_le_iff
thf(fact_1596_le__log__iff,axiom,
    ! [B2: real,X: real,Y: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ B2 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
       => ( ( ord_less_eq @ real @ Y @ ( log2 @ B2 @ X ) )
          = ( ord_less_eq @ real @ ( powr @ real @ B2 @ Y ) @ X ) ) ) ) ).

% le_log_iff
thf(fact_1597_convex__bound__lt,axiom,
    ! [A: $tType] :
      ( ( linord715952674999750819strict @ A )
     => ! [X: A,A2: A,Y: A,U: A,V: A] :
          ( ( ord_less @ A @ X @ A2 )
         => ( ( ord_less @ A @ Y @ A2 )
           => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ U )
             => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ V )
               => ( ( ( plus_plus @ A @ U @ V )
                    = ( one_one @ A ) )
                 => ( ord_less @ A @ ( plus_plus @ A @ ( times_times @ A @ U @ X ) @ ( times_times @ A @ V @ Y ) ) @ A2 ) ) ) ) ) ) ) ).

% convex_bound_lt
thf(fact_1598_divide__le__eq__numeral_I1_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,C2: A,W: num] :
          ( ( ord_less_eq @ A @ ( divide_divide @ A @ B2 @ C2 ) @ ( numeral_numeral @ A @ W ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less_eq @ A @ B2 @ ( times_times @ A @ ( numeral_numeral @ A @ W ) @ C2 ) ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ ( times_times @ A @ ( numeral_numeral @ A @ W ) @ C2 ) @ B2 ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( numeral_numeral @ A @ W ) ) ) ) ) ) ) ) ).

% divide_le_eq_numeral(1)
thf(fact_1599_le__divide__eq__numeral_I1_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [W: num,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ ( numeral_numeral @ A @ W ) @ ( divide_divide @ A @ B2 @ C2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less_eq @ A @ ( times_times @ A @ ( numeral_numeral @ A @ W ) @ C2 ) @ B2 ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ B2 @ ( times_times @ A @ ( numeral_numeral @ A @ W ) @ C2 ) ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ ( numeral_numeral @ A @ W ) @ ( zero_zero @ A ) ) ) ) ) ) ) ) ).

% le_divide_eq_numeral(1)
thf(fact_1600_scaling__mono,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [U: A,V: A,R2: A,S2: A] :
          ( ( ord_less_eq @ A @ U @ V )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ R2 )
           => ( ( ord_less_eq @ A @ R2 @ S2 )
             => ( ord_less_eq @ A @ ( plus_plus @ A @ U @ ( divide_divide @ A @ ( times_times @ A @ R2 @ ( minus_minus @ A @ V @ U ) ) @ S2 ) ) @ V ) ) ) ) ) ).

% scaling_mono
thf(fact_1601_even__two__times__div__two,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [A2: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
         => ( ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) )
            = A2 ) ) ) ).

% even_two_times_div_two
thf(fact_1602_power__eq__if,axiom,
    ! [A: $tType] :
      ( ( power @ A )
     => ( ( power_power @ A )
        = ( ^ [P5: A,M3: nat] :
              ( if @ A
              @ ( M3
                = ( zero_zero @ nat ) )
              @ ( one_one @ A )
              @ ( times_times @ A @ P5 @ ( power_power @ A @ P5 @ ( minus_minus @ nat @ M3 @ ( one_one @ nat ) ) ) ) ) ) ) ) ).

% power_eq_if
thf(fact_1603_power__minus__mult,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [N: nat,A2: A] :
          ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
         => ( ( times_times @ A @ ( power_power @ A @ A2 @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) ) @ A2 )
            = ( power_power @ A @ A2 @ N ) ) ) ) ).

% power_minus_mult
thf(fact_1604_log__base__pow,axiom,
    ! [A2: real,N: nat,X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
     => ( ( log2 @ ( power_power @ real @ A2 @ N ) @ X )
        = ( divide_divide @ real @ ( log2 @ A2 @ X ) @ ( semiring_1_of_nat @ real @ N ) ) ) ) ).

% log_base_pow
thf(fact_1605_oddE,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [A2: A] :
          ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
         => ~ ! [B4: A] :
                ( A2
               != ( plus_plus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B4 ) @ ( one_one @ A ) ) ) ) ) ).

% oddE
thf(fact_1606_power2__sum,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [X: A,Y: A] :
          ( ( power_power @ A @ ( plus_plus @ A @ X @ Y ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
          = ( plus_plus @ A @ ( plus_plus @ A @ ( power_power @ A @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ A @ Y @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( times_times @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ X ) @ Y ) ) ) ) ).

% power2_sum
thf(fact_1607_zero__le__even__power_H,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A,N: nat] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( power_power @ A @ A2 @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ) ) ).

% zero_le_even_power'
thf(fact_1608_floor__divide__lower,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [Q3: A,P6: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ Q3 )
         => ( ord_less_eq @ A @ ( times_times @ A @ ( ring_1_of_int @ A @ ( archim6421214686448440834_floor @ A @ ( divide_divide @ A @ P6 @ Q3 ) ) ) @ Q3 ) @ P6 ) ) ) ).

% floor_divide_lower
thf(fact_1609_ceiling__divide__upper,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [Q3: A,P6: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ Q3 )
         => ( ord_less_eq @ A @ P6 @ ( times_times @ A @ ( ring_1_of_int @ A @ ( archimedean_ceiling @ A @ ( divide_divide @ A @ P6 @ Q3 ) ) ) @ Q3 ) ) ) ) ).

% ceiling_divide_upper
thf(fact_1610_lemma__real__divide__sqrt__less,axiom,
    ! [U: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ U )
     => ( ord_less @ real @ ( divide_divide @ real @ U @ ( sqrt @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ U ) ) ).

% lemma_real_divide_sqrt_less
thf(fact_1611_div__pos__geq,axiom,
    ! [L: int,K: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ L )
     => ( ( ord_less_eq @ int @ L @ K )
       => ( ( divide_divide @ int @ K @ L )
          = ( plus_plus @ int @ ( divide_divide @ int @ ( minus_minus @ int @ K @ L ) @ L ) @ ( one_one @ int ) ) ) ) ) ).

% div_pos_geq
thf(fact_1612_arsinh__real__def,axiom,
    ( ( arsinh @ real )
    = ( ^ [X2: real] : ( ln_ln @ real @ ( plus_plus @ real @ X2 @ ( sqrt @ ( plus_plus @ real @ ( power_power @ real @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ real ) ) ) ) ) ) ) ).

% arsinh_real_def
thf(fact_1613_sum__squares__bound,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A,Y: A] : ( ord_less_eq @ A @ ( times_times @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ X ) @ Y ) @ ( plus_plus @ A @ ( power_power @ A @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ A @ Y @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% sum_squares_bound
thf(fact_1614_power2__diff,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [X: A,Y: A] :
          ( ( power_power @ A @ ( minus_minus @ A @ X @ Y ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
          = ( minus_minus @ A @ ( plus_plus @ A @ ( power_power @ A @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ A @ Y @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( times_times @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ X ) @ Y ) ) ) ) ).

% power2_diff
thf(fact_1615_floor__divide__upper,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [Q3: A,P6: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ Q3 )
         => ( ord_less @ A @ P6 @ ( times_times @ A @ ( plus_plus @ A @ ( ring_1_of_int @ A @ ( archim6421214686448440834_floor @ A @ ( divide_divide @ A @ P6 @ Q3 ) ) ) @ ( one_one @ A ) ) @ Q3 ) ) ) ) ).

% floor_divide_upper
thf(fact_1616_ceiling__divide__lower,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [Q3: A,P6: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ Q3 )
         => ( ord_less @ A @ ( times_times @ A @ ( minus_minus @ A @ ( ring_1_of_int @ A @ ( archimedean_ceiling @ A @ ( divide_divide @ A @ P6 @ Q3 ) ) ) @ ( one_one @ A ) ) @ Q3 ) @ P6 ) ) ) ).

% ceiling_divide_lower
thf(fact_1617_ln__one__plus__pos__lower__bound,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less_eq @ real @ X @ ( one_one @ real ) )
       => ( ord_less_eq @ real @ ( minus_minus @ real @ X @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( ln_ln @ real @ ( plus_plus @ real @ ( one_one @ real ) @ X ) ) ) ) ) ).

% ln_one_plus_pos_lower_bound
thf(fact_1618_arcosh__real__def,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( one_one @ real ) @ X )
     => ( ( arcosh @ real @ X )
        = ( ln_ln @ real @ ( plus_plus @ real @ X @ ( sqrt @ ( minus_minus @ real @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ real ) ) ) ) ) ) ) ).

% arcosh_real_def
thf(fact_1619_floor__log__eq__powr__iff,axiom,
    ! [X: real,B2: real,K: int] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less @ real @ ( one_one @ real ) @ B2 )
       => ( ( ( archim6421214686448440834_floor @ real @ ( log2 @ B2 @ X ) )
            = K )
          = ( ( ord_less_eq @ real @ ( powr @ real @ B2 @ ( ring_1_of_int @ real @ K ) ) @ X )
            & ( ord_less @ real @ X @ ( powr @ real @ B2 @ ( ring_1_of_int @ real @ ( plus_plus @ int @ K @ ( one_one @ int ) ) ) ) ) ) ) ) ) ).

% floor_log_eq_powr_iff
thf(fact_1620_arith__geo__mean,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [U: A,X: A,Y: A] :
          ( ( ( power_power @ A @ U @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
            = ( times_times @ A @ X @ Y ) )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X )
           => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ Y )
             => ( ord_less_eq @ A @ U @ ( divide_divide @ A @ ( plus_plus @ A @ X @ Y ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% arith_geo_mean
thf(fact_1621_round__def,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ( ( archimedean_round @ A )
        = ( ^ [X2: A] : ( archim6421214686448440834_floor @ A @ ( plus_plus @ A @ X2 @ ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% round_def
thf(fact_1622_even__mult__exp__div__exp__iff,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A,M: nat,N: nat] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( divide_divide @ A @ ( times_times @ A @ A2 @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M ) ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) ) )
          = ( ( ord_less @ nat @ N @ M )
            | ( ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N )
              = ( zero_zero @ A ) )
            | ( ( ord_less_eq @ nat @ M @ N )
              & ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( divide_divide @ A @ A2 @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ N @ M ) ) ) ) ) ) ) ) ).

% even_mult_exp_div_exp_iff
thf(fact_1623_sqrt__sum__squares__half__less,axiom,
    ! [X: real,U: real,Y: real] :
      ( ( ord_less @ real @ X @ ( divide_divide @ real @ U @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
     => ( ( ord_less @ real @ Y @ ( divide_divide @ real @ U @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
       => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
         => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y )
           => ( ord_less @ real @ ( sqrt @ ( plus_plus @ real @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Y @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ U ) ) ) ) ) ).

% sqrt_sum_squares_half_less
thf(fact_1624_real__average__minus__second,axiom,
    ! [B2: real,A2: real] :
      ( ( minus_minus @ real @ ( divide_divide @ real @ ( plus_plus @ real @ B2 @ A2 ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ A2 )
      = ( divide_divide @ real @ ( minus_minus @ real @ B2 @ A2 ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ).

% real_average_minus_second
thf(fact_1625_real__average__minus__first,axiom,
    ! [A2: real,B2: real] :
      ( ( minus_minus @ real @ ( divide_divide @ real @ ( plus_plus @ real @ A2 @ B2 ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ A2 )
      = ( divide_divide @ real @ ( minus_minus @ real @ B2 @ A2 ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ).

% real_average_minus_first
thf(fact_1626_set__bit__0,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A] :
          ( ( bit_se5668285175392031749et_bit @ A @ ( zero_zero @ nat ) @ A2 )
          = ( plus_plus @ A @ ( one_one @ A ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% set_bit_0
thf(fact_1627_ln__2__less__1,axiom,
    ord_less @ real @ ( ln_ln @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( one_one @ real ) ).

% ln_2_less_1
thf(fact_1628_low__inv,axiom,
    ! [X: nat,N: nat,Y: nat] :
      ( ( ord_less @ nat @ X @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) )
     => ( ( vEBT_VEBT_low @ ( plus_plus @ nat @ ( times_times @ nat @ Y @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) @ X ) @ N )
        = X ) ) ).

% low_inv
thf(fact_1629_unset__bit__0,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A] :
          ( ( bit_se2638667681897837118et_bit @ A @ ( zero_zero @ nat ) @ A2 )
          = ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ).

% unset_bit_0
thf(fact_1630_Bolzano,axiom,
    ! [A2: real,B2: real,P: real > real > $o] :
      ( ( ord_less_eq @ real @ A2 @ B2 )
     => ( ! [A5: real,B4: real,C3: real] :
            ( ( P @ A5 @ B4 )
           => ( ( P @ B4 @ C3 )
             => ( ( ord_less_eq @ real @ A5 @ B4 )
               => ( ( ord_less_eq @ real @ B4 @ C3 )
                 => ( P @ A5 @ C3 ) ) ) ) )
       => ( ! [X3: real] :
              ( ( ord_less_eq @ real @ A2 @ X3 )
             => ( ( ord_less_eq @ real @ X3 @ B2 )
               => ? [D3: real] :
                    ( ( ord_less @ real @ ( zero_zero @ real ) @ D3 )
                    & ! [A5: real,B4: real] :
                        ( ( ( ord_less_eq @ real @ A5 @ X3 )
                          & ( ord_less_eq @ real @ X3 @ B4 )
                          & ( ord_less @ real @ ( minus_minus @ real @ B4 @ A5 ) @ D3 ) )
                       => ( P @ A5 @ B4 ) ) ) ) )
         => ( P @ A2 @ B2 ) ) ) ) ).

% Bolzano
thf(fact_1631_mult__le__cancel__iff1,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [Z: A,X: A,Y: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ Z )
         => ( ( ord_less_eq @ A @ ( times_times @ A @ X @ Z ) @ ( times_times @ A @ Y @ Z ) )
            = ( ord_less_eq @ A @ X @ Y ) ) ) ) ).

% mult_le_cancel_iff1
thf(fact_1632_mult__le__cancel__iff2,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [Z: A,X: A,Y: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ Z )
         => ( ( ord_less_eq @ A @ ( times_times @ A @ Z @ X ) @ ( times_times @ A @ Z @ Y ) )
            = ( ord_less_eq @ A @ X @ Y ) ) ) ) ).

% mult_le_cancel_iff2
thf(fact_1633_bit__split__inv,axiom,
    ! [X: nat,D2: nat] :
      ( ( vEBT_VEBT_bit_concat @ ( vEBT_VEBT_high @ X @ D2 ) @ ( vEBT_VEBT_low @ X @ D2 ) @ D2 )
      = X ) ).

% bit_split_inv
thf(fact_1634_real__divide__square__eq,axiom,
    ! [R2: real,A2: real] :
      ( ( divide_divide @ real @ ( times_times @ real @ R2 @ A2 ) @ ( times_times @ real @ R2 @ R2 ) )
      = ( divide_divide @ real @ A2 @ R2 ) ) ).

% real_divide_square_eq
thf(fact_1635_not__real__square__gt__zero,axiom,
    ! [X: real] :
      ( ( ~ ( ord_less @ real @ ( zero_zero @ real ) @ ( times_times @ real @ X @ X ) ) )
      = ( X
        = ( zero_zero @ real ) ) ) ).

% not_real_square_gt_zero
thf(fact_1636_unset__bit__nonnegative__int__iff,axiom,
    ! [N: nat,K: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( bit_se2638667681897837118et_bit @ int @ N @ K ) )
      = ( ord_less_eq @ int @ ( zero_zero @ int ) @ K ) ) ).

% unset_bit_nonnegative_int_iff
thf(fact_1637_set__bit__nonnegative__int__iff,axiom,
    ! [N: nat,K: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( bit_se5668285175392031749et_bit @ int @ N @ K ) )
      = ( ord_less_eq @ int @ ( zero_zero @ int ) @ K ) ) ).

% set_bit_nonnegative_int_iff
thf(fact_1638_unset__bit__negative__int__iff,axiom,
    ! [N: nat,K: int] :
      ( ( ord_less @ int @ ( bit_se2638667681897837118et_bit @ int @ N @ K ) @ ( zero_zero @ int ) )
      = ( ord_less @ int @ K @ ( zero_zero @ int ) ) ) ).

% unset_bit_negative_int_iff
thf(fact_1639_set__bit__negative__int__iff,axiom,
    ! [N: nat,K: int] :
      ( ( ord_less @ int @ ( bit_se5668285175392031749et_bit @ int @ N @ K ) @ ( zero_zero @ int ) )
      = ( ord_less @ int @ K @ ( zero_zero @ int ) ) ) ).

% set_bit_negative_int_iff
thf(fact_1640_semiring__norm_I13_J,axiom,
    ! [M: num,N: num] :
      ( ( times_times @ num @ ( bit0 @ M ) @ ( bit0 @ N ) )
      = ( bit0 @ ( bit0 @ ( times_times @ num @ M @ N ) ) ) ) ).

% semiring_norm(13)
thf(fact_1641_semiring__norm_I11_J,axiom,
    ! [M: num] :
      ( ( times_times @ num @ M @ one2 )
      = M ) ).

% semiring_norm(11)
thf(fact_1642_semiring__norm_I12_J,axiom,
    ! [N: num] :
      ( ( times_times @ num @ one2 @ N )
      = N ) ).

% semiring_norm(12)
thf(fact_1643_num__double,axiom,
    ! [N: num] :
      ( ( times_times @ num @ ( bit0 @ one2 ) @ N )
      = ( bit0 @ N ) ) ).

% num_double
thf(fact_1644_power__mult__numeral,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [A2: A,M: num,N: num] :
          ( ( power_power @ A @ ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ M ) ) @ ( numeral_numeral @ nat @ N ) )
          = ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ ( times_times @ num @ M @ N ) ) ) ) ) ).

% power_mult_numeral
thf(fact_1645_real__sqrt__sum__squares__mult__squared__eq,axiom,
    ! [X: real,Y: real,Xa: real,Ya: real] :
      ( ( power_power @ real @ ( sqrt @ ( times_times @ real @ ( plus_plus @ real @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Y @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( plus_plus @ real @ ( power_power @ real @ Xa @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Ya @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
      = ( times_times @ real @ ( plus_plus @ real @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Y @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( plus_plus @ real @ ( power_power @ real @ Xa @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Ya @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% real_sqrt_sum_squares_mult_squared_eq
thf(fact_1646_times__int__code_I2_J,axiom,
    ! [L: int] :
      ( ( times_times @ int @ ( zero_zero @ int ) @ L )
      = ( zero_zero @ int ) ) ).

% times_int_code(2)
thf(fact_1647_times__int__code_I1_J,axiom,
    ! [K: int] :
      ( ( times_times @ int @ K @ ( zero_zero @ int ) )
      = ( zero_zero @ int ) ) ).

% times_int_code(1)
thf(fact_1648_int__distrib_I1_J,axiom,
    ! [Z1: int,Z22: int,W: int] :
      ( ( times_times @ int @ ( plus_plus @ int @ Z1 @ Z22 ) @ W )
      = ( plus_plus @ int @ ( times_times @ int @ Z1 @ W ) @ ( times_times @ int @ Z22 @ W ) ) ) ).

% int_distrib(1)
thf(fact_1649_int__distrib_I2_J,axiom,
    ! [W: int,Z1: int,Z22: int] :
      ( ( times_times @ int @ W @ ( plus_plus @ int @ Z1 @ Z22 ) )
      = ( plus_plus @ int @ ( times_times @ int @ W @ Z1 ) @ ( times_times @ int @ W @ Z22 ) ) ) ).

% int_distrib(2)
thf(fact_1650_int__distrib_I3_J,axiom,
    ! [Z1: int,Z22: int,W: int] :
      ( ( times_times @ int @ ( minus_minus @ int @ Z1 @ Z22 ) @ W )
      = ( minus_minus @ int @ ( times_times @ int @ Z1 @ W ) @ ( times_times @ int @ Z22 @ W ) ) ) ).

% int_distrib(3)
thf(fact_1651_int__distrib_I4_J,axiom,
    ! [W: int,Z1: int,Z22: int] :
      ( ( times_times @ int @ W @ ( minus_minus @ int @ Z1 @ Z22 ) )
      = ( minus_minus @ int @ ( times_times @ int @ W @ Z1 ) @ ( times_times @ int @ W @ Z22 ) ) ) ).

% int_distrib(4)
thf(fact_1652_real__sqrt__mult,axiom,
    ! [X: real,Y: real] :
      ( ( sqrt @ ( times_times @ real @ X @ Y ) )
      = ( times_times @ real @ ( sqrt @ X ) @ ( sqrt @ Y ) ) ) ).

% real_sqrt_mult
thf(fact_1653_take__bit__mult,axiom,
    ! [N: nat,K: int,L: int] :
      ( ( bit_se2584673776208193580ke_bit @ int @ N @ ( times_times @ int @ ( bit_se2584673776208193580ke_bit @ int @ N @ K ) @ ( bit_se2584673776208193580ke_bit @ int @ N @ L ) ) )
      = ( bit_se2584673776208193580ke_bit @ int @ N @ ( times_times @ int @ K @ L ) ) ) ).

% take_bit_mult
thf(fact_1654_imult__is__0,axiom,
    ! [M: extended_enat,N: extended_enat] :
      ( ( ( times_times @ extended_enat @ M @ N )
        = ( zero_zero @ extended_enat ) )
      = ( ( M
          = ( zero_zero @ extended_enat ) )
        | ( N
          = ( zero_zero @ extended_enat ) ) ) ) ).

% imult_is_0
thf(fact_1655_unset__bit__nat__def,axiom,
    ( ( bit_se2638667681897837118et_bit @ nat )
    = ( ^ [M3: nat,N3: nat] : ( nat2 @ ( bit_se2638667681897837118et_bit @ int @ M3 @ ( semiring_1_of_nat @ int @ N3 ) ) ) ) ) ).

% unset_bit_nat_def
thf(fact_1656_unset__bit__less__eq,axiom,
    ! [N: nat,K: int] : ( ord_less_eq @ int @ ( bit_se2638667681897837118et_bit @ int @ N @ K ) @ K ) ).

% unset_bit_less_eq
thf(fact_1657_set__bit__greater__eq,axiom,
    ! [K: int,N: nat] : ( ord_less_eq @ int @ K @ ( bit_se5668285175392031749et_bit @ int @ N @ K ) ) ).

% set_bit_greater_eq
thf(fact_1658_div__mult2__numeral__eq,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [A2: A,K: num,L: num] :
          ( ( divide_divide @ A @ ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ K ) ) @ ( numeral_numeral @ A @ L ) )
          = ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( times_times @ num @ K @ L ) ) ) ) ) ).

% div_mult2_numeral_eq
thf(fact_1659_zmult__zless__mono2,axiom,
    ! [I: int,J: int,K: int] :
      ( ( ord_less @ int @ I @ J )
     => ( ( ord_less @ int @ ( zero_zero @ int ) @ K )
       => ( ord_less @ int @ ( times_times @ int @ K @ I ) @ ( times_times @ int @ K @ J ) ) ) ) ).

% zmult_zless_mono2
thf(fact_1660_int__ops_I7_J,axiom,
    ! [A2: nat,B2: nat] :
      ( ( semiring_1_of_nat @ int @ ( times_times @ nat @ A2 @ B2 ) )
      = ( times_times @ int @ ( semiring_1_of_nat @ int @ A2 ) @ ( semiring_1_of_nat @ int @ B2 ) ) ) ).

% int_ops(7)
thf(fact_1661_zdvd__mult__cancel,axiom,
    ! [K: int,M: int,N: int] :
      ( ( dvd_dvd @ int @ ( times_times @ int @ K @ M ) @ ( times_times @ int @ K @ N ) )
     => ( ( K
         != ( zero_zero @ int ) )
       => ( dvd_dvd @ int @ M @ N ) ) ) ).

% zdvd_mult_cancel
thf(fact_1662_zdvd__mono,axiom,
    ! [K: int,M: int,T2: int] :
      ( ( K
       != ( zero_zero @ int ) )
     => ( ( dvd_dvd @ int @ M @ T2 )
        = ( dvd_dvd @ int @ ( times_times @ int @ K @ M ) @ ( times_times @ int @ K @ T2 ) ) ) ) ).

% zdvd_mono
thf(fact_1663_ln__powr,axiom,
    ! [X: real,Y: real] :
      ( ( X
       != ( zero_zero @ real ) )
     => ( ( ln_ln @ real @ ( powr @ real @ X @ Y ) )
        = ( times_times @ real @ Y @ ( ln_ln @ real @ X ) ) ) ) ).

% ln_powr
thf(fact_1664_zdvd__reduce,axiom,
    ! [K: int,N: int,M: int] :
      ( ( dvd_dvd @ int @ K @ ( plus_plus @ int @ N @ ( times_times @ int @ K @ M ) ) )
      = ( dvd_dvd @ int @ K @ N ) ) ).

% zdvd_reduce
thf(fact_1665_zdvd__period,axiom,
    ! [A2: int,D2: int,X: int,T2: int,C2: int] :
      ( ( dvd_dvd @ int @ A2 @ D2 )
     => ( ( dvd_dvd @ int @ A2 @ ( plus_plus @ int @ X @ T2 ) )
        = ( dvd_dvd @ int @ A2 @ ( plus_plus @ int @ ( plus_plus @ int @ X @ ( times_times @ int @ C2 @ D2 ) ) @ T2 ) ) ) ) ).

% zdvd_period
thf(fact_1666_enat__0__less__mult__iff,axiom,
    ! [M: extended_enat,N: extended_enat] :
      ( ( ord_less @ extended_enat @ ( zero_zero @ extended_enat ) @ ( times_times @ extended_enat @ M @ N ) )
      = ( ( ord_less @ extended_enat @ ( zero_zero @ extended_enat ) @ M )
        & ( ord_less @ extended_enat @ ( zero_zero @ extended_enat ) @ N ) ) ) ).

% enat_0_less_mult_iff
thf(fact_1667_ln__mult,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ Y )
       => ( ( ln_ln @ real @ ( times_times @ real @ X @ Y ) )
          = ( plus_plus @ real @ ( ln_ln @ real @ X ) @ ( ln_ln @ real @ Y ) ) ) ) ) ).

% ln_mult
thf(fact_1668_reals__Archimedean3,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ! [Y6: real] :
        ? [N2: nat] : ( ord_less @ real @ Y6 @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N2 ) @ X ) ) ) ).

% reals_Archimedean3
thf(fact_1669_pos__zmult__eq__1__iff,axiom,
    ! [M: int,N: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ M )
     => ( ( ( times_times @ int @ M @ N )
          = ( one_one @ int ) )
        = ( ( M
            = ( one_one @ int ) )
          & ( N
            = ( one_one @ int ) ) ) ) ) ).

% pos_zmult_eq_1_iff
thf(fact_1670_powr__mult,axiom,
    ! [X: real,Y: real,A2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y )
       => ( ( powr @ real @ ( times_times @ real @ X @ Y ) @ A2 )
          = ( times_times @ real @ ( powr @ real @ X @ A2 ) @ ( powr @ real @ Y @ A2 ) ) ) ) ) ).

% powr_mult
thf(fact_1671_minusinfinity,axiom,
    ! [D2: int,P1: int > $o,P: int > $o] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D2 )
     => ( ! [X3: int,K2: int] :
            ( ( P1 @ X3 )
            = ( P1 @ ( minus_minus @ int @ X3 @ ( times_times @ int @ K2 @ D2 ) ) ) )
       => ( ? [Z4: int] :
            ! [X3: int] :
              ( ( ord_less @ int @ X3 @ Z4 )
             => ( ( P @ X3 )
                = ( P1 @ X3 ) ) )
         => ( ? [X_12: int] : ( P1 @ X_12 )
           => ? [X_1: int] : ( P @ X_1 ) ) ) ) ) ).

% minusinfinity
thf(fact_1672_plusinfinity,axiom,
    ! [D2: int,P4: int > $o,P: int > $o] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D2 )
     => ( ! [X3: int,K2: int] :
            ( ( P4 @ X3 )
            = ( P4 @ ( minus_minus @ int @ X3 @ ( times_times @ int @ K2 @ D2 ) ) ) )
       => ( ? [Z4: int] :
            ! [X3: int] :
              ( ( ord_less @ int @ Z4 @ X3 )
             => ( ( P @ X3 )
                = ( P4 @ X3 ) ) )
         => ( ? [X_12: int] : ( P4 @ X_12 )
           => ? [X_1: int] : ( P @ X_1 ) ) ) ) ) ).

% plusinfinity
thf(fact_1673_zdiv__zmult2__eq,axiom,
    ! [C2: int,A2: int,B2: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ C2 )
     => ( ( divide_divide @ int @ A2 @ ( times_times @ int @ B2 @ C2 ) )
        = ( divide_divide @ int @ ( divide_divide @ int @ A2 @ B2 ) @ C2 ) ) ) ).

% zdiv_zmult2_eq
thf(fact_1674_le__real__sqrt__sumsq,axiom,
    ! [X: real,Y: real] : ( ord_less_eq @ real @ X @ ( sqrt @ ( plus_plus @ real @ ( times_times @ real @ X @ X ) @ ( times_times @ real @ Y @ Y ) ) ) ) ).

% le_real_sqrt_sumsq
thf(fact_1675_log__powr,axiom,
    ! [X: real,B2: real,Y: real] :
      ( ( X
       != ( zero_zero @ real ) )
     => ( ( log2 @ B2 @ ( powr @ real @ X @ Y ) )
        = ( times_times @ real @ Y @ ( log2 @ B2 @ X ) ) ) ) ).

% log_powr
thf(fact_1676_take__bit__unset__bit__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,M: nat,A2: A] :
          ( ( ( ord_less_eq @ nat @ N @ M )
           => ( ( bit_se2584673776208193580ke_bit @ A @ N @ ( bit_se2638667681897837118et_bit @ A @ M @ A2 ) )
              = ( bit_se2584673776208193580ke_bit @ A @ N @ A2 ) ) )
          & ( ~ ( ord_less_eq @ nat @ N @ M )
           => ( ( bit_se2584673776208193580ke_bit @ A @ N @ ( bit_se2638667681897837118et_bit @ A @ M @ A2 ) )
              = ( bit_se2638667681897837118et_bit @ A @ M @ ( bit_se2584673776208193580ke_bit @ A @ N @ A2 ) ) ) ) ) ) ).

% take_bit_unset_bit_eq
thf(fact_1677_take__bit__set__bit__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,M: nat,A2: A] :
          ( ( ( ord_less_eq @ nat @ N @ M )
           => ( ( bit_se2584673776208193580ke_bit @ A @ N @ ( bit_se5668285175392031749et_bit @ A @ M @ A2 ) )
              = ( bit_se2584673776208193580ke_bit @ A @ N @ A2 ) ) )
          & ( ~ ( ord_less_eq @ nat @ N @ M )
           => ( ( bit_se2584673776208193580ke_bit @ A @ N @ ( bit_se5668285175392031749et_bit @ A @ M @ A2 ) )
              = ( bit_se5668285175392031749et_bit @ A @ M @ ( bit_se2584673776208193580ke_bit @ A @ N @ A2 ) ) ) ) ) ) ).

% take_bit_set_bit_eq
thf(fact_1678_zmult__zless__mono2__lemma,axiom,
    ! [I: int,J: int,K: nat] :
      ( ( ord_less @ int @ I @ J )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
       => ( ord_less @ int @ ( times_times @ int @ ( semiring_1_of_nat @ int @ K ) @ I ) @ ( times_times @ int @ ( semiring_1_of_nat @ int @ K ) @ J ) ) ) ) ).

% zmult_zless_mono2_lemma
thf(fact_1679_ln__realpow,axiom,
    ! [X: real,N: nat] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( ln_ln @ real @ ( power_power @ real @ X @ N ) )
        = ( times_times @ real @ ( semiring_1_of_nat @ real @ N ) @ ( ln_ln @ real @ X ) ) ) ) ).

% ln_realpow
thf(fact_1680_incr__mult__lemma,axiom,
    ! [D2: int,P: int > $o,K: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D2 )
     => ( ! [X3: int] :
            ( ( P @ X3 )
           => ( P @ ( plus_plus @ int @ X3 @ D2 ) ) )
       => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ K )
         => ! [X5: int] :
              ( ( P @ X5 )
             => ( P @ ( plus_plus @ int @ X5 @ ( times_times @ int @ K @ D2 ) ) ) ) ) ) ) ).

% incr_mult_lemma
thf(fact_1681_q__pos__lemma,axiom,
    ! [B5: int,Q4: int,R3: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( plus_plus @ int @ ( times_times @ int @ B5 @ Q4 ) @ R3 ) )
     => ( ( ord_less @ int @ R3 @ B5 )
       => ( ( ord_less @ int @ ( zero_zero @ int ) @ B5 )
         => ( ord_less_eq @ int @ ( zero_zero @ int ) @ Q4 ) ) ) ) ).

% q_pos_lemma
thf(fact_1682_zdiv__mono2__lemma,axiom,
    ! [B2: int,Q3: int,R2: int,B5: int,Q4: int,R3: int] :
      ( ( ( plus_plus @ int @ ( times_times @ int @ B2 @ Q3 ) @ R2 )
        = ( plus_plus @ int @ ( times_times @ int @ B5 @ Q4 ) @ R3 ) )
     => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( plus_plus @ int @ ( times_times @ int @ B5 @ Q4 ) @ R3 ) )
       => ( ( ord_less @ int @ R3 @ B5 )
         => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ R2 )
           => ( ( ord_less @ int @ ( zero_zero @ int ) @ B5 )
             => ( ( ord_less_eq @ int @ B5 @ B2 )
               => ( ord_less_eq @ int @ Q3 @ Q4 ) ) ) ) ) ) ) ).

% zdiv_mono2_lemma
thf(fact_1683_zdiv__mono2__neg__lemma,axiom,
    ! [B2: int,Q3: int,R2: int,B5: int,Q4: int,R3: int] :
      ( ( ( plus_plus @ int @ ( times_times @ int @ B2 @ Q3 ) @ R2 )
        = ( plus_plus @ int @ ( times_times @ int @ B5 @ Q4 ) @ R3 ) )
     => ( ( ord_less @ int @ ( plus_plus @ int @ ( times_times @ int @ B5 @ Q4 ) @ R3 ) @ ( zero_zero @ int ) )
       => ( ( ord_less @ int @ R2 @ B2 )
         => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ R3 )
           => ( ( ord_less @ int @ ( zero_zero @ int ) @ B5 )
             => ( ( ord_less_eq @ int @ B5 @ B2 )
               => ( ord_less_eq @ int @ Q4 @ Q3 ) ) ) ) ) ) ) ).

% zdiv_mono2_neg_lemma
thf(fact_1684_unique__quotient__lemma,axiom,
    ! [B2: int,Q4: int,R3: int,Q3: int,R2: int] :
      ( ( ord_less_eq @ int @ ( plus_plus @ int @ ( times_times @ int @ B2 @ Q4 ) @ R3 ) @ ( plus_plus @ int @ ( times_times @ int @ B2 @ Q3 ) @ R2 ) )
     => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ R3 )
       => ( ( ord_less @ int @ R3 @ B2 )
         => ( ( ord_less @ int @ R2 @ B2 )
           => ( ord_less_eq @ int @ Q4 @ Q3 ) ) ) ) ) ).

% unique_quotient_lemma
thf(fact_1685_unique__quotient__lemma__neg,axiom,
    ! [B2: int,Q4: int,R3: int,Q3: int,R2: int] :
      ( ( ord_less_eq @ int @ ( plus_plus @ int @ ( times_times @ int @ B2 @ Q4 ) @ R3 ) @ ( plus_plus @ int @ ( times_times @ int @ B2 @ Q3 ) @ R2 ) )
     => ( ( ord_less_eq @ int @ R2 @ ( zero_zero @ int ) )
       => ( ( ord_less @ int @ B2 @ R2 )
         => ( ( ord_less @ int @ B2 @ R3 )
           => ( ord_less_eq @ int @ Q3 @ Q4 ) ) ) ) ) ).

% unique_quotient_lemma_neg
thf(fact_1686_log__eq__div__ln__mult__log,axiom,
    ! [A2: real,B2: real,X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
     => ( ( A2
         != ( one_one @ real ) )
       => ( ( ord_less @ real @ ( zero_zero @ real ) @ B2 )
         => ( ( B2
             != ( one_one @ real ) )
           => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
             => ( ( log2 @ A2 @ X )
                = ( times_times @ real @ ( divide_divide @ real @ ( ln_ln @ real @ B2 ) @ ( ln_ln @ real @ A2 ) ) @ ( log2 @ B2 @ X ) ) ) ) ) ) ) ) ).

% log_eq_div_ln_mult_log
thf(fact_1687_nat__mult__distrib,axiom,
    ! [Z: int,Z5: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Z )
     => ( ( nat2 @ ( times_times @ int @ Z @ Z5 ) )
        = ( times_times @ nat @ ( nat2 @ Z ) @ ( nat2 @ Z5 ) ) ) ) ).

% nat_mult_distrib
thf(fact_1688_decr__mult__lemma,axiom,
    ! [D2: int,P: int > $o,K: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D2 )
     => ( ! [X3: int] :
            ( ( P @ X3 )
           => ( P @ ( minus_minus @ int @ X3 @ D2 ) ) )
       => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ K )
         => ! [X5: int] :
              ( ( P @ X5 )
             => ( P @ ( minus_minus @ int @ X5 @ ( times_times @ int @ K @ D2 ) ) ) ) ) ) ) ).

% decr_mult_lemma
thf(fact_1689_linear__plus__1__le__power,axiom,
    ! [X: real,N: nat] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ord_less_eq @ real @ ( plus_plus @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N ) @ X ) @ ( one_one @ real ) ) @ ( power_power @ real @ ( plus_plus @ real @ X @ ( one_one @ real ) ) @ N ) ) ) ).

% linear_plus_1_le_power
thf(fact_1690_four__x__squared,axiom,
    ! [X: real] :
      ( ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
      = ( power_power @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ).

% four_x_squared
thf(fact_1691_real__archimedian__rdiv__eq__0,axiom,
    ! [X: real,C2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ C2 )
       => ( ! [M4: nat] :
              ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M4 )
             => ( ord_less_eq @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ M4 ) @ X ) @ C2 ) )
         => ( X
            = ( zero_zero @ real ) ) ) ) ) ).

% real_archimedian_rdiv_eq_0
thf(fact_1692_ln__powr__bound2,axiom,
    ! [X: real,A2: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ X )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
       => ( ord_less_eq @ real @ ( powr @ real @ ( ln_ln @ real @ X ) @ A2 ) @ ( times_times @ real @ ( powr @ real @ A2 @ A2 ) @ X ) ) ) ) ).

% ln_powr_bound2
thf(fact_1693_powr__mult__base,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( times_times @ real @ X @ ( powr @ real @ X @ Y ) )
        = ( powr @ real @ X @ ( plus_plus @ real @ ( one_one @ real ) @ Y ) ) ) ) ).

% powr_mult_base
thf(fact_1694_log__mult,axiom,
    ! [A2: real,X: real,Y: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
     => ( ( A2
         != ( one_one @ real ) )
       => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
         => ( ( ord_less @ real @ ( zero_zero @ real ) @ Y )
           => ( ( log2 @ A2 @ ( times_times @ real @ X @ Y ) )
              = ( plus_plus @ real @ ( log2 @ A2 @ X ) @ ( log2 @ A2 @ Y ) ) ) ) ) ) ) ).

% log_mult
thf(fact_1695_int__div__pos__eq,axiom,
    ! [A2: int,B2: int,Q3: int,R2: int] :
      ( ( A2
        = ( plus_plus @ int @ ( times_times @ int @ B2 @ Q3 ) @ R2 ) )
     => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ R2 )
       => ( ( ord_less @ int @ R2 @ B2 )
         => ( ( divide_divide @ int @ A2 @ B2 )
            = Q3 ) ) ) ) ).

% int_div_pos_eq
thf(fact_1696_int__div__neg__eq,axiom,
    ! [A2: int,B2: int,Q3: int,R2: int] :
      ( ( A2
        = ( plus_plus @ int @ ( times_times @ int @ B2 @ Q3 ) @ R2 ) )
     => ( ( ord_less_eq @ int @ R2 @ ( zero_zero @ int ) )
       => ( ( ord_less @ int @ B2 @ R2 )
         => ( ( divide_divide @ int @ A2 @ B2 )
            = Q3 ) ) ) ) ).

% int_div_neg_eq
thf(fact_1697_split__zdiv,axiom,
    ! [P: int > $o,N: int,K: int] :
      ( ( P @ ( divide_divide @ int @ N @ K ) )
      = ( ( ( K
            = ( zero_zero @ int ) )
         => ( P @ ( zero_zero @ int ) ) )
        & ( ( ord_less @ int @ ( zero_zero @ int ) @ K )
         => ! [I4: int,J3: int] :
              ( ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ J3 )
                & ( ord_less @ int @ J3 @ K )
                & ( N
                  = ( plus_plus @ int @ ( times_times @ int @ K @ I4 ) @ J3 ) ) )
             => ( P @ I4 ) ) )
        & ( ( ord_less @ int @ K @ ( zero_zero @ int ) )
         => ! [I4: int,J3: int] :
              ( ( ( ord_less @ int @ K @ J3 )
                & ( ord_less_eq @ int @ J3 @ ( zero_zero @ int ) )
                & ( N
                  = ( plus_plus @ int @ ( times_times @ int @ K @ I4 ) @ J3 ) ) )
             => ( P @ I4 ) ) ) ) ) ).

% split_zdiv
thf(fact_1698_log__nat__power,axiom,
    ! [X: real,B2: real,N: nat] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( log2 @ B2 @ ( power_power @ real @ X @ N ) )
        = ( times_times @ real @ ( semiring_1_of_nat @ real @ N ) @ ( log2 @ B2 @ X ) ) ) ) ).

% log_nat_power
thf(fact_1699_log__add__eq__powr,axiom,
    ! [B2: real,X: real,Y: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ B2 )
     => ( ( B2
         != ( one_one @ real ) )
       => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
         => ( ( plus_plus @ real @ ( log2 @ B2 @ X ) @ Y )
            = ( log2 @ B2 @ ( times_times @ real @ X @ ( powr @ real @ B2 @ Y ) ) ) ) ) ) ) ).

% log_add_eq_powr
thf(fact_1700_add__log__eq__powr,axiom,
    ! [B2: real,X: real,Y: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ B2 )
     => ( ( B2
         != ( one_one @ real ) )
       => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
         => ( ( plus_plus @ real @ Y @ ( log2 @ B2 @ X ) )
            = ( log2 @ B2 @ ( times_times @ real @ ( powr @ real @ B2 @ Y ) @ X ) ) ) ) ) ) ).

% add_log_eq_powr
thf(fact_1701_VEBT__internal_Oexp__split__high__low_I2_J,axiom,
    ! [X: nat,N: nat,M: nat] :
      ( ( ord_less @ nat @ X @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( plus_plus @ nat @ N @ M ) ) )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
       => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M )
         => ( ord_less @ nat @ ( vEBT_VEBT_low @ X @ N ) @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ) ) ) ).

% VEBT_internal.exp_split_high_low(2)
thf(fact_1702_L2__set__mult__ineq__lemma,axiom,
    ! [A2: real,C2: real,B2: real,D2: real] : ( ord_less_eq @ real @ ( times_times @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( times_times @ real @ A2 @ C2 ) ) @ ( times_times @ real @ B2 @ D2 ) ) @ ( plus_plus @ real @ ( times_times @ real @ ( power_power @ real @ A2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ D2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( times_times @ real @ ( power_power @ real @ B2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ C2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% L2_set_mult_ineq_lemma
thf(fact_1703_arith__geo__mean__sqrt,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y )
       => ( ord_less_eq @ real @ ( sqrt @ ( times_times @ real @ X @ Y ) ) @ ( divide_divide @ real @ ( plus_plus @ real @ X @ Y ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ).

% arith_geo_mean_sqrt
thf(fact_1704_real__sqrt__sum__squares__mult__ge__zero,axiom,
    ! [X: real,Y: real,Xa: real,Ya: real] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( sqrt @ ( times_times @ real @ ( plus_plus @ real @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Y @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( plus_plus @ real @ ( power_power @ real @ Xa @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Ya @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% real_sqrt_sum_squares_mult_ge_zero
thf(fact_1705_neg__zdiv__mult__2,axiom,
    ! [A2: int,B2: int] :
      ( ( ord_less_eq @ int @ A2 @ ( zero_zero @ int ) )
     => ( ( divide_divide @ int @ ( plus_plus @ int @ ( one_one @ int ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ B2 ) ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ A2 ) )
        = ( divide_divide @ int @ ( plus_plus @ int @ B2 @ ( one_one @ int ) ) @ A2 ) ) ) ).

% neg_zdiv_mult_2
thf(fact_1706_pos__zdiv__mult__2,axiom,
    ! [A2: int,B2: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ A2 )
     => ( ( divide_divide @ int @ ( plus_plus @ int @ ( one_one @ int ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ B2 ) ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ A2 ) )
        = ( divide_divide @ int @ B2 @ A2 ) ) ) ).

% pos_zdiv_mult_2
thf(fact_1707_even__unset__bit__iff,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M: nat,A2: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se2638667681897837118et_bit @ A @ M @ A2 ) )
          = ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
            | ( M
              = ( zero_zero @ nat ) ) ) ) ) ).

% even_unset_bit_iff
thf(fact_1708_even__set__bit__iff,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M: nat,A2: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se5668285175392031749et_bit @ A @ M @ A2 ) )
          = ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
            & ( M
             != ( zero_zero @ nat ) ) ) ) ) ).

% even_set_bit_iff
thf(fact_1709_Bernoulli__inequality__even,axiom,
    ! [N: nat,X: real] :
      ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
     => ( ord_less_eq @ real @ ( plus_plus @ real @ ( one_one @ real ) @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N ) @ X ) ) @ ( power_power @ real @ ( plus_plus @ real @ ( one_one @ real ) @ X ) @ N ) ) ) ).

% Bernoulli_inequality_even
thf(fact_1710_mult__less__iff1,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [Z: A,X: A,Y: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ Z )
         => ( ( ord_less @ A @ ( times_times @ A @ X @ Z ) @ ( times_times @ A @ Y @ Z ) )
            = ( ord_less @ A @ X @ Y ) ) ) ) ).

% mult_less_iff1
thf(fact_1711_low__def,axiom,
    ( vEBT_VEBT_low
    = ( ^ [X2: nat,N3: nat] : ( modulo_modulo @ nat @ X2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N3 ) ) ) ) ).

% low_def
thf(fact_1712_tanh__ln__real,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( tanh @ real @ ( ln_ln @ real @ X ) )
        = ( divide_divide @ real @ ( minus_minus @ real @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ real ) ) @ ( plus_plus @ real @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ real ) ) ) ) ) ).

% tanh_ln_real
thf(fact_1713_arcosh__def,axiom,
    ! [A: $tType] :
      ( ( ln @ A )
     => ( ( arcosh @ A )
        = ( ^ [X2: A] : ( ln_ln @ A @ ( plus_plus @ A @ X2 @ ( powr @ A @ ( minus_minus @ A @ ( power_power @ A @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ A ) ) @ ( real_Vector_of_real @ A @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ).

% arcosh_def
thf(fact_1714_round__altdef,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ( ( archimedean_round @ A )
        = ( ^ [X2: A] : ( if @ int @ ( ord_less_eq @ A @ ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( archimedean_frac @ A @ X2 ) ) @ ( archimedean_ceiling @ A @ X2 ) @ ( archim6421214686448440834_floor @ A @ X2 ) ) ) ) ) ).

% round_altdef
thf(fact_1715_arsinh__def,axiom,
    ! [A: $tType] :
      ( ( ln @ A )
     => ( ( arsinh @ A )
        = ( ^ [X2: A] : ( ln_ln @ A @ ( plus_plus @ A @ X2 @ ( powr @ A @ ( plus_plus @ A @ ( power_power @ A @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ A ) ) @ ( real_Vector_of_real @ A @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ).

% arsinh_def
thf(fact_1716_ln__one__minus__pos__lower__bound,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less_eq @ real @ X @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
       => ( ord_less_eq @ real @ ( minus_minus @ real @ ( uminus_uminus @ real @ X ) @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( ln_ln @ real @ ( minus_minus @ real @ ( one_one @ real ) @ X ) ) ) ) ) ).

% ln_one_minus_pos_lower_bound
thf(fact_1717_pochhammer__double,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [Z: A,N: nat] :
          ( ( comm_s3205402744901411588hammer @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ Z ) @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) )
          = ( times_times @ A @ ( times_times @ A @ ( semiring_1_of_nat @ A @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ) @ ( comm_s3205402744901411588hammer @ A @ Z @ N ) ) @ ( comm_s3205402744901411588hammer @ A @ ( plus_plus @ A @ Z @ ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) @ N ) ) ) ) ).

% pochhammer_double
thf(fact_1718_abs__ln__one__plus__x__minus__x__bound,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( abs_abs @ real @ X ) @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
     => ( ord_less_eq @ real @ ( abs_abs @ real @ ( minus_minus @ real @ ( ln_ln @ real @ ( plus_plus @ real @ ( one_one @ real ) @ X ) ) @ X ) ) @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% abs_ln_one_plus_x_minus_x_bound
thf(fact_1719_add_Oinverse__inverse,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A] :
          ( ( uminus_uminus @ A @ ( uminus_uminus @ A @ A2 ) )
          = A2 ) ) ).

% add.inverse_inverse
thf(fact_1720_neg__equal__iff__equal,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ( uminus_uminus @ A @ A2 )
            = ( uminus_uminus @ A @ B2 ) )
          = ( A2 = B2 ) ) ) ).

% neg_equal_iff_equal
thf(fact_1721_uminus__apply,axiom,
    ! [B: $tType,A: $tType] :
      ( ( uminus @ B )
     => ( ( uminus_uminus @ ( A > B ) )
        = ( ^ [A7: A > B,X2: A] : ( uminus_uminus @ B @ ( A7 @ X2 ) ) ) ) ) ).

% uminus_apply
thf(fact_1722_verit__minus__simplify_I4_J,axiom,
    ! [B: $tType] :
      ( ( group_add @ B )
     => ! [B2: B] :
          ( ( uminus_uminus @ B @ ( uminus_uminus @ B @ B2 ) )
          = B2 ) ) ).

% verit_minus_simplify(4)
thf(fact_1723_abs__idempotent,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A] :
          ( ( abs_abs @ A @ ( abs_abs @ A @ A2 ) )
          = ( abs_abs @ A @ A2 ) ) ) ).

% abs_idempotent
thf(fact_1724_frac__frac,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( archimedean_frac @ A @ ( archimedean_frac @ A @ X ) )
          = ( archimedean_frac @ A @ X ) ) ) ).

% frac_frac
thf(fact_1725_neg__le__iff__le,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ B2 ) @ ( uminus_uminus @ A @ A2 ) )
          = ( ord_less_eq @ A @ A2 @ B2 ) ) ) ).

% neg_le_iff_le
thf(fact_1726_neg__equal__zero,axiom,
    ! [A: $tType] :
      ( ( linord5086331880401160121up_add @ A )
     => ! [A2: A] :
          ( ( ( uminus_uminus @ A @ A2 )
            = A2 )
          = ( A2
            = ( zero_zero @ A ) ) ) ) ).

% neg_equal_zero
thf(fact_1727_equal__neg__zero,axiom,
    ! [A: $tType] :
      ( ( linord5086331880401160121up_add @ A )
     => ! [A2: A] :
          ( ( A2
            = ( uminus_uminus @ A @ A2 ) )
          = ( A2
            = ( zero_zero @ A ) ) ) ) ).

% equal_neg_zero
thf(fact_1728_neg__equal__0__iff__equal,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A] :
          ( ( ( uminus_uminus @ A @ A2 )
            = ( zero_zero @ A ) )
          = ( A2
            = ( zero_zero @ A ) ) ) ) ).

% neg_equal_0_iff_equal
thf(fact_1729_neg__0__equal__iff__equal,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A] :
          ( ( ( zero_zero @ A )
            = ( uminus_uminus @ A @ A2 ) )
          = ( ( zero_zero @ A )
            = A2 ) ) ) ).

% neg_0_equal_iff_equal
thf(fact_1730_add_Oinverse__neutral,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ( ( uminus_uminus @ A @ ( zero_zero @ A ) )
        = ( zero_zero @ A ) ) ) ).

% add.inverse_neutral
thf(fact_1731_neg__less__iff__less,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less @ A @ ( uminus_uminus @ A @ B2 ) @ ( uminus_uminus @ A @ A2 ) )
          = ( ord_less @ A @ A2 @ B2 ) ) ) ).

% neg_less_iff_less
thf(fact_1732_neg__numeral__eq__iff,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [M: num,N: num] :
          ( ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) )
            = ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) )
          = ( M = N ) ) ) ).

% neg_numeral_eq_iff
thf(fact_1733_add__minus__cancel,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( plus_plus @ A @ A2 @ ( plus_plus @ A @ ( uminus_uminus @ A @ A2 ) @ B2 ) )
          = B2 ) ) ).

% add_minus_cancel
thf(fact_1734_minus__add__cancel,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( plus_plus @ A @ ( uminus_uminus @ A @ A2 ) @ ( plus_plus @ A @ A2 @ B2 ) )
          = B2 ) ) ).

% minus_add_cancel
thf(fact_1735_minus__add__distrib,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( uminus_uminus @ A @ ( plus_plus @ A @ A2 @ B2 ) )
          = ( plus_plus @ A @ ( uminus_uminus @ A @ A2 ) @ ( uminus_uminus @ A @ B2 ) ) ) ) ).

% minus_add_distrib
thf(fact_1736_minus__diff__eq,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( uminus_uminus @ A @ ( minus_minus @ A @ A2 @ B2 ) )
          = ( minus_minus @ A @ B2 @ A2 ) ) ) ).

% minus_diff_eq
thf(fact_1737_abs__0,axiom,
    ! [A: $tType] :
      ( ( idom_abs_sgn @ A )
     => ( ( abs_abs @ A @ ( zero_zero @ A ) )
        = ( zero_zero @ A ) ) ) ).

% abs_0
thf(fact_1738_abs__zero,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ( ( abs_abs @ A @ ( zero_zero @ A ) )
        = ( zero_zero @ A ) ) ) ).

% abs_zero
thf(fact_1739_abs__eq__0,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A] :
          ( ( ( abs_abs @ A @ A2 )
            = ( zero_zero @ A ) )
          = ( A2
            = ( zero_zero @ A ) ) ) ) ).

% abs_eq_0
thf(fact_1740_abs__0__eq,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A] :
          ( ( ( zero_zero @ A )
            = ( abs_abs @ A @ A2 ) )
          = ( A2
            = ( zero_zero @ A ) ) ) ) ).

% abs_0_eq
thf(fact_1741_mod__self,axiom,
    ! [A: $tType] :
      ( ( semidom_modulo @ A )
     => ! [A2: A] :
          ( ( modulo_modulo @ A @ A2 @ A2 )
          = ( zero_zero @ A ) ) ) ).

% mod_self
thf(fact_1742_mod__by__0,axiom,
    ! [A: $tType] :
      ( ( semidom_modulo @ A )
     => ! [A2: A] :
          ( ( modulo_modulo @ A @ A2 @ ( zero_zero @ A ) )
          = A2 ) ) ).

% mod_by_0
thf(fact_1743_mod__0,axiom,
    ! [A: $tType] :
      ( ( semidom_modulo @ A )
     => ! [A2: A] :
          ( ( modulo_modulo @ A @ ( zero_zero @ A ) @ A2 )
          = ( zero_zero @ A ) ) ) ).

% mod_0
thf(fact_1744_bits__mod__0,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A] :
          ( ( modulo_modulo @ A @ ( zero_zero @ A ) @ A2 )
          = ( zero_zero @ A ) ) ) ).

% bits_mod_0
thf(fact_1745_abs__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N: num] :
          ( ( abs_abs @ A @ ( numeral_numeral @ A @ N ) )
          = ( numeral_numeral @ A @ N ) ) ) ).

% abs_numeral
thf(fact_1746_abs__add__abs,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A,B2: A] :
          ( ( abs_abs @ A @ ( plus_plus @ A @ ( abs_abs @ A @ A2 ) @ ( abs_abs @ A @ B2 ) ) )
          = ( plus_plus @ A @ ( abs_abs @ A @ A2 ) @ ( abs_abs @ A @ B2 ) ) ) ) ).

% abs_add_abs
thf(fact_1747_abs__minus__cancel,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A] :
          ( ( abs_abs @ A @ ( uminus_uminus @ A @ A2 ) )
          = ( abs_abs @ A @ A2 ) ) ) ).

% abs_minus_cancel
thf(fact_1748_of__int__minus,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [Z: int] :
          ( ( ring_1_of_int @ A @ ( uminus_uminus @ int @ Z ) )
          = ( uminus_uminus @ A @ ( ring_1_of_int @ A @ Z ) ) ) ) ).

% of_int_minus
thf(fact_1749_abs__of__nat,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N: nat] :
          ( ( abs_abs @ A @ ( semiring_1_of_nat @ A @ N ) )
          = ( semiring_1_of_nat @ A @ N ) ) ) ).

% abs_of_nat
thf(fact_1750_of__int__abs,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: int] :
          ( ( ring_1_of_int @ A @ ( abs_abs @ int @ X ) )
          = ( abs_abs @ A @ ( ring_1_of_int @ A @ X ) ) ) ) ).

% of_int_abs
thf(fact_1751_mod__less,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ M @ N )
     => ( ( modulo_modulo @ nat @ M @ N )
        = M ) ) ).

% mod_less
thf(fact_1752_tanh__0,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ( ( tanh @ A @ ( zero_zero @ A ) )
        = ( zero_zero @ A ) ) ) ).

% tanh_0
thf(fact_1753_tanh__real__zero__iff,axiom,
    ! [X: real] :
      ( ( ( tanh @ real @ X )
        = ( zero_zero @ real ) )
      = ( X
        = ( zero_zero @ real ) ) ) ).

% tanh_real_zero_iff
thf(fact_1754_tanh__real__less__iff,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less @ real @ ( tanh @ real @ X ) @ ( tanh @ real @ Y ) )
      = ( ord_less @ real @ X @ Y ) ) ).

% tanh_real_less_iff
thf(fact_1755_tanh__real__le__iff,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less_eq @ real @ ( tanh @ real @ X ) @ ( tanh @ real @ Y ) )
      = ( ord_less_eq @ real @ X @ Y ) ) ).

% tanh_real_le_iff
thf(fact_1756_neg__0__le__iff__le,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( uminus_uminus @ A @ A2 ) )
          = ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) ) ) ) ).

% neg_0_le_iff_le
thf(fact_1757_neg__le__0__iff__le,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ A2 ) @ ( zero_zero @ A ) )
          = ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 ) ) ) ).

% neg_le_0_iff_le
thf(fact_1758_less__eq__neg__nonpos,axiom,
    ! [A: $tType] :
      ( ( linord5086331880401160121up_add @ A )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ A2 @ ( uminus_uminus @ A @ A2 ) )
          = ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) ) ) ) ).

% less_eq_neg_nonpos
thf(fact_1759_neg__less__eq__nonneg,axiom,
    ! [A: $tType] :
      ( ( linord5086331880401160121up_add @ A )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ A2 ) @ A2 )
          = ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 ) ) ) ).

% neg_less_eq_nonneg
thf(fact_1760_less__neg__neg,axiom,
    ! [A: $tType] :
      ( ( linord5086331880401160121up_add @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ A2 @ ( uminus_uminus @ A @ A2 ) )
          = ( ord_less @ A @ A2 @ ( zero_zero @ A ) ) ) ) ).

% less_neg_neg
thf(fact_1761_neg__less__pos,axiom,
    ! [A: $tType] :
      ( ( linord5086331880401160121up_add @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( uminus_uminus @ A @ A2 ) @ A2 )
          = ( ord_less @ A @ ( zero_zero @ A ) @ A2 ) ) ) ).

% neg_less_pos
thf(fact_1762_neg__0__less__iff__less,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( uminus_uminus @ A @ A2 ) )
          = ( ord_less @ A @ A2 @ ( zero_zero @ A ) ) ) ) ).

% neg_0_less_iff_less
thf(fact_1763_neg__less__0__iff__less,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( uminus_uminus @ A @ A2 ) @ ( zero_zero @ A ) )
          = ( ord_less @ A @ ( zero_zero @ A ) @ A2 ) ) ) ).

% neg_less_0_iff_less
thf(fact_1764_add_Oright__inverse,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A] :
          ( ( plus_plus @ A @ A2 @ ( uminus_uminus @ A @ A2 ) )
          = ( zero_zero @ A ) ) ) ).

% add.right_inverse
thf(fact_1765_ab__left__minus,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A] :
          ( ( plus_plus @ A @ ( uminus_uminus @ A @ A2 ) @ A2 )
          = ( zero_zero @ A ) ) ) ).

% ab_left_minus
thf(fact_1766_verit__minus__simplify_I3_J,axiom,
    ! [B: $tType] :
      ( ( group_add @ B )
     => ! [B2: B] :
          ( ( minus_minus @ B @ ( zero_zero @ B ) @ B2 )
          = ( uminus_uminus @ B @ B2 ) ) ) ).

% verit_minus_simplify(3)
thf(fact_1767_diff__0,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A] :
          ( ( minus_minus @ A @ ( zero_zero @ A ) @ A2 )
          = ( uminus_uminus @ A @ A2 ) ) ) ).

% diff_0
thf(fact_1768_add__neg__numeral__simps_I3_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [M: num,N: num] :
          ( ( plus_plus @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) )
          = ( uminus_uminus @ A @ ( plus_plus @ A @ ( numeral_numeral @ A @ M ) @ ( numeral_numeral @ A @ N ) ) ) ) ) ).

% add_neg_numeral_simps(3)
thf(fact_1769_mult__minus1__right,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [Z: A] :
          ( ( times_times @ A @ Z @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( uminus_uminus @ A @ Z ) ) ) ).

% mult_minus1_right
thf(fact_1770_mult__minus1,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [Z: A] :
          ( ( times_times @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ Z )
          = ( uminus_uminus @ A @ Z ) ) ) ).

% mult_minus1
thf(fact_1771_abs__of__nonneg,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( abs_abs @ A @ A2 )
            = A2 ) ) ) ).

% abs_of_nonneg
thf(fact_1772_abs__le__self__iff,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ ( abs_abs @ A @ A2 ) @ A2 )
          = ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 ) ) ) ).

% abs_le_self_iff
thf(fact_1773_abs__le__zero__iff,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ ( abs_abs @ A @ A2 ) @ ( zero_zero @ A ) )
          = ( A2
            = ( zero_zero @ A ) ) ) ) ).

% abs_le_zero_iff
thf(fact_1774_diff__minus__eq__add,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( minus_minus @ A @ A2 @ ( uminus_uminus @ A @ B2 ) )
          = ( plus_plus @ A @ A2 @ B2 ) ) ) ).

% diff_minus_eq_add
thf(fact_1775_uminus__add__conv__diff,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( plus_plus @ A @ ( uminus_uminus @ A @ A2 ) @ B2 )
          = ( minus_minus @ A @ B2 @ A2 ) ) ) ).

% uminus_add_conv_diff
thf(fact_1776_zero__less__abs__iff,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( abs_abs @ A @ A2 ) )
          = ( ( A2
             != ( zero_zero @ A ) ) ) ) ) ).

% zero_less_abs_iff
thf(fact_1777_mod__mult__self1__is__0,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [B2: A,A2: A] :
          ( ( modulo_modulo @ A @ ( times_times @ A @ B2 @ A2 ) @ B2 )
          = ( zero_zero @ A ) ) ) ).

% mod_mult_self1_is_0
thf(fact_1778_mod__mult__self2__is__0,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [A2: A,B2: A] :
          ( ( modulo_modulo @ A @ ( times_times @ A @ A2 @ B2 ) @ B2 )
          = ( zero_zero @ A ) ) ) ).

% mod_mult_self2_is_0
thf(fact_1779_mod__by__1,axiom,
    ! [A: $tType] :
      ( ( semidom_modulo @ A )
     => ! [A2: A] :
          ( ( modulo_modulo @ A @ A2 @ ( one_one @ A ) )
          = ( zero_zero @ A ) ) ) ).

% mod_by_1
thf(fact_1780_bits__mod__by__1,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A] :
          ( ( modulo_modulo @ A @ A2 @ ( one_one @ A ) )
          = ( zero_zero @ A ) ) ) ).

% bits_mod_by_1
thf(fact_1781_bits__mod__div__trivial,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A,B2: A] :
          ( ( divide_divide @ A @ ( modulo_modulo @ A @ A2 @ B2 ) @ B2 )
          = ( zero_zero @ A ) ) ) ).

% bits_mod_div_trivial
thf(fact_1782_mod__div__trivial,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [A2: A,B2: A] :
          ( ( divide_divide @ A @ ( modulo_modulo @ A @ A2 @ B2 ) @ B2 )
          = ( zero_zero @ A ) ) ) ).

% mod_div_trivial
thf(fact_1783_abs__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N: num] :
          ( ( abs_abs @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) )
          = ( numeral_numeral @ A @ N ) ) ) ).

% abs_neg_numeral
thf(fact_1784_dvd__imp__mod__0,axiom,
    ! [A: $tType] :
      ( ( semidom_modulo @ A )
     => ! [A2: A,B2: A] :
          ( ( dvd_dvd @ A @ A2 @ B2 )
         => ( ( modulo_modulo @ A @ B2 @ A2 )
            = ( zero_zero @ A ) ) ) ) ).

% dvd_imp_mod_0
thf(fact_1785_abs__neg__one,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ( ( abs_abs @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
        = ( one_one @ A ) ) ) ).

% abs_neg_one
thf(fact_1786_abs__power__minus,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A,N: nat] :
          ( ( abs_abs @ A @ ( power_power @ A @ ( uminus_uminus @ A @ A2 ) @ N ) )
          = ( abs_abs @ A @ ( power_power @ A @ A2 @ N ) ) ) ) ).

% abs_power_minus
thf(fact_1787_bit_Odisj__one__left,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X: A] :
          ( ( bit_se1065995026697491101ons_or @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ X )
          = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% bit.disj_one_left
thf(fact_1788_bit_Odisj__one__right,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X: A] :
          ( ( bit_se1065995026697491101ons_or @ A @ X @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% bit.disj_one_right
thf(fact_1789_real__add__minus__iff,axiom,
    ! [X: real,A2: real] :
      ( ( ( plus_plus @ real @ X @ ( uminus_uminus @ real @ A2 ) )
        = ( zero_zero @ real ) )
      = ( X = A2 ) ) ).

% real_add_minus_iff
thf(fact_1790_pochhammer__0,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [A2: A] :
          ( ( comm_s3205402744901411588hammer @ A @ A2 @ ( zero_zero @ nat ) )
          = ( one_one @ A ) ) ) ).

% pochhammer_0
thf(fact_1791_floor__uminus__of__int,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [Z: int] :
          ( ( archim6421214686448440834_floor @ A @ ( uminus_uminus @ A @ ( ring_1_of_int @ A @ Z ) ) )
          = ( uminus_uminus @ int @ Z ) ) ) ).

% floor_uminus_of_int
thf(fact_1792_real__sqrt__mult__self,axiom,
    ! [A2: real] :
      ( ( times_times @ real @ ( sqrt @ A2 ) @ ( sqrt @ A2 ) )
      = ( abs_abs @ real @ A2 ) ) ).

% real_sqrt_mult_self
thf(fact_1793_real__sqrt__abs2,axiom,
    ! [X: real] :
      ( ( sqrt @ ( times_times @ real @ X @ X ) )
      = ( abs_abs @ real @ X ) ) ).

% real_sqrt_abs2
thf(fact_1794_frac__of__int,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [Z: int] :
          ( ( archimedean_frac @ A @ ( ring_1_of_int @ A @ Z ) )
          = ( zero_zero @ A ) ) ) ).

% frac_of_int
thf(fact_1795_tanh__real__neg__iff,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( tanh @ real @ X ) @ ( zero_zero @ real ) )
      = ( ord_less @ real @ X @ ( zero_zero @ real ) ) ) ).

% tanh_real_neg_iff
thf(fact_1796_tanh__real__pos__iff,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ ( tanh @ real @ X ) )
      = ( ord_less @ real @ ( zero_zero @ real ) @ X ) ) ).

% tanh_real_pos_iff
thf(fact_1797_tanh__real__nonneg__iff,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( tanh @ real @ X ) )
      = ( ord_less_eq @ real @ ( zero_zero @ real ) @ X ) ) ).

% tanh_real_nonneg_iff
thf(fact_1798_tanh__real__nonpos__iff,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( tanh @ real @ X ) @ ( zero_zero @ real ) )
      = ( ord_less_eq @ real @ X @ ( zero_zero @ real ) ) ) ).

% tanh_real_nonpos_iff
thf(fact_1799_dbl__simps_I1_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [K: num] :
          ( ( neg_numeral_dbl @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ K ) ) )
          = ( uminus_uminus @ A @ ( neg_numeral_dbl @ A @ ( numeral_numeral @ A @ K ) ) ) ) ) ).

% dbl_simps(1)
thf(fact_1800_add__neg__numeral__special_I8_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( plus_plus @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( one_one @ A ) )
        = ( zero_zero @ A ) ) ) ).

% add_neg_numeral_special(8)
thf(fact_1801_add__neg__numeral__special_I7_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( plus_plus @ A @ ( one_one @ A ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
        = ( zero_zero @ A ) ) ) ).

% add_neg_numeral_special(7)
thf(fact_1802_diff__numeral__special_I12_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( minus_minus @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
        = ( zero_zero @ A ) ) ) ).

% diff_numeral_special(12)
thf(fact_1803_neg__one__eq__numeral__iff,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [N: num] :
          ( ( ( uminus_uminus @ A @ ( one_one @ A ) )
            = ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) )
          = ( N = one2 ) ) ) ).

% neg_one_eq_numeral_iff
thf(fact_1804_numeral__eq__neg__one__iff,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [N: num] :
          ( ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) )
            = ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( N = one2 ) ) ) ).

% numeral_eq_neg_one_iff
thf(fact_1805_divide__le__0__abs__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( divide_divide @ A @ A2 @ ( abs_abs @ A @ B2 ) ) @ ( zero_zero @ A ) )
          = ( ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) )
            | ( B2
              = ( zero_zero @ A ) ) ) ) ) ).

% divide_le_0_abs_iff
thf(fact_1806_zero__le__divide__abs__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( divide_divide @ A @ A2 @ ( abs_abs @ A @ B2 ) ) )
          = ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
            | ( B2
              = ( zero_zero @ A ) ) ) ) ) ).

% zero_le_divide_abs_iff
thf(fact_1807_abs__of__nonpos,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) )
         => ( ( abs_abs @ A @ A2 )
            = ( uminus_uminus @ A @ A2 ) ) ) ) ).

% abs_of_nonpos
thf(fact_1808_minus__one__mult__self,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [N: nat] :
          ( ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ N ) @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ N ) )
          = ( one_one @ A ) ) ) ).

% minus_one_mult_self
thf(fact_1809_left__minus__one__mult__self,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [N: nat,A2: A] :
          ( ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ N ) @ ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ N ) @ A2 ) )
          = A2 ) ) ).

% left_minus_one_mult_self
thf(fact_1810_mod__minus1__right,axiom,
    ! [A: $tType] :
      ( ( euclid8851590272496341667cancel @ A )
     => ! [A2: A] :
          ( ( modulo_modulo @ A @ A2 @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( zero_zero @ A ) ) ) ).

% mod_minus1_right
thf(fact_1811_max__number__of_I4_J,axiom,
    ! [A: $tType] :
      ( ( ( uminus @ A )
        & ( numeral @ A )
        & ( ord @ A ) )
     => ! [U: num,V: num] :
          ( ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ U ) ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) )
           => ( ( ord_max @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ U ) ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) )
              = ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) ) )
          & ( ~ ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ U ) ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) )
           => ( ( ord_max @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ U ) ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) )
              = ( uminus_uminus @ A @ ( numeral_numeral @ A @ U ) ) ) ) ) ) ).

% max_number_of(4)
thf(fact_1812_max__number__of_I3_J,axiom,
    ! [A: $tType] :
      ( ( ( uminus @ A )
        & ( numeral @ A )
        & ( ord @ A ) )
     => ! [U: num,V: num] :
          ( ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ U ) ) @ ( numeral_numeral @ A @ V ) )
           => ( ( ord_max @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ U ) ) @ ( numeral_numeral @ A @ V ) )
              = ( numeral_numeral @ A @ V ) ) )
          & ( ~ ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ U ) ) @ ( numeral_numeral @ A @ V ) )
           => ( ( ord_max @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ U ) ) @ ( numeral_numeral @ A @ V ) )
              = ( uminus_uminus @ A @ ( numeral_numeral @ A @ U ) ) ) ) ) ) ).

% max_number_of(3)
thf(fact_1813_max__number__of_I2_J,axiom,
    ! [A: $tType] :
      ( ( ( uminus @ A )
        & ( numeral @ A )
        & ( ord @ A ) )
     => ! [U: num,V: num] :
          ( ( ( ord_less_eq @ A @ ( numeral_numeral @ A @ U ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) )
           => ( ( ord_max @ A @ ( numeral_numeral @ A @ U ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) )
              = ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) ) )
          & ( ~ ( ord_less_eq @ A @ ( numeral_numeral @ A @ U ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) )
           => ( ( ord_max @ A @ ( numeral_numeral @ A @ U ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) )
              = ( numeral_numeral @ A @ U ) ) ) ) ) ).

% max_number_of(2)
thf(fact_1814_floor__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [V: num] :
          ( ( archim6421214686448440834_floor @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) )
          = ( uminus_uminus @ int @ ( numeral_numeral @ int @ V ) ) ) ) ).

% floor_neg_numeral
thf(fact_1815_semiring__norm_I168_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [V: num,W: num,Y: A] :
          ( ( plus_plus @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) @ ( plus_plus @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) @ Y ) )
          = ( plus_plus @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( plus_plus @ num @ V @ W ) ) ) @ Y ) ) ) ).

% semiring_norm(168)
thf(fact_1816_diff__numeral__simps_I3_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [M: num,N: num] :
          ( ( minus_minus @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) @ ( numeral_numeral @ A @ N ) )
          = ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( plus_plus @ num @ M @ N ) ) ) ) ) ).

% diff_numeral_simps(3)
thf(fact_1817_diff__numeral__simps_I2_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [M: num,N: num] :
          ( ( minus_minus @ A @ ( numeral_numeral @ A @ M ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) )
          = ( numeral_numeral @ A @ ( plus_plus @ num @ M @ N ) ) ) ) ).

% diff_numeral_simps(2)
thf(fact_1818_ceiling__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [V: num] :
          ( ( archimedean_ceiling @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) )
          = ( uminus_uminus @ int @ ( numeral_numeral @ int @ V ) ) ) ) ).

% ceiling_neg_numeral
thf(fact_1819_semiring__norm_I172_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [V: num,W: num,Y: A] :
          ( ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) @ ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) @ Y ) )
          = ( times_times @ A @ ( numeral_numeral @ A @ ( times_times @ num @ V @ W ) ) @ Y ) ) ) ).

% semiring_norm(172)
thf(fact_1820_semiring__norm_I171_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [V: num,W: num,Y: A] :
          ( ( times_times @ A @ ( numeral_numeral @ A @ V ) @ ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) @ Y ) )
          = ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( times_times @ num @ V @ W ) ) ) @ Y ) ) ) ).

% semiring_norm(171)
thf(fact_1821_semiring__norm_I170_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [V: num,W: num,Y: A] :
          ( ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) @ ( times_times @ A @ ( numeral_numeral @ A @ W ) @ Y ) )
          = ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( times_times @ num @ V @ W ) ) ) @ Y ) ) ) ).

% semiring_norm(170)
thf(fact_1822_mult__neg__numeral__simps_I3_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [M: num,N: num] :
          ( ( times_times @ A @ ( numeral_numeral @ A @ M ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) )
          = ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( times_times @ num @ M @ N ) ) ) ) ) ).

% mult_neg_numeral_simps(3)
thf(fact_1823_mult__neg__numeral__simps_I2_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [M: num,N: num] :
          ( ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) @ ( numeral_numeral @ A @ N ) )
          = ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( times_times @ num @ M @ N ) ) ) ) ) ).

% mult_neg_numeral_simps(2)
thf(fact_1824_mult__neg__numeral__simps_I1_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [M: num,N: num] :
          ( ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) )
          = ( numeral_numeral @ A @ ( times_times @ num @ M @ N ) ) ) ) ).

% mult_neg_numeral_simps(1)
thf(fact_1825_artanh__minus__real,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( abs_abs @ real @ X ) @ ( one_one @ real ) )
     => ( ( artanh @ real @ ( uminus_uminus @ real @ X ) )
        = ( uminus_uminus @ real @ ( artanh @ real @ X ) ) ) ) ).

% artanh_minus_real
thf(fact_1826_neg__numeral__le__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M: num,N: num] :
          ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) )
          = ( ord_less_eq @ num @ N @ M ) ) ) ).

% neg_numeral_le_iff
thf(fact_1827_neg__numeral__less__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M: num,N: num] :
          ( ( ord_less @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) )
          = ( ord_less @ num @ N @ M ) ) ) ).

% neg_numeral_less_iff
thf(fact_1828_round__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [N: num] :
          ( ( archimedean_round @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) )
          = ( uminus_uminus @ int @ ( numeral_numeral @ int @ N ) ) ) ) ).

% round_neg_numeral
thf(fact_1829_not__neg__one__le__neg__numeral__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M: num] :
          ( ( ~ ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) ) )
          = ( ( M != one2 ) ) ) ) ).

% not_neg_one_le_neg_numeral_iff
thf(fact_1830_divide__le__eq__numeral1_I2_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,W: num,A2: A] :
          ( ( ord_less_eq @ A @ ( divide_divide @ A @ B2 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) ) @ A2 )
          = ( ord_less_eq @ A @ ( times_times @ A @ A2 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) ) @ B2 ) ) ) ).

% divide_le_eq_numeral1(2)
thf(fact_1831_le__divide__eq__numeral1_I2_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A,W: num] :
          ( ( ord_less_eq @ A @ A2 @ ( divide_divide @ A @ B2 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) ) )
          = ( ord_less_eq @ A @ B2 @ ( times_times @ A @ A2 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) ) ) ) ) ).

% le_divide_eq_numeral1(2)
thf(fact_1832_divide__eq__eq__numeral1_I2_J,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [B2: A,W: num,A2: A] :
          ( ( ( divide_divide @ A @ B2 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) )
            = A2 )
          = ( ( ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) )
               != ( zero_zero @ A ) )
             => ( B2
                = ( times_times @ A @ A2 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) ) ) )
            & ( ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) )
                = ( zero_zero @ A ) )
             => ( A2
                = ( zero_zero @ A ) ) ) ) ) ) ).

% divide_eq_eq_numeral1(2)
thf(fact_1833_eq__divide__eq__numeral1_I2_J,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A,B2: A,W: num] :
          ( ( A2
            = ( divide_divide @ A @ B2 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) ) )
          = ( ( ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) )
               != ( zero_zero @ A ) )
             => ( ( times_times @ A @ A2 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) )
                = B2 ) )
            & ( ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) )
                = ( zero_zero @ A ) )
             => ( A2
                = ( zero_zero @ A ) ) ) ) ) ) ).

% eq_divide_eq_numeral1(2)
thf(fact_1834_neg__numeral__less__neg__one__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M: num] :
          ( ( ord_less @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( ( M != one2 ) ) ) ) ).

% neg_numeral_less_neg_one_iff
thf(fact_1835_divide__less__eq__numeral1_I2_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,W: num,A2: A] :
          ( ( ord_less @ A @ ( divide_divide @ A @ B2 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) ) @ A2 )
          = ( ord_less @ A @ ( times_times @ A @ A2 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) ) @ B2 ) ) ) ).

% divide_less_eq_numeral1(2)
thf(fact_1836_less__divide__eq__numeral1_I2_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A,W: num] :
          ( ( ord_less @ A @ A2 @ ( divide_divide @ A @ B2 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) ) )
          = ( ord_less @ A @ B2 @ ( times_times @ A @ A2 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) ) ) ) ) ).

% less_divide_eq_numeral1(2)
thf(fact_1837_one__mod__two__eq__one,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ( ( modulo_modulo @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
        = ( one_one @ A ) ) ) ).

% one_mod_two_eq_one
thf(fact_1838_bits__one__mod__two__eq__one,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ( ( modulo_modulo @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
        = ( one_one @ A ) ) ) ).

% bits_one_mod_two_eq_one
thf(fact_1839_zero__less__power__abs__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A,N: nat] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( power_power @ A @ ( abs_abs @ A @ A2 ) @ N ) )
          = ( ( A2
             != ( zero_zero @ A ) )
            | ( N
              = ( zero_zero @ nat ) ) ) ) ) ).

% zero_less_power_abs_iff
thf(fact_1840_power2__minus,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [A2: A] :
          ( ( power_power @ A @ ( uminus_uminus @ A @ A2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
          = ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ).

% power2_minus
thf(fact_1841_even__mod__2__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [A2: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) )
          = ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) ) ) ).

% even_mod_2_iff
thf(fact_1842_abs__power2,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A] :
          ( ( abs_abs @ A @ ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
          = ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ).

% abs_power2
thf(fact_1843_power2__abs,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A] :
          ( ( power_power @ A @ ( abs_abs @ A @ A2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
          = ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ).

% power2_abs
thf(fact_1844_add__neg__numeral__special_I9_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( plus_plus @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
        = ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% add_neg_numeral_special(9)
thf(fact_1845_diff__numeral__special_I11_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( minus_minus @ A @ ( one_one @ A ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
        = ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ).

% diff_numeral_special(11)
thf(fact_1846_diff__numeral__special_I10_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( minus_minus @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( one_one @ A ) )
        = ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% diff_numeral_special(10)
thf(fact_1847_minus__1__div__2__eq,axiom,
    ! [A: $tType] :
      ( ( euclid8789492081693882211th_nat @ A )
     => ( ( divide_divide @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
        = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% minus_1_div_2_eq
thf(fact_1848_not__mod__2__eq__0__eq__1,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [A2: A] :
          ( ( ( ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
             != ( zero_zero @ A ) ) )
          = ( ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
            = ( one_one @ A ) ) ) ) ).

% not_mod_2_eq_0_eq_1
thf(fact_1849_not__mod__2__eq__1__eq__0,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [A2: A] :
          ( ( ( ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
             != ( one_one @ A ) ) )
          = ( ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
            = ( zero_zero @ A ) ) ) ) ).

% not_mod_2_eq_1_eq_0
thf(fact_1850_bits__minus__1__mod__2__eq,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( ( modulo_modulo @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
        = ( one_one @ A ) ) ) ).

% bits_minus_1_mod_2_eq
thf(fact_1851_minus__1__mod__2__eq,axiom,
    ! [A: $tType] :
      ( ( euclid8789492081693882211th_nat @ A )
     => ( ( modulo_modulo @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
        = ( one_one @ A ) ) ) ).

% minus_1_mod_2_eq
thf(fact_1852_Power_Oring__1__class_Opower__minus__even,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [A2: A,N: nat] :
          ( ( power_power @ A @ ( uminus_uminus @ A @ A2 ) @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) )
          = ( power_power @ A @ A2 @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ) ) ).

% Power.ring_1_class.power_minus_even
thf(fact_1853_power__minus__odd,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [N: nat,A2: A] :
          ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
         => ( ( power_power @ A @ ( uminus_uminus @ A @ A2 ) @ N )
            = ( uminus_uminus @ A @ ( power_power @ A @ A2 @ N ) ) ) ) ) ).

% power_minus_odd
thf(fact_1854_Parity_Oring__1__class_Opower__minus__even,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [N: nat,A2: A] :
          ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
         => ( ( power_power @ A @ ( uminus_uminus @ A @ A2 ) @ N )
            = ( power_power @ A @ A2 @ N ) ) ) ) ).

% Parity.ring_1_class.power_minus_even
thf(fact_1855_power__even__abs__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [W: num,A2: A] :
          ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( numeral_numeral @ nat @ W ) )
         => ( ( power_power @ A @ ( abs_abs @ A @ A2 ) @ ( numeral_numeral @ nat @ W ) )
            = ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ W ) ) ) ) ) ).

% power_even_abs_numeral
thf(fact_1856_diff__numeral__special_I4_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [M: num] :
          ( ( minus_minus @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) @ ( one_one @ A ) )
          = ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( plus_plus @ num @ M @ one2 ) ) ) ) ) ).

% diff_numeral_special(4)
thf(fact_1857_diff__numeral__special_I3_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [N: num] :
          ( ( minus_minus @ A @ ( one_one @ A ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) )
          = ( numeral_numeral @ A @ ( plus_plus @ num @ one2 @ N ) ) ) ) ).

% diff_numeral_special(3)
thf(fact_1858_add__self__mod__2,axiom,
    ! [M: nat] :
      ( ( modulo_modulo @ nat @ ( plus_plus @ nat @ M @ M ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
      = ( zero_zero @ nat ) ) ).

% add_self_mod_2
thf(fact_1859_neg__numeral__le__floor,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [V: num,X: A] :
          ( ( ord_less_eq @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ V ) ) @ ( archim6421214686448440834_floor @ A @ X ) )
          = ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) @ X ) ) ) ).

% neg_numeral_le_floor
thf(fact_1860_floor__less__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,V: num] :
          ( ( ord_less @ int @ ( archim6421214686448440834_floor @ A @ X ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ V ) ) )
          = ( ord_less @ A @ X @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) ) ) ) ).

% floor_less_neg_numeral
thf(fact_1861_ceiling__le__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,V: num] :
          ( ( ord_less_eq @ int @ ( archimedean_ceiling @ A @ X ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ V ) ) )
          = ( ord_less_eq @ A @ X @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) ) ) ) ).

% ceiling_le_neg_numeral
thf(fact_1862_ceiling__less__zero,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( ord_less @ int @ ( archimedean_ceiling @ A @ X ) @ ( zero_zero @ int ) )
          = ( ord_less_eq @ A @ X @ ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ) ).

% ceiling_less_zero
thf(fact_1863_zero__le__ceiling,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( archimedean_ceiling @ A @ X ) )
          = ( ord_less @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ X ) ) ) ).

% zero_le_ceiling
thf(fact_1864_neg__numeral__less__ceiling,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [V: num,X: A] :
          ( ( ord_less @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ V ) ) @ ( archimedean_ceiling @ A @ X ) )
          = ( ord_less @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) @ X ) ) ) ).

% neg_numeral_less_ceiling
thf(fact_1865_neg__numeral__power__eq__of__int__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [X: num,N: nat,Y: int] :
          ( ( ( power_power @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ X ) ) @ N )
            = ( ring_1_of_int @ A @ Y ) )
          = ( ( power_power @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ X ) ) @ N )
            = Y ) ) ) ).

% neg_numeral_power_eq_of_int_cancel_iff
thf(fact_1866_of__int__eq__neg__numeral__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [Y: int,X: num,N: nat] :
          ( ( ( ring_1_of_int @ A @ Y )
            = ( power_power @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ X ) ) @ N ) )
          = ( Y
            = ( power_power @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ X ) ) @ N ) ) ) ) ).

% of_int_eq_neg_numeral_power_cancel_iff
thf(fact_1867_real__sqrt__abs,axiom,
    ! [X: real] :
      ( ( sqrt @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
      = ( abs_abs @ real @ X ) ) ).

% real_sqrt_abs
thf(fact_1868_dbl__simps_I4_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( neg_numeral_dbl @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
        = ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% dbl_simps(4)
thf(fact_1869_power__minus1__even,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [N: nat] :
          ( ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) )
          = ( one_one @ A ) ) ) ).

% power_minus1_even
thf(fact_1870_neg__one__odd__power,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [N: nat] :
          ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
         => ( ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ N )
            = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ) ).

% neg_one_odd_power
thf(fact_1871_neg__one__even__power,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [N: nat] :
          ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
         => ( ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ N )
            = ( one_one @ A ) ) ) ) ).

% neg_one_even_power
thf(fact_1872_mod2__gr__0,axiom,
    ! [M: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( modulo_modulo @ nat @ M @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
      = ( ( modulo_modulo @ nat @ M @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
        = ( one_one @ nat ) ) ) ).

% mod2_gr_0
thf(fact_1873_neg__numeral__less__floor,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [V: num,X: A] :
          ( ( ord_less @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ V ) ) @ ( archim6421214686448440834_floor @ A @ X ) )
          = ( ord_less_eq @ A @ ( plus_plus @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) @ ( one_one @ A ) ) @ X ) ) ) ).

% neg_numeral_less_floor
thf(fact_1874_floor__le__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,V: num] :
          ( ( ord_less_eq @ int @ ( archim6421214686448440834_floor @ A @ X ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ V ) ) )
          = ( ord_less @ A @ X @ ( plus_plus @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) @ ( one_one @ A ) ) ) ) ) ).

% floor_le_neg_numeral
thf(fact_1875_ceiling__less__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,V: num] :
          ( ( ord_less @ int @ ( archimedean_ceiling @ A @ X ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ V ) ) )
          = ( ord_less_eq @ A @ X @ ( minus_minus @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) @ ( one_one @ A ) ) ) ) ) ).

% ceiling_less_neg_numeral
thf(fact_1876_neg__numeral__le__ceiling,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [V: num,X: A] :
          ( ( ord_less_eq @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ V ) ) @ ( archimedean_ceiling @ A @ X ) )
          = ( ord_less @ A @ ( minus_minus @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) @ ( one_one @ A ) ) @ X ) ) ) ).

% neg_numeral_le_ceiling
thf(fact_1877_neg__numeral__power__le__of__int__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: num,N: nat,A2: int] :
          ( ( ord_less_eq @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ X ) ) @ N ) @ ( ring_1_of_int @ A @ A2 ) )
          = ( ord_less_eq @ int @ ( power_power @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ X ) ) @ N ) @ A2 ) ) ) ).

% neg_numeral_power_le_of_int_cancel_iff
thf(fact_1878_of__int__le__neg__numeral__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: int,X: num,N: nat] :
          ( ( ord_less_eq @ A @ ( ring_1_of_int @ A @ A2 ) @ ( power_power @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ X ) ) @ N ) )
          = ( ord_less_eq @ int @ A2 @ ( power_power @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ X ) ) @ N ) ) ) ) ).

% of_int_le_neg_numeral_power_cancel_iff
thf(fact_1879_neg__numeral__power__less__of__int__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: num,N: nat,A2: int] :
          ( ( ord_less @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ X ) ) @ N ) @ ( ring_1_of_int @ A @ A2 ) )
          = ( ord_less @ int @ ( power_power @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ X ) ) @ N ) @ A2 ) ) ) ).

% neg_numeral_power_less_of_int_cancel_iff
thf(fact_1880_of__int__less__neg__numeral__power__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: int,X: num,N: nat] :
          ( ( ord_less @ A @ ( ring_1_of_int @ A @ A2 ) @ ( power_power @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ X ) ) @ N ) )
          = ( ord_less @ int @ A2 @ ( power_power @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ X ) ) @ N ) ) ) ) ).

% of_int_less_neg_numeral_power_cancel_iff
thf(fact_1881_square__powr__half,axiom,
    ! [X: real] :
      ( ( powr @ real @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
      = ( abs_abs @ real @ X ) ) ).

% square_powr_half
thf(fact_1882_even__succ__mod__exp,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A,N: nat] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
         => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
           => ( ( modulo_modulo @ A @ ( plus_plus @ A @ ( one_one @ A ) @ A2 ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) )
              = ( plus_plus @ A @ ( one_one @ A ) @ ( modulo_modulo @ A @ A2 @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) ) ) ) ) ) ) ).

% even_succ_mod_exp
thf(fact_1883_pochhammer__of__nat,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [X: nat,N: nat] :
          ( ( comm_s3205402744901411588hammer @ A @ ( semiring_1_of_nat @ A @ X ) @ N )
          = ( semiring_1_of_nat @ A @ ( comm_s3205402744901411588hammer @ nat @ X @ N ) ) ) ) ).

% pochhammer_of_nat
thf(fact_1884_abs__ge__minus__self,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A] : ( ord_less_eq @ A @ ( uminus_uminus @ A @ A2 ) @ ( abs_abs @ A @ A2 ) ) ) ).

% abs_ge_minus_self
thf(fact_1885_abs__le__iff,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( abs_abs @ A @ A2 ) @ B2 )
          = ( ( ord_less_eq @ A @ A2 @ B2 )
            & ( ord_less_eq @ A @ ( uminus_uminus @ A @ A2 ) @ B2 ) ) ) ) ).

% abs_le_iff
thf(fact_1886_abs__le__D2,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( abs_abs @ A @ A2 ) @ B2 )
         => ( ord_less_eq @ A @ ( uminus_uminus @ A @ A2 ) @ B2 ) ) ) ).

% abs_le_D2
thf(fact_1887_abs__leI,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ A2 ) @ B2 )
           => ( ord_less_eq @ A @ ( abs_abs @ A @ A2 ) @ B2 ) ) ) ) ).

% abs_leI
thf(fact_1888_equation__minus__iff,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( A2
            = ( uminus_uminus @ A @ B2 ) )
          = ( B2
            = ( uminus_uminus @ A @ A2 ) ) ) ) ).

% equation_minus_iff
thf(fact_1889_minus__equation__iff,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ( uminus_uminus @ A @ A2 )
            = B2 )
          = ( ( uminus_uminus @ A @ B2 )
            = A2 ) ) ) ).

% minus_equation_iff
thf(fact_1890_fun__Compl__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( uminus @ B )
     => ( ( uminus_uminus @ ( A > B ) )
        = ( ^ [A7: A > B,X2: A] : ( uminus_uminus @ B @ ( A7 @ X2 ) ) ) ) ) ).

% fun_Compl_def
thf(fact_1891_verit__negate__coefficient_I3_J,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( A2 = B2 )
         => ( ( uminus_uminus @ A @ A2 )
            = ( uminus_uminus @ A @ B2 ) ) ) ) ).

% verit_negate_coefficient(3)
thf(fact_1892_abs__less__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( abs_abs @ A @ A2 ) @ B2 )
          = ( ( ord_less @ A @ A2 @ B2 )
            & ( ord_less @ A @ ( uminus_uminus @ A @ A2 ) @ B2 ) ) ) ) ).

% abs_less_iff
thf(fact_1893_of__nat__mod,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [M: nat,N: nat] :
          ( ( semiring_1_of_nat @ A @ ( modulo_modulo @ nat @ M @ N ) )
          = ( modulo_modulo @ A @ ( semiring_1_of_nat @ A @ M ) @ ( semiring_1_of_nat @ A @ N ) ) ) ) ).

% of_nat_mod
thf(fact_1894_abs__eq__iff_H,axiom,
    ! [A: $tType] :
      ( ( linordered_ring @ A )
     => ! [A2: A,B2: A] :
          ( ( ( abs_abs @ A @ A2 )
            = B2 )
          = ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 )
            & ( ( A2 = B2 )
              | ( A2
                = ( uminus_uminus @ A @ B2 ) ) ) ) ) ) ).

% abs_eq_iff'
thf(fact_1895_eq__abs__iff_H,axiom,
    ! [A: $tType] :
      ( ( linordered_ring @ A )
     => ! [A2: A,B2: A] :
          ( ( A2
            = ( abs_abs @ A @ B2 ) )
          = ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
            & ( ( B2 = A2 )
              | ( B2
                = ( uminus_uminus @ A @ A2 ) ) ) ) ) ) ).

% eq_abs_iff'
thf(fact_1896_abs__minus__le__zero,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A] : ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( abs_abs @ A @ A2 ) ) @ ( zero_zero @ A ) ) ) ).

% abs_minus_le_zero
thf(fact_1897_abs__if,axiom,
    ! [A: $tType] :
      ( ( abs_if @ A )
     => ( ( abs_abs @ A )
        = ( ^ [A3: A] : ( if @ A @ ( ord_less @ A @ A3 @ ( zero_zero @ A ) ) @ ( uminus_uminus @ A @ A3 ) @ A3 ) ) ) ) ).

% abs_if
thf(fact_1898_abs__if__raw,axiom,
    ! [A: $tType] :
      ( ( abs_if @ A )
     => ( ( abs_abs @ A )
        = ( ^ [A3: A] : ( if @ A @ ( ord_less @ A @ A3 @ ( zero_zero @ A ) ) @ ( uminus_uminus @ A @ A3 ) @ A3 ) ) ) ) ).

% abs_if_raw
thf(fact_1899_abs__of__neg,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
         => ( ( abs_abs @ A @ A2 )
            = ( uminus_uminus @ A @ A2 ) ) ) ) ).

% abs_of_neg
thf(fact_1900_abs__real__def,axiom,
    ( ( abs_abs @ real )
    = ( ^ [A3: real] : ( if @ real @ ( ord_less @ real @ A3 @ ( zero_zero @ real ) ) @ ( uminus_uminus @ real @ A3 ) @ A3 ) ) ) ).

% abs_real_def
thf(fact_1901_abs__le__D1,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( abs_abs @ A @ A2 ) @ B2 )
         => ( ord_less_eq @ A @ A2 @ B2 ) ) ) ).

% abs_le_D1
thf(fact_1902_abs__ge__self,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A] : ( ord_less_eq @ A @ A2 @ ( abs_abs @ A @ A2 ) ) ) ).

% abs_ge_self
thf(fact_1903_abs__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( idom_abs_sgn @ A )
     => ! [A2: A] :
          ( ( ( abs_abs @ A @ A2 )
            = ( zero_zero @ A ) )
          = ( A2
            = ( zero_zero @ A ) ) ) ) ).

% abs_eq_0_iff
thf(fact_1904_abs__minus__commute,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A,B2: A] :
          ( ( abs_abs @ A @ ( minus_minus @ A @ A2 @ B2 ) )
          = ( abs_abs @ A @ ( minus_minus @ A @ B2 @ A2 ) ) ) ) ).

% abs_minus_commute
thf(fact_1905_tanh__real__gt__neg1,axiom,
    ! [X: real] : ( ord_less @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ ( tanh @ real @ X ) ) ).

% tanh_real_gt_neg1
thf(fact_1906_power__abs,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A,N: nat] :
          ( ( abs_abs @ A @ ( power_power @ A @ A2 @ N ) )
          = ( power_power @ A @ ( abs_abs @ A @ A2 ) @ N ) ) ) ).

% power_abs
thf(fact_1907_ceiling__def,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ( ( archimedean_ceiling @ A )
        = ( ^ [X2: A] : ( uminus_uminus @ int @ ( archim6421214686448440834_floor @ A @ ( uminus_uminus @ A @ X2 ) ) ) ) ) ) ).

% ceiling_def
thf(fact_1908_floor__minus,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( archim6421214686448440834_floor @ A @ ( uminus_uminus @ A @ X ) )
          = ( uminus_uminus @ int @ ( archimedean_ceiling @ A @ X ) ) ) ) ).

% floor_minus
thf(fact_1909_ceiling__minus,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( archimedean_ceiling @ A @ ( uminus_uminus @ A @ X ) )
          = ( uminus_uminus @ int @ ( archim6421214686448440834_floor @ A @ X ) ) ) ) ).

% ceiling_minus
thf(fact_1910_power__mod,axiom,
    ! [A: $tType] :
      ( ( euclid4440199948858584721cancel @ A )
     => ! [A2: A,B2: A,N: nat] :
          ( ( modulo_modulo @ A @ ( power_power @ A @ ( modulo_modulo @ A @ A2 @ B2 ) @ N ) @ B2 )
          = ( modulo_modulo @ A @ ( power_power @ A @ A2 @ N ) @ B2 ) ) ) ).

% power_mod
thf(fact_1911_le__minus__iff,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ ( uminus_uminus @ A @ B2 ) )
          = ( ord_less_eq @ A @ B2 @ ( uminus_uminus @ A @ A2 ) ) ) ) ).

% le_minus_iff
thf(fact_1912_minus__le__iff,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ A2 ) @ B2 )
          = ( ord_less_eq @ A @ ( uminus_uminus @ A @ B2 ) @ A2 ) ) ) ).

% minus_le_iff
thf(fact_1913_le__imp__neg__le,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ord_less_eq @ A @ ( uminus_uminus @ A @ B2 ) @ ( uminus_uminus @ A @ A2 ) ) ) ) ).

% le_imp_neg_le
thf(fact_1914_verit__negate__coefficient_I2_J,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ord_less @ A @ ( uminus_uminus @ A @ B2 ) @ ( uminus_uminus @ A @ A2 ) ) ) ) ).

% verit_negate_coefficient(2)
thf(fact_1915_less__minus__iff,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ ( uminus_uminus @ A @ B2 ) )
          = ( ord_less @ A @ B2 @ ( uminus_uminus @ A @ A2 ) ) ) ) ).

% less_minus_iff
thf(fact_1916_minus__less__iff,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( uminus_uminus @ A @ A2 ) @ B2 )
          = ( ord_less @ A @ ( uminus_uminus @ A @ B2 ) @ A2 ) ) ) ).

% minus_less_iff
thf(fact_1917_neg__numeral__neq__numeral,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [M: num,N: num] :
          ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) )
         != ( numeral_numeral @ A @ N ) ) ) ).

% neg_numeral_neq_numeral
thf(fact_1918_numeral__neq__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [M: num,N: num] :
          ( ( numeral_numeral @ A @ M )
         != ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) ) ) ).

% numeral_neq_neg_numeral
thf(fact_1919_mod__less__eq__dividend,axiom,
    ! [M: nat,N: nat] : ( ord_less_eq @ nat @ ( modulo_modulo @ nat @ M @ N ) @ M ) ).

% mod_less_eq_dividend
thf(fact_1920_one__neq__neg__one,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ( ( one_one @ A )
       != ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% one_neq_neg_one
thf(fact_1921_group__cancel_Oneg1,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [A4: A,K: A,A2: A] :
          ( ( A4
            = ( plus_plus @ A @ K @ A2 ) )
         => ( ( uminus_uminus @ A @ A4 )
            = ( plus_plus @ A @ ( uminus_uminus @ A @ K ) @ ( uminus_uminus @ A @ A2 ) ) ) ) ) ).

% group_cancel.neg1
thf(fact_1922_add_Oinverse__distrib__swap,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( uminus_uminus @ A @ ( plus_plus @ A @ A2 @ B2 ) )
          = ( plus_plus @ A @ ( uminus_uminus @ A @ B2 ) @ ( uminus_uminus @ A @ A2 ) ) ) ) ).

% add.inverse_distrib_swap
thf(fact_1923_is__num__normalize_I8_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [A2: A,B2: A] :
          ( ( uminus_uminus @ A @ ( plus_plus @ A @ A2 @ B2 ) )
          = ( plus_plus @ A @ ( uminus_uminus @ A @ B2 ) @ ( uminus_uminus @ A @ A2 ) ) ) ) ).

% is_num_normalize(8)
thf(fact_1924_minus__diff__commute,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [B2: A,A2: A] :
          ( ( minus_minus @ A @ ( uminus_uminus @ A @ B2 ) @ A2 )
          = ( minus_minus @ A @ ( uminus_uminus @ A @ A2 ) @ B2 ) ) ) ).

% minus_diff_commute
thf(fact_1925_minus__diff__minus,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( minus_minus @ A @ ( uminus_uminus @ A @ A2 ) @ ( uminus_uminus @ A @ B2 ) )
          = ( uminus_uminus @ A @ ( minus_minus @ A @ A2 @ B2 ) ) ) ) ).

% minus_diff_minus
thf(fact_1926_real__minus__mult__self__le,axiom,
    ! [U: real,X: real] : ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( times_times @ real @ U @ U ) ) @ ( times_times @ real @ X @ X ) ) ).

% real_minus_mult_self_le
thf(fact_1927_real__sqrt__minus,axiom,
    ! [X: real] :
      ( ( sqrt @ ( uminus_uminus @ real @ X ) )
      = ( uminus_uminus @ real @ ( sqrt @ X ) ) ) ).

% real_sqrt_minus
thf(fact_1928_pochhammer__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: A,N: nat] :
          ( ( ( comm_s3205402744901411588hammer @ A @ A2 @ N )
            = ( zero_zero @ A ) )
          = ( ? [K3: nat] :
                ( ( ord_less @ nat @ K3 @ N )
                & ( A2
                  = ( uminus_uminus @ A @ ( semiring_1_of_nat @ A @ K3 ) ) ) ) ) ) ) ).

% pochhammer_eq_0_iff
thf(fact_1929_pochhammer__of__nat__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( ( ring_char_0 @ A )
        & ( idom @ A ) )
     => ! [N: nat,K: nat] :
          ( ( ( comm_s3205402744901411588hammer @ A @ ( uminus_uminus @ A @ ( semiring_1_of_nat @ A @ N ) ) @ K )
            = ( zero_zero @ A ) )
          = ( ord_less @ nat @ N @ K ) ) ) ).

% pochhammer_of_nat_eq_0_iff
thf(fact_1930_pochhammer__of__nat__eq__0__lemma,axiom,
    ! [A: $tType] :
      ( ( idom @ A )
     => ! [N: nat,K: nat] :
          ( ( ord_less @ nat @ N @ K )
         => ( ( comm_s3205402744901411588hammer @ A @ ( uminus_uminus @ A @ ( semiring_1_of_nat @ A @ N ) ) @ K )
            = ( zero_zero @ A ) ) ) ) ).

% pochhammer_of_nat_eq_0_lemma
thf(fact_1931_pochhammer__of__nat__eq__0__lemma_H,axiom,
    ! [A: $tType] :
      ( ( ( ring_char_0 @ A )
        & ( idom @ A ) )
     => ! [K: nat,N: nat] :
          ( ( ord_less_eq @ nat @ K @ N )
         => ( ( comm_s3205402744901411588hammer @ A @ ( uminus_uminus @ A @ ( semiring_1_of_nat @ A @ N ) ) @ K )
           != ( zero_zero @ A ) ) ) ) ).

% pochhammer_of_nat_eq_0_lemma'
thf(fact_1932_of__int__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [K: num] :
          ( ( ring_1_of_int @ A @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ K ) ) )
          = ( uminus_uminus @ A @ ( numeral_numeral @ A @ K ) ) ) ) ).

% of_int_neg_numeral
thf(fact_1933_abs__ge__zero,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( abs_abs @ A @ A2 ) ) ) ).

% abs_ge_zero
thf(fact_1934_abs__of__pos,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( abs_abs @ A @ A2 )
            = A2 ) ) ) ).

% abs_of_pos
thf(fact_1935_abs__not__less__zero,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A] :
          ~ ( ord_less @ A @ ( abs_abs @ A @ A2 ) @ ( zero_zero @ A ) ) ) ).

% abs_not_less_zero
thf(fact_1936_abs__triangle__ineq,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A,B2: A] : ( ord_less_eq @ A @ ( abs_abs @ A @ ( plus_plus @ A @ A2 @ B2 ) ) @ ( plus_plus @ A @ ( abs_abs @ A @ A2 ) @ ( abs_abs @ A @ B2 ) ) ) ) ).

% abs_triangle_ineq
thf(fact_1937_abs__mult__less,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A,C2: A,B2: A,D2: A] :
          ( ( ord_less @ A @ ( abs_abs @ A @ A2 ) @ C2 )
         => ( ( ord_less @ A @ ( abs_abs @ A @ B2 ) @ D2 )
           => ( ord_less @ A @ ( times_times @ A @ ( abs_abs @ A @ A2 ) @ ( abs_abs @ A @ B2 ) ) @ ( times_times @ A @ C2 @ D2 ) ) ) ) ) ).

% abs_mult_less
thf(fact_1938_abs__triangle__ineq2__sym,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A,B2: A] : ( ord_less_eq @ A @ ( minus_minus @ A @ ( abs_abs @ A @ A2 ) @ ( abs_abs @ A @ B2 ) ) @ ( abs_abs @ A @ ( minus_minus @ A @ B2 @ A2 ) ) ) ) ).

% abs_triangle_ineq2_sym
thf(fact_1939_abs__triangle__ineq3,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A,B2: A] : ( ord_less_eq @ A @ ( abs_abs @ A @ ( minus_minus @ A @ ( abs_abs @ A @ A2 ) @ ( abs_abs @ A @ B2 ) ) ) @ ( abs_abs @ A @ ( minus_minus @ A @ A2 @ B2 ) ) ) ) ).

% abs_triangle_ineq3
thf(fact_1940_abs__triangle__ineq2,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A,B2: A] : ( ord_less_eq @ A @ ( minus_minus @ A @ ( abs_abs @ A @ A2 ) @ ( abs_abs @ A @ B2 ) ) @ ( abs_abs @ A @ ( minus_minus @ A @ A2 @ B2 ) ) ) ) ).

% abs_triangle_ineq2
thf(fact_1941_nonzero__abs__divide,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,A2: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( abs_abs @ A @ ( divide_divide @ A @ A2 @ B2 ) )
            = ( divide_divide @ A @ ( abs_abs @ A @ A2 ) @ ( abs_abs @ A @ B2 ) ) ) ) ) ).

% nonzero_abs_divide
thf(fact_1942_unique__euclidean__semiring__numeral__class_Omod__less__eq__dividend,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( ord_less_eq @ A @ ( modulo_modulo @ A @ A2 @ B2 ) @ A2 ) ) ) ).

% unique_euclidean_semiring_numeral_class.mod_less_eq_dividend
thf(fact_1943_unique__euclidean__semiring__numeral__class_Opos__mod__bound,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ B2 )
         => ( ord_less @ A @ ( modulo_modulo @ A @ A2 @ B2 ) @ B2 ) ) ) ).

% unique_euclidean_semiring_numeral_class.pos_mod_bound
thf(fact_1944_mod__eq__self__iff__div__eq__0,axiom,
    ! [A: $tType] :
      ( ( euclid3725896446679973847miring @ A )
     => ! [A2: A,B2: A] :
          ( ( ( modulo_modulo @ A @ A2 @ B2 )
            = A2 )
          = ( ( divide_divide @ A @ A2 @ B2 )
            = ( zero_zero @ A ) ) ) ) ).

% mod_eq_self_iff_div_eq_0
thf(fact_1945_cong__exp__iff__simps_I9_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [M: num,Q3: num,N: num] :
          ( ( ( modulo_modulo @ A @ ( numeral_numeral @ A @ ( bit0 @ M ) ) @ ( numeral_numeral @ A @ ( bit0 @ Q3 ) ) )
            = ( modulo_modulo @ A @ ( numeral_numeral @ A @ ( bit0 @ N ) ) @ ( numeral_numeral @ A @ ( bit0 @ Q3 ) ) ) )
          = ( ( modulo_modulo @ A @ ( numeral_numeral @ A @ M ) @ ( numeral_numeral @ A @ Q3 ) )
            = ( modulo_modulo @ A @ ( numeral_numeral @ A @ N ) @ ( numeral_numeral @ A @ Q3 ) ) ) ) ) ).

% cong_exp_iff_simps(9)
thf(fact_1946_cong__exp__iff__simps_I4_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [M: num,N: num] :
          ( ( modulo_modulo @ A @ ( numeral_numeral @ A @ M ) @ ( numeral_numeral @ A @ one2 ) )
          = ( modulo_modulo @ A @ ( numeral_numeral @ A @ N ) @ ( numeral_numeral @ A @ one2 ) ) ) ) ).

% cong_exp_iff_simps(4)
thf(fact_1947_mod__eq__0__iff__dvd,axiom,
    ! [A: $tType] :
      ( ( semidom_modulo @ A )
     => ! [A2: A,B2: A] :
          ( ( ( modulo_modulo @ A @ A2 @ B2 )
            = ( zero_zero @ A ) )
          = ( dvd_dvd @ A @ B2 @ A2 ) ) ) ).

% mod_eq_0_iff_dvd
thf(fact_1948_dvd__eq__mod__eq__0,axiom,
    ! [A: $tType] :
      ( ( semidom_modulo @ A )
     => ( ( dvd_dvd @ A )
        = ( ^ [A3: A,B3: A] :
              ( ( modulo_modulo @ A @ B3 @ A3 )
              = ( zero_zero @ A ) ) ) ) ) ).

% dvd_eq_mod_eq_0
thf(fact_1949_mod__0__imp__dvd,axiom,
    ! [A: $tType] :
      ( ( semiring_modulo @ A )
     => ! [A2: A,B2: A] :
          ( ( ( modulo_modulo @ A @ A2 @ B2 )
            = ( zero_zero @ A ) )
         => ( dvd_dvd @ A @ B2 @ A2 ) ) ) ).

% mod_0_imp_dvd
thf(fact_1950_neg__numeral__le__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M: num,N: num] : ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) @ ( numeral_numeral @ A @ N ) ) ) ).

% neg_numeral_le_numeral
thf(fact_1951_not__numeral__le__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M: num,N: num] :
          ~ ( ord_less_eq @ A @ ( numeral_numeral @ A @ M ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) ) ) ).

% not_numeral_le_neg_numeral
thf(fact_1952_zero__neq__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [N: num] :
          ( ( zero_zero @ A )
         != ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) ) ) ).

% zero_neq_neg_numeral
thf(fact_1953_gcd__nat__induct,axiom,
    ! [P: nat > nat > $o,M: nat,N: nat] :
      ( ! [M4: nat] : ( P @ M4 @ ( zero_zero @ nat ) )
     => ( ! [M4: nat,N2: nat] :
            ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
           => ( ( P @ N2 @ ( modulo_modulo @ nat @ M4 @ N2 ) )
             => ( P @ M4 @ N2 ) ) )
       => ( P @ M @ N ) ) ) ).

% gcd_nat_induct
thf(fact_1954_mod__less__divisor,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ord_less @ nat @ ( modulo_modulo @ nat @ M @ N ) @ N ) ) ).

% mod_less_divisor
thf(fact_1955_neg__numeral__less__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M: num,N: num] : ( ord_less @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) @ ( numeral_numeral @ A @ N ) ) ) ).

% neg_numeral_less_numeral
thf(fact_1956_not__numeral__less__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M: num,N: num] :
          ~ ( ord_less @ A @ ( numeral_numeral @ A @ M ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) ) ) ).

% not_numeral_less_neg_numeral
thf(fact_1957_le__minus__one__simps_I2_J,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( one_one @ A ) ) ) ).

% le_minus_one_simps(2)
thf(fact_1958_le__minus__one__simps_I4_J,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ~ ( ord_less_eq @ A @ ( one_one @ A ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% le_minus_one_simps(4)
thf(fact_1959_zero__neq__neg__one,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ( ( zero_zero @ A )
       != ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% zero_neq_neg_one
thf(fact_1960_add__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ( plus_plus @ A @ A2 @ B2 )
            = ( zero_zero @ A ) )
          = ( B2
            = ( uminus_uminus @ A @ A2 ) ) ) ) ).

% add_eq_0_iff
thf(fact_1961_ab__group__add__class_Oab__left__minus,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [A2: A] :
          ( ( plus_plus @ A @ ( uminus_uminus @ A @ A2 ) @ A2 )
          = ( zero_zero @ A ) ) ) ).

% ab_group_add_class.ab_left_minus
thf(fact_1962_add_Oinverse__unique,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ( plus_plus @ A @ A2 @ B2 )
            = ( zero_zero @ A ) )
         => ( ( uminus_uminus @ A @ A2 )
            = B2 ) ) ) ).

% add.inverse_unique
thf(fact_1963_eq__neg__iff__add__eq__0,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( A2
            = ( uminus_uminus @ A @ B2 ) )
          = ( ( plus_plus @ A @ A2 @ B2 )
            = ( zero_zero @ A ) ) ) ) ).

% eq_neg_iff_add_eq_0
thf(fact_1964_neg__eq__iff__add__eq__0,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ! [A2: A,B2: A] :
          ( ( ( uminus_uminus @ A @ A2 )
            = B2 )
          = ( ( plus_plus @ A @ A2 @ B2 )
            = ( zero_zero @ A ) ) ) ) ).

% neg_eq_iff_add_eq_0
thf(fact_1965_less__minus__one__simps_I2_J,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ( ord_less @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( one_one @ A ) ) ) ).

% less_minus_one_simps(2)
thf(fact_1966_less__minus__one__simps_I4_J,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ~ ( ord_less @ A @ ( one_one @ A ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% less_minus_one_simps(4)
thf(fact_1967_numeral__times__minus__swap,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [W: num,X: A] :
          ( ( times_times @ A @ ( numeral_numeral @ A @ W ) @ ( uminus_uminus @ A @ X ) )
          = ( times_times @ A @ X @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) ) ) ) ).

% numeral_times_minus_swap
thf(fact_1968_nonzero__minus__divide__right,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [B2: A,A2: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( uminus_uminus @ A @ ( divide_divide @ A @ A2 @ B2 ) )
            = ( divide_divide @ A @ A2 @ ( uminus_uminus @ A @ B2 ) ) ) ) ) ).

% nonzero_minus_divide_right
thf(fact_1969_nonzero__minus__divide__divide,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [B2: A,A2: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( divide_divide @ A @ ( uminus_uminus @ A @ A2 ) @ ( uminus_uminus @ A @ B2 ) )
            = ( divide_divide @ A @ A2 @ B2 ) ) ) ) ).

% nonzero_minus_divide_divide
thf(fact_1970_one__neq__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [N: num] :
          ( ( one_one @ A )
         != ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) ) ) ).

% one_neq_neg_numeral
thf(fact_1971_numeral__neq__neg__one,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [N: num] :
          ( ( numeral_numeral @ A @ N )
         != ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% numeral_neq_neg_one
thf(fact_1972_group__cancel_Osub2,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [B7: A,K: A,B2: A,A2: A] :
          ( ( B7
            = ( plus_plus @ A @ K @ B2 ) )
         => ( ( minus_minus @ A @ A2 @ B7 )
            = ( plus_plus @ A @ ( uminus_uminus @ A @ K ) @ ( minus_minus @ A @ A2 @ B2 ) ) ) ) ) ).

% group_cancel.sub2
thf(fact_1973_diff__conv__add__uminus,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ( ( minus_minus @ A )
        = ( ^ [A3: A,B3: A] : ( plus_plus @ A @ A3 @ ( uminus_uminus @ A @ B3 ) ) ) ) ) ).

% diff_conv_add_uminus
thf(fact_1974_ab__group__add__class_Oab__diff__conv__add__uminus,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ( ( minus_minus @ A )
        = ( ^ [A3: A,B3: A] : ( plus_plus @ A @ A3 @ ( uminus_uminus @ A @ B3 ) ) ) ) ) ).

% ab_group_add_class.ab_diff_conv_add_uminus
thf(fact_1975_mod__eq__0D,axiom,
    ! [M: nat,D2: nat] :
      ( ( ( modulo_modulo @ nat @ M @ D2 )
        = ( zero_zero @ nat ) )
     => ? [Q5: nat] :
          ( M
          = ( times_times @ nat @ D2 @ Q5 ) ) ) ).

% mod_eq_0D
thf(fact_1976_mod__geq,axiom,
    ! [M: nat,N: nat] :
      ( ~ ( ord_less @ nat @ M @ N )
     => ( ( modulo_modulo @ nat @ M @ N )
        = ( modulo_modulo @ nat @ ( minus_minus @ nat @ M @ N ) @ N ) ) ) ).

% mod_geq
thf(fact_1977_mod__if,axiom,
    ( ( modulo_modulo @ nat )
    = ( ^ [M3: nat,N3: nat] : ( if @ nat @ ( ord_less @ nat @ M3 @ N3 ) @ M3 @ ( modulo_modulo @ nat @ ( minus_minus @ nat @ M3 @ N3 ) @ N3 ) ) ) ) ).

% mod_if
thf(fact_1978_le__mod__geq,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less_eq @ nat @ N @ M )
     => ( ( modulo_modulo @ nat @ M @ N )
        = ( modulo_modulo @ nat @ ( minus_minus @ nat @ M @ N ) @ N ) ) ) ).

% le_mod_geq
thf(fact_1979_pochhammer__pos,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [X: A,N: nat] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ X )
         => ( ord_less @ A @ ( zero_zero @ A ) @ ( comm_s3205402744901411588hammer @ A @ X @ N ) ) ) ) ).

% pochhammer_pos
thf(fact_1980_pochhammer__eq__0__mono,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: A,N: nat,M: nat] :
          ( ( ( comm_s3205402744901411588hammer @ A @ A2 @ N )
            = ( zero_zero @ A ) )
         => ( ( ord_less_eq @ nat @ N @ M )
           => ( ( comm_s3205402744901411588hammer @ A @ A2 @ M )
              = ( zero_zero @ A ) ) ) ) ) ).

% pochhammer_eq_0_mono
thf(fact_1981_pochhammer__neq__0__mono,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: A,M: nat,N: nat] :
          ( ( ( comm_s3205402744901411588hammer @ A @ A2 @ M )
           != ( zero_zero @ A ) )
         => ( ( ord_less_eq @ nat @ N @ M )
           => ( ( comm_s3205402744901411588hammer @ A @ A2 @ N )
             != ( zero_zero @ A ) ) ) ) ) ).

% pochhammer_neq_0_mono
thf(fact_1982_minus__real__def,axiom,
    ( ( minus_minus @ real )
    = ( ^ [X2: real,Y4: real] : ( plus_plus @ real @ X2 @ ( uminus_uminus @ real @ Y4 ) ) ) ) ).

% minus_real_def
thf(fact_1983_pochhammer__absorb__comp,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [R2: A,K: nat] :
          ( ( times_times @ A @ ( minus_minus @ A @ R2 @ ( semiring_1_of_nat @ A @ K ) ) @ ( comm_s3205402744901411588hammer @ A @ ( uminus_uminus @ A @ R2 ) @ K ) )
          = ( times_times @ A @ R2 @ ( comm_s3205402744901411588hammer @ A @ ( plus_plus @ A @ ( uminus_uminus @ A @ R2 ) @ ( one_one @ A ) ) @ K ) ) ) ) ).

% pochhammer_absorb_comp
thf(fact_1984_tanh__real__lt__1,axiom,
    ! [X: real] : ( ord_less @ real @ ( tanh @ real @ X ) @ ( one_one @ real ) ) ).

% tanh_real_lt_1
thf(fact_1985_of__int__of__nat,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ( ( ring_1_of_int @ A )
        = ( ^ [K3: int] : ( if @ A @ ( ord_less @ int @ K3 @ ( zero_zero @ int ) ) @ ( uminus_uminus @ A @ ( semiring_1_of_nat @ A @ ( nat2 @ ( uminus_uminus @ int @ K3 ) ) ) ) @ ( semiring_1_of_nat @ A @ ( nat2 @ K3 ) ) ) ) ) ) ).

% of_int_of_nat
thf(fact_1986_frac__ge__0,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( archimedean_frac @ A @ X ) ) ) ).

% frac_ge_0
thf(fact_1987_frac__lt__1,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] : ( ord_less @ A @ ( archimedean_frac @ A @ X ) @ ( one_one @ A ) ) ) ).

% frac_lt_1
thf(fact_1988_frac__1__eq,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( archimedean_frac @ A @ ( plus_plus @ A @ X @ ( one_one @ A ) ) )
          = ( archimedean_frac @ A @ X ) ) ) ).

% frac_1_eq
thf(fact_1989_dense__eq0__I,axiom,
    ! [A: $tType] :
      ( ( ( ordere166539214618696060dd_abs @ A )
        & ( dense_linorder @ A ) )
     => ! [X: A] :
          ( ! [E: A] :
              ( ( ord_less @ A @ ( zero_zero @ A ) @ E )
             => ( ord_less_eq @ A @ ( abs_abs @ A @ X ) @ E ) )
         => ( X
            = ( zero_zero @ A ) ) ) ) ).

% dense_eq0_I
thf(fact_1990_abs__mult__pos,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X )
         => ( ( times_times @ A @ ( abs_abs @ A @ Y ) @ X )
            = ( abs_abs @ A @ ( times_times @ A @ Y @ X ) ) ) ) ) ).

% abs_mult_pos
thf(fact_1991_abs__eq__mult,axiom,
    ! [A: $tType] :
      ( ( ordered_ring_abs @ A )
     => ! [A2: A,B2: A] :
          ( ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
              | ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) ) )
            & ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 )
              | ( ord_less_eq @ A @ B2 @ ( zero_zero @ A ) ) ) )
         => ( ( abs_abs @ A @ ( times_times @ A @ A2 @ B2 ) )
            = ( times_times @ A @ ( abs_abs @ A @ A2 ) @ ( abs_abs @ A @ B2 ) ) ) ) ) ).

% abs_eq_mult
thf(fact_1992_abs__div__pos,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [Y: A,X: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ Y )
         => ( ( divide_divide @ A @ ( abs_abs @ A @ X ) @ Y )
            = ( abs_abs @ A @ ( divide_divide @ A @ X @ Y ) ) ) ) ) ).

% abs_div_pos
thf(fact_1993_zero__le__power__abs,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A,N: nat] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( power_power @ A @ ( abs_abs @ A @ A2 ) @ N ) ) ) ).

% zero_le_power_abs
thf(fact_1994_abs__diff__le__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: A,A2: A,R2: A] :
          ( ( ord_less_eq @ A @ ( abs_abs @ A @ ( minus_minus @ A @ X @ A2 ) ) @ R2 )
          = ( ( ord_less_eq @ A @ ( minus_minus @ A @ A2 @ R2 ) @ X )
            & ( ord_less_eq @ A @ X @ ( plus_plus @ A @ A2 @ R2 ) ) ) ) ) ).

% abs_diff_le_iff
thf(fact_1995_abs__diff__triangle__ineq,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] : ( ord_less_eq @ A @ ( abs_abs @ A @ ( minus_minus @ A @ ( plus_plus @ A @ A2 @ B2 ) @ ( plus_plus @ A @ C2 @ D2 ) ) ) @ ( plus_plus @ A @ ( abs_abs @ A @ ( minus_minus @ A @ A2 @ C2 ) ) @ ( abs_abs @ A @ ( minus_minus @ A @ B2 @ D2 ) ) ) ) ) ).

% abs_diff_triangle_ineq
thf(fact_1996_abs__triangle__ineq4,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [A2: A,B2: A] : ( ord_less_eq @ A @ ( abs_abs @ A @ ( minus_minus @ A @ A2 @ B2 ) ) @ ( plus_plus @ A @ ( abs_abs @ A @ A2 ) @ ( abs_abs @ A @ B2 ) ) ) ) ).

% abs_triangle_ineq4
thf(fact_1997_abs__diff__less__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: A,A2: A,R2: A] :
          ( ( ord_less @ A @ ( abs_abs @ A @ ( minus_minus @ A @ X @ A2 ) ) @ R2 )
          = ( ( ord_less @ A @ ( minus_minus @ A @ A2 @ R2 ) @ X )
            & ( ord_less @ A @ X @ ( plus_plus @ A @ A2 @ R2 ) ) ) ) ) ).

% abs_diff_less_iff
thf(fact_1998_unique__euclidean__semiring__numeral__class_Omod__less,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less @ A @ A2 @ B2 )
           => ( ( modulo_modulo @ A @ A2 @ B2 )
              = A2 ) ) ) ) ).

% unique_euclidean_semiring_numeral_class.mod_less
thf(fact_1999_unique__euclidean__semiring__numeral__class_Opos__mod__sign,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ B2 )
         => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( modulo_modulo @ A @ A2 @ B2 ) ) ) ) ).

% unique_euclidean_semiring_numeral_class.pos_mod_sign
thf(fact_2000_cong__exp__iff__simps_I2_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [N: num,Q3: num] :
          ( ( ( modulo_modulo @ A @ ( numeral_numeral @ A @ ( bit0 @ N ) ) @ ( numeral_numeral @ A @ ( bit0 @ Q3 ) ) )
            = ( zero_zero @ A ) )
          = ( ( modulo_modulo @ A @ ( numeral_numeral @ A @ N ) @ ( numeral_numeral @ A @ Q3 ) )
            = ( zero_zero @ A ) ) ) ) ).

% cong_exp_iff_simps(2)
thf(fact_2001_cong__exp__iff__simps_I1_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [N: num] :
          ( ( modulo_modulo @ A @ ( numeral_numeral @ A @ N ) @ ( numeral_numeral @ A @ one2 ) )
          = ( zero_zero @ A ) ) ) ).

% cong_exp_iff_simps(1)
thf(fact_2002_cong__exp__iff__simps_I8_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [M: num,Q3: num] :
          ( ( modulo_modulo @ A @ ( numeral_numeral @ A @ ( bit0 @ M ) ) @ ( numeral_numeral @ A @ ( bit0 @ Q3 ) ) )
         != ( modulo_modulo @ A @ ( numeral_numeral @ A @ one2 ) @ ( numeral_numeral @ A @ ( bit0 @ Q3 ) ) ) ) ) ).

% cong_exp_iff_simps(8)
thf(fact_2003_cong__exp__iff__simps_I6_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [Q3: num,N: num] :
          ( ( modulo_modulo @ A @ ( numeral_numeral @ A @ one2 ) @ ( numeral_numeral @ A @ ( bit0 @ Q3 ) ) )
         != ( modulo_modulo @ A @ ( numeral_numeral @ A @ ( bit0 @ N ) ) @ ( numeral_numeral @ A @ ( bit0 @ Q3 ) ) ) ) ) ).

% cong_exp_iff_simps(6)
thf(fact_2004_unit__imp__mod__eq__0,axiom,
    ! [A: $tType] :
      ( ( euclid3725896446679973847miring @ A )
     => ! [B2: A,A2: A] :
          ( ( dvd_dvd @ A @ B2 @ ( one_one @ A ) )
         => ( ( modulo_modulo @ A @ A2 @ B2 )
            = ( zero_zero @ A ) ) ) ) ).

% unit_imp_mod_eq_0
thf(fact_2005_pochhammer__minus,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [B2: A,K: nat] :
          ( ( comm_s3205402744901411588hammer @ A @ ( uminus_uminus @ A @ B2 ) @ K )
          = ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ K ) @ ( comm_s3205402744901411588hammer @ A @ ( plus_plus @ A @ ( minus_minus @ A @ B2 @ ( semiring_1_of_nat @ A @ K ) ) @ ( one_one @ A ) ) @ K ) ) ) ) ).

% pochhammer_minus
thf(fact_2006_pochhammer__minus_H,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [B2: A,K: nat] :
          ( ( comm_s3205402744901411588hammer @ A @ ( plus_plus @ A @ ( minus_minus @ A @ B2 @ ( semiring_1_of_nat @ A @ K ) ) @ ( one_one @ A ) ) @ K )
          = ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ K ) @ ( comm_s3205402744901411588hammer @ A @ ( uminus_uminus @ A @ B2 ) @ K ) ) ) ) ).

% pochhammer_minus'
thf(fact_2007_neg__numeral__le__zero,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N: num] : ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) @ ( zero_zero @ A ) ) ) ).

% neg_numeral_le_zero
thf(fact_2008_not__zero__le__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N: num] :
          ~ ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) ) ) ).

% not_zero_le_neg_numeral
thf(fact_2009_neg__numeral__less__zero,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N: num] : ( ord_less @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) @ ( zero_zero @ A ) ) ) ).

% neg_numeral_less_zero
thf(fact_2010_not__zero__less__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N: num] :
          ~ ( ord_less @ A @ ( zero_zero @ A ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) ) ) ).

% not_zero_less_neg_numeral
thf(fact_2011_le__minus__one__simps_I3_J,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ~ ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% le_minus_one_simps(3)
thf(fact_2012_le__minus__one__simps_I1_J,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( zero_zero @ A ) ) ) ).

% le_minus_one_simps(1)
thf(fact_2013_less__minus__one__simps_I3_J,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ~ ( ord_less @ A @ ( zero_zero @ A ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% less_minus_one_simps(3)
thf(fact_2014_less__minus__one__simps_I1_J,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ( ord_less @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( zero_zero @ A ) ) ) ).

% less_minus_one_simps(1)
thf(fact_2015_neg__numeral__le__one,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M: num] : ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) @ ( one_one @ A ) ) ) ).

% neg_numeral_le_one
thf(fact_2016_neg__one__le__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M: num] : ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( numeral_numeral @ A @ M ) ) ) ).

% neg_one_le_numeral
thf(fact_2017_neg__numeral__le__neg__one,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M: num] : ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% neg_numeral_le_neg_one
thf(fact_2018_not__numeral__le__neg__one,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M: num] :
          ~ ( ord_less_eq @ A @ ( numeral_numeral @ A @ M ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% not_numeral_le_neg_one
thf(fact_2019_not__one__le__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M: num] :
          ~ ( ord_less_eq @ A @ ( one_one @ A ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) ) ) ).

% not_one_le_neg_numeral
thf(fact_2020_mod__le__divisor,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ord_less_eq @ nat @ ( modulo_modulo @ nat @ M @ N ) @ N ) ) ).

% mod_le_divisor
thf(fact_2021_neg__numeral__less__one,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M: num] : ( ord_less @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) @ ( one_one @ A ) ) ) ).

% neg_numeral_less_one
thf(fact_2022_neg__one__less__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M: num] : ( ord_less @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( numeral_numeral @ A @ M ) ) ) ).

% neg_one_less_numeral
thf(fact_2023_not__numeral__less__neg__one,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M: num] :
          ~ ( ord_less @ A @ ( numeral_numeral @ A @ M ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% not_numeral_less_neg_one
thf(fact_2024_not__one__less__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M: num] :
          ~ ( ord_less @ A @ ( one_one @ A ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) ) ) ).

% not_one_less_neg_numeral
thf(fact_2025_not__neg__one__less__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [M: num] :
          ~ ( ord_less @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) ) ) ).

% not_neg_one_less_neg_numeral
thf(fact_2026_eq__minus__divide__eq,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( A2
            = ( uminus_uminus @ A @ ( divide_divide @ A @ B2 @ C2 ) ) )
          = ( ( ( C2
               != ( zero_zero @ A ) )
             => ( ( times_times @ A @ A2 @ C2 )
                = ( uminus_uminus @ A @ B2 ) ) )
            & ( ( C2
                = ( zero_zero @ A ) )
             => ( A2
                = ( zero_zero @ A ) ) ) ) ) ) ).

% eq_minus_divide_eq
thf(fact_2027_minus__divide__eq__eq,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( ( uminus_uminus @ A @ ( divide_divide @ A @ B2 @ C2 ) )
            = A2 )
          = ( ( ( C2
               != ( zero_zero @ A ) )
             => ( ( uminus_uminus @ A @ B2 )
                = ( times_times @ A @ A2 @ C2 ) ) )
            & ( ( C2
                = ( zero_zero @ A ) )
             => ( A2
                = ( zero_zero @ A ) ) ) ) ) ) ).

% minus_divide_eq_eq
thf(fact_2028_nonzero__neg__divide__eq__eq,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( ( uminus_uminus @ A @ ( divide_divide @ A @ A2 @ B2 ) )
              = C2 )
            = ( ( uminus_uminus @ A @ A2 )
              = ( times_times @ A @ C2 @ B2 ) ) ) ) ) ).

% nonzero_neg_divide_eq_eq
thf(fact_2029_nonzero__neg__divide__eq__eq2,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( C2
              = ( uminus_uminus @ A @ ( divide_divide @ A @ A2 @ B2 ) ) )
            = ( ( times_times @ A @ C2 @ B2 )
              = ( uminus_uminus @ A @ A2 ) ) ) ) ) ).

% nonzero_neg_divide_eq_eq2
thf(fact_2030_divide__eq__minus__1__iff,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A2: A,B2: A] :
          ( ( ( divide_divide @ A @ A2 @ B2 )
            = ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( ( B2
             != ( zero_zero @ A ) )
            & ( A2
              = ( uminus_uminus @ A @ B2 ) ) ) ) ) ).

% divide_eq_minus_1_iff
thf(fact_2031_mult__1s__ring__1_I2_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [B2: A] :
          ( ( times_times @ A @ B2 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ one2 ) ) )
          = ( uminus_uminus @ A @ B2 ) ) ) ).

% mult_1s_ring_1(2)
thf(fact_2032_mult__1s__ring__1_I1_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [B2: A] :
          ( ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ one2 ) ) @ B2 )
          = ( uminus_uminus @ A @ B2 ) ) ) ).

% mult_1s_ring_1(1)
thf(fact_2033_uminus__numeral__One,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ one2 ) )
        = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% uminus_numeral_One
thf(fact_2034_power__minus,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [A2: A,N: nat] :
          ( ( power_power @ A @ ( uminus_uminus @ A @ A2 ) @ N )
          = ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ N ) @ ( power_power @ A @ A2 @ N ) ) ) ) ).

% power_minus
thf(fact_2035_div__less__mono,axiom,
    ! [A4: nat,B7: nat,N: nat] :
      ( ( ord_less @ nat @ A4 @ B7 )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
       => ( ( ( modulo_modulo @ nat @ A4 @ N )
            = ( zero_zero @ nat ) )
         => ( ( ( modulo_modulo @ nat @ B7 @ N )
              = ( zero_zero @ nat ) )
           => ( ord_less @ nat @ ( divide_divide @ nat @ A4 @ N ) @ ( divide_divide @ nat @ B7 @ N ) ) ) ) ) ) ).

% div_less_mono
thf(fact_2036_mod__greater__zero__iff__not__dvd,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( modulo_modulo @ nat @ M @ N ) )
      = ( ~ ( dvd_dvd @ nat @ N @ M ) ) ) ).

% mod_greater_zero_iff_not_dvd
thf(fact_2037_nat__mod__eq__lemma,axiom,
    ! [X: nat,N: nat,Y: nat] :
      ( ( ( modulo_modulo @ nat @ X @ N )
        = ( modulo_modulo @ nat @ Y @ N ) )
     => ( ( ord_less_eq @ nat @ Y @ X )
       => ? [Q5: nat] :
            ( X
            = ( plus_plus @ nat @ Y @ ( times_times @ nat @ N @ Q5 ) ) ) ) ) ).

% nat_mod_eq_lemma
thf(fact_2038_mod__eq__nat2E,axiom,
    ! [M: nat,Q3: nat,N: nat] :
      ( ( ( modulo_modulo @ nat @ M @ Q3 )
        = ( modulo_modulo @ nat @ N @ Q3 ) )
     => ( ( ord_less_eq @ nat @ M @ N )
       => ~ ! [S3: nat] :
              ( N
             != ( plus_plus @ nat @ M @ ( times_times @ nat @ Q3 @ S3 ) ) ) ) ) ).

% mod_eq_nat2E
thf(fact_2039_mod__eq__nat1E,axiom,
    ! [M: nat,Q3: nat,N: nat] :
      ( ( ( modulo_modulo @ nat @ M @ Q3 )
        = ( modulo_modulo @ nat @ N @ Q3 ) )
     => ( ( ord_less_eq @ nat @ N @ M )
       => ~ ! [S3: nat] :
              ( M
             != ( plus_plus @ nat @ N @ ( times_times @ nat @ Q3 @ S3 ) ) ) ) ) ).

% mod_eq_nat1E
thf(fact_2040_power__minus__Bit0,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [X: A,K: num] :
          ( ( power_power @ A @ ( uminus_uminus @ A @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ K ) ) )
          = ( power_power @ A @ X @ ( numeral_numeral @ nat @ ( bit0 @ K ) ) ) ) ) ).

% power_minus_Bit0
thf(fact_2041_lemma__interval__lt,axiom,
    ! [A2: real,X: real,B2: real] :
      ( ( ord_less @ real @ A2 @ X )
     => ( ( ord_less @ real @ X @ B2 )
       => ? [D6: real] :
            ( ( ord_less @ real @ ( zero_zero @ real ) @ D6 )
            & ! [Y6: real] :
                ( ( ord_less @ real @ ( abs_abs @ real @ ( minus_minus @ real @ X @ Y6 ) ) @ D6 )
               => ( ( ord_less @ real @ A2 @ Y6 )
                  & ( ord_less @ real @ Y6 @ B2 ) ) ) ) ) ) ).

% lemma_interval_lt
thf(fact_2042_pochhammer__nonneg,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [X: A,N: nat] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ X )
         => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( comm_s3205402744901411588hammer @ A @ X @ N ) ) ) ) ).

% pochhammer_nonneg
thf(fact_2043_mod__eq__dvd__iff__nat,axiom,
    ! [N: nat,M: nat,Q3: nat] :
      ( ( ord_less_eq @ nat @ N @ M )
     => ( ( ( modulo_modulo @ nat @ M @ Q3 )
          = ( modulo_modulo @ nat @ N @ Q3 ) )
        = ( dvd_dvd @ nat @ Q3 @ ( minus_minus @ nat @ M @ N ) ) ) ) ).

% mod_eq_dvd_iff_nat
thf(fact_2044_div__mod__decomp,axiom,
    ! [A4: nat,N: nat] :
      ( A4
      = ( plus_plus @ nat @ ( times_times @ nat @ ( divide_divide @ nat @ A4 @ N ) @ N ) @ ( modulo_modulo @ nat @ A4 @ N ) ) ) ).

% div_mod_decomp
thf(fact_2045_pochhammer__0__left,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [N: nat] :
          ( ( ( N
              = ( zero_zero @ nat ) )
           => ( ( comm_s3205402744901411588hammer @ A @ ( zero_zero @ A ) @ N )
              = ( one_one @ A ) ) )
          & ( ( N
             != ( zero_zero @ nat ) )
           => ( ( comm_s3205402744901411588hammer @ A @ ( zero_zero @ A ) @ N )
              = ( zero_zero @ A ) ) ) ) ) ).

% pochhammer_0_left
thf(fact_2046_sin__bound__lemma,axiom,
    ! [X: real,Y: real,U: real,V: real] :
      ( ( X = Y )
     => ( ( ord_less_eq @ real @ ( abs_abs @ real @ U ) @ V )
       => ( ord_less_eq @ real @ ( abs_abs @ real @ ( minus_minus @ real @ ( plus_plus @ real @ X @ U ) @ Y ) ) @ V ) ) ) ).

% sin_bound_lemma
thf(fact_2047_real__0__less__add__iff,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ ( plus_plus @ real @ X @ Y ) )
      = ( ord_less @ real @ ( uminus_uminus @ real @ X ) @ Y ) ) ).

% real_0_less_add_iff
thf(fact_2048_real__add__less__0__iff,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less @ real @ ( plus_plus @ real @ X @ Y ) @ ( zero_zero @ real ) )
      = ( ord_less @ real @ Y @ ( uminus_uminus @ real @ X ) ) ) ).

% real_add_less_0_iff
thf(fact_2049_real__0__le__add__iff,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( plus_plus @ real @ X @ Y ) )
      = ( ord_less_eq @ real @ ( uminus_uminus @ real @ X ) @ Y ) ) ).

% real_0_le_add_iff
thf(fact_2050_real__add__le__0__iff,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less_eq @ real @ ( plus_plus @ real @ X @ Y ) @ ( zero_zero @ real ) )
      = ( ord_less_eq @ real @ Y @ ( uminus_uminus @ real @ X ) ) ) ).

% real_add_le_0_iff
thf(fact_2051_abs__add__one__gt__zero,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: A] : ( ord_less @ A @ ( zero_zero @ A ) @ ( plus_plus @ A @ ( one_one @ A ) @ ( abs_abs @ A @ X ) ) ) ) ).

% abs_add_one_gt_zero
thf(fact_2052_of__int__leD,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N: int,X: A] :
          ( ( ord_less_eq @ A @ ( abs_abs @ A @ ( ring_1_of_int @ A @ N ) ) @ X )
         => ( ( N
              = ( zero_zero @ int ) )
            | ( ord_less_eq @ A @ ( one_one @ A ) @ X ) ) ) ) ).

% of_int_leD
thf(fact_2053_of__int__lessD,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N: int,X: A] :
          ( ( ord_less @ A @ ( abs_abs @ A @ ( ring_1_of_int @ A @ N ) ) @ X )
         => ( ( N
              = ( zero_zero @ int ) )
            | ( ord_less @ A @ ( one_one @ A ) @ X ) ) ) ) ).

% of_int_lessD
thf(fact_2054_mod__mult2__eq_H,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [A2: A,M: nat,N: nat] :
          ( ( modulo_modulo @ A @ A2 @ ( times_times @ A @ ( semiring_1_of_nat @ A @ M ) @ ( semiring_1_of_nat @ A @ N ) ) )
          = ( plus_plus @ A @ ( times_times @ A @ ( semiring_1_of_nat @ A @ M ) @ ( modulo_modulo @ A @ ( divide_divide @ A @ A2 @ ( semiring_1_of_nat @ A @ M ) ) @ ( semiring_1_of_nat @ A @ N ) ) ) @ ( modulo_modulo @ A @ A2 @ ( semiring_1_of_nat @ A @ M ) ) ) ) ) ).

% mod_mult2_eq'
thf(fact_2055_less__minus__divide__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less @ A @ A2 @ ( uminus_uminus @ A @ ( divide_divide @ A @ B2 @ C2 ) ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less @ A @ ( times_times @ A @ A2 @ C2 ) @ ( uminus_uminus @ A @ B2 ) ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ ( uminus_uminus @ A @ B2 ) @ ( times_times @ A @ A2 @ C2 ) ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ A2 @ ( zero_zero @ A ) ) ) ) ) ) ) ) ).

% less_minus_divide_eq
thf(fact_2056_minus__divide__less__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( ord_less @ A @ ( uminus_uminus @ A @ ( divide_divide @ A @ B2 @ C2 ) ) @ A2 )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less @ A @ ( uminus_uminus @ A @ B2 ) @ ( times_times @ A @ A2 @ C2 ) ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ ( times_times @ A @ A2 @ C2 ) @ ( uminus_uminus @ A @ B2 ) ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ ( zero_zero @ A ) @ A2 ) ) ) ) ) ) ) ).

% minus_divide_less_eq
thf(fact_2057_neg__less__minus__divide__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ A2 @ ( uminus_uminus @ A @ ( divide_divide @ A @ B2 @ C2 ) ) )
            = ( ord_less @ A @ ( uminus_uminus @ A @ B2 ) @ ( times_times @ A @ A2 @ C2 ) ) ) ) ) ).

% neg_less_minus_divide_eq
thf(fact_2058_neg__minus__divide__less__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ ( uminus_uminus @ A @ ( divide_divide @ A @ B2 @ C2 ) ) @ A2 )
            = ( ord_less @ A @ ( times_times @ A @ A2 @ C2 ) @ ( uminus_uminus @ A @ B2 ) ) ) ) ) ).

% neg_minus_divide_less_eq
thf(fact_2059_pos__less__minus__divide__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
         => ( ( ord_less @ A @ A2 @ ( uminus_uminus @ A @ ( divide_divide @ A @ B2 @ C2 ) ) )
            = ( ord_less @ A @ ( times_times @ A @ A2 @ C2 ) @ ( uminus_uminus @ A @ B2 ) ) ) ) ) ).

% pos_less_minus_divide_eq
thf(fact_2060_pos__minus__divide__less__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
         => ( ( ord_less @ A @ ( uminus_uminus @ A @ ( divide_divide @ A @ B2 @ C2 ) ) @ A2 )
            = ( ord_less @ A @ ( uminus_uminus @ A @ B2 ) @ ( times_times @ A @ A2 @ C2 ) ) ) ) ) ).

% pos_minus_divide_less_eq
thf(fact_2061_even__even__mod__4__iff,axiom,
    ! [N: nat] :
      ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
      = ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( modulo_modulo @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ ( bit0 @ one2 ) ) ) ) ) ) ).

% even_even_mod_4_iff
thf(fact_2062_divide__eq__eq__numeral_I2_J,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [B2: A,C2: A,W: num] :
          ( ( ( divide_divide @ A @ B2 @ C2 )
            = ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) )
          = ( ( ( C2
               != ( zero_zero @ A ) )
             => ( B2
                = ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) @ C2 ) ) )
            & ( ( C2
                = ( zero_zero @ A ) )
             => ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) )
                = ( zero_zero @ A ) ) ) ) ) ) ).

% divide_eq_eq_numeral(2)
thf(fact_2063_eq__divide__eq__numeral_I2_J,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [W: num,B2: A,C2: A] :
          ( ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) )
            = ( divide_divide @ A @ B2 @ C2 ) )
          = ( ( ( C2
               != ( zero_zero @ A ) )
             => ( ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) @ C2 )
                = B2 ) )
            & ( ( C2
                = ( zero_zero @ A ) )
             => ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) )
                = ( zero_zero @ A ) ) ) ) ) ) ).

% eq_divide_eq_numeral(2)
thf(fact_2064_add__divide__eq__if__simps_I3_J,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [Z: A,A2: A,B2: A] :
          ( ( ( Z
              = ( zero_zero @ A ) )
           => ( ( plus_plus @ A @ ( uminus_uminus @ A @ ( divide_divide @ A @ A2 @ Z ) ) @ B2 )
              = B2 ) )
          & ( ( Z
             != ( zero_zero @ A ) )
           => ( ( plus_plus @ A @ ( uminus_uminus @ A @ ( divide_divide @ A @ A2 @ Z ) ) @ B2 )
              = ( divide_divide @ A @ ( plus_plus @ A @ ( uminus_uminus @ A @ A2 ) @ ( times_times @ A @ B2 @ Z ) ) @ Z ) ) ) ) ) ).

% add_divide_eq_if_simps(3)
thf(fact_2065_minus__divide__add__eq__iff,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [Z: A,X: A,Y: A] :
          ( ( Z
           != ( zero_zero @ A ) )
         => ( ( plus_plus @ A @ ( uminus_uminus @ A @ ( divide_divide @ A @ X @ Z ) ) @ Y )
            = ( divide_divide @ A @ ( plus_plus @ A @ ( uminus_uminus @ A @ X ) @ ( times_times @ A @ Y @ Z ) ) @ Z ) ) ) ) ).

% minus_divide_add_eq_iff
thf(fact_2066_add__divide__eq__if__simps_I6_J,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [Z: A,A2: A,B2: A] :
          ( ( ( Z
              = ( zero_zero @ A ) )
           => ( ( minus_minus @ A @ ( uminus_uminus @ A @ ( divide_divide @ A @ A2 @ Z ) ) @ B2 )
              = ( uminus_uminus @ A @ B2 ) ) )
          & ( ( Z
             != ( zero_zero @ A ) )
           => ( ( minus_minus @ A @ ( uminus_uminus @ A @ ( divide_divide @ A @ A2 @ Z ) ) @ B2 )
              = ( divide_divide @ A @ ( minus_minus @ A @ ( uminus_uminus @ A @ A2 ) @ ( times_times @ A @ B2 @ Z ) ) @ Z ) ) ) ) ) ).

% add_divide_eq_if_simps(6)
thf(fact_2067_add__divide__eq__if__simps_I5_J,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [Z: A,A2: A,B2: A] :
          ( ( ( Z
              = ( zero_zero @ A ) )
           => ( ( minus_minus @ A @ ( divide_divide @ A @ A2 @ Z ) @ B2 )
              = ( uminus_uminus @ A @ B2 ) ) )
          & ( ( Z
             != ( zero_zero @ A ) )
           => ( ( minus_minus @ A @ ( divide_divide @ A @ A2 @ Z ) @ B2 )
              = ( divide_divide @ A @ ( minus_minus @ A @ A2 @ ( times_times @ A @ B2 @ Z ) ) @ Z ) ) ) ) ) ).

% add_divide_eq_if_simps(5)
thf(fact_2068_minus__divide__diff__eq__iff,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [Z: A,X: A,Y: A] :
          ( ( Z
           != ( zero_zero @ A ) )
         => ( ( minus_minus @ A @ ( uminus_uminus @ A @ ( divide_divide @ A @ X @ Z ) ) @ Y )
            = ( divide_divide @ A @ ( minus_minus @ A @ ( uminus_uminus @ A @ X ) @ ( times_times @ A @ Y @ Z ) ) @ Z ) ) ) ) ).

% minus_divide_diff_eq_iff
thf(fact_2069_field__char__0__class_Oof__nat__div,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [M: nat,N: nat] :
          ( ( semiring_1_of_nat @ A @ ( divide_divide @ nat @ M @ N ) )
          = ( divide_divide @ A @ ( minus_minus @ A @ ( semiring_1_of_nat @ A @ M ) @ ( semiring_1_of_nat @ A @ ( modulo_modulo @ nat @ M @ N ) ) ) @ ( semiring_1_of_nat @ A @ N ) ) ) ) ).

% field_char_0_class.of_nat_div
thf(fact_2070_split__mod,axiom,
    ! [P: nat > $o,M: nat,N: nat] :
      ( ( P @ ( modulo_modulo @ nat @ M @ N ) )
      = ( ( ( N
            = ( zero_zero @ nat ) )
         => ( P @ M ) )
        & ( ( N
           != ( zero_zero @ nat ) )
         => ! [I4: nat,J3: nat] :
              ( ( ord_less @ nat @ J3 @ N )
             => ( ( M
                  = ( plus_plus @ nat @ ( times_times @ nat @ N @ I4 ) @ J3 ) )
               => ( P @ J3 ) ) ) ) ) ) ).

% split_mod
thf(fact_2071_even__minus,axiom,
    ! [A: $tType] :
      ( ( ring_parity @ A )
     => ! [A2: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( uminus_uminus @ A @ A2 ) )
          = ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) ) ) ).

% even_minus
thf(fact_2072_lemma__interval,axiom,
    ! [A2: real,X: real,B2: real] :
      ( ( ord_less @ real @ A2 @ X )
     => ( ( ord_less @ real @ X @ B2 )
       => ? [D6: real] :
            ( ( ord_less @ real @ ( zero_zero @ real ) @ D6 )
            & ! [Y6: real] :
                ( ( ord_less @ real @ ( abs_abs @ real @ ( minus_minus @ real @ X @ Y6 ) ) @ D6 )
               => ( ( ord_less_eq @ real @ A2 @ Y6 )
                  & ( ord_less_eq @ real @ Y6 @ B2 ) ) ) ) ) ) ).

% lemma_interval
thf(fact_2073_power2__eq__iff,axiom,
    ! [A: $tType] :
      ( ( idom @ A )
     => ! [X: A,Y: A] :
          ( ( ( power_power @ A @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
            = ( power_power @ A @ Y @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
          = ( ( X = Y )
            | ( X
              = ( uminus_uminus @ A @ Y ) ) ) ) ) ).

% power2_eq_iff
thf(fact_2074_mod__nat__eqI,axiom,
    ! [R2: nat,N: nat,M: nat] :
      ( ( ord_less @ nat @ R2 @ N )
     => ( ( ord_less_eq @ nat @ R2 @ M )
       => ( ( dvd_dvd @ nat @ N @ ( minus_minus @ nat @ M @ R2 ) )
         => ( ( modulo_modulo @ nat @ M @ N )
            = R2 ) ) ) ) ).

% mod_nat_eqI
thf(fact_2075_round__diff__minimal,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [Z: A,M: int] : ( ord_less_eq @ A @ ( abs_abs @ A @ ( minus_minus @ A @ Z @ ( ring_1_of_int @ A @ ( archimedean_round @ A @ Z ) ) ) ) @ ( abs_abs @ A @ ( minus_minus @ A @ Z @ ( ring_1_of_int @ A @ M ) ) ) ) ) ).

% round_diff_minimal
thf(fact_2076_frac__def,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ( ( archimedean_frac @ A )
        = ( ^ [X2: A] : ( minus_minus @ A @ X2 @ ( ring_1_of_int @ A @ ( archim6421214686448440834_floor @ A @ X2 ) ) ) ) ) ) ).

% frac_def
thf(fact_2077_real__of__nat__div__aux,axiom,
    ! [X: nat,D2: nat] :
      ( ( divide_divide @ real @ ( semiring_1_of_nat @ real @ X ) @ ( semiring_1_of_nat @ real @ D2 ) )
      = ( plus_plus @ real @ ( semiring_1_of_nat @ real @ ( divide_divide @ nat @ X @ D2 ) ) @ ( divide_divide @ real @ ( semiring_1_of_nat @ real @ ( modulo_modulo @ nat @ X @ D2 ) ) @ ( semiring_1_of_nat @ real @ D2 ) ) ) ) ).

% real_of_nat_div_aux
thf(fact_2078_pochhammer__product_H,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [Z: A,N: nat,M: nat] :
          ( ( comm_s3205402744901411588hammer @ A @ Z @ ( plus_plus @ nat @ N @ M ) )
          = ( times_times @ A @ ( comm_s3205402744901411588hammer @ A @ Z @ N ) @ ( comm_s3205402744901411588hammer @ A @ ( plus_plus @ A @ Z @ ( semiring_1_of_nat @ A @ N ) ) @ M ) ) ) ) ).

% pochhammer_product'
thf(fact_2079_abs__le__square__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ A @ ( abs_abs @ A @ X ) @ ( abs_abs @ A @ Y ) )
          = ( ord_less_eq @ A @ ( power_power @ A @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ A @ Y @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% abs_le_square_iff
thf(fact_2080_abs__square__eq__1,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: A] :
          ( ( ( power_power @ A @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
            = ( one_one @ A ) )
          = ( ( abs_abs @ A @ X )
            = ( one_one @ A ) ) ) ) ).

% abs_square_eq_1
thf(fact_2081_unique__euclidean__semiring__numeral__class_Omod__mult2__eq,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
         => ( ( modulo_modulo @ A @ A2 @ ( times_times @ A @ B2 @ C2 ) )
            = ( plus_plus @ A @ ( times_times @ A @ B2 @ ( modulo_modulo @ A @ ( divide_divide @ A @ A2 @ B2 ) @ C2 ) ) @ ( modulo_modulo @ A @ A2 @ B2 ) ) ) ) ) ).

% unique_euclidean_semiring_numeral_class.mod_mult2_eq
thf(fact_2082_even__iff__mod__2__eq__zero,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [A2: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
          = ( ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
            = ( zero_zero @ A ) ) ) ) ).

% even_iff_mod_2_eq_zero
thf(fact_2083_power__even__abs,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N: nat,A2: A] :
          ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
         => ( ( power_power @ A @ ( abs_abs @ A @ A2 ) @ N )
            = ( power_power @ A @ A2 @ N ) ) ) ) ).

% power_even_abs
thf(fact_2084_odd__iff__mod__2__eq__one,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [A2: A] :
          ( ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) )
          = ( ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
            = ( one_one @ A ) ) ) ) ).

% odd_iff_mod_2_eq_one
thf(fact_2085_take__bit__eq__mod,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se2584673776208193580ke_bit @ A )
        = ( ^ [N3: nat,A3: A] : ( modulo_modulo @ A @ A3 @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N3 ) ) ) ) ) ).

% take_bit_eq_mod
thf(fact_2086_le__minus__divide__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ ( uminus_uminus @ A @ ( divide_divide @ A @ B2 @ C2 ) ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less_eq @ A @ ( times_times @ A @ A2 @ C2 ) @ ( uminus_uminus @ A @ B2 ) ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ ( uminus_uminus @ A @ B2 ) @ ( times_times @ A @ A2 @ C2 ) ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) ) ) ) ) ) ) ) ).

% le_minus_divide_eq
thf(fact_2087_minus__divide__le__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( divide_divide @ A @ B2 @ C2 ) ) @ A2 )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less_eq @ A @ ( uminus_uminus @ A @ B2 ) @ ( times_times @ A @ A2 @ C2 ) ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ ( times_times @ A @ A2 @ C2 ) @ ( uminus_uminus @ A @ B2 ) ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 ) ) ) ) ) ) ) ).

% minus_divide_le_eq
thf(fact_2088_neg__le__minus__divide__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ A2 @ ( uminus_uminus @ A @ ( divide_divide @ A @ B2 @ C2 ) ) )
            = ( ord_less_eq @ A @ ( uminus_uminus @ A @ B2 ) @ ( times_times @ A @ A2 @ C2 ) ) ) ) ) ).

% neg_le_minus_divide_eq
thf(fact_2089_neg__minus__divide__le__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
         => ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( divide_divide @ A @ B2 @ C2 ) ) @ A2 )
            = ( ord_less_eq @ A @ ( times_times @ A @ A2 @ C2 ) @ ( uminus_uminus @ A @ B2 ) ) ) ) ) ).

% neg_minus_divide_le_eq
thf(fact_2090_pos__le__minus__divide__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
         => ( ( ord_less_eq @ A @ A2 @ ( uminus_uminus @ A @ ( divide_divide @ A @ B2 @ C2 ) ) )
            = ( ord_less_eq @ A @ ( times_times @ A @ A2 @ C2 ) @ ( uminus_uminus @ A @ B2 ) ) ) ) ) ).

% pos_le_minus_divide_eq
thf(fact_2091_pos__minus__divide__le__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
         => ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( divide_divide @ A @ B2 @ C2 ) ) @ A2 )
            = ( ord_less_eq @ A @ ( uminus_uminus @ A @ B2 ) @ ( times_times @ A @ A2 @ C2 ) ) ) ) ) ).

% pos_minus_divide_le_eq
thf(fact_2092_divide__less__eq__numeral_I2_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,C2: A,W: num] :
          ( ( ord_less @ A @ ( divide_divide @ A @ B2 @ C2 ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less @ A @ B2 @ ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) @ C2 ) ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) @ C2 ) @ B2 ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ ( zero_zero @ A ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) ) ) ) ) ) ) ) ).

% divide_less_eq_numeral(2)
thf(fact_2093_less__divide__eq__numeral_I2_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [W: num,B2: A,C2: A] :
          ( ( ord_less @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) @ ( divide_divide @ A @ B2 @ C2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less @ A @ ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) @ C2 ) @ B2 ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ B2 @ ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) @ C2 ) ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) @ ( zero_zero @ A ) ) ) ) ) ) ) ) ).

% less_divide_eq_numeral(2)
thf(fact_2094_power2__eq__1__iff,axiom,
    ! [A: $tType] :
      ( ( ring_15535105094025558882visors @ A )
     => ! [A2: A] :
          ( ( ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
            = ( one_one @ A ) )
          = ( ( A2
              = ( one_one @ A ) )
            | ( A2
              = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ) ) ).

% power2_eq_1_iff
thf(fact_2095_frac__eq,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( ( archimedean_frac @ A @ X )
            = X )
          = ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X )
            & ( ord_less @ A @ X @ ( one_one @ A ) ) ) ) ) ).

% frac_eq
thf(fact_2096_uminus__power__if,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [N: nat,A2: A] :
          ( ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
           => ( ( power_power @ A @ ( uminus_uminus @ A @ A2 ) @ N )
              = ( power_power @ A @ A2 @ N ) ) )
          & ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
           => ( ( power_power @ A @ ( uminus_uminus @ A @ A2 ) @ N )
              = ( uminus_uminus @ A @ ( power_power @ A @ A2 @ N ) ) ) ) ) ) ).

% uminus_power_if
thf(fact_2097_neg__one__power__add__eq__neg__one__power__diff,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [K: nat,N: nat] :
          ( ( ord_less_eq @ nat @ K @ N )
         => ( ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( plus_plus @ nat @ N @ K ) )
            = ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( minus_minus @ nat @ N @ K ) ) ) ) ) ).

% neg_one_power_add_eq_neg_one_power_diff
thf(fact_2098_frac__add,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,Y: A] :
          ( ( ( ord_less @ A @ ( plus_plus @ A @ ( archimedean_frac @ A @ X ) @ ( archimedean_frac @ A @ Y ) ) @ ( one_one @ A ) )
           => ( ( archimedean_frac @ A @ ( plus_plus @ A @ X @ Y ) )
              = ( plus_plus @ A @ ( archimedean_frac @ A @ X ) @ ( archimedean_frac @ A @ Y ) ) ) )
          & ( ~ ( ord_less @ A @ ( plus_plus @ A @ ( archimedean_frac @ A @ X ) @ ( archimedean_frac @ A @ Y ) ) @ ( one_one @ A ) )
           => ( ( archimedean_frac @ A @ ( plus_plus @ A @ X @ Y ) )
              = ( minus_minus @ A @ ( plus_plus @ A @ ( archimedean_frac @ A @ X ) @ ( archimedean_frac @ A @ Y ) ) @ ( one_one @ A ) ) ) ) ) ) ).

% frac_add
thf(fact_2099_realpow__square__minus__le,axiom,
    ! [U: real,X: real] : ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( power_power @ real @ U @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ).

% realpow_square_minus_le
thf(fact_2100_take__bit__nat__def,axiom,
    ( ( bit_se2584673776208193580ke_bit @ nat )
    = ( ^ [N3: nat,M3: nat] : ( modulo_modulo @ nat @ M3 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N3 ) ) ) ) ).

% take_bit_nat_def
thf(fact_2101_pochhammer__product,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [M: nat,N: nat,Z: A] :
          ( ( ord_less_eq @ nat @ M @ N )
         => ( ( comm_s3205402744901411588hammer @ A @ Z @ N )
            = ( times_times @ A @ ( comm_s3205402744901411588hammer @ A @ Z @ M ) @ ( comm_s3205402744901411588hammer @ A @ ( plus_plus @ A @ Z @ ( semiring_1_of_nat @ A @ M ) ) @ ( minus_minus @ nat @ N @ M ) ) ) ) ) ) ).

% pochhammer_product
thf(fact_2102_powr__neg__one,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( powr @ real @ X @ ( uminus_uminus @ real @ ( one_one @ real ) ) )
        = ( divide_divide @ real @ ( one_one @ real ) @ X ) ) ) ).

% powr_neg_one
thf(fact_2103_Bernoulli__inequality,axiom,
    ! [X: real,N: nat] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ X )
     => ( ord_less_eq @ real @ ( plus_plus @ real @ ( one_one @ real ) @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N ) @ X ) ) @ ( power_power @ real @ ( plus_plus @ real @ ( one_one @ real ) @ X ) @ N ) ) ) ).

% Bernoulli_inequality
thf(fact_2104_ln__add__one__self__le__self2,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ X )
     => ( ord_less_eq @ real @ ( ln_ln @ real @ ( plus_plus @ real @ ( one_one @ real ) @ X ) ) @ X ) ) ).

% ln_add_one_self_le_self2
thf(fact_2105_power2__le__iff__abs__le,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [Y: A,X: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ Y )
         => ( ( ord_less_eq @ A @ ( power_power @ A @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ A @ Y @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
            = ( ord_less_eq @ A @ ( abs_abs @ A @ X ) @ Y ) ) ) ) ).

% power2_le_iff_abs_le
thf(fact_2106_abs__square__le__1,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: A] :
          ( ( ord_less_eq @ A @ ( power_power @ A @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ A ) )
          = ( ord_less_eq @ A @ ( abs_abs @ A @ X ) @ ( one_one @ A ) ) ) ) ).

% abs_square_le_1
thf(fact_2107_abs__square__less__1,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: A] :
          ( ( ord_less @ A @ ( power_power @ A @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ A ) )
          = ( ord_less @ A @ ( abs_abs @ A @ X ) @ ( one_one @ A ) ) ) ) ).

% abs_square_less_1
thf(fact_2108_divmod__digit__0_I2_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ B2 )
         => ( ( ord_less @ A @ ( modulo_modulo @ A @ A2 @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B2 ) ) @ B2 )
           => ( ( modulo_modulo @ A @ A2 @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B2 ) )
              = ( modulo_modulo @ A @ A2 @ B2 ) ) ) ) ) ).

% divmod_digit_0(2)
thf(fact_2109_power__mono__even,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N: nat,A2: A,B2: A] :
          ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
         => ( ( ord_less_eq @ A @ ( abs_abs @ A @ A2 ) @ ( abs_abs @ A @ B2 ) )
           => ( ord_less_eq @ A @ ( power_power @ A @ A2 @ N ) @ ( power_power @ A @ B2 @ N ) ) ) ) ) ).

% power_mono_even
thf(fact_2110_bits__stable__imp__add__self,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A] :
          ( ( ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
            = A2 )
         => ( ( plus_plus @ A @ A2 @ ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) )
            = ( zero_zero @ A ) ) ) ) ).

% bits_stable_imp_add_self
thf(fact_2111_mod2__eq__if,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [A2: A] :
          ( ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
           => ( ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
              = ( zero_zero @ A ) ) )
          & ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
           => ( ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
              = ( one_one @ A ) ) ) ) ) ).

% mod2_eq_if
thf(fact_2112_parity__cases,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [A2: A] :
          ( ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
           => ( ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
             != ( zero_zero @ A ) ) )
         => ~ ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
             => ( ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
               != ( one_one @ A ) ) ) ) ) ).

% parity_cases
thf(fact_2113_div__exp__mod__exp__eq,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A,N: nat,M: nat] :
          ( ( modulo_modulo @ A @ ( divide_divide @ A @ A2 @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M ) )
          = ( divide_divide @ A @ ( modulo_modulo @ A @ A2 @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( plus_plus @ nat @ N @ M ) ) ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) ) ) ) ).

% div_exp_mod_exp_eq
thf(fact_2114_divide__le__eq__numeral_I2_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [B2: A,C2: A,W: num] :
          ( ( ord_less_eq @ A @ ( divide_divide @ A @ B2 @ C2 ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less_eq @ A @ B2 @ ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) @ C2 ) ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) @ C2 ) @ B2 ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) ) ) ) ) ) ) ) ).

% divide_le_eq_numeral(2)
thf(fact_2115_le__divide__eq__numeral_I2_J,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [W: num,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) @ ( divide_divide @ A @ B2 @ C2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ord_less_eq @ A @ ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) @ C2 ) @ B2 ) )
            & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
             => ( ( ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ B2 @ ( times_times @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) @ C2 ) ) )
                & ( ~ ( ord_less @ A @ C2 @ ( zero_zero @ A ) )
                 => ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) @ ( zero_zero @ A ) ) ) ) ) ) ) ) ).

% le_divide_eq_numeral(2)
thf(fact_2116_sqrt__ge__absD,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less_eq @ real @ ( abs_abs @ real @ X ) @ ( sqrt @ Y ) )
     => ( ord_less_eq @ real @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ Y ) ) ).

% sqrt_ge_absD
thf(fact_2117_square__le__1,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: A] :
          ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ X )
         => ( ( ord_less_eq @ A @ X @ ( one_one @ A ) )
           => ( ord_less_eq @ A @ ( power_power @ A @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ A ) ) ) ) ) ).

% square_le_1
thf(fact_2118_abs__ln__one__plus__x__minus__x__bound__nonpos,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ X )
     => ( ( ord_less_eq @ real @ X @ ( zero_zero @ real ) )
       => ( ord_less_eq @ real @ ( abs_abs @ real @ ( minus_minus @ real @ ( ln_ln @ real @ ( plus_plus @ real @ ( one_one @ real ) @ X ) ) @ X ) ) @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% abs_ln_one_plus_x_minus_x_bound_nonpos
thf(fact_2119_verit__le__mono__div,axiom,
    ! [A4: nat,B7: nat,N: nat] :
      ( ( ord_less @ nat @ A4 @ B7 )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
       => ( ord_less_eq @ nat
          @ ( plus_plus @ nat @ ( divide_divide @ nat @ A4 @ N )
            @ ( if @ nat
              @ ( ( modulo_modulo @ nat @ B7 @ N )
                = ( zero_zero @ nat ) )
              @ ( one_one @ nat )
              @ ( zero_zero @ nat ) ) )
          @ ( divide_divide @ nat @ B7 @ N ) ) ) ) ).

% verit_le_mono_div
thf(fact_2120_minus__power__mult__self,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [A2: A,N: nat] :
          ( ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ A2 ) @ N ) @ ( power_power @ A @ ( uminus_uminus @ A @ A2 ) @ N ) )
          = ( power_power @ A @ A2 @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ) ) ).

% minus_power_mult_self
thf(fact_2121_minus__one__power__iff,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [N: nat] :
          ( ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
           => ( ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ N )
              = ( one_one @ A ) ) )
          & ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
           => ( ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ N )
              = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ) ) ).

% minus_one_power_iff
thf(fact_2122_ln__one__minus__pos__upper__bound,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less @ real @ X @ ( one_one @ real ) )
       => ( ord_less_eq @ real @ ( ln_ln @ real @ ( minus_minus @ real @ ( one_one @ real ) @ X ) ) @ ( uminus_uminus @ real @ X ) ) ) ) ).

% ln_one_minus_pos_upper_bound
thf(fact_2123_log__minus__eq__powr,axiom,
    ! [B2: real,X: real,Y: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ B2 )
     => ( ( B2
         != ( one_one @ real ) )
       => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
         => ( ( minus_minus @ real @ ( log2 @ B2 @ X ) @ Y )
            = ( log2 @ B2 @ ( times_times @ real @ X @ ( powr @ real @ B2 @ ( uminus_uminus @ real @ Y ) ) ) ) ) ) ) ) ).

% log_minus_eq_powr
thf(fact_2124_divmod__digit__0_I1_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ B2 )
         => ( ( ord_less @ A @ ( modulo_modulo @ A @ A2 @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B2 ) ) @ B2 )
           => ( ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( divide_divide @ A @ A2 @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B2 ) ) )
              = ( divide_divide @ A @ A2 @ B2 ) ) ) ) ) ).

% divmod_digit_0(1)
thf(fact_2125_mult__exp__mod__exp__eq,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [M: nat,N: nat,A2: A] :
          ( ( ord_less_eq @ nat @ M @ N )
         => ( ( modulo_modulo @ A @ ( times_times @ A @ A2 @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M ) ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) )
            = ( times_times @ A @ ( modulo_modulo @ A @ A2 @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ N @ M ) ) ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M ) ) ) ) ) ).

% mult_exp_mod_exp_eq
thf(fact_2126_sqrt__sum__squares__le__sum__abs,axiom,
    ! [X: real,Y: real] : ( ord_less_eq @ real @ ( sqrt @ ( plus_plus @ real @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Y @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( plus_plus @ real @ ( abs_abs @ real @ X ) @ ( abs_abs @ real @ Y ) ) ) ).

% sqrt_sum_squares_le_sum_abs
thf(fact_2127_real__sqrt__ge__abs2,axiom,
    ! [Y: real,X: real] : ( ord_less_eq @ real @ ( abs_abs @ real @ Y ) @ ( sqrt @ ( plus_plus @ real @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Y @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% real_sqrt_ge_abs2
thf(fact_2128_real__sqrt__ge__abs1,axiom,
    ! [X: real,Y: real] : ( ord_less_eq @ real @ ( abs_abs @ real @ X ) @ ( sqrt @ ( plus_plus @ real @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Y @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% real_sqrt_ge_abs1
thf(fact_2129_mod__double__modulus,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [M: A,X: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ M )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X )
           => ( ( ( modulo_modulo @ A @ X @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M ) )
                = ( modulo_modulo @ A @ X @ M ) )
              | ( ( modulo_modulo @ A @ X @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M ) )
                = ( plus_plus @ A @ ( modulo_modulo @ A @ X @ M ) @ M ) ) ) ) ) ) ).

% mod_double_modulus
thf(fact_2130_divmod__digit__1_I2_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ B2 )
           => ( ( ord_less_eq @ A @ B2 @ ( modulo_modulo @ A @ A2 @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B2 ) ) )
             => ( ( minus_minus @ A @ ( modulo_modulo @ A @ A2 @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B2 ) ) @ B2 )
                = ( modulo_modulo @ A @ A2 @ B2 ) ) ) ) ) ) ).

% divmod_digit_1(2)
thf(fact_2131_floor__add,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,Y: A] :
          ( ( ( ord_less @ A @ ( plus_plus @ A @ ( archimedean_frac @ A @ X ) @ ( archimedean_frac @ A @ Y ) ) @ ( one_one @ A ) )
           => ( ( archim6421214686448440834_floor @ A @ ( plus_plus @ A @ X @ Y ) )
              = ( plus_plus @ int @ ( archim6421214686448440834_floor @ A @ X ) @ ( archim6421214686448440834_floor @ A @ Y ) ) ) )
          & ( ~ ( ord_less @ A @ ( plus_plus @ A @ ( archimedean_frac @ A @ X ) @ ( archimedean_frac @ A @ Y ) ) @ ( one_one @ A ) )
           => ( ( archim6421214686448440834_floor @ A @ ( plus_plus @ A @ X @ Y ) )
              = ( plus_plus @ int @ ( plus_plus @ int @ ( archim6421214686448440834_floor @ A @ X ) @ ( archim6421214686448440834_floor @ A @ Y ) ) @ ( one_one @ int ) ) ) ) ) ) ).

% floor_add
thf(fact_2132_take__bit__numeral__minus__1__eq,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [K: num] :
          ( ( bit_se2584673776208193580ke_bit @ A @ ( numeral_numeral @ nat @ K ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( minus_minus @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( numeral_numeral @ nat @ K ) ) @ ( one_one @ A ) ) ) ) ).

% take_bit_numeral_minus_1_eq
thf(fact_2133_xor__nat__unfold,axiom,
    ( ( bit_se5824344971392196577ns_xor @ nat )
    = ( ^ [M3: nat,N3: nat] :
          ( if @ nat
          @ ( M3
            = ( zero_zero @ nat ) )
          @ N3
          @ ( if @ nat
            @ ( N3
              = ( zero_zero @ nat ) )
            @ M3
            @ ( plus_plus @ nat @ ( modulo_modulo @ nat @ ( plus_plus @ nat @ ( modulo_modulo @ nat @ M3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( modulo_modulo @ nat @ N3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( bit_se5824344971392196577ns_xor @ nat @ ( divide_divide @ nat @ M3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ nat @ N3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ).

% xor_nat_unfold
thf(fact_2134_powr__neg__numeral,axiom,
    ! [X: real,N: num] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( powr @ real @ X @ ( uminus_uminus @ real @ ( numeral_numeral @ real @ N ) ) )
        = ( divide_divide @ real @ ( one_one @ real ) @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ N ) ) ) ) ) ).

% powr_neg_numeral
thf(fact_2135_of__int__round__abs__le,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] : ( ord_less_eq @ A @ ( abs_abs @ A @ ( minus_minus @ A @ ( ring_1_of_int @ A @ ( archimedean_round @ A @ X ) ) @ X ) ) @ ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% of_int_round_abs_le
thf(fact_2136_round__unique_H,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,N: int] :
          ( ( ord_less @ A @ ( abs_abs @ A @ ( minus_minus @ A @ X @ ( ring_1_of_int @ A @ N ) ) ) @ ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) )
         => ( ( archimedean_round @ A @ X )
            = N ) ) ) ).

% round_unique'
thf(fact_2137_cos__x__y__le__one,axiom,
    ! [X: real,Y: real] : ( ord_less_eq @ real @ ( abs_abs @ real @ ( divide_divide @ real @ X @ ( sqrt @ ( plus_plus @ real @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Y @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) @ ( one_one @ real ) ) ).

% cos_x_y_le_one
thf(fact_2138_real__sqrt__sum__squares__less,axiom,
    ! [X: real,U: real,Y: real] :
      ( ( ord_less @ real @ ( abs_abs @ real @ X ) @ ( divide_divide @ real @ U @ ( sqrt @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) )
     => ( ( ord_less @ real @ ( abs_abs @ real @ Y ) @ ( divide_divide @ real @ U @ ( sqrt @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) )
       => ( ord_less @ real @ ( sqrt @ ( plus_plus @ real @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Y @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ U ) ) ) ).

% real_sqrt_sum_squares_less
thf(fact_2139_divmod__digit__1_I1_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ B2 )
           => ( ( ord_less_eq @ A @ B2 @ ( modulo_modulo @ A @ A2 @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B2 ) ) )
             => ( ( plus_plus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( divide_divide @ A @ A2 @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B2 ) ) ) @ ( one_one @ A ) )
                = ( divide_divide @ A @ A2 @ B2 ) ) ) ) ) ) ).

% divmod_digit_1(1)
thf(fact_2140_or__nat__unfold,axiom,
    ( ( bit_se1065995026697491101ons_or @ nat )
    = ( ^ [M3: nat,N3: nat] :
          ( if @ nat
          @ ( M3
            = ( zero_zero @ nat ) )
          @ N3
          @ ( if @ nat
            @ ( N3
              = ( zero_zero @ nat ) )
            @ M3
            @ ( plus_plus @ nat @ ( ord_max @ nat @ ( modulo_modulo @ nat @ M3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( modulo_modulo @ nat @ N3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( bit_se1065995026697491101ons_or @ nat @ ( divide_divide @ nat @ M3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ nat @ N3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ).

% or_nat_unfold
thf(fact_2141_abs__ln__one__plus__x__minus__x__bound__nonneg,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less_eq @ real @ X @ ( one_one @ real ) )
       => ( ord_less_eq @ real @ ( abs_abs @ real @ ( minus_minus @ real @ ( ln_ln @ real @ ( plus_plus @ real @ ( one_one @ real ) @ X ) ) @ X ) ) @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% abs_ln_one_plus_x_minus_x_bound_nonneg
thf(fact_2142_take__bit__rec,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se2584673776208193580ke_bit @ A )
        = ( ^ [N3: nat,A3: A] :
              ( if @ A
              @ ( N3
                = ( zero_zero @ nat ) )
              @ ( zero_zero @ A )
              @ ( plus_plus @ A @ ( times_times @ A @ ( bit_se2584673776208193580ke_bit @ A @ ( minus_minus @ nat @ N3 @ ( one_one @ nat ) ) @ ( divide_divide @ A @ A3 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( modulo_modulo @ A @ A3 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% take_bit_rec
thf(fact_2143_of__real__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( real_V2191834092415804123ebra_1 @ A )
     => ! [W: num] :
          ( ( real_Vector_of_real @ A @ ( uminus_uminus @ real @ ( numeral_numeral @ real @ W ) ) )
          = ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) ) ) ).

% of_real_neg_numeral
thf(fact_2144_of__real__of__nat__eq,axiom,
    ! [A: $tType] :
      ( ( real_V2191834092415804123ebra_1 @ A )
     => ! [N: nat] :
          ( ( real_Vector_of_real @ A @ ( semiring_1_of_nat @ real @ N ) )
          = ( semiring_1_of_nat @ A @ N ) ) ) ).

% of_real_of_nat_eq
thf(fact_2145_of__real__power,axiom,
    ! [A: $tType] :
      ( ( real_V2191834092415804123ebra_1 @ A )
     => ! [X: real,N: nat] :
          ( ( real_Vector_of_real @ A @ ( power_power @ real @ X @ N ) )
          = ( power_power @ A @ ( real_Vector_of_real @ A @ X ) @ N ) ) ) ).

% of_real_power
thf(fact_2146_of__real__numeral,axiom,
    ! [A: $tType] :
      ( ( real_V2191834092415804123ebra_1 @ A )
     => ! [W: num] :
          ( ( real_Vector_of_real @ A @ ( numeral_numeral @ real @ W ) )
          = ( numeral_numeral @ A @ W ) ) ) ).

% of_real_numeral
thf(fact_2147_of__real__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( real_V2191834092415804123ebra_1 @ A )
     => ! [X: real] :
          ( ( ( real_Vector_of_real @ A @ X )
            = ( zero_zero @ A ) )
          = ( X
            = ( zero_zero @ real ) ) ) ) ).

% of_real_eq_0_iff
thf(fact_2148_of__real__0,axiom,
    ! [A: $tType] :
      ( ( real_V2191834092415804123ebra_1 @ A )
     => ( ( real_Vector_of_real @ A @ ( zero_zero @ real ) )
        = ( zero_zero @ A ) ) ) ).

% of_real_0
thf(fact_2149_abs__sqrt__wlog,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [P: A > A > $o,X: A] :
          ( ! [X3: A] :
              ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X3 )
             => ( P @ X3 @ ( power_power @ A @ X3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
         => ( P @ ( abs_abs @ A @ X ) @ ( power_power @ A @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% abs_sqrt_wlog
thf(fact_2150_mod__neg__neg__trivial,axiom,
    ! [K: int,L: int] :
      ( ( ord_less_eq @ int @ K @ ( zero_zero @ int ) )
     => ( ( ord_less @ int @ L @ K )
       => ( ( modulo_modulo @ int @ K @ L )
          = K ) ) ) ).

% mod_neg_neg_trivial
thf(fact_2151_mod__pos__pos__trivial,axiom,
    ! [K: int,L: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ K )
     => ( ( ord_less @ int @ K @ L )
       => ( ( modulo_modulo @ int @ K @ L )
          = K ) ) ) ).

% mod_pos_pos_trivial
thf(fact_2152_negative__eq__positive,axiom,
    ! [N: nat,M: nat] :
      ( ( ( uminus_uminus @ int @ ( semiring_1_of_nat @ int @ N ) )
        = ( semiring_1_of_nat @ int @ M ) )
      = ( ( N
          = ( zero_zero @ nat ) )
        & ( M
          = ( zero_zero @ nat ) ) ) ) ).

% negative_eq_positive
thf(fact_2153_negative__zle,axiom,
    ! [N: nat,M: nat] : ( ord_less_eq @ int @ ( uminus_uminus @ int @ ( semiring_1_of_nat @ int @ N ) ) @ ( semiring_1_of_nat @ int @ M ) ) ).

% negative_zle
thf(fact_2154_zdvd1__eq,axiom,
    ! [X: int] :
      ( ( dvd_dvd @ int @ X @ ( one_one @ int ) )
      = ( ( abs_abs @ int @ X )
        = ( one_one @ int ) ) ) ).

% zdvd1_eq
thf(fact_2155_zmod__numeral__Bit0,axiom,
    ! [V: num,W: num] :
      ( ( modulo_modulo @ int @ ( numeral_numeral @ int @ ( bit0 @ V ) ) @ ( numeral_numeral @ int @ ( bit0 @ W ) ) )
      = ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( modulo_modulo @ int @ ( numeral_numeral @ int @ V ) @ ( numeral_numeral @ int @ W ) ) ) ) ).

% zmod_numeral_Bit0
thf(fact_2156_nat__neg__numeral,axiom,
    ! [K: num] :
      ( ( nat2 @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ K ) ) )
      = ( zero_zero @ nat ) ) ).

% nat_neg_numeral
thf(fact_2157_nat__zminus__int,axiom,
    ! [N: nat] :
      ( ( nat2 @ ( uminus_uminus @ int @ ( semiring_1_of_nat @ int @ N ) ) )
      = ( zero_zero @ nat ) ) ).

% nat_zminus_int
thf(fact_2158_zabs__less__one__iff,axiom,
    ! [Z: int] :
      ( ( ord_less @ int @ ( abs_abs @ int @ Z ) @ ( one_one @ int ) )
      = ( Z
        = ( zero_zero @ int ) ) ) ).

% zabs_less_one_iff
thf(fact_2159_dvd__nat__abs__iff,axiom,
    ! [N: nat,K: int] :
      ( ( dvd_dvd @ nat @ N @ ( nat2 @ ( abs_abs @ int @ K ) ) )
      = ( dvd_dvd @ int @ ( semiring_1_of_nat @ int @ N ) @ K ) ) ).

% dvd_nat_abs_iff
thf(fact_2160_nat__abs__dvd__iff,axiom,
    ! [K: int,N: nat] :
      ( ( dvd_dvd @ nat @ ( nat2 @ ( abs_abs @ int @ K ) ) @ N )
      = ( dvd_dvd @ int @ K @ ( semiring_1_of_nat @ int @ N ) ) ) ).

% nat_abs_dvd_iff
thf(fact_2161_ceiling__divide__eq__div__numeral,axiom,
    ! [A2: num,B2: num] :
      ( ( archimedean_ceiling @ real @ ( divide_divide @ real @ ( numeral_numeral @ real @ A2 ) @ ( numeral_numeral @ real @ B2 ) ) )
      = ( uminus_uminus @ int @ ( divide_divide @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ A2 ) ) @ ( numeral_numeral @ int @ B2 ) ) ) ) ).

% ceiling_divide_eq_div_numeral
thf(fact_2162_floor__minus__divide__eq__div__numeral,axiom,
    ! [A2: num,B2: num] :
      ( ( archim6421214686448440834_floor @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ ( numeral_numeral @ real @ A2 ) @ ( numeral_numeral @ real @ B2 ) ) ) )
      = ( divide_divide @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ A2 ) ) @ ( numeral_numeral @ int @ B2 ) ) ) ).

% floor_minus_divide_eq_div_numeral
thf(fact_2163_ceiling__minus__divide__eq__div__numeral,axiom,
    ! [A2: num,B2: num] :
      ( ( archimedean_ceiling @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ ( numeral_numeral @ real @ A2 ) @ ( numeral_numeral @ real @ B2 ) ) ) )
      = ( uminus_uminus @ int @ ( divide_divide @ int @ ( numeral_numeral @ int @ A2 ) @ ( numeral_numeral @ int @ B2 ) ) ) ) ).

% ceiling_minus_divide_eq_div_numeral
thf(fact_2164_floor__minus__one__divide__eq__div__numeral,axiom,
    ! [B2: num] :
      ( ( archim6421214686448440834_floor @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ B2 ) ) ) )
      = ( divide_divide @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( numeral_numeral @ int @ B2 ) ) ) ).

% floor_minus_one_divide_eq_div_numeral
thf(fact_2165_zmod__zminus1__not__zero,axiom,
    ! [K: int,L: int] :
      ( ( ( modulo_modulo @ int @ ( uminus_uminus @ int @ K ) @ L )
       != ( zero_zero @ int ) )
     => ( ( modulo_modulo @ int @ K @ L )
       != ( zero_zero @ int ) ) ) ).

% zmod_zminus1_not_zero
thf(fact_2166_zmod__zminus2__not__zero,axiom,
    ! [K: int,L: int] :
      ( ( ( modulo_modulo @ int @ K @ ( uminus_uminus @ int @ L ) )
       != ( zero_zero @ int ) )
     => ( ( modulo_modulo @ int @ K @ L )
       != ( zero_zero @ int ) ) ) ).

% zmod_zminus2_not_zero
thf(fact_2167_abs__mod__less,axiom,
    ! [L: int,K: int] :
      ( ( L
       != ( zero_zero @ int ) )
     => ( ord_less @ int @ ( abs_abs @ int @ ( modulo_modulo @ int @ K @ L ) ) @ ( abs_abs @ int @ L ) ) ) ).

% abs_mod_less
thf(fact_2168_zabs__def,axiom,
    ( ( abs_abs @ int )
    = ( ^ [I4: int] : ( if @ int @ ( ord_less @ int @ I4 @ ( zero_zero @ int ) ) @ ( uminus_uminus @ int @ I4 ) @ I4 ) ) ) ).

% zabs_def
thf(fact_2169_zmod__zminus1__eq__if,axiom,
    ! [A2: int,B2: int] :
      ( ( ( ( modulo_modulo @ int @ A2 @ B2 )
          = ( zero_zero @ int ) )
       => ( ( modulo_modulo @ int @ ( uminus_uminus @ int @ A2 ) @ B2 )
          = ( zero_zero @ int ) ) )
      & ( ( ( modulo_modulo @ int @ A2 @ B2 )
         != ( zero_zero @ int ) )
       => ( ( modulo_modulo @ int @ ( uminus_uminus @ int @ A2 ) @ B2 )
          = ( minus_minus @ int @ B2 @ ( modulo_modulo @ int @ A2 @ B2 ) ) ) ) ) ).

% zmod_zminus1_eq_if
thf(fact_2170_zmod__zminus2__eq__if,axiom,
    ! [A2: int,B2: int] :
      ( ( ( ( modulo_modulo @ int @ A2 @ B2 )
          = ( zero_zero @ int ) )
       => ( ( modulo_modulo @ int @ A2 @ ( uminus_uminus @ int @ B2 ) )
          = ( zero_zero @ int ) ) )
      & ( ( ( modulo_modulo @ int @ A2 @ B2 )
         != ( zero_zero @ int ) )
       => ( ( modulo_modulo @ int @ A2 @ ( uminus_uminus @ int @ B2 ) )
          = ( minus_minus @ int @ ( modulo_modulo @ int @ A2 @ B2 ) @ B2 ) ) ) ) ).

% zmod_zminus2_eq_if
thf(fact_2171_uminus__int__code_I1_J,axiom,
    ( ( uminus_uminus @ int @ ( zero_zero @ int ) )
    = ( zero_zero @ int ) ) ).

% uminus_int_code(1)
thf(fact_2172_zdvd__antisym__abs,axiom,
    ! [A2: int,B2: int] :
      ( ( dvd_dvd @ int @ A2 @ B2 )
     => ( ( dvd_dvd @ int @ B2 @ A2 )
       => ( ( abs_abs @ int @ A2 )
          = ( abs_abs @ int @ B2 ) ) ) ) ).

% zdvd_antisym_abs
thf(fact_2173_int__cases2,axiom,
    ! [Z: int] :
      ( ! [N2: nat] :
          ( Z
         != ( semiring_1_of_nat @ int @ N2 ) )
     => ~ ! [N2: nat] :
            ( Z
           != ( uminus_uminus @ int @ ( semiring_1_of_nat @ int @ N2 ) ) ) ) ).

% int_cases2
thf(fact_2174_uminus__dvd__conv_I2_J,axiom,
    ( ( dvd_dvd @ int )
    = ( ^ [D4: int,T3: int] : ( dvd_dvd @ int @ D4 @ ( uminus_uminus @ int @ T3 ) ) ) ) ).

% uminus_dvd_conv(2)
thf(fact_2175_uminus__dvd__conv_I1_J,axiom,
    ( ( dvd_dvd @ int )
    = ( ^ [D4: int] : ( dvd_dvd @ int @ ( uminus_uminus @ int @ D4 ) ) ) ) ).

% uminus_dvd_conv(1)
thf(fact_2176_take__bit__minus,axiom,
    ! [N: nat,K: int] :
      ( ( bit_se2584673776208193580ke_bit @ int @ N @ ( uminus_uminus @ int @ ( bit_se2584673776208193580ke_bit @ int @ N @ K ) ) )
      = ( bit_se2584673776208193580ke_bit @ int @ N @ ( uminus_uminus @ int @ K ) ) ) ).

% take_bit_minus
thf(fact_2177_mod__abs__eq__div__nat,axiom,
    ! [K: int,L: int] :
      ( ( modulo_modulo @ int @ ( abs_abs @ int @ K ) @ ( abs_abs @ int @ L ) )
      = ( semiring_1_of_nat @ int @ ( modulo_modulo @ nat @ ( nat2 @ ( abs_abs @ int @ K ) ) @ ( nat2 @ ( abs_abs @ int @ L ) ) ) ) ) ).

% mod_abs_eq_div_nat
thf(fact_2178_minus__mod__int__eq,axiom,
    ! [L: int,K: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ L )
     => ( ( modulo_modulo @ int @ ( uminus_uminus @ int @ K ) @ L )
        = ( minus_minus @ int @ ( minus_minus @ int @ L @ ( one_one @ int ) ) @ ( modulo_modulo @ int @ ( minus_minus @ int @ K @ ( one_one @ int ) ) @ L ) ) ) ) ).

% minus_mod_int_eq
thf(fact_2179_zmod__minus1,axiom,
    ! [B2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ B2 )
     => ( ( modulo_modulo @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ B2 )
        = ( minus_minus @ int @ B2 @ ( one_one @ int ) ) ) ) ).

% zmod_minus1
thf(fact_2180_zdiv__zminus2__eq__if,axiom,
    ! [B2: int,A2: int] :
      ( ( B2
       != ( zero_zero @ int ) )
     => ( ( ( ( modulo_modulo @ int @ A2 @ B2 )
            = ( zero_zero @ int ) )
         => ( ( divide_divide @ int @ A2 @ ( uminus_uminus @ int @ B2 ) )
            = ( uminus_uminus @ int @ ( divide_divide @ int @ A2 @ B2 ) ) ) )
        & ( ( ( modulo_modulo @ int @ A2 @ B2 )
           != ( zero_zero @ int ) )
         => ( ( divide_divide @ int @ A2 @ ( uminus_uminus @ int @ B2 ) )
            = ( minus_minus @ int @ ( uminus_uminus @ int @ ( divide_divide @ int @ A2 @ B2 ) ) @ ( one_one @ int ) ) ) ) ) ) ).

% zdiv_zminus2_eq_if
thf(fact_2181_zdiv__zminus1__eq__if,axiom,
    ! [B2: int,A2: int] :
      ( ( B2
       != ( zero_zero @ int ) )
     => ( ( ( ( modulo_modulo @ int @ A2 @ B2 )
            = ( zero_zero @ int ) )
         => ( ( divide_divide @ int @ ( uminus_uminus @ int @ A2 ) @ B2 )
            = ( uminus_uminus @ int @ ( divide_divide @ int @ A2 @ B2 ) ) ) )
        & ( ( ( modulo_modulo @ int @ A2 @ B2 )
           != ( zero_zero @ int ) )
         => ( ( divide_divide @ int @ ( uminus_uminus @ int @ A2 ) @ B2 )
            = ( minus_minus @ int @ ( uminus_uminus @ int @ ( divide_divide @ int @ A2 @ B2 ) ) @ ( one_one @ int ) ) ) ) ) ) ).

% zdiv_zminus1_eq_if
thf(fact_2182_zmod__le__nonneg__dividend,axiom,
    ! [M: int,K: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ M )
     => ( ord_less_eq @ int @ ( modulo_modulo @ int @ M @ K ) @ M ) ) ).

% zmod_le_nonneg_dividend
thf(fact_2183_Euclidean__Division_Opos__mod__bound,axiom,
    ! [L: int,K: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ L )
     => ( ord_less @ int @ ( modulo_modulo @ int @ K @ L ) @ L ) ) ).

% Euclidean_Division.pos_mod_bound
thf(fact_2184_neg__mod__bound,axiom,
    ! [L: int,K: int] :
      ( ( ord_less @ int @ L @ ( zero_zero @ int ) )
     => ( ord_less @ int @ L @ ( modulo_modulo @ int @ K @ L ) ) ) ).

% neg_mod_bound
thf(fact_2185_zmod__eq__0D,axiom,
    ! [M: int,D2: int] :
      ( ( ( modulo_modulo @ int @ M @ D2 )
        = ( zero_zero @ int ) )
     => ? [Q5: int] :
          ( M
          = ( times_times @ int @ D2 @ Q5 ) ) ) ).

% zmod_eq_0D
thf(fact_2186_zmod__eq__0__iff,axiom,
    ! [M: int,D2: int] :
      ( ( ( modulo_modulo @ int @ M @ D2 )
        = ( zero_zero @ int ) )
      = ( ? [Q6: int] :
            ( M
            = ( times_times @ int @ D2 @ Q6 ) ) ) ) ).

% zmod_eq_0_iff
thf(fact_2187_abs__zmult__eq__1,axiom,
    ! [M: int,N: int] :
      ( ( ( abs_abs @ int @ ( times_times @ int @ M @ N ) )
        = ( one_one @ int ) )
     => ( ( abs_abs @ int @ M )
        = ( one_one @ int ) ) ) ).

% abs_zmult_eq_1
thf(fact_2188_zmod__int,axiom,
    ! [A2: nat,B2: nat] :
      ( ( semiring_1_of_nat @ int @ ( modulo_modulo @ nat @ A2 @ B2 ) )
      = ( modulo_modulo @ int @ ( semiring_1_of_nat @ int @ A2 ) @ ( semiring_1_of_nat @ int @ B2 ) ) ) ).

% zmod_int
thf(fact_2189_pos__zmult__eq__1__iff__lemma,axiom,
    ! [M: int,N: int] :
      ( ( ( times_times @ int @ M @ N )
        = ( one_one @ int ) )
     => ( ( M
          = ( one_one @ int ) )
        | ( M
          = ( uminus_uminus @ int @ ( one_one @ int ) ) ) ) ) ).

% pos_zmult_eq_1_iff_lemma
thf(fact_2190_zmult__eq__1__iff,axiom,
    ! [M: int,N: int] :
      ( ( ( times_times @ int @ M @ N )
        = ( one_one @ int ) )
      = ( ( ( M
            = ( one_one @ int ) )
          & ( N
            = ( one_one @ int ) ) )
        | ( ( M
            = ( uminus_uminus @ int @ ( one_one @ int ) ) )
          & ( N
            = ( uminus_uminus @ int @ ( one_one @ int ) ) ) ) ) ) ).

% zmult_eq_1_iff
thf(fact_2191_minus__int__code_I2_J,axiom,
    ! [L: int] :
      ( ( minus_minus @ int @ ( zero_zero @ int ) @ L )
      = ( uminus_uminus @ int @ L ) ) ).

% minus_int_code(2)
thf(fact_2192_not__int__zless__negative,axiom,
    ! [N: nat,M: nat] :
      ~ ( ord_less @ int @ ( semiring_1_of_nat @ int @ N ) @ ( uminus_uminus @ int @ ( semiring_1_of_nat @ int @ M ) ) ) ).

% not_int_zless_negative
thf(fact_2193_neg__mod__conj,axiom,
    ! [B2: int,A2: int] :
      ( ( ord_less @ int @ B2 @ ( zero_zero @ int ) )
     => ( ( ord_less_eq @ int @ ( modulo_modulo @ int @ A2 @ B2 ) @ ( zero_zero @ int ) )
        & ( ord_less @ int @ B2 @ ( modulo_modulo @ int @ A2 @ B2 ) ) ) ) ).

% neg_mod_conj
thf(fact_2194_pos__mod__conj,axiom,
    ! [B2: int,A2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ B2 )
     => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( modulo_modulo @ int @ A2 @ B2 ) )
        & ( ord_less @ int @ ( modulo_modulo @ int @ A2 @ B2 ) @ B2 ) ) ) ).

% pos_mod_conj
thf(fact_2195_zmod__trivial__iff,axiom,
    ! [I: int,K: int] :
      ( ( ( modulo_modulo @ int @ I @ K )
        = I )
      = ( ( K
          = ( zero_zero @ int ) )
        | ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ I )
          & ( ord_less @ int @ I @ K ) )
        | ( ( ord_less_eq @ int @ I @ ( zero_zero @ int ) )
          & ( ord_less @ int @ K @ I ) ) ) ) ).

% zmod_trivial_iff
thf(fact_2196_neg__mod__sign,axiom,
    ! [L: int,K: int] :
      ( ( ord_less @ int @ L @ ( zero_zero @ int ) )
     => ( ord_less_eq @ int @ ( modulo_modulo @ int @ K @ L ) @ ( zero_zero @ int ) ) ) ).

% neg_mod_sign
thf(fact_2197_Euclidean__Division_Opos__mod__sign,axiom,
    ! [L: int,K: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ L )
     => ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( modulo_modulo @ int @ K @ L ) ) ) ).

% Euclidean_Division.pos_mod_sign
thf(fact_2198_dvd__imp__le__int,axiom,
    ! [I: int,D2: int] :
      ( ( I
       != ( zero_zero @ int ) )
     => ( ( dvd_dvd @ int @ D2 @ I )
       => ( ord_less_eq @ int @ ( abs_abs @ int @ D2 ) @ ( abs_abs @ int @ I ) ) ) ) ).

% dvd_imp_le_int
thf(fact_2199_nat__abs__mult__distrib,axiom,
    ! [W: int,Z: int] :
      ( ( nat2 @ ( abs_abs @ int @ ( times_times @ int @ W @ Z ) ) )
      = ( times_times @ nat @ ( nat2 @ ( abs_abs @ int @ W ) ) @ ( nat2 @ ( abs_abs @ int @ Z ) ) ) ) ).

% nat_abs_mult_distrib
thf(fact_2200_zdiv__mono__strict,axiom,
    ! [A4: int,B7: int,N: int] :
      ( ( ord_less @ int @ A4 @ B7 )
     => ( ( ord_less @ int @ ( zero_zero @ int ) @ N )
       => ( ( ( modulo_modulo @ int @ A4 @ N )
            = ( zero_zero @ int ) )
         => ( ( ( modulo_modulo @ int @ B7 @ N )
              = ( zero_zero @ int ) )
           => ( ord_less @ int @ ( divide_divide @ int @ A4 @ N ) @ ( divide_divide @ int @ B7 @ N ) ) ) ) ) ) ).

% zdiv_mono_strict
thf(fact_2201_div__mod__decomp__int,axiom,
    ! [A4: int,N: int] :
      ( A4
      = ( plus_plus @ int @ ( times_times @ int @ ( divide_divide @ int @ A4 @ N ) @ N ) @ ( modulo_modulo @ int @ A4 @ N ) ) ) ).

% div_mod_decomp_int
thf(fact_2202_int__cases4,axiom,
    ! [M: int] :
      ( ! [N2: nat] :
          ( M
         != ( semiring_1_of_nat @ int @ N2 ) )
     => ~ ! [N2: nat] :
            ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
           => ( M
             != ( uminus_uminus @ int @ ( semiring_1_of_nat @ int @ N2 ) ) ) ) ) ).

% int_cases4
thf(fact_2203_int__zle__neg,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less_eq @ int @ ( semiring_1_of_nat @ int @ N ) @ ( uminus_uminus @ int @ ( semiring_1_of_nat @ int @ M ) ) )
      = ( ( N
          = ( zero_zero @ nat ) )
        & ( M
          = ( zero_zero @ nat ) ) ) ) ).

% int_zle_neg
thf(fact_2204_negative__zle__0,axiom,
    ! [N: nat] : ( ord_less_eq @ int @ ( uminus_uminus @ int @ ( semiring_1_of_nat @ int @ N ) ) @ ( zero_zero @ int ) ) ).

% negative_zle_0
thf(fact_2205_nonpos__int__cases,axiom,
    ! [K: int] :
      ( ( ord_less_eq @ int @ K @ ( zero_zero @ int ) )
     => ~ ! [N2: nat] :
            ( K
           != ( uminus_uminus @ int @ ( semiring_1_of_nat @ int @ N2 ) ) ) ) ).

% nonpos_int_cases
thf(fact_2206_nat__abs__triangle__ineq,axiom,
    ! [K: int,L: int] : ( ord_less_eq @ nat @ ( nat2 @ ( abs_abs @ int @ ( plus_plus @ int @ K @ L ) ) ) @ ( plus_plus @ nat @ ( nat2 @ ( abs_abs @ int @ K ) ) @ ( nat2 @ ( abs_abs @ int @ L ) ) ) ) ).

% nat_abs_triangle_ineq
thf(fact_2207_mod__pos__neg__trivial,axiom,
    ! [K: int,L: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ K )
     => ( ( ord_less_eq @ int @ ( plus_plus @ int @ K @ L ) @ ( zero_zero @ int ) )
       => ( ( modulo_modulo @ int @ K @ L )
          = ( plus_plus @ int @ K @ L ) ) ) ) ).

% mod_pos_neg_trivial
thf(fact_2208_mod__pos__geq,axiom,
    ! [L: int,K: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ L )
     => ( ( ord_less_eq @ int @ L @ K )
       => ( ( modulo_modulo @ int @ K @ L )
          = ( modulo_modulo @ int @ ( minus_minus @ int @ K @ L ) @ L ) ) ) ) ).

% mod_pos_geq
thf(fact_2209_mod__int__pos__iff,axiom,
    ! [K: int,L: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( modulo_modulo @ int @ K @ L ) )
      = ( ( dvd_dvd @ int @ L @ K )
        | ( ( L
            = ( zero_zero @ int ) )
          & ( ord_less_eq @ int @ ( zero_zero @ int ) @ K ) )
        | ( ord_less @ int @ ( zero_zero @ int ) @ L ) ) ) ).

% mod_int_pos_iff
thf(fact_2210_zdvd__mult__cancel1,axiom,
    ! [M: int,N: int] :
      ( ( M
       != ( zero_zero @ int ) )
     => ( ( dvd_dvd @ int @ ( times_times @ int @ M @ N ) @ M )
        = ( ( abs_abs @ int @ N )
          = ( one_one @ int ) ) ) ) ).

% zdvd_mult_cancel1
thf(fact_2211_nat__mod__distrib,axiom,
    ! [X: int,Y: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ X )
     => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Y )
       => ( ( nat2 @ ( modulo_modulo @ int @ X @ Y ) )
          = ( modulo_modulo @ nat @ ( nat2 @ X ) @ ( nat2 @ Y ) ) ) ) ) ).

% nat_mod_distrib
thf(fact_2212_div__abs__eq__div__nat,axiom,
    ! [K: int,L: int] :
      ( ( divide_divide @ int @ ( abs_abs @ int @ K ) @ ( abs_abs @ int @ L ) )
      = ( semiring_1_of_nat @ int @ ( divide_divide @ nat @ ( nat2 @ ( abs_abs @ int @ K ) ) @ ( nat2 @ ( abs_abs @ int @ L ) ) ) ) ) ).

% div_abs_eq_div_nat
thf(fact_2213_int__cases3,axiom,
    ! [K: int] :
      ( ( K
       != ( zero_zero @ int ) )
     => ( ! [N2: nat] :
            ( ( K
              = ( semiring_1_of_nat @ int @ N2 ) )
           => ~ ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 ) )
       => ~ ! [N2: nat] :
              ( ( K
                = ( uminus_uminus @ int @ ( semiring_1_of_nat @ int @ N2 ) ) )
             => ~ ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 ) ) ) ) ).

% int_cases3
thf(fact_2214_real__of__int__div__aux,axiom,
    ! [X: int,D2: int] :
      ( ( divide_divide @ real @ ( ring_1_of_int @ real @ X ) @ ( ring_1_of_int @ real @ D2 ) )
      = ( plus_plus @ real @ ( ring_1_of_int @ real @ ( divide_divide @ int @ X @ D2 ) ) @ ( divide_divide @ real @ ( ring_1_of_int @ real @ ( modulo_modulo @ int @ X @ D2 ) ) @ ( ring_1_of_int @ real @ D2 ) ) ) ) ).

% real_of_int_div_aux
thf(fact_2215_verit__less__mono__div__int2,axiom,
    ! [A4: int,B7: int,N: int] :
      ( ( ord_less_eq @ int @ A4 @ B7 )
     => ( ( ord_less @ int @ ( zero_zero @ int ) @ ( uminus_uminus @ int @ N ) )
       => ( ord_less_eq @ int @ ( divide_divide @ int @ B7 @ N ) @ ( divide_divide @ int @ A4 @ N ) ) ) ) ).

% verit_less_mono_div_int2
thf(fact_2216_div__eq__minus1,axiom,
    ! [B2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ B2 )
     => ( ( divide_divide @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ B2 )
        = ( uminus_uminus @ int @ ( one_one @ int ) ) ) ) ).

% div_eq_minus1
thf(fact_2217_ceiling__divide__eq__div,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [A2: int,B2: int] :
          ( ( archimedean_ceiling @ A @ ( divide_divide @ A @ ( ring_1_of_int @ A @ A2 ) @ ( ring_1_of_int @ A @ B2 ) ) )
          = ( uminus_uminus @ int @ ( divide_divide @ int @ ( uminus_uminus @ int @ A2 ) @ B2 ) ) ) ) ).

% ceiling_divide_eq_div
thf(fact_2218_even__abs__add__iff,axiom,
    ! [K: int,L: int] :
      ( ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( plus_plus @ int @ ( abs_abs @ int @ K ) @ L ) )
      = ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( plus_plus @ int @ K @ L ) ) ) ).

% even_abs_add_iff
thf(fact_2219_even__add__abs__iff,axiom,
    ! [K: int,L: int] :
      ( ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( plus_plus @ int @ K @ ( abs_abs @ int @ L ) ) )
      = ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( plus_plus @ int @ K @ L ) ) ) ).

% even_add_abs_iff
thf(fact_2220_int__mod__pos__eq,axiom,
    ! [A2: int,B2: int,Q3: int,R2: int] :
      ( ( A2
        = ( plus_plus @ int @ ( times_times @ int @ B2 @ Q3 ) @ R2 ) )
     => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ R2 )
       => ( ( ord_less @ int @ R2 @ B2 )
         => ( ( modulo_modulo @ int @ A2 @ B2 )
            = R2 ) ) ) ) ).

% int_mod_pos_eq
thf(fact_2221_int__mod__neg__eq,axiom,
    ! [A2: int,B2: int,Q3: int,R2: int] :
      ( ( A2
        = ( plus_plus @ int @ ( times_times @ int @ B2 @ Q3 ) @ R2 ) )
     => ( ( ord_less_eq @ int @ R2 @ ( zero_zero @ int ) )
       => ( ( ord_less @ int @ B2 @ R2 )
         => ( ( modulo_modulo @ int @ A2 @ B2 )
            = R2 ) ) ) ) ).

% int_mod_neg_eq
thf(fact_2222_split__zmod,axiom,
    ! [P: int > $o,N: int,K: int] :
      ( ( P @ ( modulo_modulo @ int @ N @ K ) )
      = ( ( ( K
            = ( zero_zero @ int ) )
         => ( P @ N ) )
        & ( ( ord_less @ int @ ( zero_zero @ int ) @ K )
         => ! [I4: int,J3: int] :
              ( ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ J3 )
                & ( ord_less @ int @ J3 @ K )
                & ( N
                  = ( plus_plus @ int @ ( times_times @ int @ K @ I4 ) @ J3 ) ) )
             => ( P @ J3 ) ) )
        & ( ( ord_less @ int @ K @ ( zero_zero @ int ) )
         => ! [I4: int,J3: int] :
              ( ( ( ord_less @ int @ K @ J3 )
                & ( ord_less_eq @ int @ J3 @ ( zero_zero @ int ) )
                & ( N
                  = ( plus_plus @ int @ ( times_times @ int @ K @ I4 ) @ J3 ) ) )
             => ( P @ J3 ) ) ) ) ) ).

% split_zmod
thf(fact_2223_nat__abs__int__diff,axiom,
    ! [A2: nat,B2: nat] :
      ( ( ( ord_less_eq @ nat @ A2 @ B2 )
       => ( ( nat2 @ ( abs_abs @ int @ ( minus_minus @ int @ ( semiring_1_of_nat @ int @ A2 ) @ ( semiring_1_of_nat @ int @ B2 ) ) ) )
          = ( minus_minus @ nat @ B2 @ A2 ) ) )
      & ( ~ ( ord_less_eq @ nat @ A2 @ B2 )
       => ( ( nat2 @ ( abs_abs @ int @ ( minus_minus @ int @ ( semiring_1_of_nat @ int @ A2 ) @ ( semiring_1_of_nat @ int @ B2 ) ) ) )
          = ( minus_minus @ nat @ A2 @ B2 ) ) ) ) ).

% nat_abs_int_diff
thf(fact_2224_zmod__zmult2__eq,axiom,
    ! [C2: int,A2: int,B2: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ C2 )
     => ( ( modulo_modulo @ int @ A2 @ ( times_times @ int @ B2 @ C2 ) )
        = ( plus_plus @ int @ ( times_times @ int @ B2 @ ( modulo_modulo @ int @ ( divide_divide @ int @ A2 @ B2 ) @ C2 ) ) @ ( modulo_modulo @ int @ A2 @ B2 ) ) ) ) ).

% zmod_zmult2_eq
thf(fact_2225_take__bit__int__def,axiom,
    ( ( bit_se2584673776208193580ke_bit @ int )
    = ( ^ [N3: nat,K3: int] : ( modulo_modulo @ int @ K3 @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N3 ) ) ) ) ).

% take_bit_int_def
thf(fact_2226_neg__int__cases,axiom,
    ! [K: int] :
      ( ( ord_less @ int @ K @ ( zero_zero @ int ) )
     => ~ ! [N2: nat] :
            ( ( K
              = ( uminus_uminus @ int @ ( semiring_1_of_nat @ int @ N2 ) ) )
           => ~ ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 ) ) ) ).

% neg_int_cases
thf(fact_2227_nat__mult__distrib__neg,axiom,
    ! [Z: int,Z5: int] :
      ( ( ord_less_eq @ int @ Z @ ( zero_zero @ int ) )
     => ( ( nat2 @ ( times_times @ int @ Z @ Z5 ) )
        = ( times_times @ nat @ ( nat2 @ ( uminus_uminus @ int @ Z ) ) @ ( nat2 @ ( uminus_uminus @ int @ Z5 ) ) ) ) ) ).

% nat_mult_distrib_neg
thf(fact_2228_or__int__unfold,axiom,
    ( ( bit_se1065995026697491101ons_or @ int )
    = ( ^ [K3: int,L2: int] :
          ( if @ int
          @ ( ( K3
              = ( uminus_uminus @ int @ ( one_one @ int ) ) )
            | ( L2
              = ( uminus_uminus @ int @ ( one_one @ int ) ) ) )
          @ ( uminus_uminus @ int @ ( one_one @ int ) )
          @ ( if @ int
            @ ( K3
              = ( zero_zero @ int ) )
            @ L2
            @ ( if @ int
              @ ( L2
                = ( zero_zero @ int ) )
              @ K3
              @ ( plus_plus @ int @ ( ord_max @ int @ ( modulo_modulo @ int @ K3 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( modulo_modulo @ int @ L2 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se1065995026697491101ons_or @ int @ ( divide_divide @ int @ K3 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ int @ L2 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ) ).

% or_int_unfold
thf(fact_2229_incr__lemma,axiom,
    ! [D2: int,Z: int,X: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D2 )
     => ( ord_less @ int @ Z @ ( plus_plus @ int @ X @ ( times_times @ int @ ( plus_plus @ int @ ( abs_abs @ int @ ( minus_minus @ int @ X @ Z ) ) @ ( one_one @ int ) ) @ D2 ) ) ) ) ).

% incr_lemma
thf(fact_2230_decr__lemma,axiom,
    ! [D2: int,X: int,Z: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D2 )
     => ( ord_less @ int @ ( minus_minus @ int @ X @ ( times_times @ int @ ( plus_plus @ int @ ( abs_abs @ int @ ( minus_minus @ int @ X @ Z ) ) @ ( one_one @ int ) ) @ D2 ) ) @ Z ) ) ).

% decr_lemma
thf(fact_2231_verit__le__mono__div__int,axiom,
    ! [A4: int,B7: int,N: int] :
      ( ( ord_less @ int @ A4 @ B7 )
     => ( ( ord_less @ int @ ( zero_zero @ int ) @ N )
       => ( ord_less_eq @ int
          @ ( plus_plus @ int @ ( divide_divide @ int @ A4 @ N )
            @ ( if @ int
              @ ( ( modulo_modulo @ int @ B7 @ N )
                = ( zero_zero @ int ) )
              @ ( one_one @ int )
              @ ( zero_zero @ int ) ) )
          @ ( divide_divide @ int @ B7 @ N ) ) ) ) ).

% verit_le_mono_div_int
thf(fact_2232_split__neg__lemma,axiom,
    ! [K: int,P: int > int > $o,N: int] :
      ( ( ord_less @ int @ K @ ( zero_zero @ int ) )
     => ( ( P @ ( divide_divide @ int @ N @ K ) @ ( modulo_modulo @ int @ N @ K ) )
        = ( ! [I4: int,J3: int] :
              ( ( ( ord_less @ int @ K @ J3 )
                & ( ord_less_eq @ int @ J3 @ ( zero_zero @ int ) )
                & ( N
                  = ( plus_plus @ int @ ( times_times @ int @ K @ I4 ) @ J3 ) ) )
             => ( P @ I4 @ J3 ) ) ) ) ) ).

% split_neg_lemma
thf(fact_2233_split__pos__lemma,axiom,
    ! [K: int,P: int > int > $o,N: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ K )
     => ( ( P @ ( divide_divide @ int @ N @ K ) @ ( modulo_modulo @ int @ N @ K ) )
        = ( ! [I4: int,J3: int] :
              ( ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ J3 )
                & ( ord_less @ int @ J3 @ K )
                & ( N
                  = ( plus_plus @ int @ ( times_times @ int @ K @ I4 ) @ J3 ) ) )
             => ( P @ I4 @ J3 ) ) ) ) ) ).

% split_pos_lemma
thf(fact_2234_minus__1__div__exp__eq__int,axiom,
    ! [N: nat] :
      ( ( divide_divide @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) )
      = ( uminus_uminus @ int @ ( one_one @ int ) ) ) ).

% minus_1_div_exp_eq_int
thf(fact_2235_div__pos__neg__trivial,axiom,
    ! [K: int,L: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ K )
     => ( ( ord_less_eq @ int @ ( plus_plus @ int @ K @ L ) @ ( zero_zero @ int ) )
       => ( ( divide_divide @ int @ K @ L )
          = ( uminus_uminus @ int @ ( one_one @ int ) ) ) ) ) ).

% div_pos_neg_trivial
thf(fact_2236_int__bit__induct,axiom,
    ! [P: int > $o,K: int] :
      ( ( P @ ( zero_zero @ int ) )
     => ( ( P @ ( uminus_uminus @ int @ ( one_one @ int ) ) )
       => ( ! [K2: int] :
              ( ( P @ K2 )
             => ( ( K2
                 != ( zero_zero @ int ) )
               => ( P @ ( times_times @ int @ K2 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) )
         => ( ! [K2: int] :
                ( ( P @ K2 )
               => ( ( K2
                   != ( uminus_uminus @ int @ ( one_one @ int ) ) )
                 => ( P @ ( plus_plus @ int @ ( one_one @ int ) @ ( times_times @ int @ K2 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) ) )
           => ( P @ K ) ) ) ) ) ).

% int_bit_induct
thf(fact_2237_pos__zmod__mult__2,axiom,
    ! [A2: int,B2: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ A2 )
     => ( ( modulo_modulo @ int @ ( plus_plus @ int @ ( one_one @ int ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ B2 ) ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ A2 ) )
        = ( plus_plus @ int @ ( one_one @ int ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( modulo_modulo @ int @ B2 @ A2 ) ) ) ) ) ).

% pos_zmod_mult_2
thf(fact_2238_nat0__intermed__int__val,axiom,
    ! [N: nat,F2: nat > int,K: int] :
      ( ! [I2: nat] :
          ( ( ord_less @ nat @ I2 @ N )
         => ( ord_less_eq @ int @ ( abs_abs @ int @ ( minus_minus @ int @ ( F2 @ ( plus_plus @ nat @ I2 @ ( one_one @ nat ) ) ) @ ( F2 @ I2 ) ) ) @ ( one_one @ int ) ) )
     => ( ( ord_less_eq @ int @ ( F2 @ ( zero_zero @ nat ) ) @ K )
       => ( ( ord_less_eq @ int @ K @ ( F2 @ N ) )
         => ? [I2: nat] :
              ( ( ord_less_eq @ nat @ I2 @ N )
              & ( ( F2 @ I2 )
                = K ) ) ) ) ) ).

% nat0_intermed_int_val
thf(fact_2239_neg__zmod__mult__2,axiom,
    ! [A2: int,B2: int] :
      ( ( ord_less_eq @ int @ A2 @ ( zero_zero @ int ) )
     => ( ( modulo_modulo @ int @ ( plus_plus @ int @ ( one_one @ int ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ B2 ) ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ A2 ) )
        = ( minus_minus @ int @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( modulo_modulo @ int @ ( plus_plus @ int @ B2 @ ( one_one @ int ) ) @ A2 ) ) @ ( one_one @ int ) ) ) ) ).

% neg_zmod_mult_2
thf(fact_2240_take__bit__minus__small__eq,axiom,
    ! [K: int,N: nat] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ K )
     => ( ( ord_less_eq @ int @ K @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) )
       => ( ( bit_se2584673776208193580ke_bit @ int @ N @ ( uminus_uminus @ int @ K ) )
          = ( minus_minus @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) @ K ) ) ) ) ).

% take_bit_minus_small_eq
thf(fact_2241_powr__int,axiom,
    ! [X: real,I: int] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ I )
         => ( ( powr @ real @ X @ ( ring_1_of_int @ real @ I ) )
            = ( power_power @ real @ X @ ( nat2 @ I ) ) ) )
        & ( ~ ( ord_less_eq @ int @ ( zero_zero @ int ) @ I )
         => ( ( powr @ real @ X @ ( ring_1_of_int @ real @ I ) )
            = ( divide_divide @ real @ ( one_one @ real ) @ ( power_power @ real @ X @ ( nat2 @ ( uminus_uminus @ int @ I ) ) ) ) ) ) ) ) ).

% powr_int
thf(fact_2242_nonzero__of__real__divide,axiom,
    ! [A: $tType] :
      ( ( real_V7773925162809079976_field @ A )
     => ! [Y: real,X: real] :
          ( ( Y
           != ( zero_zero @ real ) )
         => ( ( real_Vector_of_real @ A @ ( divide_divide @ real @ X @ Y ) )
            = ( divide_divide @ A @ ( real_Vector_of_real @ A @ X ) @ ( real_Vector_of_real @ A @ Y ) ) ) ) ) ).

% nonzero_of_real_divide
thf(fact_2243_compl__less__compl__iff,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less @ A @ ( uminus_uminus @ A @ X ) @ ( uminus_uminus @ A @ Y ) )
          = ( ord_less @ A @ Y @ X ) ) ) ).

% compl_less_compl_iff
thf(fact_2244_compl__le__compl__iff,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ X ) @ ( uminus_uminus @ A @ Y ) )
          = ( ord_less_eq @ A @ Y @ X ) ) ) ).

% compl_le_compl_iff
thf(fact_2245_signed__take__bit__rec,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( ( bit_ri4674362597316999326ke_bit @ A )
        = ( ^ [N3: nat,A3: A] :
              ( if @ A
              @ ( N3
                = ( zero_zero @ nat ) )
              @ ( uminus_uminus @ A @ ( modulo_modulo @ A @ A3 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) )
              @ ( plus_plus @ A @ ( modulo_modulo @ A @ A3 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_ri4674362597316999326ke_bit @ A @ ( minus_minus @ nat @ N3 @ ( one_one @ nat ) ) @ ( divide_divide @ A @ A3 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ).

% signed_take_bit_rec
thf(fact_2246_xor__int__unfold,axiom,
    ( ( bit_se5824344971392196577ns_xor @ int )
    = ( ^ [K3: int,L2: int] :
          ( if @ int
          @ ( K3
            = ( uminus_uminus @ int @ ( one_one @ int ) ) )
          @ ( bit_ri4277139882892585799ns_not @ int @ L2 )
          @ ( if @ int
            @ ( L2
              = ( uminus_uminus @ int @ ( one_one @ int ) ) )
            @ ( bit_ri4277139882892585799ns_not @ int @ K3 )
            @ ( if @ int
              @ ( K3
                = ( zero_zero @ int ) )
              @ L2
              @ ( if @ int
                @ ( L2
                  = ( zero_zero @ int ) )
                @ K3
                @ ( plus_plus @ int @ ( abs_abs @ int @ ( minus_minus @ int @ ( modulo_modulo @ int @ K3 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( modulo_modulo @ int @ L2 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se5824344971392196577ns_xor @ int @ ( divide_divide @ int @ K3 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ int @ L2 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ) ) ).

% xor_int_unfold
thf(fact_2247_arctan__double,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( abs_abs @ real @ X ) @ ( one_one @ real ) )
     => ( ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( arctan @ X ) )
        = ( arctan @ ( divide_divide @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ X ) @ ( minus_minus @ real @ ( one_one @ real ) @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% arctan_double
thf(fact_2248_central__binomial__lower__bound,axiom,
    ! [N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ord_less_eq @ real @ ( divide_divide @ real @ ( power_power @ real @ ( numeral_numeral @ real @ ( bit0 @ ( bit0 @ one2 ) ) ) @ N ) @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( semiring_1_of_nat @ real @ N ) ) ) @ ( semiring_1_of_nat @ real @ ( binomial @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) @ N ) ) ) ) ).

% central_binomial_lower_bound
thf(fact_2249_bit_Odouble__compl,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X: A] :
          ( ( bit_ri4277139882892585799ns_not @ A @ ( bit_ri4277139882892585799ns_not @ A @ X ) )
          = X ) ) ).

% bit.double_compl
thf(fact_2250_bit_Ocompl__eq__compl__iff,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X: A,Y: A] :
          ( ( ( bit_ri4277139882892585799ns_not @ A @ X )
            = ( bit_ri4277139882892585799ns_not @ A @ Y ) )
          = ( X = Y ) ) ) ).

% bit.compl_eq_compl_iff
thf(fact_2251_signed__take__bit__of__0,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N: nat] :
          ( ( bit_ri4674362597316999326ke_bit @ A @ N @ ( zero_zero @ A ) )
          = ( zero_zero @ A ) ) ) ).

% signed_take_bit_of_0
thf(fact_2252_arctan__zero__zero,axiom,
    ( ( arctan @ ( zero_zero @ real ) )
    = ( zero_zero @ real ) ) ).

% arctan_zero_zero
thf(fact_2253_arctan__eq__zero__iff,axiom,
    ! [X: real] :
      ( ( ( arctan @ X )
        = ( zero_zero @ real ) )
      = ( X
        = ( zero_zero @ real ) ) ) ).

% arctan_eq_zero_iff
thf(fact_2254_bit_Oxor__compl__left,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X: A,Y: A] :
          ( ( bit_se5824344971392196577ns_xor @ A @ ( bit_ri4277139882892585799ns_not @ A @ X ) @ Y )
          = ( bit_ri4277139882892585799ns_not @ A @ ( bit_se5824344971392196577ns_xor @ A @ X @ Y ) ) ) ) ).

% bit.xor_compl_left
thf(fact_2255_bit_Oxor__compl__right,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X: A,Y: A] :
          ( ( bit_se5824344971392196577ns_xor @ A @ X @ ( bit_ri4277139882892585799ns_not @ A @ Y ) )
          = ( bit_ri4277139882892585799ns_not @ A @ ( bit_se5824344971392196577ns_xor @ A @ X @ Y ) ) ) ) ).

% bit.xor_compl_right
thf(fact_2256_signed__take__bit__of__minus__1,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N: nat] :
          ( ( bit_ri4674362597316999326ke_bit @ A @ N @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% signed_take_bit_of_minus_1
thf(fact_2257_signed__take__bit__numeral__of__1,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [K: num] :
          ( ( bit_ri4674362597316999326ke_bit @ A @ ( numeral_numeral @ nat @ K ) @ ( one_one @ A ) )
          = ( one_one @ A ) ) ) ).

% signed_take_bit_numeral_of_1
thf(fact_2258_arctan__less__zero__iff,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( arctan @ X ) @ ( zero_zero @ real ) )
      = ( ord_less @ real @ X @ ( zero_zero @ real ) ) ) ).

% arctan_less_zero_iff
thf(fact_2259_zero__less__arctan__iff,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ ( arctan @ X ) )
      = ( ord_less @ real @ ( zero_zero @ real ) @ X ) ) ).

% zero_less_arctan_iff
thf(fact_2260_arctan__le__zero__iff,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( arctan @ X ) @ ( zero_zero @ real ) )
      = ( ord_less_eq @ real @ X @ ( zero_zero @ real ) ) ) ).

% arctan_le_zero_iff
thf(fact_2261_zero__le__arctan__iff,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( arctan @ X ) )
      = ( ord_less_eq @ real @ ( zero_zero @ real ) @ X ) ) ).

% zero_le_arctan_iff
thf(fact_2262_bit_Ocompl__zero,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( ( bit_ri4277139882892585799ns_not @ A @ ( zero_zero @ A ) )
        = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% bit.compl_zero
thf(fact_2263_bit_Ocompl__one,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( ( bit_ri4277139882892585799ns_not @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
        = ( zero_zero @ A ) ) ) ).

% bit.compl_one
thf(fact_2264_bit_Odisj__cancel__left,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X: A] :
          ( ( bit_se1065995026697491101ons_or @ A @ ( bit_ri4277139882892585799ns_not @ A @ X ) @ X )
          = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% bit.disj_cancel_left
thf(fact_2265_bit_Odisj__cancel__right,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X: A] :
          ( ( bit_se1065995026697491101ons_or @ A @ X @ ( bit_ri4277139882892585799ns_not @ A @ X ) )
          = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% bit.disj_cancel_right
thf(fact_2266_bit_Oxor__one__left,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X: A] :
          ( ( bit_se5824344971392196577ns_xor @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ X )
          = ( bit_ri4277139882892585799ns_not @ A @ X ) ) ) ).

% bit.xor_one_left
thf(fact_2267_bit_Oxor__one__right,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X: A] :
          ( ( bit_se5824344971392196577ns_xor @ A @ X @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( bit_ri4277139882892585799ns_not @ A @ X ) ) ) ).

% bit.xor_one_right
thf(fact_2268_bit_Oxor__cancel__left,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X: A] :
          ( ( bit_se5824344971392196577ns_xor @ A @ ( bit_ri4277139882892585799ns_not @ A @ X ) @ X )
          = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% bit.xor_cancel_left
thf(fact_2269_bit_Oxor__cancel__right,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X: A] :
          ( ( bit_se5824344971392196577ns_xor @ A @ X @ ( bit_ri4277139882892585799ns_not @ A @ X ) )
          = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% bit.xor_cancel_right
thf(fact_2270_not__nonnegative__int__iff,axiom,
    ! [K: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( bit_ri4277139882892585799ns_not @ int @ K ) )
      = ( ord_less @ int @ K @ ( zero_zero @ int ) ) ) ).

% not_nonnegative_int_iff
thf(fact_2271_not__negative__int__iff,axiom,
    ! [K: int] :
      ( ( ord_less @ int @ ( bit_ri4277139882892585799ns_not @ int @ K ) @ ( zero_zero @ int ) )
      = ( ord_less_eq @ int @ ( zero_zero @ int ) @ K ) ) ).

% not_negative_int_iff
thf(fact_2272_even__not__iff,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [A2: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_ri4277139882892585799ns_not @ A @ A2 ) )
          = ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) ) ) ) ).

% even_not_iff
thf(fact_2273_not__one__eq,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( ( bit_ri4277139882892585799ns_not @ A @ ( one_one @ A ) )
        = ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% not_one_eq
thf(fact_2274_signed__take__bit__0,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [A2: A] :
          ( ( bit_ri4674362597316999326ke_bit @ A @ ( zero_zero @ nat ) @ A2 )
          = ( uminus_uminus @ A @ ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ).

% signed_take_bit_0
thf(fact_2275_of__int__not__eq,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [K: int] :
          ( ( ring_1_of_int @ A @ ( bit_ri4277139882892585799ns_not @ int @ K ) )
          = ( bit_ri4277139882892585799ns_not @ A @ ( ring_1_of_int @ A @ K ) ) ) ) ).

% of_int_not_eq
thf(fact_2276_signed__take__bit__minus,axiom,
    ! [N: nat,K: int] :
      ( ( bit_ri4674362597316999326ke_bit @ int @ N @ ( uminus_uminus @ int @ ( bit_ri4674362597316999326ke_bit @ int @ N @ K ) ) )
      = ( bit_ri4674362597316999326ke_bit @ int @ N @ ( uminus_uminus @ int @ K ) ) ) ).

% signed_take_bit_minus
thf(fact_2277_signed__take__bit__mult,axiom,
    ! [N: nat,K: int,L: int] :
      ( ( bit_ri4674362597316999326ke_bit @ int @ N @ ( times_times @ int @ ( bit_ri4674362597316999326ke_bit @ int @ N @ K ) @ ( bit_ri4674362597316999326ke_bit @ int @ N @ L ) ) )
      = ( bit_ri4674362597316999326ke_bit @ int @ N @ ( times_times @ int @ K @ L ) ) ) ).

% signed_take_bit_mult
thf(fact_2278_signed__take__bit__add,axiom,
    ! [N: nat,K: int,L: int] :
      ( ( bit_ri4674362597316999326ke_bit @ int @ N @ ( plus_plus @ int @ ( bit_ri4674362597316999326ke_bit @ int @ N @ K ) @ ( bit_ri4674362597316999326ke_bit @ int @ N @ L ) ) )
      = ( bit_ri4674362597316999326ke_bit @ int @ N @ ( plus_plus @ int @ K @ L ) ) ) ).

% signed_take_bit_add
thf(fact_2279_take__bit__not__iff,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N: nat,A2: A,B2: A] :
          ( ( ( bit_se2584673776208193580ke_bit @ A @ N @ ( bit_ri4277139882892585799ns_not @ A @ A2 ) )
            = ( bit_se2584673776208193580ke_bit @ A @ N @ ( bit_ri4277139882892585799ns_not @ A @ B2 ) ) )
          = ( ( bit_se2584673776208193580ke_bit @ A @ N @ A2 )
            = ( bit_se2584673776208193580ke_bit @ A @ N @ B2 ) ) ) ) ).

% take_bit_not_iff
thf(fact_2280_take__bit__not__take__bit,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N: nat,A2: A] :
          ( ( bit_se2584673776208193580ke_bit @ A @ N @ ( bit_ri4277139882892585799ns_not @ A @ ( bit_se2584673776208193580ke_bit @ A @ N @ A2 ) ) )
          = ( bit_se2584673776208193580ke_bit @ A @ N @ ( bit_ri4277139882892585799ns_not @ A @ A2 ) ) ) ) ).

% take_bit_not_take_bit
thf(fact_2281_arctan__monotone,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less @ real @ X @ Y )
     => ( ord_less @ real @ ( arctan @ X ) @ ( arctan @ Y ) ) ) ).

% arctan_monotone
thf(fact_2282_arctan__less__iff,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less @ real @ ( arctan @ X ) @ ( arctan @ Y ) )
      = ( ord_less @ real @ X @ Y ) ) ).

% arctan_less_iff
thf(fact_2283_signed__take__bit__diff,axiom,
    ! [N: nat,K: int,L: int] :
      ( ( bit_ri4674362597316999326ke_bit @ int @ N @ ( minus_minus @ int @ ( bit_ri4674362597316999326ke_bit @ int @ N @ K ) @ ( bit_ri4674362597316999326ke_bit @ int @ N @ L ) ) )
      = ( bit_ri4674362597316999326ke_bit @ int @ N @ ( minus_minus @ int @ K @ L ) ) ) ).

% signed_take_bit_diff
thf(fact_2284_arctan__monotone_H,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less_eq @ real @ X @ Y )
     => ( ord_less_eq @ real @ ( arctan @ X ) @ ( arctan @ Y ) ) ) ).

% arctan_monotone'
thf(fact_2285_arctan__le__iff,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less_eq @ real @ ( arctan @ X ) @ ( arctan @ Y ) )
      = ( ord_less_eq @ real @ X @ Y ) ) ).

% arctan_le_iff
thf(fact_2286_of__int__not__numeral,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [K: num] :
          ( ( ring_1_of_int @ A @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ K ) ) )
          = ( bit_ri4277139882892585799ns_not @ A @ ( numeral_numeral @ A @ K ) ) ) ) ).

% of_int_not_numeral
thf(fact_2287_not__add__distrib,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [A2: A,B2: A] :
          ( ( bit_ri4277139882892585799ns_not @ A @ ( plus_plus @ A @ A2 @ B2 ) )
          = ( minus_minus @ A @ ( bit_ri4277139882892585799ns_not @ A @ A2 ) @ B2 ) ) ) ).

% not_add_distrib
thf(fact_2288_not__diff__distrib,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [A2: A,B2: A] :
          ( ( bit_ri4277139882892585799ns_not @ A @ ( minus_minus @ A @ A2 @ B2 ) )
          = ( plus_plus @ A @ ( bit_ri4277139882892585799ns_not @ A @ A2 ) @ B2 ) ) ) ).

% not_diff_distrib
thf(fact_2289_signed__take__bit__take__bit,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [M: nat,N: nat,A2: A] :
          ( ( bit_ri4674362597316999326ke_bit @ A @ M @ ( bit_se2584673776208193580ke_bit @ A @ N @ A2 ) )
          = ( if @ ( A > A ) @ ( ord_less_eq @ nat @ N @ M ) @ ( bit_se2584673776208193580ke_bit @ A @ N ) @ ( bit_ri4674362597316999326ke_bit @ A @ M ) @ A2 ) ) ) ).

% signed_take_bit_take_bit
thf(fact_2290_minus__eq__not__plus__1,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( ( uminus_uminus @ A )
        = ( ^ [A3: A] : ( plus_plus @ A @ ( bit_ri4277139882892585799ns_not @ A @ A3 ) @ ( one_one @ A ) ) ) ) ) ).

% minus_eq_not_plus_1
thf(fact_2291_not__eq__complement,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( ( bit_ri4277139882892585799ns_not @ A )
        = ( ^ [A3: A] : ( minus_minus @ A @ ( uminus_uminus @ A @ A3 ) @ ( one_one @ A ) ) ) ) ) ).

% not_eq_complement
thf(fact_2292_minus__eq__not__minus__1,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( ( uminus_uminus @ A )
        = ( ^ [A3: A] : ( bit_ri4277139882892585799ns_not @ A @ ( minus_minus @ A @ A3 @ ( one_one @ A ) ) ) ) ) ) ).

% minus_eq_not_minus_1
thf(fact_2293_not__int__def,axiom,
    ( ( bit_ri4277139882892585799ns_not @ int )
    = ( ^ [K3: int] : ( minus_minus @ int @ ( uminus_uminus @ int @ K3 ) @ ( one_one @ int ) ) ) ) ).

% not_int_def
thf(fact_2294_or__not__numerals_I1_J,axiom,
    ( ( bit_se1065995026697491101ons_or @ int @ ( one_one @ int ) @ ( bit_ri4277139882892585799ns_not @ int @ ( one_one @ int ) ) )
    = ( bit_ri4277139882892585799ns_not @ int @ ( zero_zero @ int ) ) ) ).

% or_not_numerals(1)
thf(fact_2295_not__int__div__2,axiom,
    ! [K: int] :
      ( ( divide_divide @ int @ ( bit_ri4277139882892585799ns_not @ int @ K ) @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) )
      = ( bit_ri4277139882892585799ns_not @ int @ ( divide_divide @ int @ K @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) ).

% not_int_div_2
thf(fact_2296_even__not__iff__int,axiom,
    ! [K: int] :
      ( ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_ri4277139882892585799ns_not @ int @ K ) )
      = ( ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ K ) ) ) ).

% even_not_iff_int
thf(fact_2297_or__not__numerals_I4_J,axiom,
    ! [M: num] :
      ( ( bit_se1065995026697491101ons_or @ int @ ( numeral_numeral @ int @ ( bit0 @ M ) ) @ ( bit_ri4277139882892585799ns_not @ int @ ( one_one @ int ) ) )
      = ( bit_ri4277139882892585799ns_not @ int @ ( one_one @ int ) ) ) ).

% or_not_numerals(4)
thf(fact_2298_or__not__numerals_I2_J,axiom,
    ! [N: num] :
      ( ( bit_se1065995026697491101ons_or @ int @ ( one_one @ int ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ ( bit0 @ N ) ) ) )
      = ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ ( bit0 @ N ) ) ) ) ).

% or_not_numerals(2)
thf(fact_2299_binomial__mono,axiom,
    ! [K: nat,K5: nat,N: nat] :
      ( ( ord_less_eq @ nat @ K @ K5 )
     => ( ( ord_less_eq @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ K5 ) @ N )
       => ( ord_less_eq @ nat @ ( binomial @ N @ K ) @ ( binomial @ N @ K5 ) ) ) ) ).

% binomial_mono
thf(fact_2300_binomial__maximum_H,axiom,
    ! [N: nat,K: nat] : ( ord_less_eq @ nat @ ( binomial @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) @ K ) @ ( binomial @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) @ N ) ) ).

% binomial_maximum'
thf(fact_2301_binomial__maximum,axiom,
    ! [N: nat,K: nat] : ( ord_less_eq @ nat @ ( binomial @ N @ K ) @ ( binomial @ N @ ( divide_divide @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ).

% binomial_maximum
thf(fact_2302_binomial__antimono,axiom,
    ! [K: nat,K5: nat,N: nat] :
      ( ( ord_less_eq @ nat @ K @ K5 )
     => ( ( ord_less_eq @ nat @ ( divide_divide @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ K )
       => ( ( ord_less_eq @ nat @ K5 @ N )
         => ( ord_less_eq @ nat @ ( binomial @ N @ K5 ) @ ( binomial @ N @ K ) ) ) ) ) ).

% binomial_antimono
thf(fact_2303_signed__take__bit__int__less__exp,axiom,
    ! [N: nat,K: int] : ( ord_less @ int @ ( bit_ri4674362597316999326ke_bit @ int @ N @ K ) @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) ) ).

% signed_take_bit_int_less_exp
thf(fact_2304_even__signed__take__bit__iff,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [M: nat,A2: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_ri4674362597316999326ke_bit @ A @ M @ A2 ) )
          = ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) ) ) ).

% even_signed_take_bit_iff
thf(fact_2305_binomial__strict__mono,axiom,
    ! [K: nat,K5: nat,N: nat] :
      ( ( ord_less @ nat @ K @ K5 )
     => ( ( ord_less_eq @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ K5 ) @ N )
       => ( ord_less @ nat @ ( binomial @ N @ K ) @ ( binomial @ N @ K5 ) ) ) ) ).

% binomial_strict_mono
thf(fact_2306_binomial__strict__antimono,axiom,
    ! [K: nat,K5: nat,N: nat] :
      ( ( ord_less @ nat @ K @ K5 )
     => ( ( ord_less_eq @ nat @ N @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ K ) )
       => ( ( ord_less_eq @ nat @ K5 @ N )
         => ( ord_less @ nat @ ( binomial @ N @ K5 ) @ ( binomial @ N @ K ) ) ) ) ) ).

% binomial_strict_antimono
thf(fact_2307_signed__take__bit__int__greater__eq__self__iff,axiom,
    ! [K: int,N: nat] :
      ( ( ord_less_eq @ int @ K @ ( bit_ri4674362597316999326ke_bit @ int @ N @ K ) )
      = ( ord_less @ int @ K @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) ) ) ).

% signed_take_bit_int_greater_eq_self_iff
thf(fact_2308_signed__take__bit__int__less__self__iff,axiom,
    ! [N: nat,K: int] :
      ( ( ord_less @ int @ ( bit_ri4674362597316999326ke_bit @ int @ N @ K ) @ K )
      = ( ord_less_eq @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) @ K ) ) ).

% signed_take_bit_int_less_self_iff
thf(fact_2309_signed__take__bit__int__greater__eq__minus__exp,axiom,
    ! [N: nat,K: int] : ( ord_less_eq @ int @ ( uminus_uminus @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) ) @ ( bit_ri4674362597316999326ke_bit @ int @ N @ K ) ) ).

% signed_take_bit_int_greater_eq_minus_exp
thf(fact_2310_signed__take__bit__int__less__eq__self__iff,axiom,
    ! [N: nat,K: int] :
      ( ( ord_less_eq @ int @ ( bit_ri4674362597316999326ke_bit @ int @ N @ K ) @ K )
      = ( ord_less_eq @ int @ ( uminus_uminus @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) ) @ K ) ) ).

% signed_take_bit_int_less_eq_self_iff
thf(fact_2311_signed__take__bit__int__greater__self__iff,axiom,
    ! [K: int,N: nat] :
      ( ( ord_less @ int @ K @ ( bit_ri4674362597316999326ke_bit @ int @ N @ K ) )
      = ( ord_less @ int @ K @ ( uminus_uminus @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) ) ) ) ).

% signed_take_bit_int_greater_self_iff
thf(fact_2312_compl__le__swap2,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [Y: A,X: A] :
          ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ Y ) @ X )
         => ( ord_less_eq @ A @ ( uminus_uminus @ A @ X ) @ Y ) ) ) ).

% compl_le_swap2
thf(fact_2313_compl__le__swap1,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [Y: A,X: A] :
          ( ( ord_less_eq @ A @ Y @ ( uminus_uminus @ A @ X ) )
         => ( ord_less_eq @ A @ X @ ( uminus_uminus @ A @ Y ) ) ) ) ).

% compl_le_swap1
thf(fact_2314_compl__mono,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ A @ X @ Y )
         => ( ord_less_eq @ A @ ( uminus_uminus @ A @ Y ) @ ( uminus_uminus @ A @ X ) ) ) ) ).

% compl_mono
thf(fact_2315_compl__less__swap2,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [Y: A,X: A] :
          ( ( ord_less @ A @ ( uminus_uminus @ A @ Y ) @ X )
         => ( ord_less @ A @ ( uminus_uminus @ A @ X ) @ Y ) ) ) ).

% compl_less_swap2
thf(fact_2316_compl__less__swap1,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [Y: A,X: A] :
          ( ( ord_less @ A @ Y @ ( uminus_uminus @ A @ X ) )
         => ( ord_less @ A @ X @ ( uminus_uminus @ A @ Y ) ) ) ) ).

% compl_less_swap1
thf(fact_2317_or__not__numerals_I5_J,axiom,
    ! [M: num,N: num] :
      ( ( bit_se1065995026697491101ons_or @ int @ ( numeral_numeral @ int @ ( bit0 @ M ) ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ ( bit0 @ N ) ) ) )
      = ( plus_plus @ int @ ( one_one @ int ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se1065995026697491101ons_or @ int @ ( numeral_numeral @ int @ M ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ N ) ) ) ) ) ) ).

% or_not_numerals(5)
thf(fact_2318_signed__take__bit__int__eq__self__iff,axiom,
    ! [N: nat,K: int] :
      ( ( ( bit_ri4674362597316999326ke_bit @ int @ N @ K )
        = K )
      = ( ( ord_less_eq @ int @ ( uminus_uminus @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) ) @ K )
        & ( ord_less @ int @ K @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) ) ) ) ).

% signed_take_bit_int_eq_self_iff
thf(fact_2319_signed__take__bit__int__eq__self,axiom,
    ! [N: nat,K: int] :
      ( ( ord_less_eq @ int @ ( uminus_uminus @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) ) @ K )
     => ( ( ord_less @ int @ K @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) )
       => ( ( bit_ri4674362597316999326ke_bit @ int @ N @ K )
          = K ) ) ) ).

% signed_take_bit_int_eq_self
thf(fact_2320_arctan__add,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less_eq @ real @ ( abs_abs @ real @ X ) @ ( one_one @ real ) )
     => ( ( ord_less @ real @ ( abs_abs @ real @ Y ) @ ( one_one @ real ) )
       => ( ( plus_plus @ real @ ( arctan @ X ) @ ( arctan @ Y ) )
          = ( arctan @ ( divide_divide @ real @ ( plus_plus @ real @ X @ Y ) @ ( minus_minus @ real @ ( one_one @ real ) @ ( times_times @ real @ X @ Y ) ) ) ) ) ) ) ).

% arctan_add
thf(fact_2321_arctan__half,axiom,
    ( arctan
    = ( ^ [X2: real] : ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( arctan @ ( divide_divide @ real @ X2 @ ( plus_plus @ real @ ( one_one @ real ) @ ( sqrt @ ( plus_plus @ real @ ( one_one @ real ) @ ( power_power @ real @ X2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ) ).

% arctan_half
thf(fact_2322_zero__less__binomial__iff,axiom,
    ! [N: nat,K: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( binomial @ N @ K ) )
      = ( ord_less_eq @ nat @ K @ N ) ) ).

% zero_less_binomial_iff
thf(fact_2323_choose__two,axiom,
    ! [N: nat] :
      ( ( binomial @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
      = ( divide_divide @ nat @ ( times_times @ nat @ N @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ).

% choose_two
thf(fact_2324_binomial__n__0,axiom,
    ! [N: nat] :
      ( ( binomial @ N @ ( zero_zero @ nat ) )
      = ( one_one @ nat ) ) ).

% binomial_n_0
thf(fact_2325_binomial__eq__0__iff,axiom,
    ! [N: nat,K: nat] :
      ( ( ( binomial @ N @ K )
        = ( zero_zero @ nat ) )
      = ( ord_less @ nat @ N @ K ) ) ).

% binomial_eq_0_iff
thf(fact_2326_times__binomial__minus1__eq,axiom,
    ! [K: nat,N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
     => ( ( times_times @ nat @ K @ ( binomial @ N @ K ) )
        = ( times_times @ nat @ N @ ( binomial @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) @ ( minus_minus @ nat @ K @ ( one_one @ nat ) ) ) ) ) ) ).

% times_binomial_minus1_eq
thf(fact_2327_choose__reduce__nat,axiom,
    ! [N: nat,K: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
       => ( ( binomial @ N @ K )
          = ( plus_plus @ nat @ ( binomial @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) @ ( minus_minus @ nat @ K @ ( one_one @ nat ) ) ) @ ( binomial @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) @ K ) ) ) ) ) ).

% choose_reduce_nat
thf(fact_2328_binomial__eq__0,axiom,
    ! [N: nat,K: nat] :
      ( ( ord_less @ nat @ N @ K )
     => ( ( binomial @ N @ K )
        = ( zero_zero @ nat ) ) ) ).

% binomial_eq_0
thf(fact_2329_binomial__symmetric,axiom,
    ! [K: nat,N: nat] :
      ( ( ord_less_eq @ nat @ K @ N )
     => ( ( binomial @ N @ K )
        = ( binomial @ N @ ( minus_minus @ nat @ N @ K ) ) ) ) ).

% binomial_symmetric
thf(fact_2330_binomial__le__pow,axiom,
    ! [R2: nat,N: nat] :
      ( ( ord_less_eq @ nat @ R2 @ N )
     => ( ord_less_eq @ nat @ ( binomial @ N @ R2 ) @ ( power_power @ nat @ N @ R2 ) ) ) ).

% binomial_le_pow
thf(fact_2331_zero__less__binomial,axiom,
    ! [K: nat,N: nat] :
      ( ( ord_less_eq @ nat @ K @ N )
     => ( ord_less @ nat @ ( zero_zero @ nat ) @ ( binomial @ N @ K ) ) ) ).

% zero_less_binomial
thf(fact_2332_choose__mult,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ K @ M )
     => ( ( ord_less_eq @ nat @ M @ N )
       => ( ( times_times @ nat @ ( binomial @ N @ M ) @ ( binomial @ M @ K ) )
          = ( times_times @ nat @ ( binomial @ N @ K ) @ ( binomial @ ( minus_minus @ nat @ N @ K ) @ ( minus_minus @ nat @ M @ K ) ) ) ) ) ) ).

% choose_mult
thf(fact_2333_binomial__ge__n__over__k__pow__k,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [K: nat,N: nat] :
          ( ( ord_less_eq @ nat @ K @ N )
         => ( ord_less_eq @ A @ ( power_power @ A @ ( divide_divide @ A @ ( semiring_1_of_nat @ A @ N ) @ ( semiring_1_of_nat @ A @ K ) ) @ K ) @ ( semiring_1_of_nat @ A @ ( binomial @ N @ K ) ) ) ) ) ).

% binomial_ge_n_over_k_pow_k
thf(fact_2334_binomial__le__pow2,axiom,
    ! [N: nat,K: nat] : ( ord_less_eq @ nat @ ( binomial @ N @ K ) @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ).

% binomial_le_pow2
thf(fact_2335_set__decode__0,axiom,
    ! [X: nat] :
      ( ( member @ nat @ ( zero_zero @ nat ) @ ( nat_set_decode @ X ) )
      = ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ X ) ) ) ).

% set_decode_0
thf(fact_2336_add__scale__eq__noteq,axiom,
    ! [A: $tType] :
      ( ( semiri1453513574482234551roduct @ A )
     => ! [R2: A,A2: A,B2: A,C2: A,D2: A] :
          ( ( R2
           != ( zero_zero @ A ) )
         => ( ( ( A2 = B2 )
              & ( C2 != D2 ) )
           => ( ( plus_plus @ A @ A2 @ ( times_times @ A @ R2 @ C2 ) )
             != ( plus_plus @ A @ B2 @ ( times_times @ A @ R2 @ D2 ) ) ) ) ) ) ).

% add_scale_eq_noteq
thf(fact_2337__C9_C,axiom,
    ( ( divide_divide @ nat @ deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
    = na ) ).

% "9"
thf(fact_2338_fact__double,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [N: nat] :
          ( ( semiring_char_0_fact @ A @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) )
          = ( times_times @ A @ ( times_times @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) @ ( comm_s3205402744901411588hammer @ A @ ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ N ) ) @ ( semiring_char_0_fact @ A @ N ) ) ) ) ).

% fact_double
thf(fact_2339_tanh__real__altdef,axiom,
    ( ( tanh @ real )
    = ( ^ [X2: real] : ( divide_divide @ real @ ( minus_minus @ real @ ( one_one @ real ) @ ( exp @ real @ ( times_times @ real @ ( uminus_uminus @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ X2 ) ) ) @ ( plus_plus @ real @ ( one_one @ real ) @ ( exp @ real @ ( times_times @ real @ ( uminus_uminus @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ X2 ) ) ) ) ) ) ).

% tanh_real_altdef
thf(fact_2340_and__int__unfold,axiom,
    ( ( bit_se5824344872417868541ns_and @ int )
    = ( ^ [K3: int,L2: int] :
          ( if @ int
          @ ( ( K3
              = ( zero_zero @ int ) )
            | ( L2
              = ( zero_zero @ int ) ) )
          @ ( zero_zero @ int )
          @ ( if @ int
            @ ( K3
              = ( uminus_uminus @ int @ ( one_one @ int ) ) )
            @ L2
            @ ( if @ int
              @ ( L2
                = ( uminus_uminus @ int @ ( one_one @ int ) ) )
              @ K3
              @ ( plus_plus @ int @ ( times_times @ int @ ( modulo_modulo @ int @ K3 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( modulo_modulo @ int @ L2 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se5824344872417868541ns_and @ int @ ( divide_divide @ int @ K3 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ int @ L2 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ) ).

% and_int_unfold
thf(fact_2341_and_Oidem,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ A2 @ A2 )
          = A2 ) ) ).

% and.idem
thf(fact_2342_and_Oleft__idem,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A,B2: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ A2 @ ( bit_se5824344872417868541ns_and @ A @ A2 @ B2 ) )
          = ( bit_se5824344872417868541ns_and @ A @ A2 @ B2 ) ) ) ).

% and.left_idem
thf(fact_2343_and_Oright__idem,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A,B2: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( bit_se5824344872417868541ns_and @ A @ A2 @ B2 ) @ B2 )
          = ( bit_se5824344872417868541ns_and @ A @ A2 @ B2 ) ) ) ).

% and.right_idem
thf(fact_2344_bit_Oconj__zero__right,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ X @ ( zero_zero @ A ) )
          = ( zero_zero @ A ) ) ) ).

% bit.conj_zero_right
thf(fact_2345_bit_Oconj__zero__left,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( zero_zero @ A ) @ X )
          = ( zero_zero @ A ) ) ) ).

% bit.conj_zero_left
thf(fact_2346_zero__and__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( zero_zero @ A ) @ A2 )
          = ( zero_zero @ A ) ) ) ).

% zero_and_eq
thf(fact_2347_and__zero__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ A2 @ ( zero_zero @ A ) )
          = ( zero_zero @ A ) ) ) ).

% and_zero_eq
thf(fact_2348_of__nat__fact,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [N: nat] :
          ( ( semiring_1_of_nat @ A @ ( semiring_char_0_fact @ nat @ N ) )
          = ( semiring_char_0_fact @ A @ N ) ) ) ).

% of_nat_fact
thf(fact_2349_exp__less__cancel__iff,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less @ real @ ( exp @ real @ X ) @ ( exp @ real @ Y ) )
      = ( ord_less @ real @ X @ Y ) ) ).

% exp_less_cancel_iff
thf(fact_2350_exp__less__mono,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less @ real @ X @ Y )
     => ( ord_less @ real @ ( exp @ real @ X ) @ ( exp @ real @ Y ) ) ) ).

% exp_less_mono
thf(fact_2351_take__bit__and,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,A2: A,B2: A] :
          ( ( bit_se2584673776208193580ke_bit @ A @ N @ ( bit_se5824344872417868541ns_and @ A @ A2 @ B2 ) )
          = ( bit_se5824344872417868541ns_and @ A @ ( bit_se2584673776208193580ke_bit @ A @ N @ A2 ) @ ( bit_se2584673776208193580ke_bit @ A @ N @ B2 ) ) ) ) ).

% take_bit_and
thf(fact_2352_exp__le__cancel__iff,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less_eq @ real @ ( exp @ real @ X ) @ ( exp @ real @ Y ) )
      = ( ord_less_eq @ real @ X @ Y ) ) ).

% exp_le_cancel_iff
thf(fact_2353__C3_C,axiom,
    ( deg
    = ( plus_plus @ nat @ na @ m ) ) ).

% "3"
thf(fact_2354_exp__zero,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ( ( exp @ A @ ( zero_zero @ A ) )
        = ( one_one @ A ) ) ) ).

% exp_zero
thf(fact_2355_and_Oleft__neutral,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [A2: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ A2 )
          = A2 ) ) ).

% and.left_neutral
thf(fact_2356_and_Oright__neutral,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [A2: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ A2 @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = A2 ) ) ).

% and.right_neutral
thf(fact_2357_bit_Oconj__one__right,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ X @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = X ) ) ).

% bit.conj_one_right
thf(fact_2358_fact__0,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ( ( semiring_char_0_fact @ A @ ( zero_zero @ nat ) )
        = ( one_one @ A ) ) ) ).

% fact_0
thf(fact_2359_bit_Oconj__cancel__right,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ X @ ( bit_ri4277139882892585799ns_not @ A @ X ) )
          = ( zero_zero @ A ) ) ) ).

% bit.conj_cancel_right
thf(fact_2360_bit_Oconj__cancel__left,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( bit_ri4277139882892585799ns_not @ A @ X ) @ X )
          = ( zero_zero @ A ) ) ) ).

% bit.conj_cancel_left
thf(fact_2361_exp__eq__one__iff,axiom,
    ! [X: real] :
      ( ( ( exp @ real @ X )
        = ( one_one @ real ) )
      = ( X
        = ( zero_zero @ real ) ) ) ).

% exp_eq_one_iff
thf(fact_2362_and__nonnegative__int__iff,axiom,
    ! [K: int,L: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( bit_se5824344872417868541ns_and @ int @ K @ L ) )
      = ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ K )
        | ( ord_less_eq @ int @ ( zero_zero @ int ) @ L ) ) ) ).

% and_nonnegative_int_iff
thf(fact_2363_and__negative__int__iff,axiom,
    ! [K: int,L: int] :
      ( ( ord_less @ int @ ( bit_se5824344872417868541ns_and @ int @ K @ L ) @ ( zero_zero @ int ) )
      = ( ( ord_less @ int @ K @ ( zero_zero @ int ) )
        & ( ord_less @ int @ L @ ( zero_zero @ int ) ) ) ) ).

% and_negative_int_iff
thf(fact_2364_bit_Ode__Morgan__disj,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X: A,Y: A] :
          ( ( bit_ri4277139882892585799ns_not @ A @ ( bit_se1065995026697491101ons_or @ A @ X @ Y ) )
          = ( bit_se5824344872417868541ns_and @ A @ ( bit_ri4277139882892585799ns_not @ A @ X ) @ ( bit_ri4277139882892585799ns_not @ A @ Y ) ) ) ) ).

% bit.de_Morgan_disj
thf(fact_2365_bit_Ode__Morgan__conj,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X: A,Y: A] :
          ( ( bit_ri4277139882892585799ns_not @ A @ ( bit_se5824344872417868541ns_and @ A @ X @ Y ) )
          = ( bit_se1065995026697491101ons_or @ A @ ( bit_ri4277139882892585799ns_not @ A @ X ) @ ( bit_ri4277139882892585799ns_not @ A @ Y ) ) ) ) ).

% bit.de_Morgan_conj
thf(fact_2366_one__less__exp__iff,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ ( exp @ real @ X ) )
      = ( ord_less @ real @ ( zero_zero @ real ) @ X ) ) ).

% one_less_exp_iff
thf(fact_2367_exp__less__one__iff,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( exp @ real @ X ) @ ( one_one @ real ) )
      = ( ord_less @ real @ X @ ( zero_zero @ real ) ) ) ).

% exp_less_one_iff
thf(fact_2368_one__le__exp__iff,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( one_one @ real ) @ ( exp @ real @ X ) )
      = ( ord_less_eq @ real @ ( zero_zero @ real ) @ X ) ) ).

% one_le_exp_iff
thf(fact_2369_exp__le__one__iff,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( exp @ real @ X ) @ ( one_one @ real ) )
      = ( ord_less_eq @ real @ X @ ( zero_zero @ real ) ) ) ).

% exp_le_one_iff
thf(fact_2370_exp__ln__iff,axiom,
    ! [X: real] :
      ( ( ( exp @ real @ ( ln_ln @ real @ X ) )
        = X )
      = ( ord_less @ real @ ( zero_zero @ real ) @ X ) ) ).

% exp_ln_iff
thf(fact_2371_exp__ln,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( exp @ real @ ( ln_ln @ real @ X ) )
        = X ) ) ).

% exp_ln
thf(fact_2372_and__numerals_I5_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X: num] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( numeral_numeral @ A @ ( bit0 @ X ) ) @ ( one_one @ A ) )
          = ( zero_zero @ A ) ) ) ).

% and_numerals(5)
thf(fact_2373_and__numerals_I1_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [Y: num] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ Y ) ) )
          = ( zero_zero @ A ) ) ) ).

% and_numerals(1)
thf(fact_2374_and__numerals_I3_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X: num,Y: num] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( numeral_numeral @ A @ ( bit0 @ X ) ) @ ( numeral_numeral @ A @ ( bit0 @ Y ) ) )
          = ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se5824344872417868541ns_and @ A @ ( numeral_numeral @ A @ X ) @ ( numeral_numeral @ A @ Y ) ) ) ) ) ).

% and_numerals(3)
thf(fact_2375_fact__2,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ( ( semiring_char_0_fact @ A @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
        = ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ).

% fact_2
thf(fact_2376_and__minus__numerals_I5_J,axiom,
    ! [N: num] :
      ( ( bit_se5824344872417868541ns_and @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit0 @ N ) ) ) @ ( one_one @ int ) )
      = ( zero_zero @ int ) ) ).

% and_minus_numerals(5)
thf(fact_2377_and__minus__numerals_I1_J,axiom,
    ! [N: num] :
      ( ( bit_se5824344872417868541ns_and @ int @ ( one_one @ int ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit0 @ N ) ) ) )
      = ( zero_zero @ int ) ) ).

% and_minus_numerals(1)
thf(fact_2378_and__minus__minus__numerals,axiom,
    ! [M: num,N: num] :
      ( ( bit_se5824344872417868541ns_and @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ M ) ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N ) ) )
      = ( bit_ri4277139882892585799ns_not @ int @ ( bit_se1065995026697491101ons_or @ int @ ( minus_minus @ int @ ( numeral_numeral @ int @ M ) @ ( one_one @ int ) ) @ ( minus_minus @ int @ ( numeral_numeral @ int @ N ) @ ( one_one @ int ) ) ) ) ) ).

% and_minus_minus_numerals
thf(fact_2379_or__minus__minus__numerals,axiom,
    ! [M: num,N: num] :
      ( ( bit_se1065995026697491101ons_or @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ M ) ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N ) ) )
      = ( bit_ri4277139882892585799ns_not @ int @ ( bit_se5824344872417868541ns_and @ int @ ( minus_minus @ int @ ( numeral_numeral @ int @ M ) @ ( one_one @ int ) ) @ ( minus_minus @ int @ ( numeral_numeral @ int @ N ) @ ( one_one @ int ) ) ) ) ) ).

% or_minus_minus_numerals
thf(fact_2380_of__int__and__eq,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [K: int,L: int] :
          ( ( ring_1_of_int @ A @ ( bit_se5824344872417868541ns_and @ int @ K @ L ) )
          = ( bit_se5824344872417868541ns_and @ A @ ( ring_1_of_int @ A @ K ) @ ( ring_1_of_int @ A @ L ) ) ) ) ).

% of_int_and_eq
thf(fact_2381_and_Oassoc,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( bit_se5824344872417868541ns_and @ A @ A2 @ B2 ) @ C2 )
          = ( bit_se5824344872417868541ns_and @ A @ A2 @ ( bit_se5824344872417868541ns_and @ A @ B2 @ C2 ) ) ) ) ).

% and.assoc
thf(fact_2382_and_Ocommute,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se5824344872417868541ns_and @ A )
        = ( ^ [A3: A,B3: A] : ( bit_se5824344872417868541ns_and @ A @ B3 @ A3 ) ) ) ) ).

% and.commute
thf(fact_2383_and_Oleft__commute,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ B2 @ ( bit_se5824344872417868541ns_and @ A @ A2 @ C2 ) )
          = ( bit_se5824344872417868541ns_and @ A @ A2 @ ( bit_se5824344872417868541ns_and @ A @ B2 @ C2 ) ) ) ) ).

% and.left_commute
thf(fact_2384_of__nat__and__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M: nat,N: nat] :
          ( ( semiring_1_of_nat @ A @ ( bit_se5824344872417868541ns_and @ nat @ M @ N ) )
          = ( bit_se5824344872417868541ns_and @ A @ ( semiring_1_of_nat @ A @ M ) @ ( semiring_1_of_nat @ A @ N ) ) ) ) ).

% of_nat_and_eq
thf(fact_2385_exp__less__cancel,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less @ real @ ( exp @ real @ X ) @ ( exp @ real @ Y ) )
     => ( ord_less @ real @ X @ Y ) ) ).

% exp_less_cancel
thf(fact_2386_fact__mono__nat,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ M @ N )
     => ( ord_less_eq @ nat @ ( semiring_char_0_fact @ nat @ M ) @ ( semiring_char_0_fact @ nat @ N ) ) ) ).

% fact_mono_nat
thf(fact_2387_fact__ge__self,axiom,
    ! [N: nat] : ( ord_less_eq @ nat @ N @ ( semiring_char_0_fact @ nat @ N ) ) ).

% fact_ge_self
thf(fact_2388_exp__not__eq__zero,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [X: A] :
          ( ( exp @ A @ X )
         != ( zero_zero @ A ) ) ) ).

% exp_not_eq_zero
thf(fact_2389_bit_Oconj__disj__distrib,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X: A,Y: A,Z: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ X @ ( bit_se1065995026697491101ons_or @ A @ Y @ Z ) )
          = ( bit_se1065995026697491101ons_or @ A @ ( bit_se5824344872417868541ns_and @ A @ X @ Y ) @ ( bit_se5824344872417868541ns_and @ A @ X @ Z ) ) ) ) ).

% bit.conj_disj_distrib
thf(fact_2390_bit_Odisj__conj__distrib,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X: A,Y: A,Z: A] :
          ( ( bit_se1065995026697491101ons_or @ A @ X @ ( bit_se5824344872417868541ns_and @ A @ Y @ Z ) )
          = ( bit_se5824344872417868541ns_and @ A @ ( bit_se1065995026697491101ons_or @ A @ X @ Y ) @ ( bit_se1065995026697491101ons_or @ A @ X @ Z ) ) ) ) ).

% bit.disj_conj_distrib
thf(fact_2391_bit_Oconj__disj__distrib2,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [Y: A,Z: A,X: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( bit_se1065995026697491101ons_or @ A @ Y @ Z ) @ X )
          = ( bit_se1065995026697491101ons_or @ A @ ( bit_se5824344872417868541ns_and @ A @ Y @ X ) @ ( bit_se5824344872417868541ns_and @ A @ Z @ X ) ) ) ) ).

% bit.conj_disj_distrib2
thf(fact_2392_bit_Odisj__conj__distrib2,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [Y: A,Z: A,X: A] :
          ( ( bit_se1065995026697491101ons_or @ A @ ( bit_se5824344872417868541ns_and @ A @ Y @ Z ) @ X )
          = ( bit_se5824344872417868541ns_and @ A @ ( bit_se1065995026697491101ons_or @ A @ Y @ X ) @ ( bit_se1065995026697491101ons_or @ A @ Z @ X ) ) ) ) ).

% bit.disj_conj_distrib2
thf(fact_2393_fact__nonzero,axiom,
    ! [A: $tType] :
      ( ( ( semiring_char_0 @ A )
        & ( semiri3467727345109120633visors @ A ) )
     => ! [N: nat] :
          ( ( semiring_char_0_fact @ A @ N )
         != ( zero_zero @ A ) ) ) ).

% fact_nonzero
thf(fact_2394_bit_Oconj__xor__distrib,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X: A,Y: A,Z: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ X @ ( bit_se5824344971392196577ns_xor @ A @ Y @ Z ) )
          = ( bit_se5824344971392196577ns_xor @ A @ ( bit_se5824344872417868541ns_and @ A @ X @ Y ) @ ( bit_se5824344872417868541ns_and @ A @ X @ Z ) ) ) ) ).

% bit.conj_xor_distrib
thf(fact_2395_bit_Oconj__xor__distrib2,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [Y: A,Z: A,X: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( bit_se5824344971392196577ns_xor @ A @ Y @ Z ) @ X )
          = ( bit_se5824344971392196577ns_xor @ A @ ( bit_se5824344872417868541ns_and @ A @ Y @ X ) @ ( bit_se5824344872417868541ns_and @ A @ Z @ X ) ) ) ) ).

% bit.conj_xor_distrib2
thf(fact_2396_subset__decode__imp__le,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less_eq @ ( set @ nat ) @ ( nat_set_decode @ M ) @ ( nat_set_decode @ N ) )
     => ( ord_less_eq @ nat @ M @ N ) ) ).

% subset_decode_imp_le
thf(fact_2397_and__eq__minus__1__iff,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [A2: A,B2: A] :
          ( ( ( bit_se5824344872417868541ns_and @ A @ A2 @ B2 )
            = ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( ( A2
              = ( uminus_uminus @ A @ ( one_one @ A ) ) )
            & ( B2
              = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ) ) ).

% and_eq_minus_1_iff
thf(fact_2398_fact__less__mono__nat,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M )
     => ( ( ord_less @ nat @ M @ N )
       => ( ord_less @ nat @ ( semiring_char_0_fact @ nat @ M ) @ ( semiring_char_0_fact @ nat @ N ) ) ) ) ).

% fact_less_mono_nat
thf(fact_2399_exp__total,axiom,
    ! [Y: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ Y )
     => ? [X3: real] :
          ( ( exp @ real @ X3 )
          = Y ) ) ).

% exp_total
thf(fact_2400_exp__gt__zero,axiom,
    ! [X: real] : ( ord_less @ real @ ( zero_zero @ real ) @ ( exp @ real @ X ) ) ).

% exp_gt_zero
thf(fact_2401_not__exp__less__zero,axiom,
    ! [X: real] :
      ~ ( ord_less @ real @ ( exp @ real @ X ) @ ( zero_zero @ real ) ) ).

% not_exp_less_zero
thf(fact_2402_exp__ge__zero,axiom,
    ! [X: real] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( exp @ real @ X ) ) ).

% exp_ge_zero
thf(fact_2403_not__exp__le__zero,axiom,
    ! [X: real] :
      ~ ( ord_less_eq @ real @ ( exp @ real @ X ) @ ( zero_zero @ real ) ) ).

% not_exp_le_zero
thf(fact_2404_AND__lower,axiom,
    ! [X: int,Y: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ X )
     => ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( bit_se5824344872417868541ns_and @ int @ X @ Y ) ) ) ).

% AND_lower
thf(fact_2405_AND__upper1,axiom,
    ! [X: int,Y: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ X )
     => ( ord_less_eq @ int @ ( bit_se5824344872417868541ns_and @ int @ X @ Y ) @ X ) ) ).

% AND_upper1
thf(fact_2406_AND__upper2,axiom,
    ! [Y: int,X: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Y )
     => ( ord_less_eq @ int @ ( bit_se5824344872417868541ns_and @ int @ X @ Y ) @ Y ) ) ).

% AND_upper2
thf(fact_2407_AND__upper1_H,axiom,
    ! [Y: int,Z: int,Ya: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Y )
     => ( ( ord_less_eq @ int @ Y @ Z )
       => ( ord_less_eq @ int @ ( bit_se5824344872417868541ns_and @ int @ Y @ Ya ) @ Z ) ) ) ).

% AND_upper1'
thf(fact_2408_AND__upper2_H,axiom,
    ! [Y: int,Z: int,X: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Y )
     => ( ( ord_less_eq @ int @ Y @ Z )
       => ( ord_less_eq @ int @ ( bit_se5824344872417868541ns_and @ int @ X @ Y ) @ Z ) ) ) ).

% AND_upper2'
thf(fact_2409_fact__ge__zero,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [N: nat] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( semiring_char_0_fact @ A @ N ) ) ) ).

% fact_ge_zero
thf(fact_2410_fact__gt__zero,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [N: nat] : ( ord_less @ A @ ( zero_zero @ A ) @ ( semiring_char_0_fact @ A @ N ) ) ) ).

% fact_gt_zero
thf(fact_2411_fact__not__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [N: nat] :
          ~ ( ord_less @ A @ ( semiring_char_0_fact @ A @ N ) @ ( zero_zero @ A ) ) ) ).

% fact_not_neg
thf(fact_2412_fact__ge__1,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [N: nat] : ( ord_less_eq @ A @ ( one_one @ A ) @ ( semiring_char_0_fact @ A @ N ) ) ) ).

% fact_ge_1
thf(fact_2413_or__eq__not__not__and,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( ( bit_se1065995026697491101ons_or @ A )
        = ( ^ [A3: A,B3: A] : ( bit_ri4277139882892585799ns_not @ A @ ( bit_se5824344872417868541ns_and @ A @ ( bit_ri4277139882892585799ns_not @ A @ A3 ) @ ( bit_ri4277139882892585799ns_not @ A @ B3 ) ) ) ) ) ) ).

% or_eq_not_not_and
thf(fact_2414_and__eq__not__not__or,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( ( bit_se5824344872417868541ns_and @ A )
        = ( ^ [A3: A,B3: A] : ( bit_ri4277139882892585799ns_not @ A @ ( bit_se1065995026697491101ons_or @ A @ ( bit_ri4277139882892585799ns_not @ A @ A3 ) @ ( bit_ri4277139882892585799ns_not @ A @ B3 ) ) ) ) ) ) ).

% and_eq_not_not_or
thf(fact_2415_fact__mono,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [M: nat,N: nat] :
          ( ( ord_less_eq @ nat @ M @ N )
         => ( ord_less_eq @ A @ ( semiring_char_0_fact @ A @ M ) @ ( semiring_char_0_fact @ A @ N ) ) ) ) ).

% fact_mono
thf(fact_2416_fact__dvd,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [N: nat,M: nat] :
          ( ( ord_less_eq @ nat @ N @ M )
         => ( dvd_dvd @ A @ ( semiring_char_0_fact @ A @ N ) @ ( semiring_char_0_fact @ A @ M ) ) ) ) ).

% fact_dvd
thf(fact_2417_plus__and__or,axiom,
    ! [X: int,Y: int] :
      ( ( plus_plus @ int @ ( bit_se5824344872417868541ns_and @ int @ X @ Y ) @ ( bit_se1065995026697491101ons_or @ int @ X @ Y ) )
      = ( plus_plus @ int @ X @ Y ) ) ).

% plus_and_or
thf(fact_2418_or__int__def,axiom,
    ( ( bit_se1065995026697491101ons_or @ int )
    = ( ^ [K3: int,L2: int] : ( bit_ri4277139882892585799ns_not @ int @ ( bit_se5824344872417868541ns_and @ int @ ( bit_ri4277139882892585799ns_not @ int @ K3 ) @ ( bit_ri4277139882892585799ns_not @ int @ L2 ) ) ) ) ) ).

% or_int_def
thf(fact_2419_exp__gt__one,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ord_less @ real @ ( one_one @ real ) @ ( exp @ real @ X ) ) ) ).

% exp_gt_one
thf(fact_2420_exp__ge__add__one__self,axiom,
    ! [X: real] : ( ord_less_eq @ real @ ( plus_plus @ real @ ( one_one @ real ) @ X ) @ ( exp @ real @ X ) ) ).

% exp_ge_add_one_self
thf(fact_2421_dvd__fact,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ ( one_one @ nat ) @ M )
     => ( ( ord_less_eq @ nat @ M @ N )
       => ( dvd_dvd @ nat @ M @ ( semiring_char_0_fact @ nat @ N ) ) ) ) ).

% dvd_fact
thf(fact_2422_AND__upper2_H_H,axiom,
    ! [Y: int,Z: int,X: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Y )
     => ( ( ord_less @ int @ Y @ Z )
       => ( ord_less @ int @ ( bit_se5824344872417868541ns_and @ int @ X @ Y ) @ Z ) ) ) ).

% AND_upper2''
thf(fact_2423_AND__upper1_H_H,axiom,
    ! [Y: int,Z: int,Ya: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Y )
     => ( ( ord_less @ int @ Y @ Z )
       => ( ord_less @ int @ ( bit_se5824344872417868541ns_and @ int @ Y @ Ya ) @ Z ) ) ) ).

% AND_upper1''
thf(fact_2424_and__less__eq,axiom,
    ! [L: int,K: int] :
      ( ( ord_less @ int @ L @ ( zero_zero @ int ) )
     => ( ord_less_eq @ int @ ( bit_se5824344872417868541ns_and @ int @ K @ L ) @ K ) ) ).

% and_less_eq
thf(fact_2425_exp__of__nat2__mult,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A,N: nat] :
          ( ( exp @ A @ ( times_times @ A @ X @ ( semiring_1_of_nat @ A @ N ) ) )
          = ( power_power @ A @ ( exp @ A @ X ) @ N ) ) ) ).

% exp_of_nat2_mult
thf(fact_2426_exp__of__nat__mult,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [N: nat,X: A] :
          ( ( exp @ A @ ( times_times @ A @ ( semiring_1_of_nat @ A @ N ) @ X ) )
          = ( power_power @ A @ ( exp @ A @ X ) @ N ) ) ) ).

% exp_of_nat_mult
thf(fact_2427_fact__less__mono,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [M: nat,N: nat] :
          ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M )
         => ( ( ord_less @ nat @ M @ N )
           => ( ord_less @ A @ ( semiring_char_0_fact @ A @ M ) @ ( semiring_char_0_fact @ A @ N ) ) ) ) ) ).

% fact_less_mono
thf(fact_2428_bit_Oxor__def,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( ( bit_se5824344971392196577ns_xor @ A )
        = ( ^ [X2: A,Y4: A] : ( bit_se1065995026697491101ons_or @ A @ ( bit_se5824344872417868541ns_and @ A @ X2 @ ( bit_ri4277139882892585799ns_not @ A @ Y4 ) ) @ ( bit_se5824344872417868541ns_and @ A @ ( bit_ri4277139882892585799ns_not @ A @ X2 ) @ Y4 ) ) ) ) ) ).

% bit.xor_def
thf(fact_2429_bit_Oxor__def2,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( ( bit_se5824344971392196577ns_xor @ A )
        = ( ^ [X2: A,Y4: A] : ( bit_se5824344872417868541ns_and @ A @ ( bit_se1065995026697491101ons_or @ A @ X2 @ Y4 ) @ ( bit_se1065995026697491101ons_or @ A @ ( bit_ri4277139882892585799ns_not @ A @ X2 ) @ ( bit_ri4277139882892585799ns_not @ A @ Y4 ) ) ) ) ) ) ).

% bit.xor_def2
thf(fact_2430_and__not__numerals_I1_J,axiom,
    ( ( bit_se5824344872417868541ns_and @ int @ ( one_one @ int ) @ ( bit_ri4277139882892585799ns_not @ int @ ( one_one @ int ) ) )
    = ( zero_zero @ int ) ) ).

% and_not_numerals(1)
thf(fact_2431_fact__mod,axiom,
    ! [A: $tType] :
      ( ( ( linordered_semidom @ A )
        & ( semidom_modulo @ A ) )
     => ! [M: nat,N: nat] :
          ( ( ord_less_eq @ nat @ M @ N )
         => ( ( modulo_modulo @ A @ ( semiring_char_0_fact @ A @ N ) @ ( semiring_char_0_fact @ A @ M ) )
            = ( zero_zero @ A ) ) ) ) ).

% fact_mod
thf(fact_2432_fact__le__power,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [N: nat] : ( ord_less_eq @ A @ ( semiring_char_0_fact @ A @ N ) @ ( semiring_1_of_nat @ A @ ( power_power @ nat @ N @ N ) ) ) ) ).

% fact_le_power
thf(fact_2433_xor__int__def,axiom,
    ( ( bit_se5824344971392196577ns_xor @ int )
    = ( ^ [K3: int,L2: int] : ( bit_se1065995026697491101ons_or @ int @ ( bit_se5824344872417868541ns_and @ int @ K3 @ ( bit_ri4277139882892585799ns_not @ int @ L2 ) ) @ ( bit_se5824344872417868541ns_and @ int @ ( bit_ri4277139882892585799ns_not @ int @ K3 ) @ L2 ) ) ) ) ).

% xor_int_def
thf(fact_2434_even__and__iff,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A,B2: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se5824344872417868541ns_and @ A @ A2 @ B2 ) )
          = ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
            | ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B2 ) ) ) ) ).

% even_and_iff
thf(fact_2435_bit_Ocomplement__unique,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [A2: A,X: A,Y: A] :
          ( ( ( bit_se5824344872417868541ns_and @ A @ A2 @ X )
            = ( zero_zero @ A ) )
         => ( ( ( bit_se1065995026697491101ons_or @ A @ A2 @ X )
              = ( uminus_uminus @ A @ ( one_one @ A ) ) )
           => ( ( ( bit_se5824344872417868541ns_and @ A @ A2 @ Y )
                = ( zero_zero @ A ) )
             => ( ( ( bit_se1065995026697491101ons_or @ A @ A2 @ Y )
                  = ( uminus_uminus @ A @ ( one_one @ A ) ) )
               => ( X = Y ) ) ) ) ) ) ).

% bit.complement_unique
thf(fact_2436_exp__ge__add__one__self__aux,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ord_less_eq @ real @ ( plus_plus @ real @ ( one_one @ real ) @ X ) @ ( exp @ real @ X ) ) ) ).

% exp_ge_add_one_self_aux
thf(fact_2437_even__and__iff__int,axiom,
    ! [K: int,L: int] :
      ( ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se5824344872417868541ns_and @ int @ K @ L ) )
      = ( ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ K )
        | ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ L ) ) ) ).

% even_and_iff_int
thf(fact_2438_lemma__exp__total,axiom,
    ! [Y: real] :
      ( ( ord_less_eq @ real @ ( one_one @ real ) @ Y )
     => ? [X3: real] :
          ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X3 )
          & ( ord_less_eq @ real @ X3 @ ( minus_minus @ real @ Y @ ( one_one @ real ) ) )
          & ( ( exp @ real @ X3 )
            = Y ) ) ) ).

% lemma_exp_total
thf(fact_2439_ln__ge__iff,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less_eq @ real @ Y @ ( ln_ln @ real @ X ) )
        = ( ord_less_eq @ real @ ( exp @ real @ Y ) @ X ) ) ) ).

% ln_ge_iff
thf(fact_2440_fact__div__fact__le__pow,axiom,
    ! [R2: nat,N: nat] :
      ( ( ord_less_eq @ nat @ R2 @ N )
     => ( ord_less_eq @ nat @ ( divide_divide @ nat @ ( semiring_char_0_fact @ nat @ N ) @ ( semiring_char_0_fact @ nat @ ( minus_minus @ nat @ N @ R2 ) ) ) @ ( power_power @ nat @ N @ R2 ) ) ) ).

% fact_div_fact_le_pow
thf(fact_2441_ln__x__over__x__mono,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less_eq @ real @ ( exp @ real @ ( one_one @ real ) ) @ X )
     => ( ( ord_less_eq @ real @ X @ Y )
       => ( ord_less_eq @ real @ ( divide_divide @ real @ ( ln_ln @ real @ Y ) @ Y ) @ ( divide_divide @ real @ ( ln_ln @ real @ X ) @ X ) ) ) ) ).

% ln_x_over_x_mono
thf(fact_2442_binomial__fact__lemma,axiom,
    ! [K: nat,N: nat] :
      ( ( ord_less_eq @ nat @ K @ N )
     => ( ( times_times @ nat @ ( times_times @ nat @ ( semiring_char_0_fact @ nat @ K ) @ ( semiring_char_0_fact @ nat @ ( minus_minus @ nat @ N @ K ) ) ) @ ( binomial @ N @ K ) )
        = ( semiring_char_0_fact @ nat @ N ) ) ) ).

% binomial_fact_lemma
thf(fact_2443_and__not__numerals_I4_J,axiom,
    ! [M: num] :
      ( ( bit_se5824344872417868541ns_and @ int @ ( numeral_numeral @ int @ ( bit0 @ M ) ) @ ( bit_ri4277139882892585799ns_not @ int @ ( one_one @ int ) ) )
      = ( numeral_numeral @ int @ ( bit0 @ M ) ) ) ).

% and_not_numerals(4)
thf(fact_2444_and__not__numerals_I2_J,axiom,
    ! [N: num] :
      ( ( bit_se5824344872417868541ns_and @ int @ ( one_one @ int ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ ( bit0 @ N ) ) ) )
      = ( one_one @ int ) ) ).

% and_not_numerals(2)
thf(fact_2445_choose__dvd,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [K: nat,N: nat] :
          ( ( ord_less_eq @ nat @ K @ N )
         => ( dvd_dvd @ A @ ( times_times @ A @ ( semiring_char_0_fact @ A @ K ) @ ( semiring_char_0_fact @ A @ ( minus_minus @ nat @ N @ K ) ) ) @ ( semiring_char_0_fact @ A @ N ) ) ) ) ).

% choose_dvd
thf(fact_2446_powr__def,axiom,
    ! [A: $tType] :
      ( ( ln @ A )
     => ( ( powr @ A )
        = ( ^ [X2: A,A3: A] :
              ( if @ A
              @ ( X2
                = ( zero_zero @ A ) )
              @ ( zero_zero @ A )
              @ ( exp @ A @ ( times_times @ A @ A3 @ ( ln_ln @ A @ X2 ) ) ) ) ) ) ) ).

% powr_def
thf(fact_2447_and__one__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ A2 @ ( one_one @ A ) )
          = ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% and_one_eq
thf(fact_2448_one__and__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( one_one @ A ) @ A2 )
          = ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% one_and_eq
thf(fact_2449_bit_Ocompl__unique,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [X: A,Y: A] :
          ( ( ( bit_se5824344872417868541ns_and @ A @ X @ Y )
            = ( zero_zero @ A ) )
         => ( ( ( bit_se1065995026697491101ons_or @ A @ X @ Y )
              = ( uminus_uminus @ A @ ( one_one @ A ) ) )
           => ( ( bit_ri4277139882892585799ns_not @ A @ X )
              = Y ) ) ) ) ).

% bit.compl_unique
thf(fact_2450_and__not__numerals_I5_J,axiom,
    ! [M: num,N: num] :
      ( ( bit_se5824344872417868541ns_and @ int @ ( numeral_numeral @ int @ ( bit0 @ M ) ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ ( bit0 @ N ) ) ) )
      = ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se5824344872417868541ns_and @ int @ ( numeral_numeral @ int @ M ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ N ) ) ) ) ) ).

% and_not_numerals(5)
thf(fact_2451_binomial__altdef__nat,axiom,
    ! [K: nat,N: nat] :
      ( ( ord_less_eq @ nat @ K @ N )
     => ( ( binomial @ N @ K )
        = ( divide_divide @ nat @ ( semiring_char_0_fact @ nat @ N ) @ ( times_times @ nat @ ( semiring_char_0_fact @ nat @ K ) @ ( semiring_char_0_fact @ nat @ ( minus_minus @ nat @ N @ K ) ) ) ) ) ) ).

% binomial_altdef_nat
thf(fact_2452_exp__divide__power__eq,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [N: nat,X: A] :
          ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
         => ( ( power_power @ A @ ( exp @ A @ ( divide_divide @ A @ X @ ( semiring_1_of_nat @ A @ N ) ) ) @ N )
            = ( exp @ A @ X ) ) ) ) ).

% exp_divide_power_eq
thf(fact_2453_square__fact__le__2__fact,axiom,
    ! [N: nat] : ( ord_less_eq @ real @ ( times_times @ real @ ( semiring_char_0_fact @ real @ N ) @ ( semiring_char_0_fact @ real @ N ) ) @ ( semiring_char_0_fact @ real @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ) ).

% square_fact_le_2_fact
thf(fact_2454_exp__half__le2,axiom,
    ord_less_eq @ real @ ( exp @ real @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ).

% exp_half_le2
thf(fact_2455_exp__double,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [Z: A] :
          ( ( exp @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ Z ) )
          = ( power_power @ A @ ( exp @ A @ Z ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ).

% exp_double
thf(fact_2456_fact__num__eq__if,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ( ( semiring_char_0_fact @ A )
        = ( ^ [M3: nat] :
              ( if @ A
              @ ( M3
                = ( zero_zero @ nat ) )
              @ ( one_one @ A )
              @ ( times_times @ A @ ( semiring_1_of_nat @ A @ M3 ) @ ( semiring_char_0_fact @ A @ ( minus_minus @ nat @ M3 @ ( one_one @ nat ) ) ) ) ) ) ) ) ).

% fact_num_eq_if
thf(fact_2457_fact__reduce,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [N: nat] :
          ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
         => ( ( semiring_char_0_fact @ A @ N )
            = ( times_times @ A @ ( semiring_1_of_nat @ A @ N ) @ ( semiring_char_0_fact @ A @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) ) ) ) ) ) ).

% fact_reduce
thf(fact_2458_pochhammer__same,axiom,
    ! [A: $tType] :
      ( ( ( semiring_char_0 @ A )
        & ( comm_ring_1 @ A )
        & ( semiri3467727345109120633visors @ A ) )
     => ! [N: nat] :
          ( ( comm_s3205402744901411588hammer @ A @ ( uminus_uminus @ A @ ( semiring_1_of_nat @ A @ N ) ) @ N )
          = ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ N ) @ ( semiring_char_0_fact @ A @ N ) ) ) ) ).

% pochhammer_same
thf(fact_2459_binomial__fact,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [K: nat,N: nat] :
          ( ( ord_less_eq @ nat @ K @ N )
         => ( ( semiring_1_of_nat @ A @ ( binomial @ N @ K ) )
            = ( divide_divide @ A @ ( semiring_char_0_fact @ A @ N ) @ ( times_times @ A @ ( semiring_char_0_fact @ A @ K ) @ ( semiring_char_0_fact @ A @ ( minus_minus @ nat @ N @ K ) ) ) ) ) ) ) ).

% binomial_fact
thf(fact_2460_fact__binomial,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [K: nat,N: nat] :
          ( ( ord_less_eq @ nat @ K @ N )
         => ( ( times_times @ A @ ( semiring_char_0_fact @ A @ K ) @ ( semiring_1_of_nat @ A @ ( binomial @ N @ K ) ) )
            = ( divide_divide @ A @ ( semiring_char_0_fact @ A @ N ) @ ( semiring_char_0_fact @ A @ ( minus_minus @ nat @ N @ K ) ) ) ) ) ) ).

% fact_binomial
thf(fact_2461_add__0__iff,axiom,
    ! [A: $tType] :
      ( ( semiri1453513574482234551roduct @ A )
     => ! [B2: A,A2: A] :
          ( ( B2
            = ( plus_plus @ A @ B2 @ A2 ) )
          = ( A2
            = ( zero_zero @ A ) ) ) ) ).

% add_0_iff
thf(fact_2462_exp__bound,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less_eq @ real @ X @ ( one_one @ real ) )
       => ( ord_less_eq @ real @ ( exp @ real @ X ) @ ( plus_plus @ real @ ( plus_plus @ real @ ( one_one @ real ) @ X ) @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% exp_bound
thf(fact_2463_real__exp__bound__lemma,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less_eq @ real @ X @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
       => ( ord_less_eq @ real @ ( exp @ real @ X ) @ ( plus_plus @ real @ ( one_one @ real ) @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ X ) ) ) ) ) ).

% real_exp_bound_lemma
thf(fact_2464_exp__ge__one__plus__x__over__n__power__n,axiom,
    ! [N: nat,X: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( semiring_1_of_nat @ real @ N ) ) @ X )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
       => ( ord_less_eq @ real @ ( power_power @ real @ ( plus_plus @ real @ ( one_one @ real ) @ ( divide_divide @ real @ X @ ( semiring_1_of_nat @ real @ N ) ) ) @ N ) @ ( exp @ real @ X ) ) ) ) ).

% exp_ge_one_plus_x_over_n_power_n
thf(fact_2465_exp__ge__one__minus__x__over__n__power__n,axiom,
    ! [X: real,N: nat] :
      ( ( ord_less_eq @ real @ X @ ( semiring_1_of_nat @ real @ N ) )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
       => ( ord_less_eq @ real @ ( power_power @ real @ ( minus_minus @ real @ ( one_one @ real ) @ ( divide_divide @ real @ X @ ( semiring_1_of_nat @ real @ N ) ) ) @ N ) @ ( exp @ real @ ( uminus_uminus @ real @ X ) ) ) ) ) ).

% exp_ge_one_minus_x_over_n_power_n
thf(fact_2466_exp__lower__Taylor__quadratic,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ord_less_eq @ real @ ( plus_plus @ real @ ( plus_plus @ real @ ( one_one @ real ) @ X ) @ ( divide_divide @ real @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ ( exp @ real @ X ) ) ) ).

% exp_lower_Taylor_quadratic
thf(fact_2467_highlowprop,axiom,
    ( ( ord_less @ nat @ ( vEBT_VEBT_high @ mi @ na ) @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ m ) )
    & ( ord_less @ nat @ ( vEBT_VEBT_low @ mi @ na ) @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ na ) ) ) ).

% highlowprop
thf(fact_2468_binomial__code,axiom,
    ( binomial
    = ( ^ [N3: nat,K3: nat] : ( if @ nat @ ( ord_less @ nat @ N3 @ K3 ) @ ( zero_zero @ nat ) @ ( if @ nat @ ( ord_less @ nat @ N3 @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ K3 ) ) @ ( binomial @ N3 @ ( minus_minus @ nat @ N3 @ K3 ) ) @ ( divide_divide @ nat @ ( set_fo6178422350223883121st_nat @ nat @ ( times_times @ nat ) @ ( plus_plus @ nat @ ( minus_minus @ nat @ N3 @ K3 ) @ ( one_one @ nat ) ) @ N3 @ ( one_one @ nat ) ) @ ( semiring_char_0_fact @ nat @ K3 ) ) ) ) ) ) ).

% binomial_code
thf(fact_2469_cos__coeff__def,axiom,
    ( cos_coeff
    = ( ^ [N3: nat] : ( if @ real @ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N3 ) @ ( divide_divide @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ ( divide_divide @ nat @ N3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( semiring_char_0_fact @ real @ N3 ) ) @ ( zero_zero @ real ) ) ) ) ).

% cos_coeff_def
thf(fact_2470_log__base__10__eq1,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( log2 @ ( numeral_numeral @ real @ ( bit0 @ ( bit1 @ ( bit0 @ one2 ) ) ) ) @ X )
        = ( times_times @ real @ ( divide_divide @ real @ ( ln_ln @ real @ ( exp @ real @ ( one_one @ real ) ) ) @ ( ln_ln @ real @ ( numeral_numeral @ real @ ( bit0 @ ( bit1 @ ( bit0 @ one2 ) ) ) ) ) ) @ ( ln_ln @ real @ X ) ) ) ) ).

% log_base_10_eq1
thf(fact_2471_fact__code,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ( ( semiring_char_0_fact @ A )
        = ( ^ [N3: nat] : ( semiring_1_of_nat @ A @ ( set_fo6178422350223883121st_nat @ nat @ ( times_times @ nat ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N3 @ ( one_one @ nat ) ) ) ) ) ) ).

% fact_code
thf(fact_2472_log__base__10__eq2,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( log2 @ ( numeral_numeral @ real @ ( bit0 @ ( bit1 @ ( bit0 @ one2 ) ) ) ) @ X )
        = ( times_times @ real @ ( log2 @ ( numeral_numeral @ real @ ( bit0 @ ( bit1 @ ( bit0 @ one2 ) ) ) ) @ ( exp @ real @ ( one_one @ real ) ) ) @ ( ln_ln @ real @ X ) ) ) ) ).

% log_base_10_eq2
thf(fact_2473__C8_C,axiom,
    na = m ).

% "8"
thf(fact_2474_verit__eq__simplify_I9_J,axiom,
    ! [X32: num,Y32: num] :
      ( ( ( bit1 @ X32 )
        = ( bit1 @ Y32 ) )
      = ( X32 = Y32 ) ) ).

% verit_eq_simplify(9)
thf(fact_2475_semiring__norm_I90_J,axiom,
    ! [M: num,N: num] :
      ( ( ( bit1 @ M )
        = ( bit1 @ N ) )
      = ( M = N ) ) ).

% semiring_norm(90)
thf(fact_2476_semiring__norm_I88_J,axiom,
    ! [M: num,N: num] :
      ( ( bit0 @ M )
     != ( bit1 @ N ) ) ).

% semiring_norm(88)
thf(fact_2477_semiring__norm_I89_J,axiom,
    ! [M: num,N: num] :
      ( ( bit1 @ M )
     != ( bit0 @ N ) ) ).

% semiring_norm(89)
thf(fact_2478_semiring__norm_I84_J,axiom,
    ! [N: num] :
      ( one2
     != ( bit1 @ N ) ) ).

% semiring_norm(84)
thf(fact_2479_semiring__norm_I86_J,axiom,
    ! [M: num] :
      ( ( bit1 @ M )
     != one2 ) ).

% semiring_norm(86)
thf(fact_2480_semiring__norm_I73_J,axiom,
    ! [M: num,N: num] :
      ( ( ord_less_eq @ num @ ( bit1 @ M ) @ ( bit1 @ N ) )
      = ( ord_less_eq @ num @ M @ N ) ) ).

% semiring_norm(73)
thf(fact_2481_semiring__norm_I80_J,axiom,
    ! [M: num,N: num] :
      ( ( ord_less @ num @ ( bit1 @ M ) @ ( bit1 @ N ) )
      = ( ord_less @ num @ M @ N ) ) ).

% semiring_norm(80)
thf(fact_2482_semiring__norm_I9_J,axiom,
    ! [M: num,N: num] :
      ( ( plus_plus @ num @ ( bit1 @ M ) @ ( bit0 @ N ) )
      = ( bit1 @ ( plus_plus @ num @ M @ N ) ) ) ).

% semiring_norm(9)
thf(fact_2483_semiring__norm_I7_J,axiom,
    ! [M: num,N: num] :
      ( ( plus_plus @ num @ ( bit0 @ M ) @ ( bit1 @ N ) )
      = ( bit1 @ ( plus_plus @ num @ M @ N ) ) ) ).

% semiring_norm(7)
thf(fact_2484_semiring__norm_I15_J,axiom,
    ! [M: num,N: num] :
      ( ( times_times @ num @ ( bit1 @ M ) @ ( bit0 @ N ) )
      = ( bit0 @ ( times_times @ num @ ( bit1 @ M ) @ N ) ) ) ).

% semiring_norm(15)
thf(fact_2485_semiring__norm_I14_J,axiom,
    ! [M: num,N: num] :
      ( ( times_times @ num @ ( bit0 @ M ) @ ( bit1 @ N ) )
      = ( bit0 @ ( times_times @ num @ M @ ( bit1 @ N ) ) ) ) ).

% semiring_norm(14)
thf(fact_2486_semiring__norm_I81_J,axiom,
    ! [M: num,N: num] :
      ( ( ord_less @ num @ ( bit1 @ M ) @ ( bit0 @ N ) )
      = ( ord_less @ num @ M @ N ) ) ).

% semiring_norm(81)
thf(fact_2487_semiring__norm_I72_J,axiom,
    ! [M: num,N: num] :
      ( ( ord_less_eq @ num @ ( bit0 @ M ) @ ( bit1 @ N ) )
      = ( ord_less_eq @ num @ M @ N ) ) ).

% semiring_norm(72)
thf(fact_2488_semiring__norm_I77_J,axiom,
    ! [N: num] : ( ord_less @ num @ one2 @ ( bit1 @ N ) ) ).

% semiring_norm(77)
thf(fact_2489_semiring__norm_I70_J,axiom,
    ! [M: num] :
      ~ ( ord_less_eq @ num @ ( bit1 @ M ) @ one2 ) ).

% semiring_norm(70)
thf(fact_2490_cos__coeff__0,axiom,
    ( ( cos_coeff @ ( zero_zero @ nat ) )
    = ( one_one @ real ) ) ).

% cos_coeff_0
thf(fact_2491_and__numerals_I8_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X: num] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( numeral_numeral @ A @ ( bit1 @ X ) ) @ ( one_one @ A ) )
          = ( one_one @ A ) ) ) ).

% and_numerals(8)
thf(fact_2492_and__numerals_I2_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [Y: num] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit1 @ Y ) ) )
          = ( one_one @ A ) ) ) ).

% and_numerals(2)
thf(fact_2493_or__numerals_I8_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X: num] :
          ( ( bit_se1065995026697491101ons_or @ A @ ( numeral_numeral @ A @ ( bit1 @ X ) ) @ ( one_one @ A ) )
          = ( numeral_numeral @ A @ ( bit1 @ X ) ) ) ) ).

% or_numerals(8)
thf(fact_2494_or__numerals_I2_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [Y: num] :
          ( ( bit_se1065995026697491101ons_or @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit1 @ Y ) ) )
          = ( numeral_numeral @ A @ ( bit1 @ Y ) ) ) ) ).

% or_numerals(2)
thf(fact_2495_zdiv__numeral__Bit1,axiom,
    ! [V: num,W: num] :
      ( ( divide_divide @ int @ ( numeral_numeral @ int @ ( bit1 @ V ) ) @ ( numeral_numeral @ int @ ( bit0 @ W ) ) )
      = ( divide_divide @ int @ ( numeral_numeral @ int @ V ) @ ( numeral_numeral @ int @ W ) ) ) ).

% zdiv_numeral_Bit1
thf(fact_2496_semiring__norm_I3_J,axiom,
    ! [N: num] :
      ( ( plus_plus @ num @ one2 @ ( bit0 @ N ) )
      = ( bit1 @ N ) ) ).

% semiring_norm(3)
thf(fact_2497_semiring__norm_I4_J,axiom,
    ! [N: num] :
      ( ( plus_plus @ num @ one2 @ ( bit1 @ N ) )
      = ( bit0 @ ( plus_plus @ num @ N @ one2 ) ) ) ).

% semiring_norm(4)
thf(fact_2498_semiring__norm_I5_J,axiom,
    ! [M: num] :
      ( ( plus_plus @ num @ ( bit0 @ M ) @ one2 )
      = ( bit1 @ M ) ) ).

% semiring_norm(5)
thf(fact_2499_semiring__norm_I8_J,axiom,
    ! [M: num] :
      ( ( plus_plus @ num @ ( bit1 @ M ) @ one2 )
      = ( bit0 @ ( plus_plus @ num @ M @ one2 ) ) ) ).

% semiring_norm(8)
thf(fact_2500_semiring__norm_I10_J,axiom,
    ! [M: num,N: num] :
      ( ( plus_plus @ num @ ( bit1 @ M ) @ ( bit1 @ N ) )
      = ( bit0 @ ( plus_plus @ num @ ( plus_plus @ num @ M @ N ) @ one2 ) ) ) ).

% semiring_norm(10)
thf(fact_2501_semiring__norm_I16_J,axiom,
    ! [M: num,N: num] :
      ( ( times_times @ num @ ( bit1 @ M ) @ ( bit1 @ N ) )
      = ( bit1 @ ( plus_plus @ num @ ( plus_plus @ num @ M @ N ) @ ( bit0 @ ( times_times @ num @ M @ N ) ) ) ) ) ).

% semiring_norm(16)
thf(fact_2502_semiring__norm_I79_J,axiom,
    ! [M: num,N: num] :
      ( ( ord_less @ num @ ( bit0 @ M ) @ ( bit1 @ N ) )
      = ( ord_less_eq @ num @ M @ N ) ) ).

% semiring_norm(79)
thf(fact_2503_semiring__norm_I74_J,axiom,
    ! [M: num,N: num] :
      ( ( ord_less_eq @ num @ ( bit1 @ M ) @ ( bit0 @ N ) )
      = ( ord_less @ num @ M @ N ) ) ).

% semiring_norm(74)
thf(fact_2504_or__numerals_I5_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X: num] :
          ( ( bit_se1065995026697491101ons_or @ A @ ( numeral_numeral @ A @ ( bit0 @ X ) ) @ ( one_one @ A ) )
          = ( numeral_numeral @ A @ ( bit1 @ X ) ) ) ) ).

% or_numerals(5)
thf(fact_2505_or__numerals_I1_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [Y: num] :
          ( ( bit_se1065995026697491101ons_or @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ Y ) ) )
          = ( numeral_numeral @ A @ ( bit1 @ Y ) ) ) ) ).

% or_numerals(1)
thf(fact_2506_xor__numerals_I1_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [Y: num] :
          ( ( bit_se5824344971392196577ns_xor @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ Y ) ) )
          = ( numeral_numeral @ A @ ( bit1 @ Y ) ) ) ) ).

% xor_numerals(1)
thf(fact_2507_xor__numerals_I2_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [Y: num] :
          ( ( bit_se5824344971392196577ns_xor @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit1 @ Y ) ) )
          = ( numeral_numeral @ A @ ( bit0 @ Y ) ) ) ) ).

% xor_numerals(2)
thf(fact_2508_xor__numerals_I5_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X: num] :
          ( ( bit_se5824344971392196577ns_xor @ A @ ( numeral_numeral @ A @ ( bit0 @ X ) ) @ ( one_one @ A ) )
          = ( numeral_numeral @ A @ ( bit1 @ X ) ) ) ) ).

% xor_numerals(5)
thf(fact_2509_xor__numerals_I8_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X: num] :
          ( ( bit_se5824344971392196577ns_xor @ A @ ( numeral_numeral @ A @ ( bit1 @ X ) ) @ ( one_one @ A ) )
          = ( numeral_numeral @ A @ ( bit0 @ X ) ) ) ) ).

% xor_numerals(8)
thf(fact_2510_and__minus__numerals_I2_J,axiom,
    ! [N: num] :
      ( ( bit_se5824344872417868541ns_and @ int @ ( one_one @ int ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit1 @ N ) ) ) )
      = ( one_one @ int ) ) ).

% and_minus_numerals(2)
thf(fact_2511_and__minus__numerals_I6_J,axiom,
    ! [N: num] :
      ( ( bit_se5824344872417868541ns_and @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit1 @ N ) ) ) @ ( one_one @ int ) )
      = ( one_one @ int ) ) ).

% and_minus_numerals(6)
thf(fact_2512_or__minus__numerals_I6_J,axiom,
    ! [N: num] :
      ( ( bit_se1065995026697491101ons_or @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit1 @ N ) ) ) @ ( one_one @ int ) )
      = ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit1 @ N ) ) ) ) ).

% or_minus_numerals(6)
thf(fact_2513_or__minus__numerals_I2_J,axiom,
    ! [N: num] :
      ( ( bit_se1065995026697491101ons_or @ int @ ( one_one @ int ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit1 @ N ) ) ) )
      = ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit1 @ N ) ) ) ) ).

% or_minus_numerals(2)
thf(fact_2514_and__numerals_I4_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X: num,Y: num] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( numeral_numeral @ A @ ( bit0 @ X ) ) @ ( numeral_numeral @ A @ ( bit1 @ Y ) ) )
          = ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se5824344872417868541ns_and @ A @ ( numeral_numeral @ A @ X ) @ ( numeral_numeral @ A @ Y ) ) ) ) ) ).

% and_numerals(4)
thf(fact_2515_and__numerals_I6_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X: num,Y: num] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( numeral_numeral @ A @ ( bit1 @ X ) ) @ ( numeral_numeral @ A @ ( bit0 @ Y ) ) )
          = ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se5824344872417868541ns_and @ A @ ( numeral_numeral @ A @ X ) @ ( numeral_numeral @ A @ Y ) ) ) ) ) ).

% and_numerals(6)
thf(fact_2516_xor__numerals_I7_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X: num,Y: num] :
          ( ( bit_se5824344971392196577ns_xor @ A @ ( numeral_numeral @ A @ ( bit1 @ X ) ) @ ( numeral_numeral @ A @ ( bit1 @ Y ) ) )
          = ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se5824344971392196577ns_xor @ A @ ( numeral_numeral @ A @ X ) @ ( numeral_numeral @ A @ Y ) ) ) ) ) ).

% xor_numerals(7)
thf(fact_2517_and__numerals_I7_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X: num,Y: num] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( numeral_numeral @ A @ ( bit1 @ X ) ) @ ( numeral_numeral @ A @ ( bit1 @ Y ) ) )
          = ( plus_plus @ A @ ( one_one @ A ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se5824344872417868541ns_and @ A @ ( numeral_numeral @ A @ X ) @ ( numeral_numeral @ A @ Y ) ) ) ) ) ) ).

% and_numerals(7)
thf(fact_2518_or__numerals_I4_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X: num,Y: num] :
          ( ( bit_se1065995026697491101ons_or @ A @ ( numeral_numeral @ A @ ( bit0 @ X ) ) @ ( numeral_numeral @ A @ ( bit1 @ Y ) ) )
          = ( plus_plus @ A @ ( one_one @ A ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se1065995026697491101ons_or @ A @ ( numeral_numeral @ A @ X ) @ ( numeral_numeral @ A @ Y ) ) ) ) ) ) ).

% or_numerals(4)
thf(fact_2519_or__numerals_I6_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X: num,Y: num] :
          ( ( bit_se1065995026697491101ons_or @ A @ ( numeral_numeral @ A @ ( bit1 @ X ) ) @ ( numeral_numeral @ A @ ( bit0 @ Y ) ) )
          = ( plus_plus @ A @ ( one_one @ A ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se1065995026697491101ons_or @ A @ ( numeral_numeral @ A @ X ) @ ( numeral_numeral @ A @ Y ) ) ) ) ) ) ).

% or_numerals(6)
thf(fact_2520_or__numerals_I7_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X: num,Y: num] :
          ( ( bit_se1065995026697491101ons_or @ A @ ( numeral_numeral @ A @ ( bit1 @ X ) ) @ ( numeral_numeral @ A @ ( bit1 @ Y ) ) )
          = ( plus_plus @ A @ ( one_one @ A ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se1065995026697491101ons_or @ A @ ( numeral_numeral @ A @ X ) @ ( numeral_numeral @ A @ Y ) ) ) ) ) ) ).

% or_numerals(7)
thf(fact_2521_xor__numerals_I4_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X: num,Y: num] :
          ( ( bit_se5824344971392196577ns_xor @ A @ ( numeral_numeral @ A @ ( bit0 @ X ) ) @ ( numeral_numeral @ A @ ( bit1 @ Y ) ) )
          = ( plus_plus @ A @ ( one_one @ A ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se5824344971392196577ns_xor @ A @ ( numeral_numeral @ A @ X ) @ ( numeral_numeral @ A @ Y ) ) ) ) ) ) ).

% xor_numerals(4)
thf(fact_2522_xor__numerals_I6_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [X: num,Y: num] :
          ( ( bit_se5824344971392196577ns_xor @ A @ ( numeral_numeral @ A @ ( bit1 @ X ) ) @ ( numeral_numeral @ A @ ( bit0 @ Y ) ) )
          = ( plus_plus @ A @ ( one_one @ A ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se5824344971392196577ns_xor @ A @ ( numeral_numeral @ A @ X ) @ ( numeral_numeral @ A @ Y ) ) ) ) ) ) ).

% xor_numerals(6)
thf(fact_2523_zmod__numeral__Bit1,axiom,
    ! [V: num,W: num] :
      ( ( modulo_modulo @ int @ ( numeral_numeral @ int @ ( bit1 @ V ) ) @ ( numeral_numeral @ int @ ( bit0 @ W ) ) )
      = ( plus_plus @ int @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( modulo_modulo @ int @ ( numeral_numeral @ int @ V ) @ ( numeral_numeral @ int @ W ) ) ) @ ( one_one @ int ) ) ) ).

% zmod_numeral_Bit1
thf(fact_2524_verit__eq__simplify_I14_J,axiom,
    ! [X22: num,X32: num] :
      ( ( bit0 @ X22 )
     != ( bit1 @ X32 ) ) ).

% verit_eq_simplify(14)
thf(fact_2525_verit__eq__simplify_I12_J,axiom,
    ! [X32: num] :
      ( one2
     != ( bit1 @ X32 ) ) ).

% verit_eq_simplify(12)
thf(fact_2526_num_Oexhaust,axiom,
    ! [Y: num] :
      ( ( Y != one2 )
     => ( ! [X23: num] :
            ( Y
           != ( bit0 @ X23 ) )
       => ~ ! [X33: num] :
              ( Y
             != ( bit1 @ X33 ) ) ) ) ).

% num.exhaust
thf(fact_2527_numeral__Bit1,axiom,
    ! [A: $tType] :
      ( ( numeral @ A )
     => ! [N: num] :
          ( ( numeral_numeral @ A @ ( bit1 @ N ) )
          = ( plus_plus @ A @ ( plus_plus @ A @ ( numeral_numeral @ A @ N ) @ ( numeral_numeral @ A @ N ) ) @ ( one_one @ A ) ) ) ) ).

% numeral_Bit1
thf(fact_2528_cong__exp__iff__simps_I10_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [M: num,Q3: num,N: num] :
          ( ( modulo_modulo @ A @ ( numeral_numeral @ A @ ( bit0 @ M ) ) @ ( numeral_numeral @ A @ ( bit0 @ Q3 ) ) )
         != ( modulo_modulo @ A @ ( numeral_numeral @ A @ ( bit1 @ N ) ) @ ( numeral_numeral @ A @ ( bit0 @ Q3 ) ) ) ) ) ).

% cong_exp_iff_simps(10)
thf(fact_2529_cong__exp__iff__simps_I12_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [M: num,Q3: num,N: num] :
          ( ( modulo_modulo @ A @ ( numeral_numeral @ A @ ( bit1 @ M ) ) @ ( numeral_numeral @ A @ ( bit0 @ Q3 ) ) )
         != ( modulo_modulo @ A @ ( numeral_numeral @ A @ ( bit0 @ N ) ) @ ( numeral_numeral @ A @ ( bit0 @ Q3 ) ) ) ) ) ).

% cong_exp_iff_simps(12)
thf(fact_2530_cong__exp__iff__simps_I13_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [M: num,Q3: num,N: num] :
          ( ( ( modulo_modulo @ A @ ( numeral_numeral @ A @ ( bit1 @ M ) ) @ ( numeral_numeral @ A @ ( bit0 @ Q3 ) ) )
            = ( modulo_modulo @ A @ ( numeral_numeral @ A @ ( bit1 @ N ) ) @ ( numeral_numeral @ A @ ( bit0 @ Q3 ) ) ) )
          = ( ( modulo_modulo @ A @ ( numeral_numeral @ A @ M ) @ ( numeral_numeral @ A @ Q3 ) )
            = ( modulo_modulo @ A @ ( numeral_numeral @ A @ N ) @ ( numeral_numeral @ A @ Q3 ) ) ) ) ) ).

% cong_exp_iff_simps(13)
thf(fact_2531_power__minus__Bit1,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [X: A,K: num] :
          ( ( power_power @ A @ ( uminus_uminus @ A @ X ) @ ( numeral_numeral @ nat @ ( bit1 @ K ) ) )
          = ( uminus_uminus @ A @ ( power_power @ A @ X @ ( numeral_numeral @ nat @ ( bit1 @ K ) ) ) ) ) ) ).

% power_minus_Bit1
thf(fact_2532_and__nat__def,axiom,
    ( ( bit_se5824344872417868541ns_and @ nat )
    = ( ^ [M3: nat,N3: nat] : ( nat2 @ ( bit_se5824344872417868541ns_and @ int @ ( semiring_1_of_nat @ int @ M3 ) @ ( semiring_1_of_nat @ int @ N3 ) ) ) ) ) ).

% and_nat_def
thf(fact_2533_numeral__Bit1__div__2,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [N: num] :
          ( ( divide_divide @ A @ ( numeral_numeral @ A @ ( bit1 @ N ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
          = ( numeral_numeral @ A @ N ) ) ) ).

% numeral_Bit1_div_2
thf(fact_2534_odd__numeral,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [N: num] :
          ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( numeral_numeral @ A @ ( bit1 @ N ) ) ) ) ).

% odd_numeral
thf(fact_2535_cong__exp__iff__simps_I3_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [N: num,Q3: num] :
          ( ( modulo_modulo @ A @ ( numeral_numeral @ A @ ( bit1 @ N ) ) @ ( numeral_numeral @ A @ ( bit0 @ Q3 ) ) )
         != ( zero_zero @ A ) ) ) ).

% cong_exp_iff_simps(3)
thf(fact_2536_power3__eq__cube,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [A2: A] :
          ( ( power_power @ A @ A2 @ ( numeral_numeral @ nat @ ( bit1 @ one2 ) ) )
          = ( times_times @ A @ ( times_times @ A @ A2 @ A2 ) @ A2 ) ) ) ).

% power3_eq_cube
thf(fact_2537_not__numeral__Bit0__eq,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N: num] :
          ( ( bit_ri4277139882892585799ns_not @ A @ ( numeral_numeral @ A @ ( bit0 @ N ) ) )
          = ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( bit1 @ N ) ) ) ) ) ).

% not_numeral_Bit0_eq
thf(fact_2538_fold__atLeastAtMost__nat_Osimps,axiom,
    ! [A: $tType] :
      ( ( set_fo6178422350223883121st_nat @ A )
      = ( ^ [F3: nat > A > A,A3: nat,B3: nat,Acc: A] : ( if @ A @ ( ord_less @ nat @ B3 @ A3 ) @ Acc @ ( set_fo6178422350223883121st_nat @ A @ F3 @ ( plus_plus @ nat @ A3 @ ( one_one @ nat ) ) @ B3 @ ( F3 @ A3 @ Acc ) ) ) ) ) ).

% fold_atLeastAtMost_nat.simps
thf(fact_2539_fold__atLeastAtMost__nat_Oelims,axiom,
    ! [A: $tType,X: nat > A > A,Xa: nat,Xb: nat,Xc: A,Y: A] :
      ( ( ( set_fo6178422350223883121st_nat @ A @ X @ Xa @ Xb @ Xc )
        = Y )
     => ( ( ( ord_less @ nat @ Xb @ Xa )
         => ( Y = Xc ) )
        & ( ~ ( ord_less @ nat @ Xb @ Xa )
         => ( Y
            = ( set_fo6178422350223883121st_nat @ A @ X @ ( plus_plus @ nat @ Xa @ ( one_one @ nat ) ) @ Xb @ ( X @ Xa @ Xc ) ) ) ) ) ) ).

% fold_atLeastAtMost_nat.elims
thf(fact_2540_cong__exp__iff__simps_I7_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [Q3: num,N: num] :
          ( ( ( modulo_modulo @ A @ ( numeral_numeral @ A @ one2 ) @ ( numeral_numeral @ A @ ( bit0 @ Q3 ) ) )
            = ( modulo_modulo @ A @ ( numeral_numeral @ A @ ( bit1 @ N ) ) @ ( numeral_numeral @ A @ ( bit0 @ Q3 ) ) ) )
          = ( ( modulo_modulo @ A @ ( numeral_numeral @ A @ N ) @ ( numeral_numeral @ A @ Q3 ) )
            = ( zero_zero @ A ) ) ) ) ).

% cong_exp_iff_simps(7)
thf(fact_2541_cong__exp__iff__simps_I11_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [M: num,Q3: num] :
          ( ( ( modulo_modulo @ A @ ( numeral_numeral @ A @ ( bit1 @ M ) ) @ ( numeral_numeral @ A @ ( bit0 @ Q3 ) ) )
            = ( modulo_modulo @ A @ ( numeral_numeral @ A @ one2 ) @ ( numeral_numeral @ A @ ( bit0 @ Q3 ) ) ) )
          = ( ( modulo_modulo @ A @ ( numeral_numeral @ A @ M ) @ ( numeral_numeral @ A @ Q3 ) )
            = ( zero_zero @ A ) ) ) ) ).

% cong_exp_iff_simps(11)
thf(fact_2542_exp__le,axiom,
    ord_less_eq @ real @ ( exp @ real @ ( one_one @ real ) ) @ ( numeral_numeral @ real @ ( bit1 @ one2 ) ) ).

% exp_le
thf(fact_2543_and__not__numerals_I7_J,axiom,
    ! [M: num] :
      ( ( bit_se5824344872417868541ns_and @ int @ ( numeral_numeral @ int @ ( bit1 @ M ) ) @ ( bit_ri4277139882892585799ns_not @ int @ ( one_one @ int ) ) )
      = ( numeral_numeral @ int @ ( bit0 @ M ) ) ) ).

% and_not_numerals(7)
thf(fact_2544_or__not__numerals_I3_J,axiom,
    ! [N: num] :
      ( ( bit_se1065995026697491101ons_or @ int @ ( one_one @ int ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ ( bit1 @ N ) ) ) )
      = ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ ( bit0 @ N ) ) ) ) ).

% or_not_numerals(3)
thf(fact_2545_and__not__numerals_I3_J,axiom,
    ! [N: num] :
      ( ( bit_se5824344872417868541ns_and @ int @ ( one_one @ int ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ ( bit1 @ N ) ) ) )
      = ( zero_zero @ int ) ) ).

% and_not_numerals(3)
thf(fact_2546_or__not__numerals_I7_J,axiom,
    ! [M: num] :
      ( ( bit_se1065995026697491101ons_or @ int @ ( numeral_numeral @ int @ ( bit1 @ M ) ) @ ( bit_ri4277139882892585799ns_not @ int @ ( one_one @ int ) ) )
      = ( bit_ri4277139882892585799ns_not @ int @ ( zero_zero @ int ) ) ) ).

% or_not_numerals(7)
thf(fact_2547_mod__exhaust__less__4,axiom,
    ! [M: nat] :
      ( ( ( modulo_modulo @ nat @ M @ ( numeral_numeral @ nat @ ( bit0 @ ( bit0 @ one2 ) ) ) )
        = ( zero_zero @ nat ) )
      | ( ( modulo_modulo @ nat @ M @ ( numeral_numeral @ nat @ ( bit0 @ ( bit0 @ one2 ) ) ) )
        = ( one_one @ nat ) )
      | ( ( modulo_modulo @ nat @ M @ ( numeral_numeral @ nat @ ( bit0 @ ( bit0 @ one2 ) ) ) )
        = ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
      | ( ( modulo_modulo @ nat @ M @ ( numeral_numeral @ nat @ ( bit0 @ ( bit0 @ one2 ) ) ) )
        = ( numeral_numeral @ nat @ ( bit1 @ one2 ) ) ) ) ).

% mod_exhaust_less_4
thf(fact_2548_and__not__numerals_I6_J,axiom,
    ! [M: num,N: num] :
      ( ( bit_se5824344872417868541ns_and @ int @ ( numeral_numeral @ int @ ( bit0 @ M ) ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ ( bit1 @ N ) ) ) )
      = ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se5824344872417868541ns_and @ int @ ( numeral_numeral @ int @ M ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ N ) ) ) ) ) ).

% and_not_numerals(6)
thf(fact_2549_and__not__numerals_I9_J,axiom,
    ! [M: num,N: num] :
      ( ( bit_se5824344872417868541ns_and @ int @ ( numeral_numeral @ int @ ( bit1 @ M ) ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ ( bit1 @ N ) ) ) )
      = ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se5824344872417868541ns_and @ int @ ( numeral_numeral @ int @ M ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ N ) ) ) ) ) ).

% and_not_numerals(9)
thf(fact_2550_or__not__numerals_I6_J,axiom,
    ! [M: num,N: num] :
      ( ( bit_se1065995026697491101ons_or @ int @ ( numeral_numeral @ int @ ( bit0 @ M ) ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ ( bit1 @ N ) ) ) )
      = ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se1065995026697491101ons_or @ int @ ( numeral_numeral @ int @ M ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ N ) ) ) ) ) ).

% or_not_numerals(6)
thf(fact_2551_and__nat__unfold,axiom,
    ( ( bit_se5824344872417868541ns_and @ nat )
    = ( ^ [M3: nat,N3: nat] :
          ( if @ nat
          @ ( ( M3
              = ( zero_zero @ nat ) )
            | ( N3
              = ( zero_zero @ nat ) ) )
          @ ( zero_zero @ nat )
          @ ( plus_plus @ nat @ ( times_times @ nat @ ( modulo_modulo @ nat @ M3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( modulo_modulo @ nat @ N3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( bit_se5824344872417868541ns_and @ nat @ ( divide_divide @ nat @ M3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ nat @ N3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ).

% and_nat_unfold
thf(fact_2552_and__not__numerals_I8_J,axiom,
    ! [M: num,N: num] :
      ( ( bit_se5824344872417868541ns_and @ int @ ( numeral_numeral @ int @ ( bit1 @ M ) ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ ( bit0 @ N ) ) ) )
      = ( plus_plus @ int @ ( one_one @ int ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se5824344872417868541ns_and @ int @ ( numeral_numeral @ int @ M ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ N ) ) ) ) ) ) ).

% and_not_numerals(8)
thf(fact_2553_or__not__numerals_I9_J,axiom,
    ! [M: num,N: num] :
      ( ( bit_se1065995026697491101ons_or @ int @ ( numeral_numeral @ int @ ( bit1 @ M ) ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ ( bit1 @ N ) ) ) )
      = ( plus_plus @ int @ ( one_one @ int ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se1065995026697491101ons_or @ int @ ( numeral_numeral @ int @ M ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ N ) ) ) ) ) ) ).

% or_not_numerals(9)
thf(fact_2554_or__not__numerals_I8_J,axiom,
    ! [M: num,N: num] :
      ( ( bit_se1065995026697491101ons_or @ int @ ( numeral_numeral @ int @ ( bit1 @ M ) ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ ( bit0 @ N ) ) ) )
      = ( plus_plus @ int @ ( one_one @ int ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se1065995026697491101ons_or @ int @ ( numeral_numeral @ int @ M ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ N ) ) ) ) ) ) ).

% or_not_numerals(8)
thf(fact_2555_signed__take__bit__numeral__minus__bit1,axiom,
    ! [L: num,K: num] :
      ( ( bit_ri4674362597316999326ke_bit @ int @ ( numeral_numeral @ nat @ L ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit1 @ K ) ) ) )
      = ( plus_plus @ int @ ( times_times @ int @ ( bit_ri4674362597316999326ke_bit @ int @ ( pred_numeral @ L ) @ ( minus_minus @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ K ) ) @ ( one_one @ int ) ) ) @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( one_one @ int ) ) ) ).

% signed_take_bit_numeral_minus_bit1
thf(fact_2556_dbl__dec__simps_I4_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( neg_numeral_dbl_dec @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
        = ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( bit1 @ one2 ) ) ) ) ) ).

% dbl_dec_simps(4)
thf(fact_2557_signed__take__bit__Suc__minus__bit1,axiom,
    ! [N: nat,K: num] :
      ( ( bit_ri4674362597316999326ke_bit @ int @ ( suc @ N ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit1 @ K ) ) ) )
      = ( plus_plus @ int @ ( times_times @ int @ ( bit_ri4674362597316999326ke_bit @ int @ N @ ( minus_minus @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ K ) ) @ ( one_one @ int ) ) ) @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( one_one @ int ) ) ) ).

% signed_take_bit_Suc_minus_bit1
thf(fact_2558_signed__take__bit__numeral__bit1,axiom,
    ! [L: num,K: num] :
      ( ( bit_ri4674362597316999326ke_bit @ int @ ( numeral_numeral @ nat @ L ) @ ( numeral_numeral @ int @ ( bit1 @ K ) ) )
      = ( plus_plus @ int @ ( times_times @ int @ ( bit_ri4674362597316999326ke_bit @ int @ ( pred_numeral @ L ) @ ( numeral_numeral @ int @ K ) ) @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( one_one @ int ) ) ) ).

% signed_take_bit_numeral_bit1
thf(fact_2559_dbl__inc__simps_I3_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( neg_numeral_dbl_inc @ A @ ( one_one @ A ) )
        = ( numeral_numeral @ A @ ( bit1 @ one2 ) ) ) ) ).

% dbl_inc_simps(3)
thf(fact_2560_signed__take__bit__Suc__bit1,axiom,
    ! [N: nat,K: num] :
      ( ( bit_ri4674362597316999326ke_bit @ int @ ( suc @ N ) @ ( numeral_numeral @ int @ ( bit1 @ K ) ) )
      = ( plus_plus @ int @ ( times_times @ int @ ( bit_ri4674362597316999326ke_bit @ int @ N @ ( numeral_numeral @ int @ K ) ) @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( one_one @ int ) ) ) ).

% signed_take_bit_Suc_bit1
thf(fact_2561_even__odd__cases,axiom,
    ! [X: nat] :
      ( ! [N2: nat] :
          ( X
         != ( plus_plus @ nat @ N2 @ N2 ) )
     => ~ ! [N2: nat] :
            ( X
           != ( plus_plus @ nat @ N2 @ ( suc @ N2 ) ) ) ) ).

% even_odd_cases
thf(fact_2562_nat_Oinject,axiom,
    ! [X22: nat,Y2: nat] :
      ( ( ( suc @ X22 )
        = ( suc @ Y2 ) )
      = ( X22 = Y2 ) ) ).

% nat.inject
thf(fact_2563_old_Onat_Oinject,axiom,
    ! [Nat: nat,Nat2: nat] :
      ( ( ( suc @ Nat )
        = ( suc @ Nat2 ) )
      = ( Nat = Nat2 ) ) ).

% old.nat.inject
thf(fact_2564_lessI,axiom,
    ! [N: nat] : ( ord_less @ nat @ N @ ( suc @ N ) ) ).

% lessI
thf(fact_2565_Suc__mono,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ M @ N )
     => ( ord_less @ nat @ ( suc @ M ) @ ( suc @ N ) ) ) ).

% Suc_mono
thf(fact_2566_Suc__less__eq,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ ( suc @ M ) @ ( suc @ N ) )
      = ( ord_less @ nat @ M @ N ) ) ).

% Suc_less_eq
thf(fact_2567_Suc__le__mono,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less_eq @ nat @ ( suc @ N ) @ ( suc @ M ) )
      = ( ord_less_eq @ nat @ N @ M ) ) ).

% Suc_le_mono
thf(fact_2568_add__Suc__right,axiom,
    ! [M: nat,N: nat] :
      ( ( plus_plus @ nat @ M @ ( suc @ N ) )
      = ( suc @ ( plus_plus @ nat @ M @ N ) ) ) ).

% add_Suc_right
thf(fact_2569_Suc__diff__diff,axiom,
    ! [M: nat,N: nat,K: nat] :
      ( ( minus_minus @ nat @ ( minus_minus @ nat @ ( suc @ M ) @ N ) @ ( suc @ K ) )
      = ( minus_minus @ nat @ ( minus_minus @ nat @ M @ N ) @ K ) ) ).

% Suc_diff_diff
thf(fact_2570_diff__Suc__Suc,axiom,
    ! [M: nat,N: nat] :
      ( ( minus_minus @ nat @ ( suc @ M ) @ ( suc @ N ) )
      = ( minus_minus @ nat @ M @ N ) ) ).

% diff_Suc_Suc
thf(fact_2571_max__Suc__Suc,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_max @ nat @ ( suc @ M ) @ ( suc @ N ) )
      = ( suc @ ( ord_max @ nat @ M @ N ) ) ) ).

% max_Suc_Suc
thf(fact_2572_dbl__dec__simps_I3_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( neg_numeral_dbl_dec @ A @ ( one_one @ A ) )
        = ( one_one @ A ) ) ) ).

% dbl_dec_simps(3)
thf(fact_2573_power__0__Suc,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [N: nat] :
          ( ( power_power @ A @ ( zero_zero @ A ) @ ( suc @ N ) )
          = ( zero_zero @ A ) ) ) ).

% power_0_Suc
thf(fact_2574_power__Suc0__right,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [A2: A] :
          ( ( power_power @ A @ A2 @ ( suc @ ( zero_zero @ nat ) ) )
          = A2 ) ) ).

% power_Suc0_right
thf(fact_2575_zero__less__Suc,axiom,
    ! [N: nat] : ( ord_less @ nat @ ( zero_zero @ nat ) @ ( suc @ N ) ) ).

% zero_less_Suc
thf(fact_2576_less__Suc0,axiom,
    ! [N: nat] :
      ( ( ord_less @ nat @ N @ ( suc @ ( zero_zero @ nat ) ) )
      = ( N
        = ( zero_zero @ nat ) ) ) ).

% less_Suc0
thf(fact_2577_mult__eq__1__iff,axiom,
    ! [M: nat,N: nat] :
      ( ( ( times_times @ nat @ M @ N )
        = ( suc @ ( zero_zero @ nat ) ) )
      = ( ( M
          = ( suc @ ( zero_zero @ nat ) ) )
        & ( N
          = ( suc @ ( zero_zero @ nat ) ) ) ) ) ).

% mult_eq_1_iff
thf(fact_2578_one__eq__mult__iff,axiom,
    ! [M: nat,N: nat] :
      ( ( ( suc @ ( zero_zero @ nat ) )
        = ( times_times @ nat @ M @ N ) )
      = ( ( M
          = ( suc @ ( zero_zero @ nat ) ) )
        & ( N
          = ( suc @ ( zero_zero @ nat ) ) ) ) ) ).

% one_eq_mult_iff
thf(fact_2579_div__by__Suc__0,axiom,
    ! [M: nat] :
      ( ( divide_divide @ nat @ M @ ( suc @ ( zero_zero @ nat ) ) )
      = M ) ).

% div_by_Suc_0
thf(fact_2580_dvd__1__iff__1,axiom,
    ! [M: nat] :
      ( ( dvd_dvd @ nat @ M @ ( suc @ ( zero_zero @ nat ) ) )
      = ( M
        = ( suc @ ( zero_zero @ nat ) ) ) ) ).

% dvd_1_iff_1
thf(fact_2581_dvd__1__left,axiom,
    ! [K: nat] : ( dvd_dvd @ nat @ ( suc @ ( zero_zero @ nat ) ) @ K ) ).

% dvd_1_left
thf(fact_2582_take__bit__Suc__1,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [N: nat] :
          ( ( bit_se2584673776208193580ke_bit @ A @ ( suc @ N ) @ ( one_one @ A ) )
          = ( one_one @ A ) ) ) ).

% take_bit_Suc_1
thf(fact_2583_mult__Suc__right,axiom,
    ! [M: nat,N: nat] :
      ( ( times_times @ nat @ M @ ( suc @ N ) )
      = ( plus_plus @ nat @ M @ ( times_times @ nat @ M @ N ) ) ) ).

% mult_Suc_right
thf(fact_2584_nat__power__eq__Suc__0__iff,axiom,
    ! [X: nat,M: nat] :
      ( ( ( power_power @ nat @ X @ M )
        = ( suc @ ( zero_zero @ nat ) ) )
      = ( ( M
          = ( zero_zero @ nat ) )
        | ( X
          = ( suc @ ( zero_zero @ nat ) ) ) ) ) ).

% nat_power_eq_Suc_0_iff
thf(fact_2585_power__Suc__0,axiom,
    ! [N: nat] :
      ( ( power_power @ nat @ ( suc @ ( zero_zero @ nat ) ) @ N )
      = ( suc @ ( zero_zero @ nat ) ) ) ).

% power_Suc_0
thf(fact_2586_diff__Suc__1,axiom,
    ! [N: nat] :
      ( ( minus_minus @ nat @ ( suc @ N ) @ ( one_one @ nat ) )
      = N ) ).

% diff_Suc_1
thf(fact_2587_mod__by__Suc__0,axiom,
    ! [M: nat] :
      ( ( modulo_modulo @ nat @ M @ ( suc @ ( zero_zero @ nat ) ) )
      = ( zero_zero @ nat ) ) ).

% mod_by_Suc_0
thf(fact_2588_binomial__0__Suc,axiom,
    ! [K: nat] :
      ( ( binomial @ ( zero_zero @ nat ) @ ( suc @ K ) )
      = ( zero_zero @ nat ) ) ).

% binomial_0_Suc
thf(fact_2589_binomial__1,axiom,
    ! [N: nat] :
      ( ( binomial @ N @ ( suc @ ( zero_zero @ nat ) ) )
      = N ) ).

% binomial_1
thf(fact_2590_signed__take__bit__Suc__1,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N: nat] :
          ( ( bit_ri4674362597316999326ke_bit @ A @ ( suc @ N ) @ ( one_one @ A ) )
          = ( one_one @ A ) ) ) ).

% signed_take_bit_Suc_1
thf(fact_2591_pochhammer__Suc0,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [A2: A] :
          ( ( comm_s3205402744901411588hammer @ A @ A2 @ ( suc @ ( zero_zero @ nat ) ) )
          = A2 ) ) ).

% pochhammer_Suc0
thf(fact_2592_pred__numeral__simps_I1_J,axiom,
    ( ( pred_numeral @ one2 )
    = ( zero_zero @ nat ) ) ).

% pred_numeral_simps(1)
thf(fact_2593_Suc__eq__numeral,axiom,
    ! [N: nat,K: num] :
      ( ( ( suc @ N )
        = ( numeral_numeral @ nat @ K ) )
      = ( N
        = ( pred_numeral @ K ) ) ) ).

% Suc_eq_numeral
thf(fact_2594_eq__numeral__Suc,axiom,
    ! [K: num,N: nat] :
      ( ( ( numeral_numeral @ nat @ K )
        = ( suc @ N ) )
      = ( ( pred_numeral @ K )
        = N ) ) ).

% eq_numeral_Suc
thf(fact_2595_dbl__inc__simps_I2_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( neg_numeral_dbl_inc @ A @ ( zero_zero @ A ) )
        = ( one_one @ A ) ) ) ).

% dbl_inc_simps(2)
thf(fact_2596_dbl__inc__simps_I4_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( neg_numeral_dbl_inc @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
        = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% dbl_inc_simps(4)
thf(fact_2597_dbl__inc__simps_I5_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [K: num] :
          ( ( neg_numeral_dbl_inc @ A @ ( numeral_numeral @ A @ K ) )
          = ( numeral_numeral @ A @ ( bit1 @ K ) ) ) ) ).

% dbl_inc_simps(5)
thf(fact_2598_of__nat__Suc,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [M: nat] :
          ( ( semiring_1_of_nat @ A @ ( suc @ M ) )
          = ( plus_plus @ A @ ( one_one @ A ) @ ( semiring_1_of_nat @ A @ M ) ) ) ) ).

% of_nat_Suc
thf(fact_2599_Suc__pred,axiom,
    ! [N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( suc @ ( minus_minus @ nat @ N @ ( suc @ ( zero_zero @ nat ) ) ) )
        = N ) ) ).

% Suc_pred
thf(fact_2600_one__le__mult__iff,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ ( suc @ ( zero_zero @ nat ) ) @ ( times_times @ nat @ M @ N ) )
      = ( ( ord_less_eq @ nat @ ( suc @ ( zero_zero @ nat ) ) @ M )
        & ( ord_less_eq @ nat @ ( suc @ ( zero_zero @ nat ) ) @ N ) ) ) ).

% one_le_mult_iff
thf(fact_2601_fact__Suc__0,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ( ( semiring_char_0_fact @ A @ ( suc @ ( zero_zero @ nat ) ) )
        = ( one_one @ A ) ) ) ).

% fact_Suc_0
thf(fact_2602_diff__Suc__diff__eq2,axiom,
    ! [K: nat,J: nat,I: nat] :
      ( ( ord_less_eq @ nat @ K @ J )
     => ( ( minus_minus @ nat @ ( suc @ ( minus_minus @ nat @ J @ K ) ) @ I )
        = ( minus_minus @ nat @ ( suc @ J ) @ ( plus_plus @ nat @ K @ I ) ) ) ) ).

% diff_Suc_diff_eq2
thf(fact_2603_diff__Suc__diff__eq1,axiom,
    ! [K: nat,J: nat,I: nat] :
      ( ( ord_less_eq @ nat @ K @ J )
     => ( ( minus_minus @ nat @ I @ ( suc @ ( minus_minus @ nat @ J @ K ) ) )
        = ( minus_minus @ nat @ ( plus_plus @ nat @ I @ K ) @ ( suc @ J ) ) ) ) ).

% diff_Suc_diff_eq1
thf(fact_2604_fact__Suc,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [N: nat] :
          ( ( semiring_char_0_fact @ A @ ( suc @ N ) )
          = ( times_times @ A @ ( semiring_1_of_nat @ A @ ( suc @ N ) ) @ ( semiring_char_0_fact @ A @ N ) ) ) ) ).

% fact_Suc
thf(fact_2605_nat__1,axiom,
    ( ( nat2 @ ( one_one @ int ) )
    = ( suc @ ( zero_zero @ nat ) ) ) ).

% nat_1
thf(fact_2606_Suc__numeral,axiom,
    ! [N: num] :
      ( ( suc @ ( numeral_numeral @ nat @ N ) )
      = ( numeral_numeral @ nat @ ( plus_plus @ num @ N @ one2 ) ) ) ).

% Suc_numeral
thf(fact_2607_negative__zless,axiom,
    ! [N: nat,M: nat] : ( ord_less @ int @ ( uminus_uminus @ int @ ( semiring_1_of_nat @ int @ ( suc @ N ) ) ) @ ( semiring_1_of_nat @ int @ M ) ) ).

% negative_zless
thf(fact_2608_less__Suc__numeral,axiom,
    ! [N: nat,K: num] :
      ( ( ord_less @ nat @ ( suc @ N ) @ ( numeral_numeral @ nat @ K ) )
      = ( ord_less @ nat @ N @ ( pred_numeral @ K ) ) ) ).

% less_Suc_numeral
thf(fact_2609_less__numeral__Suc,axiom,
    ! [K: num,N: nat] :
      ( ( ord_less @ nat @ ( numeral_numeral @ nat @ K ) @ ( suc @ N ) )
      = ( ord_less @ nat @ ( pred_numeral @ K ) @ N ) ) ).

% less_numeral_Suc
thf(fact_2610_pred__numeral__simps_I3_J,axiom,
    ! [K: num] :
      ( ( pred_numeral @ ( bit1 @ K ) )
      = ( numeral_numeral @ nat @ ( bit0 @ K ) ) ) ).

% pred_numeral_simps(3)
thf(fact_2611_le__Suc__numeral,axiom,
    ! [N: nat,K: num] :
      ( ( ord_less_eq @ nat @ ( suc @ N ) @ ( numeral_numeral @ nat @ K ) )
      = ( ord_less_eq @ nat @ N @ ( pred_numeral @ K ) ) ) ).

% le_Suc_numeral
thf(fact_2612_le__numeral__Suc,axiom,
    ! [K: num,N: nat] :
      ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ K ) @ ( suc @ N ) )
      = ( ord_less_eq @ nat @ ( pred_numeral @ K ) @ N ) ) ).

% le_numeral_Suc
thf(fact_2613_diff__numeral__Suc,axiom,
    ! [K: num,N: nat] :
      ( ( minus_minus @ nat @ ( numeral_numeral @ nat @ K ) @ ( suc @ N ) )
      = ( minus_minus @ nat @ ( pred_numeral @ K ) @ N ) ) ).

% diff_numeral_Suc
thf(fact_2614_diff__Suc__numeral,axiom,
    ! [N: nat,K: num] :
      ( ( minus_minus @ nat @ ( suc @ N ) @ ( numeral_numeral @ nat @ K ) )
      = ( minus_minus @ nat @ N @ ( pred_numeral @ K ) ) ) ).

% diff_Suc_numeral
thf(fact_2615_max__Suc__numeral,axiom,
    ! [N: nat,K: num] :
      ( ( ord_max @ nat @ ( suc @ N ) @ ( numeral_numeral @ nat @ K ) )
      = ( suc @ ( ord_max @ nat @ N @ ( pred_numeral @ K ) ) ) ) ).

% max_Suc_numeral
thf(fact_2616_max__numeral__Suc,axiom,
    ! [K: num,N: nat] :
      ( ( ord_max @ nat @ ( numeral_numeral @ nat @ K ) @ ( suc @ N ) )
      = ( suc @ ( ord_max @ nat @ ( pred_numeral @ K ) @ N ) ) ) ).

% max_numeral_Suc
thf(fact_2617_dbl__dec__simps_I2_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( neg_numeral_dbl_dec @ A @ ( zero_zero @ A ) )
        = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% dbl_dec_simps(2)
thf(fact_2618_dbl__dec__simps_I1_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [K: num] :
          ( ( neg_numeral_dbl_dec @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ K ) ) )
          = ( uminus_uminus @ A @ ( neg_numeral_dbl_inc @ A @ ( numeral_numeral @ A @ K ) ) ) ) ) ).

% dbl_dec_simps(1)
thf(fact_2619_dbl__inc__simps_I1_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [K: num] :
          ( ( neg_numeral_dbl_inc @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ K ) ) )
          = ( uminus_uminus @ A @ ( neg_numeral_dbl_dec @ A @ ( numeral_numeral @ A @ K ) ) ) ) ) ).

% dbl_inc_simps(1)
thf(fact_2620_add__2__eq__Suc,axiom,
    ! [N: nat] :
      ( ( plus_plus @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
      = ( suc @ ( suc @ N ) ) ) ).

% add_2_eq_Suc
thf(fact_2621_add__2__eq__Suc_H,axiom,
    ! [N: nat] :
      ( ( plus_plus @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
      = ( suc @ ( suc @ N ) ) ) ).

% add_2_eq_Suc'
thf(fact_2622_Suc__1,axiom,
    ( ( suc @ ( one_one @ nat ) )
    = ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ).

% Suc_1
thf(fact_2623_div2__Suc__Suc,axiom,
    ! [M: nat] :
      ( ( divide_divide @ nat @ ( suc @ ( suc @ M ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
      = ( suc @ ( divide_divide @ nat @ M @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ).

% div2_Suc_Suc
thf(fact_2624_even__Suc,axiom,
    ! [N: nat] :
      ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( suc @ N ) )
      = ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ) ).

% even_Suc
thf(fact_2625_even__Suc__Suc__iff,axiom,
    ! [N: nat] :
      ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( suc @ ( suc @ N ) ) )
      = ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ).

% even_Suc_Suc_iff
thf(fact_2626_mod2__Suc__Suc,axiom,
    ! [M: nat] :
      ( ( modulo_modulo @ nat @ ( suc @ ( suc @ M ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
      = ( modulo_modulo @ nat @ M @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ).

% mod2_Suc_Suc
thf(fact_2627_Suc__diff__1,axiom,
    ! [N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( suc @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) )
        = N ) ) ).

% Suc_diff_1
thf(fact_2628_Suc__times__numeral__mod__eq,axiom,
    ! [K: num,N: nat] :
      ( ( ( numeral_numeral @ nat @ K )
       != ( one_one @ nat ) )
     => ( ( modulo_modulo @ nat @ ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ K ) @ N ) ) @ ( numeral_numeral @ nat @ K ) )
        = ( one_one @ nat ) ) ) ).

% Suc_times_numeral_mod_eq
thf(fact_2629_and__nat__numerals_I3_J,axiom,
    ! [X: num] :
      ( ( bit_se5824344872417868541ns_and @ nat @ ( numeral_numeral @ nat @ ( bit0 @ X ) ) @ ( suc @ ( zero_zero @ nat ) ) )
      = ( zero_zero @ nat ) ) ).

% and_nat_numerals(3)
thf(fact_2630_and__nat__numerals_I1_J,axiom,
    ! [Y: num] :
      ( ( bit_se5824344872417868541ns_and @ nat @ ( suc @ ( zero_zero @ nat ) ) @ ( numeral_numeral @ nat @ ( bit0 @ Y ) ) )
      = ( zero_zero @ nat ) ) ).

% and_nat_numerals(1)
thf(fact_2631_or__nat__numerals_I2_J,axiom,
    ! [Y: num] :
      ( ( bit_se1065995026697491101ons_or @ nat @ ( suc @ ( zero_zero @ nat ) ) @ ( numeral_numeral @ nat @ ( bit1 @ Y ) ) )
      = ( numeral_numeral @ nat @ ( bit1 @ Y ) ) ) ).

% or_nat_numerals(2)
thf(fact_2632_or__nat__numerals_I4_J,axiom,
    ! [X: num] :
      ( ( bit_se1065995026697491101ons_or @ nat @ ( numeral_numeral @ nat @ ( bit1 @ X ) ) @ ( suc @ ( zero_zero @ nat ) ) )
      = ( numeral_numeral @ nat @ ( bit1 @ X ) ) ) ).

% or_nat_numerals(4)
thf(fact_2633_not__mod2__eq__Suc__0__eq__0,axiom,
    ! [N: nat] :
      ( ( ( ( modulo_modulo @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
         != ( suc @ ( zero_zero @ nat ) ) ) )
      = ( ( modulo_modulo @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
        = ( zero_zero @ nat ) ) ) ).

% not_mod2_eq_Suc_0_eq_0
thf(fact_2634_odd__Suc__div__two,axiom,
    ! [N: nat] :
      ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
     => ( ( divide_divide @ nat @ ( suc @ N ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
        = ( suc @ ( divide_divide @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% odd_Suc_div_two
thf(fact_2635_even__Suc__div__two,axiom,
    ! [N: nat] :
      ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
     => ( ( divide_divide @ nat @ ( suc @ N ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
        = ( divide_divide @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ).

% even_Suc_div_two
thf(fact_2636_Suc__div__eq__add3__div__numeral,axiom,
    ! [M: nat,V: num] :
      ( ( divide_divide @ nat @ ( suc @ ( suc @ ( suc @ M ) ) ) @ ( numeral_numeral @ nat @ V ) )
      = ( divide_divide @ nat @ ( plus_plus @ nat @ ( numeral_numeral @ nat @ ( bit1 @ one2 ) ) @ M ) @ ( numeral_numeral @ nat @ V ) ) ) ).

% Suc_div_eq_add3_div_numeral
thf(fact_2637_div__Suc__eq__div__add3,axiom,
    ! [M: nat,N: nat] :
      ( ( divide_divide @ nat @ M @ ( suc @ ( suc @ ( suc @ N ) ) ) )
      = ( divide_divide @ nat @ M @ ( plus_plus @ nat @ ( numeral_numeral @ nat @ ( bit1 @ one2 ) ) @ N ) ) ) ).

% div_Suc_eq_div_add3
thf(fact_2638_Suc__mod__eq__add3__mod__numeral,axiom,
    ! [M: nat,V: num] :
      ( ( modulo_modulo @ nat @ ( suc @ ( suc @ ( suc @ M ) ) ) @ ( numeral_numeral @ nat @ V ) )
      = ( modulo_modulo @ nat @ ( plus_plus @ nat @ ( numeral_numeral @ nat @ ( bit1 @ one2 ) ) @ M ) @ ( numeral_numeral @ nat @ V ) ) ) ).

% Suc_mod_eq_add3_mod_numeral
thf(fact_2639_mod__Suc__eq__mod__add3,axiom,
    ! [M: nat,N: nat] :
      ( ( modulo_modulo @ nat @ M @ ( suc @ ( suc @ ( suc @ N ) ) ) )
      = ( modulo_modulo @ nat @ M @ ( plus_plus @ nat @ ( numeral_numeral @ nat @ ( bit1 @ one2 ) ) @ N ) ) ) ).

% mod_Suc_eq_mod_add3
thf(fact_2640_one__less__nat__eq,axiom,
    ! [Z: int] :
      ( ( ord_less @ nat @ ( suc @ ( zero_zero @ nat ) ) @ ( nat2 @ Z ) )
      = ( ord_less @ int @ ( one_one @ int ) @ Z ) ) ).

% one_less_nat_eq
thf(fact_2641_signed__take__bit__Suc__bit0,axiom,
    ! [N: nat,K: num] :
      ( ( bit_ri4674362597316999326ke_bit @ int @ ( suc @ N ) @ ( numeral_numeral @ int @ ( bit0 @ K ) ) )
      = ( times_times @ int @ ( bit_ri4674362597316999326ke_bit @ int @ N @ ( numeral_numeral @ int @ K ) ) @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ).

% signed_take_bit_Suc_bit0
thf(fact_2642_or__nat__numerals_I1_J,axiom,
    ! [Y: num] :
      ( ( bit_se1065995026697491101ons_or @ nat @ ( suc @ ( zero_zero @ nat ) ) @ ( numeral_numeral @ nat @ ( bit0 @ Y ) ) )
      = ( numeral_numeral @ nat @ ( bit1 @ Y ) ) ) ).

% or_nat_numerals(1)
thf(fact_2643_or__nat__numerals_I3_J,axiom,
    ! [X: num] :
      ( ( bit_se1065995026697491101ons_or @ nat @ ( numeral_numeral @ nat @ ( bit0 @ X ) ) @ ( suc @ ( zero_zero @ nat ) ) )
      = ( numeral_numeral @ nat @ ( bit1 @ X ) ) ) ).

% or_nat_numerals(3)
thf(fact_2644_xor__nat__numerals_I4_J,axiom,
    ! [X: num] :
      ( ( bit_se5824344971392196577ns_xor @ nat @ ( numeral_numeral @ nat @ ( bit1 @ X ) ) @ ( suc @ ( zero_zero @ nat ) ) )
      = ( numeral_numeral @ nat @ ( bit0 @ X ) ) ) ).

% xor_nat_numerals(4)
thf(fact_2645_xor__nat__numerals_I3_J,axiom,
    ! [X: num] :
      ( ( bit_se5824344971392196577ns_xor @ nat @ ( numeral_numeral @ nat @ ( bit0 @ X ) ) @ ( suc @ ( zero_zero @ nat ) ) )
      = ( numeral_numeral @ nat @ ( bit1 @ X ) ) ) ).

% xor_nat_numerals(3)
thf(fact_2646_xor__nat__numerals_I2_J,axiom,
    ! [Y: num] :
      ( ( bit_se5824344971392196577ns_xor @ nat @ ( suc @ ( zero_zero @ nat ) ) @ ( numeral_numeral @ nat @ ( bit1 @ Y ) ) )
      = ( numeral_numeral @ nat @ ( bit0 @ Y ) ) ) ).

% xor_nat_numerals(2)
thf(fact_2647_xor__nat__numerals_I1_J,axiom,
    ! [Y: num] :
      ( ( bit_se5824344971392196577ns_xor @ nat @ ( suc @ ( zero_zero @ nat ) ) @ ( numeral_numeral @ nat @ ( bit0 @ Y ) ) )
      = ( numeral_numeral @ nat @ ( bit1 @ Y ) ) ) ).

% xor_nat_numerals(1)
thf(fact_2648_set__decode__Suc,axiom,
    ! [N: nat,X: nat] :
      ( ( member @ nat @ ( suc @ N ) @ ( nat_set_decode @ X ) )
      = ( member @ nat @ N @ ( nat_set_decode @ ( divide_divide @ nat @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% set_decode_Suc
thf(fact_2649_and__nat__numerals_I2_J,axiom,
    ! [Y: num] :
      ( ( bit_se5824344872417868541ns_and @ nat @ ( suc @ ( zero_zero @ nat ) ) @ ( numeral_numeral @ nat @ ( bit1 @ Y ) ) )
      = ( one_one @ nat ) ) ).

% and_nat_numerals(2)
thf(fact_2650_and__nat__numerals_I4_J,axiom,
    ! [X: num] :
      ( ( bit_se5824344872417868541ns_and @ nat @ ( numeral_numeral @ nat @ ( bit1 @ X ) ) @ ( suc @ ( zero_zero @ nat ) ) )
      = ( one_one @ nat ) ) ).

% and_nat_numerals(4)
thf(fact_2651_take__bit__Suc__0,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A] :
          ( ( bit_se2584673776208193580ke_bit @ A @ ( suc @ ( zero_zero @ nat ) ) @ A2 )
          = ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% take_bit_Suc_0
thf(fact_2652_odd__Suc__minus__one,axiom,
    ! [N: nat] :
      ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
     => ( ( suc @ ( minus_minus @ nat @ N @ ( suc @ ( zero_zero @ nat ) ) ) )
        = N ) ) ).

% odd_Suc_minus_one
thf(fact_2653_signed__take__bit__Suc__minus__bit0,axiom,
    ! [N: nat,K: num] :
      ( ( bit_ri4674362597316999326ke_bit @ int @ ( suc @ N ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit0 @ K ) ) ) )
      = ( times_times @ int @ ( bit_ri4674362597316999326ke_bit @ int @ N @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ K ) ) ) @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ).

% signed_take_bit_Suc_minus_bit0
thf(fact_2654_Suc__0__and__eq,axiom,
    ! [N: nat] :
      ( ( bit_se5824344872417868541ns_and @ nat @ ( suc @ ( zero_zero @ nat ) ) @ N )
      = ( modulo_modulo @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ).

% Suc_0_and_eq
thf(fact_2655_and__Suc__0__eq,axiom,
    ! [N: nat] :
      ( ( bit_se5824344872417868541ns_and @ nat @ N @ ( suc @ ( zero_zero @ nat ) ) )
      = ( modulo_modulo @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ).

% and_Suc_0_eq
thf(fact_2656_signed__take__bit__numeral__bit0,axiom,
    ! [L: num,K: num] :
      ( ( bit_ri4674362597316999326ke_bit @ int @ ( numeral_numeral @ nat @ L ) @ ( numeral_numeral @ int @ ( bit0 @ K ) ) )
      = ( times_times @ int @ ( bit_ri4674362597316999326ke_bit @ int @ ( pred_numeral @ L ) @ ( numeral_numeral @ int @ K ) ) @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ).

% signed_take_bit_numeral_bit0
thf(fact_2657_signed__take__bit__numeral__minus__bit0,axiom,
    ! [L: num,K: num] :
      ( ( bit_ri4674362597316999326ke_bit @ int @ ( numeral_numeral @ nat @ L ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit0 @ K ) ) ) )
      = ( times_times @ int @ ( bit_ri4674362597316999326ke_bit @ int @ ( pred_numeral @ L ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ K ) ) ) @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ).

% signed_take_bit_numeral_minus_bit0
thf(fact_2658_Suc__inject,axiom,
    ! [X: nat,Y: nat] :
      ( ( ( suc @ X )
        = ( suc @ Y ) )
     => ( X = Y ) ) ).

% Suc_inject
thf(fact_2659_n__not__Suc__n,axiom,
    ! [N: nat] :
      ( N
     != ( suc @ N ) ) ).

% n_not_Suc_n
thf(fact_2660_numeral__eq__Suc,axiom,
    ( ( numeral_numeral @ nat )
    = ( ^ [K3: num] : ( suc @ ( pred_numeral @ K3 ) ) ) ) ).

% numeral_eq_Suc
thf(fact_2661_list__decode_Ocases,axiom,
    ! [X: nat] :
      ( ( X
       != ( zero_zero @ nat ) )
     => ~ ! [N2: nat] :
            ( X
           != ( suc @ N2 ) ) ) ).

% list_decode.cases
thf(fact_2662_vebt__buildup_Ocases,axiom,
    ! [X: nat] :
      ( ( X
       != ( zero_zero @ nat ) )
     => ( ( X
         != ( suc @ ( zero_zero @ nat ) ) )
       => ~ ! [Va: nat] :
              ( X
             != ( suc @ ( suc @ Va ) ) ) ) ) ).

% vebt_buildup.cases
thf(fact_2663_exists__least__lemma,axiom,
    ! [P: nat > $o] :
      ( ~ ( P @ ( zero_zero @ nat ) )
     => ( ? [X_12: nat] : ( P @ X_12 )
       => ? [N2: nat] :
            ( ~ ( P @ N2 )
            & ( P @ ( suc @ N2 ) ) ) ) ) ).

% exists_least_lemma
thf(fact_2664_not0__implies__Suc,axiom,
    ! [N: nat] :
      ( ( N
       != ( zero_zero @ nat ) )
     => ? [M4: nat] :
          ( N
          = ( suc @ M4 ) ) ) ).

% not0_implies_Suc
thf(fact_2665_Zero__not__Suc,axiom,
    ! [M: nat] :
      ( ( zero_zero @ nat )
     != ( suc @ M ) ) ).

% Zero_not_Suc
thf(fact_2666_Zero__neq__Suc,axiom,
    ! [M: nat] :
      ( ( zero_zero @ nat )
     != ( suc @ M ) ) ).

% Zero_neq_Suc
thf(fact_2667_Suc__neq__Zero,axiom,
    ! [M: nat] :
      ( ( suc @ M )
     != ( zero_zero @ nat ) ) ).

% Suc_neq_Zero
thf(fact_2668_zero__induct,axiom,
    ! [P: nat > $o,K: nat] :
      ( ( P @ K )
     => ( ! [N2: nat] :
            ( ( P @ ( suc @ N2 ) )
           => ( P @ N2 ) )
       => ( P @ ( zero_zero @ nat ) ) ) ) ).

% zero_induct
thf(fact_2669_diff__induct,axiom,
    ! [P: nat > nat > $o,M: nat,N: nat] :
      ( ! [X3: nat] : ( P @ X3 @ ( zero_zero @ nat ) )
     => ( ! [Y5: nat] : ( P @ ( zero_zero @ nat ) @ ( suc @ Y5 ) )
       => ( ! [X3: nat,Y5: nat] :
              ( ( P @ X3 @ Y5 )
             => ( P @ ( suc @ X3 ) @ ( suc @ Y5 ) ) )
         => ( P @ M @ N ) ) ) ) ).

% diff_induct
thf(fact_2670_nat__induct,axiom,
    ! [P: nat > $o,N: nat] :
      ( ( P @ ( zero_zero @ nat ) )
     => ( ! [N2: nat] :
            ( ( P @ N2 )
           => ( P @ ( suc @ N2 ) ) )
       => ( P @ N ) ) ) ).

% nat_induct
thf(fact_2671_old_Onat_Oexhaust,axiom,
    ! [Y: nat] :
      ( ( Y
       != ( zero_zero @ nat ) )
     => ~ ! [Nat3: nat] :
            ( Y
           != ( suc @ Nat3 ) ) ) ).

% old.nat.exhaust
thf(fact_2672_nat_OdiscI,axiom,
    ! [Nat: nat,X22: nat] :
      ( ( Nat
        = ( suc @ X22 ) )
     => ( Nat
       != ( zero_zero @ nat ) ) ) ).

% nat.discI
thf(fact_2673_old_Onat_Odistinct_I1_J,axiom,
    ! [Nat2: nat] :
      ( ( zero_zero @ nat )
     != ( suc @ Nat2 ) ) ).

% old.nat.distinct(1)
thf(fact_2674_old_Onat_Odistinct_I2_J,axiom,
    ! [Nat4: nat] :
      ( ( suc @ Nat4 )
     != ( zero_zero @ nat ) ) ).

% old.nat.distinct(2)
thf(fact_2675_nat_Odistinct_I1_J,axiom,
    ! [X22: nat] :
      ( ( zero_zero @ nat )
     != ( suc @ X22 ) ) ).

% nat.distinct(1)
thf(fact_2676_Nat_OlessE,axiom,
    ! [I: nat,K: nat] :
      ( ( ord_less @ nat @ I @ K )
     => ( ( K
         != ( suc @ I ) )
       => ~ ! [J2: nat] :
              ( ( ord_less @ nat @ I @ J2 )
             => ( K
               != ( suc @ J2 ) ) ) ) ) ).

% Nat.lessE
thf(fact_2677_Suc__lessD,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ ( suc @ M ) @ N )
     => ( ord_less @ nat @ M @ N ) ) ).

% Suc_lessD
thf(fact_2678_Suc__lessE,axiom,
    ! [I: nat,K: nat] :
      ( ( ord_less @ nat @ ( suc @ I ) @ K )
     => ~ ! [J2: nat] :
            ( ( ord_less @ nat @ I @ J2 )
           => ( K
             != ( suc @ J2 ) ) ) ) ).

% Suc_lessE
thf(fact_2679_Suc__lessI,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ M @ N )
     => ( ( ( suc @ M )
         != N )
       => ( ord_less @ nat @ ( suc @ M ) @ N ) ) ) ).

% Suc_lessI
thf(fact_2680_less__SucE,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ M @ ( suc @ N ) )
     => ( ~ ( ord_less @ nat @ M @ N )
       => ( M = N ) ) ) ).

% less_SucE
thf(fact_2681_less__SucI,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ M @ N )
     => ( ord_less @ nat @ M @ ( suc @ N ) ) ) ).

% less_SucI
thf(fact_2682_Ex__less__Suc,axiom,
    ! [N: nat,P: nat > $o] :
      ( ( ? [I4: nat] :
            ( ( ord_less @ nat @ I4 @ ( suc @ N ) )
            & ( P @ I4 ) ) )
      = ( ( P @ N )
        | ? [I4: nat] :
            ( ( ord_less @ nat @ I4 @ N )
            & ( P @ I4 ) ) ) ) ).

% Ex_less_Suc
thf(fact_2683_less__Suc__eq,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ M @ ( suc @ N ) )
      = ( ( ord_less @ nat @ M @ N )
        | ( M = N ) ) ) ).

% less_Suc_eq
thf(fact_2684_not__less__eq,axiom,
    ! [M: nat,N: nat] :
      ( ( ~ ( ord_less @ nat @ M @ N ) )
      = ( ord_less @ nat @ N @ ( suc @ M ) ) ) ).

% not_less_eq
thf(fact_2685_All__less__Suc,axiom,
    ! [N: nat,P: nat > $o] :
      ( ( ! [I4: nat] :
            ( ( ord_less @ nat @ I4 @ ( suc @ N ) )
           => ( P @ I4 ) ) )
      = ( ( P @ N )
        & ! [I4: nat] :
            ( ( ord_less @ nat @ I4 @ N )
           => ( P @ I4 ) ) ) ) ).

% All_less_Suc
thf(fact_2686_Suc__less__eq2,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less @ nat @ ( suc @ N ) @ M )
      = ( ? [M6: nat] :
            ( ( M
              = ( suc @ M6 ) )
            & ( ord_less @ nat @ N @ M6 ) ) ) ) ).

% Suc_less_eq2
thf(fact_2687_less__antisym,axiom,
    ! [N: nat,M: nat] :
      ( ~ ( ord_less @ nat @ N @ M )
     => ( ( ord_less @ nat @ N @ ( suc @ M ) )
       => ( M = N ) ) ) ).

% less_antisym
thf(fact_2688_Suc__less__SucD,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ ( suc @ M ) @ ( suc @ N ) )
     => ( ord_less @ nat @ M @ N ) ) ).

% Suc_less_SucD
thf(fact_2689_less__trans__Suc,axiom,
    ! [I: nat,J: nat,K: nat] :
      ( ( ord_less @ nat @ I @ J )
     => ( ( ord_less @ nat @ J @ K )
       => ( ord_less @ nat @ ( suc @ I ) @ K ) ) ) ).

% less_trans_Suc
thf(fact_2690_less__Suc__induct,axiom,
    ! [I: nat,J: nat,P: nat > nat > $o] :
      ( ( ord_less @ nat @ I @ J )
     => ( ! [I2: nat] : ( P @ I2 @ ( suc @ I2 ) )
       => ( ! [I2: nat,J2: nat,K2: nat] :
              ( ( ord_less @ nat @ I2 @ J2 )
             => ( ( ord_less @ nat @ J2 @ K2 )
               => ( ( P @ I2 @ J2 )
                 => ( ( P @ J2 @ K2 )
                   => ( P @ I2 @ K2 ) ) ) ) )
         => ( P @ I @ J ) ) ) ) ).

% less_Suc_induct
thf(fact_2691_strict__inc__induct,axiom,
    ! [I: nat,J: nat,P: nat > $o] :
      ( ( ord_less @ nat @ I @ J )
     => ( ! [I2: nat] :
            ( ( J
              = ( suc @ I2 ) )
           => ( P @ I2 ) )
       => ( ! [I2: nat] :
              ( ( ord_less @ nat @ I2 @ J )
             => ( ( P @ ( suc @ I2 ) )
               => ( P @ I2 ) ) )
         => ( P @ I ) ) ) ) ).

% strict_inc_induct
thf(fact_2692_not__less__less__Suc__eq,axiom,
    ! [N: nat,M: nat] :
      ( ~ ( ord_less @ nat @ N @ M )
     => ( ( ord_less @ nat @ N @ ( suc @ M ) )
        = ( N = M ) ) ) ).

% not_less_less_Suc_eq
thf(fact_2693_Suc__leD,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ ( suc @ M ) @ N )
     => ( ord_less_eq @ nat @ M @ N ) ) ).

% Suc_leD
thf(fact_2694_le__SucE,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ M @ ( suc @ N ) )
     => ( ~ ( ord_less_eq @ nat @ M @ N )
       => ( M
          = ( suc @ N ) ) ) ) ).

% le_SucE
thf(fact_2695_le__SucI,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ M @ N )
     => ( ord_less_eq @ nat @ M @ ( suc @ N ) ) ) ).

% le_SucI
thf(fact_2696_Suc__le__D,axiom,
    ! [N: nat,M7: nat] :
      ( ( ord_less_eq @ nat @ ( suc @ N ) @ M7 )
     => ? [M4: nat] :
          ( M7
          = ( suc @ M4 ) ) ) ).

% Suc_le_D
thf(fact_2697_le__Suc__eq,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ M @ ( suc @ N ) )
      = ( ( ord_less_eq @ nat @ M @ N )
        | ( M
          = ( suc @ N ) ) ) ) ).

% le_Suc_eq
thf(fact_2698_Suc__n__not__le__n,axiom,
    ! [N: nat] :
      ~ ( ord_less_eq @ nat @ ( suc @ N ) @ N ) ).

% Suc_n_not_le_n
thf(fact_2699_not__less__eq__eq,axiom,
    ! [M: nat,N: nat] :
      ( ( ~ ( ord_less_eq @ nat @ M @ N ) )
      = ( ord_less_eq @ nat @ ( suc @ N ) @ M ) ) ).

% not_less_eq_eq
thf(fact_2700_full__nat__induct,axiom,
    ! [P: nat > $o,N: nat] :
      ( ! [N2: nat] :
          ( ! [M2: nat] :
              ( ( ord_less_eq @ nat @ ( suc @ M2 ) @ N2 )
             => ( P @ M2 ) )
         => ( P @ N2 ) )
     => ( P @ N ) ) ).

% full_nat_induct
thf(fact_2701_nat__induct__at__least,axiom,
    ! [M: nat,N: nat,P: nat > $o] :
      ( ( ord_less_eq @ nat @ M @ N )
     => ( ( P @ M )
       => ( ! [N2: nat] :
              ( ( ord_less_eq @ nat @ M @ N2 )
             => ( ( P @ N2 )
               => ( P @ ( suc @ N2 ) ) ) )
         => ( P @ N ) ) ) ) ).

% nat_induct_at_least
thf(fact_2702_transitive__stepwise__le,axiom,
    ! [M: nat,N: nat,R4: nat > nat > $o] :
      ( ( ord_less_eq @ nat @ M @ N )
     => ( ! [X3: nat] : ( R4 @ X3 @ X3 )
       => ( ! [X3: nat,Y5: nat,Z3: nat] :
              ( ( R4 @ X3 @ Y5 )
             => ( ( R4 @ Y5 @ Z3 )
               => ( R4 @ X3 @ Z3 ) ) )
         => ( ! [N2: nat] : ( R4 @ N2 @ ( suc @ N2 ) )
           => ( R4 @ M @ N ) ) ) ) ) ).

% transitive_stepwise_le
thf(fact_2703_add__Suc__shift,axiom,
    ! [M: nat,N: nat] :
      ( ( plus_plus @ nat @ ( suc @ M ) @ N )
      = ( plus_plus @ nat @ M @ ( suc @ N ) ) ) ).

% add_Suc_shift
thf(fact_2704_add__Suc,axiom,
    ! [M: nat,N: nat] :
      ( ( plus_plus @ nat @ ( suc @ M ) @ N )
      = ( suc @ ( plus_plus @ nat @ M @ N ) ) ) ).

% add_Suc
thf(fact_2705_nat__arith_Osuc1,axiom,
    ! [A4: nat,K: nat,A2: nat] :
      ( ( A4
        = ( plus_plus @ nat @ K @ A2 ) )
     => ( ( suc @ A4 )
        = ( plus_plus @ nat @ K @ ( suc @ A2 ) ) ) ) ).

% nat_arith.suc1
thf(fact_2706_zero__induct__lemma,axiom,
    ! [P: nat > $o,K: nat,I: nat] :
      ( ( P @ K )
     => ( ! [N2: nat] :
            ( ( P @ ( suc @ N2 ) )
           => ( P @ N2 ) )
       => ( P @ ( minus_minus @ nat @ K @ I ) ) ) ) ).

% zero_induct_lemma
thf(fact_2707_Suc__mult__cancel1,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( ( times_times @ nat @ ( suc @ K ) @ M )
        = ( times_times @ nat @ ( suc @ K ) @ N ) )
      = ( M = N ) ) ).

% Suc_mult_cancel1
thf(fact_2708_lift__Suc__mono__less,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [F2: nat > A,N: nat,N5: nat] :
          ( ! [N2: nat] : ( ord_less @ A @ ( F2 @ N2 ) @ ( F2 @ ( suc @ N2 ) ) )
         => ( ( ord_less @ nat @ N @ N5 )
           => ( ord_less @ A @ ( F2 @ N ) @ ( F2 @ N5 ) ) ) ) ) ).

% lift_Suc_mono_less
thf(fact_2709_lift__Suc__mono__less__iff,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [F2: nat > A,N: nat,M: nat] :
          ( ! [N2: nat] : ( ord_less @ A @ ( F2 @ N2 ) @ ( F2 @ ( suc @ N2 ) ) )
         => ( ( ord_less @ A @ ( F2 @ N ) @ ( F2 @ M ) )
            = ( ord_less @ nat @ N @ M ) ) ) ) ).

% lift_Suc_mono_less_iff
thf(fact_2710_power__Suc,axiom,
    ! [A: $tType] :
      ( ( power @ A )
     => ! [A2: A,N: nat] :
          ( ( power_power @ A @ A2 @ ( suc @ N ) )
          = ( times_times @ A @ A2 @ ( power_power @ A @ A2 @ N ) ) ) ) ).

% power_Suc
thf(fact_2711_power__Suc2,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [A2: A,N: nat] :
          ( ( power_power @ A @ A2 @ ( suc @ N ) )
          = ( times_times @ A @ ( power_power @ A @ A2 @ N ) @ A2 ) ) ) ).

% power_Suc2
thf(fact_2712_of__nat__neq__0,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [N: nat] :
          ( ( semiring_1_of_nat @ A @ ( suc @ N ) )
         != ( zero_zero @ A ) ) ) ).

% of_nat_neq_0
thf(fact_2713_lift__Suc__mono__le,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [F2: nat > A,N: nat,N5: nat] :
          ( ! [N2: nat] : ( ord_less_eq @ A @ ( F2 @ N2 ) @ ( F2 @ ( suc @ N2 ) ) )
         => ( ( ord_less_eq @ nat @ N @ N5 )
           => ( ord_less_eq @ A @ ( F2 @ N ) @ ( F2 @ N5 ) ) ) ) ) ).

% lift_Suc_mono_le
thf(fact_2714_lift__Suc__antimono__le,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [F2: nat > A,N: nat,N5: nat] :
          ( ! [N2: nat] : ( ord_less_eq @ A @ ( F2 @ ( suc @ N2 ) ) @ ( F2 @ N2 ) )
         => ( ( ord_less_eq @ nat @ N @ N5 )
           => ( ord_less_eq @ A @ ( F2 @ N5 ) @ ( F2 @ N ) ) ) ) ) ).

% lift_Suc_antimono_le
thf(fact_2715_less__Suc__eq__0__disj,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ M @ ( suc @ N ) )
      = ( ( M
          = ( zero_zero @ nat ) )
        | ? [J3: nat] :
            ( ( M
              = ( suc @ J3 ) )
            & ( ord_less @ nat @ J3 @ N ) ) ) ) ).

% less_Suc_eq_0_disj
thf(fact_2716_gr0__implies__Suc,axiom,
    ! [N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ? [M4: nat] :
          ( N
          = ( suc @ M4 ) ) ) ).

% gr0_implies_Suc
thf(fact_2717_All__less__Suc2,axiom,
    ! [N: nat,P: nat > $o] :
      ( ( ! [I4: nat] :
            ( ( ord_less @ nat @ I4 @ ( suc @ N ) )
           => ( P @ I4 ) ) )
      = ( ( P @ ( zero_zero @ nat ) )
        & ! [I4: nat] :
            ( ( ord_less @ nat @ I4 @ N )
           => ( P @ ( suc @ I4 ) ) ) ) ) ).

% All_less_Suc2
thf(fact_2718_gr0__conv__Suc,axiom,
    ! [N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
      = ( ? [M3: nat] :
            ( N
            = ( suc @ M3 ) ) ) ) ).

% gr0_conv_Suc
thf(fact_2719_Ex__less__Suc2,axiom,
    ! [N: nat,P: nat > $o] :
      ( ( ? [I4: nat] :
            ( ( ord_less @ nat @ I4 @ ( suc @ N ) )
            & ( P @ I4 ) ) )
      = ( ( P @ ( zero_zero @ nat ) )
        | ? [I4: nat] :
            ( ( ord_less @ nat @ I4 @ N )
            & ( P @ ( suc @ I4 ) ) ) ) ) ).

% Ex_less_Suc2
thf(fact_2720_Suc__leI,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ M @ N )
     => ( ord_less_eq @ nat @ ( suc @ M ) @ N ) ) ).

% Suc_leI
thf(fact_2721_Suc__le__eq,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ ( suc @ M ) @ N )
      = ( ord_less @ nat @ M @ N ) ) ).

% Suc_le_eq
thf(fact_2722_dec__induct,axiom,
    ! [I: nat,J: nat,P: nat > $o] :
      ( ( ord_less_eq @ nat @ I @ J )
     => ( ( P @ I )
       => ( ! [N2: nat] :
              ( ( ord_less_eq @ nat @ I @ N2 )
             => ( ( ord_less @ nat @ N2 @ J )
               => ( ( P @ N2 )
                 => ( P @ ( suc @ N2 ) ) ) ) )
         => ( P @ J ) ) ) ) ).

% dec_induct
thf(fact_2723_inc__induct,axiom,
    ! [I: nat,J: nat,P: nat > $o] :
      ( ( ord_less_eq @ nat @ I @ J )
     => ( ( P @ J )
       => ( ! [N2: nat] :
              ( ( ord_less_eq @ nat @ I @ N2 )
             => ( ( ord_less @ nat @ N2 @ J )
               => ( ( P @ ( suc @ N2 ) )
                 => ( P @ N2 ) ) ) )
         => ( P @ I ) ) ) ) ).

% inc_induct
thf(fact_2724_Suc__le__lessD,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ ( suc @ M ) @ N )
     => ( ord_less @ nat @ M @ N ) ) ).

% Suc_le_lessD
thf(fact_2725_le__less__Suc__eq,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ M @ N )
     => ( ( ord_less @ nat @ N @ ( suc @ M ) )
        = ( N = M ) ) ) ).

% le_less_Suc_eq
thf(fact_2726_less__Suc__eq__le,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ M @ ( suc @ N ) )
      = ( ord_less_eq @ nat @ M @ N ) ) ).

% less_Suc_eq_le
thf(fact_2727_less__eq__Suc__le,axiom,
    ( ( ord_less @ nat )
    = ( ^ [N3: nat] : ( ord_less_eq @ nat @ ( suc @ N3 ) ) ) ) ).

% less_eq_Suc_le
thf(fact_2728_le__imp__less__Suc,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ M @ N )
     => ( ord_less @ nat @ M @ ( suc @ N ) ) ) ).

% le_imp_less_Suc
thf(fact_2729_one__is__add,axiom,
    ! [M: nat,N: nat] :
      ( ( ( suc @ ( zero_zero @ nat ) )
        = ( plus_plus @ nat @ M @ N ) )
      = ( ( ( M
            = ( suc @ ( zero_zero @ nat ) ) )
          & ( N
            = ( zero_zero @ nat ) ) )
        | ( ( M
            = ( zero_zero @ nat ) )
          & ( N
            = ( suc @ ( zero_zero @ nat ) ) ) ) ) ) ).

% one_is_add
thf(fact_2730_add__is__1,axiom,
    ! [M: nat,N: nat] :
      ( ( ( plus_plus @ nat @ M @ N )
        = ( suc @ ( zero_zero @ nat ) ) )
      = ( ( ( M
            = ( suc @ ( zero_zero @ nat ) ) )
          & ( N
            = ( zero_zero @ nat ) ) )
        | ( ( M
            = ( zero_zero @ nat ) )
          & ( N
            = ( suc @ ( zero_zero @ nat ) ) ) ) ) ) ).

% add_is_1
thf(fact_2731_less__imp__Suc__add,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ M @ N )
     => ? [K2: nat] :
          ( N
          = ( suc @ ( plus_plus @ nat @ M @ K2 ) ) ) ) ).

% less_imp_Suc_add
thf(fact_2732_less__iff__Suc__add,axiom,
    ( ( ord_less @ nat )
    = ( ^ [M3: nat,N3: nat] :
        ? [K3: nat] :
          ( N3
          = ( suc @ ( plus_plus @ nat @ M3 @ K3 ) ) ) ) ) ).

% less_iff_Suc_add
thf(fact_2733_less__add__Suc2,axiom,
    ! [I: nat,M: nat] : ( ord_less @ nat @ I @ ( suc @ ( plus_plus @ nat @ M @ I ) ) ) ).

% less_add_Suc2
thf(fact_2734_less__add__Suc1,axiom,
    ! [I: nat,M: nat] : ( ord_less @ nat @ I @ ( suc @ ( plus_plus @ nat @ I @ M ) ) ) ).

% less_add_Suc1
thf(fact_2735_less__natE,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ M @ N )
     => ~ ! [Q5: nat] :
            ( N
           != ( suc @ ( plus_plus @ nat @ M @ Q5 ) ) ) ) ).

% less_natE
thf(fact_2736_diff__less__Suc,axiom,
    ! [M: nat,N: nat] : ( ord_less @ nat @ ( minus_minus @ nat @ M @ N ) @ ( suc @ M ) ) ).

% diff_less_Suc
thf(fact_2737_Suc__diff__Suc,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less @ nat @ N @ M )
     => ( ( suc @ ( minus_minus @ nat @ M @ ( suc @ N ) ) )
        = ( minus_minus @ nat @ M @ N ) ) ) ).

% Suc_diff_Suc
thf(fact_2738_Suc__mult__less__cancel1,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( ord_less @ nat @ ( times_times @ nat @ ( suc @ K ) @ M ) @ ( times_times @ nat @ ( suc @ K ) @ N ) )
      = ( ord_less @ nat @ M @ N ) ) ).

% Suc_mult_less_cancel1
thf(fact_2739_Suc__diff__le,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less_eq @ nat @ N @ M )
     => ( ( minus_minus @ nat @ ( suc @ M ) @ N )
        = ( suc @ ( minus_minus @ nat @ M @ N ) ) ) ) ).

% Suc_diff_le
thf(fact_2740_One__nat__def,axiom,
    ( ( one_one @ nat )
    = ( suc @ ( zero_zero @ nat ) ) ) ).

% One_nat_def
thf(fact_2741_Suc__mult__le__cancel1,axiom,
    ! [K: nat,M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ ( times_times @ nat @ ( suc @ K ) @ M ) @ ( times_times @ nat @ ( suc @ K ) @ N ) )
      = ( ord_less_eq @ nat @ M @ N ) ) ).

% Suc_mult_le_cancel1
thf(fact_2742_mult__Suc,axiom,
    ! [M: nat,N: nat] :
      ( ( times_times @ nat @ ( suc @ M ) @ N )
      = ( plus_plus @ nat @ N @ ( times_times @ nat @ M @ N ) ) ) ).

% mult_Suc
thf(fact_2743_Suc__div__le__mono,axiom,
    ! [M: nat,N: nat] : ( ord_less_eq @ nat @ ( divide_divide @ nat @ M @ N ) @ ( divide_divide @ nat @ ( suc @ M ) @ N ) ) ).

% Suc_div_le_mono
thf(fact_2744_Suc__eq__plus1__left,axiom,
    ( suc
    = ( plus_plus @ nat @ ( one_one @ nat ) ) ) ).

% Suc_eq_plus1_left
thf(fact_2745_plus__1__eq__Suc,axiom,
    ( ( plus_plus @ nat @ ( one_one @ nat ) )
    = suc ) ).

% plus_1_eq_Suc
thf(fact_2746_Suc__eq__plus1,axiom,
    ( suc
    = ( ^ [N3: nat] : ( plus_plus @ nat @ N3 @ ( one_one @ nat ) ) ) ) ).

% Suc_eq_plus1
thf(fact_2747_diff__Suc__eq__diff__pred,axiom,
    ! [M: nat,N: nat] :
      ( ( minus_minus @ nat @ M @ ( suc @ N ) )
      = ( minus_minus @ nat @ ( minus_minus @ nat @ M @ ( one_one @ nat ) ) @ N ) ) ).

% diff_Suc_eq_diff_pred
thf(fact_2748_mod__Suc,axiom,
    ! [M: nat,N: nat] :
      ( ( ( ( suc @ ( modulo_modulo @ nat @ M @ N ) )
          = N )
       => ( ( modulo_modulo @ nat @ ( suc @ M ) @ N )
          = ( zero_zero @ nat ) ) )
      & ( ( ( suc @ ( modulo_modulo @ nat @ M @ N ) )
         != N )
       => ( ( modulo_modulo @ nat @ ( suc @ M ) @ N )
          = ( suc @ ( modulo_modulo @ nat @ M @ N ) ) ) ) ) ).

% mod_Suc
thf(fact_2749_mod__induct,axiom,
    ! [P: nat > $o,N: nat,P6: nat,M: nat] :
      ( ( P @ N )
     => ( ( ord_less @ nat @ N @ P6 )
       => ( ( ord_less @ nat @ M @ P6 )
         => ( ! [N2: nat] :
                ( ( ord_less @ nat @ N2 @ P6 )
               => ( ( P @ N2 )
                 => ( P @ ( modulo_modulo @ nat @ ( suc @ N2 ) @ P6 ) ) ) )
           => ( P @ M ) ) ) ) ) ).

% mod_induct
thf(fact_2750_mod__Suc__le__divisor,axiom,
    ! [M: nat,N: nat] : ( ord_less_eq @ nat @ ( modulo_modulo @ nat @ M @ ( suc @ N ) ) @ N ) ).

% mod_Suc_le_divisor
thf(fact_2751_int__cases,axiom,
    ! [Z: int] :
      ( ! [N2: nat] :
          ( Z
         != ( semiring_1_of_nat @ int @ N2 ) )
     => ~ ! [N2: nat] :
            ( Z
           != ( uminus_uminus @ int @ ( semiring_1_of_nat @ int @ ( suc @ N2 ) ) ) ) ) ).

% int_cases
thf(fact_2752_int__of__nat__induct,axiom,
    ! [P: int > $o,Z: int] :
      ( ! [N2: nat] : ( P @ ( semiring_1_of_nat @ int @ N2 ) )
     => ( ! [N2: nat] : ( P @ ( uminus_uminus @ int @ ( semiring_1_of_nat @ int @ ( suc @ N2 ) ) ) )
       => ( P @ Z ) ) ) ).

% int_of_nat_induct
thf(fact_2753_signed__take__bit__eq__iff__take__bit__eq,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N: nat,A2: A,B2: A] :
          ( ( ( bit_ri4674362597316999326ke_bit @ A @ N @ A2 )
            = ( bit_ri4674362597316999326ke_bit @ A @ N @ B2 ) )
          = ( ( bit_se2584673776208193580ke_bit @ A @ ( suc @ N ) @ A2 )
            = ( bit_se2584673776208193580ke_bit @ A @ ( suc @ N ) @ B2 ) ) ) ) ).

% signed_take_bit_eq_iff_take_bit_eq
thf(fact_2754_power__inject__base,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,N: nat,B2: A] :
          ( ( ( power_power @ A @ A2 @ ( suc @ N ) )
            = ( power_power @ A @ B2 @ ( suc @ N ) ) )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
           => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 )
             => ( A2 = B2 ) ) ) ) ) ).

% power_inject_base
thf(fact_2755_power__le__imp__le__base,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,N: nat,B2: A] :
          ( ( ord_less_eq @ A @ ( power_power @ A @ A2 @ ( suc @ N ) ) @ ( power_power @ A @ B2 @ ( suc @ N ) ) )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 )
           => ( ord_less_eq @ A @ A2 @ B2 ) ) ) ) ).

% power_le_imp_le_base
thf(fact_2756_power__gt1,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,N: nat] :
          ( ( ord_less @ A @ ( one_one @ A ) @ A2 )
         => ( ord_less @ A @ ( one_one @ A ) @ ( power_power @ A @ A2 @ ( suc @ N ) ) ) ) ) ).

% power_gt1
thf(fact_2757_numeral__1__eq__Suc__0,axiom,
    ( ( numeral_numeral @ nat @ one2 )
    = ( suc @ ( zero_zero @ nat ) ) ) ).

% numeral_1_eq_Suc_0
thf(fact_2758_eval__nat__numeral_I3_J,axiom,
    ! [N: num] :
      ( ( numeral_numeral @ nat @ ( bit1 @ N ) )
      = ( suc @ ( numeral_numeral @ nat @ ( bit0 @ N ) ) ) ) ).

% eval_nat_numeral(3)
thf(fact_2759_ex__least__nat__less,axiom,
    ! [P: nat > $o,N: nat] :
      ( ( P @ N )
     => ( ~ ( P @ ( zero_zero @ nat ) )
       => ? [K2: nat] :
            ( ( ord_less @ nat @ K2 @ N )
            & ! [I3: nat] :
                ( ( ord_less_eq @ nat @ I3 @ K2 )
               => ~ ( P @ I3 ) )
            & ( P @ ( suc @ K2 ) ) ) ) ) ).

% ex_least_nat_less
thf(fact_2760_diff__Suc__less,axiom,
    ! [N: nat,I: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ord_less @ nat @ ( minus_minus @ nat @ N @ ( suc @ I ) ) @ N ) ) ).

% diff_Suc_less
thf(fact_2761_one__less__mult,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less @ nat @ ( suc @ ( zero_zero @ nat ) ) @ N )
     => ( ( ord_less @ nat @ ( suc @ ( zero_zero @ nat ) ) @ M )
       => ( ord_less @ nat @ ( suc @ ( zero_zero @ nat ) ) @ ( times_times @ nat @ M @ N ) ) ) ) ).

% one_less_mult
thf(fact_2762_n__less__m__mult__n,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less @ nat @ ( suc @ ( zero_zero @ nat ) ) @ M )
       => ( ord_less @ nat @ N @ ( times_times @ nat @ M @ N ) ) ) ) ).

% n_less_m_mult_n
thf(fact_2763_n__less__n__mult__m,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less @ nat @ ( suc @ ( zero_zero @ nat ) ) @ M )
       => ( ord_less @ nat @ N @ ( times_times @ nat @ N @ M ) ) ) ) ).

% n_less_n_mult_m
thf(fact_2764_nat__induct__non__zero,axiom,
    ! [N: nat,P: nat > $o] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( P @ ( one_one @ nat ) )
       => ( ! [N2: nat] :
              ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
             => ( ( P @ N2 )
               => ( P @ ( suc @ N2 ) ) ) )
         => ( P @ N ) ) ) ) ).

% nat_induct_non_zero
thf(fact_2765_realpow__pos__nth2,axiom,
    ! [A2: real,N: nat] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
     => ? [R: real] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ R )
          & ( ( power_power @ real @ R @ ( suc @ N ) )
            = A2 ) ) ) ).

% realpow_pos_nth2
thf(fact_2766_power__gt__expt,axiom,
    ! [N: nat,K: nat] :
      ( ( ord_less @ nat @ ( suc @ ( zero_zero @ nat ) ) @ N )
     => ( ord_less @ nat @ K @ ( power_power @ nat @ N @ K ) ) ) ).

% power_gt_expt
thf(fact_2767_nat__one__le__power,axiom,
    ! [I: nat,N: nat] :
      ( ( ord_less_eq @ nat @ ( suc @ ( zero_zero @ nat ) ) @ I )
     => ( ord_less_eq @ nat @ ( suc @ ( zero_zero @ nat ) ) @ ( power_power @ nat @ I @ N ) ) ) ).

% nat_one_le_power
thf(fact_2768_int__Suc,axiom,
    ! [N: nat] :
      ( ( semiring_1_of_nat @ int @ ( suc @ N ) )
      = ( plus_plus @ int @ ( semiring_1_of_nat @ int @ N ) @ ( one_one @ int ) ) ) ).

% int_Suc
thf(fact_2769_int__ops_I4_J,axiom,
    ! [A2: nat] :
      ( ( semiring_1_of_nat @ int @ ( suc @ A2 ) )
      = ( plus_plus @ int @ ( semiring_1_of_nat @ int @ A2 ) @ ( one_one @ int ) ) ) ).

% int_ops(4)
thf(fact_2770_zless__iff__Suc__zadd,axiom,
    ( ( ord_less @ int )
    = ( ^ [W3: int,Z6: int] :
        ? [N3: nat] :
          ( Z6
          = ( plus_plus @ int @ W3 @ ( semiring_1_of_nat @ int @ ( suc @ N3 ) ) ) ) ) ) ).

% zless_iff_Suc_zadd
thf(fact_2771_pred__numeral__def,axiom,
    ( pred_numeral
    = ( ^ [K3: num] : ( minus_minus @ nat @ ( numeral_numeral @ nat @ K3 ) @ ( one_one @ nat ) ) ) ) ).

% pred_numeral_def
thf(fact_2772_take__bit__signed__take__bit,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [M: nat,N: nat,A2: A] :
          ( ( ord_less_eq @ nat @ M @ ( suc @ N ) )
         => ( ( bit_se2584673776208193580ke_bit @ A @ M @ ( bit_ri4674362597316999326ke_bit @ A @ N @ A2 ) )
            = ( bit_se2584673776208193580ke_bit @ A @ M @ A2 ) ) ) ) ).

% take_bit_signed_take_bit
thf(fact_2773_fact__ge__Suc__0__nat,axiom,
    ! [N: nat] : ( ord_less_eq @ nat @ ( suc @ ( zero_zero @ nat ) ) @ ( semiring_char_0_fact @ nat @ N ) ) ).

% fact_ge_Suc_0_nat
thf(fact_2774_power__Suc__le__self,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,N: nat] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less_eq @ A @ A2 @ ( one_one @ A ) )
           => ( ord_less_eq @ A @ ( power_power @ A @ A2 @ ( suc @ N ) ) @ A2 ) ) ) ) ).

% power_Suc_le_self
thf(fact_2775_power__Suc__less__one,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A2: A,N: nat] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less @ A @ A2 @ ( one_one @ A ) )
           => ( ord_less @ A @ ( power_power @ A @ A2 @ ( suc @ N ) ) @ ( one_one @ A ) ) ) ) ) ).

% power_Suc_less_one
thf(fact_2776_numeral__2__eq__2,axiom,
    ( ( numeral_numeral @ nat @ ( bit0 @ one2 ) )
    = ( suc @ ( suc @ ( zero_zero @ nat ) ) ) ) ).

% numeral_2_eq_2
thf(fact_2777_dbl__inc__def,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( neg_numeral_dbl_inc @ A )
        = ( ^ [X2: A] : ( plus_plus @ A @ ( plus_plus @ A @ X2 @ X2 ) @ ( one_one @ A ) ) ) ) ) ).

% dbl_inc_def
thf(fact_2778_Suc__double__not__eq__double,axiom,
    ! [M: nat,N: nat] :
      ( ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M ) )
     != ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ).

% Suc_double_not_eq_double
thf(fact_2779_double__not__eq__Suc__double,axiom,
    ! [M: nat,N: nat] :
      ( ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M )
     != ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ) ).

% double_not_eq_Suc_double
thf(fact_2780_numeral__3__eq__3,axiom,
    ( ( numeral_numeral @ nat @ ( bit1 @ one2 ) )
    = ( suc @ ( suc @ ( suc @ ( zero_zero @ nat ) ) ) ) ) ).

% numeral_3_eq_3
thf(fact_2781_Suc3__eq__add__3,axiom,
    ! [N: nat] :
      ( ( suc @ ( suc @ ( suc @ N ) ) )
      = ( plus_plus @ nat @ ( numeral_numeral @ nat @ ( bit1 @ one2 ) ) @ N ) ) ).

% Suc3_eq_add_3
thf(fact_2782_Suc__diff__eq__diff__pred,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( minus_minus @ nat @ ( suc @ M ) @ N )
        = ( minus_minus @ nat @ M @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) ) ) ) ).

% Suc_diff_eq_diff_pred
thf(fact_2783_Suc__pred_H,axiom,
    ! [N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( N
        = ( suc @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) ) ) ) ).

% Suc_pred'
thf(fact_2784_div__if,axiom,
    ( ( divide_divide @ nat )
    = ( ^ [M3: nat,N3: nat] :
          ( if @ nat
          @ ( ( ord_less @ nat @ M3 @ N3 )
            | ( N3
              = ( zero_zero @ nat ) ) )
          @ ( zero_zero @ nat )
          @ ( suc @ ( divide_divide @ nat @ ( minus_minus @ nat @ M3 @ N3 ) @ N3 ) ) ) ) ) ).

% div_if
thf(fact_2785_div__geq,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ~ ( ord_less @ nat @ M @ N )
       => ( ( divide_divide @ nat @ M @ N )
          = ( suc @ ( divide_divide @ nat @ ( minus_minus @ nat @ M @ N ) @ N ) ) ) ) ) ).

% div_geq
thf(fact_2786_add__eq__if,axiom,
    ( ( plus_plus @ nat )
    = ( ^ [M3: nat,N3: nat] :
          ( if @ nat
          @ ( M3
            = ( zero_zero @ nat ) )
          @ N3
          @ ( suc @ ( plus_plus @ nat @ ( minus_minus @ nat @ M3 @ ( one_one @ nat ) ) @ N3 ) ) ) ) ) ).

% add_eq_if
thf(fact_2787_div__nat__eqI,axiom,
    ! [N: nat,Q3: nat,M: nat] :
      ( ( ord_less_eq @ nat @ ( times_times @ nat @ N @ Q3 ) @ M )
     => ( ( ord_less @ nat @ M @ ( times_times @ nat @ N @ ( suc @ Q3 ) ) )
       => ( ( divide_divide @ nat @ M @ N )
          = Q3 ) ) ) ).

% div_nat_eqI
thf(fact_2788_pochhammer__Suc,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [A2: A,N: nat] :
          ( ( comm_s3205402744901411588hammer @ A @ A2 @ ( suc @ N ) )
          = ( times_times @ A @ ( comm_s3205402744901411588hammer @ A @ A2 @ N ) @ ( plus_plus @ A @ A2 @ ( semiring_1_of_nat @ A @ N ) ) ) ) ) ).

% pochhammer_Suc
thf(fact_2789_pochhammer__rec_H,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [Z: A,N: nat] :
          ( ( comm_s3205402744901411588hammer @ A @ Z @ ( suc @ N ) )
          = ( times_times @ A @ ( plus_plus @ A @ Z @ ( semiring_1_of_nat @ A @ N ) ) @ ( comm_s3205402744901411588hammer @ A @ Z @ N ) ) ) ) ).

% pochhammer_rec'
thf(fact_2790_Suc__nat__number__of__add,axiom,
    ! [V: num,N: nat] :
      ( ( suc @ ( plus_plus @ nat @ ( numeral_numeral @ nat @ V ) @ N ) )
      = ( plus_plus @ nat @ ( numeral_numeral @ nat @ ( plus_plus @ num @ V @ one2 ) ) @ N ) ) ).

% Suc_nat_number_of_add
thf(fact_2791_not__zle__0__negative,axiom,
    ! [N: nat] :
      ~ ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( uminus_uminus @ int @ ( semiring_1_of_nat @ int @ ( suc @ N ) ) ) ) ).

% not_zle_0_negative
thf(fact_2792_negative__zless__0,axiom,
    ! [N: nat] : ( ord_less @ int @ ( uminus_uminus @ int @ ( semiring_1_of_nat @ int @ ( suc @ N ) ) ) @ ( zero_zero @ int ) ) ).

% negative_zless_0
thf(fact_2793_negD,axiom,
    ! [X: int] :
      ( ( ord_less @ int @ X @ ( zero_zero @ int ) )
     => ? [N2: nat] :
          ( X
          = ( uminus_uminus @ int @ ( semiring_1_of_nat @ int @ ( suc @ N2 ) ) ) ) ) ).

% negD
thf(fact_2794_fact__numeral,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [K: num] :
          ( ( semiring_char_0_fact @ A @ ( numeral_numeral @ nat @ K ) )
          = ( times_times @ A @ ( numeral_numeral @ A @ K ) @ ( semiring_char_0_fact @ A @ ( pred_numeral @ K ) ) ) ) ) ).

% fact_numeral
thf(fact_2795_Suc__as__int,axiom,
    ( suc
    = ( ^ [A3: nat] : ( nat2 @ ( plus_plus @ int @ ( semiring_1_of_nat @ int @ A3 ) @ ( one_one @ int ) ) ) ) ) ).

% Suc_as_int
thf(fact_2796_fact__diff__Suc,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less @ nat @ N @ ( suc @ M ) )
     => ( ( semiring_char_0_fact @ nat @ ( minus_minus @ nat @ ( suc @ M ) @ N ) )
        = ( times_times @ nat @ ( minus_minus @ nat @ ( suc @ M ) @ N ) @ ( semiring_char_0_fact @ nat @ ( minus_minus @ nat @ M @ N ) ) ) ) ) ).

% fact_diff_Suc
thf(fact_2797_floor__eq3,axiom,
    ! [N: nat,X: real] :
      ( ( ord_less @ real @ ( semiring_1_of_nat @ real @ N ) @ X )
     => ( ( ord_less @ real @ X @ ( semiring_1_of_nat @ real @ ( suc @ N ) ) )
       => ( ( nat2 @ ( archim6421214686448440834_floor @ real @ X ) )
          = N ) ) ) ).

% floor_eq3
thf(fact_2798_nat__approx__posE,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [E2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ E2 )
         => ~ ! [N2: nat] :
                ~ ( ord_less @ A @ ( divide_divide @ A @ ( one_one @ A ) @ ( semiring_1_of_nat @ A @ ( suc @ N2 ) ) ) @ E2 ) ) ) ).

% nat_approx_posE
thf(fact_2799_less__2__cases,axiom,
    ! [N: nat] :
      ( ( ord_less @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
     => ( ( N
          = ( zero_zero @ nat ) )
        | ( N
          = ( suc @ ( zero_zero @ nat ) ) ) ) ) ).

% less_2_cases
thf(fact_2800_less__2__cases__iff,axiom,
    ! [N: nat] :
      ( ( ord_less @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
      = ( ( N
          = ( zero_zero @ nat ) )
        | ( N
          = ( suc @ ( zero_zero @ nat ) ) ) ) ) ).

% less_2_cases_iff
thf(fact_2801_take__bit__Suc__bit0,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [N: nat,K: num] :
          ( ( bit_se2584673776208193580ke_bit @ A @ ( suc @ N ) @ ( numeral_numeral @ A @ ( bit0 @ K ) ) )
          = ( times_times @ A @ ( bit_se2584673776208193580ke_bit @ A @ N @ ( numeral_numeral @ A @ K ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% take_bit_Suc_bit0
thf(fact_2802_nat__2,axiom,
    ( ( nat2 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) )
    = ( suc @ ( suc @ ( zero_zero @ nat ) ) ) ) ).

% nat_2
thf(fact_2803_Suc__div__eq__add3__div,axiom,
    ! [M: nat,N: nat] :
      ( ( divide_divide @ nat @ ( suc @ ( suc @ ( suc @ M ) ) ) @ N )
      = ( divide_divide @ nat @ ( plus_plus @ nat @ ( numeral_numeral @ nat @ ( bit1 @ one2 ) ) @ M ) @ N ) ) ).

% Suc_div_eq_add3_div
thf(fact_2804_le__div__geq,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less_eq @ nat @ N @ M )
       => ( ( divide_divide @ nat @ M @ N )
          = ( suc @ ( divide_divide @ nat @ ( minus_minus @ nat @ M @ N ) @ N ) ) ) ) ) ).

% le_div_geq
thf(fact_2805_split__div_H,axiom,
    ! [P: nat > $o,M: nat,N: nat] :
      ( ( P @ ( divide_divide @ nat @ M @ N ) )
      = ( ( ( N
            = ( zero_zero @ nat ) )
          & ( P @ ( zero_zero @ nat ) ) )
        | ? [Q6: nat] :
            ( ( ord_less_eq @ nat @ ( times_times @ nat @ N @ Q6 ) @ M )
            & ( ord_less @ nat @ M @ ( times_times @ nat @ N @ ( suc @ Q6 ) ) )
            & ( P @ Q6 ) ) ) ) ).

% split_div'
thf(fact_2806_Suc__mod__eq__add3__mod,axiom,
    ! [M: nat,N: nat] :
      ( ( modulo_modulo @ nat @ ( suc @ ( suc @ ( suc @ M ) ) ) @ N )
      = ( modulo_modulo @ nat @ ( plus_plus @ nat @ ( numeral_numeral @ nat @ ( bit1 @ one2 ) ) @ M ) @ N ) ) ).

% Suc_mod_eq_add3_mod
thf(fact_2807_Suc__times__mod__eq,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ ( suc @ ( zero_zero @ nat ) ) @ M )
     => ( ( modulo_modulo @ nat @ ( suc @ ( times_times @ nat @ M @ N ) ) @ M )
        = ( one_one @ nat ) ) ) ).

% Suc_times_mod_eq
thf(fact_2808_Suc__nat__eq__nat__zadd1,axiom,
    ! [Z: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Z )
     => ( ( suc @ ( nat2 @ Z ) )
        = ( nat2 @ ( plus_plus @ int @ ( one_one @ int ) @ Z ) ) ) ) ).

% Suc_nat_eq_nat_zadd1
thf(fact_2809_floor__eq4,axiom,
    ! [N: nat,X: real] :
      ( ( ord_less_eq @ real @ ( semiring_1_of_nat @ real @ N ) @ X )
     => ( ( ord_less @ real @ X @ ( semiring_1_of_nat @ real @ ( suc @ N ) ) )
       => ( ( nat2 @ ( archim6421214686448440834_floor @ real @ X ) )
          = N ) ) ) ).

% floor_eq4
thf(fact_2810_dbl__dec__def,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( neg_numeral_dbl_dec @ A )
        = ( ^ [X2: A] : ( minus_minus @ A @ ( plus_plus @ A @ X2 @ X2 ) @ ( one_one @ A ) ) ) ) ) ).

% dbl_dec_def
thf(fact_2811_power__odd__eq,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [A2: A,N: nat] :
          ( ( power_power @ A @ A2 @ ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) )
          = ( times_times @ A @ A2 @ ( power_power @ A @ ( power_power @ A @ A2 @ N ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% power_odd_eq
thf(fact_2812_nat__bit__induct,axiom,
    ! [P: nat > $o,N: nat] :
      ( ( P @ ( zero_zero @ nat ) )
     => ( ! [N2: nat] :
            ( ( P @ N2 )
           => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
             => ( P @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) ) )
       => ( ! [N2: nat] :
              ( ( P @ N2 )
             => ( P @ ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 ) ) ) )
         => ( P @ N ) ) ) ) ).

% nat_bit_induct
thf(fact_2813_div__2__gt__zero,axiom,
    ! [N: nat] :
      ( ( ord_less @ nat @ ( suc @ ( zero_zero @ nat ) ) @ N )
     => ( ord_less @ nat @ ( zero_zero @ nat ) @ ( divide_divide @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ).

% div_2_gt_zero
thf(fact_2814_Suc__n__div__2__gt__zero,axiom,
    ! [N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ord_less @ nat @ ( zero_zero @ nat ) @ ( divide_divide @ nat @ ( suc @ N ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ).

% Suc_n_div_2_gt_zero
thf(fact_2815_binomial__less__binomial__Suc,axiom,
    ! [K: nat,N: nat] :
      ( ( ord_less @ nat @ K @ ( divide_divide @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
     => ( ord_less @ nat @ ( binomial @ N @ K ) @ ( binomial @ N @ ( suc @ K ) ) ) ) ).

% binomial_less_binomial_Suc
thf(fact_2816_central__binomial__odd,axiom,
    ! [N: nat] :
      ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
     => ( ( binomial @ N @ ( suc @ ( divide_divide @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
        = ( binomial @ N @ ( divide_divide @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% central_binomial_odd
thf(fact_2817_binomial__addition__formula,axiom,
    ! [N: nat,K: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( binomial @ N @ ( suc @ K ) )
        = ( plus_plus @ nat @ ( binomial @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) @ ( suc @ K ) ) @ ( binomial @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) @ K ) ) ) ) ).

% binomial_addition_formula
thf(fact_2818_take__bit__Suc__minus__bit0,axiom,
    ! [N: nat,K: num] :
      ( ( bit_se2584673776208193580ke_bit @ int @ ( suc @ N ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit0 @ K ) ) ) )
      = ( times_times @ int @ ( bit_se2584673776208193580ke_bit @ int @ N @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ K ) ) ) @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ).

% take_bit_Suc_minus_bit0
thf(fact_2819_take__bit__numeral__bit0,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [L: num,K: num] :
          ( ( bit_se2584673776208193580ke_bit @ A @ ( numeral_numeral @ nat @ L ) @ ( numeral_numeral @ A @ ( bit0 @ K ) ) )
          = ( times_times @ A @ ( bit_se2584673776208193580ke_bit @ A @ ( pred_numeral @ L ) @ ( numeral_numeral @ A @ K ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% take_bit_numeral_bit0
thf(fact_2820_nat__intermed__int__val,axiom,
    ! [M: nat,N: nat,F2: nat > int,K: int] :
      ( ! [I2: nat] :
          ( ( ( ord_less_eq @ nat @ M @ I2 )
            & ( ord_less @ nat @ I2 @ N ) )
         => ( ord_less_eq @ int @ ( abs_abs @ int @ ( minus_minus @ int @ ( F2 @ ( suc @ I2 ) ) @ ( F2 @ I2 ) ) ) @ ( one_one @ int ) ) )
     => ( ( ord_less_eq @ nat @ M @ N )
       => ( ( ord_less_eq @ int @ ( F2 @ M ) @ K )
         => ( ( ord_less_eq @ int @ K @ ( F2 @ N ) )
           => ? [I2: nat] :
                ( ( ord_less_eq @ nat @ M @ I2 )
                & ( ord_less_eq @ nat @ I2 @ N )
                & ( ( F2 @ I2 )
                  = K ) ) ) ) ) ) ).

% nat_intermed_int_val
thf(fact_2821_odd__0__le__power__imp__0__le,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A,N: nat] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( power_power @ A @ A2 @ ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ) )
         => ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 ) ) ) ).

% odd_0_le_power_imp_0_le
thf(fact_2822_odd__power__less__zero,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A,N: nat] :
          ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
         => ( ord_less @ A @ ( power_power @ A @ A2 @ ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ) @ ( zero_zero @ A ) ) ) ) ).

% odd_power_less_zero
thf(fact_2823_power__minus1__odd,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [N: nat] :
          ( ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) )
          = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% power_minus1_odd
thf(fact_2824_nat__ivt__aux,axiom,
    ! [N: nat,F2: nat > int,K: int] :
      ( ! [I2: nat] :
          ( ( ord_less @ nat @ I2 @ N )
         => ( ord_less_eq @ int @ ( abs_abs @ int @ ( minus_minus @ int @ ( F2 @ ( suc @ I2 ) ) @ ( F2 @ I2 ) ) ) @ ( one_one @ int ) ) )
     => ( ( ord_less_eq @ int @ ( F2 @ ( zero_zero @ nat ) ) @ K )
       => ( ( ord_less_eq @ int @ K @ ( F2 @ N ) )
         => ? [I2: nat] :
              ( ( ord_less_eq @ nat @ I2 @ N )
              & ( ( F2 @ I2 )
                = K ) ) ) ) ) ).

% nat_ivt_aux
thf(fact_2825_int__power__div__base,axiom,
    ! [M: nat,K: int] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M )
     => ( ( ord_less @ int @ ( zero_zero @ int ) @ K )
       => ( ( divide_divide @ int @ ( power_power @ int @ K @ M ) @ K )
          = ( power_power @ int @ K @ ( minus_minus @ nat @ M @ ( suc @ ( zero_zero @ nat ) ) ) ) ) ) ) ).

% int_power_div_base
thf(fact_2826_signed__take__bit__int__less__eq,axiom,
    ! [N: nat,K: int] :
      ( ( ord_less_eq @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) @ K )
     => ( ord_less_eq @ int @ ( bit_ri4674362597316999326ke_bit @ int @ N @ K ) @ ( minus_minus @ int @ K @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( suc @ N ) ) ) ) ) ).

% signed_take_bit_int_less_eq
thf(fact_2827_take__bit__numeral__minus__bit0,axiom,
    ! [L: num,K: num] :
      ( ( bit_se2584673776208193580ke_bit @ int @ ( numeral_numeral @ nat @ L ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit0 @ K ) ) ) )
      = ( times_times @ int @ ( bit_se2584673776208193580ke_bit @ int @ ( pred_numeral @ L ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ K ) ) ) @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ).

% take_bit_numeral_minus_bit0
thf(fact_2828_take__bit__Suc__minus__1__eq,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N: nat] :
          ( ( bit_se2584673776208193580ke_bit @ A @ ( suc @ N ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( minus_minus @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( suc @ N ) ) @ ( one_one @ A ) ) ) ) ).

% take_bit_Suc_minus_1_eq
thf(fact_2829_take__bit__Suc__bit1,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [N: nat,K: num] :
          ( ( bit_se2584673776208193580ke_bit @ A @ ( suc @ N ) @ ( numeral_numeral @ A @ ( bit1 @ K ) ) )
          = ( plus_plus @ A @ ( times_times @ A @ ( bit_se2584673776208193580ke_bit @ A @ N @ ( numeral_numeral @ A @ K ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( one_one @ A ) ) ) ) ).

% take_bit_Suc_bit1
thf(fact_2830_take__bit__Suc,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,A2: A] :
          ( ( bit_se2584673776208193580ke_bit @ A @ ( suc @ N ) @ A2 )
          = ( plus_plus @ A @ ( times_times @ A @ ( bit_se2584673776208193580ke_bit @ A @ N @ ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ).

% take_bit_Suc
thf(fact_2831_signed__take__bit__Suc,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N: nat,A2: A] :
          ( ( bit_ri4674362597316999326ke_bit @ A @ ( suc @ N ) @ A2 )
          = ( plus_plus @ A @ ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_ri4674362597316999326ke_bit @ A @ N @ ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% signed_take_bit_Suc
thf(fact_2832_unset__bit__Suc,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,A2: A] :
          ( ( bit_se2638667681897837118et_bit @ A @ ( suc @ N ) @ A2 )
          = ( plus_plus @ A @ ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se2638667681897837118et_bit @ A @ N @ ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% unset_bit_Suc
thf(fact_2833_set__bit__Suc,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,A2: A] :
          ( ( bit_se5668285175392031749et_bit @ A @ ( suc @ N ) @ A2 )
          = ( plus_plus @ A @ ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se5668285175392031749et_bit @ A @ N @ ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% set_bit_Suc
thf(fact_2834_even__mod__4__div__2,axiom,
    ! [N: nat] :
      ( ( ( modulo_modulo @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ ( bit0 @ one2 ) ) ) )
        = ( suc @ ( zero_zero @ nat ) ) )
     => ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( divide_divide @ nat @ ( minus_minus @ nat @ N @ ( suc @ ( zero_zero @ nat ) ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ).

% even_mod_4_div_2
thf(fact_2835_signed__take__bit__eq__take__bit__shift,axiom,
    ( ( bit_ri4674362597316999326ke_bit @ int )
    = ( ^ [N3: nat,K3: int] : ( minus_minus @ int @ ( bit_se2584673776208193580ke_bit @ int @ ( suc @ N3 ) @ ( plus_plus @ int @ K3 @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N3 ) ) ) @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N3 ) ) ) ) ).

% signed_take_bit_eq_take_bit_shift
thf(fact_2836_odd__mod__4__div__2,axiom,
    ! [N: nat] :
      ( ( ( modulo_modulo @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ ( bit0 @ one2 ) ) ) )
        = ( numeral_numeral @ nat @ ( bit1 @ one2 ) ) )
     => ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( divide_divide @ nat @ ( minus_minus @ nat @ N @ ( suc @ ( zero_zero @ nat ) ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ).

% odd_mod_4_div_2
thf(fact_2837_take__bit__numeral__bit1,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [L: num,K: num] :
          ( ( bit_se2584673776208193580ke_bit @ A @ ( numeral_numeral @ nat @ L ) @ ( numeral_numeral @ A @ ( bit1 @ K ) ) )
          = ( plus_plus @ A @ ( times_times @ A @ ( bit_se2584673776208193580ke_bit @ A @ ( pred_numeral @ L ) @ ( numeral_numeral @ A @ K ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( one_one @ A ) ) ) ) ).

% take_bit_numeral_bit1
thf(fact_2838_signed__take__bit__int__greater__eq,axiom,
    ! [K: int,N: nat] :
      ( ( ord_less @ int @ K @ ( uminus_uminus @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) ) )
     => ( ord_less_eq @ int @ ( plus_plus @ int @ K @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( suc @ N ) ) ) @ ( bit_ri4674362597316999326ke_bit @ int @ N @ K ) ) ) ).

% signed_take_bit_int_greater_eq
thf(fact_2839_sin__coeff__def,axiom,
    ( sin_coeff
    = ( ^ [N3: nat] : ( if @ real @ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N3 ) @ ( zero_zero @ real ) @ ( divide_divide @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ ( divide_divide @ nat @ ( minus_minus @ nat @ N3 @ ( suc @ ( zero_zero @ nat ) ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( semiring_char_0_fact @ real @ N3 ) ) ) ) ) ).

% sin_coeff_def
thf(fact_2840_lemma__termdiff3,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [H2: A,Z: A,K6: real,N: nat] :
          ( ( H2
           != ( zero_zero @ A ) )
         => ( ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ Z ) @ K6 )
           => ( ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( plus_plus @ A @ Z @ H2 ) ) @ K6 )
             => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ ( divide_divide @ A @ ( minus_minus @ A @ ( power_power @ A @ ( plus_plus @ A @ Z @ H2 ) @ N ) @ ( power_power @ A @ Z @ N ) ) @ H2 ) @ ( times_times @ A @ ( semiring_1_of_nat @ A @ N ) @ ( power_power @ A @ Z @ ( minus_minus @ nat @ N @ ( suc @ ( zero_zero @ nat ) ) ) ) ) ) ) @ ( times_times @ real @ ( times_times @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N ) @ ( semiring_1_of_nat @ real @ ( minus_minus @ nat @ N @ ( suc @ ( zero_zero @ nat ) ) ) ) ) @ ( power_power @ real @ K6 @ ( minus_minus @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( real_V7770717601297561774m_norm @ A @ H2 ) ) ) ) ) ) ) ).

% lemma_termdiff3
thf(fact_2841_take__bit__numeral__minus__bit1,axiom,
    ! [L: num,K: num] :
      ( ( bit_se2584673776208193580ke_bit @ int @ ( numeral_numeral @ nat @ L ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit1 @ K ) ) ) )
      = ( plus_plus @ int @ ( times_times @ int @ ( bit_se2584673776208193580ke_bit @ int @ ( pred_numeral @ L ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( inc @ K ) ) ) ) @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( one_one @ int ) ) ) ).

% take_bit_numeral_minus_bit1
thf(fact_2842_flip__bit__Suc,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,A2: A] :
          ( ( bit_se8732182000553998342ip_bit @ A @ ( suc @ N ) @ A2 )
          = ( plus_plus @ A @ ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se8732182000553998342ip_bit @ A @ N @ ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% flip_bit_Suc
thf(fact_2843_Suc__if__eq,axiom,
    ! [A: $tType,F2: nat > A,H2: nat > A,G: A,N: nat] :
      ( ! [N2: nat] :
          ( ( F2 @ ( suc @ N2 ) )
          = ( H2 @ N2 ) )
     => ( ( ( F2 @ ( zero_zero @ nat ) )
          = G )
       => ( ( ( N
              = ( zero_zero @ nat ) )
           => ( ( F2 @ N )
              = G ) )
          & ( ( N
             != ( zero_zero @ nat ) )
           => ( ( F2 @ N )
              = ( H2 @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) ) ) ) ) ) ) ).

% Suc_if_eq
thf(fact_2844_take__bit__Suc__minus__bit1,axiom,
    ! [N: nat,K: num] :
      ( ( bit_se2584673776208193580ke_bit @ int @ ( suc @ N ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit1 @ K ) ) ) )
      = ( plus_plus @ int @ ( times_times @ int @ ( bit_se2584673776208193580ke_bit @ int @ N @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( inc @ K ) ) ) ) @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( one_one @ int ) ) ) ).

% take_bit_Suc_minus_bit1
thf(fact_2845_flip__bit__nonnegative__int__iff,axiom,
    ! [N: nat,K: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( bit_se8732182000553998342ip_bit @ int @ N @ K ) )
      = ( ord_less_eq @ int @ ( zero_zero @ int ) @ K ) ) ).

% flip_bit_nonnegative_int_iff
thf(fact_2846_flip__bit__negative__int__iff,axiom,
    ! [N: nat,K: int] :
      ( ( ord_less @ int @ ( bit_se8732182000553998342ip_bit @ int @ N @ K ) @ ( zero_zero @ int ) )
      = ( ord_less @ int @ K @ ( zero_zero @ int ) ) ) ).

% flip_bit_negative_int_iff
thf(fact_2847_norm__zero,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ( ( real_V7770717601297561774m_norm @ A @ ( zero_zero @ A ) )
        = ( zero_zero @ real ) ) ) ).

% norm_zero
thf(fact_2848_norm__eq__zero,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X: A] :
          ( ( ( real_V7770717601297561774m_norm @ A @ X )
            = ( zero_zero @ real ) )
          = ( X
            = ( zero_zero @ A ) ) ) ) ).

% norm_eq_zero
thf(fact_2849_norm__numeral,axiom,
    ! [A: $tType] :
      ( ( real_V2822296259951069270ebra_1 @ A )
     => ! [W: num] :
          ( ( real_V7770717601297561774m_norm @ A @ ( numeral_numeral @ A @ W ) )
          = ( numeral_numeral @ real @ W ) ) ) ).

% norm_numeral
thf(fact_2850_norm__of__nat,axiom,
    ! [A: $tType] :
      ( ( real_V2822296259951069270ebra_1 @ A )
     => ! [N: nat] :
          ( ( real_V7770717601297561774m_norm @ A @ ( semiring_1_of_nat @ A @ N ) )
          = ( semiring_1_of_nat @ real @ N ) ) ) ).

% norm_of_nat
thf(fact_2851_sin__coeff__0,axiom,
    ( ( sin_coeff @ ( zero_zero @ nat ) )
    = ( zero_zero @ real ) ) ).

% sin_coeff_0
thf(fact_2852_pred__numeral__inc,axiom,
    ! [K: num] :
      ( ( pred_numeral @ ( inc @ K ) )
      = ( numeral_numeral @ nat @ K ) ) ).

% pred_numeral_inc
thf(fact_2853_zero__less__norm__iff,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X: A] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ ( real_V7770717601297561774m_norm @ A @ X ) )
          = ( ( X
             != ( zero_zero @ A ) ) ) ) ) ).

% zero_less_norm_iff
thf(fact_2854_norm__le__zero__iff,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X: A] :
          ( ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ X ) @ ( zero_zero @ real ) )
          = ( X
            = ( zero_zero @ A ) ) ) ) ).

% norm_le_zero_iff
thf(fact_2855_norm__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( real_V2822296259951069270ebra_1 @ A )
     => ! [W: num] :
          ( ( real_V7770717601297561774m_norm @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) )
          = ( numeral_numeral @ real @ W ) ) ) ).

% norm_neg_numeral
thf(fact_2856_minus__not__numeral__eq,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N: num] :
          ( ( uminus_uminus @ A @ ( bit_ri4277139882892585799ns_not @ A @ ( numeral_numeral @ A @ N ) ) )
          = ( numeral_numeral @ A @ ( inc @ N ) ) ) ) ).

% minus_not_numeral_eq
thf(fact_2857_norm__mult__numeral2,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [A2: A,W: num] :
          ( ( real_V7770717601297561774m_norm @ A @ ( times_times @ A @ A2 @ ( numeral_numeral @ A @ W ) ) )
          = ( times_times @ real @ ( real_V7770717601297561774m_norm @ A @ A2 ) @ ( numeral_numeral @ real @ W ) ) ) ) ).

% norm_mult_numeral2
thf(fact_2858_norm__mult__numeral1,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [W: num,A2: A] :
          ( ( real_V7770717601297561774m_norm @ A @ ( times_times @ A @ ( numeral_numeral @ A @ W ) @ A2 ) )
          = ( times_times @ real @ ( numeral_numeral @ real @ W ) @ ( real_V7770717601297561774m_norm @ A @ A2 ) ) ) ) ).

% norm_mult_numeral1
thf(fact_2859_norm__divide__numeral,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [A2: A,W: num] :
          ( ( real_V7770717601297561774m_norm @ A @ ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ W ) ) )
          = ( divide_divide @ real @ ( real_V7770717601297561774m_norm @ A @ A2 ) @ ( numeral_numeral @ real @ W ) ) ) ) ).

% norm_divide_numeral
thf(fact_2860_add__neg__numeral__special_I5_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [N: num] :
          ( ( plus_plus @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) )
          = ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( inc @ N ) ) ) ) ) ).

% add_neg_numeral_special(5)
thf(fact_2861_add__neg__numeral__special_I6_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [M: num] :
          ( ( plus_plus @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( inc @ M ) ) ) ) ) ).

% add_neg_numeral_special(6)
thf(fact_2862_diff__numeral__special_I5_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [N: num] :
          ( ( minus_minus @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( numeral_numeral @ A @ N ) )
          = ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( inc @ N ) ) ) ) ) ).

% diff_numeral_special(5)
thf(fact_2863_diff__numeral__special_I6_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [M: num] :
          ( ( minus_minus @ A @ ( numeral_numeral @ A @ M ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( numeral_numeral @ A @ ( inc @ M ) ) ) ) ).

% diff_numeral_special(6)
thf(fact_2864_norm__of__real__addn,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [X: real,B2: num] :
          ( ( real_V7770717601297561774m_norm @ A @ ( plus_plus @ A @ ( real_Vector_of_real @ A @ X ) @ ( numeral_numeral @ A @ B2 ) ) )
          = ( abs_abs @ real @ ( plus_plus @ real @ X @ ( numeral_numeral @ real @ B2 ) ) ) ) ) ).

% norm_of_real_addn
thf(fact_2865_num__induct,axiom,
    ! [P: num > $o,X: num] :
      ( ( P @ one2 )
     => ( ! [X3: num] :
            ( ( P @ X3 )
           => ( P @ ( inc @ X3 ) ) )
       => ( P @ X ) ) ) ).

% num_induct
thf(fact_2866_add__inc,axiom,
    ! [X: num,Y: num] :
      ( ( plus_plus @ num @ X @ ( inc @ Y ) )
      = ( inc @ ( plus_plus @ num @ X @ Y ) ) ) ).

% add_inc
thf(fact_2867_norm__not__less__zero,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X: A] :
          ~ ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ X ) @ ( zero_zero @ real ) ) ) ).

% norm_not_less_zero
thf(fact_2868_norm__ge__zero,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X: A] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( real_V7770717601297561774m_norm @ A @ X ) ) ) ).

% norm_ge_zero
thf(fact_2869_norm__power,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [X: A,N: nat] :
          ( ( real_V7770717601297561774m_norm @ A @ ( power_power @ A @ X @ N ) )
          = ( power_power @ real @ ( real_V7770717601297561774m_norm @ A @ X ) @ N ) ) ) ).

% norm_power
thf(fact_2870_complex__mod__minus__le__complex__mod,axiom,
    ! [X: complex] : ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( real_V7770717601297561774m_norm @ complex @ X ) ) @ ( real_V7770717601297561774m_norm @ complex @ X ) ) ).

% complex_mod_minus_le_complex_mod
thf(fact_2871_complex__mod__triangle__ineq2,axiom,
    ! [B2: complex,A2: complex] : ( ord_less_eq @ real @ ( minus_minus @ real @ ( real_V7770717601297561774m_norm @ complex @ ( plus_plus @ complex @ B2 @ A2 ) ) @ ( real_V7770717601297561774m_norm @ complex @ B2 ) ) @ ( real_V7770717601297561774m_norm @ complex @ A2 ) ) ).

% complex_mod_triangle_ineq2
thf(fact_2872_inc_Osimps_I1_J,axiom,
    ( ( inc @ one2 )
    = ( bit0 @ one2 ) ) ).

% inc.simps(1)
thf(fact_2873_inc_Osimps_I2_J,axiom,
    ! [X: num] :
      ( ( inc @ ( bit0 @ X ) )
      = ( bit1 @ X ) ) ).

% inc.simps(2)
thf(fact_2874_inc_Osimps_I3_J,axiom,
    ! [X: num] :
      ( ( inc @ ( bit1 @ X ) )
      = ( bit0 @ ( inc @ X ) ) ) ).

% inc.simps(3)
thf(fact_2875_add__One,axiom,
    ! [X: num] :
      ( ( plus_plus @ num @ X @ one2 )
      = ( inc @ X ) ) ).

% add_One
thf(fact_2876_nonzero__norm__divide,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [B2: A,A2: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( real_V7770717601297561774m_norm @ A @ ( divide_divide @ A @ A2 @ B2 ) )
            = ( divide_divide @ real @ ( real_V7770717601297561774m_norm @ A @ A2 ) @ ( real_V7770717601297561774m_norm @ A @ B2 ) ) ) ) ) ).

% nonzero_norm_divide
thf(fact_2877_power__eq__imp__eq__norm,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [W: A,N: nat,Z: A] :
          ( ( ( power_power @ A @ W @ N )
            = ( power_power @ A @ Z @ N ) )
         => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
           => ( ( real_V7770717601297561774m_norm @ A @ W )
              = ( real_V7770717601297561774m_norm @ A @ Z ) ) ) ) ) ).

% power_eq_imp_eq_norm
thf(fact_2878_norm__mult__less,axiom,
    ! [A: $tType] :
      ( ( real_V4412858255891104859lgebra @ A )
     => ! [X: A,R2: real,Y: A,S2: real] :
          ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ X ) @ R2 )
         => ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ Y ) @ S2 )
           => ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( times_times @ A @ X @ Y ) ) @ ( times_times @ real @ R2 @ S2 ) ) ) ) ) ).

% norm_mult_less
thf(fact_2879_norm__mult__ineq,axiom,
    ! [A: $tType] :
      ( ( real_V4412858255891104859lgebra @ A )
     => ! [X: A,Y: A] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( times_times @ A @ X @ Y ) ) @ ( times_times @ real @ ( real_V7770717601297561774m_norm @ A @ X ) @ ( real_V7770717601297561774m_norm @ A @ Y ) ) ) ) ).

% norm_mult_ineq
thf(fact_2880_norm__add__less,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X: A,R2: real,Y: A,S2: real] :
          ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ X ) @ R2 )
         => ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ Y ) @ S2 )
           => ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( plus_plus @ A @ X @ Y ) ) @ ( plus_plus @ real @ R2 @ S2 ) ) ) ) ) ).

% norm_add_less
thf(fact_2881_norm__triangle__lt,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X: A,Y: A,E2: real] :
          ( ( ord_less @ real @ ( plus_plus @ real @ ( real_V7770717601297561774m_norm @ A @ X ) @ ( real_V7770717601297561774m_norm @ A @ Y ) ) @ E2 )
         => ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( plus_plus @ A @ X @ Y ) ) @ E2 ) ) ) ).

% norm_triangle_lt
thf(fact_2882_norm__triangle__mono,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [A2: A,R2: real,B2: A,S2: real] :
          ( ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ A2 ) @ R2 )
         => ( ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ B2 ) @ S2 )
           => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( plus_plus @ A @ A2 @ B2 ) ) @ ( plus_plus @ real @ R2 @ S2 ) ) ) ) ) ).

% norm_triangle_mono
thf(fact_2883_norm__triangle__ineq,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X: A,Y: A] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( plus_plus @ A @ X @ Y ) ) @ ( plus_plus @ real @ ( real_V7770717601297561774m_norm @ A @ X ) @ ( real_V7770717601297561774m_norm @ A @ Y ) ) ) ) ).

% norm_triangle_ineq
thf(fact_2884_norm__triangle__le,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X: A,Y: A,E2: real] :
          ( ( ord_less_eq @ real @ ( plus_plus @ real @ ( real_V7770717601297561774m_norm @ A @ X ) @ ( real_V7770717601297561774m_norm @ A @ Y ) ) @ E2 )
         => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( plus_plus @ A @ X @ Y ) ) @ E2 ) ) ) ).

% norm_triangle_le
thf(fact_2885_norm__add__leD,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [A2: A,B2: A,C2: real] :
          ( ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( plus_plus @ A @ A2 @ B2 ) ) @ C2 )
         => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ B2 ) @ ( plus_plus @ real @ ( real_V7770717601297561774m_norm @ A @ A2 ) @ C2 ) ) ) ) ).

% norm_add_leD
thf(fact_2886_norm__power__ineq,axiom,
    ! [A: $tType] :
      ( ( real_V2822296259951069270ebra_1 @ A )
     => ! [X: A,N: nat] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( power_power @ A @ X @ N ) ) @ ( power_power @ real @ ( real_V7770717601297561774m_norm @ A @ X ) @ N ) ) ) ).

% norm_power_ineq
thf(fact_2887_norm__diff__triangle__less,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X: A,Y: A,E1: real,Z: A,E22: real] :
          ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ X @ Y ) ) @ E1 )
         => ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ Y @ Z ) ) @ E22 )
           => ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ X @ Z ) ) @ ( plus_plus @ real @ E1 @ E22 ) ) ) ) ) ).

% norm_diff_triangle_less
thf(fact_2888_norm__triangle__le__diff,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X: A,Y: A,E2: real] :
          ( ( ord_less_eq @ real @ ( plus_plus @ real @ ( real_V7770717601297561774m_norm @ A @ X ) @ ( real_V7770717601297561774m_norm @ A @ Y ) ) @ E2 )
         => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ X @ Y ) ) @ E2 ) ) ) ).

% norm_triangle_le_diff
thf(fact_2889_norm__diff__triangle__le,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X: A,Y: A,E1: real,Z: A,E22: real] :
          ( ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ X @ Y ) ) @ E1 )
         => ( ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ Y @ Z ) ) @ E22 )
           => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ X @ Z ) ) @ ( plus_plus @ real @ E1 @ E22 ) ) ) ) ) ).

% norm_diff_triangle_le
thf(fact_2890_norm__triangle__ineq4,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [A2: A,B2: A] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ A2 @ B2 ) ) @ ( plus_plus @ real @ ( real_V7770717601297561774m_norm @ A @ A2 ) @ ( real_V7770717601297561774m_norm @ A @ B2 ) ) ) ) ).

% norm_triangle_ineq4
thf(fact_2891_norm__triangle__sub,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X: A,Y: A] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ X ) @ ( plus_plus @ real @ ( real_V7770717601297561774m_norm @ A @ Y ) @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ X @ Y ) ) ) ) ) ).

% norm_triangle_sub
thf(fact_2892_norm__diff__ineq,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [A2: A,B2: A] : ( ord_less_eq @ real @ ( minus_minus @ real @ ( real_V7770717601297561774m_norm @ A @ A2 ) @ ( real_V7770717601297561774m_norm @ A @ B2 ) ) @ ( real_V7770717601297561774m_norm @ A @ ( plus_plus @ A @ A2 @ B2 ) ) ) ) ).

% norm_diff_ineq
thf(fact_2893_norm__triangle__ineq2,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [A2: A,B2: A] : ( ord_less_eq @ real @ ( minus_minus @ real @ ( real_V7770717601297561774m_norm @ A @ A2 ) @ ( real_V7770717601297561774m_norm @ A @ B2 ) ) @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ A2 @ B2 ) ) ) ) ).

% norm_triangle_ineq2
thf(fact_2894_mult__inc,axiom,
    ! [X: num,Y: num] :
      ( ( times_times @ num @ X @ ( inc @ Y ) )
      = ( plus_plus @ num @ ( times_times @ num @ X @ Y ) @ X ) ) ).

% mult_inc
thf(fact_2895_norm__exp,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [X: A] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( exp @ A @ X ) ) @ ( exp @ real @ ( real_V7770717601297561774m_norm @ A @ X ) ) ) ) ).

% norm_exp
thf(fact_2896_numeral__inc,axiom,
    ! [A: $tType] :
      ( ( numeral @ A )
     => ! [X: num] :
          ( ( numeral_numeral @ A @ ( inc @ X ) )
          = ( plus_plus @ A @ ( numeral_numeral @ A @ X ) @ ( one_one @ A ) ) ) ) ).

% numeral_inc
thf(fact_2897_power__eq__1__iff,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [W: A,N: nat] :
          ( ( ( power_power @ A @ W @ N )
            = ( one_one @ A ) )
         => ( ( ( real_V7770717601297561774m_norm @ A @ W )
              = ( one_one @ real ) )
            | ( N
              = ( zero_zero @ nat ) ) ) ) ) ).

% power_eq_1_iff
thf(fact_2898_norm__diff__triangle__ineq,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ ( plus_plus @ A @ A2 @ B2 ) @ ( plus_plus @ A @ C2 @ D2 ) ) ) @ ( plus_plus @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ A2 @ C2 ) ) @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ B2 @ D2 ) ) ) ) ) ).

% norm_diff_triangle_ineq
thf(fact_2899_norm__less__p1,axiom,
    ! [A: $tType] :
      ( ( real_V2822296259951069270ebra_1 @ A )
     => ! [X: A] : ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ X ) @ ( real_V7770717601297561774m_norm @ A @ ( plus_plus @ A @ ( real_Vector_of_real @ A @ ( real_V7770717601297561774m_norm @ A @ X ) ) @ ( one_one @ A ) ) ) ) ) ).

% norm_less_p1
thf(fact_2900_minus__numeral__inc__eq,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N: num] :
          ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( inc @ N ) ) )
          = ( bit_ri4277139882892585799ns_not @ A @ ( numeral_numeral @ A @ N ) ) ) ) ).

% minus_numeral_inc_eq
thf(fact_2901_norm__triangle__ineq3,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [A2: A,B2: A] : ( ord_less_eq @ real @ ( abs_abs @ real @ ( minus_minus @ real @ ( real_V7770717601297561774m_norm @ A @ A2 ) @ ( real_V7770717601297561774m_norm @ A @ B2 ) ) ) @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ A2 @ B2 ) ) ) ) ).

% norm_triangle_ineq3
thf(fact_2902_take__bit__flip__bit__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,M: nat,A2: A] :
          ( ( ( ord_less_eq @ nat @ N @ M )
           => ( ( bit_se2584673776208193580ke_bit @ A @ N @ ( bit_se8732182000553998342ip_bit @ A @ M @ A2 ) )
              = ( bit_se2584673776208193580ke_bit @ A @ N @ A2 ) ) )
          & ( ~ ( ord_less_eq @ nat @ N @ M )
           => ( ( bit_se2584673776208193580ke_bit @ A @ N @ ( bit_se8732182000553998342ip_bit @ A @ M @ A2 ) )
              = ( bit_se8732182000553998342ip_bit @ A @ M @ ( bit_se2584673776208193580ke_bit @ A @ N @ A2 ) ) ) ) ) ) ).

% take_bit_flip_bit_eq
thf(fact_2903_lemma__NBseq__def,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V822414075346904944vector @ B )
     => ! [X7: A > B] :
          ( ( ? [K7: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ K7 )
                & ! [N3: A] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ B @ ( X7 @ N3 ) ) @ K7 ) ) )
          = ( ? [N6: nat] :
              ! [N3: A] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ B @ ( X7 @ N3 ) ) @ ( semiring_1_of_nat @ real @ ( suc @ N6 ) ) ) ) ) ) ).

% lemma_NBseq_def
thf(fact_2904_lemma__NBseq__def2,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V822414075346904944vector @ B )
     => ! [X7: A > B] :
          ( ( ? [K7: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ K7 )
                & ! [N3: A] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ B @ ( X7 @ N3 ) ) @ K7 ) ) )
          = ( ? [N6: nat] :
              ! [N3: A] : ( ord_less @ real @ ( real_V7770717601297561774m_norm @ B @ ( X7 @ N3 ) ) @ ( semiring_1_of_nat @ real @ ( suc @ N6 ) ) ) ) ) ) ).

% lemma_NBseq_def2
thf(fact_2905_norm__of__real__diff,axiom,
    ! [A: $tType] :
      ( ( real_V2822296259951069270ebra_1 @ A )
     => ! [B2: real,A2: real] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ ( real_Vector_of_real @ A @ B2 ) @ ( real_Vector_of_real @ A @ A2 ) ) ) @ ( abs_abs @ real @ ( minus_minus @ real @ B2 @ A2 ) ) ) ) ).

% norm_of_real_diff
thf(fact_2906_square__norm__one,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [X: A] :
          ( ( ( power_power @ A @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
            = ( one_one @ A ) )
         => ( ( real_V7770717601297561774m_norm @ A @ X )
            = ( one_one @ real ) ) ) ) ).

% square_norm_one
thf(fact_2907_norm__power__diff,axiom,
    ! [A: $tType] :
      ( ( ( comm_monoid_mult @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [Z: A,W: A,M: nat] :
          ( ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ Z ) @ ( one_one @ real ) )
         => ( ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ W ) @ ( one_one @ real ) )
           => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ ( power_power @ A @ Z @ M ) @ ( power_power @ A @ W @ M ) ) ) @ ( times_times @ real @ ( semiring_1_of_nat @ real @ M ) @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ Z @ W ) ) ) ) ) ) ) ).

% norm_power_diff
thf(fact_2908_exp__bound__half,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [Z: A] :
          ( ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ Z ) @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
         => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( exp @ A @ Z ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ).

% exp_bound_half
thf(fact_2909_sin__coeff__Suc,axiom,
    ! [N: nat] :
      ( ( sin_coeff @ ( suc @ N ) )
      = ( divide_divide @ real @ ( cos_coeff @ N ) @ ( semiring_1_of_nat @ real @ ( suc @ N ) ) ) ) ).

% sin_coeff_Suc
thf(fact_2910_cos__coeff__Suc,axiom,
    ! [N: nat] :
      ( ( cos_coeff @ ( suc @ N ) )
      = ( divide_divide @ real @ ( uminus_uminus @ real @ ( sin_coeff @ N ) ) @ ( semiring_1_of_nat @ real @ ( suc @ N ) ) ) ) ).

% cos_coeff_Suc
thf(fact_2911_exp__bound__lemma,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [Z: A] :
          ( ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ Z ) @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
         => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( exp @ A @ Z ) ) @ ( plus_plus @ real @ ( one_one @ real ) @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( real_V7770717601297561774m_norm @ A @ Z ) ) ) ) ) ) ).

% exp_bound_lemma
thf(fact_2912_even__flip__bit__iff,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M: nat,A2: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se8732182000553998342ip_bit @ A @ M @ A2 ) )
          = ( ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
             != ( M
                = ( zero_zero @ nat ) ) ) ) ) ) ).

% even_flip_bit_iff
thf(fact_2913_triangle__def,axiom,
    ( nat_triangle
    = ( ^ [N3: nat] : ( divide_divide @ nat @ ( times_times @ nat @ N3 @ ( suc @ N3 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ).

% triangle_def
thf(fact_2914_concat__bit__Suc,axiom,
    ! [N: nat,K: int,L: int] :
      ( ( bit_concat_bit @ ( suc @ N ) @ K @ L )
      = ( plus_plus @ int @ ( modulo_modulo @ int @ K @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_concat_bit @ N @ ( divide_divide @ int @ K @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ L ) ) ) ) ).

% concat_bit_Suc
thf(fact_2915_flip__bit__0,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A] :
          ( ( bit_se8732182000553998342ip_bit @ A @ ( zero_zero @ nat ) @ A2 )
          = ( plus_plus @ A @ ( zero_neq_one_of_bool @ A @ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% flip_bit_0
thf(fact_2916_bit_Oabstract__boolean__algebra__sym__diff__axioms,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( boolea3799213064322606851m_diff @ A @ ( bit_se5824344872417868541ns_and @ A ) @ ( bit_se1065995026697491101ons_or @ A ) @ ( bit_ri4277139882892585799ns_not @ A ) @ ( zero_zero @ A ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( bit_se5824344971392196577ns_xor @ A ) ) ) ).

% bit.abstract_boolean_algebra_sym_diff_axioms
thf(fact_2917_mask__numeral,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: num] :
          ( ( bit_se2239418461657761734s_mask @ A @ ( numeral_numeral @ nat @ N ) )
          = ( plus_plus @ A @ ( one_one @ A ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se2239418461657761734s_mask @ A @ ( pred_numeral @ N ) ) ) ) ) ) ).

% mask_numeral
thf(fact_2918_nat__of__bool,axiom,
    ! [P: $o] :
      ( ( nat2 @ ( zero_neq_one_of_bool @ int @ P ) )
      = ( zero_neq_one_of_bool @ nat @ P ) ) ).

% nat_of_bool
thf(fact_2919_mask__nat__positive__iff,axiom,
    ! [N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( bit_se2239418461657761734s_mask @ nat @ N ) )
      = ( ord_less @ nat @ ( zero_zero @ nat ) @ N ) ) ).

% mask_nat_positive_iff
thf(fact_2920_of__bool__less__eq__iff,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [P: $o,Q: $o] :
          ( ( ord_less_eq @ A @ ( zero_neq_one_of_bool @ A @ P ) @ ( zero_neq_one_of_bool @ A @ Q ) )
          = ( P
           => Q ) ) ) ).

% of_bool_less_eq_iff
thf(fact_2921_of__bool__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( zero_neq_one @ A )
     => ! [P: $o] :
          ( ( ( zero_neq_one_of_bool @ A @ P )
            = ( zero_zero @ A ) )
          = ( ~ P ) ) ) ).

% of_bool_eq_0_iff
thf(fact_2922_of__bool__eq_I1_J,axiom,
    ! [A: $tType] :
      ( ( zero_neq_one @ A )
     => ( ( zero_neq_one_of_bool @ A @ $false )
        = ( zero_zero @ A ) ) ) ).

% of_bool_eq(1)
thf(fact_2923_of__bool__less__iff,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [P: $o,Q: $o] :
          ( ( ord_less @ A @ ( zero_neq_one_of_bool @ A @ P ) @ ( zero_neq_one_of_bool @ A @ Q ) )
          = ( ~ P
            & Q ) ) ) ).

% of_bool_less_iff
thf(fact_2924_of__nat__of__bool,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [P: $o] :
          ( ( semiring_1_of_nat @ A @ ( zero_neq_one_of_bool @ nat @ P ) )
          = ( zero_neq_one_of_bool @ A @ P ) ) ) ).

% of_nat_of_bool
thf(fact_2925_of__int__of__bool,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [P: $o] :
          ( ( ring_1_of_int @ A @ ( zero_neq_one_of_bool @ int @ P ) )
          = ( zero_neq_one_of_bool @ A @ P ) ) ) ).

% of_int_of_bool
thf(fact_2926_of__bool__or__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [P: $o,Q: $o] :
          ( ( zero_neq_one_of_bool @ A
            @ ( P
              | Q ) )
          = ( ord_max @ A @ ( zero_neq_one_of_bool @ A @ P ) @ ( zero_neq_one_of_bool @ A @ Q ) ) ) ) ).

% of_bool_or_iff
thf(fact_2927_concat__bit__0,axiom,
    ! [K: int,L: int] :
      ( ( bit_concat_bit @ ( zero_zero @ nat ) @ K @ L )
      = L ) ).

% concat_bit_0
thf(fact_2928_triangle__0,axiom,
    ( ( nat_triangle @ ( zero_zero @ nat ) )
    = ( zero_zero @ nat ) ) ).

% triangle_0
thf(fact_2929_zero__less__of__bool__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [P: $o] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( zero_neq_one_of_bool @ A @ P ) )
          = P ) ) ).

% zero_less_of_bool_iff
thf(fact_2930_of__bool__less__one__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [P: $o] :
          ( ( ord_less @ A @ ( zero_neq_one_of_bool @ A @ P ) @ ( one_one @ A ) )
          = ( ~ P ) ) ) ).

% of_bool_less_one_iff
thf(fact_2931_Suc__0__mod__eq,axiom,
    ! [N: nat] :
      ( ( modulo_modulo @ nat @ ( suc @ ( zero_zero @ nat ) ) @ N )
      = ( zero_neq_one_of_bool @ nat
        @ ( N
         != ( suc @ ( zero_zero @ nat ) ) ) ) ) ).

% Suc_0_mod_eq
thf(fact_2932_mask__0,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se2239418461657761734s_mask @ A @ ( zero_zero @ nat ) )
        = ( zero_zero @ A ) ) ) ).

% mask_0
thf(fact_2933_mask__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat] :
          ( ( ( bit_se2239418461657761734s_mask @ A @ N )
            = ( zero_zero @ A ) )
          = ( N
            = ( zero_zero @ nat ) ) ) ) ).

% mask_eq_0_iff
thf(fact_2934_concat__bit__nonnegative__iff,axiom,
    ! [N: nat,K: int,L: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( bit_concat_bit @ N @ K @ L ) )
      = ( ord_less_eq @ int @ ( zero_zero @ int ) @ L ) ) ).

% concat_bit_nonnegative_iff
thf(fact_2935_concat__bit__negative__iff,axiom,
    ! [N: nat,K: int,L: int] :
      ( ( ord_less @ int @ ( bit_concat_bit @ N @ K @ L ) @ ( zero_zero @ int ) )
      = ( ord_less @ int @ L @ ( zero_zero @ int ) ) ) ).

% concat_bit_negative_iff
thf(fact_2936_concat__bit__of__zero__2,axiom,
    ! [N: nat,K: int] :
      ( ( bit_concat_bit @ N @ K @ ( zero_zero @ int ) )
      = ( bit_se2584673776208193580ke_bit @ int @ N @ K ) ) ).

% concat_bit_of_zero_2
thf(fact_2937_mask__Suc__0,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se2239418461657761734s_mask @ A @ ( suc @ ( zero_zero @ nat ) ) )
        = ( one_one @ A ) ) ) ).

% mask_Suc_0
thf(fact_2938_take__bit__minus__one__eq__mask,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N: nat] :
          ( ( bit_se2584673776208193580ke_bit @ A @ N @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( bit_se2239418461657761734s_mask @ A @ N ) ) ) ).

% take_bit_minus_one_eq_mask
thf(fact_2939_take__bit__of__Suc__0,axiom,
    ! [N: nat] :
      ( ( bit_se2584673776208193580ke_bit @ nat @ N @ ( suc @ ( zero_zero @ nat ) ) )
      = ( zero_neq_one_of_bool @ nat @ ( ord_less @ nat @ ( zero_zero @ nat ) @ N ) ) ) ).

% take_bit_of_Suc_0
thf(fact_2940_odd__of__bool__self,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [P6: $o] :
          ( ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( zero_neq_one_of_bool @ A @ P6 ) ) )
          = P6 ) ) ).

% odd_of_bool_self
thf(fact_2941_take__bit__of__1,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat] :
          ( ( bit_se2584673776208193580ke_bit @ A @ N @ ( one_one @ A ) )
          = ( zero_neq_one_of_bool @ A @ ( ord_less @ nat @ ( zero_zero @ nat ) @ N ) ) ) ) ).

% take_bit_of_1
thf(fact_2942_of__bool__half__eq__0,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [B2: $o] :
          ( ( divide_divide @ A @ ( zero_neq_one_of_bool @ A @ B2 ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
          = ( zero_zero @ A ) ) ) ).

% of_bool_half_eq_0
thf(fact_2943_one__div__2__pow__eq,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [N: nat] :
          ( ( divide_divide @ A @ ( one_one @ A ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) )
          = ( zero_neq_one_of_bool @ A
            @ ( N
              = ( zero_zero @ nat ) ) ) ) ) ).

% one_div_2_pow_eq
thf(fact_2944_bits__1__div__exp,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [N: nat] :
          ( ( divide_divide @ A @ ( one_one @ A ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) )
          = ( zero_neq_one_of_bool @ A
            @ ( N
              = ( zero_zero @ nat ) ) ) ) ) ).

% bits_1_div_exp
thf(fact_2945_take__bit__of__exp,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [M: nat,N: nat] :
          ( ( bit_se2584673776208193580ke_bit @ A @ M @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) )
          = ( times_times @ A @ ( zero_neq_one_of_bool @ A @ ( ord_less @ nat @ N @ M ) ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) ) ) ) ).

% take_bit_of_exp
thf(fact_2946_take__bit__of__2,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [N: nat] :
          ( ( bit_se2584673776208193580ke_bit @ A @ N @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
          = ( times_times @ A @ ( zero_neq_one_of_bool @ A @ ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% take_bit_of_2
thf(fact_2947_one__mod__2__pow__eq,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [N: nat] :
          ( ( modulo_modulo @ A @ ( one_one @ A ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) )
          = ( zero_neq_one_of_bool @ A @ ( ord_less @ nat @ ( zero_zero @ nat ) @ N ) ) ) ) ).

% one_mod_2_pow_eq
thf(fact_2948_of__int__mask__eq,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N: nat] :
          ( ( ring_1_of_int @ A @ ( bit_se2239418461657761734s_mask @ int @ N ) )
          = ( bit_se2239418461657761734s_mask @ A @ N ) ) ) ).

% of_int_mask_eq
thf(fact_2949_of__nat__mask__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat] :
          ( ( semiring_1_of_nat @ A @ ( bit_se2239418461657761734s_mask @ nat @ N ) )
          = ( bit_se2239418461657761734s_mask @ A @ N ) ) ) ).

% of_nat_mask_eq
thf(fact_2950_nat__mask__eq,axiom,
    ! [N: nat] :
      ( ( nat2 @ ( bit_se2239418461657761734s_mask @ int @ N ) )
      = ( bit_se2239418461657761734s_mask @ nat @ N ) ) ).

% nat_mask_eq
thf(fact_2951_less__eq__mask,axiom,
    ! [N: nat] : ( ord_less_eq @ nat @ N @ ( bit_se2239418461657761734s_mask @ nat @ N ) ) ).

% less_eq_mask
thf(fact_2952_concat__bit__assoc,axiom,
    ! [N: nat,K: int,M: nat,L: int,R2: int] :
      ( ( bit_concat_bit @ N @ K @ ( bit_concat_bit @ M @ L @ R2 ) )
      = ( bit_concat_bit @ ( plus_plus @ nat @ M @ N ) @ ( bit_concat_bit @ N @ K @ L ) @ R2 ) ) ).

% concat_bit_assoc
thf(fact_2953_concat__bit__eq__iff,axiom,
    ! [N: nat,K: int,L: int,R2: int,S2: int] :
      ( ( ( bit_concat_bit @ N @ K @ L )
        = ( bit_concat_bit @ N @ R2 @ S2 ) )
      = ( ( ( bit_se2584673776208193580ke_bit @ int @ N @ K )
          = ( bit_se2584673776208193580ke_bit @ int @ N @ R2 ) )
        & ( L = S2 ) ) ) ).

% concat_bit_eq_iff
thf(fact_2954_concat__bit__take__bit__eq,axiom,
    ! [N: nat,B2: int] :
      ( ( bit_concat_bit @ N @ ( bit_se2584673776208193580ke_bit @ int @ N @ B2 ) )
      = ( bit_concat_bit @ N @ B2 ) ) ).

% concat_bit_take_bit_eq
thf(fact_2955_zero__less__eq__of__bool,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [P: $o] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( zero_neq_one_of_bool @ A @ P ) ) ) ).

% zero_less_eq_of_bool
thf(fact_2956_of__bool__less__eq__one,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [P: $o] : ( ord_less_eq @ A @ ( zero_neq_one_of_bool @ A @ P ) @ ( one_one @ A ) ) ) ).

% of_bool_less_eq_one
thf(fact_2957_split__of__bool__asm,axiom,
    ! [A: $tType] :
      ( ( zero_neq_one @ A )
     => ! [P: A > $o,P6: $o] :
          ( ( P @ ( zero_neq_one_of_bool @ A @ P6 ) )
          = ( ~ ( ( P6
                  & ~ ( P @ ( one_one @ A ) ) )
                | ( ~ P6
                  & ~ ( P @ ( zero_zero @ A ) ) ) ) ) ) ) ).

% split_of_bool_asm
thf(fact_2958_split__of__bool,axiom,
    ! [A: $tType] :
      ( ( zero_neq_one @ A )
     => ! [P: A > $o,P6: $o] :
          ( ( P @ ( zero_neq_one_of_bool @ A @ P6 ) )
          = ( ( P6
             => ( P @ ( one_one @ A ) ) )
            & ( ~ P6
             => ( P @ ( zero_zero @ A ) ) ) ) ) ) ).

% split_of_bool
thf(fact_2959_of__bool__def,axiom,
    ! [A: $tType] :
      ( ( zero_neq_one @ A )
     => ( ( zero_neq_one_of_bool @ A )
        = ( ^ [P5: $o] : ( if @ A @ P5 @ ( one_one @ A ) @ ( zero_zero @ A ) ) ) ) ) ).

% of_bool_def
thf(fact_2960_mask__nonnegative__int,axiom,
    ! [N: nat] : ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( bit_se2239418461657761734s_mask @ int @ N ) ) ).

% mask_nonnegative_int
thf(fact_2961_not__mask__negative__int,axiom,
    ! [N: nat] :
      ~ ( ord_less @ int @ ( bit_se2239418461657761734s_mask @ int @ N ) @ ( zero_zero @ int ) ) ).

% not_mask_negative_int
thf(fact_2962_take__bit__eq__mask,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se2584673776208193580ke_bit @ A )
        = ( ^ [N3: nat,A3: A] : ( bit_se5824344872417868541ns_and @ A @ A3 @ ( bit_se2239418461657761734s_mask @ A @ N3 ) ) ) ) ) ).

% take_bit_eq_mask
thf(fact_2963_less__mask,axiom,
    ! [N: nat] :
      ( ( ord_less @ nat @ ( suc @ ( zero_zero @ nat ) ) @ N )
     => ( ord_less @ nat @ N @ ( bit_se2239418461657761734s_mask @ nat @ N ) ) ) ).

% less_mask
thf(fact_2964_take__bit__not__eq__mask__diff,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N: nat,A2: A] :
          ( ( bit_se2584673776208193580ke_bit @ A @ N @ ( bit_ri4277139882892585799ns_not @ A @ A2 ) )
          = ( minus_minus @ A @ ( bit_se2239418461657761734s_mask @ A @ N ) @ ( bit_se2584673776208193580ke_bit @ A @ N @ A2 ) ) ) ) ).

% take_bit_not_eq_mask_diff
thf(fact_2965_take__bit__eq__mask__iff,axiom,
    ! [N: nat,K: int] :
      ( ( ( bit_se2584673776208193580ke_bit @ int @ N @ K )
        = ( bit_se2239418461657761734s_mask @ int @ N ) )
      = ( ( bit_se2584673776208193580ke_bit @ int @ N @ ( plus_plus @ int @ K @ ( one_one @ int ) ) )
        = ( zero_zero @ int ) ) ) ).

% take_bit_eq_mask_iff
thf(fact_2966_of__bool__odd__eq__mod__2,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [A2: A] :
          ( ( zero_neq_one_of_bool @ A
            @ ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) )
          = ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% of_bool_odd_eq_mod_2
thf(fact_2967_take__bit__not__mask__eq__0,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [M: nat,N: nat] :
          ( ( ord_less_eq @ nat @ M @ N )
         => ( ( bit_se2584673776208193580ke_bit @ A @ M @ ( bit_ri4277139882892585799ns_not @ A @ ( bit_se2239418461657761734s_mask @ A @ N ) ) )
            = ( zero_zero @ A ) ) ) ) ).

% take_bit_not_mask_eq_0
thf(fact_2968_Suc__mask__eq__exp,axiom,
    ! [N: nat] :
      ( ( suc @ ( bit_se2239418461657761734s_mask @ nat @ N ) )
      = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ).

% Suc_mask_eq_exp
thf(fact_2969_mask__nat__less__exp,axiom,
    ! [N: nat] : ( ord_less @ nat @ ( bit_se2239418461657761734s_mask @ nat @ N ) @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ).

% mask_nat_less_exp
thf(fact_2970_bits__induct,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [P: A > $o,A2: A] :
          ( ! [A5: A] :
              ( ( ( divide_divide @ A @ A5 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
                = A5 )
             => ( P @ A5 ) )
         => ( ! [A5: A,B4: $o] :
                ( ( P @ A5 )
               => ( ( ( divide_divide @ A @ ( plus_plus @ A @ ( zero_neq_one_of_bool @ A @ B4 ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A5 ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
                    = A5 )
                 => ( P @ ( plus_plus @ A @ ( zero_neq_one_of_bool @ A @ B4 ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A5 ) ) ) ) )
           => ( P @ A2 ) ) ) ) ).

% bits_induct
thf(fact_2971_semiring__bit__operations__class_Oeven__mask__iff,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se2239418461657761734s_mask @ A @ N ) )
          = ( N
            = ( zero_zero @ nat ) ) ) ) ).

% semiring_bit_operations_class.even_mask_iff
thf(fact_2972_exp__mod__exp,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [M: nat,N: nat] :
          ( ( modulo_modulo @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) )
          = ( times_times @ A @ ( zero_neq_one_of_bool @ A @ ( ord_less @ nat @ M @ N ) ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M ) ) ) ) ).

% exp_mod_exp
thf(fact_2973_one__or__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A] :
          ( ( bit_se1065995026697491101ons_or @ A @ ( one_one @ A ) @ A2 )
          = ( plus_plus @ A @ A2 @ ( zero_neq_one_of_bool @ A @ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) ) ) ) ) ).

% one_or_eq
thf(fact_2974_or__one__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A] :
          ( ( bit_se1065995026697491101ons_or @ A @ A2 @ ( one_one @ A ) )
          = ( plus_plus @ A @ A2 @ ( zero_neq_one_of_bool @ A @ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) ) ) ) ) ).

% or_one_eq
thf(fact_2975_mask__nat__def,axiom,
    ( ( bit_se2239418461657761734s_mask @ nat )
    = ( ^ [N3: nat] : ( minus_minus @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N3 ) @ ( one_one @ nat ) ) ) ) ).

% mask_nat_def
thf(fact_2976_mask__half__int,axiom,
    ! [N: nat] :
      ( ( divide_divide @ int @ ( bit_se2239418461657761734s_mask @ int @ N ) @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) )
      = ( bit_se2239418461657761734s_mask @ int @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) ) ) ).

% mask_half_int
thf(fact_2977_mask__int__def,axiom,
    ( ( bit_se2239418461657761734s_mask @ int )
    = ( ^ [N3: nat] : ( minus_minus @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N3 ) @ ( one_one @ int ) ) ) ) ).

% mask_int_def
thf(fact_2978_mask__eq__exp__minus__1,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se2239418461657761734s_mask @ A )
        = ( ^ [N3: nat] : ( minus_minus @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N3 ) @ ( one_one @ A ) ) ) ) ) ).

% mask_eq_exp_minus_1
thf(fact_2979_mask__Suc__exp,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat] :
          ( ( bit_se2239418461657761734s_mask @ A @ ( suc @ N ) )
          = ( bit_se1065995026697491101ons_or @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) @ ( bit_se2239418461657761734s_mask @ A @ N ) ) ) ) ).

% mask_Suc_exp
thf(fact_2980_minus__exp__eq__not__mask,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N: nat] :
          ( ( uminus_uminus @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) )
          = ( bit_ri4277139882892585799ns_not @ A @ ( bit_se2239418461657761734s_mask @ A @ N ) ) ) ) ).

% minus_exp_eq_not_mask
thf(fact_2981_not__int__rec,axiom,
    ( ( bit_ri4277139882892585799ns_not @ int )
    = ( ^ [K3: int] : ( plus_plus @ int @ ( zero_neq_one_of_bool @ int @ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ K3 ) ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_ri4277139882892585799ns_not @ int @ ( divide_divide @ int @ K3 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% not_int_rec
thf(fact_2982_and__int__rec,axiom,
    ( ( bit_se5824344872417868541ns_and @ int )
    = ( ^ [K3: int,L2: int] :
          ( plus_plus @ int
          @ ( zero_neq_one_of_bool @ int
            @ ( ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ K3 )
              & ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ L2 ) ) )
          @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se5824344872417868541ns_and @ int @ ( divide_divide @ int @ K3 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ int @ L2 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% and_int_rec
thf(fact_2983_or__int__rec,axiom,
    ( ( bit_se1065995026697491101ons_or @ int )
    = ( ^ [K3: int,L2: int] :
          ( plus_plus @ int
          @ ( zero_neq_one_of_bool @ int
            @ ( ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ K3 )
              | ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ L2 ) ) )
          @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se1065995026697491101ons_or @ int @ ( divide_divide @ int @ K3 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ int @ L2 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% or_int_rec
thf(fact_2984_or__Suc__0__eq,axiom,
    ! [N: nat] :
      ( ( bit_se1065995026697491101ons_or @ nat @ N @ ( suc @ ( zero_zero @ nat ) ) )
      = ( plus_plus @ nat @ N @ ( zero_neq_one_of_bool @ nat @ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ) ) ).

% or_Suc_0_eq
thf(fact_2985_Suc__0__or__eq,axiom,
    ! [N: nat] :
      ( ( bit_se1065995026697491101ons_or @ nat @ ( suc @ ( zero_zero @ nat ) ) @ N )
      = ( plus_plus @ nat @ N @ ( zero_neq_one_of_bool @ nat @ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ) ) ).

% Suc_0_or_eq
thf(fact_2986_xor__one__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A] :
          ( ( bit_se5824344971392196577ns_xor @ A @ A2 @ ( one_one @ A ) )
          = ( minus_minus @ A @ ( plus_plus @ A @ A2 @ ( zero_neq_one_of_bool @ A @ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) ) )
            @ ( zero_neq_one_of_bool @ A
              @ ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) ) ) ) ) ).

% xor_one_eq
thf(fact_2987_one__xor__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A] :
          ( ( bit_se5824344971392196577ns_xor @ A @ ( one_one @ A ) @ A2 )
          = ( minus_minus @ A @ ( plus_plus @ A @ A2 @ ( zero_neq_one_of_bool @ A @ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) ) )
            @ ( zero_neq_one_of_bool @ A
              @ ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) ) ) ) ) ).

% one_xor_eq
thf(fact_2988_xor__int__rec,axiom,
    ( ( bit_se5824344971392196577ns_xor @ int )
    = ( ^ [K3: int,L2: int] :
          ( plus_plus @ int
          @ ( zero_neq_one_of_bool @ int
            @ ( ( ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ K3 ) )
             != ( ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ L2 ) ) ) )
          @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se5824344971392196577ns_xor @ int @ ( divide_divide @ int @ K3 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ int @ L2 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% xor_int_rec
thf(fact_2989_or__nat__rec,axiom,
    ( ( bit_se1065995026697491101ons_or @ nat )
    = ( ^ [M3: nat,N3: nat] :
          ( plus_plus @ nat
          @ ( zero_neq_one_of_bool @ nat
            @ ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M3 )
              | ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N3 ) ) )
          @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( bit_se1065995026697491101ons_or @ nat @ ( divide_divide @ nat @ M3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ nat @ N3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% or_nat_rec
thf(fact_2990_xor__nat__rec,axiom,
    ( ( bit_se5824344971392196577ns_xor @ nat )
    = ( ^ [M3: nat,N3: nat] :
          ( plus_plus @ nat
          @ ( zero_neq_one_of_bool @ nat
            @ ( ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M3 ) )
             != ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N3 ) ) ) )
          @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( bit_se5824344971392196577ns_xor @ nat @ ( divide_divide @ nat @ M3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ nat @ N3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% xor_nat_rec
thf(fact_2991_and__nat__rec,axiom,
    ( ( bit_se5824344872417868541ns_and @ nat )
    = ( ^ [M3: nat,N3: nat] :
          ( plus_plus @ nat
          @ ( zero_neq_one_of_bool @ nat
            @ ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M3 )
              & ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N3 ) ) )
          @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( bit_se5824344872417868541ns_and @ nat @ ( divide_divide @ nat @ M3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ nat @ N3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% and_nat_rec
thf(fact_2992_exp__div__exp__eq,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [M: nat,N: nat] :
          ( ( divide_divide @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) )
          = ( times_times @ A
            @ ( zero_neq_one_of_bool @ A
              @ ( ( ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M )
                 != ( zero_zero @ A ) )
                & ( ord_less_eq @ nat @ N @ M ) ) )
            @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ M @ N ) ) ) ) ) ).

% exp_div_exp_eq
thf(fact_2993_xor__Suc__0__eq,axiom,
    ! [N: nat] :
      ( ( bit_se5824344971392196577ns_xor @ nat @ N @ ( suc @ ( zero_zero @ nat ) ) )
      = ( minus_minus @ nat @ ( plus_plus @ nat @ N @ ( zero_neq_one_of_bool @ nat @ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) )
        @ ( zero_neq_one_of_bool @ nat
          @ ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ) ) ).

% xor_Suc_0_eq
thf(fact_2994_Suc__0__xor__eq,axiom,
    ! [N: nat] :
      ( ( bit_se5824344971392196577ns_xor @ nat @ ( suc @ ( zero_zero @ nat ) ) @ N )
      = ( minus_minus @ nat @ ( plus_plus @ nat @ N @ ( zero_neq_one_of_bool @ nat @ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) )
        @ ( zero_neq_one_of_bool @ nat
          @ ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ) ) ).

% Suc_0_xor_eq
thf(fact_2995_mask__Suc__double,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat] :
          ( ( bit_se2239418461657761734s_mask @ A @ ( suc @ N ) )
          = ( bit_se1065995026697491101ons_or @ A @ ( one_one @ A ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se2239418461657761734s_mask @ A @ N ) ) ) ) ) ).

% mask_Suc_double
thf(fact_2996_take__bit__eq__mask__iff__exp__dvd,axiom,
    ! [N: nat,K: int] :
      ( ( ( bit_se2584673776208193580ke_bit @ int @ N @ K )
        = ( bit_se2239418461657761734s_mask @ int @ N ) )
      = ( dvd_dvd @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) @ ( plus_plus @ int @ K @ ( one_one @ int ) ) ) ) ).

% take_bit_eq_mask_iff_exp_dvd
thf(fact_2997_num_Osize__gen_I3_J,axiom,
    ! [X32: num] :
      ( ( size_num @ ( bit1 @ X32 ) )
      = ( plus_plus @ nat @ ( size_num @ X32 ) @ ( suc @ ( zero_zero @ nat ) ) ) ) ).

% num.size_gen(3)
thf(fact_2998_num_Osize__gen_I2_J,axiom,
    ! [X22: num] :
      ( ( size_num @ ( bit0 @ X22 ) )
      = ( plus_plus @ nat @ ( size_num @ X22 ) @ ( suc @ ( zero_zero @ nat ) ) ) ) ).

% num.size_gen(2)
thf(fact_2999_machin,axiom,
    ( ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ ( bit0 @ one2 ) ) ) )
    = ( minus_minus @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ ( bit0 @ one2 ) ) ) @ ( arctan @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit1 @ ( bit0 @ one2 ) ) ) ) ) ) @ ( arctan @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit0 @ ( bit1 @ ( bit1 @ one2 ) ) ) ) ) ) ) ) ) ) ) ) ).

% machin
thf(fact_3000_machin__Euler,axiom,
    ( ( plus_plus @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit1 @ ( bit0 @ one2 ) ) ) @ ( arctan @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit1 @ ( bit1 @ one2 ) ) ) ) ) ) @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( arctan @ ( divide_divide @ real @ ( numeral_numeral @ real @ ( bit1 @ one2 ) ) @ ( numeral_numeral @ real @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit0 @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) )
    = ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ ( bit0 @ one2 ) ) ) ) ) ).

% machin_Euler
thf(fact_3001_powr__real__of__int,axiom,
    ! [X: real,N: int] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ N )
         => ( ( powr @ real @ X @ ( ring_1_of_int @ real @ N ) )
            = ( power_power @ real @ X @ ( nat2 @ N ) ) ) )
        & ( ~ ( ord_less_eq @ int @ ( zero_zero @ int ) @ N )
         => ( ( powr @ real @ X @ ( ring_1_of_int @ real @ N ) )
            = ( inverse_inverse @ real @ ( power_power @ real @ X @ ( nat2 @ ( uminus_uminus @ int @ N ) ) ) ) ) ) ) ) ).

% powr_real_of_int
thf(fact_3002_inverse__zero,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ( ( inverse_inverse @ A @ ( zero_zero @ A ) )
        = ( zero_zero @ A ) ) ) ).

% inverse_zero
thf(fact_3003_inverse__nonzero__iff__nonzero,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A] :
          ( ( ( inverse_inverse @ A @ A2 )
            = ( zero_zero @ A ) )
          = ( A2
            = ( zero_zero @ A ) ) ) ) ).

% inverse_nonzero_iff_nonzero
thf(fact_3004_inverse__nonpositive__iff__nonpositive,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ ( inverse_inverse @ A @ A2 ) @ ( zero_zero @ A ) )
          = ( ord_less_eq @ A @ A2 @ ( zero_zero @ A ) ) ) ) ).

% inverse_nonpositive_iff_nonpositive
thf(fact_3005_inverse__nonnegative__iff__nonnegative,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( inverse_inverse @ A @ A2 ) )
          = ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 ) ) ) ).

% inverse_nonnegative_iff_nonnegative
thf(fact_3006_inverse__positive__iff__positive,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( inverse_inverse @ A @ A2 ) )
          = ( ord_less @ A @ ( zero_zero @ A ) @ A2 ) ) ) ).

% inverse_positive_iff_positive
thf(fact_3007_inverse__negative__iff__negative,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( inverse_inverse @ A @ A2 ) @ ( zero_zero @ A ) )
          = ( ord_less @ A @ A2 @ ( zero_zero @ A ) ) ) ) ).

% inverse_negative_iff_negative
thf(fact_3008_inverse__less__iff__less__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ B2 @ ( zero_zero @ A ) )
           => ( ( ord_less @ A @ ( inverse_inverse @ A @ A2 ) @ ( inverse_inverse @ A @ B2 ) )
              = ( ord_less @ A @ B2 @ A2 ) ) ) ) ) ).

% inverse_less_iff_less_neg
thf(fact_3009_inverse__less__iff__less,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ B2 )
           => ( ( ord_less @ A @ ( inverse_inverse @ A @ A2 ) @ ( inverse_inverse @ A @ B2 ) )
              = ( ord_less @ A @ B2 @ A2 ) ) ) ) ) ).

% inverse_less_iff_less
thf(fact_3010_inverse__le__iff__le__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
         => ( ( ord_less @ A @ B2 @ ( zero_zero @ A ) )
           => ( ( ord_less_eq @ A @ ( inverse_inverse @ A @ A2 ) @ ( inverse_inverse @ A @ B2 ) )
              = ( ord_less_eq @ A @ B2 @ A2 ) ) ) ) ) ).

% inverse_le_iff_le_neg
thf(fact_3011_inverse__le__iff__le,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ B2 )
           => ( ( ord_less_eq @ A @ ( inverse_inverse @ A @ A2 ) @ ( inverse_inverse @ A @ B2 ) )
              = ( ord_less_eq @ A @ B2 @ A2 ) ) ) ) ) ).

% inverse_le_iff_le
thf(fact_3012_left__inverse,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( times_times @ A @ ( inverse_inverse @ A @ A2 ) @ A2 )
            = ( one_one @ A ) ) ) ) ).

% left_inverse
thf(fact_3013_right__inverse,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( times_times @ A @ A2 @ ( inverse_inverse @ A @ A2 ) )
            = ( one_one @ A ) ) ) ) ).

% right_inverse
thf(fact_3014_inverse__eq__divide__numeral,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [W: num] :
          ( ( inverse_inverse @ A @ ( numeral_numeral @ A @ W ) )
          = ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ W ) ) ) ) ).

% inverse_eq_divide_numeral
thf(fact_3015_inverse__eq__divide__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [W: num] :
          ( ( inverse_inverse @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) )
          = ( divide_divide @ A @ ( one_one @ A ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) ) ) ) ).

% inverse_eq_divide_neg_numeral
thf(fact_3016_nonzero__norm__inverse,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [A2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( real_V7770717601297561774m_norm @ A @ ( inverse_inverse @ A @ A2 ) )
            = ( inverse_inverse @ real @ ( real_V7770717601297561774m_norm @ A @ A2 ) ) ) ) ) ).

% nonzero_norm_inverse
thf(fact_3017_power__inverse,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A,N: nat] :
          ( ( power_power @ A @ ( inverse_inverse @ A @ A2 ) @ N )
          = ( inverse_inverse @ A @ ( power_power @ A @ A2 @ N ) ) ) ) ).

% power_inverse
thf(fact_3018_nonzero__of__real__inverse,axiom,
    ! [A: $tType] :
      ( ( real_V5047593784448816457lgebra @ A )
     => ! [X: real] :
          ( ( X
           != ( zero_zero @ real ) )
         => ( ( real_Vector_of_real @ A @ ( inverse_inverse @ real @ X ) )
            = ( inverse_inverse @ A @ ( real_Vector_of_real @ A @ X ) ) ) ) ) ).

% nonzero_of_real_inverse
thf(fact_3019_nonzero__imp__inverse__nonzero,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( inverse_inverse @ A @ A2 )
           != ( zero_zero @ A ) ) ) ) ).

% nonzero_imp_inverse_nonzero
thf(fact_3020_nonzero__inverse__inverse__eq,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( inverse_inverse @ A @ ( inverse_inverse @ A @ A2 ) )
            = A2 ) ) ) ).

% nonzero_inverse_inverse_eq
thf(fact_3021_nonzero__inverse__eq__imp__eq,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A,B2: A] :
          ( ( ( inverse_inverse @ A @ A2 )
            = ( inverse_inverse @ A @ B2 ) )
         => ( ( A2
             != ( zero_zero @ A ) )
           => ( ( B2
               != ( zero_zero @ A ) )
             => ( A2 = B2 ) ) ) ) ) ).

% nonzero_inverse_eq_imp_eq
thf(fact_3022_inverse__zero__imp__zero,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A] :
          ( ( ( inverse_inverse @ A @ A2 )
            = ( zero_zero @ A ) )
         => ( A2
            = ( zero_zero @ A ) ) ) ) ).

% inverse_zero_imp_zero
thf(fact_3023_field__class_Ofield__inverse__zero,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ( ( inverse_inverse @ A @ ( zero_zero @ A ) )
        = ( zero_zero @ A ) ) ) ).

% field_class.field_inverse_zero
thf(fact_3024_pi__neq__zero,axiom,
    pi
 != ( zero_zero @ real ) ).

% pi_neq_zero
thf(fact_3025_real__sqrt__inverse,axiom,
    ! [X: real] :
      ( ( sqrt @ ( inverse_inverse @ real @ X ) )
      = ( inverse_inverse @ real @ ( sqrt @ X ) ) ) ).

% real_sqrt_inverse
thf(fact_3026_norm__inverse__le__norm,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [R2: real,X: A] :
          ( ( ord_less_eq @ real @ R2 @ ( real_V7770717601297561774m_norm @ A @ X ) )
         => ( ( ord_less @ real @ ( zero_zero @ real ) @ R2 )
           => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( inverse_inverse @ A @ X ) ) @ ( inverse_inverse @ real @ R2 ) ) ) ) ) ).

% norm_inverse_le_norm
thf(fact_3027_positive__imp__inverse__positive,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ord_less @ A @ ( zero_zero @ A ) @ ( inverse_inverse @ A @ A2 ) ) ) ) ).

% positive_imp_inverse_positive
thf(fact_3028_negative__imp__inverse__negative,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
         => ( ord_less @ A @ ( inverse_inverse @ A @ A2 ) @ ( zero_zero @ A ) ) ) ) ).

% negative_imp_inverse_negative
thf(fact_3029_inverse__positive__imp__positive,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( inverse_inverse @ A @ A2 ) )
         => ( ( A2
             != ( zero_zero @ A ) )
           => ( ord_less @ A @ ( zero_zero @ A ) @ A2 ) ) ) ) ).

% inverse_positive_imp_positive
thf(fact_3030_inverse__negative__imp__negative,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( inverse_inverse @ A @ A2 ) @ ( zero_zero @ A ) )
         => ( ( A2
             != ( zero_zero @ A ) )
           => ( ord_less @ A @ A2 @ ( zero_zero @ A ) ) ) ) ) ).

% inverse_negative_imp_negative
thf(fact_3031_less__imp__inverse__less__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_less @ A @ B2 @ ( zero_zero @ A ) )
           => ( ord_less @ A @ ( inverse_inverse @ A @ B2 ) @ ( inverse_inverse @ A @ A2 ) ) ) ) ) ).

% less_imp_inverse_less_neg
thf(fact_3032_inverse__less__imp__less__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( inverse_inverse @ A @ A2 ) @ ( inverse_inverse @ A @ B2 ) )
         => ( ( ord_less @ A @ B2 @ ( zero_zero @ A ) )
           => ( ord_less @ A @ B2 @ A2 ) ) ) ) ).

% inverse_less_imp_less_neg
thf(fact_3033_less__imp__inverse__less,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
           => ( ord_less @ A @ ( inverse_inverse @ A @ B2 ) @ ( inverse_inverse @ A @ A2 ) ) ) ) ) ).

% less_imp_inverse_less
thf(fact_3034_inverse__less__imp__less,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( inverse_inverse @ A @ A2 ) @ ( inverse_inverse @ A @ B2 ) )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
           => ( ord_less @ A @ B2 @ A2 ) ) ) ) ).

% inverse_less_imp_less
thf(fact_3035_nonzero__inverse__mult__distrib,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A,B2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( B2
             != ( zero_zero @ A ) )
           => ( ( inverse_inverse @ A @ ( times_times @ A @ A2 @ B2 ) )
              = ( times_times @ A @ ( inverse_inverse @ A @ B2 ) @ ( inverse_inverse @ A @ A2 ) ) ) ) ) ) ).

% nonzero_inverse_mult_distrib
thf(fact_3036_nonzero__inverse__minus__eq,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( inverse_inverse @ A @ ( uminus_uminus @ A @ A2 ) )
            = ( uminus_uminus @ A @ ( inverse_inverse @ A @ A2 ) ) ) ) ) ).

% nonzero_inverse_minus_eq
thf(fact_3037_inverse__numeral__1,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ( ( inverse_inverse @ A @ ( numeral_numeral @ A @ one2 ) )
        = ( numeral_numeral @ A @ one2 ) ) ) ).

% inverse_numeral_1
thf(fact_3038_power__mult__inverse__distrib,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [X: A,M: nat] :
          ( ( times_times @ A @ ( power_power @ A @ X @ M ) @ ( inverse_inverse @ A @ X ) )
          = ( times_times @ A @ ( inverse_inverse @ A @ X ) @ ( power_power @ A @ X @ M ) ) ) ) ).

% power_mult_inverse_distrib
thf(fact_3039_power__mult__power__inverse__commute,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [X: A,M: nat,N: nat] :
          ( ( times_times @ A @ ( power_power @ A @ X @ M ) @ ( power_power @ A @ ( inverse_inverse @ A @ X ) @ N ) )
          = ( times_times @ A @ ( power_power @ A @ ( inverse_inverse @ A @ X ) @ N ) @ ( power_power @ A @ X @ M ) ) ) ) ).

% power_mult_power_inverse_commute
thf(fact_3040_mult__inverse__of__nat__commute,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [Xa: nat,X: A] :
          ( ( times_times @ A @ ( inverse_inverse @ A @ ( semiring_1_of_nat @ A @ Xa ) ) @ X )
          = ( times_times @ A @ X @ ( inverse_inverse @ A @ ( semiring_1_of_nat @ A @ Xa ) ) ) ) ) ).

% mult_inverse_of_nat_commute
thf(fact_3041_nonzero__abs__inverse,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( abs_abs @ A @ ( inverse_inverse @ A @ A2 ) )
            = ( inverse_inverse @ A @ ( abs_abs @ A @ A2 ) ) ) ) ) ).

% nonzero_abs_inverse
thf(fact_3042_mult__inverse__of__int__commute,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [Xa: int,X: A] :
          ( ( times_times @ A @ ( inverse_inverse @ A @ ( ring_1_of_int @ A @ Xa ) ) @ X )
          = ( times_times @ A @ X @ ( inverse_inverse @ A @ ( ring_1_of_int @ A @ Xa ) ) ) ) ) ).

% mult_inverse_of_int_commute
thf(fact_3043_divide__real__def,axiom,
    ( ( divide_divide @ real )
    = ( ^ [X2: real,Y4: real] : ( times_times @ real @ X2 @ ( inverse_inverse @ real @ Y4 ) ) ) ) ).

% divide_real_def
thf(fact_3044_pi__not__less__zero,axiom,
    ~ ( ord_less @ real @ pi @ ( zero_zero @ real ) ) ).

% pi_not_less_zero
thf(fact_3045_pi__gt__zero,axiom,
    ord_less @ real @ ( zero_zero @ real ) @ pi ).

% pi_gt_zero
thf(fact_3046_pi__ge__zero,axiom,
    ord_less_eq @ real @ ( zero_zero @ real ) @ pi ).

% pi_ge_zero
thf(fact_3047_le__imp__inverse__le__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less @ A @ B2 @ ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ ( inverse_inverse @ A @ B2 ) @ ( inverse_inverse @ A @ A2 ) ) ) ) ) ).

% le_imp_inverse_le_neg
thf(fact_3048_inverse__le__imp__le__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( inverse_inverse @ A @ A2 ) @ ( inverse_inverse @ A @ B2 ) )
         => ( ( ord_less @ A @ B2 @ ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ B2 @ A2 ) ) ) ) ).

% inverse_le_imp_le_neg
thf(fact_3049_le__imp__inverse__le,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
           => ( ord_less_eq @ A @ ( inverse_inverse @ A @ B2 ) @ ( inverse_inverse @ A @ A2 ) ) ) ) ) ).

% le_imp_inverse_le
thf(fact_3050_inverse__le__imp__le,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( inverse_inverse @ A @ A2 ) @ ( inverse_inverse @ A @ B2 ) )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
           => ( ord_less_eq @ A @ B2 @ A2 ) ) ) ) ).

% inverse_le_imp_le
thf(fact_3051_inverse__le__1__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A] :
          ( ( ord_less_eq @ A @ ( inverse_inverse @ A @ X ) @ ( one_one @ A ) )
          = ( ( ord_less_eq @ A @ X @ ( zero_zero @ A ) )
            | ( ord_less_eq @ A @ ( one_one @ A ) @ X ) ) ) ) ).

% inverse_le_1_iff
thf(fact_3052_one__less__inverse__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A] :
          ( ( ord_less @ A @ ( one_one @ A ) @ ( inverse_inverse @ A @ X ) )
          = ( ( ord_less @ A @ ( zero_zero @ A ) @ X )
            & ( ord_less @ A @ X @ ( one_one @ A ) ) ) ) ) ).

% one_less_inverse_iff
thf(fact_3053_one__less__inverse,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less @ A @ A2 @ ( one_one @ A ) )
           => ( ord_less @ A @ ( one_one @ A ) @ ( inverse_inverse @ A @ A2 ) ) ) ) ) ).

% one_less_inverse
thf(fact_3054_field__class_Ofield__inverse,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( times_times @ A @ ( inverse_inverse @ A @ A2 ) @ A2 )
            = ( one_one @ A ) ) ) ) ).

% field_class.field_inverse
thf(fact_3055_inverse__add,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A2: A,B2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( B2
             != ( zero_zero @ A ) )
           => ( ( plus_plus @ A @ ( inverse_inverse @ A @ A2 ) @ ( inverse_inverse @ A @ B2 ) )
              = ( times_times @ A @ ( times_times @ A @ ( plus_plus @ A @ A2 @ B2 ) @ ( inverse_inverse @ A @ A2 ) ) @ ( inverse_inverse @ A @ B2 ) ) ) ) ) ) ).

% inverse_add
thf(fact_3056_division__ring__inverse__add,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A,B2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( B2
             != ( zero_zero @ A ) )
           => ( ( plus_plus @ A @ ( inverse_inverse @ A @ A2 ) @ ( inverse_inverse @ A @ B2 ) )
              = ( times_times @ A @ ( times_times @ A @ ( inverse_inverse @ A @ A2 ) @ ( plus_plus @ A @ A2 @ B2 ) ) @ ( inverse_inverse @ A @ B2 ) ) ) ) ) ) ).

% division_ring_inverse_add
thf(fact_3057_division__ring__inverse__diff,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A,B2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( B2
             != ( zero_zero @ A ) )
           => ( ( minus_minus @ A @ ( inverse_inverse @ A @ A2 ) @ ( inverse_inverse @ A @ B2 ) )
              = ( times_times @ A @ ( times_times @ A @ ( inverse_inverse @ A @ A2 ) @ ( minus_minus @ A @ B2 @ A2 ) ) @ ( inverse_inverse @ A @ B2 ) ) ) ) ) ) ).

% division_ring_inverse_diff
thf(fact_3058_nonzero__inverse__eq__divide,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( inverse_inverse @ A @ A2 )
            = ( divide_divide @ A @ ( one_one @ A ) @ A2 ) ) ) ) ).

% nonzero_inverse_eq_divide
thf(fact_3059_inverse__powr,axiom,
    ! [Y: real,A2: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y )
     => ( ( powr @ real @ ( inverse_inverse @ real @ Y ) @ A2 )
        = ( inverse_inverse @ real @ ( powr @ real @ Y @ A2 ) ) ) ) ).

% inverse_powr
thf(fact_3060_inverse__le__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( inverse_inverse @ A @ A2 ) @ ( inverse_inverse @ A @ B2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A2 @ B2 ) )
             => ( ord_less_eq @ A @ B2 @ A2 ) )
            & ( ( ord_less_eq @ A @ ( times_times @ A @ A2 @ B2 ) @ ( zero_zero @ A ) )
             => ( ord_less_eq @ A @ A2 @ B2 ) ) ) ) ) ).

% inverse_le_iff
thf(fact_3061_inverse__less__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ ( inverse_inverse @ A @ A2 ) @ ( inverse_inverse @ A @ B2 ) )
          = ( ( ( ord_less @ A @ ( zero_zero @ A ) @ ( times_times @ A @ A2 @ B2 ) )
             => ( ord_less @ A @ B2 @ A2 ) )
            & ( ( ord_less_eq @ A @ ( times_times @ A @ A2 @ B2 ) @ ( zero_zero @ A ) )
             => ( ord_less @ A @ A2 @ B2 ) ) ) ) ) ).

% inverse_less_iff
thf(fact_3062_one__le__inverse,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less_eq @ A @ A2 @ ( one_one @ A ) )
           => ( ord_less_eq @ A @ ( one_one @ A ) @ ( inverse_inverse @ A @ A2 ) ) ) ) ) ).

% one_le_inverse
thf(fact_3063_inverse__less__1__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A] :
          ( ( ord_less @ A @ ( inverse_inverse @ A @ X ) @ ( one_one @ A ) )
          = ( ( ord_less_eq @ A @ X @ ( zero_zero @ A ) )
            | ( ord_less @ A @ ( one_one @ A ) @ X ) ) ) ) ).

% inverse_less_1_iff
thf(fact_3064_one__le__inverse__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A] :
          ( ( ord_less_eq @ A @ ( one_one @ A ) @ ( inverse_inverse @ A @ X ) )
          = ( ( ord_less @ A @ ( zero_zero @ A ) @ X )
            & ( ord_less_eq @ A @ X @ ( one_one @ A ) ) ) ) ) ).

% one_le_inverse_iff
thf(fact_3065_inverse__diff__inverse,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A2: A,B2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( B2
             != ( zero_zero @ A ) )
           => ( ( minus_minus @ A @ ( inverse_inverse @ A @ A2 ) @ ( inverse_inverse @ A @ B2 ) )
              = ( uminus_uminus @ A @ ( times_times @ A @ ( times_times @ A @ ( inverse_inverse @ A @ A2 ) @ ( minus_minus @ A @ A2 @ B2 ) ) @ ( inverse_inverse @ A @ B2 ) ) ) ) ) ) ) ).

% inverse_diff_inverse
thf(fact_3066_reals__Archimedean,axiom,
    ! [A: $tType] :
      ( ( archim462609752435547400_field @ A )
     => ! [X: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ X )
         => ? [N2: nat] : ( ord_less @ A @ ( inverse_inverse @ A @ ( semiring_1_of_nat @ A @ ( suc @ N2 ) ) ) @ X ) ) ) ).

% reals_Archimedean
thf(fact_3067_forall__pos__mono__1,axiom,
    ! [P: real > $o,E2: real] :
      ( ! [D6: real,E: real] :
          ( ( ord_less @ real @ D6 @ E )
         => ( ( P @ D6 )
           => ( P @ E ) ) )
     => ( ! [N2: nat] : ( P @ ( inverse_inverse @ real @ ( semiring_1_of_nat @ real @ ( suc @ N2 ) ) ) )
       => ( ( ord_less @ real @ ( zero_zero @ real ) @ E2 )
         => ( P @ E2 ) ) ) ) ).

% forall_pos_mono_1
thf(fact_3068_real__arch__inverse,axiom,
    ! [E2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ E2 )
      = ( ? [N3: nat] :
            ( ( N3
             != ( zero_zero @ nat ) )
            & ( ord_less @ real @ ( zero_zero @ real ) @ ( inverse_inverse @ real @ ( semiring_1_of_nat @ real @ N3 ) ) )
            & ( ord_less @ real @ ( inverse_inverse @ real @ ( semiring_1_of_nat @ real @ N3 ) ) @ E2 ) ) ) ) ).

% real_arch_inverse
thf(fact_3069_forall__pos__mono,axiom,
    ! [P: real > $o,E2: real] :
      ( ! [D6: real,E: real] :
          ( ( ord_less @ real @ D6 @ E )
         => ( ( P @ D6 )
           => ( P @ E ) ) )
     => ( ! [N2: nat] :
            ( ( N2
             != ( zero_zero @ nat ) )
           => ( P @ ( inverse_inverse @ real @ ( semiring_1_of_nat @ real @ N2 ) ) ) )
       => ( ( ord_less @ real @ ( zero_zero @ real ) @ E2 )
         => ( P @ E2 ) ) ) ) ).

% forall_pos_mono
thf(fact_3070_sqrt__divide__self__eq,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( divide_divide @ real @ ( sqrt @ X ) @ X )
        = ( inverse_inverse @ real @ ( sqrt @ X ) ) ) ) ).

% sqrt_divide_self_eq
thf(fact_3071_ln__inverse,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( ln_ln @ real @ ( inverse_inverse @ real @ X ) )
        = ( uminus_uminus @ real @ ( ln_ln @ real @ X ) ) ) ) ).

% ln_inverse
thf(fact_3072_pi__less__4,axiom,
    ord_less @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ ( bit0 @ one2 ) ) ) ).

% pi_less_4
thf(fact_3073_pi__ge__two,axiom,
    ord_less_eq @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ).

% pi_ge_two
thf(fact_3074_pi__half__neq__two,axiom,
    ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) )
 != ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ).

% pi_half_neq_two
thf(fact_3075_ex__inverse__of__nat__less,axiom,
    ! [A: $tType] :
      ( ( archim462609752435547400_field @ A )
     => ! [X: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ X )
         => ? [N2: nat] :
              ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
              & ( ord_less @ A @ ( inverse_inverse @ A @ ( semiring_1_of_nat @ A @ N2 ) ) @ X ) ) ) ) ).

% ex_inverse_of_nat_less
thf(fact_3076_power__diff__conv__inverse,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [X: A,M: nat,N: nat] :
          ( ( X
           != ( zero_zero @ A ) )
         => ( ( ord_less_eq @ nat @ M @ N )
           => ( ( power_power @ A @ X @ ( minus_minus @ nat @ N @ M ) )
              = ( times_times @ A @ ( power_power @ A @ X @ N ) @ ( power_power @ A @ ( inverse_inverse @ A @ X ) @ M ) ) ) ) ) ) ).

% power_diff_conv_inverse
thf(fact_3077_log__inverse,axiom,
    ! [A2: real,X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
     => ( ( A2
         != ( one_one @ real ) )
       => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
         => ( ( log2 @ A2 @ ( inverse_inverse @ real @ X ) )
            = ( uminus_uminus @ real @ ( log2 @ A2 @ X ) ) ) ) ) ) ).

% log_inverse
thf(fact_3078_pi__half__neq__zero,axiom,
    ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) )
 != ( zero_zero @ real ) ).

% pi_half_neq_zero
thf(fact_3079_pi__half__less__two,axiom,
    ord_less @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ).

% pi_half_less_two
thf(fact_3080_pi__half__le__two,axiom,
    ord_less_eq @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ).

% pi_half_le_two
thf(fact_3081_num_Osize__gen_I1_J,axiom,
    ( ( size_num @ one2 )
    = ( zero_zero @ nat ) ) ).

% num.size_gen(1)
thf(fact_3082_exp__plus__inverse__exp,axiom,
    ! [X: real] : ( ord_less_eq @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( plus_plus @ real @ ( exp @ real @ X ) @ ( inverse_inverse @ real @ ( exp @ real @ X ) ) ) ) ).

% exp_plus_inverse_exp
thf(fact_3083_pi__half__gt__zero,axiom,
    ord_less @ real @ ( zero_zero @ real ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ).

% pi_half_gt_zero
thf(fact_3084_pi__half__ge__zero,axiom,
    ord_less_eq @ real @ ( zero_zero @ real ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ).

% pi_half_ge_zero
thf(fact_3085_m2pi__less__pi,axiom,
    ord_less @ real @ ( uminus_uminus @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) ) @ pi ).

% m2pi_less_pi
thf(fact_3086_arctan__ubound,axiom,
    ! [Y: real] : ( ord_less @ real @ ( arctan @ Y ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ).

% arctan_ubound
thf(fact_3087_arctan__one,axiom,
    ( ( arctan @ ( one_one @ real ) )
    = ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ ( bit0 @ one2 ) ) ) ) ) ).

% arctan_one
thf(fact_3088_plus__inverse__ge__2,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ord_less_eq @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( plus_plus @ real @ X @ ( inverse_inverse @ real @ X ) ) ) ) ).

% plus_inverse_ge_2
thf(fact_3089_real__inv__sqrt__pow2,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( power_power @ real @ ( inverse_inverse @ real @ ( sqrt @ X ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
        = ( inverse_inverse @ real @ X ) ) ) ).

% real_inv_sqrt_pow2
thf(fact_3090_minus__pi__half__less__zero,axiom,
    ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ ( zero_zero @ real ) ).

% minus_pi_half_less_zero
thf(fact_3091_arctan__lbound,axiom,
    ! [Y: real] : ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ ( arctan @ Y ) ) ).

% arctan_lbound
thf(fact_3092_arctan__bounded,axiom,
    ! [Y: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ ( arctan @ Y ) )
      & ( ord_less @ real @ ( arctan @ Y ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ).

% arctan_bounded
thf(fact_3093_real__le__x__sinh,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ord_less_eq @ real @ X @ ( divide_divide @ real @ ( minus_minus @ real @ ( exp @ real @ X ) @ ( inverse_inverse @ real @ ( exp @ real @ X ) ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ).

% real_le_x_sinh
thf(fact_3094_real__le__abs__sinh,axiom,
    ! [X: real] : ( ord_less_eq @ real @ ( abs_abs @ real @ X ) @ ( abs_abs @ real @ ( divide_divide @ real @ ( minus_minus @ real @ ( exp @ real @ X ) @ ( inverse_inverse @ real @ ( exp @ real @ X ) ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ).

% real_le_abs_sinh
thf(fact_3095_sin__cos__npi,axiom,
    ! [N: nat] :
      ( ( sin @ real @ ( divide_divide @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ) @ pi ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
      = ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ N ) ) ).

% sin_cos_npi
thf(fact_3096_cos__pi__eq__zero,axiom,
    ! [M: nat] :
      ( ( cos @ real @ ( divide_divide @ real @ ( times_times @ real @ pi @ ( semiring_1_of_nat @ real @ ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M ) ) ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
      = ( zero_zero @ real ) ) ).

% cos_pi_eq_zero
thf(fact_3097_cos__zero__iff,axiom,
    ! [X: real] :
      ( ( ( cos @ real @ X )
        = ( zero_zero @ real ) )
      = ( ? [N3: nat] :
            ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N3 )
            & ( X
              = ( times_times @ real @ ( semiring_1_of_nat @ real @ N3 ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) )
        | ? [N3: nat] :
            ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N3 )
            & ( X
              = ( uminus_uminus @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N3 ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ).

% cos_zero_iff
thf(fact_3098_cot__less__zero,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( divide_divide @ real @ ( uminus_uminus @ real @ pi ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ X )
     => ( ( ord_less @ real @ X @ ( zero_zero @ real ) )
       => ( ord_less @ real @ ( cot @ real @ X ) @ ( zero_zero @ real ) ) ) ) ).

% cot_less_zero
thf(fact_3099_cos__zero__lemma,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( ( cos @ real @ X )
          = ( zero_zero @ real ) )
       => ? [N2: nat] :
            ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 )
            & ( X
              = ( times_times @ real @ ( semiring_1_of_nat @ real @ N2 ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% cos_zero_lemma
thf(fact_3100_sin__zero,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ( ( sin @ A @ ( zero_zero @ A ) )
        = ( zero_zero @ A ) ) ) ).

% sin_zero
thf(fact_3101_cot__zero,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ( ( cot @ A @ ( zero_zero @ A ) )
        = ( zero_zero @ A ) ) ) ).

% cot_zero
thf(fact_3102_cos__zero,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ( ( cos @ A @ ( zero_zero @ A ) )
        = ( one_one @ A ) ) ) ).

% cos_zero
thf(fact_3103_sin__pi,axiom,
    ( ( sin @ real @ pi )
    = ( zero_zero @ real ) ) ).

% sin_pi
thf(fact_3104_cot__pi,axiom,
    ( ( cot @ real @ pi )
    = ( zero_zero @ real ) ) ).

% cot_pi
thf(fact_3105_sin__of__real__pi,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ( ( sin @ A @ ( real_Vector_of_real @ A @ pi ) )
        = ( zero_zero @ A ) ) ) ).

% sin_of_real_pi
thf(fact_3106_sin__npi,axiom,
    ! [N: nat] :
      ( ( sin @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N ) @ pi ) )
      = ( zero_zero @ real ) ) ).

% sin_npi
thf(fact_3107_sin__npi2,axiom,
    ! [N: nat] :
      ( ( sin @ real @ ( times_times @ real @ pi @ ( semiring_1_of_nat @ real @ N ) ) )
      = ( zero_zero @ real ) ) ).

% sin_npi2
thf(fact_3108_sin__npi__int,axiom,
    ! [N: int] :
      ( ( sin @ real @ ( times_times @ real @ pi @ ( ring_1_of_int @ real @ N ) ) )
      = ( zero_zero @ real ) ) ).

% sin_npi_int
thf(fact_3109_cot__npi,axiom,
    ! [N: nat] :
      ( ( cot @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N ) @ pi ) )
      = ( zero_zero @ real ) ) ).

% cot_npi
thf(fact_3110_cos__pi__half,axiom,
    ( ( cos @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
    = ( zero_zero @ real ) ) ).

% cos_pi_half
thf(fact_3111_sin__two__pi,axiom,
    ( ( sin @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) )
    = ( zero_zero @ real ) ) ).

% sin_two_pi
thf(fact_3112_sin__pi__half,axiom,
    ( ( sin @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
    = ( one_one @ real ) ) ).

% sin_pi_half
thf(fact_3113_cos__two__pi,axiom,
    ( ( cos @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) )
    = ( one_one @ real ) ) ).

% cos_two_pi
thf(fact_3114_cos__periodic,axiom,
    ! [X: real] :
      ( ( cos @ real @ ( plus_plus @ real @ X @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) ) )
      = ( cos @ real @ X ) ) ).

% cos_periodic
thf(fact_3115_sin__periodic,axiom,
    ! [X: real] :
      ( ( sin @ real @ ( plus_plus @ real @ X @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) ) )
      = ( sin @ real @ X ) ) ).

% sin_periodic
thf(fact_3116_cos__2pi__minus,axiom,
    ! [X: real] :
      ( ( cos @ real @ ( minus_minus @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) @ X ) )
      = ( cos @ real @ X ) ) ).

% cos_2pi_minus
thf(fact_3117_cos__npi2,axiom,
    ! [N: nat] :
      ( ( cos @ real @ ( times_times @ real @ pi @ ( semiring_1_of_nat @ real @ N ) ) )
      = ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ N ) ) ).

% cos_npi2
thf(fact_3118_cos__npi,axiom,
    ! [N: nat] :
      ( ( cos @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N ) @ pi ) )
      = ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ N ) ) ).

% cos_npi
thf(fact_3119_cot__periodic,axiom,
    ! [X: real] :
      ( ( cot @ real @ ( plus_plus @ real @ X @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) ) )
      = ( cot @ real @ X ) ) ).

% cot_periodic
thf(fact_3120_sin__cos__squared__add,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A] :
          ( ( plus_plus @ A @ ( power_power @ A @ ( sin @ A @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ A @ ( cos @ A @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
          = ( one_one @ A ) ) ) ).

% sin_cos_squared_add
thf(fact_3121_sin__cos__squared__add2,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A] :
          ( ( plus_plus @ A @ ( power_power @ A @ ( cos @ A @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ A @ ( sin @ A @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
          = ( one_one @ A ) ) ) ).

% sin_cos_squared_add2
thf(fact_3122_cos__of__real__pi__half,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V7773925162809079976_field @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ( ( cos @ A @ ( divide_divide @ A @ ( real_Vector_of_real @ A @ pi ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) )
        = ( zero_zero @ A ) ) ) ).

% cos_of_real_pi_half
thf(fact_3123_sin__of__real__pi__half,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V7773925162809079976_field @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ( ( sin @ A @ ( divide_divide @ A @ ( real_Vector_of_real @ A @ pi ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) )
        = ( one_one @ A ) ) ) ).

% sin_of_real_pi_half
thf(fact_3124_sin__2npi,axiom,
    ! [N: nat] :
      ( ( sin @ real @ ( times_times @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( semiring_1_of_nat @ real @ N ) ) @ pi ) )
      = ( zero_zero @ real ) ) ).

% sin_2npi
thf(fact_3125_cos__2npi,axiom,
    ! [N: nat] :
      ( ( cos @ real @ ( times_times @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( semiring_1_of_nat @ real @ N ) ) @ pi ) )
      = ( one_one @ real ) ) ).

% cos_2npi
thf(fact_3126_sin__2pi__minus,axiom,
    ! [X: real] :
      ( ( sin @ real @ ( minus_minus @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) @ X ) )
      = ( uminus_uminus @ real @ ( sin @ real @ X ) ) ) ).

% sin_2pi_minus
thf(fact_3127_sin__int__2pin,axiom,
    ! [N: int] :
      ( ( sin @ real @ ( times_times @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) @ ( ring_1_of_int @ real @ N ) ) )
      = ( zero_zero @ real ) ) ).

% sin_int_2pin
thf(fact_3128_cos__int__2pin,axiom,
    ! [N: int] :
      ( ( cos @ real @ ( times_times @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) @ ( ring_1_of_int @ real @ N ) ) )
      = ( one_one @ real ) ) ).

% cos_int_2pin
thf(fact_3129_cos__3over2__pi,axiom,
    ( ( cos @ real @ ( times_times @ real @ ( divide_divide @ real @ ( numeral_numeral @ real @ ( bit1 @ one2 ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ pi ) )
    = ( zero_zero @ real ) ) ).

% cos_3over2_pi
thf(fact_3130_sin__3over2__pi,axiom,
    ( ( sin @ real @ ( times_times @ real @ ( divide_divide @ real @ ( numeral_numeral @ real @ ( bit1 @ one2 ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ pi ) )
    = ( uminus_uminus @ real @ ( one_one @ real ) ) ) ).

% sin_3over2_pi
thf(fact_3131_cos__npi__int,axiom,
    ! [N: int] :
      ( ( ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N )
       => ( ( cos @ real @ ( times_times @ real @ pi @ ( ring_1_of_int @ real @ N ) ) )
          = ( one_one @ real ) ) )
      & ( ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N )
       => ( ( cos @ real @ ( times_times @ real @ pi @ ( ring_1_of_int @ real @ N ) ) )
          = ( uminus_uminus @ real @ ( one_one @ real ) ) ) ) ) ).

% cos_npi_int
thf(fact_3132_cos__one__sin__zero,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A] :
          ( ( ( cos @ A @ X )
            = ( one_one @ A ) )
         => ( ( sin @ A @ X )
            = ( zero_zero @ A ) ) ) ) ).

% cos_one_sin_zero
thf(fact_3133_sin__zero__norm__cos__one,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A] :
          ( ( ( sin @ A @ X )
            = ( zero_zero @ A ) )
         => ( ( real_V7770717601297561774m_norm @ A @ ( cos @ A @ X ) )
            = ( one_one @ real ) ) ) ) ).

% sin_zero_norm_cos_one
thf(fact_3134_sin__zero__abs__cos__one,axiom,
    ! [X: real] :
      ( ( ( sin @ real @ X )
        = ( zero_zero @ real ) )
     => ( ( abs_abs @ real @ ( cos @ real @ X ) )
        = ( one_one @ real ) ) ) ).

% sin_zero_abs_cos_one
thf(fact_3135_sin__double,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A] :
          ( ( sin @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ X ) )
          = ( times_times @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( sin @ A @ X ) ) @ ( cos @ A @ X ) ) ) ) ).

% sin_double
thf(fact_3136_sincos__principal__value,axiom,
    ! [X: real] :
    ? [Y5: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ pi ) @ Y5 )
      & ( ord_less_eq @ real @ Y5 @ pi )
      & ( ( sin @ real @ Y5 )
        = ( sin @ real @ X ) )
      & ( ( cos @ real @ Y5 )
        = ( cos @ real @ X ) ) ) ).

% sincos_principal_value
thf(fact_3137_sin__x__le__x,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ord_less_eq @ real @ ( sin @ real @ X ) @ X ) ) ).

% sin_x_le_x
thf(fact_3138_sin__le__one,axiom,
    ! [X: real] : ( ord_less_eq @ real @ ( sin @ real @ X ) @ ( one_one @ real ) ) ).

% sin_le_one
thf(fact_3139_cos__le__one,axiom,
    ! [X: real] : ( ord_less_eq @ real @ ( cos @ real @ X ) @ ( one_one @ real ) ) ).

% cos_le_one
thf(fact_3140_abs__sin__x__le__abs__x,axiom,
    ! [X: real] : ( ord_less_eq @ real @ ( abs_abs @ real @ ( sin @ real @ X ) ) @ ( abs_abs @ real @ X ) ) ).

% abs_sin_x_le_abs_x
thf(fact_3141_cos__arctan__not__zero,axiom,
    ! [X: real] :
      ( ( cos @ real @ ( arctan @ X ) )
     != ( zero_zero @ real ) ) ).

% cos_arctan_not_zero
thf(fact_3142_sin__cos__le1,axiom,
    ! [X: real,Y: real] : ( ord_less_eq @ real @ ( abs_abs @ real @ ( plus_plus @ real @ ( times_times @ real @ ( sin @ real @ X ) @ ( sin @ real @ Y ) ) @ ( times_times @ real @ ( cos @ real @ X ) @ ( cos @ real @ Y ) ) ) ) @ ( one_one @ real ) ) ).

% sin_cos_le1
thf(fact_3143_cos__squared__eq,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A] :
          ( ( power_power @ A @ ( cos @ A @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
          = ( minus_minus @ A @ ( one_one @ A ) @ ( power_power @ A @ ( sin @ A @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% cos_squared_eq
thf(fact_3144_sin__squared__eq,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A] :
          ( ( power_power @ A @ ( sin @ A @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
          = ( minus_minus @ A @ ( one_one @ A ) @ ( power_power @ A @ ( cos @ A @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% sin_squared_eq
thf(fact_3145_sin__gt__zero,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less @ real @ X @ pi )
       => ( ord_less @ real @ ( zero_zero @ real ) @ ( sin @ real @ X ) ) ) ) ).

% sin_gt_zero
thf(fact_3146_sin__x__ge__neg__x,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ord_less_eq @ real @ ( uminus_uminus @ real @ X ) @ ( sin @ real @ X ) ) ) ).

% sin_x_ge_neg_x
thf(fact_3147_sin__ge__zero,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less_eq @ real @ X @ pi )
       => ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( sin @ real @ X ) ) ) ) ).

% sin_ge_zero
thf(fact_3148_sin__ge__minus__one,axiom,
    ! [X: real] : ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ ( sin @ real @ X ) ) ).

% sin_ge_minus_one
thf(fact_3149_cos__inj__pi,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less_eq @ real @ X @ pi )
       => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y )
         => ( ( ord_less_eq @ real @ Y @ pi )
           => ( ( ( cos @ real @ X )
                = ( cos @ real @ Y ) )
             => ( X = Y ) ) ) ) ) ) ).

% cos_inj_pi
thf(fact_3150_cos__mono__le__eq,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less_eq @ real @ X @ pi )
       => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y )
         => ( ( ord_less_eq @ real @ Y @ pi )
           => ( ( ord_less_eq @ real @ ( cos @ real @ X ) @ ( cos @ real @ Y ) )
              = ( ord_less_eq @ real @ Y @ X ) ) ) ) ) ) ).

% cos_mono_le_eq
thf(fact_3151_cos__monotone__0__pi__le,axiom,
    ! [Y: real,X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y )
     => ( ( ord_less_eq @ real @ Y @ X )
       => ( ( ord_less_eq @ real @ X @ pi )
         => ( ord_less_eq @ real @ ( cos @ real @ X ) @ ( cos @ real @ Y ) ) ) ) ) ).

% cos_monotone_0_pi_le
thf(fact_3152_cos__ge__minus__one,axiom,
    ! [X: real] : ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ ( cos @ real @ X ) ) ).

% cos_ge_minus_one
thf(fact_3153_abs__sin__le__one,axiom,
    ! [X: real] : ( ord_less_eq @ real @ ( abs_abs @ real @ ( sin @ real @ X ) ) @ ( one_one @ real ) ) ).

% abs_sin_le_one
thf(fact_3154_abs__cos__le__one,axiom,
    ! [X: real] : ( ord_less_eq @ real @ ( abs_abs @ real @ ( cos @ real @ X ) ) @ ( one_one @ real ) ) ).

% abs_cos_le_one
thf(fact_3155_sin__times__sin,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [W: A,Z: A] :
          ( ( times_times @ A @ ( sin @ A @ W ) @ ( sin @ A @ Z ) )
          = ( divide_divide @ A @ ( minus_minus @ A @ ( cos @ A @ ( minus_minus @ A @ W @ Z ) ) @ ( cos @ A @ ( plus_plus @ A @ W @ Z ) ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% sin_times_sin
thf(fact_3156_sin__times__cos,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [W: A,Z: A] :
          ( ( times_times @ A @ ( sin @ A @ W ) @ ( cos @ A @ Z ) )
          = ( divide_divide @ A @ ( plus_plus @ A @ ( sin @ A @ ( plus_plus @ A @ W @ Z ) ) @ ( sin @ A @ ( minus_minus @ A @ W @ Z ) ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% sin_times_cos
thf(fact_3157_cos__times__sin,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [W: A,Z: A] :
          ( ( times_times @ A @ ( cos @ A @ W ) @ ( sin @ A @ Z ) )
          = ( divide_divide @ A @ ( minus_minus @ A @ ( sin @ A @ ( plus_plus @ A @ W @ Z ) ) @ ( sin @ A @ ( minus_minus @ A @ W @ Z ) ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% cos_times_sin
thf(fact_3158_sin__plus__sin,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [W: A,Z: A] :
          ( ( plus_plus @ A @ ( sin @ A @ W ) @ ( sin @ A @ Z ) )
          = ( times_times @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( sin @ A @ ( divide_divide @ A @ ( plus_plus @ A @ W @ Z ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) @ ( cos @ A @ ( divide_divide @ A @ ( minus_minus @ A @ W @ Z ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% sin_plus_sin
thf(fact_3159_sin__diff__sin,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [W: A,Z: A] :
          ( ( minus_minus @ A @ ( sin @ A @ W ) @ ( sin @ A @ Z ) )
          = ( times_times @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( sin @ A @ ( divide_divide @ A @ ( minus_minus @ A @ W @ Z ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) @ ( cos @ A @ ( divide_divide @ A @ ( plus_plus @ A @ W @ Z ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% sin_diff_sin
thf(fact_3160_cos__diff__cos,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [W: A,Z: A] :
          ( ( minus_minus @ A @ ( cos @ A @ W ) @ ( cos @ A @ Z ) )
          = ( times_times @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( sin @ A @ ( divide_divide @ A @ ( plus_plus @ A @ W @ Z ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) @ ( sin @ A @ ( divide_divide @ A @ ( minus_minus @ A @ Z @ W ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% cos_diff_cos
thf(fact_3161_cos__double,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A] :
          ( ( cos @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ X ) )
          = ( minus_minus @ A @ ( power_power @ A @ ( cos @ A @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ A @ ( sin @ A @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% cos_double
thf(fact_3162_sin__cos__eq,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ( ( sin @ A )
        = ( ^ [X2: A] : ( cos @ A @ ( minus_minus @ A @ ( divide_divide @ A @ ( real_Vector_of_real @ A @ pi ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ X2 ) ) ) ) ) ).

% sin_cos_eq
thf(fact_3163_cos__sin__eq,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ( ( cos @ A )
        = ( ^ [X2: A] : ( sin @ A @ ( minus_minus @ A @ ( divide_divide @ A @ ( real_Vector_of_real @ A @ pi ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ X2 ) ) ) ) ) ).

% cos_sin_eq
thf(fact_3164_cos__double__sin,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [W: A] :
          ( ( cos @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ W ) )
          = ( minus_minus @ A @ ( one_one @ A ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( power_power @ A @ ( sin @ A @ W ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% cos_double_sin
thf(fact_3165_minus__sin__cos__eq,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A] :
          ( ( uminus_uminus @ A @ ( sin @ A @ X ) )
          = ( cos @ A @ ( plus_plus @ A @ X @ ( divide_divide @ A @ ( real_Vector_of_real @ A @ pi ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% minus_sin_cos_eq
thf(fact_3166_cos__two__neq__zero,axiom,
    ( cos @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) )
 != ( zero_zero @ real ) ).

% cos_two_neq_zero
thf(fact_3167_cos__monotone__0__pi,axiom,
    ! [Y: real,X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y )
     => ( ( ord_less @ real @ Y @ X )
       => ( ( ord_less_eq @ real @ X @ pi )
         => ( ord_less @ real @ ( cos @ real @ X ) @ ( cos @ real @ Y ) ) ) ) ) ).

% cos_monotone_0_pi
thf(fact_3168_cos__mono__less__eq,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less_eq @ real @ X @ pi )
       => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y )
         => ( ( ord_less_eq @ real @ Y @ pi )
           => ( ( ord_less @ real @ ( cos @ real @ X ) @ ( cos @ real @ Y ) )
              = ( ord_less @ real @ Y @ X ) ) ) ) ) ) ).

% cos_mono_less_eq
thf(fact_3169_sin__eq__0__pi,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ pi ) @ X )
     => ( ( ord_less @ real @ X @ pi )
       => ( ( ( sin @ real @ X )
            = ( zero_zero @ real ) )
         => ( X
            = ( zero_zero @ real ) ) ) ) ) ).

% sin_eq_0_pi
thf(fact_3170_sin__zero__pi__iff,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( abs_abs @ real @ X ) @ pi )
     => ( ( ( sin @ real @ X )
          = ( zero_zero @ real ) )
        = ( X
          = ( zero_zero @ real ) ) ) ) ).

% sin_zero_pi_iff
thf(fact_3171_cos__monotone__minus__pi__0_H,axiom,
    ! [Y: real,X: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ pi ) @ Y )
     => ( ( ord_less_eq @ real @ Y @ X )
       => ( ( ord_less_eq @ real @ X @ ( zero_zero @ real ) )
         => ( ord_less_eq @ real @ ( cos @ real @ Y ) @ ( cos @ real @ X ) ) ) ) ) ).

% cos_monotone_minus_pi_0'
thf(fact_3172_sin__zero__iff__int2,axiom,
    ! [X: real] :
      ( ( ( sin @ real @ X )
        = ( zero_zero @ real ) )
      = ( ? [I4: int] :
            ( X
            = ( times_times @ real @ ( ring_1_of_int @ real @ I4 ) @ pi ) ) ) ) ).

% sin_zero_iff_int2
thf(fact_3173_sincos__total__pi,axiom,
    ! [Y: real,X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y )
     => ( ( ( plus_plus @ real @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Y @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
          = ( one_one @ real ) )
       => ? [T4: real] :
            ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ T4 )
            & ( ord_less_eq @ real @ T4 @ pi )
            & ( X
              = ( cos @ real @ T4 ) )
            & ( Y
              = ( sin @ real @ T4 ) ) ) ) ) ).

% sincos_total_pi
thf(fact_3174_sin__cos__sqrt,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( sin @ real @ X ) )
     => ( ( sin @ real @ X )
        = ( sqrt @ ( minus_minus @ real @ ( one_one @ real ) @ ( power_power @ real @ ( cos @ real @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% sin_cos_sqrt
thf(fact_3175_sin__expansion__lemma,axiom,
    ! [X: real,M: nat] :
      ( ( sin @ real @ ( plus_plus @ real @ X @ ( divide_divide @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ ( suc @ M ) ) @ pi ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) )
      = ( cos @ real @ ( plus_plus @ real @ X @ ( divide_divide @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ M ) @ pi ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ).

% sin_expansion_lemma
thf(fact_3176_cos__expansion__lemma,axiom,
    ! [X: real,M: nat] :
      ( ( cos @ real @ ( plus_plus @ real @ X @ ( divide_divide @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ ( suc @ M ) ) @ pi ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) )
      = ( uminus_uminus @ real @ ( sin @ real @ ( plus_plus @ real @ X @ ( divide_divide @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ M ) @ pi ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% cos_expansion_lemma
thf(fact_3177_sin__gt__zero__02,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less @ real @ X @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) )
       => ( ord_less @ real @ ( zero_zero @ real ) @ ( sin @ real @ X ) ) ) ) ).

% sin_gt_zero_02
thf(fact_3178_cos__two__less__zero,axiom,
    ord_less @ real @ ( cos @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( zero_zero @ real ) ).

% cos_two_less_zero
thf(fact_3179_cos__two__le__zero,axiom,
    ord_less_eq @ real @ ( cos @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( zero_zero @ real ) ).

% cos_two_le_zero
thf(fact_3180_cos__is__zero,axiom,
    ? [X3: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X3 )
      & ( ord_less_eq @ real @ X3 @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) )
      & ( ( cos @ real @ X3 )
        = ( zero_zero @ real ) )
      & ! [Y6: real] :
          ( ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y6 )
            & ( ord_less_eq @ real @ Y6 @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) )
            & ( ( cos @ real @ Y6 )
              = ( zero_zero @ real ) ) )
         => ( Y6 = X3 ) ) ) ).

% cos_is_zero
thf(fact_3181_cos__monotone__minus__pi__0,axiom,
    ! [Y: real,X: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ pi ) @ Y )
     => ( ( ord_less @ real @ Y @ X )
       => ( ( ord_less_eq @ real @ X @ ( zero_zero @ real ) )
         => ( ord_less @ real @ ( cos @ real @ Y ) @ ( cos @ real @ X ) ) ) ) ) ).

% cos_monotone_minus_pi_0
thf(fact_3182_cos__total,axiom,
    ! [Y: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ Y )
     => ( ( ord_less_eq @ real @ Y @ ( one_one @ real ) )
       => ? [X3: real] :
            ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X3 )
            & ( ord_less_eq @ real @ X3 @ pi )
            & ( ( cos @ real @ X3 )
              = Y )
            & ! [Y6: real] :
                ( ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y6 )
                  & ( ord_less_eq @ real @ Y6 @ pi )
                  & ( ( cos @ real @ Y6 )
                    = Y ) )
               => ( Y6 = X3 ) ) ) ) ) ).

% cos_total
thf(fact_3183_sincos__total__pi__half,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y )
       => ( ( ( plus_plus @ real @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Y @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
            = ( one_one @ real ) )
         => ? [T4: real] :
              ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ T4 )
              & ( ord_less_eq @ real @ T4 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
              & ( X
                = ( cos @ real @ T4 ) )
              & ( Y
                = ( sin @ real @ T4 ) ) ) ) ) ) ).

% sincos_total_pi_half
thf(fact_3184_sincos__total__2pi__le,axiom,
    ! [X: real,Y: real] :
      ( ( ( plus_plus @ real @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Y @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
        = ( one_one @ real ) )
     => ? [T4: real] :
          ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ T4 )
          & ( ord_less_eq @ real @ T4 @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) )
          & ( X
            = ( cos @ real @ T4 ) )
          & ( Y
            = ( sin @ real @ T4 ) ) ) ) ).

% sincos_total_2pi_le
thf(fact_3185_sincos__total__2pi,axiom,
    ! [X: real,Y: real] :
      ( ( ( plus_plus @ real @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Y @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
        = ( one_one @ real ) )
     => ~ ! [T4: real] :
            ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ T4 )
           => ( ( ord_less @ real @ T4 @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) )
             => ( ( X
                  = ( cos @ real @ T4 ) )
               => ( Y
                 != ( sin @ real @ T4 ) ) ) ) ) ) ).

% sincos_total_2pi
thf(fact_3186_sin__pi__divide__n__ge__0,axiom,
    ! [N: nat] :
      ( ( N
       != ( zero_zero @ nat ) )
     => ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( sin @ real @ ( divide_divide @ real @ pi @ ( semiring_1_of_nat @ real @ N ) ) ) ) ) ).

% sin_pi_divide_n_ge_0
thf(fact_3187_sin__45,axiom,
    ( ( sin @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ ( bit0 @ one2 ) ) ) ) )
    = ( divide_divide @ real @ ( sqrt @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ).

% sin_45
thf(fact_3188_cos__45,axiom,
    ( ( cos @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ ( bit0 @ one2 ) ) ) ) )
    = ( divide_divide @ real @ ( sqrt @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ).

% cos_45
thf(fact_3189_cos__plus__cos,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [W: A,Z: A] :
          ( ( plus_plus @ A @ ( cos @ A @ W ) @ ( cos @ A @ Z ) )
          = ( times_times @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( cos @ A @ ( divide_divide @ A @ ( plus_plus @ A @ W @ Z ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) @ ( cos @ A @ ( divide_divide @ A @ ( minus_minus @ A @ W @ Z ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% cos_plus_cos
thf(fact_3190_cos__times__cos,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [W: A,Z: A] :
          ( ( times_times @ A @ ( cos @ A @ W ) @ ( cos @ A @ Z ) )
          = ( divide_divide @ A @ ( plus_plus @ A @ ( cos @ A @ ( minus_minus @ A @ W @ Z ) ) @ ( cos @ A @ ( plus_plus @ A @ W @ Z ) ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% cos_times_cos
thf(fact_3191_sin__gt__zero2,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less @ real @ X @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
       => ( ord_less @ real @ ( zero_zero @ real ) @ ( sin @ real @ X ) ) ) ) ).

% sin_gt_zero2
thf(fact_3192_sin__lt__zero,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ pi @ X )
     => ( ( ord_less @ real @ X @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) )
       => ( ord_less @ real @ ( sin @ real @ X ) @ ( zero_zero @ real ) ) ) ) ).

% sin_lt_zero
thf(fact_3193_cos__double__less__one,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less @ real @ X @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) )
       => ( ord_less @ real @ ( cos @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ X ) ) @ ( one_one @ real ) ) ) ) ).

% cos_double_less_one
thf(fact_3194_sin__30,axiom,
    ( ( sin @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ ( bit1 @ one2 ) ) ) ) )
    = ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ).

% sin_30
thf(fact_3195_cos__gt__zero,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less @ real @ X @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
       => ( ord_less @ real @ ( zero_zero @ real ) @ ( cos @ real @ X ) ) ) ) ).

% cos_gt_zero
thf(fact_3196_sin__monotone__2pi__le,axiom,
    ! [Y: real,X: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ Y )
     => ( ( ord_less_eq @ real @ Y @ X )
       => ( ( ord_less_eq @ real @ X @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
         => ( ord_less_eq @ real @ ( sin @ real @ Y ) @ ( sin @ real @ X ) ) ) ) ) ).

% sin_monotone_2pi_le
thf(fact_3197_sin__mono__le__eq,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ X )
     => ( ( ord_less_eq @ real @ X @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
       => ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ Y )
         => ( ( ord_less_eq @ real @ Y @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
           => ( ( ord_less_eq @ real @ ( sin @ real @ X ) @ ( sin @ real @ Y ) )
              = ( ord_less_eq @ real @ X @ Y ) ) ) ) ) ) ).

% sin_mono_le_eq
thf(fact_3198_sin__inj__pi,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ X )
     => ( ( ord_less_eq @ real @ X @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
       => ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ Y )
         => ( ( ord_less_eq @ real @ Y @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
           => ( ( ( sin @ real @ X )
                = ( sin @ real @ Y ) )
             => ( X = Y ) ) ) ) ) ) ).

% sin_inj_pi
thf(fact_3199_cos__60,axiom,
    ( ( cos @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit1 @ one2 ) ) ) )
    = ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ).

% cos_60
thf(fact_3200_sin__60,axiom,
    ( ( sin @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit1 @ one2 ) ) ) )
    = ( divide_divide @ real @ ( sqrt @ ( numeral_numeral @ real @ ( bit1 @ one2 ) ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ).

% sin_60
thf(fact_3201_cos__30,axiom,
    ( ( cos @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ ( bit1 @ one2 ) ) ) ) )
    = ( divide_divide @ real @ ( sqrt @ ( numeral_numeral @ real @ ( bit1 @ one2 ) ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ).

% cos_30
thf(fact_3202_cos__one__2pi__int,axiom,
    ! [X: real] :
      ( ( ( cos @ real @ X )
        = ( one_one @ real ) )
      = ( ? [X2: int] :
            ( X
            = ( times_times @ real @ ( times_times @ real @ ( ring_1_of_int @ real @ X2 ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ pi ) ) ) ) ).

% cos_one_2pi_int
thf(fact_3203_cos__double__cos,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [W: A] :
          ( ( cos @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ W ) )
          = ( minus_minus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( power_power @ A @ ( cos @ A @ W ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( one_one @ A ) ) ) ) ).

% cos_double_cos
thf(fact_3204_cos__treble__cos,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A] :
          ( ( cos @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit1 @ one2 ) ) @ X ) )
          = ( minus_minus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ ( bit0 @ one2 ) ) ) @ ( power_power @ A @ ( cos @ A @ X ) @ ( numeral_numeral @ nat @ ( bit1 @ one2 ) ) ) ) @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit1 @ one2 ) ) @ ( cos @ A @ X ) ) ) ) ) ).

% cos_treble_cos
thf(fact_3205_sin__le__zero,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ pi @ X )
     => ( ( ord_less @ real @ X @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) )
       => ( ord_less_eq @ real @ ( sin @ real @ X ) @ ( zero_zero @ real ) ) ) ) ).

% sin_le_zero
thf(fact_3206_sin__less__zero,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( divide_divide @ real @ ( uminus_uminus @ real @ pi ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ X )
     => ( ( ord_less @ real @ X @ ( zero_zero @ real ) )
       => ( ord_less @ real @ ( sin @ real @ X ) @ ( zero_zero @ real ) ) ) ) ).

% sin_less_zero
thf(fact_3207_sin__monotone__2pi,axiom,
    ! [Y: real,X: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ Y )
     => ( ( ord_less @ real @ Y @ X )
       => ( ( ord_less_eq @ real @ X @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
         => ( ord_less @ real @ ( sin @ real @ Y ) @ ( sin @ real @ X ) ) ) ) ) ).

% sin_monotone_2pi
thf(fact_3208_sin__mono__less__eq,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ X )
     => ( ( ord_less_eq @ real @ X @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
       => ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ Y )
         => ( ( ord_less_eq @ real @ Y @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
           => ( ( ord_less @ real @ ( sin @ real @ X ) @ ( sin @ real @ Y ) )
              = ( ord_less @ real @ X @ Y ) ) ) ) ) ) ).

% sin_mono_less_eq
thf(fact_3209_sin__total,axiom,
    ! [Y: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ Y )
     => ( ( ord_less_eq @ real @ Y @ ( one_one @ real ) )
       => ? [X3: real] :
            ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ X3 )
            & ( ord_less_eq @ real @ X3 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
            & ( ( sin @ real @ X3 )
              = Y )
            & ! [Y6: real] :
                ( ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ Y6 )
                  & ( ord_less_eq @ real @ Y6 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
                  & ( ( sin @ real @ Y6 )
                    = Y ) )
               => ( Y6 = X3 ) ) ) ) ) ).

% sin_total
thf(fact_3210_cos__gt__zero__pi,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ X )
     => ( ( ord_less @ real @ X @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
       => ( ord_less @ real @ ( zero_zero @ real ) @ ( cos @ real @ X ) ) ) ) ).

% cos_gt_zero_pi
thf(fact_3211_cos__ge__zero,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ X )
     => ( ( ord_less_eq @ real @ X @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
       => ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( cos @ real @ X ) ) ) ) ).

% cos_ge_zero
thf(fact_3212_cos__one__2pi,axiom,
    ! [X: real] :
      ( ( ( cos @ real @ X )
        = ( one_one @ real ) )
      = ( ? [X2: nat] :
            ( X
            = ( times_times @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ X2 ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ pi ) )
        | ? [X2: nat] :
            ( X
            = ( uminus_uminus @ real @ ( times_times @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ X2 ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ pi ) ) ) ) ) ).

% cos_one_2pi
thf(fact_3213_sin__pi__divide__n__gt__0,axiom,
    ! [N: nat] :
      ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
     => ( ord_less @ real @ ( zero_zero @ real ) @ ( sin @ real @ ( divide_divide @ real @ pi @ ( semiring_1_of_nat @ real @ N ) ) ) ) ) ).

% sin_pi_divide_n_gt_0
thf(fact_3214_sin__arctan,axiom,
    ! [X: real] :
      ( ( sin @ real @ ( arctan @ X ) )
      = ( divide_divide @ real @ X @ ( sqrt @ ( plus_plus @ real @ ( one_one @ real ) @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% sin_arctan
thf(fact_3215_cos__arctan,axiom,
    ! [X: real] :
      ( ( cos @ real @ ( arctan @ X ) )
      = ( divide_divide @ real @ ( one_one @ real ) @ ( sqrt @ ( plus_plus @ real @ ( one_one @ real ) @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% cos_arctan
thf(fact_3216_cot__gt__zero,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less @ real @ X @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
       => ( ord_less @ real @ ( zero_zero @ real ) @ ( cot @ real @ X ) ) ) ) ).

% cot_gt_zero
thf(fact_3217_sin__zero__iff__int,axiom,
    ! [X: real] :
      ( ( ( sin @ real @ X )
        = ( zero_zero @ real ) )
      = ( ? [I4: int] :
            ( ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ I4 )
            & ( X
              = ( times_times @ real @ ( ring_1_of_int @ real @ I4 ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% sin_zero_iff_int
thf(fact_3218_cos__zero__iff__int,axiom,
    ! [X: real] :
      ( ( ( cos @ real @ X )
        = ( zero_zero @ real ) )
      = ( ? [I4: int] :
            ( ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ I4 )
            & ( X
              = ( times_times @ real @ ( ring_1_of_int @ real @ I4 ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% cos_zero_iff_int
thf(fact_3219_sin__zero__lemma,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( ( sin @ real @ X )
          = ( zero_zero @ real ) )
       => ? [N2: nat] :
            ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N2 )
            & ( X
              = ( times_times @ real @ ( semiring_1_of_nat @ real @ N2 ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% sin_zero_lemma
thf(fact_3220_sin__zero__iff,axiom,
    ! [X: real] :
      ( ( ( sin @ real @ X )
        = ( zero_zero @ real ) )
      = ( ? [N3: nat] :
            ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N3 )
            & ( X
              = ( times_times @ real @ ( semiring_1_of_nat @ real @ N3 ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) )
        | ? [N3: nat] :
            ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N3 )
            & ( X
              = ( uminus_uminus @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N3 ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ).

% sin_zero_iff
thf(fact_3221_tan__double,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A] :
          ( ( ( cos @ A @ X )
           != ( zero_zero @ A ) )
         => ( ( ( cos @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ X ) )
             != ( zero_zero @ A ) )
           => ( ( tan @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ X ) )
              = ( divide_divide @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( tan @ A @ X ) ) @ ( minus_minus @ A @ ( one_one @ A ) @ ( power_power @ A @ ( tan @ A @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ).

% tan_double
thf(fact_3222_sin__tan,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( abs_abs @ real @ X ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
     => ( ( sin @ real @ X )
        = ( divide_divide @ real @ ( tan @ real @ X ) @ ( sqrt @ ( plus_plus @ real @ ( one_one @ real ) @ ( power_power @ real @ ( tan @ real @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% sin_tan
thf(fact_3223_cos__tan,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( abs_abs @ real @ X ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
     => ( ( cos @ real @ X )
        = ( divide_divide @ real @ ( one_one @ real ) @ ( sqrt @ ( plus_plus @ real @ ( one_one @ real ) @ ( power_power @ real @ ( tan @ real @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% cos_tan
thf(fact_3224_complex__unimodular__polar,axiom,
    ! [Z: complex] :
      ( ( ( real_V7770717601297561774m_norm @ complex @ Z )
        = ( one_one @ real ) )
     => ~ ! [T4: real] :
            ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ T4 )
           => ( ( ord_less @ real @ T4 @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) )
             => ( Z
               != ( complex2 @ ( cos @ real @ T4 ) @ ( sin @ real @ T4 ) ) ) ) ) ) ).

% complex_unimodular_polar
thf(fact_3225_cos__arcsin,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ X )
     => ( ( ord_less_eq @ real @ X @ ( one_one @ real ) )
       => ( ( cos @ real @ ( arcsin @ X ) )
          = ( sqrt @ ( minus_minus @ real @ ( one_one @ real ) @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% cos_arcsin
thf(fact_3226_tan__zero,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ( ( tan @ A @ ( zero_zero @ A ) )
        = ( zero_zero @ A ) ) ) ).

% tan_zero
thf(fact_3227_arcsin__0,axiom,
    ( ( arcsin @ ( zero_zero @ real ) )
    = ( zero_zero @ real ) ) ).

% arcsin_0
thf(fact_3228_tan__pi,axiom,
    ( ( tan @ real @ pi )
    = ( zero_zero @ real ) ) ).

% tan_pi
thf(fact_3229_tan__npi,axiom,
    ! [N: nat] :
      ( ( tan @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N ) @ pi ) )
      = ( zero_zero @ real ) ) ).

% tan_npi
thf(fact_3230_tan__periodic__n,axiom,
    ! [X: real,N: num] :
      ( ( tan @ real @ ( plus_plus @ real @ X @ ( times_times @ real @ ( numeral_numeral @ real @ N ) @ pi ) ) )
      = ( tan @ real @ X ) ) ).

% tan_periodic_n
thf(fact_3231_sin__arcsin,axiom,
    ! [Y: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ Y )
     => ( ( ord_less_eq @ real @ Y @ ( one_one @ real ) )
       => ( ( sin @ real @ ( arcsin @ Y ) )
          = Y ) ) ) ).

% sin_arcsin
thf(fact_3232_tan__periodic__nat,axiom,
    ! [X: real,N: nat] :
      ( ( tan @ real @ ( plus_plus @ real @ X @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N ) @ pi ) ) )
      = ( tan @ real @ X ) ) ).

% tan_periodic_nat
thf(fact_3233_arcsin__1,axiom,
    ( ( arcsin @ ( one_one @ real ) )
    = ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ).

% arcsin_1
thf(fact_3234_tan__periodic,axiom,
    ! [X: real] :
      ( ( tan @ real @ ( plus_plus @ real @ X @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) ) )
      = ( tan @ real @ X ) ) ).

% tan_periodic
thf(fact_3235_arcsin__minus__1,axiom,
    ( ( arcsin @ ( uminus_uminus @ real @ ( one_one @ real ) ) )
    = ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ).

% arcsin_minus_1
thf(fact_3236_Complex__eq__0,axiom,
    ! [A2: real,B2: real] :
      ( ( ( complex2 @ A2 @ B2 )
        = ( zero_zero @ complex ) )
      = ( ( A2
          = ( zero_zero @ real ) )
        & ( B2
          = ( zero_zero @ real ) ) ) ) ).

% Complex_eq_0
thf(fact_3237_zero__complex_Ocode,axiom,
    ( ( zero_zero @ complex )
    = ( complex2 @ ( zero_zero @ real ) @ ( zero_zero @ real ) ) ) ).

% zero_complex.code
thf(fact_3238_complex__of__real__def,axiom,
    ( ( real_Vector_of_real @ complex )
    = ( ^ [R5: real] : ( complex2 @ R5 @ ( zero_zero @ real ) ) ) ) ).

% complex_of_real_def
thf(fact_3239_complex__of__real__code,axiom,
    ( ( real_Vector_of_real @ complex )
    = ( ^ [X2: real] : ( complex2 @ X2 @ ( zero_zero @ real ) ) ) ) ).

% complex_of_real_code
thf(fact_3240_complex__eq__cancel__iff2,axiom,
    ! [X: real,Y: real,Xa: real] :
      ( ( ( complex2 @ X @ Y )
        = ( real_Vector_of_real @ complex @ Xa ) )
      = ( ( X = Xa )
        & ( Y
          = ( zero_zero @ real ) ) ) ) ).

% complex_eq_cancel_iff2
thf(fact_3241_one__complex_Ocode,axiom,
    ( ( one_one @ complex )
    = ( complex2 @ ( one_one @ real ) @ ( zero_zero @ real ) ) ) ).

% one_complex.code
thf(fact_3242_Complex__eq__1,axiom,
    ! [A2: real,B2: real] :
      ( ( ( complex2 @ A2 @ B2 )
        = ( one_one @ complex ) )
      = ( ( A2
          = ( one_one @ real ) )
        & ( B2
          = ( zero_zero @ real ) ) ) ) ).

% Complex_eq_1
thf(fact_3243_Complex__eq__numeral,axiom,
    ! [A2: real,B2: real,W: num] :
      ( ( ( complex2 @ A2 @ B2 )
        = ( numeral_numeral @ complex @ W ) )
      = ( ( A2
          = ( numeral_numeral @ real @ W ) )
        & ( B2
          = ( zero_zero @ real ) ) ) ) ).

% Complex_eq_numeral
thf(fact_3244_Complex__eq__neg__1,axiom,
    ! [A2: real,B2: real] :
      ( ( ( complex2 @ A2 @ B2 )
        = ( uminus_uminus @ complex @ ( one_one @ complex ) ) )
      = ( ( A2
          = ( uminus_uminus @ real @ ( one_one @ real ) ) )
        & ( B2
          = ( zero_zero @ real ) ) ) ) ).

% Complex_eq_neg_1
thf(fact_3245_Complex__eq__neg__numeral,axiom,
    ! [A2: real,B2: real,W: num] :
      ( ( ( complex2 @ A2 @ B2 )
        = ( uminus_uminus @ complex @ ( numeral_numeral @ complex @ W ) ) )
      = ( ( A2
          = ( uminus_uminus @ real @ ( numeral_numeral @ real @ W ) ) )
        & ( B2
          = ( zero_zero @ real ) ) ) ) ).

% Complex_eq_neg_numeral
thf(fact_3246_arcsin__minus,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ X )
     => ( ( ord_less_eq @ real @ X @ ( one_one @ real ) )
       => ( ( arcsin @ ( uminus_uminus @ real @ X ) )
          = ( uminus_uminus @ real @ ( arcsin @ X ) ) ) ) ) ).

% arcsin_minus
thf(fact_3247_arcsin__le__arcsin,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ X )
     => ( ( ord_less_eq @ real @ X @ Y )
       => ( ( ord_less_eq @ real @ Y @ ( one_one @ real ) )
         => ( ord_less_eq @ real @ ( arcsin @ X ) @ ( arcsin @ Y ) ) ) ) ) ).

% arcsin_le_arcsin
thf(fact_3248_arcsin__eq__iff,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less_eq @ real @ ( abs_abs @ real @ X ) @ ( one_one @ real ) )
     => ( ( ord_less_eq @ real @ ( abs_abs @ real @ Y ) @ ( one_one @ real ) )
       => ( ( ( arcsin @ X )
            = ( arcsin @ Y ) )
          = ( X = Y ) ) ) ) ).

% arcsin_eq_iff
thf(fact_3249_arcsin__le__mono,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less_eq @ real @ ( abs_abs @ real @ X ) @ ( one_one @ real ) )
     => ( ( ord_less_eq @ real @ ( abs_abs @ real @ Y ) @ ( one_one @ real ) )
       => ( ( ord_less_eq @ real @ ( arcsin @ X ) @ ( arcsin @ Y ) )
          = ( ord_less_eq @ real @ X @ Y ) ) ) ) ).

% arcsin_le_mono
thf(fact_3250_arcsin__less__arcsin,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ X )
     => ( ( ord_less @ real @ X @ Y )
       => ( ( ord_less_eq @ real @ Y @ ( one_one @ real ) )
         => ( ord_less @ real @ ( arcsin @ X ) @ ( arcsin @ Y ) ) ) ) ) ).

% arcsin_less_arcsin
thf(fact_3251_arcsin__less__mono,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less_eq @ real @ ( abs_abs @ real @ X ) @ ( one_one @ real ) )
     => ( ( ord_less_eq @ real @ ( abs_abs @ real @ Y ) @ ( one_one @ real ) )
       => ( ( ord_less @ real @ ( arcsin @ X ) @ ( arcsin @ Y ) )
          = ( ord_less @ real @ X @ Y ) ) ) ) ).

% arcsin_less_mono
thf(fact_3252_tan__45,axiom,
    ( ( tan @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ ( bit0 @ one2 ) ) ) ) )
    = ( one_one @ real ) ) ).

% tan_45
thf(fact_3253_tan__60,axiom,
    ( ( tan @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit1 @ one2 ) ) ) )
    = ( sqrt @ ( numeral_numeral @ real @ ( bit1 @ one2 ) ) ) ) ).

% tan_60
thf(fact_3254_cos__arcsin__nonzero,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ X )
     => ( ( ord_less @ real @ X @ ( one_one @ real ) )
       => ( ( cos @ real @ ( arcsin @ X ) )
         != ( zero_zero @ real ) ) ) ) ).

% cos_arcsin_nonzero
thf(fact_3255_tan__gt__zero,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less @ real @ X @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
       => ( ord_less @ real @ ( zero_zero @ real ) @ ( tan @ real @ X ) ) ) ) ).

% tan_gt_zero
thf(fact_3256_lemma__tan__total,axiom,
    ! [Y: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ Y )
     => ? [X3: real] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ X3 )
          & ( ord_less @ real @ X3 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
          & ( ord_less @ real @ Y @ ( tan @ real @ X3 ) ) ) ) ).

% lemma_tan_total
thf(fact_3257_tan__total,axiom,
    ! [Y: real] :
    ? [X3: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ X3 )
      & ( ord_less @ real @ X3 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
      & ( ( tan @ real @ X3 )
        = Y )
      & ! [Y6: real] :
          ( ( ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ Y6 )
            & ( ord_less @ real @ Y6 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
            & ( ( tan @ real @ Y6 )
              = Y ) )
         => ( Y6 = X3 ) ) ) ).

% tan_total
thf(fact_3258_tan__monotone,axiom,
    ! [Y: real,X: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ Y )
     => ( ( ord_less @ real @ Y @ X )
       => ( ( ord_less @ real @ X @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
         => ( ord_less @ real @ ( tan @ real @ Y ) @ ( tan @ real @ X ) ) ) ) ) ).

% tan_monotone
thf(fact_3259_tan__monotone_H,axiom,
    ! [Y: real,X: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ Y )
     => ( ( ord_less @ real @ Y @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
       => ( ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ X )
         => ( ( ord_less @ real @ X @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
           => ( ( ord_less @ real @ Y @ X )
              = ( ord_less @ real @ ( tan @ real @ Y ) @ ( tan @ real @ X ) ) ) ) ) ) ) ).

% tan_monotone'
thf(fact_3260_tan__mono__lt__eq,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ X )
     => ( ( ord_less @ real @ X @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
       => ( ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ Y )
         => ( ( ord_less @ real @ Y @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
           => ( ( ord_less @ real @ ( tan @ real @ X ) @ ( tan @ real @ Y ) )
              = ( ord_less @ real @ X @ Y ) ) ) ) ) ) ).

% tan_mono_lt_eq
thf(fact_3261_lemma__tan__total1,axiom,
    ! [Y: real] :
    ? [X3: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ X3 )
      & ( ord_less @ real @ X3 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
      & ( ( tan @ real @ X3 )
        = Y ) ) ).

% lemma_tan_total1
thf(fact_3262_tan__minus__45,axiom,
    ( ( tan @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ ( bit0 @ one2 ) ) ) ) ) )
    = ( uminus_uminus @ real @ ( one_one @ real ) ) ) ).

% tan_minus_45
thf(fact_3263_tan__inverse,axiom,
    ! [Y: real] :
      ( ( divide_divide @ real @ ( one_one @ real ) @ ( tan @ real @ Y ) )
      = ( tan @ real @ ( minus_minus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ Y ) ) ) ).

% tan_inverse
thf(fact_3264_tan__cot,axiom,
    ! [X: real] :
      ( ( tan @ real @ ( minus_minus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ X ) )
      = ( inverse_inverse @ real @ ( tan @ real @ X ) ) ) ).

% tan_cot
thf(fact_3265_complex__inverse,axiom,
    ! [A2: real,B2: real] :
      ( ( inverse_inverse @ complex @ ( complex2 @ A2 @ B2 ) )
      = ( complex2 @ ( divide_divide @ real @ A2 @ ( plus_plus @ real @ ( power_power @ real @ A2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ B2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( divide_divide @ real @ ( uminus_uminus @ real @ B2 ) @ ( plus_plus @ real @ ( power_power @ real @ A2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ B2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% complex_inverse
thf(fact_3266_complex__norm,axiom,
    ! [X: real,Y: real] :
      ( ( real_V7770717601297561774m_norm @ complex @ ( complex2 @ X @ Y ) )
      = ( sqrt @ ( plus_plus @ real @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ Y @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% complex_norm
thf(fact_3267_add__tan__eq,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A,Y: A] :
          ( ( ( cos @ A @ X )
           != ( zero_zero @ A ) )
         => ( ( ( cos @ A @ Y )
             != ( zero_zero @ A ) )
           => ( ( plus_plus @ A @ ( tan @ A @ X ) @ ( tan @ A @ Y ) )
              = ( divide_divide @ A @ ( sin @ A @ ( plus_plus @ A @ X @ Y ) ) @ ( times_times @ A @ ( cos @ A @ X ) @ ( cos @ A @ Y ) ) ) ) ) ) ) ).

% add_tan_eq
thf(fact_3268_tan__cot_H,axiom,
    ! [X: real] :
      ( ( tan @ real @ ( minus_minus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ X ) )
      = ( cot @ real @ X ) ) ).

% tan_cot'
thf(fact_3269_tan__total__pos,axiom,
    ! [Y: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y )
     => ? [X3: real] :
          ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X3 )
          & ( ord_less @ real @ X3 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
          & ( ( tan @ real @ X3 )
            = Y ) ) ) ).

% tan_total_pos
thf(fact_3270_tan__pos__pi2__le,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less @ real @ X @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
       => ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( tan @ real @ X ) ) ) ) ).

% tan_pos_pi2_le
thf(fact_3271_tan__less__zero,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( divide_divide @ real @ ( uminus_uminus @ real @ pi ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ X )
     => ( ( ord_less @ real @ X @ ( zero_zero @ real ) )
       => ( ord_less @ real @ ( tan @ real @ X ) @ ( zero_zero @ real ) ) ) ) ).

% tan_less_zero
thf(fact_3272_tan__mono__le,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ X )
     => ( ( ord_less_eq @ real @ X @ Y )
       => ( ( ord_less @ real @ Y @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
         => ( ord_less_eq @ real @ ( tan @ real @ X ) @ ( tan @ real @ Y ) ) ) ) ) ).

% tan_mono_le
thf(fact_3273_tan__mono__le__eq,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ X )
     => ( ( ord_less @ real @ X @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
       => ( ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ Y )
         => ( ( ord_less @ real @ Y @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
           => ( ( ord_less_eq @ real @ ( tan @ real @ X ) @ ( tan @ real @ Y ) )
              = ( ord_less_eq @ real @ X @ Y ) ) ) ) ) ) ).

% tan_mono_le_eq
thf(fact_3274_tan__bound__pi2,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( abs_abs @ real @ X ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ ( bit0 @ one2 ) ) ) ) )
     => ( ord_less @ real @ ( abs_abs @ real @ ( tan @ real @ X ) ) @ ( one_one @ real ) ) ) ).

% tan_bound_pi2
thf(fact_3275_tan__30,axiom,
    ( ( tan @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ ( bit1 @ one2 ) ) ) ) )
    = ( divide_divide @ real @ ( one_one @ real ) @ ( sqrt @ ( numeral_numeral @ real @ ( bit1 @ one2 ) ) ) ) ) ).

% tan_30
thf(fact_3276_arctan,axiom,
    ! [Y: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ ( arctan @ Y ) )
      & ( ord_less @ real @ ( arctan @ Y ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
      & ( ( tan @ real @ ( arctan @ Y ) )
        = Y ) ) ).

% arctan
thf(fact_3277_arctan__tan,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ X )
     => ( ( ord_less @ real @ X @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
       => ( ( arctan @ ( tan @ real @ X ) )
          = X ) ) ) ).

% arctan_tan
thf(fact_3278_arctan__unique,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ X )
     => ( ( ord_less @ real @ X @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
       => ( ( ( tan @ real @ X )
            = Y )
         => ( ( arctan @ Y )
            = X ) ) ) ) ).

% arctan_unique
thf(fact_3279_lemma__tan__add1,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A,Y: A] :
          ( ( ( cos @ A @ X )
           != ( zero_zero @ A ) )
         => ( ( ( cos @ A @ Y )
             != ( zero_zero @ A ) )
           => ( ( minus_minus @ A @ ( one_one @ A ) @ ( times_times @ A @ ( tan @ A @ X ) @ ( tan @ A @ Y ) ) )
              = ( divide_divide @ A @ ( cos @ A @ ( plus_plus @ A @ X @ Y ) ) @ ( times_times @ A @ ( cos @ A @ X ) @ ( cos @ A @ Y ) ) ) ) ) ) ) ).

% lemma_tan_add1
thf(fact_3280_tan__diff,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A,Y: A] :
          ( ( ( cos @ A @ X )
           != ( zero_zero @ A ) )
         => ( ( ( cos @ A @ Y )
             != ( zero_zero @ A ) )
           => ( ( ( cos @ A @ ( minus_minus @ A @ X @ Y ) )
               != ( zero_zero @ A ) )
             => ( ( tan @ A @ ( minus_minus @ A @ X @ Y ) )
                = ( divide_divide @ A @ ( minus_minus @ A @ ( tan @ A @ X ) @ ( tan @ A @ Y ) ) @ ( plus_plus @ A @ ( one_one @ A ) @ ( times_times @ A @ ( tan @ A @ X ) @ ( tan @ A @ Y ) ) ) ) ) ) ) ) ) ).

% tan_diff
thf(fact_3281_tan__add,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A,Y: A] :
          ( ( ( cos @ A @ X )
           != ( zero_zero @ A ) )
         => ( ( ( cos @ A @ Y )
             != ( zero_zero @ A ) )
           => ( ( ( cos @ A @ ( plus_plus @ A @ X @ Y ) )
               != ( zero_zero @ A ) )
             => ( ( tan @ A @ ( plus_plus @ A @ X @ Y ) )
                = ( divide_divide @ A @ ( plus_plus @ A @ ( tan @ A @ X ) @ ( tan @ A @ Y ) ) @ ( minus_minus @ A @ ( one_one @ A ) @ ( times_times @ A @ ( tan @ A @ X ) @ ( tan @ A @ Y ) ) ) ) ) ) ) ) ) ).

% tan_add
thf(fact_3282_tan__total__pi4,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( abs_abs @ real @ X ) @ ( one_one @ real ) )
     => ? [Z3: real] :
          ( ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ ( bit0 @ one2 ) ) ) ) ) @ Z3 )
          & ( ord_less @ real @ Z3 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ ( bit0 @ one2 ) ) ) ) )
          & ( ( tan @ real @ Z3 )
            = X ) ) ) ).

% tan_total_pi4
thf(fact_3283_arcsin__lt__bounded,axiom,
    ! [Y: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ Y )
     => ( ( ord_less @ real @ Y @ ( one_one @ real ) )
       => ( ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ ( arcsin @ Y ) )
          & ( ord_less @ real @ ( arcsin @ Y ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% arcsin_lt_bounded
thf(fact_3284_arcsin__lbound,axiom,
    ! [Y: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ Y )
     => ( ( ord_less_eq @ real @ Y @ ( one_one @ real ) )
       => ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ ( arcsin @ Y ) ) ) ) ).

% arcsin_lbound
thf(fact_3285_arcsin__ubound,axiom,
    ! [Y: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ Y )
     => ( ( ord_less_eq @ real @ Y @ ( one_one @ real ) )
       => ( ord_less_eq @ real @ ( arcsin @ Y ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ).

% arcsin_ubound
thf(fact_3286_arcsin__bounded,axiom,
    ! [Y: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ Y )
     => ( ( ord_less_eq @ real @ Y @ ( one_one @ real ) )
       => ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ ( arcsin @ Y ) )
          & ( ord_less_eq @ real @ ( arcsin @ Y ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% arcsin_bounded
thf(fact_3287_arcsin__sin,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ X )
     => ( ( ord_less_eq @ real @ X @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
       => ( ( arcsin @ ( sin @ real @ X ) )
          = X ) ) ) ).

% arcsin_sin
thf(fact_3288_tan__sec,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A] :
          ( ( ( cos @ A @ X )
           != ( zero_zero @ A ) )
         => ( ( plus_plus @ A @ ( one_one @ A ) @ ( power_power @ A @ ( tan @ A @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
            = ( power_power @ A @ ( inverse_inverse @ A @ ( cos @ A @ X ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% tan_sec
thf(fact_3289_tan__half,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ( ( tan @ A )
        = ( ^ [X2: A] : ( divide_divide @ A @ ( sin @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ X2 ) ) @ ( plus_plus @ A @ ( cos @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ X2 ) ) @ ( one_one @ A ) ) ) ) ) ) ).

% tan_half
thf(fact_3290_arcsin,axiom,
    ! [Y: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ Y )
     => ( ( ord_less_eq @ real @ Y @ ( one_one @ real ) )
       => ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ ( arcsin @ Y ) )
          & ( ord_less_eq @ real @ ( arcsin @ Y ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
          & ( ( sin @ real @ ( arcsin @ Y ) )
            = Y ) ) ) ) ).

% arcsin
thf(fact_3291_arcsin__pi,axiom,
    ! [Y: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ Y )
     => ( ( ord_less_eq @ real @ Y @ ( one_one @ real ) )
       => ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ ( arcsin @ Y ) )
          & ( ord_less_eq @ real @ ( arcsin @ Y ) @ pi )
          & ( ( sin @ real @ ( arcsin @ Y ) )
            = Y ) ) ) ) ).

% arcsin_pi
thf(fact_3292_arcsin__le__iff,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ X )
     => ( ( ord_less_eq @ real @ X @ ( one_one @ real ) )
       => ( ( ord_less_eq @ real @ ( divide_divide @ real @ ( uminus_uminus @ real @ pi ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ Y )
         => ( ( ord_less_eq @ real @ Y @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
           => ( ( ord_less_eq @ real @ ( arcsin @ X ) @ Y )
              = ( ord_less_eq @ real @ X @ ( sin @ real @ Y ) ) ) ) ) ) ) ).

% arcsin_le_iff
thf(fact_3293_le__arcsin__iff,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ X )
     => ( ( ord_less_eq @ real @ X @ ( one_one @ real ) )
       => ( ( ord_less_eq @ real @ ( divide_divide @ real @ ( uminus_uminus @ real @ pi ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ Y )
         => ( ( ord_less_eq @ real @ Y @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
           => ( ( ord_less_eq @ real @ Y @ ( arcsin @ X ) )
              = ( ord_less_eq @ real @ ( sin @ real @ Y ) @ X ) ) ) ) ) ) ).

% le_arcsin_iff
thf(fact_3294_sin__arccos__abs,axiom,
    ! [Y: real] :
      ( ( ord_less_eq @ real @ ( abs_abs @ real @ Y ) @ ( one_one @ real ) )
     => ( ( sin @ real @ ( arccos @ Y ) )
        = ( sqrt @ ( minus_minus @ real @ ( one_one @ real ) @ ( power_power @ real @ Y @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% sin_arccos_abs
thf(fact_3295_sin__arccos,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ X )
     => ( ( ord_less_eq @ real @ X @ ( one_one @ real ) )
       => ( ( sin @ real @ ( arccos @ X ) )
          = ( sqrt @ ( minus_minus @ real @ ( one_one @ real ) @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% sin_arccos
thf(fact_3296_arccos__cos__eq__abs__2pi,axiom,
    ! [Theta: real] :
      ~ ! [K2: int] :
          ( ( arccos @ ( cos @ real @ Theta ) )
         != ( abs_abs @ real @ ( minus_minus @ real @ Theta @ ( times_times @ real @ ( ring_1_of_int @ real @ K2 ) @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) ) ) ) ) ).

% arccos_cos_eq_abs_2pi
thf(fact_3297_signed__take__bit__eq__take__bit__minus,axiom,
    ( ( bit_ri4674362597316999326ke_bit @ int )
    = ( ^ [N3: nat,K3: int] : ( minus_minus @ int @ ( bit_se2584673776208193580ke_bit @ int @ ( suc @ N3 ) @ K3 ) @ ( times_times @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( suc @ N3 ) ) @ ( zero_neq_one_of_bool @ int @ ( bit_se5641148757651400278ts_bit @ int @ K3 @ N3 ) ) ) ) ) ) ).

% signed_take_bit_eq_take_bit_minus
thf(fact_3298_modulo__int__def,axiom,
    ( ( modulo_modulo @ int )
    = ( ^ [K3: int,L2: int] :
          ( if @ int
          @ ( L2
            = ( zero_zero @ int ) )
          @ K3
          @ ( if @ int
            @ ( ( sgn_sgn @ int @ K3 )
              = ( sgn_sgn @ int @ L2 ) )
            @ ( times_times @ int @ ( sgn_sgn @ int @ L2 ) @ ( semiring_1_of_nat @ int @ ( modulo_modulo @ nat @ ( nat2 @ ( abs_abs @ int @ K3 ) ) @ ( nat2 @ ( abs_abs @ int @ L2 ) ) ) ) )
            @ ( times_times @ int @ ( sgn_sgn @ int @ L2 )
              @ ( minus_minus @ int
                @ ( times_times @ int @ ( abs_abs @ int @ L2 )
                  @ ( zero_neq_one_of_bool @ int
                    @ ~ ( dvd_dvd @ int @ L2 @ K3 ) ) )
                @ ( semiring_1_of_nat @ int @ ( modulo_modulo @ nat @ ( nat2 @ ( abs_abs @ int @ K3 ) ) @ ( nat2 @ ( abs_abs @ int @ L2 ) ) ) ) ) ) ) ) ) ) ).

% modulo_int_def
thf(fact_3299_sgn__0,axiom,
    ! [A: $tType] :
      ( ( idom_abs_sgn @ A )
     => ( ( sgn_sgn @ A @ ( zero_zero @ A ) )
        = ( zero_zero @ A ) ) ) ).

% sgn_0
thf(fact_3300_sgn__zero,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ( ( sgn_sgn @ A @ ( zero_zero @ A ) )
        = ( zero_zero @ A ) ) ) ).

% sgn_zero
thf(fact_3301_power__sgn,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A,N: nat] :
          ( ( sgn_sgn @ A @ ( power_power @ A @ A2 @ N ) )
          = ( power_power @ A @ ( sgn_sgn @ A @ A2 ) @ N ) ) ) ).

% power_sgn
thf(fact_3302_sgn__less,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( sgn_sgn @ A @ A2 ) @ ( zero_zero @ A ) )
          = ( ord_less @ A @ A2 @ ( zero_zero @ A ) ) ) ) ).

% sgn_less
thf(fact_3303_sgn__greater,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( sgn_sgn @ A @ A2 ) )
          = ( ord_less @ A @ ( zero_zero @ A ) @ A2 ) ) ) ).

% sgn_greater
thf(fact_3304_arccos__1,axiom,
    ( ( arccos @ ( one_one @ real ) )
    = ( zero_zero @ real ) ) ).

% arccos_1
thf(fact_3305_sgn__pos,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( sgn_sgn @ A @ A2 )
            = ( one_one @ A ) ) ) ) ).

% sgn_pos
thf(fact_3306_bit__numeral__Bit0__Suc__iff,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [M: num,N: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( numeral_numeral @ A @ ( bit0 @ M ) ) @ ( suc @ N ) )
          = ( bit_se5641148757651400278ts_bit @ A @ ( numeral_numeral @ A @ M ) @ N ) ) ) ).

% bit_numeral_Bit0_Suc_iff
thf(fact_3307_abs__sgn__eq__1,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( abs_abs @ A @ ( sgn_sgn @ A @ A2 ) )
            = ( one_one @ A ) ) ) ) ).

% abs_sgn_eq_1
thf(fact_3308_bit__numeral__Bit1__Suc__iff,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [M: num,N: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( numeral_numeral @ A @ ( bit1 @ M ) ) @ ( suc @ N ) )
          = ( bit_se5641148757651400278ts_bit @ A @ ( numeral_numeral @ A @ M ) @ N ) ) ) ).

% bit_numeral_Bit1_Suc_iff
thf(fact_3309_sgn__mult__self__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A] :
          ( ( times_times @ A @ ( sgn_sgn @ A @ A2 ) @ ( sgn_sgn @ A @ A2 ) )
          = ( zero_neq_one_of_bool @ A
            @ ( A2
             != ( zero_zero @ A ) ) ) ) ) ).

% sgn_mult_self_eq
thf(fact_3310_sgn__abs,axiom,
    ! [A: $tType] :
      ( ( idom_abs_sgn @ A )
     => ! [A2: A] :
          ( ( abs_abs @ A @ ( sgn_sgn @ A @ A2 ) )
          = ( zero_neq_one_of_bool @ A
            @ ( A2
             != ( zero_zero @ A ) ) ) ) ) ).

% sgn_abs
thf(fact_3311_idom__abs__sgn__class_Oabs__sgn,axiom,
    ! [A: $tType] :
      ( ( idom_abs_sgn @ A )
     => ! [A2: A] :
          ( ( sgn_sgn @ A @ ( abs_abs @ A @ A2 ) )
          = ( zero_neq_one_of_bool @ A
            @ ( A2
             != ( zero_zero @ A ) ) ) ) ) ).

% idom_abs_sgn_class.abs_sgn
thf(fact_3312_sgn__mult__dvd__iff,axiom,
    ! [R2: int,L: int,K: int] :
      ( ( dvd_dvd @ int @ ( times_times @ int @ ( sgn_sgn @ int @ R2 ) @ L ) @ K )
      = ( ( dvd_dvd @ int @ L @ K )
        & ( ( R2
            = ( zero_zero @ int ) )
         => ( K
            = ( zero_zero @ int ) ) ) ) ) ).

% sgn_mult_dvd_iff
thf(fact_3313_mult__sgn__dvd__iff,axiom,
    ! [L: int,R2: int,K: int] :
      ( ( dvd_dvd @ int @ ( times_times @ int @ L @ ( sgn_sgn @ int @ R2 ) ) @ K )
      = ( ( dvd_dvd @ int @ L @ K )
        & ( ( R2
            = ( zero_zero @ int ) )
         => ( K
            = ( zero_zero @ int ) ) ) ) ) ).

% mult_sgn_dvd_iff
thf(fact_3314_dvd__sgn__mult__iff,axiom,
    ! [L: int,R2: int,K: int] :
      ( ( dvd_dvd @ int @ L @ ( times_times @ int @ ( sgn_sgn @ int @ R2 ) @ K ) )
      = ( ( dvd_dvd @ int @ L @ K )
        | ( R2
          = ( zero_zero @ int ) ) ) ) ).

% dvd_sgn_mult_iff
thf(fact_3315_dvd__mult__sgn__iff,axiom,
    ! [L: int,K: int,R2: int] :
      ( ( dvd_dvd @ int @ L @ ( times_times @ int @ K @ ( sgn_sgn @ int @ R2 ) ) )
      = ( ( dvd_dvd @ int @ L @ K )
        | ( R2
          = ( zero_zero @ int ) ) ) ) ).

% dvd_mult_sgn_iff
thf(fact_3316_signed__take__bit__nonnegative__iff,axiom,
    ! [N: nat,K: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( bit_ri4674362597316999326ke_bit @ int @ N @ K ) )
      = ( ~ ( bit_se5641148757651400278ts_bit @ int @ K @ N ) ) ) ).

% signed_take_bit_nonnegative_iff
thf(fact_3317_signed__take__bit__negative__iff,axiom,
    ! [N: nat,K: int] :
      ( ( ord_less @ int @ ( bit_ri4674362597316999326ke_bit @ int @ N @ K ) @ ( zero_zero @ int ) )
      = ( bit_se5641148757651400278ts_bit @ int @ K @ N ) ) ).

% signed_take_bit_negative_iff
thf(fact_3318_sgn__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A] :
          ( ( ord_less @ A @ A2 @ ( zero_zero @ A ) )
         => ( ( sgn_sgn @ A @ A2 )
            = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ) ).

% sgn_neg
thf(fact_3319_sgn__of__nat,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N: nat] :
          ( ( sgn_sgn @ A @ ( semiring_1_of_nat @ A @ N ) )
          = ( zero_neq_one_of_bool @ A @ ( ord_less @ nat @ ( zero_zero @ nat ) @ N ) ) ) ) ).

% sgn_of_nat
thf(fact_3320_bit__numeral__simps_I2_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [W: num,N: num] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( numeral_numeral @ A @ ( bit0 @ W ) ) @ ( numeral_numeral @ nat @ N ) )
          = ( bit_se5641148757651400278ts_bit @ A @ ( numeral_numeral @ A @ W ) @ ( pred_numeral @ N ) ) ) ) ).

% bit_numeral_simps(2)
thf(fact_3321_bit__minus__numeral__Bit0__Suc__iff,axiom,
    ! [W: num,N: nat] :
      ( ( bit_se5641148757651400278ts_bit @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit0 @ W ) ) ) @ ( suc @ N ) )
      = ( bit_se5641148757651400278ts_bit @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ W ) ) @ N ) ) ).

% bit_minus_numeral_Bit0_Suc_iff
thf(fact_3322_bit__numeral__simps_I3_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [W: num,N: num] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( numeral_numeral @ A @ ( bit1 @ W ) ) @ ( numeral_numeral @ nat @ N ) )
          = ( bit_se5641148757651400278ts_bit @ A @ ( numeral_numeral @ A @ W ) @ ( pred_numeral @ N ) ) ) ) ).

% bit_numeral_simps(3)
thf(fact_3323_bit__minus__numeral__Bit1__Suc__iff,axiom,
    ! [W: num,N: nat] :
      ( ( bit_se5641148757651400278ts_bit @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit1 @ W ) ) ) @ ( suc @ N ) )
      = ( ~ ( bit_se5641148757651400278ts_bit @ int @ ( numeral_numeral @ int @ W ) @ N ) ) ) ).

% bit_minus_numeral_Bit1_Suc_iff
thf(fact_3324_cos__arccos,axiom,
    ! [Y: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ Y )
     => ( ( ord_less_eq @ real @ Y @ ( one_one @ real ) )
       => ( ( cos @ real @ ( arccos @ Y ) )
          = Y ) ) ) ).

% cos_arccos
thf(fact_3325_bit__0,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A] :
          ( ( bit_se5641148757651400278ts_bit @ A @ A2 @ ( zero_zero @ nat ) )
          = ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) ) ) ) ).

% bit_0
thf(fact_3326_bit__minus__numeral__int_I1_J,axiom,
    ! [W: num,N: num] :
      ( ( bit_se5641148757651400278ts_bit @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit0 @ W ) ) ) @ ( numeral_numeral @ nat @ N ) )
      = ( bit_se5641148757651400278ts_bit @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ W ) ) @ ( pred_numeral @ N ) ) ) ).

% bit_minus_numeral_int(1)
thf(fact_3327_bit__minus__numeral__int_I2_J,axiom,
    ! [W: num,N: num] :
      ( ( bit_se5641148757651400278ts_bit @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit1 @ W ) ) ) @ ( numeral_numeral @ nat @ N ) )
      = ( ~ ( bit_se5641148757651400278ts_bit @ int @ ( numeral_numeral @ int @ W ) @ ( pred_numeral @ N ) ) ) ) ).

% bit_minus_numeral_int(2)
thf(fact_3328_bit__mod__2__iff,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A,N: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ N )
          = ( ( N
              = ( zero_zero @ nat ) )
            & ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) ) ) ) ).

% bit_mod_2_iff
thf(fact_3329_arccos__0,axiom,
    ( ( arccos @ ( zero_zero @ real ) )
    = ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ).

% arccos_0
thf(fact_3330_bit__and__iff,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A,B2: A,N: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( bit_se5824344872417868541ns_and @ A @ A2 @ B2 ) @ N )
          = ( ( bit_se5641148757651400278ts_bit @ A @ A2 @ N )
            & ( bit_se5641148757651400278ts_bit @ A @ B2 @ N ) ) ) ) ).

% bit_and_iff
thf(fact_3331_bit__or__iff,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A,B2: A,N: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( bit_se1065995026697491101ons_or @ A @ A2 @ B2 ) @ N )
          = ( ( bit_se5641148757651400278ts_bit @ A @ A2 @ N )
            | ( bit_se5641148757651400278ts_bit @ A @ B2 @ N ) ) ) ) ).

% bit_or_iff
thf(fact_3332_bit__numeral__iff,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [M: num,N: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( numeral_numeral @ A @ M ) @ N )
          = ( bit_se5641148757651400278ts_bit @ nat @ ( numeral_numeral @ nat @ M ) @ N ) ) ) ).

% bit_numeral_iff
thf(fact_3333_bit__of__nat__iff__bit,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [M: nat,N: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( semiring_1_of_nat @ A @ M ) @ N )
          = ( bit_se5641148757651400278ts_bit @ nat @ M @ N ) ) ) ).

% bit_of_nat_iff_bit
thf(fact_3334_sgn__zero__iff,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X: A] :
          ( ( ( sgn_sgn @ A @ X )
            = ( zero_zero @ A ) )
          = ( X
            = ( zero_zero @ A ) ) ) ) ).

% sgn_zero_iff
thf(fact_3335_sgn__0__0,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A] :
          ( ( ( sgn_sgn @ A @ A2 )
            = ( zero_zero @ A ) )
          = ( A2
            = ( zero_zero @ A ) ) ) ) ).

% sgn_0_0
thf(fact_3336_sgn__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( idom_abs_sgn @ A )
     => ! [A2: A] :
          ( ( ( sgn_sgn @ A @ A2 )
            = ( zero_zero @ A ) )
          = ( A2
            = ( zero_zero @ A ) ) ) ) ).

% sgn_eq_0_iff
thf(fact_3337_bit__disjunctive__add__iff,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A,B2: A,N: nat] :
          ( ! [N2: nat] :
              ( ~ ( bit_se5641148757651400278ts_bit @ A @ A2 @ N2 )
              | ~ ( bit_se5641148757651400278ts_bit @ A @ B2 @ N2 ) )
         => ( ( bit_se5641148757651400278ts_bit @ A @ ( plus_plus @ A @ A2 @ B2 ) @ N )
            = ( ( bit_se5641148757651400278ts_bit @ A @ A2 @ N )
              | ( bit_se5641148757651400278ts_bit @ A @ B2 @ N ) ) ) ) ) ).

% bit_disjunctive_add_iff
thf(fact_3338_bit__xor__iff,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A,B2: A,N: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( bit_se5824344971392196577ns_xor @ A @ A2 @ B2 ) @ N )
          = ( ( ( bit_se5641148757651400278ts_bit @ A @ A2 @ N )
             != ( bit_se5641148757651400278ts_bit @ A @ B2 @ N ) ) ) ) ) ).

% bit_xor_iff
thf(fact_3339_bit__not__int__iff,axiom,
    ! [K: int,N: nat] :
      ( ( bit_se5641148757651400278ts_bit @ int @ ( bit_ri4277139882892585799ns_not @ int @ K ) @ N )
      = ( ~ ( bit_se5641148757651400278ts_bit @ int @ K @ N ) ) ) ).

% bit_not_int_iff
thf(fact_3340_bit__and__int__iff,axiom,
    ! [K: int,L: int,N: nat] :
      ( ( bit_se5641148757651400278ts_bit @ int @ ( bit_se5824344872417868541ns_and @ int @ K @ L ) @ N )
      = ( ( bit_se5641148757651400278ts_bit @ int @ K @ N )
        & ( bit_se5641148757651400278ts_bit @ int @ L @ N ) ) ) ).

% bit_and_int_iff
thf(fact_3341_bit__unset__bit__iff,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M: nat,A2: A,N: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( bit_se2638667681897837118et_bit @ A @ M @ A2 ) @ N )
          = ( ( bit_se5641148757651400278ts_bit @ A @ A2 @ N )
            & ( M != N ) ) ) ) ).

% bit_unset_bit_iff
thf(fact_3342_bit__or__int__iff,axiom,
    ! [K: int,L: int,N: nat] :
      ( ( bit_se5641148757651400278ts_bit @ int @ ( bit_se1065995026697491101ons_or @ int @ K @ L ) @ N )
      = ( ( bit_se5641148757651400278ts_bit @ int @ K @ N )
        | ( bit_se5641148757651400278ts_bit @ int @ L @ N ) ) ) ).

% bit_or_int_iff
thf(fact_3343_bit__xor__int__iff,axiom,
    ! [K: int,L: int,N: nat] :
      ( ( bit_se5641148757651400278ts_bit @ int @ ( bit_se5824344971392196577ns_xor @ int @ K @ L ) @ N )
      = ( ( ( bit_se5641148757651400278ts_bit @ int @ K @ N )
         != ( bit_se5641148757651400278ts_bit @ int @ L @ N ) ) ) ) ).

% bit_xor_int_iff
thf(fact_3344_not__bit__1__Suc,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat] :
          ~ ( bit_se5641148757651400278ts_bit @ A @ ( one_one @ A ) @ ( suc @ N ) ) ) ).

% not_bit_1_Suc
thf(fact_3345_bit__1__iff,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [N: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( one_one @ A ) @ N )
          = ( N
            = ( zero_zero @ nat ) ) ) ) ).

% bit_1_iff
thf(fact_3346_bit__numeral__simps_I1_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [N: num] :
          ~ ( bit_se5641148757651400278ts_bit @ A @ ( one_one @ A ) @ ( numeral_numeral @ nat @ N ) ) ) ).

% bit_numeral_simps(1)
thf(fact_3347_disjunctive__add,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A,B2: A] :
          ( ! [N2: nat] :
              ( ~ ( bit_se5641148757651400278ts_bit @ A @ A2 @ N2 )
              | ~ ( bit_se5641148757651400278ts_bit @ A @ B2 @ N2 ) )
         => ( ( plus_plus @ A @ A2 @ B2 )
            = ( bit_se1065995026697491101ons_or @ A @ A2 @ B2 ) ) ) ) ).

% disjunctive_add
thf(fact_3348_bit__take__bit__iff,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M: nat,A2: A,N: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( bit_se2584673776208193580ke_bit @ A @ M @ A2 ) @ N )
          = ( ( ord_less @ nat @ N @ M )
            & ( bit_se5641148757651400278ts_bit @ A @ A2 @ N ) ) ) ) ).

% bit_take_bit_iff
thf(fact_3349_sgn__not__eq__imp,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [B2: A,A2: A] :
          ( ( ( sgn_sgn @ A @ B2 )
           != ( sgn_sgn @ A @ A2 ) )
         => ( ( ( sgn_sgn @ A @ A2 )
             != ( zero_zero @ A ) )
           => ( ( ( sgn_sgn @ A @ B2 )
               != ( zero_zero @ A ) )
             => ( ( sgn_sgn @ A @ A2 )
                = ( uminus_uminus @ A @ ( sgn_sgn @ A @ B2 ) ) ) ) ) ) ) ).

% sgn_not_eq_imp
thf(fact_3350_bit__of__bool__iff,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [B2: $o,N: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( zero_neq_one_of_bool @ A @ B2 ) @ N )
          = ( B2
            & ( N
              = ( zero_zero @ nat ) ) ) ) ) ).

% bit_of_bool_iff
thf(fact_3351_int__sgnE,axiom,
    ! [K: int] :
      ~ ! [N2: nat,L3: int] :
          ( K
         != ( times_times @ int @ ( sgn_sgn @ int @ L3 ) @ ( semiring_1_of_nat @ int @ N2 ) ) ) ).

% int_sgnE
thf(fact_3352_signed__take__bit__eq__if__positive,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [A2: A,N: nat] :
          ( ~ ( bit_se5641148757651400278ts_bit @ A @ A2 @ N )
         => ( ( bit_ri4674362597316999326ke_bit @ A @ N @ A2 )
            = ( bit_se2584673776208193580ke_bit @ A @ N @ A2 ) ) ) ) ).

% signed_take_bit_eq_if_positive
thf(fact_3353_sgn__1__pos,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A] :
          ( ( ( sgn_sgn @ A @ A2 )
            = ( one_one @ A ) )
          = ( ord_less @ A @ ( zero_zero @ A ) @ A2 ) ) ) ).

% sgn_1_pos
thf(fact_3354_disjunctive__diff,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [B2: A,A2: A] :
          ( ! [N2: nat] :
              ( ( bit_se5641148757651400278ts_bit @ A @ B2 @ N2 )
             => ( bit_se5641148757651400278ts_bit @ A @ A2 @ N2 ) )
         => ( ( minus_minus @ A @ A2 @ B2 )
            = ( bit_se5824344872417868541ns_and @ A @ A2 @ ( bit_ri4277139882892585799ns_not @ A @ B2 ) ) ) ) ) ).

% disjunctive_diff
thf(fact_3355_abs__sgn__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A] :
          ( ( ( A2
              = ( zero_zero @ A ) )
           => ( ( abs_abs @ A @ ( sgn_sgn @ A @ A2 ) )
              = ( zero_zero @ A ) ) )
          & ( ( A2
             != ( zero_zero @ A ) )
           => ( ( abs_abs @ A @ ( sgn_sgn @ A @ A2 ) )
              = ( one_one @ A ) ) ) ) ) ).

% abs_sgn_eq
thf(fact_3356_bit__not__int__iff_H,axiom,
    ! [K: int,N: nat] :
      ( ( bit_se5641148757651400278ts_bit @ int @ ( minus_minus @ int @ ( uminus_uminus @ int @ K ) @ ( one_one @ int ) ) @ N )
      = ( ~ ( bit_se5641148757651400278ts_bit @ int @ K @ N ) ) ) ).

% bit_not_int_iff'
thf(fact_3357_sgn__mod,axiom,
    ! [L: int,K: int] :
      ( ( L
       != ( zero_zero @ int ) )
     => ( ~ ( dvd_dvd @ int @ L @ K )
       => ( ( sgn_sgn @ int @ ( modulo_modulo @ int @ K @ L ) )
          = ( sgn_sgn @ int @ L ) ) ) ) ).

% sgn_mod
thf(fact_3358_flip__bit__eq__if,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se8732182000553998342ip_bit @ A )
        = ( ^ [N3: nat,A3: A] : ( if @ ( nat > A > A ) @ ( bit_se5641148757651400278ts_bit @ A @ A3 @ N3 ) @ ( bit_se2638667681897837118et_bit @ A ) @ ( bit_se5668285175392031749et_bit @ A ) @ N3 @ A3 ) ) ) ) ).

% flip_bit_eq_if
thf(fact_3359_arccos__le__arccos,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ X )
     => ( ( ord_less_eq @ real @ X @ Y )
       => ( ( ord_less_eq @ real @ Y @ ( one_one @ real ) )
         => ( ord_less_eq @ real @ ( arccos @ Y ) @ ( arccos @ X ) ) ) ) ) ).

% arccos_le_arccos
thf(fact_3360_arccos__le__mono,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less_eq @ real @ ( abs_abs @ real @ X ) @ ( one_one @ real ) )
     => ( ( ord_less_eq @ real @ ( abs_abs @ real @ Y ) @ ( one_one @ real ) )
       => ( ( ord_less_eq @ real @ ( arccos @ X ) @ ( arccos @ Y ) )
          = ( ord_less_eq @ real @ Y @ X ) ) ) ) ).

% arccos_le_mono
thf(fact_3361_arccos__eq__iff,axiom,
    ! [X: real,Y: real] :
      ( ( ( ord_less_eq @ real @ ( abs_abs @ real @ X ) @ ( one_one @ real ) )
        & ( ord_less_eq @ real @ ( abs_abs @ real @ Y ) @ ( one_one @ real ) ) )
     => ( ( ( arccos @ X )
          = ( arccos @ Y ) )
        = ( X = Y ) ) ) ).

% arccos_eq_iff
thf(fact_3362_sgn__if,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ( ( sgn_sgn @ A )
        = ( ^ [X2: A] :
              ( if @ A
              @ ( X2
                = ( zero_zero @ A ) )
              @ ( zero_zero @ A )
              @ ( if @ A @ ( ord_less @ A @ ( zero_zero @ A ) @ X2 ) @ ( one_one @ A ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ) ) ) ).

% sgn_if
thf(fact_3363_sgn__1__neg,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A] :
          ( ( ( sgn_sgn @ A @ A2 )
            = ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( ord_less @ A @ A2 @ ( zero_zero @ A ) ) ) ) ).

% sgn_1_neg
thf(fact_3364_zsgn__def,axiom,
    ( ( sgn_sgn @ int )
    = ( ^ [I4: int] :
          ( if @ int
          @ ( I4
            = ( zero_zero @ int ) )
          @ ( zero_zero @ int )
          @ ( if @ int @ ( ord_less @ int @ ( zero_zero @ int ) @ I4 ) @ ( one_one @ int ) @ ( uminus_uminus @ int @ ( one_one @ int ) ) ) ) ) ) ).

% zsgn_def
thf(fact_3365_norm__sgn,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X: A] :
          ( ( ( X
              = ( zero_zero @ A ) )
           => ( ( real_V7770717601297561774m_norm @ A @ ( sgn_sgn @ A @ X ) )
              = ( zero_zero @ real ) ) )
          & ( ( X
             != ( zero_zero @ A ) )
           => ( ( real_V7770717601297561774m_norm @ A @ ( sgn_sgn @ A @ X ) )
              = ( one_one @ real ) ) ) ) ) ).

% norm_sgn
thf(fact_3366_div__sgn__abs__cancel,axiom,
    ! [V: int,K: int,L: int] :
      ( ( V
       != ( zero_zero @ int ) )
     => ( ( divide_divide @ int @ ( times_times @ int @ ( sgn_sgn @ int @ V ) @ ( abs_abs @ int @ K ) ) @ ( times_times @ int @ ( sgn_sgn @ int @ V ) @ ( abs_abs @ int @ L ) ) )
        = ( divide_divide @ int @ ( abs_abs @ int @ K ) @ ( abs_abs @ int @ L ) ) ) ) ).

% div_sgn_abs_cancel
thf(fact_3367_bit__imp__take__bit__positive,axiom,
    ! [N: nat,M: nat,K: int] :
      ( ( ord_less @ nat @ N @ M )
     => ( ( bit_se5641148757651400278ts_bit @ int @ K @ N )
       => ( ord_less @ int @ ( zero_zero @ int ) @ ( bit_se2584673776208193580ke_bit @ int @ M @ K ) ) ) ) ).

% bit_imp_take_bit_positive
thf(fact_3368_bit__concat__bit__iff,axiom,
    ! [M: nat,K: int,L: int,N: nat] :
      ( ( bit_se5641148757651400278ts_bit @ int @ ( bit_concat_bit @ M @ K @ L ) @ N )
      = ( ( ( ord_less @ nat @ N @ M )
          & ( bit_se5641148757651400278ts_bit @ int @ K @ N ) )
        | ( ( ord_less_eq @ nat @ M @ N )
          & ( bit_se5641148757651400278ts_bit @ int @ L @ ( minus_minus @ nat @ N @ M ) ) ) ) ) ).

% bit_concat_bit_iff
thf(fact_3369_bit__minus__int__iff,axiom,
    ! [K: int,N: nat] :
      ( ( bit_se5641148757651400278ts_bit @ int @ ( uminus_uminus @ int @ K ) @ N )
      = ( bit_se5641148757651400278ts_bit @ int @ ( bit_ri4277139882892585799ns_not @ int @ ( minus_minus @ int @ K @ ( one_one @ int ) ) ) @ N ) ) ).

% bit_minus_int_iff
thf(fact_3370_signed__take__bit__eq__concat__bit,axiom,
    ( ( bit_ri4674362597316999326ke_bit @ int )
    = ( ^ [N3: nat,K3: int] : ( bit_concat_bit @ N3 @ K3 @ ( uminus_uminus @ int @ ( zero_neq_one_of_bool @ int @ ( bit_se5641148757651400278ts_bit @ int @ K3 @ N3 ) ) ) ) ) ) ).

% signed_take_bit_eq_concat_bit
thf(fact_3371_exp__eq__0__imp__not__bit,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [N: nat,A2: A] :
          ( ( ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N )
            = ( zero_zero @ A ) )
         => ~ ( bit_se5641148757651400278ts_bit @ A @ A2 @ N ) ) ) ).

% exp_eq_0_imp_not_bit
thf(fact_3372_bit__Suc,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A,N: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ A2 @ ( suc @ N ) )
          = ( bit_se5641148757651400278ts_bit @ A @ ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ N ) ) ) ).

% bit_Suc
thf(fact_3373_bit__iff__idd__imp__stable,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A] :
          ( ! [N2: nat] :
              ( ( bit_se5641148757651400278ts_bit @ A @ A2 @ N2 )
              = ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) ) )
         => ( ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
            = A2 ) ) ) ).

% bit_iff_idd_imp_stable
thf(fact_3374_stable__imp__bit__iff__odd,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A,N: nat] :
          ( ( ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
            = A2 )
         => ( ( bit_se5641148757651400278ts_bit @ A @ A2 @ N )
            = ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) ) ) ) ) ).

% stable_imp_bit_iff_odd
thf(fact_3375_arccos__lbound,axiom,
    ! [Y: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ Y )
     => ( ( ord_less_eq @ real @ Y @ ( one_one @ real ) )
       => ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( arccos @ Y ) ) ) ) ).

% arccos_lbound
thf(fact_3376_arccos__less__arccos,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ X )
     => ( ( ord_less @ real @ X @ Y )
       => ( ( ord_less_eq @ real @ Y @ ( one_one @ real ) )
         => ( ord_less @ real @ ( arccos @ Y ) @ ( arccos @ X ) ) ) ) ) ).

% arccos_less_arccos
thf(fact_3377_arccos__less__mono,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less_eq @ real @ ( abs_abs @ real @ X ) @ ( one_one @ real ) )
     => ( ( ord_less_eq @ real @ ( abs_abs @ real @ Y ) @ ( one_one @ real ) )
       => ( ( ord_less @ real @ ( arccos @ X ) @ ( arccos @ Y ) )
          = ( ord_less @ real @ Y @ X ) ) ) ) ).

% arccos_less_mono
thf(fact_3378_arccos__ubound,axiom,
    ! [Y: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ Y )
     => ( ( ord_less_eq @ real @ Y @ ( one_one @ real ) )
       => ( ord_less_eq @ real @ ( arccos @ Y ) @ pi ) ) ) ).

% arccos_ubound
thf(fact_3379_arccos__cos,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less_eq @ real @ X @ pi )
       => ( ( arccos @ ( cos @ real @ X ) )
          = X ) ) ) ).

% arccos_cos
thf(fact_3380_int__bit__bound,axiom,
    ! [K: int] :
      ~ ! [N2: nat] :
          ( ! [M2: nat] :
              ( ( ord_less_eq @ nat @ N2 @ M2 )
             => ( ( bit_se5641148757651400278ts_bit @ int @ K @ M2 )
                = ( bit_se5641148757651400278ts_bit @ int @ K @ N2 ) ) )
         => ~ ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
             => ( ( bit_se5641148757651400278ts_bit @ int @ K @ ( minus_minus @ nat @ N2 @ ( one_one @ nat ) ) )
                = ( ~ ( bit_se5641148757651400278ts_bit @ int @ K @ N2 ) ) ) ) ) ).

% int_bit_bound
thf(fact_3381_cos__arccos__abs,axiom,
    ! [Y: real] :
      ( ( ord_less_eq @ real @ ( abs_abs @ real @ Y ) @ ( one_one @ real ) )
     => ( ( cos @ real @ ( arccos @ Y ) )
        = Y ) ) ).

% cos_arccos_abs
thf(fact_3382_arccos__cos__eq__abs,axiom,
    ! [Theta: real] :
      ( ( ord_less_eq @ real @ ( abs_abs @ real @ Theta ) @ pi )
     => ( ( arccos @ ( cos @ real @ Theta ) )
        = ( abs_abs @ real @ Theta ) ) ) ).

% arccos_cos_eq_abs
thf(fact_3383_signed__take__bit__eq__if__negative,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [A2: A,N: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ A2 @ N )
         => ( ( bit_ri4674362597316999326ke_bit @ A @ N @ A2 )
            = ( bit_se1065995026697491101ons_or @ A @ ( bit_se2584673776208193580ke_bit @ A @ N @ A2 ) @ ( bit_ri4277139882892585799ns_not @ A @ ( bit_se2239418461657761734s_mask @ A @ N ) ) ) ) ) ) ).

% signed_take_bit_eq_if_negative
thf(fact_3384_bit__iff__odd,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ( ( bit_se5641148757651400278ts_bit @ A )
        = ( ^ [A3: A,N3: nat] :
              ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( divide_divide @ A @ A3 @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N3 ) ) ) ) ) ) ).

% bit_iff_odd
thf(fact_3385_and__exp__eq__0__iff__not__bit,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A,N: nat] :
          ( ( ( bit_se5824344872417868541ns_and @ A @ A2 @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) )
            = ( zero_zero @ A ) )
          = ( ~ ( bit_se5641148757651400278ts_bit @ A @ A2 @ N ) ) ) ) ).

% and_exp_eq_0_iff_not_bit
thf(fact_3386_bit__not__iff__eq,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [A2: A,N: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( bit_ri4277139882892585799ns_not @ A @ A2 ) @ N )
          = ( ( ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N )
             != ( zero_zero @ A ) )
            & ~ ( bit_se5641148757651400278ts_bit @ A @ A2 @ N ) ) ) ) ).

% bit_not_iff_eq
thf(fact_3387_arccos__lt__bounded,axiom,
    ! [Y: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ Y )
     => ( ( ord_less @ real @ Y @ ( one_one @ real ) )
       => ( ( ord_less @ real @ ( zero_zero @ real ) @ ( arccos @ Y ) )
          & ( ord_less @ real @ ( arccos @ Y ) @ pi ) ) ) ) ).

% arccos_lt_bounded
thf(fact_3388_arccos__bounded,axiom,
    ! [Y: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ Y )
     => ( ( ord_less_eq @ real @ Y @ ( one_one @ real ) )
       => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( arccos @ Y ) )
          & ( ord_less_eq @ real @ ( arccos @ Y ) @ pi ) ) ) ) ).

% arccos_bounded
thf(fact_3389_sin__arccos__nonzero,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ X )
     => ( ( ord_less @ real @ X @ ( one_one @ real ) )
       => ( ( sin @ real @ ( arccos @ X ) )
         != ( zero_zero @ real ) ) ) ) ).

% sin_arccos_nonzero
thf(fact_3390_arccos__cos2,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ X @ ( zero_zero @ real ) )
     => ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ pi ) @ X )
       => ( ( arccos @ ( cos @ real @ X ) )
          = ( uminus_uminus @ real @ X ) ) ) ) ).

% arccos_cos2
thf(fact_3391_bit__int__def,axiom,
    ( ( bit_se5641148757651400278ts_bit @ int )
    = ( ^ [K3: int,N3: nat] :
          ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( divide_divide @ int @ K3 @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N3 ) ) ) ) ) ).

% bit_int_def
thf(fact_3392_arccos__minus,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ X )
     => ( ( ord_less_eq @ real @ X @ ( one_one @ real ) )
       => ( ( arccos @ ( uminus_uminus @ real @ X ) )
          = ( minus_minus @ real @ pi @ ( arccos @ X ) ) ) ) ) ).

% arccos_minus
thf(fact_3393_even__bit__succ__iff,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A,N: nat] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
         => ( ( bit_se5641148757651400278ts_bit @ A @ ( plus_plus @ A @ ( one_one @ A ) @ A2 ) @ N )
            = ( ( bit_se5641148757651400278ts_bit @ A @ A2 @ N )
              | ( N
                = ( zero_zero @ nat ) ) ) ) ) ) ).

% even_bit_succ_iff
thf(fact_3394_odd__bit__iff__bit__pred,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A,N: nat] :
          ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
         => ( ( bit_se5641148757651400278ts_bit @ A @ A2 @ N )
            = ( ( bit_se5641148757651400278ts_bit @ A @ ( minus_minus @ A @ A2 @ ( one_one @ A ) ) @ N )
              | ( N
                = ( zero_zero @ nat ) ) ) ) ) ) ).

% odd_bit_iff_bit_pred
thf(fact_3395_signed__take__bit__def,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( ( bit_ri4674362597316999326ke_bit @ A )
        = ( ^ [N3: nat,A3: A] : ( bit_se1065995026697491101ons_or @ A @ ( bit_se2584673776208193580ke_bit @ A @ N3 @ A3 ) @ ( times_times @ A @ ( zero_neq_one_of_bool @ A @ ( bit_se5641148757651400278ts_bit @ A @ A3 @ N3 ) ) @ ( bit_ri4277139882892585799ns_not @ A @ ( bit_se2239418461657761734s_mask @ A @ N3 ) ) ) ) ) ) ) ).

% signed_take_bit_def
thf(fact_3396_arccos,axiom,
    ! [Y: real] :
      ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ Y )
     => ( ( ord_less_eq @ real @ Y @ ( one_one @ real ) )
       => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( arccos @ Y ) )
          & ( ord_less_eq @ real @ ( arccos @ Y ) @ pi )
          & ( ( cos @ real @ ( arccos @ Y ) )
            = Y ) ) ) ) ).

% arccos
thf(fact_3397_arccos__minus__abs,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( abs_abs @ real @ X ) @ ( one_one @ real ) )
     => ( ( arccos @ ( uminus_uminus @ real @ X ) )
        = ( minus_minus @ real @ pi @ ( arccos @ X ) ) ) ) ).

% arccos_minus_abs
thf(fact_3398_div__noneq__sgn__abs,axiom,
    ! [L: int,K: int] :
      ( ( L
       != ( zero_zero @ int ) )
     => ( ( ( sgn_sgn @ int @ K )
         != ( sgn_sgn @ int @ L ) )
       => ( ( divide_divide @ int @ K @ L )
          = ( minus_minus @ int @ ( uminus_uminus @ int @ ( divide_divide @ int @ ( abs_abs @ int @ K ) @ ( abs_abs @ int @ L ) ) )
            @ ( zero_neq_one_of_bool @ int
              @ ~ ( dvd_dvd @ int @ L @ K ) ) ) ) ) ) ).

% div_noneq_sgn_abs
thf(fact_3399_bit__sum__mult__2__cases,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A,B2: A,N: nat] :
          ( ! [J2: nat] :
              ~ ( bit_se5641148757651400278ts_bit @ A @ A2 @ ( suc @ J2 ) )
         => ( ( bit_se5641148757651400278ts_bit @ A @ ( plus_plus @ A @ A2 @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B2 ) ) @ N )
            = ( ( ( N
                  = ( zero_zero @ nat ) )
               => ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) )
              & ( ( N
                 != ( zero_zero @ nat ) )
               => ( bit_se5641148757651400278ts_bit @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ B2 ) @ N ) ) ) ) ) ) ).

% bit_sum_mult_2_cases
thf(fact_3400_bit__rec,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ( ( bit_se5641148757651400278ts_bit @ A )
        = ( ^ [A3: A,N3: nat] :
              ( ( ( N3
                  = ( zero_zero @ nat ) )
               => ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A3 ) )
              & ( ( N3
                 != ( zero_zero @ nat ) )
               => ( bit_se5641148757651400278ts_bit @ A @ ( divide_divide @ A @ A3 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( minus_minus @ nat @ N3 @ ( one_one @ nat ) ) ) ) ) ) ) ) ).

% bit_rec
thf(fact_3401_set__bit__eq,axiom,
    ( ( bit_se5668285175392031749et_bit @ int )
    = ( ^ [N3: nat,K3: int] :
          ( plus_plus @ int @ K3
          @ ( times_times @ int
            @ ( zero_neq_one_of_bool @ int
              @ ~ ( bit_se5641148757651400278ts_bit @ int @ K3 @ N3 ) )
            @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N3 ) ) ) ) ) ).

% set_bit_eq
thf(fact_3402_unset__bit__eq,axiom,
    ( ( bit_se2638667681897837118et_bit @ int )
    = ( ^ [N3: nat,K3: int] : ( minus_minus @ int @ K3 @ ( times_times @ int @ ( zero_neq_one_of_bool @ int @ ( bit_se5641148757651400278ts_bit @ int @ K3 @ N3 ) ) @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N3 ) ) ) ) ) ).

% unset_bit_eq
thf(fact_3403_take__bit__Suc__from__most,axiom,
    ! [N: nat,K: int] :
      ( ( bit_se2584673776208193580ke_bit @ int @ ( suc @ N ) @ K )
      = ( plus_plus @ int @ ( times_times @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) @ ( zero_neq_one_of_bool @ int @ ( bit_se5641148757651400278ts_bit @ int @ K @ N ) ) ) @ ( bit_se2584673776208193580ke_bit @ int @ N @ K ) ) ) ).

% take_bit_Suc_from_most
thf(fact_3404_arccos__le__pi2,axiom,
    ! [Y: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y )
     => ( ( ord_less_eq @ real @ Y @ ( one_one @ real ) )
       => ( ord_less_eq @ real @ ( arccos @ Y ) @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ).

% arccos_le_pi2
thf(fact_3405_divide__int__unfold,axiom,
    ! [L: int,K: int,N: nat,M: nat] :
      ( ( ( ( ( sgn_sgn @ int @ L )
            = ( zero_zero @ int ) )
          | ( ( sgn_sgn @ int @ K )
            = ( zero_zero @ int ) )
          | ( N
            = ( zero_zero @ nat ) ) )
       => ( ( divide_divide @ int @ ( times_times @ int @ ( sgn_sgn @ int @ K ) @ ( semiring_1_of_nat @ int @ M ) ) @ ( times_times @ int @ ( sgn_sgn @ int @ L ) @ ( semiring_1_of_nat @ int @ N ) ) )
          = ( zero_zero @ int ) ) )
      & ( ~ ( ( ( sgn_sgn @ int @ L )
              = ( zero_zero @ int ) )
            | ( ( sgn_sgn @ int @ K )
              = ( zero_zero @ int ) )
            | ( N
              = ( zero_zero @ nat ) ) )
       => ( ( ( ( sgn_sgn @ int @ K )
              = ( sgn_sgn @ int @ L ) )
           => ( ( divide_divide @ int @ ( times_times @ int @ ( sgn_sgn @ int @ K ) @ ( semiring_1_of_nat @ int @ M ) ) @ ( times_times @ int @ ( sgn_sgn @ int @ L ) @ ( semiring_1_of_nat @ int @ N ) ) )
              = ( semiring_1_of_nat @ int @ ( divide_divide @ nat @ M @ N ) ) ) )
          & ( ( ( sgn_sgn @ int @ K )
             != ( sgn_sgn @ int @ L ) )
           => ( ( divide_divide @ int @ ( times_times @ int @ ( sgn_sgn @ int @ K ) @ ( semiring_1_of_nat @ int @ M ) ) @ ( times_times @ int @ ( sgn_sgn @ int @ L ) @ ( semiring_1_of_nat @ int @ N ) ) )
              = ( uminus_uminus @ int
                @ ( semiring_1_of_nat @ int
                  @ ( plus_plus @ nat @ ( divide_divide @ nat @ M @ N )
                    @ ( zero_neq_one_of_bool @ nat
                      @ ~ ( dvd_dvd @ nat @ N @ M ) ) ) ) ) ) ) ) ) ) ).

% divide_int_unfold
thf(fact_3406_modulo__int__unfold,axiom,
    ! [L: int,K: int,N: nat,M: nat] :
      ( ( ( ( ( sgn_sgn @ int @ L )
            = ( zero_zero @ int ) )
          | ( ( sgn_sgn @ int @ K )
            = ( zero_zero @ int ) )
          | ( N
            = ( zero_zero @ nat ) ) )
       => ( ( modulo_modulo @ int @ ( times_times @ int @ ( sgn_sgn @ int @ K ) @ ( semiring_1_of_nat @ int @ M ) ) @ ( times_times @ int @ ( sgn_sgn @ int @ L ) @ ( semiring_1_of_nat @ int @ N ) ) )
          = ( times_times @ int @ ( sgn_sgn @ int @ K ) @ ( semiring_1_of_nat @ int @ M ) ) ) )
      & ( ~ ( ( ( sgn_sgn @ int @ L )
              = ( zero_zero @ int ) )
            | ( ( sgn_sgn @ int @ K )
              = ( zero_zero @ int ) )
            | ( N
              = ( zero_zero @ nat ) ) )
       => ( ( ( ( sgn_sgn @ int @ K )
              = ( sgn_sgn @ int @ L ) )
           => ( ( modulo_modulo @ int @ ( times_times @ int @ ( sgn_sgn @ int @ K ) @ ( semiring_1_of_nat @ int @ M ) ) @ ( times_times @ int @ ( sgn_sgn @ int @ L ) @ ( semiring_1_of_nat @ int @ N ) ) )
              = ( times_times @ int @ ( sgn_sgn @ int @ L ) @ ( semiring_1_of_nat @ int @ ( modulo_modulo @ nat @ M @ N ) ) ) ) )
          & ( ( ( sgn_sgn @ int @ K )
             != ( sgn_sgn @ int @ L ) )
           => ( ( modulo_modulo @ int @ ( times_times @ int @ ( sgn_sgn @ int @ K ) @ ( semiring_1_of_nat @ int @ M ) ) @ ( times_times @ int @ ( sgn_sgn @ int @ L ) @ ( semiring_1_of_nat @ int @ N ) ) )
              = ( times_times @ int @ ( sgn_sgn @ int @ L )
                @ ( minus_minus @ int
                  @ ( semiring_1_of_nat @ int
                    @ ( times_times @ nat @ N
                      @ ( zero_neq_one_of_bool @ nat
                        @ ~ ( dvd_dvd @ nat @ N @ M ) ) ) )
                  @ ( semiring_1_of_nat @ int @ ( modulo_modulo @ nat @ M @ N ) ) ) ) ) ) ) ) ) ).

% modulo_int_unfold
thf(fact_3407_divide__int__def,axiom,
    ( ( divide_divide @ int )
    = ( ^ [K3: int,L2: int] :
          ( if @ int
          @ ( L2
            = ( zero_zero @ int ) )
          @ ( zero_zero @ int )
          @ ( if @ int
            @ ( ( sgn_sgn @ int @ K3 )
              = ( sgn_sgn @ int @ L2 ) )
            @ ( semiring_1_of_nat @ int @ ( divide_divide @ nat @ ( nat2 @ ( abs_abs @ int @ K3 ) ) @ ( nat2 @ ( abs_abs @ int @ L2 ) ) ) )
            @ ( uminus_uminus @ int
              @ ( semiring_1_of_nat @ int
                @ ( plus_plus @ nat @ ( divide_divide @ nat @ ( nat2 @ ( abs_abs @ int @ K3 ) ) @ ( nat2 @ ( abs_abs @ int @ L2 ) ) )
                  @ ( zero_neq_one_of_bool @ nat
                    @ ~ ( dvd_dvd @ int @ L2 @ K3 ) ) ) ) ) ) ) ) ) ).

% divide_int_def
thf(fact_3408_sinh__ln__real,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( sinh @ real @ ( ln_ln @ real @ X ) )
        = ( divide_divide @ real @ ( minus_minus @ real @ X @ ( inverse_inverse @ real @ X ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ).

% sinh_ln_real
thf(fact_3409_arctan__inverse,axiom,
    ! [X: real] :
      ( ( X
       != ( zero_zero @ real ) )
     => ( ( arctan @ ( divide_divide @ real @ ( one_one @ real ) @ X ) )
        = ( minus_minus @ real @ ( divide_divide @ real @ ( times_times @ real @ ( sgn_sgn @ real @ X ) @ pi ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( arctan @ X ) ) ) ) ).

% arctan_inverse
thf(fact_3410_exp__two__pi__i,axiom,
    ( ( exp @ complex @ ( times_times @ complex @ ( times_times @ complex @ ( numeral_numeral @ complex @ ( bit0 @ one2 ) ) @ ( real_Vector_of_real @ complex @ pi ) ) @ imaginary_unit ) )
    = ( one_one @ complex ) ) ).

% exp_two_pi_i
thf(fact_3411_exp__two__pi__i_H,axiom,
    ( ( exp @ complex @ ( times_times @ complex @ imaginary_unit @ ( times_times @ complex @ ( real_Vector_of_real @ complex @ pi ) @ ( numeral_numeral @ complex @ ( bit0 @ one2 ) ) ) ) )
    = ( one_one @ complex ) ) ).

% exp_two_pi_i'
thf(fact_3412_cosh__ln__real,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( cosh @ real @ ( ln_ln @ real @ X ) )
        = ( divide_divide @ real @ ( plus_plus @ real @ X @ ( inverse_inverse @ real @ X ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ).

% cosh_ln_real
thf(fact_3413_sinh__0,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ( ( sinh @ A @ ( zero_zero @ A ) )
        = ( zero_zero @ A ) ) ) ).

% sinh_0
thf(fact_3414_sinh__real__zero__iff,axiom,
    ! [X: real] :
      ( ( ( sinh @ real @ X )
        = ( zero_zero @ real ) )
      = ( X
        = ( zero_zero @ real ) ) ) ).

% sinh_real_zero_iff
thf(fact_3415_sinh__real__less__iff,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less @ real @ ( sinh @ real @ X ) @ ( sinh @ real @ Y ) )
      = ( ord_less @ real @ X @ Y ) ) ).

% sinh_real_less_iff
thf(fact_3416_sinh__real__le__iff,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less_eq @ real @ ( sinh @ real @ X ) @ ( sinh @ real @ Y ) )
      = ( ord_less_eq @ real @ X @ Y ) ) ).

% sinh_real_le_iff
thf(fact_3417_cosh__0,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ( ( cosh @ A @ ( zero_zero @ A ) )
        = ( one_one @ A ) ) ) ).

% cosh_0
thf(fact_3418_sinh__real__pos__iff,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ ( sinh @ real @ X ) )
      = ( ord_less @ real @ ( zero_zero @ real ) @ X ) ) ).

% sinh_real_pos_iff
thf(fact_3419_sinh__real__neg__iff,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( sinh @ real @ X ) @ ( zero_zero @ real ) )
      = ( ord_less @ real @ X @ ( zero_zero @ real ) ) ) ).

% sinh_real_neg_iff
thf(fact_3420_sinh__real__nonpos__iff,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( sinh @ real @ X ) @ ( zero_zero @ real ) )
      = ( ord_less_eq @ real @ X @ ( zero_zero @ real ) ) ) ).

% sinh_real_nonpos_iff
thf(fact_3421_sinh__real__nonneg__iff,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( sinh @ real @ X ) )
      = ( ord_less_eq @ real @ ( zero_zero @ real ) @ X ) ) ).

% sinh_real_nonneg_iff
thf(fact_3422_zero__le__sgn__iff,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( sgn_sgn @ real @ X ) )
      = ( ord_less_eq @ real @ ( zero_zero @ real ) @ X ) ) ).

% zero_le_sgn_iff
thf(fact_3423_sgn__le__0__iff,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( sgn_sgn @ real @ X ) @ ( zero_zero @ real ) )
      = ( ord_less_eq @ real @ X @ ( zero_zero @ real ) ) ) ).

% sgn_le_0_iff
thf(fact_3424_power2__i,axiom,
    ( ( power_power @ complex @ imaginary_unit @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
    = ( uminus_uminus @ complex @ ( one_one @ complex ) ) ) ).

% power2_i
thf(fact_3425_i__even__power,axiom,
    ! [N: nat] :
      ( ( power_power @ complex @ imaginary_unit @ ( times_times @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
      = ( power_power @ complex @ ( uminus_uminus @ complex @ ( one_one @ complex ) ) @ N ) ) ).

% i_even_power
thf(fact_3426_cosh__real__nonzero,axiom,
    ! [X: real] :
      ( ( cosh @ real @ X )
     != ( zero_zero @ real ) ) ).

% cosh_real_nonzero
thf(fact_3427_sinh__less__cosh__real,axiom,
    ! [X: real] : ( ord_less @ real @ ( sinh @ real @ X ) @ ( cosh @ real @ X ) ) ).

% sinh_less_cosh_real
thf(fact_3428_sinh__le__cosh__real,axiom,
    ! [X: real] : ( ord_less_eq @ real @ ( sinh @ real @ X ) @ ( cosh @ real @ X ) ) ).

% sinh_le_cosh_real
thf(fact_3429_complex__i__not__zero,axiom,
    imaginary_unit
 != ( zero_zero @ complex ) ).

% complex_i_not_zero
thf(fact_3430_bit__Suc__0__iff,axiom,
    ! [N: nat] :
      ( ( bit_se5641148757651400278ts_bit @ nat @ ( suc @ ( zero_zero @ nat ) ) @ N )
      = ( N
        = ( zero_zero @ nat ) ) ) ).

% bit_Suc_0_iff
thf(fact_3431_not__bit__Suc__0__Suc,axiom,
    ! [N: nat] :
      ~ ( bit_se5641148757651400278ts_bit @ nat @ ( suc @ ( zero_zero @ nat ) ) @ ( suc @ N ) ) ).

% not_bit_Suc_0_Suc
thf(fact_3432_cosh__real__pos,axiom,
    ! [X: real] : ( ord_less @ real @ ( zero_zero @ real ) @ ( cosh @ real @ X ) ) ).

% cosh_real_pos
thf(fact_3433_cosh__real__nonpos__le__iff,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less_eq @ real @ X @ ( zero_zero @ real ) )
     => ( ( ord_less_eq @ real @ Y @ ( zero_zero @ real ) )
       => ( ( ord_less_eq @ real @ ( cosh @ real @ X ) @ ( cosh @ real @ Y ) )
          = ( ord_less_eq @ real @ Y @ X ) ) ) ) ).

% cosh_real_nonpos_le_iff
thf(fact_3434_cosh__real__nonneg__le__iff,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y )
       => ( ( ord_less_eq @ real @ ( cosh @ real @ X ) @ ( cosh @ real @ Y ) )
          = ( ord_less_eq @ real @ X @ Y ) ) ) ) ).

% cosh_real_nonneg_le_iff
thf(fact_3435_cosh__real__nonneg,axiom,
    ! [X: real] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( cosh @ real @ X ) ) ).

% cosh_real_nonneg
thf(fact_3436_cosh__real__ge__1,axiom,
    ! [X: real] : ( ord_less_eq @ real @ ( one_one @ real ) @ ( cosh @ real @ X ) ) ).

% cosh_real_ge_1
thf(fact_3437_sinh__double,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A] :
          ( ( sinh @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ X ) )
          = ( times_times @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( sinh @ A @ X ) ) @ ( cosh @ A @ X ) ) ) ) ).

% sinh_double
thf(fact_3438_not__bit__Suc__0__numeral,axiom,
    ! [N: num] :
      ~ ( bit_se5641148757651400278ts_bit @ nat @ ( suc @ ( zero_zero @ nat ) ) @ ( numeral_numeral @ nat @ N ) ) ).

% not_bit_Suc_0_numeral
thf(fact_3439_cosh__real__strict__mono,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less @ real @ X @ Y )
       => ( ord_less @ real @ ( cosh @ real @ X ) @ ( cosh @ real @ Y ) ) ) ) ).

% cosh_real_strict_mono
thf(fact_3440_cosh__real__nonneg__less__iff,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y )
       => ( ( ord_less @ real @ ( cosh @ real @ X ) @ ( cosh @ real @ Y ) )
          = ( ord_less @ real @ X @ Y ) ) ) ) ).

% cosh_real_nonneg_less_iff
thf(fact_3441_cosh__real__nonpos__less__iff,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less_eq @ real @ X @ ( zero_zero @ real ) )
     => ( ( ord_less_eq @ real @ Y @ ( zero_zero @ real ) )
       => ( ( ord_less @ real @ ( cosh @ real @ X ) @ ( cosh @ real @ Y ) )
          = ( ord_less @ real @ Y @ X ) ) ) ) ).

% cosh_real_nonpos_less_iff
thf(fact_3442_cosh__square__eq,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A] :
          ( ( power_power @ A @ ( cosh @ A @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
          = ( plus_plus @ A @ ( power_power @ A @ ( sinh @ A @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ A ) ) ) ) ).

% cosh_square_eq
thf(fact_3443_hyperbolic__pythagoras,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A] :
          ( ( minus_minus @ A @ ( power_power @ A @ ( cosh @ A @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ A @ ( sinh @ A @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
          = ( one_one @ A ) ) ) ).

% hyperbolic_pythagoras
thf(fact_3444_sinh__square__eq,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A] :
          ( ( power_power @ A @ ( sinh @ A @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
          = ( minus_minus @ A @ ( power_power @ A @ ( cosh @ A @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ A ) ) ) ) ).

% sinh_square_eq
thf(fact_3445_arcosh__cosh__real,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( arcosh @ real @ ( cosh @ real @ X ) )
        = X ) ) ).

% arcosh_cosh_real
thf(fact_3446_imaginary__unit_Ocode,axiom,
    ( imaginary_unit
    = ( complex2 @ ( zero_zero @ real ) @ ( one_one @ real ) ) ) ).

% imaginary_unit.code
thf(fact_3447_Complex__eq__i,axiom,
    ! [X: real,Y: real] :
      ( ( ( complex2 @ X @ Y )
        = imaginary_unit )
      = ( ( X
          = ( zero_zero @ real ) )
        & ( Y
          = ( one_one @ real ) ) ) ) ).

% Complex_eq_i
thf(fact_3448_complex__of__real__i,axiom,
    ! [R2: real] :
      ( ( times_times @ complex @ ( real_Vector_of_real @ complex @ R2 ) @ imaginary_unit )
      = ( complex2 @ ( zero_zero @ real ) @ R2 ) ) ).

% complex_of_real_i
thf(fact_3449_i__complex__of__real,axiom,
    ! [R2: real] :
      ( ( times_times @ complex @ imaginary_unit @ ( real_Vector_of_real @ complex @ R2 ) )
      = ( complex2 @ ( zero_zero @ real ) @ R2 ) ) ).

% i_complex_of_real
thf(fact_3450_cosh__double,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A] :
          ( ( cosh @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ X ) )
          = ( plus_plus @ A @ ( power_power @ A @ ( cosh @ A @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ A @ ( sinh @ A @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% cosh_double
thf(fact_3451_sgn__real__def,axiom,
    ( ( sgn_sgn @ real )
    = ( ^ [A3: real] :
          ( if @ real
          @ ( A3
            = ( zero_zero @ real ) )
          @ ( zero_zero @ real )
          @ ( if @ real @ ( ord_less @ real @ ( zero_zero @ real ) @ A3 ) @ ( one_one @ real ) @ ( uminus_uminus @ real @ ( one_one @ real ) ) ) ) ) ) ).

% sgn_real_def
thf(fact_3452_bit__nat__iff,axiom,
    ! [K: int,N: nat] :
      ( ( bit_se5641148757651400278ts_bit @ nat @ ( nat2 @ K ) @ N )
      = ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ K )
        & ( bit_se5641148757651400278ts_bit @ int @ K @ N ) ) ) ).

% bit_nat_iff
thf(fact_3453_sgn__power__injE,axiom,
    ! [A2: real,N: nat,X: real,B2: real] :
      ( ( ( times_times @ real @ ( sgn_sgn @ real @ A2 ) @ ( power_power @ real @ ( abs_abs @ real @ A2 ) @ N ) )
        = X )
     => ( ( X
          = ( times_times @ real @ ( sgn_sgn @ real @ B2 ) @ ( power_power @ real @ ( abs_abs @ real @ B2 ) @ N ) ) )
       => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
         => ( A2 = B2 ) ) ) ) ).

% sgn_power_injE
thf(fact_3454_bit__nat__def,axiom,
    ( ( bit_se5641148757651400278ts_bit @ nat )
    = ( ^ [M3: nat,N3: nat] :
          ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( divide_divide @ nat @ M3 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N3 ) ) ) ) ) ).

% bit_nat_def
thf(fact_3455_tanh__add,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A,Y: A] :
          ( ( ( cosh @ A @ X )
           != ( zero_zero @ A ) )
         => ( ( ( cosh @ A @ Y )
             != ( zero_zero @ A ) )
           => ( ( tanh @ A @ ( plus_plus @ A @ X @ Y ) )
              = ( divide_divide @ A @ ( plus_plus @ A @ ( tanh @ A @ X ) @ ( tanh @ A @ Y ) ) @ ( plus_plus @ A @ ( one_one @ A ) @ ( times_times @ A @ ( tanh @ A @ X ) @ ( tanh @ A @ Y ) ) ) ) ) ) ) ) ).

% tanh_add
thf(fact_3456_cosh__field__def,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ( ( cosh @ A )
        = ( ^ [Z6: A] : ( divide_divide @ A @ ( plus_plus @ A @ ( exp @ A @ Z6 ) @ ( exp @ A @ ( uminus_uminus @ A @ Z6 ) ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ).

% cosh_field_def
thf(fact_3457_sinh__field__def,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ( ( sinh @ A )
        = ( ^ [Z6: A] : ( divide_divide @ A @ ( minus_minus @ A @ ( exp @ A @ Z6 ) @ ( exp @ A @ ( uminus_uminus @ A @ Z6 ) ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ).

% sinh_field_def
thf(fact_3458_cosh__zero__iff,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A] :
          ( ( ( cosh @ A @ X )
            = ( zero_zero @ A ) )
          = ( ( power_power @ A @ ( exp @ A @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
            = ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ) ).

% cosh_zero_iff
thf(fact_3459_Arg__minus__ii,axiom,
    ( ( arg @ ( uminus_uminus @ complex @ imaginary_unit ) )
    = ( divide_divide @ real @ ( uminus_uminus @ real @ pi ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ).

% Arg_minus_ii
thf(fact_3460_csqrt__ii,axiom,
    ( ( csqrt @ imaginary_unit )
    = ( divide_divide @ complex @ ( plus_plus @ complex @ ( one_one @ complex ) @ imaginary_unit ) @ ( real_Vector_of_real @ complex @ ( sqrt @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ).

% csqrt_ii
thf(fact_3461_Arg__ii,axiom,
    ( ( arg @ imaginary_unit )
    = ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ).

% Arg_ii
thf(fact_3462_cis__minus__pi__half,axiom,
    ( ( cis @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) )
    = ( uminus_uminus @ complex @ imaginary_unit ) ) ).

% cis_minus_pi_half
thf(fact_3463_cis__2pi,axiom,
    ( ( cis @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) )
    = ( one_one @ complex ) ) ).

% cis_2pi
thf(fact_3464_csqrt__0,axiom,
    ( ( csqrt @ ( zero_zero @ complex ) )
    = ( zero_zero @ complex ) ) ).

% csqrt_0
thf(fact_3465_csqrt__eq__0,axiom,
    ! [Z: complex] :
      ( ( ( csqrt @ Z )
        = ( zero_zero @ complex ) )
      = ( Z
        = ( zero_zero @ complex ) ) ) ).

% csqrt_eq_0
thf(fact_3466_cis__zero,axiom,
    ( ( cis @ ( zero_zero @ real ) )
    = ( one_one @ complex ) ) ).

% cis_zero
thf(fact_3467_power2__csqrt,axiom,
    ! [Z: complex] :
      ( ( power_power @ complex @ ( csqrt @ Z ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
      = Z ) ).

% power2_csqrt
thf(fact_3468_cis__pi__half,axiom,
    ( ( cis @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
    = imaginary_unit ) ).

% cis_pi_half
thf(fact_3469_cis__Arg,axiom,
    ! [Z: complex] :
      ( ( Z
       != ( zero_zero @ complex ) )
     => ( ( cis @ ( arg @ Z ) )
        = ( sgn_sgn @ complex @ Z ) ) ) ).

% cis_Arg
thf(fact_3470_cis__neq__zero,axiom,
    ! [A2: real] :
      ( ( cis @ A2 )
     != ( zero_zero @ complex ) ) ).

% cis_neq_zero
thf(fact_3471_DeMoivre,axiom,
    ! [A2: real,N: nat] :
      ( ( power_power @ complex @ ( cis @ A2 ) @ N )
      = ( cis @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N ) @ A2 ) ) ) ).

% DeMoivre
thf(fact_3472_cis__Arg__unique,axiom,
    ! [Z: complex,X: real] :
      ( ( ( sgn_sgn @ complex @ Z )
        = ( cis @ X ) )
     => ( ( ord_less @ real @ ( uminus_uminus @ real @ pi ) @ X )
       => ( ( ord_less_eq @ real @ X @ pi )
         => ( ( arg @ Z )
            = X ) ) ) ) ).

% cis_Arg_unique
thf(fact_3473_Arg__correct,axiom,
    ! [Z: complex] :
      ( ( Z
       != ( zero_zero @ complex ) )
     => ( ( ( sgn_sgn @ complex @ Z )
          = ( cis @ ( arg @ Z ) ) )
        & ( ord_less @ real @ ( uminus_uminus @ real @ pi ) @ ( arg @ Z ) )
        & ( ord_less_eq @ real @ ( arg @ Z ) @ pi ) ) ) ).

% Arg_correct
thf(fact_3474_Arg__zero,axiom,
    ( ( arg @ ( zero_zero @ complex ) )
    = ( zero_zero @ real ) ) ).

% Arg_zero
thf(fact_3475_of__real__sqrt,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( real_Vector_of_real @ complex @ ( sqrt @ X ) )
        = ( csqrt @ ( real_Vector_of_real @ complex @ X ) ) ) ) ).

% of_real_sqrt
thf(fact_3476_Arg__bounded,axiom,
    ! [Z: complex] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ pi ) @ ( arg @ Z ) )
      & ( ord_less_eq @ real @ ( arg @ Z ) @ pi ) ) ).

% Arg_bounded
thf(fact_3477_cis__multiple__2pi,axiom,
    ! [N: real] :
      ( ( member @ real @ N @ ( ring_1_Ints @ real ) )
     => ( ( cis @ ( times_times @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) @ N ) )
        = ( one_one @ complex ) ) ) ).

% cis_multiple_2pi
thf(fact_3478_gbinomial__absorption_H,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [K: nat,A2: A] :
          ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
         => ( ( gbinomial @ A @ A2 @ K )
            = ( times_times @ A @ ( divide_divide @ A @ A2 @ ( semiring_1_of_nat @ A @ K ) ) @ ( gbinomial @ A @ ( minus_minus @ A @ A2 @ ( one_one @ A ) ) @ ( minus_minus @ nat @ K @ ( one_one @ nat ) ) ) ) ) ) ) ).

% gbinomial_absorption'
thf(fact_3479_push__bit__numeral__minus__1,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N: num] :
          ( ( bit_se4730199178511100633sh_bit @ A @ ( numeral_numeral @ nat @ N ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( uminus_uminus @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( numeral_numeral @ nat @ N ) ) ) ) ) ).

% push_bit_numeral_minus_1
thf(fact_3480_Cauchy__iff2,axiom,
    ( ( topolo3814608138187158403Cauchy @ real )
    = ( ^ [X8: nat > real] :
        ! [J3: nat] :
        ? [M8: nat] :
        ! [M3: nat] :
          ( ( ord_less_eq @ nat @ M8 @ M3 )
         => ! [N3: nat] :
              ( ( ord_less_eq @ nat @ M8 @ N3 )
             => ( ord_less @ real @ ( abs_abs @ real @ ( minus_minus @ real @ ( X8 @ M3 ) @ ( X8 @ N3 ) ) ) @ ( inverse_inverse @ real @ ( semiring_1_of_nat @ real @ ( suc @ J3 ) ) ) ) ) ) ) ) ).

% Cauchy_iff2
thf(fact_3481_csqrt_Osimps_I1_J,axiom,
    ! [Z: complex] :
      ( ( re @ ( csqrt @ Z ) )
      = ( sqrt @ ( divide_divide @ real @ ( plus_plus @ real @ ( real_V7770717601297561774m_norm @ complex @ Z ) @ ( re @ Z ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ).

% csqrt.simps(1)
thf(fact_3482_push__bit__nonnegative__int__iff,axiom,
    ! [N: nat,K: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( bit_se4730199178511100633sh_bit @ int @ N @ K ) )
      = ( ord_less_eq @ int @ ( zero_zero @ int ) @ K ) ) ).

% push_bit_nonnegative_int_iff
thf(fact_3483_push__bit__negative__int__iff,axiom,
    ! [N: nat,K: int] :
      ( ( ord_less @ int @ ( bit_se4730199178511100633sh_bit @ int @ N @ K ) @ ( zero_zero @ int ) )
      = ( ord_less @ int @ K @ ( zero_zero @ int ) ) ) ).

% push_bit_negative_int_iff
thf(fact_3484_push__bit__of__0,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat] :
          ( ( bit_se4730199178511100633sh_bit @ A @ N @ ( zero_zero @ A ) )
          = ( zero_zero @ A ) ) ) ).

% push_bit_of_0
thf(fact_3485_push__bit__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [N: nat,A2: A] :
          ( ( ( bit_se4730199178511100633sh_bit @ A @ N @ A2 )
            = ( zero_zero @ A ) )
          = ( A2
            = ( zero_zero @ A ) ) ) ) ).

% push_bit_eq_0_iff
thf(fact_3486_push__bit__push__bit,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M: nat,N: nat,A2: A] :
          ( ( bit_se4730199178511100633sh_bit @ A @ M @ ( bit_se4730199178511100633sh_bit @ A @ N @ A2 ) )
          = ( bit_se4730199178511100633sh_bit @ A @ ( plus_plus @ nat @ M @ N ) @ A2 ) ) ) ).

% push_bit_push_bit
thf(fact_3487_complex__Re__of__nat,axiom,
    ! [N: nat] :
      ( ( re @ ( semiring_1_of_nat @ complex @ N ) )
      = ( semiring_1_of_nat @ real @ N ) ) ).

% complex_Re_of_nat
thf(fact_3488_push__bit__and,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,A2: A,B2: A] :
          ( ( bit_se4730199178511100633sh_bit @ A @ N @ ( bit_se5824344872417868541ns_and @ A @ A2 @ B2 ) )
          = ( bit_se5824344872417868541ns_and @ A @ ( bit_se4730199178511100633sh_bit @ A @ N @ A2 ) @ ( bit_se4730199178511100633sh_bit @ A @ N @ B2 ) ) ) ) ).

% push_bit_and
thf(fact_3489_push__bit__or,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,A2: A,B2: A] :
          ( ( bit_se4730199178511100633sh_bit @ A @ N @ ( bit_se1065995026697491101ons_or @ A @ A2 @ B2 ) )
          = ( bit_se1065995026697491101ons_or @ A @ ( bit_se4730199178511100633sh_bit @ A @ N @ A2 ) @ ( bit_se4730199178511100633sh_bit @ A @ N @ B2 ) ) ) ) ).

% push_bit_or
thf(fact_3490_push__bit__xor,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,A2: A,B2: A] :
          ( ( bit_se4730199178511100633sh_bit @ A @ N @ ( bit_se5824344971392196577ns_xor @ A @ A2 @ B2 ) )
          = ( bit_se5824344971392196577ns_xor @ A @ ( bit_se4730199178511100633sh_bit @ A @ N @ A2 ) @ ( bit_se4730199178511100633sh_bit @ A @ N @ B2 ) ) ) ) ).

% push_bit_xor
thf(fact_3491_concat__bit__of__zero__1,axiom,
    ! [N: nat,L: int] :
      ( ( bit_concat_bit @ N @ ( zero_zero @ int ) @ L )
      = ( bit_se4730199178511100633sh_bit @ int @ N @ L ) ) ).

% concat_bit_of_zero_1
thf(fact_3492_frac__in__Ints__iff,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( member @ A @ ( archimedean_frac @ A @ X ) @ ( ring_1_Ints @ A ) )
          = ( member @ A @ X @ ( ring_1_Ints @ A ) ) ) ) ).

% frac_in_Ints_iff
thf(fact_3493_gbinomial__0_I2_J,axiom,
    ! [B: $tType] :
      ( ( ( semiring_char_0 @ B )
        & ( semidom_divide @ B ) )
     => ! [K: nat] :
          ( ( gbinomial @ B @ ( zero_zero @ B ) @ ( suc @ K ) )
          = ( zero_zero @ B ) ) ) ).

% gbinomial_0(2)
thf(fact_3494_gbinomial__0_I1_J,axiom,
    ! [A: $tType] :
      ( ( ( semiring_char_0 @ A )
        & ( semidom_divide @ A ) )
     => ! [A2: A] :
          ( ( gbinomial @ A @ A2 @ ( zero_zero @ nat ) )
          = ( one_one @ A ) ) ) ).

% gbinomial_0(1)
thf(fact_3495_gbinomial__Suc0,axiom,
    ! [A: $tType] :
      ( ( ( semiring_char_0 @ A )
        & ( semidom_divide @ A ) )
     => ! [A2: A] :
          ( ( gbinomial @ A @ A2 @ ( suc @ ( zero_zero @ nat ) ) )
          = A2 ) ) ).

% gbinomial_Suc0
thf(fact_3496_frac__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( ( archimedean_frac @ A @ X )
            = ( zero_zero @ A ) )
          = ( member @ A @ X @ ( ring_1_Ints @ A ) ) ) ) ).

% frac_eq_0_iff
thf(fact_3497_complex__Re__numeral,axiom,
    ! [V: num] :
      ( ( re @ ( numeral_numeral @ complex @ V ) )
      = ( numeral_numeral @ real @ V ) ) ).

% complex_Re_numeral
thf(fact_3498_push__bit__Suc__numeral,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,K: num] :
          ( ( bit_se4730199178511100633sh_bit @ A @ ( suc @ N ) @ ( numeral_numeral @ A @ K ) )
          = ( bit_se4730199178511100633sh_bit @ A @ N @ ( numeral_numeral @ A @ ( bit0 @ K ) ) ) ) ) ).

% push_bit_Suc_numeral
thf(fact_3499_floor__add2,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,Y: A] :
          ( ( ( member @ A @ X @ ( ring_1_Ints @ A ) )
            | ( member @ A @ Y @ ( ring_1_Ints @ A ) ) )
         => ( ( archim6421214686448440834_floor @ A @ ( plus_plus @ A @ X @ Y ) )
            = ( plus_plus @ int @ ( archim6421214686448440834_floor @ A @ X ) @ ( archim6421214686448440834_floor @ A @ Y ) ) ) ) ) ).

% floor_add2
thf(fact_3500_frac__gt__0__iff,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( archimedean_frac @ A @ X ) )
          = ( ~ ( member @ A @ X @ ( ring_1_Ints @ A ) ) ) ) ) ).

% frac_gt_0_iff
thf(fact_3501_Re__divide__of__nat,axiom,
    ! [Z: complex,N: nat] :
      ( ( re @ ( divide_divide @ complex @ Z @ ( semiring_1_of_nat @ complex @ N ) ) )
      = ( divide_divide @ real @ ( re @ Z ) @ ( semiring_1_of_nat @ real @ N ) ) ) ).

% Re_divide_of_nat
thf(fact_3502_push__bit__Suc__minus__numeral,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N: nat,K: num] :
          ( ( bit_se4730199178511100633sh_bit @ A @ ( suc @ N ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ K ) ) )
          = ( bit_se4730199178511100633sh_bit @ A @ N @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( bit0 @ K ) ) ) ) ) ) ).

% push_bit_Suc_minus_numeral
thf(fact_3503_push__bit__numeral,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [L: num,K: num] :
          ( ( bit_se4730199178511100633sh_bit @ A @ ( numeral_numeral @ nat @ L ) @ ( numeral_numeral @ A @ K ) )
          = ( bit_se4730199178511100633sh_bit @ A @ ( pred_numeral @ L ) @ ( numeral_numeral @ A @ ( bit0 @ K ) ) ) ) ) ).

% push_bit_numeral
thf(fact_3504_push__bit__minus__one__eq__not__mask,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N: nat] :
          ( ( bit_se4730199178511100633sh_bit @ A @ N @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( bit_ri4277139882892585799ns_not @ A @ ( bit_se2239418461657761734s_mask @ A @ N ) ) ) ) ).

% push_bit_minus_one_eq_not_mask
thf(fact_3505_Re__divide__numeral,axiom,
    ! [Z: complex,W: num] :
      ( ( re @ ( divide_divide @ complex @ Z @ ( numeral_numeral @ complex @ W ) ) )
      = ( divide_divide @ real @ ( re @ Z ) @ ( numeral_numeral @ real @ W ) ) ) ).

% Re_divide_numeral
thf(fact_3506_cos__Arg__i__mult__zero,axiom,
    ! [Y: complex] :
      ( ( Y
       != ( zero_zero @ complex ) )
     => ( ( ( re @ Y )
          = ( zero_zero @ real ) )
       => ( ( cos @ real @ ( arg @ Y ) )
          = ( zero_zero @ real ) ) ) ) ).

% cos_Arg_i_mult_zero
thf(fact_3507_push__bit__Suc,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,A2: A] :
          ( ( bit_se4730199178511100633sh_bit @ A @ ( suc @ N ) @ A2 )
          = ( bit_se4730199178511100633sh_bit @ A @ N @ ( times_times @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ).

% push_bit_Suc
thf(fact_3508_push__bit__of__Suc__0,axiom,
    ! [N: nat] :
      ( ( bit_se4730199178511100633sh_bit @ nat @ N @ ( suc @ ( zero_zero @ nat ) ) )
      = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ).

% push_bit_of_Suc_0
thf(fact_3509_push__bit__of__1,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat] :
          ( ( bit_se4730199178511100633sh_bit @ A @ N @ ( one_one @ A ) )
          = ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) ) ) ).

% push_bit_of_1
thf(fact_3510_even__push__bit__iff,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,A2: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se4730199178511100633sh_bit @ A @ N @ A2 ) )
          = ( ( N
             != ( zero_zero @ nat ) )
            | ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) ) ) ) ).

% even_push_bit_iff
thf(fact_3511_push__bit__minus__numeral,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [L: num,K: num] :
          ( ( bit_se4730199178511100633sh_bit @ A @ ( numeral_numeral @ nat @ L ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ K ) ) )
          = ( bit_se4730199178511100633sh_bit @ A @ ( pred_numeral @ L ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( bit0 @ K ) ) ) ) ) ) ).

% push_bit_minus_numeral
thf(fact_3512_Ints__power,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [A2: A,N: nat] :
          ( ( member @ A @ A2 @ ( ring_1_Ints @ A ) )
         => ( member @ A @ ( power_power @ A @ A2 @ N ) @ ( ring_1_Ints @ A ) ) ) ) ).

% Ints_power
thf(fact_3513_Ints__cases,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [Q3: A] :
          ( ( member @ A @ Q3 @ ( ring_1_Ints @ A ) )
         => ~ ! [Z3: int] :
                ( Q3
               != ( ring_1_of_int @ A @ Z3 ) ) ) ) ).

% Ints_cases
thf(fact_3514_Ints__induct,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [Q3: A,P: A > $o] :
          ( ( member @ A @ Q3 @ ( ring_1_Ints @ A ) )
         => ( ! [Z3: int] : ( P @ ( ring_1_of_int @ A @ Z3 ) )
           => ( P @ Q3 ) ) ) ) ).

% Ints_induct
thf(fact_3515_Ints__of__int,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [Z: int] : ( member @ A @ ( ring_1_of_int @ A @ Z ) @ ( ring_1_Ints @ A ) ) ) ).

% Ints_of_int
thf(fact_3516_Ints__0,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ( member @ A @ ( zero_zero @ A ) @ ( ring_1_Ints @ A ) ) ) ).

% Ints_0
thf(fact_3517_Ints__numeral,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [N: num] : ( member @ A @ ( numeral_numeral @ A @ N ) @ ( ring_1_Ints @ A ) ) ) ).

% Ints_numeral
thf(fact_3518_push__bit__minus,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N: nat,A2: A] :
          ( ( bit_se4730199178511100633sh_bit @ A @ N @ ( uminus_uminus @ A @ A2 ) )
          = ( uminus_uminus @ A @ ( bit_se4730199178511100633sh_bit @ A @ N @ A2 ) ) ) ) ).

% push_bit_minus
thf(fact_3519_Ints__1,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ( member @ A @ ( one_one @ A ) @ ( ring_1_Ints @ A ) ) ) ).

% Ints_1
thf(fact_3520_Ints__add,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [A2: A,B2: A] :
          ( ( member @ A @ A2 @ ( ring_1_Ints @ A ) )
         => ( ( member @ A @ B2 @ ( ring_1_Ints @ A ) )
           => ( member @ A @ ( plus_plus @ A @ A2 @ B2 ) @ ( ring_1_Ints @ A ) ) ) ) ) ).

% Ints_add
thf(fact_3521_Ints__diff,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [A2: A,B2: A] :
          ( ( member @ A @ A2 @ ( ring_1_Ints @ A ) )
         => ( ( member @ A @ B2 @ ( ring_1_Ints @ A ) )
           => ( member @ A @ ( minus_minus @ A @ A2 @ B2 ) @ ( ring_1_Ints @ A ) ) ) ) ) ).

% Ints_diff
thf(fact_3522_Ints__minus,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [A2: A] :
          ( ( member @ A @ A2 @ ( ring_1_Ints @ A ) )
         => ( member @ A @ ( uminus_uminus @ A @ A2 ) @ ( ring_1_Ints @ A ) ) ) ) ).

% Ints_minus
thf(fact_3523_minus__in__Ints__iff,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [X: A] :
          ( ( member @ A @ ( uminus_uminus @ A @ X ) @ ( ring_1_Ints @ A ) )
          = ( member @ A @ X @ ( ring_1_Ints @ A ) ) ) ) ).

% minus_in_Ints_iff
thf(fact_3524_push__bit__of__nat,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,M: nat] :
          ( ( bit_se4730199178511100633sh_bit @ A @ N @ ( semiring_1_of_nat @ A @ M ) )
          = ( semiring_1_of_nat @ A @ ( bit_se4730199178511100633sh_bit @ nat @ N @ M ) ) ) ) ).

% push_bit_of_nat
thf(fact_3525_of__nat__push__bit,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M: nat,N: nat] :
          ( ( semiring_1_of_nat @ A @ ( bit_se4730199178511100633sh_bit @ nat @ M @ N ) )
          = ( bit_se4730199178511100633sh_bit @ A @ M @ ( semiring_1_of_nat @ A @ N ) ) ) ) ).

% of_nat_push_bit
thf(fact_3526_push__bit__nat__eq,axiom,
    ! [N: nat,K: int] :
      ( ( bit_se4730199178511100633sh_bit @ nat @ N @ ( nat2 @ K ) )
      = ( nat2 @ ( bit_se4730199178511100633sh_bit @ int @ N @ K ) ) ) ).

% push_bit_nat_eq
thf(fact_3527_push__bit__of__int,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N: nat,K: int] :
          ( ( bit_se4730199178511100633sh_bit @ A @ N @ ( ring_1_of_int @ A @ K ) )
          = ( ring_1_of_int @ A @ ( bit_se4730199178511100633sh_bit @ int @ N @ K ) ) ) ) ).

% push_bit_of_int
thf(fact_3528_of__nat__gbinomial,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [N: nat,K: nat] :
          ( ( semiring_1_of_nat @ A @ ( gbinomial @ nat @ N @ K ) )
          = ( gbinomial @ A @ ( semiring_1_of_nat @ A @ N ) @ K ) ) ) ).

% of_nat_gbinomial
thf(fact_3529_push__bit__add,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,A2: A,B2: A] :
          ( ( bit_se4730199178511100633sh_bit @ A @ N @ ( plus_plus @ A @ A2 @ B2 ) )
          = ( plus_plus @ A @ ( bit_se4730199178511100633sh_bit @ A @ N @ A2 ) @ ( bit_se4730199178511100633sh_bit @ A @ N @ B2 ) ) ) ) ).

% push_bit_add
thf(fact_3530_Ints__abs,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A] :
          ( ( member @ A @ A2 @ ( ring_1_Ints @ A ) )
         => ( member @ A @ ( abs_abs @ A @ A2 ) @ ( ring_1_Ints @ A ) ) ) ) ).

% Ints_abs
thf(fact_3531_Ints__of__nat,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [N: nat] : ( member @ A @ ( semiring_1_of_nat @ A @ N ) @ ( ring_1_Ints @ A ) ) ) ).

% Ints_of_nat
thf(fact_3532_Ints__mult,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [A2: A,B2: A] :
          ( ( member @ A @ A2 @ ( ring_1_Ints @ A ) )
         => ( ( member @ A @ B2 @ ( ring_1_Ints @ A ) )
           => ( member @ A @ ( times_times @ A @ A2 @ B2 ) @ ( ring_1_Ints @ A ) ) ) ) ) ).

% Ints_mult
thf(fact_3533_imaginary__unit_Osimps_I1_J,axiom,
    ( ( re @ imaginary_unit )
    = ( zero_zero @ real ) ) ).

% imaginary_unit.simps(1)
thf(fact_3534_complex__Re__le__cmod,axiom,
    ! [X: complex] : ( ord_less_eq @ real @ ( re @ X ) @ ( real_V7770717601297561774m_norm @ complex @ X ) ) ).

% complex_Re_le_cmod
thf(fact_3535_Ints__double__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [A2: A] :
          ( ( member @ A @ A2 @ ( ring_1_Ints @ A ) )
         => ( ( ( plus_plus @ A @ A2 @ A2 )
              = ( zero_zero @ A ) )
            = ( A2
              = ( zero_zero @ A ) ) ) ) ) ).

% Ints_double_eq_0_iff
thf(fact_3536_binomial__gbinomial,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [N: nat,K: nat] :
          ( ( semiring_1_of_nat @ A @ ( binomial @ N @ K ) )
          = ( gbinomial @ A @ ( semiring_1_of_nat @ A @ N ) @ K ) ) ) ).

% binomial_gbinomial
thf(fact_3537_zero__complex_Osimps_I1_J,axiom,
    ( ( re @ ( zero_zero @ complex ) )
    = ( zero_zero @ real ) ) ).

% zero_complex.simps(1)
thf(fact_3538_push__bit__take__bit,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M: nat,N: nat,A2: A] :
          ( ( bit_se4730199178511100633sh_bit @ A @ M @ ( bit_se2584673776208193580ke_bit @ A @ N @ A2 ) )
          = ( bit_se2584673776208193580ke_bit @ A @ ( plus_plus @ nat @ M @ N ) @ ( bit_se4730199178511100633sh_bit @ A @ M @ A2 ) ) ) ) ).

% push_bit_take_bit
thf(fact_3539_take__bit__push__bit,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M: nat,N: nat,A2: A] :
          ( ( bit_se2584673776208193580ke_bit @ A @ M @ ( bit_se4730199178511100633sh_bit @ A @ N @ A2 ) )
          = ( bit_se4730199178511100633sh_bit @ A @ N @ ( bit_se2584673776208193580ke_bit @ A @ ( minus_minus @ nat @ M @ N ) @ A2 ) ) ) ) ).

% take_bit_push_bit
thf(fact_3540_flip__bit__nat__def,axiom,
    ( ( bit_se8732182000553998342ip_bit @ nat )
    = ( ^ [M3: nat,N3: nat] : ( bit_se5824344971392196577ns_xor @ nat @ N3 @ ( bit_se4730199178511100633sh_bit @ nat @ M3 @ ( one_one @ nat ) ) ) ) ) ).

% flip_bit_nat_def
thf(fact_3541_set__bit__nat__def,axiom,
    ( ( bit_se5668285175392031749et_bit @ nat )
    = ( ^ [M3: nat,N3: nat] : ( bit_se1065995026697491101ons_or @ nat @ N3 @ ( bit_se4730199178511100633sh_bit @ nat @ M3 @ ( one_one @ nat ) ) ) ) ) ).

% set_bit_nat_def
thf(fact_3542_gbinomial__of__nat__symmetric,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [K: nat,N: nat] :
          ( ( ord_less_eq @ nat @ K @ N )
         => ( ( gbinomial @ A @ ( semiring_1_of_nat @ A @ N ) @ K )
            = ( gbinomial @ A @ ( semiring_1_of_nat @ A @ N ) @ ( minus_minus @ nat @ N @ K ) ) ) ) ) ).

% gbinomial_of_nat_symmetric
thf(fact_3543_abs__Re__le__cmod,axiom,
    ! [X: complex] : ( ord_less_eq @ real @ ( abs_abs @ real @ ( re @ X ) ) @ ( real_V7770717601297561774m_norm @ complex @ X ) ) ).

% abs_Re_le_cmod
thf(fact_3544_Ints__odd__nonzero,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [A2: A] :
          ( ( member @ A @ A2 @ ( ring_1_Ints @ A ) )
         => ( ( plus_plus @ A @ ( plus_plus @ A @ ( one_one @ A ) @ A2 ) @ A2 )
           != ( zero_zero @ A ) ) ) ) ).

% Ints_odd_nonzero
thf(fact_3545_bit__push__bit__iff__int,axiom,
    ! [M: nat,K: int,N: nat] :
      ( ( bit_se5641148757651400278ts_bit @ int @ ( bit_se4730199178511100633sh_bit @ int @ M @ K ) @ N )
      = ( ( ord_less_eq @ nat @ M @ N )
        & ( bit_se5641148757651400278ts_bit @ int @ K @ ( minus_minus @ nat @ N @ M ) ) ) ) ).

% bit_push_bit_iff_int
thf(fact_3546_Re__csqrt,axiom,
    ! [Z: complex] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( re @ ( csqrt @ Z ) ) ) ).

% Re_csqrt
thf(fact_3547_of__int__divide__in__Ints,axiom,
    ! [A: $tType] :
      ( ( idom_divide @ A )
     => ! [B2: int,A2: int] :
          ( ( dvd_dvd @ int @ B2 @ A2 )
         => ( member @ A @ ( divide_divide @ A @ ( ring_1_of_int @ A @ A2 ) @ ( ring_1_of_int @ A @ B2 ) ) @ ( ring_1_Ints @ A ) ) ) ) ).

% of_int_divide_in_Ints
thf(fact_3548_bit__push__bit__iff__nat,axiom,
    ! [M: nat,Q3: nat,N: nat] :
      ( ( bit_se5641148757651400278ts_bit @ nat @ ( bit_se4730199178511100633sh_bit @ nat @ M @ Q3 ) @ N )
      = ( ( ord_less_eq @ nat @ M @ N )
        & ( bit_se5641148757651400278ts_bit @ nat @ Q3 @ ( minus_minus @ nat @ N @ M ) ) ) ) ).

% bit_push_bit_iff_nat
thf(fact_3549_concat__bit__eq,axiom,
    ( bit_concat_bit
    = ( ^ [N3: nat,K3: int,L2: int] : ( plus_plus @ int @ ( bit_se2584673776208193580ke_bit @ int @ N3 @ K3 ) @ ( bit_se4730199178511100633sh_bit @ int @ N3 @ L2 ) ) ) ) ).

% concat_bit_eq
thf(fact_3550_set__bit__eq__or,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se5668285175392031749et_bit @ A )
        = ( ^ [N3: nat,A3: A] : ( bit_se1065995026697491101ons_or @ A @ A3 @ ( bit_se4730199178511100633sh_bit @ A @ N3 @ ( one_one @ A ) ) ) ) ) ) ).

% set_bit_eq_or
thf(fact_3551_concat__bit__def,axiom,
    ( bit_concat_bit
    = ( ^ [N3: nat,K3: int,L2: int] : ( bit_se1065995026697491101ons_or @ int @ ( bit_se2584673776208193580ke_bit @ int @ N3 @ K3 ) @ ( bit_se4730199178511100633sh_bit @ int @ N3 @ L2 ) ) ) ) ).

% concat_bit_def
thf(fact_3552_flip__bit__eq__xor,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se8732182000553998342ip_bit @ A )
        = ( ^ [N3: nat,A3: A] : ( bit_se5824344971392196577ns_xor @ A @ A3 @ ( bit_se4730199178511100633sh_bit @ A @ N3 @ ( one_one @ A ) ) ) ) ) ) ).

% flip_bit_eq_xor
thf(fact_3553_set__bit__int__def,axiom,
    ( ( bit_se5668285175392031749et_bit @ int )
    = ( ^ [N3: nat,K3: int] : ( bit_se1065995026697491101ons_or @ int @ K3 @ ( bit_se4730199178511100633sh_bit @ int @ N3 @ ( one_one @ int ) ) ) ) ) ).

% set_bit_int_def
thf(fact_3554_flip__bit__int__def,axiom,
    ( ( bit_se8732182000553998342ip_bit @ int )
    = ( ^ [N3: nat,K3: int] : ( bit_se5824344971392196577ns_xor @ int @ K3 @ ( bit_se4730199178511100633sh_bit @ int @ N3 @ ( one_one @ int ) ) ) ) ) ).

% flip_bit_int_def
thf(fact_3555_gbinomial__absorb__comp,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: A,K: nat] :
          ( ( times_times @ A @ ( minus_minus @ A @ A2 @ ( semiring_1_of_nat @ A @ K ) ) @ ( gbinomial @ A @ A2 @ K ) )
          = ( times_times @ A @ A2 @ ( gbinomial @ A @ ( minus_minus @ A @ A2 @ ( one_one @ A ) ) @ K ) ) ) ) ).

% gbinomial_absorb_comp
thf(fact_3556_gbinomial__ge__n__over__k__pow__k,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [K: nat,A2: A] :
          ( ( ord_less_eq @ A @ ( semiring_1_of_nat @ A @ K ) @ A2 )
         => ( ord_less_eq @ A @ ( power_power @ A @ ( divide_divide @ A @ A2 @ ( semiring_1_of_nat @ A @ K ) ) @ K ) @ ( gbinomial @ A @ A2 @ K ) ) ) ) ).

% gbinomial_ge_n_over_k_pow_k
thf(fact_3557_gbinomial__mult__1_H,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: A,K: nat] :
          ( ( times_times @ A @ ( gbinomial @ A @ A2 @ K ) @ A2 )
          = ( plus_plus @ A @ ( times_times @ A @ ( semiring_1_of_nat @ A @ K ) @ ( gbinomial @ A @ A2 @ K ) ) @ ( times_times @ A @ ( semiring_1_of_nat @ A @ ( suc @ K ) ) @ ( gbinomial @ A @ A2 @ ( suc @ K ) ) ) ) ) ) ).

% gbinomial_mult_1'
thf(fact_3558_gbinomial__mult__1,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: A,K: nat] :
          ( ( times_times @ A @ A2 @ ( gbinomial @ A @ A2 @ K ) )
          = ( plus_plus @ A @ ( times_times @ A @ ( semiring_1_of_nat @ A @ K ) @ ( gbinomial @ A @ A2 @ K ) ) @ ( times_times @ A @ ( semiring_1_of_nat @ A @ ( suc @ K ) ) @ ( gbinomial @ A @ A2 @ ( suc @ K ) ) ) ) ) ) ).

% gbinomial_mult_1
thf(fact_3559_push__bit__double,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,A2: A] :
          ( ( bit_se4730199178511100633sh_bit @ A @ N @ ( times_times @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) )
          = ( times_times @ A @ ( bit_se4730199178511100633sh_bit @ A @ N @ A2 ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% push_bit_double
thf(fact_3560_Ints__odd__less__0,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A] :
          ( ( member @ A @ A2 @ ( ring_1_Ints @ A ) )
         => ( ( ord_less @ A @ ( plus_plus @ A @ ( plus_plus @ A @ ( one_one @ A ) @ A2 ) @ A2 ) @ ( zero_zero @ A ) )
            = ( ord_less @ A @ A2 @ ( zero_zero @ A ) ) ) ) ) ).

% Ints_odd_less_0
thf(fact_3561_Ints__nonzero__abs__ge1,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: A] :
          ( ( member @ A @ X @ ( ring_1_Ints @ A ) )
         => ( ( X
             != ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ ( one_one @ A ) @ ( abs_abs @ A @ X ) ) ) ) ) ).

% Ints_nonzero_abs_ge1
thf(fact_3562_Ints__nonzero__abs__less1,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: A] :
          ( ( member @ A @ X @ ( ring_1_Ints @ A ) )
         => ( ( ord_less @ A @ ( abs_abs @ A @ X ) @ ( one_one @ A ) )
           => ( X
              = ( zero_zero @ A ) ) ) ) ) ).

% Ints_nonzero_abs_less1
thf(fact_3563_Ints__eq__abs__less1,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: A,Y: A] :
          ( ( member @ A @ X @ ( ring_1_Ints @ A ) )
         => ( ( member @ A @ Y @ ( ring_1_Ints @ A ) )
           => ( ( X = Y )
              = ( ord_less @ A @ ( abs_abs @ A @ ( minus_minus @ A @ X @ Y ) ) @ ( one_one @ A ) ) ) ) ) ) ).

% Ints_eq_abs_less1
thf(fact_3564_bit__iff__and__push__bit__not__eq__0,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se5641148757651400278ts_bit @ A )
        = ( ^ [A3: A,N3: nat] :
              ( ( bit_se5824344872417868541ns_and @ A @ A3 @ ( bit_se4730199178511100633sh_bit @ A @ N3 @ ( one_one @ A ) ) )
             != ( zero_zero @ A ) ) ) ) ) ).

% bit_iff_and_push_bit_not_eq_0
thf(fact_3565_sin__times__pi__eq__0,axiom,
    ! [X: real] :
      ( ( ( sin @ real @ ( times_times @ real @ X @ pi ) )
        = ( zero_zero @ real ) )
      = ( member @ real @ X @ ( ring_1_Ints @ real ) ) ) ).

% sin_times_pi_eq_0
thf(fact_3566_push__bit__mask__eq,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [M: nat,N: nat] :
          ( ( bit_se4730199178511100633sh_bit @ A @ M @ ( bit_se2239418461657761734s_mask @ A @ N ) )
          = ( bit_se5824344872417868541ns_and @ A @ ( bit_se2239418461657761734s_mask @ A @ ( plus_plus @ nat @ N @ M ) ) @ ( bit_ri4277139882892585799ns_not @ A @ ( bit_se2239418461657761734s_mask @ A @ M ) ) ) ) ) ).

% push_bit_mask_eq
thf(fact_3567_unset__bit__eq__and__not,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( ( bit_se2638667681897837118et_bit @ A )
        = ( ^ [N3: nat,A3: A] : ( bit_se5824344872417868541ns_and @ A @ A3 @ ( bit_ri4277139882892585799ns_not @ A @ ( bit_se4730199178511100633sh_bit @ A @ N3 @ ( one_one @ A ) ) ) ) ) ) ) ).

% unset_bit_eq_and_not
thf(fact_3568_unset__bit__int__def,axiom,
    ( ( bit_se2638667681897837118et_bit @ int )
    = ( ^ [N3: nat,K3: int] : ( bit_se5824344872417868541ns_and @ int @ K3 @ ( bit_ri4277139882892585799ns_not @ int @ ( bit_se4730199178511100633sh_bit @ int @ N3 @ ( one_one @ int ) ) ) ) ) ) ).

% unset_bit_int_def
thf(fact_3569_Suc__times__gbinomial,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [K: nat,A2: A] :
          ( ( times_times @ A @ ( semiring_1_of_nat @ A @ ( suc @ K ) ) @ ( gbinomial @ A @ ( plus_plus @ A @ A2 @ ( one_one @ A ) ) @ ( suc @ K ) ) )
          = ( times_times @ A @ ( plus_plus @ A @ A2 @ ( one_one @ A ) ) @ ( gbinomial @ A @ A2 @ K ) ) ) ) ).

% Suc_times_gbinomial
thf(fact_3570_gbinomial__absorption,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [K: nat,A2: A] :
          ( ( times_times @ A @ ( semiring_1_of_nat @ A @ ( suc @ K ) ) @ ( gbinomial @ A @ A2 @ ( suc @ K ) ) )
          = ( times_times @ A @ A2 @ ( gbinomial @ A @ ( minus_minus @ A @ A2 @ ( one_one @ A ) ) @ K ) ) ) ) ).

% gbinomial_absorption
thf(fact_3571_gbinomial__trinomial__revision,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [K: nat,M: nat,A2: A] :
          ( ( ord_less_eq @ nat @ K @ M )
         => ( ( times_times @ A @ ( gbinomial @ A @ A2 @ M ) @ ( gbinomial @ A @ ( semiring_1_of_nat @ A @ M ) @ K ) )
            = ( times_times @ A @ ( gbinomial @ A @ A2 @ K ) @ ( gbinomial @ A @ ( minus_minus @ A @ A2 @ ( semiring_1_of_nat @ A @ K ) ) @ ( minus_minus @ nat @ M @ K ) ) ) ) ) ) ).

% gbinomial_trinomial_revision
thf(fact_3572_push__bit__int__def,axiom,
    ( ( bit_se4730199178511100633sh_bit @ int )
    = ( ^ [N3: nat,K3: int] : ( times_times @ int @ K3 @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N3 ) ) ) ) ).

% push_bit_int_def
thf(fact_3573_push__bit__nat__def,axiom,
    ( ( bit_se4730199178511100633sh_bit @ nat )
    = ( ^ [N3: nat,M3: nat] : ( times_times @ nat @ M3 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N3 ) ) ) ) ).

% push_bit_nat_def
thf(fact_3574_cmod__plus__Re__le__0__iff,axiom,
    ! [Z: complex] :
      ( ( ord_less_eq @ real @ ( plus_plus @ real @ ( real_V7770717601297561774m_norm @ complex @ Z ) @ ( re @ Z ) ) @ ( zero_zero @ real ) )
      = ( ( re @ Z )
        = ( uminus_uminus @ real @ ( real_V7770717601297561774m_norm @ complex @ Z ) ) ) ) ).

% cmod_plus_Re_le_0_iff
thf(fact_3575_push__bit__eq__mult,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se4730199178511100633sh_bit @ A )
        = ( ^ [N3: nat,A3: A] : ( times_times @ A @ A3 @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N3 ) ) ) ) ) ).

% push_bit_eq_mult
thf(fact_3576_exp__dvdE,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,A2: A] :
          ( ( dvd_dvd @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) @ A2 )
         => ~ ! [B4: A] :
                ( A2
               != ( bit_se4730199178511100633sh_bit @ A @ N @ B4 ) ) ) ) ).

% exp_dvdE
thf(fact_3577_cos__n__Re__cis__pow__n,axiom,
    ! [N: nat,A2: real] :
      ( ( cos @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N ) @ A2 ) )
      = ( re @ ( power_power @ complex @ ( cis @ A2 ) @ N ) ) ) ).

% cos_n_Re_cis_pow_n
thf(fact_3578_frac__neg,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A] :
          ( ( ( member @ A @ X @ ( ring_1_Ints @ A ) )
           => ( ( archimedean_frac @ A @ ( uminus_uminus @ A @ X ) )
              = ( zero_zero @ A ) ) )
          & ( ~ ( member @ A @ X @ ( ring_1_Ints @ A ) )
           => ( ( archimedean_frac @ A @ ( uminus_uminus @ A @ X ) )
              = ( minus_minus @ A @ ( one_one @ A ) @ ( archimedean_frac @ A @ X ) ) ) ) ) ) ).

% frac_neg
thf(fact_3579_gbinomial__factors,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: A,K: nat] :
          ( ( gbinomial @ A @ ( plus_plus @ A @ A2 @ ( one_one @ A ) ) @ ( suc @ K ) )
          = ( times_times @ A @ ( divide_divide @ A @ ( plus_plus @ A @ A2 @ ( one_one @ A ) ) @ ( semiring_1_of_nat @ A @ ( suc @ K ) ) ) @ ( gbinomial @ A @ A2 @ K ) ) ) ) ).

% gbinomial_factors
thf(fact_3580_gbinomial__rec,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: A,K: nat] :
          ( ( gbinomial @ A @ ( plus_plus @ A @ A2 @ ( one_one @ A ) ) @ ( suc @ K ) )
          = ( times_times @ A @ ( gbinomial @ A @ A2 @ K ) @ ( divide_divide @ A @ ( plus_plus @ A @ A2 @ ( one_one @ A ) ) @ ( semiring_1_of_nat @ A @ ( suc @ K ) ) ) ) ) ) ).

% gbinomial_rec
thf(fact_3581_gbinomial__negated__upper,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ( ( gbinomial @ A )
        = ( ^ [A3: A,K3: nat] : ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ K3 ) @ ( gbinomial @ A @ ( minus_minus @ A @ ( minus_minus @ A @ ( semiring_1_of_nat @ A @ K3 ) @ A3 ) @ ( one_one @ A ) ) @ K3 ) ) ) ) ) ).

% gbinomial_negated_upper
thf(fact_3582_gbinomial__index__swap,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [K: nat,N: nat] :
          ( ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ K ) @ ( gbinomial @ A @ ( minus_minus @ A @ ( uminus_uminus @ A @ ( semiring_1_of_nat @ A @ N ) ) @ ( one_one @ A ) ) @ K ) )
          = ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ N ) @ ( gbinomial @ A @ ( minus_minus @ A @ ( uminus_uminus @ A @ ( semiring_1_of_nat @ A @ K ) ) @ ( one_one @ A ) ) @ N ) ) ) ) ).

% gbinomial_index_swap
thf(fact_3583_push__bit__minus__one,axiom,
    ! [N: nat] :
      ( ( bit_se4730199178511100633sh_bit @ int @ N @ ( uminus_uminus @ int @ ( one_one @ int ) ) )
      = ( uminus_uminus @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N ) ) ) ).

% push_bit_minus_one
thf(fact_3584_Cauchy__iff,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ( ( topolo3814608138187158403Cauchy @ A )
        = ( ^ [X8: nat > A] :
            ! [E3: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ E3 )
             => ? [M8: nat] :
                ! [M3: nat] :
                  ( ( ord_less_eq @ nat @ M8 @ M3 )
                 => ! [N3: nat] :
                      ( ( ord_less_eq @ nat @ M8 @ N3 )
                     => ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ ( X8 @ M3 ) @ ( X8 @ N3 ) ) ) @ E3 ) ) ) ) ) ) ) ).

% Cauchy_iff
thf(fact_3585_CauchyI,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X7: nat > A] :
          ( ! [E: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ E )
             => ? [M9: nat] :
                ! [M4: nat] :
                  ( ( ord_less_eq @ nat @ M9 @ M4 )
                 => ! [N2: nat] :
                      ( ( ord_less_eq @ nat @ M9 @ N2 )
                     => ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ ( X7 @ M4 ) @ ( X7 @ N2 ) ) ) @ E ) ) ) )
         => ( topolo3814608138187158403Cauchy @ A @ X7 ) ) ) ).

% CauchyI
thf(fact_3586_CauchyD,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X7: nat > A,E2: real] :
          ( ( topolo3814608138187158403Cauchy @ A @ X7 )
         => ( ( ord_less @ real @ ( zero_zero @ real ) @ E2 )
           => ? [M10: nat] :
              ! [M2: nat] :
                ( ( ord_less_eq @ nat @ M10 @ M2 )
               => ! [N7: nat] :
                    ( ( ord_less_eq @ nat @ M10 @ N7 )
                   => ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ ( X7 @ M2 ) @ ( X7 @ N7 ) ) ) @ E2 ) ) ) ) ) ) ).

% CauchyD
thf(fact_3587_le__mult__floor__Ints,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( archim2362893244070406136eiling @ B )
        & ( linordered_idom @ A ) )
     => ! [A2: B,B2: B] :
          ( ( ord_less_eq @ B @ ( zero_zero @ B ) @ A2 )
         => ( ( member @ B @ A2 @ ( ring_1_Ints @ B ) )
           => ( ord_less_eq @ A @ ( ring_1_of_int @ A @ ( times_times @ int @ ( archim6421214686448440834_floor @ B @ A2 ) @ ( archim6421214686448440834_floor @ B @ B2 ) ) ) @ ( ring_1_of_int @ A @ ( archim6421214686448440834_floor @ B @ ( times_times @ B @ A2 @ B2 ) ) ) ) ) ) ) ).

% le_mult_floor_Ints
thf(fact_3588_frac__unique__iff,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [X: A,A2: A] :
          ( ( ( archimedean_frac @ A @ X )
            = A2 )
          = ( ( member @ A @ ( minus_minus @ A @ X @ A2 ) @ ( ring_1_Ints @ A ) )
            & ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
            & ( ord_less @ A @ A2 @ ( one_one @ A ) ) ) ) ) ).

% frac_unique_iff
thf(fact_3589_mult__ceiling__le__Ints,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( archim2362893244070406136eiling @ B )
        & ( linordered_idom @ A ) )
     => ! [A2: B,B2: B] :
          ( ( ord_less_eq @ B @ ( zero_zero @ B ) @ A2 )
         => ( ( member @ B @ A2 @ ( ring_1_Ints @ B ) )
           => ( ord_less_eq @ A @ ( ring_1_of_int @ A @ ( archimedean_ceiling @ B @ ( times_times @ B @ A2 @ B2 ) ) ) @ ( ring_1_of_int @ A @ ( times_times @ int @ ( archimedean_ceiling @ B @ A2 ) @ ( archimedean_ceiling @ B @ B2 ) ) ) ) ) ) ) ).

% mult_ceiling_le_Ints
thf(fact_3590_gbinomial__minus,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: A,K: nat] :
          ( ( gbinomial @ A @ ( uminus_uminus @ A @ A2 ) @ K )
          = ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ K ) @ ( gbinomial @ A @ ( minus_minus @ A @ ( plus_plus @ A @ A2 @ ( semiring_1_of_nat @ A @ K ) ) @ ( one_one @ A ) ) @ K ) ) ) ) ).

% gbinomial_minus
thf(fact_3591_gbinomial__reduce__nat,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [K: nat,A2: A] :
          ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
         => ( ( gbinomial @ A @ A2 @ K )
            = ( plus_plus @ A @ ( gbinomial @ A @ ( minus_minus @ A @ A2 @ ( one_one @ A ) ) @ ( minus_minus @ nat @ K @ ( one_one @ nat ) ) ) @ ( gbinomial @ A @ ( minus_minus @ A @ A2 @ ( one_one @ A ) ) @ K ) ) ) ) ) ).

% gbinomial_reduce_nat
thf(fact_3592_gbinomial__pochhammer,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ( ( gbinomial @ A )
        = ( ^ [A3: A,K3: nat] : ( divide_divide @ A @ ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ K3 ) @ ( comm_s3205402744901411588hammer @ A @ ( uminus_uminus @ A @ A3 ) @ K3 ) ) @ ( semiring_char_0_fact @ A @ K3 ) ) ) ) ) ).

% gbinomial_pochhammer
thf(fact_3593_gbinomial__pochhammer_H,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ( ( gbinomial @ A )
        = ( ^ [A3: A,K3: nat] : ( divide_divide @ A @ ( comm_s3205402744901411588hammer @ A @ ( plus_plus @ A @ ( minus_minus @ A @ A3 @ ( semiring_1_of_nat @ A @ K3 ) ) @ ( one_one @ A ) ) @ K3 ) @ ( semiring_char_0_fact @ A @ K3 ) ) ) ) ) ).

% gbinomial_pochhammer'
thf(fact_3594_sin__integer__2pi,axiom,
    ! [N: real] :
      ( ( member @ real @ N @ ( ring_1_Ints @ real ) )
     => ( ( sin @ real @ ( times_times @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) @ N ) )
        = ( zero_zero @ real ) ) ) ).

% sin_integer_2pi
thf(fact_3595_cos__integer__2pi,axiom,
    ! [N: real] :
      ( ( member @ real @ N @ ( ring_1_Ints @ real ) )
     => ( ( cos @ real @ ( times_times @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) @ N ) )
        = ( one_one @ real ) ) ) ).

% cos_integer_2pi
thf(fact_3596_csqrt_Ocode,axiom,
    ( csqrt
    = ( ^ [Z6: complex] :
          ( complex2 @ ( sqrt @ ( divide_divide @ real @ ( plus_plus @ real @ ( real_V7770717601297561774m_norm @ complex @ Z6 ) @ ( re @ Z6 ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
          @ ( times_times @ real
            @ ( if @ real
              @ ( ( im @ Z6 )
                = ( zero_zero @ real ) )
              @ ( one_one @ real )
              @ ( sgn_sgn @ real @ ( im @ Z6 ) ) )
            @ ( sqrt @ ( divide_divide @ real @ ( minus_minus @ real @ ( real_V7770717601297561774m_norm @ complex @ Z6 ) @ ( re @ Z6 ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% csqrt.code
thf(fact_3597_csqrt_Osimps_I2_J,axiom,
    ! [Z: complex] :
      ( ( im @ ( csqrt @ Z ) )
      = ( times_times @ real
        @ ( if @ real
          @ ( ( im @ Z )
            = ( zero_zero @ real ) )
          @ ( one_one @ real )
          @ ( sgn_sgn @ real @ ( im @ Z ) ) )
        @ ( sqrt @ ( divide_divide @ real @ ( minus_minus @ real @ ( real_V7770717601297561774m_norm @ complex @ Z ) @ ( re @ Z ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ).

% csqrt.simps(2)
thf(fact_3598_csqrt__of__real__nonpos,axiom,
    ! [X: complex] :
      ( ( ( im @ X )
        = ( zero_zero @ real ) )
     => ( ( ord_less_eq @ real @ ( re @ X ) @ ( zero_zero @ real ) )
       => ( ( csqrt @ X )
          = ( times_times @ complex @ imaginary_unit @ ( real_Vector_of_real @ complex @ ( sqrt @ ( abs_abs @ real @ ( re @ X ) ) ) ) ) ) ) ) ).

% csqrt_of_real_nonpos
thf(fact_3599_Complex__divide,axiom,
    ( ( divide_divide @ complex )
    = ( ^ [X2: complex,Y4: complex] : ( complex2 @ ( divide_divide @ real @ ( plus_plus @ real @ ( times_times @ real @ ( re @ X2 ) @ ( re @ Y4 ) ) @ ( times_times @ real @ ( im @ X2 ) @ ( im @ Y4 ) ) ) @ ( plus_plus @ real @ ( power_power @ real @ ( re @ Y4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ ( im @ Y4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( divide_divide @ real @ ( minus_minus @ real @ ( times_times @ real @ ( im @ X2 ) @ ( re @ Y4 ) ) @ ( times_times @ real @ ( re @ X2 ) @ ( im @ Y4 ) ) ) @ ( plus_plus @ real @ ( power_power @ real @ ( re @ Y4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ ( im @ Y4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% Complex_divide
thf(fact_3600_inverse__complex_Ocode,axiom,
    ( ( inverse_inverse @ complex )
    = ( ^ [X2: complex] : ( complex2 @ ( divide_divide @ real @ ( re @ X2 ) @ ( plus_plus @ real @ ( power_power @ real @ ( re @ X2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ ( im @ X2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( divide_divide @ real @ ( uminus_uminus @ real @ ( im @ X2 ) ) @ ( plus_plus @ real @ ( power_power @ real @ ( re @ X2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ ( im @ X2 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% inverse_complex.code
thf(fact_3601_complex__Im__fact,axiom,
    ! [N: nat] :
      ( ( im @ ( semiring_char_0_fact @ complex @ N ) )
      = ( zero_zero @ real ) ) ).

% complex_Im_fact
thf(fact_3602_complex__Im__of__int,axiom,
    ! [Z: int] :
      ( ( im @ ( ring_1_of_int @ complex @ Z ) )
      = ( zero_zero @ real ) ) ).

% complex_Im_of_int
thf(fact_3603_Im__complex__of__real,axiom,
    ! [Z: real] :
      ( ( im @ ( real_Vector_of_real @ complex @ Z ) )
      = ( zero_zero @ real ) ) ).

% Im_complex_of_real
thf(fact_3604_Im__power__real,axiom,
    ! [X: complex,N: nat] :
      ( ( ( im @ X )
        = ( zero_zero @ real ) )
     => ( ( im @ ( power_power @ complex @ X @ N ) )
        = ( zero_zero @ real ) ) ) ).

% Im_power_real
thf(fact_3605_complex__Im__numeral,axiom,
    ! [V: num] :
      ( ( im @ ( numeral_numeral @ complex @ V ) )
      = ( zero_zero @ real ) ) ).

% complex_Im_numeral
thf(fact_3606_complex__Im__of__nat,axiom,
    ! [N: nat] :
      ( ( im @ ( semiring_1_of_nat @ complex @ N ) )
      = ( zero_zero @ real ) ) ).

% complex_Im_of_nat
thf(fact_3607_Re__power__real,axiom,
    ! [X: complex,N: nat] :
      ( ( ( im @ X )
        = ( zero_zero @ real ) )
     => ( ( re @ ( power_power @ complex @ X @ N ) )
        = ( power_power @ real @ ( re @ X ) @ N ) ) ) ).

% Re_power_real
thf(fact_3608_Im__divide__numeral,axiom,
    ! [Z: complex,W: num] :
      ( ( im @ ( divide_divide @ complex @ Z @ ( numeral_numeral @ complex @ W ) ) )
      = ( divide_divide @ real @ ( im @ Z ) @ ( numeral_numeral @ real @ W ) ) ) ).

% Im_divide_numeral
thf(fact_3609_Im__divide__of__nat,axiom,
    ! [Z: complex,N: nat] :
      ( ( im @ ( divide_divide @ complex @ Z @ ( semiring_1_of_nat @ complex @ N ) ) )
      = ( divide_divide @ real @ ( im @ Z ) @ ( semiring_1_of_nat @ real @ N ) ) ) ).

% Im_divide_of_nat
thf(fact_3610_csqrt__of__real__nonneg,axiom,
    ! [X: complex] :
      ( ( ( im @ X )
        = ( zero_zero @ real ) )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( re @ X ) )
       => ( ( csqrt @ X )
          = ( real_Vector_of_real @ complex @ ( sqrt @ ( re @ X ) ) ) ) ) ) ).

% csqrt_of_real_nonneg
thf(fact_3611_csqrt__minus,axiom,
    ! [X: complex] :
      ( ( ( ord_less @ real @ ( im @ X ) @ ( zero_zero @ real ) )
        | ( ( ( im @ X )
            = ( zero_zero @ real ) )
          & ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( re @ X ) ) ) )
     => ( ( csqrt @ ( uminus_uminus @ complex @ X ) )
        = ( times_times @ complex @ imaginary_unit @ ( csqrt @ X ) ) ) ) ).

% csqrt_minus
thf(fact_3612_complex__is__Int__iff,axiom,
    ! [Z: complex] :
      ( ( member @ complex @ Z @ ( ring_1_Ints @ complex ) )
      = ( ( ( im @ Z )
          = ( zero_zero @ real ) )
        & ? [I4: int] :
            ( ( re @ Z )
            = ( ring_1_of_int @ real @ I4 ) ) ) ) ).

% complex_is_Int_iff
thf(fact_3613_zero__complex_Osimps_I2_J,axiom,
    ( ( im @ ( zero_zero @ complex ) )
    = ( zero_zero @ real ) ) ).

% zero_complex.simps(2)
thf(fact_3614_one__complex_Osimps_I2_J,axiom,
    ( ( im @ ( one_one @ complex ) )
    = ( zero_zero @ real ) ) ).

% one_complex.simps(2)
thf(fact_3615_abs__Im__le__cmod,axiom,
    ! [X: complex] : ( ord_less_eq @ real @ ( abs_abs @ real @ ( im @ X ) ) @ ( real_V7770717601297561774m_norm @ complex @ X ) ) ).

% abs_Im_le_cmod
thf(fact_3616_Im__eq__0,axiom,
    ! [Z: complex] :
      ( ( ( abs_abs @ real @ ( re @ Z ) )
        = ( real_V7770717601297561774m_norm @ complex @ Z ) )
     => ( ( im @ Z )
        = ( zero_zero @ real ) ) ) ).

% Im_eq_0
thf(fact_3617_cmod__eq__Im,axiom,
    ! [Z: complex] :
      ( ( ( re @ Z )
        = ( zero_zero @ real ) )
     => ( ( real_V7770717601297561774m_norm @ complex @ Z )
        = ( abs_abs @ real @ ( im @ Z ) ) ) ) ).

% cmod_eq_Im
thf(fact_3618_cmod__eq__Re,axiom,
    ! [Z: complex] :
      ( ( ( im @ Z )
        = ( zero_zero @ real ) )
     => ( ( real_V7770717601297561774m_norm @ complex @ Z )
        = ( abs_abs @ real @ ( re @ Z ) ) ) ) ).

% cmod_eq_Re
thf(fact_3619_cmod__Im__le__iff,axiom,
    ! [X: complex,Y: complex] :
      ( ( ( re @ X )
        = ( re @ Y ) )
     => ( ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ complex @ X ) @ ( real_V7770717601297561774m_norm @ complex @ Y ) )
        = ( ord_less_eq @ real @ ( abs_abs @ real @ ( im @ X ) ) @ ( abs_abs @ real @ ( im @ Y ) ) ) ) ) ).

% cmod_Im_le_iff
thf(fact_3620_cmod__Re__le__iff,axiom,
    ! [X: complex,Y: complex] :
      ( ( ( im @ X )
        = ( im @ Y ) )
     => ( ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ complex @ X ) @ ( real_V7770717601297561774m_norm @ complex @ Y ) )
        = ( ord_less_eq @ real @ ( abs_abs @ real @ ( re @ X ) ) @ ( abs_abs @ real @ ( re @ Y ) ) ) ) ) ).

% cmod_Re_le_iff
thf(fact_3621_csqrt__principal,axiom,
    ! [Z: complex] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ ( re @ ( csqrt @ Z ) ) )
      | ( ( ( re @ ( csqrt @ Z ) )
          = ( zero_zero @ real ) )
        & ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( im @ ( csqrt @ Z ) ) ) ) ) ).

% csqrt_principal
thf(fact_3622_cmod__le,axiom,
    ! [Z: complex] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ complex @ Z ) @ ( plus_plus @ real @ ( abs_abs @ real @ ( re @ Z ) ) @ ( abs_abs @ real @ ( im @ Z ) ) ) ) ).

% cmod_le
thf(fact_3623_sin__n__Im__cis__pow__n,axiom,
    ! [N: nat,A2: real] :
      ( ( sin @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N ) @ A2 ) )
      = ( im @ ( power_power @ complex @ ( cis @ A2 ) @ N ) ) ) ).

% sin_n_Im_cis_pow_n
thf(fact_3624_cmod__power2,axiom,
    ! [Z: complex] :
      ( ( power_power @ real @ ( real_V7770717601297561774m_norm @ complex @ Z ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
      = ( plus_plus @ real @ ( power_power @ real @ ( re @ Z ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ ( im @ Z ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ).

% cmod_power2
thf(fact_3625_Im__power2,axiom,
    ! [X: complex] :
      ( ( im @ ( power_power @ complex @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
      = ( times_times @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( re @ X ) ) @ ( im @ X ) ) ) ).

% Im_power2
thf(fact_3626_Re__power2,axiom,
    ! [X: complex] :
      ( ( re @ ( power_power @ complex @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
      = ( minus_minus @ real @ ( power_power @ real @ ( re @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ ( im @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ).

% Re_power2
thf(fact_3627_complex__eq__0,axiom,
    ! [Z: complex] :
      ( ( Z
        = ( zero_zero @ complex ) )
      = ( ( plus_plus @ real @ ( power_power @ real @ ( re @ Z ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ ( im @ Z ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
        = ( zero_zero @ real ) ) ) ).

% complex_eq_0
thf(fact_3628_norm__complex__def,axiom,
    ( ( real_V7770717601297561774m_norm @ complex )
    = ( ^ [Z6: complex] : ( sqrt @ ( plus_plus @ real @ ( power_power @ real @ ( re @ Z6 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ ( im @ Z6 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% norm_complex_def
thf(fact_3629_inverse__complex_Osimps_I1_J,axiom,
    ! [X: complex] :
      ( ( re @ ( inverse_inverse @ complex @ X ) )
      = ( divide_divide @ real @ ( re @ X ) @ ( plus_plus @ real @ ( power_power @ real @ ( re @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ ( im @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% inverse_complex.simps(1)
thf(fact_3630_complex__neq__0,axiom,
    ! [Z: complex] :
      ( ( ( Z
         != ( zero_zero @ complex ) ) )
      = ( ord_less @ real @ ( zero_zero @ real ) @ ( plus_plus @ real @ ( power_power @ real @ ( re @ Z ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ ( im @ Z ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% complex_neq_0
thf(fact_3631_Re__divide,axiom,
    ! [X: complex,Y: complex] :
      ( ( re @ ( divide_divide @ complex @ X @ Y ) )
      = ( divide_divide @ real @ ( plus_plus @ real @ ( times_times @ real @ ( re @ X ) @ ( re @ Y ) ) @ ( times_times @ real @ ( im @ X ) @ ( im @ Y ) ) ) @ ( plus_plus @ real @ ( power_power @ real @ ( re @ Y ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ ( im @ Y ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% Re_divide
thf(fact_3632_csqrt__unique,axiom,
    ! [W: complex,Z: complex] :
      ( ( ( power_power @ complex @ W @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
        = Z )
     => ( ( ( ord_less @ real @ ( zero_zero @ real ) @ ( re @ W ) )
          | ( ( ( re @ W )
              = ( zero_zero @ real ) )
            & ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( im @ W ) ) ) )
       => ( ( csqrt @ Z )
          = W ) ) ) ).

% csqrt_unique
thf(fact_3633_csqrt__square,axiom,
    ! [B2: complex] :
      ( ( ( ord_less @ real @ ( zero_zero @ real ) @ ( re @ B2 ) )
        | ( ( ( re @ B2 )
            = ( zero_zero @ real ) )
          & ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( im @ B2 ) ) ) )
     => ( ( csqrt @ ( power_power @ complex @ B2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
        = B2 ) ) ).

% csqrt_square
thf(fact_3634_inverse__complex_Osimps_I2_J,axiom,
    ! [X: complex] :
      ( ( im @ ( inverse_inverse @ complex @ X ) )
      = ( divide_divide @ real @ ( uminus_uminus @ real @ ( im @ X ) ) @ ( plus_plus @ real @ ( power_power @ real @ ( re @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ ( im @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% inverse_complex.simps(2)
thf(fact_3635_Im__divide,axiom,
    ! [X: complex,Y: complex] :
      ( ( im @ ( divide_divide @ complex @ X @ Y ) )
      = ( divide_divide @ real @ ( minus_minus @ real @ ( times_times @ real @ ( im @ X ) @ ( re @ Y ) ) @ ( times_times @ real @ ( re @ X ) @ ( im @ Y ) ) ) @ ( plus_plus @ real @ ( power_power @ real @ ( re @ Y ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ ( im @ Y ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% Im_divide
thf(fact_3636_complex__abs__le__norm,axiom,
    ! [Z: complex] : ( ord_less_eq @ real @ ( plus_plus @ real @ ( abs_abs @ real @ ( re @ Z ) ) @ ( abs_abs @ real @ ( im @ Z ) ) ) @ ( times_times @ real @ ( sqrt @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( real_V7770717601297561774m_norm @ complex @ Z ) ) ) ).

% complex_abs_le_norm
thf(fact_3637_complex__unit__circle,axiom,
    ! [Z: complex] :
      ( ( Z
       != ( zero_zero @ complex ) )
     => ( ( plus_plus @ real @ ( power_power @ real @ ( divide_divide @ real @ ( re @ Z ) @ ( real_V7770717601297561774m_norm @ complex @ Z ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ ( divide_divide @ real @ ( im @ Z ) @ ( real_V7770717601297561774m_norm @ complex @ Z ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
        = ( one_one @ real ) ) ) ).

% complex_unit_circle
thf(fact_3638_Im__Reals__divide,axiom,
    ! [R2: complex,Z: complex] :
      ( ( member @ complex @ R2 @ ( real_Vector_Reals @ complex ) )
     => ( ( im @ ( divide_divide @ complex @ R2 @ Z ) )
        = ( divide_divide @ real @ ( times_times @ real @ ( uminus_uminus @ real @ ( re @ R2 ) ) @ ( im @ Z ) ) @ ( power_power @ real @ ( real_V7770717601297561774m_norm @ complex @ Z ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% Im_Reals_divide
thf(fact_3639_Re__Reals__divide,axiom,
    ! [R2: complex,Z: complex] :
      ( ( member @ complex @ R2 @ ( real_Vector_Reals @ complex ) )
     => ( ( re @ ( divide_divide @ complex @ R2 @ Z ) )
        = ( divide_divide @ real @ ( times_times @ real @ ( re @ R2 ) @ ( re @ Z ) ) @ ( power_power @ real @ ( real_V7770717601297561774m_norm @ complex @ Z ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% Re_Reals_divide
thf(fact_3640_complex__mult__cnj,axiom,
    ! [Z: complex] :
      ( ( times_times @ complex @ Z @ ( cnj @ Z ) )
      = ( real_Vector_of_real @ complex @ ( plus_plus @ real @ ( power_power @ real @ ( re @ Z ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( power_power @ real @ ( im @ Z ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ).

% complex_mult_cnj
thf(fact_3641_cnj__add__mult__eq__Re,axiom,
    ! [Z: complex,W: complex] :
      ( ( plus_plus @ complex @ ( times_times @ complex @ Z @ ( cnj @ W ) ) @ ( times_times @ complex @ ( cnj @ Z ) @ W ) )
      = ( real_Vector_of_real @ complex @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( re @ ( times_times @ complex @ Z @ ( cnj @ W ) ) ) ) ) ) ).

% cnj_add_mult_eq_Re
thf(fact_3642_complex__cnj__zero__iff,axiom,
    ! [Z: complex] :
      ( ( ( cnj @ Z )
        = ( zero_zero @ complex ) )
      = ( Z
        = ( zero_zero @ complex ) ) ) ).

% complex_cnj_zero_iff
thf(fact_3643_complex__cnj__zero,axiom,
    ( ( cnj @ ( zero_zero @ complex ) )
    = ( zero_zero @ complex ) ) ).

% complex_cnj_zero
thf(fact_3644_complex__cnj__power,axiom,
    ! [X: complex,N: nat] :
      ( ( cnj @ ( power_power @ complex @ X @ N ) )
      = ( power_power @ complex @ ( cnj @ X ) @ N ) ) ).

% complex_cnj_power
thf(fact_3645_complex__In__mult__cnj__zero,axiom,
    ! [Z: complex] :
      ( ( im @ ( times_times @ complex @ Z @ ( cnj @ Z ) ) )
      = ( zero_zero @ real ) ) ).

% complex_In_mult_cnj_zero
thf(fact_3646_real__eq__imaginary__iff,axiom,
    ! [Y: complex,X: complex] :
      ( ( member @ complex @ Y @ ( real_Vector_Reals @ complex ) )
     => ( ( member @ complex @ X @ ( real_Vector_Reals @ complex ) )
       => ( ( X
            = ( times_times @ complex @ imaginary_unit @ Y ) )
          = ( ( X
              = ( zero_zero @ complex ) )
            & ( Y
              = ( zero_zero @ complex ) ) ) ) ) ) ).

% real_eq_imaginary_iff
thf(fact_3647_imaginary__eq__real__iff,axiom,
    ! [Y: complex,X: complex] :
      ( ( member @ complex @ Y @ ( real_Vector_Reals @ complex ) )
     => ( ( member @ complex @ X @ ( real_Vector_Reals @ complex ) )
       => ( ( ( times_times @ complex @ imaginary_unit @ Y )
            = X )
          = ( ( X
              = ( zero_zero @ complex ) )
            & ( Y
              = ( zero_zero @ complex ) ) ) ) ) ) ).

% imaginary_eq_real_iff
thf(fact_3648_Reals__numeral,axiom,
    ! [A: $tType] :
      ( ( real_V2191834092415804123ebra_1 @ A )
     => ! [W: num] : ( member @ A @ ( numeral_numeral @ A @ W ) @ ( real_Vector_Reals @ A ) ) ) ).

% Reals_numeral
thf(fact_3649_Reals__power,axiom,
    ! [A: $tType] :
      ( ( real_V2191834092415804123ebra_1 @ A )
     => ! [A2: A,N: nat] :
          ( ( member @ A @ A2 @ ( real_Vector_Reals @ A ) )
         => ( member @ A @ ( power_power @ A @ A2 @ N ) @ ( real_Vector_Reals @ A ) ) ) ) ).

% Reals_power
thf(fact_3650_Reals__0,axiom,
    ! [A: $tType] :
      ( ( real_V2191834092415804123ebra_1 @ A )
     => ( member @ A @ ( zero_zero @ A ) @ ( real_Vector_Reals @ A ) ) ) ).

% Reals_0
thf(fact_3651_Reals__of__nat,axiom,
    ! [A: $tType] :
      ( ( real_V2191834092415804123ebra_1 @ A )
     => ! [N: nat] : ( member @ A @ ( semiring_1_of_nat @ A @ N ) @ ( real_Vector_Reals @ A ) ) ) ).

% Reals_of_nat
thf(fact_3652_complex__is__Real__iff,axiom,
    ! [Z: complex] :
      ( ( member @ complex @ Z @ ( real_Vector_Reals @ complex ) )
      = ( ( im @ Z )
        = ( zero_zero @ real ) ) ) ).

% complex_is_Real_iff
thf(fact_3653_nonzero__Reals__divide,axiom,
    ! [A: $tType] :
      ( ( real_V7773925162809079976_field @ A )
     => ! [A2: A,B2: A] :
          ( ( member @ A @ A2 @ ( real_Vector_Reals @ A ) )
         => ( ( member @ A @ B2 @ ( real_Vector_Reals @ A ) )
           => ( ( B2
               != ( zero_zero @ A ) )
             => ( member @ A @ ( divide_divide @ A @ A2 @ B2 ) @ ( real_Vector_Reals @ A ) ) ) ) ) ) ).

% nonzero_Reals_divide
thf(fact_3654_Complex__in__Reals,axiom,
    ! [X: real] : ( member @ complex @ ( complex2 @ X @ ( zero_zero @ real ) ) @ ( real_Vector_Reals @ complex ) ) ).

% Complex_in_Reals
thf(fact_3655_nonzero__Reals__inverse,axiom,
    ! [A: $tType] :
      ( ( real_V5047593784448816457lgebra @ A )
     => ! [A2: A] :
          ( ( member @ A @ A2 @ ( real_Vector_Reals @ A ) )
         => ( ( A2
             != ( zero_zero @ A ) )
           => ( member @ A @ ( inverse_inverse @ A @ A2 ) @ ( real_Vector_Reals @ A ) ) ) ) ) ).

% nonzero_Reals_inverse
thf(fact_3656_Re__complex__div__eq__0,axiom,
    ! [A2: complex,B2: complex] :
      ( ( ( re @ ( divide_divide @ complex @ A2 @ B2 ) )
        = ( zero_zero @ real ) )
      = ( ( re @ ( times_times @ complex @ A2 @ ( cnj @ B2 ) ) )
        = ( zero_zero @ real ) ) ) ).

% Re_complex_div_eq_0
thf(fact_3657_Im__complex__div__eq__0,axiom,
    ! [A2: complex,B2: complex] :
      ( ( ( im @ ( divide_divide @ complex @ A2 @ B2 ) )
        = ( zero_zero @ real ) )
      = ( ( im @ ( times_times @ complex @ A2 @ ( cnj @ B2 ) ) )
        = ( zero_zero @ real ) ) ) ).

% Im_complex_div_eq_0
thf(fact_3658_Re__complex__div__lt__0,axiom,
    ! [A2: complex,B2: complex] :
      ( ( ord_less @ real @ ( re @ ( divide_divide @ complex @ A2 @ B2 ) ) @ ( zero_zero @ real ) )
      = ( ord_less @ real @ ( re @ ( times_times @ complex @ A2 @ ( cnj @ B2 ) ) ) @ ( zero_zero @ real ) ) ) ).

% Re_complex_div_lt_0
thf(fact_3659_Re__complex__div__gt__0,axiom,
    ! [A2: complex,B2: complex] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ ( re @ ( divide_divide @ complex @ A2 @ B2 ) ) )
      = ( ord_less @ real @ ( zero_zero @ real ) @ ( re @ ( times_times @ complex @ A2 @ ( cnj @ B2 ) ) ) ) ) ).

% Re_complex_div_gt_0
thf(fact_3660_Re__complex__div__ge__0,axiom,
    ! [A2: complex,B2: complex] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( re @ ( divide_divide @ complex @ A2 @ B2 ) ) )
      = ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( re @ ( times_times @ complex @ A2 @ ( cnj @ B2 ) ) ) ) ) ).

% Re_complex_div_ge_0
thf(fact_3661_Re__complex__div__le__0,axiom,
    ! [A2: complex,B2: complex] :
      ( ( ord_less_eq @ real @ ( re @ ( divide_divide @ complex @ A2 @ B2 ) ) @ ( zero_zero @ real ) )
      = ( ord_less_eq @ real @ ( re @ ( times_times @ complex @ A2 @ ( cnj @ B2 ) ) ) @ ( zero_zero @ real ) ) ) ).

% Re_complex_div_le_0
thf(fact_3662_Im__complex__div__lt__0,axiom,
    ! [A2: complex,B2: complex] :
      ( ( ord_less @ real @ ( im @ ( divide_divide @ complex @ A2 @ B2 ) ) @ ( zero_zero @ real ) )
      = ( ord_less @ real @ ( im @ ( times_times @ complex @ A2 @ ( cnj @ B2 ) ) ) @ ( zero_zero @ real ) ) ) ).

% Im_complex_div_lt_0
thf(fact_3663_Im__complex__div__gt__0,axiom,
    ! [A2: complex,B2: complex] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ ( im @ ( divide_divide @ complex @ A2 @ B2 ) ) )
      = ( ord_less @ real @ ( zero_zero @ real ) @ ( im @ ( times_times @ complex @ A2 @ ( cnj @ B2 ) ) ) ) ) ).

% Im_complex_div_gt_0
thf(fact_3664_Im__complex__div__ge__0,axiom,
    ! [A2: complex,B2: complex] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( im @ ( divide_divide @ complex @ A2 @ B2 ) ) )
      = ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( im @ ( times_times @ complex @ A2 @ ( cnj @ B2 ) ) ) ) ) ).

% Im_complex_div_ge_0
thf(fact_3665_Im__complex__div__le__0,axiom,
    ! [A2: complex,B2: complex] :
      ( ( ord_less_eq @ real @ ( im @ ( divide_divide @ complex @ A2 @ B2 ) ) @ ( zero_zero @ real ) )
      = ( ord_less_eq @ real @ ( im @ ( times_times @ complex @ A2 @ ( cnj @ B2 ) ) ) @ ( zero_zero @ real ) ) ) ).

% Im_complex_div_le_0
thf(fact_3666_complex__mod__mult__cnj,axiom,
    ! [Z: complex] :
      ( ( real_V7770717601297561774m_norm @ complex @ ( times_times @ complex @ Z @ ( cnj @ Z ) ) )
      = ( power_power @ real @ ( real_V7770717601297561774m_norm @ complex @ Z ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ).

% complex_mod_mult_cnj
thf(fact_3667_complex__div__gt__0,axiom,
    ! [A2: complex,B2: complex] :
      ( ( ( ord_less @ real @ ( zero_zero @ real ) @ ( re @ ( divide_divide @ complex @ A2 @ B2 ) ) )
        = ( ord_less @ real @ ( zero_zero @ real ) @ ( re @ ( times_times @ complex @ A2 @ ( cnj @ B2 ) ) ) ) )
      & ( ( ord_less @ real @ ( zero_zero @ real ) @ ( im @ ( divide_divide @ complex @ A2 @ B2 ) ) )
        = ( ord_less @ real @ ( zero_zero @ real ) @ ( im @ ( times_times @ complex @ A2 @ ( cnj @ B2 ) ) ) ) ) ) ).

% complex_div_gt_0
thf(fact_3668_complex__norm__square,axiom,
    ! [Z: complex] :
      ( ( real_Vector_of_real @ complex @ ( power_power @ real @ ( real_V7770717601297561774m_norm @ complex @ Z ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
      = ( times_times @ complex @ Z @ ( cnj @ Z ) ) ) ).

% complex_norm_square
thf(fact_3669_complex__add__cnj,axiom,
    ! [Z: complex] :
      ( ( plus_plus @ complex @ Z @ ( cnj @ Z ) )
      = ( real_Vector_of_real @ complex @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( re @ Z ) ) ) ) ).

% complex_add_cnj
thf(fact_3670_complex__diff__cnj,axiom,
    ! [Z: complex] :
      ( ( minus_minus @ complex @ Z @ ( cnj @ Z ) )
      = ( times_times @ complex @ ( real_Vector_of_real @ complex @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ ( im @ Z ) ) ) @ imaginary_unit ) ) ).

% complex_diff_cnj
thf(fact_3671_complex__div__cnj,axiom,
    ( ( divide_divide @ complex )
    = ( ^ [A3: complex,B3: complex] : ( divide_divide @ complex @ ( times_times @ complex @ A3 @ ( cnj @ B3 ) ) @ ( real_Vector_of_real @ complex @ ( power_power @ real @ ( real_V7770717601297561774m_norm @ complex @ B3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% complex_div_cnj
thf(fact_3672_sinh__def,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ( ( sinh @ A )
        = ( ^ [X2: A] : ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( minus_minus @ A @ ( exp @ A @ X2 ) @ ( exp @ A @ ( uminus_uminus @ A @ X2 ) ) ) ) ) ) ) ).

% sinh_def
thf(fact_3673_cosh__def,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ( ( cosh @ A )
        = ( ^ [X2: A] : ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( plus_plus @ A @ ( exp @ A @ X2 ) @ ( exp @ A @ ( uminus_uminus @ A @ X2 ) ) ) ) ) ) ) ).

% cosh_def
thf(fact_3674_or__minus__numerals_I8_J,axiom,
    ! [N: num,M: num] :
      ( ( bit_se1065995026697491101ons_or @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit1 @ N ) ) ) @ ( numeral_numeral @ int @ M ) )
      = ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit_or_not_num_neg @ M @ ( bit0 @ N ) ) ) ) ) ).

% or_minus_numerals(8)
thf(fact_3675_or__minus__numerals_I4_J,axiom,
    ! [M: num,N: num] :
      ( ( bit_se1065995026697491101ons_or @ int @ ( numeral_numeral @ int @ M ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit1 @ N ) ) ) )
      = ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit_or_not_num_neg @ M @ ( bit0 @ N ) ) ) ) ) ).

% or_minus_numerals(4)
thf(fact_3676_scaleR__cancel__right,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [A2: real,X: A,B2: real] :
          ( ( ( real_V8093663219630862766scaleR @ A @ A2 @ X )
            = ( real_V8093663219630862766scaleR @ A @ B2 @ X ) )
          = ( ( A2 = B2 )
            | ( X
              = ( zero_zero @ A ) ) ) ) ) ).

% scaleR_cancel_right
thf(fact_3677_scaleR__zero__right,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [A2: real] :
          ( ( real_V8093663219630862766scaleR @ A @ A2 @ ( zero_zero @ A ) )
          = ( zero_zero @ A ) ) ) ).

% scaleR_zero_right
thf(fact_3678_scaleR__cancel__left,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [A2: real,X: A,Y: A] :
          ( ( ( real_V8093663219630862766scaleR @ A @ A2 @ X )
            = ( real_V8093663219630862766scaleR @ A @ A2 @ Y ) )
          = ( ( X = Y )
            | ( A2
              = ( zero_zero @ real ) ) ) ) ) ).

% scaleR_cancel_left
thf(fact_3679_scaleR__zero__left,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [X: A] :
          ( ( real_V8093663219630862766scaleR @ A @ ( zero_zero @ real ) @ X )
          = ( zero_zero @ A ) ) ) ).

% scaleR_zero_left
thf(fact_3680_scaleR__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [A2: real,X: A] :
          ( ( ( real_V8093663219630862766scaleR @ A @ A2 @ X )
            = ( zero_zero @ A ) )
          = ( ( A2
              = ( zero_zero @ real ) )
            | ( X
              = ( zero_zero @ A ) ) ) ) ) ).

% scaleR_eq_0_iff
thf(fact_3681_scaleR__power,axiom,
    ! [A: $tType] :
      ( ( real_V2822296259951069270ebra_1 @ A )
     => ! [X: real,Y: A,N: nat] :
          ( ( power_power @ A @ ( real_V8093663219630862766scaleR @ A @ X @ Y ) @ N )
          = ( real_V8093663219630862766scaleR @ A @ ( power_power @ real @ X @ N ) @ ( power_power @ A @ Y @ N ) ) ) ) ).

% scaleR_power
thf(fact_3682_scaleR__times,axiom,
    ! [A: $tType] :
      ( ( real_V2191834092415804123ebra_1 @ A )
     => ! [U: num,W: num,A2: A] :
          ( ( real_V8093663219630862766scaleR @ A @ ( numeral_numeral @ real @ U ) @ ( times_times @ A @ ( numeral_numeral @ A @ W ) @ A2 ) )
          = ( real_V8093663219630862766scaleR @ A @ ( times_times @ real @ ( numeral_numeral @ real @ U ) @ ( numeral_numeral @ real @ W ) ) @ A2 ) ) ) ).

% scaleR_times
thf(fact_3683_inverse__scaleR__times,axiom,
    ! [A: $tType] :
      ( ( real_V2191834092415804123ebra_1 @ A )
     => ! [V: num,W: num,A2: A] :
          ( ( real_V8093663219630862766scaleR @ A @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ V ) ) @ ( times_times @ A @ ( numeral_numeral @ A @ W ) @ A2 ) )
          = ( real_V8093663219630862766scaleR @ A @ ( divide_divide @ real @ ( numeral_numeral @ real @ W ) @ ( numeral_numeral @ real @ V ) ) @ A2 ) ) ) ).

% inverse_scaleR_times
thf(fact_3684_fraction__scaleR__times,axiom,
    ! [A: $tType] :
      ( ( real_V2191834092415804123ebra_1 @ A )
     => ! [U: num,V: num,W: num,A2: A] :
          ( ( real_V8093663219630862766scaleR @ A @ ( divide_divide @ real @ ( numeral_numeral @ real @ U ) @ ( numeral_numeral @ real @ V ) ) @ ( times_times @ A @ ( numeral_numeral @ A @ W ) @ A2 ) )
          = ( real_V8093663219630862766scaleR @ A @ ( divide_divide @ real @ ( times_times @ real @ ( numeral_numeral @ real @ U ) @ ( numeral_numeral @ real @ W ) ) @ ( numeral_numeral @ real @ V ) ) @ A2 ) ) ) ).

% fraction_scaleR_times
thf(fact_3685_scaleR__half__double,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [A2: A] :
          ( ( real_V8093663219630862766scaleR @ A @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( plus_plus @ A @ A2 @ A2 ) )
          = A2 ) ) ).

% scaleR_half_double
thf(fact_3686_scaleR__right__imp__eq,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [X: A,A2: real,B2: real] :
          ( ( X
           != ( zero_zero @ A ) )
         => ( ( ( real_V8093663219630862766scaleR @ A @ A2 @ X )
              = ( real_V8093663219630862766scaleR @ A @ B2 @ X ) )
           => ( A2 = B2 ) ) ) ) ).

% scaleR_right_imp_eq
thf(fact_3687_scaleR__left__imp__eq,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [A2: real,X: A,Y: A] :
          ( ( A2
           != ( zero_zero @ real ) )
         => ( ( ( real_V8093663219630862766scaleR @ A @ A2 @ X )
              = ( real_V8093663219630862766scaleR @ A @ A2 @ Y ) )
           => ( X = Y ) ) ) ) ).

% scaleR_left_imp_eq
thf(fact_3688_or__not__num__neg_Osimps_I1_J,axiom,
    ( ( bit_or_not_num_neg @ one2 @ one2 )
    = one2 ) ).

% or_not_num_neg.simps(1)
thf(fact_3689_or__not__num__neg_Osimps_I4_J,axiom,
    ! [N: num] :
      ( ( bit_or_not_num_neg @ ( bit0 @ N ) @ one2 )
      = ( bit0 @ one2 ) ) ).

% or_not_num_neg.simps(4)
thf(fact_3690_or__not__num__neg_Osimps_I6_J,axiom,
    ! [N: num,M: num] :
      ( ( bit_or_not_num_neg @ ( bit0 @ N ) @ ( bit1 @ M ) )
      = ( bit0 @ ( bit_or_not_num_neg @ N @ M ) ) ) ).

% or_not_num_neg.simps(6)
thf(fact_3691_or__not__num__neg_Osimps_I7_J,axiom,
    ! [N: num] :
      ( ( bit_or_not_num_neg @ ( bit1 @ N ) @ one2 )
      = one2 ) ).

% or_not_num_neg.simps(7)
thf(fact_3692_or__not__num__neg_Osimps_I3_J,axiom,
    ! [M: num] :
      ( ( bit_or_not_num_neg @ one2 @ ( bit1 @ M ) )
      = ( bit1 @ M ) ) ).

% or_not_num_neg.simps(3)
thf(fact_3693_scaleR__right__mono__neg,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [B2: real,A2: real,C2: A] :
          ( ( ord_less_eq @ real @ B2 @ A2 )
         => ( ( ord_less_eq @ A @ C2 @ ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ A2 @ C2 ) @ ( real_V8093663219630862766scaleR @ A @ B2 @ C2 ) ) ) ) ) ).

% scaleR_right_mono_neg
thf(fact_3694_scaleR__right__mono,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [A2: real,B2: real,X: A] :
          ( ( ord_less_eq @ real @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X )
           => ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ A2 @ X ) @ ( real_V8093663219630862766scaleR @ A @ B2 @ X ) ) ) ) ) ).

% scaleR_right_mono
thf(fact_3695_scaleR__le__cancel__left__pos,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,A2: A,B2: A] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ C2 )
         => ( ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ C2 @ A2 ) @ ( real_V8093663219630862766scaleR @ A @ C2 @ B2 ) )
            = ( ord_less_eq @ A @ A2 @ B2 ) ) ) ) ).

% scaleR_le_cancel_left_pos
thf(fact_3696_scaleR__le__cancel__left__neg,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,A2: A,B2: A] :
          ( ( ord_less @ real @ C2 @ ( zero_zero @ real ) )
         => ( ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ C2 @ A2 ) @ ( real_V8093663219630862766scaleR @ A @ C2 @ B2 ) )
            = ( ord_less_eq @ A @ B2 @ A2 ) ) ) ) ).

% scaleR_le_cancel_left_neg
thf(fact_3697_scaleR__le__cancel__left,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,A2: A,B2: A] :
          ( ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ C2 @ A2 ) @ ( real_V8093663219630862766scaleR @ A @ C2 @ B2 ) )
          = ( ( ( ord_less @ real @ ( zero_zero @ real ) @ C2 )
             => ( ord_less_eq @ A @ A2 @ B2 ) )
            & ( ( ord_less @ real @ C2 @ ( zero_zero @ real ) )
             => ( ord_less_eq @ A @ B2 @ A2 ) ) ) ) ) ).

% scaleR_le_cancel_left
thf(fact_3698_scaleR__left__mono__neg,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [B2: A,A2: A,C2: real] :
          ( ( ord_less_eq @ A @ B2 @ A2 )
         => ( ( ord_less_eq @ real @ C2 @ ( zero_zero @ real ) )
           => ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ C2 @ A2 ) @ ( real_V8093663219630862766scaleR @ A @ C2 @ B2 ) ) ) ) ) ).

% scaleR_left_mono_neg
thf(fact_3699_scaleR__left__mono,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [X: A,Y: A,A2: real] :
          ( ( ord_less_eq @ A @ X @ Y )
         => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ A2 )
           => ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ A2 @ X ) @ ( real_V8093663219630862766scaleR @ A @ A2 @ Y ) ) ) ) ) ).

% scaleR_left_mono
thf(fact_3700_eq__vector__fraction__iff,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [X: A,U: real,V: real,A2: A] :
          ( ( X
            = ( real_V8093663219630862766scaleR @ A @ ( divide_divide @ real @ U @ V ) @ A2 ) )
          = ( ( ( V
                = ( zero_zero @ real ) )
             => ( X
                = ( zero_zero @ A ) ) )
            & ( ( V
               != ( zero_zero @ real ) )
             => ( ( real_V8093663219630862766scaleR @ A @ V @ X )
                = ( real_V8093663219630862766scaleR @ A @ U @ A2 ) ) ) ) ) ) ).

% eq_vector_fraction_iff
thf(fact_3701_vector__fraction__eq__iff,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [U: real,V: real,A2: A,X: A] :
          ( ( ( real_V8093663219630862766scaleR @ A @ ( divide_divide @ real @ U @ V ) @ A2 )
            = X )
          = ( ( ( V
                = ( zero_zero @ real ) )
             => ( X
                = ( zero_zero @ A ) ) )
            & ( ( V
               != ( zero_zero @ real ) )
             => ( ( real_V8093663219630862766scaleR @ A @ U @ A2 )
                = ( real_V8093663219630862766scaleR @ A @ V @ X ) ) ) ) ) ) ).

% vector_fraction_eq_iff
thf(fact_3702_Real__Vector__Spaces_Ole__add__iff1,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [A2: real,E2: A,C2: A,B2: real,D2: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ ( real_V8093663219630862766scaleR @ A @ A2 @ E2 ) @ C2 ) @ ( plus_plus @ A @ ( real_V8093663219630862766scaleR @ A @ B2 @ E2 ) @ D2 ) )
          = ( ord_less_eq @ A @ ( plus_plus @ A @ ( real_V8093663219630862766scaleR @ A @ ( minus_minus @ real @ A2 @ B2 ) @ E2 ) @ C2 ) @ D2 ) ) ) ).

% Real_Vector_Spaces.le_add_iff1
thf(fact_3703_Real__Vector__Spaces_Ole__add__iff2,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [A2: real,E2: A,C2: A,B2: real,D2: A] :
          ( ( ord_less_eq @ A @ ( plus_plus @ A @ ( real_V8093663219630862766scaleR @ A @ A2 @ E2 ) @ C2 ) @ ( plus_plus @ A @ ( real_V8093663219630862766scaleR @ A @ B2 @ E2 ) @ D2 ) )
          = ( ord_less_eq @ A @ C2 @ ( plus_plus @ A @ ( real_V8093663219630862766scaleR @ A @ ( minus_minus @ real @ B2 @ A2 ) @ E2 ) @ D2 ) ) ) ) ).

% Real_Vector_Spaces.le_add_iff2
thf(fact_3704_or__not__num__neg_Osimps_I2_J,axiom,
    ! [M: num] :
      ( ( bit_or_not_num_neg @ one2 @ ( bit0 @ M ) )
      = ( bit1 @ M ) ) ).

% or_not_num_neg.simps(2)
thf(fact_3705_zero__le__scaleR__iff,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [A2: real,B2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( real_V8093663219630862766scaleR @ A @ A2 @ B2 ) )
          = ( ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
              & ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 ) )
            | ( ( ord_less @ real @ A2 @ ( zero_zero @ real ) )
              & ( ord_less_eq @ A @ B2 @ ( zero_zero @ A ) ) )
            | ( A2
              = ( zero_zero @ real ) ) ) ) ) ).

% zero_le_scaleR_iff
thf(fact_3706_scaleR__le__0__iff,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [A2: real,B2: A] :
          ( ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ A2 @ B2 ) @ ( zero_zero @ A ) )
          = ( ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
              & ( ord_less_eq @ A @ B2 @ ( zero_zero @ A ) ) )
            | ( ( ord_less @ real @ A2 @ ( zero_zero @ real ) )
              & ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 ) )
            | ( A2
              = ( zero_zero @ real ) ) ) ) ) ).

% scaleR_le_0_iff
thf(fact_3707_scaleR__nonpos__nonpos,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [A2: real,B2: A] :
          ( ( ord_less_eq @ real @ A2 @ ( zero_zero @ real ) )
         => ( ( ord_less_eq @ A @ B2 @ ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( real_V8093663219630862766scaleR @ A @ A2 @ B2 ) ) ) ) ) ).

% scaleR_nonpos_nonpos
thf(fact_3708_scaleR__nonpos__nonneg,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [A2: real,X: A] :
          ( ( ord_less_eq @ real @ A2 @ ( zero_zero @ real ) )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X )
           => ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ A2 @ X ) @ ( zero_zero @ A ) ) ) ) ) ).

% scaleR_nonpos_nonneg
thf(fact_3709_scaleR__nonneg__nonpos,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [A2: real,X: A] :
          ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ A2 )
         => ( ( ord_less_eq @ A @ X @ ( zero_zero @ A ) )
           => ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ A2 @ X ) @ ( zero_zero @ A ) ) ) ) ) ).

% scaleR_nonneg_nonpos
thf(fact_3710_scaleR__nonneg__nonneg,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [A2: real,X: A] :
          ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ A2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X )
           => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( real_V8093663219630862766scaleR @ A @ A2 @ X ) ) ) ) ) ).

% scaleR_nonneg_nonneg
thf(fact_3711_split__scaleR__pos__le,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [A2: real,B2: A] :
          ( ( ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ A2 )
              & ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 ) )
            | ( ( ord_less_eq @ real @ A2 @ ( zero_zero @ real ) )
              & ( ord_less_eq @ A @ B2 @ ( zero_zero @ A ) ) ) )
         => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( real_V8093663219630862766scaleR @ A @ A2 @ B2 ) ) ) ) ).

% split_scaleR_pos_le
thf(fact_3712_split__scaleR__neg__le,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [A2: real,X: A] :
          ( ( ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ A2 )
              & ( ord_less_eq @ A @ X @ ( zero_zero @ A ) ) )
            | ( ( ord_less_eq @ real @ A2 @ ( zero_zero @ real ) )
              & ( ord_less_eq @ A @ ( zero_zero @ A ) @ X ) ) )
         => ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ A2 @ X ) @ ( zero_zero @ A ) ) ) ) ).

% split_scaleR_neg_le
thf(fact_3713_scaleR__mono_H,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [A2: real,B2: real,C2: A,D2: A] :
          ( ( ord_less_eq @ real @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ C2 @ D2 )
           => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ A2 )
             => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ C2 )
               => ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ A2 @ C2 ) @ ( real_V8093663219630862766scaleR @ A @ B2 @ D2 ) ) ) ) ) ) ) ).

% scaleR_mono'
thf(fact_3714_scaleR__mono,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [A2: real,B2: real,X: A,Y: A] :
          ( ( ord_less_eq @ real @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ X @ Y )
           => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ B2 )
             => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X )
               => ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ A2 @ X ) @ ( real_V8093663219630862766scaleR @ A @ B2 @ Y ) ) ) ) ) ) ) ).

% scaleR_mono
thf(fact_3715_scaleR__left__le__one__le,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [X: A,A2: real] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X )
         => ( ( ord_less_eq @ real @ A2 @ ( one_one @ real ) )
           => ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ A2 @ X ) @ X ) ) ) ) ).

% scaleR_left_le_one_le
thf(fact_3716_scaleR__2,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [X: A] :
          ( ( real_V8093663219630862766scaleR @ A @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ X )
          = ( plus_plus @ A @ X @ X ) ) ) ).

% scaleR_2
thf(fact_3717_real__vector__eq__affinity,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [M: real,Y: A,X: A,C2: A] :
          ( ( M
           != ( zero_zero @ real ) )
         => ( ( Y
              = ( plus_plus @ A @ ( real_V8093663219630862766scaleR @ A @ M @ X ) @ C2 ) )
            = ( ( minus_minus @ A @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ M ) @ Y ) @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ M ) @ C2 ) )
              = X ) ) ) ) ).

% real_vector_eq_affinity
thf(fact_3718_real__vector__affinity__eq,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [M: real,X: A,C2: A,Y: A] :
          ( ( M
           != ( zero_zero @ real ) )
         => ( ( ( plus_plus @ A @ ( real_V8093663219630862766scaleR @ A @ M @ X ) @ C2 )
              = Y )
            = ( X
              = ( minus_minus @ A @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ M ) @ Y ) @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ M ) @ C2 ) ) ) ) ) ) ).

% real_vector_affinity_eq
thf(fact_3719_pos__divideR__le__eq,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,B2: A,A2: A] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ C2 )
         => ( ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ C2 ) @ B2 ) @ A2 )
            = ( ord_less_eq @ A @ B2 @ ( real_V8093663219630862766scaleR @ A @ C2 @ A2 ) ) ) ) ) ).

% pos_divideR_le_eq
thf(fact_3720_pos__le__divideR__eq,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,A2: A,B2: A] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ C2 )
         => ( ( ord_less_eq @ A @ A2 @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ C2 ) @ B2 ) )
            = ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ C2 @ A2 ) @ B2 ) ) ) ) ).

% pos_le_divideR_eq
thf(fact_3721_neg__divideR__le__eq,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,B2: A,A2: A] :
          ( ( ord_less @ real @ C2 @ ( zero_zero @ real ) )
         => ( ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ C2 ) @ B2 ) @ A2 )
            = ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ C2 @ A2 ) @ B2 ) ) ) ) ).

% neg_divideR_le_eq
thf(fact_3722_neg__le__divideR__eq,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,A2: A,B2: A] :
          ( ( ord_less @ real @ C2 @ ( zero_zero @ real ) )
         => ( ( ord_less_eq @ A @ A2 @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ C2 ) @ B2 ) )
            = ( ord_less_eq @ A @ B2 @ ( real_V8093663219630862766scaleR @ A @ C2 @ A2 ) ) ) ) ) ).

% neg_le_divideR_eq
thf(fact_3723_pos__divideR__less__eq,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,B2: A,A2: A] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ C2 )
         => ( ( ord_less @ A @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ C2 ) @ B2 ) @ A2 )
            = ( ord_less @ A @ B2 @ ( real_V8093663219630862766scaleR @ A @ C2 @ A2 ) ) ) ) ) ).

% pos_divideR_less_eq
thf(fact_3724_pos__less__divideR__eq,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,A2: A,B2: A] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ C2 )
         => ( ( ord_less @ A @ A2 @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ C2 ) @ B2 ) )
            = ( ord_less @ A @ ( real_V8093663219630862766scaleR @ A @ C2 @ A2 ) @ B2 ) ) ) ) ).

% pos_less_divideR_eq
thf(fact_3725_neg__divideR__less__eq,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,B2: A,A2: A] :
          ( ( ord_less @ real @ C2 @ ( zero_zero @ real ) )
         => ( ( ord_less @ A @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ C2 ) @ B2 ) @ A2 )
            = ( ord_less @ A @ ( real_V8093663219630862766scaleR @ A @ C2 @ A2 ) @ B2 ) ) ) ) ).

% neg_divideR_less_eq
thf(fact_3726_neg__less__divideR__eq,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,A2: A,B2: A] :
          ( ( ord_less @ real @ C2 @ ( zero_zero @ real ) )
         => ( ( ord_less @ A @ A2 @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ C2 ) @ B2 ) )
            = ( ord_less @ A @ B2 @ ( real_V8093663219630862766scaleR @ A @ C2 @ A2 ) ) ) ) ) ).

% neg_less_divideR_eq
thf(fact_3727_nonzero__inverse__scaleR__distrib,axiom,
    ! [A: $tType] :
      ( ( real_V5047593784448816457lgebra @ A )
     => ! [A2: real,X: A] :
          ( ( A2
           != ( zero_zero @ real ) )
         => ( ( X
             != ( zero_zero @ A ) )
           => ( ( inverse_inverse @ A @ ( real_V8093663219630862766scaleR @ A @ A2 @ X ) )
              = ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ A2 ) @ ( inverse_inverse @ A @ X ) ) ) ) ) ) ).

% nonzero_inverse_scaleR_distrib
thf(fact_3728_pos__le__minus__divideR__eq,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,A2: A,B2: A] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ C2 )
         => ( ( ord_less_eq @ A @ A2 @ ( uminus_uminus @ A @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ C2 ) @ B2 ) ) )
            = ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ C2 @ A2 ) @ ( uminus_uminus @ A @ B2 ) ) ) ) ) ).

% pos_le_minus_divideR_eq
thf(fact_3729_pos__minus__divideR__le__eq,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,B2: A,A2: A] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ C2 )
         => ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ C2 ) @ B2 ) ) @ A2 )
            = ( ord_less_eq @ A @ ( uminus_uminus @ A @ B2 ) @ ( real_V8093663219630862766scaleR @ A @ C2 @ A2 ) ) ) ) ) ).

% pos_minus_divideR_le_eq
thf(fact_3730_neg__le__minus__divideR__eq,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,A2: A,B2: A] :
          ( ( ord_less @ real @ C2 @ ( zero_zero @ real ) )
         => ( ( ord_less_eq @ A @ A2 @ ( uminus_uminus @ A @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ C2 ) @ B2 ) ) )
            = ( ord_less_eq @ A @ ( uminus_uminus @ A @ B2 ) @ ( real_V8093663219630862766scaleR @ A @ C2 @ A2 ) ) ) ) ) ).

% neg_le_minus_divideR_eq
thf(fact_3731_neg__minus__divideR__le__eq,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,B2: A,A2: A] :
          ( ( ord_less @ real @ C2 @ ( zero_zero @ real ) )
         => ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ C2 ) @ B2 ) ) @ A2 )
            = ( ord_less_eq @ A @ ( real_V8093663219630862766scaleR @ A @ C2 @ A2 ) @ ( uminus_uminus @ A @ B2 ) ) ) ) ) ).

% neg_minus_divideR_le_eq
thf(fact_3732_pos__less__minus__divideR__eq,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,A2: A,B2: A] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ C2 )
         => ( ( ord_less @ A @ A2 @ ( uminus_uminus @ A @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ C2 ) @ B2 ) ) )
            = ( ord_less @ A @ ( real_V8093663219630862766scaleR @ A @ C2 @ A2 ) @ ( uminus_uminus @ A @ B2 ) ) ) ) ) ).

% pos_less_minus_divideR_eq
thf(fact_3733_pos__minus__divideR__less__eq,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,B2: A,A2: A] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ C2 )
         => ( ( ord_less @ A @ ( uminus_uminus @ A @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ C2 ) @ B2 ) ) @ A2 )
            = ( ord_less @ A @ ( uminus_uminus @ A @ B2 ) @ ( real_V8093663219630862766scaleR @ A @ C2 @ A2 ) ) ) ) ) ).

% pos_minus_divideR_less_eq
thf(fact_3734_neg__less__minus__divideR__eq,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,A2: A,B2: A] :
          ( ( ord_less @ real @ C2 @ ( zero_zero @ real ) )
         => ( ( ord_less @ A @ A2 @ ( uminus_uminus @ A @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ C2 ) @ B2 ) ) )
            = ( ord_less @ A @ ( uminus_uminus @ A @ B2 ) @ ( real_V8093663219630862766scaleR @ A @ C2 @ A2 ) ) ) ) ) ).

% neg_less_minus_divideR_eq
thf(fact_3735_neg__minus__divideR__less__eq,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,B2: A,A2: A] :
          ( ( ord_less @ real @ C2 @ ( zero_zero @ real ) )
         => ( ( ord_less @ A @ ( uminus_uminus @ A @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ C2 ) @ B2 ) ) @ A2 )
            = ( ord_less @ A @ ( real_V8093663219630862766scaleR @ A @ C2 @ A2 ) @ ( uminus_uminus @ A @ B2 ) ) ) ) ) ).

% neg_minus_divideR_less_eq
thf(fact_3736_int__numeral__or__not__num__neg,axiom,
    ! [M: num,N: num] :
      ( ( bit_se1065995026697491101ons_or @ int @ ( numeral_numeral @ int @ M ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ N ) ) )
      = ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit_or_not_num_neg @ M @ N ) ) ) ) ).

% int_numeral_or_not_num_neg
thf(fact_3737_int__numeral__not__or__num__neg,axiom,
    ! [M: num,N: num] :
      ( ( bit_se1065995026697491101ons_or @ int @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ M ) ) @ ( numeral_numeral @ int @ N ) )
      = ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit_or_not_num_neg @ N @ M ) ) ) ) ).

% int_numeral_not_or_num_neg
thf(fact_3738_numeral__or__not__num__eq,axiom,
    ! [M: num,N: num] :
      ( ( numeral_numeral @ int @ ( bit_or_not_num_neg @ M @ N ) )
      = ( uminus_uminus @ int @ ( bit_se1065995026697491101ons_or @ int @ ( numeral_numeral @ int @ M ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ N ) ) ) ) ) ).

% numeral_or_not_num_eq
thf(fact_3739_or__minus__numerals_I5_J,axiom,
    ! [N: num] :
      ( ( bit_se1065995026697491101ons_or @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit0 @ N ) ) ) @ ( one_one @ int ) )
      = ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit_or_not_num_neg @ one2 @ ( bitM @ N ) ) ) ) ) ).

% or_minus_numerals(5)
thf(fact_3740_or__minus__numerals_I1_J,axiom,
    ! [N: num] :
      ( ( bit_se1065995026697491101ons_or @ int @ ( one_one @ int ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit0 @ N ) ) ) )
      = ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit_or_not_num_neg @ one2 @ ( bitM @ N ) ) ) ) ) ).

% or_minus_numerals(1)
thf(fact_3741_num_Osize_I6_J,axiom,
    ! [X32: num] :
      ( ( size_size @ num @ ( bit1 @ X32 ) )
      = ( plus_plus @ nat @ ( size_size @ num @ X32 ) @ ( suc @ ( zero_zero @ nat ) ) ) ) ).

% num.size(6)
thf(fact_3742_num_Osize_I5_J,axiom,
    ! [X22: num] :
      ( ( size_size @ num @ ( bit0 @ X22 ) )
      = ( plus_plus @ nat @ ( size_size @ num @ X22 ) @ ( suc @ ( zero_zero @ nat ) ) ) ) ).

% num.size(5)
thf(fact_3743_dbl__dec__simps_I5_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [K: num] :
          ( ( neg_numeral_dbl_dec @ A @ ( numeral_numeral @ A @ K ) )
          = ( numeral_numeral @ A @ ( bitM @ K ) ) ) ) ).

% dbl_dec_simps(5)
thf(fact_3744_pred__numeral__simps_I2_J,axiom,
    ! [K: num] :
      ( ( pred_numeral @ ( bit0 @ K ) )
      = ( numeral_numeral @ nat @ ( bitM @ K ) ) ) ).

% pred_numeral_simps(2)
thf(fact_3745_or__minus__numerals_I3_J,axiom,
    ! [M: num,N: num] :
      ( ( bit_se1065995026697491101ons_or @ int @ ( numeral_numeral @ int @ M ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit0 @ N ) ) ) )
      = ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit_or_not_num_neg @ M @ ( bitM @ N ) ) ) ) ) ).

% or_minus_numerals(3)
thf(fact_3746_or__minus__numerals_I7_J,axiom,
    ! [N: num,M: num] :
      ( ( bit_se1065995026697491101ons_or @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit0 @ N ) ) ) @ ( numeral_numeral @ int @ M ) )
      = ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit_or_not_num_neg @ M @ ( bitM @ N ) ) ) ) ) ).

% or_minus_numerals(7)
thf(fact_3747_semiring__norm_I26_J,axiom,
    ( ( bitM @ one2 )
    = one2 ) ).

% semiring_norm(26)
thf(fact_3748_size__neq__size__imp__neq,axiom,
    ! [A: $tType] :
      ( ( size @ A )
     => ! [X: A,Y: A] :
          ( ( ( size_size @ A @ X )
           != ( size_size @ A @ Y ) )
         => ( X != Y ) ) ) ).

% size_neq_size_imp_neq
thf(fact_3749_semiring__norm_I27_J,axiom,
    ! [N: num] :
      ( ( bitM @ ( bit0 @ N ) )
      = ( bit1 @ ( bitM @ N ) ) ) ).

% semiring_norm(27)
thf(fact_3750_semiring__norm_I28_J,axiom,
    ! [N: num] :
      ( ( bitM @ ( bit1 @ N ) )
      = ( bit1 @ ( bit0 @ N ) ) ) ).

% semiring_norm(28)
thf(fact_3751_or__not__num__neg_Osimps_I5_J,axiom,
    ! [N: num,M: num] :
      ( ( bit_or_not_num_neg @ ( bit0 @ N ) @ ( bit0 @ M ) )
      = ( bitM @ ( bit_or_not_num_neg @ N @ M ) ) ) ).

% or_not_num_neg.simps(5)
thf(fact_3752_inc__BitM__eq,axiom,
    ! [N: num] :
      ( ( inc @ ( bitM @ N ) )
      = ( bit0 @ N ) ) ).

% inc_BitM_eq
thf(fact_3753_or__not__num__neg_Osimps_I9_J,axiom,
    ! [N: num,M: num] :
      ( ( bit_or_not_num_neg @ ( bit1 @ N ) @ ( bit1 @ M ) )
      = ( bitM @ ( bit_or_not_num_neg @ N @ M ) ) ) ).

% or_not_num_neg.simps(9)
thf(fact_3754_BitM__inc__eq,axiom,
    ! [N: num] :
      ( ( bitM @ ( inc @ N ) )
      = ( bit1 @ N ) ) ).

% BitM_inc_eq
thf(fact_3755_eval__nat__numeral_I2_J,axiom,
    ! [N: num] :
      ( ( numeral_numeral @ nat @ ( bit0 @ N ) )
      = ( suc @ ( numeral_numeral @ nat @ ( bitM @ N ) ) ) ) ).

% eval_nat_numeral(2)
thf(fact_3756_one__plus__BitM,axiom,
    ! [N: num] :
      ( ( plus_plus @ num @ one2 @ ( bitM @ N ) )
      = ( bit0 @ N ) ) ).

% one_plus_BitM
thf(fact_3757_BitM__plus__one,axiom,
    ! [N: num] :
      ( ( plus_plus @ num @ ( bitM @ N ) @ one2 )
      = ( bit0 @ N ) ) ).

% BitM_plus_one
thf(fact_3758_or__not__num__neg_Osimps_I8_J,axiom,
    ! [N: num,M: num] :
      ( ( bit_or_not_num_neg @ ( bit1 @ N ) @ ( bit0 @ M ) )
      = ( bitM @ ( bit_or_not_num_neg @ N @ M ) ) ) ).

% or_not_num_neg.simps(8)
thf(fact_3759_num_Osize_I4_J,axiom,
    ( ( size_size @ num @ one2 )
    = ( zero_zero @ nat ) ) ).

% num.size(4)
thf(fact_3760_numeral__BitM,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [N: num] :
          ( ( numeral_numeral @ A @ ( bitM @ N ) )
          = ( minus_minus @ A @ ( numeral_numeral @ A @ ( bit0 @ N ) ) @ ( one_one @ A ) ) ) ) ).

% numeral_BitM
thf(fact_3761_odd__numeral__BitM,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [W: num] :
          ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( numeral_numeral @ A @ ( bitM @ W ) ) ) ) ).

% odd_numeral_BitM
thf(fact_3762_not__numeral__BitM__eq,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N: num] :
          ( ( bit_ri4277139882892585799ns_not @ A @ ( numeral_numeral @ A @ ( bitM @ N ) ) )
          = ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( bit0 @ N ) ) ) ) ) ).

% not_numeral_BitM_eq
thf(fact_3763_or__not__num__neg_Oelims,axiom,
    ! [X: num,Xa: num,Y: num] :
      ( ( ( bit_or_not_num_neg @ X @ Xa )
        = Y )
     => ( ( ( X = one2 )
         => ( ( Xa = one2 )
           => ( Y != one2 ) ) )
       => ( ( ( X = one2 )
           => ! [M4: num] :
                ( ( Xa
                  = ( bit0 @ M4 ) )
               => ( Y
                 != ( bit1 @ M4 ) ) ) )
         => ( ( ( X = one2 )
             => ! [M4: num] :
                  ( ( Xa
                    = ( bit1 @ M4 ) )
                 => ( Y
                   != ( bit1 @ M4 ) ) ) )
           => ( ( ? [N2: num] :
                    ( X
                    = ( bit0 @ N2 ) )
               => ( ( Xa = one2 )
                 => ( Y
                   != ( bit0 @ one2 ) ) ) )
             => ( ! [N2: num] :
                    ( ( X
                      = ( bit0 @ N2 ) )
                   => ! [M4: num] :
                        ( ( Xa
                          = ( bit0 @ M4 ) )
                       => ( Y
                         != ( bitM @ ( bit_or_not_num_neg @ N2 @ M4 ) ) ) ) )
               => ( ! [N2: num] :
                      ( ( X
                        = ( bit0 @ N2 ) )
                     => ! [M4: num] :
                          ( ( Xa
                            = ( bit1 @ M4 ) )
                         => ( Y
                           != ( bit0 @ ( bit_or_not_num_neg @ N2 @ M4 ) ) ) ) )
                 => ( ( ? [N2: num] :
                          ( X
                          = ( bit1 @ N2 ) )
                     => ( ( Xa = one2 )
                       => ( Y != one2 ) ) )
                   => ( ! [N2: num] :
                          ( ( X
                            = ( bit1 @ N2 ) )
                         => ! [M4: num] :
                              ( ( Xa
                                = ( bit0 @ M4 ) )
                             => ( Y
                               != ( bitM @ ( bit_or_not_num_neg @ N2 @ M4 ) ) ) ) )
                     => ~ ! [N2: num] :
                            ( ( X
                              = ( bit1 @ N2 ) )
                           => ! [M4: num] :
                                ( ( Xa
                                  = ( bit1 @ M4 ) )
                               => ( Y
                                 != ( bitM @ ( bit_or_not_num_neg @ N2 @ M4 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ).

% or_not_num_neg.elims
thf(fact_3764__C7_C,axiom,
    ( ( mi != ma )
   => ! [I3: nat] :
        ( ( ord_less @ nat @ I3 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ m ) )
       => ( ( ( ( vEBT_VEBT_high @ ma @ na )
              = I3 )
           => ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ treeList @ I3 ) @ ( vEBT_VEBT_low @ ma @ na ) ) )
          & ! [Y6: nat] :
              ( ( ( ( vEBT_VEBT_high @ Y6 @ na )
                  = I3 )
                & ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ treeList @ I3 ) @ ( vEBT_VEBT_low @ Y6 @ na ) ) )
             => ( ( ord_less @ nat @ mi @ Y6 )
                & ( ord_less_eq @ nat @ Y6 @ ma ) ) ) ) ) ) ).

% "7"
thf(fact_3765_drop__bit__numeral__minus__bit1,axiom,
    ! [L: num,K: num] :
      ( ( bit_se4197421643247451524op_bit @ int @ ( numeral_numeral @ nat @ L ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit1 @ K ) ) ) )
      = ( bit_se4197421643247451524op_bit @ int @ ( pred_numeral @ L ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( inc @ K ) ) ) ) ) ).

% drop_bit_numeral_minus_bit1
thf(fact_3766_drop__bit__rec,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se4197421643247451524op_bit @ A )
        = ( ^ [N3: nat,A3: A] :
              ( if @ A
              @ ( N3
                = ( zero_zero @ nat ) )
              @ A3
              @ ( bit_se4197421643247451524op_bit @ A @ ( minus_minus @ nat @ N3 @ ( one_one @ nat ) ) @ ( divide_divide @ A @ A3 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% drop_bit_rec
thf(fact_3767_root__powr__inverse,axiom,
    ! [N: nat,X: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
       => ( ( root @ N @ X )
          = ( powr @ real @ X @ ( divide_divide @ real @ ( one_one @ real ) @ ( semiring_1_of_nat @ real @ N ) ) ) ) ) ) ).

% root_powr_inverse
thf(fact_3768__C2_C,axiom,
    ( ( size_size @ ( list @ vEBT_VEBT ) @ treeList )
    = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ m ) ) ).

% "2"
thf(fact_3769_drop__bit__of__0,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat] :
          ( ( bit_se4197421643247451524op_bit @ A @ N @ ( zero_zero @ A ) )
          = ( zero_zero @ A ) ) ) ).

% drop_bit_of_0
thf(fact_3770_real__root__zero,axiom,
    ! [N: nat] :
      ( ( root @ N @ ( zero_zero @ real ) )
      = ( zero_zero @ real ) ) ).

% real_root_zero
thf(fact_3771_drop__bit__drop__bit,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M: nat,N: nat,A2: A] :
          ( ( bit_se4197421643247451524op_bit @ A @ M @ ( bit_se4197421643247451524op_bit @ A @ N @ A2 ) )
          = ( bit_se4197421643247451524op_bit @ A @ ( plus_plus @ nat @ M @ N ) @ A2 ) ) ) ).

% drop_bit_drop_bit
thf(fact_3772_drop__bit__and,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,A2: A,B2: A] :
          ( ( bit_se4197421643247451524op_bit @ A @ N @ ( bit_se5824344872417868541ns_and @ A @ A2 @ B2 ) )
          = ( bit_se5824344872417868541ns_and @ A @ ( bit_se4197421643247451524op_bit @ A @ N @ A2 ) @ ( bit_se4197421643247451524op_bit @ A @ N @ B2 ) ) ) ) ).

% drop_bit_and
thf(fact_3773_drop__bit__or,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,A2: A,B2: A] :
          ( ( bit_se4197421643247451524op_bit @ A @ N @ ( bit_se1065995026697491101ons_or @ A @ A2 @ B2 ) )
          = ( bit_se1065995026697491101ons_or @ A @ ( bit_se4197421643247451524op_bit @ A @ N @ A2 ) @ ( bit_se4197421643247451524op_bit @ A @ N @ B2 ) ) ) ) ).

% drop_bit_or
thf(fact_3774_drop__bit__xor,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,A2: A,B2: A] :
          ( ( bit_se4197421643247451524op_bit @ A @ N @ ( bit_se5824344971392196577ns_xor @ A @ A2 @ B2 ) )
          = ( bit_se5824344971392196577ns_xor @ A @ ( bit_se4197421643247451524op_bit @ A @ N @ A2 ) @ ( bit_se4197421643247451524op_bit @ A @ N @ B2 ) ) ) ) ).

% drop_bit_xor
thf(fact_3775_real__root__Suc__0,axiom,
    ! [X: real] :
      ( ( root @ ( suc @ ( zero_zero @ nat ) ) @ X )
      = X ) ).

% real_root_Suc_0
thf(fact_3776_root__0,axiom,
    ! [X: real] :
      ( ( root @ ( zero_zero @ nat ) @ X )
      = ( zero_zero @ real ) ) ).

% root_0
thf(fact_3777_real__root__eq__iff,axiom,
    ! [N: nat,X: real,Y: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ( root @ N @ X )
          = ( root @ N @ Y ) )
        = ( X = Y ) ) ) ).

% real_root_eq_iff
thf(fact_3778_drop__bit__of__bool,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,B2: $o] :
          ( ( bit_se4197421643247451524op_bit @ A @ N @ ( zero_neq_one_of_bool @ A @ B2 ) )
          = ( zero_neq_one_of_bool @ A
            @ ( ( N
                = ( zero_zero @ nat ) )
              & B2 ) ) ) ) ).

% drop_bit_of_bool
thf(fact_3779_drop__bit__of__Suc__0,axiom,
    ! [N: nat] :
      ( ( bit_se4197421643247451524op_bit @ nat @ N @ ( suc @ ( zero_zero @ nat ) ) )
      = ( zero_neq_one_of_bool @ nat
        @ ( N
          = ( zero_zero @ nat ) ) ) ) ).

% drop_bit_of_Suc_0
thf(fact_3780_drop__bit__nonnegative__int__iff,axiom,
    ! [N: nat,K: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( bit_se4197421643247451524op_bit @ int @ N @ K ) )
      = ( ord_less_eq @ int @ ( zero_zero @ int ) @ K ) ) ).

% drop_bit_nonnegative_int_iff
thf(fact_3781_drop__bit__negative__int__iff,axiom,
    ! [N: nat,K: int] :
      ( ( ord_less @ int @ ( bit_se4197421643247451524op_bit @ int @ N @ K ) @ ( zero_zero @ int ) )
      = ( ord_less @ int @ K @ ( zero_zero @ int ) ) ) ).

% drop_bit_negative_int_iff
thf(fact_3782_drop__bit__minus__one,axiom,
    ! [N: nat] :
      ( ( bit_se4197421643247451524op_bit @ int @ N @ ( uminus_uminus @ int @ ( one_one @ int ) ) )
      = ( uminus_uminus @ int @ ( one_one @ int ) ) ) ).

% drop_bit_minus_one
thf(fact_3783_drop__bit__Suc__bit0,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [N: nat,K: num] :
          ( ( bit_se4197421643247451524op_bit @ A @ ( suc @ N ) @ ( numeral_numeral @ A @ ( bit0 @ K ) ) )
          = ( bit_se4197421643247451524op_bit @ A @ N @ ( numeral_numeral @ A @ K ) ) ) ) ).

% drop_bit_Suc_bit0
thf(fact_3784_drop__bit__Suc__bit1,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [N: nat,K: num] :
          ( ( bit_se4197421643247451524op_bit @ A @ ( suc @ N ) @ ( numeral_numeral @ A @ ( bit1 @ K ) ) )
          = ( bit_se4197421643247451524op_bit @ A @ N @ ( numeral_numeral @ A @ K ) ) ) ) ).

% drop_bit_Suc_bit1
thf(fact_3785_real__root__eq__0__iff,axiom,
    ! [N: nat,X: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ( root @ N @ X )
          = ( zero_zero @ real ) )
        = ( X
          = ( zero_zero @ real ) ) ) ) ).

% real_root_eq_0_iff
thf(fact_3786_real__root__less__iff,axiom,
    ! [N: nat,X: real,Y: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less @ real @ ( root @ N @ X ) @ ( root @ N @ Y ) )
        = ( ord_less @ real @ X @ Y ) ) ) ).

% real_root_less_iff
thf(fact_3787_real__root__le__iff,axiom,
    ! [N: nat,X: real,Y: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less_eq @ real @ ( root @ N @ X ) @ ( root @ N @ Y ) )
        = ( ord_less_eq @ real @ X @ Y ) ) ) ).

% real_root_le_iff
thf(fact_3788_real__root__eq__1__iff,axiom,
    ! [N: nat,X: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ( root @ N @ X )
          = ( one_one @ real ) )
        = ( X
          = ( one_one @ real ) ) ) ) ).

% real_root_eq_1_iff
thf(fact_3789_real__root__one,axiom,
    ! [N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( root @ N @ ( one_one @ real ) )
        = ( one_one @ real ) ) ) ).

% real_root_one
thf(fact_3790_drop__bit__of__1,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat] :
          ( ( bit_se4197421643247451524op_bit @ A @ N @ ( one_one @ A ) )
          = ( zero_neq_one_of_bool @ A
            @ ( N
              = ( zero_zero @ nat ) ) ) ) ) ).

% drop_bit_of_1
thf(fact_3791_real__root__lt__0__iff,axiom,
    ! [N: nat,X: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less @ real @ ( root @ N @ X ) @ ( zero_zero @ real ) )
        = ( ord_less @ real @ X @ ( zero_zero @ real ) ) ) ) ).

% real_root_lt_0_iff
thf(fact_3792_real__root__gt__0__iff,axiom,
    ! [N: nat,Y: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ ( root @ N @ Y ) )
        = ( ord_less @ real @ ( zero_zero @ real ) @ Y ) ) ) ).

% real_root_gt_0_iff
thf(fact_3793_real__root__le__0__iff,axiom,
    ! [N: nat,X: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less_eq @ real @ ( root @ N @ X ) @ ( zero_zero @ real ) )
        = ( ord_less_eq @ real @ X @ ( zero_zero @ real ) ) ) ) ).

% real_root_le_0_iff
thf(fact_3794_real__root__ge__0__iff,axiom,
    ! [N: nat,Y: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( root @ N @ Y ) )
        = ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y ) ) ) ).

% real_root_ge_0_iff
thf(fact_3795_real__root__lt__1__iff,axiom,
    ! [N: nat,X: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less @ real @ ( root @ N @ X ) @ ( one_one @ real ) )
        = ( ord_less @ real @ X @ ( one_one @ real ) ) ) ) ).

% real_root_lt_1_iff
thf(fact_3796_real__root__gt__1__iff,axiom,
    ! [N: nat,Y: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less @ real @ ( one_one @ real ) @ ( root @ N @ Y ) )
        = ( ord_less @ real @ ( one_one @ real ) @ Y ) ) ) ).

% real_root_gt_1_iff
thf(fact_3797_real__root__le__1__iff,axiom,
    ! [N: nat,X: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less_eq @ real @ ( root @ N @ X ) @ ( one_one @ real ) )
        = ( ord_less_eq @ real @ X @ ( one_one @ real ) ) ) ) ).

% real_root_le_1_iff
thf(fact_3798_real__root__ge__1__iff,axiom,
    ! [N: nat,Y: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less_eq @ real @ ( one_one @ real ) @ ( root @ N @ Y ) )
        = ( ord_less_eq @ real @ ( one_one @ real ) @ Y ) ) ) ).

% real_root_ge_1_iff
thf(fact_3799_drop__bit__numeral__bit0,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [L: num,K: num] :
          ( ( bit_se4197421643247451524op_bit @ A @ ( numeral_numeral @ nat @ L ) @ ( numeral_numeral @ A @ ( bit0 @ K ) ) )
          = ( bit_se4197421643247451524op_bit @ A @ ( pred_numeral @ L ) @ ( numeral_numeral @ A @ K ) ) ) ) ).

% drop_bit_numeral_bit0
thf(fact_3800_drop__bit__numeral__bit1,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [L: num,K: num] :
          ( ( bit_se4197421643247451524op_bit @ A @ ( numeral_numeral @ nat @ L ) @ ( numeral_numeral @ A @ ( bit1 @ K ) ) )
          = ( bit_se4197421643247451524op_bit @ A @ ( pred_numeral @ L ) @ ( numeral_numeral @ A @ K ) ) ) ) ).

% drop_bit_numeral_bit1
thf(fact_3801_drop__bit__Suc__minus__bit0,axiom,
    ! [N: nat,K: num] :
      ( ( bit_se4197421643247451524op_bit @ int @ ( suc @ N ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit0 @ K ) ) ) )
      = ( bit_se4197421643247451524op_bit @ int @ N @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ K ) ) ) ) ).

% drop_bit_Suc_minus_bit0
thf(fact_3802__C4_C,axiom,
    ! [I3: nat] :
      ( ( ord_less @ nat @ I3 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ m ) )
     => ( ( ? [X8: nat] : ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ treeList @ I3 ) @ X8 ) )
        = ( vEBT_V8194947554948674370ptions @ summary @ I3 ) ) ) ).

% "4"
thf(fact_3803_real__root__pow__pos2,axiom,
    ! [N: nat,X: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
       => ( ( power_power @ real @ ( root @ N @ X ) @ N )
          = X ) ) ) ).

% real_root_pow_pos2
thf(fact_3804_drop__bit__numeral__minus__bit0,axiom,
    ! [L: num,K: num] :
      ( ( bit_se4197421643247451524op_bit @ int @ ( numeral_numeral @ nat @ L ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit0 @ K ) ) ) )
      = ( bit_se4197421643247451524op_bit @ int @ ( pred_numeral @ L ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ K ) ) ) ) ).

% drop_bit_numeral_minus_bit0
thf(fact_3805_drop__bit__Suc__minus__bit1,axiom,
    ! [N: nat,K: num] :
      ( ( bit_se4197421643247451524op_bit @ int @ ( suc @ N ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit1 @ K ) ) ) )
      = ( bit_se4197421643247451524op_bit @ int @ N @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( inc @ K ) ) ) ) ) ).

% drop_bit_Suc_minus_bit1
thf(fact_3806__C5_C,axiom,
    ( ( mi = ma )
   => ! [X5: vEBT_VEBT] :
        ( ( member @ vEBT_VEBT @ X5 @ ( set2 @ vEBT_VEBT @ treeList ) )
       => ~ ? [X_12: nat] : ( vEBT_V8194947554948674370ptions @ X5 @ X_12 ) ) ) ).

% "5"
thf(fact_3807_length__induct,axiom,
    ! [A: $tType,P: ( list @ A ) > $o,Xs: list @ A] :
      ( ! [Xs2: list @ A] :
          ( ! [Ys: list @ A] :
              ( ( ord_less @ nat @ ( size_size @ ( list @ A ) @ Ys ) @ ( size_size @ ( list @ A ) @ Xs2 ) )
             => ( P @ Ys ) )
         => ( P @ Xs2 ) )
     => ( P @ Xs ) ) ).

% length_induct
thf(fact_3808_list__eq__iff__nth__eq,axiom,
    ! [A: $tType] :
      ( ( ^ [Y3: list @ A,Z2: list @ A] : ( Y3 = Z2 ) )
      = ( ^ [Xs3: list @ A,Ys2: list @ A] :
            ( ( ( size_size @ ( list @ A ) @ Xs3 )
              = ( size_size @ ( list @ A ) @ Ys2 ) )
            & ! [I4: nat] :
                ( ( ord_less @ nat @ I4 @ ( size_size @ ( list @ A ) @ Xs3 ) )
               => ( ( nth @ A @ Xs3 @ I4 )
                  = ( nth @ A @ Ys2 @ I4 ) ) ) ) ) ) ).

% list_eq_iff_nth_eq
thf(fact_3809_Skolem__list__nth,axiom,
    ! [A: $tType,K: nat,P: nat > A > $o] :
      ( ( ! [I4: nat] :
            ( ( ord_less @ nat @ I4 @ K )
           => ? [X8: A] : ( P @ I4 @ X8 ) ) )
      = ( ? [Xs3: list @ A] :
            ( ( ( size_size @ ( list @ A ) @ Xs3 )
              = K )
            & ! [I4: nat] :
                ( ( ord_less @ nat @ I4 @ K )
               => ( P @ I4 @ ( nth @ A @ Xs3 @ I4 ) ) ) ) ) ) ).

% Skolem_list_nth
thf(fact_3810_nth__equalityI,axiom,
    ! [A: $tType,Xs: list @ A,Ys3: list @ A] :
      ( ( ( size_size @ ( list @ A ) @ Xs )
        = ( size_size @ ( list @ A ) @ Ys3 ) )
     => ( ! [I2: nat] :
            ( ( ord_less @ nat @ I2 @ ( size_size @ ( list @ A ) @ Xs ) )
           => ( ( nth @ A @ Xs @ I2 )
              = ( nth @ A @ Ys3 @ I2 ) ) )
       => ( Xs = Ys3 ) ) ) ).

% nth_equalityI
thf(fact_3811_real__root__mult__exp,axiom,
    ! [M: nat,N: nat,X: real] :
      ( ( root @ ( times_times @ nat @ M @ N ) @ X )
      = ( root @ M @ ( root @ N @ X ) ) ) ).

% real_root_mult_exp
thf(fact_3812_real__root__mult,axiom,
    ! [N: nat,X: real,Y: real] :
      ( ( root @ N @ ( times_times @ real @ X @ Y ) )
      = ( times_times @ real @ ( root @ N @ X ) @ ( root @ N @ Y ) ) ) ).

% real_root_mult
thf(fact_3813_real__root__commute,axiom,
    ! [M: nat,N: nat,X: real] :
      ( ( root @ M @ ( root @ N @ X ) )
      = ( root @ N @ ( root @ M @ X ) ) ) ).

% real_root_commute
thf(fact_3814_drop__bit__nat__eq,axiom,
    ! [N: nat,K: int] :
      ( ( bit_se4197421643247451524op_bit @ nat @ N @ ( nat2 @ K ) )
      = ( nat2 @ ( bit_se4197421643247451524op_bit @ int @ N @ K ) ) ) ).

% drop_bit_nat_eq
thf(fact_3815_real__root__inverse,axiom,
    ! [N: nat,X: real] :
      ( ( root @ N @ ( inverse_inverse @ real @ X ) )
      = ( inverse_inverse @ real @ ( root @ N @ X ) ) ) ).

% real_root_inverse
thf(fact_3816_real__root__minus,axiom,
    ! [N: nat,X: real] :
      ( ( root @ N @ ( uminus_uminus @ real @ X ) )
      = ( uminus_uminus @ real @ ( root @ N @ X ) ) ) ).

% real_root_minus
thf(fact_3817_real__root__divide,axiom,
    ! [N: nat,X: real,Y: real] :
      ( ( root @ N @ ( divide_divide @ real @ X @ Y ) )
      = ( divide_divide @ real @ ( root @ N @ X ) @ ( root @ N @ Y ) ) ) ).

% real_root_divide
thf(fact_3818_of__nat__drop__bit,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [M: nat,N: nat] :
          ( ( semiring_1_of_nat @ A @ ( bit_se4197421643247451524op_bit @ nat @ M @ N ) )
          = ( bit_se4197421643247451524op_bit @ A @ M @ ( semiring_1_of_nat @ A @ N ) ) ) ) ).

% of_nat_drop_bit
thf(fact_3819_drop__bit__of__nat,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [N: nat,M: nat] :
          ( ( bit_se4197421643247451524op_bit @ A @ N @ ( semiring_1_of_nat @ A @ M ) )
          = ( semiring_1_of_nat @ A @ ( bit_se4197421643247451524op_bit @ nat @ N @ M ) ) ) ) ).

% drop_bit_of_nat
thf(fact_3820_real__root__pos__pos__le,axiom,
    ! [X: real,N: nat] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( root @ N @ X ) ) ) ).

% real_root_pos_pos_le
thf(fact_3821_take__bit__eq__self__iff__drop__bit__eq__0,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,A2: A] :
          ( ( ( bit_se2584673776208193580ke_bit @ A @ N @ A2 )
            = A2 )
          = ( ( bit_se4197421643247451524op_bit @ A @ N @ A2 )
            = ( zero_zero @ A ) ) ) ) ).

% take_bit_eq_self_iff_drop_bit_eq_0
thf(fact_3822_drop__bit__push__bit__int,axiom,
    ! [M: nat,N: nat,K: int] :
      ( ( bit_se4197421643247451524op_bit @ int @ M @ ( bit_se4730199178511100633sh_bit @ int @ N @ K ) )
      = ( bit_se4197421643247451524op_bit @ int @ ( minus_minus @ nat @ M @ N ) @ ( bit_se4730199178511100633sh_bit @ int @ ( minus_minus @ nat @ N @ M ) @ K ) ) ) ).

% drop_bit_push_bit_int
thf(fact_3823_take__bit__drop__bit,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M: nat,N: nat,A2: A] :
          ( ( bit_se2584673776208193580ke_bit @ A @ M @ ( bit_se4197421643247451524op_bit @ A @ N @ A2 ) )
          = ( bit_se4197421643247451524op_bit @ A @ N @ ( bit_se2584673776208193580ke_bit @ A @ ( plus_plus @ nat @ M @ N ) @ A2 ) ) ) ) ).

% take_bit_drop_bit
thf(fact_3824_drop__bit__take__bit,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M: nat,N: nat,A2: A] :
          ( ( bit_se4197421643247451524op_bit @ A @ M @ ( bit_se2584673776208193580ke_bit @ A @ N @ A2 ) )
          = ( bit_se2584673776208193580ke_bit @ A @ ( minus_minus @ nat @ N @ M ) @ ( bit_se4197421643247451524op_bit @ A @ M @ A2 ) ) ) ) ).

% drop_bit_take_bit
thf(fact_3825_real__root__less__mono,axiom,
    ! [N: nat,X: real,Y: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less @ real @ X @ Y )
       => ( ord_less @ real @ ( root @ N @ X ) @ ( root @ N @ Y ) ) ) ) ).

% real_root_less_mono
thf(fact_3826_real__root__le__mono,axiom,
    ! [N: nat,X: real,Y: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less_eq @ real @ X @ Y )
       => ( ord_less_eq @ real @ ( root @ N @ X ) @ ( root @ N @ Y ) ) ) ) ).

% real_root_le_mono
thf(fact_3827_real__root__power,axiom,
    ! [N: nat,X: real,K: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( root @ N @ ( power_power @ real @ X @ K ) )
        = ( power_power @ real @ ( root @ N @ X ) @ K ) ) ) ).

% real_root_power
thf(fact_3828_real__root__abs,axiom,
    ! [N: nat,X: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( root @ N @ ( abs_abs @ real @ X ) )
        = ( abs_abs @ real @ ( root @ N @ X ) ) ) ) ).

% real_root_abs
thf(fact_3829_sgn__root,axiom,
    ! [N: nat,X: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( sgn_sgn @ real @ ( root @ N @ X ) )
        = ( sgn_sgn @ real @ X ) ) ) ).

% sgn_root
thf(fact_3830_div__push__bit__of__1__eq__drop__bit,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A,N: nat] :
          ( ( divide_divide @ A @ A2 @ ( bit_se4730199178511100633sh_bit @ A @ N @ ( one_one @ A ) ) )
          = ( bit_se4197421643247451524op_bit @ A @ N @ A2 ) ) ) ).

% div_push_bit_of_1_eq_drop_bit
thf(fact_3831_bit__iff__and__drop__bit__eq__1,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se5641148757651400278ts_bit @ A )
        = ( ^ [A3: A,N3: nat] :
              ( ( bit_se5824344872417868541ns_and @ A @ ( bit_se4197421643247451524op_bit @ A @ N3 @ A3 ) @ ( one_one @ A ) )
              = ( one_one @ A ) ) ) ) ) ).

% bit_iff_and_drop_bit_eq_1
thf(fact_3832_bits__ident,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,A2: A] :
          ( ( plus_plus @ A @ ( bit_se4730199178511100633sh_bit @ A @ N @ ( bit_se4197421643247451524op_bit @ A @ N @ A2 ) ) @ ( bit_se2584673776208193580ke_bit @ A @ N @ A2 ) )
          = A2 ) ) ).

% bits_ident
thf(fact_3833_real__root__gt__zero,axiom,
    ! [N: nat,X: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
       => ( ord_less @ real @ ( zero_zero @ real ) @ ( root @ N @ X ) ) ) ) ).

% real_root_gt_zero
thf(fact_3834_real__root__strict__decreasing,axiom,
    ! [N: nat,N4: nat,X: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less @ nat @ N @ N4 )
       => ( ( ord_less @ real @ ( one_one @ real ) @ X )
         => ( ord_less @ real @ ( root @ N4 @ X ) @ ( root @ N @ X ) ) ) ) ) ).

% real_root_strict_decreasing
thf(fact_3835_sqrt__def,axiom,
    ( sqrt
    = ( root @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ).

% sqrt_def
thf(fact_3836_root__abs__power,axiom,
    ! [N: nat,Y: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( abs_abs @ real @ ( root @ N @ ( power_power @ real @ Y @ N ) ) )
        = ( abs_abs @ real @ Y ) ) ) ).

% root_abs_power
thf(fact_3837_drop__bit__half,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,A2: A] :
          ( ( bit_se4197421643247451524op_bit @ A @ N @ ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) )
          = ( divide_divide @ A @ ( bit_se4197421643247451524op_bit @ A @ N @ A2 ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% drop_bit_half
thf(fact_3838_stable__imp__drop__bit__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A,N: nat] :
          ( ( ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
            = A2 )
         => ( ( bit_se4197421643247451524op_bit @ A @ N @ A2 )
            = A2 ) ) ) ).

% stable_imp_drop_bit_eq
thf(fact_3839_real__root__pos__pos,axiom,
    ! [N: nat,X: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
       => ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( root @ N @ X ) ) ) ) ).

% real_root_pos_pos
thf(fact_3840_real__root__strict__increasing,axiom,
    ! [N: nat,N4: nat,X: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less @ nat @ N @ N4 )
       => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
         => ( ( ord_less @ real @ X @ ( one_one @ real ) )
           => ( ord_less @ real @ ( root @ N @ X ) @ ( root @ N4 @ X ) ) ) ) ) ) ).

% real_root_strict_increasing
thf(fact_3841_real__root__decreasing,axiom,
    ! [N: nat,N4: nat,X: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less_eq @ nat @ N @ N4 )
       => ( ( ord_less_eq @ real @ ( one_one @ real ) @ X )
         => ( ord_less_eq @ real @ ( root @ N4 @ X ) @ ( root @ N @ X ) ) ) ) ) ).

% real_root_decreasing
thf(fact_3842_real__root__pow__pos,axiom,
    ! [N: nat,X: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
       => ( ( power_power @ real @ ( root @ N @ X ) @ N )
          = X ) ) ) ).

% real_root_pow_pos
thf(fact_3843_real__root__power__cancel,axiom,
    ! [N: nat,X: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
       => ( ( root @ N @ ( power_power @ real @ X @ N ) )
          = X ) ) ) ).

% real_root_power_cancel
thf(fact_3844_real__root__pos__unique,axiom,
    ! [N: nat,Y: real,X: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y )
       => ( ( ( power_power @ real @ Y @ N )
            = X )
         => ( ( root @ N @ X )
            = Y ) ) ) ) ).

% real_root_pos_unique
thf(fact_3845_odd__real__root__pow,axiom,
    ! [N: nat,X: real] :
      ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
     => ( ( power_power @ real @ ( root @ N @ X ) @ N )
        = X ) ) ).

% odd_real_root_pow
thf(fact_3846_odd__real__root__unique,axiom,
    ! [N: nat,Y: real,X: real] :
      ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
     => ( ( ( power_power @ real @ Y @ N )
          = X )
       => ( ( root @ N @ X )
          = Y ) ) ) ).

% odd_real_root_unique
thf(fact_3847_odd__real__root__power__cancel,axiom,
    ! [N: nat,X: real] :
      ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
     => ( ( root @ N @ ( power_power @ real @ X @ N ) )
        = X ) ) ).

% odd_real_root_power_cancel
thf(fact_3848_drop__bit__int__def,axiom,
    ( ( bit_se4197421643247451524op_bit @ int )
    = ( ^ [N3: nat,K3: int] : ( divide_divide @ int @ K3 @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N3 ) ) ) ) ).

% drop_bit_int_def
thf(fact_3849_drop__bit__nat__def,axiom,
    ( ( bit_se4197421643247451524op_bit @ nat )
    = ( ^ [N3: nat,M3: nat] : ( divide_divide @ nat @ M3 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N3 ) ) ) ) ).

% drop_bit_nat_def
thf(fact_3850_drop__bit__Suc,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,A2: A] :
          ( ( bit_se4197421643247451524op_bit @ A @ ( suc @ N ) @ A2 )
          = ( bit_se4197421643247451524op_bit @ A @ N @ ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ) ).

% drop_bit_Suc
thf(fact_3851_drop__bit__eq__div,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se4197421643247451524op_bit @ A )
        = ( ^ [N3: nat,A3: A] : ( divide_divide @ A @ A3 @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N3 ) ) ) ) ) ).

% drop_bit_eq_div
thf(fact_3852_bit__iff__odd__drop__bit,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se5641148757651400278ts_bit @ A )
        = ( ^ [A3: A,N3: nat] :
              ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se4197421643247451524op_bit @ A @ N3 @ A3 ) ) ) ) ) ).

% bit_iff_odd_drop_bit
thf(fact_3853_even__drop__bit__iff__not__bit,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,A2: A] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( bit_se4197421643247451524op_bit @ A @ N @ A2 ) )
          = ( ~ ( bit_se5641148757651400278ts_bit @ A @ A2 @ N ) ) ) ) ).

% even_drop_bit_iff_not_bit
thf(fact_3854_real__root__increasing,axiom,
    ! [N: nat,N4: nat,X: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less_eq @ nat @ N @ N4 )
       => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
         => ( ( ord_less_eq @ real @ X @ ( one_one @ real ) )
           => ( ord_less_eq @ real @ ( root @ N @ X ) @ ( root @ N4 @ X ) ) ) ) ) ) ).

% real_root_increasing
thf(fact_3855_root__sgn__power,axiom,
    ! [N: nat,Y: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( root @ N @ ( times_times @ real @ ( sgn_sgn @ real @ Y ) @ ( power_power @ real @ ( abs_abs @ real @ Y ) @ N ) ) )
        = Y ) ) ).

% root_sgn_power
thf(fact_3856_sgn__power__root,axiom,
    ! [N: nat,X: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( times_times @ real @ ( sgn_sgn @ real @ ( root @ N @ X ) ) @ ( power_power @ real @ ( abs_abs @ real @ ( root @ N @ X ) ) @ N ) )
        = X ) ) ).

% sgn_power_root
thf(fact_3857_ln__root,axiom,
    ! [N: nat,B2: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ B2 )
       => ( ( ln_ln @ real @ ( root @ N @ B2 ) )
          = ( divide_divide @ real @ ( ln_ln @ real @ B2 ) @ ( semiring_1_of_nat @ real @ N ) ) ) ) ) ).

% ln_root
thf(fact_3858_log__root,axiom,
    ! [N: nat,A2: real,B2: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
       => ( ( log2 @ B2 @ ( root @ N @ A2 ) )
          = ( divide_divide @ real @ ( log2 @ B2 @ A2 ) @ ( semiring_1_of_nat @ real @ N ) ) ) ) ) ).

% log_root
thf(fact_3859_log__base__root,axiom,
    ! [N: nat,B2: real,X: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ B2 )
       => ( ( log2 @ ( root @ N @ B2 ) @ X )
          = ( times_times @ real @ ( semiring_1_of_nat @ real @ N ) @ ( log2 @ B2 @ X ) ) ) ) ) ).

% log_base_root
thf(fact_3860_split__root,axiom,
    ! [P: real > $o,N: nat,X: real] :
      ( ( P @ ( root @ N @ X ) )
      = ( ( ( N
            = ( zero_zero @ nat ) )
         => ( P @ ( zero_zero @ real ) ) )
        & ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
         => ! [Y4: real] :
              ( ( ( times_times @ real @ ( sgn_sgn @ real @ Y4 ) @ ( power_power @ real @ ( abs_abs @ real @ Y4 ) @ N ) )
                = X )
             => ( P @ Y4 ) ) ) ) ) ).

% split_root
thf(fact_3861_slice__eq__mask,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N: nat,M: nat,A2: A] :
          ( ( bit_se4730199178511100633sh_bit @ A @ N @ ( bit_se2584673776208193580ke_bit @ A @ M @ ( bit_se4197421643247451524op_bit @ A @ N @ A2 ) ) )
          = ( bit_se5824344872417868541ns_and @ A @ A2 @ ( bit_se5824344872417868541ns_and @ A @ ( bit_se2239418461657761734s_mask @ A @ ( plus_plus @ nat @ M @ N ) ) @ ( bit_ri4277139882892585799ns_not @ A @ ( bit_se2239418461657761734s_mask @ A @ N ) ) ) ) ) ) ).

% slice_eq_mask
thf(fact_3862_in__children__def,axiom,
    ( vEBT_V5917875025757280293ildren
    = ( ^ [N3: nat,TreeList: list @ vEBT_VEBT,X2: nat] : ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList @ ( vEBT_VEBT_high @ X2 @ N3 ) ) @ ( vEBT_VEBT_low @ X2 @ N3 ) ) ) ) ).

% in_children_def
thf(fact_3863_not__min__Null__member,axiom,
    ! [T2: vEBT_VEBT] :
      ( ~ ( vEBT_VEBT_minNull @ T2 )
     => ? [X_1: nat] : ( vEBT_V8194947554948674370ptions @ T2 @ X_1 ) ) ).

% not_min_Null_member
thf(fact_3864_horner__sum__of__bool__2__less,axiom,
    ! [Bs: list @ $o] : ( ord_less @ int @ ( groups4207007520872428315er_sum @ $o @ int @ ( zero_neq_one_of_bool @ int ) @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ Bs ) @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( size_size @ ( list @ $o ) @ Bs ) ) ) ).

% horner_sum_of_bool_2_less
thf(fact_3865_xor__minus__numerals_I1_J,axiom,
    ! [N: num,K: int] :
      ( ( bit_se5824344971392196577ns_xor @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N ) ) @ K )
      = ( bit_ri4277139882892585799ns_not @ int @ ( bit_se5824344971392196577ns_xor @ int @ ( neg_numeral_sub @ int @ N @ one2 ) @ K ) ) ) ).

% xor_minus_numerals(1)
thf(fact_3866_inthall,axiom,
    ! [A: $tType,Xs: list @ A,P: A > $o,N: nat] :
      ( ! [X3: A] :
          ( ( member @ A @ X3 @ ( set2 @ A @ Xs ) )
         => ( P @ X3 ) )
     => ( ( ord_less @ nat @ N @ ( size_size @ ( list @ A ) @ Xs ) )
       => ( P @ ( nth @ A @ Xs @ N ) ) ) ) ).

% inthall
thf(fact_3867_sub__num__simps_I1_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( neg_numeral_sub @ A @ one2 @ one2 )
        = ( zero_zero @ A ) ) ) ).

% sub_num_simps(1)
thf(fact_3868_diff__numeral__simps_I1_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [M: num,N: num] :
          ( ( minus_minus @ A @ ( numeral_numeral @ A @ M ) @ ( numeral_numeral @ A @ N ) )
          = ( neg_numeral_sub @ A @ M @ N ) ) ) ).

% diff_numeral_simps(1)
thf(fact_3869_sub__num__simps_I6_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [K: num,L: num] :
          ( ( neg_numeral_sub @ A @ ( bit0 @ K ) @ ( bit0 @ L ) )
          = ( neg_numeral_dbl @ A @ ( neg_numeral_sub @ A @ K @ L ) ) ) ) ).

% sub_num_simps(6)
thf(fact_3870_sub__num__simps_I9_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [K: num,L: num] :
          ( ( neg_numeral_sub @ A @ ( bit1 @ K ) @ ( bit1 @ L ) )
          = ( neg_numeral_dbl @ A @ ( neg_numeral_sub @ A @ K @ L ) ) ) ) ).

% sub_num_simps(9)
thf(fact_3871_add__neg__numeral__simps_I1_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [M: num,N: num] :
          ( ( plus_plus @ A @ ( numeral_numeral @ A @ M ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) )
          = ( neg_numeral_sub @ A @ M @ N ) ) ) ).

% add_neg_numeral_simps(1)
thf(fact_3872_add__neg__numeral__simps_I2_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [M: num,N: num] :
          ( ( plus_plus @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) @ ( numeral_numeral @ A @ N ) )
          = ( neg_numeral_sub @ A @ N @ M ) ) ) ).

% add_neg_numeral_simps(2)
thf(fact_3873_semiring__norm_I166_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [V: num,W: num,Y: A] :
          ( ( plus_plus @ A @ ( numeral_numeral @ A @ V ) @ ( plus_plus @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) @ Y ) )
          = ( plus_plus @ A @ ( neg_numeral_sub @ A @ V @ W ) @ Y ) ) ) ).

% semiring_norm(166)
thf(fact_3874_semiring__norm_I167_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [V: num,W: num,Y: A] :
          ( ( plus_plus @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) @ ( plus_plus @ A @ ( numeral_numeral @ A @ W ) @ Y ) )
          = ( plus_plus @ A @ ( neg_numeral_sub @ A @ W @ V ) @ Y ) ) ) ).

% semiring_norm(167)
thf(fact_3875_diff__numeral__simps_I4_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [M: num,N: num] :
          ( ( minus_minus @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) )
          = ( neg_numeral_sub @ A @ N @ M ) ) ) ).

% diff_numeral_simps(4)
thf(fact_3876_sub__num__simps_I7_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [K: num,L: num] :
          ( ( neg_numeral_sub @ A @ ( bit0 @ K ) @ ( bit1 @ L ) )
          = ( neg_numeral_dbl_dec @ A @ ( neg_numeral_sub @ A @ K @ L ) ) ) ) ).

% sub_num_simps(7)
thf(fact_3877_sub__num__simps_I8_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [K: num,L: num] :
          ( ( neg_numeral_sub @ A @ ( bit1 @ K ) @ ( bit0 @ L ) )
          = ( neg_numeral_dbl_inc @ A @ ( neg_numeral_sub @ A @ K @ L ) ) ) ) ).

% sub_num_simps(8)
thf(fact_3878_diff__numeral__special_I1_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [N: num] :
          ( ( minus_minus @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ N ) )
          = ( neg_numeral_sub @ A @ one2 @ N ) ) ) ).

% diff_numeral_special(1)
thf(fact_3879_diff__numeral__special_I2_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [M: num] :
          ( ( minus_minus @ A @ ( numeral_numeral @ A @ M ) @ ( one_one @ A ) )
          = ( neg_numeral_sub @ A @ M @ one2 ) ) ) ).

% diff_numeral_special(2)
thf(fact_3880_sub__num__simps_I5_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [K: num] :
          ( ( neg_numeral_sub @ A @ ( bit1 @ K ) @ one2 )
          = ( numeral_numeral @ A @ ( bit0 @ K ) ) ) ) ).

% sub_num_simps(5)
thf(fact_3881_not__minus__numeral__eq,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N: num] :
          ( ( bit_ri4277139882892585799ns_not @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) )
          = ( neg_numeral_sub @ A @ N @ one2 ) ) ) ).

% not_minus_numeral_eq
thf(fact_3882_sub__num__simps_I4_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [K: num] :
          ( ( neg_numeral_sub @ A @ ( bit0 @ K ) @ one2 )
          = ( numeral_numeral @ A @ ( bitM @ K ) ) ) ) ).

% sub_num_simps(4)
thf(fact_3883_add__neg__numeral__special_I1_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [M: num] :
          ( ( plus_plus @ A @ ( one_one @ A ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) )
          = ( neg_numeral_sub @ A @ one2 @ M ) ) ) ).

% add_neg_numeral_special(1)
thf(fact_3884_add__neg__numeral__special_I2_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [M: num] :
          ( ( plus_plus @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) @ ( one_one @ A ) )
          = ( neg_numeral_sub @ A @ one2 @ M ) ) ) ).

% add_neg_numeral_special(2)
thf(fact_3885_add__neg__numeral__special_I3_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [M: num] :
          ( ( plus_plus @ A @ ( numeral_numeral @ A @ M ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( neg_numeral_sub @ A @ M @ one2 ) ) ) ).

% add_neg_numeral_special(3)
thf(fact_3886_add__neg__numeral__special_I4_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [N: num] :
          ( ( plus_plus @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( numeral_numeral @ A @ N ) )
          = ( neg_numeral_sub @ A @ N @ one2 ) ) ) ).

% add_neg_numeral_special(4)
thf(fact_3887_minus__sub__one__diff__one,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [M: num] :
          ( ( minus_minus @ A @ ( uminus_uminus @ A @ ( neg_numeral_sub @ A @ M @ one2 ) ) @ ( one_one @ A ) )
          = ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) ) ) ).

% minus_sub_one_diff_one
thf(fact_3888_diff__numeral__special_I7_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [N: num] :
          ( ( minus_minus @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) )
          = ( neg_numeral_sub @ A @ N @ one2 ) ) ) ).

% diff_numeral_special(7)
thf(fact_3889_diff__numeral__special_I8_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [M: num] :
          ( ( minus_minus @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ M ) ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) )
          = ( neg_numeral_sub @ A @ one2 @ M ) ) ) ).

% diff_numeral_special(8)
thf(fact_3890_sub__num__simps_I3_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [L: num] :
          ( ( neg_numeral_sub @ A @ one2 @ ( bit1 @ L ) )
          = ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( bit0 @ L ) ) ) ) ) ).

% sub_num_simps(3)
thf(fact_3891_sub__num__simps_I2_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [L: num] :
          ( ( neg_numeral_sub @ A @ one2 @ ( bit0 @ L ) )
          = ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( bitM @ L ) ) ) ) ) ).

% sub_num_simps(2)
thf(fact_3892__C1_C,axiom,
    vEBT_invar_vebt @ summary @ m ).

% "1"
thf(fact_3893_xor__minus__numerals_I2_J,axiom,
    ! [K: int,N: num] :
      ( ( bit_se5824344971392196577ns_xor @ int @ K @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N ) ) )
      = ( bit_ri4277139882892585799ns_not @ int @ ( bit_se5824344971392196577ns_xor @ int @ K @ ( neg_numeral_sub @ int @ N @ one2 ) ) ) ) ).

% xor_minus_numerals(2)
thf(fact_3894_length__pos__if__in__set,axiom,
    ! [A: $tType,X: A,Xs: list @ A] :
      ( ( member @ A @ X @ ( set2 @ A @ Xs ) )
     => ( ord_less @ nat @ ( zero_zero @ nat ) @ ( size_size @ ( list @ A ) @ Xs ) ) ) ).

% length_pos_if_in_set
thf(fact_3895_nth__mem,axiom,
    ! [A: $tType,N: nat,Xs: list @ A] :
      ( ( ord_less @ nat @ N @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( member @ A @ ( nth @ A @ Xs @ N ) @ ( set2 @ A @ Xs ) ) ) ).

% nth_mem
thf(fact_3896_list__ball__nth,axiom,
    ! [A: $tType,N: nat,Xs: list @ A,P: A > $o] :
      ( ( ord_less @ nat @ N @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( ! [X3: A] :
            ( ( member @ A @ X3 @ ( set2 @ A @ Xs ) )
           => ( P @ X3 ) )
       => ( P @ ( nth @ A @ Xs @ N ) ) ) ) ).

% list_ball_nth
thf(fact_3897_in__set__conv__nth,axiom,
    ! [A: $tType,X: A,Xs: list @ A] :
      ( ( member @ A @ X @ ( set2 @ A @ Xs ) )
      = ( ? [I4: nat] :
            ( ( ord_less @ nat @ I4 @ ( size_size @ ( list @ A ) @ Xs ) )
            & ( ( nth @ A @ Xs @ I4 )
              = X ) ) ) ) ).

% in_set_conv_nth
thf(fact_3898_all__nth__imp__all__set,axiom,
    ! [A: $tType,Xs: list @ A,P: A > $o,X: A] :
      ( ! [I2: nat] :
          ( ( ord_less @ nat @ I2 @ ( size_size @ ( list @ A ) @ Xs ) )
         => ( P @ ( nth @ A @ Xs @ I2 ) ) )
     => ( ( member @ A @ X @ ( set2 @ A @ Xs ) )
       => ( P @ X ) ) ) ).

% all_nth_imp_all_set
thf(fact_3899_all__set__conv__all__nth,axiom,
    ! [A: $tType,Xs: list @ A,P: A > $o] :
      ( ( ! [X2: A] :
            ( ( member @ A @ X2 @ ( set2 @ A @ Xs ) )
           => ( P @ X2 ) ) )
      = ( ! [I4: nat] :
            ( ( ord_less @ nat @ I4 @ ( size_size @ ( list @ A ) @ Xs ) )
           => ( P @ ( nth @ A @ Xs @ I4 ) ) ) ) ) ).

% all_set_conv_all_nth
thf(fact_3900_neg__numeral__class_Osub__def,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( neg_numeral_sub @ A )
        = ( ^ [K3: num,L2: num] : ( minus_minus @ A @ ( numeral_numeral @ A @ K3 ) @ ( numeral_numeral @ A @ L2 ) ) ) ) ) ).

% neg_numeral_class.sub_def
thf(fact_3901_bit__horner__sum__bit__iff,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [Bs: list @ $o,N: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( groups4207007520872428315er_sum @ $o @ A @ ( zero_neq_one_of_bool @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ Bs ) @ N )
          = ( ( ord_less @ nat @ N @ ( size_size @ ( list @ $o ) @ Bs ) )
            & ( nth @ $o @ Bs @ N ) ) ) ) ).

% bit_horner_sum_bit_iff
thf(fact_3902_sub__non__negative,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N: num,M: num] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( neg_numeral_sub @ A @ N @ M ) )
          = ( ord_less_eq @ num @ M @ N ) ) ) ).

% sub_non_negative
thf(fact_3903_sub__non__positive,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N: num,M: num] :
          ( ( ord_less_eq @ A @ ( neg_numeral_sub @ A @ N @ M ) @ ( zero_zero @ A ) )
          = ( ord_less_eq @ num @ N @ M ) ) ) ).

% sub_non_positive
thf(fact_3904_sub__negative,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N: num,M: num] :
          ( ( ord_less @ A @ ( neg_numeral_sub @ A @ N @ M ) @ ( zero_zero @ A ) )
          = ( ord_less @ num @ N @ M ) ) ) ).

% sub_negative
thf(fact_3905_sub__positive,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N: num,M: num] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( neg_numeral_sub @ A @ N @ M ) )
          = ( ord_less @ num @ M @ N ) ) ) ).

% sub_positive
thf(fact_3906_sub__inc__One__eq,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [N: num] :
          ( ( neg_numeral_sub @ A @ ( inc @ N ) @ one2 )
          = ( numeral_numeral @ A @ N ) ) ) ).

% sub_inc_One_eq
thf(fact_3907_minus__numeral__eq__not__sub__one,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N: num] :
          ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) )
          = ( bit_ri4277139882892585799ns_not @ A @ ( neg_numeral_sub @ A @ N @ one2 ) ) ) ) ).

% minus_numeral_eq_not_sub_one
thf(fact_3908_sub__BitM__One__eq,axiom,
    ! [N: num] :
      ( ( neg_numeral_sub @ int @ ( bitM @ N ) @ one2 )
      = ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( neg_numeral_sub @ int @ N @ one2 ) ) ) ).

% sub_BitM_One_eq
thf(fact_3909_set__n__deg__not__0,axiom,
    ! [TreeList2: list @ vEBT_VEBT,N: nat,M: nat] :
      ( ! [X3: vEBT_VEBT] :
          ( ( member @ vEBT_VEBT @ X3 @ ( set2 @ vEBT_VEBT @ TreeList2 ) )
         => ( vEBT_invar_vebt @ X3 @ N ) )
     => ( ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 )
          = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M ) )
       => ( ord_less_eq @ nat @ ( one_one @ nat ) @ N ) ) ) ).

% set_n_deg_not_0
thf(fact_3910__C13_C,axiom,
    ! [I3: nat] :
      ( ( ord_less @ nat @ I3 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ m ) )
     => ( ( ? [X8: nat] : ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ ( list_update @ vEBT_VEBT @ treeList @ ( vEBT_VEBT_high @ mi @ na ) @ ( vEBT_vebt_insert @ ( nth @ vEBT_VEBT @ treeList @ ( vEBT_VEBT_high @ mi @ na ) ) @ ( vEBT_VEBT_low @ mi @ na ) ) ) @ I3 ) @ X8 ) )
        = ( vEBT_V8194947554948674370ptions @ ( if @ vEBT_VEBT @ ( vEBT_VEBT_minNull @ ( nth @ vEBT_VEBT @ treeList @ ( vEBT_VEBT_high @ mi @ na ) ) ) @ ( vEBT_vebt_insert @ summary @ ( vEBT_VEBT_high @ mi @ na ) ) @ summary ) @ I3 ) ) ) ).

% "13"
thf(fact_3911__C4_OIH_C_I1_J,axiom,
    ! [X5: vEBT_VEBT] :
      ( ( member @ vEBT_VEBT @ X5 @ ( set2 @ vEBT_VEBT @ treeList ) )
     => ( ( vEBT_invar_vebt @ X5 @ na )
        & ! [Xa2: nat] :
            ( ( ord_less @ nat @ Xa2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ na ) )
           => ( vEBT_invar_vebt @ ( vEBT_vebt_insert @ X5 @ Xa2 ) @ na ) ) ) ) ).

% "4.IH"(1)
thf(fact_3912__C14_C,axiom,
    ( ( xa
      = ( ord_max @ nat @ ma @ mi ) )
   => ! [X5: vEBT_VEBT] :
        ( ( member @ vEBT_VEBT @ X5 @ ( set2 @ vEBT_VEBT @ ( list_update @ vEBT_VEBT @ treeList @ ( vEBT_VEBT_high @ mi @ na ) @ ( vEBT_vebt_insert @ ( nth @ vEBT_VEBT @ treeList @ ( vEBT_VEBT_high @ mi @ na ) ) @ ( vEBT_VEBT_low @ mi @ na ) ) ) ) )
       => ~ ? [X_12: nat] : ( vEBT_V8194947554948674370ptions @ X5 @ X_12 ) ) ) ).

% "14"
thf(fact_3913_valid__tree__deg__neq__0,axiom,
    ! [T2: vEBT_VEBT] :
      ~ ( vEBT_invar_vebt @ T2 @ ( zero_zero @ nat ) ) ).

% valid_tree_deg_neq_0
thf(fact_3914_valid__0__not,axiom,
    ! [T2: vEBT_VEBT] :
      ~ ( vEBT_invar_vebt @ T2 @ ( zero_zero @ nat ) ) ).

% valid_0_not
thf(fact_3915_deg__not__0,axiom,
    ! [T2: vEBT_VEBT,N: nat] :
      ( ( vEBT_invar_vebt @ T2 @ N )
     => ( ord_less @ nat @ ( zero_zero @ nat ) @ N ) ) ).

% deg_not_0
thf(fact_3916__C0_C,axiom,
    ! [X5: vEBT_VEBT] :
      ( ( member @ vEBT_VEBT @ X5 @ ( set2 @ vEBT_VEBT @ treeList ) )
     => ( vEBT_invar_vebt @ X5 @ na ) ) ).

% "0"
thf(fact_3917_valid__insert__both__member__options__add,axiom,
    ! [T2: vEBT_VEBT,N: nat,X: nat] :
      ( ( vEBT_invar_vebt @ T2 @ N )
     => ( ( ord_less @ nat @ X @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) )
       => ( vEBT_V8194947554948674370ptions @ ( vEBT_vebt_insert @ T2 @ X ) @ X ) ) ) ).

% valid_insert_both_member_options_add
thf(fact_3918_valid__insert__both__member__options__pres,axiom,
    ! [T2: vEBT_VEBT,N: nat,X: nat,Y: nat] :
      ( ( vEBT_invar_vebt @ T2 @ N )
     => ( ( ord_less @ nat @ X @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) )
       => ( ( ord_less @ nat @ Y @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) )
         => ( ( vEBT_V8194947554948674370ptions @ T2 @ X )
           => ( vEBT_V8194947554948674370ptions @ ( vEBT_vebt_insert @ T2 @ Y ) @ X ) ) ) ) ) ).

% valid_insert_both_member_options_pres
thf(fact_3919__C4_OIH_C_I2_J,axiom,
    ! [X: nat] :
      ( ( ord_less @ nat @ X @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ m ) )
     => ( vEBT_invar_vebt @ ( vEBT_vebt_insert @ summary @ X ) @ m ) ) ).

% "4.IH"(2)
thf(fact_3920_myIHs,axiom,
    ! [X: vEBT_VEBT,Xa: nat] :
      ( ( member @ vEBT_VEBT @ X @ ( set2 @ vEBT_VEBT @ treeList ) )
     => ( ( vEBT_invar_vebt @ X @ na )
       => ( ( ord_less @ nat @ Xa @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ na ) )
         => ( vEBT_invar_vebt @ ( vEBT_vebt_insert @ X @ Xa ) @ na ) ) ) ) ).

% myIHs
thf(fact_3921_list__update__beyond,axiom,
    ! [A: $tType,Xs: list @ A,I: nat,X: A] :
      ( ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ I )
     => ( ( list_update @ A @ Xs @ I @ X )
        = Xs ) ) ).

% list_update_beyond
thf(fact_3922__C12_C,axiom,
    vEBT_invar_vebt @ ( if @ vEBT_VEBT @ ( vEBT_VEBT_minNull @ ( nth @ vEBT_VEBT @ treeList @ ( vEBT_VEBT_high @ mi @ na ) ) ) @ ( vEBT_vebt_insert @ summary @ ( vEBT_VEBT_high @ mi @ na ) ) @ summary ) @ na ).

% "12"
thf(fact_3923__C11_C,axiom,
    ! [X5: vEBT_VEBT] :
      ( ( member @ vEBT_VEBT @ X5 @ ( set2 @ vEBT_VEBT @ ( list_update @ vEBT_VEBT @ treeList @ ( vEBT_VEBT_high @ mi @ na ) @ ( vEBT_vebt_insert @ ( nth @ vEBT_VEBT @ treeList @ ( vEBT_VEBT_high @ mi @ na ) ) @ ( vEBT_VEBT_low @ mi @ na ) ) ) ) )
     => ( vEBT_invar_vebt @ X5 @ na ) ) ).

% "11"
thf(fact_3924_nth__list__update__eq,axiom,
    ! [A: $tType,I: nat,Xs: list @ A,X: A] :
      ( ( ord_less @ nat @ I @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( ( nth @ A @ ( list_update @ A @ Xs @ I @ X ) @ I )
        = X ) ) ).

% nth_list_update_eq
thf(fact_3925_set__swap,axiom,
    ! [A: $tType,I: nat,Xs: list @ A,J: nat] :
      ( ( ord_less @ nat @ I @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( ( ord_less @ nat @ J @ ( size_size @ ( list @ A ) @ Xs ) )
       => ( ( set2 @ A @ ( list_update @ A @ ( list_update @ A @ Xs @ I @ ( nth @ A @ Xs @ J ) ) @ J @ ( nth @ A @ Xs @ I ) ) )
          = ( set2 @ A @ Xs ) ) ) ) ).

% set_swap
thf(fact_3926_set__update__memI,axiom,
    ! [A: $tType,N: nat,Xs: list @ A,X: A] :
      ( ( ord_less @ nat @ N @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( member @ A @ X @ ( set2 @ A @ ( list_update @ A @ Xs @ N @ X ) ) ) ) ).

% set_update_memI
thf(fact_3927_list__update__same__conv,axiom,
    ! [A: $tType,I: nat,Xs: list @ A,X: A] :
      ( ( ord_less @ nat @ I @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( ( ( list_update @ A @ Xs @ I @ X )
          = Xs )
        = ( ( nth @ A @ Xs @ I )
          = X ) ) ) ).

% list_update_same_conv
thf(fact_3928_nth__list__update,axiom,
    ! [A: $tType,I: nat,Xs: list @ A,J: nat,X: A] :
      ( ( ord_less @ nat @ I @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( ( ( I = J )
         => ( ( nth @ A @ ( list_update @ A @ Xs @ I @ X ) @ J )
            = X ) )
        & ( ( I != J )
         => ( ( nth @ A @ ( list_update @ A @ Xs @ I @ X ) @ J )
            = ( nth @ A @ Xs @ J ) ) ) ) ) ).

% nth_list_update
thf(fact_3929_post__member__pre__member,axiom,
    ! [T2: vEBT_VEBT,N: nat,X: nat,Y: nat] :
      ( ( vEBT_invar_vebt @ T2 @ N )
     => ( ( ord_less @ nat @ X @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) )
       => ( ( ord_less @ nat @ Y @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) )
         => ( ( vEBT_vebt_member @ ( vEBT_vebt_insert @ T2 @ X ) @ Y )
           => ( ( vEBT_vebt_member @ T2 @ Y )
              | ( X = Y ) ) ) ) ) ) ).

% post_member_pre_member
thf(fact_3930_member__bound,axiom,
    ! [Tree: vEBT_VEBT,X: nat,N: nat] :
      ( ( vEBT_vebt_member @ Tree @ X )
     => ( ( vEBT_invar_vebt @ Tree @ N )
       => ( ord_less @ nat @ X @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ) ) ).

% member_bound
thf(fact_3931_both__member__options__ding,axiom,
    ! [Info: option @ ( product_prod @ nat @ nat ),Deg: nat,TreeList2: list @ vEBT_VEBT,Summary: vEBT_VEBT,N: nat,X: nat] :
      ( ( vEBT_invar_vebt @ ( vEBT_Node @ Info @ Deg @ TreeList2 @ Summary ) @ N )
     => ( ( ord_less @ nat @ X @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg ) )
       => ( ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList2 @ ( vEBT_VEBT_high @ X @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ X @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
         => ( vEBT_V8194947554948674370ptions @ ( vEBT_Node @ Info @ Deg @ TreeList2 @ Summary ) @ X ) ) ) ) ).

% both_member_options_ding
thf(fact_3932_buildup__gives__valid,axiom,
    ! [N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( vEBT_invar_vebt @ ( vEBT_vebt_buildup @ N ) @ N ) ) ).

% buildup_gives_valid
thf(fact_3933_deg__deg__n,axiom,
    ! [Info: option @ ( product_prod @ nat @ nat ),Deg: nat,TreeList2: list @ vEBT_VEBT,Summary: vEBT_VEBT,N: nat] :
      ( ( vEBT_invar_vebt @ ( vEBT_Node @ Info @ Deg @ TreeList2 @ Summary ) @ N )
     => ( Deg = N ) ) ).

% deg_deg_n
thf(fact_3934_min__Null__member,axiom,
    ! [T2: vEBT_VEBT,X: nat] :
      ( ( vEBT_VEBT_minNull @ T2 )
     => ~ ( vEBT_vebt_member @ T2 @ X ) ) ).

% min_Null_member
thf(fact_3935_deg__SUcn__Node,axiom,
    ! [Tree: vEBT_VEBT,N: nat] :
      ( ( vEBT_invar_vebt @ Tree @ ( suc @ ( suc @ N ) ) )
     => ? [Info2: option @ ( product_prod @ nat @ nat ),TreeList3: list @ vEBT_VEBT,S3: vEBT_VEBT] :
          ( Tree
          = ( vEBT_Node @ Info2 @ ( suc @ ( suc @ N ) ) @ TreeList3 @ S3 ) ) ) ).

% deg_SUcn_Node
thf(fact_3936_valid__member__both__member__options,axiom,
    ! [T2: vEBT_VEBT,N: nat,X: nat] :
      ( ( vEBT_invar_vebt @ T2 @ N )
     => ( ( vEBT_V8194947554948674370ptions @ T2 @ X )
       => ( vEBT_vebt_member @ T2 @ X ) ) ) ).

% valid_member_both_member_options
thf(fact_3937_both__member__options__equiv__member,axiom,
    ! [T2: vEBT_VEBT,N: nat,X: nat] :
      ( ( vEBT_invar_vebt @ T2 @ N )
     => ( ( vEBT_V8194947554948674370ptions @ T2 @ X )
        = ( vEBT_vebt_member @ T2 @ X ) ) ) ).

% both_member_options_equiv_member
thf(fact_3938_member__correct,axiom,
    ! [T2: vEBT_VEBT,N: nat,X: nat] :
      ( ( vEBT_invar_vebt @ T2 @ N )
     => ( ( vEBT_vebt_member @ T2 @ X )
        = ( member @ nat @ X @ ( vEBT_set_vebt @ T2 ) ) ) ) ).

% member_correct
thf(fact_3939__C10_C,axiom,
    ( ( vEBT_vebt_insert @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ mi @ ma ) ) @ deg @ treeList @ summary ) @ xa )
    = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ xa @ ( ord_max @ nat @ mi @ ma ) ) ) @ deg @ ( list_update @ vEBT_VEBT @ treeList @ ( vEBT_VEBT_high @ mi @ na ) @ ( vEBT_vebt_insert @ ( nth @ vEBT_VEBT @ treeList @ ( vEBT_VEBT_high @ mi @ na ) ) @ ( vEBT_VEBT_low @ mi @ na ) ) ) @ ( if @ vEBT_VEBT @ ( vEBT_VEBT_minNull @ ( nth @ vEBT_VEBT @ treeList @ ( vEBT_VEBT_high @ mi @ na ) ) ) @ ( vEBT_vebt_insert @ summary @ ( vEBT_VEBT_high @ mi @ na ) ) @ summary ) ) ) ).

% "10"
thf(fact_3940_vebt__insert_Osimps_I3_J,axiom,
    ! [Info: option @ ( product_prod @ nat @ nat ),Ts: list @ vEBT_VEBT,S2: vEBT_VEBT,X: nat] :
      ( ( vEBT_vebt_insert @ ( vEBT_Node @ Info @ ( suc @ ( zero_zero @ nat ) ) @ Ts @ S2 ) @ X )
      = ( vEBT_Node @ Info @ ( suc @ ( zero_zero @ nat ) ) @ Ts @ S2 ) ) ).

% vebt_insert.simps(3)
thf(fact_3941_buildup__nothing__in__leaf,axiom,
    ! [N: nat,X: nat] :
      ~ ( vEBT_V5719532721284313246member @ ( vEBT_vebt_buildup @ N ) @ X ) ).

% buildup_nothing_in_leaf
thf(fact_3942_invar__vebt_Ointros_I3_J,axiom,
    ! [TreeList2: list @ vEBT_VEBT,N: nat,Summary: vEBT_VEBT,M: nat,Deg: nat] :
      ( ! [X3: vEBT_VEBT] :
          ( ( member @ vEBT_VEBT @ X3 @ ( set2 @ vEBT_VEBT @ TreeList2 ) )
         => ( vEBT_invar_vebt @ X3 @ N ) )
     => ( ( vEBT_invar_vebt @ Summary @ M )
       => ( ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 )
            = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M ) )
         => ( ( M
              = ( suc @ N ) )
           => ( ( Deg
                = ( plus_plus @ nat @ N @ M ) )
             => ( ~ ? [X_1: nat] : ( vEBT_V8194947554948674370ptions @ Summary @ X_1 )
               => ( ! [X3: vEBT_VEBT] :
                      ( ( member @ vEBT_VEBT @ X3 @ ( set2 @ vEBT_VEBT @ TreeList2 ) )
                     => ~ ? [X_1: nat] : ( vEBT_V8194947554948674370ptions @ X3 @ X_1 ) )
                 => ( vEBT_invar_vebt @ ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ Deg @ TreeList2 @ Summary ) @ Deg ) ) ) ) ) ) ) ) ).

% invar_vebt.intros(3)
thf(fact_3943_mi__eq__ma__no__ch,axiom,
    ! [Mi: nat,Ma: nat,Deg: nat,TreeList2: list @ vEBT_VEBT,Summary: vEBT_VEBT] :
      ( ( vEBT_invar_vebt @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi @ Ma ) ) @ Deg @ TreeList2 @ Summary ) @ Deg )
     => ( ( Mi = Ma )
       => ( ! [X5: vEBT_VEBT] :
              ( ( member @ vEBT_VEBT @ X5 @ ( set2 @ vEBT_VEBT @ TreeList2 ) )
             => ~ ? [X_12: nat] : ( vEBT_V8194947554948674370ptions @ X5 @ X_12 ) )
          & ~ ? [X_12: nat] : ( vEBT_V8194947554948674370ptions @ Summary @ X_12 ) ) ) ) ).

% mi_eq_ma_no_ch
thf(fact_3944_insert__simp__mima,axiom,
    ! [X: nat,Mi: nat,Ma: nat,Deg: nat,TreeList2: list @ vEBT_VEBT,Summary: vEBT_VEBT] :
      ( ( ( X = Mi )
        | ( X = Ma ) )
     => ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg )
       => ( ( vEBT_vebt_insert @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi @ Ma ) ) @ Deg @ TreeList2 @ Summary ) @ X )
          = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi @ Ma ) ) @ Deg @ TreeList2 @ Summary ) ) ) ) ).

% insert_simp_mima
thf(fact_3945_mi__ma__2__deg,axiom,
    ! [Mi: nat,Ma: nat,Deg: nat,TreeList2: list @ vEBT_VEBT,Summary: vEBT_VEBT,N: nat] :
      ( ( vEBT_invar_vebt @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi @ Ma ) ) @ Deg @ TreeList2 @ Summary ) @ N )
     => ( ( ord_less_eq @ nat @ Mi @ Ma )
        & ( ord_less @ nat @ Ma @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg ) ) ) ) ).

% mi_ma_2_deg
thf(fact_3946_set__vebt__set__vebt_H__valid,axiom,
    ! [T2: vEBT_VEBT,N: nat] :
      ( ( vEBT_invar_vebt @ T2 @ N )
     => ( ( vEBT_set_vebt @ T2 )
        = ( vEBT_VEBT_set_vebt @ T2 ) ) ) ).

% set_vebt_set_vebt'_valid
thf(fact_3947_both__member__options__from__complete__tree__to__child,axiom,
    ! [Deg: nat,Mi: nat,Ma: nat,TreeList2: list @ vEBT_VEBT,Summary: vEBT_VEBT,X: nat] :
      ( ( ord_less_eq @ nat @ ( one_one @ nat ) @ Deg )
     => ( ( vEBT_V8194947554948674370ptions @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi @ Ma ) ) @ Deg @ TreeList2 @ Summary ) @ X )
       => ( ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList2 @ ( vEBT_VEBT_high @ X @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ X @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
          | ( X = Mi )
          | ( X = Ma ) ) ) ) ).

% both_member_options_from_complete_tree_to_child
thf(fact_3948_member__inv,axiom,
    ! [Mi: nat,Ma: nat,Deg: nat,TreeList2: list @ vEBT_VEBT,Summary: vEBT_VEBT,X: nat] :
      ( ( vEBT_vebt_member @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi @ Ma ) ) @ Deg @ TreeList2 @ Summary ) @ X )
     => ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg )
        & ( ( X = Mi )
          | ( X = Ma )
          | ( ( ord_less @ nat @ X @ Ma )
            & ( ord_less @ nat @ Mi @ X )
            & ( ord_less @ nat @ ( vEBT_VEBT_high @ X @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 ) )
            & ( vEBT_vebt_member @ ( nth @ vEBT_VEBT @ TreeList2 @ ( vEBT_VEBT_high @ X @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ X @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ).

% member_inv
thf(fact_3949_both__member__options__from__chilf__to__complete__tree,axiom,
    ! [X: nat,Deg: nat,TreeList2: list @ vEBT_VEBT,Mi: nat,Ma: nat,Summary: vEBT_VEBT] :
      ( ( ord_less @ nat @ ( vEBT_VEBT_high @ X @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 ) )
     => ( ( ord_less_eq @ nat @ ( one_one @ nat ) @ Deg )
       => ( ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList2 @ ( vEBT_VEBT_high @ X @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ X @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
         => ( vEBT_V8194947554948674370ptions @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi @ Ma ) ) @ Deg @ TreeList2 @ Summary ) @ X ) ) ) ) ).

% both_member_options_from_chilf_to_complete_tree
thf(fact_3950_insert__simp__norm,axiom,
    ! [X: nat,Deg: nat,TreeList2: list @ vEBT_VEBT,Mi: nat,Ma: nat,Summary: vEBT_VEBT] :
      ( ( ord_less @ nat @ ( vEBT_VEBT_high @ X @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 ) )
     => ( ( ord_less @ nat @ Mi @ X )
       => ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg )
         => ( ( X != Ma )
           => ( ( vEBT_vebt_insert @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi @ Ma ) ) @ Deg @ TreeList2 @ Summary ) @ X )
              = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi @ ( ord_max @ nat @ X @ Ma ) ) ) @ Deg @ ( list_update @ vEBT_VEBT @ TreeList2 @ ( vEBT_VEBT_high @ X @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( vEBT_vebt_insert @ ( nth @ vEBT_VEBT @ TreeList2 @ ( vEBT_VEBT_high @ X @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ X @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) @ ( if @ vEBT_VEBT @ ( vEBT_VEBT_minNull @ ( nth @ vEBT_VEBT @ TreeList2 @ ( vEBT_VEBT_high @ X @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) @ ( vEBT_vebt_insert @ Summary @ ( vEBT_VEBT_high @ X @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ Summary ) ) ) ) ) ) ) ).

% insert_simp_norm
thf(fact_3951_insert__simp__excp,axiom,
    ! [Mi: nat,Deg: nat,TreeList2: list @ vEBT_VEBT,X: nat,Ma: nat,Summary: vEBT_VEBT] :
      ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Mi @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 ) )
     => ( ( ord_less @ nat @ X @ Mi )
       => ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg )
         => ( ( X != Ma )
           => ( ( vEBT_vebt_insert @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi @ Ma ) ) @ Deg @ TreeList2 @ Summary ) @ X )
              = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ X @ ( ord_max @ nat @ Mi @ Ma ) ) ) @ Deg @ ( list_update @ vEBT_VEBT @ TreeList2 @ ( vEBT_VEBT_high @ Mi @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( vEBT_vebt_insert @ ( nth @ vEBT_VEBT @ TreeList2 @ ( vEBT_VEBT_high @ Mi @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Mi @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) @ ( if @ vEBT_VEBT @ ( vEBT_VEBT_minNull @ ( nth @ vEBT_VEBT @ TreeList2 @ ( vEBT_VEBT_high @ Mi @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) @ ( vEBT_vebt_insert @ Summary @ ( vEBT_VEBT_high @ Mi @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ Summary ) ) ) ) ) ) ) ).

% insert_simp_excp
thf(fact_3952_VEBT__internal_Onaive__member_Osimps_I2_J,axiom,
    ! [Uu: option @ ( product_prod @ nat @ nat ),Uv: list @ vEBT_VEBT,Uw: vEBT_VEBT,Ux: nat] :
      ~ ( vEBT_V5719532721284313246member @ ( vEBT_Node @ Uu @ ( zero_zero @ nat ) @ Uv @ Uw ) @ Ux ) ).

% VEBT_internal.naive_member.simps(2)
thf(fact_3953_invar__vebt_Ointros_I4_J,axiom,
    ! [TreeList2: list @ vEBT_VEBT,N: nat,Summary: vEBT_VEBT,M: nat,Deg: nat,Mi: nat,Ma: nat] :
      ( ! [X3: vEBT_VEBT] :
          ( ( member @ vEBT_VEBT @ X3 @ ( set2 @ vEBT_VEBT @ TreeList2 ) )
         => ( vEBT_invar_vebt @ X3 @ N ) )
     => ( ( vEBT_invar_vebt @ Summary @ M )
       => ( ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 )
            = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M ) )
         => ( ( M = N )
           => ( ( Deg
                = ( plus_plus @ nat @ N @ M ) )
             => ( ! [I2: nat] :
                    ( ( ord_less @ nat @ I2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M ) )
                   => ( ( ? [X8: nat] : ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList2 @ I2 ) @ X8 ) )
                      = ( vEBT_V8194947554948674370ptions @ Summary @ I2 ) ) )
               => ( ( ( Mi = Ma )
                   => ! [X3: vEBT_VEBT] :
                        ( ( member @ vEBT_VEBT @ X3 @ ( set2 @ vEBT_VEBT @ TreeList2 ) )
                       => ~ ? [X_1: nat] : ( vEBT_V8194947554948674370ptions @ X3 @ X_1 ) ) )
                 => ( ( ord_less_eq @ nat @ Mi @ Ma )
                   => ( ( ord_less @ nat @ Ma @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg ) )
                     => ( ( ( Mi != Ma )
                         => ! [I2: nat] :
                              ( ( ord_less @ nat @ I2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M ) )
                             => ( ( ( ( vEBT_VEBT_high @ Ma @ N )
                                    = I2 )
                                 => ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList2 @ I2 ) @ ( vEBT_VEBT_low @ Ma @ N ) ) )
                                & ! [X3: nat] :
                                    ( ( ( ( vEBT_VEBT_high @ X3 @ N )
                                        = I2 )
                                      & ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList2 @ I2 ) @ ( vEBT_VEBT_low @ X3 @ N ) ) )
                                   => ( ( ord_less @ nat @ Mi @ X3 )
                                      & ( ord_less_eq @ nat @ X3 @ Ma ) ) ) ) ) )
                       => ( vEBT_invar_vebt @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi @ Ma ) ) @ Deg @ TreeList2 @ Summary ) @ Deg ) ) ) ) ) ) ) ) ) ) ) ).

% invar_vebt.intros(4)
thf(fact_3954_invar__vebt_Ointros_I5_J,axiom,
    ! [TreeList2: list @ vEBT_VEBT,N: nat,Summary: vEBT_VEBT,M: nat,Deg: nat,Mi: nat,Ma: nat] :
      ( ! [X3: vEBT_VEBT] :
          ( ( member @ vEBT_VEBT @ X3 @ ( set2 @ vEBT_VEBT @ TreeList2 ) )
         => ( vEBT_invar_vebt @ X3 @ N ) )
     => ( ( vEBT_invar_vebt @ Summary @ M )
       => ( ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 )
            = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M ) )
         => ( ( M
              = ( suc @ N ) )
           => ( ( Deg
                = ( plus_plus @ nat @ N @ M ) )
             => ( ! [I2: nat] :
                    ( ( ord_less @ nat @ I2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M ) )
                   => ( ( ? [X8: nat] : ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList2 @ I2 ) @ X8 ) )
                      = ( vEBT_V8194947554948674370ptions @ Summary @ I2 ) ) )
               => ( ( ( Mi = Ma )
                   => ! [X3: vEBT_VEBT] :
                        ( ( member @ vEBT_VEBT @ X3 @ ( set2 @ vEBT_VEBT @ TreeList2 ) )
                       => ~ ? [X_1: nat] : ( vEBT_V8194947554948674370ptions @ X3 @ X_1 ) ) )
                 => ( ( ord_less_eq @ nat @ Mi @ Ma )
                   => ( ( ord_less @ nat @ Ma @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg ) )
                     => ( ( ( Mi != Ma )
                         => ! [I2: nat] :
                              ( ( ord_less @ nat @ I2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M ) )
                             => ( ( ( ( vEBT_VEBT_high @ Ma @ N )
                                    = I2 )
                                 => ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList2 @ I2 ) @ ( vEBT_VEBT_low @ Ma @ N ) ) )
                                & ! [X3: nat] :
                                    ( ( ( ( vEBT_VEBT_high @ X3 @ N )
                                        = I2 )
                                      & ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList2 @ I2 ) @ ( vEBT_VEBT_low @ X3 @ N ) ) )
                                   => ( ( ord_less @ nat @ Mi @ X3 )
                                      & ( ord_less_eq @ nat @ X3 @ Ma ) ) ) ) ) )
                       => ( vEBT_invar_vebt @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi @ Ma ) ) @ Deg @ TreeList2 @ Summary ) @ Deg ) ) ) ) ) ) ) ) ) ) ) ).

% invar_vebt.intros(5)
thf(fact_3955_invar__vebt_Ointros_I2_J,axiom,
    ! [TreeList2: list @ vEBT_VEBT,N: nat,Summary: vEBT_VEBT,M: nat,Deg: nat] :
      ( ! [X3: vEBT_VEBT] :
          ( ( member @ vEBT_VEBT @ X3 @ ( set2 @ vEBT_VEBT @ TreeList2 ) )
         => ( vEBT_invar_vebt @ X3 @ N ) )
     => ( ( vEBT_invar_vebt @ Summary @ M )
       => ( ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 )
            = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M ) )
         => ( ( M = N )
           => ( ( Deg
                = ( plus_plus @ nat @ N @ M ) )
             => ( ~ ? [X_1: nat] : ( vEBT_V8194947554948674370ptions @ Summary @ X_1 )
               => ( ! [X3: vEBT_VEBT] :
                      ( ( member @ vEBT_VEBT @ X3 @ ( set2 @ vEBT_VEBT @ TreeList2 ) )
                     => ~ ? [X_1: nat] : ( vEBT_V8194947554948674370ptions @ X3 @ X_1 ) )
                 => ( vEBT_invar_vebt @ ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ Deg @ TreeList2 @ Summary ) @ Deg ) ) ) ) ) ) ) ) ).

% invar_vebt.intros(2)
thf(fact_3956_vebt__insert_Osimps_I2_J,axiom,
    ! [Info: option @ ( product_prod @ nat @ nat ),Ts: list @ vEBT_VEBT,S2: vEBT_VEBT,X: nat] :
      ( ( vEBT_vebt_insert @ ( vEBT_Node @ Info @ ( zero_zero @ nat ) @ Ts @ S2 ) @ X )
      = ( vEBT_Node @ Info @ ( zero_zero @ nat ) @ Ts @ S2 ) ) ).

% vebt_insert.simps(2)
thf(fact_3957_divmod__step__eq,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [L: num,R2: A,Q3: A] :
          ( ( ( ord_less_eq @ A @ ( numeral_numeral @ A @ L ) @ R2 )
           => ( ( unique1321980374590559556d_step @ A @ L @ ( product_Pair @ A @ A @ Q3 @ R2 ) )
              = ( product_Pair @ A @ A @ ( plus_plus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ Q3 ) @ ( one_one @ A ) ) @ ( minus_minus @ A @ R2 @ ( numeral_numeral @ A @ L ) ) ) ) )
          & ( ~ ( ord_less_eq @ A @ ( numeral_numeral @ A @ L ) @ R2 )
           => ( ( unique1321980374590559556d_step @ A @ L @ ( product_Pair @ A @ A @ Q3 @ R2 ) )
              = ( product_Pair @ A @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ Q3 ) @ R2 ) ) ) ) ) ).

% divmod_step_eq
thf(fact_3958_member__valid__both__member__options,axiom,
    ! [Tree: vEBT_VEBT,N: nat,X: nat] :
      ( ( vEBT_invar_vebt @ Tree @ N )
     => ( ( vEBT_vebt_member @ Tree @ X )
       => ( ( vEBT_V5719532721284313246member @ Tree @ X )
          | ( vEBT_VEBT_membermima @ Tree @ X ) ) ) ) ).

% member_valid_both_member_options
thf(fact_3959_invar__vebt_Osimps,axiom,
    ( vEBT_invar_vebt
    = ( ^ [A1: vEBT_VEBT,A22: nat] :
          ( ( ? [A3: $o,B3: $o] :
                ( A1
                = ( vEBT_Leaf @ A3 @ B3 ) )
            & ( A22
              = ( suc @ ( zero_zero @ nat ) ) ) )
          | ? [TreeList: list @ vEBT_VEBT,N3: nat,Summary2: vEBT_VEBT] :
              ( ( A1
                = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ A22 @ TreeList @ Summary2 ) )
              & ! [X2: vEBT_VEBT] :
                  ( ( member @ vEBT_VEBT @ X2 @ ( set2 @ vEBT_VEBT @ TreeList ) )
                 => ( vEBT_invar_vebt @ X2 @ N3 ) )
              & ( vEBT_invar_vebt @ Summary2 @ N3 )
              & ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList )
                = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N3 ) )
              & ( A22
                = ( plus_plus @ nat @ N3 @ N3 ) )
              & ~ ? [X8: nat] : ( vEBT_V8194947554948674370ptions @ Summary2 @ X8 )
              & ! [X2: vEBT_VEBT] :
                  ( ( member @ vEBT_VEBT @ X2 @ ( set2 @ vEBT_VEBT @ TreeList ) )
                 => ~ ? [X8: nat] : ( vEBT_V8194947554948674370ptions @ X2 @ X8 ) ) )
          | ? [TreeList: list @ vEBT_VEBT,N3: nat,Summary2: vEBT_VEBT] :
              ( ( A1
                = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ A22 @ TreeList @ Summary2 ) )
              & ! [X2: vEBT_VEBT] :
                  ( ( member @ vEBT_VEBT @ X2 @ ( set2 @ vEBT_VEBT @ TreeList ) )
                 => ( vEBT_invar_vebt @ X2 @ N3 ) )
              & ( vEBT_invar_vebt @ Summary2 @ ( suc @ N3 ) )
              & ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList )
                = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( suc @ N3 ) ) )
              & ( A22
                = ( plus_plus @ nat @ N3 @ ( suc @ N3 ) ) )
              & ~ ? [X8: nat] : ( vEBT_V8194947554948674370ptions @ Summary2 @ X8 )
              & ! [X2: vEBT_VEBT] :
                  ( ( member @ vEBT_VEBT @ X2 @ ( set2 @ vEBT_VEBT @ TreeList ) )
                 => ~ ? [X8: nat] : ( vEBT_V8194947554948674370ptions @ X2 @ X8 ) ) )
          | ? [TreeList: list @ vEBT_VEBT,N3: nat,Summary2: vEBT_VEBT,Mi2: nat,Ma2: nat] :
              ( ( A1
                = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ Ma2 ) ) @ A22 @ TreeList @ Summary2 ) )
              & ! [X2: vEBT_VEBT] :
                  ( ( member @ vEBT_VEBT @ X2 @ ( set2 @ vEBT_VEBT @ TreeList ) )
                 => ( vEBT_invar_vebt @ X2 @ N3 ) )
              & ( vEBT_invar_vebt @ Summary2 @ N3 )
              & ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList )
                = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N3 ) )
              & ( A22
                = ( plus_plus @ nat @ N3 @ N3 ) )
              & ! [I4: nat] :
                  ( ( ord_less @ nat @ I4 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N3 ) )
                 => ( ( ? [X8: nat] : ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList @ I4 ) @ X8 ) )
                    = ( vEBT_V8194947554948674370ptions @ Summary2 @ I4 ) ) )
              & ( ( Mi2 = Ma2 )
               => ! [X2: vEBT_VEBT] :
                    ( ( member @ vEBT_VEBT @ X2 @ ( set2 @ vEBT_VEBT @ TreeList ) )
                   => ~ ? [X8: nat] : ( vEBT_V8194947554948674370ptions @ X2 @ X8 ) ) )
              & ( ord_less_eq @ nat @ Mi2 @ Ma2 )
              & ( ord_less @ nat @ Ma2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ A22 ) )
              & ( ( Mi2 != Ma2 )
               => ! [I4: nat] :
                    ( ( ord_less @ nat @ I4 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N3 ) )
                   => ( ( ( ( vEBT_VEBT_high @ Ma2 @ N3 )
                          = I4 )
                       => ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList @ I4 ) @ ( vEBT_VEBT_low @ Ma2 @ N3 ) ) )
                      & ! [X2: nat] :
                          ( ( ( ( vEBT_VEBT_high @ X2 @ N3 )
                              = I4 )
                            & ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList @ I4 ) @ ( vEBT_VEBT_low @ X2 @ N3 ) ) )
                         => ( ( ord_less @ nat @ Mi2 @ X2 )
                            & ( ord_less_eq @ nat @ X2 @ Ma2 ) ) ) ) ) ) )
          | ? [TreeList: list @ vEBT_VEBT,N3: nat,Summary2: vEBT_VEBT,Mi2: nat,Ma2: nat] :
              ( ( A1
                = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi2 @ Ma2 ) ) @ A22 @ TreeList @ Summary2 ) )
              & ! [X2: vEBT_VEBT] :
                  ( ( member @ vEBT_VEBT @ X2 @ ( set2 @ vEBT_VEBT @ TreeList ) )
                 => ( vEBT_invar_vebt @ X2 @ N3 ) )
              & ( vEBT_invar_vebt @ Summary2 @ ( suc @ N3 ) )
              & ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList )
                = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( suc @ N3 ) ) )
              & ( A22
                = ( plus_plus @ nat @ N3 @ ( suc @ N3 ) ) )
              & ! [I4: nat] :
                  ( ( ord_less @ nat @ I4 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( suc @ N3 ) ) )
                 => ( ( ? [X8: nat] : ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList @ I4 ) @ X8 ) )
                    = ( vEBT_V8194947554948674370ptions @ Summary2 @ I4 ) ) )
              & ( ( Mi2 = Ma2 )
               => ! [X2: vEBT_VEBT] :
                    ( ( member @ vEBT_VEBT @ X2 @ ( set2 @ vEBT_VEBT @ TreeList ) )
                   => ~ ? [X8: nat] : ( vEBT_V8194947554948674370ptions @ X2 @ X8 ) ) )
              & ( ord_less_eq @ nat @ Mi2 @ Ma2 )
              & ( ord_less @ nat @ Ma2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ A22 ) )
              & ( ( Mi2 != Ma2 )
               => ! [I4: nat] :
                    ( ( ord_less @ nat @ I4 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( suc @ N3 ) ) )
                   => ( ( ( ( vEBT_VEBT_high @ Ma2 @ N3 )
                          = I4 )
                       => ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList @ I4 ) @ ( vEBT_VEBT_low @ Ma2 @ N3 ) ) )
                      & ! [X2: nat] :
                          ( ( ( ( vEBT_VEBT_high @ X2 @ N3 )
                              = I4 )
                            & ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList @ I4 ) @ ( vEBT_VEBT_low @ X2 @ N3 ) ) )
                         => ( ( ord_less @ nat @ Mi2 @ X2 )
                            & ( ord_less_eq @ nat @ X2 @ Ma2 ) ) ) ) ) ) ) ) ) ) ).

% invar_vebt.simps
thf(fact_3960_buildup__nothing__in__min__max,axiom,
    ! [N: nat,X: nat] :
      ~ ( vEBT_VEBT_membermima @ ( vEBT_vebt_buildup @ N ) @ X ) ).

% buildup_nothing_in_min_max
thf(fact_3961_Leaf__0__not,axiom,
    ! [A2: $o,B2: $o] :
      ~ ( vEBT_invar_vebt @ ( vEBT_Leaf @ A2 @ B2 ) @ ( zero_zero @ nat ) ) ).

% Leaf_0_not
thf(fact_3962_deg__1__Leafy,axiom,
    ! [T2: vEBT_VEBT,N: nat] :
      ( ( vEBT_invar_vebt @ T2 @ N )
     => ( ( N
          = ( one_one @ nat ) )
       => ? [A5: $o,B4: $o] :
            ( T2
            = ( vEBT_Leaf @ A5 @ B4 ) ) ) ) ).

% deg_1_Leafy
thf(fact_3963_deg__1__Leaf,axiom,
    ! [T2: vEBT_VEBT] :
      ( ( vEBT_invar_vebt @ T2 @ ( one_one @ nat ) )
     => ? [A5: $o,B4: $o] :
          ( T2
          = ( vEBT_Leaf @ A5 @ B4 ) ) ) ).

% deg_1_Leaf
thf(fact_3964_deg1Leaf,axiom,
    ! [T2: vEBT_VEBT] :
      ( ( vEBT_invar_vebt @ T2 @ ( one_one @ nat ) )
      = ( ? [A3: $o,B3: $o] :
            ( T2
            = ( vEBT_Leaf @ A3 @ B3 ) ) ) ) ).

% deg1Leaf
thf(fact_3965_both__member__options__def,axiom,
    ( vEBT_V8194947554948674370ptions
    = ( ^ [T3: vEBT_VEBT,X2: nat] :
          ( ( vEBT_V5719532721284313246member @ T3 @ X2 )
          | ( vEBT_VEBT_membermima @ T3 @ X2 ) ) ) ) ).

% both_member_options_def
thf(fact_3966_VEBT__internal_Onaive__member_Ocases,axiom,
    ! [X: product_prod @ vEBT_VEBT @ nat] :
      ( ! [A5: $o,B4: $o,X3: nat] :
          ( X
         != ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Leaf @ A5 @ B4 ) @ X3 ) )
     => ( ! [Uu2: option @ ( product_prod @ nat @ nat ),Uv2: list @ vEBT_VEBT,Uw2: vEBT_VEBT,Ux2: nat] :
            ( X
           != ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ Uu2 @ ( zero_zero @ nat ) @ Uv2 @ Uw2 ) @ Ux2 ) )
       => ~ ! [Uy: option @ ( product_prod @ nat @ nat ),V4: nat,TreeList3: list @ vEBT_VEBT,S3: vEBT_VEBT,X3: nat] :
              ( X
             != ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ Uy @ ( suc @ V4 ) @ TreeList3 @ S3 ) @ X3 ) ) ) ) ).

% VEBT_internal.naive_member.cases
thf(fact_3967_VEBT_Osize_I4_J,axiom,
    ! [X21: $o,X222: $o] :
      ( ( size_size @ vEBT_VEBT @ ( vEBT_Leaf @ X21 @ X222 ) )
      = ( zero_zero @ nat ) ) ).

% VEBT.size(4)
thf(fact_3968_vebt__buildup_Osimps_I1_J,axiom,
    ( ( vEBT_vebt_buildup @ ( zero_zero @ nat ) )
    = ( vEBT_Leaf @ $false @ $false ) ) ).

% vebt_buildup.simps(1)
thf(fact_3969_invar__vebt_Ointros_I1_J,axiom,
    ! [A2: $o,B2: $o] : ( vEBT_invar_vebt @ ( vEBT_Leaf @ A2 @ B2 ) @ ( suc @ ( zero_zero @ nat ) ) ) ).

% invar_vebt.intros(1)
thf(fact_3970_vebt__insert_Ocases,axiom,
    ! [X: product_prod @ vEBT_VEBT @ nat] :
      ( ! [A5: $o,B4: $o,X3: nat] :
          ( X
         != ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Leaf @ A5 @ B4 ) @ X3 ) )
     => ( ! [Info2: option @ ( product_prod @ nat @ nat ),Ts2: list @ vEBT_VEBT,S3: vEBT_VEBT,X3: nat] :
            ( X
           != ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ Info2 @ ( zero_zero @ nat ) @ Ts2 @ S3 ) @ X3 ) )
       => ( ! [Info2: option @ ( product_prod @ nat @ nat ),Ts2: list @ vEBT_VEBT,S3: vEBT_VEBT,X3: nat] :
              ( X
             != ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ Info2 @ ( suc @ ( zero_zero @ nat ) ) @ Ts2 @ S3 ) @ X3 ) )
         => ( ! [V4: nat,TreeList3: list @ vEBT_VEBT,Summary3: vEBT_VEBT,X3: nat] :
                ( X
               != ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ ( suc @ V4 ) ) @ TreeList3 @ Summary3 ) @ X3 ) )
           => ~ ! [Mi3: nat,Ma3: nat,Va: nat,TreeList3: list @ vEBT_VEBT,Summary3: vEBT_VEBT,X3: nat] :
                  ( X
                 != ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi3 @ Ma3 ) ) @ ( suc @ ( suc @ Va ) ) @ TreeList3 @ Summary3 ) @ X3 ) ) ) ) ) ) ).

% vebt_insert.cases
thf(fact_3971_VEBT__internal_Omembermima_Ocases,axiom,
    ! [X: product_prod @ vEBT_VEBT @ nat] :
      ( ! [Uu2: $o,Uv2: $o,Uw2: nat] :
          ( X
         != ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Leaf @ Uu2 @ Uv2 ) @ Uw2 ) )
     => ( ! [Ux2: list @ vEBT_VEBT,Uy: vEBT_VEBT,Uz: nat] :
            ( X
           != ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( zero_zero @ nat ) @ Ux2 @ Uy ) @ Uz ) )
       => ( ! [Mi3: nat,Ma3: nat,Va2: list @ vEBT_VEBT,Vb: vEBT_VEBT,X3: nat] :
              ( X
             != ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi3 @ Ma3 ) ) @ ( zero_zero @ nat ) @ Va2 @ Vb ) @ X3 ) )
         => ( ! [Mi3: nat,Ma3: nat,V4: nat,TreeList3: list @ vEBT_VEBT,Vc: vEBT_VEBT,X3: nat] :
                ( X
               != ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi3 @ Ma3 ) ) @ ( suc @ V4 ) @ TreeList3 @ Vc ) @ X3 ) )
           => ~ ! [V4: nat,TreeList3: list @ vEBT_VEBT,Vd: vEBT_VEBT,X3: nat] :
                  ( X
                 != ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ V4 ) @ TreeList3 @ Vd ) @ X3 ) ) ) ) ) ) ).

% VEBT_internal.membermima.cases
thf(fact_3972_vebt__insert_Osimps_I1_J,axiom,
    ! [X: nat,A2: $o,B2: $o] :
      ( ( ( X
          = ( zero_zero @ nat ) )
       => ( ( vEBT_vebt_insert @ ( vEBT_Leaf @ A2 @ B2 ) @ X )
          = ( vEBT_Leaf @ $true @ B2 ) ) )
      & ( ( X
         != ( zero_zero @ nat ) )
       => ( ( ( X
              = ( one_one @ nat ) )
           => ( ( vEBT_vebt_insert @ ( vEBT_Leaf @ A2 @ B2 ) @ X )
              = ( vEBT_Leaf @ A2 @ $true ) ) )
          & ( ( X
             != ( one_one @ nat ) )
           => ( ( vEBT_vebt_insert @ ( vEBT_Leaf @ A2 @ B2 ) @ X )
              = ( vEBT_Leaf @ A2 @ B2 ) ) ) ) ) ) ).

% vebt_insert.simps(1)
thf(fact_3973_vebt__buildup_Osimps_I2_J,axiom,
    ( ( vEBT_vebt_buildup @ ( suc @ ( zero_zero @ nat ) ) )
    = ( vEBT_Leaf @ $false @ $false ) ) ).

% vebt_buildup.simps(2)
thf(fact_3974_xor__num_Ocases,axiom,
    ! [X: product_prod @ num @ num] :
      ( ( X
       != ( product_Pair @ num @ num @ one2 @ one2 ) )
     => ( ! [N2: num] :
            ( X
           != ( product_Pair @ num @ num @ one2 @ ( bit0 @ N2 ) ) )
       => ( ! [N2: num] :
              ( X
             != ( product_Pair @ num @ num @ one2 @ ( bit1 @ N2 ) ) )
         => ( ! [M4: num] :
                ( X
               != ( product_Pair @ num @ num @ ( bit0 @ M4 ) @ one2 ) )
           => ( ! [M4: num,N2: num] :
                  ( X
                 != ( product_Pair @ num @ num @ ( bit0 @ M4 ) @ ( bit0 @ N2 ) ) )
             => ( ! [M4: num,N2: num] :
                    ( X
                   != ( product_Pair @ num @ num @ ( bit0 @ M4 ) @ ( bit1 @ N2 ) ) )
               => ( ! [M4: num] :
                      ( X
                     != ( product_Pair @ num @ num @ ( bit1 @ M4 ) @ one2 ) )
                 => ( ! [M4: num,N2: num] :
                        ( X
                       != ( product_Pair @ num @ num @ ( bit1 @ M4 ) @ ( bit0 @ N2 ) ) )
                   => ~ ! [M4: num,N2: num] :
                          ( X
                         != ( product_Pair @ num @ num @ ( bit1 @ M4 ) @ ( bit1 @ N2 ) ) ) ) ) ) ) ) ) ) ) ).

% xor_num.cases
thf(fact_3975_VEBT__internal_Onaive__member_Osimps_I1_J,axiom,
    ! [A2: $o,B2: $o,X: nat] :
      ( ( vEBT_V5719532721284313246member @ ( vEBT_Leaf @ A2 @ B2 ) @ X )
      = ( ( ( X
            = ( zero_zero @ nat ) )
         => A2 )
        & ( ( X
           != ( zero_zero @ nat ) )
         => ( ( ( X
                = ( one_one @ nat ) )
             => B2 )
            & ( X
              = ( one_one @ nat ) ) ) ) ) ) ).

% VEBT_internal.naive_member.simps(1)
thf(fact_3976_VEBT__internal_Omembermima_Osimps_I2_J,axiom,
    ! [Ux: list @ vEBT_VEBT,Uy2: vEBT_VEBT,Uz2: nat] :
      ~ ( vEBT_VEBT_membermima @ ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( zero_zero @ nat ) @ Ux @ Uy2 ) @ Uz2 ) ).

% VEBT_internal.membermima.simps(2)
thf(fact_3977_VEBT__internal_Omembermima_Osimps_I3_J,axiom,
    ! [Mi: nat,Ma: nat,Va3: list @ vEBT_VEBT,Vb2: vEBT_VEBT,X: nat] :
      ( ( vEBT_VEBT_membermima @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi @ Ma ) ) @ ( zero_zero @ nat ) @ Va3 @ Vb2 ) @ X )
      = ( ( X = Mi )
        | ( X = Ma ) ) ) ).

% VEBT_internal.membermima.simps(3)
thf(fact_3978_invar__vebt_Ocases,axiom,
    ! [A12: vEBT_VEBT,A23: nat] :
      ( ( vEBT_invar_vebt @ A12 @ A23 )
     => ( ( ? [A5: $o,B4: $o] :
              ( A12
              = ( vEBT_Leaf @ A5 @ B4 ) )
         => ( A23
           != ( suc @ ( zero_zero @ nat ) ) ) )
       => ( ! [TreeList3: list @ vEBT_VEBT,N2: nat,Summary3: vEBT_VEBT,M4: nat,Deg2: nat] :
              ( ( A12
                = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ Deg2 @ TreeList3 @ Summary3 ) )
             => ( ( A23 = Deg2 )
               => ( ! [X5: vEBT_VEBT] :
                      ( ( member @ vEBT_VEBT @ X5 @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                     => ( vEBT_invar_vebt @ X5 @ N2 ) )
                 => ( ( vEBT_invar_vebt @ Summary3 @ M4 )
                   => ( ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 )
                        = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M4 ) )
                     => ( ( M4 = N2 )
                       => ( ( Deg2
                            = ( plus_plus @ nat @ N2 @ M4 ) )
                         => ( ~ ? [X_12: nat] : ( vEBT_V8194947554948674370ptions @ Summary3 @ X_12 )
                           => ~ ! [X5: vEBT_VEBT] :
                                  ( ( member @ vEBT_VEBT @ X5 @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                                 => ~ ? [X_12: nat] : ( vEBT_V8194947554948674370ptions @ X5 @ X_12 ) ) ) ) ) ) ) ) ) )
         => ( ! [TreeList3: list @ vEBT_VEBT,N2: nat,Summary3: vEBT_VEBT,M4: nat,Deg2: nat] :
                ( ( A12
                  = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ Deg2 @ TreeList3 @ Summary3 ) )
               => ( ( A23 = Deg2 )
                 => ( ! [X5: vEBT_VEBT] :
                        ( ( member @ vEBT_VEBT @ X5 @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                       => ( vEBT_invar_vebt @ X5 @ N2 ) )
                   => ( ( vEBT_invar_vebt @ Summary3 @ M4 )
                     => ( ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 )
                          = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M4 ) )
                       => ( ( M4
                            = ( suc @ N2 ) )
                         => ( ( Deg2
                              = ( plus_plus @ nat @ N2 @ M4 ) )
                           => ( ~ ? [X_12: nat] : ( vEBT_V8194947554948674370ptions @ Summary3 @ X_12 )
                             => ~ ! [X5: vEBT_VEBT] :
                                    ( ( member @ vEBT_VEBT @ X5 @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                                   => ~ ? [X_12: nat] : ( vEBT_V8194947554948674370ptions @ X5 @ X_12 ) ) ) ) ) ) ) ) ) )
           => ( ! [TreeList3: list @ vEBT_VEBT,N2: nat,Summary3: vEBT_VEBT,M4: nat,Deg2: nat,Mi3: nat,Ma3: nat] :
                  ( ( A12
                    = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi3 @ Ma3 ) ) @ Deg2 @ TreeList3 @ Summary3 ) )
                 => ( ( A23 = Deg2 )
                   => ( ! [X5: vEBT_VEBT] :
                          ( ( member @ vEBT_VEBT @ X5 @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                         => ( vEBT_invar_vebt @ X5 @ N2 ) )
                     => ( ( vEBT_invar_vebt @ Summary3 @ M4 )
                       => ( ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 )
                            = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M4 ) )
                         => ( ( M4 = N2 )
                           => ( ( Deg2
                                = ( plus_plus @ nat @ N2 @ M4 ) )
                             => ( ! [I3: nat] :
                                    ( ( ord_less @ nat @ I3 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M4 ) )
                                   => ( ( ? [X8: nat] : ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList3 @ I3 ) @ X8 ) )
                                      = ( vEBT_V8194947554948674370ptions @ Summary3 @ I3 ) ) )
                               => ( ( ( Mi3 = Ma3 )
                                   => ! [X5: vEBT_VEBT] :
                                        ( ( member @ vEBT_VEBT @ X5 @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                                       => ~ ? [X_12: nat] : ( vEBT_V8194947554948674370ptions @ X5 @ X_12 ) ) )
                                 => ( ( ord_less_eq @ nat @ Mi3 @ Ma3 )
                                   => ( ( ord_less @ nat @ Ma3 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg2 ) )
                                     => ~ ( ( Mi3 != Ma3 )
                                         => ! [I3: nat] :
                                              ( ( ord_less @ nat @ I3 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M4 ) )
                                             => ( ( ( ( vEBT_VEBT_high @ Ma3 @ N2 )
                                                    = I3 )
                                                 => ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList3 @ I3 ) @ ( vEBT_VEBT_low @ Ma3 @ N2 ) ) )
                                                & ! [X5: nat] :
                                                    ( ( ( ( vEBT_VEBT_high @ X5 @ N2 )
                                                        = I3 )
                                                      & ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList3 @ I3 ) @ ( vEBT_VEBT_low @ X5 @ N2 ) ) )
                                                   => ( ( ord_less @ nat @ Mi3 @ X5 )
                                                      & ( ord_less_eq @ nat @ X5 @ Ma3 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) )
             => ~ ! [TreeList3: list @ vEBT_VEBT,N2: nat,Summary3: vEBT_VEBT,M4: nat,Deg2: nat,Mi3: nat,Ma3: nat] :
                    ( ( A12
                      = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi3 @ Ma3 ) ) @ Deg2 @ TreeList3 @ Summary3 ) )
                   => ( ( A23 = Deg2 )
                     => ( ! [X5: vEBT_VEBT] :
                            ( ( member @ vEBT_VEBT @ X5 @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                           => ( vEBT_invar_vebt @ X5 @ N2 ) )
                       => ( ( vEBT_invar_vebt @ Summary3 @ M4 )
                         => ( ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 )
                              = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M4 ) )
                           => ( ( M4
                                = ( suc @ N2 ) )
                             => ( ( Deg2
                                  = ( plus_plus @ nat @ N2 @ M4 ) )
                               => ( ! [I3: nat] :
                                      ( ( ord_less @ nat @ I3 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M4 ) )
                                     => ( ( ? [X8: nat] : ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList3 @ I3 ) @ X8 ) )
                                        = ( vEBT_V8194947554948674370ptions @ Summary3 @ I3 ) ) )
                                 => ( ( ( Mi3 = Ma3 )
                                     => ! [X5: vEBT_VEBT] :
                                          ( ( member @ vEBT_VEBT @ X5 @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                                         => ~ ? [X_12: nat] : ( vEBT_V8194947554948674370ptions @ X5 @ X_12 ) ) )
                                   => ( ( ord_less_eq @ nat @ Mi3 @ Ma3 )
                                     => ( ( ord_less @ nat @ Ma3 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg2 ) )
                                       => ~ ( ( Mi3 != Ma3 )
                                           => ! [I3: nat] :
                                                ( ( ord_less @ nat @ I3 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M4 ) )
                                               => ( ( ( ( vEBT_VEBT_high @ Ma3 @ N2 )
                                                      = I3 )
                                                   => ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList3 @ I3 ) @ ( vEBT_VEBT_low @ Ma3 @ N2 ) ) )
                                                  & ! [X5: nat] :
                                                      ( ( ( ( vEBT_VEBT_high @ X5 @ N2 )
                                                          = I3 )
                                                        & ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList3 @ I3 ) @ ( vEBT_VEBT_low @ X5 @ N2 ) ) )
                                                     => ( ( ord_less @ nat @ Mi3 @ X5 )
                                                        & ( ord_less_eq @ nat @ X5 @ Ma3 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ).

% invar_vebt.cases
thf(fact_3979_inrange,axiom,
    ! [T2: vEBT_VEBT,N: nat] :
      ( ( vEBT_invar_vebt @ T2 @ N )
     => ( ord_less_eq @ ( set @ nat ) @ ( vEBT_VEBT_set_vebt @ T2 ) @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ ( minus_minus @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) @ ( one_one @ nat ) ) ) ) ) ).

% inrange
thf(fact_3980_vebt__member_Ocases,axiom,
    ! [X: product_prod @ vEBT_VEBT @ nat] :
      ( ! [A5: $o,B4: $o,X3: nat] :
          ( X
         != ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Leaf @ A5 @ B4 ) @ X3 ) )
     => ( ! [Uu2: nat,Uv2: list @ vEBT_VEBT,Uw2: vEBT_VEBT,X3: nat] :
            ( X
           != ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ Uu2 @ Uv2 @ Uw2 ) @ X3 ) )
       => ( ! [V4: product_prod @ nat @ nat,Uy: list @ vEBT_VEBT,Uz: vEBT_VEBT,X3: nat] :
              ( X
             != ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ V4 ) @ ( zero_zero @ nat ) @ Uy @ Uz ) @ X3 ) )
         => ( ! [V4: product_prod @ nat @ nat,Vb: list @ vEBT_VEBT,Vc: vEBT_VEBT,X3: nat] :
                ( X
               != ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ V4 ) @ ( suc @ ( zero_zero @ nat ) ) @ Vb @ Vc ) @ X3 ) )
           => ~ ! [Mi3: nat,Ma3: nat,Va: nat,TreeList3: list @ vEBT_VEBT,Summary3: vEBT_VEBT,X3: nat] :
                  ( X
                 != ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi3 @ Ma3 ) ) @ ( suc @ ( suc @ Va ) ) @ TreeList3 @ Summary3 ) @ X3 ) ) ) ) ) ) ).

% vebt_member.cases
thf(fact_3981_vebt__member_Osimps_I4_J,axiom,
    ! [V: product_prod @ nat @ nat,Vb2: list @ vEBT_VEBT,Vc2: vEBT_VEBT,X: nat] :
      ~ ( vEBT_vebt_member @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ V ) @ ( suc @ ( zero_zero @ nat ) ) @ Vb2 @ Vc2 ) @ X ) ).

% vebt_member.simps(4)
thf(fact_3982_atLeastAtMost__iff,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [I: A,L: A,U: A] :
          ( ( member @ A @ I @ ( set_or1337092689740270186AtMost @ A @ L @ U ) )
          = ( ( ord_less_eq @ A @ L @ I )
            & ( ord_less_eq @ A @ I @ U ) ) ) ) ).

% atLeastAtMost_iff
thf(fact_3983_Icc__eq__Icc,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [L: A,H2: A,L4: A,H3: A] :
          ( ( ( set_or1337092689740270186AtMost @ A @ L @ H2 )
            = ( set_or1337092689740270186AtMost @ A @ L4 @ H3 ) )
          = ( ( ( L = L4 )
              & ( H2 = H3 ) )
            | ( ~ ( ord_less_eq @ A @ L @ H2 )
              & ~ ( ord_less_eq @ A @ L4 @ H3 ) ) ) ) ) ).

% Icc_eq_Icc
thf(fact_3984_atLeastatMost__subset__iff,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ord_less_eq @ ( set @ A ) @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) @ ( set_or1337092689740270186AtMost @ A @ C2 @ D2 ) )
          = ( ~ ( ord_less_eq @ A @ A2 @ B2 )
            | ( ( ord_less_eq @ A @ C2 @ A2 )
              & ( ord_less_eq @ A @ B2 @ D2 ) ) ) ) ) ).

% atLeastatMost_subset_iff
thf(fact_3985_atLeastatMost__psubset__iff,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ord_less @ ( set @ A ) @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) @ ( set_or1337092689740270186AtMost @ A @ C2 @ D2 ) )
          = ( ( ~ ( ord_less_eq @ A @ A2 @ B2 )
              | ( ( ord_less_eq @ A @ C2 @ A2 )
                & ( ord_less_eq @ A @ B2 @ D2 )
                & ( ( ord_less @ A @ C2 @ A2 )
                  | ( ord_less @ A @ B2 @ D2 ) ) ) )
            & ( ord_less_eq @ A @ C2 @ D2 ) ) ) ) ).

% atLeastatMost_psubset_iff
thf(fact_3986_ex__nat__less,axiom,
    ! [N: nat,P: nat > $o] :
      ( ( ? [M3: nat] :
            ( ( ord_less_eq @ nat @ M3 @ N )
            & ( P @ M3 ) ) )
      = ( ? [X2: nat] :
            ( ( member @ nat @ X2 @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N ) )
            & ( P @ X2 ) ) ) ) ).

% ex_nat_less
thf(fact_3987_all__nat__less,axiom,
    ! [N: nat,P: nat > $o] :
      ( ( ! [M3: nat] :
            ( ( ord_less_eq @ nat @ M3 @ N )
           => ( P @ M3 ) ) )
      = ( ! [X2: nat] :
            ( ( member @ nat @ X2 @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N ) )
           => ( P @ X2 ) ) ) ) ).

% all_nat_less
thf(fact_3988_vebt__member_Osimps_I1_J,axiom,
    ! [A2: $o,B2: $o,X: nat] :
      ( ( vEBT_vebt_member @ ( vEBT_Leaf @ A2 @ B2 ) @ X )
      = ( ( ( X
            = ( zero_zero @ nat ) )
         => A2 )
        & ( ( X
           != ( zero_zero @ nat ) )
         => ( ( ( X
                = ( one_one @ nat ) )
             => B2 )
            & ( X
              = ( one_one @ nat ) ) ) ) ) ) ).

% vebt_member.simps(1)
thf(fact_3989_vebt__member_Osimps_I3_J,axiom,
    ! [V: product_prod @ nat @ nat,Uy2: list @ vEBT_VEBT,Uz2: vEBT_VEBT,X: nat] :
      ~ ( vEBT_vebt_member @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ V ) @ ( zero_zero @ nat ) @ Uy2 @ Uz2 ) @ X ) ).

% vebt_member.simps(3)
thf(fact_3990_divmod__algorithm__code_I8_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [M: num,N: num] :
          ( ( ( ord_less @ num @ M @ N )
           => ( ( unique8689654367752047608divmod @ A @ ( bit1 @ M ) @ ( bit1 @ N ) )
              = ( product_Pair @ A @ A @ ( zero_zero @ A ) @ ( numeral_numeral @ A @ ( bit1 @ M ) ) ) ) )
          & ( ~ ( ord_less @ num @ M @ N )
           => ( ( unique8689654367752047608divmod @ A @ ( bit1 @ M ) @ ( bit1 @ N ) )
              = ( unique1321980374590559556d_step @ A @ ( bit1 @ N ) @ ( unique8689654367752047608divmod @ A @ ( bit1 @ M ) @ ( bit0 @ ( bit1 @ N ) ) ) ) ) ) ) ) ).

% divmod_algorithm_code(8)
thf(fact_3991_divmod__algorithm__code_I7_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [M: num,N: num] :
          ( ( ( ord_less_eq @ num @ M @ N )
           => ( ( unique8689654367752047608divmod @ A @ ( bit0 @ M ) @ ( bit1 @ N ) )
              = ( product_Pair @ A @ A @ ( zero_zero @ A ) @ ( numeral_numeral @ A @ ( bit0 @ M ) ) ) ) )
          & ( ~ ( ord_less_eq @ num @ M @ N )
           => ( ( unique8689654367752047608divmod @ A @ ( bit0 @ M ) @ ( bit1 @ N ) )
              = ( unique1321980374590559556d_step @ A @ ( bit1 @ N ) @ ( unique8689654367752047608divmod @ A @ ( bit0 @ M ) @ ( bit0 @ ( bit1 @ N ) ) ) ) ) ) ) ) ).

% divmod_algorithm_code(7)
thf(fact_3992_divides__aux__eq,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [Q3: A,R2: A] :
          ( ( unique5940410009612947441es_aux @ A @ ( product_Pair @ A @ A @ Q3 @ R2 ) )
          = ( R2
            = ( zero_zero @ A ) ) ) ) ).

% divides_aux_eq
thf(fact_3993_product__nth,axiom,
    ! [A: $tType,B: $tType,N: nat,Xs: list @ A,Ys3: list @ B] :
      ( ( ord_less @ nat @ N @ ( times_times @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ ( size_size @ ( list @ B ) @ Ys3 ) ) )
     => ( ( nth @ ( product_prod @ A @ B ) @ ( product @ A @ B @ Xs @ Ys3 ) @ N )
        = ( product_Pair @ A @ B @ ( nth @ A @ Xs @ ( divide_divide @ nat @ N @ ( size_size @ ( list @ B ) @ Ys3 ) ) ) @ ( nth @ B @ Ys3 @ ( modulo_modulo @ nat @ N @ ( size_size @ ( list @ B ) @ Ys3 ) ) ) ) ) ) ).

% product_nth
thf(fact_3994_dvd__numeral__simp,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [M: num,N: num] :
          ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ M ) @ ( numeral_numeral @ A @ N ) )
          = ( unique5940410009612947441es_aux @ A @ ( unique8689654367752047608divmod @ A @ N @ M ) ) ) ) ).

% dvd_numeral_simp
thf(fact_3995_divmod__algorithm__code_I2_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [M: num] :
          ( ( unique8689654367752047608divmod @ A @ M @ one2 )
          = ( product_Pair @ A @ A @ ( numeral_numeral @ A @ M ) @ ( zero_zero @ A ) ) ) ) ).

% divmod_algorithm_code(2)
thf(fact_3996_divmod__algorithm__code_I3_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [N: num] :
          ( ( unique8689654367752047608divmod @ A @ one2 @ ( bit0 @ N ) )
          = ( product_Pair @ A @ A @ ( zero_zero @ A ) @ ( numeral_numeral @ A @ one2 ) ) ) ) ).

% divmod_algorithm_code(3)
thf(fact_3997_divmod__algorithm__code_I4_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [N: num] :
          ( ( unique8689654367752047608divmod @ A @ one2 @ ( bit1 @ N ) )
          = ( product_Pair @ A @ A @ ( zero_zero @ A ) @ ( numeral_numeral @ A @ one2 ) ) ) ) ).

% divmod_algorithm_code(4)
thf(fact_3998_divmod__BitM__2__eq,axiom,
    ! [M: num] :
      ( ( unique8689654367752047608divmod @ int @ ( bitM @ M ) @ ( bit0 @ one2 ) )
      = ( product_Pair @ int @ int @ ( minus_minus @ int @ ( numeral_numeral @ int @ M ) @ ( one_one @ int ) ) @ ( one_one @ int ) ) ) ).

% divmod_BitM_2_eq
thf(fact_3999_bset_I1_J,axiom,
    ! [D5: int,B7: set @ int,P: int > $o,Q: int > $o] :
      ( ! [X3: int] :
          ( ! [Xa2: int] :
              ( ( member @ int @ Xa2 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
             => ! [Xb2: int] :
                  ( ( member @ int @ Xb2 @ B7 )
                 => ( X3
                   != ( plus_plus @ int @ Xb2 @ Xa2 ) ) ) )
         => ( ( P @ X3 )
           => ( P @ ( minus_minus @ int @ X3 @ D5 ) ) ) )
     => ( ! [X3: int] :
            ( ! [Xa2: int] :
                ( ( member @ int @ Xa2 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
               => ! [Xb2: int] :
                    ( ( member @ int @ Xb2 @ B7 )
                   => ( X3
                     != ( plus_plus @ int @ Xb2 @ Xa2 ) ) ) )
           => ( ( Q @ X3 )
             => ( Q @ ( minus_minus @ int @ X3 @ D5 ) ) ) )
       => ! [X5: int] :
            ( ! [Xa3: int] :
                ( ( member @ int @ Xa3 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
               => ! [Xb3: int] :
                    ( ( member @ int @ Xb3 @ B7 )
                   => ( X5
                     != ( plus_plus @ int @ Xb3 @ Xa3 ) ) ) )
           => ( ( ( P @ X5 )
                & ( Q @ X5 ) )
             => ( ( P @ ( minus_minus @ int @ X5 @ D5 ) )
                & ( Q @ ( minus_minus @ int @ X5 @ D5 ) ) ) ) ) ) ) ).

% bset(1)
thf(fact_4000_bset_I2_J,axiom,
    ! [D5: int,B7: set @ int,P: int > $o,Q: int > $o] :
      ( ! [X3: int] :
          ( ! [Xa2: int] :
              ( ( member @ int @ Xa2 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
             => ! [Xb2: int] :
                  ( ( member @ int @ Xb2 @ B7 )
                 => ( X3
                   != ( plus_plus @ int @ Xb2 @ Xa2 ) ) ) )
         => ( ( P @ X3 )
           => ( P @ ( minus_minus @ int @ X3 @ D5 ) ) ) )
     => ( ! [X3: int] :
            ( ! [Xa2: int] :
                ( ( member @ int @ Xa2 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
               => ! [Xb2: int] :
                    ( ( member @ int @ Xb2 @ B7 )
                   => ( X3
                     != ( plus_plus @ int @ Xb2 @ Xa2 ) ) ) )
           => ( ( Q @ X3 )
             => ( Q @ ( minus_minus @ int @ X3 @ D5 ) ) ) )
       => ! [X5: int] :
            ( ! [Xa3: int] :
                ( ( member @ int @ Xa3 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
               => ! [Xb3: int] :
                    ( ( member @ int @ Xb3 @ B7 )
                   => ( X5
                     != ( plus_plus @ int @ Xb3 @ Xa3 ) ) ) )
           => ( ( ( P @ X5 )
                | ( Q @ X5 ) )
             => ( ( P @ ( minus_minus @ int @ X5 @ D5 ) )
                | ( Q @ ( minus_minus @ int @ X5 @ D5 ) ) ) ) ) ) ) ).

% bset(2)
thf(fact_4001_aset_I1_J,axiom,
    ! [D5: int,A4: set @ int,P: int > $o,Q: int > $o] :
      ( ! [X3: int] :
          ( ! [Xa2: int] :
              ( ( member @ int @ Xa2 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
             => ! [Xb2: int] :
                  ( ( member @ int @ Xb2 @ A4 )
                 => ( X3
                   != ( minus_minus @ int @ Xb2 @ Xa2 ) ) ) )
         => ( ( P @ X3 )
           => ( P @ ( plus_plus @ int @ X3 @ D5 ) ) ) )
     => ( ! [X3: int] :
            ( ! [Xa2: int] :
                ( ( member @ int @ Xa2 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
               => ! [Xb2: int] :
                    ( ( member @ int @ Xb2 @ A4 )
                   => ( X3
                     != ( minus_minus @ int @ Xb2 @ Xa2 ) ) ) )
           => ( ( Q @ X3 )
             => ( Q @ ( plus_plus @ int @ X3 @ D5 ) ) ) )
       => ! [X5: int] :
            ( ! [Xa3: int] :
                ( ( member @ int @ Xa3 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
               => ! [Xb3: int] :
                    ( ( member @ int @ Xb3 @ A4 )
                   => ( X5
                     != ( minus_minus @ int @ Xb3 @ Xa3 ) ) ) )
           => ( ( ( P @ X5 )
                & ( Q @ X5 ) )
             => ( ( P @ ( plus_plus @ int @ X5 @ D5 ) )
                & ( Q @ ( plus_plus @ int @ X5 @ D5 ) ) ) ) ) ) ) ).

% aset(1)
thf(fact_4002_aset_I2_J,axiom,
    ! [D5: int,A4: set @ int,P: int > $o,Q: int > $o] :
      ( ! [X3: int] :
          ( ! [Xa2: int] :
              ( ( member @ int @ Xa2 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
             => ! [Xb2: int] :
                  ( ( member @ int @ Xb2 @ A4 )
                 => ( X3
                   != ( minus_minus @ int @ Xb2 @ Xa2 ) ) ) )
         => ( ( P @ X3 )
           => ( P @ ( plus_plus @ int @ X3 @ D5 ) ) ) )
     => ( ! [X3: int] :
            ( ! [Xa2: int] :
                ( ( member @ int @ Xa2 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
               => ! [Xb2: int] :
                    ( ( member @ int @ Xb2 @ A4 )
                   => ( X3
                     != ( minus_minus @ int @ Xb2 @ Xa2 ) ) ) )
           => ( ( Q @ X3 )
             => ( Q @ ( plus_plus @ int @ X3 @ D5 ) ) ) )
       => ! [X5: int] :
            ( ! [Xa3: int] :
                ( ( member @ int @ Xa3 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
               => ! [Xb3: int] :
                    ( ( member @ int @ Xb3 @ A4 )
                   => ( X5
                     != ( minus_minus @ int @ Xb3 @ Xa3 ) ) ) )
           => ( ( ( P @ X5 )
                | ( Q @ X5 ) )
             => ( ( P @ ( plus_plus @ int @ X5 @ D5 ) )
                | ( Q @ ( plus_plus @ int @ X5 @ D5 ) ) ) ) ) ) ) ).

% aset(2)
thf(fact_4003_divmod__int__def,axiom,
    ( ( unique8689654367752047608divmod @ int )
    = ( ^ [M3: num,N3: num] : ( product_Pair @ int @ int @ ( divide_divide @ int @ ( numeral_numeral @ int @ M3 ) @ ( numeral_numeral @ int @ N3 ) ) @ ( modulo_modulo @ int @ ( numeral_numeral @ int @ M3 ) @ ( numeral_numeral @ int @ N3 ) ) ) ) ) ).

% divmod_int_def
thf(fact_4004_bset_I9_J,axiom,
    ! [D2: int,D5: int,B7: set @ int,T2: int] :
      ( ( dvd_dvd @ int @ D2 @ D5 )
     => ! [X5: int] :
          ( ! [Xa3: int] :
              ( ( member @ int @ Xa3 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
             => ! [Xb3: int] :
                  ( ( member @ int @ Xb3 @ B7 )
                 => ( X5
                   != ( plus_plus @ int @ Xb3 @ Xa3 ) ) ) )
         => ( ( dvd_dvd @ int @ D2 @ ( plus_plus @ int @ X5 @ T2 ) )
           => ( dvd_dvd @ int @ D2 @ ( plus_plus @ int @ ( minus_minus @ int @ X5 @ D5 ) @ T2 ) ) ) ) ) ).

% bset(9)
thf(fact_4005_bset_I10_J,axiom,
    ! [D2: int,D5: int,B7: set @ int,T2: int] :
      ( ( dvd_dvd @ int @ D2 @ D5 )
     => ! [X5: int] :
          ( ! [Xa3: int] :
              ( ( member @ int @ Xa3 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
             => ! [Xb3: int] :
                  ( ( member @ int @ Xb3 @ B7 )
                 => ( X5
                   != ( plus_plus @ int @ Xb3 @ Xa3 ) ) ) )
         => ( ~ ( dvd_dvd @ int @ D2 @ ( plus_plus @ int @ X5 @ T2 ) )
           => ~ ( dvd_dvd @ int @ D2 @ ( plus_plus @ int @ ( minus_minus @ int @ X5 @ D5 ) @ T2 ) ) ) ) ) ).

% bset(10)
thf(fact_4006_aset_I9_J,axiom,
    ! [D2: int,D5: int,A4: set @ int,T2: int] :
      ( ( dvd_dvd @ int @ D2 @ D5 )
     => ! [X5: int] :
          ( ! [Xa3: int] :
              ( ( member @ int @ Xa3 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
             => ! [Xb3: int] :
                  ( ( member @ int @ Xb3 @ A4 )
                 => ( X5
                   != ( minus_minus @ int @ Xb3 @ Xa3 ) ) ) )
         => ( ( dvd_dvd @ int @ D2 @ ( plus_plus @ int @ X5 @ T2 ) )
           => ( dvd_dvd @ int @ D2 @ ( plus_plus @ int @ ( plus_plus @ int @ X5 @ D5 ) @ T2 ) ) ) ) ) ).

% aset(9)
thf(fact_4007_aset_I10_J,axiom,
    ! [D2: int,D5: int,A4: set @ int,T2: int] :
      ( ( dvd_dvd @ int @ D2 @ D5 )
     => ! [X5: int] :
          ( ! [Xa3: int] :
              ( ( member @ int @ Xa3 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
             => ! [Xb3: int] :
                  ( ( member @ int @ Xb3 @ A4 )
                 => ( X5
                   != ( minus_minus @ int @ Xb3 @ Xa3 ) ) ) )
         => ( ~ ( dvd_dvd @ int @ D2 @ ( plus_plus @ int @ X5 @ T2 ) )
           => ~ ( dvd_dvd @ int @ D2 @ ( plus_plus @ int @ ( plus_plus @ int @ X5 @ D5 ) @ T2 ) ) ) ) ) ).

% aset(10)
thf(fact_4008_periodic__finite__ex,axiom,
    ! [D2: int,P: int > $o] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D2 )
     => ( ! [X3: int,K2: int] :
            ( ( P @ X3 )
            = ( P @ ( minus_minus @ int @ X3 @ ( times_times @ int @ K2 @ D2 ) ) ) )
       => ( ( ? [X8: int] : ( P @ X8 ) )
          = ( ? [X2: int] :
                ( ( member @ int @ X2 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D2 ) )
                & ( P @ X2 ) ) ) ) ) ) ).

% periodic_finite_ex
thf(fact_4009_bset_I3_J,axiom,
    ! [D5: int,T2: int,B7: set @ int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D5 )
     => ( ( member @ int @ ( minus_minus @ int @ T2 @ ( one_one @ int ) ) @ B7 )
       => ! [X5: int] :
            ( ! [Xa3: int] :
                ( ( member @ int @ Xa3 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
               => ! [Xb3: int] :
                    ( ( member @ int @ Xb3 @ B7 )
                   => ( X5
                     != ( plus_plus @ int @ Xb3 @ Xa3 ) ) ) )
           => ( ( X5 = T2 )
             => ( ( minus_minus @ int @ X5 @ D5 )
                = T2 ) ) ) ) ) ).

% bset(3)
thf(fact_4010_bset_I4_J,axiom,
    ! [D5: int,T2: int,B7: set @ int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D5 )
     => ( ( member @ int @ T2 @ B7 )
       => ! [X5: int] :
            ( ! [Xa3: int] :
                ( ( member @ int @ Xa3 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
               => ! [Xb3: int] :
                    ( ( member @ int @ Xb3 @ B7 )
                   => ( X5
                     != ( plus_plus @ int @ Xb3 @ Xa3 ) ) ) )
           => ( ( X5 != T2 )
             => ( ( minus_minus @ int @ X5 @ D5 )
               != T2 ) ) ) ) ) ).

% bset(4)
thf(fact_4011_bset_I5_J,axiom,
    ! [D5: int,B7: set @ int,T2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D5 )
     => ! [X5: int] :
          ( ! [Xa3: int] :
              ( ( member @ int @ Xa3 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
             => ! [Xb3: int] :
                  ( ( member @ int @ Xb3 @ B7 )
                 => ( X5
                   != ( plus_plus @ int @ Xb3 @ Xa3 ) ) ) )
         => ( ( ord_less @ int @ X5 @ T2 )
           => ( ord_less @ int @ ( minus_minus @ int @ X5 @ D5 ) @ T2 ) ) ) ) ).

% bset(5)
thf(fact_4012_bset_I7_J,axiom,
    ! [D5: int,T2: int,B7: set @ int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D5 )
     => ( ( member @ int @ T2 @ B7 )
       => ! [X5: int] :
            ( ! [Xa3: int] :
                ( ( member @ int @ Xa3 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
               => ! [Xb3: int] :
                    ( ( member @ int @ Xb3 @ B7 )
                   => ( X5
                     != ( plus_plus @ int @ Xb3 @ Xa3 ) ) ) )
           => ( ( ord_less @ int @ T2 @ X5 )
             => ( ord_less @ int @ T2 @ ( minus_minus @ int @ X5 @ D5 ) ) ) ) ) ) ).

% bset(7)
thf(fact_4013_aset_I3_J,axiom,
    ! [D5: int,T2: int,A4: set @ int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D5 )
     => ( ( member @ int @ ( plus_plus @ int @ T2 @ ( one_one @ int ) ) @ A4 )
       => ! [X5: int] :
            ( ! [Xa3: int] :
                ( ( member @ int @ Xa3 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
               => ! [Xb3: int] :
                    ( ( member @ int @ Xb3 @ A4 )
                   => ( X5
                     != ( minus_minus @ int @ Xb3 @ Xa3 ) ) ) )
           => ( ( X5 = T2 )
             => ( ( plus_plus @ int @ X5 @ D5 )
                = T2 ) ) ) ) ) ).

% aset(3)
thf(fact_4014_aset_I4_J,axiom,
    ! [D5: int,T2: int,A4: set @ int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D5 )
     => ( ( member @ int @ T2 @ A4 )
       => ! [X5: int] :
            ( ! [Xa3: int] :
                ( ( member @ int @ Xa3 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
               => ! [Xb3: int] :
                    ( ( member @ int @ Xb3 @ A4 )
                   => ( X5
                     != ( minus_minus @ int @ Xb3 @ Xa3 ) ) ) )
           => ( ( X5 != T2 )
             => ( ( plus_plus @ int @ X5 @ D5 )
               != T2 ) ) ) ) ) ).

% aset(4)
thf(fact_4015_aset_I5_J,axiom,
    ! [D5: int,T2: int,A4: set @ int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D5 )
     => ( ( member @ int @ T2 @ A4 )
       => ! [X5: int] :
            ( ! [Xa3: int] :
                ( ( member @ int @ Xa3 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
               => ! [Xb3: int] :
                    ( ( member @ int @ Xb3 @ A4 )
                   => ( X5
                     != ( minus_minus @ int @ Xb3 @ Xa3 ) ) ) )
           => ( ( ord_less @ int @ X5 @ T2 )
             => ( ord_less @ int @ ( plus_plus @ int @ X5 @ D5 ) @ T2 ) ) ) ) ) ).

% aset(5)
thf(fact_4016_aset_I7_J,axiom,
    ! [D5: int,A4: set @ int,T2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D5 )
     => ! [X5: int] :
          ( ! [Xa3: int] :
              ( ( member @ int @ Xa3 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
             => ! [Xb3: int] :
                  ( ( member @ int @ Xb3 @ A4 )
                 => ( X5
                   != ( minus_minus @ int @ Xb3 @ Xa3 ) ) ) )
         => ( ( ord_less @ int @ T2 @ X5 )
           => ( ord_less @ int @ T2 @ ( plus_plus @ int @ X5 @ D5 ) ) ) ) ) ).

% aset(7)
thf(fact_4017_divmod__def,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ( ( unique8689654367752047608divmod @ A )
        = ( ^ [M3: num,N3: num] : ( product_Pair @ A @ A @ ( divide_divide @ A @ ( numeral_numeral @ A @ M3 ) @ ( numeral_numeral @ A @ N3 ) ) @ ( modulo_modulo @ A @ ( numeral_numeral @ A @ M3 ) @ ( numeral_numeral @ A @ N3 ) ) ) ) ) ) ).

% divmod_def
thf(fact_4018_divmod_H__nat__def,axiom,
    ( ( unique8689654367752047608divmod @ nat )
    = ( ^ [M3: num,N3: num] : ( product_Pair @ nat @ nat @ ( divide_divide @ nat @ ( numeral_numeral @ nat @ M3 ) @ ( numeral_numeral @ nat @ N3 ) ) @ ( modulo_modulo @ nat @ ( numeral_numeral @ nat @ M3 ) @ ( numeral_numeral @ nat @ N3 ) ) ) ) ) ).

% divmod'_nat_def
thf(fact_4019_aset_I8_J,axiom,
    ! [D5: int,A4: set @ int,T2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D5 )
     => ! [X5: int] :
          ( ! [Xa3: int] :
              ( ( member @ int @ Xa3 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
             => ! [Xb3: int] :
                  ( ( member @ int @ Xb3 @ A4 )
                 => ( X5
                   != ( minus_minus @ int @ Xb3 @ Xa3 ) ) ) )
         => ( ( ord_less_eq @ int @ T2 @ X5 )
           => ( ord_less_eq @ int @ T2 @ ( plus_plus @ int @ X5 @ D5 ) ) ) ) ) ).

% aset(8)
thf(fact_4020_aset_I6_J,axiom,
    ! [D5: int,T2: int,A4: set @ int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D5 )
     => ( ( member @ int @ ( plus_plus @ int @ T2 @ ( one_one @ int ) ) @ A4 )
       => ! [X5: int] :
            ( ! [Xa3: int] :
                ( ( member @ int @ Xa3 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
               => ! [Xb3: int] :
                    ( ( member @ int @ Xb3 @ A4 )
                   => ( X5
                     != ( minus_minus @ int @ Xb3 @ Xa3 ) ) ) )
           => ( ( ord_less_eq @ int @ X5 @ T2 )
             => ( ord_less_eq @ int @ ( plus_plus @ int @ X5 @ D5 ) @ T2 ) ) ) ) ) ).

% aset(6)
thf(fact_4021_bset_I8_J,axiom,
    ! [D5: int,T2: int,B7: set @ int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D5 )
     => ( ( member @ int @ ( minus_minus @ int @ T2 @ ( one_one @ int ) ) @ B7 )
       => ! [X5: int] :
            ( ! [Xa3: int] :
                ( ( member @ int @ Xa3 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
               => ! [Xb3: int] :
                    ( ( member @ int @ Xb3 @ B7 )
                   => ( X5
                     != ( plus_plus @ int @ Xb3 @ Xa3 ) ) ) )
           => ( ( ord_less_eq @ int @ T2 @ X5 )
             => ( ord_less_eq @ int @ T2 @ ( minus_minus @ int @ X5 @ D5 ) ) ) ) ) ) ).

% bset(8)
thf(fact_4022_bset_I6_J,axiom,
    ! [D5: int,B7: set @ int,T2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D5 )
     => ! [X5: int] :
          ( ! [Xa3: int] :
              ( ( member @ int @ Xa3 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
             => ! [Xb3: int] :
                  ( ( member @ int @ Xb3 @ B7 )
                 => ( X5
                   != ( plus_plus @ int @ Xb3 @ Xa3 ) ) ) )
         => ( ( ord_less_eq @ int @ X5 @ T2 )
           => ( ord_less_eq @ int @ ( minus_minus @ int @ X5 @ D5 ) @ T2 ) ) ) ) ).

% bset(6)
thf(fact_4023_cppi,axiom,
    ! [D5: int,P: int > $o,P4: int > $o,A4: set @ int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D5 )
     => ( ? [Z4: int] :
          ! [X3: int] :
            ( ( ord_less @ int @ Z4 @ X3 )
           => ( ( P @ X3 )
              = ( P4 @ X3 ) ) )
       => ( ! [X3: int] :
              ( ! [Xa2: int] :
                  ( ( member @ int @ Xa2 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
                 => ! [Xb2: int] :
                      ( ( member @ int @ Xb2 @ A4 )
                     => ( X3
                       != ( minus_minus @ int @ Xb2 @ Xa2 ) ) ) )
             => ( ( P @ X3 )
               => ( P @ ( plus_plus @ int @ X3 @ D5 ) ) ) )
         => ( ! [X3: int,K2: int] :
                ( ( P4 @ X3 )
                = ( P4 @ ( minus_minus @ int @ X3 @ ( times_times @ int @ K2 @ D5 ) ) ) )
           => ( ( ? [X8: int] : ( P @ X8 ) )
              = ( ? [X2: int] :
                    ( ( member @ int @ X2 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
                    & ( P4 @ X2 ) )
                | ? [X2: int] :
                    ( ( member @ int @ X2 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
                    & ? [Y4: int] :
                        ( ( member @ int @ Y4 @ A4 )
                        & ( P @ ( minus_minus @ int @ Y4 @ X2 ) ) ) ) ) ) ) ) ) ) ).

% cppi
thf(fact_4024_cpmi,axiom,
    ! [D5: int,P: int > $o,P4: int > $o,B7: set @ int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ D5 )
     => ( ? [Z4: int] :
          ! [X3: int] :
            ( ( ord_less @ int @ X3 @ Z4 )
           => ( ( P @ X3 )
              = ( P4 @ X3 ) ) )
       => ( ! [X3: int] :
              ( ! [Xa2: int] :
                  ( ( member @ int @ Xa2 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
                 => ! [Xb2: int] :
                      ( ( member @ int @ Xb2 @ B7 )
                     => ( X3
                       != ( plus_plus @ int @ Xb2 @ Xa2 ) ) ) )
             => ( ( P @ X3 )
               => ( P @ ( minus_minus @ int @ X3 @ D5 ) ) ) )
         => ( ! [X3: int,K2: int] :
                ( ( P4 @ X3 )
                = ( P4 @ ( minus_minus @ int @ X3 @ ( times_times @ int @ K2 @ D5 ) ) ) )
           => ( ( ? [X8: int] : ( P @ X8 ) )
              = ( ? [X2: int] :
                    ( ( member @ int @ X2 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
                    & ( P4 @ X2 ) )
                | ? [X2: int] :
                    ( ( member @ int @ X2 @ ( set_or1337092689740270186AtMost @ int @ ( one_one @ int ) @ D5 ) )
                    & ? [Y4: int] :
                        ( ( member @ int @ Y4 @ B7 )
                        & ( P @ ( plus_plus @ int @ Y4 @ X2 ) ) ) ) ) ) ) ) ) ) ).

% cpmi
thf(fact_4025_divmod__divmod__step,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ( ( unique8689654367752047608divmod @ A )
        = ( ^ [M3: num,N3: num] : ( if @ ( product_prod @ A @ A ) @ ( ord_less @ num @ M3 @ N3 ) @ ( product_Pair @ A @ A @ ( zero_zero @ A ) @ ( numeral_numeral @ A @ M3 ) ) @ ( unique1321980374590559556d_step @ A @ N3 @ ( unique8689654367752047608divmod @ A @ M3 @ ( bit0 @ N3 ) ) ) ) ) ) ) ).

% divmod_divmod_step
thf(fact_4026_minus__one__div__numeral,axiom,
    ! [N: num] :
      ( ( divide_divide @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( numeral_numeral @ int @ N ) )
      = ( uminus_uminus @ int @ ( adjust_div @ ( unique8689654367752047608divmod @ int @ one2 @ N ) ) ) ) ).

% minus_one_div_numeral
thf(fact_4027_one__div__minus__numeral,axiom,
    ! [N: num] :
      ( ( divide_divide @ int @ ( one_one @ int ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N ) ) )
      = ( uminus_uminus @ int @ ( adjust_div @ ( unique8689654367752047608divmod @ int @ one2 @ N ) ) ) ) ).

% one_div_minus_numeral
thf(fact_4028_neg__eucl__rel__int__mult__2,axiom,
    ! [B2: int,A2: int,Q3: int,R2: int] :
      ( ( ord_less_eq @ int @ B2 @ ( zero_zero @ int ) )
     => ( ( eucl_rel_int @ ( plus_plus @ int @ A2 @ ( one_one @ int ) ) @ B2 @ ( product_Pair @ int @ int @ Q3 @ R2 ) )
       => ( eucl_rel_int @ ( plus_plus @ int @ ( one_one @ int ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ A2 ) ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ B2 ) @ ( product_Pair @ int @ int @ Q3 @ ( minus_minus @ int @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ R2 ) @ ( one_one @ int ) ) ) ) ) ) ).

% neg_eucl_rel_int_mult_2
thf(fact_4029_Divides_Oadjust__div__eq,axiom,
    ! [Q3: int,R2: int] :
      ( ( adjust_div @ ( product_Pair @ int @ int @ Q3 @ R2 ) )
      = ( plus_plus @ int @ Q3
        @ ( zero_neq_one_of_bool @ int
          @ ( R2
           != ( zero_zero @ int ) ) ) ) ) ).

% Divides.adjust_div_eq
thf(fact_4030_minus__numeral__div__numeral,axiom,
    ! [M: num,N: num] :
      ( ( divide_divide @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ M ) ) @ ( numeral_numeral @ int @ N ) )
      = ( uminus_uminus @ int @ ( adjust_div @ ( unique8689654367752047608divmod @ int @ M @ N ) ) ) ) ).

% minus_numeral_div_numeral
thf(fact_4031_numeral__div__minus__numeral,axiom,
    ! [M: num,N: num] :
      ( ( divide_divide @ int @ ( numeral_numeral @ int @ M ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N ) ) )
      = ( uminus_uminus @ int @ ( adjust_div @ ( unique8689654367752047608divmod @ int @ M @ N ) ) ) ) ).

% numeral_div_minus_numeral
thf(fact_4032_eucl__rel__int__by0,axiom,
    ! [K: int] : ( eucl_rel_int @ K @ ( zero_zero @ int ) @ ( product_Pair @ int @ int @ ( zero_zero @ int ) @ K ) ) ).

% eucl_rel_int_by0
thf(fact_4033_eucl__rel__int__dividesI,axiom,
    ! [L: int,K: int,Q3: int] :
      ( ( L
       != ( zero_zero @ int ) )
     => ( ( K
          = ( times_times @ int @ Q3 @ L ) )
       => ( eucl_rel_int @ K @ L @ ( product_Pair @ int @ int @ Q3 @ ( zero_zero @ int ) ) ) ) ) ).

% eucl_rel_int_dividesI
thf(fact_4034_zminus1__lemma,axiom,
    ! [A2: int,B2: int,Q3: int,R2: int] :
      ( ( eucl_rel_int @ A2 @ B2 @ ( product_Pair @ int @ int @ Q3 @ R2 ) )
     => ( ( B2
         != ( zero_zero @ int ) )
       => ( eucl_rel_int @ ( uminus_uminus @ int @ A2 ) @ B2
          @ ( product_Pair @ int @ int
            @ ( if @ int
              @ ( R2
                = ( zero_zero @ int ) )
              @ ( uminus_uminus @ int @ Q3 )
              @ ( minus_minus @ int @ ( uminus_uminus @ int @ Q3 ) @ ( one_one @ int ) ) )
            @ ( if @ int
              @ ( R2
                = ( zero_zero @ int ) )
              @ ( zero_zero @ int )
              @ ( minus_minus @ int @ B2 @ R2 ) ) ) ) ) ) ).

% zminus1_lemma
thf(fact_4035_eucl__rel__int__iff,axiom,
    ! [K: int,L: int,Q3: int,R2: int] :
      ( ( eucl_rel_int @ K @ L @ ( product_Pair @ int @ int @ Q3 @ R2 ) )
      = ( ( K
          = ( plus_plus @ int @ ( times_times @ int @ L @ Q3 ) @ R2 ) )
        & ( ( ord_less @ int @ ( zero_zero @ int ) @ L )
         => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ R2 )
            & ( ord_less @ int @ R2 @ L ) ) )
        & ( ~ ( ord_less @ int @ ( zero_zero @ int ) @ L )
         => ( ( ( ord_less @ int @ L @ ( zero_zero @ int ) )
             => ( ( ord_less @ int @ L @ R2 )
                & ( ord_less_eq @ int @ R2 @ ( zero_zero @ int ) ) ) )
            & ( ~ ( ord_less @ int @ L @ ( zero_zero @ int ) )
             => ( Q3
                = ( zero_zero @ int ) ) ) ) ) ) ) ).

% eucl_rel_int_iff
thf(fact_4036_eucl__rel__int__remainderI,axiom,
    ! [R2: int,L: int,K: int,Q3: int] :
      ( ( ( sgn_sgn @ int @ R2 )
        = ( sgn_sgn @ int @ L ) )
     => ( ( ord_less @ int @ ( abs_abs @ int @ R2 ) @ ( abs_abs @ int @ L ) )
       => ( ( K
            = ( plus_plus @ int @ ( times_times @ int @ Q3 @ L ) @ R2 ) )
         => ( eucl_rel_int @ K @ L @ ( product_Pair @ int @ int @ Q3 @ R2 ) ) ) ) ) ).

% eucl_rel_int_remainderI
thf(fact_4037_eucl__rel__int_Ocases,axiom,
    ! [A12: int,A23: int,A32: product_prod @ int @ int] :
      ( ( eucl_rel_int @ A12 @ A23 @ A32 )
     => ( ( ( A23
            = ( zero_zero @ int ) )
         => ( A32
           != ( product_Pair @ int @ int @ ( zero_zero @ int ) @ A12 ) ) )
       => ( ! [Q5: int] :
              ( ( A32
                = ( product_Pair @ int @ int @ Q5 @ ( zero_zero @ int ) ) )
             => ( ( A23
                 != ( zero_zero @ int ) )
               => ( A12
                 != ( times_times @ int @ Q5 @ A23 ) ) ) )
         => ~ ! [R: int,Q5: int] :
                ( ( A32
                  = ( product_Pair @ int @ int @ Q5 @ R ) )
               => ( ( ( sgn_sgn @ int @ R )
                    = ( sgn_sgn @ int @ A23 ) )
                 => ( ( ord_less @ int @ ( abs_abs @ int @ R ) @ ( abs_abs @ int @ A23 ) )
                   => ( A12
                     != ( plus_plus @ int @ ( times_times @ int @ Q5 @ A23 ) @ R ) ) ) ) ) ) ) ) ).

% eucl_rel_int.cases
thf(fact_4038_eucl__rel__int_Osimps,axiom,
    ( eucl_rel_int
    = ( ^ [A1: int,A22: int,A33: product_prod @ int @ int] :
          ( ? [K3: int] :
              ( ( A1 = K3 )
              & ( A22
                = ( zero_zero @ int ) )
              & ( A33
                = ( product_Pair @ int @ int @ ( zero_zero @ int ) @ K3 ) ) )
          | ? [L2: int,K3: int,Q6: int] :
              ( ( A1 = K3 )
              & ( A22 = L2 )
              & ( A33
                = ( product_Pair @ int @ int @ Q6 @ ( zero_zero @ int ) ) )
              & ( L2
               != ( zero_zero @ int ) )
              & ( K3
                = ( times_times @ int @ Q6 @ L2 ) ) )
          | ? [R5: int,L2: int,K3: int,Q6: int] :
              ( ( A1 = K3 )
              & ( A22 = L2 )
              & ( A33
                = ( product_Pair @ int @ int @ Q6 @ R5 ) )
              & ( ( sgn_sgn @ int @ R5 )
                = ( sgn_sgn @ int @ L2 ) )
              & ( ord_less @ int @ ( abs_abs @ int @ R5 ) @ ( abs_abs @ int @ L2 ) )
              & ( K3
                = ( plus_plus @ int @ ( times_times @ int @ Q6 @ L2 ) @ R5 ) ) ) ) ) ) ).

% eucl_rel_int.simps
thf(fact_4039_pos__eucl__rel__int__mult__2,axiom,
    ! [B2: int,A2: int,Q3: int,R2: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ B2 )
     => ( ( eucl_rel_int @ A2 @ B2 @ ( product_Pair @ int @ int @ Q3 @ R2 ) )
       => ( eucl_rel_int @ ( plus_plus @ int @ ( one_one @ int ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ A2 ) ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ B2 ) @ ( product_Pair @ int @ int @ Q3 @ ( plus_plus @ int @ ( one_one @ int ) @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ R2 ) ) ) ) ) ) ).

% pos_eucl_rel_int_mult_2
thf(fact_4040_option_Osize_I3_J,axiom,
    ! [A: $tType] :
      ( ( size_size @ ( option @ A ) @ ( none @ A ) )
      = ( suc @ ( zero_zero @ nat ) ) ) ).

% option.size(3)
thf(fact_4041_option_Osize_I4_J,axiom,
    ! [A: $tType,X22: A] :
      ( ( size_size @ ( option @ A ) @ ( some @ A @ X22 ) )
      = ( suc @ ( zero_zero @ nat ) ) ) ).

% option.size(4)
thf(fact_4042_vebt__insert_Oelims,axiom,
    ! [X: vEBT_VEBT,Xa: nat,Y: vEBT_VEBT] :
      ( ( ( vEBT_vebt_insert @ X @ Xa )
        = Y )
     => ( ! [A5: $o,B4: $o] :
            ( ( X
              = ( vEBT_Leaf @ A5 @ B4 ) )
           => ~ ( ( ( Xa
                    = ( zero_zero @ nat ) )
                 => ( Y
                    = ( vEBT_Leaf @ $true @ B4 ) ) )
                & ( ( Xa
                   != ( zero_zero @ nat ) )
                 => ( ( ( Xa
                        = ( one_one @ nat ) )
                     => ( Y
                        = ( vEBT_Leaf @ A5 @ $true ) ) )
                    & ( ( Xa
                       != ( one_one @ nat ) )
                     => ( Y
                        = ( vEBT_Leaf @ A5 @ B4 ) ) ) ) ) ) )
       => ( ! [Info2: option @ ( product_prod @ nat @ nat ),Ts2: list @ vEBT_VEBT,S3: vEBT_VEBT] :
              ( ( X
                = ( vEBT_Node @ Info2 @ ( zero_zero @ nat ) @ Ts2 @ S3 ) )
             => ( Y
               != ( vEBT_Node @ Info2 @ ( zero_zero @ nat ) @ Ts2 @ S3 ) ) )
         => ( ! [Info2: option @ ( product_prod @ nat @ nat ),Ts2: list @ vEBT_VEBT,S3: vEBT_VEBT] :
                ( ( X
                  = ( vEBT_Node @ Info2 @ ( suc @ ( zero_zero @ nat ) ) @ Ts2 @ S3 ) )
               => ( Y
                 != ( vEBT_Node @ Info2 @ ( suc @ ( zero_zero @ nat ) ) @ Ts2 @ S3 ) ) )
           => ( ! [V4: nat,TreeList3: list @ vEBT_VEBT,Summary3: vEBT_VEBT] :
                  ( ( X
                    = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ ( suc @ V4 ) ) @ TreeList3 @ Summary3 ) )
                 => ( Y
                   != ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Xa @ Xa ) ) @ ( suc @ ( suc @ V4 ) ) @ TreeList3 @ Summary3 ) ) )
             => ~ ! [Mi3: nat,Ma3: nat,Va: nat,TreeList3: list @ vEBT_VEBT,Summary3: vEBT_VEBT] :
                    ( ( X
                      = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi3 @ Ma3 ) ) @ ( suc @ ( suc @ Va ) ) @ TreeList3 @ Summary3 ) )
                   => ( Y
                     != ( if @ vEBT_VEBT
                        @ ( ( ord_less @ nat @ ( vEBT_VEBT_high @ ( if @ nat @ ( ord_less @ nat @ Xa @ Mi3 ) @ Mi3 @ Xa ) @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) )
                          & ~ ( ( Xa = Mi3 )
                              | ( Xa = Ma3 ) ) )
                        @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ ( if @ nat @ ( ord_less @ nat @ Xa @ Mi3 ) @ Xa @ Mi3 ) @ ( ord_max @ nat @ ( if @ nat @ ( ord_less @ nat @ Xa @ Mi3 ) @ Mi3 @ Xa ) @ Ma3 ) ) ) @ ( suc @ ( suc @ Va ) ) @ ( list_update @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ ( if @ nat @ ( ord_less @ nat @ Xa @ Mi3 ) @ Mi3 @ Xa ) @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( vEBT_vebt_insert @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ ( if @ nat @ ( ord_less @ nat @ Xa @ Mi3 ) @ Mi3 @ Xa ) @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ ( if @ nat @ ( ord_less @ nat @ Xa @ Mi3 ) @ Mi3 @ Xa ) @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) @ ( if @ vEBT_VEBT @ ( vEBT_VEBT_minNull @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ ( if @ nat @ ( ord_less @ nat @ Xa @ Mi3 ) @ Mi3 @ Xa ) @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) @ ( vEBT_vebt_insert @ Summary3 @ ( vEBT_VEBT_high @ ( if @ nat @ ( ord_less @ nat @ Xa @ Mi3 ) @ Mi3 @ Xa ) @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ Summary3 ) )
                        @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi3 @ Ma3 ) ) @ ( suc @ ( suc @ Va ) ) @ TreeList3 @ Summary3 ) ) ) ) ) ) ) ) ) ).

% vebt_insert.elims
thf(fact_4043_buildup__gives__empty,axiom,
    ! [N: nat] :
      ( ( vEBT_VEBT_set_vebt @ ( vEBT_vebt_buildup @ N ) )
      = ( bot_bot @ ( set @ nat ) ) ) ).

% buildup_gives_empty
thf(fact_4044_set__vebt_H__def,axiom,
    ( vEBT_VEBT_set_vebt
    = ( ^ [T3: vEBT_VEBT] : ( collect @ nat @ ( vEBT_vebt_member @ T3 ) ) ) ) ).

% set_vebt'_def
thf(fact_4045_bot__apply,axiom,
    ! [C: $tType,D: $tType] :
      ( ( bot @ C )
     => ( ( bot_bot @ ( D > C ) )
        = ( ^ [X2: D] : ( bot_bot @ C ) ) ) ) ).

% bot_apply
thf(fact_4046_max__bot,axiom,
    ! [A: $tType] :
      ( ( order_bot @ A )
     => ! [X: A] :
          ( ( ord_max @ A @ ( bot_bot @ A ) @ X )
          = X ) ) ).

% max_bot
thf(fact_4047_max__bot2,axiom,
    ! [A: $tType] :
      ( ( order_bot @ A )
     => ! [X: A] :
          ( ( ord_max @ A @ X @ ( bot_bot @ A ) )
          = X ) ) ).

% max_bot2
thf(fact_4048_atLeastatMost__empty__iff2,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ( bot_bot @ ( set @ A ) )
            = ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) )
          = ( ~ ( ord_less_eq @ A @ A2 @ B2 ) ) ) ) ).

% atLeastatMost_empty_iff2
thf(fact_4049_atLeastatMost__empty__iff,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ( set_or1337092689740270186AtMost @ A @ A2 @ B2 )
            = ( bot_bot @ ( set @ A ) ) )
          = ( ~ ( ord_less_eq @ A @ A2 @ B2 ) ) ) ) ).

% atLeastatMost_empty_iff
thf(fact_4050_atLeastatMost__empty,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less @ A @ B2 @ A2 )
         => ( ( set_or1337092689740270186AtMost @ A @ A2 @ B2 )
            = ( bot_bot @ ( set @ A ) ) ) ) ) ).

% atLeastatMost_empty
thf(fact_4051_set__decode__zero,axiom,
    ( ( nat_set_decode @ ( zero_zero @ nat ) )
    = ( bot_bot @ ( set @ nat ) ) ) ).

% set_decode_zero
thf(fact_4052_bot__fun__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( bot @ B )
     => ( ( bot_bot @ ( A > B ) )
        = ( ^ [X2: A] : ( bot_bot @ B ) ) ) ) ).

% bot_fun_def
thf(fact_4053_lambda__zero,axiom,
    ! [A: $tType] :
      ( ( mult_zero @ A )
     => ( ( ^ [H: A] : ( zero_zero @ A ) )
        = ( times_times @ A @ ( zero_zero @ A ) ) ) ) ).

% lambda_zero
thf(fact_4054_numeral__code_I2_J,axiom,
    ! [A: $tType] :
      ( ( numeral @ A )
     => ! [N: num] :
          ( ( numeral_numeral @ A @ ( bit0 @ N ) )
          = ( plus_plus @ A @ ( numeral_numeral @ A @ N ) @ ( numeral_numeral @ A @ N ) ) ) ) ).

% numeral_code(2)
thf(fact_4055_nat__less__as__int,axiom,
    ( ( ord_less @ nat )
    = ( ^ [A3: nat,B3: nat] : ( ord_less @ int @ ( semiring_1_of_nat @ int @ A3 ) @ ( semiring_1_of_nat @ int @ B3 ) ) ) ) ).

% nat_less_as_int
thf(fact_4056_nat__leq__as__int,axiom,
    ( ( ord_less_eq @ nat )
    = ( ^ [A3: nat,B3: nat] : ( ord_less_eq @ int @ ( semiring_1_of_nat @ int @ A3 ) @ ( semiring_1_of_nat @ int @ B3 ) ) ) ) ).

% nat_leq_as_int
thf(fact_4057_bot_Oextremum__uniqueI,axiom,
    ! [A: $tType] :
      ( ( order_bot @ A )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ A2 @ ( bot_bot @ A ) )
         => ( A2
            = ( bot_bot @ A ) ) ) ) ).

% bot.extremum_uniqueI
thf(fact_4058_bot_Oextremum__unique,axiom,
    ! [A: $tType] :
      ( ( order_bot @ A )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ A2 @ ( bot_bot @ A ) )
          = ( A2
            = ( bot_bot @ A ) ) ) ) ).

% bot.extremum_unique
thf(fact_4059_bot_Oextremum,axiom,
    ! [A: $tType] :
      ( ( order_bot @ A )
     => ! [A2: A] : ( ord_less_eq @ A @ ( bot_bot @ A ) @ A2 ) ) ).

% bot.extremum
thf(fact_4060_max__def__raw,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ( ( ord_max @ A )
        = ( ^ [A3: A,B3: A] : ( if @ A @ ( ord_less_eq @ A @ A3 @ B3 ) @ B3 @ A3 ) ) ) ) ).

% max_def_raw
thf(fact_4061_bot_Onot__eq__extremum,axiom,
    ! [A: $tType] :
      ( ( order_bot @ A )
     => ! [A2: A] :
          ( ( ( A2
             != ( bot_bot @ A ) ) )
          = ( ord_less @ A @ ( bot_bot @ A ) @ A2 ) ) ) ).

% bot.not_eq_extremum
thf(fact_4062_bot_Oextremum__strict,axiom,
    ! [A: $tType] :
      ( ( order_bot @ A )
     => ! [A2: A] :
          ~ ( ord_less @ A @ A2 @ ( bot_bot @ A ) ) ) ).

% bot.extremum_strict
thf(fact_4063_numeral__code_I3_J,axiom,
    ! [A: $tType] :
      ( ( numeral @ A )
     => ! [N: num] :
          ( ( numeral_numeral @ A @ ( bit1 @ N ) )
          = ( plus_plus @ A @ ( plus_plus @ A @ ( numeral_numeral @ A @ N ) @ ( numeral_numeral @ A @ N ) ) @ ( one_one @ A ) ) ) ) ).

% numeral_code(3)
thf(fact_4064_power__numeral__even,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [Z: A,W: num] :
          ( ( power_power @ A @ Z @ ( numeral_numeral @ nat @ ( bit0 @ W ) ) )
          = ( times_times @ A @ ( power_power @ A @ Z @ ( numeral_numeral @ nat @ W ) ) @ ( power_power @ A @ Z @ ( numeral_numeral @ nat @ W ) ) ) ) ) ).

% power_numeral_even
thf(fact_4065_power__numeral__odd,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [Z: A,W: num] :
          ( ( power_power @ A @ Z @ ( numeral_numeral @ nat @ ( bit1 @ W ) ) )
          = ( times_times @ A @ ( times_times @ A @ Z @ ( power_power @ A @ Z @ ( numeral_numeral @ nat @ W ) ) ) @ ( power_power @ A @ Z @ ( numeral_numeral @ nat @ W ) ) ) ) ) ).

% power_numeral_odd
thf(fact_4066_nat__plus__as__int,axiom,
    ( ( plus_plus @ nat )
    = ( ^ [A3: nat,B3: nat] : ( nat2 @ ( plus_plus @ int @ ( semiring_1_of_nat @ int @ A3 ) @ ( semiring_1_of_nat @ int @ B3 ) ) ) ) ) ).

% nat_plus_as_int
thf(fact_4067_nat__times__as__int,axiom,
    ( ( times_times @ nat )
    = ( ^ [A3: nat,B3: nat] : ( nat2 @ ( times_times @ int @ ( semiring_1_of_nat @ int @ A3 ) @ ( semiring_1_of_nat @ int @ B3 ) ) ) ) ) ).

% nat_times_as_int
thf(fact_4068_nat__minus__as__int,axiom,
    ( ( minus_minus @ nat )
    = ( ^ [A3: nat,B3: nat] : ( nat2 @ ( minus_minus @ int @ ( semiring_1_of_nat @ int @ A3 ) @ ( semiring_1_of_nat @ int @ B3 ) ) ) ) ) ).

% nat_minus_as_int
thf(fact_4069_nat__div__as__int,axiom,
    ( ( divide_divide @ nat )
    = ( ^ [A3: nat,B3: nat] : ( nat2 @ ( divide_divide @ int @ ( semiring_1_of_nat @ int @ A3 ) @ ( semiring_1_of_nat @ int @ B3 ) ) ) ) ) ).

% nat_div_as_int
thf(fact_4070_nat__mod__as__int,axiom,
    ( ( modulo_modulo @ nat )
    = ( ^ [A3: nat,B3: nat] : ( nat2 @ ( modulo_modulo @ int @ ( semiring_1_of_nat @ int @ A3 ) @ ( semiring_1_of_nat @ int @ B3 ) ) ) ) ) ).

% nat_mod_as_int
thf(fact_4071_diff__shunt__var,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [X: A,Y: A] :
          ( ( ( minus_minus @ A @ X @ Y )
            = ( bot_bot @ A ) )
          = ( ord_less_eq @ A @ X @ Y ) ) ) ).

% diff_shunt_var
thf(fact_4072_diff__nat__eq__if,axiom,
    ! [Z5: int,Z: int] :
      ( ( ( ord_less @ int @ Z5 @ ( zero_zero @ int ) )
       => ( ( minus_minus @ nat @ ( nat2 @ Z ) @ ( nat2 @ Z5 ) )
          = ( nat2 @ Z ) ) )
      & ( ~ ( ord_less @ int @ Z5 @ ( zero_zero @ int ) )
       => ( ( minus_minus @ nat @ ( nat2 @ Z ) @ ( nat2 @ Z5 ) )
          = ( if @ nat @ ( ord_less @ int @ ( minus_minus @ int @ Z @ Z5 ) @ ( zero_zero @ int ) ) @ ( zero_zero @ nat ) @ ( nat2 @ ( minus_minus @ int @ Z @ Z5 ) ) ) ) ) ) ).

% diff_nat_eq_if
thf(fact_4073_set__decode__def,axiom,
    ( nat_set_decode
    = ( ^ [X2: nat] :
          ( collect @ nat
          @ ^ [N3: nat] :
              ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( divide_divide @ nat @ X2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N3 ) ) ) ) ) ) ).

% set_decode_def
thf(fact_4074_option_Osize__neq,axiom,
    ! [A: $tType,X: option @ A] :
      ( ( size_size @ ( option @ A ) @ X )
     != ( zero_zero @ nat ) ) ).

% option.size_neq
thf(fact_4075_signed__take__bit__code,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( ( bit_ri4674362597316999326ke_bit @ A )
        = ( ^ [N3: nat,A3: A] : ( if @ A @ ( bit_se5641148757651400278ts_bit @ A @ ( bit_se2584673776208193580ke_bit @ A @ ( suc @ N3 ) @ A3 ) @ N3 ) @ ( plus_plus @ A @ ( bit_se2584673776208193580ke_bit @ A @ ( suc @ N3 ) @ A3 ) @ ( bit_se4730199178511100633sh_bit @ A @ ( suc @ N3 ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) @ ( bit_se2584673776208193580ke_bit @ A @ ( suc @ N3 ) @ A3 ) ) ) ) ) ).

% signed_take_bit_code
thf(fact_4076_pochhammer__code,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ( ( comm_s3205402744901411588hammer @ A )
        = ( ^ [A3: A,N3: nat] :
              ( if @ A
              @ ( N3
                = ( zero_zero @ nat ) )
              @ ( one_one @ A )
              @ ( set_fo6178422350223883121st_nat @ A
                @ ^ [O: nat] : ( times_times @ A @ ( plus_plus @ A @ A3 @ ( semiring_1_of_nat @ A @ O ) ) )
                @ ( zero_zero @ nat )
                @ ( minus_minus @ nat @ N3 @ ( one_one @ nat ) )
                @ ( one_one @ A ) ) ) ) ) ) ).

% pochhammer_code
thf(fact_4077_gbinomial__code,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ( ( gbinomial @ A )
        = ( ^ [A3: A,K3: nat] :
              ( if @ A
              @ ( K3
                = ( zero_zero @ nat ) )
              @ ( one_one @ A )
              @ ( divide_divide @ A
                @ ( set_fo6178422350223883121st_nat @ A
                  @ ^ [L2: nat] : ( times_times @ A @ ( minus_minus @ A @ A3 @ ( semiring_1_of_nat @ A @ L2 ) ) )
                  @ ( zero_zero @ nat )
                  @ ( minus_minus @ nat @ K3 @ ( one_one @ nat ) )
                  @ ( one_one @ A ) )
                @ ( semiring_char_0_fact @ A @ K3 ) ) ) ) ) ) ).

% gbinomial_code
thf(fact_4078_VEBT__internal_Onaive__member_Osimps_I3_J,axiom,
    ! [Uy2: option @ ( product_prod @ nat @ nat ),V: nat,TreeList2: list @ vEBT_VEBT,S2: vEBT_VEBT,X: nat] :
      ( ( vEBT_V5719532721284313246member @ ( vEBT_Node @ Uy2 @ ( suc @ V ) @ TreeList2 @ S2 ) @ X )
      = ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ X @ ( divide_divide @ nat @ ( suc @ V ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 ) )
         => ( vEBT_V5719532721284313246member @ ( nth @ vEBT_VEBT @ TreeList2 @ ( vEBT_VEBT_high @ X @ ( divide_divide @ nat @ ( suc @ V ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ X @ ( divide_divide @ nat @ ( suc @ V ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
        & ( ord_less @ nat @ ( vEBT_VEBT_high @ X @ ( divide_divide @ nat @ ( suc @ V ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 ) ) ) ) ).

% VEBT_internal.naive_member.simps(3)
thf(fact_4079_VEBT__internal_Omembermima_Osimps_I5_J,axiom,
    ! [V: nat,TreeList2: list @ vEBT_VEBT,Vd2: vEBT_VEBT,X: nat] :
      ( ( vEBT_VEBT_membermima @ ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ V ) @ TreeList2 @ Vd2 ) @ X )
      = ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ X @ ( divide_divide @ nat @ ( suc @ V ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 ) )
         => ( vEBT_VEBT_membermima @ ( nth @ vEBT_VEBT @ TreeList2 @ ( vEBT_VEBT_high @ X @ ( divide_divide @ nat @ ( suc @ V ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ X @ ( divide_divide @ nat @ ( suc @ V ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
        & ( ord_less @ nat @ ( vEBT_VEBT_high @ X @ ( divide_divide @ nat @ ( suc @ V ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 ) ) ) ) ).

% VEBT_internal.membermima.simps(5)
thf(fact_4080_vebt__member_Osimps_I5_J,axiom,
    ! [Mi: nat,Ma: nat,Va3: nat,TreeList2: list @ vEBT_VEBT,Summary: vEBT_VEBT,X: nat] :
      ( ( vEBT_vebt_member @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi @ Ma ) ) @ ( suc @ ( suc @ Va3 ) ) @ TreeList2 @ Summary ) @ X )
      = ( ( X != Mi )
       => ( ( X != Ma )
         => ( ~ ( ord_less @ nat @ X @ Mi )
            & ( ~ ( ord_less @ nat @ X @ Mi )
             => ( ~ ( ord_less @ nat @ Ma @ X )
                & ( ~ ( ord_less @ nat @ Ma @ X )
                 => ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ X @ ( divide_divide @ nat @ ( suc @ ( suc @ Va3 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 ) )
                     => ( vEBT_vebt_member @ ( nth @ vEBT_VEBT @ TreeList2 @ ( vEBT_VEBT_high @ X @ ( divide_divide @ nat @ ( suc @ ( suc @ Va3 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ X @ ( divide_divide @ nat @ ( suc @ ( suc @ Va3 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                    & ( ord_less @ nat @ ( vEBT_VEBT_high @ X @ ( divide_divide @ nat @ ( suc @ ( suc @ Va3 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 ) ) ) ) ) ) ) ) ) ) ).

% vebt_member.simps(5)
thf(fact_4081_VEBT__internal_Omembermima_Osimps_I4_J,axiom,
    ! [Mi: nat,Ma: nat,V: nat,TreeList2: list @ vEBT_VEBT,Vc2: vEBT_VEBT,X: nat] :
      ( ( vEBT_VEBT_membermima @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi @ Ma ) ) @ ( suc @ V ) @ TreeList2 @ Vc2 ) @ X )
      = ( ( X = Mi )
        | ( X = Ma )
        | ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ X @ ( divide_divide @ nat @ ( suc @ V ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 ) )
           => ( vEBT_VEBT_membermima @ ( nth @ vEBT_VEBT @ TreeList2 @ ( vEBT_VEBT_high @ X @ ( divide_divide @ nat @ ( suc @ V ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ X @ ( divide_divide @ nat @ ( suc @ V ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
          & ( ord_less @ nat @ ( vEBT_VEBT_high @ X @ ( divide_divide @ nat @ ( suc @ V ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 ) ) ) ) ) ).

% VEBT_internal.membermima.simps(4)
thf(fact_4082_VEBT__internal_Onaive__member_Oelims_I1_J,axiom,
    ! [X: vEBT_VEBT,Xa: nat,Y: $o] :
      ( ( ( vEBT_V5719532721284313246member @ X @ Xa )
        = Y )
     => ( ! [A5: $o,B4: $o] :
            ( ( X
              = ( vEBT_Leaf @ A5 @ B4 ) )
           => ( Y
              = ( ~ ( ( ( Xa
                        = ( zero_zero @ nat ) )
                     => A5 )
                    & ( ( Xa
                       != ( zero_zero @ nat ) )
                     => ( ( ( Xa
                            = ( one_one @ nat ) )
                         => B4 )
                        & ( Xa
                          = ( one_one @ nat ) ) ) ) ) ) ) )
       => ( ( ? [Uu2: option @ ( product_prod @ nat @ nat ),Uv2: list @ vEBT_VEBT,Uw2: vEBT_VEBT] :
                ( X
                = ( vEBT_Node @ Uu2 @ ( zero_zero @ nat ) @ Uv2 @ Uw2 ) )
           => Y )
         => ~ ! [Uy: option @ ( product_prod @ nat @ nat ),V4: nat,TreeList3: list @ vEBT_VEBT] :
                ( ? [S3: vEBT_VEBT] :
                    ( X
                    = ( vEBT_Node @ Uy @ ( suc @ V4 ) @ TreeList3 @ S3 ) )
               => ( Y
                  = ( ~ ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) )
                         => ( vEBT_V5719532721284313246member @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                        & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) ) ) ) ) ) ) ) ) ).

% VEBT_internal.naive_member.elims(1)
thf(fact_4083_VEBT__internal_Onaive__member_Oelims_I2_J,axiom,
    ! [X: vEBT_VEBT,Xa: nat] :
      ( ( vEBT_V5719532721284313246member @ X @ Xa )
     => ( ! [A5: $o,B4: $o] :
            ( ( X
              = ( vEBT_Leaf @ A5 @ B4 ) )
           => ~ ( ( ( Xa
                    = ( zero_zero @ nat ) )
                 => A5 )
                & ( ( Xa
                   != ( zero_zero @ nat ) )
                 => ( ( ( Xa
                        = ( one_one @ nat ) )
                     => B4 )
                    & ( Xa
                      = ( one_one @ nat ) ) ) ) ) )
       => ~ ! [Uy: option @ ( product_prod @ nat @ nat ),V4: nat,TreeList3: list @ vEBT_VEBT] :
              ( ? [S3: vEBT_VEBT] :
                  ( X
                  = ( vEBT_Node @ Uy @ ( suc @ V4 ) @ TreeList3 @ S3 ) )
             => ~ ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) )
                   => ( vEBT_V5719532721284313246member @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                  & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) ) ) ) ) ) ).

% VEBT_internal.naive_member.elims(2)
thf(fact_4084_VEBT__internal_Onaive__member_Oelims_I3_J,axiom,
    ! [X: vEBT_VEBT,Xa: nat] :
      ( ~ ( vEBT_V5719532721284313246member @ X @ Xa )
     => ( ! [A5: $o,B4: $o] :
            ( ( X
              = ( vEBT_Leaf @ A5 @ B4 ) )
           => ( ( ( Xa
                  = ( zero_zero @ nat ) )
               => A5 )
              & ( ( Xa
                 != ( zero_zero @ nat ) )
               => ( ( ( Xa
                      = ( one_one @ nat ) )
                   => B4 )
                  & ( Xa
                    = ( one_one @ nat ) ) ) ) ) )
       => ( ! [Uu2: option @ ( product_prod @ nat @ nat ),Uv2: list @ vEBT_VEBT,Uw2: vEBT_VEBT] :
              ( X
             != ( vEBT_Node @ Uu2 @ ( zero_zero @ nat ) @ Uv2 @ Uw2 ) )
         => ~ ! [Uy: option @ ( product_prod @ nat @ nat ),V4: nat,TreeList3: list @ vEBT_VEBT] :
                ( ? [S3: vEBT_VEBT] :
                    ( X
                    = ( vEBT_Node @ Uy @ ( suc @ V4 ) @ TreeList3 @ S3 ) )
               => ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) )
                   => ( vEBT_V5719532721284313246member @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                  & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) ) ) ) ) ) ) ).

% VEBT_internal.naive_member.elims(3)
thf(fact_4085_VEBT__internal_Omembermima_Oelims_I2_J,axiom,
    ! [X: vEBT_VEBT,Xa: nat] :
      ( ( vEBT_VEBT_membermima @ X @ Xa )
     => ( ! [Mi3: nat,Ma3: nat] :
            ( ? [Va2: list @ vEBT_VEBT,Vb: vEBT_VEBT] :
                ( X
                = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi3 @ Ma3 ) ) @ ( zero_zero @ nat ) @ Va2 @ Vb ) )
           => ~ ( ( Xa = Mi3 )
                | ( Xa = Ma3 ) ) )
       => ( ! [Mi3: nat,Ma3: nat,V4: nat,TreeList3: list @ vEBT_VEBT] :
              ( ? [Vc: vEBT_VEBT] :
                  ( X
                  = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi3 @ Ma3 ) ) @ ( suc @ V4 ) @ TreeList3 @ Vc ) )
             => ~ ( ( Xa = Mi3 )
                  | ( Xa = Ma3 )
                  | ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) )
                     => ( vEBT_VEBT_membermima @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                    & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) ) ) ) )
         => ~ ! [V4: nat,TreeList3: list @ vEBT_VEBT] :
                ( ? [Vd: vEBT_VEBT] :
                    ( X
                    = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ V4 ) @ TreeList3 @ Vd ) )
               => ~ ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) )
                     => ( vEBT_VEBT_membermima @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                    & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) ) ) ) ) ) ) ).

% VEBT_internal.membermima.elims(2)
thf(fact_4086_vebt__member_Oelims_I2_J,axiom,
    ! [X: vEBT_VEBT,Xa: nat] :
      ( ( vEBT_vebt_member @ X @ Xa )
     => ( ! [A5: $o,B4: $o] :
            ( ( X
              = ( vEBT_Leaf @ A5 @ B4 ) )
           => ~ ( ( ( Xa
                    = ( zero_zero @ nat ) )
                 => A5 )
                & ( ( Xa
                   != ( zero_zero @ nat ) )
                 => ( ( ( Xa
                        = ( one_one @ nat ) )
                     => B4 )
                    & ( Xa
                      = ( one_one @ nat ) ) ) ) ) )
       => ~ ! [Mi3: nat,Ma3: nat,Va: nat,TreeList3: list @ vEBT_VEBT] :
              ( ? [Summary3: vEBT_VEBT] :
                  ( X
                  = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi3 @ Ma3 ) ) @ ( suc @ ( suc @ Va ) ) @ TreeList3 @ Summary3 ) )
             => ~ ( ( Xa != Mi3 )
                 => ( ( Xa != Ma3 )
                   => ( ~ ( ord_less @ nat @ Xa @ Mi3 )
                      & ( ~ ( ord_less @ nat @ Xa @ Mi3 )
                       => ( ~ ( ord_less @ nat @ Ma3 @ Xa )
                          & ( ~ ( ord_less @ nat @ Ma3 @ Xa )
                           => ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) )
                               => ( vEBT_vebt_member @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                              & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) ) ) ) ) ) ) ) ) ) ) ) ).

% vebt_member.elims(2)
thf(fact_4087_VEBT__internal_Omembermima_Oelims_I1_J,axiom,
    ! [X: vEBT_VEBT,Xa: nat,Y: $o] :
      ( ( ( vEBT_VEBT_membermima @ X @ Xa )
        = Y )
     => ( ( ? [Uu2: $o,Uv2: $o] :
              ( X
              = ( vEBT_Leaf @ Uu2 @ Uv2 ) )
         => Y )
       => ( ( ? [Ux2: list @ vEBT_VEBT,Uy: vEBT_VEBT] :
                ( X
                = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( zero_zero @ nat ) @ Ux2 @ Uy ) )
           => Y )
         => ( ! [Mi3: nat,Ma3: nat] :
                ( ? [Va2: list @ vEBT_VEBT,Vb: vEBT_VEBT] :
                    ( X
                    = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi3 @ Ma3 ) ) @ ( zero_zero @ nat ) @ Va2 @ Vb ) )
               => ( Y
                  = ( ~ ( ( Xa = Mi3 )
                        | ( Xa = Ma3 ) ) ) ) )
           => ( ! [Mi3: nat,Ma3: nat,V4: nat,TreeList3: list @ vEBT_VEBT] :
                  ( ? [Vc: vEBT_VEBT] :
                      ( X
                      = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi3 @ Ma3 ) ) @ ( suc @ V4 ) @ TreeList3 @ Vc ) )
                 => ( Y
                    = ( ~ ( ( Xa = Mi3 )
                          | ( Xa = Ma3 )
                          | ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) )
                             => ( vEBT_VEBT_membermima @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                            & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) ) ) ) ) ) )
             => ~ ! [V4: nat,TreeList3: list @ vEBT_VEBT] :
                    ( ? [Vd: vEBT_VEBT] :
                        ( X
                        = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ V4 ) @ TreeList3 @ Vd ) )
                   => ( Y
                      = ( ~ ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) )
                             => ( vEBT_VEBT_membermima @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                            & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) ) ) ) ) ) ) ) ) ) ) ).

% VEBT_internal.membermima.elims(1)
thf(fact_4088_VEBT__internal_Omembermima_Oelims_I3_J,axiom,
    ! [X: vEBT_VEBT,Xa: nat] :
      ( ~ ( vEBT_VEBT_membermima @ X @ Xa )
     => ( ! [Uu2: $o,Uv2: $o] :
            ( X
           != ( vEBT_Leaf @ Uu2 @ Uv2 ) )
       => ( ! [Ux2: list @ vEBT_VEBT,Uy: vEBT_VEBT] :
              ( X
             != ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( zero_zero @ nat ) @ Ux2 @ Uy ) )
         => ( ! [Mi3: nat,Ma3: nat] :
                ( ? [Va2: list @ vEBT_VEBT,Vb: vEBT_VEBT] :
                    ( X
                    = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi3 @ Ma3 ) ) @ ( zero_zero @ nat ) @ Va2 @ Vb ) )
               => ( ( Xa = Mi3 )
                  | ( Xa = Ma3 ) ) )
           => ( ! [Mi3: nat,Ma3: nat,V4: nat,TreeList3: list @ vEBT_VEBT] :
                  ( ? [Vc: vEBT_VEBT] :
                      ( X
                      = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi3 @ Ma3 ) ) @ ( suc @ V4 ) @ TreeList3 @ Vc ) )
                 => ( ( Xa = Mi3 )
                    | ( Xa = Ma3 )
                    | ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) )
                       => ( vEBT_VEBT_membermima @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                      & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) ) ) ) )
             => ~ ! [V4: nat,TreeList3: list @ vEBT_VEBT] :
                    ( ? [Vd: vEBT_VEBT] :
                        ( X
                        = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ V4 ) @ TreeList3 @ Vd ) )
                   => ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) )
                       => ( vEBT_VEBT_membermima @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                      & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) ) ) ) ) ) ) ) ) ).

% VEBT_internal.membermima.elims(3)
thf(fact_4089_vebt__insert_Osimps_I5_J,axiom,
    ! [Mi: nat,Ma: nat,Va3: nat,TreeList2: list @ vEBT_VEBT,Summary: vEBT_VEBT,X: nat] :
      ( ( vEBT_vebt_insert @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi @ Ma ) ) @ ( suc @ ( suc @ Va3 ) ) @ TreeList2 @ Summary ) @ X )
      = ( if @ vEBT_VEBT
        @ ( ( ord_less @ nat @ ( vEBT_VEBT_high @ ( if @ nat @ ( ord_less @ nat @ X @ Mi ) @ Mi @ X ) @ ( divide_divide @ nat @ ( suc @ ( suc @ Va3 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 ) )
          & ~ ( ( X = Mi )
              | ( X = Ma ) ) )
        @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ ( if @ nat @ ( ord_less @ nat @ X @ Mi ) @ X @ Mi ) @ ( ord_max @ nat @ ( if @ nat @ ( ord_less @ nat @ X @ Mi ) @ Mi @ X ) @ Ma ) ) ) @ ( suc @ ( suc @ Va3 ) ) @ ( list_update @ vEBT_VEBT @ TreeList2 @ ( vEBT_VEBT_high @ ( if @ nat @ ( ord_less @ nat @ X @ Mi ) @ Mi @ X ) @ ( divide_divide @ nat @ ( suc @ ( suc @ Va3 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( vEBT_vebt_insert @ ( nth @ vEBT_VEBT @ TreeList2 @ ( vEBT_VEBT_high @ ( if @ nat @ ( ord_less @ nat @ X @ Mi ) @ Mi @ X ) @ ( divide_divide @ nat @ ( suc @ ( suc @ Va3 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ ( if @ nat @ ( ord_less @ nat @ X @ Mi ) @ Mi @ X ) @ ( divide_divide @ nat @ ( suc @ ( suc @ Va3 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) @ ( if @ vEBT_VEBT @ ( vEBT_VEBT_minNull @ ( nth @ vEBT_VEBT @ TreeList2 @ ( vEBT_VEBT_high @ ( if @ nat @ ( ord_less @ nat @ X @ Mi ) @ Mi @ X ) @ ( divide_divide @ nat @ ( suc @ ( suc @ Va3 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) @ ( vEBT_vebt_insert @ Summary @ ( vEBT_VEBT_high @ ( if @ nat @ ( ord_less @ nat @ X @ Mi ) @ Mi @ X ) @ ( divide_divide @ nat @ ( suc @ ( suc @ Va3 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ Summary ) )
        @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi @ Ma ) ) @ ( suc @ ( suc @ Va3 ) ) @ TreeList2 @ Summary ) ) ) ).

% vebt_insert.simps(5)
thf(fact_4090_vebt__member_Oelims_I1_J,axiom,
    ! [X: vEBT_VEBT,Xa: nat,Y: $o] :
      ( ( ( vEBT_vebt_member @ X @ Xa )
        = Y )
     => ( ! [A5: $o,B4: $o] :
            ( ( X
              = ( vEBT_Leaf @ A5 @ B4 ) )
           => ( Y
              = ( ~ ( ( ( Xa
                        = ( zero_zero @ nat ) )
                     => A5 )
                    & ( ( Xa
                       != ( zero_zero @ nat ) )
                     => ( ( ( Xa
                            = ( one_one @ nat ) )
                         => B4 )
                        & ( Xa
                          = ( one_one @ nat ) ) ) ) ) ) ) )
       => ( ( ? [Uu2: nat,Uv2: list @ vEBT_VEBT,Uw2: vEBT_VEBT] :
                ( X
                = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ Uu2 @ Uv2 @ Uw2 ) )
           => Y )
         => ( ( ? [V4: product_prod @ nat @ nat,Uy: list @ vEBT_VEBT,Uz: vEBT_VEBT] :
                  ( X
                  = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ V4 ) @ ( zero_zero @ nat ) @ Uy @ Uz ) )
             => Y )
           => ( ( ? [V4: product_prod @ nat @ nat,Vb: list @ vEBT_VEBT,Vc: vEBT_VEBT] :
                    ( X
                    = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ V4 ) @ ( suc @ ( zero_zero @ nat ) ) @ Vb @ Vc ) )
               => Y )
             => ~ ! [Mi3: nat,Ma3: nat,Va: nat,TreeList3: list @ vEBT_VEBT] :
                    ( ? [Summary3: vEBT_VEBT] :
                        ( X
                        = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi3 @ Ma3 ) ) @ ( suc @ ( suc @ Va ) ) @ TreeList3 @ Summary3 ) )
                   => ( Y
                      = ( ~ ( ( Xa != Mi3 )
                           => ( ( Xa != Ma3 )
                             => ( ~ ( ord_less @ nat @ Xa @ Mi3 )
                                & ( ~ ( ord_less @ nat @ Xa @ Mi3 )
                                 => ( ~ ( ord_less @ nat @ Ma3 @ Xa )
                                    & ( ~ ( ord_less @ nat @ Ma3 @ Xa )
                                     => ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) )
                                         => ( vEBT_vebt_member @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                                        & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ).

% vebt_member.elims(1)
thf(fact_4091_vebt__member_Oelims_I3_J,axiom,
    ! [X: vEBT_VEBT,Xa: nat] :
      ( ~ ( vEBT_vebt_member @ X @ Xa )
     => ( ! [A5: $o,B4: $o] :
            ( ( X
              = ( vEBT_Leaf @ A5 @ B4 ) )
           => ( ( ( Xa
                  = ( zero_zero @ nat ) )
               => A5 )
              & ( ( Xa
                 != ( zero_zero @ nat ) )
               => ( ( ( Xa
                      = ( one_one @ nat ) )
                   => B4 )
                  & ( Xa
                    = ( one_one @ nat ) ) ) ) ) )
       => ( ! [Uu2: nat,Uv2: list @ vEBT_VEBT,Uw2: vEBT_VEBT] :
              ( X
             != ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ Uu2 @ Uv2 @ Uw2 ) )
         => ( ! [V4: product_prod @ nat @ nat,Uy: list @ vEBT_VEBT,Uz: vEBT_VEBT] :
                ( X
               != ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ V4 ) @ ( zero_zero @ nat ) @ Uy @ Uz ) )
           => ( ! [V4: product_prod @ nat @ nat,Vb: list @ vEBT_VEBT,Vc: vEBT_VEBT] :
                  ( X
                 != ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ V4 ) @ ( suc @ ( zero_zero @ nat ) ) @ Vb @ Vc ) )
             => ~ ! [Mi3: nat,Ma3: nat,Va: nat,TreeList3: list @ vEBT_VEBT] :
                    ( ? [Summary3: vEBT_VEBT] :
                        ( X
                        = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi3 @ Ma3 ) ) @ ( suc @ ( suc @ Va ) ) @ TreeList3 @ Summary3 ) )
                   => ( ( Xa != Mi3 )
                     => ( ( Xa != Ma3 )
                       => ( ~ ( ord_less @ nat @ Xa @ Mi3 )
                          & ( ~ ( ord_less @ nat @ Xa @ Mi3 )
                           => ( ~ ( ord_less @ nat @ Ma3 @ Xa )
                              & ( ~ ( ord_less @ nat @ Ma3 @ Xa )
                               => ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) )
                                   => ( vEBT_vebt_member @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                                  & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ).

% vebt_member.elims(3)
thf(fact_4092_of__int__code__if,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ( ( ring_1_of_int @ A )
        = ( ^ [K3: int] :
              ( if @ A
              @ ( K3
                = ( zero_zero @ int ) )
              @ ( zero_zero @ A )
              @ ( if @ A @ ( ord_less @ int @ K3 @ ( zero_zero @ int ) ) @ ( uminus_uminus @ A @ ( ring_1_of_int @ A @ ( uminus_uminus @ int @ K3 ) ) )
                @ ( if @ A
                  @ ( ( modulo_modulo @ int @ K3 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) )
                    = ( zero_zero @ int ) )
                  @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( ring_1_of_int @ A @ ( divide_divide @ int @ K3 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) )
                  @ ( plus_plus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( ring_1_of_int @ A @ ( divide_divide @ int @ K3 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) @ ( one_one @ A ) ) ) ) ) ) ) ) ).

% of_int_code_if
thf(fact_4093_monoseq__arctan__series,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( abs_abs @ real @ X ) @ ( one_one @ real ) )
     => ( topological_monoseq @ real
        @ ^ [N3: nat] : ( times_times @ real @ ( divide_divide @ real @ ( one_one @ real ) @ ( semiring_1_of_nat @ real @ ( plus_plus @ nat @ ( times_times @ nat @ N3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ nat ) ) ) ) @ ( power_power @ real @ X @ ( plus_plus @ nat @ ( times_times @ nat @ N3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ nat ) ) ) ) ) ) ).

% monoseq_arctan_series
thf(fact_4094_vebt__insert_Opelims,axiom,
    ! [X: vEBT_VEBT,Xa: nat,Y: vEBT_VEBT] :
      ( ( ( vEBT_vebt_insert @ X @ Xa )
        = Y )
     => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_vebt_insert_rel @ ( product_Pair @ vEBT_VEBT @ nat @ X @ Xa ) )
       => ( ! [A5: $o,B4: $o] :
              ( ( X
                = ( vEBT_Leaf @ A5 @ B4 ) )
             => ( ( ( ( Xa
                      = ( zero_zero @ nat ) )
                   => ( Y
                      = ( vEBT_Leaf @ $true @ B4 ) ) )
                  & ( ( Xa
                     != ( zero_zero @ nat ) )
                   => ( ( ( Xa
                          = ( one_one @ nat ) )
                       => ( Y
                          = ( vEBT_Leaf @ A5 @ $true ) ) )
                      & ( ( Xa
                         != ( one_one @ nat ) )
                       => ( Y
                          = ( vEBT_Leaf @ A5 @ B4 ) ) ) ) ) )
               => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_vebt_insert_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Leaf @ A5 @ B4 ) @ Xa ) ) ) )
         => ( ! [Info2: option @ ( product_prod @ nat @ nat ),Ts2: list @ vEBT_VEBT,S3: vEBT_VEBT] :
                ( ( X
                  = ( vEBT_Node @ Info2 @ ( zero_zero @ nat ) @ Ts2 @ S3 ) )
               => ( ( Y
                    = ( vEBT_Node @ Info2 @ ( zero_zero @ nat ) @ Ts2 @ S3 ) )
                 => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_vebt_insert_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ Info2 @ ( zero_zero @ nat ) @ Ts2 @ S3 ) @ Xa ) ) ) )
           => ( ! [Info2: option @ ( product_prod @ nat @ nat ),Ts2: list @ vEBT_VEBT,S3: vEBT_VEBT] :
                  ( ( X
                    = ( vEBT_Node @ Info2 @ ( suc @ ( zero_zero @ nat ) ) @ Ts2 @ S3 ) )
                 => ( ( Y
                      = ( vEBT_Node @ Info2 @ ( suc @ ( zero_zero @ nat ) ) @ Ts2 @ S3 ) )
                   => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_vebt_insert_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ Info2 @ ( suc @ ( zero_zero @ nat ) ) @ Ts2 @ S3 ) @ Xa ) ) ) )
             => ( ! [V4: nat,TreeList3: list @ vEBT_VEBT,Summary3: vEBT_VEBT] :
                    ( ( X
                      = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ ( suc @ V4 ) ) @ TreeList3 @ Summary3 ) )
                   => ( ( Y
                        = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Xa @ Xa ) ) @ ( suc @ ( suc @ V4 ) ) @ TreeList3 @ Summary3 ) )
                     => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_vebt_insert_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ ( suc @ V4 ) ) @ TreeList3 @ Summary3 ) @ Xa ) ) ) )
               => ~ ! [Mi3: nat,Ma3: nat,Va: nat,TreeList3: list @ vEBT_VEBT,Summary3: vEBT_VEBT] :
                      ( ( X
                        = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi3 @ Ma3 ) ) @ ( suc @ ( suc @ Va ) ) @ TreeList3 @ Summary3 ) )
                     => ( ( Y
                          = ( if @ vEBT_VEBT
                            @ ( ( ord_less @ nat @ ( vEBT_VEBT_high @ ( if @ nat @ ( ord_less @ nat @ Xa @ Mi3 ) @ Mi3 @ Xa ) @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) )
                              & ~ ( ( Xa = Mi3 )
                                  | ( Xa = Ma3 ) ) )
                            @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ ( if @ nat @ ( ord_less @ nat @ Xa @ Mi3 ) @ Xa @ Mi3 ) @ ( ord_max @ nat @ ( if @ nat @ ( ord_less @ nat @ Xa @ Mi3 ) @ Mi3 @ Xa ) @ Ma3 ) ) ) @ ( suc @ ( suc @ Va ) ) @ ( list_update @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ ( if @ nat @ ( ord_less @ nat @ Xa @ Mi3 ) @ Mi3 @ Xa ) @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( vEBT_vebt_insert @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ ( if @ nat @ ( ord_less @ nat @ Xa @ Mi3 ) @ Mi3 @ Xa ) @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ ( if @ nat @ ( ord_less @ nat @ Xa @ Mi3 ) @ Mi3 @ Xa ) @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) @ ( if @ vEBT_VEBT @ ( vEBT_VEBT_minNull @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ ( if @ nat @ ( ord_less @ nat @ Xa @ Mi3 ) @ Mi3 @ Xa ) @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) @ ( vEBT_vebt_insert @ Summary3 @ ( vEBT_VEBT_high @ ( if @ nat @ ( ord_less @ nat @ Xa @ Mi3 ) @ Mi3 @ Xa ) @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ Summary3 ) )
                            @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi3 @ Ma3 ) ) @ ( suc @ ( suc @ Va ) ) @ TreeList3 @ Summary3 ) ) )
                       => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_vebt_insert_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi3 @ Ma3 ) ) @ ( suc @ ( suc @ Va ) ) @ TreeList3 @ Summary3 ) @ Xa ) ) ) ) ) ) ) ) ) ) ).

% vebt_insert.pelims
thf(fact_4095_pochhammer__times__pochhammer__half,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [Z: A,N: nat] :
          ( ( times_times @ A @ ( comm_s3205402744901411588hammer @ A @ Z @ ( suc @ N ) ) @ ( comm_s3205402744901411588hammer @ A @ ( plus_plus @ A @ Z @ ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) @ ( suc @ N ) ) )
          = ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [K3: nat] : ( plus_plus @ A @ Z @ ( divide_divide @ A @ ( semiring_1_of_nat @ A @ K3 ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) )
            @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ ( plus_plus @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) @ ( one_one @ nat ) ) ) ) ) ) ).

% pochhammer_times_pochhammer_half
thf(fact_4096_bit__0__eq,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ( ( bit_se5641148757651400278ts_bit @ A @ ( zero_zero @ A ) )
        = ( bot_bot @ ( nat > $o ) ) ) ) ).

% bit_0_eq
thf(fact_4097_Ints__prod,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( comm_monoid_mult @ B )
        & ( ring_1 @ B ) )
     => ! [A4: set @ A,F2: A > B] :
          ( ! [X3: A] :
              ( ( member @ A @ X3 @ A4 )
             => ( member @ B @ ( F2 @ X3 ) @ ( ring_1_Ints @ B ) ) )
         => ( member @ B @ ( groups7121269368397514597t_prod @ A @ B @ F2 @ A4 ) @ ( ring_1_Ints @ B ) ) ) ) ).

% Ints_prod
thf(fact_4098_of__nat__prod,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [F2: B > nat,A4: set @ B] :
          ( ( semiring_1_of_nat @ A @ ( groups7121269368397514597t_prod @ B @ nat @ F2 @ A4 ) )
          = ( groups7121269368397514597t_prod @ B @ A
            @ ^ [X2: B] : ( semiring_1_of_nat @ A @ ( F2 @ X2 ) )
            @ A4 ) ) ) ).

% of_nat_prod
thf(fact_4099_of__int__prod,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [F2: B > int,A4: set @ B] :
          ( ( ring_1_of_int @ A @ ( groups7121269368397514597t_prod @ B @ int @ F2 @ A4 ) )
          = ( groups7121269368397514597t_prod @ B @ A
            @ ^ [X2: B] : ( ring_1_of_int @ A @ ( F2 @ X2 ) )
            @ A4 ) ) ) ).

% of_int_prod
thf(fact_4100_prod_Ocl__ivl__Suc,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [N: nat,M: nat,G: nat > A] :
          ( ( ( ord_less @ nat @ ( suc @ N ) @ M )
           => ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ ( suc @ N ) ) )
              = ( one_one @ A ) ) )
          & ( ~ ( ord_less @ nat @ ( suc @ N ) @ M )
           => ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ ( suc @ N ) ) )
              = ( times_times @ A @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) ) @ ( G @ ( suc @ N ) ) ) ) ) ) ) ).

% prod.cl_ivl_Suc
thf(fact_4101_bot__nat__def,axiom,
    ( ( bot_bot @ nat )
    = ( zero_zero @ nat ) ) ).

% bot_nat_def
thf(fact_4102_bot__enat__def,axiom,
    ( ( bot_bot @ extended_enat )
    = ( zero_zero @ extended_enat ) ) ).

% bot_enat_def
thf(fact_4103_norm__prod__le,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( comm_monoid_mult @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [F2: B > A,A4: set @ B] :
          ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( groups7121269368397514597t_prod @ B @ A @ F2 @ A4 ) )
          @ ( groups7121269368397514597t_prod @ B @ real
            @ ^ [A3: B] : ( real_V7770717601297561774m_norm @ A @ ( F2 @ A3 ) )
            @ A4 ) ) ) ).

% norm_prod_le
thf(fact_4104_prod_OatLeast0__atMost__Suc,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,N: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ ( suc @ N ) ) )
          = ( times_times @ A @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N ) ) @ ( G @ ( suc @ N ) ) ) ) ) ).

% prod.atLeast0_atMost_Suc
thf(fact_4105_prod_Onat__ivl__Suc_H,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [M: nat,N: nat,G: nat > A] :
          ( ( ord_less_eq @ nat @ M @ ( suc @ N ) )
         => ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ ( suc @ N ) ) )
            = ( times_times @ A @ ( G @ ( suc @ N ) ) @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) ) ) ) ) ) ).

% prod.nat_ivl_Suc'
thf(fact_4106_prod_OatLeast__Suc__atMost,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [M: nat,N: nat,G: nat > A] :
          ( ( ord_less_eq @ nat @ M @ N )
         => ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) )
            = ( times_times @ A @ ( G @ M ) @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ M ) @ N ) ) ) ) ) ) ).

% prod.atLeast_Suc_atMost
thf(fact_4107_prod_OSuc__reindex__ivl,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [M: nat,N: nat,G: nat > A] :
          ( ( ord_less_eq @ nat @ M @ N )
         => ( ( times_times @ A @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) ) @ ( G @ ( suc @ N ) ) )
            = ( times_times @ A @ ( G @ M )
              @ ( groups7121269368397514597t_prod @ nat @ A
                @ ^ [I4: nat] : ( G @ ( suc @ I4 ) )
                @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) ) ) ) ) ) ).

% prod.Suc_reindex_ivl
thf(fact_4108_fact__prod,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ( ( semiring_char_0_fact @ A )
        = ( ^ [N3: nat] :
              ( semiring_1_of_nat @ A
              @ ( groups7121269368397514597t_prod @ nat @ nat
                @ ^ [X2: nat] : X2
                @ ( set_or1337092689740270186AtMost @ nat @ ( one_one @ nat ) @ N3 ) ) ) ) ) ) ).

% fact_prod
thf(fact_4109_prod_Oub__add__nat,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [M: nat,N: nat,G: nat > A,P6: nat] :
          ( ( ord_less_eq @ nat @ M @ ( plus_plus @ nat @ N @ ( one_one @ nat ) ) )
         => ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ ( plus_plus @ nat @ N @ P6 ) ) )
            = ( times_times @ A @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) ) @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( plus_plus @ nat @ N @ ( one_one @ nat ) ) @ ( plus_plus @ nat @ N @ P6 ) ) ) ) ) ) ) ).

% prod.ub_add_nat
thf(fact_4110_fact__eq__fact__times,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less_eq @ nat @ N @ M )
     => ( ( semiring_char_0_fact @ nat @ M )
        = ( times_times @ nat @ ( semiring_char_0_fact @ nat @ N )
          @ ( groups7121269368397514597t_prod @ nat @ nat
            @ ^ [X2: nat] : X2
            @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ N ) @ M ) ) ) ) ) ).

% fact_eq_fact_times
thf(fact_4111_monoseq__realpow,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less_eq @ real @ X @ ( one_one @ real ) )
       => ( topological_monoseq @ real @ ( power_power @ real @ X ) ) ) ) ).

% monoseq_realpow
thf(fact_4112_pochhammer__Suc__prod,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [A2: A,N: nat] :
          ( ( comm_s3205402744901411588hammer @ A @ A2 @ ( suc @ N ) )
          = ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [I4: nat] : ( plus_plus @ A @ A2 @ ( semiring_1_of_nat @ A @ I4 ) )
            @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N ) ) ) ) ).

% pochhammer_Suc_prod
thf(fact_4113_pochhammer__prod__rev,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ( ( comm_s3205402744901411588hammer @ A )
        = ( ^ [A3: A,N3: nat] :
              ( groups7121269368397514597t_prod @ nat @ A
              @ ^ [I4: nat] : ( plus_plus @ A @ A3 @ ( semiring_1_of_nat @ A @ ( minus_minus @ nat @ N3 @ I4 ) ) )
              @ ( set_or1337092689740270186AtMost @ nat @ ( one_one @ nat ) @ N3 ) ) ) ) ) ).

% pochhammer_prod_rev
thf(fact_4114_fact__div__fact,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less_eq @ nat @ N @ M )
     => ( ( divide_divide @ nat @ ( semiring_char_0_fact @ nat @ M ) @ ( semiring_char_0_fact @ nat @ N ) )
        = ( groups7121269368397514597t_prod @ nat @ nat
          @ ^ [X2: nat] : X2
          @ ( set_or1337092689740270186AtMost @ nat @ ( plus_plus @ nat @ N @ ( one_one @ nat ) ) @ M ) ) ) ) ).

% fact_div_fact
thf(fact_4115_prod_Oin__pairs,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,M: nat,N: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M ) @ ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ) )
          = ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [I4: nat] : ( times_times @ A @ ( G @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ I4 ) ) @ ( G @ ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ I4 ) ) ) )
            @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) ) ) ) ).

% prod.in_pairs
thf(fact_4116_pochhammer__Suc__prod__rev,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [A2: A,N: nat] :
          ( ( comm_s3205402744901411588hammer @ A @ A2 @ ( suc @ N ) )
          = ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [I4: nat] : ( plus_plus @ A @ A2 @ ( semiring_1_of_nat @ A @ ( minus_minus @ nat @ N @ I4 ) ) )
            @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N ) ) ) ) ).

% pochhammer_Suc_prod_rev
thf(fact_4117_gbinomial__Suc,axiom,
    ! [A: $tType] :
      ( ( ( semiring_char_0 @ A )
        & ( semidom_divide @ A ) )
     => ! [A2: A,K: nat] :
          ( ( gbinomial @ A @ A2 @ ( suc @ K ) )
          = ( divide_divide @ A
            @ ( groups7121269368397514597t_prod @ nat @ A
              @ ^ [I4: nat] : ( minus_minus @ A @ A2 @ ( semiring_1_of_nat @ A @ I4 ) )
              @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ K ) )
            @ ( semiring_char_0_fact @ A @ ( suc @ K ) ) ) ) ) ).

% gbinomial_Suc
thf(fact_4118_vebt__member_Opelims_I1_J,axiom,
    ! [X: vEBT_VEBT,Xa: nat,Y: $o] :
      ( ( ( vEBT_vebt_member @ X @ Xa )
        = Y )
     => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_vebt_member_rel @ ( product_Pair @ vEBT_VEBT @ nat @ X @ Xa ) )
       => ( ! [A5: $o,B4: $o] :
              ( ( X
                = ( vEBT_Leaf @ A5 @ B4 ) )
             => ( ( Y
                  = ( ( ( Xa
                        = ( zero_zero @ nat ) )
                     => A5 )
                    & ( ( Xa
                       != ( zero_zero @ nat ) )
                     => ( ( ( Xa
                            = ( one_one @ nat ) )
                         => B4 )
                        & ( Xa
                          = ( one_one @ nat ) ) ) ) ) )
               => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_vebt_member_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Leaf @ A5 @ B4 ) @ Xa ) ) ) )
         => ( ! [Uu2: nat,Uv2: list @ vEBT_VEBT,Uw2: vEBT_VEBT] :
                ( ( X
                  = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ Uu2 @ Uv2 @ Uw2 ) )
               => ( ~ Y
                 => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_vebt_member_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ Uu2 @ Uv2 @ Uw2 ) @ Xa ) ) ) )
           => ( ! [V4: product_prod @ nat @ nat,Uy: list @ vEBT_VEBT,Uz: vEBT_VEBT] :
                  ( ( X
                    = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ V4 ) @ ( zero_zero @ nat ) @ Uy @ Uz ) )
                 => ( ~ Y
                   => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_vebt_member_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ V4 ) @ ( zero_zero @ nat ) @ Uy @ Uz ) @ Xa ) ) ) )
             => ( ! [V4: product_prod @ nat @ nat,Vb: list @ vEBT_VEBT,Vc: vEBT_VEBT] :
                    ( ( X
                      = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ V4 ) @ ( suc @ ( zero_zero @ nat ) ) @ Vb @ Vc ) )
                   => ( ~ Y
                     => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_vebt_member_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ V4 ) @ ( suc @ ( zero_zero @ nat ) ) @ Vb @ Vc ) @ Xa ) ) ) )
               => ~ ! [Mi3: nat,Ma3: nat,Va: nat,TreeList3: list @ vEBT_VEBT,Summary3: vEBT_VEBT] :
                      ( ( X
                        = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi3 @ Ma3 ) ) @ ( suc @ ( suc @ Va ) ) @ TreeList3 @ Summary3 ) )
                     => ( ( Y
                          = ( ( Xa != Mi3 )
                           => ( ( Xa != Ma3 )
                             => ( ~ ( ord_less @ nat @ Xa @ Mi3 )
                                & ( ~ ( ord_less @ nat @ Xa @ Mi3 )
                                 => ( ~ ( ord_less @ nat @ Ma3 @ Xa )
                                    & ( ~ ( ord_less @ nat @ Ma3 @ Xa )
                                     => ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) )
                                         => ( vEBT_vebt_member @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                                        & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) ) ) ) ) ) ) ) ) )
                       => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_vebt_member_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi3 @ Ma3 ) ) @ ( suc @ ( suc @ Va ) ) @ TreeList3 @ Summary3 ) @ Xa ) ) ) ) ) ) ) ) ) ) ).

% vebt_member.pelims(1)
thf(fact_4119_vebt__member_Opelims_I3_J,axiom,
    ! [X: vEBT_VEBT,Xa: nat] :
      ( ~ ( vEBT_vebt_member @ X @ Xa )
     => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_vebt_member_rel @ ( product_Pair @ vEBT_VEBT @ nat @ X @ Xa ) )
       => ( ! [A5: $o,B4: $o] :
              ( ( X
                = ( vEBT_Leaf @ A5 @ B4 ) )
             => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_vebt_member_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Leaf @ A5 @ B4 ) @ Xa ) )
               => ( ( ( Xa
                      = ( zero_zero @ nat ) )
                   => A5 )
                  & ( ( Xa
                     != ( zero_zero @ nat ) )
                   => ( ( ( Xa
                          = ( one_one @ nat ) )
                       => B4 )
                      & ( Xa
                        = ( one_one @ nat ) ) ) ) ) ) )
         => ( ! [Uu2: nat,Uv2: list @ vEBT_VEBT,Uw2: vEBT_VEBT] :
                ( ( X
                  = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ Uu2 @ Uv2 @ Uw2 ) )
               => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_vebt_member_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ Uu2 @ Uv2 @ Uw2 ) @ Xa ) ) )
           => ( ! [V4: product_prod @ nat @ nat,Uy: list @ vEBT_VEBT,Uz: vEBT_VEBT] :
                  ( ( X
                    = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ V4 ) @ ( zero_zero @ nat ) @ Uy @ Uz ) )
                 => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_vebt_member_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ V4 ) @ ( zero_zero @ nat ) @ Uy @ Uz ) @ Xa ) ) )
             => ( ! [V4: product_prod @ nat @ nat,Vb: list @ vEBT_VEBT,Vc: vEBT_VEBT] :
                    ( ( X
                      = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ V4 ) @ ( suc @ ( zero_zero @ nat ) ) @ Vb @ Vc ) )
                   => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_vebt_member_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ V4 ) @ ( suc @ ( zero_zero @ nat ) ) @ Vb @ Vc ) @ Xa ) ) )
               => ~ ! [Mi3: nat,Ma3: nat,Va: nat,TreeList3: list @ vEBT_VEBT,Summary3: vEBT_VEBT] :
                      ( ( X
                        = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi3 @ Ma3 ) ) @ ( suc @ ( suc @ Va ) ) @ TreeList3 @ Summary3 ) )
                     => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_vebt_member_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi3 @ Ma3 ) ) @ ( suc @ ( suc @ Va ) ) @ TreeList3 @ Summary3 ) @ Xa ) )
                       => ( ( Xa != Mi3 )
                         => ( ( Xa != Ma3 )
                           => ( ~ ( ord_less @ nat @ Xa @ Mi3 )
                              & ( ~ ( ord_less @ nat @ Xa @ Mi3 )
                               => ( ~ ( ord_less @ nat @ Ma3 @ Xa )
                                  & ( ~ ( ord_less @ nat @ Ma3 @ Xa )
                                   => ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) )
                                       => ( vEBT_vebt_member @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                                      & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ).

% vebt_member.pelims(3)
thf(fact_4120_VEBT__internal_Onaive__member_Opelims_I3_J,axiom,
    ! [X: vEBT_VEBT,Xa: nat] :
      ( ~ ( vEBT_V5719532721284313246member @ X @ Xa )
     => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V5765760719290551771er_rel @ ( product_Pair @ vEBT_VEBT @ nat @ X @ Xa ) )
       => ( ! [A5: $o,B4: $o] :
              ( ( X
                = ( vEBT_Leaf @ A5 @ B4 ) )
             => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V5765760719290551771er_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Leaf @ A5 @ B4 ) @ Xa ) )
               => ( ( ( Xa
                      = ( zero_zero @ nat ) )
                   => A5 )
                  & ( ( Xa
                     != ( zero_zero @ nat ) )
                   => ( ( ( Xa
                          = ( one_one @ nat ) )
                       => B4 )
                      & ( Xa
                        = ( one_one @ nat ) ) ) ) ) ) )
         => ( ! [Uu2: option @ ( product_prod @ nat @ nat ),Uv2: list @ vEBT_VEBT,Uw2: vEBT_VEBT] :
                ( ( X
                  = ( vEBT_Node @ Uu2 @ ( zero_zero @ nat ) @ Uv2 @ Uw2 ) )
               => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V5765760719290551771er_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ Uu2 @ ( zero_zero @ nat ) @ Uv2 @ Uw2 ) @ Xa ) ) )
           => ~ ! [Uy: option @ ( product_prod @ nat @ nat ),V4: nat,TreeList3: list @ vEBT_VEBT,S3: vEBT_VEBT] :
                  ( ( X
                    = ( vEBT_Node @ Uy @ ( suc @ V4 ) @ TreeList3 @ S3 ) )
                 => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V5765760719290551771er_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ Uy @ ( suc @ V4 ) @ TreeList3 @ S3 ) @ Xa ) )
                   => ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) )
                       => ( vEBT_V5719532721284313246member @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                      & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) ) ) ) ) ) ) ) ) ).

% VEBT_internal.naive_member.pelims(3)
thf(fact_4121_VEBT__internal_Onaive__member_Opelims_I2_J,axiom,
    ! [X: vEBT_VEBT,Xa: nat] :
      ( ( vEBT_V5719532721284313246member @ X @ Xa )
     => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V5765760719290551771er_rel @ ( product_Pair @ vEBT_VEBT @ nat @ X @ Xa ) )
       => ( ! [A5: $o,B4: $o] :
              ( ( X
                = ( vEBT_Leaf @ A5 @ B4 ) )
             => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V5765760719290551771er_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Leaf @ A5 @ B4 ) @ Xa ) )
               => ~ ( ( ( Xa
                        = ( zero_zero @ nat ) )
                     => A5 )
                    & ( ( Xa
                       != ( zero_zero @ nat ) )
                     => ( ( ( Xa
                            = ( one_one @ nat ) )
                         => B4 )
                        & ( Xa
                          = ( one_one @ nat ) ) ) ) ) ) )
         => ~ ! [Uy: option @ ( product_prod @ nat @ nat ),V4: nat,TreeList3: list @ vEBT_VEBT,S3: vEBT_VEBT] :
                ( ( X
                  = ( vEBT_Node @ Uy @ ( suc @ V4 ) @ TreeList3 @ S3 ) )
               => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V5765760719290551771er_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ Uy @ ( suc @ V4 ) @ TreeList3 @ S3 ) @ Xa ) )
                 => ~ ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) )
                       => ( vEBT_V5719532721284313246member @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                      & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) ) ) ) ) ) ) ) ).

% VEBT_internal.naive_member.pelims(2)
thf(fact_4122_int__prod,axiom,
    ! [B: $tType,F2: B > nat,A4: set @ B] :
      ( ( semiring_1_of_nat @ int @ ( groups7121269368397514597t_prod @ B @ nat @ F2 @ A4 ) )
      = ( groups7121269368397514597t_prod @ B @ int
        @ ^ [X2: B] : ( semiring_1_of_nat @ int @ ( F2 @ X2 ) )
        @ A4 ) ) ).

% int_prod
thf(fact_4123_prod__int__eq,axiom,
    ! [I: nat,J: nat] :
      ( ( groups7121269368397514597t_prod @ nat @ int @ ( semiring_1_of_nat @ int ) @ ( set_or1337092689740270186AtMost @ nat @ I @ J ) )
      = ( groups7121269368397514597t_prod @ int @ int
        @ ^ [X2: int] : X2
        @ ( set_or1337092689740270186AtMost @ int @ ( semiring_1_of_nat @ int @ I ) @ ( semiring_1_of_nat @ int @ J ) ) ) ) ).

% prod_int_eq
thf(fact_4124_prod__int__plus__eq,axiom,
    ! [I: nat,J: nat] :
      ( ( groups7121269368397514597t_prod @ nat @ int @ ( semiring_1_of_nat @ int ) @ ( set_or1337092689740270186AtMost @ nat @ I @ ( plus_plus @ nat @ I @ J ) ) )
      = ( groups7121269368397514597t_prod @ int @ int
        @ ^ [X2: int] : X2
        @ ( set_or1337092689740270186AtMost @ int @ ( semiring_1_of_nat @ int @ I ) @ ( semiring_1_of_nat @ int @ ( plus_plus @ nat @ I @ J ) ) ) ) ) ).

% prod_int_plus_eq
thf(fact_4125_vebt__member_Opelims_I2_J,axiom,
    ! [X: vEBT_VEBT,Xa: nat] :
      ( ( vEBT_vebt_member @ X @ Xa )
     => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_vebt_member_rel @ ( product_Pair @ vEBT_VEBT @ nat @ X @ Xa ) )
       => ( ! [A5: $o,B4: $o] :
              ( ( X
                = ( vEBT_Leaf @ A5 @ B4 ) )
             => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_vebt_member_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Leaf @ A5 @ B4 ) @ Xa ) )
               => ~ ( ( ( Xa
                        = ( zero_zero @ nat ) )
                     => A5 )
                    & ( ( Xa
                       != ( zero_zero @ nat ) )
                     => ( ( ( Xa
                            = ( one_one @ nat ) )
                         => B4 )
                        & ( Xa
                          = ( one_one @ nat ) ) ) ) ) ) )
         => ~ ! [Mi3: nat,Ma3: nat,Va: nat,TreeList3: list @ vEBT_VEBT,Summary3: vEBT_VEBT] :
                ( ( X
                  = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi3 @ Ma3 ) ) @ ( suc @ ( suc @ Va ) ) @ TreeList3 @ Summary3 ) )
               => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_vebt_member_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi3 @ Ma3 ) ) @ ( suc @ ( suc @ Va ) ) @ TreeList3 @ Summary3 ) @ Xa ) )
                 => ~ ( ( Xa != Mi3 )
                     => ( ( Xa != Ma3 )
                       => ( ~ ( ord_less @ nat @ Xa @ Mi3 )
                          & ( ~ ( ord_less @ nat @ Xa @ Mi3 )
                           => ( ~ ( ord_less @ nat @ Ma3 @ Xa )
                              & ( ~ ( ord_less @ nat @ Ma3 @ Xa )
                               => ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) )
                                   => ( vEBT_vebt_member @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                                  & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ).

% vebt_member.pelims(2)
thf(fact_4126_VEBT__internal_Onaive__member_Opelims_I1_J,axiom,
    ! [X: vEBT_VEBT,Xa: nat,Y: $o] :
      ( ( ( vEBT_V5719532721284313246member @ X @ Xa )
        = Y )
     => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V5765760719290551771er_rel @ ( product_Pair @ vEBT_VEBT @ nat @ X @ Xa ) )
       => ( ! [A5: $o,B4: $o] :
              ( ( X
                = ( vEBT_Leaf @ A5 @ B4 ) )
             => ( ( Y
                  = ( ( ( Xa
                        = ( zero_zero @ nat ) )
                     => A5 )
                    & ( ( Xa
                       != ( zero_zero @ nat ) )
                     => ( ( ( Xa
                            = ( one_one @ nat ) )
                         => B4 )
                        & ( Xa
                          = ( one_one @ nat ) ) ) ) ) )
               => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V5765760719290551771er_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Leaf @ A5 @ B4 ) @ Xa ) ) ) )
         => ( ! [Uu2: option @ ( product_prod @ nat @ nat ),Uv2: list @ vEBT_VEBT,Uw2: vEBT_VEBT] :
                ( ( X
                  = ( vEBT_Node @ Uu2 @ ( zero_zero @ nat ) @ Uv2 @ Uw2 ) )
               => ( ~ Y
                 => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V5765760719290551771er_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ Uu2 @ ( zero_zero @ nat ) @ Uv2 @ Uw2 ) @ Xa ) ) ) )
           => ~ ! [Uy: option @ ( product_prod @ nat @ nat ),V4: nat,TreeList3: list @ vEBT_VEBT,S3: vEBT_VEBT] :
                  ( ( X
                    = ( vEBT_Node @ Uy @ ( suc @ V4 ) @ TreeList3 @ S3 ) )
                 => ( ( Y
                      = ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) )
                         => ( vEBT_V5719532721284313246member @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                        & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) ) ) )
                   => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V5765760719290551771er_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ Uy @ ( suc @ V4 ) @ TreeList3 @ S3 ) @ Xa ) ) ) ) ) ) ) ) ).

% VEBT_internal.naive_member.pelims(1)
thf(fact_4127_VEBT__internal_Omembermima_Opelims_I3_J,axiom,
    ! [X: vEBT_VEBT,Xa: nat] :
      ( ~ ( vEBT_VEBT_membermima @ X @ Xa )
     => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V4351362008482014158ma_rel @ ( product_Pair @ vEBT_VEBT @ nat @ X @ Xa ) )
       => ( ! [Uu2: $o,Uv2: $o] :
              ( ( X
                = ( vEBT_Leaf @ Uu2 @ Uv2 ) )
             => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V4351362008482014158ma_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Leaf @ Uu2 @ Uv2 ) @ Xa ) ) )
         => ( ! [Ux2: list @ vEBT_VEBT,Uy: vEBT_VEBT] :
                ( ( X
                  = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( zero_zero @ nat ) @ Ux2 @ Uy ) )
               => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V4351362008482014158ma_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( zero_zero @ nat ) @ Ux2 @ Uy ) @ Xa ) ) )
           => ( ! [Mi3: nat,Ma3: nat,Va2: list @ vEBT_VEBT,Vb: vEBT_VEBT] :
                  ( ( X
                    = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi3 @ Ma3 ) ) @ ( zero_zero @ nat ) @ Va2 @ Vb ) )
                 => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V4351362008482014158ma_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi3 @ Ma3 ) ) @ ( zero_zero @ nat ) @ Va2 @ Vb ) @ Xa ) )
                   => ( ( Xa = Mi3 )
                      | ( Xa = Ma3 ) ) ) )
             => ( ! [Mi3: nat,Ma3: nat,V4: nat,TreeList3: list @ vEBT_VEBT,Vc: vEBT_VEBT] :
                    ( ( X
                      = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi3 @ Ma3 ) ) @ ( suc @ V4 ) @ TreeList3 @ Vc ) )
                   => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V4351362008482014158ma_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi3 @ Ma3 ) ) @ ( suc @ V4 ) @ TreeList3 @ Vc ) @ Xa ) )
                     => ( ( Xa = Mi3 )
                        | ( Xa = Ma3 )
                        | ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) )
                           => ( vEBT_VEBT_membermima @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                          & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) ) ) ) ) )
               => ~ ! [V4: nat,TreeList3: list @ vEBT_VEBT,Vd: vEBT_VEBT] :
                      ( ( X
                        = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ V4 ) @ TreeList3 @ Vd ) )
                     => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V4351362008482014158ma_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ V4 ) @ TreeList3 @ Vd ) @ Xa ) )
                       => ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) )
                           => ( vEBT_VEBT_membermima @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                          & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) ) ) ) ) ) ) ) ) ) ) ).

% VEBT_internal.membermima.pelims(3)
thf(fact_4128_VEBT__internal_Omembermima_Opelims_I1_J,axiom,
    ! [X: vEBT_VEBT,Xa: nat,Y: $o] :
      ( ( ( vEBT_VEBT_membermima @ X @ Xa )
        = Y )
     => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V4351362008482014158ma_rel @ ( product_Pair @ vEBT_VEBT @ nat @ X @ Xa ) )
       => ( ! [Uu2: $o,Uv2: $o] :
              ( ( X
                = ( vEBT_Leaf @ Uu2 @ Uv2 ) )
             => ( ~ Y
               => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V4351362008482014158ma_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Leaf @ Uu2 @ Uv2 ) @ Xa ) ) ) )
         => ( ! [Ux2: list @ vEBT_VEBT,Uy: vEBT_VEBT] :
                ( ( X
                  = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( zero_zero @ nat ) @ Ux2 @ Uy ) )
               => ( ~ Y
                 => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V4351362008482014158ma_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( zero_zero @ nat ) @ Ux2 @ Uy ) @ Xa ) ) ) )
           => ( ! [Mi3: nat,Ma3: nat,Va2: list @ vEBT_VEBT,Vb: vEBT_VEBT] :
                  ( ( X
                    = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi3 @ Ma3 ) ) @ ( zero_zero @ nat ) @ Va2 @ Vb ) )
                 => ( ( Y
                      = ( ( Xa = Mi3 )
                        | ( Xa = Ma3 ) ) )
                   => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V4351362008482014158ma_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi3 @ Ma3 ) ) @ ( zero_zero @ nat ) @ Va2 @ Vb ) @ Xa ) ) ) )
             => ( ! [Mi3: nat,Ma3: nat,V4: nat,TreeList3: list @ vEBT_VEBT,Vc: vEBT_VEBT] :
                    ( ( X
                      = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi3 @ Ma3 ) ) @ ( suc @ V4 ) @ TreeList3 @ Vc ) )
                   => ( ( Y
                        = ( ( Xa = Mi3 )
                          | ( Xa = Ma3 )
                          | ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) )
                             => ( vEBT_VEBT_membermima @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                            & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) ) ) ) )
                     => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V4351362008482014158ma_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi3 @ Ma3 ) ) @ ( suc @ V4 ) @ TreeList3 @ Vc ) @ Xa ) ) ) )
               => ~ ! [V4: nat,TreeList3: list @ vEBT_VEBT,Vd: vEBT_VEBT] :
                      ( ( X
                        = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ V4 ) @ TreeList3 @ Vd ) )
                     => ( ( Y
                          = ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) )
                             => ( vEBT_VEBT_membermima @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                            & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) ) ) )
                       => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V4351362008482014158ma_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ V4 ) @ TreeList3 @ Vd ) @ Xa ) ) ) ) ) ) ) ) ) ) ).

% VEBT_internal.membermima.pelims(1)
thf(fact_4129_VEBT__internal_Omembermima_Opelims_I2_J,axiom,
    ! [X: vEBT_VEBT,Xa: nat] :
      ( ( vEBT_VEBT_membermima @ X @ Xa )
     => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V4351362008482014158ma_rel @ ( product_Pair @ vEBT_VEBT @ nat @ X @ Xa ) )
       => ( ! [Mi3: nat,Ma3: nat,Va2: list @ vEBT_VEBT,Vb: vEBT_VEBT] :
              ( ( X
                = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi3 @ Ma3 ) ) @ ( zero_zero @ nat ) @ Va2 @ Vb ) )
             => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V4351362008482014158ma_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi3 @ Ma3 ) ) @ ( zero_zero @ nat ) @ Va2 @ Vb ) @ Xa ) )
               => ~ ( ( Xa = Mi3 )
                    | ( Xa = Ma3 ) ) ) )
         => ( ! [Mi3: nat,Ma3: nat,V4: nat,TreeList3: list @ vEBT_VEBT,Vc: vEBT_VEBT] :
                ( ( X
                  = ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi3 @ Ma3 ) ) @ ( suc @ V4 ) @ TreeList3 @ Vc ) )
               => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V4351362008482014158ma_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( some @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ Mi3 @ Ma3 ) ) @ ( suc @ V4 ) @ TreeList3 @ Vc ) @ Xa ) )
                 => ~ ( ( Xa = Mi3 )
                      | ( Xa = Ma3 )
                      | ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) )
                         => ( vEBT_VEBT_membermima @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                        & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) ) ) ) ) )
           => ~ ! [V4: nat,TreeList3: list @ vEBT_VEBT,Vd: vEBT_VEBT] :
                  ( ( X
                    = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ V4 ) @ TreeList3 @ Vd ) )
                 => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_V4351362008482014158ma_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ V4 ) @ TreeList3 @ Vd ) @ Xa ) )
                   => ~ ( ( ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) )
                         => ( vEBT_VEBT_membermima @ ( nth @ vEBT_VEBT @ TreeList3 @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_VEBT_low @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                        & ( ord_less @ nat @ ( vEBT_VEBT_high @ Xa @ ( divide_divide @ nat @ ( suc @ V4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 ) ) ) ) ) ) ) ) ) ).

% VEBT_internal.membermima.pelims(2)
thf(fact_4130_ln__series,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less @ real @ X @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) )
       => ( ( ln_ln @ real @ X )
          = ( suminf @ real
            @ ^ [N3: nat] : ( times_times @ real @ ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ N3 ) @ ( divide_divide @ real @ ( one_one @ real ) @ ( semiring_1_of_nat @ real @ ( plus_plus @ nat @ N3 @ ( one_one @ nat ) ) ) ) ) @ ( power_power @ real @ ( minus_minus @ real @ X @ ( one_one @ real ) ) @ ( suc @ N3 ) ) ) ) ) ) ) ).

% ln_series
thf(fact_4131_powser__zero,axiom,
    ! [A: $tType] :
      ( ( real_V2822296259951069270ebra_1 @ A )
     => ! [F2: nat > A] :
          ( ( suminf @ A
            @ ^ [N3: nat] : ( times_times @ A @ ( F2 @ N3 ) @ ( power_power @ A @ ( zero_zero @ A ) @ N3 ) ) )
          = ( F2 @ ( zero_zero @ nat ) ) ) ) ).

% powser_zero
thf(fact_4132_sin__def,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ( ( sin @ A )
        = ( ^ [X2: A] :
              ( suminf @ A
              @ ^ [N3: nat] : ( real_V8093663219630862766scaleR @ A @ ( sin_coeff @ N3 ) @ ( power_power @ A @ X2 @ N3 ) ) ) ) ) ) ).

% sin_def
thf(fact_4133_cos__def,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ( ( cos @ A )
        = ( ^ [X2: A] :
              ( suminf @ A
              @ ^ [N3: nat] : ( real_V8093663219630862766scaleR @ A @ ( cos_coeff @ N3 ) @ ( power_power @ A @ X2 @ N3 ) ) ) ) ) ) ).

% cos_def
thf(fact_4134_exp__def,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ( ( exp @ A )
        = ( ^ [X2: A] :
              ( suminf @ A
              @ ^ [N3: nat] : ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ ( semiring_char_0_fact @ real @ N3 ) ) @ ( power_power @ A @ X2 @ N3 ) ) ) ) ) ) ).

% exp_def
thf(fact_4135_exp__first__term,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ( ( exp @ A )
        = ( ^ [X2: A] :
              ( plus_plus @ A @ ( one_one @ A )
              @ ( suminf @ A
                @ ^ [N3: nat] : ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ ( semiring_char_0_fact @ real @ ( suc @ N3 ) ) ) @ ( power_power @ A @ X2 @ ( suc @ N3 ) ) ) ) ) ) ) ) ).

% exp_first_term
thf(fact_4136_exp__first__two__terms,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ( ( exp @ A )
        = ( ^ [X2: A] :
              ( plus_plus @ A @ ( plus_plus @ A @ ( one_one @ A ) @ X2 )
              @ ( suminf @ A
                @ ^ [N3: nat] : ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ ( semiring_char_0_fact @ real @ ( plus_plus @ nat @ N3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( power_power @ A @ X2 @ ( plus_plus @ nat @ N3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ).

% exp_first_two_terms
thf(fact_4137_pi__series,axiom,
    ( ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ ( bit0 @ one2 ) ) ) )
    = ( suminf @ real
      @ ^ [K3: nat] : ( divide_divide @ real @ ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ K3 ) @ ( one_one @ real ) ) @ ( semiring_1_of_nat @ real @ ( plus_plus @ nat @ ( times_times @ nat @ K3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ nat ) ) ) ) ) ) ).

% pi_series
thf(fact_4138_arctan__series,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( abs_abs @ real @ X ) @ ( one_one @ real ) )
     => ( ( arctan @ X )
        = ( suminf @ real
          @ ^ [K3: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ K3 ) @ ( times_times @ real @ ( divide_divide @ real @ ( one_one @ real ) @ ( semiring_1_of_nat @ real @ ( plus_plus @ nat @ ( times_times @ nat @ K3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ nat ) ) ) ) @ ( power_power @ real @ X @ ( plus_plus @ nat @ ( times_times @ nat @ K3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ nat ) ) ) ) ) ) ) ) ).

% arctan_series
thf(fact_4139_suminf__geometric,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [C2: A] :
          ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ C2 ) @ ( one_one @ real ) )
         => ( ( suminf @ A @ ( power_power @ A @ C2 ) )
            = ( divide_divide @ A @ ( one_one @ A ) @ ( minus_minus @ A @ ( one_one @ A ) @ C2 ) ) ) ) ) ).

% suminf_geometric
thf(fact_4140_suminf__zero,axiom,
    ! [A: $tType] :
      ( ( ( comm_monoid_add @ A )
        & ( topological_t2_space @ A ) )
     => ( ( suminf @ A
          @ ^ [N3: nat] : ( zero_zero @ A ) )
        = ( zero_zero @ A ) ) ) ).

% suminf_zero
thf(fact_4141_prod__le__1,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [A4: set @ B,F2: B > A] :
          ( ! [X3: B] :
              ( ( member @ B @ X3 @ A4 )
             => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( F2 @ X3 ) )
                & ( ord_less_eq @ A @ ( F2 @ X3 ) @ ( one_one @ A ) ) ) )
         => ( ord_less_eq @ A @ ( groups7121269368397514597t_prod @ B @ A @ F2 @ A4 ) @ ( one_one @ A ) ) ) ) ).

% prod_le_1
thf(fact_4142_bij__betw__nth__root__unity,axiom,
    ! [C2: complex,N: nat] :
      ( ( C2
       != ( zero_zero @ complex ) )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
       => ( bij_betw @ complex @ complex @ ( times_times @ complex @ ( times_times @ complex @ ( real_Vector_of_real @ complex @ ( root @ N @ ( real_V7770717601297561774m_norm @ complex @ C2 ) ) ) @ ( cis @ ( divide_divide @ real @ ( arg @ C2 ) @ ( semiring_1_of_nat @ real @ N ) ) ) ) )
          @ ( collect @ complex
            @ ^ [Z6: complex] :
                ( ( power_power @ complex @ Z6 @ N )
                = ( one_one @ complex ) ) )
          @ ( collect @ complex
            @ ^ [Z6: complex] :
                ( ( power_power @ complex @ Z6 @ N )
                = C2 ) ) ) ) ) ).

% bij_betw_nth_root_unity
thf(fact_4143_prod__power__distrib,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comm_semiring_1 @ B )
     => ! [F2: A > B,A4: set @ A,N: nat] :
          ( ( power_power @ B @ ( groups7121269368397514597t_prod @ A @ B @ F2 @ A4 ) @ N )
          = ( groups7121269368397514597t_prod @ A @ B
            @ ^ [X2: A] : ( power_power @ B @ ( F2 @ X2 ) @ N )
            @ A4 ) ) ) ).

% prod_power_distrib
thf(fact_4144_prod__mono,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A4: set @ B,F2: B > A,G: B > A] :
          ( ! [I2: B] :
              ( ( member @ B @ I2 @ A4 )
             => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( F2 @ I2 ) )
                & ( ord_less_eq @ A @ ( F2 @ I2 ) @ ( G @ I2 ) ) ) )
         => ( ord_less_eq @ A @ ( groups7121269368397514597t_prod @ B @ A @ F2 @ A4 ) @ ( groups7121269368397514597t_prod @ B @ A @ G @ A4 ) ) ) ) ).

% prod_mono
thf(fact_4145_prod__nonneg,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A4: set @ B,F2: B > A] :
          ( ! [X3: B] :
              ( ( member @ B @ X3 @ A4 )
             => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( F2 @ X3 ) ) )
         => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( groups7121269368397514597t_prod @ B @ A @ F2 @ A4 ) ) ) ) ).

% prod_nonneg
thf(fact_4146_prod__pos,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A4: set @ B,F2: B > A] :
          ( ! [X3: B] :
              ( ( member @ B @ X3 @ A4 )
             => ( ord_less @ A @ ( zero_zero @ A ) @ ( F2 @ X3 ) ) )
         => ( ord_less @ A @ ( zero_zero @ A ) @ ( groups7121269368397514597t_prod @ B @ A @ F2 @ A4 ) ) ) ) ).

% prod_pos
thf(fact_4147_prod__ge__1,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [A4: set @ B,F2: B > A] :
          ( ! [X3: B] :
              ( ( member @ B @ X3 @ A4 )
             => ( ord_less_eq @ A @ ( one_one @ A ) @ ( F2 @ X3 ) ) )
         => ( ord_less_eq @ A @ ( one_one @ A ) @ ( groups7121269368397514597t_prod @ B @ A @ F2 @ A4 ) ) ) ) ).

% prod_ge_1
thf(fact_4148_summable__arctan__series,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( abs_abs @ real @ X ) @ ( one_one @ real ) )
     => ( summable @ real
        @ ^ [K3: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ K3 ) @ ( times_times @ real @ ( divide_divide @ real @ ( one_one @ real ) @ ( semiring_1_of_nat @ real @ ( plus_plus @ nat @ ( times_times @ nat @ K3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ nat ) ) ) ) @ ( power_power @ real @ X @ ( plus_plus @ nat @ ( times_times @ nat @ K3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ nat ) ) ) ) ) ) ) ).

% summable_arctan_series
thf(fact_4149_and__int_Oelims,axiom,
    ! [X: int,Xa: int,Y: int] :
      ( ( ( bit_se5824344872417868541ns_and @ int @ X @ Xa )
        = Y )
     => ( ( ( ( member @ int @ X @ ( insert @ int @ ( zero_zero @ int ) @ ( insert @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) )
            & ( member @ int @ Xa @ ( insert @ int @ ( zero_zero @ int ) @ ( insert @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) ) )
         => ( Y
            = ( uminus_uminus @ int
              @ ( zero_neq_one_of_bool @ int
                @ ( ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ X )
                  & ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ Xa ) ) ) ) ) )
        & ( ~ ( ( member @ int @ X @ ( insert @ int @ ( zero_zero @ int ) @ ( insert @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) )
              & ( member @ int @ Xa @ ( insert @ int @ ( zero_zero @ int ) @ ( insert @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) ) )
         => ( Y
            = ( plus_plus @ int
              @ ( zero_neq_one_of_bool @ int
                @ ( ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ X )
                  & ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ Xa ) ) )
              @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se5824344872417868541ns_and @ int @ ( divide_divide @ int @ X @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ int @ Xa @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ).

% and_int.elims
thf(fact_4150_and__int_Osimps,axiom,
    ( ( bit_se5824344872417868541ns_and @ int )
    = ( ^ [K3: int,L2: int] :
          ( if @ int
          @ ( ( member @ int @ K3 @ ( insert @ int @ ( zero_zero @ int ) @ ( insert @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) )
            & ( member @ int @ L2 @ ( insert @ int @ ( zero_zero @ int ) @ ( insert @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) ) )
          @ ( uminus_uminus @ int
            @ ( zero_neq_one_of_bool @ int
              @ ( ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ K3 )
                & ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ L2 ) ) ) )
          @ ( plus_plus @ int
            @ ( zero_neq_one_of_bool @ int
              @ ( ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ K3 )
                & ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ L2 ) ) )
            @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se5824344872417868541ns_and @ int @ ( divide_divide @ int @ K3 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ int @ L2 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ).

% and_int.simps
thf(fact_4151_vebt__buildup_Oelims,axiom,
    ! [X: nat,Y: vEBT_VEBT] :
      ( ( ( vEBT_vebt_buildup @ X )
        = Y )
     => ( ( ( X
            = ( zero_zero @ nat ) )
         => ( Y
           != ( vEBT_Leaf @ $false @ $false ) ) )
       => ( ( ( X
              = ( suc @ ( zero_zero @ nat ) ) )
           => ( Y
             != ( vEBT_Leaf @ $false @ $false ) ) )
         => ~ ! [Va: nat] :
                ( ( X
                  = ( suc @ ( suc @ Va ) ) )
               => ~ ( ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( suc @ ( suc @ Va ) ) )
                     => ( Y
                        = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ ( suc @ Va ) ) @ ( replicate @ vEBT_VEBT @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( vEBT_vebt_buildup @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_vebt_buildup @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) )
                    & ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( suc @ ( suc @ Va ) ) )
                     => ( Y
                        = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ ( suc @ Va ) ) @ ( replicate @ vEBT_VEBT @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( suc @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_vebt_buildup @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_vebt_buildup @ ( suc @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ) ) ) ).

% vebt_buildup.elims
thf(fact_4152_intind,axiom,
    ! [A: $tType,I: nat,N: nat,P: A > $o,X: A] :
      ( ( ord_less @ nat @ I @ N )
     => ( ( P @ X )
       => ( P @ ( nth @ A @ ( replicate @ A @ N @ X ) @ I ) ) ) ) ).

% intind
thf(fact_4153_replicate__eq__replicate,axiom,
    ! [A: $tType,M: nat,X: A,N: nat,Y: A] :
      ( ( ( replicate @ A @ M @ X )
        = ( replicate @ A @ N @ Y ) )
      = ( ( M = N )
        & ( ( M
           != ( zero_zero @ nat ) )
         => ( X = Y ) ) ) ) ).

% replicate_eq_replicate
thf(fact_4154_summable__single,axiom,
    ! [A: $tType] :
      ( ( ( comm_monoid_add @ A )
        & ( topolo4958980785337419405_space @ A ) )
     => ! [I: nat,F2: nat > A] :
          ( summable @ A
          @ ^ [R5: nat] : ( if @ A @ ( R5 = I ) @ ( F2 @ R5 ) @ ( zero_zero @ A ) ) ) ) ).

% summable_single
thf(fact_4155_summable__zero,axiom,
    ! [A: $tType] :
      ( ( ( comm_monoid_add @ A )
        & ( topolo4958980785337419405_space @ A ) )
     => ( summable @ A
        @ ^ [N3: nat] : ( zero_zero @ A ) ) ) ).

% summable_zero
thf(fact_4156_Ball__set__replicate,axiom,
    ! [A: $tType,N: nat,A2: A,P: A > $o] :
      ( ( ! [X2: A] :
            ( ( member @ A @ X2 @ ( set2 @ A @ ( replicate @ A @ N @ A2 ) ) )
           => ( P @ X2 ) ) )
      = ( ( P @ A2 )
        | ( N
          = ( zero_zero @ nat ) ) ) ) ).

% Ball_set_replicate
thf(fact_4157_Bex__set__replicate,axiom,
    ! [A: $tType,N: nat,A2: A,P: A > $o] :
      ( ( ? [X2: A] :
            ( ( member @ A @ X2 @ ( set2 @ A @ ( replicate @ A @ N @ A2 ) ) )
            & ( P @ X2 ) ) )
      = ( ( P @ A2 )
        & ( N
         != ( zero_zero @ nat ) ) ) ) ).

% Bex_set_replicate
thf(fact_4158_in__set__replicate,axiom,
    ! [A: $tType,X: A,N: nat,Y: A] :
      ( ( member @ A @ X @ ( set2 @ A @ ( replicate @ A @ N @ Y ) ) )
      = ( ( X = Y )
        & ( N
         != ( zero_zero @ nat ) ) ) ) ).

% in_set_replicate
thf(fact_4159_nth__replicate,axiom,
    ! [A: $tType,I: nat,N: nat,X: A] :
      ( ( ord_less @ nat @ I @ N )
     => ( ( nth @ A @ ( replicate @ A @ N @ X ) @ I )
        = X ) ) ).

% nth_replicate
thf(fact_4160_summable__cmult__iff,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [C2: A,F2: nat > A] :
          ( ( summable @ A
            @ ^ [N3: nat] : ( times_times @ A @ C2 @ ( F2 @ N3 ) ) )
          = ( ( C2
              = ( zero_zero @ A ) )
            | ( summable @ A @ F2 ) ) ) ) ).

% summable_cmult_iff
thf(fact_4161_summable__divide__iff,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: nat > A,C2: A] :
          ( ( summable @ A
            @ ^ [N3: nat] : ( divide_divide @ A @ ( F2 @ N3 ) @ C2 ) )
          = ( ( C2
              = ( zero_zero @ A ) )
            | ( summable @ A @ F2 ) ) ) ) ).

% summable_divide_iff
thf(fact_4162_set__replicate,axiom,
    ! [A: $tType,N: nat,X: A] :
      ( ( N
       != ( zero_zero @ nat ) )
     => ( ( set2 @ A @ ( replicate @ A @ N @ X ) )
        = ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) ).

% set_replicate
thf(fact_4163_summable__geometric__iff,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [C2: A] :
          ( ( summable @ A @ ( power_power @ A @ C2 ) )
          = ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ C2 ) @ ( one_one @ real ) ) ) ) ).

% summable_geometric_iff
thf(fact_4164_summable__comparison__test_H,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach @ A )
     => ! [G: nat > real,N4: nat,F2: nat > A] :
          ( ( summable @ real @ G )
         => ( ! [N2: nat] :
                ( ( ord_less_eq @ nat @ N4 @ N2 )
               => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( F2 @ N2 ) ) @ ( G @ N2 ) ) )
           => ( summable @ A @ F2 ) ) ) ) ).

% summable_comparison_test'
thf(fact_4165_summable__comparison__test,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach @ A )
     => ! [F2: nat > A,G: nat > real] :
          ( ? [N8: nat] :
            ! [N2: nat] :
              ( ( ord_less_eq @ nat @ N8 @ N2 )
             => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( F2 @ N2 ) ) @ ( G @ N2 ) ) )
         => ( ( summable @ real @ G )
           => ( summable @ A @ F2 ) ) ) ) ).

% summable_comparison_test
thf(fact_4166_summable__const__iff,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [C2: A] :
          ( ( summable @ A
            @ ^ [Uu3: nat] : C2 )
          = ( C2
            = ( zero_zero @ A ) ) ) ) ).

% summable_const_iff
thf(fact_4167_set__replicate__conv__if,axiom,
    ! [A: $tType,N: nat,X: A] :
      ( ( ( N
          = ( zero_zero @ nat ) )
       => ( ( set2 @ A @ ( replicate @ A @ N @ X ) )
          = ( bot_bot @ ( set @ A ) ) ) )
      & ( ( N
         != ( zero_zero @ nat ) )
       => ( ( set2 @ A @ ( replicate @ A @ N @ X ) )
          = ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% set_replicate_conv_if
thf(fact_4168_powser__insidea,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [F2: nat > A,X: A,Z: A] :
          ( ( summable @ A
            @ ^ [N3: nat] : ( times_times @ A @ ( F2 @ N3 ) @ ( power_power @ A @ X @ N3 ) ) )
         => ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ Z ) @ ( real_V7770717601297561774m_norm @ A @ X ) )
           => ( summable @ real
              @ ^ [N3: nat] : ( real_V7770717601297561774m_norm @ A @ ( times_times @ A @ ( F2 @ N3 ) @ ( power_power @ A @ Z @ N3 ) ) ) ) ) ) ) ).

% powser_insidea
thf(fact_4169_suminf__le,axiom,
    ! [A: $tType] :
      ( ( ( ordere6911136660526730532id_add @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [F2: nat > A,G: nat > A] :
          ( ! [N2: nat] : ( ord_less_eq @ A @ ( F2 @ N2 ) @ ( G @ N2 ) )
         => ( ( summable @ A @ F2 )
           => ( ( summable @ A @ G )
             => ( ord_less_eq @ A @ ( suminf @ A @ F2 ) @ ( suminf @ A @ G ) ) ) ) ) ) ).

% suminf_le
thf(fact_4170_summable__mult__D,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [C2: A,F2: nat > A] :
          ( ( summable @ A
            @ ^ [N3: nat] : ( times_times @ A @ C2 @ ( F2 @ N3 ) ) )
         => ( ( C2
             != ( zero_zero @ A ) )
           => ( summable @ A @ F2 ) ) ) ) ).

% summable_mult_D
thf(fact_4171_summable__zero__power,axiom,
    ! [A: $tType] :
      ( ( ( comm_ring_1 @ A )
        & ( topolo4958980785337419405_space @ A ) )
     => ( summable @ A @ ( power_power @ A @ ( zero_zero @ A ) ) ) ) ).

% summable_zero_power
thf(fact_4172_suminf__nonneg,axiom,
    ! [A: $tType] :
      ( ( ( ordere6911136660526730532id_add @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [F2: nat > A] :
          ( ( summable @ A @ F2 )
         => ( ! [N2: nat] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( F2 @ N2 ) )
           => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( suminf @ A @ F2 ) ) ) ) ) ).

% suminf_nonneg
thf(fact_4173_suminf__eq__zero__iff,axiom,
    ! [A: $tType] :
      ( ( ( ordere6911136660526730532id_add @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [F2: nat > A] :
          ( ( summable @ A @ F2 )
         => ( ! [N2: nat] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( F2 @ N2 ) )
           => ( ( ( suminf @ A @ F2 )
                = ( zero_zero @ A ) )
              = ( ! [N3: nat] :
                    ( ( F2 @ N3 )
                    = ( zero_zero @ A ) ) ) ) ) ) ) ).

% suminf_eq_zero_iff
thf(fact_4174_suminf__pos,axiom,
    ! [A: $tType] :
      ( ( ( ordere6911136660526730532id_add @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [F2: nat > A] :
          ( ( summable @ A @ F2 )
         => ( ! [N2: nat] : ( ord_less @ A @ ( zero_zero @ A ) @ ( F2 @ N2 ) )
           => ( ord_less @ A @ ( zero_zero @ A ) @ ( suminf @ A @ F2 ) ) ) ) ) ).

% suminf_pos
thf(fact_4175_summable__0__powser,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [F2: nat > A] :
          ( summable @ A
          @ ^ [N3: nat] : ( times_times @ A @ ( F2 @ N3 ) @ ( power_power @ A @ ( zero_zero @ A ) @ N3 ) ) ) ) ).

% summable_0_powser
thf(fact_4176_summable__zero__power_H,axiom,
    ! [A: $tType] :
      ( ( ( ring_1 @ A )
        & ( topolo4958980785337419405_space @ A ) )
     => ! [F2: nat > A] :
          ( summable @ A
          @ ^ [N3: nat] : ( times_times @ A @ ( F2 @ N3 ) @ ( power_power @ A @ ( zero_zero @ A ) @ N3 ) ) ) ) ).

% summable_zero_power'
thf(fact_4177_summable__powser__split__head,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [F2: nat > A,Z: A] :
          ( ( summable @ A
            @ ^ [N3: nat] : ( times_times @ A @ ( F2 @ ( suc @ N3 ) ) @ ( power_power @ A @ Z @ N3 ) ) )
          = ( summable @ A
            @ ^ [N3: nat] : ( times_times @ A @ ( F2 @ N3 ) @ ( power_power @ A @ Z @ N3 ) ) ) ) ) ).

% summable_powser_split_head
thf(fact_4178_powser__split__head_I3_J,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V8999393235501362500lgebra @ A ) )
     => ! [F2: nat > A,Z: A] :
          ( ( summable @ A
            @ ^ [N3: nat] : ( times_times @ A @ ( F2 @ N3 ) @ ( power_power @ A @ Z @ N3 ) ) )
         => ( summable @ A
            @ ^ [N3: nat] : ( times_times @ A @ ( F2 @ ( suc @ N3 ) ) @ ( power_power @ A @ Z @ N3 ) ) ) ) ) ).

% powser_split_head(3)
thf(fact_4179_summable__powser__ignore__initial__segment,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [F2: nat > A,M: nat,Z: A] :
          ( ( summable @ A
            @ ^ [N3: nat] : ( times_times @ A @ ( F2 @ ( plus_plus @ nat @ N3 @ M ) ) @ ( power_power @ A @ Z @ N3 ) ) )
          = ( summable @ A
            @ ^ [N3: nat] : ( times_times @ A @ ( F2 @ N3 ) @ ( power_power @ A @ Z @ N3 ) ) ) ) ) ).

% summable_powser_ignore_initial_segment
thf(fact_4180_summable__norm__comparison__test,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: nat > A,G: nat > real] :
          ( ? [N8: nat] :
            ! [N2: nat] :
              ( ( ord_less_eq @ nat @ N8 @ N2 )
             => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( F2 @ N2 ) ) @ ( G @ N2 ) ) )
         => ( ( summable @ real @ G )
           => ( summable @ real
              @ ^ [N3: nat] : ( real_V7770717601297561774m_norm @ A @ ( F2 @ N3 ) ) ) ) ) ) ).

% summable_norm_comparison_test
thf(fact_4181_summable__rabs__comparison__test,axiom,
    ! [F2: nat > real,G: nat > real] :
      ( ? [N8: nat] :
        ! [N2: nat] :
          ( ( ord_less_eq @ nat @ N8 @ N2 )
         => ( ord_less_eq @ real @ ( abs_abs @ real @ ( F2 @ N2 ) ) @ ( G @ N2 ) ) )
     => ( ( summable @ real @ G )
       => ( summable @ real
          @ ^ [N3: nat] : ( abs_abs @ real @ ( F2 @ N3 ) ) ) ) ) ).

% summable_rabs_comparison_test
thf(fact_4182_series__comparison__complex,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach @ A )
     => ! [G: nat > complex,N4: nat,F2: nat > A] :
          ( ( summable @ complex @ G )
         => ( ! [N2: nat] : ( member @ complex @ ( G @ N2 ) @ ( real_Vector_Reals @ complex ) )
           => ( ! [N2: nat] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( re @ ( G @ N2 ) ) )
             => ( ! [N2: nat] :
                    ( ( ord_less_eq @ nat @ N4 @ N2 )
                   => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( F2 @ N2 ) ) @ ( real_V7770717601297561774m_norm @ complex @ ( G @ N2 ) ) ) )
               => ( summable @ A @ F2 ) ) ) ) ) ) ).

% series_comparison_complex
thf(fact_4183_summable__rabs,axiom,
    ! [F2: nat > real] :
      ( ( summable @ real
        @ ^ [N3: nat] : ( abs_abs @ real @ ( F2 @ N3 ) ) )
     => ( ord_less_eq @ real @ ( abs_abs @ real @ ( suminf @ real @ F2 ) )
        @ ( suminf @ real
          @ ^ [N3: nat] : ( abs_abs @ real @ ( F2 @ N3 ) ) ) ) ) ).

% summable_rabs
thf(fact_4184_suminf__pos2,axiom,
    ! [A: $tType] :
      ( ( ( ordere6911136660526730532id_add @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [F2: nat > A,I: nat] :
          ( ( summable @ A @ F2 )
         => ( ! [N2: nat] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( F2 @ N2 ) )
           => ( ( ord_less @ A @ ( zero_zero @ A ) @ ( F2 @ I ) )
             => ( ord_less @ A @ ( zero_zero @ A ) @ ( suminf @ A @ F2 ) ) ) ) ) ) ).

% suminf_pos2
thf(fact_4185_suminf__pos__iff,axiom,
    ! [A: $tType] :
      ( ( ( ordere6911136660526730532id_add @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [F2: nat > A] :
          ( ( summable @ A @ F2 )
         => ( ! [N2: nat] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( F2 @ N2 ) )
           => ( ( ord_less @ A @ ( zero_zero @ A ) @ ( suminf @ A @ F2 ) )
              = ( ? [I4: nat] : ( ord_less @ A @ ( zero_zero @ A ) @ ( F2 @ I4 ) ) ) ) ) ) ) ).

% suminf_pos_iff
thf(fact_4186_powser__inside,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V8999393235501362500lgebra @ A ) )
     => ! [F2: nat > A,X: A,Z: A] :
          ( ( summable @ A
            @ ^ [N3: nat] : ( times_times @ A @ ( F2 @ N3 ) @ ( power_power @ A @ X @ N3 ) ) )
         => ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ Z ) @ ( real_V7770717601297561774m_norm @ A @ X ) )
           => ( summable @ A
              @ ^ [N3: nat] : ( times_times @ A @ ( F2 @ N3 ) @ ( power_power @ A @ Z @ N3 ) ) ) ) ) ) ).

% powser_inside
thf(fact_4187_summable__geometric,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [C2: A] :
          ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ C2 ) @ ( one_one @ real ) )
         => ( summable @ A @ ( power_power @ A @ C2 ) ) ) ) ).

% summable_geometric
thf(fact_4188_complete__algebra__summable__geometric,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [X: A] :
          ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ X ) @ ( one_one @ real ) )
         => ( summable @ A @ ( power_power @ A @ X ) ) ) ) ).

% complete_algebra_summable_geometric
thf(fact_4189_suminf__split__head,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: nat > A] :
          ( ( summable @ A @ F2 )
         => ( ( suminf @ A
              @ ^ [N3: nat] : ( F2 @ ( suc @ N3 ) ) )
            = ( minus_minus @ A @ ( suminf @ A @ F2 ) @ ( F2 @ ( zero_zero @ nat ) ) ) ) ) ) ).

% suminf_split_head
thf(fact_4190_summable__exp,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A] :
          ( summable @ A
          @ ^ [N3: nat] : ( times_times @ A @ ( inverse_inverse @ A @ ( semiring_char_0_fact @ A @ N3 ) ) @ ( power_power @ A @ X @ N3 ) ) ) ) ).

% summable_exp
thf(fact_4191_summable__exp__generic,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [X: A] :
          ( summable @ A
          @ ^ [N3: nat] : ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ ( semiring_char_0_fact @ real @ N3 ) ) @ ( power_power @ A @ X @ N3 ) ) ) ) ).

% summable_exp_generic
thf(fact_4192_summable__norm,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach @ A )
     => ! [F2: nat > A] :
          ( ( summable @ real
            @ ^ [N3: nat] : ( real_V7770717601297561774m_norm @ A @ ( F2 @ N3 ) ) )
         => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( suminf @ A @ F2 ) )
            @ ( suminf @ real
              @ ^ [N3: nat] : ( real_V7770717601297561774m_norm @ A @ ( F2 @ N3 ) ) ) ) ) ) ).

% summable_norm
thf(fact_4193_summable__norm__sin,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [X: A] :
          ( summable @ real
          @ ^ [N3: nat] : ( real_V7770717601297561774m_norm @ A @ ( real_V8093663219630862766scaleR @ A @ ( sin_coeff @ N3 ) @ ( power_power @ A @ X @ N3 ) ) ) ) ) ).

% summable_norm_sin
thf(fact_4194_summable__norm__cos,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [X: A] :
          ( summable @ real
          @ ^ [N3: nat] : ( real_V7770717601297561774m_norm @ A @ ( real_V8093663219630862766scaleR @ A @ ( cos_coeff @ N3 ) @ ( power_power @ A @ X @ N3 ) ) ) ) ) ).

% summable_norm_cos
thf(fact_4195_atLeastAtMostPlus1__int__conv,axiom,
    ! [M: int,N: int] :
      ( ( ord_less_eq @ int @ M @ ( plus_plus @ int @ ( one_one @ int ) @ N ) )
     => ( ( set_or1337092689740270186AtMost @ int @ M @ ( plus_plus @ int @ ( one_one @ int ) @ N ) )
        = ( insert @ int @ ( plus_plus @ int @ ( one_one @ int ) @ N ) @ ( set_or1337092689740270186AtMost @ int @ M @ N ) ) ) ) ).

% atLeastAtMostPlus1_int_conv
thf(fact_4196_simp__from__to,axiom,
    ( ( set_or1337092689740270186AtMost @ int )
    = ( ^ [I4: int,J3: int] : ( if @ ( set @ int ) @ ( ord_less @ int @ J3 @ I4 ) @ ( bot_bot @ ( set @ int ) ) @ ( insert @ int @ I4 @ ( set_or1337092689740270186AtMost @ int @ ( plus_plus @ int @ I4 @ ( one_one @ int ) ) @ J3 ) ) ) ) ) ).

% simp_from_to
thf(fact_4197_summable__norm__exp,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [X: A] :
          ( summable @ real
          @ ^ [N3: nat] : ( real_V7770717601297561774m_norm @ A @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ ( semiring_char_0_fact @ real @ N3 ) ) @ ( power_power @ A @ X @ N3 ) ) ) ) ) ).

% summable_norm_exp
thf(fact_4198_powser__split__head_I1_J,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V8999393235501362500lgebra @ A ) )
     => ! [F2: nat > A,Z: A] :
          ( ( summable @ A
            @ ^ [N3: nat] : ( times_times @ A @ ( F2 @ N3 ) @ ( power_power @ A @ Z @ N3 ) ) )
         => ( ( suminf @ A
              @ ^ [N3: nat] : ( times_times @ A @ ( F2 @ N3 ) @ ( power_power @ A @ Z @ N3 ) ) )
            = ( plus_plus @ A @ ( F2 @ ( zero_zero @ nat ) )
              @ ( times_times @ A
                @ ( suminf @ A
                  @ ^ [N3: nat] : ( times_times @ A @ ( F2 @ ( suc @ N3 ) ) @ ( power_power @ A @ Z @ N3 ) ) )
                @ Z ) ) ) ) ) ).

% powser_split_head(1)
thf(fact_4199_powser__split__head_I2_J,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V8999393235501362500lgebra @ A ) )
     => ! [F2: nat > A,Z: A] :
          ( ( summable @ A
            @ ^ [N3: nat] : ( times_times @ A @ ( F2 @ N3 ) @ ( power_power @ A @ Z @ N3 ) ) )
         => ( ( times_times @ A
              @ ( suminf @ A
                @ ^ [N3: nat] : ( times_times @ A @ ( F2 @ ( suc @ N3 ) ) @ ( power_power @ A @ Z @ N3 ) ) )
              @ Z )
            = ( minus_minus @ A
              @ ( suminf @ A
                @ ^ [N3: nat] : ( times_times @ A @ ( F2 @ N3 ) @ ( power_power @ A @ Z @ N3 ) ) )
              @ ( F2 @ ( zero_zero @ nat ) ) ) ) ) ) ).

% powser_split_head(2)
thf(fact_4200_suminf__exist__split,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [R2: real,F2: nat > A] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ R2 )
         => ( ( summable @ A @ F2 )
           => ? [N9: nat] :
              ! [N7: nat] :
                ( ( ord_less_eq @ nat @ N9 @ N7 )
               => ( ord_less @ real
                  @ ( real_V7770717601297561774m_norm @ A
                    @ ( suminf @ A
                      @ ^ [I4: nat] : ( F2 @ ( plus_plus @ nat @ I4 @ N7 ) ) ) )
                  @ R2 ) ) ) ) ) ).

% suminf_exist_split
thf(fact_4201_summable__power__series,axiom,
    ! [F2: nat > real,Z: real] :
      ( ! [I2: nat] : ( ord_less_eq @ real @ ( F2 @ I2 ) @ ( one_one @ real ) )
     => ( ! [I2: nat] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( F2 @ I2 ) )
       => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ Z )
         => ( ( ord_less @ real @ Z @ ( one_one @ real ) )
           => ( summable @ real
              @ ^ [I4: nat] : ( times_times @ real @ ( F2 @ I4 ) @ ( power_power @ real @ Z @ I4 ) ) ) ) ) ) ) ).

% summable_power_series
thf(fact_4202_Abel__lemma,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [R2: real,R0: real,A2: nat > A,M5: real] :
          ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ R2 )
         => ( ( ord_less @ real @ R2 @ R0 )
           => ( ! [N2: nat] : ( ord_less_eq @ real @ ( times_times @ real @ ( real_V7770717601297561774m_norm @ A @ ( A2 @ N2 ) ) @ ( power_power @ real @ R0 @ N2 ) ) @ M5 )
             => ( summable @ real
                @ ^ [N3: nat] : ( times_times @ real @ ( real_V7770717601297561774m_norm @ A @ ( A2 @ N3 ) ) @ ( power_power @ real @ R2 @ N3 ) ) ) ) ) ) ) ).

% Abel_lemma
thf(fact_4203_sinh__zero__iff,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A] :
          ( ( ( sinh @ A @ X )
            = ( zero_zero @ A ) )
          = ( member @ A @ ( exp @ A @ X ) @ ( insert @ A @ ( one_one @ A ) @ ( insert @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ).

% sinh_zero_iff
thf(fact_4204_summable__ratio__test,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach @ A )
     => ! [C2: real,N4: nat,F2: nat > A] :
          ( ( ord_less @ real @ C2 @ ( one_one @ real ) )
         => ( ! [N2: nat] :
                ( ( ord_less_eq @ nat @ N4 @ N2 )
               => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( F2 @ ( suc @ N2 ) ) ) @ ( times_times @ real @ C2 @ ( real_V7770717601297561774m_norm @ A @ ( F2 @ N2 ) ) ) ) )
           => ( summable @ A @ F2 ) ) ) ) ).

% summable_ratio_test
thf(fact_4205_vebt__buildup_Osimps_I3_J,axiom,
    ! [Va3: nat] :
      ( ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( suc @ ( suc @ Va3 ) ) )
       => ( ( vEBT_vebt_buildup @ ( suc @ ( suc @ Va3 ) ) )
          = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ ( suc @ Va3 ) ) @ ( replicate @ vEBT_VEBT @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( divide_divide @ nat @ ( suc @ ( suc @ Va3 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( vEBT_vebt_buildup @ ( divide_divide @ nat @ ( suc @ ( suc @ Va3 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_vebt_buildup @ ( divide_divide @ nat @ ( suc @ ( suc @ Va3 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) )
      & ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( suc @ ( suc @ Va3 ) ) )
       => ( ( vEBT_vebt_buildup @ ( suc @ ( suc @ Va3 ) ) )
          = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ ( suc @ Va3 ) ) @ ( replicate @ vEBT_VEBT @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( suc @ ( divide_divide @ nat @ ( suc @ ( suc @ Va3 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_vebt_buildup @ ( divide_divide @ nat @ ( suc @ ( suc @ Va3 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_vebt_buildup @ ( suc @ ( divide_divide @ nat @ ( suc @ ( suc @ Va3 ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ).

% vebt_buildup.simps(3)
thf(fact_4206_and__int_Opsimps,axiom,
    ! [K: int,L: int] :
      ( ( accp @ ( product_prod @ int @ int ) @ bit_and_int_rel @ ( product_Pair @ int @ int @ K @ L ) )
     => ( ( ( ( member @ int @ K @ ( insert @ int @ ( zero_zero @ int ) @ ( insert @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) )
            & ( member @ int @ L @ ( insert @ int @ ( zero_zero @ int ) @ ( insert @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) ) )
         => ( ( bit_se5824344872417868541ns_and @ int @ K @ L )
            = ( uminus_uminus @ int
              @ ( zero_neq_one_of_bool @ int
                @ ( ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ K )
                  & ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ L ) ) ) ) ) )
        & ( ~ ( ( member @ int @ K @ ( insert @ int @ ( zero_zero @ int ) @ ( insert @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) )
              & ( member @ int @ L @ ( insert @ int @ ( zero_zero @ int ) @ ( insert @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) ) )
         => ( ( bit_se5824344872417868541ns_and @ int @ K @ L )
            = ( plus_plus @ int
              @ ( zero_neq_one_of_bool @ int
                @ ( ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ K )
                  & ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ L ) ) )
              @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se5824344872417868541ns_and @ int @ ( divide_divide @ int @ K @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ int @ L @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ).

% and_int.psimps
thf(fact_4207_and__int_Opelims,axiom,
    ! [X: int,Xa: int,Y: int] :
      ( ( ( bit_se5824344872417868541ns_and @ int @ X @ Xa )
        = Y )
     => ( ( accp @ ( product_prod @ int @ int ) @ bit_and_int_rel @ ( product_Pair @ int @ int @ X @ Xa ) )
       => ~ ( ( ( ( ( member @ int @ X @ ( insert @ int @ ( zero_zero @ int ) @ ( insert @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) )
                  & ( member @ int @ Xa @ ( insert @ int @ ( zero_zero @ int ) @ ( insert @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) ) )
               => ( Y
                  = ( uminus_uminus @ int
                    @ ( zero_neq_one_of_bool @ int
                      @ ( ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ X )
                        & ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ Xa ) ) ) ) ) )
              & ( ~ ( ( member @ int @ X @ ( insert @ int @ ( zero_zero @ int ) @ ( insert @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) )
                    & ( member @ int @ Xa @ ( insert @ int @ ( zero_zero @ int ) @ ( insert @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) ) )
               => ( Y
                  = ( plus_plus @ int
                    @ ( zero_neq_one_of_bool @ int
                      @ ( ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ X )
                        & ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ Xa ) ) )
                    @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( bit_se5824344872417868541ns_and @ int @ ( divide_divide @ int @ X @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ int @ Xa @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) ) ) ) )
           => ~ ( accp @ ( product_prod @ int @ int ) @ bit_and_int_rel @ ( product_Pair @ int @ int @ X @ Xa ) ) ) ) ) ).

% and_int.pelims
thf(fact_4208_sin__paired,axiom,
    ! [X: real] :
      ( sums @ real
      @ ^ [N3: nat] : ( times_times @ real @ ( divide_divide @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ N3 ) @ ( semiring_char_0_fact @ real @ ( plus_plus @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N3 ) @ ( one_one @ nat ) ) ) ) @ ( power_power @ real @ X @ ( plus_plus @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N3 ) @ ( one_one @ nat ) ) ) )
      @ ( sin @ real @ X ) ) ).

% sin_paired
thf(fact_4209_sum__gp,axiom,
    ! [A: $tType] :
      ( ( ( division_ring @ A )
        & ( comm_ring @ A ) )
     => ! [N: nat,M: nat,X: A] :
          ( ( ( ord_less @ nat @ N @ M )
           => ( ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X ) @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) )
              = ( zero_zero @ A ) ) )
          & ( ~ ( ord_less @ nat @ N @ M )
           => ( ( ( X
                  = ( one_one @ A ) )
               => ( ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X ) @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) )
                  = ( semiring_1_of_nat @ A @ ( minus_minus @ nat @ ( plus_plus @ nat @ N @ ( one_one @ nat ) ) @ M ) ) ) )
              & ( ( X
                 != ( one_one @ A ) )
               => ( ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X ) @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) )
                  = ( divide_divide @ A @ ( minus_minus @ A @ ( power_power @ A @ X @ M ) @ ( power_power @ A @ X @ ( suc @ N ) ) ) @ ( minus_minus @ A @ ( one_one @ A ) @ X ) ) ) ) ) ) ) ) ).

% sum_gp
thf(fact_4210_Ints__sum,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ring_1 @ B )
     => ! [A4: set @ A,F2: A > B] :
          ( ! [X3: A] :
              ( ( member @ A @ X3 @ A4 )
             => ( member @ B @ ( F2 @ X3 ) @ ( ring_1_Ints @ B ) ) )
         => ( member @ B @ ( groups7311177749621191930dd_sum @ A @ B @ F2 @ A4 ) @ ( ring_1_Ints @ B ) ) ) ) ).

% Ints_sum
thf(fact_4211_sum_Oneutral__const,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A4: set @ B] :
          ( ( groups7311177749621191930dd_sum @ B @ A
            @ ^ [Uu3: B] : ( zero_zero @ A )
            @ A4 )
          = ( zero_zero @ A ) ) ) ).

% sum.neutral_const
thf(fact_4212_of__nat__sum,axiom,
    ! [A: $tType,B: $tType] :
      ( ( semiring_1 @ A )
     => ! [F2: B > nat,A4: set @ B] :
          ( ( semiring_1_of_nat @ A @ ( groups7311177749621191930dd_sum @ B @ nat @ F2 @ A4 ) )
          = ( groups7311177749621191930dd_sum @ B @ A
            @ ^ [X2: B] : ( semiring_1_of_nat @ A @ ( F2 @ X2 ) )
            @ A4 ) ) ) ).

% of_nat_sum
thf(fact_4213_of__int__sum,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ring_1 @ A )
     => ! [F2: B > int,A4: set @ B] :
          ( ( ring_1_of_int @ A @ ( groups7311177749621191930dd_sum @ B @ int @ F2 @ A4 ) )
          = ( groups7311177749621191930dd_sum @ B @ A
            @ ^ [X2: B] : ( ring_1_of_int @ A @ ( F2 @ X2 ) )
            @ A4 ) ) ) ).

% of_int_sum
thf(fact_4214_sums__zero,axiom,
    ! [A: $tType] :
      ( ( ( comm_monoid_add @ A )
        & ( topolo4958980785337419405_space @ A ) )
     => ( sums @ A
        @ ^ [N3: nat] : ( zero_zero @ A )
        @ ( zero_zero @ A ) ) ) ).

% sums_zero
thf(fact_4215_sum_Oempty,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: B > A] :
          ( ( groups7311177749621191930dd_sum @ B @ A @ G @ ( bot_bot @ ( set @ B ) ) )
          = ( zero_zero @ A ) ) ) ).

% sum.empty
thf(fact_4216_sum__abs,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ordere166539214618696060dd_abs @ B )
     => ! [F2: A > B,A4: set @ A] :
          ( ord_less_eq @ B @ ( abs_abs @ B @ ( groups7311177749621191930dd_sum @ A @ B @ F2 @ A4 ) )
          @ ( groups7311177749621191930dd_sum @ A @ B
            @ ^ [I4: A] : ( abs_abs @ B @ ( F2 @ I4 ) )
            @ A4 ) ) ) ).

% sum_abs
thf(fact_4217_sum__abs__ge__zero,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ordere166539214618696060dd_abs @ B )
     => ! [F2: A > B,A4: set @ A] :
          ( ord_less_eq @ B @ ( zero_zero @ B )
          @ ( groups7311177749621191930dd_sum @ A @ B
            @ ^ [I4: A] : ( abs_abs @ B @ ( F2 @ I4 ) )
            @ A4 ) ) ) ).

% sum_abs_ge_zero
thf(fact_4218_powser__sums__zero__iff,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [A2: nat > A,X: A] :
          ( ( sums @ A
            @ ^ [N3: nat] : ( times_times @ A @ ( A2 @ N3 ) @ ( power_power @ A @ ( zero_zero @ A ) @ N3 ) )
            @ X )
          = ( ( A2 @ ( zero_zero @ nat ) )
            = X ) ) ) ).

% powser_sums_zero_iff
thf(fact_4219_sum_Ocl__ivl__Suc,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [N: nat,M: nat,G: nat > A] :
          ( ( ( ord_less @ nat @ ( suc @ N ) @ M )
           => ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ ( suc @ N ) ) )
              = ( zero_zero @ A ) ) )
          & ( ~ ( ord_less @ nat @ ( suc @ N ) @ M )
           => ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ ( suc @ N ) ) )
              = ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) ) @ ( G @ ( suc @ N ) ) ) ) ) ) ) ).

% sum.cl_ivl_Suc
thf(fact_4220_sum__norm__le,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [S: set @ B,F2: B > A,G: B > real] :
          ( ! [X3: B] :
              ( ( member @ B @ X3 @ S )
             => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( F2 @ X3 ) ) @ ( G @ X3 ) ) )
         => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ S ) ) @ ( groups7311177749621191930dd_sum @ B @ real @ G @ S ) ) ) ) ).

% sum_norm_le
thf(fact_4221_norm__sum,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: B > A,A4: set @ B] :
          ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ A4 ) )
          @ ( groups7311177749621191930dd_sum @ B @ real
            @ ^ [I4: B] : ( real_V7770717601297561774m_norm @ A @ ( F2 @ I4 ) )
            @ A4 ) ) ) ).

% norm_sum
thf(fact_4222_sums__single,axiom,
    ! [A: $tType] :
      ( ( ( comm_monoid_add @ A )
        & ( topolo4958980785337419405_space @ A ) )
     => ! [I: nat,F2: nat > A] :
          ( sums @ A
          @ ^ [R5: nat] : ( if @ A @ ( R5 = I ) @ ( F2 @ R5 ) @ ( zero_zero @ A ) )
          @ ( F2 @ I ) ) ) ).

% sums_single
thf(fact_4223_sum__mono,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [K6: set @ B,F2: B > A,G: B > A] :
          ( ! [I2: B] :
              ( ( member @ B @ I2 @ K6 )
             => ( ord_less_eq @ A @ ( F2 @ I2 ) @ ( G @ I2 ) ) )
         => ( ord_less_eq @ A @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ K6 ) @ ( groups7311177749621191930dd_sum @ B @ A @ G @ K6 ) ) ) ) ).

% sum_mono
thf(fact_4224_sums__le,axiom,
    ! [A: $tType] :
      ( ( ( ordere6911136660526730532id_add @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [F2: nat > A,G: nat > A,S2: A,T2: A] :
          ( ! [N2: nat] : ( ord_less_eq @ A @ ( F2 @ N2 ) @ ( G @ N2 ) )
         => ( ( sums @ A @ F2 @ S2 )
           => ( ( sums @ A @ G @ T2 )
             => ( ord_less_eq @ A @ S2 @ T2 ) ) ) ) ) ).

% sums_le
thf(fact_4225_sum_Onot__neutral__contains__not__neutral,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: B > A,A4: set @ B] :
          ( ( ( groups7311177749621191930dd_sum @ B @ A @ G @ A4 )
           != ( zero_zero @ A ) )
         => ~ ! [A5: B] :
                ( ( member @ B @ A5 @ A4 )
               => ( ( G @ A5 )
                  = ( zero_zero @ A ) ) ) ) ) ).

% sum.not_neutral_contains_not_neutral
thf(fact_4226_sum_Oneutral,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A4: set @ B,G: B > A] :
          ( ! [X3: B] :
              ( ( member @ B @ X3 @ A4 )
             => ( ( G @ X3 )
                = ( zero_zero @ A ) ) )
         => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ A4 )
            = ( zero_zero @ A ) ) ) ) ).

% sum.neutral
thf(fact_4227_sums__0,axiom,
    ! [A: $tType] :
      ( ( ( comm_monoid_add @ A )
        & ( topolo4958980785337419405_space @ A ) )
     => ! [F2: nat > A] :
          ( ! [N2: nat] :
              ( ( F2 @ N2 )
              = ( zero_zero @ A ) )
         => ( sums @ A @ F2 @ ( zero_zero @ A ) ) ) ) ).

% sums_0
thf(fact_4228_sum__nonneg,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [A4: set @ B,F2: B > A] :
          ( ! [X3: B] :
              ( ( member @ B @ X3 @ A4 )
             => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( F2 @ X3 ) ) )
         => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ A4 ) ) ) ) ).

% sum_nonneg
thf(fact_4229_sum__nonpos,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [A4: set @ B,F2: B > A] :
          ( ! [X3: B] :
              ( ( member @ B @ X3 @ A4 )
             => ( ord_less_eq @ A @ ( F2 @ X3 ) @ ( zero_zero @ A ) ) )
         => ( ord_less_eq @ A @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ A4 ) @ ( zero_zero @ A ) ) ) ) ).

% sum_nonpos
thf(fact_4230_sum__cong__Suc,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A4: set @ nat,F2: nat > A,G: nat > A] :
          ( ~ ( member @ nat @ ( zero_zero @ nat ) @ A4 )
         => ( ! [X3: nat] :
                ( ( member @ nat @ ( suc @ X3 ) @ A4 )
               => ( ( F2 @ ( suc @ X3 ) )
                  = ( G @ ( suc @ X3 ) ) ) )
           => ( ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ A4 )
              = ( groups7311177749621191930dd_sum @ nat @ A @ G @ A4 ) ) ) ) ) ).

% sum_cong_Suc
thf(fact_4231_sums__mult__iff,axiom,
    ! [A: $tType] :
      ( ( ( field @ A )
        & ( real_V4412858255891104859lgebra @ A ) )
     => ! [C2: A,F2: nat > A,D2: A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( sums @ A
              @ ^ [N3: nat] : ( times_times @ A @ C2 @ ( F2 @ N3 ) )
              @ ( times_times @ A @ C2 @ D2 ) )
            = ( sums @ A @ F2 @ D2 ) ) ) ) ).

% sums_mult_iff
thf(fact_4232_sums__mult2__iff,axiom,
    ! [A: $tType] :
      ( ( ( field @ A )
        & ( real_V4412858255891104859lgebra @ A ) )
     => ! [C2: A,F2: nat > A,D2: A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( sums @ A
              @ ^ [N3: nat] : ( times_times @ A @ ( F2 @ N3 ) @ C2 )
              @ ( times_times @ A @ D2 @ C2 ) )
            = ( sums @ A @ F2 @ D2 ) ) ) ) ).

% sums_mult2_iff
thf(fact_4233_sums__mult__D,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [C2: A,F2: nat > A,A2: A] :
          ( ( sums @ A
            @ ^ [N3: nat] : ( times_times @ A @ C2 @ ( F2 @ N3 ) )
            @ A2 )
         => ( ( C2
             != ( zero_zero @ A ) )
           => ( sums @ A @ F2 @ ( divide_divide @ A @ A2 @ C2 ) ) ) ) ) ).

% sums_mult_D
thf(fact_4234_sums__Suc__imp,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: nat > A,S2: A] :
          ( ( ( F2 @ ( zero_zero @ nat ) )
            = ( zero_zero @ A ) )
         => ( ( sums @ A
              @ ^ [N3: nat] : ( F2 @ ( suc @ N3 ) )
              @ S2 )
           => ( sums @ A @ F2 @ S2 ) ) ) ) ).

% sums_Suc_imp
thf(fact_4235_sums__Suc,axiom,
    ! [A: $tType] :
      ( ( ( topolo5987344860129210374id_add @ A )
        & ( topological_t2_space @ A ) )
     => ! [F2: nat > A,L: A] :
          ( ( sums @ A
            @ ^ [N3: nat] : ( F2 @ ( suc @ N3 ) )
            @ L )
         => ( sums @ A @ F2 @ ( plus_plus @ A @ L @ ( F2 @ ( zero_zero @ nat ) ) ) ) ) ) ).

% sums_Suc
thf(fact_4236_sums__Suc__iff,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: nat > A,S2: A] :
          ( ( sums @ A
            @ ^ [N3: nat] : ( F2 @ ( suc @ N3 ) )
            @ S2 )
          = ( sums @ A @ F2 @ ( plus_plus @ A @ S2 @ ( F2 @ ( zero_zero @ nat ) ) ) ) ) ) ).

% sums_Suc_iff
thf(fact_4237_sums__zero__iff__shift,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [N: nat,F2: nat > A,S2: A] :
          ( ! [I2: nat] :
              ( ( ord_less @ nat @ I2 @ N )
             => ( ( F2 @ I2 )
                = ( zero_zero @ A ) ) )
         => ( ( sums @ A
              @ ^ [I4: nat] : ( F2 @ ( plus_plus @ nat @ I4 @ N ) )
              @ S2 )
            = ( sums @ A @ F2 @ S2 ) ) ) ) ).

% sums_zero_iff_shift
thf(fact_4238_atLeast0__atMost__Suc,axiom,
    ! [N: nat] :
      ( ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ ( suc @ N ) )
      = ( insert @ nat @ ( suc @ N ) @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N ) ) ) ).

% atLeast0_atMost_Suc
thf(fact_4239_Icc__eq__insert__lb__nat,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ M @ N )
     => ( ( set_or1337092689740270186AtMost @ nat @ M @ N )
        = ( insert @ nat @ M @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ M ) @ N ) ) ) ) ).

% Icc_eq_insert_lb_nat
thf(fact_4240_atLeastAtMostSuc__conv,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ M @ ( suc @ N ) )
     => ( ( set_or1337092689740270186AtMost @ nat @ M @ ( suc @ N ) )
        = ( insert @ nat @ ( suc @ N ) @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) ) ) ) ).

% atLeastAtMostSuc_conv
thf(fact_4241_atLeastAtMost__insertL,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ M @ N )
     => ( ( insert @ nat @ M @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ M ) @ N ) )
        = ( set_or1337092689740270186AtMost @ nat @ M @ N ) ) ) ).

% atLeastAtMost_insertL
thf(fact_4242_sum__power__add,axiom,
    ! [A: $tType] :
      ( ( ( monoid_mult @ A )
        & ( comm_ring @ A ) )
     => ! [X: A,M: nat,I5: set @ nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [I4: nat] : ( power_power @ A @ X @ ( plus_plus @ nat @ M @ I4 ) )
            @ I5 )
          = ( times_times @ A @ ( power_power @ A @ X @ M ) @ ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X ) @ I5 ) ) ) ) ).

% sum_power_add
thf(fact_4243_powser__sums__if,axiom,
    ! [A: $tType] :
      ( ( ( ring_1 @ A )
        & ( topolo4958980785337419405_space @ A ) )
     => ! [M: nat,Z: A] :
          ( sums @ A
          @ ^ [N3: nat] : ( times_times @ A @ ( if @ A @ ( N3 = M ) @ ( one_one @ A ) @ ( zero_zero @ A ) ) @ ( power_power @ A @ Z @ N3 ) )
          @ ( power_power @ A @ Z @ M ) ) ) ).

% powser_sums_if
thf(fact_4244_powser__sums__zero,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [A2: nat > A] :
          ( sums @ A
          @ ^ [N3: nat] : ( times_times @ A @ ( A2 @ N3 ) @ ( power_power @ A @ ( zero_zero @ A ) @ N3 ) )
          @ ( A2 @ ( zero_zero @ nat ) ) ) ) ).

% powser_sums_zero
thf(fact_4245_sum__shift__lb__Suc0__0,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [F2: nat > A,K: nat] :
          ( ( ( F2 @ ( zero_zero @ nat ) )
            = ( zero_zero @ A ) )
         => ( ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ ( zero_zero @ nat ) ) @ K ) )
            = ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ K ) ) ) ) ) ).

% sum_shift_lb_Suc0_0
thf(fact_4246_sum_OatLeast0__atMost__Suc,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ ( suc @ N ) ) )
          = ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N ) ) @ ( G @ ( suc @ N ) ) ) ) ) ).

% sum.atLeast0_atMost_Suc
thf(fact_4247_sum_Onat__ivl__Suc_H,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [M: nat,N: nat,G: nat > A] :
          ( ( ord_less_eq @ nat @ M @ ( suc @ N ) )
         => ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ ( suc @ N ) ) )
            = ( plus_plus @ A @ ( G @ ( suc @ N ) ) @ ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) ) ) ) ) ) ).

% sum.nat_ivl_Suc'
thf(fact_4248_sum_OatLeast__Suc__atMost,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [M: nat,N: nat,G: nat > A] :
          ( ( ord_less_eq @ nat @ M @ N )
         => ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) )
            = ( plus_plus @ A @ ( G @ M ) @ ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ M ) @ N ) ) ) ) ) ) ).

% sum.atLeast_Suc_atMost
thf(fact_4249_sin__converges,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [X: A] :
          ( sums @ A
          @ ^ [N3: nat] : ( real_V8093663219630862766scaleR @ A @ ( sin_coeff @ N3 ) @ ( power_power @ A @ X @ N3 ) )
          @ ( sin @ A @ X ) ) ) ).

% sin_converges
thf(fact_4250_cos__converges,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [X: A] :
          ( sums @ A
          @ ^ [N3: nat] : ( real_V8093663219630862766scaleR @ A @ ( cos_coeff @ N3 ) @ ( power_power @ A @ X @ N3 ) )
          @ ( cos @ A @ X ) ) ) ).

% cos_converges
thf(fact_4251_sum_OSuc__reindex__ivl,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [M: nat,N: nat,G: nat > A] :
          ( ( ord_less_eq @ nat @ M @ N )
         => ( ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) ) @ ( G @ ( suc @ N ) ) )
            = ( plus_plus @ A @ ( G @ M )
              @ ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I4: nat] : ( G @ ( suc @ I4 ) )
                @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) ) ) ) ) ) ).

% sum.Suc_reindex_ivl
thf(fact_4252_sum__Suc__diff,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [M: nat,N: nat,F2: nat > A] :
          ( ( ord_less_eq @ nat @ M @ ( suc @ N ) )
         => ( ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [I4: nat] : ( minus_minus @ A @ ( F2 @ ( suc @ I4 ) ) @ ( F2 @ I4 ) )
              @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) )
            = ( minus_minus @ A @ ( F2 @ ( suc @ N ) ) @ ( F2 @ M ) ) ) ) ) ).

% sum_Suc_diff
thf(fact_4253_sum__atLeastAtMost__code,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [F2: nat > A,A2: nat,B2: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_or1337092689740270186AtMost @ nat @ A2 @ B2 ) )
          = ( set_fo6178422350223883121st_nat @ A
            @ ^ [A3: nat] : ( plus_plus @ A @ ( F2 @ A3 ) )
            @ A2
            @ B2
            @ ( zero_zero @ A ) ) ) ) ).

% sum_atLeastAtMost_code
thf(fact_4254_sum_Oub__add__nat,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [M: nat,N: nat,G: nat > A,P6: nat] :
          ( ( ord_less_eq @ nat @ M @ ( plus_plus @ nat @ N @ ( one_one @ nat ) ) )
         => ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ ( plus_plus @ nat @ N @ P6 ) ) )
            = ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) ) @ ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( plus_plus @ nat @ N @ ( one_one @ nat ) ) @ ( plus_plus @ nat @ N @ P6 ) ) ) ) ) ) ) ).

% sum.ub_add_nat
thf(fact_4255_exp__converges,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [X: A] :
          ( sums @ A
          @ ^ [N3: nat] : ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ ( semiring_char_0_fact @ real @ N3 ) ) @ ( power_power @ A @ X @ N3 ) )
          @ ( exp @ A @ X ) ) ) ).

% exp_converges
thf(fact_4256_sin__minus__converges,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [X: A] :
          ( sums @ A
          @ ^ [N3: nat] : ( uminus_uminus @ A @ ( real_V8093663219630862766scaleR @ A @ ( sin_coeff @ N3 ) @ ( power_power @ A @ ( uminus_uminus @ A @ X ) @ N3 ) ) )
          @ ( sin @ A @ X ) ) ) ).

% sin_minus_converges
thf(fact_4257_cos__minus__converges,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [X: A] :
          ( sums @ A
          @ ^ [N3: nat] : ( real_V8093663219630862766scaleR @ A @ ( cos_coeff @ N3 ) @ ( power_power @ A @ ( uminus_uminus @ A @ X ) @ N3 ) )
          @ ( cos @ A @ X ) ) ) ).

% cos_minus_converges
thf(fact_4258_convex__sum__bound__le,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linordered_idom @ B )
     => ! [I5: set @ A,X: A > B,A2: A > B,B2: B,Delta: B] :
          ( ! [I2: A] :
              ( ( member @ A @ I2 @ I5 )
             => ( ord_less_eq @ B @ ( zero_zero @ B ) @ ( X @ I2 ) ) )
         => ( ( ( groups7311177749621191930dd_sum @ A @ B @ X @ I5 )
              = ( one_one @ B ) )
           => ( ! [I2: A] :
                  ( ( member @ A @ I2 @ I5 )
                 => ( ord_less_eq @ B @ ( abs_abs @ B @ ( minus_minus @ B @ ( A2 @ I2 ) @ B2 ) ) @ Delta ) )
             => ( ord_less_eq @ B
                @ ( abs_abs @ B
                  @ ( minus_minus @ B
                    @ ( groups7311177749621191930dd_sum @ A @ B
                      @ ^ [I4: A] : ( times_times @ B @ ( A2 @ I4 ) @ ( X @ I4 ) )
                      @ I5 )
                    @ B2 ) )
                @ Delta ) ) ) ) ) ).

% convex_sum_bound_le
thf(fact_4259_sum__natinterval__diff,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [M: nat,N: nat,F2: nat > A] :
          ( ( ( ord_less_eq @ nat @ M @ N )
           => ( ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [K3: nat] : ( minus_minus @ A @ ( F2 @ K3 ) @ ( F2 @ ( plus_plus @ nat @ K3 @ ( one_one @ nat ) ) ) )
                @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) )
              = ( minus_minus @ A @ ( F2 @ M ) @ ( F2 @ ( plus_plus @ nat @ N @ ( one_one @ nat ) ) ) ) ) )
          & ( ~ ( ord_less_eq @ nat @ M @ N )
           => ( ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [K3: nat] : ( minus_minus @ A @ ( F2 @ K3 ) @ ( F2 @ ( plus_plus @ nat @ K3 @ ( one_one @ nat ) ) ) )
                @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) )
              = ( zero_zero @ A ) ) ) ) ) ).

% sum_natinterval_diff
thf(fact_4260_sum__telescope_H_H,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [M: nat,N: nat,F2: nat > A] :
          ( ( ord_less_eq @ nat @ M @ N )
         => ( ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [K3: nat] : ( minus_minus @ A @ ( F2 @ K3 ) @ ( F2 @ ( minus_minus @ nat @ K3 @ ( one_one @ nat ) ) ) )
              @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ M ) @ N ) )
            = ( minus_minus @ A @ ( F2 @ N ) @ ( F2 @ M ) ) ) ) ) ).

% sum_telescope''
thf(fact_4261_summable__partial__sum__bound,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach @ A )
     => ! [F2: nat > A,E2: real] :
          ( ( summable @ A @ F2 )
         => ( ( ord_less @ real @ ( zero_zero @ real ) @ E2 )
           => ~ ! [N9: nat] :
                  ~ ! [M2: nat] :
                      ( ( ord_less_eq @ nat @ N9 @ M2 )
                     => ! [N7: nat] : ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_or1337092689740270186AtMost @ nat @ M2 @ N7 ) ) ) @ E2 ) ) ) ) ) ).

% summable_partial_sum_bound
thf(fact_4262_geometric__sums,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [C2: A] :
          ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ C2 ) @ ( one_one @ real ) )
         => ( sums @ A @ ( power_power @ A @ C2 ) @ ( divide_divide @ A @ ( one_one @ A ) @ ( minus_minus @ A @ ( one_one @ A ) @ C2 ) ) ) ) ) ).

% geometric_sums
thf(fact_4263_set__decode__plus__power__2,axiom,
    ! [N: nat,Z: nat] :
      ( ~ ( member @ nat @ N @ ( nat_set_decode @ Z ) )
     => ( ( nat_set_decode @ ( plus_plus @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) @ Z ) )
        = ( insert @ nat @ N @ ( nat_set_decode @ Z ) ) ) ) ).

% set_decode_plus_power_2
thf(fact_4264_power__half__series,axiom,
    ( sums @ real
    @ ^ [N3: nat] : ( power_power @ real @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( suc @ N3 ) )
    @ ( one_one @ real ) ) ).

% power_half_series
thf(fact_4265_mask__eq__sum__exp,axiom,
    ! [A: $tType] :
      ( ( semiring_parity @ A )
     => ! [N: nat] :
          ( ( minus_minus @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) @ ( one_one @ A ) )
          = ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
            @ ( collect @ nat
              @ ^ [Q6: nat] : ( ord_less @ nat @ Q6 @ N ) ) ) ) ) ).

% mask_eq_sum_exp
thf(fact_4266_sum__gp__multiplied,axiom,
    ! [A: $tType] :
      ( ( ( monoid_mult @ A )
        & ( comm_ring @ A ) )
     => ! [M: nat,N: nat,X: A] :
          ( ( ord_less_eq @ nat @ M @ N )
         => ( ( times_times @ A @ ( minus_minus @ A @ ( one_one @ A ) @ X ) @ ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X ) @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) ) )
            = ( minus_minus @ A @ ( power_power @ A @ X @ M ) @ ( power_power @ A @ X @ ( suc @ N ) ) ) ) ) ) ).

% sum_gp_multiplied
thf(fact_4267_sum_Oin__pairs,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,M: nat,N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M ) @ ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ) )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [I4: nat] : ( plus_plus @ A @ ( G @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ I4 ) ) @ ( G @ ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ I4 ) ) ) )
            @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) ) ) ) ).

% sum.in_pairs
thf(fact_4268_sums__if_H,axiom,
    ! [G: nat > real,X: real] :
      ( ( sums @ real @ G @ X )
     => ( sums @ real
        @ ^ [N3: nat] : ( if @ real @ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N3 ) @ ( zero_zero @ real ) @ ( G @ ( divide_divide @ nat @ ( minus_minus @ nat @ N3 @ ( one_one @ nat ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
        @ X ) ) ).

% sums_if'
thf(fact_4269_sums__if,axiom,
    ! [G: nat > real,X: real,F2: nat > real,Y: real] :
      ( ( sums @ real @ G @ X )
     => ( ( sums @ real @ F2 @ Y )
       => ( sums @ real
          @ ^ [N3: nat] : ( if @ real @ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N3 ) @ ( F2 @ ( divide_divide @ nat @ N3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( G @ ( divide_divide @ nat @ ( minus_minus @ nat @ N3 @ ( one_one @ nat ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
          @ ( plus_plus @ real @ X @ Y ) ) ) ) ).

% sums_if
thf(fact_4270_and__int_Opinduct,axiom,
    ! [A0: int,A12: int,P: int > int > $o] :
      ( ( accp @ ( product_prod @ int @ int ) @ bit_and_int_rel @ ( product_Pair @ int @ int @ A0 @ A12 ) )
     => ( ! [K2: int,L3: int] :
            ( ( accp @ ( product_prod @ int @ int ) @ bit_and_int_rel @ ( product_Pair @ int @ int @ K2 @ L3 ) )
           => ( ( ~ ( ( member @ int @ K2 @ ( insert @ int @ ( zero_zero @ int ) @ ( insert @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) )
                    & ( member @ int @ L3 @ ( insert @ int @ ( zero_zero @ int ) @ ( insert @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( bot_bot @ ( set @ int ) ) ) ) ) )
               => ( P @ ( divide_divide @ int @ K2 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) @ ( divide_divide @ int @ L3 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) )
             => ( P @ K2 @ L3 ) ) )
       => ( P @ A0 @ A12 ) ) ) ).

% and_int.pinduct
thf(fact_4271_mask__eq__sum__exp__nat,axiom,
    ! [N: nat] :
      ( ( minus_minus @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) @ ( suc @ ( zero_zero @ nat ) ) )
      = ( groups7311177749621191930dd_sum @ nat @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
        @ ( collect @ nat
          @ ^ [Q6: nat] : ( ord_less @ nat @ Q6 @ N ) ) ) ) ).

% mask_eq_sum_exp_nat
thf(fact_4272_gauss__sum__nat,axiom,
    ! [N: nat] :
      ( ( groups7311177749621191930dd_sum @ nat @ nat
        @ ^ [X2: nat] : X2
        @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N ) )
      = ( divide_divide @ nat @ ( times_times @ nat @ N @ ( suc @ N ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ).

% gauss_sum_nat
thf(fact_4273_gbinomial__sum__up__index,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [K: nat,N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [J3: nat] : ( gbinomial @ A @ ( semiring_1_of_nat @ A @ J3 ) @ K )
            @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N ) )
          = ( gbinomial @ A @ ( plus_plus @ A @ ( semiring_1_of_nat @ A @ N ) @ ( one_one @ A ) ) @ ( plus_plus @ nat @ K @ ( one_one @ nat ) ) ) ) ) ).

% gbinomial_sum_up_index
thf(fact_4274_double__gauss__sum,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [N: nat] :
          ( ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( groups7311177749621191930dd_sum @ nat @ A @ ( semiring_1_of_nat @ A ) @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N ) ) )
          = ( times_times @ A @ ( semiring_1_of_nat @ A @ N ) @ ( plus_plus @ A @ ( semiring_1_of_nat @ A @ N ) @ ( one_one @ A ) ) ) ) ) ).

% double_gauss_sum
thf(fact_4275_double__arith__series,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [A2: A,D2: A,N: nat] :
          ( ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) )
            @ ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [I4: nat] : ( plus_plus @ A @ A2 @ ( times_times @ A @ ( semiring_1_of_nat @ A @ I4 ) @ D2 ) )
              @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N ) ) )
          = ( times_times @ A @ ( plus_plus @ A @ ( semiring_1_of_nat @ A @ N ) @ ( one_one @ A ) ) @ ( plus_plus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) @ ( times_times @ A @ ( semiring_1_of_nat @ A @ N ) @ D2 ) ) ) ) ) ).

% double_arith_series
thf(fact_4276_arith__series__nat,axiom,
    ! [A2: nat,D2: nat,N: nat] :
      ( ( groups7311177749621191930dd_sum @ nat @ nat
        @ ^ [I4: nat] : ( plus_plus @ nat @ A2 @ ( times_times @ nat @ I4 @ D2 ) )
        @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N ) )
      = ( divide_divide @ nat @ ( times_times @ nat @ ( suc @ N ) @ ( plus_plus @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ A2 ) @ ( times_times @ nat @ N @ D2 ) ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ).

% arith_series_nat
thf(fact_4277_Sum__Icc__nat,axiom,
    ! [M: nat,N: nat] :
      ( ( groups7311177749621191930dd_sum @ nat @ nat
        @ ^ [X2: nat] : X2
        @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) )
      = ( divide_divide @ nat @ ( minus_minus @ nat @ ( times_times @ nat @ N @ ( plus_plus @ nat @ N @ ( one_one @ nat ) ) ) @ ( times_times @ nat @ M @ ( minus_minus @ nat @ M @ ( one_one @ nat ) ) ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ).

% Sum_Icc_nat
thf(fact_4278_cosh__converges,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [X: A] :
          ( sums @ A
          @ ^ [N3: nat] : ( if @ A @ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N3 ) @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ ( semiring_char_0_fact @ real @ N3 ) ) @ ( power_power @ A @ X @ N3 ) ) @ ( zero_zero @ A ) )
          @ ( cosh @ A @ X ) ) ) ).

% cosh_converges
thf(fact_4279_sinh__converges,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [X: A] :
          ( sums @ A
          @ ^ [N3: nat] : ( if @ A @ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N3 ) @ ( zero_zero @ A ) @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ ( semiring_char_0_fact @ real @ N3 ) ) @ ( power_power @ A @ X @ N3 ) ) )
          @ ( sinh @ A @ X ) ) ) ).

% sinh_converges
thf(fact_4280_arith__series,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [A2: A,D2: A,N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [I4: nat] : ( plus_plus @ A @ A2 @ ( times_times @ A @ ( semiring_1_of_nat @ A @ I4 ) @ D2 ) )
            @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N ) )
          = ( divide_divide @ A @ ( times_times @ A @ ( plus_plus @ A @ ( semiring_1_of_nat @ A @ N ) @ ( one_one @ A ) ) @ ( plus_plus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) @ ( times_times @ A @ ( semiring_1_of_nat @ A @ N ) @ D2 ) ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% arith_series
thf(fact_4281_gauss__sum,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ ( semiring_1_of_nat @ A ) @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N ) )
          = ( divide_divide @ A @ ( times_times @ A @ ( semiring_1_of_nat @ A @ N ) @ ( plus_plus @ A @ ( semiring_1_of_nat @ A @ N ) @ ( one_one @ A ) ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% gauss_sum
thf(fact_4282_double__gauss__sum__from__Suc__0,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [N: nat] :
          ( ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( groups7311177749621191930dd_sum @ nat @ A @ ( semiring_1_of_nat @ A ) @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ ( zero_zero @ nat ) ) @ N ) ) )
          = ( times_times @ A @ ( semiring_1_of_nat @ A @ N ) @ ( plus_plus @ A @ ( semiring_1_of_nat @ A @ N ) @ ( one_one @ A ) ) ) ) ) ).

% double_gauss_sum_from_Suc_0
thf(fact_4283_sum__gp__offset,axiom,
    ! [A: $tType] :
      ( ( ( division_ring @ A )
        & ( comm_ring @ A ) )
     => ! [X: A,M: nat,N: nat] :
          ( ( ( X
              = ( one_one @ A ) )
           => ( ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X ) @ ( set_or1337092689740270186AtMost @ nat @ M @ ( plus_plus @ nat @ M @ N ) ) )
              = ( plus_plus @ A @ ( semiring_1_of_nat @ A @ N ) @ ( one_one @ A ) ) ) )
          & ( ( X
             != ( one_one @ A ) )
           => ( ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X ) @ ( set_or1337092689740270186AtMost @ nat @ M @ ( plus_plus @ nat @ M @ N ) ) )
              = ( divide_divide @ A @ ( times_times @ A @ ( power_power @ A @ X @ M ) @ ( minus_minus @ A @ ( one_one @ A ) @ ( power_power @ A @ X @ ( suc @ N ) ) ) ) @ ( minus_minus @ A @ ( one_one @ A ) @ X ) ) ) ) ) ) ).

% sum_gp_offset
thf(fact_4284_cos__paired,axiom,
    ! [X: real] :
      ( sums @ real
      @ ^ [N3: nat] : ( times_times @ real @ ( divide_divide @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ N3 ) @ ( semiring_char_0_fact @ real @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N3 ) ) ) @ ( power_power @ real @ X @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N3 ) ) )
      @ ( cos @ real @ X ) ) ).

% cos_paired
thf(fact_4285_gauss__sum__from__Suc__0,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ ( semiring_1_of_nat @ A ) @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ ( zero_zero @ nat ) ) @ N ) )
          = ( divide_divide @ A @ ( times_times @ A @ ( semiring_1_of_nat @ A @ N ) @ ( plus_plus @ A @ ( semiring_1_of_nat @ A @ N ) @ ( one_one @ A ) ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) ) ) ).

% gauss_sum_from_Suc_0
thf(fact_4286_gchoose__row__sum__weighted,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [R2: A,M: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [K3: nat] : ( times_times @ A @ ( gbinomial @ A @ R2 @ K3 ) @ ( minus_minus @ A @ ( divide_divide @ A @ R2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( semiring_1_of_nat @ A @ K3 ) ) )
            @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ M ) )
          = ( times_times @ A @ ( divide_divide @ A @ ( semiring_1_of_nat @ A @ ( suc @ M ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( gbinomial @ A @ R2 @ ( suc @ M ) ) ) ) ) ).

% gchoose_row_sum_weighted
thf(fact_4287_geometric__deriv__sums,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [Z: A] :
          ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ Z ) @ ( one_one @ real ) )
         => ( sums @ A
            @ ^ [N3: nat] : ( times_times @ A @ ( semiring_1_of_nat @ A @ ( suc @ N3 ) ) @ ( power_power @ A @ Z @ N3 ) )
            @ ( divide_divide @ A @ ( one_one @ A ) @ ( power_power @ A @ ( minus_minus @ A @ ( one_one @ A ) @ Z ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% geometric_deriv_sums
thf(fact_4288_sin__x__sin__y,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A,Y: A] :
          ( sums @ A
          @ ^ [P5: nat] :
              ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [N3: nat] :
                  ( if @ A
                  @ ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ P5 )
                    & ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N3 ) )
                  @ ( times_times @ A @ ( real_V8093663219630862766scaleR @ A @ ( uminus_uminus @ real @ ( divide_divide @ real @ ( ring_1_of_int @ real @ ( times_times @ int @ ( power_power @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( divide_divide @ nat @ P5 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( semiring_1_of_nat @ int @ ( binomial @ P5 @ N3 ) ) ) ) @ ( semiring_char_0_fact @ real @ P5 ) ) ) @ ( power_power @ A @ X @ N3 ) ) @ ( power_power @ A @ Y @ ( minus_minus @ nat @ P5 @ N3 ) ) )
                  @ ( zero_zero @ A ) )
              @ ( set_ord_atMost @ nat @ P5 ) )
          @ ( times_times @ A @ ( sin @ A @ X ) @ ( sin @ A @ Y ) ) ) ) ).

% sin_x_sin_y
thf(fact_4289_sums__cos__x__plus__y,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A,Y: A] :
          ( sums @ A
          @ ^ [P5: nat] :
              ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [N3: nat] : ( if @ A @ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ P5 ) @ ( times_times @ A @ ( real_V8093663219630862766scaleR @ A @ ( divide_divide @ real @ ( ring_1_of_int @ real @ ( times_times @ int @ ( power_power @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( divide_divide @ nat @ P5 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( semiring_1_of_nat @ int @ ( binomial @ P5 @ N3 ) ) ) ) @ ( semiring_char_0_fact @ real @ P5 ) ) @ ( power_power @ A @ X @ N3 ) ) @ ( power_power @ A @ Y @ ( minus_minus @ nat @ P5 @ N3 ) ) ) @ ( zero_zero @ A ) )
              @ ( set_ord_atMost @ nat @ P5 ) )
          @ ( cos @ A @ ( plus_plus @ A @ X @ Y ) ) ) ) ).

% sums_cos_x_plus_y
thf(fact_4290_cos__x__cos__y,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A,Y: A] :
          ( sums @ A
          @ ^ [P5: nat] :
              ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [N3: nat] :
                  ( if @ A
                  @ ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ P5 )
                    & ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N3 ) )
                  @ ( times_times @ A @ ( real_V8093663219630862766scaleR @ A @ ( divide_divide @ real @ ( ring_1_of_int @ real @ ( times_times @ int @ ( power_power @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( divide_divide @ nat @ P5 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( semiring_1_of_nat @ int @ ( binomial @ P5 @ N3 ) ) ) ) @ ( semiring_char_0_fact @ real @ P5 ) ) @ ( power_power @ A @ X @ N3 ) ) @ ( power_power @ A @ Y @ ( minus_minus @ nat @ P5 @ N3 ) ) )
                  @ ( zero_zero @ A ) )
              @ ( set_ord_atMost @ nat @ P5 ) )
          @ ( times_times @ A @ ( cos @ A @ X ) @ ( cos @ A @ Y ) ) ) ) ).

% cos_x_cos_y
thf(fact_4291_Maclaurin__cos__expansion2,axiom,
    ! [X: real,N: nat] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
       => ? [T4: real] :
            ( ( ord_less @ real @ ( zero_zero @ real ) @ T4 )
            & ( ord_less @ real @ T4 @ X )
            & ( ( cos @ real @ X )
              = ( plus_plus @ real
                @ ( groups7311177749621191930dd_sum @ nat @ real
                  @ ^ [M3: nat] : ( times_times @ real @ ( cos_coeff @ M3 ) @ ( power_power @ real @ X @ M3 ) )
                  @ ( set_ord_lessThan @ nat @ N ) )
                @ ( times_times @ real @ ( divide_divide @ real @ ( cos @ real @ ( plus_plus @ real @ T4 @ ( times_times @ real @ ( times_times @ real @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( semiring_1_of_nat @ real @ N ) ) @ pi ) ) ) @ ( semiring_char_0_fact @ real @ N ) ) @ ( power_power @ real @ X @ N ) ) ) ) ) ) ) ).

% Maclaurin_cos_expansion2
thf(fact_4292_lessThan__iff,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [I: A,K: A] :
          ( ( member @ A @ I @ ( set_ord_lessThan @ A @ K ) )
          = ( ord_less @ A @ I @ K ) ) ) ).

% lessThan_iff
thf(fact_4293_atMost__iff,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [I: A,K: A] :
          ( ( member @ A @ I @ ( set_ord_atMost @ A @ K ) )
          = ( ord_less_eq @ A @ I @ K ) ) ) ).

% atMost_iff
thf(fact_4294_lessThan__subset__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ ( set @ A ) @ ( set_ord_lessThan @ A @ X ) @ ( set_ord_lessThan @ A @ Y ) )
          = ( ord_less_eq @ A @ X @ Y ) ) ) ).

% lessThan_subset_iff
thf(fact_4295_atMost__subset__iff,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ ( set @ A ) @ ( set_ord_atMost @ A @ X ) @ ( set_ord_atMost @ A @ Y ) )
          = ( ord_less_eq @ A @ X @ Y ) ) ) ).

% atMost_subset_iff
thf(fact_4296_lessThan__0,axiom,
    ( ( set_ord_lessThan @ nat @ ( zero_zero @ nat ) )
    = ( bot_bot @ ( set @ nat ) ) ) ).

% lessThan_0
thf(fact_4297_Icc__subset__Iic__iff,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [L: A,H2: A,H3: A] :
          ( ( ord_less_eq @ ( set @ A ) @ ( set_or1337092689740270186AtMost @ A @ L @ H2 ) @ ( set_ord_atMost @ A @ H3 ) )
          = ( ~ ( ord_less_eq @ A @ L @ H2 )
            | ( ord_less_eq @ A @ H2 @ H3 ) ) ) ) ).

% Icc_subset_Iic_iff
thf(fact_4298_atMost__0,axiom,
    ( ( set_ord_atMost @ nat @ ( zero_zero @ nat ) )
    = ( insert @ nat @ ( zero_zero @ nat ) @ ( bot_bot @ ( set @ nat ) ) ) ) ).

% atMost_0
thf(fact_4299_sumr__cos__zero__one,axiom,
    ! [N: nat] :
      ( ( groups7311177749621191930dd_sum @ nat @ real
        @ ^ [M3: nat] : ( times_times @ real @ ( cos_coeff @ M3 ) @ ( power_power @ real @ ( zero_zero @ real ) @ M3 ) )
        @ ( set_ord_lessThan @ nat @ ( suc @ N ) ) )
      = ( one_one @ real ) ) ).

% sumr_cos_zero_one
thf(fact_4300_sum__diff__distrib,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [Q: A > nat,P: A > nat,N: A] :
          ( ! [X3: A] : ( ord_less_eq @ nat @ ( Q @ X3 ) @ ( P @ X3 ) )
         => ( ( minus_minus @ nat @ ( groups7311177749621191930dd_sum @ A @ nat @ P @ ( set_ord_lessThan @ A @ N ) ) @ ( groups7311177749621191930dd_sum @ A @ nat @ Q @ ( set_ord_lessThan @ A @ N ) ) )
            = ( groups7311177749621191930dd_sum @ A @ nat
              @ ^ [X2: A] : ( minus_minus @ nat @ ( P @ X2 ) @ ( Q @ X2 ) )
              @ ( set_ord_lessThan @ A @ N ) ) ) ) ) ).

% sum_diff_distrib
thf(fact_4301_Complex__sum_H,axiom,
    ! [A: $tType,F2: A > real,S2: set @ A] :
      ( ( groups7311177749621191930dd_sum @ A @ complex
        @ ^ [X2: A] : ( complex2 @ ( F2 @ X2 ) @ ( zero_zero @ real ) )
        @ S2 )
      = ( complex2 @ ( groups7311177749621191930dd_sum @ A @ real @ F2 @ S2 ) @ ( zero_zero @ real ) ) ) ).

% Complex_sum'
thf(fact_4302_int__sum,axiom,
    ! [B: $tType,F2: B > nat,A4: set @ B] :
      ( ( semiring_1_of_nat @ int @ ( groups7311177749621191930dd_sum @ B @ nat @ F2 @ A4 ) )
      = ( groups7311177749621191930dd_sum @ B @ int
        @ ^ [X2: B] : ( semiring_1_of_nat @ int @ ( F2 @ X2 ) )
        @ A4 ) ) ).

% int_sum
thf(fact_4303_lessThan__def,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ( ( set_ord_lessThan @ A )
        = ( ^ [U2: A] :
              ( collect @ A
              @ ^ [X2: A] : ( ord_less @ A @ X2 @ U2 ) ) ) ) ) ).

% lessThan_def
thf(fact_4304_Iic__subset__Iio__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ ( set @ A ) @ ( set_ord_atMost @ A @ A2 ) @ ( set_ord_lessThan @ A @ B2 ) )
          = ( ord_less @ A @ A2 @ B2 ) ) ) ).

% Iic_subset_Iio_iff
thf(fact_4305_atMost__def,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ( ( set_ord_atMost @ A )
        = ( ^ [U2: A] :
              ( collect @ A
              @ ^ [X2: A] : ( ord_less_eq @ A @ X2 @ U2 ) ) ) ) ) ).

% atMost_def
thf(fact_4306_sum_OatMost__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_ord_atMost @ nat @ N ) )
          = ( plus_plus @ A @ ( G @ ( zero_zero @ nat ) )
            @ ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [I4: nat] : ( G @ ( suc @ I4 ) )
              @ ( set_ord_lessThan @ nat @ N ) ) ) ) ) ).

% sum.atMost_shift
thf(fact_4307_prod_OatMost__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,N: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_ord_atMost @ nat @ N ) )
          = ( times_times @ A @ ( G @ ( zero_zero @ nat ) )
            @ ( groups7121269368397514597t_prod @ nat @ A
              @ ^ [I4: nat] : ( G @ ( suc @ I4 ) )
              @ ( set_ord_lessThan @ nat @ N ) ) ) ) ) ).

% prod.atMost_shift
thf(fact_4308_atMost__atLeast0,axiom,
    ( ( set_ord_atMost @ nat )
    = ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) ) ) ).

% atMost_atLeast0
thf(fact_4309_lessThan__strict__subset__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [M: A,N: A] :
          ( ( ord_less @ ( set @ A ) @ ( set_ord_lessThan @ A @ M ) @ ( set_ord_lessThan @ A @ N ) )
          = ( ord_less @ A @ M @ N ) ) ) ).

% lessThan_strict_subset_iff
thf(fact_4310_atMost__nat__numeral,axiom,
    ! [K: num] :
      ( ( set_ord_atMost @ nat @ ( numeral_numeral @ nat @ K ) )
      = ( insert @ nat @ ( numeral_numeral @ nat @ K ) @ ( set_ord_atMost @ nat @ ( pred_numeral @ K ) ) ) ) ).

% atMost_nat_numeral
thf(fact_4311_lessThan__nat__numeral,axiom,
    ! [K: num] :
      ( ( set_ord_lessThan @ nat @ ( numeral_numeral @ nat @ K ) )
      = ( insert @ nat @ ( pred_numeral @ K ) @ ( set_ord_lessThan @ nat @ ( pred_numeral @ K ) ) ) ) ).

% lessThan_nat_numeral
thf(fact_4312_lessThan__empty__iff,axiom,
    ! [N: nat] :
      ( ( ( set_ord_lessThan @ nat @ N )
        = ( bot_bot @ ( set @ nat ) ) )
      = ( N
        = ( zero_zero @ nat ) ) ) ).

% lessThan_empty_iff
thf(fact_4313_power__sum,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [C2: A,F2: B > nat,A4: set @ B] :
          ( ( power_power @ A @ C2 @ ( groups7311177749621191930dd_sum @ B @ nat @ F2 @ A4 ) )
          = ( groups7121269368397514597t_prod @ B @ A
            @ ^ [A3: B] : ( power_power @ A @ C2 @ ( F2 @ A3 ) )
            @ A4 ) ) ) ).

% power_sum
thf(fact_4314_sum__subtractf__nat,axiom,
    ! [A: $tType,A4: set @ A,G: A > nat,F2: A > nat] :
      ( ! [X3: A] :
          ( ( member @ A @ X3 @ A4 )
         => ( ord_less_eq @ nat @ ( G @ X3 ) @ ( F2 @ X3 ) ) )
     => ( ( groups7311177749621191930dd_sum @ A @ nat
          @ ^ [X2: A] : ( minus_minus @ nat @ ( F2 @ X2 ) @ ( G @ X2 ) )
          @ A4 )
        = ( minus_minus @ nat @ ( groups7311177749621191930dd_sum @ A @ nat @ F2 @ A4 ) @ ( groups7311177749621191930dd_sum @ A @ nat @ G @ A4 ) ) ) ) ).

% sum_subtractf_nat
thf(fact_4315_polyfun__linear__factor__root,axiom,
    ! [A: $tType] :
      ( ( idom @ A )
     => ! [C2: nat > A,A2: A,N: nat] :
          ( ( ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [I4: nat] : ( times_times @ A @ ( C2 @ I4 ) @ ( power_power @ A @ A2 @ I4 ) )
              @ ( set_ord_atMost @ nat @ N ) )
            = ( zero_zero @ A ) )
         => ~ ! [B4: nat > A] :
                ~ ! [Z4: A] :
                    ( ( groups7311177749621191930dd_sum @ nat @ A
                      @ ^ [I4: nat] : ( times_times @ A @ ( C2 @ I4 ) @ ( power_power @ A @ Z4 @ I4 ) )
                      @ ( set_ord_atMost @ nat @ N ) )
                    = ( times_times @ A @ ( minus_minus @ A @ Z4 @ A2 )
                      @ ( groups7311177749621191930dd_sum @ nat @ A
                        @ ^ [I4: nat] : ( times_times @ A @ ( B4 @ I4 ) @ ( power_power @ A @ Z4 @ I4 ) )
                        @ ( set_ord_lessThan @ nat @ N ) ) ) ) ) ) ).

% polyfun_linear_factor_root
thf(fact_4316_polyfun__linear__factor,axiom,
    ! [A: $tType] :
      ( ( idom @ A )
     => ! [C2: nat > A,N: nat,A2: A] :
        ? [B4: nat > A] :
        ! [Z4: A] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [I4: nat] : ( times_times @ A @ ( C2 @ I4 ) @ ( power_power @ A @ Z4 @ I4 ) )
            @ ( set_ord_atMost @ nat @ N ) )
          = ( plus_plus @ A
            @ ( times_times @ A @ ( minus_minus @ A @ Z4 @ A2 )
              @ ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I4: nat] : ( times_times @ A @ ( B4 @ I4 ) @ ( power_power @ A @ Z4 @ I4 ) )
                @ ( set_ord_lessThan @ nat @ N ) ) )
            @ ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [I4: nat] : ( times_times @ A @ ( C2 @ I4 ) @ ( power_power @ A @ A2 @ I4 ) )
              @ ( set_ord_atMost @ nat @ N ) ) ) ) ) ).

% polyfun_linear_factor
thf(fact_4317_sum__SucD,axiom,
    ! [A: $tType,F2: A > nat,A4: set @ A,N: nat] :
      ( ( ( groups7311177749621191930dd_sum @ A @ nat @ F2 @ A4 )
        = ( suc @ N ) )
     => ? [X3: A] :
          ( ( member @ A @ X3 @ A4 )
          & ( ord_less @ nat @ ( zero_zero @ nat ) @ ( F2 @ X3 ) ) ) ) ).

% sum_SucD
thf(fact_4318_polyfun__diff__alt,axiom,
    ! [A: $tType] :
      ( ( idom @ A )
     => ! [N: nat,A2: nat > A,X: A,Y: A] :
          ( ( ord_less_eq @ nat @ ( one_one @ nat ) @ N )
         => ( ( minus_minus @ A
              @ ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I4: nat] : ( times_times @ A @ ( A2 @ I4 ) @ ( power_power @ A @ X @ I4 ) )
                @ ( set_ord_atMost @ nat @ N ) )
              @ ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I4: nat] : ( times_times @ A @ ( A2 @ I4 ) @ ( power_power @ A @ Y @ I4 ) )
                @ ( set_ord_atMost @ nat @ N ) ) )
            = ( times_times @ A @ ( minus_minus @ A @ X @ Y )
              @ ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [J3: nat] :
                    ( groups7311177749621191930dd_sum @ nat @ A
                    @ ^ [K3: nat] : ( times_times @ A @ ( times_times @ A @ ( A2 @ ( plus_plus @ nat @ ( plus_plus @ nat @ J3 @ K3 ) @ ( one_one @ nat ) ) ) @ ( power_power @ A @ Y @ K3 ) ) @ ( power_power @ A @ X @ J3 ) )
                    @ ( set_ord_lessThan @ nat @ ( minus_minus @ nat @ N @ J3 ) ) )
                @ ( set_ord_lessThan @ nat @ N ) ) ) ) ) ) ).

% polyfun_diff_alt
thf(fact_4319_suminf__le__const,axiom,
    ! [A: $tType] :
      ( ( ( ordere6911136660526730532id_add @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [F2: nat > A,X: A] :
          ( ( summable @ A @ F2 )
         => ( ! [N2: nat] : ( ord_less_eq @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_ord_lessThan @ nat @ N2 ) ) @ X )
           => ( ord_less_eq @ A @ ( suminf @ A @ F2 ) @ X ) ) ) ) ).

% suminf_le_const
thf(fact_4320_atLeast1__atMost__eq__remove0,axiom,
    ! [N: nat] :
      ( ( set_or1337092689740270186AtMost @ nat @ ( suc @ ( zero_zero @ nat ) ) @ N )
      = ( minus_minus @ ( set @ nat ) @ ( set_ord_atMost @ nat @ N ) @ ( insert @ nat @ ( zero_zero @ nat ) @ ( bot_bot @ ( set @ nat ) ) ) ) ) ).

% atLeast1_atMost_eq_remove0
thf(fact_4321_sum_OatMost__Suc__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_ord_atMost @ nat @ ( suc @ N ) ) )
          = ( plus_plus @ A @ ( G @ ( zero_zero @ nat ) )
            @ ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [I4: nat] : ( G @ ( suc @ I4 ) )
              @ ( set_ord_atMost @ nat @ N ) ) ) ) ) ).

% sum.atMost_Suc_shift
thf(fact_4322_sum__telescope,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [F2: nat > A,I: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [I4: nat] : ( minus_minus @ A @ ( F2 @ I4 ) @ ( F2 @ ( suc @ I4 ) ) )
            @ ( set_ord_atMost @ nat @ I ) )
          = ( minus_minus @ A @ ( F2 @ ( zero_zero @ nat ) ) @ ( F2 @ ( suc @ I ) ) ) ) ) ).

% sum_telescope
thf(fact_4323_polyfun__eq__coeffs,axiom,
    ! [A: $tType] :
      ( ( ( real_V8999393235501362500lgebra @ A )
        & ( idom @ A ) )
     => ! [C2: nat > A,N: nat,D2: nat > A] :
          ( ( ! [X2: A] :
                ( ( groups7311177749621191930dd_sum @ nat @ A
                  @ ^ [I4: nat] : ( times_times @ A @ ( C2 @ I4 ) @ ( power_power @ A @ X2 @ I4 ) )
                  @ ( set_ord_atMost @ nat @ N ) )
                = ( groups7311177749621191930dd_sum @ nat @ A
                  @ ^ [I4: nat] : ( times_times @ A @ ( D2 @ I4 ) @ ( power_power @ A @ X2 @ I4 ) )
                  @ ( set_ord_atMost @ nat @ N ) ) ) )
          = ( ! [I4: nat] :
                ( ( ord_less_eq @ nat @ I4 @ N )
               => ( ( C2 @ I4 )
                  = ( D2 @ I4 ) ) ) ) ) ) ).

% polyfun_eq_coeffs
thf(fact_4324_bounded__imp__summable,axiom,
    ! [A: $tType] :
      ( ( ( condit6923001295902523014norder @ A )
        & ( linord2810124833399127020strict @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [A2: nat > A,B7: A] :
          ( ! [N2: nat] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( A2 @ N2 ) )
         => ( ! [N2: nat] : ( ord_less_eq @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ A2 @ ( set_ord_atMost @ nat @ N2 ) ) @ B7 )
           => ( summable @ A @ A2 ) ) ) ) ).

% bounded_imp_summable
thf(fact_4325_prod_OatMost__Suc__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,N: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_ord_atMost @ nat @ ( suc @ N ) ) )
          = ( times_times @ A @ ( G @ ( zero_zero @ nat ) )
            @ ( groups7121269368397514597t_prod @ nat @ A
              @ ^ [I4: nat] : ( G @ ( suc @ I4 ) )
              @ ( set_ord_atMost @ nat @ N ) ) ) ) ) ).

% prod.atMost_Suc_shift
thf(fact_4326_sum_OlessThan__Suc__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_ord_lessThan @ nat @ ( suc @ N ) ) )
          = ( plus_plus @ A @ ( G @ ( zero_zero @ nat ) )
            @ ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [I4: nat] : ( G @ ( suc @ I4 ) )
              @ ( set_ord_lessThan @ nat @ N ) ) ) ) ) ).

% sum.lessThan_Suc_shift
thf(fact_4327_sumr__diff__mult__const2,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [F2: nat > A,N: nat,R2: A] :
          ( ( minus_minus @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_ord_lessThan @ nat @ N ) ) @ ( times_times @ A @ ( semiring_1_of_nat @ A @ N ) @ R2 ) )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [I4: nat] : ( minus_minus @ A @ ( F2 @ I4 ) @ R2 )
            @ ( set_ord_lessThan @ nat @ N ) ) ) ) ).

% sumr_diff_mult_const2
thf(fact_4328_sum__lessThan__telescope,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [F2: nat > A,M: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [N3: nat] : ( minus_minus @ A @ ( F2 @ ( suc @ N3 ) ) @ ( F2 @ N3 ) )
            @ ( set_ord_lessThan @ nat @ M ) )
          = ( minus_minus @ A @ ( F2 @ M ) @ ( F2 @ ( zero_zero @ nat ) ) ) ) ) ).

% sum_lessThan_telescope
thf(fact_4329_sum__lessThan__telescope_H,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [F2: nat > A,M: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [N3: nat] : ( minus_minus @ A @ ( F2 @ N3 ) @ ( F2 @ ( suc @ N3 ) ) )
            @ ( set_ord_lessThan @ nat @ M ) )
          = ( minus_minus @ A @ ( F2 @ ( zero_zero @ nat ) ) @ ( F2 @ M ) ) ) ) ).

% sum_lessThan_telescope'
thf(fact_4330_summableI__nonneg__bounded,axiom,
    ! [A: $tType] :
      ( ( ( condit6923001295902523014norder @ A )
        & ( ordere6911136660526730532id_add @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [F2: nat > A,X: A] :
          ( ! [N2: nat] : ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( F2 @ N2 ) )
         => ( ! [N2: nat] : ( ord_less_eq @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_ord_lessThan @ nat @ N2 ) ) @ X )
           => ( summable @ A @ F2 ) ) ) ) ).

% summableI_nonneg_bounded
thf(fact_4331_prod_OlessThan__Suc__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,N: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_ord_lessThan @ nat @ ( suc @ N ) ) )
          = ( times_times @ A @ ( G @ ( zero_zero @ nat ) )
            @ ( groups7121269368397514597t_prod @ nat @ A
              @ ^ [I4: nat] : ( G @ ( suc @ I4 ) )
              @ ( set_ord_lessThan @ nat @ N ) ) ) ) ) ).

% prod.lessThan_Suc_shift
thf(fact_4332_sum__choose__diagonal,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ M @ N )
     => ( ( groups7311177749621191930dd_sum @ nat @ nat
          @ ^ [K3: nat] : ( binomial @ ( minus_minus @ nat @ N @ K3 ) @ ( minus_minus @ nat @ M @ K3 ) )
          @ ( set_ord_atMost @ nat @ M ) )
        = ( binomial @ ( suc @ N ) @ M ) ) ) ).

% sum_choose_diagonal
thf(fact_4333_sum_OatLeast1__atMost__eq,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ ( zero_zero @ nat ) ) @ N ) )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [K3: nat] : ( G @ ( suc @ K3 ) )
            @ ( set_ord_lessThan @ nat @ N ) ) ) ) ).

% sum.atLeast1_atMost_eq
thf(fact_4334_prod_OatLeast1__atMost__eq,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,N: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ ( zero_zero @ nat ) ) @ N ) )
          = ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [K3: nat] : ( G @ ( suc @ K3 ) )
            @ ( set_ord_lessThan @ nat @ N ) ) ) ) ).

% prod.atLeast1_atMost_eq
thf(fact_4335_polyfun__diff,axiom,
    ! [A: $tType] :
      ( ( idom @ A )
     => ! [N: nat,A2: nat > A,X: A,Y: A] :
          ( ( ord_less_eq @ nat @ ( one_one @ nat ) @ N )
         => ( ( minus_minus @ A
              @ ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I4: nat] : ( times_times @ A @ ( A2 @ I4 ) @ ( power_power @ A @ X @ I4 ) )
                @ ( set_ord_atMost @ nat @ N ) )
              @ ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I4: nat] : ( times_times @ A @ ( A2 @ I4 ) @ ( power_power @ A @ Y @ I4 ) )
                @ ( set_ord_atMost @ nat @ N ) ) )
            = ( times_times @ A @ ( minus_minus @ A @ X @ Y )
              @ ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [J3: nat] :
                    ( times_times @ A
                    @ ( groups7311177749621191930dd_sum @ nat @ A
                      @ ^ [I4: nat] : ( times_times @ A @ ( A2 @ I4 ) @ ( power_power @ A @ Y @ ( minus_minus @ nat @ ( minus_minus @ nat @ I4 @ J3 ) @ ( one_one @ nat ) ) ) )
                      @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ J3 ) @ N ) )
                    @ ( power_power @ A @ X @ J3 ) )
                @ ( set_ord_lessThan @ nat @ N ) ) ) ) ) ) ).

% polyfun_diff
thf(fact_4336_sum__nth__roots,axiom,
    ! [N: nat,C2: complex] :
      ( ( ord_less @ nat @ ( one_one @ nat ) @ N )
     => ( ( groups7311177749621191930dd_sum @ complex @ complex
          @ ^ [X2: complex] : X2
          @ ( collect @ complex
            @ ^ [Z6: complex] :
                ( ( power_power @ complex @ Z6 @ N )
                = C2 ) ) )
        = ( zero_zero @ complex ) ) ) ).

% sum_nth_roots
thf(fact_4337_norm__prod__diff,axiom,
    ! [A: $tType,I6: $tType] :
      ( ( ( comm_monoid_mult @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [I5: set @ I6,Z: I6 > A,W: I6 > A] :
          ( ! [I2: I6] :
              ( ( member @ I6 @ I2 @ I5 )
             => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( Z @ I2 ) ) @ ( one_one @ real ) ) )
         => ( ! [I2: I6] :
                ( ( member @ I6 @ I2 @ I5 )
               => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( W @ I2 ) ) @ ( one_one @ real ) ) )
           => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ ( groups7121269368397514597t_prod @ I6 @ A @ Z @ I5 ) @ ( groups7121269368397514597t_prod @ I6 @ A @ W @ I5 ) ) )
              @ ( groups7311177749621191930dd_sum @ I6 @ real
                @ ^ [I4: I6] : ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ ( Z @ I4 ) @ ( W @ I4 ) ) )
                @ I5 ) ) ) ) ) ).

% norm_prod_diff
thf(fact_4338_zero__polynom__imp__zero__coeffs,axiom,
    ! [A: $tType] :
      ( ( ( ab_semigroup_mult @ A )
        & ( real_V8999393235501362500lgebra @ A ) )
     => ! [C2: nat > A,N: nat,K: nat] :
          ( ! [W2: A] :
              ( ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I4: nat] : ( times_times @ A @ ( C2 @ I4 ) @ ( power_power @ A @ W2 @ I4 ) )
                @ ( set_ord_atMost @ nat @ N ) )
              = ( zero_zero @ A ) )
         => ( ( ord_less_eq @ nat @ K @ N )
           => ( ( C2 @ K )
              = ( zero_zero @ A ) ) ) ) ) ).

% zero_polynom_imp_zero_coeffs
thf(fact_4339_polyfun__eq__0,axiom,
    ! [A: $tType] :
      ( ( ( real_V8999393235501362500lgebra @ A )
        & ( idom @ A ) )
     => ! [C2: nat > A,N: nat] :
          ( ( ! [X2: A] :
                ( ( groups7311177749621191930dd_sum @ nat @ A
                  @ ^ [I4: nat] : ( times_times @ A @ ( C2 @ I4 ) @ ( power_power @ A @ X2 @ I4 ) )
                  @ ( set_ord_atMost @ nat @ N ) )
                = ( zero_zero @ A ) ) )
          = ( ! [I4: nat] :
                ( ( ord_less_eq @ nat @ I4 @ N )
               => ( ( C2 @ I4 )
                  = ( zero_zero @ A ) ) ) ) ) ) ).

% polyfun_eq_0
thf(fact_4340_one__diff__power__eq,axiom,
    ! [A: $tType] :
      ( ( ( monoid_mult @ A )
        & ( comm_ring @ A ) )
     => ! [X: A,N: nat] :
          ( ( minus_minus @ A @ ( one_one @ A ) @ ( power_power @ A @ X @ N ) )
          = ( times_times @ A @ ( minus_minus @ A @ ( one_one @ A ) @ X ) @ ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X ) @ ( set_ord_lessThan @ nat @ N ) ) ) ) ) ).

% one_diff_power_eq
thf(fact_4341_power__diff__1__eq,axiom,
    ! [A: $tType] :
      ( ( ( monoid_mult @ A )
        & ( comm_ring @ A ) )
     => ! [X: A,N: nat] :
          ( ( minus_minus @ A @ ( power_power @ A @ X @ N ) @ ( one_one @ A ) )
          = ( times_times @ A @ ( minus_minus @ A @ X @ ( one_one @ A ) ) @ ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X ) @ ( set_ord_lessThan @ nat @ N ) ) ) ) ) ).

% power_diff_1_eq
thf(fact_4342_geometric__sum,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [X: A,N: nat] :
          ( ( X
           != ( one_one @ A ) )
         => ( ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X ) @ ( set_ord_lessThan @ nat @ N ) )
            = ( divide_divide @ A @ ( minus_minus @ A @ ( power_power @ A @ X @ N ) @ ( one_one @ A ) ) @ ( minus_minus @ A @ X @ ( one_one @ A ) ) ) ) ) ) ).

% geometric_sum
thf(fact_4343_choose__row__sum,axiom,
    ! [N: nat] :
      ( ( groups7311177749621191930dd_sum @ nat @ nat @ ( binomial @ N ) @ ( set_ord_atMost @ nat @ N ) )
      = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ).

% choose_row_sum
thf(fact_4344_gbinomial__parallel__sum,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: A,N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [K3: nat] : ( gbinomial @ A @ ( plus_plus @ A @ A2 @ ( semiring_1_of_nat @ A @ K3 ) ) @ K3 )
            @ ( set_ord_atMost @ nat @ N ) )
          = ( gbinomial @ A @ ( plus_plus @ A @ ( plus_plus @ A @ A2 @ ( semiring_1_of_nat @ A @ N ) ) @ ( one_one @ A ) ) @ N ) ) ) ).

% gbinomial_parallel_sum
thf(fact_4345_binomial,axiom,
    ! [A2: nat,B2: nat,N: nat] :
      ( ( power_power @ nat @ ( plus_plus @ nat @ A2 @ B2 ) @ N )
      = ( groups7311177749621191930dd_sum @ nat @ nat
        @ ^ [K3: nat] : ( times_times @ nat @ ( times_times @ nat @ ( semiring_1_of_nat @ nat @ ( binomial @ N @ K3 ) ) @ ( power_power @ nat @ A2 @ K3 ) ) @ ( power_power @ nat @ B2 @ ( minus_minus @ nat @ N @ K3 ) ) )
        @ ( set_ord_atMost @ nat @ N ) ) ) ).

% binomial
thf(fact_4346_sum__roots__unity,axiom,
    ! [N: nat] :
      ( ( ord_less @ nat @ ( one_one @ nat ) @ N )
     => ( ( groups7311177749621191930dd_sum @ complex @ complex
          @ ^ [X2: complex] : X2
          @ ( collect @ complex
            @ ^ [Z6: complex] :
                ( ( power_power @ complex @ Z6 @ N )
                = ( one_one @ complex ) ) ) )
        = ( zero_zero @ complex ) ) ) ).

% sum_roots_unity
thf(fact_4347_sum__less__suminf,axiom,
    ! [A: $tType] :
      ( ( ( ordere8940638589300402666id_add @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [F2: nat > A,N: nat] :
          ( ( summable @ A @ F2 )
         => ( ! [M4: nat] :
                ( ( ord_less_eq @ nat @ N @ M4 )
               => ( ord_less @ A @ ( zero_zero @ A ) @ ( F2 @ M4 ) ) )
           => ( ord_less @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_ord_lessThan @ nat @ N ) ) @ ( suminf @ A @ F2 ) ) ) ) ) ).

% sum_less_suminf
thf(fact_4348_sum__gp__basic,axiom,
    ! [A: $tType] :
      ( ( ( monoid_mult @ A )
        & ( comm_ring @ A ) )
     => ! [X: A,N: nat] :
          ( ( times_times @ A @ ( minus_minus @ A @ ( one_one @ A ) @ X ) @ ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X ) @ ( set_ord_atMost @ nat @ N ) ) )
          = ( minus_minus @ A @ ( one_one @ A ) @ ( power_power @ A @ X @ ( suc @ N ) ) ) ) ) ).

% sum_gp_basic
thf(fact_4349_sum__gp__strict,axiom,
    ! [A: $tType] :
      ( ( ( division_ring @ A )
        & ( comm_ring @ A ) )
     => ! [X: A,N: nat] :
          ( ( ( X
              = ( one_one @ A ) )
           => ( ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X ) @ ( set_ord_lessThan @ nat @ N ) )
              = ( semiring_1_of_nat @ A @ N ) ) )
          & ( ( X
             != ( one_one @ A ) )
           => ( ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X ) @ ( set_ord_lessThan @ nat @ N ) )
              = ( divide_divide @ A @ ( minus_minus @ A @ ( one_one @ A ) @ ( power_power @ A @ X @ N ) ) @ ( minus_minus @ A @ ( one_one @ A ) @ X ) ) ) ) ) ) ).

% sum_gp_strict
thf(fact_4350_lemma__termdiff1,axiom,
    ! [A: $tType] :
      ( ( ( monoid_mult @ A )
        & ( comm_ring @ A ) )
     => ! [Z: A,H2: A,M: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [P5: nat] : ( minus_minus @ A @ ( times_times @ A @ ( power_power @ A @ ( plus_plus @ A @ Z @ H2 ) @ ( minus_minus @ nat @ M @ P5 ) ) @ ( power_power @ A @ Z @ P5 ) ) @ ( power_power @ A @ Z @ M ) )
            @ ( set_ord_lessThan @ nat @ M ) )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [P5: nat] : ( times_times @ A @ ( power_power @ A @ Z @ P5 ) @ ( minus_minus @ A @ ( power_power @ A @ ( plus_plus @ A @ Z @ H2 ) @ ( minus_minus @ nat @ M @ P5 ) ) @ ( power_power @ A @ Z @ ( minus_minus @ nat @ M @ P5 ) ) ) )
            @ ( set_ord_lessThan @ nat @ M ) ) ) ) ).

% lemma_termdiff1
thf(fact_4351_diff__power__eq__sum,axiom,
    ! [A: $tType] :
      ( ( ( monoid_mult @ A )
        & ( comm_ring @ A ) )
     => ! [X: A,N: nat,Y: A] :
          ( ( minus_minus @ A @ ( power_power @ A @ X @ ( suc @ N ) ) @ ( power_power @ A @ Y @ ( suc @ N ) ) )
          = ( times_times @ A @ ( minus_minus @ A @ X @ Y )
            @ ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [P5: nat] : ( times_times @ A @ ( power_power @ A @ X @ P5 ) @ ( power_power @ A @ Y @ ( minus_minus @ nat @ N @ P5 ) ) )
              @ ( set_ord_lessThan @ nat @ ( suc @ N ) ) ) ) ) ) ).

% diff_power_eq_sum
thf(fact_4352_power__diff__sumr2,axiom,
    ! [A: $tType] :
      ( ( ( monoid_mult @ A )
        & ( comm_ring @ A ) )
     => ! [X: A,N: nat,Y: A] :
          ( ( minus_minus @ A @ ( power_power @ A @ X @ N ) @ ( power_power @ A @ Y @ N ) )
          = ( times_times @ A @ ( minus_minus @ A @ X @ Y )
            @ ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [I4: nat] : ( times_times @ A @ ( power_power @ A @ Y @ ( minus_minus @ nat @ N @ ( suc @ I4 ) ) ) @ ( power_power @ A @ X @ I4 ) )
              @ ( set_ord_lessThan @ nat @ N ) ) ) ) ) ).

% power_diff_sumr2
thf(fact_4353_sum__power__shift,axiom,
    ! [A: $tType] :
      ( ( ( monoid_mult @ A )
        & ( comm_ring @ A ) )
     => ! [M: nat,N: nat,X: A] :
          ( ( ord_less_eq @ nat @ M @ N )
         => ( ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X ) @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) )
            = ( times_times @ A @ ( power_power @ A @ X @ M ) @ ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X ) @ ( set_ord_atMost @ nat @ ( minus_minus @ nat @ N @ M ) ) ) ) ) ) ) ).

% sum_power_shift
thf(fact_4354_polynomial__product__nat,axiom,
    ! [M: nat,A2: nat > nat,N: nat,B2: nat > nat,X: nat] :
      ( ! [I2: nat] :
          ( ( ord_less @ nat @ M @ I2 )
         => ( ( A2 @ I2 )
            = ( zero_zero @ nat ) ) )
     => ( ! [J2: nat] :
            ( ( ord_less @ nat @ N @ J2 )
           => ( ( B2 @ J2 )
              = ( zero_zero @ nat ) ) )
       => ( ( times_times @ nat
            @ ( groups7311177749621191930dd_sum @ nat @ nat
              @ ^ [I4: nat] : ( times_times @ nat @ ( A2 @ I4 ) @ ( power_power @ nat @ X @ I4 ) )
              @ ( set_ord_atMost @ nat @ M ) )
            @ ( groups7311177749621191930dd_sum @ nat @ nat
              @ ^ [J3: nat] : ( times_times @ nat @ ( B2 @ J3 ) @ ( power_power @ nat @ X @ J3 ) )
              @ ( set_ord_atMost @ nat @ N ) ) )
          = ( groups7311177749621191930dd_sum @ nat @ nat
            @ ^ [R5: nat] :
                ( times_times @ nat
                @ ( groups7311177749621191930dd_sum @ nat @ nat
                  @ ^ [K3: nat] : ( times_times @ nat @ ( A2 @ K3 ) @ ( B2 @ ( minus_minus @ nat @ R5 @ K3 ) ) )
                  @ ( set_ord_atMost @ nat @ R5 ) )
                @ ( power_power @ nat @ X @ R5 ) )
            @ ( set_ord_atMost @ nat @ ( plus_plus @ nat @ M @ N ) ) ) ) ) ) ).

% polynomial_product_nat
thf(fact_4355_choose__square__sum,axiom,
    ! [N: nat] :
      ( ( groups7311177749621191930dd_sum @ nat @ nat
        @ ^ [K3: nat] : ( power_power @ nat @ ( binomial @ N @ K3 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
        @ ( set_ord_atMost @ nat @ N ) )
      = ( binomial @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) @ N ) ) ).

% choose_square_sum
thf(fact_4356_real__sum__nat__ivl__bounded2,axiom,
    ! [A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [N: nat,F2: nat > A,K6: A,K: nat] :
          ( ! [P7: nat] :
              ( ( ord_less @ nat @ P7 @ N )
             => ( ord_less_eq @ A @ ( F2 @ P7 ) @ K6 ) )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ K6 )
           => ( ord_less_eq @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_ord_lessThan @ nat @ ( minus_minus @ nat @ N @ K ) ) ) @ ( times_times @ A @ ( semiring_1_of_nat @ A @ N ) @ K6 ) ) ) ) ) ).

% real_sum_nat_ivl_bounded2
thf(fact_4357_sum__less__suminf2,axiom,
    ! [A: $tType] :
      ( ( ( ordere8940638589300402666id_add @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [F2: nat > A,N: nat,I: nat] :
          ( ( summable @ A @ F2 )
         => ( ! [M4: nat] :
                ( ( ord_less_eq @ nat @ N @ M4 )
               => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( F2 @ M4 ) ) )
           => ( ( ord_less_eq @ nat @ N @ I )
             => ( ( ord_less @ A @ ( zero_zero @ A ) @ ( F2 @ I ) )
               => ( ord_less @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_ord_lessThan @ nat @ N ) ) @ ( suminf @ A @ F2 ) ) ) ) ) ) ) ).

% sum_less_suminf2
thf(fact_4358_sum_Oin__pairs__0,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_ord_atMost @ nat @ ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ) )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [I4: nat] : ( plus_plus @ A @ ( G @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ I4 ) ) @ ( G @ ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ I4 ) ) ) )
            @ ( set_ord_atMost @ nat @ N ) ) ) ) ).

% sum.in_pairs_0
thf(fact_4359_polynomial__product,axiom,
    ! [A: $tType] :
      ( ( idom @ A )
     => ! [M: nat,A2: nat > A,N: nat,B2: nat > A,X: A] :
          ( ! [I2: nat] :
              ( ( ord_less @ nat @ M @ I2 )
             => ( ( A2 @ I2 )
                = ( zero_zero @ A ) ) )
         => ( ! [J2: nat] :
                ( ( ord_less @ nat @ N @ J2 )
               => ( ( B2 @ J2 )
                  = ( zero_zero @ A ) ) )
           => ( ( times_times @ A
                @ ( groups7311177749621191930dd_sum @ nat @ A
                  @ ^ [I4: nat] : ( times_times @ A @ ( A2 @ I4 ) @ ( power_power @ A @ X @ I4 ) )
                  @ ( set_ord_atMost @ nat @ M ) )
                @ ( groups7311177749621191930dd_sum @ nat @ A
                  @ ^ [J3: nat] : ( times_times @ A @ ( B2 @ J3 ) @ ( power_power @ A @ X @ J3 ) )
                  @ ( set_ord_atMost @ nat @ N ) ) )
              = ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [R5: nat] :
                    ( times_times @ A
                    @ ( groups7311177749621191930dd_sum @ nat @ A
                      @ ^ [K3: nat] : ( times_times @ A @ ( A2 @ K3 ) @ ( B2 @ ( minus_minus @ nat @ R5 @ K3 ) ) )
                      @ ( set_ord_atMost @ nat @ R5 ) )
                    @ ( power_power @ A @ X @ R5 ) )
                @ ( set_ord_atMost @ nat @ ( plus_plus @ nat @ M @ N ) ) ) ) ) ) ) ).

% polynomial_product
thf(fact_4360_prod_Oin__pairs__0,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,N: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_ord_atMost @ nat @ ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) ) )
          = ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [I4: nat] : ( times_times @ A @ ( G @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ I4 ) ) @ ( G @ ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ I4 ) ) ) )
            @ ( set_ord_atMost @ nat @ N ) ) ) ) ).

% prod.in_pairs_0
thf(fact_4361_one__diff__power__eq_H,axiom,
    ! [A: $tType] :
      ( ( ( monoid_mult @ A )
        & ( comm_ring @ A ) )
     => ! [X: A,N: nat] :
          ( ( minus_minus @ A @ ( one_one @ A ) @ ( power_power @ A @ X @ N ) )
          = ( times_times @ A @ ( minus_minus @ A @ ( one_one @ A ) @ X )
            @ ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [I4: nat] : ( power_power @ A @ X @ ( minus_minus @ nat @ N @ ( suc @ I4 ) ) )
              @ ( set_ord_lessThan @ nat @ N ) ) ) ) ) ).

% one_diff_power_eq'
thf(fact_4362_polyfun__eq__const,axiom,
    ! [A: $tType] :
      ( ( ( real_V8999393235501362500lgebra @ A )
        & ( idom @ A ) )
     => ! [C2: nat > A,N: nat,K: A] :
          ( ( ! [X2: A] :
                ( ( groups7311177749621191930dd_sum @ nat @ A
                  @ ^ [I4: nat] : ( times_times @ A @ ( C2 @ I4 ) @ ( power_power @ A @ X2 @ I4 ) )
                  @ ( set_ord_atMost @ nat @ N ) )
                = K ) )
          = ( ( ( C2 @ ( zero_zero @ nat ) )
              = K )
            & ! [X2: nat] :
                ( ( member @ nat @ X2 @ ( set_or1337092689740270186AtMost @ nat @ ( one_one @ nat ) @ N ) )
               => ( ( C2 @ X2 )
                  = ( zero_zero @ A ) ) ) ) ) ) ).

% polyfun_eq_const
thf(fact_4363_gbinomial__sum__lower__neg,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: A,M: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [K3: nat] : ( times_times @ A @ ( gbinomial @ A @ A2 @ K3 ) @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ K3 ) )
            @ ( set_ord_atMost @ nat @ M ) )
          = ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ M ) @ ( gbinomial @ A @ ( minus_minus @ A @ A2 @ ( one_one @ A ) ) @ M ) ) ) ) ).

% gbinomial_sum_lower_neg
thf(fact_4364_binomial__ring,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [A2: A,B2: A,N: nat] :
          ( ( power_power @ A @ ( plus_plus @ A @ A2 @ B2 ) @ N )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [K3: nat] : ( times_times @ A @ ( times_times @ A @ ( semiring_1_of_nat @ A @ ( binomial @ N @ K3 ) ) @ ( power_power @ A @ A2 @ K3 ) ) @ ( power_power @ A @ B2 @ ( minus_minus @ nat @ N @ K3 ) ) )
            @ ( set_ord_atMost @ nat @ N ) ) ) ) ).

% binomial_ring
thf(fact_4365_Maclaurin__zero,axiom,
    ! [A: $tType] :
      ( ( zero @ A )
     => ! [X: real,N: nat,Diff: nat > A > real] :
          ( ( X
            = ( zero_zero @ real ) )
         => ( ( N
             != ( zero_zero @ nat ) )
           => ( ( groups7311177749621191930dd_sum @ nat @ real
                @ ^ [M3: nat] : ( times_times @ real @ ( divide_divide @ real @ ( Diff @ M3 @ ( zero_zero @ A ) ) @ ( semiring_char_0_fact @ real @ M3 ) ) @ ( power_power @ real @ X @ M3 ) )
                @ ( set_ord_lessThan @ nat @ N ) )
              = ( Diff @ ( zero_zero @ nat ) @ ( zero_zero @ A ) ) ) ) ) ) ).

% Maclaurin_zero
thf(fact_4366_pochhammer__binomial__sum,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [A2: A,B2: A,N: nat] :
          ( ( comm_s3205402744901411588hammer @ A @ ( plus_plus @ A @ A2 @ B2 ) @ N )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [K3: nat] : ( times_times @ A @ ( times_times @ A @ ( semiring_1_of_nat @ A @ ( binomial @ N @ K3 ) ) @ ( comm_s3205402744901411588hammer @ A @ A2 @ K3 ) ) @ ( comm_s3205402744901411588hammer @ A @ B2 @ ( minus_minus @ nat @ N @ K3 ) ) )
            @ ( set_ord_atMost @ nat @ N ) ) ) ) ).

% pochhammer_binomial_sum
thf(fact_4367_Maclaurin__lemma,axiom,
    ! [H2: real,F2: real > real,J: nat > real,N: nat] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ H2 )
     => ? [B8: real] :
          ( ( F2 @ H2 )
          = ( plus_plus @ real
            @ ( groups7311177749621191930dd_sum @ nat @ real
              @ ^ [M3: nat] : ( times_times @ real @ ( divide_divide @ real @ ( J @ M3 ) @ ( semiring_char_0_fact @ real @ M3 ) ) @ ( power_power @ real @ H2 @ M3 ) )
              @ ( set_ord_lessThan @ nat @ N ) )
            @ ( times_times @ real @ B8 @ ( divide_divide @ real @ ( power_power @ real @ H2 @ N ) @ ( semiring_char_0_fact @ real @ N ) ) ) ) ) ) ).

% Maclaurin_lemma
thf(fact_4368_sum_Ozero__middle,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [P6: nat,K: nat,G: nat > A,H2: nat > A] :
          ( ( ord_less_eq @ nat @ ( one_one @ nat ) @ P6 )
         => ( ( ord_less_eq @ nat @ K @ P6 )
           => ( ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [J3: nat] : ( if @ A @ ( ord_less @ nat @ J3 @ K ) @ ( G @ J3 ) @ ( if @ A @ ( J3 = K ) @ ( zero_zero @ A ) @ ( H2 @ ( minus_minus @ nat @ J3 @ ( suc @ ( zero_zero @ nat ) ) ) ) ) )
                @ ( set_ord_atMost @ nat @ P6 ) )
              = ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [J3: nat] : ( if @ A @ ( ord_less @ nat @ J3 @ K ) @ ( G @ J3 ) @ ( H2 @ J3 ) )
                @ ( set_ord_atMost @ nat @ ( minus_minus @ nat @ P6 @ ( suc @ ( zero_zero @ nat ) ) ) ) ) ) ) ) ) ).

% sum.zero_middle
thf(fact_4369_prod_Ozero__middle,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [P6: nat,K: nat,G: nat > A,H2: nat > A] :
          ( ( ord_less_eq @ nat @ ( one_one @ nat ) @ P6 )
         => ( ( ord_less_eq @ nat @ K @ P6 )
           => ( ( groups7121269368397514597t_prod @ nat @ A
                @ ^ [J3: nat] : ( if @ A @ ( ord_less @ nat @ J3 @ K ) @ ( G @ J3 ) @ ( if @ A @ ( J3 = K ) @ ( one_one @ A ) @ ( H2 @ ( minus_minus @ nat @ J3 @ ( suc @ ( zero_zero @ nat ) ) ) ) ) )
                @ ( set_ord_atMost @ nat @ P6 ) )
              = ( groups7121269368397514597t_prod @ nat @ A
                @ ^ [J3: nat] : ( if @ A @ ( ord_less @ nat @ J3 @ K ) @ ( G @ J3 ) @ ( H2 @ J3 ) )
                @ ( set_ord_atMost @ nat @ ( minus_minus @ nat @ P6 @ ( suc @ ( zero_zero @ nat ) ) ) ) ) ) ) ) ) ).

% prod.zero_middle
thf(fact_4370_gbinomial__partial__sum__poly,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [M: nat,A2: A,X: A,Y: A] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [K3: nat] : ( times_times @ A @ ( times_times @ A @ ( gbinomial @ A @ ( plus_plus @ A @ ( semiring_1_of_nat @ A @ M ) @ A2 ) @ K3 ) @ ( power_power @ A @ X @ K3 ) ) @ ( power_power @ A @ Y @ ( minus_minus @ nat @ M @ K3 ) ) )
            @ ( set_ord_atMost @ nat @ M ) )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [K3: nat] : ( times_times @ A @ ( times_times @ A @ ( gbinomial @ A @ ( uminus_uminus @ A @ A2 ) @ K3 ) @ ( power_power @ A @ ( uminus_uminus @ A @ X ) @ K3 ) ) @ ( power_power @ A @ ( plus_plus @ A @ X @ Y ) @ ( minus_minus @ nat @ M @ K3 ) ) )
            @ ( set_ord_atMost @ nat @ M ) ) ) ) ).

% gbinomial_partial_sum_poly
thf(fact_4371_binomial__r__part__sum,axiom,
    ! [M: nat] :
      ( ( groups7311177749621191930dd_sum @ nat @ nat @ ( binomial @ ( plus_plus @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M ) @ ( one_one @ nat ) ) ) @ ( set_ord_atMost @ nat @ M ) )
      = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M ) ) ) ).

% binomial_r_part_sum
thf(fact_4372_choose__linear__sum,axiom,
    ! [N: nat] :
      ( ( groups7311177749621191930dd_sum @ nat @ nat
        @ ^ [I4: nat] : ( times_times @ nat @ I4 @ ( binomial @ N @ I4 ) )
        @ ( set_ord_atMost @ nat @ N ) )
      = ( times_times @ nat @ N @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) ) ) ) ).

% choose_linear_sum
thf(fact_4373_sum__split__even__odd,axiom,
    ! [F2: nat > real,G: nat > real,N: nat] :
      ( ( groups7311177749621191930dd_sum @ nat @ real
        @ ^ [I4: nat] : ( if @ real @ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ I4 ) @ ( F2 @ I4 ) @ ( G @ I4 ) )
        @ ( set_ord_lessThan @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) )
      = ( plus_plus @ real
        @ ( groups7311177749621191930dd_sum @ nat @ real
          @ ^ [I4: nat] : ( F2 @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ I4 ) )
          @ ( set_ord_lessThan @ nat @ N ) )
        @ ( groups7311177749621191930dd_sum @ nat @ real
          @ ^ [I4: nat] : ( G @ ( plus_plus @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ I4 ) @ ( one_one @ nat ) ) )
          @ ( set_ord_lessThan @ nat @ N ) ) ) ) ).

% sum_split_even_odd
thf(fact_4374_exp__series__add__commuting,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [X: A,Y: A,N: nat] :
          ( ( ( times_times @ A @ X @ Y )
            = ( times_times @ A @ Y @ X ) )
         => ( ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ ( semiring_char_0_fact @ real @ N ) ) @ ( power_power @ A @ ( plus_plus @ A @ X @ Y ) @ N ) )
            = ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [I4: nat] : ( times_times @ A @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ ( semiring_char_0_fact @ real @ I4 ) ) @ ( power_power @ A @ X @ I4 ) ) @ ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ ( semiring_char_0_fact @ real @ ( minus_minus @ nat @ N @ I4 ) ) ) @ ( power_power @ A @ Y @ ( minus_minus @ nat @ N @ I4 ) ) ) )
              @ ( set_ord_atMost @ nat @ N ) ) ) ) ) ).

% exp_series_add_commuting
thf(fact_4375_Maclaurin__exp__le,axiom,
    ! [X: real,N: nat] :
    ? [T4: real] :
      ( ( ord_less_eq @ real @ ( abs_abs @ real @ T4 ) @ ( abs_abs @ real @ X ) )
      & ( ( exp @ real @ X )
        = ( plus_plus @ real
          @ ( groups7311177749621191930dd_sum @ nat @ real
            @ ^ [M3: nat] : ( divide_divide @ real @ ( power_power @ real @ X @ M3 ) @ ( semiring_char_0_fact @ real @ M3 ) )
            @ ( set_ord_lessThan @ nat @ N ) )
          @ ( times_times @ real @ ( divide_divide @ real @ ( exp @ real @ T4 ) @ ( semiring_char_0_fact @ real @ N ) ) @ ( power_power @ real @ X @ N ) ) ) ) ) ).

% Maclaurin_exp_le
thf(fact_4376_root__polyfun,axiom,
    ! [A: $tType] :
      ( ( idom @ A )
     => ! [N: nat,Z: A,A2: A] :
          ( ( ord_less_eq @ nat @ ( one_one @ nat ) @ N )
         => ( ( ( power_power @ A @ Z @ N )
              = A2 )
            = ( ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I4: nat] :
                    ( times_times @ A
                    @ ( if @ A
                      @ ( I4
                        = ( zero_zero @ nat ) )
                      @ ( uminus_uminus @ A @ A2 )
                      @ ( if @ A @ ( I4 = N ) @ ( one_one @ A ) @ ( zero_zero @ A ) ) )
                    @ ( power_power @ A @ Z @ I4 ) )
                @ ( set_ord_atMost @ nat @ N ) )
              = ( zero_zero @ A ) ) ) ) ) ).

% root_polyfun
thf(fact_4377_sum__gp0,axiom,
    ! [A: $tType] :
      ( ( ( division_ring @ A )
        & ( comm_ring @ A ) )
     => ! [X: A,N: nat] :
          ( ( ( X
              = ( one_one @ A ) )
           => ( ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X ) @ ( set_ord_atMost @ nat @ N ) )
              = ( semiring_1_of_nat @ A @ ( plus_plus @ nat @ N @ ( one_one @ nat ) ) ) ) )
          & ( ( X
             != ( one_one @ A ) )
           => ( ( groups7311177749621191930dd_sum @ nat @ A @ ( power_power @ A @ X ) @ ( set_ord_atMost @ nat @ N ) )
              = ( divide_divide @ A @ ( minus_minus @ A @ ( one_one @ A ) @ ( power_power @ A @ X @ ( suc @ N ) ) ) @ ( minus_minus @ A @ ( one_one @ A ) @ X ) ) ) ) ) ) ).

% sum_gp0
thf(fact_4378_choose__alternating__linear__sum,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [N: nat] :
          ( ( N
           != ( one_one @ nat ) )
         => ( ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [I4: nat] : ( times_times @ A @ ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ I4 ) @ ( semiring_1_of_nat @ A @ I4 ) ) @ ( semiring_1_of_nat @ A @ ( binomial @ N @ I4 ) ) )
              @ ( set_ord_atMost @ nat @ N ) )
            = ( zero_zero @ A ) ) ) ) ).

% choose_alternating_linear_sum
thf(fact_4379_gbinomial__sum__nat__pow2,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [M: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [K3: nat] : ( divide_divide @ A @ ( gbinomial @ A @ ( semiring_1_of_nat @ A @ ( plus_plus @ nat @ M @ K3 ) ) @ K3 ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ K3 ) )
            @ ( set_ord_atMost @ nat @ M ) )
          = ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M ) ) ) ).

% gbinomial_sum_nat_pow2
thf(fact_4380_gbinomial__partial__sum__poly__xpos,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [M: nat,A2: A,X: A,Y: A] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [K3: nat] : ( times_times @ A @ ( times_times @ A @ ( gbinomial @ A @ ( plus_plus @ A @ ( semiring_1_of_nat @ A @ M ) @ A2 ) @ K3 ) @ ( power_power @ A @ X @ K3 ) ) @ ( power_power @ A @ Y @ ( minus_minus @ nat @ M @ K3 ) ) )
            @ ( set_ord_atMost @ nat @ M ) )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [K3: nat] : ( times_times @ A @ ( times_times @ A @ ( gbinomial @ A @ ( minus_minus @ A @ ( plus_plus @ A @ ( semiring_1_of_nat @ A @ K3 ) @ A2 ) @ ( one_one @ A ) ) @ K3 ) @ ( power_power @ A @ X @ K3 ) ) @ ( power_power @ A @ ( plus_plus @ A @ X @ Y ) @ ( minus_minus @ nat @ M @ K3 ) ) )
            @ ( set_ord_atMost @ nat @ M ) ) ) ) ).

% gbinomial_partial_sum_poly_xpos
thf(fact_4381_exp__first__terms,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V2822296259951069270ebra_1 @ A ) )
     => ! [K: nat] :
          ( ( exp @ A )
          = ( ^ [X2: A] :
                ( plus_plus @ A
                @ ( groups7311177749621191930dd_sum @ nat @ A
                  @ ^ [N3: nat] : ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ ( semiring_char_0_fact @ real @ N3 ) ) @ ( power_power @ A @ X2 @ N3 ) )
                  @ ( set_ord_lessThan @ nat @ K ) )
                @ ( suminf @ A
                  @ ^ [N3: nat] : ( real_V8093663219630862766scaleR @ A @ ( inverse_inverse @ real @ ( semiring_char_0_fact @ real @ ( plus_plus @ nat @ N3 @ K ) ) ) @ ( power_power @ A @ X2 @ ( plus_plus @ nat @ N3 @ K ) ) ) ) ) ) ) ) ).

% exp_first_terms
thf(fact_4382_choose__alternating__sum,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [N: nat] :
          ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
         => ( ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [I4: nat] : ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ I4 ) @ ( semiring_1_of_nat @ A @ ( binomial @ N @ I4 ) ) )
              @ ( set_ord_atMost @ nat @ N ) )
            = ( zero_zero @ A ) ) ) ) ).

% choose_alternating_sum
thf(fact_4383_Maclaurin__sin__bound,axiom,
    ! [X: real,N: nat] :
      ( ord_less_eq @ real
      @ ( abs_abs @ real
        @ ( minus_minus @ real @ ( sin @ real @ X )
          @ ( groups7311177749621191930dd_sum @ nat @ real
            @ ^ [M3: nat] : ( times_times @ real @ ( sin_coeff @ M3 ) @ ( power_power @ real @ X @ M3 ) )
            @ ( set_ord_lessThan @ nat @ N ) ) ) )
      @ ( times_times @ real @ ( inverse_inverse @ real @ ( semiring_char_0_fact @ real @ N ) ) @ ( power_power @ real @ ( abs_abs @ real @ X ) @ N ) ) ) ).

% Maclaurin_sin_bound
thf(fact_4384_polyfun__extremal__lemma,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [E2: real,C2: nat > A,N: nat] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ E2 )
         => ? [M10: real] :
            ! [Z4: A] :
              ( ( ord_less_eq @ real @ M10 @ ( real_V7770717601297561774m_norm @ A @ Z4 ) )
             => ( ord_less_eq @ real
                @ ( real_V7770717601297561774m_norm @ A
                  @ ( groups7311177749621191930dd_sum @ nat @ A
                    @ ^ [I4: nat] : ( times_times @ A @ ( C2 @ I4 ) @ ( power_power @ A @ Z4 @ I4 ) )
                    @ ( set_ord_atMost @ nat @ N ) ) )
                @ ( times_times @ real @ E2 @ ( power_power @ real @ ( real_V7770717601297561774m_norm @ A @ Z4 ) @ ( suc @ N ) ) ) ) ) ) ) ).

% polyfun_extremal_lemma
thf(fact_4385_Sum__Icc__int,axiom,
    ! [M: int,N: int] :
      ( ( ord_less_eq @ int @ M @ N )
     => ( ( groups7311177749621191930dd_sum @ int @ int
          @ ^ [X2: int] : X2
          @ ( set_or1337092689740270186AtMost @ int @ M @ N ) )
        = ( divide_divide @ int @ ( minus_minus @ int @ ( times_times @ int @ N @ ( plus_plus @ int @ N @ ( one_one @ int ) ) ) @ ( times_times @ int @ M @ ( minus_minus @ int @ M @ ( one_one @ int ) ) ) ) @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) ).

% Sum_Icc_int
thf(fact_4386_sum__pos__lt__pair,axiom,
    ! [F2: nat > real,K: nat] :
      ( ( summable @ real @ F2 )
     => ( ! [D6: nat] : ( ord_less @ real @ ( zero_zero @ real ) @ ( plus_plus @ real @ ( F2 @ ( plus_plus @ nat @ K @ ( times_times @ nat @ ( suc @ ( suc @ ( zero_zero @ nat ) ) ) @ D6 ) ) ) @ ( F2 @ ( plus_plus @ nat @ K @ ( plus_plus @ nat @ ( times_times @ nat @ ( suc @ ( suc @ ( zero_zero @ nat ) ) ) @ D6 ) @ ( one_one @ nat ) ) ) ) ) )
       => ( ord_less @ real @ ( groups7311177749621191930dd_sum @ nat @ real @ F2 @ ( set_ord_lessThan @ nat @ K ) ) @ ( suminf @ real @ F2 ) ) ) ) ).

% sum_pos_lt_pair
thf(fact_4387_Maclaurin__exp__lt,axiom,
    ! [X: real,N: nat] :
      ( ( X
       != ( zero_zero @ real ) )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
       => ? [T4: real] :
            ( ( ord_less @ real @ ( zero_zero @ real ) @ ( abs_abs @ real @ T4 ) )
            & ( ord_less @ real @ ( abs_abs @ real @ T4 ) @ ( abs_abs @ real @ X ) )
            & ( ( exp @ real @ X )
              = ( plus_plus @ real
                @ ( groups7311177749621191930dd_sum @ nat @ real
                  @ ^ [M3: nat] : ( divide_divide @ real @ ( power_power @ real @ X @ M3 ) @ ( semiring_char_0_fact @ real @ M3 ) )
                  @ ( set_ord_lessThan @ nat @ N ) )
                @ ( times_times @ real @ ( divide_divide @ real @ ( exp @ real @ T4 ) @ ( semiring_char_0_fact @ real @ N ) ) @ ( power_power @ real @ X @ N ) ) ) ) ) ) ) ).

% Maclaurin_exp_lt
thf(fact_4388_gbinomial__r__part__sum,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [M: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ ( gbinomial @ A @ ( plus_plus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( semiring_1_of_nat @ A @ M ) ) @ ( one_one @ A ) ) ) @ ( set_ord_atMost @ nat @ M ) )
          = ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ M ) ) ) ) ).

% gbinomial_r_part_sum
thf(fact_4389_choose__odd__sum,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [N: nat] :
          ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
         => ( ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) )
              @ ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I4: nat] :
                    ( if @ A
                    @ ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ I4 )
                    @ ( semiring_1_of_nat @ A @ ( binomial @ N @ I4 ) )
                    @ ( zero_zero @ A ) )
                @ ( set_ord_atMost @ nat @ N ) ) )
            = ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) ) ) ) ).

% choose_odd_sum
thf(fact_4390_choose__even__sum,axiom,
    ! [A: $tType] :
      ( ( comm_ring_1 @ A )
     => ! [N: nat] :
          ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
         => ( ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) )
              @ ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I4: nat] : ( if @ A @ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ I4 ) @ ( semiring_1_of_nat @ A @ ( binomial @ N @ I4 ) ) @ ( zero_zero @ A ) )
                @ ( set_ord_atMost @ nat @ N ) ) )
            = ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) ) ) ) ).

% choose_even_sum
thf(fact_4391_gbinomial__partial__row__sum,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: A,M: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [K3: nat] : ( times_times @ A @ ( gbinomial @ A @ A2 @ K3 ) @ ( minus_minus @ A @ ( divide_divide @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( semiring_1_of_nat @ A @ K3 ) ) )
            @ ( set_ord_atMost @ nat @ M ) )
          = ( times_times @ A @ ( divide_divide @ A @ ( plus_plus @ A @ ( semiring_1_of_nat @ A @ M ) @ ( one_one @ A ) ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ ( gbinomial @ A @ A2 @ ( plus_plus @ nat @ M @ ( one_one @ nat ) ) ) ) ) ) ).

% gbinomial_partial_row_sum
thf(fact_4392_lemma__termdiff2,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [H2: A,Z: A,N: nat] :
          ( ( H2
           != ( zero_zero @ A ) )
         => ( ( minus_minus @ A @ ( divide_divide @ A @ ( minus_minus @ A @ ( power_power @ A @ ( plus_plus @ A @ Z @ H2 ) @ N ) @ ( power_power @ A @ Z @ N ) ) @ H2 ) @ ( times_times @ A @ ( semiring_1_of_nat @ A @ N ) @ ( power_power @ A @ Z @ ( minus_minus @ nat @ N @ ( suc @ ( zero_zero @ nat ) ) ) ) ) )
            = ( times_times @ A @ H2
              @ ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [P5: nat] :
                    ( groups7311177749621191930dd_sum @ nat @ A
                    @ ^ [Q6: nat] : ( times_times @ A @ ( power_power @ A @ ( plus_plus @ A @ Z @ H2 ) @ Q6 ) @ ( power_power @ A @ Z @ ( minus_minus @ nat @ ( minus_minus @ nat @ N @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ Q6 ) ) )
                    @ ( set_ord_lessThan @ nat @ ( minus_minus @ nat @ ( minus_minus @ nat @ N @ ( suc @ ( zero_zero @ nat ) ) ) @ P5 ) ) )
                @ ( set_ord_lessThan @ nat @ ( minus_minus @ nat @ N @ ( suc @ ( zero_zero @ nat ) ) ) ) ) ) ) ) ) ).

% lemma_termdiff2
thf(fact_4393_Maclaurin__sin__expansion,axiom,
    ! [X: real,N: nat] :
    ? [T4: real] :
      ( ( sin @ real @ X )
      = ( plus_plus @ real
        @ ( groups7311177749621191930dd_sum @ nat @ real
          @ ^ [M3: nat] : ( times_times @ real @ ( sin_coeff @ M3 ) @ ( power_power @ real @ X @ M3 ) )
          @ ( set_ord_lessThan @ nat @ N ) )
        @ ( times_times @ real @ ( divide_divide @ real @ ( sin @ real @ ( plus_plus @ real @ T4 @ ( times_times @ real @ ( times_times @ real @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( semiring_1_of_nat @ real @ N ) ) @ pi ) ) ) @ ( semiring_char_0_fact @ real @ N ) ) @ ( power_power @ real @ X @ N ) ) ) ) ).

% Maclaurin_sin_expansion
thf(fact_4394_Maclaurin__sin__expansion2,axiom,
    ! [X: real,N: nat] :
    ? [T4: real] :
      ( ( ord_less_eq @ real @ ( abs_abs @ real @ T4 ) @ ( abs_abs @ real @ X ) )
      & ( ( sin @ real @ X )
        = ( plus_plus @ real
          @ ( groups7311177749621191930dd_sum @ nat @ real
            @ ^ [M3: nat] : ( times_times @ real @ ( sin_coeff @ M3 ) @ ( power_power @ real @ X @ M3 ) )
            @ ( set_ord_lessThan @ nat @ N ) )
          @ ( times_times @ real @ ( divide_divide @ real @ ( sin @ real @ ( plus_plus @ real @ T4 @ ( times_times @ real @ ( times_times @ real @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( semiring_1_of_nat @ real @ N ) ) @ pi ) ) ) @ ( semiring_char_0_fact @ real @ N ) ) @ ( power_power @ real @ X @ N ) ) ) ) ) ).

% Maclaurin_sin_expansion2
thf(fact_4395_Maclaurin__cos__expansion,axiom,
    ! [X: real,N: nat] :
    ? [T4: real] :
      ( ( ord_less_eq @ real @ ( abs_abs @ real @ T4 ) @ ( abs_abs @ real @ X ) )
      & ( ( cos @ real @ X )
        = ( plus_plus @ real
          @ ( groups7311177749621191930dd_sum @ nat @ real
            @ ^ [M3: nat] : ( times_times @ real @ ( cos_coeff @ M3 ) @ ( power_power @ real @ X @ M3 ) )
            @ ( set_ord_lessThan @ nat @ N ) )
          @ ( times_times @ real @ ( divide_divide @ real @ ( cos @ real @ ( plus_plus @ real @ T4 @ ( times_times @ real @ ( times_times @ real @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( semiring_1_of_nat @ real @ N ) ) @ pi ) ) ) @ ( semiring_char_0_fact @ real @ N ) ) @ ( power_power @ real @ X @ N ) ) ) ) ) ).

% Maclaurin_cos_expansion
thf(fact_4396_Maclaurin__sin__expansion4,axiom,
    ! [X: real,N: nat] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ? [T4: real] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ T4 )
          & ( ord_less_eq @ real @ T4 @ X )
          & ( ( sin @ real @ X )
            = ( plus_plus @ real
              @ ( groups7311177749621191930dd_sum @ nat @ real
                @ ^ [M3: nat] : ( times_times @ real @ ( sin_coeff @ M3 ) @ ( power_power @ real @ X @ M3 ) )
                @ ( set_ord_lessThan @ nat @ N ) )
              @ ( times_times @ real @ ( divide_divide @ real @ ( sin @ real @ ( plus_plus @ real @ T4 @ ( times_times @ real @ ( times_times @ real @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( semiring_1_of_nat @ real @ N ) ) @ pi ) ) ) @ ( semiring_char_0_fact @ real @ N ) ) @ ( power_power @ real @ X @ N ) ) ) ) ) ) ).

% Maclaurin_sin_expansion4
thf(fact_4397_Maclaurin__sin__expansion3,axiom,
    ! [N: nat,X: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
       => ? [T4: real] :
            ( ( ord_less @ real @ ( zero_zero @ real ) @ T4 )
            & ( ord_less @ real @ T4 @ X )
            & ( ( sin @ real @ X )
              = ( plus_plus @ real
                @ ( groups7311177749621191930dd_sum @ nat @ real
                  @ ^ [M3: nat] : ( times_times @ real @ ( sin_coeff @ M3 ) @ ( power_power @ real @ X @ M3 ) )
                  @ ( set_ord_lessThan @ nat @ N ) )
                @ ( times_times @ real @ ( divide_divide @ real @ ( sin @ real @ ( plus_plus @ real @ T4 @ ( times_times @ real @ ( times_times @ real @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( semiring_1_of_nat @ real @ N ) ) @ pi ) ) ) @ ( semiring_char_0_fact @ real @ N ) ) @ ( power_power @ real @ X @ N ) ) ) ) ) ) ) ).

% Maclaurin_sin_expansion3
thf(fact_4398_Maclaurin__minus__cos__expansion,axiom,
    ! [N: nat,X: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less @ real @ X @ ( zero_zero @ real ) )
       => ? [T4: real] :
            ( ( ord_less @ real @ X @ T4 )
            & ( ord_less @ real @ T4 @ ( zero_zero @ real ) )
            & ( ( cos @ real @ X )
              = ( plus_plus @ real
                @ ( groups7311177749621191930dd_sum @ nat @ real
                  @ ^ [M3: nat] : ( times_times @ real @ ( cos_coeff @ M3 ) @ ( power_power @ real @ X @ M3 ) )
                  @ ( set_ord_lessThan @ nat @ N ) )
                @ ( times_times @ real @ ( divide_divide @ real @ ( cos @ real @ ( plus_plus @ real @ T4 @ ( times_times @ real @ ( times_times @ real @ ( divide_divide @ real @ ( one_one @ real ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( semiring_1_of_nat @ real @ N ) ) @ pi ) ) ) @ ( semiring_char_0_fact @ real @ N ) ) @ ( power_power @ real @ X @ N ) ) ) ) ) ) ) ).

% Maclaurin_minus_cos_expansion
thf(fact_4399_upto_Opinduct,axiom,
    ! [A0: int,A12: int,P: int > int > $o] :
      ( ( accp @ ( product_prod @ int @ int ) @ upto_rel @ ( product_Pair @ int @ int @ A0 @ A12 ) )
     => ( ! [I2: int,J2: int] :
            ( ( accp @ ( product_prod @ int @ int ) @ upto_rel @ ( product_Pair @ int @ int @ I2 @ J2 ) )
           => ( ( ( ord_less_eq @ int @ I2 @ J2 )
               => ( P @ ( plus_plus @ int @ I2 @ ( one_one @ int ) ) @ J2 ) )
             => ( P @ I2 @ J2 ) ) )
       => ( P @ A0 @ A12 ) ) ) ).

% upto.pinduct
thf(fact_4400_diffs__equiv,axiom,
    ! [A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( ring_1 @ A ) )
     => ! [C2: nat > A,X: A] :
          ( ( summable @ A
            @ ^ [N3: nat] : ( times_times @ A @ ( diffs @ A @ C2 @ N3 ) @ ( power_power @ A @ X @ N3 ) ) )
         => ( sums @ A
            @ ^ [N3: nat] : ( times_times @ A @ ( times_times @ A @ ( semiring_1_of_nat @ A @ N3 ) @ ( C2 @ N3 ) ) @ ( power_power @ A @ X @ ( minus_minus @ nat @ N3 @ ( suc @ ( zero_zero @ nat ) ) ) ) )
            @ ( suminf @ A
              @ ^ [N3: nat] : ( times_times @ A @ ( diffs @ A @ C2 @ N3 ) @ ( power_power @ A @ X @ N3 ) ) ) ) ) ) ).

% diffs_equiv
thf(fact_4401_bij__betw__roots__unity,axiom,
    ! [N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( bij_betw @ nat @ complex
        @ ^ [K3: nat] : ( cis @ ( divide_divide @ real @ ( times_times @ real @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) @ ( semiring_1_of_nat @ real @ K3 ) ) @ ( semiring_1_of_nat @ real @ N ) ) )
        @ ( set_ord_lessThan @ nat @ N )
        @ ( collect @ complex
          @ ^ [Z6: complex] :
              ( ( power_power @ complex @ Z6 @ N )
              = ( one_one @ complex ) ) ) ) ) ).

% bij_betw_roots_unity
thf(fact_4402_monoI1,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [X7: nat > A] :
          ( ! [M4: nat,N2: nat] :
              ( ( ord_less_eq @ nat @ M4 @ N2 )
             => ( ord_less_eq @ A @ ( X7 @ M4 ) @ ( X7 @ N2 ) ) )
         => ( topological_monoseq @ A @ X7 ) ) ) ).

% monoI1
thf(fact_4403_diffs__def,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ( ( diffs @ A )
        = ( ^ [C4: nat > A,N3: nat] : ( times_times @ A @ ( semiring_1_of_nat @ A @ ( suc @ N3 ) ) @ ( C4 @ ( suc @ N3 ) ) ) ) ) ) ).

% diffs_def
thf(fact_4404_termdiff__converges__all,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [C2: nat > A,X: A] :
          ( ! [X3: A] :
              ( summable @ A
              @ ^ [N3: nat] : ( times_times @ A @ ( C2 @ N3 ) @ ( power_power @ A @ X3 @ N3 ) ) )
         => ( summable @ A
            @ ^ [N3: nat] : ( times_times @ A @ ( diffs @ A @ C2 @ N3 ) @ ( power_power @ A @ X @ N3 ) ) ) ) ) ).

% termdiff_converges_all
thf(fact_4405_termdiff__converges,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A,K6: real,C2: nat > A] :
          ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ X ) @ K6 )
         => ( ! [X3: A] :
                ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ X3 ) @ K6 )
               => ( summable @ A
                  @ ^ [N3: nat] : ( times_times @ A @ ( C2 @ N3 ) @ ( power_power @ A @ X3 @ N3 ) ) ) )
           => ( summable @ A
              @ ^ [N3: nat] : ( times_times @ A @ ( diffs @ A @ C2 @ N3 ) @ ( power_power @ A @ X @ N3 ) ) ) ) ) ) ).

% termdiff_converges
thf(fact_4406_mono__SucI1,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [X7: nat > A] :
          ( ! [N2: nat] : ( ord_less_eq @ A @ ( X7 @ N2 ) @ ( X7 @ ( suc @ N2 ) ) )
         => ( topological_monoseq @ A @ X7 ) ) ) ).

% mono_SucI1
thf(fact_4407_mono__SucI2,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [X7: nat > A] :
          ( ! [N2: nat] : ( ord_less_eq @ A @ ( X7 @ ( suc @ N2 ) ) @ ( X7 @ N2 ) )
         => ( topological_monoseq @ A @ X7 ) ) ) ).

% mono_SucI2
thf(fact_4408_monoseq__Suc,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( topological_monoseq @ A )
        = ( ^ [X8: nat > A] :
              ( ! [N3: nat] : ( ord_less_eq @ A @ ( X8 @ N3 ) @ ( X8 @ ( suc @ N3 ) ) )
              | ! [N3: nat] : ( ord_less_eq @ A @ ( X8 @ ( suc @ N3 ) ) @ ( X8 @ N3 ) ) ) ) ) ) ).

% monoseq_Suc
thf(fact_4409_monoseq__def,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( topological_monoseq @ A )
        = ( ^ [X8: nat > A] :
              ( ! [M3: nat,N3: nat] :
                  ( ( ord_less_eq @ nat @ M3 @ N3 )
                 => ( ord_less_eq @ A @ ( X8 @ M3 ) @ ( X8 @ N3 ) ) )
              | ! [M3: nat,N3: nat] :
                  ( ( ord_less_eq @ nat @ M3 @ N3 )
                 => ( ord_less_eq @ A @ ( X8 @ N3 ) @ ( X8 @ M3 ) ) ) ) ) ) ) ).

% monoseq_def
thf(fact_4410_monoI2,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [X7: nat > A] :
          ( ! [M4: nat,N2: nat] :
              ( ( ord_less_eq @ nat @ M4 @ N2 )
             => ( ord_less_eq @ A @ ( X7 @ N2 ) @ ( X7 @ M4 ) ) )
         => ( topological_monoseq @ A @ X7 ) ) ) ).

% monoI2
thf(fact_4411_of__nat__code,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ( ( semiring_1_of_nat @ A )
        = ( ^ [N3: nat] :
              ( semiri8178284476397505188at_aux @ A
              @ ^ [I4: A] : ( plus_plus @ A @ I4 @ ( one_one @ A ) )
              @ N3
              @ ( zero_zero @ A ) ) ) ) ) ).

% of_nat_code
thf(fact_4412_Arg__def,axiom,
    ( arg
    = ( ^ [Z6: complex] :
          ( if @ real
          @ ( Z6
            = ( zero_zero @ complex ) )
          @ ( zero_zero @ real )
          @ ( fChoice @ real
            @ ^ [A3: real] :
                ( ( ( sgn_sgn @ complex @ Z6 )
                  = ( cis @ A3 ) )
                & ( ord_less @ real @ ( uminus_uminus @ real @ pi ) @ A3 )
                & ( ord_less_eq @ real @ A3 @ pi ) ) ) ) ) ) ).

% Arg_def
thf(fact_4413_vebt__buildup_Opelims,axiom,
    ! [X: nat,Y: vEBT_VEBT] :
      ( ( ( vEBT_vebt_buildup @ X )
        = Y )
     => ( ( accp @ nat @ vEBT_v4011308405150292612up_rel @ X )
       => ( ( ( X
              = ( zero_zero @ nat ) )
           => ( ( Y
                = ( vEBT_Leaf @ $false @ $false ) )
             => ~ ( accp @ nat @ vEBT_v4011308405150292612up_rel @ ( zero_zero @ nat ) ) ) )
         => ( ( ( X
                = ( suc @ ( zero_zero @ nat ) ) )
             => ( ( Y
                  = ( vEBT_Leaf @ $false @ $false ) )
               => ~ ( accp @ nat @ vEBT_v4011308405150292612up_rel @ ( suc @ ( zero_zero @ nat ) ) ) ) )
           => ~ ! [Va: nat] :
                  ( ( X
                    = ( suc @ ( suc @ Va ) ) )
                 => ( ( ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( suc @ ( suc @ Va ) ) )
                       => ( Y
                          = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ ( suc @ Va ) ) @ ( replicate @ vEBT_VEBT @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( vEBT_vebt_buildup @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_vebt_buildup @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) )
                      & ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( suc @ ( suc @ Va ) ) )
                       => ( Y
                          = ( vEBT_Node @ ( none @ ( product_prod @ nat @ nat ) ) @ ( suc @ ( suc @ Va ) ) @ ( replicate @ vEBT_VEBT @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( suc @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_vebt_buildup @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( vEBT_vebt_buildup @ ( suc @ ( divide_divide @ nat @ ( suc @ ( suc @ Va ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) )
                   => ~ ( accp @ nat @ vEBT_v4011308405150292612up_rel @ ( suc @ ( suc @ Va ) ) ) ) ) ) ) ) ) ).

% vebt_buildup.pelims
thf(fact_4414_option_Osize__gen_I2_J,axiom,
    ! [A: $tType,X: A > nat,X22: A] :
      ( ( size_option @ A @ X @ ( some @ A @ X22 ) )
      = ( plus_plus @ nat @ ( X @ X22 ) @ ( suc @ ( zero_zero @ nat ) ) ) ) ).

% option.size_gen(2)
thf(fact_4415_verit__sko__forall__indirect2,axiom,
    ! [A: $tType,X: A,P: A > $o,P4: A > $o] :
      ( ( X
        = ( fChoice @ A
          @ ^ [X2: A] :
              ~ ( P @ X2 ) ) )
     => ( ! [X3: A] :
            ( ( P @ X3 )
            = ( P4 @ X3 ) )
       => ( ( ! [X8: A] : ( P4 @ X8 ) )
          = ( P @ X ) ) ) ) ).

% verit_sko_forall_indirect2
thf(fact_4416_verit__sko__forall__indirect,axiom,
    ! [A: $tType,X: A,P: A > $o] :
      ( ( X
        = ( fChoice @ A
          @ ^ [X2: A] :
              ~ ( P @ X2 ) ) )
     => ( ( ! [X8: A] : ( P @ X8 ) )
        = ( P @ X ) ) ) ).

% verit_sko_forall_indirect
thf(fact_4417_verit__sko__ex__indirect2,axiom,
    ! [A: $tType,X: A,P: A > $o,P4: A > $o] :
      ( ( X
        = ( fChoice @ A @ P ) )
     => ( ! [X3: A] :
            ( ( P @ X3 )
            = ( P4 @ X3 ) )
       => ( ( ? [X8: A] : ( P4 @ X8 ) )
          = ( P @ X ) ) ) ) ).

% verit_sko_ex_indirect2
thf(fact_4418_verit__sko__ex__indirect,axiom,
    ! [A: $tType,X: A,P: A > $o] :
      ( ( X
        = ( fChoice @ A @ P ) )
     => ( ( ? [X8: A] : ( P @ X8 ) )
        = ( P @ X ) ) ) ).

% verit_sko_ex_indirect
thf(fact_4419_verit__sko__forall_H_H,axiom,
    ! [A: $tType,B7: A,A4: A,P: A > $o] :
      ( ( B7 = A4 )
     => ( ( ( fChoice @ A @ P )
          = A4 )
        = ( ( fChoice @ A @ P )
          = B7 ) ) ) ).

% verit_sko_forall''
thf(fact_4420_verit__sko__forall_H,axiom,
    ! [A: $tType,P: A > $o,A4: $o] :
      ( ( ( P
          @ ( fChoice @ A
            @ ^ [X2: A] :
                ~ ( P @ X2 ) ) )
        = A4 )
     => ( ( ! [X8: A] : ( P @ X8 ) )
        = A4 ) ) ).

% verit_sko_forall'
thf(fact_4421_verit__sko__forall,axiom,
    ! [A: $tType] :
      ( ( ^ [P2: A > $o] :
          ! [X4: A] : ( P2 @ X4 ) )
      = ( ^ [P3: A > $o] :
            ( P3
            @ ( fChoice @ A
              @ ^ [X2: A] :
                  ~ ( P3 @ X2 ) ) ) ) ) ).

% verit_sko_forall
thf(fact_4422_verit__sko__ex_H,axiom,
    ! [A: $tType,P: A > $o,A4: $o] :
      ( ( ( P @ ( fChoice @ A @ P ) )
        = A4 )
     => ( ( ? [X8: A] : ( P @ X8 ) )
        = A4 ) ) ).

% verit_sko_ex'
thf(fact_4423_of__nat__aux_Osimps_I2_J,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [Inc: A > A,N: nat,I: A] :
          ( ( semiri8178284476397505188at_aux @ A @ Inc @ ( suc @ N ) @ I )
          = ( semiri8178284476397505188at_aux @ A @ Inc @ N @ ( Inc @ I ) ) ) ) ).

% of_nat_aux.simps(2)
thf(fact_4424_of__nat__aux_Osimps_I1_J,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [Inc: A > A,I: A] :
          ( ( semiri8178284476397505188at_aux @ A @ Inc @ ( zero_zero @ nat ) @ I )
          = I ) ) ).

% of_nat_aux.simps(1)
thf(fact_4425_option_Osize__gen_I1_J,axiom,
    ! [A: $tType,X: A > nat] :
      ( ( size_option @ A @ X @ ( none @ A ) )
      = ( suc @ ( zero_zero @ nat ) ) ) ).

% option.size_gen(1)
thf(fact_4426_divmod__algorithm__code_I6_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [M: num,N: num] :
          ( ( unique8689654367752047608divmod @ A @ ( bit1 @ M ) @ ( bit0 @ N ) )
          = ( product_case_prod @ A @ A @ ( product_prod @ A @ A )
            @ ^ [Q6: A,R5: A] : ( product_Pair @ A @ A @ Q6 @ ( plus_plus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ R5 ) @ ( one_one @ A ) ) )
            @ ( unique8689654367752047608divmod @ A @ M @ N ) ) ) ) ).

% divmod_algorithm_code(6)
thf(fact_4427_arctan__def,axiom,
    ( arctan
    = ( ^ [Y4: real] :
          ( the @ real
          @ ^ [X2: real] :
              ( ( ord_less @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ X2 )
              & ( ord_less @ real @ X2 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
              & ( ( tan @ real @ X2 )
                = Y4 ) ) ) ) ) ).

% arctan_def
thf(fact_4428_arcsin__def,axiom,
    ( arcsin
    = ( ^ [Y4: real] :
          ( the @ real
          @ ^ [X2: real] :
              ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ X2 )
              & ( ord_less_eq @ real @ X2 @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
              & ( ( sin @ real @ X2 )
                = Y4 ) ) ) ) ) ).

% arcsin_def
thf(fact_4429_divmod__step__def,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ( ( unique1321980374590559556d_step @ A )
        = ( ^ [L2: num] :
              ( product_case_prod @ A @ A @ ( product_prod @ A @ A )
              @ ^ [Q6: A,R5: A] : ( if @ ( product_prod @ A @ A ) @ ( ord_less_eq @ A @ ( numeral_numeral @ A @ L2 ) @ R5 ) @ ( product_Pair @ A @ A @ ( plus_plus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ Q6 ) @ ( one_one @ A ) ) @ ( minus_minus @ A @ R5 @ ( numeral_numeral @ A @ L2 ) ) ) @ ( product_Pair @ A @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ Q6 ) @ R5 ) ) ) ) ) ) ).

% divmod_step_def
thf(fact_4430_divmod__algorithm__code_I5_J,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [M: num,N: num] :
          ( ( unique8689654367752047608divmod @ A @ ( bit0 @ M ) @ ( bit0 @ N ) )
          = ( product_case_prod @ A @ A @ ( product_prod @ A @ A )
            @ ^ [Q6: A,R5: A] : ( product_Pair @ A @ A @ Q6 @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ R5 ) )
            @ ( unique8689654367752047608divmod @ A @ M @ N ) ) ) ) ).

% divmod_algorithm_code(5)
thf(fact_4431_split__cong,axiom,
    ! [C: $tType,B: $tType,A: $tType,Q3: product_prod @ A @ B,F2: A > B > C,G: A > B > C,P6: product_prod @ A @ B] :
      ( ! [X3: A,Y5: B] :
          ( ( ( product_Pair @ A @ B @ X3 @ Y5 )
            = Q3 )
         => ( ( F2 @ X3 @ Y5 )
            = ( G @ X3 @ Y5 ) ) )
     => ( ( P6 = Q3 )
       => ( ( product_case_prod @ A @ B @ C @ F2 @ P6 )
          = ( product_case_prod @ A @ B @ C @ G @ Q3 ) ) ) ) ).

% split_cong
thf(fact_4432_ln__neg__is__const,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ X @ ( zero_zero @ real ) )
     => ( ( ln_ln @ real @ X )
        = ( the @ real
          @ ^ [X2: real] : $false ) ) ) ).

% ln_neg_is_const
thf(fact_4433_arccos__def,axiom,
    ( arccos
    = ( ^ [Y4: real] :
          ( the @ real
          @ ^ [X2: real] :
              ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X2 )
              & ( ord_less_eq @ real @ X2 @ pi )
              & ( ( cos @ real @ X2 )
                = Y4 ) ) ) ) ) ).

% arccos_def
thf(fact_4434_divmod__step__nat__def,axiom,
    ( ( unique1321980374590559556d_step @ nat )
    = ( ^ [L2: num] :
          ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
          @ ^ [Q6: nat,R5: nat] : ( if @ ( product_prod @ nat @ nat ) @ ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ L2 ) @ R5 ) @ ( product_Pair @ nat @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Q6 ) @ ( one_one @ nat ) ) @ ( minus_minus @ nat @ R5 @ ( numeral_numeral @ nat @ L2 ) ) ) @ ( product_Pair @ nat @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Q6 ) @ R5 ) ) ) ) ) ).

% divmod_step_nat_def
thf(fact_4435_divmod__step__int__def,axiom,
    ( ( unique1321980374590559556d_step @ int )
    = ( ^ [L2: num] :
          ( product_case_prod @ int @ int @ ( product_prod @ int @ int )
          @ ^ [Q6: int,R5: int] : ( if @ ( product_prod @ int @ int ) @ ( ord_less_eq @ int @ ( numeral_numeral @ int @ L2 ) @ R5 ) @ ( product_Pair @ int @ int @ ( plus_plus @ int @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ Q6 ) @ ( one_one @ int ) ) @ ( minus_minus @ int @ R5 @ ( numeral_numeral @ int @ L2 ) ) ) @ ( product_Pair @ int @ int @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ Q6 ) @ R5 ) ) ) ) ) ).

% divmod_step_int_def
thf(fact_4436_pi__half,axiom,
    ( ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) )
    = ( the @ real
      @ ^ [X2: real] :
          ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X2 )
          & ( ord_less_eq @ real @ X2 @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) )
          & ( ( cos @ real @ X2 )
            = ( zero_zero @ real ) ) ) ) ) ).

% pi_half
thf(fact_4437_pi__def,axiom,
    ( pi
    = ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) )
      @ ( the @ real
        @ ^ [X2: real] :
            ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X2 )
            & ( ord_less_eq @ real @ X2 @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) )
            & ( ( cos @ real @ X2 )
              = ( zero_zero @ real ) ) ) ) ) ) ).

% pi_def
thf(fact_4438_divmod__nat__if,axiom,
    ( divmod_nat
    = ( ^ [M3: nat,N3: nat] :
          ( if @ ( product_prod @ nat @ nat )
          @ ( ( N3
              = ( zero_zero @ nat ) )
            | ( ord_less @ nat @ M3 @ N3 ) )
          @ ( product_Pair @ nat @ nat @ ( zero_zero @ nat ) @ M3 )
          @ ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
            @ ^ [Q6: nat] : ( product_Pair @ nat @ nat @ ( suc @ Q6 ) )
            @ ( divmod_nat @ ( minus_minus @ nat @ M3 @ N3 ) @ N3 ) ) ) ) ) ).

% divmod_nat_if
thf(fact_4439_set__encode__def,axiom,
    ( nat_set_encode
    = ( groups7311177749621191930dd_sum @ nat @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ).

% set_encode_def
thf(fact_4440_valid__eq,axiom,
    vEBT_VEBT_valid = vEBT_invar_vebt ).

% valid_eq
thf(fact_4441_valid__eq1,axiom,
    ! [T2: vEBT_VEBT,D2: nat] :
      ( ( vEBT_invar_vebt @ T2 @ D2 )
     => ( vEBT_VEBT_valid @ T2 @ D2 ) ) ).

% valid_eq1
thf(fact_4442_valid__eq2,axiom,
    ! [T2: vEBT_VEBT,D2: nat] :
      ( ( vEBT_VEBT_valid @ T2 @ D2 )
     => ( vEBT_invar_vebt @ T2 @ D2 ) ) ).

% valid_eq2
thf(fact_4443_set__encode__empty,axiom,
    ( ( nat_set_encode @ ( bot_bot @ ( set @ nat ) ) )
    = ( zero_zero @ nat ) ) ).

% set_encode_empty
thf(fact_4444_sum_Otriangle__reindex__eq,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > nat > A,N: nat] :
          ( ( groups7311177749621191930dd_sum @ ( product_prod @ nat @ nat ) @ A @ ( product_case_prod @ nat @ nat @ A @ G )
            @ ( collect @ ( product_prod @ nat @ nat )
              @ ( product_case_prod @ nat @ nat @ $o
                @ ^ [I4: nat,J3: nat] : ( ord_less_eq @ nat @ ( plus_plus @ nat @ I4 @ J3 ) @ N ) ) ) )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [K3: nat] :
                ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I4: nat] : ( G @ I4 @ ( minus_minus @ nat @ K3 @ I4 ) )
                @ ( set_ord_atMost @ nat @ K3 ) )
            @ ( set_ord_atMost @ nat @ N ) ) ) ) ).

% sum.triangle_reindex_eq
thf(fact_4445_prod_Otriangle__reindex__eq,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > nat > A,N: nat] :
          ( ( groups7121269368397514597t_prod @ ( product_prod @ nat @ nat ) @ A @ ( product_case_prod @ nat @ nat @ A @ G )
            @ ( collect @ ( product_prod @ nat @ nat )
              @ ( product_case_prod @ nat @ nat @ $o
                @ ^ [I4: nat,J3: nat] : ( ord_less_eq @ nat @ ( plus_plus @ nat @ I4 @ J3 ) @ N ) ) ) )
          = ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [K3: nat] :
                ( groups7121269368397514597t_prod @ nat @ A
                @ ^ [I4: nat] : ( G @ I4 @ ( minus_minus @ nat @ K3 @ I4 ) )
                @ ( set_ord_atMost @ nat @ K3 ) )
            @ ( set_ord_atMost @ nat @ N ) ) ) ) ).

% prod.triangle_reindex_eq
thf(fact_4446_sum_Otriangle__reindex,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > nat > A,N: nat] :
          ( ( groups7311177749621191930dd_sum @ ( product_prod @ nat @ nat ) @ A @ ( product_case_prod @ nat @ nat @ A @ G )
            @ ( collect @ ( product_prod @ nat @ nat )
              @ ( product_case_prod @ nat @ nat @ $o
                @ ^ [I4: nat,J3: nat] : ( ord_less @ nat @ ( plus_plus @ nat @ I4 @ J3 ) @ N ) ) ) )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [K3: nat] :
                ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I4: nat] : ( G @ I4 @ ( minus_minus @ nat @ K3 @ I4 ) )
                @ ( set_ord_atMost @ nat @ K3 ) )
            @ ( set_ord_lessThan @ nat @ N ) ) ) ) ).

% sum.triangle_reindex
thf(fact_4447_prod_Otriangle__reindex,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > nat > A,N: nat] :
          ( ( groups7121269368397514597t_prod @ ( product_prod @ nat @ nat ) @ A @ ( product_case_prod @ nat @ nat @ A @ G )
            @ ( collect @ ( product_prod @ nat @ nat )
              @ ( product_case_prod @ nat @ nat @ $o
                @ ^ [I4: nat,J3: nat] : ( ord_less @ nat @ ( plus_plus @ nat @ I4 @ J3 ) @ N ) ) ) )
          = ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [K3: nat] :
                ( groups7121269368397514597t_prod @ nat @ A
                @ ^ [I4: nat] : ( G @ I4 @ ( minus_minus @ nat @ K3 @ I4 ) )
                @ ( set_ord_atMost @ nat @ K3 ) )
            @ ( set_ord_lessThan @ nat @ N ) ) ) ) ).

% prod.triangle_reindex
thf(fact_4448_Divides_Oadjust__div__def,axiom,
    ( adjust_div
    = ( product_case_prod @ int @ int @ int
      @ ^ [Q6: int,R5: int] :
          ( plus_plus @ int @ Q6
          @ ( zero_neq_one_of_bool @ int
            @ ( R5
             != ( zero_zero @ int ) ) ) ) ) ) ).

% Divides.adjust_div_def
thf(fact_4449_of__nat__code__if,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ( ( semiring_1_of_nat @ A )
        = ( ^ [N3: nat] :
              ( if @ A
              @ ( N3
                = ( zero_zero @ nat ) )
              @ ( zero_zero @ A )
              @ ( product_case_prod @ nat @ nat @ A
                @ ^ [M3: nat,Q6: nat] :
                    ( if @ A
                    @ ( Q6
                      = ( zero_zero @ nat ) )
                    @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( semiring_1_of_nat @ A @ M3 ) )
                    @ ( plus_plus @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( semiring_1_of_nat @ A @ M3 ) ) @ ( one_one @ A ) ) )
                @ ( divmod_nat @ N3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% of_nat_code_if
thf(fact_4450_int__ge__less__than__def,axiom,
    ( int_ge_less_than
    = ( ^ [D4: int] :
          ( collect @ ( product_prod @ int @ int )
          @ ( product_case_prod @ int @ int @ $o
            @ ^ [Z7: int,Z6: int] :
                ( ( ord_less_eq @ int @ D4 @ Z7 )
                & ( ord_less @ int @ Z7 @ Z6 ) ) ) ) ) ) ).

% int_ge_less_than_def
thf(fact_4451_int__ge__less__than2__def,axiom,
    ( int_ge_less_than2
    = ( ^ [D4: int] :
          ( collect @ ( product_prod @ int @ int )
          @ ( product_case_prod @ int @ int @ $o
            @ ^ [Z7: int,Z6: int] :
                ( ( ord_less_eq @ int @ D4 @ Z6 )
                & ( ord_less @ int @ Z7 @ Z6 ) ) ) ) ) ) ).

% int_ge_less_than2_def
thf(fact_4452_set__encode__insert,axiom,
    ! [A4: set @ nat,N: nat] :
      ( ( finite_finite @ nat @ A4 )
     => ( ~ ( member @ nat @ N @ A4 )
       => ( ( nat_set_encode @ ( insert @ nat @ N @ A4 ) )
          = ( plus_plus @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) @ ( nat_set_encode @ A4 ) ) ) ) ) ).

% set_encode_insert
thf(fact_4453_set__vebt__finite,axiom,
    ! [T2: vEBT_VEBT,N: nat] :
      ( ( vEBT_invar_vebt @ T2 @ N )
     => ( finite_finite @ nat @ ( vEBT_VEBT_set_vebt @ T2 ) ) ) ).

% set_vebt_finite
thf(fact_4454_sum_Oinfinite,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A4: set @ B,G: B > A] :
          ( ~ ( finite_finite @ B @ A4 )
         => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ A4 )
            = ( zero_zero @ A ) ) ) ) ).

% sum.infinite
thf(fact_4455_sum__eq__0__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ! [F4: set @ B,F2: B > A] :
          ( ( finite_finite @ B @ F4 )
         => ( ( ( groups7311177749621191930dd_sum @ B @ A @ F2 @ F4 )
              = ( zero_zero @ A ) )
            = ( ! [X2: B] :
                  ( ( member @ B @ X2 @ F4 )
                 => ( ( F2 @ X2 )
                    = ( zero_zero @ A ) ) ) ) ) ) ) ).

% sum_eq_0_iff
thf(fact_4456_prod__zero__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( semidom @ A )
     => ! [A4: set @ B,F2: B > A] :
          ( ( finite_finite @ B @ A4 )
         => ( ( ( groups7121269368397514597t_prod @ B @ A @ F2 @ A4 )
              = ( zero_zero @ A ) )
            = ( ? [X2: B] :
                  ( ( member @ B @ X2 @ A4 )
                  & ( ( F2 @ X2 )
                    = ( zero_zero @ A ) ) ) ) ) ) ) ).

% prod_zero_iff
thf(fact_4457_infinite__Icc__iff,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ~ ( finite_finite @ A @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) ) )
          = ( ord_less @ A @ A2 @ B2 ) ) ) ).

% infinite_Icc_iff
thf(fact_4458_sum_Odelta_H,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [S: set @ B,A2: B,B2: B > A] :
          ( ( finite_finite @ B @ S )
         => ( ( ( member @ B @ A2 @ S )
             => ( ( groups7311177749621191930dd_sum @ B @ A
                  @ ^ [K3: B] : ( if @ A @ ( A2 = K3 ) @ ( B2 @ K3 ) @ ( zero_zero @ A ) )
                  @ S )
                = ( B2 @ A2 ) ) )
            & ( ~ ( member @ B @ A2 @ S )
             => ( ( groups7311177749621191930dd_sum @ B @ A
                  @ ^ [K3: B] : ( if @ A @ ( A2 = K3 ) @ ( B2 @ K3 ) @ ( zero_zero @ A ) )
                  @ S )
                = ( zero_zero @ A ) ) ) ) ) ) ).

% sum.delta'
thf(fact_4459_sum_Odelta,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [S: set @ B,A2: B,B2: B > A] :
          ( ( finite_finite @ B @ S )
         => ( ( ( member @ B @ A2 @ S )
             => ( ( groups7311177749621191930dd_sum @ B @ A
                  @ ^ [K3: B] : ( if @ A @ ( K3 = A2 ) @ ( B2 @ K3 ) @ ( zero_zero @ A ) )
                  @ S )
                = ( B2 @ A2 ) ) )
            & ( ~ ( member @ B @ A2 @ S )
             => ( ( groups7311177749621191930dd_sum @ B @ A
                  @ ^ [K3: B] : ( if @ A @ ( K3 = A2 ) @ ( B2 @ K3 ) @ ( zero_zero @ A ) )
                  @ S )
                = ( zero_zero @ A ) ) ) ) ) ) ).

% sum.delta
thf(fact_4460_summable__If__finite__set,axiom,
    ! [A: $tType] :
      ( ( ( comm_monoid_add @ A )
        & ( topolo4958980785337419405_space @ A ) )
     => ! [A4: set @ nat,F2: nat > A] :
          ( ( finite_finite @ nat @ A4 )
         => ( summable @ A
            @ ^ [R5: nat] : ( if @ A @ ( member @ nat @ R5 @ A4 ) @ ( F2 @ R5 ) @ ( zero_zero @ A ) ) ) ) ) ).

% summable_If_finite_set
thf(fact_4461_summable__If__finite,axiom,
    ! [A: $tType] :
      ( ( ( comm_monoid_add @ A )
        & ( topolo4958980785337419405_space @ A ) )
     => ! [P: nat > $o,F2: nat > A] :
          ( ( finite_finite @ nat @ ( collect @ nat @ P ) )
         => ( summable @ A
            @ ^ [R5: nat] : ( if @ A @ ( P @ R5 ) @ ( F2 @ R5 ) @ ( zero_zero @ A ) ) ) ) ) ).

% summable_If_finite
thf(fact_4462_prod__pos__nat__iff,axiom,
    ! [A: $tType,A4: set @ A,F2: A > nat] :
      ( ( finite_finite @ A @ A4 )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( groups7121269368397514597t_prod @ A @ nat @ F2 @ A4 ) )
        = ( ! [X2: A] :
              ( ( member @ A @ X2 @ A4 )
             => ( ord_less @ nat @ ( zero_zero @ nat ) @ ( F2 @ X2 ) ) ) ) ) ) ).

% prod_pos_nat_iff
thf(fact_4463_sum__zero__power,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [A4: set @ nat,C2: nat > A] :
          ( ( ( ( finite_finite @ nat @ A4 )
              & ( member @ nat @ ( zero_zero @ nat ) @ A4 ) )
           => ( ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I4: nat] : ( times_times @ A @ ( C2 @ I4 ) @ ( power_power @ A @ ( zero_zero @ A ) @ I4 ) )
                @ A4 )
              = ( C2 @ ( zero_zero @ nat ) ) ) )
          & ( ~ ( ( finite_finite @ nat @ A4 )
                & ( member @ nat @ ( zero_zero @ nat ) @ A4 ) )
           => ( ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I4: nat] : ( times_times @ A @ ( C2 @ I4 ) @ ( power_power @ A @ ( zero_zero @ A ) @ I4 ) )
                @ A4 )
              = ( zero_zero @ A ) ) ) ) ) ).

% sum_zero_power
thf(fact_4464_sum__zero__power_H,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A4: set @ nat,C2: nat > A,D2: nat > A] :
          ( ( ( ( finite_finite @ nat @ A4 )
              & ( member @ nat @ ( zero_zero @ nat ) @ A4 ) )
           => ( ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I4: nat] : ( divide_divide @ A @ ( times_times @ A @ ( C2 @ I4 ) @ ( power_power @ A @ ( zero_zero @ A ) @ I4 ) ) @ ( D2 @ I4 ) )
                @ A4 )
              = ( divide_divide @ A @ ( C2 @ ( zero_zero @ nat ) ) @ ( D2 @ ( zero_zero @ nat ) ) ) ) )
          & ( ~ ( ( finite_finite @ nat @ A4 )
                & ( member @ nat @ ( zero_zero @ nat ) @ A4 ) )
           => ( ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I4: nat] : ( divide_divide @ A @ ( times_times @ A @ ( C2 @ I4 ) @ ( power_power @ A @ ( zero_zero @ A ) @ I4 ) ) @ ( D2 @ I4 ) )
                @ A4 )
              = ( zero_zero @ A ) ) ) ) ) ).

% sum_zero_power'
thf(fact_4465_finite__M__bounded__by__nat,axiom,
    ! [P: nat > $o,I: nat] :
      ( finite_finite @ nat
      @ ( collect @ nat
        @ ^ [K3: nat] :
            ( ( P @ K3 )
            & ( ord_less @ nat @ K3 @ I ) ) ) ) ).

% finite_M_bounded_by_nat
thf(fact_4466_finite__nat__set__iff__bounded,axiom,
    ( ( finite_finite @ nat )
    = ( ^ [N6: set @ nat] :
        ? [M3: nat] :
        ! [X2: nat] :
          ( ( member @ nat @ X2 @ N6 )
         => ( ord_less @ nat @ X2 @ M3 ) ) ) ) ).

% finite_nat_set_iff_bounded
thf(fact_4467_bounded__nat__set__is__finite,axiom,
    ! [N4: set @ nat,N: nat] :
      ( ! [X3: nat] :
          ( ( member @ nat @ X3 @ N4 )
         => ( ord_less @ nat @ X3 @ N ) )
     => ( finite_finite @ nat @ N4 ) ) ).

% bounded_nat_set_is_finite
thf(fact_4468_finite__nat__set__iff__bounded__le,axiom,
    ( ( finite_finite @ nat )
    = ( ^ [N6: set @ nat] :
        ? [M3: nat] :
        ! [X2: nat] :
          ( ( member @ nat @ X2 @ N6 )
         => ( ord_less_eq @ nat @ X2 @ M3 ) ) ) ) ).

% finite_nat_set_iff_bounded_le
thf(fact_4469_finite__less__ub,axiom,
    ! [F2: nat > nat,U: nat] :
      ( ! [N2: nat] : ( ord_less_eq @ nat @ N2 @ ( F2 @ N2 ) )
     => ( finite_finite @ nat
        @ ( collect @ nat
          @ ^ [N3: nat] : ( ord_less_eq @ nat @ ( F2 @ N3 ) @ U ) ) ) ) ).

% finite_less_ub
thf(fact_4470_ex__min__if__finite,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [S: set @ A] :
          ( ( finite_finite @ A @ S )
         => ( ( S
             != ( bot_bot @ ( set @ A ) ) )
           => ? [X3: A] :
                ( ( member @ A @ X3 @ S )
                & ~ ? [Xa2: A] :
                      ( ( member @ A @ Xa2 @ S )
                      & ( ord_less @ A @ Xa2 @ X3 ) ) ) ) ) ) ).

% ex_min_if_finite
thf(fact_4471_infinite__growing,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X7: set @ A] :
          ( ( X7
           != ( bot_bot @ ( set @ A ) ) )
         => ( ! [X3: A] :
                ( ( member @ A @ X3 @ X7 )
               => ? [Xa2: A] :
                    ( ( member @ A @ Xa2 @ X7 )
                    & ( ord_less @ A @ X3 @ Xa2 ) ) )
           => ~ ( finite_finite @ A @ X7 ) ) ) ) ).

% infinite_growing
thf(fact_4472_sum__mono__inv,axiom,
    ! [A: $tType,I6: $tType] :
      ( ( ordere8940638589300402666id_add @ A )
     => ! [F2: I6 > A,I5: set @ I6,G: I6 > A,I: I6] :
          ( ( ( groups7311177749621191930dd_sum @ I6 @ A @ F2 @ I5 )
            = ( groups7311177749621191930dd_sum @ I6 @ A @ G @ I5 ) )
         => ( ! [I2: I6] :
                ( ( member @ I6 @ I2 @ I5 )
               => ( ord_less_eq @ A @ ( F2 @ I2 ) @ ( G @ I2 ) ) )
           => ( ( member @ I6 @ I @ I5 )
             => ( ( finite_finite @ I6 @ I5 )
               => ( ( F2 @ I )
                  = ( G @ I ) ) ) ) ) ) ) ).

% sum_mono_inv
thf(fact_4473_prod__zero,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [A4: set @ B,F2: B > A] :
          ( ( finite_finite @ B @ A4 )
         => ( ? [X5: B] :
                ( ( member @ B @ X5 @ A4 )
                & ( ( F2 @ X5 )
                  = ( zero_zero @ A ) ) )
           => ( ( groups7121269368397514597t_prod @ B @ A @ F2 @ A4 )
              = ( zero_zero @ A ) ) ) ) ) ).

% prod_zero
thf(fact_4474_infinite__Icc,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ~ ( finite_finite @ A @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) ) ) ) ).

% infinite_Icc
thf(fact_4475_finite__lists__length__le,axiom,
    ! [A: $tType,A4: set @ A,N: nat] :
      ( ( finite_finite @ A @ A4 )
     => ( finite_finite @ ( list @ A )
        @ ( collect @ ( list @ A )
          @ ^ [Xs3: list @ A] :
              ( ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ Xs3 ) @ A4 )
              & ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ Xs3 ) @ N ) ) ) ) ) ).

% finite_lists_length_le
thf(fact_4476_summable__finite,axiom,
    ! [A: $tType] :
      ( ( ( comm_monoid_add @ A )
        & ( topolo4958980785337419405_space @ A ) )
     => ! [N4: set @ nat,F2: nat > A] :
          ( ( finite_finite @ nat @ N4 )
         => ( ! [N2: nat] :
                ( ~ ( member @ nat @ N2 @ N4 )
               => ( ( F2 @ N2 )
                  = ( zero_zero @ A ) ) )
           => ( summable @ A @ F2 ) ) ) ) ).

% summable_finite
thf(fact_4477_sum_Ofinite__Collect__op,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [I5: set @ B,X: B > A,Y: B > A] :
          ( ( finite_finite @ B
            @ ( collect @ B
              @ ^ [I4: B] :
                  ( ( member @ B @ I4 @ I5 )
                  & ( ( X @ I4 )
                   != ( zero_zero @ A ) ) ) ) )
         => ( ( finite_finite @ B
              @ ( collect @ B
                @ ^ [I4: B] :
                    ( ( member @ B @ I4 @ I5 )
                    & ( ( Y @ I4 )
                     != ( zero_zero @ A ) ) ) ) )
           => ( finite_finite @ B
              @ ( collect @ B
                @ ^ [I4: B] :
                    ( ( member @ B @ I4 @ I5 )
                    & ( ( plus_plus @ A @ ( X @ I4 ) @ ( Y @ I4 ) )
                     != ( zero_zero @ A ) ) ) ) ) ) ) ) ).

% sum.finite_Collect_op
thf(fact_4478_sum_Ointer__filter,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A4: set @ B,G: B > A,P: B > $o] :
          ( ( finite_finite @ B @ A4 )
         => ( ( groups7311177749621191930dd_sum @ B @ A @ G
              @ ( collect @ B
                @ ^ [X2: B] :
                    ( ( member @ B @ X2 @ A4 )
                    & ( P @ X2 ) ) ) )
            = ( groups7311177749621191930dd_sum @ B @ A
              @ ^ [X2: B] : ( if @ A @ ( P @ X2 ) @ ( G @ X2 ) @ ( zero_zero @ A ) )
              @ A4 ) ) ) ) ).

% sum.inter_filter
thf(fact_4479_set__encode__inf,axiom,
    ! [A4: set @ nat] :
      ( ~ ( finite_finite @ nat @ A4 )
     => ( ( nat_set_encode @ A4 )
        = ( zero_zero @ nat ) ) ) ).

% set_encode_inf
thf(fact_4480_finite__int__segment,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [A2: A,B2: A] :
          ( finite_finite @ A
          @ ( collect @ A
            @ ^ [X2: A] :
                ( ( member @ A @ X2 @ ( ring_1_Ints @ A ) )
                & ( ord_less_eq @ A @ A2 @ X2 )
                & ( ord_less_eq @ A @ X2 @ B2 ) ) ) ) ) ).

% finite_int_segment
thf(fact_4481_sum__le__included,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [S2: set @ B,T2: set @ C,G: C > A,I: C > B,F2: B > A] :
          ( ( finite_finite @ B @ S2 )
         => ( ( finite_finite @ C @ T2 )
           => ( ! [X3: C] :
                  ( ( member @ C @ X3 @ T2 )
                 => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( G @ X3 ) ) )
             => ( ! [X3: B] :
                    ( ( member @ B @ X3 @ S2 )
                   => ? [Xa2: C] :
                        ( ( member @ C @ Xa2 @ T2 )
                        & ( ( I @ Xa2 )
                          = X3 )
                        & ( ord_less_eq @ A @ ( F2 @ X3 ) @ ( G @ Xa2 ) ) ) )
               => ( ord_less_eq @ A @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ S2 ) @ ( groups7311177749621191930dd_sum @ C @ A @ G @ T2 ) ) ) ) ) ) ) ).

% sum_le_included
thf(fact_4482_sum__nonneg__eq__0__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [A4: set @ B,F2: B > A] :
          ( ( finite_finite @ B @ A4 )
         => ( ! [X3: B] :
                ( ( member @ B @ X3 @ A4 )
               => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( F2 @ X3 ) ) )
           => ( ( ( groups7311177749621191930dd_sum @ B @ A @ F2 @ A4 )
                = ( zero_zero @ A ) )
              = ( ! [X2: B] :
                    ( ( member @ B @ X2 @ A4 )
                   => ( ( F2 @ X2 )
                      = ( zero_zero @ A ) ) ) ) ) ) ) ) ).

% sum_nonneg_eq_0_iff
thf(fact_4483_sum__strict__mono__ex1,axiom,
    ! [A: $tType,I6: $tType] :
      ( ( ordere8940638589300402666id_add @ A )
     => ! [A4: set @ I6,F2: I6 > A,G: I6 > A] :
          ( ( finite_finite @ I6 @ A4 )
         => ( ! [X3: I6] :
                ( ( member @ I6 @ X3 @ A4 )
               => ( ord_less_eq @ A @ ( F2 @ X3 ) @ ( G @ X3 ) ) )
           => ( ? [X5: I6] :
                  ( ( member @ I6 @ X5 @ A4 )
                  & ( ord_less @ A @ ( F2 @ X5 ) @ ( G @ X5 ) ) )
             => ( ord_less @ A @ ( groups7311177749621191930dd_sum @ I6 @ A @ F2 @ A4 ) @ ( groups7311177749621191930dd_sum @ I6 @ A @ G @ A4 ) ) ) ) ) ) ).

% sum_strict_mono_ex1
thf(fact_4484_sum_Orelated,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [R4: A > A > $o,S: set @ B,H2: B > A,G: B > A] :
          ( ( R4 @ ( zero_zero @ A ) @ ( zero_zero @ A ) )
         => ( ! [X1: A,Y1: A,X23: A,Y22: A] :
                ( ( ( R4 @ X1 @ X23 )
                  & ( R4 @ Y1 @ Y22 ) )
               => ( R4 @ ( plus_plus @ A @ X1 @ Y1 ) @ ( plus_plus @ A @ X23 @ Y22 ) ) )
           => ( ( finite_finite @ B @ S )
             => ( ! [X3: B] :
                    ( ( member @ B @ X3 @ S )
                   => ( R4 @ ( H2 @ X3 ) @ ( G @ X3 ) ) )
               => ( R4 @ ( groups7311177749621191930dd_sum @ B @ A @ H2 @ S ) @ ( groups7311177749621191930dd_sum @ B @ A @ G @ S ) ) ) ) ) ) ) ).

% sum.related
thf(fact_4485_finite__ranking__induct,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [S: set @ B,P: ( set @ B ) > $o,F2: B > A] :
          ( ( finite_finite @ B @ S )
         => ( ( P @ ( bot_bot @ ( set @ B ) ) )
           => ( ! [X3: B,S4: set @ B] :
                  ( ( finite_finite @ B @ S4 )
                 => ( ! [Y6: B] :
                        ( ( member @ B @ Y6 @ S4 )
                       => ( ord_less_eq @ A @ ( F2 @ Y6 ) @ ( F2 @ X3 ) ) )
                   => ( ( P @ S4 )
                     => ( P @ ( insert @ B @ X3 @ S4 ) ) ) ) )
             => ( P @ S ) ) ) ) ) ).

% finite_ranking_induct
thf(fact_4486_finite__linorder__max__induct,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A4: set @ A,P: ( set @ A ) > $o] :
          ( ( finite_finite @ A @ A4 )
         => ( ( P @ ( bot_bot @ ( set @ A ) ) )
           => ( ! [B4: A,A8: set @ A] :
                  ( ( finite_finite @ A @ A8 )
                 => ( ! [X5: A] :
                        ( ( member @ A @ X5 @ A8 )
                       => ( ord_less @ A @ X5 @ B4 ) )
                   => ( ( P @ A8 )
                     => ( P @ ( insert @ A @ B4 @ A8 ) ) ) ) )
             => ( P @ A4 ) ) ) ) ) ).

% finite_linorder_max_induct
thf(fact_4487_finite__linorder__min__induct,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A4: set @ A,P: ( set @ A ) > $o] :
          ( ( finite_finite @ A @ A4 )
         => ( ( P @ ( bot_bot @ ( set @ A ) ) )
           => ( ! [B4: A,A8: set @ A] :
                  ( ( finite_finite @ A @ A8 )
                 => ( ! [X5: A] :
                        ( ( member @ A @ X5 @ A8 )
                       => ( ord_less @ A @ B4 @ X5 ) )
                   => ( ( P @ A8 )
                     => ( P @ ( insert @ A @ B4 @ A8 ) ) ) ) )
             => ( P @ A4 ) ) ) ) ) ).

% finite_linorder_min_induct
thf(fact_4488_sum__strict__mono,axiom,
    ! [A: $tType,B: $tType] :
      ( ( strict7427464778891057005id_add @ A )
     => ! [A4: set @ B,F2: B > A,G: B > A] :
          ( ( finite_finite @ B @ A4 )
         => ( ( A4
             != ( bot_bot @ ( set @ B ) ) )
           => ( ! [X3: B] :
                  ( ( member @ B @ X3 @ A4 )
                 => ( ord_less @ A @ ( F2 @ X3 ) @ ( G @ X3 ) ) )
             => ( ord_less @ A @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ A4 ) @ ( groups7311177749621191930dd_sum @ B @ A @ G @ A4 ) ) ) ) ) ) ).

% sum_strict_mono
thf(fact_4489_sum_Oreindex__bij__witness__not__neutral,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [S5: set @ B,T5: set @ C,S: set @ B,I: C > B,J: B > C,T6: set @ C,G: B > A,H2: C > A] :
          ( ( finite_finite @ B @ S5 )
         => ( ( finite_finite @ C @ T5 )
           => ( ! [A5: B] :
                  ( ( member @ B @ A5 @ ( minus_minus @ ( set @ B ) @ S @ S5 ) )
                 => ( ( I @ ( J @ A5 ) )
                    = A5 ) )
             => ( ! [A5: B] :
                    ( ( member @ B @ A5 @ ( minus_minus @ ( set @ B ) @ S @ S5 ) )
                   => ( member @ C @ ( J @ A5 ) @ ( minus_minus @ ( set @ C ) @ T6 @ T5 ) ) )
               => ( ! [B4: C] :
                      ( ( member @ C @ B4 @ ( minus_minus @ ( set @ C ) @ T6 @ T5 ) )
                     => ( ( J @ ( I @ B4 ) )
                        = B4 ) )
                 => ( ! [B4: C] :
                        ( ( member @ C @ B4 @ ( minus_minus @ ( set @ C ) @ T6 @ T5 ) )
                       => ( member @ B @ ( I @ B4 ) @ ( minus_minus @ ( set @ B ) @ S @ S5 ) ) )
                   => ( ! [A5: B] :
                          ( ( member @ B @ A5 @ S5 )
                         => ( ( G @ A5 )
                            = ( zero_zero @ A ) ) )
                     => ( ! [B4: C] :
                            ( ( member @ C @ B4 @ T5 )
                           => ( ( H2 @ B4 )
                              = ( zero_zero @ A ) ) )
                       => ( ! [A5: B] :
                              ( ( member @ B @ A5 @ S )
                             => ( ( H2 @ ( J @ A5 ) )
                                = ( G @ A5 ) ) )
                         => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ S )
                            = ( groups7311177749621191930dd_sum @ C @ A @ H2 @ T6 ) ) ) ) ) ) ) ) ) ) ) ) ).

% sum.reindex_bij_witness_not_neutral
thf(fact_4490_sum__eq__Suc0__iff,axiom,
    ! [A: $tType,A4: set @ A,F2: A > nat] :
      ( ( finite_finite @ A @ A4 )
     => ( ( ( groups7311177749621191930dd_sum @ A @ nat @ F2 @ A4 )
          = ( suc @ ( zero_zero @ nat ) ) )
        = ( ? [X2: A] :
              ( ( member @ A @ X2 @ A4 )
              & ( ( F2 @ X2 )
                = ( suc @ ( zero_zero @ nat ) ) )
              & ! [Y4: A] :
                  ( ( member @ A @ Y4 @ A4 )
                 => ( ( X2 != Y4 )
                   => ( ( F2 @ Y4 )
                      = ( zero_zero @ nat ) ) ) ) ) ) ) ) ).

% sum_eq_Suc0_iff
thf(fact_4491_sum__eq__1__iff,axiom,
    ! [A: $tType,A4: set @ A,F2: A > nat] :
      ( ( finite_finite @ A @ A4 )
     => ( ( ( groups7311177749621191930dd_sum @ A @ nat @ F2 @ A4 )
          = ( one_one @ nat ) )
        = ( ? [X2: A] :
              ( ( member @ A @ X2 @ A4 )
              & ( ( F2 @ X2 )
                = ( one_one @ nat ) )
              & ! [Y4: A] :
                  ( ( member @ A @ Y4 @ A4 )
                 => ( ( X2 != Y4 )
                   => ( ( F2 @ Y4 )
                      = ( zero_zero @ nat ) ) ) ) ) ) ) ) ).

% sum_eq_1_iff
thf(fact_4492_sum__nonneg__0,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [S2: set @ B,F2: B > A,I: B] :
          ( ( finite_finite @ B @ S2 )
         => ( ! [I2: B] :
                ( ( member @ B @ I2 @ S2 )
               => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( F2 @ I2 ) ) )
           => ( ( ( groups7311177749621191930dd_sum @ B @ A @ F2 @ S2 )
                = ( zero_zero @ A ) )
             => ( ( member @ B @ I @ S2 )
               => ( ( F2 @ I )
                  = ( zero_zero @ A ) ) ) ) ) ) ) ).

% sum_nonneg_0
thf(fact_4493_sum__nonneg__leq__bound,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [S2: set @ B,F2: B > A,B7: A,I: B] :
          ( ( finite_finite @ B @ S2 )
         => ( ! [I2: B] :
                ( ( member @ B @ I2 @ S2 )
               => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( F2 @ I2 ) ) )
           => ( ( ( groups7311177749621191930dd_sum @ B @ A @ F2 @ S2 )
                = B7 )
             => ( ( member @ B @ I @ S2 )
               => ( ord_less_eq @ A @ ( F2 @ I ) @ B7 ) ) ) ) ) ) ).

% sum_nonneg_leq_bound
thf(fact_4494_sum_Osetdiff__irrelevant,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A4: set @ B,G: B > A] :
          ( ( finite_finite @ B @ A4 )
         => ( ( groups7311177749621191930dd_sum @ B @ A @ G
              @ ( minus_minus @ ( set @ B ) @ A4
                @ ( collect @ B
                  @ ^ [X2: B] :
                      ( ( G @ X2 )
                      = ( zero_zero @ A ) ) ) ) )
            = ( groups7311177749621191930dd_sum @ B @ A @ G @ A4 ) ) ) ) ).

% sum.setdiff_irrelevant
thf(fact_4495_finite__divisors__nat,axiom,
    ! [M: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M )
     => ( finite_finite @ nat
        @ ( collect @ nat
          @ ^ [D4: nat] : ( dvd_dvd @ nat @ D4 @ M ) ) ) ) ).

% finite_divisors_nat
thf(fact_4496_sums__If__finite__set,axiom,
    ! [A: $tType] :
      ( ( ( comm_monoid_add @ A )
        & ( topolo4958980785337419405_space @ A ) )
     => ! [A4: set @ nat,F2: nat > A] :
          ( ( finite_finite @ nat @ A4 )
         => ( sums @ A
            @ ^ [R5: nat] : ( if @ A @ ( member @ nat @ R5 @ A4 ) @ ( F2 @ R5 ) @ ( zero_zero @ A ) )
            @ ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ A4 ) ) ) ) ).

% sums_If_finite_set
thf(fact_4497_sums__If__finite,axiom,
    ! [A: $tType] :
      ( ( ( comm_monoid_add @ A )
        & ( topolo4958980785337419405_space @ A ) )
     => ! [P: nat > $o,F2: nat > A] :
          ( ( finite_finite @ nat @ ( collect @ nat @ P ) )
         => ( sums @ A
            @ ^ [R5: nat] : ( if @ A @ ( P @ R5 ) @ ( F2 @ R5 ) @ ( zero_zero @ A ) )
            @ ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( collect @ nat @ P ) ) ) ) ) ).

% sums_If_finite
thf(fact_4498_sums__finite,axiom,
    ! [A: $tType] :
      ( ( ( comm_monoid_add @ A )
        & ( topolo4958980785337419405_space @ A ) )
     => ! [N4: set @ nat,F2: nat > A] :
          ( ( finite_finite @ nat @ N4 )
         => ( ! [N2: nat] :
                ( ~ ( member @ nat @ N2 @ N4 )
               => ( ( F2 @ N2 )
                  = ( zero_zero @ A ) ) )
           => ( sums @ A @ F2 @ ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ N4 ) ) ) ) ) ).

% sums_finite
thf(fact_4499_suminf__finite,axiom,
    ! [A: $tType] :
      ( ( ( comm_monoid_add @ A )
        & ( topological_t2_space @ A ) )
     => ! [N4: set @ nat,F2: nat > A] :
          ( ( finite_finite @ nat @ N4 )
         => ( ! [N2: nat] :
                ( ~ ( member @ nat @ N2 @ N4 )
               => ( ( F2 @ N2 )
                  = ( zero_zero @ A ) ) )
           => ( ( suminf @ A @ F2 )
              = ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ N4 ) ) ) ) ) ).

% suminf_finite
thf(fact_4500_finite__abs__int__segment,axiom,
    ! [A: $tType] :
      ( ( archim2362893244070406136eiling @ A )
     => ! [A2: A] :
          ( finite_finite @ A
          @ ( collect @ A
            @ ^ [K3: A] :
                ( ( member @ A @ K3 @ ( ring_1_Ints @ A ) )
                & ( ord_less_eq @ A @ ( abs_abs @ A @ K3 ) @ A2 ) ) ) ) ) ).

% finite_abs_int_segment
thf(fact_4501_subset__eq__atLeast0__atMost__finite,axiom,
    ! [N4: set @ nat,N: nat] :
      ( ( ord_less_eq @ ( set @ nat ) @ N4 @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N ) )
     => ( finite_finite @ nat @ N4 ) ) ).

% subset_eq_atLeast0_atMost_finite
thf(fact_4502_sum__pos2,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [I5: set @ B,I: B,F2: B > A] :
          ( ( finite_finite @ B @ I5 )
         => ( ( member @ B @ I @ I5 )
           => ( ( ord_less @ A @ ( zero_zero @ A ) @ ( F2 @ I ) )
             => ( ! [I2: B] :
                    ( ( member @ B @ I2 @ I5 )
                   => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( F2 @ I2 ) ) )
               => ( ord_less @ A @ ( zero_zero @ A ) @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ I5 ) ) ) ) ) ) ) ).

% sum_pos2
thf(fact_4503_sum__pos,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [I5: set @ B,F2: B > A] :
          ( ( finite_finite @ B @ I5 )
         => ( ( I5
             != ( bot_bot @ ( set @ B ) ) )
           => ( ! [I2: B] :
                  ( ( member @ B @ I2 @ I5 )
                 => ( ord_less @ A @ ( zero_zero @ A ) @ ( F2 @ I2 ) ) )
             => ( ord_less @ A @ ( zero_zero @ A ) @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ I5 ) ) ) ) ) ) ).

% sum_pos
thf(fact_4504_less__1__prod2,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linordered_idom @ B )
     => ! [I5: set @ A,I: A,F2: A > B] :
          ( ( finite_finite @ A @ I5 )
         => ( ( member @ A @ I @ I5 )
           => ( ( ord_less @ B @ ( one_one @ B ) @ ( F2 @ I ) )
             => ( ! [I2: A] :
                    ( ( member @ A @ I2 @ I5 )
                   => ( ord_less_eq @ B @ ( one_one @ B ) @ ( F2 @ I2 ) ) )
               => ( ord_less @ B @ ( one_one @ B ) @ ( groups7121269368397514597t_prod @ A @ B @ F2 @ I5 ) ) ) ) ) ) ) ).

% less_1_prod2
thf(fact_4505_less__1__prod,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linordered_idom @ B )
     => ! [I5: set @ A,F2: A > B] :
          ( ( finite_finite @ A @ I5 )
         => ( ( I5
             != ( bot_bot @ ( set @ A ) ) )
           => ( ! [I2: A] :
                  ( ( member @ A @ I2 @ I5 )
                 => ( ord_less @ B @ ( one_one @ B ) @ ( F2 @ I2 ) ) )
             => ( ord_less @ B @ ( one_one @ B ) @ ( groups7121269368397514597t_prod @ A @ B @ F2 @ I5 ) ) ) ) ) ) ).

% less_1_prod
thf(fact_4506_sum_Osame__carrier,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [C5: set @ B,A4: set @ B,B7: set @ B,G: B > A,H2: B > A] :
          ( ( finite_finite @ B @ C5 )
         => ( ( ord_less_eq @ ( set @ B ) @ A4 @ C5 )
           => ( ( ord_less_eq @ ( set @ B ) @ B7 @ C5 )
             => ( ! [A5: B] :
                    ( ( member @ B @ A5 @ ( minus_minus @ ( set @ B ) @ C5 @ A4 ) )
                   => ( ( G @ A5 )
                      = ( zero_zero @ A ) ) )
               => ( ! [B4: B] :
                      ( ( member @ B @ B4 @ ( minus_minus @ ( set @ B ) @ C5 @ B7 ) )
                     => ( ( H2 @ B4 )
                        = ( zero_zero @ A ) ) )
                 => ( ( ( groups7311177749621191930dd_sum @ B @ A @ G @ A4 )
                      = ( groups7311177749621191930dd_sum @ B @ A @ H2 @ B7 ) )
                    = ( ( groups7311177749621191930dd_sum @ B @ A @ G @ C5 )
                      = ( groups7311177749621191930dd_sum @ B @ A @ H2 @ C5 ) ) ) ) ) ) ) ) ) ).

% sum.same_carrier
thf(fact_4507_sum_Osame__carrierI,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [C5: set @ B,A4: set @ B,B7: set @ B,G: B > A,H2: B > A] :
          ( ( finite_finite @ B @ C5 )
         => ( ( ord_less_eq @ ( set @ B ) @ A4 @ C5 )
           => ( ( ord_less_eq @ ( set @ B ) @ B7 @ C5 )
             => ( ! [A5: B] :
                    ( ( member @ B @ A5 @ ( minus_minus @ ( set @ B ) @ C5 @ A4 ) )
                   => ( ( G @ A5 )
                      = ( zero_zero @ A ) ) )
               => ( ! [B4: B] :
                      ( ( member @ B @ B4 @ ( minus_minus @ ( set @ B ) @ C5 @ B7 ) )
                     => ( ( H2 @ B4 )
                        = ( zero_zero @ A ) ) )
                 => ( ( ( groups7311177749621191930dd_sum @ B @ A @ G @ C5 )
                      = ( groups7311177749621191930dd_sum @ B @ A @ H2 @ C5 ) )
                   => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ A4 )
                      = ( groups7311177749621191930dd_sum @ B @ A @ H2 @ B7 ) ) ) ) ) ) ) ) ) ).

% sum.same_carrierI
thf(fact_4508_sum_Omono__neutral__left,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [T6: set @ B,S: set @ B,G: B > A] :
          ( ( finite_finite @ B @ T6 )
         => ( ( ord_less_eq @ ( set @ B ) @ S @ T6 )
           => ( ! [X3: B] :
                  ( ( member @ B @ X3 @ ( minus_minus @ ( set @ B ) @ T6 @ S ) )
                 => ( ( G @ X3 )
                    = ( zero_zero @ A ) ) )
             => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ S )
                = ( groups7311177749621191930dd_sum @ B @ A @ G @ T6 ) ) ) ) ) ) ).

% sum.mono_neutral_left
thf(fact_4509_sum_Omono__neutral__right,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [T6: set @ B,S: set @ B,G: B > A] :
          ( ( finite_finite @ B @ T6 )
         => ( ( ord_less_eq @ ( set @ B ) @ S @ T6 )
           => ( ! [X3: B] :
                  ( ( member @ B @ X3 @ ( minus_minus @ ( set @ B ) @ T6 @ S ) )
                 => ( ( G @ X3 )
                    = ( zero_zero @ A ) ) )
             => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ T6 )
                = ( groups7311177749621191930dd_sum @ B @ A @ G @ S ) ) ) ) ) ) ).

% sum.mono_neutral_right
thf(fact_4510_sum_Omono__neutral__cong__left,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [T6: set @ B,S: set @ B,H2: B > A,G: B > A] :
          ( ( finite_finite @ B @ T6 )
         => ( ( ord_less_eq @ ( set @ B ) @ S @ T6 )
           => ( ! [X3: B] :
                  ( ( member @ B @ X3 @ ( minus_minus @ ( set @ B ) @ T6 @ S ) )
                 => ( ( H2 @ X3 )
                    = ( zero_zero @ A ) ) )
             => ( ! [X3: B] :
                    ( ( member @ B @ X3 @ S )
                   => ( ( G @ X3 )
                      = ( H2 @ X3 ) ) )
               => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ S )
                  = ( groups7311177749621191930dd_sum @ B @ A @ H2 @ T6 ) ) ) ) ) ) ) ).

% sum.mono_neutral_cong_left
thf(fact_4511_sum_Omono__neutral__cong__right,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [T6: set @ B,S: set @ B,G: B > A,H2: B > A] :
          ( ( finite_finite @ B @ T6 )
         => ( ( ord_less_eq @ ( set @ B ) @ S @ T6 )
           => ( ! [X3: B] :
                  ( ( member @ B @ X3 @ ( minus_minus @ ( set @ B ) @ T6 @ S ) )
                 => ( ( G @ X3 )
                    = ( zero_zero @ A ) ) )
             => ( ! [X3: B] :
                    ( ( member @ B @ X3 @ S )
                   => ( ( G @ X3 )
                      = ( H2 @ X3 ) ) )
               => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ T6 )
                  = ( groups7311177749621191930dd_sum @ B @ A @ H2 @ S ) ) ) ) ) ) ) ).

% sum.mono_neutral_cong_right
thf(fact_4512_finite__roots__unity,axiom,
    ! [A: $tType] :
      ( ( ( real_V8999393235501362500lgebra @ A )
        & ( idom @ A ) )
     => ! [N: nat] :
          ( ( ord_less_eq @ nat @ ( one_one @ nat ) @ N )
         => ( finite_finite @ A
            @ ( collect @ A
              @ ^ [Z6: A] :
                  ( ( power_power @ A @ Z6 @ N )
                  = ( one_one @ A ) ) ) ) ) ) ).

% finite_roots_unity
thf(fact_4513_sum_Oreindex__bij__betw__not__neutral,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [S5: set @ B,T5: set @ C,H2: B > C,S: set @ B,T6: set @ C,G: C > A] :
          ( ( finite_finite @ B @ S5 )
         => ( ( finite_finite @ C @ T5 )
           => ( ( bij_betw @ B @ C @ H2 @ ( minus_minus @ ( set @ B ) @ S @ S5 ) @ ( minus_minus @ ( set @ C ) @ T6 @ T5 ) )
             => ( ! [A5: B] :
                    ( ( member @ B @ A5 @ S5 )
                   => ( ( G @ ( H2 @ A5 ) )
                      = ( zero_zero @ A ) ) )
               => ( ! [B4: C] :
                      ( ( member @ C @ B4 @ T5 )
                     => ( ( G @ B4 )
                        = ( zero_zero @ A ) ) )
                 => ( ( groups7311177749621191930dd_sum @ B @ A
                      @ ^ [X2: B] : ( G @ ( H2 @ X2 ) )
                      @ S )
                    = ( groups7311177749621191930dd_sum @ C @ A @ G @ T6 ) ) ) ) ) ) ) ) ).

% sum.reindex_bij_betw_not_neutral
thf(fact_4514_prod__mono__strict,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A4: set @ B,F2: B > A,G: B > A] :
          ( ( finite_finite @ B @ A4 )
         => ( ! [I2: B] :
                ( ( member @ B @ I2 @ A4 )
               => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( F2 @ I2 ) )
                  & ( ord_less @ A @ ( F2 @ I2 ) @ ( G @ I2 ) ) ) )
           => ( ( A4
               != ( bot_bot @ ( set @ B ) ) )
             => ( ord_less @ A @ ( groups7121269368397514597t_prod @ B @ A @ F2 @ A4 ) @ ( groups7121269368397514597t_prod @ B @ A @ G @ A4 ) ) ) ) ) ) ).

% prod_mono_strict
thf(fact_4515_sum__mono2,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [B7: set @ B,A4: set @ B,F2: B > A] :
          ( ( finite_finite @ B @ B7 )
         => ( ( ord_less_eq @ ( set @ B ) @ A4 @ B7 )
           => ( ! [B4: B] :
                  ( ( member @ B @ B4 @ ( minus_minus @ ( set @ B ) @ B7 @ A4 ) )
                 => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( F2 @ B4 ) ) )
             => ( ord_less_eq @ A @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ A4 ) @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ B7 ) ) ) ) ) ) ).

% sum_mono2
thf(fact_4516_even__prod__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( semiring_parity @ A )
     => ! [A4: set @ B,F2: B > A] :
          ( ( finite_finite @ B @ A4 )
         => ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( groups7121269368397514597t_prod @ B @ A @ F2 @ A4 ) )
            = ( ? [X2: B] :
                  ( ( member @ B @ X2 @ A4 )
                  & ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( F2 @ X2 ) ) ) ) ) ) ) ).

% even_prod_iff
thf(fact_4517_sum__le__suminf,axiom,
    ! [A: $tType] :
      ( ( ( ordere6911136660526730532id_add @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [F2: nat > A,I5: set @ nat] :
          ( ( summable @ A @ F2 )
         => ( ( finite_finite @ nat @ I5 )
           => ( ! [N2: nat] :
                  ( ( member @ nat @ N2 @ ( uminus_uminus @ ( set @ nat ) @ I5 ) )
                 => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( F2 @ N2 ) ) )
             => ( ord_less_eq @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ I5 ) @ ( suminf @ A @ F2 ) ) ) ) ) ) ).

% sum_le_suminf
thf(fact_4518_sum__strict__mono2,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ordere8940638589300402666id_add @ B )
     => ! [B7: set @ A,A4: set @ A,B2: A,F2: A > B] :
          ( ( finite_finite @ A @ B7 )
         => ( ( ord_less_eq @ ( set @ A ) @ A4 @ B7 )
           => ( ( member @ A @ B2 @ ( minus_minus @ ( set @ A ) @ B7 @ A4 ) )
             => ( ( ord_less @ B @ ( zero_zero @ B ) @ ( F2 @ B2 ) )
               => ( ! [X3: A] :
                      ( ( member @ A @ X3 @ B7 )
                     => ( ord_less_eq @ B @ ( zero_zero @ B ) @ ( F2 @ X3 ) ) )
                 => ( ord_less @ B @ ( groups7311177749621191930dd_sum @ A @ B @ F2 @ A4 ) @ ( groups7311177749621191930dd_sum @ A @ B @ F2 @ B7 ) ) ) ) ) ) ) ) ).

% sum_strict_mono2
thf(fact_4519_member__le__sum,axiom,
    ! [B: $tType,C: $tType] :
      ( ( ( ordere6911136660526730532id_add @ B )
        & ( semiring_1 @ B ) )
     => ! [I: C,A4: set @ C,F2: C > B] :
          ( ( member @ C @ I @ A4 )
         => ( ! [X3: C] :
                ( ( member @ C @ X3 @ ( minus_minus @ ( set @ C ) @ A4 @ ( insert @ C @ I @ ( bot_bot @ ( set @ C ) ) ) ) )
               => ( ord_less_eq @ B @ ( zero_zero @ B ) @ ( F2 @ X3 ) ) )
           => ( ( finite_finite @ C @ A4 )
             => ( ord_less_eq @ B @ ( F2 @ I ) @ ( groups7311177749621191930dd_sum @ C @ B @ F2 @ A4 ) ) ) ) ) ) ).

% member_le_sum
thf(fact_4520_prod__mono2,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linordered_idom @ B )
     => ! [B7: set @ A,A4: set @ A,F2: A > B] :
          ( ( finite_finite @ A @ B7 )
         => ( ( ord_less_eq @ ( set @ A ) @ A4 @ B7 )
           => ( ! [B4: A] :
                  ( ( member @ A @ B4 @ ( minus_minus @ ( set @ A ) @ B7 @ A4 ) )
                 => ( ord_less_eq @ B @ ( one_one @ B ) @ ( F2 @ B4 ) ) )
             => ( ! [A5: A] :
                    ( ( member @ A @ A5 @ A4 )
                   => ( ord_less_eq @ B @ ( zero_zero @ B ) @ ( F2 @ A5 ) ) )
               => ( ord_less_eq @ B @ ( groups7121269368397514597t_prod @ A @ B @ F2 @ A4 ) @ ( groups7121269368397514597t_prod @ A @ B @ F2 @ B7 ) ) ) ) ) ) ) ).

% prod_mono2
thf(fact_4521_prod__diff1,axiom,
    ! [A: $tType,B: $tType] :
      ( ( semidom_divide @ A )
     => ! [A4: set @ B,F2: B > A,A2: B] :
          ( ( finite_finite @ B @ A4 )
         => ( ( ( F2 @ A2 )
             != ( zero_zero @ A ) )
           => ( ( ( member @ B @ A2 @ A4 )
               => ( ( groups7121269368397514597t_prod @ B @ A @ F2 @ ( minus_minus @ ( set @ B ) @ A4 @ ( insert @ B @ A2 @ ( bot_bot @ ( set @ B ) ) ) ) )
                  = ( divide_divide @ A @ ( groups7121269368397514597t_prod @ B @ A @ F2 @ A4 ) @ ( F2 @ A2 ) ) ) )
              & ( ~ ( member @ B @ A2 @ A4 )
               => ( ( groups7121269368397514597t_prod @ B @ A @ F2 @ ( minus_minus @ ( set @ B ) @ A4 @ ( insert @ B @ A2 @ ( bot_bot @ ( set @ B ) ) ) ) )
                  = ( groups7121269368397514597t_prod @ B @ A @ F2 @ A4 ) ) ) ) ) ) ) ).

% prod_diff1
thf(fact_4522_ln__prod,axiom,
    ! [A: $tType,I5: set @ A,F2: A > real] :
      ( ( finite_finite @ A @ I5 )
     => ( ! [I2: A] :
            ( ( member @ A @ I2 @ I5 )
           => ( ord_less @ real @ ( zero_zero @ real ) @ ( F2 @ I2 ) ) )
       => ( ( ln_ln @ real @ ( groups7121269368397514597t_prod @ A @ real @ F2 @ I5 ) )
          = ( groups7311177749621191930dd_sum @ A @ real
            @ ^ [X2: A] : ( ln_ln @ real @ ( F2 @ X2 ) )
            @ I5 ) ) ) ) ).

% ln_prod
thf(fact_4523_even__set__encode__iff,axiom,
    ! [A4: set @ nat] :
      ( ( finite_finite @ nat @ A4 )
     => ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( nat_set_encode @ A4 ) )
        = ( ~ ( member @ nat @ ( zero_zero @ nat ) @ A4 ) ) ) ) ).

% even_set_encode_iff
thf(fact_4524_polyfun__roots__finite,axiom,
    ! [A: $tType] :
      ( ( ( real_V8999393235501362500lgebra @ A )
        & ( idom @ A ) )
     => ! [C2: nat > A,K: nat,N: nat] :
          ( ( ( C2 @ K )
           != ( zero_zero @ A ) )
         => ( ( ord_less_eq @ nat @ K @ N )
           => ( finite_finite @ A
              @ ( collect @ A
                @ ^ [Z6: A] :
                    ( ( groups7311177749621191930dd_sum @ nat @ A
                      @ ^ [I4: nat] : ( times_times @ A @ ( C2 @ I4 ) @ ( power_power @ A @ Z6 @ I4 ) )
                      @ ( set_ord_atMost @ nat @ N ) )
                    = ( zero_zero @ A ) ) ) ) ) ) ) ).

% polyfun_roots_finite
thf(fact_4525_polyfun__finite__roots,axiom,
    ! [A: $tType] :
      ( ( ( real_V8999393235501362500lgebra @ A )
        & ( idom @ A ) )
     => ! [C2: nat > A,N: nat] :
          ( ( finite_finite @ A
            @ ( collect @ A
              @ ^ [X2: A] :
                  ( ( groups7311177749621191930dd_sum @ nat @ A
                    @ ^ [I4: nat] : ( times_times @ A @ ( C2 @ I4 ) @ ( power_power @ A @ X2 @ I4 ) )
                    @ ( set_ord_atMost @ nat @ N ) )
                  = ( zero_zero @ A ) ) ) )
          = ( ? [I4: nat] :
                ( ( ord_less_eq @ nat @ I4 @ N )
                & ( ( C2 @ I4 )
                 != ( zero_zero @ A ) ) ) ) ) ) ).

% polyfun_finite_roots
thf(fact_4526_finite__Collect__le__nat,axiom,
    ! [K: nat] :
      ( finite_finite @ nat
      @ ( collect @ nat
        @ ^ [N3: nat] : ( ord_less_eq @ nat @ N3 @ K ) ) ) ).

% finite_Collect_le_nat
thf(fact_4527_finite__Collect__less__nat,axiom,
    ! [K: nat] :
      ( finite_finite @ nat
      @ ( collect @ nat
        @ ^ [N3: nat] : ( ord_less @ nat @ N3 @ K ) ) ) ).

% finite_Collect_less_nat
thf(fact_4528_finite__has__minimal,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [A4: set @ A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( A4
             != ( bot_bot @ ( set @ A ) ) )
           => ? [X3: A] :
                ( ( member @ A @ X3 @ A4 )
                & ! [Xa2: A] :
                    ( ( member @ A @ Xa2 @ A4 )
                   => ( ( ord_less_eq @ A @ Xa2 @ X3 )
                     => ( X3 = Xa2 ) ) ) ) ) ) ) ).

% finite_has_minimal
thf(fact_4529_finite__has__maximal,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [A4: set @ A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( A4
             != ( bot_bot @ ( set @ A ) ) )
           => ? [X3: A] :
                ( ( member @ A @ X3 @ A4 )
                & ! [Xa2: A] :
                    ( ( member @ A @ Xa2 @ A4 )
                   => ( ( ord_less_eq @ A @ X3 @ Xa2 )
                     => ( X3 = Xa2 ) ) ) ) ) ) ) ).

% finite_has_maximal
thf(fact_4530_finite__interval__int1,axiom,
    ! [A2: int,B2: int] :
      ( finite_finite @ int
      @ ( collect @ int
        @ ^ [I4: int] :
            ( ( ord_less_eq @ int @ A2 @ I4 )
            & ( ord_less_eq @ int @ I4 @ B2 ) ) ) ) ).

% finite_interval_int1
thf(fact_4531_finite__interval__int4,axiom,
    ! [A2: int,B2: int] :
      ( finite_finite @ int
      @ ( collect @ int
        @ ^ [I4: int] :
            ( ( ord_less @ int @ A2 @ I4 )
            & ( ord_less @ int @ I4 @ B2 ) ) ) ) ).

% finite_interval_int4
thf(fact_4532_finite__interval__int2,axiom,
    ! [A2: int,B2: int] :
      ( finite_finite @ int
      @ ( collect @ int
        @ ^ [I4: int] :
            ( ( ord_less_eq @ int @ A2 @ I4 )
            & ( ord_less @ int @ I4 @ B2 ) ) ) ) ).

% finite_interval_int2
thf(fact_4533_finite__interval__int3,axiom,
    ! [A2: int,B2: int] :
      ( finite_finite @ int
      @ ( collect @ int
        @ ^ [I4: int] :
            ( ( ord_less @ int @ A2 @ I4 )
            & ( ord_less_eq @ int @ I4 @ B2 ) ) ) ) ).

% finite_interval_int3
thf(fact_4534_finite__nth__roots,axiom,
    ! [N: nat,C2: complex] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( finite_finite @ complex
        @ ( collect @ complex
          @ ^ [Z6: complex] :
              ( ( power_power @ complex @ Z6 @ N )
              = C2 ) ) ) ) ).

% finite_nth_roots
thf(fact_4535_finite__maxlen,axiom,
    ! [A: $tType,M5: set @ ( list @ A )] :
      ( ( finite_finite @ ( list @ A ) @ M5 )
     => ? [N2: nat] :
        ! [X5: list @ A] :
          ( ( member @ ( list @ A ) @ X5 @ M5 )
         => ( ord_less @ nat @ ( size_size @ ( list @ A ) @ X5 ) @ N2 ) ) ) ).

% finite_maxlen
thf(fact_4536_finite__divisors__int,axiom,
    ! [I: int] :
      ( ( I
       != ( zero_zero @ int ) )
     => ( finite_finite @ int
        @ ( collect @ int
          @ ^ [D4: int] : ( dvd_dvd @ int @ D4 @ I ) ) ) ) ).

% finite_divisors_int
thf(fact_4537_finite__has__minimal2,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [A4: set @ A,A2: A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( member @ A @ A2 @ A4 )
           => ? [X3: A] :
                ( ( member @ A @ X3 @ A4 )
                & ( ord_less_eq @ A @ X3 @ A2 )
                & ! [Xa2: A] :
                    ( ( member @ A @ Xa2 @ A4 )
                   => ( ( ord_less_eq @ A @ Xa2 @ X3 )
                     => ( X3 = Xa2 ) ) ) ) ) ) ) ).

% finite_has_minimal2
thf(fact_4538_finite__has__maximal2,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [A4: set @ A,A2: A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( member @ A @ A2 @ A4 )
           => ? [X3: A] :
                ( ( member @ A @ X3 @ A4 )
                & ( ord_less_eq @ A @ A2 @ X3 )
                & ! [Xa2: A] :
                    ( ( member @ A @ Xa2 @ A4 )
                   => ( ( ord_less_eq @ A @ X3 @ Xa2 )
                     => ( X3 = Xa2 ) ) ) ) ) ) ) ).

% finite_has_maximal2
thf(fact_4539_sum__diff1_H__aux,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ab_group_add @ B )
     => ! [F4: set @ A,I5: set @ A,F2: A > B,I: A] :
          ( ( finite_finite @ A @ F4 )
         => ( ( ord_less_eq @ ( set @ A )
              @ ( collect @ A
                @ ^ [I4: A] :
                    ( ( member @ A @ I4 @ I5 )
                    & ( ( F2 @ I4 )
                     != ( zero_zero @ B ) ) ) )
              @ F4 )
           => ( ( ( member @ A @ I @ I5 )
               => ( ( groups1027152243600224163dd_sum @ A @ B @ F2 @ ( minus_minus @ ( set @ A ) @ I5 @ ( insert @ A @ I @ ( bot_bot @ ( set @ A ) ) ) ) )
                  = ( minus_minus @ B @ ( groups1027152243600224163dd_sum @ A @ B @ F2 @ I5 ) @ ( F2 @ I ) ) ) )
              & ( ~ ( member @ A @ I @ I5 )
               => ( ( groups1027152243600224163dd_sum @ A @ B @ F2 @ ( minus_minus @ ( set @ A ) @ I5 @ ( insert @ A @ I @ ( bot_bot @ ( set @ A ) ) ) ) )
                  = ( groups1027152243600224163dd_sum @ A @ B @ F2 @ I5 ) ) ) ) ) ) ) ).

% sum_diff1'_aux
thf(fact_4540_Sum__Ico__nat,axiom,
    ! [M: nat,N: nat] :
      ( ( groups7311177749621191930dd_sum @ nat @ nat
        @ ^ [X2: nat] : X2
        @ ( set_or7035219750837199246ssThan @ nat @ M @ N ) )
      = ( divide_divide @ nat @ ( minus_minus @ nat @ ( times_times @ nat @ N @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) ) @ ( times_times @ nat @ M @ ( minus_minus @ nat @ M @ ( one_one @ nat ) ) ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ).

% Sum_Ico_nat
thf(fact_4541_VEBT_Osize_I3_J,axiom,
    ! [X11: option @ ( product_prod @ nat @ nat ),X12: nat,X13: list @ vEBT_VEBT,X14: vEBT_VEBT] :
      ( ( size_size @ vEBT_VEBT @ ( vEBT_Node @ X11 @ X12 @ X13 @ X14 ) )
      = ( plus_plus @ nat @ ( plus_plus @ nat @ ( size_list @ vEBT_VEBT @ ( size_size @ vEBT_VEBT ) @ X13 ) @ ( size_size @ vEBT_VEBT @ X14 ) ) @ ( suc @ ( zero_zero @ nat ) ) ) ) ).

% VEBT.size(3)
thf(fact_4542_sum__power2,axiom,
    ! [K: nat] :
      ( ( groups7311177749621191930dd_sum @ nat @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ K ) )
      = ( minus_minus @ nat @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ K ) @ ( one_one @ nat ) ) ) ).

% sum_power2
thf(fact_4543_atLeastLessThan__iff,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [I: A,L: A,U: A] :
          ( ( member @ A @ I @ ( set_or7035219750837199246ssThan @ A @ L @ U ) )
          = ( ( ord_less_eq @ A @ L @ I )
            & ( ord_less @ A @ I @ U ) ) ) ) ).

% atLeastLessThan_iff
thf(fact_4544_atLeastLessThan__empty,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less_eq @ A @ B2 @ A2 )
         => ( ( set_or7035219750837199246ssThan @ A @ A2 @ B2 )
            = ( bot_bot @ ( set @ A ) ) ) ) ) ).

% atLeastLessThan_empty
thf(fact_4545_ivl__subset,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [I: A,J: A,M: A,N: A] :
          ( ( ord_less_eq @ ( set @ A ) @ ( set_or7035219750837199246ssThan @ A @ I @ J ) @ ( set_or7035219750837199246ssThan @ A @ M @ N ) )
          = ( ( ord_less_eq @ A @ J @ I )
            | ( ( ord_less_eq @ A @ M @ I )
              & ( ord_less_eq @ A @ J @ N ) ) ) ) ) ).

% ivl_subset
thf(fact_4546_atLeastLessThan__empty__iff,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ( set_or7035219750837199246ssThan @ A @ A2 @ B2 )
            = ( bot_bot @ ( set @ A ) ) )
          = ( ~ ( ord_less @ A @ A2 @ B2 ) ) ) ) ).

% atLeastLessThan_empty_iff
thf(fact_4547_atLeastLessThan__empty__iff2,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ( bot_bot @ ( set @ A ) )
            = ( set_or7035219750837199246ssThan @ A @ A2 @ B2 ) )
          = ( ~ ( ord_less @ A @ A2 @ B2 ) ) ) ) ).

% atLeastLessThan_empty_iff2
thf(fact_4548_infinite__Ico__iff,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ~ ( finite_finite @ A @ ( set_or7035219750837199246ssThan @ A @ A2 @ B2 ) ) )
          = ( ord_less @ A @ A2 @ B2 ) ) ) ).

% infinite_Ico_iff
thf(fact_4549_ivl__diff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [I: A,N: A,M: A] :
          ( ( ord_less_eq @ A @ I @ N )
         => ( ( minus_minus @ ( set @ A ) @ ( set_or7035219750837199246ssThan @ A @ I @ M ) @ ( set_or7035219750837199246ssThan @ A @ I @ N ) )
            = ( set_or7035219750837199246ssThan @ A @ N @ M ) ) ) ) ).

% ivl_diff
thf(fact_4550_sum_Oempty_H,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [P6: B > A] :
          ( ( groups1027152243600224163dd_sum @ B @ A @ P6 @ ( bot_bot @ ( set @ B ) ) )
          = ( zero_zero @ A ) ) ) ).

% sum.empty'
thf(fact_4551_sum_Oinsert_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [I5: set @ B,P6: B > A,I: B] :
          ( ( finite_finite @ B
            @ ( collect @ B
              @ ^ [X2: B] :
                  ( ( member @ B @ X2 @ I5 )
                  & ( ( P6 @ X2 )
                   != ( zero_zero @ A ) ) ) ) )
         => ( ( ( member @ B @ I @ I5 )
             => ( ( groups1027152243600224163dd_sum @ B @ A @ P6 @ ( insert @ B @ I @ I5 ) )
                = ( groups1027152243600224163dd_sum @ B @ A @ P6 @ I5 ) ) )
            & ( ~ ( member @ B @ I @ I5 )
             => ( ( groups1027152243600224163dd_sum @ B @ A @ P6 @ ( insert @ B @ I @ I5 ) )
                = ( plus_plus @ A @ ( P6 @ I ) @ ( groups1027152243600224163dd_sum @ B @ A @ P6 @ I5 ) ) ) ) ) ) ) ).

% sum.insert'
thf(fact_4552_sum_Oop__ivl__Suc,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [N: nat,M: nat,G: nat > A] :
          ( ( ( ord_less @ nat @ N @ M )
           => ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ M @ ( suc @ N ) ) )
              = ( zero_zero @ A ) ) )
          & ( ~ ( ord_less @ nat @ N @ M )
           => ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ M @ ( suc @ N ) ) )
              = ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ M @ N ) ) @ ( G @ N ) ) ) ) ) ) ).

% sum.op_ivl_Suc
thf(fact_4553_prod_Oop__ivl__Suc,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [N: nat,M: nat,G: nat > A] :
          ( ( ( ord_less @ nat @ N @ M )
           => ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ M @ ( suc @ N ) ) )
              = ( one_one @ A ) ) )
          & ( ~ ( ord_less @ nat @ N @ M )
           => ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ M @ ( suc @ N ) ) )
              = ( times_times @ A @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ M @ N ) ) @ ( G @ N ) ) ) ) ) ) ).

% prod.op_ivl_Suc
thf(fact_4554_atLeastLessThan__inj_I2_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ( set_or7035219750837199246ssThan @ A @ A2 @ B2 )
            = ( set_or7035219750837199246ssThan @ A @ C2 @ D2 ) )
         => ( ( ord_less @ A @ A2 @ B2 )
           => ( ( ord_less @ A @ C2 @ D2 )
             => ( B2 = D2 ) ) ) ) ) ).

% atLeastLessThan_inj(2)
thf(fact_4555_atLeastLessThan__inj_I1_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ( set_or7035219750837199246ssThan @ A @ A2 @ B2 )
            = ( set_or7035219750837199246ssThan @ A @ C2 @ D2 ) )
         => ( ( ord_less @ A @ A2 @ B2 )
           => ( ( ord_less @ A @ C2 @ D2 )
             => ( A2 = C2 ) ) ) ) ) ).

% atLeastLessThan_inj(1)
thf(fact_4556_atLeastLessThan__eq__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_less @ A @ C2 @ D2 )
           => ( ( ( set_or7035219750837199246ssThan @ A @ A2 @ B2 )
                = ( set_or7035219750837199246ssThan @ A @ C2 @ D2 ) )
              = ( ( A2 = C2 )
                & ( B2 = D2 ) ) ) ) ) ) ).

% atLeastLessThan_eq_iff
thf(fact_4557_sum_Onon__neutral_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: B > A,I5: set @ B] :
          ( ( groups1027152243600224163dd_sum @ B @ A @ G
            @ ( collect @ B
              @ ^ [X2: B] :
                  ( ( member @ B @ X2 @ I5 )
                  & ( ( G @ X2 )
                   != ( zero_zero @ A ) ) ) ) )
          = ( groups1027152243600224163dd_sum @ B @ A @ G @ I5 ) ) ) ).

% sum.non_neutral'
thf(fact_4558_atLeastLessThan__subset__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ord_less_eq @ ( set @ A ) @ ( set_or7035219750837199246ssThan @ A @ A2 @ B2 ) @ ( set_or7035219750837199246ssThan @ A @ C2 @ D2 ) )
         => ( ( ord_less_eq @ A @ B2 @ A2 )
            | ( ( ord_less_eq @ A @ C2 @ A2 )
              & ( ord_less_eq @ A @ B2 @ D2 ) ) ) ) ) ).

% atLeastLessThan_subset_iff
thf(fact_4559_infinite__Ico,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ~ ( finite_finite @ A @ ( set_or7035219750837199246ssThan @ A @ A2 @ B2 ) ) ) ) ).

% infinite_Ico
thf(fact_4560_all__nat__less__eq,axiom,
    ! [N: nat,P: nat > $o] :
      ( ( ! [M3: nat] :
            ( ( ord_less @ nat @ M3 @ N )
           => ( P @ M3 ) ) )
      = ( ! [X2: nat] :
            ( ( member @ nat @ X2 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N ) )
           => ( P @ X2 ) ) ) ) ).

% all_nat_less_eq
thf(fact_4561_ex__nat__less__eq,axiom,
    ! [N: nat,P: nat > $o] :
      ( ( ? [M3: nat] :
            ( ( ord_less @ nat @ M3 @ N )
            & ( P @ M3 ) ) )
      = ( ? [X2: nat] :
            ( ( member @ nat @ X2 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N ) )
            & ( P @ X2 ) ) ) ) ).

% ex_nat_less_eq
thf(fact_4562_lessThan__atLeast0,axiom,
    ( ( set_ord_lessThan @ nat )
    = ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) ) ) ).

% lessThan_atLeast0
thf(fact_4563_atLeastLessThan0,axiom,
    ! [M: nat] :
      ( ( set_or7035219750837199246ssThan @ nat @ M @ ( zero_zero @ nat ) )
      = ( bot_bot @ ( set @ nat ) ) ) ).

% atLeastLessThan0
thf(fact_4564_sum_Oivl__cong,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( ord @ B )
        & ( comm_monoid_add @ A ) )
     => ! [A2: B,C2: B,B2: B,D2: B,G: B > A,H2: B > A] :
          ( ( A2 = C2 )
         => ( ( B2 = D2 )
           => ( ! [X3: B] :
                  ( ( ord_less_eq @ B @ C2 @ X3 )
                 => ( ( ord_less @ B @ X3 @ D2 )
                   => ( ( G @ X3 )
                      = ( H2 @ X3 ) ) ) )
             => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ ( set_or7035219750837199246ssThan @ B @ A2 @ B2 ) )
                = ( groups7311177749621191930dd_sum @ B @ A @ H2 @ ( set_or7035219750837199246ssThan @ B @ C2 @ D2 ) ) ) ) ) ) ) ).

% sum.ivl_cong
thf(fact_4565_prod_Oivl__cong,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( ord @ B )
        & ( comm_monoid_mult @ A ) )
     => ! [A2: B,C2: B,B2: B,D2: B,G: B > A,H2: B > A] :
          ( ( A2 = C2 )
         => ( ( B2 = D2 )
           => ( ! [X3: B] :
                  ( ( ord_less_eq @ B @ C2 @ X3 )
                 => ( ( ord_less @ B @ X3 @ D2 )
                   => ( ( G @ X3 )
                      = ( H2 @ X3 ) ) ) )
             => ( ( groups7121269368397514597t_prod @ B @ A @ G @ ( set_or7035219750837199246ssThan @ B @ A2 @ B2 ) )
                = ( groups7121269368397514597t_prod @ B @ A @ H2 @ ( set_or7035219750837199246ssThan @ B @ C2 @ D2 ) ) ) ) ) ) ) ).

% prod.ivl_cong
thf(fact_4566_sum_OatLeastLessThan__concat,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [M: nat,N: nat,P6: nat,G: nat > A] :
          ( ( ord_less_eq @ nat @ M @ N )
         => ( ( ord_less_eq @ nat @ N @ P6 )
           => ( ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ M @ N ) ) @ ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ N @ P6 ) ) )
              = ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ M @ P6 ) ) ) ) ) ) ).

% sum.atLeastLessThan_concat
thf(fact_4567_sum__diff__nat__ivl,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [M: nat,N: nat,P6: nat,F2: nat > A] :
          ( ( ord_less_eq @ nat @ M @ N )
         => ( ( ord_less_eq @ nat @ N @ P6 )
           => ( ( minus_minus @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_or7035219750837199246ssThan @ nat @ M @ P6 ) ) @ ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_or7035219750837199246ssThan @ nat @ M @ N ) ) )
              = ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_or7035219750837199246ssThan @ nat @ N @ P6 ) ) ) ) ) ) ).

% sum_diff_nat_ivl
thf(fact_4568_size__list__estimation,axiom,
    ! [A: $tType,X: A,Xs: list @ A,Y: nat,F2: A > nat] :
      ( ( member @ A @ X @ ( set2 @ A @ Xs ) )
     => ( ( ord_less @ nat @ Y @ ( F2 @ X ) )
       => ( ord_less @ nat @ Y @ ( size_list @ A @ F2 @ Xs ) ) ) ) ).

% size_list_estimation
thf(fact_4569_size__list__estimation_H,axiom,
    ! [A: $tType,X: A,Xs: list @ A,Y: nat,F2: A > nat] :
      ( ( member @ A @ X @ ( set2 @ A @ Xs ) )
     => ( ( ord_less_eq @ nat @ Y @ ( F2 @ X ) )
       => ( ord_less_eq @ nat @ Y @ ( size_list @ A @ F2 @ Xs ) ) ) ) ).

% size_list_estimation'
thf(fact_4570_size__list__pointwise,axiom,
    ! [A: $tType,Xs: list @ A,F2: A > nat,G: A > nat] :
      ( ! [X3: A] :
          ( ( member @ A @ X3 @ ( set2 @ A @ Xs ) )
         => ( ord_less_eq @ nat @ ( F2 @ X3 ) @ ( G @ X3 ) ) )
     => ( ord_less_eq @ nat @ ( size_list @ A @ F2 @ Xs ) @ ( size_list @ A @ G @ Xs ) ) ) ).

% size_list_pointwise
thf(fact_4571_prod_OatLeastLessThan__concat,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [M: nat,N: nat,P6: nat,G: nat > A] :
          ( ( ord_less_eq @ nat @ M @ N )
         => ( ( ord_less_eq @ nat @ N @ P6 )
           => ( ( times_times @ A @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ M @ N ) ) @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ N @ P6 ) ) )
              = ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ M @ P6 ) ) ) ) ) ) ).

% prod.atLeastLessThan_concat
thf(fact_4572_atLeast0__lessThan__Suc,axiom,
    ! [N: nat] :
      ( ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( suc @ N ) )
      = ( insert @ nat @ N @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N ) ) ) ).

% atLeast0_lessThan_Suc
thf(fact_4573_subset__eq__atLeast0__lessThan__finite,axiom,
    ! [N4: set @ nat,N: nat] :
      ( ( ord_less_eq @ ( set @ nat ) @ N4 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N ) )
     => ( finite_finite @ nat @ N4 ) ) ).

% subset_eq_atLeast0_lessThan_finite
thf(fact_4574_sum_Omono__neutral__left_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [S: set @ B,T6: set @ B,G: B > A] :
          ( ( ord_less_eq @ ( set @ B ) @ S @ T6 )
         => ( ! [X3: B] :
                ( ( member @ B @ X3 @ ( minus_minus @ ( set @ B ) @ T6 @ S ) )
               => ( ( G @ X3 )
                  = ( zero_zero @ A ) ) )
           => ( ( groups1027152243600224163dd_sum @ B @ A @ G @ S )
              = ( groups1027152243600224163dd_sum @ B @ A @ G @ T6 ) ) ) ) ) ).

% sum.mono_neutral_left'
thf(fact_4575_sum_Omono__neutral__right_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [S: set @ B,T6: set @ B,G: B > A] :
          ( ( ord_less_eq @ ( set @ B ) @ S @ T6 )
         => ( ! [X3: B] :
                ( ( member @ B @ X3 @ ( minus_minus @ ( set @ B ) @ T6 @ S ) )
               => ( ( G @ X3 )
                  = ( zero_zero @ A ) ) )
           => ( ( groups1027152243600224163dd_sum @ B @ A @ G @ T6 )
              = ( groups1027152243600224163dd_sum @ B @ A @ G @ S ) ) ) ) ) ).

% sum.mono_neutral_right'
thf(fact_4576_sum_Omono__neutral__cong__left_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [S: set @ B,T6: set @ B,H2: B > A,G: B > A] :
          ( ( ord_less_eq @ ( set @ B ) @ S @ T6 )
         => ( ! [I2: B] :
                ( ( member @ B @ I2 @ ( minus_minus @ ( set @ B ) @ T6 @ S ) )
               => ( ( H2 @ I2 )
                  = ( zero_zero @ A ) ) )
           => ( ! [X3: B] :
                  ( ( member @ B @ X3 @ S )
                 => ( ( G @ X3 )
                    = ( H2 @ X3 ) ) )
             => ( ( groups1027152243600224163dd_sum @ B @ A @ G @ S )
                = ( groups1027152243600224163dd_sum @ B @ A @ H2 @ T6 ) ) ) ) ) ) ).

% sum.mono_neutral_cong_left'
thf(fact_4577_sum_Omono__neutral__cong__right_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [S: set @ B,T6: set @ B,G: B > A,H2: B > A] :
          ( ( ord_less_eq @ ( set @ B ) @ S @ T6 )
         => ( ! [X3: B] :
                ( ( member @ B @ X3 @ ( minus_minus @ ( set @ B ) @ T6 @ S ) )
               => ( ( G @ X3 )
                  = ( zero_zero @ A ) ) )
           => ( ! [X3: B] :
                  ( ( member @ B @ X3 @ S )
                 => ( ( G @ X3 )
                    = ( H2 @ X3 ) ) )
             => ( ( groups1027152243600224163dd_sum @ B @ A @ G @ T6 )
                = ( groups1027152243600224163dd_sum @ B @ A @ H2 @ S ) ) ) ) ) ) ).

% sum.mono_neutral_cong_right'
thf(fact_4578_atLeastLessThan__subseteq__atLeastAtMost__iff,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ord_less_eq @ ( set @ A ) @ ( set_or7035219750837199246ssThan @ A @ A2 @ B2 ) @ ( set_or1337092689740270186AtMost @ A @ C2 @ D2 ) )
          = ( ( ord_less @ A @ A2 @ B2 )
           => ( ( ord_less_eq @ A @ C2 @ A2 )
              & ( ord_less_eq @ A @ B2 @ D2 ) ) ) ) ) ).

% atLeastLessThan_subseteq_atLeastAtMost_iff
thf(fact_4579_atLeastAtMost__subseteq__atLeastLessThan__iff,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ord_less_eq @ ( set @ A ) @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) @ ( set_or7035219750837199246ssThan @ A @ C2 @ D2 ) )
          = ( ( ord_less_eq @ A @ A2 @ B2 )
           => ( ( ord_less_eq @ A @ C2 @ A2 )
              & ( ord_less @ A @ B2 @ D2 ) ) ) ) ) ).

% atLeastAtMost_subseteq_atLeastLessThan_iff
thf(fact_4580_sum__shift__lb__Suc0__0__upt,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [F2: nat > A,K: nat] :
          ( ( ( F2 @ ( zero_zero @ nat ) )
            = ( zero_zero @ A ) )
         => ( ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_or7035219750837199246ssThan @ nat @ ( suc @ ( zero_zero @ nat ) ) @ K ) )
            = ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ K ) ) ) ) ) ).

% sum_shift_lb_Suc0_0_upt
thf(fact_4581_sum_OatLeast0__lessThan__Suc,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( suc @ N ) ) )
          = ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N ) ) @ ( G @ N ) ) ) ) ).

% sum.atLeast0_lessThan_Suc
thf(fact_4582_sum_OatLeast__Suc__lessThan,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [M: nat,N: nat,G: nat > A] :
          ( ( ord_less @ nat @ M @ N )
         => ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ M @ N ) )
            = ( plus_plus @ A @ ( G @ M ) @ ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ ( suc @ M ) @ N ) ) ) ) ) ) ).

% sum.atLeast_Suc_lessThan
thf(fact_4583_sum_OatLeastLessThan__Suc,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A2: nat,B2: nat,G: nat > A] :
          ( ( ord_less_eq @ nat @ A2 @ B2 )
         => ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ A2 @ ( suc @ B2 ) ) )
            = ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ A2 @ B2 ) ) @ ( G @ B2 ) ) ) ) ) ).

% sum.atLeastLessThan_Suc
thf(fact_4584_sum_Odistrib_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [I5: set @ B,G: B > A,H2: B > A] :
          ( ( finite_finite @ B
            @ ( collect @ B
              @ ^ [X2: B] :
                  ( ( member @ B @ X2 @ I5 )
                  & ( ( G @ X2 )
                   != ( zero_zero @ A ) ) ) ) )
         => ( ( finite_finite @ B
              @ ( collect @ B
                @ ^ [X2: B] :
                    ( ( member @ B @ X2 @ I5 )
                    & ( ( H2 @ X2 )
                     != ( zero_zero @ A ) ) ) ) )
           => ( ( groups1027152243600224163dd_sum @ B @ A
                @ ^ [I4: B] : ( plus_plus @ A @ ( G @ I4 ) @ ( H2 @ I4 ) )
                @ I5 )
              = ( plus_plus @ A @ ( groups1027152243600224163dd_sum @ B @ A @ G @ I5 ) @ ( groups1027152243600224163dd_sum @ B @ A @ H2 @ I5 ) ) ) ) ) ) ).

% sum.distrib'
thf(fact_4585_prod_OatLeast0__lessThan__Suc,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,N: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( suc @ N ) ) )
          = ( times_times @ A @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N ) ) @ ( G @ N ) ) ) ) ).

% prod.atLeast0_lessThan_Suc
thf(fact_4586_prod_OatLeast__Suc__lessThan,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [M: nat,N: nat,G: nat > A] :
          ( ( ord_less @ nat @ M @ N )
         => ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ M @ N ) )
            = ( times_times @ A @ ( G @ M ) @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ ( suc @ M ) @ N ) ) ) ) ) ) ).

% prod.atLeast_Suc_lessThan
thf(fact_4587_prod_OatLeastLessThan__Suc,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A2: nat,B2: nat,G: nat > A] :
          ( ( ord_less_eq @ nat @ A2 @ B2 )
         => ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ A2 @ ( suc @ B2 ) ) )
            = ( times_times @ A @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ A2 @ B2 ) ) @ ( G @ B2 ) ) ) ) ) ).

% prod.atLeastLessThan_Suc
thf(fact_4588_sum_OG__def,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ( ( groups1027152243600224163dd_sum @ B @ A )
        = ( ^ [P5: B > A,I7: set @ B] :
              ( if @ A
              @ ( finite_finite @ B
                @ ( collect @ B
                  @ ^ [X2: B] :
                      ( ( member @ B @ X2 @ I7 )
                      & ( ( P5 @ X2 )
                       != ( zero_zero @ A ) ) ) ) )
              @ ( groups7311177749621191930dd_sum @ B @ A @ P5
                @ ( collect @ B
                  @ ^ [X2: B] :
                      ( ( member @ B @ X2 @ I7 )
                      & ( ( P5 @ X2 )
                       != ( zero_zero @ A ) ) ) ) )
              @ ( zero_zero @ A ) ) ) ) ) ).

% sum.G_def
thf(fact_4589_sum_Olast__plus,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [M: nat,N: nat,G: nat > A] :
          ( ( ord_less_eq @ nat @ M @ N )
         => ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) )
            = ( plus_plus @ A @ ( G @ N ) @ ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ M @ N ) ) ) ) ) ) ).

% sum.last_plus
thf(fact_4590_prod_Olast__plus,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [M: nat,N: nat,G: nat > A] :
          ( ( ord_less_eq @ nat @ M @ N )
         => ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) )
            = ( times_times @ A @ ( G @ N ) @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ M @ N ) ) ) ) ) ) ).

% prod.last_plus
thf(fact_4591_sum__Suc__diff_H,axiom,
    ! [A: $tType] :
      ( ( ab_group_add @ A )
     => ! [M: nat,N: nat,F2: nat > A] :
          ( ( ord_less_eq @ nat @ M @ N )
         => ( ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [I4: nat] : ( minus_minus @ A @ ( F2 @ ( suc @ I4 ) ) @ ( F2 @ I4 ) )
              @ ( set_or7035219750837199246ssThan @ nat @ M @ N ) )
            = ( minus_minus @ A @ ( F2 @ N ) @ ( F2 @ M ) ) ) ) ) ).

% sum_Suc_diff'
thf(fact_4592_atLeastLessThanSuc,axiom,
    ! [M: nat,N: nat] :
      ( ( ( ord_less_eq @ nat @ M @ N )
       => ( ( set_or7035219750837199246ssThan @ nat @ M @ ( suc @ N ) )
          = ( insert @ nat @ N @ ( set_or7035219750837199246ssThan @ nat @ M @ N ) ) ) )
      & ( ~ ( ord_less_eq @ nat @ M @ N )
       => ( ( set_or7035219750837199246ssThan @ nat @ M @ ( suc @ N ) )
          = ( bot_bot @ ( set @ nat ) ) ) ) ) ).

% atLeastLessThanSuc
thf(fact_4593_sum_Onested__swap,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A2: nat > nat > A,N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [I4: nat] : ( groups7311177749621191930dd_sum @ nat @ A @ ( A2 @ I4 ) @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ I4 ) )
            @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N ) )
          = ( groups7311177749621191930dd_sum @ nat @ A
            @ ^ [J3: nat] :
                ( groups7311177749621191930dd_sum @ nat @ A
                @ ^ [I4: nat] : ( A2 @ I4 @ J3 )
                @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ J3 ) @ N ) )
            @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N ) ) ) ) ).

% sum.nested_swap
thf(fact_4594_prod_Onested__swap,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [A2: nat > nat > A,N: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [I4: nat] : ( groups7121269368397514597t_prod @ nat @ A @ ( A2 @ I4 ) @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ I4 ) )
            @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N ) )
          = ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [J3: nat] :
                ( groups7121269368397514597t_prod @ nat @ A
                @ ^ [I4: nat] : ( A2 @ I4 @ J3 )
                @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ J3 ) @ N ) )
            @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N ) ) ) ) ).

% prod.nested_swap
thf(fact_4595_prod__Suc__fact,axiom,
    ! [N: nat] :
      ( ( groups7121269368397514597t_prod @ nat @ nat @ suc @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N ) )
      = ( semiring_char_0_fact @ nat @ N ) ) ).

% prod_Suc_fact
thf(fact_4596_prod__Suc__Suc__fact,axiom,
    ! [N: nat] :
      ( ( groups7121269368397514597t_prod @ nat @ nat @ suc @ ( set_or7035219750837199246ssThan @ nat @ ( suc @ ( zero_zero @ nat ) ) @ N ) )
      = ( semiring_char_0_fact @ nat @ N ) ) ).

% prod_Suc_Suc_fact
thf(fact_4597_sum_Ohead__if,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [N: nat,M: nat,G: nat > A] :
          ( ( ( ord_less @ nat @ N @ M )
           => ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) )
              = ( zero_zero @ A ) ) )
          & ( ~ ( ord_less @ nat @ N @ M )
           => ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) )
              = ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ M @ N ) ) @ ( G @ N ) ) ) ) ) ) ).

% sum.head_if
thf(fact_4598_prod_Ohead__if,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [N: nat,M: nat,G: nat > A] :
          ( ( ( ord_less @ nat @ N @ M )
           => ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) )
              = ( one_one @ A ) ) )
          & ( ~ ( ord_less @ nat @ N @ M )
           => ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) )
              = ( times_times @ A @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ M @ N ) ) @ ( G @ N ) ) ) ) ) ) ).

% prod.head_if
thf(fact_4599_fact__prod__Suc,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ( ( semiring_char_0_fact @ A )
        = ( ^ [N3: nat] : ( semiring_1_of_nat @ A @ ( groups7121269368397514597t_prod @ nat @ nat @ suc @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N3 ) ) ) ) ) ) ).

% fact_prod_Suc
thf(fact_4600_pochhammer__prod,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ( ( comm_s3205402744901411588hammer @ A )
        = ( ^ [A3: A,N3: nat] :
              ( groups7121269368397514597t_prod @ nat @ A
              @ ^ [I4: nat] : ( plus_plus @ A @ A3 @ ( semiring_1_of_nat @ A @ I4 ) )
              @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N3 ) ) ) ) ) ).

% pochhammer_prod
thf(fact_4601_atLeastLessThan__nat__numeral,axiom,
    ! [M: nat,K: num] :
      ( ( ( ord_less_eq @ nat @ M @ ( pred_numeral @ K ) )
       => ( ( set_or7035219750837199246ssThan @ nat @ M @ ( numeral_numeral @ nat @ K ) )
          = ( insert @ nat @ ( pred_numeral @ K ) @ ( set_or7035219750837199246ssThan @ nat @ M @ ( pred_numeral @ K ) ) ) ) )
      & ( ~ ( ord_less_eq @ nat @ M @ ( pred_numeral @ K ) )
       => ( ( set_or7035219750837199246ssThan @ nat @ M @ ( numeral_numeral @ nat @ K ) )
          = ( bot_bot @ ( set @ nat ) ) ) ) ) ).

% atLeastLessThan_nat_numeral
thf(fact_4602_fact__prod__rev,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ( ( semiring_char_0_fact @ A )
        = ( ^ [N3: nat] : ( semiring_1_of_nat @ A @ ( groups7121269368397514597t_prod @ nat @ nat @ ( minus_minus @ nat @ N3 ) @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N3 ) ) ) ) ) ) ).

% fact_prod_rev
thf(fact_4603_summable__Cauchy,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach @ A )
     => ( ( summable @ A )
        = ( ^ [F3: nat > A] :
            ! [E3: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ E3 )
             => ? [N6: nat] :
                ! [M3: nat] :
                  ( ( ord_less_eq @ nat @ N6 @ M3 )
                 => ! [N3: nat] : ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ F3 @ ( set_or7035219750837199246ssThan @ nat @ M3 @ N3 ) ) ) @ E3 ) ) ) ) ) ) ).

% summable_Cauchy
thf(fact_4604_sums__group,axiom,
    ! [A: $tType] :
      ( ( ( comm_monoid_add @ A )
        & ( topolo4958980785337419405_space @ A ) )
     => ! [F2: nat > A,S2: A,K: nat] :
          ( ( sums @ A @ F2 @ S2 )
         => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
           => ( sums @ A
              @ ^ [N3: nat] : ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_or7035219750837199246ssThan @ nat @ ( times_times @ nat @ N3 @ K ) @ ( plus_plus @ nat @ ( times_times @ nat @ N3 @ K ) @ K ) ) )
              @ S2 ) ) ) ) ).

% sums_group
thf(fact_4605_take__bit__sum,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ( ( bit_se2584673776208193580ke_bit @ A )
        = ( ^ [N3: nat,A3: A] :
              ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [K3: nat] : ( bit_se4730199178511100633sh_bit @ A @ K3 @ ( zero_neq_one_of_bool @ A @ ( bit_se5641148757651400278ts_bit @ A @ A3 @ K3 ) ) )
              @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N3 ) ) ) ) ) ).

% take_bit_sum
thf(fact_4606_atLeast1__lessThan__eq__remove0,axiom,
    ! [N: nat] :
      ( ( set_or7035219750837199246ssThan @ nat @ ( suc @ ( zero_zero @ nat ) ) @ N )
      = ( minus_minus @ ( set @ nat ) @ ( set_ord_lessThan @ nat @ N ) @ ( insert @ nat @ ( zero_zero @ nat ) @ ( bot_bot @ ( set @ nat ) ) ) ) ) ).

% atLeast1_lessThan_eq_remove0
thf(fact_4607_fact__split,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [K: nat,N: nat] :
          ( ( ord_less_eq @ nat @ K @ N )
         => ( ( semiring_char_0_fact @ A @ N )
            = ( times_times @ A @ ( semiring_1_of_nat @ A @ ( groups7121269368397514597t_prod @ nat @ nat @ suc @ ( set_or7035219750837199246ssThan @ nat @ ( minus_minus @ nat @ N @ K ) @ N ) ) ) @ ( semiring_char_0_fact @ A @ ( minus_minus @ nat @ N @ K ) ) ) ) ) ) ).

% fact_split
thf(fact_4608_binomial__altdef__of__nat,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [K: nat,N: nat] :
          ( ( ord_less_eq @ nat @ K @ N )
         => ( ( semiring_1_of_nat @ A @ ( binomial @ N @ K ) )
            = ( groups7121269368397514597t_prod @ nat @ A
              @ ^ [I4: nat] : ( divide_divide @ A @ ( semiring_1_of_nat @ A @ ( minus_minus @ nat @ N @ I4 ) ) @ ( semiring_1_of_nat @ A @ ( minus_minus @ nat @ K @ I4 ) ) )
              @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ K ) ) ) ) ) ).

% binomial_altdef_of_nat
thf(fact_4609_gbinomial__altdef__of__nat,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ( ( gbinomial @ A )
        = ( ^ [A3: A,K3: nat] :
              ( groups7121269368397514597t_prod @ nat @ A
              @ ^ [I4: nat] : ( divide_divide @ A @ ( minus_minus @ A @ A3 @ ( semiring_1_of_nat @ A @ I4 ) ) @ ( semiring_1_of_nat @ A @ ( minus_minus @ nat @ K3 @ I4 ) ) )
              @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ K3 ) ) ) ) ) ).

% gbinomial_altdef_of_nat
thf(fact_4610_gbinomial__mult__fact,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [K: nat,A2: A] :
          ( ( times_times @ A @ ( semiring_char_0_fact @ A @ K ) @ ( gbinomial @ A @ A2 @ K ) )
          = ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [I4: nat] : ( minus_minus @ A @ A2 @ ( semiring_1_of_nat @ A @ I4 ) )
            @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ K ) ) ) ) ).

% gbinomial_mult_fact
thf(fact_4611_gbinomial__mult__fact_H,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: A,K: nat] :
          ( ( times_times @ A @ ( gbinomial @ A @ A2 @ K ) @ ( semiring_char_0_fact @ A @ K ) )
          = ( groups7121269368397514597t_prod @ nat @ A
            @ ^ [I4: nat] : ( minus_minus @ A @ A2 @ ( semiring_1_of_nat @ A @ I4 ) )
            @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ K ) ) ) ) ).

% gbinomial_mult_fact'
thf(fact_4612_gbinomial__prod__rev,axiom,
    ! [A: $tType] :
      ( ( ( semiring_char_0 @ A )
        & ( semidom_divide @ A ) )
     => ( ( gbinomial @ A )
        = ( ^ [A3: A,K3: nat] :
              ( divide_divide @ A
              @ ( groups7121269368397514597t_prod @ nat @ A
                @ ^ [I4: nat] : ( minus_minus @ A @ A3 @ ( semiring_1_of_nat @ A @ I4 ) )
                @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ K3 ) )
              @ ( semiring_char_0_fact @ A @ K3 ) ) ) ) ) ).

% gbinomial_prod_rev
thf(fact_4613_sum__diff1_H,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ab_group_add @ B )
     => ! [I5: set @ A,F2: A > B,I: A] :
          ( ( finite_finite @ A
            @ ( collect @ A
              @ ^ [I4: A] :
                  ( ( member @ A @ I4 @ I5 )
                  & ( ( F2 @ I4 )
                   != ( zero_zero @ B ) ) ) ) )
         => ( ( ( member @ A @ I @ I5 )
             => ( ( groups1027152243600224163dd_sum @ A @ B @ F2 @ ( minus_minus @ ( set @ A ) @ I5 @ ( insert @ A @ I @ ( bot_bot @ ( set @ A ) ) ) ) )
                = ( minus_minus @ B @ ( groups1027152243600224163dd_sum @ A @ B @ F2 @ I5 ) @ ( F2 @ I ) ) ) )
            & ( ~ ( member @ A @ I @ I5 )
             => ( ( groups1027152243600224163dd_sum @ A @ B @ F2 @ ( minus_minus @ ( set @ A ) @ I5 @ ( insert @ A @ I @ ( bot_bot @ ( set @ A ) ) ) ) )
                = ( groups1027152243600224163dd_sum @ A @ B @ F2 @ I5 ) ) ) ) ) ) ).

% sum_diff1'
thf(fact_4614_horner__sum__eq__sum,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_semiring_1 @ A )
     => ( ( groups4207007520872428315er_sum @ B @ A )
        = ( ^ [F3: B > A,A3: A,Xs3: list @ B] :
              ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [N3: nat] : ( times_times @ A @ ( F3 @ ( nth @ B @ Xs3 @ N3 ) ) @ ( power_power @ A @ A3 @ N3 ) )
              @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( size_size @ ( list @ B ) @ Xs3 ) ) ) ) ) ) ).

% horner_sum_eq_sum
thf(fact_4615_Chebyshev__sum__upper,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [N: nat,A2: nat > A,B2: nat > A] :
          ( ! [I2: nat,J2: nat] :
              ( ( ord_less_eq @ nat @ I2 @ J2 )
             => ( ( ord_less @ nat @ J2 @ N )
               => ( ord_less_eq @ A @ ( A2 @ I2 ) @ ( A2 @ J2 ) ) ) )
         => ( ! [I2: nat,J2: nat] :
                ( ( ord_less_eq @ nat @ I2 @ J2 )
               => ( ( ord_less @ nat @ J2 @ N )
                 => ( ord_less_eq @ A @ ( B2 @ J2 ) @ ( B2 @ I2 ) ) ) )
           => ( ord_less_eq @ A
              @ ( times_times @ A @ ( semiring_1_of_nat @ A @ N )
                @ ( groups7311177749621191930dd_sum @ nat @ A
                  @ ^ [K3: nat] : ( times_times @ A @ ( A2 @ K3 ) @ ( B2 @ K3 ) )
                  @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N ) ) )
              @ ( times_times @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ A2 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N ) ) @ ( groups7311177749621191930dd_sum @ nat @ A @ B2 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N ) ) ) ) ) ) ) ).

% Chebyshev_sum_upper
thf(fact_4616_Chebyshev__sum__upper__nat,axiom,
    ! [N: nat,A2: nat > nat,B2: nat > nat] :
      ( ! [I2: nat,J2: nat] :
          ( ( ord_less_eq @ nat @ I2 @ J2 )
         => ( ( ord_less @ nat @ J2 @ N )
           => ( ord_less_eq @ nat @ ( A2 @ I2 ) @ ( A2 @ J2 ) ) ) )
     => ( ! [I2: nat,J2: nat] :
            ( ( ord_less_eq @ nat @ I2 @ J2 )
           => ( ( ord_less @ nat @ J2 @ N )
             => ( ord_less_eq @ nat @ ( B2 @ J2 ) @ ( B2 @ I2 ) ) ) )
       => ( ord_less_eq @ nat
          @ ( times_times @ nat @ N
            @ ( groups7311177749621191930dd_sum @ nat @ nat
              @ ^ [I4: nat] : ( times_times @ nat @ ( A2 @ I4 ) @ ( B2 @ I4 ) )
              @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N ) ) )
          @ ( times_times @ nat @ ( groups7311177749621191930dd_sum @ nat @ nat @ A2 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N ) ) @ ( groups7311177749621191930dd_sum @ nat @ nat @ B2 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N ) ) ) ) ) ) ).

% Chebyshev_sum_upper_nat
thf(fact_4617_VEBT_Osize__gen_I1_J,axiom,
    ! [X11: option @ ( product_prod @ nat @ nat ),X12: nat,X13: list @ vEBT_VEBT,X14: vEBT_VEBT] :
      ( ( vEBT_size_VEBT @ ( vEBT_Node @ X11 @ X12 @ X13 @ X14 ) )
      = ( plus_plus @ nat @ ( plus_plus @ nat @ ( size_list @ vEBT_VEBT @ vEBT_size_VEBT @ X13 ) @ ( vEBT_size_VEBT @ X14 ) ) @ ( suc @ ( zero_zero @ nat ) ) ) ) ).

% VEBT.size_gen(1)
thf(fact_4618_finite__atLeastZeroLessThan__int,axiom,
    ! [U: int] : ( finite_finite @ int @ ( set_or7035219750837199246ssThan @ int @ ( zero_zero @ int ) @ U ) ) ).

% finite_atLeastZeroLessThan_int
thf(fact_4619_VEBT_Osize__gen_I2_J,axiom,
    ! [X21: $o,X222: $o] :
      ( ( vEBT_size_VEBT @ ( vEBT_Leaf @ X21 @ X222 ) )
      = ( zero_zero @ nat ) ) ).

% VEBT.size_gen(2)
thf(fact_4620_infinite__int__iff__unbounded,axiom,
    ! [S: set @ int] :
      ( ( ~ ( finite_finite @ int @ S ) )
      = ( ! [M3: int] :
          ? [N3: int] :
            ( ( ord_less @ int @ M3 @ ( abs_abs @ int @ N3 ) )
            & ( member @ int @ N3 @ S ) ) ) ) ).

% infinite_int_iff_unbounded
thf(fact_4621_infinite__int__iff__unbounded__le,axiom,
    ! [S: set @ int] :
      ( ( ~ ( finite_finite @ int @ S ) )
      = ( ! [M3: int] :
          ? [N3: int] :
            ( ( ord_less_eq @ int @ M3 @ ( abs_abs @ int @ N3 ) )
            & ( member @ int @ N3 @ S ) ) ) ) ).

% infinite_int_iff_unbounded_le
thf(fact_4622_int__of__nat__def,axiom,
    ( code_T6385005292777649522of_nat
    = ( semiring_1_of_nat @ int ) ) ).

% int_of_nat_def
thf(fact_4623_infinite__nat__iff__unbounded,axiom,
    ! [S: set @ nat] :
      ( ( ~ ( finite_finite @ nat @ S ) )
      = ( ! [M3: nat] :
          ? [N3: nat] :
            ( ( ord_less @ nat @ M3 @ N3 )
            & ( member @ nat @ N3 @ S ) ) ) ) ).

% infinite_nat_iff_unbounded
thf(fact_4624_unbounded__k__infinite,axiom,
    ! [K: nat,S: set @ nat] :
      ( ! [M4: nat] :
          ( ( ord_less @ nat @ K @ M4 )
         => ? [N7: nat] :
              ( ( ord_less @ nat @ M4 @ N7 )
              & ( member @ nat @ N7 @ S ) ) )
     => ~ ( finite_finite @ nat @ S ) ) ).

% unbounded_k_infinite
thf(fact_4625_infinite__nat__iff__unbounded__le,axiom,
    ! [S: set @ nat] :
      ( ( ~ ( finite_finite @ nat @ S ) )
      = ( ! [M3: nat] :
          ? [N3: nat] :
            ( ( ord_less_eq @ nat @ M3 @ N3 )
            & ( member @ nat @ N3 @ S ) ) ) ) ).

% infinite_nat_iff_unbounded_le
thf(fact_4626_length__subseqs,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( size_size @ ( list @ ( list @ A ) ) @ ( subseqs @ A @ Xs ) )
      = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( size_size @ ( list @ A ) @ Xs ) ) ) ).

% length_subseqs
thf(fact_4627_Code__Target__Int_Opositive__def,axiom,
    ( code_Target_positive
    = ( numeral_numeral @ int ) ) ).

% Code_Target_Int.positive_def
thf(fact_4628_divmod__step__integer__def,axiom,
    ( ( unique1321980374590559556d_step @ code_integer )
    = ( ^ [L2: num] :
          ( product_case_prod @ code_integer @ code_integer @ ( product_prod @ code_integer @ code_integer )
          @ ^ [Q6: code_integer,R5: code_integer] : ( if @ ( product_prod @ code_integer @ code_integer ) @ ( ord_less_eq @ code_integer @ ( numeral_numeral @ code_integer @ L2 ) @ R5 ) @ ( product_Pair @ code_integer @ code_integer @ ( plus_plus @ code_integer @ ( times_times @ code_integer @ ( numeral_numeral @ code_integer @ ( bit0 @ one2 ) ) @ Q6 ) @ ( one_one @ code_integer ) ) @ ( minus_minus @ code_integer @ R5 @ ( numeral_numeral @ code_integer @ L2 ) ) ) @ ( product_Pair @ code_integer @ code_integer @ ( times_times @ code_integer @ ( numeral_numeral @ code_integer @ ( bit0 @ one2 ) ) @ Q6 ) @ R5 ) ) ) ) ) ).

% divmod_step_integer_def
thf(fact_4629_less__eq__integer__code_I1_J,axiom,
    ord_less_eq @ code_integer @ ( zero_zero @ code_integer ) @ ( zero_zero @ code_integer ) ).

% less_eq_integer_code(1)
thf(fact_4630_times__integer__code_I2_J,axiom,
    ! [L: code_integer] :
      ( ( times_times @ code_integer @ ( zero_zero @ code_integer ) @ L )
      = ( zero_zero @ code_integer ) ) ).

% times_integer_code(2)
thf(fact_4631_times__integer__code_I1_J,axiom,
    ! [K: code_integer] :
      ( ( times_times @ code_integer @ K @ ( zero_zero @ code_integer ) )
      = ( zero_zero @ code_integer ) ) ).

% times_integer_code(1)
thf(fact_4632_plus__integer__code_I2_J,axiom,
    ! [L: code_integer] :
      ( ( plus_plus @ code_integer @ ( zero_zero @ code_integer ) @ L )
      = L ) ).

% plus_integer_code(2)
thf(fact_4633_plus__integer__code_I1_J,axiom,
    ! [K: code_integer] :
      ( ( plus_plus @ code_integer @ K @ ( zero_zero @ code_integer ) )
      = K ) ).

% plus_integer_code(1)
thf(fact_4634_sgn__integer__code,axiom,
    ( ( sgn_sgn @ code_integer )
    = ( ^ [K3: code_integer] :
          ( if @ code_integer
          @ ( K3
            = ( zero_zero @ code_integer ) )
          @ ( zero_zero @ code_integer )
          @ ( if @ code_integer @ ( ord_less @ code_integer @ K3 @ ( zero_zero @ code_integer ) ) @ ( uminus_uminus @ code_integer @ ( one_one @ code_integer ) ) @ ( one_one @ code_integer ) ) ) ) ) ).

% sgn_integer_code
thf(fact_4635_minus__integer__code_I2_J,axiom,
    ! [L: code_integer] :
      ( ( minus_minus @ code_integer @ ( zero_zero @ code_integer ) @ L )
      = ( uminus_uminus @ code_integer @ L ) ) ).

% minus_integer_code(2)
thf(fact_4636_minus__integer__code_I1_J,axiom,
    ! [K: code_integer] :
      ( ( minus_minus @ code_integer @ K @ ( zero_zero @ code_integer ) )
      = K ) ).

% minus_integer_code(1)
thf(fact_4637_zero__natural_Orsp,axiom,
    ( ( zero_zero @ nat )
    = ( zero_zero @ nat ) ) ).

% zero_natural.rsp
thf(fact_4638_zero__integer_Orsp,axiom,
    ( ( zero_zero @ int )
    = ( zero_zero @ int ) ) ).

% zero_integer.rsp
thf(fact_4639_integer__of__int__code,axiom,
    ( code_integer_of_int
    = ( ^ [K3: int] :
          ( if @ code_integer @ ( ord_less @ int @ K3 @ ( zero_zero @ int ) ) @ ( uminus_uminus @ code_integer @ ( code_integer_of_int @ ( uminus_uminus @ int @ K3 ) ) )
          @ ( if @ code_integer
            @ ( K3
              = ( zero_zero @ int ) )
            @ ( zero_zero @ code_integer )
            @ ( if @ code_integer
              @ ( ( modulo_modulo @ int @ K3 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) )
                = ( zero_zero @ int ) )
              @ ( times_times @ code_integer @ ( numeral_numeral @ code_integer @ ( bit0 @ one2 ) ) @ ( code_integer_of_int @ ( divide_divide @ int @ K3 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) )
              @ ( plus_plus @ code_integer @ ( times_times @ code_integer @ ( numeral_numeral @ code_integer @ ( bit0 @ one2 ) ) @ ( code_integer_of_int @ ( divide_divide @ int @ K3 @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) ) ) ) @ ( one_one @ code_integer ) ) ) ) ) ) ) ).

% integer_of_int_code
thf(fact_4640_length__mul__elem,axiom,
    ! [A: $tType,Xs: list @ ( list @ A ),N: nat] :
      ( ! [X3: list @ A] :
          ( ( member @ ( list @ A ) @ X3 @ ( set2 @ ( list @ A ) @ Xs ) )
         => ( ( size_size @ ( list @ A ) @ X3 )
            = N ) )
     => ( ( size_size @ ( list @ A ) @ ( concat @ A @ Xs ) )
        = ( times_times @ nat @ ( size_size @ ( list @ ( list @ A ) ) @ Xs ) @ N ) ) ) ).

% length_mul_elem
thf(fact_4641_even__sum__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( semiring_parity @ A )
     => ! [A4: set @ B,F2: B > A] :
          ( ( finite_finite @ B @ A4 )
         => ( ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ A4 ) )
            = ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) )
              @ ( finite_card @ B
                @ ( collect @ B
                  @ ^ [A3: B] :
                      ( ( member @ B @ A3 @ A4 )
                      & ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( F2 @ A3 ) ) ) ) ) ) ) ) ) ).

% even_sum_iff
thf(fact_4642_card__Collect__less__nat,axiom,
    ! [N: nat] :
      ( ( finite_card @ nat
        @ ( collect @ nat
          @ ^ [I4: nat] : ( ord_less @ nat @ I4 @ N ) ) )
      = N ) ).

% card_Collect_less_nat
thf(fact_4643_card__Collect__le__nat,axiom,
    ! [N: nat] :
      ( ( finite_card @ nat
        @ ( collect @ nat
          @ ^ [I4: nat] : ( ord_less_eq @ nat @ I4 @ N ) ) )
      = ( suc @ N ) ) ).

% card_Collect_le_nat
thf(fact_4644_card_Oempty,axiom,
    ! [A: $tType] :
      ( ( finite_card @ A @ ( bot_bot @ ( set @ A ) ) )
      = ( zero_zero @ nat ) ) ).

% card.empty
thf(fact_4645_card_Oinfinite,axiom,
    ! [A: $tType,A4: set @ A] :
      ( ~ ( finite_finite @ A @ A4 )
     => ( ( finite_card @ A @ A4 )
        = ( zero_zero @ nat ) ) ) ).

% card.infinite
thf(fact_4646_prod__constant,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [Y: A,A4: set @ B] :
          ( ( groups7121269368397514597t_prod @ B @ A
            @ ^ [X2: B] : Y
            @ A4 )
          = ( power_power @ A @ Y @ ( finite_card @ B @ A4 ) ) ) ) ).

% prod_constant
thf(fact_4647_card__0__eq,axiom,
    ! [A: $tType,A4: set @ A] :
      ( ( finite_finite @ A @ A4 )
     => ( ( ( finite_card @ A @ A4 )
          = ( zero_zero @ nat ) )
        = ( A4
          = ( bot_bot @ ( set @ A ) ) ) ) ) ).

% card_0_eq
thf(fact_4648_sum__constant,axiom,
    ! [B: $tType,A: $tType] :
      ( ( semiring_1 @ A )
     => ! [Y: A,A4: set @ B] :
          ( ( groups7311177749621191930dd_sum @ B @ A
            @ ^ [X2: B] : Y
            @ A4 )
          = ( times_times @ A @ ( semiring_1_of_nat @ A @ ( finite_card @ B @ A4 ) ) @ Y ) ) ) ).

% sum_constant
thf(fact_4649_less__integer__code_I1_J,axiom,
    ~ ( ord_less @ code_integer @ ( zero_zero @ code_integer ) @ ( zero_zero @ code_integer ) ) ).

% less_integer_code(1)
thf(fact_4650_less__integer_Oabs__eq,axiom,
    ! [Xa: int,X: int] :
      ( ( ord_less @ code_integer @ ( code_integer_of_int @ Xa ) @ ( code_integer_of_int @ X ) )
      = ( ord_less @ int @ Xa @ X ) ) ).

% less_integer.abs_eq
thf(fact_4651_zero__integer__def,axiom,
    ( ( zero_zero @ code_integer )
    = ( code_integer_of_int @ ( zero_zero @ int ) ) ) ).

% zero_integer_def
thf(fact_4652_uminus__integer__code_I1_J,axiom,
    ( ( uminus_uminus @ code_integer @ ( zero_zero @ code_integer ) )
    = ( zero_zero @ code_integer ) ) ).

% uminus_integer_code(1)
thf(fact_4653_abs__integer__code,axiom,
    ( ( abs_abs @ code_integer )
    = ( ^ [K3: code_integer] : ( if @ code_integer @ ( ord_less @ code_integer @ K3 @ ( zero_zero @ code_integer ) ) @ ( uminus_uminus @ code_integer @ K3 ) @ K3 ) ) ) ).

% abs_integer_code
thf(fact_4654_card__le__if__inj__on__rel,axiom,
    ! [B: $tType,A: $tType,B7: set @ A,A4: set @ B,R2: B > A > $o] :
      ( ( finite_finite @ A @ B7 )
     => ( ! [A5: B] :
            ( ( member @ B @ A5 @ A4 )
           => ? [B9: A] :
                ( ( member @ A @ B9 @ B7 )
                & ( R2 @ A5 @ B9 ) ) )
       => ( ! [A13: B,A24: B,B4: A] :
              ( ( member @ B @ A13 @ A4 )
             => ( ( member @ B @ A24 @ A4 )
               => ( ( member @ A @ B4 @ B7 )
                 => ( ( R2 @ A13 @ B4 )
                   => ( ( R2 @ A24 @ B4 )
                     => ( A13 = A24 ) ) ) ) ) )
         => ( ord_less_eq @ nat @ ( finite_card @ B @ A4 ) @ ( finite_card @ A @ B7 ) ) ) ) ) ).

% card_le_if_inj_on_rel
thf(fact_4655_card__insert__le,axiom,
    ! [A: $tType,A4: set @ A,X: A] : ( ord_less_eq @ nat @ ( finite_card @ A @ A4 ) @ ( finite_card @ A @ ( insert @ A @ X @ A4 ) ) ) ).

% card_insert_le
thf(fact_4656_less__eq__integer_Oabs__eq,axiom,
    ! [Xa: int,X: int] :
      ( ( ord_less_eq @ code_integer @ ( code_integer_of_int @ Xa ) @ ( code_integer_of_int @ X ) )
      = ( ord_less_eq @ int @ Xa @ X ) ) ).

% less_eq_integer.abs_eq
thf(fact_4657_card__lists__length__eq,axiom,
    ! [A: $tType,A4: set @ A,N: nat] :
      ( ( finite_finite @ A @ A4 )
     => ( ( finite_card @ ( list @ A )
          @ ( collect @ ( list @ A )
            @ ^ [Xs3: list @ A] :
                ( ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ Xs3 ) @ A4 )
                & ( ( size_size @ ( list @ A ) @ Xs3 )
                  = N ) ) ) )
        = ( power_power @ nat @ ( finite_card @ A @ A4 ) @ N ) ) ) ).

% card_lists_length_eq
thf(fact_4658_card__2__iff_H,axiom,
    ! [A: $tType,S: set @ A] :
      ( ( ( finite_card @ A @ S )
        = ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
      = ( ? [X2: A] :
            ( ( member @ A @ X2 @ S )
            & ? [Y4: A] :
                ( ( member @ A @ Y4 @ S )
                & ( X2 != Y4 )
                & ! [Z6: A] :
                    ( ( member @ A @ Z6 @ S )
                   => ( ( Z6 = X2 )
                      | ( Z6 = Y4 ) ) ) ) ) ) ) ).

% card_2_iff'
thf(fact_4659_card__eq__0__iff,axiom,
    ! [A: $tType,A4: set @ A] :
      ( ( ( finite_card @ A @ A4 )
        = ( zero_zero @ nat ) )
      = ( ( A4
          = ( bot_bot @ ( set @ A ) ) )
        | ~ ( finite_finite @ A @ A4 ) ) ) ).

% card_eq_0_iff
thf(fact_4660_card__ge__0__finite,axiom,
    ! [A: $tType,A4: set @ A] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( finite_card @ A @ A4 ) )
     => ( finite_finite @ A @ A4 ) ) ).

% card_ge_0_finite
thf(fact_4661_obtain__subset__with__card__n,axiom,
    ! [A: $tType,N: nat,S: set @ A] :
      ( ( ord_less_eq @ nat @ N @ ( finite_card @ A @ S ) )
     => ~ ! [T7: set @ A] :
            ( ( ord_less_eq @ ( set @ A ) @ T7 @ S )
           => ( ( ( finite_card @ A @ T7 )
                = N )
             => ~ ( finite_finite @ A @ T7 ) ) ) ) ).

% obtain_subset_with_card_n
thf(fact_4662_finite__if__finite__subsets__card__bdd,axiom,
    ! [A: $tType,F4: set @ A,C5: nat] :
      ( ! [G3: set @ A] :
          ( ( ord_less_eq @ ( set @ A ) @ G3 @ F4 )
         => ( ( finite_finite @ A @ G3 )
           => ( ord_less_eq @ nat @ ( finite_card @ A @ G3 ) @ C5 ) ) )
     => ( ( finite_finite @ A @ F4 )
        & ( ord_less_eq @ nat @ ( finite_card @ A @ F4 ) @ C5 ) ) ) ).

% finite_if_finite_subsets_card_bdd
thf(fact_4663_card__seteq,axiom,
    ! [A: $tType,B7: set @ A,A4: set @ A] :
      ( ( finite_finite @ A @ B7 )
     => ( ( ord_less_eq @ ( set @ A ) @ A4 @ B7 )
       => ( ( ord_less_eq @ nat @ ( finite_card @ A @ B7 ) @ ( finite_card @ A @ A4 ) )
         => ( A4 = B7 ) ) ) ) ).

% card_seteq
thf(fact_4664_card__mono,axiom,
    ! [A: $tType,B7: set @ A,A4: set @ A] :
      ( ( finite_finite @ A @ B7 )
     => ( ( ord_less_eq @ ( set @ A ) @ A4 @ B7 )
       => ( ord_less_eq @ nat @ ( finite_card @ A @ A4 ) @ ( finite_card @ A @ B7 ) ) ) ) ).

% card_mono
thf(fact_4665_card__less__sym__Diff,axiom,
    ! [A: $tType,A4: set @ A,B7: set @ A] :
      ( ( finite_finite @ A @ A4 )
     => ( ( finite_finite @ A @ B7 )
       => ( ( ord_less @ nat @ ( finite_card @ A @ A4 ) @ ( finite_card @ A @ B7 ) )
         => ( ord_less @ nat @ ( finite_card @ A @ ( minus_minus @ ( set @ A ) @ A4 @ B7 ) ) @ ( finite_card @ A @ ( minus_minus @ ( set @ A ) @ B7 @ A4 ) ) ) ) ) ) ).

% card_less_sym_Diff
thf(fact_4666_card__le__sym__Diff,axiom,
    ! [A: $tType,A4: set @ A,B7: set @ A] :
      ( ( finite_finite @ A @ A4 )
     => ( ( finite_finite @ A @ B7 )
       => ( ( ord_less_eq @ nat @ ( finite_card @ A @ A4 ) @ ( finite_card @ A @ B7 ) )
         => ( ord_less_eq @ nat @ ( finite_card @ A @ ( minus_minus @ ( set @ A ) @ A4 @ B7 ) ) @ ( finite_card @ A @ ( minus_minus @ ( set @ A ) @ B7 @ A4 ) ) ) ) ) ) ).

% card_le_sym_Diff
thf(fact_4667_card__length,axiom,
    ! [A: $tType,Xs: list @ A] : ( ord_less_eq @ nat @ ( finite_card @ A @ ( set2 @ A @ Xs ) ) @ ( size_size @ ( list @ A ) @ Xs ) ) ).

% card_length
thf(fact_4668_ex__bij__betw__finite__nat,axiom,
    ! [A: $tType,M5: set @ A] :
      ( ( finite_finite @ A @ M5 )
     => ? [H4: A > nat] : ( bij_betw @ A @ nat @ H4 @ M5 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( finite_card @ A @ M5 ) ) ) ) ).

% ex_bij_betw_finite_nat
thf(fact_4669_psubset__card__mono,axiom,
    ! [A: $tType,B7: set @ A,A4: set @ A] :
      ( ( finite_finite @ A @ B7 )
     => ( ( ord_less @ ( set @ A ) @ A4 @ B7 )
       => ( ord_less @ nat @ ( finite_card @ A @ A4 ) @ ( finite_card @ A @ B7 ) ) ) ) ).

% psubset_card_mono
thf(fact_4670_card__less__Suc2,axiom,
    ! [M5: set @ nat,I: nat] :
      ( ~ ( member @ nat @ ( zero_zero @ nat ) @ M5 )
     => ( ( finite_card @ nat
          @ ( collect @ nat
            @ ^ [K3: nat] :
                ( ( member @ nat @ ( suc @ K3 ) @ M5 )
                & ( ord_less @ nat @ K3 @ I ) ) ) )
        = ( finite_card @ nat
          @ ( collect @ nat
            @ ^ [K3: nat] :
                ( ( member @ nat @ K3 @ M5 )
                & ( ord_less @ nat @ K3 @ ( suc @ I ) ) ) ) ) ) ) ).

% card_less_Suc2
thf(fact_4671_card__less__Suc,axiom,
    ! [M5: set @ nat,I: nat] :
      ( ( member @ nat @ ( zero_zero @ nat ) @ M5 )
     => ( ( suc
          @ ( finite_card @ nat
            @ ( collect @ nat
              @ ^ [K3: nat] :
                  ( ( member @ nat @ ( suc @ K3 ) @ M5 )
                  & ( ord_less @ nat @ K3 @ I ) ) ) ) )
        = ( finite_card @ nat
          @ ( collect @ nat
            @ ^ [K3: nat] :
                ( ( member @ nat @ K3 @ M5 )
                & ( ord_less @ nat @ K3 @ ( suc @ I ) ) ) ) ) ) ) ).

% card_less_Suc
thf(fact_4672_card__less,axiom,
    ! [M5: set @ nat,I: nat] :
      ( ( member @ nat @ ( zero_zero @ nat ) @ M5 )
     => ( ( finite_card @ nat
          @ ( collect @ nat
            @ ^ [K3: nat] :
                ( ( member @ nat @ K3 @ M5 )
                & ( ord_less @ nat @ K3 @ ( suc @ I ) ) ) ) )
       != ( zero_zero @ nat ) ) ) ).

% card_less
thf(fact_4673_card__atLeastZeroLessThan__int,axiom,
    ! [U: int] :
      ( ( finite_card @ int @ ( set_or7035219750837199246ssThan @ int @ ( zero_zero @ int ) @ U ) )
      = ( nat2 @ U ) ) ).

% card_atLeastZeroLessThan_int
thf(fact_4674_sum__constant__scaleR,axiom,
    ! [C: $tType,A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [Y: A,A4: set @ C] :
          ( ( groups7311177749621191930dd_sum @ C @ A
            @ ^ [X2: C] : Y
            @ A4 )
          = ( real_V8093663219630862766scaleR @ A @ ( semiring_1_of_nat @ real @ ( finite_card @ C @ A4 ) ) @ Y ) ) ) ).

% sum_constant_scaleR
thf(fact_4675_real__of__card,axiom,
    ! [A: $tType,A4: set @ A] :
      ( ( semiring_1_of_nat @ real @ ( finite_card @ A @ A4 ) )
      = ( groups7311177749621191930dd_sum @ A @ real
        @ ^ [X2: A] : ( one_one @ real )
        @ A4 ) ) ).

% real_of_card
thf(fact_4676_sum__bounded__above,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( ordere6911136660526730532id_add @ A )
        & ( semiring_1 @ A ) )
     => ! [A4: set @ B,F2: B > A,K6: A] :
          ( ! [I2: B] :
              ( ( member @ B @ I2 @ A4 )
             => ( ord_less_eq @ A @ ( F2 @ I2 ) @ K6 ) )
         => ( ord_less_eq @ A @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ A4 ) @ ( times_times @ A @ ( semiring_1_of_nat @ A @ ( finite_card @ B @ A4 ) ) @ K6 ) ) ) ) ).

% sum_bounded_above
thf(fact_4677_sum__bounded__below,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( ordere6911136660526730532id_add @ A )
        & ( semiring_1 @ A ) )
     => ! [A4: set @ B,K6: A,F2: B > A] :
          ( ! [I2: B] :
              ( ( member @ B @ I2 @ A4 )
             => ( ord_less_eq @ A @ K6 @ ( F2 @ I2 ) ) )
         => ( ord_less_eq @ A @ ( times_times @ A @ ( semiring_1_of_nat @ A @ ( finite_card @ B @ A4 ) ) @ K6 ) @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ A4 ) ) ) ) ).

% sum_bounded_below
thf(fact_4678_card__gt__0__iff,axiom,
    ! [A: $tType,A4: set @ A] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( finite_card @ A @ A4 ) )
      = ( ( A4
         != ( bot_bot @ ( set @ A ) ) )
        & ( finite_finite @ A @ A4 ) ) ) ).

% card_gt_0_iff
thf(fact_4679_card__1__singleton__iff,axiom,
    ! [A: $tType,A4: set @ A] :
      ( ( ( finite_card @ A @ A4 )
        = ( suc @ ( zero_zero @ nat ) ) )
      = ( ? [X2: A] :
            ( A4
            = ( insert @ A @ X2 @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% card_1_singleton_iff
thf(fact_4680_card__eq__SucD,axiom,
    ! [A: $tType,A4: set @ A,K: nat] :
      ( ( ( finite_card @ A @ A4 )
        = ( suc @ K ) )
     => ? [B4: A,B8: set @ A] :
          ( ( A4
            = ( insert @ A @ B4 @ B8 ) )
          & ~ ( member @ A @ B4 @ B8 )
          & ( ( finite_card @ A @ B8 )
            = K )
          & ( ( K
              = ( zero_zero @ nat ) )
           => ( B8
              = ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% card_eq_SucD
thf(fact_4681_card__Suc__eq,axiom,
    ! [A: $tType,A4: set @ A,K: nat] :
      ( ( ( finite_card @ A @ A4 )
        = ( suc @ K ) )
      = ( ? [B3: A,B6: set @ A] :
            ( ( A4
              = ( insert @ A @ B3 @ B6 ) )
            & ~ ( member @ A @ B3 @ B6 )
            & ( ( finite_card @ A @ B6 )
              = K )
            & ( ( K
                = ( zero_zero @ nat ) )
             => ( B6
                = ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ).

% card_Suc_eq
thf(fact_4682_card__le__Suc0__iff__eq,axiom,
    ! [A: $tType,A4: set @ A] :
      ( ( finite_finite @ A @ A4 )
     => ( ( ord_less_eq @ nat @ ( finite_card @ A @ A4 ) @ ( suc @ ( zero_zero @ nat ) ) )
        = ( ! [X2: A] :
              ( ( member @ A @ X2 @ A4 )
             => ! [Y4: A] :
                  ( ( member @ A @ Y4 @ A4 )
                 => ( X2 = Y4 ) ) ) ) ) ) ).

% card_le_Suc0_iff_eq
thf(fact_4683_card__le__Suc__iff,axiom,
    ! [A: $tType,N: nat,A4: set @ A] :
      ( ( ord_less_eq @ nat @ ( suc @ N ) @ ( finite_card @ A @ A4 ) )
      = ( ? [A3: A,B6: set @ A] :
            ( ( A4
              = ( insert @ A @ A3 @ B6 ) )
            & ~ ( member @ A @ A3 @ B6 )
            & ( ord_less_eq @ nat @ N @ ( finite_card @ A @ B6 ) )
            & ( finite_finite @ A @ B6 ) ) ) ) ).

% card_le_Suc_iff
thf(fact_4684_card__Diff1__le,axiom,
    ! [A: $tType,A4: set @ A,X: A] : ( ord_less_eq @ nat @ ( finite_card @ A @ ( minus_minus @ ( set @ A ) @ A4 @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) @ ( finite_card @ A @ A4 ) ) ).

% card_Diff1_le
thf(fact_4685_card__psubset,axiom,
    ! [A: $tType,B7: set @ A,A4: set @ A] :
      ( ( finite_finite @ A @ B7 )
     => ( ( ord_less_eq @ ( set @ A ) @ A4 @ B7 )
       => ( ( ord_less @ nat @ ( finite_card @ A @ A4 ) @ ( finite_card @ A @ B7 ) )
         => ( ord_less @ ( set @ A ) @ A4 @ B7 ) ) ) ) ).

% card_psubset
thf(fact_4686_diff__card__le__card__Diff,axiom,
    ! [A: $tType,B7: set @ A,A4: set @ A] :
      ( ( finite_finite @ A @ B7 )
     => ( ord_less_eq @ nat @ ( minus_minus @ nat @ ( finite_card @ A @ A4 ) @ ( finite_card @ A @ B7 ) ) @ ( finite_card @ A @ ( minus_minus @ ( set @ A ) @ A4 @ B7 ) ) ) ) ).

% diff_card_le_card_Diff
thf(fact_4687_card__lists__length__le,axiom,
    ! [A: $tType,A4: set @ A,N: nat] :
      ( ( finite_finite @ A @ A4 )
     => ( ( finite_card @ ( list @ A )
          @ ( collect @ ( list @ A )
            @ ^ [Xs3: list @ A] :
                ( ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ Xs3 ) @ A4 )
                & ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ Xs3 ) @ N ) ) ) )
        = ( groups7311177749621191930dd_sum @ nat @ nat @ ( power_power @ nat @ ( finite_card @ A @ A4 ) ) @ ( set_ord_atMost @ nat @ N ) ) ) ) ).

% card_lists_length_le
thf(fact_4688_ex__bij__betw__nat__finite,axiom,
    ! [A: $tType,M5: set @ A] :
      ( ( finite_finite @ A @ M5 )
     => ? [H4: nat > A] : ( bij_betw @ nat @ A @ H4 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( finite_card @ A @ M5 ) ) @ M5 ) ) ).

% ex_bij_betw_nat_finite
thf(fact_4689_card__roots__unity,axiom,
    ! [A: $tType] :
      ( ( ( real_V8999393235501362500lgebra @ A )
        & ( idom @ A ) )
     => ! [N: nat] :
          ( ( ord_less_eq @ nat @ ( one_one @ nat ) @ N )
         => ( ord_less_eq @ nat
            @ ( finite_card @ A
              @ ( collect @ A
                @ ^ [Z6: A] :
                    ( ( power_power @ A @ Z6 @ N )
                    = ( one_one @ A ) ) ) )
            @ N ) ) ) ).

% card_roots_unity
thf(fact_4690_subset__eq__atLeast0__lessThan__card,axiom,
    ! [N4: set @ nat,N: nat] :
      ( ( ord_less_eq @ ( set @ nat ) @ N4 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N ) )
     => ( ord_less_eq @ nat @ ( finite_card @ nat @ N4 ) @ N ) ) ).

% subset_eq_atLeast0_lessThan_card
thf(fact_4691_card__sum__le__nat__sum,axiom,
    ! [S: set @ nat] :
      ( ord_less_eq @ nat
      @ ( groups7311177749621191930dd_sum @ nat @ nat
        @ ^ [X2: nat] : X2
        @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( finite_card @ nat @ S ) ) )
      @ ( groups7311177749621191930dd_sum @ nat @ nat
        @ ^ [X2: nat] : X2
        @ S ) ) ).

% card_sum_le_nat_sum
thf(fact_4692_card__nth__roots,axiom,
    ! [C2: complex,N: nat] :
      ( ( C2
       != ( zero_zero @ complex ) )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
       => ( ( finite_card @ complex
            @ ( collect @ complex
              @ ^ [Z6: complex] :
                  ( ( power_power @ complex @ Z6 @ N )
                  = C2 ) ) )
          = N ) ) ) ).

% card_nth_roots
thf(fact_4693_card__roots__unity__eq,axiom,
    ! [N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( finite_card @ complex
          @ ( collect @ complex
            @ ^ [Z6: complex] :
                ( ( power_power @ complex @ Z6 @ N )
                = ( one_one @ complex ) ) ) )
        = N ) ) ).

% card_roots_unity_eq
thf(fact_4694_card__2__iff,axiom,
    ! [A: $tType,S: set @ A] :
      ( ( ( finite_card @ A @ S )
        = ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
      = ( ? [X2: A,Y4: A] :
            ( ( S
              = ( insert @ A @ X2 @ ( insert @ A @ Y4 @ ( bot_bot @ ( set @ A ) ) ) ) )
            & ( X2 != Y4 ) ) ) ) ).

% card_2_iff
thf(fact_4695_card__3__iff,axiom,
    ! [A: $tType,S: set @ A] :
      ( ( ( finite_card @ A @ S )
        = ( numeral_numeral @ nat @ ( bit1 @ one2 ) ) )
      = ( ? [X2: A,Y4: A,Z6: A] :
            ( ( S
              = ( insert @ A @ X2 @ ( insert @ A @ Y4 @ ( insert @ A @ Z6 @ ( bot_bot @ ( set @ A ) ) ) ) ) )
            & ( X2 != Y4 )
            & ( Y4 != Z6 )
            & ( X2 != Z6 ) ) ) ) ).

% card_3_iff
thf(fact_4696_odd__card__imp__not__empty,axiom,
    ! [A: $tType,A4: set @ A] :
      ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( finite_card @ A @ A4 ) )
     => ( A4
       != ( bot_bot @ ( set @ A ) ) ) ) ).

% odd_card_imp_not_empty
thf(fact_4697_card__Diff1__less__iff,axiom,
    ! [A: $tType,A4: set @ A,X: A] :
      ( ( ord_less @ nat @ ( finite_card @ A @ ( minus_minus @ ( set @ A ) @ A4 @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) @ ( finite_card @ A @ A4 ) )
      = ( ( finite_finite @ A @ A4 )
        & ( member @ A @ X @ A4 ) ) ) ).

% card_Diff1_less_iff
thf(fact_4698_card__Diff2__less,axiom,
    ! [A: $tType,A4: set @ A,X: A,Y: A] :
      ( ( finite_finite @ A @ A4 )
     => ( ( member @ A @ X @ A4 )
       => ( ( member @ A @ Y @ A4 )
         => ( ord_less @ nat @ ( finite_card @ A @ ( minus_minus @ ( set @ A ) @ ( minus_minus @ ( set @ A ) @ A4 @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) @ ( insert @ A @ Y @ ( bot_bot @ ( set @ A ) ) ) ) ) @ ( finite_card @ A @ A4 ) ) ) ) ) ).

% card_Diff2_less
thf(fact_4699_card__Diff1__less,axiom,
    ! [A: $tType,A4: set @ A,X: A] :
      ( ( finite_finite @ A @ A4 )
     => ( ( member @ A @ X @ A4 )
       => ( ord_less @ nat @ ( finite_card @ A @ ( minus_minus @ ( set @ A ) @ A4 @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) @ ( finite_card @ A @ A4 ) ) ) ) ).

% card_Diff1_less
thf(fact_4700_sum__norm__bound,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [S: set @ B,F2: B > A,K6: real] :
          ( ! [X3: B] :
              ( ( member @ B @ X3 @ S )
             => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( F2 @ X3 ) ) @ K6 ) )
         => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ S ) ) @ ( times_times @ real @ ( semiring_1_of_nat @ real @ ( finite_card @ B @ S ) ) @ K6 ) ) ) ) ).

% sum_norm_bound
thf(fact_4701_prod__le__power,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linordered_semidom @ A )
     => ! [A4: set @ B,F2: B > A,N: A,K: nat] :
          ( ! [I2: B] :
              ( ( member @ B @ I2 @ A4 )
             => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( F2 @ I2 ) )
                & ( ord_less_eq @ A @ ( F2 @ I2 ) @ N ) ) )
         => ( ( ord_less_eq @ nat @ ( finite_card @ B @ A4 ) @ K )
           => ( ( ord_less_eq @ A @ ( one_one @ A ) @ N )
             => ( ord_less_eq @ A @ ( groups7121269368397514597t_prod @ B @ A @ F2 @ A4 ) @ ( power_power @ A @ N @ K ) ) ) ) ) ) ).

% prod_le_power
thf(fact_4702_sum__bounded__above__strict,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( ordere8940638589300402666id_add @ A )
        & ( semiring_1 @ A ) )
     => ! [A4: set @ B,F2: B > A,K6: A] :
          ( ! [I2: B] :
              ( ( member @ B @ I2 @ A4 )
             => ( ord_less @ A @ ( F2 @ I2 ) @ K6 ) )
         => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( finite_card @ B @ A4 ) )
           => ( ord_less @ A @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ A4 ) @ ( times_times @ A @ ( semiring_1_of_nat @ A @ ( finite_card @ B @ A4 ) ) @ K6 ) ) ) ) ) ).

% sum_bounded_above_strict
thf(fact_4703_sum__bounded__above__divide,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linordered_field @ A )
     => ! [A4: set @ B,F2: B > A,K6: A] :
          ( ! [I2: B] :
              ( ( member @ B @ I2 @ A4 )
             => ( ord_less_eq @ A @ ( F2 @ I2 ) @ ( divide_divide @ A @ K6 @ ( semiring_1_of_nat @ A @ ( finite_card @ B @ A4 ) ) ) ) )
         => ( ( finite_finite @ B @ A4 )
           => ( ( A4
               != ( bot_bot @ ( set @ B ) ) )
             => ( ord_less_eq @ A @ ( groups7311177749621191930dd_sum @ B @ A @ F2 @ A4 ) @ K6 ) ) ) ) ) ).

% sum_bounded_above_divide
thf(fact_4704_card__insert__le__m1,axiom,
    ! [A: $tType,N: nat,Y: set @ A,X: A] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less_eq @ nat @ ( finite_card @ A @ Y ) @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) )
       => ( ord_less_eq @ nat @ ( finite_card @ A @ ( insert @ A @ X @ Y ) ) @ N ) ) ) ).

% card_insert_le_m1
thf(fact_4705_polyfun__roots__card,axiom,
    ! [A: $tType] :
      ( ( ( real_V8999393235501362500lgebra @ A )
        & ( idom @ A ) )
     => ! [C2: nat > A,K: nat,N: nat] :
          ( ( ( C2 @ K )
           != ( zero_zero @ A ) )
         => ( ( ord_less_eq @ nat @ K @ N )
           => ( ord_less_eq @ nat
              @ ( finite_card @ A
                @ ( collect @ A
                  @ ^ [Z6: A] :
                      ( ( groups7311177749621191930dd_sum @ nat @ A
                        @ ^ [I4: nat] : ( times_times @ A @ ( C2 @ I4 ) @ ( power_power @ A @ Z6 @ I4 ) )
                        @ ( set_ord_atMost @ nat @ N ) )
                      = ( zero_zero @ A ) ) ) )
              @ N ) ) ) ) ).

% polyfun_roots_card
thf(fact_4706_prod__gen__delta,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [S: set @ B,A2: B,B2: B > A,C2: A] :
          ( ( finite_finite @ B @ S )
         => ( ( ( member @ B @ A2 @ S )
             => ( ( groups7121269368397514597t_prod @ B @ A
                  @ ^ [K3: B] : ( if @ A @ ( K3 = A2 ) @ ( B2 @ K3 ) @ C2 )
                  @ S )
                = ( times_times @ A @ ( B2 @ A2 ) @ ( power_power @ A @ C2 @ ( minus_minus @ nat @ ( finite_card @ B @ S ) @ ( one_one @ nat ) ) ) ) ) )
            & ( ~ ( member @ B @ A2 @ S )
             => ( ( groups7121269368397514597t_prod @ B @ A
                  @ ^ [K3: B] : ( if @ A @ ( K3 = A2 ) @ ( B2 @ K3 ) @ C2 )
                  @ S )
                = ( power_power @ A @ C2 @ ( finite_card @ B @ S ) ) ) ) ) ) ) ).

% prod_gen_delta
thf(fact_4707_polyfun__rootbound,axiom,
    ! [A: $tType] :
      ( ( ( real_V8999393235501362500lgebra @ A )
        & ( idom @ A ) )
     => ! [C2: nat > A,K: nat,N: nat] :
          ( ( ( C2 @ K )
           != ( zero_zero @ A ) )
         => ( ( ord_less_eq @ nat @ K @ N )
           => ( ( finite_finite @ A
                @ ( collect @ A
                  @ ^ [Z6: A] :
                      ( ( groups7311177749621191930dd_sum @ nat @ A
                        @ ^ [I4: nat] : ( times_times @ A @ ( C2 @ I4 ) @ ( power_power @ A @ Z6 @ I4 ) )
                        @ ( set_ord_atMost @ nat @ N ) )
                      = ( zero_zero @ A ) ) ) )
              & ( ord_less_eq @ nat
                @ ( finite_card @ A
                  @ ( collect @ A
                    @ ^ [Z6: A] :
                        ( ( groups7311177749621191930dd_sum @ nat @ A
                          @ ^ [I4: nat] : ( times_times @ A @ ( C2 @ I4 ) @ ( power_power @ A @ Z6 @ I4 ) )
                          @ ( set_ord_atMost @ nat @ N ) )
                        = ( zero_zero @ A ) ) ) )
                @ N ) ) ) ) ) ).

% polyfun_rootbound
thf(fact_4708_card__lists__distinct__length__eq,axiom,
    ! [A: $tType,A4: set @ A,K: nat] :
      ( ( finite_finite @ A @ A4 )
     => ( ( ord_less_eq @ nat @ K @ ( finite_card @ A @ A4 ) )
       => ( ( finite_card @ ( list @ A )
            @ ( collect @ ( list @ A )
              @ ^ [Xs3: list @ A] :
                  ( ( ( size_size @ ( list @ A ) @ Xs3 )
                    = K )
                  & ( distinct @ A @ Xs3 )
                  & ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ Xs3 ) @ A4 ) ) ) )
          = ( groups7121269368397514597t_prod @ nat @ nat
            @ ^ [X2: nat] : X2
            @ ( set_or1337092689740270186AtMost @ nat @ ( plus_plus @ nat @ ( minus_minus @ nat @ ( finite_card @ A @ A4 ) @ K ) @ ( one_one @ nat ) ) @ ( finite_card @ A @ A4 ) ) ) ) ) ) ).

% card_lists_distinct_length_eq
thf(fact_4709_card__lists__distinct__length__eq_H,axiom,
    ! [A: $tType,K: nat,A4: set @ A] :
      ( ( ord_less @ nat @ K @ ( finite_card @ A @ A4 ) )
     => ( ( finite_card @ ( list @ A )
          @ ( collect @ ( list @ A )
            @ ^ [Xs3: list @ A] :
                ( ( ( size_size @ ( list @ A ) @ Xs3 )
                  = K )
                & ( distinct @ A @ Xs3 )
                & ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ Xs3 ) @ A4 ) ) ) )
        = ( groups7121269368397514597t_prod @ nat @ nat
          @ ^ [X2: nat] : X2
          @ ( set_or1337092689740270186AtMost @ nat @ ( plus_plus @ nat @ ( minus_minus @ nat @ ( finite_card @ A @ A4 ) @ K ) @ ( one_one @ nat ) ) @ ( finite_card @ A @ A4 ) ) ) ) ) ).

% card_lists_distinct_length_eq'
thf(fact_4710_int__of__integer__code,axiom,
    ( code_int_of_integer
    = ( ^ [K3: code_integer] :
          ( if @ int @ ( ord_less @ code_integer @ K3 @ ( zero_zero @ code_integer ) ) @ ( uminus_uminus @ int @ ( code_int_of_integer @ ( uminus_uminus @ code_integer @ K3 ) ) )
          @ ( if @ int
            @ ( K3
              = ( zero_zero @ code_integer ) )
            @ ( zero_zero @ int )
            @ ( product_case_prod @ code_integer @ code_integer @ int
              @ ^ [L2: code_integer,J3: code_integer] :
                  ( if @ int
                  @ ( J3
                    = ( zero_zero @ code_integer ) )
                  @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( code_int_of_integer @ L2 ) )
                  @ ( plus_plus @ int @ ( times_times @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( code_int_of_integer @ L2 ) ) @ ( one_one @ int ) ) )
              @ ( code_divmod_integer @ K3 @ ( numeral_numeral @ code_integer @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ).

% int_of_integer_code
thf(fact_4711_int__of__integer__of__nat,axiom,
    ! [N: nat] :
      ( ( code_int_of_integer @ ( semiring_1_of_nat @ code_integer @ N ) )
      = ( semiring_1_of_nat @ int @ N ) ) ).

% int_of_integer_of_nat
thf(fact_4712_zero__integer_Orep__eq,axiom,
    ( ( code_int_of_integer @ ( zero_zero @ code_integer ) )
    = ( zero_zero @ int ) ) ).

% zero_integer.rep_eq
thf(fact_4713_int__of__integer__numeral,axiom,
    ! [K: num] :
      ( ( code_int_of_integer @ ( numeral_numeral @ code_integer @ K ) )
      = ( numeral_numeral @ int @ K ) ) ).

% int_of_integer_numeral
thf(fact_4714_distinct__swap,axiom,
    ! [A: $tType,I: nat,Xs: list @ A,J: nat] :
      ( ( ord_less @ nat @ I @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( ( ord_less @ nat @ J @ ( size_size @ ( list @ A ) @ Xs ) )
       => ( ( distinct @ A @ ( list_update @ A @ ( list_update @ A @ Xs @ I @ ( nth @ A @ Xs @ J ) ) @ J @ ( nth @ A @ Xs @ I ) ) )
          = ( distinct @ A @ Xs ) ) ) ) ).

% distinct_swap
thf(fact_4715_less__integer_Orep__eq,axiom,
    ( ( ord_less @ code_integer )
    = ( ^ [X2: code_integer,Xa4: code_integer] : ( ord_less @ int @ ( code_int_of_integer @ X2 ) @ ( code_int_of_integer @ Xa4 ) ) ) ) ).

% less_integer.rep_eq
thf(fact_4716_integer__less__iff,axiom,
    ( ( ord_less @ code_integer )
    = ( ^ [K3: code_integer,L2: code_integer] : ( ord_less @ int @ ( code_int_of_integer @ K3 ) @ ( code_int_of_integer @ L2 ) ) ) ) ).

% integer_less_iff
thf(fact_4717_less__eq__integer_Orep__eq,axiom,
    ( ( ord_less_eq @ code_integer )
    = ( ^ [X2: code_integer,Xa4: code_integer] : ( ord_less_eq @ int @ ( code_int_of_integer @ X2 ) @ ( code_int_of_integer @ Xa4 ) ) ) ) ).

% less_eq_integer.rep_eq
thf(fact_4718_integer__less__eq__iff,axiom,
    ( ( ord_less_eq @ code_integer )
    = ( ^ [K3: code_integer,L2: code_integer] : ( ord_less_eq @ int @ ( code_int_of_integer @ K3 ) @ ( code_int_of_integer @ L2 ) ) ) ) ).

% integer_less_eq_iff
thf(fact_4719_nth__eq__iff__index__eq,axiom,
    ! [A: $tType,Xs: list @ A,I: nat,J: nat] :
      ( ( distinct @ A @ Xs )
     => ( ( ord_less @ nat @ I @ ( size_size @ ( list @ A ) @ Xs ) )
       => ( ( ord_less @ nat @ J @ ( size_size @ ( list @ A ) @ Xs ) )
         => ( ( ( nth @ A @ Xs @ I )
              = ( nth @ A @ Xs @ J ) )
            = ( I = J ) ) ) ) ) ).

% nth_eq_iff_index_eq
thf(fact_4720_distinct__conv__nth,axiom,
    ! [A: $tType] :
      ( ( distinct @ A )
      = ( ^ [Xs3: list @ A] :
          ! [I4: nat] :
            ( ( ord_less @ nat @ I4 @ ( size_size @ ( list @ A ) @ Xs3 ) )
           => ! [J3: nat] :
                ( ( ord_less @ nat @ J3 @ ( size_size @ ( list @ A ) @ Xs3 ) )
               => ( ( I4 != J3 )
                 => ( ( nth @ A @ Xs3 @ I4 )
                   != ( nth @ A @ Xs3 @ J3 ) ) ) ) ) ) ) ).

% distinct_conv_nth
thf(fact_4721_distinct__Ex1,axiom,
    ! [A: $tType,Xs: list @ A,X: A] :
      ( ( distinct @ A @ Xs )
     => ( ( member @ A @ X @ ( set2 @ A @ Xs ) )
       => ? [X3: nat] :
            ( ( ord_less @ nat @ X3 @ ( size_size @ ( list @ A ) @ Xs ) )
            & ( ( nth @ A @ Xs @ X3 )
              = X )
            & ! [Y6: nat] :
                ( ( ( ord_less @ nat @ Y6 @ ( size_size @ ( list @ A ) @ Xs ) )
                  & ( ( nth @ A @ Xs @ Y6 )
                    = X ) )
               => ( Y6 = X3 ) ) ) ) ) ).

% distinct_Ex1
thf(fact_4722_set__update__distinct,axiom,
    ! [A: $tType,Xs: list @ A,N: nat,X: A] :
      ( ( distinct @ A @ Xs )
     => ( ( ord_less @ nat @ N @ ( size_size @ ( list @ A ) @ Xs ) )
       => ( ( set2 @ A @ ( list_update @ A @ Xs @ N @ X ) )
          = ( insert @ A @ X @ ( minus_minus @ ( set @ A ) @ ( set2 @ A @ Xs ) @ ( insert @ A @ ( nth @ A @ Xs @ N ) @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ).

% set_update_distinct
thf(fact_4723_num__of__integer__code,axiom,
    ( code_num_of_integer
    = ( ^ [K3: code_integer] :
          ( if @ num @ ( ord_less_eq @ code_integer @ K3 @ ( one_one @ code_integer ) ) @ one2
          @ ( product_case_prod @ code_integer @ code_integer @ num
            @ ^ [L2: code_integer,J3: code_integer] :
                ( if @ num
                @ ( J3
                  = ( zero_zero @ code_integer ) )
                @ ( plus_plus @ num @ ( code_num_of_integer @ L2 ) @ ( code_num_of_integer @ L2 ) )
                @ ( plus_plus @ num @ ( plus_plus @ num @ ( code_num_of_integer @ L2 ) @ ( code_num_of_integer @ L2 ) ) @ one2 ) )
            @ ( code_divmod_integer @ K3 @ ( numeral_numeral @ code_integer @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% num_of_integer_code
thf(fact_4724_nat__of__integer__code,axiom,
    ( code_nat_of_integer
    = ( ^ [K3: code_integer] :
          ( if @ nat @ ( ord_less_eq @ code_integer @ K3 @ ( zero_zero @ code_integer ) ) @ ( zero_zero @ nat )
          @ ( product_case_prod @ code_integer @ code_integer @ nat
            @ ^ [L2: code_integer,J3: code_integer] :
                ( if @ nat
                @ ( J3
                  = ( zero_zero @ code_integer ) )
                @ ( plus_plus @ nat @ ( code_nat_of_integer @ L2 ) @ ( code_nat_of_integer @ L2 ) )
                @ ( plus_plus @ nat @ ( plus_plus @ nat @ ( code_nat_of_integer @ L2 ) @ ( code_nat_of_integer @ L2 ) ) @ ( one_one @ nat ) ) )
            @ ( code_divmod_integer @ K3 @ ( numeral_numeral @ code_integer @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% nat_of_integer_code
thf(fact_4725_case__nat__add__eq__if,axiom,
    ! [A: $tType,A2: A,F2: nat > A,V: num,N: nat] :
      ( ( case_nat @ A @ A2 @ F2 @ ( plus_plus @ nat @ ( numeral_numeral @ nat @ V ) @ N ) )
      = ( F2 @ ( plus_plus @ nat @ ( pred_numeral @ V ) @ N ) ) ) ).

% case_nat_add_eq_if
thf(fact_4726_case__nat__numeral,axiom,
    ! [A: $tType,A2: A,F2: nat > A,V: num] :
      ( ( case_nat @ A @ A2 @ F2 @ ( numeral_numeral @ nat @ V ) )
      = ( F2 @ ( pred_numeral @ V ) ) ) ).

% case_nat_numeral
thf(fact_4727_of__nat__of__integer,axiom,
    ! [K: code_integer] :
      ( ( semiring_1_of_nat @ code_integer @ ( code_nat_of_integer @ K ) )
      = ( ord_max @ code_integer @ ( zero_zero @ code_integer ) @ K ) ) ).

% of_nat_of_integer
thf(fact_4728_nat__of__integer__non__positive,axiom,
    ! [K: code_integer] :
      ( ( ord_less_eq @ code_integer @ K @ ( zero_zero @ code_integer ) )
     => ( ( code_nat_of_integer @ K )
        = ( zero_zero @ nat ) ) ) ).

% nat_of_integer_non_positive
thf(fact_4729_nat_Ocase__distrib,axiom,
    ! [B: $tType,A: $tType,H2: A > B,F1: A,F22: nat > A,Nat: nat] :
      ( ( H2 @ ( case_nat @ A @ F1 @ F22 @ Nat ) )
      = ( case_nat @ B @ ( H2 @ F1 )
        @ ^ [X2: nat] : ( H2 @ ( F22 @ X2 ) )
        @ Nat ) ) ).

% nat.case_distrib
thf(fact_4730_old_Onat_Osimps_I5_J,axiom,
    ! [A: $tType,F1: A,F22: nat > A,X22: nat] :
      ( ( case_nat @ A @ F1 @ F22 @ ( suc @ X22 ) )
      = ( F22 @ X22 ) ) ).

% old.nat.simps(5)
thf(fact_4731_old_Onat_Osimps_I4_J,axiom,
    ! [A: $tType,F1: A,F22: nat > A] :
      ( ( case_nat @ A @ F1 @ F22 @ ( zero_zero @ nat ) )
      = F1 ) ).

% old.nat.simps(4)
thf(fact_4732_nat_Odisc__eq__case_I2_J,axiom,
    ! [Nat: nat] :
      ( ( ( Nat
         != ( zero_zero @ nat ) ) )
      = ( case_nat @ $o @ $false
        @ ^ [Uu3: nat] : $true
        @ Nat ) ) ).

% nat.disc_eq_case(2)
thf(fact_4733_nat_Odisc__eq__case_I1_J,axiom,
    ! [Nat: nat] :
      ( ( Nat
        = ( zero_zero @ nat ) )
      = ( case_nat @ $o @ $true
        @ ^ [Uu3: nat] : $false
        @ Nat ) ) ).

% nat.disc_eq_case(1)
thf(fact_4734_nat__of__integer__code__post_I1_J,axiom,
    ( ( code_nat_of_integer @ ( zero_zero @ code_integer ) )
    = ( zero_zero @ nat ) ) ).

% nat_of_integer_code_post(1)
thf(fact_4735_less__eq__nat_Osimps_I2_J,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ ( suc @ M ) @ N )
      = ( case_nat @ $o @ $false @ ( ord_less_eq @ nat @ M ) @ N ) ) ).

% less_eq_nat.simps(2)
thf(fact_4736_nat__of__integer__code__post_I3_J,axiom,
    ! [K: num] :
      ( ( code_nat_of_integer @ ( numeral_numeral @ code_integer @ K ) )
      = ( numeral_numeral @ nat @ K ) ) ).

% nat_of_integer_code_post(3)
thf(fact_4737_max__Suc2,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_max @ nat @ M @ ( suc @ N ) )
      = ( case_nat @ nat @ ( suc @ N )
        @ ^ [M6: nat] : ( suc @ ( ord_max @ nat @ M6 @ N ) )
        @ M ) ) ).

% max_Suc2
thf(fact_4738_max__Suc1,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_max @ nat @ ( suc @ N ) @ M )
      = ( case_nat @ nat @ ( suc @ N )
        @ ^ [M6: nat] : ( suc @ ( ord_max @ nat @ N @ M6 ) )
        @ M ) ) ).

% max_Suc1
thf(fact_4739_diff__Suc,axiom,
    ! [M: nat,N: nat] :
      ( ( minus_minus @ nat @ M @ ( suc @ N ) )
      = ( case_nat @ nat @ ( zero_zero @ nat )
        @ ^ [K3: nat] : K3
        @ ( minus_minus @ nat @ M @ N ) ) ) ).

% diff_Suc
thf(fact_4740_bit__numeral__rec_I1_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [W: num,N: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( numeral_numeral @ A @ ( bit0 @ W ) ) @ N )
          = ( case_nat @ $o @ $false @ ( bit_se5641148757651400278ts_bit @ A @ ( numeral_numeral @ A @ W ) ) @ N ) ) ) ).

% bit_numeral_rec(1)
thf(fact_4741_bit__numeral__rec_I2_J,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [W: num,N: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( numeral_numeral @ A @ ( bit1 @ W ) ) @ N )
          = ( case_nat @ $o @ $true @ ( bit_se5641148757651400278ts_bit @ A @ ( numeral_numeral @ A @ W ) ) @ N ) ) ) ).

% bit_numeral_rec(2)
thf(fact_4742_Nitpick_Ocase__nat__unfold,axiom,
    ! [A: $tType] :
      ( ( case_nat @ A )
      = ( ^ [X2: A,F3: nat > A,N3: nat] :
            ( if @ A
            @ ( N3
              = ( zero_zero @ nat ) )
            @ X2
            @ ( F3 @ ( minus_minus @ nat @ N3 @ ( one_one @ nat ) ) ) ) ) ) ).

% Nitpick.case_nat_unfold
thf(fact_4743_nat_Osplit__sels_I1_J,axiom,
    ! [A: $tType,P: A > $o,F1: A,F22: nat > A,Nat: nat] :
      ( ( P @ ( case_nat @ A @ F1 @ F22 @ Nat ) )
      = ( ( ( Nat
            = ( zero_zero @ nat ) )
         => ( P @ F1 ) )
        & ( ( Nat
            = ( suc @ ( pred @ Nat ) ) )
         => ( P @ ( F22 @ ( pred @ Nat ) ) ) ) ) ) ).

% nat.split_sels(1)
thf(fact_4744_nat_Osplit__sels_I2_J,axiom,
    ! [A: $tType,P: A > $o,F1: A,F22: nat > A,Nat: nat] :
      ( ( P @ ( case_nat @ A @ F1 @ F22 @ Nat ) )
      = ( ~ ( ( ( Nat
                = ( zero_zero @ nat ) )
              & ~ ( P @ F1 ) )
            | ( ( Nat
                = ( suc @ ( pred @ Nat ) ) )
              & ~ ( P @ ( F22 @ ( pred @ Nat ) ) ) ) ) ) ) ).

% nat.split_sels(2)
thf(fact_4745_rec__nat__add__eq__if,axiom,
    ! [A: $tType,A2: A,F2: nat > A > A,V: num,N: nat] :
      ( ( rec_nat @ A @ A2 @ F2 @ ( plus_plus @ nat @ ( numeral_numeral @ nat @ V ) @ N ) )
      = ( F2 @ ( plus_plus @ nat @ ( pred_numeral @ V ) @ N ) @ ( rec_nat @ A @ A2 @ F2 @ ( plus_plus @ nat @ ( pred_numeral @ V ) @ N ) ) ) ) ).

% rec_nat_add_eq_if
thf(fact_4746_old_Onat_Osimps_I7_J,axiom,
    ! [T: $tType,F1: T,F22: nat > T > T,Nat: nat] :
      ( ( rec_nat @ T @ F1 @ F22 @ ( suc @ Nat ) )
      = ( F22 @ Nat @ ( rec_nat @ T @ F1 @ F22 @ Nat ) ) ) ).

% old.nat.simps(7)
thf(fact_4747_old_Onat_Osimps_I6_J,axiom,
    ! [T: $tType,F1: T,F22: nat > T > T] :
      ( ( rec_nat @ T @ F1 @ F22 @ ( zero_zero @ nat ) )
      = F1 ) ).

% old.nat.simps(6)
thf(fact_4748_rec__nat__numeral,axiom,
    ! [A: $tType,A2: A,F2: nat > A > A,V: num] :
      ( ( rec_nat @ A @ A2 @ F2 @ ( numeral_numeral @ nat @ V ) )
      = ( F2 @ ( pred_numeral @ V ) @ ( rec_nat @ A @ A2 @ F2 @ ( pred_numeral @ V ) ) ) ) ).

% rec_nat_numeral
thf(fact_4749_pred__def,axiom,
    ( pred
    = ( case_nat @ nat @ ( zero_zero @ nat )
      @ ^ [X24: nat] : X24 ) ) ).

% pred_def
thf(fact_4750_old_Orec__nat__def,axiom,
    ! [T: $tType] :
      ( ( rec_nat @ T )
      = ( ^ [F12: T,F23: nat > T > T,X2: nat] : ( the @ T @ ( rec_set_nat @ T @ F12 @ F23 @ X2 ) ) ) ) ).

% old.rec_nat_def
thf(fact_4751_rec__nat__0__imp,axiom,
    ! [A: $tType,F2: nat > A,F1: A,F22: nat > A > A] :
      ( ( F2
        = ( rec_nat @ A @ F1 @ F22 ) )
     => ( ( F2 @ ( zero_zero @ nat ) )
        = F1 ) ) ).

% rec_nat_0_imp
thf(fact_4752_bezw__0,axiom,
    ! [X: nat] :
      ( ( bezw @ X @ ( zero_zero @ nat ) )
      = ( product_Pair @ int @ int @ ( one_one @ int ) @ ( zero_zero @ int ) ) ) ).

% bezw_0
thf(fact_4753_floor__real__def,axiom,
    ( ( archim6421214686448440834_floor @ real )
    = ( ^ [X2: real] :
          ( the @ int
          @ ^ [Z6: int] :
              ( ( ord_less_eq @ real @ ( ring_1_of_int @ real @ Z6 ) @ X2 )
              & ( ord_less @ real @ X2 @ ( ring_1_of_int @ real @ ( plus_plus @ int @ Z6 @ ( one_one @ int ) ) ) ) ) ) ) ) ).

% floor_real_def
thf(fact_4754_prod__decode__aux_Oelims,axiom,
    ! [X: nat,Xa: nat,Y: product_prod @ nat @ nat] :
      ( ( ( nat_prod_decode_aux @ X @ Xa )
        = Y )
     => ( ( ( ord_less_eq @ nat @ Xa @ X )
         => ( Y
            = ( product_Pair @ nat @ nat @ Xa @ ( minus_minus @ nat @ X @ Xa ) ) ) )
        & ( ~ ( ord_less_eq @ nat @ Xa @ X )
         => ( Y
            = ( nat_prod_decode_aux @ ( suc @ X ) @ ( minus_minus @ nat @ Xa @ ( suc @ X ) ) ) ) ) ) ) ).

% prod_decode_aux.elims
thf(fact_4755_prod__decode__aux_Osimps,axiom,
    ( nat_prod_decode_aux
    = ( ^ [K3: nat,M3: nat] : ( if @ ( product_prod @ nat @ nat ) @ ( ord_less_eq @ nat @ M3 @ K3 ) @ ( product_Pair @ nat @ nat @ M3 @ ( minus_minus @ nat @ K3 @ M3 ) ) @ ( nat_prod_decode_aux @ ( suc @ K3 ) @ ( minus_minus @ nat @ M3 @ ( suc @ K3 ) ) ) ) ) ) ).

% prod_decode_aux.simps
thf(fact_4756_Suc__0__div__numeral,axiom,
    ! [K: num] :
      ( ( divide_divide @ nat @ ( suc @ ( zero_zero @ nat ) ) @ ( numeral_numeral @ nat @ K ) )
      = ( product_fst @ nat @ nat @ ( unique8689654367752047608divmod @ nat @ one2 @ K ) ) ) ).

% Suc_0_div_numeral
thf(fact_4757_numeral__div__numeral,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [K: num,L: num] :
          ( ( divide_divide @ A @ ( numeral_numeral @ A @ K ) @ ( numeral_numeral @ A @ L ) )
          = ( product_fst @ A @ A @ ( unique8689654367752047608divmod @ A @ K @ L ) ) ) ) ).

% numeral_div_numeral
thf(fact_4758_one__div__numeral,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [N: num] :
          ( ( divide_divide @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ N ) )
          = ( product_fst @ A @ A @ ( unique8689654367752047608divmod @ A @ one2 @ N ) ) ) ) ).

% one_div_numeral
thf(fact_4759_fst__divmod,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [M: num,N: num] :
          ( ( product_fst @ A @ A @ ( unique8689654367752047608divmod @ A @ M @ N ) )
          = ( divide_divide @ A @ ( numeral_numeral @ A @ M ) @ ( numeral_numeral @ A @ N ) ) ) ) ).

% fst_divmod
thf(fact_4760_Suc__0__mod__numeral,axiom,
    ! [K: num] :
      ( ( modulo_modulo @ nat @ ( suc @ ( zero_zero @ nat ) ) @ ( numeral_numeral @ nat @ K ) )
      = ( product_snd @ nat @ nat @ ( unique8689654367752047608divmod @ nat @ one2 @ K ) ) ) ).

% Suc_0_mod_numeral
thf(fact_4761_finite__enumerate,axiom,
    ! [S: set @ nat] :
      ( ( finite_finite @ nat @ S )
     => ? [R: nat > nat] :
          ( ( strict_mono_on @ nat @ nat @ R @ ( set_ord_lessThan @ nat @ ( finite_card @ nat @ S ) ) )
          & ! [N7: nat] :
              ( ( ord_less @ nat @ N7 @ ( finite_card @ nat @ S ) )
             => ( member @ nat @ ( R @ N7 ) @ S ) ) ) ) ).

% finite_enumerate
thf(fact_4762_bit__cut__integer__code,axiom,
    ( code_bit_cut_integer
    = ( ^ [K3: code_integer] :
          ( if @ ( product_prod @ code_integer @ $o )
          @ ( K3
            = ( zero_zero @ code_integer ) )
          @ ( product_Pair @ code_integer @ $o @ ( zero_zero @ code_integer ) @ $false )
          @ ( product_case_prod @ code_integer @ code_integer @ ( product_prod @ code_integer @ $o )
            @ ^ [R5: code_integer,S6: code_integer] :
                ( product_Pair @ code_integer @ $o @ ( if @ code_integer @ ( ord_less @ code_integer @ ( zero_zero @ code_integer ) @ K3 ) @ R5 @ ( minus_minus @ code_integer @ ( uminus_uminus @ code_integer @ R5 ) @ S6 ) )
                @ ( S6
                  = ( one_one @ code_integer ) ) )
            @ ( code_divmod_abs @ K3 @ ( numeral_numeral @ code_integer @ ( bit0 @ one2 ) ) ) ) ) ) ) ).

% bit_cut_integer_code
thf(fact_4763_numeral__mod__numeral,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [K: num,L: num] :
          ( ( modulo_modulo @ A @ ( numeral_numeral @ A @ K ) @ ( numeral_numeral @ A @ L ) )
          = ( product_snd @ A @ A @ ( unique8689654367752047608divmod @ A @ K @ L ) ) ) ) ).

% numeral_mod_numeral
thf(fact_4764_one__mod__numeral,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [N: num] :
          ( ( modulo_modulo @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ N ) )
          = ( product_snd @ A @ A @ ( unique8689654367752047608divmod @ A @ one2 @ N ) ) ) ) ).

% one_mod_numeral
thf(fact_4765_divides__aux__def,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ( ( unique5940410009612947441es_aux @ A )
        = ( ^ [Qr: product_prod @ A @ A] :
              ( ( product_snd @ A @ A @ Qr )
              = ( zero_zero @ A ) ) ) ) ) ).

% divides_aux_def
thf(fact_4766_snd__divmod,axiom,
    ! [A: $tType] :
      ( ( unique1627219031080169319umeral @ A )
     => ! [M: num,N: num] :
          ( ( product_snd @ A @ A @ ( unique8689654367752047608divmod @ A @ M @ N ) )
          = ( modulo_modulo @ A @ ( numeral_numeral @ A @ M ) @ ( numeral_numeral @ A @ N ) ) ) ) ).

% snd_divmod
thf(fact_4767_divmod__abs__code_I6_J,axiom,
    ! [J: code_integer] :
      ( ( code_divmod_abs @ ( zero_zero @ code_integer ) @ J )
      = ( product_Pair @ code_integer @ code_integer @ ( zero_zero @ code_integer ) @ ( zero_zero @ code_integer ) ) ) ).

% divmod_abs_code(6)
thf(fact_4768_divmod__abs__code_I5_J,axiom,
    ! [J: code_integer] :
      ( ( code_divmod_abs @ J @ ( zero_zero @ code_integer ) )
      = ( product_Pair @ code_integer @ code_integer @ ( zero_zero @ code_integer ) @ ( abs_abs @ code_integer @ J ) ) ) ).

% divmod_abs_code(5)
thf(fact_4769_bit__cut__integer__def,axiom,
    ( code_bit_cut_integer
    = ( ^ [K3: code_integer] :
          ( product_Pair @ code_integer @ $o @ ( divide_divide @ code_integer @ K3 @ ( numeral_numeral @ code_integer @ ( bit0 @ one2 ) ) )
          @ ~ ( dvd_dvd @ code_integer @ ( numeral_numeral @ code_integer @ ( bit0 @ one2 ) ) @ K3 ) ) ) ) ).

% bit_cut_integer_def
thf(fact_4770_divmod__integer__code,axiom,
    ( code_divmod_integer
    = ( ^ [K3: code_integer,L2: code_integer] :
          ( if @ ( product_prod @ code_integer @ code_integer )
          @ ( K3
            = ( zero_zero @ code_integer ) )
          @ ( product_Pair @ code_integer @ code_integer @ ( zero_zero @ code_integer ) @ ( zero_zero @ code_integer ) )
          @ ( if @ ( product_prod @ code_integer @ code_integer ) @ ( ord_less @ code_integer @ ( zero_zero @ code_integer ) @ L2 )
            @ ( if @ ( product_prod @ code_integer @ code_integer ) @ ( ord_less @ code_integer @ ( zero_zero @ code_integer ) @ K3 ) @ ( code_divmod_abs @ K3 @ L2 )
              @ ( product_case_prod @ code_integer @ code_integer @ ( product_prod @ code_integer @ code_integer )
                @ ^ [R5: code_integer,S6: code_integer] :
                    ( if @ ( product_prod @ code_integer @ code_integer )
                    @ ( S6
                      = ( zero_zero @ code_integer ) )
                    @ ( product_Pair @ code_integer @ code_integer @ ( uminus_uminus @ code_integer @ R5 ) @ ( zero_zero @ code_integer ) )
                    @ ( product_Pair @ code_integer @ code_integer @ ( minus_minus @ code_integer @ ( uminus_uminus @ code_integer @ R5 ) @ ( one_one @ code_integer ) ) @ ( minus_minus @ code_integer @ L2 @ S6 ) ) )
                @ ( code_divmod_abs @ K3 @ L2 ) ) )
            @ ( if @ ( product_prod @ code_integer @ code_integer )
              @ ( L2
                = ( zero_zero @ code_integer ) )
              @ ( product_Pair @ code_integer @ code_integer @ ( zero_zero @ code_integer ) @ K3 )
              @ ( product_apsnd @ code_integer @ code_integer @ code_integer @ ( uminus_uminus @ code_integer )
                @ ( if @ ( product_prod @ code_integer @ code_integer ) @ ( ord_less @ code_integer @ K3 @ ( zero_zero @ code_integer ) ) @ ( code_divmod_abs @ K3 @ L2 )
                  @ ( product_case_prod @ code_integer @ code_integer @ ( product_prod @ code_integer @ code_integer )
                    @ ^ [R5: code_integer,S6: code_integer] :
                        ( if @ ( product_prod @ code_integer @ code_integer )
                        @ ( S6
                          = ( zero_zero @ code_integer ) )
                        @ ( product_Pair @ code_integer @ code_integer @ ( uminus_uminus @ code_integer @ R5 ) @ ( zero_zero @ code_integer ) )
                        @ ( product_Pair @ code_integer @ code_integer @ ( minus_minus @ code_integer @ ( uminus_uminus @ code_integer @ R5 ) @ ( one_one @ code_integer ) ) @ ( minus_minus @ code_integer @ ( uminus_uminus @ code_integer @ L2 ) @ S6 ) ) )
                    @ ( code_divmod_abs @ K3 @ L2 ) ) ) ) ) ) ) ) ) ).

% divmod_integer_code
thf(fact_4771_size__prod__simp,axiom,
    ! [B: $tType,A: $tType] :
      ( ( basic_BNF_size_prod @ A @ B )
      = ( ^ [F3: A > nat,G2: B > nat,P5: product_prod @ A @ B] : ( plus_plus @ nat @ ( plus_plus @ nat @ ( F3 @ ( product_fst @ A @ B @ P5 ) ) @ ( G2 @ ( product_snd @ A @ B @ P5 ) ) ) @ ( suc @ ( zero_zero @ nat ) ) ) ) ) ).

% size_prod_simp
thf(fact_4772_in__set__enumerate__eq,axiom,
    ! [A: $tType,P6: product_prod @ nat @ A,N: nat,Xs: list @ A] :
      ( ( member @ ( product_prod @ nat @ A ) @ P6 @ ( set2 @ ( product_prod @ nat @ A ) @ ( enumerate @ A @ N @ Xs ) ) )
      = ( ( ord_less_eq @ nat @ N @ ( product_fst @ nat @ A @ P6 ) )
        & ( ord_less @ nat @ ( product_fst @ nat @ A @ P6 ) @ ( plus_plus @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ N ) )
        & ( ( nth @ A @ Xs @ ( minus_minus @ nat @ ( product_fst @ nat @ A @ P6 ) @ N ) )
          = ( product_snd @ nat @ A @ P6 ) ) ) ) ).

% in_set_enumerate_eq
thf(fact_4773_nth__enumerate__eq,axiom,
    ! [A: $tType,M: nat,Xs: list @ A,N: nat] :
      ( ( ord_less @ nat @ M @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( ( nth @ ( product_prod @ nat @ A ) @ ( enumerate @ A @ N @ Xs ) @ M )
        = ( product_Pair @ nat @ A @ ( plus_plus @ nat @ N @ M ) @ ( nth @ A @ Xs @ M ) ) ) ) ).

% nth_enumerate_eq
thf(fact_4774_bezw__non__0,axiom,
    ! [Y: nat,X: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ Y )
     => ( ( bezw @ X @ Y )
        = ( product_Pair @ int @ int @ ( product_snd @ int @ int @ ( bezw @ Y @ ( modulo_modulo @ nat @ X @ Y ) ) ) @ ( minus_minus @ int @ ( product_fst @ int @ int @ ( bezw @ Y @ ( modulo_modulo @ nat @ X @ Y ) ) ) @ ( times_times @ int @ ( product_snd @ int @ int @ ( bezw @ Y @ ( modulo_modulo @ nat @ X @ Y ) ) ) @ ( semiring_1_of_nat @ int @ ( divide_divide @ nat @ X @ Y ) ) ) ) ) ) ) ).

% bezw_non_0
thf(fact_4775_bezw_Oelims,axiom,
    ! [X: nat,Xa: nat,Y: product_prod @ int @ int] :
      ( ( ( bezw @ X @ Xa )
        = Y )
     => ( ( ( Xa
            = ( zero_zero @ nat ) )
         => ( Y
            = ( product_Pair @ int @ int @ ( one_one @ int ) @ ( zero_zero @ int ) ) ) )
        & ( ( Xa
           != ( zero_zero @ nat ) )
         => ( Y
            = ( product_Pair @ int @ int @ ( product_snd @ int @ int @ ( bezw @ Xa @ ( modulo_modulo @ nat @ X @ Xa ) ) ) @ ( minus_minus @ int @ ( product_fst @ int @ int @ ( bezw @ Xa @ ( modulo_modulo @ nat @ X @ Xa ) ) ) @ ( times_times @ int @ ( product_snd @ int @ int @ ( bezw @ Xa @ ( modulo_modulo @ nat @ X @ Xa ) ) ) @ ( semiring_1_of_nat @ int @ ( divide_divide @ nat @ X @ Xa ) ) ) ) ) ) ) ) ) ).

% bezw.elims
thf(fact_4776_bezw_Osimps,axiom,
    ( bezw
    = ( ^ [X2: nat,Y4: nat] :
          ( if @ ( product_prod @ int @ int )
          @ ( Y4
            = ( zero_zero @ nat ) )
          @ ( product_Pair @ int @ int @ ( one_one @ int ) @ ( zero_zero @ int ) )
          @ ( product_Pair @ int @ int @ ( product_snd @ int @ int @ ( bezw @ Y4 @ ( modulo_modulo @ nat @ X2 @ Y4 ) ) ) @ ( minus_minus @ int @ ( product_fst @ int @ int @ ( bezw @ Y4 @ ( modulo_modulo @ nat @ X2 @ Y4 ) ) ) @ ( times_times @ int @ ( product_snd @ int @ int @ ( bezw @ Y4 @ ( modulo_modulo @ nat @ X2 @ Y4 ) ) ) @ ( semiring_1_of_nat @ int @ ( divide_divide @ nat @ X2 @ Y4 ) ) ) ) ) ) ) ) ).

% bezw.simps
thf(fact_4777_one__mod__minus__numeral,axiom,
    ! [N: num] :
      ( ( modulo_modulo @ int @ ( one_one @ int ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N ) ) )
      = ( uminus_uminus @ int @ ( adjust_mod @ ( numeral_numeral @ int @ N ) @ ( product_snd @ int @ int @ ( unique8689654367752047608divmod @ int @ one2 @ N ) ) ) ) ) ).

% one_mod_minus_numeral
thf(fact_4778_minus__one__mod__numeral,axiom,
    ! [N: num] :
      ( ( modulo_modulo @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( numeral_numeral @ int @ N ) )
      = ( adjust_mod @ ( numeral_numeral @ int @ N ) @ ( product_snd @ int @ int @ ( unique8689654367752047608divmod @ int @ one2 @ N ) ) ) ) ).

% minus_one_mod_numeral
thf(fact_4779_numeral__mod__minus__numeral,axiom,
    ! [M: num,N: num] :
      ( ( modulo_modulo @ int @ ( numeral_numeral @ int @ M ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N ) ) )
      = ( uminus_uminus @ int @ ( adjust_mod @ ( numeral_numeral @ int @ N ) @ ( product_snd @ int @ int @ ( unique8689654367752047608divmod @ int @ M @ N ) ) ) ) ) ).

% numeral_mod_minus_numeral
thf(fact_4780_minus__numeral__mod__numeral,axiom,
    ! [M: num,N: num] :
      ( ( modulo_modulo @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ M ) ) @ ( numeral_numeral @ int @ N ) )
      = ( adjust_mod @ ( numeral_numeral @ int @ N ) @ ( product_snd @ int @ int @ ( unique8689654367752047608divmod @ int @ M @ N ) ) ) ) ).

% minus_numeral_mod_numeral
thf(fact_4781_Divides_Oadjust__mod__def,axiom,
    ( adjust_mod
    = ( ^ [L2: int,R5: int] :
          ( if @ int
          @ ( R5
            = ( zero_zero @ int ) )
          @ ( zero_zero @ int )
          @ ( minus_minus @ int @ L2 @ R5 ) ) ) ) ).

% Divides.adjust_mod_def
thf(fact_4782_bezw_Opelims,axiom,
    ! [X: nat,Xa: nat,Y: product_prod @ int @ int] :
      ( ( ( bezw @ X @ Xa )
        = Y )
     => ( ( accp @ ( product_prod @ nat @ nat ) @ bezw_rel @ ( product_Pair @ nat @ nat @ X @ Xa ) )
       => ~ ( ( ( ( Xa
                  = ( zero_zero @ nat ) )
               => ( Y
                  = ( product_Pair @ int @ int @ ( one_one @ int ) @ ( zero_zero @ int ) ) ) )
              & ( ( Xa
                 != ( zero_zero @ nat ) )
               => ( Y
                  = ( product_Pair @ int @ int @ ( product_snd @ int @ int @ ( bezw @ Xa @ ( modulo_modulo @ nat @ X @ Xa ) ) ) @ ( minus_minus @ int @ ( product_fst @ int @ int @ ( bezw @ Xa @ ( modulo_modulo @ nat @ X @ Xa ) ) ) @ ( times_times @ int @ ( product_snd @ int @ int @ ( bezw @ Xa @ ( modulo_modulo @ nat @ X @ Xa ) ) ) @ ( semiring_1_of_nat @ int @ ( divide_divide @ nat @ X @ Xa ) ) ) ) ) ) ) )
           => ~ ( accp @ ( product_prod @ nat @ nat ) @ bezw_rel @ ( product_Pair @ nat @ nat @ X @ Xa ) ) ) ) ) ).

% bezw.pelims
thf(fact_4783_strict__mono__onD,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( ord @ A )
        & ( ord @ B ) )
     => ! [F2: A > B,A4: set @ A,R2: A,S2: A] :
          ( ( strict_mono_on @ A @ B @ F2 @ A4 )
         => ( ( member @ A @ R2 @ A4 )
           => ( ( member @ A @ S2 @ A4 )
             => ( ( ord_less @ A @ R2 @ S2 )
               => ( ord_less @ B @ ( F2 @ R2 ) @ ( F2 @ S2 ) ) ) ) ) ) ) ).

% strict_mono_onD
thf(fact_4784_strict__mono__onI,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( ord @ A )
        & ( ord @ B ) )
     => ! [A4: set @ A,F2: A > B] :
          ( ! [R: A,S3: A] :
              ( ( member @ A @ R @ A4 )
             => ( ( member @ A @ S3 @ A4 )
               => ( ( ord_less @ A @ R @ S3 )
                 => ( ord_less @ B @ ( F2 @ R ) @ ( F2 @ S3 ) ) ) ) )
         => ( strict_mono_on @ A @ B @ F2 @ A4 ) ) ) ).

% strict_mono_onI
thf(fact_4785_strict__mono__on__leD,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( linorder @ A )
        & ( preorder @ B ) )
     => ! [F2: A > B,A4: set @ A,X: A,Y: A] :
          ( ( strict_mono_on @ A @ B @ F2 @ A4 )
         => ( ( member @ A @ X @ A4 )
           => ( ( member @ A @ Y @ A4 )
             => ( ( ord_less_eq @ A @ X @ Y )
               => ( ord_less_eq @ B @ ( F2 @ X ) @ ( F2 @ Y ) ) ) ) ) ) ) ).

% strict_mono_on_leD
thf(fact_4786_strict__mono__on__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( ord @ A )
        & ( ord @ B ) )
     => ( ( strict_mono_on @ A @ B )
        = ( ^ [F3: A > B,A7: set @ A] :
            ! [R5: A,S6: A] :
              ( ( ( member @ A @ R5 @ A7 )
                & ( member @ A @ S6 @ A7 )
                & ( ord_less @ A @ R5 @ S6 ) )
             => ( ord_less @ B @ ( F3 @ R5 ) @ ( F3 @ S6 ) ) ) ) ) ) ).

% strict_mono_on_def
thf(fact_4787_prod__decode__aux_Opelims,axiom,
    ! [X: nat,Xa: nat,Y: product_prod @ nat @ nat] :
      ( ( ( nat_prod_decode_aux @ X @ Xa )
        = Y )
     => ( ( accp @ ( product_prod @ nat @ nat ) @ nat_pr5047031295181774490ux_rel @ ( product_Pair @ nat @ nat @ X @ Xa ) )
       => ~ ( ( ( ( ord_less_eq @ nat @ Xa @ X )
               => ( Y
                  = ( product_Pair @ nat @ nat @ Xa @ ( minus_minus @ nat @ X @ Xa ) ) ) )
              & ( ~ ( ord_less_eq @ nat @ Xa @ X )
               => ( Y
                  = ( nat_prod_decode_aux @ ( suc @ X ) @ ( minus_minus @ nat @ Xa @ ( suc @ X ) ) ) ) ) )
           => ~ ( accp @ ( product_prod @ nat @ nat ) @ nat_pr5047031295181774490ux_rel @ ( product_Pair @ nat @ nat @ X @ Xa ) ) ) ) ) ).

% prod_decode_aux.pelims
thf(fact_4788_divmod__integer__eq__cases,axiom,
    ( code_divmod_integer
    = ( ^ [K3: code_integer,L2: code_integer] :
          ( if @ ( product_prod @ code_integer @ code_integer )
          @ ( K3
            = ( zero_zero @ code_integer ) )
          @ ( product_Pair @ code_integer @ code_integer @ ( zero_zero @ code_integer ) @ ( zero_zero @ code_integer ) )
          @ ( if @ ( product_prod @ code_integer @ code_integer )
            @ ( L2
              = ( zero_zero @ code_integer ) )
            @ ( product_Pair @ code_integer @ code_integer @ ( zero_zero @ code_integer ) @ K3 )
            @ ( comp @ code_integer @ ( ( product_prod @ code_integer @ code_integer ) > ( product_prod @ code_integer @ code_integer ) ) @ code_integer @ ( comp @ ( code_integer > code_integer ) @ ( ( product_prod @ code_integer @ code_integer ) > ( product_prod @ code_integer @ code_integer ) ) @ code_integer @ ( product_apsnd @ code_integer @ code_integer @ code_integer ) @ ( times_times @ code_integer ) ) @ ( sgn_sgn @ code_integer ) @ L2
              @ ( if @ ( product_prod @ code_integer @ code_integer )
                @ ( ( sgn_sgn @ code_integer @ K3 )
                  = ( sgn_sgn @ code_integer @ L2 ) )
                @ ( code_divmod_abs @ K3 @ L2 )
                @ ( product_case_prod @ code_integer @ code_integer @ ( product_prod @ code_integer @ code_integer )
                  @ ^ [R5: code_integer,S6: code_integer] :
                      ( if @ ( product_prod @ code_integer @ code_integer )
                      @ ( S6
                        = ( zero_zero @ code_integer ) )
                      @ ( product_Pair @ code_integer @ code_integer @ ( uminus_uminus @ code_integer @ R5 ) @ ( zero_zero @ code_integer ) )
                      @ ( product_Pair @ code_integer @ code_integer @ ( minus_minus @ code_integer @ ( uminus_uminus @ code_integer @ R5 ) @ ( one_one @ code_integer ) ) @ ( minus_minus @ code_integer @ ( abs_abs @ code_integer @ L2 ) @ S6 ) ) )
                  @ ( code_divmod_abs @ K3 @ L2 ) ) ) ) ) ) ) ) ).

% divmod_integer_eq_cases
thf(fact_4789_nth__rotate1,axiom,
    ! [A: $tType,N: nat,Xs: list @ A] :
      ( ( ord_less @ nat @ N @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( ( nth @ A @ ( rotate1 @ A @ Xs ) @ N )
        = ( nth @ A @ Xs @ ( modulo_modulo @ nat @ ( suc @ N ) @ ( size_size @ ( list @ A ) @ Xs ) ) ) ) ) ).

% nth_rotate1
thf(fact_4790_rotate1__length01,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ ( one_one @ nat ) )
     => ( ( rotate1 @ A @ Xs )
        = Xs ) ) ).

% rotate1_length01
thf(fact_4791_comp__cong,axiom,
    ! [C: $tType,B: $tType,D: $tType,A: $tType,E4: $tType,F2: B > A,G: C > B,X: C,F5: D > A,G4: E4 > D,X6: E4] :
      ( ( ( F2 @ ( G @ X ) )
        = ( F5 @ ( G4 @ X6 ) ) )
     => ( ( comp @ B @ A @ C @ F2 @ G @ X )
        = ( comp @ D @ A @ E4 @ F5 @ G4 @ X6 ) ) ) ).

% comp_cong
thf(fact_4792_sum__comp__morphism,axiom,
    ! [A: $tType,B: $tType,C: $tType] :
      ( ( ( comm_monoid_add @ B )
        & ( comm_monoid_add @ A ) )
     => ! [H2: B > A,G: C > B,A4: set @ C] :
          ( ( ( H2 @ ( zero_zero @ B ) )
            = ( zero_zero @ A ) )
         => ( ! [X3: B,Y5: B] :
                ( ( H2 @ ( plus_plus @ B @ X3 @ Y5 ) )
                = ( plus_plus @ A @ ( H2 @ X3 ) @ ( H2 @ Y5 ) ) )
           => ( ( groups7311177749621191930dd_sum @ C @ A @ ( comp @ B @ A @ C @ H2 @ G ) @ A4 )
              = ( H2 @ ( groups7311177749621191930dd_sum @ C @ B @ G @ A4 ) ) ) ) ) ) ).

% sum_comp_morphism
thf(fact_4793_bounded__linear__axioms__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ( ( real_V4916620083959148203axioms @ A @ B )
        = ( ^ [F3: A > B] :
            ? [K7: real] :
            ! [X2: A] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ B @ ( F3 @ X2 ) ) @ ( times_times @ real @ ( real_V7770717601297561774m_norm @ A @ X2 ) @ K7 ) ) ) ) ) ).

% bounded_linear_axioms_def
thf(fact_4794_bounded__linear__axioms_Ointro,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F2: A > B] :
          ( ? [K8: real] :
            ! [X3: A] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ B @ ( F2 @ X3 ) ) @ ( times_times @ real @ ( real_V7770717601297561774m_norm @ A @ X3 ) @ K8 ) )
         => ( real_V4916620083959148203axioms @ A @ B @ F2 ) ) ) ).

% bounded_linear_axioms.intro
thf(fact_4795_horner__sum__eq__sum__funpow,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_semiring_0 @ A )
     => ( ( groups4207007520872428315er_sum @ B @ A )
        = ( ^ [F3: B > A,A3: A,Xs3: list @ B] :
              ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [N3: nat] : ( compow @ ( A > A ) @ N3 @ ( times_times @ A @ A3 ) @ ( F3 @ ( nth @ B @ Xs3 @ N3 ) ) )
              @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( size_size @ ( list @ B ) @ Xs3 ) ) ) ) ) ) ).

% horner_sum_eq_sum_funpow
thf(fact_4796_Suc__funpow,axiom,
    ! [N: nat] :
      ( ( compow @ ( nat > nat ) @ N @ suc )
      = ( plus_plus @ nat @ N ) ) ).

% Suc_funpow
thf(fact_4797_funpow__0,axiom,
    ! [A: $tType,F2: A > A,X: A] :
      ( ( compow @ ( A > A ) @ ( zero_zero @ nat ) @ F2 @ X )
      = X ) ).

% funpow_0
thf(fact_4798_comp__funpow,axiom,
    ! [B: $tType,A: $tType,N: nat,F2: A > A] :
      ( ( compow @ ( ( B > A ) > B > A ) @ N @ ( comp @ A @ A @ B @ F2 ) )
      = ( comp @ A @ A @ B @ ( compow @ ( A > A ) @ N @ F2 ) ) ) ).

% comp_funpow
thf(fact_4799_funpow__swap1,axiom,
    ! [A: $tType,F2: A > A,N: nat,X: A] :
      ( ( F2 @ ( compow @ ( A > A ) @ N @ F2 @ X ) )
      = ( compow @ ( A > A ) @ N @ F2 @ ( F2 @ X ) ) ) ).

% funpow_swap1
thf(fact_4800_funpow__mult,axiom,
    ! [A: $tType,N: nat,M: nat,F2: A > A] :
      ( ( compow @ ( A > A ) @ N @ ( compow @ ( A > A ) @ M @ F2 ) )
      = ( compow @ ( A > A ) @ ( times_times @ nat @ M @ N ) @ F2 ) ) ).

% funpow_mult
thf(fact_4801_bij__betw__funpow,axiom,
    ! [A: $tType,F2: A > A,S: set @ A,N: nat] :
      ( ( bij_betw @ A @ A @ F2 @ S @ S )
     => ( bij_betw @ A @ A @ ( compow @ ( A > A ) @ N @ F2 ) @ S @ S ) ) ).

% bij_betw_funpow
thf(fact_4802_funpow__times__power,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ! [F2: A > nat,X: A] :
          ( ( compow @ ( A > A ) @ ( F2 @ X ) @ ( times_times @ A @ X ) )
          = ( times_times @ A @ ( power_power @ A @ X @ ( F2 @ X ) ) ) ) ) ).

% funpow_times_power
thf(fact_4803_funpow__Suc__right,axiom,
    ! [A: $tType,N: nat,F2: A > A] :
      ( ( compow @ ( A > A ) @ ( suc @ N ) @ F2 )
      = ( comp @ A @ A @ A @ ( compow @ ( A > A ) @ N @ F2 ) @ F2 ) ) ).

% funpow_Suc_right
thf(fact_4804_funpow_Osimps_I2_J,axiom,
    ! [A: $tType,N: nat,F2: A > A] :
      ( ( compow @ ( A > A ) @ ( suc @ N ) @ F2 )
      = ( comp @ A @ A @ A @ F2 @ ( compow @ ( A > A ) @ N @ F2 ) ) ) ).

% funpow.simps(2)
thf(fact_4805_funpow__add,axiom,
    ! [A: $tType,M: nat,N: nat,F2: A > A] :
      ( ( compow @ ( A > A ) @ ( plus_plus @ nat @ M @ N ) @ F2 )
      = ( comp @ A @ A @ A @ ( compow @ ( A > A ) @ M @ F2 ) @ ( compow @ ( A > A ) @ N @ F2 ) ) ) ).

% funpow_add
thf(fact_4806_bit__drop__bit__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [N: nat,A2: A] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( bit_se4197421643247451524op_bit @ A @ N @ A2 ) )
          = ( comp @ nat @ $o @ nat @ ( bit_se5641148757651400278ts_bit @ A @ A2 ) @ ( plus_plus @ nat @ N ) ) ) ) ).

% bit_drop_bit_eq
thf(fact_4807_of__nat__def,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ( ( semiring_1_of_nat @ A )
        = ( ^ [N3: nat] : ( compow @ ( A > A ) @ N3 @ ( plus_plus @ A @ ( one_one @ A ) ) @ ( zero_zero @ A ) ) ) ) ) ).

% of_nat_def
thf(fact_4808_numeral__add__unfold__funpow,axiom,
    ! [A: $tType] :
      ( ( semiring_numeral @ A )
     => ! [K: num,A2: A] :
          ( ( plus_plus @ A @ ( numeral_numeral @ A @ K ) @ A2 )
          = ( compow @ ( A > A ) @ ( numeral_numeral @ nat @ K ) @ ( plus_plus @ A @ ( one_one @ A ) ) @ A2 ) ) ) ).

% numeral_add_unfold_funpow
thf(fact_4809_numeral__unfold__funpow,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ( ( numeral_numeral @ A )
        = ( ^ [K3: num] : ( compow @ ( A > A ) @ ( numeral_numeral @ nat @ K3 ) @ ( plus_plus @ A @ ( one_one @ A ) ) @ ( zero_zero @ A ) ) ) ) ) ).

% numeral_unfold_funpow
thf(fact_4810_sum_OatLeast0__atMost__Suc__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ ( suc @ N ) ) )
          = ( plus_plus @ A @ ( G @ ( zero_zero @ nat ) ) @ ( groups7311177749621191930dd_sum @ nat @ A @ ( comp @ nat @ A @ nat @ G @ suc ) @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N ) ) ) ) ) ).

% sum.atLeast0_atMost_Suc_shift
thf(fact_4811_sum_OatLeast0__lessThan__Suc__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( suc @ N ) ) )
          = ( plus_plus @ A @ ( G @ ( zero_zero @ nat ) ) @ ( groups7311177749621191930dd_sum @ nat @ A @ ( comp @ nat @ A @ nat @ G @ suc ) @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N ) ) ) ) ) ).

% sum.atLeast0_lessThan_Suc_shift
thf(fact_4812_prod_OatLeast0__atMost__Suc__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,N: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ ( suc @ N ) ) )
          = ( times_times @ A @ ( G @ ( zero_zero @ nat ) ) @ ( groups7121269368397514597t_prod @ nat @ A @ ( comp @ nat @ A @ nat @ G @ suc ) @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N ) ) ) ) ) ).

% prod.atLeast0_atMost_Suc_shift
thf(fact_4813_prod_OatLeast0__lessThan__Suc__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,N: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( suc @ N ) ) )
          = ( times_times @ A @ ( G @ ( zero_zero @ nat ) ) @ ( groups7121269368397514597t_prod @ nat @ A @ ( comp @ nat @ A @ nat @ G @ suc ) @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N ) ) ) ) ) ).

% prod.atLeast0_lessThan_Suc_shift
thf(fact_4814_sum_OatLeastLessThan__shift__0,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,M: nat,N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ M @ N ) )
          = ( groups7311177749621191930dd_sum @ nat @ A @ ( comp @ nat @ A @ nat @ G @ ( plus_plus @ nat @ M ) ) @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( minus_minus @ nat @ N @ M ) ) ) ) ) ).

% sum.atLeastLessThan_shift_0
thf(fact_4815_prod_OatLeastLessThan__shift__0,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,M: nat,N: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ M @ N ) )
          = ( groups7121269368397514597t_prod @ nat @ A @ ( comp @ nat @ A @ nat @ G @ ( plus_plus @ nat @ M ) ) @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( minus_minus @ nat @ N @ M ) ) ) ) ) ).

% prod.atLeastLessThan_shift_0
thf(fact_4816_sum_OatLeast__atMost__pred__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,M: nat,N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ( comp @ nat @ A @ nat @ G
              @ ^ [N3: nat] : ( minus_minus @ nat @ N3 @ ( suc @ ( zero_zero @ nat ) ) ) )
            @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ M ) @ ( suc @ N ) ) )
          = ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) ) ) ) ).

% sum.atLeast_atMost_pred_shift
thf(fact_4817_sum_OatLeast__lessThan__pred__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: nat > A,M: nat,N: nat] :
          ( ( groups7311177749621191930dd_sum @ nat @ A
            @ ( comp @ nat @ A @ nat @ G
              @ ^ [N3: nat] : ( minus_minus @ nat @ N3 @ ( suc @ ( zero_zero @ nat ) ) ) )
            @ ( set_or7035219750837199246ssThan @ nat @ ( suc @ M ) @ ( suc @ N ) ) )
          = ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ M @ N ) ) ) ) ).

% sum.atLeast_lessThan_pred_shift
thf(fact_4818_prod_OatLeast__atMost__pred__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,M: nat,N: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A
            @ ( comp @ nat @ A @ nat @ G
              @ ^ [N3: nat] : ( minus_minus @ nat @ N3 @ ( suc @ ( zero_zero @ nat ) ) ) )
            @ ( set_or1337092689740270186AtMost @ nat @ ( suc @ M ) @ ( suc @ N ) ) )
          = ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) ) ) ) ).

% prod.atLeast_atMost_pred_shift
thf(fact_4819_prod_OatLeast__lessThan__pred__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: nat > A,M: nat,N: nat] :
          ( ( groups7121269368397514597t_prod @ nat @ A
            @ ( comp @ nat @ A @ nat @ G
              @ ^ [N3: nat] : ( minus_minus @ nat @ N3 @ ( suc @ ( zero_zero @ nat ) ) ) )
            @ ( set_or7035219750837199246ssThan @ nat @ ( suc @ M ) @ ( suc @ N ) ) )
          = ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or7035219750837199246ssThan @ nat @ M @ N ) ) ) ) ).

% prod.atLeast_lessThan_pred_shift
thf(fact_4820_sum_OatLeast__int__atMost__int__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: int > A,M: nat,N: nat] :
          ( ( groups7311177749621191930dd_sum @ int @ A @ G @ ( set_or1337092689740270186AtMost @ int @ ( semiring_1_of_nat @ int @ M ) @ ( semiring_1_of_nat @ int @ N ) ) )
          = ( groups7311177749621191930dd_sum @ nat @ A @ ( comp @ int @ A @ nat @ G @ ( semiring_1_of_nat @ int ) ) @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) ) ) ) ).

% sum.atLeast_int_atMost_int_shift
thf(fact_4821_prod_OatLeast__int__atMost__int__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: int > A,M: nat,N: nat] :
          ( ( groups7121269368397514597t_prod @ int @ A @ G @ ( set_or1337092689740270186AtMost @ int @ ( semiring_1_of_nat @ int @ M ) @ ( semiring_1_of_nat @ int @ N ) ) )
          = ( groups7121269368397514597t_prod @ nat @ A @ ( comp @ int @ A @ nat @ G @ ( semiring_1_of_nat @ int ) ) @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) ) ) ) ).

% prod.atLeast_int_atMost_int_shift
thf(fact_4822_sum_OatLeast__int__lessThan__int__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [G: int > A,M: nat,N: nat] :
          ( ( groups7311177749621191930dd_sum @ int @ A @ G @ ( set_or7035219750837199246ssThan @ int @ ( semiring_1_of_nat @ int @ M ) @ ( semiring_1_of_nat @ int @ N ) ) )
          = ( groups7311177749621191930dd_sum @ nat @ A @ ( comp @ int @ A @ nat @ G @ ( semiring_1_of_nat @ int ) ) @ ( set_or7035219750837199246ssThan @ nat @ M @ N ) ) ) ) ).

% sum.atLeast_int_lessThan_int_shift
thf(fact_4823_sum_OatLeastAtMost__shift__0,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [M: nat,N: nat,G: nat > A] :
          ( ( ord_less_eq @ nat @ M @ N )
         => ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) )
            = ( groups7311177749621191930dd_sum @ nat @ A @ ( comp @ nat @ A @ nat @ G @ ( plus_plus @ nat @ M ) ) @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ ( minus_minus @ nat @ N @ M ) ) ) ) ) ) ).

% sum.atLeastAtMost_shift_0
thf(fact_4824_prod_OatLeastAtMost__shift__0,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [M: nat,N: nat,G: nat > A] :
          ( ( ord_less_eq @ nat @ M @ N )
         => ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) )
            = ( groups7121269368397514597t_prod @ nat @ A @ ( comp @ nat @ A @ nat @ G @ ( plus_plus @ nat @ M ) ) @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ ( minus_minus @ nat @ N @ M ) ) ) ) ) ) ).

% prod.atLeastAtMost_shift_0
thf(fact_4825_prod_OatLeast__int__lessThan__int__shift,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [G: int > A,M: nat,N: nat] :
          ( ( groups7121269368397514597t_prod @ int @ A @ G @ ( set_or7035219750837199246ssThan @ int @ ( semiring_1_of_nat @ int @ M ) @ ( semiring_1_of_nat @ int @ N ) ) )
          = ( groups7121269368397514597t_prod @ nat @ A @ ( comp @ int @ A @ nat @ G @ ( semiring_1_of_nat @ int ) ) @ ( set_or7035219750837199246ssThan @ nat @ M @ N ) ) ) ) ).

% prod.atLeast_int_lessThan_int_shift
thf(fact_4826_Code__Target__Int_Onegative__def,axiom,
    ( code_Target_negative
    = ( comp @ int @ int @ num @ ( uminus_uminus @ int ) @ ( numeral_numeral @ int ) ) ) ).

% Code_Target_Int.negative_def
thf(fact_4827_relpowp__fun__conv,axiom,
    ! [A: $tType] :
      ( ( compow @ ( A > A > $o ) )
      = ( ^ [N3: nat,P3: A > A > $o,X2: A,Y4: A] :
          ? [F3: nat > A] :
            ( ( ( F3 @ ( zero_zero @ nat ) )
              = X2 )
            & ( ( F3 @ N3 )
              = Y4 )
            & ! [I4: nat] :
                ( ( ord_less @ nat @ I4 @ N3 )
               => ( P3 @ ( F3 @ I4 ) @ ( F3 @ ( suc @ I4 ) ) ) ) ) ) ) ).

% relpowp_fun_conv
thf(fact_4828_Nat_Ofunpow__code__def,axiom,
    ! [A: $tType] :
      ( ( funpow @ A )
      = ( compow @ ( A > A ) ) ) ).

% Nat.funpow_code_def
thf(fact_4829_relpowp_Osimps_I1_J,axiom,
    ! [A: $tType,R4: A > A > $o] :
      ( ( compow @ ( A > A > $o ) @ ( zero_zero @ nat ) @ R4 )
      = ( ^ [Y3: A,Z2: A] : ( Y3 = Z2 ) ) ) ).

% relpowp.simps(1)
thf(fact_4830_relpowp__0__E,axiom,
    ! [A: $tType,P: A > A > $o,X: A,Y: A] :
      ( ( compow @ ( A > A > $o ) @ ( zero_zero @ nat ) @ P @ X @ Y )
     => ( X = Y ) ) ).

% relpowp_0_E
thf(fact_4831_relpowp__0__I,axiom,
    ! [A: $tType,P: A > A > $o,X: A] : ( compow @ ( A > A > $o ) @ ( zero_zero @ nat ) @ P @ X @ X ) ).

% relpowp_0_I
thf(fact_4832_relpowp__E2,axiom,
    ! [A: $tType,N: nat,P: A > A > $o,X: A,Z: A] :
      ( ( compow @ ( A > A > $o ) @ N @ P @ X @ Z )
     => ( ( ( N
            = ( zero_zero @ nat ) )
         => ( X != Z ) )
       => ~ ! [Y5: A,M4: nat] :
              ( ( N
                = ( suc @ M4 ) )
             => ( ( P @ X @ Y5 )
               => ~ ( compow @ ( A > A > $o ) @ M4 @ P @ Y5 @ Z ) ) ) ) ) ).

% relpowp_E2
thf(fact_4833_relpowp__E,axiom,
    ! [A: $tType,N: nat,P: A > A > $o,X: A,Z: A] :
      ( ( compow @ ( A > A > $o ) @ N @ P @ X @ Z )
     => ( ( ( N
            = ( zero_zero @ nat ) )
         => ( X != Z ) )
       => ~ ! [Y5: A,M4: nat] :
              ( ( N
                = ( suc @ M4 ) )
             => ( ( compow @ ( A > A > $o ) @ M4 @ P @ X @ Y5 )
               => ~ ( P @ Y5 @ Z ) ) ) ) ) ).

% relpowp_E
thf(fact_4834_relpowp__bot,axiom,
    ! [A: $tType,N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( compow @ ( A > A > $o ) @ N @ ( bot_bot @ ( A > A > $o ) ) )
        = ( bot_bot @ ( A > A > $o ) ) ) ) ).

% relpowp_bot
thf(fact_4835_max__nat_Osemilattice__neutr__order__axioms,axiom,
    ( semila1105856199041335345_order @ nat @ ( ord_max @ nat ) @ ( zero_zero @ nat )
    @ ^ [X2: nat,Y4: nat] : ( ord_less_eq @ nat @ Y4 @ X2 )
    @ ^ [X2: nat,Y4: nat] : ( ord_less @ nat @ Y4 @ X2 ) ) ).

% max_nat.semilattice_neutr_order_axioms
thf(fact_4836_bit_Oabstract__boolean__algebra__axioms,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( boolea2506097494486148201lgebra @ A @ ( bit_se5824344872417868541ns_and @ A ) @ ( bit_se1065995026697491101ons_or @ A ) @ ( bit_ri4277139882892585799ns_not @ A ) @ ( zero_zero @ A ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% bit.abstract_boolean_algebra_axioms
thf(fact_4837_arg__min__if__finite_I2_J,axiom,
    ! [B: $tType,A: $tType] :
      ( ( order @ B )
     => ! [S: set @ A,F2: A > B] :
          ( ( finite_finite @ A @ S )
         => ( ( S
             != ( bot_bot @ ( set @ A ) ) )
           => ~ ? [X5: A] :
                  ( ( member @ A @ X5 @ S )
                  & ( ord_less @ B @ ( F2 @ X5 ) @ ( F2 @ ( lattic7623131987881927897min_on @ A @ B @ F2 @ S ) ) ) ) ) ) ) ).

% arg_min_if_finite(2)
thf(fact_4838_semilattice__neutr__order_Oeq__neutr__iff,axiom,
    ! [A: $tType,F2: A > A > A,Z: A,Less_eq: A > A > $o,Less: A > A > $o,A2: A,B2: A] :
      ( ( semila1105856199041335345_order @ A @ F2 @ Z @ Less_eq @ Less )
     => ( ( ( F2 @ A2 @ B2 )
          = Z )
        = ( ( A2 = Z )
          & ( B2 = Z ) ) ) ) ).

% semilattice_neutr_order.eq_neutr_iff
thf(fact_4839_semilattice__neutr__order_Oneutr__eq__iff,axiom,
    ! [A: $tType,F2: A > A > A,Z: A,Less_eq: A > A > $o,Less: A > A > $o,A2: A,B2: A] :
      ( ( semila1105856199041335345_order @ A @ F2 @ Z @ Less_eq @ Less )
     => ( ( Z
          = ( F2 @ A2 @ B2 ) )
        = ( ( A2 = Z )
          & ( B2 = Z ) ) ) ) ).

% semilattice_neutr_order.neutr_eq_iff
thf(fact_4840_bot2E,axiom,
    ! [A: $tType,B: $tType,X: A,Y: B] :
      ~ ( bot_bot @ ( A > B > $o ) @ X @ Y ) ).

% bot2E
thf(fact_4841_arg__min__if__finite_I1_J,axiom,
    ! [B: $tType,A: $tType] :
      ( ( order @ B )
     => ! [S: set @ A,F2: A > B] :
          ( ( finite_finite @ A @ S )
         => ( ( S
             != ( bot_bot @ ( set @ A ) ) )
           => ( member @ A @ ( lattic7623131987881927897min_on @ A @ B @ F2 @ S ) @ S ) ) ) ) ).

% arg_min_if_finite(1)
thf(fact_4842_arg__min__least,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linorder @ B )
     => ! [S: set @ A,Y: A,F2: A > B] :
          ( ( finite_finite @ A @ S )
         => ( ( S
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( member @ A @ Y @ S )
             => ( ord_less_eq @ B @ ( F2 @ ( lattic7623131987881927897min_on @ A @ B @ F2 @ S ) ) @ ( F2 @ Y ) ) ) ) ) ) ).

% arg_min_least
thf(fact_4843_times__int_Oabs__eq,axiom,
    ! [Xa: product_prod @ nat @ nat,X: product_prod @ nat @ nat] :
      ( ( times_times @ int @ ( abs_Integ @ Xa ) @ ( abs_Integ @ X ) )
      = ( abs_Integ
        @ ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) )
          @ ^ [X2: nat,Y4: nat] :
              ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
              @ ^ [U2: nat,V5: nat] : ( product_Pair @ nat @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ X2 @ U2 ) @ ( times_times @ nat @ Y4 @ V5 ) ) @ ( plus_plus @ nat @ ( times_times @ nat @ X2 @ V5 ) @ ( times_times @ nat @ Y4 @ U2 ) ) ) )
          @ Xa
          @ X ) ) ) ).

% times_int.abs_eq
thf(fact_4844_Gcd__remove0__nat,axiom,
    ! [M5: set @ nat] :
      ( ( finite_finite @ nat @ M5 )
     => ( ( gcd_Gcd @ nat @ M5 )
        = ( gcd_Gcd @ nat @ ( minus_minus @ ( set @ nat ) @ M5 @ ( insert @ nat @ ( zero_zero @ nat ) @ ( bot_bot @ ( set @ nat ) ) ) ) ) ) ) ).

% Gcd_remove0_nat
thf(fact_4845_eq__numeral__iff__iszero_I8_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [Y: num] :
          ( ( ( one_one @ A )
            = ( uminus_uminus @ A @ ( numeral_numeral @ A @ Y ) ) )
          = ( ring_1_iszero @ A @ ( numeral_numeral @ A @ ( plus_plus @ num @ one2 @ Y ) ) ) ) ) ).

% eq_numeral_iff_iszero(8)
thf(fact_4846_Gcd__empty,axiom,
    ! [A: $tType] :
      ( ( semiring_Gcd @ A )
     => ( ( gcd_Gcd @ A @ ( bot_bot @ ( set @ A ) ) )
        = ( zero_zero @ A ) ) ) ).

% Gcd_empty
thf(fact_4847_iszero__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [W: num] :
          ( ( ring_1_iszero @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) )
          = ( ring_1_iszero @ A @ ( numeral_numeral @ A @ W ) ) ) ) ).

% iszero_neg_numeral
thf(fact_4848_Gcd__0__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_Gcd @ A )
     => ! [A4: set @ A] :
          ( ( ( gcd_Gcd @ A @ A4 )
            = ( zero_zero @ A ) )
          = ( ord_less_eq @ ( set @ A ) @ A4 @ ( insert @ A @ ( zero_zero @ A ) @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% Gcd_0_iff
thf(fact_4849_not__iszero__numeral,axiom,
    ! [A: $tType] :
      ( ( ring_char_0 @ A )
     => ! [W: num] :
          ~ ( ring_1_iszero @ A @ ( numeral_numeral @ A @ W ) ) ) ).

% not_iszero_numeral
thf(fact_4850_not__iszero__1,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ~ ( ring_1_iszero @ A @ ( one_one @ A ) ) ) ).

% not_iszero_1
thf(fact_4851_eq__iff__iszero__diff,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ( ( ^ [Y3: A,Z2: A] : ( Y3 = Z2 ) )
        = ( ^ [X2: A,Y4: A] : ( ring_1_iszero @ A @ ( minus_minus @ A @ X2 @ Y4 ) ) ) ) ) ).

% eq_iff_iszero_diff
thf(fact_4852_int_Oabs__induct,axiom,
    ! [P: int > $o,X: int] :
      ( ! [Y5: product_prod @ nat @ nat] : ( P @ ( abs_Integ @ Y5 ) )
     => ( P @ X ) ) ).

% int.abs_induct
thf(fact_4853_iszero__def,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ( ( ring_1_iszero @ A )
        = ( ^ [Z6: A] :
              ( Z6
              = ( zero_zero @ A ) ) ) ) ) ).

% iszero_def
thf(fact_4854_iszero__0,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ( ring_1_iszero @ A @ ( zero_zero @ A ) ) ) ).

% iszero_0
thf(fact_4855_eq__Abs__Integ,axiom,
    ! [Z: int] :
      ~ ! [X3: nat,Y5: nat] :
          ( Z
         != ( abs_Integ @ ( product_Pair @ nat @ nat @ X3 @ Y5 ) ) ) ).

% eq_Abs_Integ
thf(fact_4856_nat_Oabs__eq,axiom,
    ! [X: product_prod @ nat @ nat] :
      ( ( nat2 @ ( abs_Integ @ X ) )
      = ( product_case_prod @ nat @ nat @ nat @ ( minus_minus @ nat ) @ X ) ) ).

% nat.abs_eq
thf(fact_4857_eq__numeral__iff__iszero_I10_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [Y: num] :
          ( ( ( zero_zero @ A )
            = ( numeral_numeral @ A @ Y ) )
          = ( ring_1_iszero @ A @ ( numeral_numeral @ A @ Y ) ) ) ) ).

% eq_numeral_iff_iszero(10)
thf(fact_4858_eq__numeral__iff__iszero_I9_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [X: num] :
          ( ( ( numeral_numeral @ A @ X )
            = ( zero_zero @ A ) )
          = ( ring_1_iszero @ A @ ( numeral_numeral @ A @ X ) ) ) ) ).

% eq_numeral_iff_iszero(9)
thf(fact_4859_not__iszero__Numeral1,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ~ ( ring_1_iszero @ A @ ( numeral_numeral @ A @ one2 ) ) ) ).

% not_iszero_Numeral1
thf(fact_4860_not__iszero__neg__1,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ~ ( ring_1_iszero @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% not_iszero_neg_1
thf(fact_4861_eq__numeral__iff__iszero_I1_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [X: num,Y: num] :
          ( ( ( numeral_numeral @ A @ X )
            = ( numeral_numeral @ A @ Y ) )
          = ( ring_1_iszero @ A @ ( neg_numeral_sub @ A @ X @ Y ) ) ) ) ).

% eq_numeral_iff_iszero(1)
thf(fact_4862_zero__int__def,axiom,
    ( ( zero_zero @ int )
    = ( abs_Integ @ ( product_Pair @ nat @ nat @ ( zero_zero @ nat ) @ ( zero_zero @ nat ) ) ) ) ).

% zero_int_def
thf(fact_4863_int__def,axiom,
    ( ( semiring_1_of_nat @ int )
    = ( ^ [N3: nat] : ( abs_Integ @ ( product_Pair @ nat @ nat @ N3 @ ( zero_zero @ nat ) ) ) ) ) ).

% int_def
thf(fact_4864_eq__numeral__iff__iszero_I11_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [X: num] :
          ( ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ X ) )
            = ( zero_zero @ A ) )
          = ( ring_1_iszero @ A @ ( numeral_numeral @ A @ X ) ) ) ) ).

% eq_numeral_iff_iszero(11)
thf(fact_4865_eq__numeral__iff__iszero_I12_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [Y: num] :
          ( ( ( zero_zero @ A )
            = ( uminus_uminus @ A @ ( numeral_numeral @ A @ Y ) ) )
          = ( ring_1_iszero @ A @ ( numeral_numeral @ A @ Y ) ) ) ) ).

% eq_numeral_iff_iszero(12)
thf(fact_4866_not__iszero__neg__Numeral1,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ~ ( ring_1_iszero @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ one2 ) ) ) ) ).

% not_iszero_neg_Numeral1
thf(fact_4867_eq__numeral__iff__iszero_I3_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [X: num,Y: num] :
          ( ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ X ) )
            = ( numeral_numeral @ A @ Y ) )
          = ( ring_1_iszero @ A @ ( numeral_numeral @ A @ ( plus_plus @ num @ X @ Y ) ) ) ) ) ).

% eq_numeral_iff_iszero(3)
thf(fact_4868_eq__numeral__iff__iszero_I2_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [X: num,Y: num] :
          ( ( ( numeral_numeral @ A @ X )
            = ( uminus_uminus @ A @ ( numeral_numeral @ A @ Y ) ) )
          = ( ring_1_iszero @ A @ ( numeral_numeral @ A @ ( plus_plus @ num @ X @ Y ) ) ) ) ) ).

% eq_numeral_iff_iszero(2)
thf(fact_4869_eq__numeral__iff__iszero_I4_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [X: num,Y: num] :
          ( ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ X ) )
            = ( uminus_uminus @ A @ ( numeral_numeral @ A @ Y ) ) )
          = ( ring_1_iszero @ A @ ( neg_numeral_sub @ A @ Y @ X ) ) ) ) ).

% eq_numeral_iff_iszero(4)
thf(fact_4870_uminus__int_Oabs__eq,axiom,
    ! [X: product_prod @ nat @ nat] :
      ( ( uminus_uminus @ int @ ( abs_Integ @ X ) )
      = ( abs_Integ
        @ ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
          @ ^ [X2: nat,Y4: nat] : ( product_Pair @ nat @ nat @ Y4 @ X2 )
          @ X ) ) ) ).

% uminus_int.abs_eq
thf(fact_4871_one__int__def,axiom,
    ( ( one_one @ int )
    = ( abs_Integ @ ( product_Pair @ nat @ nat @ ( one_one @ nat ) @ ( zero_zero @ nat ) ) ) ) ).

% one_int_def
thf(fact_4872_of__int_Oabs__eq,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [X: product_prod @ nat @ nat] :
          ( ( ring_1_of_int @ A @ ( abs_Integ @ X ) )
          = ( product_case_prod @ nat @ nat @ A
            @ ^ [I4: nat,J3: nat] : ( minus_minus @ A @ ( semiring_1_of_nat @ A @ I4 ) @ ( semiring_1_of_nat @ A @ J3 ) )
            @ X ) ) ) ).

% of_int.abs_eq
thf(fact_4873_less__int_Oabs__eq,axiom,
    ! [Xa: product_prod @ nat @ nat,X: product_prod @ nat @ nat] :
      ( ( ord_less @ int @ ( abs_Integ @ Xa ) @ ( abs_Integ @ X ) )
      = ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > $o )
        @ ^ [X2: nat,Y4: nat] :
            ( product_case_prod @ nat @ nat @ $o
            @ ^ [U2: nat,V5: nat] : ( ord_less @ nat @ ( plus_plus @ nat @ X2 @ V5 ) @ ( plus_plus @ nat @ U2 @ Y4 ) ) )
        @ Xa
        @ X ) ) ).

% less_int.abs_eq
thf(fact_4874_less__eq__int_Oabs__eq,axiom,
    ! [Xa: product_prod @ nat @ nat,X: product_prod @ nat @ nat] :
      ( ( ord_less_eq @ int @ ( abs_Integ @ Xa ) @ ( abs_Integ @ X ) )
      = ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > $o )
        @ ^ [X2: nat,Y4: nat] :
            ( product_case_prod @ nat @ nat @ $o
            @ ^ [U2: nat,V5: nat] : ( ord_less_eq @ nat @ ( plus_plus @ nat @ X2 @ V5 ) @ ( plus_plus @ nat @ U2 @ Y4 ) ) )
        @ Xa
        @ X ) ) ).

% less_eq_int.abs_eq
thf(fact_4875_eq__numeral__iff__iszero_I5_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [X: num] :
          ( ( ( numeral_numeral @ A @ X )
            = ( one_one @ A ) )
          = ( ring_1_iszero @ A @ ( neg_numeral_sub @ A @ X @ one2 ) ) ) ) ).

% eq_numeral_iff_iszero(5)
thf(fact_4876_eq__numeral__iff__iszero_I6_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [Y: num] :
          ( ( ( one_one @ A )
            = ( numeral_numeral @ A @ Y ) )
          = ( ring_1_iszero @ A @ ( neg_numeral_sub @ A @ one2 @ Y ) ) ) ) ).

% eq_numeral_iff_iszero(6)
thf(fact_4877_plus__int_Oabs__eq,axiom,
    ! [Xa: product_prod @ nat @ nat,X: product_prod @ nat @ nat] :
      ( ( plus_plus @ int @ ( abs_Integ @ Xa ) @ ( abs_Integ @ X ) )
      = ( abs_Integ
        @ ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) )
          @ ^ [X2: nat,Y4: nat] :
              ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
              @ ^ [U2: nat,V5: nat] : ( product_Pair @ nat @ nat @ ( plus_plus @ nat @ X2 @ U2 ) @ ( plus_plus @ nat @ Y4 @ V5 ) ) )
          @ Xa
          @ X ) ) ) ).

% plus_int.abs_eq
thf(fact_4878_minus__int_Oabs__eq,axiom,
    ! [Xa: product_prod @ nat @ nat,X: product_prod @ nat @ nat] :
      ( ( minus_minus @ int @ ( abs_Integ @ Xa ) @ ( abs_Integ @ X ) )
      = ( abs_Integ
        @ ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) )
          @ ^ [X2: nat,Y4: nat] :
              ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
              @ ^ [U2: nat,V5: nat] : ( product_Pair @ nat @ nat @ ( plus_plus @ nat @ X2 @ V5 ) @ ( plus_plus @ nat @ Y4 @ U2 ) ) )
          @ Xa
          @ X ) ) ) ).

% minus_int.abs_eq
thf(fact_4879_eq__numeral__iff__iszero_I7_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [X: num] :
          ( ( ( uminus_uminus @ A @ ( numeral_numeral @ A @ X ) )
            = ( one_one @ A ) )
          = ( ring_1_iszero @ A @ ( numeral_numeral @ A @ ( plus_plus @ num @ X @ one2 ) ) ) ) ) ).

% eq_numeral_iff_iszero(7)
thf(fact_4880_semiring__char__def,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ( ( semiri4206861660011772517g_char @ A )
        = ( ^ [Uu4: itself @ A] :
              ( gcd_Gcd @ nat
              @ ( collect @ nat
                @ ^ [N3: nat] :
                    ( ( semiring_1_of_nat @ A @ N3 )
                    = ( zero_zero @ A ) ) ) ) ) ) ) ).

% semiring_char_def
thf(fact_4881_num__of__nat_Osimps_I2_J,axiom,
    ! [N: nat] :
      ( ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
       => ( ( num_of_nat @ ( suc @ N ) )
          = ( inc @ ( num_of_nat @ N ) ) ) )
      & ( ~ ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
       => ( ( num_of_nat @ ( suc @ N ) )
          = one2 ) ) ) ).

% num_of_nat.simps(2)
thf(fact_4882_pow_Osimps_I3_J,axiom,
    ! [X: num,Y: num] :
      ( ( pow @ X @ ( bit1 @ Y ) )
      = ( times_times @ num @ ( sqr @ ( pow @ X @ Y ) ) @ X ) ) ).

% pow.simps(3)
thf(fact_4883_num__of__nat__numeral__eq,axiom,
    ! [Q3: num] :
      ( ( num_of_nat @ ( numeral_numeral @ nat @ Q3 ) )
      = Q3 ) ).

% num_of_nat_numeral_eq
thf(fact_4884_sqr_Osimps_I2_J,axiom,
    ! [N: num] :
      ( ( sqr @ ( bit0 @ N ) )
      = ( bit0 @ ( bit0 @ ( sqr @ N ) ) ) ) ).

% sqr.simps(2)
thf(fact_4885_sqr_Osimps_I1_J,axiom,
    ( ( sqr @ one2 )
    = one2 ) ).

% sqr.simps(1)
thf(fact_4886_Gcd__int__greater__eq__0,axiom,
    ! [K6: set @ int] : ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( gcd_Gcd @ int @ K6 ) ) ).

% Gcd_int_greater_eq_0
thf(fact_4887_sqr__conv__mult,axiom,
    ( sqr
    = ( ^ [X2: num] : ( times_times @ num @ X2 @ X2 ) ) ) ).

% sqr_conv_mult
thf(fact_4888_num__of__nat_Osimps_I1_J,axiom,
    ( ( num_of_nat @ ( zero_zero @ nat ) )
    = one2 ) ).

% num_of_nat.simps(1)
thf(fact_4889_numeral__sqr,axiom,
    ! [A: $tType] :
      ( ( semiring_numeral @ A )
     => ! [K: num] :
          ( ( numeral_numeral @ A @ ( sqr @ K ) )
          = ( times_times @ A @ ( numeral_numeral @ A @ K ) @ ( numeral_numeral @ A @ K ) ) ) ) ).

% numeral_sqr
thf(fact_4890_numeral__num__of__nat,axiom,
    ! [N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( numeral_numeral @ nat @ ( num_of_nat @ N ) )
        = N ) ) ).

% numeral_num_of_nat
thf(fact_4891_num__of__nat__One,axiom,
    ! [N: nat] :
      ( ( ord_less_eq @ nat @ N @ ( one_one @ nat ) )
     => ( ( num_of_nat @ N )
        = one2 ) ) ).

% num_of_nat_One
thf(fact_4892_pow_Osimps_I2_J,axiom,
    ! [X: num,Y: num] :
      ( ( pow @ X @ ( bit0 @ Y ) )
      = ( sqr @ ( pow @ X @ Y ) ) ) ).

% pow.simps(2)
thf(fact_4893_numeral__num__of__nat__unfold,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [N: nat] :
          ( ( ( N
              = ( zero_zero @ nat ) )
           => ( ( numeral_numeral @ A @ ( num_of_nat @ N ) )
              = ( one_one @ A ) ) )
          & ( ( N
             != ( zero_zero @ nat ) )
           => ( ( numeral_numeral @ A @ ( num_of_nat @ N ) )
              = ( semiring_1_of_nat @ A @ N ) ) ) ) ) ).

% numeral_num_of_nat_unfold
thf(fact_4894_num__of__nat__double,axiom,
    ! [N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( num_of_nat @ ( plus_plus @ nat @ N @ N ) )
        = ( bit0 @ ( num_of_nat @ N ) ) ) ) ).

% num_of_nat_double
thf(fact_4895_num__of__nat__plus__distrib,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
       => ( ( num_of_nat @ ( plus_plus @ nat @ M @ N ) )
          = ( plus_plus @ num @ ( num_of_nat @ M ) @ ( num_of_nat @ N ) ) ) ) ) ).

% num_of_nat_plus_distrib
thf(fact_4896_sqr_Osimps_I3_J,axiom,
    ! [N: num] :
      ( ( sqr @ ( bit1 @ N ) )
      = ( bit1 @ ( bit0 @ ( plus_plus @ num @ ( sqr @ N ) @ N ) ) ) ) ).

% sqr.simps(3)
thf(fact_4897_less__eq__int_Orep__eq,axiom,
    ( ( ord_less_eq @ int )
    = ( ^ [X2: int,Xa4: int] :
          ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > $o )
          @ ^ [Y4: nat,Z6: nat] :
              ( product_case_prod @ nat @ nat @ $o
              @ ^ [U2: nat,V5: nat] : ( ord_less_eq @ nat @ ( plus_plus @ nat @ Y4 @ V5 ) @ ( plus_plus @ nat @ U2 @ Z6 ) ) )
          @ ( rep_Integ @ X2 )
          @ ( rep_Integ @ Xa4 ) ) ) ) ).

% less_eq_int.rep_eq
thf(fact_4898_less__int_Orep__eq,axiom,
    ( ( ord_less @ int )
    = ( ^ [X2: int,Xa4: int] :
          ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > $o )
          @ ^ [Y4: nat,Z6: nat] :
              ( product_case_prod @ nat @ nat @ $o
              @ ^ [U2: nat,V5: nat] : ( ord_less @ nat @ ( plus_plus @ nat @ Y4 @ V5 ) @ ( plus_plus @ nat @ U2 @ Z6 ) ) )
          @ ( rep_Integ @ X2 )
          @ ( rep_Integ @ Xa4 ) ) ) ) ).

% less_int.rep_eq
thf(fact_4899_dependent__nat__choice,axiom,
    ! [A: $tType,P: nat > A > $o,Q: nat > A > A > $o] :
      ( ? [X_12: A] : ( P @ ( zero_zero @ nat ) @ X_12 )
     => ( ! [X3: A,N2: nat] :
            ( ( P @ N2 @ X3 )
           => ? [Y6: A] :
                ( ( P @ ( suc @ N2 ) @ Y6 )
                & ( Q @ N2 @ X3 @ Y6 ) ) )
       => ? [F6: nat > A] :
          ! [N7: nat] :
            ( ( P @ N7 @ ( F6 @ N7 ) )
            & ( Q @ N7 @ ( F6 @ N7 ) @ ( F6 @ ( suc @ N7 ) ) ) ) ) ) ).

% dependent_nat_choice
thf(fact_4900_nat_Orep__eq,axiom,
    ( nat2
    = ( ^ [X2: int] : ( product_case_prod @ nat @ nat @ nat @ ( minus_minus @ nat ) @ ( rep_Integ @ X2 ) ) ) ) ).

% nat.rep_eq
thf(fact_4901_of__int_Orep__eq,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ( ( ring_1_of_int @ A )
        = ( ^ [X2: int] :
              ( product_case_prod @ nat @ nat @ A
              @ ^ [I4: nat,J3: nat] : ( minus_minus @ A @ ( semiring_1_of_nat @ A @ I4 ) @ ( semiring_1_of_nat @ A @ J3 ) )
              @ ( rep_Integ @ X2 ) ) ) ) ) ).

% of_int.rep_eq
thf(fact_4902_uminus__int__def,axiom,
    ( ( uminus_uminus @ int )
    = ( map_fun @ int @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ int @ rep_Integ @ abs_Integ
      @ ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
        @ ^ [X2: nat,Y4: nat] : ( product_Pair @ nat @ nat @ Y4 @ X2 ) ) ) ) ).

% uminus_int_def
thf(fact_4903_integer__of__num__triv_I2_J,axiom,
    ( ( code_integer_of_num @ ( bit0 @ one2 ) )
    = ( numeral_numeral @ code_integer @ ( bit0 @ one2 ) ) ) ).

% integer_of_num_triv(2)
thf(fact_4904_length__n__lists,axiom,
    ! [A: $tType,N: nat,Xs: list @ A] :
      ( ( size_size @ ( list @ ( list @ A ) ) @ ( n_lists @ A @ N @ Xs ) )
      = ( power_power @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ N ) ) ).

% length_n_lists
thf(fact_4905_integer__of__num__triv_I1_J,axiom,
    ( ( code_integer_of_num @ one2 )
    = ( one_one @ code_integer ) ) ).

% integer_of_num_triv(1)
thf(fact_4906_integer__of__num_I2_J,axiom,
    ! [N: num] :
      ( ( code_integer_of_num @ ( bit0 @ N ) )
      = ( plus_plus @ code_integer @ ( code_integer_of_num @ N ) @ ( code_integer_of_num @ N ) ) ) ).

% integer_of_num(2)
thf(fact_4907_times__int__def,axiom,
    ( ( times_times @ int )
    = ( map_fun @ int @ ( product_prod @ nat @ nat ) @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) ) @ ( int > int ) @ rep_Integ @ ( map_fun @ int @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ int @ rep_Integ @ abs_Integ )
      @ ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) )
        @ ^ [X2: nat,Y4: nat] :
            ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
            @ ^ [U2: nat,V5: nat] : ( product_Pair @ nat @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ X2 @ U2 ) @ ( times_times @ nat @ Y4 @ V5 ) ) @ ( plus_plus @ nat @ ( times_times @ nat @ X2 @ V5 ) @ ( times_times @ nat @ Y4 @ U2 ) ) ) ) ) ) ) ).

% times_int_def
thf(fact_4908_minus__int__def,axiom,
    ( ( minus_minus @ int )
    = ( map_fun @ int @ ( product_prod @ nat @ nat ) @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) ) @ ( int > int ) @ rep_Integ @ ( map_fun @ int @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ int @ rep_Integ @ abs_Integ )
      @ ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) )
        @ ^ [X2: nat,Y4: nat] :
            ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
            @ ^ [U2: nat,V5: nat] : ( product_Pair @ nat @ nat @ ( plus_plus @ nat @ X2 @ V5 ) @ ( plus_plus @ nat @ Y4 @ U2 ) ) ) ) ) ) ).

% minus_int_def
thf(fact_4909_plus__int__def,axiom,
    ( ( plus_plus @ int )
    = ( map_fun @ int @ ( product_prod @ nat @ nat ) @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) ) @ ( int > int ) @ rep_Integ @ ( map_fun @ int @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ int @ rep_Integ @ abs_Integ )
      @ ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) )
        @ ^ [X2: nat,Y4: nat] :
            ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
            @ ^ [U2: nat,V5: nat] : ( product_Pair @ nat @ nat @ ( plus_plus @ nat @ X2 @ U2 ) @ ( plus_plus @ nat @ Y4 @ V5 ) ) ) ) ) ) ).

% plus_int_def
thf(fact_4910_sum__of__bool__eq,axiom,
    ! [A: $tType,B: $tType] :
      ( ( semiring_1 @ A )
     => ! [A4: set @ B,P: B > $o] :
          ( ( finite_finite @ B @ A4 )
         => ( ( finite_finite @ B @ A4 )
           => ( ( groups7311177749621191930dd_sum @ B @ A
                @ ^ [X2: B] : ( zero_neq_one_of_bool @ A @ ( P @ X2 ) )
                @ A4 )
              = ( semiring_1_of_nat @ A @ ( finite_card @ B @ ( inf_inf @ ( set @ B ) @ A4 @ ( collect @ B @ P ) ) ) ) ) ) ) ) ).

% sum_of_bool_eq
thf(fact_4911_image__minus__const__atLeastLessThan__nat,axiom,
    ! [C2: nat,Y: nat,X: nat] :
      ( ( ( ord_less @ nat @ C2 @ Y )
       => ( ( image @ nat @ nat
            @ ^ [I4: nat] : ( minus_minus @ nat @ I4 @ C2 )
            @ ( set_or7035219750837199246ssThan @ nat @ X @ Y ) )
          = ( set_or7035219750837199246ssThan @ nat @ ( minus_minus @ nat @ X @ C2 ) @ ( minus_minus @ nat @ Y @ C2 ) ) ) )
      & ( ~ ( ord_less @ nat @ C2 @ Y )
       => ( ( ( ord_less @ nat @ X @ Y )
           => ( ( image @ nat @ nat
                @ ^ [I4: nat] : ( minus_minus @ nat @ I4 @ C2 )
                @ ( set_or7035219750837199246ssThan @ nat @ X @ Y ) )
              = ( insert @ nat @ ( zero_zero @ nat ) @ ( bot_bot @ ( set @ nat ) ) ) ) )
          & ( ~ ( ord_less @ nat @ X @ Y )
           => ( ( image @ nat @ nat
                @ ^ [I4: nat] : ( minus_minus @ nat @ I4 @ C2 )
                @ ( set_or7035219750837199246ssThan @ nat @ X @ Y ) )
              = ( bot_bot @ ( set @ nat ) ) ) ) ) ) ) ).

% image_minus_const_atLeastLessThan_nat
thf(fact_4912_ring__1__class_Oof__int__def,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ( ( ring_1_of_int @ A )
        = ( map_fun @ int @ ( product_prod @ nat @ nat ) @ A @ A @ rep_Integ @ ( id @ A )
          @ ( product_case_prod @ nat @ nat @ A
            @ ^ [I4: nat,J3: nat] : ( minus_minus @ A @ ( semiring_1_of_nat @ A @ I4 ) @ ( semiring_1_of_nat @ A @ J3 ) ) ) ) ) ) ).

% ring_1_class.of_int_def
thf(fact_4913_inf_Oidem,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A2: A] :
          ( ( inf_inf @ A @ A2 @ A2 )
          = A2 ) ) ).

% inf.idem
thf(fact_4914_inf__idem,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [X: A] :
          ( ( inf_inf @ A @ X @ X )
          = X ) ) ).

% inf_idem
thf(fact_4915_inf_Oleft__idem,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A2: A,B2: A] :
          ( ( inf_inf @ A @ A2 @ ( inf_inf @ A @ A2 @ B2 ) )
          = ( inf_inf @ A @ A2 @ B2 ) ) ) ).

% inf.left_idem
thf(fact_4916_inf__left__idem,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [X: A,Y: A] :
          ( ( inf_inf @ A @ X @ ( inf_inf @ A @ X @ Y ) )
          = ( inf_inf @ A @ X @ Y ) ) ) ).

% inf_left_idem
thf(fact_4917_inf_Oright__idem,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A2: A,B2: A] :
          ( ( inf_inf @ A @ ( inf_inf @ A @ A2 @ B2 ) @ B2 )
          = ( inf_inf @ A @ A2 @ B2 ) ) ) ).

% inf.right_idem
thf(fact_4918_inf__right__idem,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [X: A,Y: A] :
          ( ( inf_inf @ A @ ( inf_inf @ A @ X @ Y ) @ Y )
          = ( inf_inf @ A @ X @ Y ) ) ) ).

% inf_right_idem
thf(fact_4919_inf__apply,axiom,
    ! [B: $tType,A: $tType] :
      ( ( semilattice_inf @ B )
     => ( ( inf_inf @ ( A > B ) )
        = ( ^ [F3: A > B,G2: A > B,X2: A] : ( inf_inf @ B @ ( F3 @ X2 ) @ ( G2 @ X2 ) ) ) ) ) ).

% inf_apply
thf(fact_4920_of__nat__eq__id,axiom,
    ( ( semiring_1_of_nat @ nat )
    = ( id @ nat ) ) ).

% of_nat_eq_id
thf(fact_4921_inf_Obounded__iff,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ ( inf_inf @ A @ B2 @ C2 ) )
          = ( ( ord_less_eq @ A @ A2 @ B2 )
            & ( ord_less_eq @ A @ A2 @ C2 ) ) ) ) ).

% inf.bounded_iff
thf(fact_4922_le__inf__iff,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [X: A,Y: A,Z: A] :
          ( ( ord_less_eq @ A @ X @ ( inf_inf @ A @ Y @ Z ) )
          = ( ( ord_less_eq @ A @ X @ Y )
            & ( ord_less_eq @ A @ X @ Z ) ) ) ) ).

% le_inf_iff
thf(fact_4923_inf__bot__right,axiom,
    ! [A: $tType] :
      ( ( bounded_lattice_bot @ A )
     => ! [X: A] :
          ( ( inf_inf @ A @ X @ ( bot_bot @ A ) )
          = ( bot_bot @ A ) ) ) ).

% inf_bot_right
thf(fact_4924_inf__bot__left,axiom,
    ! [A: $tType] :
      ( ( bounded_lattice_bot @ A )
     => ! [X: A] :
          ( ( inf_inf @ A @ ( bot_bot @ A ) @ X )
          = ( bot_bot @ A ) ) ) ).

% inf_bot_left
thf(fact_4925_id__funpow,axiom,
    ! [A: $tType,N: nat] :
      ( ( compow @ ( A > A ) @ N @ ( id @ A ) )
      = ( id @ A ) ) ).

% id_funpow
thf(fact_4926_bij__betw__Suc,axiom,
    ! [M5: set @ nat,N4: set @ nat] :
      ( ( bij_betw @ nat @ nat @ suc @ M5 @ N4 )
      = ( ( image @ nat @ nat @ suc @ M5 )
        = N4 ) ) ).

% bij_betw_Suc
thf(fact_4927_push__bit__0__id,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se4730199178511100633sh_bit @ A @ ( zero_zero @ nat ) )
        = ( id @ A ) ) ) ).

% push_bit_0_id
thf(fact_4928_drop__bit__0,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( ( bit_se4197421643247451524op_bit @ A @ ( zero_zero @ nat ) )
        = ( id @ A ) ) ) ).

% drop_bit_0
thf(fact_4929_bij__betw__of__nat,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [N4: set @ nat,A4: set @ A] :
          ( ( bij_betw @ nat @ A @ ( semiring_1_of_nat @ A ) @ N4 @ A4 )
          = ( ( image @ nat @ A @ ( semiring_1_of_nat @ A ) @ N4 )
            = A4 ) ) ) ).

% bij_betw_of_nat
thf(fact_4930_image__mult__atLeastAtMost,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [D2: A,A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ D2 )
         => ( ( image @ A @ A @ ( times_times @ A @ D2 ) @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) )
            = ( set_or1337092689740270186AtMost @ A @ ( times_times @ A @ D2 @ A2 ) @ ( times_times @ A @ D2 @ B2 ) ) ) ) ) ).

% image_mult_atLeastAtMost
thf(fact_4931_image__divide__atLeastAtMost,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [D2: A,A2: A,B2: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ D2 )
         => ( ( image @ A @ A
              @ ^ [C4: A] : ( divide_divide @ A @ C4 @ D2 )
              @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) )
            = ( set_or1337092689740270186AtMost @ A @ ( divide_divide @ A @ A2 @ D2 ) @ ( divide_divide @ A @ B2 @ D2 ) ) ) ) ) ).

% image_divide_atLeastAtMost
thf(fact_4932_inf_Ostrict__coboundedI2,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( ord_less @ A @ B2 @ C2 )
         => ( ord_less @ A @ ( inf_inf @ A @ A2 @ B2 ) @ C2 ) ) ) ).

% inf.strict_coboundedI2
thf(fact_4933_inf_Ostrict__coboundedI1,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ C2 )
         => ( ord_less @ A @ ( inf_inf @ A @ A2 @ B2 ) @ C2 ) ) ) ).

% inf.strict_coboundedI1
thf(fact_4934_inf_Ostrict__order__iff,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ( ( ord_less @ A )
        = ( ^ [A3: A,B3: A] :
              ( ( A3
                = ( inf_inf @ A @ A3 @ B3 ) )
              & ( A3 != B3 ) ) ) ) ) ).

% inf.strict_order_iff
thf(fact_4935_inf_Ostrict__boundedE,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less @ A @ A2 @ ( inf_inf @ A @ B2 @ C2 ) )
         => ~ ( ( ord_less @ A @ A2 @ B2 )
             => ~ ( ord_less @ A @ A2 @ C2 ) ) ) ) ).

% inf.strict_boundedE
thf(fact_4936_inf_Oabsorb4,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less @ A @ B2 @ A2 )
         => ( ( inf_inf @ A @ A2 @ B2 )
            = B2 ) ) ) ).

% inf.absorb4
thf(fact_4937_inf_Oabsorb3,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( inf_inf @ A @ A2 @ B2 )
            = A2 ) ) ) ).

% inf.absorb3
thf(fact_4938_less__infI2,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [B2: A,X: A,A2: A] :
          ( ( ord_less @ A @ B2 @ X )
         => ( ord_less @ A @ ( inf_inf @ A @ A2 @ B2 ) @ X ) ) ) ).

% less_infI2
thf(fact_4939_less__infI1,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A2: A,X: A,B2: A] :
          ( ( ord_less @ A @ A2 @ X )
         => ( ord_less @ A @ ( inf_inf @ A @ A2 @ B2 ) @ X ) ) ) ).

% less_infI1
thf(fact_4940_inf__sup__aci_I4_J,axiom,
    ! [A: $tType] :
      ( ( lattice @ A )
     => ! [X: A,Y: A] :
          ( ( inf_inf @ A @ X @ ( inf_inf @ A @ X @ Y ) )
          = ( inf_inf @ A @ X @ Y ) ) ) ).

% inf_sup_aci(4)
thf(fact_4941_inf__sup__aci_I3_J,axiom,
    ! [A: $tType] :
      ( ( lattice @ A )
     => ! [X: A,Y: A,Z: A] :
          ( ( inf_inf @ A @ X @ ( inf_inf @ A @ Y @ Z ) )
          = ( inf_inf @ A @ Y @ ( inf_inf @ A @ X @ Z ) ) ) ) ).

% inf_sup_aci(3)
thf(fact_4942_inf__sup__aci_I2_J,axiom,
    ! [A: $tType] :
      ( ( lattice @ A )
     => ! [X: A,Y: A,Z: A] :
          ( ( inf_inf @ A @ ( inf_inf @ A @ X @ Y ) @ Z )
          = ( inf_inf @ A @ X @ ( inf_inf @ A @ Y @ Z ) ) ) ) ).

% inf_sup_aci(2)
thf(fact_4943_inf__sup__aci_I1_J,axiom,
    ! [A: $tType] :
      ( ( lattice @ A )
     => ( ( inf_inf @ A )
        = ( ^ [X2: A,Y4: A] : ( inf_inf @ A @ Y4 @ X2 ) ) ) ) ).

% inf_sup_aci(1)
thf(fact_4944_inf_Oassoc,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( inf_inf @ A @ ( inf_inf @ A @ A2 @ B2 ) @ C2 )
          = ( inf_inf @ A @ A2 @ ( inf_inf @ A @ B2 @ C2 ) ) ) ) ).

% inf.assoc
thf(fact_4945_inf__assoc,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [X: A,Y: A,Z: A] :
          ( ( inf_inf @ A @ ( inf_inf @ A @ X @ Y ) @ Z )
          = ( inf_inf @ A @ X @ ( inf_inf @ A @ Y @ Z ) ) ) ) ).

% inf_assoc
thf(fact_4946_inf_Ocommute,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ( ( inf_inf @ A )
        = ( ^ [A3: A,B3: A] : ( inf_inf @ A @ B3 @ A3 ) ) ) ) ).

% inf.commute
thf(fact_4947_inf__commute,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ( ( inf_inf @ A )
        = ( ^ [X2: A,Y4: A] : ( inf_inf @ A @ Y4 @ X2 ) ) ) ) ).

% inf_commute
thf(fact_4948_inf_Oleft__commute,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( inf_inf @ A @ B2 @ ( inf_inf @ A @ A2 @ C2 ) )
          = ( inf_inf @ A @ A2 @ ( inf_inf @ A @ B2 @ C2 ) ) ) ) ).

% inf.left_commute
thf(fact_4949_inf__left__commute,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [X: A,Y: A,Z: A] :
          ( ( inf_inf @ A @ X @ ( inf_inf @ A @ Y @ Z ) )
          = ( inf_inf @ A @ Y @ ( inf_inf @ A @ X @ Z ) ) ) ) ).

% inf_left_commute
thf(fact_4950_inf__fun__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( semilattice_inf @ B )
     => ( ( inf_inf @ ( A > B ) )
        = ( ^ [F3: A > B,G2: A > B,X2: A] : ( inf_inf @ B @ ( F3 @ X2 ) @ ( G2 @ X2 ) ) ) ) ) ).

% inf_fun_def
thf(fact_4951_inf_OcoboundedI2,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( ord_less_eq @ A @ B2 @ C2 )
         => ( ord_less_eq @ A @ ( inf_inf @ A @ A2 @ B2 ) @ C2 ) ) ) ).

% inf.coboundedI2
thf(fact_4952_inf_OcoboundedI1,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ C2 )
         => ( ord_less_eq @ A @ ( inf_inf @ A @ A2 @ B2 ) @ C2 ) ) ) ).

% inf.coboundedI1
thf(fact_4953_inf_Oabsorb__iff2,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [B3: A,A3: A] :
              ( ( inf_inf @ A @ A3 @ B3 )
              = B3 ) ) ) ) ).

% inf.absorb_iff2
thf(fact_4954_inf_Oabsorb__iff1,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [A3: A,B3: A] :
              ( ( inf_inf @ A @ A3 @ B3 )
              = A3 ) ) ) ) ).

% inf.absorb_iff1
thf(fact_4955_inf_Ocobounded2,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A2: A,B2: A] : ( ord_less_eq @ A @ ( inf_inf @ A @ A2 @ B2 ) @ B2 ) ) ).

% inf.cobounded2
thf(fact_4956_inf_Ocobounded1,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A2: A,B2: A] : ( ord_less_eq @ A @ ( inf_inf @ A @ A2 @ B2 ) @ A2 ) ) ).

% inf.cobounded1
thf(fact_4957_inf_Oorder__iff,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [A3: A,B3: A] :
              ( A3
              = ( inf_inf @ A @ A3 @ B3 ) ) ) ) ) ).

% inf.order_iff
thf(fact_4958_inf__greatest,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [X: A,Y: A,Z: A] :
          ( ( ord_less_eq @ A @ X @ Y )
         => ( ( ord_less_eq @ A @ X @ Z )
           => ( ord_less_eq @ A @ X @ ( inf_inf @ A @ Y @ Z ) ) ) ) ) ).

% inf_greatest
thf(fact_4959_inf_OboundedI,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ A2 @ C2 )
           => ( ord_less_eq @ A @ A2 @ ( inf_inf @ A @ B2 @ C2 ) ) ) ) ) ).

% inf.boundedI
thf(fact_4960_inf_OboundedE,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ ( inf_inf @ A @ B2 @ C2 ) )
         => ~ ( ( ord_less_eq @ A @ A2 @ B2 )
             => ~ ( ord_less_eq @ A @ A2 @ C2 ) ) ) ) ).

% inf.boundedE
thf(fact_4961_inf__absorb2,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [Y: A,X: A] :
          ( ( ord_less_eq @ A @ Y @ X )
         => ( ( inf_inf @ A @ X @ Y )
            = Y ) ) ) ).

% inf_absorb2
thf(fact_4962_inf__absorb1,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ A @ X @ Y )
         => ( ( inf_inf @ A @ X @ Y )
            = X ) ) ) ).

% inf_absorb1
thf(fact_4963_inf_Oabsorb2,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less_eq @ A @ B2 @ A2 )
         => ( ( inf_inf @ A @ A2 @ B2 )
            = B2 ) ) ) ).

% inf.absorb2
thf(fact_4964_inf_Oabsorb1,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( inf_inf @ A @ A2 @ B2 )
            = A2 ) ) ) ).

% inf.absorb1
thf(fact_4965_le__iff__inf,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [X2: A,Y4: A] :
              ( ( inf_inf @ A @ X2 @ Y4 )
              = X2 ) ) ) ) ).

% le_iff_inf
thf(fact_4966_inf__unique,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [F2: A > A > A,X: A,Y: A] :
          ( ! [X3: A,Y5: A] : ( ord_less_eq @ A @ ( F2 @ X3 @ Y5 ) @ X3 )
         => ( ! [X3: A,Y5: A] : ( ord_less_eq @ A @ ( F2 @ X3 @ Y5 ) @ Y5 )
           => ( ! [X3: A,Y5: A,Z3: A] :
                  ( ( ord_less_eq @ A @ X3 @ Y5 )
                 => ( ( ord_less_eq @ A @ X3 @ Z3 )
                   => ( ord_less_eq @ A @ X3 @ ( F2 @ Y5 @ Z3 ) ) ) )
             => ( ( inf_inf @ A @ X @ Y )
                = ( F2 @ X @ Y ) ) ) ) ) ) ).

% inf_unique
thf(fact_4967_inf_OorderI,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A2: A,B2: A] :
          ( ( A2
            = ( inf_inf @ A @ A2 @ B2 ) )
         => ( ord_less_eq @ A @ A2 @ B2 ) ) ) ).

% inf.orderI
thf(fact_4968_inf_OorderE,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( A2
            = ( inf_inf @ A @ A2 @ B2 ) ) ) ) ).

% inf.orderE
thf(fact_4969_le__infI2,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [B2: A,X: A,A2: A] :
          ( ( ord_less_eq @ A @ B2 @ X )
         => ( ord_less_eq @ A @ ( inf_inf @ A @ A2 @ B2 ) @ X ) ) ) ).

% le_infI2
thf(fact_4970_le__infI1,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A2: A,X: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ X )
         => ( ord_less_eq @ A @ ( inf_inf @ A @ A2 @ B2 ) @ X ) ) ) ).

% le_infI1
thf(fact_4971_inf__mono,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A2: A,C2: A,B2: A,D2: A] :
          ( ( ord_less_eq @ A @ A2 @ C2 )
         => ( ( ord_less_eq @ A @ B2 @ D2 )
           => ( ord_less_eq @ A @ ( inf_inf @ A @ A2 @ B2 ) @ ( inf_inf @ A @ C2 @ D2 ) ) ) ) ) ).

% inf_mono
thf(fact_4972_le__infI,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [X: A,A2: A,B2: A] :
          ( ( ord_less_eq @ A @ X @ A2 )
         => ( ( ord_less_eq @ A @ X @ B2 )
           => ( ord_less_eq @ A @ X @ ( inf_inf @ A @ A2 @ B2 ) ) ) ) ) ).

% le_infI
thf(fact_4973_le__infE,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [X: A,A2: A,B2: A] :
          ( ( ord_less_eq @ A @ X @ ( inf_inf @ A @ A2 @ B2 ) )
         => ~ ( ( ord_less_eq @ A @ X @ A2 )
             => ~ ( ord_less_eq @ A @ X @ B2 ) ) ) ) ).

% le_infE
thf(fact_4974_inf__le2,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [X: A,Y: A] : ( ord_less_eq @ A @ ( inf_inf @ A @ X @ Y ) @ Y ) ) ).

% inf_le2
thf(fact_4975_inf__le1,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [X: A,Y: A] : ( ord_less_eq @ A @ ( inf_inf @ A @ X @ Y ) @ X ) ) ).

% inf_le1
thf(fact_4976_inf__sup__ord_I1_J,axiom,
    ! [A: $tType] :
      ( ( lattice @ A )
     => ! [X: A,Y: A] : ( ord_less_eq @ A @ ( inf_inf @ A @ X @ Y ) @ X ) ) ).

% inf_sup_ord(1)
thf(fact_4977_inf__sup__ord_I2_J,axiom,
    ! [A: $tType] :
      ( ( lattice @ A )
     => ! [X: A,Y: A] : ( ord_less_eq @ A @ ( inf_inf @ A @ X @ Y ) @ Y ) ) ).

% inf_sup_ord(2)
thf(fact_4978_zero__notin__Suc__image,axiom,
    ! [A4: set @ nat] :
      ~ ( member @ nat @ ( zero_zero @ nat ) @ ( image @ nat @ nat @ suc @ A4 ) ) ).

% zero_notin_Suc_image
thf(fact_4979_funpow__simps__right_I1_J,axiom,
    ! [A: $tType,F2: A > A] :
      ( ( compow @ ( A > A ) @ ( zero_zero @ nat ) @ F2 )
      = ( id @ A ) ) ).

% funpow_simps_right(1)
thf(fact_4980_less__int__def,axiom,
    ( ( ord_less @ int )
    = ( map_fun @ int @ ( product_prod @ nat @ nat ) @ ( ( product_prod @ nat @ nat ) > $o ) @ ( int > $o ) @ rep_Integ @ ( map_fun @ int @ ( product_prod @ nat @ nat ) @ $o @ $o @ rep_Integ @ ( id @ $o ) )
      @ ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > $o )
        @ ^ [X2: nat,Y4: nat] :
            ( product_case_prod @ nat @ nat @ $o
            @ ^ [U2: nat,V5: nat] : ( ord_less @ nat @ ( plus_plus @ nat @ X2 @ V5 ) @ ( plus_plus @ nat @ U2 @ Y4 ) ) ) ) ) ) ).

% less_int_def
thf(fact_4981_less__eq__int__def,axiom,
    ( ( ord_less_eq @ int )
    = ( map_fun @ int @ ( product_prod @ nat @ nat ) @ ( ( product_prod @ nat @ nat ) > $o ) @ ( int > $o ) @ rep_Integ @ ( map_fun @ int @ ( product_prod @ nat @ nat ) @ $o @ $o @ rep_Integ @ ( id @ $o ) )
      @ ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > $o )
        @ ^ [X2: nat,Y4: nat] :
            ( product_case_prod @ nat @ nat @ $o
            @ ^ [U2: nat,V5: nat] : ( ord_less_eq @ nat @ ( plus_plus @ nat @ X2 @ V5 ) @ ( plus_plus @ nat @ U2 @ Y4 ) ) ) ) ) ) ).

% less_eq_int_def
thf(fact_4982_nat__seg__image__imp__finite,axiom,
    ! [A: $tType,A4: set @ A,F2: nat > A,N: nat] :
      ( ( A4
        = ( image @ nat @ A @ F2
          @ ( collect @ nat
            @ ^ [I4: nat] : ( ord_less @ nat @ I4 @ N ) ) ) )
     => ( finite_finite @ A @ A4 ) ) ).

% nat_seg_image_imp_finite
thf(fact_4983_finite__conv__nat__seg__image,axiom,
    ! [A: $tType] :
      ( ( finite_finite @ A )
      = ( ^ [A7: set @ A] :
          ? [N3: nat,F3: nat > A] :
            ( A7
            = ( image @ nat @ A @ F3
              @ ( collect @ nat
                @ ^ [I4: nat] : ( ord_less @ nat @ I4 @ N3 ) ) ) ) ) ) ).

% finite_conv_nat_seg_image
thf(fact_4984_nat__def,axiom,
    ( nat2
    = ( map_fun @ int @ ( product_prod @ nat @ nat ) @ nat @ nat @ rep_Integ @ ( id @ nat ) @ ( product_case_prod @ nat @ nat @ nat @ ( minus_minus @ nat ) ) ) ) ).

% nat_def
thf(fact_4985_inf__shunt,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [X: A,Y: A] :
          ( ( ( inf_inf @ A @ X @ Y )
            = ( bot_bot @ A ) )
          = ( ord_less_eq @ A @ X @ ( uminus_uminus @ A @ Y ) ) ) ) ).

% inf_shunt
thf(fact_4986_card__image__le,axiom,
    ! [B: $tType,A: $tType,A4: set @ A,F2: A > B] :
      ( ( finite_finite @ A @ A4 )
     => ( ord_less_eq @ nat @ ( finite_card @ B @ ( image @ A @ B @ F2 @ A4 ) ) @ ( finite_card @ A @ A4 ) ) ) ).

% card_image_le
thf(fact_4987_sum_Ointer__restrict,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A4: set @ B,G: B > A,B7: set @ B] :
          ( ( finite_finite @ B @ A4 )
         => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ ( inf_inf @ ( set @ B ) @ A4 @ B7 ) )
            = ( groups7311177749621191930dd_sum @ B @ A
              @ ^ [X2: B] : ( if @ A @ ( member @ B @ X2 @ B7 ) @ ( G @ X2 ) @ ( zero_zero @ A ) )
              @ A4 ) ) ) ) ).

% sum.inter_restrict
thf(fact_4988_sum_Oreindex__nontrivial,axiom,
    ! [C: $tType,A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A4: set @ B,H2: B > C,G: C > A] :
          ( ( finite_finite @ B @ A4 )
         => ( ! [X3: B,Y5: B] :
                ( ( member @ B @ X3 @ A4 )
               => ( ( member @ B @ Y5 @ A4 )
                 => ( ( X3 != Y5 )
                   => ( ( ( H2 @ X3 )
                        = ( H2 @ Y5 ) )
                     => ( ( G @ ( H2 @ X3 ) )
                        = ( zero_zero @ A ) ) ) ) ) )
           => ( ( groups7311177749621191930dd_sum @ C @ A @ G @ ( image @ B @ C @ H2 @ A4 ) )
              = ( groups7311177749621191930dd_sum @ B @ A @ ( comp @ C @ A @ B @ G @ H2 ) @ A4 ) ) ) ) ) ).

% sum.reindex_nontrivial
thf(fact_4989_surj__card__le,axiom,
    ! [B: $tType,A: $tType,A4: set @ A,B7: set @ B,F2: A > B] :
      ( ( finite_finite @ A @ A4 )
     => ( ( ord_less_eq @ ( set @ B ) @ B7 @ ( image @ A @ B @ F2 @ A4 ) )
       => ( ord_less_eq @ nat @ ( finite_card @ B @ B7 ) @ ( finite_card @ A @ A4 ) ) ) ) ).

% surj_card_le
thf(fact_4990_scaleR__image__atLeastAtMost,axiom,
    ! [A: $tType] :
      ( ( real_V5355595471888546746vector @ A )
     => ! [C2: real,X: A,Y: A] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ C2 )
         => ( ( image @ A @ A @ ( real_V8093663219630862766scaleR @ A @ C2 ) @ ( set_or1337092689740270186AtMost @ A @ X @ Y ) )
            = ( set_or1337092689740270186AtMost @ A @ ( real_V8093663219630862766scaleR @ A @ C2 @ X ) @ ( real_V8093663219630862766scaleR @ A @ C2 @ Y ) ) ) ) ) ).

% scaleR_image_atLeastAtMost
thf(fact_4991_sum_Omono__neutral__cong,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [T6: set @ B,S: set @ B,H2: B > A,G: B > A] :
          ( ( finite_finite @ B @ T6 )
         => ( ( finite_finite @ B @ S )
           => ( ! [I2: B] :
                  ( ( member @ B @ I2 @ ( minus_minus @ ( set @ B ) @ T6 @ S ) )
                 => ( ( H2 @ I2 )
                    = ( zero_zero @ A ) ) )
             => ( ! [I2: B] :
                    ( ( member @ B @ I2 @ ( minus_minus @ ( set @ B ) @ S @ T6 ) )
                   => ( ( G @ I2 )
                      = ( zero_zero @ A ) ) )
               => ( ! [X3: B] :
                      ( ( member @ B @ X3 @ ( inf_inf @ ( set @ B ) @ S @ T6 ) )
                     => ( ( G @ X3 )
                        = ( H2 @ X3 ) ) )
                 => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ S )
                    = ( groups7311177749621191930dd_sum @ B @ A @ H2 @ T6 ) ) ) ) ) ) ) ) ).

% sum.mono_neutral_cong
thf(fact_4992_Iio__Int__singleton,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [X: A,K: A] :
          ( ( ( ord_less @ A @ X @ K )
           => ( ( inf_inf @ ( set @ A ) @ ( set_ord_lessThan @ A @ K ) @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
              = ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) )
          & ( ~ ( ord_less @ A @ X @ K )
           => ( ( inf_inf @ ( set @ A ) @ ( set_ord_lessThan @ A @ K ) @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
              = ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% Iio_Int_singleton
thf(fact_4993_atLeast0__atMost__Suc__eq__insert__0,axiom,
    ! [N: nat] :
      ( ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ ( suc @ N ) )
      = ( insert @ nat @ ( zero_zero @ nat ) @ ( image @ nat @ nat @ suc @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N ) ) ) ) ).

% atLeast0_atMost_Suc_eq_insert_0
thf(fact_4994_atLeast0__lessThan__Suc__eq__insert__0,axiom,
    ! [N: nat] :
      ( ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( suc @ N ) )
      = ( insert @ nat @ ( zero_zero @ nat ) @ ( image @ nat @ nat @ suc @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N ) ) ) ) ).

% atLeast0_lessThan_Suc_eq_insert_0
thf(fact_4995_lessThan__Suc__eq__insert__0,axiom,
    ! [N: nat] :
      ( ( set_ord_lessThan @ nat @ ( suc @ N ) )
      = ( insert @ nat @ ( zero_zero @ nat ) @ ( image @ nat @ nat @ suc @ ( set_ord_lessThan @ nat @ N ) ) ) ) ).

% lessThan_Suc_eq_insert_0
thf(fact_4996_atMost__Suc__eq__insert__0,axiom,
    ! [N: nat] :
      ( ( set_ord_atMost @ nat @ ( suc @ N ) )
      = ( insert @ nat @ ( zero_zero @ nat ) @ ( image @ nat @ nat @ suc @ ( set_ord_atMost @ nat @ N ) ) ) ) ).

% atMost_Suc_eq_insert_0
thf(fact_4997_sum__image__le,axiom,
    ! [A: $tType,B: $tType,C: $tType] :
      ( ( ordere6911136660526730532id_add @ B )
     => ! [I5: set @ C,G: A > B,F2: C > A] :
          ( ( finite_finite @ C @ I5 )
         => ( ! [I2: C] :
                ( ( member @ C @ I2 @ I5 )
               => ( ord_less_eq @ B @ ( zero_zero @ B ) @ ( G @ ( F2 @ I2 ) ) ) )
           => ( ord_less_eq @ B @ ( groups7311177749621191930dd_sum @ A @ B @ G @ ( image @ C @ A @ F2 @ I5 ) ) @ ( groups7311177749621191930dd_sum @ C @ B @ ( comp @ A @ B @ C @ G @ F2 ) @ I5 ) ) ) ) ) ).

% sum_image_le
thf(fact_4998_image__mult__atLeastAtMost__if,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [C2: A,X: A,Y: A] :
          ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
           => ( ( image @ A @ A @ ( times_times @ A @ C2 ) @ ( set_or1337092689740270186AtMost @ A @ X @ Y ) )
              = ( set_or1337092689740270186AtMost @ A @ ( times_times @ A @ C2 @ X ) @ ( times_times @ A @ C2 @ Y ) ) ) )
          & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
           => ( ( ( ord_less_eq @ A @ X @ Y )
               => ( ( image @ A @ A @ ( times_times @ A @ C2 ) @ ( set_or1337092689740270186AtMost @ A @ X @ Y ) )
                  = ( set_or1337092689740270186AtMost @ A @ ( times_times @ A @ C2 @ Y ) @ ( times_times @ A @ C2 @ X ) ) ) )
              & ( ~ ( ord_less_eq @ A @ X @ Y )
               => ( ( image @ A @ A @ ( times_times @ A @ C2 ) @ ( set_or1337092689740270186AtMost @ A @ X @ Y ) )
                  = ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ).

% image_mult_atLeastAtMost_if
thf(fact_4999_image__mult__atLeastAtMost__if_H,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A,Y: A,C2: A] :
          ( ( ( ord_less_eq @ A @ X @ Y )
           => ( ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
               => ( ( image @ A @ A
                    @ ^ [X2: A] : ( times_times @ A @ X2 @ C2 )
                    @ ( set_or1337092689740270186AtMost @ A @ X @ Y ) )
                  = ( set_or1337092689740270186AtMost @ A @ ( times_times @ A @ X @ C2 ) @ ( times_times @ A @ Y @ C2 ) ) ) )
              & ( ~ ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
               => ( ( image @ A @ A
                    @ ^ [X2: A] : ( times_times @ A @ X2 @ C2 )
                    @ ( set_or1337092689740270186AtMost @ A @ X @ Y ) )
                  = ( set_or1337092689740270186AtMost @ A @ ( times_times @ A @ Y @ C2 ) @ ( times_times @ A @ X @ C2 ) ) ) ) ) )
          & ( ~ ( ord_less_eq @ A @ X @ Y )
           => ( ( image @ A @ A
                @ ^ [X2: A] : ( times_times @ A @ X2 @ C2 )
                @ ( set_or1337092689740270186AtMost @ A @ X @ Y ) )
              = ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% image_mult_atLeastAtMost_if'
thf(fact_5000_image__affinity__atLeastAtMost,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A,M: A,C2: A] :
          ( ( ( ( set_or1337092689740270186AtMost @ A @ A2 @ B2 )
              = ( bot_bot @ ( set @ A ) ) )
           => ( ( image @ A @ A
                @ ^ [X2: A] : ( plus_plus @ A @ ( times_times @ A @ M @ X2 ) @ C2 )
                @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) )
              = ( bot_bot @ ( set @ A ) ) ) )
          & ( ( ( set_or1337092689740270186AtMost @ A @ A2 @ B2 )
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ M )
               => ( ( image @ A @ A
                    @ ^ [X2: A] : ( plus_plus @ A @ ( times_times @ A @ M @ X2 ) @ C2 )
                    @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) )
                  = ( set_or1337092689740270186AtMost @ A @ ( plus_plus @ A @ ( times_times @ A @ M @ A2 ) @ C2 ) @ ( plus_plus @ A @ ( times_times @ A @ M @ B2 ) @ C2 ) ) ) )
              & ( ~ ( ord_less_eq @ A @ ( zero_zero @ A ) @ M )
               => ( ( image @ A @ A
                    @ ^ [X2: A] : ( plus_plus @ A @ ( times_times @ A @ M @ X2 ) @ C2 )
                    @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) )
                  = ( set_or1337092689740270186AtMost @ A @ ( plus_plus @ A @ ( times_times @ A @ M @ B2 ) @ C2 ) @ ( plus_plus @ A @ ( times_times @ A @ M @ A2 ) @ C2 ) ) ) ) ) ) ) ) ).

% image_affinity_atLeastAtMost
thf(fact_5001_image__affinity__atLeastAtMost__diff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A,M: A,C2: A] :
          ( ( ( ( set_or1337092689740270186AtMost @ A @ A2 @ B2 )
              = ( bot_bot @ ( set @ A ) ) )
           => ( ( image @ A @ A
                @ ^ [X2: A] : ( minus_minus @ A @ ( times_times @ A @ M @ X2 ) @ C2 )
                @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) )
              = ( bot_bot @ ( set @ A ) ) ) )
          & ( ( ( set_or1337092689740270186AtMost @ A @ A2 @ B2 )
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ M )
               => ( ( image @ A @ A
                    @ ^ [X2: A] : ( minus_minus @ A @ ( times_times @ A @ M @ X2 ) @ C2 )
                    @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) )
                  = ( set_or1337092689740270186AtMost @ A @ ( minus_minus @ A @ ( times_times @ A @ M @ A2 ) @ C2 ) @ ( minus_minus @ A @ ( times_times @ A @ M @ B2 ) @ C2 ) ) ) )
              & ( ~ ( ord_less_eq @ A @ ( zero_zero @ A ) @ M )
               => ( ( image @ A @ A
                    @ ^ [X2: A] : ( minus_minus @ A @ ( times_times @ A @ M @ X2 ) @ C2 )
                    @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) )
                  = ( set_or1337092689740270186AtMost @ A @ ( minus_minus @ A @ ( times_times @ A @ M @ B2 ) @ C2 ) @ ( minus_minus @ A @ ( times_times @ A @ M @ A2 ) @ C2 ) ) ) ) ) ) ) ) ).

% image_affinity_atLeastAtMost_diff
thf(fact_5002_image__affinity__atLeastAtMost__div,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A,M: A,C2: A] :
          ( ( ( ( set_or1337092689740270186AtMost @ A @ A2 @ B2 )
              = ( bot_bot @ ( set @ A ) ) )
           => ( ( image @ A @ A
                @ ^ [X2: A] : ( plus_plus @ A @ ( divide_divide @ A @ X2 @ M ) @ C2 )
                @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) )
              = ( bot_bot @ ( set @ A ) ) ) )
          & ( ( ( set_or1337092689740270186AtMost @ A @ A2 @ B2 )
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ M )
               => ( ( image @ A @ A
                    @ ^ [X2: A] : ( plus_plus @ A @ ( divide_divide @ A @ X2 @ M ) @ C2 )
                    @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) )
                  = ( set_or1337092689740270186AtMost @ A @ ( plus_plus @ A @ ( divide_divide @ A @ A2 @ M ) @ C2 ) @ ( plus_plus @ A @ ( divide_divide @ A @ B2 @ M ) @ C2 ) ) ) )
              & ( ~ ( ord_less_eq @ A @ ( zero_zero @ A ) @ M )
               => ( ( image @ A @ A
                    @ ^ [X2: A] : ( plus_plus @ A @ ( divide_divide @ A @ X2 @ M ) @ C2 )
                    @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) )
                  = ( set_or1337092689740270186AtMost @ A @ ( plus_plus @ A @ ( divide_divide @ A @ B2 @ M ) @ C2 ) @ ( plus_plus @ A @ ( divide_divide @ A @ A2 @ M ) @ C2 ) ) ) ) ) ) ) ) ).

% image_affinity_atLeastAtMost_div
thf(fact_5003_image__affinity__atLeastAtMost__div__diff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A,M: A,C2: A] :
          ( ( ( ( set_or1337092689740270186AtMost @ A @ A2 @ B2 )
              = ( bot_bot @ ( set @ A ) ) )
           => ( ( image @ A @ A
                @ ^ [X2: A] : ( minus_minus @ A @ ( divide_divide @ A @ X2 @ M ) @ C2 )
                @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) )
              = ( bot_bot @ ( set @ A ) ) ) )
          & ( ( ( set_or1337092689740270186AtMost @ A @ A2 @ B2 )
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ M )
               => ( ( image @ A @ A
                    @ ^ [X2: A] : ( minus_minus @ A @ ( divide_divide @ A @ X2 @ M ) @ C2 )
                    @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) )
                  = ( set_or1337092689740270186AtMost @ A @ ( minus_minus @ A @ ( divide_divide @ A @ A2 @ M ) @ C2 ) @ ( minus_minus @ A @ ( divide_divide @ A @ B2 @ M ) @ C2 ) ) ) )
              & ( ~ ( ord_less_eq @ A @ ( zero_zero @ A ) @ M )
               => ( ( image @ A @ A
                    @ ^ [X2: A] : ( minus_minus @ A @ ( divide_divide @ A @ X2 @ M ) @ C2 )
                    @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) )
                  = ( set_or1337092689740270186AtMost @ A @ ( minus_minus @ A @ ( divide_divide @ A @ B2 @ M ) @ C2 ) @ ( minus_minus @ A @ ( divide_divide @ A @ A2 @ M ) @ C2 ) ) ) ) ) ) ) ) ).

% image_affinity_atLeastAtMost_div_diff
thf(fact_5004_sum__fun__comp,axiom,
    ! [A: $tType,C: $tType,B: $tType] :
      ( ( semiring_1 @ C )
     => ! [S: set @ A,R4: set @ B,G: A > B,F2: B > C] :
          ( ( finite_finite @ A @ S )
         => ( ( finite_finite @ B @ R4 )
           => ( ( ord_less_eq @ ( set @ B ) @ ( image @ A @ B @ G @ S ) @ R4 )
             => ( ( groups7311177749621191930dd_sum @ A @ C
                  @ ^ [X2: A] : ( F2 @ ( G @ X2 ) )
                  @ S )
                = ( groups7311177749621191930dd_sum @ B @ C
                  @ ^ [Y4: B] :
                      ( times_times @ C
                      @ ( semiring_1_of_nat @ C
                        @ ( finite_card @ A
                          @ ( collect @ A
                            @ ^ [X2: A] :
                                ( ( member @ A @ X2 @ S )
                                & ( ( G @ X2 )
                                  = Y4 ) ) ) ) )
                      @ ( F2 @ Y4 ) )
                  @ R4 ) ) ) ) ) ) ).

% sum_fun_comp
thf(fact_5005_image__add__0,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [S: set @ A] :
          ( ( image @ A @ A @ ( plus_plus @ A @ ( zero_zero @ A ) ) @ S )
          = S ) ) ).

% image_add_0
thf(fact_5006_take__bit__numeral__minus__numeral__int,axiom,
    ! [M: num,N: num] :
      ( ( bit_se2584673776208193580ke_bit @ int @ ( numeral_numeral @ nat @ M ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N ) ) )
      = ( case_option @ int @ num @ ( zero_zero @ int )
        @ ^ [Q6: num] : ( bit_se2584673776208193580ke_bit @ int @ ( numeral_numeral @ nat @ M ) @ ( minus_minus @ int @ ( power_power @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ ( numeral_numeral @ nat @ M ) ) @ ( numeral_numeral @ int @ Q6 ) ) )
        @ ( bit_take_bit_num @ ( numeral_numeral @ nat @ M ) @ N ) ) ) ).

% take_bit_numeral_minus_numeral_int
thf(fact_5007_rat__inverse__code,axiom,
    ! [P6: rat] :
      ( ( quotient_of @ ( inverse_inverse @ rat @ P6 ) )
      = ( product_case_prod @ int @ int @ ( product_prod @ int @ int )
        @ ^ [A3: int,B3: int] :
            ( if @ ( product_prod @ int @ int )
            @ ( A3
              = ( zero_zero @ int ) )
            @ ( product_Pair @ int @ int @ ( zero_zero @ int ) @ ( one_one @ int ) )
            @ ( product_Pair @ int @ int @ ( times_times @ int @ ( sgn_sgn @ int @ A3 ) @ B3 ) @ ( abs_abs @ int @ A3 ) ) )
        @ ( quotient_of @ P6 ) ) ) ).

% rat_inverse_code
thf(fact_5008_take__bit__num__simps_I1_J,axiom,
    ! [M: num] :
      ( ( bit_take_bit_num @ ( zero_zero @ nat ) @ M )
      = ( none @ num ) ) ).

% take_bit_num_simps(1)
thf(fact_5009_take__bit__num__simps_I2_J,axiom,
    ! [N: nat] :
      ( ( bit_take_bit_num @ ( suc @ N ) @ one2 )
      = ( some @ num @ one2 ) ) ).

% take_bit_num_simps(2)
thf(fact_5010_take__bit__num__simps_I5_J,axiom,
    ! [R2: num] :
      ( ( bit_take_bit_num @ ( numeral_numeral @ nat @ R2 ) @ one2 )
      = ( some @ num @ one2 ) ) ).

% take_bit_num_simps(5)
thf(fact_5011_Gcd__int__eq,axiom,
    ! [N4: set @ nat] :
      ( ( gcd_Gcd @ int @ ( image @ nat @ int @ ( semiring_1_of_nat @ int ) @ N4 ) )
      = ( semiring_1_of_nat @ int @ ( gcd_Gcd @ nat @ N4 ) ) ) ).

% Gcd_int_eq
thf(fact_5012_rat__zero__code,axiom,
    ( ( quotient_of @ ( zero_zero @ rat ) )
    = ( product_Pair @ int @ int @ ( zero_zero @ int ) @ ( one_one @ int ) ) ) ).

% rat_zero_code
thf(fact_5013_quotient__of__number_I3_J,axiom,
    ! [K: num] :
      ( ( quotient_of @ ( numeral_numeral @ rat @ K ) )
      = ( product_Pair @ int @ int @ ( numeral_numeral @ int @ K ) @ ( one_one @ int ) ) ) ).

% quotient_of_number(3)
thf(fact_5014_quotient__of__number_I5_J,axiom,
    ! [K: num] :
      ( ( quotient_of @ ( uminus_uminus @ rat @ ( numeral_numeral @ rat @ K ) ) )
      = ( product_Pair @ int @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ K ) ) @ ( one_one @ int ) ) ) ).

% quotient_of_number(5)
thf(fact_5015_take__bit__numeral__numeral,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M: num,N: num] :
          ( ( bit_se2584673776208193580ke_bit @ A @ ( numeral_numeral @ nat @ M ) @ ( numeral_numeral @ A @ N ) )
          = ( case_option @ A @ num @ ( zero_zero @ A ) @ ( numeral_numeral @ A ) @ ( bit_take_bit_num @ ( numeral_numeral @ nat @ M ) @ N ) ) ) ) ).

% take_bit_numeral_numeral
thf(fact_5016_Code__Abstract__Nat_Otake__bit__num__code_I1_J,axiom,
    ! [N: nat] :
      ( ( bit_take_bit_num @ N @ one2 )
      = ( case_nat @ ( option @ num ) @ ( none @ num )
        @ ^ [N3: nat] : ( some @ num @ one2 )
        @ N ) ) ).

% Code_Abstract_Nat.take_bit_num_code(1)
thf(fact_5017_quotient__of__denom__pos,axiom,
    ! [R2: rat,P6: int,Q3: int] :
      ( ( ( quotient_of @ R2 )
        = ( product_Pair @ int @ int @ P6 @ Q3 ) )
     => ( ord_less @ int @ ( zero_zero @ int ) @ Q3 ) ) ).

% quotient_of_denom_pos
thf(fact_5018_quotient__of__denom__pos_H,axiom,
    ! [R2: rat] : ( ord_less @ int @ ( zero_zero @ int ) @ ( product_snd @ int @ int @ ( quotient_of @ R2 ) ) ) ).

% quotient_of_denom_pos'
thf(fact_5019_take__bit__num__eq__Some__imp,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M: nat,N: num,Q3: num] :
          ( ( ( bit_take_bit_num @ M @ N )
            = ( some @ num @ Q3 ) )
         => ( ( bit_se2584673776208193580ke_bit @ A @ M @ ( numeral_numeral @ A @ N ) )
            = ( numeral_numeral @ A @ Q3 ) ) ) ) ).

% take_bit_num_eq_Some_imp
thf(fact_5020_rat__less__eq__code,axiom,
    ( ( ord_less_eq @ rat )
    = ( ^ [P5: rat,Q6: rat] :
          ( product_case_prod @ int @ int @ $o
          @ ^ [A3: int,C4: int] :
              ( product_case_prod @ int @ int @ $o
              @ ^ [B3: int,D4: int] : ( ord_less_eq @ int @ ( times_times @ int @ A3 @ D4 ) @ ( times_times @ int @ C4 @ B3 ) )
              @ ( quotient_of @ Q6 ) )
          @ ( quotient_of @ P5 ) ) ) ) ).

% rat_less_eq_code
thf(fact_5021_rat__less__code,axiom,
    ( ( ord_less @ rat )
    = ( ^ [P5: rat,Q6: rat] :
          ( product_case_prod @ int @ int @ $o
          @ ^ [A3: int,C4: int] :
              ( product_case_prod @ int @ int @ $o
              @ ^ [B3: int,D4: int] : ( ord_less @ int @ ( times_times @ int @ A3 @ D4 ) @ ( times_times @ int @ C4 @ B3 ) )
              @ ( quotient_of @ Q6 ) )
          @ ( quotient_of @ P5 ) ) ) ) ).

% rat_less_code
thf(fact_5022_image__int__atLeastAtMost,axiom,
    ! [A2: nat,B2: nat] :
      ( ( image @ nat @ int @ ( semiring_1_of_nat @ int ) @ ( set_or1337092689740270186AtMost @ nat @ A2 @ B2 ) )
      = ( set_or1337092689740270186AtMost @ int @ ( semiring_1_of_nat @ int @ A2 ) @ ( semiring_1_of_nat @ int @ B2 ) ) ) ).

% image_int_atLeastAtMost
thf(fact_5023_image__int__atLeastLessThan,axiom,
    ! [A2: nat,B2: nat] :
      ( ( image @ nat @ int @ ( semiring_1_of_nat @ int ) @ ( set_or7035219750837199246ssThan @ nat @ A2 @ B2 ) )
      = ( set_or7035219750837199246ssThan @ int @ ( semiring_1_of_nat @ int @ A2 ) @ ( semiring_1_of_nat @ int @ B2 ) ) ) ).

% image_int_atLeastLessThan
thf(fact_5024_take__bit__num__eq__None__imp,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M: nat,N: num] :
          ( ( ( bit_take_bit_num @ M @ N )
            = ( none @ num ) )
         => ( ( bit_se2584673776208193580ke_bit @ A @ M @ ( numeral_numeral @ A @ N ) )
            = ( zero_zero @ A ) ) ) ) ).

% take_bit_num_eq_None_imp
thf(fact_5025_image__add__int__atLeastLessThan,axiom,
    ! [L: int,U: int] :
      ( ( image @ int @ int
        @ ^ [X2: int] : ( plus_plus @ int @ X2 @ L )
        @ ( set_or7035219750837199246ssThan @ int @ ( zero_zero @ int ) @ ( minus_minus @ int @ U @ L ) ) )
      = ( set_or7035219750837199246ssThan @ int @ L @ U ) ) ).

% image_add_int_atLeastLessThan
thf(fact_5026_take__bit__num__def,axiom,
    ( bit_take_bit_num
    = ( ^ [N3: nat,M3: num] :
          ( if @ ( option @ num )
          @ ( ( bit_se2584673776208193580ke_bit @ nat @ N3 @ ( numeral_numeral @ nat @ M3 ) )
            = ( zero_zero @ nat ) )
          @ ( none @ num )
          @ ( some @ num @ ( num_of_nat @ ( bit_se2584673776208193580ke_bit @ nat @ N3 @ ( numeral_numeral @ nat @ M3 ) ) ) ) ) ) ) ).

% take_bit_num_def
thf(fact_5027_Gcd__int__def,axiom,
    ( ( gcd_Gcd @ int )
    = ( ^ [K7: set @ int] : ( semiring_1_of_nat @ int @ ( gcd_Gcd @ nat @ ( image @ int @ nat @ ( comp @ int @ nat @ int @ nat2 @ ( abs_abs @ int ) ) @ K7 ) ) ) ) ) ).

% Gcd_int_def
thf(fact_5028_image__atLeastZeroLessThan__int,axiom,
    ! [U: int] :
      ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ U )
     => ( ( set_or7035219750837199246ssThan @ int @ ( zero_zero @ int ) @ U )
        = ( image @ nat @ int @ ( semiring_1_of_nat @ int ) @ ( set_ord_lessThan @ nat @ ( nat2 @ U ) ) ) ) ) ).

% image_atLeastZeroLessThan_int
thf(fact_5029_and__minus__numerals_I3_J,axiom,
    ! [M: num,N: num] :
      ( ( bit_se5824344872417868541ns_and @ int @ ( numeral_numeral @ int @ M ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit0 @ N ) ) ) )
      = ( case_option @ int @ num @ ( zero_zero @ int ) @ ( numeral_numeral @ int ) @ ( bit_and_not_num @ M @ ( bitM @ N ) ) ) ) ).

% and_minus_numerals(3)
thf(fact_5030_and__minus__numerals_I7_J,axiom,
    ! [N: num,M: num] :
      ( ( bit_se5824344872417868541ns_and @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit0 @ N ) ) ) @ ( numeral_numeral @ int @ M ) )
      = ( case_option @ int @ num @ ( zero_zero @ int ) @ ( numeral_numeral @ int ) @ ( bit_and_not_num @ M @ ( bitM @ N ) ) ) ) ).

% and_minus_numerals(7)
thf(fact_5031_and__minus__numerals_I4_J,axiom,
    ! [M: num,N: num] :
      ( ( bit_se5824344872417868541ns_and @ int @ ( numeral_numeral @ int @ M ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit1 @ N ) ) ) )
      = ( case_option @ int @ num @ ( zero_zero @ int ) @ ( numeral_numeral @ int ) @ ( bit_and_not_num @ M @ ( bit0 @ N ) ) ) ) ).

% and_minus_numerals(4)
thf(fact_5032_take__bit__num__simps_I4_J,axiom,
    ! [N: nat,M: num] :
      ( ( bit_take_bit_num @ ( suc @ N ) @ ( bit1 @ M ) )
      = ( some @ num @ ( case_option @ num @ num @ one2 @ bit1 @ ( bit_take_bit_num @ N @ M ) ) ) ) ).

% take_bit_num_simps(4)
thf(fact_5033_take__bit__num__simps_I3_J,axiom,
    ! [N: nat,M: num] :
      ( ( bit_take_bit_num @ ( suc @ N ) @ ( bit0 @ M ) )
      = ( case_option @ ( option @ num ) @ num @ ( none @ num )
        @ ^ [Q6: num] : ( some @ num @ ( bit0 @ Q6 ) )
        @ ( bit_take_bit_num @ N @ M ) ) ) ).

% take_bit_num_simps(3)
thf(fact_5034_take__bit__num__simps_I7_J,axiom,
    ! [R2: num,M: num] :
      ( ( bit_take_bit_num @ ( numeral_numeral @ nat @ R2 ) @ ( bit1 @ M ) )
      = ( some @ num @ ( case_option @ num @ num @ one2 @ bit1 @ ( bit_take_bit_num @ ( pred_numeral @ R2 ) @ M ) ) ) ) ).

% take_bit_num_simps(7)
thf(fact_5035_take__bit__num__simps_I6_J,axiom,
    ! [R2: num,M: num] :
      ( ( bit_take_bit_num @ ( numeral_numeral @ nat @ R2 ) @ ( bit0 @ M ) )
      = ( case_option @ ( option @ num ) @ num @ ( none @ num )
        @ ^ [Q6: num] : ( some @ num @ ( bit0 @ Q6 ) )
        @ ( bit_take_bit_num @ ( pred_numeral @ R2 ) @ M ) ) ) ).

% take_bit_num_simps(6)
thf(fact_5036_and__minus__numerals_I8_J,axiom,
    ! [N: num,M: num] :
      ( ( bit_se5824344872417868541ns_and @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ ( bit1 @ N ) ) ) @ ( numeral_numeral @ int @ M ) )
      = ( case_option @ int @ num @ ( zero_zero @ int ) @ ( numeral_numeral @ int ) @ ( bit_and_not_num @ M @ ( bit0 @ N ) ) ) ) ).

% and_minus_numerals(8)
thf(fact_5037_abs__rat__def,axiom,
    ( ( abs_abs @ rat )
    = ( ^ [A3: rat] : ( if @ rat @ ( ord_less @ rat @ A3 @ ( zero_zero @ rat ) ) @ ( uminus_uminus @ rat @ A3 ) @ A3 ) ) ) ).

% abs_rat_def
thf(fact_5038_sgn__rat__def,axiom,
    ( ( sgn_sgn @ rat )
    = ( ^ [A3: rat] :
          ( if @ rat
          @ ( A3
            = ( zero_zero @ rat ) )
          @ ( zero_zero @ rat )
          @ ( if @ rat @ ( ord_less @ rat @ ( zero_zero @ rat ) @ A3 ) @ ( one_one @ rat ) @ ( uminus_uminus @ rat @ ( one_one @ rat ) ) ) ) ) ) ).

% sgn_rat_def
thf(fact_5039_obtain__pos__sum,axiom,
    ! [R2: rat] :
      ( ( ord_less @ rat @ ( zero_zero @ rat ) @ R2 )
     => ~ ! [S3: rat] :
            ( ( ord_less @ rat @ ( zero_zero @ rat ) @ S3 )
           => ! [T4: rat] :
                ( ( ord_less @ rat @ ( zero_zero @ rat ) @ T4 )
               => ( R2
                 != ( plus_plus @ rat @ S3 @ T4 ) ) ) ) ) ).

% obtain_pos_sum
thf(fact_5040_and__not__num_Osimps_I1_J,axiom,
    ( ( bit_and_not_num @ one2 @ one2 )
    = ( none @ num ) ) ).

% and_not_num.simps(1)
thf(fact_5041_and__not__num_Osimps_I8_J,axiom,
    ! [M: num,N: num] :
      ( ( bit_and_not_num @ ( bit1 @ M ) @ ( bit0 @ N ) )
      = ( case_option @ ( option @ num ) @ num @ ( some @ num @ one2 )
        @ ^ [N10: num] : ( some @ num @ ( bit1 @ N10 ) )
        @ ( bit_and_not_num @ M @ N ) ) ) ).

% and_not_num.simps(8)
thf(fact_5042_and__not__num_Osimps_I4_J,axiom,
    ! [M: num] :
      ( ( bit_and_not_num @ ( bit0 @ M ) @ one2 )
      = ( some @ num @ ( bit0 @ M ) ) ) ).

% and_not_num.simps(4)
thf(fact_5043_and__not__num_Osimps_I2_J,axiom,
    ! [N: num] :
      ( ( bit_and_not_num @ one2 @ ( bit0 @ N ) )
      = ( some @ num @ one2 ) ) ).

% and_not_num.simps(2)
thf(fact_5044_and__not__num_Osimps_I3_J,axiom,
    ! [N: num] :
      ( ( bit_and_not_num @ one2 @ ( bit1 @ N ) )
      = ( none @ num ) ) ).

% and_not_num.simps(3)
thf(fact_5045_Code__Abstract__Nat_Otake__bit__num__code_I2_J,axiom,
    ! [N: nat,M: num] :
      ( ( bit_take_bit_num @ N @ ( bit0 @ M ) )
      = ( case_nat @ ( option @ num ) @ ( none @ num )
        @ ^ [N3: nat] :
            ( case_option @ ( option @ num ) @ num @ ( none @ num )
            @ ^ [Q6: num] : ( some @ num @ ( bit0 @ Q6 ) )
            @ ( bit_take_bit_num @ N3 @ M ) )
        @ N ) ) ).

% Code_Abstract_Nat.take_bit_num_code(2)
thf(fact_5046_and__not__num_Osimps_I7_J,axiom,
    ! [M: num] :
      ( ( bit_and_not_num @ ( bit1 @ M ) @ one2 )
      = ( some @ num @ ( bit0 @ M ) ) ) ).

% and_not_num.simps(7)
thf(fact_5047_and__not__num__eq__Some__iff,axiom,
    ! [M: num,N: num,Q3: num] :
      ( ( ( bit_and_not_num @ M @ N )
        = ( some @ num @ Q3 ) )
      = ( ( bit_se5824344872417868541ns_and @ int @ ( numeral_numeral @ int @ M ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ N ) ) )
        = ( numeral_numeral @ int @ Q3 ) ) ) ).

% and_not_num_eq_Some_iff
thf(fact_5048_Code__Abstract__Nat_Otake__bit__num__code_I3_J,axiom,
    ! [N: nat,M: num] :
      ( ( bit_take_bit_num @ N @ ( bit1 @ M ) )
      = ( case_nat @ ( option @ num ) @ ( none @ num )
        @ ^ [N3: nat] : ( some @ num @ ( case_option @ num @ num @ one2 @ bit1 @ ( bit_take_bit_num @ N3 @ M ) ) )
        @ N ) ) ).

% Code_Abstract_Nat.take_bit_num_code(3)
thf(fact_5049_and__not__num__eq__None__iff,axiom,
    ! [M: num,N: num] :
      ( ( ( bit_and_not_num @ M @ N )
        = ( none @ num ) )
      = ( ( bit_se5824344872417868541ns_and @ int @ ( numeral_numeral @ int @ M ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ N ) ) )
        = ( zero_zero @ int ) ) ) ).

% and_not_num_eq_None_iff
thf(fact_5050_int__numeral__and__not__num,axiom,
    ! [M: num,N: num] :
      ( ( bit_se5824344872417868541ns_and @ int @ ( numeral_numeral @ int @ M ) @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ N ) ) )
      = ( case_option @ int @ num @ ( zero_zero @ int ) @ ( numeral_numeral @ int ) @ ( bit_and_not_num @ M @ N ) ) ) ).

% int_numeral_and_not_num
thf(fact_5051_int__numeral__not__and__num,axiom,
    ! [M: num,N: num] :
      ( ( bit_se5824344872417868541ns_and @ int @ ( bit_ri4277139882892585799ns_not @ int @ ( numeral_numeral @ int @ M ) ) @ ( numeral_numeral @ int @ N ) )
      = ( case_option @ int @ num @ ( zero_zero @ int ) @ ( numeral_numeral @ int ) @ ( bit_and_not_num @ N @ M ) ) ) ).

% int_numeral_not_and_num
thf(fact_5052_Bit__Operations_Otake__bit__num__code,axiom,
    ( bit_take_bit_num
    = ( ^ [N3: nat,M3: num] :
          ( product_case_prod @ nat @ num @ ( option @ num )
          @ ^ [A3: nat,X2: num] :
              ( case_nat @ ( option @ num ) @ ( none @ num )
              @ ^ [O: nat] :
                  ( case_num @ ( option @ num ) @ ( some @ num @ one2 )
                  @ ^ [P5: num] :
                      ( case_option @ ( option @ num ) @ num @ ( none @ num )
                      @ ^ [Q6: num] : ( some @ num @ ( bit0 @ Q6 ) )
                      @ ( bit_take_bit_num @ O @ P5 ) )
                  @ ^ [P5: num] : ( some @ num @ ( case_option @ num @ num @ one2 @ bit1 @ ( bit_take_bit_num @ O @ P5 ) ) )
                  @ X2 )
              @ A3 )
          @ ( product_Pair @ nat @ num @ N3 @ M3 ) ) ) ) ).

% Bit_Operations.take_bit_num_code
thf(fact_5053_normalize__negative,axiom,
    ! [Q3: int,P6: int] :
      ( ( ord_less @ int @ Q3 @ ( zero_zero @ int ) )
     => ( ( normalize @ ( product_Pair @ int @ int @ P6 @ Q3 ) )
        = ( normalize @ ( product_Pair @ int @ int @ ( uminus_uminus @ int @ P6 ) @ ( uminus_uminus @ int @ Q3 ) ) ) ) ) ).

% normalize_negative
thf(fact_5054_Frct__code__post_I5_J,axiom,
    ! [K: num] :
      ( ( frct @ ( product_Pair @ int @ int @ ( one_one @ int ) @ ( numeral_numeral @ int @ K ) ) )
      = ( divide_divide @ rat @ ( one_one @ rat ) @ ( numeral_numeral @ rat @ K ) ) ) ).

% Frct_code_post(5)
thf(fact_5055_normalize__denom__zero,axiom,
    ! [P6: int] :
      ( ( normalize @ ( product_Pair @ int @ int @ P6 @ ( zero_zero @ int ) ) )
      = ( product_Pair @ int @ int @ ( zero_zero @ int ) @ ( one_one @ int ) ) ) ).

% normalize_denom_zero
thf(fact_5056_num_Ocase__distrib,axiom,
    ! [B: $tType,A: $tType,H2: A > B,F1: A,F22: num > A,F32: num > A,Num: num] :
      ( ( H2 @ ( case_num @ A @ F1 @ F22 @ F32 @ Num ) )
      = ( case_num @ B @ ( H2 @ F1 )
        @ ^ [X2: num] : ( H2 @ ( F22 @ X2 ) )
        @ ^ [X2: num] : ( H2 @ ( F32 @ X2 ) )
        @ Num ) ) ).

% num.case_distrib
thf(fact_5057_verit__eq__simplify_I17_J,axiom,
    ! [A: $tType,F1: A,F22: num > A,F32: num > A,X22: num] :
      ( ( case_num @ A @ F1 @ F22 @ F32 @ ( bit0 @ X22 ) )
      = ( F22 @ X22 ) ) ).

% verit_eq_simplify(17)
thf(fact_5058_verit__eq__simplify_I16_J,axiom,
    ! [A: $tType,F1: A,F22: num > A,F32: num > A] :
      ( ( case_num @ A @ F1 @ F22 @ F32 @ one2 )
      = F1 ) ).

% verit_eq_simplify(16)
thf(fact_5059_verit__eq__simplify_I18_J,axiom,
    ! [A: $tType,F1: A,F22: num > A,F32: num > A,X32: num] :
      ( ( case_num @ A @ F1 @ F22 @ F32 @ ( bit1 @ X32 ) )
      = ( F32 @ X32 ) ) ).

% verit_eq_simplify(18)
thf(fact_5060_normalize__denom__pos,axiom,
    ! [R2: product_prod @ int @ int,P6: int,Q3: int] :
      ( ( ( normalize @ R2 )
        = ( product_Pair @ int @ int @ P6 @ Q3 ) )
     => ( ord_less @ int @ ( zero_zero @ int ) @ Q3 ) ) ).

% normalize_denom_pos
thf(fact_5061_normalize__crossproduct,axiom,
    ! [Q3: int,S2: int,P6: int,R2: int] :
      ( ( Q3
       != ( zero_zero @ int ) )
     => ( ( S2
         != ( zero_zero @ int ) )
       => ( ( ( normalize @ ( product_Pair @ int @ int @ P6 @ Q3 ) )
            = ( normalize @ ( product_Pair @ int @ int @ R2 @ S2 ) ) )
         => ( ( times_times @ int @ P6 @ S2 )
            = ( times_times @ int @ R2 @ Q3 ) ) ) ) ) ).

% normalize_crossproduct
thf(fact_5062_Frct__code__post_I2_J,axiom,
    ! [A2: int] :
      ( ( frct @ ( product_Pair @ int @ int @ A2 @ ( zero_zero @ int ) ) )
      = ( zero_zero @ rat ) ) ).

% Frct_code_post(2)
thf(fact_5063_Frct__code__post_I1_J,axiom,
    ! [A2: int] :
      ( ( frct @ ( product_Pair @ int @ int @ ( zero_zero @ int ) @ A2 ) )
      = ( zero_zero @ rat ) ) ).

% Frct_code_post(1)
thf(fact_5064_Frct__code__post_I6_J,axiom,
    ! [K: num,L: num] :
      ( ( frct @ ( product_Pair @ int @ int @ ( numeral_numeral @ int @ K ) @ ( numeral_numeral @ int @ L ) ) )
      = ( divide_divide @ rat @ ( numeral_numeral @ rat @ K ) @ ( numeral_numeral @ rat @ L ) ) ) ).

% Frct_code_post(6)
thf(fact_5065_Frct__code__post_I4_J,axiom,
    ! [K: num] :
      ( ( frct @ ( product_Pair @ int @ int @ ( numeral_numeral @ int @ K ) @ ( one_one @ int ) ) )
      = ( numeral_numeral @ rat @ K ) ) ).

% Frct_code_post(4)
thf(fact_5066_normalize__def,axiom,
    ( normalize
    = ( ^ [P5: product_prod @ int @ int] :
          ( if @ ( product_prod @ int @ int ) @ ( ord_less @ int @ ( zero_zero @ int ) @ ( product_snd @ int @ int @ P5 ) ) @ ( product_Pair @ int @ int @ ( divide_divide @ int @ ( product_fst @ int @ int @ P5 ) @ ( gcd_gcd @ int @ ( product_fst @ int @ int @ P5 ) @ ( product_snd @ int @ int @ P5 ) ) ) @ ( divide_divide @ int @ ( product_snd @ int @ int @ P5 ) @ ( gcd_gcd @ int @ ( product_fst @ int @ int @ P5 ) @ ( product_snd @ int @ int @ P5 ) ) ) )
          @ ( if @ ( product_prod @ int @ int )
            @ ( ( product_snd @ int @ int @ P5 )
              = ( zero_zero @ int ) )
            @ ( product_Pair @ int @ int @ ( zero_zero @ int ) @ ( one_one @ int ) )
            @ ( product_Pair @ int @ int @ ( divide_divide @ int @ ( product_fst @ int @ int @ P5 ) @ ( uminus_uminus @ int @ ( gcd_gcd @ int @ ( product_fst @ int @ int @ P5 ) @ ( product_snd @ int @ int @ P5 ) ) ) ) @ ( divide_divide @ int @ ( product_snd @ int @ int @ P5 ) @ ( uminus_uminus @ int @ ( gcd_gcd @ int @ ( product_fst @ int @ int @ P5 ) @ ( product_snd @ int @ int @ P5 ) ) ) ) ) ) ) ) ) ).

% normalize_def
thf(fact_5067_and__not__num_Oelims,axiom,
    ! [X: num,Xa: num,Y: option @ num] :
      ( ( ( bit_and_not_num @ X @ Xa )
        = Y )
     => ( ( ( X = one2 )
         => ( ( Xa = one2 )
           => ( Y
             != ( none @ num ) ) ) )
       => ( ( ( X = one2 )
           => ( ? [N2: num] :
                  ( Xa
                  = ( bit0 @ N2 ) )
             => ( Y
               != ( some @ num @ one2 ) ) ) )
         => ( ( ( X = one2 )
             => ( ? [N2: num] :
                    ( Xa
                    = ( bit1 @ N2 ) )
               => ( Y
                 != ( none @ num ) ) ) )
           => ( ! [M4: num] :
                  ( ( X
                    = ( bit0 @ M4 ) )
                 => ( ( Xa = one2 )
                   => ( Y
                     != ( some @ num @ ( bit0 @ M4 ) ) ) ) )
             => ( ! [M4: num] :
                    ( ( X
                      = ( bit0 @ M4 ) )
                   => ! [N2: num] :
                        ( ( Xa
                          = ( bit0 @ N2 ) )
                       => ( Y
                         != ( map_option @ num @ num @ bit0 @ ( bit_and_not_num @ M4 @ N2 ) ) ) ) )
               => ( ! [M4: num] :
                      ( ( X
                        = ( bit0 @ M4 ) )
                     => ! [N2: num] :
                          ( ( Xa
                            = ( bit1 @ N2 ) )
                         => ( Y
                           != ( map_option @ num @ num @ bit0 @ ( bit_and_not_num @ M4 @ N2 ) ) ) ) )
                 => ( ! [M4: num] :
                        ( ( X
                          = ( bit1 @ M4 ) )
                       => ( ( Xa = one2 )
                         => ( Y
                           != ( some @ num @ ( bit0 @ M4 ) ) ) ) )
                   => ( ! [M4: num] :
                          ( ( X
                            = ( bit1 @ M4 ) )
                         => ! [N2: num] :
                              ( ( Xa
                                = ( bit0 @ N2 ) )
                             => ( Y
                               != ( case_option @ ( option @ num ) @ num @ ( some @ num @ one2 )
                                  @ ^ [N10: num] : ( some @ num @ ( bit1 @ N10 ) )
                                  @ ( bit_and_not_num @ M4 @ N2 ) ) ) ) )
                     => ~ ! [M4: num] :
                            ( ( X
                              = ( bit1 @ M4 ) )
                           => ! [N2: num] :
                                ( ( Xa
                                  = ( bit1 @ N2 ) )
                               => ( Y
                                 != ( map_option @ num @ num @ bit0 @ ( bit_and_not_num @ M4 @ N2 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ).

% and_not_num.elims
thf(fact_5068_div__add__self1__no__field,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( euclid4440199948858584721cancel @ A )
        & ( field @ B ) )
     => ! [X: B,B2: A,A2: A] :
          ( ( nO_MATCH @ B @ A @ X @ B2 )
         => ( ( B2
             != ( zero_zero @ A ) )
           => ( ( divide_divide @ A @ ( plus_plus @ A @ B2 @ A2 ) @ B2 )
              = ( plus_plus @ A @ ( divide_divide @ A @ A2 @ B2 ) @ ( one_one @ A ) ) ) ) ) ) ).

% div_add_self1_no_field
thf(fact_5069_gcd__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A2: A,B2: A] :
          ( ( ( gcd_gcd @ A @ A2 @ B2 )
            = ( zero_zero @ A ) )
          = ( ( A2
              = ( zero_zero @ A ) )
            & ( B2
              = ( zero_zero @ A ) ) ) ) ) ).

% gcd_eq_0_iff
thf(fact_5070_gcd__exp,axiom,
    ! [A: $tType] :
      ( ( semiri6843258321239162965malize @ A )
     => ! [A2: A,N: nat,B2: A] :
          ( ( gcd_gcd @ A @ ( power_power @ A @ A2 @ N ) @ ( power_power @ A @ B2 @ N ) )
          = ( power_power @ A @ ( gcd_gcd @ A @ A2 @ B2 ) @ N ) ) ) ).

% gcd_exp
thf(fact_5071_gcd__neg__numeral__2,axiom,
    ! [A: $tType] :
      ( ( ring_gcd @ A )
     => ! [A2: A,N: num] :
          ( ( gcd_gcd @ A @ A2 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) )
          = ( gcd_gcd @ A @ A2 @ ( numeral_numeral @ A @ N ) ) ) ) ).

% gcd_neg_numeral_2
thf(fact_5072_gcd__neg__numeral__1,axiom,
    ! [A: $tType] :
      ( ( ring_gcd @ A )
     => ! [N: num,A2: A] :
          ( ( gcd_gcd @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) @ A2 )
          = ( gcd_gcd @ A @ ( numeral_numeral @ A @ N ) @ A2 ) ) ) ).

% gcd_neg_numeral_1
thf(fact_5073_gcd__pos__int,axiom,
    ! [M: int,N: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ ( gcd_gcd @ int @ M @ N ) )
      = ( ( M
         != ( zero_zero @ int ) )
        | ( N
         != ( zero_zero @ int ) ) ) ) ).

% gcd_pos_int
thf(fact_5074_gcd__neg__numeral__1__int,axiom,
    ! [N: num,X: int] :
      ( ( gcd_gcd @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N ) ) @ X )
      = ( gcd_gcd @ int @ ( numeral_numeral @ int @ N ) @ X ) ) ).

% gcd_neg_numeral_1_int
thf(fact_5075_gcd__neg__numeral__2__int,axiom,
    ! [X: int,N: num] :
      ( ( gcd_gcd @ int @ X @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N ) ) )
      = ( gcd_gcd @ int @ X @ ( numeral_numeral @ int @ N ) ) ) ).

% gcd_neg_numeral_2_int
thf(fact_5076_gcd__0__left__int,axiom,
    ! [X: int] :
      ( ( gcd_gcd @ int @ ( zero_zero @ int ) @ X )
      = ( abs_abs @ int @ X ) ) ).

% gcd_0_left_int
thf(fact_5077_gcd__0__int,axiom,
    ! [X: int] :
      ( ( gcd_gcd @ int @ X @ ( zero_zero @ int ) )
      = ( abs_abs @ int @ X ) ) ).

% gcd_0_int
thf(fact_5078_div__add__self2__no__field,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( euclid4440199948858584721cancel @ A )
        & ( field @ B ) )
     => ! [X: B,B2: A,A2: A] :
          ( ( nO_MATCH @ B @ A @ X @ B2 )
         => ( ( B2
             != ( zero_zero @ A ) )
           => ( ( divide_divide @ A @ ( plus_plus @ A @ A2 @ B2 ) @ B2 )
              = ( plus_plus @ A @ ( divide_divide @ A @ A2 @ B2 ) @ ( one_one @ A ) ) ) ) ) ) ).

% div_add_self2_no_field
thf(fact_5079_gcd__ge__0__int,axiom,
    ! [X: int,Y: int] : ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( gcd_gcd @ int @ X @ Y ) ) ).

% gcd_ge_0_int
thf(fact_5080_and__not__num_Osimps_I5_J,axiom,
    ! [M: num,N: num] :
      ( ( bit_and_not_num @ ( bit0 @ M ) @ ( bit0 @ N ) )
      = ( map_option @ num @ num @ bit0 @ ( bit_and_not_num @ M @ N ) ) ) ).

% and_not_num.simps(5)
thf(fact_5081_and__not__num_Osimps_I6_J,axiom,
    ! [M: num,N: num] :
      ( ( bit_and_not_num @ ( bit0 @ M ) @ ( bit1 @ N ) )
      = ( map_option @ num @ num @ bit0 @ ( bit_and_not_num @ M @ N ) ) ) ).

% and_not_num.simps(6)
thf(fact_5082_and__not__num_Osimps_I9_J,axiom,
    ! [M: num,N: num] :
      ( ( bit_and_not_num @ ( bit1 @ M ) @ ( bit1 @ N ) )
      = ( map_option @ num @ num @ bit0 @ ( bit_and_not_num @ M @ N ) ) ) ).

% and_not_num.simps(9)
thf(fact_5083_gcd__le2__int,axiom,
    ! [B2: int,A2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ B2 )
     => ( ord_less_eq @ int @ ( gcd_gcd @ int @ A2 @ B2 ) @ B2 ) ) ).

% gcd_le2_int
thf(fact_5084_gcd__le1__int,axiom,
    ! [A2: int,B2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ A2 )
     => ( ord_less_eq @ int @ ( gcd_gcd @ int @ A2 @ B2 ) @ A2 ) ) ).

% gcd_le1_int
thf(fact_5085_gcd__cases__int,axiom,
    ! [X: int,Y: int,P: int > $o] :
      ( ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ X )
       => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Y )
         => ( P @ ( gcd_gcd @ int @ X @ Y ) ) ) )
     => ( ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ X )
         => ( ( ord_less_eq @ int @ Y @ ( zero_zero @ int ) )
           => ( P @ ( gcd_gcd @ int @ X @ ( uminus_uminus @ int @ Y ) ) ) ) )
       => ( ( ( ord_less_eq @ int @ X @ ( zero_zero @ int ) )
           => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Y )
             => ( P @ ( gcd_gcd @ int @ ( uminus_uminus @ int @ X ) @ Y ) ) ) )
         => ( ( ( ord_less_eq @ int @ X @ ( zero_zero @ int ) )
             => ( ( ord_less_eq @ int @ Y @ ( zero_zero @ int ) )
               => ( P @ ( gcd_gcd @ int @ ( uminus_uminus @ int @ X ) @ ( uminus_uminus @ int @ Y ) ) ) ) )
           => ( P @ ( gcd_gcd @ int @ X @ Y ) ) ) ) ) ) ).

% gcd_cases_int
thf(fact_5086_gcd__unique__int,axiom,
    ! [D2: int,A2: int,B2: int] :
      ( ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ D2 )
        & ( dvd_dvd @ int @ D2 @ A2 )
        & ( dvd_dvd @ int @ D2 @ B2 )
        & ! [E3: int] :
            ( ( ( dvd_dvd @ int @ E3 @ A2 )
              & ( dvd_dvd @ int @ E3 @ B2 ) )
           => ( dvd_dvd @ int @ E3 @ D2 ) ) )
      = ( D2
        = ( gcd_gcd @ int @ A2 @ B2 ) ) ) ).

% gcd_unique_int
thf(fact_5087_gcd__non__0__int,axiom,
    ! [Y: int,X: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ Y )
     => ( ( gcd_gcd @ int @ X @ Y )
        = ( gcd_gcd @ int @ Y @ ( modulo_modulo @ int @ X @ Y ) ) ) ) ).

% gcd_non_0_int
thf(fact_5088_gcd__code__int,axiom,
    ( ( gcd_gcd @ int )
    = ( ^ [K3: int,L2: int] :
          ( abs_abs @ int
          @ ( if @ int
            @ ( L2
              = ( zero_zero @ int ) )
            @ K3
            @ ( gcd_gcd @ int @ L2 @ ( modulo_modulo @ int @ ( abs_abs @ int @ K3 ) @ ( abs_abs @ int @ L2 ) ) ) ) ) ) ) ).

% gcd_code_int
thf(fact_5089_power__minus_H,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [X: A,N: nat] :
          ( ( nO_MATCH @ A @ A @ ( one_one @ A ) @ X )
         => ( ( power_power @ A @ ( uminus_uminus @ A @ X ) @ N )
            = ( times_times @ A @ ( power_power @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ N ) @ ( power_power @ A @ X @ N ) ) ) ) ) ).

% power_minus'
thf(fact_5090_and__num_Oelims,axiom,
    ! [X: num,Xa: num,Y: option @ num] :
      ( ( ( bit_un7362597486090784418nd_num @ X @ Xa )
        = Y )
     => ( ( ( X = one2 )
         => ( ( Xa = one2 )
           => ( Y
             != ( some @ num @ one2 ) ) ) )
       => ( ( ( X = one2 )
           => ( ? [N2: num] :
                  ( Xa
                  = ( bit0 @ N2 ) )
             => ( Y
               != ( none @ num ) ) ) )
         => ( ( ( X = one2 )
             => ( ? [N2: num] :
                    ( Xa
                    = ( bit1 @ N2 ) )
               => ( Y
                 != ( some @ num @ one2 ) ) ) )
           => ( ( ? [M4: num] :
                    ( X
                    = ( bit0 @ M4 ) )
               => ( ( Xa = one2 )
                 => ( Y
                   != ( none @ num ) ) ) )
             => ( ! [M4: num] :
                    ( ( X
                      = ( bit0 @ M4 ) )
                   => ! [N2: num] :
                        ( ( Xa
                          = ( bit0 @ N2 ) )
                       => ( Y
                         != ( map_option @ num @ num @ bit0 @ ( bit_un7362597486090784418nd_num @ M4 @ N2 ) ) ) ) )
               => ( ! [M4: num] :
                      ( ( X
                        = ( bit0 @ M4 ) )
                     => ! [N2: num] :
                          ( ( Xa
                            = ( bit1 @ N2 ) )
                         => ( Y
                           != ( map_option @ num @ num @ bit0 @ ( bit_un7362597486090784418nd_num @ M4 @ N2 ) ) ) ) )
                 => ( ( ? [M4: num] :
                          ( X
                          = ( bit1 @ M4 ) )
                     => ( ( Xa = one2 )
                       => ( Y
                         != ( some @ num @ one2 ) ) ) )
                   => ( ! [M4: num] :
                          ( ( X
                            = ( bit1 @ M4 ) )
                         => ! [N2: num] :
                              ( ( Xa
                                = ( bit0 @ N2 ) )
                             => ( Y
                               != ( map_option @ num @ num @ bit0 @ ( bit_un7362597486090784418nd_num @ M4 @ N2 ) ) ) ) )
                     => ~ ! [M4: num] :
                            ( ( X
                              = ( bit1 @ M4 ) )
                           => ! [N2: num] :
                                ( ( Xa
                                  = ( bit1 @ N2 ) )
                               => ( Y
                                 != ( case_option @ ( option @ num ) @ num @ ( some @ num @ one2 )
                                    @ ^ [N10: num] : ( some @ num @ ( bit1 @ N10 ) )
                                    @ ( bit_un7362597486090784418nd_num @ M4 @ N2 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ).

% and_num.elims
thf(fact_5091_xor__num_Oelims,axiom,
    ! [X: num,Xa: num,Y: option @ num] :
      ( ( ( bit_un2480387367778600638or_num @ X @ Xa )
        = Y )
     => ( ( ( X = one2 )
         => ( ( Xa = one2 )
           => ( Y
             != ( none @ num ) ) ) )
       => ( ( ( X = one2 )
           => ! [N2: num] :
                ( ( Xa
                  = ( bit0 @ N2 ) )
               => ( Y
                 != ( some @ num @ ( bit1 @ N2 ) ) ) ) )
         => ( ( ( X = one2 )
             => ! [N2: num] :
                  ( ( Xa
                    = ( bit1 @ N2 ) )
                 => ( Y
                   != ( some @ num @ ( bit0 @ N2 ) ) ) ) )
           => ( ! [M4: num] :
                  ( ( X
                    = ( bit0 @ M4 ) )
                 => ( ( Xa = one2 )
                   => ( Y
                     != ( some @ num @ ( bit1 @ M4 ) ) ) ) )
             => ( ! [M4: num] :
                    ( ( X
                      = ( bit0 @ M4 ) )
                   => ! [N2: num] :
                        ( ( Xa
                          = ( bit0 @ N2 ) )
                       => ( Y
                         != ( map_option @ num @ num @ bit0 @ ( bit_un2480387367778600638or_num @ M4 @ N2 ) ) ) ) )
               => ( ! [M4: num] :
                      ( ( X
                        = ( bit0 @ M4 ) )
                     => ! [N2: num] :
                          ( ( Xa
                            = ( bit1 @ N2 ) )
                         => ( Y
                           != ( some @ num @ ( case_option @ num @ num @ one2 @ bit1 @ ( bit_un2480387367778600638or_num @ M4 @ N2 ) ) ) ) ) )
                 => ( ! [M4: num] :
                        ( ( X
                          = ( bit1 @ M4 ) )
                       => ( ( Xa = one2 )
                         => ( Y
                           != ( some @ num @ ( bit0 @ M4 ) ) ) ) )
                   => ( ! [M4: num] :
                          ( ( X
                            = ( bit1 @ M4 ) )
                         => ! [N2: num] :
                              ( ( Xa
                                = ( bit0 @ N2 ) )
                             => ( Y
                               != ( some @ num @ ( case_option @ num @ num @ one2 @ bit1 @ ( bit_un2480387367778600638or_num @ M4 @ N2 ) ) ) ) ) )
                     => ~ ! [M4: num] :
                            ( ( X
                              = ( bit1 @ M4 ) )
                           => ! [N2: num] :
                                ( ( Xa
                                  = ( bit1 @ N2 ) )
                               => ( Y
                                 != ( map_option @ num @ num @ bit0 @ ( bit_un2480387367778600638or_num @ M4 @ N2 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ).

% xor_num.elims
thf(fact_5092_measure__function__int,axiom,
    fun_is_measure @ int @ ( comp @ int @ nat @ int @ nat2 @ ( abs_abs @ int ) ) ).

% measure_function_int
thf(fact_5093_gcd__0__left__nat,axiom,
    ! [X: nat] :
      ( ( gcd_gcd @ nat @ ( zero_zero @ nat ) @ X )
      = X ) ).

% gcd_0_left_nat
thf(fact_5094_gcd__0__nat,axiom,
    ! [X: nat] :
      ( ( gcd_gcd @ nat @ X @ ( zero_zero @ nat ) )
      = X ) ).

% gcd_0_nat
thf(fact_5095_gcd__nat_Oright__neutral,axiom,
    ! [A2: nat] :
      ( ( gcd_gcd @ nat @ A2 @ ( zero_zero @ nat ) )
      = A2 ) ).

% gcd_nat.right_neutral
thf(fact_5096_gcd__nat_Oneutr__eq__iff,axiom,
    ! [A2: nat,B2: nat] :
      ( ( ( zero_zero @ nat )
        = ( gcd_gcd @ nat @ A2 @ B2 ) )
      = ( ( A2
          = ( zero_zero @ nat ) )
        & ( B2
          = ( zero_zero @ nat ) ) ) ) ).

% gcd_nat.neutr_eq_iff
thf(fact_5097_gcd__nat_Oleft__neutral,axiom,
    ! [A2: nat] :
      ( ( gcd_gcd @ nat @ ( zero_zero @ nat ) @ A2 )
      = A2 ) ).

% gcd_nat.left_neutral
thf(fact_5098_gcd__nat_Oeq__neutr__iff,axiom,
    ! [A2: nat,B2: nat] :
      ( ( ( gcd_gcd @ nat @ A2 @ B2 )
        = ( zero_zero @ nat ) )
      = ( ( A2
          = ( zero_zero @ nat ) )
        & ( B2
          = ( zero_zero @ nat ) ) ) ) ).

% gcd_nat.eq_neutr_iff
thf(fact_5099_gcd__Suc__0,axiom,
    ! [M: nat] :
      ( ( gcd_gcd @ nat @ M @ ( suc @ ( zero_zero @ nat ) ) )
      = ( suc @ ( zero_zero @ nat ) ) ) ).

% gcd_Suc_0
thf(fact_5100_gcd__pos__nat,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( gcd_gcd @ nat @ M @ N ) )
      = ( ( M
         != ( zero_zero @ nat ) )
        | ( N
         != ( zero_zero @ nat ) ) ) ) ).

% gcd_pos_nat
thf(fact_5101_gcd__int__int__eq,axiom,
    ! [M: nat,N: nat] :
      ( ( gcd_gcd @ int @ ( semiring_1_of_nat @ int @ M ) @ ( semiring_1_of_nat @ int @ N ) )
      = ( semiring_1_of_nat @ int @ ( gcd_gcd @ nat @ M @ N ) ) ) ).

% gcd_int_int_eq
thf(fact_5102_gcd__nat__abs__right__eq,axiom,
    ! [N: nat,K: int] :
      ( ( gcd_gcd @ nat @ N @ ( nat2 @ ( abs_abs @ int @ K ) ) )
      = ( nat2 @ ( gcd_gcd @ int @ ( semiring_1_of_nat @ int @ N ) @ K ) ) ) ).

% gcd_nat_abs_right_eq
thf(fact_5103_gcd__nat__abs__left__eq,axiom,
    ! [K: int,N: nat] :
      ( ( gcd_gcd @ nat @ ( nat2 @ ( abs_abs @ int @ K ) ) @ N )
      = ( nat2 @ ( gcd_gcd @ int @ K @ ( semiring_1_of_nat @ int @ N ) ) ) ) ).

% gcd_nat_abs_left_eq
thf(fact_5104_is__measure__trivial,axiom,
    ! [A: $tType,F2: A > nat] : ( fun_is_measure @ A @ F2 ) ).

% is_measure_trivial
thf(fact_5105_is__measure_Osimps,axiom,
    ! [A: $tType] :
      ( ( fun_is_measure @ A )
      = ( ^ [A3: A > nat] :
          ? [X8: A > nat] :
            ( ^ [Y3: A > nat,Z2: A > nat] : ( Y3 = Z2 )
            @ A3
            @ X8 ) ) ) ).

% is_measure.simps
thf(fact_5106_measure__snd,axiom,
    ! [A: $tType,B: $tType,F2: A > nat] :
      ( ( fun_is_measure @ A @ F2 )
     => ( fun_is_measure @ ( product_prod @ B @ A )
        @ ^ [P5: product_prod @ B @ A] : ( F2 @ ( product_snd @ B @ A @ P5 ) ) ) ) ).

% measure_snd
thf(fact_5107_measure__fst,axiom,
    ! [B: $tType,A: $tType,F2: A > nat] :
      ( ( fun_is_measure @ A @ F2 )
     => ( fun_is_measure @ ( product_prod @ A @ B )
        @ ^ [P5: product_prod @ A @ B] : ( F2 @ ( product_fst @ A @ B @ P5 ) ) ) ) ).

% measure_fst
thf(fact_5108_gcd__le2__nat,axiom,
    ! [B2: nat,A2: nat] :
      ( ( B2
       != ( zero_zero @ nat ) )
     => ( ord_less_eq @ nat @ ( gcd_gcd @ nat @ A2 @ B2 ) @ B2 ) ) ).

% gcd_le2_nat
thf(fact_5109_gcd__le1__nat,axiom,
    ! [A2: nat,B2: nat] :
      ( ( A2
       != ( zero_zero @ nat ) )
     => ( ord_less_eq @ nat @ ( gcd_gcd @ nat @ A2 @ B2 ) @ A2 ) ) ).

% gcd_le1_nat
thf(fact_5110_gcd__diff1__nat,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less_eq @ nat @ N @ M )
     => ( ( gcd_gcd @ nat @ ( minus_minus @ nat @ M @ N ) @ N )
        = ( gcd_gcd @ nat @ M @ N ) ) ) ).

% gcd_diff1_nat
thf(fact_5111_gcd__diff2__nat,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ M @ N )
     => ( ( gcd_gcd @ nat @ ( minus_minus @ nat @ N @ M ) @ N )
        = ( gcd_gcd @ nat @ M @ N ) ) ) ).

% gcd_diff2_nat
thf(fact_5112_gcd__non__0__nat,axiom,
    ! [Y: nat,X: nat] :
      ( ( Y
       != ( zero_zero @ nat ) )
     => ( ( gcd_gcd @ nat @ X @ Y )
        = ( gcd_gcd @ nat @ Y @ ( modulo_modulo @ nat @ X @ Y ) ) ) ) ).

% gcd_non_0_nat
thf(fact_5113_gcd__nat_Osimps,axiom,
    ( ( gcd_gcd @ nat )
    = ( ^ [X2: nat,Y4: nat] :
          ( if @ nat
          @ ( Y4
            = ( zero_zero @ nat ) )
          @ X2
          @ ( gcd_gcd @ nat @ Y4 @ ( modulo_modulo @ nat @ X2 @ Y4 ) ) ) ) ) ).

% gcd_nat.simps
thf(fact_5114_gcd__nat_Oelims,axiom,
    ! [X: nat,Xa: nat,Y: nat] :
      ( ( ( gcd_gcd @ nat @ X @ Xa )
        = Y )
     => ( ( ( Xa
            = ( zero_zero @ nat ) )
         => ( Y = X ) )
        & ( ( Xa
           != ( zero_zero @ nat ) )
         => ( Y
            = ( gcd_gcd @ nat @ Xa @ ( modulo_modulo @ nat @ X @ Xa ) ) ) ) ) ) ).

% gcd_nat.elims
thf(fact_5115_gcd__code__integer,axiom,
    ( ( gcd_gcd @ code_integer )
    = ( ^ [K3: code_integer,L2: code_integer] :
          ( abs_abs @ code_integer
          @ ( if @ code_integer
            @ ( L2
              = ( zero_zero @ code_integer ) )
            @ K3
            @ ( gcd_gcd @ code_integer @ L2 @ ( modulo_modulo @ code_integer @ ( abs_abs @ code_integer @ K3 ) @ ( abs_abs @ code_integer @ L2 ) ) ) ) ) ) ) ).

% gcd_code_integer
thf(fact_5116_measure__size,axiom,
    ! [A: $tType] :
      ( ( size @ A )
     => ( fun_is_measure @ A @ ( size_size @ A ) ) ) ).

% measure_size
thf(fact_5117_and__num_Osimps_I1_J,axiom,
    ( ( bit_un7362597486090784418nd_num @ one2 @ one2 )
    = ( some @ num @ one2 ) ) ).

% and_num.simps(1)
thf(fact_5118_bezout__nat,axiom,
    ! [A2: nat,B2: nat] :
      ( ( A2
       != ( zero_zero @ nat ) )
     => ? [X3: nat,Y5: nat] :
          ( ( times_times @ nat @ A2 @ X3 )
          = ( plus_plus @ nat @ ( times_times @ nat @ B2 @ Y5 ) @ ( gcd_gcd @ nat @ A2 @ B2 ) ) ) ) ).

% bezout_nat
thf(fact_5119_xor__num_Osimps_I1_J,axiom,
    ( ( bit_un2480387367778600638or_num @ one2 @ one2 )
    = ( none @ num ) ) ).

% xor_num.simps(1)
thf(fact_5120_bezout__gcd__nat_H,axiom,
    ! [B2: nat,A2: nat] :
    ? [X3: nat,Y5: nat] :
      ( ( ( ord_less_eq @ nat @ ( times_times @ nat @ B2 @ Y5 ) @ ( times_times @ nat @ A2 @ X3 ) )
        & ( ( minus_minus @ nat @ ( times_times @ nat @ A2 @ X3 ) @ ( times_times @ nat @ B2 @ Y5 ) )
          = ( gcd_gcd @ nat @ A2 @ B2 ) ) )
      | ( ( ord_less_eq @ nat @ ( times_times @ nat @ A2 @ Y5 ) @ ( times_times @ nat @ B2 @ X3 ) )
        & ( ( minus_minus @ nat @ ( times_times @ nat @ B2 @ X3 ) @ ( times_times @ nat @ A2 @ Y5 ) )
          = ( gcd_gcd @ nat @ A2 @ B2 ) ) ) ) ).

% bezout_gcd_nat'
thf(fact_5121_xor__num_Osimps_I5_J,axiom,
    ! [M: num,N: num] :
      ( ( bit_un2480387367778600638or_num @ ( bit0 @ M ) @ ( bit0 @ N ) )
      = ( map_option @ num @ num @ bit0 @ ( bit_un2480387367778600638or_num @ M @ N ) ) ) ).

% xor_num.simps(5)
thf(fact_5122_and__num_Osimps_I5_J,axiom,
    ! [M: num,N: num] :
      ( ( bit_un7362597486090784418nd_num @ ( bit0 @ M ) @ ( bit0 @ N ) )
      = ( map_option @ num @ num @ bit0 @ ( bit_un7362597486090784418nd_num @ M @ N ) ) ) ).

% and_num.simps(5)
thf(fact_5123_and__num_Osimps_I3_J,axiom,
    ! [N: num] :
      ( ( bit_un7362597486090784418nd_num @ one2 @ ( bit1 @ N ) )
      = ( some @ num @ one2 ) ) ).

% and_num.simps(3)
thf(fact_5124_and__num_Osimps_I7_J,axiom,
    ! [M: num] :
      ( ( bit_un7362597486090784418nd_num @ ( bit1 @ M ) @ one2 )
      = ( some @ num @ one2 ) ) ).

% and_num.simps(7)
thf(fact_5125_and__num_Osimps_I2_J,axiom,
    ! [N: num] :
      ( ( bit_un7362597486090784418nd_num @ one2 @ ( bit0 @ N ) )
      = ( none @ num ) ) ).

% and_num.simps(2)
thf(fact_5126_and__num_Osimps_I4_J,axiom,
    ! [M: num] :
      ( ( bit_un7362597486090784418nd_num @ ( bit0 @ M ) @ one2 )
      = ( none @ num ) ) ).

% and_num.simps(4)
thf(fact_5127_and__num__eq__Some__iff,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [M: num,N: num,Q3: num] :
          ( ( ( bit_un7362597486090784418nd_num @ M @ N )
            = ( some @ num @ Q3 ) )
          = ( ( bit_se5824344872417868541ns_and @ A @ ( numeral_numeral @ A @ M ) @ ( numeral_numeral @ A @ N ) )
            = ( numeral_numeral @ A @ Q3 ) ) ) ) ).

% and_num_eq_Some_iff
thf(fact_5128_gcd__int__def,axiom,
    ( ( gcd_gcd @ int )
    = ( ^ [X2: int,Y4: int] : ( semiring_1_of_nat @ int @ ( gcd_gcd @ nat @ ( nat2 @ ( abs_abs @ int @ X2 ) ) @ ( nat2 @ ( abs_abs @ int @ Y4 ) ) ) ) ) ) ).

% gcd_int_def
thf(fact_5129_xor__num__eq__Some__iff,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [M: num,N: num,Q3: num] :
          ( ( ( bit_un2480387367778600638or_num @ M @ N )
            = ( some @ num @ Q3 ) )
          = ( ( bit_se5824344971392196577ns_xor @ A @ ( numeral_numeral @ A @ M ) @ ( numeral_numeral @ A @ N ) )
            = ( numeral_numeral @ A @ Q3 ) ) ) ) ).

% xor_num_eq_Some_iff
thf(fact_5130_and__num_Osimps_I8_J,axiom,
    ! [M: num,N: num] :
      ( ( bit_un7362597486090784418nd_num @ ( bit1 @ M ) @ ( bit0 @ N ) )
      = ( map_option @ num @ num @ bit0 @ ( bit_un7362597486090784418nd_num @ M @ N ) ) ) ).

% and_num.simps(8)
thf(fact_5131_and__num_Osimps_I6_J,axiom,
    ! [M: num,N: num] :
      ( ( bit_un7362597486090784418nd_num @ ( bit0 @ M ) @ ( bit1 @ N ) )
      = ( map_option @ num @ num @ bit0 @ ( bit_un7362597486090784418nd_num @ M @ N ) ) ) ).

% and_num.simps(6)
thf(fact_5132_xor__num_Osimps_I9_J,axiom,
    ! [M: num,N: num] :
      ( ( bit_un2480387367778600638or_num @ ( bit1 @ M ) @ ( bit1 @ N ) )
      = ( map_option @ num @ num @ bit0 @ ( bit_un2480387367778600638or_num @ M @ N ) ) ) ).

% xor_num.simps(9)
thf(fact_5133_gcd__nat_Osemilattice__neutr__order__axioms,axiom,
    ( semila1105856199041335345_order @ nat @ ( gcd_gcd @ nat ) @ ( zero_zero @ nat ) @ ( dvd_dvd @ nat )
    @ ^ [M3: nat,N3: nat] :
        ( ( dvd_dvd @ nat @ M3 @ N3 )
        & ( M3 != N3 ) ) ) ).

% gcd_nat.semilattice_neutr_order_axioms
thf(fact_5134_xor__num_Osimps_I2_J,axiom,
    ! [N: num] :
      ( ( bit_un2480387367778600638or_num @ one2 @ ( bit0 @ N ) )
      = ( some @ num @ ( bit1 @ N ) ) ) ).

% xor_num.simps(2)
thf(fact_5135_xor__num_Osimps_I3_J,axiom,
    ! [N: num] :
      ( ( bit_un2480387367778600638or_num @ one2 @ ( bit1 @ N ) )
      = ( some @ num @ ( bit0 @ N ) ) ) ).

% xor_num.simps(3)
thf(fact_5136_xor__num_Osimps_I4_J,axiom,
    ! [M: num] :
      ( ( bit_un2480387367778600638or_num @ ( bit0 @ M ) @ one2 )
      = ( some @ num @ ( bit1 @ M ) ) ) ).

% xor_num.simps(4)
thf(fact_5137_xor__num_Osimps_I7_J,axiom,
    ! [M: num] :
      ( ( bit_un2480387367778600638or_num @ ( bit1 @ M ) @ one2 )
      = ( some @ num @ ( bit0 @ M ) ) ) ).

% xor_num.simps(7)
thf(fact_5138_and__num__eq__None__iff,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [M: num,N: num] :
          ( ( ( bit_un7362597486090784418nd_num @ M @ N )
            = ( none @ num ) )
          = ( ( bit_se5824344872417868541ns_and @ A @ ( numeral_numeral @ A @ M ) @ ( numeral_numeral @ A @ N ) )
            = ( zero_zero @ A ) ) ) ) ).

% and_num_eq_None_iff
thf(fact_5139_xor__num__eq__None__iff,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [M: num,N: num] :
          ( ( ( bit_un2480387367778600638or_num @ M @ N )
            = ( none @ num ) )
          = ( ( bit_se5824344971392196577ns_xor @ A @ ( numeral_numeral @ A @ M ) @ ( numeral_numeral @ A @ N ) )
            = ( zero_zero @ A ) ) ) ) ).

% xor_num_eq_None_iff
thf(fact_5140_numeral__and__num,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [M: num,N: num] :
          ( ( bit_se5824344872417868541ns_and @ A @ ( numeral_numeral @ A @ M ) @ ( numeral_numeral @ A @ N ) )
          = ( case_option @ A @ num @ ( zero_zero @ A ) @ ( numeral_numeral @ A ) @ ( bit_un7362597486090784418nd_num @ M @ N ) ) ) ) ).

% numeral_and_num
thf(fact_5141_numeral__xor__num,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [M: num,N: num] :
          ( ( bit_se5824344971392196577ns_xor @ A @ ( numeral_numeral @ A @ M ) @ ( numeral_numeral @ A @ N ) )
          = ( case_option @ A @ num @ ( zero_zero @ A ) @ ( numeral_numeral @ A ) @ ( bit_un2480387367778600638or_num @ M @ N ) ) ) ) ).

% numeral_xor_num
thf(fact_5142_and__num_Osimps_I9_J,axiom,
    ! [M: num,N: num] :
      ( ( bit_un7362597486090784418nd_num @ ( bit1 @ M ) @ ( bit1 @ N ) )
      = ( case_option @ ( option @ num ) @ num @ ( some @ num @ one2 )
        @ ^ [N10: num] : ( some @ num @ ( bit1 @ N10 ) )
        @ ( bit_un7362597486090784418nd_num @ M @ N ) ) ) ).

% and_num.simps(9)
thf(fact_5143_bezw__aux,axiom,
    ! [X: nat,Y: nat] :
      ( ( semiring_1_of_nat @ int @ ( gcd_gcd @ nat @ X @ Y ) )
      = ( plus_plus @ int @ ( times_times @ int @ ( product_fst @ int @ int @ ( bezw @ X @ Y ) ) @ ( semiring_1_of_nat @ int @ X ) ) @ ( times_times @ int @ ( product_snd @ int @ int @ ( bezw @ X @ Y ) ) @ ( semiring_1_of_nat @ int @ Y ) ) ) ) ).

% bezw_aux
thf(fact_5144_xor__num_Osimps_I6_J,axiom,
    ! [M: num,N: num] :
      ( ( bit_un2480387367778600638or_num @ ( bit0 @ M ) @ ( bit1 @ N ) )
      = ( some @ num @ ( case_option @ num @ num @ one2 @ bit1 @ ( bit_un2480387367778600638or_num @ M @ N ) ) ) ) ).

% xor_num.simps(6)
thf(fact_5145_xor__num_Osimps_I8_J,axiom,
    ! [M: num,N: num] :
      ( ( bit_un2480387367778600638or_num @ ( bit1 @ M ) @ ( bit0 @ N ) )
      = ( some @ num @ ( case_option @ num @ num @ one2 @ bit1 @ ( bit_un2480387367778600638or_num @ M @ N ) ) ) ) ).

% xor_num.simps(8)
thf(fact_5146_gcd__nat_Opelims,axiom,
    ! [X: nat,Xa: nat,Y: nat] :
      ( ( ( gcd_gcd @ nat @ X @ Xa )
        = Y )
     => ( ( accp @ ( product_prod @ nat @ nat ) @ gcd_nat_rel @ ( product_Pair @ nat @ nat @ X @ Xa ) )
       => ~ ( ( ( ( Xa
                  = ( zero_zero @ nat ) )
               => ( Y = X ) )
              & ( ( Xa
                 != ( zero_zero @ nat ) )
               => ( Y
                  = ( gcd_gcd @ nat @ Xa @ ( modulo_modulo @ nat @ X @ Xa ) ) ) ) )
           => ~ ( accp @ ( product_prod @ nat @ nat ) @ gcd_nat_rel @ ( product_Pair @ nat @ nat @ X @ Xa ) ) ) ) ) ).

% gcd_nat.pelims
thf(fact_5147_xor__num__dict,axiom,
    bit_un2480387367778600638or_num = bit_un6178654185764691216or_num ).

% xor_num_dict
thf(fact_5148_and__num__dict,axiom,
    bit_un7362597486090784418nd_num = bit_un1837492267222099188nd_num ).

% and_num_dict
thf(fact_5149_nth__image,axiom,
    ! [A: $tType,L: nat,Xs: list @ A] :
      ( ( ord_less_eq @ nat @ L @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( ( image @ nat @ A @ ( nth @ A @ Xs ) @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ L ) )
        = ( set2 @ A @ ( take @ A @ L @ Xs ) ) ) ) ).

% nth_image
thf(fact_5150_dual__min,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( ( min @ A
          @ ^ [X2: A,Y4: A] : ( ord_less_eq @ A @ Y4 @ X2 ) )
        = ( ord_max @ A ) ) ) ).

% dual_min
thf(fact_5151_card__Min__le__sum,axiom,
    ! [A: $tType,A4: set @ A,F2: A > nat] :
      ( ( finite_finite @ A @ A4 )
     => ( ord_less_eq @ nat @ ( times_times @ nat @ ( finite_card @ A @ A4 ) @ ( lattic643756798350308766er_Min @ nat @ ( image @ A @ nat @ F2 @ A4 ) ) ) @ ( groups7311177749621191930dd_sum @ A @ nat @ F2 @ A4 ) ) ) ).

% card_Min_le_sum
thf(fact_5152_take__all__iff,axiom,
    ! [A: $tType,N: nat,Xs: list @ A] :
      ( ( ( take @ A @ N @ Xs )
        = Xs )
      = ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ N ) ) ).

% take_all_iff
thf(fact_5153_take__all,axiom,
    ! [A: $tType,Xs: list @ A,N: nat] :
      ( ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ N )
     => ( ( take @ A @ N @ Xs )
        = Xs ) ) ).

% take_all
thf(fact_5154_Min__singleton,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A] :
          ( ( lattic643756798350308766er_Min @ A @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
          = X ) ) ).

% Min_singleton
thf(fact_5155_nth__take,axiom,
    ! [A: $tType,I: nat,N: nat,Xs: list @ A] :
      ( ( ord_less @ nat @ I @ N )
     => ( ( nth @ A @ ( take @ A @ N @ Xs ) @ I )
        = ( nth @ A @ Xs @ I ) ) ) ).

% nth_take
thf(fact_5156_take__update__cancel,axiom,
    ! [A: $tType,N: nat,M: nat,Xs: list @ A,Y: A] :
      ( ( ord_less_eq @ nat @ N @ M )
     => ( ( take @ A @ N @ ( list_update @ A @ Xs @ M @ Y ) )
        = ( take @ A @ N @ Xs ) ) ) ).

% take_update_cancel
thf(fact_5157_Min_Obounded__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A4: set @ A,X: A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( A4
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ord_less_eq @ A @ X @ ( lattic643756798350308766er_Min @ A @ A4 ) )
              = ( ! [X2: A] :
                    ( ( member @ A @ X2 @ A4 )
                   => ( ord_less_eq @ A @ X @ X2 ) ) ) ) ) ) ) ).

% Min.bounded_iff
thf(fact_5158_Min__gr__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A4: set @ A,X: A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( A4
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ord_less @ A @ X @ ( lattic643756798350308766er_Min @ A @ A4 ) )
              = ( ! [X2: A] :
                    ( ( member @ A @ X2 @ A4 )
                   => ( ord_less @ A @ X @ X2 ) ) ) ) ) ) ) ).

% Min_gr_iff
thf(fact_5159_Min__const,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linorder @ A )
     => ! [A4: set @ B,C2: A] :
          ( ( finite_finite @ B @ A4 )
         => ( ( A4
             != ( bot_bot @ ( set @ B ) ) )
           => ( ( lattic643756798350308766er_Min @ A
                @ ( image @ B @ A
                  @ ^ [Uu3: B] : C2
                  @ A4 ) )
              = C2 ) ) ) ) ).

% Min_const
thf(fact_5160_ord_Omin_Ocong,axiom,
    ! [A: $tType] :
      ( ( min @ A )
      = ( min @ A ) ) ).

% ord.min.cong
thf(fact_5161_ord_Omin__def,axiom,
    ! [A: $tType] :
      ( ( min @ A )
      = ( ^ [Less_eq2: A > A > $o,A3: A,B3: A] : ( if @ A @ ( Less_eq2 @ A3 @ B3 ) @ A3 @ B3 ) ) ) ).

% ord.min_def
thf(fact_5162_Min__le,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A4: set @ A,X: A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( member @ A @ X @ A4 )
           => ( ord_less_eq @ A @ ( lattic643756798350308766er_Min @ A @ A4 ) @ X ) ) ) ) ).

% Min_le
thf(fact_5163_Min__eqI,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A4: set @ A,X: A] :
          ( ( finite_finite @ A @ A4 )
         => ( ! [Y5: A] :
                ( ( member @ A @ Y5 @ A4 )
               => ( ord_less_eq @ A @ X @ Y5 ) )
           => ( ( member @ A @ X @ A4 )
             => ( ( lattic643756798350308766er_Min @ A @ A4 )
                = X ) ) ) ) ) ).

% Min_eqI
thf(fact_5164_Min_OcoboundedI,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A4: set @ A,A2: A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( member @ A @ A2 @ A4 )
           => ( ord_less_eq @ A @ ( lattic643756798350308766er_Min @ A @ A4 ) @ A2 ) ) ) ) ).

% Min.coboundedI
thf(fact_5165_Min__in,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A4: set @ A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( A4
             != ( bot_bot @ ( set @ A ) ) )
           => ( member @ A @ ( lattic643756798350308766er_Min @ A @ A4 ) @ A4 ) ) ) ) ).

% Min_in
thf(fact_5166_set__take__subset__set__take,axiom,
    ! [A: $tType,M: nat,N: nat,Xs: list @ A] :
      ( ( ord_less_eq @ nat @ M @ N )
     => ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ ( take @ A @ M @ Xs ) ) @ ( set2 @ A @ ( take @ A @ N @ Xs ) ) ) ) ).

% set_take_subset_set_take
thf(fact_5167_Min__eq__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A4: set @ A,M: A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( A4
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ( lattic643756798350308766er_Min @ A @ A4 )
                = M )
              = ( ( member @ A @ M @ A4 )
                & ! [X2: A] :
                    ( ( member @ A @ X2 @ A4 )
                   => ( ord_less_eq @ A @ M @ X2 ) ) ) ) ) ) ) ).

% Min_eq_iff
thf(fact_5168_Min__le__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A4: set @ A,X: A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( A4
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ord_less_eq @ A @ ( lattic643756798350308766er_Min @ A @ A4 ) @ X )
              = ( ? [X2: A] :
                    ( ( member @ A @ X2 @ A4 )
                    & ( ord_less_eq @ A @ X2 @ X ) ) ) ) ) ) ) ).

% Min_le_iff
thf(fact_5169_eq__Min__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A4: set @ A,M: A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( A4
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( M
                = ( lattic643756798350308766er_Min @ A @ A4 ) )
              = ( ( member @ A @ M @ A4 )
                & ! [X2: A] :
                    ( ( member @ A @ X2 @ A4 )
                   => ( ord_less_eq @ A @ M @ X2 ) ) ) ) ) ) ) ).

% eq_Min_iff
thf(fact_5170_Min_OboundedE,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A4: set @ A,X: A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( A4
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ord_less_eq @ A @ X @ ( lattic643756798350308766er_Min @ A @ A4 ) )
             => ! [A9: A] :
                  ( ( member @ A @ A9 @ A4 )
                 => ( ord_less_eq @ A @ X @ A9 ) ) ) ) ) ) ).

% Min.boundedE
thf(fact_5171_Min_OboundedI,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A4: set @ A,X: A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( A4
             != ( bot_bot @ ( set @ A ) ) )
           => ( ! [A5: A] :
                  ( ( member @ A @ A5 @ A4 )
                 => ( ord_less_eq @ A @ X @ A5 ) )
             => ( ord_less_eq @ A @ X @ ( lattic643756798350308766er_Min @ A @ A4 ) ) ) ) ) ) ).

% Min.boundedI
thf(fact_5172_Min__less__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A4: set @ A,X: A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( A4
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ord_less @ A @ ( lattic643756798350308766er_Min @ A @ A4 ) @ X )
              = ( ? [X2: A] :
                    ( ( member @ A @ X2 @ A4 )
                    & ( ord_less @ A @ X2 @ X ) ) ) ) ) ) ) ).

% Min_less_iff
thf(fact_5173_Min__insert2,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A4: set @ A,A2: A] :
          ( ( finite_finite @ A @ A4 )
         => ( ! [B4: A] :
                ( ( member @ A @ B4 @ A4 )
               => ( ord_less_eq @ A @ A2 @ B4 ) )
           => ( ( lattic643756798350308766er_Min @ A @ ( insert @ A @ A2 @ A4 ) )
              = A2 ) ) ) ) ).

% Min_insert2
thf(fact_5174_nth__take__lemma,axiom,
    ! [A: $tType,K: nat,Xs: list @ A,Ys3: list @ A] :
      ( ( ord_less_eq @ nat @ K @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( ( ord_less_eq @ nat @ K @ ( size_size @ ( list @ A ) @ Ys3 ) )
       => ( ! [I2: nat] :
              ( ( ord_less @ nat @ I2 @ K )
             => ( ( nth @ A @ Xs @ I2 )
                = ( nth @ A @ Ys3 @ I2 ) ) )
         => ( ( take @ A @ K @ Xs )
            = ( take @ A @ K @ Ys3 ) ) ) ) ) ).

% nth_take_lemma
thf(fact_5175_Min__antimono,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [M5: set @ A,N4: set @ A] :
          ( ( ord_less_eq @ ( set @ A ) @ M5 @ N4 )
         => ( ( M5
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( finite_finite @ A @ N4 )
             => ( ord_less_eq @ A @ ( lattic643756798350308766er_Min @ A @ N4 ) @ ( lattic643756798350308766er_Min @ A @ M5 ) ) ) ) ) ) ).

% Min_antimono
thf(fact_5176_Min_Osubset__imp,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A4: set @ A,B7: set @ A] :
          ( ( ord_less_eq @ ( set @ A ) @ A4 @ B7 )
         => ( ( A4
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( finite_finite @ A @ B7 )
             => ( ord_less_eq @ A @ ( lattic643756798350308766er_Min @ A @ B7 ) @ ( lattic643756798350308766er_Min @ A @ A4 ) ) ) ) ) ) ).

% Min.subset_imp
thf(fact_5177_Min__add__commute,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linord4140545234300271783up_add @ A )
     => ! [S: set @ B,F2: B > A,K: A] :
          ( ( finite_finite @ B @ S )
         => ( ( S
             != ( bot_bot @ ( set @ B ) ) )
           => ( ( lattic643756798350308766er_Min @ A
                @ ( image @ B @ A
                  @ ^ [X2: B] : ( plus_plus @ A @ ( F2 @ X2 ) @ K )
                  @ S ) )
              = ( plus_plus @ A @ ( lattic643756798350308766er_Min @ A @ ( image @ B @ A @ F2 @ S ) ) @ K ) ) ) ) ) ).

% Min_add_commute
thf(fact_5178_arg__min__SOME__Min,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linorder @ B )
     => ! [S: set @ A,F2: A > B] :
          ( ( finite_finite @ A @ S )
         => ( ( lattic7623131987881927897min_on @ A @ B @ F2 @ S )
            = ( fChoice @ A
              @ ^ [Y4: A] :
                  ( ( member @ A @ Y4 @ S )
                  & ( ( F2 @ Y4 )
                    = ( lattic643756798350308766er_Min @ B @ ( image @ A @ B @ F2 @ S ) ) ) ) ) ) ) ) ).

% arg_min_SOME_Min
thf(fact_5179_take__bit__horner__sum__bit__eq,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [N: nat,Bs: list @ $o] :
          ( ( bit_se2584673776208193580ke_bit @ A @ N @ ( groups4207007520872428315er_sum @ $o @ A @ ( zero_neq_one_of_bool @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ Bs ) )
          = ( groups4207007520872428315er_sum @ $o @ A @ ( zero_neq_one_of_bool @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( take @ $o @ N @ Bs ) ) ) ) ).

% take_bit_horner_sum_bit_eq
thf(fact_5180_dual__Max,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( ( lattices_Max @ A
          @ ^ [X2: A,Y4: A] : ( ord_less_eq @ A @ Y4 @ X2 ) )
        = ( lattic643756798350308766er_Min @ A ) ) ) ).

% dual_Max
thf(fact_5181_lex__take__index,axiom,
    ! [A: $tType,Xs: list @ A,Ys3: list @ A,R2: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Ys3 ) @ ( lex @ A @ R2 ) )
     => ~ ! [I2: nat] :
            ( ( ord_less @ nat @ I2 @ ( size_size @ ( list @ A ) @ Xs ) )
           => ( ( ord_less @ nat @ I2 @ ( size_size @ ( list @ A ) @ Ys3 ) )
             => ( ( ( take @ A @ I2 @ Xs )
                  = ( take @ A @ I2 @ Ys3 ) )
               => ~ ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ ( nth @ A @ Xs @ I2 ) @ ( nth @ A @ Ys3 @ I2 ) ) @ R2 ) ) ) ) ) ).

% lex_take_index
thf(fact_5182_minus__Min__eq__Max,axiom,
    ! [A: $tType] :
      ( ( linord5086331880401160121up_add @ A )
     => ! [S: set @ A] :
          ( ( finite_finite @ A @ S )
         => ( ( S
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( uminus_uminus @ A @ ( lattic643756798350308766er_Min @ A @ S ) )
              = ( lattic643756798349783984er_Max @ A @ ( image @ A @ A @ ( uminus_uminus @ A ) @ S ) ) ) ) ) ) ).

% minus_Min_eq_Max
thf(fact_5183_Max__divisors__self__nat,axiom,
    ! [N: nat] :
      ( ( N
       != ( zero_zero @ nat ) )
     => ( ( lattic643756798349783984er_Max @ nat
          @ ( collect @ nat
            @ ^ [D4: nat] : ( dvd_dvd @ nat @ D4 @ N ) ) )
        = N ) ) ).

% Max_divisors_self_nat
thf(fact_5184_Max__singleton,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A] :
          ( ( lattic643756798349783984er_Max @ A @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
          = X ) ) ).

% Max_singleton
thf(fact_5185_Max__divisors__self__int,axiom,
    ! [N: int] :
      ( ( N
       != ( zero_zero @ int ) )
     => ( ( lattic643756798349783984er_Max @ int
          @ ( collect @ int
            @ ^ [D4: int] : ( dvd_dvd @ int @ D4 @ N ) ) )
        = ( abs_abs @ int @ N ) ) ) ).

% Max_divisors_self_int
thf(fact_5186_Max_Obounded__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A4: set @ A,X: A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( A4
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ord_less_eq @ A @ ( lattic643756798349783984er_Max @ A @ A4 ) @ X )
              = ( ! [X2: A] :
                    ( ( member @ A @ X2 @ A4 )
                   => ( ord_less_eq @ A @ X2 @ X ) ) ) ) ) ) ) ).

% Max.bounded_iff
thf(fact_5187_Max__less__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A4: set @ A,X: A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( A4
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ord_less @ A @ ( lattic643756798349783984er_Max @ A @ A4 ) @ X )
              = ( ! [X2: A] :
                    ( ( member @ A @ X2 @ A4 )
                   => ( ord_less @ A @ X2 @ X ) ) ) ) ) ) ) ).

% Max_less_iff
thf(fact_5188_Max__const,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linorder @ A )
     => ! [A4: set @ B,C2: A] :
          ( ( finite_finite @ B @ A4 )
         => ( ( A4
             != ( bot_bot @ ( set @ B ) ) )
           => ( ( lattic643756798349783984er_Max @ A
                @ ( image @ B @ A
                  @ ^ [Uu3: B] : C2
                  @ A4 ) )
              = C2 ) ) ) ) ).

% Max_const
thf(fact_5189_Max__insert,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A4: set @ A,X: A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( A4
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( lattic643756798349783984er_Max @ A @ ( insert @ A @ X @ A4 ) )
              = ( ord_max @ A @ X @ ( lattic643756798349783984er_Max @ A @ A4 ) ) ) ) ) ) ).

% Max_insert
thf(fact_5190_minus__Max__eq__Min,axiom,
    ! [A: $tType] :
      ( ( linord5086331880401160121up_add @ A )
     => ! [S: set @ A] :
          ( ( finite_finite @ A @ S )
         => ( ( S
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( uminus_uminus @ A @ ( lattic643756798349783984er_Max @ A @ S ) )
              = ( lattic643756798350308766er_Min @ A @ ( image @ A @ A @ ( uminus_uminus @ A ) @ S ) ) ) ) ) ) ).

% minus_Max_eq_Min
thf(fact_5191_linorder_OMax_Ocong,axiom,
    ! [A: $tType] :
      ( ( lattices_Max @ A )
      = ( lattices_Max @ A ) ) ).

% linorder.Max.cong
thf(fact_5192_Max_OcoboundedI,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A4: set @ A,A2: A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( member @ A @ A2 @ A4 )
           => ( ord_less_eq @ A @ A2 @ ( lattic643756798349783984er_Max @ A @ A4 ) ) ) ) ) ).

% Max.coboundedI
thf(fact_5193_Max__eq__if,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A4: set @ A,B7: set @ A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( finite_finite @ A @ B7 )
           => ( ! [X3: A] :
                  ( ( member @ A @ X3 @ A4 )
                 => ? [Xa2: A] :
                      ( ( member @ A @ Xa2 @ B7 )
                      & ( ord_less_eq @ A @ X3 @ Xa2 ) ) )
             => ( ! [X3: A] :
                    ( ( member @ A @ X3 @ B7 )
                   => ? [Xa2: A] :
                        ( ( member @ A @ Xa2 @ A4 )
                        & ( ord_less_eq @ A @ X3 @ Xa2 ) ) )
               => ( ( lattic643756798349783984er_Max @ A @ A4 )
                  = ( lattic643756798349783984er_Max @ A @ B7 ) ) ) ) ) ) ) ).

% Max_eq_if
thf(fact_5194_Max__eqI,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A4: set @ A,X: A] :
          ( ( finite_finite @ A @ A4 )
         => ( ! [Y5: A] :
                ( ( member @ A @ Y5 @ A4 )
               => ( ord_less_eq @ A @ Y5 @ X ) )
           => ( ( member @ A @ X @ A4 )
             => ( ( lattic643756798349783984er_Max @ A @ A4 )
                = X ) ) ) ) ) ).

% Max_eqI
thf(fact_5195_Max__ge,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A4: set @ A,X: A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( member @ A @ X @ A4 )
           => ( ord_less_eq @ A @ X @ ( lattic643756798349783984er_Max @ A @ A4 ) ) ) ) ) ).

% Max_ge
thf(fact_5196_Max__in,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A4: set @ A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( A4
             != ( bot_bot @ ( set @ A ) ) )
           => ( member @ A @ ( lattic643756798349783984er_Max @ A @ A4 ) @ A4 ) ) ) ) ).

% Max_in
thf(fact_5197_Max_Oin__idem,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A4: set @ A,X: A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( member @ A @ X @ A4 )
           => ( ( ord_max @ A @ X @ ( lattic643756798349783984er_Max @ A @ A4 ) )
              = ( lattic643756798349783984er_Max @ A @ A4 ) ) ) ) ) ).

% Max.in_idem
thf(fact_5198_Max_OboundedI,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A4: set @ A,X: A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( A4
             != ( bot_bot @ ( set @ A ) ) )
           => ( ! [A5: A] :
                  ( ( member @ A @ A5 @ A4 )
                 => ( ord_less_eq @ A @ A5 @ X ) )
             => ( ord_less_eq @ A @ ( lattic643756798349783984er_Max @ A @ A4 ) @ X ) ) ) ) ) ).

% Max.boundedI
thf(fact_5199_Max_OboundedE,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A4: set @ A,X: A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( A4
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ord_less_eq @ A @ ( lattic643756798349783984er_Max @ A @ A4 ) @ X )
             => ! [A9: A] :
                  ( ( member @ A @ A9 @ A4 )
                 => ( ord_less_eq @ A @ A9 @ X ) ) ) ) ) ) ).

% Max.boundedE
thf(fact_5200_eq__Max__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A4: set @ A,M: A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( A4
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( M
                = ( lattic643756798349783984er_Max @ A @ A4 ) )
              = ( ( member @ A @ M @ A4 )
                & ! [X2: A] :
                    ( ( member @ A @ X2 @ A4 )
                   => ( ord_less_eq @ A @ X2 @ M ) ) ) ) ) ) ) ).

% eq_Max_iff
thf(fact_5201_Max__ge__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A4: set @ A,X: A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( A4
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ord_less_eq @ A @ X @ ( lattic643756798349783984er_Max @ A @ A4 ) )
              = ( ? [X2: A] :
                    ( ( member @ A @ X2 @ A4 )
                    & ( ord_less_eq @ A @ X @ X2 ) ) ) ) ) ) ) ).

% Max_ge_iff
thf(fact_5202_Max__eq__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A4: set @ A,M: A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( A4
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ( lattic643756798349783984er_Max @ A @ A4 )
                = M )
              = ( ( member @ A @ M @ A4 )
                & ! [X2: A] :
                    ( ( member @ A @ X2 @ A4 )
                   => ( ord_less_eq @ A @ X2 @ M ) ) ) ) ) ) ) ).

% Max_eq_iff
thf(fact_5203_Max__gr__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A4: set @ A,X: A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( A4
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ord_less @ A @ X @ ( lattic643756798349783984er_Max @ A @ A4 ) )
              = ( ? [X2: A] :
                    ( ( member @ A @ X2 @ A4 )
                    & ( ord_less @ A @ X @ X2 ) ) ) ) ) ) ) ).

% Max_gr_iff
thf(fact_5204_Max__insert2,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A4: set @ A,A2: A] :
          ( ( finite_finite @ A @ A4 )
         => ( ! [B4: A] :
                ( ( member @ A @ B4 @ A4 )
               => ( ord_less_eq @ A @ B4 @ A2 ) )
           => ( ( lattic643756798349783984er_Max @ A @ ( insert @ A @ A2 @ A4 ) )
              = A2 ) ) ) ) ).

% Max_insert2
thf(fact_5205_gcd__is__Max__divisors__int,axiom,
    ! [N: int,M: int] :
      ( ( N
       != ( zero_zero @ int ) )
     => ( ( gcd_gcd @ int @ M @ N )
        = ( lattic643756798349783984er_Max @ int
          @ ( collect @ int
            @ ^ [D4: int] :
                ( ( dvd_dvd @ int @ D4 @ M )
                & ( dvd_dvd @ int @ D4 @ N ) ) ) ) ) ) ).

% gcd_is_Max_divisors_int
thf(fact_5206_Max_Osubset__imp,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A4: set @ A,B7: set @ A] :
          ( ( ord_less_eq @ ( set @ A ) @ A4 @ B7 )
         => ( ( A4
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( finite_finite @ A @ B7 )
             => ( ord_less_eq @ A @ ( lattic643756798349783984er_Max @ A @ A4 ) @ ( lattic643756798349783984er_Max @ A @ B7 ) ) ) ) ) ) ).

% Max.subset_imp
thf(fact_5207_Max__mono,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [M5: set @ A,N4: set @ A] :
          ( ( ord_less_eq @ ( set @ A ) @ M5 @ N4 )
         => ( ( M5
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( finite_finite @ A @ N4 )
             => ( ord_less_eq @ A @ ( lattic643756798349783984er_Max @ A @ M5 ) @ ( lattic643756798349783984er_Max @ A @ N4 ) ) ) ) ) ) ).

% Max_mono
thf(fact_5208_hom__Max__commute,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [H2: A > A,N4: set @ A] :
          ( ! [X3: A,Y5: A] :
              ( ( H2 @ ( ord_max @ A @ X3 @ Y5 ) )
              = ( ord_max @ A @ ( H2 @ X3 ) @ ( H2 @ Y5 ) ) )
         => ( ( finite_finite @ A @ N4 )
           => ( ( N4
               != ( bot_bot @ ( set @ A ) ) )
             => ( ( H2 @ ( lattic643756798349783984er_Max @ A @ N4 ) )
                = ( lattic643756798349783984er_Max @ A @ ( image @ A @ A @ H2 @ N4 ) ) ) ) ) ) ) ).

% hom_Max_commute
thf(fact_5209_Max_Osubset,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A4: set @ A,B7: set @ A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( B7
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ord_less_eq @ ( set @ A ) @ B7 @ A4 )
             => ( ( ord_max @ A @ ( lattic643756798349783984er_Max @ A @ B7 ) @ ( lattic643756798349783984er_Max @ A @ A4 ) )
                = ( lattic643756798349783984er_Max @ A @ A4 ) ) ) ) ) ) ).

% Max.subset
thf(fact_5210_Max_Oclosed,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A4: set @ A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( A4
             != ( bot_bot @ ( set @ A ) ) )
           => ( ! [X3: A,Y5: A] : ( member @ A @ ( ord_max @ A @ X3 @ Y5 ) @ ( insert @ A @ X3 @ ( insert @ A @ Y5 @ ( bot_bot @ ( set @ A ) ) ) ) )
             => ( member @ A @ ( lattic643756798349783984er_Max @ A @ A4 ) @ A4 ) ) ) ) ) ).

% Max.closed
thf(fact_5211_Max_Oinsert__not__elem,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A4: set @ A,X: A] :
          ( ( finite_finite @ A @ A4 )
         => ( ~ ( member @ A @ X @ A4 )
           => ( ( A4
               != ( bot_bot @ ( set @ A ) ) )
             => ( ( lattic643756798349783984er_Max @ A @ ( insert @ A @ X @ A4 ) )
                = ( ord_max @ A @ X @ ( lattic643756798349783984er_Max @ A @ A4 ) ) ) ) ) ) ) ).

% Max.insert_not_elem
thf(fact_5212_card__le__Suc__Max,axiom,
    ! [S: set @ nat] :
      ( ( finite_finite @ nat @ S )
     => ( ord_less_eq @ nat @ ( finite_card @ nat @ S ) @ ( suc @ ( lattic643756798349783984er_Max @ nat @ S ) ) ) ) ).

% card_le_Suc_Max
thf(fact_5213_divide__nat__def,axiom,
    ( ( divide_divide @ nat )
    = ( ^ [M3: nat,N3: nat] :
          ( if @ nat
          @ ( N3
            = ( zero_zero @ nat ) )
          @ ( zero_zero @ nat )
          @ ( lattic643756798349783984er_Max @ nat
            @ ( collect @ nat
              @ ^ [K3: nat] : ( ord_less_eq @ nat @ ( times_times @ nat @ K3 @ N3 ) @ M3 ) ) ) ) ) ) ).

% divide_nat_def
thf(fact_5214_Max__add__commute,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linord4140545234300271783up_add @ A )
     => ! [S: set @ B,F2: B > A,K: A] :
          ( ( finite_finite @ B @ S )
         => ( ( S
             != ( bot_bot @ ( set @ B ) ) )
           => ( ( lattic643756798349783984er_Max @ A
                @ ( image @ B @ A
                  @ ^ [X2: B] : ( plus_plus @ A @ ( F2 @ X2 ) @ K )
                  @ S ) )
              = ( plus_plus @ A @ ( lattic643756798349783984er_Max @ A @ ( image @ B @ A @ F2 @ S ) ) @ K ) ) ) ) ) ).

% Max_add_commute
thf(fact_5215_gcd__is__Max__divisors__nat,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( gcd_gcd @ nat @ M @ N )
        = ( lattic643756798349783984er_Max @ nat
          @ ( collect @ nat
            @ ^ [D4: nat] :
                ( ( dvd_dvd @ nat @ D4 @ M )
                & ( dvd_dvd @ nat @ D4 @ N ) ) ) ) ) ) ).

% gcd_is_Max_divisors_nat
thf(fact_5216_Max_Oremove,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A4: set @ A,X: A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( member @ A @ X @ A4 )
           => ( ( ( ( minus_minus @ ( set @ A ) @ A4 @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
                  = ( bot_bot @ ( set @ A ) ) )
               => ( ( lattic643756798349783984er_Max @ A @ A4 )
                  = X ) )
              & ( ( ( minus_minus @ ( set @ A ) @ A4 @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
                 != ( bot_bot @ ( set @ A ) ) )
               => ( ( lattic643756798349783984er_Max @ A @ A4 )
                  = ( ord_max @ A @ X @ ( lattic643756798349783984er_Max @ A @ ( minus_minus @ ( set @ A ) @ A4 @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ) ) ) ) ).

% Max.remove
thf(fact_5217_Max_Oinsert__remove,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A4: set @ A,X: A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( ( ( minus_minus @ ( set @ A ) @ A4 @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
                = ( bot_bot @ ( set @ A ) ) )
             => ( ( lattic643756798349783984er_Max @ A @ ( insert @ A @ X @ A4 ) )
                = X ) )
            & ( ( ( minus_minus @ ( set @ A ) @ A4 @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
               != ( bot_bot @ ( set @ A ) ) )
             => ( ( lattic643756798349783984er_Max @ A @ ( insert @ A @ X @ A4 ) )
                = ( ord_max @ A @ X @ ( lattic643756798349783984er_Max @ A @ ( minus_minus @ ( set @ A ) @ A4 @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ) ) ) ).

% Max.insert_remove
thf(fact_5218_sum__le__card__Max,axiom,
    ! [A: $tType,A4: set @ A,F2: A > nat] :
      ( ( finite_finite @ A @ A4 )
     => ( ord_less_eq @ nat @ ( groups7311177749621191930dd_sum @ A @ nat @ F2 @ A4 ) @ ( times_times @ nat @ ( finite_card @ A @ A4 ) @ ( lattic643756798349783984er_Max @ nat @ ( image @ A @ nat @ F2 @ A4 ) ) ) ) ) ).

% sum_le_card_Max
thf(fact_5219_dual__Min,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( ( lattices_Min @ A
          @ ^ [X2: A,Y4: A] : ( ord_less_eq @ A @ Y4 @ X2 ) )
        = ( lattic643756798349783984er_Max @ A ) ) ) ).

% dual_Min
thf(fact_5220_listrel1__iff__update,axiom,
    ! [A: $tType,Xs: list @ A,Ys3: list @ A,R2: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs @ Ys3 ) @ ( listrel1 @ A @ R2 ) )
      = ( ? [Y4: A,N3: nat] :
            ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ ( nth @ A @ Xs @ N3 ) @ Y4 ) @ R2 )
            & ( ord_less @ nat @ N3 @ ( size_size @ ( list @ A ) @ Xs ) )
            & ( Ys3
              = ( list_update @ A @ Xs @ N3 @ Y4 ) ) ) ) ) ).

% listrel1_iff_update
thf(fact_5221_lenlex__conv,axiom,
    ! [A: $tType] :
      ( ( lenlex @ A )
      = ( ^ [R5: set @ ( product_prod @ A @ A )] :
            ( collect @ ( product_prod @ ( list @ A ) @ ( list @ A ) )
            @ ( product_case_prod @ ( list @ A ) @ ( list @ A ) @ $o
              @ ^ [Xs3: list @ A,Ys2: list @ A] :
                  ( ( ord_less @ nat @ ( size_size @ ( list @ A ) @ Xs3 ) @ ( size_size @ ( list @ A ) @ Ys2 ) )
                  | ( ( ( size_size @ ( list @ A ) @ Xs3 )
                      = ( size_size @ ( list @ A ) @ Ys2 ) )
                    & ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs3 @ Ys2 ) @ ( lex @ A @ R5 ) ) ) ) ) ) ) ) ).

% lenlex_conv
thf(fact_5222_linorder_OMin_Ocong,axiom,
    ! [A: $tType] :
      ( ( lattices_Min @ A )
      = ( lattices_Min @ A ) ) ).

% linorder.Min.cong
thf(fact_5223_lenlex__length,axiom,
    ! [A: $tType,Ms: list @ A,Ns: list @ A,R2: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Ms @ Ns ) @ ( lenlex @ A @ R2 ) )
     => ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ Ms ) @ ( size_size @ ( list @ A ) @ Ns ) ) ) ).

% lenlex_length
thf(fact_5224_Gcd__eq__Max,axiom,
    ! [M5: set @ nat] :
      ( ( finite_finite @ nat @ M5 )
     => ( ( M5
         != ( bot_bot @ ( set @ nat ) ) )
       => ( ~ ( member @ nat @ ( zero_zero @ nat ) @ M5 )
         => ( ( gcd_Gcd @ nat @ M5 )
            = ( lattic643756798349783984er_Max @ nat
              @ ( complete_Inf_Inf @ ( set @ nat )
                @ ( image @ nat @ ( set @ nat )
                  @ ^ [M3: nat] :
                      ( collect @ nat
                      @ ^ [D4: nat] : ( dvd_dvd @ nat @ D4 @ M3 ) )
                  @ M5 ) ) ) ) ) ) ) ).

% Gcd_eq_Max
thf(fact_5225_mask__mod__exp,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [N: nat,M: nat] :
          ( ( modulo_modulo @ A @ ( minus_minus @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) @ ( one_one @ A ) ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M ) )
          = ( minus_minus @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( ord_min @ nat @ M @ N ) ) @ ( one_one @ A ) ) ) ) ).

% mask_mod_exp
thf(fact_5226_find__Some__iff2,axiom,
    ! [A: $tType,X: A,P: A > $o,Xs: list @ A] :
      ( ( ( some @ A @ X )
        = ( find @ A @ P @ Xs ) )
      = ( ? [I4: nat] :
            ( ( ord_less @ nat @ I4 @ ( size_size @ ( list @ A ) @ Xs ) )
            & ( P @ ( nth @ A @ Xs @ I4 ) )
            & ( X
              = ( nth @ A @ Xs @ I4 ) )
            & ! [J3: nat] :
                ( ( ord_less @ nat @ J3 @ I4 )
               => ~ ( P @ ( nth @ A @ Xs @ J3 ) ) ) ) ) ) ).

% find_Some_iff2
thf(fact_5227_min_Oidem,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A] :
          ( ( ord_min @ A @ A2 @ A2 )
          = A2 ) ) ).

% min.idem
thf(fact_5228_min_Oleft__idem,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_min @ A @ A2 @ ( ord_min @ A @ A2 @ B2 ) )
          = ( ord_min @ A @ A2 @ B2 ) ) ) ).

% min.left_idem
thf(fact_5229_min_Oright__idem,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_min @ A @ ( ord_min @ A @ A2 @ B2 ) @ B2 )
          = ( ord_min @ A @ A2 @ B2 ) ) ) ).

% min.right_idem
thf(fact_5230_min_Oabsorb1,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_min @ A @ A2 @ B2 )
            = A2 ) ) ) ).

% min.absorb1
thf(fact_5231_min_Oabsorb2,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less_eq @ A @ B2 @ A2 )
         => ( ( ord_min @ A @ A2 @ B2 )
            = B2 ) ) ) ).

% min.absorb2
thf(fact_5232_min_Obounded__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ ( ord_min @ A @ B2 @ C2 ) )
          = ( ( ord_less_eq @ A @ A2 @ B2 )
            & ( ord_less_eq @ A @ A2 @ C2 ) ) ) ) ).

% min.bounded_iff
thf(fact_5233_min_Oabsorb3,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_min @ A @ A2 @ B2 )
            = A2 ) ) ) ).

% min.absorb3
thf(fact_5234_min_Oabsorb4,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less @ A @ B2 @ A2 )
         => ( ( ord_min @ A @ A2 @ B2 )
            = B2 ) ) ) ).

% min.absorb4
thf(fact_5235_min__less__iff__conj,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Z: A,X: A,Y: A] :
          ( ( ord_less @ A @ Z @ ( ord_min @ A @ X @ Y ) )
          = ( ( ord_less @ A @ Z @ X )
            & ( ord_less @ A @ Z @ Y ) ) ) ) ).

% min_less_iff_conj
thf(fact_5236_min__bot2,axiom,
    ! [A: $tType] :
      ( ( order_bot @ A )
     => ! [X: A] :
          ( ( ord_min @ A @ X @ ( bot_bot @ A ) )
          = ( bot_bot @ A ) ) ) ).

% min_bot2
thf(fact_5237_min__bot,axiom,
    ! [A: $tType] :
      ( ( order_bot @ A )
     => ! [X: A] :
          ( ( ord_min @ A @ ( bot_bot @ A ) @ X )
          = ( bot_bot @ A ) ) ) ).

% min_bot
thf(fact_5238_max__min__same_I4_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Y: A,X: A] :
          ( ( ord_max @ A @ Y @ ( ord_min @ A @ X @ Y ) )
          = Y ) ) ).

% max_min_same(4)
thf(fact_5239_max__min__same_I3_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A,Y: A] :
          ( ( ord_max @ A @ ( ord_min @ A @ X @ Y ) @ Y )
          = Y ) ) ).

% max_min_same(3)
thf(fact_5240_max__min__same_I2_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A,Y: A] :
          ( ( ord_max @ A @ ( ord_min @ A @ X @ Y ) @ X )
          = X ) ) ).

% max_min_same(2)
thf(fact_5241_max__min__same_I1_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A,Y: A] :
          ( ( ord_max @ A @ X @ ( ord_min @ A @ X @ Y ) )
          = X ) ) ).

% max_min_same(1)
thf(fact_5242_min__Suc__Suc,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_min @ nat @ ( suc @ M ) @ ( suc @ N ) )
      = ( suc @ ( ord_min @ nat @ M @ N ) ) ) ).

% min_Suc_Suc
thf(fact_5243_min__0L,axiom,
    ! [N: nat] :
      ( ( ord_min @ nat @ ( zero_zero @ nat ) @ N )
      = ( zero_zero @ nat ) ) ).

% min_0L
thf(fact_5244_min__0R,axiom,
    ! [N: nat] :
      ( ( ord_min @ nat @ N @ ( zero_zero @ nat ) )
      = ( zero_zero @ nat ) ) ).

% min_0R
thf(fact_5245_take__bit__take__bit,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M: nat,N: nat,A2: A] :
          ( ( bit_se2584673776208193580ke_bit @ A @ M @ ( bit_se2584673776208193580ke_bit @ A @ N @ A2 ) )
          = ( bit_se2584673776208193580ke_bit @ A @ ( ord_min @ nat @ M @ N ) @ A2 ) ) ) ).

% take_bit_take_bit
thf(fact_5246_signed__take__bit__signed__take__bit,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [M: nat,N: nat,A2: A] :
          ( ( bit_ri4674362597316999326ke_bit @ A @ M @ ( bit_ri4674362597316999326ke_bit @ A @ N @ A2 ) )
          = ( bit_ri4674362597316999326ke_bit @ A @ ( ord_min @ nat @ M @ N ) @ A2 ) ) ) ).

% signed_take_bit_signed_take_bit
thf(fact_5247_min__number__of_I1_J,axiom,
    ! [A: $tType] :
      ( ( ( numeral @ A )
        & ( ord @ A ) )
     => ! [U: num,V: num] :
          ( ( ( ord_less_eq @ A @ ( numeral_numeral @ A @ U ) @ ( numeral_numeral @ A @ V ) )
           => ( ( ord_min @ A @ ( numeral_numeral @ A @ U ) @ ( numeral_numeral @ A @ V ) )
              = ( numeral_numeral @ A @ U ) ) )
          & ( ~ ( ord_less_eq @ A @ ( numeral_numeral @ A @ U ) @ ( numeral_numeral @ A @ V ) )
           => ( ( ord_min @ A @ ( numeral_numeral @ A @ U ) @ ( numeral_numeral @ A @ V ) )
              = ( numeral_numeral @ A @ V ) ) ) ) ) ).

% min_number_of(1)
thf(fact_5248_min__0__1_I3_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [X: num] :
          ( ( ord_min @ A @ ( zero_zero @ A ) @ ( numeral_numeral @ A @ X ) )
          = ( zero_zero @ A ) ) ) ).

% min_0_1(3)
thf(fact_5249_min__0__1_I4_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [X: num] :
          ( ( ord_min @ A @ ( numeral_numeral @ A @ X ) @ ( zero_zero @ A ) )
          = ( zero_zero @ A ) ) ) ).

% min_0_1(4)
thf(fact_5250_min__0__1_I2_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ( ( ord_min @ A @ ( one_one @ A ) @ ( zero_zero @ A ) )
        = ( zero_zero @ A ) ) ) ).

% min_0_1(2)
thf(fact_5251_min__0__1_I1_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ( ( ord_min @ A @ ( zero_zero @ A ) @ ( one_one @ A ) )
        = ( zero_zero @ A ) ) ) ).

% min_0_1(1)
thf(fact_5252_cInf__atLeastAtMost,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [Y: A,X: A] :
          ( ( ord_less_eq @ A @ Y @ X )
         => ( ( complete_Inf_Inf @ A @ ( set_or1337092689740270186AtMost @ A @ Y @ X ) )
            = Y ) ) ) ).

% cInf_atLeastAtMost
thf(fact_5253_Inf__atLeastAtMost,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ A @ X @ Y )
         => ( ( complete_Inf_Inf @ A @ ( set_or1337092689740270186AtMost @ A @ X @ Y ) )
            = X ) ) ) ).

% Inf_atLeastAtMost
thf(fact_5254_min__0__1_I5_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [X: num] :
          ( ( ord_min @ A @ ( one_one @ A ) @ ( numeral_numeral @ A @ X ) )
          = ( one_one @ A ) ) ) ).

% min_0_1(5)
thf(fact_5255_min__0__1_I6_J,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [X: num] :
          ( ( ord_min @ A @ ( numeral_numeral @ A @ X ) @ ( one_one @ A ) )
          = ( one_one @ A ) ) ) ).

% min_0_1(6)
thf(fact_5256_cInf__singleton,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [X: A] :
          ( ( complete_Inf_Inf @ A @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
          = X ) ) ).

% cInf_singleton
thf(fact_5257_cInf__atLeastLessThan,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [Y: A,X: A] :
          ( ( ord_less @ A @ Y @ X )
         => ( ( complete_Inf_Inf @ A @ ( set_or7035219750837199246ssThan @ A @ Y @ X ) )
            = Y ) ) ) ).

% cInf_atLeastLessThan
thf(fact_5258_Inf__atLeastLessThan,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less @ A @ X @ Y )
         => ( ( complete_Inf_Inf @ A @ ( set_or7035219750837199246ssThan @ A @ X @ Y ) )
            = X ) ) ) ).

% Inf_atLeastLessThan
thf(fact_5259_cINF__const,axiom,
    ! [B: $tType,A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [A4: set @ B,C2: A] :
          ( ( A4
           != ( bot_bot @ ( set @ B ) ) )
         => ( ( complete_Inf_Inf @ A
              @ ( image @ B @ A
                @ ^ [X2: B] : C2
                @ A4 ) )
            = C2 ) ) ) ).

% cINF_const
thf(fact_5260_take__bit__of__mask,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M: nat,N: nat] :
          ( ( bit_se2584673776208193580ke_bit @ A @ M @ ( bit_se2239418461657761734s_mask @ A @ N ) )
          = ( bit_se2239418461657761734s_mask @ A @ ( ord_min @ nat @ M @ N ) ) ) ) ).

% take_bit_of_mask
thf(fact_5261_min__number__of_I4_J,axiom,
    ! [A: $tType] :
      ( ( ( uminus @ A )
        & ( numeral @ A )
        & ( ord @ A ) )
     => ! [U: num,V: num] :
          ( ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ U ) ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) )
           => ( ( ord_min @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ U ) ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) )
              = ( uminus_uminus @ A @ ( numeral_numeral @ A @ U ) ) ) )
          & ( ~ ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ U ) ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) )
           => ( ( ord_min @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ U ) ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) )
              = ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) ) ) ) ) ).

% min_number_of(4)
thf(fact_5262_min__number__of_I3_J,axiom,
    ! [A: $tType] :
      ( ( ( uminus @ A )
        & ( numeral @ A )
        & ( ord @ A ) )
     => ! [U: num,V: num] :
          ( ( ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ U ) ) @ ( numeral_numeral @ A @ V ) )
           => ( ( ord_min @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ U ) ) @ ( numeral_numeral @ A @ V ) )
              = ( uminus_uminus @ A @ ( numeral_numeral @ A @ U ) ) ) )
          & ( ~ ( ord_less_eq @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ U ) ) @ ( numeral_numeral @ A @ V ) )
           => ( ( ord_min @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ U ) ) @ ( numeral_numeral @ A @ V ) )
              = ( numeral_numeral @ A @ V ) ) ) ) ) ).

% min_number_of(3)
thf(fact_5263_min__number__of_I2_J,axiom,
    ! [A: $tType] :
      ( ( ( uminus @ A )
        & ( numeral @ A )
        & ( ord @ A ) )
     => ! [U: num,V: num] :
          ( ( ( ord_less_eq @ A @ ( numeral_numeral @ A @ U ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) )
           => ( ( ord_min @ A @ ( numeral_numeral @ A @ U ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) )
              = ( numeral_numeral @ A @ U ) ) )
          & ( ~ ( ord_less_eq @ A @ ( numeral_numeral @ A @ U ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) )
           => ( ( ord_min @ A @ ( numeral_numeral @ A @ U ) @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) )
              = ( uminus_uminus @ A @ ( numeral_numeral @ A @ V ) ) ) ) ) ) ).

% min_number_of(2)
thf(fact_5264_Int__atLeastAtMost,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( inf_inf @ ( set @ A ) @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) @ ( set_or1337092689740270186AtMost @ A @ C2 @ D2 ) )
          = ( set_or1337092689740270186AtMost @ A @ ( ord_max @ A @ A2 @ C2 ) @ ( ord_min @ A @ B2 @ D2 ) ) ) ) ).

% Int_atLeastAtMost
thf(fact_5265_Int__atLeastLessThan,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( inf_inf @ ( set @ A ) @ ( set_or7035219750837199246ssThan @ A @ A2 @ B2 ) @ ( set_or7035219750837199246ssThan @ A @ C2 @ D2 ) )
          = ( set_or7035219750837199246ssThan @ A @ ( ord_max @ A @ A2 @ C2 ) @ ( ord_min @ A @ B2 @ D2 ) ) ) ) ).

% Int_atLeastLessThan
thf(fact_5266_min__Suc__numeral,axiom,
    ! [N: nat,K: num] :
      ( ( ord_min @ nat @ ( suc @ N ) @ ( numeral_numeral @ nat @ K ) )
      = ( suc @ ( ord_min @ nat @ N @ ( pred_numeral @ K ) ) ) ) ).

% min_Suc_numeral
thf(fact_5267_min__numeral__Suc,axiom,
    ! [K: num,N: nat] :
      ( ( ord_min @ nat @ ( numeral_numeral @ nat @ K ) @ ( suc @ N ) )
      = ( suc @ ( ord_min @ nat @ ( pred_numeral @ K ) @ N ) ) ) ).

% min_numeral_Suc
thf(fact_5268_Min__insert,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A4: set @ A,X: A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( A4
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( lattic643756798350308766er_Min @ A @ ( insert @ A @ X @ A4 ) )
              = ( ord_min @ A @ X @ ( lattic643756798350308766er_Min @ A @ A4 ) ) ) ) ) ) ).

% Min_insert
thf(fact_5269_min__add__distrib__left,axiom,
    ! [A: $tType] :
      ( ( ordere2412721322843649153imp_le @ A )
     => ! [X: A,Y: A,Z: A] :
          ( ( plus_plus @ A @ ( ord_min @ A @ X @ Y ) @ Z )
          = ( ord_min @ A @ ( plus_plus @ A @ X @ Z ) @ ( plus_plus @ A @ Y @ Z ) ) ) ) ).

% min_add_distrib_left
thf(fact_5270_min__add__distrib__right,axiom,
    ! [A: $tType] :
      ( ( ordere2412721322843649153imp_le @ A )
     => ! [X: A,Y: A,Z: A] :
          ( ( plus_plus @ A @ X @ ( ord_min @ A @ Y @ Z ) )
          = ( ord_min @ A @ ( plus_plus @ A @ X @ Y ) @ ( plus_plus @ A @ X @ Z ) ) ) ) ).

% min_add_distrib_right
thf(fact_5271_inf__nat__def,axiom,
    ( ( inf_inf @ nat )
    = ( ord_min @ nat ) ) ).

% inf_nat_def
thf(fact_5272_inf__min,axiom,
    ! [A: $tType] :
      ( ( ( semilattice_inf @ A )
        & ( linorder @ A ) )
     => ( ( inf_inf @ A )
        = ( ord_min @ A ) ) ) ).

% inf_min
thf(fact_5273_of__nat__min,axiom,
    ! [A: $tType] :
      ( ( linord181362715937106298miring @ A )
     => ! [X: nat,Y: nat] :
          ( ( semiring_1_of_nat @ A @ ( ord_min @ nat @ X @ Y ) )
          = ( ord_min @ A @ ( semiring_1_of_nat @ A @ X ) @ ( semiring_1_of_nat @ A @ Y ) ) ) ) ).

% of_nat_min
thf(fact_5274_of__int__min,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [X: int,Y: int] :
          ( ( ring_1_of_int @ A @ ( ord_min @ int @ X @ Y ) )
          = ( ord_min @ A @ ( ring_1_of_int @ A @ X ) @ ( ring_1_of_int @ A @ Y ) ) ) ) ).

% of_int_min
thf(fact_5275_min_Oassoc,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_min @ A @ ( ord_min @ A @ A2 @ B2 ) @ C2 )
          = ( ord_min @ A @ A2 @ ( ord_min @ A @ B2 @ C2 ) ) ) ) ).

% min.assoc
thf(fact_5276_min_Ocommute,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( ( ord_min @ A )
        = ( ^ [A3: A,B3: A] : ( ord_min @ A @ B3 @ A3 ) ) ) ) ).

% min.commute
thf(fact_5277_min_Oleft__commute,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( ord_min @ A @ B2 @ ( ord_min @ A @ A2 @ C2 ) )
          = ( ord_min @ A @ A2 @ ( ord_min @ A @ B2 @ C2 ) ) ) ) ).

% min.left_commute
thf(fact_5278_min__diff,axiom,
    ! [M: nat,I: nat,N: nat] :
      ( ( ord_min @ nat @ ( minus_minus @ nat @ M @ I ) @ ( minus_minus @ nat @ N @ I ) )
      = ( minus_minus @ nat @ ( ord_min @ nat @ M @ N ) @ I ) ) ).

% min_diff
thf(fact_5279_min__diff__distrib__left,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [X: A,Y: A,Z: A] :
          ( ( minus_minus @ A @ ( ord_min @ A @ X @ Y ) @ Z )
          = ( ord_min @ A @ ( minus_minus @ A @ X @ Z ) @ ( minus_minus @ A @ Y @ Z ) ) ) ) ).

% min_diff_distrib_left
thf(fact_5280_nat__mult__min__right,axiom,
    ! [M: nat,N: nat,Q3: nat] :
      ( ( times_times @ nat @ M @ ( ord_min @ nat @ N @ Q3 ) )
      = ( ord_min @ nat @ ( times_times @ nat @ M @ N ) @ ( times_times @ nat @ M @ Q3 ) ) ) ).

% nat_mult_min_right
thf(fact_5281_nat__mult__min__left,axiom,
    ! [M: nat,N: nat,Q3: nat] :
      ( ( times_times @ nat @ ( ord_min @ nat @ M @ N ) @ Q3 )
      = ( ord_min @ nat @ ( times_times @ nat @ M @ Q3 ) @ ( times_times @ nat @ N @ Q3 ) ) ) ).

% nat_mult_min_left
thf(fact_5282_max__min__distrib1,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( ord_max @ A @ ( ord_min @ A @ B2 @ C2 ) @ A2 )
          = ( ord_min @ A @ ( ord_max @ A @ B2 @ A2 ) @ ( ord_max @ A @ C2 @ A2 ) ) ) ) ).

% max_min_distrib1
thf(fact_5283_max__min__distrib2,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_max @ A @ A2 @ ( ord_min @ A @ B2 @ C2 ) )
          = ( ord_min @ A @ ( ord_max @ A @ A2 @ B2 ) @ ( ord_max @ A @ A2 @ C2 ) ) ) ) ).

% max_min_distrib2
thf(fact_5284_min__max__distrib1,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( ord_min @ A @ ( ord_max @ A @ B2 @ C2 ) @ A2 )
          = ( ord_max @ A @ ( ord_min @ A @ B2 @ A2 ) @ ( ord_min @ A @ C2 @ A2 ) ) ) ) ).

% min_max_distrib1
thf(fact_5285_min__max__distrib2,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_min @ A @ A2 @ ( ord_max @ A @ B2 @ C2 ) )
          = ( ord_max @ A @ ( ord_min @ A @ A2 @ B2 ) @ ( ord_min @ A @ A2 @ C2 ) ) ) ) ).

% min_max_distrib2
thf(fact_5286_Inf__insert__finite,axiom,
    ! [A: $tType] :
      ( ( condit6923001295902523014norder @ A )
     => ! [S: set @ A,X: A] :
          ( ( finite_finite @ A @ S )
         => ( ( ( S
                = ( bot_bot @ ( set @ A ) ) )
             => ( ( complete_Inf_Inf @ A @ ( insert @ A @ X @ S ) )
                = X ) )
            & ( ( S
               != ( bot_bot @ ( set @ A ) ) )
             => ( ( complete_Inf_Inf @ A @ ( insert @ A @ X @ S ) )
                = ( ord_min @ A @ X @ ( complete_Inf_Inf @ A @ S ) ) ) ) ) ) ) ).

% Inf_insert_finite
thf(fact_5287_cInf__eq__minimum,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [Z: A,X7: set @ A] :
          ( ( member @ A @ Z @ X7 )
         => ( ! [X3: A] :
                ( ( member @ A @ X3 @ X7 )
               => ( ord_less_eq @ A @ Z @ X3 ) )
           => ( ( complete_Inf_Inf @ A @ X7 )
              = Z ) ) ) ) ).

% cInf_eq_minimum
thf(fact_5288_cInf__eq,axiom,
    ! [A: $tType] :
      ( ( ( condit1219197933456340205attice @ A )
        & ( no_top @ A ) )
     => ! [X7: set @ A,A2: A] :
          ( ! [X3: A] :
              ( ( member @ A @ X3 @ X7 )
             => ( ord_less_eq @ A @ A2 @ X3 ) )
         => ( ! [Y5: A] :
                ( ! [X5: A] :
                    ( ( member @ A @ X5 @ X7 )
                   => ( ord_less_eq @ A @ Y5 @ X5 ) )
               => ( ord_less_eq @ A @ Y5 @ A2 ) )
           => ( ( complete_Inf_Inf @ A @ X7 )
              = A2 ) ) ) ) ).

% cInf_eq
thf(fact_5289_min__def,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ( ( ord_min @ A )
        = ( ^ [A3: A,B3: A] : ( if @ A @ ( ord_less_eq @ A @ A3 @ B3 ) @ A3 @ B3 ) ) ) ) ).

% min_def
thf(fact_5290_min__absorb1,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ A @ X @ Y )
         => ( ( ord_min @ A @ X @ Y )
            = X ) ) ) ).

% min_absorb1
thf(fact_5291_min__absorb2,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [Y: A,X: A] :
          ( ( ord_less_eq @ A @ Y @ X )
         => ( ( ord_min @ A @ X @ Y )
            = Y ) ) ) ).

% min_absorb2
thf(fact_5292_min_Omono,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,C2: A,B2: A,D2: A] :
          ( ( ord_less_eq @ A @ A2 @ C2 )
         => ( ( ord_less_eq @ A @ B2 @ D2 )
           => ( ord_less_eq @ A @ ( ord_min @ A @ A2 @ B2 ) @ ( ord_min @ A @ C2 @ D2 ) ) ) ) ) ).

% min.mono
thf(fact_5293_min_OorderE,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( A2
            = ( ord_min @ A @ A2 @ B2 ) ) ) ) ).

% min.orderE
thf(fact_5294_min_OorderI,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A] :
          ( ( A2
            = ( ord_min @ A @ A2 @ B2 ) )
         => ( ord_less_eq @ A @ A2 @ B2 ) ) ) ).

% min.orderI
thf(fact_5295_min_OboundedE,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ ( ord_min @ A @ B2 @ C2 ) )
         => ~ ( ( ord_less_eq @ A @ A2 @ B2 )
             => ~ ( ord_less_eq @ A @ A2 @ C2 ) ) ) ) ).

% min.boundedE
thf(fact_5296_min_OboundedI,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ A2 @ C2 )
           => ( ord_less_eq @ A @ A2 @ ( ord_min @ A @ B2 @ C2 ) ) ) ) ) ).

% min.boundedI
thf(fact_5297_min_Oorder__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [A3: A,B3: A] :
              ( A3
              = ( ord_min @ A @ A3 @ B3 ) ) ) ) ) ).

% min.order_iff
thf(fact_5298_min_Ocobounded1,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A] : ( ord_less_eq @ A @ ( ord_min @ A @ A2 @ B2 ) @ A2 ) ) ).

% min.cobounded1
thf(fact_5299_min_Ocobounded2,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A] : ( ord_less_eq @ A @ ( ord_min @ A @ A2 @ B2 ) @ B2 ) ) ).

% min.cobounded2
thf(fact_5300_min_Oabsorb__iff1,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [A3: A,B3: A] :
              ( ( ord_min @ A @ A3 @ B3 )
              = A3 ) ) ) ) ).

% min.absorb_iff1
thf(fact_5301_min_Oabsorb__iff2,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [B3: A,A3: A] :
              ( ( ord_min @ A @ A3 @ B3 )
              = B3 ) ) ) ) ).

% min.absorb_iff2
thf(fact_5302_min_OcoboundedI1,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ C2 )
         => ( ord_less_eq @ A @ ( ord_min @ A @ A2 @ B2 ) @ C2 ) ) ) ).

% min.coboundedI1
thf(fact_5303_min_OcoboundedI2,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( ord_less_eq @ A @ B2 @ C2 )
         => ( ord_less_eq @ A @ ( ord_min @ A @ A2 @ B2 ) @ C2 ) ) ) ).

% min.coboundedI2
thf(fact_5304_min__le__iff__disj,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A,Y: A,Z: A] :
          ( ( ord_less_eq @ A @ ( ord_min @ A @ X @ Y ) @ Z )
          = ( ( ord_less_eq @ A @ X @ Z )
            | ( ord_less_eq @ A @ Y @ Z ) ) ) ) ).

% min_le_iff_disj
thf(fact_5305_min__less__iff__disj,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A,Y: A,Z: A] :
          ( ( ord_less @ A @ ( ord_min @ A @ X @ Y ) @ Z )
          = ( ( ord_less @ A @ X @ Z )
            | ( ord_less @ A @ Y @ Z ) ) ) ) ).

% min_less_iff_disj
thf(fact_5306_min_Ostrict__boundedE,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( ord_less @ A @ A2 @ ( ord_min @ A @ B2 @ C2 ) )
         => ~ ( ( ord_less @ A @ A2 @ B2 )
             => ~ ( ord_less @ A @ A2 @ C2 ) ) ) ) ).

% min.strict_boundedE
thf(fact_5307_min_Ostrict__order__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( ( ord_less @ A )
        = ( ^ [A3: A,B3: A] :
              ( ( A3
                = ( ord_min @ A @ A3 @ B3 ) )
              & ( A3 != B3 ) ) ) ) ) ).

% min.strict_order_iff
thf(fact_5308_min_Ostrict__coboundedI1,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,C2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ C2 )
         => ( ord_less @ A @ ( ord_min @ A @ A2 @ B2 ) @ C2 ) ) ) ).

% min.strict_coboundedI1
thf(fact_5309_min_Ostrict__coboundedI2,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( ord_less @ A @ B2 @ C2 )
         => ( ord_less @ A @ ( ord_min @ A @ A2 @ B2 ) @ C2 ) ) ) ).

% min.strict_coboundedI2
thf(fact_5310_min__def__raw,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ( ( ord_min @ A )
        = ( ^ [A3: A,B3: A] : ( if @ A @ ( ord_less_eq @ A @ A3 @ B3 ) @ A3 @ B3 ) ) ) ) ).

% min_def_raw
thf(fact_5311_cInf__eq__non__empty,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [X7: set @ A,A2: A] :
          ( ( X7
           != ( bot_bot @ ( set @ A ) ) )
         => ( ! [X3: A] :
                ( ( member @ A @ X3 @ X7 )
               => ( ord_less_eq @ A @ A2 @ X3 ) )
           => ( ! [Y5: A] :
                  ( ! [X5: A] :
                      ( ( member @ A @ X5 @ X7 )
                     => ( ord_less_eq @ A @ Y5 @ X5 ) )
                 => ( ord_less_eq @ A @ Y5 @ A2 ) )
             => ( ( complete_Inf_Inf @ A @ X7 )
                = A2 ) ) ) ) ) ).

% cInf_eq_non_empty
thf(fact_5312_cInf__greatest,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [X7: set @ A,Z: A] :
          ( ( X7
           != ( bot_bot @ ( set @ A ) ) )
         => ( ! [X3: A] :
                ( ( member @ A @ X3 @ X7 )
               => ( ord_less_eq @ A @ Z @ X3 ) )
           => ( ord_less_eq @ A @ Z @ ( complete_Inf_Inf @ A @ X7 ) ) ) ) ) ).

% cInf_greatest
thf(fact_5313_cInf__le__finite,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [X7: set @ A,X: A] :
          ( ( finite_finite @ A @ X7 )
         => ( ( member @ A @ X @ X7 )
           => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ X7 ) @ X ) ) ) ) ).

% cInf_le_finite
thf(fact_5314_cInf__lessD,axiom,
    ! [A: $tType] :
      ( ( condit6923001295902523014norder @ A )
     => ! [X7: set @ A,Z: A] :
          ( ( X7
           != ( bot_bot @ ( set @ A ) ) )
         => ( ( ord_less @ A @ ( complete_Inf_Inf @ A @ X7 ) @ Z )
           => ? [X3: A] :
                ( ( member @ A @ X3 @ X7 )
                & ( ord_less @ A @ X3 @ Z ) ) ) ) ) ).

% cInf_lessD
thf(fact_5315_finite__imp__less__Inf,axiom,
    ! [A: $tType] :
      ( ( condit6923001295902523014norder @ A )
     => ! [X7: set @ A,X: A,A2: A] :
          ( ( finite_finite @ A @ X7 )
         => ( ( member @ A @ X @ X7 )
           => ( ! [X3: A] :
                  ( ( member @ A @ X3 @ X7 )
                 => ( ord_less @ A @ A2 @ X3 ) )
             => ( ord_less @ A @ A2 @ ( complete_Inf_Inf @ A @ X7 ) ) ) ) ) ) ).

% finite_imp_less_Inf
thf(fact_5316_minus__min__eq__max,axiom,
    ! [A: $tType] :
      ( ( linord5086331880401160121up_add @ A )
     => ! [X: A,Y: A] :
          ( ( uminus_uminus @ A @ ( ord_min @ A @ X @ Y ) )
          = ( ord_max @ A @ ( uminus_uminus @ A @ X ) @ ( uminus_uminus @ A @ Y ) ) ) ) ).

% minus_min_eq_max
thf(fact_5317_minus__max__eq__min,axiom,
    ! [A: $tType] :
      ( ( linord5086331880401160121up_add @ A )
     => ! [X: A,Y: A] :
          ( ( uminus_uminus @ A @ ( ord_max @ A @ X @ Y ) )
          = ( ord_min @ A @ ( uminus_uminus @ A @ X ) @ ( uminus_uminus @ A @ Y ) ) ) ) ).

% minus_max_eq_min
thf(fact_5318_Min_Oin__idem,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A4: set @ A,X: A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( member @ A @ X @ A4 )
           => ( ( ord_min @ A @ X @ ( lattic643756798350308766er_Min @ A @ A4 ) )
              = ( lattic643756798350308766er_Min @ A @ A4 ) ) ) ) ) ).

% Min.in_idem
thf(fact_5319_concat__bit__assoc__sym,axiom,
    ! [M: nat,N: nat,K: int,L: int,R2: int] :
      ( ( bit_concat_bit @ M @ ( bit_concat_bit @ N @ K @ L ) @ R2 )
      = ( bit_concat_bit @ ( ord_min @ nat @ M @ N ) @ K @ ( bit_concat_bit @ ( minus_minus @ nat @ M @ N ) @ L @ R2 ) ) ) ).

% concat_bit_assoc_sym
thf(fact_5320_cINF__greatest,axiom,
    ! [A: $tType,B: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [A4: set @ B,M: A,F2: B > A] :
          ( ( A4
           != ( bot_bot @ ( set @ B ) ) )
         => ( ! [X3: B] :
                ( ( member @ B @ X3 @ A4 )
               => ( ord_less_eq @ A @ M @ ( F2 @ X3 ) ) )
           => ( ord_less_eq @ A @ M @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ F2 @ A4 ) ) ) ) ) ) ).

% cINF_greatest
thf(fact_5321_finite__less__Inf__iff,axiom,
    ! [A: $tType] :
      ( ( condit6923001295902523014norder @ A )
     => ! [X7: set @ A,A2: A] :
          ( ( finite_finite @ A @ X7 )
         => ( ( X7
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ord_less @ A @ A2 @ ( complete_Inf_Inf @ A @ X7 ) )
              = ( ! [X2: A] :
                    ( ( member @ A @ X2 @ X7 )
                   => ( ord_less @ A @ A2 @ X2 ) ) ) ) ) ) ) ).

% finite_less_Inf_iff
thf(fact_5322_cInf__abs__ge,axiom,
    ! [A: $tType] :
      ( ( ( condit6923001295902523014norder @ A )
        & ( linordered_idom @ A ) )
     => ! [S: set @ A,A2: A] :
          ( ( S
           != ( bot_bot @ ( set @ A ) ) )
         => ( ! [X3: A] :
                ( ( member @ A @ X3 @ S )
               => ( ord_less_eq @ A @ ( abs_abs @ A @ X3 ) @ A2 ) )
           => ( ord_less_eq @ A @ ( abs_abs @ A @ ( complete_Inf_Inf @ A @ S ) ) @ A2 ) ) ) ) ).

% cInf_abs_ge
thf(fact_5323_Min__Inf,axiom,
    ! [A: $tType] :
      ( ( comple5582772986160207858norder @ A )
     => ! [A4: set @ A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( A4
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( lattic643756798350308766er_Min @ A @ A4 )
              = ( complete_Inf_Inf @ A @ A4 ) ) ) ) ) ).

% Min_Inf
thf(fact_5324_cInf__eq__Min,axiom,
    ! [A: $tType] :
      ( ( condit6923001295902523014norder @ A )
     => ! [X7: set @ A] :
          ( ( finite_finite @ A @ X7 )
         => ( ( X7
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( complete_Inf_Inf @ A @ X7 )
              = ( lattic643756798350308766er_Min @ A @ X7 ) ) ) ) ) ).

% cInf_eq_Min
thf(fact_5325_take__bit__concat__bit__eq,axiom,
    ! [M: nat,N: nat,K: int,L: int] :
      ( ( bit_se2584673776208193580ke_bit @ int @ M @ ( bit_concat_bit @ N @ K @ L ) )
      = ( bit_concat_bit @ ( ord_min @ nat @ M @ N ) @ K @ ( bit_se2584673776208193580ke_bit @ int @ ( minus_minus @ nat @ M @ N ) @ L ) ) ) ).

% take_bit_concat_bit_eq
thf(fact_5326_max__mult__distrib__left,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [P6: A,X: A,Y: A] :
          ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ P6 )
           => ( ( times_times @ A @ P6 @ ( ord_max @ A @ X @ Y ) )
              = ( ord_max @ A @ ( times_times @ A @ P6 @ X ) @ ( times_times @ A @ P6 @ Y ) ) ) )
          & ( ~ ( ord_less_eq @ A @ ( zero_zero @ A ) @ P6 )
           => ( ( times_times @ A @ P6 @ ( ord_max @ A @ X @ Y ) )
              = ( ord_min @ A @ ( times_times @ A @ P6 @ X ) @ ( times_times @ A @ P6 @ Y ) ) ) ) ) ) ).

% max_mult_distrib_left
thf(fact_5327_min__mult__distrib__left,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [P6: A,X: A,Y: A] :
          ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ P6 )
           => ( ( times_times @ A @ P6 @ ( ord_min @ A @ X @ Y ) )
              = ( ord_min @ A @ ( times_times @ A @ P6 @ X ) @ ( times_times @ A @ P6 @ Y ) ) ) )
          & ( ~ ( ord_less_eq @ A @ ( zero_zero @ A ) @ P6 )
           => ( ( times_times @ A @ P6 @ ( ord_min @ A @ X @ Y ) )
              = ( ord_max @ A @ ( times_times @ A @ P6 @ X ) @ ( times_times @ A @ P6 @ Y ) ) ) ) ) ) ).

% min_mult_distrib_left
thf(fact_5328_max__mult__distrib__right,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [P6: A,X: A,Y: A] :
          ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ P6 )
           => ( ( times_times @ A @ ( ord_max @ A @ X @ Y ) @ P6 )
              = ( ord_max @ A @ ( times_times @ A @ X @ P6 ) @ ( times_times @ A @ Y @ P6 ) ) ) )
          & ( ~ ( ord_less_eq @ A @ ( zero_zero @ A ) @ P6 )
           => ( ( times_times @ A @ ( ord_max @ A @ X @ Y ) @ P6 )
              = ( ord_min @ A @ ( times_times @ A @ X @ P6 ) @ ( times_times @ A @ Y @ P6 ) ) ) ) ) ) ).

% max_mult_distrib_right
thf(fact_5329_min__mult__distrib__right,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [P6: A,X: A,Y: A] :
          ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ P6 )
           => ( ( times_times @ A @ ( ord_min @ A @ X @ Y ) @ P6 )
              = ( ord_min @ A @ ( times_times @ A @ X @ P6 ) @ ( times_times @ A @ Y @ P6 ) ) ) )
          & ( ~ ( ord_less_eq @ A @ ( zero_zero @ A ) @ P6 )
           => ( ( times_times @ A @ ( ord_min @ A @ X @ Y ) @ P6 )
              = ( ord_max @ A @ ( times_times @ A @ X @ P6 ) @ ( times_times @ A @ Y @ P6 ) ) ) ) ) ) ).

% min_mult_distrib_right
thf(fact_5330_min__divide__distrib__right,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [P6: A,X: A,Y: A] :
          ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ P6 )
           => ( ( divide_divide @ A @ ( ord_min @ A @ X @ Y ) @ P6 )
              = ( ord_min @ A @ ( divide_divide @ A @ X @ P6 ) @ ( divide_divide @ A @ Y @ P6 ) ) ) )
          & ( ~ ( ord_less_eq @ A @ ( zero_zero @ A ) @ P6 )
           => ( ( divide_divide @ A @ ( ord_min @ A @ X @ Y ) @ P6 )
              = ( ord_max @ A @ ( divide_divide @ A @ X @ P6 ) @ ( divide_divide @ A @ Y @ P6 ) ) ) ) ) ) ).

% min_divide_distrib_right
thf(fact_5331_max__divide__distrib__right,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [P6: A,X: A,Y: A] :
          ( ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ P6 )
           => ( ( divide_divide @ A @ ( ord_max @ A @ X @ Y ) @ P6 )
              = ( ord_max @ A @ ( divide_divide @ A @ X @ P6 ) @ ( divide_divide @ A @ Y @ P6 ) ) ) )
          & ( ~ ( ord_less_eq @ A @ ( zero_zero @ A ) @ P6 )
           => ( ( divide_divide @ A @ ( ord_max @ A @ X @ Y ) @ P6 )
              = ( ord_min @ A @ ( divide_divide @ A @ X @ P6 ) @ ( divide_divide @ A @ Y @ P6 ) ) ) ) ) ) ).

% max_divide_distrib_right
thf(fact_5332_min__Suc1,axiom,
    ! [N: nat,M: nat] :
      ( ( ord_min @ nat @ ( suc @ N ) @ M )
      = ( case_nat @ nat @ ( zero_zero @ nat )
        @ ^ [M6: nat] : ( suc @ ( ord_min @ nat @ N @ M6 ) )
        @ M ) ) ).

% min_Suc1
thf(fact_5333_min__Suc2,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_min @ nat @ M @ ( suc @ N ) )
      = ( case_nat @ nat @ ( zero_zero @ nat )
        @ ^ [M6: nat] : ( suc @ ( ord_min @ nat @ M6 @ N ) )
        @ M ) ) ).

% min_Suc2
thf(fact_5334_hom__Min__commute,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [H2: A > A,N4: set @ A] :
          ( ! [X3: A,Y5: A] :
              ( ( H2 @ ( ord_min @ A @ X3 @ Y5 ) )
              = ( ord_min @ A @ ( H2 @ X3 ) @ ( H2 @ Y5 ) ) )
         => ( ( finite_finite @ A @ N4 )
           => ( ( N4
               != ( bot_bot @ ( set @ A ) ) )
             => ( ( H2 @ ( lattic643756798350308766er_Min @ A @ N4 ) )
                = ( lattic643756798350308766er_Min @ A @ ( image @ A @ A @ H2 @ N4 ) ) ) ) ) ) ) ).

% hom_Min_commute
thf(fact_5335_Min_Osubset,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A4: set @ A,B7: set @ A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( B7
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ord_less_eq @ ( set @ A ) @ B7 @ A4 )
             => ( ( ord_min @ A @ ( lattic643756798350308766er_Min @ A @ B7 ) @ ( lattic643756798350308766er_Min @ A @ A4 ) )
                = ( lattic643756798350308766er_Min @ A @ A4 ) ) ) ) ) ) ).

% Min.subset
thf(fact_5336_cInf__asclose,axiom,
    ! [A: $tType] :
      ( ( ( condit6923001295902523014norder @ A )
        & ( linordered_idom @ A ) )
     => ! [S: set @ A,L: A,E2: A] :
          ( ( S
           != ( bot_bot @ ( set @ A ) ) )
         => ( ! [X3: A] :
                ( ( member @ A @ X3 @ S )
               => ( ord_less_eq @ A @ ( abs_abs @ A @ ( minus_minus @ A @ X3 @ L ) ) @ E2 ) )
           => ( ord_less_eq @ A @ ( abs_abs @ A @ ( minus_minus @ A @ ( complete_Inf_Inf @ A @ S ) @ L ) ) @ E2 ) ) ) ) ).

% cInf_asclose
thf(fact_5337_Min_Oclosed,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A4: set @ A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( A4
             != ( bot_bot @ ( set @ A ) ) )
           => ( ! [X3: A,Y5: A] : ( member @ A @ ( ord_min @ A @ X3 @ Y5 ) @ ( insert @ A @ X3 @ ( insert @ A @ Y5 @ ( bot_bot @ ( set @ A ) ) ) ) )
             => ( member @ A @ ( lattic643756798350308766er_Min @ A @ A4 ) @ A4 ) ) ) ) ) ).

% Min.closed
thf(fact_5338_Min_Oinsert__not__elem,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A4: set @ A,X: A] :
          ( ( finite_finite @ A @ A4 )
         => ( ~ ( member @ A @ X @ A4 )
           => ( ( A4
               != ( bot_bot @ ( set @ A ) ) )
             => ( ( lattic643756798350308766er_Min @ A @ ( insert @ A @ X @ A4 ) )
                = ( ord_min @ A @ X @ ( lattic643756798350308766er_Min @ A @ A4 ) ) ) ) ) ) ) ).

% Min.insert_not_elem
thf(fact_5339_mod__exp__eq,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A,M: nat,N: nat] :
          ( ( modulo_modulo @ A @ ( modulo_modulo @ A @ A2 @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M ) ) @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) )
          = ( modulo_modulo @ A @ A2 @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( ord_min @ nat @ M @ N ) ) ) ) ) ).

% mod_exp_eq
thf(fact_5340_Min_Oinsert__remove,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A4: set @ A,X: A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( ( ( minus_minus @ ( set @ A ) @ A4 @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
                = ( bot_bot @ ( set @ A ) ) )
             => ( ( lattic643756798350308766er_Min @ A @ ( insert @ A @ X @ A4 ) )
                = X ) )
            & ( ( ( minus_minus @ ( set @ A ) @ A4 @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
               != ( bot_bot @ ( set @ A ) ) )
             => ( ( lattic643756798350308766er_Min @ A @ ( insert @ A @ X @ A4 ) )
                = ( ord_min @ A @ X @ ( lattic643756798350308766er_Min @ A @ ( minus_minus @ ( set @ A ) @ A4 @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ) ) ) ).

% Min.insert_remove
thf(fact_5341_Min_Oremove,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A4: set @ A,X: A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( member @ A @ X @ A4 )
           => ( ( ( ( minus_minus @ ( set @ A ) @ A4 @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
                  = ( bot_bot @ ( set @ A ) ) )
               => ( ( lattic643756798350308766er_Min @ A @ A4 )
                  = X ) )
              & ( ( ( minus_minus @ ( set @ A ) @ A4 @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
                 != ( bot_bot @ ( set @ A ) ) )
               => ( ( lattic643756798350308766er_Min @ A @ A4 )
                  = ( ord_min @ A @ X @ ( lattic643756798350308766er_Min @ A @ ( minus_minus @ ( set @ A ) @ A4 @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ) ) ) ) ).

% Min.remove
thf(fact_5342_find__Some__iff,axiom,
    ! [A: $tType,P: A > $o,Xs: list @ A,X: A] :
      ( ( ( find @ A @ P @ Xs )
        = ( some @ A @ X ) )
      = ( ? [I4: nat] :
            ( ( ord_less @ nat @ I4 @ ( size_size @ ( list @ A ) @ Xs ) )
            & ( P @ ( nth @ A @ Xs @ I4 ) )
            & ( X
              = ( nth @ A @ Xs @ I4 ) )
            & ! [J3: nat] :
                ( ( ord_less @ nat @ J3 @ I4 )
               => ~ ( P @ ( nth @ A @ Xs @ J3 ) ) ) ) ) ) ).

% find_Some_iff
thf(fact_5343_INF__eq__bot__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comple5582772986160207858norder @ A )
     => ! [F2: B > A,A4: set @ B] :
          ( ( ( complete_Inf_Inf @ A @ ( image @ B @ A @ F2 @ A4 ) )
            = ( bot_bot @ A ) )
          = ( ! [X2: A] :
                ( ( ord_less @ A @ ( bot_bot @ A ) @ X2 )
               => ? [Y4: B] :
                    ( ( member @ B @ Y4 @ A4 )
                    & ( ord_less @ A @ ( F2 @ Y4 ) @ X2 ) ) ) ) ) ) ).

% INF_eq_bot_iff
thf(fact_5344_Inf__eq__bot__iff,axiom,
    ! [A: $tType] :
      ( ( comple5582772986160207858norder @ A )
     => ! [A4: set @ A] :
          ( ( ( complete_Inf_Inf @ A @ A4 )
            = ( bot_bot @ A ) )
          = ( ! [X2: A] :
                ( ( ord_less @ A @ ( bot_bot @ A ) @ X2 )
               => ? [Y4: A] :
                    ( ( member @ A @ Y4 @ A4 )
                    & ( ord_less @ A @ Y4 @ X2 ) ) ) ) ) ) ).

% Inf_eq_bot_iff
thf(fact_5345_INF__nat__binary,axiom,
    ! [A: $tType] :
      ( ( counta3822494911875563373attice @ A )
     => ! [A4: A,B7: A] :
          ( ( inf_inf @ A @ A4
            @ ( complete_Inf_Inf @ A
              @ ( image @ nat @ A
                @ ^ [X2: nat] : B7
                @ ( collect @ nat @ ( ord_less @ nat @ ( zero_zero @ nat ) ) ) ) ) )
          = ( inf_inf @ A @ A4 @ B7 ) ) ) ).

% INF_nat_binary
thf(fact_5346_min__enat__simps_I3_J,axiom,
    ! [Q3: extended_enat] :
      ( ( ord_min @ extended_enat @ ( zero_zero @ extended_enat ) @ Q3 )
      = ( zero_zero @ extended_enat ) ) ).

% min_enat_simps(3)
thf(fact_5347_min__enat__simps_I2_J,axiom,
    ! [Q3: extended_enat] :
      ( ( ord_min @ extended_enat @ Q3 @ ( zero_zero @ extended_enat ) )
      = ( zero_zero @ extended_enat ) ) ).

% min_enat_simps(2)
thf(fact_5348_inf__int__def,axiom,
    ( ( inf_inf @ int )
    = ( ord_min @ int ) ) ).

% inf_int_def
thf(fact_5349_Inf__nat__def1,axiom,
    ! [K6: set @ nat] :
      ( ( K6
       != ( bot_bot @ ( set @ nat ) ) )
     => ( member @ nat @ ( complete_Inf_Inf @ nat @ K6 ) @ K6 ) ) ).

% Inf_nat_def1
thf(fact_5350_Inf__eqI,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A4: set @ A,X: A] :
          ( ! [I2: A] :
              ( ( member @ A @ I2 @ A4 )
             => ( ord_less_eq @ A @ X @ I2 ) )
         => ( ! [Y5: A] :
                ( ! [I3: A] :
                    ( ( member @ A @ I3 @ A4 )
                   => ( ord_less_eq @ A @ Y5 @ I3 ) )
               => ( ord_less_eq @ A @ Y5 @ X ) )
           => ( ( complete_Inf_Inf @ A @ A4 )
              = X ) ) ) ) ).

% Inf_eqI
thf(fact_5351_Inf__mono,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [B7: set @ A,A4: set @ A] :
          ( ! [B4: A] :
              ( ( member @ A @ B4 @ B7 )
             => ? [X5: A] :
                  ( ( member @ A @ X5 @ A4 )
                  & ( ord_less_eq @ A @ X5 @ B4 ) ) )
         => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ A4 ) @ ( complete_Inf_Inf @ A @ B7 ) ) ) ) ).

% Inf_mono
thf(fact_5352_Inf__lower,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [X: A,A4: set @ A] :
          ( ( member @ A @ X @ A4 )
         => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ A4 ) @ X ) ) ) ).

% Inf_lower
thf(fact_5353_Inf__lower2,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [U: A,A4: set @ A,V: A] :
          ( ( member @ A @ U @ A4 )
         => ( ( ord_less_eq @ A @ U @ V )
           => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ A4 ) @ V ) ) ) ) ).

% Inf_lower2
thf(fact_5354_le__Inf__iff,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [B2: A,A4: set @ A] :
          ( ( ord_less_eq @ A @ B2 @ ( complete_Inf_Inf @ A @ A4 ) )
          = ( ! [X2: A] :
                ( ( member @ A @ X2 @ A4 )
               => ( ord_less_eq @ A @ B2 @ X2 ) ) ) ) ) ).

% le_Inf_iff
thf(fact_5355_Inf__greatest,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A4: set @ A,Z: A] :
          ( ! [X3: A] :
              ( ( member @ A @ X3 @ A4 )
             => ( ord_less_eq @ A @ Z @ X3 ) )
         => ( ord_less_eq @ A @ Z @ ( complete_Inf_Inf @ A @ A4 ) ) ) ) ).

% Inf_greatest
thf(fact_5356_Inf__less__iff,axiom,
    ! [A: $tType] :
      ( ( comple5582772986160207858norder @ A )
     => ! [S: set @ A,A2: A] :
          ( ( ord_less @ A @ ( complete_Inf_Inf @ A @ S ) @ A2 )
          = ( ? [X2: A] :
                ( ( member @ A @ X2 @ S )
                & ( ord_less @ A @ X2 @ A2 ) ) ) ) ) ).

% Inf_less_iff
thf(fact_5357_Inf__le__iff,axiom,
    ! [A: $tType] :
      ( ( comple5582772986160207858norder @ A )
     => ! [A4: set @ A,X: A] :
          ( ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ A4 ) @ X )
          = ( ! [Y4: A] :
                ( ( ord_less @ A @ X @ Y4 )
               => ? [X2: A] :
                    ( ( member @ A @ X2 @ A4 )
                    & ( ord_less @ A @ X2 @ Y4 ) ) ) ) ) ) ).

% Inf_le_iff
thf(fact_5358_INF__eq,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A4: set @ B,B7: set @ C,G: C > A,F2: B > A] :
          ( ! [I2: B] :
              ( ( member @ B @ I2 @ A4 )
             => ? [X5: C] :
                  ( ( member @ C @ X5 @ B7 )
                  & ( ord_less_eq @ A @ ( G @ X5 ) @ ( F2 @ I2 ) ) ) )
         => ( ! [J2: C] :
                ( ( member @ C @ J2 @ B7 )
               => ? [X5: B] :
                    ( ( member @ B @ X5 @ A4 )
                    & ( ord_less_eq @ A @ ( F2 @ X5 ) @ ( G @ J2 ) ) ) )
           => ( ( complete_Inf_Inf @ A @ ( image @ B @ A @ F2 @ A4 ) )
              = ( complete_Inf_Inf @ A @ ( image @ C @ A @ G @ B7 ) ) ) ) ) ) ).

% INF_eq
thf(fact_5359_Inf__less__eq,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A4: set @ A,U: A] :
          ( ! [V4: A] :
              ( ( member @ A @ V4 @ A4 )
             => ( ord_less_eq @ A @ V4 @ U ) )
         => ( ( A4
             != ( bot_bot @ ( set @ A ) ) )
           => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ A4 ) @ U ) ) ) ) ).

% Inf_less_eq
thf(fact_5360_Inf__superset__mono,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [B7: set @ A,A4: set @ A] :
          ( ( ord_less_eq @ ( set @ A ) @ B7 @ A4 )
         => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ A4 ) @ ( complete_Inf_Inf @ A @ B7 ) ) ) ) ).

% Inf_superset_mono
thf(fact_5361_INF__eqI,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A4: set @ B,X: A,F2: B > A] :
          ( ! [I2: B] :
              ( ( member @ B @ I2 @ A4 )
             => ( ord_less_eq @ A @ X @ ( F2 @ I2 ) ) )
         => ( ! [Y5: A] :
                ( ! [I3: B] :
                    ( ( member @ B @ I3 @ A4 )
                   => ( ord_less_eq @ A @ Y5 @ ( F2 @ I3 ) ) )
               => ( ord_less_eq @ A @ Y5 @ X ) )
           => ( ( complete_Inf_Inf @ A @ ( image @ B @ A @ F2 @ A4 ) )
              = X ) ) ) ) ).

% INF_eqI
thf(fact_5362_INF__mono,axiom,
    ! [C: $tType,A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [B7: set @ B,A4: set @ C,F2: C > A,G: B > A] :
          ( ! [M4: B] :
              ( ( member @ B @ M4 @ B7 )
             => ? [X5: C] :
                  ( ( member @ C @ X5 @ A4 )
                  & ( ord_less_eq @ A @ ( F2 @ X5 ) @ ( G @ M4 ) ) ) )
         => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ ( image @ C @ A @ F2 @ A4 ) ) @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ G @ B7 ) ) ) ) ) ).

% INF_mono
thf(fact_5363_INF__lower,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [I: B,A4: set @ B,F2: B > A] :
          ( ( member @ B @ I @ A4 )
         => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ F2 @ A4 ) ) @ ( F2 @ I ) ) ) ) ).

% INF_lower
thf(fact_5364_INF__mono_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [F2: B > A,G: B > A,A4: set @ B] :
          ( ! [X3: B] : ( ord_less_eq @ A @ ( F2 @ X3 ) @ ( G @ X3 ) )
         => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ F2 @ A4 ) ) @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ G @ A4 ) ) ) ) ) ).

% INF_mono'
thf(fact_5365_INF__lower2,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [I: B,A4: set @ B,F2: B > A,U: A] :
          ( ( member @ B @ I @ A4 )
         => ( ( ord_less_eq @ A @ ( F2 @ I ) @ U )
           => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ F2 @ A4 ) ) @ U ) ) ) ) ).

% INF_lower2
thf(fact_5366_le__INF__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [U: A,F2: B > A,A4: set @ B] :
          ( ( ord_less_eq @ A @ U @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ F2 @ A4 ) ) )
          = ( ! [X2: B] :
                ( ( member @ B @ X2 @ A4 )
               => ( ord_less_eq @ A @ U @ ( F2 @ X2 ) ) ) ) ) ) ).

% le_INF_iff
thf(fact_5367_INF__greatest,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A4: set @ B,U: A,F2: B > A] :
          ( ! [I2: B] :
              ( ( member @ B @ I2 @ A4 )
             => ( ord_less_eq @ A @ U @ ( F2 @ I2 ) ) )
         => ( ord_less_eq @ A @ U @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ F2 @ A4 ) ) ) ) ) ).

% INF_greatest
thf(fact_5368_less__INF__D,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [Y: A,F2: B > A,A4: set @ B,I: B] :
          ( ( ord_less @ A @ Y @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ F2 @ A4 ) ) )
         => ( ( member @ B @ I @ A4 )
           => ( ord_less @ A @ Y @ ( F2 @ I ) ) ) ) ) ).

% less_INF_D
thf(fact_5369_INF__less__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple5582772986160207858norder @ A )
     => ! [F2: B > A,A4: set @ B,A2: A] :
          ( ( ord_less @ A @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ F2 @ A4 ) ) @ A2 )
          = ( ? [X2: B] :
                ( ( member @ B @ X2 @ A4 )
                & ( ord_less @ A @ ( F2 @ X2 ) @ A2 ) ) ) ) ) ).

% INF_less_iff
thf(fact_5370_INF__le__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comple5582772986160207858norder @ A )
     => ! [F2: B > A,A4: set @ B,X: A] :
          ( ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ F2 @ A4 ) ) @ X )
          = ( ! [Y4: A] :
                ( ( ord_less @ A @ X @ Y4 )
               => ? [X2: B] :
                    ( ( member @ B @ X2 @ A4 )
                    & ( ord_less @ A @ ( F2 @ X2 ) @ Y4 ) ) ) ) ) ) ).

% INF_le_iff
thf(fact_5371_INF__eq__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [I5: set @ B,F2: B > A,C2: A] :
          ( ( I5
           != ( bot_bot @ ( set @ B ) ) )
         => ( ! [I2: B] :
                ( ( member @ B @ I2 @ I5 )
               => ( ord_less_eq @ A @ ( F2 @ I2 ) @ C2 ) )
           => ( ( ( complete_Inf_Inf @ A @ ( image @ B @ A @ F2 @ I5 ) )
                = C2 )
              = ( ! [X2: B] :
                    ( ( member @ B @ X2 @ I5 )
                   => ( ( F2 @ X2 )
                      = C2 ) ) ) ) ) ) ) ).

% INF_eq_iff
thf(fact_5372_INF__superset__mono,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [B7: set @ B,A4: set @ B,F2: B > A,G: B > A] :
          ( ( ord_less_eq @ ( set @ B ) @ B7 @ A4 )
         => ( ! [X3: B] :
                ( ( member @ B @ X3 @ B7 )
               => ( ord_less_eq @ A @ ( F2 @ X3 ) @ ( G @ X3 ) ) )
           => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ F2 @ A4 ) ) @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ G @ B7 ) ) ) ) ) ) ).

% INF_superset_mono
thf(fact_5373_card__UNION,axiom,
    ! [A: $tType,A4: set @ ( set @ A )] :
      ( ( finite_finite @ ( set @ A ) @ A4 )
     => ( ! [X3: set @ A] :
            ( ( member @ ( set @ A ) @ X3 @ A4 )
           => ( finite_finite @ A @ X3 ) )
       => ( ( finite_card @ A @ ( complete_Sup_Sup @ ( set @ A ) @ A4 ) )
          = ( nat2
            @ ( groups7311177749621191930dd_sum @ ( set @ ( set @ A ) ) @ int
              @ ^ [I7: set @ ( set @ A )] : ( times_times @ int @ ( power_power @ int @ ( uminus_uminus @ int @ ( one_one @ int ) ) @ ( plus_plus @ nat @ ( finite_card @ ( set @ A ) @ I7 ) @ ( one_one @ nat ) ) ) @ ( semiring_1_of_nat @ int @ ( finite_card @ A @ ( complete_Inf_Inf @ ( set @ A ) @ I7 ) ) ) )
              @ ( collect @ ( set @ ( set @ A ) )
                @ ^ [I7: set @ ( set @ A )] :
                    ( ( ord_less_eq @ ( set @ ( set @ A ) ) @ I7 @ A4 )
                    & ( I7
                     != ( bot_bot @ ( set @ ( set @ A ) ) ) ) ) ) ) ) ) ) ) ).

% card_UNION
thf(fact_5374_lexord__take__index__conv,axiom,
    ! [A: $tType,X: list @ A,Y: list @ A,R2: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ X @ Y ) @ ( lexord @ A @ R2 ) )
      = ( ( ( ord_less @ nat @ ( size_size @ ( list @ A ) @ X ) @ ( size_size @ ( list @ A ) @ Y ) )
          & ( ( take @ A @ ( size_size @ ( list @ A ) @ X ) @ Y )
            = X ) )
        | ? [I4: nat] :
            ( ( ord_less @ nat @ I4 @ ( ord_min @ nat @ ( size_size @ ( list @ A ) @ X ) @ ( size_size @ ( list @ A ) @ Y ) ) )
            & ( ( take @ A @ I4 @ X )
              = ( take @ A @ I4 @ Y ) )
            & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ ( nth @ A @ X @ I4 ) @ ( nth @ A @ Y @ I4 ) ) @ R2 ) ) ) ) ).

% lexord_take_index_conv
thf(fact_5375_dual__max,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( ( max @ A
          @ ^ [X2: A,Y4: A] : ( ord_less_eq @ A @ Y4 @ X2 ) )
        = ( ord_min @ A ) ) ) ).

% dual_max
thf(fact_5376_cSup__lessThan,axiom,
    ! [A: $tType] :
      ( ( ( condit6923001295902523014norder @ A )
        & ( dense_linorder @ A )
        & ( no_bot @ A ) )
     => ! [X: A] :
          ( ( complete_Sup_Sup @ A @ ( set_ord_lessThan @ A @ X ) )
          = X ) ) ).

% cSup_lessThan
thf(fact_5377_cSup__atMost,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [X: A] :
          ( ( complete_Sup_Sup @ A @ ( set_ord_atMost @ A @ X ) )
          = X ) ) ).

% cSup_atMost
thf(fact_5378_cSup__atLeastAtMost,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [Y: A,X: A] :
          ( ( ord_less_eq @ A @ Y @ X )
         => ( ( complete_Sup_Sup @ A @ ( set_or1337092689740270186AtMost @ A @ Y @ X ) )
            = X ) ) ) ).

% cSup_atLeastAtMost
thf(fact_5379_Sup__atLeastAtMost,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ A @ X @ Y )
         => ( ( complete_Sup_Sup @ A @ ( set_or1337092689740270186AtMost @ A @ X @ Y ) )
            = Y ) ) ) ).

% Sup_atLeastAtMost
thf(fact_5380_cSup__singleton,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [X: A] :
          ( ( complete_Sup_Sup @ A @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
          = X ) ) ).

% cSup_singleton
thf(fact_5381_cSup__atLeastLessThan,axiom,
    ! [A: $tType] :
      ( ( ( condit6923001295902523014norder @ A )
        & ( dense_linorder @ A ) )
     => ! [Y: A,X: A] :
          ( ( ord_less @ A @ Y @ X )
         => ( ( complete_Sup_Sup @ A @ ( set_or7035219750837199246ssThan @ A @ Y @ X ) )
            = X ) ) ) ).

% cSup_atLeastLessThan
thf(fact_5382_Sup__atLeastLessThan,axiom,
    ! [A: $tType] :
      ( ( ( comple6319245703460814977attice @ A )
        & ( dense_linorder @ A ) )
     => ! [X: A,Y: A] :
          ( ( ord_less @ A @ X @ Y )
         => ( ( complete_Sup_Sup @ A @ ( set_or7035219750837199246ssThan @ A @ X @ Y ) )
            = Y ) ) ) ).

% Sup_atLeastLessThan
thf(fact_5383_cSUP__const,axiom,
    ! [B: $tType,A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [A4: set @ B,C2: A] :
          ( ( A4
           != ( bot_bot @ ( set @ B ) ) )
         => ( ( complete_Sup_Sup @ A
              @ ( image @ B @ A
                @ ^ [X2: B] : C2
                @ A4 ) )
            = C2 ) ) ) ).

% cSUP_const
thf(fact_5384_inf__enat__def,axiom,
    ( ( inf_inf @ extended_enat )
    = ( ord_min @ extended_enat ) ) ).

% inf_enat_def
thf(fact_5385_le__Sup__iff,axiom,
    ! [A: $tType] :
      ( ( comple5582772986160207858norder @ A )
     => ! [X: A,A4: set @ A] :
          ( ( ord_less_eq @ A @ X @ ( complete_Sup_Sup @ A @ A4 ) )
          = ( ! [Y4: A] :
                ( ( ord_less @ A @ Y4 @ X )
               => ? [X2: A] :
                    ( ( member @ A @ X2 @ A4 )
                    & ( ord_less @ A @ Y4 @ X2 ) ) ) ) ) ) ).

% le_Sup_iff
thf(fact_5386_less__Sup__iff,axiom,
    ! [A: $tType] :
      ( ( comple5582772986160207858norder @ A )
     => ! [A2: A,S: set @ A] :
          ( ( ord_less @ A @ A2 @ ( complete_Sup_Sup @ A @ S ) )
          = ( ? [X2: A] :
                ( ( member @ A @ X2 @ S )
                & ( ord_less @ A @ A2 @ X2 ) ) ) ) ) ).

% less_Sup_iff
thf(fact_5387_Sup__eqI,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A4: set @ A,X: A] :
          ( ! [Y5: A] :
              ( ( member @ A @ Y5 @ A4 )
             => ( ord_less_eq @ A @ Y5 @ X ) )
         => ( ! [Y5: A] :
                ( ! [Z4: A] :
                    ( ( member @ A @ Z4 @ A4 )
                   => ( ord_less_eq @ A @ Z4 @ Y5 ) )
               => ( ord_less_eq @ A @ X @ Y5 ) )
           => ( ( complete_Sup_Sup @ A @ A4 )
              = X ) ) ) ) ).

% Sup_eqI
thf(fact_5388_Sup__mono,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A4: set @ A,B7: set @ A] :
          ( ! [A5: A] :
              ( ( member @ A @ A5 @ A4 )
             => ? [X5: A] :
                  ( ( member @ A @ X5 @ B7 )
                  & ( ord_less_eq @ A @ A5 @ X5 ) ) )
         => ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ A4 ) @ ( complete_Sup_Sup @ A @ B7 ) ) ) ) ).

% Sup_mono
thf(fact_5389_Sup__least,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A4: set @ A,Z: A] :
          ( ! [X3: A] :
              ( ( member @ A @ X3 @ A4 )
             => ( ord_less_eq @ A @ X3 @ Z ) )
         => ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ A4 ) @ Z ) ) ) ).

% Sup_least
thf(fact_5390_Sup__upper,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [X: A,A4: set @ A] :
          ( ( member @ A @ X @ A4 )
         => ( ord_less_eq @ A @ X @ ( complete_Sup_Sup @ A @ A4 ) ) ) ) ).

% Sup_upper
thf(fact_5391_Sup__le__iff,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A4: set @ A,B2: A] :
          ( ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ A4 ) @ B2 )
          = ( ! [X2: A] :
                ( ( member @ A @ X2 @ A4 )
               => ( ord_less_eq @ A @ X2 @ B2 ) ) ) ) ) ).

% Sup_le_iff
thf(fact_5392_Sup__upper2,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [U: A,A4: set @ A,V: A] :
          ( ( member @ A @ U @ A4 )
         => ( ( ord_less_eq @ A @ V @ U )
           => ( ord_less_eq @ A @ V @ ( complete_Sup_Sup @ A @ A4 ) ) ) ) ) ).

% Sup_upper2
thf(fact_5393_ord_Omax__def,axiom,
    ! [A: $tType] :
      ( ( max @ A )
      = ( ^ [Less_eq2: A > A > $o,A3: A,B3: A] : ( if @ A @ ( Less_eq2 @ A3 @ B3 ) @ B3 @ A3 ) ) ) ).

% ord.max_def
thf(fact_5394_ord_Omax_Ocong,axiom,
    ! [A: $tType] :
      ( ( max @ A )
      = ( max @ A ) ) ).

% ord.max.cong
thf(fact_5395_cSup__eq__maximum,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [Z: A,X7: set @ A] :
          ( ( member @ A @ Z @ X7 )
         => ( ! [X3: A] :
                ( ( member @ A @ X3 @ X7 )
               => ( ord_less_eq @ A @ X3 @ Z ) )
           => ( ( complete_Sup_Sup @ A @ X7 )
              = Z ) ) ) ) ).

% cSup_eq_maximum
thf(fact_5396_cSup__eq,axiom,
    ! [A: $tType] :
      ( ( ( condit1219197933456340205attice @ A )
        & ( no_bot @ A ) )
     => ! [X7: set @ A,A2: A] :
          ( ! [X3: A] :
              ( ( member @ A @ X3 @ X7 )
             => ( ord_less_eq @ A @ X3 @ A2 ) )
         => ( ! [Y5: A] :
                ( ! [X5: A] :
                    ( ( member @ A @ X5 @ X7 )
                   => ( ord_less_eq @ A @ X5 @ Y5 ) )
               => ( ord_less_eq @ A @ A2 @ Y5 ) )
           => ( ( complete_Sup_Sup @ A @ X7 )
              = A2 ) ) ) ) ).

% cSup_eq
thf(fact_5397_SUP__eq,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A4: set @ B,B7: set @ C,F2: B > A,G: C > A] :
          ( ! [I2: B] :
              ( ( member @ B @ I2 @ A4 )
             => ? [X5: C] :
                  ( ( member @ C @ X5 @ B7 )
                  & ( ord_less_eq @ A @ ( F2 @ I2 ) @ ( G @ X5 ) ) ) )
         => ( ! [J2: C] :
                ( ( member @ C @ J2 @ B7 )
               => ? [X5: B] :
                    ( ( member @ B @ X5 @ A4 )
                    & ( ord_less_eq @ A @ ( G @ J2 ) @ ( F2 @ X5 ) ) ) )
           => ( ( complete_Sup_Sup @ A @ ( image @ B @ A @ F2 @ A4 ) )
              = ( complete_Sup_Sup @ A @ ( image @ C @ A @ G @ B7 ) ) ) ) ) ) ).

% SUP_eq
thf(fact_5398_cSup__eq__non__empty,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [X7: set @ A,A2: A] :
          ( ( X7
           != ( bot_bot @ ( set @ A ) ) )
         => ( ! [X3: A] :
                ( ( member @ A @ X3 @ X7 )
               => ( ord_less_eq @ A @ X3 @ A2 ) )
           => ( ! [Y5: A] :
                  ( ! [X5: A] :
                      ( ( member @ A @ X5 @ X7 )
                     => ( ord_less_eq @ A @ X5 @ Y5 ) )
                 => ( ord_less_eq @ A @ A2 @ Y5 ) )
             => ( ( complete_Sup_Sup @ A @ X7 )
                = A2 ) ) ) ) ) ).

% cSup_eq_non_empty
thf(fact_5399_cSup__least,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [X7: set @ A,Z: A] :
          ( ( X7
           != ( bot_bot @ ( set @ A ) ) )
         => ( ! [X3: A] :
                ( ( member @ A @ X3 @ X7 )
               => ( ord_less_eq @ A @ X3 @ Z ) )
           => ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ X7 ) @ Z ) ) ) ) ).

% cSup_least
thf(fact_5400_less__eq__Sup,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A4: set @ A,U: A] :
          ( ! [V4: A] :
              ( ( member @ A @ V4 @ A4 )
             => ( ord_less_eq @ A @ U @ V4 ) )
         => ( ( A4
             != ( bot_bot @ ( set @ A ) ) )
           => ( ord_less_eq @ A @ U @ ( complete_Sup_Sup @ A @ A4 ) ) ) ) ) ).

% less_eq_Sup
thf(fact_5401_le__cSup__finite,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [X7: set @ A,X: A] :
          ( ( finite_finite @ A @ X7 )
         => ( ( member @ A @ X @ X7 )
           => ( ord_less_eq @ A @ X @ ( complete_Sup_Sup @ A @ X7 ) ) ) ) ) ).

% le_cSup_finite
thf(fact_5402_Sup__subset__mono,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A4: set @ A,B7: set @ A] :
          ( ( ord_less_eq @ ( set @ A ) @ A4 @ B7 )
         => ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ A4 ) @ ( complete_Sup_Sup @ A @ B7 ) ) ) ) ).

% Sup_subset_mono
thf(fact_5403_less__cSupD,axiom,
    ! [A: $tType] :
      ( ( condit6923001295902523014norder @ A )
     => ! [X7: set @ A,Z: A] :
          ( ( X7
           != ( bot_bot @ ( set @ A ) ) )
         => ( ( ord_less @ A @ Z @ ( complete_Sup_Sup @ A @ X7 ) )
           => ? [X3: A] :
                ( ( member @ A @ X3 @ X7 )
                & ( ord_less @ A @ Z @ X3 ) ) ) ) ) ).

% less_cSupD
thf(fact_5404_less__cSupE,axiom,
    ! [A: $tType] :
      ( ( condit6923001295902523014norder @ A )
     => ! [Y: A,X7: set @ A] :
          ( ( ord_less @ A @ Y @ ( complete_Sup_Sup @ A @ X7 ) )
         => ( ( X7
             != ( bot_bot @ ( set @ A ) ) )
           => ~ ! [X3: A] :
                  ( ( member @ A @ X3 @ X7 )
                 => ~ ( ord_less @ A @ Y @ X3 ) ) ) ) ) ).

% less_cSupE
thf(fact_5405_finite__imp__Sup__less,axiom,
    ! [A: $tType] :
      ( ( condit6923001295902523014norder @ A )
     => ! [X7: set @ A,X: A,A2: A] :
          ( ( finite_finite @ A @ X7 )
         => ( ( member @ A @ X @ X7 )
           => ( ! [X3: A] :
                  ( ( member @ A @ X3 @ X7 )
                 => ( ord_less @ A @ X3 @ A2 ) )
             => ( ord_less @ A @ ( complete_Sup_Sup @ A @ X7 ) @ A2 ) ) ) ) ) ).

% finite_imp_Sup_less
thf(fact_5406_card__Union__le__sum__card,axiom,
    ! [A: $tType,U3: set @ ( set @ A )] : ( ord_less_eq @ nat @ ( finite_card @ A @ ( complete_Sup_Sup @ ( set @ A ) @ U3 ) ) @ ( groups7311177749621191930dd_sum @ ( set @ A ) @ nat @ ( finite_card @ A ) @ U3 ) ) ).

% card_Union_le_sum_card
thf(fact_5407_SUP__eqI,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A4: set @ B,F2: B > A,X: A] :
          ( ! [I2: B] :
              ( ( member @ B @ I2 @ A4 )
             => ( ord_less_eq @ A @ ( F2 @ I2 ) @ X ) )
         => ( ! [Y5: A] :
                ( ! [I3: B] :
                    ( ( member @ B @ I3 @ A4 )
                   => ( ord_less_eq @ A @ ( F2 @ I3 ) @ Y5 ) )
               => ( ord_less_eq @ A @ X @ Y5 ) )
           => ( ( complete_Sup_Sup @ A @ ( image @ B @ A @ F2 @ A4 ) )
              = X ) ) ) ) ).

% SUP_eqI
thf(fact_5408_SUP__mono,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A4: set @ B,B7: set @ C,F2: B > A,G: C > A] :
          ( ! [N2: B] :
              ( ( member @ B @ N2 @ A4 )
             => ? [X5: C] :
                  ( ( member @ C @ X5 @ B7 )
                  & ( ord_less_eq @ A @ ( F2 @ N2 ) @ ( G @ X5 ) ) ) )
         => ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F2 @ A4 ) ) @ ( complete_Sup_Sup @ A @ ( image @ C @ A @ G @ B7 ) ) ) ) ) ).

% SUP_mono
thf(fact_5409_SUP__least,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A4: set @ B,F2: B > A,U: A] :
          ( ! [I2: B] :
              ( ( member @ B @ I2 @ A4 )
             => ( ord_less_eq @ A @ ( F2 @ I2 ) @ U ) )
         => ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F2 @ A4 ) ) @ U ) ) ) ).

% SUP_least
thf(fact_5410_SUP__mono_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [F2: B > A,G: B > A,A4: set @ B] :
          ( ! [X3: B] : ( ord_less_eq @ A @ ( F2 @ X3 ) @ ( G @ X3 ) )
         => ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F2 @ A4 ) ) @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ G @ A4 ) ) ) ) ) ).

% SUP_mono'
thf(fact_5411_SUP__upper,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [I: B,A4: set @ B,F2: B > A] :
          ( ( member @ B @ I @ A4 )
         => ( ord_less_eq @ A @ ( F2 @ I ) @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F2 @ A4 ) ) ) ) ) ).

% SUP_upper
thf(fact_5412_SUP__le__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [F2: B > A,A4: set @ B,U: A] :
          ( ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F2 @ A4 ) ) @ U )
          = ( ! [X2: B] :
                ( ( member @ B @ X2 @ A4 )
               => ( ord_less_eq @ A @ ( F2 @ X2 ) @ U ) ) ) ) ) ).

% SUP_le_iff
thf(fact_5413_SUP__upper2,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [I: B,A4: set @ B,U: A,F2: B > A] :
          ( ( member @ B @ I @ A4 )
         => ( ( ord_less_eq @ A @ U @ ( F2 @ I ) )
           => ( ord_less_eq @ A @ U @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F2 @ A4 ) ) ) ) ) ) ).

% SUP_upper2
thf(fact_5414_SUP__lessD,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [F2: B > A,A4: set @ B,Y: A,I: B] :
          ( ( ord_less @ A @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F2 @ A4 ) ) @ Y )
         => ( ( member @ B @ I @ A4 )
           => ( ord_less @ A @ ( F2 @ I ) @ Y ) ) ) ) ).

% SUP_lessD
thf(fact_5415_less__SUP__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple5582772986160207858norder @ A )
     => ! [A2: A,F2: B > A,A4: set @ B] :
          ( ( ord_less @ A @ A2 @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F2 @ A4 ) ) )
          = ( ? [X2: B] :
                ( ( member @ B @ X2 @ A4 )
                & ( ord_less @ A @ A2 @ ( F2 @ X2 ) ) ) ) ) ) ).

% less_SUP_iff
thf(fact_5416_le__SUP__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comple5582772986160207858norder @ A )
     => ! [X: A,F2: B > A,A4: set @ B] :
          ( ( ord_less_eq @ A @ X @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F2 @ A4 ) ) )
          = ( ! [Y4: A] :
                ( ( ord_less @ A @ Y4 @ X )
               => ? [X2: B] :
                    ( ( member @ B @ X2 @ A4 )
                    & ( ord_less @ A @ Y4 @ ( F2 @ X2 ) ) ) ) ) ) ) ).

% le_SUP_iff
thf(fact_5417_cSUP__least,axiom,
    ! [B: $tType,A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [A4: set @ B,F2: B > A,M5: A] :
          ( ( A4
           != ( bot_bot @ ( set @ B ) ) )
         => ( ! [X3: B] :
                ( ( member @ B @ X3 @ A4 )
               => ( ord_less_eq @ A @ ( F2 @ X3 ) @ M5 ) )
           => ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F2 @ A4 ) ) @ M5 ) ) ) ) ).

% cSUP_least
thf(fact_5418_SUP__eq__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [I5: set @ B,C2: A,F2: B > A] :
          ( ( I5
           != ( bot_bot @ ( set @ B ) ) )
         => ( ! [I2: B] :
                ( ( member @ B @ I2 @ I5 )
               => ( ord_less_eq @ A @ C2 @ ( F2 @ I2 ) ) )
           => ( ( ( complete_Sup_Sup @ A @ ( image @ B @ A @ F2 @ I5 ) )
                = C2 )
              = ( ! [X2: B] :
                    ( ( member @ B @ X2 @ I5 )
                   => ( ( F2 @ X2 )
                      = C2 ) ) ) ) ) ) ) ).

% SUP_eq_iff
thf(fact_5419_finite__Sup__less__iff,axiom,
    ! [A: $tType] :
      ( ( condit6923001295902523014norder @ A )
     => ! [X7: set @ A,A2: A] :
          ( ( finite_finite @ A @ X7 )
         => ( ( X7
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ord_less @ A @ ( complete_Sup_Sup @ A @ X7 ) @ A2 )
              = ( ! [X2: A] :
                    ( ( member @ A @ X2 @ X7 )
                   => ( ord_less @ A @ X2 @ A2 ) ) ) ) ) ) ) ).

% finite_Sup_less_iff
thf(fact_5420_Inf__le__Sup,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A4: set @ A] :
          ( ( A4
           != ( bot_bot @ ( set @ A ) ) )
         => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ A4 ) @ ( complete_Sup_Sup @ A @ A4 ) ) ) ) ).

% Inf_le_Sup
thf(fact_5421_cSup__abs__le,axiom,
    ! [A: $tType] :
      ( ( ( condit6923001295902523014norder @ A )
        & ( linordered_idom @ A ) )
     => ! [S: set @ A,A2: A] :
          ( ( S
           != ( bot_bot @ ( set @ A ) ) )
         => ( ! [X3: A] :
                ( ( member @ A @ X3 @ S )
               => ( ord_less_eq @ A @ ( abs_abs @ A @ X3 ) @ A2 ) )
           => ( ord_less_eq @ A @ ( abs_abs @ A @ ( complete_Sup_Sup @ A @ S ) ) @ A2 ) ) ) ) ).

% cSup_abs_le
thf(fact_5422_Sup__inter__less__eq,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A4: set @ A,B7: set @ A] : ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ ( inf_inf @ ( set @ A ) @ A4 @ B7 ) ) @ ( inf_inf @ A @ ( complete_Sup_Sup @ A @ A4 ) @ ( complete_Sup_Sup @ A @ B7 ) ) ) ) ).

% Sup_inter_less_eq
thf(fact_5423_sum_OUnion__comp,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [B7: set @ ( set @ B ),G: B > A] :
          ( ! [X3: set @ B] :
              ( ( member @ ( set @ B ) @ X3 @ B7 )
             => ( finite_finite @ B @ X3 ) )
         => ( ! [A14: set @ B] :
                ( ( member @ ( set @ B ) @ A14 @ B7 )
               => ! [A25: set @ B] :
                    ( ( member @ ( set @ B ) @ A25 @ B7 )
                   => ( ( A14 != A25 )
                     => ! [X3: B] :
                          ( ( member @ B @ X3 @ A14 )
                         => ( ( member @ B @ X3 @ A25 )
                           => ( ( G @ X3 )
                              = ( zero_zero @ A ) ) ) ) ) ) )
           => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ ( complete_Sup_Sup @ ( set @ B ) @ B7 ) )
              = ( comp @ ( ( set @ B ) > A ) @ ( ( set @ ( set @ B ) ) > A ) @ ( B > A ) @ ( groups7311177749621191930dd_sum @ ( set @ B ) @ A ) @ ( groups7311177749621191930dd_sum @ B @ A ) @ G @ B7 ) ) ) ) ) ).

% sum.Union_comp
thf(fact_5424_Max__Sup,axiom,
    ! [A: $tType] :
      ( ( comple5582772986160207858norder @ A )
     => ! [A4: set @ A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( A4
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( lattic643756798349783984er_Max @ A @ A4 )
              = ( complete_Sup_Sup @ A @ A4 ) ) ) ) ) ).

% Max_Sup
thf(fact_5425_cSup__eq__Max,axiom,
    ! [A: $tType] :
      ( ( condit6923001295902523014norder @ A )
     => ! [X7: set @ A] :
          ( ( finite_finite @ A @ X7 )
         => ( ( X7
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( complete_Sup_Sup @ A @ X7 )
              = ( lattic643756798349783984er_Max @ A @ X7 ) ) ) ) ) ).

% cSup_eq_Max
thf(fact_5426_card__Union__le__sum__card__weak,axiom,
    ! [A: $tType,U3: set @ ( set @ A )] :
      ( ! [X3: set @ A] :
          ( ( member @ ( set @ A ) @ X3 @ U3 )
         => ( finite_finite @ A @ X3 ) )
     => ( ord_less_eq @ nat @ ( finite_card @ A @ ( complete_Sup_Sup @ ( set @ A ) @ U3 ) ) @ ( groups7311177749621191930dd_sum @ ( set @ A ) @ nat @ ( finite_card @ A ) @ U3 ) ) ) ).

% card_Union_le_sum_card_weak
thf(fact_5427_SUP__subset__mono,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A4: set @ B,B7: set @ B,F2: B > A,G: B > A] :
          ( ( ord_less_eq @ ( set @ B ) @ A4 @ B7 )
         => ( ! [X3: B] :
                ( ( member @ B @ X3 @ A4 )
               => ( ord_less_eq @ A @ ( F2 @ X3 ) @ ( G @ X3 ) ) )
           => ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F2 @ A4 ) ) @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ G @ B7 ) ) ) ) ) ) ).

% SUP_subset_mono
thf(fact_5428_cSup__asclose,axiom,
    ! [A: $tType] :
      ( ( ( condit6923001295902523014norder @ A )
        & ( linordered_idom @ A ) )
     => ! [S: set @ A,L: A,E2: A] :
          ( ( S
           != ( bot_bot @ ( set @ A ) ) )
         => ( ! [X3: A] :
                ( ( member @ A @ X3 @ S )
               => ( ord_less_eq @ A @ ( abs_abs @ A @ ( minus_minus @ A @ X3 @ L ) ) @ E2 ) )
           => ( ord_less_eq @ A @ ( abs_abs @ A @ ( minus_minus @ A @ ( complete_Sup_Sup @ A @ S ) @ L ) ) @ E2 ) ) ) ) ).

% cSup_asclose
thf(fact_5429_INF__le__SUP,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A4: set @ B,F2: B > A] :
          ( ( A4
           != ( bot_bot @ ( set @ B ) ) )
         => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ F2 @ A4 ) ) @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F2 @ A4 ) ) ) ) ) ).

% INF_le_SUP
thf(fact_5430_Sup__insert__finite,axiom,
    ! [A: $tType] :
      ( ( condit6923001295902523014norder @ A )
     => ! [S: set @ A,X: A] :
          ( ( finite_finite @ A @ S )
         => ( ( ( S
                = ( bot_bot @ ( set @ A ) ) )
             => ( ( complete_Sup_Sup @ A @ ( insert @ A @ X @ S ) )
                = X ) )
            & ( ( S
               != ( bot_bot @ ( set @ A ) ) )
             => ( ( complete_Sup_Sup @ A @ ( insert @ A @ X @ S ) )
                = ( ord_max @ A @ X @ ( complete_Sup_Sup @ A @ S ) ) ) ) ) ) ) ).

% Sup_insert_finite
thf(fact_5431_card__UN__le,axiom,
    ! [B: $tType,A: $tType,I5: set @ A,A4: A > ( set @ B )] :
      ( ( finite_finite @ A @ I5 )
     => ( ord_less_eq @ nat @ ( finite_card @ B @ ( complete_Sup_Sup @ ( set @ B ) @ ( image @ A @ ( set @ B ) @ A4 @ I5 ) ) )
        @ ( groups7311177749621191930dd_sum @ A @ nat
          @ ^ [I4: A] : ( finite_card @ B @ ( A4 @ I4 ) )
          @ I5 ) ) ) ).

% card_UN_le
thf(fact_5432_finite__mono__strict__prefix__implies__finite__fixpoint,axiom,
    ! [A: $tType,F2: nat > ( set @ A ),S: set @ A] :
      ( ! [I2: nat] : ( ord_less_eq @ ( set @ A ) @ ( F2 @ I2 ) @ S )
     => ( ( finite_finite @ A @ S )
       => ( ? [N8: nat] :
              ( ! [N2: nat] :
                  ( ( ord_less_eq @ nat @ N2 @ N8 )
                 => ! [M4: nat] :
                      ( ( ord_less_eq @ nat @ M4 @ N8 )
                     => ( ( ord_less @ nat @ M4 @ N2 )
                       => ( ord_less @ ( set @ A ) @ ( F2 @ M4 ) @ ( F2 @ N2 ) ) ) ) )
              & ! [N2: nat] :
                  ( ( ord_less_eq @ nat @ N8 @ N2 )
                 => ( ( F2 @ N8 )
                    = ( F2 @ N2 ) ) ) )
         => ( ( F2 @ ( finite_card @ A @ S ) )
            = ( complete_Sup_Sup @ ( set @ A ) @ ( image @ nat @ ( set @ A ) @ F2 @ ( top_top @ ( set @ nat ) ) ) ) ) ) ) ) ).

% finite_mono_strict_prefix_implies_finite_fixpoint
thf(fact_5433_card__Pow,axiom,
    ! [A: $tType,A4: set @ A] :
      ( ( finite_finite @ A @ A4 )
     => ( ( finite_card @ ( set @ A ) @ ( pow2 @ A @ A4 ) )
        = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( finite_card @ A @ A4 ) ) ) ) ).

% card_Pow
thf(fact_5434_sums__SUP,axiom,
    ! [A: $tType] :
      ( ( ( comple5582772986160207858norder @ A )
        & ( canoni5634975068530333245id_add @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [F2: nat > A] :
          ( sums @ A @ F2
          @ ( complete_Sup_Sup @ A
            @ ( image @ nat @ A
              @ ^ [N3: nat] : ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_ord_lessThan @ nat @ N3 ) )
              @ ( top_top @ ( set @ nat ) ) ) ) ) ) ).

% sums_SUP
thf(fact_5435_top__apply,axiom,
    ! [C: $tType,D: $tType] :
      ( ( top @ C )
     => ( ( top_top @ ( D > C ) )
        = ( ^ [X2: D] : ( top_top @ C ) ) ) ) ).

% top_apply
thf(fact_5436_inf__top_Oright__neutral,axiom,
    ! [A: $tType] :
      ( ( bounde4346867609351753570nf_top @ A )
     => ! [A2: A] :
          ( ( inf_inf @ A @ A2 @ ( top_top @ A ) )
          = A2 ) ) ).

% inf_top.right_neutral
thf(fact_5437_inf__top_Oneutr__eq__iff,axiom,
    ! [A: $tType] :
      ( ( bounde4346867609351753570nf_top @ A )
     => ! [A2: A,B2: A] :
          ( ( ( top_top @ A )
            = ( inf_inf @ A @ A2 @ B2 ) )
          = ( ( A2
              = ( top_top @ A ) )
            & ( B2
              = ( top_top @ A ) ) ) ) ) ).

% inf_top.neutr_eq_iff
thf(fact_5438_inf__top_Oleft__neutral,axiom,
    ! [A: $tType] :
      ( ( bounde4346867609351753570nf_top @ A )
     => ! [A2: A] :
          ( ( inf_inf @ A @ ( top_top @ A ) @ A2 )
          = A2 ) ) ).

% inf_top.left_neutral
thf(fact_5439_inf__top_Oeq__neutr__iff,axiom,
    ! [A: $tType] :
      ( ( bounde4346867609351753570nf_top @ A )
     => ! [A2: A,B2: A] :
          ( ( ( inf_inf @ A @ A2 @ B2 )
            = ( top_top @ A ) )
          = ( ( A2
              = ( top_top @ A ) )
            & ( B2
              = ( top_top @ A ) ) ) ) ) ).

% inf_top.eq_neutr_iff
thf(fact_5440_top__eq__inf__iff,axiom,
    ! [A: $tType] :
      ( ( bounde4346867609351753570nf_top @ A )
     => ! [X: A,Y: A] :
          ( ( ( top_top @ A )
            = ( inf_inf @ A @ X @ Y ) )
          = ( ( X
              = ( top_top @ A ) )
            & ( Y
              = ( top_top @ A ) ) ) ) ) ).

% top_eq_inf_iff
thf(fact_5441_inf__eq__top__iff,axiom,
    ! [A: $tType] :
      ( ( bounde4346867609351753570nf_top @ A )
     => ! [X: A,Y: A] :
          ( ( ( inf_inf @ A @ X @ Y )
            = ( top_top @ A ) )
          = ( ( X
              = ( top_top @ A ) )
            & ( Y
              = ( top_top @ A ) ) ) ) ) ).

% inf_eq_top_iff
thf(fact_5442_inf__top__right,axiom,
    ! [A: $tType] :
      ( ( bounde4346867609351753570nf_top @ A )
     => ! [X: A] :
          ( ( inf_inf @ A @ X @ ( top_top @ A ) )
          = X ) ) ).

% inf_top_right
thf(fact_5443_inf__top__left,axiom,
    ! [A: $tType] :
      ( ( bounde4346867609351753570nf_top @ A )
     => ! [X: A] :
          ( ( inf_inf @ A @ ( top_top @ A ) @ X )
          = X ) ) ).

% inf_top_left
thf(fact_5444_max__top2,axiom,
    ! [A: $tType] :
      ( ( order_top @ A )
     => ! [X: A] :
          ( ( ord_max @ A @ X @ ( top_top @ A ) )
          = ( top_top @ A ) ) ) ).

% max_top2
thf(fact_5445_max__top,axiom,
    ! [A: $tType] :
      ( ( order_top @ A )
     => ! [X: A] :
          ( ( ord_max @ A @ ( top_top @ A ) @ X )
          = ( top_top @ A ) ) ) ).

% max_top
thf(fact_5446_min__top,axiom,
    ! [A: $tType] :
      ( ( order_top @ A )
     => ! [X: A] :
          ( ( ord_min @ A @ ( top_top @ A ) @ X )
          = X ) ) ).

% min_top
thf(fact_5447_min__top2,axiom,
    ! [A: $tType] :
      ( ( order_top @ A )
     => ! [X: A] :
          ( ( ord_min @ A @ X @ ( top_top @ A ) )
          = X ) ) ).

% min_top2
thf(fact_5448_Sup__nat__empty,axiom,
    ( ( complete_Sup_Sup @ nat @ ( bot_bot @ ( set @ nat ) ) )
    = ( zero_zero @ nat ) ) ).

% Sup_nat_empty
thf(fact_5449_Sup__eq__top__iff,axiom,
    ! [A: $tType] :
      ( ( comple5582772986160207858norder @ A )
     => ! [A4: set @ A] :
          ( ( ( complete_Sup_Sup @ A @ A4 )
            = ( top_top @ A ) )
          = ( ! [X2: A] :
                ( ( ord_less @ A @ X2 @ ( top_top @ A ) )
               => ? [Y4: A] :
                    ( ( member @ A @ Y4 @ A4 )
                    & ( ord_less @ A @ X2 @ Y4 ) ) ) ) ) ) ).

% Sup_eq_top_iff
thf(fact_5450_surj__fn,axiom,
    ! [A: $tType,F2: A > A,N: nat] :
      ( ( ( image @ A @ A @ F2 @ ( top_top @ ( set @ A ) ) )
        = ( top_top @ ( set @ A ) ) )
     => ( ( image @ A @ A @ ( compow @ ( A > A ) @ N @ F2 ) @ ( top_top @ ( set @ A ) ) )
        = ( top_top @ ( set @ A ) ) ) ) ).

% surj_fn
thf(fact_5451_SUP__eq__top__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comple5582772986160207858norder @ A )
     => ! [F2: B > A,A4: set @ B] :
          ( ( ( complete_Sup_Sup @ A @ ( image @ B @ A @ F2 @ A4 ) )
            = ( top_top @ A ) )
          = ( ! [X2: A] :
                ( ( ord_less @ A @ X2 @ ( top_top @ A ) )
               => ? [Y4: B] :
                    ( ( member @ B @ Y4 @ A4 )
                    & ( ord_less @ A @ X2 @ ( F2 @ Y4 ) ) ) ) ) ) ) ).

% SUP_eq_top_iff
thf(fact_5452_Inf__atMostLessThan,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [X: A] :
          ( ( ord_less @ A @ ( top_top @ A ) @ X )
         => ( ( complete_Inf_Inf @ A @ ( set_ord_lessThan @ A @ X ) )
            = ( bot_bot @ A ) ) ) ) ).

% Inf_atMostLessThan
thf(fact_5453_Inf__real__def,axiom,
    ( ( complete_Inf_Inf @ real )
    = ( ^ [X8: set @ real] : ( uminus_uminus @ real @ ( complete_Sup_Sup @ real @ ( image @ real @ real @ ( uminus_uminus @ real ) @ X8 ) ) ) ) ) ).

% Inf_real_def
thf(fact_5454_top__greatest,axiom,
    ! [A: $tType] :
      ( ( order_top @ A )
     => ! [A2: A] : ( ord_less_eq @ A @ A2 @ ( top_top @ A ) ) ) ).

% top_greatest
thf(fact_5455_top_Oextremum__unique,axiom,
    ! [A: $tType] :
      ( ( order_top @ A )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ ( top_top @ A ) @ A2 )
          = ( A2
            = ( top_top @ A ) ) ) ) ).

% top.extremum_unique
thf(fact_5456_top_Oextremum__uniqueI,axiom,
    ! [A: $tType] :
      ( ( order_top @ A )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ ( top_top @ A ) @ A2 )
         => ( A2
            = ( top_top @ A ) ) ) ) ).

% top.extremum_uniqueI
thf(fact_5457_top_Onot__eq__extremum,axiom,
    ! [A: $tType] :
      ( ( order_top @ A )
     => ! [A2: A] :
          ( ( ( A2
             != ( top_top @ A ) ) )
          = ( ord_less @ A @ A2 @ ( top_top @ A ) ) ) ) ).

% top.not_eq_extremum
thf(fact_5458_top_Oextremum__strict,axiom,
    ! [A: $tType] :
      ( ( order_top @ A )
     => ! [A2: A] :
          ~ ( ord_less @ A @ ( top_top @ A ) @ A2 ) ) ).

% top.extremum_strict
thf(fact_5459_finite__fun__UNIVD1,axiom,
    ! [B: $tType,A: $tType] :
      ( ( finite_finite @ ( A > B ) @ ( top_top @ ( set @ ( A > B ) ) ) )
     => ( ( ( finite_card @ B @ ( top_top @ ( set @ B ) ) )
         != ( suc @ ( zero_zero @ nat ) ) )
       => ( finite_finite @ A @ ( top_top @ ( set @ A ) ) ) ) ) ).

% finite_fun_UNIVD1
thf(fact_5460_bij__fn,axiom,
    ! [A: $tType,F2: A > A,N: nat] :
      ( ( bij_betw @ A @ A @ F2 @ ( top_top @ ( set @ A ) ) @ ( top_top @ ( set @ A ) ) )
     => ( bij_betw @ A @ A @ ( compow @ ( A > A ) @ N @ F2 ) @ ( top_top @ ( set @ A ) ) @ ( top_top @ ( set @ A ) ) ) ) ).

% bij_fn
thf(fact_5461_Inf__int__def,axiom,
    ( ( complete_Inf_Inf @ int )
    = ( ^ [X8: set @ int] : ( uminus_uminus @ int @ ( complete_Sup_Sup @ int @ ( image @ int @ int @ ( uminus_uminus @ int ) @ X8 ) ) ) ) ) ).

% Inf_int_def
thf(fact_5462_suminf__eq__SUP__real,axiom,
    ! [X7: nat > real] :
      ( ( summable @ real @ X7 )
     => ( ! [I2: nat] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( X7 @ I2 ) )
       => ( ( suminf @ real @ X7 )
          = ( complete_Sup_Sup @ real
            @ ( image @ nat @ real
              @ ^ [I4: nat] : ( groups7311177749621191930dd_sum @ nat @ real @ X7 @ ( set_ord_lessThan @ nat @ I4 ) )
              @ ( top_top @ ( set @ nat ) ) ) ) ) ) ) ).

% suminf_eq_SUP_real
thf(fact_5463_Sup__nat__def,axiom,
    ( ( complete_Sup_Sup @ nat )
    = ( ^ [X8: set @ nat] :
          ( if @ nat
          @ ( X8
            = ( bot_bot @ ( set @ nat ) ) )
          @ ( zero_zero @ nat )
          @ ( lattic643756798349783984er_Max @ nat @ X8 ) ) ) ) ).

% Sup_nat_def
thf(fact_5464_inf__top_Osemilattice__neutr__order__axioms,axiom,
    ! [A: $tType] :
      ( ( bounde4346867609351753570nf_top @ A )
     => ( semila1105856199041335345_order @ A @ ( inf_inf @ A ) @ ( top_top @ A ) @ ( ord_less_eq @ A ) @ ( ord_less @ A ) ) ) ).

% inf_top.semilattice_neutr_order_axioms
thf(fact_5465_finite__UNIV__card__ge__0,axiom,
    ! [A: $tType] :
      ( ( finite_finite @ A @ ( top_top @ ( set @ A ) ) )
     => ( ord_less @ nat @ ( zero_zero @ nat ) @ ( finite_card @ A @ ( top_top @ ( set @ A ) ) ) ) ) ).

% finite_UNIV_card_ge_0
thf(fact_5466_UN__UN__finite__eq,axiom,
    ! [A: $tType,A4: nat > ( set @ A )] :
      ( ( complete_Sup_Sup @ ( set @ A )
        @ ( image @ nat @ ( set @ A )
          @ ^ [N3: nat] : ( complete_Sup_Sup @ ( set @ A ) @ ( image @ nat @ ( set @ A ) @ A4 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N3 ) ) )
          @ ( top_top @ ( set @ nat ) ) ) )
      = ( complete_Sup_Sup @ ( set @ A ) @ ( image @ nat @ ( set @ A ) @ A4 @ ( top_top @ ( set @ nat ) ) ) ) ) ).

% UN_UN_finite_eq
thf(fact_5467_binomial__def,axiom,
    ( binomial
    = ( ^ [N3: nat,K3: nat] :
          ( finite_card @ ( set @ nat )
          @ ( collect @ ( set @ nat )
            @ ^ [K7: set @ nat] :
                ( ( member @ ( set @ nat ) @ K7 @ ( pow2 @ nat @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N3 ) ) )
                & ( ( finite_card @ nat @ K7 )
                  = K3 ) ) ) ) ) ) ).

% binomial_def
thf(fact_5468_card__range__greater__zero,axiom,
    ! [A: $tType,B: $tType,F2: B > A] :
      ( ( finite_finite @ A @ ( image @ B @ A @ F2 @ ( top_top @ ( set @ B ) ) ) )
     => ( ord_less @ nat @ ( zero_zero @ nat ) @ ( finite_card @ A @ ( image @ B @ A @ F2 @ ( top_top @ ( set @ B ) ) ) ) ) ) ).

% card_range_greater_zero
thf(fact_5469_UN__finite__subset,axiom,
    ! [A: $tType,A4: nat > ( set @ A ),C5: set @ A] :
      ( ! [N2: nat] : ( ord_less_eq @ ( set @ A ) @ ( complete_Sup_Sup @ ( set @ A ) @ ( image @ nat @ ( set @ A ) @ A4 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N2 ) ) ) @ C5 )
     => ( ord_less_eq @ ( set @ A ) @ ( complete_Sup_Sup @ ( set @ A ) @ ( image @ nat @ ( set @ A ) @ A4 @ ( top_top @ ( set @ nat ) ) ) ) @ C5 ) ) ).

% UN_finite_subset
thf(fact_5470_UN__finite2__eq,axiom,
    ! [A: $tType,A4: nat > ( set @ A ),B7: nat > ( set @ A ),K: nat] :
      ( ! [N2: nat] :
          ( ( complete_Sup_Sup @ ( set @ A ) @ ( image @ nat @ ( set @ A ) @ A4 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N2 ) ) )
          = ( complete_Sup_Sup @ ( set @ A ) @ ( image @ nat @ ( set @ A ) @ B7 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( plus_plus @ nat @ N2 @ K ) ) ) ) )
     => ( ( complete_Sup_Sup @ ( set @ A ) @ ( image @ nat @ ( set @ A ) @ A4 @ ( top_top @ ( set @ nat ) ) ) )
        = ( complete_Sup_Sup @ ( set @ A ) @ ( image @ nat @ ( set @ A ) @ B7 @ ( top_top @ ( set @ nat ) ) ) ) ) ) ).

% UN_finite2_eq
thf(fact_5471_suminf__eq__SUP,axiom,
    ! [A: $tType] :
      ( ( ( comple5582772986160207858norder @ A )
        & ( canoni5634975068530333245id_add @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ( ( suminf @ A )
        = ( ^ [F3: nat > A] :
              ( complete_Sup_Sup @ A
              @ ( image @ nat @ A
                @ ^ [N3: nat] : ( groups7311177749621191930dd_sum @ nat @ A @ F3 @ ( set_ord_lessThan @ nat @ N3 ) )
                @ ( top_top @ ( set @ nat ) ) ) ) ) ) ) ).

% suminf_eq_SUP
thf(fact_5472_range__mod,axiom,
    ! [N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( image @ nat @ nat
          @ ^ [M3: nat] : ( modulo_modulo @ nat @ M3 @ N )
          @ ( top_top @ ( set @ nat ) ) )
        = ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N ) ) ) ).

% range_mod
thf(fact_5473_UN__finite2__subset,axiom,
    ! [A: $tType,A4: nat > ( set @ A ),B7: nat > ( set @ A ),K: nat] :
      ( ! [N2: nat] : ( ord_less_eq @ ( set @ A ) @ ( complete_Sup_Sup @ ( set @ A ) @ ( image @ nat @ ( set @ A ) @ A4 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N2 ) ) ) @ ( complete_Sup_Sup @ ( set @ A ) @ ( image @ nat @ ( set @ A ) @ B7 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( plus_plus @ nat @ N2 @ K ) ) ) ) )
     => ( ord_less_eq @ ( set @ A ) @ ( complete_Sup_Sup @ ( set @ A ) @ ( image @ nat @ ( set @ A ) @ A4 @ ( top_top @ ( set @ nat ) ) ) ) @ ( complete_Sup_Sup @ ( set @ A ) @ ( image @ nat @ ( set @ A ) @ B7 @ ( top_top @ ( set @ nat ) ) ) ) ) ) ).

% UN_finite2_subset
thf(fact_5474_UNIV__nat__eq,axiom,
    ( ( top_top @ ( set @ nat ) )
    = ( insert @ nat @ ( zero_zero @ nat ) @ ( image @ nat @ nat @ suc @ ( top_top @ ( set @ nat ) ) ) ) ) ).

% UNIV_nat_eq
thf(fact_5475_UN__le__eq__Un0,axiom,
    ! [A: $tType,M5: nat > ( set @ A ),N: nat] :
      ( ( complete_Sup_Sup @ ( set @ A ) @ ( image @ nat @ ( set @ A ) @ M5 @ ( set_ord_atMost @ nat @ N ) ) )
      = ( sup_sup @ ( set @ A ) @ ( complete_Sup_Sup @ ( set @ A ) @ ( image @ nat @ ( set @ A ) @ M5 @ ( set_or1337092689740270186AtMost @ nat @ ( one_one @ nat ) @ N ) ) ) @ ( M5 @ ( zero_zero @ nat ) ) ) ) ).

% UN_le_eq_Un0
thf(fact_5476_nth__rotate,axiom,
    ! [A: $tType,N: nat,Xs: list @ A,M: nat] :
      ( ( ord_less @ nat @ N @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( ( nth @ A @ ( rotate @ A @ M @ Xs ) @ N )
        = ( nth @ A @ Xs @ ( modulo_modulo @ nat @ ( plus_plus @ nat @ M @ N ) @ ( size_size @ ( list @ A ) @ Xs ) ) ) ) ) ).

% nth_rotate
thf(fact_5477_sup_Oidem,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A2: A] :
          ( ( sup_sup @ A @ A2 @ A2 )
          = A2 ) ) ).

% sup.idem
thf(fact_5478_sup__idem,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [X: A] :
          ( ( sup_sup @ A @ X @ X )
          = X ) ) ).

% sup_idem
thf(fact_5479_sup_Oleft__idem,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A2: A,B2: A] :
          ( ( sup_sup @ A @ A2 @ ( sup_sup @ A @ A2 @ B2 ) )
          = ( sup_sup @ A @ A2 @ B2 ) ) ) ).

% sup.left_idem
thf(fact_5480_sup__left__idem,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [X: A,Y: A] :
          ( ( sup_sup @ A @ X @ ( sup_sup @ A @ X @ Y ) )
          = ( sup_sup @ A @ X @ Y ) ) ) ).

% sup_left_idem
thf(fact_5481_sup_Oright__idem,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A2: A,B2: A] :
          ( ( sup_sup @ A @ ( sup_sup @ A @ A2 @ B2 ) @ B2 )
          = ( sup_sup @ A @ A2 @ B2 ) ) ) ).

% sup.right_idem
thf(fact_5482_sup__apply,axiom,
    ! [B: $tType,A: $tType] :
      ( ( semilattice_sup @ B )
     => ( ( sup_sup @ ( A > B ) )
        = ( ^ [F3: A > B,G2: A > B,X2: A] : ( sup_sup @ B @ ( F3 @ X2 ) @ ( G2 @ X2 ) ) ) ) ) ).

% sup_apply
thf(fact_5483_sup_Obounded__iff,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( ord_less_eq @ A @ ( sup_sup @ A @ B2 @ C2 ) @ A2 )
          = ( ( ord_less_eq @ A @ B2 @ A2 )
            & ( ord_less_eq @ A @ C2 @ A2 ) ) ) ) ).

% sup.bounded_iff
thf(fact_5484_le__sup__iff,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [X: A,Y: A,Z: A] :
          ( ( ord_less_eq @ A @ ( sup_sup @ A @ X @ Y ) @ Z )
          = ( ( ord_less_eq @ A @ X @ Z )
            & ( ord_less_eq @ A @ Y @ Z ) ) ) ) ).

% le_sup_iff
thf(fact_5485_sup__top__right,axiom,
    ! [A: $tType] :
      ( ( bounded_lattice_top @ A )
     => ! [X: A] :
          ( ( sup_sup @ A @ X @ ( top_top @ A ) )
          = ( top_top @ A ) ) ) ).

% sup_top_right
thf(fact_5486_sup__top__left,axiom,
    ! [A: $tType] :
      ( ( bounded_lattice_top @ A )
     => ! [X: A] :
          ( ( sup_sup @ A @ ( top_top @ A ) @ X )
          = ( top_top @ A ) ) ) ).

% sup_top_left
thf(fact_5487_sup__bot__left,axiom,
    ! [A: $tType] :
      ( ( bounde4967611905675639751up_bot @ A )
     => ! [X: A] :
          ( ( sup_sup @ A @ ( bot_bot @ A ) @ X )
          = X ) ) ).

% sup_bot_left
thf(fact_5488_sup__bot__right,axiom,
    ! [A: $tType] :
      ( ( bounde4967611905675639751up_bot @ A )
     => ! [X: A] :
          ( ( sup_sup @ A @ X @ ( bot_bot @ A ) )
          = X ) ) ).

% sup_bot_right
thf(fact_5489_bot__eq__sup__iff,axiom,
    ! [A: $tType] :
      ( ( bounde4967611905675639751up_bot @ A )
     => ! [X: A,Y: A] :
          ( ( ( bot_bot @ A )
            = ( sup_sup @ A @ X @ Y ) )
          = ( ( X
              = ( bot_bot @ A ) )
            & ( Y
              = ( bot_bot @ A ) ) ) ) ) ).

% bot_eq_sup_iff
thf(fact_5490_sup__eq__bot__iff,axiom,
    ! [A: $tType] :
      ( ( bounde4967611905675639751up_bot @ A )
     => ! [X: A,Y: A] :
          ( ( ( sup_sup @ A @ X @ Y )
            = ( bot_bot @ A ) )
          = ( ( X
              = ( bot_bot @ A ) )
            & ( Y
              = ( bot_bot @ A ) ) ) ) ) ).

% sup_eq_bot_iff
thf(fact_5491_sup__bot_Oeq__neutr__iff,axiom,
    ! [A: $tType] :
      ( ( bounde4967611905675639751up_bot @ A )
     => ! [A2: A,B2: A] :
          ( ( ( sup_sup @ A @ A2 @ B2 )
            = ( bot_bot @ A ) )
          = ( ( A2
              = ( bot_bot @ A ) )
            & ( B2
              = ( bot_bot @ A ) ) ) ) ) ).

% sup_bot.eq_neutr_iff
thf(fact_5492_sup__bot_Oleft__neutral,axiom,
    ! [A: $tType] :
      ( ( bounde4967611905675639751up_bot @ A )
     => ! [A2: A] :
          ( ( sup_sup @ A @ ( bot_bot @ A ) @ A2 )
          = A2 ) ) ).

% sup_bot.left_neutral
thf(fact_5493_sup__bot_Oneutr__eq__iff,axiom,
    ! [A: $tType] :
      ( ( bounde4967611905675639751up_bot @ A )
     => ! [A2: A,B2: A] :
          ( ( ( bot_bot @ A )
            = ( sup_sup @ A @ A2 @ B2 ) )
          = ( ( A2
              = ( bot_bot @ A ) )
            & ( B2
              = ( bot_bot @ A ) ) ) ) ) ).

% sup_bot.neutr_eq_iff
thf(fact_5494_sup__bot_Oright__neutral,axiom,
    ! [A: $tType] :
      ( ( bounde4967611905675639751up_bot @ A )
     => ! [A2: A] :
          ( ( sup_sup @ A @ A2 @ ( bot_bot @ A ) )
          = A2 ) ) ).

% sup_bot.right_neutral
thf(fact_5495_sup__inf__absorb,axiom,
    ! [A: $tType] :
      ( ( lattice @ A )
     => ! [X: A,Y: A] :
          ( ( sup_sup @ A @ X @ ( inf_inf @ A @ X @ Y ) )
          = X ) ) ).

% sup_inf_absorb
thf(fact_5496_inf__sup__absorb,axiom,
    ! [A: $tType] :
      ( ( lattice @ A )
     => ! [X: A,Y: A] :
          ( ( inf_inf @ A @ X @ ( sup_sup @ A @ X @ Y ) )
          = X ) ) ).

% inf_sup_absorb
thf(fact_5497_rotate0,axiom,
    ! [A: $tType] :
      ( ( rotate @ A @ ( zero_zero @ nat ) )
      = ( id @ ( list @ A ) ) ) ).

% rotate0
thf(fact_5498_card__UNIV__bool,axiom,
    ( ( finite_card @ $o @ ( top_top @ ( set @ $o ) ) )
    = ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ).

% card_UNIV_bool
thf(fact_5499_range__mult,axiom,
    ! [A2: real] :
      ( ( ( A2
          = ( zero_zero @ real ) )
       => ( ( image @ real @ real @ ( times_times @ real @ A2 ) @ ( top_top @ ( set @ real ) ) )
          = ( insert @ real @ ( zero_zero @ real ) @ ( bot_bot @ ( set @ real ) ) ) ) )
      & ( ( A2
         != ( zero_zero @ real ) )
       => ( ( image @ real @ real @ ( times_times @ real @ A2 ) @ ( top_top @ ( set @ real ) ) )
          = ( top_top @ ( set @ real ) ) ) ) ) ).

% range_mult
thf(fact_5500_rotate__length01,axiom,
    ! [A: $tType,Xs: list @ A,N: nat] :
      ( ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ ( one_one @ nat ) )
     => ( ( rotate @ A @ N @ Xs )
        = Xs ) ) ).

% rotate_length01
thf(fact_5501_rotate__id,axiom,
    ! [A: $tType,N: nat,Xs: list @ A] :
      ( ( ( modulo_modulo @ nat @ N @ ( size_size @ ( list @ A ) @ Xs ) )
        = ( zero_zero @ nat ) )
     => ( ( rotate @ A @ N @ Xs )
        = Xs ) ) ).

% rotate_id
thf(fact_5502_sup__inf__distrib2,axiom,
    ! [A: $tType] :
      ( ( distrib_lattice @ A )
     => ! [Y: A,Z: A,X: A] :
          ( ( sup_sup @ A @ ( inf_inf @ A @ Y @ Z ) @ X )
          = ( inf_inf @ A @ ( sup_sup @ A @ Y @ X ) @ ( sup_sup @ A @ Z @ X ) ) ) ) ).

% sup_inf_distrib2
thf(fact_5503_sup__inf__distrib1,axiom,
    ! [A: $tType] :
      ( ( distrib_lattice @ A )
     => ! [X: A,Y: A,Z: A] :
          ( ( sup_sup @ A @ X @ ( inf_inf @ A @ Y @ Z ) )
          = ( inf_inf @ A @ ( sup_sup @ A @ X @ Y ) @ ( sup_sup @ A @ X @ Z ) ) ) ) ).

% sup_inf_distrib1
thf(fact_5504_inf__sup__distrib2,axiom,
    ! [A: $tType] :
      ( ( distrib_lattice @ A )
     => ! [Y: A,Z: A,X: A] :
          ( ( inf_inf @ A @ ( sup_sup @ A @ Y @ Z ) @ X )
          = ( sup_sup @ A @ ( inf_inf @ A @ Y @ X ) @ ( inf_inf @ A @ Z @ X ) ) ) ) ).

% inf_sup_distrib2
thf(fact_5505_inf__sup__distrib1,axiom,
    ! [A: $tType] :
      ( ( distrib_lattice @ A )
     => ! [X: A,Y: A,Z: A] :
          ( ( inf_inf @ A @ X @ ( sup_sup @ A @ Y @ Z ) )
          = ( sup_sup @ A @ ( inf_inf @ A @ X @ Y ) @ ( inf_inf @ A @ X @ Z ) ) ) ) ).

% inf_sup_distrib1
thf(fact_5506_distrib__imp2,axiom,
    ! [A: $tType] :
      ( ( lattice @ A )
     => ! [X: A,Y: A,Z: A] :
          ( ! [X3: A,Y5: A,Z3: A] :
              ( ( sup_sup @ A @ X3 @ ( inf_inf @ A @ Y5 @ Z3 ) )
              = ( inf_inf @ A @ ( sup_sup @ A @ X3 @ Y5 ) @ ( sup_sup @ A @ X3 @ Z3 ) ) )
         => ( ( inf_inf @ A @ X @ ( sup_sup @ A @ Y @ Z ) )
            = ( sup_sup @ A @ ( inf_inf @ A @ X @ Y ) @ ( inf_inf @ A @ X @ Z ) ) ) ) ) ).

% distrib_imp2
thf(fact_5507_distrib__imp1,axiom,
    ! [A: $tType] :
      ( ( lattice @ A )
     => ! [X: A,Y: A,Z: A] :
          ( ! [X3: A,Y5: A,Z3: A] :
              ( ( inf_inf @ A @ X3 @ ( sup_sup @ A @ Y5 @ Z3 ) )
              = ( sup_sup @ A @ ( inf_inf @ A @ X3 @ Y5 ) @ ( inf_inf @ A @ X3 @ Z3 ) ) )
         => ( ( sup_sup @ A @ X @ ( inf_inf @ A @ Y @ Z ) )
            = ( inf_inf @ A @ ( sup_sup @ A @ X @ Y ) @ ( sup_sup @ A @ X @ Z ) ) ) ) ) ).

% distrib_imp1
thf(fact_5508_infinite__UNIV__int,axiom,
    ~ ( finite_finite @ int @ ( top_top @ ( set @ int ) ) ) ).

% infinite_UNIV_int
thf(fact_5509_distrib__sup__le,axiom,
    ! [A: $tType] :
      ( ( lattice @ A )
     => ! [X: A,Y: A,Z: A] : ( ord_less_eq @ A @ ( sup_sup @ A @ X @ ( inf_inf @ A @ Y @ Z ) ) @ ( inf_inf @ A @ ( sup_sup @ A @ X @ Y ) @ ( sup_sup @ A @ X @ Z ) ) ) ) ).

% distrib_sup_le
thf(fact_5510_distrib__inf__le,axiom,
    ! [A: $tType] :
      ( ( lattice @ A )
     => ! [X: A,Y: A,Z: A] : ( ord_less_eq @ A @ ( sup_sup @ A @ ( inf_inf @ A @ X @ Y ) @ ( inf_inf @ A @ X @ Z ) ) @ ( inf_inf @ A @ X @ ( sup_sup @ A @ Y @ Z ) ) ) ) ).

% distrib_inf_le
thf(fact_5511_complete__linorder__sup__max,axiom,
    ! [A: $tType] :
      ( ( comple5582772986160207858norder @ A )
     => ( ( sup_sup @ A )
        = ( ord_max @ A ) ) ) ).

% complete_linorder_sup_max
thf(fact_5512_inf__sup__aci_I8_J,axiom,
    ! [A: $tType] :
      ( ( lattice @ A )
     => ! [X: A,Y: A] :
          ( ( sup_sup @ A @ X @ ( sup_sup @ A @ X @ Y ) )
          = ( sup_sup @ A @ X @ Y ) ) ) ).

% inf_sup_aci(8)
thf(fact_5513_inf__sup__aci_I7_J,axiom,
    ! [A: $tType] :
      ( ( lattice @ A )
     => ! [X: A,Y: A,Z: A] :
          ( ( sup_sup @ A @ X @ ( sup_sup @ A @ Y @ Z ) )
          = ( sup_sup @ A @ Y @ ( sup_sup @ A @ X @ Z ) ) ) ) ).

% inf_sup_aci(7)
thf(fact_5514_inf__sup__aci_I6_J,axiom,
    ! [A: $tType] :
      ( ( lattice @ A )
     => ! [X: A,Y: A,Z: A] :
          ( ( sup_sup @ A @ ( sup_sup @ A @ X @ Y ) @ Z )
          = ( sup_sup @ A @ X @ ( sup_sup @ A @ Y @ Z ) ) ) ) ).

% inf_sup_aci(6)
thf(fact_5515_inf__sup__aci_I5_J,axiom,
    ! [A: $tType] :
      ( ( lattice @ A )
     => ( ( sup_sup @ A )
        = ( ^ [X2: A,Y4: A] : ( sup_sup @ A @ Y4 @ X2 ) ) ) ) ).

% inf_sup_aci(5)
thf(fact_5516_sup_Oassoc,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( sup_sup @ A @ ( sup_sup @ A @ A2 @ B2 ) @ C2 )
          = ( sup_sup @ A @ A2 @ ( sup_sup @ A @ B2 @ C2 ) ) ) ) ).

% sup.assoc
thf(fact_5517_sup__assoc,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [X: A,Y: A,Z: A] :
          ( ( sup_sup @ A @ ( sup_sup @ A @ X @ Y ) @ Z )
          = ( sup_sup @ A @ X @ ( sup_sup @ A @ Y @ Z ) ) ) ) ).

% sup_assoc
thf(fact_5518_sup_Ocommute,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ( ( sup_sup @ A )
        = ( ^ [A3: A,B3: A] : ( sup_sup @ A @ B3 @ A3 ) ) ) ) ).

% sup.commute
thf(fact_5519_sup__commute,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ( ( sup_sup @ A )
        = ( ^ [X2: A,Y4: A] : ( sup_sup @ A @ Y4 @ X2 ) ) ) ) ).

% sup_commute
thf(fact_5520_sup_Oleft__commute,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( sup_sup @ A @ B2 @ ( sup_sup @ A @ A2 @ C2 ) )
          = ( sup_sup @ A @ A2 @ ( sup_sup @ A @ B2 @ C2 ) ) ) ) ).

% sup.left_commute
thf(fact_5521_sup__left__commute,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [X: A,Y: A,Z: A] :
          ( ( sup_sup @ A @ X @ ( sup_sup @ A @ Y @ Z ) )
          = ( sup_sup @ A @ Y @ ( sup_sup @ A @ X @ Z ) ) ) ) ).

% sup_left_commute
thf(fact_5522_sup__fun__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( semilattice_sup @ B )
     => ( ( sup_sup @ ( A > B ) )
        = ( ^ [F3: A > B,G2: A > B,X2: A] : ( sup_sup @ B @ ( F3 @ X2 ) @ ( G2 @ X2 ) ) ) ) ) ).

% sup_fun_def
thf(fact_5523_sup__max,axiom,
    ! [A: $tType] :
      ( ( ( semilattice_sup @ A )
        & ( linorder @ A ) )
     => ( ( sup_sup @ A )
        = ( ord_max @ A ) ) ) ).

% sup_max
thf(fact_5524_less__supI1,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [X: A,A2: A,B2: A] :
          ( ( ord_less @ A @ X @ A2 )
         => ( ord_less @ A @ X @ ( sup_sup @ A @ A2 @ B2 ) ) ) ) ).

% less_supI1
thf(fact_5525_less__supI2,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [X: A,B2: A,A2: A] :
          ( ( ord_less @ A @ X @ B2 )
         => ( ord_less @ A @ X @ ( sup_sup @ A @ A2 @ B2 ) ) ) ) ).

% less_supI2
thf(fact_5526_sup_Oabsorb3,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less @ A @ B2 @ A2 )
         => ( ( sup_sup @ A @ A2 @ B2 )
            = A2 ) ) ) ).

% sup.absorb3
thf(fact_5527_sup_Oabsorb4,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( sup_sup @ A @ A2 @ B2 )
            = B2 ) ) ) ).

% sup.absorb4
thf(fact_5528_sup_Ostrict__boundedE,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( ord_less @ A @ ( sup_sup @ A @ B2 @ C2 ) @ A2 )
         => ~ ( ( ord_less @ A @ B2 @ A2 )
             => ~ ( ord_less @ A @ C2 @ A2 ) ) ) ) ).

% sup.strict_boundedE
thf(fact_5529_sup_Ostrict__order__iff,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ( ( ord_less @ A )
        = ( ^ [B3: A,A3: A] :
              ( ( A3
                = ( sup_sup @ A @ A3 @ B3 ) )
              & ( A3 != B3 ) ) ) ) ) ).

% sup.strict_order_iff
thf(fact_5530_sup_Ostrict__coboundedI1,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less @ A @ C2 @ A2 )
         => ( ord_less @ A @ C2 @ ( sup_sup @ A @ A2 @ B2 ) ) ) ) ).

% sup.strict_coboundedI1
thf(fact_5531_sup_Ostrict__coboundedI2,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( ord_less @ A @ C2 @ B2 )
         => ( ord_less @ A @ C2 @ ( sup_sup @ A @ A2 @ B2 ) ) ) ) ).

% sup.strict_coboundedI2
thf(fact_5532_sup_OcoboundedI2,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [C2: A,B2: A,A2: A] :
          ( ( ord_less_eq @ A @ C2 @ B2 )
         => ( ord_less_eq @ A @ C2 @ ( sup_sup @ A @ A2 @ B2 ) ) ) ) ).

% sup.coboundedI2
thf(fact_5533_sup_OcoboundedI1,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [C2: A,A2: A,B2: A] :
          ( ( ord_less_eq @ A @ C2 @ A2 )
         => ( ord_less_eq @ A @ C2 @ ( sup_sup @ A @ A2 @ B2 ) ) ) ) ).

% sup.coboundedI1
thf(fact_5534_sup_Oabsorb__iff2,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [A3: A,B3: A] :
              ( ( sup_sup @ A @ A3 @ B3 )
              = B3 ) ) ) ) ).

% sup.absorb_iff2
thf(fact_5535_sup_Oabsorb__iff1,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [B3: A,A3: A] :
              ( ( sup_sup @ A @ A3 @ B3 )
              = A3 ) ) ) ) ).

% sup.absorb_iff1
thf(fact_5536_sup_Ocobounded2,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [B2: A,A2: A] : ( ord_less_eq @ A @ B2 @ ( sup_sup @ A @ A2 @ B2 ) ) ) ).

% sup.cobounded2
thf(fact_5537_sup_Ocobounded1,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A2: A,B2: A] : ( ord_less_eq @ A @ A2 @ ( sup_sup @ A @ A2 @ B2 ) ) ) ).

% sup.cobounded1
thf(fact_5538_sup_Oorder__iff,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [B3: A,A3: A] :
              ( A3
              = ( sup_sup @ A @ A3 @ B3 ) ) ) ) ) ).

% sup.order_iff
thf(fact_5539_sup_OboundedI,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [B2: A,A2: A,C2: A] :
          ( ( ord_less_eq @ A @ B2 @ A2 )
         => ( ( ord_less_eq @ A @ C2 @ A2 )
           => ( ord_less_eq @ A @ ( sup_sup @ A @ B2 @ C2 ) @ A2 ) ) ) ) ).

% sup.boundedI
thf(fact_5540_sup_OboundedE,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [B2: A,C2: A,A2: A] :
          ( ( ord_less_eq @ A @ ( sup_sup @ A @ B2 @ C2 ) @ A2 )
         => ~ ( ( ord_less_eq @ A @ B2 @ A2 )
             => ~ ( ord_less_eq @ A @ C2 @ A2 ) ) ) ) ).

% sup.boundedE
thf(fact_5541_sup__absorb2,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ A @ X @ Y )
         => ( ( sup_sup @ A @ X @ Y )
            = Y ) ) ) ).

% sup_absorb2
thf(fact_5542_sup__absorb1,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [Y: A,X: A] :
          ( ( ord_less_eq @ A @ Y @ X )
         => ( ( sup_sup @ A @ X @ Y )
            = X ) ) ) ).

% sup_absorb1
thf(fact_5543_sup_Oabsorb2,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( sup_sup @ A @ A2 @ B2 )
            = B2 ) ) ) ).

% sup.absorb2
thf(fact_5544_sup_Oabsorb1,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less_eq @ A @ B2 @ A2 )
         => ( ( sup_sup @ A @ A2 @ B2 )
            = A2 ) ) ) ).

% sup.absorb1
thf(fact_5545_sup__unique,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [F2: A > A > A,X: A,Y: A] :
          ( ! [X3: A,Y5: A] : ( ord_less_eq @ A @ X3 @ ( F2 @ X3 @ Y5 ) )
         => ( ! [X3: A,Y5: A] : ( ord_less_eq @ A @ Y5 @ ( F2 @ X3 @ Y5 ) )
           => ( ! [X3: A,Y5: A,Z3: A] :
                  ( ( ord_less_eq @ A @ Y5 @ X3 )
                 => ( ( ord_less_eq @ A @ Z3 @ X3 )
                   => ( ord_less_eq @ A @ ( F2 @ Y5 @ Z3 ) @ X3 ) ) )
             => ( ( sup_sup @ A @ X @ Y )
                = ( F2 @ X @ Y ) ) ) ) ) ) ).

% sup_unique
thf(fact_5546_sup_OorderI,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A2: A,B2: A] :
          ( ( A2
            = ( sup_sup @ A @ A2 @ B2 ) )
         => ( ord_less_eq @ A @ B2 @ A2 ) ) ) ).

% sup.orderI
thf(fact_5547_sup_OorderE,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [B2: A,A2: A] :
          ( ( ord_less_eq @ A @ B2 @ A2 )
         => ( A2
            = ( sup_sup @ A @ A2 @ B2 ) ) ) ) ).

% sup.orderE
thf(fact_5548_le__iff__sup,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ( ( ord_less_eq @ A )
        = ( ^ [X2: A,Y4: A] :
              ( ( sup_sup @ A @ X2 @ Y4 )
              = Y4 ) ) ) ) ).

% le_iff_sup
thf(fact_5549_sup__least,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [Y: A,X: A,Z: A] :
          ( ( ord_less_eq @ A @ Y @ X )
         => ( ( ord_less_eq @ A @ Z @ X )
           => ( ord_less_eq @ A @ ( sup_sup @ A @ Y @ Z ) @ X ) ) ) ) ).

% sup_least
thf(fact_5550_sup__mono,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A2: A,C2: A,B2: A,D2: A] :
          ( ( ord_less_eq @ A @ A2 @ C2 )
         => ( ( ord_less_eq @ A @ B2 @ D2 )
           => ( ord_less_eq @ A @ ( sup_sup @ A @ A2 @ B2 ) @ ( sup_sup @ A @ C2 @ D2 ) ) ) ) ) ).

% sup_mono
thf(fact_5551_sup_Omono,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [C2: A,A2: A,D2: A,B2: A] :
          ( ( ord_less_eq @ A @ C2 @ A2 )
         => ( ( ord_less_eq @ A @ D2 @ B2 )
           => ( ord_less_eq @ A @ ( sup_sup @ A @ C2 @ D2 ) @ ( sup_sup @ A @ A2 @ B2 ) ) ) ) ) ).

% sup.mono
thf(fact_5552_le__supI2,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [X: A,B2: A,A2: A] :
          ( ( ord_less_eq @ A @ X @ B2 )
         => ( ord_less_eq @ A @ X @ ( sup_sup @ A @ A2 @ B2 ) ) ) ) ).

% le_supI2
thf(fact_5553_le__supI1,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [X: A,A2: A,B2: A] :
          ( ( ord_less_eq @ A @ X @ A2 )
         => ( ord_less_eq @ A @ X @ ( sup_sup @ A @ A2 @ B2 ) ) ) ) ).

% le_supI1
thf(fact_5554_sup__ge2,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [Y: A,X: A] : ( ord_less_eq @ A @ Y @ ( sup_sup @ A @ X @ Y ) ) ) ).

% sup_ge2
thf(fact_5555_sup__ge1,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [X: A,Y: A] : ( ord_less_eq @ A @ X @ ( sup_sup @ A @ X @ Y ) ) ) ).

% sup_ge1
thf(fact_5556_le__supI,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A2: A,X: A,B2: A] :
          ( ( ord_less_eq @ A @ A2 @ X )
         => ( ( ord_less_eq @ A @ B2 @ X )
           => ( ord_less_eq @ A @ ( sup_sup @ A @ A2 @ B2 ) @ X ) ) ) ) ).

% le_supI
thf(fact_5557_le__supE,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A2: A,B2: A,X: A] :
          ( ( ord_less_eq @ A @ ( sup_sup @ A @ A2 @ B2 ) @ X )
         => ~ ( ( ord_less_eq @ A @ A2 @ X )
             => ~ ( ord_less_eq @ A @ B2 @ X ) ) ) ) ).

% le_supE
thf(fact_5558_inf__sup__ord_I3_J,axiom,
    ! [A: $tType] :
      ( ( lattice @ A )
     => ! [X: A,Y: A] : ( ord_less_eq @ A @ X @ ( sup_sup @ A @ X @ Y ) ) ) ).

% inf_sup_ord(3)
thf(fact_5559_inf__sup__ord_I4_J,axiom,
    ! [A: $tType] :
      ( ( lattice @ A )
     => ! [Y: A,X: A] : ( ord_less_eq @ A @ Y @ ( sup_sup @ A @ X @ Y ) ) ) ).

% inf_sup_ord(4)
thf(fact_5560_ivl__disj__un__two__touch_I4_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L: A,M: A,U: A] :
          ( ( ord_less_eq @ A @ L @ M )
         => ( ( ord_less_eq @ A @ M @ U )
           => ( ( sup_sup @ ( set @ A ) @ ( set_or1337092689740270186AtMost @ A @ L @ M ) @ ( set_or1337092689740270186AtMost @ A @ M @ U ) )
              = ( set_or1337092689740270186AtMost @ A @ L @ U ) ) ) ) ) ).

% ivl_disj_un_two_touch(4)
thf(fact_5561_ivl__disj__un__two_I3_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L: A,M: A,U: A] :
          ( ( ord_less_eq @ A @ L @ M )
         => ( ( ord_less_eq @ A @ M @ U )
           => ( ( sup_sup @ ( set @ A ) @ ( set_or7035219750837199246ssThan @ A @ L @ M ) @ ( set_or7035219750837199246ssThan @ A @ M @ U ) )
              = ( set_or7035219750837199246ssThan @ A @ L @ U ) ) ) ) ) ).

% ivl_disj_un_two(3)
thf(fact_5562_sup__shunt,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [X: A,Y: A] :
          ( ( ( sup_sup @ A @ X @ Y )
            = ( top_top @ A ) )
          = ( ord_less_eq @ A @ ( uminus_uminus @ A @ X ) @ Y ) ) ) ).

% sup_shunt
thf(fact_5563_sup__neg__inf,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [P6: A,Q3: A,R2: A] :
          ( ( ord_less_eq @ A @ P6 @ ( sup_sup @ A @ Q3 @ R2 ) )
          = ( ord_less_eq @ A @ ( inf_inf @ A @ P6 @ ( uminus_uminus @ A @ Q3 ) ) @ R2 ) ) ) ).

% sup_neg_inf
thf(fact_5564_shunt2,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [X: A,Y: A,Z: A] :
          ( ( ord_less_eq @ A @ ( inf_inf @ A @ X @ ( uminus_uminus @ A @ Y ) ) @ Z )
          = ( ord_less_eq @ A @ X @ ( sup_sup @ A @ Y @ Z ) ) ) ) ).

% shunt2
thf(fact_5565_shunt1,axiom,
    ! [A: $tType] :
      ( ( boolea8198339166811842893lgebra @ A )
     => ! [X: A,Y: A,Z: A] :
          ( ( ord_less_eq @ A @ ( inf_inf @ A @ X @ Y ) @ Z )
          = ( ord_less_eq @ A @ X @ ( sup_sup @ A @ ( uminus_uminus @ A @ Y ) @ Z ) ) ) ) ).

% shunt1
thf(fact_5566_less__eq__Inf__inter,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A4: set @ A,B7: set @ A] : ( ord_less_eq @ A @ ( sup_sup @ A @ ( complete_Inf_Inf @ A @ A4 ) @ ( complete_Inf_Inf @ A @ B7 ) ) @ ( complete_Inf_Inf @ A @ ( inf_inf @ ( set @ A ) @ A4 @ B7 ) ) ) ) ).

% less_eq_Inf_inter
thf(fact_5567_ivl__disj__un__two_I7_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L: A,M: A,U: A] :
          ( ( ord_less_eq @ A @ L @ M )
         => ( ( ord_less_eq @ A @ M @ U )
           => ( ( sup_sup @ ( set @ A ) @ ( set_or7035219750837199246ssThan @ A @ L @ M ) @ ( set_or1337092689740270186AtMost @ A @ M @ U ) )
              = ( set_or1337092689740270186AtMost @ A @ L @ U ) ) ) ) ) ).

% ivl_disj_un_two(7)
thf(fact_5568_ivl__disj__un__one_I2_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L: A,U: A] :
          ( ( ord_less_eq @ A @ L @ U )
         => ( ( sup_sup @ ( set @ A ) @ ( set_ord_lessThan @ A @ L ) @ ( set_or7035219750837199246ssThan @ A @ L @ U ) )
            = ( set_ord_lessThan @ A @ U ) ) ) ) ).

% ivl_disj_un_one(2)
thf(fact_5569_card__Un__le,axiom,
    ! [A: $tType,A4: set @ A,B7: set @ A] : ( ord_less_eq @ nat @ ( finite_card @ A @ ( sup_sup @ ( set @ A ) @ A4 @ B7 ) ) @ ( plus_plus @ nat @ ( finite_card @ A @ A4 ) @ ( finite_card @ A @ B7 ) ) ) ).

% card_Un_le
thf(fact_5570_atLeastLessThan__add__Un,axiom,
    ! [I: nat,J: nat,K: nat] :
      ( ( ord_less_eq @ nat @ I @ J )
     => ( ( set_or7035219750837199246ssThan @ nat @ I @ ( plus_plus @ nat @ J @ K ) )
        = ( sup_sup @ ( set @ nat ) @ ( set_or7035219750837199246ssThan @ nat @ I @ J ) @ ( set_or7035219750837199246ssThan @ nat @ J @ ( plus_plus @ nat @ J @ K ) ) ) ) ) ).

% atLeastLessThan_add_Un
thf(fact_5571_Ints__def,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ( ( ring_1_Ints @ A )
        = ( image @ int @ A @ ( ring_1_of_int @ A ) @ ( top_top @ ( set @ int ) ) ) ) ) ).

% Ints_def
thf(fact_5572_int__in__range__abs,axiom,
    ! [N: nat] : ( member @ int @ ( semiring_1_of_nat @ int @ N ) @ ( image @ int @ int @ ( abs_abs @ int ) @ ( top_top @ ( set @ int ) ) ) ) ).

% int_in_range_abs
thf(fact_5573_ivl__disj__un__two__touch_I2_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L: A,M: A,U: A] :
          ( ( ord_less_eq @ A @ L @ M )
         => ( ( ord_less @ A @ M @ U )
           => ( ( sup_sup @ ( set @ A ) @ ( set_or1337092689740270186AtMost @ A @ L @ M ) @ ( set_or7035219750837199246ssThan @ A @ M @ U ) )
              = ( set_or7035219750837199246ssThan @ A @ L @ U ) ) ) ) ) ).

% ivl_disj_un_two_touch(2)
thf(fact_5574_ivl__disj__un__one_I4_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L: A,U: A] :
          ( ( ord_less_eq @ A @ L @ U )
         => ( ( sup_sup @ ( set @ A ) @ ( set_ord_lessThan @ A @ L ) @ ( set_or1337092689740270186AtMost @ A @ L @ U ) )
            = ( set_ord_atMost @ A @ U ) ) ) ) ).

% ivl_disj_un_one(4)
thf(fact_5575_Max_Ounion,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A4: set @ A,B7: set @ A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( A4
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( finite_finite @ A @ B7 )
             => ( ( B7
                 != ( bot_bot @ ( set @ A ) ) )
               => ( ( lattic643756798349783984er_Max @ A @ ( sup_sup @ ( set @ A ) @ A4 @ B7 ) )
                  = ( ord_max @ A @ ( lattic643756798349783984er_Max @ A @ A4 ) @ ( lattic643756798349783984er_Max @ A @ B7 ) ) ) ) ) ) ) ) ).

% Max.union
thf(fact_5576_Min_Ounion,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A4: set @ A,B7: set @ A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( A4
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( finite_finite @ A @ B7 )
             => ( ( B7
                 != ( bot_bot @ ( set @ A ) ) )
               => ( ( lattic643756798350308766er_Min @ A @ ( sup_sup @ ( set @ A ) @ A4 @ B7 ) )
                  = ( ord_min @ A @ ( lattic643756798350308766er_Min @ A @ A4 ) @ ( lattic643756798350308766er_Min @ A @ B7 ) ) ) ) ) ) ) ) ).

% Min.union
thf(fact_5577_SUP__nat__binary,axiom,
    ! [A: $tType] :
      ( ( counta3822494911875563373attice @ A )
     => ! [A4: A,B7: A] :
          ( ( sup_sup @ A @ A4
            @ ( complete_Sup_Sup @ A
              @ ( image @ nat @ A
                @ ^ [X2: nat] : B7
                @ ( collect @ nat @ ( ord_less @ nat @ ( zero_zero @ nat ) ) ) ) ) )
          = ( sup_sup @ A @ A4 @ B7 ) ) ) ).

% SUP_nat_binary
thf(fact_5578_sup__bot_Osemilattice__neutr__order__axioms,axiom,
    ! [A: $tType] :
      ( ( bounde4967611905675639751up_bot @ A )
     => ( semila1105856199041335345_order @ A @ ( sup_sup @ A ) @ ( bot_bot @ A )
        @ ^ [X2: A,Y4: A] : ( ord_less_eq @ A @ Y4 @ X2 )
        @ ^ [X2: A,Y4: A] : ( ord_less @ A @ Y4 @ X2 ) ) ) ).

% sup_bot.semilattice_neutr_order_axioms
thf(fact_5579_sum_Ounion__inter__neutral,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [A4: set @ B,B7: set @ B,G: B > A] :
          ( ( finite_finite @ B @ A4 )
         => ( ( finite_finite @ B @ B7 )
           => ( ! [X3: B] :
                  ( ( member @ B @ X3 @ ( inf_inf @ ( set @ B ) @ A4 @ B7 ) )
                 => ( ( G @ X3 )
                    = ( zero_zero @ A ) ) )
             => ( ( groups7311177749621191930dd_sum @ B @ A @ G @ ( sup_sup @ ( set @ B ) @ A4 @ B7 ) )
                = ( plus_plus @ A @ ( groups7311177749621191930dd_sum @ B @ A @ G @ A4 ) @ ( groups7311177749621191930dd_sum @ B @ A @ G @ B7 ) ) ) ) ) ) ) ).

% sum.union_inter_neutral
thf(fact_5580_ivl__disj__un__singleton_I6_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L: A,U: A] :
          ( ( ord_less_eq @ A @ L @ U )
         => ( ( sup_sup @ ( set @ A ) @ ( set_or7035219750837199246ssThan @ A @ L @ U ) @ ( insert @ A @ U @ ( bot_bot @ ( set @ A ) ) ) )
            = ( set_or1337092689740270186AtMost @ A @ L @ U ) ) ) ) ).

% ivl_disj_un_singleton(6)
thf(fact_5581_prod__Un,axiom,
    ! [A: $tType,B: $tType] :
      ( ( field @ A )
     => ! [A4: set @ B,B7: set @ B,F2: B > A] :
          ( ( finite_finite @ B @ A4 )
         => ( ( finite_finite @ B @ B7 )
           => ( ! [X3: B] :
                  ( ( member @ B @ X3 @ ( inf_inf @ ( set @ B ) @ A4 @ B7 ) )
                 => ( ( F2 @ X3 )
                   != ( zero_zero @ A ) ) )
             => ( ( groups7121269368397514597t_prod @ B @ A @ F2 @ ( sup_sup @ ( set @ B ) @ A4 @ B7 ) )
                = ( divide_divide @ A @ ( times_times @ A @ ( groups7121269368397514597t_prod @ B @ A @ F2 @ A4 ) @ ( groups7121269368397514597t_prod @ B @ A @ F2 @ B7 ) ) @ ( groups7121269368397514597t_prod @ B @ A @ F2 @ ( inf_inf @ ( set @ B ) @ A4 @ B7 ) ) ) ) ) ) ) ) ).

% prod_Un
thf(fact_5582_root__def,axiom,
    ( root
    = ( ^ [N3: nat,X2: real] :
          ( if @ real
          @ ( N3
            = ( zero_zero @ nat ) )
          @ ( zero_zero @ real )
          @ ( the_inv_into @ real @ real @ ( top_top @ ( set @ real ) )
            @ ^ [Y4: real] : ( times_times @ real @ ( sgn_sgn @ real @ Y4 ) @ ( power_power @ real @ ( abs_abs @ real @ Y4 ) @ N3 ) )
            @ X2 ) ) ) ) ).

% root_def
thf(fact_5583_card__UNIV__char,axiom,
    ( ( finite_card @ char @ ( top_top @ ( set @ char ) ) )
    = ( numeral_numeral @ nat @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ).

% card_UNIV_char
thf(fact_5584_DERIV__real__root__generic,axiom,
    ! [N: nat,X: real,D5: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( X
         != ( zero_zero @ real ) )
       => ( ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
           => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
             => ( D5
                = ( inverse_inverse @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N ) @ ( power_power @ real @ ( root @ N @ X ) @ ( minus_minus @ nat @ N @ ( suc @ ( zero_zero @ nat ) ) ) ) ) ) ) ) )
         => ( ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
             => ( ( ord_less @ real @ X @ ( zero_zero @ real ) )
               => ( D5
                  = ( uminus_uminus @ real @ ( inverse_inverse @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N ) @ ( power_power @ real @ ( root @ N @ X ) @ ( minus_minus @ nat @ N @ ( suc @ ( zero_zero @ nat ) ) ) ) ) ) ) ) ) )
           => ( ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
               => ( D5
                  = ( inverse_inverse @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N ) @ ( power_power @ real @ ( root @ N @ X ) @ ( minus_minus @ nat @ N @ ( suc @ ( zero_zero @ nat ) ) ) ) ) ) ) )
             => ( has_field_derivative @ real @ ( root @ N ) @ D5 @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) ) ) ) ) ) ) ).

% DERIV_real_root_generic
thf(fact_5585_MVT2,axiom,
    ! [A2: real,B2: real,F2: real > real,F5: real > real] :
      ( ( ord_less @ real @ A2 @ B2 )
     => ( ! [X3: real] :
            ( ( ord_less_eq @ real @ A2 @ X3 )
           => ( ( ord_less_eq @ real @ X3 @ B2 )
             => ( has_field_derivative @ real @ F2 @ ( F5 @ X3 ) @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) ) ) )
       => ? [Z3: real] :
            ( ( ord_less @ real @ A2 @ Z3 )
            & ( ord_less @ real @ Z3 @ B2 )
            & ( ( minus_minus @ real @ ( F2 @ B2 ) @ ( F2 @ A2 ) )
              = ( times_times @ real @ ( minus_minus @ real @ B2 @ A2 ) @ ( F5 @ Z3 ) ) ) ) ) ) ).

% MVT2
thf(fact_5586_deriv__nonneg__imp__mono,axiom,
    ! [A2: real,B2: real,G: real > real,G4: real > real] :
      ( ! [X3: real] :
          ( ( member @ real @ X3 @ ( set_or1337092689740270186AtMost @ real @ A2 @ B2 ) )
         => ( has_field_derivative @ real @ G @ ( G4 @ X3 ) @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) ) )
     => ( ! [X3: real] :
            ( ( member @ real @ X3 @ ( set_or1337092689740270186AtMost @ real @ A2 @ B2 ) )
           => ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( G4 @ X3 ) ) )
       => ( ( ord_less_eq @ real @ A2 @ B2 )
         => ( ord_less_eq @ real @ ( G @ A2 ) @ ( G @ B2 ) ) ) ) ) ).

% deriv_nonneg_imp_mono
thf(fact_5587_DERIV__neg__imp__decreasing,axiom,
    ! [A2: real,B2: real,F2: real > real] :
      ( ( ord_less @ real @ A2 @ B2 )
     => ( ! [X3: real] :
            ( ( ord_less_eq @ real @ A2 @ X3 )
           => ( ( ord_less_eq @ real @ X3 @ B2 )
             => ? [Y6: real] :
                  ( ( has_field_derivative @ real @ F2 @ Y6 @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) )
                  & ( ord_less @ real @ Y6 @ ( zero_zero @ real ) ) ) ) )
       => ( ord_less @ real @ ( F2 @ B2 ) @ ( F2 @ A2 ) ) ) ) ).

% DERIV_neg_imp_decreasing
thf(fact_5588_DERIV__pos__imp__increasing,axiom,
    ! [A2: real,B2: real,F2: real > real] :
      ( ( ord_less @ real @ A2 @ B2 )
     => ( ! [X3: real] :
            ( ( ord_less_eq @ real @ A2 @ X3 )
           => ( ( ord_less_eq @ real @ X3 @ B2 )
             => ? [Y6: real] :
                  ( ( has_field_derivative @ real @ F2 @ Y6 @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) )
                  & ( ord_less @ real @ ( zero_zero @ real ) @ Y6 ) ) ) )
       => ( ord_less @ real @ ( F2 @ A2 ) @ ( F2 @ B2 ) ) ) ) ).

% DERIV_pos_imp_increasing
thf(fact_5589_DERIV__nonpos__imp__nonincreasing,axiom,
    ! [A2: real,B2: real,F2: real > real] :
      ( ( ord_less_eq @ real @ A2 @ B2 )
     => ( ! [X3: real] :
            ( ( ord_less_eq @ real @ A2 @ X3 )
           => ( ( ord_less_eq @ real @ X3 @ B2 )
             => ? [Y6: real] :
                  ( ( has_field_derivative @ real @ F2 @ Y6 @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) )
                  & ( ord_less_eq @ real @ Y6 @ ( zero_zero @ real ) ) ) ) )
       => ( ord_less_eq @ real @ ( F2 @ B2 ) @ ( F2 @ A2 ) ) ) ) ).

% DERIV_nonpos_imp_nonincreasing
thf(fact_5590_DERIV__nonneg__imp__nondecreasing,axiom,
    ! [A2: real,B2: real,F2: real > real] :
      ( ( ord_less_eq @ real @ A2 @ B2 )
     => ( ! [X3: real] :
            ( ( ord_less_eq @ real @ A2 @ X3 )
           => ( ( ord_less_eq @ real @ X3 @ B2 )
             => ? [Y6: real] :
                  ( ( has_field_derivative @ real @ F2 @ Y6 @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) )
                  & ( ord_less_eq @ real @ ( zero_zero @ real ) @ Y6 ) ) ) )
       => ( ord_less_eq @ real @ ( F2 @ A2 ) @ ( F2 @ B2 ) ) ) ) ).

% DERIV_nonneg_imp_nondecreasing
thf(fact_5591_DERIV__ln,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( has_field_derivative @ real @ ( ln_ln @ real ) @ ( inverse_inverse @ real @ X ) @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) ) ) ).

% DERIV_ln
thf(fact_5592_DERIV__pos__inc__left,axiom,
    ! [F2: real > real,L: real,X: real] :
      ( ( has_field_derivative @ real @ F2 @ L @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ L )
       => ? [D6: real] :
            ( ( ord_less @ real @ ( zero_zero @ real ) @ D6 )
            & ! [H5: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ H5 )
               => ( ( ord_less @ real @ H5 @ D6 )
                 => ( ord_less @ real @ ( F2 @ ( minus_minus @ real @ X @ H5 ) ) @ ( F2 @ X ) ) ) ) ) ) ) ).

% DERIV_pos_inc_left
thf(fact_5593_DERIV__neg__dec__left,axiom,
    ! [F2: real > real,L: real,X: real] :
      ( ( has_field_derivative @ real @ F2 @ L @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) )
     => ( ( ord_less @ real @ L @ ( zero_zero @ real ) )
       => ? [D6: real] :
            ( ( ord_less @ real @ ( zero_zero @ real ) @ D6 )
            & ! [H5: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ H5 )
               => ( ( ord_less @ real @ H5 @ D6 )
                 => ( ord_less @ real @ ( F2 @ X ) @ ( F2 @ ( minus_minus @ real @ X @ H5 ) ) ) ) ) ) ) ) ).

% DERIV_neg_dec_left
thf(fact_5594_DERIV__isconst__all,axiom,
    ! [F2: real > real,X: real,Y: real] :
      ( ! [X3: real] : ( has_field_derivative @ real @ F2 @ ( zero_zero @ real ) @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) )
     => ( ( F2 @ X )
        = ( F2 @ Y ) ) ) ).

% DERIV_isconst_all
thf(fact_5595_DERIV__local__const,axiom,
    ! [F2: real > real,L: real,X: real,D2: real] :
      ( ( has_field_derivative @ real @ F2 @ L @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ D2 )
       => ( ! [Y5: real] :
              ( ( ord_less @ real @ ( abs_abs @ real @ ( minus_minus @ real @ X @ Y5 ) ) @ D2 )
             => ( ( F2 @ X )
                = ( F2 @ Y5 ) ) )
         => ( L
            = ( zero_zero @ real ) ) ) ) ) ).

% DERIV_local_const
thf(fact_5596_DERIV__pos__inc__right,axiom,
    ! [F2: real > real,L: real,X: real] :
      ( ( has_field_derivative @ real @ F2 @ L @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ L )
       => ? [D6: real] :
            ( ( ord_less @ real @ ( zero_zero @ real ) @ D6 )
            & ! [H5: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ H5 )
               => ( ( ord_less @ real @ H5 @ D6 )
                 => ( ord_less @ real @ ( F2 @ X ) @ ( F2 @ ( plus_plus @ real @ X @ H5 ) ) ) ) ) ) ) ) ).

% DERIV_pos_inc_right
thf(fact_5597_DERIV__neg__dec__right,axiom,
    ! [F2: real > real,L: real,X: real] :
      ( ( has_field_derivative @ real @ F2 @ L @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) )
     => ( ( ord_less @ real @ L @ ( zero_zero @ real ) )
       => ? [D6: real] :
            ( ( ord_less @ real @ ( zero_zero @ real ) @ D6 )
            & ! [H5: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ H5 )
               => ( ( ord_less @ real @ H5 @ D6 )
                 => ( ord_less @ real @ ( F2 @ ( plus_plus @ real @ X @ H5 ) ) @ ( F2 @ X ) ) ) ) ) ) ) ).

% DERIV_neg_dec_right
thf(fact_5598_sup__enat__def,axiom,
    ( ( sup_sup @ extended_enat )
    = ( ord_max @ extended_enat ) ) ).

% sup_enat_def
thf(fact_5599_sup__nat__def,axiom,
    ( ( sup_sup @ nat )
    = ( ord_max @ nat ) ) ).

% sup_nat_def
thf(fact_5600_sup__int__def,axiom,
    ( ( sup_sup @ int )
    = ( ord_max @ int ) ) ).

% sup_int_def
thf(fact_5601_DERIV__const,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [K: A,F4: filter @ A] :
          ( has_field_derivative @ A
          @ ^ [X2: A] : K
          @ ( zero_zero @ A )
          @ F4 ) ) ).

% DERIV_const
thf(fact_5602_has__real__derivative__pos__inc__left,axiom,
    ! [F2: real > real,L: real,X: real,S: set @ real] :
      ( ( has_field_derivative @ real @ F2 @ L @ ( topolo174197925503356063within @ real @ X @ S ) )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ L )
       => ? [D6: real] :
            ( ( ord_less @ real @ ( zero_zero @ real ) @ D6 )
            & ! [H5: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ H5 )
               => ( ( member @ real @ ( minus_minus @ real @ X @ H5 ) @ S )
                 => ( ( ord_less @ real @ H5 @ D6 )
                   => ( ord_less @ real @ ( F2 @ ( minus_minus @ real @ X @ H5 ) ) @ ( F2 @ X ) ) ) ) ) ) ) ) ).

% has_real_derivative_pos_inc_left
thf(fact_5603_has__real__derivative__neg__dec__left,axiom,
    ! [F2: real > real,L: real,X: real,S: set @ real] :
      ( ( has_field_derivative @ real @ F2 @ L @ ( topolo174197925503356063within @ real @ X @ S ) )
     => ( ( ord_less @ real @ L @ ( zero_zero @ real ) )
       => ? [D6: real] :
            ( ( ord_less @ real @ ( zero_zero @ real ) @ D6 )
            & ! [H5: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ H5 )
               => ( ( member @ real @ ( minus_minus @ real @ X @ H5 ) @ S )
                 => ( ( ord_less @ real @ H5 @ D6 )
                   => ( ord_less @ real @ ( F2 @ X ) @ ( F2 @ ( minus_minus @ real @ X @ H5 ) ) ) ) ) ) ) ) ) ).

% has_real_derivative_neg_dec_left
thf(fact_5604_has__real__derivative__neg__dec__right,axiom,
    ! [F2: real > real,L: real,X: real,S: set @ real] :
      ( ( has_field_derivative @ real @ F2 @ L @ ( topolo174197925503356063within @ real @ X @ S ) )
     => ( ( ord_less @ real @ L @ ( zero_zero @ real ) )
       => ? [D6: real] :
            ( ( ord_less @ real @ ( zero_zero @ real ) @ D6 )
            & ! [H5: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ H5 )
               => ( ( member @ real @ ( plus_plus @ real @ X @ H5 ) @ S )
                 => ( ( ord_less @ real @ H5 @ D6 )
                   => ( ord_less @ real @ ( F2 @ ( plus_plus @ real @ X @ H5 ) ) @ ( F2 @ X ) ) ) ) ) ) ) ) ).

% has_real_derivative_neg_dec_right
thf(fact_5605_has__real__derivative__pos__inc__right,axiom,
    ! [F2: real > real,L: real,X: real,S: set @ real] :
      ( ( has_field_derivative @ real @ F2 @ L @ ( topolo174197925503356063within @ real @ X @ S ) )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ L )
       => ? [D6: real] :
            ( ( ord_less @ real @ ( zero_zero @ real ) @ D6 )
            & ! [H5: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ H5 )
               => ( ( member @ real @ ( plus_plus @ real @ X @ H5 ) @ S )
                 => ( ( ord_less @ real @ H5 @ D6 )
                   => ( ord_less @ real @ ( F2 @ X ) @ ( F2 @ ( plus_plus @ real @ X @ H5 ) ) ) ) ) ) ) ) ) ).

% has_real_derivative_pos_inc_right
thf(fact_5606_DERIV__divide,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,D5: A,X: A,S2: set @ A,G: A > A,E5: A] :
          ( ( has_field_derivative @ A @ F2 @ D5 @ ( topolo174197925503356063within @ A @ X @ S2 ) )
         => ( ( has_field_derivative @ A @ G @ E5 @ ( topolo174197925503356063within @ A @ X @ S2 ) )
           => ( ( ( G @ X )
               != ( zero_zero @ A ) )
             => ( has_field_derivative @ A
                @ ^ [X2: A] : ( divide_divide @ A @ ( F2 @ X2 ) @ ( G @ X2 ) )
                @ ( divide_divide @ A @ ( minus_minus @ A @ ( times_times @ A @ D5 @ ( G @ X ) ) @ ( times_times @ A @ ( F2 @ X ) @ E5 ) ) @ ( times_times @ A @ ( G @ X ) @ ( G @ X ) ) )
                @ ( topolo174197925503356063within @ A @ X @ S2 ) ) ) ) ) ) ).

% DERIV_divide
thf(fact_5607_DERIV__inverse_H,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,D5: A,X: A,S2: set @ A] :
          ( ( has_field_derivative @ A @ F2 @ D5 @ ( topolo174197925503356063within @ A @ X @ S2 ) )
         => ( ( ( F2 @ X )
             != ( zero_zero @ A ) )
           => ( has_field_derivative @ A
              @ ^ [X2: A] : ( inverse_inverse @ A @ ( F2 @ X2 ) )
              @ ( uminus_uminus @ A @ ( times_times @ A @ ( times_times @ A @ ( inverse_inverse @ A @ ( F2 @ X ) ) @ D5 ) @ ( inverse_inverse @ A @ ( F2 @ X ) ) ) )
              @ ( topolo174197925503356063within @ A @ X @ S2 ) ) ) ) ) ).

% DERIV_inverse'
thf(fact_5608_DERIV__const__average,axiom,
    ! [A2: real,B2: real,V: real > real,K: real] :
      ( ( A2 != B2 )
     => ( ! [X3: real] : ( has_field_derivative @ real @ V @ K @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) )
       => ( ( V @ ( divide_divide @ real @ ( plus_plus @ real @ A2 @ B2 ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
          = ( divide_divide @ real @ ( plus_plus @ real @ ( V @ A2 ) @ ( V @ B2 ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ).

% DERIV_const_average
thf(fact_5609_DERIV__local__min,axiom,
    ! [F2: real > real,L: real,X: real,D2: real] :
      ( ( has_field_derivative @ real @ F2 @ L @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ D2 )
       => ( ! [Y5: real] :
              ( ( ord_less @ real @ ( abs_abs @ real @ ( minus_minus @ real @ X @ Y5 ) ) @ D2 )
             => ( ord_less_eq @ real @ ( F2 @ X ) @ ( F2 @ Y5 ) ) )
         => ( L
            = ( zero_zero @ real ) ) ) ) ) ).

% DERIV_local_min
thf(fact_5610_DERIV__local__max,axiom,
    ! [F2: real > real,L: real,X: real,D2: real] :
      ( ( has_field_derivative @ real @ F2 @ L @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ D2 )
       => ( ! [Y5: real] :
              ( ( ord_less @ real @ ( abs_abs @ real @ ( minus_minus @ real @ X @ Y5 ) ) @ D2 )
             => ( ord_less_eq @ real @ ( F2 @ Y5 ) @ ( F2 @ X ) ) )
         => ( L
            = ( zero_zero @ real ) ) ) ) ) ).

% DERIV_local_max
thf(fact_5611_DERIV__ln__divide,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( has_field_derivative @ real @ ( ln_ln @ real ) @ ( divide_divide @ real @ ( one_one @ real ) @ X ) @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) ) ) ).

% DERIV_ln_divide
thf(fact_5612_DERIV__fun__pow,axiom,
    ! [G: real > real,M: real,X: real,N: nat] :
      ( ( has_field_derivative @ real @ G @ M @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) )
     => ( has_field_derivative @ real
        @ ^ [X2: real] : ( power_power @ real @ ( G @ X2 ) @ N )
        @ ( times_times @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N ) @ ( power_power @ real @ ( G @ X ) @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) ) ) @ M )
        @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) ) ) ).

% DERIV_fun_pow
thf(fact_5613_DERIV__power__Suc,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,D5: A,X: A,S2: set @ A,N: nat] :
          ( ( has_field_derivative @ A @ F2 @ D5 @ ( topolo174197925503356063within @ A @ X @ S2 ) )
         => ( has_field_derivative @ A
            @ ^ [X2: A] : ( power_power @ A @ ( F2 @ X2 ) @ ( suc @ N ) )
            @ ( times_times @ A @ ( plus_plus @ A @ ( one_one @ A ) @ ( semiring_1_of_nat @ A @ N ) ) @ ( times_times @ A @ D5 @ ( power_power @ A @ ( F2 @ X ) @ N ) ) )
            @ ( topolo174197925503356063within @ A @ X @ S2 ) ) ) ) ).

% DERIV_power_Suc
thf(fact_5614_DERIV__inverse,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [X: A,S2: set @ A] :
          ( ( X
           != ( zero_zero @ A ) )
         => ( has_field_derivative @ A @ ( inverse_inverse @ A ) @ ( uminus_uminus @ A @ ( power_power @ A @ ( inverse_inverse @ A @ X ) @ ( suc @ ( suc @ ( zero_zero @ nat ) ) ) ) ) @ ( topolo174197925503356063within @ A @ X @ S2 ) ) ) ) ).

% DERIV_inverse
thf(fact_5615_DERIV__power,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,D5: A,X: A,S2: set @ A,N: nat] :
          ( ( has_field_derivative @ A @ F2 @ D5 @ ( topolo174197925503356063within @ A @ X @ S2 ) )
         => ( has_field_derivative @ A
            @ ^ [X2: A] : ( power_power @ A @ ( F2 @ X2 ) @ N )
            @ ( times_times @ A @ ( semiring_1_of_nat @ A @ N ) @ ( times_times @ A @ D5 @ ( power_power @ A @ ( F2 @ X ) @ ( minus_minus @ nat @ N @ ( suc @ ( zero_zero @ nat ) ) ) ) ) )
            @ ( topolo174197925503356063within @ A @ X @ S2 ) ) ) ) ).

% DERIV_power
thf(fact_5616_DERIV__pow,axiom,
    ! [N: nat,X: real,S2: set @ real] :
      ( has_field_derivative @ real
      @ ^ [X2: real] : ( power_power @ real @ X2 @ N )
      @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N ) @ ( power_power @ real @ X @ ( minus_minus @ nat @ N @ ( suc @ ( zero_zero @ nat ) ) ) ) )
      @ ( topolo174197925503356063within @ real @ X @ S2 ) ) ).

% DERIV_pow
thf(fact_5617_termdiffs__strong__converges__everywhere,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [C2: nat > A,X: A] :
          ( ! [Y5: A] :
              ( summable @ A
              @ ^ [N3: nat] : ( times_times @ A @ ( C2 @ N3 ) @ ( power_power @ A @ Y5 @ N3 ) ) )
         => ( has_field_derivative @ A
            @ ^ [X2: A] :
                ( suminf @ A
                @ ^ [N3: nat] : ( times_times @ A @ ( C2 @ N3 ) @ ( power_power @ A @ X2 @ N3 ) ) )
            @ ( suminf @ A
              @ ^ [N3: nat] : ( times_times @ A @ ( diffs @ A @ C2 @ N3 ) @ ( power_power @ A @ X @ N3 ) ) )
            @ ( topolo174197925503356063within @ A @ X @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% termdiffs_strong_converges_everywhere
thf(fact_5618_at__within__Icc__at,axiom,
    ! [A: $tType] :
      ( ( topolo2564578578187576103pology @ A )
     => ! [A2: A,X: A,B2: A] :
          ( ( ord_less @ A @ A2 @ X )
         => ( ( ord_less @ A @ X @ B2 )
           => ( ( topolo174197925503356063within @ A @ X @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) )
              = ( topolo174197925503356063within @ A @ X @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ).

% at_within_Icc_at
thf(fact_5619_has__real__derivative__powr,axiom,
    ! [Z: real,R2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ Z )
     => ( has_field_derivative @ real
        @ ^ [Z6: real] : ( powr @ real @ Z6 @ R2 )
        @ ( times_times @ real @ R2 @ ( powr @ real @ Z @ ( minus_minus @ real @ R2 @ ( one_one @ real ) ) ) )
        @ ( topolo174197925503356063within @ real @ Z @ ( top_top @ ( set @ real ) ) ) ) ) ).

% has_real_derivative_powr
thf(fact_5620_at__within__Icc__at__left,axiom,
    ! [A: $tType] :
      ( ( topolo2564578578187576103pology @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( topolo174197925503356063within @ A @ B2 @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) )
            = ( topolo174197925503356063within @ A @ B2 @ ( set_ord_lessThan @ A @ B2 ) ) ) ) ) ).

% at_within_Icc_at_left
thf(fact_5621_DERIV__quotient,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,D2: A,X: A,S2: set @ A,G: A > A,E2: A] :
          ( ( has_field_derivative @ A @ F2 @ D2 @ ( topolo174197925503356063within @ A @ X @ S2 ) )
         => ( ( has_field_derivative @ A @ G @ E2 @ ( topolo174197925503356063within @ A @ X @ S2 ) )
           => ( ( ( G @ X )
               != ( zero_zero @ A ) )
             => ( has_field_derivative @ A
                @ ^ [Y4: A] : ( divide_divide @ A @ ( F2 @ Y4 ) @ ( G @ Y4 ) )
                @ ( divide_divide @ A @ ( minus_minus @ A @ ( times_times @ A @ D2 @ ( G @ X ) ) @ ( times_times @ A @ E2 @ ( F2 @ X ) ) ) @ ( power_power @ A @ ( G @ X ) @ ( suc @ ( suc @ ( zero_zero @ nat ) ) ) ) )
                @ ( topolo174197925503356063within @ A @ X @ S2 ) ) ) ) ) ) ).

% DERIV_quotient
thf(fact_5622_DERIV__inverse__fun,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,D2: A,X: A,S2: set @ A] :
          ( ( has_field_derivative @ A @ F2 @ D2 @ ( topolo174197925503356063within @ A @ X @ S2 ) )
         => ( ( ( F2 @ X )
             != ( zero_zero @ A ) )
           => ( has_field_derivative @ A
              @ ^ [X2: A] : ( inverse_inverse @ A @ ( F2 @ X2 ) )
              @ ( uminus_uminus @ A @ ( times_times @ A @ D2 @ ( inverse_inverse @ A @ ( power_power @ A @ ( F2 @ X ) @ ( suc @ ( suc @ ( zero_zero @ nat ) ) ) ) ) ) )
              @ ( topolo174197925503356063within @ A @ X @ S2 ) ) ) ) ) ).

% DERIV_inverse_fun
thf(fact_5623_termdiffs__sums__strong,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [K6: real,C2: nat > A,F2: A > A,F5: A,Z: A] :
          ( ! [Z3: A] :
              ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ Z3 ) @ K6 )
             => ( sums @ A
                @ ^ [N3: nat] : ( times_times @ A @ ( C2 @ N3 ) @ ( power_power @ A @ Z3 @ N3 ) )
                @ ( F2 @ Z3 ) ) )
         => ( ( has_field_derivative @ A @ F2 @ F5 @ ( topolo174197925503356063within @ A @ Z @ ( top_top @ ( set @ A ) ) ) )
           => ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ Z ) @ K6 )
             => ( sums @ A
                @ ^ [N3: nat] : ( times_times @ A @ ( diffs @ A @ C2 @ N3 ) @ ( power_power @ A @ Z @ N3 ) )
                @ F5 ) ) ) ) ) ).

% termdiffs_sums_strong
thf(fact_5624_DERIV__log,axiom,
    ! [X: real,B2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( has_field_derivative @ real @ ( log2 @ B2 ) @ ( divide_divide @ real @ ( one_one @ real ) @ ( times_times @ real @ ( ln_ln @ real @ B2 ) @ X ) ) @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) ) ) ).

% DERIV_log
thf(fact_5625_DERIV__fun__powr,axiom,
    ! [G: real > real,M: real,X: real,R2: real] :
      ( ( has_field_derivative @ real @ G @ M @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ ( G @ X ) )
       => ( has_field_derivative @ real
          @ ^ [X2: real] : ( powr @ real @ ( G @ X2 ) @ R2 )
          @ ( times_times @ real @ ( times_times @ real @ R2 @ ( powr @ real @ ( G @ X ) @ ( minus_minus @ real @ R2 @ ( semiring_1_of_nat @ real @ ( one_one @ nat ) ) ) ) ) @ M )
          @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) ) ) ) ).

% DERIV_fun_powr
thf(fact_5626_DERIV__powr,axiom,
    ! [G: real > real,M: real,X: real,F2: real > real,R2: real] :
      ( ( has_field_derivative @ real @ G @ M @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ ( G @ X ) )
       => ( ( has_field_derivative @ real @ F2 @ R2 @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) )
         => ( has_field_derivative @ real
            @ ^ [X2: real] : ( powr @ real @ ( G @ X2 ) @ ( F2 @ X2 ) )
            @ ( times_times @ real @ ( powr @ real @ ( G @ X ) @ ( F2 @ X ) ) @ ( plus_plus @ real @ ( times_times @ real @ R2 @ ( ln_ln @ real @ ( G @ X ) ) ) @ ( divide_divide @ real @ ( times_times @ real @ M @ ( F2 @ X ) ) @ ( G @ X ) ) ) )
            @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) ) ) ) ) ).

% DERIV_powr
thf(fact_5627_DERIV__real__sqrt,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
     => ( has_field_derivative @ real @ sqrt @ ( divide_divide @ real @ ( inverse_inverse @ real @ ( sqrt @ X ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) ) ) ).

% DERIV_real_sqrt
thf(fact_5628_DERIV__arctan,axiom,
    ! [X: real] : ( has_field_derivative @ real @ arctan @ ( inverse_inverse @ real @ ( plus_plus @ real @ ( one_one @ real ) @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) ) ).

% DERIV_arctan
thf(fact_5629_termdiffs__strong_H,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [K6: real,C2: nat > A,Z: A] :
          ( ! [Z3: A] :
              ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ Z3 ) @ K6 )
             => ( summable @ A
                @ ^ [N3: nat] : ( times_times @ A @ ( C2 @ N3 ) @ ( power_power @ A @ Z3 @ N3 ) ) ) )
         => ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ Z ) @ K6 )
           => ( has_field_derivative @ A
              @ ^ [Z6: A] :
                  ( suminf @ A
                  @ ^ [N3: nat] : ( times_times @ A @ ( C2 @ N3 ) @ ( power_power @ A @ Z6 @ N3 ) ) )
              @ ( suminf @ A
                @ ^ [N3: nat] : ( times_times @ A @ ( diffs @ A @ C2 @ N3 ) @ ( power_power @ A @ Z @ N3 ) ) )
              @ ( topolo174197925503356063within @ A @ Z @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ).

% termdiffs_strong'
thf(fact_5630_termdiffs__strong,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [C2: nat > A,K6: A,X: A] :
          ( ( summable @ A
            @ ^ [N3: nat] : ( times_times @ A @ ( C2 @ N3 ) @ ( power_power @ A @ K6 @ N3 ) ) )
         => ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ X ) @ ( real_V7770717601297561774m_norm @ A @ K6 ) )
           => ( has_field_derivative @ A
              @ ^ [X2: A] :
                  ( suminf @ A
                  @ ^ [N3: nat] : ( times_times @ A @ ( C2 @ N3 ) @ ( power_power @ A @ X2 @ N3 ) ) )
              @ ( suminf @ A
                @ ^ [N3: nat] : ( times_times @ A @ ( diffs @ A @ C2 @ N3 ) @ ( power_power @ A @ X @ N3 ) ) )
              @ ( topolo174197925503356063within @ A @ X @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ).

% termdiffs_strong
thf(fact_5631_termdiffs,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [C2: nat > A,K6: A,X: A] :
          ( ( summable @ A
            @ ^ [N3: nat] : ( times_times @ A @ ( C2 @ N3 ) @ ( power_power @ A @ K6 @ N3 ) ) )
         => ( ( summable @ A
              @ ^ [N3: nat] : ( times_times @ A @ ( diffs @ A @ C2 @ N3 ) @ ( power_power @ A @ K6 @ N3 ) ) )
           => ( ( summable @ A
                @ ^ [N3: nat] : ( times_times @ A @ ( diffs @ A @ ( diffs @ A @ C2 ) @ N3 ) @ ( power_power @ A @ K6 @ N3 ) ) )
             => ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ X ) @ ( real_V7770717601297561774m_norm @ A @ K6 ) )
               => ( has_field_derivative @ A
                  @ ^ [X2: A] :
                      ( suminf @ A
                      @ ^ [N3: nat] : ( times_times @ A @ ( C2 @ N3 ) @ ( power_power @ A @ X2 @ N3 ) ) )
                  @ ( suminf @ A
                    @ ^ [N3: nat] : ( times_times @ A @ ( diffs @ A @ C2 @ N3 ) @ ( power_power @ A @ X @ N3 ) ) )
                  @ ( topolo174197925503356063within @ A @ X @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ) ) ).

% termdiffs
thf(fact_5632_DERIV__tan,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A] :
          ( ( ( cos @ A @ X )
           != ( zero_zero @ A ) )
         => ( has_field_derivative @ A @ ( tan @ A ) @ ( inverse_inverse @ A @ ( power_power @ A @ ( cos @ A @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ ( topolo174197925503356063within @ A @ X @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% DERIV_tan
thf(fact_5633_DERIV__real__sqrt__generic,axiom,
    ! [X: real,D5: real] :
      ( ( X
       != ( zero_zero @ real ) )
     => ( ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
         => ( D5
            = ( divide_divide @ real @ ( inverse_inverse @ real @ ( sqrt @ X ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) )
       => ( ( ( ord_less @ real @ X @ ( zero_zero @ real ) )
           => ( D5
              = ( divide_divide @ real @ ( uminus_uminus @ real @ ( inverse_inverse @ real @ ( sqrt @ X ) ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) )
         => ( has_field_derivative @ real @ sqrt @ D5 @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) ) ) ) ) ).

% DERIV_real_sqrt_generic
thf(fact_5634_arsinh__real__has__field__derivative,axiom,
    ! [X: real,A4: set @ real] : ( has_field_derivative @ real @ ( arsinh @ real ) @ ( divide_divide @ real @ ( one_one @ real ) @ ( sqrt @ ( plus_plus @ real @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ real ) ) ) ) @ ( topolo174197925503356063within @ real @ X @ A4 ) ) ).

% arsinh_real_has_field_derivative
thf(fact_5635_DERIV__cot,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A] :
          ( ( ( sin @ A @ X )
           != ( zero_zero @ A ) )
         => ( has_field_derivative @ A @ ( cot @ A ) @ ( uminus_uminus @ A @ ( inverse_inverse @ A @ ( power_power @ A @ ( sin @ A @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( topolo174197925503356063within @ A @ X @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% DERIV_cot
thf(fact_5636_has__field__derivative__tanh,axiom,
    ! [A10: $tType] :
      ( ( ( real_Vector_banach @ A10 )
        & ( real_V3459762299906320749_field @ A10 ) )
     => ! [G: A10 > A10,X: A10,Db: A10,S2: set @ A10] :
          ( ( ( cosh @ A10 @ ( G @ X ) )
           != ( zero_zero @ A10 ) )
         => ( ( has_field_derivative @ A10 @ G @ Db @ ( topolo174197925503356063within @ A10 @ X @ S2 ) )
           => ( has_field_derivative @ A10
              @ ^ [X2: A10] : ( tanh @ A10 @ ( G @ X2 ) )
              @ ( times_times @ A10 @ ( minus_minus @ A10 @ ( one_one @ A10 ) @ ( power_power @ A10 @ ( tanh @ A10 @ ( G @ X ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) @ Db )
              @ ( topolo174197925503356063within @ A10 @ X @ S2 ) ) ) ) ) ).

% has_field_derivative_tanh
thf(fact_5637_arcosh__real__has__field__derivative,axiom,
    ! [X: real,A4: set @ real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ X )
     => ( has_field_derivative @ real @ ( arcosh @ real ) @ ( divide_divide @ real @ ( one_one @ real ) @ ( sqrt @ ( minus_minus @ real @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ real ) ) ) ) @ ( topolo174197925503356063within @ real @ X @ A4 ) ) ) ).

% arcosh_real_has_field_derivative
thf(fact_5638_artanh__real__has__field__derivative,axiom,
    ! [X: real,A4: set @ real] :
      ( ( ord_less @ real @ ( abs_abs @ real @ X ) @ ( one_one @ real ) )
     => ( has_field_derivative @ real @ ( artanh @ real ) @ ( divide_divide @ real @ ( one_one @ real ) @ ( minus_minus @ real @ ( one_one @ real ) @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) @ ( topolo174197925503356063within @ real @ X @ A4 ) ) ) ).

% artanh_real_has_field_derivative
thf(fact_5639_DERIV__real__root,axiom,
    ! [N: nat,X: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ X )
       => ( has_field_derivative @ real @ ( root @ N ) @ ( inverse_inverse @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N ) @ ( power_power @ real @ ( root @ N @ X ) @ ( minus_minus @ nat @ N @ ( suc @ ( zero_zero @ nat ) ) ) ) ) ) @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) ) ) ) ).

% DERIV_real_root
thf(fact_5640_DERIV__arccos,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ X )
     => ( ( ord_less @ real @ X @ ( one_one @ real ) )
       => ( has_field_derivative @ real @ arccos @ ( inverse_inverse @ real @ ( uminus_uminus @ real @ ( sqrt @ ( minus_minus @ real @ ( one_one @ real ) @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) ) ) ) ).

% DERIV_arccos
thf(fact_5641_DERIV__arcsin,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ X )
     => ( ( ord_less @ real @ X @ ( one_one @ real ) )
       => ( has_field_derivative @ real @ arcsin @ ( inverse_inverse @ real @ ( sqrt @ ( minus_minus @ real @ ( one_one @ real ) @ ( power_power @ real @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) ) ) ) ).

% DERIV_arcsin
thf(fact_5642_Maclaurin__all__le,axiom,
    ! [Diff: nat > real > real,F2: real > real,X: real,N: nat] :
      ( ( ( Diff @ ( zero_zero @ nat ) )
        = F2 )
     => ( ! [M4: nat,X3: real] : ( has_field_derivative @ real @ ( Diff @ M4 ) @ ( Diff @ ( suc @ M4 ) @ X3 ) @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) )
       => ? [T4: real] :
            ( ( ord_less_eq @ real @ ( abs_abs @ real @ T4 ) @ ( abs_abs @ real @ X ) )
            & ( ( F2 @ X )
              = ( plus_plus @ real
                @ ( groups7311177749621191930dd_sum @ nat @ real
                  @ ^ [M3: nat] : ( times_times @ real @ ( divide_divide @ real @ ( Diff @ M3 @ ( zero_zero @ real ) ) @ ( semiring_char_0_fact @ real @ M3 ) ) @ ( power_power @ real @ X @ M3 ) )
                  @ ( set_ord_lessThan @ nat @ N ) )
                @ ( times_times @ real @ ( divide_divide @ real @ ( Diff @ N @ T4 ) @ ( semiring_char_0_fact @ real @ N ) ) @ ( power_power @ real @ X @ N ) ) ) ) ) ) ) ).

% Maclaurin_all_le
thf(fact_5643_Maclaurin__all__le__objl,axiom,
    ! [Diff: nat > real > real,F2: real > real,X: real,N: nat] :
      ( ( ( ( Diff @ ( zero_zero @ nat ) )
          = F2 )
        & ! [M4: nat,X3: real] : ( has_field_derivative @ real @ ( Diff @ M4 ) @ ( Diff @ ( suc @ M4 ) @ X3 ) @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) ) )
     => ? [T4: real] :
          ( ( ord_less_eq @ real @ ( abs_abs @ real @ T4 ) @ ( abs_abs @ real @ X ) )
          & ( ( F2 @ X )
            = ( plus_plus @ real
              @ ( groups7311177749621191930dd_sum @ nat @ real
                @ ^ [M3: nat] : ( times_times @ real @ ( divide_divide @ real @ ( Diff @ M3 @ ( zero_zero @ real ) ) @ ( semiring_char_0_fact @ real @ M3 ) ) @ ( power_power @ real @ X @ M3 ) )
                @ ( set_ord_lessThan @ nat @ N ) )
              @ ( times_times @ real @ ( divide_divide @ real @ ( Diff @ N @ T4 ) @ ( semiring_char_0_fact @ real @ N ) ) @ ( power_power @ real @ X @ N ) ) ) ) ) ) ).

% Maclaurin_all_le_objl
thf(fact_5644_DERIV__odd__real__root,axiom,
    ! [N: nat,X: real] :
      ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
     => ( ( X
         != ( zero_zero @ real ) )
       => ( has_field_derivative @ real @ ( root @ N ) @ ( inverse_inverse @ real @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N ) @ ( power_power @ real @ ( root @ N @ X ) @ ( minus_minus @ nat @ N @ ( suc @ ( zero_zero @ nat ) ) ) ) ) ) @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) ) ) ) ).

% DERIV_odd_real_root
thf(fact_5645_Maclaurin__minus,axiom,
    ! [H2: real,N: nat,Diff: nat > real > real,F2: real > real] :
      ( ( ord_less @ real @ H2 @ ( zero_zero @ real ) )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
       => ( ( ( Diff @ ( zero_zero @ nat ) )
            = F2 )
         => ( ! [M4: nat,T4: real] :
                ( ( ( ord_less @ nat @ M4 @ N )
                  & ( ord_less_eq @ real @ H2 @ T4 )
                  & ( ord_less_eq @ real @ T4 @ ( zero_zero @ real ) ) )
               => ( has_field_derivative @ real @ ( Diff @ M4 ) @ ( Diff @ ( suc @ M4 ) @ T4 ) @ ( topolo174197925503356063within @ real @ T4 @ ( top_top @ ( set @ real ) ) ) ) )
           => ? [T4: real] :
                ( ( ord_less @ real @ H2 @ T4 )
                & ( ord_less @ real @ T4 @ ( zero_zero @ real ) )
                & ( ( F2 @ H2 )
                  = ( plus_plus @ real
                    @ ( groups7311177749621191930dd_sum @ nat @ real
                      @ ^ [M3: nat] : ( times_times @ real @ ( divide_divide @ real @ ( Diff @ M3 @ ( zero_zero @ real ) ) @ ( semiring_char_0_fact @ real @ M3 ) ) @ ( power_power @ real @ H2 @ M3 ) )
                      @ ( set_ord_lessThan @ nat @ N ) )
                    @ ( times_times @ real @ ( divide_divide @ real @ ( Diff @ N @ T4 ) @ ( semiring_char_0_fact @ real @ N ) ) @ ( power_power @ real @ H2 @ N ) ) ) ) ) ) ) ) ) ).

% Maclaurin_minus
thf(fact_5646_Maclaurin2,axiom,
    ! [H2: real,Diff: nat > real > real,F2: real > real,N: nat] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ H2 )
     => ( ( ( Diff @ ( zero_zero @ nat ) )
          = F2 )
       => ( ! [M4: nat,T4: real] :
              ( ( ( ord_less @ nat @ M4 @ N )
                & ( ord_less_eq @ real @ ( zero_zero @ real ) @ T4 )
                & ( ord_less_eq @ real @ T4 @ H2 ) )
             => ( has_field_derivative @ real @ ( Diff @ M4 ) @ ( Diff @ ( suc @ M4 ) @ T4 ) @ ( topolo174197925503356063within @ real @ T4 @ ( top_top @ ( set @ real ) ) ) ) )
         => ? [T4: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ T4 )
              & ( ord_less_eq @ real @ T4 @ H2 )
              & ( ( F2 @ H2 )
                = ( plus_plus @ real
                  @ ( groups7311177749621191930dd_sum @ nat @ real
                    @ ^ [M3: nat] : ( times_times @ real @ ( divide_divide @ real @ ( Diff @ M3 @ ( zero_zero @ real ) ) @ ( semiring_char_0_fact @ real @ M3 ) ) @ ( power_power @ real @ H2 @ M3 ) )
                    @ ( set_ord_lessThan @ nat @ N ) )
                  @ ( times_times @ real @ ( divide_divide @ real @ ( Diff @ N @ T4 ) @ ( semiring_char_0_fact @ real @ N ) ) @ ( power_power @ real @ H2 @ N ) ) ) ) ) ) ) ) ).

% Maclaurin2
thf(fact_5647_Maclaurin,axiom,
    ! [H2: real,N: nat,Diff: nat > real > real,F2: real > real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ H2 )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
       => ( ( ( Diff @ ( zero_zero @ nat ) )
            = F2 )
         => ( ! [M4: nat,T4: real] :
                ( ( ( ord_less @ nat @ M4 @ N )
                  & ( ord_less_eq @ real @ ( zero_zero @ real ) @ T4 )
                  & ( ord_less_eq @ real @ T4 @ H2 ) )
               => ( has_field_derivative @ real @ ( Diff @ M4 ) @ ( Diff @ ( suc @ M4 ) @ T4 ) @ ( topolo174197925503356063within @ real @ T4 @ ( top_top @ ( set @ real ) ) ) ) )
           => ? [T4: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ T4 )
                & ( ord_less @ real @ T4 @ H2 )
                & ( ( F2 @ H2 )
                  = ( plus_plus @ real
                    @ ( groups7311177749621191930dd_sum @ nat @ real
                      @ ^ [M3: nat] : ( times_times @ real @ ( divide_divide @ real @ ( Diff @ M3 @ ( zero_zero @ real ) ) @ ( semiring_char_0_fact @ real @ M3 ) ) @ ( power_power @ real @ H2 @ M3 ) )
                      @ ( set_ord_lessThan @ nat @ N ) )
                    @ ( times_times @ real @ ( divide_divide @ real @ ( Diff @ N @ T4 ) @ ( semiring_char_0_fact @ real @ N ) ) @ ( power_power @ real @ H2 @ N ) ) ) ) ) ) ) ) ) ).

% Maclaurin
thf(fact_5648_Maclaurin__all__lt,axiom,
    ! [Diff: nat > real > real,F2: real > real,N: nat,X: real] :
      ( ( ( Diff @ ( zero_zero @ nat ) )
        = F2 )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
       => ( ( X
           != ( zero_zero @ real ) )
         => ( ! [M4: nat,X3: real] : ( has_field_derivative @ real @ ( Diff @ M4 ) @ ( Diff @ ( suc @ M4 ) @ X3 ) @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) )
           => ? [T4: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ ( abs_abs @ real @ T4 ) )
                & ( ord_less @ real @ ( abs_abs @ real @ T4 ) @ ( abs_abs @ real @ X ) )
                & ( ( F2 @ X )
                  = ( plus_plus @ real
                    @ ( groups7311177749621191930dd_sum @ nat @ real
                      @ ^ [M3: nat] : ( times_times @ real @ ( divide_divide @ real @ ( Diff @ M3 @ ( zero_zero @ real ) ) @ ( semiring_char_0_fact @ real @ M3 ) ) @ ( power_power @ real @ X @ M3 ) )
                      @ ( set_ord_lessThan @ nat @ N ) )
                    @ ( times_times @ real @ ( divide_divide @ real @ ( Diff @ N @ T4 ) @ ( semiring_char_0_fact @ real @ N ) ) @ ( power_power @ real @ X @ N ) ) ) ) ) ) ) ) ) ).

% Maclaurin_all_lt
thf(fact_5649_Maclaurin__bi__le,axiom,
    ! [Diff: nat > real > real,F2: real > real,N: nat,X: real] :
      ( ( ( Diff @ ( zero_zero @ nat ) )
        = F2 )
     => ( ! [M4: nat,T4: real] :
            ( ( ( ord_less @ nat @ M4 @ N )
              & ( ord_less_eq @ real @ ( abs_abs @ real @ T4 ) @ ( abs_abs @ real @ X ) ) )
           => ( has_field_derivative @ real @ ( Diff @ M4 ) @ ( Diff @ ( suc @ M4 ) @ T4 ) @ ( topolo174197925503356063within @ real @ T4 @ ( top_top @ ( set @ real ) ) ) ) )
       => ? [T4: real] :
            ( ( ord_less_eq @ real @ ( abs_abs @ real @ T4 ) @ ( abs_abs @ real @ X ) )
            & ( ( F2 @ X )
              = ( plus_plus @ real
                @ ( groups7311177749621191930dd_sum @ nat @ real
                  @ ^ [M3: nat] : ( times_times @ real @ ( divide_divide @ real @ ( Diff @ M3 @ ( zero_zero @ real ) ) @ ( semiring_char_0_fact @ real @ M3 ) ) @ ( power_power @ real @ X @ M3 ) )
                  @ ( set_ord_lessThan @ nat @ N ) )
                @ ( times_times @ real @ ( divide_divide @ real @ ( Diff @ N @ T4 ) @ ( semiring_char_0_fact @ real @ N ) ) @ ( power_power @ real @ X @ N ) ) ) ) ) ) ) ).

% Maclaurin_bi_le
thf(fact_5650_Taylor__down,axiom,
    ! [N: nat,Diff: nat > real > real,F2: real > real,A2: real,B2: real,C2: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ( Diff @ ( zero_zero @ nat ) )
          = F2 )
       => ( ! [M4: nat,T4: real] :
              ( ( ( ord_less @ nat @ M4 @ N )
                & ( ord_less_eq @ real @ A2 @ T4 )
                & ( ord_less_eq @ real @ T4 @ B2 ) )
             => ( has_field_derivative @ real @ ( Diff @ M4 ) @ ( Diff @ ( suc @ M4 ) @ T4 ) @ ( topolo174197925503356063within @ real @ T4 @ ( top_top @ ( set @ real ) ) ) ) )
         => ( ( ord_less @ real @ A2 @ C2 )
           => ( ( ord_less_eq @ real @ C2 @ B2 )
             => ? [T4: real] :
                  ( ( ord_less @ real @ A2 @ T4 )
                  & ( ord_less @ real @ T4 @ C2 )
                  & ( ( F2 @ A2 )
                    = ( plus_plus @ real
                      @ ( groups7311177749621191930dd_sum @ nat @ real
                        @ ^ [M3: nat] : ( times_times @ real @ ( divide_divide @ real @ ( Diff @ M3 @ C2 ) @ ( semiring_char_0_fact @ real @ M3 ) ) @ ( power_power @ real @ ( minus_minus @ real @ A2 @ C2 ) @ M3 ) )
                        @ ( set_ord_lessThan @ nat @ N ) )
                      @ ( times_times @ real @ ( divide_divide @ real @ ( Diff @ N @ T4 ) @ ( semiring_char_0_fact @ real @ N ) ) @ ( power_power @ real @ ( minus_minus @ real @ A2 @ C2 ) @ N ) ) ) ) ) ) ) ) ) ) ).

% Taylor_down
thf(fact_5651_Taylor__up,axiom,
    ! [N: nat,Diff: nat > real > real,F2: real > real,A2: real,B2: real,C2: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ( Diff @ ( zero_zero @ nat ) )
          = F2 )
       => ( ! [M4: nat,T4: real] :
              ( ( ( ord_less @ nat @ M4 @ N )
                & ( ord_less_eq @ real @ A2 @ T4 )
                & ( ord_less_eq @ real @ T4 @ B2 ) )
             => ( has_field_derivative @ real @ ( Diff @ M4 ) @ ( Diff @ ( suc @ M4 ) @ T4 ) @ ( topolo174197925503356063within @ real @ T4 @ ( top_top @ ( set @ real ) ) ) ) )
         => ( ( ord_less_eq @ real @ A2 @ C2 )
           => ( ( ord_less @ real @ C2 @ B2 )
             => ? [T4: real] :
                  ( ( ord_less @ real @ C2 @ T4 )
                  & ( ord_less @ real @ T4 @ B2 )
                  & ( ( F2 @ B2 )
                    = ( plus_plus @ real
                      @ ( groups7311177749621191930dd_sum @ nat @ real
                        @ ^ [M3: nat] : ( times_times @ real @ ( divide_divide @ real @ ( Diff @ M3 @ C2 ) @ ( semiring_char_0_fact @ real @ M3 ) ) @ ( power_power @ real @ ( minus_minus @ real @ B2 @ C2 ) @ M3 ) )
                        @ ( set_ord_lessThan @ nat @ N ) )
                      @ ( times_times @ real @ ( divide_divide @ real @ ( Diff @ N @ T4 ) @ ( semiring_char_0_fact @ real @ N ) ) @ ( power_power @ real @ ( minus_minus @ real @ B2 @ C2 ) @ N ) ) ) ) ) ) ) ) ) ) ).

% Taylor_up
thf(fact_5652_Taylor,axiom,
    ! [N: nat,Diff: nat > real > real,F2: real > real,A2: real,B2: real,C2: real,X: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( ( Diff @ ( zero_zero @ nat ) )
          = F2 )
       => ( ! [M4: nat,T4: real] :
              ( ( ( ord_less @ nat @ M4 @ N )
                & ( ord_less_eq @ real @ A2 @ T4 )
                & ( ord_less_eq @ real @ T4 @ B2 ) )
             => ( has_field_derivative @ real @ ( Diff @ M4 ) @ ( Diff @ ( suc @ M4 ) @ T4 ) @ ( topolo174197925503356063within @ real @ T4 @ ( top_top @ ( set @ real ) ) ) ) )
         => ( ( ord_less_eq @ real @ A2 @ C2 )
           => ( ( ord_less_eq @ real @ C2 @ B2 )
             => ( ( ord_less_eq @ real @ A2 @ X )
               => ( ( ord_less_eq @ real @ X @ B2 )
                 => ( ( X != C2 )
                   => ? [T4: real] :
                        ( ( ( ord_less @ real @ X @ C2 )
                         => ( ( ord_less @ real @ X @ T4 )
                            & ( ord_less @ real @ T4 @ C2 ) ) )
                        & ( ~ ( ord_less @ real @ X @ C2 )
                         => ( ( ord_less @ real @ C2 @ T4 )
                            & ( ord_less @ real @ T4 @ X ) ) )
                        & ( ( F2 @ X )
                          = ( plus_plus @ real
                            @ ( groups7311177749621191930dd_sum @ nat @ real
                              @ ^ [M3: nat] : ( times_times @ real @ ( divide_divide @ real @ ( Diff @ M3 @ C2 ) @ ( semiring_char_0_fact @ real @ M3 ) ) @ ( power_power @ real @ ( minus_minus @ real @ X @ C2 ) @ M3 ) )
                              @ ( set_ord_lessThan @ nat @ N ) )
                            @ ( times_times @ real @ ( divide_divide @ real @ ( Diff @ N @ T4 ) @ ( semiring_char_0_fact @ real @ N ) ) @ ( power_power @ real @ ( minus_minus @ real @ X @ C2 ) @ N ) ) ) ) ) ) ) ) ) ) ) ) ) ).

% Taylor
thf(fact_5653_Maclaurin__lemma2,axiom,
    ! [N: nat,H2: real,Diff: nat > real > real,K: nat,B7: real] :
      ( ! [M4: nat,T4: real] :
          ( ( ( ord_less @ nat @ M4 @ N )
            & ( ord_less_eq @ real @ ( zero_zero @ real ) @ T4 )
            & ( ord_less_eq @ real @ T4 @ H2 ) )
         => ( has_field_derivative @ real @ ( Diff @ M4 ) @ ( Diff @ ( suc @ M4 ) @ T4 ) @ ( topolo174197925503356063within @ real @ T4 @ ( top_top @ ( set @ real ) ) ) ) )
     => ( ( N
          = ( suc @ K ) )
       => ! [M2: nat,T8: real] :
            ( ( ( ord_less @ nat @ M2 @ N )
              & ( ord_less_eq @ real @ ( zero_zero @ real ) @ T8 )
              & ( ord_less_eq @ real @ T8 @ H2 ) )
           => ( has_field_derivative @ real
              @ ^ [U2: real] :
                  ( minus_minus @ real @ ( Diff @ M2 @ U2 )
                  @ ( plus_plus @ real
                    @ ( groups7311177749621191930dd_sum @ nat @ real
                      @ ^ [P5: nat] : ( times_times @ real @ ( divide_divide @ real @ ( Diff @ ( plus_plus @ nat @ M2 @ P5 ) @ ( zero_zero @ real ) ) @ ( semiring_char_0_fact @ real @ P5 ) ) @ ( power_power @ real @ U2 @ P5 ) )
                      @ ( set_ord_lessThan @ nat @ ( minus_minus @ nat @ N @ M2 ) ) )
                    @ ( times_times @ real @ B7 @ ( divide_divide @ real @ ( power_power @ real @ U2 @ ( minus_minus @ nat @ N @ M2 ) ) @ ( semiring_char_0_fact @ real @ ( minus_minus @ nat @ N @ M2 ) ) ) ) ) )
              @ ( minus_minus @ real @ ( Diff @ ( suc @ M2 ) @ T8 )
                @ ( plus_plus @ real
                  @ ( groups7311177749621191930dd_sum @ nat @ real
                    @ ^ [P5: nat] : ( times_times @ real @ ( divide_divide @ real @ ( Diff @ ( plus_plus @ nat @ ( suc @ M2 ) @ P5 ) @ ( zero_zero @ real ) ) @ ( semiring_char_0_fact @ real @ P5 ) ) @ ( power_power @ real @ T8 @ P5 ) )
                    @ ( set_ord_lessThan @ nat @ ( minus_minus @ nat @ N @ ( suc @ M2 ) ) ) )
                  @ ( times_times @ real @ B7 @ ( divide_divide @ real @ ( power_power @ real @ T8 @ ( minus_minus @ nat @ N @ ( suc @ M2 ) ) ) @ ( semiring_char_0_fact @ real @ ( minus_minus @ nat @ N @ ( suc @ M2 ) ) ) ) ) ) )
              @ ( topolo174197925503356063within @ real @ T8 @ ( top_top @ ( set @ real ) ) ) ) ) ) ) ).

% Maclaurin_lemma2
thf(fact_5654_DERIV__arctan__series,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( abs_abs @ real @ X ) @ ( one_one @ real ) )
     => ( has_field_derivative @ real
        @ ^ [X9: real] :
            ( suminf @ real
            @ ^ [K3: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ K3 ) @ ( times_times @ real @ ( divide_divide @ real @ ( one_one @ real ) @ ( semiring_1_of_nat @ real @ ( plus_plus @ nat @ ( times_times @ nat @ K3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ nat ) ) ) ) @ ( power_power @ real @ X9 @ ( plus_plus @ nat @ ( times_times @ nat @ K3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ nat ) ) ) ) ) )
        @ ( suminf @ real
          @ ^ [K3: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ K3 ) @ ( power_power @ real @ X @ ( times_times @ nat @ K3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
        @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) ) ) ).

% DERIV_arctan_series
thf(fact_5655_DERIV__even__real__root,axiom,
    ! [N: nat,X: real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
       => ( ( ord_less @ real @ X @ ( zero_zero @ real ) )
         => ( has_field_derivative @ real @ ( root @ N ) @ ( inverse_inverse @ real @ ( times_times @ real @ ( uminus_uminus @ real @ ( semiring_1_of_nat @ real @ N ) ) @ ( power_power @ real @ ( root @ N @ X ) @ ( minus_minus @ nat @ N @ ( suc @ ( zero_zero @ nat ) ) ) ) ) ) @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) ) ) ) ) ).

% DERIV_even_real_root
thf(fact_5656_DERIV__power__series_H,axiom,
    ! [R4: real,F2: nat > real,X0: real] :
      ( ! [X3: real] :
          ( ( member @ real @ X3 @ ( set_or5935395276787703475ssThan @ real @ ( uminus_uminus @ real @ R4 ) @ R4 ) )
         => ( summable @ real
            @ ^ [N3: nat] : ( times_times @ real @ ( times_times @ real @ ( F2 @ N3 ) @ ( semiring_1_of_nat @ real @ ( suc @ N3 ) ) ) @ ( power_power @ real @ X3 @ N3 ) ) ) )
     => ( ( member @ real @ X0 @ ( set_or5935395276787703475ssThan @ real @ ( uminus_uminus @ real @ R4 ) @ R4 ) )
       => ( ( ord_less @ real @ ( zero_zero @ real ) @ R4 )
         => ( has_field_derivative @ real
            @ ^ [X2: real] :
                ( suminf @ real
                @ ^ [N3: nat] : ( times_times @ real @ ( F2 @ N3 ) @ ( power_power @ real @ X2 @ ( suc @ N3 ) ) ) )
            @ ( suminf @ real
              @ ^ [N3: nat] : ( times_times @ real @ ( times_times @ real @ ( F2 @ N3 ) @ ( semiring_1_of_nat @ real @ ( suc @ N3 ) ) ) @ ( power_power @ real @ X0 @ N3 ) ) )
            @ ( topolo174197925503356063within @ real @ X0 @ ( top_top @ ( set @ real ) ) ) ) ) ) ) ).

% DERIV_power_series'
thf(fact_5657_has__derivative__arcsin,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [G: A > real,X: A,G4: A > real,S2: set @ A] :
          ( ( ord_less @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ ( G @ X ) )
         => ( ( ord_less @ real @ ( G @ X ) @ ( one_one @ real ) )
           => ( ( has_derivative @ A @ real @ G @ G4 @ ( topolo174197925503356063within @ A @ X @ S2 ) )
             => ( has_derivative @ A @ real
                @ ^ [X2: A] : ( arcsin @ ( G @ X2 ) )
                @ ^ [X2: A] : ( times_times @ real @ ( G4 @ X2 ) @ ( inverse_inverse @ real @ ( sqrt @ ( minus_minus @ real @ ( one_one @ real ) @ ( power_power @ real @ ( G @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) )
                @ ( topolo174197925503356063within @ A @ X @ S2 ) ) ) ) ) ) ).

% has_derivative_arcsin
thf(fact_5658_has__derivative__arccos,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [G: A > real,X: A,G4: A > real,S2: set @ A] :
          ( ( ord_less @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ ( G @ X ) )
         => ( ( ord_less @ real @ ( G @ X ) @ ( one_one @ real ) )
           => ( ( has_derivative @ A @ real @ G @ G4 @ ( topolo174197925503356063within @ A @ X @ S2 ) )
             => ( has_derivative @ A @ real
                @ ^ [X2: A] : ( arccos @ ( G @ X2 ) )
                @ ^ [X2: A] : ( times_times @ real @ ( G4 @ X2 ) @ ( inverse_inverse @ real @ ( uminus_uminus @ real @ ( sqrt @ ( minus_minus @ real @ ( one_one @ real ) @ ( power_power @ real @ ( G @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) )
                @ ( topolo174197925503356063within @ A @ X @ S2 ) ) ) ) ) ) ).

% has_derivative_arccos
thf(fact_5659_greaterThanLessThan__iff,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [I: A,L: A,U: A] :
          ( ( member @ A @ I @ ( set_or5935395276787703475ssThan @ A @ L @ U ) )
          = ( ( ord_less @ A @ L @ I )
            & ( ord_less @ A @ I @ U ) ) ) ) ).

% greaterThanLessThan_iff
thf(fact_5660_greaterThanLessThan__empty__iff2,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ( bot_bot @ ( set @ A ) )
            = ( set_or5935395276787703475ssThan @ A @ A2 @ B2 ) )
          = ( ord_less_eq @ A @ B2 @ A2 ) ) ) ).

% greaterThanLessThan_empty_iff2
thf(fact_5661_greaterThanLessThan__empty__iff,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ( set_or5935395276787703475ssThan @ A @ A2 @ B2 )
            = ( bot_bot @ ( set @ A ) ) )
          = ( ord_less_eq @ A @ B2 @ A2 ) ) ) ).

% greaterThanLessThan_empty_iff
thf(fact_5662_greaterThanLessThan__empty,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [L: A,K: A] :
          ( ( ord_less_eq @ A @ L @ K )
         => ( ( set_or5935395276787703475ssThan @ A @ K @ L )
            = ( bot_bot @ ( set @ A ) ) ) ) ) ).

% greaterThanLessThan_empty
thf(fact_5663_infinite__Ioo__iff,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ~ ( finite_finite @ A @ ( set_or5935395276787703475ssThan @ A @ A2 @ B2 ) ) )
          = ( ord_less @ A @ A2 @ B2 ) ) ) ).

% infinite_Ioo_iff
thf(fact_5664_cSup__greaterThanLessThan,axiom,
    ! [A: $tType] :
      ( ( ( condit6923001295902523014norder @ A )
        & ( dense_linorder @ A ) )
     => ! [Y: A,X: A] :
          ( ( ord_less @ A @ Y @ X )
         => ( ( complete_Sup_Sup @ A @ ( set_or5935395276787703475ssThan @ A @ Y @ X ) )
            = X ) ) ) ).

% cSup_greaterThanLessThan
thf(fact_5665_Sup__greaterThanLessThan,axiom,
    ! [A: $tType] :
      ( ( ( comple6319245703460814977attice @ A )
        & ( dense_linorder @ A ) )
     => ! [X: A,Y: A] :
          ( ( ord_less @ A @ X @ Y )
         => ( ( complete_Sup_Sup @ A @ ( set_or5935395276787703475ssThan @ A @ X @ Y ) )
            = Y ) ) ) ).

% Sup_greaterThanLessThan
thf(fact_5666_cInf__greaterThanLessThan,axiom,
    ! [A: $tType] :
      ( ( ( condit6923001295902523014norder @ A )
        & ( dense_linorder @ A ) )
     => ! [Y: A,X: A] :
          ( ( ord_less @ A @ Y @ X )
         => ( ( complete_Inf_Inf @ A @ ( set_or5935395276787703475ssThan @ A @ Y @ X ) )
            = Y ) ) ) ).

% cInf_greaterThanLessThan
thf(fact_5667_Inf__greaterThanLessThan,axiom,
    ! [A: $tType] :
      ( ( ( comple6319245703460814977attice @ A )
        & ( dense_linorder @ A ) )
     => ! [X: A,Y: A] :
          ( ( ord_less @ A @ X @ Y )
         => ( ( complete_Inf_Inf @ A @ ( set_or5935395276787703475ssThan @ A @ X @ Y ) )
            = X ) ) ) ).

% Inf_greaterThanLessThan
thf(fact_5668_Int__greaterThanLessThan,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( inf_inf @ ( set @ A ) @ ( set_or5935395276787703475ssThan @ A @ A2 @ B2 ) @ ( set_or5935395276787703475ssThan @ A @ C2 @ D2 ) )
          = ( set_or5935395276787703475ssThan @ A @ ( ord_max @ A @ A2 @ C2 ) @ ( ord_min @ A @ B2 @ D2 ) ) ) ) ).

% Int_greaterThanLessThan
thf(fact_5669_has__derivative__const,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [C2: B,F4: filter @ A] :
          ( has_derivative @ A @ B
          @ ^ [X2: A] : C2
          @ ^ [X2: A] : ( zero_zero @ B )
          @ F4 ) ) ).

% has_derivative_const
thf(fact_5670_infinite__Ioo,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ~ ( finite_finite @ A @ ( set_or5935395276787703475ssThan @ A @ A2 @ B2 ) ) ) ) ).

% infinite_Ioo
thf(fact_5671_has__derivative__zero__unique,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F4: A > B,X: A] :
          ( ( has_derivative @ A @ B
            @ ^ [X2: A] : ( zero_zero @ B )
            @ F4
            @ ( topolo174197925503356063within @ A @ X @ ( top_top @ ( set @ A ) ) ) )
         => ( F4
            = ( ^ [H: A] : ( zero_zero @ B ) ) ) ) ) ).

% has_derivative_zero_unique
thf(fact_5672_greaterThanLessThan__subseteq__greaterThanLessThan,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ord_less_eq @ ( set @ A ) @ ( set_or5935395276787703475ssThan @ A @ A2 @ B2 ) @ ( set_or5935395276787703475ssThan @ A @ C2 @ D2 ) )
          = ( ( ord_less @ A @ A2 @ B2 )
           => ( ( ord_less_eq @ A @ C2 @ A2 )
              & ( ord_less_eq @ A @ B2 @ D2 ) ) ) ) ) ).

% greaterThanLessThan_subseteq_greaterThanLessThan
thf(fact_5673_greaterThanLessThan__subseteq__atLeastAtMost__iff,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ord_less_eq @ ( set @ A ) @ ( set_or5935395276787703475ssThan @ A @ A2 @ B2 ) @ ( set_or1337092689740270186AtMost @ A @ C2 @ D2 ) )
          = ( ( ord_less @ A @ A2 @ B2 )
           => ( ( ord_less_eq @ A @ C2 @ A2 )
              & ( ord_less_eq @ A @ B2 @ D2 ) ) ) ) ) ).

% greaterThanLessThan_subseteq_atLeastAtMost_iff
thf(fact_5674_greaterThanLessThan__subseteq__atLeastLessThan__iff,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ord_less_eq @ ( set @ A ) @ ( set_or5935395276787703475ssThan @ A @ A2 @ B2 ) @ ( set_or7035219750837199246ssThan @ A @ C2 @ D2 ) )
          = ( ( ord_less @ A @ A2 @ B2 )
           => ( ( ord_less_eq @ A @ C2 @ A2 )
              & ( ord_less_eq @ A @ B2 @ D2 ) ) ) ) ) ).

% greaterThanLessThan_subseteq_atLeastLessThan_iff
thf(fact_5675_ivl__disj__un__two_I1_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L: A,M: A,U: A] :
          ( ( ord_less @ A @ L @ M )
         => ( ( ord_less_eq @ A @ M @ U )
           => ( ( sup_sup @ ( set @ A ) @ ( set_or5935395276787703475ssThan @ A @ L @ M ) @ ( set_or7035219750837199246ssThan @ A @ M @ U ) )
              = ( set_or5935395276787703475ssThan @ A @ L @ U ) ) ) ) ) ).

% ivl_disj_un_two(1)
thf(fact_5676_ivl__disj__un__one_I1_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L: A,U: A] :
          ( ( ord_less @ A @ L @ U )
         => ( ( sup_sup @ ( set @ A ) @ ( set_ord_atMost @ A @ L ) @ ( set_or5935395276787703475ssThan @ A @ L @ U ) )
            = ( set_ord_lessThan @ A @ U ) ) ) ) ).

% ivl_disj_un_one(1)
thf(fact_5677_has__derivative__divide_H,axiom,
    ! [A: $tType,C: $tType] :
      ( ( ( real_V822414075346904944vector @ C )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [F2: C > A,F5: C > A,X: C,S: set @ C,G: C > A,G4: C > A] :
          ( ( has_derivative @ C @ A @ F2 @ F5 @ ( topolo174197925503356063within @ C @ X @ S ) )
         => ( ( has_derivative @ C @ A @ G @ G4 @ ( topolo174197925503356063within @ C @ X @ S ) )
           => ( ( ( G @ X )
               != ( zero_zero @ A ) )
             => ( has_derivative @ C @ A
                @ ^ [X2: C] : ( divide_divide @ A @ ( F2 @ X2 ) @ ( G @ X2 ) )
                @ ^ [H: C] : ( divide_divide @ A @ ( minus_minus @ A @ ( times_times @ A @ ( F5 @ H ) @ ( G @ X ) ) @ ( times_times @ A @ ( F2 @ X ) @ ( G4 @ H ) ) ) @ ( times_times @ A @ ( G @ X ) @ ( G @ X ) ) )
                @ ( topolo174197925503356063within @ C @ X @ S ) ) ) ) ) ) ).

% has_derivative_divide'
thf(fact_5678_has__derivative__inverse,axiom,
    ! [A: $tType,C: $tType] :
      ( ( ( real_V822414075346904944vector @ C )
        & ( real_V8999393235501362500lgebra @ A ) )
     => ! [F2: C > A,X: C,F5: C > A,S: set @ C] :
          ( ( ( F2 @ X )
           != ( zero_zero @ A ) )
         => ( ( has_derivative @ C @ A @ F2 @ F5 @ ( topolo174197925503356063within @ C @ X @ S ) )
           => ( has_derivative @ C @ A
              @ ^ [X2: C] : ( inverse_inverse @ A @ ( F2 @ X2 ) )
              @ ^ [H: C] : ( uminus_uminus @ A @ ( times_times @ A @ ( times_times @ A @ ( inverse_inverse @ A @ ( F2 @ X ) ) @ ( F5 @ H ) ) @ ( inverse_inverse @ A @ ( F2 @ X ) ) ) )
              @ ( topolo174197925503356063within @ C @ X @ S ) ) ) ) ) ).

% has_derivative_inverse
thf(fact_5679_has__derivative__inverse_H,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [X: A,S: set @ A] :
          ( ( X
           != ( zero_zero @ A ) )
         => ( has_derivative @ A @ A @ ( inverse_inverse @ A )
            @ ^ [H: A] : ( uminus_uminus @ A @ ( times_times @ A @ ( times_times @ A @ ( inverse_inverse @ A @ X ) @ H ) @ ( inverse_inverse @ A @ X ) ) )
            @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ).

% has_derivative_inverse'
thf(fact_5680_DERIV__isconst3,axiom,
    ! [A2: real,B2: real,X: real,Y: real,F2: real > real] :
      ( ( ord_less @ real @ A2 @ B2 )
     => ( ( member @ real @ X @ ( set_or5935395276787703475ssThan @ real @ A2 @ B2 ) )
       => ( ( member @ real @ Y @ ( set_or5935395276787703475ssThan @ real @ A2 @ B2 ) )
         => ( ! [X3: real] :
                ( ( member @ real @ X3 @ ( set_or5935395276787703475ssThan @ real @ A2 @ B2 ) )
               => ( has_field_derivative @ real @ F2 @ ( zero_zero @ real ) @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) ) )
           => ( ( F2 @ X )
              = ( F2 @ Y ) ) ) ) ) ) ).

% DERIV_isconst3
thf(fact_5681_ivl__disj__un__two_I4_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L: A,M: A,U: A] :
          ( ( ord_less_eq @ A @ L @ M )
         => ( ( ord_less @ A @ M @ U )
           => ( ( sup_sup @ ( set @ A ) @ ( set_or1337092689740270186AtMost @ A @ L @ M ) @ ( set_or5935395276787703475ssThan @ A @ M @ U ) )
              = ( set_or7035219750837199246ssThan @ A @ L @ U ) ) ) ) ) ).

% ivl_disj_un_two(4)
thf(fact_5682_ivl__disj__un__singleton_I3_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L: A,U: A] :
          ( ( ord_less @ A @ L @ U )
         => ( ( sup_sup @ ( set @ A ) @ ( insert @ A @ L @ ( bot_bot @ ( set @ A ) ) ) @ ( set_or5935395276787703475ssThan @ A @ L @ U ) )
            = ( set_or7035219750837199246ssThan @ A @ L @ U ) ) ) ) ).

% ivl_disj_un_singleton(3)
thf(fact_5683_has__derivative__power,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V3459762299906320749_field @ B ) )
     => ! [F2: A > B,F5: A > B,X: A,S: set @ A,N: nat] :
          ( ( has_derivative @ A @ B @ F2 @ F5 @ ( topolo174197925503356063within @ A @ X @ S ) )
         => ( has_derivative @ A @ B
            @ ^ [X2: A] : ( power_power @ B @ ( F2 @ X2 ) @ N )
            @ ^ [Y4: A] : ( times_times @ B @ ( times_times @ B @ ( semiring_1_of_nat @ B @ N ) @ ( F5 @ Y4 ) ) @ ( power_power @ B @ ( F2 @ X ) @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) ) )
            @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ).

% has_derivative_power
thf(fact_5684_has__derivative__ln,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [G: A > real,X: A,G4: A > real,S2: set @ A] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ ( G @ X ) )
         => ( ( has_derivative @ A @ real @ G @ G4 @ ( topolo174197925503356063within @ A @ X @ S2 ) )
           => ( has_derivative @ A @ real
              @ ^ [X2: A] : ( ln_ln @ real @ ( G @ X2 ) )
              @ ^ [X2: A] : ( times_times @ real @ ( G4 @ X2 ) @ ( inverse_inverse @ real @ ( G @ X ) ) )
              @ ( topolo174197925503356063within @ A @ X @ S2 ) ) ) ) ) ).

% has_derivative_ln
thf(fact_5685_has__derivative__divide,axiom,
    ! [A: $tType,C: $tType] :
      ( ( ( real_V822414075346904944vector @ C )
        & ( real_V8999393235501362500lgebra @ A ) )
     => ! [F2: C > A,F5: C > A,X: C,S: set @ C,G: C > A,G4: C > A] :
          ( ( has_derivative @ C @ A @ F2 @ F5 @ ( topolo174197925503356063within @ C @ X @ S ) )
         => ( ( has_derivative @ C @ A @ G @ G4 @ ( topolo174197925503356063within @ C @ X @ S ) )
           => ( ( ( G @ X )
               != ( zero_zero @ A ) )
             => ( has_derivative @ C @ A
                @ ^ [X2: C] : ( divide_divide @ A @ ( F2 @ X2 ) @ ( G @ X2 ) )
                @ ^ [H: C] : ( plus_plus @ A @ ( times_times @ A @ ( uminus_uminus @ A @ ( F2 @ X ) ) @ ( times_times @ A @ ( times_times @ A @ ( inverse_inverse @ A @ ( G @ X ) ) @ ( G4 @ H ) ) @ ( inverse_inverse @ A @ ( G @ X ) ) ) ) @ ( divide_divide @ A @ ( F5 @ H ) @ ( G @ X ) ) )
                @ ( topolo174197925503356063within @ C @ X @ S ) ) ) ) ) ) ).

% has_derivative_divide
thf(fact_5686_has__derivative__powr,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [G: A > real,G4: A > real,X: A,X7: set @ A,F2: A > real,F5: A > real] :
          ( ( has_derivative @ A @ real @ G @ G4 @ ( topolo174197925503356063within @ A @ X @ X7 ) )
         => ( ( has_derivative @ A @ real @ F2 @ F5 @ ( topolo174197925503356063within @ A @ X @ X7 ) )
           => ( ( ord_less @ real @ ( zero_zero @ real ) @ ( G @ X ) )
             => ( ( member @ A @ X @ X7 )
               => ( has_derivative @ A @ real
                  @ ^ [X2: A] : ( powr @ real @ ( G @ X2 ) @ ( F2 @ X2 ) )
                  @ ^ [H: A] : ( times_times @ real @ ( powr @ real @ ( G @ X ) @ ( F2 @ X ) ) @ ( plus_plus @ real @ ( times_times @ real @ ( F5 @ H ) @ ( ln_ln @ real @ ( G @ X ) ) ) @ ( divide_divide @ real @ ( times_times @ real @ ( G4 @ H ) @ ( F2 @ X ) ) @ ( G @ X ) ) ) )
                  @ ( topolo174197925503356063within @ A @ X @ X7 ) ) ) ) ) ) ) ).

% has_derivative_powr
thf(fact_5687_has__derivative__real__sqrt,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [G: A > real,X: A,G4: A > real,S2: set @ A] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ ( G @ X ) )
         => ( ( has_derivative @ A @ real @ G @ G4 @ ( topolo174197925503356063within @ A @ X @ S2 ) )
           => ( has_derivative @ A @ real
              @ ^ [X2: A] : ( sqrt @ ( G @ X2 ) )
              @ ^ [X2: A] : ( times_times @ real @ ( G4 @ X2 ) @ ( divide_divide @ real @ ( inverse_inverse @ real @ ( sqrt @ ( G @ X ) ) ) @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
              @ ( topolo174197925503356063within @ A @ X @ S2 ) ) ) ) ) ).

% has_derivative_real_sqrt
thf(fact_5688_has__derivative__arctan,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [G: A > real,G4: A > real,X: A,S2: set @ A] :
          ( ( has_derivative @ A @ real @ G @ G4 @ ( topolo174197925503356063within @ A @ X @ S2 ) )
         => ( has_derivative @ A @ real
            @ ^ [X2: A] : ( arctan @ ( G @ X2 ) )
            @ ^ [X2: A] : ( times_times @ real @ ( G4 @ X2 ) @ ( inverse_inverse @ real @ ( plus_plus @ real @ ( one_one @ real ) @ ( power_power @ real @ ( G @ X ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
            @ ( topolo174197925503356063within @ A @ X @ S2 ) ) ) ) ).

% has_derivative_arctan
thf(fact_5689_has__derivative__tan,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [G: A > real,X: A,G4: A > real,S2: set @ A] :
          ( ( ( cos @ real @ ( G @ X ) )
           != ( zero_zero @ real ) )
         => ( ( has_derivative @ A @ real @ G @ G4 @ ( topolo174197925503356063within @ A @ X @ S2 ) )
           => ( has_derivative @ A @ real
              @ ^ [X2: A] : ( tan @ real @ ( G @ X2 ) )
              @ ^ [X2: A] : ( times_times @ real @ ( G4 @ X2 ) @ ( inverse_inverse @ real @ ( power_power @ real @ ( cos @ real @ ( G @ X ) ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
              @ ( topolo174197925503356063within @ A @ X @ S2 ) ) ) ) ) ).

% has_derivative_tan
thf(fact_5690_DERIV__series_H,axiom,
    ! [F2: real > nat > real,F5: real > nat > real,X0: real,A2: real,B2: real,L5: nat > real] :
      ( ! [N2: nat] :
          ( has_field_derivative @ real
          @ ^ [X2: real] : ( F2 @ X2 @ N2 )
          @ ( F5 @ X0 @ N2 )
          @ ( topolo174197925503356063within @ real @ X0 @ ( top_top @ ( set @ real ) ) ) )
     => ( ! [X3: real] :
            ( ( member @ real @ X3 @ ( set_or5935395276787703475ssThan @ real @ A2 @ B2 ) )
           => ( summable @ real @ ( F2 @ X3 ) ) )
       => ( ( member @ real @ X0 @ ( set_or5935395276787703475ssThan @ real @ A2 @ B2 ) )
         => ( ( summable @ real @ ( F5 @ X0 ) )
           => ( ( summable @ real @ L5 )
             => ( ! [N2: nat,X3: real,Y5: real] :
                    ( ( member @ real @ X3 @ ( set_or5935395276787703475ssThan @ real @ A2 @ B2 ) )
                   => ( ( member @ real @ Y5 @ ( set_or5935395276787703475ssThan @ real @ A2 @ B2 ) )
                     => ( ord_less_eq @ real @ ( abs_abs @ real @ ( minus_minus @ real @ ( F2 @ X3 @ N2 ) @ ( F2 @ Y5 @ N2 ) ) ) @ ( times_times @ real @ ( L5 @ N2 ) @ ( abs_abs @ real @ ( minus_minus @ real @ X3 @ Y5 ) ) ) ) ) )
               => ( has_field_derivative @ real
                  @ ^ [X2: real] : ( suminf @ real @ ( F2 @ X2 ) )
                  @ ( suminf @ real @ ( F5 @ X0 ) )
                  @ ( topolo174197925503356063within @ real @ X0 @ ( top_top @ ( set @ real ) ) ) ) ) ) ) ) ) ) ).

% DERIV_series'
thf(fact_5691_UNIV__char__of__nat,axiom,
    ( ( top_top @ ( set @ char ) )
    = ( image @ nat @ char @ ( unique5772411509450598832har_of @ nat ) @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( numeral_numeral @ nat @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ) ) ).

% UNIV_char_of_nat
thf(fact_5692_char__of__mod__256,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [N: A] :
          ( ( unique5772411509450598832har_of @ A @ ( modulo_modulo @ A @ N @ ( numeral_numeral @ A @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) )
          = ( unique5772411509450598832har_of @ A @ N ) ) ) ).

% char_of_mod_256
thf(fact_5693_char__of__quasi__inj,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [M: A,N: A] :
          ( ( ( unique5772411509450598832har_of @ A @ M )
            = ( unique5772411509450598832har_of @ A @ N ) )
          = ( ( modulo_modulo @ A @ M @ ( numeral_numeral @ A @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) )
            = ( modulo_modulo @ A @ N @ ( numeral_numeral @ A @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ) ) ) ).

% char_of_quasi_inj
thf(fact_5694_char__of__nat,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [N: nat] :
          ( ( unique5772411509450598832har_of @ A @ ( semiring_1_of_nat @ A @ N ) )
          = ( unique5772411509450598832har_of @ nat @ N ) ) ) ).

% char_of_nat
thf(fact_5695_char__of__take__bit__eq,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [N: nat,M: A] :
          ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ ( bit0 @ ( bit0 @ one2 ) ) ) ) @ N )
         => ( ( unique5772411509450598832har_of @ A @ ( bit_se2584673776208193580ke_bit @ A @ N @ M ) )
            = ( unique5772411509450598832har_of @ A @ M ) ) ) ) ).

% char_of_take_bit_eq
thf(fact_5696_of__char__of,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [A2: A] :
          ( ( comm_s6883823935334413003f_char @ A @ ( unique5772411509450598832har_of @ A @ A2 ) )
          = ( modulo_modulo @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ) ) ).

% of_char_of
thf(fact_5697_char__of__def,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ( ( unique5772411509450598832har_of @ A )
        = ( ^ [N3: A] :
              ( char2
              @ ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N3 )
              @ ( bit_se5641148757651400278ts_bit @ A @ N3 @ ( one_one @ nat ) )
              @ ( bit_se5641148757651400278ts_bit @ A @ N3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
              @ ( bit_se5641148757651400278ts_bit @ A @ N3 @ ( numeral_numeral @ nat @ ( bit1 @ one2 ) ) )
              @ ( bit_se5641148757651400278ts_bit @ A @ N3 @ ( numeral_numeral @ nat @ ( bit0 @ ( bit0 @ one2 ) ) ) )
              @ ( bit_se5641148757651400278ts_bit @ A @ N3 @ ( numeral_numeral @ nat @ ( bit1 @ ( bit0 @ one2 ) ) ) )
              @ ( bit_se5641148757651400278ts_bit @ A @ N3 @ ( numeral_numeral @ nat @ ( bit0 @ ( bit1 @ one2 ) ) ) )
              @ ( bit_se5641148757651400278ts_bit @ A @ N3 @ ( numeral_numeral @ nat @ ( bit1 @ ( bit1 @ one2 ) ) ) ) ) ) ) ) ).

% char_of_def
thf(fact_5698_has__derivative__floor,axiom,
    ! [Aa: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( archim2362893244070406136eiling @ Aa )
        & ( topolo2564578578187576103pology @ Aa ) )
     => ! [G: A > real,X: A,F2: real > Aa,G4: A > real,S2: set @ A] :
          ( ( topolo3448309680560233919inuous @ real @ Aa @ ( topolo174197925503356063within @ real @ ( G @ X ) @ ( top_top @ ( set @ real ) ) ) @ F2 )
         => ( ~ ( member @ Aa @ ( F2 @ ( G @ X ) ) @ ( ring_1_Ints @ Aa ) )
           => ( ( has_derivative @ A @ real @ G @ G4 @ ( topolo174197925503356063within @ A @ X @ S2 ) )
             => ( has_derivative @ A @ real
                @ ^ [X2: A] : ( ring_1_of_int @ real @ ( archim6421214686448440834_floor @ Aa @ ( F2 @ ( G @ X2 ) ) ) )
                @ ^ [X2: A] : ( times_times @ real @ ( G4 @ X2 ) @ ( zero_zero @ real ) )
                @ ( topolo174197925503356063within @ A @ X @ S2 ) ) ) ) ) ) ).

% has_derivative_floor
thf(fact_5699_of__char__mod__256,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [C2: char] :
          ( ( modulo_modulo @ A @ ( comm_s6883823935334413003f_char @ A @ C2 ) @ ( numeral_numeral @ A @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) )
          = ( comm_s6883823935334413003f_char @ A @ C2 ) ) ) ).

% of_char_mod_256
thf(fact_5700_char_Osize_I2_J,axiom,
    ! [X15: $o,X22: $o,X32: $o,X42: $o,X52: $o,X62: $o,X72: $o,X82: $o] :
      ( ( size_size @ char @ ( char2 @ X15 @ X22 @ X32 @ X42 @ X52 @ X62 @ X72 @ X82 ) )
      = ( zero_zero @ nat ) ) ).

% char.size(2)
thf(fact_5701_continuous__max,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topological_t2_space @ A )
        & ( topolo1944317154257567458pology @ B ) )
     => ! [F4: filter @ A,F2: A > B,G: A > B] :
          ( ( topolo3448309680560233919inuous @ A @ B @ F4 @ F2 )
         => ( ( topolo3448309680560233919inuous @ A @ B @ F4 @ G )
           => ( topolo3448309680560233919inuous @ A @ B @ F4
              @ ^ [X2: A] : ( ord_max @ B @ ( F2 @ X2 ) @ ( G @ X2 ) ) ) ) ) ) ).

% continuous_max
thf(fact_5702_continuous__power_H,axiom,
    ! [B: $tType,C: $tType] :
      ( ( ( topological_t2_space @ C )
        & ( topolo1898628316856586783d_mult @ B ) )
     => ! [F4: filter @ C,F2: C > B,G: C > nat] :
          ( ( topolo3448309680560233919inuous @ C @ B @ F4 @ F2 )
         => ( ( topolo3448309680560233919inuous @ C @ nat @ F4 @ G )
           => ( topolo3448309680560233919inuous @ C @ B @ F4
              @ ^ [X2: C] : ( power_power @ B @ ( F2 @ X2 ) @ ( G @ X2 ) ) ) ) ) ) ).

% continuous_power'
thf(fact_5703_continuous__power,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topological_t2_space @ A )
        & ( power @ B )
        & ( real_V4412858255891104859lgebra @ B ) )
     => ! [F4: filter @ A,F2: A > B,N: nat] :
          ( ( topolo3448309680560233919inuous @ A @ B @ F4 @ F2 )
         => ( topolo3448309680560233919inuous @ A @ B @ F4
            @ ^ [X2: A] : ( power_power @ B @ ( F2 @ X2 ) @ N ) ) ) ) ).

% continuous_power
thf(fact_5704_IVT,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( topolo1944317154257567458pology @ B )
        & ( topolo8458572112393995274pology @ A ) )
     => ! [F2: A > B,A2: A,Y: B,B2: A] :
          ( ( ord_less_eq @ B @ ( F2 @ A2 ) @ Y )
         => ( ( ord_less_eq @ B @ Y @ ( F2 @ B2 ) )
           => ( ( ord_less_eq @ A @ A2 @ B2 )
             => ( ! [X3: A] :
                    ( ( ( ord_less_eq @ A @ A2 @ X3 )
                      & ( ord_less_eq @ A @ X3 @ B2 ) )
                   => ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ X3 @ ( top_top @ ( set @ A ) ) ) @ F2 ) )
               => ? [X3: A] :
                    ( ( ord_less_eq @ A @ A2 @ X3 )
                    & ( ord_less_eq @ A @ X3 @ B2 )
                    & ( ( F2 @ X3 )
                      = Y ) ) ) ) ) ) ) ).

% IVT
thf(fact_5705_IVT2,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( topolo1944317154257567458pology @ B )
        & ( topolo8458572112393995274pology @ A ) )
     => ! [F2: A > B,B2: A,Y: B,A2: A] :
          ( ( ord_less_eq @ B @ ( F2 @ B2 ) @ Y )
         => ( ( ord_less_eq @ B @ Y @ ( F2 @ A2 ) )
           => ( ( ord_less_eq @ A @ A2 @ B2 )
             => ( ! [X3: A] :
                    ( ( ( ord_less_eq @ A @ A2 @ X3 )
                      & ( ord_less_eq @ A @ X3 @ B2 ) )
                   => ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ X3 @ ( top_top @ ( set @ A ) ) ) @ F2 ) )
               => ? [X3: A] :
                    ( ( ord_less_eq @ A @ A2 @ X3 )
                    & ( ord_less_eq @ A @ X3 @ B2 )
                    & ( ( F2 @ X3 )
                      = Y ) ) ) ) ) ) ) ).

% IVT2
thf(fact_5706_isCont__Lb__Ub,axiom,
    ! [A2: real,B2: real,F2: real > real] :
      ( ( ord_less_eq @ real @ A2 @ B2 )
     => ( ! [X3: real] :
            ( ( ( ord_less_eq @ real @ A2 @ X3 )
              & ( ord_less_eq @ real @ X3 @ B2 ) )
           => ( topolo3448309680560233919inuous @ real @ real @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) @ F2 ) )
       => ? [L6: real,M10: real] :
            ( ! [X5: real] :
                ( ( ( ord_less_eq @ real @ A2 @ X5 )
                  & ( ord_less_eq @ real @ X5 @ B2 ) )
               => ( ( ord_less_eq @ real @ L6 @ ( F2 @ X5 ) )
                  & ( ord_less_eq @ real @ ( F2 @ X5 ) @ M10 ) ) )
            & ! [Y6: real] :
                ( ( ( ord_less_eq @ real @ L6 @ Y6 )
                  & ( ord_less_eq @ real @ Y6 @ M10 ) )
               => ? [X3: real] :
                    ( ( ord_less_eq @ real @ A2 @ X3 )
                    & ( ord_less_eq @ real @ X3 @ B2 )
                    & ( ( F2 @ X3 )
                      = Y6 ) ) ) ) ) ) ).

% isCont_Lb_Ub
thf(fact_5707_isCont__real__sqrt,axiom,
    ! [X: real] : ( topolo3448309680560233919inuous @ real @ real @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) @ sqrt ) ).

% isCont_real_sqrt
thf(fact_5708_isCont__real__root,axiom,
    ! [X: real,N: nat] : ( topolo3448309680560233919inuous @ real @ real @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) @ ( root @ N ) ) ).

% isCont_real_root
thf(fact_5709_continuous__at__within__divide,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topological_t2_space @ A )
        & ( real_V3459762299906320749_field @ B ) )
     => ! [A2: A,S2: set @ A,F2: A > B,G: A > B] :
          ( ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ S2 ) @ F2 )
         => ( ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ S2 ) @ G )
           => ( ( ( G @ A2 )
               != ( zero_zero @ B ) )
             => ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ S2 )
                @ ^ [X2: A] : ( divide_divide @ B @ ( F2 @ X2 ) @ ( G @ X2 ) ) ) ) ) ) ) ).

% continuous_at_within_divide
thf(fact_5710_isCont__power,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topological_t2_space @ A )
        & ( power @ B )
        & ( real_V4412858255891104859lgebra @ B ) )
     => ! [A2: A,F2: A > B,N: nat] :
          ( ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) @ F2 )
         => ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) )
            @ ^ [X2: A] : ( power_power @ B @ ( F2 @ X2 ) @ N ) ) ) ) ).

% isCont_power
thf(fact_5711_continuous__at__within__inverse,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topological_t2_space @ A )
        & ( real_V8999393235501362500lgebra @ B ) )
     => ! [A2: A,S2: set @ A,F2: A > B] :
          ( ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ S2 ) @ F2 )
         => ( ( ( F2 @ A2 )
             != ( zero_zero @ B ) )
           => ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ S2 )
              @ ^ [X2: A] : ( inverse_inverse @ B @ ( F2 @ X2 ) ) ) ) ) ) ).

% continuous_at_within_inverse
thf(fact_5712_continuous__at__within__sgn,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topological_t2_space @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [A2: A,S2: set @ A,F2: A > B] :
          ( ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ S2 ) @ F2 )
         => ( ( ( F2 @ A2 )
             != ( zero_zero @ B ) )
           => ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ S2 )
              @ ^ [X2: A] : ( sgn_sgn @ B @ ( F2 @ X2 ) ) ) ) ) ) ).

% continuous_at_within_sgn
thf(fact_5713_isCont__eq__Lb,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [A2: real,B2: real,F2: real > A] :
          ( ( ord_less_eq @ real @ A2 @ B2 )
         => ( ! [X3: real] :
                ( ( ( ord_less_eq @ real @ A2 @ X3 )
                  & ( ord_less_eq @ real @ X3 @ B2 ) )
               => ( topolo3448309680560233919inuous @ real @ A @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) @ F2 ) )
           => ? [M10: A] :
                ( ! [X5: real] :
                    ( ( ( ord_less_eq @ real @ A2 @ X5 )
                      & ( ord_less_eq @ real @ X5 @ B2 ) )
                   => ( ord_less_eq @ A @ M10 @ ( F2 @ X5 ) ) )
                & ? [X3: real] :
                    ( ( ord_less_eq @ real @ A2 @ X3 )
                    & ( ord_less_eq @ real @ X3 @ B2 )
                    & ( ( F2 @ X3 )
                      = M10 ) ) ) ) ) ) ).

% isCont_eq_Lb
thf(fact_5714_isCont__eq__Ub,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [A2: real,B2: real,F2: real > A] :
          ( ( ord_less_eq @ real @ A2 @ B2 )
         => ( ! [X3: real] :
                ( ( ( ord_less_eq @ real @ A2 @ X3 )
                  & ( ord_less_eq @ real @ X3 @ B2 ) )
               => ( topolo3448309680560233919inuous @ real @ A @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) @ F2 ) )
           => ? [M10: A] :
                ( ! [X5: real] :
                    ( ( ( ord_less_eq @ real @ A2 @ X5 )
                      & ( ord_less_eq @ real @ X5 @ B2 ) )
                   => ( ord_less_eq @ A @ ( F2 @ X5 ) @ M10 ) )
                & ? [X3: real] :
                    ( ( ord_less_eq @ real @ A2 @ X3 )
                    & ( ord_less_eq @ real @ X3 @ B2 )
                    & ( ( F2 @ X3 )
                      = M10 ) ) ) ) ) ) ).

% isCont_eq_Ub
thf(fact_5715_isCont__bounded,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [A2: real,B2: real,F2: real > A] :
          ( ( ord_less_eq @ real @ A2 @ B2 )
         => ( ! [X3: real] :
                ( ( ( ord_less_eq @ real @ A2 @ X3 )
                  & ( ord_less_eq @ real @ X3 @ B2 ) )
               => ( topolo3448309680560233919inuous @ real @ A @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) @ F2 ) )
           => ? [M10: A] :
              ! [X5: real] :
                ( ( ( ord_less_eq @ real @ A2 @ X5 )
                  & ( ord_less_eq @ real @ X5 @ B2 ) )
               => ( ord_less_eq @ A @ ( F2 @ X5 ) @ M10 ) ) ) ) ) ).

% isCont_bounded
thf(fact_5716_isCont__inverse__function2,axiom,
    ! [A2: real,X: real,B2: real,G: real > real,F2: real > real] :
      ( ( ord_less @ real @ A2 @ X )
     => ( ( ord_less @ real @ X @ B2 )
       => ( ! [Z3: real] :
              ( ( ord_less_eq @ real @ A2 @ Z3 )
             => ( ( ord_less_eq @ real @ Z3 @ B2 )
               => ( ( G @ ( F2 @ Z3 ) )
                  = Z3 ) ) )
         => ( ! [Z3: real] :
                ( ( ord_less_eq @ real @ A2 @ Z3 )
               => ( ( ord_less_eq @ real @ Z3 @ B2 )
                 => ( topolo3448309680560233919inuous @ real @ real @ ( topolo174197925503356063within @ real @ Z3 @ ( top_top @ ( set @ real ) ) ) @ F2 ) ) )
           => ( topolo3448309680560233919inuous @ real @ real @ ( topolo174197925503356063within @ real @ ( F2 @ X ) @ ( top_top @ ( set @ real ) ) ) @ G ) ) ) ) ) ).

% isCont_inverse_function2
thf(fact_5717_isCont__ln,axiom,
    ! [X: real] :
      ( ( X
       != ( zero_zero @ real ) )
     => ( topolo3448309680560233919inuous @ real @ real @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) @ ( ln_ln @ real ) ) ) ).

% isCont_ln
thf(fact_5718_isCont__divide,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topological_t2_space @ A )
        & ( real_V3459762299906320749_field @ B ) )
     => ! [A2: A,F2: A > B,G: A > B] :
          ( ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) @ F2 )
         => ( ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) @ G )
           => ( ( ( G @ A2 )
               != ( zero_zero @ B ) )
             => ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) )
                @ ^ [X2: A] : ( divide_divide @ B @ ( F2 @ X2 ) @ ( G @ X2 ) ) ) ) ) ) ) ).

% isCont_divide
thf(fact_5719_isCont__sgn,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topological_t2_space @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [A2: A,F2: A > B] :
          ( ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) @ F2 )
         => ( ( ( F2 @ A2 )
             != ( zero_zero @ B ) )
           => ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) )
              @ ^ [X2: A] : ( sgn_sgn @ B @ ( F2 @ X2 ) ) ) ) ) ) ).

% isCont_sgn
thf(fact_5720_continuous__within__tan,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A,S2: set @ A,F2: A > A] :
          ( ( topolo3448309680560233919inuous @ A @ A @ ( topolo174197925503356063within @ A @ X @ S2 ) @ F2 )
         => ( ( ( cos @ A @ ( F2 @ X ) )
             != ( zero_zero @ A ) )
           => ( topolo3448309680560233919inuous @ A @ A @ ( topolo174197925503356063within @ A @ X @ S2 )
              @ ^ [X2: A] : ( tan @ A @ ( F2 @ X2 ) ) ) ) ) ) ).

% continuous_within_tan
thf(fact_5721_continuous__within__cot,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A,S2: set @ A,F2: A > A] :
          ( ( topolo3448309680560233919inuous @ A @ A @ ( topolo174197925503356063within @ A @ X @ S2 ) @ F2 )
         => ( ( ( sin @ A @ ( F2 @ X ) )
             != ( zero_zero @ A ) )
           => ( topolo3448309680560233919inuous @ A @ A @ ( topolo174197925503356063within @ A @ X @ S2 )
              @ ^ [X2: A] : ( cot @ A @ ( F2 @ X2 ) ) ) ) ) ) ).

% continuous_within_cot
thf(fact_5722_continuous__at__within__tanh,axiom,
    ! [A: $tType,C: $tType] :
      ( ( ( topological_t2_space @ C )
        & ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: C,A4: set @ C,F2: C > A] :
          ( ( topolo3448309680560233919inuous @ C @ A @ ( topolo174197925503356063within @ C @ X @ A4 ) @ F2 )
         => ( ( ( cosh @ A @ ( F2 @ X ) )
             != ( zero_zero @ A ) )
           => ( topolo3448309680560233919inuous @ C @ A @ ( topolo174197925503356063within @ C @ X @ A4 )
              @ ^ [X2: C] : ( tanh @ A @ ( F2 @ X2 ) ) ) ) ) ) ).

% continuous_at_within_tanh
thf(fact_5723_nat__of__char__less__256,axiom,
    ! [C2: char] : ( ord_less @ nat @ ( comm_s6883823935334413003f_char @ nat @ C2 ) @ ( numeral_numeral @ nat @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ).

% nat_of_char_less_256
thf(fact_5724_isCont__has__Ub,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [A2: real,B2: real,F2: real > A] :
          ( ( ord_less_eq @ real @ A2 @ B2 )
         => ( ! [X3: real] :
                ( ( ( ord_less_eq @ real @ A2 @ X3 )
                  & ( ord_less_eq @ real @ X3 @ B2 ) )
               => ( topolo3448309680560233919inuous @ real @ A @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) @ F2 ) )
           => ? [M10: A] :
                ( ! [X5: real] :
                    ( ( ( ord_less_eq @ real @ A2 @ X5 )
                      & ( ord_less_eq @ real @ X5 @ B2 ) )
                   => ( ord_less_eq @ A @ ( F2 @ X5 ) @ M10 ) )
                & ! [N8: A] :
                    ( ( ord_less @ A @ N8 @ M10 )
                   => ? [X3: real] :
                        ( ( ord_less_eq @ real @ A2 @ X3 )
                        & ( ord_less_eq @ real @ X3 @ B2 )
                        & ( ord_less @ A @ N8 @ ( F2 @ X3 ) ) ) ) ) ) ) ) ).

% isCont_has_Ub
thf(fact_5725_isCont__tan,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A] :
          ( ( ( cos @ A @ X )
           != ( zero_zero @ A ) )
         => ( topolo3448309680560233919inuous @ A @ A @ ( topolo174197925503356063within @ A @ X @ ( top_top @ ( set @ A ) ) ) @ ( tan @ A ) ) ) ) ).

% isCont_tan
thf(fact_5726_isCont__cot,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A] :
          ( ( ( sin @ A @ X )
           != ( zero_zero @ A ) )
         => ( topolo3448309680560233919inuous @ A @ A @ ( topolo174197925503356063within @ A @ X @ ( top_top @ ( set @ A ) ) ) @ ( cot @ A ) ) ) ) ).

% isCont_cot
thf(fact_5727_isCont__tanh,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A] :
          ( ( ( cosh @ A @ X )
           != ( zero_zero @ A ) )
         => ( topolo3448309680560233919inuous @ A @ A @ ( topolo174197925503356063within @ A @ X @ ( top_top @ ( set @ A ) ) ) @ ( tanh @ A ) ) ) ) ).

% isCont_tanh
thf(fact_5728_isCont__tan_H,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [A2: A,F2: A > A] :
          ( ( topolo3448309680560233919inuous @ A @ A @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) @ F2 )
         => ( ( ( cos @ A @ ( F2 @ A2 ) )
             != ( zero_zero @ A ) )
           => ( topolo3448309680560233919inuous @ A @ A @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) )
              @ ^ [X2: A] : ( tan @ A @ ( F2 @ X2 ) ) ) ) ) ) ).

% isCont_tan'
thf(fact_5729_isCont__arcosh,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ X )
     => ( topolo3448309680560233919inuous @ real @ real @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) @ ( arcosh @ real ) ) ) ).

% isCont_arcosh
thf(fact_5730_isCont__cot_H,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [A2: A,F2: A > A] :
          ( ( topolo3448309680560233919inuous @ A @ A @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) @ F2 )
         => ( ( ( sin @ A @ ( F2 @ A2 ) )
             != ( zero_zero @ A ) )
           => ( topolo3448309680560233919inuous @ A @ A @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) )
              @ ^ [X2: A] : ( cot @ A @ ( F2 @ X2 ) ) ) ) ) ) ).

% isCont_cot'
thf(fact_5731_DERIV__inverse__function,axiom,
    ! [F2: real > real,D5: real,G: real > real,X: real,A2: real,B2: real] :
      ( ( has_field_derivative @ real @ F2 @ D5 @ ( topolo174197925503356063within @ real @ ( G @ X ) @ ( top_top @ ( set @ real ) ) ) )
     => ( ( D5
         != ( zero_zero @ real ) )
       => ( ( ord_less @ real @ A2 @ X )
         => ( ( ord_less @ real @ X @ B2 )
           => ( ! [Y5: real] :
                  ( ( ord_less @ real @ A2 @ Y5 )
                 => ( ( ord_less @ real @ Y5 @ B2 )
                   => ( ( F2 @ ( G @ Y5 ) )
                      = Y5 ) ) )
             => ( ( topolo3448309680560233919inuous @ real @ real @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) @ G )
               => ( has_field_derivative @ real @ G @ ( inverse_inverse @ real @ D5 ) @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) ) ) ) ) ) ) ) ).

% DERIV_inverse_function
thf(fact_5732_isCont__polynom,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [A2: A,C2: nat > A,N: nat] :
          ( topolo3448309680560233919inuous @ A @ A @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) )
          @ ^ [W3: A] :
              ( groups7311177749621191930dd_sum @ nat @ A
              @ ^ [I4: nat] : ( times_times @ A @ ( C2 @ I4 ) @ ( power_power @ A @ W3 @ I4 ) )
              @ ( set_ord_atMost @ nat @ N ) ) ) ) ).

% isCont_polynom
thf(fact_5733_isCont__arccos,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ X )
     => ( ( ord_less @ real @ X @ ( one_one @ real ) )
       => ( topolo3448309680560233919inuous @ real @ real @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) @ arccos ) ) ) ).

% isCont_arccos
thf(fact_5734_isCont__arcsin,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ X )
     => ( ( ord_less @ real @ X @ ( one_one @ real ) )
       => ( topolo3448309680560233919inuous @ real @ real @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) @ arcsin ) ) ) ).

% isCont_arcsin
thf(fact_5735_isCont__powser__converges__everywhere,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [C2: nat > A,X: A] :
          ( ! [Y5: A] :
              ( summable @ A
              @ ^ [N3: nat] : ( times_times @ A @ ( C2 @ N3 ) @ ( power_power @ A @ Y5 @ N3 ) ) )
         => ( topolo3448309680560233919inuous @ A @ A @ ( topolo174197925503356063within @ A @ X @ ( top_top @ ( set @ A ) ) )
            @ ^ [X2: A] :
                ( suminf @ A
                @ ^ [N3: nat] : ( times_times @ A @ ( C2 @ N3 ) @ ( power_power @ A @ X2 @ N3 ) ) ) ) ) ) ).

% isCont_powser_converges_everywhere
thf(fact_5736_LIM__less__bound,axiom,
    ! [B2: real,X: real,F2: real > real] :
      ( ( ord_less @ real @ B2 @ X )
     => ( ! [X3: real] :
            ( ( member @ real @ X3 @ ( set_or5935395276787703475ssThan @ real @ B2 @ X ) )
           => ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( F2 @ X3 ) ) )
       => ( ( topolo3448309680560233919inuous @ real @ real @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) @ F2 )
         => ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( F2 @ X ) ) ) ) ) ).

% LIM_less_bound
thf(fact_5737_isCont__artanh,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ X )
     => ( ( ord_less @ real @ X @ ( one_one @ real ) )
       => ( topolo3448309680560233919inuous @ real @ real @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) @ ( artanh @ real ) ) ) ) ).

% isCont_artanh
thf(fact_5738_isCont__inverse__function,axiom,
    ! [D2: real,X: real,G: real > real,F2: real > real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ D2 )
     => ( ! [Z3: real] :
            ( ( ord_less_eq @ real @ ( abs_abs @ real @ ( minus_minus @ real @ Z3 @ X ) ) @ D2 )
           => ( ( G @ ( F2 @ Z3 ) )
              = Z3 ) )
       => ( ! [Z3: real] :
              ( ( ord_less_eq @ real @ ( abs_abs @ real @ ( minus_minus @ real @ Z3 @ X ) ) @ D2 )
             => ( topolo3448309680560233919inuous @ real @ real @ ( topolo174197925503356063within @ real @ Z3 @ ( top_top @ ( set @ real ) ) ) @ F2 ) )
         => ( topolo3448309680560233919inuous @ real @ real @ ( topolo174197925503356063within @ real @ ( F2 @ X ) @ ( top_top @ ( set @ real ) ) ) @ G ) ) ) ) ).

% isCont_inverse_function
thf(fact_5739_GMVT_H,axiom,
    ! [A2: real,B2: real,F2: real > real,G: real > real,G4: real > real,F5: real > real] :
      ( ( ord_less @ real @ A2 @ B2 )
     => ( ! [Z3: real] :
            ( ( ord_less_eq @ real @ A2 @ Z3 )
           => ( ( ord_less_eq @ real @ Z3 @ B2 )
             => ( topolo3448309680560233919inuous @ real @ real @ ( topolo174197925503356063within @ real @ Z3 @ ( top_top @ ( set @ real ) ) ) @ F2 ) ) )
       => ( ! [Z3: real] :
              ( ( ord_less_eq @ real @ A2 @ Z3 )
             => ( ( ord_less_eq @ real @ Z3 @ B2 )
               => ( topolo3448309680560233919inuous @ real @ real @ ( topolo174197925503356063within @ real @ Z3 @ ( top_top @ ( set @ real ) ) ) @ G ) ) )
         => ( ! [Z3: real] :
                ( ( ord_less @ real @ A2 @ Z3 )
               => ( ( ord_less @ real @ Z3 @ B2 )
                 => ( has_field_derivative @ real @ G @ ( G4 @ Z3 ) @ ( topolo174197925503356063within @ real @ Z3 @ ( top_top @ ( set @ real ) ) ) ) ) )
           => ( ! [Z3: real] :
                  ( ( ord_less @ real @ A2 @ Z3 )
                 => ( ( ord_less @ real @ Z3 @ B2 )
                   => ( has_field_derivative @ real @ F2 @ ( F5 @ Z3 ) @ ( topolo174197925503356063within @ real @ Z3 @ ( top_top @ ( set @ real ) ) ) ) ) )
             => ? [C3: real] :
                  ( ( ord_less @ real @ A2 @ C3 )
                  & ( ord_less @ real @ C3 @ B2 )
                  & ( ( times_times @ real @ ( minus_minus @ real @ ( F2 @ B2 ) @ ( F2 @ A2 ) ) @ ( G4 @ C3 ) )
                    = ( times_times @ real @ ( minus_minus @ real @ ( G @ B2 ) @ ( G @ A2 ) ) @ ( F5 @ C3 ) ) ) ) ) ) ) ) ) ).

% GMVT'
thf(fact_5740_floor__has__real__derivative,axiom,
    ! [A: $tType] :
      ( ( ( archim2362893244070406136eiling @ A )
        & ( topolo2564578578187576103pology @ A ) )
     => ! [X: real,F2: real > A] :
          ( ( topolo3448309680560233919inuous @ real @ A @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) @ F2 )
         => ( ~ ( member @ A @ ( F2 @ X ) @ ( ring_1_Ints @ A ) )
           => ( has_field_derivative @ real
              @ ^ [X2: real] : ( ring_1_of_int @ real @ ( archim6421214686448440834_floor @ A @ ( F2 @ X2 ) ) )
              @ ( zero_zero @ real )
              @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) ) ) ) ) ).

% floor_has_real_derivative
thf(fact_5741_range__nat__of__char,axiom,
    ( ( image @ char @ nat @ ( comm_s6883823935334413003f_char @ nat ) @ ( top_top @ ( set @ char ) ) )
    = ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( numeral_numeral @ nat @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ) ).

% range_nat_of_char
thf(fact_5742_isCont__powser,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [C2: nat > A,K6: A,X: A] :
          ( ( summable @ A
            @ ^ [N3: nat] : ( times_times @ A @ ( C2 @ N3 ) @ ( power_power @ A @ K6 @ N3 ) ) )
         => ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ X ) @ ( real_V7770717601297561774m_norm @ A @ K6 ) )
           => ( topolo3448309680560233919inuous @ A @ A @ ( topolo174197925503356063within @ A @ X @ ( top_top @ ( set @ A ) ) )
              @ ^ [X2: A] :
                  ( suminf @ A
                  @ ^ [N3: nat] : ( times_times @ A @ ( C2 @ N3 ) @ ( power_power @ A @ X2 @ N3 ) ) ) ) ) ) ) ).

% isCont_powser
thf(fact_5743_isCont__powser_H,axiom,
    ! [Aa: $tType,A: $tType] :
      ( ( ( topological_t2_space @ A )
        & ( real_Vector_banach @ Aa )
        & ( real_V3459762299906320749_field @ Aa ) )
     => ! [A2: A,F2: A > Aa,C2: nat > Aa,K6: Aa] :
          ( ( topolo3448309680560233919inuous @ A @ Aa @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) @ F2 )
         => ( ( summable @ Aa
              @ ^ [N3: nat] : ( times_times @ Aa @ ( C2 @ N3 ) @ ( power_power @ Aa @ K6 @ N3 ) ) )
           => ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ Aa @ ( F2 @ A2 ) ) @ ( real_V7770717601297561774m_norm @ Aa @ K6 ) )
             => ( topolo3448309680560233919inuous @ A @ Aa @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) )
                @ ^ [X2: A] :
                    ( suminf @ Aa
                    @ ^ [N3: nat] : ( times_times @ Aa @ ( C2 @ N3 ) @ ( power_power @ Aa @ ( F2 @ X2 ) @ N3 ) ) ) ) ) ) ) ) ).

% isCont_powser'
thf(fact_5744_char__of__eq__iff,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [N: A,C2: char] :
          ( ( ( unique5772411509450598832har_of @ A @ N )
            = C2 )
          = ( ( bit_se2584673776208193580ke_bit @ A @ ( numeral_numeral @ nat @ ( bit0 @ ( bit0 @ ( bit0 @ one2 ) ) ) ) @ N )
            = ( comm_s6883823935334413003f_char @ A @ C2 ) ) ) ) ).

% char_of_eq_iff
thf(fact_5745_integer__of__char__code,axiom,
    ! [B0: $o,B1: $o,B22: $o,B32: $o,B42: $o,B52: $o,B62: $o,B72: $o] :
      ( ( integer_of_char @ ( char2 @ B0 @ B1 @ B22 @ B32 @ B42 @ B52 @ B62 @ B72 ) )
      = ( plus_plus @ code_integer @ ( times_times @ code_integer @ ( plus_plus @ code_integer @ ( times_times @ code_integer @ ( plus_plus @ code_integer @ ( times_times @ code_integer @ ( plus_plus @ code_integer @ ( times_times @ code_integer @ ( plus_plus @ code_integer @ ( times_times @ code_integer @ ( plus_plus @ code_integer @ ( times_times @ code_integer @ ( plus_plus @ code_integer @ ( times_times @ code_integer @ ( zero_neq_one_of_bool @ code_integer @ B72 ) @ ( numeral_numeral @ code_integer @ ( bit0 @ one2 ) ) ) @ ( zero_neq_one_of_bool @ code_integer @ B62 ) ) @ ( numeral_numeral @ code_integer @ ( bit0 @ one2 ) ) ) @ ( zero_neq_one_of_bool @ code_integer @ B52 ) ) @ ( numeral_numeral @ code_integer @ ( bit0 @ one2 ) ) ) @ ( zero_neq_one_of_bool @ code_integer @ B42 ) ) @ ( numeral_numeral @ code_integer @ ( bit0 @ one2 ) ) ) @ ( zero_neq_one_of_bool @ code_integer @ B32 ) ) @ ( numeral_numeral @ code_integer @ ( bit0 @ one2 ) ) ) @ ( zero_neq_one_of_bool @ code_integer @ B22 ) ) @ ( numeral_numeral @ code_integer @ ( bit0 @ one2 ) ) ) @ ( zero_neq_one_of_bool @ code_integer @ B1 ) ) @ ( numeral_numeral @ code_integer @ ( bit0 @ one2 ) ) ) @ ( zero_neq_one_of_bool @ code_integer @ B0 ) ) ) ).

% integer_of_char_code
thf(fact_5746_char_Osize__gen,axiom,
    ! [X15: $o,X22: $o,X32: $o,X42: $o,X52: $o,X62: $o,X72: $o,X82: $o] :
      ( ( size_char @ ( char2 @ X15 @ X22 @ X32 @ X42 @ X52 @ X62 @ X72 @ X82 ) )
      = ( zero_zero @ nat ) ) ).

% char.size_gen
thf(fact_5747_termdiffs__aux,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [C2: nat > A,K6: A,X: A] :
          ( ( summable @ A
            @ ^ [N3: nat] : ( times_times @ A @ ( diffs @ A @ ( diffs @ A @ C2 ) @ N3 ) @ ( power_power @ A @ K6 @ N3 ) ) )
         => ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ X ) @ ( real_V7770717601297561774m_norm @ A @ K6 ) )
           => ( filterlim @ A @ A
              @ ^ [H: A] :
                  ( suminf @ A
                  @ ^ [N3: nat] : ( times_times @ A @ ( C2 @ N3 ) @ ( minus_minus @ A @ ( divide_divide @ A @ ( minus_minus @ A @ ( power_power @ A @ ( plus_plus @ A @ X @ H ) @ N3 ) @ ( power_power @ A @ X @ N3 ) ) @ H ) @ ( times_times @ A @ ( semiring_1_of_nat @ A @ N3 ) @ ( power_power @ A @ X @ ( minus_minus @ nat @ N3 @ ( suc @ ( zero_zero @ nat ) ) ) ) ) ) ) )
              @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) )
              @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ).

% termdiffs_aux
thf(fact_5748_tendsto__mult__left__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( field @ A )
        & ( topolo4211221413907600880p_mult @ A ) )
     => ! [C2: A,F2: B > A,L: A,F4: filter @ B] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( filterlim @ B @ A
              @ ^ [X2: B] : ( times_times @ A @ C2 @ ( F2 @ X2 ) )
              @ ( topolo7230453075368039082e_nhds @ A @ ( times_times @ A @ C2 @ L ) )
              @ F4 )
            = ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ L ) @ F4 ) ) ) ) ).

% tendsto_mult_left_iff
thf(fact_5749_tendsto__mult__right__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( field @ A )
        & ( topolo4211221413907600880p_mult @ A ) )
     => ! [C2: A,F2: B > A,L: A,F4: filter @ B] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( filterlim @ B @ A
              @ ^ [X2: B] : ( times_times @ A @ ( F2 @ X2 ) @ C2 )
              @ ( topolo7230453075368039082e_nhds @ A @ ( times_times @ A @ L @ C2 ) )
              @ F4 )
            = ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ L ) @ F4 ) ) ) ) ).

% tendsto_mult_right_iff
thf(fact_5750_power__tendsto__0__iff,axiom,
    ! [A: $tType,N: nat,F2: A > real,F4: filter @ A] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( filterlim @ A @ real
          @ ^ [X2: A] : ( power_power @ real @ ( F2 @ X2 ) @ N )
          @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
          @ F4 )
        = ( filterlim @ A @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ F4 ) ) ) ).

% power_tendsto_0_iff
thf(fact_5751_continuous__real__root,axiom,
    ! [A: $tType] :
      ( ( topological_t2_space @ A )
     => ! [F4: filter @ A,F2: A > real,N: nat] :
          ( ( topolo3448309680560233919inuous @ A @ real @ F4 @ F2 )
         => ( topolo3448309680560233919inuous @ A @ real @ F4
            @ ^ [X2: A] : ( root @ N @ ( F2 @ X2 ) ) ) ) ) ).

% continuous_real_root
thf(fact_5752_continuous__real__sqrt,axiom,
    ! [A: $tType] :
      ( ( topological_t2_space @ A )
     => ! [F4: filter @ A,F2: A > real] :
          ( ( topolo3448309680560233919inuous @ A @ real @ F4 @ F2 )
         => ( topolo3448309680560233919inuous @ A @ real @ F4
            @ ^ [X2: A] : ( sqrt @ ( F2 @ X2 ) ) ) ) ) ).

% continuous_real_sqrt
thf(fact_5753_real__LIM__sandwich__zero,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [F2: A > real,A2: A,G: A > real] :
          ( ( filterlim @ A @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) )
         => ( ! [X3: A] :
                ( ( X3 != A2 )
               => ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( G @ X3 ) ) )
           => ( ! [X3: A] :
                  ( ( X3 != A2 )
                 => ( ord_less_eq @ real @ ( G @ X3 ) @ ( F2 @ X3 ) ) )
             => ( filterlim @ A @ real @ G @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ) ).

% real_LIM_sandwich_zero
thf(fact_5754_LIM__not__zero,axiom,
    ! [Aa: $tType,A: $tType] :
      ( ( ( topolo8386298272705272623_space @ A )
        & ( zero @ Aa )
        & ( topological_t2_space @ Aa ) )
     => ! [K: Aa,A2: A] :
          ( ( K
           != ( zero_zero @ Aa ) )
         => ~ ( filterlim @ A @ Aa
              @ ^ [X2: A] : K
              @ ( topolo7230453075368039082e_nhds @ Aa @ ( zero_zero @ Aa ) )
              @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% LIM_not_zero
thf(fact_5755_LIM__isCont__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( topolo4958980785337419405_space @ B ) )
     => ! [F2: A > B,A2: A] :
          ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ ( F2 @ A2 ) ) @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) )
          = ( filterlim @ A @ B
            @ ^ [H: A] : ( F2 @ ( plus_plus @ A @ A2 @ H ) )
            @ ( topolo7230453075368039082e_nhds @ B @ ( F2 @ A2 ) )
            @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% LIM_isCont_iff
thf(fact_5756_LIM__offset__zero,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( topolo4958980785337419405_space @ B ) )
     => ! [F2: A > B,L5: B,A2: A] :
          ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ L5 ) @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) )
         => ( filterlim @ A @ B
            @ ^ [H: A] : ( F2 @ ( plus_plus @ A @ A2 @ H ) )
            @ ( topolo7230453075368039082e_nhds @ B @ L5 )
            @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% LIM_offset_zero
thf(fact_5757_LIM__offset__zero__cancel,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( topolo4958980785337419405_space @ B ) )
     => ! [F2: A > B,A2: A,L5: B] :
          ( ( filterlim @ A @ B
            @ ^ [H: A] : ( F2 @ ( plus_plus @ A @ A2 @ H ) )
            @ ( topolo7230453075368039082e_nhds @ B @ L5 )
            @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) )
         => ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ L5 ) @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% LIM_offset_zero_cancel
thf(fact_5758_tendsto__log,axiom,
    ! [A: $tType,F2: A > real,A2: real,F4: filter @ A,G: A > real,B2: real] :
      ( ( filterlim @ A @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ A2 ) @ F4 )
     => ( ( filterlim @ A @ real @ G @ ( topolo7230453075368039082e_nhds @ real @ B2 ) @ F4 )
       => ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
         => ( ( A2
             != ( one_one @ real ) )
           => ( ( ord_less @ real @ ( zero_zero @ real ) @ B2 )
             => ( filterlim @ A @ real
                @ ^ [X2: A] : ( log2 @ ( F2 @ X2 ) @ ( G @ X2 ) )
                @ ( topolo7230453075368039082e_nhds @ real @ ( log2 @ A2 @ B2 ) )
                @ F4 ) ) ) ) ) ) ).

% tendsto_log
thf(fact_5759_tendsto__null__power,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V2822296259951069270ebra_1 @ B )
     => ! [F2: A > B,F4: filter @ A,N: nat] :
          ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ ( zero_zero @ B ) ) @ F4 )
         => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
           => ( filterlim @ A @ B
              @ ^ [X2: A] : ( power_power @ B @ ( F2 @ X2 ) @ N )
              @ ( topolo7230453075368039082e_nhds @ B @ ( zero_zero @ B ) )
              @ F4 ) ) ) ) ).

% tendsto_null_power
thf(fact_5760_tendsto__inverse,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [F2: B > A,A2: A,F4: filter @ B] :
          ( ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ A2 ) @ F4 )
         => ( ( A2
             != ( zero_zero @ A ) )
           => ( filterlim @ B @ A
              @ ^ [X2: B] : ( inverse_inverse @ A @ ( F2 @ X2 ) )
              @ ( topolo7230453075368039082e_nhds @ A @ ( inverse_inverse @ A @ A2 ) )
              @ F4 ) ) ) ) ).

% tendsto_inverse
thf(fact_5761_tendsto__cot,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [F2: A > A,A2: A,F4: filter @ A] :
          ( ( filterlim @ A @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ A2 ) @ F4 )
         => ( ( ( sin @ A @ A2 )
             != ( zero_zero @ A ) )
           => ( filterlim @ A @ A
              @ ^ [X2: A] : ( cot @ A @ ( F2 @ X2 ) )
              @ ( topolo7230453075368039082e_nhds @ A @ ( cot @ A @ A2 ) )
              @ F4 ) ) ) ) ).

% tendsto_cot
thf(fact_5762_tendsto__tanh,axiom,
    ! [A: $tType,C: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [F2: C > A,A2: A,F4: filter @ C] :
          ( ( filterlim @ C @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ A2 ) @ F4 )
         => ( ( ( cosh @ A @ A2 )
             != ( zero_zero @ A ) )
           => ( filterlim @ C @ A
              @ ^ [X2: C] : ( tanh @ A @ ( F2 @ X2 ) )
              @ ( topolo7230453075368039082e_nhds @ A @ ( tanh @ A @ A2 ) )
              @ F4 ) ) ) ) ).

% tendsto_tanh
thf(fact_5763_tendsto__ln,axiom,
    ! [A: $tType,F2: A > real,A2: real,F4: filter @ A] :
      ( ( filterlim @ A @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ A2 ) @ F4 )
     => ( ( A2
         != ( zero_zero @ real ) )
       => ( filterlim @ A @ real
          @ ^ [X2: A] : ( ln_ln @ real @ ( F2 @ X2 ) )
          @ ( topolo7230453075368039082e_nhds @ real @ ( ln_ln @ real @ A2 ) )
          @ F4 ) ) ) ).

% tendsto_ln
thf(fact_5764_tendsto__powr,axiom,
    ! [A: $tType,F2: A > real,A2: real,F4: filter @ A,G: A > real,B2: real] :
      ( ( filterlim @ A @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ A2 ) @ F4 )
     => ( ( filterlim @ A @ real @ G @ ( topolo7230453075368039082e_nhds @ real @ B2 ) @ F4 )
       => ( ( A2
           != ( zero_zero @ real ) )
         => ( filterlim @ A @ real
            @ ^ [X2: A] : ( powr @ real @ ( F2 @ X2 ) @ ( G @ X2 ) )
            @ ( topolo7230453075368039082e_nhds @ real @ ( powr @ real @ A2 @ B2 ) )
            @ F4 ) ) ) ) ).

% tendsto_powr
thf(fact_5765_tendsto__norm__zero,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector @ B )
     => ! [F2: A > B,F4: filter @ A] :
          ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ ( zero_zero @ B ) ) @ F4 )
         => ( filterlim @ A @ real
            @ ^ [X2: A] : ( real_V7770717601297561774m_norm @ B @ ( F2 @ X2 ) )
            @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
            @ F4 ) ) ) ).

% tendsto_norm_zero
thf(fact_5766_tendsto__norm__zero__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector @ B )
     => ! [F2: A > B,F4: filter @ A] :
          ( ( filterlim @ A @ real
            @ ^ [X2: A] : ( real_V7770717601297561774m_norm @ B @ ( F2 @ X2 ) )
            @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
            @ F4 )
          = ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ ( zero_zero @ B ) ) @ F4 ) ) ) ).

% tendsto_norm_zero_iff
thf(fact_5767_tendsto__norm__zero__cancel,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector @ B )
     => ! [F2: A > B,F4: filter @ A] :
          ( ( filterlim @ A @ real
            @ ^ [X2: A] : ( real_V7770717601297561774m_norm @ B @ ( F2 @ X2 ) )
            @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
            @ F4 )
         => ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ ( zero_zero @ B ) ) @ F4 ) ) ) ).

% tendsto_norm_zero_cancel
thf(fact_5768_tendsto__tan,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [F2: A > A,A2: A,F4: filter @ A] :
          ( ( filterlim @ A @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ A2 ) @ F4 )
         => ( ( ( cos @ A @ A2 )
             != ( zero_zero @ A ) )
           => ( filterlim @ A @ A
              @ ^ [X2: A] : ( tan @ A @ ( F2 @ X2 ) )
              @ ( topolo7230453075368039082e_nhds @ A @ ( tan @ A @ A2 ) )
              @ F4 ) ) ) ) ).

% tendsto_tan
thf(fact_5769_LIM__zero,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector @ B )
     => ! [F2: A > B,L: B,F4: filter @ A] :
          ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ L ) @ F4 )
         => ( filterlim @ A @ B
            @ ^ [X2: A] : ( minus_minus @ B @ ( F2 @ X2 ) @ L )
            @ ( topolo7230453075368039082e_nhds @ B @ ( zero_zero @ B ) )
            @ F4 ) ) ) ).

% LIM_zero
thf(fact_5770_LIM__zero__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector @ B )
     => ! [F2: A > B,L: B,F4: filter @ A] :
          ( ( filterlim @ A @ B
            @ ^ [X2: A] : ( minus_minus @ B @ ( F2 @ X2 ) @ L )
            @ ( topolo7230453075368039082e_nhds @ B @ ( zero_zero @ B ) )
            @ F4 )
          = ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ L ) @ F4 ) ) ) ).

% LIM_zero_iff
thf(fact_5771_Lim__transform,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [G: B > A,A2: A,F4: filter @ B,F2: B > A] :
          ( ( filterlim @ B @ A @ G @ ( topolo7230453075368039082e_nhds @ A @ A2 ) @ F4 )
         => ( ( filterlim @ B @ A
              @ ^ [X2: B] : ( minus_minus @ A @ ( F2 @ X2 ) @ ( G @ X2 ) )
              @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) )
              @ F4 )
           => ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ A2 ) @ F4 ) ) ) ) ).

% Lim_transform
thf(fact_5772_Lim__transform2,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: B > A,A2: A,F4: filter @ B,G: B > A] :
          ( ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ A2 ) @ F4 )
         => ( ( filterlim @ B @ A
              @ ^ [X2: B] : ( minus_minus @ A @ ( F2 @ X2 ) @ ( G @ X2 ) )
              @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) )
              @ F4 )
           => ( filterlim @ B @ A @ G @ ( topolo7230453075368039082e_nhds @ A @ A2 ) @ F4 ) ) ) ) ).

% Lim_transform2
thf(fact_5773_LIM__zero__cancel,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector @ B )
     => ! [F2: A > B,L: B,F4: filter @ A] :
          ( ( filterlim @ A @ B
            @ ^ [X2: A] : ( minus_minus @ B @ ( F2 @ X2 ) @ L )
            @ ( topolo7230453075368039082e_nhds @ B @ ( zero_zero @ B ) )
            @ F4 )
         => ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ L ) @ F4 ) ) ) ).

% LIM_zero_cancel
thf(fact_5774_Lim__transform__eq,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: B > A,G: B > A,F4: filter @ B,A2: A] :
          ( ( filterlim @ B @ A
            @ ^ [X2: B] : ( minus_minus @ A @ ( F2 @ X2 ) @ ( G @ X2 ) )
            @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) )
            @ F4 )
         => ( ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ A2 ) @ F4 )
            = ( filterlim @ B @ A @ G @ ( topolo7230453075368039082e_nhds @ A @ A2 ) @ F4 ) ) ) ) ).

% Lim_transform_eq
thf(fact_5775_tendsto__mult__zero,axiom,
    ! [A: $tType,D: $tType] :
      ( ( real_V4412858255891104859lgebra @ A )
     => ! [F2: D > A,F4: filter @ D,G: D > A] :
          ( ( filterlim @ D @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) ) @ F4 )
         => ( ( filterlim @ D @ A @ G @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) ) @ F4 )
           => ( filterlim @ D @ A
              @ ^ [X2: D] : ( times_times @ A @ ( F2 @ X2 ) @ ( G @ X2 ) )
              @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) )
              @ F4 ) ) ) ) ).

% tendsto_mult_zero
thf(fact_5776_tendsto__mult__left__zero,axiom,
    ! [A: $tType,D: $tType] :
      ( ( real_V4412858255891104859lgebra @ A )
     => ! [F2: D > A,F4: filter @ D,C2: A] :
          ( ( filterlim @ D @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) ) @ F4 )
         => ( filterlim @ D @ A
            @ ^ [X2: D] : ( times_times @ A @ ( F2 @ X2 ) @ C2 )
            @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) )
            @ F4 ) ) ) ).

% tendsto_mult_left_zero
thf(fact_5777_tendsto__mult__right__zero,axiom,
    ! [A: $tType,D: $tType] :
      ( ( real_V4412858255891104859lgebra @ A )
     => ! [F2: D > A,F4: filter @ D,C2: A] :
          ( ( filterlim @ D @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) ) @ F4 )
         => ( filterlim @ D @ A
            @ ^ [X2: D] : ( times_times @ A @ C2 @ ( F2 @ X2 ) )
            @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) )
            @ F4 ) ) ) ).

% tendsto_mult_right_zero
thf(fact_5778_tendsto__real__root,axiom,
    ! [A: $tType,F2: A > real,X: real,F4: filter @ A,N: nat] :
      ( ( filterlim @ A @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ X ) @ F4 )
     => ( filterlim @ A @ real
        @ ^ [X2: A] : ( root @ N @ ( F2 @ X2 ) )
        @ ( topolo7230453075368039082e_nhds @ real @ ( root @ N @ X ) )
        @ F4 ) ) ).

% tendsto_real_root
thf(fact_5779_tendsto__power,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( power @ B )
        & ( real_V4412858255891104859lgebra @ B ) )
     => ! [F2: A > B,A2: B,F4: filter @ A,N: nat] :
          ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ A2 ) @ F4 )
         => ( filterlim @ A @ B
            @ ^ [X2: A] : ( power_power @ B @ ( F2 @ X2 ) @ N )
            @ ( topolo7230453075368039082e_nhds @ B @ ( power_power @ B @ A2 @ N ) )
            @ F4 ) ) ) ).

% tendsto_power
thf(fact_5780_tendsto__power__strong,axiom,
    ! [B: $tType,C: $tType] :
      ( ( topolo1898628316856586783d_mult @ B )
     => ! [F2: C > B,A2: B,F4: filter @ C,G: C > nat,B2: nat] :
          ( ( filterlim @ C @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ A2 ) @ F4 )
         => ( ( filterlim @ C @ nat @ G @ ( topolo7230453075368039082e_nhds @ nat @ B2 ) @ F4 )
           => ( filterlim @ C @ B
              @ ^ [X2: C] : ( power_power @ B @ ( F2 @ X2 ) @ ( G @ X2 ) )
              @ ( topolo7230453075368039082e_nhds @ B @ ( power_power @ B @ A2 @ B2 ) )
              @ F4 ) ) ) ) ).

% tendsto_power_strong
thf(fact_5781_tendsto__real__sqrt,axiom,
    ! [A: $tType,F2: A > real,X: real,F4: filter @ A] :
      ( ( filterlim @ A @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ X ) @ F4 )
     => ( filterlim @ A @ real
        @ ^ [X2: A] : ( sqrt @ ( F2 @ X2 ) )
        @ ( topolo7230453075368039082e_nhds @ real @ ( sqrt @ X ) )
        @ F4 ) ) ).

% tendsto_real_sqrt
thf(fact_5782_tendsto__max,axiom,
    ! [A: $tType,B: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [X7: B > A,X: A,Net: filter @ B,Y7: B > A,Y: A] :
          ( ( filterlim @ B @ A @ X7 @ ( topolo7230453075368039082e_nhds @ A @ X ) @ Net )
         => ( ( filterlim @ B @ A @ Y7 @ ( topolo7230453075368039082e_nhds @ A @ Y ) @ Net )
           => ( filterlim @ B @ A
              @ ^ [X2: B] : ( ord_max @ A @ ( X7 @ X2 ) @ ( Y7 @ X2 ) )
              @ ( topolo7230453075368039082e_nhds @ A @ ( ord_max @ A @ X @ Y ) )
              @ Net ) ) ) ) ).

% tendsto_max
thf(fact_5783_tendsto__arcosh,axiom,
    ! [B: $tType,F2: B > real,A2: real,F4: filter @ B] :
      ( ( filterlim @ B @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ A2 ) @ F4 )
     => ( ( ord_less @ real @ ( one_one @ real ) @ A2 )
       => ( filterlim @ B @ real
          @ ^ [X2: B] : ( arcosh @ real @ ( F2 @ X2 ) )
          @ ( topolo7230453075368039082e_nhds @ real @ ( arcosh @ real @ A2 ) )
          @ F4 ) ) ) ).

% tendsto_arcosh
thf(fact_5784_tendsto__divide__zero,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: B > A,F4: filter @ B,C2: A] :
          ( ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) ) @ F4 )
         => ( filterlim @ B @ A
            @ ^ [X2: B] : ( divide_divide @ A @ ( F2 @ X2 ) @ C2 )
            @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) )
            @ F4 ) ) ) ).

% tendsto_divide_zero
thf(fact_5785_tendsto__divide,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: B > A,A2: A,F4: filter @ B,G: B > A,B2: A] :
          ( ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ A2 ) @ F4 )
         => ( ( filterlim @ B @ A @ G @ ( topolo7230453075368039082e_nhds @ A @ B2 ) @ F4 )
           => ( ( B2
               != ( zero_zero @ A ) )
             => ( filterlim @ B @ A
                @ ^ [X2: B] : ( divide_divide @ A @ ( F2 @ X2 ) @ ( G @ X2 ) )
                @ ( topolo7230453075368039082e_nhds @ A @ ( divide_divide @ A @ A2 @ B2 ) )
                @ F4 ) ) ) ) ) ).

% tendsto_divide
thf(fact_5786_tendsto__add__zero,axiom,
    ! [B: $tType,D: $tType] :
      ( ( topolo6943815403480290642id_add @ B )
     => ! [F2: D > B,F4: filter @ D,G: D > B] :
          ( ( filterlim @ D @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ ( zero_zero @ B ) ) @ F4 )
         => ( ( filterlim @ D @ B @ G @ ( topolo7230453075368039082e_nhds @ B @ ( zero_zero @ B ) ) @ F4 )
           => ( filterlim @ D @ B
              @ ^ [X2: D] : ( plus_plus @ B @ ( F2 @ X2 ) @ ( G @ X2 ) )
              @ ( topolo7230453075368039082e_nhds @ B @ ( zero_zero @ B ) )
              @ F4 ) ) ) ) ).

% tendsto_add_zero
thf(fact_5787_tendsto__sgn,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: B > A,L: A,F4: filter @ B] :
          ( ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ L ) @ F4 )
         => ( ( L
             != ( zero_zero @ A ) )
           => ( filterlim @ B @ A
              @ ^ [X2: B] : ( sgn_sgn @ A @ ( F2 @ X2 ) )
              @ ( topolo7230453075368039082e_nhds @ A @ ( sgn_sgn @ A @ L ) )
              @ F4 ) ) ) ) ).

% tendsto_sgn
thf(fact_5788_tendsto__rabs__zero,axiom,
    ! [A: $tType,F2: A > real,F4: filter @ A] :
      ( ( filterlim @ A @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ F4 )
     => ( filterlim @ A @ real
        @ ^ [X2: A] : ( abs_abs @ real @ ( F2 @ X2 ) )
        @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
        @ F4 ) ) ).

% tendsto_rabs_zero
thf(fact_5789_tendsto__rabs__zero__iff,axiom,
    ! [A: $tType,F2: A > real,F4: filter @ A] :
      ( ( filterlim @ A @ real
        @ ^ [X2: A] : ( abs_abs @ real @ ( F2 @ X2 ) )
        @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
        @ F4 )
      = ( filterlim @ A @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ F4 ) ) ).

% tendsto_rabs_zero_iff
thf(fact_5790_tendsto__rabs__zero__cancel,axiom,
    ! [A: $tType,F2: A > real,F4: filter @ A] :
      ( ( filterlim @ A @ real
        @ ^ [X2: A] : ( abs_abs @ real @ ( F2 @ X2 ) )
        @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
        @ F4 )
     => ( filterlim @ A @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ F4 ) ) ).

% tendsto_rabs_zero_cancel
thf(fact_5791_tendsto__null__sum,axiom,
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( topolo5987344860129210374id_add @ C )
     => ! [I5: set @ B,F2: A > B > C,F4: filter @ A] :
          ( ! [I2: B] :
              ( ( member @ B @ I2 @ I5 )
             => ( filterlim @ A @ C
                @ ^ [X2: A] : ( F2 @ X2 @ I2 )
                @ ( topolo7230453075368039082e_nhds @ C @ ( zero_zero @ C ) )
                @ F4 ) )
         => ( filterlim @ A @ C
            @ ^ [I4: A] : ( groups7311177749621191930dd_sum @ B @ C @ ( F2 @ I4 ) @ I5 )
            @ ( topolo7230453075368039082e_nhds @ C @ ( zero_zero @ C ) )
            @ F4 ) ) ) ).

% tendsto_null_sum
thf(fact_5792_tendsto__artanh,axiom,
    ! [A: $tType,F2: A > real,A2: real,F4: filter @ A] :
      ( ( filterlim @ A @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ A2 ) @ F4 )
     => ( ( ord_less @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ A2 )
       => ( ( ord_less @ real @ A2 @ ( one_one @ real ) )
         => ( filterlim @ A @ real
            @ ^ [X2: A] : ( artanh @ real @ ( F2 @ X2 ) )
            @ ( topolo7230453075368039082e_nhds @ real @ ( artanh @ real @ A2 ) )
            @ F4 ) ) ) ) ).

% tendsto_artanh
thf(fact_5793_LIM__imp__LIM,axiom,
    ! [B: $tType,C: $tType,A: $tType] :
      ( ( ( topolo4958980785337419405_space @ A )
        & ( real_V822414075346904944vector @ C )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F2: A > B,L: B,A2: A,G: A > C,M: C] :
          ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ L ) @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) )
         => ( ! [X3: A] :
                ( ( X3 != A2 )
               => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ C @ ( minus_minus @ C @ ( G @ X3 ) @ M ) ) @ ( real_V7770717601297561774m_norm @ B @ ( minus_minus @ B @ ( F2 @ X3 ) @ L ) ) ) )
           => ( filterlim @ A @ C @ G @ ( topolo7230453075368039082e_nhds @ C @ M ) @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ).

% LIM_imp_LIM
thf(fact_5794_isCont__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( topolo4958980785337419405_space @ B ) )
     => ! [X: A,F2: A > B] :
          ( ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ X @ ( top_top @ ( set @ A ) ) ) @ F2 )
          = ( filterlim @ A @ B
            @ ^ [H: A] : ( F2 @ ( plus_plus @ A @ X @ H ) )
            @ ( topolo7230453075368039082e_nhds @ B @ ( F2 @ X ) )
            @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% isCont_iff
thf(fact_5795_LIM__offset__zero__iff,axiom,
    ! [C: $tType,D: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( topolo4958980785337419405_space @ D )
        & ( zero @ C ) )
     => ! [A2: A,F2: A > D,L5: D] :
          ( ( nO_MATCH @ C @ A @ ( zero_zero @ C ) @ A2 )
         => ( ( filterlim @ A @ D @ F2 @ ( topolo7230453075368039082e_nhds @ D @ L5 ) @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) )
            = ( filterlim @ A @ D
              @ ^ [H: A] : ( F2 @ ( plus_plus @ A @ A2 @ H ) )
              @ ( topolo7230453075368039082e_nhds @ D @ L5 )
              @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ).

% LIM_offset_zero_iff
thf(fact_5796_LIM__D,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F2: A > B,L5: B,A2: A,R2: real] :
          ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ L5 ) @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) )
         => ( ( ord_less @ real @ ( zero_zero @ real ) @ R2 )
           => ? [S3: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ S3 )
                & ! [X5: A] :
                    ( ( ( X5 != A2 )
                      & ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ X5 @ A2 ) ) @ S3 ) )
                   => ( ord_less @ real @ ( real_V7770717601297561774m_norm @ B @ ( minus_minus @ B @ ( F2 @ X5 ) @ L5 ) ) @ R2 ) ) ) ) ) ) ).

% LIM_D
thf(fact_5797_LIM__I,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [A2: A,F2: A > B,L5: B] :
          ( ! [R: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ R )
             => ? [S7: real] :
                  ( ( ord_less @ real @ ( zero_zero @ real ) @ S7 )
                  & ! [X3: A] :
                      ( ( ( X3 != A2 )
                        & ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ X3 @ A2 ) ) @ S7 ) )
                     => ( ord_less @ real @ ( real_V7770717601297561774m_norm @ B @ ( minus_minus @ B @ ( F2 @ X3 ) @ L5 ) ) @ R ) ) ) )
         => ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ L5 ) @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% LIM_I
thf(fact_5798_LIM__eq,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F2: A > B,L5: B,A2: A] :
          ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ L5 ) @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) )
          = ( ! [R5: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ R5 )
               => ? [S6: real] :
                    ( ( ord_less @ real @ ( zero_zero @ real ) @ S6 )
                    & ! [X2: A] :
                        ( ( ( X2 != A2 )
                          & ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ X2 @ A2 ) ) @ S6 ) )
                       => ( ord_less @ real @ ( real_V7770717601297561774m_norm @ B @ ( minus_minus @ B @ ( F2 @ X2 ) @ L5 ) ) @ R5 ) ) ) ) ) ) ) ).

% LIM_eq
thf(fact_5799_LIM__equal2,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( topolo4958980785337419405_space @ B ) )
     => ! [R4: real,A2: A,F2: A > B,G: A > B,L: B] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ R4 )
         => ( ! [X3: A] :
                ( ( X3 != A2 )
               => ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ X3 @ A2 ) ) @ R4 )
                 => ( ( F2 @ X3 )
                    = ( G @ X3 ) ) ) )
           => ( ( filterlim @ A @ B @ G @ ( topolo7230453075368039082e_nhds @ B @ L ) @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) )
             => ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ L ) @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ) ).

% LIM_equal2
thf(fact_5800_DERIV__LIM__iff,axiom,
    ! [A: $tType] :
      ( ( ( inverse @ A )
        & ( real_V822414075346904944vector @ A ) )
     => ! [F2: A > A,A2: A,D5: A] :
          ( ( filterlim @ A @ A
            @ ^ [H: A] : ( divide_divide @ A @ ( minus_minus @ A @ ( F2 @ ( plus_plus @ A @ A2 @ H ) ) @ ( F2 @ A2 ) ) @ H )
            @ ( topolo7230453075368039082e_nhds @ A @ D5 )
            @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) )
          = ( filterlim @ A @ A
            @ ^ [X2: A] : ( divide_divide @ A @ ( minus_minus @ A @ ( F2 @ X2 ) @ ( F2 @ A2 ) ) @ ( minus_minus @ A @ X2 @ A2 ) )
            @ ( topolo7230453075368039082e_nhds @ A @ D5 )
            @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% DERIV_LIM_iff
thf(fact_5801_LIM__fun__less__zero,axiom,
    ! [F2: real > real,L: real,C2: real] :
      ( ( filterlim @ real @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ L ) @ ( topolo174197925503356063within @ real @ C2 @ ( top_top @ ( set @ real ) ) ) )
     => ( ( ord_less @ real @ L @ ( zero_zero @ real ) )
       => ? [R: real] :
            ( ( ord_less @ real @ ( zero_zero @ real ) @ R )
            & ! [X5: real] :
                ( ( ( X5 != C2 )
                  & ( ord_less @ real @ ( abs_abs @ real @ ( minus_minus @ real @ C2 @ X5 ) ) @ R ) )
               => ( ord_less @ real @ ( F2 @ X5 ) @ ( zero_zero @ real ) ) ) ) ) ) ).

% LIM_fun_less_zero
thf(fact_5802_LIM__fun__not__zero,axiom,
    ! [F2: real > real,L: real,C2: real] :
      ( ( filterlim @ real @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ L ) @ ( topolo174197925503356063within @ real @ C2 @ ( top_top @ ( set @ real ) ) ) )
     => ( ( L
         != ( zero_zero @ real ) )
       => ? [R: real] :
            ( ( ord_less @ real @ ( zero_zero @ real ) @ R )
            & ! [X5: real] :
                ( ( ( X5 != C2 )
                  & ( ord_less @ real @ ( abs_abs @ real @ ( minus_minus @ real @ C2 @ X5 ) ) @ R ) )
               => ( ( F2 @ X5 )
                 != ( zero_zero @ real ) ) ) ) ) ) ).

% LIM_fun_not_zero
thf(fact_5803_LIM__fun__gt__zero,axiom,
    ! [F2: real > real,L: real,C2: real] :
      ( ( filterlim @ real @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ L ) @ ( topolo174197925503356063within @ real @ C2 @ ( top_top @ ( set @ real ) ) ) )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ L )
       => ? [R: real] :
            ( ( ord_less @ real @ ( zero_zero @ real ) @ R )
            & ! [X5: real] :
                ( ( ( X5 != C2 )
                  & ( ord_less @ real @ ( abs_abs @ real @ ( minus_minus @ real @ C2 @ X5 ) ) @ R ) )
               => ( ord_less @ real @ ( zero_zero @ real ) @ ( F2 @ X5 ) ) ) ) ) ) ).

% LIM_fun_gt_zero
thf(fact_5804_LIM__compose2,axiom,
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( topolo4958980785337419405_space @ B )
        & ( topolo4958980785337419405_space @ C ) )
     => ! [F2: A > B,B2: B,A2: A,G: B > C,C2: C] :
          ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ B2 ) @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) )
         => ( ( filterlim @ B @ C @ G @ ( topolo7230453075368039082e_nhds @ C @ C2 ) @ ( topolo174197925503356063within @ B @ B2 @ ( top_top @ ( set @ B ) ) ) )
           => ( ? [D3: real] :
                  ( ( ord_less @ real @ ( zero_zero @ real ) @ D3 )
                  & ! [X3: A] :
                      ( ( ( X3 != A2 )
                        & ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ X3 @ A2 ) ) @ D3 ) )
                     => ( ( F2 @ X3 )
                       != B2 ) ) )
             => ( filterlim @ A @ C
                @ ^ [X2: A] : ( G @ ( F2 @ X2 ) )
                @ ( topolo7230453075368039082e_nhds @ C @ C2 )
                @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ) ).

% LIM_compose2
thf(fact_5805_continuous__at__within__powr,axiom,
    ! [C: $tType] :
      ( ( topological_t2_space @ C )
     => ! [A2: C,S2: set @ C,F2: C > real,G: C > real] :
          ( ( topolo3448309680560233919inuous @ C @ real @ ( topolo174197925503356063within @ C @ A2 @ S2 ) @ F2 )
         => ( ( topolo3448309680560233919inuous @ C @ real @ ( topolo174197925503356063within @ C @ A2 @ S2 ) @ G )
           => ( ( ( F2 @ A2 )
               != ( zero_zero @ real ) )
             => ( topolo3448309680560233919inuous @ C @ real @ ( topolo174197925503356063within @ C @ A2 @ S2 )
                @ ^ [X2: C] : ( powr @ real @ ( F2 @ X2 ) @ ( G @ X2 ) ) ) ) ) ) ) ).

% continuous_at_within_powr
thf(fact_5806_continuous__within__ln,axiom,
    ! [A: $tType] :
      ( ( topological_t2_space @ A )
     => ! [X: A,S2: set @ A,F2: A > real] :
          ( ( topolo3448309680560233919inuous @ A @ real @ ( topolo174197925503356063within @ A @ X @ S2 ) @ F2 )
         => ( ( ( F2 @ X )
             != ( zero_zero @ real ) )
           => ( topolo3448309680560233919inuous @ A @ real @ ( topolo174197925503356063within @ A @ X @ S2 )
              @ ^ [X2: A] : ( ln_ln @ real @ ( F2 @ X2 ) ) ) ) ) ) ).

% continuous_within_ln
thf(fact_5807_DERIV__D,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,D5: A,X: A] :
          ( ( has_field_derivative @ A @ F2 @ D5 @ ( topolo174197925503356063within @ A @ X @ ( top_top @ ( set @ A ) ) ) )
         => ( filterlim @ A @ A
            @ ^ [H: A] : ( divide_divide @ A @ ( minus_minus @ A @ ( F2 @ ( plus_plus @ A @ X @ H ) ) @ ( F2 @ X ) ) @ H )
            @ ( topolo7230453075368039082e_nhds @ A @ D5 )
            @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% DERIV_D
thf(fact_5808_DERIV__def,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,D5: A,X: A] :
          ( ( has_field_derivative @ A @ F2 @ D5 @ ( topolo174197925503356063within @ A @ X @ ( top_top @ ( set @ A ) ) ) )
          = ( filterlim @ A @ A
            @ ^ [H: A] : ( divide_divide @ A @ ( minus_minus @ A @ ( F2 @ ( plus_plus @ A @ X @ H ) ) @ ( F2 @ X ) ) @ H )
            @ ( topolo7230453075368039082e_nhds @ A @ D5 )
            @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% DERIV_def
thf(fact_5809_lim__exp__minus__1,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ( filterlim @ A @ A
        @ ^ [Z6: A] : ( divide_divide @ A @ ( minus_minus @ A @ ( exp @ A @ Z6 ) @ ( one_one @ A ) ) @ Z6 )
        @ ( topolo7230453075368039082e_nhds @ A @ ( one_one @ A ) )
        @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ).

% lim_exp_minus_1
thf(fact_5810_isCont__LIM__compose2,axiom,
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( topolo4958980785337419405_space @ B )
        & ( topolo4958980785337419405_space @ C ) )
     => ! [A2: A,F2: A > B,G: B > C,L: C] :
          ( ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) @ F2 )
         => ( ( filterlim @ B @ C @ G @ ( topolo7230453075368039082e_nhds @ C @ L ) @ ( topolo174197925503356063within @ B @ ( F2 @ A2 ) @ ( top_top @ ( set @ B ) ) ) )
           => ( ? [D3: real] :
                  ( ( ord_less @ real @ ( zero_zero @ real ) @ D3 )
                  & ! [X3: A] :
                      ( ( ( X3 != A2 )
                        & ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ X3 @ A2 ) ) @ D3 ) )
                     => ( ( F2 @ X3 )
                       != ( F2 @ A2 ) ) ) )
             => ( filterlim @ A @ C
                @ ^ [X2: A] : ( G @ ( F2 @ X2 ) )
                @ ( topolo7230453075368039082e_nhds @ C @ L )
                @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ) ).

% isCont_LIM_compose2
thf(fact_5811_lemma__termdiff4,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [K: real,F2: A > B,K6: real] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ K )
         => ( ! [H4: A] :
                ( ( H4
                 != ( zero_zero @ A ) )
               => ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ H4 ) @ K )
                 => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ B @ ( F2 @ H4 ) ) @ ( times_times @ real @ K6 @ ( real_V7770717601297561774m_norm @ A @ H4 ) ) ) ) )
           => ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ ( zero_zero @ B ) ) @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ).

% lemma_termdiff4
thf(fact_5812_field__has__derivative__at,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,D5: A,X: A] :
          ( ( has_derivative @ A @ A @ F2 @ ( times_times @ A @ D5 ) @ ( topolo174197925503356063within @ A @ X @ ( top_top @ ( set @ A ) ) ) )
          = ( filterlim @ A @ A
            @ ^ [H: A] : ( divide_divide @ A @ ( minus_minus @ A @ ( F2 @ ( plus_plus @ A @ X @ H ) ) @ ( F2 @ X ) ) @ H )
            @ ( topolo7230453075368039082e_nhds @ A @ D5 )
            @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% field_has_derivative_at
thf(fact_5813_filterlim__at__to__0,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: A > B,F4: filter @ B,A2: A] :
          ( ( filterlim @ A @ B @ F2 @ F4 @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) )
          = ( filterlim @ A @ B
            @ ^ [X2: A] : ( F2 @ ( plus_plus @ A @ X2 @ A2 ) )
            @ F4
            @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% filterlim_at_to_0
thf(fact_5814_isCont__powr,axiom,
    ! [C: $tType] :
      ( ( topological_t2_space @ C )
     => ! [A2: C,F2: C > real,G: C > real] :
          ( ( topolo3448309680560233919inuous @ C @ real @ ( topolo174197925503356063within @ C @ A2 @ ( top_top @ ( set @ C ) ) ) @ F2 )
         => ( ( topolo3448309680560233919inuous @ C @ real @ ( topolo174197925503356063within @ C @ A2 @ ( top_top @ ( set @ C ) ) ) @ G )
           => ( ( ( F2 @ A2 )
               != ( zero_zero @ real ) )
             => ( topolo3448309680560233919inuous @ C @ real @ ( topolo174197925503356063within @ C @ A2 @ ( top_top @ ( set @ C ) ) )
                @ ^ [X2: C] : ( powr @ real @ ( F2 @ X2 ) @ ( G @ X2 ) ) ) ) ) ) ) ).

% isCont_powr
thf(fact_5815_isCont__ln_H,axiom,
    ! [A: $tType] :
      ( ( topological_t2_space @ A )
     => ! [X: A,F2: A > real] :
          ( ( topolo3448309680560233919inuous @ A @ real @ ( topolo174197925503356063within @ A @ X @ ( top_top @ ( set @ A ) ) ) @ F2 )
         => ( ( ( F2 @ X )
             != ( zero_zero @ real ) )
           => ( topolo3448309680560233919inuous @ A @ real @ ( topolo174197925503356063within @ A @ X @ ( top_top @ ( set @ A ) ) )
              @ ^ [X2: A] : ( ln_ln @ real @ ( F2 @ X2 ) ) ) ) ) ) ).

% isCont_ln'
thf(fact_5816_powser__limit__0__strong,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [S2: real,A2: nat > A,F2: A > A] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ S2 )
         => ( ! [X3: A] :
                ( ( X3
                 != ( zero_zero @ A ) )
               => ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ X3 ) @ S2 )
                 => ( sums @ A
                    @ ^ [N3: nat] : ( times_times @ A @ ( A2 @ N3 ) @ ( power_power @ A @ X3 @ N3 ) )
                    @ ( F2 @ X3 ) ) ) )
           => ( filterlim @ A @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ ( A2 @ ( zero_zero @ nat ) ) ) @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ).

% powser_limit_0_strong
thf(fact_5817_powser__limit__0,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [S2: real,A2: nat > A,F2: A > A] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ S2 )
         => ( ! [X3: A] :
                ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ X3 ) @ S2 )
               => ( sums @ A
                  @ ^ [N3: nat] : ( times_times @ A @ ( A2 @ N3 ) @ ( power_power @ A @ X3 @ N3 ) )
                  @ ( F2 @ X3 ) ) )
           => ( filterlim @ A @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ ( A2 @ ( zero_zero @ nat ) ) ) @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ).

% powser_limit_0
thf(fact_5818_lemma__termdiff5,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_Vector_banach @ B ) )
     => ! [K: real,F2: nat > real,G: A > nat > B] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ K )
         => ( ( summable @ real @ F2 )
           => ( ! [H4: A,N2: nat] :
                  ( ( H4
                   != ( zero_zero @ A ) )
                 => ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ H4 ) @ K )
                   => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ B @ ( G @ H4 @ N2 ) ) @ ( times_times @ real @ ( F2 @ N2 ) @ ( real_V7770717601297561774m_norm @ A @ H4 ) ) ) ) )
             => ( filterlim @ A @ B
                @ ^ [H: A] : ( suminf @ B @ ( G @ H ) )
                @ ( topolo7230453075368039082e_nhds @ B @ ( zero_zero @ B ) )
                @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ) ).

% lemma_termdiff5
thf(fact_5819_continuous__at__within__log,axiom,
    ! [A: $tType] :
      ( ( topological_t2_space @ A )
     => ! [A2: A,S2: set @ A,F2: A > real,G: A > real] :
          ( ( topolo3448309680560233919inuous @ A @ real @ ( topolo174197925503356063within @ A @ A2 @ S2 ) @ F2 )
         => ( ( topolo3448309680560233919inuous @ A @ real @ ( topolo174197925503356063within @ A @ A2 @ S2 ) @ G )
           => ( ( ord_less @ real @ ( zero_zero @ real ) @ ( F2 @ A2 ) )
             => ( ( ( F2 @ A2 )
                 != ( one_one @ real ) )
               => ( ( ord_less @ real @ ( zero_zero @ real ) @ ( G @ A2 ) )
                 => ( topolo3448309680560233919inuous @ A @ real @ ( topolo174197925503356063within @ A @ A2 @ S2 )
                    @ ^ [X2: A] : ( log2 @ ( F2 @ X2 ) @ ( G @ X2 ) ) ) ) ) ) ) ) ) ).

% continuous_at_within_log
thf(fact_5820_LIM__cos__div__sin,axiom,
    ( filterlim @ real @ real
    @ ^ [X2: real] : ( divide_divide @ real @ ( cos @ real @ X2 ) @ ( sin @ real @ X2 ) )
    @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
    @ ( topolo174197925503356063within @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( top_top @ ( set @ real ) ) ) ) ).

% LIM_cos_div_sin
thf(fact_5821_isCont__log,axiom,
    ! [A: $tType] :
      ( ( topological_t2_space @ A )
     => ! [A2: A,F2: A > real,G: A > real] :
          ( ( topolo3448309680560233919inuous @ A @ real @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) @ F2 )
         => ( ( topolo3448309680560233919inuous @ A @ real @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) @ G )
           => ( ( ord_less @ real @ ( zero_zero @ real ) @ ( F2 @ A2 ) )
             => ( ( ( F2 @ A2 )
                 != ( one_one @ real ) )
               => ( ( ord_less @ real @ ( zero_zero @ real ) @ ( G @ A2 ) )
                 => ( topolo3448309680560233919inuous @ A @ real @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) )
                    @ ^ [X2: A] : ( log2 @ ( F2 @ X2 ) @ ( G @ X2 ) ) ) ) ) ) ) ) ) ).

% isCont_log
thf(fact_5822_summable__Leibniz_I2_J,axiom,
    ! [A2: nat > real] :
      ( ( filterlim @ nat @ real @ A2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( at_top @ nat ) )
     => ( ( topological_monoseq @ real @ A2 )
       => ( ( ord_less @ real @ ( zero_zero @ real ) @ ( A2 @ ( zero_zero @ nat ) ) )
         => ! [N7: nat] :
              ( member @ real
              @ ( suminf @ real
                @ ^ [I4: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I4 ) @ ( A2 @ I4 ) ) )
              @ ( set_or1337092689740270186AtMost @ real
                @ ( groups7311177749621191930dd_sum @ nat @ real
                  @ ^ [I4: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I4 ) @ ( A2 @ I4 ) )
                  @ ( set_ord_lessThan @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N7 ) ) )
                @ ( groups7311177749621191930dd_sum @ nat @ real
                  @ ^ [I4: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I4 ) @ ( A2 @ I4 ) )
                  @ ( set_ord_lessThan @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N7 ) @ ( one_one @ nat ) ) ) ) ) ) ) ) ) ).

% summable_Leibniz(2)
thf(fact_5823_summable__Leibniz_I3_J,axiom,
    ! [A2: nat > real] :
      ( ( filterlim @ nat @ real @ A2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( at_top @ nat ) )
     => ( ( topological_monoseq @ real @ A2 )
       => ( ( ord_less @ real @ ( A2 @ ( zero_zero @ nat ) ) @ ( zero_zero @ real ) )
         => ! [N7: nat] :
              ( member @ real
              @ ( suminf @ real
                @ ^ [I4: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I4 ) @ ( A2 @ I4 ) ) )
              @ ( set_or1337092689740270186AtMost @ real
                @ ( groups7311177749621191930dd_sum @ nat @ real
                  @ ^ [I4: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I4 ) @ ( A2 @ I4 ) )
                  @ ( set_ord_lessThan @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N7 ) @ ( one_one @ nat ) ) ) )
                @ ( groups7311177749621191930dd_sum @ nat @ real
                  @ ^ [I4: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I4 ) @ ( A2 @ I4 ) )
                  @ ( set_ord_lessThan @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N7 ) ) ) ) ) ) ) ) ).

% summable_Leibniz(3)
thf(fact_5824_summable__Leibniz_H_I5_J,axiom,
    ! [A2: nat > real] :
      ( ( filterlim @ nat @ real @ A2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( at_top @ nat ) )
     => ( ! [N2: nat] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( A2 @ N2 ) )
       => ( ! [N2: nat] : ( ord_less_eq @ real @ ( A2 @ ( suc @ N2 ) ) @ ( A2 @ N2 ) )
         => ( filterlim @ nat @ real
            @ ^ [N3: nat] :
                ( groups7311177749621191930dd_sum @ nat @ real
                @ ^ [I4: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I4 ) @ ( A2 @ I4 ) )
                @ ( set_ord_lessThan @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N3 ) @ ( one_one @ nat ) ) ) )
            @ ( topolo7230453075368039082e_nhds @ real
              @ ( suminf @ real
                @ ^ [I4: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I4 ) @ ( A2 @ I4 ) ) ) )
            @ ( at_top @ nat ) ) ) ) ) ).

% summable_Leibniz'(5)
thf(fact_5825_tendsto__zero__mult__right__iff,axiom,
    ! [A: $tType] :
      ( ( ( field @ A )
        & ( topolo4211221413907600880p_mult @ A ) )
     => ! [C2: A,A2: nat > A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( filterlim @ nat @ A
              @ ^ [N3: nat] : ( times_times @ A @ ( A2 @ N3 ) @ C2 )
              @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) )
              @ ( at_top @ nat ) )
            = ( filterlim @ nat @ A @ A2 @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) ) @ ( at_top @ nat ) ) ) ) ) ).

% tendsto_zero_mult_right_iff
thf(fact_5826_tendsto__zero__mult__left__iff,axiom,
    ! [A: $tType] :
      ( ( ( field @ A )
        & ( topolo4211221413907600880p_mult @ A ) )
     => ! [C2: A,A2: nat > A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( filterlim @ nat @ A
              @ ^ [N3: nat] : ( times_times @ A @ C2 @ ( A2 @ N3 ) )
              @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) )
              @ ( at_top @ nat ) )
            = ( filterlim @ nat @ A @ A2 @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) ) @ ( at_top @ nat ) ) ) ) ) ).

% tendsto_zero_mult_left_iff
thf(fact_5827_tendsto__zero__divide__iff,axiom,
    ! [A: $tType] :
      ( ( ( field @ A )
        & ( topolo4211221413907600880p_mult @ A ) )
     => ! [C2: A,A2: nat > A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( filterlim @ nat @ A
              @ ^ [N3: nat] : ( divide_divide @ A @ ( A2 @ N3 ) @ C2 )
              @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) )
              @ ( at_top @ nat ) )
            = ( filterlim @ nat @ A @ A2 @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) ) @ ( at_top @ nat ) ) ) ) ) ).

% tendsto_zero_divide_iff
thf(fact_5828_approx__from__above__dense__linorder,axiom,
    ! [A: $tType] :
      ( ( ( dense_linorder @ A )
        & ( topolo3112930676232923870pology @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [X: A,Y: A] :
          ( ( ord_less @ A @ X @ Y )
         => ? [U4: nat > A] :
              ( ! [N7: nat] : ( ord_less @ A @ X @ ( U4 @ N7 ) )
              & ( filterlim @ nat @ A @ U4 @ ( topolo7230453075368039082e_nhds @ A @ X ) @ ( at_top @ nat ) ) ) ) ) ).

% approx_from_above_dense_linorder
thf(fact_5829_approx__from__below__dense__linorder,axiom,
    ! [A: $tType] :
      ( ( ( dense_linorder @ A )
        & ( topolo3112930676232923870pology @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [Y: A,X: A] :
          ( ( ord_less @ A @ Y @ X )
         => ? [U4: nat > A] :
              ( ! [N7: nat] : ( ord_less @ A @ ( U4 @ N7 ) @ X )
              & ( filterlim @ nat @ A @ U4 @ ( topolo7230453075368039082e_nhds @ A @ X ) @ ( at_top @ nat ) ) ) ) ) ).

% approx_from_below_dense_linorder
thf(fact_5830_lim__mono,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [N4: nat,X7: nat > A,Y7: nat > A,X: A,Y: A] :
          ( ! [N2: nat] :
              ( ( ord_less_eq @ nat @ N4 @ N2 )
             => ( ord_less_eq @ A @ ( X7 @ N2 ) @ ( Y7 @ N2 ) ) )
         => ( ( filterlim @ nat @ A @ X7 @ ( topolo7230453075368039082e_nhds @ A @ X ) @ ( at_top @ nat ) )
           => ( ( filterlim @ nat @ A @ Y7 @ ( topolo7230453075368039082e_nhds @ A @ Y ) @ ( at_top @ nat ) )
             => ( ord_less_eq @ A @ X @ Y ) ) ) ) ) ).

% lim_mono
thf(fact_5831_LIMSEQ__le,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [X7: nat > A,X: A,Y7: nat > A,Y: A] :
          ( ( filterlim @ nat @ A @ X7 @ ( topolo7230453075368039082e_nhds @ A @ X ) @ ( at_top @ nat ) )
         => ( ( filterlim @ nat @ A @ Y7 @ ( topolo7230453075368039082e_nhds @ A @ Y ) @ ( at_top @ nat ) )
           => ( ? [N8: nat] :
                ! [N2: nat] :
                  ( ( ord_less_eq @ nat @ N8 @ N2 )
                 => ( ord_less_eq @ A @ ( X7 @ N2 ) @ ( Y7 @ N2 ) ) )
             => ( ord_less_eq @ A @ X @ Y ) ) ) ) ) ).

% LIMSEQ_le
thf(fact_5832_Lim__bounded,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [F2: nat > A,L: A,M5: nat,C5: A] :
          ( ( filterlim @ nat @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ L ) @ ( at_top @ nat ) )
         => ( ! [N2: nat] :
                ( ( ord_less_eq @ nat @ M5 @ N2 )
               => ( ord_less_eq @ A @ ( F2 @ N2 ) @ C5 ) )
           => ( ord_less_eq @ A @ L @ C5 ) ) ) ) ).

% Lim_bounded
thf(fact_5833_Lim__bounded2,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [F2: nat > A,L: A,N4: nat,C5: A] :
          ( ( filterlim @ nat @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ L ) @ ( at_top @ nat ) )
         => ( ! [N2: nat] :
                ( ( ord_less_eq @ nat @ N4 @ N2 )
               => ( ord_less_eq @ A @ C5 @ ( F2 @ N2 ) ) )
           => ( ord_less_eq @ A @ C5 @ L ) ) ) ) ).

% Lim_bounded2
thf(fact_5834_LIMSEQ__le__const,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [X7: nat > A,X: A,A2: A] :
          ( ( filterlim @ nat @ A @ X7 @ ( topolo7230453075368039082e_nhds @ A @ X ) @ ( at_top @ nat ) )
         => ( ? [N8: nat] :
              ! [N2: nat] :
                ( ( ord_less_eq @ nat @ N8 @ N2 )
               => ( ord_less_eq @ A @ A2 @ ( X7 @ N2 ) ) )
           => ( ord_less_eq @ A @ A2 @ X ) ) ) ) ).

% LIMSEQ_le_const
thf(fact_5835_LIMSEQ__le__const2,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [X7: nat > A,X: A,A2: A] :
          ( ( filterlim @ nat @ A @ X7 @ ( topolo7230453075368039082e_nhds @ A @ X ) @ ( at_top @ nat ) )
         => ( ? [N8: nat] :
              ! [N2: nat] :
                ( ( ord_less_eq @ nat @ N8 @ N2 )
               => ( ord_less_eq @ A @ ( X7 @ N2 ) @ A2 ) )
           => ( ord_less_eq @ A @ X @ A2 ) ) ) ) ).

% LIMSEQ_le_const2
thf(fact_5836_Sup__lim,axiom,
    ! [A: $tType] :
      ( ( ( comple5582772986160207858norder @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [B2: nat > A,S2: set @ A,A2: A] :
          ( ! [N2: nat] : ( member @ A @ ( B2 @ N2 ) @ S2 )
         => ( ( filterlim @ nat @ A @ B2 @ ( topolo7230453075368039082e_nhds @ A @ A2 ) @ ( at_top @ nat ) )
           => ( ord_less_eq @ A @ A2 @ ( complete_Sup_Sup @ A @ S2 ) ) ) ) ) ).

% Sup_lim
thf(fact_5837_Inf__lim,axiom,
    ! [A: $tType] :
      ( ( ( comple5582772986160207858norder @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [B2: nat > A,S2: set @ A,A2: A] :
          ( ! [N2: nat] : ( member @ A @ ( B2 @ N2 ) @ S2 )
         => ( ( filterlim @ nat @ A @ B2 @ ( topolo7230453075368039082e_nhds @ A @ A2 ) @ ( at_top @ nat ) )
           => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ S2 ) @ A2 ) ) ) ) ).

% Inf_lim
thf(fact_5838_summable__LIMSEQ__zero,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: nat > A] :
          ( ( summable @ A @ F2 )
         => ( filterlim @ nat @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) ) @ ( at_top @ nat ) ) ) ) ).

% summable_LIMSEQ_zero
thf(fact_5839_mult__nat__right__at__top,axiom,
    ! [C2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ C2 )
     => ( filterlim @ nat @ nat
        @ ^ [X2: nat] : ( times_times @ nat @ X2 @ C2 )
        @ ( at_top @ nat )
        @ ( at_top @ nat ) ) ) ).

% mult_nat_right_at_top
thf(fact_5840_mult__nat__left__at__top,axiom,
    ! [C2: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ C2 )
     => ( filterlim @ nat @ nat @ ( times_times @ nat @ C2 ) @ ( at_top @ nat ) @ ( at_top @ nat ) ) ) ).

% mult_nat_left_at_top
thf(fact_5841_monoseq__convergent,axiom,
    ! [X7: nat > real,B7: real] :
      ( ( topological_monoseq @ real @ X7 )
     => ( ! [I2: nat] : ( ord_less_eq @ real @ ( abs_abs @ real @ ( X7 @ I2 ) ) @ B7 )
       => ~ ! [L6: real] :
              ~ ( filterlim @ nat @ real @ X7 @ ( topolo7230453075368039082e_nhds @ real @ L6 ) @ ( at_top @ nat ) ) ) ) ).

% monoseq_convergent
thf(fact_5842_LIMSEQ__root,axiom,
    ( filterlim @ nat @ real
    @ ^ [N3: nat] : ( root @ N3 @ ( semiring_1_of_nat @ real @ N3 ) )
    @ ( topolo7230453075368039082e_nhds @ real @ ( one_one @ real ) )
    @ ( at_top @ nat ) ) ).

% LIMSEQ_root
thf(fact_5843_monoseq__le,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [A2: nat > A,X: A] :
          ( ( topological_monoseq @ A @ A2 )
         => ( ( filterlim @ nat @ A @ A2 @ ( topolo7230453075368039082e_nhds @ A @ X ) @ ( at_top @ nat ) )
           => ( ( ! [N7: nat] : ( ord_less_eq @ A @ ( A2 @ N7 ) @ X )
                & ! [M2: nat,N7: nat] :
                    ( ( ord_less_eq @ nat @ M2 @ N7 )
                   => ( ord_less_eq @ A @ ( A2 @ M2 ) @ ( A2 @ N7 ) ) ) )
              | ( ! [N7: nat] : ( ord_less_eq @ A @ X @ ( A2 @ N7 ) )
                & ! [M2: nat,N7: nat] :
                    ( ( ord_less_eq @ nat @ M2 @ N7 )
                   => ( ord_less_eq @ A @ ( A2 @ N7 ) @ ( A2 @ M2 ) ) ) ) ) ) ) ) ).

% monoseq_le
thf(fact_5844_lim__const__over__n,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [A2: A] :
          ( filterlim @ nat @ A
          @ ^ [N3: nat] : ( divide_divide @ A @ A2 @ ( semiring_1_of_nat @ A @ N3 ) )
          @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) )
          @ ( at_top @ nat ) ) ) ).

% lim_const_over_n
thf(fact_5845_lim__inverse__n,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ( filterlim @ nat @ A
        @ ^ [N3: nat] : ( inverse_inverse @ A @ ( semiring_1_of_nat @ A @ N3 ) )
        @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) )
        @ ( at_top @ nat ) ) ) ).

% lim_inverse_n
thf(fact_5846_LIMSEQ__linear,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [X7: nat > A,X: A,L: nat] :
          ( ( filterlim @ nat @ A @ X7 @ ( topolo7230453075368039082e_nhds @ A @ X ) @ ( at_top @ nat ) )
         => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ L )
           => ( filterlim @ nat @ A
              @ ^ [N3: nat] : ( X7 @ ( times_times @ nat @ N3 @ L ) )
              @ ( topolo7230453075368039082e_nhds @ A @ X )
              @ ( at_top @ nat ) ) ) ) ) ).

% LIMSEQ_linear
thf(fact_5847_nested__sequence__unique,axiom,
    ! [F2: nat > real,G: nat > real] :
      ( ! [N2: nat] : ( ord_less_eq @ real @ ( F2 @ N2 ) @ ( F2 @ ( suc @ N2 ) ) )
     => ( ! [N2: nat] : ( ord_less_eq @ real @ ( G @ ( suc @ N2 ) ) @ ( G @ N2 ) )
       => ( ! [N2: nat] : ( ord_less_eq @ real @ ( F2 @ N2 ) @ ( G @ N2 ) )
         => ( ( filterlim @ nat @ real
              @ ^ [N3: nat] : ( minus_minus @ real @ ( F2 @ N3 ) @ ( G @ N3 ) )
              @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
              @ ( at_top @ nat ) )
           => ? [L3: real] :
                ( ! [N7: nat] : ( ord_less_eq @ real @ ( F2 @ N7 ) @ L3 )
                & ( filterlim @ nat @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ L3 ) @ ( at_top @ nat ) )
                & ! [N7: nat] : ( ord_less_eq @ real @ L3 @ ( G @ N7 ) )
                & ( filterlim @ nat @ real @ G @ ( topolo7230453075368039082e_nhds @ real @ L3 ) @ ( at_top @ nat ) ) ) ) ) ) ) ).

% nested_sequence_unique
thf(fact_5848_LIMSEQ__inverse__zero,axiom,
    ! [X7: nat > real] :
      ( ! [R: real] :
        ? [N8: nat] :
        ! [N2: nat] :
          ( ( ord_less_eq @ nat @ N8 @ N2 )
         => ( ord_less @ real @ R @ ( X7 @ N2 ) ) )
     => ( filterlim @ nat @ real
        @ ^ [N3: nat] : ( inverse_inverse @ real @ ( X7 @ N3 ) )
        @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
        @ ( at_top @ nat ) ) ) ).

% LIMSEQ_inverse_zero
thf(fact_5849_lim__inverse__n_H,axiom,
    ( filterlim @ nat @ real
    @ ^ [N3: nat] : ( divide_divide @ real @ ( one_one @ real ) @ ( semiring_1_of_nat @ real @ N3 ) )
    @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
    @ ( at_top @ nat ) ) ).

% lim_inverse_n'
thf(fact_5850_LIMSEQ__root__const,axiom,
    ! [C2: real] :
      ( ( ord_less @ real @ ( zero_zero @ real ) @ C2 )
     => ( filterlim @ nat @ real
        @ ^ [N3: nat] : ( root @ N3 @ C2 )
        @ ( topolo7230453075368039082e_nhds @ real @ ( one_one @ real ) )
        @ ( at_top @ nat ) ) ) ).

% LIMSEQ_root_const
thf(fact_5851_LIMSEQ__inverse__real__of__nat,axiom,
    ( filterlim @ nat @ real
    @ ^ [N3: nat] : ( inverse_inverse @ real @ ( semiring_1_of_nat @ real @ ( suc @ N3 ) ) )
    @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
    @ ( at_top @ nat ) ) ).

% LIMSEQ_inverse_real_of_nat
thf(fact_5852_LIMSEQ__inverse__real__of__nat__add,axiom,
    ! [R2: real] :
      ( filterlim @ nat @ real
      @ ^ [N3: nat] : ( plus_plus @ real @ R2 @ ( inverse_inverse @ real @ ( semiring_1_of_nat @ real @ ( suc @ N3 ) ) ) )
      @ ( topolo7230453075368039082e_nhds @ real @ R2 )
      @ ( at_top @ nat ) ) ).

% LIMSEQ_inverse_real_of_nat_add
thf(fact_5853_increasing__LIMSEQ,axiom,
    ! [F2: nat > real,L: real] :
      ( ! [N2: nat] : ( ord_less_eq @ real @ ( F2 @ N2 ) @ ( F2 @ ( suc @ N2 ) ) )
     => ( ! [N2: nat] : ( ord_less_eq @ real @ ( F2 @ N2 ) @ L )
       => ( ! [E: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ E )
             => ? [N7: nat] : ( ord_less_eq @ real @ L @ ( plus_plus @ real @ ( F2 @ N7 ) @ E ) ) )
         => ( filterlim @ nat @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ L ) @ ( at_top @ nat ) ) ) ) ) ).

% increasing_LIMSEQ
thf(fact_5854_lim__1__over__n,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ( filterlim @ nat @ A
        @ ^ [N3: nat] : ( divide_divide @ A @ ( one_one @ A ) @ ( semiring_1_of_nat @ A @ N3 ) )
        @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) )
        @ ( at_top @ nat ) ) ) ).

% lim_1_over_n
thf(fact_5855_LIMSEQ__n__over__Suc__n,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ( filterlim @ nat @ A
        @ ^ [N3: nat] : ( divide_divide @ A @ ( semiring_1_of_nat @ A @ N3 ) @ ( semiring_1_of_nat @ A @ ( suc @ N3 ) ) )
        @ ( topolo7230453075368039082e_nhds @ A @ ( one_one @ A ) )
        @ ( at_top @ nat ) ) ) ).

% LIMSEQ_n_over_Suc_n
thf(fact_5856_LIMSEQ__Suc__n__over__n,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ( filterlim @ nat @ A
        @ ^ [N3: nat] : ( divide_divide @ A @ ( semiring_1_of_nat @ A @ ( suc @ N3 ) ) @ ( semiring_1_of_nat @ A @ N3 ) )
        @ ( topolo7230453075368039082e_nhds @ A @ ( one_one @ A ) )
        @ ( at_top @ nat ) ) ) ).

% LIMSEQ_Suc_n_over_n
thf(fact_5857_LIMSEQ__realpow__zero,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less @ real @ X @ ( one_one @ real ) )
       => ( filterlim @ nat @ real @ ( power_power @ real @ X ) @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( at_top @ nat ) ) ) ) ).

% LIMSEQ_realpow_zero
thf(fact_5858_telescope__sums,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: nat > A,C2: A] :
          ( ( filterlim @ nat @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ C2 ) @ ( at_top @ nat ) )
         => ( sums @ A
            @ ^ [N3: nat] : ( minus_minus @ A @ ( F2 @ ( suc @ N3 ) ) @ ( F2 @ N3 ) )
            @ ( minus_minus @ A @ C2 @ ( F2 @ ( zero_zero @ nat ) ) ) ) ) ) ).

% telescope_sums
thf(fact_5859_telescope__sums_H,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: nat > A,C2: A] :
          ( ( filterlim @ nat @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ C2 ) @ ( at_top @ nat ) )
         => ( sums @ A
            @ ^ [N3: nat] : ( minus_minus @ A @ ( F2 @ N3 ) @ ( F2 @ ( suc @ N3 ) ) )
            @ ( minus_minus @ A @ ( F2 @ ( zero_zero @ nat ) ) @ C2 ) ) ) ) ).

% telescope_sums'
thf(fact_5860_LIMSEQ__divide__realpow__zero,axiom,
    ! [X: real,A2: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ X )
     => ( filterlim @ nat @ real
        @ ^ [N3: nat] : ( divide_divide @ real @ A2 @ ( power_power @ real @ X @ N3 ) )
        @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
        @ ( at_top @ nat ) ) ) ).

% LIMSEQ_divide_realpow_zero
thf(fact_5861_LIMSEQ__abs__realpow__zero,axiom,
    ! [C2: real] :
      ( ( ord_less @ real @ ( abs_abs @ real @ C2 ) @ ( one_one @ real ) )
     => ( filterlim @ nat @ real @ ( power_power @ real @ ( abs_abs @ real @ C2 ) ) @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( at_top @ nat ) ) ) ).

% LIMSEQ_abs_realpow_zero
thf(fact_5862_LIMSEQ__abs__realpow__zero2,axiom,
    ! [C2: real] :
      ( ( ord_less @ real @ ( abs_abs @ real @ C2 ) @ ( one_one @ real ) )
     => ( filterlim @ nat @ real @ ( power_power @ real @ C2 ) @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( at_top @ nat ) ) ) ).

% LIMSEQ_abs_realpow_zero2
thf(fact_5863_LIMSEQ__inverse__realpow__zero,axiom,
    ! [X: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ X )
     => ( filterlim @ nat @ real
        @ ^ [N3: nat] : ( inverse_inverse @ real @ ( power_power @ real @ X @ N3 ) )
        @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
        @ ( at_top @ nat ) ) ) ).

% LIMSEQ_inverse_realpow_zero
thf(fact_5864_sums__def_H,axiom,
    ! [A: $tType] :
      ( ( ( comm_monoid_add @ A )
        & ( topolo4958980785337419405_space @ A ) )
     => ( ( sums @ A )
        = ( ^ [F3: nat > A,S6: A] :
              ( filterlim @ nat @ A
              @ ^ [N3: nat] : ( groups7311177749621191930dd_sum @ nat @ A @ F3 @ ( set_or1337092689740270186AtMost @ nat @ ( zero_zero @ nat ) @ N3 ) )
              @ ( topolo7230453075368039082e_nhds @ A @ S6 )
              @ ( at_top @ nat ) ) ) ) ) ).

% sums_def'
thf(fact_5865_root__test__convergence,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach @ A )
     => ! [F2: nat > A,X: real] :
          ( ( filterlim @ nat @ real
            @ ^ [N3: nat] : ( root @ N3 @ ( real_V7770717601297561774m_norm @ A @ ( F2 @ N3 ) ) )
            @ ( topolo7230453075368039082e_nhds @ real @ X )
            @ ( at_top @ nat ) )
         => ( ( ord_less @ real @ X @ ( one_one @ real ) )
           => ( summable @ A @ F2 ) ) ) ) ).

% root_test_convergence
thf(fact_5866_LIMSEQ__inverse__real__of__nat__add__minus,axiom,
    ! [R2: real] :
      ( filterlim @ nat @ real
      @ ^ [N3: nat] : ( plus_plus @ real @ R2 @ ( uminus_uminus @ real @ ( inverse_inverse @ real @ ( semiring_1_of_nat @ real @ ( suc @ N3 ) ) ) ) )
      @ ( topolo7230453075368039082e_nhds @ real @ R2 )
      @ ( at_top @ nat ) ) ).

% LIMSEQ_inverse_real_of_nat_add_minus
thf(fact_5867_LIMSEQ__iff,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X7: nat > A,L5: A] :
          ( ( filterlim @ nat @ A @ X7 @ ( topolo7230453075368039082e_nhds @ A @ L5 ) @ ( at_top @ nat ) )
          = ( ! [R5: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ R5 )
               => ? [No: nat] :
                  ! [N3: nat] :
                    ( ( ord_less_eq @ nat @ No @ N3 )
                   => ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ ( X7 @ N3 ) @ L5 ) ) @ R5 ) ) ) ) ) ) ).

% LIMSEQ_iff
thf(fact_5868_LIMSEQ__I,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X7: nat > A,L5: A] :
          ( ! [R: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ R )
             => ? [No2: nat] :
                ! [N2: nat] :
                  ( ( ord_less_eq @ nat @ No2 @ N2 )
                 => ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ ( X7 @ N2 ) @ L5 ) ) @ R ) ) )
         => ( filterlim @ nat @ A @ X7 @ ( topolo7230453075368039082e_nhds @ A @ L5 ) @ ( at_top @ nat ) ) ) ) ).

% LIMSEQ_I
thf(fact_5869_LIMSEQ__D,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X7: nat > A,L5: A,R2: real] :
          ( ( filterlim @ nat @ A @ X7 @ ( topolo7230453075368039082e_nhds @ A @ L5 ) @ ( at_top @ nat ) )
         => ( ( ord_less @ real @ ( zero_zero @ real ) @ R2 )
           => ? [No3: nat] :
              ! [N7: nat] :
                ( ( ord_less_eq @ nat @ No3 @ N7 )
               => ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ ( X7 @ N7 ) @ L5 ) ) @ R2 ) ) ) ) ) ).

% LIMSEQ_D
thf(fact_5870_LIMSEQ__power__zero,axiom,
    ! [A: $tType] :
      ( ( real_V2822296259951069270ebra_1 @ A )
     => ! [X: A] :
          ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ X ) @ ( one_one @ real ) )
         => ( filterlim @ nat @ A @ ( power_power @ A @ X ) @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) ) @ ( at_top @ nat ) ) ) ) ).

% LIMSEQ_power_zero
thf(fact_5871_tendsto__exp__limit__sequentially,axiom,
    ! [X: real] :
      ( filterlim @ nat @ real
      @ ^ [N3: nat] : ( power_power @ real @ ( plus_plus @ real @ ( one_one @ real ) @ ( divide_divide @ real @ X @ ( semiring_1_of_nat @ real @ N3 ) ) ) @ N3 )
      @ ( topolo7230453075368039082e_nhds @ real @ ( exp @ real @ X ) )
      @ ( at_top @ nat ) ) ).

% tendsto_exp_limit_sequentially
thf(fact_5872_tendsto__power__zero,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V2822296259951069270ebra_1 @ A )
     => ! [F2: B > nat,F4: filter @ B,X: A] :
          ( ( filterlim @ B @ nat @ F2 @ ( at_top @ nat ) @ F4 )
         => ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ X ) @ ( one_one @ real ) )
           => ( filterlim @ B @ A
              @ ^ [Y4: B] : ( power_power @ A @ X @ ( F2 @ Y4 ) )
              @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) )
              @ F4 ) ) ) ) ).

% tendsto_power_zero
thf(fact_5873_LIMSEQ__inverse__real__of__nat__add__minus__mult,axiom,
    ! [R2: real] :
      ( filterlim @ nat @ real
      @ ^ [N3: nat] : ( times_times @ real @ R2 @ ( plus_plus @ real @ ( one_one @ real ) @ ( uminus_uminus @ real @ ( inverse_inverse @ real @ ( semiring_1_of_nat @ real @ ( suc @ N3 ) ) ) ) ) )
      @ ( topolo7230453075368039082e_nhds @ real @ R2 )
      @ ( at_top @ nat ) ) ).

% LIMSEQ_inverse_real_of_nat_add_minus_mult
thf(fact_5874_LIMSEQ__norm__0,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: nat > A] :
          ( ! [N2: nat] : ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( F2 @ N2 ) ) @ ( divide_divide @ real @ ( one_one @ real ) @ ( semiring_1_of_nat @ real @ ( suc @ N2 ) ) ) )
         => ( filterlim @ nat @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) ) @ ( at_top @ nat ) ) ) ) ).

% LIMSEQ_norm_0
thf(fact_5875_summable__Leibniz_I1_J,axiom,
    ! [A2: nat > real] :
      ( ( filterlim @ nat @ real @ A2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( at_top @ nat ) )
     => ( ( topological_monoseq @ real @ A2 )
       => ( summable @ real
          @ ^ [N3: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ N3 ) @ ( A2 @ N3 ) ) ) ) ) ).

% summable_Leibniz(1)
thf(fact_5876_field__derivative__lim__unique,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,Df: A,Z: A,S2: nat > A,A2: A] :
          ( ( has_field_derivative @ A @ F2 @ Df @ ( topolo174197925503356063within @ A @ Z @ ( top_top @ ( set @ A ) ) ) )
         => ( ( filterlim @ nat @ A @ S2 @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) ) @ ( at_top @ nat ) )
           => ( ! [N2: nat] :
                  ( ( S2 @ N2 )
                 != ( zero_zero @ A ) )
             => ( ( filterlim @ nat @ A
                  @ ^ [N3: nat] : ( divide_divide @ A @ ( minus_minus @ A @ ( F2 @ ( plus_plus @ A @ Z @ ( S2 @ N3 ) ) ) @ ( F2 @ Z ) ) @ ( S2 @ N3 ) )
                  @ ( topolo7230453075368039082e_nhds @ A @ A2 )
                  @ ( at_top @ nat ) )
               => ( Df = A2 ) ) ) ) ) ) ).

% field_derivative_lim_unique
thf(fact_5877_powser__times__n__limit__0,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V8999393235501362500lgebra @ A ) )
     => ! [X: A] :
          ( ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ X ) @ ( one_one @ real ) )
         => ( filterlim @ nat @ A
            @ ^ [N3: nat] : ( times_times @ A @ ( semiring_1_of_nat @ A @ N3 ) @ ( power_power @ A @ X @ N3 ) )
            @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) )
            @ ( at_top @ nat ) ) ) ) ).

% powser_times_n_limit_0
thf(fact_5878_lim__n__over__pown,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [X: A] :
          ( ( ord_less @ real @ ( one_one @ real ) @ ( real_V7770717601297561774m_norm @ A @ X ) )
         => ( filterlim @ nat @ A
            @ ^ [N3: nat] : ( divide_divide @ A @ ( semiring_1_of_nat @ A @ N3 ) @ ( power_power @ A @ X @ N3 ) )
            @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) )
            @ ( at_top @ nat ) ) ) ) ).

% lim_n_over_pown
thf(fact_5879_summable,axiom,
    ! [A2: nat > real] :
      ( ( filterlim @ nat @ real @ A2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( at_top @ nat ) )
     => ( ! [N2: nat] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( A2 @ N2 ) )
       => ( ! [N2: nat] : ( ord_less_eq @ real @ ( A2 @ ( suc @ N2 ) ) @ ( A2 @ N2 ) )
         => ( summable @ real
            @ ^ [N3: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ N3 ) @ ( A2 @ N3 ) ) ) ) ) ) ).

% summable
thf(fact_5880_cos__diff__limit__1,axiom,
    ! [Theta: nat > real,Theta2: real] :
      ( ( filterlim @ nat @ real
        @ ^ [J3: nat] : ( cos @ real @ ( minus_minus @ real @ ( Theta @ J3 ) @ Theta2 ) )
        @ ( topolo7230453075368039082e_nhds @ real @ ( one_one @ real ) )
        @ ( at_top @ nat ) )
     => ~ ! [K2: nat > int] :
            ~ ( filterlim @ nat @ real
              @ ^ [J3: nat] : ( minus_minus @ real @ ( Theta @ J3 ) @ ( times_times @ real @ ( ring_1_of_int @ real @ ( K2 @ J3 ) ) @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) ) )
              @ ( topolo7230453075368039082e_nhds @ real @ Theta2 )
              @ ( at_top @ nat ) ) ) ).

% cos_diff_limit_1
thf(fact_5881_cos__limit__1,axiom,
    ! [Theta: nat > real] :
      ( ( filterlim @ nat @ real
        @ ^ [J3: nat] : ( cos @ real @ ( Theta @ J3 ) )
        @ ( topolo7230453075368039082e_nhds @ real @ ( one_one @ real ) )
        @ ( at_top @ nat ) )
     => ? [K2: nat > int] :
          ( filterlim @ nat @ real
          @ ^ [J3: nat] : ( minus_minus @ real @ ( Theta @ J3 ) @ ( times_times @ real @ ( ring_1_of_int @ real @ ( K2 @ J3 ) ) @ ( times_times @ real @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) @ pi ) ) )
          @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
          @ ( at_top @ nat ) ) ) ).

% cos_limit_1
thf(fact_5882_summable__Leibniz_I4_J,axiom,
    ! [A2: nat > real] :
      ( ( filterlim @ nat @ real @ A2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( at_top @ nat ) )
     => ( ( topological_monoseq @ real @ A2 )
       => ( filterlim @ nat @ real
          @ ^ [N3: nat] :
              ( groups7311177749621191930dd_sum @ nat @ real
              @ ^ [I4: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I4 ) @ ( A2 @ I4 ) )
              @ ( set_ord_lessThan @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N3 ) ) )
          @ ( topolo7230453075368039082e_nhds @ real
            @ ( suminf @ real
              @ ^ [I4: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I4 ) @ ( A2 @ I4 ) ) ) )
          @ ( at_top @ nat ) ) ) ) ).

% summable_Leibniz(4)
thf(fact_5883_zeroseq__arctan__series,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( abs_abs @ real @ X ) @ ( one_one @ real ) )
     => ( filterlim @ nat @ real
        @ ^ [N3: nat] : ( times_times @ real @ ( divide_divide @ real @ ( one_one @ real ) @ ( semiring_1_of_nat @ real @ ( plus_plus @ nat @ ( times_times @ nat @ N3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ nat ) ) ) ) @ ( power_power @ real @ X @ ( plus_plus @ nat @ ( times_times @ nat @ N3 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ ( one_one @ nat ) ) ) )
        @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
        @ ( at_top @ nat ) ) ) ).

% zeroseq_arctan_series
thf(fact_5884_summable__Leibniz_H_I2_J,axiom,
    ! [A2: nat > real,N: nat] :
      ( ( filterlim @ nat @ real @ A2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( at_top @ nat ) )
     => ( ! [N2: nat] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( A2 @ N2 ) )
       => ( ! [N2: nat] : ( ord_less_eq @ real @ ( A2 @ ( suc @ N2 ) ) @ ( A2 @ N2 ) )
         => ( ord_less_eq @ real
            @ ( groups7311177749621191930dd_sum @ nat @ real
              @ ^ [I4: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I4 ) @ ( A2 @ I4 ) )
              @ ( set_ord_lessThan @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) )
            @ ( suminf @ real
              @ ^ [I4: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I4 ) @ ( A2 @ I4 ) ) ) ) ) ) ) ).

% summable_Leibniz'(2)
thf(fact_5885_summable__Leibniz_H_I3_J,axiom,
    ! [A2: nat > real] :
      ( ( filterlim @ nat @ real @ A2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( at_top @ nat ) )
     => ( ! [N2: nat] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( A2 @ N2 ) )
       => ( ! [N2: nat] : ( ord_less_eq @ real @ ( A2 @ ( suc @ N2 ) ) @ ( A2 @ N2 ) )
         => ( filterlim @ nat @ real
            @ ^ [N3: nat] :
                ( groups7311177749621191930dd_sum @ nat @ real
                @ ^ [I4: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I4 ) @ ( A2 @ I4 ) )
                @ ( set_ord_lessThan @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N3 ) ) )
            @ ( topolo7230453075368039082e_nhds @ real
              @ ( suminf @ real
                @ ^ [I4: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I4 ) @ ( A2 @ I4 ) ) ) )
            @ ( at_top @ nat ) ) ) ) ) ).

% summable_Leibniz'(3)
thf(fact_5886_sums__alternating__upper__lower,axiom,
    ! [A2: nat > real] :
      ( ! [N2: nat] : ( ord_less_eq @ real @ ( A2 @ ( suc @ N2 ) ) @ ( A2 @ N2 ) )
     => ( ! [N2: nat] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( A2 @ N2 ) )
       => ( ( filterlim @ nat @ real @ A2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( at_top @ nat ) )
         => ? [L3: real] :
              ( ! [N7: nat] :
                  ( ord_less_eq @ real
                  @ ( groups7311177749621191930dd_sum @ nat @ real
                    @ ^ [I4: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I4 ) @ ( A2 @ I4 ) )
                    @ ( set_ord_lessThan @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N7 ) ) )
                  @ L3 )
              & ( filterlim @ nat @ real
                @ ^ [N3: nat] :
                    ( groups7311177749621191930dd_sum @ nat @ real
                    @ ^ [I4: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I4 ) @ ( A2 @ I4 ) )
                    @ ( set_ord_lessThan @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N3 ) ) )
                @ ( topolo7230453075368039082e_nhds @ real @ L3 )
                @ ( at_top @ nat ) )
              & ! [N7: nat] :
                  ( ord_less_eq @ real @ L3
                  @ ( groups7311177749621191930dd_sum @ nat @ real
                    @ ^ [I4: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I4 ) @ ( A2 @ I4 ) )
                    @ ( set_ord_lessThan @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N7 ) @ ( one_one @ nat ) ) ) ) )
              & ( filterlim @ nat @ real
                @ ^ [N3: nat] :
                    ( groups7311177749621191930dd_sum @ nat @ real
                    @ ^ [I4: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I4 ) @ ( A2 @ I4 ) )
                    @ ( set_ord_lessThan @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N3 ) @ ( one_one @ nat ) ) ) )
                @ ( topolo7230453075368039082e_nhds @ real @ L3 )
                @ ( at_top @ nat ) ) ) ) ) ) ).

% sums_alternating_upper_lower
thf(fact_5887_summable__Leibniz_I5_J,axiom,
    ! [A2: nat > real] :
      ( ( filterlim @ nat @ real @ A2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( at_top @ nat ) )
     => ( ( topological_monoseq @ real @ A2 )
       => ( filterlim @ nat @ real
          @ ^ [N3: nat] :
              ( groups7311177749621191930dd_sum @ nat @ real
              @ ^ [I4: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I4 ) @ ( A2 @ I4 ) )
              @ ( set_ord_lessThan @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N3 ) @ ( one_one @ nat ) ) ) )
          @ ( topolo7230453075368039082e_nhds @ real
            @ ( suminf @ real
              @ ^ [I4: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I4 ) @ ( A2 @ I4 ) ) ) )
          @ ( at_top @ nat ) ) ) ) ).

% summable_Leibniz(5)
thf(fact_5888_summable__Leibniz_H_I4_J,axiom,
    ! [A2: nat > real,N: nat] :
      ( ( filterlim @ nat @ real @ A2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( at_top @ nat ) )
     => ( ! [N2: nat] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( A2 @ N2 ) )
       => ( ! [N2: nat] : ( ord_less_eq @ real @ ( A2 @ ( suc @ N2 ) ) @ ( A2 @ N2 ) )
         => ( ord_less_eq @ real
            @ ( suminf @ real
              @ ^ [I4: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I4 ) @ ( A2 @ I4 ) ) )
            @ ( groups7311177749621191930dd_sum @ nat @ real
              @ ^ [I4: nat] : ( times_times @ real @ ( power_power @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ I4 ) @ ( A2 @ I4 ) )
              @ ( set_ord_lessThan @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) @ ( one_one @ nat ) ) ) ) ) ) ) ) ).

% summable_Leibniz'(4)
thf(fact_5889_has__derivative__at2,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F2: A > B,F5: A > B,X: A] :
          ( ( has_derivative @ A @ B @ F2 @ F5 @ ( topolo174197925503356063within @ A @ X @ ( top_top @ ( set @ A ) ) ) )
          = ( ( real_V3181309239436604168linear @ A @ B @ F5 )
            & ( filterlim @ A @ B
              @ ^ [Y4: A] : ( real_V8093663219630862766scaleR @ B @ ( divide_divide @ real @ ( one_one @ real ) @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ Y4 @ X ) ) ) @ ( minus_minus @ B @ ( F2 @ Y4 ) @ ( plus_plus @ B @ ( F2 @ X ) @ ( F5 @ ( minus_minus @ A @ Y4 @ X ) ) ) ) )
              @ ( topolo7230453075368039082e_nhds @ B @ ( zero_zero @ B ) )
              @ ( topolo174197925503356063within @ A @ X @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ).

% has_derivative_at2
thf(fact_5890_has__derivative__at,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F2: A > B,D5: A > B,X: A] :
          ( ( has_derivative @ A @ B @ F2 @ D5 @ ( topolo174197925503356063within @ A @ X @ ( top_top @ ( set @ A ) ) ) )
          = ( ( real_V3181309239436604168linear @ A @ B @ D5 )
            & ( filterlim @ A @ real
              @ ^ [H: A] : ( divide_divide @ real @ ( real_V7770717601297561774m_norm @ B @ ( minus_minus @ B @ ( minus_minus @ B @ ( F2 @ ( plus_plus @ A @ X @ H ) ) @ ( F2 @ X ) ) @ ( D5 @ H ) ) ) @ ( real_V7770717601297561774m_norm @ A @ H ) )
              @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
              @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ).

% has_derivative_at
thf(fact_5891_has__derivative__within,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F2: A > B,F5: A > B,X: A,S2: set @ A] :
          ( ( has_derivative @ A @ B @ F2 @ F5 @ ( topolo174197925503356063within @ A @ X @ S2 ) )
          = ( ( real_V3181309239436604168linear @ A @ B @ F5 )
            & ( filterlim @ A @ B
              @ ^ [Y4: A] : ( real_V8093663219630862766scaleR @ B @ ( divide_divide @ real @ ( one_one @ real ) @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ Y4 @ X ) ) ) @ ( minus_minus @ B @ ( F2 @ Y4 ) @ ( plus_plus @ B @ ( F2 @ X ) @ ( F5 @ ( minus_minus @ A @ Y4 @ X ) ) ) ) )
              @ ( topolo7230453075368039082e_nhds @ B @ ( zero_zero @ B ) )
              @ ( topolo174197925503356063within @ A @ X @ S2 ) ) ) ) ) ).

% has_derivative_within
thf(fact_5892_bounded__linear__zero,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ( real_V3181309239436604168linear @ A @ B
        @ ^ [X2: A] : ( zero_zero @ B ) ) ) ).

% bounded_linear_zero
thf(fact_5893_bounded__linear_Obounded,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F2: A > B] :
          ( ( real_V3181309239436604168linear @ A @ B @ F2 )
         => ? [K9: real] :
            ! [X5: A] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ B @ ( F2 @ X5 ) ) @ ( times_times @ real @ ( real_V7770717601297561774m_norm @ A @ X5 ) @ K9 ) ) ) ) ).

% bounded_linear.bounded
thf(fact_5894_bounded__linear_Otendsto__zero,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F2: A > B,G: C > A,F4: filter @ C] :
          ( ( real_V3181309239436604168linear @ A @ B @ F2 )
         => ( ( filterlim @ C @ A @ G @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) ) @ F4 )
           => ( filterlim @ C @ B
              @ ^ [X2: C] : ( F2 @ ( G @ X2 ) )
              @ ( topolo7230453075368039082e_nhds @ B @ ( zero_zero @ B ) )
              @ F4 ) ) ) ) ).

% bounded_linear.tendsto_zero
thf(fact_5895_bounded__linear_Ononneg__bounded,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F2: A > B] :
          ( ( real_V3181309239436604168linear @ A @ B @ F2 )
         => ? [K9: real] :
              ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ K9 )
              & ! [X5: A] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ B @ ( F2 @ X5 ) ) @ ( times_times @ real @ ( real_V7770717601297561774m_norm @ A @ X5 ) @ K9 ) ) ) ) ) ).

% bounded_linear.nonneg_bounded
thf(fact_5896_bounded__linear_Opos__bounded,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F2: A > B] :
          ( ( real_V3181309239436604168linear @ A @ B @ F2 )
         => ? [K9: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ K9 )
              & ! [X5: A] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ B @ ( F2 @ X5 ) ) @ ( times_times @ real @ ( real_V7770717601297561774m_norm @ A @ X5 ) @ K9 ) ) ) ) ) ).

% bounded_linear.pos_bounded
thf(fact_5897_bounded__linear__intro,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F2: A > B,K6: real] :
          ( ! [X3: A,Y5: A] :
              ( ( F2 @ ( plus_plus @ A @ X3 @ Y5 ) )
              = ( plus_plus @ B @ ( F2 @ X3 ) @ ( F2 @ Y5 ) ) )
         => ( ! [R: real,X3: A] :
                ( ( F2 @ ( real_V8093663219630862766scaleR @ A @ R @ X3 ) )
                = ( real_V8093663219630862766scaleR @ B @ R @ ( F2 @ X3 ) ) )
           => ( ! [X3: A] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ B @ ( F2 @ X3 ) ) @ ( times_times @ real @ ( real_V7770717601297561774m_norm @ A @ X3 ) @ K6 ) )
             => ( real_V3181309239436604168linear @ A @ B @ F2 ) ) ) ) ) ).

% bounded_linear_intro
thf(fact_5898_has__derivative__iff__norm,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F2: A > B,F5: A > B,X: A,S2: set @ A] :
          ( ( has_derivative @ A @ B @ F2 @ F5 @ ( topolo174197925503356063within @ A @ X @ S2 ) )
          = ( ( real_V3181309239436604168linear @ A @ B @ F5 )
            & ( filterlim @ A @ real
              @ ^ [Y4: A] : ( divide_divide @ real @ ( real_V7770717601297561774m_norm @ B @ ( minus_minus @ B @ ( minus_minus @ B @ ( F2 @ Y4 ) @ ( F2 @ X ) ) @ ( F5 @ ( minus_minus @ A @ Y4 @ X ) ) ) ) @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ Y4 @ X ) ) )
              @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
              @ ( topolo174197925503356063within @ A @ X @ S2 ) ) ) ) ) ).

% has_derivative_iff_norm
thf(fact_5899_has__derivativeI,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F5: A > B,X: A,F2: A > B,S2: set @ A] :
          ( ( real_V3181309239436604168linear @ A @ B @ F5 )
         => ( ( filterlim @ A @ B
              @ ^ [Y4: A] : ( real_V8093663219630862766scaleR @ B @ ( inverse_inverse @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ Y4 @ X ) ) ) @ ( minus_minus @ B @ ( minus_minus @ B @ ( F2 @ Y4 ) @ ( F2 @ X ) ) @ ( F5 @ ( minus_minus @ A @ Y4 @ X ) ) ) )
              @ ( topolo7230453075368039082e_nhds @ B @ ( zero_zero @ B ) )
              @ ( topolo174197925503356063within @ A @ X @ S2 ) )
           => ( has_derivative @ A @ B @ F2 @ F5 @ ( topolo174197925503356063within @ A @ X @ S2 ) ) ) ) ) ).

% has_derivativeI
thf(fact_5900_has__derivative__at__within,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F2: A > B,F5: A > B,X: A,S2: set @ A] :
          ( ( has_derivative @ A @ B @ F2 @ F5 @ ( topolo174197925503356063within @ A @ X @ S2 ) )
          = ( ( real_V3181309239436604168linear @ A @ B @ F5 )
            & ( filterlim @ A @ B
              @ ^ [Y4: A] : ( real_V8093663219630862766scaleR @ B @ ( inverse_inverse @ real @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ Y4 @ X ) ) ) @ ( minus_minus @ B @ ( minus_minus @ B @ ( F2 @ Y4 ) @ ( F2 @ X ) ) @ ( F5 @ ( minus_minus @ A @ Y4 @ X ) ) ) )
              @ ( topolo7230453075368039082e_nhds @ B @ ( zero_zero @ B ) )
              @ ( topolo174197925503356063within @ A @ X @ S2 ) ) ) ) ) ).

% has_derivative_at_within
thf(fact_5901_has__derivative__iff__Ex,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F2: A > B,F5: A > B,X: A] :
          ( ( has_derivative @ A @ B @ F2 @ F5 @ ( topolo174197925503356063within @ A @ X @ ( top_top @ ( set @ A ) ) ) )
          = ( ( real_V3181309239436604168linear @ A @ B @ F5 )
            & ? [E3: A > B] :
                ( ! [H: A] :
                    ( ( F2 @ ( plus_plus @ A @ X @ H ) )
                    = ( plus_plus @ B @ ( plus_plus @ B @ ( F2 @ X ) @ ( F5 @ H ) ) @ ( E3 @ H ) ) )
                & ( filterlim @ A @ real
                  @ ^ [H: A] : ( divide_divide @ real @ ( real_V7770717601297561774m_norm @ B @ ( E3 @ H ) ) @ ( real_V7770717601297561774m_norm @ A @ H ) )
                  @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
                  @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ) ).

% has_derivative_iff_Ex
thf(fact_5902_has__derivative__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ( ( has_derivative @ A @ B )
        = ( ^ [F3: A > B,F7: A > B,F8: filter @ A] :
              ( ( real_V3181309239436604168linear @ A @ B @ F7 )
              & ( filterlim @ A @ B
                @ ^ [Y4: A] :
                    ( real_V8093663219630862766scaleR @ B
                    @ ( inverse_inverse @ real
                      @ ( real_V7770717601297561774m_norm @ A
                        @ ( minus_minus @ A @ Y4
                          @ ( topolo3827282254853284352ce_Lim @ A @ A @ F8
                            @ ^ [X2: A] : X2 ) ) ) )
                    @ ( minus_minus @ B
                      @ ( minus_minus @ B @ ( F3 @ Y4 )
                        @ ( F3
                          @ ( topolo3827282254853284352ce_Lim @ A @ A @ F8
                            @ ^ [X2: A] : X2 ) ) )
                      @ ( F7
                        @ ( minus_minus @ A @ Y4
                          @ ( topolo3827282254853284352ce_Lim @ A @ A @ F8
                            @ ^ [X2: A] : X2 ) ) ) ) )
                @ ( topolo7230453075368039082e_nhds @ B @ ( zero_zero @ B ) )
                @ F8 ) ) ) ) ) ).

% has_derivative_def
thf(fact_5903_has__derivative__at__within__iff__Ex,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [X: A,S: set @ A,F2: A > B,F5: A > B] :
          ( ( member @ A @ X @ S )
         => ( ( topolo1002775350975398744n_open @ A @ S )
           => ( ( has_derivative @ A @ B @ F2 @ F5 @ ( topolo174197925503356063within @ A @ X @ S ) )
              = ( ( real_V3181309239436604168linear @ A @ B @ F5 )
                & ? [E3: A > B] :
                    ( ! [H: A] :
                        ( ( member @ A @ ( plus_plus @ A @ X @ H ) @ S )
                       => ( ( F2 @ ( plus_plus @ A @ X @ H ) )
                          = ( plus_plus @ B @ ( plus_plus @ B @ ( F2 @ X ) @ ( F5 @ H ) ) @ ( E3 @ H ) ) ) )
                    & ( filterlim @ A @ real
                      @ ^ [H: A] : ( divide_divide @ real @ ( real_V7770717601297561774m_norm @ B @ ( E3 @ H ) ) @ ( real_V7770717601297561774m_norm @ A @ H ) )
                      @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
                      @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ) ) ) ).

% has_derivative_at_within_iff_Ex
thf(fact_5904_String_Ochar__of__ascii__of,axiom,
    ! [C2: char] :
      ( ( comm_s6883823935334413003f_char @ nat @ ( ascii_of @ C2 ) )
      = ( bit_se2584673776208193580ke_bit @ nat @ ( numeral_numeral @ nat @ ( bit1 @ ( bit1 @ one2 ) ) ) @ ( comm_s6883823935334413003f_char @ nat @ C2 ) ) ) ).

% String.char_of_ascii_of
thf(fact_5905_Inf__notin__open,axiom,
    ! [A: $tType] :
      ( ( topolo8458572112393995274pology @ A )
     => ! [A4: set @ A,X: A] :
          ( ( topolo1002775350975398744n_open @ A @ A4 )
         => ( ! [X3: A] :
                ( ( member @ A @ X3 @ A4 )
               => ( ord_less @ A @ X @ X3 ) )
           => ~ ( member @ A @ ( complete_Inf_Inf @ A @ A4 ) @ A4 ) ) ) ) ).

% Inf_notin_open
thf(fact_5906_Sup__notin__open,axiom,
    ! [A: $tType] :
      ( ( topolo8458572112393995274pology @ A )
     => ! [A4: set @ A,X: A] :
          ( ( topolo1002775350975398744n_open @ A @ A4 )
         => ( ! [X3: A] :
                ( ( member @ A @ X3 @ A4 )
               => ( ord_less @ A @ X3 @ X ) )
           => ~ ( member @ A @ ( complete_Sup_Sup @ A @ A4 ) @ A4 ) ) ) ) ).

% Sup_notin_open
thf(fact_5907_open__right,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [S: set @ A,X: A,Y: A] :
          ( ( topolo1002775350975398744n_open @ A @ S )
         => ( ( member @ A @ X @ S )
           => ( ( ord_less @ A @ X @ Y )
             => ? [B4: A] :
                  ( ( ord_less @ A @ X @ B4 )
                  & ( ord_less_eq @ ( set @ A ) @ ( set_or7035219750837199246ssThan @ A @ X @ B4 ) @ S ) ) ) ) ) ) ).

% open_right
thf(fact_5908_lim__explicit,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [F2: nat > A,F0: A] :
          ( ( filterlim @ nat @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ F0 ) @ ( at_top @ nat ) )
          = ( ! [S8: set @ A] :
                ( ( topolo1002775350975398744n_open @ A @ S8 )
               => ( ( member @ A @ F0 @ S8 )
                 => ? [N6: nat] :
                    ! [N3: nat] :
                      ( ( ord_less_eq @ nat @ N6 @ N3 )
                     => ( member @ A @ ( F2 @ N3 ) @ S8 ) ) ) ) ) ) ) ).

% lim_explicit
thf(fact_5909_continuous__divide,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topological_t2_space @ A )
        & ( real_V3459762299906320749_field @ B ) )
     => ! [F4: filter @ A,F2: A > B,G: A > B] :
          ( ( topolo3448309680560233919inuous @ A @ B @ F4 @ F2 )
         => ( ( topolo3448309680560233919inuous @ A @ B @ F4 @ G )
           => ( ( ( G
                  @ ( topolo3827282254853284352ce_Lim @ A @ A @ F4
                    @ ^ [X2: A] : X2 ) )
               != ( zero_zero @ B ) )
             => ( topolo3448309680560233919inuous @ A @ B @ F4
                @ ^ [X2: A] : ( divide_divide @ B @ ( F2 @ X2 ) @ ( G @ X2 ) ) ) ) ) ) ) ).

% continuous_divide
thf(fact_5910_continuous__inverse,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topological_t2_space @ A )
        & ( real_V8999393235501362500lgebra @ B ) )
     => ! [F4: filter @ A,F2: A > B] :
          ( ( topolo3448309680560233919inuous @ A @ B @ F4 @ F2 )
         => ( ( ( F2
                @ ( topolo3827282254853284352ce_Lim @ A @ A @ F4
                  @ ^ [X2: A] : X2 ) )
             != ( zero_zero @ B ) )
           => ( topolo3448309680560233919inuous @ A @ B @ F4
              @ ^ [X2: A] : ( inverse_inverse @ B @ ( F2 @ X2 ) ) ) ) ) ) ).

% continuous_inverse
thf(fact_5911_continuous__sgn,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topological_t2_space @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F4: filter @ A,F2: A > B] :
          ( ( topolo3448309680560233919inuous @ A @ B @ F4 @ F2 )
         => ( ( ( F2
                @ ( topolo3827282254853284352ce_Lim @ A @ A @ F4
                  @ ^ [X2: A] : X2 ) )
             != ( zero_zero @ B ) )
           => ( topolo3448309680560233919inuous @ A @ B @ F4
              @ ^ [X2: A] : ( sgn_sgn @ B @ ( F2 @ X2 ) ) ) ) ) ) ).

% continuous_sgn
thf(fact_5912_continuous__powr,axiom,
    ! [A: $tType] :
      ( ( topological_t2_space @ A )
     => ! [F4: filter @ A,F2: A > real,G: A > real] :
          ( ( topolo3448309680560233919inuous @ A @ real @ F4 @ F2 )
         => ( ( topolo3448309680560233919inuous @ A @ real @ F4 @ G )
           => ( ( ( F2
                  @ ( topolo3827282254853284352ce_Lim @ A @ A @ F4
                    @ ^ [X2: A] : X2 ) )
               != ( zero_zero @ real ) )
             => ( topolo3448309680560233919inuous @ A @ real @ F4
                @ ^ [X2: A] : ( powr @ real @ ( F2 @ X2 ) @ ( G @ X2 ) ) ) ) ) ) ) ).

% continuous_powr
thf(fact_5913_continuous__ln,axiom,
    ! [A: $tType] :
      ( ( topological_t2_space @ A )
     => ! [F4: filter @ A,F2: A > real] :
          ( ( topolo3448309680560233919inuous @ A @ real @ F4 @ F2 )
         => ( ( ( F2
                @ ( topolo3827282254853284352ce_Lim @ A @ A @ F4
                  @ ^ [X2: A] : X2 ) )
             != ( zero_zero @ real ) )
           => ( topolo3448309680560233919inuous @ A @ real @ F4
              @ ^ [X2: A] : ( ln_ln @ real @ ( F2 @ X2 ) ) ) ) ) ) ).

% continuous_ln
thf(fact_5914_continuous__tan,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [F4: filter @ A,F2: A > A] :
          ( ( topolo3448309680560233919inuous @ A @ A @ F4 @ F2 )
         => ( ( ( cos @ A
                @ ( F2
                  @ ( topolo3827282254853284352ce_Lim @ A @ A @ F4
                    @ ^ [X2: A] : X2 ) ) )
             != ( zero_zero @ A ) )
           => ( topolo3448309680560233919inuous @ A @ A @ F4
              @ ^ [X2: A] : ( tan @ A @ ( F2 @ X2 ) ) ) ) ) ) ).

% continuous_tan
thf(fact_5915_continuous__cot,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [F4: filter @ A,F2: A > A] :
          ( ( topolo3448309680560233919inuous @ A @ A @ F4 @ F2 )
         => ( ( ( sin @ A
                @ ( F2
                  @ ( topolo3827282254853284352ce_Lim @ A @ A @ F4
                    @ ^ [X2: A] : X2 ) ) )
             != ( zero_zero @ A ) )
           => ( topolo3448309680560233919inuous @ A @ A @ F4
              @ ^ [X2: A] : ( cot @ A @ ( F2 @ X2 ) ) ) ) ) ) ).

% continuous_cot
thf(fact_5916_continuous__tanh,axiom,
    ! [A: $tType,C: $tType] :
      ( ( ( topological_t2_space @ C )
        & ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [F4: filter @ C,F2: C > A] :
          ( ( topolo3448309680560233919inuous @ C @ A @ F4 @ F2 )
         => ( ( ( cosh @ A
                @ ( F2
                  @ ( topolo3827282254853284352ce_Lim @ C @ C @ F4
                    @ ^ [X2: C] : X2 ) ) )
             != ( zero_zero @ A ) )
           => ( topolo3448309680560233919inuous @ C @ A @ F4
              @ ^ [X2: C] : ( tanh @ A @ ( F2 @ X2 ) ) ) ) ) ) ).

% continuous_tanh
thf(fact_5917_continuous__arcosh,axiom,
    ! [A: $tType] :
      ( ( topological_t2_space @ A )
     => ! [F4: filter @ A,F2: A > real] :
          ( ( topolo3448309680560233919inuous @ A @ real @ F4 @ F2 )
         => ( ( ord_less @ real @ ( one_one @ real )
              @ ( F2
                @ ( topolo3827282254853284352ce_Lim @ A @ A @ F4
                  @ ^ [X2: A] : X2 ) ) )
           => ( topolo3448309680560233919inuous @ A @ real @ F4
              @ ^ [X2: A] : ( arcosh @ real @ ( F2 @ X2 ) ) ) ) ) ) ).

% continuous_arcosh
thf(fact_5918_tendsto__offset__zero__iff,axiom,
    ! [C: $tType,D: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( topolo4958980785337419405_space @ D )
        & ( zero @ C ) )
     => ! [A2: A,S: set @ A,F2: A > D,L5: D] :
          ( ( nO_MATCH @ C @ A @ ( zero_zero @ C ) @ A2 )
         => ( ( member @ A @ A2 @ S )
           => ( ( topolo1002775350975398744n_open @ A @ S )
             => ( ( filterlim @ A @ D @ F2 @ ( topolo7230453075368039082e_nhds @ D @ L5 ) @ ( topolo174197925503356063within @ A @ A2 @ S ) )
                = ( filterlim @ A @ D
                  @ ^ [H: A] : ( F2 @ ( plus_plus @ A @ A2 @ H ) )
                  @ ( topolo7230453075368039082e_nhds @ D @ L5 )
                  @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ) ) ).

% tendsto_offset_zero_iff
thf(fact_5919_continuous__log,axiom,
    ! [A: $tType] :
      ( ( topological_t2_space @ A )
     => ! [F4: filter @ A,F2: A > real,G: A > real] :
          ( ( topolo3448309680560233919inuous @ A @ real @ F4 @ F2 )
         => ( ( topolo3448309680560233919inuous @ A @ real @ F4 @ G )
           => ( ( ord_less @ real @ ( zero_zero @ real )
                @ ( F2
                  @ ( topolo3827282254853284352ce_Lim @ A @ A @ F4
                    @ ^ [X2: A] : X2 ) ) )
             => ( ( ( F2
                    @ ( topolo3827282254853284352ce_Lim @ A @ A @ F4
                      @ ^ [X2: A] : X2 ) )
                 != ( one_one @ real ) )
               => ( ( ord_less @ real @ ( zero_zero @ real )
                    @ ( G
                      @ ( topolo3827282254853284352ce_Lim @ A @ A @ F4
                        @ ^ [X2: A] : X2 ) ) )
                 => ( topolo3448309680560233919inuous @ A @ real @ F4
                    @ ^ [X2: A] : ( log2 @ ( F2 @ X2 ) @ ( G @ X2 ) ) ) ) ) ) ) ) ) ).

% continuous_log
thf(fact_5920_has__derivativeI__sandwich,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [E2: real,F5: A > B,S2: set @ A,X: A,F2: A > B,H6: A > real] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ E2 )
         => ( ( real_V3181309239436604168linear @ A @ B @ F5 )
           => ( ! [Y5: A] :
                  ( ( member @ A @ Y5 @ S2 )
                 => ( ( Y5 != X )
                   => ( ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ Y5 @ X ) @ E2 )
                     => ( ord_less_eq @ real @ ( divide_divide @ real @ ( real_V7770717601297561774m_norm @ B @ ( minus_minus @ B @ ( minus_minus @ B @ ( F2 @ Y5 ) @ ( F2 @ X ) ) @ ( F5 @ ( minus_minus @ A @ Y5 @ X ) ) ) ) @ ( real_V7770717601297561774m_norm @ A @ ( minus_minus @ A @ Y5 @ X ) ) ) @ ( H6 @ Y5 ) ) ) ) )
             => ( ( filterlim @ A @ real @ H6 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( topolo174197925503356063within @ A @ X @ S2 ) )
               => ( has_derivative @ A @ B @ F2 @ F5 @ ( topolo174197925503356063within @ A @ X @ S2 ) ) ) ) ) ) ) ).

% has_derivativeI_sandwich
thf(fact_5921_tendsto__exp__limit__at__right,axiom,
    ! [X: real] :
      ( filterlim @ real @ real
      @ ^ [Y4: real] : ( powr @ real @ ( plus_plus @ real @ ( one_one @ real ) @ ( times_times @ real @ X @ Y4 ) ) @ ( divide_divide @ real @ ( one_one @ real ) @ Y4 ) )
      @ ( topolo7230453075368039082e_nhds @ real @ ( exp @ real @ X ) )
      @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) ) ).

% tendsto_exp_limit_at_right
thf(fact_5922_tendsto__arctan__at__bot,axiom,
    filterlim @ real @ real @ arctan @ ( topolo7230453075368039082e_nhds @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) @ ( at_bot @ real ) ).

% tendsto_arctan_at_bot
thf(fact_5923_greaterThan__iff,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [I: A,K: A] :
          ( ( member @ A @ I @ ( set_ord_greaterThan @ A @ K ) )
          = ( ord_less @ A @ K @ I ) ) ) ).

% greaterThan_iff
thf(fact_5924_dist__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X: A,Y: A] :
          ( ( ( real_V557655796197034286t_dist @ A @ X @ Y )
            = ( zero_zero @ real ) )
          = ( X = Y ) ) ) ).

% dist_eq_0_iff
thf(fact_5925_dist__self,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X: A] :
          ( ( real_V557655796197034286t_dist @ A @ X @ X )
          = ( zero_zero @ real ) ) ) ).

% dist_self
thf(fact_5926_cInf__greaterThan,axiom,
    ! [A: $tType] :
      ( ( ( condit6923001295902523014norder @ A )
        & ( dense_linorder @ A )
        & ( no_top @ A ) )
     => ! [X: A] :
          ( ( complete_Inf_Inf @ A @ ( set_ord_greaterThan @ A @ X ) )
          = X ) ) ).

% cInf_greaterThan
thf(fact_5927_greaterThan__subset__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ ( set @ A ) @ ( set_ord_greaterThan @ A @ X ) @ ( set_ord_greaterThan @ A @ Y ) )
          = ( ord_less_eq @ A @ Y @ X ) ) ) ).

% greaterThan_subset_iff
thf(fact_5928_dist__0__norm,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X: A] :
          ( ( real_V557655796197034286t_dist @ A @ ( zero_zero @ A ) @ X )
          = ( real_V7770717601297561774m_norm @ A @ X ) ) ) ).

% dist_0_norm
thf(fact_5929_zero__less__dist__iff,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ ( real_V557655796197034286t_dist @ A @ X @ Y ) )
          = ( ( X != Y ) ) ) ) ).

% zero_less_dist_iff
thf(fact_5930_dist__le__zero__iff,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ real @ ( real_V557655796197034286t_dist @ A @ X @ Y ) @ ( zero_zero @ real ) )
          = ( X = Y ) ) ) ).

% dist_le_zero_iff
thf(fact_5931_Sup__greaterThanAtLeast,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [X: A] :
          ( ( ord_less @ A @ X @ ( top_top @ A ) )
         => ( ( complete_Sup_Sup @ A @ ( set_ord_greaterThan @ A @ X ) )
            = ( top_top @ A ) ) ) ) ).

% Sup_greaterThanAtLeast
thf(fact_5932_ln__at__0,axiom,
    filterlim @ real @ real @ ( ln_ln @ real ) @ ( at_bot @ real ) @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) ).

% ln_at_0
thf(fact_5933_lessThan__Int__lessThan,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A] :
          ( ( inf_inf @ ( set @ A ) @ ( set_ord_greaterThan @ A @ A2 ) @ ( set_ord_greaterThan @ A @ B2 ) )
          = ( set_ord_greaterThan @ A @ ( ord_max @ A @ A2 @ B2 ) ) ) ) ).

% lessThan_Int_lessThan
thf(fact_5934_dist__triangle__le,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X: A,Z: A,Y: A,E2: real] :
          ( ( ord_less_eq @ real @ ( plus_plus @ real @ ( real_V557655796197034286t_dist @ A @ X @ Z ) @ ( real_V557655796197034286t_dist @ A @ Y @ Z ) ) @ E2 )
         => ( ord_less_eq @ real @ ( real_V557655796197034286t_dist @ A @ X @ Y ) @ E2 ) ) ) ).

% dist_triangle_le
thf(fact_5935_dist__triangle3,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X: A,Y: A,A2: A] : ( ord_less_eq @ real @ ( real_V557655796197034286t_dist @ A @ X @ Y ) @ ( plus_plus @ real @ ( real_V557655796197034286t_dist @ A @ A2 @ X ) @ ( real_V557655796197034286t_dist @ A @ A2 @ Y ) ) ) ) ).

% dist_triangle3
thf(fact_5936_dist__triangle2,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X: A,Y: A,Z: A] : ( ord_less_eq @ real @ ( real_V557655796197034286t_dist @ A @ X @ Y ) @ ( plus_plus @ real @ ( real_V557655796197034286t_dist @ A @ X @ Z ) @ ( real_V557655796197034286t_dist @ A @ Y @ Z ) ) ) ) ).

% dist_triangle2
thf(fact_5937_dist__triangle,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X: A,Z: A,Y: A] : ( ord_less_eq @ real @ ( real_V557655796197034286t_dist @ A @ X @ Z ) @ ( plus_plus @ real @ ( real_V557655796197034286t_dist @ A @ X @ Y ) @ ( real_V557655796197034286t_dist @ A @ Y @ Z ) ) ) ) ).

% dist_triangle
thf(fact_5938_zero__le__dist,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X: A,Y: A] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( real_V557655796197034286t_dist @ A @ X @ Y ) ) ) ).

% zero_le_dist
thf(fact_5939_greaterThan__def,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ( ( set_ord_greaterThan @ A )
        = ( ^ [L2: A] : ( collect @ A @ ( ord_less @ A @ L2 ) ) ) ) ) ).

% greaterThan_def
thf(fact_5940_dist__commute__lessI,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [Y: A,X: A,E2: real] :
          ( ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ Y @ X ) @ E2 )
         => ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X @ Y ) @ E2 ) ) ) ).

% dist_commute_lessI
thf(fact_5941_dist__pos__lt,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X: A,Y: A] :
          ( ( X != Y )
         => ( ord_less @ real @ ( zero_zero @ real ) @ ( real_V557655796197034286t_dist @ A @ X @ Y ) ) ) ) ).

% dist_pos_lt
thf(fact_5942_dist__not__less__zero,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X: A,Y: A] :
          ~ ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X @ Y ) @ ( zero_zero @ real ) ) ) ).

% dist_not_less_zero
thf(fact_5943_norm__conv__dist,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ( ( real_V7770717601297561774m_norm @ A )
        = ( ^ [X2: A] : ( real_V557655796197034286t_dist @ A @ X2 @ ( zero_zero @ A ) ) ) ) ) ).

% norm_conv_dist
thf(fact_5944_dist__triangle__less__add,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X15: A,Y: A,E1: real,X22: A,E22: real] :
          ( ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X15 @ Y ) @ E1 )
         => ( ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X22 @ Y ) @ E22 )
           => ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X15 @ X22 ) @ ( plus_plus @ real @ E1 @ E22 ) ) ) ) ) ).

% dist_triangle_less_add
thf(fact_5945_dist__triangle__lt,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X: A,Z: A,Y: A,E2: real] :
          ( ( ord_less @ real @ ( plus_plus @ real @ ( real_V557655796197034286t_dist @ A @ X @ Z ) @ ( real_V557655796197034286t_dist @ A @ Y @ Z ) ) @ E2 )
         => ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X @ Y ) @ E2 ) ) ) ).

% dist_triangle_lt
thf(fact_5946_open__ball,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X: A,D2: real] :
          ( topolo1002775350975398744n_open @ A
          @ ( collect @ A
            @ ^ [Y4: A] : ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X @ Y4 ) @ D2 ) ) ) ) ).

% open_ball
thf(fact_5947_open__dist,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ( ( topolo1002775350975398744n_open @ A )
        = ( ^ [S8: set @ A] :
            ! [X2: A] :
              ( ( member @ A @ X2 @ S8 )
             => ? [E3: real] :
                  ( ( ord_less @ real @ ( zero_zero @ real ) @ E3 )
                  & ! [Y4: A] :
                      ( ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ Y4 @ X2 ) @ E3 )
                     => ( member @ A @ Y4 @ S8 ) ) ) ) ) ) ) ).

% open_dist
thf(fact_5948_abs__dist__diff__le,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [A2: A,B2: A,C2: A] : ( ord_less_eq @ real @ ( abs_abs @ real @ ( minus_minus @ real @ ( real_V557655796197034286t_dist @ A @ A2 @ B2 ) @ ( real_V557655796197034286t_dist @ A @ B2 @ C2 ) ) ) @ ( real_V557655796197034286t_dist @ A @ A2 @ C2 ) ) ) ).

% abs_dist_diff_le
thf(fact_5949_at__within__Icc__at__right,axiom,
    ! [A: $tType] :
      ( ( topolo2564578578187576103pology @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( topolo174197925503356063within @ A @ A2 @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) )
            = ( topolo174197925503356063within @ A @ A2 @ ( set_ord_greaterThan @ A @ A2 ) ) ) ) ) ).

% at_within_Icc_at_right
thf(fact_5950_filterlim__transform__within,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [G: A > B,G5: filter @ B,X: A,S: set @ A,F4: filter @ B,D2: real,F2: A > B] :
          ( ( filterlim @ A @ B @ G @ G5 @ ( topolo174197925503356063within @ A @ X @ S ) )
         => ( ( ord_less_eq @ ( filter @ B ) @ G5 @ F4 )
           => ( ( ord_less @ real @ ( zero_zero @ real ) @ D2 )
             => ( ! [X10: A] :
                    ( ( member @ A @ X10 @ S )
                   => ( ( ord_less @ real @ ( zero_zero @ real ) @ ( real_V557655796197034286t_dist @ A @ X10 @ X ) )
                     => ( ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X10 @ X ) @ D2 )
                       => ( ( F2 @ X10 )
                          = ( G @ X10 ) ) ) ) )
               => ( filterlim @ A @ B @ F2 @ F4 @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ) ) ) ).

% filterlim_transform_within
thf(fact_5951_has__field__derivative__transform__within,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,F5: A,A2: A,S: set @ A,D2: real,G: A > A] :
          ( ( has_field_derivative @ A @ F2 @ F5 @ ( topolo174197925503356063within @ A @ A2 @ S ) )
         => ( ( ord_less @ real @ ( zero_zero @ real ) @ D2 )
           => ( ( member @ A @ A2 @ S )
             => ( ! [X3: A] :
                    ( ( member @ A @ X3 @ S )
                   => ( ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X3 @ A2 ) @ D2 )
                     => ( ( F2 @ X3 )
                        = ( G @ X3 ) ) ) )
               => ( has_field_derivative @ A @ G @ F5 @ ( topolo174197925503356063within @ A @ A2 @ S ) ) ) ) ) ) ) ).

% has_field_derivative_transform_within
thf(fact_5952_has__derivative__transform__within,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F2: A > B,F5: A > B,X: A,S2: set @ A,D2: real,G: A > B] :
          ( ( has_derivative @ A @ B @ F2 @ F5 @ ( topolo174197925503356063within @ A @ X @ S2 ) )
         => ( ( ord_less @ real @ ( zero_zero @ real ) @ D2 )
           => ( ( member @ A @ X @ S2 )
             => ( ! [X10: A] :
                    ( ( member @ A @ X10 @ S2 )
                   => ( ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X10 @ X ) @ D2 )
                     => ( ( F2 @ X10 )
                        = ( G @ X10 ) ) ) )
               => ( has_derivative @ A @ B @ G @ F5 @ ( topolo174197925503356063within @ A @ X @ S2 ) ) ) ) ) ) ) ).

% has_derivative_transform_within
thf(fact_5953_Cauchy__def,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ( ( topolo3814608138187158403Cauchy @ A )
        = ( ^ [X8: nat > A] :
            ! [E3: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ E3 )
             => ? [M8: nat] :
                ! [M3: nat] :
                  ( ( ord_less_eq @ nat @ M8 @ M3 )
                 => ! [N3: nat] :
                      ( ( ord_less_eq @ nat @ M8 @ N3 )
                     => ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ ( X8 @ M3 ) @ ( X8 @ N3 ) ) @ E3 ) ) ) ) ) ) ) ).

% Cauchy_def
thf(fact_5954_Cauchy__altdef2,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ( ( topolo3814608138187158403Cauchy @ A )
        = ( ^ [S6: nat > A] :
            ! [E3: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ E3 )
             => ? [N6: nat] :
                ! [N3: nat] :
                  ( ( ord_less_eq @ nat @ N6 @ N3 )
                 => ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ ( S6 @ N3 ) @ ( S6 @ N6 ) ) @ E3 ) ) ) ) ) ) ).

% Cauchy_altdef2
thf(fact_5955_metric__CauchyD,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X7: nat > A,E2: real] :
          ( ( topolo3814608138187158403Cauchy @ A @ X7 )
         => ( ( ord_less @ real @ ( zero_zero @ real ) @ E2 )
           => ? [M10: nat] :
              ! [M2: nat] :
                ( ( ord_less_eq @ nat @ M10 @ M2 )
               => ! [N7: nat] :
                    ( ( ord_less_eq @ nat @ M10 @ N7 )
                   => ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ ( X7 @ M2 ) @ ( X7 @ N7 ) ) @ E2 ) ) ) ) ) ) ).

% metric_CauchyD
thf(fact_5956_metric__CauchyI,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X7: nat > A] :
          ( ! [E: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ E )
             => ? [M9: nat] :
                ! [M4: nat] :
                  ( ( ord_less_eq @ nat @ M9 @ M4 )
                 => ! [N2: nat] :
                      ( ( ord_less_eq @ nat @ M9 @ N2 )
                     => ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ ( X7 @ M4 ) @ ( X7 @ N2 ) ) @ E ) ) ) )
         => ( topolo3814608138187158403Cauchy @ A @ X7 ) ) ) ).

% metric_CauchyI
thf(fact_5957_less__separate,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less @ A @ X @ Y )
         => ? [A5: A,B4: A] :
              ( ( member @ A @ X @ ( set_ord_lessThan @ A @ A5 ) )
              & ( member @ A @ Y @ ( set_ord_greaterThan @ A @ B4 ) )
              & ( ( inf_inf @ ( set @ A ) @ ( set_ord_lessThan @ A @ A5 ) @ ( set_ord_greaterThan @ A @ B4 ) )
                = ( bot_bot @ ( set @ A ) ) ) ) ) ) ).

% less_separate
thf(fact_5958_filterlim__at__right__to__0,axiom,
    ! [A: $tType,F2: real > A,F4: filter @ A,A2: real] :
      ( ( filterlim @ real @ A @ F2 @ F4 @ ( topolo174197925503356063within @ real @ A2 @ ( set_ord_greaterThan @ real @ A2 ) ) )
      = ( filterlim @ real @ A
        @ ^ [X2: real] : ( F2 @ ( plus_plus @ real @ X2 @ A2 ) )
        @ F4
        @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) ) ) ).

% filterlim_at_right_to_0
thf(fact_5959_filterlim__tan__at__right,axiom,
    filterlim @ real @ real @ ( tan @ real ) @ ( at_bot @ real ) @ ( topolo174197925503356063within @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ ( set_ord_greaterThan @ real @ ( uminus_uminus @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ) ).

% filterlim_tan_at_right
thf(fact_5960_metric__LIM__imp__LIM,axiom,
    ! [A: $tType,B: $tType,C: $tType] :
      ( ( ( topolo4958980785337419405_space @ C )
        & ( real_V7819770556892013058_space @ B )
        & ( real_V7819770556892013058_space @ A ) )
     => ! [F2: C > A,L: A,A2: C,G: C > B,M: B] :
          ( ( filterlim @ C @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ L ) @ ( topolo174197925503356063within @ C @ A2 @ ( top_top @ ( set @ C ) ) ) )
         => ( ! [X3: C] :
                ( ( X3 != A2 )
               => ( ord_less_eq @ real @ ( real_V557655796197034286t_dist @ B @ ( G @ X3 ) @ M ) @ ( real_V557655796197034286t_dist @ A @ ( F2 @ X3 ) @ L ) ) )
           => ( filterlim @ C @ B @ G @ ( topolo7230453075368039082e_nhds @ B @ M ) @ ( topolo174197925503356063within @ C @ A2 @ ( top_top @ ( set @ C ) ) ) ) ) ) ) ).

% metric_LIM_imp_LIM
thf(fact_5961_Lim__transform__within,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V7819770556892013058_space @ A )
        & ( topolo4958980785337419405_space @ B ) )
     => ! [F2: A > B,L: B,X: A,S: set @ A,D2: real,G: A > B] :
          ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ L ) @ ( topolo174197925503356063within @ A @ X @ S ) )
         => ( ( ord_less @ real @ ( zero_zero @ real ) @ D2 )
           => ( ! [X10: A] :
                  ( ( member @ A @ X10 @ S )
                 => ( ( ord_less @ real @ ( zero_zero @ real ) @ ( real_V557655796197034286t_dist @ A @ X10 @ X ) )
                   => ( ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X10 @ X ) @ D2 )
                     => ( ( F2 @ X10 )
                        = ( G @ X10 ) ) ) ) )
             => ( filterlim @ A @ B @ G @ ( topolo7230453075368039082e_nhds @ B @ L ) @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ) ) ).

% Lim_transform_within
thf(fact_5962_dist__triangle__half__l,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X15: A,Y: A,E2: real,X22: A] :
          ( ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X15 @ Y ) @ ( divide_divide @ real @ E2 @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
         => ( ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X22 @ Y ) @ ( divide_divide @ real @ E2 @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
           => ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X15 @ X22 ) @ E2 ) ) ) ) ).

% dist_triangle_half_l
thf(fact_5963_dist__triangle__half__r,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [Y: A,X15: A,E2: real,X22: A] :
          ( ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ Y @ X15 ) @ ( divide_divide @ real @ E2 @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
         => ( ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ Y @ X22 ) @ ( divide_divide @ real @ E2 @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) )
           => ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X15 @ X22 ) @ E2 ) ) ) ) ).

% dist_triangle_half_r
thf(fact_5964_dist__triangle__third,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X15: A,X22: A,E2: real,X32: A,X42: A] :
          ( ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X15 @ X22 ) @ ( divide_divide @ real @ E2 @ ( numeral_numeral @ real @ ( bit1 @ one2 ) ) ) )
         => ( ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X22 @ X32 ) @ ( divide_divide @ real @ E2 @ ( numeral_numeral @ real @ ( bit1 @ one2 ) ) ) )
           => ( ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X32 @ X42 ) @ ( divide_divide @ real @ E2 @ ( numeral_numeral @ real @ ( bit1 @ one2 ) ) ) )
             => ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X15 @ X42 ) @ E2 ) ) ) ) ) ).

% dist_triangle_third
thf(fact_5965_exp__at__bot,axiom,
    filterlim @ real @ real @ ( exp @ real ) @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( at_bot @ real ) ).

% exp_at_bot
thf(fact_5966_CauchyI_H,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X7: nat > A] :
          ( ! [E: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ E )
             => ? [M9: nat] :
                ! [M4: nat] :
                  ( ( ord_less_eq @ nat @ M9 @ M4 )
                 => ! [N2: nat] :
                      ( ( ord_less @ nat @ M4 @ N2 )
                     => ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ ( X7 @ M4 ) @ ( X7 @ N2 ) ) @ E ) ) ) )
         => ( topolo3814608138187158403Cauchy @ A @ X7 ) ) ) ).

% CauchyI'
thf(fact_5967_Cauchy__altdef,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ( ( topolo3814608138187158403Cauchy @ A )
        = ( ^ [F3: nat > A] :
            ! [E3: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ E3 )
             => ? [M8: nat] :
                ! [M3: nat] :
                  ( ( ord_less_eq @ nat @ M8 @ M3 )
                 => ! [N3: nat] :
                      ( ( ord_less @ nat @ M3 @ N3 )
                     => ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ ( F3 @ M3 ) @ ( F3 @ N3 ) ) @ E3 ) ) ) ) ) ) ) ).

% Cauchy_altdef
thf(fact_5968_dist__of__nat,axiom,
    ! [A: $tType] :
      ( ( real_V2822296259951069270ebra_1 @ A )
     => ! [M: nat,N: nat] :
          ( ( real_V557655796197034286t_dist @ A @ ( semiring_1_of_nat @ A @ M ) @ ( semiring_1_of_nat @ A @ N ) )
          = ( ring_1_of_int @ real @ ( abs_abs @ int @ ( minus_minus @ int @ ( semiring_1_of_nat @ int @ M ) @ ( semiring_1_of_nat @ int @ N ) ) ) ) ) ) ).

% dist_of_nat
thf(fact_5969_filterlim__inverse__at__bot__neg,axiom,
    filterlim @ real @ real @ ( inverse_inverse @ real ) @ ( at_bot @ real ) @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_lessThan @ real @ ( zero_zero @ real ) ) ) ).

% filterlim_inverse_at_bot_neg
thf(fact_5970_tendsto__dist__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V7819770556892013058_space @ B )
     => ! [F2: A > B,L: B,F4: filter @ A] :
          ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ L ) @ F4 )
          = ( filterlim @ A @ real
            @ ^ [X2: A] : ( real_V557655796197034286t_dist @ B @ ( F2 @ X2 ) @ L )
            @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
            @ F4 ) ) ) ).

% tendsto_dist_iff
thf(fact_5971_filterlim__times__pos,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( linordered_field @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [F2: B > A,P6: A,F13: filter @ B,C2: A,L: A] :
          ( ( filterlim @ B @ A @ F2 @ ( topolo174197925503356063within @ A @ P6 @ ( set_ord_greaterThan @ A @ P6 ) ) @ F13 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
           => ( ( L
                = ( times_times @ A @ C2 @ P6 ) )
             => ( filterlim @ B @ A
                @ ^ [X2: B] : ( times_times @ A @ C2 @ ( F2 @ X2 ) )
                @ ( topolo174197925503356063within @ A @ L @ ( set_ord_greaterThan @ A @ L ) )
                @ F13 ) ) ) ) ) ).

% filterlim_times_pos
thf(fact_5972_LIM__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V7819770556892013058_space @ A )
        & ( real_V7819770556892013058_space @ B ) )
     => ! [F2: A > B,L5: B,A2: A] :
          ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ L5 ) @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) )
          = ( ! [R5: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ R5 )
               => ? [S6: real] :
                    ( ( ord_less @ real @ ( zero_zero @ real ) @ S6 )
                    & ! [X2: A] :
                        ( ( ( X2 != A2 )
                          & ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X2 @ A2 ) @ S6 ) )
                       => ( ord_less @ real @ ( real_V557655796197034286t_dist @ B @ ( F2 @ X2 ) @ L5 ) @ R5 ) ) ) ) ) ) ) ).

% LIM_def
thf(fact_5973_metric__LIM__D,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V7819770556892013058_space @ A )
        & ( real_V7819770556892013058_space @ B ) )
     => ! [F2: A > B,L5: B,A2: A,R2: real] :
          ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ L5 ) @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) )
         => ( ( ord_less @ real @ ( zero_zero @ real ) @ R2 )
           => ? [S3: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ S3 )
                & ! [X5: A] :
                    ( ( ( X5 != A2 )
                      & ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X5 @ A2 ) @ S3 ) )
                   => ( ord_less @ real @ ( real_V557655796197034286t_dist @ B @ ( F2 @ X5 ) @ L5 ) @ R2 ) ) ) ) ) ) ).

% metric_LIM_D
thf(fact_5974_metric__LIM__I,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V7819770556892013058_space @ A )
        & ( real_V7819770556892013058_space @ B ) )
     => ! [A2: A,F2: A > B,L5: B] :
          ( ! [R: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ R )
             => ? [S7: real] :
                  ( ( ord_less @ real @ ( zero_zero @ real ) @ S7 )
                  & ! [X3: A] :
                      ( ( ( X3 != A2 )
                        & ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X3 @ A2 ) @ S7 ) )
                     => ( ord_less @ real @ ( real_V557655796197034286t_dist @ B @ ( F2 @ X3 ) @ L5 ) @ R ) ) ) )
         => ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ L5 ) @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% metric_LIM_I
thf(fact_5975_metric__LIM__equal2,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V7819770556892013058_space @ A )
        & ( topolo4958980785337419405_space @ B ) )
     => ! [G: A > B,L: B,A2: A,R4: real,F2: A > B] :
          ( ( filterlim @ A @ B @ G @ ( topolo7230453075368039082e_nhds @ B @ L ) @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) )
         => ( ( ord_less @ real @ ( zero_zero @ real ) @ R4 )
           => ( ! [X3: A] :
                  ( ( X3 != A2 )
                 => ( ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X3 @ A2 ) @ R4 )
                   => ( ( F2 @ X3 )
                      = ( G @ X3 ) ) ) )
             => ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ L ) @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ) ).

% metric_LIM_equal2
thf(fact_5976_metric__LIMSEQ__D,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X7: nat > A,L5: A,R2: real] :
          ( ( filterlim @ nat @ A @ X7 @ ( topolo7230453075368039082e_nhds @ A @ L5 ) @ ( at_top @ nat ) )
         => ( ( ord_less @ real @ ( zero_zero @ real ) @ R2 )
           => ? [No3: nat] :
              ! [N7: nat] :
                ( ( ord_less_eq @ nat @ No3 @ N7 )
               => ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ ( X7 @ N7 ) @ L5 ) @ R2 ) ) ) ) ) ).

% metric_LIMSEQ_D
thf(fact_5977_metric__LIMSEQ__I,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X7: nat > A,L5: A] :
          ( ! [R: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ R )
             => ? [No2: nat] :
                ! [N2: nat] :
                  ( ( ord_less_eq @ nat @ No2 @ N2 )
                 => ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ ( X7 @ N2 ) @ L5 ) @ R ) ) )
         => ( filterlim @ nat @ A @ X7 @ ( topolo7230453075368039082e_nhds @ A @ L5 ) @ ( at_top @ nat ) ) ) ) ).

% metric_LIMSEQ_I
thf(fact_5978_lim__sequentially,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X7: nat > A,L5: A] :
          ( ( filterlim @ nat @ A @ X7 @ ( topolo7230453075368039082e_nhds @ A @ L5 ) @ ( at_top @ nat ) )
          = ( ! [R5: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ R5 )
               => ? [No: nat] :
                  ! [N3: nat] :
                    ( ( ord_less_eq @ nat @ No @ N3 )
                   => ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ ( X7 @ N3 ) @ L5 ) @ R5 ) ) ) ) ) ) ).

% lim_sequentially
thf(fact_5979_metric__Cauchy__iff2,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ( ( topolo3814608138187158403Cauchy @ A )
        = ( ^ [X8: nat > A] :
            ! [J3: nat] :
            ? [M8: nat] :
            ! [M3: nat] :
              ( ( ord_less_eq @ nat @ M8 @ M3 )
             => ! [N3: nat] :
                  ( ( ord_less_eq @ nat @ M8 @ N3 )
                 => ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ ( X8 @ M3 ) @ ( X8 @ N3 ) ) @ ( inverse_inverse @ real @ ( semiring_1_of_nat @ real @ ( suc @ J3 ) ) ) ) ) ) ) ) ) ).

% metric_Cauchy_iff2
thf(fact_5980_metric__LIM__compose2,axiom,
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( ( real_V7819770556892013058_space @ A )
        & ( topolo4958980785337419405_space @ B )
        & ( topolo4958980785337419405_space @ C ) )
     => ! [F2: A > B,B2: B,A2: A,G: B > C,C2: C] :
          ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ B2 ) @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) )
         => ( ( filterlim @ B @ C @ G @ ( topolo7230453075368039082e_nhds @ C @ C2 ) @ ( topolo174197925503356063within @ B @ B2 @ ( top_top @ ( set @ B ) ) ) )
           => ( ? [D3: real] :
                  ( ( ord_less @ real @ ( zero_zero @ real ) @ D3 )
                  & ! [X3: A] :
                      ( ( ( X3 != A2 )
                        & ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X3 @ A2 ) @ D3 ) )
                     => ( ( F2 @ X3 )
                       != B2 ) ) )
             => ( filterlim @ A @ C
                @ ^ [X2: A] : ( G @ ( F2 @ X2 ) )
                @ ( topolo7230453075368039082e_nhds @ C @ C2 )
                @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ) ).

% metric_LIM_compose2
thf(fact_5981_filterlim__tendsto__pos__mult__at__bot,axiom,
    ! [A: $tType,F2: A > real,C2: real,F4: filter @ A,G: A > real] :
      ( ( filterlim @ A @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ C2 ) @ F4 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ C2 )
       => ( ( filterlim @ A @ real @ G @ ( at_bot @ real ) @ F4 )
         => ( filterlim @ A @ real
            @ ^ [X2: A] : ( times_times @ real @ ( F2 @ X2 ) @ ( G @ X2 ) )
            @ ( at_bot @ real )
            @ F4 ) ) ) ) ).

% filterlim_tendsto_pos_mult_at_bot
thf(fact_5982_tendsto__arcosh__at__left__1,axiom,
    filterlim @ real @ real @ ( arcosh @ real ) @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( topolo174197925503356063within @ real @ ( one_one @ real ) @ ( set_ord_greaterThan @ real @ ( one_one @ real ) ) ) ).

% tendsto_arcosh_at_left_1
thf(fact_5983_metric__isCont__LIM__compose2,axiom,
    ! [D: $tType,C: $tType,A: $tType] :
      ( ( ( real_V7819770556892013058_space @ A )
        & ( topolo4958980785337419405_space @ C )
        & ( topolo4958980785337419405_space @ D ) )
     => ! [A2: A,F2: A > C,G: C > D,L: D] :
          ( ( topolo3448309680560233919inuous @ A @ C @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) @ F2 )
         => ( ( filterlim @ C @ D @ G @ ( topolo7230453075368039082e_nhds @ D @ L ) @ ( topolo174197925503356063within @ C @ ( F2 @ A2 ) @ ( top_top @ ( set @ C ) ) ) )
           => ( ? [D3: real] :
                  ( ( ord_less @ real @ ( zero_zero @ real ) @ D3 )
                  & ! [X3: A] :
                      ( ( ( X3 != A2 )
                        & ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X3 @ A2 ) @ D3 ) )
                     => ( ( F2 @ X3 )
                       != ( F2 @ A2 ) ) ) )
             => ( filterlim @ A @ D
                @ ^ [X2: A] : ( G @ ( F2 @ X2 ) )
                @ ( topolo7230453075368039082e_nhds @ D @ L )
                @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) ) ) ) ) ) ).

% metric_isCont_LIM_compose2
thf(fact_5984_isCont__If__ge,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topolo1944317154257567458pology @ A )
        & ( topolo4958980785337419405_space @ B ) )
     => ! [A2: A,G: A > B,F2: A > B] :
          ( ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ ( set_ord_lessThan @ A @ A2 ) ) @ G )
         => ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ ( G @ A2 ) ) @ ( topolo174197925503356063within @ A @ A2 @ ( set_ord_greaterThan @ A @ A2 ) ) )
           => ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) )
              @ ^ [X2: A] : ( if @ B @ ( ord_less_eq @ A @ X2 @ A2 ) @ ( G @ X2 ) @ ( F2 @ X2 ) ) ) ) ) ) ).

% isCont_If_ge
thf(fact_5985_LIMSEQ__iff__nz,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [X7: nat > A,L5: A] :
          ( ( filterlim @ nat @ A @ X7 @ ( topolo7230453075368039082e_nhds @ A @ L5 ) @ ( at_top @ nat ) )
          = ( ! [R5: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ R5 )
               => ? [No: nat] :
                    ( ( ord_less @ nat @ ( zero_zero @ nat ) @ No )
                    & ! [N3: nat] :
                        ( ( ord_less_eq @ nat @ No @ N3 )
                       => ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ ( X7 @ N3 ) @ L5 ) @ R5 ) ) ) ) ) ) ) ).

% LIMSEQ_iff_nz
thf(fact_5986_DERIV__pos__imp__increasing__at__bot,axiom,
    ! [B2: real,F2: real > real,Flim: real] :
      ( ! [X3: real] :
          ( ( ord_less_eq @ real @ X3 @ B2 )
         => ? [Y6: real] :
              ( ( has_field_derivative @ real @ F2 @ Y6 @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) )
              & ( ord_less @ real @ ( zero_zero @ real ) @ Y6 ) ) )
     => ( ( filterlim @ real @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ Flim ) @ ( at_bot @ real ) )
       => ( ord_less @ real @ Flim @ ( F2 @ B2 ) ) ) ) ).

% DERIV_pos_imp_increasing_at_bot
thf(fact_5987_filterlim__pow__at__bot__odd,axiom,
    ! [N: nat,F2: real > real,F4: filter @ real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( filterlim @ real @ real @ F2 @ ( at_bot @ real ) @ F4 )
       => ( ~ ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
         => ( filterlim @ real @ real
            @ ^ [X2: real] : ( power_power @ real @ ( F2 @ X2 ) @ N )
            @ ( at_bot @ real )
            @ F4 ) ) ) ) ).

% filterlim_pow_at_bot_odd
thf(fact_5988_totally__bounded__metric,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ( ( topolo6688025880775521714ounded @ A )
        = ( ^ [S8: set @ A] :
            ! [E3: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ E3 )
             => ? [K3: set @ A] :
                  ( ( finite_finite @ A @ K3 )
                  & ( ord_less_eq @ ( set @ A ) @ S8
                    @ ( complete_Sup_Sup @ ( set @ A )
                      @ ( image @ A @ ( set @ A )
                        @ ^ [X2: A] :
                            ( collect @ A
                            @ ^ [Y4: A] : ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X2 @ Y4 ) @ E3 ) )
                        @ K3 ) ) ) ) ) ) ) ) ).

% totally_bounded_metric
thf(fact_5989_filterlim__pow__at__bot__even,axiom,
    ! [N: nat,F2: real > real,F4: filter @ real] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( filterlim @ real @ real @ F2 @ ( at_bot @ real ) @ F4 )
       => ( ( dvd_dvd @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N )
         => ( filterlim @ real @ real
            @ ^ [X2: real] : ( power_power @ real @ ( F2 @ X2 ) @ N )
            @ ( at_top @ real )
            @ F4 ) ) ) ) ).

% filterlim_pow_at_bot_even
thf(fact_5990_lim__zero__infinity,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,L: A] :
          ( ( filterlim @ A @ A
            @ ^ [X2: A] : ( F2 @ ( divide_divide @ A @ ( one_one @ A ) @ X2 ) )
            @ ( topolo7230453075368039082e_nhds @ A @ L )
            @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) )
         => ( filterlim @ A @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ L ) @ ( at_infinity @ A ) ) ) ) ).

% lim_zero_infinity
thf(fact_5991_sqrt__at__top,axiom,
    filterlim @ real @ real @ sqrt @ ( at_top @ real ) @ ( at_top @ real ) ).

% sqrt_at_top
thf(fact_5992_filterlim__real__sequentially,axiom,
    filterlim @ nat @ real @ ( semiring_1_of_nat @ real ) @ ( at_top @ real ) @ ( at_top @ nat ) ).

% filterlim_real_sequentially
thf(fact_5993_filterlim__real__at__infinity__sequentially,axiom,
    filterlim @ nat @ real @ ( semiring_1_of_nat @ real ) @ ( at_infinity @ real ) @ ( at_top @ nat ) ).

% filterlim_real_at_infinity_sequentially
thf(fact_5994_tendsto__of__nat,axiom,
    ! [A: $tType] :
      ( ( real_V2822296259951069270ebra_1 @ A )
     => ( filterlim @ nat @ A @ ( semiring_1_of_nat @ A ) @ ( at_infinity @ A ) @ ( at_top @ nat ) ) ) ).

% tendsto_of_nat
thf(fact_5995_greaterThan__0,axiom,
    ( ( set_ord_greaterThan @ nat @ ( zero_zero @ nat ) )
    = ( image @ nat @ nat @ suc @ ( top_top @ ( set @ nat ) ) ) ) ).

% greaterThan_0
thf(fact_5996_filterlim__pow__at__top,axiom,
    ! [A: $tType,N: nat,F2: A > real,F4: filter @ A] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( filterlim @ A @ real @ F2 @ ( at_top @ real ) @ F4 )
       => ( filterlim @ A @ real
          @ ^ [X2: A] : ( power_power @ real @ ( F2 @ X2 ) @ N )
          @ ( at_top @ real )
          @ F4 ) ) ) ).

% filterlim_pow_at_top
thf(fact_5997_real__tendsto__divide__at__top,axiom,
    ! [A: $tType,F2: A > real,C2: real,F4: filter @ A,G: A > real] :
      ( ( filterlim @ A @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ C2 ) @ F4 )
     => ( ( filterlim @ A @ real @ G @ ( at_top @ real ) @ F4 )
       => ( filterlim @ A @ real
          @ ^ [X2: A] : ( divide_divide @ real @ ( F2 @ X2 ) @ ( G @ X2 ) )
          @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
          @ F4 ) ) ) ).

% real_tendsto_divide_at_top
thf(fact_5998_tendsto__inverse__0__at__top,axiom,
    ! [A: $tType,F2: A > real,F4: filter @ A] :
      ( ( filterlim @ A @ real @ F2 @ ( at_top @ real ) @ F4 )
     => ( filterlim @ A @ real
        @ ^ [X2: A] : ( inverse_inverse @ real @ ( F2 @ X2 ) )
        @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
        @ F4 ) ) ).

% tendsto_inverse_0_at_top
thf(fact_5999_filterlim__sequentially__iff__filterlim__real,axiom,
    ! [A: $tType,F2: A > nat,F4: filter @ A] :
      ( ( filterlim @ A @ nat @ F2 @ ( at_top @ nat ) @ F4 )
      = ( filterlim @ A @ real
        @ ^ [X2: A] : ( semiring_1_of_nat @ real @ ( F2 @ X2 ) )
        @ ( at_top @ real )
        @ F4 ) ) ).

% filterlim_sequentially_iff_filterlim_real
thf(fact_6000_tendsto__inverse__0,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ( filterlim @ A @ A @ ( inverse_inverse @ A ) @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) ) @ ( at_infinity @ A ) ) ) ).

% tendsto_inverse_0
thf(fact_6001_filterlim__tendsto__pos__mult__at__top,axiom,
    ! [A: $tType,F2: A > real,C2: real,F4: filter @ A,G: A > real] :
      ( ( filterlim @ A @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ C2 ) @ F4 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ C2 )
       => ( ( filterlim @ A @ real @ G @ ( at_top @ real ) @ F4 )
         => ( filterlim @ A @ real
            @ ^ [X2: A] : ( times_times @ real @ ( F2 @ X2 ) @ ( G @ X2 ) )
            @ ( at_top @ real )
            @ F4 ) ) ) ) ).

% filterlim_tendsto_pos_mult_at_top
thf(fact_6002_filterlim__at__top__mult__tendsto__pos,axiom,
    ! [A: $tType,F2: A > real,C2: real,F4: filter @ A,G: A > real] :
      ( ( filterlim @ A @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ C2 ) @ F4 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ C2 )
       => ( ( filterlim @ A @ real @ G @ ( at_top @ real ) @ F4 )
         => ( filterlim @ A @ real
            @ ^ [X2: A] : ( times_times @ real @ ( G @ X2 ) @ ( F2 @ X2 ) )
            @ ( at_top @ real )
            @ F4 ) ) ) ) ).

% filterlim_at_top_mult_tendsto_pos
thf(fact_6003_tendsto__neg__powr,axiom,
    ! [A: $tType,S2: real,F2: A > real,F4: filter @ A] :
      ( ( ord_less @ real @ S2 @ ( zero_zero @ real ) )
     => ( ( filterlim @ A @ real @ F2 @ ( at_top @ real ) @ F4 )
       => ( filterlim @ A @ real
          @ ^ [X2: A] : ( powr @ real @ ( F2 @ X2 ) @ S2 )
          @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
          @ F4 ) ) ) ).

% tendsto_neg_powr
thf(fact_6004_tendsto__mult__filterlim__at__infinity,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: B > A,C2: A,F4: filter @ B,G: B > A] :
          ( ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ C2 ) @ F4 )
         => ( ( C2
             != ( zero_zero @ A ) )
           => ( ( filterlim @ B @ A @ G @ ( at_infinity @ A ) @ F4 )
             => ( filterlim @ B @ A
                @ ^ [X2: B] : ( times_times @ A @ ( F2 @ X2 ) @ ( G @ X2 ) )
                @ ( at_infinity @ A )
                @ F4 ) ) ) ) ) ).

% tendsto_mult_filterlim_at_infinity
thf(fact_6005_ln__x__over__x__tendsto__0,axiom,
    ( filterlim @ real @ real
    @ ^ [X2: real] : ( divide_divide @ real @ ( ln_ln @ real @ X2 ) @ X2 )
    @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
    @ ( at_top @ real ) ) ).

% ln_x_over_x_tendsto_0
thf(fact_6006_tendsto__divide__0,axiom,
    ! [A: $tType,C: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [F2: C > A,C2: A,F4: filter @ C,G: C > A] :
          ( ( filterlim @ C @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ C2 ) @ F4 )
         => ( ( filterlim @ C @ A @ G @ ( at_infinity @ A ) @ F4 )
           => ( filterlim @ C @ A
              @ ^ [X2: C] : ( divide_divide @ A @ ( F2 @ X2 ) @ ( G @ X2 ) )
              @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) )
              @ F4 ) ) ) ) ).

% tendsto_divide_0
thf(fact_6007_filterlim__at__top__to__right,axiom,
    ! [A: $tType,F2: real > A,F4: filter @ A] :
      ( ( filterlim @ real @ A @ F2 @ F4 @ ( at_top @ real ) )
      = ( filterlim @ real @ A
        @ ^ [X2: real] : ( F2 @ ( inverse_inverse @ real @ X2 ) )
        @ F4
        @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) ) ) ).

% filterlim_at_top_to_right
thf(fact_6008_filterlim__at__right__to__top,axiom,
    ! [A: $tType,F2: real > A,F4: filter @ A] :
      ( ( filterlim @ real @ A @ F2 @ F4 @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) )
      = ( filterlim @ real @ A
        @ ^ [X2: real] : ( F2 @ ( inverse_inverse @ real @ X2 ) )
        @ F4
        @ ( at_top @ real ) ) ) ).

% filterlim_at_right_to_top
thf(fact_6009_filterlim__power__at__infinity,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V8999393235501362500lgebra @ B )
     => ! [F2: A > B,F4: filter @ A,N: nat] :
          ( ( filterlim @ A @ B @ F2 @ ( at_infinity @ B ) @ F4 )
         => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
           => ( filterlim @ A @ B
              @ ^ [X2: A] : ( power_power @ B @ ( F2 @ X2 ) @ N )
              @ ( at_infinity @ B )
              @ F4 ) ) ) ) ).

% filterlim_power_at_infinity
thf(fact_6010_filterlim__inverse__at__top__right,axiom,
    filterlim @ real @ real @ ( inverse_inverse @ real ) @ ( at_top @ real ) @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) ).

% filterlim_inverse_at_top_right
thf(fact_6011_filterlim__inverse__at__right__top,axiom,
    filterlim @ real @ real @ ( inverse_inverse @ real ) @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) @ ( at_top @ real ) ).

% filterlim_inverse_at_right_top
thf(fact_6012_filterlim__inverse__at__infinity,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ( filterlim @ A @ A @ ( inverse_inverse @ A ) @ ( at_infinity @ A ) @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ).

% filterlim_inverse_at_infinity
thf(fact_6013_filterlim__tendsto__neg__mult__at__bot,axiom,
    ! [A: $tType,F2: A > real,C2: real,F4: filter @ A,G: A > real] :
      ( ( filterlim @ A @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ C2 ) @ F4 )
     => ( ( ord_less @ real @ C2 @ ( zero_zero @ real ) )
       => ( ( filterlim @ A @ real @ G @ ( at_top @ real ) @ F4 )
         => ( filterlim @ A @ real
            @ ^ [X2: A] : ( times_times @ real @ ( F2 @ X2 ) @ ( G @ X2 ) )
            @ ( at_bot @ real )
            @ F4 ) ) ) ) ).

% filterlim_tendsto_neg_mult_at_bot
thf(fact_6014_tendsto__power__div__exp__0,axiom,
    ! [K: nat] :
      ( filterlim @ real @ real
      @ ^ [X2: real] : ( divide_divide @ real @ ( power_power @ real @ X2 @ K ) @ ( exp @ real @ X2 ) )
      @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
      @ ( at_top @ real ) ) ).

% tendsto_power_div_exp_0
thf(fact_6015_lim__infinity__imp__sequentially,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [F2: real > A,L: A] :
          ( ( filterlim @ real @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ L ) @ ( at_infinity @ real ) )
         => ( filterlim @ nat @ A
            @ ^ [N3: nat] : ( F2 @ ( semiring_1_of_nat @ real @ N3 ) )
            @ ( topolo7230453075368039082e_nhds @ A @ L )
            @ ( at_top @ nat ) ) ) ) ).

% lim_infinity_imp_sequentially
thf(fact_6016_filterlim__inverse__at__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V8999393235501362500lgebra @ B )
     => ! [G: A > B,F4: filter @ A] :
          ( ( filterlim @ A @ B
            @ ^ [X2: A] : ( inverse_inverse @ B @ ( G @ X2 ) )
            @ ( topolo174197925503356063within @ B @ ( zero_zero @ B ) @ ( top_top @ ( set @ B ) ) )
            @ F4 )
          = ( filterlim @ A @ B @ G @ ( at_infinity @ B ) @ F4 ) ) ) ).

% filterlim_inverse_at_iff
thf(fact_6017_filterlim__divide__at__infinity,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,C2: A,F4: filter @ A,G: A > A] :
          ( ( filterlim @ A @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ C2 ) @ F4 )
         => ( ( filterlim @ A @ A @ G @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) @ F4 )
           => ( ( C2
               != ( zero_zero @ A ) )
             => ( filterlim @ A @ A
                @ ^ [X2: A] : ( divide_divide @ A @ ( F2 @ X2 ) @ ( G @ X2 ) )
                @ ( at_infinity @ A )
                @ F4 ) ) ) ) ) ).

% filterlim_divide_at_infinity
thf(fact_6018_filterlim__tan__at__left,axiom,
    filterlim @ real @ real @ ( tan @ real ) @ ( at_top @ real ) @ ( topolo174197925503356063within @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) @ ( set_ord_lessThan @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) ) ).

% filterlim_tan_at_left
thf(fact_6019_DERIV__neg__imp__decreasing__at__top,axiom,
    ! [B2: real,F2: real > real,Flim: real] :
      ( ! [X3: real] :
          ( ( ord_less_eq @ real @ B2 @ X3 )
         => ? [Y6: real] :
              ( ( has_field_derivative @ real @ F2 @ Y6 @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) )
              & ( ord_less @ real @ Y6 @ ( zero_zero @ real ) ) ) )
     => ( ( filterlim @ real @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ Flim ) @ ( at_top @ real ) )
       => ( ord_less @ real @ Flim @ ( F2 @ B2 ) ) ) ) ).

% DERIV_neg_imp_decreasing_at_top
thf(fact_6020_tendsto__arctan__at__top,axiom,
    filterlim @ real @ real @ arctan @ ( topolo7230453075368039082e_nhds @ real @ ( divide_divide @ real @ pi @ ( numeral_numeral @ real @ ( bit0 @ one2 ) ) ) ) @ ( at_top @ real ) ).

% tendsto_arctan_at_top
thf(fact_6021_filterlim__realpow__sequentially__gt1,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [X: A] :
          ( ( ord_less @ real @ ( one_one @ real ) @ ( real_V7770717601297561774m_norm @ A @ X ) )
         => ( filterlim @ nat @ A @ ( power_power @ A @ X ) @ ( at_infinity @ A ) @ ( at_top @ nat ) ) ) ) ).

% filterlim_realpow_sequentially_gt1
thf(fact_6022_lim__at__infinity__0,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,L: A] :
          ( ( filterlim @ A @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ L ) @ ( at_infinity @ A ) )
          = ( filterlim @ A @ A @ ( comp @ A @ A @ A @ F2 @ ( inverse_inverse @ A ) ) @ ( topolo7230453075368039082e_nhds @ A @ L ) @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% lim_at_infinity_0
thf(fact_6023_polyfun__extremal,axiom,
    ! [A: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [C2: nat > A,K: nat,N: nat,B7: real] :
          ( ( ( C2 @ K )
           != ( zero_zero @ A ) )
         => ( ( ord_less_eq @ nat @ ( one_one @ nat ) @ K )
           => ( ( ord_less_eq @ nat @ K @ N )
             => ( eventually @ A
                @ ^ [Z6: A] :
                    ( ord_less_eq @ real @ B7
                    @ ( real_V7770717601297561774m_norm @ A
                      @ ( groups7311177749621191930dd_sum @ nat @ A
                        @ ^ [I4: nat] : ( times_times @ A @ ( C2 @ I4 ) @ ( power_power @ A @ Z6 @ I4 ) )
                        @ ( set_ord_atMost @ nat @ N ) ) ) )
                @ ( at_infinity @ A ) ) ) ) ) ) ).

% polyfun_extremal
thf(fact_6024_lhopital__left__at__top,axiom,
    ! [G: real > real,X: real,G4: real > real,F2: real > real,F5: real > real,Y: real] :
      ( ( filterlim @ real @ real @ G @ ( at_top @ real ) @ ( topolo174197925503356063within @ real @ X @ ( set_ord_lessThan @ real @ X ) ) )
     => ( ( eventually @ real
          @ ^ [X2: real] :
              ( ( G4 @ X2 )
             != ( zero_zero @ real ) )
          @ ( topolo174197925503356063within @ real @ X @ ( set_ord_lessThan @ real @ X ) ) )
       => ( ( eventually @ real
            @ ^ [X2: real] : ( has_field_derivative @ real @ F2 @ ( F5 @ X2 ) @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) )
            @ ( topolo174197925503356063within @ real @ X @ ( set_ord_lessThan @ real @ X ) ) )
         => ( ( eventually @ real
              @ ^ [X2: real] : ( has_field_derivative @ real @ G @ ( G4 @ X2 ) @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) )
              @ ( topolo174197925503356063within @ real @ X @ ( set_ord_lessThan @ real @ X ) ) )
           => ( ( filterlim @ real @ real
                @ ^ [X2: real] : ( divide_divide @ real @ ( F5 @ X2 ) @ ( G4 @ X2 ) )
                @ ( topolo7230453075368039082e_nhds @ real @ Y )
                @ ( topolo174197925503356063within @ real @ X @ ( set_ord_lessThan @ real @ X ) ) )
             => ( filterlim @ real @ real
                @ ^ [X2: real] : ( divide_divide @ real @ ( F2 @ X2 ) @ ( G @ X2 ) )
                @ ( topolo7230453075368039082e_nhds @ real @ Y )
                @ ( topolo174197925503356063within @ real @ X @ ( set_ord_lessThan @ real @ X ) ) ) ) ) ) ) ) ).

% lhopital_left_at_top
thf(fact_6025_eventually__nhds__top,axiom,
    ! [A: $tType] :
      ( ( ( order_top @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [B2: A,P: A > $o] :
          ( ( ord_less @ A @ B2 @ ( top_top @ A ) )
         => ( ( eventually @ A @ P @ ( topolo7230453075368039082e_nhds @ A @ ( top_top @ A ) ) )
            = ( ? [B3: A] :
                  ( ( ord_less @ A @ B3 @ ( top_top @ A ) )
                  & ! [Z6: A] :
                      ( ( ord_less @ A @ B3 @ Z6 )
                     => ( P @ Z6 ) ) ) ) ) ) ) ).

% eventually_nhds_top
thf(fact_6026_eventually__at__left__field,axiom,
    ! [A: $tType] :
      ( ( ( linordered_field @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [P: A > $o,X: A] :
          ( ( eventually @ A @ P @ ( topolo174197925503356063within @ A @ X @ ( set_ord_lessThan @ A @ X ) ) )
          = ( ? [B3: A] :
                ( ( ord_less @ A @ B3 @ X )
                & ! [Y4: A] :
                    ( ( ord_less @ A @ B3 @ Y4 )
                   => ( ( ord_less @ A @ Y4 @ X )
                     => ( P @ Y4 ) ) ) ) ) ) ) ).

% eventually_at_left_field
thf(fact_6027_eventually__at__left,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [Y: A,X: A,P: A > $o] :
          ( ( ord_less @ A @ Y @ X )
         => ( ( eventually @ A @ P @ ( topolo174197925503356063within @ A @ X @ ( set_ord_lessThan @ A @ X ) ) )
            = ( ? [B3: A] :
                  ( ( ord_less @ A @ B3 @ X )
                  & ! [Y4: A] :
                      ( ( ord_less @ A @ B3 @ Y4 )
                     => ( ( ord_less @ A @ Y4 @ X )
                       => ( P @ Y4 ) ) ) ) ) ) ) ) ).

% eventually_at_left
thf(fact_6028_eventually__at__right,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [X: A,Y: A,P: A > $o] :
          ( ( ord_less @ A @ X @ Y )
         => ( ( eventually @ A @ P @ ( topolo174197925503356063within @ A @ X @ ( set_ord_greaterThan @ A @ X ) ) )
            = ( ? [B3: A] :
                  ( ( ord_less @ A @ X @ B3 )
                  & ! [Y4: A] :
                      ( ( ord_less @ A @ X @ Y4 )
                     => ( ( ord_less @ A @ Y4 @ B3 )
                       => ( P @ Y4 ) ) ) ) ) ) ) ) ).

% eventually_at_right
thf(fact_6029_eventually__at__right__field,axiom,
    ! [A: $tType] :
      ( ( ( linordered_field @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [P: A > $o,X: A] :
          ( ( eventually @ A @ P @ ( topolo174197925503356063within @ A @ X @ ( set_ord_greaterThan @ A @ X ) ) )
          = ( ? [B3: A] :
                ( ( ord_less @ A @ X @ B3 )
                & ! [Y4: A] :
                    ( ( ord_less @ A @ X @ Y4 )
                   => ( ( ord_less @ A @ Y4 @ B3 )
                     => ( P @ Y4 ) ) ) ) ) ) ) ).

% eventually_at_right_field
thf(fact_6030_eventually__at__infinity,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [P: A > $o] :
          ( ( eventually @ A @ P @ ( at_infinity @ A ) )
          = ( ? [B3: real] :
              ! [X2: A] :
                ( ( ord_less_eq @ real @ B3 @ ( real_V7770717601297561774m_norm @ A @ X2 ) )
               => ( P @ X2 ) ) ) ) ) ).

% eventually_at_infinity
thf(fact_6031_tendsto__sandwich,axiom,
    ! [A: $tType,B: $tType] :
      ( ( topolo2564578578187576103pology @ A )
     => ! [F2: B > A,G: B > A,Net: filter @ B,H2: B > A,C2: A] :
          ( ( eventually @ B
            @ ^ [N3: B] : ( ord_less_eq @ A @ ( F2 @ N3 ) @ ( G @ N3 ) )
            @ Net )
         => ( ( eventually @ B
              @ ^ [N3: B] : ( ord_less_eq @ A @ ( G @ N3 ) @ ( H2 @ N3 ) )
              @ Net )
           => ( ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ C2 ) @ Net )
             => ( ( filterlim @ B @ A @ H2 @ ( topolo7230453075368039082e_nhds @ A @ C2 ) @ Net )
               => ( filterlim @ B @ A @ G @ ( topolo7230453075368039082e_nhds @ A @ C2 ) @ Net ) ) ) ) ) ) ).

% tendsto_sandwich
thf(fact_6032_tendsto__le,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [F4: filter @ B,F2: B > A,X: A,G: B > A,Y: A] :
          ( ( F4
           != ( bot_bot @ ( filter @ B ) ) )
         => ( ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ X ) @ F4 )
           => ( ( filterlim @ B @ A @ G @ ( topolo7230453075368039082e_nhds @ A @ Y ) @ F4 )
             => ( ( eventually @ B
                  @ ^ [X2: B] : ( ord_less_eq @ A @ ( G @ X2 ) @ ( F2 @ X2 ) )
                  @ F4 )
               => ( ord_less_eq @ A @ Y @ X ) ) ) ) ) ) ).

% tendsto_le
thf(fact_6033_tendsto__lowerbound,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [F2: B > A,X: A,F4: filter @ B,A2: A] :
          ( ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ X ) @ F4 )
         => ( ( eventually @ B
              @ ^ [I4: B] : ( ord_less_eq @ A @ A2 @ ( F2 @ I4 ) )
              @ F4 )
           => ( ( F4
               != ( bot_bot @ ( filter @ B ) ) )
             => ( ord_less_eq @ A @ A2 @ X ) ) ) ) ) ).

% tendsto_lowerbound
thf(fact_6034_tendsto__upperbound,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [F2: B > A,X: A,F4: filter @ B,A2: A] :
          ( ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ X ) @ F4 )
         => ( ( eventually @ B
              @ ^ [I4: B] : ( ord_less_eq @ A @ ( F2 @ I4 ) @ A2 )
              @ F4 )
           => ( ( F4
               != ( bot_bot @ ( filter @ B ) ) )
             => ( ord_less_eq @ A @ X @ A2 ) ) ) ) ) ).

% tendsto_upperbound
thf(fact_6035_order__tendstoD_I2_J,axiom,
    ! [A: $tType,B: $tType] :
      ( ( topolo2564578578187576103pology @ A )
     => ! [F2: B > A,Y: A,F4: filter @ B,A2: A] :
          ( ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ Y ) @ F4 )
         => ( ( ord_less @ A @ Y @ A2 )
           => ( eventually @ B
              @ ^ [X2: B] : ( ord_less @ A @ ( F2 @ X2 ) @ A2 )
              @ F4 ) ) ) ) ).

% order_tendstoD(2)
thf(fact_6036_order__tendstoD_I1_J,axiom,
    ! [A: $tType,B: $tType] :
      ( ( topolo2564578578187576103pology @ A )
     => ! [F2: B > A,Y: A,F4: filter @ B,A2: A] :
          ( ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ Y ) @ F4 )
         => ( ( ord_less @ A @ A2 @ Y )
           => ( eventually @ B
              @ ^ [X2: B] : ( ord_less @ A @ A2 @ ( F2 @ X2 ) )
              @ F4 ) ) ) ) ).

% order_tendstoD(1)
thf(fact_6037_order__tendstoI,axiom,
    ! [A: $tType,B: $tType] :
      ( ( topolo2564578578187576103pology @ A )
     => ! [Y: A,F2: B > A,F4: filter @ B] :
          ( ! [A5: A] :
              ( ( ord_less @ A @ A5 @ Y )
             => ( eventually @ B
                @ ^ [X2: B] : ( ord_less @ A @ A5 @ ( F2 @ X2 ) )
                @ F4 ) )
         => ( ! [A5: A] :
                ( ( ord_less @ A @ Y @ A5 )
               => ( eventually @ B
                  @ ^ [X2: B] : ( ord_less @ A @ ( F2 @ X2 ) @ A5 )
                  @ F4 ) )
           => ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ Y ) @ F4 ) ) ) ) ).

% order_tendstoI
thf(fact_6038_order__tendsto__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo2564578578187576103pology @ A )
     => ! [F2: B > A,X: A,F4: filter @ B] :
          ( ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ X ) @ F4 )
          = ( ! [L2: A] :
                ( ( ord_less @ A @ L2 @ X )
               => ( eventually @ B
                  @ ^ [X2: B] : ( ord_less @ A @ L2 @ ( F2 @ X2 ) )
                  @ F4 ) )
            & ! [U2: A] :
                ( ( ord_less @ A @ X @ U2 )
               => ( eventually @ B
                  @ ^ [X2: B] : ( ord_less @ A @ ( F2 @ X2 ) @ U2 )
                  @ F4 ) ) ) ) ) ).

% order_tendsto_iff
thf(fact_6039_eventually__at__right__less,axiom,
    ! [A: $tType] :
      ( ( ( no_top @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [X: A] : ( eventually @ A @ ( ord_less @ A @ X ) @ ( topolo174197925503356063within @ A @ X @ ( set_ord_greaterThan @ A @ X ) ) ) ) ).

% eventually_at_right_less
thf(fact_6040_real__tendsto__sandwich,axiom,
    ! [B: $tType,F2: B > real,G: B > real,Net: filter @ B,H2: B > real,C2: real] :
      ( ( eventually @ B
        @ ^ [N3: B] : ( ord_less_eq @ real @ ( F2 @ N3 ) @ ( G @ N3 ) )
        @ Net )
     => ( ( eventually @ B
          @ ^ [N3: B] : ( ord_less_eq @ real @ ( G @ N3 ) @ ( H2 @ N3 ) )
          @ Net )
       => ( ( filterlim @ B @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ C2 ) @ Net )
         => ( ( filterlim @ B @ real @ H2 @ ( topolo7230453075368039082e_nhds @ real @ C2 ) @ Net )
           => ( filterlim @ B @ real @ G @ ( topolo7230453075368039082e_nhds @ real @ C2 ) @ Net ) ) ) ) ) ).

% real_tendsto_sandwich
thf(fact_6041_eventually__at,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [P: A > $o,A2: A,S: set @ A] :
          ( ( eventually @ A @ P @ ( topolo174197925503356063within @ A @ A2 @ S ) )
          = ( ? [D4: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ D4 )
                & ! [X2: A] :
                    ( ( member @ A @ X2 @ S )
                   => ( ( ( X2 != A2 )
                        & ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X2 @ A2 ) @ D4 ) )
                     => ( P @ X2 ) ) ) ) ) ) ) ).

% eventually_at
thf(fact_6042_eventually__nhds__metric,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [P: A > $o,A2: A] :
          ( ( eventually @ A @ P @ ( topolo7230453075368039082e_nhds @ A @ A2 ) )
          = ( ? [D4: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ D4 )
                & ! [X2: A] :
                    ( ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X2 @ A2 ) @ D4 )
                   => ( P @ X2 ) ) ) ) ) ) ).

% eventually_nhds_metric
thf(fact_6043_eventually__at__leftI,axiom,
    ! [A: $tType] :
      ( ( topolo2564578578187576103pology @ A )
     => ! [A2: A,B2: A,P: A > $o] :
          ( ! [X3: A] :
              ( ( member @ A @ X3 @ ( set_or5935395276787703475ssThan @ A @ A2 @ B2 ) )
             => ( P @ X3 ) )
         => ( ( ord_less @ A @ A2 @ B2 )
           => ( eventually @ A @ P @ ( topolo174197925503356063within @ A @ B2 @ ( set_ord_lessThan @ A @ B2 ) ) ) ) ) ) ).

% eventually_at_leftI
thf(fact_6044_eventually__at__rightI,axiom,
    ! [A: $tType] :
      ( ( topolo2564578578187576103pology @ A )
     => ! [A2: A,B2: A,P: A > $o] :
          ( ! [X3: A] :
              ( ( member @ A @ X3 @ ( set_or5935395276787703475ssThan @ A @ A2 @ B2 ) )
             => ( P @ X3 ) )
         => ( ( ord_less @ A @ A2 @ B2 )
           => ( eventually @ A @ P @ ( topolo174197925503356063within @ A @ A2 @ ( set_ord_greaterThan @ A @ A2 ) ) ) ) ) ) ).

% eventually_at_rightI
thf(fact_6045_eventually__at__to__0,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [P: A > $o,A2: A] :
          ( ( eventually @ A @ P @ ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) ) )
          = ( eventually @ A
            @ ^ [X2: A] : ( P @ ( plus_plus @ A @ X2 @ A2 ) )
            @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% eventually_at_to_0
thf(fact_6046_increasing__tendsto,axiom,
    ! [A: $tType,B: $tType] :
      ( ( topolo2564578578187576103pology @ A )
     => ! [F2: B > A,L: A,F4: filter @ B] :
          ( ( eventually @ B
            @ ^ [N3: B] : ( ord_less_eq @ A @ ( F2 @ N3 ) @ L )
            @ F4 )
         => ( ! [X3: A] :
                ( ( ord_less @ A @ X3 @ L )
               => ( eventually @ B
                  @ ^ [N3: B] : ( ord_less @ A @ X3 @ ( F2 @ N3 ) )
                  @ F4 ) )
           => ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ L ) @ F4 ) ) ) ) ).

% increasing_tendsto
thf(fact_6047_decreasing__tendsto,axiom,
    ! [A: $tType,B: $tType] :
      ( ( topolo2564578578187576103pology @ A )
     => ! [L: A,F2: B > A,F4: filter @ B] :
          ( ( eventually @ B
            @ ^ [N3: B] : ( ord_less_eq @ A @ L @ ( F2 @ N3 ) )
            @ F4 )
         => ( ! [X3: A] :
                ( ( ord_less @ A @ L @ X3 )
               => ( eventually @ B
                  @ ^ [N3: B] : ( ord_less @ A @ ( F2 @ N3 ) @ X3 )
                  @ F4 ) )
           => ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ L ) @ F4 ) ) ) ) ).

% decreasing_tendsto
thf(fact_6048_metric__tendsto__imp__tendsto,axiom,
    ! [A: $tType,B: $tType,C: $tType] :
      ( ( ( real_V7819770556892013058_space @ B )
        & ( real_V7819770556892013058_space @ A ) )
     => ! [F2: C > A,A2: A,F4: filter @ C,G: C > B,B2: B] :
          ( ( filterlim @ C @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ A2 ) @ F4 )
         => ( ( eventually @ C
              @ ^ [X2: C] : ( ord_less_eq @ real @ ( real_V557655796197034286t_dist @ B @ ( G @ X2 ) @ B2 ) @ ( real_V557655796197034286t_dist @ A @ ( F2 @ X2 ) @ A2 ) )
              @ F4 )
           => ( filterlim @ C @ B @ G @ ( topolo7230453075368039082e_nhds @ B @ B2 ) @ F4 ) ) ) ) ).

% metric_tendsto_imp_tendsto
thf(fact_6049_filterlim__at__infinity__imp__filterlim__at__top,axiom,
    ! [A: $tType,F2: A > real,F4: filter @ A] :
      ( ( filterlim @ A @ real @ F2 @ ( at_infinity @ real ) @ F4 )
     => ( ( eventually @ A
          @ ^ [X2: A] : ( ord_less @ real @ ( zero_zero @ real ) @ ( F2 @ X2 ) )
          @ F4 )
       => ( filterlim @ A @ real @ F2 @ ( at_top @ real ) @ F4 ) ) ) ).

% filterlim_at_infinity_imp_filterlim_at_top
thf(fact_6050_filterlim__at__infinity__imp__filterlim__at__bot,axiom,
    ! [A: $tType,F2: A > real,F4: filter @ A] :
      ( ( filterlim @ A @ real @ F2 @ ( at_infinity @ real ) @ F4 )
     => ( ( eventually @ A
          @ ^ [X2: A] : ( ord_less @ real @ ( F2 @ X2 ) @ ( zero_zero @ real ) )
          @ F4 )
       => ( filterlim @ A @ real @ F2 @ ( at_bot @ real ) @ F4 ) ) ) ).

% filterlim_at_infinity_imp_filterlim_at_bot
thf(fact_6051_eventually__at__right__to__0,axiom,
    ! [P: real > $o,A2: real] :
      ( ( eventually @ real @ P @ ( topolo174197925503356063within @ real @ A2 @ ( set_ord_greaterThan @ real @ A2 ) ) )
      = ( eventually @ real
        @ ^ [X2: real] : ( P @ ( plus_plus @ real @ X2 @ A2 ) )
        @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) ) ) ).

% eventually_at_right_to_0
thf(fact_6052_continuous__arcosh__strong,axiom,
    ! [A: $tType] :
      ( ( topological_t2_space @ A )
     => ! [F4: filter @ A,F2: A > real] :
          ( ( topolo3448309680560233919inuous @ A @ real @ F4 @ F2 )
         => ( ( eventually @ A
              @ ^ [X2: A] : ( ord_less_eq @ real @ ( one_one @ real ) @ ( F2 @ X2 ) )
              @ F4 )
           => ( topolo3448309680560233919inuous @ A @ real @ F4
              @ ^ [X2: A] : ( arcosh @ real @ ( F2 @ X2 ) ) ) ) ) ) ).

% continuous_arcosh_strong
thf(fact_6053_eventually__at__right__real,axiom,
    ! [A2: real,B2: real] :
      ( ( ord_less @ real @ A2 @ B2 )
     => ( eventually @ real
        @ ^ [X2: real] : ( member @ real @ X2 @ ( set_or5935395276787703475ssThan @ real @ A2 @ B2 ) )
        @ ( topolo174197925503356063within @ real @ A2 @ ( set_ord_greaterThan @ real @ A2 ) ) ) ) ).

% eventually_at_right_real
thf(fact_6054_eventually__at__left__real,axiom,
    ! [B2: real,A2: real] :
      ( ( ord_less @ real @ B2 @ A2 )
     => ( eventually @ real
        @ ^ [X2: real] : ( member @ real @ X2 @ ( set_or5935395276787703475ssThan @ real @ B2 @ A2 ) )
        @ ( topolo174197925503356063within @ real @ A2 @ ( set_ord_lessThan @ real @ A2 ) ) ) ) ).

% eventually_at_left_real
thf(fact_6055_eventually__at__le,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [P: A > $o,A2: A,S: set @ A] :
          ( ( eventually @ A @ P @ ( topolo174197925503356063within @ A @ A2 @ S ) )
          = ( ? [D4: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ D4 )
                & ! [X2: A] :
                    ( ( member @ A @ X2 @ S )
                   => ( ( ( X2 != A2 )
                        & ( ord_less_eq @ real @ ( real_V557655796197034286t_dist @ A @ X2 @ A2 ) @ D4 ) )
                     => ( P @ X2 ) ) ) ) ) ) ) ).

% eventually_at_le
thf(fact_6056_eventually__at__infinity__pos,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [P6: A > $o] :
          ( ( eventually @ A @ P6 @ ( at_infinity @ A ) )
          = ( ? [B3: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ B3 )
                & ! [X2: A] :
                    ( ( ord_less_eq @ real @ B3 @ ( real_V7770717601297561774m_norm @ A @ X2 ) )
                   => ( P6 @ X2 ) ) ) ) ) ) ).

% eventually_at_infinity_pos
thf(fact_6057_tendsto__imp__filterlim__at__left,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo2564578578187576103pology @ B )
     => ! [F2: A > B,L5: B,F4: filter @ A] :
          ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ L5 ) @ F4 )
         => ( ( eventually @ A
              @ ^ [X2: A] : ( ord_less @ B @ ( F2 @ X2 ) @ L5 )
              @ F4 )
           => ( filterlim @ A @ B @ F2 @ ( topolo174197925503356063within @ B @ L5 @ ( set_ord_lessThan @ B @ L5 ) ) @ F4 ) ) ) ) ).

% tendsto_imp_filterlim_at_left
thf(fact_6058_tendsto__imp__filterlim__at__right,axiom,
    ! [B: $tType,A: $tType] :
      ( ( topolo2564578578187576103pology @ B )
     => ! [F2: A > B,L5: B,F4: filter @ A] :
          ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ L5 ) @ F4 )
         => ( ( eventually @ A
              @ ^ [X2: A] : ( ord_less @ B @ L5 @ ( F2 @ X2 ) )
              @ F4 )
           => ( filterlim @ A @ B @ F2 @ ( topolo174197925503356063within @ B @ L5 @ ( set_ord_greaterThan @ B @ L5 ) ) @ F4 ) ) ) ) ).

% tendsto_imp_filterlim_at_right
thf(fact_6059_tendsto__iff,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [F2: B > A,L: A,F4: filter @ B] :
          ( ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ L ) @ F4 )
          = ( ! [E3: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ E3 )
               => ( eventually @ B
                  @ ^ [X2: B] : ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ ( F2 @ X2 ) @ L ) @ E3 )
                  @ F4 ) ) ) ) ) ).

% tendsto_iff
thf(fact_6060_tendstoI,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [F2: B > A,L: A,F4: filter @ B] :
          ( ! [E: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ E )
             => ( eventually @ B
                @ ^ [X2: B] : ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ ( F2 @ X2 ) @ L ) @ E )
                @ F4 ) )
         => ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ L ) @ F4 ) ) ) ).

% tendstoI
thf(fact_6061_tendstoD,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [F2: B > A,L: A,F4: filter @ B,E2: real] :
          ( ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ L ) @ F4 )
         => ( ( ord_less @ real @ ( zero_zero @ real ) @ E2 )
           => ( eventually @ B
              @ ^ [X2: B] : ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ ( F2 @ X2 ) @ L ) @ E2 )
              @ F4 ) ) ) ) ).

% tendstoD
thf(fact_6062_summable__comparison__test__ev,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach @ A )
     => ! [F2: nat > A,G: nat > real] :
          ( ( eventually @ nat
            @ ^ [N3: nat] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( F2 @ N3 ) ) @ ( G @ N3 ) )
            @ ( at_top @ nat ) )
         => ( ( summable @ real @ G )
           => ( summable @ A @ F2 ) ) ) ) ).

% summable_comparison_test_ev
thf(fact_6063_eventually__at__top__to__right,axiom,
    ! [P: real > $o] :
      ( ( eventually @ real @ P @ ( at_top @ real ) )
      = ( eventually @ real
        @ ^ [X2: real] : ( P @ ( inverse_inverse @ real @ X2 ) )
        @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) ) ) ).

% eventually_at_top_to_right
thf(fact_6064_eventually__at__right__to__top,axiom,
    ! [P: real > $o] :
      ( ( eventually @ real @ P @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) )
      = ( eventually @ real
        @ ^ [X2: real] : ( P @ ( inverse_inverse @ real @ X2 ) )
        @ ( at_top @ real ) ) ) ).

% eventually_at_right_to_top
thf(fact_6065_tendsto__arcosh__strong,axiom,
    ! [B: $tType,F2: B > real,A2: real,F4: filter @ B] :
      ( ( filterlim @ B @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ A2 ) @ F4 )
     => ( ( ord_less_eq @ real @ ( one_one @ real ) @ A2 )
       => ( ( eventually @ B
            @ ^ [X2: B] : ( ord_less_eq @ real @ ( one_one @ real ) @ ( F2 @ X2 ) )
            @ F4 )
         => ( filterlim @ B @ real
            @ ^ [X2: B] : ( arcosh @ real @ ( F2 @ X2 ) )
            @ ( topolo7230453075368039082e_nhds @ real @ ( arcosh @ real @ A2 ) )
            @ F4 ) ) ) ) ).

% tendsto_arcosh_strong
thf(fact_6066_filterlim__at__top__at__left,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topolo1944317154257567458pology @ A )
        & ( linorder @ B ) )
     => ! [Q: A > $o,F2: A > B,P: B > $o,G: B > A,A2: A] :
          ( ! [X3: A,Y5: A] :
              ( ( Q @ X3 )
             => ( ( Q @ Y5 )
               => ( ( ord_less_eq @ A @ X3 @ Y5 )
                 => ( ord_less_eq @ B @ ( F2 @ X3 ) @ ( F2 @ Y5 ) ) ) ) )
         => ( ! [X3: B] :
                ( ( P @ X3 )
               => ( ( F2 @ ( G @ X3 ) )
                  = X3 ) )
           => ( ! [X3: B] :
                  ( ( P @ X3 )
                 => ( Q @ ( G @ X3 ) ) )
             => ( ( eventually @ A @ Q @ ( topolo174197925503356063within @ A @ A2 @ ( set_ord_lessThan @ A @ A2 ) ) )
               => ( ! [B4: A] :
                      ( ( Q @ B4 )
                     => ( ord_less @ A @ B4 @ A2 ) )
                 => ( ( eventually @ B @ P @ ( at_top @ B ) )
                   => ( filterlim @ A @ B @ F2 @ ( at_top @ B ) @ ( topolo174197925503356063within @ A @ A2 @ ( set_ord_lessThan @ A @ A2 ) ) ) ) ) ) ) ) ) ) ).

% filterlim_at_top_at_left
thf(fact_6067_filterlim__at__bot__at__right,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topolo1944317154257567458pology @ A )
        & ( linorder @ B ) )
     => ! [Q: A > $o,F2: A > B,P: B > $o,G: B > A,A2: A] :
          ( ! [X3: A,Y5: A] :
              ( ( Q @ X3 )
             => ( ( Q @ Y5 )
               => ( ( ord_less_eq @ A @ X3 @ Y5 )
                 => ( ord_less_eq @ B @ ( F2 @ X3 ) @ ( F2 @ Y5 ) ) ) ) )
         => ( ! [X3: B] :
                ( ( P @ X3 )
               => ( ( F2 @ ( G @ X3 ) )
                  = X3 ) )
           => ( ! [X3: B] :
                  ( ( P @ X3 )
                 => ( Q @ ( G @ X3 ) ) )
             => ( ( eventually @ A @ Q @ ( topolo174197925503356063within @ A @ A2 @ ( set_ord_greaterThan @ A @ A2 ) ) )
               => ( ! [B4: A] :
                      ( ( Q @ B4 )
                     => ( ord_less @ A @ A2 @ B4 ) )
                 => ( ( eventually @ B @ P @ ( at_bot @ B ) )
                   => ( filterlim @ A @ B @ F2 @ ( at_bot @ B ) @ ( topolo174197925503356063within @ A @ A2 @ ( set_ord_greaterThan @ A @ A2 ) ) ) ) ) ) ) ) ) ) ).

% filterlim_at_bot_at_right
thf(fact_6068_tendsto__0__le,axiom,
    ! [B: $tType,C: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ C )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F2: A > B,F4: filter @ A,G: A > C,K6: real] :
          ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ ( zero_zero @ B ) ) @ F4 )
         => ( ( eventually @ A
              @ ^ [X2: A] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ C @ ( G @ X2 ) ) @ ( times_times @ real @ ( real_V7770717601297561774m_norm @ B @ ( F2 @ X2 ) ) @ K6 ) )
              @ F4 )
           => ( filterlim @ A @ C @ G @ ( topolo7230453075368039082e_nhds @ C @ ( zero_zero @ C ) ) @ F4 ) ) ) ) ).

% tendsto_0_le
thf(fact_6069_filterlim__at__infinity,axiom,
    ! [C: $tType,A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [C2: real,F2: C > A,F4: filter @ C] :
          ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ C2 )
         => ( ( filterlim @ C @ A @ F2 @ ( at_infinity @ A ) @ F4 )
            = ( ! [R5: real] :
                  ( ( ord_less @ real @ C2 @ R5 )
                 => ( eventually @ C
                    @ ^ [X2: C] : ( ord_less_eq @ real @ R5 @ ( real_V7770717601297561774m_norm @ A @ ( F2 @ X2 ) ) )
                    @ F4 ) ) ) ) ) ) ).

% filterlim_at_infinity
thf(fact_6070_tendsto__zero__powrI,axiom,
    ! [A: $tType,F2: A > real,F4: filter @ A,G: A > real,B2: real] :
      ( ( filterlim @ A @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ F4 )
     => ( ( filterlim @ A @ real @ G @ ( topolo7230453075368039082e_nhds @ real @ B2 ) @ F4 )
       => ( ( eventually @ A
            @ ^ [X2: A] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( F2 @ X2 ) )
            @ F4 )
         => ( ( ord_less @ real @ ( zero_zero @ real ) @ B2 )
           => ( filterlim @ A @ real
              @ ^ [X2: A] : ( powr @ real @ ( F2 @ X2 ) @ ( G @ X2 ) )
              @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) )
              @ F4 ) ) ) ) ) ).

% tendsto_zero_powrI
thf(fact_6071_tendsto__powr2,axiom,
    ! [A: $tType,F2: A > real,A2: real,F4: filter @ A,G: A > real,B2: real] :
      ( ( filterlim @ A @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ A2 ) @ F4 )
     => ( ( filterlim @ A @ real @ G @ ( topolo7230453075368039082e_nhds @ real @ B2 ) @ F4 )
       => ( ( eventually @ A
            @ ^ [X2: A] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( F2 @ X2 ) )
            @ F4 )
         => ( ( ord_less @ real @ ( zero_zero @ real ) @ B2 )
           => ( filterlim @ A @ real
              @ ^ [X2: A] : ( powr @ real @ ( F2 @ X2 ) @ ( G @ X2 ) )
              @ ( topolo7230453075368039082e_nhds @ real @ ( powr @ real @ A2 @ B2 ) )
              @ F4 ) ) ) ) ) ).

% tendsto_powr2
thf(fact_6072_tendsto__powr_H,axiom,
    ! [A: $tType,F2: A > real,A2: real,F4: filter @ A,G: A > real,B2: real] :
      ( ( filterlim @ A @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ A2 ) @ F4 )
     => ( ( filterlim @ A @ real @ G @ ( topolo7230453075368039082e_nhds @ real @ B2 ) @ F4 )
       => ( ( ( A2
             != ( zero_zero @ real ) )
            | ( ( ord_less @ real @ ( zero_zero @ real ) @ B2 )
              & ( eventually @ A
                @ ^ [X2: A] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( F2 @ X2 ) )
                @ F4 ) ) )
         => ( filterlim @ A @ real
            @ ^ [X2: A] : ( powr @ real @ ( F2 @ X2 ) @ ( G @ X2 ) )
            @ ( topolo7230453075368039082e_nhds @ real @ ( powr @ real @ A2 @ B2 ) )
            @ F4 ) ) ) ) ).

% tendsto_powr'
thf(fact_6073_eventually__floor__less,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( archim2362893244070406136eiling @ B )
        & ( topolo2564578578187576103pology @ B ) )
     => ! [F2: A > B,L: B,F4: filter @ A] :
          ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ L ) @ F4 )
         => ( ~ ( member @ B @ L @ ( ring_1_Ints @ B ) )
           => ( eventually @ A
              @ ^ [X2: A] : ( ord_less @ B @ ( ring_1_of_int @ B @ ( archim6421214686448440834_floor @ B @ L ) ) @ ( F2 @ X2 ) )
              @ F4 ) ) ) ) ).

% eventually_floor_less
thf(fact_6074_LIM__at__top__divide,axiom,
    ! [A: $tType,F2: A > real,A2: real,F4: filter @ A,G: A > real] :
      ( ( filterlim @ A @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ A2 ) @ F4 )
     => ( ( ord_less @ real @ ( zero_zero @ real ) @ A2 )
       => ( ( filterlim @ A @ real @ G @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ F4 )
         => ( ( eventually @ A
              @ ^ [X2: A] : ( ord_less @ real @ ( zero_zero @ real ) @ ( G @ X2 ) )
              @ F4 )
           => ( filterlim @ A @ real
              @ ^ [X2: A] : ( divide_divide @ real @ ( F2 @ X2 ) @ ( G @ X2 ) )
              @ ( at_top @ real )
              @ F4 ) ) ) ) ) ).

% LIM_at_top_divide
thf(fact_6075_eventually__less__ceiling,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( archim2362893244070406136eiling @ B )
        & ( topolo2564578578187576103pology @ B ) )
     => ! [F2: A > B,L: B,F4: filter @ A] :
          ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ L ) @ F4 )
         => ( ~ ( member @ B @ L @ ( ring_1_Ints @ B ) )
           => ( eventually @ A
              @ ^ [X2: A] : ( ord_less @ B @ ( F2 @ X2 ) @ ( ring_1_of_int @ B @ ( archimedean_ceiling @ B @ L ) ) )
              @ F4 ) ) ) ) ).

% eventually_less_ceiling
thf(fact_6076_filterlim__at__top__iff__inverse__0,axiom,
    ! [A: $tType,F2: A > real,F4: filter @ A] :
      ( ( eventually @ A
        @ ^ [X2: A] : ( ord_less @ real @ ( zero_zero @ real ) @ ( F2 @ X2 ) )
        @ F4 )
     => ( ( filterlim @ A @ real @ F2 @ ( at_top @ real ) @ F4 )
        = ( filterlim @ A @ real @ ( comp @ real @ real @ A @ ( inverse_inverse @ real ) @ F2 ) @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ F4 ) ) ) ).

% filterlim_at_top_iff_inverse_0
thf(fact_6077_filterlim__inverse__at__top,axiom,
    ! [A: $tType,F2: A > real,F4: filter @ A] :
      ( ( filterlim @ A @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ F4 )
     => ( ( eventually @ A
          @ ^ [X2: A] : ( ord_less @ real @ ( zero_zero @ real ) @ ( F2 @ X2 ) )
          @ F4 )
       => ( filterlim @ A @ real
          @ ^ [X2: A] : ( inverse_inverse @ real @ ( F2 @ X2 ) )
          @ ( at_top @ real )
          @ F4 ) ) ) ).

% filterlim_inverse_at_top
thf(fact_6078_filterlim__inverse__at__top__iff,axiom,
    ! [A: $tType,F2: A > real,F4: filter @ A] :
      ( ( eventually @ A
        @ ^ [X2: A] : ( ord_less @ real @ ( zero_zero @ real ) @ ( F2 @ X2 ) )
        @ F4 )
     => ( ( filterlim @ A @ real
          @ ^ [X2: A] : ( inverse_inverse @ real @ ( F2 @ X2 ) )
          @ ( at_top @ real )
          @ F4 )
        = ( filterlim @ A @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ F4 ) ) ) ).

% filterlim_inverse_at_top_iff
thf(fact_6079_filterlim__inverse__at__bot,axiom,
    ! [A: $tType,F2: A > real,F4: filter @ A] :
      ( ( filterlim @ A @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ F4 )
     => ( ( eventually @ A
          @ ^ [X2: A] : ( ord_less @ real @ ( F2 @ X2 ) @ ( zero_zero @ real ) )
          @ F4 )
       => ( filterlim @ A @ real
          @ ^ [X2: A] : ( inverse_inverse @ real @ ( F2 @ X2 ) )
          @ ( at_bot @ real )
          @ F4 ) ) ) ).

% filterlim_inverse_at_bot
thf(fact_6080_lhopital,axiom,
    ! [F2: real > real,X: real,G: real > real,G4: real > real,F5: real > real,F4: filter @ real] :
      ( ( filterlim @ real @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) )
     => ( ( filterlim @ real @ real @ G @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) )
       => ( ( eventually @ real
            @ ^ [X2: real] :
                ( ( G @ X2 )
               != ( zero_zero @ real ) )
            @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) )
         => ( ( eventually @ real
              @ ^ [X2: real] :
                  ( ( G4 @ X2 )
                 != ( zero_zero @ real ) )
              @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) )
           => ( ( eventually @ real
                @ ^ [X2: real] : ( has_field_derivative @ real @ F2 @ ( F5 @ X2 ) @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) )
                @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) )
             => ( ( eventually @ real
                  @ ^ [X2: real] : ( has_field_derivative @ real @ G @ ( G4 @ X2 ) @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) )
                  @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) )
               => ( ( filterlim @ real @ real
                    @ ^ [X2: real] : ( divide_divide @ real @ ( F5 @ X2 ) @ ( G4 @ X2 ) )
                    @ F4
                    @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) )
                 => ( filterlim @ real @ real
                    @ ^ [X2: real] : ( divide_divide @ real @ ( F2 @ X2 ) @ ( G @ X2 ) )
                    @ F4
                    @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) ) ) ) ) ) ) ) ) ).

% lhopital
thf(fact_6081_lhospital__at__top__at__top,axiom,
    ! [G: real > real,G4: real > real,F2: real > real,F5: real > real,X: real] :
      ( ( filterlim @ real @ real @ G @ ( at_top @ real ) @ ( at_top @ real ) )
     => ( ( eventually @ real
          @ ^ [X2: real] :
              ( ( G4 @ X2 )
             != ( zero_zero @ real ) )
          @ ( at_top @ real ) )
       => ( ( eventually @ real
            @ ^ [X2: real] : ( has_field_derivative @ real @ F2 @ ( F5 @ X2 ) @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) )
            @ ( at_top @ real ) )
         => ( ( eventually @ real
              @ ^ [X2: real] : ( has_field_derivative @ real @ G @ ( G4 @ X2 ) @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) )
              @ ( at_top @ real ) )
           => ( ( filterlim @ real @ real
                @ ^ [X2: real] : ( divide_divide @ real @ ( F5 @ X2 ) @ ( G4 @ X2 ) )
                @ ( topolo7230453075368039082e_nhds @ real @ X )
                @ ( at_top @ real ) )
             => ( filterlim @ real @ real
                @ ^ [X2: real] : ( divide_divide @ real @ ( F2 @ X2 ) @ ( G @ X2 ) )
                @ ( topolo7230453075368039082e_nhds @ real @ X )
                @ ( at_top @ real ) ) ) ) ) ) ) ).

% lhospital_at_top_at_top
thf(fact_6082_lhopital__at__top,axiom,
    ! [G: real > real,X: real,G4: real > real,F2: real > real,F5: real > real,Y: real] :
      ( ( filterlim @ real @ real @ G @ ( at_top @ real ) @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) )
     => ( ( eventually @ real
          @ ^ [X2: real] :
              ( ( G4 @ X2 )
             != ( zero_zero @ real ) )
          @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) )
       => ( ( eventually @ real
            @ ^ [X2: real] : ( has_field_derivative @ real @ F2 @ ( F5 @ X2 ) @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) )
            @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) )
         => ( ( eventually @ real
              @ ^ [X2: real] : ( has_field_derivative @ real @ G @ ( G4 @ X2 ) @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) )
              @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) )
           => ( ( filterlim @ real @ real
                @ ^ [X2: real] : ( divide_divide @ real @ ( F5 @ X2 ) @ ( G4 @ X2 ) )
                @ ( topolo7230453075368039082e_nhds @ real @ Y )
                @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) )
             => ( filterlim @ real @ real
                @ ^ [X2: real] : ( divide_divide @ real @ ( F2 @ X2 ) @ ( G @ X2 ) )
                @ ( topolo7230453075368039082e_nhds @ real @ Y )
                @ ( topolo174197925503356063within @ real @ X @ ( top_top @ ( set @ real ) ) ) ) ) ) ) ) ) ).

% lhopital_at_top
thf(fact_6083_lhopital__right__0,axiom,
    ! [F0: real > real,G0: real > real,G4: real > real,F5: real > real,F4: filter @ real] :
      ( ( filterlim @ real @ real @ F0 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) )
     => ( ( filterlim @ real @ real @ G0 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) )
       => ( ( eventually @ real
            @ ^ [X2: real] :
                ( ( G0 @ X2 )
               != ( zero_zero @ real ) )
            @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) )
         => ( ( eventually @ real
              @ ^ [X2: real] :
                  ( ( G4 @ X2 )
                 != ( zero_zero @ real ) )
              @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) )
           => ( ( eventually @ real
                @ ^ [X2: real] : ( has_field_derivative @ real @ F0 @ ( F5 @ X2 ) @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) )
                @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) )
             => ( ( eventually @ real
                  @ ^ [X2: real] : ( has_field_derivative @ real @ G0 @ ( G4 @ X2 ) @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) )
                  @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) )
               => ( ( filterlim @ real @ real
                    @ ^ [X2: real] : ( divide_divide @ real @ ( F5 @ X2 ) @ ( G4 @ X2 ) )
                    @ F4
                    @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) )
                 => ( filterlim @ real @ real
                    @ ^ [X2: real] : ( divide_divide @ real @ ( F0 @ X2 ) @ ( G0 @ X2 ) )
                    @ F4
                    @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) ) ) ) ) ) ) ) ) ).

% lhopital_right_0
thf(fact_6084_lhopital__right,axiom,
    ! [F2: real > real,X: real,G: real > real,G4: real > real,F5: real > real,F4: filter @ real] :
      ( ( filterlim @ real @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( topolo174197925503356063within @ real @ X @ ( set_ord_greaterThan @ real @ X ) ) )
     => ( ( filterlim @ real @ real @ G @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( topolo174197925503356063within @ real @ X @ ( set_ord_greaterThan @ real @ X ) ) )
       => ( ( eventually @ real
            @ ^ [X2: real] :
                ( ( G @ X2 )
               != ( zero_zero @ real ) )
            @ ( topolo174197925503356063within @ real @ X @ ( set_ord_greaterThan @ real @ X ) ) )
         => ( ( eventually @ real
              @ ^ [X2: real] :
                  ( ( G4 @ X2 )
                 != ( zero_zero @ real ) )
              @ ( topolo174197925503356063within @ real @ X @ ( set_ord_greaterThan @ real @ X ) ) )
           => ( ( eventually @ real
                @ ^ [X2: real] : ( has_field_derivative @ real @ F2 @ ( F5 @ X2 ) @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) )
                @ ( topolo174197925503356063within @ real @ X @ ( set_ord_greaterThan @ real @ X ) ) )
             => ( ( eventually @ real
                  @ ^ [X2: real] : ( has_field_derivative @ real @ G @ ( G4 @ X2 ) @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) )
                  @ ( topolo174197925503356063within @ real @ X @ ( set_ord_greaterThan @ real @ X ) ) )
               => ( ( filterlim @ real @ real
                    @ ^ [X2: real] : ( divide_divide @ real @ ( F5 @ X2 ) @ ( G4 @ X2 ) )
                    @ F4
                    @ ( topolo174197925503356063within @ real @ X @ ( set_ord_greaterThan @ real @ X ) ) )
                 => ( filterlim @ real @ real
                    @ ^ [X2: real] : ( divide_divide @ real @ ( F2 @ X2 ) @ ( G @ X2 ) )
                    @ F4
                    @ ( topolo174197925503356063within @ real @ X @ ( set_ord_greaterThan @ real @ X ) ) ) ) ) ) ) ) ) ) ).

% lhopital_right
thf(fact_6085_lhopital__left,axiom,
    ! [F2: real > real,X: real,G: real > real,G4: real > real,F5: real > real,F4: filter @ real] :
      ( ( filterlim @ real @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( topolo174197925503356063within @ real @ X @ ( set_ord_lessThan @ real @ X ) ) )
     => ( ( filterlim @ real @ real @ G @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( topolo174197925503356063within @ real @ X @ ( set_ord_lessThan @ real @ X ) ) )
       => ( ( eventually @ real
            @ ^ [X2: real] :
                ( ( G @ X2 )
               != ( zero_zero @ real ) )
            @ ( topolo174197925503356063within @ real @ X @ ( set_ord_lessThan @ real @ X ) ) )
         => ( ( eventually @ real
              @ ^ [X2: real] :
                  ( ( G4 @ X2 )
                 != ( zero_zero @ real ) )
              @ ( topolo174197925503356063within @ real @ X @ ( set_ord_lessThan @ real @ X ) ) )
           => ( ( eventually @ real
                @ ^ [X2: real] : ( has_field_derivative @ real @ F2 @ ( F5 @ X2 ) @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) )
                @ ( topolo174197925503356063within @ real @ X @ ( set_ord_lessThan @ real @ X ) ) )
             => ( ( eventually @ real
                  @ ^ [X2: real] : ( has_field_derivative @ real @ G @ ( G4 @ X2 ) @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) )
                  @ ( topolo174197925503356063within @ real @ X @ ( set_ord_lessThan @ real @ X ) ) )
               => ( ( filterlim @ real @ real
                    @ ^ [X2: real] : ( divide_divide @ real @ ( F5 @ X2 ) @ ( G4 @ X2 ) )
                    @ F4
                    @ ( topolo174197925503356063within @ real @ X @ ( set_ord_lessThan @ real @ X ) ) )
                 => ( filterlim @ real @ real
                    @ ^ [X2: real] : ( divide_divide @ real @ ( F2 @ X2 ) @ ( G @ X2 ) )
                    @ F4
                    @ ( topolo174197925503356063within @ real @ X @ ( set_ord_lessThan @ real @ X ) ) ) ) ) ) ) ) ) ) ).

% lhopital_left
thf(fact_6086_lhopital__right__at__top,axiom,
    ! [G: real > real,X: real,G4: real > real,F2: real > real,F5: real > real,Y: real] :
      ( ( filterlim @ real @ real @ G @ ( at_top @ real ) @ ( topolo174197925503356063within @ real @ X @ ( set_ord_greaterThan @ real @ X ) ) )
     => ( ( eventually @ real
          @ ^ [X2: real] :
              ( ( G4 @ X2 )
             != ( zero_zero @ real ) )
          @ ( topolo174197925503356063within @ real @ X @ ( set_ord_greaterThan @ real @ X ) ) )
       => ( ( eventually @ real
            @ ^ [X2: real] : ( has_field_derivative @ real @ F2 @ ( F5 @ X2 ) @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) )
            @ ( topolo174197925503356063within @ real @ X @ ( set_ord_greaterThan @ real @ X ) ) )
         => ( ( eventually @ real
              @ ^ [X2: real] : ( has_field_derivative @ real @ G @ ( G4 @ X2 ) @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) )
              @ ( topolo174197925503356063within @ real @ X @ ( set_ord_greaterThan @ real @ X ) ) )
           => ( ( filterlim @ real @ real
                @ ^ [X2: real] : ( divide_divide @ real @ ( F5 @ X2 ) @ ( G4 @ X2 ) )
                @ ( topolo7230453075368039082e_nhds @ real @ Y )
                @ ( topolo174197925503356063within @ real @ X @ ( set_ord_greaterThan @ real @ X ) ) )
             => ( filterlim @ real @ real
                @ ^ [X2: real] : ( divide_divide @ real @ ( F2 @ X2 ) @ ( G @ X2 ) )
                @ ( topolo7230453075368039082e_nhds @ real @ Y )
                @ ( topolo174197925503356063within @ real @ X @ ( set_ord_greaterThan @ real @ X ) ) ) ) ) ) ) ) ).

% lhopital_right_at_top
thf(fact_6087_lhopital__right__0__at__top,axiom,
    ! [G: real > real,G4: real > real,F2: real > real,F5: real > real,X: real] :
      ( ( filterlim @ real @ real @ G @ ( at_top @ real ) @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) )
     => ( ( eventually @ real
          @ ^ [X2: real] :
              ( ( G4 @ X2 )
             != ( zero_zero @ real ) )
          @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) )
       => ( ( eventually @ real
            @ ^ [X2: real] : ( has_field_derivative @ real @ F2 @ ( F5 @ X2 ) @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) )
            @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) )
         => ( ( eventually @ real
              @ ^ [X2: real] : ( has_field_derivative @ real @ G @ ( G4 @ X2 ) @ ( topolo174197925503356063within @ real @ X2 @ ( top_top @ ( set @ real ) ) ) )
              @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) )
           => ( ( filterlim @ real @ real
                @ ^ [X2: real] : ( divide_divide @ real @ ( F5 @ X2 ) @ ( G4 @ X2 ) )
                @ ( topolo7230453075368039082e_nhds @ real @ X )
                @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) )
             => ( filterlim @ real @ real
                @ ^ [X2: real] : ( divide_divide @ real @ ( F2 @ X2 ) @ ( G @ X2 ) )
                @ ( topolo7230453075368039082e_nhds @ real @ X )
                @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) ) ) ) ) ) ) ).

% lhopital_right_0_at_top
thf(fact_6088_filterlim__at__bot__lt,axiom,
    ! [A: $tType,B: $tType] :
      ( ( unboun7993243217541854897norder @ B )
     => ! [F2: A > B,F4: filter @ A,C2: B] :
          ( ( filterlim @ A @ B @ F2 @ ( at_bot @ B ) @ F4 )
          = ( ! [Z8: B] :
                ( ( ord_less @ B @ Z8 @ C2 )
               => ( eventually @ A
                  @ ^ [X2: A] : ( ord_less_eq @ B @ ( F2 @ X2 ) @ Z8 )
                  @ F4 ) ) ) ) ) ).

% filterlim_at_bot_lt
thf(fact_6089_filterlim__at__top__gt,axiom,
    ! [A: $tType,B: $tType] :
      ( ( unboun7993243217541854897norder @ B )
     => ! [F2: A > B,F4: filter @ A,C2: B] :
          ( ( filterlim @ A @ B @ F2 @ ( at_top @ B ) @ F4 )
          = ( ! [Z8: B] :
                ( ( ord_less @ B @ C2 @ Z8 )
               => ( eventually @ A
                  @ ^ [X2: A] : ( ord_less_eq @ B @ Z8 @ ( F2 @ X2 ) )
                  @ F4 ) ) ) ) ) ).

% filterlim_at_top_gt
thf(fact_6090_filterlim__int__sequentially,axiom,
    filterlim @ nat @ int @ ( semiring_1_of_nat @ int ) @ ( at_top @ int ) @ ( at_top @ nat ) ).

% filterlim_int_sequentially
thf(fact_6091_filterlim__int__of__nat__at__topD,axiom,
    ! [A: $tType,F2: int > A,F4: filter @ A] :
      ( ( filterlim @ nat @ A
        @ ^ [X2: nat] : ( F2 @ ( semiring_1_of_nat @ int @ X2 ) )
        @ F4
        @ ( at_top @ nat ) )
     => ( filterlim @ int @ A @ F2 @ F4 @ ( at_top @ int ) ) ) ).

% filterlim_int_of_nat_at_topD
thf(fact_6092_eventually__sequentiallyI,axiom,
    ! [C2: nat,P: nat > $o] :
      ( ! [X3: nat] :
          ( ( ord_less_eq @ nat @ C2 @ X3 )
         => ( P @ X3 ) )
     => ( eventually @ nat @ P @ ( at_top @ nat ) ) ) ).

% eventually_sequentiallyI
thf(fact_6093_eventually__sequentially,axiom,
    ! [P: nat > $o] :
      ( ( eventually @ nat @ P @ ( at_top @ nat ) )
      = ( ? [N6: nat] :
          ! [N3: nat] :
            ( ( ord_less_eq @ nat @ N6 @ N3 )
           => ( P @ N3 ) ) ) ) ).

% eventually_sequentially
thf(fact_6094_le__sequentially,axiom,
    ! [F4: filter @ nat] :
      ( ( ord_less_eq @ ( filter @ nat ) @ F4 @ ( at_top @ nat ) )
      = ( ! [N6: nat] : ( eventually @ nat @ ( ord_less_eq @ nat @ N6 ) @ F4 ) ) ) ).

% le_sequentially
thf(fact_6095_eventually__at__top__linorderI,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [C2: A,P: A > $o] :
          ( ! [X3: A] :
              ( ( ord_less_eq @ A @ C2 @ X3 )
             => ( P @ X3 ) )
         => ( eventually @ A @ P @ ( at_top @ A ) ) ) ) ).

% eventually_at_top_linorderI
thf(fact_6096_eventually__at__top__linorder,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [P: A > $o] :
          ( ( eventually @ A @ P @ ( at_top @ A ) )
          = ( ? [N6: A] :
              ! [N3: A] :
                ( ( ord_less_eq @ A @ N6 @ N3 )
               => ( P @ N3 ) ) ) ) ) ).

% eventually_at_top_linorder
thf(fact_6097_eventually__at__top__dense,axiom,
    ! [A: $tType] :
      ( ( ( linorder @ A )
        & ( no_top @ A ) )
     => ! [P: A > $o] :
          ( ( eventually @ A @ P @ ( at_top @ A ) )
          = ( ? [N6: A] :
              ! [N3: A] :
                ( ( ord_less @ A @ N6 @ N3 )
               => ( P @ N3 ) ) ) ) ) ).

% eventually_at_top_dense
thf(fact_6098_eventually__at__bot__linorder,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [P: A > $o] :
          ( ( eventually @ A @ P @ ( at_bot @ A ) )
          = ( ? [N6: A] :
              ! [N3: A] :
                ( ( ord_less_eq @ A @ N3 @ N6 )
               => ( P @ N3 ) ) ) ) ) ).

% eventually_at_bot_linorder
thf(fact_6099_eventually__at__bot__dense,axiom,
    ! [A: $tType] :
      ( ( ( linorder @ A )
        & ( no_bot @ A ) )
     => ! [P: A > $o] :
          ( ( eventually @ A @ P @ ( at_bot @ A ) )
          = ( ? [N6: A] :
              ! [N3: A] :
                ( ( ord_less @ A @ N3 @ N6 )
               => ( P @ N3 ) ) ) ) ) ).

% eventually_at_bot_dense
thf(fact_6100_eventually__ge__at__top,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [C2: A] : ( eventually @ A @ ( ord_less_eq @ A @ C2 ) @ ( at_top @ A ) ) ) ).

% eventually_ge_at_top
thf(fact_6101_eventually__gt__at__top,axiom,
    ! [A: $tType] :
      ( ( ( linorder @ A )
        & ( no_top @ A ) )
     => ! [C2: A] : ( eventually @ A @ ( ord_less @ A @ C2 ) @ ( at_top @ A ) ) ) ).

% eventually_gt_at_top
thf(fact_6102_eventually__le__at__bot,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [C2: A] :
          ( eventually @ A
          @ ^ [X2: A] : ( ord_less_eq @ A @ X2 @ C2 )
          @ ( at_bot @ A ) ) ) ).

% eventually_le_at_bot
thf(fact_6103_eventually__gt__at__bot,axiom,
    ! [A: $tType] :
      ( ( unboun7993243217541854897norder @ A )
     => ! [C2: A] :
          ( eventually @ A
          @ ^ [X2: A] : ( ord_less @ A @ X2 @ C2 )
          @ ( at_bot @ A ) ) ) ).

% eventually_gt_at_bot
thf(fact_6104_filterlim__at__top__at__top,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( linorder @ A )
        & ( linorder @ B ) )
     => ! [Q: A > $o,F2: A > B,P: B > $o,G: B > A] :
          ( ! [X3: A,Y5: A] :
              ( ( Q @ X3 )
             => ( ( Q @ Y5 )
               => ( ( ord_less_eq @ A @ X3 @ Y5 )
                 => ( ord_less_eq @ B @ ( F2 @ X3 ) @ ( F2 @ Y5 ) ) ) ) )
         => ( ! [X3: B] :
                ( ( P @ X3 )
               => ( ( F2 @ ( G @ X3 ) )
                  = X3 ) )
           => ( ! [X3: B] :
                  ( ( P @ X3 )
                 => ( Q @ ( G @ X3 ) ) )
             => ( ( eventually @ A @ Q @ ( at_top @ A ) )
               => ( ( eventually @ B @ P @ ( at_top @ B ) )
                 => ( filterlim @ A @ B @ F2 @ ( at_top @ B ) @ ( at_top @ A ) ) ) ) ) ) ) ) ).

% filterlim_at_top_at_top
thf(fact_6105_filterlim__at__top,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ B )
     => ! [F2: A > B,F4: filter @ A] :
          ( ( filterlim @ A @ B @ F2 @ ( at_top @ B ) @ F4 )
          = ( ! [Z8: B] :
                ( eventually @ A
                @ ^ [X2: A] : ( ord_less_eq @ B @ Z8 @ ( F2 @ X2 ) )
                @ F4 ) ) ) ) ).

% filterlim_at_top
thf(fact_6106_filterlim__at__top__ge,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ B )
     => ! [F2: A > B,F4: filter @ A,C2: B] :
          ( ( filterlim @ A @ B @ F2 @ ( at_top @ B ) @ F4 )
          = ( ! [Z8: B] :
                ( ( ord_less_eq @ B @ C2 @ Z8 )
               => ( eventually @ A
                  @ ^ [X2: A] : ( ord_less_eq @ B @ Z8 @ ( F2 @ X2 ) )
                  @ F4 ) ) ) ) ) ).

% filterlim_at_top_ge
thf(fact_6107_filterlim__at__top__mono,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F2: B > A,F4: filter @ B,G: B > A] :
          ( ( filterlim @ B @ A @ F2 @ ( at_top @ A ) @ F4 )
         => ( ( eventually @ B
              @ ^ [X2: B] : ( ord_less_eq @ A @ ( F2 @ X2 ) @ ( G @ X2 ) )
              @ F4 )
           => ( filterlim @ B @ A @ G @ ( at_top @ A ) @ F4 ) ) ) ) ).

% filterlim_at_top_mono
thf(fact_6108_filterlim__at__top__dense,axiom,
    ! [A: $tType,B: $tType] :
      ( ( unboun7993243217541854897norder @ B )
     => ! [F2: A > B,F4: filter @ A] :
          ( ( filterlim @ A @ B @ F2 @ ( at_top @ B ) @ F4 )
          = ( ! [Z8: B] :
                ( eventually @ A
                @ ^ [X2: A] : ( ord_less @ B @ Z8 @ ( F2 @ X2 ) )
                @ F4 ) ) ) ) ).

% filterlim_at_top_dense
thf(fact_6109_filterlim__at__bot,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ B )
     => ! [F2: A > B,F4: filter @ A] :
          ( ( filterlim @ A @ B @ F2 @ ( at_bot @ B ) @ F4 )
          = ( ! [Z8: B] :
                ( eventually @ A
                @ ^ [X2: A] : ( ord_less_eq @ B @ ( F2 @ X2 ) @ Z8 )
                @ F4 ) ) ) ) ).

% filterlim_at_bot
thf(fact_6110_filterlim__at__bot__le,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ B )
     => ! [F2: A > B,F4: filter @ A,C2: B] :
          ( ( filterlim @ A @ B @ F2 @ ( at_bot @ B ) @ F4 )
          = ( ! [Z8: B] :
                ( ( ord_less_eq @ B @ Z8 @ C2 )
               => ( eventually @ A
                  @ ^ [X2: A] : ( ord_less_eq @ B @ ( F2 @ X2 ) @ Z8 )
                  @ F4 ) ) ) ) ) ).

% filterlim_at_bot_le
thf(fact_6111_filterlim__at__bot__dense,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( dense_linorder @ B )
        & ( no_bot @ B ) )
     => ! [F2: A > B,F4: filter @ A] :
          ( ( filterlim @ A @ B @ F2 @ ( at_bot @ B ) @ F4 )
          = ( ! [Z8: B] :
                ( eventually @ A
                @ ^ [X2: A] : ( ord_less @ B @ ( F2 @ X2 ) @ Z8 )
                @ F4 ) ) ) ) ).

% filterlim_at_bot_dense
thf(fact_6112_summable__Cauchy_H,axiom,
    ! [A: $tType] :
      ( ( real_Vector_banach @ A )
     => ! [F2: nat > A,G: nat > real] :
          ( ( eventually @ nat
            @ ^ [M3: nat] :
              ! [N3: nat] :
                ( ( ord_less_eq @ nat @ M3 @ N3 )
               => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_or7035219750837199246ssThan @ nat @ M3 @ N3 ) ) ) @ ( G @ M3 ) ) )
            @ ( at_top @ nat ) )
         => ( ( filterlim @ nat @ real @ G @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( at_top @ nat ) )
           => ( summable @ A @ F2 ) ) ) ) ).

% summable_Cauchy'
thf(fact_6113_Bfun__metric__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V7819770556892013058_space @ B )
     => ( ( bfun @ A @ B )
        = ( ^ [F3: A > B,F8: filter @ A] :
            ? [Y4: B,K7: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ K7 )
              & ( eventually @ A
                @ ^ [X2: A] : ( ord_less_eq @ real @ ( real_V557655796197034286t_dist @ B @ ( F3 @ X2 ) @ Y4 ) @ K7 )
                @ F8 ) ) ) ) ) ).

% Bfun_metric_def
thf(fact_6114_eventually__all__ge__at__top,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [P: A > $o] :
          ( ( eventually @ A @ P @ ( at_top @ A ) )
         => ( eventually @ A
            @ ^ [X2: A] :
              ! [Y4: A] :
                ( ( ord_less_eq @ A @ X2 @ Y4 )
               => ( P @ Y4 ) )
            @ ( at_top @ A ) ) ) ) ).

% eventually_all_ge_at_top
thf(fact_6115_BseqI_H,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X7: nat > A,K6: real] :
          ( ! [N2: nat] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( X7 @ N2 ) ) @ K6 )
         => ( bfun @ nat @ A @ X7 @ ( at_top @ nat ) ) ) ) ).

% BseqI'
thf(fact_6116_Bseq__cmult__iff,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [C2: A,F2: nat > A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( bfun @ nat @ A
              @ ^ [X2: nat] : ( times_times @ A @ C2 @ ( F2 @ X2 ) )
              @ ( at_top @ nat ) )
            = ( bfun @ nat @ A @ F2 @ ( at_top @ nat ) ) ) ) ) ).

% Bseq_cmult_iff
thf(fact_6117_Bseq__eventually__mono,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F2: nat > A,G: nat > B] :
          ( ( eventually @ nat
            @ ^ [N3: nat] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( F2 @ N3 ) ) @ ( real_V7770717601297561774m_norm @ B @ ( G @ N3 ) ) )
            @ ( at_top @ nat ) )
         => ( ( bfun @ nat @ B @ G @ ( at_top @ nat ) )
           => ( bfun @ nat @ A @ F2 @ ( at_top @ nat ) ) ) ) ) ).

% Bseq_eventually_mono
thf(fact_6118_Bseq__def,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X7: nat > A] :
          ( ( bfun @ nat @ A @ X7 @ ( at_top @ nat ) )
          = ( ? [K7: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ K7 )
                & ! [N3: nat] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( X7 @ N3 ) ) @ K7 ) ) ) ) ) ).

% Bseq_def
thf(fact_6119_BseqI,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [K6: real,X7: nat > A] :
          ( ( ord_less @ real @ ( zero_zero @ real ) @ K6 )
         => ( ! [N2: nat] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( X7 @ N2 ) ) @ K6 )
           => ( bfun @ nat @ A @ X7 @ ( at_top @ nat ) ) ) ) ) ).

% BseqI
thf(fact_6120_BseqE,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X7: nat > A] :
          ( ( bfun @ nat @ A @ X7 @ ( at_top @ nat ) )
         => ~ ! [K9: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ K9 )
               => ~ ! [N7: nat] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( X7 @ N7 ) ) @ K9 ) ) ) ) ).

% BseqE
thf(fact_6121_BseqD,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X7: nat > A] :
          ( ( bfun @ nat @ A @ X7 @ ( at_top @ nat ) )
         => ? [K9: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ K9 )
              & ! [N7: nat] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( X7 @ N7 ) ) @ K9 ) ) ) ) ).

% BseqD
thf(fact_6122_Bseq__iff1a,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X7: nat > A] :
          ( ( bfun @ nat @ A @ X7 @ ( at_top @ nat ) )
          = ( ? [N6: nat] :
              ! [N3: nat] : ( ord_less @ real @ ( real_V7770717601297561774m_norm @ A @ ( X7 @ N3 ) ) @ ( semiring_1_of_nat @ real @ ( suc @ N6 ) ) ) ) ) ) ).

% Bseq_iff1a
thf(fact_6123_Bseq__iff,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X7: nat > A] :
          ( ( bfun @ nat @ A @ X7 @ ( at_top @ nat ) )
          = ( ? [N6: nat] :
              ! [N3: nat] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( X7 @ N3 ) ) @ ( semiring_1_of_nat @ real @ ( suc @ N6 ) ) ) ) ) ) ).

% Bseq_iff
thf(fact_6124_Bseq__realpow,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less_eq @ real @ X @ ( one_one @ real ) )
       => ( bfun @ nat @ real @ ( power_power @ real @ X ) @ ( at_top @ nat ) ) ) ) ).

% Bseq_realpow
thf(fact_6125_BfunI,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector @ B )
     => ! [F2: A > B,K6: real,F4: filter @ A] :
          ( ( eventually @ A
            @ ^ [X2: A] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ B @ ( F2 @ X2 ) ) @ K6 )
            @ F4 )
         => ( bfun @ A @ B @ F2 @ F4 ) ) ) ).

% BfunI
thf(fact_6126_Bseq__iff3,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X7: nat > A] :
          ( ( bfun @ nat @ A @ X7 @ ( at_top @ nat ) )
          = ( ? [K3: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ K3 )
                & ? [N6: nat] :
                  ! [N3: nat] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( plus_plus @ A @ ( X7 @ N3 ) @ ( uminus_uminus @ A @ ( X7 @ N6 ) ) ) ) @ K3 ) ) ) ) ) ).

% Bseq_iff3
thf(fact_6127_Bseq__iff2,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [X7: nat > A] :
          ( ( bfun @ nat @ A @ X7 @ ( at_top @ nat ) )
          = ( ? [K3: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ K3 )
                & ? [X2: A] :
                  ! [N3: nat] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( plus_plus @ A @ ( X7 @ N3 ) @ ( uminus_uminus @ A @ X2 ) ) ) @ K3 ) ) ) ) ) ).

% Bseq_iff2
thf(fact_6128_Bfun__inverse,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [F2: B > A,A2: A,F4: filter @ B] :
          ( ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ A2 ) @ F4 )
         => ( ( A2
             != ( zero_zero @ A ) )
           => ( bfun @ B @ A
              @ ^ [X2: B] : ( inverse_inverse @ A @ ( F2 @ X2 ) )
              @ F4 ) ) ) ) ).

% Bfun_inverse
thf(fact_6129_Bfun__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector @ B )
     => ( ( bfun @ A @ B )
        = ( ^ [F3: A > B,F8: filter @ A] :
            ? [K7: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ K7 )
              & ( eventually @ A
                @ ^ [X2: A] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ B @ ( F3 @ X2 ) ) @ K7 )
                @ F8 ) ) ) ) ) ).

% Bfun_def
thf(fact_6130_BfunE,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector @ B )
     => ! [F2: A > B,F4: filter @ A] :
          ( ( bfun @ A @ B @ F2 @ F4 )
         => ~ ! [B8: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ B8 )
               => ~ ( eventually @ A
                    @ ^ [X2: A] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ B @ ( F2 @ X2 ) ) @ B8 )
                    @ F4 ) ) ) ) ).

% BfunE
thf(fact_6131_summable__bounded__partials,axiom,
    ! [A: $tType] :
      ( ( ( real_V8037385150606011577_space @ A )
        & ( real_V822414075346904944vector @ A ) )
     => ! [F2: nat > A,G: nat > real] :
          ( ( eventually @ nat
            @ ^ [X02: nat] :
              ! [A3: nat] :
                ( ( ord_less_eq @ nat @ X02 @ A3 )
               => ! [B3: nat] :
                    ( ( ord_less @ nat @ A3 @ B3 )
                   => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( groups7311177749621191930dd_sum @ nat @ A @ F2 @ ( set_or3652927894154168847AtMost @ nat @ A3 @ B3 ) ) ) @ ( G @ A3 ) ) ) )
            @ ( at_top @ nat ) )
         => ( ( filterlim @ nat @ real @ G @ ( topolo7230453075368039082e_nhds @ real @ ( zero_zero @ real ) ) @ ( at_top @ nat ) )
           => ( summable @ A @ F2 ) ) ) ) ).

% summable_bounded_partials
thf(fact_6132_Greatest__def,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( order_Greatest @ A )
        = ( ^ [P3: A > $o] :
              ( the @ A
              @ ^ [X2: A] :
                  ( ( P3 @ X2 )
                  & ! [Y4: A] :
                      ( ( P3 @ Y4 )
                     => ( ord_less_eq @ A @ Y4 @ X2 ) ) ) ) ) ) ) ).

% Greatest_def
thf(fact_6133_greaterThanAtMost__iff,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [I: A,L: A,U: A] :
          ( ( member @ A @ I @ ( set_or3652927894154168847AtMost @ A @ L @ U ) )
          = ( ( ord_less @ A @ L @ I )
            & ( ord_less_eq @ A @ I @ U ) ) ) ) ).

% greaterThanAtMost_iff
thf(fact_6134_greaterThanAtMost__empty,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [L: A,K: A] :
          ( ( ord_less_eq @ A @ L @ K )
         => ( ( set_or3652927894154168847AtMost @ A @ K @ L )
            = ( bot_bot @ ( set @ A ) ) ) ) ) ).

% greaterThanAtMost_empty
thf(fact_6135_greaterThanAtMost__empty__iff2,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [K: A,L: A] :
          ( ( ( bot_bot @ ( set @ A ) )
            = ( set_or3652927894154168847AtMost @ A @ K @ L ) )
          = ( ~ ( ord_less @ A @ K @ L ) ) ) ) ).

% greaterThanAtMost_empty_iff2
thf(fact_6136_greaterThanAtMost__empty__iff,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [K: A,L: A] :
          ( ( ( set_or3652927894154168847AtMost @ A @ K @ L )
            = ( bot_bot @ ( set @ A ) ) )
          = ( ~ ( ord_less @ A @ K @ L ) ) ) ) ).

% greaterThanAtMost_empty_iff
thf(fact_6137_infinite__Ioc__iff,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ~ ( finite_finite @ A @ ( set_or3652927894154168847AtMost @ A @ A2 @ B2 ) ) )
          = ( ord_less @ A @ A2 @ B2 ) ) ) ).

% infinite_Ioc_iff
thf(fact_6138_cSup__greaterThanAtMost,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [Y: A,X: A] :
          ( ( ord_less @ A @ Y @ X )
         => ( ( complete_Sup_Sup @ A @ ( set_or3652927894154168847AtMost @ A @ Y @ X ) )
            = X ) ) ) ).

% cSup_greaterThanAtMost
thf(fact_6139_Sup__greaterThanAtMost,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less @ A @ X @ Y )
         => ( ( complete_Sup_Sup @ A @ ( set_or3652927894154168847AtMost @ A @ X @ Y ) )
            = Y ) ) ) ).

% Sup_greaterThanAtMost
thf(fact_6140_cInf__greaterThanAtMost,axiom,
    ! [A: $tType] :
      ( ( ( condit6923001295902523014norder @ A )
        & ( dense_linorder @ A ) )
     => ! [Y: A,X: A] :
          ( ( ord_less @ A @ Y @ X )
         => ( ( complete_Inf_Inf @ A @ ( set_or3652927894154168847AtMost @ A @ Y @ X ) )
            = Y ) ) ) ).

% cInf_greaterThanAtMost
thf(fact_6141_Inf__greaterThanAtMost,axiom,
    ! [A: $tType] :
      ( ( ( comple6319245703460814977attice @ A )
        & ( dense_linorder @ A ) )
     => ! [X: A,Y: A] :
          ( ( ord_less @ A @ X @ Y )
         => ( ( complete_Inf_Inf @ A @ ( set_or3652927894154168847AtMost @ A @ X @ Y ) )
            = X ) ) ) ).

% Inf_greaterThanAtMost
thf(fact_6142_Int__greaterThanAtMost,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( inf_inf @ ( set @ A ) @ ( set_or3652927894154168847AtMost @ A @ A2 @ B2 ) @ ( set_or3652927894154168847AtMost @ A @ C2 @ D2 ) )
          = ( set_or3652927894154168847AtMost @ A @ ( ord_max @ A @ A2 @ C2 ) @ ( ord_min @ A @ B2 @ D2 ) ) ) ) ).

% Int_greaterThanAtMost
thf(fact_6143_Ioc__subset__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ord_less_eq @ ( set @ A ) @ ( set_or3652927894154168847AtMost @ A @ A2 @ B2 ) @ ( set_or3652927894154168847AtMost @ A @ C2 @ D2 ) )
          = ( ( ord_less_eq @ A @ B2 @ A2 )
            | ( ( ord_less_eq @ A @ C2 @ A2 )
              & ( ord_less_eq @ A @ B2 @ D2 ) ) ) ) ) ).

% Ioc_subset_iff
thf(fact_6144_Ioc__inj,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ( set_or3652927894154168847AtMost @ A @ A2 @ B2 )
            = ( set_or3652927894154168847AtMost @ A @ C2 @ D2 ) )
          = ( ( ( ord_less_eq @ A @ B2 @ A2 )
              & ( ord_less_eq @ A @ D2 @ C2 ) )
            | ( ( A2 = C2 )
              & ( B2 = D2 ) ) ) ) ) ).

% Ioc_inj
thf(fact_6145_ivl__disj__un__two_I6_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L: A,M: A,U: A] :
          ( ( ord_less_eq @ A @ L @ M )
         => ( ( ord_less_eq @ A @ M @ U )
           => ( ( sup_sup @ ( set @ A ) @ ( set_or3652927894154168847AtMost @ A @ L @ M ) @ ( set_or3652927894154168847AtMost @ A @ M @ U ) )
              = ( set_or3652927894154168847AtMost @ A @ L @ U ) ) ) ) ) ).

% ivl_disj_un_two(6)
thf(fact_6146_infinite__Ioc,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ~ ( finite_finite @ A @ ( set_or3652927894154168847AtMost @ A @ A2 @ B2 ) ) ) ) ).

% infinite_Ioc
thf(fact_6147_GreatestI__nat,axiom,
    ! [P: nat > $o,K: nat,B2: nat] :
      ( ( P @ K )
     => ( ! [Y5: nat] :
            ( ( P @ Y5 )
           => ( ord_less_eq @ nat @ Y5 @ B2 ) )
       => ( P @ ( order_Greatest @ nat @ P ) ) ) ) ).

% GreatestI_nat
thf(fact_6148_Greatest__le__nat,axiom,
    ! [P: nat > $o,K: nat,B2: nat] :
      ( ( P @ K )
     => ( ! [Y5: nat] :
            ( ( P @ Y5 )
           => ( ord_less_eq @ nat @ Y5 @ B2 ) )
       => ( ord_less_eq @ nat @ K @ ( order_Greatest @ nat @ P ) ) ) ) ).

% Greatest_le_nat
thf(fact_6149_GreatestI__ex__nat,axiom,
    ! [P: nat > $o,B2: nat] :
      ( ? [X_12: nat] : ( P @ X_12 )
     => ( ! [Y5: nat] :
            ( ( P @ Y5 )
           => ( ord_less_eq @ nat @ Y5 @ B2 ) )
       => ( P @ ( order_Greatest @ nat @ P ) ) ) ) ).

% GreatestI_ex_nat
thf(fact_6150_Ioc__disjoint,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ( inf_inf @ ( set @ A ) @ ( set_or3652927894154168847AtMost @ A @ A2 @ B2 ) @ ( set_or3652927894154168847AtMost @ A @ C2 @ D2 ) )
            = ( bot_bot @ ( set @ A ) ) )
          = ( ( ord_less_eq @ A @ B2 @ A2 )
            | ( ord_less_eq @ A @ D2 @ C2 )
            | ( ord_less_eq @ A @ B2 @ C2 )
            | ( ord_less_eq @ A @ D2 @ A2 ) ) ) ) ).

% Ioc_disjoint
thf(fact_6151_ivl__disj__un__two_I8_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L: A,M: A,U: A] :
          ( ( ord_less_eq @ A @ L @ M )
         => ( ( ord_less_eq @ A @ M @ U )
           => ( ( sup_sup @ ( set @ A ) @ ( set_or1337092689740270186AtMost @ A @ L @ M ) @ ( set_or3652927894154168847AtMost @ A @ M @ U ) )
              = ( set_or1337092689740270186AtMost @ A @ L @ U ) ) ) ) ) ).

% ivl_disj_un_two(8)
thf(fact_6152_open__left,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [S: set @ A,X: A,Y: A] :
          ( ( topolo1002775350975398744n_open @ A @ S )
         => ( ( member @ A @ X @ S )
           => ( ( ord_less @ A @ Y @ X )
             => ? [B4: A] :
                  ( ( ord_less @ A @ B4 @ X )
                  & ( ord_less_eq @ ( set @ A ) @ ( set_or3652927894154168847AtMost @ A @ B4 @ X ) @ S ) ) ) ) ) ) ).

% open_left
thf(fact_6153_ivl__disj__un__one_I3_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L: A,U: A] :
          ( ( ord_less_eq @ A @ L @ U )
         => ( ( sup_sup @ ( set @ A ) @ ( set_ord_atMost @ A @ L ) @ ( set_or3652927894154168847AtMost @ A @ L @ U ) )
            = ( set_ord_atMost @ A @ U ) ) ) ) ).

% ivl_disj_un_one(3)
thf(fact_6154_ivl__disj__un__one_I5_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L: A,U: A] :
          ( ( ord_less_eq @ A @ L @ U )
         => ( ( sup_sup @ ( set @ A ) @ ( set_or3652927894154168847AtMost @ A @ L @ U ) @ ( set_ord_greaterThan @ A @ U ) )
            = ( set_ord_greaterThan @ A @ L ) ) ) ) ).

% ivl_disj_un_one(5)
thf(fact_6155_GreatestI2__order,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [P: A > $o,X: A,Q: A > $o] :
          ( ( P @ X )
         => ( ! [Y5: A] :
                ( ( P @ Y5 )
               => ( ord_less_eq @ A @ Y5 @ X ) )
           => ( ! [X3: A] :
                  ( ( P @ X3 )
                 => ( ! [Y6: A] :
                        ( ( P @ Y6 )
                       => ( ord_less_eq @ A @ Y6 @ X3 ) )
                   => ( Q @ X3 ) ) )
             => ( Q @ ( order_Greatest @ A @ P ) ) ) ) ) ) ).

% GreatestI2_order
thf(fact_6156_Greatest__equality,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [P: A > $o,X: A] :
          ( ( P @ X )
         => ( ! [Y5: A] :
                ( ( P @ Y5 )
               => ( ord_less_eq @ A @ Y5 @ X ) )
           => ( ( order_Greatest @ A @ P )
              = X ) ) ) ) ).

% Greatest_equality
thf(fact_6157_sum_Ohead,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ! [M: nat,N: nat,G: nat > A] :
          ( ( ord_less_eq @ nat @ M @ N )
         => ( ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) )
            = ( plus_plus @ A @ ( G @ M ) @ ( groups7311177749621191930dd_sum @ nat @ A @ G @ ( set_or3652927894154168847AtMost @ nat @ M @ N ) ) ) ) ) ) ).

% sum.head
thf(fact_6158_prod_Ohead,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ! [M: nat,N: nat,G: nat > A] :
          ( ( ord_less_eq @ nat @ M @ N )
         => ( ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or1337092689740270186AtMost @ nat @ M @ N ) )
            = ( times_times @ A @ ( G @ M ) @ ( groups7121269368397514597t_prod @ nat @ A @ G @ ( set_or3652927894154168847AtMost @ nat @ M @ N ) ) ) ) ) ) ).

% prod.head
thf(fact_6159_greaterThanAtMost__subseteq__atLeastAtMost__iff,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ord_less_eq @ ( set @ A ) @ ( set_or3652927894154168847AtMost @ A @ A2 @ B2 ) @ ( set_or1337092689740270186AtMost @ A @ C2 @ D2 ) )
          = ( ( ord_less @ A @ A2 @ B2 )
           => ( ( ord_less_eq @ A @ C2 @ A2 )
              & ( ord_less_eq @ A @ B2 @ D2 ) ) ) ) ) ).

% greaterThanAtMost_subseteq_atLeastAtMost_iff
thf(fact_6160_greaterThanAtMost__subseteq__atLeastLessThan__iff,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ord_less_eq @ ( set @ A ) @ ( set_or3652927894154168847AtMost @ A @ A2 @ B2 ) @ ( set_or7035219750837199246ssThan @ A @ C2 @ D2 ) )
          = ( ( ord_less @ A @ A2 @ B2 )
           => ( ( ord_less_eq @ A @ C2 @ A2 )
              & ( ord_less @ A @ B2 @ D2 ) ) ) ) ) ).

% greaterThanAtMost_subseteq_atLeastLessThan_iff
thf(fact_6161_ivl__disj__un__two__touch_I3_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L: A,M: A,U: A] :
          ( ( ord_less @ A @ L @ M )
         => ( ( ord_less_eq @ A @ M @ U )
           => ( ( sup_sup @ ( set @ A ) @ ( set_or3652927894154168847AtMost @ A @ L @ M ) @ ( set_or1337092689740270186AtMost @ A @ M @ U ) )
              = ( set_or3652927894154168847AtMost @ A @ L @ U ) ) ) ) ) ).

% ivl_disj_un_two_touch(3)
thf(fact_6162_greaterThanLessThan__subseteq__greaterThanAtMost__iff,axiom,
    ! [A: $tType] :
      ( ( dense_linorder @ A )
     => ! [A2: A,B2: A,C2: A,D2: A] :
          ( ( ord_less_eq @ ( set @ A ) @ ( set_or5935395276787703475ssThan @ A @ A2 @ B2 ) @ ( set_or3652927894154168847AtMost @ A @ C2 @ D2 ) )
          = ( ( ord_less @ A @ A2 @ B2 )
           => ( ( ord_less_eq @ A @ C2 @ A2 )
              & ( ord_less_eq @ A @ B2 @ D2 ) ) ) ) ) ).

% greaterThanLessThan_subseteq_greaterThanAtMost_iff
thf(fact_6163_ivl__disj__un__two_I2_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L: A,M: A,U: A] :
          ( ( ord_less_eq @ A @ L @ M )
         => ( ( ord_less @ A @ M @ U )
           => ( ( sup_sup @ ( set @ A ) @ ( set_or3652927894154168847AtMost @ A @ L @ M ) @ ( set_or5935395276787703475ssThan @ A @ M @ U ) )
              = ( set_or5935395276787703475ssThan @ A @ L @ U ) ) ) ) ) ).

% ivl_disj_un_two(2)
thf(fact_6164_ivl__disj__un__two__touch_I1_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L: A,M: A,U: A] :
          ( ( ord_less @ A @ L @ M )
         => ( ( ord_less @ A @ M @ U )
           => ( ( sup_sup @ ( set @ A ) @ ( set_or3652927894154168847AtMost @ A @ L @ M ) @ ( set_or7035219750837199246ssThan @ A @ M @ U ) )
              = ( set_or5935395276787703475ssThan @ A @ L @ U ) ) ) ) ) ).

% ivl_disj_un_two_touch(1)
thf(fact_6165_ivl__disj__un__singleton_I5_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L: A,U: A] :
          ( ( ord_less_eq @ A @ L @ U )
         => ( ( sup_sup @ ( set @ A ) @ ( insert @ A @ L @ ( bot_bot @ ( set @ A ) ) ) @ ( set_or3652927894154168847AtMost @ A @ L @ U ) )
            = ( set_or1337092689740270186AtMost @ A @ L @ U ) ) ) ) ).

% ivl_disj_un_singleton(5)
thf(fact_6166_ivl__disj__un__two_I5_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L: A,M: A,U: A] :
          ( ( ord_less @ A @ L @ M )
         => ( ( ord_less_eq @ A @ M @ U )
           => ( ( sup_sup @ ( set @ A ) @ ( set_or5935395276787703475ssThan @ A @ L @ M ) @ ( set_or1337092689740270186AtMost @ A @ M @ U ) )
              = ( set_or3652927894154168847AtMost @ A @ L @ U ) ) ) ) ) ).

% ivl_disj_un_two(5)
thf(fact_6167_ivl__disj__un__singleton_I4_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L: A,U: A] :
          ( ( ord_less @ A @ L @ U )
         => ( ( sup_sup @ ( set @ A ) @ ( set_or5935395276787703475ssThan @ A @ L @ U ) @ ( insert @ A @ U @ ( bot_bot @ ( set @ A ) ) ) )
            = ( set_or3652927894154168847AtMost @ A @ L @ U ) ) ) ) ).

% ivl_disj_un_singleton(4)
thf(fact_6168_interval__cases,axiom,
    ! [A: $tType] :
      ( ( condit6923001295902523014norder @ A )
     => ! [S: set @ A] :
          ( ! [A5: A,B4: A,X3: A] :
              ( ( member @ A @ A5 @ S )
             => ( ( member @ A @ B4 @ S )
               => ( ( ord_less_eq @ A @ A5 @ X3 )
                 => ( ( ord_less_eq @ A @ X3 @ B4 )
                   => ( member @ A @ X3 @ S ) ) ) ) )
         => ? [A5: A,B4: A] :
              ( ( S
                = ( bot_bot @ ( set @ A ) ) )
              | ( S
                = ( top_top @ ( set @ A ) ) )
              | ( S
                = ( set_ord_lessThan @ A @ B4 ) )
              | ( S
                = ( set_ord_atMost @ A @ B4 ) )
              | ( S
                = ( set_ord_greaterThan @ A @ A5 ) )
              | ( S
                = ( set_ord_atLeast @ A @ A5 ) )
              | ( S
                = ( set_or5935395276787703475ssThan @ A @ A5 @ B4 ) )
              | ( S
                = ( set_or3652927894154168847AtMost @ A @ A5 @ B4 ) )
              | ( S
                = ( set_or7035219750837199246ssThan @ A @ A5 @ B4 ) )
              | ( S
                = ( set_or1337092689740270186AtMost @ A @ A5 @ B4 ) ) ) ) ) ).

% interval_cases
thf(fact_6169_sequentially__imp__eventually__at__right,axiom,
    ! [A: $tType] :
      ( ( ( topolo3112930676232923870pology @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [A2: A,B2: A,P: A > $o] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ! [F6: nat > A] :
                ( ! [N7: nat] : ( ord_less @ A @ A2 @ ( F6 @ N7 ) )
               => ( ! [N7: nat] : ( ord_less @ A @ ( F6 @ N7 ) @ B2 )
                 => ( ( order_antimono @ nat @ A @ F6 )
                   => ( ( filterlim @ nat @ A @ F6 @ ( topolo7230453075368039082e_nhds @ A @ A2 ) @ ( at_top @ nat ) )
                     => ( eventually @ nat
                        @ ^ [N3: nat] : ( P @ ( F6 @ N3 ) )
                        @ ( at_top @ nat ) ) ) ) ) )
           => ( eventually @ A @ P @ ( topolo174197925503356063within @ A @ A2 @ ( set_ord_greaterThan @ A @ A2 ) ) ) ) ) ) ).

% sequentially_imp_eventually_at_right
thf(fact_6170_atLeast__0,axiom,
    ( ( set_ord_atLeast @ nat @ ( zero_zero @ nat ) )
    = ( top_top @ ( set @ nat ) ) ) ).

% atLeast_0
thf(fact_6171_atLeast__iff,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [I: A,K: A] :
          ( ( member @ A @ I @ ( set_ord_atLeast @ A @ K ) )
          = ( ord_less_eq @ A @ K @ I ) ) ) ).

% atLeast_iff
thf(fact_6172_cInf__atLeast,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [X: A] :
          ( ( complete_Inf_Inf @ A @ ( set_ord_atLeast @ A @ X ) )
          = X ) ) ).

% cInf_atLeast
thf(fact_6173_atLeast__subset__iff,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less_eq @ ( set @ A ) @ ( set_ord_atLeast @ A @ X ) @ ( set_ord_atLeast @ A @ Y ) )
          = ( ord_less_eq @ A @ Y @ X ) ) ) ).

% atLeast_subset_iff
thf(fact_6174_Icc__subset__Ici__iff,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [L: A,H2: A,L4: A] :
          ( ( ord_less_eq @ ( set @ A ) @ ( set_or1337092689740270186AtMost @ A @ L @ H2 ) @ ( set_ord_atLeast @ A @ L4 ) )
          = ( ~ ( ord_less_eq @ A @ L @ H2 )
            | ( ord_less_eq @ A @ L4 @ L ) ) ) ) ).

% Icc_subset_Ici_iff
thf(fact_6175_Int__atLeastAtMostL2,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A,C2: A] :
          ( ( inf_inf @ ( set @ A ) @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) @ ( set_ord_atLeast @ A @ C2 ) )
          = ( set_or1337092689740270186AtMost @ A @ ( ord_max @ A @ A2 @ C2 ) @ B2 ) ) ) ).

% Int_atLeastAtMostL2
thf(fact_6176_Int__atLeastAtMostR2,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,C2: A,D2: A] :
          ( ( inf_inf @ ( set @ A ) @ ( set_ord_atLeast @ A @ A2 ) @ ( set_or1337092689740270186AtMost @ A @ C2 @ D2 ) )
          = ( set_or1337092689740270186AtMost @ A @ ( ord_max @ A @ A2 @ C2 ) @ D2 ) ) ) ).

% Int_atLeastAtMostR2
thf(fact_6177_antimono__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( order @ A )
        & ( order @ B ) )
     => ( ( order_antimono @ A @ B )
        = ( ^ [F3: A > B] :
            ! [X2: A,Y4: A] :
              ( ( ord_less_eq @ A @ X2 @ Y4 )
             => ( ord_less_eq @ B @ ( F3 @ Y4 ) @ ( F3 @ X2 ) ) ) ) ) ) ).

% antimono_def
thf(fact_6178_antimonoI,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( order @ A )
        & ( order @ B ) )
     => ! [F2: A > B] :
          ( ! [X3: A,Y5: A] :
              ( ( ord_less_eq @ A @ X3 @ Y5 )
             => ( ord_less_eq @ B @ ( F2 @ Y5 ) @ ( F2 @ X3 ) ) )
         => ( order_antimono @ A @ B @ F2 ) ) ) ).

% antimonoI
thf(fact_6179_antimonoE,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( order @ A )
        & ( order @ B ) )
     => ! [F2: A > B,X: A,Y: A] :
          ( ( order_antimono @ A @ B @ F2 )
         => ( ( ord_less_eq @ A @ X @ Y )
           => ( ord_less_eq @ B @ ( F2 @ Y ) @ ( F2 @ X ) ) ) ) ) ).

% antimonoE
thf(fact_6180_antimonoD,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( order @ A )
        & ( order @ B ) )
     => ! [F2: A > B,X: A,Y: A] :
          ( ( order_antimono @ A @ B @ F2 )
         => ( ( ord_less_eq @ A @ X @ Y )
           => ( ord_less_eq @ B @ ( F2 @ Y ) @ ( F2 @ X ) ) ) ) ) ).

% antimonoD
thf(fact_6181_atLeast__def,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ( ( set_ord_atLeast @ A )
        = ( ^ [L2: A] : ( collect @ A @ ( ord_less_eq @ A @ L2 ) ) ) ) ) ).

% atLeast_def
thf(fact_6182_decseq__Suc__iff,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( order_antimono @ nat @ A )
        = ( ^ [F3: nat > A] :
            ! [N3: nat] : ( ord_less_eq @ A @ ( F3 @ ( suc @ N3 ) ) @ ( F3 @ N3 ) ) ) ) ) ).

% decseq_Suc_iff
thf(fact_6183_decseq__SucI,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [X7: nat > A] :
          ( ! [N2: nat] : ( ord_less_eq @ A @ ( X7 @ ( suc @ N2 ) ) @ ( X7 @ N2 ) )
         => ( order_antimono @ nat @ A @ X7 ) ) ) ).

% decseq_SucI
thf(fact_6184_decseq__SucD,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [A4: nat > A,I: nat] :
          ( ( order_antimono @ nat @ A @ A4 )
         => ( ord_less_eq @ A @ ( A4 @ ( suc @ I ) ) @ ( A4 @ I ) ) ) ) ).

% decseq_SucD
thf(fact_6185_decseqD,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [F2: nat > A,I: nat,J: nat] :
          ( ( order_antimono @ nat @ A @ F2 )
         => ( ( ord_less_eq @ nat @ I @ J )
           => ( ord_less_eq @ A @ ( F2 @ J ) @ ( F2 @ I ) ) ) ) ) ).

% decseqD
thf(fact_6186_decseq__def,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( order_antimono @ nat @ A )
        = ( ^ [X8: nat > A] :
            ! [M3: nat,N3: nat] :
              ( ( ord_less_eq @ nat @ M3 @ N3 )
             => ( ord_less_eq @ A @ ( X8 @ N3 ) @ ( X8 @ M3 ) ) ) ) ) ) ).

% decseq_def
thf(fact_6187_ivl__disj__un__one_I8_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L: A,U: A] :
          ( ( ord_less_eq @ A @ L @ U )
         => ( ( sup_sup @ ( set @ A ) @ ( set_or7035219750837199246ssThan @ A @ L @ U ) @ ( set_ord_atLeast @ A @ U ) )
            = ( set_ord_atLeast @ A @ L ) ) ) ) ).

% ivl_disj_un_one(8)
thf(fact_6188_Ici__subset__Ioi__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,B2: A] :
          ( ( ord_less_eq @ ( set @ A ) @ ( set_ord_atLeast @ A @ A2 ) @ ( set_ord_greaterThan @ A @ B2 ) )
          = ( ord_less @ A @ B2 @ A2 ) ) ) ).

% Ici_subset_Ioi_iff
thf(fact_6189_max__of__antimono,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( linorder @ A )
        & ( linorder @ B ) )
     => ! [F2: A > B,X: A,Y: A] :
          ( ( order_antimono @ A @ B @ F2 )
         => ( ( ord_max @ B @ ( F2 @ X ) @ ( F2 @ Y ) )
            = ( F2 @ ( ord_min @ A @ X @ Y ) ) ) ) ) ).

% max_of_antimono
thf(fact_6190_min__of__antimono,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( linorder @ A )
        & ( linorder @ B ) )
     => ! [F2: A > B,X: A,Y: A] :
          ( ( order_antimono @ A @ B @ F2 )
         => ( ( ord_min @ B @ ( F2 @ X ) @ ( F2 @ Y ) )
            = ( F2 @ ( ord_max @ A @ X @ Y ) ) ) ) ) ).

% min_of_antimono
thf(fact_6191_decseq__bounded,axiom,
    ! [X7: nat > real,B7: real] :
      ( ( order_antimono @ nat @ real @ X7 )
     => ( ! [I2: nat] : ( ord_less_eq @ real @ B7 @ ( X7 @ I2 ) )
       => ( bfun @ nat @ real @ X7 @ ( at_top @ nat ) ) ) ) ).

% decseq_bounded
thf(fact_6192_ivl__disj__un__one_I7_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L: A,U: A] :
          ( ( ord_less_eq @ A @ L @ U )
         => ( ( sup_sup @ ( set @ A ) @ ( set_or1337092689740270186AtMost @ A @ L @ U ) @ ( set_ord_greaterThan @ A @ U ) )
            = ( set_ord_atLeast @ A @ L ) ) ) ) ).

% ivl_disj_un_one(7)
thf(fact_6193_ivl__disj__un__one_I6_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L: A,U: A] :
          ( ( ord_less @ A @ L @ U )
         => ( ( sup_sup @ ( set @ A ) @ ( set_or5935395276787703475ssThan @ A @ L @ U ) @ ( set_ord_atLeast @ A @ U ) )
            = ( set_ord_greaterThan @ A @ L ) ) ) ) ).

% ivl_disj_un_one(6)
thf(fact_6194_decseq__ge,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [X7: nat > A,L5: A,N: nat] :
          ( ( order_antimono @ nat @ A @ X7 )
         => ( ( filterlim @ nat @ A @ X7 @ ( topolo7230453075368039082e_nhds @ A @ L5 ) @ ( at_top @ nat ) )
           => ( ord_less_eq @ A @ L5 @ ( X7 @ N ) ) ) ) ) ).

% decseq_ge
thf(fact_6195_decseq__convergent,axiom,
    ! [X7: nat > real,B7: real] :
      ( ( order_antimono @ nat @ real @ X7 )
     => ( ! [I2: nat] : ( ord_less_eq @ real @ B7 @ ( X7 @ I2 ) )
       => ~ ! [L6: real] :
              ( ( filterlim @ nat @ real @ X7 @ ( topolo7230453075368039082e_nhds @ real @ L6 ) @ ( at_top @ nat ) )
             => ~ ! [I3: nat] : ( ord_less_eq @ real @ L6 @ ( X7 @ I3 ) ) ) ) ) ).

% decseq_convergent
thf(fact_6196_tendsto__at__right__sequentially,axiom,
    ! [C: $tType,B: $tType] :
      ( ( ( topolo3112930676232923870pology @ B )
        & ( topolo1944317154257567458pology @ B )
        & ( topolo4958980785337419405_space @ C ) )
     => ! [A2: B,B2: B,X7: B > C,L5: C] :
          ( ( ord_less @ B @ A2 @ B2 )
         => ( ! [S4: nat > B] :
                ( ! [N7: nat] : ( ord_less @ B @ A2 @ ( S4 @ N7 ) )
               => ( ! [N7: nat] : ( ord_less @ B @ ( S4 @ N7 ) @ B2 )
                 => ( ( order_antimono @ nat @ B @ S4 )
                   => ( ( filterlim @ nat @ B @ S4 @ ( topolo7230453075368039082e_nhds @ B @ A2 ) @ ( at_top @ nat ) )
                     => ( filterlim @ nat @ C
                        @ ^ [N3: nat] : ( X7 @ ( S4 @ N3 ) )
                        @ ( topolo7230453075368039082e_nhds @ C @ L5 )
                        @ ( at_top @ nat ) ) ) ) ) )
           => ( filterlim @ B @ C @ X7 @ ( topolo7230453075368039082e_nhds @ C @ L5 ) @ ( topolo174197925503356063within @ B @ A2 @ ( set_ord_greaterThan @ B @ A2 ) ) ) ) ) ) ).

% tendsto_at_right_sequentially
thf(fact_6197_cauchy__filter__metric,axiom,
    ! [A: $tType] :
      ( ( ( real_V768167426530841204y_dist @ A )
        & ( topolo7287701948861334536_space @ A ) )
     => ( ( topolo6773858410816713723filter @ A )
        = ( ^ [F8: filter @ A] :
            ! [E3: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ E3 )
             => ? [P3: A > $o] :
                  ( ( eventually @ A @ P3 @ F8 )
                  & ! [X2: A,Y4: A] :
                      ( ( ( P3 @ X2 )
                        & ( P3 @ Y4 ) )
                     => ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X2 @ Y4 ) @ E3 ) ) ) ) ) ) ) ).

% cauchy_filter_metric
thf(fact_6198_GMVT,axiom,
    ! [A2: real,B2: real,F2: real > real,G: real > real] :
      ( ( ord_less @ real @ A2 @ B2 )
     => ( ! [X3: real] :
            ( ( ( ord_less_eq @ real @ A2 @ X3 )
              & ( ord_less_eq @ real @ X3 @ B2 ) )
           => ( topolo3448309680560233919inuous @ real @ real @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) @ F2 ) )
       => ( ! [X3: real] :
              ( ( ( ord_less @ real @ A2 @ X3 )
                & ( ord_less @ real @ X3 @ B2 ) )
             => ( differentiable @ real @ real @ F2 @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) ) )
         => ( ! [X3: real] :
                ( ( ( ord_less_eq @ real @ A2 @ X3 )
                  & ( ord_less_eq @ real @ X3 @ B2 ) )
               => ( topolo3448309680560233919inuous @ real @ real @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) @ G ) )
           => ( ! [X3: real] :
                  ( ( ( ord_less @ real @ A2 @ X3 )
                    & ( ord_less @ real @ X3 @ B2 ) )
                 => ( differentiable @ real @ real @ G @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) ) )
             => ? [G_c: real,F_c: real,C3: real] :
                  ( ( has_field_derivative @ real @ G @ G_c @ ( topolo174197925503356063within @ real @ C3 @ ( top_top @ ( set @ real ) ) ) )
                  & ( has_field_derivative @ real @ F2 @ F_c @ ( topolo174197925503356063within @ real @ C3 @ ( top_top @ ( set @ real ) ) ) )
                  & ( ord_less @ real @ A2 @ C3 )
                  & ( ord_less @ real @ C3 @ B2 )
                  & ( ( times_times @ real @ ( minus_minus @ real @ ( F2 @ B2 ) @ ( F2 @ A2 ) ) @ G_c )
                    = ( times_times @ real @ ( minus_minus @ real @ ( G @ B2 ) @ ( G @ A2 ) ) @ F_c ) ) ) ) ) ) ) ) ).

% GMVT
thf(fact_6199_differentiable__cmult__right__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( real_V822414075346904944vector @ B )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [Q3: B > A,C2: A,T2: B] :
          ( ( differentiable @ B @ A
            @ ^ [T3: B] : ( times_times @ A @ ( Q3 @ T3 ) @ C2 )
            @ ( topolo174197925503356063within @ B @ T2 @ ( top_top @ ( set @ B ) ) ) )
          = ( ( C2
              = ( zero_zero @ A ) )
            | ( differentiable @ B @ A @ Q3 @ ( topolo174197925503356063within @ B @ T2 @ ( top_top @ ( set @ B ) ) ) ) ) ) ) ).

% differentiable_cmult_right_iff
thf(fact_6200_differentiable__cmult__left__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( real_V822414075346904944vector @ B )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [C2: A,Q3: B > A,T2: B] :
          ( ( differentiable @ B @ A
            @ ^ [T3: B] : ( times_times @ A @ C2 @ ( Q3 @ T3 ) )
            @ ( topolo174197925503356063within @ B @ T2 @ ( top_top @ ( set @ B ) ) ) )
          = ( ( C2
              = ( zero_zero @ A ) )
            | ( differentiable @ B @ A @ Q3 @ ( topolo174197925503356063within @ B @ T2 @ ( top_top @ ( set @ B ) ) ) ) ) ) ) ).

% differentiable_cmult_left_iff
thf(fact_6201_differentiable__power,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V3459762299906320749_field @ B ) )
     => ! [F2: A > B,X: A,S2: set @ A,N: nat] :
          ( ( differentiable @ A @ B @ F2 @ ( topolo174197925503356063within @ A @ X @ S2 ) )
         => ( differentiable @ A @ B
            @ ^ [X2: A] : ( power_power @ B @ ( F2 @ X2 ) @ N )
            @ ( topolo174197925503356063within @ A @ X @ S2 ) ) ) ) ).

% differentiable_power
thf(fact_6202_differentiable__divide,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V3459762299906320749_field @ B ) )
     => ! [F2: A > B,X: A,S2: set @ A,G: A > B] :
          ( ( differentiable @ A @ B @ F2 @ ( topolo174197925503356063within @ A @ X @ S2 ) )
         => ( ( differentiable @ A @ B @ G @ ( topolo174197925503356063within @ A @ X @ S2 ) )
           => ( ( ( G @ X )
               != ( zero_zero @ B ) )
             => ( differentiable @ A @ B
                @ ^ [X2: A] : ( divide_divide @ B @ ( F2 @ X2 ) @ ( G @ X2 ) )
                @ ( topolo174197925503356063within @ A @ X @ S2 ) ) ) ) ) ) ).

% differentiable_divide
thf(fact_6203_differentiable__inverse,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V3459762299906320749_field @ B ) )
     => ! [F2: A > B,X: A,S2: set @ A] :
          ( ( differentiable @ A @ B @ F2 @ ( topolo174197925503356063within @ A @ X @ S2 ) )
         => ( ( ( F2 @ X )
             != ( zero_zero @ B ) )
           => ( differentiable @ A @ B
              @ ^ [X2: A] : ( inverse_inverse @ B @ ( F2 @ X2 ) )
              @ ( topolo174197925503356063within @ A @ X @ S2 ) ) ) ) ) ).

% differentiable_inverse
thf(fact_6204_MVT,axiom,
    ! [A2: real,B2: real,F2: real > real] :
      ( ( ord_less @ real @ A2 @ B2 )
     => ( ( topolo81223032696312382ous_on @ real @ real @ ( set_or1337092689740270186AtMost @ real @ A2 @ B2 ) @ F2 )
       => ( ! [X3: real] :
              ( ( ord_less @ real @ A2 @ X3 )
             => ( ( ord_less @ real @ X3 @ B2 )
               => ( differentiable @ real @ real @ F2 @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) ) ) )
         => ? [L3: real,Z3: real] :
              ( ( ord_less @ real @ A2 @ Z3 )
              & ( ord_less @ real @ Z3 @ B2 )
              & ( has_field_derivative @ real @ F2 @ L3 @ ( topolo174197925503356063within @ real @ Z3 @ ( top_top @ ( set @ real ) ) ) )
              & ( ( minus_minus @ real @ ( F2 @ B2 ) @ ( F2 @ A2 ) )
                = ( times_times @ real @ ( minus_minus @ real @ B2 @ A2 ) @ L3 ) ) ) ) ) ) ).

% MVT
thf(fact_6205_ord_OLeast__def,axiom,
    ! [A: $tType] :
      ( ( least @ A )
      = ( ^ [Less_eq2: A > A > $o,P3: A > $o] :
            ( the @ A
            @ ^ [X2: A] :
                ( ( P3 @ X2 )
                & ! [Y4: A] :
                    ( ( P3 @ Y4 )
                   => ( Less_eq2 @ X2 @ Y4 ) ) ) ) ) ) ).

% ord.Least_def
thf(fact_6206_continuous__on__powr,axiom,
    ! [C: $tType] :
      ( ( topolo4958980785337419405_space @ C )
     => ! [S2: set @ C,F2: C > real,G: C > real] :
          ( ( topolo81223032696312382ous_on @ C @ real @ S2 @ F2 )
         => ( ( topolo81223032696312382ous_on @ C @ real @ S2 @ G )
           => ( ! [X3: C] :
                  ( ( member @ C @ X3 @ S2 )
                 => ( ( F2 @ X3 )
                   != ( zero_zero @ real ) ) )
             => ( topolo81223032696312382ous_on @ C @ real @ S2
                @ ^ [X2: C] : ( powr @ real @ ( F2 @ X2 ) @ ( G @ X2 ) ) ) ) ) ) ) ).

% continuous_on_powr
thf(fact_6207_continuous__on__ln,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [S2: set @ A,F2: A > real] :
          ( ( topolo81223032696312382ous_on @ A @ real @ S2 @ F2 )
         => ( ! [X3: A] :
                ( ( member @ A @ X3 @ S2 )
               => ( ( F2 @ X3 )
                 != ( zero_zero @ real ) ) )
           => ( topolo81223032696312382ous_on @ A @ real @ S2
              @ ^ [X2: A] : ( ln_ln @ real @ ( F2 @ X2 ) ) ) ) ) ) ).

% continuous_on_ln
thf(fact_6208_continuous__on__inverse,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topolo4958980785337419405_space @ A )
        & ( real_V8999393235501362500lgebra @ B ) )
     => ! [S2: set @ A,F2: A > B] :
          ( ( topolo81223032696312382ous_on @ A @ B @ S2 @ F2 )
         => ( ! [X3: A] :
                ( ( member @ A @ X3 @ S2 )
               => ( ( F2 @ X3 )
                 != ( zero_zero @ B ) ) )
           => ( topolo81223032696312382ous_on @ A @ B @ S2
              @ ^ [X2: A] : ( inverse_inverse @ B @ ( F2 @ X2 ) ) ) ) ) ) ).

% continuous_on_inverse
thf(fact_6209_continuous__on__divide,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topolo4958980785337419405_space @ A )
        & ( real_V3459762299906320749_field @ B ) )
     => ! [S2: set @ A,F2: A > B,G: A > B] :
          ( ( topolo81223032696312382ous_on @ A @ B @ S2 @ F2 )
         => ( ( topolo81223032696312382ous_on @ A @ B @ S2 @ G )
           => ( ! [X3: A] :
                  ( ( member @ A @ X3 @ S2 )
                 => ( ( G @ X3 )
                   != ( zero_zero @ B ) ) )
             => ( topolo81223032696312382ous_on @ A @ B @ S2
                @ ^ [X2: A] : ( divide_divide @ B @ ( F2 @ X2 ) @ ( G @ X2 ) ) ) ) ) ) ) ).

% continuous_on_divide
thf(fact_6210_ord_OLeast_Ocong,axiom,
    ! [A: $tType] :
      ( ( least @ A )
      = ( least @ A ) ) ).

% ord.Least.cong
thf(fact_6211_continuous__on__real__root,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [S2: set @ A,F2: A > real,N: nat] :
          ( ( topolo81223032696312382ous_on @ A @ real @ S2 @ F2 )
         => ( topolo81223032696312382ous_on @ A @ real @ S2
            @ ^ [X2: A] : ( root @ N @ ( F2 @ X2 ) ) ) ) ) ).

% continuous_on_real_root
thf(fact_6212_continuous__on__power,axiom,
    ! [B: $tType,C: $tType] :
      ( ( ( topolo4958980785337419405_space @ C )
        & ( power @ B )
        & ( real_V4412858255891104859lgebra @ B ) )
     => ! [S2: set @ C,F2: C > B,N: nat] :
          ( ( topolo81223032696312382ous_on @ C @ B @ S2 @ F2 )
         => ( topolo81223032696312382ous_on @ C @ B @ S2
            @ ^ [X2: C] : ( power_power @ B @ ( F2 @ X2 ) @ N ) ) ) ) ).

% continuous_on_power
thf(fact_6213_continuous__on__power_H,axiom,
    ! [B: $tType,C: $tType] :
      ( ( ( topolo4958980785337419405_space @ C )
        & ( topolo1898628316856586783d_mult @ B ) )
     => ! [A4: set @ C,F2: C > B,G: C > nat] :
          ( ( topolo81223032696312382ous_on @ C @ B @ A4 @ F2 )
         => ( ( topolo81223032696312382ous_on @ C @ nat @ A4 @ G )
           => ( topolo81223032696312382ous_on @ C @ B @ A4
              @ ^ [X2: C] : ( power_power @ B @ ( F2 @ X2 ) @ ( G @ X2 ) ) ) ) ) ) ).

% continuous_on_power'
thf(fact_6214_continuous__on__real__sqrt,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [S2: set @ A,F2: A > real] :
          ( ( topolo81223032696312382ous_on @ A @ real @ S2 @ F2 )
         => ( topolo81223032696312382ous_on @ A @ real @ S2
            @ ^ [X2: A] : ( sqrt @ ( F2 @ X2 ) ) ) ) ) ).

% continuous_on_real_sqrt
thf(fact_6215_continuous__on__max,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topolo4958980785337419405_space @ A )
        & ( topolo1944317154257567458pology @ B ) )
     => ! [A4: set @ A,F2: A > B,G: A > B] :
          ( ( topolo81223032696312382ous_on @ A @ B @ A4 @ F2 )
         => ( ( topolo81223032696312382ous_on @ A @ B @ A4 @ G )
           => ( topolo81223032696312382ous_on @ A @ B @ A4
              @ ^ [X2: A] : ( ord_max @ B @ ( F2 @ X2 ) @ ( G @ X2 ) ) ) ) ) ) ).

% continuous_on_max
thf(fact_6216_continuous__on__sgn,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topolo4958980785337419405_space @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [S2: set @ A,F2: A > B] :
          ( ( topolo81223032696312382ous_on @ A @ B @ S2 @ F2 )
         => ( ! [X3: A] :
                ( ( member @ A @ X3 @ S2 )
               => ( ( F2 @ X3 )
                 != ( zero_zero @ B ) ) )
           => ( topolo81223032696312382ous_on @ A @ B @ S2
              @ ^ [X2: A] : ( sgn_sgn @ B @ ( F2 @ X2 ) ) ) ) ) ) ).

% continuous_on_sgn
thf(fact_6217_IVT_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( topolo1944317154257567458pology @ B )
        & ( topolo8458572112393995274pology @ A ) )
     => ! [F2: A > B,A2: A,Y: B,B2: A] :
          ( ( ord_less_eq @ B @ ( F2 @ A2 ) @ Y )
         => ( ( ord_less_eq @ B @ Y @ ( F2 @ B2 ) )
           => ( ( ord_less_eq @ A @ A2 @ B2 )
             => ( ( topolo81223032696312382ous_on @ A @ B @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) @ F2 )
               => ? [X3: A] :
                    ( ( ord_less_eq @ A @ A2 @ X3 )
                    & ( ord_less_eq @ A @ X3 @ B2 )
                    & ( ( F2 @ X3 )
                      = Y ) ) ) ) ) ) ) ).

% IVT'
thf(fact_6218_IVT2_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( topolo1944317154257567458pology @ B )
        & ( topolo8458572112393995274pology @ A ) )
     => ! [F2: A > B,B2: A,Y: B,A2: A] :
          ( ( ord_less_eq @ B @ ( F2 @ B2 ) @ Y )
         => ( ( ord_less_eq @ B @ Y @ ( F2 @ A2 ) )
           => ( ( ord_less_eq @ A @ A2 @ B2 )
             => ( ( topolo81223032696312382ous_on @ A @ B @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) @ F2 )
               => ? [X3: A] :
                    ( ( ord_less_eq @ A @ A2 @ X3 )
                    & ( ord_less_eq @ A @ X3 @ B2 )
                    & ( ( F2 @ X3 )
                      = Y ) ) ) ) ) ) ) ).

% IVT2'
thf(fact_6219_continuous__onI__mono,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topolo1944317154257567458pology @ A )
        & ( dense_order @ B )
        & ( topolo1944317154257567458pology @ B ) )
     => ! [F2: A > B,A4: set @ A] :
          ( ( topolo1002775350975398744n_open @ B @ ( image @ A @ B @ F2 @ A4 ) )
         => ( ! [X3: A,Y5: A] :
                ( ( member @ A @ X3 @ A4 )
               => ( ( member @ A @ Y5 @ A4 )
                 => ( ( ord_less_eq @ A @ X3 @ Y5 )
                   => ( ord_less_eq @ B @ ( F2 @ X3 ) @ ( F2 @ Y5 ) ) ) ) )
           => ( topolo81223032696312382ous_on @ A @ B @ A4 @ F2 ) ) ) ) ).

% continuous_onI_mono
thf(fact_6220_open__Collect__less,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topolo4958980785337419405_space @ A )
        & ( topolo1944317154257567458pology @ B ) )
     => ! [F2: A > B,G: A > B] :
          ( ( topolo81223032696312382ous_on @ A @ B @ ( top_top @ ( set @ A ) ) @ F2 )
         => ( ( topolo81223032696312382ous_on @ A @ B @ ( top_top @ ( set @ A ) ) @ G )
           => ( topolo1002775350975398744n_open @ A
              @ ( collect @ A
                @ ^ [X2: A] : ( ord_less @ B @ ( F2 @ X2 ) @ ( G @ X2 ) ) ) ) ) ) ) ).

% open_Collect_less
thf(fact_6221_continuous__on__tan,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [S2: set @ A,F2: A > A] :
          ( ( topolo81223032696312382ous_on @ A @ A @ S2 @ F2 )
         => ( ! [X3: A] :
                ( ( member @ A @ X3 @ S2 )
               => ( ( cos @ A @ ( F2 @ X3 ) )
                 != ( zero_zero @ A ) ) )
           => ( topolo81223032696312382ous_on @ A @ A @ S2
              @ ^ [X2: A] : ( tan @ A @ ( F2 @ X2 ) ) ) ) ) ) ).

% continuous_on_tan
thf(fact_6222_open__Collect__less__Int,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [S2: set @ A,F2: A > real,G: A > real] :
          ( ( topolo81223032696312382ous_on @ A @ real @ S2 @ F2 )
         => ( ( topolo81223032696312382ous_on @ A @ real @ S2 @ G )
           => ? [A8: set @ A] :
                ( ( topolo1002775350975398744n_open @ A @ A8 )
                & ( ( inf_inf @ ( set @ A ) @ A8 @ S2 )
                  = ( collect @ A
                    @ ^ [X2: A] :
                        ( ( member @ A @ X2 @ S2 )
                        & ( ord_less @ real @ ( F2 @ X2 ) @ ( G @ X2 ) ) ) ) ) ) ) ) ) ).

% open_Collect_less_Int
thf(fact_6223_continuous__on__cot,axiom,
    ! [A: $tType] :
      ( ( ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [S2: set @ A,F2: A > A] :
          ( ( topolo81223032696312382ous_on @ A @ A @ S2 @ F2 )
         => ( ! [X3: A] :
                ( ( member @ A @ X3 @ S2 )
               => ( ( sin @ A @ ( F2 @ X3 ) )
                 != ( zero_zero @ A ) ) )
           => ( topolo81223032696312382ous_on @ A @ A @ S2
              @ ^ [X2: A] : ( cot @ A @ ( F2 @ X2 ) ) ) ) ) ) ).

% continuous_on_cot
thf(fact_6224_continuous__on__tanh,axiom,
    ! [A: $tType,C: $tType] :
      ( ( ( topolo4958980785337419405_space @ C )
        & ( real_Vector_banach @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [A4: set @ C,F2: C > A] :
          ( ( topolo81223032696312382ous_on @ C @ A @ A4 @ F2 )
         => ( ! [X3: C] :
                ( ( member @ C @ X3 @ A4 )
               => ( ( cosh @ A @ ( F2 @ X3 ) )
                 != ( zero_zero @ A ) ) )
           => ( topolo81223032696312382ous_on @ C @ A @ A4
              @ ^ [X2: C] : ( tanh @ A @ ( F2 @ X2 ) ) ) ) ) ) ).

% continuous_on_tanh
thf(fact_6225_continuous__on__arcosh_H,axiom,
    ! [A4: set @ real,F2: real > real] :
      ( ( topolo81223032696312382ous_on @ real @ real @ A4 @ F2 )
     => ( ! [X3: real] :
            ( ( member @ real @ X3 @ A4 )
           => ( ord_less_eq @ real @ ( one_one @ real ) @ ( F2 @ X3 ) ) )
       => ( topolo81223032696312382ous_on @ real @ real @ A4
          @ ^ [X2: real] : ( arcosh @ real @ ( F2 @ X2 ) ) ) ) ) ).

% continuous_on_arcosh'
thf(fact_6226_continuous__image__closed__interval,axiom,
    ! [A2: real,B2: real,F2: real > real] :
      ( ( ord_less_eq @ real @ A2 @ B2 )
     => ( ( topolo81223032696312382ous_on @ real @ real @ ( set_or1337092689740270186AtMost @ real @ A2 @ B2 ) @ F2 )
       => ? [C3: real,D6: real] :
            ( ( ( image @ real @ real @ F2 @ ( set_or1337092689740270186AtMost @ real @ A2 @ B2 ) )
              = ( set_or1337092689740270186AtMost @ real @ C3 @ D6 ) )
            & ( ord_less_eq @ real @ C3 @ D6 ) ) ) ) ).

% continuous_image_closed_interval
thf(fact_6227_open__Collect__positive,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [S2: set @ A,F2: A > real] :
          ( ( topolo81223032696312382ous_on @ A @ real @ S2 @ F2 )
         => ? [A8: set @ A] :
              ( ( topolo1002775350975398744n_open @ A @ A8 )
              & ( ( inf_inf @ ( set @ A ) @ A8 @ S2 )
                = ( collect @ A
                  @ ^ [X2: A] :
                      ( ( member @ A @ X2 @ S2 )
                      & ( ord_less @ real @ ( zero_zero @ real ) @ ( F2 @ X2 ) ) ) ) ) ) ) ) ).

% open_Collect_positive
thf(fact_6228_continuous__on__powr_H,axiom,
    ! [C: $tType] :
      ( ( topolo4958980785337419405_space @ C )
     => ! [S2: set @ C,F2: C > real,G: C > real] :
          ( ( topolo81223032696312382ous_on @ C @ real @ S2 @ F2 )
         => ( ( topolo81223032696312382ous_on @ C @ real @ S2 @ G )
           => ( ! [X3: C] :
                  ( ( member @ C @ X3 @ S2 )
                 => ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( F2 @ X3 ) )
                    & ( ( ( F2 @ X3 )
                        = ( zero_zero @ real ) )
                     => ( ord_less @ real @ ( zero_zero @ real ) @ ( G @ X3 ) ) ) ) )
             => ( topolo81223032696312382ous_on @ C @ real @ S2
                @ ^ [X2: C] : ( powr @ real @ ( F2 @ X2 ) @ ( G @ X2 ) ) ) ) ) ) ) ).

% continuous_on_powr'
thf(fact_6229_continuous__on__log,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [S2: set @ A,F2: A > real,G: A > real] :
          ( ( topolo81223032696312382ous_on @ A @ real @ S2 @ F2 )
         => ( ( topolo81223032696312382ous_on @ A @ real @ S2 @ G )
           => ( ! [X3: A] :
                  ( ( member @ A @ X3 @ S2 )
                 => ( ord_less @ real @ ( zero_zero @ real ) @ ( F2 @ X3 ) ) )
             => ( ! [X3: A] :
                    ( ( member @ A @ X3 @ S2 )
                   => ( ( F2 @ X3 )
                     != ( one_one @ real ) ) )
               => ( ! [X3: A] :
                      ( ( member @ A @ X3 @ S2 )
                     => ( ord_less @ real @ ( zero_zero @ real ) @ ( G @ X3 ) ) )
                 => ( topolo81223032696312382ous_on @ A @ real @ S2
                    @ ^ [X2: A] : ( log2 @ ( F2 @ X2 ) @ ( G @ X2 ) ) ) ) ) ) ) ) ) ).

% continuous_on_log
thf(fact_6230_continuous__on__arccos,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [S2: set @ A,F2: A > real] :
          ( ( topolo81223032696312382ous_on @ A @ real @ S2 @ F2 )
         => ( ! [X3: A] :
                ( ( member @ A @ X3 @ S2 )
               => ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ ( F2 @ X3 ) )
                  & ( ord_less_eq @ real @ ( F2 @ X3 ) @ ( one_one @ real ) ) ) )
           => ( topolo81223032696312382ous_on @ A @ real @ S2
              @ ^ [X2: A] : ( arccos @ ( F2 @ X2 ) ) ) ) ) ) ).

% continuous_on_arccos
thf(fact_6231_continuous__on__arcsin,axiom,
    ! [A: $tType] :
      ( ( topolo4958980785337419405_space @ A )
     => ! [S2: set @ A,F2: A > real] :
          ( ( topolo81223032696312382ous_on @ A @ real @ S2 @ F2 )
         => ( ! [X3: A] :
                ( ( member @ A @ X3 @ S2 )
               => ( ( ord_less_eq @ real @ ( uminus_uminus @ real @ ( one_one @ real ) ) @ ( F2 @ X3 ) )
                  & ( ord_less_eq @ real @ ( F2 @ X3 ) @ ( one_one @ real ) ) ) )
           => ( topolo81223032696312382ous_on @ A @ real @ S2
              @ ^ [X2: A] : ( arcsin @ ( F2 @ X2 ) ) ) ) ) ) ).

% continuous_on_arcsin
thf(fact_6232_DERIV__atLeastAtMost__imp__continuous__on,axiom,
    ! [A: $tType] :
      ( ( ( ord @ A )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [A2: A,B2: A,F2: A > A] :
          ( ! [X3: A] :
              ( ( ord_less_eq @ A @ A2 @ X3 )
             => ( ( ord_less_eq @ A @ X3 @ B2 )
               => ? [Y6: A] : ( has_field_derivative @ A @ F2 @ Y6 @ ( topolo174197925503356063within @ A @ X3 @ ( top_top @ ( set @ A ) ) ) ) ) )
         => ( topolo81223032696312382ous_on @ A @ A @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) @ F2 ) ) ) ).

% DERIV_atLeastAtMost_imp_continuous_on
thf(fact_6233_Rolle__deriv,axiom,
    ! [A2: real,B2: real,F2: real > real,F5: real > real > real] :
      ( ( ord_less @ real @ A2 @ B2 )
     => ( ( ( F2 @ A2 )
          = ( F2 @ B2 ) )
       => ( ( topolo81223032696312382ous_on @ real @ real @ ( set_or1337092689740270186AtMost @ real @ A2 @ B2 ) @ F2 )
         => ( ! [X3: real] :
                ( ( ord_less @ real @ A2 @ X3 )
               => ( ( ord_less @ real @ X3 @ B2 )
                 => ( has_derivative @ real @ real @ F2 @ ( F5 @ X3 ) @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) ) ) )
           => ? [Z3: real] :
                ( ( ord_less @ real @ A2 @ Z3 )
                & ( ord_less @ real @ Z3 @ B2 )
                & ( ( F5 @ Z3 )
                  = ( ^ [V5: real] : ( zero_zero @ real ) ) ) ) ) ) ) ) ).

% Rolle_deriv
thf(fact_6234_mvt,axiom,
    ! [A2: real,B2: real,F2: real > real,F5: real > real > real] :
      ( ( ord_less @ real @ A2 @ B2 )
     => ( ( topolo81223032696312382ous_on @ real @ real @ ( set_or1337092689740270186AtMost @ real @ A2 @ B2 ) @ F2 )
       => ( ! [X3: real] :
              ( ( ord_less @ real @ A2 @ X3 )
             => ( ( ord_less @ real @ X3 @ B2 )
               => ( has_derivative @ real @ real @ F2 @ ( F5 @ X3 ) @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) ) ) )
         => ~ ! [Xi: real] :
                ( ( ord_less @ real @ A2 @ Xi )
               => ( ( ord_less @ real @ Xi @ B2 )
                 => ( ( minus_minus @ real @ ( F2 @ B2 ) @ ( F2 @ A2 ) )
                   != ( F5 @ Xi @ ( minus_minus @ real @ B2 @ A2 ) ) ) ) ) ) ) ) ).

% mvt
thf(fact_6235_continuous__on__Icc__at__leftD,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topolo1944317154257567458pology @ A )
        & ( topolo4958980785337419405_space @ B ) )
     => ! [A2: A,B2: A,F2: A > B] :
          ( ( topolo81223032696312382ous_on @ A @ B @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) @ F2 )
         => ( ( ord_less @ A @ A2 @ B2 )
           => ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ ( F2 @ B2 ) ) @ ( topolo174197925503356063within @ A @ B2 @ ( set_ord_lessThan @ A @ B2 ) ) ) ) ) ) ).

% continuous_on_Icc_at_leftD
thf(fact_6236_continuous__on__Icc__at__rightD,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topolo1944317154257567458pology @ A )
        & ( topolo4958980785337419405_space @ B ) )
     => ! [A2: A,B2: A,F2: A > B] :
          ( ( topolo81223032696312382ous_on @ A @ B @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) @ F2 )
         => ( ( ord_less @ A @ A2 @ B2 )
           => ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ ( F2 @ A2 ) ) @ ( topolo174197925503356063within @ A @ A2 @ ( set_ord_greaterThan @ A @ A2 ) ) ) ) ) ) ).

% continuous_on_Icc_at_rightD
thf(fact_6237_DERIV__isconst__end,axiom,
    ! [A2: real,B2: real,F2: real > real] :
      ( ( ord_less @ real @ A2 @ B2 )
     => ( ( topolo81223032696312382ous_on @ real @ real @ ( set_or1337092689740270186AtMost @ real @ A2 @ B2 ) @ F2 )
       => ( ! [X3: real] :
              ( ( ord_less @ real @ A2 @ X3 )
             => ( ( ord_less @ real @ X3 @ B2 )
               => ( has_field_derivative @ real @ F2 @ ( zero_zero @ real ) @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) ) ) )
         => ( ( F2 @ B2 )
            = ( F2 @ A2 ) ) ) ) ) ).

% DERIV_isconst_end
thf(fact_6238_DERIV__neg__imp__decreasing__open,axiom,
    ! [A2: real,B2: real,F2: real > real] :
      ( ( ord_less @ real @ A2 @ B2 )
     => ( ! [X3: real] :
            ( ( ord_less @ real @ A2 @ X3 )
           => ( ( ord_less @ real @ X3 @ B2 )
             => ? [Y6: real] :
                  ( ( has_field_derivative @ real @ F2 @ Y6 @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) )
                  & ( ord_less @ real @ Y6 @ ( zero_zero @ real ) ) ) ) )
       => ( ( topolo81223032696312382ous_on @ real @ real @ ( set_or1337092689740270186AtMost @ real @ A2 @ B2 ) @ F2 )
         => ( ord_less @ real @ ( F2 @ B2 ) @ ( F2 @ A2 ) ) ) ) ) ).

% DERIV_neg_imp_decreasing_open
thf(fact_6239_DERIV__pos__imp__increasing__open,axiom,
    ! [A2: real,B2: real,F2: real > real] :
      ( ( ord_less @ real @ A2 @ B2 )
     => ( ! [X3: real] :
            ( ( ord_less @ real @ A2 @ X3 )
           => ( ( ord_less @ real @ X3 @ B2 )
             => ? [Y6: real] :
                  ( ( has_field_derivative @ real @ F2 @ Y6 @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) )
                  & ( ord_less @ real @ ( zero_zero @ real ) @ Y6 ) ) ) )
       => ( ( topolo81223032696312382ous_on @ real @ real @ ( set_or1337092689740270186AtMost @ real @ A2 @ B2 ) @ F2 )
         => ( ord_less @ real @ ( F2 @ A2 ) @ ( F2 @ B2 ) ) ) ) ) ).

% DERIV_pos_imp_increasing_open
thf(fact_6240_DERIV__isconst2,axiom,
    ! [A2: real,B2: real,F2: real > real,X: real] :
      ( ( ord_less @ real @ A2 @ B2 )
     => ( ( topolo81223032696312382ous_on @ real @ real @ ( set_or1337092689740270186AtMost @ real @ A2 @ B2 ) @ F2 )
       => ( ! [X3: real] :
              ( ( ord_less @ real @ A2 @ X3 )
             => ( ( ord_less @ real @ X3 @ B2 )
               => ( has_field_derivative @ real @ F2 @ ( zero_zero @ real ) @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) ) ) )
         => ( ( ord_less_eq @ real @ A2 @ X )
           => ( ( ord_less_eq @ real @ X @ B2 )
             => ( ( F2 @ X )
                = ( F2 @ A2 ) ) ) ) ) ) ) ).

% DERIV_isconst2
thf(fact_6241_continuous__on__IccI,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topolo1944317154257567458pology @ A )
        & ( topolo4958980785337419405_space @ B ) )
     => ! [F2: A > B,A2: A,B2: A] :
          ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ ( F2 @ A2 ) ) @ ( topolo174197925503356063within @ A @ A2 @ ( set_ord_greaterThan @ A @ A2 ) ) )
         => ( ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ ( F2 @ B2 ) ) @ ( topolo174197925503356063within @ A @ B2 @ ( set_ord_lessThan @ A @ B2 ) ) )
           => ( ! [X3: A] :
                  ( ( ord_less @ A @ A2 @ X3 )
                 => ( ( ord_less @ A @ X3 @ B2 )
                   => ( filterlim @ A @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ ( F2 @ X3 ) ) @ ( topolo174197925503356063within @ A @ X3 @ ( top_top @ ( set @ A ) ) ) ) ) )
             => ( ( ord_less @ A @ A2 @ B2 )
               => ( topolo81223032696312382ous_on @ A @ B @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) @ F2 ) ) ) ) ) ) ).

% continuous_on_IccI
thf(fact_6242_Rolle,axiom,
    ! [A2: real,B2: real,F2: real > real] :
      ( ( ord_less @ real @ A2 @ B2 )
     => ( ( ( F2 @ A2 )
          = ( F2 @ B2 ) )
       => ( ( topolo81223032696312382ous_on @ real @ real @ ( set_or1337092689740270186AtMost @ real @ A2 @ B2 ) @ F2 )
         => ( ! [X3: real] :
                ( ( ord_less @ real @ A2 @ X3 )
               => ( ( ord_less @ real @ X3 @ B2 )
                 => ( differentiable @ real @ real @ F2 @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) ) ) )
           => ? [Z3: real] :
                ( ( ord_less @ real @ A2 @ Z3 )
                & ( ord_less @ real @ Z3 @ B2 )
                & ( has_field_derivative @ real @ F2 @ ( zero_zero @ real ) @ ( topolo174197925503356063within @ real @ Z3 @ ( top_top @ ( set @ real ) ) ) ) ) ) ) ) ) ).

% Rolle
thf(fact_6243_sequentially__imp__eventually__at__left,axiom,
    ! [A: $tType] :
      ( ( ( topolo3112930676232923870pology @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [B2: A,A2: A,P: A > $o] :
          ( ( ord_less @ A @ B2 @ A2 )
         => ( ! [F6: nat > A] :
                ( ! [N7: nat] : ( ord_less @ A @ B2 @ ( F6 @ N7 ) )
               => ( ! [N7: nat] : ( ord_less @ A @ ( F6 @ N7 ) @ A2 )
                 => ( ( order_mono @ nat @ A @ F6 )
                   => ( ( filterlim @ nat @ A @ F6 @ ( topolo7230453075368039082e_nhds @ A @ A2 ) @ ( at_top @ nat ) )
                     => ( eventually @ nat
                        @ ^ [N3: nat] : ( P @ ( F6 @ N3 ) )
                        @ ( at_top @ nat ) ) ) ) ) )
           => ( eventually @ A @ P @ ( topolo174197925503356063within @ A @ A2 @ ( set_ord_lessThan @ A @ A2 ) ) ) ) ) ) ).

% sequentially_imp_eventually_at_left
thf(fact_6244_range__abs__Nats,axiom,
    ( ( image @ int @ int @ ( abs_abs @ int ) @ ( top_top @ ( set @ int ) ) )
    = ( semiring_1_Nats @ int ) ) ).

% range_abs_Nats
thf(fact_6245_mono__inf,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( semilattice_inf @ A )
        & ( semilattice_inf @ B ) )
     => ! [F2: A > B,A4: A,B7: A] :
          ( ( order_mono @ A @ B @ F2 )
         => ( ord_less_eq @ B @ ( F2 @ ( inf_inf @ A @ A4 @ B7 ) ) @ ( inf_inf @ B @ ( F2 @ A4 ) @ ( F2 @ B7 ) ) ) ) ) ).

% mono_inf
thf(fact_6246_mono__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( order @ A )
        & ( order @ B ) )
     => ( ( order_mono @ A @ B )
        = ( ^ [F3: A > B] :
            ! [X2: A,Y4: A] :
              ( ( ord_less_eq @ A @ X2 @ Y4 )
             => ( ord_less_eq @ B @ ( F3 @ X2 ) @ ( F3 @ Y4 ) ) ) ) ) ) ).

% mono_def
thf(fact_6247_monoI,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( order @ A )
        & ( order @ B ) )
     => ! [F2: A > B] :
          ( ! [X3: A,Y5: A] :
              ( ( ord_less_eq @ A @ X3 @ Y5 )
             => ( ord_less_eq @ B @ ( F2 @ X3 ) @ ( F2 @ Y5 ) ) )
         => ( order_mono @ A @ B @ F2 ) ) ) ).

% monoI
thf(fact_6248_monoE,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( order @ A )
        & ( order @ B ) )
     => ! [F2: A > B,X: A,Y: A] :
          ( ( order_mono @ A @ B @ F2 )
         => ( ( ord_less_eq @ A @ X @ Y )
           => ( ord_less_eq @ B @ ( F2 @ X ) @ ( F2 @ Y ) ) ) ) ) ).

% monoE
thf(fact_6249_monoD,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( order @ A )
        & ( order @ B ) )
     => ! [F2: A > B,X: A,Y: A] :
          ( ( order_mono @ A @ B @ F2 )
         => ( ( ord_less_eq @ A @ X @ Y )
           => ( ord_less_eq @ B @ ( F2 @ X ) @ ( F2 @ Y ) ) ) ) ) ).

% monoD
thf(fact_6250_incseq__SucD,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [A4: nat > A,I: nat] :
          ( ( order_mono @ nat @ A @ A4 )
         => ( ord_less_eq @ A @ ( A4 @ I ) @ ( A4 @ ( suc @ I ) ) ) ) ) ).

% incseq_SucD
thf(fact_6251_incseq__SucI,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [X7: nat > A] :
          ( ! [N2: nat] : ( ord_less_eq @ A @ ( X7 @ N2 ) @ ( X7 @ ( suc @ N2 ) ) )
         => ( order_mono @ nat @ A @ X7 ) ) ) ).

% incseq_SucI
thf(fact_6252_incseq__Suc__iff,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( order_mono @ nat @ A )
        = ( ^ [F3: nat > A] :
            ! [N3: nat] : ( ord_less_eq @ A @ ( F3 @ N3 ) @ ( F3 @ ( suc @ N3 ) ) ) ) ) ) ).

% incseq_Suc_iff
thf(fact_6253_incseq__def,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( order_mono @ nat @ A )
        = ( ^ [X8: nat > A] :
            ! [M3: nat,N3: nat] :
              ( ( ord_less_eq @ nat @ M3 @ N3 )
             => ( ord_less_eq @ A @ ( X8 @ M3 ) @ ( X8 @ N3 ) ) ) ) ) ) ).

% incseq_def
thf(fact_6254_incseqD,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [F2: nat > A,I: nat,J: nat] :
          ( ( order_mono @ nat @ A @ F2 )
         => ( ( ord_less_eq @ nat @ I @ J )
           => ( ord_less_eq @ A @ ( F2 @ I ) @ ( F2 @ J ) ) ) ) ) ).

% incseqD
thf(fact_6255_mono__invE,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( linorder @ A )
        & ( order @ B ) )
     => ! [F2: A > B,X: A,Y: A] :
          ( ( order_mono @ A @ B @ F2 )
         => ( ( ord_less @ B @ ( F2 @ X ) @ ( F2 @ Y ) )
           => ( ord_less_eq @ A @ X @ Y ) ) ) ) ).

% mono_invE
thf(fact_6256_funpow__mono,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [F2: A > A,A4: A,B7: A,N: nat] :
          ( ( order_mono @ A @ A @ F2 )
         => ( ( ord_less_eq @ A @ A4 @ B7 )
           => ( ord_less_eq @ A @ ( compow @ ( A > A ) @ N @ F2 @ A4 ) @ ( compow @ ( A > A ) @ N @ F2 @ B7 ) ) ) ) ) ).

% funpow_mono
thf(fact_6257_mono__sup,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( semilattice_sup @ A )
        & ( semilattice_sup @ B ) )
     => ! [F2: A > B,A4: A,B7: A] :
          ( ( order_mono @ A @ B @ F2 )
         => ( ord_less_eq @ B @ ( sup_sup @ B @ ( F2 @ A4 ) @ ( F2 @ B7 ) ) @ ( F2 @ ( sup_sup @ A @ A4 @ B7 ) ) ) ) ) ).

% mono_sup
thf(fact_6258_mono__add,axiom,
    ! [A: $tType] :
      ( ( ordere6658533253407199908up_add @ A )
     => ! [A2: A] : ( order_mono @ A @ A @ ( plus_plus @ A @ A2 ) ) ) ).

% mono_add
thf(fact_6259_Nats__1,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ( member @ A @ ( one_one @ A ) @ ( semiring_1_Nats @ A ) ) ) ).

% Nats_1
thf(fact_6260_Nats__add,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [A2: A,B2: A] :
          ( ( member @ A @ A2 @ ( semiring_1_Nats @ A ) )
         => ( ( member @ A @ B2 @ ( semiring_1_Nats @ A ) )
           => ( member @ A @ ( plus_plus @ A @ A2 @ B2 ) @ ( semiring_1_Nats @ A ) ) ) ) ) ).

% Nats_add
thf(fact_6261_mono__pow,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [F2: A > A,N: nat] :
          ( ( order_mono @ A @ A @ F2 )
         => ( order_mono @ A @ A @ ( compow @ ( A > A ) @ N @ F2 ) ) ) ) ).

% mono_pow
thf(fact_6262_mono__Suc,axiom,
    order_mono @ nat @ nat @ suc ).

% mono_Suc
thf(fact_6263_Nats__mult,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [A2: A,B2: A] :
          ( ( member @ A @ A2 @ ( semiring_1_Nats @ A ) )
         => ( ( member @ A @ B2 @ ( semiring_1_Nats @ A ) )
           => ( member @ A @ ( times_times @ A @ A2 @ B2 ) @ ( semiring_1_Nats @ A ) ) ) ) ) ).

% Nats_mult
thf(fact_6264_Nats__cases,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [X: A] :
          ( ( member @ A @ X @ ( semiring_1_Nats @ A ) )
         => ~ ! [N2: nat] :
                ( X
               != ( semiring_1_of_nat @ A @ N2 ) ) ) ) ).

% Nats_cases
thf(fact_6265_Nats__induct,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [X: A,P: A > $o] :
          ( ( member @ A @ X @ ( semiring_1_Nats @ A ) )
         => ( ! [N2: nat] : ( P @ ( semiring_1_of_nat @ A @ N2 ) )
           => ( P @ X ) ) ) ) ).

% Nats_induct
thf(fact_6266_of__nat__in__Nats,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [N: nat] : ( member @ A @ ( semiring_1_of_nat @ A @ N ) @ ( semiring_1_Nats @ A ) ) ) ).

% of_nat_in_Nats
thf(fact_6267_max__of__mono,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( linorder @ A )
        & ( linorder @ B ) )
     => ! [F2: A > B,M: A,N: A] :
          ( ( order_mono @ A @ B @ F2 )
         => ( ( ord_max @ B @ ( F2 @ M ) @ ( F2 @ N ) )
            = ( F2 @ ( ord_max @ A @ M @ N ) ) ) ) ) ).

% max_of_mono
thf(fact_6268_Nats__numeral,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [W: num] : ( member @ A @ ( numeral_numeral @ A @ W ) @ ( semiring_1_Nats @ A ) ) ) ).

% Nats_numeral
thf(fact_6269_mono__strict__invE,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( linorder @ A )
        & ( order @ B ) )
     => ! [F2: A > B,X: A,Y: A] :
          ( ( order_mono @ A @ B @ F2 )
         => ( ( ord_less @ B @ ( F2 @ X ) @ ( F2 @ Y ) )
           => ( ord_less @ A @ X @ Y ) ) ) ) ).

% mono_strict_invE
thf(fact_6270_Nats__0,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ( member @ A @ ( zero_zero @ A ) @ ( semiring_1_Nats @ A ) ) ) ).

% Nats_0
thf(fact_6271_min__of__mono,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( linorder @ A )
        & ( linorder @ B ) )
     => ! [F2: A > B,M: A,N: A] :
          ( ( order_mono @ A @ B @ F2 )
         => ( ( ord_min @ B @ ( F2 @ M ) @ ( F2 @ N ) )
            = ( F2 @ ( ord_min @ A @ M @ N ) ) ) ) ) ).

% min_of_mono
thf(fact_6272_mono__funpow,axiom,
    ! [A: $tType] :
      ( ( ( lattice @ A )
        & ( order_bot @ A ) )
     => ! [Q: A > A] :
          ( ( order_mono @ A @ A @ Q )
         => ( order_mono @ nat @ A
            @ ^ [I4: nat] : ( compow @ ( A > A ) @ I4 @ Q @ ( bot_bot @ A ) ) ) ) ) ).

% mono_funpow
thf(fact_6273_mono__times__nat,axiom,
    ! [N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( order_mono @ nat @ nat @ ( times_times @ nat @ N ) ) ) ).

% mono_times_nat
thf(fact_6274_mono__mult,axiom,
    ! [A: $tType] :
      ( ( ordered_semiring @ A )
     => ! [A2: A] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( order_mono @ A @ A @ ( times_times @ A @ A2 ) ) ) ) ).

% mono_mult
thf(fact_6275_mono__image__least,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( order @ B )
        & ( order @ A ) )
     => ! [F2: A > B,M: A,N: A,M7: B,N5: B] :
          ( ( order_mono @ A @ B @ F2 )
         => ( ( ( image @ A @ B @ F2 @ ( set_or7035219750837199246ssThan @ A @ M @ N ) )
              = ( set_or7035219750837199246ssThan @ B @ M7 @ N5 ) )
           => ( ( ord_less @ A @ M @ N )
             => ( ( F2 @ M )
                = M7 ) ) ) ) ) ).

% mono_image_least
thf(fact_6276_Kleene__iter__gpfp,axiom,
    ! [A: $tType] :
      ( ( order_top @ A )
     => ! [F2: A > A,P6: A,K: nat] :
          ( ( order_mono @ A @ A @ F2 )
         => ( ( ord_less_eq @ A @ P6 @ ( F2 @ P6 ) )
           => ( ord_less_eq @ A @ P6 @ ( compow @ ( A > A ) @ K @ F2 @ ( top_top @ A ) ) ) ) ) ) ).

% Kleene_iter_gpfp
thf(fact_6277_Kleene__iter__lpfp,axiom,
    ! [A: $tType] :
      ( ( order_bot @ A )
     => ! [F2: A > A,P6: A,K: nat] :
          ( ( order_mono @ A @ A @ F2 )
         => ( ( ord_less_eq @ A @ ( F2 @ P6 ) @ P6 )
           => ( ord_less_eq @ A @ ( compow @ ( A > A ) @ K @ F2 @ ( bot_bot @ A ) ) @ P6 ) ) ) ) ).

% Kleene_iter_lpfp
thf(fact_6278_funpow__mono2,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [F2: A > A,I: nat,J: nat,X: A,Y: A] :
          ( ( order_mono @ A @ A @ F2 )
         => ( ( ord_less_eq @ nat @ I @ J )
           => ( ( ord_less_eq @ A @ X @ Y )
             => ( ( ord_less_eq @ A @ X @ ( F2 @ X ) )
               => ( ord_less_eq @ A @ ( compow @ ( A > A ) @ I @ F2 @ X ) @ ( compow @ ( A > A ) @ J @ F2 @ Y ) ) ) ) ) ) ) ).

% funpow_mono2
thf(fact_6279_incseq__bounded,axiom,
    ! [X7: nat > real,B7: real] :
      ( ( order_mono @ nat @ real @ X7 )
     => ( ! [I2: nat] : ( ord_less_eq @ real @ ( X7 @ I2 ) @ B7 )
       => ( bfun @ nat @ real @ X7 @ ( at_top @ nat ) ) ) ) ).

% incseq_bounded
thf(fact_6280_Nats__diff,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ! [A2: A,B2: A] :
          ( ( member @ A @ A2 @ ( semiring_1_Nats @ A ) )
         => ( ( member @ A @ B2 @ ( semiring_1_Nats @ A ) )
           => ( ( ord_less_eq @ A @ B2 @ A2 )
             => ( member @ A @ ( minus_minus @ A @ A2 @ B2 ) @ ( semiring_1_Nats @ A ) ) ) ) ) ) ).

% Nats_diff
thf(fact_6281_mono__Sup,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( comple6319245703460814977attice @ A )
        & ( comple6319245703460814977attice @ B ) )
     => ! [F2: A > B,A4: set @ A] :
          ( ( order_mono @ A @ B @ F2 )
         => ( ord_less_eq @ B @ ( complete_Sup_Sup @ B @ ( image @ A @ B @ F2 @ A4 ) ) @ ( F2 @ ( complete_Sup_Sup @ A @ A4 ) ) ) ) ) ).

% mono_Sup
thf(fact_6282_mono__SUP,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( ( comple6319245703460814977attice @ A )
        & ( comple6319245703460814977attice @ B ) )
     => ! [F2: A > B,A4: C > A,I5: set @ C] :
          ( ( order_mono @ A @ B @ F2 )
         => ( ord_less_eq @ B
            @ ( complete_Sup_Sup @ B
              @ ( image @ C @ B
                @ ^ [X2: C] : ( F2 @ ( A4 @ X2 ) )
                @ I5 ) )
            @ ( F2 @ ( complete_Sup_Sup @ A @ ( image @ C @ A @ A4 @ I5 ) ) ) ) ) ) ).

% mono_SUP
thf(fact_6283_mono__Inf,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( comple6319245703460814977attice @ A )
        & ( comple6319245703460814977attice @ B ) )
     => ! [F2: A > B,A4: set @ A] :
          ( ( order_mono @ A @ B @ F2 )
         => ( ord_less_eq @ B @ ( F2 @ ( complete_Inf_Inf @ A @ A4 ) ) @ ( complete_Inf_Inf @ B @ ( image @ A @ B @ F2 @ A4 ) ) ) ) ) ).

% mono_Inf
thf(fact_6284_mono__INF,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( ( comple6319245703460814977attice @ A )
        & ( comple6319245703460814977attice @ B ) )
     => ! [F2: A > B,A4: C > A,I5: set @ C] :
          ( ( order_mono @ A @ B @ F2 )
         => ( ord_less_eq @ B @ ( F2 @ ( complete_Inf_Inf @ A @ ( image @ C @ A @ A4 @ I5 ) ) )
            @ ( complete_Inf_Inf @ B
              @ ( image @ C @ B
                @ ^ [X2: C] : ( F2 @ ( A4 @ X2 ) )
                @ I5 ) ) ) ) ) ).

% mono_INF
thf(fact_6285_Nats__subset__Ints,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ( ord_less_eq @ ( set @ A ) @ ( semiring_1_Nats @ A ) @ ( ring_1_Ints @ A ) ) ) ).

% Nats_subset_Ints
thf(fact_6286_antimono__funpow,axiom,
    ! [A: $tType] :
      ( ( ( lattice @ A )
        & ( order_top @ A ) )
     => ! [Q: A > A] :
          ( ( order_mono @ A @ A @ Q )
         => ( order_antimono @ nat @ A
            @ ^ [I4: nat] : ( compow @ ( A > A ) @ I4 @ Q @ ( top_top @ A ) ) ) ) ) ).

% antimono_funpow
thf(fact_6287_incseq__le,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [X7: nat > A,L5: A,N: nat] :
          ( ( order_mono @ nat @ A @ X7 )
         => ( ( filterlim @ nat @ A @ X7 @ ( topolo7230453075368039082e_nhds @ A @ L5 ) @ ( at_top @ nat ) )
           => ( ord_less_eq @ A @ ( X7 @ N ) @ L5 ) ) ) ) ).

% incseq_le
thf(fact_6288_funpow__increasing,axiom,
    ! [A: $tType] :
      ( ( ( lattice @ A )
        & ( order_top @ A ) )
     => ! [M: nat,N: nat,F2: A > A] :
          ( ( ord_less_eq @ nat @ M @ N )
         => ( ( order_mono @ A @ A @ F2 )
           => ( ord_less_eq @ A @ ( compow @ ( A > A ) @ N @ F2 @ ( top_top @ A ) ) @ ( compow @ ( A > A ) @ M @ F2 @ ( top_top @ A ) ) ) ) ) ) ).

% funpow_increasing
thf(fact_6289_funpow__decreasing,axiom,
    ! [A: $tType] :
      ( ( ( lattice @ A )
        & ( order_bot @ A ) )
     => ! [M: nat,N: nat,F2: A > A] :
          ( ( ord_less_eq @ nat @ M @ N )
         => ( ( order_mono @ A @ A @ F2 )
           => ( ord_less_eq @ A @ ( compow @ ( A > A ) @ M @ F2 @ ( bot_bot @ A ) ) @ ( compow @ ( A > A ) @ N @ F2 @ ( bot_bot @ A ) ) ) ) ) ) ).

% funpow_decreasing
thf(fact_6290_incseq__convergent,axiom,
    ! [X7: nat > real,B7: real] :
      ( ( order_mono @ nat @ real @ X7 )
     => ( ! [I2: nat] : ( ord_less_eq @ real @ ( X7 @ I2 ) @ B7 )
       => ~ ! [L6: real] :
              ( ( filterlim @ nat @ real @ X7 @ ( topolo7230453075368039082e_nhds @ real @ L6 ) @ ( at_top @ nat ) )
             => ~ ! [I3: nat] : ( ord_less_eq @ real @ ( X7 @ I3 ) @ L6 ) ) ) ) ).

% incseq_convergent
thf(fact_6291_mono__Max__commute,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( linorder @ A )
        & ( linorder @ B ) )
     => ! [F2: A > B,A4: set @ A] :
          ( ( order_mono @ A @ B @ F2 )
         => ( ( finite_finite @ A @ A4 )
           => ( ( A4
               != ( bot_bot @ ( set @ A ) ) )
             => ( ( F2 @ ( lattic643756798349783984er_Max @ A @ A4 ) )
                = ( lattic643756798349783984er_Max @ B @ ( image @ A @ B @ F2 @ A4 ) ) ) ) ) ) ) ).

% mono_Max_commute
thf(fact_6292_mono__Min__commute,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( linorder @ A )
        & ( linorder @ B ) )
     => ! [F2: A > B,A4: set @ A] :
          ( ( order_mono @ A @ B @ F2 )
         => ( ( finite_finite @ A @ A4 )
           => ( ( A4
               != ( bot_bot @ ( set @ A ) ) )
             => ( ( F2 @ ( lattic643756798350308766er_Min @ A @ A4 ) )
                = ( lattic643756798350308766er_Min @ B @ ( image @ A @ B @ F2 @ A4 ) ) ) ) ) ) ) ).

% mono_Min_commute
thf(fact_6293_Nats__def,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ( ( semiring_1_Nats @ A )
        = ( image @ nat @ A @ ( semiring_1_of_nat @ A ) @ ( top_top @ ( set @ nat ) ) ) ) ) ).

% Nats_def
thf(fact_6294_Nats__altdef2,axiom,
    ! [A: $tType] :
      ( ( linordered_idom @ A )
     => ( ( semiring_1_Nats @ A )
        = ( collect @ A
          @ ^ [N3: A] :
              ( ( member @ A @ N3 @ ( ring_1_Ints @ A ) )
              & ( ord_less_eq @ A @ ( zero_zero @ A ) @ N3 ) ) ) ) ) ).

% Nats_altdef2
thf(fact_6295_mono__ge2__power__minus__self,axiom,
    ! [K: nat] :
      ( ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ K )
     => ( order_mono @ nat @ nat
        @ ^ [M3: nat] : ( minus_minus @ nat @ ( power_power @ nat @ K @ M3 ) @ M3 ) ) ) ).

% mono_ge2_power_minus_self
thf(fact_6296_finite__mono__remains__stable__implies__strict__prefix,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [F2: nat > A] :
          ( ( finite_finite @ A @ ( image @ nat @ A @ F2 @ ( top_top @ ( set @ nat ) ) ) )
         => ( ( order_mono @ nat @ A @ F2 )
           => ( ! [N2: nat] :
                  ( ( ( F2 @ N2 )
                    = ( F2 @ ( suc @ N2 ) ) )
                 => ( ( F2 @ ( suc @ N2 ) )
                    = ( F2 @ ( suc @ ( suc @ N2 ) ) ) ) )
             => ? [N9: nat] :
                  ( ! [N7: nat] :
                      ( ( ord_less_eq @ nat @ N7 @ N9 )
                     => ! [M2: nat] :
                          ( ( ord_less_eq @ nat @ M2 @ N9 )
                         => ( ( ord_less @ nat @ M2 @ N7 )
                           => ( ord_less @ A @ ( F2 @ M2 ) @ ( F2 @ N7 ) ) ) ) )
                  & ! [N7: nat] :
                      ( ( ord_less_eq @ nat @ N9 @ N7 )
                     => ( ( F2 @ N9 )
                        = ( F2 @ N7 ) ) ) ) ) ) ) ) ).

% finite_mono_remains_stable_implies_strict_prefix
thf(fact_6297_tendsto__at__left__sequentially,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( topolo3112930676232923870pology @ B )
        & ( topolo1944317154257567458pology @ B )
        & ( topolo4958980785337419405_space @ A ) )
     => ! [B2: B,A2: B,X7: B > A,L5: A] :
          ( ( ord_less @ B @ B2 @ A2 )
         => ( ! [S4: nat > B] :
                ( ! [N7: nat] : ( ord_less @ B @ ( S4 @ N7 ) @ A2 )
               => ( ! [N7: nat] : ( ord_less @ B @ B2 @ ( S4 @ N7 ) )
                 => ( ( order_mono @ nat @ B @ S4 )
                   => ( ( filterlim @ nat @ B @ S4 @ ( topolo7230453075368039082e_nhds @ B @ A2 ) @ ( at_top @ nat ) )
                     => ( filterlim @ nat @ A
                        @ ^ [N3: nat] : ( X7 @ ( S4 @ N3 ) )
                        @ ( topolo7230453075368039082e_nhds @ A @ L5 )
                        @ ( at_top @ nat ) ) ) ) ) )
           => ( filterlim @ B @ A @ X7 @ ( topolo7230453075368039082e_nhds @ A @ L5 ) @ ( topolo174197925503356063within @ B @ A2 @ ( set_ord_lessThan @ B @ A2 ) ) ) ) ) ) ).

% tendsto_at_left_sequentially
thf(fact_6298_remdups__adj__altdef,axiom,
    ! [A: $tType,Xs: list @ A,Ys3: list @ A] :
      ( ( ( remdups_adj @ A @ Xs )
        = Ys3 )
      = ( ? [F3: nat > nat] :
            ( ( order_mono @ nat @ nat @ F3 )
            & ( ( image @ nat @ nat @ F3 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( size_size @ ( list @ A ) @ Xs ) ) )
              = ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( size_size @ ( list @ A ) @ Ys3 ) ) )
            & ! [I4: nat] :
                ( ( ord_less @ nat @ I4 @ ( size_size @ ( list @ A ) @ Xs ) )
               => ( ( nth @ A @ Xs @ I4 )
                  = ( nth @ A @ Ys3 @ ( F3 @ I4 ) ) ) )
            & ! [I4: nat] :
                ( ( ord_less @ nat @ ( plus_plus @ nat @ I4 @ ( one_one @ nat ) ) @ ( size_size @ ( list @ A ) @ Xs ) )
               => ( ( ( nth @ A @ Xs @ I4 )
                    = ( nth @ A @ Xs @ ( plus_plus @ nat @ I4 @ ( one_one @ nat ) ) ) )
                  = ( ( F3 @ I4 )
                    = ( F3 @ ( plus_plus @ nat @ I4 @ ( one_one @ nat ) ) ) ) ) ) ) ) ) ).

% remdups_adj_altdef
thf(fact_6299_inj__sgn__power,axiom,
    ! [N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( inj_on @ real @ real
        @ ^ [Y4: real] : ( times_times @ real @ ( sgn_sgn @ real @ Y4 ) @ ( power_power @ real @ ( abs_abs @ real @ Y4 ) @ N ) )
        @ ( top_top @ ( set @ real ) ) ) ) ).

% inj_sgn_power
thf(fact_6300_inj__mult__left,axiom,
    ! [A: $tType] :
      ( ( idom @ A )
     => ! [A2: A] :
          ( ( inj_on @ A @ A @ ( times_times @ A @ A2 ) @ ( top_top @ ( set @ A ) ) )
          = ( ( A2
             != ( zero_zero @ A ) ) ) ) ) ).

% inj_mult_left
thf(fact_6301_inj__divide__right,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [A2: A] :
          ( ( inj_on @ A @ A
            @ ^ [B3: A] : ( divide_divide @ A @ B3 @ A2 )
            @ ( top_top @ ( set @ A ) ) )
          = ( ( A2
             != ( zero_zero @ A ) ) ) ) ) ).

% inj_divide_right
thf(fact_6302_inj__on__mult,axiom,
    ! [A: $tType] :
      ( ( semidom_divide @ A )
     => ! [A2: A,A4: set @ A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( inj_on @ A @ A @ ( times_times @ A @ A2 ) @ A4 ) ) ) ).

% inj_on_mult
thf(fact_6303_inj__fn,axiom,
    ! [A: $tType,F2: A > A,N: nat] :
      ( ( inj_on @ A @ A @ F2 @ ( top_top @ ( set @ A ) ) )
     => ( inj_on @ A @ A @ ( compow @ ( A > A ) @ N @ F2 ) @ ( top_top @ ( set @ A ) ) ) ) ).

% inj_fn
thf(fact_6304_linorder__injI,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linorder @ A )
     => ! [F2: A > B] :
          ( ! [X3: A,Y5: A] :
              ( ( ord_less @ A @ X3 @ Y5 )
             => ( ( F2 @ X3 )
               != ( F2 @ Y5 ) ) )
         => ( inj_on @ A @ B @ F2 @ ( top_top @ ( set @ A ) ) ) ) ) ).

% linorder_injI
thf(fact_6305_remdups__adj__length,axiom,
    ! [A: $tType,Xs: list @ A] : ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ ( remdups_adj @ A @ Xs ) ) @ ( size_size @ ( list @ A ) @ Xs ) ) ).

% remdups_adj_length
thf(fact_6306_linorder__inj__onI,axiom,
    ! [B: $tType,A: $tType] :
      ( ( order @ A )
     => ! [A4: set @ A,F2: A > B] :
          ( ! [X3: A,Y5: A] :
              ( ( ord_less @ A @ X3 @ Y5 )
             => ( ( member @ A @ X3 @ A4 )
               => ( ( member @ A @ Y5 @ A4 )
                 => ( ( F2 @ X3 )
                   != ( F2 @ Y5 ) ) ) ) )
         => ( ! [X3: A,Y5: A] :
                ( ( member @ A @ X3 @ A4 )
               => ( ( member @ A @ Y5 @ A4 )
                 => ( ( ord_less_eq @ A @ X3 @ Y5 )
                    | ( ord_less_eq @ A @ Y5 @ X3 ) ) ) )
           => ( inj_on @ A @ B @ F2 @ A4 ) ) ) ) ).

% linorder_inj_onI
thf(fact_6307_pigeonhole,axiom,
    ! [A: $tType,B: $tType,F2: B > A,A4: set @ B] :
      ( ( ord_less @ nat @ ( finite_card @ A @ ( image @ B @ A @ F2 @ A4 ) ) @ ( finite_card @ B @ A4 ) )
     => ~ ( inj_on @ B @ A @ F2 @ A4 ) ) ).

% pigeonhole
thf(fact_6308_continuous__inj__imp__mono,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topolo8458572112393995274pology @ A )
        & ( topolo1944317154257567458pology @ B ) )
     => ! [A2: A,X: A,B2: A,F2: A > B] :
          ( ( ord_less @ A @ A2 @ X )
         => ( ( ord_less @ A @ X @ B2 )
           => ( ( topolo81223032696312382ous_on @ A @ B @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) @ F2 )
             => ( ( inj_on @ A @ B @ F2 @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) )
               => ( ( ( ord_less @ B @ ( F2 @ A2 ) @ ( F2 @ X ) )
                    & ( ord_less @ B @ ( F2 @ X ) @ ( F2 @ B2 ) ) )
                  | ( ( ord_less @ B @ ( F2 @ B2 ) @ ( F2 @ X ) )
                    & ( ord_less @ B @ ( F2 @ X ) @ ( F2 @ A2 ) ) ) ) ) ) ) ) ) ).

% continuous_inj_imp_mono
thf(fact_6309_injective__scaleR,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [C2: real] :
          ( ( C2
           != ( zero_zero @ real ) )
         => ( inj_on @ A @ A @ ( real_V8093663219630862766scaleR @ A @ C2 ) @ ( top_top @ ( set @ A ) ) ) ) ) ).

% injective_scaleR
thf(fact_6310_remdups__adj__adjacent,axiom,
    ! [A: $tType,I: nat,Xs: list @ A] :
      ( ( ord_less @ nat @ ( suc @ I ) @ ( size_size @ ( list @ A ) @ ( remdups_adj @ A @ Xs ) ) )
     => ( ( nth @ A @ ( remdups_adj @ A @ Xs ) @ I )
       != ( nth @ A @ ( remdups_adj @ A @ Xs ) @ ( suc @ I ) ) ) ) ).

% remdups_adj_adjacent
thf(fact_6311_inj__on__iff__card__le,axiom,
    ! [A: $tType,B: $tType,A4: set @ A,B7: set @ B] :
      ( ( finite_finite @ A @ A4 )
     => ( ( finite_finite @ B @ B7 )
       => ( ( ? [F3: A > B] :
                ( ( inj_on @ A @ B @ F3 @ A4 )
                & ( ord_less_eq @ ( set @ B ) @ ( image @ A @ B @ F3 @ A4 ) @ B7 ) ) )
          = ( ord_less_eq @ nat @ ( finite_card @ A @ A4 ) @ ( finite_card @ B @ B7 ) ) ) ) ) ).

% inj_on_iff_card_le
thf(fact_6312_card__inj__on__le,axiom,
    ! [A: $tType,B: $tType,F2: A > B,A4: set @ A,B7: set @ B] :
      ( ( inj_on @ A @ B @ F2 @ A4 )
     => ( ( ord_less_eq @ ( set @ B ) @ ( image @ A @ B @ F2 @ A4 ) @ B7 )
       => ( ( finite_finite @ B @ B7 )
         => ( ord_less_eq @ nat @ ( finite_card @ A @ A4 ) @ ( finite_card @ B @ B7 ) ) ) ) ) ).

% card_inj_on_le
thf(fact_6313_card__le__inj,axiom,
    ! [B: $tType,A: $tType,A4: set @ A,B7: set @ B] :
      ( ( finite_finite @ A @ A4 )
     => ( ( finite_finite @ B @ B7 )
       => ( ( ord_less_eq @ nat @ ( finite_card @ A @ A4 ) @ ( finite_card @ B @ B7 ) )
         => ? [F6: A > B] :
              ( ( ord_less_eq @ ( set @ B ) @ ( image @ A @ B @ F6 @ A4 ) @ B7 )
              & ( inj_on @ A @ B @ F6 @ A4 ) ) ) ) ) ).

% card_le_inj
thf(fact_6314_log__inj,axiom,
    ! [B2: real] :
      ( ( ord_less @ real @ ( one_one @ real ) @ B2 )
     => ( inj_on @ real @ real @ ( log2 @ B2 ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) ) ).

% log_inj
thf(fact_6315_complex__is__Nat__iff,axiom,
    ! [Z: complex] :
      ( ( member @ complex @ Z @ ( semiring_1_Nats @ complex ) )
      = ( ( ( im @ Z )
          = ( zero_zero @ real ) )
        & ? [I4: nat] :
            ( ( re @ Z )
            = ( semiring_1_of_nat @ real @ I4 ) ) ) ) ).

% complex_is_Nat_iff
thf(fact_6316_tendsto__at__topI__sequentially__real,axiom,
    ! [F2: real > real,Y: real] :
      ( ( order_mono @ real @ real @ F2 )
     => ( ( filterlim @ nat @ real
          @ ^ [N3: nat] : ( F2 @ ( semiring_1_of_nat @ real @ N3 ) )
          @ ( topolo7230453075368039082e_nhds @ real @ Y )
          @ ( at_top @ nat ) )
       => ( filterlim @ real @ real @ F2 @ ( topolo7230453075368039082e_nhds @ real @ Y ) @ ( at_top @ real ) ) ) ) ).

% tendsto_at_topI_sequentially_real
thf(fact_6317_nonneg__incseq__Bseq__subseq__iff,axiom,
    ! [F2: nat > real,G: nat > nat] :
      ( ! [X3: nat] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( F2 @ X3 ) )
     => ( ( order_mono @ nat @ real @ F2 )
       => ( ( order_strict_mono @ nat @ nat @ G )
         => ( ( bfun @ nat @ real
              @ ^ [X2: nat] : ( F2 @ ( G @ X2 ) )
              @ ( at_top @ nat ) )
            = ( bfun @ nat @ real @ F2 @ ( at_top @ nat ) ) ) ) ) ) ).

% nonneg_incseq_Bseq_subseq_iff
thf(fact_6318_has__derivative__power__int,axiom,
    ! [A: $tType,C: $tType] :
      ( ( ( real_V822414075346904944vector @ C )
        & ( real_V3459762299906320749_field @ A ) )
     => ! [F2: C > A,X: C,F5: C > A,S: set @ C,N: int] :
          ( ( ( F2 @ X )
           != ( zero_zero @ A ) )
         => ( ( has_derivative @ C @ A @ F2 @ F5 @ ( topolo174197925503356063within @ C @ X @ S ) )
           => ( has_derivative @ C @ A
              @ ^ [X2: C] : ( power_int @ A @ ( F2 @ X2 ) @ N )
              @ ^ [H: C] : ( times_times @ A @ ( F5 @ H ) @ ( times_times @ A @ ( ring_1_of_int @ A @ N ) @ ( power_int @ A @ ( F2 @ X ) @ ( minus_minus @ int @ N @ ( one_one @ int ) ) ) ) )
              @ ( topolo174197925503356063within @ C @ X @ S ) ) ) ) ) ).

% has_derivative_power_int
thf(fact_6319_power__int__1__left,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [N: int] :
          ( ( power_int @ A @ ( one_one @ A ) @ N )
          = ( one_one @ A ) ) ) ).

% power_int_1_left
thf(fact_6320_power__int__1__right,axiom,
    ! [A: $tType] :
      ( ( ( inverse @ A )
        & ( monoid_mult @ A ) )
     => ! [Y: A] :
          ( ( power_int @ A @ Y @ ( one_one @ int ) )
          = Y ) ) ).

% power_int_1_right
thf(fact_6321_power__int__sgn,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,N: int] :
          ( ( sgn_sgn @ A @ ( power_int @ A @ A2 @ N ) )
          = ( power_int @ A @ ( sgn_sgn @ A @ A2 ) @ N ) ) ) ).

% power_int_sgn
thf(fact_6322_power__int__mult__distrib__numeral2,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [X: A,W: num,M: int] :
          ( ( power_int @ A @ ( times_times @ A @ X @ ( numeral_numeral @ A @ W ) ) @ M )
          = ( times_times @ A @ ( power_int @ A @ X @ M ) @ ( power_int @ A @ ( numeral_numeral @ A @ W ) @ M ) ) ) ) ).

% power_int_mult_distrib_numeral2
thf(fact_6323_power__int__mult__distrib__numeral1,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [W: num,Y: A,M: int] :
          ( ( power_int @ A @ ( times_times @ A @ ( numeral_numeral @ A @ W ) @ Y ) @ M )
          = ( times_times @ A @ ( power_int @ A @ ( numeral_numeral @ A @ W ) @ M ) @ ( power_int @ A @ Y @ M ) ) ) ) ).

% power_int_mult_distrib_numeral1
thf(fact_6324_power__int__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [X: A,N: int] :
          ( ( ( power_int @ A @ X @ N )
            = ( zero_zero @ A ) )
          = ( ( X
              = ( zero_zero @ A ) )
            & ( N
             != ( zero_zero @ int ) ) ) ) ) ).

% power_int_eq_0_iff
thf(fact_6325_power__int__0__left,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [M: int] :
          ( ( M
           != ( zero_zero @ int ) )
         => ( ( power_int @ A @ ( zero_zero @ A ) @ M )
            = ( zero_zero @ A ) ) ) ) ).

% power_int_0_left
thf(fact_6326_power__int__0__right,axiom,
    ! [B: $tType] :
      ( ( ( inverse @ B )
        & ( power @ B ) )
     => ! [X: B] :
          ( ( power_int @ B @ X @ ( zero_zero @ int ) )
          = ( one_one @ B ) ) ) ).

% power_int_0_right
thf(fact_6327_abs__power__int__minus,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,N: int] :
          ( ( abs_abs @ A @ ( power_int @ A @ ( uminus_uminus @ A @ A2 ) @ N ) )
          = ( abs_abs @ A @ ( power_int @ A @ A2 @ N ) ) ) ) ).

% abs_power_int_minus
thf(fact_6328_power__int__of__nat,axiom,
    ! [A: $tType] :
      ( ( ( inverse @ A )
        & ( power @ A ) )
     => ! [X: A,N: nat] :
          ( ( power_int @ A @ X @ ( semiring_1_of_nat @ int @ N ) )
          = ( power_power @ A @ X @ N ) ) ) ).

% power_int_of_nat
thf(fact_6329_power__int__mult__numeral,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [X: A,M: num,N: num] :
          ( ( power_int @ A @ ( power_int @ A @ X @ ( numeral_numeral @ int @ M ) ) @ ( numeral_numeral @ int @ N ) )
          = ( power_int @ A @ X @ ( numeral_numeral @ int @ ( times_times @ num @ M @ N ) ) ) ) ) ).

% power_int_mult_numeral
thf(fact_6330_power__int__numeral,axiom,
    ! [A: $tType] :
      ( ( ( inverse @ A )
        & ( power @ A ) )
     => ! [X: A,N: num] :
          ( ( power_int @ A @ X @ ( numeral_numeral @ int @ N ) )
          = ( power_power @ A @ X @ ( numeral_numeral @ nat @ N ) ) ) ) ).

% power_int_numeral
thf(fact_6331_of__real__eq__numeral__power__int__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( real_V5047593784448816457lgebra @ A )
     => ! [Y: real,X: num,N: int] :
          ( ( ( real_Vector_of_real @ A @ Y )
            = ( power_int @ A @ ( numeral_numeral @ A @ X ) @ N ) )
          = ( Y
            = ( power_int @ real @ ( numeral_numeral @ real @ X ) @ N ) ) ) ) ).

% of_real_eq_numeral_power_int_cancel_iff
thf(fact_6332_numeral__power__int__eq__of__real__cancel__iff,axiom,
    ! [A: $tType] :
      ( ( real_V5047593784448816457lgebra @ A )
     => ! [X: num,N: int,Y: real] :
          ( ( ( power_int @ A @ ( numeral_numeral @ A @ X ) @ N )
            = ( real_Vector_of_real @ A @ Y ) )
          = ( ( power_int @ real @ ( numeral_numeral @ real @ X ) @ N )
            = Y ) ) ) ).

% numeral_power_int_eq_of_real_cancel_iff
thf(fact_6333_power__int__minus1__right,axiom,
    ! [A: $tType] :
      ( ( ( inverse @ A )
        & ( monoid_mult @ A ) )
     => ! [Y: A] :
          ( ( power_int @ A @ Y @ ( uminus_uminus @ int @ ( one_one @ int ) ) )
          = ( inverse_inverse @ A @ Y ) ) ) ).

% power_int_minus1_right
thf(fact_6334_power__int__add__numeral2,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [X: A,M: num,N: num,B2: A] :
          ( ( times_times @ A @ ( power_int @ A @ X @ ( numeral_numeral @ int @ M ) ) @ ( times_times @ A @ ( power_int @ A @ X @ ( numeral_numeral @ int @ N ) ) @ B2 ) )
          = ( times_times @ A @ ( power_int @ A @ X @ ( numeral_numeral @ int @ ( plus_plus @ num @ M @ N ) ) ) @ B2 ) ) ) ).

% power_int_add_numeral2
thf(fact_6335_power__int__add__numeral,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [X: A,M: num,N: num] :
          ( ( times_times @ A @ ( power_int @ A @ X @ ( numeral_numeral @ int @ M ) ) @ ( power_int @ A @ X @ ( numeral_numeral @ int @ N ) ) )
          = ( power_int @ A @ X @ ( numeral_numeral @ int @ ( plus_plus @ num @ M @ N ) ) ) ) ) ).

% power_int_add_numeral
thf(fact_6336_power__int__mono__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A,N: int] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ B2 )
           => ( ( ord_less @ int @ ( zero_zero @ int ) @ N )
             => ( ( ord_less_eq @ A @ ( power_int @ A @ A2 @ N ) @ ( power_int @ A @ B2 @ N ) )
                = ( ord_less_eq @ A @ A2 @ B2 ) ) ) ) ) ) ).

% power_int_mono_iff
thf(fact_6337_power__int__minus__left__even,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [N: int,A2: A] :
          ( ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N )
         => ( ( power_int @ A @ ( uminus_uminus @ A @ A2 ) @ N )
            = ( power_int @ A @ A2 @ N ) ) ) ) ).

% power_int_minus_left_even
thf(fact_6338_power__int__minus__left__odd,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [N: int,A2: A] :
          ( ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N )
         => ( ( power_int @ A @ ( uminus_uminus @ A @ A2 ) @ N )
            = ( uminus_uminus @ A @ ( power_int @ A @ A2 @ N ) ) ) ) ) ).

% power_int_minus_left_odd
thf(fact_6339_power__int__numeral__neg__numeral,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [M: num,N: num] :
          ( ( power_int @ A @ ( numeral_numeral @ A @ M ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N ) ) )
          = ( inverse_inverse @ A @ ( numeral_numeral @ A @ ( pow @ M @ N ) ) ) ) ) ).

% power_int_numeral_neg_numeral
thf(fact_6340_strict__mono__mono,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( order @ A )
        & ( order @ B ) )
     => ! [F2: A > B] :
          ( ( order_strict_mono @ A @ B @ F2 )
         => ( order_mono @ A @ B @ F2 ) ) ) ).

% strict_mono_mono
thf(fact_6341_inj__Suc,axiom,
    ! [N4: set @ nat] : ( inj_on @ nat @ nat @ suc @ N4 ) ).

% inj_Suc
thf(fact_6342_inj__on__of__nat,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ! [N4: set @ nat] : ( inj_on @ nat @ A @ ( semiring_1_of_nat @ A ) @ N4 ) ) ).

% inj_on_of_nat
thf(fact_6343_inj__of__nat,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ( inj_on @ nat @ A @ ( semiring_1_of_nat @ A ) @ ( top_top @ ( set @ nat ) ) ) ) ).

% inj_of_nat
thf(fact_6344_inj__on__diff__nat,axiom,
    ! [N4: set @ nat,K: nat] :
      ( ! [N2: nat] :
          ( ( member @ nat @ N2 @ N4 )
         => ( ord_less_eq @ nat @ K @ N2 ) )
     => ( inj_on @ nat @ nat
        @ ^ [N3: nat] : ( minus_minus @ nat @ N3 @ K )
        @ N4 ) ) ).

% inj_on_diff_nat
thf(fact_6345_strict__mono__imp__increasing,axiom,
    ! [F2: nat > nat,N: nat] :
      ( ( order_strict_mono @ nat @ nat @ F2 )
     => ( ord_less_eq @ nat @ N @ ( F2 @ N ) ) ) ).

% strict_mono_imp_increasing
thf(fact_6346_strict__mono__less__eq,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( linorder @ A )
        & ( order @ B ) )
     => ! [F2: A > B,X: A,Y: A] :
          ( ( order_strict_mono @ A @ B @ F2 )
         => ( ( ord_less_eq @ B @ ( F2 @ X ) @ ( F2 @ Y ) )
            = ( ord_less_eq @ A @ X @ Y ) ) ) ) ).

% strict_mono_less_eq
thf(fact_6347_strict__mono__leD,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( order @ A )
        & ( order @ B ) )
     => ! [R2: A > B,M: A,N: A] :
          ( ( order_strict_mono @ A @ B @ R2 )
         => ( ( ord_less_eq @ A @ M @ N )
           => ( ord_less_eq @ B @ ( R2 @ M ) @ ( R2 @ N ) ) ) ) ) ).

% strict_mono_leD
thf(fact_6348_zero__le__power__int,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A,N: int] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X )
         => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( power_int @ A @ X @ N ) ) ) ) ).

% zero_le_power_int
thf(fact_6349_power__int__minus,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [X: A,N: int] :
          ( ( power_int @ A @ X @ ( uminus_uminus @ int @ N ) )
          = ( inverse_inverse @ A @ ( power_int @ A @ X @ N ) ) ) ) ).

% power_int_minus
thf(fact_6350_power__int__one__over,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [X: A,N: int] :
          ( ( power_int @ A @ ( divide_divide @ A @ ( one_one @ A ) @ X ) @ N )
          = ( divide_divide @ A @ ( one_one @ A ) @ ( power_int @ A @ X @ N ) ) ) ) ).

% power_int_one_over
thf(fact_6351_power__int__divide__distrib,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [X: A,Y: A,M: int] :
          ( ( power_int @ A @ ( divide_divide @ A @ X @ Y ) @ M )
          = ( divide_divide @ A @ ( power_int @ A @ X @ M ) @ ( power_int @ A @ Y @ M ) ) ) ) ).

% power_int_divide_distrib
thf(fact_6352_power__int__abs,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,N: int] :
          ( ( abs_abs @ A @ ( power_int @ A @ A2 @ N ) )
          = ( power_int @ A @ ( abs_abs @ A @ A2 ) @ N ) ) ) ).

% power_int_abs
thf(fact_6353_power__int__inverse,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [X: A,N: int] :
          ( ( power_int @ A @ ( inverse_inverse @ A @ X ) @ N )
          = ( inverse_inverse @ A @ ( power_int @ A @ X @ N ) ) ) ) ).

% power_int_inverse
thf(fact_6354_strict__mono__eq,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( linorder @ A )
        & ( order @ B ) )
     => ! [F2: A > B,X: A,Y: A] :
          ( ( order_strict_mono @ A @ B @ F2 )
         => ( ( ( F2 @ X )
              = ( F2 @ Y ) )
            = ( X = Y ) ) ) ) ).

% strict_mono_eq
thf(fact_6355_power__int__mult,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [X: A,M: int,N: int] :
          ( ( power_int @ A @ X @ ( times_times @ int @ M @ N ) )
          = ( power_int @ A @ ( power_int @ A @ X @ M ) @ N ) ) ) ).

% power_int_mult
thf(fact_6356_power__int__mult__distrib,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [X: A,Y: A,M: int] :
          ( ( power_int @ A @ ( times_times @ A @ X @ Y ) @ M )
          = ( times_times @ A @ ( power_int @ A @ X @ M ) @ ( power_int @ A @ Y @ M ) ) ) ) ).

% power_int_mult_distrib
thf(fact_6357_power__int__commutes,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [X: A,N: int] :
          ( ( times_times @ A @ ( power_int @ A @ X @ N ) @ X )
          = ( times_times @ A @ X @ ( power_int @ A @ X @ N ) ) ) ) ).

% power_int_commutes
thf(fact_6358_strict__mono__less,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( linorder @ A )
        & ( order @ B ) )
     => ! [F2: A > B,X: A,Y: A] :
          ( ( order_strict_mono @ A @ B @ F2 )
         => ( ( ord_less @ B @ ( F2 @ X ) @ ( F2 @ Y ) )
            = ( ord_less @ A @ X @ Y ) ) ) ) ).

% strict_mono_less
thf(fact_6359_strict__mono__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( order @ A )
        & ( order @ B ) )
     => ( ( order_strict_mono @ A @ B )
        = ( ^ [F3: A > B] :
            ! [X2: A,Y4: A] :
              ( ( ord_less @ A @ X2 @ Y4 )
             => ( ord_less @ B @ ( F3 @ X2 ) @ ( F3 @ Y4 ) ) ) ) ) ) ).

% strict_mono_def
thf(fact_6360_strict__monoI,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( order @ A )
        & ( order @ B ) )
     => ! [F2: A > B] :
          ( ! [X3: A,Y5: A] :
              ( ( ord_less @ A @ X3 @ Y5 )
             => ( ord_less @ B @ ( F2 @ X3 ) @ ( F2 @ Y5 ) ) )
         => ( order_strict_mono @ A @ B @ F2 ) ) ) ).

% strict_monoI
thf(fact_6361_strict__monoD,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( order @ A )
        & ( order @ B ) )
     => ! [F2: A > B,X: A,Y: A] :
          ( ( order_strict_mono @ A @ B @ F2 )
         => ( ( ord_less @ A @ X @ Y )
           => ( ord_less @ B @ ( F2 @ X ) @ ( F2 @ Y ) ) ) ) ) ).

% strict_monoD
thf(fact_6362_zero__less__power__int,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A,N: int] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ X )
         => ( ord_less @ A @ ( zero_zero @ A ) @ ( power_int @ A @ X @ N ) ) ) ) ).

% zero_less_power_int
thf(fact_6363_power__int__not__zero,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [X: A,N: int] :
          ( ( ( X
             != ( zero_zero @ A ) )
            | ( N
              = ( zero_zero @ int ) ) )
         => ( ( power_int @ A @ X @ N )
           != ( zero_zero @ A ) ) ) ) ).

% power_int_not_zero
thf(fact_6364_continuous__on__power__int,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topolo4958980785337419405_space @ A )
        & ( real_V8999393235501362500lgebra @ B ) )
     => ! [S2: set @ A,F2: A > B,N: int] :
          ( ( topolo81223032696312382ous_on @ A @ B @ S2 @ F2 )
         => ( ! [X3: A] :
                ( ( member @ A @ X3 @ S2 )
               => ( ( F2 @ X3 )
                 != ( zero_zero @ B ) ) )
           => ( topolo81223032696312382ous_on @ A @ B @ S2
              @ ^ [X2: A] : ( power_int @ B @ ( F2 @ X2 ) @ N ) ) ) ) ) ).

% continuous_on_power_int
thf(fact_6365_strict__mono__Suc__iff,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ( order_strict_mono @ nat @ A )
        = ( ^ [F3: nat > A] :
            ! [N3: nat] : ( ord_less @ A @ ( F3 @ N3 ) @ ( F3 @ ( suc @ N3 ) ) ) ) ) ) ).

% strict_mono_Suc_iff
thf(fact_6366_power__int__0__left__If,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [M: int] :
          ( ( ( M
              = ( zero_zero @ int ) )
           => ( ( power_int @ A @ ( zero_zero @ A ) @ M )
              = ( one_one @ A ) ) )
          & ( ( M
             != ( zero_zero @ int ) )
           => ( ( power_int @ A @ ( zero_zero @ A ) @ M )
              = ( zero_zero @ A ) ) ) ) ) ).

% power_int_0_left_If
thf(fact_6367_power__int__increasing,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [N: int,N4: int,A2: A] :
          ( ( ord_less_eq @ int @ N @ N4 )
         => ( ( ord_less_eq @ A @ ( one_one @ A ) @ A2 )
           => ( ord_less_eq @ A @ ( power_int @ A @ A2 @ N ) @ ( power_int @ A @ A2 @ N4 ) ) ) ) ) ).

% power_int_increasing
thf(fact_6368_power__int__strict__increasing,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [N: int,N4: int,A2: A] :
          ( ( ord_less @ int @ N @ N4 )
         => ( ( ord_less @ A @ ( one_one @ A ) @ A2 )
           => ( ord_less @ A @ ( power_int @ A @ A2 @ N ) @ ( power_int @ A @ A2 @ N4 ) ) ) ) ) ).

% power_int_strict_increasing
thf(fact_6369_power__int__diff,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [X: A,M: int,N: int] :
          ( ( ( X
             != ( zero_zero @ A ) )
            | ( M != N ) )
         => ( ( power_int @ A @ X @ ( minus_minus @ int @ M @ N ) )
            = ( divide_divide @ A @ ( power_int @ A @ X @ M ) @ ( power_int @ A @ X @ N ) ) ) ) ) ).

% power_int_diff
thf(fact_6370_tendsto__power__int,axiom,
    ! [A: $tType,B: $tType] :
      ( ( real_V8999393235501362500lgebra @ A )
     => ! [F2: B > A,A2: A,F4: filter @ B,N: int] :
          ( ( filterlim @ B @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ A2 ) @ F4 )
         => ( ( A2
             != ( zero_zero @ A ) )
           => ( filterlim @ B @ A
              @ ^ [X2: B] : ( power_int @ A @ ( F2 @ X2 ) @ N )
              @ ( topolo7230453075368039082e_nhds @ A @ ( power_int @ A @ A2 @ N ) )
              @ F4 ) ) ) ) ).

% tendsto_power_int
thf(fact_6371_continuous__at__within__power__int,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topological_t2_space @ A )
        & ( real_V8999393235501362500lgebra @ B ) )
     => ! [A2: A,S2: set @ A,F2: A > B,N: int] :
          ( ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ S2 ) @ F2 )
         => ( ( ( F2 @ A2 )
             != ( zero_zero @ B ) )
           => ( topolo3448309680560233919inuous @ A @ B @ ( topolo174197925503356063within @ A @ A2 @ S2 )
              @ ^ [X2: A] : ( power_int @ B @ ( F2 @ X2 ) @ N ) ) ) ) ) ).

% continuous_at_within_power_int
thf(fact_6372_finite__imp__nat__seg__image__inj__on,axiom,
    ! [A: $tType,A4: set @ A] :
      ( ( finite_finite @ A @ A4 )
     => ? [N2: nat,F6: nat > A] :
          ( ( A4
            = ( image @ nat @ A @ F6
              @ ( collect @ nat
                @ ^ [I4: nat] : ( ord_less @ nat @ I4 @ N2 ) ) ) )
          & ( inj_on @ nat @ A @ F6
            @ ( collect @ nat
              @ ^ [I4: nat] : ( ord_less @ nat @ I4 @ N2 ) ) ) ) ) ).

% finite_imp_nat_seg_image_inj_on
thf(fact_6373_differentiable__power__int,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V3459762299906320749_field @ B ) )
     => ! [F2: A > B,X: A,S2: set @ A,N: int] :
          ( ( differentiable @ A @ B @ F2 @ ( topolo174197925503356063within @ A @ X @ S2 ) )
         => ( ( ( F2 @ X )
             != ( zero_zero @ B ) )
           => ( differentiable @ A @ B
              @ ^ [X2: A] : ( power_int @ B @ ( F2 @ X2 ) @ N )
              @ ( topolo174197925503356063within @ A @ X @ S2 ) ) ) ) ) ).

% differentiable_power_int
thf(fact_6374_finite__imp__inj__to__nat__seg,axiom,
    ! [A: $tType,A4: set @ A] :
      ( ( finite_finite @ A @ A4 )
     => ? [F6: A > nat,N2: nat] :
          ( ( ( image @ A @ nat @ F6 @ A4 )
            = ( collect @ nat
              @ ^ [I4: nat] : ( ord_less @ nat @ I4 @ N2 ) ) )
          & ( inj_on @ A @ nat @ F6 @ A4 ) ) ) ).

% finite_imp_inj_to_nat_seg
thf(fact_6375_continuous__power__int,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topological_t2_space @ A )
        & ( real_V8999393235501362500lgebra @ B ) )
     => ! [F4: filter @ A,F2: A > B,N: int] :
          ( ( topolo3448309680560233919inuous @ A @ B @ F4 @ F2 )
         => ( ( ( F2
                @ ( topolo3827282254853284352ce_Lim @ A @ A @ F4
                  @ ^ [X2: A] : X2 ) )
             != ( zero_zero @ B ) )
           => ( topolo3448309680560233919inuous @ A @ B @ F4
              @ ^ [X2: A] : ( power_int @ B @ ( F2 @ X2 ) @ N ) ) ) ) ) ).

% continuous_power_int
thf(fact_6376_power__int__strict__decreasing,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [N: int,N4: int,A2: A] :
          ( ( ord_less @ int @ N @ N4 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
           => ( ( ord_less @ A @ A2 @ ( one_one @ A ) )
             => ( ord_less @ A @ ( power_int @ A @ A2 @ N4 ) @ ( power_int @ A @ A2 @ N ) ) ) ) ) ) ).

% power_int_strict_decreasing
thf(fact_6377_power__int__mono,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A,Y: A,N: int] :
          ( ( ord_less_eq @ A @ X @ Y )
         => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ N )
           => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X )
             => ( ord_less_eq @ A @ ( power_int @ A @ X @ N ) @ ( power_int @ A @ Y @ N ) ) ) ) ) ) ).

% power_int_mono
thf(fact_6378_power__int__strict__antimono,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A,N: int] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
           => ( ( ord_less @ int @ N @ ( zero_zero @ int ) )
             => ( ord_less @ A @ ( power_int @ A @ B2 @ N ) @ ( power_int @ A @ A2 @ N ) ) ) ) ) ) ).

% power_int_strict_antimono
thf(fact_6379_one__le__power__int,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A,N: int] :
          ( ( ord_less_eq @ A @ ( one_one @ A ) @ X )
         => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ N )
           => ( ord_less_eq @ A @ ( one_one @ A ) @ ( power_int @ A @ X @ N ) ) ) ) ) ).

% one_le_power_int
thf(fact_6380_one__less__power__int,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,N: int] :
          ( ( ord_less @ A @ ( one_one @ A ) @ A2 )
         => ( ( ord_less @ int @ ( zero_zero @ int ) @ N )
           => ( ord_less @ A @ ( one_one @ A ) @ ( power_int @ A @ A2 @ N ) ) ) ) ) ).

% one_less_power_int
thf(fact_6381_power__int__add,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [X: A,M: int,N: int] :
          ( ( ( X
             != ( zero_zero @ A ) )
            | ( ( plus_plus @ int @ M @ N )
             != ( zero_zero @ int ) ) )
         => ( ( power_int @ A @ X @ ( plus_plus @ int @ M @ N ) )
            = ( times_times @ A @ ( power_int @ A @ X @ M ) @ ( power_int @ A @ X @ N ) ) ) ) ) ).

% power_int_add
thf(fact_6382_inj__on__nth,axiom,
    ! [A: $tType,Xs: list @ A,I5: set @ nat] :
      ( ( distinct @ A @ Xs )
     => ( ! [X3: nat] :
            ( ( member @ nat @ X3 @ I5 )
           => ( ord_less @ nat @ X3 @ ( size_size @ ( list @ A ) @ Xs ) ) )
       => ( inj_on @ nat @ A @ ( nth @ A @ Xs ) @ I5 ) ) ) ).

% inj_on_nth
thf(fact_6383_summable__reindex,axiom,
    ! [F2: nat > real,G: nat > nat] :
      ( ( summable @ real @ F2 )
     => ( ( inj_on @ nat @ nat @ G @ ( top_top @ ( set @ nat ) ) )
       => ( ! [X3: nat] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( F2 @ X3 ) )
         => ( summable @ real @ ( comp @ nat @ real @ nat @ F2 @ G ) ) ) ) ) ).

% summable_reindex
thf(fact_6384_inj__on__funpow__least,axiom,
    ! [A: $tType,N: nat,F2: A > A,S2: A] :
      ( ( ( compow @ ( A > A ) @ N @ F2 @ S2 )
        = S2 )
     => ( ! [M4: nat] :
            ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M4 )
           => ( ( ord_less @ nat @ M4 @ N )
             => ( ( compow @ ( A > A ) @ M4 @ F2 @ S2 )
               != S2 ) ) )
       => ( inj_on @ nat @ A
          @ ^ [K3: nat] : ( compow @ ( A > A ) @ K3 @ F2 @ S2 )
          @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ N ) ) ) ) ).

% inj_on_funpow_least
thf(fact_6385_power__int__antimono,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A,N: int] :
          ( ( ord_less_eq @ A @ A2 @ B2 )
         => ( ( ord_less @ A @ ( zero_zero @ A ) @ A2 )
           => ( ( ord_less @ int @ N @ ( zero_zero @ int ) )
             => ( ord_less_eq @ A @ ( power_int @ A @ B2 @ N ) @ ( power_int @ A @ A2 @ N ) ) ) ) ) ) ).

% power_int_antimono
thf(fact_6386_power__int__strict__mono,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [A2: A,B2: A,N: int] :
          ( ( ord_less @ A @ A2 @ B2 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
           => ( ( ord_less @ int @ ( zero_zero @ int ) @ N )
             => ( ord_less @ A @ ( power_int @ A @ A2 @ N ) @ ( power_int @ A @ B2 @ N ) ) ) ) ) ) ).

% power_int_strict_mono
thf(fact_6387_power__int__le__one,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A,N: int] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ X )
         => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ N )
           => ( ( ord_less_eq @ A @ X @ ( one_one @ A ) )
             => ( ord_less_eq @ A @ ( power_int @ A @ X @ N ) @ ( one_one @ A ) ) ) ) ) ) ).

% power_int_le_one
thf(fact_6388_power__int__decreasing,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [N: int,N4: int,A2: A] :
          ( ( ord_less_eq @ int @ N @ N4 )
         => ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ A2 )
           => ( ( ord_less_eq @ A @ A2 @ ( one_one @ A ) )
             => ( ( ( A2
                   != ( zero_zero @ A ) )
                  | ( N4
                   != ( zero_zero @ int ) )
                  | ( N
                    = ( zero_zero @ int ) ) )
               => ( ord_less_eq @ A @ ( power_int @ A @ A2 @ N4 ) @ ( power_int @ A @ A2 @ N ) ) ) ) ) ) ) ).

% power_int_decreasing
thf(fact_6389_power__int__le__imp__le__exp,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A,M: int,N: int] :
          ( ( ord_less @ A @ ( one_one @ A ) @ X )
         => ( ( ord_less_eq @ A @ ( power_int @ A @ X @ M ) @ ( power_int @ A @ X @ N ) )
           => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ N )
             => ( ord_less_eq @ int @ M @ N ) ) ) ) ) ).

% power_int_le_imp_le_exp
thf(fact_6390_power__int__le__imp__less__exp,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [X: A,M: int,N: int] :
          ( ( ord_less @ A @ ( one_one @ A ) @ X )
         => ( ( ord_less @ A @ ( power_int @ A @ X @ M ) @ ( power_int @ A @ X @ N ) )
           => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ N )
             => ( ord_less @ int @ M @ N ) ) ) ) ) ).

% power_int_le_imp_less_exp
thf(fact_6391_power__int__minus__left,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [N: int,A2: A] :
          ( ( ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N )
           => ( ( power_int @ A @ ( uminus_uminus @ A @ A2 ) @ N )
              = ( power_int @ A @ A2 @ N ) ) )
          & ( ~ ( dvd_dvd @ int @ ( numeral_numeral @ int @ ( bit0 @ one2 ) ) @ N )
           => ( ( power_int @ A @ ( uminus_uminus @ A @ A2 ) @ N )
              = ( uminus_uminus @ A @ ( power_int @ A @ A2 @ N ) ) ) ) ) ) ).

% power_int_minus_left
thf(fact_6392_power__int__minus__mult,axiom,
    ! [A: $tType] :
      ( ( field @ A )
     => ! [X: A,N: int] :
          ( ( ( X
             != ( zero_zero @ A ) )
            | ( N
             != ( zero_zero @ int ) ) )
         => ( ( times_times @ A @ ( power_int @ A @ X @ ( minus_minus @ int @ N @ ( one_one @ int ) ) ) @ X )
            = ( power_int @ A @ X @ N ) ) ) ) ).

% power_int_minus_mult
thf(fact_6393_power__int__add__1_H,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [X: A,M: int] :
          ( ( ( X
             != ( zero_zero @ A ) )
            | ( M
             != ( uminus_uminus @ int @ ( one_one @ int ) ) ) )
         => ( ( power_int @ A @ X @ ( plus_plus @ int @ M @ ( one_one @ int ) ) )
            = ( times_times @ A @ X @ ( power_int @ A @ X @ M ) ) ) ) ) ).

% power_int_add_1'
thf(fact_6394_power__int__add__1,axiom,
    ! [A: $tType] :
      ( ( division_ring @ A )
     => ! [X: A,M: int] :
          ( ( ( X
             != ( zero_zero @ A ) )
            | ( M
             != ( uminus_uminus @ int @ ( one_one @ int ) ) ) )
         => ( ( power_int @ A @ X @ ( plus_plus @ int @ M @ ( one_one @ int ) ) )
            = ( times_times @ A @ ( power_int @ A @ X @ M ) @ X ) ) ) ) ).

% power_int_add_1
thf(fact_6395_suminf__reindex__mono,axiom,
    ! [F2: nat > real,G: nat > nat] :
      ( ( summable @ real @ F2 )
     => ( ( inj_on @ nat @ nat @ G @ ( top_top @ ( set @ nat ) ) )
       => ( ! [X3: nat] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( F2 @ X3 ) )
         => ( ord_less_eq @ real @ ( suminf @ real @ ( comp @ nat @ real @ nat @ F2 @ G ) ) @ ( suminf @ real @ F2 ) ) ) ) ) ).

% suminf_reindex_mono
thf(fact_6396_summable__mono__reindex,axiom,
    ! [A: $tType] :
      ( ( ( comm_monoid_add @ A )
        & ( topolo4958980785337419405_space @ A ) )
     => ! [G: nat > nat,F2: nat > A] :
          ( ( order_strict_mono @ nat @ nat @ G )
         => ( ! [N2: nat] :
                ( ~ ( member @ nat @ N2 @ ( image @ nat @ nat @ G @ ( top_top @ ( set @ nat ) ) ) )
               => ( ( F2 @ N2 )
                  = ( zero_zero @ A ) ) )
           => ( ( summable @ A
                @ ^ [N3: nat] : ( F2 @ ( G @ N3 ) ) )
              = ( summable @ A @ F2 ) ) ) ) ) ).

% summable_mono_reindex
thf(fact_6397_sums__mono__reindex,axiom,
    ! [A: $tType] :
      ( ( ( comm_monoid_add @ A )
        & ( topolo4958980785337419405_space @ A ) )
     => ! [G: nat > nat,F2: nat > A,C2: A] :
          ( ( order_strict_mono @ nat @ nat @ G )
         => ( ! [N2: nat] :
                ( ~ ( member @ nat @ N2 @ ( image @ nat @ nat @ G @ ( top_top @ ( set @ nat ) ) ) )
               => ( ( F2 @ N2 )
                  = ( zero_zero @ A ) ) )
           => ( ( sums @ A
                @ ^ [N3: nat] : ( F2 @ ( G @ N3 ) )
                @ C2 )
              = ( sums @ A @ F2 @ C2 ) ) ) ) ) ).

% sums_mono_reindex
thf(fact_6398_suminf__mono__reindex,axiom,
    ! [A: $tType] :
      ( ( ( comm_monoid_add @ A )
        & ( topological_t2_space @ A ) )
     => ! [G: nat > nat,F2: nat > A] :
          ( ( order_strict_mono @ nat @ nat @ G )
         => ( ! [N2: nat] :
                ( ~ ( member @ nat @ N2 @ ( image @ nat @ nat @ G @ ( top_top @ ( set @ nat ) ) ) )
               => ( ( F2 @ N2 )
                  = ( zero_zero @ A ) ) )
           => ( ( suminf @ A
                @ ^ [N3: nat] : ( F2 @ ( G @ N3 ) ) )
              = ( suminf @ A @ F2 ) ) ) ) ) ).

% suminf_mono_reindex
thf(fact_6399_power__int__def,axiom,
    ! [A: $tType] :
      ( ( ( inverse @ A )
        & ( power @ A ) )
     => ( ( power_int @ A )
        = ( ^ [X2: A,N3: int] : ( if @ A @ ( ord_less_eq @ int @ ( zero_zero @ int ) @ N3 ) @ ( power_power @ A @ X2 @ ( nat2 @ N3 ) ) @ ( power_power @ A @ ( inverse_inverse @ A @ X2 ) @ ( nat2 @ ( uminus_uminus @ int @ N3 ) ) ) ) ) ) ) ).

% power_int_def
thf(fact_6400_powr__real__of__int_H,axiom,
    ! [X: real,N: int] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( ( X
           != ( zero_zero @ real ) )
          | ( ord_less @ int @ ( zero_zero @ int ) @ N ) )
       => ( ( powr @ real @ X @ ( ring_1_of_int @ real @ N ) )
          = ( power_int @ real @ X @ N ) ) ) ) ).

% powr_real_of_int'
thf(fact_6401_inj__on__char__of__nat,axiom,
    inj_on @ nat @ char @ ( unique5772411509450598832har_of @ nat ) @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( numeral_numeral @ nat @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ).

% inj_on_char_of_nat
thf(fact_6402_suminf__reindex,axiom,
    ! [F2: nat > real,G: nat > nat] :
      ( ( summable @ real @ F2 )
     => ( ( inj_on @ nat @ nat @ G @ ( top_top @ ( set @ nat ) ) )
       => ( ! [X3: nat] : ( ord_less_eq @ real @ ( zero_zero @ real ) @ ( F2 @ X3 ) )
         => ( ! [X3: nat] :
                ( ~ ( member @ nat @ X3 @ ( image @ nat @ nat @ G @ ( top_top @ ( set @ nat ) ) ) )
               => ( ( F2 @ X3 )
                  = ( zero_zero @ real ) ) )
           => ( ( suminf @ real @ ( comp @ nat @ real @ nat @ F2 @ G ) )
              = ( suminf @ real @ F2 ) ) ) ) ) ) ).

% suminf_reindex
thf(fact_6403_increasing__Bseq__subseq__iff,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [F2: nat > A,G: nat > nat] :
          ( ! [X3: nat,Y5: nat] :
              ( ( ord_less_eq @ nat @ X3 @ Y5 )
             => ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ A @ ( F2 @ X3 ) ) @ ( real_V7770717601297561774m_norm @ A @ ( F2 @ Y5 ) ) ) )
         => ( ( order_strict_mono @ nat @ nat @ G )
           => ( ( bfun @ nat @ A
                @ ^ [X2: nat] : ( F2 @ ( G @ X2 ) )
                @ ( at_top @ nat ) )
              = ( bfun @ nat @ A @ F2 @ ( at_top @ nat ) ) ) ) ) ) ).

% increasing_Bseq_subseq_iff
thf(fact_6404_DERIV__power__int,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [F2: A > A,D2: A,X: A,S2: set @ A,N: int] :
          ( ( has_field_derivative @ A @ F2 @ D2 @ ( topolo174197925503356063within @ A @ X @ S2 ) )
         => ( ( ( F2 @ X )
             != ( zero_zero @ A ) )
           => ( has_field_derivative @ A
              @ ^ [X2: A] : ( power_int @ A @ ( F2 @ X2 ) @ N )
              @ ( times_times @ A @ ( times_times @ A @ ( ring_1_of_int @ A @ N ) @ ( power_int @ A @ ( F2 @ X ) @ ( minus_minus @ int @ N @ ( one_one @ int ) ) ) ) @ D2 )
              @ ( topolo174197925503356063within @ A @ X @ S2 ) ) ) ) ) ).

% DERIV_power_int
thf(fact_6405_has__derivative__power__int_H,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [X: A,N: int,S: set @ A] :
          ( ( X
           != ( zero_zero @ A ) )
         => ( has_derivative @ A @ A
            @ ^ [X2: A] : ( power_int @ A @ X2 @ N )
            @ ^ [Y4: A] : ( times_times @ A @ Y4 @ ( times_times @ A @ ( ring_1_of_int @ A @ N ) @ ( power_int @ A @ X @ ( minus_minus @ int @ N @ ( one_one @ int ) ) ) ) )
            @ ( topolo174197925503356063within @ A @ X @ S ) ) ) ) ).

% has_derivative_power_int'
thf(fact_6406_VEBT__internal_Ovalid_H_Oelims_I1_J,axiom,
    ! [X: vEBT_VEBT,Xa: nat,Y: $o] :
      ( ( ( vEBT_VEBT_valid @ X @ Xa )
        = Y )
     => ( ( ? [Uu2: $o,Uv2: $o] :
              ( X
              = ( vEBT_Leaf @ Uu2 @ Uv2 ) )
         => ( Y
            = ( ( Xa
               != ( one_one @ nat ) ) ) ) )
       => ~ ! [Mima: option @ ( product_prod @ nat @ nat ),Deg2: nat,TreeList3: list @ vEBT_VEBT,Summary3: vEBT_VEBT] :
              ( ( X
                = ( vEBT_Node @ Mima @ Deg2 @ TreeList3 @ Summary3 ) )
             => ( Y
                = ( ~ ( ( Deg2 = Xa )
                      & ! [X2: vEBT_VEBT] :
                          ( ( member @ vEBT_VEBT @ X2 @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                         => ( vEBT_VEBT_valid @ X2 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
                      & ( vEBT_VEBT_valid @ Summary3 @ ( minus_minus @ nat @ Deg2 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
                      & ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 )
                        = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ Deg2 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                      & ( case_option @ $o @ ( product_prod @ nat @ nat )
                        @ ( ~ ? [X8: nat] : ( vEBT_V8194947554948674370ptions @ Summary3 @ X8 )
                          & ! [X2: vEBT_VEBT] :
                              ( ( member @ vEBT_VEBT @ X2 @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                             => ~ ? [X8: nat] : ( vEBT_V8194947554948674370ptions @ X2 @ X8 ) ) )
                        @ ( product_case_prod @ nat @ nat @ $o
                          @ ^ [Mi2: nat,Ma2: nat] :
                              ( ( ord_less_eq @ nat @ Mi2 @ Ma2 )
                              & ( ord_less @ nat @ Ma2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg2 ) )
                              & ! [I4: nat] :
                                  ( ( ord_less @ nat @ I4 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ Deg2 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                                 => ( ( ? [X8: nat] : ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList3 @ I4 ) @ X8 ) )
                                    = ( vEBT_V8194947554948674370ptions @ Summary3 @ I4 ) ) )
                              & ( ( Mi2 = Ma2 )
                               => ! [X2: vEBT_VEBT] :
                                    ( ( member @ vEBT_VEBT @ X2 @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                                   => ~ ? [X8: nat] : ( vEBT_V8194947554948674370ptions @ X2 @ X8 ) ) )
                              & ( ( Mi2 != Ma2 )
                               => ( ( vEBT_V5917875025757280293ildren @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ TreeList3 @ Ma2 )
                                  & ! [X2: nat] :
                                      ( ( ord_less @ nat @ X2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg2 ) )
                                     => ( ( vEBT_V5917875025757280293ildren @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ TreeList3 @ X2 )
                                       => ( ( ord_less @ nat @ Mi2 @ X2 )
                                          & ( ord_less_eq @ nat @ X2 @ Ma2 ) ) ) ) ) ) ) )
                        @ Mima ) ) ) ) ) ) ) ).

% VEBT_internal.valid'.elims(1)
thf(fact_6407_VEBT__internal_Ovalid_H_Oelims_I2_J,axiom,
    ! [X: vEBT_VEBT,Xa: nat] :
      ( ( vEBT_VEBT_valid @ X @ Xa )
     => ( ( ? [Uu2: $o,Uv2: $o] :
              ( X
              = ( vEBT_Leaf @ Uu2 @ Uv2 ) )
         => ( Xa
           != ( one_one @ nat ) ) )
       => ~ ! [Mima: option @ ( product_prod @ nat @ nat ),Deg2: nat,TreeList3: list @ vEBT_VEBT,Summary3: vEBT_VEBT] :
              ( ( X
                = ( vEBT_Node @ Mima @ Deg2 @ TreeList3 @ Summary3 ) )
             => ~ ( ( Deg2 = Xa )
                  & ! [X5: vEBT_VEBT] :
                      ( ( member @ vEBT_VEBT @ X5 @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                     => ( vEBT_VEBT_valid @ X5 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
                  & ( vEBT_VEBT_valid @ Summary3 @ ( minus_minus @ nat @ Deg2 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
                  & ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 )
                    = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ Deg2 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                  & ( case_option @ $o @ ( product_prod @ nat @ nat )
                    @ ( ~ ? [X8: nat] : ( vEBT_V8194947554948674370ptions @ Summary3 @ X8 )
                      & ! [X2: vEBT_VEBT] :
                          ( ( member @ vEBT_VEBT @ X2 @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                         => ~ ? [X8: nat] : ( vEBT_V8194947554948674370ptions @ X2 @ X8 ) ) )
                    @ ( product_case_prod @ nat @ nat @ $o
                      @ ^ [Mi2: nat,Ma2: nat] :
                          ( ( ord_less_eq @ nat @ Mi2 @ Ma2 )
                          & ( ord_less @ nat @ Ma2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg2 ) )
                          & ! [I4: nat] :
                              ( ( ord_less @ nat @ I4 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ Deg2 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                             => ( ( ? [X8: nat] : ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList3 @ I4 ) @ X8 ) )
                                = ( vEBT_V8194947554948674370ptions @ Summary3 @ I4 ) ) )
                          & ( ( Mi2 = Ma2 )
                           => ! [X2: vEBT_VEBT] :
                                ( ( member @ vEBT_VEBT @ X2 @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                               => ~ ? [X8: nat] : ( vEBT_V8194947554948674370ptions @ X2 @ X8 ) ) )
                          & ( ( Mi2 != Ma2 )
                           => ( ( vEBT_V5917875025757280293ildren @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ TreeList3 @ Ma2 )
                              & ! [X2: nat] :
                                  ( ( ord_less @ nat @ X2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg2 ) )
                                 => ( ( vEBT_V5917875025757280293ildren @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ TreeList3 @ X2 )
                                   => ( ( ord_less @ nat @ Mi2 @ X2 )
                                      & ( ord_less_eq @ nat @ X2 @ Ma2 ) ) ) ) ) ) ) )
                    @ Mima ) ) ) ) ) ).

% VEBT_internal.valid'.elims(2)
thf(fact_6408_Ball__def__raw,axiom,
    ! [A: $tType] :
      ( ( ball @ A )
      = ( ^ [A7: set @ A,P3: A > $o] :
          ! [X2: A] :
            ( ( member @ A @ X2 @ A7 )
           => ( P3 @ X2 ) ) ) ) ).

% Ball_def_raw
thf(fact_6409_open__subdiagonal,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ( topolo1002775350975398744n_open @ ( product_prod @ A @ A )
        @ ( collect @ ( product_prod @ A @ A )
          @ ^ [Uu3: product_prod @ A @ A] :
            ? [X2: A,Y4: A] :
              ( ( Uu3
                = ( product_Pair @ A @ A @ X2 @ Y4 ) )
              & ( ord_less @ A @ X2 @ Y4 ) ) ) ) ) ).

% open_subdiagonal
thf(fact_6410_open__superdiagonal,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ( topolo1002775350975398744n_open @ ( product_prod @ A @ A )
        @ ( collect @ ( product_prod @ A @ A )
          @ ^ [Uu3: product_prod @ A @ A] :
            ? [X2: A,Y4: A] :
              ( ( Uu3
                = ( product_Pair @ A @ A @ X2 @ Y4 ) )
              & ( ord_less @ A @ Y4 @ X2 ) ) ) ) ) ).

% open_superdiagonal
thf(fact_6411_Sup__eq__Inf,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ( ( complete_Sup_Sup @ A )
        = ( ^ [A7: set @ A] :
              ( complete_Inf_Inf @ A
              @ ( collect @ A
                @ ^ [B3: A] :
                  ! [X2: A] :
                    ( ( member @ A @ X2 @ A7 )
                   => ( ord_less_eq @ A @ X2 @ B3 ) ) ) ) ) ) ) ).

% Sup_eq_Inf
thf(fact_6412_Inf__eq__Sup,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ( ( complete_Inf_Inf @ A )
        = ( ^ [A7: set @ A] :
              ( complete_Sup_Sup @ A
              @ ( collect @ A
                @ ^ [B3: A] :
                  ! [X2: A] :
                    ( ( member @ A @ X2 @ A7 )
                   => ( ord_less_eq @ A @ B3 @ X2 ) ) ) ) ) ) ) ).

% Inf_eq_Sup
thf(fact_6413_set__conv__nth,axiom,
    ! [A: $tType] :
      ( ( set2 @ A )
      = ( ^ [Xs3: list @ A] :
            ( collect @ A
            @ ^ [Uu3: A] :
              ? [I4: nat] :
                ( ( Uu3
                  = ( nth @ A @ Xs3 @ I4 ) )
                & ( ord_less @ nat @ I4 @ ( size_size @ ( list @ A ) @ Xs3 ) ) ) ) ) ) ).

% set_conv_nth
thf(fact_6414_VEBT__internal_Ovalid_H_Osimps_I2_J,axiom,
    ! [Mima2: option @ ( product_prod @ nat @ nat ),Deg: nat,TreeList2: list @ vEBT_VEBT,Summary: vEBT_VEBT,Deg3: nat] :
      ( ( vEBT_VEBT_valid @ ( vEBT_Node @ Mima2 @ Deg @ TreeList2 @ Summary ) @ Deg3 )
      = ( ( Deg = Deg3 )
        & ! [X2: vEBT_VEBT] :
            ( ( member @ vEBT_VEBT @ X2 @ ( set2 @ vEBT_VEBT @ TreeList2 ) )
           => ( vEBT_VEBT_valid @ X2 @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
        & ( vEBT_VEBT_valid @ Summary @ ( minus_minus @ nat @ Deg @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
        & ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList2 )
          = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ Deg @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
        & ( case_option @ $o @ ( product_prod @ nat @ nat )
          @ ( ~ ? [X8: nat] : ( vEBT_V8194947554948674370ptions @ Summary @ X8 )
            & ! [X2: vEBT_VEBT] :
                ( ( member @ vEBT_VEBT @ X2 @ ( set2 @ vEBT_VEBT @ TreeList2 ) )
               => ~ ? [X8: nat] : ( vEBT_V8194947554948674370ptions @ X2 @ X8 ) ) )
          @ ( product_case_prod @ nat @ nat @ $o
            @ ^ [Mi2: nat,Ma2: nat] :
                ( ( ord_less_eq @ nat @ Mi2 @ Ma2 )
                & ( ord_less @ nat @ Ma2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg ) )
                & ! [I4: nat] :
                    ( ( ord_less @ nat @ I4 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ Deg @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                   => ( ( ? [X8: nat] : ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList2 @ I4 ) @ X8 ) )
                      = ( vEBT_V8194947554948674370ptions @ Summary @ I4 ) ) )
                & ( ( Mi2 = Ma2 )
                 => ! [X2: vEBT_VEBT] :
                      ( ( member @ vEBT_VEBT @ X2 @ ( set2 @ vEBT_VEBT @ TreeList2 ) )
                     => ~ ? [X8: nat] : ( vEBT_V8194947554948674370ptions @ X2 @ X8 ) ) )
                & ( ( Mi2 != Ma2 )
                 => ( ( vEBT_V5917875025757280293ildren @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ TreeList2 @ Ma2 )
                    & ! [X2: nat] :
                        ( ( ord_less @ nat @ X2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg ) )
                       => ( ( vEBT_V5917875025757280293ildren @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ TreeList2 @ X2 )
                         => ( ( ord_less @ nat @ Mi2 @ X2 )
                            & ( ord_less_eq @ nat @ X2 @ Ma2 ) ) ) ) ) ) ) )
          @ Mima2 ) ) ) ).

% VEBT_internal.valid'.simps(2)
thf(fact_6415_funpow__inj__finite,axiom,
    ! [A: $tType,P6: A > A,X: A] :
      ( ( inj_on @ A @ A @ P6 @ ( top_top @ ( set @ A ) ) )
     => ( ( finite_finite @ A
          @ ( collect @ A
            @ ^ [Y4: A] :
              ? [N3: nat] :
                ( Y4
                = ( compow @ ( A > A ) @ N3 @ P6 @ X ) ) ) )
       => ~ ! [N2: nat] :
              ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N2 )
             => ( ( compow @ ( A > A ) @ N2 @ P6 @ X )
               != X ) ) ) ) ).

% funpow_inj_finite
thf(fact_6416_pos__deriv__imp__strict__mono,axiom,
    ! [F2: real > real,F5: real > real] :
      ( ! [X3: real] : ( has_field_derivative @ real @ F2 @ ( F5 @ X3 ) @ ( topolo174197925503356063within @ real @ X3 @ ( top_top @ ( set @ real ) ) ) )
     => ( ! [X3: real] : ( ord_less @ real @ ( zero_zero @ real ) @ ( F5 @ X3 ) )
       => ( order_strict_mono @ real @ real @ F2 ) ) ) ).

% pos_deriv_imp_strict_mono
thf(fact_6417_VEBT__internal_Ovalid_H_Oelims_I3_J,axiom,
    ! [X: vEBT_VEBT,Xa: nat] :
      ( ~ ( vEBT_VEBT_valid @ X @ Xa )
     => ( ( ? [Uu2: $o,Uv2: $o] :
              ( X
              = ( vEBT_Leaf @ Uu2 @ Uv2 ) )
         => ( Xa
            = ( one_one @ nat ) ) )
       => ~ ! [Mima: option @ ( product_prod @ nat @ nat ),Deg2: nat,TreeList3: list @ vEBT_VEBT,Summary3: vEBT_VEBT] :
              ( ( X
                = ( vEBT_Node @ Mima @ Deg2 @ TreeList3 @ Summary3 ) )
             => ( ( Deg2 = Xa )
                & ! [X3: vEBT_VEBT] :
                    ( ( member @ vEBT_VEBT @ X3 @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                   => ( vEBT_VEBT_valid @ X3 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
                & ( vEBT_VEBT_valid @ Summary3 @ ( minus_minus @ nat @ Deg2 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
                & ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 )
                  = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ Deg2 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                & ( case_option @ $o @ ( product_prod @ nat @ nat )
                  @ ( ~ ? [X8: nat] : ( vEBT_V8194947554948674370ptions @ Summary3 @ X8 )
                    & ! [X2: vEBT_VEBT] :
                        ( ( member @ vEBT_VEBT @ X2 @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                       => ~ ? [X8: nat] : ( vEBT_V8194947554948674370ptions @ X2 @ X8 ) ) )
                  @ ( product_case_prod @ nat @ nat @ $o
                    @ ^ [Mi2: nat,Ma2: nat] :
                        ( ( ord_less_eq @ nat @ Mi2 @ Ma2 )
                        & ( ord_less @ nat @ Ma2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg2 ) )
                        & ! [I4: nat] :
                            ( ( ord_less @ nat @ I4 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ Deg2 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                           => ( ( ? [X8: nat] : ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList3 @ I4 ) @ X8 ) )
                              = ( vEBT_V8194947554948674370ptions @ Summary3 @ I4 ) ) )
                        & ( ( Mi2 = Ma2 )
                         => ! [X2: vEBT_VEBT] :
                              ( ( member @ vEBT_VEBT @ X2 @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                             => ~ ? [X8: nat] : ( vEBT_V8194947554948674370ptions @ X2 @ X8 ) ) )
                        & ( ( Mi2 != Ma2 )
                         => ( ( vEBT_V5917875025757280293ildren @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ TreeList3 @ Ma2 )
                            & ! [X2: nat] :
                                ( ( ord_less @ nat @ X2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg2 ) )
                               => ( ( vEBT_V5917875025757280293ildren @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ TreeList3 @ X2 )
                                 => ( ( ord_less @ nat @ Mi2 @ X2 )
                                    & ( ord_less_eq @ nat @ X2 @ Ma2 ) ) ) ) ) ) ) )
                  @ Mima ) ) ) ) ) ).

% VEBT_internal.valid'.elims(3)
thf(fact_6418_VEBT__internal_Ovalid_H_Opelims_I3_J,axiom,
    ! [X: vEBT_VEBT,Xa: nat] :
      ( ~ ( vEBT_VEBT_valid @ X @ Xa )
     => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_VEBT_valid_rel @ ( product_Pair @ vEBT_VEBT @ nat @ X @ Xa ) )
       => ( ! [Uu2: $o,Uv2: $o] :
              ( ( X
                = ( vEBT_Leaf @ Uu2 @ Uv2 ) )
             => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_VEBT_valid_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Leaf @ Uu2 @ Uv2 ) @ Xa ) )
               => ( Xa
                  = ( one_one @ nat ) ) ) )
         => ~ ! [Mima: option @ ( product_prod @ nat @ nat ),Deg2: nat,TreeList3: list @ vEBT_VEBT,Summary3: vEBT_VEBT] :
                ( ( X
                  = ( vEBT_Node @ Mima @ Deg2 @ TreeList3 @ Summary3 ) )
               => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_VEBT_valid_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ Mima @ Deg2 @ TreeList3 @ Summary3 ) @ Xa ) )
                 => ( ( Deg2 = Xa )
                    & ! [X3: vEBT_VEBT] :
                        ( ( member @ vEBT_VEBT @ X3 @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                       => ( vEBT_VEBT_valid @ X3 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
                    & ( vEBT_VEBT_valid @ Summary3 @ ( minus_minus @ nat @ Deg2 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
                    & ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 )
                      = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ Deg2 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                    & ( case_option @ $o @ ( product_prod @ nat @ nat )
                      @ ( ~ ? [X8: nat] : ( vEBT_V8194947554948674370ptions @ Summary3 @ X8 )
                        & ! [X2: vEBT_VEBT] :
                            ( ( member @ vEBT_VEBT @ X2 @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                           => ~ ? [X8: nat] : ( vEBT_V8194947554948674370ptions @ X2 @ X8 ) ) )
                      @ ( product_case_prod @ nat @ nat @ $o
                        @ ^ [Mi2: nat,Ma2: nat] :
                            ( ( ord_less_eq @ nat @ Mi2 @ Ma2 )
                            & ( ord_less @ nat @ Ma2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg2 ) )
                            & ! [I4: nat] :
                                ( ( ord_less @ nat @ I4 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ Deg2 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                               => ( ( ? [X8: nat] : ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList3 @ I4 ) @ X8 ) )
                                  = ( vEBT_V8194947554948674370ptions @ Summary3 @ I4 ) ) )
                            & ( ( Mi2 = Ma2 )
                             => ! [X2: vEBT_VEBT] :
                                  ( ( member @ vEBT_VEBT @ X2 @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                                 => ~ ? [X8: nat] : ( vEBT_V8194947554948674370ptions @ X2 @ X8 ) ) )
                            & ( ( Mi2 != Ma2 )
                             => ( ( vEBT_V5917875025757280293ildren @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ TreeList3 @ Ma2 )
                                & ! [X2: nat] :
                                    ( ( ord_less @ nat @ X2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg2 ) )
                                   => ( ( vEBT_V5917875025757280293ildren @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ TreeList3 @ X2 )
                                     => ( ( ord_less @ nat @ Mi2 @ X2 )
                                        & ( ord_less_eq @ nat @ X2 @ Ma2 ) ) ) ) ) ) ) )
                      @ Mima ) ) ) ) ) ) ) ).

% VEBT_internal.valid'.pelims(3)
thf(fact_6419_VEBT__internal_Ovalid_H_Opelims_I2_J,axiom,
    ! [X: vEBT_VEBT,Xa: nat] :
      ( ( vEBT_VEBT_valid @ X @ Xa )
     => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_VEBT_valid_rel @ ( product_Pair @ vEBT_VEBT @ nat @ X @ Xa ) )
       => ( ! [Uu2: $o,Uv2: $o] :
              ( ( X
                = ( vEBT_Leaf @ Uu2 @ Uv2 ) )
             => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_VEBT_valid_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Leaf @ Uu2 @ Uv2 ) @ Xa ) )
               => ( Xa
                 != ( one_one @ nat ) ) ) )
         => ~ ! [Mima: option @ ( product_prod @ nat @ nat ),Deg2: nat,TreeList3: list @ vEBT_VEBT,Summary3: vEBT_VEBT] :
                ( ( X
                  = ( vEBT_Node @ Mima @ Deg2 @ TreeList3 @ Summary3 ) )
               => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_VEBT_valid_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ Mima @ Deg2 @ TreeList3 @ Summary3 ) @ Xa ) )
                 => ~ ( ( Deg2 = Xa )
                      & ! [X5: vEBT_VEBT] :
                          ( ( member @ vEBT_VEBT @ X5 @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                         => ( vEBT_VEBT_valid @ X5 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
                      & ( vEBT_VEBT_valid @ Summary3 @ ( minus_minus @ nat @ Deg2 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
                      & ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 )
                        = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ Deg2 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                      & ( case_option @ $o @ ( product_prod @ nat @ nat )
                        @ ( ~ ? [X8: nat] : ( vEBT_V8194947554948674370ptions @ Summary3 @ X8 )
                          & ! [X2: vEBT_VEBT] :
                              ( ( member @ vEBT_VEBT @ X2 @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                             => ~ ? [X8: nat] : ( vEBT_V8194947554948674370ptions @ X2 @ X8 ) ) )
                        @ ( product_case_prod @ nat @ nat @ $o
                          @ ^ [Mi2: nat,Ma2: nat] :
                              ( ( ord_less_eq @ nat @ Mi2 @ Ma2 )
                              & ( ord_less @ nat @ Ma2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg2 ) )
                              & ! [I4: nat] :
                                  ( ( ord_less @ nat @ I4 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ Deg2 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                                 => ( ( ? [X8: nat] : ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList3 @ I4 ) @ X8 ) )
                                    = ( vEBT_V8194947554948674370ptions @ Summary3 @ I4 ) ) )
                              & ( ( Mi2 = Ma2 )
                               => ! [X2: vEBT_VEBT] :
                                    ( ( member @ vEBT_VEBT @ X2 @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                                   => ~ ? [X8: nat] : ( vEBT_V8194947554948674370ptions @ X2 @ X8 ) ) )
                              & ( ( Mi2 != Ma2 )
                               => ( ( vEBT_V5917875025757280293ildren @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ TreeList3 @ Ma2 )
                                  & ! [X2: nat] :
                                      ( ( ord_less @ nat @ X2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg2 ) )
                                     => ( ( vEBT_V5917875025757280293ildren @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ TreeList3 @ X2 )
                                       => ( ( ord_less @ nat @ Mi2 @ X2 )
                                          & ( ord_less_eq @ nat @ X2 @ Ma2 ) ) ) ) ) ) ) )
                        @ Mima ) ) ) ) ) ) ) ).

% VEBT_internal.valid'.pelims(2)
thf(fact_6420_Sup__Inf__le,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A4: set @ ( set @ A )] :
          ( ord_less_eq @ A
          @ ( complete_Sup_Sup @ A
            @ ( image @ ( set @ A ) @ A @ ( complete_Inf_Inf @ A )
              @ ( collect @ ( set @ A )
                @ ^ [Uu3: set @ A] :
                  ? [F3: ( set @ A ) > A] :
                    ( ( Uu3
                      = ( image @ ( set @ A ) @ A @ F3 @ A4 ) )
                    & ! [X2: set @ A] :
                        ( ( member @ ( set @ A ) @ X2 @ A4 )
                       => ( member @ A @ ( F3 @ X2 ) @ X2 ) ) ) ) ) )
          @ ( complete_Inf_Inf @ A @ ( image @ ( set @ A ) @ A @ ( complete_Sup_Sup @ A ) @ A4 ) ) ) ) ).

% Sup_Inf_le
thf(fact_6421_Inf__Sup__le,axiom,
    ! [A: $tType] :
      ( ( comple592849572758109894attice @ A )
     => ! [A4: set @ ( set @ A )] :
          ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ ( image @ ( set @ A ) @ A @ ( complete_Sup_Sup @ A ) @ A4 ) )
          @ ( complete_Sup_Sup @ A
            @ ( image @ ( set @ A ) @ A @ ( complete_Inf_Inf @ A )
              @ ( collect @ ( set @ A )
                @ ^ [Uu3: set @ A] :
                  ? [F3: ( set @ A ) > A] :
                    ( ( Uu3
                      = ( image @ ( set @ A ) @ A @ F3 @ A4 ) )
                    & ! [X2: set @ A] :
                        ( ( member @ ( set @ A ) @ X2 @ A4 )
                       => ( member @ A @ ( F3 @ X2 ) @ X2 ) ) ) ) ) ) ) ) ).

% Inf_Sup_le
thf(fact_6422_Nats__altdef1,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ( ( semiring_1_Nats @ A )
        = ( collect @ A
          @ ^ [Uu3: A] :
            ? [N3: int] :
              ( ( Uu3
                = ( ring_1_of_int @ A @ N3 ) )
              & ( ord_less_eq @ int @ ( zero_zero @ int ) @ N3 ) ) ) ) ) ).

% Nats_altdef1
thf(fact_6423_Sup__int__def,axiom,
    ( ( complete_Sup_Sup @ int )
    = ( ^ [X8: set @ int] :
          ( the @ int
          @ ^ [X2: int] :
              ( ( member @ int @ X2 @ X8 )
              & ! [Y4: int] :
                  ( ( member @ int @ Y4 @ X8 )
                 => ( ord_less_eq @ int @ Y4 @ X2 ) ) ) ) ) ) ).

% Sup_int_def
thf(fact_6424_VEBT__internal_Ovalid_H_Opelims_I1_J,axiom,
    ! [X: vEBT_VEBT,Xa: nat,Y: $o] :
      ( ( ( vEBT_VEBT_valid @ X @ Xa )
        = Y )
     => ( ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_VEBT_valid_rel @ ( product_Pair @ vEBT_VEBT @ nat @ X @ Xa ) )
       => ( ! [Uu2: $o,Uv2: $o] :
              ( ( X
                = ( vEBT_Leaf @ Uu2 @ Uv2 ) )
             => ( ( Y
                  = ( Xa
                    = ( one_one @ nat ) ) )
               => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_VEBT_valid_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Leaf @ Uu2 @ Uv2 ) @ Xa ) ) ) )
         => ~ ! [Mima: option @ ( product_prod @ nat @ nat ),Deg2: nat,TreeList3: list @ vEBT_VEBT,Summary3: vEBT_VEBT] :
                ( ( X
                  = ( vEBT_Node @ Mima @ Deg2 @ TreeList3 @ Summary3 ) )
               => ( ( Y
                    = ( ( Deg2 = Xa )
                      & ! [X2: vEBT_VEBT] :
                          ( ( member @ vEBT_VEBT @ X2 @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                         => ( vEBT_VEBT_valid @ X2 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
                      & ( vEBT_VEBT_valid @ Summary3 @ ( minus_minus @ nat @ Deg2 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
                      & ( ( size_size @ ( list @ vEBT_VEBT ) @ TreeList3 )
                        = ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ Deg2 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                      & ( case_option @ $o @ ( product_prod @ nat @ nat )
                        @ ( ~ ? [X8: nat] : ( vEBT_V8194947554948674370ptions @ Summary3 @ X8 )
                          & ! [X2: vEBT_VEBT] :
                              ( ( member @ vEBT_VEBT @ X2 @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                             => ~ ? [X8: nat] : ( vEBT_V8194947554948674370ptions @ X2 @ X8 ) ) )
                        @ ( product_case_prod @ nat @ nat @ $o
                          @ ^ [Mi2: nat,Ma2: nat] :
                              ( ( ord_less_eq @ nat @ Mi2 @ Ma2 )
                              & ( ord_less @ nat @ Ma2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg2 ) )
                              & ! [I4: nat] :
                                  ( ( ord_less @ nat @ I4 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ Deg2 @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                                 => ( ( ? [X8: nat] : ( vEBT_V8194947554948674370ptions @ ( nth @ vEBT_VEBT @ TreeList3 @ I4 ) @ X8 ) )
                                    = ( vEBT_V8194947554948674370ptions @ Summary3 @ I4 ) ) )
                              & ( ( Mi2 = Ma2 )
                               => ! [X2: vEBT_VEBT] :
                                    ( ( member @ vEBT_VEBT @ X2 @ ( set2 @ vEBT_VEBT @ TreeList3 ) )
                                   => ~ ? [X8: nat] : ( vEBT_V8194947554948674370ptions @ X2 @ X8 ) ) )
                              & ( ( Mi2 != Ma2 )
                               => ( ( vEBT_V5917875025757280293ildren @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ TreeList3 @ Ma2 )
                                  & ! [X2: nat] :
                                      ( ( ord_less @ nat @ X2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ Deg2 ) )
                                     => ( ( vEBT_V5917875025757280293ildren @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) @ TreeList3 @ X2 )
                                       => ( ( ord_less @ nat @ Mi2 @ X2 )
                                          & ( ord_less_eq @ nat @ X2 @ Ma2 ) ) ) ) ) ) ) )
                        @ Mima ) ) )
                 => ~ ( accp @ ( product_prod @ vEBT_VEBT @ nat ) @ vEBT_VEBT_valid_rel @ ( product_Pair @ vEBT_VEBT @ nat @ ( vEBT_Node @ Mima @ Deg2 @ TreeList3 @ Summary3 ) @ Xa ) ) ) ) ) ) ) ).

% VEBT_internal.valid'.pelims(1)
thf(fact_6425_finite__Inf__Sup,axiom,
    ! [A: $tType] :
      ( ( finite8700451911770168679attice @ A )
     => ! [A4: set @ ( set @ A )] :
          ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ ( image @ ( set @ A ) @ A @ ( complete_Sup_Sup @ A ) @ A4 ) )
          @ ( complete_Sup_Sup @ A
            @ ( image @ ( set @ A ) @ A @ ( complete_Inf_Inf @ A )
              @ ( collect @ ( set @ A )
                @ ^ [Uu3: set @ A] :
                  ? [F3: ( set @ A ) > A] :
                    ( ( Uu3
                      = ( image @ ( set @ A ) @ A @ F3 @ A4 ) )
                    & ! [X2: set @ A] :
                        ( ( member @ ( set @ A ) @ X2 @ A4 )
                       => ( member @ A @ ( F3 @ X2 ) @ X2 ) ) ) ) ) ) ) ) ).

% finite_Inf_Sup
thf(fact_6426_set__zip,axiom,
    ! [B: $tType,A: $tType,Xs: list @ A,Ys3: list @ B] :
      ( ( set2 @ ( product_prod @ A @ B ) @ ( zip @ A @ B @ Xs @ Ys3 ) )
      = ( collect @ ( product_prod @ A @ B )
        @ ^ [Uu3: product_prod @ A @ B] :
          ? [I4: nat] :
            ( ( Uu3
              = ( product_Pair @ A @ B @ ( nth @ A @ Xs @ I4 ) @ ( nth @ B @ Ys3 @ I4 ) ) )
            & ( ord_less @ nat @ I4 @ ( ord_min @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ ( size_size @ ( list @ B ) @ Ys3 ) ) ) ) ) ) ).

% set_zip
thf(fact_6427_nth__zip,axiom,
    ! [A: $tType,B: $tType,I: nat,Xs: list @ A,Ys3: list @ B] :
      ( ( ord_less @ nat @ I @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( ( ord_less @ nat @ I @ ( size_size @ ( list @ B ) @ Ys3 ) )
       => ( ( nth @ ( product_prod @ A @ B ) @ ( zip @ A @ B @ Xs @ Ys3 ) @ I )
          = ( product_Pair @ A @ B @ ( nth @ A @ Xs @ I ) @ ( nth @ B @ Ys3 @ I ) ) ) ) ) ).

% nth_zip
thf(fact_6428_in__set__zip,axiom,
    ! [B: $tType,A: $tType,P6: product_prod @ A @ B,Xs: list @ A,Ys3: list @ B] :
      ( ( member @ ( product_prod @ A @ B ) @ P6 @ ( set2 @ ( product_prod @ A @ B ) @ ( zip @ A @ B @ Xs @ Ys3 ) ) )
      = ( ? [N3: nat] :
            ( ( ( nth @ A @ Xs @ N3 )
              = ( product_fst @ A @ B @ P6 ) )
            & ( ( nth @ B @ Ys3 @ N3 )
              = ( product_snd @ A @ B @ P6 ) )
            & ( ord_less @ nat @ N3 @ ( size_size @ ( list @ A ) @ Xs ) )
            & ( ord_less @ nat @ N3 @ ( size_size @ ( list @ B ) @ Ys3 ) ) ) ) ) ).

% in_set_zip
thf(fact_6429_mlex__eq,axiom,
    ! [A: $tType] :
      ( ( mlex_prod @ A )
      = ( ^ [F3: A > nat,R6: set @ ( product_prod @ A @ A )] :
            ( collect @ ( product_prod @ A @ A )
            @ ( product_case_prod @ A @ A @ $o
              @ ^ [X2: A,Y4: A] :
                  ( ( ord_less @ nat @ ( F3 @ X2 ) @ ( F3 @ Y4 ) )
                  | ( ( ord_less_eq @ nat @ ( F3 @ X2 ) @ ( F3 @ Y4 ) )
                    & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X2 @ Y4 ) @ R6 ) ) ) ) ) ) ) ).

% mlex_eq
thf(fact_6430_Rats__eq__int__div__nat,axiom,
    ( ( field_char_0_Rats @ real )
    = ( collect @ real
      @ ^ [Uu3: real] :
        ? [I4: int,N3: nat] :
          ( ( Uu3
            = ( divide_divide @ real @ ( ring_1_of_int @ real @ I4 ) @ ( semiring_1_of_nat @ real @ N3 ) ) )
          & ( N3
           != ( zero_zero @ nat ) ) ) ) ) ).

% Rats_eq_int_div_nat
thf(fact_6431_Rats__abs__iff,axiom,
    ! [X: real] :
      ( ( member @ real @ ( abs_abs @ real @ X ) @ ( field_char_0_Rats @ real ) )
      = ( member @ real @ X @ ( field_char_0_Rats @ real ) ) ) ).

% Rats_abs_iff
thf(fact_6432_Rats__no__top__le,axiom,
    ! [X: real] :
    ? [X3: real] :
      ( ( member @ real @ X3 @ ( field_char_0_Rats @ real ) )
      & ( ord_less_eq @ real @ X @ X3 ) ) ).

% Rats_no_top_le
thf(fact_6433_Rats__power,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: A,N: nat] :
          ( ( member @ A @ A2 @ ( field_char_0_Rats @ A ) )
         => ( member @ A @ ( power_power @ A @ A2 @ N ) @ ( field_char_0_Rats @ A ) ) ) ) ).

% Rats_power
thf(fact_6434_Rats__of__nat,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [N: nat] : ( member @ A @ ( semiring_1_of_nat @ A @ N ) @ ( field_char_0_Rats @ A ) ) ) ).

% Rats_of_nat
thf(fact_6435_Rats__dense__in__real,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less @ real @ X @ Y )
     => ? [X3: real] :
          ( ( member @ real @ X3 @ ( field_char_0_Rats @ real ) )
          & ( ord_less @ real @ X @ X3 )
          & ( ord_less @ real @ X3 @ Y ) ) ) ).

% Rats_dense_in_real
thf(fact_6436_Rats__no__bot__less,axiom,
    ! [X: real] :
    ? [X3: real] :
      ( ( member @ real @ X3 @ ( field_char_0_Rats @ real ) )
      & ( ord_less @ real @ X3 @ X ) ) ).

% Rats_no_bot_less
thf(fact_6437_Rats__0,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ( member @ A @ ( zero_zero @ A ) @ ( field_char_0_Rats @ A ) ) ) ).

% Rats_0
thf(fact_6438_Rats__number__of,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [W: num] : ( member @ A @ ( numeral_numeral @ A @ W ) @ ( field_char_0_Rats @ A ) ) ) ).

% Rats_number_of
thf(fact_6439_Rats__eq__int__div__int,axiom,
    ( ( field_char_0_Rats @ real )
    = ( collect @ real
      @ ^ [Uu3: real] :
        ? [I4: int,J3: int] :
          ( ( Uu3
            = ( divide_divide @ real @ ( ring_1_of_int @ real @ I4 ) @ ( ring_1_of_int @ real @ J3 ) ) )
          & ( J3
           != ( zero_zero @ int ) ) ) ) ) ).

% Rats_eq_int_div_int
thf(fact_6440_mlex__leq,axiom,
    ! [A: $tType,F2: A > nat,X: A,Y: A,R4: set @ ( product_prod @ A @ A )] :
      ( ( ord_less_eq @ nat @ ( F2 @ X ) @ ( F2 @ Y ) )
     => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y ) @ R4 )
       => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y ) @ ( mlex_prod @ A @ F2 @ R4 ) ) ) ) ).

% mlex_leq
thf(fact_6441_mlex__iff,axiom,
    ! [A: $tType,X: A,Y: A,F2: A > nat,R4: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y ) @ ( mlex_prod @ A @ F2 @ R4 ) )
      = ( ( ord_less @ nat @ ( F2 @ X ) @ ( F2 @ Y ) )
        | ( ( ( F2 @ X )
            = ( F2 @ Y ) )
          & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y ) @ R4 ) ) ) ) ).

% mlex_iff
thf(fact_6442_mlex__less,axiom,
    ! [A: $tType,F2: A > nat,X: A,Y: A,R4: set @ ( product_prod @ A @ A )] :
      ( ( ord_less @ nat @ ( F2 @ X ) @ ( F2 @ Y ) )
     => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y ) @ ( mlex_prod @ A @ F2 @ R4 ) ) ) ).

% mlex_less
thf(fact_6443_in__measure,axiom,
    ! [A: $tType,X: A,Y: A,F2: A > nat] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y ) @ ( measure @ A @ F2 ) )
      = ( ord_less @ nat @ ( F2 @ X ) @ ( F2 @ Y ) ) ) ).

% in_measure
thf(fact_6444_set__nths,axiom,
    ! [A: $tType,Xs: list @ A,I5: set @ nat] :
      ( ( set2 @ A @ ( nths @ A @ Xs @ I5 ) )
      = ( collect @ A
        @ ^ [Uu3: A] :
          ? [I4: nat] :
            ( ( Uu3
              = ( nth @ A @ Xs @ I4 ) )
            & ( ord_less @ nat @ I4 @ ( size_size @ ( list @ A ) @ Xs ) )
            & ( member @ nat @ I4 @ I5 ) ) ) ) ).

% set_nths
thf(fact_6445_nths__all,axiom,
    ! [A: $tType,Xs: list @ A,I5: set @ nat] :
      ( ! [I2: nat] :
          ( ( ord_less @ nat @ I2 @ ( size_size @ ( list @ A ) @ Xs ) )
         => ( member @ nat @ I2 @ I5 ) )
     => ( ( nths @ A @ Xs @ I5 )
        = Xs ) ) ).

% nths_all
thf(fact_6446_length__nths,axiom,
    ! [A: $tType,Xs: list @ A,I5: set @ nat] :
      ( ( size_size @ ( list @ A ) @ ( nths @ A @ Xs @ I5 ) )
      = ( finite_card @ nat
        @ ( collect @ nat
          @ ^ [I4: nat] :
              ( ( ord_less @ nat @ I4 @ ( size_size @ ( list @ A ) @ Xs ) )
              & ( member @ nat @ I4 @ I5 ) ) ) ) ) ).

% length_nths
thf(fact_6447_nth__sorted__list__of__set__greaterThanAtMost,axiom,
    ! [N: nat,J: nat,I: nat] :
      ( ( ord_less @ nat @ N @ ( minus_minus @ nat @ J @ I ) )
     => ( ( nth @ nat @ ( linord4507533701916653071of_set @ nat @ ( set_or3652927894154168847AtMost @ nat @ I @ J ) ) @ N )
        = ( suc @ ( plus_plus @ nat @ I @ N ) ) ) ) ).

% nth_sorted_list_of_set_greaterThanAtMost
thf(fact_6448_sum__list__update,axiom,
    ! [A: $tType] :
      ( ( ordere1170586879665033532d_diff @ A )
     => ! [K: nat,Xs: list @ A,X: A] :
          ( ( ord_less @ nat @ K @ ( size_size @ ( list @ A ) @ Xs ) )
         => ( ( groups8242544230860333062m_list @ A @ ( list_update @ A @ Xs @ K @ X ) )
            = ( minus_minus @ A @ ( plus_plus @ A @ ( groups8242544230860333062m_list @ A @ Xs ) @ X ) @ ( nth @ A @ Xs @ K ) ) ) ) ) ).

% sum_list_update
thf(fact_6449_sum__list__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ! [Ns: list @ A] :
          ( ( ( groups8242544230860333062m_list @ A @ Ns )
            = ( zero_zero @ A ) )
          = ( ! [X2: A] :
                ( ( member @ A @ X2 @ ( set2 @ A @ Ns ) )
               => ( X2
                  = ( zero_zero @ A ) ) ) ) ) ) ).

% sum_list_eq_0_iff
thf(fact_6450_member__le__sum__list,axiom,
    ! [A: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ! [X: A,Xs: list @ A] :
          ( ( member @ A @ X @ ( set2 @ A @ Xs ) )
         => ( ord_less_eq @ A @ X @ ( groups8242544230860333062m_list @ A @ Xs ) ) ) ) ).

% member_le_sum_list
thf(fact_6451_sum__list__nonpos,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [Xs: list @ A] :
          ( ! [X3: A] :
              ( ( member @ A @ X3 @ ( set2 @ A @ Xs ) )
             => ( ord_less_eq @ A @ X3 @ ( zero_zero @ A ) ) )
         => ( ord_less_eq @ A @ ( groups8242544230860333062m_list @ A @ Xs ) @ ( zero_zero @ A ) ) ) ) ).

% sum_list_nonpos
thf(fact_6452_sum__list__nonneg__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [Xs: list @ A] :
          ( ! [X3: A] :
              ( ( member @ A @ X3 @ ( set2 @ A @ Xs ) )
             => ( ord_less_eq @ A @ ( zero_zero @ A ) @ X3 ) )
         => ( ( ( groups8242544230860333062m_list @ A @ Xs )
              = ( zero_zero @ A ) )
            = ( ! [X2: A] :
                  ( ( member @ A @ X2 @ ( set2 @ A @ Xs ) )
                 => ( X2
                    = ( zero_zero @ A ) ) ) ) ) ) ) ).

% sum_list_nonneg_eq_0_iff
thf(fact_6453_Groups__List_Osum__list__nonneg,axiom,
    ! [A: $tType] :
      ( ( ordere6911136660526730532id_add @ A )
     => ! [Xs: list @ A] :
          ( ! [X3: A] :
              ( ( member @ A @ X3 @ ( set2 @ A @ Xs ) )
             => ( ord_less_eq @ A @ ( zero_zero @ A ) @ X3 ) )
         => ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( groups8242544230860333062m_list @ A @ Xs ) ) ) ) ).

% Groups_List.sum_list_nonneg
thf(fact_6454_sum__list__replicate,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [N: nat,C2: A] :
          ( ( groups8242544230860333062m_list @ A @ ( replicate @ A @ N @ C2 ) )
          = ( times_times @ A @ ( semiring_1_of_nat @ A @ N ) @ C2 ) ) ) ).

% sum_list_replicate
thf(fact_6455_elem__le__sum__list,axiom,
    ! [A: $tType] :
      ( ( canoni5634975068530333245id_add @ A )
     => ! [K: nat,Ns: list @ A] :
          ( ( ord_less @ nat @ K @ ( size_size @ ( list @ A ) @ Ns ) )
         => ( ord_less_eq @ A @ ( nth @ A @ Ns @ K ) @ ( groups8242544230860333062m_list @ A @ Ns ) ) ) ) ).

% elem_le_sum_list
thf(fact_6456_card__length__sum__list__rec,axiom,
    ! [M: nat,N4: nat] :
      ( ( ord_less_eq @ nat @ ( one_one @ nat ) @ M )
     => ( ( finite_card @ ( list @ nat )
          @ ( collect @ ( list @ nat )
            @ ^ [L2: list @ nat] :
                ( ( ( size_size @ ( list @ nat ) @ L2 )
                  = M )
                & ( ( groups8242544230860333062m_list @ nat @ L2 )
                  = N4 ) ) ) )
        = ( plus_plus @ nat
          @ ( finite_card @ ( list @ nat )
            @ ( collect @ ( list @ nat )
              @ ^ [L2: list @ nat] :
                  ( ( ( size_size @ ( list @ nat ) @ L2 )
                    = ( minus_minus @ nat @ M @ ( one_one @ nat ) ) )
                  & ( ( groups8242544230860333062m_list @ nat @ L2 )
                    = N4 ) ) ) )
          @ ( finite_card @ ( list @ nat )
            @ ( collect @ ( list @ nat )
              @ ^ [L2: list @ nat] :
                  ( ( ( size_size @ ( list @ nat ) @ L2 )
                    = M )
                  & ( ( plus_plus @ nat @ ( groups8242544230860333062m_list @ nat @ L2 ) @ ( one_one @ nat ) )
                    = N4 ) ) ) ) ) ) ) ).

% card_length_sum_list_rec
thf(fact_6457_nth__sorted__list__of__set__greaterThanLessThan,axiom,
    ! [N: nat,J: nat,I: nat] :
      ( ( ord_less @ nat @ N @ ( minus_minus @ nat @ J @ ( suc @ I ) ) )
     => ( ( nth @ nat @ ( linord4507533701916653071of_set @ nat @ ( set_or5935395276787703475ssThan @ nat @ I @ J ) ) @ N )
        = ( suc @ ( plus_plus @ nat @ I @ N ) ) ) ) ).

% nth_sorted_list_of_set_greaterThanLessThan
thf(fact_6458_sum__list__sum__nth,axiom,
    ! [B: $tType] :
      ( ( comm_monoid_add @ B )
     => ( ( groups8242544230860333062m_list @ B )
        = ( ^ [Xs3: list @ B] : ( groups7311177749621191930dd_sum @ nat @ B @ ( nth @ B @ Xs3 ) @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( size_size @ ( list @ B ) @ Xs3 ) ) ) ) ) ) ).

% sum_list_sum_nth
thf(fact_6459_and__not__num_Opelims,axiom,
    ! [X: num,Xa: num,Y: option @ num] :
      ( ( ( bit_and_not_num @ X @ Xa )
        = Y )
     => ( ( accp @ ( product_prod @ num @ num ) @ bit_and_not_num_rel @ ( product_Pair @ num @ num @ X @ Xa ) )
       => ( ( ( X = one2 )
           => ( ( Xa = one2 )
             => ( ( Y
                  = ( none @ num ) )
               => ~ ( accp @ ( product_prod @ num @ num ) @ bit_and_not_num_rel @ ( product_Pair @ num @ num @ one2 @ one2 ) ) ) ) )
         => ( ( ( X = one2 )
             => ! [N2: num] :
                  ( ( Xa
                    = ( bit0 @ N2 ) )
                 => ( ( Y
                      = ( some @ num @ one2 ) )
                   => ~ ( accp @ ( product_prod @ num @ num ) @ bit_and_not_num_rel @ ( product_Pair @ num @ num @ one2 @ ( bit0 @ N2 ) ) ) ) ) )
           => ( ( ( X = one2 )
               => ! [N2: num] :
                    ( ( Xa
                      = ( bit1 @ N2 ) )
                   => ( ( Y
                        = ( none @ num ) )
                     => ~ ( accp @ ( product_prod @ num @ num ) @ bit_and_not_num_rel @ ( product_Pair @ num @ num @ one2 @ ( bit1 @ N2 ) ) ) ) ) )
             => ( ! [M4: num] :
                    ( ( X
                      = ( bit0 @ M4 ) )
                   => ( ( Xa = one2 )
                     => ( ( Y
                          = ( some @ num @ ( bit0 @ M4 ) ) )
                       => ~ ( accp @ ( product_prod @ num @ num ) @ bit_and_not_num_rel @ ( product_Pair @ num @ num @ ( bit0 @ M4 ) @ one2 ) ) ) ) )
               => ( ! [M4: num] :
                      ( ( X
                        = ( bit0 @ M4 ) )
                     => ! [N2: num] :
                          ( ( Xa
                            = ( bit0 @ N2 ) )
                         => ( ( Y
                              = ( map_option @ num @ num @ bit0 @ ( bit_and_not_num @ M4 @ N2 ) ) )
                           => ~ ( accp @ ( product_prod @ num @ num ) @ bit_and_not_num_rel @ ( product_Pair @ num @ num @ ( bit0 @ M4 ) @ ( bit0 @ N2 ) ) ) ) ) )
                 => ( ! [M4: num] :
                        ( ( X
                          = ( bit0 @ M4 ) )
                       => ! [N2: num] :
                            ( ( Xa
                              = ( bit1 @ N2 ) )
                           => ( ( Y
                                = ( map_option @ num @ num @ bit0 @ ( bit_and_not_num @ M4 @ N2 ) ) )
                             => ~ ( accp @ ( product_prod @ num @ num ) @ bit_and_not_num_rel @ ( product_Pair @ num @ num @ ( bit0 @ M4 ) @ ( bit1 @ N2 ) ) ) ) ) )
                   => ( ! [M4: num] :
                          ( ( X
                            = ( bit1 @ M4 ) )
                         => ( ( Xa = one2 )
                           => ( ( Y
                                = ( some @ num @ ( bit0 @ M4 ) ) )
                             => ~ ( accp @ ( product_prod @ num @ num ) @ bit_and_not_num_rel @ ( product_Pair @ num @ num @ ( bit1 @ M4 ) @ one2 ) ) ) ) )
                     => ( ! [M4: num] :
                            ( ( X
                              = ( bit1 @ M4 ) )
                           => ! [N2: num] :
                                ( ( Xa
                                  = ( bit0 @ N2 ) )
                               => ( ( Y
                                    = ( case_option @ ( option @ num ) @ num @ ( some @ num @ one2 )
                                      @ ^ [N10: num] : ( some @ num @ ( bit1 @ N10 ) )
                                      @ ( bit_and_not_num @ M4 @ N2 ) ) )
                                 => ~ ( accp @ ( product_prod @ num @ num ) @ bit_and_not_num_rel @ ( product_Pair @ num @ num @ ( bit1 @ M4 ) @ ( bit0 @ N2 ) ) ) ) ) )
                       => ~ ! [M4: num] :
                              ( ( X
                                = ( bit1 @ M4 ) )
                             => ! [N2: num] :
                                  ( ( Xa
                                    = ( bit1 @ N2 ) )
                                 => ( ( Y
                                      = ( map_option @ num @ num @ bit0 @ ( bit_and_not_num @ M4 @ N2 ) ) )
                                   => ~ ( accp @ ( product_prod @ num @ num ) @ bit_and_not_num_rel @ ( product_Pair @ num @ num @ ( bit1 @ M4 ) @ ( bit1 @ N2 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ).

% and_not_num.pelims
thf(fact_6460_power_Opower__eq__if,axiom,
    ! [A: $tType] :
      ( ( power2 @ A )
      = ( ^ [One: A,Times: A > A > A,P5: A,M3: nat] :
            ( if @ A
            @ ( M3
              = ( zero_zero @ nat ) )
            @ One
            @ ( Times @ P5 @ ( power2 @ A @ One @ Times @ P5 @ ( minus_minus @ nat @ M3 @ ( one_one @ nat ) ) ) ) ) ) ) ).

% power.power_eq_if
thf(fact_6461_power_Opower_Opower__Suc,axiom,
    ! [A: $tType,One2: A,Times2: A > A > A,A2: A,N: nat] :
      ( ( power2 @ A @ One2 @ Times2 @ A2 @ ( suc @ N ) )
      = ( Times2 @ A2 @ ( power2 @ A @ One2 @ Times2 @ A2 @ N ) ) ) ).

% power.power.power_Suc
thf(fact_6462_power_Opower_Opower__0,axiom,
    ! [A: $tType,One2: A,Times2: A > A > A,A2: A] :
      ( ( power2 @ A @ One2 @ Times2 @ A2 @ ( zero_zero @ nat ) )
      = One2 ) ).

% power.power.power_0
thf(fact_6463_power_Opower_Ocong,axiom,
    ! [A: $tType] :
      ( ( power2 @ A )
      = ( power2 @ A ) ) ).

% power.power.cong
thf(fact_6464_and__num_Opelims,axiom,
    ! [X: num,Xa: num,Y: option @ num] :
      ( ( ( bit_un7362597486090784418nd_num @ X @ Xa )
        = Y )
     => ( ( accp @ ( product_prod @ num @ num ) @ bit_un4731106466462545111um_rel @ ( product_Pair @ num @ num @ X @ Xa ) )
       => ( ( ( X = one2 )
           => ( ( Xa = one2 )
             => ( ( Y
                  = ( some @ num @ one2 ) )
               => ~ ( accp @ ( product_prod @ num @ num ) @ bit_un4731106466462545111um_rel @ ( product_Pair @ num @ num @ one2 @ one2 ) ) ) ) )
         => ( ( ( X = one2 )
             => ! [N2: num] :
                  ( ( Xa
                    = ( bit0 @ N2 ) )
                 => ( ( Y
                      = ( none @ num ) )
                   => ~ ( accp @ ( product_prod @ num @ num ) @ bit_un4731106466462545111um_rel @ ( product_Pair @ num @ num @ one2 @ ( bit0 @ N2 ) ) ) ) ) )
           => ( ( ( X = one2 )
               => ! [N2: num] :
                    ( ( Xa
                      = ( bit1 @ N2 ) )
                   => ( ( Y
                        = ( some @ num @ one2 ) )
                     => ~ ( accp @ ( product_prod @ num @ num ) @ bit_un4731106466462545111um_rel @ ( product_Pair @ num @ num @ one2 @ ( bit1 @ N2 ) ) ) ) ) )
             => ( ! [M4: num] :
                    ( ( X
                      = ( bit0 @ M4 ) )
                   => ( ( Xa = one2 )
                     => ( ( Y
                          = ( none @ num ) )
                       => ~ ( accp @ ( product_prod @ num @ num ) @ bit_un4731106466462545111um_rel @ ( product_Pair @ num @ num @ ( bit0 @ M4 ) @ one2 ) ) ) ) )
               => ( ! [M4: num] :
                      ( ( X
                        = ( bit0 @ M4 ) )
                     => ! [N2: num] :
                          ( ( Xa
                            = ( bit0 @ N2 ) )
                         => ( ( Y
                              = ( map_option @ num @ num @ bit0 @ ( bit_un7362597486090784418nd_num @ M4 @ N2 ) ) )
                           => ~ ( accp @ ( product_prod @ num @ num ) @ bit_un4731106466462545111um_rel @ ( product_Pair @ num @ num @ ( bit0 @ M4 ) @ ( bit0 @ N2 ) ) ) ) ) )
                 => ( ! [M4: num] :
                        ( ( X
                          = ( bit0 @ M4 ) )
                       => ! [N2: num] :
                            ( ( Xa
                              = ( bit1 @ N2 ) )
                           => ( ( Y
                                = ( map_option @ num @ num @ bit0 @ ( bit_un7362597486090784418nd_num @ M4 @ N2 ) ) )
                             => ~ ( accp @ ( product_prod @ num @ num ) @ bit_un4731106466462545111um_rel @ ( product_Pair @ num @ num @ ( bit0 @ M4 ) @ ( bit1 @ N2 ) ) ) ) ) )
                   => ( ! [M4: num] :
                          ( ( X
                            = ( bit1 @ M4 ) )
                         => ( ( Xa = one2 )
                           => ( ( Y
                                = ( some @ num @ one2 ) )
                             => ~ ( accp @ ( product_prod @ num @ num ) @ bit_un4731106466462545111um_rel @ ( product_Pair @ num @ num @ ( bit1 @ M4 ) @ one2 ) ) ) ) )
                     => ( ! [M4: num] :
                            ( ( X
                              = ( bit1 @ M4 ) )
                           => ! [N2: num] :
                                ( ( Xa
                                  = ( bit0 @ N2 ) )
                               => ( ( Y
                                    = ( map_option @ num @ num @ bit0 @ ( bit_un7362597486090784418nd_num @ M4 @ N2 ) ) )
                                 => ~ ( accp @ ( product_prod @ num @ num ) @ bit_un4731106466462545111um_rel @ ( product_Pair @ num @ num @ ( bit1 @ M4 ) @ ( bit0 @ N2 ) ) ) ) ) )
                       => ~ ! [M4: num] :
                              ( ( X
                                = ( bit1 @ M4 ) )
                             => ! [N2: num] :
                                  ( ( Xa
                                    = ( bit1 @ N2 ) )
                                 => ( ( Y
                                      = ( case_option @ ( option @ num ) @ num @ ( some @ num @ one2 )
                                        @ ^ [N10: num] : ( some @ num @ ( bit1 @ N10 ) )
                                        @ ( bit_un7362597486090784418nd_num @ M4 @ N2 ) ) )
                                   => ~ ( accp @ ( product_prod @ num @ num ) @ bit_un4731106466462545111um_rel @ ( product_Pair @ num @ num @ ( bit1 @ M4 ) @ ( bit1 @ N2 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ).

% and_num.pelims
thf(fact_6465_xor__num_Opelims,axiom,
    ! [X: num,Xa: num,Y: option @ num] :
      ( ( ( bit_un2480387367778600638or_num @ X @ Xa )
        = Y )
     => ( ( accp @ ( product_prod @ num @ num ) @ bit_un2901131394128224187um_rel @ ( product_Pair @ num @ num @ X @ Xa ) )
       => ( ( ( X = one2 )
           => ( ( Xa = one2 )
             => ( ( Y
                  = ( none @ num ) )
               => ~ ( accp @ ( product_prod @ num @ num ) @ bit_un2901131394128224187um_rel @ ( product_Pair @ num @ num @ one2 @ one2 ) ) ) ) )
         => ( ( ( X = one2 )
             => ! [N2: num] :
                  ( ( Xa
                    = ( bit0 @ N2 ) )
                 => ( ( Y
                      = ( some @ num @ ( bit1 @ N2 ) ) )
                   => ~ ( accp @ ( product_prod @ num @ num ) @ bit_un2901131394128224187um_rel @ ( product_Pair @ num @ num @ one2 @ ( bit0 @ N2 ) ) ) ) ) )
           => ( ( ( X = one2 )
               => ! [N2: num] :
                    ( ( Xa
                      = ( bit1 @ N2 ) )
                   => ( ( Y
                        = ( some @ num @ ( bit0 @ N2 ) ) )
                     => ~ ( accp @ ( product_prod @ num @ num ) @ bit_un2901131394128224187um_rel @ ( product_Pair @ num @ num @ one2 @ ( bit1 @ N2 ) ) ) ) ) )
             => ( ! [M4: num] :
                    ( ( X
                      = ( bit0 @ M4 ) )
                   => ( ( Xa = one2 )
                     => ( ( Y
                          = ( some @ num @ ( bit1 @ M4 ) ) )
                       => ~ ( accp @ ( product_prod @ num @ num ) @ bit_un2901131394128224187um_rel @ ( product_Pair @ num @ num @ ( bit0 @ M4 ) @ one2 ) ) ) ) )
               => ( ! [M4: num] :
                      ( ( X
                        = ( bit0 @ M4 ) )
                     => ! [N2: num] :
                          ( ( Xa
                            = ( bit0 @ N2 ) )
                         => ( ( Y
                              = ( map_option @ num @ num @ bit0 @ ( bit_un2480387367778600638or_num @ M4 @ N2 ) ) )
                           => ~ ( accp @ ( product_prod @ num @ num ) @ bit_un2901131394128224187um_rel @ ( product_Pair @ num @ num @ ( bit0 @ M4 ) @ ( bit0 @ N2 ) ) ) ) ) )
                 => ( ! [M4: num] :
                        ( ( X
                          = ( bit0 @ M4 ) )
                       => ! [N2: num] :
                            ( ( Xa
                              = ( bit1 @ N2 ) )
                           => ( ( Y
                                = ( some @ num @ ( case_option @ num @ num @ one2 @ bit1 @ ( bit_un2480387367778600638or_num @ M4 @ N2 ) ) ) )
                             => ~ ( accp @ ( product_prod @ num @ num ) @ bit_un2901131394128224187um_rel @ ( product_Pair @ num @ num @ ( bit0 @ M4 ) @ ( bit1 @ N2 ) ) ) ) ) )
                   => ( ! [M4: num] :
                          ( ( X
                            = ( bit1 @ M4 ) )
                         => ( ( Xa = one2 )
                           => ( ( Y
                                = ( some @ num @ ( bit0 @ M4 ) ) )
                             => ~ ( accp @ ( product_prod @ num @ num ) @ bit_un2901131394128224187um_rel @ ( product_Pair @ num @ num @ ( bit1 @ M4 ) @ one2 ) ) ) ) )
                     => ( ! [M4: num] :
                            ( ( X
                              = ( bit1 @ M4 ) )
                           => ! [N2: num] :
                                ( ( Xa
                                  = ( bit0 @ N2 ) )
                               => ( ( Y
                                    = ( some @ num @ ( case_option @ num @ num @ one2 @ bit1 @ ( bit_un2480387367778600638or_num @ M4 @ N2 ) ) ) )
                                 => ~ ( accp @ ( product_prod @ num @ num ) @ bit_un2901131394128224187um_rel @ ( product_Pair @ num @ num @ ( bit1 @ M4 ) @ ( bit0 @ N2 ) ) ) ) ) )
                       => ~ ! [M4: num] :
                              ( ( X
                                = ( bit1 @ M4 ) )
                             => ! [N2: num] :
                                  ( ( Xa
                                    = ( bit1 @ N2 ) )
                                 => ( ( Y
                                      = ( map_option @ num @ num @ bit0 @ ( bit_un2480387367778600638or_num @ M4 @ N2 ) ) )
                                   => ~ ( accp @ ( product_prod @ num @ num ) @ bit_un2901131394128224187um_rel @ ( product_Pair @ num @ num @ ( bit1 @ M4 ) @ ( bit1 @ N2 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ).

% xor_num.pelims
thf(fact_6466_or__not__num__neg_Opelims,axiom,
    ! [X: num,Xa: num,Y: num] :
      ( ( ( bit_or_not_num_neg @ X @ Xa )
        = Y )
     => ( ( accp @ ( product_prod @ num @ num ) @ bit_or3848514188828904588eg_rel @ ( product_Pair @ num @ num @ X @ Xa ) )
       => ( ( ( X = one2 )
           => ( ( Xa = one2 )
             => ( ( Y = one2 )
               => ~ ( accp @ ( product_prod @ num @ num ) @ bit_or3848514188828904588eg_rel @ ( product_Pair @ num @ num @ one2 @ one2 ) ) ) ) )
         => ( ( ( X = one2 )
             => ! [M4: num] :
                  ( ( Xa
                    = ( bit0 @ M4 ) )
                 => ( ( Y
                      = ( bit1 @ M4 ) )
                   => ~ ( accp @ ( product_prod @ num @ num ) @ bit_or3848514188828904588eg_rel @ ( product_Pair @ num @ num @ one2 @ ( bit0 @ M4 ) ) ) ) ) )
           => ( ( ( X = one2 )
               => ! [M4: num] :
                    ( ( Xa
                      = ( bit1 @ M4 ) )
                   => ( ( Y
                        = ( bit1 @ M4 ) )
                     => ~ ( accp @ ( product_prod @ num @ num ) @ bit_or3848514188828904588eg_rel @ ( product_Pair @ num @ num @ one2 @ ( bit1 @ M4 ) ) ) ) ) )
             => ( ! [N2: num] :
                    ( ( X
                      = ( bit0 @ N2 ) )
                   => ( ( Xa = one2 )
                     => ( ( Y
                          = ( bit0 @ one2 ) )
                       => ~ ( accp @ ( product_prod @ num @ num ) @ bit_or3848514188828904588eg_rel @ ( product_Pair @ num @ num @ ( bit0 @ N2 ) @ one2 ) ) ) ) )
               => ( ! [N2: num] :
                      ( ( X
                        = ( bit0 @ N2 ) )
                     => ! [M4: num] :
                          ( ( Xa
                            = ( bit0 @ M4 ) )
                         => ( ( Y
                              = ( bitM @ ( bit_or_not_num_neg @ N2 @ M4 ) ) )
                           => ~ ( accp @ ( product_prod @ num @ num ) @ bit_or3848514188828904588eg_rel @ ( product_Pair @ num @ num @ ( bit0 @ N2 ) @ ( bit0 @ M4 ) ) ) ) ) )
                 => ( ! [N2: num] :
                        ( ( X
                          = ( bit0 @ N2 ) )
                       => ! [M4: num] :
                            ( ( Xa
                              = ( bit1 @ M4 ) )
                           => ( ( Y
                                = ( bit0 @ ( bit_or_not_num_neg @ N2 @ M4 ) ) )
                             => ~ ( accp @ ( product_prod @ num @ num ) @ bit_or3848514188828904588eg_rel @ ( product_Pair @ num @ num @ ( bit0 @ N2 ) @ ( bit1 @ M4 ) ) ) ) ) )
                   => ( ! [N2: num] :
                          ( ( X
                            = ( bit1 @ N2 ) )
                         => ( ( Xa = one2 )
                           => ( ( Y = one2 )
                             => ~ ( accp @ ( product_prod @ num @ num ) @ bit_or3848514188828904588eg_rel @ ( product_Pair @ num @ num @ ( bit1 @ N2 ) @ one2 ) ) ) ) )
                     => ( ! [N2: num] :
                            ( ( X
                              = ( bit1 @ N2 ) )
                           => ! [M4: num] :
                                ( ( Xa
                                  = ( bit0 @ M4 ) )
                               => ( ( Y
                                    = ( bitM @ ( bit_or_not_num_neg @ N2 @ M4 ) ) )
                                 => ~ ( accp @ ( product_prod @ num @ num ) @ bit_or3848514188828904588eg_rel @ ( product_Pair @ num @ num @ ( bit1 @ N2 ) @ ( bit0 @ M4 ) ) ) ) ) )
                       => ~ ! [N2: num] :
                              ( ( X
                                = ( bit1 @ N2 ) )
                             => ! [M4: num] :
                                  ( ( Xa
                                    = ( bit1 @ M4 ) )
                                 => ( ( Y
                                      = ( bitM @ ( bit_or_not_num_neg @ N2 @ M4 ) ) )
                                   => ~ ( accp @ ( product_prod @ num @ num ) @ bit_or3848514188828904588eg_rel @ ( product_Pair @ num @ num @ ( bit1 @ N2 ) @ ( bit1 @ M4 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ).

% or_not_num_neg.pelims
thf(fact_6467_xor__num__rel__dict,axiom,
    bit_un2901131394128224187um_rel = bit_un3595099601533988841um_rel ).

% xor_num_rel_dict
thf(fact_6468_and__num__rel__dict,axiom,
    bit_un4731106466462545111um_rel = bit_un5425074673868309765um_rel ).

% and_num_rel_dict
thf(fact_6469_nth__Cons__pos,axiom,
    ! [A: $tType,N: nat,X: A,Xs: list @ A] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( nth @ A @ ( cons @ A @ X @ Xs ) @ N )
        = ( nth @ A @ Xs @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) ) ) ) ).

% nth_Cons_pos
thf(fact_6470_nth__Cons__0,axiom,
    ! [A: $tType,X: A,Xs: list @ A] :
      ( ( nth @ A @ ( cons @ A @ X @ Xs ) @ ( zero_zero @ nat ) )
      = X ) ).

% nth_Cons_0
thf(fact_6471_nth__Cons__numeral,axiom,
    ! [A: $tType,X: A,Xs: list @ A,V: num] :
      ( ( nth @ A @ ( cons @ A @ X @ Xs ) @ ( numeral_numeral @ nat @ V ) )
      = ( nth @ A @ Xs @ ( minus_minus @ nat @ ( numeral_numeral @ nat @ V ) @ ( one_one @ nat ) ) ) ) ).

% nth_Cons_numeral
thf(fact_6472_take__Cons__numeral,axiom,
    ! [A: $tType,V: num,X: A,Xs: list @ A] :
      ( ( take @ A @ ( numeral_numeral @ nat @ V ) @ ( cons @ A @ X @ Xs ) )
      = ( cons @ A @ X @ ( take @ A @ ( minus_minus @ nat @ ( numeral_numeral @ nat @ V ) @ ( one_one @ nat ) ) @ Xs ) ) ) ).

% take_Cons_numeral
thf(fact_6473_impossible__Cons,axiom,
    ! [A: $tType,Xs: list @ A,Ys3: list @ A,X: A] :
      ( ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ ( size_size @ ( list @ A ) @ Ys3 ) )
     => ( Xs
       != ( cons @ A @ X @ Ys3 ) ) ) ).

% impossible_Cons
thf(fact_6474_list__update__code_I2_J,axiom,
    ! [A: $tType,X: A,Xs: list @ A,Y: A] :
      ( ( list_update @ A @ ( cons @ A @ X @ Xs ) @ ( zero_zero @ nat ) @ Y )
      = ( cons @ A @ Y @ Xs ) ) ).

% list_update_code(2)
thf(fact_6475_Suc__le__length__iff,axiom,
    ! [A: $tType,N: nat,Xs: list @ A] :
      ( ( ord_less_eq @ nat @ ( suc @ N ) @ ( size_size @ ( list @ A ) @ Xs ) )
      = ( ? [X2: A,Ys2: list @ A] :
            ( ( Xs
              = ( cons @ A @ X2 @ Ys2 ) )
            & ( ord_less_eq @ nat @ N @ ( size_size @ ( list @ A ) @ Ys2 ) ) ) ) ) ).

% Suc_le_length_iff
thf(fact_6476_list_Osize_I4_J,axiom,
    ! [A: $tType,X21: A,X222: list @ A] :
      ( ( size_size @ ( list @ A ) @ ( cons @ A @ X21 @ X222 ) )
      = ( plus_plus @ nat @ ( size_size @ ( list @ A ) @ X222 ) @ ( suc @ ( zero_zero @ nat ) ) ) ) ).

% list.size(4)
thf(fact_6477_nth__Cons_H,axiom,
    ! [A: $tType,N: nat,X: A,Xs: list @ A] :
      ( ( ( N
          = ( zero_zero @ nat ) )
       => ( ( nth @ A @ ( cons @ A @ X @ Xs ) @ N )
          = X ) )
      & ( ( N
         != ( zero_zero @ nat ) )
       => ( ( nth @ A @ ( cons @ A @ X @ Xs ) @ N )
          = ( nth @ A @ Xs @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) ) ) ) ) ).

% nth_Cons'
thf(fact_6478_list_Osize__gen_I2_J,axiom,
    ! [A: $tType,X: A > nat,X21: A,X222: list @ A] :
      ( ( size_list @ A @ X @ ( cons @ A @ X21 @ X222 ) )
      = ( plus_plus @ nat @ ( plus_plus @ nat @ ( X @ X21 ) @ ( size_list @ A @ X @ X222 ) ) @ ( suc @ ( zero_zero @ nat ) ) ) ) ).

% list.size_gen(2)
thf(fact_6479_sorted__list__of__set__greaterThanAtMost,axiom,
    ! [I: nat,J: nat] :
      ( ( ord_less_eq @ nat @ ( suc @ I ) @ J )
     => ( ( linord4507533701916653071of_set @ nat @ ( set_or3652927894154168847AtMost @ nat @ I @ J ) )
        = ( cons @ nat @ ( suc @ I ) @ ( linord4507533701916653071of_set @ nat @ ( set_or3652927894154168847AtMost @ nat @ ( suc @ I ) @ J ) ) ) ) ) ).

% sorted_list_of_set_greaterThanAtMost
thf(fact_6480_sorted__list__of__set__greaterThanLessThan,axiom,
    ! [I: nat,J: nat] :
      ( ( ord_less @ nat @ ( suc @ I ) @ J )
     => ( ( linord4507533701916653071of_set @ nat @ ( set_or5935395276787703475ssThan @ nat @ I @ J ) )
        = ( cons @ nat @ ( suc @ I ) @ ( linord4507533701916653071of_set @ nat @ ( set_or5935395276787703475ssThan @ nat @ ( suc @ I ) @ J ) ) ) ) ) ).

% sorted_list_of_set_greaterThanLessThan
thf(fact_6481_nth__equal__first__eq,axiom,
    ! [A: $tType,X: A,Xs: list @ A,N: nat] :
      ( ~ ( member @ A @ X @ ( set2 @ A @ Xs ) )
     => ( ( ord_less_eq @ nat @ N @ ( size_size @ ( list @ A ) @ Xs ) )
       => ( ( ( nth @ A @ ( cons @ A @ X @ Xs ) @ N )
            = X )
          = ( N
            = ( zero_zero @ nat ) ) ) ) ) ).

% nth_equal_first_eq
thf(fact_6482_nth__non__equal__first__eq,axiom,
    ! [A: $tType,X: A,Y: A,Xs: list @ A,N: nat] :
      ( ( X != Y )
     => ( ( ( nth @ A @ ( cons @ A @ X @ Xs ) @ N )
          = Y )
        = ( ( ( nth @ A @ Xs @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) )
            = Y )
          & ( ord_less @ nat @ ( zero_zero @ nat ) @ N ) ) ) ) ).

% nth_non_equal_first_eq
thf(fact_6483_Cons__replicate__eq,axiom,
    ! [A: $tType,X: A,Xs: list @ A,N: nat,Y: A] :
      ( ( ( cons @ A @ X @ Xs )
        = ( replicate @ A @ N @ Y ) )
      = ( ( X = Y )
        & ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
        & ( Xs
          = ( replicate @ A @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) @ X ) ) ) ) ).

% Cons_replicate_eq
thf(fact_6484_Cons__lenlex__iff,axiom,
    ! [A: $tType,M: A,Ms: list @ A,N: A,Ns: list @ A,R2: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( cons @ A @ M @ Ms ) @ ( cons @ A @ N @ Ns ) ) @ ( lenlex @ A @ R2 ) )
      = ( ( ord_less @ nat @ ( size_size @ ( list @ A ) @ Ms ) @ ( size_size @ ( list @ A ) @ Ns ) )
        | ( ( ( size_size @ ( list @ A ) @ Ms )
            = ( size_size @ ( list @ A ) @ Ns ) )
          & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ M @ N ) @ R2 ) )
        | ( ( M = N )
          & ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Ms @ Ns ) @ ( lenlex @ A @ R2 ) ) ) ) ) ).

% Cons_lenlex_iff
thf(fact_6485_of__char__Char,axiom,
    ! [A: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [B0: $o,B1: $o,B22: $o,B32: $o,B42: $o,B52: $o,B62: $o,B72: $o] :
          ( ( comm_s6883823935334413003f_char @ A @ ( char2 @ B0 @ B1 @ B22 @ B32 @ B42 @ B52 @ B62 @ B72 ) )
          = ( groups4207007520872428315er_sum @ $o @ A @ ( zero_neq_one_of_bool @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( cons @ $o @ B0 @ ( cons @ $o @ B1 @ ( cons @ $o @ B22 @ ( cons @ $o @ B32 @ ( cons @ $o @ B42 @ ( cons @ $o @ B52 @ ( cons @ $o @ B62 @ ( cons @ $o @ B72 @ ( nil @ $o ) ) ) ) ) ) ) ) ) ) ) ) ).

% of_char_Char
thf(fact_6486_upto__aux__rec,axiom,
    ( upto_aux
    = ( ^ [I4: int,J3: int,Js: list @ int] : ( if @ ( list @ int ) @ ( ord_less @ int @ J3 @ I4 ) @ Js @ ( upto_aux @ I4 @ ( minus_minus @ int @ J3 @ ( one_one @ int ) ) @ ( cons @ int @ J3 @ Js ) ) ) ) ) ).

% upto_aux_rec
thf(fact_6487_length__0__conv,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( ( size_size @ ( list @ A ) @ Xs )
        = ( zero_zero @ nat ) )
      = ( Xs
        = ( nil @ A ) ) ) ).

% length_0_conv
thf(fact_6488_sum__list_ONil,axiom,
    ! [A: $tType] :
      ( ( monoid_add @ A )
     => ( ( groups8242544230860333062m_list @ A @ ( nil @ A ) )
        = ( zero_zero @ A ) ) ) ).

% sum_list.Nil
thf(fact_6489_take__eq__Nil2,axiom,
    ! [A: $tType,N: nat,Xs: list @ A] :
      ( ( ( nil @ A )
        = ( take @ A @ N @ Xs ) )
      = ( ( N
          = ( zero_zero @ nat ) )
        | ( Xs
          = ( nil @ A ) ) ) ) ).

% take_eq_Nil2
thf(fact_6490_take__eq__Nil,axiom,
    ! [A: $tType,N: nat,Xs: list @ A] :
      ( ( ( take @ A @ N @ Xs )
        = ( nil @ A ) )
      = ( ( N
          = ( zero_zero @ nat ) )
        | ( Xs
          = ( nil @ A ) ) ) ) ).

% take_eq_Nil
thf(fact_6491_take0,axiom,
    ! [A: $tType] :
      ( ( take @ A @ ( zero_zero @ nat ) )
      = ( ^ [Xs3: list @ A] : ( nil @ A ) ) ) ).

% take0
thf(fact_6492_replicate__empty,axiom,
    ! [A: $tType,N: nat,X: A] :
      ( ( ( replicate @ A @ N @ X )
        = ( nil @ A ) )
      = ( N
        = ( zero_zero @ nat ) ) ) ).

% replicate_empty
thf(fact_6493_empty__replicate,axiom,
    ! [A: $tType,N: nat,X: A] :
      ( ( ( nil @ A )
        = ( replicate @ A @ N @ X ) )
      = ( N
        = ( zero_zero @ nat ) ) ) ).

% empty_replicate
thf(fact_6494_horner__sum__simps_I1_J,axiom,
    ! [B: $tType,A: $tType] :
      ( ( comm_semiring_0 @ A )
     => ! [F2: B > A,A2: A] :
          ( ( groups4207007520872428315er_sum @ B @ A @ F2 @ A2 @ ( nil @ B ) )
          = ( zero_zero @ A ) ) ) ).

% horner_sum_simps(1)
thf(fact_6495_n__lists__Nil,axiom,
    ! [A: $tType,N: nat] :
      ( ( ( N
          = ( zero_zero @ nat ) )
       => ( ( n_lists @ A @ N @ ( nil @ A ) )
          = ( cons @ ( list @ A ) @ ( nil @ A ) @ ( nil @ ( list @ A ) ) ) ) )
      & ( ( N
         != ( zero_zero @ nat ) )
       => ( ( n_lists @ A @ N @ ( nil @ A ) )
          = ( nil @ ( list @ A ) ) ) ) ) ).

% n_lists_Nil
thf(fact_6496_length__greater__0__conv,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( size_size @ ( list @ A ) @ Xs ) )
      = ( ( Xs
         != ( nil @ A ) ) ) ) ).

% length_greater_0_conv
thf(fact_6497_nths__singleton,axiom,
    ! [A: $tType,A4: set @ nat,X: A] :
      ( ( ( member @ nat @ ( zero_zero @ nat ) @ A4 )
       => ( ( nths @ A @ ( cons @ A @ X @ ( nil @ A ) ) @ A4 )
          = ( cons @ A @ X @ ( nil @ A ) ) ) )
      & ( ~ ( member @ nat @ ( zero_zero @ nat ) @ A4 )
       => ( ( nths @ A @ ( cons @ A @ X @ ( nil @ A ) ) @ A4 )
          = ( nil @ A ) ) ) ) ).

% nths_singleton
thf(fact_6498_n__lists_Osimps_I1_J,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( n_lists @ A @ ( zero_zero @ nat ) @ Xs )
      = ( cons @ ( list @ A ) @ ( nil @ A ) @ ( nil @ ( list @ A ) ) ) ) ).

% n_lists.simps(1)
thf(fact_6499_list_Osize__gen_I1_J,axiom,
    ! [A: $tType,X: A > nat] :
      ( ( size_list @ A @ X @ ( nil @ A ) )
      = ( zero_zero @ nat ) ) ).

% list.size_gen(1)
thf(fact_6500_replicate__0,axiom,
    ! [A: $tType,X: A] :
      ( ( replicate @ A @ ( zero_zero @ nat ) @ X )
      = ( nil @ A ) ) ).

% replicate_0
thf(fact_6501_take__0,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( take @ A @ ( zero_zero @ nat ) @ Xs )
      = ( nil @ A ) ) ).

% take_0
thf(fact_6502_list_Osize_I3_J,axiom,
    ! [A: $tType] :
      ( ( size_size @ ( list @ A ) @ ( nil @ A ) )
      = ( zero_zero @ nat ) ) ).

% list.size(3)
thf(fact_6503_lexordp_Omono,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ( order_mono @ ( ( list @ A ) > ( list @ A ) > $o ) @ ( ( list @ A ) > ( list @ A ) > $o )
        @ ^ [P5: ( list @ A ) > ( list @ A ) > $o,X16: list @ A,X24: list @ A] :
            ( ? [Y4: A,Ys2: list @ A] :
                ( ( X16
                  = ( nil @ A ) )
                & ( X24
                  = ( cons @ A @ Y4 @ Ys2 ) ) )
            | ? [X2: A,Y4: A,Xs3: list @ A,Ys2: list @ A] :
                ( ( X16
                  = ( cons @ A @ X2 @ Xs3 ) )
                & ( X24
                  = ( cons @ A @ Y4 @ Ys2 ) )
                & ( ord_less @ A @ X2 @ Y4 ) )
            | ? [X2: A,Y4: A,Xs3: list @ A,Ys2: list @ A] :
                ( ( X16
                  = ( cons @ A @ X2 @ Xs3 ) )
                & ( X24
                  = ( cons @ A @ Y4 @ Ys2 ) )
                & ~ ( ord_less @ A @ X2 @ Y4 )
                & ~ ( ord_less @ A @ Y4 @ X2 )
                & ( P5 @ Xs3 @ Ys2 ) ) ) ) ) ).

% lexordp.mono
thf(fact_6504_remdups__adj__replicate,axiom,
    ! [A: $tType,N: nat,X: A] :
      ( ( ( N
          = ( zero_zero @ nat ) )
       => ( ( remdups_adj @ A @ ( replicate @ A @ N @ X ) )
          = ( nil @ A ) ) )
      & ( ( N
         != ( zero_zero @ nat ) )
       => ( ( remdups_adj @ A @ ( replicate @ A @ N @ X ) )
          = ( cons @ A @ X @ ( nil @ A ) ) ) ) ) ).

% remdups_adj_replicate
thf(fact_6505_remdups__adj__length__ge1,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( Xs
       != ( nil @ A ) )
     => ( ord_less_eq @ nat @ ( suc @ ( zero_zero @ nat ) ) @ ( size_size @ ( list @ A ) @ ( remdups_adj @ A @ Xs ) ) ) ) ).

% remdups_adj_length_ge1
thf(fact_6506_take__Cons_H,axiom,
    ! [A: $tType,N: nat,X: A,Xs: list @ A] :
      ( ( ( N
          = ( zero_zero @ nat ) )
       => ( ( take @ A @ N @ ( cons @ A @ X @ Xs ) )
          = ( nil @ A ) ) )
      & ( ( N
         != ( zero_zero @ nat ) )
       => ( ( take @ A @ N @ ( cons @ A @ X @ Xs ) )
          = ( cons @ A @ X @ ( take @ A @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) @ Xs ) ) ) ) ) ).

% take_Cons'
thf(fact_6507_concat__inth,axiom,
    ! [A: $tType,Xs: list @ A,X: A,Ys3: list @ A] :
      ( ( nth @ A @ ( append @ A @ Xs @ ( append @ A @ ( cons @ A @ X @ ( nil @ A ) ) @ Ys3 ) ) @ ( size_size @ ( list @ A ) @ Xs ) )
      = X ) ).

% concat_inth
thf(fact_6508_take__Suc__conv__app__nth,axiom,
    ! [A: $tType,I: nat,Xs: list @ A] :
      ( ( ord_less @ nat @ I @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( ( take @ A @ ( suc @ I ) @ Xs )
        = ( append @ A @ ( take @ A @ I @ Xs ) @ ( cons @ A @ ( nth @ A @ Xs @ I ) @ ( nil @ A ) ) ) ) ) ).

% take_Suc_conv_app_nth
thf(fact_6509_mono__compose,axiom,
    ! [D: $tType,C: $tType,B: $tType,A: $tType] :
      ( ( ( order @ A )
        & ( order @ C ) )
     => ! [Q: A > B > C,F2: D > B] :
          ( ( order_mono @ A @ ( B > C ) @ Q )
         => ( order_mono @ A @ ( D > C )
            @ ^ [I4: A,X2: D] : ( Q @ I4 @ ( F2 @ X2 ) ) ) ) ) ).

% mono_compose
thf(fact_6510_list__update__append1,axiom,
    ! [A: $tType,I: nat,Xs: list @ A,Ys3: list @ A,X: A] :
      ( ( ord_less @ nat @ I @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( ( list_update @ A @ ( append @ A @ Xs @ Ys3 ) @ I @ X )
        = ( append @ A @ ( list_update @ A @ Xs @ I @ X ) @ Ys3 ) ) ) ).

% list_update_append1
thf(fact_6511_nth__append,axiom,
    ! [A: $tType,N: nat,Xs: list @ A,Ys3: list @ A] :
      ( ( ( ord_less @ nat @ N @ ( size_size @ ( list @ A ) @ Xs ) )
       => ( ( nth @ A @ ( append @ A @ Xs @ Ys3 ) @ N )
          = ( nth @ A @ Xs @ N ) ) )
      & ( ~ ( ord_less @ nat @ N @ ( size_size @ ( list @ A ) @ Xs ) )
       => ( ( nth @ A @ ( append @ A @ Xs @ Ys3 ) @ N )
          = ( nth @ A @ Ys3 @ ( minus_minus @ nat @ N @ ( size_size @ ( list @ A ) @ Xs ) ) ) ) ) ) ).

% nth_append
thf(fact_6512_list__update__append,axiom,
    ! [A: $tType,N: nat,Xs: list @ A,Ys3: list @ A,X: A] :
      ( ( ( ord_less @ nat @ N @ ( size_size @ ( list @ A ) @ Xs ) )
       => ( ( list_update @ A @ ( append @ A @ Xs @ Ys3 ) @ N @ X )
          = ( append @ A @ ( list_update @ A @ Xs @ N @ X ) @ Ys3 ) ) )
      & ( ~ ( ord_less @ nat @ N @ ( size_size @ ( list @ A ) @ Xs ) )
       => ( ( list_update @ A @ ( append @ A @ Xs @ Ys3 ) @ N @ X )
          = ( append @ A @ Xs @ ( list_update @ A @ Ys3 @ ( minus_minus @ nat @ N @ ( size_size @ ( list @ A ) @ Xs ) ) @ X ) ) ) ) ) ).

% list_update_append
thf(fact_6513_comm__append__is__replicate,axiom,
    ! [A: $tType,Xs: list @ A,Ys3: list @ A] :
      ( ( Xs
       != ( nil @ A ) )
     => ( ( Ys3
         != ( nil @ A ) )
       => ( ( ( append @ A @ Xs @ Ys3 )
            = ( append @ A @ Ys3 @ Xs ) )
         => ? [N2: nat,Zs: list @ A] :
              ( ( ord_less @ nat @ ( one_one @ nat ) @ N2 )
              & ( ( concat @ A @ ( replicate @ ( list @ A ) @ N2 @ Zs ) )
                = ( append @ A @ Xs @ Ys3 ) ) ) ) ) ) ).

% comm_append_is_replicate
thf(fact_6514_lexord__sufI,axiom,
    ! [A: $tType,U: list @ A,W: list @ A,R2: set @ ( product_prod @ A @ A ),V: list @ A,Z: list @ A] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ U @ W ) @ ( lexord @ A @ R2 ) )
     => ( ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ W ) @ ( size_size @ ( list @ A ) @ U ) )
       => ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ ( append @ A @ U @ V ) @ ( append @ A @ W @ Z ) ) @ ( lexord @ A @ R2 ) ) ) ) ).

% lexord_sufI
thf(fact_6515_horner__sum__append,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_semiring_1 @ A )
     => ! [F2: B > A,A2: A,Xs: list @ B,Ys3: list @ B] :
          ( ( groups4207007520872428315er_sum @ B @ A @ F2 @ A2 @ ( append @ B @ Xs @ Ys3 ) )
          = ( plus_plus @ A @ ( groups4207007520872428315er_sum @ B @ A @ F2 @ A2 @ Xs ) @ ( times_times @ A @ ( power_power @ A @ A2 @ ( size_size @ ( list @ B ) @ Xs ) ) @ ( groups4207007520872428315er_sum @ B @ A @ F2 @ A2 @ Ys3 ) ) ) ) ) ).

% horner_sum_append
thf(fact_6516_nths__Cons,axiom,
    ! [A: $tType,X: A,L: list @ A,A4: set @ nat] :
      ( ( nths @ A @ ( cons @ A @ X @ L ) @ A4 )
      = ( append @ A @ ( if @ ( list @ A ) @ ( member @ nat @ ( zero_zero @ nat ) @ A4 ) @ ( cons @ A @ X @ ( nil @ A ) ) @ ( nil @ A ) )
        @ ( nths @ A @ L
          @ ( collect @ nat
            @ ^ [J3: nat] : ( member @ nat @ ( suc @ J3 ) @ A4 ) ) ) ) ) ).

% nths_Cons
thf(fact_6517_nth__repl,axiom,
    ! [A: $tType,M: nat,Xs: list @ A,N: nat,X: A] :
      ( ( ord_less @ nat @ M @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( ( ord_less @ nat @ N @ ( size_size @ ( list @ A ) @ Xs ) )
       => ( ( M != N )
         => ( ( nth @ A @ ( append @ A @ ( take @ A @ N @ Xs ) @ ( append @ A @ ( cons @ A @ X @ ( nil @ A ) ) @ ( drop @ A @ ( plus_plus @ nat @ N @ ( one_one @ nat ) ) @ Xs ) ) ) @ M )
            = ( nth @ A @ Xs @ M ) ) ) ) ) ).

% nth_repl
thf(fact_6518_pos__n__replace,axiom,
    ! [A: $tType,N: nat,Xs: list @ A,Y: A] :
      ( ( ord_less @ nat @ N @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( ( size_size @ ( list @ A ) @ Xs )
        = ( size_size @ ( list @ A ) @ ( append @ A @ ( take @ A @ N @ Xs ) @ ( append @ A @ ( cons @ A @ Y @ ( nil @ A ) ) @ ( drop @ A @ ( suc @ N ) @ Xs ) ) ) ) ) ) ).

% pos_n_replace
thf(fact_6519_drop0,axiom,
    ! [A: $tType] :
      ( ( drop @ A @ ( zero_zero @ nat ) )
      = ( ^ [X2: list @ A] : X2 ) ) ).

% drop0
thf(fact_6520_drop__update__cancel,axiom,
    ! [A: $tType,N: nat,M: nat,Xs: list @ A,X: A] :
      ( ( ord_less @ nat @ N @ M )
     => ( ( drop @ A @ M @ ( list_update @ A @ Xs @ N @ X ) )
        = ( drop @ A @ M @ Xs ) ) ) ).

% drop_update_cancel
thf(fact_6521_drop__eq__Nil2,axiom,
    ! [A: $tType,N: nat,Xs: list @ A] :
      ( ( ( nil @ A )
        = ( drop @ A @ N @ Xs ) )
      = ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ N ) ) ).

% drop_eq_Nil2
thf(fact_6522_drop__eq__Nil,axiom,
    ! [A: $tType,N: nat,Xs: list @ A] :
      ( ( ( drop @ A @ N @ Xs )
        = ( nil @ A ) )
      = ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ N ) ) ).

% drop_eq_Nil
thf(fact_6523_drop__all,axiom,
    ! [A: $tType,Xs: list @ A,N: nat] :
      ( ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ N )
     => ( ( drop @ A @ N @ Xs )
        = ( nil @ A ) ) ) ).

% drop_all
thf(fact_6524_drop__Cons__numeral,axiom,
    ! [A: $tType,V: num,X: A,Xs: list @ A] :
      ( ( drop @ A @ ( numeral_numeral @ nat @ V ) @ ( cons @ A @ X @ Xs ) )
      = ( drop @ A @ ( minus_minus @ nat @ ( numeral_numeral @ nat @ V ) @ ( one_one @ nat ) ) @ Xs ) ) ).

% drop_Cons_numeral
thf(fact_6525_nth__drop,axiom,
    ! [A: $tType,N: nat,Xs: list @ A,I: nat] :
      ( ( ord_less_eq @ nat @ N @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( ( nth @ A @ ( drop @ A @ N @ Xs ) @ I )
        = ( nth @ A @ Xs @ ( plus_plus @ nat @ N @ I ) ) ) ) ).

% nth_drop
thf(fact_6526_drop__0,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( drop @ A @ ( zero_zero @ nat ) @ Xs )
      = Xs ) ).

% drop_0
thf(fact_6527_drop__eq__nths,axiom,
    ! [A: $tType] :
      ( ( drop @ A )
      = ( ^ [N3: nat,Xs3: list @ A] : ( nths @ A @ Xs3 @ ( collect @ nat @ ( ord_less_eq @ nat @ N3 ) ) ) ) ) ).

% drop_eq_nths
thf(fact_6528_set__drop__subset__set__drop,axiom,
    ! [A: $tType,N: nat,M: nat,Xs: list @ A] :
      ( ( ord_less_eq @ nat @ N @ M )
     => ( ord_less_eq @ ( set @ A ) @ ( set2 @ A @ ( drop @ A @ M @ Xs ) ) @ ( set2 @ A @ ( drop @ A @ N @ Xs ) ) ) ) ).

% set_drop_subset_set_drop
thf(fact_6529_drop__update__swap,axiom,
    ! [A: $tType,M: nat,N: nat,Xs: list @ A,X: A] :
      ( ( ord_less_eq @ nat @ M @ N )
     => ( ( drop @ A @ M @ ( list_update @ A @ Xs @ N @ X ) )
        = ( list_update @ A @ ( drop @ A @ M @ Xs ) @ ( minus_minus @ nat @ N @ M ) @ X ) ) ) ).

% drop_update_swap
thf(fact_6530_drop__Cons_H,axiom,
    ! [A: $tType,N: nat,X: A,Xs: list @ A] :
      ( ( ( N
          = ( zero_zero @ nat ) )
       => ( ( drop @ A @ N @ ( cons @ A @ X @ Xs ) )
          = ( cons @ A @ X @ Xs ) ) )
      & ( ( N
         != ( zero_zero @ nat ) )
       => ( ( drop @ A @ N @ ( cons @ A @ X @ Xs ) )
          = ( drop @ A @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) @ Xs ) ) ) ) ).

% drop_Cons'
thf(fact_6531_append__eq__append__conv__if,axiom,
    ! [A: $tType,Xs_1: list @ A,Xs_2: list @ A,Ys_1: list @ A,Ys_2: list @ A] :
      ( ( ( append @ A @ Xs_1 @ Xs_2 )
        = ( append @ A @ Ys_1 @ Ys_2 ) )
      = ( ( ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ Xs_1 ) @ ( size_size @ ( list @ A ) @ Ys_1 ) )
         => ( ( Xs_1
              = ( take @ A @ ( size_size @ ( list @ A ) @ Xs_1 ) @ Ys_1 ) )
            & ( Xs_2
              = ( append @ A @ ( drop @ A @ ( size_size @ ( list @ A ) @ Xs_1 ) @ Ys_1 ) @ Ys_2 ) ) ) )
        & ( ~ ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ Xs_1 ) @ ( size_size @ ( list @ A ) @ Ys_1 ) )
         => ( ( ( take @ A @ ( size_size @ ( list @ A ) @ Ys_1 ) @ Xs_1 )
              = Ys_1 )
            & ( ( append @ A @ ( drop @ A @ ( size_size @ ( list @ A ) @ Ys_1 ) @ Xs_1 ) @ Xs_2 )
              = Ys_2 ) ) ) ) ) ).

% append_eq_append_conv_if
thf(fact_6532_Cons__nth__drop__Suc,axiom,
    ! [A: $tType,I: nat,Xs: list @ A] :
      ( ( ord_less @ nat @ I @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( ( cons @ A @ ( nth @ A @ Xs @ I ) @ ( drop @ A @ ( suc @ I ) @ Xs ) )
        = ( drop @ A @ I @ Xs ) ) ) ).

% Cons_nth_drop_Suc
thf(fact_6533_set__take__disj__set__drop__if__distinct,axiom,
    ! [A: $tType,Vs: list @ A,I: nat,J: nat] :
      ( ( distinct @ A @ Vs )
     => ( ( ord_less_eq @ nat @ I @ J )
       => ( ( inf_inf @ ( set @ A ) @ ( set2 @ A @ ( take @ A @ I @ Vs ) ) @ ( set2 @ A @ ( drop @ A @ J @ Vs ) ) )
          = ( bot_bot @ ( set @ A ) ) ) ) ) ).

% set_take_disj_set_drop_if_distinct
thf(fact_6534_id__take__nth__drop,axiom,
    ! [A: $tType,I: nat,Xs: list @ A] :
      ( ( ord_less @ nat @ I @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( Xs
        = ( append @ A @ ( take @ A @ I @ Xs ) @ ( cons @ A @ ( nth @ A @ Xs @ I ) @ ( drop @ A @ ( suc @ I ) @ Xs ) ) ) ) ) ).

% id_take_nth_drop
thf(fact_6535_upd__conv__take__nth__drop,axiom,
    ! [A: $tType,I: nat,Xs: list @ A,A2: A] :
      ( ( ord_less @ nat @ I @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( ( list_update @ A @ Xs @ I @ A2 )
        = ( append @ A @ ( take @ A @ I @ Xs ) @ ( cons @ A @ A2 @ ( drop @ A @ ( suc @ I ) @ Xs ) ) ) ) ) ).

% upd_conv_take_nth_drop
thf(fact_6536_upto_Opelims,axiom,
    ! [X: int,Xa: int,Y: list @ int] :
      ( ( ( upto @ X @ Xa )
        = Y )
     => ( ( accp @ ( product_prod @ int @ int ) @ upto_rel @ ( product_Pair @ int @ int @ X @ Xa ) )
       => ~ ( ( ( ( ord_less_eq @ int @ X @ Xa )
               => ( Y
                  = ( cons @ int @ X @ ( upto @ ( plus_plus @ int @ X @ ( one_one @ int ) ) @ Xa ) ) ) )
              & ( ~ ( ord_less_eq @ int @ X @ Xa )
               => ( Y
                  = ( nil @ int ) ) ) )
           => ~ ( accp @ ( product_prod @ int @ int ) @ upto_rel @ ( product_Pair @ int @ int @ X @ Xa ) ) ) ) ) ).

% upto.pelims
thf(fact_6537_upto_Opsimps,axiom,
    ! [I: int,J: int] :
      ( ( accp @ ( product_prod @ int @ int ) @ upto_rel @ ( product_Pair @ int @ int @ I @ J ) )
     => ( ( ( ord_less_eq @ int @ I @ J )
         => ( ( upto @ I @ J )
            = ( cons @ int @ I @ ( upto @ ( plus_plus @ int @ I @ ( one_one @ int ) ) @ J ) ) ) )
        & ( ~ ( ord_less_eq @ int @ I @ J )
         => ( ( upto @ I @ J )
            = ( nil @ int ) ) ) ) ) ).

% upto.psimps
thf(fact_6538_upto__Nil,axiom,
    ! [I: int,J: int] :
      ( ( ( upto @ I @ J )
        = ( nil @ int ) )
      = ( ord_less @ int @ J @ I ) ) ).

% upto_Nil
thf(fact_6539_upto__Nil2,axiom,
    ! [I: int,J: int] :
      ( ( ( nil @ int )
        = ( upto @ I @ J ) )
      = ( ord_less @ int @ J @ I ) ) ).

% upto_Nil2
thf(fact_6540_upto__empty,axiom,
    ! [J: int,I: int] :
      ( ( ord_less @ int @ J @ I )
     => ( ( upto @ I @ J )
        = ( nil @ int ) ) ) ).

% upto_empty
thf(fact_6541_nth__upto,axiom,
    ! [I: int,K: nat,J: int] :
      ( ( ord_less_eq @ int @ ( plus_plus @ int @ I @ ( semiring_1_of_nat @ int @ K ) ) @ J )
     => ( ( nth @ int @ ( upto @ I @ J ) @ K )
        = ( plus_plus @ int @ I @ ( semiring_1_of_nat @ int @ K ) ) ) ) ).

% nth_upto
thf(fact_6542_upto__rec__numeral_I1_J,axiom,
    ! [M: num,N: num] :
      ( ( ( ord_less_eq @ int @ ( numeral_numeral @ int @ M ) @ ( numeral_numeral @ int @ N ) )
       => ( ( upto @ ( numeral_numeral @ int @ M ) @ ( numeral_numeral @ int @ N ) )
          = ( cons @ int @ ( numeral_numeral @ int @ M ) @ ( upto @ ( plus_plus @ int @ ( numeral_numeral @ int @ M ) @ ( one_one @ int ) ) @ ( numeral_numeral @ int @ N ) ) ) ) )
      & ( ~ ( ord_less_eq @ int @ ( numeral_numeral @ int @ M ) @ ( numeral_numeral @ int @ N ) )
       => ( ( upto @ ( numeral_numeral @ int @ M ) @ ( numeral_numeral @ int @ N ) )
          = ( nil @ int ) ) ) ) ).

% upto_rec_numeral(1)
thf(fact_6543_upto__rec__numeral_I4_J,axiom,
    ! [M: num,N: num] :
      ( ( ( ord_less_eq @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ M ) ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N ) ) )
       => ( ( upto @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ M ) ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N ) ) )
          = ( cons @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ M ) ) @ ( upto @ ( plus_plus @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ M ) ) @ ( one_one @ int ) ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N ) ) ) ) ) )
      & ( ~ ( ord_less_eq @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ M ) ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N ) ) )
       => ( ( upto @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ M ) ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N ) ) )
          = ( nil @ int ) ) ) ) ).

% upto_rec_numeral(4)
thf(fact_6544_upto__rec__numeral_I3_J,axiom,
    ! [M: num,N: num] :
      ( ( ( ord_less_eq @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ M ) ) @ ( numeral_numeral @ int @ N ) )
       => ( ( upto @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ M ) ) @ ( numeral_numeral @ int @ N ) )
          = ( cons @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ M ) ) @ ( upto @ ( plus_plus @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ M ) ) @ ( one_one @ int ) ) @ ( numeral_numeral @ int @ N ) ) ) ) )
      & ( ~ ( ord_less_eq @ int @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ M ) ) @ ( numeral_numeral @ int @ N ) )
       => ( ( upto @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ M ) ) @ ( numeral_numeral @ int @ N ) )
          = ( nil @ int ) ) ) ) ).

% upto_rec_numeral(3)
thf(fact_6545_upto__rec__numeral_I2_J,axiom,
    ! [M: num,N: num] :
      ( ( ( ord_less_eq @ int @ ( numeral_numeral @ int @ M ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N ) ) )
       => ( ( upto @ ( numeral_numeral @ int @ M ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N ) ) )
          = ( cons @ int @ ( numeral_numeral @ int @ M ) @ ( upto @ ( plus_plus @ int @ ( numeral_numeral @ int @ M ) @ ( one_one @ int ) ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N ) ) ) ) ) )
      & ( ~ ( ord_less_eq @ int @ ( numeral_numeral @ int @ M ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N ) ) )
       => ( ( upto @ ( numeral_numeral @ int @ M ) @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ N ) ) )
          = ( nil @ int ) ) ) ) ).

% upto_rec_numeral(2)
thf(fact_6546_upto__split2,axiom,
    ! [I: int,J: int,K: int] :
      ( ( ord_less_eq @ int @ I @ J )
     => ( ( ord_less_eq @ int @ J @ K )
       => ( ( upto @ I @ K )
          = ( append @ int @ ( upto @ I @ J ) @ ( upto @ ( plus_plus @ int @ J @ ( one_one @ int ) ) @ K ) ) ) ) ) ).

% upto_split2
thf(fact_6547_upto__split1,axiom,
    ! [I: int,J: int,K: int] :
      ( ( ord_less_eq @ int @ I @ J )
     => ( ( ord_less_eq @ int @ J @ K )
       => ( ( upto @ I @ K )
          = ( append @ int @ ( upto @ I @ ( minus_minus @ int @ J @ ( one_one @ int ) ) ) @ ( upto @ J @ K ) ) ) ) ) ).

% upto_split1
thf(fact_6548_upto_Oelims,axiom,
    ! [X: int,Xa: int,Y: list @ int] :
      ( ( ( upto @ X @ Xa )
        = Y )
     => ( ( ( ord_less_eq @ int @ X @ Xa )
         => ( Y
            = ( cons @ int @ X @ ( upto @ ( plus_plus @ int @ X @ ( one_one @ int ) ) @ Xa ) ) ) )
        & ( ~ ( ord_less_eq @ int @ X @ Xa )
         => ( Y
            = ( nil @ int ) ) ) ) ) ).

% upto.elims
thf(fact_6549_upto_Osimps,axiom,
    ( upto
    = ( ^ [I4: int,J3: int] : ( if @ ( list @ int ) @ ( ord_less_eq @ int @ I4 @ J3 ) @ ( cons @ int @ I4 @ ( upto @ ( plus_plus @ int @ I4 @ ( one_one @ int ) ) @ J3 ) ) @ ( nil @ int ) ) ) ) ).

% upto.simps
thf(fact_6550_upto__rec1,axiom,
    ! [I: int,J: int] :
      ( ( ord_less_eq @ int @ I @ J )
     => ( ( upto @ I @ J )
        = ( cons @ int @ I @ ( upto @ ( plus_plus @ int @ I @ ( one_one @ int ) ) @ J ) ) ) ) ).

% upto_rec1
thf(fact_6551_upto__rec2,axiom,
    ! [I: int,J: int] :
      ( ( ord_less_eq @ int @ I @ J )
     => ( ( upto @ I @ J )
        = ( append @ int @ ( upto @ I @ ( minus_minus @ int @ J @ ( one_one @ int ) ) ) @ ( cons @ int @ J @ ( nil @ int ) ) ) ) ) ).

% upto_rec2
thf(fact_6552_upto__split3,axiom,
    ! [I: int,J: int,K: int] :
      ( ( ord_less_eq @ int @ I @ J )
     => ( ( ord_less_eq @ int @ J @ K )
       => ( ( upto @ I @ K )
          = ( append @ int @ ( upto @ I @ ( minus_minus @ int @ J @ ( one_one @ int ) ) ) @ ( cons @ int @ J @ ( upto @ ( plus_plus @ int @ J @ ( one_one @ int ) ) @ K ) ) ) ) ) ) ).

% upto_split3
thf(fact_6553_take__hd__drop,axiom,
    ! [A: $tType,N: nat,Xs: list @ A] :
      ( ( ord_less @ nat @ N @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( ( append @ A @ ( take @ A @ N @ Xs ) @ ( cons @ A @ ( hd @ A @ ( drop @ A @ N @ Xs ) ) @ ( nil @ A ) ) )
        = ( take @ A @ ( suc @ N ) @ Xs ) ) ) ).

% take_hd_drop
thf(fact_6554_remdups__adj__singleton__iff,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( ( size_size @ ( list @ A ) @ ( remdups_adj @ A @ Xs ) )
        = ( suc @ ( zero_zero @ nat ) ) )
      = ( ( Xs
         != ( nil @ A ) )
        & ( Xs
          = ( replicate @ A @ ( size_size @ ( list @ A ) @ Xs ) @ ( hd @ A @ Xs ) ) ) ) ) ).

% remdups_adj_singleton_iff
thf(fact_6555_hd__replicate,axiom,
    ! [A: $tType,N: nat,X: A] :
      ( ( N
       != ( zero_zero @ nat ) )
     => ( ( hd @ A @ ( replicate @ A @ N @ X ) )
        = X ) ) ).

% hd_replicate
thf(fact_6556_hd__take,axiom,
    ! [A: $tType,J: nat,Xs: list @ A] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ J )
     => ( ( hd @ A @ ( take @ A @ J @ Xs ) )
        = ( hd @ A @ Xs ) ) ) ).

% hd_take
thf(fact_6557_hd__conv__nth,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( Xs
       != ( nil @ A ) )
     => ( ( hd @ A @ Xs )
        = ( nth @ A @ Xs @ ( zero_zero @ nat ) ) ) ) ).

% hd_conv_nth
thf(fact_6558_hd__drop__conv__nth,axiom,
    ! [A: $tType,N: nat,Xs: list @ A] :
      ( ( ord_less @ nat @ N @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( ( hd @ A @ ( drop @ A @ N @ Xs ) )
        = ( nth @ A @ Xs @ N ) ) ) ).

% hd_drop_conv_nth
thf(fact_6559_Nitpick_Osize__list__simp_I1_J,axiom,
    ! [A: $tType] :
      ( ( size_list @ A )
      = ( ^ [F3: A > nat,Xs3: list @ A] :
            ( if @ nat
            @ ( Xs3
              = ( nil @ A ) )
            @ ( zero_zero @ nat )
            @ ( suc @ ( plus_plus @ nat @ ( F3 @ ( hd @ A @ Xs3 ) ) @ ( size_list @ A @ F3 @ ( tl @ A @ Xs3 ) ) ) ) ) ) ) ).

% Nitpick.size_list_simp(1)
thf(fact_6560_butlast__take,axiom,
    ! [A: $tType,N: nat,Xs: list @ A] :
      ( ( ord_less_eq @ nat @ N @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( ( butlast @ A @ ( take @ A @ N @ Xs ) )
        = ( take @ A @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) @ Xs ) ) ) ).

% butlast_take
thf(fact_6561_nth__butlast,axiom,
    ! [A: $tType,N: nat,Xs: list @ A] :
      ( ( ord_less @ nat @ N @ ( size_size @ ( list @ A ) @ ( butlast @ A @ Xs ) ) )
     => ( ( nth @ A @ ( butlast @ A @ Xs ) @ N )
        = ( nth @ A @ Xs @ N ) ) ) ).

% nth_butlast
thf(fact_6562_take__butlast,axiom,
    ! [A: $tType,N: nat,Xs: list @ A] :
      ( ( ord_less @ nat @ N @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( ( take @ A @ N @ ( butlast @ A @ Xs ) )
        = ( take @ A @ N @ Xs ) ) ) ).

% take_butlast
thf(fact_6563_Nitpick_Osize__list__simp_I2_J,axiom,
    ! [A: $tType] :
      ( ( size_size @ ( list @ A ) )
      = ( ^ [Xs3: list @ A] :
            ( if @ nat
            @ ( Xs3
              = ( nil @ A ) )
            @ ( zero_zero @ nat )
            @ ( suc @ ( size_size @ ( list @ A ) @ ( tl @ A @ Xs3 ) ) ) ) ) ) ).

% Nitpick.size_list_simp(2)
thf(fact_6564_nth__tl,axiom,
    ! [A: $tType,N: nat,Xs: list @ A] :
      ( ( ord_less @ nat @ N @ ( size_size @ ( list @ A ) @ ( tl @ A @ Xs ) ) )
     => ( ( nth @ A @ ( tl @ A @ Xs ) @ N )
        = ( nth @ A @ Xs @ ( suc @ N ) ) ) ) ).

% nth_tl
thf(fact_6565_finite__enumerate__initial__segment,axiom,
    ! [A: $tType] :
      ( ( wellorder @ A )
     => ! [S: set @ A,N: nat,S2: A] :
          ( ( finite_finite @ A @ S )
         => ( ( ord_less @ nat @ N @ ( finite_card @ A @ ( inf_inf @ ( set @ A ) @ S @ ( set_ord_lessThan @ A @ S2 ) ) ) )
           => ( ( infini527867602293511546merate @ A @ ( inf_inf @ ( set @ A ) @ S @ ( set_ord_lessThan @ A @ S2 ) ) @ N )
              = ( infini527867602293511546merate @ A @ S @ N ) ) ) ) ) ).

% finite_enumerate_initial_segment
thf(fact_6566_DeMoivre2,axiom,
    ! [R2: real,A2: real,N: nat] :
      ( ( power_power @ complex @ ( rcis @ R2 @ A2 ) @ N )
      = ( rcis @ ( power_power @ real @ R2 @ N ) @ ( times_times @ real @ ( semiring_1_of_nat @ real @ N ) @ A2 ) ) ) ).

% DeMoivre2
thf(fact_6567_rcis__zero__arg,axiom,
    ! [R2: real] :
      ( ( rcis @ R2 @ ( zero_zero @ real ) )
      = ( real_Vector_of_real @ complex @ R2 ) ) ).

% rcis_zero_arg
thf(fact_6568_rcis__zero__mod,axiom,
    ! [A2: real] :
      ( ( rcis @ ( zero_zero @ real ) @ A2 )
      = ( zero_zero @ complex ) ) ).

% rcis_zero_mod
thf(fact_6569_rcis__eq__zero__iff,axiom,
    ! [R2: real,A2: real] :
      ( ( ( rcis @ R2 @ A2 )
        = ( zero_zero @ complex ) )
      = ( R2
        = ( zero_zero @ real ) ) ) ).

% rcis_eq_zero_iff
thf(fact_6570_enumerate__mono__iff,axiom,
    ! [A: $tType] :
      ( ( wellorder @ A )
     => ! [S: set @ A,M: nat,N: nat] :
          ( ~ ( finite_finite @ A @ S )
         => ( ( ord_less @ A @ ( infini527867602293511546merate @ A @ S @ M ) @ ( infini527867602293511546merate @ A @ S @ N ) )
            = ( ord_less @ nat @ M @ N ) ) ) ) ).

% enumerate_mono_iff
thf(fact_6571_finite__enumerate__mono__iff,axiom,
    ! [A: $tType] :
      ( ( wellorder @ A )
     => ! [S: set @ A,M: nat,N: nat] :
          ( ( finite_finite @ A @ S )
         => ( ( ord_less @ nat @ M @ ( finite_card @ A @ S ) )
           => ( ( ord_less @ nat @ N @ ( finite_card @ A @ S ) )
             => ( ( ord_less @ A @ ( infini527867602293511546merate @ A @ S @ M ) @ ( infini527867602293511546merate @ A @ S @ N ) )
                = ( ord_less @ nat @ M @ N ) ) ) ) ) ) ).

% finite_enumerate_mono_iff
thf(fact_6572_le__enumerate,axiom,
    ! [S: set @ nat,N: nat] :
      ( ~ ( finite_finite @ nat @ S )
     => ( ord_less_eq @ nat @ N @ ( infini527867602293511546merate @ nat @ S @ N ) ) ) ).

% le_enumerate
thf(fact_6573_enumerate__step,axiom,
    ! [A: $tType] :
      ( ( wellorder @ A )
     => ! [S: set @ A,N: nat] :
          ( ~ ( finite_finite @ A @ S )
         => ( ord_less @ A @ ( infini527867602293511546merate @ A @ S @ N ) @ ( infini527867602293511546merate @ A @ S @ ( suc @ N ) ) ) ) ) ).

% enumerate_step
thf(fact_6574_enumerate__mono,axiom,
    ! [A: $tType] :
      ( ( wellorder @ A )
     => ! [M: nat,N: nat,S: set @ A] :
          ( ( ord_less @ nat @ M @ N )
         => ( ~ ( finite_finite @ A @ S )
           => ( ord_less @ A @ ( infini527867602293511546merate @ A @ S @ M ) @ ( infini527867602293511546merate @ A @ S @ N ) ) ) ) ) ).

% enumerate_mono
thf(fact_6575_finite__enum__ext,axiom,
    ! [A: $tType] :
      ( ( wellorder @ A )
     => ! [X7: set @ A,Y7: set @ A] :
          ( ! [I2: nat] :
              ( ( ord_less @ nat @ I2 @ ( finite_card @ A @ X7 ) )
             => ( ( infini527867602293511546merate @ A @ X7 @ I2 )
                = ( infini527867602293511546merate @ A @ Y7 @ I2 ) ) )
         => ( ( finite_finite @ A @ X7 )
           => ( ( finite_finite @ A @ Y7 )
             => ( ( ( finite_card @ A @ X7 )
                  = ( finite_card @ A @ Y7 ) )
               => ( X7 = Y7 ) ) ) ) ) ) ).

% finite_enum_ext
thf(fact_6576_finite__enumerate__Ex,axiom,
    ! [A: $tType] :
      ( ( wellorder @ A )
     => ! [S: set @ A,S2: A] :
          ( ( finite_finite @ A @ S )
         => ( ( member @ A @ S2 @ S )
           => ? [N2: nat] :
                ( ( ord_less @ nat @ N2 @ ( finite_card @ A @ S ) )
                & ( ( infini527867602293511546merate @ A @ S @ N2 )
                  = S2 ) ) ) ) ) ).

% finite_enumerate_Ex
thf(fact_6577_finite__enumerate__in__set,axiom,
    ! [A: $tType] :
      ( ( wellorder @ A )
     => ! [S: set @ A,N: nat] :
          ( ( finite_finite @ A @ S )
         => ( ( ord_less @ nat @ N @ ( finite_card @ A @ S ) )
           => ( member @ A @ ( infini527867602293511546merate @ A @ S @ N ) @ S ) ) ) ) ).

% finite_enumerate_in_set
thf(fact_6578_finite__enumerate__mono,axiom,
    ! [A: $tType] :
      ( ( wellorder @ A )
     => ! [M: nat,N: nat,S: set @ A] :
          ( ( ord_less @ nat @ M @ N )
         => ( ( finite_finite @ A @ S )
           => ( ( ord_less @ nat @ N @ ( finite_card @ A @ S ) )
             => ( ord_less @ A @ ( infini527867602293511546merate @ A @ S @ M ) @ ( infini527867602293511546merate @ A @ S @ N ) ) ) ) ) ) ).

% finite_enumerate_mono
thf(fact_6579_finite__le__enumerate,axiom,
    ! [S: set @ nat,N: nat] :
      ( ( finite_finite @ nat @ S )
     => ( ( ord_less @ nat @ N @ ( finite_card @ nat @ S ) )
       => ( ord_less_eq @ nat @ N @ ( infini527867602293511546merate @ nat @ S @ N ) ) ) ) ).

% finite_le_enumerate
thf(fact_6580_finite__enumerate__step,axiom,
    ! [A: $tType] :
      ( ( wellorder @ A )
     => ! [S: set @ A,N: nat] :
          ( ( finite_finite @ A @ S )
         => ( ( ord_less @ nat @ ( suc @ N ) @ ( finite_card @ A @ S ) )
           => ( ord_less @ A @ ( infini527867602293511546merate @ A @ S @ N ) @ ( infini527867602293511546merate @ A @ S @ ( suc @ N ) ) ) ) ) ) ).

% finite_enumerate_step
thf(fact_6581_enumerate__Suc_H,axiom,
    ! [A: $tType] :
      ( ( wellorder @ A )
     => ! [S: set @ A,N: nat] :
          ( ( infini527867602293511546merate @ A @ S @ ( suc @ N ) )
          = ( infini527867602293511546merate @ A @ ( minus_minus @ ( set @ A ) @ S @ ( insert @ A @ ( infini527867602293511546merate @ A @ S @ ( zero_zero @ nat ) ) @ ( bot_bot @ ( set @ A ) ) ) ) @ N ) ) ) ).

% enumerate_Suc'
thf(fact_6582_finite__enum__subset,axiom,
    ! [A: $tType] :
      ( ( wellorder @ A )
     => ! [X7: set @ A,Y7: set @ A] :
          ( ! [I2: nat] :
              ( ( ord_less @ nat @ I2 @ ( finite_card @ A @ X7 ) )
             => ( ( infini527867602293511546merate @ A @ X7 @ I2 )
                = ( infini527867602293511546merate @ A @ Y7 @ I2 ) ) )
         => ( ( finite_finite @ A @ X7 )
           => ( ( finite_finite @ A @ Y7 )
             => ( ( ord_less_eq @ nat @ ( finite_card @ A @ X7 ) @ ( finite_card @ A @ Y7 ) )
               => ( ord_less_eq @ ( set @ A ) @ X7 @ Y7 ) ) ) ) ) ) ).

% finite_enum_subset
thf(fact_6583_finite__enumerate__Suc_H_H,axiom,
    ! [A: $tType] :
      ( ( wellorder @ A )
     => ! [S: set @ A,N: nat] :
          ( ( finite_finite @ A @ S )
         => ( ( ord_less @ nat @ ( suc @ N ) @ ( finite_card @ A @ S ) )
           => ( ( infini527867602293511546merate @ A @ S @ ( suc @ N ) )
              = ( ord_Least @ A
                @ ^ [S6: A] :
                    ( ( member @ A @ S6 @ S )
                    & ( ord_less @ A @ ( infini527867602293511546merate @ A @ S @ N ) @ S6 ) ) ) ) ) ) ) ).

% finite_enumerate_Suc''
thf(fact_6584_independentD,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [S2: set @ A,T2: set @ A,U: A > real,V: A] :
          ( ~ ( real_V358717886546972837endent @ A @ S2 )
         => ( ( finite_finite @ A @ T2 )
           => ( ( ord_less_eq @ ( set @ A ) @ T2 @ S2 )
             => ( ( ( groups7311177749621191930dd_sum @ A @ A
                    @ ^ [V5: A] : ( real_V8093663219630862766scaleR @ A @ ( U @ V5 ) @ V5 )
                    @ T2 )
                  = ( zero_zero @ A ) )
               => ( ( member @ A @ V @ T2 )
                 => ( ( U @ V )
                    = ( zero_zero @ real ) ) ) ) ) ) ) ) ).

% independentD
thf(fact_6585_Least__eq__0,axiom,
    ! [P: nat > $o] :
      ( ( P @ ( zero_zero @ nat ) )
     => ( ( ord_Least @ nat @ P )
        = ( zero_zero @ nat ) ) ) ).

% Least_eq_0
thf(fact_6586_dependent__single,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [X: A] :
          ( ( real_V358717886546972837endent @ A @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
          = ( X
            = ( zero_zero @ A ) ) ) ) ).

% dependent_single
thf(fact_6587_dependent__zero,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [A4: set @ A] :
          ( ( member @ A @ ( zero_zero @ A ) @ A4 )
         => ( real_V358717886546972837endent @ A @ A4 ) ) ) ).

% dependent_zero
thf(fact_6588_LeastI2__ex,axiom,
    ! [A: $tType] :
      ( ( wellorder @ A )
     => ! [P: A > $o,Q: A > $o] :
          ( ? [X_12: A] : ( P @ X_12 )
         => ( ! [X3: A] :
                ( ( P @ X3 )
               => ( Q @ X3 ) )
           => ( Q @ ( ord_Least @ A @ P ) ) ) ) ) ).

% LeastI2_ex
thf(fact_6589_LeastI__ex,axiom,
    ! [A: $tType] :
      ( ( wellorder @ A )
     => ! [P: A > $o] :
          ( ? [X_12: A] : ( P @ X_12 )
         => ( P @ ( ord_Least @ A @ P ) ) ) ) ).

% LeastI_ex
thf(fact_6590_LeastI2,axiom,
    ! [A: $tType] :
      ( ( wellorder @ A )
     => ! [P: A > $o,A2: A,Q: A > $o] :
          ( ( P @ A2 )
         => ( ! [X3: A] :
                ( ( P @ X3 )
               => ( Q @ X3 ) )
           => ( Q @ ( ord_Least @ A @ P ) ) ) ) ) ).

% LeastI2
thf(fact_6591_LeastI,axiom,
    ! [A: $tType] :
      ( ( wellorder @ A )
     => ! [P: A > $o,K: A] :
          ( ( P @ K )
         => ( P @ ( ord_Least @ A @ P ) ) ) ) ).

% LeastI
thf(fact_6592_not__less__Least,axiom,
    ! [A: $tType] :
      ( ( wellorder @ A )
     => ! [K: A,P: A > $o] :
          ( ( ord_less @ A @ K @ ( ord_Least @ A @ P ) )
         => ~ ( P @ K ) ) ) ).

% not_less_Least
thf(fact_6593_Least__le,axiom,
    ! [A: $tType] :
      ( ( wellorder @ A )
     => ! [P: A > $o,K: A] :
          ( ( P @ K )
         => ( ord_less_eq @ A @ ( ord_Least @ A @ P ) @ K ) ) ) ).

% Least_le
thf(fact_6594_LeastI2__wellorder__ex,axiom,
    ! [A: $tType] :
      ( ( wellorder @ A )
     => ! [P: A > $o,Q: A > $o] :
          ( ? [X_12: A] : ( P @ X_12 )
         => ( ! [A5: A] :
                ( ( P @ A5 )
               => ( ! [B9: A] :
                      ( ( P @ B9 )
                     => ( ord_less_eq @ A @ A5 @ B9 ) )
                 => ( Q @ A5 ) ) )
           => ( Q @ ( ord_Least @ A @ P ) ) ) ) ) ).

% LeastI2_wellorder_ex
thf(fact_6595_LeastI2__wellorder,axiom,
    ! [A: $tType] :
      ( ( wellorder @ A )
     => ! [P: A > $o,A2: A,Q: A > $o] :
          ( ( P @ A2 )
         => ( ! [A5: A] :
                ( ( P @ A5 )
               => ( ! [B9: A] :
                      ( ( P @ B9 )
                     => ( ord_less_eq @ A @ A5 @ B9 ) )
                 => ( Q @ A5 ) ) )
           => ( Q @ ( ord_Least @ A @ P ) ) ) ) ) ).

% LeastI2_wellorder
thf(fact_6596_Least__equality,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [P: A > $o,X: A] :
          ( ( P @ X )
         => ( ! [Y5: A] :
                ( ( P @ Y5 )
               => ( ord_less_eq @ A @ X @ Y5 ) )
           => ( ( ord_Least @ A @ P )
              = X ) ) ) ) ).

% Least_equality
thf(fact_6597_LeastI2__order,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [P: A > $o,X: A,Q: A > $o] :
          ( ( P @ X )
         => ( ! [Y5: A] :
                ( ( P @ Y5 )
               => ( ord_less_eq @ A @ X @ Y5 ) )
           => ( ! [X3: A] :
                  ( ( P @ X3 )
                 => ( ! [Y6: A] :
                        ( ( P @ Y6 )
                       => ( ord_less_eq @ A @ X3 @ Y6 ) )
                   => ( Q @ X3 ) ) )
             => ( Q @ ( ord_Least @ A @ P ) ) ) ) ) ) ).

% LeastI2_order
thf(fact_6598_Least1__le,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [P: A > $o,Z: A] :
          ( ? [X5: A] :
              ( ( P @ X5 )
              & ! [Y5: A] :
                  ( ( P @ Y5 )
                 => ( ord_less_eq @ A @ X5 @ Y5 ) )
              & ! [Y5: A] :
                  ( ( ( P @ Y5 )
                    & ! [Ya2: A] :
                        ( ( P @ Ya2 )
                       => ( ord_less_eq @ A @ Y5 @ Ya2 ) ) )
                 => ( Y5 = X5 ) ) )
         => ( ( P @ Z )
           => ( ord_less_eq @ A @ ( ord_Least @ A @ P ) @ Z ) ) ) ) ).

% Least1_le
thf(fact_6599_Least1I,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ! [P: A > $o] :
          ( ? [X5: A] :
              ( ( P @ X5 )
              & ! [Y5: A] :
                  ( ( P @ Y5 )
                 => ( ord_less_eq @ A @ X5 @ Y5 ) )
              & ! [Y5: A] :
                  ( ( ( P @ Y5 )
                    & ! [Ya2: A] :
                        ( ( P @ Ya2 )
                       => ( ord_less_eq @ A @ Y5 @ Ya2 ) ) )
                 => ( Y5 = X5 ) ) )
         => ( P @ ( ord_Least @ A @ P ) ) ) ) ).

% Least1I
thf(fact_6600_Least__Suc2,axiom,
    ! [P: nat > $o,N: nat,Q: nat > $o,M: nat] :
      ( ( P @ N )
     => ( ( Q @ M )
       => ( ~ ( P @ ( zero_zero @ nat ) )
         => ( ! [K2: nat] :
                ( ( P @ ( suc @ K2 ) )
                = ( Q @ K2 ) )
           => ( ( ord_Least @ nat @ P )
              = ( suc @ ( ord_Least @ nat @ Q ) ) ) ) ) ) ) ).

% Least_Suc2
thf(fact_6601_Least__Suc,axiom,
    ! [P: nat > $o,N: nat] :
      ( ( P @ N )
     => ( ~ ( P @ ( zero_zero @ nat ) )
       => ( ( ord_Least @ nat @ P )
          = ( suc
            @ ( ord_Least @ nat
              @ ^ [M3: nat] : ( P @ ( suc @ M3 ) ) ) ) ) ) ) ).

% Least_Suc
thf(fact_6602_Inf__nat__def,axiom,
    ( ( complete_Inf_Inf @ nat )
    = ( ^ [X8: set @ nat] :
          ( ord_Least @ nat
          @ ^ [N3: nat] : ( member @ nat @ N3 @ X8 ) ) ) ) ).

% Inf_nat_def
thf(fact_6603_Least__Min,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [P: A > $o] :
          ( ( finite_finite @ A @ ( collect @ A @ P ) )
         => ( ? [X_12: A] : ( P @ X_12 )
           => ( ( ord_Least @ A @ P )
              = ( lattic643756798350308766er_Min @ A @ ( collect @ A @ P ) ) ) ) ) ) ).

% Least_Min
thf(fact_6604_enumerate__0,axiom,
    ! [A: $tType] :
      ( ( wellorder @ A )
     => ! [S: set @ A] :
          ( ( infini527867602293511546merate @ A @ S @ ( zero_zero @ nat ) )
          = ( ord_Least @ A
            @ ^ [N3: A] : ( member @ A @ N3 @ S ) ) ) ) ).

% enumerate_0
thf(fact_6605_unique__representation,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [Basis: set @ A,F2: A > real,G: A > real] :
          ( ~ ( real_V358717886546972837endent @ A @ Basis )
         => ( ! [V4: A] :
                ( ( ( F2 @ V4 )
                 != ( zero_zero @ real ) )
               => ( member @ A @ V4 @ Basis ) )
           => ( ! [V4: A] :
                  ( ( ( G @ V4 )
                   != ( zero_zero @ real ) )
                 => ( member @ A @ V4 @ Basis ) )
             => ( ( finite_finite @ A
                  @ ( collect @ A
                    @ ^ [V5: A] :
                        ( ( F2 @ V5 )
                       != ( zero_zero @ real ) ) ) )
               => ( ( finite_finite @ A
                    @ ( collect @ A
                      @ ^ [V5: A] :
                          ( ( G @ V5 )
                         != ( zero_zero @ real ) ) ) )
                 => ( ( ( groups7311177749621191930dd_sum @ A @ A
                        @ ^ [V5: A] : ( real_V8093663219630862766scaleR @ A @ ( F2 @ V5 ) @ V5 )
                        @ ( collect @ A
                          @ ^ [V5: A] :
                              ( ( F2 @ V5 )
                             != ( zero_zero @ real ) ) ) )
                      = ( groups7311177749621191930dd_sum @ A @ A
                        @ ^ [V5: A] : ( real_V8093663219630862766scaleR @ A @ ( G @ V5 ) @ V5 )
                        @ ( collect @ A
                          @ ^ [V5: A] :
                              ( ( G @ V5 )
                             != ( zero_zero @ real ) ) ) ) )
                   => ( F2 = G ) ) ) ) ) ) ) ) ).

% unique_representation
thf(fact_6606_Sup__real__def,axiom,
    ( ( complete_Sup_Sup @ real )
    = ( ^ [X8: set @ real] :
          ( ord_Least @ real
          @ ^ [Z6: real] :
            ! [X2: real] :
              ( ( member @ real @ X2 @ X8 )
             => ( ord_less_eq @ real @ X2 @ Z6 ) ) ) ) ) ).

% Sup_real_def
thf(fact_6607_Least__mono,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( order @ A )
        & ( order @ B ) )
     => ! [F2: A > B,S: set @ A] :
          ( ( order_mono @ A @ B @ F2 )
         => ( ? [X5: A] :
                ( ( member @ A @ X5 @ S )
                & ! [Xa3: A] :
                    ( ( member @ A @ Xa3 @ S )
                   => ( ord_less_eq @ A @ X5 @ Xa3 ) ) )
           => ( ( ord_Least @ B
                @ ^ [Y4: B] : ( member @ B @ Y4 @ ( image @ A @ B @ F2 @ S ) ) )
              = ( F2
                @ ( ord_Least @ A
                  @ ^ [X2: A] : ( member @ A @ X2 @ S ) ) ) ) ) ) ) ).

% Least_mono
thf(fact_6608_Least__def,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ( ( ord_Least @ A )
        = ( ^ [P3: A > $o] :
              ( the @ A
              @ ^ [X2: A] :
                  ( ( P3 @ X2 )
                  & ! [Y4: A] :
                      ( ( P3 @ Y4 )
                     => ( ord_less_eq @ A @ X2 @ Y4 ) ) ) ) ) ) ) ).

% Least_def
thf(fact_6609_dependent__finite,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [S: set @ A] :
          ( ( finite_finite @ A @ S )
         => ( ( real_V358717886546972837endent @ A @ S )
            = ( ? [U2: A > real] :
                  ( ? [X2: A] :
                      ( ( member @ A @ X2 @ S )
                      & ( ( U2 @ X2 )
                       != ( zero_zero @ real ) ) )
                  & ( ( groups7311177749621191930dd_sum @ A @ A
                      @ ^ [V5: A] : ( real_V8093663219630862766scaleR @ A @ ( U2 @ V5 ) @ V5 )
                      @ S )
                    = ( zero_zero @ A ) ) ) ) ) ) ) ).

% dependent_finite
thf(fact_6610_independent__if__scalars__zero,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [A4: set @ A] :
          ( ( finite_finite @ A @ A4 )
         => ( ! [F6: A > real,X3: A] :
                ( ( ( groups7311177749621191930dd_sum @ A @ A
                    @ ^ [Y4: A] : ( real_V8093663219630862766scaleR @ A @ ( F6 @ Y4 ) @ Y4 )
                    @ A4 )
                  = ( zero_zero @ A ) )
               => ( ( member @ A @ X3 @ A4 )
                 => ( ( F6 @ X3 )
                    = ( zero_zero @ real ) ) ) )
           => ~ ( real_V358717886546972837endent @ A @ A4 ) ) ) ) ).

% independent_if_scalars_zero
thf(fact_6611_independentD__unique,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [B7: set @ A,X7: A > real,Y7: A > real] :
          ( ~ ( real_V358717886546972837endent @ A @ B7 )
         => ( ( finite_finite @ A
              @ ( collect @ A
                @ ^ [X2: A] :
                    ( ( X7 @ X2 )
                   != ( zero_zero @ real ) ) ) )
           => ( ( ord_less_eq @ ( set @ A )
                @ ( collect @ A
                  @ ^ [X2: A] :
                      ( ( X7 @ X2 )
                     != ( zero_zero @ real ) ) )
                @ B7 )
             => ( ( finite_finite @ A
                  @ ( collect @ A
                    @ ^ [X2: A] :
                        ( ( Y7 @ X2 )
                       != ( zero_zero @ real ) ) ) )
               => ( ( ord_less_eq @ ( set @ A )
                    @ ( collect @ A
                      @ ^ [X2: A] :
                          ( ( Y7 @ X2 )
                         != ( zero_zero @ real ) ) )
                    @ B7 )
                 => ( ( ( groups7311177749621191930dd_sum @ A @ A
                        @ ^ [X2: A] : ( real_V8093663219630862766scaleR @ A @ ( X7 @ X2 ) @ X2 )
                        @ ( collect @ A
                          @ ^ [X2: A] :
                              ( ( X7 @ X2 )
                             != ( zero_zero @ real ) ) ) )
                      = ( groups7311177749621191930dd_sum @ A @ A
                        @ ^ [X2: A] : ( real_V8093663219630862766scaleR @ A @ ( Y7 @ X2 ) @ X2 )
                        @ ( collect @ A
                          @ ^ [X2: A] :
                              ( ( Y7 @ X2 )
                             != ( zero_zero @ real ) ) ) ) )
                   => ( X7 = Y7 ) ) ) ) ) ) ) ) ).

% independentD_unique
thf(fact_6612_enumerate__Suc_H_H,axiom,
    ! [A: $tType] :
      ( ( wellorder @ A )
     => ! [S: set @ A,N: nat] :
          ( ~ ( finite_finite @ A @ S )
         => ( ( infini527867602293511546merate @ A @ S @ ( suc @ N ) )
            = ( ord_Least @ A
              @ ^ [S6: A] :
                  ( ( member @ A @ S6 @ S )
                  & ( ord_less @ A @ ( infini527867602293511546merate @ A @ S @ N ) @ S6 ) ) ) ) ) ) ).

% enumerate_Suc''
thf(fact_6613_independent__explicit__finite__subsets,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [A4: set @ A] :
          ( ( ~ ( real_V358717886546972837endent @ A @ A4 ) )
          = ( ! [S8: set @ A] :
                ( ( ord_less_eq @ ( set @ A ) @ S8 @ A4 )
               => ( ( finite_finite @ A @ S8 )
                 => ! [U2: A > real] :
                      ( ( ( groups7311177749621191930dd_sum @ A @ A
                          @ ^ [V5: A] : ( real_V8093663219630862766scaleR @ A @ ( U2 @ V5 ) @ V5 )
                          @ S8 )
                        = ( zero_zero @ A ) )
                     => ! [X2: A] :
                          ( ( member @ A @ X2 @ S8 )
                         => ( ( U2 @ X2 )
                            = ( zero_zero @ real ) ) ) ) ) ) ) ) ) ).

% independent_explicit_finite_subsets
thf(fact_6614_independent__explicit__module,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [S2: set @ A] :
          ( ( ~ ( real_V358717886546972837endent @ A @ S2 ) )
          = ( ! [T3: set @ A,U2: A > real,V5: A] :
                ( ( finite_finite @ A @ T3 )
               => ( ( ord_less_eq @ ( set @ A ) @ T3 @ S2 )
                 => ( ( ( groups7311177749621191930dd_sum @ A @ A
                        @ ^ [W3: A] : ( real_V8093663219630862766scaleR @ A @ ( U2 @ W3 ) @ W3 )
                        @ T3 )
                      = ( zero_zero @ A ) )
                   => ( ( member @ A @ V5 @ T3 )
                     => ( ( U2 @ V5 )
                        = ( zero_zero @ real ) ) ) ) ) ) ) ) ) ).

% independent_explicit_module
thf(fact_6615_dependent__explicit,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ( ( real_V358717886546972837endent @ A )
        = ( ^ [S6: set @ A] :
            ? [T3: set @ A] :
              ( ( finite_finite @ A @ T3 )
              & ( ord_less_eq @ ( set @ A ) @ T3 @ S6 )
              & ? [U2: A > real] :
                  ( ( ( groups7311177749621191930dd_sum @ A @ A
                      @ ^ [V5: A] : ( real_V8093663219630862766scaleR @ A @ ( U2 @ V5 ) @ V5 )
                      @ T3 )
                    = ( zero_zero @ A ) )
                  & ? [X2: A] :
                      ( ( member @ A @ X2 @ T3 )
                      & ( ( U2 @ X2 )
                       != ( zero_zero @ real ) ) ) ) ) ) ) ) ).

% dependent_explicit
thf(fact_6616_independentD__alt,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [B7: set @ A,X7: A > real,X: A] :
          ( ~ ( real_V358717886546972837endent @ A @ B7 )
         => ( ( finite_finite @ A
              @ ( collect @ A
                @ ^ [X2: A] :
                    ( ( X7 @ X2 )
                   != ( zero_zero @ real ) ) ) )
           => ( ( ord_less_eq @ ( set @ A )
                @ ( collect @ A
                  @ ^ [X2: A] :
                      ( ( X7 @ X2 )
                     != ( zero_zero @ real ) ) )
                @ B7 )
             => ( ( ( groups7311177749621191930dd_sum @ A @ A
                    @ ^ [X2: A] : ( real_V8093663219630862766scaleR @ A @ ( X7 @ X2 ) @ X2 )
                    @ ( collect @ A
                      @ ^ [X2: A] :
                          ( ( X7 @ X2 )
                         != ( zero_zero @ real ) ) ) )
                  = ( zero_zero @ A ) )
               => ( ( X7 @ X )
                  = ( zero_zero @ real ) ) ) ) ) ) ) ).

% independentD_alt
thf(fact_6617_independent__alt,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [B7: set @ A] :
          ( ( ~ ( real_V358717886546972837endent @ A @ B7 ) )
          = ( ! [X8: A > real] :
                ( ( finite_finite @ A
                  @ ( collect @ A
                    @ ^ [X2: A] :
                        ( ( X8 @ X2 )
                       != ( zero_zero @ real ) ) ) )
               => ( ( ord_less_eq @ ( set @ A )
                    @ ( collect @ A
                      @ ^ [X2: A] :
                          ( ( X8 @ X2 )
                         != ( zero_zero @ real ) ) )
                    @ B7 )
                 => ( ( ( groups7311177749621191930dd_sum @ A @ A
                        @ ^ [X2: A] : ( real_V8093663219630862766scaleR @ A @ ( X8 @ X2 ) @ X2 )
                        @ ( collect @ A
                          @ ^ [X2: A] :
                              ( ( X8 @ X2 )
                             != ( zero_zero @ real ) ) ) )
                      = ( zero_zero @ A ) )
                   => ! [X2: A] :
                        ( ( X8 @ X2 )
                        = ( zero_zero @ real ) ) ) ) ) ) ) ) ).

% independent_alt
thf(fact_6618_dependent__alt,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ( ( real_V358717886546972837endent @ A )
        = ( ^ [B6: set @ A] :
            ? [X8: A > real] :
              ( ( finite_finite @ A
                @ ( collect @ A
                  @ ^ [X2: A] :
                      ( ( X8 @ X2 )
                     != ( zero_zero @ real ) ) ) )
              & ( ord_less_eq @ ( set @ A )
                @ ( collect @ A
                  @ ^ [X2: A] :
                      ( ( X8 @ X2 )
                     != ( zero_zero @ real ) ) )
                @ B6 )
              & ( ( groups7311177749621191930dd_sum @ A @ A
                  @ ^ [X2: A] : ( real_V8093663219630862766scaleR @ A @ ( X8 @ X2 ) @ X2 )
                  @ ( collect @ A
                    @ ^ [X2: A] :
                        ( ( X8 @ X2 )
                       != ( zero_zero @ real ) ) ) )
                = ( zero_zero @ A ) )
              & ? [X2: A] :
                  ( ( X8 @ X2 )
                 != ( zero_zero @ real ) ) ) ) ) ) ).

% dependent_alt
thf(fact_6619_isUCont__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V7819770556892013058_space @ A )
        & ( real_V7819770556892013058_space @ B ) )
     => ! [F2: A > B] :
          ( ( topolo6026614971017936543ous_on @ A @ B @ ( top_top @ ( set @ A ) ) @ F2 )
          = ( ! [R5: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ R5 )
               => ? [S6: real] :
                    ( ( ord_less @ real @ ( zero_zero @ real ) @ S6 )
                    & ! [X2: A,Y4: A] :
                        ( ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X2 @ Y4 ) @ S6 )
                       => ( ord_less @ real @ ( real_V557655796197034286t_dist @ B @ ( F2 @ X2 ) @ ( F2 @ Y4 ) ) @ R5 ) ) ) ) ) ) ) ).

% isUCont_def
thf(fact_6620_possible__bit__def,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ( ( bit_se6407376104438227557le_bit @ A )
        = ( ^ [Tyrep: itself @ A,N3: nat] :
              ( ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N3 )
             != ( zero_zero @ A ) ) ) ) ) ).

% possible_bit_def
thf(fact_6621_possible__bit__min,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [Tyrep2: itself @ A,I: nat,J: nat] :
          ( ( bit_se6407376104438227557le_bit @ A @ Tyrep2 @ ( ord_min @ nat @ I @ J ) )
          = ( ( bit_se6407376104438227557le_bit @ A @ Tyrep2 @ I )
            | ( bit_se6407376104438227557le_bit @ A @ Tyrep2 @ J ) ) ) ) ).

% possible_bit_min
thf(fact_6622_possible__bit__less__imp,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [Tyrep2: itself @ A,I: nat,J: nat] :
          ( ( bit_se6407376104438227557le_bit @ A @ Tyrep2 @ I )
         => ( ( ord_less_eq @ nat @ J @ I )
           => ( bit_se6407376104438227557le_bit @ A @ Tyrep2 @ J ) ) ) ) ).

% possible_bit_less_imp
thf(fact_6623_possible__bit__0,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [Ty: itself @ A] : ( bit_se6407376104438227557le_bit @ A @ Ty @ ( zero_zero @ nat ) ) ) ).

% possible_bit_0
thf(fact_6624_uniformly__continuous__on__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V7819770556892013058_space @ A )
        & ( real_V7819770556892013058_space @ B ) )
     => ( ( topolo6026614971017936543ous_on @ A @ B )
        = ( ^ [S6: set @ A,F3: A > B] :
            ! [E3: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ E3 )
             => ? [D4: real] :
                  ( ( ord_less @ real @ ( zero_zero @ real ) @ D4 )
                  & ! [X2: A] :
                      ( ( member @ A @ X2 @ S6 )
                     => ! [Y4: A] :
                          ( ( member @ A @ Y4 @ S6 )
                         => ( ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ Y4 @ X2 ) @ D4 )
                           => ( ord_less @ real @ ( real_V557655796197034286t_dist @ B @ ( F3 @ Y4 ) @ ( F3 @ X2 ) ) @ E3 ) ) ) ) ) ) ) ) ) ).

% uniformly_continuous_on_def
thf(fact_6625_drop__bit__exp__eq,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M: nat,N: nat] :
          ( ( bit_se4197421643247451524op_bit @ A @ M @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N ) )
          = ( times_times @ A
            @ ( zero_neq_one_of_bool @ A
              @ ( ( ord_less_eq @ nat @ M @ N )
                & ( bit_se6407376104438227557le_bit @ A @ ( type2 @ A ) @ N ) ) )
            @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( minus_minus @ nat @ N @ M ) ) ) ) ) ).

% drop_bit_exp_eq
thf(fact_6626_bit__minus__2__iff,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) ) @ N )
          = ( ( bit_se6407376104438227557le_bit @ A @ ( type2 @ A ) @ N )
            & ( ord_less @ nat @ ( zero_zero @ nat ) @ N ) ) ) ) ).

% bit_minus_2_iff
thf(fact_6627_CHAR__eq__0,axiom,
    ! [A: $tType] :
      ( ( semiring_char_0 @ A )
     => ( ( semiri4206861660011772517g_char @ A @ ( type2 @ A ) )
        = ( zero_zero @ nat ) ) ) ).

% CHAR_eq_0
thf(fact_6628_of__nat__CHAR,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ( ( semiring_1_of_nat @ A @ ( semiri4206861660011772517g_char @ A @ ( type2 @ A ) ) )
        = ( zero_zero @ A ) ) ) ).

% of_nat_CHAR
thf(fact_6629_bit__minus__1__iff,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [N: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( uminus_uminus @ A @ ( one_one @ A ) ) @ N )
          = ( bit_se6407376104438227557le_bit @ A @ ( type2 @ A ) @ N ) ) ) ).

% bit_minus_1_iff
thf(fact_6630_bit__eqI,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A,B2: A] :
          ( ! [N2: nat] :
              ( ( bit_se6407376104438227557le_bit @ A @ ( type2 @ A ) @ N2 )
             => ( ( bit_se5641148757651400278ts_bit @ A @ A2 @ N2 )
                = ( bit_se5641148757651400278ts_bit @ A @ B2 @ N2 ) ) )
         => ( A2 = B2 ) ) ) ).

% bit_eqI
thf(fact_6631_bit__eq__iff,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ( ( ^ [Y3: A,Z2: A] : ( Y3 = Z2 ) )
        = ( ^ [A3: A,B3: A] :
            ! [N3: nat] :
              ( ( bit_se6407376104438227557le_bit @ A @ ( type2 @ A ) @ N3 )
             => ( ( bit_se5641148757651400278ts_bit @ A @ A3 @ N3 )
                = ( bit_se5641148757651400278ts_bit @ A @ B3 @ N3 ) ) ) ) ) ) ).

% bit_eq_iff
thf(fact_6632_impossible__bit,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [N: nat,A2: A] :
          ( ~ ( bit_se6407376104438227557le_bit @ A @ ( type2 @ A ) @ N )
         => ~ ( bit_se5641148757651400278ts_bit @ A @ A2 @ N ) ) ) ).

% impossible_bit
thf(fact_6633_bit__imp__possible__bit,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A,N: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ A2 @ N )
         => ( bit_se6407376104438227557le_bit @ A @ ( type2 @ A ) @ N ) ) ) ).

% bit_imp_possible_bit
thf(fact_6634_bit__not__iff,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [A2: A,N: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( bit_ri4277139882892585799ns_not @ A @ A2 ) @ N )
          = ( ~ ~ ( bit_se6407376104438227557le_bit @ A @ ( type2 @ A ) @ N )
            & ~ ( bit_se5641148757651400278ts_bit @ A @ A2 @ N ) ) ) ) ).

% bit_not_iff
thf(fact_6635_bit__set__bit__iff,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M: nat,A2: A,N: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( bit_se5668285175392031749et_bit @ A @ M @ A2 ) @ N )
          = ( ( bit_se5641148757651400278ts_bit @ A @ A2 @ N )
            | ( ( M = N )
              & ( bit_se6407376104438227557le_bit @ A @ ( type2 @ A ) @ N ) ) ) ) ) ).

% bit_set_bit_iff
thf(fact_6636_bit__flip__bit__iff,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M: nat,A2: A,N: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( bit_se8732182000553998342ip_bit @ A @ M @ A2 ) @ N )
          = ( ( ( M = N )
              = ( ~ ( bit_se5641148757651400278ts_bit @ A @ A2 @ N ) ) )
            & ( bit_se6407376104438227557le_bit @ A @ ( type2 @ A ) @ N ) ) ) ) ).

% bit_flip_bit_iff
thf(fact_6637_bit__mask__iff,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M: nat,N: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( bit_se2239418461657761734s_mask @ A @ M ) @ N )
          = ( ( bit_se6407376104438227557le_bit @ A @ ( type2 @ A ) @ N )
            & ( ord_less @ nat @ N @ M ) ) ) ) ).

% bit_mask_iff
thf(fact_6638_CHAR__eqI,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [C2: nat] :
          ( ( ( semiring_1_of_nat @ A @ C2 )
            = ( zero_zero @ A ) )
         => ( ! [X3: nat] :
                ( ( ( semiring_1_of_nat @ A @ X3 )
                  = ( zero_zero @ A ) )
               => ( dvd_dvd @ nat @ C2 @ X3 ) )
           => ( ( semiri4206861660011772517g_char @ A @ ( type2 @ A ) )
              = C2 ) ) ) ) ).

% CHAR_eqI
thf(fact_6639_of__nat__eq__0__iff__char__dvd,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [N: nat] :
          ( ( ( semiring_1_of_nat @ A @ N )
            = ( zero_zero @ A ) )
          = ( dvd_dvd @ nat @ ( semiri4206861660011772517g_char @ A @ ( type2 @ A ) ) @ N ) ) ) ).

% of_nat_eq_0_iff_char_dvd
thf(fact_6640_bit__of__int__iff,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [K: int,N: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( ring_1_of_int @ A @ K ) @ N )
          = ( ( bit_se6407376104438227557le_bit @ A @ ( type2 @ A ) @ N )
            & ( bit_se5641148757651400278ts_bit @ int @ K @ N ) ) ) ) ).

% bit_of_int_iff
thf(fact_6641_bit__of__nat__iff,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [M: nat,N: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( semiring_1_of_nat @ A @ M ) @ N )
          = ( ( bit_se6407376104438227557le_bit @ A @ ( type2 @ A ) @ N )
            & ( bit_se5641148757651400278ts_bit @ nat @ M @ N ) ) ) ) ).

% bit_of_nat_iff
thf(fact_6642_bit__signed__take__bit__iff,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [M: nat,A2: A,N: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( bit_ri4674362597316999326ke_bit @ A @ M @ A2 ) @ N )
          = ( ( bit_se6407376104438227557le_bit @ A @ ( type2 @ A ) @ N )
            & ( bit_se5641148757651400278ts_bit @ A @ A2 @ ( ord_min @ nat @ M @ N ) ) ) ) ) ).

% bit_signed_take_bit_iff
thf(fact_6643_bit__minus__iff,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [A2: A,N: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( uminus_uminus @ A @ A2 ) @ N )
          = ( ( bit_se6407376104438227557le_bit @ A @ ( type2 @ A ) @ N )
            & ~ ( bit_se5641148757651400278ts_bit @ A @ ( minus_minus @ A @ A2 @ ( one_one @ A ) ) @ N ) ) ) ) ).

% bit_minus_iff
thf(fact_6644_CHAR__pos__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( semiri4206861660011772517g_char @ A @ ( type2 @ A ) ) )
        = ( ? [N3: nat] :
              ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N3 )
              & ( ( semiring_1_of_nat @ A @ N3 )
                = ( zero_zero @ A ) ) ) ) ) ) ).

% CHAR_pos_iff
thf(fact_6645_CHAR__eq__posI,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ! [C2: nat] :
          ( ( ord_less @ nat @ ( zero_zero @ nat ) @ C2 )
         => ( ( ( semiring_1_of_nat @ A @ C2 )
              = ( zero_zero @ A ) )
           => ( ! [X3: nat] :
                  ( ( ord_less @ nat @ ( zero_zero @ nat ) @ X3 )
                 => ( ( ord_less @ nat @ X3 @ C2 )
                   => ( ( semiring_1_of_nat @ A @ X3 )
                     != ( zero_zero @ A ) ) ) )
             => ( ( semiri4206861660011772517g_char @ A @ ( type2 @ A ) )
                = C2 ) ) ) ) ) ).

% CHAR_eq_posI
thf(fact_6646_CHAR__eq0__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_1 @ A )
     => ( ( ( semiri4206861660011772517g_char @ A @ ( type2 @ A ) )
          = ( zero_zero @ nat ) )
        = ( ! [N3: nat] :
              ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N3 )
             => ( ( semiring_1_of_nat @ A @ N3 )
               != ( zero_zero @ A ) ) ) ) ) ) ).

% CHAR_eq0_iff
thf(fact_6647_bit__push__bit__iff,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [M: nat,A2: A,N: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( bit_se4730199178511100633sh_bit @ A @ M @ A2 ) @ N )
          = ( ( ord_less_eq @ nat @ M @ N )
            & ( bit_se6407376104438227557le_bit @ A @ ( type2 @ A ) @ N )
            & ( bit_se5641148757651400278ts_bit @ A @ A2 @ ( minus_minus @ nat @ N @ M ) ) ) ) ) ).

% bit_push_bit_iff
thf(fact_6648_fold__possible__bit,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [N: nat] :
          ( ( ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N )
            = ( zero_zero @ A ) )
          = ( ~ ( bit_se6407376104438227557le_bit @ A @ ( type2 @ A ) @ N ) ) ) ) ).

% fold_possible_bit
thf(fact_6649_bit__exp__iff,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [M: nat,N: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M ) @ N )
          = ( ( bit_se6407376104438227557le_bit @ A @ ( type2 @ A ) @ N )
            & ( M = N ) ) ) ) ).

% bit_exp_iff
thf(fact_6650_bit__2__iff,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [N: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ N )
          = ( ( bit_se6407376104438227557le_bit @ A @ ( type2 @ A ) @ ( one_one @ nat ) )
            & ( N
              = ( one_one @ nat ) ) ) ) ) ).

% bit_2_iff
thf(fact_6651_bit__not__exp__iff,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [M: nat,N: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( bit_ri4277139882892585799ns_not @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M ) ) @ N )
          = ( ( bit_se6407376104438227557le_bit @ A @ ( type2 @ A ) @ N )
            & ( N != M ) ) ) ) ).

% bit_not_exp_iff
thf(fact_6652_bit__minus__exp__iff,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ! [M: nat,N: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( uminus_uminus @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M ) ) @ N )
          = ( ( bit_se6407376104438227557le_bit @ A @ ( type2 @ A ) @ N )
            & ( ord_less_eq @ nat @ M @ N ) ) ) ) ).

% bit_minus_exp_iff
thf(fact_6653_bit__mask__sub__iff,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [M: nat,N: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( minus_minus @ A @ ( power_power @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ M ) @ ( one_one @ A ) ) @ N )
          = ( ( bit_se6407376104438227557le_bit @ A @ ( type2 @ A ) @ N )
            & ( ord_less @ nat @ N @ M ) ) ) ) ).

% bit_mask_sub_iff
thf(fact_6654_bit__double__iff,axiom,
    ! [A: $tType] :
      ( ( bit_semiring_bits @ A )
     => ! [A2: A,N: nat] :
          ( ( bit_se5641148757651400278ts_bit @ A @ ( times_times @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) @ N )
          = ( ( bit_se5641148757651400278ts_bit @ A @ A2 @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) )
            & ( N
             != ( zero_zero @ nat ) )
            & ( bit_se6407376104438227557le_bit @ A @ ( type2 @ A ) @ N ) ) ) ) ).

% bit_double_iff
thf(fact_6655_sum__list__upt,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ M @ N )
     => ( ( groups8242544230860333062m_list @ nat @ ( upt @ M @ N ) )
        = ( groups7311177749621191930dd_sum @ nat @ nat
          @ ^ [X2: nat] : X2
          @ ( set_or7035219750837199246ssThan @ nat @ M @ N ) ) ) ) ).

% sum_list_upt
thf(fact_6656_Gcd__fin__0__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A4: set @ A] :
          ( ( ( semiring_gcd_Gcd_fin @ A @ A4 )
            = ( zero_zero @ A ) )
          = ( ( ord_less_eq @ ( set @ A ) @ A4 @ ( insert @ A @ ( zero_zero @ A ) @ ( bot_bot @ ( set @ A ) ) ) )
            & ( finite_finite @ A @ A4 ) ) ) ) ).

% Gcd_fin_0_iff
thf(fact_6657_hd__upt,axiom,
    ! [I: nat,J: nat] :
      ( ( ord_less @ nat @ I @ J )
     => ( ( hd @ nat @ ( upt @ I @ J ) )
        = I ) ) ).

% hd_upt
thf(fact_6658_upt__conv__Nil,axiom,
    ! [J: nat,I: nat] :
      ( ( ord_less_eq @ nat @ J @ I )
     => ( ( upt @ I @ J )
        = ( nil @ nat ) ) ) ).

% upt_conv_Nil
thf(fact_6659_upt__eq__Nil__conv,axiom,
    ! [I: nat,J: nat] :
      ( ( ( upt @ I @ J )
        = ( nil @ nat ) )
      = ( ( J
          = ( zero_zero @ nat ) )
        | ( ord_less_eq @ nat @ J @ I ) ) ) ).

% upt_eq_Nil_conv
thf(fact_6660_Gcd__fin_Oempty,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ( ( semiring_gcd_Gcd_fin @ A @ ( bot_bot @ ( set @ A ) ) )
        = ( zero_zero @ A ) ) ) ).

% Gcd_fin.empty
thf(fact_6661_take__upt,axiom,
    ! [I: nat,M: nat,N: nat] :
      ( ( ord_less_eq @ nat @ ( plus_plus @ nat @ I @ M ) @ N )
     => ( ( take @ nat @ M @ ( upt @ I @ N ) )
        = ( upt @ I @ ( plus_plus @ nat @ I @ M ) ) ) ) ).

% take_upt
thf(fact_6662_nth__upt,axiom,
    ! [I: nat,K: nat,J: nat] :
      ( ( ord_less @ nat @ ( plus_plus @ nat @ I @ K ) @ J )
     => ( ( nth @ nat @ ( upt @ I @ J ) @ K )
        = ( plus_plus @ nat @ I @ K ) ) ) ).

% nth_upt
thf(fact_6663_upt__rec__numeral,axiom,
    ! [M: num,N: num] :
      ( ( ( ord_less @ nat @ ( numeral_numeral @ nat @ M ) @ ( numeral_numeral @ nat @ N ) )
       => ( ( upt @ ( numeral_numeral @ nat @ M ) @ ( numeral_numeral @ nat @ N ) )
          = ( cons @ nat @ ( numeral_numeral @ nat @ M ) @ ( upt @ ( suc @ ( numeral_numeral @ nat @ M ) ) @ ( numeral_numeral @ nat @ N ) ) ) ) )
      & ( ~ ( ord_less @ nat @ ( numeral_numeral @ nat @ M ) @ ( numeral_numeral @ nat @ N ) )
       => ( ( upt @ ( numeral_numeral @ nat @ M ) @ ( numeral_numeral @ nat @ N ) )
          = ( nil @ nat ) ) ) ) ).

% upt_rec_numeral
thf(fact_6664_upt__0,axiom,
    ! [I: nat] :
      ( ( upt @ I @ ( zero_zero @ nat ) )
      = ( nil @ nat ) ) ).

% upt_0
thf(fact_6665_atLeast__upt,axiom,
    ( ( set_ord_lessThan @ nat )
    = ( ^ [N3: nat] : ( set2 @ nat @ ( upt @ ( zero_zero @ nat ) @ N3 ) ) ) ) ).

% atLeast_upt
thf(fact_6666_upt__add__eq__append,axiom,
    ! [I: nat,J: nat,K: nat] :
      ( ( ord_less_eq @ nat @ I @ J )
     => ( ( upt @ I @ ( plus_plus @ nat @ J @ K ) )
        = ( append @ nat @ ( upt @ I @ J ) @ ( upt @ J @ ( plus_plus @ nat @ J @ K ) ) ) ) ) ).

% upt_add_eq_append
thf(fact_6667_atMost__upto,axiom,
    ( ( set_ord_atMost @ nat )
    = ( ^ [N3: nat] : ( set2 @ nat @ ( upt @ ( zero_zero @ nat ) @ ( suc @ N3 ) ) ) ) ) ).

% atMost_upto
thf(fact_6668_upt__conv__Cons,axiom,
    ! [I: nat,J: nat] :
      ( ( ord_less @ nat @ I @ J )
     => ( ( upt @ I @ J )
        = ( cons @ nat @ I @ ( upt @ ( suc @ I ) @ J ) ) ) ) ).

% upt_conv_Cons
thf(fact_6669_upt__rec,axiom,
    ( upt
    = ( ^ [I4: nat,J3: nat] : ( if @ ( list @ nat ) @ ( ord_less @ nat @ I4 @ J3 ) @ ( cons @ nat @ I4 @ ( upt @ ( suc @ I4 ) @ J3 ) ) @ ( nil @ nat ) ) ) ) ).

% upt_rec
thf(fact_6670_upt__Suc__append,axiom,
    ! [I: nat,J: nat] :
      ( ( ord_less_eq @ nat @ I @ J )
     => ( ( upt @ I @ ( suc @ J ) )
        = ( append @ nat @ ( upt @ I @ J ) @ ( cons @ nat @ J @ ( nil @ nat ) ) ) ) ) ).

% upt_Suc_append
thf(fact_6671_upt__Suc,axiom,
    ! [I: nat,J: nat] :
      ( ( ( ord_less_eq @ nat @ I @ J )
       => ( ( upt @ I @ ( suc @ J ) )
          = ( append @ nat @ ( upt @ I @ J ) @ ( cons @ nat @ J @ ( nil @ nat ) ) ) ) )
      & ( ~ ( ord_less_eq @ nat @ I @ J )
       => ( ( upt @ I @ ( suc @ J ) )
          = ( nil @ nat ) ) ) ) ).

% upt_Suc
thf(fact_6672_upt__eq__Cons__conv,axiom,
    ! [I: nat,J: nat,X: nat,Xs: list @ nat] :
      ( ( ( upt @ I @ J )
        = ( cons @ nat @ X @ Xs ) )
      = ( ( ord_less @ nat @ I @ J )
        & ( I = X )
        & ( ( upt @ ( plus_plus @ nat @ I @ ( one_one @ nat ) ) @ J )
          = Xs ) ) ) ).

% upt_eq_Cons_conv
thf(fact_6673_horner__sum__bit__eq__take__bit,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ! [A2: A,N: nat] :
          ( ( groups4207007520872428315er_sum @ $o @ A @ ( zero_neq_one_of_bool @ A ) @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ ( map @ nat @ $o @ ( bit_se5641148757651400278ts_bit @ A @ A2 ) @ ( upt @ ( zero_zero @ nat ) @ N ) ) )
          = ( bit_se2584673776208193580ke_bit @ A @ N @ A2 ) ) ) ).

% horner_sum_bit_eq_take_bit
thf(fact_6674_listrel__iff__nth,axiom,
    ! [A: $tType,B: $tType,Xs: list @ A,Ys3: list @ B,R2: set @ ( product_prod @ A @ B )] :
      ( ( member @ ( product_prod @ ( list @ A ) @ ( list @ B ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ B ) @ Xs @ Ys3 ) @ ( listrel @ A @ B @ R2 ) )
      = ( ( ( size_size @ ( list @ A ) @ Xs )
          = ( size_size @ ( list @ B ) @ Ys3 ) )
        & ! [N3: nat] :
            ( ( ord_less @ nat @ N3 @ ( size_size @ ( list @ A ) @ Xs ) )
           => ( member @ ( product_prod @ A @ B ) @ ( product_Pair @ A @ B @ ( nth @ A @ Xs @ N3 ) @ ( nth @ B @ Ys3 @ N3 ) ) @ R2 ) ) ) ) ).

% listrel_iff_nth
thf(fact_6675_sum__list__0,axiom,
    ! [B: $tType,A: $tType] :
      ( ( monoid_add @ A )
     => ! [Xs: list @ B] :
          ( ( groups8242544230860333062m_list @ A
            @ ( map @ B @ A
              @ ^ [X2: B] : ( zero_zero @ A )
              @ Xs ) )
          = ( zero_zero @ A ) ) ) ).

% sum_list_0
thf(fact_6676_nth__map,axiom,
    ! [B: $tType,A: $tType,N: nat,Xs: list @ A,F2: A > B] :
      ( ( ord_less @ nat @ N @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( ( nth @ B @ ( map @ A @ B @ F2 @ Xs ) @ N )
        = ( F2 @ ( nth @ A @ Xs @ N ) ) ) ) ).

% nth_map
thf(fact_6677_sum__list__abs,axiom,
    ! [A: $tType] :
      ( ( ordere166539214618696060dd_abs @ A )
     => ! [Xs: list @ A] : ( ord_less_eq @ A @ ( abs_abs @ A @ ( groups8242544230860333062m_list @ A @ Xs ) ) @ ( groups8242544230860333062m_list @ A @ ( map @ A @ A @ ( abs_abs @ A ) @ Xs ) ) ) ) ).

% sum_list_abs
thf(fact_6678_sum__list__mono,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( monoid_add @ B )
        & ( ordere6658533253407199908up_add @ B ) )
     => ! [Xs: list @ A,F2: A > B,G: A > B] :
          ( ! [X3: A] :
              ( ( member @ A @ X3 @ ( set2 @ A @ Xs ) )
             => ( ord_less_eq @ B @ ( F2 @ X3 ) @ ( G @ X3 ) ) )
         => ( ord_less_eq @ B @ ( groups8242544230860333062m_list @ B @ ( map @ A @ B @ F2 @ Xs ) ) @ ( groups8242544230860333062m_list @ B @ ( map @ A @ B @ G @ Xs ) ) ) ) ) ).

% sum_list_mono
thf(fact_6679_map__replicate__trivial,axiom,
    ! [A: $tType,X: A,I: nat] :
      ( ( map @ nat @ A
        @ ^ [I4: nat] : X
        @ ( upt @ ( zero_zero @ nat ) @ I ) )
      = ( replicate @ A @ I @ X ) ) ).

% map_replicate_trivial
thf(fact_6680_sum__list__strict__mono,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( monoid_add @ B )
        & ( strict9044650504122735259up_add @ B ) )
     => ! [Xs: list @ A,F2: A > B,G: A > B] :
          ( ( Xs
           != ( nil @ A ) )
         => ( ! [X3: A] :
                ( ( member @ A @ X3 @ ( set2 @ A @ Xs ) )
               => ( ord_less @ B @ ( F2 @ X3 ) @ ( G @ X3 ) ) )
           => ( ord_less @ B @ ( groups8242544230860333062m_list @ B @ ( map @ A @ B @ F2 @ Xs ) ) @ ( groups8242544230860333062m_list @ B @ ( map @ A @ B @ G @ Xs ) ) ) ) ) ) ).

% sum_list_strict_mono
thf(fact_6681_map__upt__Suc,axiom,
    ! [A: $tType,F2: nat > A,N: nat] :
      ( ( map @ nat @ A @ F2 @ ( upt @ ( zero_zero @ nat ) @ ( suc @ N ) ) )
      = ( cons @ A @ ( F2 @ ( zero_zero @ nat ) )
        @ ( map @ nat @ A
          @ ^ [I4: nat] : ( F2 @ ( suc @ I4 ) )
          @ ( upt @ ( zero_zero @ nat ) @ N ) ) ) ) ).

% map_upt_Suc
thf(fact_6682_sum__list__triv,axiom,
    ! [C: $tType,B: $tType] :
      ( ( semiring_1 @ B )
     => ! [R2: B,Xs: list @ C] :
          ( ( groups8242544230860333062m_list @ B
            @ ( map @ C @ B
              @ ^ [X2: C] : R2
              @ Xs ) )
          = ( times_times @ B @ ( semiring_1_of_nat @ B @ ( size_size @ ( list @ C ) @ Xs ) ) @ R2 ) ) ) ).

% sum_list_triv
thf(fact_6683_map__nth,axiom,
    ! [A: $tType,Xs: list @ A] :
      ( ( map @ nat @ A @ ( nth @ A @ Xs ) @ ( upt @ ( zero_zero @ nat ) @ ( size_size @ ( list @ A ) @ Xs ) ) )
      = Xs ) ).

% map_nth
thf(fact_6684_nth__map__upt,axiom,
    ! [A: $tType,I: nat,N: nat,M: nat,F2: nat > A] :
      ( ( ord_less @ nat @ I @ ( minus_minus @ nat @ N @ M ) )
     => ( ( nth @ A @ ( map @ nat @ A @ F2 @ ( upt @ M @ N ) ) @ I )
        = ( F2 @ ( plus_plus @ nat @ M @ I ) ) ) ) ).

% nth_map_upt
thf(fact_6685_map__upt__eqI,axiom,
    ! [A: $tType,Xs: list @ A,N: nat,M: nat,F2: nat > A] :
      ( ( ( size_size @ ( list @ A ) @ Xs )
        = ( minus_minus @ nat @ N @ M ) )
     => ( ! [I2: nat] :
            ( ( ord_less @ nat @ I2 @ ( size_size @ ( list @ A ) @ Xs ) )
           => ( ( nth @ A @ Xs @ I2 )
              = ( F2 @ ( plus_plus @ nat @ M @ I2 ) ) ) )
       => ( ( map @ nat @ A @ F2 @ ( upt @ M @ N ) )
          = Xs ) ) ) ).

% map_upt_eqI
thf(fact_6686_transpose__rectangle,axiom,
    ! [A: $tType,Xs: list @ ( list @ A ),N: nat] :
      ( ( ( Xs
          = ( nil @ ( list @ A ) ) )
       => ( N
          = ( zero_zero @ nat ) ) )
     => ( ! [I2: nat] :
            ( ( ord_less @ nat @ I2 @ ( size_size @ ( list @ ( list @ A ) ) @ Xs ) )
           => ( ( size_size @ ( list @ A ) @ ( nth @ ( list @ A ) @ Xs @ I2 ) )
              = N ) )
       => ( ( transpose @ A @ Xs )
          = ( map @ nat @ ( list @ A )
            @ ^ [I4: nat] :
                ( map @ nat @ A
                @ ^ [J3: nat] : ( nth @ A @ ( nth @ ( list @ A ) @ Xs @ J3 ) @ I4 )
                @ ( upt @ ( zero_zero @ nat ) @ ( size_size @ ( list @ ( list @ A ) ) @ Xs ) ) )
            @ ( upt @ ( zero_zero @ nat ) @ N ) ) ) ) ) ).

% transpose_rectangle
thf(fact_6687_sorted__wrt__less__sum__mono__lowerbound,axiom,
    ! [B: $tType] :
      ( ( ordere6911136660526730532id_add @ B )
     => ! [F2: nat > B,Ns: list @ nat] :
          ( ! [X3: nat,Y5: nat] :
              ( ( ord_less_eq @ nat @ X3 @ Y5 )
             => ( ord_less_eq @ B @ ( F2 @ X3 ) @ ( F2 @ Y5 ) ) )
         => ( ( sorted_wrt @ nat @ ( ord_less @ nat ) @ Ns )
           => ( ord_less_eq @ B @ ( groups7311177749621191930dd_sum @ nat @ B @ F2 @ ( set_or7035219750837199246ssThan @ nat @ ( zero_zero @ nat ) @ ( size_size @ ( list @ nat ) @ Ns ) ) ) @ ( groups8242544230860333062m_list @ B @ ( map @ nat @ B @ F2 @ Ns ) ) ) ) ) ) ).

% sorted_wrt_less_sum_mono_lowerbound
thf(fact_6688_sorted__map,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F2: B > A,Xs: list @ B] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( map @ B @ A @ F2 @ Xs ) )
          = ( sorted_wrt @ B
            @ ^ [X2: B,Y4: B] : ( ord_less_eq @ A @ ( F2 @ X2 ) @ ( F2 @ Y4 ) )
            @ Xs ) ) ) ).

% sorted_map
thf(fact_6689_sorted__enumerate,axiom,
    ! [A: $tType,N: nat,Xs: list @ A] : ( sorted_wrt @ nat @ ( ord_less_eq @ nat ) @ ( map @ ( product_prod @ nat @ A ) @ nat @ ( product_fst @ nat @ A ) @ ( enumerate @ A @ N @ Xs ) ) ) ).

% sorted_enumerate
thf(fact_6690_sorted__take,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A,N: nat] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs )
         => ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( take @ A @ N @ Xs ) ) ) ) ).

% sorted_take
thf(fact_6691_strict__sorted__equal,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A,Ys3: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less @ A ) @ Xs )
         => ( ( sorted_wrt @ A @ ( ord_less @ A ) @ Ys3 )
           => ( ( ( set2 @ A @ Ys3 )
                = ( set2 @ A @ Xs ) )
             => ( Ys3 = Xs ) ) ) ) ) ).

% strict_sorted_equal
thf(fact_6692_sorted0,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( nil @ A ) ) ) ).

% sorted0
thf(fact_6693_strict__sorted__simps_I1_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( sorted_wrt @ A @ ( ord_less @ A ) @ ( nil @ A ) ) ) ).

% strict_sorted_simps(1)
thf(fact_6694_sorted__tl,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs )
         => ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( tl @ A @ Xs ) ) ) ) ).

% sorted_tl
thf(fact_6695_sorted2,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A,Y: A,Zs2: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( cons @ A @ X @ ( cons @ A @ Y @ Zs2 ) ) )
          = ( ( ord_less_eq @ A @ X @ Y )
            & ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( cons @ A @ Y @ Zs2 ) ) ) ) ) ).

% sorted2
thf(fact_6696_sorted__list__of__set_Ostrict__sorted__key__list__of__set,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A4: set @ A] : ( sorted_wrt @ A @ ( ord_less @ A ) @ ( linord4507533701916653071of_set @ A @ A4 ) ) ) ).

% sorted_list_of_set.strict_sorted_key_list_of_set
thf(fact_6697_sorted__list__of__set_Osorted__sorted__key__list__of__set,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A4: set @ A] : ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( linord4507533701916653071of_set @ A @ A4 ) ) ) ).

% sorted_list_of_set.sorted_sorted_key_list_of_set
thf(fact_6698_sorted__remdups__adj,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs )
         => ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( remdups_adj @ A @ Xs ) ) ) ) ).

% sorted_remdups_adj
thf(fact_6699_strict__sorted__imp__sorted,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less @ A ) @ Xs )
         => ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs ) ) ) ).

% strict_sorted_imp_sorted
thf(fact_6700_sorted__nths,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A,I5: set @ nat] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs )
         => ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( nths @ A @ Xs @ I5 ) ) ) ) ).

% sorted_nths
thf(fact_6701_sorted__drop,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A,N: nat] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs )
         => ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( drop @ A @ N @ Xs ) ) ) ) ).

% sorted_drop
thf(fact_6702_sorted__replicate,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [N: nat,X: A] : ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( replicate @ A @ N @ X ) ) ) ).

% sorted_replicate
thf(fact_6703_sorted__wrt__upt,axiom,
    ! [M: nat,N: nat] : ( sorted_wrt @ nat @ ( ord_less @ nat ) @ ( upt @ M @ N ) ) ).

% sorted_wrt_upt
thf(fact_6704_sorted__upt,axiom,
    ! [M: nat,N: nat] : ( sorted_wrt @ nat @ ( ord_less_eq @ nat ) @ ( upt @ M @ N ) ) ).

% sorted_upt
thf(fact_6705_sorted1,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A] : ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( cons @ A @ X @ ( nil @ A ) ) ) ) ).

% sorted1
thf(fact_6706_sorted__simps_I2_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A,Ys3: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( cons @ A @ X @ Ys3 ) )
          = ( ! [X2: A] :
                ( ( member @ A @ X2 @ ( set2 @ A @ Ys3 ) )
               => ( ord_less_eq @ A @ X @ X2 ) )
            & ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Ys3 ) ) ) ) ).

% sorted_simps(2)
thf(fact_6707_strict__sorted__simps_I2_J,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A,Ys3: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less @ A ) @ ( cons @ A @ X @ Ys3 ) )
          = ( ! [X2: A] :
                ( ( member @ A @ X2 @ ( set2 @ A @ Ys3 ) )
               => ( ord_less @ A @ X @ X2 ) )
            & ( sorted_wrt @ A @ ( ord_less @ A ) @ Ys3 ) ) ) ) ).

% strict_sorted_simps(2)
thf(fact_6708_strict__sorted__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [L: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less @ A ) @ L )
          = ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ L )
            & ( distinct @ A @ L ) ) ) ) ).

% strict_sorted_iff
thf(fact_6709_sorted__append,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A,Ys3: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( append @ A @ Xs @ Ys3 ) )
          = ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs )
            & ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Ys3 )
            & ! [X2: A] :
                ( ( member @ A @ X2 @ ( set2 @ A @ Xs ) )
               => ! [Y4: A] :
                    ( ( member @ A @ Y4 @ ( set2 @ A @ Ys3 ) )
                   => ( ord_less_eq @ A @ X2 @ Y4 ) ) ) ) ) ) ).

% sorted_append
thf(fact_6710_sorted__distinct__set__unique,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A,Ys3: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs )
         => ( ( distinct @ A @ Xs )
           => ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Ys3 )
             => ( ( distinct @ A @ Ys3 )
               => ( ( ( set2 @ A @ Xs )
                    = ( set2 @ A @ Ys3 ) )
                 => ( Xs = Ys3 ) ) ) ) ) ) ) ).

% sorted_distinct_set_unique
thf(fact_6711_sorted__wrt__iff__nth__less,axiom,
    ! [A: $tType] :
      ( ( sorted_wrt @ A )
      = ( ^ [P3: A > A > $o,Xs3: list @ A] :
          ! [I4: nat,J3: nat] :
            ( ( ord_less @ nat @ I4 @ J3 )
           => ( ( ord_less @ nat @ J3 @ ( size_size @ ( list @ A ) @ Xs3 ) )
             => ( P3 @ ( nth @ A @ Xs3 @ I4 ) @ ( nth @ A @ Xs3 @ J3 ) ) ) ) ) ) ).

% sorted_wrt_iff_nth_less
thf(fact_6712_sorted__wrt__nth__less,axiom,
    ! [A: $tType,P: A > A > $o,Xs: list @ A,I: nat,J: nat] :
      ( ( sorted_wrt @ A @ P @ Xs )
     => ( ( ord_less @ nat @ I @ J )
       => ( ( ord_less @ nat @ J @ ( size_size @ ( list @ A ) @ Xs ) )
         => ( P @ ( nth @ A @ Xs @ I ) @ ( nth @ A @ Xs @ J ) ) ) ) ) ).

% sorted_wrt_nth_less
thf(fact_6713_sorted__wrt01,axiom,
    ! [A: $tType,Xs: list @ A,P: A > A > $o] :
      ( ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ ( one_one @ nat ) )
     => ( sorted_wrt @ A @ P @ Xs ) ) ).

% sorted_wrt01
thf(fact_6714_sorted__butlast,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A] :
          ( ( Xs
           != ( nil @ A ) )
         => ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs )
           => ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( butlast @ A @ Xs ) ) ) ) ) ).

% sorted_butlast
thf(fact_6715_map__add__upt,axiom,
    ! [N: nat,M: nat] :
      ( ( map @ nat @ nat
        @ ^ [I4: nat] : ( plus_plus @ nat @ I4 @ N )
        @ ( upt @ ( zero_zero @ nat ) @ M ) )
      = ( upt @ N @ ( plus_plus @ nat @ M @ N ) ) ) ).

% map_add_upt
thf(fact_6716_sorted__iff__nth__mono__less,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs )
          = ( ! [I4: nat,J3: nat] :
                ( ( ord_less @ nat @ I4 @ J3 )
               => ( ( ord_less @ nat @ J3 @ ( size_size @ ( list @ A ) @ Xs ) )
                 => ( ord_less_eq @ A @ ( nth @ A @ Xs @ I4 ) @ ( nth @ A @ Xs @ J3 ) ) ) ) ) ) ) ).

% sorted_iff_nth_mono_less
thf(fact_6717_sorted01,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A] :
          ( ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ ( one_one @ nat ) )
         => ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs ) ) ) ).

% sorted01
thf(fact_6718_finite__sorted__distinct__unique,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A4: set @ A] :
          ( ( finite_finite @ A @ A4 )
         => ? [X3: list @ A] :
              ( ( ( set2 @ A @ X3 )
                = A4 )
              & ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ X3 )
              & ( distinct @ A @ X3 )
              & ! [Y6: list @ A] :
                  ( ( ( ( set2 @ A @ Y6 )
                      = A4 )
                    & ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Y6 )
                    & ( distinct @ A @ Y6 ) )
                 => ( Y6 = X3 ) ) ) ) ) ).

% finite_sorted_distinct_unique
thf(fact_6719_sorted__list__of__set_Oidem__if__sorted__distinct,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs )
         => ( ( distinct @ A @ Xs )
           => ( ( linord4507533701916653071of_set @ A @ ( set2 @ A @ Xs ) )
              = Xs ) ) ) ) ).

% sorted_list_of_set.idem_if_sorted_distinct
thf(fact_6720_map__decr__upt,axiom,
    ! [M: nat,N: nat] :
      ( ( map @ nat @ nat
        @ ^ [N3: nat] : ( minus_minus @ nat @ N3 @ ( suc @ ( zero_zero @ nat ) ) )
        @ ( upt @ ( suc @ M ) @ ( suc @ N ) ) )
      = ( upt @ M @ N ) ) ).

% map_decr_upt
thf(fact_6721_sorted__iff__nth__Suc,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs )
          = ( ! [I4: nat] :
                ( ( ord_less @ nat @ ( suc @ I4 ) @ ( size_size @ ( list @ A ) @ Xs ) )
               => ( ord_less_eq @ A @ ( nth @ A @ Xs @ I4 ) @ ( nth @ A @ Xs @ ( suc @ I4 ) ) ) ) ) ) ) ).

% sorted_iff_nth_Suc
thf(fact_6722_sorted__list__of__set_Ofinite__set__strict__sorted,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A4: set @ A] :
          ( ( finite_finite @ A @ A4 )
         => ~ ! [L3: list @ A] :
                ( ( sorted_wrt @ A @ ( ord_less @ A ) @ L3 )
               => ( ( ( set2 @ A @ L3 )
                    = A4 )
                 => ( ( size_size @ ( list @ A ) @ L3 )
                   != ( finite_card @ A @ A4 ) ) ) ) ) ) ).

% sorted_list_of_set.finite_set_strict_sorted
thf(fact_6723_sorted__iff__nth__mono,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs )
          = ( ! [I4: nat,J3: nat] :
                ( ( ord_less_eq @ nat @ I4 @ J3 )
               => ( ( ord_less @ nat @ J3 @ ( size_size @ ( list @ A ) @ Xs ) )
                 => ( ord_less_eq @ A @ ( nth @ A @ Xs @ I4 ) @ ( nth @ A @ Xs @ J3 ) ) ) ) ) ) ) ).

% sorted_iff_nth_mono
thf(fact_6724_sorted__nth__mono,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A,I: nat,J: nat] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs )
         => ( ( ord_less_eq @ nat @ I @ J )
           => ( ( ord_less @ nat @ J @ ( size_size @ ( list @ A ) @ Xs ) )
             => ( ord_less_eq @ A @ ( nth @ A @ Xs @ I ) @ ( nth @ A @ Xs @ J ) ) ) ) ) ) ).

% sorted_nth_mono
thf(fact_6725_sorted__wrt__less__idx,axiom,
    ! [Ns: list @ nat,I: nat] :
      ( ( sorted_wrt @ nat @ ( ord_less @ nat ) @ Ns )
     => ( ( ord_less @ nat @ I @ ( size_size @ ( list @ nat ) @ Ns ) )
       => ( ord_less_eq @ nat @ I @ ( nth @ nat @ Ns @ I ) ) ) ) ).

% sorted_wrt_less_idx
thf(fact_6726_sorted__find__Min,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A,P: A > $o] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs )
         => ( ? [X5: A] :
                ( ( member @ A @ X5 @ ( set2 @ A @ Xs ) )
                & ( P @ X5 ) )
           => ( ( find @ A @ P @ Xs )
              = ( some @ A
                @ ( lattic643756798350308766er_Min @ A
                  @ ( collect @ A
                    @ ^ [X2: A] :
                        ( ( member @ A @ X2 @ ( set2 @ A @ Xs ) )
                        & ( P @ X2 ) ) ) ) ) ) ) ) ) ).

% sorted_find_Min
thf(fact_6727_map__sorted__distinct__set__unique,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F2: B > A,Xs: list @ B,Ys3: list @ B] :
          ( ( inj_on @ B @ A @ F2 @ ( sup_sup @ ( set @ B ) @ ( set2 @ B @ Xs ) @ ( set2 @ B @ Ys3 ) ) )
         => ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( map @ B @ A @ F2 @ Xs ) )
           => ( ( distinct @ A @ ( map @ B @ A @ F2 @ Xs ) )
             => ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( map @ B @ A @ F2 @ Ys3 ) )
               => ( ( distinct @ A @ ( map @ B @ A @ F2 @ Ys3 ) )
                 => ( ( ( set2 @ B @ Xs )
                      = ( set2 @ B @ Ys3 ) )
                   => ( Xs = Ys3 ) ) ) ) ) ) ) ) ).

% map_sorted_distinct_set_unique
thf(fact_6728_sorted__list__of__set_Osorted__key__list__of__set__unique,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A4: set @ A,L: list @ A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( ( sorted_wrt @ A @ ( ord_less @ A ) @ L )
              & ( ( set2 @ A @ L )
                = A4 )
              & ( ( size_size @ ( list @ A ) @ L )
                = ( finite_card @ A @ A4 ) ) )
            = ( ( linord4507533701916653071of_set @ A @ A4 )
              = L ) ) ) ) ).

% sorted_list_of_set.sorted_key_list_of_set_unique
thf(fact_6729_length__transpose__sorted,axiom,
    ! [A: $tType,Xs: list @ ( list @ A )] :
      ( ( sorted_wrt @ nat @ ( ord_less_eq @ nat ) @ ( rev @ nat @ ( map @ ( list @ A ) @ nat @ ( size_size @ ( list @ A ) ) @ Xs ) ) )
     => ( ( ( Xs
            = ( nil @ ( list @ A ) ) )
         => ( ( size_size @ ( list @ ( list @ A ) ) @ ( transpose @ A @ Xs ) )
            = ( zero_zero @ nat ) ) )
        & ( ( Xs
           != ( nil @ ( list @ A ) ) )
         => ( ( size_size @ ( list @ ( list @ A ) ) @ ( transpose @ A @ Xs ) )
            = ( size_size @ ( list @ A ) @ ( nth @ ( list @ A ) @ Xs @ ( zero_zero @ nat ) ) ) ) ) ) ) ).

% length_transpose_sorted
thf(fact_6730_length__transpose,axiom,
    ! [A: $tType,Xs: list @ ( list @ A )] :
      ( ( size_size @ ( list @ ( list @ A ) ) @ ( transpose @ A @ Xs ) )
      = ( foldr @ ( list @ A ) @ nat
        @ ^ [Xs3: list @ A] : ( ord_max @ nat @ ( size_size @ ( list @ A ) @ Xs3 ) )
        @ Xs
        @ ( zero_zero @ nat ) ) ) ).

% length_transpose
thf(fact_6731_sorted__wrt__upto,axiom,
    ! [I: int,J: int] : ( sorted_wrt @ int @ ( ord_less @ int ) @ ( upto @ I @ J ) ) ).

% sorted_wrt_upto
thf(fact_6732_sorted__upto,axiom,
    ! [M: int,N: int] : ( sorted_wrt @ int @ ( ord_less_eq @ int ) @ ( upto @ M @ N ) ) ).

% sorted_upto
thf(fact_6733_foldr__max__sorted,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A,Y: A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( rev @ A @ Xs ) )
         => ( ( ( Xs
                = ( nil @ A ) )
             => ( ( foldr @ A @ A @ ( ord_max @ A ) @ Xs @ Y )
                = Y ) )
            & ( ( Xs
               != ( nil @ A ) )
             => ( ( foldr @ A @ A @ ( ord_max @ A ) @ Xs @ Y )
                = ( ord_max @ A @ ( nth @ A @ Xs @ ( zero_zero @ nat ) ) @ Y ) ) ) ) ) ) ).

% foldr_max_sorted
thf(fact_6734_sum__list_Oeq__foldr,axiom,
    ! [A: $tType] :
      ( ( monoid_add @ A )
     => ( ( groups8242544230860333062m_list @ A )
        = ( ^ [Xs3: list @ A] : ( foldr @ A @ A @ ( plus_plus @ A ) @ Xs3 @ ( zero_zero @ A ) ) ) ) ) ).

% sum_list.eq_foldr
thf(fact_6735_sorted__transpose,axiom,
    ! [A: $tType,Xs: list @ ( list @ A )] : ( sorted_wrt @ nat @ ( ord_less_eq @ nat ) @ ( rev @ nat @ ( map @ ( list @ A ) @ nat @ ( size_size @ ( list @ A ) ) @ ( transpose @ A @ Xs ) ) ) ) ).

% sorted_transpose
thf(fact_6736_rev__nth,axiom,
    ! [A: $tType,N: nat,Xs: list @ A] :
      ( ( ord_less @ nat @ N @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( ( nth @ A @ ( rev @ A @ Xs ) @ N )
        = ( nth @ A @ Xs @ ( minus_minus @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ ( suc @ N ) ) ) ) ) ).

% rev_nth
thf(fact_6737_rev__update,axiom,
    ! [A: $tType,K: nat,Xs: list @ A,Y: A] :
      ( ( ord_less @ nat @ K @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( ( rev @ A @ ( list_update @ A @ Xs @ K @ Y ) )
        = ( list_update @ A @ ( rev @ A @ Xs ) @ ( minus_minus @ nat @ ( minus_minus @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ K ) @ ( one_one @ nat ) ) @ Y ) ) ) ).

% rev_update
thf(fact_6738_sorted__rev__iff__nth__Suc,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( rev @ A @ Xs ) )
          = ( ! [I4: nat] :
                ( ( ord_less @ nat @ ( suc @ I4 ) @ ( size_size @ ( list @ A ) @ Xs ) )
               => ( ord_less_eq @ A @ ( nth @ A @ Xs @ ( suc @ I4 ) ) @ ( nth @ A @ Xs @ I4 ) ) ) ) ) ) ).

% sorted_rev_iff_nth_Suc
thf(fact_6739_sorted__rev__iff__nth__mono,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( rev @ A @ Xs ) )
          = ( ! [I4: nat,J3: nat] :
                ( ( ord_less_eq @ nat @ I4 @ J3 )
               => ( ( ord_less @ nat @ J3 @ ( size_size @ ( list @ A ) @ Xs ) )
                 => ( ord_less_eq @ A @ ( nth @ A @ Xs @ J3 ) @ ( nth @ A @ Xs @ I4 ) ) ) ) ) ) ) ).

% sorted_rev_iff_nth_mono
thf(fact_6740_sorted__rev__nth__mono,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A,I: nat,J: nat] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( rev @ A @ Xs ) )
         => ( ( ord_less_eq @ nat @ I @ J )
           => ( ( ord_less @ nat @ J @ ( size_size @ ( list @ A ) @ Xs ) )
             => ( ord_less_eq @ A @ ( nth @ A @ Xs @ J ) @ ( nth @ A @ Xs @ I ) ) ) ) ) ) ).

% sorted_rev_nth_mono
thf(fact_6741_horner__sum__foldr,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_semiring_0 @ A )
     => ( ( groups4207007520872428315er_sum @ B @ A )
        = ( ^ [F3: B > A,A3: A,Xs3: list @ B] :
              ( foldr @ B @ A
              @ ^ [X2: B,B3: A] : ( plus_plus @ A @ ( F3 @ X2 ) @ ( times_times @ A @ A3 @ B3 ) )
              @ Xs3
              @ ( zero_zero @ A ) ) ) ) ) ).

% horner_sum_foldr
thf(fact_6742_nth__nth__transpose__sorted,axiom,
    ! [A: $tType,Xs: list @ ( list @ A ),I: nat,J: nat] :
      ( ( sorted_wrt @ nat @ ( ord_less_eq @ nat ) @ ( rev @ nat @ ( map @ ( list @ A ) @ nat @ ( size_size @ ( list @ A ) ) @ Xs ) ) )
     => ( ( ord_less @ nat @ I @ ( size_size @ ( list @ ( list @ A ) ) @ ( transpose @ A @ Xs ) ) )
       => ( ( ord_less @ nat @ J
            @ ( size_size @ ( list @ ( list @ A ) )
              @ ( filter2 @ ( list @ A )
                @ ^ [Ys2: list @ A] : ( ord_less @ nat @ I @ ( size_size @ ( list @ A ) @ Ys2 ) )
                @ Xs ) ) )
         => ( ( nth @ A @ ( nth @ ( list @ A ) @ ( transpose @ A @ Xs ) @ I ) @ J )
            = ( nth @ A @ ( nth @ ( list @ A ) @ Xs @ J ) @ I ) ) ) ) ) ).

% nth_nth_transpose_sorted
thf(fact_6743_transpose__column,axiom,
    ! [A: $tType,Xs: list @ ( list @ A ),I: nat] :
      ( ( sorted_wrt @ nat @ ( ord_less_eq @ nat ) @ ( rev @ nat @ ( map @ ( list @ A ) @ nat @ ( size_size @ ( list @ A ) ) @ Xs ) ) )
     => ( ( ord_less @ nat @ I @ ( size_size @ ( list @ ( list @ A ) ) @ Xs ) )
       => ( ( map @ ( list @ A ) @ A
            @ ^ [Ys2: list @ A] : ( nth @ A @ Ys2 @ I )
            @ ( filter2 @ ( list @ A )
              @ ^ [Ys2: list @ A] : ( ord_less @ nat @ I @ ( size_size @ ( list @ A ) @ Ys2 ) )
              @ ( transpose @ A @ Xs ) ) )
          = ( nth @ ( list @ A ) @ Xs @ I ) ) ) ) ).

% transpose_column
thf(fact_6744_sorted__same,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [G: ( list @ A ) > A,Xs: list @ A] :
          ( sorted_wrt @ A @ ( ord_less_eq @ A )
          @ ( filter2 @ A
            @ ^ [X2: A] :
                ( X2
                = ( G @ Xs ) )
            @ Xs ) ) ) ).

% sorted_same
thf(fact_6745_length__filter__le,axiom,
    ! [A: $tType,P: A > $o,Xs: list @ A] : ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ ( filter2 @ A @ P @ Xs ) ) @ ( size_size @ ( list @ A ) @ Xs ) ) ).

% length_filter_le
thf(fact_6746_length__filter__less,axiom,
    ! [A: $tType,X: A,Xs: list @ A,P: A > $o] :
      ( ( member @ A @ X @ ( set2 @ A @ Xs ) )
     => ( ~ ( P @ X )
       => ( ord_less @ nat @ ( size_size @ ( list @ A ) @ ( filter2 @ A @ P @ Xs ) ) @ ( size_size @ ( list @ A ) @ Xs ) ) ) ) ).

% length_filter_less
thf(fact_6747_sorted__filter,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F2: B > A,Xs: list @ B,P: B > $o] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( map @ B @ A @ F2 @ Xs ) )
         => ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( map @ B @ A @ F2 @ ( filter2 @ B @ P @ Xs ) ) ) ) ) ).

% sorted_filter
thf(fact_6748_sorted__map__same,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F2: B > A,G: ( list @ B ) > A,Xs: list @ B] :
          ( sorted_wrt @ A @ ( ord_less_eq @ A )
          @ ( map @ B @ A @ F2
            @ ( filter2 @ B
              @ ^ [X2: B] :
                  ( ( F2 @ X2 )
                  = ( G @ Xs ) )
              @ Xs ) ) ) ) ).

% sorted_map_same
thf(fact_6749_sum__list__map__filter_H,axiom,
    ! [A: $tType,B: $tType] :
      ( ( monoid_add @ A )
     => ! [F2: B > A,P: B > $o,Xs: list @ B] :
          ( ( groups8242544230860333062m_list @ A @ ( map @ B @ A @ F2 @ ( filter2 @ B @ P @ Xs ) ) )
          = ( groups8242544230860333062m_list @ A
            @ ( map @ B @ A
              @ ^ [X2: B] : ( if @ A @ ( P @ X2 ) @ ( F2 @ X2 ) @ ( zero_zero @ A ) )
              @ Xs ) ) ) ) ).

% sum_list_map_filter'
thf(fact_6750_sum__list__filter__le__nat,axiom,
    ! [A: $tType,F2: A > nat,P: A > $o,Xs: list @ A] : ( ord_less_eq @ nat @ ( groups8242544230860333062m_list @ nat @ ( map @ A @ nat @ F2 @ ( filter2 @ A @ P @ Xs ) ) ) @ ( groups8242544230860333062m_list @ nat @ ( map @ A @ nat @ F2 @ Xs ) ) ) ).

% sum_list_filter_le_nat
thf(fact_6751_sum__list__map__filter,axiom,
    ! [A: $tType,B: $tType] :
      ( ( monoid_add @ A )
     => ! [Xs: list @ B,P: B > $o,F2: B > A] :
          ( ! [X3: B] :
              ( ( member @ B @ X3 @ ( set2 @ B @ Xs ) )
             => ( ~ ( P @ X3 )
               => ( ( F2 @ X3 )
                  = ( zero_zero @ A ) ) ) )
         => ( ( groups8242544230860333062m_list @ A @ ( map @ B @ A @ F2 @ ( filter2 @ B @ P @ Xs ) ) )
            = ( groups8242544230860333062m_list @ A @ ( map @ B @ A @ F2 @ Xs ) ) ) ) ) ).

% sum_list_map_filter
thf(fact_6752_filter__eq__nths,axiom,
    ! [A: $tType] :
      ( ( filter2 @ A )
      = ( ^ [P3: A > $o,Xs3: list @ A] :
            ( nths @ A @ Xs3
            @ ( collect @ nat
              @ ^ [I4: nat] :
                  ( ( ord_less @ nat @ I4 @ ( size_size @ ( list @ A ) @ Xs3 ) )
                  & ( P3 @ ( nth @ A @ Xs3 @ I4 ) ) ) ) ) ) ) ).

% filter_eq_nths
thf(fact_6753_length__filter__conv__card,axiom,
    ! [A: $tType,P6: A > $o,Xs: list @ A] :
      ( ( size_size @ ( list @ A ) @ ( filter2 @ A @ P6 @ Xs ) )
      = ( finite_card @ nat
        @ ( collect @ nat
          @ ^ [I4: nat] :
              ( ( ord_less @ nat @ I4 @ ( size_size @ ( list @ A ) @ Xs ) )
              & ( P6 @ ( nth @ A @ Xs @ I4 ) ) ) ) ) ) ).

% length_filter_conv_card
thf(fact_6754_transpose__aux__max,axiom,
    ! [A: $tType,B: $tType,Xs: list @ A,Xss: list @ ( list @ B )] :
      ( ( ord_max @ nat @ ( suc @ ( size_size @ ( list @ A ) @ Xs ) )
        @ ( foldr @ ( list @ B ) @ nat
          @ ^ [Xs3: list @ B] : ( ord_max @ nat @ ( size_size @ ( list @ B ) @ Xs3 ) )
          @ Xss
          @ ( zero_zero @ nat ) ) )
      = ( suc
        @ ( ord_max @ nat @ ( size_size @ ( list @ A ) @ Xs )
          @ ( foldr @ ( list @ B ) @ nat
            @ ^ [X2: list @ B] : ( ord_max @ nat @ ( minus_minus @ nat @ ( size_size @ ( list @ B ) @ X2 ) @ ( suc @ ( zero_zero @ nat ) ) ) )
            @ ( filter2 @ ( list @ B )
              @ ^ [Ys2: list @ B] :
                  ( Ys2
                 != ( nil @ B ) )
              @ Xss )
            @ ( zero_zero @ nat ) ) ) ) ) ).

% transpose_aux_max
thf(fact_6755_nth__transpose,axiom,
    ! [A: $tType,I: nat,Xs: list @ ( list @ A )] :
      ( ( ord_less @ nat @ I @ ( size_size @ ( list @ ( list @ A ) ) @ ( transpose @ A @ Xs ) ) )
     => ( ( nth @ ( list @ A ) @ ( transpose @ A @ Xs ) @ I )
        = ( map @ ( list @ A ) @ A
          @ ^ [Xs3: list @ A] : ( nth @ A @ Xs3 @ I )
          @ ( filter2 @ ( list @ A )
            @ ^ [Ys2: list @ A] : ( ord_less @ nat @ I @ ( size_size @ ( list @ A ) @ Ys2 ) )
            @ Xs ) ) ) ) ).

% nth_transpose
thf(fact_6756_transpose__max__length,axiom,
    ! [A: $tType,Xs: list @ ( list @ A )] :
      ( ( foldr @ ( list @ A ) @ nat
        @ ^ [Xs3: list @ A] : ( ord_max @ nat @ ( size_size @ ( list @ A ) @ Xs3 ) )
        @ ( transpose @ A @ Xs )
        @ ( zero_zero @ nat ) )
      = ( size_size @ ( list @ ( list @ A ) )
        @ ( filter2 @ ( list @ A )
          @ ^ [X2: list @ A] :
              ( X2
             != ( nil @ A ) )
          @ Xs ) ) ) ).

% transpose_max_length
thf(fact_6757_transpose__column__length,axiom,
    ! [A: $tType,Xs: list @ ( list @ A ),I: nat] :
      ( ( sorted_wrt @ nat @ ( ord_less_eq @ nat ) @ ( rev @ nat @ ( map @ ( list @ A ) @ nat @ ( size_size @ ( list @ A ) ) @ Xs ) ) )
     => ( ( ord_less @ nat @ I @ ( size_size @ ( list @ ( list @ A ) ) @ Xs ) )
       => ( ( size_size @ ( list @ ( list @ A ) )
            @ ( filter2 @ ( list @ A )
              @ ^ [Ys2: list @ A] : ( ord_less @ nat @ I @ ( size_size @ ( list @ A ) @ Ys2 ) )
              @ ( transpose @ A @ Xs ) ) )
          = ( size_size @ ( list @ A ) @ ( nth @ ( list @ A ) @ Xs @ I ) ) ) ) ) ).

% transpose_column_length
thf(fact_6758_transpose__transpose,axiom,
    ! [A: $tType,Xs: list @ ( list @ A )] :
      ( ( sorted_wrt @ nat @ ( ord_less_eq @ nat ) @ ( rev @ nat @ ( map @ ( list @ A ) @ nat @ ( size_size @ ( list @ A ) ) @ Xs ) ) )
     => ( ( transpose @ A @ ( transpose @ A @ Xs ) )
        = ( takeWhile @ ( list @ A )
          @ ^ [X2: list @ A] :
              ( X2
             != ( nil @ A ) )
          @ Xs ) ) ) ).

% transpose_transpose
thf(fact_6759_sorted__insort__is__snoc,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A,A2: A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs )
         => ( ! [X3: A] :
                ( ( member @ A @ X3 @ ( set2 @ A @ Xs ) )
               => ( ord_less_eq @ A @ X3 @ A2 ) )
           => ( ( linorder_insort_key @ A @ A
                @ ^ [X2: A] : X2
                @ A2
                @ Xs )
              = ( append @ A @ Xs @ ( cons @ A @ A2 @ ( nil @ A ) ) ) ) ) ) ) ).

% sorted_insort_is_snoc
thf(fact_6760_sorted__takeWhile,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A,P: A > $o] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs )
         => ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( takeWhile @ A @ P @ Xs ) ) ) ) ).

% sorted_takeWhile
thf(fact_6761_sorted__insort,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A,Xs: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A )
            @ ( linorder_insort_key @ A @ A
              @ ^ [X2: A] : X2
              @ X
              @ Xs ) )
          = ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs ) ) ) ).

% sorted_insort
thf(fact_6762_length__takeWhile__le,axiom,
    ! [A: $tType,P: A > $o,Xs: list @ A] : ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ ( takeWhile @ A @ P @ Xs ) ) @ ( size_size @ ( list @ A ) @ Xs ) ) ).

% length_takeWhile_le
thf(fact_6763_insort__key_Osimps_I2_J,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F2: B > A,X: B,Y: B,Ys3: list @ B] :
          ( ( ( ord_less_eq @ A @ ( F2 @ X ) @ ( F2 @ Y ) )
           => ( ( linorder_insort_key @ B @ A @ F2 @ X @ ( cons @ B @ Y @ Ys3 ) )
              = ( cons @ B @ X @ ( cons @ B @ Y @ Ys3 ) ) ) )
          & ( ~ ( ord_less_eq @ A @ ( F2 @ X ) @ ( F2 @ Y ) )
           => ( ( linorder_insort_key @ B @ A @ F2 @ X @ ( cons @ B @ Y @ Ys3 ) )
              = ( cons @ B @ Y @ ( linorder_insort_key @ B @ A @ F2 @ X @ Ys3 ) ) ) ) ) ) ).

% insort_key.simps(2)
thf(fact_6764_insort__is__Cons,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ B,F2: B > A,A2: B] :
          ( ! [X3: B] :
              ( ( member @ B @ X3 @ ( set2 @ B @ Xs ) )
             => ( ord_less_eq @ A @ ( F2 @ A2 ) @ ( F2 @ X3 ) ) )
         => ( ( linorder_insort_key @ B @ A @ F2 @ A2 @ Xs )
            = ( cons @ B @ A2 @ Xs ) ) ) ) ).

% insort_is_Cons
thf(fact_6765_takeWhile__nth,axiom,
    ! [A: $tType,J: nat,P: A > $o,Xs: list @ A] :
      ( ( ord_less @ nat @ J @ ( size_size @ ( list @ A ) @ ( takeWhile @ A @ P @ Xs ) ) )
     => ( ( nth @ A @ ( takeWhile @ A @ P @ Xs ) @ J )
        = ( nth @ A @ Xs @ J ) ) ) ).

% takeWhile_nth
thf(fact_6766_nth__length__takeWhile,axiom,
    ! [A: $tType,P: A > $o,Xs: list @ A] :
      ( ( ord_less @ nat @ ( size_size @ ( list @ A ) @ ( takeWhile @ A @ P @ Xs ) ) @ ( size_size @ ( list @ A ) @ Xs ) )
     => ~ ( P @ ( nth @ A @ Xs @ ( size_size @ ( list @ A ) @ ( takeWhile @ A @ P @ Xs ) ) ) ) ) ).

% nth_length_takeWhile
thf(fact_6767_sorted__insort__key,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F2: B > A,X: B,Xs: list @ B] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( map @ B @ A @ F2 @ ( linorder_insort_key @ B @ A @ F2 @ X @ Xs ) ) )
          = ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( map @ B @ A @ F2 @ Xs ) ) ) ) ).

% sorted_insort_key
thf(fact_6768_length__takeWhile__less__P__nth,axiom,
    ! [A: $tType,J: nat,P: A > $o,Xs: list @ A] :
      ( ! [I2: nat] :
          ( ( ord_less @ nat @ I2 @ J )
         => ( P @ ( nth @ A @ Xs @ I2 ) ) )
     => ( ( ord_less_eq @ nat @ J @ ( size_size @ ( list @ A ) @ Xs ) )
       => ( ord_less_eq @ nat @ J @ ( size_size @ ( list @ A ) @ ( takeWhile @ A @ P @ Xs ) ) ) ) ) ).

% length_takeWhile_less_P_nth
thf(fact_6769_takeWhile__eq__take__P__nth,axiom,
    ! [A: $tType,N: nat,Xs: list @ A,P: A > $o] :
      ( ! [I2: nat] :
          ( ( ord_less @ nat @ I2 @ N )
         => ( ( ord_less @ nat @ I2 @ ( size_size @ ( list @ A ) @ Xs ) )
           => ( P @ ( nth @ A @ Xs @ I2 ) ) ) )
     => ( ( ( ord_less @ nat @ N @ ( size_size @ ( list @ A ) @ Xs ) )
         => ~ ( P @ ( nth @ A @ Xs @ N ) ) )
       => ( ( takeWhile @ A @ P @ Xs )
          = ( take @ A @ N @ Xs ) ) ) ) ).

% takeWhile_eq_take_P_nth
thf(fact_6770_filter__insort,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F2: B > A,Xs: list @ B,P: B > $o,X: B] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( map @ B @ A @ F2 @ Xs ) )
         => ( ( P @ X )
           => ( ( filter2 @ B @ P @ ( linorder_insort_key @ B @ A @ F2 @ X @ Xs ) )
              = ( linorder_insort_key @ B @ A @ F2 @ X @ ( filter2 @ B @ P @ Xs ) ) ) ) ) ) ).

% filter_insort
thf(fact_6771_nths__shift__lemma,axiom,
    ! [A: $tType,A4: set @ nat,Xs: list @ A,I: nat] :
      ( ( map @ ( product_prod @ A @ nat ) @ A @ ( product_fst @ A @ nat )
        @ ( filter2 @ ( product_prod @ A @ nat )
          @ ^ [P5: product_prod @ A @ nat] : ( member @ nat @ ( product_snd @ A @ nat @ P5 ) @ A4 )
          @ ( zip @ A @ nat @ Xs @ ( upt @ I @ ( plus_plus @ nat @ I @ ( size_size @ ( list @ A ) @ Xs ) ) ) ) ) )
      = ( map @ ( product_prod @ A @ nat ) @ A @ ( product_fst @ A @ nat )
        @ ( filter2 @ ( product_prod @ A @ nat )
          @ ^ [P5: product_prod @ A @ nat] : ( member @ nat @ ( plus_plus @ nat @ ( product_snd @ A @ nat @ P5 ) @ I ) @ A4 )
          @ ( zip @ A @ nat @ Xs @ ( upt @ ( zero_zero @ nat ) @ ( size_size @ ( list @ A ) @ Xs ) ) ) ) ) ) ).

% nths_shift_lemma
thf(fact_6772_nths__def,axiom,
    ! [A: $tType] :
      ( ( nths @ A )
      = ( ^ [Xs3: list @ A,A7: set @ nat] :
            ( map @ ( product_prod @ A @ nat ) @ A @ ( product_fst @ A @ nat )
            @ ( filter2 @ ( product_prod @ A @ nat )
              @ ^ [P5: product_prod @ A @ nat] : ( member @ nat @ ( product_snd @ A @ nat @ P5 ) @ A7 )
              @ ( zip @ A @ nat @ Xs3 @ ( upt @ ( zero_zero @ nat ) @ ( size_size @ ( list @ A ) @ Xs3 ) ) ) ) ) ) ) ).

% nths_def
thf(fact_6773_filter__equals__takeWhile__sorted__rev,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F2: B > A,Xs: list @ B,T2: A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( rev @ A @ ( map @ B @ A @ F2 @ Xs ) ) )
         => ( ( filter2 @ B
              @ ^ [X2: B] : ( ord_less @ A @ T2 @ ( F2 @ X2 ) )
              @ Xs )
            = ( takeWhile @ B
              @ ^ [X2: B] : ( ord_less @ A @ T2 @ ( F2 @ X2 ) )
              @ Xs ) ) ) ) ).

% filter_equals_takeWhile_sorted_rev
thf(fact_6774_insort__key__remove1,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [A2: B,Xs: list @ B,F2: B > A] :
          ( ( member @ B @ A2 @ ( set2 @ B @ Xs ) )
         => ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( map @ B @ A @ F2 @ Xs ) )
           => ( ( ( hd @ B
                  @ ( filter2 @ B
                    @ ^ [X2: B] :
                        ( ( F2 @ A2 )
                        = ( F2 @ X2 ) )
                    @ Xs ) )
                = A2 )
             => ( ( linorder_insort_key @ B @ A @ F2 @ A2 @ ( remove1 @ B @ A2 @ Xs ) )
                = Xs ) ) ) ) ) ).

% insort_key_remove1
thf(fact_6775_last__upt,axiom,
    ! [I: nat,J: nat] :
      ( ( ord_less @ nat @ I @ J )
     => ( ( last @ nat @ ( upt @ I @ J ) )
        = ( minus_minus @ nat @ J @ ( one_one @ nat ) ) ) ) ).

% last_upt
thf(fact_6776_last__replicate,axiom,
    ! [A: $tType,N: nat,X: A] :
      ( ( N
       != ( zero_zero @ nat ) )
     => ( ( last @ A @ ( replicate @ A @ N @ X ) )
        = X ) ) ).

% last_replicate
thf(fact_6777_last__drop,axiom,
    ! [A: $tType,N: nat,Xs: list @ A] :
      ( ( ord_less @ nat @ N @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( ( last @ A @ ( drop @ A @ N @ Xs ) )
        = ( last @ A @ Xs ) ) ) ).

% last_drop
thf(fact_6778_sorted__remove1,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A,A2: A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs )
         => ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( remove1 @ A @ A2 @ Xs ) ) ) ) ).

% sorted_remove1
thf(fact_6779_sorted__map__remove1,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F2: B > A,Xs: list @ B,X: B] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( map @ B @ A @ F2 @ Xs ) )
         => ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( map @ B @ A @ F2 @ ( remove1 @ B @ X @ Xs ) ) ) ) ) ).

% sorted_map_remove1
thf(fact_6780_insort__remove1,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A2: A,Xs: list @ A] :
          ( ( member @ A @ A2 @ ( set2 @ A @ Xs ) )
         => ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs )
           => ( ( linorder_insort_key @ A @ A
                @ ^ [X2: A] : X2
                @ A2
                @ ( remove1 @ A @ A2 @ Xs ) )
              = Xs ) ) ) ) ).

% insort_remove1
thf(fact_6781_count__notin,axiom,
    ! [A: $tType,X: A,Xs: list @ A] :
      ( ~ ( member @ A @ X @ ( set2 @ A @ Xs ) )
     => ( ( count_list @ A @ Xs @ X )
        = ( zero_zero @ nat ) ) ) ).

% count_notin
thf(fact_6782_arg__min__inj__eq,axiom,
    ! [B: $tType,A: $tType] :
      ( ( order @ B )
     => ! [F2: A > B,P: A > $o,A2: A] :
          ( ( inj_on @ A @ B @ F2 @ ( collect @ A @ P ) )
         => ( ( P @ A2 )
           => ( ! [Y5: A] :
                  ( ( P @ Y5 )
                 => ( ord_less_eq @ B @ ( F2 @ A2 ) @ ( F2 @ Y5 ) ) )
             => ( ( lattices_ord_arg_min @ A @ B @ F2 @ P )
                = A2 ) ) ) ) ) ).

% arg_min_inj_eq
thf(fact_6783_arg__min__nat__le,axiom,
    ! [A: $tType,P: A > $o,X: A,M: A > nat] :
      ( ( P @ X )
     => ( ord_less_eq @ nat @ ( M @ ( lattices_ord_arg_min @ A @ nat @ M @ P ) ) @ ( M @ X ) ) ) ).

% arg_min_nat_le
thf(fact_6784_arg__min__nat__lemma,axiom,
    ! [A: $tType,P: A > $o,K: A,M: A > nat] :
      ( ( P @ K )
     => ( ( P @ ( lattices_ord_arg_min @ A @ nat @ M @ P ) )
        & ! [Y6: A] :
            ( ( P @ Y6 )
           => ( ord_less_eq @ nat @ ( M @ ( lattices_ord_arg_min @ A @ nat @ M @ P ) ) @ ( M @ Y6 ) ) ) ) ) ).

% arg_min_nat_lemma
thf(fact_6785_arg__min__equality,axiom,
    ! [A: $tType,C: $tType] :
      ( ( order @ A )
     => ! [P: C > $o,K: C,F2: C > A] :
          ( ( P @ K )
         => ( ! [X3: C] :
                ( ( P @ X3 )
               => ( ord_less_eq @ A @ ( F2 @ K ) @ ( F2 @ X3 ) ) )
           => ( ( F2 @ ( lattices_ord_arg_min @ C @ A @ F2 @ P ) )
              = ( F2 @ K ) ) ) ) ) ).

% arg_min_equality
thf(fact_6786_arg__minI,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ord @ B )
     => ! [P: A > $o,X: A,F2: A > B,Q: A > $o] :
          ( ( P @ X )
         => ( ! [Y5: A] :
                ( ( P @ Y5 )
               => ~ ( ord_less @ B @ ( F2 @ Y5 ) @ ( F2 @ X ) ) )
           => ( ! [X3: A] :
                  ( ( P @ X3 )
                 => ( ! [Y6: A] :
                        ( ( P @ Y6 )
                       => ~ ( ord_less @ B @ ( F2 @ Y6 ) @ ( F2 @ X3 ) ) )
                   => ( Q @ X3 ) ) )
             => ( Q @ ( lattices_ord_arg_min @ A @ B @ F2 @ P ) ) ) ) ) ) ).

% arg_minI
thf(fact_6787_count__list_Osimps_I1_J,axiom,
    ! [A: $tType,Y: A] :
      ( ( count_list @ A @ ( nil @ A ) @ Y )
      = ( zero_zero @ nat ) ) ).

% count_list.simps(1)
thf(fact_6788_count__le__length,axiom,
    ! [A: $tType,Xs: list @ A,X: A] : ( ord_less_eq @ nat @ ( count_list @ A @ Xs @ X ) @ ( size_size @ ( list @ A ) @ Xs ) ) ).

% count_le_length
thf(fact_6789_arg__min__on__def,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ord @ A )
     => ( ( lattic7623131987881927897min_on @ B @ A )
        = ( ^ [F3: B > A,S8: set @ B] :
              ( lattices_ord_arg_min @ B @ A @ F3
              @ ^ [X2: B] : ( member @ B @ X2 @ S8 ) ) ) ) ) ).

% arg_min_on_def
thf(fact_6790_arg__min__def,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ord @ A )
     => ( ( lattices_ord_arg_min @ B @ A )
        = ( ^ [F3: B > A,P3: B > $o] : ( fChoice @ B @ ( lattic501386751177426532rg_min @ B @ A @ F3 @ P3 ) ) ) ) ) ).

% arg_min_def
thf(fact_6791_in__measures_I2_J,axiom,
    ! [A: $tType,X: A,Y: A,F2: A > nat,Fs: list @ ( A > nat )] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y ) @ ( measures @ A @ ( cons @ ( A > nat ) @ F2 @ Fs ) ) )
      = ( ( ord_less @ nat @ ( F2 @ X ) @ ( F2 @ Y ) )
        | ( ( ( F2 @ X )
            = ( F2 @ Y ) )
          & ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y ) @ ( measures @ A @ Fs ) ) ) ) ) ).

% in_measures(2)
thf(fact_6792_is__arg__min__arg__min__nat,axiom,
    ! [A: $tType,P: A > $o,X: A,M: A > nat] :
      ( ( P @ X )
     => ( lattic501386751177426532rg_min @ A @ nat @ M @ P @ ( lattices_ord_arg_min @ A @ nat @ M @ P ) ) ) ).

% is_arg_min_arg_min_nat
thf(fact_6793_arg__min__natI,axiom,
    ! [A: $tType,P: A > $o,K: A,M: A > nat] :
      ( ( P @ K )
     => ( P @ ( lattices_ord_arg_min @ A @ nat @ M @ P ) ) ) ).

% arg_min_natI
thf(fact_6794_is__arg__min__linorder,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linorder @ B )
     => ( ( lattic501386751177426532rg_min @ A @ B )
        = ( ^ [F3: A > B,P3: A > $o,X2: A] :
              ( ( P3 @ X2 )
              & ! [Y4: A] :
                  ( ( P3 @ Y4 )
                 => ( ord_less_eq @ B @ ( F3 @ X2 ) @ ( F3 @ Y4 ) ) ) ) ) ) ) ).

% is_arg_min_linorder
thf(fact_6795_is__arg__min__antimono,axiom,
    ! [B: $tType,A: $tType] :
      ( ( order @ B )
     => ! [F2: A > B,P: A > $o,X: A,Y: A] :
          ( ( lattic501386751177426532rg_min @ A @ B @ F2 @ P @ X )
         => ( ( ord_less_eq @ B @ ( F2 @ Y ) @ ( F2 @ X ) )
           => ( ( P @ Y )
             => ( lattic501386751177426532rg_min @ A @ B @ F2 @ P @ Y ) ) ) ) ) ).

% is_arg_min_antimono
thf(fact_6796_is__arg__min__def,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ord @ A )
     => ( ( lattic501386751177426532rg_min @ B @ A )
        = ( ^ [F3: B > A,P3: B > $o,X2: B] :
              ( ( P3 @ X2 )
              & ~ ? [Y4: B] :
                    ( ( P3 @ Y4 )
                    & ( ord_less @ A @ ( F3 @ Y4 ) @ ( F3 @ X2 ) ) ) ) ) ) ) ).

% is_arg_min_def
thf(fact_6797_measures__less,axiom,
    ! [A: $tType,F2: A > nat,X: A,Y: A,Fs: list @ ( A > nat )] :
      ( ( ord_less @ nat @ ( F2 @ X ) @ ( F2 @ Y ) )
     => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y ) @ ( measures @ A @ ( cons @ ( A > nat ) @ F2 @ Fs ) ) ) ) ).

% measures_less
thf(fact_6798_measures__lesseq,axiom,
    ! [A: $tType,F2: A > nat,X: A,Y: A,Fs: list @ ( A > nat )] :
      ( ( ord_less_eq @ nat @ ( F2 @ X ) @ ( F2 @ Y ) )
     => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y ) @ ( measures @ A @ Fs ) )
       => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y ) @ ( measures @ A @ ( cons @ ( A > nat ) @ F2 @ Fs ) ) ) ) ) ).

% measures_lesseq
thf(fact_6799_ex__is__arg__min__if__finite,axiom,
    ! [B: $tType,A: $tType] :
      ( ( order @ B )
     => ! [S: set @ A,F2: A > B] :
          ( ( finite_finite @ A @ S )
         => ( ( S
             != ( bot_bot @ ( set @ A ) ) )
           => ? [X_1: A] :
                ( lattic501386751177426532rg_min @ A @ B @ F2
                @ ^ [X2: A] : ( member @ A @ X2 @ S )
                @ X_1 ) ) ) ) ).

% ex_is_arg_min_if_finite
thf(fact_6800_Sup__fin_Oinsert__remove,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A4: set @ A,X: A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( ( ( minus_minus @ ( set @ A ) @ A4 @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
                = ( bot_bot @ ( set @ A ) ) )
             => ( ( lattic5882676163264333800up_fin @ A @ ( insert @ A @ X @ A4 ) )
                = X ) )
            & ( ( ( minus_minus @ ( set @ A ) @ A4 @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
               != ( bot_bot @ ( set @ A ) ) )
             => ( ( lattic5882676163264333800up_fin @ A @ ( insert @ A @ X @ A4 ) )
                = ( sup_sup @ A @ X @ ( lattic5882676163264333800up_fin @ A @ ( minus_minus @ ( set @ A ) @ A4 @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ) ) ) ).

% Sup_fin.insert_remove
thf(fact_6801_Sup__fin_Oremove,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A4: set @ A,X: A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( member @ A @ X @ A4 )
           => ( ( ( ( minus_minus @ ( set @ A ) @ A4 @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
                  = ( bot_bot @ ( set @ A ) ) )
               => ( ( lattic5882676163264333800up_fin @ A @ A4 )
                  = X ) )
              & ( ( ( minus_minus @ ( set @ A ) @ A4 @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
                 != ( bot_bot @ ( set @ A ) ) )
               => ( ( lattic5882676163264333800up_fin @ A @ A4 )
                  = ( sup_sup @ A @ X @ ( lattic5882676163264333800up_fin @ A @ ( minus_minus @ ( set @ A ) @ A4 @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ) ) ) ) ).

% Sup_fin.remove
thf(fact_6802_inf__Sup__absorb,axiom,
    ! [A: $tType] :
      ( ( lattice @ A )
     => ! [A4: set @ A,A2: A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( member @ A @ A2 @ A4 )
           => ( ( inf_inf @ A @ A2 @ ( lattic5882676163264333800up_fin @ A @ A4 ) )
              = A2 ) ) ) ) ).

% inf_Sup_absorb
thf(fact_6803_Sup__fin_Osingleton,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [X: A] :
          ( ( lattic5882676163264333800up_fin @ A @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
          = X ) ) ).

% Sup_fin.singleton
thf(fact_6804_Sup__fin_Oinsert,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A4: set @ A,X: A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( A4
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( lattic5882676163264333800up_fin @ A @ ( insert @ A @ X @ A4 ) )
              = ( sup_sup @ A @ X @ ( lattic5882676163264333800up_fin @ A @ A4 ) ) ) ) ) ) ).

% Sup_fin.insert
thf(fact_6805_Sup__fin_Oin__idem,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A4: set @ A,X: A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( member @ A @ X @ A4 )
           => ( ( sup_sup @ A @ X @ ( lattic5882676163264333800up_fin @ A @ A4 ) )
              = ( lattic5882676163264333800up_fin @ A @ A4 ) ) ) ) ) ).

% Sup_fin.in_idem
thf(fact_6806_Sup__fin__Max,axiom,
    ! [A: $tType] :
      ( ( ( semilattice_sup @ A )
        & ( linorder @ A ) )
     => ( ( lattic5882676163264333800up_fin @ A )
        = ( lattic643756798349783984er_Max @ A ) ) ) ).

% Sup_fin_Max
thf(fact_6807_Sup__fin_OcoboundedI,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A4: set @ A,A2: A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( member @ A @ A2 @ A4 )
           => ( ord_less_eq @ A @ A2 @ ( lattic5882676163264333800up_fin @ A @ A4 ) ) ) ) ) ).

% Sup_fin.coboundedI
thf(fact_6808_Sup__fin_OboundedE,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A4: set @ A,X: A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( A4
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ord_less_eq @ A @ ( lattic5882676163264333800up_fin @ A @ A4 ) @ X )
             => ! [A9: A] :
                  ( ( member @ A @ A9 @ A4 )
                 => ( ord_less_eq @ A @ A9 @ X ) ) ) ) ) ) ).

% Sup_fin.boundedE
thf(fact_6809_Sup__fin_OboundedI,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A4: set @ A,X: A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( A4
             != ( bot_bot @ ( set @ A ) ) )
           => ( ! [A5: A] :
                  ( ( member @ A @ A5 @ A4 )
                 => ( ord_less_eq @ A @ A5 @ X ) )
             => ( ord_less_eq @ A @ ( lattic5882676163264333800up_fin @ A @ A4 ) @ X ) ) ) ) ) ).

% Sup_fin.boundedI
thf(fact_6810_Sup__fin_Obounded__iff,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A4: set @ A,X: A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( A4
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ord_less_eq @ A @ ( lattic5882676163264333800up_fin @ A @ A4 ) @ X )
              = ( ! [X2: A] :
                    ( ( member @ A @ X2 @ A4 )
                   => ( ord_less_eq @ A @ X2 @ X ) ) ) ) ) ) ) ).

% Sup_fin.bounded_iff
thf(fact_6811_cSup__eq__Sup__fin,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [X7: set @ A] :
          ( ( finite_finite @ A @ X7 )
         => ( ( X7
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( complete_Sup_Sup @ A @ X7 )
              = ( lattic5882676163264333800up_fin @ A @ X7 ) ) ) ) ) ).

% cSup_eq_Sup_fin
thf(fact_6812_Sup__fin__Sup,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A4: set @ A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( A4
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( lattic5882676163264333800up_fin @ A @ A4 )
              = ( complete_Sup_Sup @ A @ A4 ) ) ) ) ) ).

% Sup_fin_Sup
thf(fact_6813_Sup__fin_Osubset__imp,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A4: set @ A,B7: set @ A] :
          ( ( ord_less_eq @ ( set @ A ) @ A4 @ B7 )
         => ( ( A4
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( finite_finite @ A @ B7 )
             => ( ord_less_eq @ A @ ( lattic5882676163264333800up_fin @ A @ A4 ) @ ( lattic5882676163264333800up_fin @ A @ B7 ) ) ) ) ) ) ).

% Sup_fin.subset_imp
thf(fact_6814_Sup__fin_Ohom__commute,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [H2: A > A,N4: set @ A] :
          ( ! [X3: A,Y5: A] :
              ( ( H2 @ ( sup_sup @ A @ X3 @ Y5 ) )
              = ( sup_sup @ A @ ( H2 @ X3 ) @ ( H2 @ Y5 ) ) )
         => ( ( finite_finite @ A @ N4 )
           => ( ( N4
               != ( bot_bot @ ( set @ A ) ) )
             => ( ( H2 @ ( lattic5882676163264333800up_fin @ A @ N4 ) )
                = ( lattic5882676163264333800up_fin @ A @ ( image @ A @ A @ H2 @ N4 ) ) ) ) ) ) ) ).

% Sup_fin.hom_commute
thf(fact_6815_Sup__fin_Osubset,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A4: set @ A,B7: set @ A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( B7
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ord_less_eq @ ( set @ A ) @ B7 @ A4 )
             => ( ( sup_sup @ A @ ( lattic5882676163264333800up_fin @ A @ B7 ) @ ( lattic5882676163264333800up_fin @ A @ A4 ) )
                = ( lattic5882676163264333800up_fin @ A @ A4 ) ) ) ) ) ) ).

% Sup_fin.subset
thf(fact_6816_Sup__fin_Oclosed,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A4: set @ A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( A4
             != ( bot_bot @ ( set @ A ) ) )
           => ( ! [X3: A,Y5: A] : ( member @ A @ ( sup_sup @ A @ X3 @ Y5 ) @ ( insert @ A @ X3 @ ( insert @ A @ Y5 @ ( bot_bot @ ( set @ A ) ) ) ) )
             => ( member @ A @ ( lattic5882676163264333800up_fin @ A @ A4 ) @ A4 ) ) ) ) ) ).

% Sup_fin.closed
thf(fact_6817_Sup__fin_Oinsert__not__elem,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A4: set @ A,X: A] :
          ( ( finite_finite @ A @ A4 )
         => ( ~ ( member @ A @ X @ A4 )
           => ( ( A4
               != ( bot_bot @ ( set @ A ) ) )
             => ( ( lattic5882676163264333800up_fin @ A @ ( insert @ A @ X @ A4 ) )
                = ( sup_sup @ A @ X @ ( lattic5882676163264333800up_fin @ A @ A4 ) ) ) ) ) ) ) ).

% Sup_fin.insert_not_elem
thf(fact_6818_Sup__fin_Ounion,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A4: set @ A,B7: set @ A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( A4
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( finite_finite @ A @ B7 )
             => ( ( B7
                 != ( bot_bot @ ( set @ A ) ) )
               => ( ( lattic5882676163264333800up_fin @ A @ ( sup_sup @ ( set @ A ) @ A4 @ B7 ) )
                  = ( sup_sup @ A @ ( lattic5882676163264333800up_fin @ A @ A4 ) @ ( lattic5882676163264333800up_fin @ A @ B7 ) ) ) ) ) ) ) ) ).

% Sup_fin.union
thf(fact_6819_inf__Sup1__distrib,axiom,
    ! [A: $tType] :
      ( ( distrib_lattice @ A )
     => ! [A4: set @ A,X: A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( A4
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( inf_inf @ A @ X @ ( lattic5882676163264333800up_fin @ A @ A4 ) )
              = ( lattic5882676163264333800up_fin @ A
                @ ( collect @ A
                  @ ^ [Uu3: A] :
                    ? [A3: A] :
                      ( ( Uu3
                        = ( inf_inf @ A @ X @ A3 ) )
                      & ( member @ A @ A3 @ A4 ) ) ) ) ) ) ) ) ).

% inf_Sup1_distrib
thf(fact_6820_inf__Sup2__distrib,axiom,
    ! [A: $tType] :
      ( ( distrib_lattice @ A )
     => ! [A4: set @ A,B7: set @ A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( A4
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( finite_finite @ A @ B7 )
             => ( ( B7
                 != ( bot_bot @ ( set @ A ) ) )
               => ( ( inf_inf @ A @ ( lattic5882676163264333800up_fin @ A @ A4 ) @ ( lattic5882676163264333800up_fin @ A @ B7 ) )
                  = ( lattic5882676163264333800up_fin @ A
                    @ ( collect @ A
                      @ ^ [Uu3: A] :
                        ? [A3: A,B3: A] :
                          ( ( Uu3
                            = ( inf_inf @ A @ A3 @ B3 ) )
                          & ( member @ A @ A3 @ A4 )
                          & ( member @ A @ B3 @ B7 ) ) ) ) ) ) ) ) ) ) ).

% inf_Sup2_distrib
thf(fact_6821_Inf__fin_Oinsert__remove,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A4: set @ A,X: A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( ( ( minus_minus @ ( set @ A ) @ A4 @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
                = ( bot_bot @ ( set @ A ) ) )
             => ( ( lattic7752659483105999362nf_fin @ A @ ( insert @ A @ X @ A4 ) )
                = X ) )
            & ( ( ( minus_minus @ ( set @ A ) @ A4 @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
               != ( bot_bot @ ( set @ A ) ) )
             => ( ( lattic7752659483105999362nf_fin @ A @ ( insert @ A @ X @ A4 ) )
                = ( inf_inf @ A @ X @ ( lattic7752659483105999362nf_fin @ A @ ( minus_minus @ ( set @ A ) @ A4 @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ) ) ) ).

% Inf_fin.insert_remove
thf(fact_6822_Inf__fin_Oremove,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A4: set @ A,X: A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( member @ A @ X @ A4 )
           => ( ( ( ( minus_minus @ ( set @ A ) @ A4 @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
                  = ( bot_bot @ ( set @ A ) ) )
               => ( ( lattic7752659483105999362nf_fin @ A @ A4 )
                  = X ) )
              & ( ( ( minus_minus @ ( set @ A ) @ A4 @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
                 != ( bot_bot @ ( set @ A ) ) )
               => ( ( lattic7752659483105999362nf_fin @ A @ A4 )
                  = ( inf_inf @ A @ X @ ( lattic7752659483105999362nf_fin @ A @ ( minus_minus @ ( set @ A ) @ A4 @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ) ) ) ) ).

% Inf_fin.remove
thf(fact_6823_Inf__fin_Osingleton,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [X: A] :
          ( ( lattic7752659483105999362nf_fin @ A @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
          = X ) ) ).

% Inf_fin.singleton
thf(fact_6824_sup__Inf__absorb,axiom,
    ! [A: $tType] :
      ( ( lattice @ A )
     => ! [A4: set @ A,A2: A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( member @ A @ A2 @ A4 )
           => ( ( sup_sup @ A @ ( lattic7752659483105999362nf_fin @ A @ A4 ) @ A2 )
              = A2 ) ) ) ) ).

% sup_Inf_absorb
thf(fact_6825_Inf__fin_Oinsert,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A4: set @ A,X: A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( A4
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( lattic7752659483105999362nf_fin @ A @ ( insert @ A @ X @ A4 ) )
              = ( inf_inf @ A @ X @ ( lattic7752659483105999362nf_fin @ A @ A4 ) ) ) ) ) ) ).

% Inf_fin.insert
thf(fact_6826_Inf__fin_Oin__idem,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A4: set @ A,X: A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( member @ A @ X @ A4 )
           => ( ( inf_inf @ A @ X @ ( lattic7752659483105999362nf_fin @ A @ A4 ) )
              = ( lattic7752659483105999362nf_fin @ A @ A4 ) ) ) ) ) ).

% Inf_fin.in_idem
thf(fact_6827_Inf__fin_OcoboundedI,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A4: set @ A,A2: A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( member @ A @ A2 @ A4 )
           => ( ord_less_eq @ A @ ( lattic7752659483105999362nf_fin @ A @ A4 ) @ A2 ) ) ) ) ).

% Inf_fin.coboundedI
thf(fact_6828_Inf__fin__Min,axiom,
    ! [A: $tType] :
      ( ( ( semilattice_inf @ A )
        & ( linorder @ A ) )
     => ( ( lattic7752659483105999362nf_fin @ A )
        = ( lattic643756798350308766er_Min @ A ) ) ) ).

% Inf_fin_Min
thf(fact_6829_Inf__fin_Obounded__iff,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A4: set @ A,X: A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( A4
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ord_less_eq @ A @ X @ ( lattic7752659483105999362nf_fin @ A @ A4 ) )
              = ( ! [X2: A] :
                    ( ( member @ A @ X2 @ A4 )
                   => ( ord_less_eq @ A @ X @ X2 ) ) ) ) ) ) ) ).

% Inf_fin.bounded_iff
thf(fact_6830_Inf__fin_OboundedI,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A4: set @ A,X: A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( A4
             != ( bot_bot @ ( set @ A ) ) )
           => ( ! [A5: A] :
                  ( ( member @ A @ A5 @ A4 )
                 => ( ord_less_eq @ A @ X @ A5 ) )
             => ( ord_less_eq @ A @ X @ ( lattic7752659483105999362nf_fin @ A @ A4 ) ) ) ) ) ) ).

% Inf_fin.boundedI
thf(fact_6831_Inf__fin_OboundedE,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A4: set @ A,X: A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( A4
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ord_less_eq @ A @ X @ ( lattic7752659483105999362nf_fin @ A @ A4 ) )
             => ! [A9: A] :
                  ( ( member @ A @ A9 @ A4 )
                 => ( ord_less_eq @ A @ X @ A9 ) ) ) ) ) ) ).

% Inf_fin.boundedE
thf(fact_6832_Inf__fin__Inf,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A4: set @ A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( A4
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( lattic7752659483105999362nf_fin @ A @ A4 )
              = ( complete_Inf_Inf @ A @ A4 ) ) ) ) ) ).

% Inf_fin_Inf
thf(fact_6833_cInf__eq__Inf__fin,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [X7: set @ A] :
          ( ( finite_finite @ A @ X7 )
         => ( ( X7
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( complete_Inf_Inf @ A @ X7 )
              = ( lattic7752659483105999362nf_fin @ A @ X7 ) ) ) ) ) ).

% cInf_eq_Inf_fin
thf(fact_6834_Inf__fin_Osubset__imp,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A4: set @ A,B7: set @ A] :
          ( ( ord_less_eq @ ( set @ A ) @ A4 @ B7 )
         => ( ( A4
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( finite_finite @ A @ B7 )
             => ( ord_less_eq @ A @ ( lattic7752659483105999362nf_fin @ A @ B7 ) @ ( lattic7752659483105999362nf_fin @ A @ A4 ) ) ) ) ) ) ).

% Inf_fin.subset_imp
thf(fact_6835_Inf__fin_Ohom__commute,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [H2: A > A,N4: set @ A] :
          ( ! [X3: A,Y5: A] :
              ( ( H2 @ ( inf_inf @ A @ X3 @ Y5 ) )
              = ( inf_inf @ A @ ( H2 @ X3 ) @ ( H2 @ Y5 ) ) )
         => ( ( finite_finite @ A @ N4 )
           => ( ( N4
               != ( bot_bot @ ( set @ A ) ) )
             => ( ( H2 @ ( lattic7752659483105999362nf_fin @ A @ N4 ) )
                = ( lattic7752659483105999362nf_fin @ A @ ( image @ A @ A @ H2 @ N4 ) ) ) ) ) ) ) ).

% Inf_fin.hom_commute
thf(fact_6836_Inf__fin_Osubset,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A4: set @ A,B7: set @ A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( B7
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( ord_less_eq @ ( set @ A ) @ B7 @ A4 )
             => ( ( inf_inf @ A @ ( lattic7752659483105999362nf_fin @ A @ B7 ) @ ( lattic7752659483105999362nf_fin @ A @ A4 ) )
                = ( lattic7752659483105999362nf_fin @ A @ A4 ) ) ) ) ) ) ).

% Inf_fin.subset
thf(fact_6837_Inf__fin_Oclosed,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A4: set @ A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( A4
             != ( bot_bot @ ( set @ A ) ) )
           => ( ! [X3: A,Y5: A] : ( member @ A @ ( inf_inf @ A @ X3 @ Y5 ) @ ( insert @ A @ X3 @ ( insert @ A @ Y5 @ ( bot_bot @ ( set @ A ) ) ) ) )
             => ( member @ A @ ( lattic7752659483105999362nf_fin @ A @ A4 ) @ A4 ) ) ) ) ) ).

% Inf_fin.closed
thf(fact_6838_Inf__fin_Oinsert__not__elem,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A4: set @ A,X: A] :
          ( ( finite_finite @ A @ A4 )
         => ( ~ ( member @ A @ X @ A4 )
           => ( ( A4
               != ( bot_bot @ ( set @ A ) ) )
             => ( ( lattic7752659483105999362nf_fin @ A @ ( insert @ A @ X @ A4 ) )
                = ( inf_inf @ A @ X @ ( lattic7752659483105999362nf_fin @ A @ A4 ) ) ) ) ) ) ) ).

% Inf_fin.insert_not_elem
thf(fact_6839_Inf__fin_Ounion,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A4: set @ A,B7: set @ A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( A4
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( finite_finite @ A @ B7 )
             => ( ( B7
                 != ( bot_bot @ ( set @ A ) ) )
               => ( ( lattic7752659483105999362nf_fin @ A @ ( sup_sup @ ( set @ A ) @ A4 @ B7 ) )
                  = ( inf_inf @ A @ ( lattic7752659483105999362nf_fin @ A @ A4 ) @ ( lattic7752659483105999362nf_fin @ A @ B7 ) ) ) ) ) ) ) ) ).

% Inf_fin.union
thf(fact_6840_Inf__fin__le__Sup__fin,axiom,
    ! [A: $tType] :
      ( ( lattice @ A )
     => ! [A4: set @ A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( A4
             != ( bot_bot @ ( set @ A ) ) )
           => ( ord_less_eq @ A @ ( lattic7752659483105999362nf_fin @ A @ A4 ) @ ( lattic5882676163264333800up_fin @ A @ A4 ) ) ) ) ) ).

% Inf_fin_le_Sup_fin
thf(fact_6841_sup__Inf1__distrib,axiom,
    ! [A: $tType] :
      ( ( distrib_lattice @ A )
     => ! [A4: set @ A,X: A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( A4
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( sup_sup @ A @ X @ ( lattic7752659483105999362nf_fin @ A @ A4 ) )
              = ( lattic7752659483105999362nf_fin @ A
                @ ( collect @ A
                  @ ^ [Uu3: A] :
                    ? [A3: A] :
                      ( ( Uu3
                        = ( sup_sup @ A @ X @ A3 ) )
                      & ( member @ A @ A3 @ A4 ) ) ) ) ) ) ) ) ).

% sup_Inf1_distrib
thf(fact_6842_sup__Inf2__distrib,axiom,
    ! [A: $tType] :
      ( ( distrib_lattice @ A )
     => ! [A4: set @ A,B7: set @ A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( A4
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( finite_finite @ A @ B7 )
             => ( ( B7
                 != ( bot_bot @ ( set @ A ) ) )
               => ( ( sup_sup @ A @ ( lattic7752659483105999362nf_fin @ A @ A4 ) @ ( lattic7752659483105999362nf_fin @ A @ B7 ) )
                  = ( lattic7752659483105999362nf_fin @ A
                    @ ( collect @ A
                      @ ^ [Uu3: A] :
                        ? [A3: A,B3: A] :
                          ( ( Uu3
                            = ( sup_sup @ A @ A3 @ B3 ) )
                          & ( member @ A @ A3 @ A4 )
                          & ( member @ A @ B3 @ B7 ) ) ) ) ) ) ) ) ) ) ).

% sup_Inf2_distrib
thf(fact_6843_nhds__metric,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ( ( topolo7230453075368039082e_nhds @ A )
        = ( ^ [X2: A] :
              ( complete_Inf_Inf @ ( filter @ A )
              @ ( image @ real @ ( filter @ A )
                @ ^ [E3: real] :
                    ( principal @ A
                    @ ( collect @ A
                      @ ^ [Y4: A] : ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ Y4 @ X2 ) @ E3 ) ) )
                @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) ) ) ) ) ).

% nhds_metric
thf(fact_6844_eventually__uniformity__metric,axiom,
    ! [A: $tType] :
      ( ( real_V768167426530841204y_dist @ A )
     => ! [P: ( product_prod @ A @ A ) > $o] :
          ( ( eventually @ ( product_prod @ A @ A ) @ P @ ( topolo7806501430040627800ormity @ A ) )
          = ( ? [E3: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ E3 )
                & ! [X2: A,Y4: A] :
                    ( ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X2 @ Y4 ) @ E3 )
                   => ( P @ ( product_Pair @ A @ A @ X2 @ Y4 ) ) ) ) ) ) ) ).

% eventually_uniformity_metric
thf(fact_6845_uniformity__real__def,axiom,
    ( ( topolo7806501430040627800ormity @ real )
    = ( complete_Inf_Inf @ ( filter @ ( product_prod @ real @ real ) )
      @ ( image @ real @ ( filter @ ( product_prod @ real @ real ) )
        @ ^ [E3: real] :
            ( principal @ ( product_prod @ real @ real )
            @ ( collect @ ( product_prod @ real @ real )
              @ ( product_case_prod @ real @ real @ $o
                @ ^ [X2: real,Y4: real] : ( ord_less @ real @ ( real_V557655796197034286t_dist @ real @ X2 @ Y4 ) @ E3 ) ) ) )
        @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) ) ) ).

% uniformity_real_def
thf(fact_6846_uniformity__complex__def,axiom,
    ( ( topolo7806501430040627800ormity @ complex )
    = ( complete_Inf_Inf @ ( filter @ ( product_prod @ complex @ complex ) )
      @ ( image @ real @ ( filter @ ( product_prod @ complex @ complex ) )
        @ ^ [E3: real] :
            ( principal @ ( product_prod @ complex @ complex )
            @ ( collect @ ( product_prod @ complex @ complex )
              @ ( product_case_prod @ complex @ complex @ $o
                @ ^ [X2: complex,Y4: complex] : ( ord_less @ real @ ( real_V557655796197034286t_dist @ complex @ X2 @ Y4 ) @ E3 ) ) ) )
        @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) ) ) ).

% uniformity_complex_def
thf(fact_6847_uniformity__dist,axiom,
    ! [A: $tType] :
      ( ( real_V768167426530841204y_dist @ A )
     => ( ( topolo7806501430040627800ormity @ A )
        = ( complete_Inf_Inf @ ( filter @ ( product_prod @ A @ A ) )
          @ ( image @ real @ ( filter @ ( product_prod @ A @ A ) )
            @ ^ [E3: real] :
                ( principal @ ( product_prod @ A @ A )
                @ ( collect @ ( product_prod @ A @ A )
                  @ ( product_case_prod @ A @ A @ $o
                    @ ^ [X2: A,Y4: A] : ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X2 @ Y4 ) @ E3 ) ) ) )
            @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) ) ) ) ).

% uniformity_dist
thf(fact_6848_Cauchy__uniform__iff,axiom,
    ! [A: $tType] :
      ( ( topolo7287701948861334536_space @ A )
     => ( ( topolo3814608138187158403Cauchy @ A )
        = ( ^ [X8: nat > A] :
            ! [P3: ( product_prod @ A @ A ) > $o] :
              ( ( eventually @ ( product_prod @ A @ A ) @ P3 @ ( topolo7806501430040627800ormity @ A ) )
             => ? [N6: nat] :
                ! [N3: nat] :
                  ( ( ord_less_eq @ nat @ N6 @ N3 )
                 => ! [M3: nat] :
                      ( ( ord_less_eq @ nat @ N6 @ M3 )
                     => ( P3 @ ( product_Pair @ A @ A @ ( X8 @ N3 ) @ ( X8 @ M3 ) ) ) ) ) ) ) ) ) ).

% Cauchy_uniform_iff
thf(fact_6849_at__left__eq,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [Y: A,X: A] :
          ( ( ord_less @ A @ Y @ X )
         => ( ( topolo174197925503356063within @ A @ X @ ( set_ord_lessThan @ A @ X ) )
            = ( complete_Inf_Inf @ ( filter @ A )
              @ ( image @ A @ ( filter @ A )
                @ ^ [A3: A] : ( principal @ A @ ( set_or5935395276787703475ssThan @ A @ A3 @ X ) )
                @ ( set_ord_lessThan @ A @ X ) ) ) ) ) ) ).

% at_left_eq
thf(fact_6850_at__right__eq,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [X: A,Y: A] :
          ( ( ord_less @ A @ X @ Y )
         => ( ( topolo174197925503356063within @ A @ X @ ( set_ord_greaterThan @ A @ X ) )
            = ( complete_Inf_Inf @ ( filter @ A )
              @ ( image @ A @ ( filter @ A )
                @ ^ [A3: A] : ( principal @ A @ ( set_or5935395276787703475ssThan @ A @ X @ A3 ) )
                @ ( set_ord_greaterThan @ A @ X ) ) ) ) ) ) ).

% at_right_eq
thf(fact_6851_at__infinity__def,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ( ( at_infinity @ A )
        = ( complete_Inf_Inf @ ( filter @ A )
          @ ( image @ real @ ( filter @ A )
            @ ^ [R5: real] :
                ( principal @ A
                @ ( collect @ A
                  @ ^ [X2: A] : ( ord_less_eq @ real @ R5 @ ( real_V7770717601297561774m_norm @ A @ X2 ) ) ) )
            @ ( top_top @ ( set @ real ) ) ) ) ) ) ).

% at_infinity_def
thf(fact_6852_zero__rat__def,axiom,
    ( ( zero_zero @ rat )
    = ( abs_Rat @ ( product_Pair @ int @ int @ ( zero_zero @ int ) @ ( one_one @ int ) ) ) ) ).

% zero_rat_def
thf(fact_6853_Bseq__monoseq__convergent_H__inc,axiom,
    ! [F2: nat > real,M5: nat] :
      ( ( bfun @ nat @ real
        @ ^ [N3: nat] : ( F2 @ ( plus_plus @ nat @ N3 @ M5 ) )
        @ ( at_top @ nat ) )
     => ( ! [M4: nat,N2: nat] :
            ( ( ord_less_eq @ nat @ M5 @ M4 )
           => ( ( ord_less_eq @ nat @ M4 @ N2 )
             => ( ord_less_eq @ real @ ( F2 @ M4 ) @ ( F2 @ N2 ) ) ) )
       => ( topolo6863149650580417670ergent @ real @ F2 ) ) ) ).

% Bseq_monoseq_convergent'_inc
thf(fact_6854_convergent__mult__const__right__iff,axiom,
    ! [A: $tType] :
      ( ( ( field @ A )
        & ( topolo4211221413907600880p_mult @ A ) )
     => ! [C2: A,F2: nat > A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( topolo6863149650580417670ergent @ A
              @ ^ [N3: nat] : ( times_times @ A @ ( F2 @ N3 ) @ C2 ) )
            = ( topolo6863149650580417670ergent @ A @ F2 ) ) ) ) ).

% convergent_mult_const_right_iff
thf(fact_6855_convergent__mult__const__iff,axiom,
    ! [A: $tType] :
      ( ( ( field @ A )
        & ( topolo4211221413907600880p_mult @ A ) )
     => ! [C2: A,F2: nat > A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( topolo6863149650580417670ergent @ A
              @ ^ [N3: nat] : ( times_times @ A @ C2 @ ( F2 @ N3 ) ) )
            = ( topolo6863149650580417670ergent @ A @ F2 ) ) ) ) ).

% convergent_mult_const_iff
thf(fact_6856_lim__le,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [F2: nat > A,X: A] :
          ( ( topolo6863149650580417670ergent @ A @ F2 )
         => ( ! [N2: nat] : ( ord_less_eq @ A @ ( F2 @ N2 ) @ X )
           => ( ord_less_eq @ A @ ( topolo3827282254853284352ce_Lim @ nat @ A @ ( at_top @ nat ) @ F2 ) @ X ) ) ) ) ).

% lim_le
thf(fact_6857_Bseq__mono__convergent,axiom,
    ! [X7: nat > real] :
      ( ( bfun @ nat @ real @ X7 @ ( at_top @ nat ) )
     => ( ! [M4: nat,N2: nat] :
            ( ( ord_less_eq @ nat @ M4 @ N2 )
           => ( ord_less_eq @ real @ ( X7 @ M4 ) @ ( X7 @ N2 ) ) )
       => ( topolo6863149650580417670ergent @ real @ X7 ) ) ) ).

% Bseq_mono_convergent
thf(fact_6858_convergent__realpow,axiom,
    ! [X: real] :
      ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ X )
     => ( ( ord_less_eq @ real @ X @ ( one_one @ real ) )
       => ( topolo6863149650580417670ergent @ real @ ( power_power @ real @ X ) ) ) ) ).

% convergent_realpow
thf(fact_6859_Bseq__monoseq__convergent_H__dec,axiom,
    ! [F2: nat > real,M5: nat] :
      ( ( bfun @ nat @ real
        @ ^ [N3: nat] : ( F2 @ ( plus_plus @ nat @ N3 @ M5 ) )
        @ ( at_top @ nat ) )
     => ( ! [M4: nat,N2: nat] :
            ( ( ord_less_eq @ nat @ M5 @ M4 )
           => ( ( ord_less_eq @ nat @ M4 @ N2 )
             => ( ord_less_eq @ real @ ( F2 @ N2 ) @ ( F2 @ M4 ) ) ) )
       => ( topolo6863149650580417670ergent @ real @ F2 ) ) ) ).

% Bseq_monoseq_convergent'_dec
thf(fact_6860_inverse__rat_Oabs__eq,axiom,
    ! [X: product_prod @ int @ int] :
      ( ( ratrel @ X @ X )
     => ( ( inverse_inverse @ rat @ ( abs_Rat @ X ) )
        = ( abs_Rat
          @ ( if @ ( product_prod @ int @ int )
            @ ( ( product_fst @ int @ int @ X )
              = ( zero_zero @ int ) )
            @ ( product_Pair @ int @ int @ ( zero_zero @ int ) @ ( one_one @ int ) )
            @ ( product_Pair @ int @ int @ ( product_snd @ int @ int @ X ) @ ( product_fst @ int @ int @ X ) ) ) ) ) ) ).

% inverse_rat.abs_eq
thf(fact_6861_sorted__insort__insert__key,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F2: B > A,Xs: list @ B,X: B] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( map @ B @ A @ F2 @ Xs ) )
         => ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( map @ B @ A @ F2 @ ( linord329482645794927042rt_key @ B @ A @ F2 @ X @ Xs ) ) ) ) ) ).

% sorted_insort_insert_key
thf(fact_6862_ratrel__iff,axiom,
    ( ratrel
    = ( ^ [X2: product_prod @ int @ int,Y4: product_prod @ int @ int] :
          ( ( ( product_snd @ int @ int @ X2 )
           != ( zero_zero @ int ) )
          & ( ( product_snd @ int @ int @ Y4 )
           != ( zero_zero @ int ) )
          & ( ( times_times @ int @ ( product_fst @ int @ int @ X2 ) @ ( product_snd @ int @ int @ Y4 ) )
            = ( times_times @ int @ ( product_fst @ int @ int @ Y4 ) @ ( product_snd @ int @ int @ X2 ) ) ) ) ) ) ).

% ratrel_iff
thf(fact_6863_zero__rat_Orsp,axiom,
    ratrel @ ( product_Pair @ int @ int @ ( zero_zero @ int ) @ ( one_one @ int ) ) @ ( product_Pair @ int @ int @ ( zero_zero @ int ) @ ( one_one @ int ) ) ).

% zero_rat.rsp
thf(fact_6864_sorted__insort__insert,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A,X: A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs )
         => ( sorted_wrt @ A @ ( ord_less_eq @ A )
            @ ( linord329482645794927042rt_key @ A @ A
              @ ^ [X2: A] : X2
              @ X
              @ Xs ) ) ) ) ).

% sorted_insort_insert
thf(fact_6865_ratrel__def,axiom,
    ( ratrel
    = ( ^ [X2: product_prod @ int @ int,Y4: product_prod @ int @ int] :
          ( ( ( product_snd @ int @ int @ X2 )
           != ( zero_zero @ int ) )
          & ( ( product_snd @ int @ int @ Y4 )
           != ( zero_zero @ int ) )
          & ( ( times_times @ int @ ( product_fst @ int @ int @ X2 ) @ ( product_snd @ int @ int @ Y4 ) )
            = ( times_times @ int @ ( product_fst @ int @ int @ Y4 ) @ ( product_snd @ int @ int @ X2 ) ) ) ) ) ) ).

% ratrel_def
thf(fact_6866_Rat_Opositive_Oabs__eq,axiom,
    ! [X: product_prod @ int @ int] :
      ( ( ratrel @ X @ X )
     => ( ( positive @ ( abs_Rat @ X ) )
        = ( ord_less @ int @ ( zero_zero @ int ) @ ( times_times @ int @ ( product_fst @ int @ int @ X ) @ ( product_snd @ int @ int @ X ) ) ) ) ) ).

% Rat.positive.abs_eq
thf(fact_6867_Rat_Opositive_Orsp,axiom,
    ( bNF_rel_fun @ ( product_prod @ int @ int ) @ ( product_prod @ int @ int ) @ $o @ $o @ ratrel
    @ ^ [Y3: $o,Z2: $o] : ( Y3 = Z2 )
    @ ^ [X2: product_prod @ int @ int] : ( ord_less @ int @ ( zero_zero @ int ) @ ( times_times @ int @ ( product_fst @ int @ int @ X2 ) @ ( product_snd @ int @ int @ X2 ) ) )
    @ ^ [X2: product_prod @ int @ int] : ( ord_less @ int @ ( zero_zero @ int ) @ ( times_times @ int @ ( product_fst @ int @ int @ X2 ) @ ( product_snd @ int @ int @ X2 ) ) ) ) ).

% Rat.positive.rsp
thf(fact_6868_Rat_Opositive__zero,axiom,
    ~ ( positive @ ( zero_zero @ rat ) ) ).

% Rat.positive_zero
thf(fact_6869_transfer__rule__numeral,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( monoid_add @ B )
        & ( semiring_numeral @ B )
        & ( monoid_add @ A )
        & ( semiring_numeral @ A ) )
     => ! [R4: A > B > $o] :
          ( ( R4 @ ( zero_zero @ A ) @ ( zero_zero @ B ) )
         => ( ( R4 @ ( one_one @ A ) @ ( one_one @ B ) )
           => ( ( bNF_rel_fun @ A @ B @ ( A > A ) @ ( B > B ) @ R4 @ ( bNF_rel_fun @ A @ B @ A @ B @ R4 @ R4 ) @ ( plus_plus @ A ) @ ( plus_plus @ B ) )
             => ( bNF_rel_fun @ num @ num @ A @ B
                @ ^ [Y3: num,Z2: num] : ( Y3 = Z2 )
                @ R4
                @ ( numeral_numeral @ A )
                @ ( numeral_numeral @ B ) ) ) ) ) ) ).

% transfer_rule_numeral
thf(fact_6870_transfer__rule__of__int,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( ring_1 @ B )
        & ( ring_1 @ A ) )
     => ! [R4: A > B > $o] :
          ( ( R4 @ ( zero_zero @ A ) @ ( zero_zero @ B ) )
         => ( ( R4 @ ( one_one @ A ) @ ( one_one @ B ) )
           => ( ( bNF_rel_fun @ A @ B @ ( A > A ) @ ( B > B ) @ R4 @ ( bNF_rel_fun @ A @ B @ A @ B @ R4 @ R4 ) @ ( plus_plus @ A ) @ ( plus_plus @ B ) )
             => ( ( bNF_rel_fun @ A @ B @ A @ B @ R4 @ R4 @ ( uminus_uminus @ A ) @ ( uminus_uminus @ B ) )
               => ( bNF_rel_fun @ int @ int @ A @ B
                  @ ^ [Y3: int,Z2: int] : ( Y3 = Z2 )
                  @ R4
                  @ ( ring_1_of_int @ A )
                  @ ( ring_1_of_int @ B ) ) ) ) ) ) ) ).

% transfer_rule_of_int
thf(fact_6871_power__transfer,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( power @ B )
        & ( power @ A ) )
     => ! [R4: A > B > $o] :
          ( ( R4 @ ( one_one @ A ) @ ( one_one @ B ) )
         => ( ( bNF_rel_fun @ A @ B @ ( A > A ) @ ( B > B ) @ R4 @ ( bNF_rel_fun @ A @ B @ A @ B @ R4 @ R4 ) @ ( times_times @ A ) @ ( times_times @ B ) )
           => ( bNF_rel_fun @ A @ B @ ( nat > A ) @ ( nat > B ) @ R4
              @ ( bNF_rel_fun @ nat @ nat @ A @ B
                @ ^ [Y3: nat,Z2: nat] : ( Y3 = Z2 )
                @ R4 )
              @ ( power_power @ A )
              @ ( power_power @ B ) ) ) ) ) ).

% power_transfer
thf(fact_6872_Rat_Opositive__minus,axiom,
    ! [X: rat] :
      ( ~ ( positive @ X )
     => ( ( X
         != ( zero_zero @ rat ) )
       => ( positive @ ( uminus_uminus @ rat @ X ) ) ) ) ).

% Rat.positive_minus
thf(fact_6873_transfer__rule__of__nat,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( semiring_1 @ B )
        & ( semiring_1 @ A ) )
     => ! [R4: A > B > $o] :
          ( ( R4 @ ( zero_zero @ A ) @ ( zero_zero @ B ) )
         => ( ( R4 @ ( one_one @ A ) @ ( one_one @ B ) )
           => ( ( bNF_rel_fun @ A @ B @ ( A > A ) @ ( B > B ) @ R4 @ ( bNF_rel_fun @ A @ B @ A @ B @ R4 @ R4 ) @ ( plus_plus @ A ) @ ( plus_plus @ B ) )
             => ( bNF_rel_fun @ nat @ nat @ A @ B
                @ ^ [Y3: nat,Z2: nat] : ( Y3 = Z2 )
                @ R4
                @ ( semiring_1_of_nat @ A )
                @ ( semiring_1_of_nat @ B ) ) ) ) ) ) ).

% transfer_rule_of_nat
thf(fact_6874_Rat_Opositive_Orep__eq,axiom,
    ( positive
    = ( ^ [X2: rat] : ( ord_less @ int @ ( zero_zero @ int ) @ ( times_times @ int @ ( product_fst @ int @ int @ ( rep_Rat @ X2 ) ) @ ( product_snd @ int @ int @ ( rep_Rat @ X2 ) ) ) ) ) ) ).

% Rat.positive.rep_eq
thf(fact_6875_Fract_Orsp,axiom,
    ( bNF_rel_fun @ int @ int @ ( int > ( product_prod @ int @ int ) ) @ ( int > ( product_prod @ int @ int ) )
    @ ^ [Y3: int,Z2: int] : ( Y3 = Z2 )
    @ ( bNF_rel_fun @ int @ int @ ( product_prod @ int @ int ) @ ( product_prod @ int @ int )
      @ ^ [Y3: int,Z2: int] : ( Y3 = Z2 )
      @ ratrel )
    @ ^ [A3: int,B3: int] :
        ( if @ ( product_prod @ int @ int )
        @ ( B3
          = ( zero_zero @ int ) )
        @ ( product_Pair @ int @ int @ ( zero_zero @ int ) @ ( one_one @ int ) )
        @ ( product_Pair @ int @ int @ A3 @ B3 ) )
    @ ^ [A3: int,B3: int] :
        ( if @ ( product_prod @ int @ int )
        @ ( B3
          = ( zero_zero @ int ) )
        @ ( product_Pair @ int @ int @ ( zero_zero @ int ) @ ( one_one @ int ) )
        @ ( product_Pair @ int @ int @ A3 @ B3 ) ) ) ).

% Fract.rsp
thf(fact_6876_less__eq__natural_Orsp,axiom,
    ( bNF_rel_fun @ nat @ nat @ ( nat > $o ) @ ( nat > $o )
    @ ^ [Y3: nat,Z2: nat] : ( Y3 = Z2 )
    @ ( bNF_rel_fun @ nat @ nat @ $o @ $o
      @ ^ [Y3: nat,Z2: nat] : ( Y3 = Z2 )
      @ ^ [Y3: $o,Z2: $o] : ( Y3 = Z2 ) )
    @ ( ord_less_eq @ nat )
    @ ( ord_less_eq @ nat ) ) ).

% less_eq_natural.rsp
thf(fact_6877_less__eq__integer_Orsp,axiom,
    ( bNF_rel_fun @ int @ int @ ( int > $o ) @ ( int > $o )
    @ ^ [Y3: int,Z2: int] : ( Y3 = Z2 )
    @ ( bNF_rel_fun @ int @ int @ $o @ $o
      @ ^ [Y3: int,Z2: int] : ( Y3 = Z2 )
      @ ^ [Y3: $o,Z2: $o] : ( Y3 = Z2 ) )
    @ ( ord_less_eq @ int )
    @ ( ord_less_eq @ int ) ) ).

% less_eq_integer.rsp
thf(fact_6878_integer__of__natural_Orsp,axiom,
    ( bNF_rel_fun @ nat @ nat @ int @ int
    @ ^ [Y3: nat,Z2: nat] : ( Y3 = Z2 )
    @ ^ [Y3: int,Z2: int] : ( Y3 = Z2 )
    @ ( semiring_1_of_nat @ int )
    @ ( semiring_1_of_nat @ int ) ) ).

% integer_of_natural.rsp
thf(fact_6879_less__natural_Orsp,axiom,
    ( bNF_rel_fun @ nat @ nat @ ( nat > $o ) @ ( nat > $o )
    @ ^ [Y3: nat,Z2: nat] : ( Y3 = Z2 )
    @ ( bNF_rel_fun @ nat @ nat @ $o @ $o
      @ ^ [Y3: nat,Z2: nat] : ( Y3 = Z2 )
      @ ^ [Y3: $o,Z2: $o] : ( Y3 = Z2 ) )
    @ ( ord_less @ nat )
    @ ( ord_less @ nat ) ) ).

% less_natural.rsp
thf(fact_6880_less__integer_Orsp,axiom,
    ( bNF_rel_fun @ int @ int @ ( int > $o ) @ ( int > $o )
    @ ^ [Y3: int,Z2: int] : ( Y3 = Z2 )
    @ ( bNF_rel_fun @ int @ int @ $o @ $o
      @ ^ [Y3: int,Z2: int] : ( Y3 = Z2 )
      @ ^ [Y3: $o,Z2: $o] : ( Y3 = Z2 ) )
    @ ( ord_less @ int )
    @ ( ord_less @ int ) ) ).

% less_integer.rsp
thf(fact_6881_sub_Orsp,axiom,
    ( bNF_rel_fun @ num @ num @ ( num > int ) @ ( num > int )
    @ ^ [Y3: num,Z2: num] : ( Y3 = Z2 )
    @ ( bNF_rel_fun @ num @ num @ int @ int
      @ ^ [Y3: num,Z2: num] : ( Y3 = Z2 )
      @ ^ [Y3: int,Z2: int] : ( Y3 = Z2 ) )
    @ ^ [M3: num,N3: num] : ( minus_minus @ int @ ( numeral_numeral @ int @ M3 ) @ ( numeral_numeral @ int @ N3 ) )
    @ ^ [M3: num,N3: num] : ( minus_minus @ int @ ( numeral_numeral @ int @ M3 ) @ ( numeral_numeral @ int @ N3 ) ) ) ).

% sub.rsp
thf(fact_6882_num_Ocase__transfer,axiom,
    ! [A: $tType,B: $tType,S: A > B > $o] :
      ( bNF_rel_fun @ A @ B @ ( ( num > A ) > ( num > A ) > num > A ) @ ( ( num > B ) > ( num > B ) > num > B ) @ S
      @ ( bNF_rel_fun @ ( num > A ) @ ( num > B ) @ ( ( num > A ) > num > A ) @ ( ( num > B ) > num > B )
        @ ( bNF_rel_fun @ num @ num @ A @ B
          @ ^ [Y3: num,Z2: num] : ( Y3 = Z2 )
          @ S )
        @ ( bNF_rel_fun @ ( num > A ) @ ( num > B ) @ ( num > A ) @ ( num > B )
          @ ( bNF_rel_fun @ num @ num @ A @ B
            @ ^ [Y3: num,Z2: num] : ( Y3 = Z2 )
            @ S )
          @ ( bNF_rel_fun @ num @ num @ A @ B
            @ ^ [Y3: num,Z2: num] : ( Y3 = Z2 )
            @ S ) ) )
      @ ( case_num @ A )
      @ ( case_num @ B ) ) ).

% num.case_transfer
thf(fact_6883_transfer__rule__of__bool,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( zero_neq_one @ B )
        & ( zero_neq_one @ A ) )
     => ! [R4: A > B > $o] :
          ( ( R4 @ ( zero_zero @ A ) @ ( zero_zero @ B ) )
         => ( ( R4 @ ( one_one @ A ) @ ( one_one @ B ) )
           => ( bNF_rel_fun @ $o @ $o @ A @ B
              @ ^ [Y3: $o,Z2: $o] : ( Y3 = Z2 )
              @ R4
              @ ( zero_neq_one_of_bool @ A )
              @ ( zero_neq_one_of_bool @ B ) ) ) ) ) ).

% transfer_rule_of_bool
thf(fact_6884_inverse__rat_Orsp,axiom,
    ( bNF_rel_fun @ ( product_prod @ int @ int ) @ ( product_prod @ int @ int ) @ ( product_prod @ int @ int ) @ ( product_prod @ int @ int ) @ ratrel @ ratrel
    @ ^ [X2: product_prod @ int @ int] :
        ( if @ ( product_prod @ int @ int )
        @ ( ( product_fst @ int @ int @ X2 )
          = ( zero_zero @ int ) )
        @ ( product_Pair @ int @ int @ ( zero_zero @ int ) @ ( one_one @ int ) )
        @ ( product_Pair @ int @ int @ ( product_snd @ int @ int @ X2 ) @ ( product_fst @ int @ int @ X2 ) ) )
    @ ^ [X2: product_prod @ int @ int] :
        ( if @ ( product_prod @ int @ int )
        @ ( ( product_fst @ int @ int @ X2 )
          = ( zero_zero @ int ) )
        @ ( product_Pair @ int @ int @ ( zero_zero @ int ) @ ( one_one @ int ) )
        @ ( product_Pair @ int @ int @ ( product_snd @ int @ int @ X2 ) @ ( product_fst @ int @ int @ X2 ) ) ) ) ).

% inverse_rat.rsp
thf(fact_6885_Rat_Opositive__def,axiom,
    ( positive
    = ( map_fun @ rat @ ( product_prod @ int @ int ) @ $o @ $o @ rep_Rat @ ( id @ $o )
      @ ^ [X2: product_prod @ int @ int] : ( ord_less @ int @ ( zero_zero @ int ) @ ( times_times @ int @ ( product_fst @ int @ int @ X2 ) @ ( product_snd @ int @ int @ X2 ) ) ) ) ) ).

% Rat.positive_def
thf(fact_6886_inverse__rat__def,axiom,
    ( ( inverse_inverse @ rat )
    = ( map_fun @ rat @ ( product_prod @ int @ int ) @ ( product_prod @ int @ int ) @ rat @ rep_Rat @ abs_Rat
      @ ^ [X2: product_prod @ int @ int] :
          ( if @ ( product_prod @ int @ int )
          @ ( ( product_fst @ int @ int @ X2 )
            = ( zero_zero @ int ) )
          @ ( product_Pair @ int @ int @ ( zero_zero @ int ) @ ( one_one @ int ) )
          @ ( product_Pair @ int @ int @ ( product_snd @ int @ int @ X2 ) @ ( product_fst @ int @ int @ X2 ) ) ) ) ) ).

% inverse_rat_def
thf(fact_6887_inverse__rat_Otransfer,axiom,
    ( bNF_rel_fun @ ( product_prod @ int @ int ) @ rat @ ( product_prod @ int @ int ) @ rat @ pcr_rat @ pcr_rat
    @ ^ [X2: product_prod @ int @ int] :
        ( if @ ( product_prod @ int @ int )
        @ ( ( product_fst @ int @ int @ X2 )
          = ( zero_zero @ int ) )
        @ ( product_Pair @ int @ int @ ( zero_zero @ int ) @ ( one_one @ int ) )
        @ ( product_Pair @ int @ int @ ( product_snd @ int @ int @ X2 ) @ ( product_fst @ int @ int @ X2 ) ) )
    @ ( inverse_inverse @ rat ) ) ).

% inverse_rat.transfer
thf(fact_6888_Rat_Opositive_Otransfer,axiom,
    ( bNF_rel_fun @ ( product_prod @ int @ int ) @ rat @ $o @ $o @ pcr_rat
    @ ^ [Y3: $o,Z2: $o] : ( Y3 = Z2 )
    @ ^ [X2: product_prod @ int @ int] : ( ord_less @ int @ ( zero_zero @ int ) @ ( times_times @ int @ ( product_fst @ int @ int @ X2 ) @ ( product_snd @ int @ int @ X2 ) ) )
    @ positive ) ).

% Rat.positive.transfer
thf(fact_6889_zero__rat_Otransfer,axiom,
    pcr_rat @ ( product_Pair @ int @ int @ ( zero_zero @ int ) @ ( one_one @ int ) ) @ ( zero_zero @ rat ) ).

% zero_rat.transfer
thf(fact_6890_times__int_Otransfer,axiom,
    ( bNF_rel_fun @ ( product_prod @ nat @ nat ) @ int @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) ) @ ( int > int ) @ pcr_int @ ( bNF_rel_fun @ ( product_prod @ nat @ nat ) @ int @ ( product_prod @ nat @ nat ) @ int @ pcr_int @ pcr_int )
    @ ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) )
      @ ^ [X2: nat,Y4: nat] :
          ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
          @ ^ [U2: nat,V5: nat] : ( product_Pair @ nat @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ X2 @ U2 ) @ ( times_times @ nat @ Y4 @ V5 ) ) @ ( plus_plus @ nat @ ( times_times @ nat @ X2 @ V5 ) @ ( times_times @ nat @ Y4 @ U2 ) ) ) ) )
    @ ( times_times @ int ) ) ).

% times_int.transfer
thf(fact_6891_num_Orec__transfer,axiom,
    ! [A: $tType,B: $tType,S: A > B > $o] :
      ( bNF_rel_fun @ A @ B @ ( ( num > A > A ) > ( num > A > A ) > num > A ) @ ( ( num > B > B ) > ( num > B > B ) > num > B ) @ S
      @ ( bNF_rel_fun @ ( num > A > A ) @ ( num > B > B ) @ ( ( num > A > A ) > num > A ) @ ( ( num > B > B ) > num > B )
        @ ( bNF_rel_fun @ num @ num @ ( A > A ) @ ( B > B )
          @ ^ [Y3: num,Z2: num] : ( Y3 = Z2 )
          @ ( bNF_rel_fun @ A @ B @ A @ B @ S @ S ) )
        @ ( bNF_rel_fun @ ( num > A > A ) @ ( num > B > B ) @ ( num > A ) @ ( num > B )
          @ ( bNF_rel_fun @ num @ num @ ( A > A ) @ ( B > B )
            @ ^ [Y3: num,Z2: num] : ( Y3 = Z2 )
            @ ( bNF_rel_fun @ A @ B @ A @ B @ S @ S ) )
          @ ( bNF_rel_fun @ num @ num @ A @ B
            @ ^ [Y3: num,Z2: num] : ( Y3 = Z2 )
            @ S ) ) )
      @ ( rec_num @ A )
      @ ( rec_num @ B ) ) ).

% num.rec_transfer
thf(fact_6892_verit__eq__simplify_I19_J,axiom,
    ! [A: $tType,F1: A,F22: num > A > A,F32: num > A > A] :
      ( ( rec_num @ A @ F1 @ F22 @ F32 @ one2 )
      = F1 ) ).

% verit_eq_simplify(19)
thf(fact_6893_verit__eq__simplify_I20_J,axiom,
    ! [A: $tType,F1: A,F22: num > A > A,F32: num > A > A,X22: num] :
      ( ( rec_num @ A @ F1 @ F22 @ F32 @ ( bit0 @ X22 ) )
      = ( F22 @ X22 @ ( rec_num @ A @ F1 @ F22 @ F32 @ X22 ) ) ) ).

% verit_eq_simplify(20)
thf(fact_6894_verit__eq__simplify_I21_J,axiom,
    ! [A: $tType,F1: A,F22: num > A > A,F32: num > A > A,X32: num] :
      ( ( rec_num @ A @ F1 @ F22 @ F32 @ ( bit1 @ X32 ) )
      = ( F32 @ X32 @ ( rec_num @ A @ F1 @ F22 @ F32 @ X32 ) ) ) ).

% verit_eq_simplify(21)
thf(fact_6895_zero__int_Otransfer,axiom,
    pcr_int @ ( product_Pair @ nat @ nat @ ( zero_zero @ nat ) @ ( zero_zero @ nat ) ) @ ( zero_zero @ int ) ).

% zero_int.transfer
thf(fact_6896_int__transfer,axiom,
    ( bNF_rel_fun @ nat @ nat @ ( product_prod @ nat @ nat ) @ int
    @ ^ [Y3: nat,Z2: nat] : ( Y3 = Z2 )
    @ pcr_int
    @ ^ [N3: nat] : ( product_Pair @ nat @ nat @ N3 @ ( zero_zero @ nat ) )
    @ ( semiring_1_of_nat @ int ) ) ).

% int_transfer
thf(fact_6897_uminus__int_Otransfer,axiom,
    ( bNF_rel_fun @ ( product_prod @ nat @ nat ) @ int @ ( product_prod @ nat @ nat ) @ int @ pcr_int @ pcr_int
    @ ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
      @ ^ [X2: nat,Y4: nat] : ( product_Pair @ nat @ nat @ Y4 @ X2 ) )
    @ ( uminus_uminus @ int ) ) ).

% uminus_int.transfer
thf(fact_6898_nat_Otransfer,axiom,
    ( bNF_rel_fun @ ( product_prod @ nat @ nat ) @ int @ nat @ nat @ pcr_int
    @ ^ [Y3: nat,Z2: nat] : ( Y3 = Z2 )
    @ ( product_case_prod @ nat @ nat @ nat @ ( minus_minus @ nat ) )
    @ nat2 ) ).

% nat.transfer
thf(fact_6899_one__int_Otransfer,axiom,
    pcr_int @ ( product_Pair @ nat @ nat @ ( one_one @ nat ) @ ( zero_zero @ nat ) ) @ ( one_one @ int ) ).

% one_int.transfer
thf(fact_6900_of__int_Otransfer,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ( bNF_rel_fun @ ( product_prod @ nat @ nat ) @ int @ A @ A @ pcr_int
        @ ^ [Y3: A,Z2: A] : ( Y3 = Z2 )
        @ ( product_case_prod @ nat @ nat @ A
          @ ^ [I4: nat,J3: nat] : ( minus_minus @ A @ ( semiring_1_of_nat @ A @ I4 ) @ ( semiring_1_of_nat @ A @ J3 ) ) )
        @ ( ring_1_of_int @ A ) ) ) ).

% of_int.transfer
thf(fact_6901_less__int_Otransfer,axiom,
    ( bNF_rel_fun @ ( product_prod @ nat @ nat ) @ int @ ( ( product_prod @ nat @ nat ) > $o ) @ ( int > $o ) @ pcr_int
    @ ( bNF_rel_fun @ ( product_prod @ nat @ nat ) @ int @ $o @ $o @ pcr_int
      @ ^ [Y3: $o,Z2: $o] : ( Y3 = Z2 ) )
    @ ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > $o )
      @ ^ [X2: nat,Y4: nat] :
          ( product_case_prod @ nat @ nat @ $o
          @ ^ [U2: nat,V5: nat] : ( ord_less @ nat @ ( plus_plus @ nat @ X2 @ V5 ) @ ( plus_plus @ nat @ U2 @ Y4 ) ) ) )
    @ ( ord_less @ int ) ) ).

% less_int.transfer
thf(fact_6902_less__eq__int_Otransfer,axiom,
    ( bNF_rel_fun @ ( product_prod @ nat @ nat ) @ int @ ( ( product_prod @ nat @ nat ) > $o ) @ ( int > $o ) @ pcr_int
    @ ( bNF_rel_fun @ ( product_prod @ nat @ nat ) @ int @ $o @ $o @ pcr_int
      @ ^ [Y3: $o,Z2: $o] : ( Y3 = Z2 ) )
    @ ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > $o )
      @ ^ [X2: nat,Y4: nat] :
          ( product_case_prod @ nat @ nat @ $o
          @ ^ [U2: nat,V5: nat] : ( ord_less_eq @ nat @ ( plus_plus @ nat @ X2 @ V5 ) @ ( plus_plus @ nat @ U2 @ Y4 ) ) ) )
    @ ( ord_less_eq @ int ) ) ).

% less_eq_int.transfer
thf(fact_6903_plus__int_Otransfer,axiom,
    ( bNF_rel_fun @ ( product_prod @ nat @ nat ) @ int @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) ) @ ( int > int ) @ pcr_int @ ( bNF_rel_fun @ ( product_prod @ nat @ nat ) @ int @ ( product_prod @ nat @ nat ) @ int @ pcr_int @ pcr_int )
    @ ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) )
      @ ^ [X2: nat,Y4: nat] :
          ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
          @ ^ [U2: nat,V5: nat] : ( product_Pair @ nat @ nat @ ( plus_plus @ nat @ X2 @ U2 ) @ ( plus_plus @ nat @ Y4 @ V5 ) ) ) )
    @ ( plus_plus @ int ) ) ).

% plus_int.transfer
thf(fact_6904_minus__int_Otransfer,axiom,
    ( bNF_rel_fun @ ( product_prod @ nat @ nat ) @ int @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) ) @ ( int > int ) @ pcr_int @ ( bNF_rel_fun @ ( product_prod @ nat @ nat ) @ int @ ( product_prod @ nat @ nat ) @ int @ pcr_int @ pcr_int )
    @ ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) )
      @ ^ [X2: nat,Y4: nat] :
          ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
          @ ^ [U2: nat,V5: nat] : ( product_Pair @ nat @ nat @ ( plus_plus @ nat @ X2 @ V5 ) @ ( plus_plus @ nat @ Y4 @ U2 ) ) ) )
    @ ( minus_minus @ int ) ) ).

% minus_int.transfer
thf(fact_6905_times__int_Orsp,axiom,
    ( bNF_rel_fun @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) ) @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) ) @ intrel @ ( bNF_rel_fun @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ intrel @ intrel )
    @ ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) )
      @ ^ [X2: nat,Y4: nat] :
          ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
          @ ^ [U2: nat,V5: nat] : ( product_Pair @ nat @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ X2 @ U2 ) @ ( times_times @ nat @ Y4 @ V5 ) ) @ ( plus_plus @ nat @ ( times_times @ nat @ X2 @ V5 ) @ ( times_times @ nat @ Y4 @ U2 ) ) ) ) )
    @ ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) )
      @ ^ [X2: nat,Y4: nat] :
          ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
          @ ^ [U2: nat,V5: nat] : ( product_Pair @ nat @ nat @ ( plus_plus @ nat @ ( times_times @ nat @ X2 @ U2 ) @ ( times_times @ nat @ Y4 @ V5 ) ) @ ( plus_plus @ nat @ ( times_times @ nat @ X2 @ V5 ) @ ( times_times @ nat @ Y4 @ U2 ) ) ) ) ) ) ).

% times_int.rsp
thf(fact_6906_Real_Opositive_Orsp,axiom,
    ( bNF_rel_fun @ ( nat > rat ) @ ( nat > rat ) @ $o @ $o @ realrel
    @ ^ [Y3: $o,Z2: $o] : ( Y3 = Z2 )
    @ ^ [X8: nat > rat] :
      ? [R5: rat] :
        ( ( ord_less @ rat @ ( zero_zero @ rat ) @ R5 )
        & ? [K3: nat] :
          ! [N3: nat] :
            ( ( ord_less_eq @ nat @ K3 @ N3 )
           => ( ord_less @ rat @ R5 @ ( X8 @ N3 ) ) ) )
    @ ^ [X8: nat > rat] :
      ? [R5: rat] :
        ( ( ord_less @ rat @ ( zero_zero @ rat ) @ R5 )
        & ? [K3: nat] :
          ! [N3: nat] :
            ( ( ord_less_eq @ nat @ K3 @ N3 )
           => ( ord_less @ rat @ R5 @ ( X8 @ N3 ) ) ) ) ) ).

% Real.positive.rsp
thf(fact_6907_intrel__iff,axiom,
    ! [X: nat,Y: nat,U: nat,V: nat] :
      ( ( intrel @ ( product_Pair @ nat @ nat @ X @ Y ) @ ( product_Pair @ nat @ nat @ U @ V ) )
      = ( ( plus_plus @ nat @ X @ V )
        = ( plus_plus @ nat @ U @ Y ) ) ) ).

% intrel_iff
thf(fact_6908_plus__real_Orsp,axiom,
    ( bNF_rel_fun @ ( nat > rat ) @ ( nat > rat ) @ ( ( nat > rat ) > nat > rat ) @ ( ( nat > rat ) > nat > rat ) @ realrel @ ( bNF_rel_fun @ ( nat > rat ) @ ( nat > rat ) @ ( nat > rat ) @ ( nat > rat ) @ realrel @ realrel )
    @ ^ [X8: nat > rat,Y8: nat > rat,N3: nat] : ( plus_plus @ rat @ ( X8 @ N3 ) @ ( Y8 @ N3 ) )
    @ ^ [X8: nat > rat,Y8: nat > rat,N3: nat] : ( plus_plus @ rat @ ( X8 @ N3 ) @ ( Y8 @ N3 ) ) ) ).

% plus_real.rsp
thf(fact_6909_times__real_Orsp,axiom,
    ( bNF_rel_fun @ ( nat > rat ) @ ( nat > rat ) @ ( ( nat > rat ) > nat > rat ) @ ( ( nat > rat ) > nat > rat ) @ realrel @ ( bNF_rel_fun @ ( nat > rat ) @ ( nat > rat ) @ ( nat > rat ) @ ( nat > rat ) @ realrel @ realrel )
    @ ^ [X8: nat > rat,Y8: nat > rat,N3: nat] : ( times_times @ rat @ ( X8 @ N3 ) @ ( Y8 @ N3 ) )
    @ ^ [X8: nat > rat,Y8: nat > rat,N3: nat] : ( times_times @ rat @ ( X8 @ N3 ) @ ( Y8 @ N3 ) ) ) ).

% times_real.rsp
thf(fact_6910_int_Orel__eq__transfer,axiom,
    ( bNF_rel_fun @ ( product_prod @ nat @ nat ) @ int @ ( ( product_prod @ nat @ nat ) > $o ) @ ( int > $o ) @ pcr_int
    @ ( bNF_rel_fun @ ( product_prod @ nat @ nat ) @ int @ $o @ $o @ pcr_int
      @ ^ [Y3: $o,Z2: $o] : ( Y3 = Z2 ) )
    @ intrel
    @ ^ [Y3: int,Z2: int] : ( Y3 = Z2 ) ) ).

% int.rel_eq_transfer
thf(fact_6911_uminus__real_Orsp,axiom,
    ( bNF_rel_fun @ ( nat > rat ) @ ( nat > rat ) @ ( nat > rat ) @ ( nat > rat ) @ realrel @ realrel
    @ ^ [X8: nat > rat,N3: nat] : ( uminus_uminus @ rat @ ( X8 @ N3 ) )
    @ ^ [X8: nat > rat,N3: nat] : ( uminus_uminus @ rat @ ( X8 @ N3 ) ) ) ).

% uminus_real.rsp
thf(fact_6912_zero__real_Orsp,axiom,
    ( realrel
    @ ^ [N3: nat] : ( zero_zero @ rat )
    @ ^ [N3: nat] : ( zero_zero @ rat ) ) ).

% zero_real.rsp
thf(fact_6913_int_Oabs__eq__iff,axiom,
    ! [X: product_prod @ nat @ nat,Y: product_prod @ nat @ nat] :
      ( ( ( abs_Integ @ X )
        = ( abs_Integ @ Y ) )
      = ( intrel @ X @ Y ) ) ).

% int.abs_eq_iff
thf(fact_6914_one__real_Orsp,axiom,
    ( realrel
    @ ^ [N3: nat] : ( one_one @ rat )
    @ ^ [N3: nat] : ( one_one @ rat ) ) ).

% one_real.rsp
thf(fact_6915_zero__int_Orsp,axiom,
    intrel @ ( product_Pair @ nat @ nat @ ( zero_zero @ nat ) @ ( zero_zero @ nat ) ) @ ( product_Pair @ nat @ nat @ ( zero_zero @ nat ) @ ( zero_zero @ nat ) ) ).

% zero_int.rsp
thf(fact_6916_uminus__int_Orsp,axiom,
    ( bNF_rel_fun @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ intrel @ intrel
    @ ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
      @ ^ [X2: nat,Y4: nat] : ( product_Pair @ nat @ nat @ Y4 @ X2 ) )
    @ ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
      @ ^ [X2: nat,Y4: nat] : ( product_Pair @ nat @ nat @ Y4 @ X2 ) ) ) ).

% uminus_int.rsp
thf(fact_6917_nat_Orsp,axiom,
    ( bNF_rel_fun @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ nat @ nat @ intrel
    @ ^ [Y3: nat,Z2: nat] : ( Y3 = Z2 )
    @ ( product_case_prod @ nat @ nat @ nat @ ( minus_minus @ nat ) )
    @ ( product_case_prod @ nat @ nat @ nat @ ( minus_minus @ nat ) ) ) ).

% nat.rsp
thf(fact_6918_one__int_Orsp,axiom,
    intrel @ ( product_Pair @ nat @ nat @ ( one_one @ nat ) @ ( zero_zero @ nat ) ) @ ( product_Pair @ nat @ nat @ ( one_one @ nat ) @ ( zero_zero @ nat ) ) ).

% one_int.rsp
thf(fact_6919_of__int_Orsp,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ( bNF_rel_fun @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ A @ A @ intrel
        @ ^ [Y3: A,Z2: A] : ( Y3 = Z2 )
        @ ( product_case_prod @ nat @ nat @ A
          @ ^ [I4: nat,J3: nat] : ( minus_minus @ A @ ( semiring_1_of_nat @ A @ I4 ) @ ( semiring_1_of_nat @ A @ J3 ) ) )
        @ ( product_case_prod @ nat @ nat @ A
          @ ^ [I4: nat,J3: nat] : ( minus_minus @ A @ ( semiring_1_of_nat @ A @ I4 ) @ ( semiring_1_of_nat @ A @ J3 ) ) ) ) ) ).

% of_int.rsp
thf(fact_6920_intrel__def,axiom,
    ( intrel
    = ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > $o )
      @ ^ [X2: nat,Y4: nat] :
          ( product_case_prod @ nat @ nat @ $o
          @ ^ [U2: nat,V5: nat] :
              ( ( plus_plus @ nat @ X2 @ V5 )
              = ( plus_plus @ nat @ U2 @ Y4 ) ) ) ) ) ).

% intrel_def
thf(fact_6921_less__int_Orsp,axiom,
    ( bNF_rel_fun @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ ( ( product_prod @ nat @ nat ) > $o ) @ ( ( product_prod @ nat @ nat ) > $o ) @ intrel
    @ ( bNF_rel_fun @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ $o @ $o @ intrel
      @ ^ [Y3: $o,Z2: $o] : ( Y3 = Z2 ) )
    @ ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > $o )
      @ ^ [X2: nat,Y4: nat] :
          ( product_case_prod @ nat @ nat @ $o
          @ ^ [U2: nat,V5: nat] : ( ord_less @ nat @ ( plus_plus @ nat @ X2 @ V5 ) @ ( plus_plus @ nat @ U2 @ Y4 ) ) ) )
    @ ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > $o )
      @ ^ [X2: nat,Y4: nat] :
          ( product_case_prod @ nat @ nat @ $o
          @ ^ [U2: nat,V5: nat] : ( ord_less @ nat @ ( plus_plus @ nat @ X2 @ V5 ) @ ( plus_plus @ nat @ U2 @ Y4 ) ) ) ) ) ).

% less_int.rsp
thf(fact_6922_less__eq__int_Orsp,axiom,
    ( bNF_rel_fun @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ ( ( product_prod @ nat @ nat ) > $o ) @ ( ( product_prod @ nat @ nat ) > $o ) @ intrel
    @ ( bNF_rel_fun @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ $o @ $o @ intrel
      @ ^ [Y3: $o,Z2: $o] : ( Y3 = Z2 ) )
    @ ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > $o )
      @ ^ [X2: nat,Y4: nat] :
          ( product_case_prod @ nat @ nat @ $o
          @ ^ [U2: nat,V5: nat] : ( ord_less_eq @ nat @ ( plus_plus @ nat @ X2 @ V5 ) @ ( plus_plus @ nat @ U2 @ Y4 ) ) ) )
    @ ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > $o )
      @ ^ [X2: nat,Y4: nat] :
          ( product_case_prod @ nat @ nat @ $o
          @ ^ [U2: nat,V5: nat] : ( ord_less_eq @ nat @ ( plus_plus @ nat @ X2 @ V5 ) @ ( plus_plus @ nat @ U2 @ Y4 ) ) ) ) ) ).

% less_eq_int.rsp
thf(fact_6923_minus__int_Orsp,axiom,
    ( bNF_rel_fun @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) ) @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) ) @ intrel @ ( bNF_rel_fun @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ intrel @ intrel )
    @ ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) )
      @ ^ [X2: nat,Y4: nat] :
          ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
          @ ^ [U2: nat,V5: nat] : ( product_Pair @ nat @ nat @ ( plus_plus @ nat @ X2 @ V5 ) @ ( plus_plus @ nat @ Y4 @ U2 ) ) ) )
    @ ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) )
      @ ^ [X2: nat,Y4: nat] :
          ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
          @ ^ [U2: nat,V5: nat] : ( product_Pair @ nat @ nat @ ( plus_plus @ nat @ X2 @ V5 ) @ ( plus_plus @ nat @ Y4 @ U2 ) ) ) ) ) ).

% minus_int.rsp
thf(fact_6924_plus__int_Orsp,axiom,
    ( bNF_rel_fun @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) ) @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) ) @ intrel @ ( bNF_rel_fun @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ intrel @ intrel )
    @ ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) )
      @ ^ [X2: nat,Y4: nat] :
          ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
          @ ^ [U2: nat,V5: nat] : ( product_Pair @ nat @ nat @ ( plus_plus @ nat @ X2 @ U2 ) @ ( plus_plus @ nat @ Y4 @ V5 ) ) ) )
    @ ( product_case_prod @ nat @ nat @ ( ( product_prod @ nat @ nat ) > ( product_prod @ nat @ nat ) )
      @ ^ [X2: nat,Y4: nat] :
          ( product_case_prod @ nat @ nat @ ( product_prod @ nat @ nat )
          @ ^ [U2: nat,V5: nat] : ( product_Pair @ nat @ nat @ ( plus_plus @ nat @ X2 @ U2 ) @ ( plus_plus @ nat @ Y4 @ V5 ) ) ) ) ) ).

% plus_int.rsp
thf(fact_6925_mono__transfer,axiom,
    ! [A: $tType,C: $tType,D: $tType,B: $tType] :
      ( ( ( order @ B )
        & ( order @ D )
        & ( order @ C )
        & ( order @ A ) )
     => ! [A4: A > B > $o,B7: C > D > $o] :
          ( ( bi_total @ A @ B @ A4 )
         => ( ( bNF_rel_fun @ A @ B @ ( A > $o ) @ ( B > $o ) @ A4
              @ ( bNF_rel_fun @ A @ B @ $o @ $o @ A4
                @ ^ [Y3: $o,Z2: $o] : ( Y3 = Z2 ) )
              @ ( ord_less_eq @ A )
              @ ( ord_less_eq @ B ) )
           => ( ( bNF_rel_fun @ C @ D @ ( C > $o ) @ ( D > $o ) @ B7
                @ ( bNF_rel_fun @ C @ D @ $o @ $o @ B7
                  @ ^ [Y3: $o,Z2: $o] : ( Y3 = Z2 ) )
                @ ( ord_less_eq @ C )
                @ ( ord_less_eq @ D ) )
             => ( bNF_rel_fun @ ( A > C ) @ ( B > D ) @ $o @ $o @ ( bNF_rel_fun @ A @ B @ C @ D @ A4 @ B7 )
                @ ^ [Y3: $o,Z2: $o] : ( Y3 = Z2 )
                @ ( order_mono @ A @ C )
                @ ( order_mono @ B @ D ) ) ) ) ) ) ).

% mono_transfer
thf(fact_6926_cauchy__filter__metric__filtermap,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( real_V768167426530841204y_dist @ B )
        & ( topolo7287701948861334536_space @ B ) )
     => ! [F2: A > B,F4: filter @ A] :
          ( ( topolo6773858410816713723filter @ B @ ( filtermap @ A @ B @ F2 @ F4 ) )
          = ( ! [E3: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ E3 )
               => ? [P3: A > $o] :
                    ( ( eventually @ A @ P3 @ F4 )
                    & ! [X2: A,Y4: A] :
                        ( ( ( P3 @ X2 )
                          & ( P3 @ Y4 ) )
                       => ( ord_less @ real @ ( real_V557655796197034286t_dist @ B @ ( F2 @ X2 ) @ ( F2 @ Y4 ) ) @ E3 ) ) ) ) ) ) ) ).

% cauchy_filter_metric_filtermap
thf(fact_6927_int_Obi__total,axiom,
    bi_total @ ( product_prod @ nat @ nat ) @ int @ pcr_int ).

% int.bi_total
thf(fact_6928_filtermap__nhds__times,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ! [C2: A,A2: A] :
          ( ( C2
           != ( zero_zero @ A ) )
         => ( ( filtermap @ A @ A @ ( times_times @ A @ C2 ) @ ( topolo7230453075368039082e_nhds @ A @ A2 ) )
            = ( topolo7230453075368039082e_nhds @ A @ ( times_times @ A @ C2 @ A2 ) ) ) ) ) ).

% filtermap_nhds_times
thf(fact_6929_at__to__0,axiom,
    ! [A: $tType] :
      ( ( real_V822414075346904944vector @ A )
     => ! [A2: A] :
          ( ( topolo174197925503356063within @ A @ A2 @ ( top_top @ ( set @ A ) ) )
          = ( filtermap @ A @ A
            @ ^ [X2: A] : ( plus_plus @ A @ X2 @ A2 )
            @ ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) ) ) ) ) ).

% at_to_0
thf(fact_6930_at__right__to__0,axiom,
    ! [A2: real] :
      ( ( topolo174197925503356063within @ real @ A2 @ ( set_ord_greaterThan @ real @ A2 ) )
      = ( filtermap @ real @ real
        @ ^ [X2: real] : ( plus_plus @ real @ X2 @ A2 )
        @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) ) ) ).

% at_right_to_0
thf(fact_6931_filtermap__times__pos__at__right,axiom,
    ! [A: $tType] :
      ( ( ( linordered_field @ A )
        & ( topolo1944317154257567458pology @ A ) )
     => ! [C2: A,P6: A] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ C2 )
         => ( ( filtermap @ A @ A @ ( times_times @ A @ C2 ) @ ( topolo174197925503356063within @ A @ P6 @ ( set_ord_greaterThan @ A @ P6 ) ) )
            = ( topolo174197925503356063within @ A @ ( times_times @ A @ C2 @ P6 ) @ ( set_ord_greaterThan @ A @ ( times_times @ A @ C2 @ P6 ) ) ) ) ) ) ).

% filtermap_times_pos_at_right
thf(fact_6932_at__to__infinity,axiom,
    ! [A: $tType] :
      ( ( real_V3459762299906320749_field @ A )
     => ( ( topolo174197925503356063within @ A @ ( zero_zero @ A ) @ ( top_top @ ( set @ A ) ) )
        = ( filtermap @ A @ A @ ( inverse_inverse @ A ) @ ( at_infinity @ A ) ) ) ) ).

% at_to_infinity
thf(fact_6933_at__right__to__top,axiom,
    ( ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) )
    = ( filtermap @ real @ real @ ( inverse_inverse @ real ) @ ( at_top @ real ) ) ) ).

% at_right_to_top
thf(fact_6934_at__top__to__right,axiom,
    ( ( at_top @ real )
    = ( filtermap @ real @ real @ ( inverse_inverse @ real ) @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) ) ) ).

% at_top_to_right
thf(fact_6935_filtermap__ln__at__right,axiom,
    ( ( filtermap @ real @ real @ ( ln_ln @ real ) @ ( topolo174197925503356063within @ real @ ( zero_zero @ real ) @ ( set_ord_greaterThan @ real @ ( zero_zero @ real ) ) ) )
    = ( at_bot @ real ) ) ).

% filtermap_ln_at_right
thf(fact_6936_inverse__real_Orsp,axiom,
    ( bNF_rel_fun @ ( nat > rat ) @ ( nat > rat ) @ ( nat > rat ) @ ( nat > rat ) @ realrel @ realrel
    @ ^ [X8: nat > rat] :
        ( if @ ( nat > rat ) @ ( vanishes @ X8 )
        @ ^ [N3: nat] : ( zero_zero @ rat )
        @ ^ [N3: nat] : ( inverse_inverse @ rat @ ( X8 @ N3 ) ) )
    @ ^ [X8: nat > rat] :
        ( if @ ( nat > rat ) @ ( vanishes @ X8 )
        @ ^ [N3: nat] : ( zero_zero @ rat )
        @ ^ [N3: nat] : ( inverse_inverse @ rat @ ( X8 @ N3 ) ) ) ) ).

% inverse_real.rsp
thf(fact_6937_vanishes__mult__bounded,axiom,
    ! [X7: nat > rat,Y7: nat > rat] :
      ( ? [A9: rat] :
          ( ( ord_less @ rat @ ( zero_zero @ rat ) @ A9 )
          & ! [N2: nat] : ( ord_less @ rat @ ( abs_abs @ rat @ ( X7 @ N2 ) ) @ A9 ) )
     => ( ( vanishes @ Y7 )
       => ( vanishes
          @ ^ [N3: nat] : ( times_times @ rat @ ( X7 @ N3 ) @ ( Y7 @ N3 ) ) ) ) ) ).

% vanishes_mult_bounded
thf(fact_6938_vanishes__const,axiom,
    ! [C2: rat] :
      ( ( vanishes
        @ ^ [N3: nat] : C2 )
      = ( C2
        = ( zero_zero @ rat ) ) ) ).

% vanishes_const
thf(fact_6939_vanishes__add,axiom,
    ! [X7: nat > rat,Y7: nat > rat] :
      ( ( vanishes @ X7 )
     => ( ( vanishes @ Y7 )
       => ( vanishes
          @ ^ [N3: nat] : ( plus_plus @ rat @ ( X7 @ N3 ) @ ( Y7 @ N3 ) ) ) ) ) ).

% vanishes_add
thf(fact_6940_vanishes__diff,axiom,
    ! [X7: nat > rat,Y7: nat > rat] :
      ( ( vanishes @ X7 )
     => ( ( vanishes @ Y7 )
       => ( vanishes
          @ ^ [N3: nat] : ( minus_minus @ rat @ ( X7 @ N3 ) @ ( Y7 @ N3 ) ) ) ) ) ).

% vanishes_diff
thf(fact_6941_vanishes__minus,axiom,
    ! [X7: nat > rat] :
      ( ( vanishes @ X7 )
     => ( vanishes
        @ ^ [N3: nat] : ( uminus_uminus @ rat @ ( X7 @ N3 ) ) ) ) ).

% vanishes_minus
thf(fact_6942_vanishesD,axiom,
    ! [X7: nat > rat,R2: rat] :
      ( ( vanishes @ X7 )
     => ( ( ord_less @ rat @ ( zero_zero @ rat ) @ R2 )
       => ? [K2: nat] :
          ! [N7: nat] :
            ( ( ord_less_eq @ nat @ K2 @ N7 )
           => ( ord_less @ rat @ ( abs_abs @ rat @ ( X7 @ N7 ) ) @ R2 ) ) ) ) ).

% vanishesD
thf(fact_6943_vanishesI,axiom,
    ! [X7: nat > rat] :
      ( ! [R: rat] :
          ( ( ord_less @ rat @ ( zero_zero @ rat ) @ R )
         => ? [K4: nat] :
            ! [N2: nat] :
              ( ( ord_less_eq @ nat @ K4 @ N2 )
             => ( ord_less @ rat @ ( abs_abs @ rat @ ( X7 @ N2 ) ) @ R ) ) )
     => ( vanishes @ X7 ) ) ).

% vanishesI
thf(fact_6944_vanishes__def,axiom,
    ( vanishes
    = ( ^ [X8: nat > rat] :
        ! [R5: rat] :
          ( ( ord_less @ rat @ ( zero_zero @ rat ) @ R5 )
         => ? [K3: nat] :
            ! [N3: nat] :
              ( ( ord_less_eq @ nat @ K3 @ N3 )
             => ( ord_less @ rat @ ( abs_abs @ rat @ ( X8 @ N3 ) ) @ R5 ) ) ) ) ) ).

% vanishes_def
thf(fact_6945_inverse__real_Otransfer,axiom,
    ( bNF_rel_fun @ ( nat > rat ) @ real @ ( nat > rat ) @ real @ pcr_real @ pcr_real
    @ ^ [X8: nat > rat] :
        ( if @ ( nat > rat ) @ ( vanishes @ X8 )
        @ ^ [N3: nat] : ( zero_zero @ rat )
        @ ^ [N3: nat] : ( inverse_inverse @ rat @ ( X8 @ N3 ) ) )
    @ ( inverse_inverse @ real ) ) ).

% inverse_real.transfer
thf(fact_6946_inverse__real_Oabs__eq,axiom,
    ! [X: nat > rat] :
      ( ( realrel @ X @ X )
     => ( ( inverse_inverse @ real @ ( real2 @ X ) )
        = ( real2
          @ ( if @ ( nat > rat ) @ ( vanishes @ X )
            @ ^ [N3: nat] : ( zero_zero @ rat )
            @ ^ [N3: nat] : ( inverse_inverse @ rat @ ( X @ N3 ) ) ) ) ) ) ).

% inverse_real.abs_eq
thf(fact_6947_real_Oabs__induct,axiom,
    ! [P: real > $o,X: real] :
      ( ! [Y5: nat > rat] :
          ( ( realrel @ Y5 @ Y5 )
         => ( P @ ( real2 @ Y5 ) ) )
     => ( P @ X ) ) ).

% real.abs_induct
thf(fact_6948_of__int__Real,axiom,
    ( ( ring_1_of_int @ real )
    = ( ^ [X2: int] :
          ( real2
          @ ^ [N3: nat] : ( ring_1_of_int @ rat @ X2 ) ) ) ) ).

% of_int_Real
thf(fact_6949_of__nat__Real,axiom,
    ( ( semiring_1_of_nat @ real )
    = ( ^ [X2: nat] :
          ( real2
          @ ^ [N3: nat] : ( semiring_1_of_nat @ rat @ X2 ) ) ) ) ).

% of_nat_Real
thf(fact_6950_zero__real__def,axiom,
    ( ( zero_zero @ real )
    = ( real2
      @ ^ [N3: nat] : ( zero_zero @ rat ) ) ) ).

% zero_real_def
thf(fact_6951_real_Orel__eq__transfer,axiom,
    ( bNF_rel_fun @ ( nat > rat ) @ real @ ( ( nat > rat ) > $o ) @ ( real > $o ) @ pcr_real
    @ ( bNF_rel_fun @ ( nat > rat ) @ real @ $o @ $o @ pcr_real
      @ ^ [Y3: $o,Z2: $o] : ( Y3 = Z2 ) )
    @ realrel
    @ ^ [Y3: real,Z2: real] : ( Y3 = Z2 ) ) ).

% real.rel_eq_transfer
thf(fact_6952_one__real__def,axiom,
    ( ( one_one @ real )
    = ( real2
      @ ^ [N3: nat] : ( one_one @ rat ) ) ) ).

% one_real_def
thf(fact_6953_zero__real_Otransfer,axiom,
    ( pcr_real
    @ ^ [N3: nat] : ( zero_zero @ rat )
    @ ( zero_zero @ real ) ) ).

% zero_real.transfer
thf(fact_6954_one__real_Otransfer,axiom,
    ( pcr_real
    @ ^ [N3: nat] : ( one_one @ rat )
    @ ( one_one @ real ) ) ).

% one_real.transfer
thf(fact_6955_uminus__real_Otransfer,axiom,
    ( bNF_rel_fun @ ( nat > rat ) @ real @ ( nat > rat ) @ real @ pcr_real @ pcr_real
    @ ^ [X8: nat > rat,N3: nat] : ( uminus_uminus @ rat @ ( X8 @ N3 ) )
    @ ( uminus_uminus @ real ) ) ).

% uminus_real.transfer
thf(fact_6956_plus__real_Otransfer,axiom,
    ( bNF_rel_fun @ ( nat > rat ) @ real @ ( ( nat > rat ) > nat > rat ) @ ( real > real ) @ pcr_real @ ( bNF_rel_fun @ ( nat > rat ) @ real @ ( nat > rat ) @ real @ pcr_real @ pcr_real )
    @ ^ [X8: nat > rat,Y8: nat > rat,N3: nat] : ( plus_plus @ rat @ ( X8 @ N3 ) @ ( Y8 @ N3 ) )
    @ ( plus_plus @ real ) ) ).

% plus_real.transfer
thf(fact_6957_uminus__real_Oabs__eq,axiom,
    ! [X: nat > rat] :
      ( ( realrel @ X @ X )
     => ( ( uminus_uminus @ real @ ( real2 @ X ) )
        = ( real2
          @ ^ [N3: nat] : ( uminus_uminus @ rat @ ( X @ N3 ) ) ) ) ) ).

% uminus_real.abs_eq
thf(fact_6958_times__real_Otransfer,axiom,
    ( bNF_rel_fun @ ( nat > rat ) @ real @ ( ( nat > rat ) > nat > rat ) @ ( real > real ) @ pcr_real @ ( bNF_rel_fun @ ( nat > rat ) @ real @ ( nat > rat ) @ real @ pcr_real @ pcr_real )
    @ ^ [X8: nat > rat,Y8: nat > rat,N3: nat] : ( times_times @ rat @ ( X8 @ N3 ) @ ( Y8 @ N3 ) )
    @ ( times_times @ real ) ) ).

% times_real.transfer
thf(fact_6959_plus__real_Oabs__eq,axiom,
    ! [Xa: nat > rat,X: nat > rat] :
      ( ( realrel @ Xa @ Xa )
     => ( ( realrel @ X @ X )
       => ( ( plus_plus @ real @ ( real2 @ Xa ) @ ( real2 @ X ) )
          = ( real2
            @ ^ [N3: nat] : ( plus_plus @ rat @ ( Xa @ N3 ) @ ( X @ N3 ) ) ) ) ) ) ).

% plus_real.abs_eq
thf(fact_6960_times__real_Oabs__eq,axiom,
    ! [Xa: nat > rat,X: nat > rat] :
      ( ( realrel @ Xa @ Xa )
     => ( ( realrel @ X @ X )
       => ( ( times_times @ real @ ( real2 @ Xa ) @ ( real2 @ X ) )
          = ( real2
            @ ^ [N3: nat] : ( times_times @ rat @ ( Xa @ N3 ) @ ( X @ N3 ) ) ) ) ) ) ).

% times_real.abs_eq
thf(fact_6961_Real_Opositive_Otransfer,axiom,
    ( bNF_rel_fun @ ( nat > rat ) @ real @ $o @ $o @ pcr_real
    @ ^ [Y3: $o,Z2: $o] : ( Y3 = Z2 )
    @ ^ [X8: nat > rat] :
      ? [R5: rat] :
        ( ( ord_less @ rat @ ( zero_zero @ rat ) @ R5 )
        & ? [K3: nat] :
          ! [N3: nat] :
            ( ( ord_less_eq @ nat @ K3 @ N3 )
           => ( ord_less @ rat @ R5 @ ( X8 @ N3 ) ) ) )
    @ positive2 ) ).

% Real.positive.transfer
thf(fact_6962_Real_Opositive_Oabs__eq,axiom,
    ! [X: nat > rat] :
      ( ( realrel @ X @ X )
     => ( ( positive2 @ ( real2 @ X ) )
        = ( ? [R5: rat] :
              ( ( ord_less @ rat @ ( zero_zero @ rat ) @ R5 )
              & ? [K3: nat] :
                ! [N3: nat] :
                  ( ( ord_less_eq @ nat @ K3 @ N3 )
                 => ( ord_less @ rat @ R5 @ ( X @ N3 ) ) ) ) ) ) ) ).

% Real.positive.abs_eq
thf(fact_6963_Real_Opositive__mult,axiom,
    ! [X: real,Y: real] :
      ( ( positive2 @ X )
     => ( ( positive2 @ Y )
       => ( positive2 @ ( times_times @ real @ X @ Y ) ) ) ) ).

% Real.positive_mult
thf(fact_6964_Real_Opositive__zero,axiom,
    ~ ( positive2 @ ( zero_zero @ real ) ) ).

% Real.positive_zero
thf(fact_6965_Real_Opositive__add,axiom,
    ! [X: real,Y: real] :
      ( ( positive2 @ X )
     => ( ( positive2 @ Y )
       => ( positive2 @ ( plus_plus @ real @ X @ Y ) ) ) ) ).

% Real.positive_add
thf(fact_6966_Real_Opositive__minus,axiom,
    ! [X: real] :
      ( ~ ( positive2 @ X )
     => ( ( X
         != ( zero_zero @ real ) )
       => ( positive2 @ ( uminus_uminus @ real @ X ) ) ) ) ).

% Real.positive_minus
thf(fact_6967_less__real__def,axiom,
    ( ( ord_less @ real )
    = ( ^ [X2: real,Y4: real] : ( positive2 @ ( minus_minus @ real @ Y4 @ X2 ) ) ) ) ).

% less_real_def
thf(fact_6968_le__Real,axiom,
    ! [X7: nat > rat,Y7: nat > rat] :
      ( ( cauchy @ X7 )
     => ( ( cauchy @ Y7 )
       => ( ( ord_less_eq @ real @ ( real2 @ X7 ) @ ( real2 @ Y7 ) )
          = ( ! [R5: rat] :
                ( ( ord_less @ rat @ ( zero_zero @ rat ) @ R5 )
               => ? [K3: nat] :
                  ! [N3: nat] :
                    ( ( ord_less_eq @ nat @ K3 @ N3 )
                   => ( ord_less_eq @ rat @ ( X7 @ N3 ) @ ( plus_plus @ rat @ ( Y7 @ N3 ) @ R5 ) ) ) ) ) ) ) ) ).

% le_Real
thf(fact_6969_Real_Opositive_Orep__eq,axiom,
    ( positive2
    = ( ^ [X2: real] :
        ? [R5: rat] :
          ( ( ord_less @ rat @ ( zero_zero @ rat ) @ R5 )
          & ? [K3: nat] :
            ! [N3: nat] :
              ( ( ord_less_eq @ nat @ K3 @ N3 )
             => ( ord_less @ rat @ R5 @ ( rep_real @ X2 @ N3 ) ) ) ) ) ) ).

% Real.positive.rep_eq
thf(fact_6970_realrel__refl,axiom,
    ! [X7: nat > rat] :
      ( ( cauchy @ X7 )
     => ( realrel @ X7 @ X7 ) ) ).

% realrel_refl
thf(fact_6971_cauchy__const,axiom,
    ! [X: rat] :
      ( cauchy
      @ ^ [N3: nat] : X ) ).

% cauchy_const
thf(fact_6972_cauchy__minus,axiom,
    ! [X7: nat > rat] :
      ( ( cauchy @ X7 )
     => ( cauchy
        @ ^ [N3: nat] : ( uminus_uminus @ rat @ ( X7 @ N3 ) ) ) ) ).

% cauchy_minus
thf(fact_6973_cauchy__add,axiom,
    ! [X7: nat > rat,Y7: nat > rat] :
      ( ( cauchy @ X7 )
     => ( ( cauchy @ Y7 )
       => ( cauchy
          @ ^ [N3: nat] : ( plus_plus @ rat @ ( X7 @ N3 ) @ ( Y7 @ N3 ) ) ) ) ) ).

% cauchy_add
thf(fact_6974_cauchy__mult,axiom,
    ! [X7: nat > rat,Y7: nat > rat] :
      ( ( cauchy @ X7 )
     => ( ( cauchy @ Y7 )
       => ( cauchy
          @ ^ [N3: nat] : ( times_times @ rat @ ( X7 @ N3 ) @ ( Y7 @ N3 ) ) ) ) ) ).

% cauchy_mult
thf(fact_6975_Real__induct,axiom,
    ! [P: real > $o,X: real] :
      ( ! [X17: nat > rat] :
          ( ( cauchy @ X17 )
         => ( P @ ( real2 @ X17 ) ) )
     => ( P @ X ) ) ).

% Real_induct
thf(fact_6976_cauchy__diff,axiom,
    ! [X7: nat > rat,Y7: nat > rat] :
      ( ( cauchy @ X7 )
     => ( ( cauchy @ Y7 )
       => ( cauchy
          @ ^ [N3: nat] : ( minus_minus @ rat @ ( X7 @ N3 ) @ ( Y7 @ N3 ) ) ) ) ) ).

% cauchy_diff
thf(fact_6977_cr__real__eq,axiom,
    ( pcr_real
    = ( ^ [X2: nat > rat,Y4: real] :
          ( ( cauchy @ X2 )
          & ( ( real2 @ X2 )
            = Y4 ) ) ) ) ).

% cr_real_eq
thf(fact_6978_cauchy__inverse,axiom,
    ! [X7: nat > rat] :
      ( ( cauchy @ X7 )
     => ( ~ ( vanishes @ X7 )
       => ( cauchy
          @ ^ [N3: nat] : ( inverse_inverse @ rat @ ( X7 @ N3 ) ) ) ) ) ).

% cauchy_inverse
thf(fact_6979_cauchy__imp__bounded,axiom,
    ! [X7: nat > rat] :
      ( ( cauchy @ X7 )
     => ? [B4: rat] :
          ( ( ord_less @ rat @ ( zero_zero @ rat ) @ B4 )
          & ! [N7: nat] : ( ord_less @ rat @ ( abs_abs @ rat @ ( X7 @ N7 ) ) @ B4 ) ) ) ).

% cauchy_imp_bounded
thf(fact_6980_minus__Real,axiom,
    ! [X7: nat > rat] :
      ( ( cauchy @ X7 )
     => ( ( uminus_uminus @ real @ ( real2 @ X7 ) )
        = ( real2
          @ ^ [N3: nat] : ( uminus_uminus @ rat @ ( X7 @ N3 ) ) ) ) ) ).

% minus_Real
thf(fact_6981_add__Real,axiom,
    ! [X7: nat > rat,Y7: nat > rat] :
      ( ( cauchy @ X7 )
     => ( ( cauchy @ Y7 )
       => ( ( plus_plus @ real @ ( real2 @ X7 ) @ ( real2 @ Y7 ) )
          = ( real2
            @ ^ [N3: nat] : ( plus_plus @ rat @ ( X7 @ N3 ) @ ( Y7 @ N3 ) ) ) ) ) ) ).

% add_Real
thf(fact_6982_mult__Real,axiom,
    ! [X7: nat > rat,Y7: nat > rat] :
      ( ( cauchy @ X7 )
     => ( ( cauchy @ Y7 )
       => ( ( times_times @ real @ ( real2 @ X7 ) @ ( real2 @ Y7 ) )
          = ( real2
            @ ^ [N3: nat] : ( times_times @ rat @ ( X7 @ N3 ) @ ( Y7 @ N3 ) ) ) ) ) ) ).

% mult_Real
thf(fact_6983_diff__Real,axiom,
    ! [X7: nat > rat,Y7: nat > rat] :
      ( ( cauchy @ X7 )
     => ( ( cauchy @ Y7 )
       => ( ( minus_minus @ real @ ( real2 @ X7 ) @ ( real2 @ Y7 ) )
          = ( real2
            @ ^ [N3: nat] : ( minus_minus @ rat @ ( X7 @ N3 ) @ ( Y7 @ N3 ) ) ) ) ) ) ).

% diff_Real
thf(fact_6984_realrelI,axiom,
    ! [X7: nat > rat,Y7: nat > rat] :
      ( ( cauchy @ X7 )
     => ( ( cauchy @ Y7 )
       => ( ( vanishes
            @ ^ [N3: nat] : ( minus_minus @ rat @ ( X7 @ N3 ) @ ( Y7 @ N3 ) ) )
         => ( realrel @ X7 @ Y7 ) ) ) ) ).

% realrelI
thf(fact_6985_eq__Real,axiom,
    ! [X7: nat > rat,Y7: nat > rat] :
      ( ( cauchy @ X7 )
     => ( ( cauchy @ Y7 )
       => ( ( ( real2 @ X7 )
            = ( real2 @ Y7 ) )
          = ( vanishes
            @ ^ [N3: nat] : ( minus_minus @ rat @ ( X7 @ N3 ) @ ( Y7 @ N3 ) ) ) ) ) ) ).

% eq_Real
thf(fact_6986_vanishes__diff__inverse,axiom,
    ! [X7: nat > rat,Y7: nat > rat] :
      ( ( cauchy @ X7 )
     => ( ~ ( vanishes @ X7 )
       => ( ( cauchy @ Y7 )
         => ( ~ ( vanishes @ Y7 )
           => ( ( vanishes
                @ ^ [N3: nat] : ( minus_minus @ rat @ ( X7 @ N3 ) @ ( Y7 @ N3 ) ) )
             => ( vanishes
                @ ^ [N3: nat] : ( minus_minus @ rat @ ( inverse_inverse @ rat @ ( X7 @ N3 ) ) @ ( inverse_inverse @ rat @ ( Y7 @ N3 ) ) ) ) ) ) ) ) ) ).

% vanishes_diff_inverse
thf(fact_6987_realrel__def,axiom,
    ( realrel
    = ( ^ [X8: nat > rat,Y8: nat > rat] :
          ( ( cauchy @ X8 )
          & ( cauchy @ Y8 )
          & ( vanishes
            @ ^ [N3: nat] : ( minus_minus @ rat @ ( X8 @ N3 ) @ ( Y8 @ N3 ) ) ) ) ) ) ).

% realrel_def
thf(fact_6988_cauchy__not__vanishes__cases,axiom,
    ! [X7: nat > rat] :
      ( ( cauchy @ X7 )
     => ( ~ ( vanishes @ X7 )
       => ? [B4: rat] :
            ( ( ord_less @ rat @ ( zero_zero @ rat ) @ B4 )
            & ? [K2: nat] :
                ( ! [N7: nat] :
                    ( ( ord_less_eq @ nat @ K2 @ N7 )
                   => ( ord_less @ rat @ B4 @ ( uminus_uminus @ rat @ ( X7 @ N7 ) ) ) )
                | ! [N7: nat] :
                    ( ( ord_less_eq @ nat @ K2 @ N7 )
                   => ( ord_less @ rat @ B4 @ ( X7 @ N7 ) ) ) ) ) ) ) ).

% cauchy_not_vanishes_cases
thf(fact_6989_positive__Real,axiom,
    ! [X7: nat > rat] :
      ( ( cauchy @ X7 )
     => ( ( positive2 @ ( real2 @ X7 ) )
        = ( ? [R5: rat] :
              ( ( ord_less @ rat @ ( zero_zero @ rat ) @ R5 )
              & ? [K3: nat] :
                ! [N3: nat] :
                  ( ( ord_less_eq @ nat @ K3 @ N3 )
                 => ( ord_less @ rat @ R5 @ ( X7 @ N3 ) ) ) ) ) ) ) ).

% positive_Real
thf(fact_6990_cauchy__not__vanishes,axiom,
    ! [X7: nat > rat] :
      ( ( cauchy @ X7 )
     => ( ~ ( vanishes @ X7 )
       => ? [B4: rat] :
            ( ( ord_less @ rat @ ( zero_zero @ rat ) @ B4 )
            & ? [K2: nat] :
              ! [N7: nat] :
                ( ( ord_less_eq @ nat @ K2 @ N7 )
               => ( ord_less @ rat @ B4 @ ( abs_abs @ rat @ ( X7 @ N7 ) ) ) ) ) ) ) ).

% cauchy_not_vanishes
thf(fact_6991_cauchy__def,axiom,
    ( cauchy
    = ( ^ [X8: nat > rat] :
        ! [R5: rat] :
          ( ( ord_less @ rat @ ( zero_zero @ rat ) @ R5 )
         => ? [K3: nat] :
            ! [M3: nat] :
              ( ( ord_less_eq @ nat @ K3 @ M3 )
             => ! [N3: nat] :
                  ( ( ord_less_eq @ nat @ K3 @ N3 )
                 => ( ord_less @ rat @ ( abs_abs @ rat @ ( minus_minus @ rat @ ( X8 @ M3 ) @ ( X8 @ N3 ) ) ) @ R5 ) ) ) ) ) ) ).

% cauchy_def
thf(fact_6992_cauchyI,axiom,
    ! [X7: nat > rat] :
      ( ! [R: rat] :
          ( ( ord_less @ rat @ ( zero_zero @ rat ) @ R )
         => ? [K4: nat] :
            ! [M4: nat] :
              ( ( ord_less_eq @ nat @ K4 @ M4 )
             => ! [N2: nat] :
                  ( ( ord_less_eq @ nat @ K4 @ N2 )
                 => ( ord_less @ rat @ ( abs_abs @ rat @ ( minus_minus @ rat @ ( X7 @ M4 ) @ ( X7 @ N2 ) ) ) @ R ) ) ) )
     => ( cauchy @ X7 ) ) ).

% cauchyI
thf(fact_6993_cauchyD,axiom,
    ! [X7: nat > rat,R2: rat] :
      ( ( cauchy @ X7 )
     => ( ( ord_less @ rat @ ( zero_zero @ rat ) @ R2 )
       => ? [K2: nat] :
          ! [M2: nat] :
            ( ( ord_less_eq @ nat @ K2 @ M2 )
           => ! [N7: nat] :
                ( ( ord_less_eq @ nat @ K2 @ N7 )
               => ( ord_less @ rat @ ( abs_abs @ rat @ ( minus_minus @ rat @ ( X7 @ M2 ) @ ( X7 @ N7 ) ) ) @ R2 ) ) ) ) ) ).

% cauchyD
thf(fact_6994_inverse__Real,axiom,
    ! [X7: nat > rat] :
      ( ( cauchy @ X7 )
     => ( ( ( vanishes @ X7 )
         => ( ( inverse_inverse @ real @ ( real2 @ X7 ) )
            = ( zero_zero @ real ) ) )
        & ( ~ ( vanishes @ X7 )
         => ( ( inverse_inverse @ real @ ( real2 @ X7 ) )
            = ( real2
              @ ^ [N3: nat] : ( inverse_inverse @ rat @ ( X7 @ N3 ) ) ) ) ) ) ) ).

% inverse_Real
thf(fact_6995_not__positive__Real,axiom,
    ! [X7: nat > rat] :
      ( ( cauchy @ X7 )
     => ( ( ~ ( positive2 @ ( real2 @ X7 ) ) )
        = ( ! [R5: rat] :
              ( ( ord_less @ rat @ ( zero_zero @ rat ) @ R5 )
             => ? [K3: nat] :
                ! [N3: nat] :
                  ( ( ord_less_eq @ nat @ K3 @ N3 )
                 => ( ord_less_eq @ rat @ ( X7 @ N3 ) @ R5 ) ) ) ) ) ) ).

% not_positive_Real
thf(fact_6996_Real_Opositive__def,axiom,
    ( positive2
    = ( map_fun @ real @ ( nat > rat ) @ $o @ $o @ rep_real @ ( id @ $o )
      @ ^ [X8: nat > rat] :
        ? [R5: rat] :
          ( ( ord_less @ rat @ ( zero_zero @ rat ) @ R5 )
          & ? [K3: nat] :
            ! [N3: nat] :
              ( ( ord_less_eq @ nat @ K3 @ N3 )
             => ( ord_less @ rat @ R5 @ ( X8 @ N3 ) ) ) ) ) ) ).

% Real.positive_def
thf(fact_6997_inverse__real__def,axiom,
    ( ( inverse_inverse @ real )
    = ( map_fun @ real @ ( nat > rat ) @ ( nat > rat ) @ real @ rep_real @ real2
      @ ^ [X8: nat > rat] :
          ( if @ ( nat > rat ) @ ( vanishes @ X8 )
          @ ^ [N3: nat] : ( zero_zero @ rat )
          @ ^ [N3: nat] : ( inverse_inverse @ rat @ ( X8 @ N3 ) ) ) ) ) ).

% inverse_real_def
thf(fact_6998_uminus__real__def,axiom,
    ( ( uminus_uminus @ real )
    = ( map_fun @ real @ ( nat > rat ) @ ( nat > rat ) @ real @ rep_real @ real2
      @ ^ [X8: nat > rat,N3: nat] : ( uminus_uminus @ rat @ ( X8 @ N3 ) ) ) ) ).

% uminus_real_def
thf(fact_6999_times__real__def,axiom,
    ( ( times_times @ real )
    = ( map_fun @ real @ ( nat > rat ) @ ( ( nat > rat ) > nat > rat ) @ ( real > real ) @ rep_real @ ( map_fun @ real @ ( nat > rat ) @ ( nat > rat ) @ real @ rep_real @ real2 )
      @ ^ [X8: nat > rat,Y8: nat > rat,N3: nat] : ( times_times @ rat @ ( X8 @ N3 ) @ ( Y8 @ N3 ) ) ) ) ).

% times_real_def
thf(fact_7000_plus__real__def,axiom,
    ( ( plus_plus @ real )
    = ( map_fun @ real @ ( nat > rat ) @ ( ( nat > rat ) > nat > rat ) @ ( real > real ) @ rep_real @ ( map_fun @ real @ ( nat > rat ) @ ( nat > rat ) @ real @ rep_real @ real2 )
      @ ^ [X8: nat > rat,Y8: nat > rat,N3: nat] : ( plus_plus @ rat @ ( X8 @ N3 ) @ ( Y8 @ N3 ) ) ) ) ).

% plus_real_def
thf(fact_7001_cr__real__def,axiom,
    ( cr_real
    = ( ^ [X2: nat > rat,Y4: real] :
          ( ( realrel @ X2 @ X2 )
          & ( ( real2 @ X2 )
            = Y4 ) ) ) ) ).

% cr_real_def
thf(fact_7002_pair__lessI2,axiom,
    ! [A2: nat,B2: nat,S2: nat,T2: nat] :
      ( ( ord_less_eq @ nat @ A2 @ B2 )
     => ( ( ord_less @ nat @ S2 @ T2 )
       => ( member @ ( product_prod @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) ) @ ( product_Pair @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ A2 @ S2 ) @ ( product_Pair @ nat @ nat @ B2 @ T2 ) ) @ fun_pair_less ) ) ) ).

% pair_lessI2
thf(fact_7003_pair__less__iff1,axiom,
    ! [X: nat,Y: nat,Z: nat] :
      ( ( member @ ( product_prod @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) ) @ ( product_Pair @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ X @ Y ) @ ( product_Pair @ nat @ nat @ X @ Z ) ) @ fun_pair_less )
      = ( ord_less @ nat @ Y @ Z ) ) ).

% pair_less_iff1
thf(fact_7004_real_Opcr__cr__eq,axiom,
    pcr_real = cr_real ).

% real.pcr_cr_eq
thf(fact_7005_pair__lessI1,axiom,
    ! [A2: nat,B2: nat,S2: nat,T2: nat] :
      ( ( ord_less @ nat @ A2 @ B2 )
     => ( member @ ( product_prod @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) ) @ ( product_Pair @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ A2 @ S2 ) @ ( product_Pair @ nat @ nat @ B2 @ T2 ) ) @ fun_pair_less ) ) ).

% pair_lessI1
thf(fact_7006_pair__leqI2,axiom,
    ! [A2: nat,B2: nat,S2: nat,T2: nat] :
      ( ( ord_less_eq @ nat @ A2 @ B2 )
     => ( ( ord_less_eq @ nat @ S2 @ T2 )
       => ( member @ ( product_prod @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) ) @ ( product_Pair @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ A2 @ S2 ) @ ( product_Pair @ nat @ nat @ B2 @ T2 ) ) @ fun_pair_leq ) ) ) ).

% pair_leqI2
thf(fact_7007_pair__leqI1,axiom,
    ! [A2: nat,B2: nat,S2: nat,T2: nat] :
      ( ( ord_less @ nat @ A2 @ B2 )
     => ( member @ ( product_prod @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) ) @ ( product_Pair @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ A2 @ S2 ) @ ( product_Pair @ nat @ nat @ B2 @ T2 ) ) @ fun_pair_leq ) ) ).

% pair_leqI1
thf(fact_7008_wmax__insertI,axiom,
    ! [Y: product_prod @ nat @ nat,YS: set @ ( product_prod @ nat @ nat ),X: product_prod @ nat @ nat,XS: set @ ( product_prod @ nat @ nat )] :
      ( ( member @ ( product_prod @ nat @ nat ) @ Y @ YS )
     => ( ( member @ ( product_prod @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) ) @ ( product_Pair @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ X @ Y ) @ fun_pair_leq )
       => ( ( member @ ( product_prod @ ( set @ ( product_prod @ nat @ nat ) ) @ ( set @ ( product_prod @ nat @ nat ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ nat @ nat ) ) @ ( set @ ( product_prod @ nat @ nat ) ) @ XS @ YS ) @ fun_max_weak )
         => ( member @ ( product_prod @ ( set @ ( product_prod @ nat @ nat ) ) @ ( set @ ( product_prod @ nat @ nat ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ nat @ nat ) ) @ ( set @ ( product_prod @ nat @ nat ) ) @ ( insert @ ( product_prod @ nat @ nat ) @ X @ XS ) @ YS ) @ fun_max_weak ) ) ) ) ).

% wmax_insertI
thf(fact_7009_wmin__insertI,axiom,
    ! [X: product_prod @ nat @ nat,XS: set @ ( product_prod @ nat @ nat ),Y: product_prod @ nat @ nat,YS: set @ ( product_prod @ nat @ nat )] :
      ( ( member @ ( product_prod @ nat @ nat ) @ X @ XS )
     => ( ( member @ ( product_prod @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) ) @ ( product_Pair @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ X @ Y ) @ fun_pair_leq )
       => ( ( member @ ( product_prod @ ( set @ ( product_prod @ nat @ nat ) ) @ ( set @ ( product_prod @ nat @ nat ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ nat @ nat ) ) @ ( set @ ( product_prod @ nat @ nat ) ) @ XS @ YS ) @ fun_min_weak )
         => ( member @ ( product_prod @ ( set @ ( product_prod @ nat @ nat ) ) @ ( set @ ( product_prod @ nat @ nat ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ nat @ nat ) ) @ ( set @ ( product_prod @ nat @ nat ) ) @ XS @ ( insert @ ( product_prod @ nat @ nat ) @ Y @ YS ) ) @ fun_min_weak ) ) ) ) ).

% wmin_insertI
thf(fact_7010_wmin__emptyI,axiom,
    ! [X7: set @ ( product_prod @ nat @ nat )] : ( member @ ( product_prod @ ( set @ ( product_prod @ nat @ nat ) ) @ ( set @ ( product_prod @ nat @ nat ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ nat @ nat ) ) @ ( set @ ( product_prod @ nat @ nat ) ) @ X7 @ ( bot_bot @ ( set @ ( product_prod @ nat @ nat ) ) ) ) @ fun_min_weak ) ).

% wmin_emptyI
thf(fact_7011_wmax__emptyI,axiom,
    ! [X7: set @ ( product_prod @ nat @ nat )] :
      ( ( finite_finite @ ( product_prod @ nat @ nat ) @ X7 )
     => ( member @ ( product_prod @ ( set @ ( product_prod @ nat @ nat ) ) @ ( set @ ( product_prod @ nat @ nat ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ nat @ nat ) ) @ ( set @ ( product_prod @ nat @ nat ) ) @ ( bot_bot @ ( set @ ( product_prod @ nat @ nat ) ) ) @ X7 ) @ fun_max_weak ) ) ).

% wmax_emptyI
thf(fact_7012_smax__insertI,axiom,
    ! [Y: product_prod @ nat @ nat,Y7: set @ ( product_prod @ nat @ nat ),X: product_prod @ nat @ nat,X7: set @ ( product_prod @ nat @ nat )] :
      ( ( member @ ( product_prod @ nat @ nat ) @ Y @ Y7 )
     => ( ( member @ ( product_prod @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) ) @ ( product_Pair @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ X @ Y ) @ fun_pair_less )
       => ( ( member @ ( product_prod @ ( set @ ( product_prod @ nat @ nat ) ) @ ( set @ ( product_prod @ nat @ nat ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ nat @ nat ) ) @ ( set @ ( product_prod @ nat @ nat ) ) @ X7 @ Y7 ) @ fun_max_strict )
         => ( member @ ( product_prod @ ( set @ ( product_prod @ nat @ nat ) ) @ ( set @ ( product_prod @ nat @ nat ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ nat @ nat ) ) @ ( set @ ( product_prod @ nat @ nat ) ) @ ( insert @ ( product_prod @ nat @ nat ) @ X @ X7 ) @ Y7 ) @ fun_max_strict ) ) ) ) ).

% smax_insertI
thf(fact_7013_smin__insertI,axiom,
    ! [X: product_prod @ nat @ nat,XS: set @ ( product_prod @ nat @ nat ),Y: product_prod @ nat @ nat,YS: set @ ( product_prod @ nat @ nat )] :
      ( ( member @ ( product_prod @ nat @ nat ) @ X @ XS )
     => ( ( member @ ( product_prod @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) ) @ ( product_Pair @ ( product_prod @ nat @ nat ) @ ( product_prod @ nat @ nat ) @ X @ Y ) @ fun_pair_less )
       => ( ( member @ ( product_prod @ ( set @ ( product_prod @ nat @ nat ) ) @ ( set @ ( product_prod @ nat @ nat ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ nat @ nat ) ) @ ( set @ ( product_prod @ nat @ nat ) ) @ XS @ YS ) @ fun_min_strict )
         => ( member @ ( product_prod @ ( set @ ( product_prod @ nat @ nat ) ) @ ( set @ ( product_prod @ nat @ nat ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ nat @ nat ) ) @ ( set @ ( product_prod @ nat @ nat ) ) @ XS @ ( insert @ ( product_prod @ nat @ nat ) @ Y @ YS ) ) @ fun_min_strict ) ) ) ) ).

% smin_insertI
thf(fact_7014_less__by__empty,axiom,
    ! [A: $tType,A4: set @ ( product_prod @ A @ A ),B7: set @ ( product_prod @ A @ A )] :
      ( ( A4
        = ( bot_bot @ ( set @ ( product_prod @ A @ A ) ) ) )
     => ( ord_less_eq @ ( set @ ( product_prod @ A @ A ) ) @ A4 @ B7 ) ) ).

% less_by_empty
thf(fact_7015_smax__emptyI,axiom,
    ! [Y7: set @ ( product_prod @ nat @ nat )] :
      ( ( finite_finite @ ( product_prod @ nat @ nat ) @ Y7 )
     => ( ( Y7
         != ( bot_bot @ ( set @ ( product_prod @ nat @ nat ) ) ) )
       => ( member @ ( product_prod @ ( set @ ( product_prod @ nat @ nat ) ) @ ( set @ ( product_prod @ nat @ nat ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ nat @ nat ) ) @ ( set @ ( product_prod @ nat @ nat ) ) @ ( bot_bot @ ( set @ ( product_prod @ nat @ nat ) ) ) @ Y7 ) @ fun_max_strict ) ) ) ).

% smax_emptyI
thf(fact_7016_smin__emptyI,axiom,
    ! [X7: set @ ( product_prod @ nat @ nat )] :
      ( ( X7
       != ( bot_bot @ ( set @ ( product_prod @ nat @ nat ) ) ) )
     => ( member @ ( product_prod @ ( set @ ( product_prod @ nat @ nat ) ) @ ( set @ ( product_prod @ nat @ nat ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ nat @ nat ) ) @ ( set @ ( product_prod @ nat @ nat ) ) @ X7 @ ( bot_bot @ ( set @ ( product_prod @ nat @ nat ) ) ) ) @ fun_min_strict ) ) ).

% smin_emptyI
thf(fact_7017_min__weak__def,axiom,
    ( fun_min_weak
    = ( sup_sup @ ( set @ ( product_prod @ ( set @ ( product_prod @ nat @ nat ) ) @ ( set @ ( product_prod @ nat @ nat ) ) ) ) @ ( min_ext @ ( product_prod @ nat @ nat ) @ fun_pair_leq ) @ ( insert @ ( product_prod @ ( set @ ( product_prod @ nat @ nat ) ) @ ( set @ ( product_prod @ nat @ nat ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ nat @ nat ) ) @ ( set @ ( product_prod @ nat @ nat ) ) @ ( bot_bot @ ( set @ ( product_prod @ nat @ nat ) ) ) @ ( bot_bot @ ( set @ ( product_prod @ nat @ nat ) ) ) ) @ ( bot_bot @ ( set @ ( product_prod @ ( set @ ( product_prod @ nat @ nat ) ) @ ( set @ ( product_prod @ nat @ nat ) ) ) ) ) ) ) ) ).

% min_weak_def
thf(fact_7018_max__weak__def,axiom,
    ( fun_max_weak
    = ( sup_sup @ ( set @ ( product_prod @ ( set @ ( product_prod @ nat @ nat ) ) @ ( set @ ( product_prod @ nat @ nat ) ) ) ) @ ( max_ext @ ( product_prod @ nat @ nat ) @ fun_pair_leq ) @ ( insert @ ( product_prod @ ( set @ ( product_prod @ nat @ nat ) ) @ ( set @ ( product_prod @ nat @ nat ) ) ) @ ( product_Pair @ ( set @ ( product_prod @ nat @ nat ) ) @ ( set @ ( product_prod @ nat @ nat ) ) @ ( bot_bot @ ( set @ ( product_prod @ nat @ nat ) ) ) @ ( bot_bot @ ( set @ ( product_prod @ nat @ nat ) ) ) ) @ ( bot_bot @ ( set @ ( product_prod @ ( set @ ( product_prod @ nat @ nat ) ) @ ( set @ ( product_prod @ nat @ nat ) ) ) ) ) ) ) ) ).

% max_weak_def
thf(fact_7019_max__strict__def,axiom,
    ( fun_max_strict
    = ( max_ext @ ( product_prod @ nat @ nat ) @ fun_pair_less ) ) ).

% max_strict_def
thf(fact_7020_min__strict__def,axiom,
    ( fun_min_strict
    = ( min_ext @ ( product_prod @ nat @ nat ) @ fun_pair_less ) ) ).

% min_strict_def
thf(fact_7021_max__rpair__set,axiom,
    fun_reduction_pair @ ( set @ ( product_prod @ nat @ nat ) ) @ ( product_Pair @ ( set @ ( product_prod @ ( set @ ( product_prod @ nat @ nat ) ) @ ( set @ ( product_prod @ nat @ nat ) ) ) ) @ ( set @ ( product_prod @ ( set @ ( product_prod @ nat @ nat ) ) @ ( set @ ( product_prod @ nat @ nat ) ) ) ) @ fun_max_strict @ fun_max_weak ) ).

% max_rpair_set
thf(fact_7022_min__rpair__set,axiom,
    fun_reduction_pair @ ( set @ ( product_prod @ nat @ nat ) ) @ ( product_Pair @ ( set @ ( product_prod @ ( set @ ( product_prod @ nat @ nat ) ) @ ( set @ ( product_prod @ nat @ nat ) ) ) ) @ ( set @ ( product_prod @ ( set @ ( product_prod @ nat @ nat ) ) @ ( set @ ( product_prod @ nat @ nat ) ) ) ) @ fun_min_strict @ fun_min_weak ) ).

% min_rpair_set
thf(fact_7023_rp__inv__image__rp,axiom,
    ! [A: $tType,B: $tType,P: product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ A @ A ) ),F2: B > A] :
      ( ( fun_reduction_pair @ A @ P )
     => ( fun_reduction_pair @ B @ ( fun_rp_inv_image @ A @ B @ P @ F2 ) ) ) ).

% rp_inv_image_rp
thf(fact_7024_relpow__finite__bounded1,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A ),K: nat] :
      ( ( finite_finite @ ( product_prod @ A @ A ) @ R4 )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ K )
       => ( ord_less_eq @ ( set @ ( product_prod @ A @ A ) ) @ ( compow @ ( set @ ( product_prod @ A @ A ) ) @ K @ R4 )
          @ ( complete_Sup_Sup @ ( set @ ( product_prod @ A @ A ) )
            @ ( image @ nat @ ( set @ ( product_prod @ A @ A ) )
              @ ^ [N3: nat] : ( compow @ ( set @ ( product_prod @ A @ A ) ) @ N3 @ R4 )
              @ ( collect @ nat
                @ ^ [N3: nat] :
                    ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N3 )
                    & ( ord_less_eq @ nat @ N3 @ ( finite_card @ ( product_prod @ A @ A ) @ R4 ) ) ) ) ) ) ) ) ) ).

% relpow_finite_bounded1
thf(fact_7025_finite__relpow,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A ),N: nat] :
      ( ( finite_finite @ ( product_prod @ A @ A ) @ R4 )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
       => ( finite_finite @ ( product_prod @ A @ A ) @ ( compow @ ( set @ ( product_prod @ A @ A ) ) @ N @ R4 ) ) ) ) ).

% finite_relpow
thf(fact_7026_relpow__0__E,axiom,
    ! [A: $tType,X: A,Y: A,R4: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y ) @ ( compow @ ( set @ ( product_prod @ A @ A ) ) @ ( zero_zero @ nat ) @ R4 ) )
     => ( X = Y ) ) ).

% relpow_0_E
thf(fact_7027_relpow__0__I,axiom,
    ! [A: $tType,X: A,R4: set @ ( product_prod @ A @ A )] : ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ X ) @ ( compow @ ( set @ ( product_prod @ A @ A ) ) @ ( zero_zero @ nat ) @ R4 ) ) ).

% relpow_0_I
thf(fact_7028_relpow__E,axiom,
    ! [A: $tType,X: A,Z: A,N: nat,R4: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Z ) @ ( compow @ ( set @ ( product_prod @ A @ A ) ) @ N @ R4 ) )
     => ( ( ( N
            = ( zero_zero @ nat ) )
         => ( X != Z ) )
       => ~ ! [Y5: A,M4: nat] :
              ( ( N
                = ( suc @ M4 ) )
             => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y5 ) @ ( compow @ ( set @ ( product_prod @ A @ A ) ) @ M4 @ R4 ) )
               => ~ ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Y5 @ Z ) @ R4 ) ) ) ) ) ).

% relpow_E
thf(fact_7029_relpow__E2,axiom,
    ! [A: $tType,X: A,Z: A,N: nat,R4: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Z ) @ ( compow @ ( set @ ( product_prod @ A @ A ) ) @ N @ R4 ) )
     => ( ( ( N
            = ( zero_zero @ nat ) )
         => ( X != Z ) )
       => ~ ! [Y5: A,M4: nat] :
              ( ( N
                = ( suc @ M4 ) )
             => ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X @ Y5 ) @ R4 )
               => ~ ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Y5 @ Z ) @ ( compow @ ( set @ ( product_prod @ A @ A ) ) @ M4 @ R4 ) ) ) ) ) ) ).

% relpow_E2
thf(fact_7030_relpow__empty,axiom,
    ! [A: $tType,N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( compow @ ( set @ ( product_prod @ A @ A ) ) @ N @ ( bot_bot @ ( set @ ( product_prod @ A @ A ) ) ) )
        = ( bot_bot @ ( set @ ( product_prod @ A @ A ) ) ) ) ) ).

% relpow_empty
thf(fact_7031_relpow__finite__bounded,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A ),K: nat] :
      ( ( finite_finite @ ( product_prod @ A @ A ) @ R4 )
     => ( ord_less_eq @ ( set @ ( product_prod @ A @ A ) ) @ ( compow @ ( set @ ( product_prod @ A @ A ) ) @ K @ R4 )
        @ ( complete_Sup_Sup @ ( set @ ( product_prod @ A @ A ) )
          @ ( image @ nat @ ( set @ ( product_prod @ A @ A ) )
            @ ^ [N3: nat] : ( compow @ ( set @ ( product_prod @ A @ A ) ) @ N3 @ R4 )
            @ ( collect @ nat
              @ ^ [N3: nat] : ( ord_less_eq @ nat @ N3 @ ( finite_card @ ( product_prod @ A @ A ) @ R4 ) ) ) ) ) ) ) ).

% relpow_finite_bounded
thf(fact_7032_relpow__fun__conv,axiom,
    ! [A: $tType,A2: A,B2: A,N: nat,R4: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ A2 @ B2 ) @ ( compow @ ( set @ ( product_prod @ A @ A ) ) @ N @ R4 ) )
      = ( ? [F3: nat > A] :
            ( ( ( F3 @ ( zero_zero @ nat ) )
              = A2 )
            & ( ( F3 @ N )
              = B2 )
            & ! [I4: nat] :
                ( ( ord_less @ nat @ I4 @ N )
               => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ ( F3 @ I4 ) @ ( F3 @ ( suc @ I4 ) ) ) @ R4 ) ) ) ) ) ).

% relpow_fun_conv
thf(fact_7033_ntrancl__def,axiom,
    ! [A: $tType] :
      ( ( transitive_ntrancl @ A )
      = ( ^ [N3: nat,R6: set @ ( product_prod @ A @ A )] :
            ( complete_Sup_Sup @ ( set @ ( product_prod @ A @ A ) )
            @ ( image @ nat @ ( set @ ( product_prod @ A @ A ) )
              @ ^ [I4: nat] : ( compow @ ( set @ ( product_prod @ A @ A ) ) @ I4 @ R6 )
              @ ( collect @ nat
                @ ^ [I4: nat] :
                    ( ( ord_less @ nat @ ( zero_zero @ nat ) @ I4 )
                    & ( ord_less_eq @ nat @ I4 @ ( suc @ N3 ) ) ) ) ) ) ) ) ).

% ntrancl_def
thf(fact_7034_trancl__finite__eq__relpow,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A )] :
      ( ( finite_finite @ ( product_prod @ A @ A ) @ R4 )
     => ( ( transitive_trancl @ A @ R4 )
        = ( complete_Sup_Sup @ ( set @ ( product_prod @ A @ A ) )
          @ ( image @ nat @ ( set @ ( product_prod @ A @ A ) )
            @ ^ [N3: nat] : ( compow @ ( set @ ( product_prod @ A @ A ) ) @ N3 @ R4 )
            @ ( collect @ nat
              @ ^ [N3: nat] :
                  ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N3 )
                  & ( ord_less_eq @ nat @ N3 @ ( finite_card @ ( product_prod @ A @ A ) @ R4 ) ) ) ) ) ) ) ) ).

% trancl_finite_eq_relpow
thf(fact_7035_ntrancl__Zero,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A )] :
      ( ( transitive_ntrancl @ A @ ( zero_zero @ nat ) @ R4 )
      = R4 ) ).

% ntrancl_Zero
thf(fact_7036_trancl__power,axiom,
    ! [A: $tType,P6: product_prod @ A @ A,R4: set @ ( product_prod @ A @ A )] :
      ( ( member @ ( product_prod @ A @ A ) @ P6 @ ( transitive_trancl @ A @ R4 ) )
      = ( ? [N3: nat] :
            ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N3 )
            & ( member @ ( product_prod @ A @ A ) @ P6 @ ( compow @ ( set @ ( product_prod @ A @ A ) ) @ N3 @ R4 ) ) ) ) ) ).

% trancl_power
thf(fact_7037_rtrancl__finite__eq__relpow,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A )] :
      ( ( finite_finite @ ( product_prod @ A @ A ) @ R4 )
     => ( ( transitive_rtrancl @ A @ R4 )
        = ( complete_Sup_Sup @ ( set @ ( product_prod @ A @ A ) )
          @ ( image @ nat @ ( set @ ( product_prod @ A @ A ) )
            @ ^ [N3: nat] : ( compow @ ( set @ ( product_prod @ A @ A ) ) @ N3 @ R4 )
            @ ( collect @ nat
              @ ^ [N3: nat] : ( ord_less_eq @ nat @ N3 @ ( finite_card @ ( product_prod @ A @ A ) @ R4 ) ) ) ) ) ) ) ).

% rtrancl_finite_eq_relpow
thf(fact_7038_rp__inv__image__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( fun_rp_inv_image @ A @ B )
      = ( product_case_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ A @ A ) ) @ ( ( B > A ) > ( product_prod @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ B @ B ) ) ) )
        @ ^ [R6: set @ ( product_prod @ A @ A ),S8: set @ ( product_prod @ A @ A ),F3: B > A] : ( product_Pair @ ( set @ ( product_prod @ B @ B ) ) @ ( set @ ( product_prod @ B @ B ) ) @ ( inv_image @ A @ B @ R6 @ F3 ) @ ( inv_image @ A @ B @ S8 @ F3 ) ) ) ) ).

% rp_inv_image_def
thf(fact_7039_pred__nat__trancl__eq__le,axiom,
    ! [M: nat,N: nat] :
      ( ( member @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ M @ N ) @ ( transitive_rtrancl @ nat @ pred_nat ) )
      = ( ord_less_eq @ nat @ M @ N ) ) ).

% pred_nat_trancl_eq_le
thf(fact_7040_less__eq,axiom,
    ! [M: nat,N: nat] :
      ( ( member @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ M @ N ) @ ( transitive_trancl @ nat @ pred_nat ) )
      = ( ord_less @ nat @ M @ N ) ) ).

% less_eq
thf(fact_7041_horner__sum__transfer,axiom,
    ! [C: $tType,A: $tType,B: $tType,D: $tType] :
      ( ( ( comm_semiring_0 @ B )
        & ( comm_semiring_0 @ A ) )
     => ! [A4: A > B > $o,B7: C > D > $o] :
          ( ( A4 @ ( zero_zero @ A ) @ ( zero_zero @ B ) )
         => ( ( bNF_rel_fun @ A @ B @ ( A > A ) @ ( B > B ) @ A4 @ ( bNF_rel_fun @ A @ B @ A @ B @ A4 @ A4 ) @ ( plus_plus @ A ) @ ( plus_plus @ B ) )
           => ( ( bNF_rel_fun @ A @ B @ ( A > A ) @ ( B > B ) @ A4 @ ( bNF_rel_fun @ A @ B @ A @ B @ A4 @ A4 ) @ ( times_times @ A ) @ ( times_times @ B ) )
             => ( bNF_rel_fun @ ( C > A ) @ ( D > B ) @ ( A > ( list @ C ) > A ) @ ( B > ( list @ D ) > B ) @ ( bNF_rel_fun @ C @ D @ A @ B @ B7 @ A4 ) @ ( bNF_rel_fun @ A @ B @ ( ( list @ C ) > A ) @ ( ( list @ D ) > B ) @ A4 @ ( bNF_rel_fun @ ( list @ C ) @ ( list @ D ) @ A @ B @ ( list_all2 @ C @ D @ B7 ) @ A4 ) ) @ ( groups4207007520872428315er_sum @ C @ A ) @ ( groups4207007520872428315er_sum @ D @ B ) ) ) ) ) ) ).

% horner_sum_transfer
thf(fact_7042_bot_Oordering__top__axioms,axiom,
    ! [A: $tType] :
      ( ( order_bot @ A )
     => ( ordering_top @ A
        @ ^ [X2: A,Y4: A] : ( ord_less_eq @ A @ Y4 @ X2 )
        @ ^ [X2: A,Y4: A] : ( ord_less @ A @ Y4 @ X2 )
        @ ( bot_bot @ A ) ) ) ).

% bot.ordering_top_axioms
thf(fact_7043_ordering__top_Oextremum__uniqueI,axiom,
    ! [A: $tType,Less_eq: A > A > $o,Less: A > A > $o,Top: A,A2: A] :
      ( ( ordering_top @ A @ Less_eq @ Less @ Top )
     => ( ( Less_eq @ Top @ A2 )
       => ( A2 = Top ) ) ) ).

% ordering_top.extremum_uniqueI
thf(fact_7044_ordering__top_Onot__eq__extremum,axiom,
    ! [A: $tType,Less_eq: A > A > $o,Less: A > A > $o,Top: A,A2: A] :
      ( ( ordering_top @ A @ Less_eq @ Less @ Top )
     => ( ( ( A2 != Top ) )
        = ( Less @ A2 @ Top ) ) ) ).

% ordering_top.not_eq_extremum
thf(fact_7045_ordering__top_Oextremum__unique,axiom,
    ! [A: $tType,Less_eq: A > A > $o,Less: A > A > $o,Top: A,A2: A] :
      ( ( ordering_top @ A @ Less_eq @ Less @ Top )
     => ( ( Less_eq @ Top @ A2 )
        = ( A2 = Top ) ) ) ).

% ordering_top.extremum_unique
thf(fact_7046_ordering__top_Oextremum__strict,axiom,
    ! [A: $tType,Less_eq: A > A > $o,Less: A > A > $o,Top: A,A2: A] :
      ( ( ordering_top @ A @ Less_eq @ Less @ Top )
     => ~ ( Less @ Top @ A2 ) ) ).

% ordering_top.extremum_strict
thf(fact_7047_ordering__top_Oextremum,axiom,
    ! [A: $tType,Less_eq: A > A > $o,Less: A > A > $o,Top: A,A2: A] :
      ( ( ordering_top @ A @ Less_eq @ Less @ Top )
     => ( Less_eq @ A2 @ Top ) ) ).

% ordering_top.extremum
thf(fact_7048_list__all2__conv__all__nth,axiom,
    ! [B: $tType,A: $tType] :
      ( ( list_all2 @ A @ B )
      = ( ^ [P3: A > B > $o,Xs3: list @ A,Ys2: list @ B] :
            ( ( ( size_size @ ( list @ A ) @ Xs3 )
              = ( size_size @ ( list @ B ) @ Ys2 ) )
            & ! [I4: nat] :
                ( ( ord_less @ nat @ I4 @ ( size_size @ ( list @ A ) @ Xs3 ) )
               => ( P3 @ ( nth @ A @ Xs3 @ I4 ) @ ( nth @ B @ Ys2 @ I4 ) ) ) ) ) ) ).

% list_all2_conv_all_nth
thf(fact_7049_list__all2__all__nthI,axiom,
    ! [A: $tType,B: $tType,A2: list @ A,B2: list @ B,P: A > B > $o] :
      ( ( ( size_size @ ( list @ A ) @ A2 )
        = ( size_size @ ( list @ B ) @ B2 ) )
     => ( ! [N2: nat] :
            ( ( ord_less @ nat @ N2 @ ( size_size @ ( list @ A ) @ A2 ) )
           => ( P @ ( nth @ A @ A2 @ N2 ) @ ( nth @ B @ B2 @ N2 ) ) )
       => ( list_all2 @ A @ B @ P @ A2 @ B2 ) ) ) ).

% list_all2_all_nthI
thf(fact_7050_list__all2__nthD2,axiom,
    ! [A: $tType,B: $tType,P: A > B > $o,Xs: list @ A,Ys3: list @ B,P6: nat] :
      ( ( list_all2 @ A @ B @ P @ Xs @ Ys3 )
     => ( ( ord_less @ nat @ P6 @ ( size_size @ ( list @ B ) @ Ys3 ) )
       => ( P @ ( nth @ A @ Xs @ P6 ) @ ( nth @ B @ Ys3 @ P6 ) ) ) ) ).

% list_all2_nthD2
thf(fact_7051_list__all2__nthD,axiom,
    ! [A: $tType,B: $tType,P: A > B > $o,Xs: list @ A,Ys3: list @ B,P6: nat] :
      ( ( list_all2 @ A @ B @ P @ Xs @ Ys3 )
     => ( ( ord_less @ nat @ P6 @ ( size_size @ ( list @ A ) @ Xs ) )
       => ( P @ ( nth @ A @ Xs @ P6 ) @ ( nth @ B @ Ys3 @ P6 ) ) ) ) ).

% list_all2_nthD
thf(fact_7052_gcd__nat_Oordering__top__axioms,axiom,
    ( ordering_top @ nat @ ( dvd_dvd @ nat )
    @ ^ [M3: nat,N3: nat] :
        ( ( dvd_dvd @ nat @ M3 @ N3 )
        & ( M3 != N3 ) )
    @ ( zero_zero @ nat ) ) ).

% gcd_nat.ordering_top_axioms
thf(fact_7053_sum__list__transfer,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( monoid_add @ B )
        & ( monoid_add @ A ) )
     => ! [A4: A > B > $o] :
          ( ( A4 @ ( zero_zero @ A ) @ ( zero_zero @ B ) )
         => ( ( bNF_rel_fun @ A @ B @ ( A > A ) @ ( B > B ) @ A4 @ ( bNF_rel_fun @ A @ B @ A @ B @ A4 @ A4 ) @ ( plus_plus @ A ) @ ( plus_plus @ B ) )
           => ( bNF_rel_fun @ ( list @ A ) @ ( list @ B ) @ A @ B @ ( list_all2 @ A @ B @ A4 ) @ A4 @ ( groups8242544230860333062m_list @ A ) @ ( groups8242544230860333062m_list @ B ) ) ) ) ) ).

% sum_list_transfer
thf(fact_7054_top_Oordering__top__axioms,axiom,
    ! [A: $tType] :
      ( ( order_top @ A )
     => ( ordering_top @ A @ ( ord_less_eq @ A ) @ ( ord_less @ A ) @ ( top_top @ A ) ) ) ).

% top.ordering_top_axioms
thf(fact_7055_bot__nat__0_Oordering__top__axioms,axiom,
    ( ordering_top @ nat
    @ ^ [X2: nat,Y4: nat] : ( ord_less_eq @ nat @ Y4 @ X2 )
    @ ^ [X2: nat,Y4: nat] : ( ord_less @ nat @ Y4 @ X2 )
    @ ( zero_zero @ nat ) ) ).

% bot_nat_0.ordering_top_axioms
thf(fact_7056_dropWhile__nth,axiom,
    ! [A: $tType,J: nat,P: A > $o,Xs: list @ A] :
      ( ( ord_less @ nat @ J @ ( size_size @ ( list @ A ) @ ( dropWhile @ A @ P @ Xs ) ) )
     => ( ( nth @ A @ ( dropWhile @ A @ P @ Xs ) @ J )
        = ( nth @ A @ Xs @ ( plus_plus @ nat @ J @ ( size_size @ ( list @ A ) @ ( takeWhile @ A @ P @ Xs ) ) ) ) ) ) ).

% dropWhile_nth
thf(fact_7057_of__rat__neg__numeral__eq,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [W: num] :
          ( ( field_char_0_of_rat @ A @ ( uminus_uminus @ rat @ ( numeral_numeral @ rat @ W ) ) )
          = ( uminus_uminus @ A @ ( numeral_numeral @ A @ W ) ) ) ) ).

% of_rat_neg_numeral_eq
thf(fact_7058_of__rat__0,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ( ( field_char_0_of_rat @ A @ ( zero_zero @ rat ) )
        = ( zero_zero @ A ) ) ) ).

% of_rat_0
thf(fact_7059_of__rat__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: rat] :
          ( ( ( field_char_0_of_rat @ A @ A2 )
            = ( zero_zero @ A ) )
          = ( A2
            = ( zero_zero @ rat ) ) ) ) ).

% of_rat_eq_0_iff
thf(fact_7060_zero__eq__of__rat__iff,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: rat] :
          ( ( ( zero_zero @ A )
            = ( field_char_0_of_rat @ A @ A2 ) )
          = ( ( zero_zero @ rat )
            = A2 ) ) ) ).

% zero_eq_of_rat_iff
thf(fact_7061_of__rat__numeral__eq,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [W: num] :
          ( ( field_char_0_of_rat @ A @ ( numeral_numeral @ rat @ W ) )
          = ( numeral_numeral @ A @ W ) ) ) ).

% of_rat_numeral_eq
thf(fact_7062_of__rat__of__nat__eq,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [N: nat] :
          ( ( field_char_0_of_rat @ A @ ( semiring_1_of_nat @ rat @ N ) )
          = ( semiring_1_of_nat @ A @ N ) ) ) ).

% of_rat_of_nat_eq
thf(fact_7063_of__rat__less__0__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [R2: rat] :
          ( ( ord_less @ A @ ( field_char_0_of_rat @ A @ R2 ) @ ( zero_zero @ A ) )
          = ( ord_less @ rat @ R2 @ ( zero_zero @ rat ) ) ) ) ).

% of_rat_less_0_iff
thf(fact_7064_zero__less__of__rat__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [R2: rat] :
          ( ( ord_less @ A @ ( zero_zero @ A ) @ ( field_char_0_of_rat @ A @ R2 ) )
          = ( ord_less @ rat @ ( zero_zero @ rat ) @ R2 ) ) ) ).

% zero_less_of_rat_iff
thf(fact_7065_of__rat__less__1__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [R2: rat] :
          ( ( ord_less @ A @ ( field_char_0_of_rat @ A @ R2 ) @ ( one_one @ A ) )
          = ( ord_less @ rat @ R2 @ ( one_one @ rat ) ) ) ) ).

% of_rat_less_1_iff
thf(fact_7066_one__less__of__rat__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [R2: rat] :
          ( ( ord_less @ A @ ( one_one @ A ) @ ( field_char_0_of_rat @ A @ R2 ) )
          = ( ord_less @ rat @ ( one_one @ rat ) @ R2 ) ) ) ).

% one_less_of_rat_iff
thf(fact_7067_zero__le__of__rat__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [R2: rat] :
          ( ( ord_less_eq @ A @ ( zero_zero @ A ) @ ( field_char_0_of_rat @ A @ R2 ) )
          = ( ord_less_eq @ rat @ ( zero_zero @ rat ) @ R2 ) ) ) ).

% zero_le_of_rat_iff
thf(fact_7068_of__rat__le__0__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [R2: rat] :
          ( ( ord_less_eq @ A @ ( field_char_0_of_rat @ A @ R2 ) @ ( zero_zero @ A ) )
          = ( ord_less_eq @ rat @ R2 @ ( zero_zero @ rat ) ) ) ) ).

% of_rat_le_0_iff
thf(fact_7069_of__rat__le__1__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [R2: rat] :
          ( ( ord_less_eq @ A @ ( field_char_0_of_rat @ A @ R2 ) @ ( one_one @ A ) )
          = ( ord_less_eq @ rat @ R2 @ ( one_one @ rat ) ) ) ) ).

% of_rat_le_1_iff
thf(fact_7070_one__le__of__rat__iff,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [R2: rat] :
          ( ( ord_less_eq @ A @ ( one_one @ A ) @ ( field_char_0_of_rat @ A @ R2 ) )
          = ( ord_less_eq @ rat @ ( one_one @ rat ) @ R2 ) ) ) ).

% one_le_of_rat_iff
thf(fact_7071_sorted__dropWhile,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A,P: A > $o] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs )
         => ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( dropWhile @ A @ P @ Xs ) ) ) ) ).

% sorted_dropWhile
thf(fact_7072_length__dropWhile__le,axiom,
    ! [A: $tType,P: A > $o,Xs: list @ A] : ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ ( dropWhile @ A @ P @ Xs ) ) @ ( size_size @ ( list @ A ) @ Xs ) ) ).

% length_dropWhile_le
thf(fact_7073_of__rat__less__eq,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [R2: rat,S2: rat] :
          ( ( ord_less_eq @ A @ ( field_char_0_of_rat @ A @ R2 ) @ ( field_char_0_of_rat @ A @ S2 ) )
          = ( ord_less_eq @ rat @ R2 @ S2 ) ) ) ).

% of_rat_less_eq
thf(fact_7074_of__rat__less,axiom,
    ! [A: $tType] :
      ( ( linordered_field @ A )
     => ! [R2: rat,S2: rat] :
          ( ( ord_less @ A @ ( field_char_0_of_rat @ A @ R2 ) @ ( field_char_0_of_rat @ A @ S2 ) )
          = ( ord_less @ rat @ R2 @ S2 ) ) ) ).

% of_rat_less
thf(fact_7075_of__rat__power,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: rat,N: nat] :
          ( ( field_char_0_of_rat @ A @ ( power_power @ rat @ A2 @ N ) )
          = ( power_power @ A @ ( field_char_0_of_rat @ A @ A2 ) @ N ) ) ) ).

% of_rat_power
thf(fact_7076_of__rat__dense,axiom,
    ! [X: real,Y: real] :
      ( ( ord_less @ real @ X @ Y )
     => ? [Q5: rat] :
          ( ( ord_less @ real @ X @ ( field_char_0_of_rat @ real @ Q5 ) )
          & ( ord_less @ real @ ( field_char_0_of_rat @ real @ Q5 ) @ Y ) ) ) ).

% of_rat_dense
thf(fact_7077_of__rat__Real,axiom,
    ( ( field_char_0_of_rat @ real )
    = ( ^ [X2: rat] :
          ( real2
          @ ^ [N3: nat] : X2 ) ) ) ).

% of_rat_Real
thf(fact_7078_less__RealD,axiom,
    ! [Y7: nat > rat,X: real] :
      ( ( cauchy @ Y7 )
     => ( ( ord_less @ real @ X @ ( real2 @ Y7 ) )
       => ? [N2: nat] : ( ord_less @ real @ X @ ( field_char_0_of_rat @ real @ ( Y7 @ N2 ) ) ) ) ) ).

% less_RealD
thf(fact_7079_Real__leI,axiom,
    ! [X7: nat > rat,Y: real] :
      ( ( cauchy @ X7 )
     => ( ! [N2: nat] : ( ord_less_eq @ real @ ( field_char_0_of_rat @ real @ ( X7 @ N2 ) ) @ Y )
       => ( ord_less_eq @ real @ ( real2 @ X7 ) @ Y ) ) ) ).

% Real_leI
thf(fact_7080_le__RealI,axiom,
    ! [Y7: nat > rat,X: real] :
      ( ( cauchy @ Y7 )
     => ( ! [N2: nat] : ( ord_less_eq @ real @ X @ ( field_char_0_of_rat @ real @ ( Y7 @ N2 ) ) )
       => ( ord_less_eq @ real @ X @ ( real2 @ Y7 ) ) ) ) ).

% le_RealI
thf(fact_7081_nonzero__of__rat__inverse,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [A2: rat] :
          ( ( A2
           != ( zero_zero @ rat ) )
         => ( ( field_char_0_of_rat @ A @ ( inverse_inverse @ rat @ A2 ) )
            = ( inverse_inverse @ A @ ( field_char_0_of_rat @ A @ A2 ) ) ) ) ) ).

% nonzero_of_rat_inverse
thf(fact_7082_nonzero__of__rat__divide,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [B2: rat,A2: rat] :
          ( ( B2
           != ( zero_zero @ rat ) )
         => ( ( field_char_0_of_rat @ A @ ( divide_divide @ rat @ A2 @ B2 ) )
            = ( divide_divide @ A @ ( field_char_0_of_rat @ A @ A2 ) @ ( field_char_0_of_rat @ A @ B2 ) ) ) ) ) ).

% nonzero_of_rat_divide
thf(fact_7083_set__encode__vimage__Suc,axiom,
    ! [A4: set @ nat] :
      ( ( nat_set_encode @ ( vimage @ nat @ nat @ suc @ A4 ) )
      = ( divide_divide @ nat @ ( nat_set_encode @ A4 ) @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ).

% set_encode_vimage_Suc
thf(fact_7084_euclidean__size__times__nonunit,axiom,
    ! [A: $tType] :
      ( ( euclid3725896446679973847miring @ A )
     => ! [A2: A,B2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( B2
             != ( zero_zero @ A ) )
           => ( ~ ( dvd_dvd @ A @ A2 @ ( one_one @ A ) )
             => ( ord_less @ nat @ ( euclid6346220572633701492n_size @ A @ B2 ) @ ( euclid6346220572633701492n_size @ A @ ( times_times @ A @ A2 @ B2 ) ) ) ) ) ) ) ).

% euclidean_size_times_nonunit
thf(fact_7085_euclidean__size__of__nat,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [N: nat] :
          ( ( euclid6346220572633701492n_size @ A @ ( semiring_1_of_nat @ A @ N ) )
          = N ) ) ).

% euclidean_size_of_nat
thf(fact_7086_size__0,axiom,
    ! [A: $tType] :
      ( ( euclid3725896446679973847miring @ A )
     => ( ( euclid6346220572633701492n_size @ A @ ( zero_zero @ A ) )
        = ( zero_zero @ nat ) ) ) ).

% size_0
thf(fact_7087_euclidean__size__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( euclid3725896446679973847miring @ A )
     => ! [B2: A] :
          ( ( ( euclid6346220572633701492n_size @ A @ B2 )
            = ( zero_zero @ nat ) )
          = ( B2
            = ( zero_zero @ A ) ) ) ) ).

% euclidean_size_eq_0_iff
thf(fact_7088_euclidean__size__numeral,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [K: num] :
          ( ( euclid6346220572633701492n_size @ A @ ( numeral_numeral @ A @ K ) )
          = ( numeral_numeral @ nat @ K ) ) ) ).

% euclidean_size_numeral
thf(fact_7089_euclidean__size__greater__0__iff,axiom,
    ! [A: $tType] :
      ( ( euclid3725896446679973847miring @ A )
     => ! [B2: A] :
          ( ( ord_less @ nat @ ( zero_zero @ nat ) @ ( euclid6346220572633701492n_size @ A @ B2 ) )
          = ( ( B2
             != ( zero_zero @ A ) ) ) ) ) ).

% euclidean_size_greater_0_iff
thf(fact_7090_vimage__Suc__insert__0,axiom,
    ! [A4: set @ nat] :
      ( ( vimage @ nat @ nat @ suc @ ( insert @ nat @ ( zero_zero @ nat ) @ A4 ) )
      = ( vimage @ nat @ nat @ suc @ A4 ) ) ).

% vimage_Suc_insert_0
thf(fact_7091_dvd__euclidean__size__eq__imp__dvd,axiom,
    ! [A: $tType] :
      ( ( euclid3725896446679973847miring @ A )
     => ! [A2: A,B2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( ( euclid6346220572633701492n_size @ A @ A2 )
              = ( euclid6346220572633701492n_size @ A @ B2 ) )
           => ( ( dvd_dvd @ A @ B2 @ A2 )
             => ( dvd_dvd @ A @ A2 @ B2 ) ) ) ) ) ).

% dvd_euclidean_size_eq_imp_dvd
thf(fact_7092_unit__iff__euclidean__size,axiom,
    ! [A: $tType] :
      ( ( euclid3725896446679973847miring @ A )
     => ! [A2: A] :
          ( ( dvd_dvd @ A @ A2 @ ( one_one @ A ) )
          = ( ( ( euclid6346220572633701492n_size @ A @ A2 )
              = ( euclid6346220572633701492n_size @ A @ ( one_one @ A ) ) )
            & ( A2
             != ( zero_zero @ A ) ) ) ) ) ).

% unit_iff_euclidean_size
thf(fact_7093_size__mult__mono_H,axiom,
    ! [A: $tType] :
      ( ( euclid3725896446679973847miring @ A )
     => ! [B2: A,A2: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ord_less_eq @ nat @ ( euclid6346220572633701492n_size @ A @ A2 ) @ ( euclid6346220572633701492n_size @ A @ ( times_times @ A @ B2 @ A2 ) ) ) ) ) ).

% size_mult_mono'
thf(fact_7094_size__mult__mono,axiom,
    ! [A: $tType] :
      ( ( euclid3725896446679973847miring @ A )
     => ! [B2: A,A2: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ord_less_eq @ nat @ ( euclid6346220572633701492n_size @ A @ A2 ) @ ( euclid6346220572633701492n_size @ A @ ( times_times @ A @ A2 @ B2 ) ) ) ) ) ).

% size_mult_mono
thf(fact_7095_dvd__proper__imp__size__less,axiom,
    ! [A: $tType] :
      ( ( euclid3725896446679973847miring @ A )
     => ! [A2: A,B2: A] :
          ( ( dvd_dvd @ A @ A2 @ B2 )
         => ( ~ ( dvd_dvd @ A @ B2 @ A2 )
           => ( ( B2
               != ( zero_zero @ A ) )
             => ( ord_less @ nat @ ( euclid6346220572633701492n_size @ A @ A2 ) @ ( euclid6346220572633701492n_size @ A @ B2 ) ) ) ) ) ) ).

% dvd_proper_imp_size_less
thf(fact_7096_dvd__imp__size__le,axiom,
    ! [A: $tType] :
      ( ( euclid3725896446679973847miring @ A )
     => ! [A2: A,B2: A] :
          ( ( dvd_dvd @ A @ A2 @ B2 )
         => ( ( B2
             != ( zero_zero @ A ) )
           => ( ord_less_eq @ nat @ ( euclid6346220572633701492n_size @ A @ A2 ) @ ( euclid6346220572633701492n_size @ A @ B2 ) ) ) ) ) ).

% dvd_imp_size_le
thf(fact_7097_mod__size__less,axiom,
    ! [A: $tType] :
      ( ( euclid3725896446679973847miring @ A )
     => ! [B2: A,A2: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ord_less @ nat @ ( euclid6346220572633701492n_size @ A @ ( modulo_modulo @ A @ A2 @ B2 ) ) @ ( euclid6346220572633701492n_size @ A @ B2 ) ) ) ) ).

% mod_size_less
thf(fact_7098_card__vimage__inj__on__le,axiom,
    ! [A: $tType,B: $tType,F2: A > B,D5: set @ A,A4: set @ B] :
      ( ( inj_on @ A @ B @ F2 @ D5 )
     => ( ( finite_finite @ B @ A4 )
       => ( ord_less_eq @ nat @ ( finite_card @ A @ ( inf_inf @ ( set @ A ) @ ( vimage @ A @ B @ F2 @ A4 ) @ D5 ) ) @ ( finite_card @ B @ A4 ) ) ) ) ).

% card_vimage_inj_on_le
thf(fact_7099_set__decode__div__2,axiom,
    ! [X: nat] :
      ( ( nat_set_decode @ ( divide_divide @ nat @ X @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) )
      = ( vimage @ nat @ nat @ suc @ ( nat_set_decode @ X ) ) ) ).

% set_decode_div_2
thf(fact_7100_divmod__cases,axiom,
    ! [A: $tType] :
      ( ( euclid3128863361964157862miring @ A )
     => ! [B2: A,A2: A] :
          ( ( ( B2
             != ( zero_zero @ A ) )
           => ( ( ( modulo_modulo @ A @ A2 @ B2 )
                = ( zero_zero @ A ) )
             => ( A2
               != ( times_times @ A @ ( divide_divide @ A @ A2 @ B2 ) @ B2 ) ) ) )
         => ( ( ( B2
               != ( zero_zero @ A ) )
             => ! [Q5: A,R: A] :
                  ( ( ( euclid7384307370059645450egment @ A @ R )
                    = ( euclid7384307370059645450egment @ A @ B2 ) )
                 => ( ( ord_less @ nat @ ( euclid6346220572633701492n_size @ A @ R ) @ ( euclid6346220572633701492n_size @ A @ B2 ) )
                   => ( ( R
                       != ( zero_zero @ A ) )
                     => ( ( ( divide_divide @ A @ A2 @ B2 )
                          = Q5 )
                       => ( ( ( modulo_modulo @ A @ A2 @ B2 )
                            = R )
                         => ( A2
                           != ( plus_plus @ A @ ( times_times @ A @ Q5 @ B2 ) @ R ) ) ) ) ) ) ) )
           => ( B2
              = ( zero_zero @ A ) ) ) ) ) ).

% divmod_cases
thf(fact_7101_mod__eqI,axiom,
    ! [A: $tType] :
      ( ( euclid3128863361964157862miring @ A )
     => ! [B2: A,R2: A,Q3: A,A2: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( ( euclid7384307370059645450egment @ A @ R2 )
              = ( euclid7384307370059645450egment @ A @ B2 ) )
           => ( ( ord_less @ nat @ ( euclid6346220572633701492n_size @ A @ R2 ) @ ( euclid6346220572633701492n_size @ A @ B2 ) )
             => ( ( ( plus_plus @ A @ ( times_times @ A @ Q3 @ B2 ) @ R2 )
                  = A2 )
               => ( ( modulo_modulo @ A @ A2 @ B2 )
                  = R2 ) ) ) ) ) ) ).

% mod_eqI
thf(fact_7102_division__segment__numeral,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [K: num] :
          ( ( euclid7384307370059645450egment @ A @ ( numeral_numeral @ A @ K ) )
          = ( one_one @ A ) ) ) ).

% division_segment_numeral
thf(fact_7103_division__segment__of__nat,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [N: nat] :
          ( ( euclid7384307370059645450egment @ A @ ( semiring_1_of_nat @ A @ N ) )
          = ( one_one @ A ) ) ) ).

% division_segment_of_nat
thf(fact_7104_division__segment__euclidean__size,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [A2: A] :
          ( ( times_times @ A @ ( euclid7384307370059645450egment @ A @ A2 ) @ ( semiring_1_of_nat @ A @ ( euclid6346220572633701492n_size @ A @ A2 ) ) )
          = A2 ) ) ).

% division_segment_euclidean_size
thf(fact_7105_division__segment__not__0,axiom,
    ! [A: $tType] :
      ( ( euclid3128863361964157862miring @ A )
     => ! [A2: A] :
          ( ( euclid7384307370059645450egment @ A @ A2 )
         != ( zero_zero @ A ) ) ) ).

% division_segment_not_0
thf(fact_7106_division__segment__eq__sgn,axiom,
    ! [K: int] :
      ( ( K
       != ( zero_zero @ int ) )
     => ( ( euclid7384307370059645450egment @ int @ K )
        = ( sgn_sgn @ int @ K ) ) ) ).

% division_segment_eq_sgn
thf(fact_7107_division__segment__mult,axiom,
    ! [A: $tType] :
      ( ( euclid3128863361964157862miring @ A )
     => ! [A2: A,B2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( B2
             != ( zero_zero @ A ) )
           => ( ( euclid7384307370059645450egment @ A @ ( times_times @ A @ A2 @ B2 ) )
              = ( times_times @ A @ ( euclid7384307370059645450egment @ A @ A2 ) @ ( euclid7384307370059645450egment @ A @ B2 ) ) ) ) ) ) ).

% division_segment_mult
thf(fact_7108_division__segment__mod,axiom,
    ! [A: $tType] :
      ( ( euclid3128863361964157862miring @ A )
     => ! [B2: A,A2: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ~ ( dvd_dvd @ A @ B2 @ A2 )
           => ( ( euclid7384307370059645450egment @ A @ ( modulo_modulo @ A @ A2 @ B2 ) )
              = ( euclid7384307370059645450egment @ A @ B2 ) ) ) ) ) ).

% division_segment_mod
thf(fact_7109_of__nat__euclidean__size,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [A2: A] :
          ( ( semiring_1_of_nat @ A @ ( euclid6346220572633701492n_size @ A @ A2 ) )
          = ( divide_divide @ A @ A2 @ ( euclid7384307370059645450egment @ A @ A2 ) ) ) ) ).

% of_nat_euclidean_size
thf(fact_7110_division__segment__int__def,axiom,
    ( ( euclid7384307370059645450egment @ int )
    = ( ^ [K3: int] : ( if @ int @ ( ord_less_eq @ int @ ( zero_zero @ int ) @ K3 ) @ ( one_one @ int ) @ ( uminus_uminus @ int @ ( one_one @ int ) ) ) ) ) ).

% division_segment_int_def
thf(fact_7111_unique__euclidean__semiring__class_Odiv__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( euclid3128863361964157862miring @ A )
     => ! [A2: A,B2: A] :
          ( ( ( euclid7384307370059645450egment @ A @ A2 )
            = ( euclid7384307370059645450egment @ A @ B2 ) )
         => ( ( ( divide_divide @ A @ A2 @ B2 )
              = ( zero_zero @ A ) )
            = ( ( ord_less @ nat @ ( euclid6346220572633701492n_size @ A @ A2 ) @ ( euclid6346220572633701492n_size @ A @ B2 ) )
              | ( B2
                = ( zero_zero @ A ) ) ) ) ) ) ).

% unique_euclidean_semiring_class.div_eq_0_iff
thf(fact_7112_div__bounded,axiom,
    ! [A: $tType] :
      ( ( euclid3128863361964157862miring @ A )
     => ! [B2: A,R2: A,Q3: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( ( euclid7384307370059645450egment @ A @ R2 )
              = ( euclid7384307370059645450egment @ A @ B2 ) )
           => ( ( ord_less @ nat @ ( euclid6346220572633701492n_size @ A @ R2 ) @ ( euclid6346220572633701492n_size @ A @ B2 ) )
             => ( ( divide_divide @ A @ ( plus_plus @ A @ ( times_times @ A @ Q3 @ B2 ) @ R2 ) @ B2 )
                = Q3 ) ) ) ) ) ).

% div_bounded
thf(fact_7113_div__eqI,axiom,
    ! [A: $tType] :
      ( ( euclid3128863361964157862miring @ A )
     => ! [B2: A,R2: A,Q3: A,A2: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( ( euclid7384307370059645450egment @ A @ R2 )
              = ( euclid7384307370059645450egment @ A @ B2 ) )
           => ( ( ord_less @ nat @ ( euclid6346220572633701492n_size @ A @ R2 ) @ ( euclid6346220572633701492n_size @ A @ B2 ) )
             => ( ( ( plus_plus @ A @ ( times_times @ A @ Q3 @ B2 ) @ R2 )
                  = A2 )
               => ( ( divide_divide @ A @ A2 @ B2 )
                  = Q3 ) ) ) ) ) ) ).

% div_eqI
thf(fact_7114_less__eq__enat__def,axiom,
    ( ( ord_less_eq @ extended_enat )
    = ( ^ [M3: extended_enat] :
          ( extended_case_enat @ $o
          @ ^ [N1: nat] :
              ( extended_case_enat @ $o
              @ ^ [M1: nat] : ( ord_less_eq @ nat @ M1 @ N1 )
              @ $false
              @ M3 )
          @ $true ) ) ) ).

% less_eq_enat_def
thf(fact_7115_rat__number__expand_I5_J,axiom,
    ! [K: num] :
      ( ( uminus_uminus @ rat @ ( numeral_numeral @ rat @ K ) )
      = ( fract @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ K ) ) @ ( one_one @ int ) ) ) ).

% rat_number_expand(5)
thf(fact_7116_less__rat,axiom,
    ! [B2: int,D2: int,A2: int,C2: int] :
      ( ( B2
       != ( zero_zero @ int ) )
     => ( ( D2
         != ( zero_zero @ int ) )
       => ( ( ord_less @ rat @ ( fract @ A2 @ B2 ) @ ( fract @ C2 @ D2 ) )
          = ( ord_less @ int @ ( times_times @ int @ ( times_times @ int @ A2 @ D2 ) @ ( times_times @ int @ B2 @ D2 ) ) @ ( times_times @ int @ ( times_times @ int @ C2 @ B2 ) @ ( times_times @ int @ B2 @ D2 ) ) ) ) ) ) ).

% less_rat
thf(fact_7117_add__rat,axiom,
    ! [B2: int,D2: int,A2: int,C2: int] :
      ( ( B2
       != ( zero_zero @ int ) )
     => ( ( D2
         != ( zero_zero @ int ) )
       => ( ( plus_plus @ rat @ ( fract @ A2 @ B2 ) @ ( fract @ C2 @ D2 ) )
          = ( fract @ ( plus_plus @ int @ ( times_times @ int @ A2 @ D2 ) @ ( times_times @ int @ C2 @ B2 ) ) @ ( times_times @ int @ B2 @ D2 ) ) ) ) ) ).

% add_rat
thf(fact_7118_le__rat,axiom,
    ! [B2: int,D2: int,A2: int,C2: int] :
      ( ( B2
       != ( zero_zero @ int ) )
     => ( ( D2
         != ( zero_zero @ int ) )
       => ( ( ord_less_eq @ rat @ ( fract @ A2 @ B2 ) @ ( fract @ C2 @ D2 ) )
          = ( ord_less_eq @ int @ ( times_times @ int @ ( times_times @ int @ A2 @ D2 ) @ ( times_times @ int @ B2 @ D2 ) ) @ ( times_times @ int @ ( times_times @ int @ C2 @ B2 ) @ ( times_times @ int @ B2 @ D2 ) ) ) ) ) ) ).

% le_rat
thf(fact_7119_diff__rat,axiom,
    ! [B2: int,D2: int,A2: int,C2: int] :
      ( ( B2
       != ( zero_zero @ int ) )
     => ( ( D2
         != ( zero_zero @ int ) )
       => ( ( minus_minus @ rat @ ( fract @ A2 @ B2 ) @ ( fract @ C2 @ D2 ) )
          = ( fract @ ( minus_minus @ int @ ( times_times @ int @ A2 @ D2 ) @ ( times_times @ int @ C2 @ B2 ) ) @ ( times_times @ int @ B2 @ D2 ) ) ) ) ) ).

% diff_rat
thf(fact_7120_eq__rat_I1_J,axiom,
    ! [B2: int,D2: int,A2: int,C2: int] :
      ( ( B2
       != ( zero_zero @ int ) )
     => ( ( D2
         != ( zero_zero @ int ) )
       => ( ( ( fract @ A2 @ B2 )
            = ( fract @ C2 @ D2 ) )
          = ( ( times_times @ int @ A2 @ D2 )
            = ( times_times @ int @ C2 @ B2 ) ) ) ) ) ).

% eq_rat(1)
thf(fact_7121_mult__rat__cancel,axiom,
    ! [C2: int,A2: int,B2: int] :
      ( ( C2
       != ( zero_zero @ int ) )
     => ( ( fract @ ( times_times @ int @ C2 @ A2 ) @ ( times_times @ int @ C2 @ B2 ) )
        = ( fract @ A2 @ B2 ) ) ) ).

% mult_rat_cancel
thf(fact_7122_eq__rat_I3_J,axiom,
    ! [A2: int,C2: int] :
      ( ( fract @ ( zero_zero @ int ) @ A2 )
      = ( fract @ ( zero_zero @ int ) @ C2 ) ) ).

% eq_rat(3)
thf(fact_7123_Rat__induct__pos,axiom,
    ! [P: rat > $o,Q3: rat] :
      ( ! [A5: int,B4: int] :
          ( ( ord_less @ int @ ( zero_zero @ int ) @ B4 )
         => ( P @ ( fract @ A5 @ B4 ) ) )
     => ( P @ Q3 ) ) ).

% Rat_induct_pos
thf(fact_7124_eq__rat_I2_J,axiom,
    ! [A2: int] :
      ( ( fract @ A2 @ ( zero_zero @ int ) )
      = ( fract @ ( zero_zero @ int ) @ ( one_one @ int ) ) ) ).

% eq_rat(2)
thf(fact_7125_rat__number__collapse_I6_J,axiom,
    ! [K: int] :
      ( ( fract @ K @ ( zero_zero @ int ) )
      = ( zero_zero @ rat ) ) ).

% rat_number_collapse(6)
thf(fact_7126_rat__number__collapse_I1_J,axiom,
    ! [K: int] :
      ( ( fract @ ( zero_zero @ int ) @ K )
      = ( zero_zero @ rat ) ) ).

% rat_number_collapse(1)
thf(fact_7127_Zero__rat__def,axiom,
    ( ( zero_zero @ rat )
    = ( fract @ ( zero_zero @ int ) @ ( one_one @ int ) ) ) ).

% Zero_rat_def
thf(fact_7128_rat__number__expand_I3_J,axiom,
    ( ( numeral_numeral @ rat )
    = ( ^ [K3: num] : ( fract @ ( numeral_numeral @ int @ K3 ) @ ( one_one @ int ) ) ) ) ).

% rat_number_expand(3)
thf(fact_7129_rat__number__collapse_I3_J,axiom,
    ! [W: num] :
      ( ( fract @ ( numeral_numeral @ int @ W ) @ ( one_one @ int ) )
      = ( numeral_numeral @ rat @ W ) ) ).

% rat_number_collapse(3)
thf(fact_7130_Fract__of__nat__eq,axiom,
    ! [K: nat] :
      ( ( fract @ ( semiring_1_of_nat @ int @ K ) @ ( one_one @ int ) )
      = ( semiring_1_of_nat @ rat @ K ) ) ).

% Fract_of_nat_eq
thf(fact_7131_of__rat__rat,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [B2: int,A2: int] :
          ( ( B2
           != ( zero_zero @ int ) )
         => ( ( field_char_0_of_rat @ A @ ( fract @ A2 @ B2 ) )
            = ( divide_divide @ A @ ( ring_1_of_int @ A @ A2 ) @ ( ring_1_of_int @ A @ B2 ) ) ) ) ) ).

% of_rat_rat
thf(fact_7132_Fract__less__zero__iff,axiom,
    ! [B2: int,A2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ B2 )
     => ( ( ord_less @ rat @ ( fract @ A2 @ B2 ) @ ( zero_zero @ rat ) )
        = ( ord_less @ int @ A2 @ ( zero_zero @ int ) ) ) ) ).

% Fract_less_zero_iff
thf(fact_7133_zero__less__Fract__iff,axiom,
    ! [B2: int,A2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ B2 )
     => ( ( ord_less @ rat @ ( zero_zero @ rat ) @ ( fract @ A2 @ B2 ) )
        = ( ord_less @ int @ ( zero_zero @ int ) @ A2 ) ) ) ).

% zero_less_Fract_iff
thf(fact_7134_Fract_Oabs__eq,axiom,
    ( fract
    = ( ^ [Xa4: int,X2: int] :
          ( abs_Rat
          @ ( if @ ( product_prod @ int @ int )
            @ ( X2
              = ( zero_zero @ int ) )
            @ ( product_Pair @ int @ int @ ( zero_zero @ int ) @ ( one_one @ int ) )
            @ ( product_Pair @ int @ int @ Xa4 @ X2 ) ) ) ) ) ).

% Fract.abs_eq
thf(fact_7135_positive__rat,axiom,
    ! [A2: int,B2: int] :
      ( ( positive @ ( fract @ A2 @ B2 ) )
      = ( ord_less @ int @ ( zero_zero @ int ) @ ( times_times @ int @ A2 @ B2 ) ) ) ).

% positive_rat
thf(fact_7136_Fract__less__one__iff,axiom,
    ! [B2: int,A2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ B2 )
     => ( ( ord_less @ rat @ ( fract @ A2 @ B2 ) @ ( one_one @ rat ) )
        = ( ord_less @ int @ A2 @ B2 ) ) ) ).

% Fract_less_one_iff
thf(fact_7137_one__less__Fract__iff,axiom,
    ! [B2: int,A2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ B2 )
     => ( ( ord_less @ rat @ ( one_one @ rat ) @ ( fract @ A2 @ B2 ) )
        = ( ord_less @ int @ B2 @ A2 ) ) ) ).

% one_less_Fract_iff
thf(fact_7138_Fract__add__one,axiom,
    ! [N: int,M: int] :
      ( ( N
       != ( zero_zero @ int ) )
     => ( ( fract @ ( plus_plus @ int @ M @ N ) @ N )
        = ( plus_plus @ rat @ ( fract @ M @ N ) @ ( one_one @ rat ) ) ) ) ).

% Fract_add_one
thf(fact_7139_Fract_Otransfer,axiom,
    ( bNF_rel_fun @ int @ int @ ( int > ( product_prod @ int @ int ) ) @ ( int > rat )
    @ ^ [Y3: int,Z2: int] : ( Y3 = Z2 )
    @ ( bNF_rel_fun @ int @ int @ ( product_prod @ int @ int ) @ rat
      @ ^ [Y3: int,Z2: int] : ( Y3 = Z2 )
      @ pcr_rat )
    @ ^ [A3: int,B3: int] :
        ( if @ ( product_prod @ int @ int )
        @ ( B3
          = ( zero_zero @ int ) )
        @ ( product_Pair @ int @ int @ ( zero_zero @ int ) @ ( one_one @ int ) )
        @ ( product_Pair @ int @ int @ A3 @ B3 ) )
    @ fract ) ).

% Fract.transfer
thf(fact_7140_Fract__le__zero__iff,axiom,
    ! [B2: int,A2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ B2 )
     => ( ( ord_less_eq @ rat @ ( fract @ A2 @ B2 ) @ ( zero_zero @ rat ) )
        = ( ord_less_eq @ int @ A2 @ ( zero_zero @ int ) ) ) ) ).

% Fract_le_zero_iff
thf(fact_7141_zero__le__Fract__iff,axiom,
    ! [B2: int,A2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ B2 )
     => ( ( ord_less_eq @ rat @ ( zero_zero @ rat ) @ ( fract @ A2 @ B2 ) )
        = ( ord_less_eq @ int @ ( zero_zero @ int ) @ A2 ) ) ) ).

% zero_le_Fract_iff
thf(fact_7142_Fract__le__one__iff,axiom,
    ! [B2: int,A2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ B2 )
     => ( ( ord_less_eq @ rat @ ( fract @ A2 @ B2 ) @ ( one_one @ rat ) )
        = ( ord_less_eq @ int @ A2 @ B2 ) ) ) ).

% Fract_le_one_iff
thf(fact_7143_one__le__Fract__iff,axiom,
    ! [B2: int,A2: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ B2 )
     => ( ( ord_less_eq @ rat @ ( one_one @ rat ) @ ( fract @ A2 @ B2 ) )
        = ( ord_less_eq @ int @ B2 @ A2 ) ) ) ).

% one_le_Fract_iff
thf(fact_7144_less__enat__def,axiom,
    ( ( ord_less @ extended_enat )
    = ( ^ [M3: extended_enat,N3: extended_enat] :
          ( extended_case_enat @ $o
          @ ^ [M1: nat] : ( extended_case_enat @ $o @ ( ord_less @ nat @ M1 ) @ $true @ N3 )
          @ $false
          @ M3 ) ) ) ).

% less_enat_def
thf(fact_7145_rat__number__collapse_I4_J,axiom,
    ! [W: num] :
      ( ( fract @ ( uminus_uminus @ int @ ( numeral_numeral @ int @ W ) ) @ ( one_one @ int ) )
      = ( uminus_uminus @ rat @ ( numeral_numeral @ rat @ W ) ) ) ).

% rat_number_collapse(4)
thf(fact_7146_quotient__of__def,axiom,
    ( quotient_of
    = ( ^ [X2: rat] :
          ( the @ ( product_prod @ int @ int )
          @ ^ [Pair: product_prod @ int @ int] :
              ( ( X2
                = ( fract @ ( product_fst @ int @ int @ Pair ) @ ( product_snd @ int @ int @ Pair ) ) )
              & ( ord_less @ int @ ( zero_zero @ int ) @ ( product_snd @ int @ int @ Pair ) )
              & ( algebr8660921524188924756oprime @ int @ ( product_fst @ int @ int @ Pair ) @ ( product_snd @ int @ int @ Pair ) ) ) ) ) ) ).

% quotient_of_def
thf(fact_7147_sorted__wrt__iff__nth__Suc__transp,axiom,
    ! [A: $tType,P: A > A > $o,Xs: list @ A] :
      ( ( transp @ A @ P )
     => ( ( sorted_wrt @ A @ P @ Xs )
        = ( ! [I4: nat] :
              ( ( ord_less @ nat @ ( suc @ I4 ) @ ( size_size @ ( list @ A ) @ Xs ) )
             => ( P @ ( nth @ A @ Xs @ I4 ) @ ( nth @ A @ Xs @ ( suc @ I4 ) ) ) ) ) ) ) ).

% sorted_wrt_iff_nth_Suc_transp
thf(fact_7148_coprime__mod__right__iff,axiom,
    ! [A: $tType] :
      ( ( euclid3725896446679973847miring @ A )
     => ! [A2: A,B2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( algebr8660921524188924756oprime @ A @ A2 @ ( modulo_modulo @ A @ B2 @ A2 ) )
            = ( algebr8660921524188924756oprime @ A @ A2 @ B2 ) ) ) ) ).

% coprime_mod_right_iff
thf(fact_7149_coprime__mod__left__iff,axiom,
    ! [A: $tType] :
      ( ( euclid3725896446679973847miring @ A )
     => ! [B2: A,A2: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( algebr8660921524188924756oprime @ A @ ( modulo_modulo @ A @ A2 @ B2 ) @ B2 )
            = ( algebr8660921524188924756oprime @ A @ A2 @ B2 ) ) ) ) ).

% coprime_mod_left_iff
thf(fact_7150_coprime__power__left__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A2: A,N: nat,B2: A] :
          ( ( algebr8660921524188924756oprime @ A @ ( power_power @ A @ A2 @ N ) @ B2 )
          = ( ( algebr8660921524188924756oprime @ A @ A2 @ B2 )
            | ( N
              = ( zero_zero @ nat ) ) ) ) ) ).

% coprime_power_left_iff
thf(fact_7151_coprime__power__right__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A2: A,B2: A,N: nat] :
          ( ( algebr8660921524188924756oprime @ A @ A2 @ ( power_power @ A @ B2 @ N ) )
          = ( ( algebr8660921524188924756oprime @ A @ A2 @ B2 )
            | ( N
              = ( zero_zero @ nat ) ) ) ) ) ).

% coprime_power_right_iff
thf(fact_7152_coprime__0__right__iff,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A] :
          ( ( algebr8660921524188924756oprime @ A @ A2 @ ( zero_zero @ A ) )
          = ( dvd_dvd @ A @ A2 @ ( one_one @ A ) ) ) ) ).

% coprime_0_right_iff
thf(fact_7153_coprime__0__left__iff,axiom,
    ! [A: $tType] :
      ( ( algebraic_semidom @ A )
     => ! [A2: A] :
          ( ( algebr8660921524188924756oprime @ A @ ( zero_zero @ A ) @ A2 )
          = ( dvd_dvd @ A @ A2 @ ( one_one @ A ) ) ) ) ).

% coprime_0_left_iff
thf(fact_7154_coprime__left__2__iff__odd,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [A2: A] :
          ( ( algebr8660921524188924756oprime @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 )
          = ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) ) ) ) ).

% coprime_left_2_iff_odd
thf(fact_7155_coprime__right__2__iff__odd,axiom,
    ! [A: $tType] :
      ( ( euclid5411537665997757685th_nat @ A )
     => ! [A2: A] :
          ( ( algebr8660921524188924756oprime @ A @ A2 @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) )
          = ( ~ ( dvd_dvd @ A @ ( numeral_numeral @ A @ ( bit0 @ one2 ) ) @ A2 ) ) ) ) ).

% coprime_right_2_iff_odd
thf(fact_7156_normalize__stable,axiom,
    ! [Q3: int,P6: int] :
      ( ( ord_less @ int @ ( zero_zero @ int ) @ Q3 )
     => ( ( algebr8660921524188924756oprime @ int @ P6 @ Q3 )
       => ( ( normalize @ ( product_Pair @ int @ int @ P6 @ Q3 ) )
          = ( product_Pair @ int @ int @ P6 @ Q3 ) ) ) ) ).

% normalize_stable
thf(fact_7157_div__gcd__coprime,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A2: A,B2: A] :
          ( ( ( A2
             != ( zero_zero @ A ) )
            | ( B2
             != ( zero_zero @ A ) ) )
         => ( algebr8660921524188924756oprime @ A @ ( divide_divide @ A @ A2 @ ( gcd_gcd @ A @ A2 @ B2 ) ) @ ( divide_divide @ A @ B2 @ ( gcd_gcd @ A @ A2 @ B2 ) ) ) ) ) ).

% div_gcd_coprime
thf(fact_7158_transp__realrel,axiom,
    transp @ ( nat > rat ) @ realrel ).

% transp_realrel
thf(fact_7159_gcd__coprime__exists,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A2: A,B2: A] :
          ( ( ( gcd_gcd @ A @ A2 @ B2 )
           != ( zero_zero @ A ) )
         => ? [A11: A,B10: A] :
              ( ( A2
                = ( times_times @ A @ A11 @ ( gcd_gcd @ A @ A2 @ B2 ) ) )
              & ( B2
                = ( times_times @ A @ B10 @ ( gcd_gcd @ A @ A2 @ B2 ) ) )
              & ( algebr8660921524188924756oprime @ A @ A11 @ B10 ) ) ) ) ).

% gcd_coprime_exists
thf(fact_7160_gcd__coprime,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A2: A,B2: A,A6: A,B5: A] :
          ( ( ( gcd_gcd @ A @ A2 @ B2 )
           != ( zero_zero @ A ) )
         => ( ( A2
              = ( times_times @ A @ A6 @ ( gcd_gcd @ A @ A2 @ B2 ) ) )
           => ( ( B2
                = ( times_times @ A @ B5 @ ( gcd_gcd @ A @ A2 @ B2 ) ) )
             => ( algebr8660921524188924756oprime @ A @ A6 @ B5 ) ) ) ) ) ).

% gcd_coprime
thf(fact_7161_Rat__induct,axiom,
    ! [P: rat > $o,Q3: rat] :
      ( ! [A5: int,B4: int] :
          ( ( ord_less @ int @ ( zero_zero @ int ) @ B4 )
         => ( ( algebr8660921524188924756oprime @ int @ A5 @ B4 )
           => ( P @ ( fract @ A5 @ B4 ) ) ) )
     => ( P @ Q3 ) ) ).

% Rat_induct
thf(fact_7162_Rat__cases,axiom,
    ! [Q3: rat] :
      ~ ! [A5: int,B4: int] :
          ( ( Q3
            = ( fract @ A5 @ B4 ) )
         => ( ( ord_less @ int @ ( zero_zero @ int ) @ B4 )
           => ~ ( algebr8660921524188924756oprime @ int @ A5 @ B4 ) ) ) ).

% Rat_cases
thf(fact_7163_Rat__cases__nonzero,axiom,
    ! [Q3: rat] :
      ( ! [A5: int,B4: int] :
          ( ( Q3
            = ( fract @ A5 @ B4 ) )
         => ( ( ord_less @ int @ ( zero_zero @ int ) @ B4 )
           => ( ( A5
               != ( zero_zero @ int ) )
             => ~ ( algebr8660921524188924756oprime @ int @ A5 @ B4 ) ) ) )
     => ( Q3
        = ( zero_zero @ rat ) ) ) ).

% Rat_cases_nonzero
thf(fact_7164_Rats__cases_H,axiom,
    ! [A: $tType] :
      ( ( field_char_0 @ A )
     => ! [X: A] :
          ( ( member @ A @ X @ ( field_char_0_Rats @ A ) )
         => ~ ! [A5: int,B4: int] :
                ( ( ord_less @ int @ ( zero_zero @ int ) @ B4 )
               => ( ( algebr8660921524188924756oprime @ int @ A5 @ B4 )
                 => ( X
                   != ( divide_divide @ A @ ( ring_1_of_int @ A @ A5 ) @ ( ring_1_of_int @ A @ B4 ) ) ) ) ) ) ) ).

% Rats_cases'
thf(fact_7165_quotient__of__unique,axiom,
    ! [R2: rat] :
    ? [X3: product_prod @ int @ int] :
      ( ( R2
        = ( fract @ ( product_fst @ int @ int @ X3 ) @ ( product_snd @ int @ int @ X3 ) ) )
      & ( ord_less @ int @ ( zero_zero @ int ) @ ( product_snd @ int @ int @ X3 ) )
      & ( algebr8660921524188924756oprime @ int @ ( product_fst @ int @ int @ X3 ) @ ( product_snd @ int @ int @ X3 ) )
      & ! [Y6: product_prod @ int @ int] :
          ( ( ( R2
              = ( fract @ ( product_fst @ int @ int @ Y6 ) @ ( product_snd @ int @ int @ Y6 ) ) )
            & ( ord_less @ int @ ( zero_zero @ int ) @ ( product_snd @ int @ int @ Y6 ) )
            & ( algebr8660921524188924756oprime @ int @ ( product_fst @ int @ int @ Y6 ) @ ( product_snd @ int @ int @ Y6 ) ) )
         => ( Y6 = X3 ) ) ) ).

% quotient_of_unique
thf(fact_7166_transp__gr,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ( transp @ A
        @ ^ [X2: A,Y4: A] : ( ord_less @ A @ Y4 @ X2 ) ) ) ).

% transp_gr
thf(fact_7167_transp__ge,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ( transp @ A
        @ ^ [X2: A,Y4: A] : ( ord_less_eq @ A @ Y4 @ X2 ) ) ) ).

% transp_ge
thf(fact_7168_coprime__int__iff,axiom,
    ! [M: nat,N: nat] :
      ( ( algebr8660921524188924756oprime @ int @ ( semiring_1_of_nat @ int @ M ) @ ( semiring_1_of_nat @ int @ N ) )
      = ( algebr8660921524188924756oprime @ nat @ M @ N ) ) ).

% coprime_int_iff
thf(fact_7169_coprime__nat__abs__right__iff,axiom,
    ! [N: nat,K: int] :
      ( ( algebr8660921524188924756oprime @ nat @ N @ ( nat2 @ ( abs_abs @ int @ K ) ) )
      = ( algebr8660921524188924756oprime @ int @ ( semiring_1_of_nat @ int @ N ) @ K ) ) ).

% coprime_nat_abs_right_iff
thf(fact_7170_coprime__nat__abs__left__iff,axiom,
    ! [K: int,N: nat] :
      ( ( algebr8660921524188924756oprime @ nat @ ( nat2 @ ( abs_abs @ int @ K ) ) @ N )
      = ( algebr8660921524188924756oprime @ int @ K @ ( semiring_1_of_nat @ int @ N ) ) ) ).

% coprime_nat_abs_left_iff
thf(fact_7171_coprime__Suc__0__right,axiom,
    ! [N: nat] : ( algebr8660921524188924756oprime @ nat @ N @ ( suc @ ( zero_zero @ nat ) ) ) ).

% coprime_Suc_0_right
thf(fact_7172_coprime__Suc__0__left,axiom,
    ! [N: nat] : ( algebr8660921524188924756oprime @ nat @ ( suc @ ( zero_zero @ nat ) ) @ N ) ).

% coprime_Suc_0_left
thf(fact_7173_coprime__diff__one__left__nat,axiom,
    ! [N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( algebr8660921524188924756oprime @ nat @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) @ N ) ) ).

% coprime_diff_one_left_nat
thf(fact_7174_coprime__diff__one__right__nat,axiom,
    ! [N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( algebr8660921524188924756oprime @ nat @ N @ ( minus_minus @ nat @ N @ ( one_one @ nat ) ) ) ) ).

% coprime_diff_one_right_nat
thf(fact_7175_Rats__abs__nat__div__natE,axiom,
    ! [X: real] :
      ( ( member @ real @ X @ ( field_char_0_Rats @ real ) )
     => ~ ! [M4: nat,N2: nat] :
            ( ( N2
             != ( zero_zero @ nat ) )
           => ( ( ( abs_abs @ real @ X )
                = ( divide_divide @ real @ ( semiring_1_of_nat @ real @ M4 ) @ ( semiring_1_of_nat @ real @ N2 ) ) )
             => ~ ( algebr8660921524188924756oprime @ nat @ M4 @ N2 ) ) ) ) ).

% Rats_abs_nat_div_natE
thf(fact_7176_transp__le,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ( transp @ A @ ( ord_less_eq @ A ) ) ) ).

% transp_le
thf(fact_7177_transp__less,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ( transp @ A @ ( ord_less @ A ) ) ) ).

% transp_less
thf(fact_7178_span__explicit_H,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ( ( real_Vector_span @ A )
        = ( ^ [B3: set @ A] :
              ( collect @ A
              @ ^ [Uu3: A] :
                ? [F3: A > real] :
                  ( ( Uu3
                    = ( groups7311177749621191930dd_sum @ A @ A
                      @ ^ [V5: A] : ( real_V8093663219630862766scaleR @ A @ ( F3 @ V5 ) @ V5 )
                      @ ( collect @ A
                        @ ^ [V5: A] :
                            ( ( F3 @ V5 )
                           != ( zero_zero @ real ) ) ) ) )
                  & ( finite_finite @ A
                    @ ( collect @ A
                      @ ^ [V5: A] :
                          ( ( F3 @ V5 )
                         != ( zero_zero @ real ) ) ) )
                  & ! [V5: A] :
                      ( ( ( F3 @ V5 )
                       != ( zero_zero @ real ) )
                     => ( member @ A @ V5 @ B3 ) ) ) ) ) ) ) ).

% span_explicit'
thf(fact_7179_span__alt,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ( ( real_Vector_span @ A )
        = ( ^ [B6: set @ A] :
              ( collect @ A
              @ ^ [Uu3: A] :
                ? [F3: A > real] :
                  ( ( Uu3
                    = ( groups7311177749621191930dd_sum @ A @ A
                      @ ^ [X2: A] : ( real_V8093663219630862766scaleR @ A @ ( F3 @ X2 ) @ X2 )
                      @ ( collect @ A
                        @ ^ [X2: A] :
                            ( ( F3 @ X2 )
                           != ( zero_zero @ real ) ) ) ) )
                  & ( ord_less_eq @ ( set @ A )
                    @ ( collect @ A
                      @ ^ [X2: A] :
                          ( ( F3 @ X2 )
                         != ( zero_zero @ real ) ) )
                    @ B6 )
                  & ( finite_finite @ A
                    @ ( collect @ A
                      @ ^ [X2: A] :
                          ( ( F3 @ X2 )
                         != ( zero_zero @ real ) ) ) ) ) ) ) ) ) ).

% span_alt
thf(fact_7180_span__insert__0,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [S: set @ A] :
          ( ( real_Vector_span @ A @ ( insert @ A @ ( zero_zero @ A ) @ S ) )
          = ( real_Vector_span @ A @ S ) ) ) ).

% span_insert_0
thf(fact_7181_span__empty,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ( ( real_Vector_span @ A @ ( bot_bot @ ( set @ A ) ) )
        = ( insert @ A @ ( zero_zero @ A ) @ ( bot_bot @ ( set @ A ) ) ) ) ) ).

% span_empty
thf(fact_7182_span__delete__0,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [S: set @ A] :
          ( ( real_Vector_span @ A @ ( minus_minus @ ( set @ A ) @ S @ ( insert @ A @ ( zero_zero @ A ) @ ( bot_bot @ ( set @ A ) ) ) ) )
          = ( real_Vector_span @ A @ S ) ) ) ).

% span_delete_0
thf(fact_7183_span__induct__alt,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [X: A,S: set @ A,H2: A > $o] :
          ( ( member @ A @ X @ ( real_Vector_span @ A @ S ) )
         => ( ( H2 @ ( zero_zero @ A ) )
           => ( ! [C3: real,X3: A,Y5: A] :
                  ( ( member @ A @ X3 @ S )
                 => ( ( H2 @ Y5 )
                   => ( H2 @ ( plus_plus @ A @ ( real_V8093663219630862766scaleR @ A @ C3 @ X3 ) @ Y5 ) ) ) )
             => ( H2 @ X ) ) ) ) ) ).

% span_induct_alt
thf(fact_7184_span__0,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [S: set @ A] : ( member @ A @ ( zero_zero @ A ) @ ( real_Vector_span @ A @ S ) ) ) ).

% span_0
thf(fact_7185_span__image__scale,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [S: set @ A,C2: A > real] :
          ( ( finite_finite @ A @ S )
         => ( ! [X3: A] :
                ( ( member @ A @ X3 @ S )
               => ( ( C2 @ X3 )
                 != ( zero_zero @ real ) ) )
           => ( ( real_Vector_span @ A
                @ ( image @ A @ A
                  @ ^ [X2: A] : ( real_V8093663219630862766scaleR @ A @ ( C2 @ X2 ) @ X2 )
                  @ S ) )
              = ( real_Vector_span @ A @ S ) ) ) ) ) ).

% span_image_scale
thf(fact_7186_independent__span__bound,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [T6: set @ A,S: set @ A] :
          ( ( finite_finite @ A @ T6 )
         => ( ~ ( real_V358717886546972837endent @ A @ S )
           => ( ( ord_less_eq @ ( set @ A ) @ S @ ( real_Vector_span @ A @ T6 ) )
             => ( ( finite_finite @ A @ S )
                & ( ord_less_eq @ nat @ ( finite_card @ A @ S ) @ ( finite_card @ A @ T6 ) ) ) ) ) ) ) ).

% independent_span_bound
thf(fact_7187_representation__def,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ( ( real_V7696804695334737415tation @ A )
        = ( ^ [Basis2: set @ A,V5: A] :
              ( if @ ( A > real )
              @ ( ~ ( real_V358717886546972837endent @ A @ Basis2 )
                & ( member @ A @ V5 @ ( real_Vector_span @ A @ Basis2 ) ) )
              @ ( fChoice @ ( A > real )
                @ ^ [F3: A > real] :
                    ( ! [W3: A] :
                        ( ( ( F3 @ W3 )
                         != ( zero_zero @ real ) )
                       => ( member @ A @ W3 @ Basis2 ) )
                    & ( finite_finite @ A
                      @ ( collect @ A
                        @ ^ [W3: A] :
                            ( ( F3 @ W3 )
                           != ( zero_zero @ real ) ) ) )
                    & ( ( groups7311177749621191930dd_sum @ A @ A
                        @ ^ [W3: A] : ( real_V8093663219630862766scaleR @ A @ ( F3 @ W3 ) @ W3 )
                        @ ( collect @ A
                          @ ^ [W3: A] :
                              ( ( F3 @ W3 )
                             != ( zero_zero @ real ) ) ) )
                      = V5 ) ) )
              @ ^ [B3: A] : ( zero_zero @ real ) ) ) ) ) ).

% representation_def
thf(fact_7188_representation__eqI,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [Basis: set @ A,V: A,F2: A > real] :
          ( ~ ( real_V358717886546972837endent @ A @ Basis )
         => ( ( member @ A @ V @ ( real_Vector_span @ A @ Basis ) )
           => ( ! [B4: A] :
                  ( ( ( F2 @ B4 )
                   != ( zero_zero @ real ) )
                 => ( member @ A @ B4 @ Basis ) )
             => ( ( finite_finite @ A
                  @ ( collect @ A
                    @ ^ [B3: A] :
                        ( ( F2 @ B3 )
                       != ( zero_zero @ real ) ) ) )
               => ( ( ( groups7311177749621191930dd_sum @ A @ A
                      @ ^ [B3: A] : ( real_V8093663219630862766scaleR @ A @ ( F2 @ B3 ) @ B3 )
                      @ ( collect @ A
                        @ ^ [B3: A] :
                            ( ( F2 @ B3 )
                           != ( zero_zero @ real ) ) ) )
                    = V )
                 => ( ( real_V7696804695334737415tation @ A @ Basis @ V )
                    = F2 ) ) ) ) ) ) ) ).

% representation_eqI
thf(fact_7189_representation__ne__zero,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [Basis: set @ A,V: A,B2: A] :
          ( ( ( real_V7696804695334737415tation @ A @ Basis @ V @ B2 )
           != ( zero_zero @ real ) )
         => ( member @ A @ B2 @ Basis ) ) ) ).

% representation_ne_zero
thf(fact_7190_representation__zero,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [Basis: set @ A] :
          ( ( real_V7696804695334737415tation @ A @ Basis @ ( zero_zero @ A ) )
          = ( ^ [B3: A] : ( zero_zero @ real ) ) ) ) ).

% representation_zero
thf(fact_7191_finite__representation,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [Basis: set @ A,V: A] :
          ( finite_finite @ A
          @ ( collect @ A
            @ ^ [B3: A] :
                ( ( real_V7696804695334737415tation @ A @ Basis @ V @ B3 )
               != ( zero_zero @ real ) ) ) ) ) ).

% finite_representation
thf(fact_7192_representation__basis,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [Basis: set @ A,B2: A] :
          ( ~ ( real_V358717886546972837endent @ A @ Basis )
         => ( ( member @ A @ B2 @ Basis )
           => ( ( real_V7696804695334737415tation @ A @ Basis @ B2 )
              = ( ^ [V5: A] : ( if @ real @ ( V5 = B2 ) @ ( one_one @ real ) @ ( zero_zero @ real ) ) ) ) ) ) ) ).

% representation_basis
thf(fact_7193_sum__nonzero__representation__eq,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [Basis: set @ A,V: A] :
          ( ~ ( real_V358717886546972837endent @ A @ Basis )
         => ( ( member @ A @ V @ ( real_Vector_span @ A @ Basis ) )
           => ( ( groups7311177749621191930dd_sum @ A @ A
                @ ^ [B3: A] : ( real_V8093663219630862766scaleR @ A @ ( real_V7696804695334737415tation @ A @ Basis @ V @ B3 ) @ B3 )
                @ ( collect @ A
                  @ ^ [B3: A] :
                      ( ( real_V7696804695334737415tation @ A @ Basis @ V @ B3 )
                     != ( zero_zero @ real ) ) ) )
              = V ) ) ) ) ).

% sum_nonzero_representation_eq
thf(fact_7194_span__card__ge__dim,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [B7: set @ A,V2: set @ A] :
          ( ( ord_less_eq @ ( set @ A ) @ B7 @ V2 )
         => ( ( ord_less_eq @ ( set @ A ) @ V2 @ ( real_Vector_span @ A @ B7 ) )
           => ( ( finite_finite @ A @ B7 )
             => ( ord_less_eq @ nat @ ( real_Vector_dim @ A @ V2 ) @ ( finite_card @ A @ B7 ) ) ) ) ) ) ).

% span_card_ge_dim
thf(fact_7195_dim__le__card,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [V2: set @ A,W4: set @ A] :
          ( ( ord_less_eq @ ( set @ A ) @ V2 @ ( real_Vector_span @ A @ W4 ) )
         => ( ( finite_finite @ A @ W4 )
           => ( ord_less_eq @ nat @ ( real_Vector_dim @ A @ V2 ) @ ( finite_card @ A @ W4 ) ) ) ) ) ).

% dim_le_card
thf(fact_7196_dim__le__card_H,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [S2: set @ A] :
          ( ( finite_finite @ A @ S2 )
         => ( ord_less_eq @ nat @ ( real_Vector_dim @ A @ S2 ) @ ( finite_card @ A @ S2 ) ) ) ) ).

% dim_le_card'
thf(fact_7197_dim__def,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ( ( real_Vector_dim @ A )
        = ( ^ [V6: set @ A] :
              ( if @ nat
              @ ? [B3: set @ A] :
                  ( ~ ( real_V358717886546972837endent @ A @ B3 )
                  & ( ( real_Vector_span @ A @ B3 )
                    = ( real_Vector_span @ A @ V6 ) ) )
              @ ( finite_card @ A
                @ ( fChoice @ ( set @ A )
                  @ ^ [B3: set @ A] :
                      ( ~ ( real_V358717886546972837endent @ A @ B3 )
                      & ( ( real_Vector_span @ A @ B3 )
                        = ( real_Vector_span @ A @ V6 ) ) ) ) )
              @ ( zero_zero @ nat ) ) ) ) ) ).

% dim_def
thf(fact_7198_linear__indep__image__lemma,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V4867850818363320053vector @ A )
        & ( real_V4867850818363320053vector @ B ) )
     => ! [F2: A > B,B7: set @ A,X: A] :
          ( ( real_Vector_linear @ A @ B @ F2 )
         => ( ( finite_finite @ A @ B7 )
           => ( ~ ( real_V358717886546972837endent @ B @ ( image @ A @ B @ F2 @ B7 ) )
             => ( ( inj_on @ A @ B @ F2 @ B7 )
               => ( ( member @ A @ X @ ( real_Vector_span @ A @ B7 ) )
                 => ( ( ( F2 @ X )
                      = ( zero_zero @ B ) )
                   => ( X
                      = ( zero_zero @ A ) ) ) ) ) ) ) ) ) ).

% linear_indep_image_lemma
thf(fact_7199_lexordp__conv__lexord,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( ( ord_lexordp @ A )
        = ( ^ [Xs3: list @ A,Ys2: list @ A] : ( member @ ( product_prod @ ( list @ A ) @ ( list @ A ) ) @ ( product_Pair @ ( list @ A ) @ ( list @ A ) @ Xs3 @ Ys2 ) @ ( lexord @ A @ ( collect @ ( product_prod @ A @ A ) @ ( product_case_prod @ A @ A @ $o @ ( ord_less @ A ) ) ) ) ) ) ) ) ).

% lexordp_conv_lexord
thf(fact_7200_lexordp__simps_I3_J,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [X: A,Xs: list @ A,Y: A,Ys3: list @ A] :
          ( ( ord_lexordp @ A @ ( cons @ A @ X @ Xs ) @ ( cons @ A @ Y @ Ys3 ) )
          = ( ( ord_less @ A @ X @ Y )
            | ( ~ ( ord_less @ A @ Y @ X )
              & ( ord_lexordp @ A @ Xs @ Ys3 ) ) ) ) ) ).

% lexordp_simps(3)
thf(fact_7201_linear__eq__0__on__span,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( real_V4867850818363320053vector @ B )
        & ( real_V4867850818363320053vector @ A ) )
     => ! [F2: A > B,B2: set @ A,X: A] :
          ( ( real_Vector_linear @ A @ B @ F2 )
         => ( ! [X3: A] :
                ( ( member @ A @ X3 @ B2 )
               => ( ( F2 @ X3 )
                  = ( zero_zero @ B ) ) )
           => ( ( member @ A @ X @ ( real_Vector_span @ A @ B2 ) )
             => ( ( F2 @ X )
                = ( zero_zero @ B ) ) ) ) ) ) ).

% linear_eq_0_on_span
thf(fact_7202_lexordp_OCons,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [X: A,Y: A,Xs: list @ A,Ys3: list @ A] :
          ( ( ord_less @ A @ X @ Y )
         => ( ord_lexordp @ A @ ( cons @ A @ X @ Xs ) @ ( cons @ A @ Y @ Ys3 ) ) ) ) ).

% lexordp.Cons
thf(fact_7203_lexordp_OCons__eq,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [X: A,Y: A,Xs: list @ A,Ys3: list @ A] :
          ( ~ ( ord_less @ A @ X @ Y )
         => ( ~ ( ord_less @ A @ Y @ X )
           => ( ( ord_lexordp @ A @ Xs @ Ys3 )
             => ( ord_lexordp @ A @ ( cons @ A @ X @ Xs ) @ ( cons @ A @ Y @ Ys3 ) ) ) ) ) ) ).

% lexordp.Cons_eq
thf(fact_7204_module__hom__zero,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V4867850818363320053vector @ A )
        & ( real_V4867850818363320053vector @ B ) )
     => ( real_Vector_linear @ A @ B
        @ ^ [X2: A] : ( zero_zero @ B ) ) ) ).

% module_hom_zero
thf(fact_7205_linear__0,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( real_V4867850818363320053vector @ B )
        & ( real_V4867850818363320053vector @ A ) )
     => ! [F2: A > B] :
          ( ( real_Vector_linear @ A @ B @ F2 )
         => ( ( F2 @ ( zero_zero @ A ) )
            = ( zero_zero @ B ) ) ) ) ).

% linear_0
thf(fact_7206_lexordp__irreflexive,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [Xs: list @ A] :
          ( ! [X3: A] :
              ~ ( ord_less @ A @ X3 @ X3 )
         => ~ ( ord_lexordp @ A @ Xs @ Xs ) ) ) ).

% lexordp_irreflexive
thf(fact_7207_lexordp__append__leftD,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [Xs: list @ A,Us: list @ A,Vs: list @ A] :
          ( ( ord_lexordp @ A @ ( append @ A @ Xs @ Us ) @ ( append @ A @ Xs @ Vs ) )
         => ( ! [A5: A] :
                ~ ( ord_less @ A @ A5 @ A5 )
           => ( ord_lexordp @ A @ Us @ Vs ) ) ) ) ).

% lexordp_append_leftD
thf(fact_7208_linear__injective__0,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V4867850818363320053vector @ A )
        & ( real_V4867850818363320053vector @ B ) )
     => ! [F2: A > B] :
          ( ( real_Vector_linear @ A @ B @ F2 )
         => ( ( inj_on @ A @ B @ F2 @ ( top_top @ ( set @ A ) ) )
            = ( ! [X2: A] :
                  ( ( ( F2 @ X2 )
                    = ( zero_zero @ B ) )
                 => ( X2
                    = ( zero_zero @ A ) ) ) ) ) ) ) ).

% linear_injective_0
thf(fact_7209_lexordp__induct,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A,Ys3: list @ A,P: ( list @ A ) > ( list @ A ) > $o] :
          ( ( ord_lexordp @ A @ Xs @ Ys3 )
         => ( ! [Y5: A,Ys4: list @ A] : ( P @ ( nil @ A ) @ ( cons @ A @ Y5 @ Ys4 ) )
           => ( ! [X3: A,Xs2: list @ A,Y5: A,Ys4: list @ A] :
                  ( ( ord_less @ A @ X3 @ Y5 )
                 => ( P @ ( cons @ A @ X3 @ Xs2 ) @ ( cons @ A @ Y5 @ Ys4 ) ) )
             => ( ! [X3: A,Xs2: list @ A,Ys4: list @ A] :
                    ( ( ord_lexordp @ A @ Xs2 @ Ys4 )
                   => ( ( P @ Xs2 @ Ys4 )
                     => ( P @ ( cons @ A @ X3 @ Xs2 ) @ ( cons @ A @ X3 @ Ys4 ) ) ) )
               => ( P @ Xs @ Ys3 ) ) ) ) ) ) ).

% lexordp_induct
thf(fact_7210_lexordp__cases,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A,Ys3: list @ A] :
          ( ( ord_lexordp @ A @ Xs @ Ys3 )
         => ( ( ( Xs
                = ( nil @ A ) )
             => ! [Y5: A,Ys5: list @ A] :
                  ( Ys3
                 != ( cons @ A @ Y5 @ Ys5 ) ) )
           => ( ! [X3: A] :
                  ( ? [Xs4: list @ A] :
                      ( Xs
                      = ( cons @ A @ X3 @ Xs4 ) )
                 => ! [Y5: A] :
                      ( ? [Ys5: list @ A] :
                          ( Ys3
                          = ( cons @ A @ Y5 @ Ys5 ) )
                     => ~ ( ord_less @ A @ X3 @ Y5 ) ) )
             => ~ ! [X3: A,Xs4: list @ A] :
                    ( ( Xs
                      = ( cons @ A @ X3 @ Xs4 ) )
                   => ! [Ys5: list @ A] :
                        ( ( Ys3
                          = ( cons @ A @ X3 @ Ys5 ) )
                       => ~ ( ord_lexordp @ A @ Xs4 @ Ys5 ) ) ) ) ) ) ) ).

% lexordp_cases
thf(fact_7211_lexordp_Osimps,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ( ( ord_lexordp @ A )
        = ( ^ [A1: list @ A,A22: list @ A] :
              ( ? [Y4: A,Ys2: list @ A] :
                  ( ( A1
                    = ( nil @ A ) )
                  & ( A22
                    = ( cons @ A @ Y4 @ Ys2 ) ) )
              | ? [X2: A,Y4: A,Xs3: list @ A,Ys2: list @ A] :
                  ( ( A1
                    = ( cons @ A @ X2 @ Xs3 ) )
                  & ( A22
                    = ( cons @ A @ Y4 @ Ys2 ) )
                  & ( ord_less @ A @ X2 @ Y4 ) )
              | ? [X2: A,Y4: A,Xs3: list @ A,Ys2: list @ A] :
                  ( ( A1
                    = ( cons @ A @ X2 @ Xs3 ) )
                  & ( A22
                    = ( cons @ A @ Y4 @ Ys2 ) )
                  & ~ ( ord_less @ A @ X2 @ Y4 )
                  & ~ ( ord_less @ A @ Y4 @ X2 )
                  & ( ord_lexordp @ A @ Xs3 @ Ys2 ) ) ) ) ) ) ).

% lexordp.simps
thf(fact_7212_lexordp_Ocases,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [A12: list @ A,A23: list @ A] :
          ( ( ord_lexordp @ A @ A12 @ A23 )
         => ( ( ( A12
                = ( nil @ A ) )
             => ! [Y5: A,Ys4: list @ A] :
                  ( A23
                 != ( cons @ A @ Y5 @ Ys4 ) ) )
           => ( ! [X3: A] :
                  ( ? [Xs2: list @ A] :
                      ( A12
                      = ( cons @ A @ X3 @ Xs2 ) )
                 => ! [Y5: A] :
                      ( ? [Ys4: list @ A] :
                          ( A23
                          = ( cons @ A @ Y5 @ Ys4 ) )
                     => ~ ( ord_less @ A @ X3 @ Y5 ) ) )
             => ~ ! [X3: A,Y5: A,Xs2: list @ A] :
                    ( ( A12
                      = ( cons @ A @ X3 @ Xs2 ) )
                   => ! [Ys4: list @ A] :
                        ( ( A23
                          = ( cons @ A @ Y5 @ Ys4 ) )
                       => ( ~ ( ord_less @ A @ X3 @ Y5 )
                         => ( ~ ( ord_less @ A @ Y5 @ X3 )
                           => ~ ( ord_lexordp @ A @ Xs2 @ Ys4 ) ) ) ) ) ) ) ) ) ).

% lexordp.cases
thf(fact_7213_lexordp__iff,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( ( ord_lexordp @ A )
        = ( ^ [Xs3: list @ A,Ys2: list @ A] :
              ( ? [X2: A,Vs2: list @ A] :
                  ( Ys2
                  = ( append @ A @ Xs3 @ ( cons @ A @ X2 @ Vs2 ) ) )
              | ? [Us2: list @ A,A3: A,B3: A,Vs2: list @ A,Ws: list @ A] :
                  ( ( ord_less @ A @ A3 @ B3 )
                  & ( Xs3
                    = ( append @ A @ Us2 @ ( cons @ A @ A3 @ Vs2 ) ) )
                  & ( Ys2
                    = ( append @ A @ Us2 @ ( cons @ A @ B3 @ Ws ) ) ) ) ) ) ) ) ).

% lexordp_iff
thf(fact_7214_lexordp__append__left__rightI,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [X: A,Y: A,Us: list @ A,Xs: list @ A,Ys3: list @ A] :
          ( ( ord_less @ A @ X @ Y )
         => ( ord_lexordp @ A @ ( append @ A @ Us @ ( cons @ A @ X @ Xs ) ) @ ( append @ A @ Us @ ( cons @ A @ Y @ Ys3 ) ) ) ) ) ).

% lexordp_append_left_rightI
thf(fact_7215_ord__class_Olexordp__def,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ( ( ord_lexordp @ A )
        = ( complete_lattice_lfp @ ( ( list @ A ) > ( list @ A ) > $o )
          @ ^ [P5: ( list @ A ) > ( list @ A ) > $o,X16: list @ A,X24: list @ A] :
              ( ? [Y4: A,Ys2: list @ A] :
                  ( ( X16
                    = ( nil @ A ) )
                  & ( X24
                    = ( cons @ A @ Y4 @ Ys2 ) ) )
              | ? [X2: A,Y4: A,Xs3: list @ A,Ys2: list @ A] :
                  ( ( X16
                    = ( cons @ A @ X2 @ Xs3 ) )
                  & ( X24
                    = ( cons @ A @ Y4 @ Ys2 ) )
                  & ( ord_less @ A @ X2 @ Y4 ) )
              | ? [X2: A,Y4: A,Xs3: list @ A,Ys2: list @ A] :
                  ( ( X16
                    = ( cons @ A @ X2 @ Xs3 ) )
                  & ( X24
                    = ( cons @ A @ Y4 @ Ys2 ) )
                  & ~ ( ord_less @ A @ X2 @ Y4 )
                  & ~ ( ord_less @ A @ Y4 @ X2 )
                  & ( P5 @ Xs3 @ Ys2 ) ) ) ) ) ) ).

% ord_class.lexordp_def
thf(fact_7216_bounded__bilinear__def,axiom,
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B )
        & ( real_V822414075346904944vector @ C ) )
     => ( ( real_V2442710119149674383linear @ A @ B @ C )
        = ( ^ [Prod: A > B > C] :
              ( ! [A3: A,A15: A,B3: B] :
                  ( ( Prod @ ( plus_plus @ A @ A3 @ A15 ) @ B3 )
                  = ( plus_plus @ C @ ( Prod @ A3 @ B3 ) @ ( Prod @ A15 @ B3 ) ) )
              & ! [A3: A,B3: B,B11: B] :
                  ( ( Prod @ A3 @ ( plus_plus @ B @ B3 @ B11 ) )
                  = ( plus_plus @ C @ ( Prod @ A3 @ B3 ) @ ( Prod @ A3 @ B11 ) ) )
              & ! [R5: real,A3: A,B3: B] :
                  ( ( Prod @ ( real_V8093663219630862766scaleR @ A @ R5 @ A3 ) @ B3 )
                  = ( real_V8093663219630862766scaleR @ C @ R5 @ ( Prod @ A3 @ B3 ) ) )
              & ! [A3: A,R5: real,B3: B] :
                  ( ( Prod @ A3 @ ( real_V8093663219630862766scaleR @ B @ R5 @ B3 ) )
                  = ( real_V8093663219630862766scaleR @ C @ R5 @ ( Prod @ A3 @ B3 ) ) )
              & ? [K7: real] :
                ! [A3: A,B3: B] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ C @ ( Prod @ A3 @ B3 ) ) @ ( times_times @ real @ ( times_times @ real @ ( real_V7770717601297561774m_norm @ A @ A3 ) @ ( real_V7770717601297561774m_norm @ B @ B3 ) ) @ K7 ) ) ) ) ) ) ).

% bounded_bilinear_def
thf(fact_7217_bounded__bilinear_Ozero__left,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( ( real_V822414075346904944vector @ C )
        & ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [Prod2: A > B > C,B2: B] :
          ( ( real_V2442710119149674383linear @ A @ B @ C @ Prod2 )
         => ( ( Prod2 @ ( zero_zero @ A ) @ B2 )
            = ( zero_zero @ C ) ) ) ) ).

% bounded_bilinear.zero_left
thf(fact_7218_bounded__bilinear_Ozero__right,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( ( real_V822414075346904944vector @ C )
        & ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B ) )
     => ! [Prod2: A > B > C,A2: A] :
          ( ( real_V2442710119149674383linear @ A @ B @ C @ Prod2 )
         => ( ( Prod2 @ A2 @ ( zero_zero @ B ) )
            = ( zero_zero @ C ) ) ) ) ).

% bounded_bilinear.zero_right
thf(fact_7219_bounded__bilinear_Obounded,axiom,
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B )
        & ( real_V822414075346904944vector @ C ) )
     => ! [Prod2: A > B > C] :
          ( ( real_V2442710119149674383linear @ A @ B @ C @ Prod2 )
         => ? [K9: real] :
            ! [A9: A,B9: B] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ C @ ( Prod2 @ A9 @ B9 ) ) @ ( times_times @ real @ ( times_times @ real @ ( real_V7770717601297561774m_norm @ A @ A9 ) @ ( real_V7770717601297561774m_norm @ B @ B9 ) ) @ K9 ) ) ) ) ).

% bounded_bilinear.bounded
thf(fact_7220_bounded__bilinear_Otendsto__right__zero,axiom,
    ! [C: $tType,B: $tType,A: $tType,D: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B )
        & ( real_V822414075346904944vector @ C ) )
     => ! [Prod2: A > B > C,F2: D > B,F4: filter @ D,C2: A] :
          ( ( real_V2442710119149674383linear @ A @ B @ C @ Prod2 )
         => ( ( filterlim @ D @ B @ F2 @ ( topolo7230453075368039082e_nhds @ B @ ( zero_zero @ B ) ) @ F4 )
           => ( filterlim @ D @ C
              @ ^ [X2: D] : ( Prod2 @ C2 @ ( F2 @ X2 ) )
              @ ( topolo7230453075368039082e_nhds @ C @ ( zero_zero @ C ) )
              @ F4 ) ) ) ) ).

% bounded_bilinear.tendsto_right_zero
thf(fact_7221_bounded__bilinear_Otendsto__left__zero,axiom,
    ! [C: $tType,B: $tType,A: $tType,D: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B )
        & ( real_V822414075346904944vector @ C ) )
     => ! [Prod2: A > B > C,F2: D > A,F4: filter @ D,C2: B] :
          ( ( real_V2442710119149674383linear @ A @ B @ C @ Prod2 )
         => ( ( filterlim @ D @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) ) @ F4 )
           => ( filterlim @ D @ C
              @ ^ [X2: D] : ( Prod2 @ ( F2 @ X2 ) @ C2 )
              @ ( topolo7230453075368039082e_nhds @ C @ ( zero_zero @ C ) )
              @ F4 ) ) ) ) ).

% bounded_bilinear.tendsto_left_zero
thf(fact_7222_bounded__bilinear_Otendsto__zero,axiom,
    ! [C: $tType,B: $tType,A: $tType,D: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B )
        & ( real_V822414075346904944vector @ C ) )
     => ! [Prod2: A > B > C,F2: D > A,F4: filter @ D,G: D > B] :
          ( ( real_V2442710119149674383linear @ A @ B @ C @ Prod2 )
         => ( ( filterlim @ D @ A @ F2 @ ( topolo7230453075368039082e_nhds @ A @ ( zero_zero @ A ) ) @ F4 )
           => ( ( filterlim @ D @ B @ G @ ( topolo7230453075368039082e_nhds @ B @ ( zero_zero @ B ) ) @ F4 )
             => ( filterlim @ D @ C
                @ ^ [X2: D] : ( Prod2 @ ( F2 @ X2 ) @ ( G @ X2 ) )
                @ ( topolo7230453075368039082e_nhds @ C @ ( zero_zero @ C ) )
                @ F4 ) ) ) ) ) ).

% bounded_bilinear.tendsto_zero
thf(fact_7223_lfp__funpow,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [F2: A > A,N: nat] :
          ( ( order_mono @ A @ A @ F2 )
         => ( ( complete_lattice_lfp @ A @ ( compow @ ( A > A ) @ ( suc @ N ) @ F2 ) )
            = ( complete_lattice_lfp @ A @ F2 ) ) ) ) ).

% lfp_funpow
thf(fact_7224_bounded__bilinear_Ononneg__bounded,axiom,
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B )
        & ( real_V822414075346904944vector @ C ) )
     => ! [Prod2: A > B > C] :
          ( ( real_V2442710119149674383linear @ A @ B @ C @ Prod2 )
         => ? [K9: real] :
              ( ( ord_less_eq @ real @ ( zero_zero @ real ) @ K9 )
              & ! [A9: A,B9: B] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ C @ ( Prod2 @ A9 @ B9 ) ) @ ( times_times @ real @ ( times_times @ real @ ( real_V7770717601297561774m_norm @ A @ A9 ) @ ( real_V7770717601297561774m_norm @ B @ B9 ) ) @ K9 ) ) ) ) ) ).

% bounded_bilinear.nonneg_bounded
thf(fact_7225_lfp__Kleene__iter,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [F2: A > A,K: nat] :
          ( ( order_mono @ A @ A @ F2 )
         => ( ( ( compow @ ( A > A ) @ ( suc @ K ) @ F2 @ ( bot_bot @ A ) )
              = ( compow @ ( A > A ) @ K @ F2 @ ( bot_bot @ A ) ) )
           => ( ( complete_lattice_lfp @ A @ F2 )
              = ( compow @ ( A > A ) @ K @ F2 @ ( bot_bot @ A ) ) ) ) ) ) ).

% lfp_Kleene_iter
thf(fact_7226_bounded__bilinear_Opos__bounded,axiom,
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B )
        & ( real_V822414075346904944vector @ C ) )
     => ! [Prod2: A > B > C] :
          ( ( real_V2442710119149674383linear @ A @ B @ C @ Prod2 )
         => ? [K9: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ K9 )
              & ! [A9: A,B9: B] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ C @ ( Prod2 @ A9 @ B9 ) ) @ ( times_times @ real @ ( times_times @ real @ ( real_V7770717601297561774m_norm @ A @ A9 ) @ ( real_V7770717601297561774m_norm @ B @ B9 ) ) @ K9 ) ) ) ) ) ).

% bounded_bilinear.pos_bounded
thf(fact_7227_bounded__bilinear_Ointro,axiom,
    ! [C: $tType,B: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ A )
        & ( real_V822414075346904944vector @ B )
        & ( real_V822414075346904944vector @ C ) )
     => ! [Prod2: A > B > C] :
          ( ! [A5: A,A11: A,B4: B] :
              ( ( Prod2 @ ( plus_plus @ A @ A5 @ A11 ) @ B4 )
              = ( plus_plus @ C @ ( Prod2 @ A5 @ B4 ) @ ( Prod2 @ A11 @ B4 ) ) )
         => ( ! [A5: A,B4: B,B10: B] :
                ( ( Prod2 @ A5 @ ( plus_plus @ B @ B4 @ B10 ) )
                = ( plus_plus @ C @ ( Prod2 @ A5 @ B4 ) @ ( Prod2 @ A5 @ B10 ) ) )
           => ( ! [R: real,A5: A,B4: B] :
                  ( ( Prod2 @ ( real_V8093663219630862766scaleR @ A @ R @ A5 ) @ B4 )
                  = ( real_V8093663219630862766scaleR @ C @ R @ ( Prod2 @ A5 @ B4 ) ) )
             => ( ! [A5: A,R: real,B4: B] :
                    ( ( Prod2 @ A5 @ ( real_V8093663219630862766scaleR @ B @ R @ B4 ) )
                    = ( real_V8093663219630862766scaleR @ C @ R @ ( Prod2 @ A5 @ B4 ) ) )
               => ( ? [K8: real] :
                    ! [A5: A,B4: B] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ C @ ( Prod2 @ A5 @ B4 ) ) @ ( times_times @ real @ ( times_times @ real @ ( real_V7770717601297561774m_norm @ A @ A5 ) @ ( real_V7770717601297561774m_norm @ B @ B4 ) ) @ K8 ) )
                 => ( real_V2442710119149674383linear @ A @ B @ C @ Prod2 ) ) ) ) ) ) ) ).

% bounded_bilinear.intro
thf(fact_7228_lfp__ordinal__induct,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [F2: A > A,P: A > $o] :
          ( ( order_mono @ A @ A @ F2 )
         => ( ! [S4: A] :
                ( ( P @ S4 )
               => ( ( ord_less_eq @ A @ S4 @ ( complete_lattice_lfp @ A @ F2 ) )
                 => ( P @ ( F2 @ S4 ) ) ) )
           => ( ! [M10: set @ A] :
                  ( ! [X5: A] :
                      ( ( member @ A @ X5 @ M10 )
                     => ( P @ X5 ) )
                 => ( P @ ( complete_Sup_Sup @ A @ M10 ) ) )
             => ( P @ ( complete_lattice_lfp @ A @ F2 ) ) ) ) ) ) ).

% lfp_ordinal_induct
thf(fact_7229_def__lfp__induct,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A4: A,F2: A > A,P: A] :
          ( ( A4
            = ( complete_lattice_lfp @ A @ F2 ) )
         => ( ( order_mono @ A @ A @ F2 )
           => ( ( ord_less_eq @ A @ ( F2 @ ( inf_inf @ A @ A4 @ P ) ) @ P )
             => ( ord_less_eq @ A @ A4 @ P ) ) ) ) ) ).

% def_lfp_induct
thf(fact_7230_le__rel__bool__arg__iff,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ( ( ord_less_eq @ ( $o > A ) )
        = ( ^ [X8: $o > A,Y8: $o > A] :
              ( ( ord_less_eq @ A @ ( X8 @ $false ) @ ( Y8 @ $false ) )
              & ( ord_less_eq @ A @ ( X8 @ $true ) @ ( Y8 @ $true ) ) ) ) ) ) ).

% le_rel_bool_arg_iff
thf(fact_7231_lfp__greatest,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [F2: A > A,A4: A] :
          ( ! [U4: A] :
              ( ( ord_less_eq @ A @ ( F2 @ U4 ) @ U4 )
             => ( ord_less_eq @ A @ A4 @ U4 ) )
         => ( ord_less_eq @ A @ A4 @ ( complete_lattice_lfp @ A @ F2 ) ) ) ) ).

% lfp_greatest
thf(fact_7232_lfp__lowerbound,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [F2: A > A,A4: A] :
          ( ( ord_less_eq @ A @ ( F2 @ A4 ) @ A4 )
         => ( ord_less_eq @ A @ ( complete_lattice_lfp @ A @ F2 ) @ A4 ) ) ) ).

% lfp_lowerbound
thf(fact_7233_lfp__mono,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [F2: A > A,G: A > A] :
          ( ! [Z9: A] : ( ord_less_eq @ A @ ( F2 @ Z9 ) @ ( G @ Z9 ) )
         => ( ord_less_eq @ A @ ( complete_lattice_lfp @ A @ F2 ) @ ( complete_lattice_lfp @ A @ G ) ) ) ) ).

% lfp_mono
thf(fact_7234_lfp__lfp,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [F2: A > A > A] :
          ( ! [X3: A,Y5: A,W2: A,Z3: A] :
              ( ( ord_less_eq @ A @ X3 @ Y5 )
             => ( ( ord_less_eq @ A @ W2 @ Z3 )
               => ( ord_less_eq @ A @ ( F2 @ X3 @ W2 ) @ ( F2 @ Y5 @ Z3 ) ) ) )
         => ( ( complete_lattice_lfp @ A
              @ ^ [X2: A] : ( complete_lattice_lfp @ A @ ( F2 @ X2 ) ) )
            = ( complete_lattice_lfp @ A
              @ ^ [X2: A] : ( F2 @ X2 @ X2 ) ) ) ) ) ).

% lfp_lfp
thf(fact_7235_lfp__eqI,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [F4: A > A,X: A] :
          ( ( order_mono @ A @ A @ F4 )
         => ( ( ( F4 @ X )
              = X )
           => ( ! [Z3: A] :
                  ( ( ( F4 @ Z3 )
                    = Z3 )
                 => ( ord_less_eq @ A @ X @ Z3 ) )
             => ( ( complete_lattice_lfp @ A @ F4 )
                = X ) ) ) ) ) ).

% lfp_eqI
thf(fact_7236_lfp__def,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ( ( complete_lattice_lfp @ A )
        = ( ^ [F3: A > A] :
              ( complete_Inf_Inf @ A
              @ ( collect @ A
                @ ^ [U2: A] : ( ord_less_eq @ A @ ( F3 @ U2 ) @ U2 ) ) ) ) ) ) ).

% lfp_def
thf(fact_7237_lfp__induct,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [F2: A > A,P: A] :
          ( ( order_mono @ A @ A @ F2 )
         => ( ( ord_less_eq @ A @ ( F2 @ ( inf_inf @ A @ ( complete_lattice_lfp @ A @ F2 ) @ P ) ) @ P )
           => ( ord_less_eq @ A @ ( complete_lattice_lfp @ A @ F2 ) @ P ) ) ) ) ).

% lfp_induct
thf(fact_7238_lfp__transfer__bounded,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( comple6319245703460814977attice @ B )
        & ( comple6319245703460814977attice @ A ) )
     => ! [P: A > $o,F2: A > A,Alpha: A > B,G: B > B] :
          ( ( P @ ( bot_bot @ A ) )
         => ( ! [X3: A] :
                ( ( P @ X3 )
               => ( P @ ( F2 @ X3 ) ) )
           => ( ! [M10: nat > A] :
                  ( ! [I3: nat] : ( P @ ( M10 @ I3 ) )
                 => ( P @ ( complete_Sup_Sup @ A @ ( image @ nat @ A @ M10 @ ( top_top @ ( set @ nat ) ) ) ) ) )
             => ( ! [M10: nat > A] :
                    ( ( order_mono @ nat @ A @ M10 )
                   => ( ! [I3: nat] : ( P @ ( M10 @ I3 ) )
                     => ( ( Alpha @ ( complete_Sup_Sup @ A @ ( image @ nat @ A @ M10 @ ( top_top @ ( set @ nat ) ) ) ) )
                        = ( complete_Sup_Sup @ B
                          @ ( image @ nat @ B
                            @ ^ [I4: nat] : ( Alpha @ ( M10 @ I4 ) )
                            @ ( top_top @ ( set @ nat ) ) ) ) ) ) )
               => ( ( order_sup_continuous @ A @ A @ F2 )
                 => ( ( order_sup_continuous @ B @ B @ G )
                   => ( ! [X3: A] :
                          ( ( P @ X3 )
                         => ( ( ord_less_eq @ A @ X3 @ ( complete_lattice_lfp @ A @ F2 ) )
                           => ( ( Alpha @ ( F2 @ X3 ) )
                              = ( G @ ( Alpha @ X3 ) ) ) ) )
                     => ( ! [X3: B] : ( ord_less_eq @ B @ ( Alpha @ ( bot_bot @ A ) ) @ ( G @ X3 ) )
                       => ( ( Alpha @ ( complete_lattice_lfp @ A @ F2 ) )
                          = ( complete_lattice_lfp @ B @ G ) ) ) ) ) ) ) ) ) ) ) ).

% lfp_transfer_bounded
thf(fact_7239_cSUP__UNION,axiom,
    ! [B: $tType,D: $tType,C: $tType] :
      ( ( condit1219197933456340205attice @ B )
     => ! [A4: set @ C,B7: C > ( set @ D ),F2: D > B] :
          ( ( A4
           != ( bot_bot @ ( set @ C ) ) )
         => ( ! [X3: C] :
                ( ( member @ C @ X3 @ A4 )
               => ( ( B7 @ X3 )
                 != ( bot_bot @ ( set @ D ) ) ) )
           => ( ( condit941137186595557371_above @ B
                @ ( complete_Sup_Sup @ ( set @ B )
                  @ ( image @ C @ ( set @ B )
                    @ ^ [X2: C] : ( image @ D @ B @ F2 @ ( B7 @ X2 ) )
                    @ A4 ) ) )
             => ( ( complete_Sup_Sup @ B @ ( image @ D @ B @ F2 @ ( complete_Sup_Sup @ ( set @ D ) @ ( image @ C @ ( set @ D ) @ B7 @ A4 ) ) ) )
                = ( complete_Sup_Sup @ B
                  @ ( image @ C @ B
                    @ ^ [X2: C] : ( complete_Sup_Sup @ B @ ( image @ D @ B @ F2 @ ( B7 @ X2 ) ) )
                    @ A4 ) ) ) ) ) ) ) ).

% cSUP_UNION
thf(fact_7240_bdd__above__top,axiom,
    ! [A: $tType] :
      ( ( order_top @ A )
     => ! [A4: set @ A] : ( condit941137186595557371_above @ A @ A4 ) ) ).

% bdd_above_top
thf(fact_7241_bdd__above_OI,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A4: set @ A,M5: A] :
          ( ! [X3: A] :
              ( ( member @ A @ X3 @ A4 )
             => ( ord_less_eq @ A @ X3 @ M5 ) )
         => ( condit941137186595557371_above @ A @ A4 ) ) ) ).

% bdd_above.I
thf(fact_7242_bdd__above__empty,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ( condit941137186595557371_above @ A @ ( bot_bot @ ( set @ A ) ) ) ) ).

% bdd_above_empty
thf(fact_7243_bdd__above__insert,axiom,
    ! [A: $tType] :
      ( ( lattice @ A )
     => ! [A2: A,A4: set @ A] :
          ( ( condit941137186595557371_above @ A @ ( insert @ A @ A2 @ A4 ) )
          = ( condit941137186595557371_above @ A @ A4 ) ) ) ).

% bdd_above_insert
thf(fact_7244_bdd__above__Icc,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A2: A,B2: A] : ( condit941137186595557371_above @ A @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) ) ) ).

% bdd_above_Icc
thf(fact_7245_bdd__above__Un,axiom,
    ! [A: $tType] :
      ( ( lattice @ A )
     => ! [A4: set @ A,B7: set @ A] :
          ( ( condit941137186595557371_above @ A @ ( sup_sup @ ( set @ A ) @ A4 @ B7 ) )
          = ( ( condit941137186595557371_above @ A @ A4 )
            & ( condit941137186595557371_above @ A @ B7 ) ) ) ) ).

% bdd_above_Un
thf(fact_7246_bdd__above__Ico,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A2: A,B2: A] : ( condit941137186595557371_above @ A @ ( set_or7035219750837199246ssThan @ A @ A2 @ B2 ) ) ) ).

% bdd_above_Ico
thf(fact_7247_bdd__above__Iio,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [B2: A] : ( condit941137186595557371_above @ A @ ( set_ord_lessThan @ A @ B2 ) ) ) ).

% bdd_above_Iio
thf(fact_7248_bdd__above__Iic,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [B2: A] : ( condit941137186595557371_above @ A @ ( set_ord_atMost @ A @ B2 ) ) ) ).

% bdd_above_Iic
thf(fact_7249_bdd__above__Ioo,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A2: A,B2: A] : ( condit941137186595557371_above @ A @ ( set_or5935395276787703475ssThan @ A @ A2 @ B2 ) ) ) ).

% bdd_above_Ioo
thf(fact_7250_bdd__above__Ioc,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A2: A,B2: A] : ( condit941137186595557371_above @ A @ ( set_or3652927894154168847AtMost @ A @ A2 @ B2 ) ) ) ).

% bdd_above_Ioc
thf(fact_7251_bdd__above__image__sup,axiom,
    ! [A: $tType,B: $tType] :
      ( ( lattice @ A )
     => ! [F2: B > A,G: B > A,A4: set @ B] :
          ( ( condit941137186595557371_above @ A
            @ ( image @ B @ A
              @ ^ [X2: B] : ( sup_sup @ A @ ( F2 @ X2 ) @ ( G @ X2 ) )
              @ A4 ) )
          = ( ( condit941137186595557371_above @ A @ ( image @ B @ A @ F2 @ A4 ) )
            & ( condit941137186595557371_above @ A @ ( image @ B @ A @ G @ A4 ) ) ) ) ) ).

% bdd_above_image_sup
thf(fact_7252_bdd__above__UN,axiom,
    ! [A: $tType,B: $tType] :
      ( ( lattice @ A )
     => ! [I5: set @ B,A4: B > ( set @ A )] :
          ( ( finite_finite @ B @ I5 )
         => ( ( condit941137186595557371_above @ A @ ( complete_Sup_Sup @ ( set @ A ) @ ( image @ B @ ( set @ A ) @ A4 @ I5 ) ) )
            = ( ! [X2: B] :
                  ( ( member @ B @ X2 @ I5 )
                 => ( condit941137186595557371_above @ A @ ( A4 @ X2 ) ) ) ) ) ) ) ).

% bdd_above_UN
thf(fact_7253_bdd__above__nat,axiom,
    ( ( condit941137186595557371_above @ nat )
    = ( finite_finite @ nat ) ) ).

% bdd_above_nat
thf(fact_7254_bdd__above__finite,axiom,
    ! [A: $tType] :
      ( ( lattice @ A )
     => ! [A4: set @ A] :
          ( ( finite_finite @ A @ A4 )
         => ( condit941137186595557371_above @ A @ A4 ) ) ) ).

% bdd_above_finite
thf(fact_7255_bdd__above__image__mono,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( order @ A )
        & ( order @ B ) )
     => ! [F2: A > B,A4: set @ A] :
          ( ( order_mono @ A @ B @ F2 )
         => ( ( condit941137186595557371_above @ A @ A4 )
           => ( condit941137186595557371_above @ B @ ( image @ A @ B @ F2 @ A4 ) ) ) ) ) ).

% bdd_above_image_mono
thf(fact_7256_cSup__upper,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [X: A,X7: set @ A] :
          ( ( member @ A @ X @ X7 )
         => ( ( condit941137186595557371_above @ A @ X7 )
           => ( ord_less_eq @ A @ X @ ( complete_Sup_Sup @ A @ X7 ) ) ) ) ) ).

% cSup_upper
thf(fact_7257_cSup__upper2,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [X: A,X7: set @ A,Y: A] :
          ( ( member @ A @ X @ X7 )
         => ( ( ord_less_eq @ A @ Y @ X )
           => ( ( condit941137186595557371_above @ A @ X7 )
             => ( ord_less_eq @ A @ Y @ ( complete_Sup_Sup @ A @ X7 ) ) ) ) ) ) ).

% cSup_upper2
thf(fact_7258_bdd__above_OI2,axiom,
    ! [A: $tType,B: $tType] :
      ( ( preorder @ A )
     => ! [A4: set @ B,F2: B > A,M5: A] :
          ( ! [X3: B] :
              ( ( member @ B @ X3 @ A4 )
             => ( ord_less_eq @ A @ ( F2 @ X3 ) @ M5 ) )
         => ( condit941137186595557371_above @ A @ ( image @ B @ A @ F2 @ A4 ) ) ) ) ).

% bdd_above.I2
thf(fact_7259_bdd__above__mono,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [B7: set @ A,A4: set @ A] :
          ( ( condit941137186595557371_above @ A @ B7 )
         => ( ( ord_less_eq @ ( set @ A ) @ A4 @ B7 )
           => ( condit941137186595557371_above @ A @ A4 ) ) ) ) ).

% bdd_above_mono
thf(fact_7260_bdd__above_OE,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A4: set @ A] :
          ( ( condit941137186595557371_above @ A @ A4 )
         => ~ ! [M10: A] :
                ~ ! [X5: A] :
                    ( ( member @ A @ X5 @ A4 )
                   => ( ord_less_eq @ A @ X5 @ M10 ) ) ) ) ).

% bdd_above.E
thf(fact_7261_bdd__above_Ounfold,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ( ( condit941137186595557371_above @ A )
        = ( ^ [A7: set @ A] :
            ? [M8: A] :
            ! [X2: A] :
              ( ( member @ A @ X2 @ A7 )
             => ( ord_less_eq @ A @ X2 @ M8 ) ) ) ) ) ).

% bdd_above.unfold
thf(fact_7262_bdd__above__Int2,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [B7: set @ A,A4: set @ A] :
          ( ( condit941137186595557371_above @ A @ B7 )
         => ( condit941137186595557371_above @ A @ ( inf_inf @ ( set @ A ) @ A4 @ B7 ) ) ) ) ).

% bdd_above_Int2
thf(fact_7263_bdd__above__Int1,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A4: set @ A,B7: set @ A] :
          ( ( condit941137186595557371_above @ A @ A4 )
         => ( condit941137186595557371_above @ A @ ( inf_inf @ ( set @ A ) @ A4 @ B7 ) ) ) ) ).

% bdd_above_Int1
thf(fact_7264_cSUP__upper2,axiom,
    ! [A: $tType,B: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [F2: B > A,A4: set @ B,X: B,U: A] :
          ( ( condit941137186595557371_above @ A @ ( image @ B @ A @ F2 @ A4 ) )
         => ( ( member @ B @ X @ A4 )
           => ( ( ord_less_eq @ A @ U @ ( F2 @ X ) )
             => ( ord_less_eq @ A @ U @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F2 @ A4 ) ) ) ) ) ) ) ).

% cSUP_upper2
thf(fact_7265_cSUP__upper,axiom,
    ! [A: $tType,B: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [X: B,A4: set @ B,F2: B > A] :
          ( ( member @ B @ X @ A4 )
         => ( ( condit941137186595557371_above @ A @ ( image @ B @ A @ F2 @ A4 ) )
           => ( ord_less_eq @ A @ ( F2 @ X ) @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F2 @ A4 ) ) ) ) ) ) ).

% cSUP_upper
thf(fact_7266_cSup__mono,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [B7: set @ A,A4: set @ A] :
          ( ( B7
           != ( bot_bot @ ( set @ A ) ) )
         => ( ( condit941137186595557371_above @ A @ A4 )
           => ( ! [B4: A] :
                  ( ( member @ A @ B4 @ B7 )
                 => ? [X5: A] :
                      ( ( member @ A @ X5 @ A4 )
                      & ( ord_less_eq @ A @ B4 @ X5 ) ) )
             => ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ B7 ) @ ( complete_Sup_Sup @ A @ A4 ) ) ) ) ) ) ).

% cSup_mono
thf(fact_7267_cSup__le__iff,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [S: set @ A,A2: A] :
          ( ( S
           != ( bot_bot @ ( set @ A ) ) )
         => ( ( condit941137186595557371_above @ A @ S )
           => ( ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ S ) @ A2 )
              = ( ! [X2: A] :
                    ( ( member @ A @ X2 @ S )
                   => ( ord_less_eq @ A @ X2 @ A2 ) ) ) ) ) ) ) ).

% cSup_le_iff
thf(fact_7268_less__cSup__iff,axiom,
    ! [A: $tType] :
      ( ( condit6923001295902523014norder @ A )
     => ! [X7: set @ A,Y: A] :
          ( ( X7
           != ( bot_bot @ ( set @ A ) ) )
         => ( ( condit941137186595557371_above @ A @ X7 )
           => ( ( ord_less @ A @ Y @ ( complete_Sup_Sup @ A @ X7 ) )
              = ( ? [X2: A] :
                    ( ( member @ A @ X2 @ X7 )
                    & ( ord_less @ A @ Y @ X2 ) ) ) ) ) ) ) ).

% less_cSup_iff
thf(fact_7269_cSUP__lessD,axiom,
    ! [B: $tType,A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [F2: B > A,A4: set @ B,Y: A,I: B] :
          ( ( condit941137186595557371_above @ A @ ( image @ B @ A @ F2 @ A4 ) )
         => ( ( ord_less @ A @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F2 @ A4 ) ) @ Y )
           => ( ( member @ B @ I @ A4 )
             => ( ord_less @ A @ ( F2 @ I ) @ Y ) ) ) ) ) ).

% cSUP_lessD
thf(fact_7270_lfp__transfer,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( comple6319245703460814977attice @ B )
        & ( comple6319245703460814977attice @ A ) )
     => ! [Alpha: A > B,F2: A > A,G: B > B] :
          ( ( order_sup_continuous @ A @ B @ Alpha )
         => ( ( order_sup_continuous @ A @ A @ F2 )
           => ( ( order_sup_continuous @ B @ B @ G )
             => ( ! [X3: B] : ( ord_less_eq @ B @ ( Alpha @ ( bot_bot @ A ) ) @ ( G @ X3 ) )
               => ( ! [X3: A] :
                      ( ( ord_less_eq @ A @ X3 @ ( complete_lattice_lfp @ A @ F2 ) )
                     => ( ( Alpha @ ( F2 @ X3 ) )
                        = ( G @ ( Alpha @ X3 ) ) ) )
                 => ( ( Alpha @ ( complete_lattice_lfp @ A @ F2 ) )
                    = ( complete_lattice_lfp @ B @ G ) ) ) ) ) ) ) ) ).

% lfp_transfer
thf(fact_7271_cSUP__mono,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [A4: set @ B,G: C > A,B7: set @ C,F2: B > A] :
          ( ( A4
           != ( bot_bot @ ( set @ B ) ) )
         => ( ( condit941137186595557371_above @ A @ ( image @ C @ A @ G @ B7 ) )
           => ( ! [N2: B] :
                  ( ( member @ B @ N2 @ A4 )
                 => ? [X5: C] :
                      ( ( member @ C @ X5 @ B7 )
                      & ( ord_less_eq @ A @ ( F2 @ N2 ) @ ( G @ X5 ) ) ) )
             => ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F2 @ A4 ) ) @ ( complete_Sup_Sup @ A @ ( image @ C @ A @ G @ B7 ) ) ) ) ) ) ) ).

% cSUP_mono
thf(fact_7272_cSUP__le__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [A4: set @ B,F2: B > A,U: A] :
          ( ( A4
           != ( bot_bot @ ( set @ B ) ) )
         => ( ( condit941137186595557371_above @ A @ ( image @ B @ A @ F2 @ A4 ) )
           => ( ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F2 @ A4 ) ) @ U )
              = ( ! [X2: B] :
                    ( ( member @ B @ X2 @ A4 )
                   => ( ord_less_eq @ A @ ( F2 @ X2 ) @ U ) ) ) ) ) ) ) ).

% cSUP_le_iff
thf(fact_7273_cSup__subset__mono,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [A4: set @ A,B7: set @ A] :
          ( ( A4
           != ( bot_bot @ ( set @ A ) ) )
         => ( ( condit941137186595557371_above @ A @ B7 )
           => ( ( ord_less_eq @ ( set @ A ) @ A4 @ B7 )
             => ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ A4 ) @ ( complete_Sup_Sup @ A @ B7 ) ) ) ) ) ) ).

% cSup_subset_mono
thf(fact_7274_cSup__insert__If,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [X7: set @ A,A2: A] :
          ( ( condit941137186595557371_above @ A @ X7 )
         => ( ( ( X7
                = ( bot_bot @ ( set @ A ) ) )
             => ( ( complete_Sup_Sup @ A @ ( insert @ A @ A2 @ X7 ) )
                = A2 ) )
            & ( ( X7
               != ( bot_bot @ ( set @ A ) ) )
             => ( ( complete_Sup_Sup @ A @ ( insert @ A @ A2 @ X7 ) )
                = ( sup_sup @ A @ A2 @ ( complete_Sup_Sup @ A @ X7 ) ) ) ) ) ) ) ).

% cSup_insert_If
thf(fact_7275_cSup__insert,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [X7: set @ A,A2: A] :
          ( ( X7
           != ( bot_bot @ ( set @ A ) ) )
         => ( ( condit941137186595557371_above @ A @ X7 )
           => ( ( complete_Sup_Sup @ A @ ( insert @ A @ A2 @ X7 ) )
              = ( sup_sup @ A @ A2 @ ( complete_Sup_Sup @ A @ X7 ) ) ) ) ) ) ).

% cSup_insert
thf(fact_7276_cSup__union__distrib,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [A4: set @ A,B7: set @ A] :
          ( ( A4
           != ( bot_bot @ ( set @ A ) ) )
         => ( ( condit941137186595557371_above @ A @ A4 )
           => ( ( B7
               != ( bot_bot @ ( set @ A ) ) )
             => ( ( condit941137186595557371_above @ A @ B7 )
               => ( ( complete_Sup_Sup @ A @ ( sup_sup @ ( set @ A ) @ A4 @ B7 ) )
                  = ( sup_sup @ A @ ( complete_Sup_Sup @ A @ A4 ) @ ( complete_Sup_Sup @ A @ B7 ) ) ) ) ) ) ) ) ).

% cSup_union_distrib
thf(fact_7277_less__cSUP__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( condit6923001295902523014norder @ A )
     => ! [A4: set @ B,F2: B > A,A2: A] :
          ( ( A4
           != ( bot_bot @ ( set @ B ) ) )
         => ( ( condit941137186595557371_above @ A @ ( image @ B @ A @ F2 @ A4 ) )
           => ( ( ord_less @ A @ A2 @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F2 @ A4 ) ) )
              = ( ? [X2: B] :
                    ( ( member @ B @ X2 @ A4 )
                    & ( ord_less @ A @ A2 @ ( F2 @ X2 ) ) ) ) ) ) ) ) ).

% less_cSUP_iff
thf(fact_7278_conditionally__complete__lattice__class_OSUP__sup__distrib,axiom,
    ! [A: $tType,B: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [A4: set @ B,F2: B > A,G: B > A] :
          ( ( A4
           != ( bot_bot @ ( set @ B ) ) )
         => ( ( condit941137186595557371_above @ A @ ( image @ B @ A @ F2 @ A4 ) )
           => ( ( condit941137186595557371_above @ A @ ( image @ B @ A @ G @ A4 ) )
             => ( ( sup_sup @ A @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F2 @ A4 ) ) @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ G @ A4 ) ) )
                = ( complete_Sup_Sup @ A
                  @ ( image @ B @ A
                    @ ^ [A3: B] : ( sup_sup @ A @ ( F2 @ A3 ) @ ( G @ A3 ) )
                    @ A4 ) ) ) ) ) ) ) ).

% conditionally_complete_lattice_class.SUP_sup_distrib
thf(fact_7279_cSUP__subset__mono,axiom,
    ! [A: $tType,B: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [A4: set @ B,G: B > A,B7: set @ B,F2: B > A] :
          ( ( A4
           != ( bot_bot @ ( set @ B ) ) )
         => ( ( condit941137186595557371_above @ A @ ( image @ B @ A @ G @ B7 ) )
           => ( ( ord_less_eq @ ( set @ B ) @ A4 @ B7 )
             => ( ! [X3: B] :
                    ( ( member @ B @ X3 @ A4 )
                   => ( ord_less_eq @ A @ ( F2 @ X3 ) @ ( G @ X3 ) ) )
               => ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F2 @ A4 ) ) @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ G @ B7 ) ) ) ) ) ) ) ) ).

% cSUP_subset_mono
thf(fact_7280_cSup__inter__less__eq,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [A4: set @ A,B7: set @ A] :
          ( ( condit941137186595557371_above @ A @ A4 )
         => ( ( condit941137186595557371_above @ A @ B7 )
           => ( ( ( inf_inf @ ( set @ A ) @ A4 @ B7 )
               != ( bot_bot @ ( set @ A ) ) )
             => ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ ( inf_inf @ ( set @ A ) @ A4 @ B7 ) ) @ ( sup_sup @ A @ ( complete_Sup_Sup @ A @ A4 ) @ ( complete_Sup_Sup @ A @ B7 ) ) ) ) ) ) ) ).

% cSup_inter_less_eq
thf(fact_7281_cSUP__insert,axiom,
    ! [A: $tType,B: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [A4: set @ B,F2: B > A,A2: B] :
          ( ( A4
           != ( bot_bot @ ( set @ B ) ) )
         => ( ( condit941137186595557371_above @ A @ ( image @ B @ A @ F2 @ A4 ) )
           => ( ( complete_Sup_Sup @ A @ ( image @ B @ A @ F2 @ ( insert @ B @ A2 @ A4 ) ) )
              = ( sup_sup @ A @ ( F2 @ A2 ) @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F2 @ A4 ) ) ) ) ) ) ) ).

% cSUP_insert
thf(fact_7282_cSUP__union,axiom,
    ! [A: $tType,B: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [A4: set @ B,F2: B > A,B7: set @ B] :
          ( ( A4
           != ( bot_bot @ ( set @ B ) ) )
         => ( ( condit941137186595557371_above @ A @ ( image @ B @ A @ F2 @ A4 ) )
           => ( ( B7
               != ( bot_bot @ ( set @ B ) ) )
             => ( ( condit941137186595557371_above @ A @ ( image @ B @ A @ F2 @ B7 ) )
               => ( ( complete_Sup_Sup @ A @ ( image @ B @ A @ F2 @ ( sup_sup @ ( set @ B ) @ A4 @ B7 ) ) )
                  = ( sup_sup @ A @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F2 @ A4 ) ) @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F2 @ B7 ) ) ) ) ) ) ) ) ) ).

% cSUP_union
thf(fact_7283_cSup__cInf,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [S: set @ A] :
          ( ( S
           != ( bot_bot @ ( set @ A ) ) )
         => ( ( condit941137186595557371_above @ A @ S )
           => ( ( complete_Sup_Sup @ A @ S )
              = ( complete_Inf_Inf @ A
                @ ( collect @ A
                  @ ^ [X2: A] :
                    ! [Y4: A] :
                      ( ( member @ A @ Y4 @ S )
                     => ( ord_less_eq @ A @ Y4 @ X2 ) ) ) ) ) ) ) ) ).

% cSup_cInf
thf(fact_7284_mono__cSUP,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( ( condit1219197933456340205attice @ A )
        & ( condit1219197933456340205attice @ B ) )
     => ! [F2: A > B,A4: C > A,I5: set @ C] :
          ( ( order_mono @ A @ B @ F2 )
         => ( ( condit941137186595557371_above @ A @ ( image @ C @ A @ A4 @ I5 ) )
           => ( ( I5
               != ( bot_bot @ ( set @ C ) ) )
             => ( ord_less_eq @ B
                @ ( complete_Sup_Sup @ B
                  @ ( image @ C @ B
                    @ ^ [X2: C] : ( F2 @ ( A4 @ X2 ) )
                    @ I5 ) )
                @ ( F2 @ ( complete_Sup_Sup @ A @ ( image @ C @ A @ A4 @ I5 ) ) ) ) ) ) ) ) ).

% mono_cSUP
thf(fact_7285_mono__cSup,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( condit1219197933456340205attice @ A )
        & ( condit1219197933456340205attice @ B ) )
     => ! [F2: A > B,A4: set @ A] :
          ( ( order_mono @ A @ B @ F2 )
         => ( ( condit941137186595557371_above @ A @ A4 )
           => ( ( A4
               != ( bot_bot @ ( set @ A ) ) )
             => ( ord_less_eq @ B @ ( complete_Sup_Sup @ B @ ( image @ A @ B @ F2 @ A4 ) ) @ ( F2 @ ( complete_Sup_Sup @ A @ A4 ) ) ) ) ) ) ) ).

% mono_cSup
thf(fact_7286_cINF__UNION,axiom,
    ! [B: $tType,D: $tType,C: $tType] :
      ( ( condit1219197933456340205attice @ B )
     => ! [A4: set @ C,B7: C > ( set @ D ),F2: D > B] :
          ( ( A4
           != ( bot_bot @ ( set @ C ) ) )
         => ( ! [X3: C] :
                ( ( member @ C @ X3 @ A4 )
               => ( ( B7 @ X3 )
                 != ( bot_bot @ ( set @ D ) ) ) )
           => ( ( condit1013018076250108175_below @ B
                @ ( complete_Sup_Sup @ ( set @ B )
                  @ ( image @ C @ ( set @ B )
                    @ ^ [X2: C] : ( image @ D @ B @ F2 @ ( B7 @ X2 ) )
                    @ A4 ) ) )
             => ( ( complete_Inf_Inf @ B @ ( image @ D @ B @ F2 @ ( complete_Sup_Sup @ ( set @ D ) @ ( image @ C @ ( set @ D ) @ B7 @ A4 ) ) ) )
                = ( complete_Inf_Inf @ B
                  @ ( image @ C @ B
                    @ ^ [X2: C] : ( complete_Inf_Inf @ B @ ( image @ D @ B @ F2 @ ( B7 @ X2 ) ) )
                    @ A4 ) ) ) ) ) ) ) ).

% cINF_UNION
thf(fact_7287_mono__cINF,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( ( condit1219197933456340205attice @ A )
        & ( condit1219197933456340205attice @ B ) )
     => ! [F2: A > B,A4: C > A,I5: set @ C] :
          ( ( order_mono @ A @ B @ F2 )
         => ( ( condit1013018076250108175_below @ A @ ( image @ C @ A @ A4 @ I5 ) )
           => ( ( I5
               != ( bot_bot @ ( set @ C ) ) )
             => ( ord_less_eq @ B @ ( F2 @ ( complete_Inf_Inf @ A @ ( image @ C @ A @ A4 @ I5 ) ) )
                @ ( complete_Inf_Inf @ B
                  @ ( image @ C @ B
                    @ ^ [X2: C] : ( F2 @ ( A4 @ X2 ) )
                    @ I5 ) ) ) ) ) ) ) ).

% mono_cINF
thf(fact_7288_bdd__below__bot,axiom,
    ! [A: $tType] :
      ( ( order_bot @ A )
     => ! [A4: set @ A] : ( condit1013018076250108175_below @ A @ A4 ) ) ).

% bdd_below_bot
thf(fact_7289_bdd__belowI,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A4: set @ A,M: A] :
          ( ! [X3: A] :
              ( ( member @ A @ X3 @ A4 )
             => ( ord_less_eq @ A @ M @ X3 ) )
         => ( condit1013018076250108175_below @ A @ A4 ) ) ) ).

% bdd_belowI
thf(fact_7290_bdd__below_OI,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A4: set @ A,M5: A] :
          ( ! [X3: A] :
              ( ( member @ A @ X3 @ A4 )
             => ( ord_less_eq @ A @ M5 @ X3 ) )
         => ( condit1013018076250108175_below @ A @ A4 ) ) ) ).

% bdd_below.I
thf(fact_7291_bdd__below__empty,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ( condit1013018076250108175_below @ A @ ( bot_bot @ ( set @ A ) ) ) ) ).

% bdd_below_empty
thf(fact_7292_bdd__below__insert,axiom,
    ! [A: $tType] :
      ( ( lattice @ A )
     => ! [A2: A,A4: set @ A] :
          ( ( condit1013018076250108175_below @ A @ ( insert @ A @ A2 @ A4 ) )
          = ( condit1013018076250108175_below @ A @ A4 ) ) ) ).

% bdd_below_insert
thf(fact_7293_bdd__below__Icc,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A2: A,B2: A] : ( condit1013018076250108175_below @ A @ ( set_or1337092689740270186AtMost @ A @ A2 @ B2 ) ) ) ).

% bdd_below_Icc
thf(fact_7294_bdd__below__Un,axiom,
    ! [A: $tType] :
      ( ( lattice @ A )
     => ! [A4: set @ A,B7: set @ A] :
          ( ( condit1013018076250108175_below @ A @ ( sup_sup @ ( set @ A ) @ A4 @ B7 ) )
          = ( ( condit1013018076250108175_below @ A @ A4 )
            & ( condit1013018076250108175_below @ A @ B7 ) ) ) ) ).

% bdd_below_Un
thf(fact_7295_bdd__below__Ico,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A2: A,B2: A] : ( condit1013018076250108175_below @ A @ ( set_or7035219750837199246ssThan @ A @ A2 @ B2 ) ) ) ).

% bdd_below_Ico
thf(fact_7296_bdd__below__Ioi,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A2: A] : ( condit1013018076250108175_below @ A @ ( set_ord_greaterThan @ A @ A2 ) ) ) ).

% bdd_below_Ioi
thf(fact_7297_bdd__below__Ioo,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A2: A,B2: A] : ( condit1013018076250108175_below @ A @ ( set_or5935395276787703475ssThan @ A @ A2 @ B2 ) ) ) ).

% bdd_below_Ioo
thf(fact_7298_bdd__below__Ioc,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A2: A,B2: A] : ( condit1013018076250108175_below @ A @ ( set_or3652927894154168847AtMost @ A @ A2 @ B2 ) ) ) ).

% bdd_below_Ioc
thf(fact_7299_bdd__below__Ici,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A2: A] : ( condit1013018076250108175_below @ A @ ( set_ord_atLeast @ A @ A2 ) ) ) ).

% bdd_below_Ici
thf(fact_7300_bdd__below__image__inf,axiom,
    ! [A: $tType,B: $tType] :
      ( ( lattice @ A )
     => ! [F2: B > A,G: B > A,A4: set @ B] :
          ( ( condit1013018076250108175_below @ A
            @ ( image @ B @ A
              @ ^ [X2: B] : ( inf_inf @ A @ ( F2 @ X2 ) @ ( G @ X2 ) )
              @ A4 ) )
          = ( ( condit1013018076250108175_below @ A @ ( image @ B @ A @ F2 @ A4 ) )
            & ( condit1013018076250108175_below @ A @ ( image @ B @ A @ G @ A4 ) ) ) ) ) ).

% bdd_below_image_inf
thf(fact_7301_bdd__above__uminus,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [X7: set @ A] :
          ( ( condit941137186595557371_above @ A @ ( image @ A @ A @ ( uminus_uminus @ A ) @ X7 ) )
          = ( condit1013018076250108175_below @ A @ X7 ) ) ) ).

% bdd_above_uminus
thf(fact_7302_bdd__below__uminus,axiom,
    ! [A: $tType] :
      ( ( ordered_ab_group_add @ A )
     => ! [X7: set @ A] :
          ( ( condit1013018076250108175_below @ A @ ( image @ A @ A @ ( uminus_uminus @ A ) @ X7 ) )
          = ( condit941137186595557371_above @ A @ X7 ) ) ) ).

% bdd_below_uminus
thf(fact_7303_bdd__below__UN,axiom,
    ! [A: $tType,B: $tType] :
      ( ( lattice @ A )
     => ! [I5: set @ B,A4: B > ( set @ A )] :
          ( ( finite_finite @ B @ I5 )
         => ( ( condit1013018076250108175_below @ A @ ( complete_Sup_Sup @ ( set @ A ) @ ( image @ B @ ( set @ A ) @ A4 @ I5 ) ) )
            = ( ! [X2: B] :
                  ( ( member @ B @ X2 @ I5 )
                 => ( condit1013018076250108175_below @ A @ ( A4 @ X2 ) ) ) ) ) ) ) ).

% bdd_below_UN
thf(fact_7304_bdd__belowI2,axiom,
    ! [A: $tType,B: $tType] :
      ( ( preorder @ A )
     => ! [A4: set @ B,M: A,F2: B > A] :
          ( ! [X3: B] :
              ( ( member @ B @ X3 @ A4 )
             => ( ord_less_eq @ A @ M @ ( F2 @ X3 ) ) )
         => ( condit1013018076250108175_below @ A @ ( image @ B @ A @ F2 @ A4 ) ) ) ) ).

% bdd_belowI2
thf(fact_7305_bdd__below_OI2,axiom,
    ! [A: $tType,B: $tType] :
      ( ( preorder @ A )
     => ! [A4: set @ B,M5: A,F2: B > A] :
          ( ! [X3: B] :
              ( ( member @ B @ X3 @ A4 )
             => ( ord_less_eq @ A @ M5 @ ( F2 @ X3 ) ) )
         => ( condit1013018076250108175_below @ A @ ( image @ B @ A @ F2 @ A4 ) ) ) ) ).

% bdd_below.I2
thf(fact_7306_cInf__lower2,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [X: A,X7: set @ A,Y: A] :
          ( ( member @ A @ X @ X7 )
         => ( ( ord_less_eq @ A @ X @ Y )
           => ( ( condit1013018076250108175_below @ A @ X7 )
             => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ X7 ) @ Y ) ) ) ) ) ).

% cInf_lower2
thf(fact_7307_cInf__lower,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [X: A,X7: set @ A] :
          ( ( member @ A @ X @ X7 )
         => ( ( condit1013018076250108175_below @ A @ X7 )
           => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ X7 ) @ X ) ) ) ) ).

% cInf_lower
thf(fact_7308_bdd__below__mono,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [B7: set @ A,A4: set @ A] :
          ( ( condit1013018076250108175_below @ A @ B7 )
         => ( ( ord_less_eq @ ( set @ A ) @ A4 @ B7 )
           => ( condit1013018076250108175_below @ A @ A4 ) ) ) ) ).

% bdd_below_mono
thf(fact_7309_bdd__below_OE,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A4: set @ A] :
          ( ( condit1013018076250108175_below @ A @ A4 )
         => ~ ! [M10: A] :
                ~ ! [X5: A] :
                    ( ( member @ A @ X5 @ A4 )
                   => ( ord_less_eq @ A @ M10 @ X5 ) ) ) ) ).

% bdd_below.E
thf(fact_7310_bdd__below_Ounfold,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ( ( condit1013018076250108175_below @ A )
        = ( ^ [A7: set @ A] :
            ? [M8: A] :
            ! [X2: A] :
              ( ( member @ A @ X2 @ A7 )
             => ( ord_less_eq @ A @ M8 @ X2 ) ) ) ) ) ).

% bdd_below.unfold
thf(fact_7311_bdd__below__Int1,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [A4: set @ A,B7: set @ A] :
          ( ( condit1013018076250108175_below @ A @ A4 )
         => ( condit1013018076250108175_below @ A @ ( inf_inf @ ( set @ A ) @ A4 @ B7 ) ) ) ) ).

% bdd_below_Int1
thf(fact_7312_bdd__below__Int2,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ! [B7: set @ A,A4: set @ A] :
          ( ( condit1013018076250108175_below @ A @ B7 )
         => ( condit1013018076250108175_below @ A @ ( inf_inf @ ( set @ A ) @ A4 @ B7 ) ) ) ) ).

% bdd_below_Int2
thf(fact_7313_bdd__below__image__mono,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( order @ A )
        & ( order @ B ) )
     => ! [F2: A > B,A4: set @ A] :
          ( ( order_mono @ A @ B @ F2 )
         => ( ( condit1013018076250108175_below @ A @ A4 )
           => ( condit1013018076250108175_below @ B @ ( image @ A @ B @ F2 @ A4 ) ) ) ) ) ).

% bdd_below_image_mono
thf(fact_7314_bdd__below__finite,axiom,
    ! [A: $tType] :
      ( ( lattice @ A )
     => ! [A4: set @ A] :
          ( ( finite_finite @ A @ A4 )
         => ( condit1013018076250108175_below @ A @ A4 ) ) ) ).

% bdd_below_finite
thf(fact_7315_cINF__lower2,axiom,
    ! [B: $tType,A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [F2: B > A,A4: set @ B,X: B,U: A] :
          ( ( condit1013018076250108175_below @ A @ ( image @ B @ A @ F2 @ A4 ) )
         => ( ( member @ B @ X @ A4 )
           => ( ( ord_less_eq @ A @ ( F2 @ X ) @ U )
             => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ F2 @ A4 ) ) @ U ) ) ) ) ) ).

% cINF_lower2
thf(fact_7316_cINF__lower,axiom,
    ! [A: $tType,B: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [F2: B > A,A4: set @ B,X: B] :
          ( ( condit1013018076250108175_below @ A @ ( image @ B @ A @ F2 @ A4 ) )
         => ( ( member @ B @ X @ A4 )
           => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ F2 @ A4 ) ) @ ( F2 @ X ) ) ) ) ) ).

% cINF_lower
thf(fact_7317_le__cInf__iff,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [S: set @ A,A2: A] :
          ( ( S
           != ( bot_bot @ ( set @ A ) ) )
         => ( ( condit1013018076250108175_below @ A @ S )
           => ( ( ord_less_eq @ A @ A2 @ ( complete_Inf_Inf @ A @ S ) )
              = ( ! [X2: A] :
                    ( ( member @ A @ X2 @ S )
                   => ( ord_less_eq @ A @ A2 @ X2 ) ) ) ) ) ) ) ).

% le_cInf_iff
thf(fact_7318_cInf__mono,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [B7: set @ A,A4: set @ A] :
          ( ( B7
           != ( bot_bot @ ( set @ A ) ) )
         => ( ( condit1013018076250108175_below @ A @ A4 )
           => ( ! [B4: A] :
                  ( ( member @ A @ B4 @ B7 )
                 => ? [X5: A] :
                      ( ( member @ A @ X5 @ A4 )
                      & ( ord_less_eq @ A @ X5 @ B4 ) ) )
             => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ A4 ) @ ( complete_Inf_Inf @ A @ B7 ) ) ) ) ) ) ).

% cInf_mono
thf(fact_7319_cInf__less__iff,axiom,
    ! [A: $tType] :
      ( ( condit6923001295902523014norder @ A )
     => ! [X7: set @ A,Y: A] :
          ( ( X7
           != ( bot_bot @ ( set @ A ) ) )
         => ( ( condit1013018076250108175_below @ A @ X7 )
           => ( ( ord_less @ A @ ( complete_Inf_Inf @ A @ X7 ) @ Y )
              = ( ? [X2: A] :
                    ( ( member @ A @ X2 @ X7 )
                    & ( ord_less @ A @ X2 @ Y ) ) ) ) ) ) ) ).

% cInf_less_iff
thf(fact_7320_bdd__below__image__antimono,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( order @ A )
        & ( order @ B ) )
     => ! [F2: A > B,A4: set @ A] :
          ( ( order_antimono @ A @ B @ F2 )
         => ( ( condit941137186595557371_above @ A @ A4 )
           => ( condit1013018076250108175_below @ B @ ( image @ A @ B @ F2 @ A4 ) ) ) ) ) ).

% bdd_below_image_antimono
thf(fact_7321_bdd__above__image__antimono,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( order @ A )
        & ( order @ B ) )
     => ! [F2: A > B,A4: set @ A] :
          ( ( order_antimono @ A @ B @ F2 )
         => ( ( condit1013018076250108175_below @ A @ A4 )
           => ( condit941137186595557371_above @ B @ ( image @ A @ B @ F2 @ A4 ) ) ) ) ) ).

% bdd_above_image_antimono
thf(fact_7322_less__cINF__D,axiom,
    ! [A: $tType,B: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [F2: B > A,A4: set @ B,Y: A,I: B] :
          ( ( condit1013018076250108175_below @ A @ ( image @ B @ A @ F2 @ A4 ) )
         => ( ( ord_less @ A @ Y @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ F2 @ A4 ) ) )
           => ( ( member @ B @ I @ A4 )
             => ( ord_less @ A @ Y @ ( F2 @ I ) ) ) ) ) ) ).

% less_cINF_D
thf(fact_7323_cINF__mono,axiom,
    ! [C: $tType,A: $tType,B: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [B7: set @ B,F2: C > A,A4: set @ C,G: B > A] :
          ( ( B7
           != ( bot_bot @ ( set @ B ) ) )
         => ( ( condit1013018076250108175_below @ A @ ( image @ C @ A @ F2 @ A4 ) )
           => ( ! [M4: B] :
                  ( ( member @ B @ M4 @ B7 )
                 => ? [X5: C] :
                      ( ( member @ C @ X5 @ A4 )
                      & ( ord_less_eq @ A @ ( F2 @ X5 ) @ ( G @ M4 ) ) ) )
             => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ ( image @ C @ A @ F2 @ A4 ) ) @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ G @ B7 ) ) ) ) ) ) ) ).

% cINF_mono
thf(fact_7324_le__cINF__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [A4: set @ B,F2: B > A,U: A] :
          ( ( A4
           != ( bot_bot @ ( set @ B ) ) )
         => ( ( condit1013018076250108175_below @ A @ ( image @ B @ A @ F2 @ A4 ) )
           => ( ( ord_less_eq @ A @ U @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ F2 @ A4 ) ) )
              = ( ! [X2: B] :
                    ( ( member @ B @ X2 @ A4 )
                   => ( ord_less_eq @ A @ U @ ( F2 @ X2 ) ) ) ) ) ) ) ) ).

% le_cINF_iff
thf(fact_7325_cInf__superset__mono,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [A4: set @ A,B7: set @ A] :
          ( ( A4
           != ( bot_bot @ ( set @ A ) ) )
         => ( ( condit1013018076250108175_below @ A @ B7 )
           => ( ( ord_less_eq @ ( set @ A ) @ A4 @ B7 )
             => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ B7 ) @ ( complete_Inf_Inf @ A @ A4 ) ) ) ) ) ) ).

% cInf_superset_mono
thf(fact_7326_cInf__insert,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [X7: set @ A,A2: A] :
          ( ( X7
           != ( bot_bot @ ( set @ A ) ) )
         => ( ( condit1013018076250108175_below @ A @ X7 )
           => ( ( complete_Inf_Inf @ A @ ( insert @ A @ A2 @ X7 ) )
              = ( inf_inf @ A @ A2 @ ( complete_Inf_Inf @ A @ X7 ) ) ) ) ) ) ).

% cInf_insert
thf(fact_7327_cInf__insert__If,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [X7: set @ A,A2: A] :
          ( ( condit1013018076250108175_below @ A @ X7 )
         => ( ( ( X7
                = ( bot_bot @ ( set @ A ) ) )
             => ( ( complete_Inf_Inf @ A @ ( insert @ A @ A2 @ X7 ) )
                = A2 ) )
            & ( ( X7
               != ( bot_bot @ ( set @ A ) ) )
             => ( ( complete_Inf_Inf @ A @ ( insert @ A @ A2 @ X7 ) )
                = ( inf_inf @ A @ A2 @ ( complete_Inf_Inf @ A @ X7 ) ) ) ) ) ) ) ).

% cInf_insert_If
thf(fact_7328_cInf__union__distrib,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [A4: set @ A,B7: set @ A] :
          ( ( A4
           != ( bot_bot @ ( set @ A ) ) )
         => ( ( condit1013018076250108175_below @ A @ A4 )
           => ( ( B7
               != ( bot_bot @ ( set @ A ) ) )
             => ( ( condit1013018076250108175_below @ A @ B7 )
               => ( ( complete_Inf_Inf @ A @ ( sup_sup @ ( set @ A ) @ A4 @ B7 ) )
                  = ( inf_inf @ A @ ( complete_Inf_Inf @ A @ A4 ) @ ( complete_Inf_Inf @ A @ B7 ) ) ) ) ) ) ) ) ).

% cInf_union_distrib
thf(fact_7329_cINF__less__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( condit6923001295902523014norder @ A )
     => ! [A4: set @ B,F2: B > A,A2: A] :
          ( ( A4
           != ( bot_bot @ ( set @ B ) ) )
         => ( ( condit1013018076250108175_below @ A @ ( image @ B @ A @ F2 @ A4 ) )
           => ( ( ord_less @ A @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ F2 @ A4 ) ) @ A2 )
              = ( ? [X2: B] :
                    ( ( member @ B @ X2 @ A4 )
                    & ( ord_less @ A @ ( F2 @ X2 ) @ A2 ) ) ) ) ) ) ) ).

% cINF_less_iff
thf(fact_7330_cINF__inf__distrib,axiom,
    ! [A: $tType,B: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [A4: set @ B,F2: B > A,G: B > A] :
          ( ( A4
           != ( bot_bot @ ( set @ B ) ) )
         => ( ( condit1013018076250108175_below @ A @ ( image @ B @ A @ F2 @ A4 ) )
           => ( ( condit1013018076250108175_below @ A @ ( image @ B @ A @ G @ A4 ) )
             => ( ( inf_inf @ A @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ F2 @ A4 ) ) @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ G @ A4 ) ) )
                = ( complete_Inf_Inf @ A
                  @ ( image @ B @ A
                    @ ^ [A3: B] : ( inf_inf @ A @ ( F2 @ A3 ) @ ( G @ A3 ) )
                    @ A4 ) ) ) ) ) ) ) ).

% cINF_inf_distrib
thf(fact_7331_cSUP__eq__cINF__D,axiom,
    ! [B: $tType,C: $tType] :
      ( ( condit1219197933456340205attice @ B )
     => ! [F2: C > B,A4: set @ C,A2: C] :
          ( ( ( complete_Sup_Sup @ B @ ( image @ C @ B @ F2 @ A4 ) )
            = ( complete_Inf_Inf @ B @ ( image @ C @ B @ F2 @ A4 ) ) )
         => ( ( condit941137186595557371_above @ B @ ( image @ C @ B @ F2 @ A4 ) )
           => ( ( condit1013018076250108175_below @ B @ ( image @ C @ B @ F2 @ A4 ) )
             => ( ( member @ C @ A2 @ A4 )
               => ( ( F2 @ A2 )
                  = ( complete_Inf_Inf @ B @ ( image @ C @ B @ F2 @ A4 ) ) ) ) ) ) ) ) ).

% cSUP_eq_cINF_D
thf(fact_7332_cINF__superset__mono,axiom,
    ! [A: $tType,B: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [A4: set @ B,G: B > A,B7: set @ B,F2: B > A] :
          ( ( A4
           != ( bot_bot @ ( set @ B ) ) )
         => ( ( condit1013018076250108175_below @ A @ ( image @ B @ A @ G @ B7 ) )
           => ( ( ord_less_eq @ ( set @ B ) @ A4 @ B7 )
             => ( ! [X3: B] :
                    ( ( member @ B @ X3 @ B7 )
                   => ( ord_less_eq @ A @ ( G @ X3 ) @ ( F2 @ X3 ) ) )
               => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ G @ B7 ) ) @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ F2 @ A4 ) ) ) ) ) ) ) ) ).

% cINF_superset_mono
thf(fact_7333_less__eq__cInf__inter,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [A4: set @ A,B7: set @ A] :
          ( ( condit1013018076250108175_below @ A @ A4 )
         => ( ( condit1013018076250108175_below @ A @ B7 )
           => ( ( ( inf_inf @ ( set @ A ) @ A4 @ B7 )
               != ( bot_bot @ ( set @ A ) ) )
             => ( ord_less_eq @ A @ ( inf_inf @ A @ ( complete_Inf_Inf @ A @ A4 ) @ ( complete_Inf_Inf @ A @ B7 ) ) @ ( complete_Inf_Inf @ A @ ( inf_inf @ ( set @ A ) @ A4 @ B7 ) ) ) ) ) ) ) ).

% less_eq_cInf_inter
thf(fact_7334_cINF__insert,axiom,
    ! [A: $tType,B: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [A4: set @ B,F2: B > A,A2: B] :
          ( ( A4
           != ( bot_bot @ ( set @ B ) ) )
         => ( ( condit1013018076250108175_below @ A @ ( image @ B @ A @ F2 @ A4 ) )
           => ( ( complete_Inf_Inf @ A @ ( image @ B @ A @ F2 @ ( insert @ B @ A2 @ A4 ) ) )
              = ( inf_inf @ A @ ( F2 @ A2 ) @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ F2 @ A4 ) ) ) ) ) ) ) ).

% cINF_insert
thf(fact_7335_cINF__union,axiom,
    ! [A: $tType,B: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [A4: set @ B,F2: B > A,B7: set @ B] :
          ( ( A4
           != ( bot_bot @ ( set @ B ) ) )
         => ( ( condit1013018076250108175_below @ A @ ( image @ B @ A @ F2 @ A4 ) )
           => ( ( B7
               != ( bot_bot @ ( set @ B ) ) )
             => ( ( condit1013018076250108175_below @ A @ ( image @ B @ A @ F2 @ B7 ) )
               => ( ( complete_Inf_Inf @ A @ ( image @ B @ A @ F2 @ ( sup_sup @ ( set @ B ) @ A4 @ B7 ) ) )
                  = ( inf_inf @ A @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ F2 @ A4 ) ) @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ F2 @ B7 ) ) ) ) ) ) ) ) ) ).

% cINF_union
thf(fact_7336_cInf__le__cSup,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [A4: set @ A] :
          ( ( A4
           != ( bot_bot @ ( set @ A ) ) )
         => ( ( condit941137186595557371_above @ A @ A4 )
           => ( ( condit1013018076250108175_below @ A @ A4 )
             => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ A4 ) @ ( complete_Sup_Sup @ A @ A4 ) ) ) ) ) ) ).

% cInf_le_cSup
thf(fact_7337_cInf__cSup,axiom,
    ! [A: $tType] :
      ( ( condit1219197933456340205attice @ A )
     => ! [S: set @ A] :
          ( ( S
           != ( bot_bot @ ( set @ A ) ) )
         => ( ( condit1013018076250108175_below @ A @ S )
           => ( ( complete_Inf_Inf @ A @ S )
              = ( complete_Sup_Sup @ A
                @ ( collect @ A
                  @ ^ [X2: A] :
                    ! [Y4: A] :
                      ( ( member @ A @ Y4 @ S )
                     => ( ord_less_eq @ A @ X2 @ Y4 ) ) ) ) ) ) ) ) ).

% cInf_cSup
thf(fact_7338_mono__cInf,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( condit1219197933456340205attice @ A )
        & ( condit1219197933456340205attice @ B ) )
     => ! [F2: A > B,A4: set @ A] :
          ( ( order_mono @ A @ B @ F2 )
         => ( ( condit1013018076250108175_below @ A @ A4 )
           => ( ( A4
               != ( bot_bot @ ( set @ A ) ) )
             => ( ord_less_eq @ B @ ( F2 @ ( complete_Inf_Inf @ A @ A4 ) ) @ ( complete_Inf_Inf @ B @ ( image @ A @ B @ F2 @ A4 ) ) ) ) ) ) ) ).

% mono_cInf
thf(fact_7339_Max_Osemilattice__order__set__axioms,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( lattic4895041142388067077er_set @ A @ ( ord_max @ A )
        @ ^ [X2: A,Y4: A] : ( ord_less_eq @ A @ Y4 @ X2 )
        @ ^ [X2: A,Y4: A] : ( ord_less @ A @ Y4 @ X2 ) ) ) ).

% Max.semilattice_order_set_axioms
thf(fact_7340_Gcd__fin__def,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ( ( semiring_gcd_Gcd_fin @ A )
        = ( bounde2362111253966948842tice_F @ A @ ( gcd_gcd @ A ) @ ( zero_zero @ A ) @ ( one_one @ A ) ) ) ) ).

% Gcd_fin_def
thf(fact_7341_Inf__fin_Osemilattice__order__set__axioms,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ( lattic4895041142388067077er_set @ A @ ( inf_inf @ A ) @ ( ord_less_eq @ A ) @ ( ord_less @ A ) ) ) ).

% Inf_fin.semilattice_order_set_axioms
thf(fact_7342_Min_Osemilattice__order__set__axioms,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( lattic4895041142388067077er_set @ A @ ( ord_min @ A ) @ ( ord_less_eq @ A ) @ ( ord_less @ A ) ) ) ).

% Min.semilattice_order_set_axioms
thf(fact_7343_Sup__fin_Osemilattice__order__set__axioms,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ( lattic4895041142388067077er_set @ A @ ( sup_sup @ A )
        @ ^ [X2: A,Y4: A] : ( ord_less_eq @ A @ Y4 @ X2 )
        @ ^ [X2: A,Y4: A] : ( ord_less @ A @ Y4 @ X2 ) ) ) ).

% Sup_fin.semilattice_order_set_axioms
thf(fact_7344_compute__powr__real,axiom,
    ( powr_real
    = ( ^ [B3: real,I4: real] :
          ( if @ real @ ( ord_less_eq @ real @ B3 @ ( zero_zero @ real ) )
          @ ( abort @ real @ ( literal2 @ $false @ $false @ $false @ $false @ $true @ $true @ $true @ ( literal2 @ $true @ $true @ $true @ $true @ $false @ $true @ $true @ ( literal2 @ $true @ $true @ $true @ $false @ $true @ $true @ $true @ ( literal2 @ $false @ $true @ $false @ $false @ $true @ $true @ $true @ ( literal2 @ $true @ $true @ $true @ $true @ $true @ $false @ $true @ ( literal2 @ $false @ $true @ $false @ $false @ $true @ $true @ $true @ ( literal2 @ $true @ $false @ $true @ $false @ $false @ $true @ $true @ ( literal2 @ $true @ $false @ $false @ $false @ $false @ $true @ $true @ ( literal2 @ $false @ $false @ $true @ $true @ $false @ $true @ $true @ ( literal2 @ $false @ $false @ $false @ $false @ $false @ $true @ $false @ ( literal2 @ $true @ $true @ $true @ $false @ $true @ $true @ $true @ ( literal2 @ $true @ $false @ $false @ $true @ $false @ $true @ $true @ ( literal2 @ $false @ $false @ $true @ $false @ $true @ $true @ $true @ ( literal2 @ $false @ $false @ $false @ $true @ $false @ $true @ $true @ ( literal2 @ $false @ $false @ $false @ $false @ $false @ $true @ $false @ ( literal2 @ $false @ $true @ $true @ $true @ $false @ $true @ $true @ ( literal2 @ $true @ $true @ $true @ $true @ $false @ $true @ $true @ ( literal2 @ $false @ $true @ $true @ $true @ $false @ $true @ $true @ ( literal2 @ $false @ $false @ $false @ $false @ $true @ $true @ $true @ ( literal2 @ $true @ $true @ $true @ $true @ $false @ $true @ $true @ ( literal2 @ $true @ $true @ $false @ $false @ $true @ $true @ $true @ ( literal2 @ $true @ $false @ $false @ $true @ $false @ $true @ $true @ ( literal2 @ $false @ $false @ $true @ $false @ $true @ $true @ $true @ ( literal2 @ $true @ $false @ $false @ $true @ $false @ $true @ $true @ ( literal2 @ $false @ $true @ $true @ $false @ $true @ $true @ $true @ ( literal2 @ $true @ $false @ $true @ $false @ $false @ $true @ $true @ ( literal2 @ $false @ $false @ $false @ $false @ $false @ $true @ $false @ ( literal2 @ $false @ $true @ $false @ $false @ $false @ $true @ $true @ ( literal2 @ $true @ $false @ $false @ $false @ $false @ $true @ $true @ ( literal2 @ $true @ $true @ $false @ $false @ $true @ $true @ $true @ ( literal2 @ $true @ $false @ $true @ $false @ $false @ $true @ $true @ ( zero_zero @ literal ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) )
            @ ^ [Uu3: product_unit] : ( powr_real @ B3 @ I4 ) )
          @ ( if @ real
            @ ( ( ring_1_of_int @ real @ ( archim6421214686448440834_floor @ real @ I4 ) )
              = I4 )
            @ ( if @ real @ ( ord_less_eq @ real @ ( zero_zero @ real ) @ I4 ) @ ( power_power @ real @ B3 @ ( nat2 @ ( archim6421214686448440834_floor @ real @ I4 ) ) ) @ ( divide_divide @ real @ ( one_one @ real ) @ ( power_power @ real @ B3 @ ( nat2 @ ( archim6421214686448440834_floor @ real @ ( uminus_uminus @ real @ I4 ) ) ) ) ) )
            @ ( abort @ real @ ( literal2 @ $false @ $false @ $false @ $false @ $true @ $true @ $true @ ( literal2 @ $true @ $true @ $true @ $true @ $false @ $true @ $true @ ( literal2 @ $true @ $true @ $true @ $false @ $true @ $true @ $true @ ( literal2 @ $false @ $true @ $false @ $false @ $true @ $true @ $true @ ( literal2 @ $true @ $true @ $true @ $true @ $true @ $false @ $true @ ( literal2 @ $false @ $true @ $false @ $false @ $true @ $true @ $true @ ( literal2 @ $true @ $false @ $true @ $false @ $false @ $true @ $true @ ( literal2 @ $true @ $false @ $false @ $false @ $false @ $true @ $true @ ( literal2 @ $false @ $false @ $true @ $true @ $false @ $true @ $true @ ( literal2 @ $false @ $false @ $false @ $false @ $false @ $true @ $false @ ( literal2 @ $true @ $true @ $true @ $false @ $true @ $true @ $true @ ( literal2 @ $true @ $false @ $false @ $true @ $false @ $true @ $true @ ( literal2 @ $false @ $false @ $true @ $false @ $true @ $true @ $true @ ( literal2 @ $false @ $false @ $false @ $true @ $false @ $true @ $true @ ( literal2 @ $false @ $false @ $false @ $false @ $false @ $true @ $false @ ( literal2 @ $false @ $true @ $true @ $true @ $false @ $true @ $true @ ( literal2 @ $true @ $true @ $true @ $true @ $false @ $true @ $true @ ( literal2 @ $false @ $true @ $true @ $true @ $false @ $true @ $true @ ( literal2 @ $true @ $false @ $true @ $true @ $false @ $true @ $false @ ( literal2 @ $true @ $false @ $false @ $true @ $false @ $true @ $true @ ( literal2 @ $false @ $true @ $true @ $true @ $false @ $true @ $true @ ( literal2 @ $false @ $false @ $true @ $false @ $true @ $true @ $true @ ( literal2 @ $true @ $false @ $true @ $false @ $false @ $true @ $true @ ( literal2 @ $true @ $true @ $true @ $false @ $false @ $true @ $true @ ( literal2 @ $true @ $false @ $true @ $false @ $false @ $true @ $true @ ( literal2 @ $false @ $true @ $false @ $false @ $true @ $true @ $true @ ( literal2 @ $false @ $false @ $false @ $false @ $false @ $true @ $false @ ( literal2 @ $true @ $false @ $true @ $false @ $false @ $true @ $true @ ( literal2 @ $false @ $false @ $false @ $true @ $true @ $true @ $true @ ( literal2 @ $false @ $false @ $false @ $false @ $true @ $true @ $true @ ( literal2 @ $true @ $true @ $true @ $true @ $false @ $true @ $true @ ( literal2 @ $false @ $true @ $true @ $true @ $false @ $true @ $true @ ( literal2 @ $true @ $false @ $true @ $false @ $false @ $true @ $true @ ( literal2 @ $false @ $true @ $true @ $true @ $false @ $true @ $true @ ( literal2 @ $false @ $false @ $true @ $false @ $true @ $true @ $true @ ( zero_zero @ literal ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) )
              @ ^ [Uu3: product_unit] : ( powr_real @ B3 @ I4 ) ) ) ) ) ) ).

% compute_powr_real
thf(fact_7345_integer__of__nat_Orep__eq,axiom,
    ! [X: nat] :
      ( ( code_int_of_integer @ ( code_integer_of_nat @ X ) )
      = ( semiring_1_of_nat @ int @ X ) ) ).

% integer_of_nat.rep_eq
thf(fact_7346_int__of__integer__integer__of__nat,axiom,
    ! [N: nat] :
      ( ( code_int_of_integer @ ( code_integer_of_nat @ N ) )
      = ( semiring_1_of_nat @ int @ N ) ) ).

% int_of_integer_integer_of_nat
thf(fact_7347_String_Oempty__neq__Literal,axiom,
    ! [B0: $o,B1: $o,B22: $o,B32: $o,B42: $o,B52: $o,B62: $o,S2: literal] :
      ( ( zero_zero @ literal )
     != ( literal2 @ B0 @ B1 @ B22 @ B32 @ B42 @ B52 @ B62 @ S2 ) ) ).

% String.empty_neq_Literal
thf(fact_7348_integer__of__nat__0,axiom,
    ( ( code_integer_of_nat @ ( zero_zero @ nat ) )
    = ( zero_zero @ code_integer ) ) ).

% integer_of_nat_0
thf(fact_7349_integer__of__nat_Oabs__eq,axiom,
    ( code_integer_of_nat
    = ( ^ [X2: nat] : ( code_integer_of_int @ ( semiring_1_of_nat @ int @ X2 ) ) ) ) ).

% integer_of_nat.abs_eq
thf(fact_7350_integer__of__nat__numeral,axiom,
    ! [N: num] :
      ( ( code_integer_of_nat @ ( numeral_numeral @ nat @ N ) )
      = ( numeral_numeral @ code_integer @ N ) ) ).

% integer_of_nat_numeral
thf(fact_7351_divmod__nat__code,axiom,
    ( divmod_nat
    = ( ^ [M3: nat,N3: nat] :
          ( product_map_prod @ code_integer @ nat @ code_integer @ nat @ code_nat_of_integer @ code_nat_of_integer
          @ ( if @ ( product_prod @ code_integer @ code_integer )
            @ ( ( code_integer_of_nat @ M3 )
              = ( zero_zero @ code_integer ) )
            @ ( product_Pair @ code_integer @ code_integer @ ( zero_zero @ code_integer ) @ ( zero_zero @ code_integer ) )
            @ ( if @ ( product_prod @ code_integer @ code_integer )
              @ ( ( code_integer_of_nat @ N3 )
                = ( zero_zero @ code_integer ) )
              @ ( product_Pair @ code_integer @ code_integer @ ( zero_zero @ code_integer ) @ ( code_integer_of_nat @ M3 ) )
              @ ( code_divmod_abs @ ( code_integer_of_nat @ M3 ) @ ( code_integer_of_nat @ N3 ) ) ) ) ) ) ) ).

% divmod_nat_code
thf(fact_7352_integer__of__nat__def,axiom,
    ( code_integer_of_nat
    = ( map_fun @ nat @ nat @ int @ code_integer @ ( id @ nat ) @ code_integer_of_int @ ( semiring_1_of_nat @ int ) ) ) ).

% integer_of_nat_def
thf(fact_7353_uniformity__Abort,axiom,
    ! [A: $tType] :
      ( ( topolo4638772830378233104ormity @ A )
     => ( ( topolo7806501430040627800ormity @ A )
        = ( abstract_filter @ ( product_prod @ A @ A )
          @ ^ [U2: product_unit] :
              ( abort @ ( filter @ ( product_prod @ A @ A ) ) @ ( literal2 @ $true @ $false @ $true @ $false @ $true @ $true @ $true @ ( literal2 @ $false @ $true @ $true @ $true @ $false @ $true @ $true @ ( literal2 @ $true @ $false @ $false @ $true @ $false @ $true @ $true @ ( literal2 @ $false @ $true @ $true @ $false @ $false @ $true @ $true @ ( literal2 @ $true @ $true @ $true @ $true @ $false @ $true @ $true @ ( literal2 @ $false @ $true @ $false @ $false @ $true @ $true @ $true @ ( literal2 @ $true @ $false @ $true @ $true @ $false @ $true @ $true @ ( literal2 @ $true @ $false @ $false @ $true @ $false @ $true @ $true @ ( literal2 @ $false @ $false @ $true @ $false @ $true @ $true @ $true @ ( literal2 @ $true @ $false @ $false @ $true @ $true @ $true @ $true @ ( literal2 @ $false @ $false @ $false @ $false @ $false @ $true @ $false @ ( literal2 @ $true @ $false @ $false @ $true @ $false @ $true @ $true @ ( literal2 @ $true @ $true @ $false @ $false @ $true @ $true @ $true @ ( literal2 @ $false @ $false @ $false @ $false @ $false @ $true @ $false @ ( literal2 @ $false @ $true @ $true @ $true @ $false @ $true @ $true @ ( literal2 @ $true @ $true @ $true @ $true @ $false @ $true @ $true @ ( literal2 @ $false @ $false @ $true @ $false @ $true @ $true @ $true @ ( literal2 @ $false @ $false @ $false @ $false @ $false @ $true @ $false @ ( literal2 @ $true @ $false @ $true @ $false @ $false @ $true @ $true @ ( literal2 @ $false @ $false @ $false @ $true @ $true @ $true @ $true @ ( literal2 @ $true @ $false @ $true @ $false @ $false @ $true @ $true @ ( literal2 @ $true @ $true @ $false @ $false @ $false @ $true @ $true @ ( literal2 @ $true @ $false @ $true @ $false @ $true @ $true @ $true @ ( literal2 @ $false @ $false @ $true @ $false @ $true @ $true @ $true @ ( literal2 @ $true @ $false @ $false @ $false @ $false @ $true @ $true @ ( literal2 @ $false @ $true @ $false @ $false @ $false @ $true @ $true @ ( literal2 @ $false @ $false @ $true @ $true @ $false @ $true @ $true @ ( literal2 @ $true @ $false @ $true @ $false @ $false @ $true @ $true @ ( zero_zero @ literal ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) )
              @ ^ [V5: product_unit] : ( topolo7806501430040627800ormity @ A ) ) ) ) ) ).

% uniformity_Abort
thf(fact_7354_length__code,axiom,
    ! [A: $tType] :
      ( ( size_size @ ( list @ A ) )
      = ( gen_length @ A @ ( zero_zero @ nat ) ) ) ).

% length_code
thf(fact_7355_pairs__le__eq__Sigma,axiom,
    ! [M: nat] :
      ( ( collect @ ( product_prod @ nat @ nat )
        @ ( product_case_prod @ nat @ nat @ $o
          @ ^ [I4: nat,J3: nat] : ( ord_less_eq @ nat @ ( plus_plus @ nat @ I4 @ J3 ) @ M ) ) )
      = ( product_Sigma @ nat @ nat @ ( set_ord_atMost @ nat @ M )
        @ ^ [R5: nat] : ( set_ord_atMost @ nat @ ( minus_minus @ nat @ M @ R5 ) ) ) ) ).

% pairs_le_eq_Sigma
thf(fact_7356_card__def,axiom,
    ! [B: $tType] :
      ( ( finite_card @ B )
      = ( finite_folding_F @ B @ nat
        @ ^ [Uu3: B] : suc
        @ ( zero_zero @ nat ) ) ) ).

% card_def
thf(fact_7357_Gcd__fin_Oeq__fold,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ( ( semiring_gcd_Gcd_fin @ A )
        = ( ^ [A7: set @ A] : ( if @ A @ ( finite_finite @ A @ A7 ) @ ( finite_fold @ A @ A @ ( gcd_gcd @ A ) @ ( zero_zero @ A ) @ A7 ) @ ( one_one @ A ) ) ) ) ) ).

% Gcd_fin.eq_fold
thf(fact_7358_less__than__iff,axiom,
    ! [X: nat,Y: nat] :
      ( ( member @ ( product_prod @ nat @ nat ) @ ( product_Pair @ nat @ nat @ X @ Y ) @ less_than )
      = ( ord_less @ nat @ X @ Y ) ) ).

% less_than_iff
thf(fact_7359_card_Oeq__fold,axiom,
    ! [A: $tType] :
      ( ( finite_card @ A )
      = ( finite_fold @ A @ nat
        @ ^ [Uu3: A] : suc
        @ ( zero_zero @ nat ) ) ) ).

% card.eq_fold
thf(fact_7360_sum_Oeq__fold,axiom,
    ! [A: $tType,B: $tType] :
      ( ( comm_monoid_add @ A )
     => ( ( groups7311177749621191930dd_sum @ B @ A )
        = ( ^ [G2: B > A] : ( finite_fold @ B @ A @ ( comp @ A @ ( A > A ) @ B @ ( plus_plus @ A ) @ G2 ) @ ( zero_zero @ A ) ) ) ) ) ).

% sum.eq_fold
thf(fact_7361_Inf__fin_Oeq__fold,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A4: set @ A,X: A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( lattic7752659483105999362nf_fin @ A @ ( insert @ A @ X @ A4 ) )
            = ( finite_fold @ A @ A @ ( inf_inf @ A ) @ X @ A4 ) ) ) ) ).

% Inf_fin.eq_fold
thf(fact_7362_Sup__fin_Oeq__fold,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A4: set @ A,X: A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( lattic5882676163264333800up_fin @ A @ ( insert @ A @ X @ A4 ) )
            = ( finite_fold @ A @ A @ ( sup_sup @ A ) @ X @ A4 ) ) ) ) ).

% Sup_fin.eq_fold
thf(fact_7363_Max_Oeq__fold,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A4: set @ A,X: A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( lattic643756798349783984er_Max @ A @ ( insert @ A @ X @ A4 ) )
            = ( finite_fold @ A @ A @ ( ord_max @ A ) @ X @ A4 ) ) ) ) ).

% Max.eq_fold
thf(fact_7364_Min_Oeq__fold,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A4: set @ A,X: A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( lattic643756798350308766er_Min @ A @ ( insert @ A @ X @ A4 ) )
            = ( finite_fold @ A @ A @ ( ord_min @ A ) @ X @ A4 ) ) ) ) ).

% Min.eq_fold
thf(fact_7365_Min_Oeq__fold_H,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( ( lattic643756798350308766er_Min @ A )
        = ( ^ [A7: set @ A] :
              ( the2 @ A
              @ ( finite_fold @ A @ ( option @ A )
                @ ^ [X2: A,Y4: option @ A] : ( some @ A @ ( case_option @ A @ A @ X2 @ ( ord_min @ A @ X2 ) @ Y4 ) )
                @ ( none @ A )
                @ A7 ) ) ) ) ) ).

% Min.eq_fold'
thf(fact_7366_Max_Oeq__fold_H,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( ( lattic643756798349783984er_Max @ A )
        = ( ^ [A7: set @ A] :
              ( the2 @ A
              @ ( finite_fold @ A @ ( option @ A )
                @ ^ [X2: A,Y4: option @ A] : ( some @ A @ ( case_option @ A @ A @ X2 @ ( ord_max @ A @ X2 ) @ Y4 ) )
                @ ( none @ A )
                @ A7 ) ) ) ) ) ).

% Max.eq_fold'
thf(fact_7367_Max_Oinfinite,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A4: set @ A] :
          ( ~ ( finite_finite @ A @ A4 )
         => ( ( lattic643756798349783984er_Max @ A @ A4 )
            = ( the2 @ A @ ( none @ A ) ) ) ) ) ).

% Max.infinite
thf(fact_7368_Min_Oinfinite,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A4: set @ A] :
          ( ~ ( finite_finite @ A @ A4 )
         => ( ( lattic643756798350308766er_Min @ A @ A4 )
            = ( the2 @ A @ ( none @ A ) ) ) ) ) ).

% Min.infinite
thf(fact_7369_Inf__fin_Oinfinite,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ! [A4: set @ A] :
          ( ~ ( finite_finite @ A @ A4 )
         => ( ( lattic7752659483105999362nf_fin @ A @ A4 )
            = ( the2 @ A @ ( none @ A ) ) ) ) ) ).

% Inf_fin.infinite
thf(fact_7370_Sup__fin_Oinfinite,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ! [A4: set @ A] :
          ( ~ ( finite_finite @ A @ A4 )
         => ( ( lattic5882676163264333800up_fin @ A @ A4 )
            = ( the2 @ A @ ( none @ A ) ) ) ) ) ).

% Sup_fin.infinite
thf(fact_7371_Inf__fin_Oeq__fold_H,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ( ( lattic7752659483105999362nf_fin @ A )
        = ( ^ [A7: set @ A] :
              ( the2 @ A
              @ ( finite_fold @ A @ ( option @ A )
                @ ^ [X2: A,Y4: option @ A] : ( some @ A @ ( case_option @ A @ A @ X2 @ ( inf_inf @ A @ X2 ) @ Y4 ) )
                @ ( none @ A )
                @ A7 ) ) ) ) ) ).

% Inf_fin.eq_fold'
thf(fact_7372_Sup__fin_Oeq__fold_H,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ( ( lattic5882676163264333800up_fin @ A )
        = ( ^ [A7: set @ A] :
              ( the2 @ A
              @ ( finite_fold @ A @ ( option @ A )
                @ ^ [X2: A,Y4: option @ A] : ( some @ A @ ( case_option @ A @ A @ X2 @ ( sup_sup @ A @ X2 ) @ Y4 ) )
                @ ( none @ A )
                @ A7 ) ) ) ) ) ).

% Sup_fin.eq_fold'
thf(fact_7373_pair__less__def,axiom,
    ( fun_pair_less
    = ( lex_prod @ nat @ nat @ less_than @ less_than ) ) ).

% pair_less_def
thf(fact_7374_elimnum,axiom,
    ! [Info: option @ ( product_prod @ nat @ nat ),Deg: nat,TreeList2: list @ vEBT_VEBT,Summary: vEBT_VEBT,N: nat] :
      ( ( vEBT_invar_vebt @ ( vEBT_Node @ Info @ Deg @ TreeList2 @ Summary ) @ N )
     => ( ( vEBT_VEBT_elim_dead @ ( vEBT_Node @ Info @ Deg @ TreeList2 @ Summary ) @ ( extended_enat2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ N ) ) )
        = ( vEBT_Node @ Info @ Deg @ TreeList2 @ Summary ) ) ) ).

% elimnum
thf(fact_7375_enat_Oinject,axiom,
    ! [Nat: nat,Nat2: nat] :
      ( ( ( extended_enat2 @ Nat )
        = ( extended_enat2 @ Nat2 ) )
      = ( Nat = Nat2 ) ) ).

% enat.inject
thf(fact_7376_enat_Osimps_I4_J,axiom,
    ! [T: $tType,F1: nat > T,F22: T,Nat: nat] :
      ( ( extended_case_enat @ T @ F1 @ F22 @ ( extended_enat2 @ Nat ) )
      = ( F1 @ Nat ) ) ).

% enat.simps(4)
thf(fact_7377_enat__ord__simps_I2_J,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ extended_enat @ ( extended_enat2 @ M ) @ ( extended_enat2 @ N ) )
      = ( ord_less @ nat @ M @ N ) ) ).

% enat_ord_simps(2)
thf(fact_7378_enat__ord__simps_I1_J,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less_eq @ extended_enat @ ( extended_enat2 @ M ) @ ( extended_enat2 @ N ) )
      = ( ord_less_eq @ nat @ M @ N ) ) ).

% enat_ord_simps(1)
thf(fact_7379_plus__enat__simps_I1_J,axiom,
    ! [M: nat,N: nat] :
      ( ( plus_plus @ extended_enat @ ( extended_enat2 @ M ) @ ( extended_enat2 @ N ) )
      = ( extended_enat2 @ ( plus_plus @ nat @ M @ N ) ) ) ).

% plus_enat_simps(1)
thf(fact_7380_idiff__enat__0__right,axiom,
    ! [N: extended_enat] :
      ( ( minus_minus @ extended_enat @ N @ ( extended_enat2 @ ( zero_zero @ nat ) ) )
      = N ) ).

% idiff_enat_0_right
thf(fact_7381_idiff__enat__0,axiom,
    ! [N: extended_enat] :
      ( ( minus_minus @ extended_enat @ ( extended_enat2 @ ( zero_zero @ nat ) ) @ N )
      = ( extended_enat2 @ ( zero_zero @ nat ) ) ) ).

% idiff_enat_0
thf(fact_7382_idiff__enat__enat,axiom,
    ! [A2: nat,B2: nat] :
      ( ( minus_minus @ extended_enat @ ( extended_enat2 @ A2 ) @ ( extended_enat2 @ B2 ) )
      = ( extended_enat2 @ ( minus_minus @ nat @ A2 @ B2 ) ) ) ).

% idiff_enat_enat
thf(fact_7383_times__enat__simps_I1_J,axiom,
    ! [M: nat,N: nat] :
      ( ( times_times @ extended_enat @ ( extended_enat2 @ M ) @ ( extended_enat2 @ N ) )
      = ( extended_enat2 @ ( times_times @ nat @ M @ N ) ) ) ).

% times_enat_simps(1)
thf(fact_7384_max__enat__simps_I1_J,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_max @ extended_enat @ ( extended_enat2 @ M ) @ ( extended_enat2 @ N ) )
      = ( extended_enat2 @ ( ord_max @ nat @ M @ N ) ) ) ).

% max_enat_simps(1)
thf(fact_7385_min__enat__simps_I1_J,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_min @ extended_enat @ ( extended_enat2 @ M ) @ ( extended_enat2 @ N ) )
      = ( extended_enat2 @ ( ord_min @ nat @ M @ N ) ) ) ).

% min_enat_simps(1)
thf(fact_7386_numeral__less__enat__iff,axiom,
    ! [M: num,N: nat] :
      ( ( ord_less @ extended_enat @ ( numeral_numeral @ extended_enat @ M ) @ ( extended_enat2 @ N ) )
      = ( ord_less @ nat @ ( numeral_numeral @ nat @ M ) @ N ) ) ).

% numeral_less_enat_iff
thf(fact_7387_numeral__le__enat__iff,axiom,
    ! [M: num,N: nat] :
      ( ( ord_less_eq @ extended_enat @ ( numeral_numeral @ extended_enat @ M ) @ ( extended_enat2 @ N ) )
      = ( ord_less_eq @ nat @ ( numeral_numeral @ nat @ M ) @ N ) ) ).

% numeral_le_enat_iff
thf(fact_7388_finite__enat__bounded,axiom,
    ! [A4: set @ extended_enat,N: nat] :
      ( ! [Y5: extended_enat] :
          ( ( member @ extended_enat @ Y5 @ A4 )
         => ( ord_less_eq @ extended_enat @ Y5 @ ( extended_enat2 @ N ) ) )
     => ( finite_finite @ extended_enat @ A4 ) ) ).

% finite_enat_bounded
thf(fact_7389_enat__ile,axiom,
    ! [N: extended_enat,M: nat] :
      ( ( ord_less_eq @ extended_enat @ N @ ( extended_enat2 @ M ) )
     => ? [K2: nat] :
          ( N
          = ( extended_enat2 @ K2 ) ) ) ).

% enat_ile
thf(fact_7390_less__enatE,axiom,
    ! [N: extended_enat,M: nat] :
      ( ( ord_less @ extended_enat @ N @ ( extended_enat2 @ M ) )
     => ~ ! [K2: nat] :
            ( ( N
              = ( extended_enat2 @ K2 ) )
           => ~ ( ord_less @ nat @ K2 @ M ) ) ) ).

% less_enatE
thf(fact_7391_enat__iless,axiom,
    ! [N: extended_enat,M: nat] :
      ( ( ord_less @ extended_enat @ N @ ( extended_enat2 @ M ) )
     => ? [K2: nat] :
          ( N
          = ( extended_enat2 @ K2 ) ) ) ).

% enat_iless
thf(fact_7392_chain__incr,axiom,
    ! [A: $tType,Y7: A > extended_enat,K: nat] :
      ( ! [I2: A] :
        ? [J4: A] : ( ord_less @ extended_enat @ ( Y7 @ I2 ) @ ( Y7 @ J4 ) )
     => ? [J2: A] : ( ord_less @ extended_enat @ ( extended_enat2 @ K ) @ ( Y7 @ J2 ) ) ) ).

% chain_incr
thf(fact_7393_numeral__eq__enat,axiom,
    ( ( numeral_numeral @ extended_enat )
    = ( ^ [K3: num] : ( extended_enat2 @ ( numeral_numeral @ nat @ K3 ) ) ) ) ).

% numeral_eq_enat
thf(fact_7394_one__enat__def,axiom,
    ( ( one_one @ extended_enat )
    = ( extended_enat2 @ ( one_one @ nat ) ) ) ).

% one_enat_def
thf(fact_7395_enat__1__iff_I1_J,axiom,
    ! [X: nat] :
      ( ( ( extended_enat2 @ X )
        = ( one_one @ extended_enat ) )
      = ( X
        = ( one_one @ nat ) ) ) ).

% enat_1_iff(1)
thf(fact_7396_enat__1__iff_I2_J,axiom,
    ! [X: nat] :
      ( ( ( one_one @ extended_enat )
        = ( extended_enat2 @ X ) )
      = ( X
        = ( one_one @ nat ) ) ) ).

% enat_1_iff(2)
thf(fact_7397_of__nat__eq__enat,axiom,
    ( ( semiring_1_of_nat @ extended_enat )
    = extended_enat2 ) ).

% of_nat_eq_enat
thf(fact_7398_enat__0__iff_I2_J,axiom,
    ! [X: nat] :
      ( ( ( zero_zero @ extended_enat )
        = ( extended_enat2 @ X ) )
      = ( X
        = ( zero_zero @ nat ) ) ) ).

% enat_0_iff(2)
thf(fact_7399_enat__0__iff_I1_J,axiom,
    ! [X: nat] :
      ( ( ( extended_enat2 @ X )
        = ( zero_zero @ extended_enat ) )
      = ( X
        = ( zero_zero @ nat ) ) ) ).

% enat_0_iff(1)
thf(fact_7400_zero__enat__def,axiom,
    ( ( zero_zero @ extended_enat )
    = ( extended_enat2 @ ( zero_zero @ nat ) ) ) ).

% zero_enat_def
thf(fact_7401_Suc__ile__eq,axiom,
    ! [M: nat,N: extended_enat] :
      ( ( ord_less_eq @ extended_enat @ ( extended_enat2 @ ( suc @ M ) ) @ N )
      = ( ord_less @ extended_enat @ ( extended_enat2 @ M ) @ N ) ) ).

% Suc_ile_eq
thf(fact_7402_VEBT__internal_Oelim__dead_Osimps_I3_J,axiom,
    ! [Info: option @ ( product_prod @ nat @ nat ),Deg: nat,TreeList2: list @ vEBT_VEBT,Summary: vEBT_VEBT,L: nat] :
      ( ( vEBT_VEBT_elim_dead @ ( vEBT_Node @ Info @ Deg @ TreeList2 @ Summary ) @ ( extended_enat2 @ L ) )
      = ( vEBT_Node @ Info @ Deg
        @ ( take @ vEBT_VEBT @ ( divide_divide @ nat @ L @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
          @ ( map @ vEBT_VEBT @ vEBT_VEBT
            @ ^ [T3: vEBT_VEBT] : ( vEBT_VEBT_elim_dead @ T3 @ ( extended_enat2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
            @ TreeList2 ) )
        @ ( vEBT_VEBT_elim_dead @ Summary @ ( extended_enat2 @ ( divide_divide @ nat @ L @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ).

% VEBT_internal.elim_dead.simps(3)
thf(fact_7403_iadd__le__enat__iff,axiom,
    ! [X: extended_enat,Y: extended_enat,N: nat] :
      ( ( ord_less_eq @ extended_enat @ ( plus_plus @ extended_enat @ X @ Y ) @ ( extended_enat2 @ N ) )
      = ( ? [Y9: nat,X9: nat] :
            ( ( X
              = ( extended_enat2 @ X9 ) )
            & ( Y
              = ( extended_enat2 @ Y9 ) )
            & ( ord_less_eq @ nat @ ( plus_plus @ nat @ X9 @ Y9 ) @ N ) ) ) ) ).

% iadd_le_enat_iff
thf(fact_7404_VEBT__internal_Oelim__dead_Oelims,axiom,
    ! [X: vEBT_VEBT,Xa: extended_enat,Y: vEBT_VEBT] :
      ( ( ( vEBT_VEBT_elim_dead @ X @ Xa )
        = Y )
     => ( ! [A5: $o,B4: $o] :
            ( ( X
              = ( vEBT_Leaf @ A5 @ B4 ) )
           => ( Y
             != ( vEBT_Leaf @ A5 @ B4 ) ) )
       => ( ! [Info2: option @ ( product_prod @ nat @ nat ),Deg2: nat,TreeList3: list @ vEBT_VEBT,Summary3: vEBT_VEBT] :
              ( ( X
                = ( vEBT_Node @ Info2 @ Deg2 @ TreeList3 @ Summary3 ) )
             => ( ( Xa
                  = ( extend4730790105801354508finity @ extended_enat ) )
               => ( Y
                 != ( vEBT_Node @ Info2 @ Deg2
                    @ ( map @ vEBT_VEBT @ vEBT_VEBT
                      @ ^ [T3: vEBT_VEBT] : ( vEBT_VEBT_elim_dead @ T3 @ ( extended_enat2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                      @ TreeList3 )
                    @ ( vEBT_VEBT_elim_dead @ Summary3 @ ( extend4730790105801354508finity @ extended_enat ) ) ) ) ) )
         => ~ ! [Info2: option @ ( product_prod @ nat @ nat ),Deg2: nat,TreeList3: list @ vEBT_VEBT,Summary3: vEBT_VEBT] :
                ( ( X
                  = ( vEBT_Node @ Info2 @ Deg2 @ TreeList3 @ Summary3 ) )
               => ! [L3: nat] :
                    ( ( Xa
                      = ( extended_enat2 @ L3 ) )
                   => ( Y
                     != ( vEBT_Node @ Info2 @ Deg2
                        @ ( take @ vEBT_VEBT @ ( divide_divide @ nat @ L3 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
                          @ ( map @ vEBT_VEBT @ vEBT_VEBT
                            @ ^ [T3: vEBT_VEBT] : ( vEBT_VEBT_elim_dead @ T3 @ ( extended_enat2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                            @ TreeList3 ) )
                        @ ( vEBT_VEBT_elim_dead @ Summary3 @ ( extended_enat2 @ ( divide_divide @ nat @ L3 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ).

% VEBT_internal.elim_dead.elims
thf(fact_7405_elimcomplete,axiom,
    ! [Info: option @ ( product_prod @ nat @ nat ),Deg: nat,TreeList2: list @ vEBT_VEBT,Summary: vEBT_VEBT,N: nat] :
      ( ( vEBT_invar_vebt @ ( vEBT_Node @ Info @ Deg @ TreeList2 @ Summary ) @ N )
     => ( ( vEBT_VEBT_elim_dead @ ( vEBT_Node @ Info @ Deg @ TreeList2 @ Summary ) @ ( extend4730790105801354508finity @ extended_enat ) )
        = ( vEBT_Node @ Info @ Deg @ TreeList2 @ Summary ) ) ) ).

% elimcomplete
thf(fact_7406_not__infinity__eq,axiom,
    ! [X: extended_enat] :
      ( ( ( X
         != ( extend4730790105801354508finity @ extended_enat ) ) )
      = ( ? [I4: nat] :
            ( X
            = ( extended_enat2 @ I4 ) ) ) ) ).

% not_infinity_eq
thf(fact_7407_not__enat__eq,axiom,
    ! [X: extended_enat] :
      ( ( ! [Y4: nat] :
            ( X
           != ( extended_enat2 @ Y4 ) ) )
      = ( X
        = ( extend4730790105801354508finity @ extended_enat ) ) ) ).

% not_enat_eq
thf(fact_7408_enat__ord__simps_I4_J,axiom,
    ! [Q3: extended_enat] :
      ( ( ord_less @ extended_enat @ Q3 @ ( extend4730790105801354508finity @ extended_enat ) )
      = ( ( Q3
         != ( extend4730790105801354508finity @ extended_enat ) ) ) ) ).

% enat_ord_simps(4)
thf(fact_7409_enat__ord__simps_I6_J,axiom,
    ! [Q3: extended_enat] :
      ~ ( ord_less @ extended_enat @ ( extend4730790105801354508finity @ extended_enat ) @ Q3 ) ).

% enat_ord_simps(6)
thf(fact_7410_plus__enat__simps_I2_J,axiom,
    ! [Q3: extended_enat] :
      ( ( plus_plus @ extended_enat @ ( extend4730790105801354508finity @ extended_enat ) @ Q3 )
      = ( extend4730790105801354508finity @ extended_enat ) ) ).

% plus_enat_simps(2)
thf(fact_7411_plus__enat__simps_I3_J,axiom,
    ! [Q3: extended_enat] :
      ( ( plus_plus @ extended_enat @ Q3 @ ( extend4730790105801354508finity @ extended_enat ) )
      = ( extend4730790105801354508finity @ extended_enat ) ) ).

% plus_enat_simps(3)
thf(fact_7412_enat__ord__code_I3_J,axiom,
    ! [Q3: extended_enat] : ( ord_less_eq @ extended_enat @ Q3 @ ( extend4730790105801354508finity @ extended_enat ) ) ).

% enat_ord_code(3)
thf(fact_7413_enat__ord__simps_I5_J,axiom,
    ! [Q3: extended_enat] :
      ( ( ord_less_eq @ extended_enat @ ( extend4730790105801354508finity @ extended_enat ) @ Q3 )
      = ( Q3
        = ( extend4730790105801354508finity @ extended_enat ) ) ) ).

% enat_ord_simps(5)
thf(fact_7414_idiff__infinity,axiom,
    ! [N: extended_enat] :
      ( ( minus_minus @ extended_enat @ ( extend4730790105801354508finity @ extended_enat ) @ N )
      = ( extend4730790105801354508finity @ extended_enat ) ) ).

% idiff_infinity
thf(fact_7415_enat_Osimps_I5_J,axiom,
    ! [T: $tType,F1: nat > T,F22: T] :
      ( ( extended_case_enat @ T @ F1 @ F22 @ ( extend4730790105801354508finity @ extended_enat ) )
      = F22 ) ).

% enat.simps(5)
thf(fact_7416_times__enat__simps_I2_J,axiom,
    ( ( times_times @ extended_enat @ ( extend4730790105801354508finity @ extended_enat ) @ ( extend4730790105801354508finity @ extended_enat ) )
    = ( extend4730790105801354508finity @ extended_enat ) ) ).

% times_enat_simps(2)
thf(fact_7417_max__enat__simps_I5_J,axiom,
    ! [Q3: extended_enat] :
      ( ( ord_max @ extended_enat @ ( extend4730790105801354508finity @ extended_enat ) @ Q3 )
      = ( extend4730790105801354508finity @ extended_enat ) ) ).

% max_enat_simps(5)
thf(fact_7418_max__enat__simps_I4_J,axiom,
    ! [Q3: extended_enat] :
      ( ( ord_max @ extended_enat @ Q3 @ ( extend4730790105801354508finity @ extended_enat ) )
      = ( extend4730790105801354508finity @ extended_enat ) ) ).

% max_enat_simps(4)
thf(fact_7419_min__enat__simps_I4_J,axiom,
    ! [Q3: extended_enat] :
      ( ( ord_min @ extended_enat @ Q3 @ ( extend4730790105801354508finity @ extended_enat ) )
      = Q3 ) ).

% min_enat_simps(4)
thf(fact_7420_min__enat__simps_I5_J,axiom,
    ! [Q3: extended_enat] :
      ( ( ord_min @ extended_enat @ ( extend4730790105801354508finity @ extended_enat ) @ Q3 )
      = Q3 ) ).

% min_enat_simps(5)
thf(fact_7421_idiff__self,axiom,
    ! [N: extended_enat] :
      ( ( N
       != ( extend4730790105801354508finity @ extended_enat ) )
     => ( ( minus_minus @ extended_enat @ N @ N )
        = ( zero_zero @ extended_enat ) ) ) ).

% idiff_self
thf(fact_7422_add__diff__cancel__enat,axiom,
    ! [X: extended_enat,Y: extended_enat] :
      ( ( X
       != ( extend4730790105801354508finity @ extended_enat ) )
     => ( ( minus_minus @ extended_enat @ ( plus_plus @ extended_enat @ X @ Y ) @ X )
        = Y ) ) ).

% add_diff_cancel_enat
thf(fact_7423_idiff__infinity__right,axiom,
    ! [A2: nat] :
      ( ( minus_minus @ extended_enat @ ( extended_enat2 @ A2 ) @ ( extend4730790105801354508finity @ extended_enat ) )
      = ( zero_zero @ extended_enat ) ) ).

% idiff_infinity_right
thf(fact_7424_times__enat__simps_I3_J,axiom,
    ! [N: nat] :
      ( ( ( N
          = ( zero_zero @ nat ) )
       => ( ( times_times @ extended_enat @ ( extend4730790105801354508finity @ extended_enat ) @ ( extended_enat2 @ N ) )
          = ( zero_zero @ extended_enat ) ) )
      & ( ( N
         != ( zero_zero @ nat ) )
       => ( ( times_times @ extended_enat @ ( extend4730790105801354508finity @ extended_enat ) @ ( extended_enat2 @ N ) )
          = ( extend4730790105801354508finity @ extended_enat ) ) ) ) ).

% times_enat_simps(3)
thf(fact_7425_times__enat__simps_I4_J,axiom,
    ! [M: nat] :
      ( ( ( M
          = ( zero_zero @ nat ) )
       => ( ( times_times @ extended_enat @ ( extended_enat2 @ M ) @ ( extend4730790105801354508finity @ extended_enat ) )
          = ( zero_zero @ extended_enat ) ) )
      & ( ( M
         != ( zero_zero @ nat ) )
       => ( ( times_times @ extended_enat @ ( extended_enat2 @ M ) @ ( extend4730790105801354508finity @ extended_enat ) )
          = ( extend4730790105801354508finity @ extended_enat ) ) ) ) ).

% times_enat_simps(4)
thf(fact_7426_infinity__ileE,axiom,
    ! [M: nat] :
      ~ ( ord_less_eq @ extended_enat @ ( extend4730790105801354508finity @ extended_enat ) @ ( extended_enat2 @ M ) ) ).

% infinity_ileE
thf(fact_7427_enat__ord__code_I5_J,axiom,
    ! [N: nat] :
      ~ ( ord_less_eq @ extended_enat @ ( extend4730790105801354508finity @ extended_enat ) @ ( extended_enat2 @ N ) ) ).

% enat_ord_code(5)
thf(fact_7428_infinity__ilessE,axiom,
    ! [M: nat] :
      ~ ( ord_less @ extended_enat @ ( extend4730790105801354508finity @ extended_enat ) @ ( extended_enat2 @ M ) ) ).

% infinity_ilessE
thf(fact_7429_less__infinityE,axiom,
    ! [N: extended_enat] :
      ( ( ord_less @ extended_enat @ N @ ( extend4730790105801354508finity @ extended_enat ) )
     => ~ ! [K2: nat] :
            ( N
           != ( extended_enat2 @ K2 ) ) ) ).

% less_infinityE
thf(fact_7430_enat__ord__code_I4_J,axiom,
    ! [M: nat] : ( ord_less @ extended_enat @ ( extended_enat2 @ M ) @ ( extend4730790105801354508finity @ extended_enat ) ) ).

% enat_ord_code(4)
thf(fact_7431_enat__ex__split,axiom,
    ( ( ^ [P2: extended_enat > $o] :
        ? [X4: extended_enat] : ( P2 @ X4 ) )
    = ( ^ [P3: extended_enat > $o] :
          ( ( P3 @ ( extend4730790105801354508finity @ extended_enat ) )
          | ? [X2: nat] : ( P3 @ ( extended_enat2 @ X2 ) ) ) ) ) ).

% enat_ex_split
thf(fact_7432_enat3__cases,axiom,
    ! [Y: extended_enat,Ya: extended_enat,Yb: extended_enat] :
      ( ( ? [Nat3: nat] :
            ( Y
            = ( extended_enat2 @ Nat3 ) )
       => ( ? [Nata: nat] :
              ( Ya
              = ( extended_enat2 @ Nata ) )
         => ! [Natb: nat] :
              ( Yb
             != ( extended_enat2 @ Natb ) ) ) )
     => ( ( ? [Nat3: nat] :
              ( Y
              = ( extended_enat2 @ Nat3 ) )
         => ( ? [Nata: nat] :
                ( Ya
                = ( extended_enat2 @ Nata ) )
           => ( Yb
             != ( extend4730790105801354508finity @ extended_enat ) ) ) )
       => ( ( ? [Nat3: nat] :
                ( Y
                = ( extended_enat2 @ Nat3 ) )
           => ( ( Ya
                = ( extend4730790105801354508finity @ extended_enat ) )
             => ! [Nata: nat] :
                  ( Yb
                 != ( extended_enat2 @ Nata ) ) ) )
         => ( ( ? [Nat3: nat] :
                  ( Y
                  = ( extended_enat2 @ Nat3 ) )
             => ( ( Ya
                  = ( extend4730790105801354508finity @ extended_enat ) )
               => ( Yb
                 != ( extend4730790105801354508finity @ extended_enat ) ) ) )
           => ( ( ( Y
                  = ( extend4730790105801354508finity @ extended_enat ) )
               => ( ? [Nat3: nat] :
                      ( Ya
                      = ( extended_enat2 @ Nat3 ) )
                 => ! [Nata: nat] :
                      ( Yb
                     != ( extended_enat2 @ Nata ) ) ) )
             => ( ( ( Y
                    = ( extend4730790105801354508finity @ extended_enat ) )
                 => ( ? [Nat3: nat] :
                        ( Ya
                        = ( extended_enat2 @ Nat3 ) )
                   => ( Yb
                     != ( extend4730790105801354508finity @ extended_enat ) ) ) )
               => ( ( ( Y
                      = ( extend4730790105801354508finity @ extended_enat ) )
                   => ( ( Ya
                        = ( extend4730790105801354508finity @ extended_enat ) )
                     => ! [Nat3: nat] :
                          ( Yb
                         != ( extended_enat2 @ Nat3 ) ) ) )
                 => ~ ( ( Y
                        = ( extend4730790105801354508finity @ extended_enat ) )
                     => ( ( Ya
                          = ( extend4730790105801354508finity @ extended_enat ) )
                       => ( Yb
                         != ( extend4730790105801354508finity @ extended_enat ) ) ) ) ) ) ) ) ) ) ) ).

% enat3_cases
thf(fact_7433_enat2__cases,axiom,
    ! [Y: extended_enat,Ya: extended_enat] :
      ( ( ? [Nat3: nat] :
            ( Y
            = ( extended_enat2 @ Nat3 ) )
       => ! [Nata: nat] :
            ( Ya
           != ( extended_enat2 @ Nata ) ) )
     => ( ( ? [Nat3: nat] :
              ( Y
              = ( extended_enat2 @ Nat3 ) )
         => ( Ya
           != ( extend4730790105801354508finity @ extended_enat ) ) )
       => ( ( ( Y
              = ( extend4730790105801354508finity @ extended_enat ) )
           => ! [Nat3: nat] :
                ( Ya
               != ( extended_enat2 @ Nat3 ) ) )
         => ~ ( ( Y
                = ( extend4730790105801354508finity @ extended_enat ) )
             => ( Ya
               != ( extend4730790105801354508finity @ extended_enat ) ) ) ) ) ) ).

% enat2_cases
thf(fact_7434_enat_Oexhaust,axiom,
    ! [Y: extended_enat] :
      ( ! [Nat3: nat] :
          ( Y
         != ( extended_enat2 @ Nat3 ) )
     => ( Y
        = ( extend4730790105801354508finity @ extended_enat ) ) ) ).

% enat.exhaust
thf(fact_7435_enat_Odistinct_I1_J,axiom,
    ! [Nat: nat] :
      ( ( extended_enat2 @ Nat )
     != ( extend4730790105801354508finity @ extended_enat ) ) ).

% enat.distinct(1)
thf(fact_7436_enat_Odistinct_I2_J,axiom,
    ! [Nat5: nat] :
      ( ( extend4730790105801354508finity @ extended_enat )
     != ( extended_enat2 @ Nat5 ) ) ).

% enat.distinct(2)
thf(fact_7437_plus__enat__def,axiom,
    ( ( plus_plus @ extended_enat )
    = ( ^ [M3: extended_enat,N3: extended_enat] :
          ( extended_case_enat @ extended_enat
          @ ^ [O: nat] :
              ( extended_case_enat @ extended_enat
              @ ^ [P5: nat] : ( extended_enat2 @ ( plus_plus @ nat @ O @ P5 ) )
              @ ( extend4730790105801354508finity @ extended_enat )
              @ N3 )
          @ ( extend4730790105801354508finity @ extended_enat )
          @ M3 ) ) ) ).

% plus_enat_def
thf(fact_7438_diff__enat__def,axiom,
    ( ( minus_minus @ extended_enat )
    = ( ^ [A3: extended_enat,B3: extended_enat] :
          ( extended_case_enat @ extended_enat
          @ ^ [X2: nat] :
              ( extended_case_enat @ extended_enat
              @ ^ [Y4: nat] : ( extended_enat2 @ ( minus_minus @ nat @ X2 @ Y4 ) )
              @ ( zero_zero @ extended_enat )
              @ B3 )
          @ ( extend4730790105801354508finity @ extended_enat )
          @ A3 ) ) ) ).

% diff_enat_def
thf(fact_7439_imult__is__infinity,axiom,
    ! [A2: extended_enat,B2: extended_enat] :
      ( ( ( times_times @ extended_enat @ A2 @ B2 )
        = ( extend4730790105801354508finity @ extended_enat ) )
      = ( ( ( A2
            = ( extend4730790105801354508finity @ extended_enat ) )
          & ( B2
           != ( zero_zero @ extended_enat ) ) )
        | ( ( B2
            = ( extend4730790105801354508finity @ extended_enat ) )
          & ( A2
           != ( zero_zero @ extended_enat ) ) ) ) ) ).

% imult_is_infinity
thf(fact_7440_infinity__ne__i0,axiom,
    ( extend4730790105801354508finity @ extended_enat )
 != ( zero_zero @ extended_enat ) ).

% infinity_ne_i0
thf(fact_7441_Sup__enat__def,axiom,
    ( ( complete_Sup_Sup @ extended_enat )
    = ( ^ [A7: set @ extended_enat] :
          ( if @ extended_enat
          @ ( A7
            = ( bot_bot @ ( set @ extended_enat ) ) )
          @ ( zero_zero @ extended_enat )
          @ ( if @ extended_enat @ ( finite_finite @ extended_enat @ A7 ) @ ( lattic643756798349783984er_Max @ extended_enat @ A7 ) @ ( extend4730790105801354508finity @ extended_enat ) ) ) ) ) ).

% Sup_enat_def
thf(fact_7442_Inf__enat__def,axiom,
    ( ( complete_Inf_Inf @ extended_enat )
    = ( ^ [A7: set @ extended_enat] :
          ( if @ extended_enat
          @ ( A7
            = ( bot_bot @ ( set @ extended_enat ) ) )
          @ ( extend4730790105801354508finity @ extended_enat )
          @ ( ord_Least @ extended_enat
            @ ^ [X2: extended_enat] : ( member @ extended_enat @ X2 @ A7 ) ) ) ) ) ).

% Inf_enat_def
thf(fact_7443_enat__add__left__cancel__less,axiom,
    ! [A2: extended_enat,B2: extended_enat,C2: extended_enat] :
      ( ( ord_less @ extended_enat @ ( plus_plus @ extended_enat @ A2 @ B2 ) @ ( plus_plus @ extended_enat @ A2 @ C2 ) )
      = ( ( A2
         != ( extend4730790105801354508finity @ extended_enat ) )
        & ( ord_less @ extended_enat @ B2 @ C2 ) ) ) ).

% enat_add_left_cancel_less
thf(fact_7444_top__enat__def,axiom,
    ( ( top_top @ extended_enat )
    = ( extend4730790105801354508finity @ extended_enat ) ) ).

% top_enat_def
thf(fact_7445_infinity__ne__i1,axiom,
    ( extend4730790105801354508finity @ extended_enat )
 != ( one_one @ extended_enat ) ).

% infinity_ne_i1
thf(fact_7446_plus__eq__infty__iff__enat,axiom,
    ! [M: extended_enat,N: extended_enat] :
      ( ( ( plus_plus @ extended_enat @ M @ N )
        = ( extend4730790105801354508finity @ extended_enat ) )
      = ( ( M
          = ( extend4730790105801354508finity @ extended_enat ) )
        | ( N
          = ( extend4730790105801354508finity @ extended_enat ) ) ) ) ).

% plus_eq_infty_iff_enat
thf(fact_7447_enat__add__left__cancel,axiom,
    ! [A2: extended_enat,B2: extended_enat,C2: extended_enat] :
      ( ( ( plus_plus @ extended_enat @ A2 @ B2 )
        = ( plus_plus @ extended_enat @ A2 @ C2 ) )
      = ( ( A2
          = ( extend4730790105801354508finity @ extended_enat ) )
        | ( B2 = C2 ) ) ) ).

% enat_add_left_cancel
thf(fact_7448_numeral__ne__infinity,axiom,
    ! [K: num] :
      ( ( numeral_numeral @ extended_enat @ K )
     != ( extend4730790105801354508finity @ extended_enat ) ) ).

% numeral_ne_infinity
thf(fact_7449_enat__add__left__cancel__le,axiom,
    ! [A2: extended_enat,B2: extended_enat,C2: extended_enat] :
      ( ( ord_less_eq @ extended_enat @ ( plus_plus @ extended_enat @ A2 @ B2 ) @ ( plus_plus @ extended_enat @ A2 @ C2 ) )
      = ( ( A2
          = ( extend4730790105801354508finity @ extended_enat ) )
        | ( ord_less_eq @ extended_enat @ B2 @ C2 ) ) ) ).

% enat_add_left_cancel_le
thf(fact_7450_enat__ord__simps_I3_J,axiom,
    ! [Q3: extended_enat] : ( ord_less_eq @ extended_enat @ Q3 @ ( extend4730790105801354508finity @ extended_enat ) ) ).

% enat_ord_simps(3)
thf(fact_7451_times__enat__def,axiom,
    ( ( times_times @ extended_enat )
    = ( ^ [M3: extended_enat,N3: extended_enat] :
          ( extended_case_enat @ extended_enat
          @ ^ [O: nat] :
              ( extended_case_enat @ extended_enat
              @ ^ [P5: nat] : ( extended_enat2 @ ( times_times @ nat @ O @ P5 ) )
              @ ( if @ extended_enat
                @ ( O
                  = ( zero_zero @ nat ) )
                @ ( zero_zero @ extended_enat )
                @ ( extend4730790105801354508finity @ extended_enat ) )
              @ N3 )
          @ ( if @ extended_enat
            @ ( N3
              = ( zero_zero @ extended_enat ) )
            @ ( zero_zero @ extended_enat )
            @ ( extend4730790105801354508finity @ extended_enat ) )
          @ M3 ) ) ) ).

% times_enat_def
thf(fact_7452_imult__infinity,axiom,
    ! [N: extended_enat] :
      ( ( ord_less @ extended_enat @ ( zero_zero @ extended_enat ) @ N )
     => ( ( times_times @ extended_enat @ ( extend4730790105801354508finity @ extended_enat ) @ N )
        = ( extend4730790105801354508finity @ extended_enat ) ) ) ).

% imult_infinity
thf(fact_7453_imult__infinity__right,axiom,
    ! [N: extended_enat] :
      ( ( ord_less @ extended_enat @ ( zero_zero @ extended_enat ) @ N )
     => ( ( times_times @ extended_enat @ N @ ( extend4730790105801354508finity @ extended_enat ) )
        = ( extend4730790105801354508finity @ extended_enat ) ) ) ).

% imult_infinity_right
thf(fact_7454_VEBT__internal_Oelim__dead_Osimps_I2_J,axiom,
    ! [Info: option @ ( product_prod @ nat @ nat ),Deg: nat,TreeList2: list @ vEBT_VEBT,Summary: vEBT_VEBT] :
      ( ( vEBT_VEBT_elim_dead @ ( vEBT_Node @ Info @ Deg @ TreeList2 @ Summary ) @ ( extend4730790105801354508finity @ extended_enat ) )
      = ( vEBT_Node @ Info @ Deg
        @ ( map @ vEBT_VEBT @ vEBT_VEBT
          @ ^ [T3: vEBT_VEBT] : ( vEBT_VEBT_elim_dead @ T3 @ ( extended_enat2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( divide_divide @ nat @ Deg @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
          @ TreeList2 )
        @ ( vEBT_VEBT_elim_dead @ Summary @ ( extend4730790105801354508finity @ extended_enat ) ) ) ) ).

% VEBT_internal.elim_dead.simps(2)
thf(fact_7455_VEBT__internal_Oelim__dead_Opelims,axiom,
    ! [X: vEBT_VEBT,Xa: extended_enat,Y: vEBT_VEBT] :
      ( ( ( vEBT_VEBT_elim_dead @ X @ Xa )
        = Y )
     => ( ( accp @ ( product_prod @ vEBT_VEBT @ extended_enat ) @ vEBT_V312737461966249ad_rel @ ( product_Pair @ vEBT_VEBT @ extended_enat @ X @ Xa ) )
       => ( ! [A5: $o,B4: $o] :
              ( ( X
                = ( vEBT_Leaf @ A5 @ B4 ) )
             => ( ( Y
                  = ( vEBT_Leaf @ A5 @ B4 ) )
               => ~ ( accp @ ( product_prod @ vEBT_VEBT @ extended_enat ) @ vEBT_V312737461966249ad_rel @ ( product_Pair @ vEBT_VEBT @ extended_enat @ ( vEBT_Leaf @ A5 @ B4 ) @ Xa ) ) ) )
         => ( ! [Info2: option @ ( product_prod @ nat @ nat ),Deg2: nat,TreeList3: list @ vEBT_VEBT,Summary3: vEBT_VEBT] :
                ( ( X
                  = ( vEBT_Node @ Info2 @ Deg2 @ TreeList3 @ Summary3 ) )
               => ( ( Xa
                    = ( extend4730790105801354508finity @ extended_enat ) )
                 => ( ( Y
                      = ( vEBT_Node @ Info2 @ Deg2
                        @ ( map @ vEBT_VEBT @ vEBT_VEBT
                          @ ^ [T3: vEBT_VEBT] : ( vEBT_VEBT_elim_dead @ T3 @ ( extended_enat2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                          @ TreeList3 )
                        @ ( vEBT_VEBT_elim_dead @ Summary3 @ ( extend4730790105801354508finity @ extended_enat ) ) ) )
                   => ~ ( accp @ ( product_prod @ vEBT_VEBT @ extended_enat ) @ vEBT_V312737461966249ad_rel @ ( product_Pair @ vEBT_VEBT @ extended_enat @ ( vEBT_Node @ Info2 @ Deg2 @ TreeList3 @ Summary3 ) @ ( extend4730790105801354508finity @ extended_enat ) ) ) ) ) )
           => ~ ! [Info2: option @ ( product_prod @ nat @ nat ),Deg2: nat,TreeList3: list @ vEBT_VEBT,Summary3: vEBT_VEBT] :
                  ( ( X
                    = ( vEBT_Node @ Info2 @ Deg2 @ TreeList3 @ Summary3 ) )
                 => ! [L3: nat] :
                      ( ( Xa
                        = ( extended_enat2 @ L3 ) )
                     => ( ( Y
                          = ( vEBT_Node @ Info2 @ Deg2
                            @ ( take @ vEBT_VEBT @ ( divide_divide @ nat @ L3 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) )
                              @ ( map @ vEBT_VEBT @ vEBT_VEBT
                                @ ^ [T3: vEBT_VEBT] : ( vEBT_VEBT_elim_dead @ T3 @ ( extended_enat2 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) )
                                @ TreeList3 ) )
                            @ ( vEBT_VEBT_elim_dead @ Summary3 @ ( extended_enat2 @ ( divide_divide @ nat @ L3 @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ ( divide_divide @ nat @ Deg2 @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) ) ) ) ) ) ) )
                       => ~ ( accp @ ( product_prod @ vEBT_VEBT @ extended_enat ) @ vEBT_V312737461966249ad_rel @ ( product_Pair @ vEBT_VEBT @ extended_enat @ ( vEBT_Node @ Info2 @ Deg2 @ TreeList3 @ Summary3 ) @ ( extended_enat2 @ L3 ) ) ) ) ) ) ) ) ) ) ).

% VEBT_internal.elim_dead.pelims
thf(fact_7456_the__enat_Osimps,axiom,
    ! [N: nat] :
      ( ( extended_the_enat @ ( extended_enat2 @ N ) )
      = N ) ).

% the_enat.simps
thf(fact_7457_eSuc__Max,axiom,
    ! [A4: set @ extended_enat] :
      ( ( finite_finite @ extended_enat @ A4 )
     => ( ( A4
         != ( bot_bot @ ( set @ extended_enat ) ) )
       => ( ( extended_eSuc @ ( lattic643756798349783984er_Max @ extended_enat @ A4 ) )
          = ( lattic643756798349783984er_Max @ extended_enat @ ( image @ extended_enat @ extended_enat @ extended_eSuc @ A4 ) ) ) ) ) ).

% eSuc_Max
thf(fact_7458_enat_Osimps_I7_J,axiom,
    ! [T: $tType,F1: nat > T,F22: T] :
      ( ( extended_rec_enat @ T @ F1 @ F22 @ ( extend4730790105801354508finity @ extended_enat ) )
      = F22 ) ).

% enat.simps(7)
thf(fact_7459_eSuc__inject,axiom,
    ! [M: extended_enat,N: extended_enat] :
      ( ( ( extended_eSuc @ M )
        = ( extended_eSuc @ N ) )
      = ( M = N ) ) ).

% eSuc_inject
thf(fact_7460_eSuc__infinity,axiom,
    ( ( extended_eSuc @ ( extend4730790105801354508finity @ extended_enat ) )
    = ( extend4730790105801354508finity @ extended_enat ) ) ).

% eSuc_infinity
thf(fact_7461_eSuc__mono,axiom,
    ! [N: extended_enat,M: extended_enat] :
      ( ( ord_less @ extended_enat @ ( extended_eSuc @ N ) @ ( extended_eSuc @ M ) )
      = ( ord_less @ extended_enat @ N @ M ) ) ).

% eSuc_mono
thf(fact_7462_eSuc__ile__mono,axiom,
    ! [N: extended_enat,M: extended_enat] :
      ( ( ord_less_eq @ extended_enat @ ( extended_eSuc @ N ) @ ( extended_eSuc @ M ) )
      = ( ord_less_eq @ extended_enat @ N @ M ) ) ).

% eSuc_ile_mono
thf(fact_7463_eSuc__minus__eSuc,axiom,
    ! [N: extended_enat,M: extended_enat] :
      ( ( minus_minus @ extended_enat @ ( extended_eSuc @ N ) @ ( extended_eSuc @ M ) )
      = ( minus_minus @ extended_enat @ N @ M ) ) ).

% eSuc_minus_eSuc
thf(fact_7464_enat_Osimps_I6_J,axiom,
    ! [T: $tType,F1: nat > T,F22: T,Nat: nat] :
      ( ( extended_rec_enat @ T @ F1 @ F22 @ ( extended_enat2 @ Nat ) )
      = ( F1 @ Nat ) ) ).

% enat.simps(6)
thf(fact_7465_iless__eSuc0,axiom,
    ! [N: extended_enat] :
      ( ( ord_less @ extended_enat @ N @ ( extended_eSuc @ ( zero_zero @ extended_enat ) ) )
      = ( N
        = ( zero_zero @ extended_enat ) ) ) ).

% iless_eSuc0
thf(fact_7466_eSuc__minus__1,axiom,
    ! [N: extended_enat] :
      ( ( minus_minus @ extended_enat @ ( extended_eSuc @ N ) @ ( one_one @ extended_enat ) )
      = N ) ).

% eSuc_minus_1
thf(fact_7467_eSuc__numeral,axiom,
    ! [K: num] :
      ( ( extended_eSuc @ ( numeral_numeral @ extended_enat @ K ) )
      = ( numeral_numeral @ extended_enat @ ( plus_plus @ num @ K @ one2 ) ) ) ).

% eSuc_numeral
thf(fact_7468_iless__Suc__eq,axiom,
    ! [M: nat,N: extended_enat] :
      ( ( ord_less @ extended_enat @ ( extended_enat2 @ M ) @ ( extended_eSuc @ N ) )
      = ( ord_less_eq @ extended_enat @ ( extended_enat2 @ M ) @ N ) ) ).

% iless_Suc_eq
thf(fact_7469_eSuc__enat,axiom,
    ! [N: nat] :
      ( ( extended_eSuc @ ( extended_enat2 @ N ) )
      = ( extended_enat2 @ ( suc @ N ) ) ) ).

% eSuc_enat
thf(fact_7470_eSuc__enat__iff,axiom,
    ! [X: extended_enat,Y: nat] :
      ( ( ( extended_eSuc @ X )
        = ( extended_enat2 @ Y ) )
      = ( ? [N3: nat] :
            ( ( Y
              = ( suc @ N3 ) )
            & ( X
              = ( extended_enat2 @ N3 ) ) ) ) ) ).

% eSuc_enat_iff
thf(fact_7471_enat__eSuc__iff,axiom,
    ! [Y: nat,X: extended_enat] :
      ( ( ( extended_enat2 @ Y )
        = ( extended_eSuc @ X ) )
      = ( ? [N3: nat] :
            ( ( Y
              = ( suc @ N3 ) )
            & ( ( extended_enat2 @ N3 )
              = X ) ) ) ) ).

% enat_eSuc_iff
thf(fact_7472_mult__eSuc__right,axiom,
    ! [M: extended_enat,N: extended_enat] :
      ( ( times_times @ extended_enat @ M @ ( extended_eSuc @ N ) )
      = ( plus_plus @ extended_enat @ M @ ( times_times @ extended_enat @ M @ N ) ) ) ).

% mult_eSuc_right
thf(fact_7473_mult__eSuc,axiom,
    ! [M: extended_enat,N: extended_enat] :
      ( ( times_times @ extended_enat @ ( extended_eSuc @ M ) @ N )
      = ( plus_plus @ extended_enat @ N @ ( times_times @ extended_enat @ M @ N ) ) ) ).

% mult_eSuc
thf(fact_7474_not__eSuc__ilei0,axiom,
    ! [N: extended_enat] :
      ~ ( ord_less_eq @ extended_enat @ ( extended_eSuc @ N ) @ ( zero_zero @ extended_enat ) ) ).

% not_eSuc_ilei0
thf(fact_7475_i0__iless__eSuc,axiom,
    ! [N: extended_enat] : ( ord_less @ extended_enat @ ( zero_zero @ extended_enat ) @ ( extended_eSuc @ N ) ) ).

% i0_iless_eSuc
thf(fact_7476_zero__ne__eSuc,axiom,
    ! [N: extended_enat] :
      ( ( zero_zero @ extended_enat )
     != ( extended_eSuc @ N ) ) ).

% zero_ne_eSuc
thf(fact_7477_iadd__Suc__right,axiom,
    ! [M: extended_enat,N: extended_enat] :
      ( ( plus_plus @ extended_enat @ M @ ( extended_eSuc @ N ) )
      = ( extended_eSuc @ ( plus_plus @ extended_enat @ M @ N ) ) ) ).

% iadd_Suc_right
thf(fact_7478_iadd__Suc,axiom,
    ! [M: extended_enat,N: extended_enat] :
      ( ( plus_plus @ extended_enat @ ( extended_eSuc @ M ) @ N )
      = ( extended_eSuc @ ( plus_plus @ extended_enat @ M @ N ) ) ) ).

% iadd_Suc
thf(fact_7479_eSuc__max,axiom,
    ! [X: extended_enat,Y: extended_enat] :
      ( ( extended_eSuc @ ( ord_max @ extended_enat @ X @ Y ) )
      = ( ord_max @ extended_enat @ ( extended_eSuc @ X ) @ ( extended_eSuc @ Y ) ) ) ).

% eSuc_max
thf(fact_7480_mono__eSuc,axiom,
    order_mono @ extended_enat @ extended_enat @ extended_eSuc ).

% mono_eSuc
thf(fact_7481_sup__continuous__eSuc,axiom,
    ! [A: $tType] :
      ( ( counta3822494911875563373attice @ A )
     => ! [F2: A > extended_enat] :
          ( ( order_sup_continuous @ A @ extended_enat @ F2 )
         => ( order_sup_continuous @ A @ extended_enat
            @ ^ [X2: A] : ( extended_eSuc @ ( F2 @ X2 ) ) ) ) ) ).

% sup_continuous_eSuc
thf(fact_7482_ile__eSuc,axiom,
    ! [N: extended_enat] : ( ord_less_eq @ extended_enat @ N @ ( extended_eSuc @ N ) ) ).

% ile_eSuc
thf(fact_7483_ileI1,axiom,
    ! [M: extended_enat,N: extended_enat] :
      ( ( ord_less @ extended_enat @ M @ N )
     => ( ord_less_eq @ extended_enat @ ( extended_eSuc @ M ) @ N ) ) ).

% ileI1
thf(fact_7484_one__eSuc,axiom,
    ( ( one_one @ extended_enat )
    = ( extended_eSuc @ ( zero_zero @ extended_enat ) ) ) ).

% one_eSuc
thf(fact_7485_plus__1__eSuc_I2_J,axiom,
    ! [Q3: extended_enat] :
      ( ( plus_plus @ extended_enat @ Q3 @ ( one_one @ extended_enat ) )
      = ( extended_eSuc @ Q3 ) ) ).

% plus_1_eSuc(2)
thf(fact_7486_plus__1__eSuc_I1_J,axiom,
    ! [Q3: extended_enat] :
      ( ( plus_plus @ extended_enat @ ( one_one @ extended_enat ) @ Q3 )
      = ( extended_eSuc @ Q3 ) ) ).

% plus_1_eSuc(1)
thf(fact_7487_eSuc__plus__1,axiom,
    ( extended_eSuc
    = ( ^ [N3: extended_enat] : ( plus_plus @ extended_enat @ N3 @ ( one_one @ extended_enat ) ) ) ) ).

% eSuc_plus_1
thf(fact_7488_eSuc__Sup,axiom,
    ! [A4: set @ extended_enat] :
      ( ( A4
       != ( bot_bot @ ( set @ extended_enat ) ) )
     => ( ( extended_eSuc @ ( complete_Sup_Sup @ extended_enat @ A4 ) )
        = ( complete_Sup_Sup @ extended_enat @ ( image @ extended_enat @ extended_enat @ extended_eSuc @ A4 ) ) ) ) ).

% eSuc_Sup
thf(fact_7489_case__enat__def,axiom,
    ! [T: $tType] :
      ( ( extended_case_enat @ T )
      = ( extended_rec_enat @ T ) ) ).

% case_enat_def
thf(fact_7490_eSuc__def,axiom,
    ( extended_eSuc
    = ( extended_case_enat @ extended_enat
      @ ^ [N3: nat] : ( extended_enat2 @ ( suc @ N3 ) )
      @ ( extend4730790105801354508finity @ extended_enat ) ) ) ).

% eSuc_def
thf(fact_7491_rec__enat__def,axiom,
    ! [T: $tType] :
      ( ( extended_rec_enat @ T )
      = ( ^ [F12: nat > T,F23: T,X2: extended_enat] : ( the @ T @ ( extend4933016492236175606t_enat @ T @ F12 @ F23 @ X2 ) ) ) ) ).

% rec_enat_def
thf(fact_7492_Gcd__nat__set__eq__fold,axiom,
    ! [Xs: list @ nat] :
      ( ( gcd_Gcd @ nat @ ( set2 @ nat @ Xs ) )
      = ( fold @ nat @ nat @ ( gcd_gcd @ nat ) @ Xs @ ( zero_zero @ nat ) ) ) ).

% Gcd_nat_set_eq_fold
thf(fact_7493_Gcd__set__eq__fold,axiom,
    ! [A: $tType] :
      ( ( semiring_Gcd @ A )
     => ! [Xs: list @ A] :
          ( ( gcd_Gcd @ A @ ( set2 @ A @ Xs ) )
          = ( fold @ A @ A @ ( gcd_gcd @ A ) @ Xs @ ( zero_zero @ A ) ) ) ) ).

% Gcd_set_eq_fold
thf(fact_7494_Max_Oset__eq__fold,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [X: A,Xs: list @ A] :
          ( ( lattic643756798349783984er_Max @ A @ ( set2 @ A @ ( cons @ A @ X @ Xs ) ) )
          = ( fold @ A @ A @ ( ord_max @ A ) @ Xs @ X ) ) ) ).

% Max.set_eq_fold
thf(fact_7495_Gcd__fin_Oset__eq__fold,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [Xs: list @ A] :
          ( ( semiring_gcd_Gcd_fin @ A @ ( set2 @ A @ Xs ) )
          = ( fold @ A @ A @ ( gcd_gcd @ A ) @ Xs @ ( zero_zero @ A ) ) ) ) ).

% Gcd_fin.set_eq_fold
thf(fact_7496_Quotient__real,axiom,
    quotient @ ( nat > rat ) @ real @ realrel @ real2 @ rep_real @ cr_real ).

% Quotient_real
thf(fact_7497_Zfun__imp__Zfun,axiom,
    ! [B: $tType,C: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ C )
        & ( real_V822414075346904944vector @ B ) )
     => ! [F2: A > B,F4: filter @ A,G: A > C,K6: real] :
          ( ( zfun @ A @ B @ F2 @ F4 )
         => ( ( eventually @ A
              @ ^ [X2: A] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ C @ ( G @ X2 ) ) @ ( times_times @ real @ ( real_V7770717601297561774m_norm @ B @ ( F2 @ X2 ) ) @ K6 ) )
              @ F4 )
           => ( zfun @ A @ C @ G @ F4 ) ) ) ) ).

% Zfun_imp_Zfun
thf(fact_7498_Zfun__zero,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector @ B )
     => ! [F4: filter @ A] :
          ( zfun @ A @ B
          @ ^ [X2: A] : ( zero_zero @ B )
          @ F4 ) ) ).

% Zfun_zero
thf(fact_7499_Zfun__le,axiom,
    ! [B: $tType,C: $tType,A: $tType] :
      ( ( ( real_V822414075346904944vector @ C )
        & ( real_V822414075346904944vector @ B ) )
     => ! [G: A > B,F4: filter @ A,F2: A > C] :
          ( ( zfun @ A @ B @ G @ F4 )
         => ( ! [X3: A] : ( ord_less_eq @ real @ ( real_V7770717601297561774m_norm @ C @ ( F2 @ X3 ) ) @ ( real_V7770717601297561774m_norm @ B @ ( G @ X3 ) ) )
           => ( zfun @ A @ C @ F2 @ F4 ) ) ) ) ).

% Zfun_le
thf(fact_7500_Gcd__int__set__eq__fold,axiom,
    ! [Xs: list @ int] :
      ( ( gcd_Gcd @ int @ ( set2 @ int @ Xs ) )
      = ( fold @ int @ int @ ( gcd_gcd @ int ) @ Xs @ ( zero_zero @ int ) ) ) ).

% Gcd_int_set_eq_fold
thf(fact_7501_Zfun__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector @ B )
     => ( ( zfun @ A @ B )
        = ( ^ [F3: A > B,F8: filter @ A] :
            ! [R5: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ R5 )
             => ( eventually @ A
                @ ^ [X2: A] : ( ord_less @ real @ ( real_V7770717601297561774m_norm @ B @ ( F3 @ X2 ) ) @ R5 )
                @ F8 ) ) ) ) ) ).

% Zfun_def
thf(fact_7502_ZfunI,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector @ B )
     => ! [F2: A > B,F4: filter @ A] :
          ( ! [R: real] :
              ( ( ord_less @ real @ ( zero_zero @ real ) @ R )
             => ( eventually @ A
                @ ^ [X2: A] : ( ord_less @ real @ ( real_V7770717601297561774m_norm @ B @ ( F2 @ X2 ) ) @ R )
                @ F4 ) )
         => ( zfun @ A @ B @ F2 @ F4 ) ) ) ).

% ZfunI
thf(fact_7503_ZfunD,axiom,
    ! [B: $tType,A: $tType] :
      ( ( real_V822414075346904944vector @ B )
     => ! [F2: A > B,F4: filter @ A,R2: real] :
          ( ( zfun @ A @ B @ F2 @ F4 )
         => ( ( ord_less @ real @ ( zero_zero @ real ) @ R2 )
           => ( eventually @ A
              @ ^ [X2: A] : ( ord_less @ real @ ( real_V7770717601297561774m_norm @ B @ ( F2 @ X2 ) ) @ R2 )
              @ F4 ) ) ) ) ).

% ZfunD
thf(fact_7504_semilattice__order__set_Osubset__imp,axiom,
    ! [A: $tType,F2: A > A > A,Less_eq: A > A > $o,Less: A > A > $o,A4: set @ A,B7: set @ A] :
      ( ( lattic4895041142388067077er_set @ A @ F2 @ Less_eq @ Less )
     => ( ( ord_less_eq @ ( set @ A ) @ A4 @ B7 )
       => ( ( A4
           != ( bot_bot @ ( set @ A ) ) )
         => ( ( finite_finite @ A @ B7 )
           => ( Less_eq @ ( lattic1715443433743089157tice_F @ A @ F2 @ B7 ) @ ( lattic1715443433743089157tice_F @ A @ F2 @ A4 ) ) ) ) ) ) ).

% semilattice_order_set.subset_imp
thf(fact_7505_not__in__connected__cases,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [S: set @ A,X: A] :
          ( ( topolo1966860045006549960nected @ A @ S )
         => ( ~ ( member @ A @ X @ S )
           => ( ( S
               != ( bot_bot @ ( set @ A ) ) )
             => ( ( ( condit941137186595557371_above @ A @ S )
                 => ~ ! [Y6: A] :
                        ( ( member @ A @ Y6 @ S )
                       => ( ord_less_eq @ A @ Y6 @ X ) ) )
               => ~ ( ( condit1013018076250108175_below @ A @ S )
                   => ~ ! [Y6: A] :
                          ( ( member @ A @ Y6 @ S )
                         => ( ord_less_eq @ A @ X @ Y6 ) ) ) ) ) ) ) ) ).

% not_in_connected_cases
thf(fact_7506_semilattice__order__set_OcoboundedI,axiom,
    ! [A: $tType,F2: A > A > A,Less_eq: A > A > $o,Less: A > A > $o,A4: set @ A,A2: A] :
      ( ( lattic4895041142388067077er_set @ A @ F2 @ Less_eq @ Less )
     => ( ( finite_finite @ A @ A4 )
       => ( ( member @ A @ A2 @ A4 )
         => ( Less_eq @ ( lattic1715443433743089157tice_F @ A @ F2 @ A4 ) @ A2 ) ) ) ) ).

% semilattice_order_set.coboundedI
thf(fact_7507_connectedD__interval,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [U3: set @ A,X: A,Y: A,Z: A] :
          ( ( topolo1966860045006549960nected @ A @ U3 )
         => ( ( member @ A @ X @ U3 )
           => ( ( member @ A @ Y @ U3 )
             => ( ( ord_less_eq @ A @ X @ Z )
               => ( ( ord_less_eq @ A @ Z @ Y )
                 => ( member @ A @ Z @ U3 ) ) ) ) ) ) ) ).

% connectedD_interval
thf(fact_7508_connectedI__interval,axiom,
    ! [A: $tType] :
      ( ( topolo8458572112393995274pology @ A )
     => ! [U3: set @ A] :
          ( ! [X3: A,Y5: A,Z3: A] :
              ( ( member @ A @ X3 @ U3 )
             => ( ( member @ A @ Y5 @ U3 )
               => ( ( ord_less_eq @ A @ X3 @ Z3 )
                 => ( ( ord_less_eq @ A @ Z3 @ Y5 )
                   => ( member @ A @ Z3 @ U3 ) ) ) ) )
         => ( topolo1966860045006549960nected @ A @ U3 ) ) ) ).

% connectedI_interval
thf(fact_7509_connected__iff__interval,axiom,
    ! [A: $tType] :
      ( ( topolo8458572112393995274pology @ A )
     => ( ( topolo1966860045006549960nected @ A )
        = ( ^ [U5: set @ A] :
            ! [X2: A] :
              ( ( member @ A @ X2 @ U5 )
             => ! [Y4: A] :
                  ( ( member @ A @ Y4 @ U5 )
                 => ! [Z6: A] :
                      ( ( ord_less_eq @ A @ X2 @ Z6 )
                     => ( ( ord_less_eq @ A @ Z6 @ Y4 )
                       => ( member @ A @ Z6 @ U5 ) ) ) ) ) ) ) ) ).

% connected_iff_interval
thf(fact_7510_Inf__fin__def,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ( ( lattic7752659483105999362nf_fin @ A )
        = ( lattic1715443433743089157tice_F @ A @ ( inf_inf @ A ) ) ) ) ).

% Inf_fin_def
thf(fact_7511_Min__def,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( ( lattic643756798350308766er_Min @ A )
        = ( lattic1715443433743089157tice_F @ A @ ( ord_min @ A ) ) ) ) ).

% Min_def
thf(fact_7512_semilattice__set_OF_Ocong,axiom,
    ! [A: $tType] :
      ( ( lattic1715443433743089157tice_F @ A )
      = ( lattic1715443433743089157tice_F @ A ) ) ).

% semilattice_set.F.cong
thf(fact_7513_Sup__fin__def,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ( ( lattic5882676163264333800up_fin @ A )
        = ( lattic1715443433743089157tice_F @ A @ ( sup_sup @ A ) ) ) ) ).

% Sup_fin_def
thf(fact_7514_Max__def,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( ( lattic643756798349783984er_Max @ A )
        = ( lattic1715443433743089157tice_F @ A @ ( ord_max @ A ) ) ) ) ).

% Max_def
thf(fact_7515_semilattice__order__set_OboundedE,axiom,
    ! [A: $tType,F2: A > A > A,Less_eq: A > A > $o,Less: A > A > $o,A4: set @ A,X: A] :
      ( ( lattic4895041142388067077er_set @ A @ F2 @ Less_eq @ Less )
     => ( ( finite_finite @ A @ A4 )
       => ( ( A4
           != ( bot_bot @ ( set @ A ) ) )
         => ( ( Less_eq @ X @ ( lattic1715443433743089157tice_F @ A @ F2 @ A4 ) )
           => ! [A9: A] :
                ( ( member @ A @ A9 @ A4 )
               => ( Less_eq @ X @ A9 ) ) ) ) ) ) ).

% semilattice_order_set.boundedE
thf(fact_7516_semilattice__order__set_OboundedI,axiom,
    ! [A: $tType,F2: A > A > A,Less_eq: A > A > $o,Less: A > A > $o,A4: set @ A,X: A] :
      ( ( lattic4895041142388067077er_set @ A @ F2 @ Less_eq @ Less )
     => ( ( finite_finite @ A @ A4 )
       => ( ( A4
           != ( bot_bot @ ( set @ A ) ) )
         => ( ! [A5: A] :
                ( ( member @ A @ A5 @ A4 )
               => ( Less_eq @ X @ A5 ) )
           => ( Less_eq @ X @ ( lattic1715443433743089157tice_F @ A @ F2 @ A4 ) ) ) ) ) ) ).

% semilattice_order_set.boundedI
thf(fact_7517_semilattice__order__set_Obounded__iff,axiom,
    ! [A: $tType,F2: A > A > A,Less_eq: A > A > $o,Less: A > A > $o,A4: set @ A,X: A] :
      ( ( lattic4895041142388067077er_set @ A @ F2 @ Less_eq @ Less )
     => ( ( finite_finite @ A @ A4 )
       => ( ( A4
           != ( bot_bot @ ( set @ A ) ) )
         => ( ( Less_eq @ X @ ( lattic1715443433743089157tice_F @ A @ F2 @ A4 ) )
            = ( ! [X2: A] :
                  ( ( member @ A @ X2 @ A4 )
                 => ( Less_eq @ X @ X2 ) ) ) ) ) ) ) ).

% semilattice_order_set.bounded_iff
thf(fact_7518_semilattice__set_Oeq__fold_H,axiom,
    ! [A: $tType,F2: A > A > A,A4: set @ A] :
      ( ( lattic149705377957585745ce_set @ A @ F2 )
     => ( ( lattic1715443433743089157tice_F @ A @ F2 @ A4 )
        = ( the2 @ A
          @ ( finite_fold @ A @ ( option @ A )
            @ ^ [X2: A,Y4: option @ A] : ( some @ A @ ( case_option @ A @ A @ X2 @ ( F2 @ X2 ) @ Y4 ) )
            @ ( none @ A )
            @ A4 ) ) ) ) ).

% semilattice_set.eq_fold'
thf(fact_7519_semilattice__set_Oremove,axiom,
    ! [A: $tType,F2: A > A > A,A4: set @ A,X: A] :
      ( ( lattic149705377957585745ce_set @ A @ F2 )
     => ( ( finite_finite @ A @ A4 )
       => ( ( member @ A @ X @ A4 )
         => ( ( ( ( minus_minus @ ( set @ A ) @ A4 @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
                = ( bot_bot @ ( set @ A ) ) )
             => ( ( lattic1715443433743089157tice_F @ A @ F2 @ A4 )
                = X ) )
            & ( ( ( minus_minus @ ( set @ A ) @ A4 @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
               != ( bot_bot @ ( set @ A ) ) )
             => ( ( lattic1715443433743089157tice_F @ A @ F2 @ A4 )
                = ( F2 @ X @ ( lattic1715443433743089157tice_F @ A @ F2 @ ( minus_minus @ ( set @ A ) @ A4 @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ) ) ) ) ).

% semilattice_set.remove
thf(fact_7520_semilattice__set_Oin__idem,axiom,
    ! [A: $tType,F2: A > A > A,A4: set @ A,X: A] :
      ( ( lattic149705377957585745ce_set @ A @ F2 )
     => ( ( finite_finite @ A @ A4 )
       => ( ( member @ A @ X @ A4 )
         => ( ( F2 @ X @ ( lattic1715443433743089157tice_F @ A @ F2 @ A4 ) )
            = ( lattic1715443433743089157tice_F @ A @ F2 @ A4 ) ) ) ) ) ).

% semilattice_set.in_idem
thf(fact_7521_Sup__fin_Osemilattice__set__axioms,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ( lattic149705377957585745ce_set @ A @ ( sup_sup @ A ) ) ) ).

% Sup_fin.semilattice_set_axioms
thf(fact_7522_Inf__fin_Osemilattice__set__axioms,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ( lattic149705377957585745ce_set @ A @ ( inf_inf @ A ) ) ) ).

% Inf_fin.semilattice_set_axioms
thf(fact_7523_Max_Osemilattice__set__axioms,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( lattic149705377957585745ce_set @ A @ ( ord_max @ A ) ) ) ).

% Max.semilattice_set_axioms
thf(fact_7524_Min_Osemilattice__set__axioms,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( lattic149705377957585745ce_set @ A @ ( ord_min @ A ) ) ) ).

% Min.semilattice_set_axioms
thf(fact_7525_semilattice__order__set_Oaxioms_I2_J,axiom,
    ! [A: $tType,F2: A > A > A,Less_eq: A > A > $o,Less: A > A > $o] :
      ( ( lattic4895041142388067077er_set @ A @ F2 @ Less_eq @ Less )
     => ( lattic149705377957585745ce_set @ A @ F2 ) ) ).

% semilattice_order_set.axioms(2)
thf(fact_7526_semilattice__set_Osingleton,axiom,
    ! [A: $tType,F2: A > A > A,X: A] :
      ( ( lattic149705377957585745ce_set @ A @ F2 )
     => ( ( lattic1715443433743089157tice_F @ A @ F2 @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
        = X ) ) ).

% semilattice_set.singleton
thf(fact_7527_semilattice__set_Ohom__commute,axiom,
    ! [A: $tType,F2: A > A > A,H2: A > A,N4: set @ A] :
      ( ( lattic149705377957585745ce_set @ A @ F2 )
     => ( ! [X3: A,Y5: A] :
            ( ( H2 @ ( F2 @ X3 @ Y5 ) )
            = ( F2 @ ( H2 @ X3 ) @ ( H2 @ Y5 ) ) )
       => ( ( finite_finite @ A @ N4 )
         => ( ( N4
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( H2 @ ( lattic1715443433743089157tice_F @ A @ F2 @ N4 ) )
              = ( lattic1715443433743089157tice_F @ A @ F2 @ ( image @ A @ A @ H2 @ N4 ) ) ) ) ) ) ) ).

% semilattice_set.hom_commute
thf(fact_7528_semilattice__set_Osubset,axiom,
    ! [A: $tType,F2: A > A > A,A4: set @ A,B7: set @ A] :
      ( ( lattic149705377957585745ce_set @ A @ F2 )
     => ( ( finite_finite @ A @ A4 )
       => ( ( B7
           != ( bot_bot @ ( set @ A ) ) )
         => ( ( ord_less_eq @ ( set @ A ) @ B7 @ A4 )
           => ( ( F2 @ ( lattic1715443433743089157tice_F @ A @ F2 @ B7 ) @ ( lattic1715443433743089157tice_F @ A @ F2 @ A4 ) )
              = ( lattic1715443433743089157tice_F @ A @ F2 @ A4 ) ) ) ) ) ) ).

% semilattice_set.subset
thf(fact_7529_semilattice__set_Oclosed,axiom,
    ! [A: $tType,F2: A > A > A,A4: set @ A] :
      ( ( lattic149705377957585745ce_set @ A @ F2 )
     => ( ( finite_finite @ A @ A4 )
       => ( ( A4
           != ( bot_bot @ ( set @ A ) ) )
         => ( ! [X3: A,Y5: A] : ( member @ A @ ( F2 @ X3 @ Y5 ) @ ( insert @ A @ X3 @ ( insert @ A @ Y5 @ ( bot_bot @ ( set @ A ) ) ) ) )
           => ( member @ A @ ( lattic1715443433743089157tice_F @ A @ F2 @ A4 ) @ A4 ) ) ) ) ) ).

% semilattice_set.closed
thf(fact_7530_semilattice__set_Oinsert,axiom,
    ! [A: $tType,F2: A > A > A,A4: set @ A,X: A] :
      ( ( lattic149705377957585745ce_set @ A @ F2 )
     => ( ( finite_finite @ A @ A4 )
       => ( ( A4
           != ( bot_bot @ ( set @ A ) ) )
         => ( ( lattic1715443433743089157tice_F @ A @ F2 @ ( insert @ A @ X @ A4 ) )
            = ( F2 @ X @ ( lattic1715443433743089157tice_F @ A @ F2 @ A4 ) ) ) ) ) ) ).

% semilattice_set.insert
thf(fact_7531_semilattice__set_Oinsert__not__elem,axiom,
    ! [A: $tType,F2: A > A > A,A4: set @ A,X: A] :
      ( ( lattic149705377957585745ce_set @ A @ F2 )
     => ( ( finite_finite @ A @ A4 )
       => ( ~ ( member @ A @ X @ A4 )
         => ( ( A4
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( lattic1715443433743089157tice_F @ A @ F2 @ ( insert @ A @ X @ A4 ) )
              = ( F2 @ X @ ( lattic1715443433743089157tice_F @ A @ F2 @ A4 ) ) ) ) ) ) ) ).

% semilattice_set.insert_not_elem
thf(fact_7532_semilattice__set_Ounion,axiom,
    ! [A: $tType,F2: A > A > A,A4: set @ A,B7: set @ A] :
      ( ( lattic149705377957585745ce_set @ A @ F2 )
     => ( ( finite_finite @ A @ A4 )
       => ( ( A4
           != ( bot_bot @ ( set @ A ) ) )
         => ( ( finite_finite @ A @ B7 )
           => ( ( B7
               != ( bot_bot @ ( set @ A ) ) )
             => ( ( lattic1715443433743089157tice_F @ A @ F2 @ ( sup_sup @ ( set @ A ) @ A4 @ B7 ) )
                = ( F2 @ ( lattic1715443433743089157tice_F @ A @ F2 @ A4 ) @ ( lattic1715443433743089157tice_F @ A @ F2 @ B7 ) ) ) ) ) ) ) ) ).

% semilattice_set.union
thf(fact_7533_semilattice__set_Oeq__fold,axiom,
    ! [A: $tType,F2: A > A > A,A4: set @ A,X: A] :
      ( ( lattic149705377957585745ce_set @ A @ F2 )
     => ( ( finite_finite @ A @ A4 )
       => ( ( lattic1715443433743089157tice_F @ A @ F2 @ ( insert @ A @ X @ A4 ) )
          = ( finite_fold @ A @ A @ F2 @ X @ A4 ) ) ) ) ).

% semilattice_set.eq_fold
thf(fact_7534_semilattice__set_Oinfinite,axiom,
    ! [A: $tType,F2: A > A > A,A4: set @ A] :
      ( ( lattic149705377957585745ce_set @ A @ F2 )
     => ( ~ ( finite_finite @ A @ A4 )
       => ( ( lattic1715443433743089157tice_F @ A @ F2 @ A4 )
          = ( the2 @ A @ ( none @ A ) ) ) ) ) ).

% semilattice_set.infinite
thf(fact_7535_semilattice__set_Oinsert__remove,axiom,
    ! [A: $tType,F2: A > A > A,A4: set @ A,X: A] :
      ( ( lattic149705377957585745ce_set @ A @ F2 )
     => ( ( finite_finite @ A @ A4 )
       => ( ( ( ( minus_minus @ ( set @ A ) @ A4 @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
              = ( bot_bot @ ( set @ A ) ) )
           => ( ( lattic1715443433743089157tice_F @ A @ F2 @ ( insert @ A @ X @ A4 ) )
              = X ) )
          & ( ( ( minus_minus @ ( set @ A ) @ A4 @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) )
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( lattic1715443433743089157tice_F @ A @ F2 @ ( insert @ A @ X @ A4 ) )
              = ( F2 @ X @ ( lattic1715443433743089157tice_F @ A @ F2 @ ( minus_minus @ ( set @ A ) @ A4 @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ) ) ) ).

% semilattice_set.insert_remove
thf(fact_7536_cr__int__def,axiom,
    ( cr_int
    = ( ^ [X2: product_prod @ nat @ nat] :
          ( ^ [Y3: int,Z2: int] : ( Y3 = Z2 )
          @ ( abs_Integ @ X2 ) ) ) ) ).

% cr_int_def
thf(fact_7537_gfp__Kleene__iter,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [F2: A > A,K: nat] :
          ( ( order_mono @ A @ A @ F2 )
         => ( ( ( compow @ ( A > A ) @ ( suc @ K ) @ F2 @ ( top_top @ A ) )
              = ( compow @ ( A > A ) @ K @ F2 @ ( top_top @ A ) ) )
           => ( ( complete_lattice_gfp @ A @ F2 )
              = ( compow @ ( A > A ) @ K @ F2 @ ( top_top @ A ) ) ) ) ) ) ).

% gfp_Kleene_iter
thf(fact_7538_gfp__gfp,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [F2: A > A > A] :
          ( ! [X3: A,Y5: A,W2: A,Z3: A] :
              ( ( ord_less_eq @ A @ X3 @ Y5 )
             => ( ( ord_less_eq @ A @ W2 @ Z3 )
               => ( ord_less_eq @ A @ ( F2 @ X3 @ W2 ) @ ( F2 @ Y5 @ Z3 ) ) ) )
         => ( ( complete_lattice_gfp @ A
              @ ^ [X2: A] : ( complete_lattice_gfp @ A @ ( F2 @ X2 ) ) )
            = ( complete_lattice_gfp @ A
              @ ^ [X2: A] : ( F2 @ X2 @ X2 ) ) ) ) ) ).

% gfp_gfp
thf(fact_7539_gfp__least,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [F2: A > A,X7: A] :
          ( ! [U4: A] :
              ( ( ord_less_eq @ A @ U4 @ ( F2 @ U4 ) )
             => ( ord_less_eq @ A @ U4 @ X7 ) )
         => ( ord_less_eq @ A @ ( complete_lattice_gfp @ A @ F2 ) @ X7 ) ) ) ).

% gfp_least
thf(fact_7540_gfp__upperbound,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [X7: A,F2: A > A] :
          ( ( ord_less_eq @ A @ X7 @ ( F2 @ X7 ) )
         => ( ord_less_eq @ A @ X7 @ ( complete_lattice_gfp @ A @ F2 ) ) ) ) ).

% gfp_upperbound
thf(fact_7541_gfp__mono,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [F2: A > A,G: A > A] :
          ( ! [Z9: A] : ( ord_less_eq @ A @ ( F2 @ Z9 ) @ ( G @ Z9 ) )
         => ( ord_less_eq @ A @ ( complete_lattice_gfp @ A @ F2 ) @ ( complete_lattice_gfp @ A @ G ) ) ) ) ).

% gfp_mono
thf(fact_7542_gfp__def,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ( ( complete_lattice_gfp @ A )
        = ( ^ [F3: A > A] :
              ( complete_Sup_Sup @ A
              @ ( collect @ A
                @ ^ [U2: A] : ( ord_less_eq @ A @ U2 @ ( F3 @ U2 ) ) ) ) ) ) ) ).

% gfp_def
thf(fact_7543_gfp__eqI,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [F4: A > A,X: A] :
          ( ( order_mono @ A @ A @ F4 )
         => ( ( ( F4 @ X )
              = X )
           => ( ! [Z3: A] :
                  ( ( ( F4 @ Z3 )
                    = Z3 )
                 => ( ord_less_eq @ A @ Z3 @ X ) )
             => ( ( complete_lattice_gfp @ A @ F4 )
                = X ) ) ) ) ) ).

% gfp_eqI
thf(fact_7544_coinduct__lemma,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [X7: A,F2: A > A] :
          ( ( ord_less_eq @ A @ X7 @ ( F2 @ ( sup_sup @ A @ X7 @ ( complete_lattice_gfp @ A @ F2 ) ) ) )
         => ( ( order_mono @ A @ A @ F2 )
           => ( ord_less_eq @ A @ ( sup_sup @ A @ X7 @ ( complete_lattice_gfp @ A @ F2 ) ) @ ( F2 @ ( sup_sup @ A @ X7 @ ( complete_lattice_gfp @ A @ F2 ) ) ) ) ) ) ) ).

% coinduct_lemma
thf(fact_7545_def__coinduct,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [A4: A,F2: A > A,X7: A] :
          ( ( A4
            = ( complete_lattice_gfp @ A @ F2 ) )
         => ( ( order_mono @ A @ A @ F2 )
           => ( ( ord_less_eq @ A @ X7 @ ( F2 @ ( sup_sup @ A @ X7 @ A4 ) ) )
             => ( ord_less_eq @ A @ X7 @ A4 ) ) ) ) ) ).

% def_coinduct
thf(fact_7546_coinduct,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [F2: A > A,X7: A] :
          ( ( order_mono @ A @ A @ F2 )
         => ( ( ord_less_eq @ A @ X7 @ ( F2 @ ( sup_sup @ A @ X7 @ ( complete_lattice_gfp @ A @ F2 ) ) ) )
           => ( ord_less_eq @ A @ X7 @ ( complete_lattice_gfp @ A @ F2 ) ) ) ) ) ).

% coinduct
thf(fact_7547_gfp__ordinal__induct,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [F2: A > A,P: A > $o] :
          ( ( order_mono @ A @ A @ F2 )
         => ( ! [S4: A] :
                ( ( P @ S4 )
               => ( ( ord_less_eq @ A @ ( complete_lattice_gfp @ A @ F2 ) @ S4 )
                 => ( P @ ( F2 @ S4 ) ) ) )
           => ( ! [M10: set @ A] :
                  ( ! [X5: A] :
                      ( ( member @ A @ X5 @ M10 )
                     => ( P @ X5 ) )
                 => ( P @ ( complete_Inf_Inf @ A @ M10 ) ) )
             => ( P @ ( complete_lattice_gfp @ A @ F2 ) ) ) ) ) ) ).

% gfp_ordinal_induct
thf(fact_7548_gfp__funpow,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [F2: A > A,N: nat] :
          ( ( order_mono @ A @ A @ F2 )
         => ( ( complete_lattice_gfp @ A @ ( compow @ ( A > A ) @ ( suc @ N ) @ F2 ) )
            = ( complete_lattice_gfp @ A @ F2 ) ) ) ) ).

% gfp_funpow
thf(fact_7549_lfp__le__gfp,axiom,
    ! [A: $tType] :
      ( ( comple6319245703460814977attice @ A )
     => ! [F2: A > A] :
          ( ( order_mono @ A @ A @ F2 )
         => ( ord_less_eq @ A @ ( complete_lattice_lfp @ A @ F2 ) @ ( complete_lattice_gfp @ A @ F2 ) ) ) ) ).

% lfp_le_gfp
thf(fact_7550_int_Opcr__cr__eq,axiom,
    pcr_int = cr_int ).

% int.pcr_cr_eq
thf(fact_7551_gfp__transfer__bounded,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( comple6319245703460814977attice @ B )
        & ( comple6319245703460814977attice @ A ) )
     => ! [P: A > $o,F2: A > A,Alpha: A > B,G: B > B] :
          ( ( P @ ( F2 @ ( top_top @ A ) ) )
         => ( ! [X3: A] :
                ( ( P @ X3 )
               => ( P @ ( F2 @ X3 ) ) )
           => ( ! [M10: nat > A] :
                  ( ( order_antimono @ nat @ A @ M10 )
                 => ( ! [I3: nat] : ( P @ ( M10 @ I3 ) )
                   => ( P @ ( complete_Inf_Inf @ A @ ( image @ nat @ A @ M10 @ ( top_top @ ( set @ nat ) ) ) ) ) ) )
             => ( ! [M10: nat > A] :
                    ( ( order_antimono @ nat @ A @ M10 )
                   => ( ! [I3: nat] : ( P @ ( M10 @ I3 ) )
                     => ( ( Alpha @ ( complete_Inf_Inf @ A @ ( image @ nat @ A @ M10 @ ( top_top @ ( set @ nat ) ) ) ) )
                        = ( complete_Inf_Inf @ B
                          @ ( image @ nat @ B
                            @ ^ [I4: nat] : ( Alpha @ ( M10 @ I4 ) )
                            @ ( top_top @ ( set @ nat ) ) ) ) ) ) )
               => ( ( order_inf_continuous @ A @ A @ F2 )
                 => ( ( order_inf_continuous @ B @ B @ G )
                   => ( ! [X3: A] :
                          ( ( P @ X3 )
                         => ( ( Alpha @ ( F2 @ X3 ) )
                            = ( G @ ( Alpha @ X3 ) ) ) )
                     => ( ! [X3: B] : ( ord_less_eq @ B @ ( G @ X3 ) @ ( Alpha @ ( F2 @ ( top_top @ A ) ) ) )
                       => ( ( Alpha @ ( complete_lattice_gfp @ A @ F2 ) )
                          = ( complete_lattice_gfp @ B @ G ) ) ) ) ) ) ) ) ) ) ) ).

% gfp_transfer_bounded
thf(fact_7552_Quotient__int,axiom,
    quotient @ ( product_prod @ nat @ nat ) @ int @ intrel @ abs_Integ @ rep_Integ @ cr_int ).

% Quotient_int
thf(fact_7553_strict__sorted__equal__Uniq,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [A4: set @ A] :
          ( uniq @ ( list @ A )
          @ ^ [Xs3: list @ A] :
              ( ( sorted_wrt @ A @ ( ord_less @ A ) @ Xs3 )
              & ( ( set2 @ A @ Xs3 )
                = A4 ) ) ) ) ).

% strict_sorted_equal_Uniq
thf(fact_7554_map__of__zip__nth,axiom,
    ! [A: $tType,B: $tType,Xs: list @ A,Ys3: list @ B,I: nat] :
      ( ( ( size_size @ ( list @ A ) @ Xs )
        = ( size_size @ ( list @ B ) @ Ys3 ) )
     => ( ( distinct @ A @ Xs )
       => ( ( ord_less @ nat @ I @ ( size_size @ ( list @ B ) @ Ys3 ) )
         => ( ( map_of @ A @ B @ ( zip @ A @ B @ Xs @ Ys3 ) @ ( nth @ A @ Xs @ I ) )
            = ( some @ B @ ( nth @ B @ Ys3 @ I ) ) ) ) ) ) ).

% map_of_zip_nth
thf(fact_7555_map__upds__list__update2__drop,axiom,
    ! [A: $tType,B: $tType,Xs: list @ A,I: nat,M: A > ( option @ B ),Ys3: list @ B,Y: B] :
      ( ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ I )
     => ( ( map_upds @ A @ B @ M @ Xs @ ( list_update @ B @ Ys3 @ I @ Y ) )
        = ( map_upds @ A @ B @ M @ Xs @ Ys3 ) ) ) ).

% map_upds_list_update2_drop
thf(fact_7556_list__ex__length,axiom,
    ! [A: $tType] :
      ( ( list_ex @ A )
      = ( ^ [P3: A > $o,Xs3: list @ A] :
          ? [N3: nat] :
            ( ( ord_less @ nat @ N3 @ ( size_size @ ( list @ A ) @ Xs3 ) )
            & ( P3 @ ( nth @ A @ Xs3 @ N3 ) ) ) ) ) ).

% list_ex_length
thf(fact_7557_map__upds__append1,axiom,
    ! [B: $tType,A: $tType,Xs: list @ A,Ys3: list @ B,M: A > ( option @ B ),X: A] :
      ( ( ord_less @ nat @ ( size_size @ ( list @ A ) @ Xs ) @ ( size_size @ ( list @ B ) @ Ys3 ) )
     => ( ( map_upds @ A @ B @ M @ ( append @ A @ Xs @ ( cons @ A @ X @ ( nil @ A ) ) ) @ Ys3 )
        = ( fun_upd @ A @ ( option @ B ) @ ( map_upds @ A @ B @ M @ Xs @ Ys3 ) @ X @ ( some @ B @ ( nth @ B @ Ys3 @ ( size_size @ ( list @ A ) @ Xs ) ) ) ) ) ) ).

% map_upds_append1
thf(fact_7558_and_Osemilattice__neutr__axioms,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( semilattice_neutr @ A @ ( bit_se5824344872417868541ns_and @ A ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% and.semilattice_neutr_axioms
thf(fact_7559_semilattice__neutr__order_Oaxioms_I1_J,axiom,
    ! [A: $tType,F2: A > A > A,Z: A,Less_eq: A > A > $o,Less: A > A > $o] :
      ( ( semila1105856199041335345_order @ A @ F2 @ Z @ Less_eq @ Less )
     => ( semilattice_neutr @ A @ F2 @ Z ) ) ).

% semilattice_neutr_order.axioms(1)
thf(fact_7560_inf__top_Osemilattice__neutr__axioms,axiom,
    ! [A: $tType] :
      ( ( bounde4346867609351753570nf_top @ A )
     => ( semilattice_neutr @ A @ ( inf_inf @ A ) @ ( top_top @ A ) ) ) ).

% inf_top.semilattice_neutr_axioms
thf(fact_7561_sup__bot_Osemilattice__neutr__axioms,axiom,
    ! [A: $tType] :
      ( ( bounde4967611905675639751up_bot @ A )
     => ( semilattice_neutr @ A @ ( sup_sup @ A ) @ ( bot_bot @ A ) ) ) ).

% sup_bot.semilattice_neutr_axioms
thf(fact_7562_gcd__nat_Osemilattice__neutr__axioms,axiom,
    semilattice_neutr @ nat @ ( gcd_gcd @ nat ) @ ( zero_zero @ nat ) ).

% gcd_nat.semilattice_neutr_axioms
thf(fact_7563_or_Osemilattice__neutr__axioms,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( semilattice_neutr @ A @ ( bit_se1065995026697491101ons_or @ A ) @ ( zero_zero @ A ) ) ) ).

% or.semilattice_neutr_axioms
thf(fact_7564_max__nat_Osemilattice__neutr__axioms,axiom,
    semilattice_neutr @ nat @ ( ord_max @ nat ) @ ( zero_zero @ nat ) ).

% max_nat.semilattice_neutr_axioms
thf(fact_7565_cclfp__lowerbound,axiom,
    ! [A: $tType] :
      ( ( counta3822494911875563373attice @ A )
     => ! [F2: A > A,A4: A] :
          ( ( order_mono @ A @ A @ F2 )
         => ( ( ord_less_eq @ A @ ( F2 @ A4 ) @ A4 )
           => ( ord_less_eq @ A @ ( order_532582986084564980_cclfp @ A @ F2 ) @ A4 ) ) ) ) ).

% cclfp_lowerbound
thf(fact_7566_sum__list__def,axiom,
    ! [A: $tType] :
      ( ( monoid_add @ A )
     => ( ( groups8242544230860333062m_list @ A )
        = ( groups_monoid_F @ A @ ( plus_plus @ A ) @ ( zero_zero @ A ) ) ) ) ).

% sum_list_def
thf(fact_7567_construct__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V4867850818363320053vector @ A )
        & ( real_V4867850818363320053vector @ B ) )
     => ( ( real_V4425403222259421789struct @ A @ B )
        = ( ^ [B6: set @ A,G2: A > B,V5: A] :
              ( groups7311177749621191930dd_sum @ A @ B
              @ ^ [B3: A] : ( real_V8093663219630862766scaleR @ B @ ( real_V7696804695334737415tation @ A @ ( real_V4986007116245087402_basis @ A @ B6 ) @ V5 @ B3 ) @ ( if @ B @ ( member @ A @ B3 @ B6 ) @ ( G2 @ B3 ) @ ( zero_zero @ B ) ) )
              @ ( collect @ A
                @ ^ [B3: A] :
                    ( ( real_V7696804695334737415tation @ A @ ( real_V4986007116245087402_basis @ A @ B6 ) @ V5 @ B3 )
                   != ( zero_zero @ real ) ) ) ) ) ) ) ).

% construct_def
thf(fact_7568_natLess__def,axiom,
    ( bNF_Ca8459412986667044542atLess
    = ( collect @ ( product_prod @ nat @ nat ) @ ( product_case_prod @ nat @ nat @ $o @ ( ord_less @ nat ) ) ) ) ).

% natLess_def
thf(fact_7569_construct__outside,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( real_V4867850818363320053vector @ B )
        & ( real_V4867850818363320053vector @ A ) )
     => ! [B7: set @ A,V: A,F2: A > B] :
          ( ~ ( real_V358717886546972837endent @ A @ B7 )
         => ( ( member @ A @ V @ ( real_Vector_span @ A @ ( minus_minus @ ( set @ A ) @ ( real_V4986007116245087402_basis @ A @ B7 ) @ B7 ) ) )
           => ( ( real_V4425403222259421789struct @ A @ B @ B7 @ F2 @ V )
              = ( zero_zero @ B ) ) ) ) ) ).

% construct_outside
thf(fact_7570_relChain__def,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ord @ B )
     => ( ( bNF_Ca3754400796208372196lChain @ A @ B )
        = ( ^ [R5: set @ ( product_prod @ A @ A ),As: A > B] :
            ! [I4: A,J3: A] :
              ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ I4 @ J3 ) @ R5 )
             => ( ord_less_eq @ B @ ( As @ I4 ) @ ( As @ J3 ) ) ) ) ) ) ).

% relChain_def
thf(fact_7571_Restr__natLeq,axiom,
    ! [N: nat] :
      ( ( inf_inf @ ( set @ ( product_prod @ nat @ nat ) ) @ bNF_Ca8665028551170535155natLeq
        @ ( product_Sigma @ nat @ nat
          @ ( collect @ nat
            @ ^ [X2: nat] : ( ord_less @ nat @ X2 @ N ) )
          @ ^ [Uu3: nat] :
              ( collect @ nat
              @ ^ [X2: nat] : ( ord_less @ nat @ X2 @ N ) ) ) )
      = ( collect @ ( product_prod @ nat @ nat )
        @ ( product_case_prod @ nat @ nat @ $o
          @ ^ [X2: nat,Y4: nat] :
              ( ( ord_less @ nat @ X2 @ N )
              & ( ord_less @ nat @ Y4 @ N )
              & ( ord_less_eq @ nat @ X2 @ Y4 ) ) ) ) ) ).

% Restr_natLeq
thf(fact_7572_natLeq__def,axiom,
    ( bNF_Ca8665028551170535155natLeq
    = ( collect @ ( product_prod @ nat @ nat ) @ ( product_case_prod @ nat @ nat @ $o @ ( ord_less_eq @ nat ) ) ) ) ).

% natLeq_def
thf(fact_7573_Restr__natLeq2,axiom,
    ! [N: nat] :
      ( ( inf_inf @ ( set @ ( product_prod @ nat @ nat ) ) @ bNF_Ca8665028551170535155natLeq
        @ ( product_Sigma @ nat @ nat @ ( order_underS @ nat @ bNF_Ca8665028551170535155natLeq @ N )
          @ ^ [Uu3: nat] : ( order_underS @ nat @ bNF_Ca8665028551170535155natLeq @ N ) ) )
      = ( collect @ ( product_prod @ nat @ nat )
        @ ( product_case_prod @ nat @ nat @ $o
          @ ^ [X2: nat,Y4: nat] :
              ( ( ord_less @ nat @ X2 @ N )
              & ( ord_less @ nat @ Y4 @ N )
              & ( ord_less_eq @ nat @ X2 @ Y4 ) ) ) ) ) ).

% Restr_natLeq2
thf(fact_7574_sorted__list__of__set_Ofolding__insort__key__axioms,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( folding_insort_key @ A @ A @ ( ord_less_eq @ A ) @ ( ord_less @ A ) @ ( top_top @ ( set @ A ) )
        @ ^ [X2: A] : X2 ) ) ).

% sorted_list_of_set.folding_insort_key_axioms
thf(fact_7575_natLeq__underS__less,axiom,
    ! [N: nat] :
      ( ( order_underS @ nat @ bNF_Ca8665028551170535155natLeq @ N )
      = ( collect @ nat
        @ ^ [X2: nat] : ( ord_less @ nat @ X2 @ N ) ) ) ).

% natLeq_underS_less
thf(fact_7576_fun__cong__unused__0,axiom,
    ! [A: $tType,B: $tType,C: $tType] :
      ( ( zero @ B )
     => ! [F2: ( A > B ) > C,G: C] :
          ( ( F2
            = ( ^ [X2: A > B] : G ) )
         => ( ( F2
              @ ^ [X2: A] : ( zero_zero @ B ) )
            = G ) ) ) ).

% fun_cong_unused_0
thf(fact_7577_add_Ogroup__axioms,axiom,
    ! [A: $tType] :
      ( ( group_add @ A )
     => ( group @ A @ ( plus_plus @ A ) @ ( zero_zero @ A ) @ ( uminus_uminus @ A ) ) ) ).

% add.group_axioms
thf(fact_7578_group_Oleft__cancel,axiom,
    ! [A: $tType,F2: A > A > A,Z: A,Inverse: A > A,A2: A,B2: A,C2: A] :
      ( ( group @ A @ F2 @ Z @ Inverse )
     => ( ( ( F2 @ A2 @ B2 )
          = ( F2 @ A2 @ C2 ) )
        = ( B2 = C2 ) ) ) ).

% group.left_cancel
thf(fact_7579_group_Oleft__inverse,axiom,
    ! [A: $tType,F2: A > A > A,Z: A,Inverse: A > A,A2: A] :
      ( ( group @ A @ F2 @ Z @ Inverse )
     => ( ( F2 @ ( Inverse @ A2 ) @ A2 )
        = Z ) ) ).

% group.left_inverse
thf(fact_7580_group_Oright__cancel,axiom,
    ! [A: $tType,F2: A > A > A,Z: A,Inverse: A > A,B2: A,A2: A,C2: A] :
      ( ( group @ A @ F2 @ Z @ Inverse )
     => ( ( ( F2 @ B2 @ A2 )
          = ( F2 @ C2 @ A2 ) )
        = ( B2 = C2 ) ) ) ).

% group.right_cancel
thf(fact_7581_group_Oright__inverse,axiom,
    ! [A: $tType,F2: A > A > A,Z: A,Inverse: A > A,A2: A] :
      ( ( group @ A @ F2 @ Z @ Inverse )
     => ( ( F2 @ A2 @ ( Inverse @ A2 ) )
        = Z ) ) ).

% group.right_inverse
thf(fact_7582_group_Oinverse__unique,axiom,
    ! [A: $tType,F2: A > A > A,Z: A,Inverse: A > A,A2: A,B2: A] :
      ( ( group @ A @ F2 @ Z @ Inverse )
     => ( ( ( F2 @ A2 @ B2 )
          = Z )
       => ( ( Inverse @ A2 )
          = B2 ) ) ) ).

% group.inverse_unique
thf(fact_7583_group_Oinverse__inverse,axiom,
    ! [A: $tType,F2: A > A > A,Z: A,Inverse: A > A,A2: A] :
      ( ( group @ A @ F2 @ Z @ Inverse )
     => ( ( Inverse @ ( Inverse @ A2 ) )
        = A2 ) ) ).

% group.inverse_inverse
thf(fact_7584_group_Oinverse__neutral,axiom,
    ! [A: $tType,F2: A > A > A,Z: A,Inverse: A > A] :
      ( ( group @ A @ F2 @ Z @ Inverse )
     => ( ( Inverse @ Z )
        = Z ) ) ).

% group.inverse_neutral
thf(fact_7585_group_Ogroup__left__neutral,axiom,
    ! [A: $tType,F2: A > A > A,Z: A,Inverse: A > A,A2: A] :
      ( ( group @ A @ F2 @ Z @ Inverse )
     => ( ( F2 @ Z @ A2 )
        = A2 ) ) ).

% group.group_left_neutral
thf(fact_7586_group_Oinverse__distrib__swap,axiom,
    ! [A: $tType,F2: A > A > A,Z: A,Inverse: A > A,A2: A,B2: A] :
      ( ( group @ A @ F2 @ Z @ Inverse )
     => ( ( Inverse @ ( F2 @ A2 @ B2 ) )
        = ( F2 @ ( Inverse @ B2 ) @ ( Inverse @ A2 ) ) ) ) ).

% group.inverse_distrib_swap
thf(fact_7587_sub_Oabs__eq,axiom,
    ( code_sub
    = ( ^ [Xa4: num,X2: num] : ( code_integer_of_int @ ( minus_minus @ int @ ( numeral_numeral @ int @ Xa4 ) @ ( numeral_numeral @ int @ X2 ) ) ) ) ) ).

% sub.abs_eq
thf(fact_7588_sub_Orep__eq,axiom,
    ! [X: num,Xa: num] :
      ( ( code_int_of_integer @ ( code_sub @ X @ Xa ) )
      = ( minus_minus @ int @ ( numeral_numeral @ int @ X ) @ ( numeral_numeral @ int @ Xa ) ) ) ).

% sub.rep_eq
thf(fact_7589_Code__Numeral_Osub__code_I1_J,axiom,
    ( ( code_sub @ one2 @ one2 )
    = ( zero_zero @ code_integer ) ) ).

% Code_Numeral.sub_code(1)
thf(fact_7590_Code__Numeral_Osub__code_I9_J,axiom,
    ! [M: num,N: num] :
      ( ( code_sub @ ( bit0 @ M ) @ ( bit1 @ N ) )
      = ( minus_minus @ code_integer @ ( code_dup @ ( code_sub @ M @ N ) ) @ ( one_one @ code_integer ) ) ) ).

% Code_Numeral.sub_code(9)
thf(fact_7591_Code__Numeral_Osub__code_I8_J,axiom,
    ! [M: num,N: num] :
      ( ( code_sub @ ( bit1 @ M ) @ ( bit0 @ N ) )
      = ( plus_plus @ code_integer @ ( code_dup @ ( code_sub @ M @ N ) ) @ ( one_one @ code_integer ) ) ) ).

% Code_Numeral.sub_code(8)
thf(fact_7592_Code__Numeral_Odup__code_I1_J,axiom,
    ( ( code_dup @ ( zero_zero @ code_integer ) )
    = ( zero_zero @ code_integer ) ) ).

% Code_Numeral.dup_code(1)
thf(fact_7593_Code__Numeral_Osub__code_I6_J,axiom,
    ! [M: num,N: num] :
      ( ( code_sub @ ( bit0 @ M ) @ ( bit0 @ N ) )
      = ( code_dup @ ( code_sub @ M @ N ) ) ) ).

% Code_Numeral.sub_code(6)
thf(fact_7594_Code__Numeral_Osub__code_I4_J,axiom,
    ! [N: num] :
      ( ( code_sub @ one2 @ ( bit0 @ N ) )
      = ( code_Neg @ ( bitM @ N ) ) ) ).

% Code_Numeral.sub_code(4)
thf(fact_7595_Code__Numeral_Osub__code_I2_J,axiom,
    ! [M: num] :
      ( ( code_sub @ ( bit0 @ M ) @ one2 )
      = ( code_Pos @ ( bitM @ M ) ) ) ).

% Code_Numeral.sub_code(2)
thf(fact_7596_Code__Numeral_Odup__code_I3_J,axiom,
    ! [N: num] :
      ( ( code_dup @ ( code_Neg @ N ) )
      = ( code_Neg @ ( bit0 @ N ) ) ) ).

% Code_Numeral.dup_code(3)
thf(fact_7597_Code__Numeral_Odup__code_I2_J,axiom,
    ! [N: num] :
      ( ( code_dup @ ( code_Pos @ N ) )
      = ( code_Pos @ ( bit0 @ N ) ) ) ).

% Code_Numeral.dup_code(2)
thf(fact_7598_less__eq__integer__code_I9_J,axiom,
    ! [K: num,L: num] :
      ( ( ord_less_eq @ code_integer @ ( code_Neg @ K ) @ ( code_Neg @ L ) )
      = ( ord_less_eq @ num @ L @ K ) ) ).

% less_eq_integer_code(9)
thf(fact_7599_less__integer__code_I9_J,axiom,
    ! [K: num,L: num] :
      ( ( ord_less @ code_integer @ ( code_Neg @ K ) @ ( code_Neg @ L ) )
      = ( ord_less @ num @ L @ K ) ) ).

% less_integer_code(9)
thf(fact_7600_less__eq__integer__code_I5_J,axiom,
    ! [K: num,L: num] :
      ( ( ord_less_eq @ code_integer @ ( code_Pos @ K ) @ ( code_Pos @ L ) )
      = ( ord_less_eq @ num @ K @ L ) ) ).

% less_eq_integer_code(5)
thf(fact_7601_one__integer__code,axiom,
    ( ( one_one @ code_integer )
    = ( code_Pos @ one2 ) ) ).

% one_integer_code
thf(fact_7602_Pos__fold_I1_J,axiom,
    ( ( numeral_numeral @ code_integer @ one2 )
    = ( code_Pos @ one2 ) ) ).

% Pos_fold(1)
thf(fact_7603_Pos__fold_I2_J,axiom,
    ! [K: num] :
      ( ( numeral_numeral @ code_integer @ ( bit0 @ K ) )
      = ( code_Pos @ ( bit0 @ K ) ) ) ).

% Pos_fold(2)
thf(fact_7604_less__integer__code_I5_J,axiom,
    ! [K: num,L: num] :
      ( ( ord_less @ code_integer @ ( code_Pos @ K ) @ ( code_Pos @ L ) )
      = ( ord_less @ num @ K @ L ) ) ).

% less_integer_code(5)
thf(fact_7605_less__integer__code_I7_J,axiom,
    ! [K: num] : ( ord_less @ code_integer @ ( code_Neg @ K ) @ ( zero_zero @ code_integer ) ) ).

% less_integer_code(7)
thf(fact_7606_less__integer__code_I3_J,axiom,
    ! [L: num] :
      ~ ( ord_less @ code_integer @ ( zero_zero @ code_integer ) @ ( code_Neg @ L ) ) ).

% less_integer_code(3)
thf(fact_7607_less__integer__code_I4_J,axiom,
    ! [K: num] :
      ~ ( ord_less @ code_integer @ ( code_Pos @ K ) @ ( zero_zero @ code_integer ) ) ).

% less_integer_code(4)
thf(fact_7608_less__integer__code_I2_J,axiom,
    ! [L: num] : ( ord_less @ code_integer @ ( zero_zero @ code_integer ) @ ( code_Pos @ L ) ) ).

% less_integer_code(2)
thf(fact_7609_less__eq__integer__code_I7_J,axiom,
    ! [K: num] : ( ord_less_eq @ code_integer @ ( code_Neg @ K ) @ ( zero_zero @ code_integer ) ) ).

% less_eq_integer_code(7)
thf(fact_7610_less__eq__integer__code_I3_J,axiom,
    ! [L: num] :
      ~ ( ord_less_eq @ code_integer @ ( zero_zero @ code_integer ) @ ( code_Neg @ L ) ) ).

% less_eq_integer_code(3)
thf(fact_7611_less__eq__integer__code_I2_J,axiom,
    ! [L: num] : ( ord_less_eq @ code_integer @ ( zero_zero @ code_integer ) @ ( code_Pos @ L ) ) ).

% less_eq_integer_code(2)
thf(fact_7612_less__eq__integer__code_I4_J,axiom,
    ! [K: num] :
      ~ ( ord_less_eq @ code_integer @ ( code_Pos @ K ) @ ( zero_zero @ code_integer ) ) ).

% less_eq_integer_code(4)
thf(fact_7613_Code__Numeral_Osub__code_I3_J,axiom,
    ! [M: num] :
      ( ( code_sub @ ( bit1 @ M ) @ one2 )
      = ( code_Pos @ ( bit0 @ M ) ) ) ).

% Code_Numeral.sub_code(3)
thf(fact_7614_Code__Numeral_Osub__code_I5_J,axiom,
    ! [N: num] :
      ( ( code_sub @ one2 @ ( bit1 @ N ) )
      = ( code_Neg @ ( bit0 @ N ) ) ) ).

% Code_Numeral.sub_code(5)
thf(fact_7615_and_Omonoid__axioms,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( monoid @ A @ ( bit_se5824344872417868541ns_and @ A ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% and.monoid_axioms
thf(fact_7616_iteratesp_Omono,axiom,
    ! [A: $tType] :
      ( ( comple9053668089753744459l_ccpo @ A )
     => ! [F2: A > A] :
          ( order_mono @ ( A > $o ) @ ( A > $o )
          @ ^ [P5: A > $o,X2: A] :
              ( ? [Y4: A] :
                  ( ( X2
                    = ( F2 @ Y4 ) )
                  & ( P5 @ Y4 ) )
              | ? [M8: set @ A] :
                  ( ( X2
                    = ( complete_Sup_Sup @ A @ M8 ) )
                  & ( comple1602240252501008431_chain @ A @ ( ord_less_eq @ A ) @ M8 )
                  & ! [Y4: A] :
                      ( ( member @ A @ Y4 @ M8 )
                     => ( P5 @ Y4 ) ) ) ) ) ) ).

% iteratesp.mono
thf(fact_7617_xor_Omonoid__axioms,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( monoid @ A @ ( bit_se5824344971392196577ns_xor @ A ) @ ( zero_zero @ A ) ) ) ).

% xor.monoid_axioms
thf(fact_7618_or_Omonoid__axioms,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( monoid @ A @ ( bit_se1065995026697491101ons_or @ A ) @ ( zero_zero @ A ) ) ) ).

% or.monoid_axioms
thf(fact_7619_sup__bot_Omonoid__axioms,axiom,
    ! [A: $tType] :
      ( ( bounde4967611905675639751up_bot @ A )
     => ( monoid @ A @ ( sup_sup @ A ) @ ( bot_bot @ A ) ) ) ).

% sup_bot.monoid_axioms
thf(fact_7620_ccpo__Sup__upper,axiom,
    ! [A: $tType] :
      ( ( comple9053668089753744459l_ccpo @ A )
     => ! [A4: set @ A,X: A] :
          ( ( comple1602240252501008431_chain @ A @ ( ord_less_eq @ A ) @ A4 )
         => ( ( member @ A @ X @ A4 )
           => ( ord_less_eq @ A @ X @ ( complete_Sup_Sup @ A @ A4 ) ) ) ) ) ).

% ccpo_Sup_upper
thf(fact_7621_ccpo__Sup__least,axiom,
    ! [A: $tType] :
      ( ( comple9053668089753744459l_ccpo @ A )
     => ! [A4: set @ A,Z: A] :
          ( ( comple1602240252501008431_chain @ A @ ( ord_less_eq @ A ) @ A4 )
         => ( ! [X3: A] :
                ( ( member @ A @ X3 @ A4 )
               => ( ord_less_eq @ A @ X3 @ Z ) )
           => ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ A4 ) @ Z ) ) ) ) ).

% ccpo_Sup_least
thf(fact_7622_chain__singleton,axiom,
    ! [A: $tType] :
      ( ( comple9053668089753744459l_ccpo @ A )
     => ! [X: A] : ( comple1602240252501008431_chain @ A @ ( ord_less_eq @ A ) @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) ).

% chain_singleton
thf(fact_7623_gcd__nat_Omonoid__axioms,axiom,
    monoid @ nat @ ( gcd_gcd @ nat ) @ ( zero_zero @ nat ) ).

% gcd_nat.monoid_axioms
thf(fact_7624_add_Omonoid__axioms,axiom,
    ! [A: $tType] :
      ( ( monoid_add @ A )
     => ( monoid @ A @ ( plus_plus @ A ) @ ( zero_zero @ A ) ) ) ).

% add.monoid_axioms
thf(fact_7625_mult_Omonoid__axioms,axiom,
    ! [A: $tType] :
      ( ( monoid_mult @ A )
     => ( monoid @ A @ ( times_times @ A ) @ ( one_one @ A ) ) ) ).

% mult.monoid_axioms
thf(fact_7626_monoid_Oleft__neutral,axiom,
    ! [A: $tType,F2: A > A > A,Z: A,A2: A] :
      ( ( monoid @ A @ F2 @ Z )
     => ( ( F2 @ Z @ A2 )
        = A2 ) ) ).

% monoid.left_neutral
thf(fact_7627_monoid_Oright__neutral,axiom,
    ! [A: $tType,F2: A > A > A,Z: A,A2: A] :
      ( ( monoid @ A @ F2 @ Z )
     => ( ( F2 @ A2 @ Z )
        = A2 ) ) ).

% monoid.right_neutral
thf(fact_7628_max__nat_Omonoid__axioms,axiom,
    monoid @ nat @ ( ord_max @ nat ) @ ( zero_zero @ nat ) ).

% max_nat.monoid_axioms
thf(fact_7629_inf__top_Omonoid__axioms,axiom,
    ! [A: $tType] :
      ( ( bounde4346867609351753570nf_top @ A )
     => ( monoid @ A @ ( inf_inf @ A ) @ ( top_top @ A ) ) ) ).

% inf_top.monoid_axioms
thf(fact_7630_in__chain__finite,axiom,
    ! [A: $tType] :
      ( ( comple9053668089753744459l_ccpo @ A )
     => ! [A4: set @ A] :
          ( ( comple1602240252501008431_chain @ A @ ( ord_less_eq @ A ) @ A4 )
         => ( ( finite_finite @ A @ A4 )
           => ( ( A4
               != ( bot_bot @ ( set @ A ) ) )
             => ( member @ A @ ( complete_Sup_Sup @ A @ A4 ) @ A4 ) ) ) ) ) ).

% in_chain_finite
thf(fact_7631_iteratesp__def,axiom,
    ! [A: $tType] :
      ( ( comple9053668089753744459l_ccpo @ A )
     => ( ( comple7512665784863727008ratesp @ A )
        = ( ^ [F3: A > A] :
              ( complete_lattice_lfp @ ( A > $o )
              @ ^ [P5: A > $o,X2: A] :
                  ( ? [Y4: A] :
                      ( ( X2
                        = ( F3 @ Y4 ) )
                      & ( P5 @ Y4 ) )
                  | ? [M8: set @ A] :
                      ( ( X2
                        = ( complete_Sup_Sup @ A @ M8 ) )
                      & ( comple1602240252501008431_chain @ A @ ( ord_less_eq @ A ) @ M8 )
                      & ! [Y4: A] :
                          ( ( member @ A @ Y4 @ M8 )
                         => ( P5 @ Y4 ) ) ) ) ) ) ) ) ).

% iteratesp_def
thf(fact_7632_iteratesp_OSup,axiom,
    ! [A: $tType] :
      ( ( comple9053668089753744459l_ccpo @ A )
     => ! [M5: set @ A,F2: A > A] :
          ( ( comple1602240252501008431_chain @ A @ ( ord_less_eq @ A ) @ M5 )
         => ( ! [X3: A] :
                ( ( member @ A @ X3 @ M5 )
               => ( comple7512665784863727008ratesp @ A @ F2 @ X3 ) )
           => ( comple7512665784863727008ratesp @ A @ F2 @ ( complete_Sup_Sup @ A @ M5 ) ) ) ) ) ).

% iteratesp.Sup
thf(fact_7633_iteratesp_Ocases,axiom,
    ! [A: $tType] :
      ( ( comple9053668089753744459l_ccpo @ A )
     => ! [F2: A > A,A2: A] :
          ( ( comple7512665784863727008ratesp @ A @ F2 @ A2 )
         => ( ! [X3: A] :
                ( ( A2
                  = ( F2 @ X3 ) )
               => ~ ( comple7512665784863727008ratesp @ A @ F2 @ X3 ) )
           => ~ ! [M10: set @ A] :
                  ( ( A2
                    = ( complete_Sup_Sup @ A @ M10 ) )
                 => ( ( comple1602240252501008431_chain @ A @ ( ord_less_eq @ A ) @ M10 )
                   => ~ ! [X5: A] :
                          ( ( member @ A @ X5 @ M10 )
                         => ( comple7512665784863727008ratesp @ A @ F2 @ X5 ) ) ) ) ) ) ) ).

% iteratesp.cases
thf(fact_7634_iteratesp_Osimps,axiom,
    ! [A: $tType] :
      ( ( comple9053668089753744459l_ccpo @ A )
     => ( ( comple7512665784863727008ratesp @ A )
        = ( ^ [F3: A > A,A3: A] :
              ( ? [X2: A] :
                  ( ( A3
                    = ( F3 @ X2 ) )
                  & ( comple7512665784863727008ratesp @ A @ F3 @ X2 ) )
              | ? [M8: set @ A] :
                  ( ( A3
                    = ( complete_Sup_Sup @ A @ M8 ) )
                  & ( comple1602240252501008431_chain @ A @ ( ord_less_eq @ A ) @ M8 )
                  & ! [X2: A] :
                      ( ( member @ A @ X2 @ M8 )
                     => ( comple7512665784863727008ratesp @ A @ F3 @ X2 ) ) ) ) ) ) ) ).

% iteratesp.simps
thf(fact_7635_admissible__chfin,axiom,
    ! [A: $tType] :
      ( ( comple9053668089753744459l_ccpo @ A )
     => ! [P: A > $o] :
          ( ! [S4: set @ A] :
              ( ( comple1602240252501008431_chain @ A @ ( ord_less_eq @ A ) @ S4 )
             => ( finite_finite @ A @ S4 ) )
         => ( comple1908693960933563346ssible @ A @ ( complete_Sup_Sup @ A ) @ ( ord_less_eq @ A ) @ P ) ) ) ).

% admissible_chfin
thf(fact_7636_arg__min__list_Osimps_I2_J,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linorder @ B )
     => ! [F2: A > B,X: A,Y: A,Zs2: list @ A] :
          ( ( arg_min_list @ A @ B @ F2 @ ( cons @ A @ X @ ( cons @ A @ Y @ Zs2 ) ) )
          = ( if @ A @ ( ord_less_eq @ B @ ( F2 @ X ) @ ( F2 @ ( arg_min_list @ A @ B @ F2 @ ( cons @ A @ Y @ Zs2 ) ) ) ) @ X @ ( arg_min_list @ A @ B @ F2 @ ( cons @ A @ Y @ Zs2 ) ) ) ) ) ).

% arg_min_list.simps(2)
thf(fact_7637_admissible__disj,axiom,
    ! [A: $tType] :
      ( ( comple9053668089753744459l_ccpo @ A )
     => ! [P: A > $o,Q: A > $o] :
          ( ( comple1908693960933563346ssible @ A @ ( complete_Sup_Sup @ A ) @ ( ord_less_eq @ A ) @ P )
         => ( ( comple1908693960933563346ssible @ A @ ( complete_Sup_Sup @ A ) @ ( ord_less_eq @ A ) @ Q )
           => ( comple1908693960933563346ssible @ A @ ( complete_Sup_Sup @ A ) @ ( ord_less_eq @ A )
              @ ^ [X2: A] :
                  ( ( P @ X2 )
                  | ( Q @ X2 ) ) ) ) ) ) ).

% admissible_disj
thf(fact_7638_arg__min__list_Oelims,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linorder @ B )
     => ! [X: A > B,Xa: list @ A,Y: A] :
          ( ( ( arg_min_list @ A @ B @ X @ Xa )
            = Y )
         => ( ! [X3: A] :
                ( ( Xa
                  = ( cons @ A @ X3 @ ( nil @ A ) ) )
               => ( Y != X3 ) )
           => ( ! [X3: A,Y5: A,Zs: list @ A] :
                  ( ( Xa
                    = ( cons @ A @ X3 @ ( cons @ A @ Y5 @ Zs ) ) )
                 => ( Y
                   != ( if @ A @ ( ord_less_eq @ B @ ( X @ X3 ) @ ( X @ ( arg_min_list @ A @ B @ X @ ( cons @ A @ Y5 @ Zs ) ) ) ) @ X3 @ ( arg_min_list @ A @ B @ X @ ( cons @ A @ Y5 @ Zs ) ) ) ) )
             => ~ ( ( Xa
                    = ( nil @ A ) )
                 => ( Y
                   != ( undefined @ A ) ) ) ) ) ) ) ).

% arg_min_list.elims
thf(fact_7639_list__encode_Oelims,axiom,
    ! [X: list @ nat,Y: nat] :
      ( ( ( nat_list_encode @ X )
        = Y )
     => ( ( ( X
            = ( nil @ nat ) )
         => ( Y
           != ( zero_zero @ nat ) ) )
       => ~ ! [X3: nat,Xs2: list @ nat] :
              ( ( X
                = ( cons @ nat @ X3 @ Xs2 ) )
             => ( Y
               != ( suc @ ( nat_prod_encode @ ( product_Pair @ nat @ nat @ X3 @ ( nat_list_encode @ Xs2 ) ) ) ) ) ) ) ) ).

% list_encode.elims
thf(fact_7640_le__prod__encode__2,axiom,
    ! [B2: nat,A2: nat] : ( ord_less_eq @ nat @ B2 @ ( nat_prod_encode @ ( product_Pair @ nat @ nat @ A2 @ B2 ) ) ) ).

% le_prod_encode_2
thf(fact_7641_le__prod__encode__1,axiom,
    ! [A2: nat,B2: nat] : ( ord_less_eq @ nat @ A2 @ ( nat_prod_encode @ ( product_Pair @ nat @ nat @ A2 @ B2 ) ) ) ).

% le_prod_encode_1
thf(fact_7642_list__encode_Osimps_I1_J,axiom,
    ( ( nat_list_encode @ ( nil @ nat ) )
    = ( zero_zero @ nat ) ) ).

% list_encode.simps(1)
thf(fact_7643_list__encode_Opelims,axiom,
    ! [X: list @ nat,Y: nat] :
      ( ( ( nat_list_encode @ X )
        = Y )
     => ( ( accp @ ( list @ nat ) @ nat_list_encode_rel @ X )
       => ( ( ( X
              = ( nil @ nat ) )
           => ( ( Y
                = ( zero_zero @ nat ) )
             => ~ ( accp @ ( list @ nat ) @ nat_list_encode_rel @ ( nil @ nat ) ) ) )
         => ~ ! [X3: nat,Xs2: list @ nat] :
                ( ( X
                  = ( cons @ nat @ X3 @ Xs2 ) )
               => ( ( Y
                    = ( suc @ ( nat_prod_encode @ ( product_Pair @ nat @ nat @ X3 @ ( nat_list_encode @ Xs2 ) ) ) ) )
                 => ~ ( accp @ ( list @ nat ) @ nat_list_encode_rel @ ( cons @ nat @ X3 @ Xs2 ) ) ) ) ) ) ) ).

% list_encode.pelims
thf(fact_7644_arg__min__list_Opelims,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linorder @ B )
     => ! [X: A > B,Xa: list @ A,Y: A] :
          ( ( ( arg_min_list @ A @ B @ X @ Xa )
            = Y )
         => ( ( accp @ ( product_prod @ ( A > B ) @ ( list @ A ) ) @ ( arg_min_list_rel @ A @ B ) @ ( product_Pair @ ( A > B ) @ ( list @ A ) @ X @ Xa ) )
           => ( ! [X3: A] :
                  ( ( Xa
                    = ( cons @ A @ X3 @ ( nil @ A ) ) )
                 => ( ( Y = X3 )
                   => ~ ( accp @ ( product_prod @ ( A > B ) @ ( list @ A ) ) @ ( arg_min_list_rel @ A @ B ) @ ( product_Pair @ ( A > B ) @ ( list @ A ) @ X @ ( cons @ A @ X3 @ ( nil @ A ) ) ) ) ) )
             => ( ! [X3: A,Y5: A,Zs: list @ A] :
                    ( ( Xa
                      = ( cons @ A @ X3 @ ( cons @ A @ Y5 @ Zs ) ) )
                   => ( ( Y
                        = ( if @ A @ ( ord_less_eq @ B @ ( X @ X3 ) @ ( X @ ( arg_min_list @ A @ B @ X @ ( cons @ A @ Y5 @ Zs ) ) ) ) @ X3 @ ( arg_min_list @ A @ B @ X @ ( cons @ A @ Y5 @ Zs ) ) ) )
                     => ~ ( accp @ ( product_prod @ ( A > B ) @ ( list @ A ) ) @ ( arg_min_list_rel @ A @ B ) @ ( product_Pair @ ( A > B ) @ ( list @ A ) @ X @ ( cons @ A @ X3 @ ( cons @ A @ Y5 @ Zs ) ) ) ) ) )
               => ~ ( ( Xa
                      = ( nil @ A ) )
                   => ( ( Y
                        = ( undefined @ A ) )
                     => ~ ( accp @ ( product_prod @ ( A > B ) @ ( list @ A ) ) @ ( arg_min_list_rel @ A @ B ) @ ( product_Pair @ ( A > B ) @ ( list @ A ) @ X @ ( nil @ A ) ) ) ) ) ) ) ) ) ) ).

% arg_min_list.pelims
thf(fact_7645_iterates_Osimps,axiom,
    ! [A: $tType] :
      ( ( comple9053668089753744459l_ccpo @ A )
     => ! [A2: A,F2: A > A] :
          ( ( member @ A @ A2 @ ( comple6359979572994053840erates @ A @ F2 ) )
          = ( ? [X2: A] :
                ( ( A2
                  = ( F2 @ X2 ) )
                & ( member @ A @ X2 @ ( comple6359979572994053840erates @ A @ F2 ) ) )
            | ? [M8: set @ A] :
                ( ( A2
                  = ( complete_Sup_Sup @ A @ M8 ) )
                & ( comple1602240252501008431_chain @ A @ ( ord_less_eq @ A ) @ M8 )
                & ! [X2: A] :
                    ( ( member @ A @ X2 @ M8 )
                   => ( member @ A @ X2 @ ( comple6359979572994053840erates @ A @ F2 ) ) ) ) ) ) ) ).

% iterates.simps
thf(fact_7646_iterates_OSup,axiom,
    ! [A: $tType] :
      ( ( comple9053668089753744459l_ccpo @ A )
     => ! [M5: set @ A,F2: A > A] :
          ( ( comple1602240252501008431_chain @ A @ ( ord_less_eq @ A ) @ M5 )
         => ( ! [X3: A] :
                ( ( member @ A @ X3 @ M5 )
               => ( member @ A @ X3 @ ( comple6359979572994053840erates @ A @ F2 ) ) )
           => ( member @ A @ ( complete_Sup_Sup @ A @ M5 ) @ ( comple6359979572994053840erates @ A @ F2 ) ) ) ) ) ).

% iterates.Sup
thf(fact_7647_iterates_Ocases,axiom,
    ! [A: $tType] :
      ( ( comple9053668089753744459l_ccpo @ A )
     => ! [A2: A,F2: A > A] :
          ( ( member @ A @ A2 @ ( comple6359979572994053840erates @ A @ F2 ) )
         => ( ! [X3: A] :
                ( ( A2
                  = ( F2 @ X3 ) )
               => ~ ( member @ A @ X3 @ ( comple6359979572994053840erates @ A @ F2 ) ) )
           => ~ ! [M10: set @ A] :
                  ( ( A2
                    = ( complete_Sup_Sup @ A @ M10 ) )
                 => ( ( comple1602240252501008431_chain @ A @ ( ord_less_eq @ A ) @ M10 )
                   => ~ ! [X5: A] :
                          ( ( member @ A @ X5 @ M10 )
                         => ( member @ A @ X5 @ ( comple6359979572994053840erates @ A @ F2 ) ) ) ) ) ) ) ) ).

% iterates.cases
thf(fact_7648_chain__iterates,axiom,
    ! [A: $tType] :
      ( ( comple9053668089753744459l_ccpo @ A )
     => ! [F2: A > A] :
          ( ( comple7038119648293358887notone @ A @ A @ ( ord_less_eq @ A ) @ ( ord_less_eq @ A ) @ F2 )
         => ( comple1602240252501008431_chain @ A @ ( ord_less_eq @ A ) @ ( comple6359979572994053840erates @ A @ F2 ) ) ) ) ).

% chain_iterates
thf(fact_7649_sorted__sort__key,axiom,
    ! [A: $tType,B: $tType] :
      ( ( linorder @ A )
     => ! [F2: B > A,Xs: list @ B] : ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ ( map @ B @ A @ F2 @ ( linorder_sort_key @ B @ A @ F2 @ Xs ) ) ) ) ).

% sorted_sort_key
thf(fact_7650_iterates__le__f,axiom,
    ! [A: $tType] :
      ( ( comple9053668089753744459l_ccpo @ A )
     => ! [X: A,F2: A > A] :
          ( ( member @ A @ X @ ( comple6359979572994053840erates @ A @ F2 ) )
         => ( ( comple7038119648293358887notone @ A @ A @ ( ord_less_eq @ A ) @ ( ord_less_eq @ A ) @ F2 )
           => ( ord_less_eq @ A @ X @ ( F2 @ X ) ) ) ) ) ).

% iterates_le_f
thf(fact_7651_sorted__sort,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A] :
          ( sorted_wrt @ A @ ( ord_less_eq @ A )
          @ ( linorder_sort_key @ A @ A
            @ ^ [X2: A] : X2
            @ Xs ) ) ) ).

% sorted_sort
thf(fact_7652_sorted__sort__id,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Xs: list @ A] :
          ( ( sorted_wrt @ A @ ( ord_less_eq @ A ) @ Xs )
         => ( ( linorder_sort_key @ A @ A
              @ ^ [X2: A] : X2
              @ Xs )
            = Xs ) ) ) ).

% sorted_sort_id
thf(fact_7653_fixp__induct,axiom,
    ! [A: $tType] :
      ( ( comple9053668089753744459l_ccpo @ A )
     => ! [P: A > $o,F2: A > A] :
          ( ( comple1908693960933563346ssible @ A @ ( complete_Sup_Sup @ A ) @ ( ord_less_eq @ A ) @ P )
         => ( ( comple7038119648293358887notone @ A @ A @ ( ord_less_eq @ A ) @ ( ord_less_eq @ A ) @ F2 )
           => ( ( P @ ( complete_Sup_Sup @ A @ ( bot_bot @ ( set @ A ) ) ) )
             => ( ! [X3: A] :
                    ( ( P @ X3 )
                   => ( P @ ( F2 @ X3 ) ) )
               => ( P @ ( comple115746919287870866o_fixp @ A @ F2 ) ) ) ) ) ) ) ).

% fixp_induct
thf(fact_7654_iterates__fixp,axiom,
    ! [A: $tType] :
      ( ( comple9053668089753744459l_ccpo @ A )
     => ! [F2: A > A] :
          ( ( comple7038119648293358887notone @ A @ A @ ( ord_less_eq @ A ) @ ( ord_less_eq @ A ) @ F2 )
         => ( member @ A @ ( comple115746919287870866o_fixp @ A @ F2 ) @ ( comple6359979572994053840erates @ A @ F2 ) ) ) ) ).

% iterates_fixp
thf(fact_7655_fixp__unfold,axiom,
    ! [A: $tType] :
      ( ( comple9053668089753744459l_ccpo @ A )
     => ! [F2: A > A] :
          ( ( comple7038119648293358887notone @ A @ A @ ( ord_less_eq @ A ) @ ( ord_less_eq @ A ) @ F2 )
         => ( ( comple115746919287870866o_fixp @ A @ F2 )
            = ( F2 @ ( comple115746919287870866o_fixp @ A @ F2 ) ) ) ) ) ).

% fixp_unfold
thf(fact_7656_fixp__lowerbound,axiom,
    ! [A: $tType] :
      ( ( comple9053668089753744459l_ccpo @ A )
     => ! [F2: A > A,Z: A] :
          ( ( comple7038119648293358887notone @ A @ A @ ( ord_less_eq @ A ) @ ( ord_less_eq @ A ) @ F2 )
         => ( ( ord_less_eq @ A @ ( F2 @ Z ) @ Z )
           => ( ord_less_eq @ A @ ( comple115746919287870866o_fixp @ A @ F2 ) @ Z ) ) ) ) ).

% fixp_lowerbound
thf(fact_7657_continuous__attains__inf,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topolo4958980785337419405_space @ A )
        & ( topolo1944317154257567458pology @ B ) )
     => ! [S2: set @ A,F2: A > B] :
          ( ( topolo2193935891317330818ompact @ A @ S2 )
         => ( ( S2
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( topolo81223032696312382ous_on @ A @ B @ S2 @ F2 )
             => ? [X3: A] :
                  ( ( member @ A @ X3 @ S2 )
                  & ! [Xa2: A] :
                      ( ( member @ A @ Xa2 @ S2 )
                     => ( ord_less_eq @ B @ ( F2 @ X3 ) @ ( F2 @ Xa2 ) ) ) ) ) ) ) ) ).

% continuous_attains_inf
thf(fact_7658_continuous__attains__sup,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( topolo4958980785337419405_space @ A )
        & ( topolo1944317154257567458pology @ B ) )
     => ! [S2: set @ A,F2: A > B] :
          ( ( topolo2193935891317330818ompact @ A @ S2 )
         => ( ( S2
             != ( bot_bot @ ( set @ A ) ) )
           => ( ( topolo81223032696312382ous_on @ A @ B @ S2 @ F2 )
             => ? [X3: A] :
                  ( ( member @ A @ X3 @ S2 )
                  & ! [Xa2: A] :
                      ( ( member @ A @ Xa2 @ S2 )
                     => ( ord_less_eq @ B @ ( F2 @ Xa2 ) @ ( F2 @ X3 ) ) ) ) ) ) ) ) ).

% continuous_attains_sup
thf(fact_7659_compact__attains__sup,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [S: set @ A] :
          ( ( topolo2193935891317330818ompact @ A @ S )
         => ( ( S
             != ( bot_bot @ ( set @ A ) ) )
           => ? [X3: A] :
                ( ( member @ A @ X3 @ S )
                & ! [Xa2: A] :
                    ( ( member @ A @ Xa2 @ S )
                   => ( ord_less_eq @ A @ Xa2 @ X3 ) ) ) ) ) ) ).

% compact_attains_sup
thf(fact_7660_compact__attains__inf,axiom,
    ! [A: $tType] :
      ( ( topolo1944317154257567458pology @ A )
     => ! [S: set @ A] :
          ( ( topolo2193935891317330818ompact @ A @ S )
         => ( ( S
             != ( bot_bot @ ( set @ A ) ) )
           => ? [X3: A] :
                ( ( member @ A @ X3 @ S )
                & ! [Xa2: A] :
                    ( ( member @ A @ Xa2 @ S )
                   => ( ord_less_eq @ A @ X3 @ Xa2 ) ) ) ) ) ) ).

% compact_attains_inf
thf(fact_7661_mono__ccInf,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( counta4013691401010221786attice @ A )
        & ( counta3822494911875563373attice @ B ) )
     => ! [F2: A > B,A4: set @ A] :
          ( ( order_mono @ A @ B @ F2 )
         => ( ( countable_countable @ A @ A4 )
           => ( ord_less_eq @ B @ ( F2 @ ( complete_Inf_Inf @ A @ A4 ) ) @ ( complete_Inf_Inf @ B @ ( image @ A @ B @ F2 @ A4 ) ) ) ) ) ) ).

% mono_ccInf
thf(fact_7662_mono__ccINF,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( ( counta4013691401010221786attice @ A )
        & ( counta3822494911875563373attice @ B ) )
     => ! [F2: A > B,I5: set @ C,A4: C > A] :
          ( ( order_mono @ A @ B @ F2 )
         => ( ( countable_countable @ C @ I5 )
           => ( ord_less_eq @ B @ ( F2 @ ( complete_Inf_Inf @ A @ ( image @ C @ A @ A4 @ I5 ) ) )
              @ ( complete_Inf_Inf @ B
                @ ( image @ C @ B
                  @ ^ [X2: C] : ( F2 @ ( A4 @ X2 ) )
                  @ I5 ) ) ) ) ) ) ).

% mono_ccINF
thf(fact_7663_ccSUP__mono,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( counta3822494911875563373attice @ A )
     => ! [A4: set @ B,B7: set @ C,F2: B > A,G: C > A] :
          ( ( countable_countable @ B @ A4 )
         => ( ( countable_countable @ C @ B7 )
           => ( ! [N2: B] :
                  ( ( member @ B @ N2 @ A4 )
                 => ? [X5: C] :
                      ( ( member @ C @ X5 @ B7 )
                      & ( ord_less_eq @ A @ ( F2 @ N2 ) @ ( G @ X5 ) ) ) )
             => ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F2 @ A4 ) ) @ ( complete_Sup_Sup @ A @ ( image @ C @ A @ G @ B7 ) ) ) ) ) ) ) ).

% ccSUP_mono
thf(fact_7664_ccSUP__least,axiom,
    ! [B: $tType,A: $tType] :
      ( ( counta3822494911875563373attice @ A )
     => ! [A4: set @ B,F2: B > A,U: A] :
          ( ( countable_countable @ B @ A4 )
         => ( ! [I2: B] :
                ( ( member @ B @ I2 @ A4 )
               => ( ord_less_eq @ A @ ( F2 @ I2 ) @ U ) )
           => ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F2 @ A4 ) ) @ U ) ) ) ) ).

% ccSUP_least
thf(fact_7665_ccSUP__upper,axiom,
    ! [A: $tType,B: $tType] :
      ( ( counta3822494911875563373attice @ A )
     => ! [A4: set @ B,I: B,F2: B > A] :
          ( ( countable_countable @ B @ A4 )
         => ( ( member @ B @ I @ A4 )
           => ( ord_less_eq @ A @ ( F2 @ I ) @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F2 @ A4 ) ) ) ) ) ) ).

% ccSUP_upper
thf(fact_7666_ccSUP__le__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( counta3822494911875563373attice @ A )
     => ! [A4: set @ B,F2: B > A,U: A] :
          ( ( countable_countable @ B @ A4 )
         => ( ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F2 @ A4 ) ) @ U )
            = ( ! [X2: B] :
                  ( ( member @ B @ X2 @ A4 )
                 => ( ord_less_eq @ A @ ( F2 @ X2 ) @ U ) ) ) ) ) ) ).

% ccSUP_le_iff
thf(fact_7667_ccSUP__upper2,axiom,
    ! [A: $tType,B: $tType] :
      ( ( counta3822494911875563373attice @ A )
     => ! [A4: set @ B,I: B,U: A,F2: B > A] :
          ( ( countable_countable @ B @ A4 )
         => ( ( member @ B @ I @ A4 )
           => ( ( ord_less_eq @ A @ U @ ( F2 @ I ) )
             => ( ord_less_eq @ A @ U @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F2 @ A4 ) ) ) ) ) ) ) ).

% ccSUP_upper2
thf(fact_7668_less__ccSup__iff,axiom,
    ! [A: $tType] :
      ( ( ( counta3822494911875563373attice @ A )
        & ( linorder @ A ) )
     => ! [S: set @ A,A2: A] :
          ( ( countable_countable @ A @ S )
         => ( ( ord_less @ A @ A2 @ ( complete_Sup_Sup @ A @ S ) )
            = ( ? [X2: A] :
                  ( ( member @ A @ X2 @ S )
                  & ( ord_less @ A @ A2 @ X2 ) ) ) ) ) ) ).

% less_ccSup_iff
thf(fact_7669_ccInf__less__iff,axiom,
    ! [A: $tType] :
      ( ( ( counta3822494911875563373attice @ A )
        & ( linorder @ A ) )
     => ! [S: set @ A,A2: A] :
          ( ( countable_countable @ A @ S )
         => ( ( ord_less @ A @ ( complete_Inf_Inf @ A @ S ) @ A2 )
            = ( ? [X2: A] :
                  ( ( member @ A @ X2 @ S )
                  & ( ord_less @ A @ X2 @ A2 ) ) ) ) ) ) ).

% ccInf_less_iff
thf(fact_7670_ccInf__mono,axiom,
    ! [A: $tType] :
      ( ( counta3822494911875563373attice @ A )
     => ! [B7: set @ A,A4: set @ A] :
          ( ( countable_countable @ A @ B7 )
         => ( ( countable_countable @ A @ A4 )
           => ( ! [B4: A] :
                  ( ( member @ A @ B4 @ B7 )
                 => ? [X5: A] :
                      ( ( member @ A @ X5 @ A4 )
                      & ( ord_less_eq @ A @ X5 @ B4 ) ) )
             => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ A4 ) @ ( complete_Inf_Inf @ A @ B7 ) ) ) ) ) ) ).

% ccInf_mono
thf(fact_7671_ccInf__lower,axiom,
    ! [A: $tType] :
      ( ( counta3822494911875563373attice @ A )
     => ! [A4: set @ A,X: A] :
          ( ( countable_countable @ A @ A4 )
         => ( ( member @ A @ X @ A4 )
           => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ A4 ) @ X ) ) ) ) ).

% ccInf_lower
thf(fact_7672_ccInf__lower2,axiom,
    ! [A: $tType] :
      ( ( counta3822494911875563373attice @ A )
     => ! [A4: set @ A,U: A,V: A] :
          ( ( countable_countable @ A @ A4 )
         => ( ( member @ A @ U @ A4 )
           => ( ( ord_less_eq @ A @ U @ V )
             => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ A4 ) @ V ) ) ) ) ) ).

% ccInf_lower2
thf(fact_7673_le__ccInf__iff,axiom,
    ! [A: $tType] :
      ( ( counta3822494911875563373attice @ A )
     => ! [A4: set @ A,B2: A] :
          ( ( countable_countable @ A @ A4 )
         => ( ( ord_less_eq @ A @ B2 @ ( complete_Inf_Inf @ A @ A4 ) )
            = ( ! [X2: A] :
                  ( ( member @ A @ X2 @ A4 )
                 => ( ord_less_eq @ A @ B2 @ X2 ) ) ) ) ) ) ).

% le_ccInf_iff
thf(fact_7674_ccInf__greatest,axiom,
    ! [A: $tType] :
      ( ( counta3822494911875563373attice @ A )
     => ! [A4: set @ A,Z: A] :
          ( ( countable_countable @ A @ A4 )
         => ( ! [X3: A] :
                ( ( member @ A @ X3 @ A4 )
               => ( ord_less_eq @ A @ Z @ X3 ) )
           => ( ord_less_eq @ A @ Z @ ( complete_Inf_Inf @ A @ A4 ) ) ) ) ) ).

% ccInf_greatest
thf(fact_7675_ccSup__mono,axiom,
    ! [A: $tType] :
      ( ( counta3822494911875563373attice @ A )
     => ! [B7: set @ A,A4: set @ A] :
          ( ( countable_countable @ A @ B7 )
         => ( ( countable_countable @ A @ A4 )
           => ( ! [A5: A] :
                  ( ( member @ A @ A5 @ A4 )
                 => ? [X5: A] :
                      ( ( member @ A @ X5 @ B7 )
                      & ( ord_less_eq @ A @ A5 @ X5 ) ) )
             => ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ A4 ) @ ( complete_Sup_Sup @ A @ B7 ) ) ) ) ) ) ).

% ccSup_mono
thf(fact_7676_ccSup__least,axiom,
    ! [A: $tType] :
      ( ( counta3822494911875563373attice @ A )
     => ! [A4: set @ A,Z: A] :
          ( ( countable_countable @ A @ A4 )
         => ( ! [X3: A] :
                ( ( member @ A @ X3 @ A4 )
               => ( ord_less_eq @ A @ X3 @ Z ) )
           => ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ A4 ) @ Z ) ) ) ) ).

% ccSup_least
thf(fact_7677_ccSup__upper,axiom,
    ! [A: $tType] :
      ( ( counta3822494911875563373attice @ A )
     => ! [A4: set @ A,X: A] :
          ( ( countable_countable @ A @ A4 )
         => ( ( member @ A @ X @ A4 )
           => ( ord_less_eq @ A @ X @ ( complete_Sup_Sup @ A @ A4 ) ) ) ) ) ).

% ccSup_upper
thf(fact_7678_ccSup__le__iff,axiom,
    ! [A: $tType] :
      ( ( counta3822494911875563373attice @ A )
     => ! [A4: set @ A,B2: A] :
          ( ( countable_countable @ A @ A4 )
         => ( ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ A4 ) @ B2 )
            = ( ! [X2: A] :
                  ( ( member @ A @ X2 @ A4 )
                 => ( ord_less_eq @ A @ X2 @ B2 ) ) ) ) ) ) ).

% ccSup_le_iff
thf(fact_7679_ccSup__upper2,axiom,
    ! [A: $tType] :
      ( ( counta3822494911875563373attice @ A )
     => ! [A4: set @ A,U: A,V: A] :
          ( ( countable_countable @ A @ A4 )
         => ( ( member @ A @ U @ A4 )
           => ( ( ord_less_eq @ A @ V @ U )
             => ( ord_less_eq @ A @ V @ ( complete_Sup_Sup @ A @ A4 ) ) ) ) ) ) ).

% ccSup_upper2
thf(fact_7680_ccSup__subset__mono,axiom,
    ! [A: $tType] :
      ( ( counta3822494911875563373attice @ A )
     => ! [B7: set @ A,A4: set @ A] :
          ( ( countable_countable @ A @ B7 )
         => ( ( ord_less_eq @ ( set @ A ) @ A4 @ B7 )
           => ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ A4 ) @ ( complete_Sup_Sup @ A @ B7 ) ) ) ) ) ).

% ccSup_subset_mono
thf(fact_7681_ccInf__superset__mono,axiom,
    ! [A: $tType] :
      ( ( counta3822494911875563373attice @ A )
     => ! [A4: set @ A,B7: set @ A] :
          ( ( countable_countable @ A @ A4 )
         => ( ( ord_less_eq @ ( set @ A ) @ B7 @ A4 )
           => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ A4 ) @ ( complete_Inf_Inf @ A @ B7 ) ) ) ) ) ).

% ccInf_superset_mono
thf(fact_7682_less__ccSUP__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( counta3822494911875563373attice @ A )
        & ( linorder @ A ) )
     => ! [A4: set @ B,A2: A,F2: B > A] :
          ( ( countable_countable @ B @ A4 )
         => ( ( ord_less @ A @ A2 @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F2 @ A4 ) ) )
            = ( ? [X2: B] :
                  ( ( member @ B @ X2 @ A4 )
                  & ( ord_less @ A @ A2 @ ( F2 @ X2 ) ) ) ) ) ) ) ).

% less_ccSUP_iff
thf(fact_7683_ccINF__mono,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( counta3822494911875563373attice @ A )
     => ! [A4: set @ B,B7: set @ C,F2: B > A,G: C > A] :
          ( ( countable_countable @ B @ A4 )
         => ( ( countable_countable @ C @ B7 )
           => ( ! [M4: C] :
                  ( ( member @ C @ M4 @ B7 )
                 => ? [X5: B] :
                      ( ( member @ B @ X5 @ A4 )
                      & ( ord_less_eq @ A @ ( F2 @ X5 ) @ ( G @ M4 ) ) ) )
             => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ F2 @ A4 ) ) @ ( complete_Inf_Inf @ A @ ( image @ C @ A @ G @ B7 ) ) ) ) ) ) ) ).

% ccINF_mono
thf(fact_7684_ccINF__lower,axiom,
    ! [A: $tType,B: $tType] :
      ( ( counta3822494911875563373attice @ A )
     => ! [A4: set @ B,I: B,F2: B > A] :
          ( ( countable_countable @ B @ A4 )
         => ( ( member @ B @ I @ A4 )
           => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ F2 @ A4 ) ) @ ( F2 @ I ) ) ) ) ) ).

% ccINF_lower
thf(fact_7685_ccINF__lower2,axiom,
    ! [B: $tType,A: $tType] :
      ( ( counta3822494911875563373attice @ A )
     => ! [A4: set @ B,I: B,F2: B > A,U: A] :
          ( ( countable_countable @ B @ A4 )
         => ( ( member @ B @ I @ A4 )
           => ( ( ord_less_eq @ A @ ( F2 @ I ) @ U )
             => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ F2 @ A4 ) ) @ U ) ) ) ) ) ).

% ccINF_lower2
thf(fact_7686_le__ccINF__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( counta3822494911875563373attice @ A )
     => ! [A4: set @ B,U: A,F2: B > A] :
          ( ( countable_countable @ B @ A4 )
         => ( ( ord_less_eq @ A @ U @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ F2 @ A4 ) ) )
            = ( ! [X2: B] :
                  ( ( member @ B @ X2 @ A4 )
                 => ( ord_less_eq @ A @ U @ ( F2 @ X2 ) ) ) ) ) ) ) ).

% le_ccINF_iff
thf(fact_7687_ccINF__greatest,axiom,
    ! [A: $tType,B: $tType] :
      ( ( counta3822494911875563373attice @ A )
     => ! [A4: set @ B,U: A,F2: B > A] :
          ( ( countable_countable @ B @ A4 )
         => ( ! [I2: B] :
                ( ( member @ B @ I2 @ A4 )
               => ( ord_less_eq @ A @ U @ ( F2 @ I2 ) ) )
           => ( ord_less_eq @ A @ U @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ F2 @ A4 ) ) ) ) ) ) ).

% ccINF_greatest
thf(fact_7688_ccINF__less__iff,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ( counta3822494911875563373attice @ A )
        & ( linorder @ A ) )
     => ! [A4: set @ B,F2: B > A,A2: A] :
          ( ( countable_countable @ B @ A4 )
         => ( ( ord_less @ A @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ F2 @ A4 ) ) @ A2 )
            = ( ? [X2: B] :
                  ( ( member @ B @ X2 @ A4 )
                  & ( ord_less @ A @ ( F2 @ X2 ) @ A2 ) ) ) ) ) ) ).

% ccINF_less_iff
thf(fact_7689_ccSup__inter__less__eq,axiom,
    ! [A: $tType] :
      ( ( counta3822494911875563373attice @ A )
     => ! [A4: set @ A,B7: set @ A] :
          ( ( countable_countable @ A @ A4 )
         => ( ( countable_countable @ A @ B7 )
           => ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ ( inf_inf @ ( set @ A ) @ A4 @ B7 ) ) @ ( inf_inf @ A @ ( complete_Sup_Sup @ A @ A4 ) @ ( complete_Sup_Sup @ A @ B7 ) ) ) ) ) ) ).

% ccSup_inter_less_eq
thf(fact_7690_less__eq__ccInf__inter,axiom,
    ! [A: $tType] :
      ( ( counta3822494911875563373attice @ A )
     => ! [A4: set @ A,B7: set @ A] :
          ( ( countable_countable @ A @ A4 )
         => ( ( countable_countable @ A @ B7 )
           => ( ord_less_eq @ A @ ( sup_sup @ A @ ( complete_Inf_Inf @ A @ A4 ) @ ( complete_Inf_Inf @ A @ B7 ) ) @ ( complete_Inf_Inf @ A @ ( inf_inf @ ( set @ A ) @ A4 @ B7 ) ) ) ) ) ) ).

% less_eq_ccInf_inter
thf(fact_7691_ccSUP__subset__mono,axiom,
    ! [A: $tType,B: $tType] :
      ( ( counta3822494911875563373attice @ A )
     => ! [B7: set @ B,A4: set @ B,F2: B > A,G: B > A] :
          ( ( countable_countable @ B @ B7 )
         => ( ( ord_less_eq @ ( set @ B ) @ A4 @ B7 )
           => ( ! [X3: B] :
                  ( ( member @ B @ X3 @ A4 )
                 => ( ord_less_eq @ A @ ( F2 @ X3 ) @ ( G @ X3 ) ) )
             => ( ord_less_eq @ A @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ F2 @ A4 ) ) @ ( complete_Sup_Sup @ A @ ( image @ B @ A @ G @ B7 ) ) ) ) ) ) ) ).

% ccSUP_subset_mono
thf(fact_7692_ccINF__superset__mono,axiom,
    ! [A: $tType,B: $tType] :
      ( ( counta3822494911875563373attice @ A )
     => ! [A4: set @ B,B7: set @ B,F2: B > A,G: B > A] :
          ( ( countable_countable @ B @ A4 )
         => ( ( ord_less_eq @ ( set @ B ) @ B7 @ A4 )
           => ( ! [X3: B] :
                  ( ( member @ B @ X3 @ B7 )
                 => ( ord_less_eq @ A @ ( F2 @ X3 ) @ ( G @ X3 ) ) )
             => ( ord_less_eq @ A @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ F2 @ A4 ) ) @ ( complete_Inf_Inf @ A @ ( image @ B @ A @ G @ B7 ) ) ) ) ) ) ) ).

% ccINF_superset_mono
thf(fact_7693_mono__ccSup,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( counta4013691401010221786attice @ A )
        & ( counta3822494911875563373attice @ B ) )
     => ! [F2: A > B,A4: set @ A] :
          ( ( order_mono @ A @ B @ F2 )
         => ( ( countable_countable @ A @ A4 )
           => ( ord_less_eq @ B @ ( complete_Sup_Sup @ B @ ( image @ A @ B @ F2 @ A4 ) ) @ ( F2 @ ( complete_Sup_Sup @ A @ A4 ) ) ) ) ) ) ).

% mono_ccSup
thf(fact_7694_mono__ccSUP,axiom,
    ! [B: $tType,A: $tType,C: $tType] :
      ( ( ( counta4013691401010221786attice @ A )
        & ( counta3822494911875563373attice @ B ) )
     => ! [F2: A > B,I5: set @ C,A4: C > A] :
          ( ( order_mono @ A @ B @ F2 )
         => ( ( countable_countable @ C @ I5 )
           => ( ord_less_eq @ B
              @ ( complete_Sup_Sup @ B
                @ ( image @ C @ B
                  @ ^ [X2: C] : ( F2 @ ( A4 @ X2 ) )
                  @ I5 ) )
              @ ( F2 @ ( complete_Sup_Sup @ A @ ( image @ C @ A @ A4 @ I5 ) ) ) ) ) ) ) ).

% mono_ccSUP
thf(fact_7695_min__ext__compat,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A ),S: set @ ( product_prod @ A @ A )] :
      ( ( ord_less_eq @ ( set @ ( product_prod @ A @ A ) ) @ ( relcomp @ A @ A @ A @ R4 @ S ) @ R4 )
     => ( ord_less_eq @ ( set @ ( product_prod @ ( set @ A ) @ ( set @ A ) ) ) @ ( relcomp @ ( set @ A ) @ ( set @ A ) @ ( set @ A ) @ ( min_ext @ A @ R4 ) @ ( sup_sup @ ( set @ ( product_prod @ ( set @ A ) @ ( set @ A ) ) ) @ ( min_ext @ A @ S ) @ ( insert @ ( product_prod @ ( set @ A ) @ ( set @ A ) ) @ ( product_Pair @ ( set @ A ) @ ( set @ A ) @ ( bot_bot @ ( set @ A ) ) @ ( bot_bot @ ( set @ A ) ) ) @ ( bot_bot @ ( set @ ( product_prod @ ( set @ A ) @ ( set @ A ) ) ) ) ) ) ) @ ( min_ext @ A @ R4 ) ) ) ).

% min_ext_compat
thf(fact_7696_length__removeAll__less,axiom,
    ! [A: $tType,X: A,Xs: list @ A] :
      ( ( member @ A @ X @ ( set2 @ A @ Xs ) )
     => ( ord_less @ nat @ ( size_size @ ( list @ A ) @ ( removeAll @ A @ X @ Xs ) ) @ ( size_size @ ( list @ A ) @ Xs ) ) ) ).

% length_removeAll_less
thf(fact_7697_union__comp__emptyR,axiom,
    ! [A: $tType,A4: set @ ( product_prod @ A @ A ),B7: set @ ( product_prod @ A @ A ),C5: set @ ( product_prod @ A @ A )] :
      ( ( ( relcomp @ A @ A @ A @ A4 @ B7 )
        = ( bot_bot @ ( set @ ( product_prod @ A @ A ) ) ) )
     => ( ( ( relcomp @ A @ A @ A @ A4 @ C5 )
          = ( bot_bot @ ( set @ ( product_prod @ A @ A ) ) ) )
       => ( ( relcomp @ A @ A @ A @ A4 @ ( sup_sup @ ( set @ ( product_prod @ A @ A ) ) @ B7 @ C5 ) )
          = ( bot_bot @ ( set @ ( product_prod @ A @ A ) ) ) ) ) ) ).

% union_comp_emptyR
thf(fact_7698_union__comp__emptyL,axiom,
    ! [A: $tType,A4: set @ ( product_prod @ A @ A ),C5: set @ ( product_prod @ A @ A ),B7: set @ ( product_prod @ A @ A )] :
      ( ( ( relcomp @ A @ A @ A @ A4 @ C5 )
        = ( bot_bot @ ( set @ ( product_prod @ A @ A ) ) ) )
     => ( ( ( relcomp @ A @ A @ A @ B7 @ C5 )
          = ( bot_bot @ ( set @ ( product_prod @ A @ A ) ) ) )
       => ( ( relcomp @ A @ A @ A @ ( sup_sup @ ( set @ ( product_prod @ A @ A ) ) @ A4 @ B7 ) @ C5 )
          = ( bot_bot @ ( set @ ( product_prod @ A @ A ) ) ) ) ) ) ).

% union_comp_emptyL
thf(fact_7699_length__removeAll__less__eq,axiom,
    ! [A: $tType,X: A,Xs: list @ A] : ( ord_less_eq @ nat @ ( size_size @ ( list @ A ) @ ( removeAll @ A @ X @ Xs ) ) @ ( size_size @ ( list @ A ) @ Xs ) ) ).

% length_removeAll_less_eq
thf(fact_7700_max__ext__compat,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A ),S: set @ ( product_prod @ A @ A )] :
      ( ( ord_less_eq @ ( set @ ( product_prod @ A @ A ) ) @ ( relcomp @ A @ A @ A @ R4 @ S ) @ R4 )
     => ( ord_less_eq @ ( set @ ( product_prod @ ( set @ A ) @ ( set @ A ) ) ) @ ( relcomp @ ( set @ A ) @ ( set @ A ) @ ( set @ A ) @ ( max_ext @ A @ R4 ) @ ( sup_sup @ ( set @ ( product_prod @ ( set @ A ) @ ( set @ A ) ) ) @ ( max_ext @ A @ S ) @ ( insert @ ( product_prod @ ( set @ A ) @ ( set @ A ) ) @ ( product_Pair @ ( set @ A ) @ ( set @ A ) @ ( bot_bot @ ( set @ A ) ) @ ( bot_bot @ ( set @ A ) ) ) @ ( bot_bot @ ( set @ ( product_prod @ ( set @ A ) @ ( set @ A ) ) ) ) ) ) ) @ ( max_ext @ A @ R4 ) ) ) ).

% max_ext_compat
thf(fact_7701_reduction__pairI,axiom,
    ! [A: $tType,R4: set @ ( product_prod @ A @ A ),S: set @ ( product_prod @ A @ A )] :
      ( ( wf @ A @ R4 )
     => ( ( ord_less_eq @ ( set @ ( product_prod @ A @ A ) ) @ ( relcomp @ A @ A @ A @ R4 @ S ) @ R4 )
       => ( fun_reduction_pair @ A @ ( product_Pair @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ A @ A ) ) @ R4 @ S ) ) ) ) ).

% reduction_pairI
thf(fact_7702_wf__no__loop,axiom,
    ! [B: $tType,R4: set @ ( product_prod @ B @ B )] :
      ( ( ( relcomp @ B @ B @ B @ R4 @ R4 )
        = ( bot_bot @ ( set @ ( product_prod @ B @ B ) ) ) )
     => ( wf @ B @ R4 ) ) ).

% wf_no_loop
thf(fact_7703_wf__linord__ex__has__least,axiom,
    ! [B: $tType,A: $tType,R2: set @ ( product_prod @ A @ A ),P: B > $o,K: B,M: B > A] :
      ( ( wf @ A @ R2 )
     => ( ! [X3: A,Y5: A] :
            ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ X3 @ Y5 ) @ ( transitive_trancl @ A @ R2 ) )
            = ( ~ ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ Y5 @ X3 ) @ ( transitive_rtrancl @ A @ R2 ) ) ) )
       => ( ( P @ K )
         => ? [X3: B] :
              ( ( P @ X3 )
              & ! [Y6: B] :
                  ( ( P @ Y6 )
                 => ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ ( M @ X3 ) @ ( M @ Y6 ) ) @ ( transitive_rtrancl @ A @ R2 ) ) ) ) ) ) ) ).

% wf_linord_ex_has_least
thf(fact_7704_wf__bounded__measure,axiom,
    ! [A: $tType,R2: set @ ( product_prod @ A @ A ),Ub: A > nat,F2: A > nat] :
      ( ! [A5: A,B4: A] :
          ( ( member @ ( product_prod @ A @ A ) @ ( product_Pair @ A @ A @ B4 @ A5 ) @ R2 )
         => ( ( ord_less_eq @ nat @ ( Ub @ B4 ) @ ( Ub @ A5 ) )
            & ( ord_less_eq @ nat @ ( F2 @ B4 ) @ ( Ub @ A5 ) )
            & ( ord_less @ nat @ ( F2 @ A5 ) @ ( F2 @ B4 ) ) ) )
     => ( wf @ A @ R2 ) ) ).

% wf_bounded_measure
thf(fact_7705_wf__int__ge__less__than,axiom,
    ! [D2: int] : ( wf @ int @ ( int_ge_less_than @ D2 ) ) ).

% wf_int_ge_less_than
thf(fact_7706_wf__int__ge__less__than2,axiom,
    ! [D2: int] : ( wf @ int @ ( int_ge_less_than2 @ D2 ) ) ).

% wf_int_ge_less_than2
thf(fact_7707_wf__pair__less,axiom,
    wf @ ( product_prod @ nat @ nat ) @ fun_pair_less ).

% wf_pair_less
thf(fact_7708_wf,axiom,
    ! [A: $tType] :
      ( ( wellorder @ A )
     => ( wf @ A @ ( collect @ ( product_prod @ A @ A ) @ ( product_case_prod @ A @ A @ $o @ ( ord_less @ A ) ) ) ) ) ).

% wf
thf(fact_7709_wf__if__measure,axiom,
    ! [A: $tType,P: A > $o,F2: A > nat,G: A > A] :
      ( ! [X3: A] :
          ( ( P @ X3 )
         => ( ord_less @ nat @ ( F2 @ ( G @ X3 ) ) @ ( F2 @ X3 ) ) )
     => ( wf @ A
        @ ( collect @ ( product_prod @ A @ A )
          @ ( product_case_prod @ A @ A @ $o
            @ ^ [Y4: A,X2: A] :
                ( ( P @ X2 )
                & ( Y4
                  = ( G @ X2 ) ) ) ) ) ) ) ).

% wf_if_measure
thf(fact_7710_wf__less,axiom,
    wf @ nat @ ( collect @ ( product_prod @ nat @ nat ) @ ( product_case_prod @ nat @ nat @ $o @ ( ord_less @ nat ) ) ) ).

% wf_less
thf(fact_7711_prod__decode__def,axiom,
    ( nat_prod_decode
    = ( nat_prod_decode_aux @ ( zero_zero @ nat ) ) ) ).

% prod_decode_def
thf(fact_7712_reduction__pair__def,axiom,
    ! [A: $tType] :
      ( ( fun_reduction_pair @ A )
      = ( ^ [P3: product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ A @ A ) )] :
            ( ( wf @ A @ ( product_fst @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ A @ A ) ) @ P3 ) )
            & ( ord_less_eq @ ( set @ ( product_prod @ A @ A ) ) @ ( relcomp @ A @ A @ A @ ( product_fst @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ A @ A ) ) @ P3 ) @ ( product_snd @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ A @ A ) ) @ P3 ) ) @ ( product_fst @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ A @ A ) ) @ P3 ) ) ) ) ) ).

% reduction_pair_def
thf(fact_7713_reduction__pair__lemma,axiom,
    ! [A: $tType,P: product_prod @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ A @ A ) ),R4: set @ ( product_prod @ A @ A ),S: set @ ( product_prod @ A @ A )] :
      ( ( fun_reduction_pair @ A @ P )
     => ( ( ord_less_eq @ ( set @ ( product_prod @ A @ A ) ) @ R4 @ ( product_fst @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ A @ A ) ) @ P ) )
       => ( ( ord_less_eq @ ( set @ ( product_prod @ A @ A ) ) @ S @ ( product_snd @ ( set @ ( product_prod @ A @ A ) ) @ ( set @ ( product_prod @ A @ A ) ) @ P ) )
         => ( ( wf @ A @ S )
           => ( wf @ A @ ( sup_sup @ ( set @ ( product_prod @ A @ A ) ) @ R4 @ S ) ) ) ) ) ) ).

% reduction_pair_lemma
thf(fact_7714_list__decode_Opinduct,axiom,
    ! [A0: nat,P: nat > $o] :
      ( ( accp @ nat @ nat_list_decode_rel @ A0 )
     => ( ( ( accp @ nat @ nat_list_decode_rel @ ( zero_zero @ nat ) )
         => ( P @ ( zero_zero @ nat ) ) )
       => ( ! [N2: nat] :
              ( ( accp @ nat @ nat_list_decode_rel @ ( suc @ N2 ) )
             => ( ! [X5: nat,Y6: nat] :
                    ( ( ( product_Pair @ nat @ nat @ X5 @ Y6 )
                      = ( nat_prod_decode @ N2 ) )
                   => ( P @ Y6 ) )
               => ( P @ ( suc @ N2 ) ) ) )
         => ( P @ A0 ) ) ) ) ).

% list_decode.pinduct
thf(fact_7715_list__decode_Oelims,axiom,
    ! [X: nat,Y: list @ nat] :
      ( ( ( nat_list_decode @ X )
        = Y )
     => ( ( ( X
            = ( zero_zero @ nat ) )
         => ( Y
           != ( nil @ nat ) ) )
       => ~ ! [N2: nat] :
              ( ( X
                = ( suc @ N2 ) )
             => ( Y
               != ( product_case_prod @ nat @ nat @ ( list @ nat )
                  @ ^ [X2: nat,Y4: nat] : ( cons @ nat @ X2 @ ( nat_list_decode @ Y4 ) )
                  @ ( nat_prod_decode @ N2 ) ) ) ) ) ) ).

% list_decode.elims
thf(fact_7716_list__decode_Opsimps_I1_J,axiom,
    ( ( accp @ nat @ nat_list_decode_rel @ ( zero_zero @ nat ) )
   => ( ( nat_list_decode @ ( zero_zero @ nat ) )
      = ( nil @ nat ) ) ) ).

% list_decode.psimps(1)
thf(fact_7717_list__decode_Osimps_I1_J,axiom,
    ( ( nat_list_decode @ ( zero_zero @ nat ) )
    = ( nil @ nat ) ) ).

% list_decode.simps(1)
thf(fact_7718_list__decode_Opelims,axiom,
    ! [X: nat,Y: list @ nat] :
      ( ( ( nat_list_decode @ X )
        = Y )
     => ( ( accp @ nat @ nat_list_decode_rel @ X )
       => ( ( ( X
              = ( zero_zero @ nat ) )
           => ( ( Y
                = ( nil @ nat ) )
             => ~ ( accp @ nat @ nat_list_decode_rel @ ( zero_zero @ nat ) ) ) )
         => ~ ! [N2: nat] :
                ( ( X
                  = ( suc @ N2 ) )
               => ( ( Y
                    = ( product_case_prod @ nat @ nat @ ( list @ nat )
                      @ ^ [X2: nat,Y4: nat] : ( cons @ nat @ X2 @ ( nat_list_decode @ Y4 ) )
                      @ ( nat_prod_decode @ N2 ) ) )
                 => ~ ( accp @ nat @ nat_list_decode_rel @ ( suc @ N2 ) ) ) ) ) ) ) ).

% list_decode.pelims
thf(fact_7719_and_Ocomm__monoid__axioms,axiom,
    ! [A: $tType] :
      ( ( bit_ri3973907225187159222ations @ A )
     => ( comm_monoid @ A @ ( bit_se5824344872417868541ns_and @ A ) @ ( uminus_uminus @ A @ ( one_one @ A ) ) ) ) ).

% and.comm_monoid_axioms
thf(fact_7720_card__Plus__conv__if,axiom,
    ! [B: $tType,A: $tType,A4: set @ A,B7: set @ B] :
      ( ( ( ( finite_finite @ A @ A4 )
          & ( finite_finite @ B @ B7 ) )
       => ( ( finite_card @ ( sum_sum @ A @ B ) @ ( sum_Plus @ A @ B @ A4 @ B7 ) )
          = ( plus_plus @ nat @ ( finite_card @ A @ A4 ) @ ( finite_card @ B @ B7 ) ) ) )
      & ( ~ ( ( finite_finite @ A @ A4 )
            & ( finite_finite @ B @ B7 ) )
       => ( ( finite_card @ ( sum_sum @ A @ B ) @ ( sum_Plus @ A @ B @ A4 @ B7 ) )
          = ( zero_zero @ nat ) ) ) ) ).

% card_Plus_conv_if
thf(fact_7721_inf__top_Ocomm__monoid__axioms,axiom,
    ! [A: $tType] :
      ( ( bounde4346867609351753570nf_top @ A )
     => ( comm_monoid @ A @ ( inf_inf @ A ) @ ( top_top @ A ) ) ) ).

% inf_top.comm_monoid_axioms
thf(fact_7722_semilattice__neutr_Oaxioms_I2_J,axiom,
    ! [A: $tType,F2: A > A > A,Z: A] :
      ( ( semilattice_neutr @ A @ F2 @ Z )
     => ( comm_monoid @ A @ F2 @ Z ) ) ).

% semilattice_neutr.axioms(2)
thf(fact_7723_mult_Ocomm__monoid__axioms,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_mult @ A )
     => ( comm_monoid @ A @ ( times_times @ A ) @ ( one_one @ A ) ) ) ).

% mult.comm_monoid_axioms
thf(fact_7724_comm__monoid_Ocomm__neutral,axiom,
    ! [A: $tType,F2: A > A > A,Z: A,A2: A] :
      ( ( comm_monoid @ A @ F2 @ Z )
     => ( ( F2 @ A2 @ Z )
        = A2 ) ) ).

% comm_monoid.comm_neutral
thf(fact_7725_xor_Ocomm__monoid__axioms,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( comm_monoid @ A @ ( bit_se5824344971392196577ns_xor @ A ) @ ( zero_zero @ A ) ) ) ).

% xor.comm_monoid_axioms
thf(fact_7726_or_Ocomm__monoid__axioms,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( comm_monoid @ A @ ( bit_se1065995026697491101ons_or @ A ) @ ( zero_zero @ A ) ) ) ).

% or.comm_monoid_axioms
thf(fact_7727_add_Ocomm__monoid__axioms,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ( comm_monoid @ A @ ( plus_plus @ A ) @ ( zero_zero @ A ) ) ) ).

% add.comm_monoid_axioms
thf(fact_7728_gcd__nat_Ocomm__monoid__axioms,axiom,
    comm_monoid @ nat @ ( gcd_gcd @ nat ) @ ( zero_zero @ nat ) ).

% gcd_nat.comm_monoid_axioms
thf(fact_7729_max__nat_Ocomm__monoid__axioms,axiom,
    comm_monoid @ nat @ ( ord_max @ nat ) @ ( zero_zero @ nat ) ).

% max_nat.comm_monoid_axioms
thf(fact_7730_sup__bot_Ocomm__monoid__axioms,axiom,
    ! [A: $tType] :
      ( ( bounde4967611905675639751up_bot @ A )
     => ( comm_monoid @ A @ ( sup_sup @ A ) @ ( bot_bot @ A ) ) ) ).

% sup_bot.comm_monoid_axioms
thf(fact_7731_is__num_Osimps,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( ( neg_numeral_is_num @ A )
        = ( ^ [A3: A] :
              ( ( A3
                = ( one_one @ A ) )
              | ? [X2: A] :
                  ( ( A3
                    = ( uminus_uminus @ A @ X2 ) )
                  & ( neg_numeral_is_num @ A @ X2 ) )
              | ? [X2: A,Y4: A] :
                  ( ( A3
                    = ( plus_plus @ A @ X2 @ Y4 ) )
                  & ( neg_numeral_is_num @ A @ X2 )
                  & ( neg_numeral_is_num @ A @ Y4 ) ) ) ) ) ) ).

% is_num.simps
thf(fact_7732_is__num__add__left__commute,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [X: A,Y: A,Z: A] :
          ( ( neg_numeral_is_num @ A @ X )
         => ( ( neg_numeral_is_num @ A @ Y )
           => ( ( plus_plus @ A @ X @ ( plus_plus @ A @ Y @ Z ) )
              = ( plus_plus @ A @ Y @ ( plus_plus @ A @ X @ Z ) ) ) ) ) ) ).

% is_num_add_left_commute
thf(fact_7733_is__num__add__commute,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [X: A,Y: A] :
          ( ( neg_numeral_is_num @ A @ X )
         => ( ( neg_numeral_is_num @ A @ Y )
           => ( ( plus_plus @ A @ X @ Y )
              = ( plus_plus @ A @ Y @ X ) ) ) ) ) ).

% is_num_add_commute
thf(fact_7734_is__num__normalize_I6_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [X: A,Y: A] :
          ( ( neg_numeral_is_num @ A @ X )
         => ( ( neg_numeral_is_num @ A @ Y )
           => ( neg_numeral_is_num @ A @ ( plus_plus @ A @ X @ Y ) ) ) ) ) ).

% is_num_normalize(6)
thf(fact_7735_is__num__normalize_I4_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ( neg_numeral_is_num @ A @ ( one_one @ A ) ) ) ).

% is_num_normalize(4)
thf(fact_7736_is__num__numeral,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [K: num] : ( neg_numeral_is_num @ A @ ( numeral_numeral @ A @ K ) ) ) ).

% is_num_numeral
thf(fact_7737_is__num__normalize_I5_J,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [X: A] :
          ( ( neg_numeral_is_num @ A @ X )
         => ( neg_numeral_is_num @ A @ ( uminus_uminus @ A @ X ) ) ) ) ).

% is_num_normalize(5)
thf(fact_7738_is__num_Ocases,axiom,
    ! [A: $tType] :
      ( ( neg_numeral @ A )
     => ! [A2: A] :
          ( ( neg_numeral_is_num @ A @ A2 )
         => ( ( A2
             != ( one_one @ A ) )
           => ( ! [X3: A] :
                  ( ( A2
                    = ( uminus_uminus @ A @ X3 ) )
                 => ~ ( neg_numeral_is_num @ A @ X3 ) )
             => ~ ! [X3: A,Y5: A] :
                    ( ( A2
                      = ( plus_plus @ A @ X3 @ Y5 ) )
                   => ( ( neg_numeral_is_num @ A @ X3 )
                     => ~ ( neg_numeral_is_num @ A @ Y5 ) ) ) ) ) ) ) ).

% is_num.cases
thf(fact_7739_times__num__def,axiom,
    ( ( times_times @ num )
    = ( ^ [M3: num,N3: num] : ( num_of_nat @ ( times_times @ nat @ ( nat_of_num @ M3 ) @ ( nat_of_num @ N3 ) ) ) ) ) ).

% times_num_def
thf(fact_7740_arg__max__nat__le,axiom,
    ! [A: $tType,P: A > $o,X: A,F2: A > nat,B2: nat] :
      ( ( P @ X )
     => ( ! [Y5: A] :
            ( ( P @ Y5 )
           => ( ord_less @ nat @ ( F2 @ Y5 ) @ B2 ) )
       => ( ord_less_eq @ nat @ ( F2 @ X ) @ ( F2 @ ( lattices_ord_arg_max @ A @ nat @ F2 @ P ) ) ) ) ) ).

% arg_max_nat_le
thf(fact_7741_arg__max__equality,axiom,
    ! [A: $tType,C: $tType] :
      ( ( order @ A )
     => ! [P: C > $o,K: C,F2: C > A] :
          ( ( P @ K )
         => ( ! [X3: C] :
                ( ( P @ X3 )
               => ( ord_less_eq @ A @ ( F2 @ X3 ) @ ( F2 @ K ) ) )
           => ( ( F2 @ ( lattices_ord_arg_max @ C @ A @ F2 @ P ) )
              = ( F2 @ K ) ) ) ) ) ).

% arg_max_equality
thf(fact_7742_less__eq__num__def,axiom,
    ( ( ord_less_eq @ num )
    = ( ^ [M3: num,N3: num] : ( ord_less_eq @ nat @ ( nat_of_num @ M3 ) @ ( nat_of_num @ N3 ) ) ) ) ).

% less_eq_num_def
thf(fact_7743_arg__maxI,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ord @ B )
     => ! [P: A > $o,X: A,F2: A > B,Q: A > $o] :
          ( ( P @ X )
         => ( ! [Y5: A] :
                ( ( P @ Y5 )
               => ~ ( ord_less @ B @ ( F2 @ X ) @ ( F2 @ Y5 ) ) )
           => ( ! [X3: A] :
                  ( ( P @ X3 )
                 => ( ! [Y6: A] :
                        ( ( P @ Y6 )
                       => ~ ( ord_less @ B @ ( F2 @ X3 ) @ ( F2 @ Y6 ) ) )
                   => ( Q @ X3 ) ) )
             => ( Q @ ( lattices_ord_arg_max @ A @ B @ F2 @ P ) ) ) ) ) ) ).

% arg_maxI
thf(fact_7744_nat__of__num__sqr,axiom,
    ! [X: num] :
      ( ( nat_of_num @ ( sqr @ X ) )
      = ( times_times @ nat @ ( nat_of_num @ X ) @ ( nat_of_num @ X ) ) ) ).

% nat_of_num_sqr
thf(fact_7745_nat__of__num__mult,axiom,
    ! [X: num,Y: num] :
      ( ( nat_of_num @ ( times_times @ num @ X @ Y ) )
      = ( times_times @ nat @ ( nat_of_num @ X ) @ ( nat_of_num @ Y ) ) ) ).

% nat_of_num_mult
thf(fact_7746_less__num__def,axiom,
    ( ( ord_less @ num )
    = ( ^ [M3: num,N3: num] : ( ord_less @ nat @ ( nat_of_num @ M3 ) @ ( nat_of_num @ N3 ) ) ) ) ).

% less_num_def
thf(fact_7747_nat__of__num__add,axiom,
    ! [X: num,Y: num] :
      ( ( nat_of_num @ ( plus_plus @ num @ X @ Y ) )
      = ( plus_plus @ nat @ ( nat_of_num @ X ) @ ( nat_of_num @ Y ) ) ) ).

% nat_of_num_add
thf(fact_7748_nat__of__num_Osimps_I2_J,axiom,
    ! [X: num] :
      ( ( nat_of_num @ ( bit0 @ X ) )
      = ( plus_plus @ nat @ ( nat_of_num @ X ) @ ( nat_of_num @ X ) ) ) ).

% nat_of_num.simps(2)
thf(fact_7749_arg__max__natI,axiom,
    ! [A: $tType,P: A > $o,K: A,F2: A > nat,B2: nat] :
      ( ( P @ K )
     => ( ! [Y5: A] :
            ( ( P @ Y5 )
           => ( ord_less @ nat @ ( F2 @ Y5 ) @ B2 ) )
       => ( P @ ( lattices_ord_arg_max @ A @ nat @ F2 @ P ) ) ) ) ).

% arg_max_natI
thf(fact_7750_nat__of__num__numeral,axiom,
    ( nat_of_num
    = ( numeral_numeral @ nat ) ) ).

% nat_of_num_numeral
thf(fact_7751_nat__of__num__inverse,axiom,
    ! [X: num] :
      ( ( num_of_nat @ ( nat_of_num @ X ) )
      = X ) ).

% nat_of_num_inverse
thf(fact_7752_num__eq__iff,axiom,
    ( ( ^ [Y3: num,Z2: num] : ( Y3 = Z2 ) )
    = ( ^ [X2: num,Y4: num] :
          ( ( nat_of_num @ X2 )
          = ( nat_of_num @ Y4 ) ) ) ) ).

% num_eq_iff
thf(fact_7753_nat__of__num__code_I1_J,axiom,
    ( ( nat_of_num @ one2 )
    = ( one_one @ nat ) ) ).

% nat_of_num_code(1)
thf(fact_7754_nat__of__num__inc,axiom,
    ! [X: num] :
      ( ( nat_of_num @ ( inc @ X ) )
      = ( suc @ ( nat_of_num @ X ) ) ) ).

% nat_of_num_inc
thf(fact_7755_nat__of__num__code_I2_J,axiom,
    ! [N: num] :
      ( ( nat_of_num @ ( bit0 @ N ) )
      = ( plus_plus @ nat @ ( nat_of_num @ N ) @ ( nat_of_num @ N ) ) ) ).

% nat_of_num_code(2)
thf(fact_7756_nat__of__num__neq__0,axiom,
    ! [X: num] :
      ( ( nat_of_num @ X )
     != ( zero_zero @ nat ) ) ).

% nat_of_num_neq_0
thf(fact_7757_nat__of__num__pos,axiom,
    ! [X: num] : ( ord_less @ nat @ ( zero_zero @ nat ) @ ( nat_of_num @ X ) ) ).

% nat_of_num_pos
thf(fact_7758_nat__of__num_Osimps_I1_J,axiom,
    ( ( nat_of_num @ one2 )
    = ( suc @ ( zero_zero @ nat ) ) ) ).

% nat_of_num.simps(1)
thf(fact_7759_nat__of__num_Osimps_I3_J,axiom,
    ! [X: num] :
      ( ( nat_of_num @ ( bit1 @ X ) )
      = ( suc @ ( plus_plus @ nat @ ( nat_of_num @ X ) @ ( nat_of_num @ X ) ) ) ) ).

% nat_of_num.simps(3)
thf(fact_7760_num__of__nat__inverse,axiom,
    ! [N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
     => ( ( nat_of_num @ ( num_of_nat @ N ) )
        = N ) ) ).

% num_of_nat_inverse
thf(fact_7761_nat__of__num__code_I3_J,axiom,
    ! [N: num] :
      ( ( nat_of_num @ ( bit1 @ N ) )
      = ( suc @ ( plus_plus @ nat @ ( nat_of_num @ N ) @ ( nat_of_num @ N ) ) ) ) ).

% nat_of_num_code(3)
thf(fact_7762_plus__num__def,axiom,
    ( ( plus_plus @ num )
    = ( ^ [M3: num,N3: num] : ( num_of_nat @ ( plus_plus @ nat @ ( nat_of_num @ M3 ) @ ( nat_of_num @ N3 ) ) ) ) ) ).

% plus_num_def
thf(fact_7763_arg__max__nat__lemma,axiom,
    ! [A: $tType,P: A > $o,K: A,F2: A > nat,B2: nat] :
      ( ( P @ K )
     => ( ! [Y5: A] :
            ( ( P @ Y5 )
           => ( ord_less @ nat @ ( F2 @ Y5 ) @ B2 ) )
       => ( ( P @ ( lattices_ord_arg_max @ A @ nat @ F2 @ P ) )
          & ! [Y6: A] :
              ( ( P @ Y6 )
             => ( ord_less_eq @ nat @ ( F2 @ Y6 ) @ ( F2 @ ( lattices_ord_arg_max @ A @ nat @ F2 @ P ) ) ) ) ) ) ) ).

% arg_max_nat_lemma
thf(fact_7764_arg__max__on__def,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ord @ A )
     => ( ( lattic1883929316492267755max_on @ B @ A )
        = ( ^ [F3: B > A,S8: set @ B] :
              ( lattices_ord_arg_max @ B @ A @ F3
              @ ^ [X2: B] : ( member @ B @ X2 @ S8 ) ) ) ) ) ).

% arg_max_on_def
thf(fact_7765_arg__max__def,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ord @ A )
     => ( ( lattices_ord_arg_max @ B @ A )
        = ( ^ [F3: B > A,P3: B > $o] : ( fChoice @ B @ ( lattic501386751176901750rg_max @ B @ A @ F3 @ P3 ) ) ) ) ) ).

% arg_max_def
thf(fact_7766_is__arg__max__linorder,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linorder @ B )
     => ( ( lattic501386751176901750rg_max @ A @ B )
        = ( ^ [F3: A > B,P3: A > $o,X2: A] :
              ( ( P3 @ X2 )
              & ! [Y4: A] :
                  ( ( P3 @ Y4 )
                 => ( ord_less_eq @ B @ ( F3 @ Y4 ) @ ( F3 @ X2 ) ) ) ) ) ) ) ).

% is_arg_max_linorder
thf(fact_7767_is__arg__max__def,axiom,
    ! [A: $tType,B: $tType] :
      ( ( ord @ A )
     => ( ( lattic501386751176901750rg_max @ B @ A )
        = ( ^ [F3: B > A,P3: B > $o,X2: B] :
              ( ( P3 @ X2 )
              & ~ ? [Y4: B] :
                    ( ( P3 @ Y4 )
                    & ( ord_less @ A @ ( F3 @ X2 ) @ ( F3 @ Y4 ) ) ) ) ) ) ) ).

% is_arg_max_def
thf(fact_7768_or__num_Osimps_I4_J,axiom,
    ! [M: num] :
      ( ( bit_un6697907153464112080or_num @ ( bit0 @ M ) @ one2 )
      = ( bit1 @ M ) ) ).

% or_num.simps(4)
thf(fact_7769_or__num_Osimps_I2_J,axiom,
    ! [N: num] :
      ( ( bit_un6697907153464112080or_num @ one2 @ ( bit0 @ N ) )
      = ( bit1 @ N ) ) ).

% or_num.simps(2)
thf(fact_7770_numeral__or__num__eq,axiom,
    ! [A: $tType] :
      ( ( bit_un5681908812861735899ations @ A )
     => ! [M: num,N: num] :
          ( ( numeral_numeral @ A @ ( bit_un6697907153464112080or_num @ M @ N ) )
          = ( bit_se1065995026697491101ons_or @ A @ ( numeral_numeral @ A @ M ) @ ( numeral_numeral @ A @ N ) ) ) ) ).

% numeral_or_num_eq
thf(fact_7771_or__num_Osimps_I8_J,axiom,
    ! [M: num,N: num] :
      ( ( bit_un6697907153464112080or_num @ ( bit1 @ M ) @ ( bit0 @ N ) )
      = ( bit1 @ ( bit_un6697907153464112080or_num @ M @ N ) ) ) ).

% or_num.simps(8)
thf(fact_7772_or__num_Osimps_I6_J,axiom,
    ! [M: num,N: num] :
      ( ( bit_un6697907153464112080or_num @ ( bit0 @ M ) @ ( bit1 @ N ) )
      = ( bit1 @ ( bit_un6697907153464112080or_num @ M @ N ) ) ) ).

% or_num.simps(6)
thf(fact_7773_or__num_Osimps_I9_J,axiom,
    ! [M: num,N: num] :
      ( ( bit_un6697907153464112080or_num @ ( bit1 @ M ) @ ( bit1 @ N ) )
      = ( bit1 @ ( bit_un6697907153464112080or_num @ M @ N ) ) ) ).

% or_num.simps(9)
thf(fact_7774_or__num_Osimps_I1_J,axiom,
    ( ( bit_un6697907153464112080or_num @ one2 @ one2 )
    = one2 ) ).

% or_num.simps(1)
thf(fact_7775_or__num_Osimps_I5_J,axiom,
    ! [M: num,N: num] :
      ( ( bit_un6697907153464112080or_num @ ( bit0 @ M ) @ ( bit0 @ N ) )
      = ( bit0 @ ( bit_un6697907153464112080or_num @ M @ N ) ) ) ).

% or_num.simps(5)
thf(fact_7776_or__num_Osimps_I7_J,axiom,
    ! [M: num] :
      ( ( bit_un6697907153464112080or_num @ ( bit1 @ M ) @ one2 )
      = ( bit1 @ M ) ) ).

% or_num.simps(7)
thf(fact_7777_or__num_Osimps_I3_J,axiom,
    ! [N: num] :
      ( ( bit_un6697907153464112080or_num @ one2 @ ( bit1 @ N ) )
      = ( bit1 @ N ) ) ).

% or_num.simps(3)
thf(fact_7778_or__num_Oelims,axiom,
    ! [X: num,Xa: num,Y: num] :
      ( ( ( bit_un6697907153464112080or_num @ X @ Xa )
        = Y )
     => ( ( ( X = one2 )
         => ( ( Xa = one2 )
           => ( Y != one2 ) ) )
       => ( ( ( X = one2 )
           => ! [N2: num] :
                ( ( Xa
                  = ( bit0 @ N2 ) )
               => ( Y
                 != ( bit1 @ N2 ) ) ) )
         => ( ( ( X = one2 )
             => ! [N2: num] :
                  ( ( Xa
                    = ( bit1 @ N2 ) )
                 => ( Y
                   != ( bit1 @ N2 ) ) ) )
           => ( ! [M4: num] :
                  ( ( X
                    = ( bit0 @ M4 ) )
                 => ( ( Xa = one2 )
                   => ( Y
                     != ( bit1 @ M4 ) ) ) )
             => ( ! [M4: num] :
                    ( ( X
                      = ( bit0 @ M4 ) )
                   => ! [N2: num] :
                        ( ( Xa
                          = ( bit0 @ N2 ) )
                       => ( Y
                         != ( bit0 @ ( bit_un6697907153464112080or_num @ M4 @ N2 ) ) ) ) )
               => ( ! [M4: num] :
                      ( ( X
                        = ( bit0 @ M4 ) )
                     => ! [N2: num] :
                          ( ( Xa
                            = ( bit1 @ N2 ) )
                         => ( Y
                           != ( bit1 @ ( bit_un6697907153464112080or_num @ M4 @ N2 ) ) ) ) )
                 => ( ! [M4: num] :
                        ( ( X
                          = ( bit1 @ M4 ) )
                       => ( ( Xa = one2 )
                         => ( Y
                           != ( bit1 @ M4 ) ) ) )
                   => ( ! [M4: num] :
                          ( ( X
                            = ( bit1 @ M4 ) )
                         => ! [N2: num] :
                              ( ( Xa
                                = ( bit0 @ N2 ) )
                             => ( Y
                               != ( bit1 @ ( bit_un6697907153464112080or_num @ M4 @ N2 ) ) ) ) )
                     => ~ ! [M4: num] :
                            ( ( X
                              = ( bit1 @ M4 ) )
                           => ! [N2: num] :
                                ( ( Xa
                                  = ( bit1 @ N2 ) )
                               => ( Y
                                 != ( bit1 @ ( bit_un6697907153464112080or_num @ M4 @ N2 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ).

% or_num.elims
thf(fact_7779_or__num_Opelims,axiom,
    ! [X: num,Xa: num,Y: num] :
      ( ( ( bit_un6697907153464112080or_num @ X @ Xa )
        = Y )
     => ( ( accp @ ( product_prod @ num @ num ) @ bit_un4773296044027857193um_rel @ ( product_Pair @ num @ num @ X @ Xa ) )
       => ( ( ( X = one2 )
           => ( ( Xa = one2 )
             => ( ( Y = one2 )
               => ~ ( accp @ ( product_prod @ num @ num ) @ bit_un4773296044027857193um_rel @ ( product_Pair @ num @ num @ one2 @ one2 ) ) ) ) )
         => ( ( ( X = one2 )
             => ! [N2: num] :
                  ( ( Xa
                    = ( bit0 @ N2 ) )
                 => ( ( Y
                      = ( bit1 @ N2 ) )
                   => ~ ( accp @ ( product_prod @ num @ num ) @ bit_un4773296044027857193um_rel @ ( product_Pair @ num @ num @ one2 @ ( bit0 @ N2 ) ) ) ) ) )
           => ( ( ( X = one2 )
               => ! [N2: num] :
                    ( ( Xa
                      = ( bit1 @ N2 ) )
                   => ( ( Y
                        = ( bit1 @ N2 ) )
                     => ~ ( accp @ ( product_prod @ num @ num ) @ bit_un4773296044027857193um_rel @ ( product_Pair @ num @ num @ one2 @ ( bit1 @ N2 ) ) ) ) ) )
             => ( ! [M4: num] :
                    ( ( X
                      = ( bit0 @ M4 ) )
                   => ( ( Xa = one2 )
                     => ( ( Y
                          = ( bit1 @ M4 ) )
                       => ~ ( accp @ ( product_prod @ num @ num ) @ bit_un4773296044027857193um_rel @ ( product_Pair @ num @ num @ ( bit0 @ M4 ) @ one2 ) ) ) ) )
               => ( ! [M4: num] :
                      ( ( X
                        = ( bit0 @ M4 ) )
                     => ! [N2: num] :
                          ( ( Xa
                            = ( bit0 @ N2 ) )
                         => ( ( Y
                              = ( bit0 @ ( bit_un6697907153464112080or_num @ M4 @ N2 ) ) )
                           => ~ ( accp @ ( product_prod @ num @ num ) @ bit_un4773296044027857193um_rel @ ( product_Pair @ num @ num @ ( bit0 @ M4 ) @ ( bit0 @ N2 ) ) ) ) ) )
                 => ( ! [M4: num] :
                        ( ( X
                          = ( bit0 @ M4 ) )
                       => ! [N2: num] :
                            ( ( Xa
                              = ( bit1 @ N2 ) )
                           => ( ( Y
                                = ( bit1 @ ( bit_un6697907153464112080or_num @ M4 @ N2 ) ) )
                             => ~ ( accp @ ( product_prod @ num @ num ) @ bit_un4773296044027857193um_rel @ ( product_Pair @ num @ num @ ( bit0 @ M4 ) @ ( bit1 @ N2 ) ) ) ) ) )
                   => ( ! [M4: num] :
                          ( ( X
                            = ( bit1 @ M4 ) )
                         => ( ( Xa = one2 )
                           => ( ( Y
                                = ( bit1 @ M4 ) )
                             => ~ ( accp @ ( product_prod @ num @ num ) @ bit_un4773296044027857193um_rel @ ( product_Pair @ num @ num @ ( bit1 @ M4 ) @ one2 ) ) ) ) )
                     => ( ! [M4: num] :
                            ( ( X
                              = ( bit1 @ M4 ) )
                           => ! [N2: num] :
                                ( ( Xa
                                  = ( bit0 @ N2 ) )
                               => ( ( Y
                                    = ( bit1 @ ( bit_un6697907153464112080or_num @ M4 @ N2 ) ) )
                                 => ~ ( accp @ ( product_prod @ num @ num ) @ bit_un4773296044027857193um_rel @ ( product_Pair @ num @ num @ ( bit1 @ M4 ) @ ( bit0 @ N2 ) ) ) ) ) )
                       => ~ ! [M4: num] :
                              ( ( X
                                = ( bit1 @ M4 ) )
                             => ! [N2: num] :
                                  ( ( Xa
                                    = ( bit1 @ N2 ) )
                                 => ( ( Y
                                      = ( bit1 @ ( bit_un6697907153464112080or_num @ M4 @ N2 ) ) )
                                   => ~ ( accp @ ( product_prod @ num @ num ) @ bit_un4773296044027857193um_rel @ ( product_Pair @ num @ num @ ( bit1 @ M4 ) @ ( bit1 @ N2 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ).

% or_num.pelims
thf(fact_7780_or__num__dict,axiom,
    bit_un6697907153464112080or_num = bit_un2785000775030745342or_num ).

% or_num_dict
thf(fact_7781_or__num__rel__dict,axiom,
    bit_un4773296044027857193um_rel = bit_un6909899581280750971um_rel ).

% or_num_rel_dict
thf(fact_7782_inv__unit__factor__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( normal8620421768224518004emidom @ A )
     => ! [A2: A] :
          ( ( ( divide_divide @ A @ ( one_one @ A ) @ ( unit_f5069060285200089521factor @ A @ A2 ) )
            = ( zero_zero @ A ) )
          = ( A2
            = ( zero_zero @ A ) ) ) ) ).

% inv_unit_factor_eq_0_iff
thf(fact_7783_unit__factor__simps_I1_J,axiom,
    ( ( unit_f5069060285200089521factor @ nat @ ( zero_zero @ nat ) )
    = ( zero_zero @ nat ) ) ).

% unit_factor_simps(1)
thf(fact_7784_unit__factor__0,axiom,
    ! [A: $tType] :
      ( ( semido2269285787275462019factor @ A )
     => ( ( unit_f5069060285200089521factor @ A @ ( zero_zero @ A ) )
        = ( zero_zero @ A ) ) ) ).

% unit_factor_0
thf(fact_7785_unit__factor__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( normal8620421768224518004emidom @ A )
     => ! [A2: A] :
          ( ( ( unit_f5069060285200089521factor @ A @ A2 )
            = ( zero_zero @ A ) )
          = ( A2
            = ( zero_zero @ A ) ) ) ) ).

% unit_factor_eq_0_iff
thf(fact_7786_unit__factor__gcd,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A2: A,B2: A] :
          ( ( ( ( A2
                = ( zero_zero @ A ) )
              & ( B2
                = ( zero_zero @ A ) ) )
           => ( ( unit_f5069060285200089521factor @ A @ ( gcd_gcd @ A @ A2 @ B2 ) )
              = ( zero_zero @ A ) ) )
          & ( ~ ( ( A2
                  = ( zero_zero @ A ) )
                & ( B2
                  = ( zero_zero @ A ) ) )
           => ( ( unit_f5069060285200089521factor @ A @ ( gcd_gcd @ A @ A2 @ B2 ) )
              = ( one_one @ A ) ) ) ) ) ).

% unit_factor_gcd
thf(fact_7787_unit__factor__is__unit,axiom,
    ! [A: $tType] :
      ( ( semido2269285787275462019factor @ A )
     => ! [A2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( dvd_dvd @ A @ ( unit_f5069060285200089521factor @ A @ A2 ) @ ( one_one @ A ) ) ) ) ).

% unit_factor_is_unit
thf(fact_7788_unit__factor__power,axiom,
    ! [A: $tType] :
      ( ( normal6328177297339901930cative @ A )
     => ! [A2: A,N: nat] :
          ( ( unit_f5069060285200089521factor @ A @ ( power_power @ A @ A2 @ N ) )
          = ( power_power @ A @ ( unit_f5069060285200089521factor @ A @ A2 ) @ N ) ) ) ).

% unit_factor_power
thf(fact_7789_unit__factor__dvd,axiom,
    ! [A: $tType] :
      ( ( normal8620421768224518004emidom @ A )
     => ! [A2: A,B2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( dvd_dvd @ A @ ( unit_f5069060285200089521factor @ A @ A2 ) @ B2 ) ) ) ).

% unit_factor_dvd
thf(fact_7790_unit__factor__nat__def,axiom,
    ( ( unit_f5069060285200089521factor @ nat )
    = ( ^ [N3: nat] :
          ( if @ nat
          @ ( N3
            = ( zero_zero @ nat ) )
          @ ( zero_zero @ nat )
          @ ( one_one @ nat ) ) ) ) ).

% unit_factor_nat_def
thf(fact_7791_coprime__crossproduct_H,axiom,
    ! [A: $tType] :
      ( ( semiri6843258321239162965malize @ A )
     => ! [B2: A,D2: A,A2: A,C2: A] :
          ( ( B2
           != ( zero_zero @ A ) )
         => ( ( ( unit_f5069060285200089521factor @ A @ B2 )
              = ( unit_f5069060285200089521factor @ A @ D2 ) )
           => ( ( algebr8660921524188924756oprime @ A @ A2 @ B2 )
             => ( ( algebr8660921524188924756oprime @ A @ C2 @ D2 )
               => ( ( ( times_times @ A @ A2 @ D2 )
                    = ( times_times @ A @ B2 @ C2 ) )
                  = ( ( A2 = C2 )
                    & ( B2 = D2 ) ) ) ) ) ) ) ) ).

% coprime_crossproduct'
thf(fact_7792_unit__factor__Gcd,axiom,
    ! [A: $tType] :
      ( ( semiring_Gcd @ A )
     => ! [A4: set @ A] :
          ( ( ( ( gcd_Gcd @ A @ A4 )
              = ( zero_zero @ A ) )
           => ( ( unit_f5069060285200089521factor @ A @ ( gcd_Gcd @ A @ A4 ) )
              = ( zero_zero @ A ) ) )
          & ( ( ( gcd_Gcd @ A @ A4 )
             != ( zero_zero @ A ) )
           => ( ( unit_f5069060285200089521factor @ A @ ( gcd_Gcd @ A @ A4 ) )
              = ( one_one @ A ) ) ) ) ) ).

% unit_factor_Gcd
thf(fact_7793_unit__factor__Gcd__fin,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A4: set @ A] :
          ( ( unit_f5069060285200089521factor @ A @ ( semiring_gcd_Gcd_fin @ A @ A4 ) )
          = ( zero_neq_one_of_bool @ A
            @ ( ( semiring_gcd_Gcd_fin @ A @ A4 )
             != ( zero_zero @ A ) ) ) ) ) ).

% unit_factor_Gcd_fin
thf(fact_7794_frequently__at,axiom,
    ! [A: $tType] :
      ( ( real_V7819770556892013058_space @ A )
     => ! [P: A > $o,A2: A,S: set @ A] :
          ( ( frequently @ A @ P @ ( topolo174197925503356063within @ A @ A2 @ S ) )
          = ( ! [D4: real] :
                ( ( ord_less @ real @ ( zero_zero @ real ) @ D4 )
               => ? [X2: A] :
                    ( ( member @ A @ X2 @ S )
                    & ( X2 != A2 )
                    & ( ord_less @ real @ ( real_V557655796197034286t_dist @ A @ X2 @ A2 ) @ D4 )
                    & ( P @ X2 ) ) ) ) ) ) ).

% frequently_at
thf(fact_7795_fold__atLeastAtMost__nat_Opsimps,axiom,
    ! [A: $tType,F2: nat > A > A,A2: nat,B2: nat,Acc2: A] :
      ( ( accp @ ( product_prod @ ( nat > A > A ) @ ( product_prod @ nat @ ( product_prod @ nat @ A ) ) ) @ ( set_fo1817059534552279752at_rel @ A ) @ ( product_Pair @ ( nat > A > A ) @ ( product_prod @ nat @ ( product_prod @ nat @ A ) ) @ F2 @ ( product_Pair @ nat @ ( product_prod @ nat @ A ) @ A2 @ ( product_Pair @ nat @ A @ B2 @ Acc2 ) ) ) )
     => ( ( ( ord_less @ nat @ B2 @ A2 )
         => ( ( set_fo6178422350223883121st_nat @ A @ F2 @ A2 @ B2 @ Acc2 )
            = Acc2 ) )
        & ( ~ ( ord_less @ nat @ B2 @ A2 )
         => ( ( set_fo6178422350223883121st_nat @ A @ F2 @ A2 @ B2 @ Acc2 )
            = ( set_fo6178422350223883121st_nat @ A @ F2 @ ( plus_plus @ nat @ A2 @ ( one_one @ nat ) ) @ B2 @ ( F2 @ A2 @ Acc2 ) ) ) ) ) ) ).

% fold_atLeastAtMost_nat.psimps
thf(fact_7796_fold__atLeastAtMost__nat_Opinduct,axiom,
    ! [A: $tType,A0: nat > A > A,A12: nat,A23: nat,A32: A,P: ( nat > A > A ) > nat > nat > A > $o] :
      ( ( accp @ ( product_prod @ ( nat > A > A ) @ ( product_prod @ nat @ ( product_prod @ nat @ A ) ) ) @ ( set_fo1817059534552279752at_rel @ A ) @ ( product_Pair @ ( nat > A > A ) @ ( product_prod @ nat @ ( product_prod @ nat @ A ) ) @ A0 @ ( product_Pair @ nat @ ( product_prod @ nat @ A ) @ A12 @ ( product_Pair @ nat @ A @ A23 @ A32 ) ) ) )
     => ( ! [F6: nat > A > A,A5: nat,B4: nat,Acc3: A] :
            ( ( accp @ ( product_prod @ ( nat > A > A ) @ ( product_prod @ nat @ ( product_prod @ nat @ A ) ) ) @ ( set_fo1817059534552279752at_rel @ A ) @ ( product_Pair @ ( nat > A > A ) @ ( product_prod @ nat @ ( product_prod @ nat @ A ) ) @ F6 @ ( product_Pair @ nat @ ( product_prod @ nat @ A ) @ A5 @ ( product_Pair @ nat @ A @ B4 @ Acc3 ) ) ) )
           => ( ( ~ ( ord_less @ nat @ B4 @ A5 )
               => ( P @ F6 @ ( plus_plus @ nat @ A5 @ ( one_one @ nat ) ) @ B4 @ ( F6 @ A5 @ Acc3 ) ) )
             => ( P @ F6 @ A5 @ B4 @ Acc3 ) ) )
       => ( P @ A0 @ A12 @ A23 @ A32 ) ) ) ).

% fold_atLeastAtMost_nat.pinduct
thf(fact_7797_fold__atLeastAtMost__nat_Opelims,axiom,
    ! [A: $tType,X: nat > A > A,Xa: nat,Xb: nat,Xc: A,Y: A] :
      ( ( ( set_fo6178422350223883121st_nat @ A @ X @ Xa @ Xb @ Xc )
        = Y )
     => ( ( accp @ ( product_prod @ ( nat > A > A ) @ ( product_prod @ nat @ ( product_prod @ nat @ A ) ) ) @ ( set_fo1817059534552279752at_rel @ A ) @ ( product_Pair @ ( nat > A > A ) @ ( product_prod @ nat @ ( product_prod @ nat @ A ) ) @ X @ ( product_Pair @ nat @ ( product_prod @ nat @ A ) @ Xa @ ( product_Pair @ nat @ A @ Xb @ Xc ) ) ) )
       => ~ ( ( ( ( ord_less @ nat @ Xb @ Xa )
               => ( Y = Xc ) )
              & ( ~ ( ord_less @ nat @ Xb @ Xa )
               => ( Y
                  = ( set_fo6178422350223883121st_nat @ A @ X @ ( plus_plus @ nat @ Xa @ ( one_one @ nat ) ) @ Xb @ ( X @ Xa @ Xc ) ) ) ) )
           => ~ ( accp @ ( product_prod @ ( nat > A > A ) @ ( product_prod @ nat @ ( product_prod @ nat @ A ) ) ) @ ( set_fo1817059534552279752at_rel @ A ) @ ( product_Pair @ ( nat > A > A ) @ ( product_prod @ nat @ ( product_prod @ nat @ A ) ) @ X @ ( product_Pair @ nat @ ( product_prod @ nat @ A ) @ Xa @ ( product_Pair @ nat @ A @ Xb @ Xc ) ) ) ) ) ) ) ).

% fold_atLeastAtMost_nat.pelims
thf(fact_7798_sum_Ocomm__monoid__list__set__axioms,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ( groups4802862169904069756st_set @ A @ ( plus_plus @ A ) @ ( zero_zero @ A ) ) ) ).

% sum.comm_monoid_list_set_axioms
thf(fact_7799_unit__factor__Lcm__fin,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A4: set @ A] :
          ( ( unit_f5069060285200089521factor @ A @ ( semiring_gcd_Lcm_fin @ A @ A4 ) )
          = ( zero_neq_one_of_bool @ A
            @ ( ( semiring_gcd_Lcm_fin @ A @ A4 )
             != ( zero_zero @ A ) ) ) ) ) ).

% unit_factor_Lcm_fin
thf(fact_7800_Lcm__fin_Oinfinite,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A4: set @ A] :
          ( ~ ( finite_finite @ A @ A4 )
         => ( ( semiring_gcd_Lcm_fin @ A @ A4 )
            = ( zero_zero @ A ) ) ) ) ).

% Lcm_fin.infinite
thf(fact_7801_Lcm__fin__0__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A4: set @ A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( ( semiring_gcd_Lcm_fin @ A @ A4 )
              = ( zero_zero @ A ) )
            = ( member @ A @ ( zero_zero @ A ) @ A4 ) ) ) ) ).

% Lcm_fin_0_iff
thf(fact_7802_Lcm__fin_Oeq__fold,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ( ( semiring_gcd_Lcm_fin @ A )
        = ( ^ [A7: set @ A] : ( if @ A @ ( finite_finite @ A @ A7 ) @ ( finite_fold @ A @ A @ ( gcd_lcm @ A ) @ ( one_one @ A ) @ A7 ) @ ( zero_zero @ A ) ) ) ) ) ).

% Lcm_fin.eq_fold
thf(fact_7803_Lcm__fin__def,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ( ( semiring_gcd_Lcm_fin @ A )
        = ( bounde2362111253966948842tice_F @ A @ ( gcd_lcm @ A ) @ ( one_one @ A ) @ ( zero_zero @ A ) ) ) ) ).

% Lcm_fin_def
thf(fact_7804_lcm__0__iff__nat,axiom,
    ! [M: nat,N: nat] :
      ( ( ( gcd_lcm @ nat @ M @ N )
        = ( zero_zero @ nat ) )
      = ( ( M
          = ( zero_zero @ nat ) )
        | ( N
          = ( zero_zero @ nat ) ) ) ) ).

% lcm_0_iff_nat
thf(fact_7805_lcm__0__iff__int,axiom,
    ! [M: int,N: int] :
      ( ( ( gcd_lcm @ int @ M @ N )
        = ( zero_zero @ int ) )
      = ( ( M
          = ( zero_zero @ int ) )
        | ( N
          = ( zero_zero @ int ) ) ) ) ).

% lcm_0_iff_int
thf(fact_7806_lcm__int__int__eq,axiom,
    ! [M: nat,N: nat] :
      ( ( gcd_lcm @ int @ ( semiring_1_of_nat @ int @ M ) @ ( semiring_1_of_nat @ int @ N ) )
      = ( semiring_1_of_nat @ int @ ( gcd_lcm @ nat @ M @ N ) ) ) ).

% lcm_int_int_eq
thf(fact_7807_lcm__1__iff__nat,axiom,
    ! [M: nat,N: nat] :
      ( ( ( gcd_lcm @ nat @ M @ N )
        = ( suc @ ( zero_zero @ nat ) ) )
      = ( ( M
          = ( suc @ ( zero_zero @ nat ) ) )
        & ( N
          = ( suc @ ( zero_zero @ nat ) ) ) ) ) ).

% lcm_1_iff_nat
thf(fact_7808_lcm_Obottom__right__bottom,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A2: A] :
          ( ( gcd_lcm @ A @ A2 @ ( zero_zero @ A ) )
          = ( zero_zero @ A ) ) ) ).

% lcm.bottom_right_bottom
thf(fact_7809_lcm_Obottom__left__bottom,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A2: A] :
          ( ( gcd_lcm @ A @ ( zero_zero @ A ) @ A2 )
          = ( zero_zero @ A ) ) ) ).

% lcm.bottom_left_bottom
thf(fact_7810_lcm__neg__numeral__1,axiom,
    ! [A: $tType] :
      ( ( ring_gcd @ A )
     => ! [N: num,A2: A] :
          ( ( gcd_lcm @ A @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) @ A2 )
          = ( gcd_lcm @ A @ ( numeral_numeral @ A @ N ) @ A2 ) ) ) ).

% lcm_neg_numeral_1
thf(fact_7811_lcm__neg__numeral__2,axiom,
    ! [A: $tType] :
      ( ( ring_gcd @ A )
     => ! [A2: A,N: num] :
          ( ( gcd_lcm @ A @ A2 @ ( uminus_uminus @ A @ ( numeral_numeral @ A @ N ) ) )
          = ( gcd_lcm @ A @ A2 @ ( numeral_numeral @ A @ N ) ) ) ) ).

% lcm_neg_numeral_2
thf(fact_7812_lcm__nat__abs__right__eq,axiom,
    ! [N: nat,K: int] :
      ( ( gcd_lcm @ nat @ N @ ( nat2 @ ( abs_abs @ int @ K ) ) )
      = ( nat2 @ ( gcd_lcm @ int @ ( semiring_1_of_nat @ int @ N ) @ K ) ) ) ).

% lcm_nat_abs_right_eq
thf(fact_7813_lcm__nat__abs__left__eq,axiom,
    ! [K: int,N: nat] :
      ( ( gcd_lcm @ nat @ ( nat2 @ ( abs_abs @ int @ K ) ) @ N )
      = ( nat2 @ ( gcd_lcm @ int @ K @ ( semiring_1_of_nat @ int @ N ) ) ) ) ).

% lcm_nat_abs_left_eq
thf(fact_7814_unit__factor__lcm,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A2: A,B2: A] :
          ( ( ( ( A2
                = ( zero_zero @ A ) )
              | ( B2
                = ( zero_zero @ A ) ) )
           => ( ( unit_f5069060285200089521factor @ A @ ( gcd_lcm @ A @ A2 @ B2 ) )
              = ( zero_zero @ A ) ) )
          & ( ~ ( ( A2
                  = ( zero_zero @ A ) )
                | ( B2
                  = ( zero_zero @ A ) ) )
           => ( ( unit_f5069060285200089521factor @ A @ ( gcd_lcm @ A @ A2 @ B2 ) )
              = ( one_one @ A ) ) ) ) ) ).

% unit_factor_lcm
thf(fact_7815_lcm__pos__int,axiom,
    ! [M: int,N: int] :
      ( ( M
       != ( zero_zero @ int ) )
     => ( ( N
         != ( zero_zero @ int ) )
       => ( ord_less @ int @ ( zero_zero @ int ) @ ( gcd_lcm @ int @ M @ N ) ) ) ) ).

% lcm_pos_int
thf(fact_7816_lcm__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A2: A,B2: A] :
          ( ( ( gcd_lcm @ A @ A2 @ B2 )
            = ( zero_zero @ A ) )
          = ( ( A2
              = ( zero_zero @ A ) )
            | ( B2
              = ( zero_zero @ A ) ) ) ) ) ).

% lcm_eq_0_iff
thf(fact_7817_zero__eq__lcm__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A2: A,B2: A] :
          ( ( ( zero_zero @ A )
            = ( gcd_lcm @ A @ A2 @ B2 ) )
          = ( ( A2
              = ( zero_zero @ A ) )
            | ( B2
              = ( zero_zero @ A ) ) ) ) ) ).

% zero_eq_lcm_iff
thf(fact_7818_lcm__pos__nat,axiom,
    ! [M: nat,N: nat] :
      ( ( ord_less @ nat @ ( zero_zero @ nat ) @ M )
     => ( ( ord_less @ nat @ ( zero_zero @ nat ) @ N )
       => ( ord_less @ nat @ ( zero_zero @ nat ) @ ( gcd_lcm @ nat @ M @ N ) ) ) ) ).

% lcm_pos_nat
thf(fact_7819_lcm__int__def,axiom,
    ( ( gcd_lcm @ int )
    = ( ^ [X2: int,Y4: int] : ( semiring_1_of_nat @ int @ ( gcd_lcm @ nat @ ( nat2 @ ( abs_abs @ int @ X2 ) ) @ ( nat2 @ ( abs_abs @ int @ Y4 ) ) ) ) ) ) ).

% lcm_int_def
thf(fact_7820_lcm__unique__int,axiom,
    ! [D2: int,A2: int,B2: int] :
      ( ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ D2 )
        & ( dvd_dvd @ int @ A2 @ D2 )
        & ( dvd_dvd @ int @ B2 @ D2 )
        & ! [E3: int] :
            ( ( ( dvd_dvd @ int @ A2 @ E3 )
              & ( dvd_dvd @ int @ B2 @ E3 ) )
           => ( dvd_dvd @ int @ D2 @ E3 ) ) )
      = ( D2
        = ( gcd_lcm @ int @ A2 @ B2 ) ) ) ).

% lcm_unique_int
thf(fact_7821_lcm__cases__int,axiom,
    ! [X: int,Y: int,P: int > $o] :
      ( ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ X )
       => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Y )
         => ( P @ ( gcd_lcm @ int @ X @ Y ) ) ) )
     => ( ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ X )
         => ( ( ord_less_eq @ int @ Y @ ( zero_zero @ int ) )
           => ( P @ ( gcd_lcm @ int @ X @ ( uminus_uminus @ int @ Y ) ) ) ) )
       => ( ( ( ord_less_eq @ int @ X @ ( zero_zero @ int ) )
           => ( ( ord_less_eq @ int @ ( zero_zero @ int ) @ Y )
             => ( P @ ( gcd_lcm @ int @ ( uminus_uminus @ int @ X ) @ Y ) ) ) )
         => ( ( ( ord_less_eq @ int @ X @ ( zero_zero @ int ) )
             => ( ( ord_less_eq @ int @ Y @ ( zero_zero @ int ) )
               => ( P @ ( gcd_lcm @ int @ ( uminus_uminus @ int @ X ) @ ( uminus_uminus @ int @ Y ) ) ) ) )
           => ( P @ ( gcd_lcm @ int @ X @ Y ) ) ) ) ) ) ).

% lcm_cases_int
thf(fact_7822_lcm__ge__0__int,axiom,
    ! [X: int,Y: int] : ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( gcd_lcm @ int @ X @ Y ) ) ).

% lcm_ge_0_int
thf(fact_7823_Lcm__eq__Max__nat,axiom,
    ! [M5: set @ nat] :
      ( ( finite_finite @ nat @ M5 )
     => ( ( M5
         != ( bot_bot @ ( set @ nat ) ) )
       => ( ~ ( member @ nat @ ( zero_zero @ nat ) @ M5 )
         => ( ! [M4: nat,N2: nat] :
                ( ( member @ nat @ M4 @ M5 )
               => ( ( member @ nat @ N2 @ M5 )
                 => ( member @ nat @ ( gcd_lcm @ nat @ M4 @ N2 ) @ M5 ) ) )
           => ( ( gcd_Lcm @ nat @ M5 )
              = ( lattic643756798349783984er_Max @ nat @ M5 ) ) ) ) ) ) ).

% Lcm_eq_Max_nat
thf(fact_7824_gcd__lcm,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A2: A,B2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( B2
             != ( zero_zero @ A ) )
           => ( ( gcd_gcd @ A @ A2 @ B2 )
              = ( normal6383669964737779283malize @ A @ ( divide_divide @ A @ ( times_times @ A @ A2 @ B2 ) @ ( gcd_lcm @ A @ A2 @ B2 ) ) ) ) ) ) ) ).

% gcd_lcm
thf(fact_7825_lcm_Onormalize__bottom,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ( ( normal6383669964737779283malize @ A @ ( zero_zero @ A ) )
        = ( zero_zero @ A ) ) ) ).

% lcm.normalize_bottom
thf(fact_7826_normalize__0,axiom,
    ! [A: $tType] :
      ( ( normal8620421768224518004emidom @ A )
     => ( ( normal6383669964737779283malize @ A @ ( zero_zero @ A ) )
        = ( zero_zero @ A ) ) ) ).

% normalize_0
thf(fact_7827_normalize__eq__0__iff,axiom,
    ! [A: $tType] :
      ( ( normal8620421768224518004emidom @ A )
     => ! [A2: A] :
          ( ( ( normal6383669964737779283malize @ A @ A2 )
            = ( zero_zero @ A ) )
          = ( A2
            = ( zero_zero @ A ) ) ) ) ).

% normalize_eq_0_iff
thf(fact_7828_Lcm__eq__0__I__nat,axiom,
    ! [A4: set @ nat] :
      ( ( member @ nat @ ( zero_zero @ nat ) @ A4 )
     => ( ( gcd_Lcm @ nat @ A4 )
        = ( zero_zero @ nat ) ) ) ).

% Lcm_eq_0_I_nat
thf(fact_7829_Lcm__UNIV,axiom,
    ! [A: $tType] :
      ( ( semiring_Gcd @ A )
     => ( ( gcd_Lcm @ A @ ( top_top @ ( set @ A ) ) )
        = ( zero_zero @ A ) ) ) ).

% Lcm_UNIV
thf(fact_7830_gcd_Otop__left__normalize,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A2: A] :
          ( ( gcd_gcd @ A @ ( zero_zero @ A ) @ A2 )
          = ( normal6383669964737779283malize @ A @ A2 ) ) ) ).

% gcd.top_left_normalize
thf(fact_7831_gcd_Otop__right__normalize,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A2: A] :
          ( ( gcd_gcd @ A @ A2 @ ( zero_zero @ A ) )
          = ( normal6383669964737779283malize @ A @ A2 ) ) ) ).

% gcd.top_right_normalize
thf(fact_7832_Lcm__0__iff__nat,axiom,
    ! [A4: set @ nat] :
      ( ( finite_finite @ nat @ A4 )
     => ( ( ( gcd_Lcm @ nat @ A4 )
          = ( zero_zero @ nat ) )
        = ( member @ nat @ ( zero_zero @ nat ) @ A4 ) ) ) ).

% Lcm_0_iff_nat
thf(fact_7833_unit__factor__normalize,axiom,
    ! [A: $tType] :
      ( ( normal8620421768224518004emidom @ A )
     => ! [A2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( unit_f5069060285200089521factor @ A @ ( normal6383669964737779283malize @ A @ A2 ) )
            = ( one_one @ A ) ) ) ) ).

% unit_factor_normalize
thf(fact_7834_normalize__unit__factor,axiom,
    ! [A: $tType] :
      ( ( normal8620421768224518004emidom @ A )
     => ! [A2: A] :
          ( ( A2
           != ( zero_zero @ A ) )
         => ( ( normal6383669964737779283malize @ A @ ( unit_f5069060285200089521factor @ A @ A2 ) )
            = ( one_one @ A ) ) ) ) ).

% normalize_unit_factor
thf(fact_7835_normalize__idem__imp__unit__factor__eq,axiom,
    ! [A: $tType] :
      ( ( normal8620421768224518004emidom @ A )
     => ! [A2: A] :
          ( ( ( normal6383669964737779283malize @ A @ A2 )
            = A2 )
         => ( ( unit_f5069060285200089521factor @ A @ A2 )
            = ( zero_neq_one_of_bool @ A
              @ ( A2
               != ( zero_zero @ A ) ) ) ) ) ) ).

% normalize_idem_imp_unit_factor_eq
thf(fact_7836_Lcm__0__iff,axiom,
    ! [A: $tType] :
      ( ( semiring_Gcd @ A )
     => ! [A4: set @ A] :
          ( ( finite_finite @ A @ A4 )
         => ( ( ( gcd_Lcm @ A @ A4 )
              = ( zero_zero @ A ) )
            = ( member @ A @ ( zero_zero @ A ) @ A4 ) ) ) ) ).

% Lcm_0_iff
thf(fact_7837_Lcm__nat__infinite,axiom,
    ! [M5: set @ nat] :
      ( ~ ( finite_finite @ nat @ M5 )
     => ( ( gcd_Lcm @ nat @ M5 )
        = ( zero_zero @ nat ) ) ) ).

% Lcm_nat_infinite
thf(fact_7838_gcd__exp__weak,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ! [A2: A,N: nat,B2: A] :
          ( ( gcd_gcd @ A @ ( power_power @ A @ A2 @ N ) @ ( power_power @ A @ B2 @ N ) )
          = ( normal6383669964737779283malize @ A @ ( power_power @ A @ ( gcd_gcd @ A @ A2 @ B2 ) @ N ) ) ) ) ).

% gcd_exp_weak
thf(fact_7839_normalize__power,axiom,
    ! [A: $tType] :
      ( ( normal6328177297339901930cative @ A )
     => ! [A2: A,N: nat] :
          ( ( normal6383669964737779283malize @ A @ ( power_power @ A @ A2 @ N ) )
          = ( power_power @ A @ ( normal6383669964737779283malize @ A @ A2 ) @ N ) ) ) ).

% normalize_power
thf(fact_7840_Lcm__eq__0__I,axiom,
    ! [A: $tType] :
      ( ( semiring_Gcd @ A )
     => ! [A4: set @ A] :
          ( ( member @ A @ ( zero_zero @ A ) @ A4 )
         => ( ( gcd_Lcm @ A @ A4 )
            = ( zero_zero @ A ) ) ) ) ).

% Lcm_eq_0_I
thf(fact_7841_Lcm__0__iff_H,axiom,
    ! [A: $tType] :
      ( ( semiring_Gcd @ A )
     => ! [A4: set @ A] :
          ( ( ( gcd_Lcm @ A @ A4 )
            = ( zero_zero @ A ) )
          = ( ~ ? [L2: A] :
                  ( ( L2
                   != ( zero_zero @ A ) )
                  & ! [X2: A] :
                      ( ( member @ A @ X2 @ A4 )
                     => ( dvd_dvd @ A @ X2 @ L2 ) ) ) ) ) ) ).

% Lcm_0_iff'
thf(fact_7842_Lcm__no__multiple,axiom,
    ! [A: $tType] :
      ( ( semiring_Gcd @ A )
     => ! [A4: set @ A] :
          ( ! [M4: A] :
              ( ( M4
               != ( zero_zero @ A ) )
             => ? [X5: A] :
                  ( ( member @ A @ X5 @ A4 )
                  & ~ ( dvd_dvd @ A @ X5 @ M4 ) ) )
         => ( ( gcd_Lcm @ A @ A4 )
            = ( zero_zero @ A ) ) ) ) ).

% Lcm_no_multiple
thf(fact_7843_Lcm__coprime_H,axiom,
    ! [A: $tType] :
      ( ( semiring_Gcd @ A )
     => ! [A4: set @ A] :
          ( ( ( finite_card @ A @ A4 )
           != ( zero_zero @ nat ) )
         => ( ! [A5: A,B4: A] :
                ( ( member @ A @ A5 @ A4 )
               => ( ( member @ A @ B4 @ A4 )
                 => ( ( A5 != B4 )
                   => ( algebr8660921524188924756oprime @ A @ A5 @ B4 ) ) ) )
           => ( ( gcd_Lcm @ A @ A4 )
              = ( normal6383669964737779283malize @ A
                @ ( groups7121269368397514597t_prod @ A @ A
                  @ ^ [X2: A] : X2
                  @ A4 ) ) ) ) ) ) ).

% Lcm_coprime'
thf(fact_7844_unit__factor__Lcm,axiom,
    ! [A: $tType] :
      ( ( semiring_Gcd @ A )
     => ! [A4: set @ A] :
          ( ( ( ( gcd_Lcm @ A @ A4 )
              = ( zero_zero @ A ) )
           => ( ( unit_f5069060285200089521factor @ A @ ( gcd_Lcm @ A @ A4 ) )
              = ( zero_zero @ A ) ) )
          & ( ( ( gcd_Lcm @ A @ A4 )
             != ( zero_zero @ A ) )
           => ( ( unit_f5069060285200089521factor @ A @ ( gcd_Lcm @ A @ A4 ) )
              = ( one_one @ A ) ) ) ) ) ).

% unit_factor_Lcm
thf(fact_7845_Lcm__int__def,axiom,
    ( ( gcd_Lcm @ int )
    = ( ^ [K7: set @ int] : ( semiring_1_of_nat @ int @ ( gcd_Lcm @ nat @ ( image @ int @ nat @ ( comp @ int @ nat @ int @ nat2 @ ( abs_abs @ int ) ) @ K7 ) ) ) ) ) ).

% Lcm_int_def
thf(fact_7846_Lcm__nat__def,axiom,
    ( ( gcd_Lcm @ nat )
    = ( ^ [M8: set @ nat] : ( if @ nat @ ( finite_finite @ nat @ M8 ) @ ( lattic5214292709420241887eutr_F @ nat @ ( gcd_lcm @ nat ) @ ( one_one @ nat ) @ M8 ) @ ( zero_zero @ nat ) ) ) ) ).

% Lcm_nat_def
thf(fact_7847_Lcm__int__eq,axiom,
    ! [N4: set @ nat] :
      ( ( gcd_Lcm @ int @ ( image @ nat @ int @ ( semiring_1_of_nat @ int ) @ N4 ) )
      = ( semiring_1_of_nat @ int @ ( gcd_Lcm @ nat @ N4 ) ) ) ).

% Lcm_int_eq
thf(fact_7848_Lcm__int__greater__eq__0,axiom,
    ! [K6: set @ int] : ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( gcd_Lcm @ int @ K6 ) ) ).

% Lcm_int_greater_eq_0
thf(fact_7849_semilattice__neutr__set_OF_Ocong,axiom,
    ! [A: $tType] :
      ( ( lattic5214292709420241887eutr_F @ A )
      = ( lattic5214292709420241887eutr_F @ A ) ) ).

% semilattice_neutr_set.F.cong
thf(fact_7850_semilattice__neutr__set_Oinsert__remove,axiom,
    ! [A: $tType,F2: A > A > A,Z: A,A4: set @ A,X: A] :
      ( ( lattic5652469242046573047tr_set @ A @ F2 @ Z )
     => ( ( finite_finite @ A @ A4 )
       => ( ( lattic5214292709420241887eutr_F @ A @ F2 @ Z @ ( insert @ A @ X @ A4 ) )
          = ( F2 @ X @ ( lattic5214292709420241887eutr_F @ A @ F2 @ Z @ ( minus_minus @ ( set @ A ) @ A4 @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ) ).

% semilattice_neutr_set.insert_remove
thf(fact_7851_semilattice__neutr__set_Oremove,axiom,
    ! [A: $tType,F2: A > A > A,Z: A,A4: set @ A,X: A] :
      ( ( lattic5652469242046573047tr_set @ A @ F2 @ Z )
     => ( ( finite_finite @ A @ A4 )
       => ( ( member @ A @ X @ A4 )
         => ( ( lattic5214292709420241887eutr_F @ A @ F2 @ Z @ A4 )
            = ( F2 @ X @ ( lattic5214292709420241887eutr_F @ A @ F2 @ Z @ ( minus_minus @ ( set @ A ) @ A4 @ ( insert @ A @ X @ ( bot_bot @ ( set @ A ) ) ) ) ) ) ) ) ) ) ).

% semilattice_neutr_set.remove
thf(fact_7852_semilattice__neutr__set__def,axiom,
    ! [A: $tType] :
      ( ( lattic5652469242046573047tr_set @ A )
      = ( semilattice_neutr @ A ) ) ).

% semilattice_neutr_set_def
thf(fact_7853_semilattice__neutr__set_Oaxioms,axiom,
    ! [A: $tType,F2: A > A > A,Z: A] :
      ( ( lattic5652469242046573047tr_set @ A @ F2 @ Z )
     => ( semilattice_neutr @ A @ F2 @ Z ) ) ).

% semilattice_neutr_set.axioms
thf(fact_7854_semilattice__neutr__set_Ointro,axiom,
    ! [A: $tType,F2: A > A > A,Z: A] :
      ( ( semilattice_neutr @ A @ F2 @ Z )
     => ( lattic5652469242046573047tr_set @ A @ F2 @ Z ) ) ).

% semilattice_neutr_set.intro
thf(fact_7855_semilattice__neutr__set_Oempty,axiom,
    ! [A: $tType,F2: A > A > A,Z: A] :
      ( ( lattic5652469242046573047tr_set @ A @ F2 @ Z )
     => ( ( lattic5214292709420241887eutr_F @ A @ F2 @ Z @ ( bot_bot @ ( set @ A ) ) )
        = Z ) ) ).

% semilattice_neutr_set.empty
thf(fact_7856_semilattice__neutr__set_Oinfinite,axiom,
    ! [A: $tType,F2: A > A > A,Z: A,A4: set @ A] :
      ( ( lattic5652469242046573047tr_set @ A @ F2 @ Z )
     => ( ~ ( finite_finite @ A @ A4 )
       => ( ( lattic5214292709420241887eutr_F @ A @ F2 @ Z @ A4 )
          = Z ) ) ) ).

% semilattice_neutr_set.infinite
thf(fact_7857_semilattice__neutr__set_Oin__idem,axiom,
    ! [A: $tType,F2: A > A > A,Z: A,A4: set @ A,X: A] :
      ( ( lattic5652469242046573047tr_set @ A @ F2 @ Z )
     => ( ( finite_finite @ A @ A4 )
       => ( ( member @ A @ X @ A4 )
         => ( ( F2 @ X @ ( lattic5214292709420241887eutr_F @ A @ F2 @ Z @ A4 ) )
            = ( lattic5214292709420241887eutr_F @ A @ F2 @ Z @ A4 ) ) ) ) ) ).

% semilattice_neutr_set.in_idem
thf(fact_7858_semilattice__neutr__set_Oeq__fold,axiom,
    ! [A: $tType,F2: A > A > A,Z: A,A4: set @ A] :
      ( ( lattic5652469242046573047tr_set @ A @ F2 @ Z )
     => ( ( lattic5214292709420241887eutr_F @ A @ F2 @ Z @ A4 )
        = ( finite_fold @ A @ A @ F2 @ Z @ A4 ) ) ) ).

% semilattice_neutr_set.eq_fold
thf(fact_7859_semilattice__neutr__set_Osubset,axiom,
    ! [A: $tType,F2: A > A > A,Z: A,A4: set @ A,B7: set @ A] :
      ( ( lattic5652469242046573047tr_set @ A @ F2 @ Z )
     => ( ( finite_finite @ A @ A4 )
       => ( ( ord_less_eq @ ( set @ A ) @ B7 @ A4 )
         => ( ( F2 @ ( lattic5214292709420241887eutr_F @ A @ F2 @ Z @ B7 ) @ ( lattic5214292709420241887eutr_F @ A @ F2 @ Z @ A4 ) )
            = ( lattic5214292709420241887eutr_F @ A @ F2 @ Z @ A4 ) ) ) ) ) ).

% semilattice_neutr_set.subset
thf(fact_7860_semilattice__neutr__set_Oinsert,axiom,
    ! [A: $tType,F2: A > A > A,Z: A,A4: set @ A,X: A] :
      ( ( lattic5652469242046573047tr_set @ A @ F2 @ Z )
     => ( ( finite_finite @ A @ A4 )
       => ( ( lattic5214292709420241887eutr_F @ A @ F2 @ Z @ ( insert @ A @ X @ A4 ) )
          = ( F2 @ X @ ( lattic5214292709420241887eutr_F @ A @ F2 @ Z @ A4 ) ) ) ) ) ).

% semilattice_neutr_set.insert
thf(fact_7861_semilattice__neutr__set_Ounion,axiom,
    ! [A: $tType,F2: A > A > A,Z: A,A4: set @ A,B7: set @ A] :
      ( ( lattic5652469242046573047tr_set @ A @ F2 @ Z )
     => ( ( finite_finite @ A @ A4 )
       => ( ( finite_finite @ A @ B7 )
         => ( ( lattic5214292709420241887eutr_F @ A @ F2 @ Z @ ( sup_sup @ ( set @ A ) @ A4 @ B7 ) )
            = ( F2 @ ( lattic5214292709420241887eutr_F @ A @ F2 @ Z @ A4 ) @ ( lattic5214292709420241887eutr_F @ A @ F2 @ Z @ B7 ) ) ) ) ) ) ).

% semilattice_neutr_set.union
thf(fact_7862_semilattice__neutr__set_Oclosed,axiom,
    ! [A: $tType,F2: A > A > A,Z: A,A4: set @ A] :
      ( ( lattic5652469242046573047tr_set @ A @ F2 @ Z )
     => ( ( finite_finite @ A @ A4 )
       => ( ( A4
           != ( bot_bot @ ( set @ A ) ) )
         => ( ! [X3: A,Y5: A] : ( member @ A @ ( F2 @ X3 @ Y5 ) @ ( insert @ A @ X3 @ ( insert @ A @ Y5 @ ( bot_bot @ ( set @ A ) ) ) ) )
           => ( member @ A @ ( lattic5214292709420241887eutr_F @ A @ F2 @ Z @ A4 ) @ A4 ) ) ) ) ) ).

% semilattice_neutr_set.closed
thf(fact_7863_Lcm__fin_Obounded__quasi__semilattice__set__axioms,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ( bounde6485984586167503788ce_set @ A @ ( gcd_lcm @ A ) @ ( one_one @ A ) @ ( zero_zero @ A ) @ ( normal6383669964737779283malize @ A ) ) ) ).

% Lcm_fin.bounded_quasi_semilattice_set_axioms
thf(fact_7864_Gcd__fin_Obounded__quasi__semilattice__set__axioms,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ( bounde6485984586167503788ce_set @ A @ ( gcd_gcd @ A ) @ ( zero_zero @ A ) @ ( one_one @ A ) @ ( normal6383669964737779283malize @ A ) ) ) ).

% Gcd_fin.bounded_quasi_semilattice_set_axioms
thf(fact_7865_semilattice__order__neutr__set_Osubset__imp,axiom,
    ! [A: $tType,F2: A > A > A,Z: A,Less_eq: A > A > $o,Less: A > A > $o,A4: set @ A,B7: set @ A] :
      ( ( lattic3600114342068043075tr_set @ A @ F2 @ Z @ Less_eq @ Less )
     => ( ( ord_less_eq @ ( set @ A ) @ A4 @ B7 )
       => ( ( finite_finite @ A @ B7 )
         => ( Less_eq @ ( lattic5214292709420241887eutr_F @ A @ F2 @ Z @ B7 ) @ ( lattic5214292709420241887eutr_F @ A @ F2 @ Z @ A4 ) ) ) ) ) ).

% semilattice_order_neutr_set.subset_imp
thf(fact_7866_lcm_Obounded__quasi__semilattice__axioms,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ( bounde8507323023520639062attice @ A @ ( gcd_lcm @ A ) @ ( one_one @ A ) @ ( zero_zero @ A ) @ ( normal6383669964737779283malize @ A ) ) ) ).

% lcm.bounded_quasi_semilattice_axioms
thf(fact_7867_semilattice__order__neutr__set_Oaxioms_I1_J,axiom,
    ! [A: $tType,F2: A > A > A,Z: A,Less_eq: A > A > $o,Less: A > A > $o] :
      ( ( lattic3600114342068043075tr_set @ A @ F2 @ Z @ Less_eq @ Less )
     => ( semila1105856199041335345_order @ A @ F2 @ Z @ Less_eq @ Less ) ) ).

% semilattice_order_neutr_set.axioms(1)
thf(fact_7868_semilattice__order__neutr__set_Oaxioms_I2_J,axiom,
    ! [A: $tType,F2: A > A > A,Z: A,Less_eq: A > A > $o,Less: A > A > $o] :
      ( ( lattic3600114342068043075tr_set @ A @ F2 @ Z @ Less_eq @ Less )
     => ( lattic5652469242046573047tr_set @ A @ F2 @ Z ) ) ).

% semilattice_order_neutr_set.axioms(2)
thf(fact_7869_semilattice__order__neutr__set_Obounded__iff,axiom,
    ! [A: $tType,F2: A > A > A,Z: A,Less_eq: A > A > $o,Less: A > A > $o,A4: set @ A,X: A] :
      ( ( lattic3600114342068043075tr_set @ A @ F2 @ Z @ Less_eq @ Less )
     => ( ( finite_finite @ A @ A4 )
       => ( ( Less_eq @ X @ ( lattic5214292709420241887eutr_F @ A @ F2 @ Z @ A4 ) )
          = ( ! [X2: A] :
                ( ( member @ A @ X2 @ A4 )
               => ( Less_eq @ X @ X2 ) ) ) ) ) ) ).

% semilattice_order_neutr_set.bounded_iff
thf(fact_7870_semilattice__order__neutr__set_OcoboundedI,axiom,
    ! [A: $tType,F2: A > A > A,Z: A,Less_eq: A > A > $o,Less: A > A > $o,A4: set @ A,A2: A] :
      ( ( lattic3600114342068043075tr_set @ A @ F2 @ Z @ Less_eq @ Less )
     => ( ( finite_finite @ A @ A4 )
       => ( ( member @ A @ A2 @ A4 )
         => ( Less_eq @ ( lattic5214292709420241887eutr_F @ A @ F2 @ Z @ A4 ) @ A2 ) ) ) ) ).

% semilattice_order_neutr_set.coboundedI
thf(fact_7871_semilattice__order__neutr__set_OboundedI,axiom,
    ! [A: $tType,F2: A > A > A,Z: A,Less_eq: A > A > $o,Less: A > A > $o,A4: set @ A,X: A] :
      ( ( lattic3600114342068043075tr_set @ A @ F2 @ Z @ Less_eq @ Less )
     => ( ( finite_finite @ A @ A4 )
       => ( ! [A5: A] :
              ( ( member @ A @ A5 @ A4 )
             => ( Less_eq @ X @ A5 ) )
         => ( Less_eq @ X @ ( lattic5214292709420241887eutr_F @ A @ F2 @ Z @ A4 ) ) ) ) ) ).

% semilattice_order_neutr_set.boundedI
thf(fact_7872_semilattice__order__neutr__set_OboundedE,axiom,
    ! [A: $tType,F2: A > A > A,Z: A,Less_eq: A > A > $o,Less: A > A > $o,A4: set @ A,X: A] :
      ( ( lattic3600114342068043075tr_set @ A @ F2 @ Z @ Less_eq @ Less )
     => ( ( finite_finite @ A @ A4 )
       => ( ( Less_eq @ X @ ( lattic5214292709420241887eutr_F @ A @ F2 @ Z @ A4 ) )
         => ! [A9: A] :
              ( ( member @ A @ A9 @ A4 )
             => ( Less_eq @ X @ A9 ) ) ) ) ) ).

% semilattice_order_neutr_set.boundedE
thf(fact_7873_semilattice__order__neutr__set__def,axiom,
    ! [A: $tType] :
      ( ( lattic3600114342068043075tr_set @ A )
      = ( ^ [F3: A > A > A,Z6: A,Less_eq2: A > A > $o,Less2: A > A > $o] :
            ( ( semila1105856199041335345_order @ A @ F3 @ Z6 @ Less_eq2 @ Less2 )
            & ( lattic5652469242046573047tr_set @ A @ F3 @ Z6 ) ) ) ) ).

% semilattice_order_neutr_set_def
thf(fact_7874_semilattice__order__neutr__set_Ointro,axiom,
    ! [A: $tType,F2: A > A > A,Z: A,Less_eq: A > A > $o,Less: A > A > $o] :
      ( ( semila1105856199041335345_order @ A @ F2 @ Z @ Less_eq @ Less )
     => ( ( lattic5652469242046573047tr_set @ A @ F2 @ Z )
       => ( lattic3600114342068043075tr_set @ A @ F2 @ Z @ Less_eq @ Less ) ) ) ).

% semilattice_order_neutr_set.intro
thf(fact_7875_gcd_Obounded__quasi__semilattice__axioms,axiom,
    ! [A: $tType] :
      ( ( semiring_gcd @ A )
     => ( bounde8507323023520639062attice @ A @ ( gcd_gcd @ A ) @ ( zero_zero @ A ) @ ( one_one @ A ) @ ( normal6383669964737779283malize @ A ) ) ) ).

% gcd.bounded_quasi_semilattice_axioms
thf(fact_7876_natLeq__on__wo__rel,axiom,
    ! [N: nat] :
      ( bNF_Wellorder_wo_rel @ nat
      @ ( collect @ ( product_prod @ nat @ nat )
        @ ( product_case_prod @ nat @ nat @ $o
          @ ^ [X2: nat,Y4: nat] :
              ( ( ord_less @ nat @ X2 @ N )
              & ( ord_less @ nat @ Y4 @ N )
              & ( ord_less_eq @ nat @ X2 @ Y4 ) ) ) ) ) ).

% natLeq_on_wo_rel
thf(fact_7877_sum_H__def,axiom,
    ! [C: $tType,A: $tType] :
      ( ( comm_monoid_add @ A )
     => ( ( groups1027152243600224163dd_sum @ C @ A )
        = ( groups_comm_monoid_G @ A @ C @ ( plus_plus @ A ) @ ( zero_zero @ A ) ) ) ) ).

% sum'_def
thf(fact_7878_max_Osemilattice__order__axioms,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( semilattice_order @ A @ ( ord_max @ A )
        @ ^ [X2: A,Y4: A] : ( ord_less_eq @ A @ Y4 @ X2 )
        @ ^ [X2: A,Y4: A] : ( ord_less @ A @ Y4 @ X2 ) ) ) ).

% max.semilattice_order_axioms
thf(fact_7879_lexordp__eq_Ocases,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [A12: list @ A,A23: list @ A] :
          ( ( ord_lexordp_eq @ A @ A12 @ A23 )
         => ( ( A12
             != ( nil @ A ) )
           => ( ! [X3: A] :
                  ( ? [Xs2: list @ A] :
                      ( A12
                      = ( cons @ A @ X3 @ Xs2 ) )
                 => ! [Y5: A] :
                      ( ? [Ys4: list @ A] :
                          ( A23
                          = ( cons @ A @ Y5 @ Ys4 ) )
                     => ~ ( ord_less @ A @ X3 @ Y5 ) ) )
             => ~ ! [X3: A,Y5: A,Xs2: list @ A] :
                    ( ( A12
                      = ( cons @ A @ X3 @ Xs2 ) )
                   => ! [Ys4: list @ A] :
                        ( ( A23
                          = ( cons @ A @ Y5 @ Ys4 ) )
                       => ( ~ ( ord_less @ A @ X3 @ Y5 )
                         => ( ~ ( ord_less @ A @ Y5 @ X3 )
                           => ~ ( ord_lexordp_eq @ A @ Xs2 @ Ys4 ) ) ) ) ) ) ) ) ) ).

% lexordp_eq.cases
thf(fact_7880_lexordp__eq__simps_I4_J,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [X: A,Xs: list @ A,Y: A,Ys3: list @ A] :
          ( ( ord_lexordp_eq @ A @ ( cons @ A @ X @ Xs ) @ ( cons @ A @ Y @ Ys3 ) )
          = ( ( ord_less @ A @ X @ Y )
            | ( ~ ( ord_less @ A @ Y @ X )
              & ( ord_lexordp_eq @ A @ Xs @ Ys3 ) ) ) ) ) ).

% lexordp_eq_simps(4)
thf(fact_7881_semilattice__neutr__order__def,axiom,
    ! [A: $tType] :
      ( ( semila1105856199041335345_order @ A )
      = ( ^ [F3: A > A > A,Z6: A,Less_eq2: A > A > $o,Less2: A > A > $o] :
            ( ( semilattice_neutr @ A @ F3 @ Z6 )
            & ( semilattice_order @ A @ F3 @ Less_eq2 @ Less2 ) ) ) ) ).

% semilattice_neutr_order_def
thf(fact_7882_semilattice__neutr__order_Ointro,axiom,
    ! [A: $tType,F2: A > A > A,Z: A,Less_eq: A > A > $o,Less: A > A > $o] :
      ( ( semilattice_neutr @ A @ F2 @ Z )
     => ( ( semilattice_order @ A @ F2 @ Less_eq @ Less )
       => ( semila1105856199041335345_order @ A @ F2 @ Z @ Less_eq @ Less ) ) ) ).

% semilattice_neutr_order.intro
thf(fact_7883_semilattice__order__set__def,axiom,
    ! [A: $tType] :
      ( ( lattic4895041142388067077er_set @ A )
      = ( ^ [F3: A > A > A,Less_eq2: A > A > $o,Less2: A > A > $o] :
            ( ( semilattice_order @ A @ F3 @ Less_eq2 @ Less2 )
            & ( lattic149705377957585745ce_set @ A @ F3 ) ) ) ) ).

% semilattice_order_set_def
thf(fact_7884_semilattice__order__set_Ointro,axiom,
    ! [A: $tType,F2: A > A > A,Less_eq: A > A > $o,Less: A > A > $o] :
      ( ( semilattice_order @ A @ F2 @ Less_eq @ Less )
     => ( ( lattic149705377957585745ce_set @ A @ F2 )
       => ( lattic4895041142388067077er_set @ A @ F2 @ Less_eq @ Less ) ) ) ).

% semilattice_order_set.intro
thf(fact_7885_semilattice__order__set_Oaxioms_I1_J,axiom,
    ! [A: $tType,F2: A > A > A,Less_eq: A > A > $o,Less: A > A > $o] :
      ( ( lattic4895041142388067077er_set @ A @ F2 @ Less_eq @ Less )
     => ( semilattice_order @ A @ F2 @ Less_eq @ Less ) ) ).

% semilattice_order_set.axioms(1)
thf(fact_7886_lexordp__eq_OCons,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [X: A,Y: A,Xs: list @ A,Ys3: list @ A] :
          ( ( ord_less @ A @ X @ Y )
         => ( ord_lexordp_eq @ A @ ( cons @ A @ X @ Xs ) @ ( cons @ A @ Y @ Ys3 ) ) ) ) ).

% lexordp_eq.Cons
thf(fact_7887_lexordp__eq_OCons__eq,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ! [X: A,Y: A,Xs: list @ A,Ys3: list @ A] :
          ( ~ ( ord_less @ A @ X @ Y )
         => ( ~ ( ord_less @ A @ Y @ X )
           => ( ( ord_lexordp_eq @ A @ Xs @ Ys3 )
             => ( ord_lexordp_eq @ A @ ( cons @ A @ X @ Xs ) @ ( cons @ A @ Y @ Ys3 ) ) ) ) ) ) ).

% lexordp_eq.Cons_eq
thf(fact_7888_semilattice__order_Ostrict__coboundedI2,axiom,
    ! [A: $tType,F2: A > A > A,Less_eq: A > A > $o,Less: A > A > $o,B2: A,C2: A,A2: A] :
      ( ( semilattice_order @ A @ F2 @ Less_eq @ Less )
     => ( ( Less @ B2 @ C2 )
       => ( Less @ ( F2 @ A2 @ B2 ) @ C2 ) ) ) ).

% semilattice_order.strict_coboundedI2
thf(fact_7889_semilattice__order_Ostrict__coboundedI1,axiom,
    ! [A: $tType,F2: A > A > A,Less_eq: A > A > $o,Less: A > A > $o,A2: A,C2: A,B2: A] :
      ( ( semilattice_order @ A @ F2 @ Less_eq @ Less )
     => ( ( Less @ A2 @ C2 )
       => ( Less @ ( F2 @ A2 @ B2 ) @ C2 ) ) ) ).

% semilattice_order.strict_coboundedI1
thf(fact_7890_semilattice__order_Ostrict__order__iff,axiom,
    ! [A: $tType,F2: A > A > A,Less_eq: A > A > $o,Less: A > A > $o,A2: A,B2: A] :
      ( ( semilattice_order @ A @ F2 @ Less_eq @ Less )
     => ( ( Less @ A2 @ B2 )
        = ( ( A2
            = ( F2 @ A2 @ B2 ) )
          & ( A2 != B2 ) ) ) ) ).

% semilattice_order.strict_order_iff
thf(fact_7891_semilattice__order_Ostrict__boundedE,axiom,
    ! [A: $tType,F2: A > A > A,Less_eq: A > A > $o,Less: A > A > $o,A2: A,B2: A,C2: A] :
      ( ( semilattice_order @ A @ F2 @ Less_eq @ Less )
     => ( ( Less @ A2 @ ( F2 @ B2 @ C2 ) )
       => ~ ( ( Less @ A2 @ B2 )
           => ~ ( Less @ A2 @ C2 ) ) ) ) ).

% semilattice_order.strict_boundedE
thf(fact_7892_semilattice__order_OcoboundedI2,axiom,
    ! [A: $tType,F2: A > A > A,Less_eq: A > A > $o,Less: A > A > $o,B2: A,C2: A,A2: A] :
      ( ( semilattice_order @ A @ F2 @ Less_eq @ Less )
     => ( ( Less_eq @ B2 @ C2 )
       => ( Less_eq @ ( F2 @ A2 @ B2 ) @ C2 ) ) ) ).

% semilattice_order.coboundedI2
thf(fact_7893_semilattice__order_OcoboundedI1,axiom,
    ! [A: $tType,F2: A > A > A,Less_eq: A > A > $o,Less: A > A > $o,A2: A,C2: A,B2: A] :
      ( ( semilattice_order @ A @ F2 @ Less_eq @ Less )
     => ( ( Less_eq @ A2 @ C2 )
       => ( Less_eq @ ( F2 @ A2 @ B2 ) @ C2 ) ) ) ).

% semilattice_order.coboundedI1
thf(fact_7894_semilattice__order_Obounded__iff,axiom,
    ! [A: $tType,F2: A > A > A,Less_eq: A > A > $o,Less: A > A > $o,A2: A,B2: A,C2: A] :
      ( ( semilattice_order @ A @ F2 @ Less_eq @ Less )
     => ( ( Less_eq @ A2 @ ( F2 @ B2 @ C2 ) )
        = ( ( Less_eq @ A2 @ B2 )
          & ( Less_eq @ A2 @ C2 ) ) ) ) ).

% semilattice_order.bounded_iff
thf(fact_7895_semilattice__order_Oabsorb__iff2,axiom,
    ! [A: $tType,F2: A > A > A,Less_eq: A > A > $o,Less: A > A > $o,B2: A,A2: A] :
      ( ( semilattice_order @ A @ F2 @ Less_eq @ Less )
     => ( ( Less_eq @ B2 @ A2 )
        = ( ( F2 @ A2 @ B2 )
          = B2 ) ) ) ).

% semilattice_order.absorb_iff2
thf(fact_7896_semilattice__order_Oabsorb__iff1,axiom,
    ! [A: $tType,F2: A > A > A,Less_eq: A > A > $o,Less: A > A > $o,A2: A,B2: A] :
      ( ( semilattice_order @ A @ F2 @ Less_eq @ Less )
     => ( ( Less_eq @ A2 @ B2 )
        = ( ( F2 @ A2 @ B2 )
          = A2 ) ) ) ).

% semilattice_order.absorb_iff1
thf(fact_7897_semilattice__order_Ocobounded2,axiom,
    ! [A: $tType,F2: A > A > A,Less_eq: A > A > $o,Less: A > A > $o,A2: A,B2: A] :
      ( ( semilattice_order @ A @ F2 @ Less_eq @ Less )
     => ( Less_eq @ ( F2 @ A2 @ B2 ) @ B2 ) ) ).

% semilattice_order.cobounded2
thf(fact_7898_semilattice__order_Ocobounded1,axiom,
    ! [A: $tType,F2: A > A > A,Less_eq: A > A > $o,Less: A > A > $o,A2: A,B2: A] :
      ( ( semilattice_order @ A @ F2 @ Less_eq @ Less )
     => ( Less_eq @ ( F2 @ A2 @ B2 ) @ A2 ) ) ).

% semilattice_order.cobounded1
thf(fact_7899_semilattice__order_Oorder__iff,axiom,
    ! [A: $tType,F2: A > A > A,Less_eq: A > A > $o,Less: A > A > $o,A2: A,B2: A] :
      ( ( semilattice_order @ A @ F2 @ Less_eq @ Less )
     => ( ( Less_eq @ A2 @ B2 )
        = ( A2
          = ( F2 @ A2 @ B2 ) ) ) ) ).

% semilattice_order.order_iff
thf(fact_7900_semilattice__order_OboundedI,axiom,
    ! [A: $tType,F2: A > A > A,Less_eq: A > A > $o,Less: A > A > $o,A2: A,B2: A,C2: A] :
      ( ( semilattice_order @ A @ F2 @ Less_eq @ Less )
     => ( ( Less_eq @ A2 @ B2 )
       => ( ( Less_eq @ A2 @ C2 )
         => ( Less_eq @ A2 @ ( F2 @ B2 @ C2 ) ) ) ) ) ).

% semilattice_order.boundedI
thf(fact_7901_semilattice__order_OboundedE,axiom,
    ! [A: $tType,F2: A > A > A,Less_eq: A > A > $o,Less: A > A > $o,A2: A,B2: A,C2: A] :
      ( ( semilattice_order @ A @ F2 @ Less_eq @ Less )
     => ( ( Less_eq @ A2 @ ( F2 @ B2 @ C2 ) )
       => ~ ( ( Less_eq @ A2 @ B2 )
           => ~ ( Less_eq @ A2 @ C2 ) ) ) ) ).

% semilattice_order.boundedE
thf(fact_7902_semilattice__order_Oabsorb4,axiom,
    ! [A: $tType,F2: A > A > A,Less_eq: A > A > $o,Less: A > A > $o,B2: A,A2: A] :
      ( ( semilattice_order @ A @ F2 @ Less_eq @ Less )
     => ( ( Less @ B2 @ A2 )
       => ( ( F2 @ A2 @ B2 )
          = B2 ) ) ) ).

% semilattice_order.absorb4
thf(fact_7903_semilattice__order_Oabsorb3,axiom,
    ! [A: $tType,F2: A > A > A,Less_eq: A > A > $o,Less: A > A > $o,A2: A,B2: A] :
      ( ( semilattice_order @ A @ F2 @ Less_eq @ Less )
     => ( ( Less @ A2 @ B2 )
       => ( ( F2 @ A2 @ B2 )
          = A2 ) ) ) ).

% semilattice_order.absorb3
thf(fact_7904_semilattice__order_Oabsorb2,axiom,
    ! [A: $tType,F2: A > A > A,Less_eq: A > A > $o,Less: A > A > $o,B2: A,A2: A] :
      ( ( semilattice_order @ A @ F2 @ Less_eq @ Less )
     => ( ( Less_eq @ B2 @ A2 )
       => ( ( F2 @ A2 @ B2 )
          = B2 ) ) ) ).

% semilattice_order.absorb2
thf(fact_7905_semilattice__order_Oabsorb1,axiom,
    ! [A: $tType,F2: A > A > A,Less_eq: A > A > $o,Less: A > A > $o,A2: A,B2: A] :
      ( ( semilattice_order @ A @ F2 @ Less_eq @ Less )
     => ( ( Less_eq @ A2 @ B2 )
       => ( ( F2 @ A2 @ B2 )
          = A2 ) ) ) ).

% semilattice_order.absorb1
thf(fact_7906_semilattice__order_OorderI,axiom,
    ! [A: $tType,F2: A > A > A,Less_eq: A > A > $o,Less: A > A > $o,A2: A,B2: A] :
      ( ( semilattice_order @ A @ F2 @ Less_eq @ Less )
     => ( ( A2
          = ( F2 @ A2 @ B2 ) )
       => ( Less_eq @ A2 @ B2 ) ) ) ).

% semilattice_order.orderI
thf(fact_7907_semilattice__order_OorderE,axiom,
    ! [A: $tType,F2: A > A > A,Less_eq: A > A > $o,Less: A > A > $o,A2: A,B2: A] :
      ( ( semilattice_order @ A @ F2 @ Less_eq @ Less )
     => ( ( Less_eq @ A2 @ B2 )
       => ( A2
          = ( F2 @ A2 @ B2 ) ) ) ) ).

% semilattice_order.orderE
thf(fact_7908_semilattice__order_Omono,axiom,
    ! [A: $tType,F2: A > A > A,Less_eq: A > A > $o,Less: A > A > $o,A2: A,C2: A,B2: A,D2: A] :
      ( ( semilattice_order @ A @ F2 @ Less_eq @ Less )
     => ( ( Less_eq @ A2 @ C2 )
       => ( ( Less_eq @ B2 @ D2 )
         => ( Less_eq @ ( F2 @ A2 @ B2 ) @ ( F2 @ C2 @ D2 ) ) ) ) ) ).

% semilattice_order.mono
thf(fact_7909_semilattice__neutr__order_Oaxioms_I2_J,axiom,
    ! [A: $tType,F2: A > A > A,Z: A,Less_eq: A > A > $o,Less: A > A > $o] :
      ( ( semila1105856199041335345_order @ A @ F2 @ Z @ Less_eq @ Less )
     => ( semilattice_order @ A @ F2 @ Less_eq @ Less ) ) ).

% semilattice_neutr_order.axioms(2)
thf(fact_7910_inf_Osemilattice__order__axioms,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ( semilattice_order @ A @ ( inf_inf @ A ) @ ( ord_less_eq @ A ) @ ( ord_less @ A ) ) ) ).

% inf.semilattice_order_axioms
thf(fact_7911_min_Osemilattice__order__axioms,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( semilattice_order @ A @ ( ord_min @ A ) @ ( ord_less_eq @ A ) @ ( ord_less @ A ) ) ) ).

% min.semilattice_order_axioms
thf(fact_7912_sup_Osemilattice__order__axioms,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ( semilattice_order @ A @ ( sup_sup @ A )
        @ ^ [X2: A,Y4: A] : ( ord_less_eq @ A @ Y4 @ X2 )
        @ ^ [X2: A,Y4: A] : ( ord_less @ A @ Y4 @ X2 ) ) ) ).

% sup.semilattice_order_axioms
thf(fact_7913_lexordp__eq_Osimps,axiom,
    ! [A: $tType] :
      ( ( ord @ A )
     => ( ( ord_lexordp_eq @ A )
        = ( ^ [A1: list @ A,A22: list @ A] :
              ( ? [Ys2: list @ A] :
                  ( ( A1
                    = ( nil @ A ) )
                  & ( A22 = Ys2 ) )
              | ? [X2: A,Y4: A,Xs3: list @ A,Ys2: list @ A] :
                  ( ( A1
                    = ( cons @ A @ X2 @ Xs3 ) )
                  & ( A22
                    = ( cons @ A @ Y4 @ Ys2 ) )
                  & ( ord_less @ A @ X2 @ Y4 ) )
              | ? [X2: A,Y4: A,Xs3: list @ A,Ys2: list @ A] :
                  ( ( A1
                    = ( cons @ A @ X2 @ Xs3 ) )
                  & ( A22
                    = ( cons @ A @ Y4 @ Ys2 ) )
                  & ~ ( ord_less @ A @ X2 @ Y4 )
                  & ~ ( ord_less @ A @ Y4 @ X2 )
                  & ( ord_lexordp_eq @ A @ Xs3 @ Ys2 ) ) ) ) ) ) ).

% lexordp_eq.simps
thf(fact_7914_integer__of__natural__of__integer,axiom,
    ! [K: code_integer] :
      ( ( code_i5400310926305786745atural @ ( code_n4118661773612635043nteger @ K ) )
      = ( ord_max @ code_integer @ ( zero_zero @ code_integer ) @ K ) ) ).

% integer_of_natural_of_integer
thf(fact_7915_bdd__below__primitive__def,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ( ( condit1013018076250108175_below @ A )
        = ( condit16957441358409770ng_bdd @ A
          @ ^ [X2: A,Y4: A] : ( ord_less_eq @ A @ Y4 @ X2 ) ) ) ) ).

% bdd_below_primitive_def
thf(fact_7916_preordering__bdd_Obdd_Ocong,axiom,
    ! [A: $tType] :
      ( ( condit16957441358409770ng_bdd @ A )
      = ( condit16957441358409770ng_bdd @ A ) ) ).

% preordering_bdd.bdd.cong
thf(fact_7917_bdd__above__primitive__def,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ( ( condit941137186595557371_above @ A )
        = ( condit16957441358409770ng_bdd @ A @ ( ord_less_eq @ A ) ) ) ) ).

% bdd_above_primitive_def
thf(fact_7918_integer__of__natural_Orep__eq,axiom,
    ! [X: code_natural] :
      ( ( code_int_of_integer @ ( code_i5400310926305786745atural @ X ) )
      = ( semiring_1_of_nat @ int @ ( code_nat_of_natural @ X ) ) ) ).

% integer_of_natural.rep_eq
thf(fact_7919_int__of__integer__of__natural,axiom,
    ! [N: code_natural] :
      ( ( code_int_of_integer @ ( code_i5400310926305786745atural @ N ) )
      = ( semiring_1_of_nat @ int @ ( code_nat_of_natural @ N ) ) ) ).

% int_of_integer_of_natural
thf(fact_7920_zero__natural_Orep__eq,axiom,
    ( ( code_nat_of_natural @ ( zero_zero @ code_natural ) )
    = ( zero_zero @ nat ) ) ).

% zero_natural.rep_eq
thf(fact_7921_nat__of__natural__numeral,axiom,
    ! [K: num] :
      ( ( code_nat_of_natural @ ( numeral_numeral @ code_natural @ K ) )
      = ( numeral_numeral @ nat @ K ) ) ).

% nat_of_natural_numeral
thf(fact_7922_nat__of__natural__max,axiom,
    ! [K: code_natural,L: code_natural] :
      ( ( code_nat_of_natural @ ( ord_max @ code_natural @ K @ L ) )
      = ( ord_max @ nat @ ( code_nat_of_natural @ K ) @ ( code_nat_of_natural @ L ) ) ) ).

% nat_of_natural_max
thf(fact_7923_less__eq__natural_Orep__eq,axiom,
    ( ( ord_less_eq @ code_natural )
    = ( ^ [X2: code_natural,Xa4: code_natural] : ( ord_less_eq @ nat @ ( code_nat_of_natural @ X2 ) @ ( code_nat_of_natural @ Xa4 ) ) ) ) ).

% less_eq_natural.rep_eq
thf(fact_7924_less__natural_Orep__eq,axiom,
    ( ( ord_less @ code_natural )
    = ( ^ [X2: code_natural,Xa4: code_natural] : ( ord_less @ nat @ ( code_nat_of_natural @ X2 ) @ ( code_nat_of_natural @ Xa4 ) ) ) ) ).

% less_natural.rep_eq
thf(fact_7925_natural__decr,axiom,
    ! [N: code_natural] :
      ( ( N
       != ( zero_zero @ code_natural ) )
     => ( ord_less @ nat @ ( minus_minus @ nat @ ( code_nat_of_natural @ N ) @ ( suc @ ( zero_zero @ nat ) ) ) @ ( code_nat_of_natural @ N ) ) ) ).

% natural_decr
thf(fact_7926_integer__of__natural__def,axiom,
    ( code_i5400310926305786745atural
    = ( map_fun @ code_natural @ nat @ int @ code_integer @ code_nat_of_natural @ code_integer_of_int @ ( semiring_1_of_nat @ int ) ) ) ).

% integer_of_natural_def
thf(fact_7927_preordering__bdd_OInt2,axiom,
    ! [A: $tType,Less_eq: A > A > $o,Less: A > A > $o,B7: set @ A,A4: set @ A] :
      ( ( condit622319405099724424ng_bdd @ A @ Less_eq @ Less )
     => ( ( condit16957441358409770ng_bdd @ A @ Less_eq @ B7 )
       => ( condit16957441358409770ng_bdd @ A @ Less_eq @ ( inf_inf @ ( set @ A ) @ A4 @ B7 ) ) ) ) ).

% preordering_bdd.Int2
thf(fact_7928_natural__zero__minus__one,axiom,
    ( ( minus_minus @ code_natural @ ( zero_zero @ code_natural ) @ ( one_one @ code_natural ) )
    = ( zero_zero @ code_natural ) ) ).

% natural_zero_minus_one
thf(fact_7929_bdd__above_Opreordering__bdd__axioms,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ( condit622319405099724424ng_bdd @ A @ ( ord_less_eq @ A ) @ ( ord_less @ A ) ) ) ).

% bdd_above.preordering_bdd_axioms
thf(fact_7930_preordering__bdd_Ounfold,axiom,
    ! [A: $tType,Less_eq: A > A > $o,Less: A > A > $o,A4: set @ A] :
      ( ( condit622319405099724424ng_bdd @ A @ Less_eq @ Less )
     => ( ( condit16957441358409770ng_bdd @ A @ Less_eq @ A4 )
        = ( ? [M8: A] :
            ! [X2: A] :
              ( ( member @ A @ X2 @ A4 )
             => ( Less_eq @ X2 @ M8 ) ) ) ) ) ).

% preordering_bdd.unfold
thf(fact_7931_preordering__bdd_OI,axiom,
    ! [A: $tType,Less_eq: A > A > $o,Less: A > A > $o,A4: set @ A,M5: A] :
      ( ( condit622319405099724424ng_bdd @ A @ Less_eq @ Less )
     => ( ! [X3: A] :
            ( ( member @ A @ X3 @ A4 )
           => ( Less_eq @ X3 @ M5 ) )
       => ( condit16957441358409770ng_bdd @ A @ Less_eq @ A4 ) ) ) ).

% preordering_bdd.I
thf(fact_7932_preordering__bdd_OE,axiom,
    ! [A: $tType,Less_eq: A > A > $o,Less: A > A > $o,A4: set @ A] :
      ( ( condit622319405099724424ng_bdd @ A @ Less_eq @ Less )
     => ( ( condit16957441358409770ng_bdd @ A @ Less_eq @ A4 )
       => ~ ! [M10: A] :
              ~ ! [X5: A] :
                  ( ( member @ A @ X5 @ A4 )
                 => ( Less_eq @ X5 @ M10 ) ) ) ) ).

% preordering_bdd.E
thf(fact_7933_bdd__below_Opreordering__bdd__axioms,axiom,
    ! [A: $tType] :
      ( ( preorder @ A )
     => ( condit622319405099724424ng_bdd @ A
        @ ^ [X2: A,Y4: A] : ( ord_less_eq @ A @ Y4 @ X2 )
        @ ^ [X2: A,Y4: A] : ( ord_less @ A @ Y4 @ X2 ) ) ) ).

% bdd_below.preordering_bdd_axioms
thf(fact_7934_preordering__bdd_OI2,axiom,
    ! [A: $tType,B: $tType,Less_eq: A > A > $o,Less: A > A > $o,A4: set @ B,F2: B > A,M5: A] :
      ( ( condit622319405099724424ng_bdd @ A @ Less_eq @ Less )
     => ( ! [X3: B] :
            ( ( member @ B @ X3 @ A4 )
           => ( Less_eq @ ( F2 @ X3 ) @ M5 ) )
       => ( condit16957441358409770ng_bdd @ A @ Less_eq @ ( image @ B @ A @ F2 @ A4 ) ) ) ) ).

% preordering_bdd.I2
thf(fact_7935_preordering__bdd_Oempty,axiom,
    ! [A: $tType,Less_eq: A > A > $o,Less: A > A > $o] :
      ( ( condit622319405099724424ng_bdd @ A @ Less_eq @ Less )
     => ( condit16957441358409770ng_bdd @ A @ Less_eq @ ( bot_bot @ ( set @ A ) ) ) ) ).

% preordering_bdd.empty
thf(fact_7936_preordering__bdd_Omono,axiom,
    ! [A: $tType,Less_eq: A > A > $o,Less: A > A > $o,B7: set @ A,A4: set @ A] :
      ( ( condit622319405099724424ng_bdd @ A @ Less_eq @ Less )
     => ( ( condit16957441358409770ng_bdd @ A @ Less_eq @ B7 )
       => ( ( ord_less_eq @ ( set @ A ) @ A4 @ B7 )
         => ( condit16957441358409770ng_bdd @ A @ Less_eq @ A4 ) ) ) ) ).

% preordering_bdd.mono
thf(fact_7937_preordering__bdd_OInt1,axiom,
    ! [A: $tType,Less_eq: A > A > $o,Less: A > A > $o,A4: set @ A,B7: set @ A] :
      ( ( condit622319405099724424ng_bdd @ A @ Less_eq @ Less )
     => ( ( condit16957441358409770ng_bdd @ A @ Less_eq @ A4 )
       => ( condit16957441358409770ng_bdd @ A @ Less_eq @ ( inf_inf @ ( set @ A ) @ A4 @ B7 ) ) ) ) ).

% preordering_bdd.Int1
thf(fact_7938_natural_Osimps_I4_J,axiom,
    ! [T: $tType,F1: T,F22: code_natural > T] :
      ( ( code_case_natural @ T @ F1 @ F22 @ ( zero_zero @ code_natural ) )
      = F1 ) ).

% natural.simps(4)
thf(fact_7939_next_Osimps,axiom,
    ! [V: code_natural,W: code_natural] :
      ( ( next @ ( product_Pair @ code_natural @ code_natural @ V @ W ) )
      = ( product_Pair @ code_natural @ ( product_prod @ code_natural @ code_natural ) @ ( plus_plus @ code_natural @ ( minus_shift @ ( numeral_numeral @ code_natural @ ( bit0 @ ( bit1 @ ( bit0 @ ( bit1 @ ( bit0 @ ( bit1 @ ( bit0 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ one2 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) @ ( minus_shift @ ( numeral_numeral @ code_natural @ ( bit1 @ ( bit1 @ ( bit0 @ ( bit1 @ ( bit0 @ ( bit1 @ ( bit0 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ one2 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) @ ( times_times @ code_natural @ ( modulo_modulo @ code_natural @ V @ ( numeral_numeral @ code_natural @ ( bit0 @ ( bit0 @ ( bit1 @ ( bit0 @ ( bit0 @ ( bit1 @ ( bit0 @ ( bit1 @ ( bit1 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit1 @ ( bit0 @ ( bit1 @ one2 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) @ ( numeral_numeral @ code_natural @ ( bit0 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit0 @ ( bit0 @ ( bit1 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit0 @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) @ ( times_times @ code_natural @ ( divide_divide @ code_natural @ V @ ( numeral_numeral @ code_natural @ ( bit0 @ ( bit0 @ ( bit1 @ ( bit0 @ ( bit0 @ ( bit1 @ ( bit0 @ ( bit1 @ ( bit1 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit1 @ ( bit0 @ ( bit1 @ one2 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) @ ( numeral_numeral @ code_natural @ ( bit1 @ ( bit1 @ ( bit0 @ ( bit0 @ ( bit1 @ ( bit1 @ ( bit0 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) @ ( plus_plus @ code_natural @ ( minus_shift @ ( numeral_numeral @ code_natural @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ one2 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) @ ( times_times @ code_natural @ ( modulo_modulo @ code_natural @ W @ ( numeral_numeral @ code_natural @ ( bit0 @ ( bit1 @ ( bit1 @ ( bit0 @ ( bit0 @ ( bit1 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit0 @ ( bit0 @ ( bit1 @ one2 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) @ ( numeral_numeral @ code_natural @ ( bit0 @ ( bit0 @ ( bit1 @ ( bit0 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit0 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit0 @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) @ ( times_times @ code_natural @ ( divide_divide @ code_natural @ W @ ( numeral_numeral @ code_natural @ ( bit0 @ ( bit1 @ ( bit1 @ ( bit0 @ ( bit0 @ ( bit1 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit0 @ ( bit0 @ ( bit1 @ one2 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) @ ( numeral_numeral @ code_natural @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit0 @ ( bit0 @ ( bit1 @ ( bit1 @ ( bit0 @ ( bit1 @ ( bit1 @ one2 ) ) ) ) ) ) ) ) ) ) ) ) ) ) @ ( one_one @ code_natural ) ) ) @ ( one_one @ code_natural ) ) @ ( product_Pair @ code_natural @ code_natural @ ( minus_shift @ ( numeral_numeral @ code_natural @ ( bit1 @ ( bit1 @ ( bit0 @ ( bit1 @ ( bit0 @ ( bit1 @ ( bit0 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ one2 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) @ ( times_times @ code_natural @ ( modulo_modulo @ code_natural @ V @ ( numeral_numeral @ code_natural @ ( bit0 @ ( bit0 @ ( bit1 @ ( bit0 @ ( bit0 @ ( bit1 @ ( bit0 @ ( bit1 @ ( bit1 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit1 @ ( bit0 @ ( bit1 @ one2 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) @ ( numeral_numeral @ code_natural @ ( bit0 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit0 @ ( bit0 @ ( bit1 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit0 @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) @ ( times_times @ code_natural @ ( divide_divide @ code_natural @ V @ ( numeral_numeral @ code_natural @ ( bit0 @ ( bit0 @ ( bit1 @ ( bit0 @ ( bit0 @ ( bit1 @ ( bit0 @ ( bit1 @ ( bit1 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit1 @ ( bit0 @ ( bit1 @ one2 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) @ ( numeral_numeral @ code_natural @ ( bit1 @ ( bit1 @ ( bit0 @ ( bit0 @ ( bit1 @ ( bit1 @ ( bit0 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) @ ( minus_shift @ ( numeral_numeral @ code_natural @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ one2 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) @ ( times_times @ code_natural @ ( modulo_modulo @ code_natural @ W @ ( numeral_numeral @ code_natural @ ( bit0 @ ( bit1 @ ( bit1 @ ( bit0 @ ( bit0 @ ( bit1 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit0 @ ( bit0 @ ( bit1 @ one2 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) @ ( numeral_numeral @ code_natural @ ( bit0 @ ( bit0 @ ( bit1 @ ( bit0 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit0 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit0 @ ( bit0 @ one2 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) @ ( times_times @ code_natural @ ( divide_divide @ code_natural @ W @ ( numeral_numeral @ code_natural @ ( bit0 @ ( bit1 @ ( bit1 @ ( bit0 @ ( bit0 @ ( bit1 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit0 @ ( bit0 @ ( bit1 @ one2 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) @ ( numeral_numeral @ code_natural @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit0 @ ( bit0 @ ( bit1 @ ( bit1 @ ( bit0 @ ( bit1 @ ( bit1 @ one2 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ).

% next.simps
thf(fact_7940_select__weight__member,axiom,
    ! [A: $tType,Xs: list @ ( product_prod @ code_natural @ A ),S2: product_prod @ code_natural @ code_natural] :
      ( ( ord_less @ code_natural @ ( zero_zero @ code_natural ) @ ( groups8242544230860333062m_list @ code_natural @ ( map @ ( product_prod @ code_natural @ A ) @ code_natural @ ( product_fst @ code_natural @ A ) @ Xs ) ) )
     => ( member @ A @ ( product_fst @ A @ ( product_prod @ code_natural @ code_natural ) @ ( select_weight @ A @ Xs @ S2 ) ) @ ( set2 @ A @ ( map @ ( product_prod @ code_natural @ A ) @ A @ ( product_snd @ code_natural @ A ) @ Xs ) ) ) ) ).

% select_weight_member
thf(fact_7941_select__weight__cons__zero,axiom,
    ! [A: $tType,X: A,Xs: list @ ( product_prod @ code_natural @ A )] :
      ( ( select_weight @ A @ ( cons @ ( product_prod @ code_natural @ A ) @ ( product_Pair @ code_natural @ A @ ( zero_zero @ code_natural ) @ X ) @ Xs ) )
      = ( select_weight @ A @ Xs ) ) ).

% select_weight_cons_zero
thf(fact_7942_select__weight__drop__zero,axiom,
    ! [A: $tType,Xs: list @ ( product_prod @ code_natural @ A )] :
      ( ( select_weight @ A
        @ ( filter2 @ ( product_prod @ code_natural @ A )
          @ ( product_case_prod @ code_natural @ A @ $o
            @ ^ [K3: code_natural,Uu3: A] : ( ord_less @ code_natural @ ( zero_zero @ code_natural ) @ K3 ) )
          @ Xs ) )
      = ( select_weight @ A @ Xs ) ) ).

% select_weight_drop_zero
thf(fact_7943_split__seed__def,axiom,
    ( split_seed
    = ( ^ [S6: product_prod @ code_natural @ code_natural] :
          ( product_case_prod @ code_natural @ code_natural @ ( product_prod @ ( product_prod @ code_natural @ code_natural ) @ ( product_prod @ code_natural @ code_natural ) )
          @ ^ [V5: code_natural,W3: code_natural] :
              ( product_case_prod @ code_natural @ code_natural @ ( product_prod @ ( product_prod @ code_natural @ code_natural ) @ ( product_prod @ code_natural @ code_natural ) )
              @ ^ [V7: code_natural,W5: code_natural] : ( product_Pair @ ( product_prod @ code_natural @ code_natural ) @ ( product_prod @ code_natural @ code_natural ) @ ( product_Pair @ code_natural @ code_natural @ ( inc_shift @ ( numeral_numeral @ code_natural @ ( bit0 @ ( bit1 @ ( bit0 @ ( bit1 @ ( bit0 @ ( bit1 @ ( bit0 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ one2 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) @ V5 ) @ W5 ) @ ( product_Pair @ code_natural @ code_natural @ V7 @ ( inc_shift @ ( numeral_numeral @ code_natural @ ( bit0 @ ( bit1 @ ( bit1 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit0 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ one2 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) @ W3 ) ) )
              @ ( product_snd @ code_natural @ ( product_prod @ code_natural @ code_natural ) @ ( next @ S6 ) ) )
          @ S6 ) ) ) ).

% split_seed_def
thf(fact_7944_range,axiom,
    ! [K: code_natural,S2: product_prod @ code_natural @ code_natural] :
      ( ( ord_less @ code_natural @ ( zero_zero @ code_natural ) @ K )
     => ( ord_less @ code_natural @ ( product_fst @ code_natural @ ( product_prod @ code_natural @ code_natural ) @ ( range @ K @ S2 ) ) @ K ) ) ).

% range
thf(fact_7945_pick__drop__zero,axiom,
    ! [A: $tType,Xs: list @ ( product_prod @ code_natural @ A )] :
      ( ( pick @ A
        @ ( filter2 @ ( product_prod @ code_natural @ A )
          @ ( product_case_prod @ code_natural @ A @ $o
            @ ^ [K3: code_natural,Uu3: A] : ( ord_less @ code_natural @ ( zero_zero @ code_natural ) @ K3 ) )
          @ Xs ) )
      = ( pick @ A @ Xs ) ) ).

% pick_drop_zero
thf(fact_7946_Random_Orange__def,axiom,
    ( range
    = ( ^ [K3: code_natural] :
          ( product_scomp @ ( product_prod @ code_natural @ code_natural ) @ code_natural @ ( product_prod @ code_natural @ code_natural ) @ ( product_prod @ code_natural @ ( product_prod @ code_natural @ code_natural ) )
          @ ( iterate @ code_natural @ ( product_prod @ code_natural @ code_natural ) @ ( log @ ( numeral_numeral @ code_natural @ ( bit1 @ ( bit0 @ ( bit0 @ ( bit1 @ ( bit0 @ ( bit1 @ ( bit0 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ one2 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) @ K3 )
            @ ^ [L2: code_natural] :
                ( product_scomp @ ( product_prod @ code_natural @ code_natural ) @ code_natural @ ( product_prod @ code_natural @ code_natural ) @ ( product_prod @ code_natural @ ( product_prod @ code_natural @ code_natural ) ) @ next
                @ ^ [V5: code_natural] : ( product_Pair @ code_natural @ ( product_prod @ code_natural @ code_natural ) @ ( plus_plus @ code_natural @ V5 @ ( times_times @ code_natural @ L2 @ ( numeral_numeral @ code_natural @ ( bit1 @ ( bit0 @ ( bit0 @ ( bit1 @ ( bit0 @ ( bit1 @ ( bit0 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ ( bit1 @ one2 ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) ) )
            @ ( one_one @ code_natural ) )
          @ ^ [V5: code_natural] : ( product_Pair @ code_natural @ ( product_prod @ code_natural @ code_natural ) @ ( modulo_modulo @ code_natural @ V5 @ K3 ) ) ) ) ) ).

% Random.range_def
thf(fact_7947_iterate_Osimps,axiom,
    ! [B: $tType,A: $tType] :
      ( ( iterate @ B @ A )
      = ( ^ [K3: code_natural,F3: B > A > ( product_prod @ B @ A ),X2: B] :
            ( if @ ( A > ( product_prod @ B @ A ) )
            @ ( K3
              = ( zero_zero @ code_natural ) )
            @ ( product_Pair @ B @ A @ X2 )
            @ ( product_scomp @ A @ B @ A @ ( product_prod @ B @ A ) @ ( F3 @ X2 ) @ ( iterate @ B @ A @ ( minus_minus @ code_natural @ K3 @ ( one_one @ code_natural ) ) @ F3 ) ) ) ) ) ).

% iterate.simps
thf(fact_7948_iterate_Oelims,axiom,
    ! [A: $tType,B: $tType,X: code_natural,Xa: B > A > ( product_prod @ B @ A ),Xb: B,Y: A > ( product_prod @ B @ A )] :
      ( ( ( iterate @ B @ A @ X @ Xa @ Xb )
        = Y )
     => ( ( ( X
            = ( zero_zero @ code_natural ) )
         => ( Y
            = ( product_Pair @ B @ A @ Xb ) ) )
        & ( ( X
           != ( zero_zero @ code_natural ) )
         => ( Y
            = ( product_scomp @ A @ B @ A @ ( product_prod @ B @ A ) @ ( Xa @ Xb ) @ ( iterate @ B @ A @ ( minus_minus @ code_natural @ X @ ( one_one @ code_natural ) ) @ Xa ) ) ) ) ) ) ).

% iterate.elims
thf(fact_7949_pick__same,axiom,
    ! [A: $tType,L: nat,Xs: list @ A] :
      ( ( ord_less @ nat @ L @ ( size_size @ ( list @ A ) @ Xs ) )
     => ( ( pick @ A @ ( map @ A @ ( product_prod @ code_natural @ A ) @ ( product_Pair @ code_natural @ A @ ( one_one @ code_natural ) ) @ Xs ) @ ( code_natural_of_nat @ L ) )
        = ( nth @ A @ Xs @ L ) ) ) ).

% pick_same
thf(fact_7950_iterate_Opelims,axiom,
    ! [A: $tType,B: $tType,X: code_natural,Xa: B > A > ( product_prod @ B @ A ),Xb: B,Y: A > ( product_prod @ B @ A )] :
      ( ( ( iterate @ B @ A @ X @ Xa @ Xb )
        = Y )
     => ( ( accp @ ( product_prod @ code_natural @ ( product_prod @ ( B > A > ( product_prod @ B @ A ) ) @ B ) ) @ ( iterate_rel @ B @ A ) @ ( product_Pair @ code_natural @ ( product_prod @ ( B > A > ( product_prod @ B @ A ) ) @ B ) @ X @ ( product_Pair @ ( B > A > ( product_prod @ B @ A ) ) @ B @ Xa @ Xb ) ) )
       => ~ ( ( ( ( X
                  = ( zero_zero @ code_natural ) )
               => ( Y
                  = ( product_Pair @ B @ A @ Xb ) ) )
              & ( ( X
                 != ( zero_zero @ code_natural ) )
               => ( Y
                  = ( product_scomp @ A @ B @ A @ ( product_prod @ B @ A ) @ ( Xa @ Xb ) @ ( iterate @ B @ A @ ( minus_minus @ code_natural @ X @ ( one_one @ code_natural ) ) @ Xa ) ) ) ) )
           => ~ ( accp @ ( product_prod @ code_natural @ ( product_prod @ ( B > A > ( product_prod @ B @ A ) ) @ B ) ) @ ( iterate_rel @ B @ A ) @ ( product_Pair @ code_natural @ ( product_prod @ ( B > A > ( product_prod @ B @ A ) ) @ B ) @ X @ ( product_Pair @ ( B > A > ( product_prod @ B @ A ) ) @ B @ Xa @ Xb ) ) ) ) ) ) ).

% iterate.pelims
thf(fact_7951_less__eq__natural_Oabs__eq,axiom,
    ! [Xa: nat,X: nat] :
      ( ( ord_less_eq @ code_natural @ ( code_natural_of_nat @ Xa ) @ ( code_natural_of_nat @ X ) )
      = ( ord_less_eq @ nat @ Xa @ X ) ) ).

% less_eq_natural.abs_eq
thf(fact_7952_less__natural_Oabs__eq,axiom,
    ! [Xa: nat,X: nat] :
      ( ( ord_less @ code_natural @ ( code_natural_of_nat @ Xa ) @ ( code_natural_of_nat @ X ) )
      = ( ord_less @ nat @ Xa @ X ) ) ).

% less_natural.abs_eq
thf(fact_7953_zero__natural__def,axiom,
    ( ( zero_zero @ code_natural )
    = ( code_natural_of_nat @ ( zero_zero @ nat ) ) ) ).

% zero_natural_def
thf(fact_7954_integer__of__natural_Oabs__eq,axiom,
    ! [X: nat] :
      ( ( code_i5400310926305786745atural @ ( code_natural_of_nat @ X ) )
      = ( code_integer_of_int @ ( semiring_1_of_nat @ int @ X ) ) ) ).

% integer_of_natural.abs_eq
thf(fact_7955_natural_Osimps_I6_J,axiom,
    ! [T: $tType,F1: T,F22: code_natural > T > T] :
      ( ( code_rec_natural @ T @ F1 @ F22 @ ( zero_zero @ code_natural ) )
      = F1 ) ).

% natural.simps(6)
thf(fact_7956_eventually__prod__sequentially,axiom,
    ! [P: ( product_prod @ nat @ nat ) > $o] :
      ( ( eventually @ ( product_prod @ nat @ nat ) @ P @ ( prod_filter @ nat @ nat @ ( at_top @ nat ) @ ( at_top @ nat ) ) )
      = ( ? [N6: nat] :
          ! [M3: nat] :
            ( ( ord_less_eq @ nat @ N6 @ M3 )
           => ! [N3: nat] :
                ( ( ord_less_eq @ nat @ N6 @ N3 )
               => ( P @ ( product_Pair @ nat @ nat @ N3 @ M3 ) ) ) ) ) ) ).

% eventually_prod_sequentially
thf(fact_7957_Quotient3__int,axiom,
    quotient3 @ ( product_prod @ nat @ nat ) @ int @ intrel @ abs_Integ @ rep_Integ ).

% Quotient3_int
thf(fact_7958_Field__natLeq__on,axiom,
    ! [N: nat] :
      ( ( field2 @ nat
        @ ( collect @ ( product_prod @ nat @ nat )
          @ ( product_case_prod @ nat @ nat @ $o
            @ ^ [X2: nat,Y4: nat] :
                ( ( ord_less @ nat @ X2 @ N )
                & ( ord_less @ nat @ Y4 @ N )
                & ( ord_less_eq @ nat @ X2 @ Y4 ) ) ) ) )
      = ( collect @ nat
        @ ^ [X2: nat] : ( ord_less @ nat @ X2 @ N ) ) ) ).

% Field_natLeq_on
thf(fact_7959_natLeq__on__Well__order,axiom,
    ! [N: nat] :
      ( order_well_order_on @ nat
      @ ( field2 @ nat
        @ ( collect @ ( product_prod @ nat @ nat )
          @ ( product_case_prod @ nat @ nat @ $o
            @ ^ [X2: nat,Y4: nat] :
                ( ( ord_less @ nat @ X2 @ N )
                & ( ord_less @ nat @ Y4 @ N )
                & ( ord_less_eq @ nat @ X2 @ Y4 ) ) ) ) )
      @ ( collect @ ( product_prod @ nat @ nat )
        @ ( product_case_prod @ nat @ nat @ $o
          @ ^ [X2: nat,Y4: nat] :
              ( ( ord_less @ nat @ X2 @ N )
              & ( ord_less @ nat @ Y4 @ N )
              & ( ord_less_eq @ nat @ X2 @ Y4 ) ) ) ) ) ).

% natLeq_on_Well_order
thf(fact_7960_sub_Otransfer,axiom,
    ( bNF_rel_fun @ num @ num @ ( num > int ) @ ( num > code_integer )
    @ ^ [Y3: num,Z2: num] : ( Y3 = Z2 )
    @ ( bNF_rel_fun @ num @ num @ int @ code_integer
      @ ^ [Y3: num,Z2: num] : ( Y3 = Z2 )
      @ code_pcr_integer )
    @ ^ [M3: num,N3: num] : ( minus_minus @ int @ ( numeral_numeral @ int @ M3 ) @ ( numeral_numeral @ int @ N3 ) )
    @ code_sub ) ).

% sub.transfer
thf(fact_7961_natLeq__on__well__order__on,axiom,
    ! [N: nat] :
      ( order_well_order_on @ nat
      @ ( collect @ nat
        @ ^ [X2: nat] : ( ord_less @ nat @ X2 @ N ) )
      @ ( collect @ ( product_prod @ nat @ nat )
        @ ( product_case_prod @ nat @ nat @ $o
          @ ^ [X2: nat,Y4: nat] :
              ( ( ord_less @ nat @ X2 @ N )
              & ( ord_less @ nat @ Y4 @ N )
              & ( ord_less_eq @ nat @ X2 @ Y4 ) ) ) ) ) ).

% natLeq_on_well_order_on
thf(fact_7962_zero__integer_Otransfer,axiom,
    code_pcr_integer @ ( zero_zero @ int ) @ ( zero_zero @ code_integer ) ).

% zero_integer.transfer
thf(fact_7963_less__integer_Otransfer,axiom,
    ( bNF_rel_fun @ int @ code_integer @ ( int > $o ) @ ( code_integer > $o ) @ code_pcr_integer
    @ ( bNF_rel_fun @ int @ code_integer @ $o @ $o @ code_pcr_integer
      @ ^ [Y3: $o,Z2: $o] : ( Y3 = Z2 ) )
    @ ( ord_less @ int )
    @ ( ord_less @ code_integer ) ) ).

% less_integer.transfer
thf(fact_7964_less__eq__integer_Otransfer,axiom,
    ( bNF_rel_fun @ int @ code_integer @ ( int > $o ) @ ( code_integer > $o ) @ code_pcr_integer
    @ ( bNF_rel_fun @ int @ code_integer @ $o @ $o @ code_pcr_integer
      @ ^ [Y3: $o,Z2: $o] : ( Y3 = Z2 ) )
    @ ( ord_less_eq @ int )
    @ ( ord_less_eq @ code_integer ) ) ).

% less_eq_integer.transfer
thf(fact_7965_integer__of__nat_Otransfer,axiom,
    ( bNF_rel_fun @ nat @ nat @ int @ code_integer
    @ ^ [Y3: nat,Z2: nat] : ( Y3 = Z2 )
    @ code_pcr_integer
    @ ( semiring_1_of_nat @ int )
    @ code_integer_of_nat ) ).

% integer_of_nat.transfer
thf(fact_7966_integer__of__natural_Otransfer,axiom,
    bNF_rel_fun @ nat @ code_natural @ int @ code_integer @ code_pcr_natural @ code_pcr_integer @ ( semiring_1_of_nat @ int ) @ code_i5400310926305786745atural ).

% integer_of_natural.transfer
thf(fact_7967_list__all__length,axiom,
    ! [A: $tType] :
      ( ( list_all @ A )
      = ( ^ [P3: A > $o,Xs3: list @ A] :
          ! [N3: nat] :
            ( ( ord_less @ nat @ N3 @ ( size_size @ ( list @ A ) @ Xs3 ) )
           => ( P3 @ ( nth @ A @ Xs3 @ N3 ) ) ) ) ) ).

% list_all_length
thf(fact_7968_less__natural_Otransfer,axiom,
    ( bNF_rel_fun @ nat @ code_natural @ ( nat > $o ) @ ( code_natural > $o ) @ code_pcr_natural
    @ ( bNF_rel_fun @ nat @ code_natural @ $o @ $o @ code_pcr_natural
      @ ^ [Y3: $o,Z2: $o] : ( Y3 = Z2 ) )
    @ ( ord_less @ nat )
    @ ( ord_less @ code_natural ) ) ).

% less_natural.transfer
thf(fact_7969_less__eq__natural_Otransfer,axiom,
    ( bNF_rel_fun @ nat @ code_natural @ ( nat > $o ) @ ( code_natural > $o ) @ code_pcr_natural
    @ ( bNF_rel_fun @ nat @ code_natural @ $o @ $o @ code_pcr_natural
      @ ^ [Y3: $o,Z2: $o] : ( Y3 = Z2 ) )
    @ ( ord_less_eq @ nat )
    @ ( ord_less_eq @ code_natural ) ) ).

% less_eq_natural.transfer
thf(fact_7970_zero__natural_Otransfer,axiom,
    code_pcr_natural @ ( zero_zero @ nat ) @ ( zero_zero @ code_natural ) ).

% zero_natural.transfer
thf(fact_7971_String_Oliteral__of__asciis__Nil,axiom,
    ( ( literal_of_asciis @ ( nil @ code_integer ) )
    = ( zero_zero @ literal ) ) ).

% String.literal_of_asciis_Nil
thf(fact_7972_String_Oasciis__of__zero,axiom,
    ( ( asciis_of_literal @ ( zero_zero @ literal ) )
    = ( nil @ code_integer ) ) ).

% String.asciis_of_zero
thf(fact_7973_linear__injective__on__subspace__0,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V4867850818363320053vector @ A )
        & ( real_V4867850818363320053vector @ B ) )
     => ! [F2: A > B,S2: set @ A] :
          ( ( real_Vector_linear @ A @ B @ F2 )
         => ( ( real_Vector_subspace @ A @ S2 )
           => ( ( inj_on @ A @ B @ F2 @ S2 )
              = ( ! [X2: A] :
                    ( ( member @ A @ X2 @ S2 )
                   => ( ( ( F2 @ X2 )
                        = ( zero_zero @ B ) )
                     => ( X2
                        = ( zero_zero @ A ) ) ) ) ) ) ) ) ) ).

% linear_injective_on_subspace_0
thf(fact_7974_eventually__filtercomap__at__bot__dense,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( linorder @ A )
        & ( no_bot @ A ) )
     => ! [P: B > $o,F2: B > A] :
          ( ( eventually @ B @ P @ ( filtercomap @ B @ A @ F2 @ ( at_bot @ A ) ) )
          = ( ? [N6: A] :
              ! [X2: B] :
                ( ( ord_less @ A @ ( F2 @ X2 ) @ N6 )
               => ( P @ X2 ) ) ) ) ) ).

% eventually_filtercomap_at_bot_dense
thf(fact_7975_subspace__single__0,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ( real_Vector_subspace @ A @ ( insert @ A @ ( zero_zero @ A ) @ ( bot_bot @ ( set @ A ) ) ) ) ) ).

% subspace_single_0
thf(fact_7976_linear__subspace__kernel,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( real_V4867850818363320053vector @ A )
        & ( real_V4867850818363320053vector @ B ) )
     => ! [F2: A > B] :
          ( ( real_Vector_linear @ A @ B @ F2 )
         => ( real_Vector_subspace @ A
            @ ( collect @ A
              @ ^ [X2: A] :
                  ( ( F2 @ X2 )
                  = ( zero_zero @ B ) ) ) ) ) ) ).

% linear_subspace_kernel
thf(fact_7977_subspace__0,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [S: set @ A] :
          ( ( real_Vector_subspace @ A @ S )
         => ( member @ A @ ( zero_zero @ A ) @ S ) ) ) ).

% subspace_0
thf(fact_7978_subspaceI,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ! [S: set @ A] :
          ( ( member @ A @ ( zero_zero @ A ) @ S )
         => ( ! [X3: A,Y5: A] :
                ( ( member @ A @ X3 @ S )
               => ( ( member @ A @ Y5 @ S )
                 => ( member @ A @ ( plus_plus @ A @ X3 @ Y5 ) @ S ) ) )
           => ( ! [C3: real,X3: A] :
                  ( ( member @ A @ X3 @ S )
                 => ( member @ A @ ( real_V8093663219630862766scaleR @ A @ C3 @ X3 ) @ S ) )
             => ( real_Vector_subspace @ A @ S ) ) ) ) ) ).

% subspaceI
thf(fact_7979_subspace__def,axiom,
    ! [A: $tType] :
      ( ( real_V4867850818363320053vector @ A )
     => ( ( real_Vector_subspace @ A )
        = ( ^ [S8: set @ A] :
              ( ( member @ A @ ( zero_zero @ A ) @ S8 )
              & ! [X2: A] :
                  ( ( member @ A @ X2 @ S8 )
                 => ! [Y4: A] :
                      ( ( member @ A @ Y4 @ S8 )
                     => ( member @ A @ ( plus_plus @ A @ X2 @ Y4 ) @ S8 ) ) )
              & ! [C4: real,X2: A] :
                  ( ( member @ A @ X2 @ S8 )
                 => ( member @ A @ ( real_V8093663219630862766scaleR @ A @ C4 @ X2 ) @ S8 ) ) ) ) ) ) ).

% subspace_def
thf(fact_7980_eventually__filtercomap__at__top__linorder,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linorder @ A )
     => ! [P: B > $o,F2: B > A] :
          ( ( eventually @ B @ P @ ( filtercomap @ B @ A @ F2 @ ( at_top @ A ) ) )
          = ( ? [N6: A] :
              ! [X2: B] :
                ( ( ord_less_eq @ A @ N6 @ ( F2 @ X2 ) )
               => ( P @ X2 ) ) ) ) ) ).

% eventually_filtercomap_at_top_linorder
thf(fact_7981_eventually__filtercomap__at__top__dense,axiom,
    ! [B: $tType,A: $tType] :
      ( ( ( linorder @ A )
        & ( no_top @ A ) )
     => ! [P: B > $o,F2: B > A] :
          ( ( eventually @ B @ P @ ( filtercomap @ B @ A @ F2 @ ( at_top @ A ) ) )
          = ( ? [N6: A] :
              ! [X2: B] :
                ( ( ord_less @ A @ N6 @ ( F2 @ X2 ) )
               => ( P @ X2 ) ) ) ) ) ).

% eventually_filtercomap_at_top_dense
thf(fact_7982_eventually__filtercomap__at__bot__linorder,axiom,
    ! [B: $tType,A: $tType] :
      ( ( linorder @ A )
     => ! [P: B > $o,F2: B > A] :
          ( ( eventually @ B @ P @ ( filtercomap @ B @ A @ F2 @ ( at_bot @ A ) ) )
          = ( ? [N6: A] :
              ! [X2: B] :
                ( ( ord_less_eq @ A @ ( F2 @ X2 ) @ N6 )
               => ( P @ X2 ) ) ) ) ) ).

% eventually_filtercomap_at_bot_linorder
thf(fact_7983_ordering__top_Oaxioms_I2_J,axiom,
    ! [A: $tType,Less_eq: A > A > $o,Less: A > A > $o,Top: A] :
      ( ( ordering_top @ A @ Less_eq @ Less @ Top )
     => ( ordering_top_axioms @ A @ Less_eq @ Top ) ) ).

% ordering_top.axioms(2)
thf(fact_7984_of__int__code_I1_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [K: num] :
          ( ( ring_1_of_int @ A @ ( neg @ K ) )
          = ( uminus_uminus @ A @ ( numeral_numeral @ A @ K ) ) ) ) ).

% of_int_code(1)
thf(fact_7985_nat__code_I1_J,axiom,
    ! [K: num] :
      ( ( nat2 @ ( neg @ K ) )
      = ( zero_zero @ nat ) ) ).

% nat_code(1)
thf(fact_7986_less__int__code_I3_J,axiom,
    ! [L: num] :
      ~ ( ord_less @ int @ ( zero_zero @ int ) @ ( neg @ L ) ) ).

% less_int_code(3)
thf(fact_7987_less__int__code_I7_J,axiom,
    ! [K: num] : ( ord_less @ int @ ( neg @ K ) @ ( zero_zero @ int ) ) ).

% less_int_code(7)
thf(fact_7988_less__int__code_I9_J,axiom,
    ! [K: num,L: num] :
      ( ( ord_less @ int @ ( neg @ K ) @ ( neg @ L ) )
      = ( ord_less @ num @ L @ K ) ) ).

% less_int_code(9)
thf(fact_7989_less__eq__int__code_I9_J,axiom,
    ! [K: num,L: num] :
      ( ( ord_less_eq @ int @ ( neg @ K ) @ ( neg @ L ) )
      = ( ord_less_eq @ num @ L @ K ) ) ).

% less_eq_int_code(9)
thf(fact_7990_less__eq__int__code_I7_J,axiom,
    ! [K: num] : ( ord_less_eq @ int @ ( neg @ K ) @ ( zero_zero @ int ) ) ).

% less_eq_int_code(7)
thf(fact_7991_less__eq__int__code_I3_J,axiom,
    ! [L: num] :
      ~ ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( neg @ L ) ) ).

% less_eq_int_code(3)
thf(fact_7992_ordering__top__axioms__def,axiom,
    ! [A: $tType] :
      ( ( ordering_top_axioms @ A )
      = ( ^ [Less_eq2: A > A > $o,Top2: A] :
          ! [A3: A] : ( Less_eq2 @ A3 @ Top2 ) ) ) ).

% ordering_top_axioms_def
thf(fact_7993_ordering__top__axioms_Ointro,axiom,
    ! [A: $tType,Less_eq: A > A > $o,Top: A] :
      ( ! [A5: A] : ( Less_eq @ A5 @ Top )
     => ( ordering_top_axioms @ A @ Less_eq @ Top ) ) ).

% ordering_top_axioms.intro
thf(fact_7994_plus__int__code_I6_J,axiom,
    ! [M: num,N: num] :
      ( ( plus_plus @ int @ ( neg @ M ) @ ( neg @ N ) )
      = ( neg @ ( plus_plus @ num @ M @ N ) ) ) ).

% plus_int_code(6)
thf(fact_7995_Int_Osub__code_I4_J,axiom,
    ! [N: num] :
      ( ( sub @ one2 @ ( bit0 @ N ) )
      = ( neg @ ( bitM @ N ) ) ) ).

% Int.sub_code(4)
thf(fact_7996_Int_Osub__code_I5_J,axiom,
    ! [N: num] :
      ( ( sub @ one2 @ ( bit1 @ N ) )
      = ( neg @ ( bit0 @ N ) ) ) ).

% Int.sub_code(5)
thf(fact_7997_Int_Osub__def,axiom,
    ( sub
    = ( ^ [M3: num,N3: num] : ( minus_minus @ int @ ( numeral_numeral @ int @ M3 ) @ ( numeral_numeral @ int @ N3 ) ) ) ) ).

% Int.sub_def
thf(fact_7998_Int_Osub__code_I1_J,axiom,
    ( ( sub @ one2 @ one2 )
    = ( zero_zero @ int ) ) ).

% Int.sub_code(1)
thf(fact_7999_minus__int__code_I6_J,axiom,
    ! [M: num,N: num] :
      ( ( minus_minus @ int @ ( neg @ M ) @ ( neg @ N ) )
      = ( sub @ N @ M ) ) ).

% minus_int_code(6)
thf(fact_8000_Int_Osub__code_I9_J,axiom,
    ! [M: num,N: num] :
      ( ( sub @ ( bit0 @ M ) @ ( bit1 @ N ) )
      = ( minus_minus @ int @ ( dup @ ( sub @ M @ N ) ) @ ( one_one @ int ) ) ) ).

% Int.sub_code(9)
thf(fact_8001_Int_Osub__code_I8_J,axiom,
    ! [M: num,N: num] :
      ( ( sub @ ( bit1 @ M ) @ ( bit0 @ N ) )
      = ( plus_plus @ int @ ( dup @ ( sub @ M @ N ) ) @ ( one_one @ int ) ) ) ).

% Int.sub_code(8)
thf(fact_8002_Int_Odup__code_I1_J,axiom,
    ( ( dup @ ( zero_zero @ int ) )
    = ( zero_zero @ int ) ) ).

% Int.dup_code(1)
thf(fact_8003_Int_Odup__def,axiom,
    ( dup
    = ( ^ [K3: int] : ( plus_plus @ int @ K3 @ K3 ) ) ) ).

% Int.dup_def
thf(fact_8004_Int_Odup__code_I3_J,axiom,
    ! [N: num] :
      ( ( dup @ ( neg @ N ) )
      = ( neg @ ( bit0 @ N ) ) ) ).

% Int.dup_code(3)
thf(fact_8005_Int_Osub__code_I6_J,axiom,
    ! [M: num,N: num] :
      ( ( sub @ ( bit0 @ M ) @ ( bit0 @ N ) )
      = ( dup @ ( sub @ M @ N ) ) ) ).

% Int.sub_code(6)
thf(fact_8006_Int_Osub__code_I7_J,axiom,
    ! [M: num,N: num] :
      ( ( sub @ ( bit1 @ M ) @ ( bit1 @ N ) )
      = ( dup @ ( sub @ M @ N ) ) ) ).

% Int.sub_code(7)
thf(fact_8007_Int_Osub__code_I2_J,axiom,
    ! [M: num] :
      ( ( sub @ ( bit0 @ M ) @ one2 )
      = ( pos @ ( bitM @ M ) ) ) ).

% Int.sub_code(2)
thf(fact_8008_Int_Osub__code_I3_J,axiom,
    ! [M: num] :
      ( ( sub @ ( bit1 @ M ) @ one2 )
      = ( pos @ ( bit0 @ M ) ) ) ).

% Int.sub_code(3)
thf(fact_8009_Int_Odup__code_I2_J,axiom,
    ! [N: num] :
      ( ( dup @ ( pos @ N ) )
      = ( pos @ ( bit0 @ N ) ) ) ).

% Int.dup_code(2)
thf(fact_8010_less__int__code_I6_J,axiom,
    ! [K: num,L: num] :
      ~ ( ord_less @ int @ ( pos @ K ) @ ( neg @ L ) ) ).

% less_int_code(6)
thf(fact_8011_less__int__code_I8_J,axiom,
    ! [K: num,L: num] : ( ord_less @ int @ ( neg @ K ) @ ( pos @ L ) ) ).

% less_int_code(8)
thf(fact_8012_less__eq__int__code_I8_J,axiom,
    ! [K: num,L: num] : ( ord_less_eq @ int @ ( neg @ K ) @ ( pos @ L ) ) ).

% less_eq_int_code(8)
thf(fact_8013_less__eq__int__code_I6_J,axiom,
    ! [K: num,L: num] :
      ~ ( ord_less_eq @ int @ ( pos @ K ) @ ( neg @ L ) ) ).

% less_eq_int_code(6)
thf(fact_8014_Int_ONeg__def,axiom,
    ( neg
    = ( ^ [N3: num] : ( uminus_uminus @ int @ ( pos @ N3 ) ) ) ) ).

% Int.Neg_def
thf(fact_8015_uminus__int__code_I2_J,axiom,
    ! [M: num] :
      ( ( uminus_uminus @ int @ ( pos @ M ) )
      = ( neg @ M ) ) ).

% uminus_int_code(2)
thf(fact_8016_uminus__int__code_I3_J,axiom,
    ! [M: num] :
      ( ( uminus_uminus @ int @ ( neg @ M ) )
      = ( pos @ M ) ) ).

% uminus_int_code(3)
thf(fact_8017_times__int__code_I3_J,axiom,
    ! [M: num,N: num] :
      ( ( times_times @ int @ ( pos @ M ) @ ( pos @ N ) )
      = ( pos @ ( times_times @ num @ M @ N ) ) ) ).

% times_int_code(3)
thf(fact_8018_plus__int__code_I3_J,axiom,
    ! [M: num,N: num] :
      ( ( plus_plus @ int @ ( pos @ M ) @ ( pos @ N ) )
      = ( pos @ ( plus_plus @ num @ M @ N ) ) ) ).

% plus_int_code(3)
thf(fact_8019_one__int__code,axiom,
    ( ( one_one @ int )
    = ( pos @ one2 ) ) ).

% one_int_code
thf(fact_8020_nat__code_I3_J,axiom,
    ! [K: num] :
      ( ( nat2 @ ( pos @ K ) )
      = ( nat_of_num @ K ) ) ).

% nat_code(3)
thf(fact_8021_less__eq__int__code_I2_J,axiom,
    ! [L: num] : ( ord_less_eq @ int @ ( zero_zero @ int ) @ ( pos @ L ) ) ).

% less_eq_int_code(2)
thf(fact_8022_less__eq__int__code_I4_J,axiom,
    ! [K: num] :
      ~ ( ord_less_eq @ int @ ( pos @ K ) @ ( zero_zero @ int ) ) ).

% less_eq_int_code(4)
thf(fact_8023_less__eq__int__code_I5_J,axiom,
    ! [K: num,L: num] :
      ( ( ord_less_eq @ int @ ( pos @ K ) @ ( pos @ L ) )
      = ( ord_less_eq @ num @ K @ L ) ) ).

% less_eq_int_code(5)
thf(fact_8024_less__int__code_I5_J,axiom,
    ! [K: num,L: num] :
      ( ( ord_less @ int @ ( pos @ K ) @ ( pos @ L ) )
      = ( ord_less @ num @ K @ L ) ) ).

% less_int_code(5)
thf(fact_8025_Int_OPos__def,axiom,
    ( pos
    = ( numeral_numeral @ int ) ) ).

% Int.Pos_def
thf(fact_8026_of__int__code_I3_J,axiom,
    ! [A: $tType] :
      ( ( ring_1 @ A )
     => ! [K: num] :
          ( ( ring_1_of_int @ A @ ( pos @ K ) )
          = ( numeral_numeral @ A @ K ) ) ) ).

% of_int_code(3)
thf(fact_8027_less__int__code_I4_J,axiom,
    ! [K: num] :
      ~ ( ord_less @ int @ ( pos @ K ) @ ( zero_zero @ int ) ) ).

% less_int_code(4)
thf(fact_8028_less__int__code_I2_J,axiom,
    ! [L: num] : ( ord_less @ int @ ( zero_zero @ int ) @ ( pos @ L ) ) ).

% less_int_code(2)
thf(fact_8029_minus__int__code_I3_J,axiom,
    ! [M: num,N: num] :
      ( ( minus_minus @ int @ ( pos @ M ) @ ( pos @ N ) )
      = ( sub @ M @ N ) ) ).

% minus_int_code(3)
thf(fact_8030_minus__int__code_I5_J,axiom,
    ! [M: num,N: num] :
      ( ( minus_minus @ int @ ( neg @ M ) @ ( pos @ N ) )
      = ( neg @ ( plus_plus @ num @ M @ N ) ) ) ).

% minus_int_code(5)
thf(fact_8031_minus__int__code_I4_J,axiom,
    ! [M: num,N: num] :
      ( ( minus_minus @ int @ ( pos @ M ) @ ( neg @ N ) )
      = ( pos @ ( plus_plus @ num @ M @ N ) ) ) ).

% minus_int_code(4)
thf(fact_8032_times__int__code_I4_J,axiom,
    ! [M: num,N: num] :
      ( ( times_times @ int @ ( pos @ M ) @ ( neg @ N ) )
      = ( neg @ ( times_times @ num @ M @ N ) ) ) ).

% times_int_code(4)
thf(fact_8033_times__int__code_I5_J,axiom,
    ! [M: num,N: num] :
      ( ( times_times @ int @ ( neg @ M ) @ ( pos @ N ) )
      = ( neg @ ( times_times @ num @ M @ N ) ) ) ).

% times_int_code(5)
thf(fact_8034_times__int__code_I6_J,axiom,
    ! [M: num,N: num] :
      ( ( times_times @ int @ ( neg @ M ) @ ( neg @ N ) )
      = ( pos @ ( times_times @ num @ M @ N ) ) ) ).

% times_int_code(6)
thf(fact_8035_plus__int__code_I5_J,axiom,
    ! [M: num,N: num] :
      ( ( plus_plus @ int @ ( neg @ M ) @ ( pos @ N ) )
      = ( sub @ N @ M ) ) ).

% plus_int_code(5)
thf(fact_8036_plus__int__code_I4_J,axiom,
    ! [M: num,N: num] :
      ( ( plus_plus @ int @ ( pos @ M ) @ ( neg @ N ) )
      = ( sub @ M @ N ) ) ).

% plus_int_code(4)
thf(fact_8037_ordering__top_Ointro,axiom,
    ! [A: $tType,Less_eq: A > A > $o,Less: A > A > $o,Top: A] :
      ( ( ordering @ A @ Less_eq @ Less )
     => ( ( ordering_top_axioms @ A @ Less_eq @ Top )
       => ( ordering_top @ A @ Less_eq @ Less @ Top ) ) ) ).

% ordering_top.intro
thf(fact_8038_ordering__top__def,axiom,
    ! [A: $tType] :
      ( ( ordering_top @ A )
      = ( ^ [Less_eq2: A > A > $o,Less2: A > A > $o,Top2: A] :
            ( ( ordering @ A @ Less_eq2 @ Less2 )
            & ( ordering_top_axioms @ A @ Less_eq2 @ Top2 ) ) ) ) ).

% ordering_top_def
thf(fact_8039_dual__order_Oordering__axioms,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ordering @ A
        @ ^ [X2: A,Y4: A] : ( ord_less_eq @ A @ Y4 @ X2 )
        @ ^ [X2: A,Y4: A] : ( ord_less @ A @ Y4 @ X2 ) ) ) ).

% dual_order.ordering_axioms
thf(fact_8040_order_Oordering__axioms,axiom,
    ! [A: $tType] :
      ( ( order @ A )
     => ( ordering @ A @ ( ord_less_eq @ A ) @ ( ord_less @ A ) ) ) ).

% order.ordering_axioms
thf(fact_8041_ordering__top_Oaxioms_I1_J,axiom,
    ! [A: $tType,Less_eq: A > A > $o,Less: A > A > $o,Top: A] :
      ( ( ordering_top @ A @ Less_eq @ Less @ Top )
     => ( ordering @ A @ Less_eq @ Less ) ) ).

% ordering_top.axioms(1)
thf(fact_8042_ordering__strictI,axiom,
    ! [A: $tType,Less_eq: A > A > $o,Less: A > A > $o] :
      ( ! [A5: A,B4: A] :
          ( ( Less_eq @ A5 @ B4 )
          = ( ( Less @ A5 @ B4 )
            | ( A5 = B4 ) ) )
     => ( ! [A5: A,B4: A] :
            ( ( Less @ A5 @ B4 )
           => ~ ( Less @ B4 @ A5 ) )
       => ( ! [A5: A] :
              ~ ( Less @ A5 @ A5 )
         => ( ! [A5: A,B4: A,C3: A] :
                ( ( Less @ A5 @ B4 )
               => ( ( Less @ B4 @ C3 )
                 => ( Less @ A5 @ C3 ) ) )
           => ( ordering @ A @ Less_eq @ Less ) ) ) ) ) ).

% ordering_strictI
thf(fact_8043_ordering_Onot__eq__order__implies__strict,axiom,
    ! [A: $tType,Less_eq: A > A > $o,Less: A > A > $o,A2: A,B2: A] :
      ( ( ordering @ A @ Less_eq @ Less )
     => ( ( A2 != B2 )
       => ( ( Less_eq @ A2 @ B2 )
         => ( Less @ A2 @ B2 ) ) ) ) ).

% ordering.not_eq_order_implies_strict
thf(fact_8044_ordering_Ostrict__implies__not__eq,axiom,
    ! [A: $tType,Less_eq: A > A > $o,Less: A > A > $o,A2: A,B2: A] :
      ( ( ordering @ A @ Less_eq @ Less )
     => ( ( Less @ A2 @ B2 )
       => ( A2 != B2 ) ) ) ).

% ordering.strict_implies_not_eq
thf(fact_8045_ordering_Ostrict__iff__order,axiom,
    ! [A: $tType,Less_eq: A > A > $o,Less: A > A > $o,A2: A,B2: A] :
      ( ( ordering @ A @ Less_eq @ Less )
     => ( ( Less @ A2 @ B2 )
        = ( ( Less_eq @ A2 @ B2 )
          & ( A2 != B2 ) ) ) ) ).

% ordering.strict_iff_order
thf(fact_8046_ordering_Oorder__iff__strict,axiom,
    ! [A: $tType,Less_eq: A > A > $o,Less: A > A > $o,A2: A,B2: A] :
      ( ( ordering @ A @ Less_eq @ Less )
     => ( ( Less_eq @ A2 @ B2 )
        = ( ( Less @ A2 @ B2 )
          | ( A2 = B2 ) ) ) ) ).

% ordering.order_iff_strict
thf(fact_8047_ordering_Oantisym,axiom,
    ! [A: $tType,Less_eq: A > A > $o,Less: A > A > $o,A2: A,B2: A] :
      ( ( ordering @ A @ Less_eq @ Less )
     => ( ( Less_eq @ A2 @ B2 )
       => ( ( Less_eq @ B2 @ A2 )
         => ( A2 = B2 ) ) ) ) ).

% ordering.antisym
thf(fact_8048_ordering_Oeq__iff,axiom,
    ! [A: $tType,Less_eq: A > A > $o,Less: A > A > $o,A2: A,B2: A] :
      ( ( ordering @ A @ Less_eq @ Less )
     => ( ( A2 = B2 )
        = ( ( Less_eq @ A2 @ B2 )
          & ( Less_eq @ B2 @ A2 ) ) ) ) ).

% ordering.eq_iff
thf(fact_8049_ordering__dualI,axiom,
    ! [A: $tType,Less_eq: A > A > $o,Less: A > A > $o] :
      ( ( ordering @ A
        @ ^ [A3: A,B3: A] : ( Less_eq @ B3 @ A3 )
        @ ^ [A3: A,B3: A] : ( Less @ B3 @ A3 ) )
     => ( ordering @ A @ Less_eq @ Less ) ) ).

% ordering_dualI
thf(fact_8050_group_Oaxioms_I2_J,axiom,
    ! [A: $tType,F2: A > A > A,Z: A,Inverse: A > A] :
      ( ( group @ A @ F2 @ Z @ Inverse )
     => ( group_axioms @ A @ F2 @ Z @ Inverse ) ) ).

% group.axioms(2)
thf(fact_8051_sum__list_Ocomm__monoid__list__axioms,axiom,
    ! [A: $tType] :
      ( ( comm_monoid_add @ A )
     => ( groups1828464146339083142d_list @ A @ ( plus_plus @ A ) @ ( zero_zero @ A ) ) ) ).

% sum_list.comm_monoid_list_axioms
thf(fact_8052_group__axioms_Ointro,axiom,
    ! [A: $tType,F2: A > A > A,Z: A,Inverse: A > A] :
      ( ! [A5: A] :
          ( ( F2 @ Z @ A5 )
          = A5 )
     => ( ! [A5: A] :
            ( ( F2 @ ( Inverse @ A5 ) @ A5 )
            = Z )
       => ( group_axioms @ A @ F2 @ Z @ Inverse ) ) ) ).

% group_axioms.intro
thf(fact_8053_group__axioms__def,axiom,
    ! [A: $tType] :
      ( ( group_axioms @ A )
      = ( ^ [F3: A > A > A,Z6: A,Inverse2: A > A] :
            ( ! [A3: A] :
                ( ( F3 @ Z6 @ A3 )
                = A3 )
            & ! [A3: A] :
                ( ( F3 @ ( Inverse2 @ A3 ) @ A3 )
                = Z6 ) ) ) ) ).

% group_axioms_def
thf(fact_8054_group__def,axiom,
    ! [A: $tType] :
      ( ( group @ A )
      = ( ^ [F3: A > A > A,Z6: A,Inverse2: A > A] :
            ( ( semigroup @ A @ F3 )
            & ( group_axioms @ A @ F3 @ Z6 @ Inverse2 ) ) ) ) ).

% group_def
thf(fact_8055_group_Ointro,axiom,
    ! [A: $tType,F2: A > A > A,Z: A,Inverse: A > A] :
      ( ( semigroup @ A @ F2 )
     => ( ( group_axioms @ A @ F2 @ Z @ Inverse )
       => ( group @ A @ F2 @ Z @ Inverse ) ) ) ).

% group.intro
thf(fact_8056_max_Osemigroup__axioms,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( semigroup @ A @ ( ord_max @ A ) ) ) ).

% max.semigroup_axioms
thf(fact_8057_group_Oaxioms_I1_J,axiom,
    ! [A: $tType,F2: A > A > A,Z: A,Inverse: A > A] :
      ( ( group @ A @ F2 @ Z @ Inverse )
     => ( semigroup @ A @ F2 ) ) ).

% group.axioms(1)
thf(fact_8058_inf_Osemigroup__axioms,axiom,
    ! [A: $tType] :
      ( ( semilattice_inf @ A )
     => ( semigroup @ A @ ( inf_inf @ A ) ) ) ).

% inf.semigroup_axioms
thf(fact_8059_min_Osemigroup__axioms,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ( semigroup @ A @ ( ord_min @ A ) ) ) ).

% min.semigroup_axioms
thf(fact_8060_xor_Osemigroup__axioms,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( semigroup @ A @ ( bit_se5824344971392196577ns_xor @ A ) ) ) ).

% xor.semigroup_axioms
thf(fact_8061_semigroup__def,axiom,
    ! [A: $tType] :
      ( ( semigroup @ A )
      = ( ^ [F3: A > A > A] :
          ! [A3: A,B3: A,C4: A] :
            ( ( F3 @ ( F3 @ A3 @ B3 ) @ C4 )
            = ( F3 @ A3 @ ( F3 @ B3 @ C4 ) ) ) ) ) ).

% semigroup_def
thf(fact_8062_semigroup_Ointro,axiom,
    ! [A: $tType,F2: A > A > A] :
      ( ! [A5: A,B4: A,C3: A] :
          ( ( F2 @ ( F2 @ A5 @ B4 ) @ C3 )
          = ( F2 @ A5 @ ( F2 @ B4 @ C3 ) ) )
     => ( semigroup @ A @ F2 ) ) ).

% semigroup.intro
thf(fact_8063_semigroup_Oassoc,axiom,
    ! [A: $tType,F2: A > A > A,A2: A,B2: A,C2: A] :
      ( ( semigroup @ A @ F2 )
     => ( ( F2 @ ( F2 @ A2 @ B2 ) @ C2 )
        = ( F2 @ A2 @ ( F2 @ B2 @ C2 ) ) ) ) ).

% semigroup.assoc
thf(fact_8064_or_Osemigroup__axioms,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( semigroup @ A @ ( bit_se1065995026697491101ons_or @ A ) ) ) ).

% or.semigroup_axioms
thf(fact_8065_and_Osemigroup__axioms,axiom,
    ! [A: $tType] :
      ( ( bit_se359711467146920520ations @ A )
     => ( semigroup @ A @ ( bit_se5824344872417868541ns_and @ A ) ) ) ).

% and.semigroup_axioms
thf(fact_8066_monoid_Oaxioms_I1_J,axiom,
    ! [A: $tType,F2: A > A > A,Z: A] :
      ( ( monoid @ A @ F2 @ Z )
     => ( semigroup @ A @ F2 ) ) ).

% monoid.axioms(1)
thf(fact_8067_sup_Osemigroup__axioms,axiom,
    ! [A: $tType] :
      ( ( semilattice_sup @ A )
     => ( semigroup @ A @ ( sup_sup @ A ) ) ) ).

% sup.semigroup_axioms
thf(fact_8068_add_Osemigroup__axioms,axiom,
    ! [A: $tType] :
      ( ( semigroup_add @ A )
     => ( semigroup @ A @ ( plus_plus @ A ) ) ) ).

% add.semigroup_axioms
thf(fact_8069_mult_Osemigroup__axioms,axiom,
    ! [A: $tType] :
      ( ( semigroup_mult @ A )
     => ( semigroup @ A @ ( times_times @ A ) ) ) ).

% mult.semigroup_axioms
thf(fact_8070_monoid__def,axiom,
    ! [A: $tType] :
      ( ( monoid @ A )
      = ( ^ [F3: A > A > A,Z6: A] :
            ( ( semigroup @ A @ F3 )
            & ( monoid_axioms @ A @ F3 @ Z6 ) ) ) ) ).

% monoid_def
thf(fact_8071_monoid_Ointro,axiom,
    ! [A: $tType,F2: A > A > A,Z: A] :
      ( ( semigroup @ A @ F2 )
     => ( ( monoid_axioms @ A @ F2 @ Z )
       => ( monoid @ A @ F2 @ Z ) ) ) ).

% monoid.intro
thf(fact_8072_monoid__axioms_Ointro,axiom,
    ! [A: $tType,F2: A > A > A,Z: A] :
      ( ! [A5: A] :
          ( ( F2 @ Z @ A5 )
          = A5 )
     => ( ! [A5: A] :
            ( ( F2 @ A5 @ Z )
            = A5 )
       => ( monoid_axioms @ A @ F2 @ Z ) ) ) ).

% monoid_axioms.intro
thf(fact_8073_monoid__axioms__def,axiom,
    ! [A: $tType] :
      ( ( monoid_axioms @ A )
      = ( ^ [F3: A > A > A,Z6: A] :
            ( ! [A3: A] :
                ( ( F3 @ Z6 @ A3 )
                = A3 )
            & ! [A3: A] :
                ( ( F3 @ A3 @ Z6 )
                = A3 ) ) ) ) ).

% monoid_axioms_def
thf(fact_8074_monoid_Oaxioms_I2_J,axiom,
    ! [A: $tType,F2: A > A > A,Z: A] :
      ( ( monoid @ A @ F2 @ Z )
     => ( monoid_axioms @ A @ F2 @ Z ) ) ).

% monoid.axioms(2)
thf(fact_8075_Quotient3__real,axiom,
    quotient3 @ ( nat > rat ) @ real @ realrel @ real2 @ rep_real ).

% Quotient3_real
thf(fact_8076_disjnt__ge__max,axiom,
    ! [A: $tType] :
      ( ( linorder @ A )
     => ! [Y7: set @ A,X7: set @ A] :
          ( ( finite_finite @ A @ Y7 )
         => ( ! [X3: A] :
                ( ( member @ A @ X3 @ X7 )
               => ( ord_less @ A @ ( lattic643756798349783984er_Max @ A @ Y7 ) @ X3 ) )
           => ( disjnt @ A @ X7 @ Y7 ) ) ) ) ).

% disjnt_ge_max
thf(fact_8077_sum__encode__def,axiom,
    ( nat_sum_encode
    = ( sum_case_sum @ nat @ nat @ nat @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) )
      @ ^ [B3: nat] : ( suc @ ( times_times @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ B3 ) ) ) ) ).

% sum_encode_def
thf(fact_8078_nths__nths,axiom,
    ! [A: $tType,Xs: list @ A,A4: set @ nat,B7: set @ nat] :
      ( ( nths @ A @ ( nths @ A @ Xs @ A4 ) @ B7 )
      = ( nths @ A @ Xs
        @ ( collect @ nat
          @ ^ [I4: nat] :
              ( ( member @ nat @ I4 @ A4 )
              & ( member @ nat
                @ ( finite_card @ nat
                  @ ( collect @ nat
                    @ ^ [I8: nat] :
                        ( ( member @ nat @ I8 @ A4 )
                        & ( ord_less @ nat @ I8 @ I4 ) ) ) )
                @ B7 ) ) ) ) ) ).

% nths_nths
thf(fact_8079_Bex__def__raw,axiom,
    ! [A: $tType] :
      ( ( bex @ A )
      = ( ^ [A7: set @ A,P3: A > $o] :
          ? [X2: A] :
            ( ( member @ A @ X2 @ A7 )
            & ( P3 @ X2 ) ) ) ) ).

% Bex_def_raw

% Type constructors (858)
thf(tcon_Extended__Nat_Oenat___Lattices_Obounded__lattice,axiom,
    bounded_lattice @ extended_enat ).

thf(tcon_Filter_Ofilter___Lattices_Obounded__lattice_1,axiom,
    ! [A10: $tType] : ( bounded_lattice @ ( filter @ A10 ) ) ).

thf(tcon_HOL_Obool___Lattices_Obounded__lattice_2,axiom,
    bounded_lattice @ $o ).

thf(tcon_Set_Oset___Lattices_Obounded__lattice_3,axiom,
    ! [A10: $tType] : ( bounded_lattice @ ( set @ A10 ) ) ).

thf(tcon_fun___Lattices_Obounded__lattice_4,axiom,
    ! [A10: $tType,A16: $tType] :
      ( ( bounded_lattice @ A16 )
     => ( bounded_lattice @ ( A10 > A16 ) ) ) ).

thf(tcon_fun___Countable__Complete__Lattices_Ocountable__complete__distrib__lattice,axiom,
    ! [A10: $tType,A16: $tType] :
      ( ( comple592849572758109894attice @ A16 )
     => ( counta4013691401010221786attice @ ( A10 > A16 ) ) ) ).

thf(tcon_fun___Conditionally__Complete__Lattices_Oconditionally__complete__lattice,axiom,
    ! [A10: $tType,A16: $tType] :
      ( ( comple6319245703460814977attice @ A16 )
     => ( condit1219197933456340205attice @ ( A10 > A16 ) ) ) ).

thf(tcon_fun___Countable__Complete__Lattices_Ocountable__complete__lattice,axiom,
    ! [A10: $tType,A16: $tType] :
      ( ( counta3822494911875563373attice @ A16 )
     => ( counta3822494911875563373attice @ ( A10 > A16 ) ) ) ).

thf(tcon_fun___Complete__Lattices_Ocomplete__distrib__lattice,axiom,
    ! [A10: $tType,A16: $tType] :
      ( ( comple592849572758109894attice @ A16 )
     => ( comple592849572758109894attice @ ( A10 > A16 ) ) ) ).

thf(tcon_fun___Lattices_Obounded__semilattice__sup__bot,axiom,
    ! [A10: $tType,A16: $tType] :
      ( ( bounded_lattice @ A16 )
     => ( bounde4967611905675639751up_bot @ ( A10 > A16 ) ) ) ).

thf(tcon_fun___Lattices_Obounded__semilattice__inf__top,axiom,
    ! [A10: $tType,A16: $tType] :
      ( ( bounded_lattice @ A16 )
     => ( bounde4346867609351753570nf_top @ ( A10 > A16 ) ) ) ).

thf(tcon_fun___Complete__Lattices_Ocomplete__lattice,axiom,
    ! [A10: $tType,A16: $tType] :
      ( ( comple6319245703460814977attice @ A16 )
     => ( comple6319245703460814977attice @ ( A10 > A16 ) ) ) ).

thf(tcon_fun___Boolean__Algebras_Oboolean__algebra,axiom,
    ! [A10: $tType,A16: $tType] :
      ( ( boolea8198339166811842893lgebra @ A16 )
     => ( boolea8198339166811842893lgebra @ ( A10 > A16 ) ) ) ).

thf(tcon_fun___Lattices_Obounded__lattice__top,axiom,
    ! [A10: $tType,A16: $tType] :
      ( ( bounded_lattice @ A16 )
     => ( bounded_lattice_top @ ( A10 > A16 ) ) ) ).

thf(tcon_fun___Lattices_Obounded__lattice__bot,axiom,
    ! [A10: $tType,A16: $tType] :
      ( ( bounded_lattice @ A16 )
     => ( bounded_lattice_bot @ ( A10 > A16 ) ) ) ).

thf(tcon_fun___Complete__Partial__Order_Occpo,axiom,
    ! [A10: $tType,A16: $tType] :
      ( ( comple6319245703460814977attice @ A16 )
     => ( comple9053668089753744459l_ccpo @ ( A10 > A16 ) ) ) ).

thf(tcon_fun___Lattices_Osemilattice__sup,axiom,
    ! [A10: $tType,A16: $tType] :
      ( ( semilattice_sup @ A16 )
     => ( semilattice_sup @ ( A10 > A16 ) ) ) ).

thf(tcon_fun___Lattices_Osemilattice__inf,axiom,
    ! [A10: $tType,A16: $tType] :
      ( ( semilattice_inf @ A16 )
     => ( semilattice_inf @ ( A10 > A16 ) ) ) ).

thf(tcon_fun___Lattices_Odistrib__lattice,axiom,
    ! [A10: $tType,A16: $tType] :
      ( ( distrib_lattice @ A16 )
     => ( distrib_lattice @ ( A10 > A16 ) ) ) ).

thf(tcon_fun___Orderings_Oorder__top,axiom,
    ! [A10: $tType,A16: $tType] :
      ( ( order_top @ A16 )
     => ( order_top @ ( A10 > A16 ) ) ) ).

thf(tcon_fun___Orderings_Oorder__bot,axiom,
    ! [A10: $tType,A16: $tType] :
      ( ( order_bot @ A16 )
     => ( order_bot @ ( A10 > A16 ) ) ) ).

thf(tcon_fun___Orderings_Opreorder,axiom,
    ! [A10: $tType,A16: $tType] :
      ( ( preorder @ A16 )
     => ( preorder @ ( A10 > A16 ) ) ) ).

thf(tcon_fun___Lattices_Olattice,axiom,
    ! [A10: $tType,A16: $tType] :
      ( ( lattice @ A16 )
     => ( lattice @ ( A10 > A16 ) ) ) ).

thf(tcon_fun___Orderings_Oorder,axiom,
    ! [A10: $tType,A16: $tType] :
      ( ( order @ A16 )
     => ( order @ ( A10 > A16 ) ) ) ).

thf(tcon_fun___Orderings_Otop,axiom,
    ! [A10: $tType,A16: $tType] :
      ( ( top @ A16 )
     => ( top @ ( A10 > A16 ) ) ) ).

thf(tcon_fun___Orderings_Oord,axiom,
    ! [A10: $tType,A16: $tType] :
      ( ( ord @ A16 )
     => ( ord @ ( A10 > A16 ) ) ) ).

thf(tcon_fun___Orderings_Obot,axiom,
    ! [A10: $tType,A16: $tType] :
      ( ( bot @ A16 )
     => ( bot @ ( A10 > A16 ) ) ) ).

thf(tcon_fun___Groups_Ouminus,axiom,
    ! [A10: $tType,A16: $tType] :
      ( ( uminus @ A16 )
     => ( uminus @ ( A10 > A16 ) ) ) ).

thf(tcon_fun___Groups_Ominus,axiom,
    ! [A10: $tType,A16: $tType] :
      ( ( minus @ A16 )
     => ( minus @ ( A10 > A16 ) ) ) ).

thf(tcon_Int_Oint___Conditionally__Complete__Lattices_Oconditionally__complete__linorder,axiom,
    condit6923001295902523014norder @ int ).

thf(tcon_Int_Oint___Conditionally__Complete__Lattices_Oconditionally__complete__lattice_5,axiom,
    condit1219197933456340205attice @ int ).

thf(tcon_Int_Oint___Bit__Operations_Ounique__euclidean__semiring__with__bit__operations,axiom,
    bit_un5681908812861735899ations @ int ).

thf(tcon_Int_Oint___Semiring__Normalization_Ocomm__semiring__1__cancel__crossproduct,axiom,
    semiri1453513574482234551roduct @ int ).

thf(tcon_Int_Oint___Euclidean__Division_Ounique__euclidean__semiring__with__nat,axiom,
    euclid5411537665997757685th_nat @ int ).

thf(tcon_Int_Oint___Euclidean__Division_Ounique__euclidean__ring__with__nat,axiom,
    euclid8789492081693882211th_nat @ int ).

thf(tcon_Int_Oint___Groups_Oordered__ab__semigroup__monoid__add__imp__le,axiom,
    ordere1937475149494474687imp_le @ int ).

thf(tcon_Int_Oint___Euclidean__Division_Ounique__euclidean__semiring,axiom,
    euclid3128863361964157862miring @ int ).

thf(tcon_Int_Oint___Euclidean__Division_Oeuclidean__semiring__cancel,axiom,
    euclid4440199948858584721cancel @ int ).

thf(tcon_Int_Oint___Rings_Onormalization__semidom__multiplicative,axiom,
    normal6328177297339901930cative @ int ).

thf(tcon_Int_Oint___Divides_Ounique__euclidean__semiring__numeral,axiom,
    unique1627219031080169319umeral @ int ).

thf(tcon_Int_Oint___Euclidean__Division_Oeuclidean__ring__cancel,axiom,
    euclid8851590272496341667cancel @ int ).

thf(tcon_Int_Oint___Rings_Osemiring__no__zero__divisors__cancel,axiom,
    semiri6575147826004484403cancel @ int ).

thf(tcon_Int_Oint___Groups_Ostrict__ordered__ab__semigroup__add,axiom,
    strict9044650504122735259up_add @ int ).

thf(tcon_Int_Oint___Groups_Oordered__cancel__ab__semigroup__add,axiom,
    ordere580206878836729694up_add @ int ).

thf(tcon_Int_Oint___Groups_Oordered__ab__semigroup__add__imp__le,axiom,
    ordere2412721322843649153imp_le @ int ).

thf(tcon_Int_Oint___Bit__Operations_Osemiring__bit__operations,axiom,
    bit_se359711467146920520ations @ int ).

thf(tcon_Int_Oint___Rings_Olinordered__comm__semiring__strict,axiom,
    linord2810124833399127020strict @ int ).

thf(tcon_Int_Oint___Groups_Ostrict__ordered__comm__monoid__add,axiom,
    strict7427464778891057005id_add @ int ).

thf(tcon_Int_Oint___Groups_Oordered__cancel__comm__monoid__add,axiom,
    ordere8940638589300402666id_add @ int ).

thf(tcon_Int_Oint___Euclidean__Division_Oeuclidean__semiring,axiom,
    euclid3725896446679973847miring @ int ).

thf(tcon_Int_Oint___Topological__Spaces_Otopological__space,axiom,
    topolo4958980785337419405_space @ int ).

thf(tcon_Int_Oint___Topological__Spaces_Olinorder__topology,axiom,
    topolo1944317154257567458pology @ int ).

thf(tcon_Int_Oint___Rings_Olinordered__semiring__1__strict,axiom,
    linord715952674999750819strict @ int ).

thf(tcon_Int_Oint___Limits_Otopological__comm__monoid__add,axiom,
    topolo5987344860129210374id_add @ int ).

thf(tcon_Int_Oint___Groups_Olinordered__ab__semigroup__add,axiom,
    linord4140545234300271783up_add @ int ).

thf(tcon_Int_Oint___Bit__Operations_Oring__bit__operations,axiom,
    bit_ri3973907225187159222ations @ int ).

thf(tcon_Int_Oint___Topological__Spaces_Oorder__topology,axiom,
    topolo2564578578187576103pology @ int ).

thf(tcon_Int_Oint___Rings_Osemiring__1__no__zero__divisors,axiom,
    semiri2026040879449505780visors @ int ).

thf(tcon_Int_Oint___Rings_Olinordered__nonzero__semiring,axiom,
    linord181362715937106298miring @ int ).

thf(tcon_Int_Oint___Limits_Otopological__semigroup__mult,axiom,
    topolo4211221413907600880p_mult @ int ).

thf(tcon_Int_Oint___Rings_Osemidom__divide__unit__factor,axiom,
    semido2269285787275462019factor @ int ).

thf(tcon_Int_Oint___Rings_Olinordered__semiring__strict,axiom,
    linord8928482502909563296strict @ int ).

thf(tcon_Int_Oint___Rings_Osemiring__no__zero__divisors,axiom,
    semiri3467727345109120633visors @ int ).

thf(tcon_Int_Oint___Groups_Oordered__ab__semigroup__add,axiom,
    ordere6658533253407199908up_add @ int ).

thf(tcon_Int_Oint___Groups_Oordered__ab__group__add__abs,axiom,
    ordere166539214618696060dd_abs @ int ).

thf(tcon_Int_Oint___GCD_Osemiring__gcd__mult__normalize,axiom,
    semiri6843258321239162965malize @ int ).

thf(tcon_Int_Oint___Limits_Otopological__monoid__mult,axiom,
    topolo1898628316856586783d_mult @ int ).

thf(tcon_Int_Oint___Groups_Oordered__comm__monoid__add,axiom,
    ordere6911136660526730532id_add @ int ).

thf(tcon_Int_Oint___Groups_Olinordered__ab__group__add,axiom,
    linord5086331880401160121up_add @ int ).

thf(tcon_Int_Oint___Groups_Ocancel__ab__semigroup__add,axiom,
    cancel2418104881723323429up_add @ int ).

thf(tcon_Int_Oint___Rings_Oring__1__no__zero__divisors,axiom,
    ring_15535105094025558882visors @ int ).

thf(tcon_Int_Oint___Limits_Otopological__monoid__add,axiom,
    topolo6943815403480290642id_add @ int ).

thf(tcon_Int_Oint___Groups_Ocancel__comm__monoid__add,axiom,
    cancel1802427076303600483id_add @ int ).

thf(tcon_Int_Oint___Rings_Olinordered__ring__strict,axiom,
    linord4710134922213307826strict @ int ).

thf(tcon_Int_Oint___Bit__Operations_Osemiring__bits,axiom,
    bit_semiring_bits @ int ).

thf(tcon_Int_Oint___Topological__Spaces_Ot2__space,axiom,
    topological_t2_space @ int ).

thf(tcon_Int_Oint___Rings_Oordered__comm__semiring,axiom,
    ordere2520102378445227354miring @ int ).

thf(tcon_Int_Oint___Rings_Onormalization__semidom,axiom,
    normal8620421768224518004emidom @ int ).

thf(tcon_Int_Oint___Rings_Olinordered__semiring__1,axiom,
    linord6961819062388156250ring_1 @ int ).

thf(tcon_Int_Oint___Groups_Oordered__ab__group__add,axiom,
    ordered_ab_group_add @ int ).

thf(tcon_Int_Oint___Groups_Ocancel__semigroup__add,axiom,
    cancel_semigroup_add @ int ).

thf(tcon_Int_Oint___Rings_Olinordered__semiring,axiom,
    linordered_semiring @ int ).

thf(tcon_Int_Oint___Rings_Oordered__semiring__0,axiom,
    ordered_semiring_0 @ int ).

thf(tcon_Int_Oint___Rings_Olinordered__semidom,axiom,
    linordered_semidom @ int ).

thf(tcon_Int_Oint___Lattices_Osemilattice__sup_6,axiom,
    semilattice_sup @ int ).

thf(tcon_Int_Oint___Lattices_Osemilattice__inf_7,axiom,
    semilattice_inf @ int ).

thf(tcon_Int_Oint___Lattices_Odistrib__lattice_8,axiom,
    distrib_lattice @ int ).

thf(tcon_Int_Oint___Groups_Oab__semigroup__mult,axiom,
    ab_semigroup_mult @ int ).

thf(tcon_Int_Oint___Rings_Osemiring__1__cancel,axiom,
    semiring_1_cancel @ int ).

thf(tcon_Int_Oint___Rings_Oalgebraic__semidom,axiom,
    algebraic_semidom @ int ).

thf(tcon_Int_Oint___Groups_Ocomm__monoid__mult,axiom,
    comm_monoid_mult @ int ).

thf(tcon_Int_Oint___Groups_Oab__semigroup__add,axiom,
    ab_semigroup_add @ int ).

thf(tcon_Int_Oint___Rings_Oordered__semiring,axiom,
    ordered_semiring @ int ).

thf(tcon_Int_Oint___Rings_Oordered__ring__abs,axiom,
    ordered_ring_abs @ int ).

thf(tcon_Int_Oint___Parity_Osemiring__parity,axiom,
    semiring_parity @ int ).

thf(tcon_Int_Oint___Groups_Ocomm__monoid__add,axiom,
    comm_monoid_add @ int ).

thf(tcon_Int_Oint___Rings_Osemiring__modulo,axiom,
    semiring_modulo @ int ).

thf(tcon_Int_Oint___Rings_Olinordered__ring,axiom,
    linordered_ring @ int ).

thf(tcon_Int_Oint___Rings_Olinordered__idom,axiom,
    linordered_idom @ int ).

thf(tcon_Int_Oint___Rings_Ocomm__semiring__1,axiom,
    comm_semiring_1 @ int ).

thf(tcon_Int_Oint___Rings_Ocomm__semiring__0,axiom,
    comm_semiring_0 @ int ).

thf(tcon_Int_Oint___Groups_Osemigroup__mult,axiom,
    semigroup_mult @ int ).

thf(tcon_Int_Oint___Rings_Osemidom__modulo,axiom,
    semidom_modulo @ int ).

thf(tcon_Int_Oint___Rings_Osemidom__divide,axiom,
    semidom_divide @ int ).

thf(tcon_Int_Oint___Num_Osemiring__numeral,axiom,
    semiring_numeral @ int ).

thf(tcon_Int_Oint___Groups_Osemigroup__add,axiom,
    semigroup_add @ int ).

thf(tcon_Int_Oint___Rings_Ozero__less__one,axiom,
    zero_less_one @ int ).

thf(tcon_Int_Oint___Nat_Osemiring__char__0,axiom,
    semiring_char_0 @ int ).

thf(tcon_Int_Oint___Groups_Oab__group__add,axiom,
    ab_group_add @ int ).

thf(tcon_Int_Oint___Rings_Ozero__neq__one,axiom,
    zero_neq_one @ int ).

thf(tcon_Int_Oint___Rings_Oordered__ring,axiom,
    ordered_ring @ int ).

thf(tcon_Int_Oint___Rings_Oidom__abs__sgn,axiom,
    idom_abs_sgn @ int ).

thf(tcon_Int_Oint___Parity_Oring__parity,axiom,
    ring_parity @ int ).

thf(tcon_Int_Oint___Orderings_Opreorder_9,axiom,
    preorder @ int ).

thf(tcon_Int_Oint___Orderings_Olinorder,axiom,
    linorder @ int ).

thf(tcon_Int_Oint___Groups_Omonoid__mult,axiom,
    monoid_mult @ int ).

thf(tcon_Int_Oint___Rings_Oidom__divide,axiom,
    idom_divide @ int ).

thf(tcon_Int_Oint___Rings_Ocomm__ring__1,axiom,
    comm_ring_1 @ int ).

thf(tcon_Int_Oint___Groups_Omonoid__add,axiom,
    monoid_add @ int ).

thf(tcon_Int_Oint___Rings_Osemiring__1,axiom,
    semiring_1 @ int ).

thf(tcon_Int_Oint___Rings_Osemiring__0,axiom,
    semiring_0 @ int ).

thf(tcon_Int_Oint___Orderings_Ono__top,axiom,
    no_top @ int ).

thf(tcon_Int_Oint___Orderings_Ono__bot,axiom,
    no_bot @ int ).

thf(tcon_Int_Oint___Lattices_Olattice_10,axiom,
    lattice @ int ).

thf(tcon_Int_Oint___Groups_Ogroup__add,axiom,
    group_add @ int ).

thf(tcon_Int_Oint___GCD_Osemiring__gcd,axiom,
    semiring_gcd @ int ).

thf(tcon_Int_Oint___GCD_Osemiring__Gcd,axiom,
    semiring_Gcd @ int ).

thf(tcon_Int_Oint___Rings_Omult__zero,axiom,
    mult_zero @ int ).

thf(tcon_Int_Oint___Rings_Ocomm__ring,axiom,
    comm_ring @ int ).

thf(tcon_Int_Oint___Orderings_Oorder_11,axiom,
    order @ int ).

thf(tcon_Int_Oint___Num_Oneg__numeral,axiom,
    neg_numeral @ int ).

thf(tcon_Int_Oint___Nat_Oring__char__0,axiom,
    ring_char_0 @ int ).

thf(tcon_Int_Oint___Rings_Osemiring,axiom,
    semiring @ int ).

thf(tcon_Int_Oint___Rings_Osemidom,axiom,
    semidom @ int ).

thf(tcon_Int_Oint___Orderings_Oord_12,axiom,
    ord @ int ).

thf(tcon_Int_Oint___Groups_Ouminus_13,axiom,
    uminus @ int ).

thf(tcon_Int_Oint___Rings_Oring__1,axiom,
    ring_1 @ int ).

thf(tcon_Int_Oint___Rings_Oabs__if,axiom,
    abs_if @ int ).

thf(tcon_Int_Oint___Groups_Ominus_14,axiom,
    minus @ int ).

thf(tcon_Int_Oint___GCD_Oring__gcd,axiom,
    ring_gcd @ int ).

thf(tcon_Int_Oint___Power_Opower,axiom,
    power @ int ).

thf(tcon_Int_Oint___Num_Onumeral,axiom,
    numeral @ int ).

thf(tcon_Int_Oint___Groups_Ozero,axiom,
    zero @ int ).

thf(tcon_Int_Oint___Groups_Oplus,axiom,
    plus @ int ).

thf(tcon_Int_Oint___Rings_Oring,axiom,
    ring @ int ).

thf(tcon_Int_Oint___Rings_Oidom,axiom,
    idom @ int ).

thf(tcon_Int_Oint___Groups_Oone,axiom,
    one @ int ).

thf(tcon_Int_Oint___Rings_Odvd,axiom,
    dvd @ int ).

thf(tcon_Nat_Onat___Conditionally__Complete__Lattices_Oconditionally__complete__linorder_15,axiom,
    condit6923001295902523014norder @ nat ).

thf(tcon_Nat_Onat___Conditionally__Complete__Lattices_Oconditionally__complete__lattice_16,axiom,
    condit1219197933456340205attice @ nat ).

thf(tcon_Nat_Onat___Bit__Operations_Ounique__euclidean__semiring__with__bit__operations_17,axiom,
    bit_un5681908812861735899ations @ nat ).

thf(tcon_Nat_Onat___Semiring__Normalization_Ocomm__semiring__1__cancel__crossproduct_18,axiom,
    semiri1453513574482234551roduct @ nat ).

thf(tcon_Nat_Onat___Euclidean__Division_Ounique__euclidean__semiring__with__nat_19,axiom,
    euclid5411537665997757685th_nat @ nat ).

thf(tcon_Nat_Onat___Groups_Oordered__ab__semigroup__monoid__add__imp__le_20,axiom,
    ordere1937475149494474687imp_le @ nat ).

thf(tcon_Nat_Onat___Euclidean__Division_Ounique__euclidean__semiring_21,axiom,
    euclid3128863361964157862miring @ nat ).

thf(tcon_Nat_Onat___Euclidean__Division_Oeuclidean__semiring__cancel_22,axiom,
    euclid4440199948858584721cancel @ nat ).

thf(tcon_Nat_Onat___Rings_Onormalization__semidom__multiplicative_23,axiom,
    normal6328177297339901930cative @ nat ).

thf(tcon_Nat_Onat___Divides_Ounique__euclidean__semiring__numeral_24,axiom,
    unique1627219031080169319umeral @ nat ).

thf(tcon_Nat_Onat___Rings_Osemiring__no__zero__divisors__cancel_25,axiom,
    semiri6575147826004484403cancel @ nat ).

thf(tcon_Nat_Onat___Groups_Ostrict__ordered__ab__semigroup__add_26,axiom,
    strict9044650504122735259up_add @ nat ).

thf(tcon_Nat_Onat___Groups_Oordered__cancel__comm__monoid__diff,axiom,
    ordere1170586879665033532d_diff @ nat ).

thf(tcon_Nat_Onat___Groups_Oordered__cancel__ab__semigroup__add_27,axiom,
    ordere580206878836729694up_add @ nat ).

thf(tcon_Nat_Onat___Groups_Oordered__ab__semigroup__add__imp__le_28,axiom,
    ordere2412721322843649153imp_le @ nat ).

thf(tcon_Nat_Onat___Bit__Operations_Osemiring__bit__operations_29,axiom,
    bit_se359711467146920520ations @ nat ).

thf(tcon_Nat_Onat___Rings_Olinordered__comm__semiring__strict_30,axiom,
    linord2810124833399127020strict @ nat ).

thf(tcon_Nat_Onat___Groups_Ostrict__ordered__comm__monoid__add_31,axiom,
    strict7427464778891057005id_add @ nat ).

thf(tcon_Nat_Onat___Groups_Oordered__cancel__comm__monoid__add_32,axiom,
    ordere8940638589300402666id_add @ nat ).

thf(tcon_Nat_Onat___Groups_Ocanonically__ordered__monoid__add,axiom,
    canoni5634975068530333245id_add @ nat ).

thf(tcon_Nat_Onat___Euclidean__Division_Oeuclidean__semiring_33,axiom,
    euclid3725896446679973847miring @ nat ).

thf(tcon_Nat_Onat___Topological__Spaces_Otopological__space_34,axiom,
    topolo4958980785337419405_space @ nat ).

thf(tcon_Nat_Onat___Topological__Spaces_Olinorder__topology_35,axiom,
    topolo1944317154257567458pology @ nat ).

thf(tcon_Nat_Onat___Limits_Otopological__comm__monoid__add_36,axiom,
    topolo5987344860129210374id_add @ nat ).

thf(tcon_Nat_Onat___Groups_Olinordered__ab__semigroup__add_37,axiom,
    linord4140545234300271783up_add @ nat ).

thf(tcon_Nat_Onat___Topological__Spaces_Oorder__topology_38,axiom,
    topolo2564578578187576103pology @ nat ).

thf(tcon_Nat_Onat___Rings_Osemiring__1__no__zero__divisors_39,axiom,
    semiri2026040879449505780visors @ nat ).

thf(tcon_Nat_Onat___Rings_Olinordered__nonzero__semiring_40,axiom,
    linord181362715937106298miring @ nat ).

thf(tcon_Nat_Onat___Limits_Otopological__semigroup__mult_41,axiom,
    topolo4211221413907600880p_mult @ nat ).

thf(tcon_Nat_Onat___Rings_Osemidom__divide__unit__factor_42,axiom,
    semido2269285787275462019factor @ nat ).

thf(tcon_Nat_Onat___Rings_Olinordered__semiring__strict_43,axiom,
    linord8928482502909563296strict @ nat ).

thf(tcon_Nat_Onat___Rings_Osemiring__no__zero__divisors_44,axiom,
    semiri3467727345109120633visors @ nat ).

thf(tcon_Nat_Onat___Groups_Oordered__ab__semigroup__add_45,axiom,
    ordere6658533253407199908up_add @ nat ).

thf(tcon_Nat_Onat___GCD_Osemiring__gcd__mult__normalize_46,axiom,
    semiri6843258321239162965malize @ nat ).

thf(tcon_Nat_Onat___Limits_Otopological__monoid__mult_47,axiom,
    topolo1898628316856586783d_mult @ nat ).

thf(tcon_Nat_Onat___Groups_Oordered__comm__monoid__add_48,axiom,
    ordere6911136660526730532id_add @ nat ).

thf(tcon_Nat_Onat___Groups_Ocancel__ab__semigroup__add_49,axiom,
    cancel2418104881723323429up_add @ nat ).

thf(tcon_Nat_Onat___Limits_Otopological__monoid__add_50,axiom,
    topolo6943815403480290642id_add @ nat ).

thf(tcon_Nat_Onat___Groups_Ocancel__comm__monoid__add_51,axiom,
    cancel1802427076303600483id_add @ nat ).

thf(tcon_Nat_Onat___Bit__Operations_Osemiring__bits_52,axiom,
    bit_semiring_bits @ nat ).

thf(tcon_Nat_Onat___Topological__Spaces_Ot2__space_53,axiom,
    topological_t2_space @ nat ).

thf(tcon_Nat_Onat___Rings_Oordered__comm__semiring_54,axiom,
    ordere2520102378445227354miring @ nat ).

thf(tcon_Nat_Onat___Rings_Onormalization__semidom_55,axiom,
    normal8620421768224518004emidom @ nat ).

thf(tcon_Nat_Onat___Groups_Ocancel__semigroup__add_56,axiom,
    cancel_semigroup_add @ nat ).

thf(tcon_Nat_Onat___Rings_Olinordered__semiring_57,axiom,
    linordered_semiring @ nat ).

thf(tcon_Nat_Onat___Rings_Oordered__semiring__0_58,axiom,
    ordered_semiring_0 @ nat ).

thf(tcon_Nat_Onat___Rings_Olinordered__semidom_59,axiom,
    linordered_semidom @ nat ).

thf(tcon_Nat_Onat___Lattices_Osemilattice__sup_60,axiom,
    semilattice_sup @ nat ).

thf(tcon_Nat_Onat___Lattices_Osemilattice__inf_61,axiom,
    semilattice_inf @ nat ).

thf(tcon_Nat_Onat___Lattices_Odistrib__lattice_62,axiom,
    distrib_lattice @ nat ).

thf(tcon_Nat_Onat___Groups_Oab__semigroup__mult_63,axiom,
    ab_semigroup_mult @ nat ).

thf(tcon_Nat_Onat___Rings_Osemiring__1__cancel_64,axiom,
    semiring_1_cancel @ nat ).

thf(tcon_Nat_Onat___Rings_Oalgebraic__semidom_65,axiom,
    algebraic_semidom @ nat ).

thf(tcon_Nat_Onat___Groups_Ocomm__monoid__mult_66,axiom,
    comm_monoid_mult @ nat ).

thf(tcon_Nat_Onat___Groups_Ocomm__monoid__diff,axiom,
    comm_monoid_diff @ nat ).

thf(tcon_Nat_Onat___Groups_Oab__semigroup__add_67,axiom,
    ab_semigroup_add @ nat ).

thf(tcon_Nat_Onat___Rings_Oordered__semiring_68,axiom,
    ordered_semiring @ nat ).

thf(tcon_Nat_Onat___Parity_Osemiring__parity_69,axiom,
    semiring_parity @ nat ).

thf(tcon_Nat_Onat___Groups_Ocomm__monoid__add_70,axiom,
    comm_monoid_add @ nat ).

thf(tcon_Nat_Onat___Rings_Osemiring__modulo_71,axiom,
    semiring_modulo @ nat ).

thf(tcon_Nat_Onat___Rings_Ocomm__semiring__1_72,axiom,
    comm_semiring_1 @ nat ).

thf(tcon_Nat_Onat___Rings_Ocomm__semiring__0_73,axiom,
    comm_semiring_0 @ nat ).

thf(tcon_Nat_Onat___Groups_Osemigroup__mult_74,axiom,
    semigroup_mult @ nat ).

thf(tcon_Nat_Onat___Rings_Osemidom__modulo_75,axiom,
    semidom_modulo @ nat ).

thf(tcon_Nat_Onat___Rings_Osemidom__divide_76,axiom,
    semidom_divide @ nat ).

thf(tcon_Nat_Onat___Num_Osemiring__numeral_77,axiom,
    semiring_numeral @ nat ).

thf(tcon_Nat_Onat___Groups_Osemigroup__add_78,axiom,
    semigroup_add @ nat ).

thf(tcon_Nat_Onat___Rings_Ozero__less__one_79,axiom,
    zero_less_one @ nat ).

thf(tcon_Nat_Onat___Orderings_Owellorder,axiom,
    wellorder @ nat ).

thf(tcon_Nat_Onat___Orderings_Oorder__bot_80,axiom,
    order_bot @ nat ).

thf(tcon_Nat_Onat___Nat_Osemiring__char__0_81,axiom,
    semiring_char_0 @ nat ).

thf(tcon_Nat_Onat___Rings_Ozero__neq__one_82,axiom,
    zero_neq_one @ nat ).

thf(tcon_Nat_Onat___Orderings_Opreorder_83,axiom,
    preorder @ nat ).

thf(tcon_Nat_Onat___Orderings_Olinorder_84,axiom,
    linorder @ nat ).

thf(tcon_Nat_Onat___Groups_Omonoid__mult_85,axiom,
    monoid_mult @ nat ).

thf(tcon_Nat_Onat___Groups_Omonoid__add_86,axiom,
    monoid_add @ nat ).

thf(tcon_Nat_Onat___Rings_Osemiring__1_87,axiom,
    semiring_1 @ nat ).

thf(tcon_Nat_Onat___Rings_Osemiring__0_88,axiom,
    semiring_0 @ nat ).

thf(tcon_Nat_Onat___Orderings_Ono__top_89,axiom,
    no_top @ nat ).

thf(tcon_Nat_Onat___Lattices_Olattice_90,axiom,
    lattice @ nat ).

thf(tcon_Nat_Onat___GCD_Osemiring__gcd_91,axiom,
    semiring_gcd @ nat ).

thf(tcon_Nat_Onat___GCD_Osemiring__Gcd_92,axiom,
    semiring_Gcd @ nat ).

thf(tcon_Nat_Onat___Rings_Omult__zero_93,axiom,
    mult_zero @ nat ).

thf(tcon_Nat_Onat___Orderings_Oorder_94,axiom,
    order @ nat ).

thf(tcon_Nat_Onat___Rings_Osemiring_95,axiom,
    semiring @ nat ).

thf(tcon_Nat_Onat___Rings_Osemidom_96,axiom,
    semidom @ nat ).

thf(tcon_Nat_Onat___Orderings_Oord_97,axiom,
    ord @ nat ).

thf(tcon_Nat_Onat___Orderings_Obot_98,axiom,
    bot @ nat ).

thf(tcon_Nat_Onat___Groups_Ominus_99,axiom,
    minus @ nat ).

thf(tcon_Nat_Onat___Power_Opower_100,axiom,
    power @ nat ).

thf(tcon_Nat_Onat___Num_Onumeral_101,axiom,
    numeral @ nat ).

thf(tcon_Nat_Onat___Groups_Ozero_102,axiom,
    zero @ nat ).

thf(tcon_Nat_Onat___Groups_Oplus_103,axiom,
    plus @ nat ).

thf(tcon_Nat_Onat___Groups_Oone_104,axiom,
    one @ nat ).

thf(tcon_Nat_Onat___Rings_Odvd_105,axiom,
    dvd @ nat ).

thf(tcon_Nat_Onat___Nat_Osize,axiom,
    size @ nat ).

thf(tcon_Num_Onum___Orderings_Opreorder_106,axiom,
    preorder @ num ).

thf(tcon_Num_Onum___Orderings_Olinorder_107,axiom,
    linorder @ num ).

thf(tcon_Num_Onum___Orderings_Oorder_108,axiom,
    order @ num ).

thf(tcon_Num_Onum___Orderings_Oord_109,axiom,
    ord @ num ).

thf(tcon_Num_Onum___Groups_Oplus_110,axiom,
    plus @ num ).

thf(tcon_Num_Onum___Nat_Osize_111,axiom,
    size @ num ).

thf(tcon_Rat_Orat___Semiring__Normalization_Ocomm__semiring__1__cancel__crossproduct_112,axiom,
    semiri1453513574482234551roduct @ rat ).

thf(tcon_Rat_Orat___Groups_Oordered__ab__semigroup__monoid__add__imp__le_113,axiom,
    ordere1937475149494474687imp_le @ rat ).

thf(tcon_Rat_Orat___Rings_Osemiring__no__zero__divisors__cancel_114,axiom,
    semiri6575147826004484403cancel @ rat ).

thf(tcon_Rat_Orat___Groups_Ostrict__ordered__ab__semigroup__add_115,axiom,
    strict9044650504122735259up_add @ rat ).

thf(tcon_Rat_Orat___Groups_Oordered__cancel__ab__semigroup__add_116,axiom,
    ordere580206878836729694up_add @ rat ).

thf(tcon_Rat_Orat___Groups_Oordered__ab__semigroup__add__imp__le_117,axiom,
    ordere2412721322843649153imp_le @ rat ).

thf(tcon_Rat_Orat___Rings_Olinordered__comm__semiring__strict_118,axiom,
    linord2810124833399127020strict @ rat ).

thf(tcon_Rat_Orat___Groups_Ostrict__ordered__comm__monoid__add_119,axiom,
    strict7427464778891057005id_add @ rat ).

thf(tcon_Rat_Orat___Groups_Oordered__cancel__comm__monoid__add_120,axiom,
    ordere8940638589300402666id_add @ rat ).

thf(tcon_Rat_Orat___Archimedean__Field_Oarchimedean__field,axiom,
    archim462609752435547400_field @ rat ).

thf(tcon_Rat_Orat___Rings_Olinordered__semiring__1__strict_121,axiom,
    linord715952674999750819strict @ rat ).

thf(tcon_Rat_Orat___Orderings_Ounbounded__dense__linorder,axiom,
    unboun7993243217541854897norder @ rat ).

thf(tcon_Rat_Orat___Groups_Olinordered__ab__semigroup__add_122,axiom,
    linord4140545234300271783up_add @ rat ).

thf(tcon_Rat_Orat___Rings_Osemiring__1__no__zero__divisors_123,axiom,
    semiri2026040879449505780visors @ rat ).

thf(tcon_Rat_Orat___Rings_Olinordered__nonzero__semiring_124,axiom,
    linord181362715937106298miring @ rat ).

thf(tcon_Rat_Orat___Rings_Olinordered__semiring__strict_125,axiom,
    linord8928482502909563296strict @ rat ).

thf(tcon_Rat_Orat___Rings_Osemiring__no__zero__divisors_126,axiom,
    semiri3467727345109120633visors @ rat ).

thf(tcon_Rat_Orat___Groups_Oordered__ab__semigroup__add_127,axiom,
    ordere6658533253407199908up_add @ rat ).

thf(tcon_Rat_Orat___Groups_Oordered__ab__group__add__abs_128,axiom,
    ordere166539214618696060dd_abs @ rat ).

thf(tcon_Rat_Orat___Archimedean__Field_Ofloor__ceiling,axiom,
    archim2362893244070406136eiling @ rat ).

thf(tcon_Rat_Orat___Groups_Oordered__comm__monoid__add_129,axiom,
    ordere6911136660526730532id_add @ rat ).

thf(tcon_Rat_Orat___Groups_Olinordered__ab__group__add_130,axiom,
    linord5086331880401160121up_add @ rat ).

thf(tcon_Rat_Orat___Groups_Ocancel__ab__semigroup__add_131,axiom,
    cancel2418104881723323429up_add @ rat ).

thf(tcon_Rat_Orat___Rings_Oring__1__no__zero__divisors_132,axiom,
    ring_15535105094025558882visors @ rat ).

thf(tcon_Rat_Orat___Groups_Ocancel__comm__monoid__add_133,axiom,
    cancel1802427076303600483id_add @ rat ).

thf(tcon_Rat_Orat___Rings_Olinordered__ring__strict_134,axiom,
    linord4710134922213307826strict @ rat ).

thf(tcon_Rat_Orat___Rings_Oordered__comm__semiring_135,axiom,
    ordere2520102378445227354miring @ rat ).

thf(tcon_Rat_Orat___Rings_Olinordered__semiring__1_136,axiom,
    linord6961819062388156250ring_1 @ rat ).

thf(tcon_Rat_Orat___Groups_Oordered__ab__group__add_137,axiom,
    ordered_ab_group_add @ rat ).

thf(tcon_Rat_Orat___Groups_Ocancel__semigroup__add_138,axiom,
    cancel_semigroup_add @ rat ).

thf(tcon_Rat_Orat___Rings_Olinordered__semiring_139,axiom,
    linordered_semiring @ rat ).

thf(tcon_Rat_Orat___Rings_Oordered__semiring__0_140,axiom,
    ordered_semiring_0 @ rat ).

thf(tcon_Rat_Orat___Rings_Olinordered__semidom_141,axiom,
    linordered_semidom @ rat ).

thf(tcon_Rat_Orat___Orderings_Odense__linorder,axiom,
    dense_linorder @ rat ).

thf(tcon_Rat_Orat___Lattices_Osemilattice__sup_142,axiom,
    semilattice_sup @ rat ).

thf(tcon_Rat_Orat___Lattices_Osemilattice__inf_143,axiom,
    semilattice_inf @ rat ).

thf(tcon_Rat_Orat___Lattices_Odistrib__lattice_144,axiom,
    distrib_lattice @ rat ).

thf(tcon_Rat_Orat___Groups_Oab__semigroup__mult_145,axiom,
    ab_semigroup_mult @ rat ).

thf(tcon_Rat_Orat___Rings_Osemiring__1__cancel_146,axiom,
    semiring_1_cancel @ rat ).

thf(tcon_Rat_Orat___Groups_Ocomm__monoid__mult_147,axiom,
    comm_monoid_mult @ rat ).

thf(tcon_Rat_Orat___Groups_Oab__semigroup__add_148,axiom,
    ab_semigroup_add @ rat ).

thf(tcon_Rat_Orat___Fields_Olinordered__field,axiom,
    linordered_field @ rat ).

thf(tcon_Rat_Orat___Rings_Oordered__semiring_149,axiom,
    ordered_semiring @ rat ).

thf(tcon_Rat_Orat___Rings_Oordered__ring__abs_150,axiom,
    ordered_ring_abs @ rat ).

thf(tcon_Rat_Orat___Groups_Ocomm__monoid__add_151,axiom,
    comm_monoid_add @ rat ).

thf(tcon_Rat_Orat___Rings_Olinordered__ring_152,axiom,
    linordered_ring @ rat ).

thf(tcon_Rat_Orat___Rings_Olinordered__idom_153,axiom,
    linordered_idom @ rat ).

thf(tcon_Rat_Orat___Rings_Ocomm__semiring__1_154,axiom,
    comm_semiring_1 @ rat ).

thf(tcon_Rat_Orat___Rings_Ocomm__semiring__0_155,axiom,
    comm_semiring_0 @ rat ).

thf(tcon_Rat_Orat___Orderings_Odense__order,axiom,
    dense_order @ rat ).

thf(tcon_Rat_Orat___Groups_Osemigroup__mult_156,axiom,
    semigroup_mult @ rat ).

thf(tcon_Rat_Orat___Rings_Osemidom__divide_157,axiom,
    semidom_divide @ rat ).

thf(tcon_Rat_Orat___Num_Osemiring__numeral_158,axiom,
    semiring_numeral @ rat ).

thf(tcon_Rat_Orat___Groups_Osemigroup__add_159,axiom,
    semigroup_add @ rat ).

thf(tcon_Rat_Orat___Fields_Odivision__ring,axiom,
    division_ring @ rat ).

thf(tcon_Rat_Orat___Rings_Ozero__less__one_160,axiom,
    zero_less_one @ rat ).

thf(tcon_Rat_Orat___Nat_Osemiring__char__0_161,axiom,
    semiring_char_0 @ rat ).

thf(tcon_Rat_Orat___Groups_Oab__group__add_162,axiom,
    ab_group_add @ rat ).

thf(tcon_Rat_Orat___Fields_Ofield__char__0,axiom,
    field_char_0 @ rat ).

thf(tcon_Rat_Orat___Rings_Ozero__neq__one_163,axiom,
    zero_neq_one @ rat ).

thf(tcon_Rat_Orat___Rings_Oordered__ring_164,axiom,
    ordered_ring @ rat ).

thf(tcon_Rat_Orat___Rings_Oidom__abs__sgn_165,axiom,
    idom_abs_sgn @ rat ).

thf(tcon_Rat_Orat___Orderings_Opreorder_166,axiom,
    preorder @ rat ).

thf(tcon_Rat_Orat___Orderings_Olinorder_167,axiom,
    linorder @ rat ).

thf(tcon_Rat_Orat___Groups_Omonoid__mult_168,axiom,
    monoid_mult @ rat ).

thf(tcon_Rat_Orat___Rings_Oidom__divide_169,axiom,
    idom_divide @ rat ).

thf(tcon_Rat_Orat___Rings_Ocomm__ring__1_170,axiom,
    comm_ring_1 @ rat ).

thf(tcon_Rat_Orat___Groups_Omonoid__add_171,axiom,
    monoid_add @ rat ).

thf(tcon_Rat_Orat___Rings_Osemiring__1_172,axiom,
    semiring_1 @ rat ).

thf(tcon_Rat_Orat___Rings_Osemiring__0_173,axiom,
    semiring_0 @ rat ).

thf(tcon_Rat_Orat___Orderings_Ono__top_174,axiom,
    no_top @ rat ).

thf(tcon_Rat_Orat___Orderings_Ono__bot_175,axiom,
    no_bot @ rat ).

thf(tcon_Rat_Orat___Lattices_Olattice_176,axiom,
    lattice @ rat ).

thf(tcon_Rat_Orat___Groups_Ogroup__add_177,axiom,
    group_add @ rat ).

thf(tcon_Rat_Orat___Rings_Omult__zero_178,axiom,
    mult_zero @ rat ).

thf(tcon_Rat_Orat___Rings_Ocomm__ring_179,axiom,
    comm_ring @ rat ).

thf(tcon_Rat_Orat___Orderings_Oorder_180,axiom,
    order @ rat ).

thf(tcon_Rat_Orat___Num_Oneg__numeral_181,axiom,
    neg_numeral @ rat ).

thf(tcon_Rat_Orat___Nat_Oring__char__0_182,axiom,
    ring_char_0 @ rat ).

thf(tcon_Rat_Orat___Rings_Osemiring_183,axiom,
    semiring @ rat ).

thf(tcon_Rat_Orat___Fields_Oinverse,axiom,
    inverse @ rat ).

thf(tcon_Rat_Orat___Rings_Osemidom_184,axiom,
    semidom @ rat ).

thf(tcon_Rat_Orat___Orderings_Oord_185,axiom,
    ord @ rat ).

thf(tcon_Rat_Orat___Groups_Ouminus_186,axiom,
    uminus @ rat ).

thf(tcon_Rat_Orat___Rings_Oring__1_187,axiom,
    ring_1 @ rat ).

thf(tcon_Rat_Orat___Rings_Oabs__if_188,axiom,
    abs_if @ rat ).

thf(tcon_Rat_Orat___Groups_Ominus_189,axiom,
    minus @ rat ).

thf(tcon_Rat_Orat___Fields_Ofield,axiom,
    field @ rat ).

thf(tcon_Rat_Orat___Power_Opower_190,axiom,
    power @ rat ).

thf(tcon_Rat_Orat___Num_Onumeral_191,axiom,
    numeral @ rat ).

thf(tcon_Rat_Orat___Groups_Ozero_192,axiom,
    zero @ rat ).

thf(tcon_Rat_Orat___Groups_Oplus_193,axiom,
    plus @ rat ).

thf(tcon_Rat_Orat___Rings_Oring_194,axiom,
    ring @ rat ).

thf(tcon_Rat_Orat___Rings_Oidom_195,axiom,
    idom @ rat ).

thf(tcon_Rat_Orat___Groups_Oone_196,axiom,
    one @ rat ).

thf(tcon_Rat_Orat___Rings_Odvd_197,axiom,
    dvd @ rat ).

thf(tcon_Set_Oset___Countable__Complete__Lattices_Ocountable__complete__distrib__lattice_198,axiom,
    ! [A10: $tType] : ( counta4013691401010221786attice @ ( set @ A10 ) ) ).

thf(tcon_Set_Oset___Conditionally__Complete__Lattices_Oconditionally__complete__lattice_199,axiom,
    ! [A10: $tType] : ( condit1219197933456340205attice @ ( set @ A10 ) ) ).

thf(tcon_Set_Oset___Countable__Complete__Lattices_Ocountable__complete__lattice_200,axiom,
    ! [A10: $tType] : ( counta3822494911875563373attice @ ( set @ A10 ) ) ).

thf(tcon_Set_Oset___Complete__Lattices_Ocomplete__distrib__lattice_201,axiom,
    ! [A10: $tType] : ( comple592849572758109894attice @ ( set @ A10 ) ) ).

thf(tcon_Set_Oset___Lattices_Obounded__semilattice__sup__bot_202,axiom,
    ! [A10: $tType] : ( bounde4967611905675639751up_bot @ ( set @ A10 ) ) ).

thf(tcon_Set_Oset___Lattices_Obounded__semilattice__inf__top_203,axiom,
    ! [A10: $tType] : ( bounde4346867609351753570nf_top @ ( set @ A10 ) ) ).

thf(tcon_Set_Oset___Complete__Lattices_Ocomplete__lattice_204,axiom,
    ! [A10: $tType] : ( comple6319245703460814977attice @ ( set @ A10 ) ) ).

thf(tcon_Set_Oset___Boolean__Algebras_Oboolean__algebra_205,axiom,
    ! [A10: $tType] : ( boolea8198339166811842893lgebra @ ( set @ A10 ) ) ).

thf(tcon_Set_Oset___Lattices_Obounded__lattice__top_206,axiom,
    ! [A10: $tType] : ( bounded_lattice_top @ ( set @ A10 ) ) ).

thf(tcon_Set_Oset___Lattices_Obounded__lattice__bot_207,axiom,
    ! [A10: $tType] : ( bounded_lattice_bot @ ( set @ A10 ) ) ).

thf(tcon_Set_Oset___Complete__Partial__Order_Occpo_208,axiom,
    ! [A10: $tType] : ( comple9053668089753744459l_ccpo @ ( set @ A10 ) ) ).

thf(tcon_Set_Oset___Lattices_Osemilattice__sup_209,axiom,
    ! [A10: $tType] : ( semilattice_sup @ ( set @ A10 ) ) ).

thf(tcon_Set_Oset___Lattices_Osemilattice__inf_210,axiom,
    ! [A10: $tType] : ( semilattice_inf @ ( set @ A10 ) ) ).

thf(tcon_Set_Oset___Lattices_Odistrib__lattice_211,axiom,
    ! [A10: $tType] : ( distrib_lattice @ ( set @ A10 ) ) ).

thf(tcon_Set_Oset___Orderings_Oorder__top_212,axiom,
    ! [A10: $tType] : ( order_top @ ( set @ A10 ) ) ).

thf(tcon_Set_Oset___Orderings_Oorder__bot_213,axiom,
    ! [A10: $tType] : ( order_bot @ ( set @ A10 ) ) ).

thf(tcon_Set_Oset___Orderings_Opreorder_214,axiom,
    ! [A10: $tType] : ( preorder @ ( set @ A10 ) ) ).

thf(tcon_Set_Oset___Lattices_Olattice_215,axiom,
    ! [A10: $tType] : ( lattice @ ( set @ A10 ) ) ).

thf(tcon_Set_Oset___Orderings_Oorder_216,axiom,
    ! [A10: $tType] : ( order @ ( set @ A10 ) ) ).

thf(tcon_Set_Oset___Orderings_Otop_217,axiom,
    ! [A10: $tType] : ( top @ ( set @ A10 ) ) ).

thf(tcon_Set_Oset___Orderings_Oord_218,axiom,
    ! [A10: $tType] : ( ord @ ( set @ A10 ) ) ).

thf(tcon_Set_Oset___Orderings_Obot_219,axiom,
    ! [A10: $tType] : ( bot @ ( set @ A10 ) ) ).

thf(tcon_Set_Oset___Groups_Ouminus_220,axiom,
    ! [A10: $tType] : ( uminus @ ( set @ A10 ) ) ).

thf(tcon_Set_Oset___Groups_Ominus_221,axiom,
    ! [A10: $tType] : ( minus @ ( set @ A10 ) ) ).

thf(tcon_HOL_Obool___Countable__Complete__Lattices_Ocountable__complete__distrib__lattice_222,axiom,
    counta4013691401010221786attice @ $o ).

thf(tcon_HOL_Obool___Conditionally__Complete__Lattices_Oconditionally__complete__lattice_223,axiom,
    condit1219197933456340205attice @ $o ).

thf(tcon_HOL_Obool___Countable__Complete__Lattices_Ocountable__complete__lattice_224,axiom,
    counta3822494911875563373attice @ $o ).

thf(tcon_HOL_Obool___Complete__Lattices_Ocomplete__distrib__lattice_225,axiom,
    comple592849572758109894attice @ $o ).

thf(tcon_HOL_Obool___Topological__Spaces_Otopological__space_226,axiom,
    topolo4958980785337419405_space @ $o ).

thf(tcon_HOL_Obool___Topological__Spaces_Olinorder__topology_227,axiom,
    topolo1944317154257567458pology @ $o ).

thf(tcon_HOL_Obool___Lattices_Obounded__semilattice__sup__bot_228,axiom,
    bounde4967611905675639751up_bot @ $o ).

thf(tcon_HOL_Obool___Lattices_Obounded__semilattice__inf__top_229,axiom,
    bounde4346867609351753570nf_top @ $o ).

thf(tcon_HOL_Obool___Complete__Lattices_Ocomplete__lattice_230,axiom,
    comple6319245703460814977attice @ $o ).

thf(tcon_HOL_Obool___Topological__Spaces_Oorder__topology_231,axiom,
    topolo2564578578187576103pology @ $o ).

thf(tcon_HOL_Obool___Boolean__Algebras_Oboolean__algebra_232,axiom,
    boolea8198339166811842893lgebra @ $o ).

thf(tcon_HOL_Obool___Lattices_Obounded__lattice__top_233,axiom,
    bounded_lattice_top @ $o ).

thf(tcon_HOL_Obool___Lattices_Obounded__lattice__bot_234,axiom,
    bounded_lattice_bot @ $o ).

thf(tcon_HOL_Obool___Topological__Spaces_Ot2__space_235,axiom,
    topological_t2_space @ $o ).

thf(tcon_HOL_Obool___Complete__Partial__Order_Occpo_236,axiom,
    comple9053668089753744459l_ccpo @ $o ).

thf(tcon_HOL_Obool___Lattices_Osemilattice__sup_237,axiom,
    semilattice_sup @ $o ).

thf(tcon_HOL_Obool___Lattices_Osemilattice__inf_238,axiom,
    semilattice_inf @ $o ).

thf(tcon_HOL_Obool___Lattices_Odistrib__lattice_239,axiom,
    distrib_lattice @ $o ).

thf(tcon_HOL_Obool___Orderings_Oorder__top_240,axiom,
    order_top @ $o ).

thf(tcon_HOL_Obool___Orderings_Oorder__bot_241,axiom,
    order_bot @ $o ).

thf(tcon_HOL_Obool___Orderings_Opreorder_242,axiom,
    preorder @ $o ).

thf(tcon_HOL_Obool___Orderings_Olinorder_243,axiom,
    linorder @ $o ).

thf(tcon_HOL_Obool___Lattices_Olattice_244,axiom,
    lattice @ $o ).

thf(tcon_HOL_Obool___Orderings_Oorder_245,axiom,
    order @ $o ).

thf(tcon_HOL_Obool___Orderings_Otop_246,axiom,
    top @ $o ).

thf(tcon_HOL_Obool___Orderings_Oord_247,axiom,
    ord @ $o ).

thf(tcon_HOL_Obool___Orderings_Obot_248,axiom,
    bot @ $o ).

thf(tcon_HOL_Obool___Groups_Ouminus_249,axiom,
    uminus @ $o ).

thf(tcon_HOL_Obool___Groups_Ominus_250,axiom,
    minus @ $o ).

thf(tcon_List_Olist___Nat_Osize_251,axiom,
    ! [A10: $tType] : ( size @ ( list @ A10 ) ) ).

thf(tcon_Real_Oreal___Conditionally__Complete__Lattices_Oconditionally__complete__linorder_252,axiom,
    condit6923001295902523014norder @ real ).

thf(tcon_Real_Oreal___Conditionally__Complete__Lattices_Oconditionally__complete__lattice_253,axiom,
    condit1219197933456340205attice @ real ).

thf(tcon_Real_Oreal___Semiring__Normalization_Ocomm__semiring__1__cancel__crossproduct_254,axiom,
    semiri1453513574482234551roduct @ real ).

thf(tcon_Real_Oreal___Conditionally__Complete__Lattices_Olinear__continuum,axiom,
    condit5016429287641298734tinuum @ real ).

thf(tcon_Real_Oreal___Groups_Oordered__ab__semigroup__monoid__add__imp__le_255,axiom,
    ordere1937475149494474687imp_le @ real ).

thf(tcon_Real_Oreal___Topological__Spaces_Olinear__continuum__topology,axiom,
    topolo8458572112393995274pology @ real ).

thf(tcon_Real_Oreal___Topological__Spaces_Ofirst__countable__topology,axiom,
    topolo3112930676232923870pology @ real ).

thf(tcon_Real_Oreal___Real__Vector__Spaces_Oreal__normed__div__algebra,axiom,
    real_V8999393235501362500lgebra @ real ).

thf(tcon_Real_Oreal___Real__Vector__Spaces_Oreal__normed__algebra__1,axiom,
    real_V2822296259951069270ebra_1 @ real ).

thf(tcon_Real_Oreal___Rings_Osemiring__no__zero__divisors__cancel_256,axiom,
    semiri6575147826004484403cancel @ real ).

thf(tcon_Real_Oreal___Real__Vector__Spaces_Oreal__normed__algebra,axiom,
    real_V4412858255891104859lgebra @ real ).

thf(tcon_Real_Oreal___Real__Vector__Spaces_Oordered__real__vector,axiom,
    real_V5355595471888546746vector @ real ).

thf(tcon_Real_Oreal___Groups_Ostrict__ordered__ab__semigroup__add_257,axiom,
    strict9044650504122735259up_add @ real ).

thf(tcon_Real_Oreal___Groups_Oordered__cancel__ab__semigroup__add_258,axiom,
    ordere580206878836729694up_add @ real ).

thf(tcon_Real_Oreal___Groups_Oordered__ab__semigroup__add__imp__le_259,axiom,
    ordere2412721322843649153imp_le @ real ).

thf(tcon_Real_Oreal___Rings_Olinordered__comm__semiring__strict_260,axiom,
    linord2810124833399127020strict @ real ).

thf(tcon_Real_Oreal___Real__Vector__Spaces_Oreal__normed__vector,axiom,
    real_V822414075346904944vector @ real ).

thf(tcon_Real_Oreal___Groups_Ostrict__ordered__comm__monoid__add_261,axiom,
    strict7427464778891057005id_add @ real ).

thf(tcon_Real_Oreal___Groups_Oordered__cancel__comm__monoid__add_262,axiom,
    ordere8940638589300402666id_add @ real ).

thf(tcon_Real_Oreal___Topological__Spaces_Otopological__space_263,axiom,
    topolo4958980785337419405_space @ real ).

thf(tcon_Real_Oreal___Topological__Spaces_Olinorder__topology_264,axiom,
    topolo1944317154257567458pology @ real ).

thf(tcon_Real_Oreal___Real__Vector__Spaces_Oreal__normed__field,axiom,
    real_V3459762299906320749_field @ real ).

thf(tcon_Real_Oreal___Real__Vector__Spaces_Oreal__div__algebra,axiom,
    real_V5047593784448816457lgebra @ real ).

thf(tcon_Real_Oreal___Archimedean__Field_Oarchimedean__field_265,axiom,
    archim462609752435547400_field @ real ).

thf(tcon_Real_Oreal___Rings_Olinordered__semiring__1__strict_266,axiom,
    linord715952674999750819strict @ real ).

thf(tcon_Real_Oreal___Real__Vector__Spaces_Ouniformity__dist,axiom,
    real_V768167426530841204y_dist @ real ).

thf(tcon_Real_Oreal___Orderings_Ounbounded__dense__linorder_267,axiom,
    unboun7993243217541854897norder @ real ).

thf(tcon_Real_Oreal___Limits_Otopological__comm__monoid__add_268,axiom,
    topolo5987344860129210374id_add @ real ).

thf(tcon_Real_Oreal___Groups_Olinordered__ab__semigroup__add_269,axiom,
    linord4140545234300271783up_add @ real ).

thf(tcon_Real_Oreal___Topological__Spaces_Oorder__topology_270,axiom,
    topolo2564578578187576103pology @ real ).

thf(tcon_Real_Oreal___Rings_Osemiring__1__no__zero__divisors_271,axiom,
    semiri2026040879449505780visors @ real ).

thf(tcon_Real_Oreal___Rings_Olinordered__nonzero__semiring_272,axiom,
    linord181362715937106298miring @ real ).

thf(tcon_Real_Oreal___Real__Vector__Spaces_Oreal__algebra__1,axiom,
    real_V2191834092415804123ebra_1 @ real ).

thf(tcon_Real_Oreal___Real__Vector__Spaces_Ocomplete__space,axiom,
    real_V8037385150606011577_space @ real ).

thf(tcon_Real_Oreal___Limits_Otopological__semigroup__mult_273,axiom,
    topolo4211221413907600880p_mult @ real ).

thf(tcon_Real_Oreal___Topological__Spaces_Ouniform__space,axiom,
    topolo7287701948861334536_space @ real ).

thf(tcon_Real_Oreal___Topological__Spaces_Operfect__space,axiom,
    topolo8386298272705272623_space @ real ).

thf(tcon_Real_Oreal___Rings_Olinordered__semiring__strict_274,axiom,
    linord8928482502909563296strict @ real ).

thf(tcon_Real_Oreal___Rings_Osemiring__no__zero__divisors_275,axiom,
    semiri3467727345109120633visors @ real ).

thf(tcon_Real_Oreal___Real__Vector__Spaces_Ometric__space,axiom,
    real_V7819770556892013058_space @ real ).

thf(tcon_Real_Oreal___Groups_Oordered__ab__semigroup__add_276,axiom,
    ordere6658533253407199908up_add @ real ).

thf(tcon_Real_Oreal___Groups_Oordered__ab__group__add__abs_277,axiom,
    ordere166539214618696060dd_abs @ real ).

thf(tcon_Real_Oreal___Archimedean__Field_Ofloor__ceiling_278,axiom,
    archim2362893244070406136eiling @ real ).

thf(tcon_Real_Oreal___Real__Vector__Spaces_Oreal__vector,axiom,
    real_V4867850818363320053vector @ real ).

thf(tcon_Real_Oreal___Groups_Oordered__comm__monoid__add_279,axiom,
    ordere6911136660526730532id_add @ real ).

thf(tcon_Real_Oreal___Groups_Olinordered__ab__group__add_280,axiom,
    linord5086331880401160121up_add @ real ).

thf(tcon_Real_Oreal___Groups_Ocancel__ab__semigroup__add_281,axiom,
    cancel2418104881723323429up_add @ real ).

thf(tcon_Real_Oreal___Topological__Spaces_Ouniformity,axiom,
    topolo4638772830378233104ormity @ real ).

thf(tcon_Real_Oreal___Rings_Oring__1__no__zero__divisors_282,axiom,
    ring_15535105094025558882visors @ real ).

thf(tcon_Real_Oreal___Real__Vector__Spaces_Oreal__field,axiom,
    real_V7773925162809079976_field @ real ).

thf(tcon_Real_Oreal___Limits_Otopological__monoid__add_283,axiom,
    topolo6943815403480290642id_add @ real ).

thf(tcon_Real_Oreal___Groups_Ocancel__comm__monoid__add_284,axiom,
    cancel1802427076303600483id_add @ real ).

thf(tcon_Real_Oreal___Rings_Olinordered__ring__strict_285,axiom,
    linord4710134922213307826strict @ real ).

thf(tcon_Real_Oreal___Topological__Spaces_Ot2__space_286,axiom,
    topological_t2_space @ real ).

thf(tcon_Real_Oreal___Rings_Oordered__comm__semiring_287,axiom,
    ordere2520102378445227354miring @ real ).

thf(tcon_Real_Oreal___Rings_Olinordered__semiring__1_288,axiom,
    linord6961819062388156250ring_1 @ real ).

thf(tcon_Real_Oreal___Groups_Oordered__ab__group__add_289,axiom,
    ordered_ab_group_add @ real ).

thf(tcon_Real_Oreal___Groups_Ocancel__semigroup__add_290,axiom,
    cancel_semigroup_add @ real ).

thf(tcon_Real_Oreal___Rings_Olinordered__semiring_291,axiom,
    linordered_semiring @ real ).

thf(tcon_Real_Oreal___Real__Vector__Spaces_Obanach,axiom,
    real_Vector_banach @ real ).

thf(tcon_Real_Oreal___Rings_Oordered__semiring__0_292,axiom,
    ordered_semiring_0 @ real ).

thf(tcon_Real_Oreal___Rings_Olinordered__semidom_293,axiom,
    linordered_semidom @ real ).

thf(tcon_Real_Oreal___Orderings_Odense__linorder_294,axiom,
    dense_linorder @ real ).

thf(tcon_Real_Oreal___Lattices_Osemilattice__sup_295,axiom,
    semilattice_sup @ real ).

thf(tcon_Real_Oreal___Lattices_Osemilattice__inf_296,axiom,
    semilattice_inf @ real ).

thf(tcon_Real_Oreal___Lattices_Odistrib__lattice_297,axiom,
    distrib_lattice @ real ).

thf(tcon_Real_Oreal___Groups_Oab__semigroup__mult_298,axiom,
    ab_semigroup_mult @ real ).

thf(tcon_Real_Oreal___Rings_Osemiring__1__cancel_299,axiom,
    semiring_1_cancel @ real ).

thf(tcon_Real_Oreal___Groups_Ocomm__monoid__mult_300,axiom,
    comm_monoid_mult @ real ).

thf(tcon_Real_Oreal___Groups_Oab__semigroup__add_301,axiom,
    ab_semigroup_add @ real ).

thf(tcon_Real_Oreal___Fields_Olinordered__field_302,axiom,
    linordered_field @ real ).

thf(tcon_Real_Oreal___Rings_Oordered__semiring_303,axiom,
    ordered_semiring @ real ).

thf(tcon_Real_Oreal___Rings_Oordered__ring__abs_304,axiom,
    ordered_ring_abs @ real ).

thf(tcon_Real_Oreal___Groups_Ocomm__monoid__add_305,axiom,
    comm_monoid_add @ real ).

thf(tcon_Real_Oreal___Rings_Olinordered__ring_306,axiom,
    linordered_ring @ real ).

thf(tcon_Real_Oreal___Rings_Olinordered__idom_307,axiom,
    linordered_idom @ real ).

thf(tcon_Real_Oreal___Rings_Ocomm__semiring__1_308,axiom,
    comm_semiring_1 @ real ).

thf(tcon_Real_Oreal___Rings_Ocomm__semiring__0_309,axiom,
    comm_semiring_0 @ real ).

thf(tcon_Real_Oreal___Orderings_Odense__order_310,axiom,
    dense_order @ real ).

thf(tcon_Real_Oreal___Groups_Osemigroup__mult_311,axiom,
    semigroup_mult @ real ).

thf(tcon_Real_Oreal___Rings_Osemidom__divide_312,axiom,
    semidom_divide @ real ).

thf(tcon_Real_Oreal___Num_Osemiring__numeral_313,axiom,
    semiring_numeral @ real ).

thf(tcon_Real_Oreal___Groups_Osemigroup__add_314,axiom,
    semigroup_add @ real ).

thf(tcon_Real_Oreal___Fields_Odivision__ring_315,axiom,
    division_ring @ real ).

thf(tcon_Real_Oreal___Rings_Ozero__less__one_316,axiom,
    zero_less_one @ real ).

thf(tcon_Real_Oreal___Nat_Osemiring__char__0_317,axiom,
    semiring_char_0 @ real ).

thf(tcon_Real_Oreal___Groups_Oab__group__add_318,axiom,
    ab_group_add @ real ).

thf(tcon_Real_Oreal___Fields_Ofield__char__0_319,axiom,
    field_char_0 @ real ).

thf(tcon_Real_Oreal___Rings_Ozero__neq__one_320,axiom,
    zero_neq_one @ real ).

thf(tcon_Real_Oreal___Rings_Oordered__ring_321,axiom,
    ordered_ring @ real ).

thf(tcon_Real_Oreal___Rings_Oidom__abs__sgn_322,axiom,
    idom_abs_sgn @ real ).

thf(tcon_Real_Oreal___Orderings_Opreorder_323,axiom,
    preorder @ real ).

thf(tcon_Real_Oreal___Orderings_Olinorder_324,axiom,
    linorder @ real ).

thf(tcon_Real_Oreal___Groups_Omonoid__mult_325,axiom,
    monoid_mult @ real ).

thf(tcon_Real_Oreal___Transcendental_Oln,axiom,
    ln @ real ).

thf(tcon_Real_Oreal___Rings_Oidom__divide_326,axiom,
    idom_divide @ real ).

thf(tcon_Real_Oreal___Rings_Ocomm__ring__1_327,axiom,
    comm_ring_1 @ real ).

thf(tcon_Real_Oreal___Groups_Omonoid__add_328,axiom,
    monoid_add @ real ).

thf(tcon_Real_Oreal___Rings_Osemiring__1_329,axiom,
    semiring_1 @ real ).

thf(tcon_Real_Oreal___Rings_Osemiring__0_330,axiom,
    semiring_0 @ real ).

thf(tcon_Real_Oreal___Orderings_Ono__top_331,axiom,
    no_top @ real ).

thf(tcon_Real_Oreal___Orderings_Ono__bot_332,axiom,
    no_bot @ real ).

thf(tcon_Real_Oreal___Lattices_Olattice_333,axiom,
    lattice @ real ).

thf(tcon_Real_Oreal___Groups_Ogroup__add_334,axiom,
    group_add @ real ).

thf(tcon_Real_Oreal___Rings_Omult__zero_335,axiom,
    mult_zero @ real ).

thf(tcon_Real_Oreal___Rings_Ocomm__ring_336,axiom,
    comm_ring @ real ).

thf(tcon_Real_Oreal___Orderings_Oorder_337,axiom,
    order @ real ).

thf(tcon_Real_Oreal___Num_Oneg__numeral_338,axiom,
    neg_numeral @ real ).

thf(tcon_Real_Oreal___Nat_Oring__char__0_339,axiom,
    ring_char_0 @ real ).

thf(tcon_Real_Oreal___Rings_Osemiring_340,axiom,
    semiring @ real ).

thf(tcon_Real_Oreal___Fields_Oinverse_341,axiom,
    inverse @ real ).

thf(tcon_Real_Oreal___Rings_Osemidom_342,axiom,
    semidom @ real ).

thf(tcon_Real_Oreal___Orderings_Oord_343,axiom,
    ord @ real ).

thf(tcon_Real_Oreal___Groups_Ouminus_344,axiom,
    uminus @ real ).

thf(tcon_Real_Oreal___Rings_Oring__1_345,axiom,
    ring_1 @ real ).

thf(tcon_Real_Oreal___Rings_Oabs__if_346,axiom,
    abs_if @ real ).

thf(tcon_Real_Oreal___Groups_Ominus_347,axiom,
    minus @ real ).

thf(tcon_Real_Oreal___Fields_Ofield_348,axiom,
    field @ real ).

thf(tcon_Real_Oreal___Power_Opower_349,axiom,
    power @ real ).

thf(tcon_Real_Oreal___Num_Onumeral_350,axiom,
    numeral @ real ).

thf(tcon_Real_Oreal___Groups_Ozero_351,axiom,
    zero @ real ).

thf(tcon_Real_Oreal___Groups_Oplus_352,axiom,
    plus @ real ).

thf(tcon_Real_Oreal___Rings_Oring_353,axiom,
    ring @ real ).

thf(tcon_Real_Oreal___Rings_Oidom_354,axiom,
    idom @ real ).

thf(tcon_Real_Oreal___Groups_Oone_355,axiom,
    one @ real ).

thf(tcon_Real_Oreal___Rings_Odvd_356,axiom,
    dvd @ real ).

thf(tcon_String_Ochar___Nat_Osize_357,axiom,
    size @ char ).

thf(tcon_Sum__Type_Osum___Nat_Osize_358,axiom,
    ! [A10: $tType,A16: $tType] : ( size @ ( sum_sum @ A10 @ A16 ) ) ).

thf(tcon_Filter_Ofilter___Conditionally__Complete__Lattices_Oconditionally__complete__lattice_359,axiom,
    ! [A10: $tType] : ( condit1219197933456340205attice @ ( filter @ A10 ) ) ).

thf(tcon_Filter_Ofilter___Countable__Complete__Lattices_Ocountable__complete__lattice_360,axiom,
    ! [A10: $tType] : ( counta3822494911875563373attice @ ( filter @ A10 ) ) ).

thf(tcon_Filter_Ofilter___Lattices_Obounded__semilattice__sup__bot_361,axiom,
    ! [A10: $tType] : ( bounde4967611905675639751up_bot @ ( filter @ A10 ) ) ).

thf(tcon_Filter_Ofilter___Lattices_Obounded__semilattice__inf__top_362,axiom,
    ! [A10: $tType] : ( bounde4346867609351753570nf_top @ ( filter @ A10 ) ) ).

thf(tcon_Filter_Ofilter___Complete__Lattices_Ocomplete__lattice_363,axiom,
    ! [A10: $tType] : ( comple6319245703460814977attice @ ( filter @ A10 ) ) ).

thf(tcon_Filter_Ofilter___Lattices_Obounded__lattice__top_364,axiom,
    ! [A10: $tType] : ( bounded_lattice_top @ ( filter @ A10 ) ) ).

thf(tcon_Filter_Ofilter___Lattices_Obounded__lattice__bot_365,axiom,
    ! [A10: $tType] : ( bounded_lattice_bot @ ( filter @ A10 ) ) ).

thf(tcon_Filter_Ofilter___Complete__Partial__Order_Occpo_366,axiom,
    ! [A10: $tType] : ( comple9053668089753744459l_ccpo @ ( filter @ A10 ) ) ).

thf(tcon_Filter_Ofilter___Lattices_Osemilattice__sup_367,axiom,
    ! [A10: $tType] : ( semilattice_sup @ ( filter @ A10 ) ) ).

thf(tcon_Filter_Ofilter___Lattices_Osemilattice__inf_368,axiom,
    ! [A10: $tType] : ( semilattice_inf @ ( filter @ A10 ) ) ).

thf(tcon_Filter_Ofilter___Lattices_Odistrib__lattice_369,axiom,
    ! [A10: $tType] : ( distrib_lattice @ ( filter @ A10 ) ) ).

thf(tcon_Filter_Ofilter___Orderings_Oorder__top_370,axiom,
    ! [A10: $tType] : ( order_top @ ( filter @ A10 ) ) ).

thf(tcon_Filter_Ofilter___Orderings_Oorder__bot_371,axiom,
    ! [A10: $tType] : ( order_bot @ ( filter @ A10 ) ) ).

thf(tcon_Filter_Ofilter___Orderings_Opreorder_372,axiom,
    ! [A10: $tType] : ( preorder @ ( filter @ A10 ) ) ).

thf(tcon_Filter_Ofilter___Lattices_Olattice_373,axiom,
    ! [A10: $tType] : ( lattice @ ( filter @ A10 ) ) ).

thf(tcon_Filter_Ofilter___Orderings_Oorder_374,axiom,
    ! [A10: $tType] : ( order @ ( filter @ A10 ) ) ).

thf(tcon_Filter_Ofilter___Orderings_Otop_375,axiom,
    ! [A10: $tType] : ( top @ ( filter @ A10 ) ) ).

thf(tcon_Filter_Ofilter___Orderings_Oord_376,axiom,
    ! [A10: $tType] : ( ord @ ( filter @ A10 ) ) ).

thf(tcon_Filter_Ofilter___Orderings_Obot_377,axiom,
    ! [A10: $tType] : ( bot @ ( filter @ A10 ) ) ).

thf(tcon_Option_Ooption___Nat_Osize_378,axiom,
    ! [A10: $tType] : ( size @ ( option @ A10 ) ) ).

thf(tcon_String_Oliteral___Groups_Osemigroup__add_379,axiom,
    semigroup_add @ literal ).

thf(tcon_String_Oliteral___Orderings_Opreorder_380,axiom,
    preorder @ literal ).

thf(tcon_String_Oliteral___Orderings_Olinorder_381,axiom,
    linorder @ literal ).

thf(tcon_String_Oliteral___Groups_Omonoid__add_382,axiom,
    monoid_add @ literal ).

thf(tcon_String_Oliteral___Orderings_Oorder_383,axiom,
    order @ literal ).

thf(tcon_String_Oliteral___Orderings_Oord_384,axiom,
    ord @ literal ).

thf(tcon_String_Oliteral___Groups_Ozero_385,axiom,
    zero @ literal ).

thf(tcon_String_Oliteral___Groups_Oplus_386,axiom,
    plus @ literal ).

thf(tcon_String_Oliteral___Nat_Osize_387,axiom,
    size @ literal ).

thf(tcon_Complex_Ocomplex___Semiring__Normalization_Ocomm__semiring__1__cancel__crossproduct_388,axiom,
    semiri1453513574482234551roduct @ complex ).

thf(tcon_Complex_Ocomplex___Topological__Spaces_Ofirst__countable__topology_389,axiom,
    topolo3112930676232923870pology @ complex ).

thf(tcon_Complex_Ocomplex___Real__Vector__Spaces_Oreal__normed__div__algebra_390,axiom,
    real_V8999393235501362500lgebra @ complex ).

thf(tcon_Complex_Ocomplex___Real__Vector__Spaces_Oreal__normed__algebra__1_391,axiom,
    real_V2822296259951069270ebra_1 @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Osemiring__no__zero__divisors__cancel_392,axiom,
    semiri6575147826004484403cancel @ complex ).

thf(tcon_Complex_Ocomplex___Real__Vector__Spaces_Oreal__normed__algebra_393,axiom,
    real_V4412858255891104859lgebra @ complex ).

thf(tcon_Complex_Ocomplex___Real__Vector__Spaces_Oreal__normed__vector_394,axiom,
    real_V822414075346904944vector @ complex ).

thf(tcon_Complex_Ocomplex___Topological__Spaces_Otopological__space_395,axiom,
    topolo4958980785337419405_space @ complex ).

thf(tcon_Complex_Ocomplex___Real__Vector__Spaces_Oreal__normed__field_396,axiom,
    real_V3459762299906320749_field @ complex ).

thf(tcon_Complex_Ocomplex___Real__Vector__Spaces_Oreal__div__algebra_397,axiom,
    real_V5047593784448816457lgebra @ complex ).

thf(tcon_Complex_Ocomplex___Real__Vector__Spaces_Ouniformity__dist_398,axiom,
    real_V768167426530841204y_dist @ complex ).

thf(tcon_Complex_Ocomplex___Limits_Otopological__comm__monoid__add_399,axiom,
    topolo5987344860129210374id_add @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Osemiring__1__no__zero__divisors_400,axiom,
    semiri2026040879449505780visors @ complex ).

thf(tcon_Complex_Ocomplex___Real__Vector__Spaces_Oreal__algebra__1_401,axiom,
    real_V2191834092415804123ebra_1 @ complex ).

thf(tcon_Complex_Ocomplex___Real__Vector__Spaces_Ocomplete__space_402,axiom,
    real_V8037385150606011577_space @ complex ).

thf(tcon_Complex_Ocomplex___Limits_Otopological__semigroup__mult_403,axiom,
    topolo4211221413907600880p_mult @ complex ).

thf(tcon_Complex_Ocomplex___Topological__Spaces_Ouniform__space_404,axiom,
    topolo7287701948861334536_space @ complex ).

thf(tcon_Complex_Ocomplex___Topological__Spaces_Operfect__space_405,axiom,
    topolo8386298272705272623_space @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Osemiring__no__zero__divisors_406,axiom,
    semiri3467727345109120633visors @ complex ).

thf(tcon_Complex_Ocomplex___Real__Vector__Spaces_Ometric__space_407,axiom,
    real_V7819770556892013058_space @ complex ).

thf(tcon_Complex_Ocomplex___Real__Vector__Spaces_Oreal__vector_408,axiom,
    real_V4867850818363320053vector @ complex ).

thf(tcon_Complex_Ocomplex___Groups_Ocancel__ab__semigroup__add_409,axiom,
    cancel2418104881723323429up_add @ complex ).

thf(tcon_Complex_Ocomplex___Topological__Spaces_Ouniformity_410,axiom,
    topolo4638772830378233104ormity @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Oring__1__no__zero__divisors_411,axiom,
    ring_15535105094025558882visors @ complex ).

thf(tcon_Complex_Ocomplex___Real__Vector__Spaces_Oreal__field_412,axiom,
    real_V7773925162809079976_field @ complex ).

thf(tcon_Complex_Ocomplex___Limits_Otopological__monoid__add_413,axiom,
    topolo6943815403480290642id_add @ complex ).

thf(tcon_Complex_Ocomplex___Groups_Ocancel__comm__monoid__add_414,axiom,
    cancel1802427076303600483id_add @ complex ).

thf(tcon_Complex_Ocomplex___Topological__Spaces_Ot2__space_415,axiom,
    topological_t2_space @ complex ).

thf(tcon_Complex_Ocomplex___Groups_Ocancel__semigroup__add_416,axiom,
    cancel_semigroup_add @ complex ).

thf(tcon_Complex_Ocomplex___Real__Vector__Spaces_Obanach_417,axiom,
    real_Vector_banach @ complex ).

thf(tcon_Complex_Ocomplex___Groups_Oab__semigroup__mult_418,axiom,
    ab_semigroup_mult @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Osemiring__1__cancel_419,axiom,
    semiring_1_cancel @ complex ).

thf(tcon_Complex_Ocomplex___Groups_Ocomm__monoid__mult_420,axiom,
    comm_monoid_mult @ complex ).

thf(tcon_Complex_Ocomplex___Groups_Oab__semigroup__add_421,axiom,
    ab_semigroup_add @ complex ).

thf(tcon_Complex_Ocomplex___Groups_Ocomm__monoid__add_422,axiom,
    comm_monoid_add @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Ocomm__semiring__1_423,axiom,
    comm_semiring_1 @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Ocomm__semiring__0_424,axiom,
    comm_semiring_0 @ complex ).

thf(tcon_Complex_Ocomplex___Groups_Osemigroup__mult_425,axiom,
    semigroup_mult @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Osemidom__divide_426,axiom,
    semidom_divide @ complex ).

thf(tcon_Complex_Ocomplex___Num_Osemiring__numeral_427,axiom,
    semiring_numeral @ complex ).

thf(tcon_Complex_Ocomplex___Groups_Osemigroup__add_428,axiom,
    semigroup_add @ complex ).

thf(tcon_Complex_Ocomplex___Fields_Odivision__ring_429,axiom,
    division_ring @ complex ).

thf(tcon_Complex_Ocomplex___Nat_Osemiring__char__0_430,axiom,
    semiring_char_0 @ complex ).

thf(tcon_Complex_Ocomplex___Groups_Oab__group__add_431,axiom,
    ab_group_add @ complex ).

thf(tcon_Complex_Ocomplex___Fields_Ofield__char__0_432,axiom,
    field_char_0 @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Ozero__neq__one_433,axiom,
    zero_neq_one @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Oidom__abs__sgn_434,axiom,
    idom_abs_sgn @ complex ).

thf(tcon_Complex_Ocomplex___Groups_Omonoid__mult_435,axiom,
    monoid_mult @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Oidom__divide_436,axiom,
    idom_divide @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Ocomm__ring__1_437,axiom,
    comm_ring_1 @ complex ).

thf(tcon_Complex_Ocomplex___Groups_Omonoid__add_438,axiom,
    monoid_add @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Osemiring__1_439,axiom,
    semiring_1 @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Osemiring__0_440,axiom,
    semiring_0 @ complex ).

thf(tcon_Complex_Ocomplex___Groups_Ogroup__add_441,axiom,
    group_add @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Omult__zero_442,axiom,
    mult_zero @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Ocomm__ring_443,axiom,
    comm_ring @ complex ).

thf(tcon_Complex_Ocomplex___Num_Oneg__numeral_444,axiom,
    neg_numeral @ complex ).

thf(tcon_Complex_Ocomplex___Nat_Oring__char__0_445,axiom,
    ring_char_0 @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Osemiring_446,axiom,
    semiring @ complex ).

thf(tcon_Complex_Ocomplex___Fields_Oinverse_447,axiom,
    inverse @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Osemidom_448,axiom,
    semidom @ complex ).

thf(tcon_Complex_Ocomplex___Groups_Ouminus_449,axiom,
    uminus @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Oring__1_450,axiom,
    ring_1 @ complex ).

thf(tcon_Complex_Ocomplex___Groups_Ominus_451,axiom,
    minus @ complex ).

thf(tcon_Complex_Ocomplex___Fields_Ofield_452,axiom,
    field @ complex ).

thf(tcon_Complex_Ocomplex___Power_Opower_453,axiom,
    power @ complex ).

thf(tcon_Complex_Ocomplex___Num_Onumeral_454,axiom,
    numeral @ complex ).

thf(tcon_Complex_Ocomplex___Groups_Ozero_455,axiom,
    zero @ complex ).

thf(tcon_Complex_Ocomplex___Groups_Oplus_456,axiom,
    plus @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Oring_457,axiom,
    ring @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Oidom_458,axiom,
    idom @ complex ).

thf(tcon_Complex_Ocomplex___Groups_Oone_459,axiom,
    one @ complex ).

thf(tcon_Complex_Ocomplex___Rings_Odvd_460,axiom,
    dvd @ complex ).

thf(tcon_Extended__Nat_Oenat___Conditionally__Complete__Lattices_Oconditionally__complete__linorder_461,axiom,
    condit6923001295902523014norder @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Countable__Complete__Lattices_Ocountable__complete__distrib__lattice_462,axiom,
    counta4013691401010221786attice @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Conditionally__Complete__Lattices_Oconditionally__complete__lattice_463,axiom,
    condit1219197933456340205attice @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Countable__Complete__Lattices_Ocountable__complete__lattice_464,axiom,
    counta3822494911875563373attice @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Complete__Lattices_Ocomplete__distrib__lattice_465,axiom,
    comple592849572758109894attice @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Groups_Ostrict__ordered__ab__semigroup__add_466,axiom,
    strict9044650504122735259up_add @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Groups_Ostrict__ordered__comm__monoid__add_467,axiom,
    strict7427464778891057005id_add @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Groups_Ocanonically__ordered__monoid__add_468,axiom,
    canoni5634975068530333245id_add @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Lattices_Obounded__semilattice__sup__bot_469,axiom,
    bounde4967611905675639751up_bot @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Lattices_Obounded__semilattice__inf__top_470,axiom,
    bounde4346867609351753570nf_top @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Complete__Lattices_Ocomplete__linorder,axiom,
    comple5582772986160207858norder @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Groups_Olinordered__ab__semigroup__add_471,axiom,
    linord4140545234300271783up_add @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Complete__Lattices_Ocomplete__lattice_472,axiom,
    comple6319245703460814977attice @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Rings_Olinordered__nonzero__semiring_473,axiom,
    linord181362715937106298miring @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Rings_Osemiring__no__zero__divisors_474,axiom,
    semiri3467727345109120633visors @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Groups_Oordered__ab__semigroup__add_475,axiom,
    ordere6658533253407199908up_add @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Groups_Oordered__comm__monoid__add_476,axiom,
    ordere6911136660526730532id_add @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Lattices_Obounded__lattice__top_477,axiom,
    bounded_lattice_top @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Lattices_Obounded__lattice__bot_478,axiom,
    bounded_lattice_bot @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Rings_Oordered__comm__semiring_479,axiom,
    ordere2520102378445227354miring @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Complete__Partial__Order_Occpo_480,axiom,
    comple9053668089753744459l_ccpo @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Lattices_Osemilattice__sup_481,axiom,
    semilattice_sup @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Lattices_Osemilattice__inf_482,axiom,
    semilattice_inf @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Lattices_Odistrib__lattice_483,axiom,
    distrib_lattice @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Groups_Oab__semigroup__mult_484,axiom,
    ab_semigroup_mult @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Groups_Ocomm__monoid__mult_485,axiom,
    comm_monoid_mult @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Groups_Oab__semigroup__add_486,axiom,
    ab_semigroup_add @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Rings_Oordered__semiring_487,axiom,
    ordered_semiring @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Groups_Ocomm__monoid__add_488,axiom,
    comm_monoid_add @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Rings_Ocomm__semiring__1_489,axiom,
    comm_semiring_1 @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Rings_Ocomm__semiring__0_490,axiom,
    comm_semiring_0 @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Groups_Osemigroup__mult_491,axiom,
    semigroup_mult @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Num_Osemiring__numeral_492,axiom,
    semiring_numeral @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Groups_Osemigroup__add_493,axiom,
    semigroup_add @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Rings_Ozero__less__one_494,axiom,
    zero_less_one @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Orderings_Owellorder_495,axiom,
    wellorder @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Orderings_Oorder__top_496,axiom,
    order_top @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Orderings_Oorder__bot_497,axiom,
    order_bot @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Nat_Osemiring__char__0_498,axiom,
    semiring_char_0 @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Rings_Ozero__neq__one_499,axiom,
    zero_neq_one @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Orderings_Opreorder_500,axiom,
    preorder @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Orderings_Olinorder_501,axiom,
    linorder @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Groups_Omonoid__mult_502,axiom,
    monoid_mult @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Groups_Omonoid__add_503,axiom,
    monoid_add @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Rings_Osemiring__1_504,axiom,
    semiring_1 @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Rings_Osemiring__0_505,axiom,
    semiring_0 @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Lattices_Olattice_506,axiom,
    lattice @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Rings_Omult__zero_507,axiom,
    mult_zero @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Orderings_Oorder_508,axiom,
    order @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Rings_Osemiring_509,axiom,
    semiring @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Orderings_Otop_510,axiom,
    top @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Orderings_Oord_511,axiom,
    ord @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Orderings_Obot_512,axiom,
    bot @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Groups_Ominus_513,axiom,
    minus @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Power_Opower_514,axiom,
    power @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Num_Onumeral_515,axiom,
    numeral @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Groups_Ozero_516,axiom,
    zero @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Groups_Oplus_517,axiom,
    plus @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Groups_Oone_518,axiom,
    one @ extended_enat ).

thf(tcon_Extended__Nat_Oenat___Rings_Odvd_519,axiom,
    dvd @ extended_enat ).

thf(tcon_Product__Type_Oprod___Topological__Spaces_Otopological__space_520,axiom,
    ! [A10: $tType,A16: $tType] :
      ( ( ( topolo4958980785337419405_space @ A10 )
        & ( topolo4958980785337419405_space @ A16 ) )
     => ( topolo4958980785337419405_space @ ( product_prod @ A10 @ A16 ) ) ) ).

thf(tcon_Product__Type_Oprod___Topological__Spaces_Ot2__space_521,axiom,
    ! [A10: $tType,A16: $tType] :
      ( ( ( topological_t2_space @ A10 )
        & ( topological_t2_space @ A16 ) )
     => ( topological_t2_space @ ( product_prod @ A10 @ A16 ) ) ) ).

thf(tcon_Product__Type_Oprod___Nat_Osize_522,axiom,
    ! [A10: $tType,A16: $tType] : ( size @ ( product_prod @ A10 @ A16 ) ) ).

thf(tcon_Code__Numeral_Ointeger___Bit__Operations_Ounique__euclidean__semiring__with__bit__operations_523,axiom,
    bit_un5681908812861735899ations @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Semiring__Normalization_Ocomm__semiring__1__cancel__crossproduct_524,axiom,
    semiri1453513574482234551roduct @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Euclidean__Division_Ounique__euclidean__semiring__with__nat_525,axiom,
    euclid5411537665997757685th_nat @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Euclidean__Division_Ounique__euclidean__ring__with__nat_526,axiom,
    euclid8789492081693882211th_nat @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Oordered__ab__semigroup__monoid__add__imp__le_527,axiom,
    ordere1937475149494474687imp_le @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Euclidean__Division_Ounique__euclidean__semiring_528,axiom,
    euclid3128863361964157862miring @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Euclidean__Division_Oeuclidean__semiring__cancel_529,axiom,
    euclid4440199948858584721cancel @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Divides_Ounique__euclidean__semiring__numeral_530,axiom,
    unique1627219031080169319umeral @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Euclidean__Division_Oeuclidean__ring__cancel_531,axiom,
    euclid8851590272496341667cancel @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Osemiring__no__zero__divisors__cancel_532,axiom,
    semiri6575147826004484403cancel @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Ostrict__ordered__ab__semigroup__add_533,axiom,
    strict9044650504122735259up_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Oordered__cancel__ab__semigroup__add_534,axiom,
    ordere580206878836729694up_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Oordered__ab__semigroup__add__imp__le_535,axiom,
    ordere2412721322843649153imp_le @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Bit__Operations_Osemiring__bit__operations_536,axiom,
    bit_se359711467146920520ations @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Olinordered__comm__semiring__strict_537,axiom,
    linord2810124833399127020strict @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Ostrict__ordered__comm__monoid__add_538,axiom,
    strict7427464778891057005id_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Oordered__cancel__comm__monoid__add_539,axiom,
    ordere8940638589300402666id_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Euclidean__Division_Oeuclidean__semiring_540,axiom,
    euclid3725896446679973847miring @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Olinordered__semiring__1__strict_541,axiom,
    linord715952674999750819strict @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Olinordered__ab__semigroup__add_542,axiom,
    linord4140545234300271783up_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Bit__Operations_Oring__bit__operations_543,axiom,
    bit_ri3973907225187159222ations @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Osemiring__1__no__zero__divisors_544,axiom,
    semiri2026040879449505780visors @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Olinordered__nonzero__semiring_545,axiom,
    linord181362715937106298miring @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Olinordered__semiring__strict_546,axiom,
    linord8928482502909563296strict @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Osemiring__no__zero__divisors_547,axiom,
    semiri3467727345109120633visors @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Oordered__ab__semigroup__add_548,axiom,
    ordere6658533253407199908up_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Oordered__ab__group__add__abs_549,axiom,
    ordere166539214618696060dd_abs @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Oordered__comm__monoid__add_550,axiom,
    ordere6911136660526730532id_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Olinordered__ab__group__add_551,axiom,
    linord5086331880401160121up_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Ocancel__ab__semigroup__add_552,axiom,
    cancel2418104881723323429up_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Oring__1__no__zero__divisors_553,axiom,
    ring_15535105094025558882visors @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Ocancel__comm__monoid__add_554,axiom,
    cancel1802427076303600483id_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Olinordered__ring__strict_555,axiom,
    linord4710134922213307826strict @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Bit__Operations_Osemiring__bits_556,axiom,
    bit_semiring_bits @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Oordered__comm__semiring_557,axiom,
    ordere2520102378445227354miring @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Olinordered__semiring__1_558,axiom,
    linord6961819062388156250ring_1 @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Oordered__ab__group__add_559,axiom,
    ordered_ab_group_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Ocancel__semigroup__add_560,axiom,
    cancel_semigroup_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Olinordered__semiring_561,axiom,
    linordered_semiring @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Oordered__semiring__0_562,axiom,
    ordered_semiring_0 @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Olinordered__semidom_563,axiom,
    linordered_semidom @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Oab__semigroup__mult_564,axiom,
    ab_semigroup_mult @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Osemiring__1__cancel_565,axiom,
    semiring_1_cancel @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Oalgebraic__semidom_566,axiom,
    algebraic_semidom @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Ocomm__monoid__mult_567,axiom,
    comm_monoid_mult @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Oab__semigroup__add_568,axiom,
    ab_semigroup_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Oordered__semiring_569,axiom,
    ordered_semiring @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Oordered__ring__abs_570,axiom,
    ordered_ring_abs @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Parity_Osemiring__parity_571,axiom,
    semiring_parity @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Ocomm__monoid__add_572,axiom,
    comm_monoid_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Osemiring__modulo_573,axiom,
    semiring_modulo @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Olinordered__ring_574,axiom,
    linordered_ring @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Olinordered__idom_575,axiom,
    linordered_idom @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Ocomm__semiring__1_576,axiom,
    comm_semiring_1 @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Ocomm__semiring__0_577,axiom,
    comm_semiring_0 @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Osemigroup__mult_578,axiom,
    semigroup_mult @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Osemidom__modulo_579,axiom,
    semidom_modulo @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Osemidom__divide_580,axiom,
    semidom_divide @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Num_Osemiring__numeral_581,axiom,
    semiring_numeral @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Osemigroup__add_582,axiom,
    semigroup_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Ozero__less__one_583,axiom,
    zero_less_one @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Nat_Osemiring__char__0_584,axiom,
    semiring_char_0 @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Oab__group__add_585,axiom,
    ab_group_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Ozero__neq__one_586,axiom,
    zero_neq_one @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Oordered__ring_587,axiom,
    ordered_ring @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Oidom__abs__sgn_588,axiom,
    idom_abs_sgn @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Parity_Oring__parity_589,axiom,
    ring_parity @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Orderings_Opreorder_590,axiom,
    preorder @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Orderings_Olinorder_591,axiom,
    linorder @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Omonoid__mult_592,axiom,
    monoid_mult @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Oidom__divide_593,axiom,
    idom_divide @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Ocomm__ring__1_594,axiom,
    comm_ring_1 @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Omonoid__add_595,axiom,
    monoid_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Osemiring__1_596,axiom,
    semiring_1 @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Osemiring__0_597,axiom,
    semiring_0 @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Ogroup__add_598,axiom,
    group_add @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Omult__zero_599,axiom,
    mult_zero @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Ocomm__ring_600,axiom,
    comm_ring @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Orderings_Oorder_601,axiom,
    order @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Num_Oneg__numeral_602,axiom,
    neg_numeral @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Nat_Oring__char__0_603,axiom,
    ring_char_0 @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Osemiring_604,axiom,
    semiring @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Osemidom_605,axiom,
    semidom @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Orderings_Oord_606,axiom,
    ord @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Ouminus_607,axiom,
    uminus @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Oring__1_608,axiom,
    ring_1 @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Oabs__if_609,axiom,
    abs_if @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Ominus_610,axiom,
    minus @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Power_Opower_611,axiom,
    power @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Num_Onumeral_612,axiom,
    numeral @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Ozero_613,axiom,
    zero @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Oplus_614,axiom,
    plus @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Oring_615,axiom,
    ring @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Oidom_616,axiom,
    idom @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Groups_Oone_617,axiom,
    one @ code_integer ).

thf(tcon_Code__Numeral_Ointeger___Rings_Odvd_618,axiom,
    dvd @ code_integer ).

thf(tcon_Code__Numeral_Onatural___Bit__Operations_Ounique__euclidean__semiring__with__bit__operations_619,axiom,
    bit_un5681908812861735899ations @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Euclidean__Division_Ounique__euclidean__semiring__with__nat_620,axiom,
    euclid5411537665997757685th_nat @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Groups_Oordered__ab__semigroup__monoid__add__imp__le_621,axiom,
    ordere1937475149494474687imp_le @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Euclidean__Division_Ounique__euclidean__semiring_622,axiom,
    euclid3128863361964157862miring @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Euclidean__Division_Oeuclidean__semiring__cancel_623,axiom,
    euclid4440199948858584721cancel @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Rings_Osemiring__no__zero__divisors__cancel_624,axiom,
    semiri6575147826004484403cancel @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Groups_Ostrict__ordered__ab__semigroup__add_625,axiom,
    strict9044650504122735259up_add @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Groups_Oordered__cancel__ab__semigroup__add_626,axiom,
    ordere580206878836729694up_add @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Groups_Oordered__ab__semigroup__add__imp__le_627,axiom,
    ordere2412721322843649153imp_le @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Bit__Operations_Osemiring__bit__operations_628,axiom,
    bit_se359711467146920520ations @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Rings_Olinordered__comm__semiring__strict_629,axiom,
    linord2810124833399127020strict @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Groups_Ostrict__ordered__comm__monoid__add_630,axiom,
    strict7427464778891057005id_add @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Groups_Oordered__cancel__comm__monoid__add_631,axiom,
    ordere8940638589300402666id_add @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Euclidean__Division_Oeuclidean__semiring_632,axiom,
    euclid3725896446679973847miring @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Groups_Olinordered__ab__semigroup__add_633,axiom,
    linord4140545234300271783up_add @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Rings_Osemiring__1__no__zero__divisors_634,axiom,
    semiri2026040879449505780visors @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Rings_Olinordered__nonzero__semiring_635,axiom,
    linord181362715937106298miring @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Rings_Olinordered__semiring__strict_636,axiom,
    linord8928482502909563296strict @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Rings_Osemiring__no__zero__divisors_637,axiom,
    semiri3467727345109120633visors @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Groups_Oordered__ab__semigroup__add_638,axiom,
    ordere6658533253407199908up_add @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Groups_Oordered__comm__monoid__add_639,axiom,
    ordere6911136660526730532id_add @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Groups_Ocancel__ab__semigroup__add_640,axiom,
    cancel2418104881723323429up_add @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Groups_Ocancel__comm__monoid__add_641,axiom,
    cancel1802427076303600483id_add @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Bit__Operations_Osemiring__bits_642,axiom,
    bit_semiring_bits @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Rings_Oordered__comm__semiring_643,axiom,
    ordere2520102378445227354miring @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Groups_Ocancel__semigroup__add_644,axiom,
    cancel_semigroup_add @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Rings_Olinordered__semiring_645,axiom,
    linordered_semiring @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Rings_Oordered__semiring__0_646,axiom,
    ordered_semiring_0 @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Rings_Olinordered__semidom_647,axiom,
    linordered_semidom @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Groups_Oab__semigroup__mult_648,axiom,
    ab_semigroup_mult @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Rings_Osemiring__1__cancel_649,axiom,
    semiring_1_cancel @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Rings_Oalgebraic__semidom_650,axiom,
    algebraic_semidom @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Groups_Ocomm__monoid__mult_651,axiom,
    comm_monoid_mult @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Groups_Ocomm__monoid__diff_652,axiom,
    comm_monoid_diff @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Groups_Oab__semigroup__add_653,axiom,
    ab_semigroup_add @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Rings_Oordered__semiring_654,axiom,
    ordered_semiring @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Parity_Osemiring__parity_655,axiom,
    semiring_parity @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Groups_Ocomm__monoid__add_656,axiom,
    comm_monoid_add @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Rings_Osemiring__modulo_657,axiom,
    semiring_modulo @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Rings_Ocomm__semiring__1_658,axiom,
    comm_semiring_1 @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Rings_Ocomm__semiring__0_659,axiom,
    comm_semiring_0 @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Groups_Osemigroup__mult_660,axiom,
    semigroup_mult @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Rings_Osemidom__modulo_661,axiom,
    semidom_modulo @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Rings_Osemidom__divide_662,axiom,
    semidom_divide @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Num_Osemiring__numeral_663,axiom,
    semiring_numeral @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Groups_Osemigroup__add_664,axiom,
    semigroup_add @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Rings_Ozero__less__one_665,axiom,
    zero_less_one @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Nat_Osemiring__char__0_666,axiom,
    semiring_char_0 @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Rings_Ozero__neq__one_667,axiom,
    zero_neq_one @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Orderings_Opreorder_668,axiom,
    preorder @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Orderings_Olinorder_669,axiom,
    linorder @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Groups_Omonoid__mult_670,axiom,
    monoid_mult @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Groups_Omonoid__add_671,axiom,
    monoid_add @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Rings_Osemiring__1_672,axiom,
    semiring_1 @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Rings_Osemiring__0_673,axiom,
    semiring_0 @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Rings_Omult__zero_674,axiom,
    mult_zero @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Orderings_Oorder_675,axiom,
    order @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Rings_Osemiring_676,axiom,
    semiring @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Rings_Osemidom_677,axiom,
    semidom @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Orderings_Oord_678,axiom,
    ord @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Groups_Ominus_679,axiom,
    minus @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Power_Opower_680,axiom,
    power @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Num_Onumeral_681,axiom,
    numeral @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Groups_Ozero_682,axiom,
    zero @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Groups_Oplus_683,axiom,
    plus @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Groups_Oone_684,axiom,
    one @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Rings_Odvd_685,axiom,
    dvd @ code_natural ).

thf(tcon_Code__Numeral_Onatural___Nat_Osize_686,axiom,
    size @ code_natural ).

thf(tcon_VEBT__Definitions_OVEBT___Nat_Osize_687,axiom,
    size @ vEBT_VEBT ).

% Helper facts (4)
thf(help_If_3_1_T,axiom,
    ! [P: $o] :
      ( ( P = $true )
      | ( P = $false ) ) ).

thf(help_If_2_1_T,axiom,
    ! [A: $tType,X: A,Y: A] :
      ( ( if @ A @ $false @ X @ Y )
      = Y ) ).

thf(help_If_1_1_T,axiom,
    ! [A: $tType,X: A,Y: A] :
      ( ( if @ A @ $true @ X @ Y )
      = X ) ).

thf(help_fChoice_1_1_T,axiom,
    ! [A: $tType,P: A > $o] :
      ( ( P @ ( fChoice @ A @ P ) )
      = ( ? [X8: A] : ( P @ X8 ) ) ) ).

% Conjectures (1)
thf(conj_0,conjecture,
    ( ( ord_less_eq @ nat @ xa @ ( ord_max @ nat @ ma @ mi ) )
    & ( ord_less @ nat @ ( ord_max @ nat @ ma @ mi ) @ ( power_power @ nat @ ( numeral_numeral @ nat @ ( bit0 @ one2 ) ) @ deg ) ) ) ).

%------------------------------------------------------------------------------
